
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file BSIM6.1.1.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:28
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSbsim6.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

  #include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMSbsim6 {
namespace AnalogFunctions {
// Derivative of Analog Function lexp
double d_lexp(double x  , double d_x )
{
// Function return variable and total deriv
double lexp;
double d_lexp;
// Derivatives of return value w.r.t input vars
double d_lexp_d_x;
{
if((x>80.0))
{
d_lexp_d_x=(5.540622384e+34);
lexp=(5.540622384e+34*((1.0+x)-80.0));
}
else
{
if((x<(-80.0)))
{
d_lexp_d_x=0.0;
lexp=1.804851387e-35;
}
else
{
d_lexp_d_x=exp(x);
lexp=exp(x);
}
}
}
d_lexp = d_lexp_d_x*d_x;
return(d_lexp);
}

// Evaluator class implementations for Analog Function lexp
  // Constructor
  lexpEvaluator::lexpEvaluator(double x)
  {
    lexpReturn_ = evaluator_(x);
  }
  // method to get precomputed values into double vars 
  double lexpEvaluator::getValues(double  x)
  {
    // Silence unused argument warnings
    (void) x;
    // Copy all precomputed values into corresponding output
    return(lexpReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double lexpEvaluator::getDerivs(double x  , double d_x)
  {
    // Function total deriv
    double d_lexp;
    // Silence unused argument warnings
    (void) x;
    d_lexp = lexpReturn_.deriv_WRT_x*d_x;
    return(d_lexp);
  }
  // method that actually performs our computations.
  lexpEvaluator::returnType lexpEvaluator::evaluator_(double x)
  {
  // Function value and derivs variables, and a returnType to store everything
  double lexp;
  lexpEvaluator::returnType lexpReturn;
  // Derivatives of return value w.r.t input vars
  double d_lexp_d_x;
  // declared local variables
{
if((x>80.0))
{
d_lexp_d_x=(5.540622384e+34);
lexp=(5.540622384e+34*((1.0+x)-80.0));
}
else
{
if((x<(-80.0)))
{
d_lexp_d_x=0.0;
lexp=1.804851387e-35;
}
else
{
d_lexp_d_x=exp(x);
lexp=exp(x);
}
}
}
  // now save outputs and derivs into appropriate return vars
  lexpReturn.value=lexp;
  lexpReturn.deriv_WRT_x = d_lexp_d_x;
  return(lexpReturn);
  }

// Derivative of Analog Function lln
double d_lln(double x  , double d_x )
{
// Function return variable and total deriv
double lln;
double d_lln;
// Derivatives of return value w.r.t input vars
double d_lln_d_x;
{
d_lln_d_x=(1.0/std::max( static_cast<double>(x), static_cast<double>(1.0e-38)))*((x>=1.0e-38)?1.0:0.0);
lln=log(std::max( static_cast<double>(x), static_cast<double>(1.0e-38)));
}
d_lln = d_lln_d_x*d_x;
return(d_lln);
}

// Evaluator class implementations for Analog Function lln
  // Constructor
  llnEvaluator::llnEvaluator(double x)
  {
    llnReturn_ = evaluator_(x);
  }
  // method to get precomputed values into double vars 
  double llnEvaluator::getValues(double  x)
  {
    // Silence unused argument warnings
    (void) x;
    // Copy all precomputed values into corresponding output
    return(llnReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double llnEvaluator::getDerivs(double x  , double d_x)
  {
    // Function total deriv
    double d_lln;
    // Silence unused argument warnings
    (void) x;
    d_lln = llnReturn_.deriv_WRT_x*d_x;
    return(d_lln);
  }
  // method that actually performs our computations.
  llnEvaluator::returnType llnEvaluator::evaluator_(double x)
  {
  // Function value and derivs variables, and a returnType to store everything
  double lln;
  llnEvaluator::returnType llnReturn;
  // Derivatives of return value w.r.t input vars
  double d_lln_d_x;
  // declared local variables
{
d_lln_d_x=(1.0/std::max( static_cast<double>(x), static_cast<double>(1.0e-38)))*((x>=1.0e-38)?1.0:0.0);
lln=log(std::max( static_cast<double>(x), static_cast<double>(1.0e-38)));
}
  // now save outputs and derivs into appropriate return vars
  llnReturn.value=lln;
  llnReturn.deriv_WRT_x = d_lln_d_x;
  return(llnReturn);
  }

// Derivative of Analog Function hypsmooth
double d_hypsmooth(double x , double c  , double d_x , double d_c )
{
// Function return variable and total deriv
double hypsmooth;
double d_hypsmooth;
// Derivatives of return value w.r.t input vars
double d_hypsmooth_d_x;
double d_hypsmooth_d_c;
{
d_hypsmooth_d_x=(0.5*(1.0+(0.5/sqrt(((x*x)+((4.0*c)*c))))*(x+x)));
d_hypsmooth_d_c=(0.5*(0.5/sqrt(((x*x)+((4.0*c)*c))))*((4.0*c)+c*(4.0)));
hypsmooth=(0.5*(x+sqrt(((x*x)+((4.0*c)*c)))));
}
d_hypsmooth = d_hypsmooth_d_x*d_x+d_hypsmooth_d_c*d_c;
return(d_hypsmooth);
}

// Evaluator class implementations for Analog Function hypsmooth
  // Constructor
  hypsmoothEvaluator::hypsmoothEvaluator(double x, double c)
  {
    hypsmoothReturn_ = evaluator_(x, c);
  }
  // method to get precomputed values into double vars 
  double hypsmoothEvaluator::getValues(double  x, double  c)
  {
    // Silence unused argument warnings
    (void) x;
    (void) c;
    // Copy all precomputed values into corresponding output
    return(hypsmoothReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double hypsmoothEvaluator::getDerivs(double x , double c  , double d_x, double d_c)
  {
    // Function total deriv
    double d_hypsmooth;
    // Silence unused argument warnings
    (void) x;
    (void) c;
    d_hypsmooth = hypsmoothReturn_.deriv_WRT_x*d_x+hypsmoothReturn_.deriv_WRT_c*d_c;
    return(d_hypsmooth);
  }
  // method that actually performs our computations.
  hypsmoothEvaluator::returnType hypsmoothEvaluator::evaluator_(double x, double c)
  {
  // Function value and derivs variables, and a returnType to store everything
  double hypsmooth;
  hypsmoothEvaluator::returnType hypsmoothReturn;
  // Derivatives of return value w.r.t input vars
  double d_hypsmooth_d_x;
  double d_hypsmooth_d_c;
  // declared local variables
{
d_hypsmooth_d_x=(0.5*(1.0+(0.5/sqrt(((x*x)+((4.0*c)*c))))*(x+x)));
d_hypsmooth_d_c=(0.5*(0.5/sqrt(((x*x)+((4.0*c)*c))))*((4.0*c)+c*(4.0)));
hypsmooth=(0.5*(x+sqrt(((x*x)+((4.0*c)*c)))));
}
  // now save outputs and derivs into appropriate return vars
  hypsmoothReturn.value=hypsmooth;
  hypsmoothReturn.deriv_WRT_x = d_hypsmooth_d_x;
  hypsmoothReturn.deriv_WRT_c = d_hypsmooth_d_c;
  return(hypsmoothReturn);
  }

} // namepace AnalogFunctions


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_d;
    const int Instance::admsNodeID_g;
    const int Instance::admsNodeID_s;
    const int Instance::admsNodeID_b;
    const int Instance::admsNodeID_t;
    const int Instance::admsNodeID_di;
    const int Instance::admsNodeID_si;
    const int Instance::admsNodeID_gi;
    const int Instance::admsNodeID_gm;
    const int Instance::admsNodeID_bi;
    const int Instance::admsNodeID_sbulk;
    const int Instance::admsNodeID_dbulk;
    const int Instance::admsNodeID_N1;
    const int Instance::admsNodeID_N2;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSbsim6::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSbsim6::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(10*1.0e-6), &ADMSbsim6::Instance::L)
    .setUnit(U_METER)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("W", static_cast<double>(10*1.0e-6), &ADMSbsim6::Instance::W)
    .setUnit(U_METER)
    .setDescription("Total width including fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NF", static_cast<int>(1), &ADMSbsim6::Instance::NF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers");
  p.addPar("NRS", static_cast<double>(1.0), &ADMSbsim6::Instance::NRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares in source")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRD", static_cast<double>(1.0), &ADMSbsim6::Instance::NRD)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares in drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBSDOFF", static_cast<double>(0.0), &ADMSbsim6::Instance::VFBSDOFF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MINZ", static_cast<int>(0), &ADMSbsim6::Instance::MINZ)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimize either D or S");
  p.addPar("XGW", static_cast<double>(0.0), &ADMSbsim6::Instance::XGW)
    .setUnit(U_METER)
    .setDescription("Dist from gate contact center to dev edge [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsim6::Instance::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contacts");
  p.addPar("RGATEMOD", static_cast<int>(0), &ADMSbsim6::Instance::RGATEMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate resistance model selector");
  p.addPar("RBODYMOD", static_cast<int>(0), &ADMSbsim6::Instance::RBODYMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distributed body R model");
  p.addPar("GEOMOD", static_cast<int>(0), &ADMSbsim6::Instance::GEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geo dependent parasitics model");
  p.addPar("RGEOMOD", static_cast<int>(0), &ADMSbsim6::Instance::RGEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-dependent source/drain resistance,  0: RSH-based, 1: Holistic");
  p.addPar("RBPB", static_cast<double>(50.0), &ADMSbsim6::Instance::RBPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPD", static_cast<double>(50.0), &ADMSbsim6::Instance::RBPD)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPS", static_cast<double>(50.0), &ADMSbsim6::Instance::RBPS)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and sbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBDB", static_cast<double>(50.0), &ADMSbsim6::Instance::RBDB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and dbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSB", static_cast<double>(50.0), &ADMSbsim6::Instance::RBSB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and sbNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SA", static_cast<double>(0.0), &ADMSbsim6::Instance::SA)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SB", static_cast<double>(0.0), &ADMSbsim6::Instance::SB)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SD", static_cast<double>(0.0), &ADMSbsim6::Instance::SD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between neighboring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCA", static_cast<int>(0.0), &ADMSbsim6::Instance::SCA)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCB", static_cast<int>(0.0), &ADMSbsim6::Instance::SCB)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCC", static_cast<int>(0.0), &ADMSbsim6::Instance::SCC)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SC", static_cast<int>(0.0), &ADMSbsim6::Instance::SC)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance to a single well edge if <=0.0, turn off WPE");
  p.addPar("AS", static_cast<double>(0.0), &ADMSbsim6::Instance::AS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source to Substrate Junction Area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AD", static_cast<double>(0.0), &ADMSbsim6::Instance::AD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain to Substrate Junction Area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PS", static_cast<double>(0.0), &ADMSbsim6::Instance::PS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source to Substrate Junction Perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PD", static_cast<double>(0.0), &ADMSbsim6::Instance::PD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain to Substrate Junction Perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("M", static_cast<double>(1.0), &ADMSbsim6::Instance::m)
    .setUnit(U_UNKNOWN)
    .setDescription("multiplicity factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;


}

void Traits::loadModelParameters(ParametricData<ADMSbsim6::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSbsim6::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("L", static_cast<double>(10*1.0e-6), &ADMSbsim6::Model::L)
    .setUnit(U_METER)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBSDOFF", static_cast<double>(0.0), &ADMSbsim6::Model::VFBSDOFF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XGW", static_cast<double>(0.0), &ADMSbsim6::Model::XGW)
    .setUnit(U_METER)
    .setDescription("Dist from gate contact center to dev edge [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsim6::Model::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contacts");
  p.addPar("RGATEMOD", static_cast<int>(0), &ADMSbsim6::Model::RGATEMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate resistance model selector");
  p.addPar("RBODYMOD", static_cast<int>(0), &ADMSbsim6::Model::RBODYMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distributed body R model");
  p.addPar("GEOMOD", static_cast<int>(0), &ADMSbsim6::Model::GEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geo dependent parasitics model");
  p.addPar("RGEOMOD", static_cast<int>(0), &ADMSbsim6::Model::RGEOMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-dependent source/drain resistance,  0: RSH-based, 1: Holistic");
  p.addPar("RBPB", static_cast<double>(50.0), &ADMSbsim6::Model::RBPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPD", static_cast<double>(50.0), &ADMSbsim6::Model::RBPD)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and bNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPS", static_cast<double>(50.0), &ADMSbsim6::Model::RBPS)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNodePrime and sbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBDB", static_cast<double>(50.0), &ADMSbsim6::Model::RBDB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and dbNode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSB", static_cast<double>(50.0), &ADMSbsim6::Model::RBSB)
    .setUnit(U_UNKNOWN)
    .setDescription("Resistance between bNode and sbNode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SA", static_cast<double>(0.0), &ADMSbsim6::Model::SA)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SB", static_cast<double>(0.0), &ADMSbsim6::Model::SB)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between OD edge from Poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SD", static_cast<double>(0.0), &ADMSbsim6::Model::SD)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance between neighboring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCA", static_cast<int>(0.0), &ADMSbsim6::Model::SCA)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCB", static_cast<int>(0.0), &ADMSbsim6::Model::SCB)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SCC", static_cast<int>(0.0), &ADMSbsim6::Model::SCC)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("SC", static_cast<int>(0.0), &ADMSbsim6::Model::SC)
    .setUnit(U_UNKNOWN)
    .setDescription("Distance to a single well edge if <=0.0, turn off WPE");
  p.addPar("TYPE", static_cast<int>(1), &ADMSbsim6::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("");
  p.addPar("CVMOD", static_cast<int>(0), &ADMSbsim6::Model::CVMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Consistent IV-CV, 1: Different IV-CV");
  p.addPar("COVMOD", static_cast<int>(0), &ADMSbsim6::Model::COVMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Use Bias-independent Overlap Capacitances,  1: Use Bias-dependent Overlap Capacitances");
  p.addPar("RDSMOD", static_cast<int>(0), &ADMSbsim6::Model::RDSMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Internal bias dependent and external bias independent s/d resistance model,  1: External s/d resistance model,  2: Internal s/d resistance model");
  p.addPar("WPEMOD", static_cast<int>(0), &ADMSbsim6::Model::WPEMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Model flag");
  p.addPar("ASYMMOD", static_cast<int>(0), &ADMSbsim6::Model::ASYMMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Asymmetry Model turned off - forward mode parameters used,  1: Asymmetry Model turned on");
  p.addPar("GIDLMOD", static_cast<int>(0), &ADMSbsim6::Model::GIDLMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off GIDL Current,  1: Turn on GIDL Current");
  p.addPar("IGCMOD", static_cast<int>(0), &ADMSbsim6::Model::IGCMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off Igc, Igs and Igd,  1: Turn on Igc, Igs and Igd");
  p.addPar("IGBMOD", static_cast<int>(0), &ADMSbsim6::Model::IGBMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Turn off Igb,  1: Turn on Igb");
  p.addPar("TNOIMOD", static_cast<int>(0), &ADMSbsim6::Model::TNOIMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise model selector");
  p.addPar("SHMOD", static_cast<int>(0), &ADMSbsim6::Model::SHMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("0 : Self heating model OFF,  1 : Self heating model ON");
  p.addPar("MOBSCALE", static_cast<int>(0), &ADMSbsim6::Model::MOBSCALE)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility scaling model, 0: Old Model,  1: New Model");
  p.addPar("LLONG", static_cast<double>(10*1.0e-6), &ADMSbsim6::Model::LLONG)
    .setUnit(U_METER)
    .setDescription("L of extracted Long channel device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMLT", static_cast<double>(1.0), &ADMSbsim6::Model::LMLT)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Shrinking Parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMLT", static_cast<double>(1.0), &ADMSbsim6::Model::WMLT)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Shrinking Parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XL", static_cast<double>(0.0), &ADMSbsim6::Model::XL)
    .setUnit(U_UNKNOWN)
    .setDescription("L offset for channel length due to mask/etch effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WWIDE", static_cast<double>(10*1.0e-6), &ADMSbsim6::Model::WWIDE)
    .setUnit(U_METER)
    .setDescription("W of extracted Wide channel device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XW", static_cast<double>(0.0), &ADMSbsim6::Model::XW)
    .setUnit(U_UNKNOWN)
    .setDescription("W offset for channel width due to mask/etch effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LINT", static_cast<double>(0.0), &ADMSbsim6::Model::LINT)
    .setUnit(U_UNKNOWN)
    .setDescription("delta L for IV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LL", static_cast<double>(0.0), &ADMSbsim6::Model::LL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LW", static_cast<double>(0.0), &ADMSbsim6::Model::LW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LWL", static_cast<double>(0.0), &ADMSbsim6::Model::LWL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLN", static_cast<double>(1.0), &ADMSbsim6::Model::LLN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LWN", static_cast<double>(1.0), &ADMSbsim6::Model::LWN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WINT", static_cast<double>(0.0), &ADMSbsim6::Model::WINT)
    .setUnit(U_UNKNOWN)
    .setDescription("delta W for IV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WL", static_cast<double>(0.0), &ADMSbsim6::Model::WL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WW", static_cast<double>(0.0), &ADMSbsim6::Model::WW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WWL", static_cast<double>(0.0), &ADMSbsim6::Model::WWL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLN", static_cast<double>(1.0), &ADMSbsim6::Model::WLN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WWN", static_cast<double>(1.0), &ADMSbsim6::Model::WWN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLC", static_cast<double>(0.0), &ADMSbsim6::Model::DLC)
    .setUnit(U_UNKNOWN)
    .setDescription("delta L for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLC", static_cast<double>(0.0), &ADMSbsim6::Model::LLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LWC", static_cast<double>(0.0), &ADMSbsim6::Model::LWC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LWLC", static_cast<double>(0.0), &ADMSbsim6::Model::LWLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DWC", static_cast<double>(0.0), &ADMSbsim6::Model::DWC)
    .setUnit(U_UNKNOWN)
    .setDescription("delta W for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLC", static_cast<double>(0.0), &ADMSbsim6::Model::WLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WWC", static_cast<double>(0.0), &ADMSbsim6::Model::WWC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WWLC", static_cast<double>(0.0), &ADMSbsim6::Model::WWLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXE", static_cast<double>(3.0e-9), &ADMSbsim6::Model::TOXE)
    .setUnit(U_METER)
    .setDescription("Effective gate dielectric thickness relative to SiO2, m")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXP", 0.0, &ADMSbsim6::Model::TOXP)
    .setUnit(U_METER)
    .setDescription("Physical gate dielectric thickness,If not given, TOXP is calculated from TOXE and DTOX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DTOX", static_cast<double>(0.0), &ADMSbsim6::Model::DTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("Difference between effective dielectric thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEP", static_cast<double>(1e24), &ADMSbsim6::Model::NDEP)
    .setUnit(U_METERM3)
    .setDescription("Channel Doping Concentration for IV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPL1", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPL1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPLEXP1", static_cast<double>(1.0), &ADMSbsim6::Model::NDEPLEXP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPL2", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of NDEP - For Short Channel Devices")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPLEXP2", static_cast<double>(2.0), &ADMSbsim6::Model::NDEPLEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPW", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NDEPWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPWL", static_cast<double>(0.0), &ADMSbsim6::Model::NDEPWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NDEPWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of NDEP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNDEP", static_cast<double>(0.0), &ADMSbsim6::Model::LNDEP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNDEP", static_cast<double>(0.0), &ADMSbsim6::Model::WNDEP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNDEP", static_cast<double>(0.0), &ADMSbsim6::Model::PNDEP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCV", 0.0, &ADMSbsim6::Model::NDEPCV)
    .setUnit(U_METERM3)
    .setDescription("Channel Doping Concentration for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVL1", 0.0, &ADMSbsim6::Model::NDEPCVL1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVLEXP1", 0.0, &ADMSbsim6::Model::NDEPCVLEXP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVL2", 0.0, &ADMSbsim6::Model::NDEPCVL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NDEPCV - For Short Channel Devices")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVLEXP2", 0.0, &ADMSbsim6::Model::NDEPCVLEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVW", 0.0, &ADMSbsim6::Model::NDEPCVW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVWEXP", 0.0, &ADMSbsim6::Model::NDEPCVWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVWL", 0.0, &ADMSbsim6::Model::NDEPCVWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDEPCVWLEXP", 0.0, &ADMSbsim6::Model::NDEPCVWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of NDEPCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNDEPCV", 0.0, &ADMSbsim6::Model::LNDEPCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNDEPCV", 0.0, &ADMSbsim6::Model::WNDEPCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNDEPCV", 0.0, &ADMSbsim6::Model::PNDEPCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGATE", static_cast<double>(5e25), &ADMSbsim6::Model::NGATE)
    .setUnit(U_METERM3)
    .setDescription("Gate Doping Concentration")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNGATE", static_cast<double>(0.0), &ADMSbsim6::Model::LNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNGATE", static_cast<double>(0.0), &ADMSbsim6::Model::WNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNGATE", static_cast<double>(0.0), &ADMSbsim6::Model::PNGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EASUB", static_cast<double>(4.05), &ADMSbsim6::Model::EASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Electron affinity of substrate")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NI0SUB", static_cast<double>(1.1e16), &ADMSbsim6::Model::NI0SUB)
    .setUnit(U_METERM3)
    .setDescription("Intrinsic carrier concentration of the substrate at 300.15K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BG0SUB", static_cast<double>(1.17), &ADMSbsim6::Model::BG0SUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Band gap of substrate at 300.15K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSRSUB", static_cast<double>(11.9), &ADMSbsim6::Model::EPSRSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative dielectric constant of the channel material")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSROX", static_cast<double>(3.9), &ADMSbsim6::Model::EPSROX)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative dielectric constant of the gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJ", static_cast<double>(1.5e-7), &ADMSbsim6::Model::XJ)
    .setUnit(U_UNKNOWN)
    .setDescription("S/D junction depth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LXJ", static_cast<double>(0.0), &ADMSbsim6::Model::LXJ)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WXJ", static_cast<double>(0.0), &ADMSbsim6::Model::WXJ)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PXJ", static_cast<double>(0.0), &ADMSbsim6::Model::PXJ)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVFB", static_cast<double>(0.0), &ADMSbsim6::Model::LVFB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVFB", static_cast<double>(0.0), &ADMSbsim6::Model::WVFB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVFB", static_cast<double>(0.0), &ADMSbsim6::Model::PVFB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFB", static_cast<double>((-0.5)), &ADMSbsim6::Model::VFB)
    .setUnit(U_VOLT)
    .setDescription("Flat band voltage ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBCV", 0.0, &ADMSbsim6::Model::VFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("Flat band voltage for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVFBCV", 0.0, &ADMSbsim6::Model::LVFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVFBCV", 0.0, &ADMSbsim6::Model::WVFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVFBCV", 0.0, &ADMSbsim6::Model::PVFBCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBCVL", static_cast<double>(0.0), &ADMSbsim6::Model::VFBCVL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBCVLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VFBCVLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBCVW", static_cast<double>(0.0), &ADMSbsim6::Model::VFBCVW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBCVWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VFBCVWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBCVWL", static_cast<double>(0.0), &ADMSbsim6::Model::VFBCVWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBCVWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VFBCVWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of VFBCV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PERMOD", static_cast<int>(1), &ADMSbsim6::Model::PERMOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Whether PS/PD (when given) include gate-edge perimeter");
  p.addPar("DWJ", 0.0, &ADMSbsim6::Model::DWJ)
    .setUnit(U_UNKNOWN)
    .setDescription("delta W for S/D junctions")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSD", static_cast<double>(1e26), &ADMSbsim6::Model::NSD)
    .setUnit(U_METERM3)
    .setDescription("S/D Doping Concentration")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNSD", static_cast<double>(0.0), &ADMSbsim6::Model::LNSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNSD", static_cast<double>(0.0), &ADMSbsim6::Model::WNSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNSD", static_cast<double>(0.0), &ADMSbsim6::Model::PNSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVT0", static_cast<double>(0.0), &ADMSbsim6::Model::DELVT0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP0", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTP0", static_cast<double>(0), &ADMSbsim6::Model::LDVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDVTP0", static_cast<double>(0), &ADMSbsim6::Model::WDVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTP0", static_cast<double>(0), &ADMSbsim6::Model::PDVTP0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP1", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTP1", static_cast<double>(0), &ADMSbsim6::Model::LDVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDVTP1", static_cast<double>(0), &ADMSbsim6::Model::WDVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTP1", static_cast<double>(0), &ADMSbsim6::Model::PDVTP1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP2", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTP2", static_cast<double>(0), &ADMSbsim6::Model::LDVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDVTP2", static_cast<double>(0), &ADMSbsim6::Model::WDVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTP2", static_cast<double>(0), &ADMSbsim6::Model::PDVTP2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP3", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTP3", static_cast<double>(0), &ADMSbsim6::Model::LDVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDVTP3", static_cast<double>(0), &ADMSbsim6::Model::WDVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTP3", static_cast<double>(0), &ADMSbsim6::Model::PDVTP3)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP4", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTP4", static_cast<double>(0), &ADMSbsim6::Model::LDVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDVTP4", static_cast<double>(0), &ADMSbsim6::Model::WDVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTP4", static_cast<double>(0), &ADMSbsim6::Model::PDVTP4)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP5", static_cast<double>(0.0), &ADMSbsim6::Model::DVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("DITS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTP5", static_cast<double>(0), &ADMSbsim6::Model::LDVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDVTP5", static_cast<double>(0), &ADMSbsim6::Model::WDVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTP5", static_cast<double>(0), &ADMSbsim6::Model::PDVTP5)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIN", static_cast<double>(0.045), &ADMSbsim6::Model::PHIN)
    .setUnit(U_VOLT)
    .setDescription("Nonuniform vertical doping effect on surface potential, V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPHIN", static_cast<double>(0.0), &ADMSbsim6::Model::LPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPHIN", static_cast<double>(0.0), &ADMSbsim6::Model::WPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPHIN", static_cast<double>(0.0), &ADMSbsim6::Model::PPHIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETA0", static_cast<double>(0.08), &ADMSbsim6::Model::ETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LETA0", static_cast<double>(0.0), &ADMSbsim6::Model::LETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WETA0", static_cast<double>(0.0), &ADMSbsim6::Model::WETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PETA0", static_cast<double>(0.0), &ADMSbsim6::Model::PETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETA0R", 0.0, &ADMSbsim6::Model::ETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LETA0R", 0.0, &ADMSbsim6::Model::LETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WETA0R", 0.0, &ADMSbsim6::Model::WETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PETA0R", 0.0, &ADMSbsim6::Model::PETA0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DSUB", static_cast<double>(1.0), &ADMSbsim6::Model::DSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Length scaling exponent for DIBL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETAB", static_cast<double>((-0.07)), &ADMSbsim6::Model::ETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("Body bias coefficient for subthreshold DIBL effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETABEXP", static_cast<double>(1.0), &ADMSbsim6::Model::ETABEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent coefficient of ETAB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LETAB", static_cast<double>(0.0), &ADMSbsim6::Model::LETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WETAB", static_cast<double>(0.0), &ADMSbsim6::Model::WETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PETAB", static_cast<double>(0.0), &ADMSbsim6::Model::PETAB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1", static_cast<double>(0.0), &ADMSbsim6::Model::K1)
    .setUnit(U_UNKNOWN)
    .setDescription("First-order body-bias Vth shift due to Vertical Non-uniform doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1L", static_cast<double>(0.0), &ADMSbsim6::Model::K1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K1LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1W", static_cast<double>(0.0), &ADMSbsim6::Model::K1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1WEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K1WEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1WL", static_cast<double>(0.0), &ADMSbsim6::Model::K1WL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1WLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K1WLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK1", static_cast<double>(0.0), &ADMSbsim6::Model::LK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WK1", static_cast<double>(0.0), &ADMSbsim6::Model::WK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK1", static_cast<double>(0.0), &ADMSbsim6::Model::PK1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2", static_cast<double>(0.0), &ADMSbsim6::Model::K2)
    .setUnit(U_UNKNOWN)
    .setDescription("Vth shift due to Vertical Non-uniform doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2L", static_cast<double>(0.0), &ADMSbsim6::Model::K2L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K2LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2W", static_cast<double>(0.0), &ADMSbsim6::Model::K2W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2WEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K2WEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2WL", static_cast<double>(0.0), &ADMSbsim6::Model::K2WL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2WLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::K2WLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of K2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK2", static_cast<double>(0.0), &ADMSbsim6::Model::LK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WK2", static_cast<double>(0.0), &ADMSbsim6::Model::WK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK2", static_cast<double>(0.0), &ADMSbsim6::Model::PK2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ADOS", static_cast<double>(0.0), &ADMSbsim6::Model::ADOS)
    .setUnit(U_UNKNOWN)
    .setDescription("Quantum mechanical effect prefactor cum switch in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BDOS", static_cast<double>(1.0), &ADMSbsim6::Model::BDOS)
    .setUnit(U_UNKNOWN)
    .setDescription("Charge centroid parameter - slope of CV curve under QME in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QM0", static_cast<double>(1.0e-3), &ADMSbsim6::Model::QM0)
    .setUnit(U_UNKNOWN)
    .setDescription("Charge centroid parameter - starting point for QME in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETAQM", static_cast<double>(0.54), &ADMSbsim6::Model::ETAQM)
    .setUnit(U_UNKNOWN)
    .setDescription("Bulk charge coefficient for charge centroid in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIT", static_cast<double>(0.0), &ADMSbsim6::Model::CIT)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for interface trap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIT", static_cast<double>(0.0), &ADMSbsim6::Model::LCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCIT", static_cast<double>(0.0), &ADMSbsim6::Model::WCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIT", static_cast<double>(0.0), &ADMSbsim6::Model::PCIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub-threshold slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTORL", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTORL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTORLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NFACTORLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTORW", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTORW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTORWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NFACTORWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTORWL", static_cast<double>(0.0), &ADMSbsim6::Model::NFACTORWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTORWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::NFACTORWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::LNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::WNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::PNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCD", static_cast<double>(1e-9), &ADMSbsim6::Model::CDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("drain-bias sensitivity of sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDL", static_cast<double>(0.0), &ADMSbsim6::Model::CDSCDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::CDSCDLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCDSCD", static_cast<double>(0.0), &ADMSbsim6::Model::LCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCDSCD", static_cast<double>(0.0), &ADMSbsim6::Model::WCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCDSCD", static_cast<double>(0.0), &ADMSbsim6::Model::PCDSCD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDR", 0.0, &ADMSbsim6::Model::CDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("drain-bias sensitivity of sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDLR", 0.0, &ADMSbsim6::Model::CDSCDLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCDSCDR", 0.0, &ADMSbsim6::Model::LCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCDSCDR", 0.0, &ADMSbsim6::Model::WCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCDSCDR", 0.0, &ADMSbsim6::Model::PCDSCDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::CDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("body-bias sensitivity of sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCBL", static_cast<double>(0.0), &ADMSbsim6::Model::CDSCBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of CDSCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCBLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::CDSCBLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of CDSCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::LCDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::WCDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCDSCB", static_cast<double>(0.0), &ADMSbsim6::Model::PCDSCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT", static_cast<double>(1e5), &ADMSbsim6::Model::VSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation Velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::LVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::WVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::PVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATL", static_cast<double>(0.0), &ADMSbsim6::Model::VSATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VSATLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATW", static_cast<double>(0.0), &ADMSbsim6::Model::VSATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VSATWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATWL", static_cast<double>(0.0), &ADMSbsim6::Model::VSATWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::VSATWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of of VSAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATR", 0.0, &ADMSbsim6::Model::VSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation Velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVSATR", 0.0, &ADMSbsim6::Model::LVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVSATR", 0.0, &ADMSbsim6::Model::WVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVSATR", 0.0, &ADMSbsim6::Model::PVSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA", static_cast<double>(0.125), &ADMSbsim6::Model::DELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("Smoothing function factor for Vdsat")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::LDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::WDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::PDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTAL", static_cast<double>(0.0), &ADMSbsim6::Model::DELTAL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of DELTA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTALEXP", static_cast<double>(1.0), &ADMSbsim6::Model::DELTALEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of DELTA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCV", 0.0, &ADMSbsim6::Model::VSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("VSAT parameter for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVSATCV", 0.0, &ADMSbsim6::Model::LVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVSATCV", 0.0, &ADMSbsim6::Model::WVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVSATCV", 0.0, &ADMSbsim6::Model::PVSATCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCVL", 0.0, &ADMSbsim6::Model::VSATCVL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCVLEXP", 0.0, &ADMSbsim6::Model::VSATCVLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCVW", 0.0, &ADMSbsim6::Model::VSATCVW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCVWEXP", 0.0, &ADMSbsim6::Model::VSATCVWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCVWL", 0.0, &ADMSbsim6::Model::VSATCVWL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCVWLEXP", 0.0, &ADMSbsim6::Model::VSATCVWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UP1", static_cast<double>(0.0), &ADMSbsim6::Model::UP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP1", static_cast<double>(1.0e-8), &ADMSbsim6::Model::LP1)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length exponential coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UP2", static_cast<double>(0.0), &ADMSbsim6::Model::UP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP2", static_cast<double>(1.0e-8), &ADMSbsim6::Model::LP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility channel length exponential coefficent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MULU0", static_cast<double>(1.0), &ADMSbsim6::Model::MULU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0", static_cast<double>(67.0e-3), &ADMSbsim6::Model::U0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0L", static_cast<double>(0.0), &ADMSbsim6::Model::U0L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of U0L")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::U0LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of U0L")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LU0", static_cast<double>(0.0), &ADMSbsim6::Model::LU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WU0", static_cast<double>(0.0), &ADMSbsim6::Model::WU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PU0", static_cast<double>(0.0), &ADMSbsim6::Model::PU0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0R", 0.0, &ADMSbsim6::Model::U0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LU0R", 0.0, &ADMSbsim6::Model::LU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WU0R", 0.0, &ADMSbsim6::Model::WU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PU0R", 0.0, &ADMSbsim6::Model::PU0R)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETAMOB", static_cast<double>(1.0), &ADMSbsim6::Model::ETAMOB)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter (should be kept close to 1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UA", static_cast<double>(0.001), &ADMSbsim6::Model::UA)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UAL", static_cast<double>(0.0), &ADMSbsim6::Model::UAL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of  UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UALEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UALEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of  UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UAW", static_cast<double>(0.0), &ADMSbsim6::Model::UAW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UAWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UAWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UAWL", static_cast<double>(0.0), &ADMSbsim6::Model::UAWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UAWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UAWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUA", static_cast<double>(0.0), &ADMSbsim6::Model::LUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUA", static_cast<double>(0.0), &ADMSbsim6::Model::WUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUA", static_cast<double>(0.0), &ADMSbsim6::Model::PUA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UAR", 0.0, &ADMSbsim6::Model::UAR)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUAR", 0.0, &ADMSbsim6::Model::LUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUAR", 0.0, &ADMSbsim6::Model::WUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUAR", 0.0, &ADMSbsim6::Model::PUAR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EU", static_cast<double>(1.5), &ADMSbsim6::Model::EU)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEU", static_cast<double>(0.0), &ADMSbsim6::Model::LEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEU", static_cast<double>(0.0), &ADMSbsim6::Model::WEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEU", static_cast<double>(0.0), &ADMSbsim6::Model::PEU)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EUL", static_cast<double>(0.0), &ADMSbsim6::Model::EUL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EULEXP", static_cast<double>(1.0), &ADMSbsim6::Model::EULEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EUW", static_cast<double>(0.0), &ADMSbsim6::Model::EUW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EUWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::EUWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EUWL", static_cast<double>(0.0), &ADMSbsim6::Model::EUWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EUWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::EUWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of EU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UD", static_cast<double>(0.001), &ADMSbsim6::Model::UD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UDL", static_cast<double>(0.0), &ADMSbsim6::Model::UDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UDLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UDLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUD", static_cast<double>(0.0), &ADMSbsim6::Model::LUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUD", static_cast<double>(0.0), &ADMSbsim6::Model::WUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUD", static_cast<double>(0.0), &ADMSbsim6::Model::PUD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UDR", 0.0, &ADMSbsim6::Model::UDR)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUDR", 0.0, &ADMSbsim6::Model::LUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUDR", 0.0, &ADMSbsim6::Model::WUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUDR", 0.0, &ADMSbsim6::Model::PUDR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCS", static_cast<double>(2.0), &ADMSbsim6::Model::UCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUCS", static_cast<double>(0.0), &ADMSbsim6::Model::LUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUCS", static_cast<double>(0.0), &ADMSbsim6::Model::WUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUCS", static_cast<double>(0.0), &ADMSbsim6::Model::PUCS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCSR", 0.0, &ADMSbsim6::Model::UCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulombic scattering parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUCSR", 0.0, &ADMSbsim6::Model::LUCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUCSR", 0.0, &ADMSbsim6::Model::WUCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUCSR", 0.0, &ADMSbsim6::Model::PUCSR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UC", static_cast<double>(0.0), &ADMSbsim6::Model::UC)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction with body bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCL", static_cast<double>(0.0), &ADMSbsim6::Model::UCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UCLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCW", static_cast<double>(0.0), &ADMSbsim6::Model::UCW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCWEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UCWEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence exponent coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCWL", static_cast<double>(0.0), &ADMSbsim6::Model::UCWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::UCWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Width-Length dependence exponent coefficient of UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUC", static_cast<double>(0.0), &ADMSbsim6::Model::LUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUC", static_cast<double>(0.0), &ADMSbsim6::Model::WUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUC", static_cast<double>(0.0), &ADMSbsim6::Model::PUC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCR", 0.0, &ADMSbsim6::Model::UCR)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction with body bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUCR", 0.0, &ADMSbsim6::Model::LUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUCR", 0.0, &ADMSbsim6::Model::WUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUCR", 0.0, &ADMSbsim6::Model::PUCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLM", static_cast<double>(0.0), &ADMSbsim6::Model::PCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM prefactor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLML", static_cast<double>(0.0), &ADMSbsim6::Model::PCLML)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PCLMLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PCLM")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCLM", static_cast<double>(0.0), &ADMSbsim6::Model::LPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPCLM", static_cast<double>(0.0), &ADMSbsim6::Model::WPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPCLM", static_cast<double>(0.0), &ADMSbsim6::Model::PPCLM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMR", 0.0, &ADMSbsim6::Model::PCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM prefactor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCLMR", 0.0, &ADMSbsim6::Model::LPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPCLMR", 0.0, &ADMSbsim6::Model::WPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPCLMR", 0.0, &ADMSbsim6::Model::PPCLMR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMG", static_cast<double>(0.0), &ADMSbsim6::Model::PCLMG)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM prefactor gate voltage dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMCV", 0.0, &ADMSbsim6::Model::PCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM parameter for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMCVL", 0.0, &ADMSbsim6::Model::PCLMCVL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMCVLEXP", 0.0, &ADMSbsim6::Model::PCLMCVLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCLMCV", 0.0, &ADMSbsim6::Model::LPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPCLMCV", 0.0, &ADMSbsim6::Model::WPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPCLMCV", 0.0, &ADMSbsim6::Model::PPCLMCV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCBE1", static_cast<double>(4.24e8), &ADMSbsim6::Model::PSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate current body-effect coeff")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPSCBE1", static_cast<double>(0.0), &ADMSbsim6::Model::LPSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPSCBE1", static_cast<double>(0.0), &ADMSbsim6::Model::WPSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPSCBE1", static_cast<double>(0.0), &ADMSbsim6::Model::PPSCBE1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCBE2", static_cast<double>(1.0e-8), &ADMSbsim6::Model::PSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate current body-effect coeff")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPSCBE2", static_cast<double>(0.0), &ADMSbsim6::Model::LPSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPSCBE2", static_cast<double>(0.0), &ADMSbsim6::Model::WPSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPSCBE2", static_cast<double>(0.0), &ADMSbsim6::Model::PPSCBE2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDITS", static_cast<double>(0.0), &ADMSbsim6::Model::PDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for drain-induced Vth shifts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDITS", static_cast<double>(0.0), &ADMSbsim6::Model::LPDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPDITS", static_cast<double>(0.0), &ADMSbsim6::Model::WPDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDITS", static_cast<double>(0.0), &ADMSbsim6::Model::PPDITS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDITSL", static_cast<double>(0.0), &ADMSbsim6::Model::PDITSL)
    .setUnit(U_UNKNOWN)
    .setDescription("L dep of drain-induced Vth shifts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::PDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Vds dep of drain-induced Vth shifts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::LPDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::WPDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDITSD", static_cast<double>(0.0), &ADMSbsim6::Model::PPDITSD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSH", static_cast<double>(0.0), &ADMSbsim6::Model::RSH)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-drain sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRWG", static_cast<double>(1.0), &ADMSbsim6::Model::PRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("gate bias dependence of S/D extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPRWG", static_cast<double>(0.0), &ADMSbsim6::Model::LPRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPRWG", static_cast<double>(0.0), &ADMSbsim6::Model::WPRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPRWG", static_cast<double>(0.0), &ADMSbsim6::Model::PPRWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRWB", static_cast<double>(0.0), &ADMSbsim6::Model::PRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("Body bias dependence of resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPRWB", static_cast<double>(0.0), &ADMSbsim6::Model::LPRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPRWB", static_cast<double>(0.0), &ADMSbsim6::Model::WPRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPRWB", static_cast<double>(0.0), &ADMSbsim6::Model::PPRWB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRWBL", static_cast<double>(0.0), &ADMSbsim6::Model::PRWBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PPRWB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRWBLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PRWBLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PPRWB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WR", static_cast<double>(1.0), &ADMSbsim6::Model::WR)
    .setUnit(U_UNKNOWN)
    .setDescription("W dependence parameter of S/D extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LWR", static_cast<double>(0.0), &ADMSbsim6::Model::LWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WWR", static_cast<double>(0.0), &ADMSbsim6::Model::WWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWR", static_cast<double>(0.0), &ADMSbsim6::Model::PWR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::RSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Source Resistance per unit width at high Vgs (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::LRSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WRSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::WRSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::PRSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW", static_cast<double>(10.0), &ADMSbsim6::Model::RSW)
    .setUnit(U_UNKNOWN)
    .setDescription("zero bias Source Resistance (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRSW", static_cast<double>(0.0), &ADMSbsim6::Model::LRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WRSW", static_cast<double>(0.0), &ADMSbsim6::Model::WRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRSW", static_cast<double>(0.0), &ADMSbsim6::Model::PRSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSWL", static_cast<double>(0.0), &ADMSbsim6::Model::RSWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RSW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::RSWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RSW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDWMIN", 0.0, &ADMSbsim6::Model::RDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain Resistance per unit width at high Vgs (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRDWMIN", 0.0, &ADMSbsim6::Model::LRDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WRDWMIN", 0.0, &ADMSbsim6::Model::WRDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRDWMIN", 0.0, &ADMSbsim6::Model::PRDWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDW", 0.0, &ADMSbsim6::Model::RDW)
    .setUnit(U_UNKNOWN)
    .setDescription("zero bias Drain Resistance (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRDW", 0.0, &ADMSbsim6::Model::LRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WRDW", 0.0, &ADMSbsim6::Model::WRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRDW", 0.0, &ADMSbsim6::Model::PRDW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDWL", 0.0, &ADMSbsim6::Model::RDWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDWLEXP", 0.0, &ADMSbsim6::Model::RDWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDW (RDSMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::RDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("S/D Resistance per unit width at high Vgs (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::LRDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WRDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::WRDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRDSWMIN", static_cast<double>(0.0), &ADMSbsim6::Model::PRDSWMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDSW", static_cast<double>(20.0), &ADMSbsim6::Model::RDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("zero bias Resistance (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDSWL", static_cast<double>(0.0), &ADMSbsim6::Model::RDSWL)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDSW (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDSWLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::RDSWLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical scaling of RDSW (RDSMOD=0 and RDSMOD=2)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRDSW", static_cast<double>(0.0), &ADMSbsim6::Model::LRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WRDSW", static_cast<double>(0.0), &ADMSbsim6::Model::WRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRDSW", static_cast<double>(0.0), &ADMSbsim6::Model::PRDSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSAT", static_cast<double>(1.0), &ADMSbsim6::Model::PSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Gmsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPSAT", static_cast<double>(0.0), &ADMSbsim6::Model::LPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPSAT", static_cast<double>(0.0), &ADMSbsim6::Model::WPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPSAT", static_cast<double>(0.0), &ADMSbsim6::Model::PPSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSATL", static_cast<double>(0.0), &ADMSbsim6::Model::PSATL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSATLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PSATLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSATB", static_cast<double>(0.0), &ADMSbsim6::Model::PSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("Body bias effect on Idsat")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSATR", 0.0, &ADMSbsim6::Model::PSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("Gmsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPSATR", 0.0, &ADMSbsim6::Model::LPSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPSATR", 0.0, &ADMSbsim6::Model::WPSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPSATR", 0.0, &ADMSbsim6::Model::PPSATR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPSATB", static_cast<double>(0.0), &ADMSbsim6::Model::LPSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPSATB", static_cast<double>(0.0), &ADMSbsim6::Model::WPSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPSATB", static_cast<double>(0.0), &ADMSbsim6::Model::PPSATB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSATX", static_cast<double>(1.0), &ADMSbsim6::Model::PSATX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWG", static_cast<double>(0.0), &ADMSbsim6::Model::PTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Idsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPTWG", static_cast<double>(0.0), &ADMSbsim6::Model::LPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPTWG", static_cast<double>(0.0), &ADMSbsim6::Model::WPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPTWG", static_cast<double>(0.0), &ADMSbsim6::Model::PPTWG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGL", static_cast<double>(0.0), &ADMSbsim6::Model::PTWGL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PTWGLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGR", 0.0, &ADMSbsim6::Model::PTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("Idsat variation with gate bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPTWGR", 0.0, &ADMSbsim6::Model::LPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPTWGR", 0.0, &ADMSbsim6::Model::WPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPTWGR", 0.0, &ADMSbsim6::Model::PPTWGR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGLR", 0.0, &ADMSbsim6::Model::PTWGLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGLEXPR", 0.0, &ADMSbsim6::Model::PTWGLEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1", static_cast<double>(0.0), &ADMSbsim6::Model::A1)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-saturation effect parameter for strong inversion region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA1", static_cast<double>(0.0), &ADMSbsim6::Model::LA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WA1", static_cast<double>(0.0), &ADMSbsim6::Model::WA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA1", static_cast<double>(0.0), &ADMSbsim6::Model::PA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A11", static_cast<double>(0.0), &ADMSbsim6::Model::A11)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA11", static_cast<double>(0.0), &ADMSbsim6::Model::LA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WA11", static_cast<double>(0.0), &ADMSbsim6::Model::WA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA11", static_cast<double>(0.0), &ADMSbsim6::Model::PA11)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A2", static_cast<double>(0.0), &ADMSbsim6::Model::A2)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-saturation effect parameter for moderate inversion region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA2", static_cast<double>(0.0), &ADMSbsim6::Model::LA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WA2", static_cast<double>(0.0), &ADMSbsim6::Model::WA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA2", static_cast<double>(0.0), &ADMSbsim6::Model::PA2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A21", static_cast<double>(0.0), &ADMSbsim6::Model::A21)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA21", static_cast<double>(0.0), &ADMSbsim6::Model::LA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WA21", static_cast<double>(0.0), &ADMSbsim6::Model::WA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA21", static_cast<double>(0.0), &ADMSbsim6::Model::PA21)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for DIBL effect on Rout")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBLCL", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBLCLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::PDIBLCLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::LPDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::WPDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDIBLC", static_cast<double>(0.0), &ADMSbsim6::Model::PPDIBLC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBLCR", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for DIBL effect on Rout")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBLCLR", 0.0, &ADMSbsim6::Model::PDIBLCLR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBLCLEXPR", 0.0, &ADMSbsim6::Model::PDIBLCLEXPR)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of PDIBLC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDIBLCR", 0.0, &ADMSbsim6::Model::LPDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPDIBLCR", 0.0, &ADMSbsim6::Model::WPDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDIBLCR", 0.0, &ADMSbsim6::Model::PPDIBLCR)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::PDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("parameter for DIBL effect on Rout")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::LPDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::WPDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDIBLCB", static_cast<double>(0.0), &ADMSbsim6::Model::PPDIBLCB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVAG", static_cast<double>(1.0), &ADMSbsim6::Model::PVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("Vg dependence of early voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPVAG", static_cast<double>(0.0), &ADMSbsim6::Model::LPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPVAG", static_cast<double>(0.0), &ADMSbsim6::Model::WPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPVAG", static_cast<double>(0.0), &ADMSbsim6::Model::PPVAG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::FPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FPROUTL", static_cast<double>(0.0), &ADMSbsim6::Model::FPROUTL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of FPROUT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FPROUTLEXP", static_cast<double>(1.0), &ADMSbsim6::Model::FPROUTLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of FPROUT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LFPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::LFPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WFPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::WFPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PFPROUT", static_cast<double>(0.0), &ADMSbsim6::Model::PFPROUT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::ALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("first parameter of Iii, m/V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA0L", static_cast<double>(0.0), &ADMSbsim6::Model::ALPHA0L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of ALPHA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA0LEXP", static_cast<double>(1.0), &ADMSbsim6::Model::ALPHA0LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent coefficient of ALPHA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::LALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::WALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PALPHA0", static_cast<double>(0.0), &ADMSbsim6::Model::PALPHA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETA0", static_cast<double>(0.0), &ADMSbsim6::Model::BETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("Vds dependent parameter of Iii, 1/V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBETA0", static_cast<double>(0.0), &ADMSbsim6::Model::LBETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBETA0", static_cast<double>(0.0), &ADMSbsim6::Model::WBETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBETA0", static_cast<double>(0.0), &ADMSbsim6::Model::PBETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGBACC", static_cast<double>(1.36e-2), &ADMSbsim6::Model::AIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGBACC", static_cast<double>(1.71e-3), &ADMSbsim6::Model::BIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGBACC", static_cast<double>(0.075), &ADMSbsim6::Model::CIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIGBACC", static_cast<double>(1.0), &ADMSbsim6::Model::NIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igbacc slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGBINV", static_cast<double>(1.11e-2), &ADMSbsim6::Model::AIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGBINV", static_cast<double>(9.49e-4), &ADMSbsim6::Model::BIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGBINV", static_cast<double>(0.006), &ADMSbsim6::Model::CIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igb")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EIGBINV", static_cast<double>(1.1), &ADMSbsim6::Model::EIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parm for the Si bandgap for Igbinv")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIGBINV", static_cast<double>(3.0), &ADMSbsim6::Model::NIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igbinv slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGC", 0.0, &ADMSbsim6::Model::AIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGC", 0.0, &ADMSbsim6::Model::BIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGC", 0.0, &ADMSbsim6::Model::CIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igc")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGS", 0.0, &ADMSbsim6::Model::AIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGS", 0.0, &ADMSbsim6::Model::BIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGS", 0.0, &ADMSbsim6::Model::CIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGD", 0.0, &ADMSbsim6::Model::AIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGD", 0.0, &ADMSbsim6::Model::BIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGD", 0.0, &ADMSbsim6::Model::CIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter for Igs d")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLCIG", 0.0, &ADMSbsim6::Model::DLCIG)
    .setUnit(U_METER)
    .setDescription("Delta L for Ig model [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLCIGD", 0.0, &ADMSbsim6::Model::DLCIGD)
    .setUnit(U_METER)
    .setDescription("Delta L for Ig model [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POXEDGE", static_cast<double>(1.0), &ADMSbsim6::Model::POXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Factor for the gate edge Tox")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTOX", static_cast<double>(1.0), &ADMSbsim6::Model::NTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for Tox ratio")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXREF", static_cast<double>(3.0e-9), &ADMSbsim6::Model::TOXREF)
    .setUnit(U_METER)
    .setDescription("Target tox value")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PIGCD", static_cast<double>(1.0), &ADMSbsim6::Model::PIGCD)
    .setUnit(U_UNKNOWN)
    .setDescription("Igc, S/D partition parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGCL", static_cast<double>(0.0), &ADMSbsim6::Model::AIGCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AIGC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGCW", static_cast<double>(0.0), &ADMSbsim6::Model::AIGCW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AIGC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGSL", static_cast<double>(0.0), &ADMSbsim6::Model::AIGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AIGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGSW", static_cast<double>(0.0), &ADMSbsim6::Model::AIGSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AIGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGDL", static_cast<double>(0.0), &ADMSbsim6::Model::AIGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AIGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGDW", static_cast<double>(0.0), &ADMSbsim6::Model::AIGDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AIGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PIGCDL", static_cast<double>(0.0), &ADMSbsim6::Model::PIGCDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of PIGCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PEIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::LNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::WNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNIGBINV", static_cast<double>(0.0), &ADMSbsim6::Model::PNIGBINV)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::LNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::WNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNIGBACC", static_cast<double>(0.0), &ADMSbsim6::Model::PNIGBACC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGC", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAIGC", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGC", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGC", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBIGC", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGC", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGC", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCIGC", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGC", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGS", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAIGS", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGS", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGS", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBIGS", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGS", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGS", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCIGS", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGS", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PAIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PBIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPOXEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::LPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPOXEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::WPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPOXEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::PPOXEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDLCIG", static_cast<double>(0.0), &ADMSbsim6::Model::LDLCIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDLCIG", static_cast<double>(0.0), &ADMSbsim6::Model::WDLCIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDLCIG", static_cast<double>(0.0), &ADMSbsim6::Model::PDLCIG)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDLCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::LDLCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WDLCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::WDLCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDLCIGD", static_cast<double>(0.0), &ADMSbsim6::Model::PDLCIGD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNTOX", static_cast<double>(0.0), &ADMSbsim6::Model::LNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WNTOX", static_cast<double>(0.0), &ADMSbsim6::Model::WNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNTOX", static_cast<double>(0.0), &ADMSbsim6::Model::PNTOX)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::AGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("pre-exponential coeff. for GIDL in mho")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLL", static_cast<double>(0.0), &ADMSbsim6::Model::AGIDLL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLW", static_cast<double>(0.0), &ADMSbsim6::Model::AGIDLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PAGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDL", static_cast<double>(2.3e9), &ADMSbsim6::Model::BGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GIDL in")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LBGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WBGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PBGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDL", static_cast<double>(0.5), &ADMSbsim6::Model::CGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GIDL in V/m")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EGIDL", static_cast<double>(0.8), &ADMSbsim6::Model::EGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("band bending parameter for GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PEGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGISL", 0.0, &ADMSbsim6::Model::AGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("pre-exponential coeff. for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGISLL", 0.0, &ADMSbsim6::Model::AGISLL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of AGISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGISLW", 0.0, &ADMSbsim6::Model::AGISLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient of AGISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAGISL", 0.0, &ADMSbsim6::Model::LAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAGISL", 0.0, &ADMSbsim6::Model::WAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAGISL", 0.0, &ADMSbsim6::Model::PAGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGISL", 0.0, &ADMSbsim6::Model::BGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBGISL", 0.0, &ADMSbsim6::Model::LBGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBGISL", 0.0, &ADMSbsim6::Model::WBGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBGISL", 0.0, &ADMSbsim6::Model::PBGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGISL", 0.0, &ADMSbsim6::Model::CGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("exponential coeff. for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGISL", 0.0, &ADMSbsim6::Model::LCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCGISL", 0.0, &ADMSbsim6::Model::WCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGISL", 0.0, &ADMSbsim6::Model::PCGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EGISL", 0.0, &ADMSbsim6::Model::EGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("band bending parameter for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEGISL", 0.0, &ADMSbsim6::Model::LEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEGISL", 0.0, &ADMSbsim6::Model::WEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEGISL", 0.0, &ADMSbsim6::Model::PEGISL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CF", static_cast<double>(0.0), &ADMSbsim6::Model::CF)
    .setUnit(U_FARAD)
    .setDescription("Outer Fringe Cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCF", static_cast<double>(0.0), &ADMSbsim6::Model::LCF)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCF", static_cast<double>(0.0), &ADMSbsim6::Model::WCF)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCF", static_cast<double>(0.0), &ADMSbsim6::Model::PCF)
    .setUnit(U_FARAD)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRCOEFF", static_cast<double>(1.0), &ADMSbsim6::Model::CFRCOEFF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for Outer Fringe Cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGSO", static_cast<double>(0.0), &ADMSbsim6::Model::CGSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Source overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGDO", static_cast<double>(0.0), &ADMSbsim6::Model::CGDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Drain overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBO", static_cast<double>(0.0), &ADMSbsim6::Model::CGBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Body overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGSL", static_cast<double>(0.0), &ADMSbsim6::Model::CGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGSL", static_cast<double>(0.0), &ADMSbsim6::Model::LCGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCGSL", static_cast<double>(0.0), &ADMSbsim6::Model::WCGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGSL", static_cast<double>(0.0), &ADMSbsim6::Model::PCGSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGDL", static_cast<double>(0.0), &ADMSbsim6::Model::CGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGDL", static_cast<double>(0.0), &ADMSbsim6::Model::LCGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCGDL", static_cast<double>(0.0), &ADMSbsim6::Model::WCGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGDL", static_cast<double>(0.0), &ADMSbsim6::Model::PCGDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CKAPPAS", static_cast<double>(0.6), &ADMSbsim6::Model::CKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCKAPPAS", static_cast<double>(0.0), &ADMSbsim6::Model::LCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCKAPPAS", static_cast<double>(0.0), &ADMSbsim6::Model::WCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCKAPPAS", static_cast<double>(0.0), &ADMSbsim6::Model::PCKAPPAS)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CKAPPAD", static_cast<double>(0.6), &ADMSbsim6::Model::CKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCKAPPAD", static_cast<double>(0.0), &ADMSbsim6::Model::LCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WCKAPPAD", static_cast<double>(0.0), &ADMSbsim6::Model::WCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCKAPPAD", static_cast<double>(0.0), &ADMSbsim6::Model::PCKAPPAD)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DMCG", static_cast<double>(0.0), &ADMSbsim6::Model::DMCG)
    .setUnit(U_METER)
    .setDescription("Distance of Mid-Contact to Gate edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DMCI", 0.0, &ADMSbsim6::Model::DMCI)
    .setUnit(U_METER)
    .setDescription("Distance of Mid-Contact to Isolation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DMDG", static_cast<double>(0.0), &ADMSbsim6::Model::DMDG)
    .setUnit(U_METER)
    .setDescription("Distance of Mid-Diffusion to Gate edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DMCGT", static_cast<double>(0.0), &ADMSbsim6::Model::DMCGT)
    .setUnit(U_METER)
    .setDescription("Dist of Mid-Contact to Gate edge in Test")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XGL", static_cast<double>(0.0), &ADMSbsim6::Model::XGL)
    .setUnit(U_METER)
    .setDescription("Variation in Ldrawn")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSHG", static_cast<double>(0.1), &ADMSbsim6::Model::RSHG)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJS", static_cast<double>(5.0e-4), &ADMSbsim6::Model::CJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit area source-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJD", 0.0, &ADMSbsim6::Model::CJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit area drain-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWS", static_cast<double>(5.0e-10), &ADMSbsim6::Model::CJSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length source-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWD", 0.0, &ADMSbsim6::Model::CJSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length drain-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWGS", static_cast<double>(0.0), &ADMSbsim6::Model::CJSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length source-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWGD", 0.0, &ADMSbsim6::Model::CJSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length drain-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBS", static_cast<double>(1.0), &ADMSbsim6::Model::PBS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBD", 0.0, &ADMSbsim6::Model::PBD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWS", static_cast<double>(1.0), &ADMSbsim6::Model::PBSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Source-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWD", 0.0, &ADMSbsim6::Model::PBSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Drain-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWGS", 0.0, &ADMSbsim6::Model::PBSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Source-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWGD", 0.0, &ADMSbsim6::Model::PBSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Built-in potential for Drain-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJS", static_cast<double>(0.5), &ADMSbsim6::Model::MJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJD", 0.0, &ADMSbsim6::Model::MJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWS", static_cast<double>(0.33), &ADMSbsim6::Model::MJSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWD", 0.0, &ADMSbsim6::Model::MJSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWGS", 0.0, &ADMSbsim6::Model::MJSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWGD", 0.0, &ADMSbsim6::Model::MJSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSS", static_cast<double>(1.0e-4), &ADMSbsim6::Model::JSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSD", 0.0, &ADMSbsim6::Model::JSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWS", static_cast<double>(0.0), &ADMSbsim6::Model::JSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWD", 0.0, &ADMSbsim6::Model::JSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWGS", static_cast<double>(0.0), &ADMSbsim6::Model::JSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWGD", 0.0, &ADMSbsim6::Model::JSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJS", static_cast<double>(1.0), &ADMSbsim6::Model::NJS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJD", 0.0, &ADMSbsim6::Model::NJD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHSFWD", static_cast<double>(0.1), &ADMSbsim6::Model::IJTHSFWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Forward source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHDFWD", 0.0, &ADMSbsim6::Model::IJTHDFWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Forward drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHSREV", static_cast<double>(0.1), &ADMSbsim6::Model::IJTHSREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHDREV", 0.0, &ADMSbsim6::Model::IJTHDREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Reverse drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BVS", static_cast<double>(10.0), &ADMSbsim6::Model::BVS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BVD", 0.0, &ADMSbsim6::Model::BVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJBVS", static_cast<double>(1.0), &ADMSbsim6::Model::XJBVS)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for source diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJBVD", 0.0, &ADMSbsim6::Model::XJBVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Fitting parameter for drain diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSS", static_cast<double>(0.0), &ADMSbsim6::Model::JTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSD", 0.0, &ADMSbsim6::Model::JTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWS", static_cast<double>(0.0), &ADMSbsim6::Model::JTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWD", 0.0, &ADMSbsim6::Model::JTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWGS", static_cast<double>(0.0), &ADMSbsim6::Model::JTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWGD", 0.0, &ADMSbsim6::Model::JTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTWEFF", static_cast<double>(0.0), &ADMSbsim6::Model::JTWEFF)
    .setUnit(U_UNKNOWN)
    .setDescription("Trap assisted tunneling current width dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTS", static_cast<double>(20.0), &ADMSbsim6::Model::NJTS)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSD", 0.0, &ADMSbsim6::Model::NJTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSW", static_cast<double>(20.0), &ADMSbsim6::Model::NJTSSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSWD", 0.0, &ADMSbsim6::Model::NJTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSWG", static_cast<double>(20.0), &ADMSbsim6::Model::NJTSSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSWGD", 0.0, &ADMSbsim6::Model::NJTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Non-ideality factor for JTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSS", static_cast<double>(10.0), &ADMSbsim6::Model::VTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom source junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSD", 0.0, &ADMSbsim6::Model::VTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Bottom drain junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWS", static_cast<double>(10.0), &ADMSbsim6::Model::VTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWD", 0.0, &ADMSbsim6::Model::VTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWGS", static_cast<double>(10.0), &ADMSbsim6::Model::VTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWGD", 0.0, &ADMSbsim6::Model::VTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XRCRG1", static_cast<double>(12.0), &ADMSbsim6::Model::XRCRG1)
    .setUnit(U_UNKNOWN)
    .setDescription("1st fitting parm the bias-dependent Rg //make it binnable")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XRCRG2", static_cast<double>(1.0), &ADMSbsim6::Model::XRCRG2)
    .setUnit(U_UNKNOWN)
    .setDescription("2nd fitting parm the bias-dependent Rg  //make it binnable")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GBMIN", static_cast<double>(1.0e-12), &ADMSbsim6::Model::GBMIN)
    .setUnit(U_UNKNOWN)
    .setDescription("Minimum body conductance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPS0", static_cast<double>(50.0), &ADMSbsim6::Model::RBPS0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBPS 50 Ohms")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPSL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPSL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPSW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPSW)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPSNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPSNF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPD0", static_cast<double>(50.0), &ADMSbsim6::Model::RBPD0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPDL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBPD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPDW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBPD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPDNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPDNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBPD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBX0", static_cast<double>(100.0), &ADMSbsim6::Model::RBPBX0)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBXL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBXL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBPBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBXW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBXW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBPBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBXNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBXNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBPBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBY0", static_cast<double>(100.0), &ADMSbsim6::Model::RBPBY0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBYL", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBYL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBYW", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBYW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBPBYNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBPBYNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBPBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSBX0", static_cast<double>(100.0), &ADMSbsim6::Model::RBSBX0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBSBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSBY0", static_cast<double>(100.0), &ADMSbsim6::Model::RBSBY0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBSBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBDBX0", static_cast<double>(100.0), &ADMSbsim6::Model::RBDBX0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBDBY0", static_cast<double>(100.0), &ADMSbsim6::Model::RBDBY0)
    .setUnit(U_UNKNOWN)
    .setDescription("Scaling prefactor for RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSDBXL", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBXL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBSBX and RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSDBXW", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBXW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBSBX and RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSDBXNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBXNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBSBX and RBDBX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSDBYL", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBYL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for RBSBY and RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSDBYW", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBYW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Scaling parameter for RBSBY and RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBSDBYNF", static_cast<double>(0.0), &ADMSbsim6::Model::RBSDBYNF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers Scaling parameter for RBSBY and RBDBY")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EF", static_cast<double>(1.0), &ADMSbsim6::Model::EF)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker Noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EM", static_cast<double>(4.1e7), &ADMSbsim6::Model::EM)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOIA", static_cast<double>(6.250e+40), &ADMSbsim6::Model::NOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOIB", static_cast<double>(3.125e+25), &ADMSbsim6::Model::NOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOIC", static_cast<double>(8.750e+8), &ADMSbsim6::Model::NOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSbsim6::Model::LINTNOI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTNOI", static_cast<double>(1.0), &ADMSbsim6::Model::NTNOI)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RNOIA", static_cast<double>(0.577), &ADMSbsim6::Model::RNOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RNOIB", static_cast<double>(0.5164), &ADMSbsim6::Model::RNOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RNOIC", static_cast<double>(0.395), &ADMSbsim6::Model::RNOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOIA", static_cast<double>(0.0), &ADMSbsim6::Model::TNOIA)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOIB", static_cast<double>(0.0), &ADMSbsim6::Model::TNOIB)
    .setUnit(U_UNKNOWN)
    .setDescription("TNOIMOD = 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOIC", static_cast<double>(0.0), &ADMSbsim6::Model::TNOIC)
    .setUnit(U_UNKNOWN)
    .setDescription("Correlation coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BINUNIT", static_cast<int>(1), &ADMSbsim6::Model::BINUNIT)
    .setUnit(U_UNKNOWN)
    .setDescription("Unit of L and W for Binning, 1 : micro-meter, 0 : default");
  p.addPar("DLBIN", static_cast<double>(0.0), &ADMSbsim6::Model::DLBIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DWBIN", static_cast<double>(0.0), &ADMSbsim6::Model::DWBIN)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSbsim6::Model::TNOM)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature at which the model was extracted")
   .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSbsim6::Model::DTEMP)
    .setUnit(U_UNKNOWN)
    .setDescription("Offset of Device Temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBGASUB", static_cast<double>(4.73e-4), &ADMSbsim6::Model::TBGASUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap Temperature Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBGBSUB", static_cast<double>(636.0), &ADMSbsim6::Model::TBGBSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Bandgap Temperature Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNFACTOR", static_cast<double>(0.0), &ADMSbsim6::Model::TNFACTOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature exponent for NFACTOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UTE", static_cast<double>((-1.5)), &ADMSbsim6::Model::UTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUTE", static_cast<double>(0.0), &ADMSbsim6::Model::LUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUTE", static_cast<double>(0.0), &ADMSbsim6::Model::WUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUTE", static_cast<double>(0.0), &ADMSbsim6::Model::PUTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UTEL", static_cast<double>(0.0), &ADMSbsim6::Model::UTEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for UTE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UA1", static_cast<double>(1.0e-3), &ADMSbsim6::Model::UA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUA1", static_cast<double>(0.0), &ADMSbsim6::Model::LUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUA1", static_cast<double>(0.0), &ADMSbsim6::Model::WUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUA1", static_cast<double>(0.0), &ADMSbsim6::Model::PUA1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UA1L", static_cast<double>(0.0), &ADMSbsim6::Model::UA1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for UA1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UC1", static_cast<double>(0.056e-9), &ADMSbsim6::Model::UC1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUC1", static_cast<double>(0.0), &ADMSbsim6::Model::LUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUC1", static_cast<double>(0.0), &ADMSbsim6::Model::WUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUC1", static_cast<double>(0.0), &ADMSbsim6::Model::PUC1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UD1", static_cast<double>(0.0), &ADMSbsim6::Model::UD1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUD1", static_cast<double>(0.0), &ADMSbsim6::Model::LUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUD1", static_cast<double>(0.0), &ADMSbsim6::Model::WUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUD1", static_cast<double>(0.0), &ADMSbsim6::Model::PUD1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UD1L", static_cast<double>(0.0), &ADMSbsim6::Model::UD1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for UD1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCSTE", static_cast<double>((-4.775e-3)), &ADMSbsim6::Model::UCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for UCS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUCSTE", static_cast<double>(0.0), &ADMSbsim6::Model::LUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WUCSTE", static_cast<double>(0.0), &ADMSbsim6::Model::WUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUCSTE", static_cast<double>(0.0), &ADMSbsim6::Model::PUCSTE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TETA0", static_cast<double>(0.0), &ADMSbsim6::Model::TETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for ETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRT", static_cast<double>(0.0), &ADMSbsim6::Model::PRT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPRT", static_cast<double>(0.0), &ADMSbsim6::Model::LPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPRT", static_cast<double>(0.0), &ADMSbsim6::Model::WPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPRT", static_cast<double>(0.0), &ADMSbsim6::Model::PPRT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AT", static_cast<double>((-1.56e-3)), &ADMSbsim6::Model::AT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for saturation velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAT", static_cast<double>(0.0), &ADMSbsim6::Model::LAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WAT", static_cast<double>(0.0), &ADMSbsim6::Model::WAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAT", static_cast<double>(0.0), &ADMSbsim6::Model::PAT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ATL", static_cast<double>(0.0), &ADMSbsim6::Model::ATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for AT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TDELTA", static_cast<double>(0.0), &ADMSbsim6::Model::TDELTA)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for DELTA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::PTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PTWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::LPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WPTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::WPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPTWGT", static_cast<double>(0.0), &ADMSbsim6::Model::PPTWGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGTL", static_cast<double>(0.0), &ADMSbsim6::Model::PTWGTL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Scaling parameter for PTWGT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1", static_cast<double>((-0.11)), &ADMSbsim6::Model::KT1)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1EXP", static_cast<double>(1.0), &ADMSbsim6::Model::KT1EXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1L", static_cast<double>(0.0), &ADMSbsim6::Model::KT1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKT1", static_cast<double>(0.0), &ADMSbsim6::Model::LKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKT1", static_cast<double>(0.0), &ADMSbsim6::Model::WKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKT1", static_cast<double>(0.0), &ADMSbsim6::Model::PKT1)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT2", static_cast<double>(0.022), &ADMSbsim6::Model::KT2)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKT2", static_cast<double>(0.0), &ADMSbsim6::Model::LKT2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKT2", static_cast<double>(0.0), &ADMSbsim6::Model::WKT2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKT2", static_cast<double>(0.0), &ADMSbsim6::Model::PKT2)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IIT", static_cast<double>(0.0), &ADMSbsim6::Model::IIT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for BETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LIIT", static_cast<double>(0.0), &ADMSbsim6::Model::LIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WIIT", static_cast<double>(0.0), &ADMSbsim6::Model::WIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PIIT", static_cast<double>(0.0), &ADMSbsim6::Model::PIIT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGT", static_cast<double>(2.5), &ADMSbsim6::Model::IGT)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate Current Temperature Dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LIGT", static_cast<double>(0.0), &ADMSbsim6::Model::LIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WIGT", static_cast<double>(0.0), &ADMSbsim6::Model::WIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PIGT", static_cast<double>(0.0), &ADMSbsim6::Model::PIGT)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::TGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for GIDL/GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LTGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::LTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WTGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::WTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTGIDL", static_cast<double>(0.0), &ADMSbsim6::Model::PTGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TCJ", static_cast<double>(0.0), &ADMSbsim6::Model::TCJ)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJS/CJD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TCJSW", static_cast<double>(0.0), &ADMSbsim6::Model::TCJSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJSWS/CJSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TCJSWG", static_cast<double>(0.0), &ADMSbsim6::Model::TCJSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for CJSWGS/CJSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TPB", static_cast<double>(0.0), &ADMSbsim6::Model::TPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBS/PBD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TPBSW", static_cast<double>(0.0), &ADMSbsim6::Model::TPBSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBSWS/PBSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TPBSWG", static_cast<double>(0.0), &ADMSbsim6::Model::TPBSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for PBSWGS/PBSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTIS", static_cast<double>(3.0), &ADMSbsim6::Model::XTIS)
    .setUnit(U_UNKNOWN)
    .setDescription("Source junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTID", 0.0, &ADMSbsim6::Model::XTID)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSS", static_cast<double>(0.02), &ADMSbsim6::Model::XTSS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSD", 0.0, &ADMSbsim6::Model::XTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWS", static_cast<double>(0.02), &ADMSbsim6::Model::XTSSWS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWD", 0.0, &ADMSbsim6::Model::XTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWGS", static_cast<double>(0.02), &ADMSbsim6::Model::XTSSWGS)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWGS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWGD", 0.0, &ADMSbsim6::Model::XTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Power dependence of JTSSWGD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTS", static_cast<double>(0.0), &ADMSbsim6::Model::TNJTS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSD", 0.0, &ADMSbsim6::Model::TNJTSD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSW", static_cast<double>(0.0), &ADMSbsim6::Model::TNJTSSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSWD", 0.0, &ADMSbsim6::Model::TNJTSSWD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSWG", static_cast<double>(0.0), &ADMSbsim6::Model::TNJTSSWG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSWGD", 0.0, &ADMSbsim6::Model::TNJTSSWGD)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature coefficient for NJTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTH0", static_cast<double>(0.0), &ADMSbsim6::Model::RTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTH0", static_cast<double>(1.0E-05), &ADMSbsim6::Model::CTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WTH0", static_cast<double>(0.0), &ADMSbsim6::Model::WTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence coefficient for Rth and Cth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SAREF", static_cast<double>(1.0e-6), &ADMSbsim6::Model::SAREF)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference distance between OD edge from Poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SBREF", static_cast<double>(1.0e-6), &ADMSbsim6::Model::SBREF)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference distance between OD edge from Poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLOD", static_cast<double>(0.0), &ADMSbsim6::Model::WLOD)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Parameter for Stress Effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KU0", static_cast<double>(0.0), &ADMSbsim6::Model::KU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility degradation/enhancement Parameter for Stress Effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVSAT", static_cast<double>(0.0), &ADMSbsim6::Model::KVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation Velocity degradation/enhancement Parameter for Stress Effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TKU0", static_cast<double>(0.0), &ADMSbsim6::Model::TKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature Coefficient for KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKU0", static_cast<double>(0.0), &ADMSbsim6::Model::LKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Dependence of KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKU0", static_cast<double>(0.0), &ADMSbsim6::Model::WKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Dependence of KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKU0", static_cast<double>(0.0), &ADMSbsim6::Model::PKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross Term Dependence of KU0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODKU0", static_cast<double>(0.0), &ADMSbsim6::Model::LLODKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Parameter for u0 stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODKU0", static_cast<double>(0.0), &ADMSbsim6::Model::WLODKU0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Parameter for u0 stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::KVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Threshold Shift parameter for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::LKVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KVTH0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::WKVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KVTH0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKVTH0", static_cast<double>(0.0), &ADMSbsim6::Model::PKVTH0)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KVTH0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODVTH", static_cast<double>(0.0), &ADMSbsim6::Model::LLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Length Parameter for Vth stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODVTH", static_cast<double>(0.0), &ADMSbsim6::Model::WLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Width Parameter for Vth stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STK2", static_cast<double>(0.0), &ADMSbsim6::Model::STK2)
    .setUnit(U_UNKNOWN)
    .setDescription("K2 shift factor related to Vth change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LODK2", static_cast<double>(0.0), &ADMSbsim6::Model::LODK2)
    .setUnit(U_UNKNOWN)
    .setDescription("K2 shift modification factor for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STETA0", static_cast<double>(0.0), &ADMSbsim6::Model::STETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("eta0 shift related to Vth0 change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LODETA0", static_cast<double>(0.0), &ADMSbsim6::Model::LODETA0)
    .setUnit(U_UNKNOWN)
    .setDescription("eta0 modification foator for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEB", static_cast<double>(0.0), &ADMSbsim6::Model::WEB)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEC", static_cast<double>(0.0), &ADMSbsim6::Model::WEC)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::KVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::LKVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::WKVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKVTH0WE", static_cast<double>(0.0), &ADMSbsim6::Model::PKVTH0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K2WE", static_cast<double>(0.0), &ADMSbsim6::Model::K2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK2WE", static_cast<double>(0.0), &ADMSbsim6::Model::LK2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WK2WE", static_cast<double>(0.0), &ADMSbsim6::Model::WK2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK2WE", static_cast<double>(0.0), &ADMSbsim6::Model::PK2WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::KU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::LKU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::WKU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKU0WE", static_cast<double>(0.0), &ADMSbsim6::Model::PKU0WE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCREF", static_cast<double>(1.0e-6), &ADMSbsim6::Model::SCREF)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EDGEFET", static_cast<int>(1), &ADMSbsim6::Model::EDGEFET)
    .setUnit(U_UNKNOWN)
    .setDescription("0: Edge FET Model Off, 1: Edge FET Model ON");
  p.addPar("WEDGE", static_cast<double>(10.0e-9), &ADMSbsim6::Model::WEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGAMMAEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::DGAMMAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGAMMAEDGEL", static_cast<double>(0.0), &ADMSbsim6::Model::DGAMMAEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGAMMAEDGELEXP", static_cast<double>(1.0), &ADMSbsim6::Model::DGAMMAEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTEDGE", static_cast<double>(0.0), &ADMSbsim6::Model::DVTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Vth shift for Edge FET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFACTOREDGE", 0.0, &ADMSbsim6::Model::NFACTOREDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CITEDGE", 0.0, &ADMSbsim6::Model::CITEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDEDGE", 0.0, &ADMSbsim6::Model::CDSCDEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCBEDGE", 0.0, &ADMSbsim6::Model::CDSCBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETA0EDGE", 0.0, &ADMSbsim6::Model::ETA0EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETABEDGE", 0.0, &ADMSbsim6::Model::ETABEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1EDGE", 0.0, &ADMSbsim6::Model::KT1EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1LEDGE", 0.0, &ADMSbsim6::Model::KT1LEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT2EDGE", 0.0, &ADMSbsim6::Model::KT2EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1EXPEDGE", 0.0, &ADMSbsim6::Model::KT1EXPEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNFACTOREDGE", 0.0, &ADMSbsim6::Model::TNFACTOREDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TETA0EDGE", 0.0, &ADMSbsim6::Model::TETA0EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVT0EDGE", static_cast<double>(2.2), &ADMSbsim6::Model::DVT0EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVT1EDGE", static_cast<double>(0.53), &ADMSbsim6::Model::DVT1EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVT2EDGE", static_cast<double>(0.0), &ADMSbsim6::Model::DVT2EDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Body-bias coefficient for SCE effect for Edge FET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMIN", static_cast<double>(0.0), &ADMSbsim6::Model::LMIN)
    .setUnit(U_METER)
    .setDescription("Minimum length for which this model should be used")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMIN", static_cast<double>(0.0), &ADMSbsim6::Model::WMIN)
    .setUnit(U_METER)
    .setDescription("Minimum width for which this model should be used")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMAX", static_cast<double>(100.0), &ADMSbsim6::Model::LMAX)
    .setUnit(U_METER)
    .setDescription("Maximum length for which this model should be used")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMAX", static_cast<double>(0.0), &ADMSbsim6::Model::WMAX)
    .setUnit(U_METER)
    .setDescription("Maximum width for which this model should be used")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
   if (!(given("L")))
   {
      L = model_.L;
   }
   if (!(given("VFBSDOFF")))
   {
      VFBSDOFF = model_.VFBSDOFF;
   }
   if (!(given("XGW")))
   {
      XGW = model_.XGW;
   }
   if (!(given("NGCON")))
   {
      NGCON = model_.NGCON;
   }
   if (!(given("RGATEMOD")))
   {
      RGATEMOD = model_.RGATEMOD;
   }
   if (!(given("RBODYMOD")))
   {
      RBODYMOD = model_.RBODYMOD;
   }
   if (!(given("GEOMOD")))
   {
      GEOMOD = model_.GEOMOD;
   }
   if (!(given("RGEOMOD")))
   {
      RGEOMOD = model_.RGEOMOD;
   }
   if (!(given("RBPB")))
   {
      RBPB = model_.RBPB;
   }
   if (!(given("RBPD")))
   {
      RBPD = model_.RBPD;
   }
   if (!(given("RBPS")))
   {
      RBPS = model_.RBPS;
   }
   if (!(given("RBDB")))
   {
      RBDB = model_.RBDB;
   }
   if (!(given("RBSB")))
   {
      RBSB = model_.RBSB;
   }
   if (!(given("SA")))
   {
      SA = model_.SA;
   }
   if (!(given("SB")))
   {
      SB = model_.SB;
   }
   if (!(given("SD")))
   {
      SD = model_.SD;
   }
   if (!(given("SCA")))
   {
      SCA = model_.SCA;
   }
   if (!(given("SCB")))
   {
      SCB = model_.SCB;
   }
   if (!(given("SCC")))
   {
      SCC = model_.SCC;
   }
   if (!(given("SC")))
   {
      SC = model_.SC;
   }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter L : ] 0,  (+inf) [
  if ( (!((L >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter L value " << L << " out of range ] 0,  (+inf) [";
  }

//    Parameter W : ] 0,  (+inf) [
  if ( (!((W >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter W value " << W << " out of range ] 0,  (+inf) [";
  }

//    Parameter NF : [ 1,  (+inf) [
  if ( (!((NF >=1))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NF value " << NF << " out of range [ 1,  (+inf) [";
  }

//    Parameter NRS : [ 0,  (+inf) [
  if ( (!((NRS >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NRS value " << NRS << " out of range [ 0,  (+inf) [";
  }

//    Parameter NRD : [ 0,  (+inf) [
  if ( (!((NRD >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NRD value " << NRD << " out of range [ 0,  (+inf) [";
  }

//    Parameter MINZ : [ 0, 1 ]
  if ( (!((MINZ >=0 && MINZ <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter MINZ value " << MINZ << " out of range [ 0, 1 ]";
  }

//    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

//    Parameter RGATEMOD : [ 0, 3 ]
  if ( (!((RGATEMOD >=0 && RGATEMOD <=3 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RGATEMOD value " << RGATEMOD << " out of range [ 0, 3 ]";
  }

//    Parameter RBODYMOD : [ 0, 2 ]
  if ( (!((RBODYMOD >=0 && RBODYMOD <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBODYMOD value " << RBODYMOD << " out of range [ 0, 2 ]";
  }

//    Parameter GEOMOD : [ 0, 10 ]
  if ( (!((GEOMOD >=0 && GEOMOD <=10 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter GEOMOD value " << GEOMOD << " out of range [ 0, 10 ]";
  }

//    Parameter RGEOMOD : [ 0, 8 ]
  if ( (!((RGEOMOD >=0 && RGEOMOD <=8 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RGEOMOD value " << RGEOMOD << " out of range [ 0, 8 ]";
  }

//    Parameter RBPB : [ 0,  (+inf) [
  if ( (!((RBPB >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPB value " << RBPB << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPD : [ 0,  (+inf) [
  if ( (!((RBPD >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPD value " << RBPD << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPS : [ 0,  (+inf) [
  if ( (!((RBPS >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPS value " << RBPS << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBDB : [ 0,  (+inf) [
  if ( (!((RBDB >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBDB value " << RBDB << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSB : [ 0,  (+inf) [
  if ( (!((RBSB >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSB value " << RBSB << " out of range [ 0,  (+inf) [";
  }

//    Parameter SCA :  ] (-inf)  (+inf) [

//    Parameter SCB :  ] (-inf)  (+inf) [

//    Parameter SCC :  ] (-inf)  (+inf) [

//    Parameter SC :  ] (-inf)  (+inf) [

//    Parameter AS : [ 0,  (+inf) [
  if ( (!((AS >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter AS value " << AS << " out of range [ 0,  (+inf) [";
  }

//    Parameter AD : [ 0,  (+inf) [
  if ( (!((AD >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter AD value " << AD << " out of range [ 0,  (+inf) [";
  }

//    Parameter PS : [ 0,  (+inf) [
  if ( (!((PS >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PS value " << PS << " out of range [ 0,  (+inf) [";
  }

//    Parameter PD : [ 0,  (+inf) [
  if ( (!((PD >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PD value " << PD << " out of range [ 0,  (+inf) [";
  }

//    Parameter m : ] 0.0,  (+inf) [
  if ( (!((m >0.0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter m value " << m << " out of range ] 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double ToxRatioEdge=0.0;
  double Rbpby=0.0;
  double Rbpbx=0.0;
  double Rbdby=0.0;
  double Rbdbx=0.0;
  double Rbsby=0.0;
  double Rbsbx=0.0;
  double Rbsb=0.0;
  double Rbdb=0.0;
  double Rbps=0.0;
  double Rbpd=0.0;
  double Rbpb=0.0;
  double Bodymode=0.0;
  double Lnnf=0.0;
  double Lnw=0.0;
  double Lnl=0.0;
  double Rtot=0.0;
  double Rint=0.0;
  double Rend=0.0;
  double NTOX_i=0.0;
  double POXEDGE_i=0.0;
  double BIN_WL=0.0;
  double BIN_W=0.0;
  double BIN_L=0.0;
  double Weff1=0.0;
  double Leff1=0.0;
  double dWB=0.0;
  double LW_WLN_WWN1=0.0;
  double dLB=0.0;
  double LW_LLN_LWN1=0.0;
  double Inv_WL=0.0;
  double Inv_Wwide=0.0;
  double Inv_Llong=0.0;
  double Inv_Wact=0.0;
  double Inv_Lact=0.0;
  double Inv_W=0.0;
  double Inv_L=0.0;
  double dWJ=0.0;
  double dWCV=0.0;
  double dLCV=0.0;
  double dWIV=0.0;
  double LW_WLN_WWN=0.0;
  double W_WWN=0.0;
  double L_WLN=0.0;
  double dLIV=0.0;
  double LW_LLN_LWN=0.0;
  double W_LWN=0.0;
  double L_LLN=0.0;
  double W_by_NF=0.0;
  double W_mult=0.0;
  double W_WWN1=0.0;
  double W_LWN1=0.0;
  double L_WLN1=0.0;
  double L_LLN1=0.0;
//Begin block initial_instance
{
CDSCDR_i = 0;
ETA0R_i = 0;

d_ETA0R_t_dTemp_t_GND =  0.0;
ETA0R_t = 0;
L_LLN1 = 0;
L_WLN1 = 0;
PCLMR_i = 0;
PDIBLCR_i = 0;
PSATR_i = 0;
PTWGR_i = 0;

d_PTWGR_t_dTemp_t_GND =  0.0;
PTWGR_t = 0;
U0R_i = 0;

d_U0R_t_dTemp_t_GND =  0.0;
U0R_t = 0;
UAR_i = 0;

d_UAR_t_dTemp_t_GND =  0.0;
UAR_t = 0;
UCR_i = 0;

d_UCR_t_dTemp_t_GND =  0.0;
UCR_t = 0;
UCSR_i = 0;

d_UCSR_t_dTemp_t_GND =  0.0;
UCSR_t = 0;
UDR_i = 0;

d_UDR_t_dTemp_t_GND =  0.0;
UDR_t = 0;

d_UD_a_dTemp_t_GND = d_UD_a_dV_di_bi = d_UD_a_dV_si_bi =  0.0;
UD_a = 0;
VSATR_i = 0;

d_VSATR_t_dTemp_t_GND =  0.0;
VSATR_t = 0;
W_LWN1 = 0;
W_WWN1 = 0;
if (((model_.TYPE)==1))
{
devsign = 1;
}
else
{
devsign = (-1);
}
epssi = ((model_.EPSRSUB)*8.85418e-12);
epsox = ((model_.EPSROX)*8.85418e-12);
Cox = (((model_.EPSROX)*8.85418e-12)/(model_.TOXE));
epsratio = ((model_.EPSRSUB)/(model_.EPSROX));
if ((!(model_.given("TOXP"))))
{
BSIM6TOXP = ((((model_.TOXE)*(model_.EPSROX))/3.9)-(model_.DTOX));
}
else
{
BSIM6TOXP = (model_.TOXP);
}
L_mult = (L*(model_.LMLT));
W_mult = (W*(model_.WMLT));
Lnew = (L_mult+(model_.XL));
if ((Lnew<=0))
{
UserInfo(*this)  << "Fatal: Ldrawn*LMLT+XL = %e for  %M is non-positive" << " " << Lnew << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
W_by_NF = (W_mult/NF);
Wnew = (W_by_NF+(model_.XW));
if ((Wnew<=0))
{
UserInfo(*this)  << "Fatal: W/NF*WMLT+XW = %e for  %M is non-positive" << " " << Wnew << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
{
double value_pow_0 = pow(Lnew,(-(model_.LLN)));
L_LLN = value_pow_0;
}
{
double value_pow_0 = pow(Wnew,(-(model_.LWN)));
W_LWN = value_pow_0;
}
LW_LLN_LWN = (L_LLN*W_LWN);
dLIV = ((((model_.LINT)+((model_.LL)*L_LLN))+((model_.LW)*W_LWN))+((model_.LWL)*LW_LLN_LWN));
{
double value_pow_0 = pow(Lnew,(-(model_.WLN)));
L_WLN = value_pow_0;
}
{
double value_pow_0 = pow(Wnew,(-(model_.WWN)));
W_WWN = value_pow_0;
}
LW_WLN_WWN = (L_WLN*W_WWN);
dWIV = ((((model_.WINT)+((model_.WL)*L_WLN))+((model_.WW)*W_WWN))+((model_.WWL)*LW_WLN_WWN));
Leff = (Lnew-(2.0*dLIV));
if ((Leff<=0))
{
UserInfo(*this)  << "Fatal: Effective channel length = %e for  %M is non-positive" << " " << Leff << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
else
{
if ((Leff<=1.0e-9))
{
UserInfo(*this)  << "Warning: Effective channel length = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << " " << Leff << " " <<  std::endl; 
}
}
Weff = (Wnew-(2.0*dWIV));
if ((Weff<=0))
{
UserInfo(*this)  << "Fatal: Effective channel Width = %e for  %M is non-positive" << " " << Weff << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
else
{
if ((Weff<=1.0e-9))
{
UserInfo(*this)  << "Warning: Effective channel width = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << " " << Leff << " " <<  std::endl; 
}
}
dLCV = ((((model_.DLC)+((model_.LLC)*L_LLN))+((model_.LWC)*W_LWN))+((model_.LWLC)*LW_LLN_LWN));
dWCV = ((((model_.DWC)+((model_.WLC)*L_WLN))+((model_.WWC)*W_WWN))+((model_.WWLC)*LW_WLN_WWN));
Lact = (Lnew-(2.0*dLCV));
if ((Lact<=0))
{
UserInfo(*this)  << "Fatal: Effective channel length for CV = %e for  %M is non-positive" << " " << Lact << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
else
{
if ((Lact<=1.0e-9))
{
UserInfo(*this)  << "Warning: Effective channel length for CV = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << " " << Leff << " " <<  std::endl; 
}
}
Wact = (Wnew-(2.0*dWCV));
if ((Wact<=0))
{
UserInfo(*this)  << "Fatal: Effective channel width for CV = %e for  %M is non-positive" << " " << Wact << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
else
{
if ((Wact<=1.0e-9))
{
UserInfo(*this)  << "Warning: Effective channel width for CV = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << " " << Leff << " " <<  std::endl; 
}
}
{
double value_pow_0 = pow(Lnew,(model_.WLN));
double value_pow_1 = pow(Wnew,(model_.WWN));
double value_pow_2 = pow(Lnew,(model_.WLN));
double value_pow_3 = pow(Wnew,(model_.WWN));
dWJ = ((((model_.DWJ)+((model_.WLC)/value_pow_0))+((model_.WWC)/value_pow_1))+(((model_.WWLC)/value_pow_2)/value_pow_3));
}
Weffcj = (Wnew-(2.0*dWJ));
if ((Weffcj<=0))
{
UserInfo(*this)  << "Fatal: Effective channel width for S/D junctions = %e for  %M is non-positive" << " " << Weffcj << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
Inv_L = (1.0e-6/Leff);
Inv_W = (1.0e-6/Weff);
Inv_Lact = (1.0e-6/Lact);
Inv_Wact = (1.0e-6/Wact);
Inv_Llong = (1.0e-6/(model_.LLONG));
Inv_Wwide = (1.0e-6/(model_.WWIDE));
Inv_WL = (Inv_L*Inv_W);
L_LLN1 = L_LLN;
L_WLN1 = L_WLN;
if (((model_.DLBIN)!=0))
{
if (((model_.DLBIN)<=(-Lnew)))
{
UserInfo(*this)  << "Fatal: DLBIN for  %M = %e is <= -Ldrawn*LMLT" << " " << (model_.DLBIN) << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
else
{
{
double value_pow_0 = pow((Lnew+(model_.DLBIN)),(-(model_.LLN)));
L_LLN1 = value_pow_0;
}
{
double value_pow_0 = pow((Lnew+(model_.DLBIN)),(-(model_.WLN)));
L_WLN1 = value_pow_0;
}
}
}
W_LWN1 = W_LWN;
W_WWN1 = W_WWN;
if (((model_.DWBIN)!=0))
{
if (((model_.DWBIN)<=(-Wnew)))
{
UserInfo(*this)  << "Fatal: DWBIN for  %M = %e is <= -Wdrawn*WMLT" << " " << (model_.DWBIN) << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
else
{
{
double value_pow_0 = pow((Wnew+(model_.DWBIN)),(-(model_.LWN)));
W_LWN1 = value_pow_0;
}
{
double value_pow_0 = pow((Wnew+(model_.DWBIN)),(-(model_.WWN)));
W_WWN1 = value_pow_0;
}
}
}
LW_LLN_LWN1 = (L_LLN1*W_LWN1);
dLB = ((((model_.LINT)+((model_.LL)*L_LLN1))+((model_.LW)*W_LWN1))+((model_.LWL)*LW_LLN_LWN1));
LW_WLN_WWN1 = (L_WLN1*W_WWN1);
dWB = ((((model_.WINT)+((model_.WL)*L_WLN1))+((model_.WW)*W_WWN1))+((model_.WWL)*LW_WLN_WWN1));
Leff1 = ((Lnew-(2.0*dLB))+(model_.DLBIN));
if ((Leff1<=0))
{
UserInfo(*this)  << "Fatal: Effective channel length for binning = %e for  %M is non-positive" << " " << Leff1 << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
Weff1 = ((Wnew-(2.0*dWB))+(model_.DWBIN));
if ((Weff1<=0))
{
UserInfo(*this)  << "Fatal: Effective channel width for binning = %e for  %M is non-positive" << " " << Weff1 << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if (((model_.BINUNIT)==1))
{
BIN_L = (1.0e-6/Leff1);
BIN_W = (1.0e-6/Weff1);
}
else
{
BIN_L = (1.0/Leff1);
BIN_W = (1.0/Weff1);
}
BIN_WL = (BIN_L*BIN_W);
VFB_i = ((((model_.VFB)+(BIN_L*(model_.LVFB)))+(BIN_W*(model_.WVFB)))+(BIN_WL*(model_.PVFB)));
VFBCV_i = ((((model_.VFBCV)+(BIN_L*(model_.LVFBCV)))+(BIN_W*(model_.WVFBCV)))+(BIN_WL*(model_.PVFBCV)));
NSD_i = ((((model_.NSD)+(BIN_L*(model_.LNSD)))+(BIN_W*(model_.WNSD)))+(BIN_WL*(model_.PNSD)));
NDEP_i = ((((model_.NDEP)+(BIN_L*(model_.LNDEP)))+(BIN_W*(model_.WNDEP)))+(BIN_WL*(model_.PNDEP)));
NDEPCV_i = ((((model_.NDEPCV)+(BIN_L*(model_.LNDEPCV)))+(BIN_W*(model_.WNDEPCV)))+(BIN_WL*(model_.PNDEPCV)));
NGATE_i = ((((model_.NGATE)+(BIN_L*(model_.LNGATE)))+(BIN_W*(model_.WNGATE)))+(BIN_WL*(model_.PNGATE)));
CIT_i = ((((model_.CIT)+(BIN_L*(model_.LCIT)))+(BIN_W*(model_.WCIT)))+(BIN_WL*(model_.PCIT)));
NFACTOR_i = ((((model_.NFACTOR)+(BIN_L*(model_.LNFACTOR)))+(BIN_W*(model_.WNFACTOR)))+(BIN_WL*(model_.PNFACTOR)));
CDSCD_i = ((((model_.CDSCD)+(BIN_L*(model_.LCDSCD)))+(BIN_W*(model_.WCDSCD)))+(BIN_WL*(model_.PCDSCD)));
CDSCB_i = ((((model_.CDSCB)+(BIN_L*(model_.LCDSCB)))+(BIN_W*(model_.WCDSCB)))+(BIN_WL*(model_.PCDSCB)));
DVTP0_i = ((((model_.DVTP0)+(BIN_L*(model_.LDVTP0)))+(BIN_W*(model_.WDVTP0)))+(BIN_WL*(model_.PDVTP0)));
DVTP1_i = ((((model_.DVTP1)+(BIN_L*(model_.LDVTP1)))+(BIN_W*(model_.WDVTP1)))+(BIN_WL*(model_.PDVTP1)));
DVTP2_i = ((((model_.DVTP2)+(BIN_L*(model_.LDVTP2)))+(BIN_W*(model_.WDVTP2)))+(BIN_WL*(model_.PDVTP2)));
DVTP3_i = ((((model_.DVTP3)+(BIN_L*(model_.LDVTP3)))+(BIN_W*(model_.WDVTP3)))+(BIN_WL*(model_.PDVTP3)));
DVTP4_i = ((((model_.DVTP4)+(BIN_L*(model_.LDVTP4)))+(BIN_W*(model_.WDVTP4)))+(BIN_WL*(model_.PDVTP4)));
DVTP5_i = ((((model_.DVTP5)+(BIN_L*(model_.LDVTP5)))+(BIN_W*(model_.WDVTP5)))+(BIN_WL*(model_.PDVTP5)));

d_K2_i_dTemp_t_GND =  0.0;
K2_i = ((((model_.K2)+(BIN_L*(model_.LK2)))+(BIN_W*(model_.WK2)))+(BIN_WL*(model_.PK2)));
K1_i = ((((model_.K1)+(BIN_L*(model_.LK1)))+(BIN_W*(model_.WK1)))+(BIN_WL*(model_.PK1)));
XJ_i = ((((model_.XJ)+(BIN_L*(model_.LXJ)))+(BIN_W*(model_.WXJ)))+(BIN_WL*(model_.PXJ)));
PHIN_i = ((((model_.PHIN)+(BIN_L*(model_.LPHIN)))+(BIN_W*(model_.WPHIN)))+(BIN_WL*(model_.PPHIN)));
ETA0_i = ((((model_.ETA0)+(BIN_L*(model_.LETA0)))+(BIN_W*(model_.WETA0)))+(BIN_WL*(model_.PETA0)));
ETAB_i = ((((model_.ETAB)+(BIN_L*(model_.LETAB)))+(BIN_W*(model_.WETAB)))+(BIN_WL*(model_.PETAB)));
DELTA_i = ((((model_.DELTA)+(BIN_L*(model_.LDELTA)))+(BIN_W*(model_.WDELTA)))+(BIN_WL*(model_.PDELTA)));
U0_i = ((((model_.U0)+(BIN_L*(model_.LU0)))+(BIN_W*(model_.WU0)))+(BIN_WL*(model_.PU0)));
UA_i = ((((model_.UA)+(BIN_L*(model_.LUA)))+(BIN_W*(model_.WUA)))+(BIN_WL*(model_.PUA)));
UD_i = ((((model_.UD)+(BIN_L*(model_.LUD)))+(BIN_W*(model_.WUD)))+(BIN_WL*(model_.PUD)));
EU_i = ((((model_.EU)+(BIN_L*(model_.LEU)))+(BIN_W*(model_.WEU)))+(BIN_WL*(model_.PEU)));
UCS_i = ((((model_.UCS)+(BIN_L*(model_.LUCS)))+(BIN_W*(model_.WUCS)))+(BIN_WL*(model_.PUCS)));
UC_i = ((((model_.UC)+(BIN_L*(model_.LUC)))+(BIN_W*(model_.WUC)))+(BIN_WL*(model_.PUC)));
PCLM_i = ((((model_.PCLM)+(BIN_L*(model_.LPCLM)))+(BIN_W*(model_.WPCLM)))+(BIN_WL*(model_.PPCLM)));
PCLMCV_i = ((((model_.PCLMCV)+(BIN_L*(model_.LPCLMCV)))+(BIN_W*(model_.WPCLMCV)))+(BIN_WL*(model_.PPCLMCV)));
RSW_i = ((((model_.RSW)+(BIN_L*(model_.LRSW)))+(BIN_W*(model_.WRSW)))+(BIN_WL*(model_.PRSW)));
RDW_i = ((((model_.RDW)+(BIN_L*(model_.LRDW)))+(BIN_W*(model_.WRDW)))+(BIN_WL*(model_.PRDW)));
PRWG_i = ((((model_.PRWG)+(BIN_L*(model_.LPRWG)))+(BIN_W*(model_.WPRWG)))+(BIN_WL*(model_.PPRWG)));
PRWB_i = ((((model_.PRWB)+(BIN_L*(model_.LPRWB)))+(BIN_W*(model_.WPRWB)))+(BIN_WL*(model_.PPRWB)));
WR_i = ((((model_.WR)+(BIN_L*(model_.LWR)))+(BIN_W*(model_.WWR)))+(BIN_WL*(model_.PWR)));
RSWMIN_i = ((((model_.RSWMIN)+(BIN_L*(model_.LRSWMIN)))+(BIN_W*(model_.WRSWMIN)))+(BIN_WL*(model_.PRSWMIN)));
RDWMIN_i = ((((model_.RDWMIN)+(BIN_L*(model_.LRDWMIN)))+(BIN_W*(model_.WRDWMIN)))+(BIN_WL*(model_.PRDWMIN)));
RDSW_i = ((((model_.RDSW)+(BIN_L*(model_.LRDSW)))+(BIN_W*(model_.WRDSW)))+(BIN_WL*(model_.PRDSW)));
RDSWMIN_i = ((((model_.RDSWMIN)+(BIN_L*(model_.LRDSWMIN)))+(BIN_W*(model_.WRDSWMIN)))+(BIN_WL*(model_.PRDSWMIN)));
PTWG_i = ((((model_.PTWG)+(BIN_L*(model_.LPTWG)))+(BIN_W*(model_.WPTWG)))+(BIN_WL*(model_.PPTWG)));
PDIBLC_i = ((((model_.PDIBLC)+(BIN_L*(model_.LPDIBLC)))+(BIN_W*(model_.WPDIBLC)))+(BIN_WL*(model_.PPDIBLC)));
PDIBLCB_i = ((((model_.PDIBLCB)+(BIN_L*(model_.LPDIBLCB)))+(BIN_W*(model_.WPDIBLCB)))+(BIN_WL*(model_.PPDIBLCB)));
PSCBE1_i = ((((model_.PSCBE1)+(BIN_L*(model_.LPSCBE1)))+(BIN_W*(model_.WPSCBE1)))+(BIN_WL*(model_.PPSCBE1)));
PSCBE2_i = ((((model_.PSCBE2)+(BIN_L*(model_.LPSCBE2)))+(BIN_W*(model_.WPSCBE2)))+(BIN_WL*(model_.PPSCBE2)));
PDITS_i = ((((model_.PDITS)+(BIN_L*(model_.LPDITS)))+(BIN_W*(model_.WPDITS)))+(BIN_WL*(model_.PPDITS)));
PDITSD_i = ((((model_.PDITSD)+(BIN_L*(model_.LPDITSD)))+(BIN_W*(model_.WPDITSD)))+(BIN_WL*(model_.PPDITSD)));
FPROUT_i = ((((model_.FPROUT)+(BIN_L*(model_.LFPROUT)))+(BIN_W*(model_.WFPROUT)))+(BIN_WL*(model_.PFPROUT)));
PVAG_i = ((((model_.PVAG)+(BIN_L*(model_.LPVAG)))+(BIN_W*(model_.WPVAG)))+(BIN_WL*(model_.PPVAG)));
VSAT_i = ((((model_.VSAT)+(BIN_L*(model_.LVSAT)))+(BIN_W*(model_.WVSAT)))+(BIN_WL*(model_.PVSAT)));
PSAT_i = ((((model_.PSAT)+(BIN_L*(model_.LPSAT)))+(BIN_W*(model_.WPSAT)))+(BIN_WL*(model_.PPSAT)));
VSATCV_i = ((((model_.VSATCV)+(BIN_L*(model_.LVSATCV)))+(BIN_W*(model_.WVSATCV)))+(BIN_WL*(model_.PVSATCV)));
CF_i = ((((model_.CF)+(BIN_L*(model_.LCF)))+(BIN_W*(model_.WCF)))+(BIN_WL*(model_.PCF)));
CGSL_i = ((((model_.CGSL)+(BIN_L*(model_.LCGSL)))+(BIN_W*(model_.WCGSL)))+(BIN_WL*(model_.PCGSL)));
CGDL_i = ((((model_.CGDL)+(BIN_L*(model_.LCGDL)))+(BIN_W*(model_.WCGDL)))+(BIN_WL*(model_.PCGDL)));
CKAPPAS_i = ((((model_.CKAPPAS)+(BIN_L*(model_.LCKAPPAS)))+(BIN_W*(model_.WCKAPPAS)))+(BIN_WL*(model_.PCKAPPAS)));
CKAPPAD_i = ((((model_.CKAPPAD)+(BIN_L*(model_.LCKAPPAD)))+(BIN_W*(model_.WCKAPPAD)))+(BIN_WL*(model_.PCKAPPAD)));
ALPHA0_i = ((((model_.ALPHA0)+(BIN_L*(model_.LALPHA0)))+(BIN_W*(model_.WALPHA0)))+(BIN_WL*(model_.PALPHA0)));
BETA0_i = ((((model_.BETA0)+(BIN_L*(model_.LBETA0)))+(BIN_W*(model_.WBETA0)))+(BIN_WL*(model_.PBETA0)));
KVTH0WE_i = ((((model_.KVTH0WE)+(BIN_L*(model_.LKVTH0WE)))+(BIN_W*(model_.WKVTH0WE)))+(BIN_WL*(model_.PKVTH0WE)));
K2WE_i = ((((model_.K2WE)+(BIN_L*(model_.LK2WE)))+(BIN_W*(model_.WK2WE)))+(BIN_WL*(model_.PK2WE)));
KU0WE_i = ((((model_.KU0WE)+(BIN_L*(model_.LKU0WE)))+(BIN_W*(model_.WKU0WE)))+(BIN_WL*(model_.PKU0WE)));
AGIDL_i = ((((model_.AGIDL)+(BIN_L*(model_.LAGIDL)))+(BIN_W*(model_.WAGIDL)))+(BIN_WL*(model_.PAGIDL)));
BGIDL_i = ((((model_.BGIDL)+(BIN_L*(model_.LBGIDL)))+(BIN_W*(model_.WBGIDL)))+(BIN_WL*(model_.PBGIDL)));
CGIDL_i = ((((model_.CGIDL)+(BIN_L*(model_.LCGIDL)))+(BIN_W*(model_.WCGIDL)))+(BIN_WL*(model_.PCGIDL)));
EGIDL_i = ((((model_.EGIDL)+(BIN_L*(model_.LEGIDL)))+(BIN_W*(model_.WEGIDL)))+(BIN_WL*(model_.PEGIDL)));
AGISL_i = ((((model_.AGISL)+(BIN_L*(model_.LAGISL)))+(BIN_W*(model_.WAGISL)))+(BIN_WL*(model_.PAGISL)));
BGISL_i = ((((model_.BGISL)+(BIN_L*(model_.LBGISL)))+(BIN_W*(model_.WBGISL)))+(BIN_WL*(model_.PBGISL)));
CGISL_i = ((((model_.CGISL)+(BIN_L*(model_.LCGISL)))+(BIN_W*(model_.WCGISL)))+(BIN_WL*(model_.PCGISL)));
EGISL_i = ((((model_.EGISL)+(BIN_L*(model_.LEGISL)))+(BIN_W*(model_.WEGISL)))+(BIN_WL*(model_.PEGISL)));
UTE_i = ((((model_.UTE)+(BIN_L*(model_.LUTE)))+(BIN_W*(model_.WUTE)))+(BIN_WL*(model_.PUTE)));
UA1_i = ((((model_.UA1)+(BIN_L*(model_.LUA1)))+(BIN_W*(model_.WUA1)))+(BIN_WL*(model_.PUA1)));
UC1_i = ((((model_.UC1)+(BIN_L*(model_.LUC1)))+(BIN_W*(model_.WUC1)))+(BIN_WL*(model_.PUC1)));
UD1_i = ((((model_.UD1)+(BIN_L*(model_.LUD1)))+(BIN_W*(model_.WUD1)))+(BIN_WL*(model_.PUD1)));
UCSTE_i = ((((model_.UCSTE)+(BIN_L*(model_.LUCSTE)))+(BIN_W*(model_.WUCSTE)))+(BIN_WL*(model_.PUCSTE)));
PRT_i = ((((model_.PRT)+(BIN_L*(model_.LPRT)))+(BIN_W*(model_.WPRT)))+(BIN_WL*(model_.PPRT)));
AT_i = ((((model_.AT)+(BIN_L*(model_.LAT)))+(BIN_W*(model_.WAT)))+(BIN_WL*(model_.PAT)));
PTWGT_i = ((((model_.PTWGT)+(BIN_L*(model_.LPTWGT)))+(BIN_W*(model_.WPTWGT)))+(BIN_WL*(model_.PPTWGT)));
IIT_i = ((((model_.IIT)+(BIN_L*(model_.LIIT)))+(BIN_W*(model_.WIIT)))+(BIN_WL*(model_.PIIT)));
TGIDL_i = ((((model_.TGIDL)+(BIN_L*(model_.LTGIDL)))+(BIN_W*(model_.WTGIDL)))+(BIN_WL*(model_.PTGIDL)));
IGT_i = ((((model_.IGT)+(BIN_L*(model_.LIGT)))+(BIN_W*(model_.WIGT)))+(BIN_WL*(model_.PIGT)));
AIGBINV_i = ((((model_.AIGBINV)+(BIN_L*(model_.LAIGBINV)))+(BIN_W*(model_.WAIGBINV)))+(BIN_WL*(model_.PAIGBINV)));
BIGBINV_i = ((((model_.BIGBINV)+(BIN_L*(model_.LBIGBINV)))+(BIN_W*(model_.WBIGBINV)))+(BIN_WL*(model_.PBIGBINV)));
CIGBINV_i = ((((model_.CIGBINV)+(BIN_L*(model_.LCIGBINV)))+(BIN_W*(model_.WCIGBINV)))+(BIN_WL*(model_.PCIGBINV)));
EIGBINV_i = ((((model_.EIGBINV)+(BIN_L*(model_.LEIGBINV)))+(BIN_W*(model_.WEIGBINV)))+(BIN_WL*(model_.PEIGBINV)));
NIGBINV_i = ((((model_.NIGBINV)+(BIN_L*(model_.LNIGBINV)))+(BIN_W*(model_.WNIGBINV)))+(BIN_WL*(model_.PNIGBINV)));
AIGBACC_i = ((((model_.AIGBACC)+(BIN_L*(model_.LAIGBACC)))+(BIN_W*(model_.WAIGBACC)))+(BIN_WL*(model_.PAIGBACC)));
BIGBACC_i = ((((model_.BIGBACC)+(BIN_L*(model_.LBIGBACC)))+(BIN_W*(model_.WBIGBACC)))+(BIN_WL*(model_.PBIGBACC)));
CIGBACC_i = ((((model_.CIGBACC)+(BIN_L*(model_.LCIGBACC)))+(BIN_W*(model_.WCIGBACC)))+(BIN_WL*(model_.PCIGBACC)));
NIGBACC_i = ((((model_.NIGBACC)+(BIN_L*(model_.LNIGBACC)))+(BIN_W*(model_.WNIGBACC)))+(BIN_WL*(model_.PNIGBACC)));
AIGC_i = ((((model_.AIGC)+(BIN_L*(model_.LAIGC)))+(BIN_W*(model_.WAIGC)))+(BIN_WL*(model_.PAIGC)));
BIGC_i = ((((model_.BIGC)+(BIN_L*(model_.LBIGC)))+(BIN_W*(model_.WBIGC)))+(BIN_WL*(model_.PBIGC)));
CIGC_i = ((((model_.CIGC)+(BIN_L*(model_.LCIGC)))+(BIN_W*(model_.WCIGC)))+(BIN_WL*(model_.PCIGC)));
AIGS_i = ((((model_.AIGS)+(BIN_L*(model_.LAIGS)))+(BIN_W*(model_.WAIGS)))+(BIN_WL*(model_.PAIGS)));
BIGS_i = ((((model_.BIGS)+(BIN_L*(model_.LBIGS)))+(BIN_W*(model_.WBIGS)))+(BIN_WL*(model_.PBIGS)));
CIGS_i = ((((model_.CIGS)+(BIN_L*(model_.LCIGS)))+(BIN_W*(model_.WCIGS)))+(BIN_WL*(model_.PCIGS)));
AIGD_i = ((((model_.AIGD)+(BIN_L*(model_.LAIGD)))+(BIN_W*(model_.WAIGD)))+(BIN_WL*(model_.PAIGD)));
BIGD_i = ((((model_.BIGD)+(BIN_L*(model_.LBIGD)))+(BIN_W*(model_.WBIGD)))+(BIN_WL*(model_.PBIGD)));
CIGD_i = ((((model_.CIGD)+(BIN_L*(model_.LCIGD)))+(BIN_W*(model_.WCIGD)))+(BIN_WL*(model_.PCIGD)));
POXEDGE_i = ((((model_.POXEDGE)+(BIN_L*(model_.LPOXEDGE)))+(BIN_W*(model_.WPOXEDGE)))+(BIN_WL*(model_.PPOXEDGE)));
DLCIG_i = ((((model_.DLCIG)+(BIN_L*(model_.LDLCIG)))+(BIN_W*(model_.WDLCIG)))+(BIN_WL*(model_.PDLCIG)));
DLCIGD_i = ((((model_.DLCIGD)+(BIN_L*(model_.LDLCIGD)))+(BIN_W*(model_.WDLCIGD)))+(BIN_WL*(model_.PDLCIGD)));
NTOX_i = ((((model_.NTOX)+(BIN_L*(model_.LNTOX)))+(BIN_W*(model_.WNTOX)))+(BIN_WL*(model_.PNTOX)));
KT1_i = ((((model_.KT1)+(BIN_L*(model_.LKT1)))+(BIN_W*(model_.WKT1)))+(BIN_WL*(model_.PKT1)));
KT2_i = ((((model_.KT2)+(BIN_L*(model_.LKT2)))+(BIN_W*(model_.WKT2)))+(BIN_WL*(model_.PKT2)));
PSATB_i = ((((model_.PSATB)+(BIN_L*(model_.LPSATB)))+(BIN_W*(model_.WPSATB)))+(BIN_WL*(model_.PPSATB)));
A1_i = ((((model_.A1)+(BIN_L*(model_.LA1)))+(BIN_W*(model_.WA1)))+(BIN_WL*(model_.PA1)));
A11_i = ((((model_.A11)+(BIN_L*(model_.LA11)))+(BIN_W*(model_.WA11)))+(BIN_WL*(model_.PA11)));
A2_i = ((((model_.A2)+(BIN_L*(model_.LA2)))+(BIN_W*(model_.WA2)))+(BIN_WL*(model_.PA2)));
A21_i = ((((model_.A21)+(BIN_L*(model_.LA21)))+(BIN_W*(model_.WA21)))+(BIN_WL*(model_.PA21)));
if (((model_.ASYMMOD)!=0))
{
CDSCDR_i = ((((model_.CDSCDR)+(BIN_L*(model_.LCDSCDR)))+(BIN_W*(model_.WCDSCDR)))+(BIN_WL*(model_.PCDSCDR)));
ETA0R_i = ((((model_.ETA0R)+(BIN_L*(model_.LETA0R)))+(BIN_W*(model_.WETA0R)))+(BIN_WL*(model_.PETA0R)));
U0R_i = ((((model_.U0R)+(BIN_L*(model_.LU0R)))+(BIN_W*(model_.WU0R)))+(BIN_WL*(model_.PU0R)));
UAR_i = ((((model_.UAR)+(BIN_L*(model_.LUAR)))+(BIN_W*(model_.WUAR)))+(BIN_WL*(model_.PUAR)));
UDR_i = ((((model_.UDR)+(BIN_L*(model_.LUDR)))+(BIN_W*(model_.WUDR)))+(BIN_WL*(model_.PUDR)));
UCSR_i = ((((model_.UCSR)+(BIN_L*(model_.LUCSR)))+(BIN_W*(model_.WUCSR)))+(BIN_WL*(model_.PUCSR)));
UCR_i = ((((model_.UCR)+(BIN_L*(model_.LUCR)))+(BIN_W*(model_.WUCR)))+(BIN_WL*(model_.PUCR)));
PCLMR_i = ((((model_.PCLMR)+(BIN_L*(model_.LPCLMR)))+(BIN_W*(model_.WPCLMR)))+(BIN_WL*(model_.PPCLMR)));
PDIBLCR_i = ((((model_.PDIBLCR)+(BIN_L*(model_.LPDIBLCR)))+(BIN_W*(model_.WPDIBLCR)))+(BIN_WL*(model_.PPDIBLCR)));
VSATR_i = ((((model_.VSATR)+(BIN_L*(model_.LVSATR)))+(BIN_W*(model_.WVSATR)))+(BIN_WL*(model_.PVSATR)));
PSATR_i = ((((model_.PSATR)+(BIN_L*(model_.LPSATR)))+(BIN_W*(model_.WPSATR)))+(BIN_WL*(model_.PPSATR)));
PTWGR_i = ((((model_.PTWGR)+(BIN_L*(model_.LPTWGR)))+(BIN_W*(model_.WPTWGR)))+(BIN_WL*(model_.PPTWGR)));
}
{
double value_pow_0 = pow(Inv_L,(model_.NDEPLEXP1));
double value_pow_1 = pow(Inv_Llong,(model_.NDEPLEXP1));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_L,(model_.NDEPLEXP2));
double value_pow_4 = pow(Inv_Llong,(model_.NDEPLEXP2));
double value_max_5 = std::max((value_pow_3-value_pow_4),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (((model_.NDEPL1)*value_max_2)+((model_.NDEPL2)*value_max_5));
}
{
double value_pow_0 = pow(Inv_W,(model_.NDEPWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.NDEPWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow((Inv_W*Inv_L),(model_.NDEPWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.NDEPW)*value_max_2)+((model_.NDEPWL)*value_pow_3));
}
NDEP_i = (NDEP_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_L,(model_.NFACTORLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.NFACTORLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.NFACTORL)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.NFACTORWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.NFACTORWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.NFACTORWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.NFACTORW)*value_max_2)+((model_.NFACTORWL)*value_pow_3));
}
NFACTOR_i = (NFACTOR_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_L,(model_.CDSCDLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.CDSCDLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (1.0+((model_.CDSCDL)*value_max_2));
}
CDSCD_i = (CDSCD_i*T0);
if (((model_.ASYMMOD)!=0))
{
CDSCDR_i = (CDSCDR_i*T0);
}
{
double value_pow_0 = pow(Inv_L,(model_.CDSCBLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.CDSCBLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
CDSCB_i = (CDSCB_i*(1.0+((model_.CDSCBL)*value_max_2)));
}
U0_i = ((model_.MULU0)*U0_i);
if (((model_.MOBSCALE)!=1))
{
if (((model_.U0LEXP)>0))
{
{
double value_pow_0 = pow(Inv_L,(model_.U0LEXP));
double value_pow_1 = pow(Inv_Llong,(model_.U0LEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
U0_i = (U0_i*(1.0-((model_.U0L)*value_max_2)));
}
if (((model_.ASYMMOD)!=0))
{
{
double value_pow_0 = pow(Inv_L,(model_.U0LEXP));
double value_pow_1 = pow(Inv_Llong,(model_.U0LEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
U0R_i = (U0R_i*(1.0-((model_.U0L)*value_max_2)));
}
}
}
else
{
U0_i = (U0_i*(1.0-(model_.U0L)));
if (((model_.ASYMMOD)!=0))
{
U0R_i = (U0R_i*(1.0-(model_.U0L)));
}
}
}
else
{
{
double value_exp_0 = exp(((-Leff)/(model_.LP1)));
double value_exp_1 = exp(((-Leff)/(model_.LP2)));
U0_i = (U0_i*((1.0-((model_.UP1)*value_exp_0))-((model_.UP2)*value_exp_1)));
}
if (((model_.ASYMMOD)!=0))
{
{
double value_exp_0 = exp(((-Leff)/(model_.LP1)));
double value_exp_1 = exp(((-Leff)/(model_.LP2)));
U0R_i = (U0R_i*((1.0-((model_.UP1)*value_exp_0))-((model_.UP2)*value_exp_1)));
}
}
}
{
double value_pow_0 = pow(Inv_L,(model_.UALEXP));
double value_pow_1 = pow(Inv_Llong,(model_.UALEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.UAL)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.UAWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.UAWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.UAWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.UAW)*value_max_2)+((model_.UAWL)*value_pow_3));
}
UA_i = (UA_i*((1.0+T0)+T1));
if (((model_.ASYMMOD)!=0))
{
UAR_i = (UAR_i*((1.0+T0)+T1));
}
{
double value_pow_0 = pow(Inv_L,(model_.EULEXP));
double value_pow_1 = pow(Inv_Llong,(model_.EULEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.EUL)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.EUWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.EUWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.EUWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.EUW)*value_max_2)+((model_.EUWL)*value_pow_3));
}
EU_i = (EU_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_L,(model_.UDLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.UDLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (1.0+((model_.UDL)*value_max_2));
}
UD_i = (UD_i*T0);
if (((model_.ASYMMOD)!=0))
{
UDR_i = (UDR_i*T0);
}
{
double value_pow_0 = pow(Inv_L,(model_.UCLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.UCLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.UCL)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.UCWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.UCWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.UCWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.UCW)*value_max_2)+((model_.UCWL)*value_pow_3));
}
UC_i = (UC_i*((1.0+T0)+T1));
if (((model_.ASYMMOD)!=0))
{
UCR_i = (UCR_i*((1.0+T0)+T1));
}
{
double value_pow_0 = pow(Inv_L,(model_.DSUB));
double value_pow_1 = pow(Inv_Llong,(model_.DSUB));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = value_max_2;
}
ETA0_i = (ETA0_i*T0);
if (((model_.ASYMMOD)!=0))
{
ETA0R_i = (ETA0R_i*T0);
}
{
double value_pow_0 = pow(Inv_L,(model_.ETABEXP));
double value_pow_1 = pow(Inv_Llong,(model_.ETABEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
ETAB_i = (ETAB_i*value_max_2);
}
{
double value_pow_0 = pow(Inv_L,(model_.PDIBLCLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.PDIBLCLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (1.0+((model_.PDIBLCL)*value_max_2));
}
PDIBLC_i = (PDIBLC_i*T0);
if (((model_.ASYMMOD)!=0))
{
PDIBLCR_i = (PDIBLCR_i*T0);
}
{
double value_pow_0 = pow(Inv_L,(model_.DELTALEXP));
double value_pow_1 = pow(Inv_Llong,(model_.DELTALEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (DELTA_i*(1.0+((model_.DELTAL)*value_max_2)));
}
{
double value_min_0 = std::min(T0,static_cast<double>(0.5));
DELTA_i = value_min_0;
}
{
double value_pow_0 = pow(Inv_L,(model_.FPROUTLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.FPROUTLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
FPROUT_i = (FPROUT_i*(1.0+((model_.FPROUTL)*value_max_2)));
}
{
double value_pow_0 = pow(Inv_L,(model_.PCLMLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.PCLMLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (1.0+((model_.PCLML)*value_max_2));
}
PCLM_i = (PCLM_i*T0);
{
double value_max_0 = std::max(PCLM_i,static_cast<double>(0));
PCLM_i = value_max_0;
}
if (((model_.ASYMMOD)!=0))
{
PCLMR_i = (PCLMR_i*T0);
{
double value_max_0 = std::max(PCLMR_i,static_cast<double>(0));
PCLMR_i = value_max_0;
}
}
{
double value_pow_0 = pow(Inv_L,(model_.VSATLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.VSATLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.VSATL)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.VSATWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.VSATWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.VSATWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.VSATW)*value_max_2)+((model_.VSATWL)*value_pow_3));
}
VSAT_i = (VSAT_i*((1.0+T0)+T1));
if (((model_.ASYMMOD)!=0))
{
VSATR_i = (VSATR_i*((1.0+T0)+T1));
}
{
double value_pow_0 = pow(Inv_L,(model_.PSATLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.PSATLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_max_3 = std::max((PSAT_i*(1.0+((model_.PSATL)*value_max_2))),static_cast<double>(0.25));
PSAT_i = value_max_3;
}
if (((model_.ASYMMOD)!=0))
{
{
double value_pow_0 = pow(Inv_L,(model_.PSATLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.PSATLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_max_3 = std::max((PSATR_i*(1.0+((model_.PSATL)*value_max_2))),static_cast<double>(0.25));
PSATR_i = value_max_3;
}
}
{
double value_pow_0 = pow(Inv_L,(model_.PTWGLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.PTWGLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (1.0+((model_.PTWGL)*value_max_2));
}
PTWG_i = (PTWG_i*T0);
if (((model_.ASYMMOD)!=0))
{
PTWGR_i = (PTWGR_i*T0);
}
{
double value_pow_0 = pow(Inv_L,(model_.ALPHA0LEXP));
double value_pow_1 = pow(Inv_Llong,(model_.ALPHA0LEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
ALPHA0_i = (ALPHA0_i*(1.0+((model_.ALPHA0L)*value_max_2)));
}
AGIDL_i = (AGIDL_i*((1.0+((model_.AGIDLL)*Inv_L))+((model_.AGIDLW)*Inv_W)));
AGISL_i = (AGISL_i*((1.0+((model_.AGISLL)*Inv_L))+((model_.AGISLW)*Inv_W)));
AIGC_i = (AIGC_i*((1.0+((model_.AIGCL)*Inv_L))+((model_.AIGCW)*Inv_W)));
AIGS_i = (AIGS_i*((1.0+((model_.AIGSL)*Inv_L))+((model_.AIGSW)*Inv_W)));
AIGD_i = (AIGD_i*((1.0+((model_.AIGDL)*Inv_L))+((model_.AIGDW)*Inv_W)));
PIGCD_i = ((model_.PIGCD)*(1.0+((model_.PIGCDL)*Inv_L)));
{
double value_pow_0 = pow(Inv_Lact,(model_.NDEPCVLEXP1));
double value_pow_1 = pow(Inv_Llong,(model_.NDEPCVLEXP1));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_Lact,(model_.NDEPCVLEXP2));
double value_pow_4 = pow(Inv_Llong,(model_.NDEPCVLEXP2));
double value_max_5 = std::max((value_pow_3-value_pow_4),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (((model_.NDEPCVL1)*value_max_2)+((model_.NDEPCVL2)*value_max_5));
}
{
double value_pow_0 = pow(Inv_Wact,(model_.NDEPCVWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.NDEPCVWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow((Inv_Wact*Inv_Lact),(model_.NDEPCVWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.NDEPCVW)*value_max_2)+((model_.NDEPCVWL)*value_pow_3));
}
NDEPCV_i = (NDEPCV_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_Lact,(model_.VFBCVLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.VFBCVLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.VFBCVL)*value_max_2);
}
{
double value_pow_0 = pow(Inv_Wact,(model_.VFBCVWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.VFBCVWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.VFBCVWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.VFBCVW)*value_max_2)+((model_.VFBCVWL)*value_pow_3));
}
VFBCV_i = (VFBCV_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_Lact,(model_.VSATCVLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.VSATCVLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.VSATCVL)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.VSATCVWEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.VSATCVWEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.VSATCVWLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.VSATCVW)*value_max_2)+((model_.VSATCVWL)*value_pow_3));
}
VSATCV_i = (VSATCV_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_Lact,(model_.PCLMCVLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.PCLMCVLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
PCLMCV_i = (PCLMCV_i*(1.0+((model_.PCLMCVL)*value_max_2)));
}
{
double value_max_0 = std::max(PCLMCV_i,static_cast<double>(0));
PCLMCV_i = value_max_0;
}
{
double value_pow_0 = pow(Inv_L,(model_.K1LEXP));
double value_pow_1 = pow(Inv_Llong,(model_.K1LEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.K1L)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.K1WEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.K1WEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.K1WLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.K1W)*value_max_2)+((model_.K1WL)*value_pow_3));
}
K1_i = (K1_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_L,(model_.K2LEXP));
double value_pow_1 = pow(Inv_Llong,(model_.K2LEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.K2L)*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,(model_.K2WEXP));
double value_pow_1 = pow(Inv_Wwide,(model_.K2WEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,(model_.K2WLEXP));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (((model_.K2W)*value_max_2)+((model_.K2WL)*value_pow_3));
}

d_K2_i_dTemp_t_GND =  0.0;
K2_i = (K2_i*((1.0+T0)+T1));
{
double value_pow_0 = pow(Inv_L,(model_.PRWBLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.PRWBLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
PRWB_i = (PRWB_i*(1.0+((model_.PRWBL)*value_max_2)));
}
UTE_i = (UTE_i*(1.0+(Inv_L*(model_.UTEL))));
UA1_i = (UA1_i*(1.0+(Inv_L*(model_.UA1L))));
UD1_i = (UD1_i*(1.0+(Inv_L*(model_.UD1L))));
AT_i = (AT_i*(1.0+(Inv_L*(model_.ATL))));
PTWGT_i = (PTWGT_i*(1.0+(Inv_L*(model_.PTWGTL))));
if ((portsConnected_[admsNodeID_t]==0))
{
}
if (((model_.RDSMOD)==1))
{
{
double value_pow_0 = pow(Inv_L,(model_.RSWLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.RSWLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
RSW_i = (RSW_i*(1.0+((model_.RSWL)*value_max_2)));
}
{
double value_pow_0 = pow(Inv_L,(model_.RDWLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.RDWLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
RDW_i = (RDW_i*(1.0+((model_.RDWL)*value_max_2)));
}
}
else
{
{
double value_pow_0 = pow(Inv_L,(model_.RDSWLEXP));
double value_pow_1 = pow(Inv_Llong,(model_.RDSWLEXP));
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
RDSW_i = (RDSW_i*(1.0+((model_.RDSWL)*value_max_2)));
}
}
if ((UCS_i<1.0))
{
UCS_i = 1.0;
}
else
{
if ((UCS_i>2.0))
{
UCS_i = 2.0;
}
}
if (((model_.ASYMMOD)!=0))
{
if ((UCSR_i<1.0))
{
UCSR_i = 1.0;
}
else
{
if ((UCSR_i>2.0))
{
UCSR_i = 2.0;
}
}
if ((UCR_i<0))
{
UserInfo(*this)  << "Fatal: UCR_i = %e is negative." << " " << UCR_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
}
if ((CGIDL_i<0))
{
UserInfo(*this)  << "Fatal: CGIDL_i = %e is negative." << " " << CGIDL_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((CGISL_i<0))
{
UserInfo(*this)  << "Fatal: CGISL_i = %e is negative." << " " << CGISL_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((CKAPPAD_i<=0))
{
UserInfo(*this)  << "Fatal: CKAPPAD_i = %e is non-positive." << " " << CKAPPAD_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((CKAPPAS_i<=0))
{
UserInfo(*this)  << "Fatal: CKAPPAS_i = %e is non-positive." << " " << CKAPPAS_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((PDITS_i<0))
{
UserInfo(*this)  << "Fatal: PDITS_i = %e is negative." << " " << PDITS_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((CIT_i<0))
{
UserInfo(*this)  << "Fatal: CIT_i = %e is negative." << " " << CIT_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((NFACTOR_i<0))
{
UserInfo(*this)  << "Fatal: NFACTOR_i = %e is negative." << " " << NFACTOR_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((K1_i<0))
{
UserInfo(*this)  << "Fatal: K1_i = %e is positive." << " " << K1_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((NSD_i<=0))
{
UserInfo(*this)  << "Fatal: NSD_i = %e is non-positive." << " " << NSD_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((NDEP_i<=0))
{
UserInfo(*this)  << "Fatal: NDEP_i = %e is non-positive." << " " << NDEP_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((NDEPCV_i<=0))
{
UserInfo(*this)  << "Fatal: NDEPCV_i = %e is non-positive." << " " << NDEPCV_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if (((model_.IGBMOD)!=0))
{
if ((NIGBINV_i<=0))
{
UserInfo(*this)  << "Fatal: NIGBINV_i = %e is non-positive." << " " << NIGBINV_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if ((NIGBACC_i<=0))
{
UserInfo(*this)  << "Fatal: NIGBACC_i = %e is non-positive." << " " << NIGBACC_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
}
if (((model_.IGCMOD)!=0))
{
if ((POXEDGE_i<=0))
{
UserInfo(*this)  << "Fatal: POXEDGE_i = %e is non-positive." << " " << POXEDGE_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
}
if ((CDSCD_i<0))
{
UserInfo(*this)  << "Fatal: CDSCD_i = %e is negative." << " " << CDSCD_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
if (((model_.ASYMMOD)!=0))
{
if ((CDSCDR_i<0))
{
UserInfo(*this)  << "Fatal: CDSCDR_i = %e is negative." << " " << CDSCDR_i << " " <<  std::endl; 
 UserError(*this) << "$finish called." << std::endl; 
}
}
nuEndD = 0;
nuEndS = 0;
nuIntD = 0;
nuIntS = 0;
Rend = 0;
Rint = 0;
DMCGeff = ((model_.DMCG)-(model_.DMCGT));
DMCIeff = (model_.DMCI);
DMDGeff = ((model_.DMDG)-(model_.DMCGT));
if (((model_.RSH)>0))
{
if (((!given("NRD"))&&(RGEOMOD!=0)))
{
if ((GEOMOD<9))
{
if (((NF%2)!=0))
{
nuEndD = 1.0;
nuEndS = 1.0;
{
double value_max_0 = std::max(((NF-1.0)/2.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuIntS = nuIntD;
}
else
{
if ((MINZ==1))
{
nuEndD = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuEndS = 0.0;
nuIntS = NF;
}
else
{
nuEndD = 0.0;
nuIntD = NF;
nuEndS = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntS = (2.0*value_max_0);
}
}
}
if ((0==1))
{
if ((nuIntS==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
}
}
else
{
if ((nuIntD==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
}
}
}
if ( GEOMOD == (0))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (1))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (2))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (3))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (4))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
}
else
if ( GEOMOD == (5))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((nuEndD==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
}
}
}
else
if ( GEOMOD == (6))
{
if ((0==1))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (7))
{
if ((0==1))
{
if ((nuEndS==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (8))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
if ( GEOMOD == (9))
{
if ((0==1))
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
else
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
}
else
if ( GEOMOD == (10))
{
if ((0==1))
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
else
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
}
else
{
Rint = 0.0;
}
if ((Rint<=0.0))
{
Rtot = Rend;
}
else
{
if ((Rend<=0.0))
{
Rtot = Rint;
}
else
{
Rtot = ((Rint*Rend)/(Rint+Rend));
}
}
if ((Rtot==0.0))
{
}
}
}
if (((model_.RSH)>0))
{
if (((!given("NRS"))&&(RGEOMOD!=0)))
{
if ((GEOMOD<9))
{
if (((NF%2)!=0))
{
nuEndD = 1.0;
nuEndS = 1.0;
{
double value_max_0 = std::max(((NF-1.0)/2.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuIntS = nuIntD;
}
else
{
if ((MINZ==1))
{
nuEndD = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuEndS = 0.0;
nuIntS = NF;
}
else
{
nuEndD = 0.0;
nuIntD = NF;
nuEndS = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntS = (2.0*value_max_0);
}
}
}
if ((1==1))
{
if ((nuIntS==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
}
}
else
{
if ((nuIntD==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
}
}
}
if ( GEOMOD == (0))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (1))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (2))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (3))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (4))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
}
else
if ( GEOMOD == (5))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((nuEndD==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
}
}
}
else
if ( GEOMOD == (6))
{
if ((1==1))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (7))
{
if ((1==1))
{
if ((nuEndS==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (8))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
if ( GEOMOD == (9))
{
if ((1==1))
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
else
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
}
else
if ( GEOMOD == (10))
{
if ((1==1))
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
else
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
}
else
{
Rint = 0.0;
}
if ((Rint<=0.0))
{
Rtot = Rend;
}
else
{
if ((Rend<=0.0))
{
Rtot = Rint;
}
else
{
Rtot = ((Rint*Rend)/(Rint+Rend));
}
}
if ((Rtot==0.0))
{
}
}
}
if (given("NRS"))
{
RSourceGeo = ((model_.RSH)*NRS);
}
else
{
if ((RGEOMOD>0))
{
{
if ((GEOMOD<9))
{
if (((NF%2)!=0))
{
nuEndD = 1.0;
nuEndS = 1.0;
{
double value_max_0 = std::max(((NF-1.0)/2.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuIntS = nuIntD;
}
else
{
if ((MINZ==1))
{
nuEndD = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuEndS = 0.0;
nuIntS = NF;
}
else
{
nuEndD = 0.0;
nuIntD = NF;
nuEndS = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntS = (2.0*value_max_0);
}
}
}
if ((1==1))
{
if ((nuIntS==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
}
}
else
{
if ((nuIntD==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
}
}
}
if ( GEOMOD == (0))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (1))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (2))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (3))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (4))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
}
else
if ( GEOMOD == (5))
{
if ((1==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((nuEndD==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
}
}
}
else
if ( GEOMOD == (6))
{
if ((1==1))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (7))
{
if ((1==1))
{
if ((nuEndS==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (8))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
if ( GEOMOD == (9))
{
if ((1==1))
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
else
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
}
else
if ( GEOMOD == (10))
{
if ((1==1))
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
else
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
}
else
{
Rint = 0.0;
}
if ((Rint<=0.0))
{
RSourceGeo = Rend;
}
else
{
if ((Rend<=0.0))
{
RSourceGeo = Rint;
}
else
{
RSourceGeo = ((Rint*Rend)/(Rint+Rend));
}
}
if ((RSourceGeo==0.0))
{
}
}
}
else
{
RSourceGeo = 0.0;
}
}
if (given("NRD"))
{
RDrainGeo = ((model_.RSH)*NRD);
}
else
{
if ((RGEOMOD>0))
{
{
if ((GEOMOD<9))
{
if (((NF%2)!=0))
{
nuEndD = 1.0;
nuEndS = 1.0;
{
double value_max_0 = std::max(((NF-1.0)/2.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuIntS = nuIntD;
}
else
{
if ((MINZ==1))
{
nuEndD = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuEndS = 0.0;
nuIntS = NF;
}
else
{
nuEndD = 0.0;
nuIntD = NF;
nuEndS = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntS = (2.0*value_max_0);
}
}
}
if ((0==1))
{
if ((nuIntS==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntS));
}
}
else
{
if ((nuIntD==0.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*nuIntD));
}
}
}
if ( GEOMOD == (0))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (1))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (2))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (3))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (4))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
}
else
if ( GEOMOD == (5))
{
if ((0==1))
{
if ((1==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndS));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndS==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
else
{
if ((nuEndD==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndD));
}
}
}
else
if ( GEOMOD == (6))
{
if ((0==1))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if (((DMCGeff+DMCIeff)==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (7))
{
if ((0==1))
{
if ((nuEndS==0))
{
Rend = 0;
}
else
{
Rend = (((model_.RSH)*DMDGeff)/(Weff*nuEndS));
}
}
else
{
if ((0==1))
{
if ( RGEOMOD == (1)||RGEOMOD == (2)||RGEOMOD == (5))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (3)||RGEOMOD == (4)||RGEOMOD == (6))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
else
{
if ( RGEOMOD == (1)||RGEOMOD == (3)||RGEOMOD == (7))
{
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*DMCGeff)/(Weff*nuEndD));
}
}
else
if ( RGEOMOD == (2)||RGEOMOD == (4)||RGEOMOD == (8))
{
if ((DMCGeff==0.0))
{
}
if ((nuEndD==0.0))
{
Rend = 0.0;
}
else
{
Rend = (((model_.RSH)*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
{
Rend = 0.0;
}
}
}
}
else
if ( GEOMOD == (8))
{
Rend = (((model_.RSH)*DMDGeff)/Weff);
}
else
if ( GEOMOD == (9))
{
if ((0==1))
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
else
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
}
else
if ( GEOMOD == (10))
{
if ((0==1))
{
Rend = 0.0;
Rint = (((model_.RSH)*DMCGeff)/(Weff*NF));
}
else
{
Rend = (((0.5*(model_.RSH))*DMCGeff)/Weff);
if ((NF==2.0))
{
Rint = 0.0;
}
else
{
Rint = (((model_.RSH)*DMCGeff)/(Weff*(NF-2.0)));
}
}
}
else
{
Rint = 0.0;
}
if ((Rint<=0.0))
{
RDrainGeo = Rend;
}
else
{
if ((Rend<=0.0))
{
RDrainGeo = Rint;
}
else
{
RDrainGeo = ((Rint*Rend)/(Rint+Rend));
}
}
if ((RDrainGeo==0.0))
{
}
}
}
else
{
RDrainGeo = 0.0;
}
}
if ((RSourceGeo<=1.0e-3))
{
RSourceGeo = 1.0e-3;
}
if ((RDrainGeo<=1.0e-3))
{
RDrainGeo = 1.0e-3;
}
if (((model_.RDSMOD)==1))
{
if ((RSWMIN_i<=0))
{
RSWMIN_i = 0;
}
if ((RDWMIN_i<=0))
{
RDWMIN_i = 0;
}
if ((RSW_i<=0))
{
RSW_i = 0;
}
if ((RDW_i<=0))
{
RDW_i = 0;
}
}
else
{
if ((RDSWMIN_i<=0))
{
RDSWMIN_i = 0;
}
if ((RDSW_i<=0))
{
RDSW_i = 0;
}
}
Grbsb = 0.0;
Grbdb = 0.0;
Grbpb = 0.0;
Grbps = 0.0;
Grbpd = 0.0;
if ((RBODYMOD!=0))
{
{
double value_log_0 = log((Leff*1.0e6));
Lnl = value_log_0;
}
{
double value_log_0 = log((Weff*1.0e6));
Lnw = value_log_0;
}
{
double value_log_0 = log(static_cast<double>(NF));
Lnnf = value_log_0;
}
Bodymode = 5;
Rbpb = RBPB;
Rbpd = RBPD;
Rbps = RBPS;
Rbdb = RBDB;
Rbsb = RBSB;
if (((!(model_.given("RBPS0")))||(!(model_.given("RBPD0")))))
{
Bodymode = 1;
}
else
{
if ((((!(model_.given("RBSBX0")))&&(!(model_.given("RBSBY0"))))||((!(model_.given("RBDBX0")))&&(!(model_.given("RBDBY0"))))))
{
Bodymode = 3;
}
}
if ((RBODYMOD==2))
{
if ((Bodymode==5))
{
{
double value_exp_0 = exp(((((model_.RBSDBXL)*Lnl)+((model_.RBSDBXW)*Lnw))+((model_.RBSDBXNF)*Lnnf)));
Rbsbx = ((model_.RBSBX0)*value_exp_0);
}
{
double value_exp_0 = exp(((((model_.RBSDBYL)*Lnl)+((model_.RBSDBYW)*Lnw))+((model_.RBSDBYNF)*Lnnf)));
Rbsby = ((model_.RBSBY0)*value_exp_0);
}
Rbsb = ((Rbsbx*Rbsby)/(Rbsbx+Rbsby));
{
double value_exp_0 = exp(((((model_.RBSDBXL)*Lnl)+((model_.RBSDBXW)*Lnw))+((model_.RBSDBXNF)*Lnnf)));
Rbdbx = ((model_.RBDBX0)*value_exp_0);
}
{
double value_exp_0 = exp(((((model_.RBSDBYL)*Lnl)+((model_.RBSDBYW)*Lnw))+((model_.RBSDBYNF)*Lnnf)));
Rbdby = ((model_.RBDBY0)*value_exp_0);
}
Rbdb = ((Rbdbx*Rbdby)/(Rbdbx+Rbdby));
}
if (((Bodymode==3)||(Bodymode==5)))
{
{
double value_exp_0 = exp(((((model_.RBPSL)*Lnl)+((model_.RBPSW)*Lnw))+((model_.RBPSNF)*Lnnf)));
Rbps = ((model_.RBPS0)*value_exp_0);
}
{
double value_exp_0 = exp(((((model_.RBPDL)*Lnl)+((model_.RBPDW)*Lnw))+((model_.RBPDNF)*Lnnf)));
Rbpd = ((model_.RBPD0)*value_exp_0);
}
}
{
double value_exp_0 = exp(((((model_.RBPBXL)*Lnl)+((model_.RBPBXW)*Lnw))+((model_.RBPBXNF)*Lnnf)));
Rbpbx = ((model_.RBPBX0)*value_exp_0);
}
{
double value_exp_0 = exp(((((model_.RBPBYL)*Lnl)+((model_.RBPBYW)*Lnw))+((model_.RBPBYNF)*Lnnf)));
Rbpby = ((model_.RBPBY0)*value_exp_0);
}
Rbpb = ((Rbpbx*Rbpby)/(Rbpbx+Rbpby));
}
if (((RBODYMOD==1)||((RBODYMOD==2)&&(Bodymode==5))))
{
if ((Rbdb<1.0e-3))
{
Grbdb = 1.0e3;
}
else
{
Grbdb = ((model_.GBMIN)+(1.0/Rbdb));
}
if ((Rbpb<1.0e-3))
{
Grbpb = 1.0e3;
}
else
{
Grbpb = ((model_.GBMIN)+(1.0/Rbpb));
}
if ((Rbps<1.0e-3))
{
Grbps = 1.0e3;
}
else
{
Grbps = ((model_.GBMIN)+(1.0/Rbps));
}
if ((Rbsb<1.0e-3))
{
Grbsb = 1.0e3;
}
else
{
Grbsb = ((model_.GBMIN)+(1.0/Rbsb));
}
if ((Rbpd<1.0e-3))
{
Grbpd = 1.0e3;
}
else
{
Grbpd = ((model_.GBMIN)+(1.0/Rbpd));
}
}
else
{
if (((RBODYMOD==2)&&(Bodymode==3)))
{
Grbdb = (model_.GBMIN);
Grbsb = (model_.GBMIN);
if ((Rbpb<1.0e-3))
{
Grbpb = 1.0e3;
}
else
{
Grbpb = ((model_.GBMIN)+(1.0/Rbpb));
}
if ((Rbps<1.0e-3))
{
Grbps = 1.0e3;
}
else
{
Grbps = ((model_.GBMIN)+(1.0/Rbps));
}
if ((Rbpd<1.0e-3))
{
Grbpd = 1.0e3;
}
else
{
Grbpd = ((model_.GBMIN)+(1.0/Rbpd));
}
}
else
{
if (((RBODYMOD==2)&&(Bodymode==1)))
{
Grbdb = (model_.GBMIN);
Grbsb = (model_.GBMIN);
Grbps = 1.0e3;
Grbpd = 1.0e3;
if ((Rbpb<1.0e-3))
{
Grbpb = 1.0e3;
}
else
{
Grbpb = ((model_.GBMIN)+(1.0/Rbpb));
}
}
}
}
}
Grgeltd = (((model_.RSHG)*(XGW+((Weffcj/3.0)/NGCON)))/((NGCON*NF)*(Lnew-(model_.XGL))));
if ((Grgeltd>0.0))
{
Grgeltd = (1.0/Grgeltd);
}
else
{
Grgeltd = 1.0e3;
if ((RGATEMOD!=0))
{
}
}

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((model_.TOXE)*(model_.TOXE));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = ((model_.TOXE)*POXEDGE_i);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = (T1*T1);
{
double value_log_0 = log(((model_.TOXREF)/(model_.TOXE)));
double value_exp_1 = exp((NTOX_i*value_log_0));
ToxRatio = (value_exp_1/T0);
}
{
double value_log_0 = log(((model_.TOXREF)/T1));
double value_exp_1 = exp((NTOX_i*value_log_0));
ToxRatioEdge = (value_exp_1/T2);
}
Aechvb = (((model_.TYPE)==1)?4.97232e-7:3.42537e-7);
Bechvb = (((model_.TYPE)==1)?7.45669e11:1.16645e12);
AechvbEdge = ((Aechvb*Weff)*ToxRatioEdge);
BechvbEdge = (((-Bechvb)*(model_.TOXE))*POXEDGE_i);
Aechvb = (Aechvb*((Weff*Leff)*ToxRatio));
Bechvb = (Bechvb*(-(model_.TOXE)));
if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
{
gth = ((((model_.WTH0)+Weff)*NF)/(model_.RTH0));
cth = (((model_.CTH0)*((model_.WTH0)+Weff))*NF);
}
else
{
gth = 1.0;
cth = 0.0;
}
}
// End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(10*1.0e-6),
    W(10*1.0e-6),
    NF(1),
    NRS(1.0),
    NRD(1.0),
    VFBSDOFF(0.0),
    MINZ(0),
    XGW(0.0),
    NGCON(1),
    RGATEMOD(0),
    RBODYMOD(0),
    GEOMOD(0),
    RGEOMOD(0),
    RBPB(50.0),
    RBPD(50.0),
    RBPS(50.0),
    RBDB(50.0),
    RBSB(50.0),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    AS(0.0),
    AD(0.0),
    PS(0.0),
    PD(0.0),
    m(1.0),
    T0(0.0),
d_T0_dV_gm_di(0.0),
d_T0_dV_gm_si(0.0),
d_T0_dV_dbulk_di(0.0),
d_T0_dV_sbulk_si(0.0),
d_T0_dV_gi_bi(0.0),
d_T0_dV_di_bi(0.0),
d_T0_dV_si_bi(0.0),
d_T0_dTemp_t_GND(0.0),
    T1(0.0),
d_T1_dV_gm_di(0.0),
d_T1_dV_gm_si(0.0),
d_T1_dV_dbulk_di(0.0),
d_T1_dV_sbulk_si(0.0),
d_T1_dV_gi_bi(0.0),
d_T1_dV_di_bi(0.0),
d_T1_dV_si_bi(0.0),
d_T1_dTemp_t_GND(0.0),
    T2(0.0),
d_T2_dV_gm_di(0.0),
d_T2_dV_gm_si(0.0),
d_T2_dV_dbulk_di(0.0),
d_T2_dV_sbulk_si(0.0),
d_T2_dV_gi_bi(0.0),
d_T2_dV_di_bi(0.0),
d_T2_dV_si_bi(0.0),
d_T2_dTemp_t_GND(0.0),
    epssi(0.0),
    epsox(0.0),
    Weff(0.0),
    Leff(0.0),
    Wact(0.0),
    Lact(0.0),
    Weffcj(0.0),
    Cox(0.0),
    epsratio(0.0),
    Lnew(0.0),
    L_mult(0.0),
    Wnew(0.0),
    DVTP0_i(0.0),
    DVTP1_i(0.0),
    DVTP2_i(0.0),
    DVTP3_i(0.0),
    DVTP4_i(0.0),
    DVTP5_i(0.0),
    A1_i(0.0),
    A11_i(0.0),
    A2_i(0.0),
    A21_i(0.0),
    PSAT_i(0.0),
    PSATR_i(0.0),
    devsign(0),
    BSIM6TOXP(0.0),
    DMCGeff(0.0),
    DMDGeff(0.0),
    DMCIeff(0.0),
    RSourceGeo(0.0),
    RDrainGeo(0.0),
    Grgeltd(0.0),
    Grbsb(0.0),
    Grbdb(0.0),
    Grbpb(0.0),
    Grbps(0.0),
    Grbpd(0.0),
    Aechvb(0.0),
    Bechvb(0.0),
    AechvbEdge(0.0),
    BechvbEdge(0.0),
    ToxRatio(0.0),
    U0R_t(0.0),
d_U0R_t_dTemp_t_GND(0.0),
    UAR_t(0.0),
d_UAR_t_dTemp_t_GND(0.0),
    UCR_t(0.0),
d_UCR_t_dTemp_t_GND(0.0),
    UDR_t(0.0),
d_UDR_t_dTemp_t_GND(0.0),
    UCSR_t(0.0),
d_UCSR_t_dTemp_t_GND(0.0),
    VSATR_t(0.0),
d_VSATR_t_dTemp_t_GND(0.0),
    PTWGR_t(0.0),
d_PTWGR_t_dTemp_t_GND(0.0),
    ETA0R_t(0.0),
d_ETA0R_t_dTemp_t_GND(0.0),
    PSATB_i(0.0),
    KT1_i(0.0),
    KT2_i(0.0),
    NGATE_i(0.0),
    NSD_i(0.0),
    NDEP_i(0.0),
    VFB_i(0.0),
    CIT_i(0.0),
    CDSCD_i(0.0),
    CDSCDR_i(0.0),
    CDSCB_i(0.0),
    NFACTOR_i(0.0),
    PHIN_i(0.0),
    ETA0_i(0.0),
    ETA0R_i(0.0),
    ETAB_i(0.0),
    K2_i(0.0),
d_K2_i_dTemp_t_GND(0.0),
    K1_i(0.0),
    DELTA_i(0.0),
    U0_i(0.0),
    U0R_i(0.0),
    VSAT_i(0.0),
    VSATR_i(0.0),
    VSATCV_i(0.0),
    UA_i(0.0),
    UAR_i(0.0),
    EU_i(0.0),
    UD_i(0.0),
    UDR_i(0.0),
    UD_a(0.0),
d_UD_a_dTemp_t_GND(0.0),
d_UD_a_dV_di_bi(0.0),
d_UD_a_dV_si_bi(0.0),
    UCS_i(0.0),
    UCSR_i(0.0),
    UC_i(0.0),
    UCR_i(0.0),
    PDIBLC_i(0.0),
    PDIBLCR_i(0.0),
    PDIBLCB_i(0.0),
    PSCBE1_i(0.0),
    PSCBE2_i(0.0),
    PDITS_i(0.0),
    PDITSD_i(0.0),
    FPROUT_i(0.0),
    PRWG_i(0.0),
    WR_i(0.0),
    RDWMIN_i(0.0),
    RSWMIN_i(0.0),
    RDW_i(0.0),
    RSW_i(0.0),
    RDSW_i(0.0),
    RDSWMIN_i(0.0),
    PTWG_i(0.0),
    PTWGR_i(0.0),
    PVAG_i(0.0),
    XJ_i(0.0),
    PCLM_i(0.0),
    PCLMR_i(0.0),
    PCLMCV_i(0.0),
    PRWB_i(0.0),
    CF_i(0.0),
    CGSL_i(0.0),
    CGDL_i(0.0),
    CKAPPAS_i(0.0),
    CKAPPAD_i(0.0),
    VFBCV_i(0.0),
    NDEPCV_i(0.0),
    ALPHA0_i(0.0),
    BETA0_i(0.0),
    AGIDL_i(0.0),
    BGIDL_i(0.0),
    CGIDL_i(0.0),
    EGIDL_i(0.0),
    AGISL_i(0.0),
    BGISL_i(0.0),
    CGISL_i(0.0),
    EGISL_i(0.0),
    UTE_i(0.0),
    UA1_i(0.0),
    UC1_i(0.0),
    UD1_i(0.0),
    UCSTE_i(0.0),
    PRT_i(0.0),
    AT_i(0.0),
    PTWGT_i(0.0),
    IIT_i(0.0),
    TGIDL_i(0.0),
    KVTH0WE_i(0.0),
    K2WE_i(0.0),
    KU0WE_i(0.0),
    AIGBINV_i(0.0),
    BIGBINV_i(0.0),
    CIGBINV_i(0.0),
    EIGBINV_i(0.0),
    NIGBINV_i(0.0),
    AIGBACC_i(0.0),
    BIGBACC_i(0.0),
    CIGBACC_i(0.0),
    NIGBACC_i(0.0),
    AIGC_i(0.0),
    BIGC_i(0.0),
    CIGC_i(0.0),
    AIGS_i(0.0),
    BIGS_i(0.0),
    CIGS_i(0.0),
    AIGD_i(0.0),
    BIGD_i(0.0),
    CIGD_i(0.0),
    PIGCD_i(0.0),
    DLCIG_i(0.0),
    DLCIGD_i(0.0),
    IGT_i(0.0),
    nuIntD(0.0),
    nuEndD(0.0),
    nuIntS(0.0),
    nuEndS(0.0),
    gth(0.0),
    cth(0.0),
    QBI(0.0),
d_QBI_dTemp_t_GND(0.0),
d_QBI_dV_dbulk_di(0.0),
d_QBI_dV_sbulk_si(0.0),
d_QBI_dV_gi_bi(0.0),
d_QBI_dV_di_bi(0.0),
d_QBI_dV_si_bi(0.0),
    QSI(0.0),
d_QSI_dV_dbulk_di(0.0),
d_QSI_dV_sbulk_si(0.0),
d_QSI_dTemp_t_GND(0.0),
d_QSI_dV_gi_bi(0.0),
d_QSI_dV_di_bi(0.0),
d_QSI_dV_si_bi(0.0),
    QDI(0.0),
d_QDI_dV_dbulk_di(0.0),
d_QDI_dV_sbulk_si(0.0),
d_QDI_dTemp_t_GND(0.0),
d_QDI_dV_gi_bi(0.0),
d_QDI_dV_di_bi(0.0),
d_QDI_dV_si_bi(0.0),
    QGI(0.0),
d_QGI_dTemp_t_GND(0.0),
d_QGI_dV_dbulk_di(0.0),
d_QGI_dV_sbulk_si(0.0),
d_QGI_dV_gi_bi(0.0),
d_QGI_dV_di_bi(0.0),
d_QGI_dV_si_bi(0.0),
    CGGI(0.0),
    CGBI(0.0),
    CGSI(0.0),
    CGDI(0.0),
    CSGI(0.0),
    CSBI(0.0),
    CSSI(0.0),
    CSDI(0.0),
    CDGI(0.0),
    CDBI(0.0),
    CDSI(0.0),
    CDDI(0.0),
    CBGI(0.0),
    CBBI(0.0),
    CBSI(0.0),
    CBDI(0.0),
    QB(0.0),
d_QB_dTemp_t_GND(0.0),
d_QB_dV_dbulk_di(0.0),
d_QB_dV_sbulk_si(0.0),
d_QB_dV_gi_bi(0.0),
d_QB_dV_di_bi(0.0),
d_QB_dV_si_bi(0.0),
d_QB_dV_gm_bi(0.0),
    QS(0.0),
d_QS_dV_dbulk_di(0.0),
d_QS_dV_sbulk_si(0.0),
d_QS_dTemp_t_GND(0.0),
d_QS_dV_gi_bi(0.0),
d_QS_dV_di_bi(0.0),
d_QS_dV_si_bi(0.0),
d_QS_dV_gm_si(0.0),
    QD(0.0),
d_QD_dV_dbulk_di(0.0),
d_QD_dV_sbulk_si(0.0),
d_QD_dTemp_t_GND(0.0),
d_QD_dV_gi_bi(0.0),
d_QD_dV_di_bi(0.0),
d_QD_dV_si_bi(0.0),
d_QD_dV_gm_si(0.0),
d_QD_dV_gm_di(0.0),
    QG(0.0),
d_QG_dTemp_t_GND(0.0),
d_QG_dV_dbulk_di(0.0),
d_QG_dV_sbulk_si(0.0),
d_QG_dV_gi_bi(0.0),
d_QG_dV_di_bi(0.0),
d_QG_dV_si_bi(0.0),
d_QG_dV_gm_si(0.0),
d_QG_dV_gm_di(0.0),
d_QG_dV_gm_bi(0.0),
    CGG(0.0),
    CGB(0.0),
    CGS(0.0),
    CGD(0.0),
    CSG(0.0),
    CSB(0.0),
    CSS(0.0),
    CSD(0.0),
    CDG(0.0),
    CDB(0.0),
    CDS(0.0),
    CDD(0.0),
    CBG(0.0),
    CBB(0.0),
    CBS(0.0),
    CBD(0.0),
    ISUB(0.0),
d_ISUB_dV_di_bi(0.0),
d_ISUB_dV_si_bi(0.0),
d_ISUB_dV_gi_bi(0.0),
d_ISUB_dTemp_t_GND(0.0),
    IGIDL(0.0),
d_IGIDL_dV_gi_bi(0.0),
d_IGIDL_dV_di_bi(0.0),
d_IGIDL_dV_si_bi(0.0),
d_IGIDL_dTemp_t_GND(0.0),
    IGISL(0.0),
d_IGISL_dV_gi_bi(0.0),
d_IGISL_dV_di_bi(0.0),
d_IGISL_dV_si_bi(0.0),
d_IGISL_dTemp_t_GND(0.0),
    IGS(0.0),
d_IGS_dTemp_t_GND(0.0),
d_IGS_dV_gi_bi(0.0),
d_IGS_dV_si_bi(0.0),
d_IGS_dV_di_bi(0.0),
    IGD(0.0),
d_IGD_dTemp_t_GND(0.0),
d_IGD_dV_gi_bi(0.0),
d_IGD_dV_di_bi(0.0),
d_IGD_dV_si_bi(0.0),
    IGCS(0.0),
d_IGCS_dV_gi_bi(0.0),
d_IGCS_dV_di_bi(0.0),
d_IGCS_dV_si_bi(0.0),
d_IGCS_dTemp_t_GND(0.0),
    IGCD(0.0),
d_IGCD_dV_gi_bi(0.0),
d_IGCD_dV_di_bi(0.0),
d_IGCD_dV_si_bi(0.0),
d_IGCD_dTemp_t_GND(0.0),
    IGB(0.0),
d_IGB_dV_gi_bi(0.0),
d_IGB_dV_di_bi(0.0),
d_IGB_dV_si_bi(0.0),
d_IGB_dTemp_t_GND(0.0),
    CGSEXT(0.0),
    CGDEXT(0.0),
    CGBOV(0.0),
    CAPBS(0.0),
    CAPBD(0.0),
    WEFF(0.0),
    LEFF(0.0),
    WEFFCV(0.0),
    LEFFCV(0.0),
    IDS(0.0),
d_IDS_dV_gm_si(0.0),
d_IDS_dV_gm_di(0.0),
d_IDS_dV_dbulk_di(0.0),
d_IDS_dV_sbulk_si(0.0),
d_IDS_dV_gi_bi(0.0),
d_IDS_dTemp_t_GND(0.0),
d_IDS_dV_di_bi(0.0),
d_IDS_dV_si_bi(0.0),
    IDEFF(0.0),
    ISEFF(0.0),
    IGEFF(0.0),
    IBS(0.0),
    IBD(0.0),
    VDS(0.0),
    VGS(0.0),
    VBS(0.0),
    VDSAT(0.0),
    GM(0.0),
    GMBS(0.0),
    GDS(0.0),
    TK(0.0),
    VTH(0.0),
    li_d(-1),
    li_g(-1),
    li_s(-1),
    li_b(-1),
    li_t(-1),
    li_di(-1),
    li_si(-1),
    li_gi(-1),
    li_gm(-1),
    li_bi(-1),
    li_sbulk(-1),
    li_dbulk(-1),
    li_N1(-1),
    li_N2(-1),
    li_branch_id(-1),
    li_branch_ig(-1),
    li_branch_is(-1),
    li_branch_ib(-1),
    li_branch_it(-1),
    f_di_Equ_t_Node_Ptr(0),
    f_si_Equ_t_Node_Ptr(0),
    f_di_Equ_si_Node_Ptr(0),
    f_di_Equ_bi_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_si_Equ_bi_Node_Ptr(0),
    f_di_Equ_di_Node_Ptr(0),
    f_si_Equ_di_Node_Ptr(0),
    f_di_Equ_gi_Node_Ptr(0),
    f_si_Equ_gi_Node_Ptr(0),
    f_di_Equ_sbulk_Node_Ptr(0),
    f_si_Equ_sbulk_Node_Ptr(0),
    f_di_Equ_dbulk_Node_Ptr(0),
    f_si_Equ_dbulk_Node_Ptr(0),
    f_N2_Equ_sbulk_Node_Ptr(0),
    f_N2_Equ_si_Node_Ptr(0),
    f_N2_Equ_dbulk_Node_Ptr(0),
    f_N2_Equ_di_Node_Ptr(0),
    f_N2_Equ_t_Node_Ptr(0),
    f_N2_Equ_bi_Node_Ptr(0),
    f_N2_Equ_gi_Node_Ptr(0),
    f_N1_Equ_sbulk_Node_Ptr(0),
    f_N1_Equ_si_Node_Ptr(0),
    f_N1_Equ_dbulk_Node_Ptr(0),
    f_N1_Equ_di_Node_Ptr(0),
    f_N1_Equ_bi_Node_Ptr(0),
    f_N1_Equ_gi_Node_Ptr(0),
    f_N1_Equ_t_Node_Ptr(0),
    f_N1_Equ_N2_Node_Ptr(0),
    f_N1_Equ_N1_Node_Ptr(0),
    f_di_Equ_N2_Node_Ptr(0),
    f_si_Equ_N2_Node_Ptr(0),
    f_gi_Equ_N1_Node_Ptr(0),
    f_si_Equ_N1_Node_Ptr(0),
    f_gi_Equ_sbulk_Node_Ptr(0),
    f_gi_Equ_si_Node_Ptr(0),
    f_gi_Equ_dbulk_Node_Ptr(0),
    f_gi_Equ_di_Node_Ptr(0),
    f_gi_Equ_t_Node_Ptr(0),
    f_gi_Equ_bi_Node_Ptr(0),
    f_gi_Equ_gi_Node_Ptr(0),
    f_di_Equ_N1_Node_Ptr(0),
    f_N2_Equ_N2_Node_Ptr(0),
    f_bi_Equ_t_Node_Ptr(0),
    f_bi_Equ_si_Node_Ptr(0),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_di_Node_Ptr(0),
    f_bi_Equ_gi_Node_Ptr(0),
    f_bi_Equ_sbulk_Node_Ptr(0),
    f_bi_Equ_dbulk_Node_Ptr(0),
    f_gm_Equ_gm_Node_Ptr(0),
    f_gm_Equ_si_Node_Ptr(0),
    f_si_Equ_gm_Node_Ptr(0),
    f_gm_Equ_bi_Node_Ptr(0),
    f_gm_Equ_di_Node_Ptr(0),
    f_gm_Equ_gi_Node_Ptr(0),
    f_gm_Equ_sbulk_Node_Ptr(0),
    f_gm_Equ_dbulk_Node_Ptr(0),
    f_gm_Equ_t_Node_Ptr(0),
    f_di_Equ_gm_Node_Ptr(0),
    f_bi_Equ_gm_Node_Ptr(0),
    f_d_Equ_si_Node_Ptr(0),
    f_d_Equ_bi_Node_Ptr(0),
    f_d_Equ_di_Node_Ptr(0),
    f_d_Equ_gi_Node_Ptr(0),
    f_d_Equ_t_Node_Ptr(0),
    f_d_Equ_d_Node_Ptr(0),
    f_di_Equ_d_Node_Ptr(0),
    f_s_Equ_si_Node_Ptr(0),
    f_s_Equ_bi_Node_Ptr(0),
    f_s_Equ_di_Node_Ptr(0),
    f_s_Equ_gi_Node_Ptr(0),
    f_s_Equ_t_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_g_Equ_t_Node_Ptr(0),
    f_g_Equ_si_Node_Ptr(0),
    f_g_Equ_bi_Node_Ptr(0),
    f_g_Equ_di_Node_Ptr(0),
    f_g_Equ_gi_Node_Ptr(0),
    f_g_Equ_g_Node_Ptr(0),
    f_g_Equ_gm_Node_Ptr(0),
    f_gm_Equ_g_Node_Ptr(0),
    f_gi_Equ_gm_Node_Ptr(0),
    f_t_Equ_s_Node_Ptr(0),
    f_t_Equ_si_Node_Ptr(0),
    f_t_Equ_d_Node_Ptr(0),
    f_t_Equ_di_Node_Ptr(0),
    f_t_Equ_bi_Node_Ptr(0),
    f_t_Equ_t_Node_Ptr(0),
    f_t_Equ_gi_Node_Ptr(0),
    f_t_Equ_sbulk_Node_Ptr(0),
    f_t_Equ_dbulk_Node_Ptr(0),
    f_t_Equ_gm_Node_Ptr(0),
    f_sbulk_Equ_bi_Node_Ptr(0),
    f_sbulk_Equ_sbulk_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_b_Equ_sbulk_Node_Ptr(0),
    f_sbulk_Equ_b_Node_Ptr(0),
    f_b_Equ_bi_Node_Ptr(0),
    f_bi_Equ_b_Node_Ptr(0),
    f_b_Equ_dbulk_Node_Ptr(0),
    f_dbulk_Equ_b_Node_Ptr(0),
    f_dbulk_Equ_dbulk_Node_Ptr(0),
    f_dbulk_Equ_bi_Node_Ptr(0),
    f_sbulk_Equ_t_Node_Ptr(0),
    f_b_Equ_t_Node_Ptr(0),
    f_dbulk_Equ_t_Node_Ptr(0),
    f_sbulk_Equ_si_Node_Ptr(0),
    f_sbulk_Equ_di_Node_Ptr(0),
    f_sbulk_Equ_gi_Node_Ptr(0),
    f_dbulk_Equ_si_Node_Ptr(0),
    f_dbulk_Equ_di_Node_Ptr(0),
    f_dbulk_Equ_gi_Node_Ptr(0),
    f_dbulk_Equ_sbulk_Node_Ptr(0),
    f_sbulk_Equ_dbulk_Node_Ptr(0),
    q_di_Equ_t_Node_Ptr(0),
    q_si_Equ_t_Node_Ptr(0),
    q_di_Equ_si_Node_Ptr(0),
    q_di_Equ_bi_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_si_Equ_bi_Node_Ptr(0),
    q_di_Equ_di_Node_Ptr(0),
    q_si_Equ_di_Node_Ptr(0),
    q_di_Equ_gi_Node_Ptr(0),
    q_si_Equ_gi_Node_Ptr(0),
    q_di_Equ_sbulk_Node_Ptr(0),
    q_si_Equ_sbulk_Node_Ptr(0),
    q_di_Equ_dbulk_Node_Ptr(0),
    q_si_Equ_dbulk_Node_Ptr(0),
    q_N2_Equ_sbulk_Node_Ptr(0),
    q_N2_Equ_si_Node_Ptr(0),
    q_N2_Equ_dbulk_Node_Ptr(0),
    q_N2_Equ_di_Node_Ptr(0),
    q_N2_Equ_t_Node_Ptr(0),
    q_N2_Equ_bi_Node_Ptr(0),
    q_N2_Equ_gi_Node_Ptr(0),
    q_N1_Equ_sbulk_Node_Ptr(0),
    q_N1_Equ_si_Node_Ptr(0),
    q_N1_Equ_dbulk_Node_Ptr(0),
    q_N1_Equ_di_Node_Ptr(0),
    q_N1_Equ_bi_Node_Ptr(0),
    q_N1_Equ_gi_Node_Ptr(0),
    q_N1_Equ_t_Node_Ptr(0),
    q_N1_Equ_N2_Node_Ptr(0),
    q_N1_Equ_N1_Node_Ptr(0),
    q_di_Equ_N2_Node_Ptr(0),
    q_si_Equ_N2_Node_Ptr(0),
    q_gi_Equ_N1_Node_Ptr(0),
    q_si_Equ_N1_Node_Ptr(0),
    q_gi_Equ_sbulk_Node_Ptr(0),
    q_gi_Equ_si_Node_Ptr(0),
    q_gi_Equ_dbulk_Node_Ptr(0),
    q_gi_Equ_di_Node_Ptr(0),
    q_gi_Equ_t_Node_Ptr(0),
    q_gi_Equ_bi_Node_Ptr(0),
    q_gi_Equ_gi_Node_Ptr(0),
    q_di_Equ_N1_Node_Ptr(0),
    q_N2_Equ_N2_Node_Ptr(0),
    q_bi_Equ_t_Node_Ptr(0),
    q_bi_Equ_si_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_di_Node_Ptr(0),
    q_bi_Equ_gi_Node_Ptr(0),
    q_bi_Equ_sbulk_Node_Ptr(0),
    q_bi_Equ_dbulk_Node_Ptr(0),
    q_gm_Equ_gm_Node_Ptr(0),
    q_gm_Equ_si_Node_Ptr(0),
    q_si_Equ_gm_Node_Ptr(0),
    q_gm_Equ_bi_Node_Ptr(0),
    q_gm_Equ_di_Node_Ptr(0),
    q_gm_Equ_gi_Node_Ptr(0),
    q_gm_Equ_sbulk_Node_Ptr(0),
    q_gm_Equ_dbulk_Node_Ptr(0),
    q_gm_Equ_t_Node_Ptr(0),
    q_di_Equ_gm_Node_Ptr(0),
    q_bi_Equ_gm_Node_Ptr(0),
    q_d_Equ_si_Node_Ptr(0),
    q_d_Equ_bi_Node_Ptr(0),
    q_d_Equ_di_Node_Ptr(0),
    q_d_Equ_gi_Node_Ptr(0),
    q_d_Equ_t_Node_Ptr(0),
    q_d_Equ_d_Node_Ptr(0),
    q_di_Equ_d_Node_Ptr(0),
    q_s_Equ_si_Node_Ptr(0),
    q_s_Equ_bi_Node_Ptr(0),
    q_s_Equ_di_Node_Ptr(0),
    q_s_Equ_gi_Node_Ptr(0),
    q_s_Equ_t_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_g_Equ_t_Node_Ptr(0),
    q_g_Equ_si_Node_Ptr(0),
    q_g_Equ_bi_Node_Ptr(0),
    q_g_Equ_di_Node_Ptr(0),
    q_g_Equ_gi_Node_Ptr(0),
    q_g_Equ_g_Node_Ptr(0),
    q_g_Equ_gm_Node_Ptr(0),
    q_gm_Equ_g_Node_Ptr(0),
    q_gi_Equ_gm_Node_Ptr(0),
    q_t_Equ_s_Node_Ptr(0),
    q_t_Equ_si_Node_Ptr(0),
    q_t_Equ_d_Node_Ptr(0),
    q_t_Equ_di_Node_Ptr(0),
    q_t_Equ_bi_Node_Ptr(0),
    q_t_Equ_t_Node_Ptr(0),
    q_t_Equ_gi_Node_Ptr(0),
    q_t_Equ_sbulk_Node_Ptr(0),
    q_t_Equ_dbulk_Node_Ptr(0),
    q_t_Equ_gm_Node_Ptr(0),
    q_sbulk_Equ_bi_Node_Ptr(0),
    q_sbulk_Equ_sbulk_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_b_Equ_sbulk_Node_Ptr(0),
    q_sbulk_Equ_b_Node_Ptr(0),
    q_b_Equ_bi_Node_Ptr(0),
    q_bi_Equ_b_Node_Ptr(0),
    q_b_Equ_dbulk_Node_Ptr(0),
    q_dbulk_Equ_b_Node_Ptr(0),
    q_dbulk_Equ_dbulk_Node_Ptr(0),
    q_dbulk_Equ_bi_Node_Ptr(0),
    q_sbulk_Equ_t_Node_Ptr(0),
    q_b_Equ_t_Node_Ptr(0),
    q_dbulk_Equ_t_Node_Ptr(0),
    q_sbulk_Equ_si_Node_Ptr(0),
    q_sbulk_Equ_di_Node_Ptr(0),
    q_sbulk_Equ_gi_Node_Ptr(0),
    q_dbulk_Equ_si_Node_Ptr(0),
    q_dbulk_Equ_di_Node_Ptr(0),
    q_dbulk_Equ_gi_Node_Ptr(0),
    q_dbulk_Equ_sbulk_Node_Ptr(0),
    q_sbulk_Equ_dbulk_Node_Ptr(0),
    A_di_Equ_t_NodeOffset(-1),
    A_si_Equ_t_NodeOffset(-1),
    A_di_Equ_si_NodeOffset(-1),
    A_di_Equ_bi_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_si_Equ_bi_NodeOffset(-1),
    A_di_Equ_di_NodeOffset(-1),
    A_si_Equ_di_NodeOffset(-1),
    A_di_Equ_gi_NodeOffset(-1),
    A_si_Equ_gi_NodeOffset(-1),
    A_di_Equ_sbulk_NodeOffset(-1),
    A_si_Equ_sbulk_NodeOffset(-1),
    A_di_Equ_dbulk_NodeOffset(-1),
    A_si_Equ_dbulk_NodeOffset(-1),
    A_N2_Equ_sbulk_NodeOffset(-1),
    A_N2_Equ_si_NodeOffset(-1),
    A_N2_Equ_dbulk_NodeOffset(-1),
    A_N2_Equ_di_NodeOffset(-1),
    A_N2_Equ_t_NodeOffset(-1),
    A_N2_Equ_bi_NodeOffset(-1),
    A_N2_Equ_gi_NodeOffset(-1),
    A_N1_Equ_sbulk_NodeOffset(-1),
    A_N1_Equ_si_NodeOffset(-1),
    A_N1_Equ_dbulk_NodeOffset(-1),
    A_N1_Equ_di_NodeOffset(-1),
    A_N1_Equ_bi_NodeOffset(-1),
    A_N1_Equ_gi_NodeOffset(-1),
    A_N1_Equ_t_NodeOffset(-1),
    A_N1_Equ_N2_NodeOffset(-1),
    A_N1_Equ_N1_NodeOffset(-1),
    A_di_Equ_N2_NodeOffset(-1),
    A_si_Equ_N2_NodeOffset(-1),
    A_gi_Equ_N1_NodeOffset(-1),
    A_si_Equ_N1_NodeOffset(-1),
    A_gi_Equ_sbulk_NodeOffset(-1),
    A_gi_Equ_si_NodeOffset(-1),
    A_gi_Equ_dbulk_NodeOffset(-1),
    A_gi_Equ_di_NodeOffset(-1),
    A_gi_Equ_t_NodeOffset(-1),
    A_gi_Equ_bi_NodeOffset(-1),
    A_gi_Equ_gi_NodeOffset(-1),
    A_di_Equ_N1_NodeOffset(-1),
    A_N2_Equ_N2_NodeOffset(-1),
    A_bi_Equ_t_NodeOffset(-1),
    A_bi_Equ_si_NodeOffset(-1),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_di_NodeOffset(-1),
    A_bi_Equ_gi_NodeOffset(-1),
    A_bi_Equ_sbulk_NodeOffset(-1),
    A_bi_Equ_dbulk_NodeOffset(-1),
    A_gm_Equ_gm_NodeOffset(-1),
    A_gm_Equ_si_NodeOffset(-1),
    A_si_Equ_gm_NodeOffset(-1),
    A_gm_Equ_bi_NodeOffset(-1),
    A_gm_Equ_di_NodeOffset(-1),
    A_gm_Equ_gi_NodeOffset(-1),
    A_gm_Equ_sbulk_NodeOffset(-1),
    A_gm_Equ_dbulk_NodeOffset(-1),
    A_gm_Equ_t_NodeOffset(-1),
    A_di_Equ_gm_NodeOffset(-1),
    A_bi_Equ_gm_NodeOffset(-1),
    A_d_Equ_si_NodeOffset(-1),
    A_d_Equ_bi_NodeOffset(-1),
    A_d_Equ_di_NodeOffset(-1),
    A_d_Equ_gi_NodeOffset(-1),
    A_d_Equ_t_NodeOffset(-1),
    A_d_Equ_d_NodeOffset(-1),
    A_di_Equ_d_NodeOffset(-1),
    A_s_Equ_si_NodeOffset(-1),
    A_s_Equ_bi_NodeOffset(-1),
    A_s_Equ_di_NodeOffset(-1),
    A_s_Equ_gi_NodeOffset(-1),
    A_s_Equ_t_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_g_Equ_t_NodeOffset(-1),
    A_g_Equ_si_NodeOffset(-1),
    A_g_Equ_bi_NodeOffset(-1),
    A_g_Equ_di_NodeOffset(-1),
    A_g_Equ_gi_NodeOffset(-1),
    A_g_Equ_g_NodeOffset(-1),
    A_g_Equ_gm_NodeOffset(-1),
    A_gm_Equ_g_NodeOffset(-1),
    A_gi_Equ_gm_NodeOffset(-1),
    A_t_Equ_s_NodeOffset(-1),
    A_t_Equ_si_NodeOffset(-1),
    A_t_Equ_d_NodeOffset(-1),
    A_t_Equ_di_NodeOffset(-1),
    A_t_Equ_bi_NodeOffset(-1),
    A_t_Equ_t_NodeOffset(-1),
    A_t_Equ_gi_NodeOffset(-1),
    A_t_Equ_sbulk_NodeOffset(-1),
    A_t_Equ_dbulk_NodeOffset(-1),
    A_t_Equ_gm_NodeOffset(-1),
    A_sbulk_Equ_bi_NodeOffset(-1),
    A_sbulk_Equ_sbulk_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_b_Equ_sbulk_NodeOffset(-1),
    A_sbulk_Equ_b_NodeOffset(-1),
    A_b_Equ_bi_NodeOffset(-1),
    A_bi_Equ_b_NodeOffset(-1),
    A_b_Equ_dbulk_NodeOffset(-1),
    A_dbulk_Equ_b_NodeOffset(-1),
    A_dbulk_Equ_dbulk_NodeOffset(-1),
    A_dbulk_Equ_bi_NodeOffset(-1),
    A_sbulk_Equ_t_NodeOffset(-1),
    A_b_Equ_t_NodeOffset(-1),
    A_dbulk_Equ_t_NodeOffset(-1),
    A_sbulk_Equ_si_NodeOffset(-1),
    A_sbulk_Equ_di_NodeOffset(-1),
    A_sbulk_Equ_gi_NodeOffset(-1),
    A_dbulk_Equ_si_NodeOffset(-1),
    A_dbulk_Equ_di_NodeOffset(-1),
    A_dbulk_Equ_gi_NodeOffset(-1),
    A_dbulk_Equ_sbulk_NodeOffset(-1),
    A_sbulk_Equ_dbulk_NodeOffset(-1),
    li_store_QBI(-1),
    li_store_QSI(-1),
    li_store_QDI(-1),
    li_store_QGI(-1),
    li_store_CGGI(-1),
    li_store_CGBI(-1),
    li_store_CGSI(-1),
    li_store_CGDI(-1),
    li_store_CSGI(-1),
    li_store_CSBI(-1),
    li_store_CSSI(-1),
    li_store_CSDI(-1),
    li_store_CDGI(-1),
    li_store_CDBI(-1),
    li_store_CDSI(-1),
    li_store_CDDI(-1),
    li_store_CBGI(-1),
    li_store_CBBI(-1),
    li_store_CBSI(-1),
    li_store_CBDI(-1),
    li_store_QB(-1),
    li_store_QS(-1),
    li_store_QD(-1),
    li_store_QG(-1),
    li_store_CGG(-1),
    li_store_CGB(-1),
    li_store_CGS(-1),
    li_store_CGD(-1),
    li_store_CSG(-1),
    li_store_CSB(-1),
    li_store_CSS(-1),
    li_store_CSD(-1),
    li_store_CDG(-1),
    li_store_CDB(-1),
    li_store_CDS(-1),
    li_store_CDD(-1),
    li_store_CBG(-1),
    li_store_CBB(-1),
    li_store_CBS(-1),
    li_store_CBD(-1),
    li_store_ISUB(-1),
    li_store_IGIDL(-1),
    li_store_IGISL(-1),
    li_store_IGS(-1),
    li_store_IGD(-1),
    li_store_IGCS(-1),
    li_store_IGCD(-1),
    li_store_IGB(-1),
    li_store_CGSEXT(-1),
    li_store_CGDEXT(-1),
    li_store_CGBOV(-1),
    li_store_CAPBS(-1),
    li_store_CAPBD(-1),
    li_store_WEFF(-1),
    li_store_LEFF(-1),
    li_store_WEFFCV(-1),
    li_store_LEFFCV(-1),
    li_store_IDS(-1),
    li_store_IDEFF(-1),
    li_store_ISEFF(-1),
    li_store_IGEFF(-1),
    li_store_IBS(-1),
    li_store_IBD(-1),
    li_store_VDS(-1),
    li_store_VGS(-1),
    li_store_VBS(-1),
    li_store_VDSAT(-1),
    li_store_GM(-1),
    li_store_GMBS(-1),
    li_store_GDS(-1),
    li_store_TK(-1),
    li_store_VTH(-1),
    collapseNode_t(false),
    collapseNode_di(false),
    collapseNode_si(false),
    collapseNode_gi(false),
    collapseNode_gm(false),
    collapseNode_bi(false),
    collapseNode_sbulk(false),
    collapseNode_dbulk(false),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 9 + 0;
    numExtVars = 5;

    portsConnected_.resize(5,true);
    if (instance_block.numExtVars < 5)
    {
       // some of our optional nodes were not given...
       for (int i=instance_block.numExtVars ; i<numExtVars; i++)
       {
         portsConnected_[i]=false;
       }
       numIntVars += (5-instance_block.numExtVars);
       numExtVars = instance_block.numExtVars;
     }
  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+72);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = std::min(5,numExtVars);

  leadCurrentF.resize(5);
  leadCurrentQ.resize(5);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_gm));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_t,admsNodeID_gm));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_N2));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_N1));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_gm));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_N2));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_N1));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_gm));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_N1));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_gm));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_gm));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_gm,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_gm));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_sbulk,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_dbulk,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_N2));
    jacobianElements.push_back(IntPair(admsNodeID_N1,admsNodeID_N1));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_sbulk));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_dbulk));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_t));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_N2,admsNodeID_N2));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_t)
  {
  //this node is optional, we only *literally* collapse it if it's not
  // connected
  if(!portsConnected_[admsNodeID_t])
  {
  collapsedNodes.push_back(IntPair(admsNodeID_t,admsNodeID_GND));
  }
  else
  {
  UserWarning(*this) << "Collapsing optional external node t (node " << admsNodeID_t+1 << ") to ground.  This can lead to singular matrices and convergence problems.  Consider removing this optional node from the instance line if convergence problems result." << std::endl;
  }
  }
  if (collapseNode_di)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_di,admsNodeID_d));
  }
  if (collapseNode_si)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  }
  if (collapseNode_gi)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_gi,admsNodeID_gm));
  }
  if (collapseNode_gm)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_gm,admsNodeID_g));
  }
  if (collapseNode_bi)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_bi,admsNodeID_b));
  }
  if (collapseNode_sbulk)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_sbulk,admsNodeID_b));
  }
  if (collapseNode_dbulk)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_dbulk,admsNodeID_b));
  }

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 14+0;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
collapseNode_t = false;
collapseNode_di = false;
collapseNode_si = false;
collapseNode_gi = false;
collapseNode_gm = false;
collapseNode_bi = false;
collapseNode_sbulk = false;
collapseNode_dbulk = false;
if (!(((model_.RDSMOD)!=2)))
{

collapseNode_di = true;

collapseNode_si = true;

}

if ((RGATEMOD==0))
{

collapseNode_gm = true;

}

if (!((RGATEMOD==3)))
{

collapseNode_gi = true;

}

if (!((((model_.SHMOD)!=0)&&((model_.RTH0)>0))))
{

collapseNode_t = true;

}

if (!((RBODYMOD!=0)))
{

collapseNode_sbulk = true;

collapseNode_bi = true;

collapseNode_dbulk = true;

}


  if (collapseNode_t)
  {
  //this node is optional, and is external if it's connected --- so don't
  // decrement the internal node count!
  if(!portsConnected_[admsNodeID_t])
  {
    numIntVars--;
  }
  }
  if (collapseNode_di)
  {
    numIntVars--;
  }
  if (collapseNode_si)
  {
    numIntVars--;
  }
  if (collapseNode_gi)
  {
    numIntVars--;
  }
  if (collapseNode_gm)
  {
    numIntVars--;
  }
  if (collapseNode_bi)
  {
    numIntVars--;
  }
  if (collapseNode_sbulk)
  {
    numIntVars--;
  }
  if (collapseNode_dbulk)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSbsim6::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_d = localLIDVec[nodeMap[admsNodeID_d]];
  li_g = localLIDVec[nodeMap[admsNodeID_g]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  if (collapseNode_t)
  {
    li_t = -1;
  }
  else
  {
  li_t = localLIDVec[nodeMap[admsNodeID_t]];
  }
  li_di = localLIDVec[nodeMap[admsNodeID_di]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_gi = localLIDVec[nodeMap[admsNodeID_gi]];
  li_gm = localLIDVec[nodeMap[admsNodeID_gm]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_sbulk = localLIDVec[nodeMap[admsNodeID_sbulk]];
  li_dbulk = localLIDVec[nodeMap[admsNodeID_dbulk]];
  li_N1 = localLIDVec[nodeMap[admsNodeID_N1]];
  li_N2 = localLIDVec[nodeMap[admsNodeID_N2]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_d = " << li_d << std::endl;
      Xyce::dout() << "\nli_g = " << li_g << std::endl;
      Xyce::dout() << "\nli_s = " << li_s << std::endl;
      Xyce::dout() << "\nli_b = " << li_b << std::endl;
      Xyce::dout() << "\nli_t = " << li_t << std::endl;
      Xyce::dout() << "\nli_di = " << li_di << std::endl;
      Xyce::dout() << "\nli_si = " << li_si << std::endl;
      Xyce::dout() << "\nli_gi = " << li_gi << std::endl;
      Xyce::dout() << "\nli_gm = " << li_gm << std::endl;
      Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
      Xyce::dout() << "\nli_sbulk = " << li_sbulk << std::endl;
      Xyce::dout() << "\nli_dbulk = " << li_dbulk << std::endl;
      Xyce::dout() << "\nli_N1 = " << li_N1 << std::endl;
      Xyce::dout() << "\nli_N2 = " << li_N2 << std::endl;

    Xyce::dout() << "\nEnd of ADMSbsim6::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    if (!portsConnected_[admsNodeID_t])
    {
    if (!collapseNode_t)
    {
    addInternalNode(symbol_table, li_t, getName(), "t");
    }
    }
    if (!collapseNode_di)
    {
    addInternalNode(symbol_table, li_di, getName(), "di");
    }
    if (!collapseNode_si)
    {
    addInternalNode(symbol_table, li_si, getName(), "si");
    }
    if (!collapseNode_gi)
    {
    addInternalNode(symbol_table, li_gi, getName(), "gi");
    }
    if (!collapseNode_gm)
    {
    addInternalNode(symbol_table, li_gm, getName(), "gm");
    }
    if (!collapseNode_bi)
    {
    addInternalNode(symbol_table, li_bi, getName(), "bi");
    }
    if (!collapseNode_sbulk)
    {
    addInternalNode(symbol_table, li_sbulk, getName(), "sbulk");
    }
    if (!collapseNode_dbulk)
    {
    addInternalNode(symbol_table, li_dbulk, getName(), "dbulk");
    }
    addInternalNode(symbol_table, li_N1, getName(), "N1");
    addInternalNode(symbol_table, li_N2, getName(), "N2");
    addStoreNode(symbol_table, li_store_QBI, getName().getEncodedName() + ":QBI");
    addStoreNode(symbol_table, li_store_QSI, getName().getEncodedName() + ":QSI");
    addStoreNode(symbol_table, li_store_QDI, getName().getEncodedName() + ":QDI");
    addStoreNode(symbol_table, li_store_QGI, getName().getEncodedName() + ":QGI");
    addStoreNode(symbol_table, li_store_CGGI, getName().getEncodedName() + ":CGGI");
    addStoreNode(symbol_table, li_store_CGBI, getName().getEncodedName() + ":CGBI");
    addStoreNode(symbol_table, li_store_CGSI, getName().getEncodedName() + ":CGSI");
    addStoreNode(symbol_table, li_store_CGDI, getName().getEncodedName() + ":CGDI");
    addStoreNode(symbol_table, li_store_CSGI, getName().getEncodedName() + ":CSGI");
    addStoreNode(symbol_table, li_store_CSBI, getName().getEncodedName() + ":CSBI");
    addStoreNode(symbol_table, li_store_CSSI, getName().getEncodedName() + ":CSSI");
    addStoreNode(symbol_table, li_store_CSDI, getName().getEncodedName() + ":CSDI");
    addStoreNode(symbol_table, li_store_CDGI, getName().getEncodedName() + ":CDGI");
    addStoreNode(symbol_table, li_store_CDBI, getName().getEncodedName() + ":CDBI");
    addStoreNode(symbol_table, li_store_CDSI, getName().getEncodedName() + ":CDSI");
    addStoreNode(symbol_table, li_store_CDDI, getName().getEncodedName() + ":CDDI");
    addStoreNode(symbol_table, li_store_CBGI, getName().getEncodedName() + ":CBGI");
    addStoreNode(symbol_table, li_store_CBBI, getName().getEncodedName() + ":CBBI");
    addStoreNode(symbol_table, li_store_CBSI, getName().getEncodedName() + ":CBSI");
    addStoreNode(symbol_table, li_store_CBDI, getName().getEncodedName() + ":CBDI");
    addStoreNode(symbol_table, li_store_QB, getName().getEncodedName() + ":QB");
    addStoreNode(symbol_table, li_store_QS, getName().getEncodedName() + ":QS");
    addStoreNode(symbol_table, li_store_QD, getName().getEncodedName() + ":QD");
    addStoreNode(symbol_table, li_store_QG, getName().getEncodedName() + ":QG");
    addStoreNode(symbol_table, li_store_CGG, getName().getEncodedName() + ":CGG");
    addStoreNode(symbol_table, li_store_CGB, getName().getEncodedName() + ":CGB");
    addStoreNode(symbol_table, li_store_CGS, getName().getEncodedName() + ":CGS");
    addStoreNode(symbol_table, li_store_CGD, getName().getEncodedName() + ":CGD");
    addStoreNode(symbol_table, li_store_CSG, getName().getEncodedName() + ":CSG");
    addStoreNode(symbol_table, li_store_CSB, getName().getEncodedName() + ":CSB");
    addStoreNode(symbol_table, li_store_CSS, getName().getEncodedName() + ":CSS");
    addStoreNode(symbol_table, li_store_CSD, getName().getEncodedName() + ":CSD");
    addStoreNode(symbol_table, li_store_CDG, getName().getEncodedName() + ":CDG");
    addStoreNode(symbol_table, li_store_CDB, getName().getEncodedName() + ":CDB");
    addStoreNode(symbol_table, li_store_CDS, getName().getEncodedName() + ":CDS");
    addStoreNode(symbol_table, li_store_CDD, getName().getEncodedName() + ":CDD");
    addStoreNode(symbol_table, li_store_CBG, getName().getEncodedName() + ":CBG");
    addStoreNode(symbol_table, li_store_CBB, getName().getEncodedName() + ":CBB");
    addStoreNode(symbol_table, li_store_CBS, getName().getEncodedName() + ":CBS");
    addStoreNode(symbol_table, li_store_CBD, getName().getEncodedName() + ":CBD");
    addStoreNode(symbol_table, li_store_ISUB, getName().getEncodedName() + ":ISUB");
    addStoreNode(symbol_table, li_store_IGIDL, getName().getEncodedName() + ":IGIDL");
    addStoreNode(symbol_table, li_store_IGISL, getName().getEncodedName() + ":IGISL");
    addStoreNode(symbol_table, li_store_IGS, getName().getEncodedName() + ":IGS");
    addStoreNode(symbol_table, li_store_IGD, getName().getEncodedName() + ":IGD");
    addStoreNode(symbol_table, li_store_IGCS, getName().getEncodedName() + ":IGCS");
    addStoreNode(symbol_table, li_store_IGCD, getName().getEncodedName() + ":IGCD");
    addStoreNode(symbol_table, li_store_IGB, getName().getEncodedName() + ":IGB");
    addStoreNode(symbol_table, li_store_CGSEXT, getName().getEncodedName() + ":CGSEXT");
    addStoreNode(symbol_table, li_store_CGDEXT, getName().getEncodedName() + ":CGDEXT");
    addStoreNode(symbol_table, li_store_CGBOV, getName().getEncodedName() + ":CGBOV");
    addStoreNode(symbol_table, li_store_CAPBS, getName().getEncodedName() + ":CAPBS");
    addStoreNode(symbol_table, li_store_CAPBD, getName().getEncodedName() + ":CAPBD");
    addStoreNode(symbol_table, li_store_WEFF, getName().getEncodedName() + ":WEFF");
    addStoreNode(symbol_table, li_store_LEFF, getName().getEncodedName() + ":LEFF");
    addStoreNode(symbol_table, li_store_WEFFCV, getName().getEncodedName() + ":WEFFCV");
    addStoreNode(symbol_table, li_store_LEFFCV, getName().getEncodedName() + ":LEFFCV");
    addStoreNode(symbol_table, li_store_IDS, getName().getEncodedName() + ":IDS");
    addStoreNode(symbol_table, li_store_IDEFF, getName().getEncodedName() + ":IDEFF");
    addStoreNode(symbol_table, li_store_ISEFF, getName().getEncodedName() + ":ISEFF");
    addStoreNode(symbol_table, li_store_IGEFF, getName().getEncodedName() + ":IGEFF");
    addStoreNode(symbol_table, li_store_IBS, getName().getEncodedName() + ":IBS");
    addStoreNode(symbol_table, li_store_IBD, getName().getEncodedName() + ":IBD");
    addStoreNode(symbol_table, li_store_VDS, getName().getEncodedName() + ":VDS");
    addStoreNode(symbol_table, li_store_VGS, getName().getEncodedName() + ":VGS");
    addStoreNode(symbol_table, li_store_VBS, getName().getEncodedName() + ":VBS");
    addStoreNode(symbol_table, li_store_VDSAT, getName().getEncodedName() + ":VDSAT");
    addStoreNode(symbol_table, li_store_GM, getName().getEncodedName() + ":GM");
    addStoreNode(symbol_table, li_store_GMBS, getName().getEncodedName() + ":GMBS");
    addStoreNode(symbol_table, li_store_GDS, getName().getEncodedName() + ":GDS");
    addStoreNode(symbol_table, li_store_TK, getName().getEncodedName() + ":TK");
    addStoreNode(symbol_table, li_store_VTH, getName().getEncodedName() + ":VTH");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_id, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_ig, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    if (portsConnected_[admsNodeID_t])
    {
    addBranchDataNode( symbol_table, li_branch_it, getName(), "BRANCH_D5");
    }


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_QBI= stoLIDVec[i++];
      li_store_QSI= stoLIDVec[i++];
      li_store_QDI= stoLIDVec[i++];
      li_store_QGI= stoLIDVec[i++];
      li_store_CGGI= stoLIDVec[i++];
      li_store_CGBI= stoLIDVec[i++];
      li_store_CGSI= stoLIDVec[i++];
      li_store_CGDI= stoLIDVec[i++];
      li_store_CSGI= stoLIDVec[i++];
      li_store_CSBI= stoLIDVec[i++];
      li_store_CSSI= stoLIDVec[i++];
      li_store_CSDI= stoLIDVec[i++];
      li_store_CDGI= stoLIDVec[i++];
      li_store_CDBI= stoLIDVec[i++];
      li_store_CDSI= stoLIDVec[i++];
      li_store_CDDI= stoLIDVec[i++];
      li_store_CBGI= stoLIDVec[i++];
      li_store_CBBI= stoLIDVec[i++];
      li_store_CBSI= stoLIDVec[i++];
      li_store_CBDI= stoLIDVec[i++];
      li_store_QB= stoLIDVec[i++];
      li_store_QS= stoLIDVec[i++];
      li_store_QD= stoLIDVec[i++];
      li_store_QG= stoLIDVec[i++];
      li_store_CGG= stoLIDVec[i++];
      li_store_CGB= stoLIDVec[i++];
      li_store_CGS= stoLIDVec[i++];
      li_store_CGD= stoLIDVec[i++];
      li_store_CSG= stoLIDVec[i++];
      li_store_CSB= stoLIDVec[i++];
      li_store_CSS= stoLIDVec[i++];
      li_store_CSD= stoLIDVec[i++];
      li_store_CDG= stoLIDVec[i++];
      li_store_CDB= stoLIDVec[i++];
      li_store_CDS= stoLIDVec[i++];
      li_store_CDD= stoLIDVec[i++];
      li_store_CBG= stoLIDVec[i++];
      li_store_CBB= stoLIDVec[i++];
      li_store_CBS= stoLIDVec[i++];
      li_store_CBD= stoLIDVec[i++];
      li_store_ISUB= stoLIDVec[i++];
      li_store_IGIDL= stoLIDVec[i++];
      li_store_IGISL= stoLIDVec[i++];
      li_store_IGS= stoLIDVec[i++];
      li_store_IGD= stoLIDVec[i++];
      li_store_IGCS= stoLIDVec[i++];
      li_store_IGCD= stoLIDVec[i++];
      li_store_IGB= stoLIDVec[i++];
      li_store_CGSEXT= stoLIDVec[i++];
      li_store_CGDEXT= stoLIDVec[i++];
      li_store_CGBOV= stoLIDVec[i++];
      li_store_CAPBS= stoLIDVec[i++];
      li_store_CAPBD= stoLIDVec[i++];
      li_store_WEFF= stoLIDVec[i++];
      li_store_LEFF= stoLIDVec[i++];
      li_store_WEFFCV= stoLIDVec[i++];
      li_store_LEFFCV= stoLIDVec[i++];
      li_store_IDS= stoLIDVec[i++];
      li_store_IDEFF= stoLIDVec[i++];
      li_store_ISEFF= stoLIDVec[i++];
      li_store_IGEFF= stoLIDVec[i++];
      li_store_IBS= stoLIDVec[i++];
      li_store_IBD= stoLIDVec[i++];
      li_store_VDS= stoLIDVec[i++];
      li_store_VGS= stoLIDVec[i++];
      li_store_VBS= stoLIDVec[i++];
      li_store_VDSAT= stoLIDVec[i++];
      li_store_GM= stoLIDVec[i++];
      li_store_GMBS= stoLIDVec[i++];
      li_store_GDS= stoLIDVec[i++];
      li_store_TK= stoLIDVec[i++];
      li_store_VTH= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_id = branchLIDVecRef[i++];
    li_branch_ig = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    if (portsConnected_[admsNodeID_t])
    {
    li_branch_it = branchLIDVecRef[i++];
    }

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_si)];
    A_d_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_bi)];
    A_d_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_di)];
    A_d_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_gi)];
    A_d_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_t)];
    A_d_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_d)];
    A_d_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_t)];
    A_g_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_si)];
    A_g_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_bi)];
    A_g_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_di)];
    A_g_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_gi)];
    A_g_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_g)];
    A_g_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_gm)];
    A_g_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_si)];
    A_s_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_bi)];
    A_s_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_di)];
    A_s_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_gi)];
    A_s_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_t)];
    A_s_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
    A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
    A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_sbulk)];
    A_b_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bi)];
    A_b_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dbulk)];
    A_b_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_t)];
    A_b_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_s)];
    A_t_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_si)];
    A_t_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_d)];
    A_t_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_di)];
    A_t_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_bi)];
    A_t_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_t)];
    A_t_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_gi)];
    A_t_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_sbulk)];
    A_t_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_dbulk)];
    A_t_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_t,admsNodeID_gm)];
    A_t_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_t)];
    A_di_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_si)];
    A_di_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_bi)];
    A_di_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_di)];
    A_di_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_gi)];
    A_di_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_sbulk)];
    A_di_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_dbulk)];
    A_di_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_N2)];
    A_di_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_N1)];
    A_di_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_gm)];
    A_di_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_d)];
    A_di_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_t)];
    A_si_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
    A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bi)];
    A_si_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_di)];
    A_si_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_gi)];
    A_si_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_sbulk)];
    A_si_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_dbulk)];
    A_si_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_N2)];
    A_si_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_N1)];
    A_si_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_gm)];
    A_si_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
    A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_N1)];
    A_gi_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_sbulk)];
    A_gi_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_si)];
    A_gi_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_dbulk)];
    A_gi_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_di)];
    A_gi_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_t)];
    A_gi_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_bi)];
    A_gi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_gi)];
    A_gi_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_gm)];
    A_gi_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_gm)];
    A_gm_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_si)];
    A_gm_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_bi)];
    A_gm_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_di)];
    A_gm_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_gi)];
    A_gm_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_sbulk)];
    A_gm_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_dbulk)];
    A_gm_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_t)];
    A_gm_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gm,admsNodeID_g)];
    A_gm_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_t)];
    A_bi_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_si)];
    A_bi_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
    A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_di)];
    A_bi_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_gi)];
    A_bi_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_sbulk)];
    A_bi_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_dbulk)];
    A_bi_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_gm)];
    A_bi_Equ_gm_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_b)];
    A_bi_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_bi)];
    A_sbulk_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_sbulk)];
    A_sbulk_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_b)];
    A_sbulk_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_t)];
    A_sbulk_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_si)];
    A_sbulk_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_di)];
    A_sbulk_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_gi)];
    A_sbulk_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_sbulk,admsNodeID_dbulk)];
    A_sbulk_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_b)];
    A_dbulk_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_dbulk)];
    A_dbulk_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_bi)];
    A_dbulk_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_t)];
    A_dbulk_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_si)];
    A_dbulk_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_di)];
    A_dbulk_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_gi)];
    A_dbulk_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dbulk,admsNodeID_sbulk)];
    A_dbulk_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_sbulk)];
    A_N1_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_si)];
    A_N1_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_dbulk)];
    A_N1_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_di)];
    A_N1_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_bi)];
    A_N1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_gi)];
    A_N1_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_t)];
    A_N1_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_N2)];
    A_N1_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N1,admsNodeID_N1)];
    A_N1_Equ_N1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_sbulk)];
    A_N2_Equ_sbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_si)];
    A_N2_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_dbulk)];
    A_N2_Equ_dbulk_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_di)];
    A_N2_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_t)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_t)];
    A_N2_Equ_t_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_bi)];
    A_N2_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_gi)];
    A_N2_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_N2,admsNodeID_N2)];
    A_N2_Equ_N2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
    f_d_Equ_si_Node_Ptr = &(dFdx[li_d][A_d_Equ_si_NodeOffset]);
    q_d_Equ_si_Node_Ptr = &(dQdx[li_d][A_d_Equ_si_NodeOffset]);
    f_d_Equ_bi_Node_Ptr = &(dFdx[li_d][A_d_Equ_bi_NodeOffset]);
    q_d_Equ_bi_Node_Ptr = &(dQdx[li_d][A_d_Equ_bi_NodeOffset]);
    f_d_Equ_di_Node_Ptr = &(dFdx[li_d][A_d_Equ_di_NodeOffset]);
    q_d_Equ_di_Node_Ptr = &(dQdx[li_d][A_d_Equ_di_NodeOffset]);
    f_d_Equ_gi_Node_Ptr = &(dFdx[li_d][A_d_Equ_gi_NodeOffset]);
    q_d_Equ_gi_Node_Ptr = &(dQdx[li_d][A_d_Equ_gi_NodeOffset]);
if (!collapseNode_t)
{
    f_d_Equ_t_Node_Ptr = &(dFdx[li_d][A_d_Equ_t_NodeOffset]);
    q_d_Equ_t_Node_Ptr = &(dQdx[li_d][A_d_Equ_t_NodeOffset]);
}
    f_d_Equ_d_Node_Ptr = &(dFdx[li_d][A_d_Equ_d_NodeOffset]);
    q_d_Equ_d_Node_Ptr = &(dQdx[li_d][A_d_Equ_d_NodeOffset]);
if (!collapseNode_t)
{
    f_g_Equ_t_Node_Ptr = &(dFdx[li_g][A_g_Equ_t_NodeOffset]);
    q_g_Equ_t_Node_Ptr = &(dQdx[li_g][A_g_Equ_t_NodeOffset]);
}
    f_g_Equ_si_Node_Ptr = &(dFdx[li_g][A_g_Equ_si_NodeOffset]);
    q_g_Equ_si_Node_Ptr = &(dQdx[li_g][A_g_Equ_si_NodeOffset]);
    f_g_Equ_bi_Node_Ptr = &(dFdx[li_g][A_g_Equ_bi_NodeOffset]);
    q_g_Equ_bi_Node_Ptr = &(dQdx[li_g][A_g_Equ_bi_NodeOffset]);
    f_g_Equ_di_Node_Ptr = &(dFdx[li_g][A_g_Equ_di_NodeOffset]);
    q_g_Equ_di_Node_Ptr = &(dQdx[li_g][A_g_Equ_di_NodeOffset]);
    f_g_Equ_gi_Node_Ptr = &(dFdx[li_g][A_g_Equ_gi_NodeOffset]);
    q_g_Equ_gi_Node_Ptr = &(dQdx[li_g][A_g_Equ_gi_NodeOffset]);
    f_g_Equ_g_Node_Ptr = &(dFdx[li_g][A_g_Equ_g_NodeOffset]);
    q_g_Equ_g_Node_Ptr = &(dQdx[li_g][A_g_Equ_g_NodeOffset]);
    f_g_Equ_gm_Node_Ptr = &(dFdx[li_g][A_g_Equ_gm_NodeOffset]);
    q_g_Equ_gm_Node_Ptr = &(dQdx[li_g][A_g_Equ_gm_NodeOffset]);
    f_s_Equ_si_Node_Ptr = &(dFdx[li_s][A_s_Equ_si_NodeOffset]);
    q_s_Equ_si_Node_Ptr = &(dQdx[li_s][A_s_Equ_si_NodeOffset]);
    f_s_Equ_bi_Node_Ptr = &(dFdx[li_s][A_s_Equ_bi_NodeOffset]);
    q_s_Equ_bi_Node_Ptr = &(dQdx[li_s][A_s_Equ_bi_NodeOffset]);
    f_s_Equ_di_Node_Ptr = &(dFdx[li_s][A_s_Equ_di_NodeOffset]);
    q_s_Equ_di_Node_Ptr = &(dQdx[li_s][A_s_Equ_di_NodeOffset]);
    f_s_Equ_gi_Node_Ptr = &(dFdx[li_s][A_s_Equ_gi_NodeOffset]);
    q_s_Equ_gi_Node_Ptr = &(dQdx[li_s][A_s_Equ_gi_NodeOffset]);
if (!collapseNode_t)
{
    f_s_Equ_t_Node_Ptr = &(dFdx[li_s][A_s_Equ_t_NodeOffset]);
    q_s_Equ_t_Node_Ptr = &(dQdx[li_s][A_s_Equ_t_NodeOffset]);
}
    f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
    q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
    f_b_Equ_b_Node_Ptr = &(dFdx[li_b][A_b_Equ_b_NodeOffset]);
    q_b_Equ_b_Node_Ptr = &(dQdx[li_b][A_b_Equ_b_NodeOffset]);
    f_b_Equ_sbulk_Node_Ptr = &(dFdx[li_b][A_b_Equ_sbulk_NodeOffset]);
    q_b_Equ_sbulk_Node_Ptr = &(dQdx[li_b][A_b_Equ_sbulk_NodeOffset]);
    f_b_Equ_bi_Node_Ptr = &(dFdx[li_b][A_b_Equ_bi_NodeOffset]);
    q_b_Equ_bi_Node_Ptr = &(dQdx[li_b][A_b_Equ_bi_NodeOffset]);
    f_b_Equ_dbulk_Node_Ptr = &(dFdx[li_b][A_b_Equ_dbulk_NodeOffset]);
    q_b_Equ_dbulk_Node_Ptr = &(dQdx[li_b][A_b_Equ_dbulk_NodeOffset]);
if (!collapseNode_t)
{
    f_b_Equ_t_Node_Ptr = &(dFdx[li_b][A_b_Equ_t_NodeOffset]);
    q_b_Equ_t_Node_Ptr = &(dQdx[li_b][A_b_Equ_t_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_s_Node_Ptr = &(dFdx[li_t][A_t_Equ_s_NodeOffset]);
    q_t_Equ_s_Node_Ptr = &(dQdx[li_t][A_t_Equ_s_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_si_Node_Ptr = &(dFdx[li_t][A_t_Equ_si_NodeOffset]);
    q_t_Equ_si_Node_Ptr = &(dQdx[li_t][A_t_Equ_si_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_d_Node_Ptr = &(dFdx[li_t][A_t_Equ_d_NodeOffset]);
    q_t_Equ_d_Node_Ptr = &(dQdx[li_t][A_t_Equ_d_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_di_Node_Ptr = &(dFdx[li_t][A_t_Equ_di_NodeOffset]);
    q_t_Equ_di_Node_Ptr = &(dQdx[li_t][A_t_Equ_di_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_bi_Node_Ptr = &(dFdx[li_t][A_t_Equ_bi_NodeOffset]);
    q_t_Equ_bi_Node_Ptr = &(dQdx[li_t][A_t_Equ_bi_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_t_Node_Ptr = &(dFdx[li_t][A_t_Equ_t_NodeOffset]);
    q_t_Equ_t_Node_Ptr = &(dQdx[li_t][A_t_Equ_t_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_gi_Node_Ptr = &(dFdx[li_t][A_t_Equ_gi_NodeOffset]);
    q_t_Equ_gi_Node_Ptr = &(dQdx[li_t][A_t_Equ_gi_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_sbulk_Node_Ptr = &(dFdx[li_t][A_t_Equ_sbulk_NodeOffset]);
    q_t_Equ_sbulk_Node_Ptr = &(dQdx[li_t][A_t_Equ_sbulk_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_dbulk_Node_Ptr = &(dFdx[li_t][A_t_Equ_dbulk_NodeOffset]);
    q_t_Equ_dbulk_Node_Ptr = &(dQdx[li_t][A_t_Equ_dbulk_NodeOffset]);
}
if (!collapseNode_t)
{
    f_t_Equ_gm_Node_Ptr = &(dFdx[li_t][A_t_Equ_gm_NodeOffset]);
    q_t_Equ_gm_Node_Ptr = &(dQdx[li_t][A_t_Equ_gm_NodeOffset]);
}
if (!collapseNode_t)
{
    f_di_Equ_t_Node_Ptr = &(dFdx[li_di][A_di_Equ_t_NodeOffset]);
    q_di_Equ_t_Node_Ptr = &(dQdx[li_di][A_di_Equ_t_NodeOffset]);
}
    f_di_Equ_si_Node_Ptr = &(dFdx[li_di][A_di_Equ_si_NodeOffset]);
    q_di_Equ_si_Node_Ptr = &(dQdx[li_di][A_di_Equ_si_NodeOffset]);
    f_di_Equ_bi_Node_Ptr = &(dFdx[li_di][A_di_Equ_bi_NodeOffset]);
    q_di_Equ_bi_Node_Ptr = &(dQdx[li_di][A_di_Equ_bi_NodeOffset]);
    f_di_Equ_di_Node_Ptr = &(dFdx[li_di][A_di_Equ_di_NodeOffset]);
    q_di_Equ_di_Node_Ptr = &(dQdx[li_di][A_di_Equ_di_NodeOffset]);
    f_di_Equ_gi_Node_Ptr = &(dFdx[li_di][A_di_Equ_gi_NodeOffset]);
    q_di_Equ_gi_Node_Ptr = &(dQdx[li_di][A_di_Equ_gi_NodeOffset]);
    f_di_Equ_sbulk_Node_Ptr = &(dFdx[li_di][A_di_Equ_sbulk_NodeOffset]);
    q_di_Equ_sbulk_Node_Ptr = &(dQdx[li_di][A_di_Equ_sbulk_NodeOffset]);
    f_di_Equ_dbulk_Node_Ptr = &(dFdx[li_di][A_di_Equ_dbulk_NodeOffset]);
    q_di_Equ_dbulk_Node_Ptr = &(dQdx[li_di][A_di_Equ_dbulk_NodeOffset]);
    f_di_Equ_N2_Node_Ptr = &(dFdx[li_di][A_di_Equ_N2_NodeOffset]);
    q_di_Equ_N2_Node_Ptr = &(dQdx[li_di][A_di_Equ_N2_NodeOffset]);
    f_di_Equ_N1_Node_Ptr = &(dFdx[li_di][A_di_Equ_N1_NodeOffset]);
    q_di_Equ_N1_Node_Ptr = &(dQdx[li_di][A_di_Equ_N1_NodeOffset]);
    f_di_Equ_gm_Node_Ptr = &(dFdx[li_di][A_di_Equ_gm_NodeOffset]);
    q_di_Equ_gm_Node_Ptr = &(dQdx[li_di][A_di_Equ_gm_NodeOffset]);
    f_di_Equ_d_Node_Ptr = &(dFdx[li_di][A_di_Equ_d_NodeOffset]);
    q_di_Equ_d_Node_Ptr = &(dQdx[li_di][A_di_Equ_d_NodeOffset]);
if (!collapseNode_t)
{
    f_si_Equ_t_Node_Ptr = &(dFdx[li_si][A_si_Equ_t_NodeOffset]);
    q_si_Equ_t_Node_Ptr = &(dQdx[li_si][A_si_Equ_t_NodeOffset]);
}
    f_si_Equ_si_Node_Ptr = &(dFdx[li_si][A_si_Equ_si_NodeOffset]);
    q_si_Equ_si_Node_Ptr = &(dQdx[li_si][A_si_Equ_si_NodeOffset]);
    f_si_Equ_bi_Node_Ptr = &(dFdx[li_si][A_si_Equ_bi_NodeOffset]);
    q_si_Equ_bi_Node_Ptr = &(dQdx[li_si][A_si_Equ_bi_NodeOffset]);
    f_si_Equ_di_Node_Ptr = &(dFdx[li_si][A_si_Equ_di_NodeOffset]);
    q_si_Equ_di_Node_Ptr = &(dQdx[li_si][A_si_Equ_di_NodeOffset]);
    f_si_Equ_gi_Node_Ptr = &(dFdx[li_si][A_si_Equ_gi_NodeOffset]);
    q_si_Equ_gi_Node_Ptr = &(dQdx[li_si][A_si_Equ_gi_NodeOffset]);
    f_si_Equ_sbulk_Node_Ptr = &(dFdx[li_si][A_si_Equ_sbulk_NodeOffset]);
    q_si_Equ_sbulk_Node_Ptr = &(dQdx[li_si][A_si_Equ_sbulk_NodeOffset]);
    f_si_Equ_dbulk_Node_Ptr = &(dFdx[li_si][A_si_Equ_dbulk_NodeOffset]);
    q_si_Equ_dbulk_Node_Ptr = &(dQdx[li_si][A_si_Equ_dbulk_NodeOffset]);
    f_si_Equ_N2_Node_Ptr = &(dFdx[li_si][A_si_Equ_N2_NodeOffset]);
    q_si_Equ_N2_Node_Ptr = &(dQdx[li_si][A_si_Equ_N2_NodeOffset]);
    f_si_Equ_N1_Node_Ptr = &(dFdx[li_si][A_si_Equ_N1_NodeOffset]);
    q_si_Equ_N1_Node_Ptr = &(dQdx[li_si][A_si_Equ_N1_NodeOffset]);
    f_si_Equ_gm_Node_Ptr = &(dFdx[li_si][A_si_Equ_gm_NodeOffset]);
    q_si_Equ_gm_Node_Ptr = &(dQdx[li_si][A_si_Equ_gm_NodeOffset]);
    f_si_Equ_s_Node_Ptr = &(dFdx[li_si][A_si_Equ_s_NodeOffset]);
    q_si_Equ_s_Node_Ptr = &(dQdx[li_si][A_si_Equ_s_NodeOffset]);
    f_gi_Equ_N1_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_N1_NodeOffset]);
    q_gi_Equ_N1_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_N1_NodeOffset]);
    f_gi_Equ_sbulk_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_sbulk_NodeOffset]);
    q_gi_Equ_sbulk_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_sbulk_NodeOffset]);
    f_gi_Equ_si_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_si_NodeOffset]);
    q_gi_Equ_si_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_si_NodeOffset]);
    f_gi_Equ_dbulk_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_dbulk_NodeOffset]);
    q_gi_Equ_dbulk_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_dbulk_NodeOffset]);
    f_gi_Equ_di_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_di_NodeOffset]);
    q_gi_Equ_di_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_di_NodeOffset]);
if (!collapseNode_t)
{
    f_gi_Equ_t_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_t_NodeOffset]);
    q_gi_Equ_t_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_t_NodeOffset]);
}
    f_gi_Equ_bi_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_bi_NodeOffset]);
    q_gi_Equ_bi_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_bi_NodeOffset]);
    f_gi_Equ_gi_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_gi_NodeOffset]);
    q_gi_Equ_gi_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_gi_NodeOffset]);
    f_gi_Equ_gm_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_gm_NodeOffset]);
    q_gi_Equ_gm_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_gm_NodeOffset]);
    f_gm_Equ_gm_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_gm_NodeOffset]);
    q_gm_Equ_gm_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_gm_NodeOffset]);
    f_gm_Equ_si_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_si_NodeOffset]);
    q_gm_Equ_si_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_si_NodeOffset]);
    f_gm_Equ_bi_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_bi_NodeOffset]);
    q_gm_Equ_bi_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_bi_NodeOffset]);
    f_gm_Equ_di_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_di_NodeOffset]);
    q_gm_Equ_di_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_di_NodeOffset]);
    f_gm_Equ_gi_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_gi_NodeOffset]);
    q_gm_Equ_gi_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_gi_NodeOffset]);
    f_gm_Equ_sbulk_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_sbulk_NodeOffset]);
    q_gm_Equ_sbulk_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_sbulk_NodeOffset]);
    f_gm_Equ_dbulk_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_dbulk_NodeOffset]);
    q_gm_Equ_dbulk_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_dbulk_NodeOffset]);
if (!collapseNode_t)
{
    f_gm_Equ_t_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_t_NodeOffset]);
    q_gm_Equ_t_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_t_NodeOffset]);
}
    f_gm_Equ_g_Node_Ptr = &(dFdx[li_gm][A_gm_Equ_g_NodeOffset]);
    q_gm_Equ_g_Node_Ptr = &(dQdx[li_gm][A_gm_Equ_g_NodeOffset]);
if (!collapseNode_t)
{
    f_bi_Equ_t_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_t_NodeOffset]);
    q_bi_Equ_t_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_t_NodeOffset]);
}
    f_bi_Equ_si_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_si_NodeOffset]);
    q_bi_Equ_si_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_si_NodeOffset]);
    f_bi_Equ_bi_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_bi_NodeOffset]);
    q_bi_Equ_bi_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_bi_NodeOffset]);
    f_bi_Equ_di_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_di_NodeOffset]);
    q_bi_Equ_di_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_di_NodeOffset]);
    f_bi_Equ_gi_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_gi_NodeOffset]);
    q_bi_Equ_gi_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_gi_NodeOffset]);
    f_bi_Equ_sbulk_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_sbulk_NodeOffset]);
    q_bi_Equ_sbulk_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_sbulk_NodeOffset]);
    f_bi_Equ_dbulk_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_dbulk_NodeOffset]);
    q_bi_Equ_dbulk_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_dbulk_NodeOffset]);
    f_bi_Equ_gm_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_gm_NodeOffset]);
    q_bi_Equ_gm_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_gm_NodeOffset]);
    f_bi_Equ_b_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_b_NodeOffset]);
    q_bi_Equ_b_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_b_NodeOffset]);
    f_sbulk_Equ_bi_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset]);
    q_sbulk_Equ_bi_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset]);
    f_sbulk_Equ_sbulk_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset]);
    q_sbulk_Equ_sbulk_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset]);
    f_sbulk_Equ_b_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_b_NodeOffset]);
    q_sbulk_Equ_b_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_b_NodeOffset]);
if (!collapseNode_t)
{
    f_sbulk_Equ_t_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_t_NodeOffset]);
    q_sbulk_Equ_t_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_t_NodeOffset]);
}
    f_sbulk_Equ_si_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_si_NodeOffset]);
    q_sbulk_Equ_si_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_si_NodeOffset]);
    f_sbulk_Equ_di_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_di_NodeOffset]);
    q_sbulk_Equ_di_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_di_NodeOffset]);
    f_sbulk_Equ_gi_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset]);
    q_sbulk_Equ_gi_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset]);
    f_sbulk_Equ_dbulk_Node_Ptr = &(dFdx[li_sbulk][A_sbulk_Equ_dbulk_NodeOffset]);
    q_sbulk_Equ_dbulk_Node_Ptr = &(dQdx[li_sbulk][A_sbulk_Equ_dbulk_NodeOffset]);
    f_dbulk_Equ_b_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_b_NodeOffset]);
    q_dbulk_Equ_b_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_b_NodeOffset]);
    f_dbulk_Equ_dbulk_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset]);
    q_dbulk_Equ_dbulk_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset]);
    f_dbulk_Equ_bi_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset]);
    q_dbulk_Equ_bi_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset]);
if (!collapseNode_t)
{
    f_dbulk_Equ_t_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_t_NodeOffset]);
    q_dbulk_Equ_t_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_t_NodeOffset]);
}
    f_dbulk_Equ_si_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_si_NodeOffset]);
    q_dbulk_Equ_si_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_si_NodeOffset]);
    f_dbulk_Equ_di_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_di_NodeOffset]);
    q_dbulk_Equ_di_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_di_NodeOffset]);
    f_dbulk_Equ_gi_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset]);
    q_dbulk_Equ_gi_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset]);
    f_dbulk_Equ_sbulk_Node_Ptr = &(dFdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset]);
    q_dbulk_Equ_sbulk_Node_Ptr = &(dQdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset]);
    f_N1_Equ_sbulk_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_sbulk_NodeOffset]);
    q_N1_Equ_sbulk_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_sbulk_NodeOffset]);
    f_N1_Equ_si_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_si_NodeOffset]);
    q_N1_Equ_si_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_si_NodeOffset]);
    f_N1_Equ_dbulk_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_dbulk_NodeOffset]);
    q_N1_Equ_dbulk_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_dbulk_NodeOffset]);
    f_N1_Equ_di_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_di_NodeOffset]);
    q_N1_Equ_di_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_di_NodeOffset]);
    f_N1_Equ_bi_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_bi_NodeOffset]);
    q_N1_Equ_bi_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_bi_NodeOffset]);
    f_N1_Equ_gi_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_gi_NodeOffset]);
    q_N1_Equ_gi_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_gi_NodeOffset]);
if (!collapseNode_t)
{
    f_N1_Equ_t_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_t_NodeOffset]);
    q_N1_Equ_t_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_t_NodeOffset]);
}
    f_N1_Equ_N2_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_N2_NodeOffset]);
    q_N1_Equ_N2_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_N2_NodeOffset]);
    f_N1_Equ_N1_Node_Ptr = &(dFdx[li_N1][A_N1_Equ_N1_NodeOffset]);
    q_N1_Equ_N1_Node_Ptr = &(dQdx[li_N1][A_N1_Equ_N1_NodeOffset]);
    f_N2_Equ_sbulk_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_sbulk_NodeOffset]);
    q_N2_Equ_sbulk_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_sbulk_NodeOffset]);
    f_N2_Equ_si_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_si_NodeOffset]);
    q_N2_Equ_si_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_si_NodeOffset]);
    f_N2_Equ_dbulk_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_dbulk_NodeOffset]);
    q_N2_Equ_dbulk_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_dbulk_NodeOffset]);
    f_N2_Equ_di_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_di_NodeOffset]);
    q_N2_Equ_di_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_di_NodeOffset]);
if (!collapseNode_t)
{
    f_N2_Equ_t_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_t_NodeOffset]);
    q_N2_Equ_t_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_t_NodeOffset]);
}
    f_N2_Equ_bi_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_bi_NodeOffset]);
    q_N2_Equ_bi_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_bi_NodeOffset]);
    f_N2_Equ_gi_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_gi_NodeOffset]);
    q_N2_Equ_gi_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_gi_NodeOffset]);
    f_N2_Equ_N2_Node_Ptr = &(dFdx[li_N2][A_N2_Equ_N2_NodeOffset]);
    q_N2_Equ_N2_Node_Ptr = &(dQdx[li_N2][A_N2_Equ_N2_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_d] += staticContributions[admsNodeID_d];
(*extData.daeFVectorPtr)[li_g] += staticContributions[admsNodeID_g];
(*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s];
(*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b];
if (!collapseNode_t)
  (*extData.daeFVectorPtr)[li_t] += staticContributions[admsNodeID_t];
(*extData.daeFVectorPtr)[li_di] += staticContributions[admsNodeID_di];
(*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si];
(*extData.daeFVectorPtr)[li_gi] += staticContributions[admsNodeID_gi];
(*extData.daeFVectorPtr)[li_gm] += staticContributions[admsNodeID_gm];
(*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi];
(*extData.daeFVectorPtr)[li_sbulk] += staticContributions[admsNodeID_sbulk];
(*extData.daeFVectorPtr)[li_dbulk] += staticContributions[admsNodeID_dbulk];
(*extData.daeFVectorPtr)[li_N1] += staticContributions[admsNodeID_N1];
(*extData.daeFVectorPtr)[li_N2] += staticContributions[admsNodeID_N2];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_id] = leadCurrentF[admsNodeID_d];
    leadF[li_branch_ig] = leadCurrentF[admsNodeID_g];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    if (portsConnected_[admsNodeID_t])
    {
    leadF[li_branch_it] = leadCurrentF[admsNodeID_t];
    }



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_id] = solVec[li_d] - solVec[li_s];
        junctionV[li_branch_ig] = solVec[li_g] - solVec[li_s];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_d] += dynamicContributions[admsNodeID_d];
(*extData.daeQVectorPtr)[li_g] += dynamicContributions[admsNodeID_g];
(*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s];
(*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b];
if (!collapseNode_t)
  (*extData.daeQVectorPtr)[li_t] += dynamicContributions[admsNodeID_t];
(*extData.daeQVectorPtr)[li_di] += dynamicContributions[admsNodeID_di];
(*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si];
(*extData.daeQVectorPtr)[li_gi] += dynamicContributions[admsNodeID_gi];
(*extData.daeQVectorPtr)[li_gm] += dynamicContributions[admsNodeID_gm];
(*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi];
(*extData.daeQVectorPtr)[li_sbulk] += dynamicContributions[admsNodeID_sbulk];
(*extData.daeQVectorPtr)[li_dbulk] += dynamicContributions[admsNodeID_dbulk];
(*extData.daeQVectorPtr)[li_N1] += dynamicContributions[admsNodeID_N1];
(*extData.daeQVectorPtr)[li_N2] += dynamicContributions[admsNodeID_N2];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_id] = leadCurrentQ[admsNodeID_d];
    leadQ[li_branch_ig] = leadCurrentQ[admsNodeID_g];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    if (portsConnected_[admsNodeID_t])
    {
    leadQ[li_branch_it] = leadCurrentQ[admsNodeID_t];
    }


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_QBI] = QBI;
  stoVec[li_store_QSI] = QSI;
  stoVec[li_store_QDI] = QDI;
  stoVec[li_store_QGI] = QGI;
  stoVec[li_store_CGGI] = CGGI;
  stoVec[li_store_CGBI] = CGBI;
  stoVec[li_store_CGSI] = CGSI;
  stoVec[li_store_CGDI] = CGDI;
  stoVec[li_store_CSGI] = CSGI;
  stoVec[li_store_CSBI] = CSBI;
  stoVec[li_store_CSSI] = CSSI;
  stoVec[li_store_CSDI] = CSDI;
  stoVec[li_store_CDGI] = CDGI;
  stoVec[li_store_CDBI] = CDBI;
  stoVec[li_store_CDSI] = CDSI;
  stoVec[li_store_CDDI] = CDDI;
  stoVec[li_store_CBGI] = CBGI;
  stoVec[li_store_CBBI] = CBBI;
  stoVec[li_store_CBSI] = CBSI;
  stoVec[li_store_CBDI] = CBDI;
  stoVec[li_store_QB] = QB;
  stoVec[li_store_QS] = QS;
  stoVec[li_store_QD] = QD;
  stoVec[li_store_QG] = QG;
  stoVec[li_store_CGG] = CGG;
  stoVec[li_store_CGB] = CGB;
  stoVec[li_store_CGS] = CGS;
  stoVec[li_store_CGD] = CGD;
  stoVec[li_store_CSG] = CSG;
  stoVec[li_store_CSB] = CSB;
  stoVec[li_store_CSS] = CSS;
  stoVec[li_store_CSD] = CSD;
  stoVec[li_store_CDG] = CDG;
  stoVec[li_store_CDB] = CDB;
  stoVec[li_store_CDS] = CDS;
  stoVec[li_store_CDD] = CDD;
  stoVec[li_store_CBG] = CBG;
  stoVec[li_store_CBB] = CBB;
  stoVec[li_store_CBS] = CBS;
  stoVec[li_store_CBD] = CBD;
  stoVec[li_store_ISUB] = ISUB;
  stoVec[li_store_IGIDL] = IGIDL;
  stoVec[li_store_IGISL] = IGISL;
  stoVec[li_store_IGS] = IGS;
  stoVec[li_store_IGD] = IGD;
  stoVec[li_store_IGCS] = IGCS;
  stoVec[li_store_IGCD] = IGCD;
  stoVec[li_store_IGB] = IGB;
  stoVec[li_store_CGSEXT] = CGSEXT;
  stoVec[li_store_CGDEXT] = CGDEXT;
  stoVec[li_store_CGBOV] = CGBOV;
  stoVec[li_store_CAPBS] = CAPBS;
  stoVec[li_store_CAPBD] = CAPBD;
  stoVec[li_store_WEFF] = WEFF;
  stoVec[li_store_LEFF] = LEFF;
  stoVec[li_store_WEFFCV] = WEFFCV;
  stoVec[li_store_LEFFCV] = LEFFCV;
  stoVec[li_store_IDS] = IDS;
  stoVec[li_store_IDEFF] = IDEFF;
  stoVec[li_store_ISEFF] = ISEFF;
  stoVec[li_store_IGEFF] = IGEFF;
  stoVec[li_store_IBS] = IBS;
  stoVec[li_store_IBD] = IBD;
  stoVec[li_store_VDS] = VDS;
  stoVec[li_store_VGS] = VGS;
  stoVec[li_store_VBS] = VBS;
  stoVec[li_store_VDSAT] = VDSAT;
  stoVec[li_store_GM] = GM;
  stoVec[li_store_GMBS] = GMBS;
  stoVec[li_store_GDS] = GDS;
  stoVec[li_store_TK] = TK;
  stoVec[li_store_VTH] = VTH;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one bsim6 instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSbsim6::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double gspr=0.0;
     double d_gspr_dTemp_t_GND=0.0;
     double d_gspr_dV_gi_bi=0.0;
     double d_gspr_dV_di_bi=0.0;
     double d_gspr_dV_si_bi=0.0;
  double gdpr=0.0;
     double d_gdpr_dTemp_t_GND=0.0;
     double d_gdpr_dV_gi_bi=0.0;
     double d_gdpr_dV_di_bi=0.0;
     double d_gdpr_dV_si_bi=0.0;
  double ids_edge=0.0;
     double d_ids_edge_dV_gm_si=0.0;
     double d_ids_edge_dV_gm_di=0.0;
     double d_ids_edge_dV_dbulk_di=0.0;
     double d_ids_edge_dV_sbulk_si=0.0;
     double d_ids_edge_dV_gi_bi=0.0;
     double d_ids_edge_dTemp_t_GND=0.0;
     double d_ids_edge_dV_di_bi=0.0;
     double d_ids_edge_dV_si_bi=0.0;
  double Vdssate=0.0;
     double d_Vdssate_dV_gm_si=0.0;
     double d_Vdssate_dV_dbulk_di=0.0;
     double d_Vdssate_dV_sbulk_si=0.0;
     double d_Vdssate_dV_gi_bi=0.0;
     double d_Vdssate_dV_di_bi=0.0;
     double d_Vdssate_dV_si_bi=0.0;
     double d_Vdssate_dTemp_t_GND=0.0;
     double d_Vdssate_dV_gm_di=0.0;
  double Vdsatedge=0.0;
     double d_Vdsatedge_dV_gm_si=0.0;
     double d_Vdsatedge_dV_dbulk_di=0.0;
     double d_Vdsatedge_dV_sbulk_si=0.0;
     double d_Vdsatedge_dV_gi_bi=0.0;
     double d_Vdsatedge_dV_di_bi=0.0;
     double d_Vdsatedge_dV_si_bi=0.0;
     double d_Vdsatedge_dTemp_t_GND=0.0;
     double d_Vdsatedge_dV_gm_di=0.0;
  double vdsatedge=0.0;
     double d_vdsatedge_dV_gm_si=0.0;
     double d_vdsatedge_dV_dbulk_di=0.0;
     double d_vdsatedge_dV_sbulk_si=0.0;
     double d_vdsatedge_dV_gi_bi=0.0;
     double d_vdsatedge_dV_di_bi=0.0;
     double d_vdsatedge_dV_si_bi=0.0;
     double d_vdsatedge_dTemp_t_GND=0.0;
     double d_vdsatedge_dV_gm_di=0.0;
  double DGAMMAEDGE_i=0.0;
  double dvth_sce=0.0;
     double d_dvth_sce_dV_di_bi=0.0;
     double d_dvth_sce_dV_si_bi=0.0;
     double d_dvth_sce_dTemp_t_GND=0.0;
  double theta_sce_edge=0.0;
     double d_theta_sce_edge_dV_di_bi=0.0;
     double d_theta_sce_edge_dV_si_bi=0.0;
  double litl_edge=0.0;
     double d_litl_edge_dV_di_bi=0.0;
     double d_litl_edge_dV_si_bi=0.0;
  double dvth_dibl=0.0;
     double d_dvth_dibl_dTemp_t_GND=0.0;
     double d_dvth_dibl_dV_di_bi=0.0;
     double d_dvth_dibl_dV_si_bi=0.0;
  double ETA0EDGE_t=0.0;
     double d_ETA0EDGE_t_dTemp_t_GND=0.0;
  double NFACTOREDGE_t=0.0;
     double d_NFACTOREDGE_t_dTemp_t_GND=0.0;
  double Qovg=0.0;
     double d_Qovg_dTemp_t_GND=0.0;
     double d_Qovg_dV_dbulk_di=0.0;
     double d_Qovg_dV_sbulk_si=0.0;
     double d_Qovg_dV_gi_bi=0.0;
     double d_Qovg_dV_di_bi=0.0;
     double d_Qovg_dV_si_bi=0.0;
     double d_Qovg_dV_gm_si=0.0;
     double d_Qovg_dV_gm_di=0.0;
     double d_Qovg_dV_gm_bi=0.0;
  double Qovb=0.0;
     double d_Qovb_dV_gm_bi=0.0;
  double Qovd=0.0;
     double d_Qovd_dTemp_t_GND=0.0;
     double d_Qovd_dV_gm_si=0.0;
     double d_Qovd_dV_dbulk_di=0.0;
     double d_Qovd_dV_sbulk_si=0.0;
     double d_Qovd_dV_gi_bi=0.0;
     double d_Qovd_dV_di_bi=0.0;
     double d_Qovd_dV_si_bi=0.0;
     double d_Qovd_dV_gm_di=0.0;
  double Qovs=0.0;
     double d_Qovs_dTemp_t_GND=0.0;
     double d_Qovs_dV_dbulk_di=0.0;
     double d_Qovs_dV_sbulk_si=0.0;
     double d_Qovs_dV_gi_bi=0.0;
     double d_Qovs_dV_di_bi=0.0;
     double d_Qovs_dV_si_bi=0.0;
     double d_Qovs_dV_gm_si=0.0;
  double Vgdov=0.0;
     double d_Vgdov_dV_gm_di=0.0;
     double d_Vgdov_dTemp_t_GND=0.0;
     double d_Vgdov_dV_gm_si=0.0;
     double d_Vgdov_dV_dbulk_di=0.0;
     double d_Vgdov_dV_sbulk_si=0.0;
     double d_Vgdov_dV_gi_bi=0.0;
     double d_Vgdov_dV_di_bi=0.0;
     double d_Vgdov_dV_si_bi=0.0;
  double Vgsov=0.0;
     double d_Vgsov_dV_gm_si=0.0;
     double d_Vgsov_dTemp_t_GND=0.0;
     double d_Vgsov_dV_dbulk_di=0.0;
     double d_Vgsov_dV_sbulk_si=0.0;
     double d_Vgsov_dV_gi_bi=0.0;
     double d_Vgsov_dV_di_bi=0.0;
     double d_Vgsov_dV_si_bi=0.0;
  double Cgdof=0.0;
  double Cgsof=0.0;
  double QGi=0.0;
     double d_QGi_dTemp_t_GND=0.0;
     double d_QGi_dV_dbulk_di=0.0;
     double d_QGi_dV_sbulk_si=0.0;
     double d_QGi_dV_gi_bi=0.0;
     double d_QGi_dV_di_bi=0.0;
     double d_QGi_dV_si_bi=0.0;
  double WLCOXVtinv=0.0;
     double d_WLCOXVtinv_dV_dbulk_di=0.0;
     double d_WLCOXVtinv_dV_sbulk_si=0.0;
     double d_WLCOXVtinv_dV_gi_bi=0.0;
     double d_WLCOXVtinv_dV_di_bi=0.0;
     double d_WLCOXVtinv_dV_si_bi=0.0;
     double d_WLCOXVtinv_dTemp_t_GND=0.0;
  double QBi=0.0;
     double d_QBi_dTemp_t_GND=0.0;
     double d_QBi_dV_dbulk_di=0.0;
     double d_QBi_dV_sbulk_si=0.0;
     double d_QBi_dV_gi_bi=0.0;
     double d_QBi_dV_di_bi=0.0;
     double d_QBi_dV_si_bi=0.0;
  double Coxeffinv=0.0;
     double d_Coxeffinv_dV_dbulk_di=0.0;
     double d_Coxeffinv_dV_sbulk_si=0.0;
     double d_Coxeffinv_dV_gi_bi=0.0;
     double d_Coxeffinv_dV_di_bi=0.0;
     double d_Coxeffinv_dV_si_bi=0.0;
     double d_Coxeffinv_dTemp_t_GND=0.0;
  double XDCinv=0.0;
     double d_XDCinv_dV_dbulk_di=0.0;
     double d_XDCinv_dV_sbulk_si=0.0;
     double d_XDCinv_dV_gi_bi=0.0;
     double d_XDCinv_dV_di_bi=0.0;
     double d_XDCinv_dV_si_bi=0.0;
     double d_XDCinv_dTemp_t_GND=0.0;
  double qiaCV=0.0;
     double d_qiaCV_dTemp_t_GND=0.0;
     double d_qiaCV_dV_dbulk_di=0.0;
     double d_qiaCV_dV_sbulk_si=0.0;
     double d_qiaCV_dV_gi_bi=0.0;
     double d_qiaCV_dV_di_bi=0.0;
     double d_qiaCV_dV_si_bi=0.0;
  double qbaCV=0.0;
     double d_qbaCV_dTemp_t_GND=0.0;
     double d_qbaCV_dV_dbulk_di=0.0;
     double d_qbaCV_dV_sbulk_si=0.0;
     double d_qbaCV_dV_gi_bi=0.0;
     double d_qbaCV_dV_di_bi=0.0;
     double d_qbaCV_dV_si_bi=0.0;
  double Qd2=0.0;
     double d_Qd2_dV_dbulk_di=0.0;
     double d_Qd2_dV_sbulk_si=0.0;
     double d_Qd2_dV_gi_bi=0.0;
     double d_Qd2_dTemp_t_GND=0.0;
     double d_Qd2_dV_di_bi=0.0;
     double d_Qd2_dV_si_bi=0.0;
  double Qd1=0.0;
     double d_Qd1_dV_dbulk_di=0.0;
     double d_Qd1_dV_sbulk_si=0.0;
     double d_Qd1_dV_gi_bi=0.0;
     double d_Qd1_dTemp_t_GND=0.0;
     double d_Qd1_dV_di_bi=0.0;
     double d_Qd1_dV_si_bi=0.0;
  double Qi=0.0;
     double d_Qi_dV_dbulk_di=0.0;
     double d_Qi_dV_sbulk_si=0.0;
     double d_Qi_dV_gi_bi=0.0;
     double d_Qi_dTemp_t_GND=0.0;
     double d_Qi_dV_di_bi=0.0;
     double d_Qi_dV_si_bi=0.0;
  double qbeff=0.0;
     double d_qbeff_dV_gi_bi=0.0;
     double d_qbeff_dV_di_bi=0.0;
     double d_qbeff_dV_si_bi=0.0;
     double d_qbeff_dTemp_t_GND=0.0;
     double d_qbeff_dV_dbulk_di=0.0;
     double d_qbeff_dV_sbulk_si=0.0;
  double dqgeff=0.0;
     double d_dqgeff_dV_gi_bi=0.0;
     double d_dqgeff_dV_di_bi=0.0;
     double d_dqgeff_dV_si_bi=0.0;
     double d_dqgeff_dTemp_t_GND=0.0;
     double d_dqgeff_dV_dbulk_di=0.0;
     double d_dqgeff_dV_sbulk_si=0.0;
  double Tempd=0.0;
     double d_Tempd_dV_dbulk_di=0.0;
     double d_Tempd_dV_sbulk_si=0.0;
     double d_Tempd_dV_gi_bi=0.0;
     double d_Tempd_dV_di_bi=0.0;
     double d_Tempd_dV_si_bi=0.0;
     double d_Tempd_dTemp_t_GND=0.0;
  double Temps=0.0;
     double d_Temps_dV_dbulk_di=0.0;
     double d_Temps_dV_sbulk_si=0.0;
     double d_Temps_dV_gi_bi=0.0;
     double d_Temps_dV_di_bi=0.0;
     double d_Temps_dV_si_bi=0.0;
     double d_Temps_dTemp_t_GND=0.0;
  double sid=0.0;
     double d_sid_dV_gi_bi=0.0;
     double d_sid_dV_di_bi=0.0;
     double d_sid_dV_si_bi=0.0;
     double d_sid_dTemp_t_GND=0.0;
     double d_sid_dV_dbulk_di=0.0;
     double d_sid_dV_sbulk_si=0.0;
  double sis=0.0;
     double d_sis_dV_gi_bi=0.0;
     double d_sis_dV_di_bi=0.0;
     double d_sis_dV_si_bi=0.0;
     double d_sis_dTemp_t_GND=0.0;
     double d_sis_dV_dbulk_di=0.0;
     double d_sis_dV_sbulk_si=0.0;
  double vgpqm=0.0;
     double d_vgpqm_dV_gi_bi=0.0;
     double d_vgpqm_dV_di_bi=0.0;
     double d_vgpqm_dV_si_bi=0.0;
     double d_vgpqm_dTemp_t_GND=0.0;
     double d_vgpqm_dV_dbulk_di=0.0;
     double d_vgpqm_dV_sbulk_si=0.0;
  double MdL_less_1=0.0;
     double d_MdL_less_1_dV_dbulk_di=0.0;
     double d_MdL_less_1_dV_sbulk_si=0.0;
     double d_MdL_less_1_dV_gi_bi=0.0;
     double d_MdL_less_1_dV_di_bi=0.0;
     double d_MdL_less_1_dV_si_bi=0.0;
     double d_MdL_less_1_dTemp_t_GND=0.0;
  double inv_MdL_2=0.0;
     double d_inv_MdL_2_dV_dbulk_di=0.0;
     double d_inv_MdL_2_dV_sbulk_si=0.0;
     double d_inv_MdL_2_dV_gi_bi=0.0;
     double d_inv_MdL_2_dV_di_bi=0.0;
     double d_inv_MdL_2_dV_si_bi=0.0;
     double d_inv_MdL_2_dTemp_t_GND=0.0;
  double inv_MdL=0.0;
     double d_inv_MdL_dV_dbulk_di=0.0;
     double d_inv_MdL_dV_sbulk_si=0.0;
     double d_inv_MdL_dV_gi_bi=0.0;
     double d_inv_MdL_dV_di_bi=0.0;
     double d_inv_MdL_dV_si_bi=0.0;
     double d_inv_MdL_dTemp_t_GND=0.0;
  double MdL_2=0.0;
     double d_MdL_2_dV_dbulk_di=0.0;
     double d_MdL_2_dV_sbulk_si=0.0;
     double d_MdL_2_dV_gi_bi=0.0;
     double d_MdL_2_dV_di_bi=0.0;
     double d_MdL_2_dV_si_bi=0.0;
     double d_MdL_2_dTemp_t_GND=0.0;
  double zsat=0.0;
     double d_zsat_dV_dbulk_di=0.0;
     double d_zsat_dV_sbulk_si=0.0;
     double d_zsat_dV_gi_bi=0.0;
     double d_zsat_dV_di_bi=0.0;
     double d_zsat_dV_si_bi=0.0;
     double d_zsat_dTemp_t_GND=0.0;
  double dps=0.0;
     double d_dps_dV_dbulk_di=0.0;
     double d_dps_dV_sbulk_si=0.0;
     double d_dps_dV_gi_bi=0.0;
     double d_dps_dV_di_bi=0.0;
     double d_dps_dV_si_bi=0.0;
     double d_dps_dTemp_t_GND=0.0;
  double qb=0.0;
     double d_qb_dV_dbulk_di=0.0;
     double d_qb_dV_sbulk_si=0.0;
     double d_qb_dV_gi_bi=0.0;
     double d_qb_dV_di_bi=0.0;
     double d_qb_dV_si_bi=0.0;
     double d_qb_dTemp_t_GND=0.0;
  double qbd=0.0;
     double d_qbd_dV_dbulk_di=0.0;
     double d_qbd_dV_sbulk_si=0.0;
     double d_qbd_dV_gi_bi=0.0;
     double d_qbd_dV_di_bi=0.0;
     double d_qbd_dV_si_bi=0.0;
     double d_qbd_dTemp_t_GND=0.0;
  double VdssatCV=0.0;
     double d_VdssatCV_dV_dbulk_di=0.0;
     double d_VdssatCV_dV_sbulk_si=0.0;
     double d_VdssatCV_dV_gi_bi=0.0;
     double d_VdssatCV_dV_di_bi=0.0;
     double d_VdssatCV_dV_si_bi=0.0;
     double d_VdssatCV_dTemp_t_GND=0.0;
  double VdsatCV=0.0;
     double d_VdsatCV_dV_dbulk_di=0.0;
     double d_VdsatCV_dV_sbulk_si=0.0;
     double d_VdsatCV_dV_gi_bi=0.0;
     double d_VdsatCV_dV_di_bi=0.0;
     double d_VdsatCV_dV_si_bi=0.0;
     double d_VdsatCV_dTemp_t_GND=0.0;
  double vdsatcv=0.0;
     double d_vdsatcv_dV_dbulk_di=0.0;
     double d_vdsatcv_dV_sbulk_si=0.0;
     double d_vdsatcv_dV_gi_bi=0.0;
     double d_vdsatcv_dV_di_bi=0.0;
     double d_vdsatcv_dV_si_bi=0.0;
     double d_vdsatcv_dTemp_t_GND=0.0;
  double LambdaC_by2=0.0;
     double d_LambdaC_by2_dTemp_t_GND=0.0;
     double d_LambdaC_by2_dV_di_bi=0.0;
     double d_LambdaC_by2_dV_si_bi=0.0;
     double d_LambdaC_by2_dV_dbulk_di=0.0;
     double d_LambdaC_by2_dV_sbulk_si=0.0;
     double d_LambdaC_by2_dV_gi_bi=0.0;
  double DPD=0.0;
  double invgamg2=0.0;
     double d_invgamg2_dTemp_t_GND=0.0;
  double gamg2=0.0;
     double d_gamg2_dTemp_t_GND=0.0;
  double vgfbCV=0.0;
     double d_vgfbCV_dV_gi_bi=0.0;
     double d_vgfbCV_dV_di_bi=0.0;
     double d_vgfbCV_dV_si_bi=0.0;
     double d_vgfbCV_dTemp_t_GND=0.0;
  double QSi=0.0;
     double d_QSi_dV_dbulk_di=0.0;
     double d_QSi_dV_sbulk_si=0.0;
     double d_QSi_dTemp_t_GND=0.0;
     double d_QSi_dV_gi_bi=0.0;
     double d_QSi_dV_di_bi=0.0;
     double d_QSi_dV_si_bi=0.0;
  double QDi=0.0;
     double d_QDi_dV_dbulk_di=0.0;
     double d_QDi_dV_sbulk_si=0.0;
     double d_QDi_dTemp_t_GND=0.0;
     double d_QDi_dV_gi_bi=0.0;
     double d_QDi_dV_di_bi=0.0;
     double d_QDi_dV_si_bi=0.0;
  double Gtnoi=0.0;
  double sidn=0.0;
  double Vtn=0.0;
     double d_Vtn_dV_gi_bi=0.0;
     double d_Vtn_dTemp_t_GND=0.0;
     double d_Vtn_dV_di_bi=0.0;
     double d_Vtn_dV_si_bi=0.0;
  double Lvsat=0.0;
     double d_Lvsat_dV_gi_bi=0.0;
     double d_Lvsat_dV_di_bi=0.0;
     double d_Lvsat_dV_si_bi=0.0;
     double d_Lvsat_dTemp_t_GND=0.0;
  double mid=0.0;
     double d_mid_dV_dbulk_di=0.0;
     double d_mid_dV_sbulk_si=0.0;
     double d_mid_dV_gi_bi=0.0;
     double d_mid_dV_di_bi=0.0;
     double d_mid_dV_si_bi=0.0;
     double d_mid_dTemp_t_GND=0.0;
  double mig=0.0;
     double d_mig_dV_gi_bi=0.0;
     double d_mig_dV_di_bi=0.0;
     double d_mig_dV_si_bi=0.0;
     double d_mig_dTemp_t_GND=0.0;
     double d_mig_dV_dbulk_di=0.0;
     double d_mig_dV_sbulk_si=0.0;
  double migid=0.0;
  double sqid=0.0;
     double d_sqid_dTemp_t_GND=0.0;
     double d_sqid_dV_dbulk_di=0.0;
     double d_sqid_dV_sbulk_si=0.0;
     double d_sqid_dV_gi_bi=0.0;
     double d_sqid_dV_di_bi=0.0;
     double d_sqid_dV_si_bi=0.0;
  double sqig=0.0;
     double d_sqig_dTemp_t_GND=0.0;
     double d_sqig_dV_gi_bi=0.0;
     double d_sqig_dV_di_bi=0.0;
     double d_sqig_dV_si_bi=0.0;
     double d_sqig_dV_dbulk_di=0.0;
     double d_sqig_dV_sbulk_si=0.0;
  double cm_igid=0.0;
  double thetanoisq=0.0;
     double d_thetanoisq_dV_dbulk_di=0.0;
     double d_thetanoisq_dV_sbulk_si=0.0;
     double d_thetanoisq_dV_gi_bi=0.0;
     double d_thetanoisq_dV_di_bi=0.0;
     double d_thetanoisq_dV_si_bi=0.0;
     double d_thetanoisq_dTemp_t_GND=0.0;
  double betanoisq=0.0;
     double d_betanoisq_dV_dbulk_di=0.0;
     double d_betanoisq_dV_sbulk_si=0.0;
     double d_betanoisq_dV_gi_bi=0.0;
     double d_betanoisq_dV_di_bi=0.0;
     double d_betanoisq_dV_si_bi=0.0;
     double d_betanoisq_dTemp_t_GND=0.0;
  double ctnoi=0.0;
  double FNPowerAt1Hz=0.0;
  double Swi=0.0;
     double d_Swi_dTemp_t_GND=0.0;
     double d_Swi_dV_gi_bi=0.0;
     double d_Swi_dV_di_bi=0.0;
     double d_Swi_dV_si_bi=0.0;
  double T10=0.0;
     double d_T10_dV_dbulk_di=0.0;
     double d_T10_dV_sbulk_si=0.0;
     double d_T10_dV_gi_bi=0.0;
     double d_T10_dV_di_bi=0.0;
     double d_T10_dV_si_bi=0.0;
     double d_T10_dTemp_t_GND=0.0;
  double Ssi=0.0;
     double d_Ssi_dV_dbulk_di=0.0;
     double d_Ssi_dV_sbulk_si=0.0;
     double d_Ssi_dV_gi_bi=0.0;
     double d_Ssi_dV_di_bi=0.0;
     double d_Ssi_dV_si_bi=0.0;
     double d_Ssi_dTemp_t_GND=0.0;
  double Nstar=0.0;
     double d_Nstar_dTemp_t_GND=0.0;
     double d_Nstar_dV_di_bi=0.0;
     double d_Nstar_dV_si_bi=0.0;
  double Nl=0.0;
     double d_Nl_dV_gi_bi=0.0;
     double d_Nl_dTemp_t_GND=0.0;
     double d_Nl_dV_di_bi=0.0;
     double d_Nl_dV_si_bi=0.0;
  double N0=0.0;
     double d_N0_dV_gi_bi=0.0;
     double d_N0_dTemp_t_GND=0.0;
     double d_N0_dV_di_bi=0.0;
     double d_N0_dV_si_bi=0.0;
  double DelClm=0.0;
     double d_DelClm_dV_dbulk_di=0.0;
     double d_DelClm_dV_sbulk_si=0.0;
     double d_DelClm_dV_gi_bi=0.0;
     double d_DelClm_dV_di_bi=0.0;
     double d_DelClm_dV_si_bi=0.0;
     double d_DelClm_dTemp_t_GND=0.0;
  double Leffnoisq=0.0;
  double Leffnoi=0.0;
  double Esatnoi=0.0;
     double d_Esatnoi_dTemp_t_GND=0.0;
     double d_Esatnoi_dV_di_bi=0.0;
     double d_Esatnoi_dV_si_bi=0.0;
     double d_Esatnoi_dV_gi_bi=0.0;
  double LINTNOI_i=0.0;
  double Nt=0.0;
     double d_Nt_dTemp_t_GND=0.0;
  double Qbd=0.0;
     double d_Qbd_dTemp_t_GND=0.0;
     double d_Qbd_dV_dbulk_di=0.0;
     double d_Qbd_dV_sbulk_si=0.0;
     double d_Qbd_dV_gi_bi=0.0;
     double d_Qbd_dV_di_bi=0.0;
     double d_Qbd_dV_si_bi=0.0;
  double Qbs=0.0;
     double d_Qbs_dTemp_t_GND=0.0;
     double d_Qbs_dV_dbulk_di=0.0;
     double d_Qbs_dV_sbulk_si=0.0;
     double d_Qbs_dV_gi_bi=0.0;
     double d_Qbs_dV_di_bi=0.0;
     double d_Qbs_dV_si_bi=0.0;
  double sarg=0.0;
     double d_sarg_dV_dbulk_di=0.0;
     double d_sarg_dV_sbulk_si=0.0;
     double d_sarg_dV_gi_bi=0.0;
     double d_sarg_dV_di_bi=0.0;
     double d_sarg_dV_si_bi=0.0;
     double d_sarg_dTemp_t_GND=0.0;
  double arg=0.0;
     double d_arg_dV_dbulk_di=0.0;
     double d_arg_dV_sbulk_si=0.0;
     double d_arg_dV_gi_bi=0.0;
     double d_arg_dV_di_bi=0.0;
     double d_arg_dV_si_bi=0.0;
     double d_arg_dTemp_t_GND=0.0;
  double Ibd=0.0;
     double d_Ibd_dV_dbulk_di=0.0;
     double d_Ibd_dV_sbulk_si=0.0;
     double d_Ibd_dV_gi_bi=0.0;
     double d_Ibd_dV_di_bi=0.0;
     double d_Ibd_dV_si_bi=0.0;
     double d_Ibd_dTemp_t_GND=0.0;
  double Ibs=0.0;
     double d_Ibs_dV_sbulk_si=0.0;
     double d_Ibs_dV_gi_bi=0.0;
     double d_Ibs_dV_di_bi=0.0;
     double d_Ibs_dV_si_bi=0.0;
     double d_Ibs_dTemp_t_GND=0.0;
  double igidl=0.0;
     double d_igidl_dV_gi_bi=0.0;
     double d_igidl_dV_di_bi=0.0;
     double d_igidl_dV_si_bi=0.0;
     double d_igidl_dTemp_t_GND=0.0;
  double igisl=0.0;
     double d_igisl_dV_gi_bi=0.0;
     double d_igisl_dV_di_bi=0.0;
     double d_igisl_dV_si_bi=0.0;
     double d_igisl_dTemp_t_GND=0.0;
  double igd_mult=0.0;
     double d_igd_mult_dTemp_t_GND=0.0;
  double igs_mult=0.0;
     double d_igs_mult_dTemp_t_GND=0.0;
  double T1_exp=0.0;
     double d_T1_exp_dV_gi_bi=0.0;
     double d_T1_exp_dV_di_bi=0.0;
     double d_T1_exp_dV_si_bi=0.0;
     double d_T1_exp_dTemp_t_GND=0.0;
  double Vdseffx=0.0;
     double d_Vdseffx_dV_di_bi=0.0;
     double d_Vdseffx_dV_si_bi=0.0;
     double d_Vdseffx_dV_gi_bi=0.0;
     double d_Vdseffx_dTemp_t_GND=0.0;
  double igc0=0.0;
     double d_igc0_dV_gi_bi=0.0;
     double d_igc0_dV_di_bi=0.0;
     double d_igc0_dV_si_bi=0.0;
     double d_igc0_dTemp_t_GND=0.0;
  double Vaux_Igbinv=0.0;
     double d_Vaux_Igbinv_dTemp_t_GND=0.0;
     double d_Vaux_Igbinv_dV_gi_bi=0.0;
     double d_Vaux_Igbinv_dV_di_bi=0.0;
     double d_Vaux_Igbinv_dV_si_bi=0.0;
  double Vaux_Igbacc=0.0;
     double d_Vaux_Igbacc_dTemp_t_GND=0.0;
     double d_Vaux_Igbacc_dV_gi_bi=0.0;
     double d_Vaux_Igbacc_dV_di_bi=0.0;
     double d_Vaux_Igbacc_dV_si_bi=0.0;
  double Voxminv=0.0;
     double d_Voxminv_dV_di_bi=0.0;
     double d_Voxminv_dV_si_bi=0.0;
     double d_Voxminv_dTemp_t_GND=0.0;
     double d_Voxminv_dV_gi_bi=0.0;
  double Voxmacc=0.0;
     double d_Voxmacc_dV_di_bi=0.0;
     double d_Voxmacc_dV_si_bi=0.0;
     double d_Voxmacc_dTemp_t_GND=0.0;
     double d_Voxmacc_dV_gi_bi=0.0;
  double Voxm=0.0;
     double d_Voxm_dV_di_bi=0.0;
     double d_Voxm_dV_si_bi=0.0;
     double d_Voxm_dTemp_t_GND=0.0;
     double d_Voxm_dV_gi_bi=0.0;
  double igd=0.0;
     double d_igd_dTemp_t_GND=0.0;
     double d_igd_dV_gi_bi=0.0;
     double d_igd_dV_di_bi=0.0;
     double d_igd_dV_si_bi=0.0;
  double igs=0.0;
     double d_igs_dTemp_t_GND=0.0;
     double d_igs_dV_gi_bi=0.0;
     double d_igs_dV_si_bi=0.0;
     double d_igs_dV_di_bi=0.0;
  double igcd=0.0;
     double d_igcd_dV_gi_bi=0.0;
     double d_igcd_dV_di_bi=0.0;
     double d_igcd_dV_si_bi=0.0;
     double d_igcd_dTemp_t_GND=0.0;
  double igcs=0.0;
     double d_igcs_dV_gi_bi=0.0;
     double d_igcs_dV_di_bi=0.0;
     double d_igcs_dV_si_bi=0.0;
     double d_igcs_dTemp_t_GND=0.0;
  double igb=0.0;
     double d_igb_dV_gi_bi=0.0;
     double d_igb_dV_di_bi=0.0;
     double d_igb_dV_si_bi=0.0;
     double d_igb_dTemp_t_GND=0.0;
  double igbacc=0.0;
     double d_igbacc_dV_gi_bi=0.0;
     double d_igbacc_dV_di_bi=0.0;
     double d_igbacc_dV_si_bi=0.0;
     double d_igbacc_dTemp_t_GND=0.0;
  double igbinv=0.0;
     double d_igbinv_dV_gi_bi=0.0;
     double d_igbinv_dV_di_bi=0.0;
     double d_igbinv_dV_si_bi=0.0;
     double d_igbinv_dTemp_t_GND=0.0;
  double Iii=0.0;
     double d_Iii_dV_di_bi=0.0;
     double d_Iii_dV_si_bi=0.0;
     double d_Iii_dV_gi_bi=0.0;
     double d_Iii_dTemp_t_GND=0.0;
  double idsovvds=0.0;
     double d_idsovvds_dTemp_t_GND=0.0;
     double d_idsovvds_dV_di_bi=0.0;
     double d_idsovvds_dV_si_bi=0.0;
     double d_idsovvds_dV_gi_bi=0.0;
  double Gcrg=0.0;
     double d_Gcrg_dV_gi_bi=0.0;
     double d_Gcrg_dV_di_bi=0.0;
     double d_Gcrg_dV_si_bi=0.0;
     double d_Gcrg_dTemp_t_GND=0.0;
  double ids=0.0;
     double d_ids_dV_gm_si=0.0;
     double d_ids_dV_gm_di=0.0;
     double d_ids_dV_dbulk_di=0.0;
     double d_ids_dV_sbulk_si=0.0;
     double d_ids_dV_gi_bi=0.0;
     double d_ids_dTemp_t_GND=0.0;
     double d_ids_dV_di_bi=0.0;
     double d_ids_dV_si_bi=0.0;
  double ueff=0.0;
     double d_ueff_dTemp_t_GND=0.0;
     double d_ueff_dV_di_bi=0.0;
     double d_ueff_dV_si_bi=0.0;
     double d_ueff_dV_gi_bi=0.0;
  double Dtot=0.0;
     double d_Dtot_dV_gi_bi=0.0;
     double d_Dtot_dV_di_bi=0.0;
     double d_Dtot_dV_si_bi=0.0;
     double d_Dtot_dTemp_t_GND=0.0;
  double Nsat=0.0;
     double d_Nsat_dV_gi_bi=0.0;
     double d_Nsat_dV_di_bi=0.0;
     double d_Nsat_dV_si_bi=0.0;
     double d_Nsat_dTemp_t_GND=0.0;
  double DQSD=0.0;
     double d_DQSD_dV_dbulk_di=0.0;
     double d_DQSD_dV_sbulk_si=0.0;
     double d_DQSD_dV_gi_bi=0.0;
     double d_DQSD_dV_di_bi=0.0;
     double d_DQSD_dV_si_bi=0.0;
     double d_DQSD_dTemp_t_GND=0.0;
  double Vgd_eff=0.0;
     double d_Vgd_eff_dV_gi_bi=0.0;
     double d_Vgd_eff_dV_di_bi=0.0;
     double d_Vgd_eff_dV_si_bi=0.0;
     double d_Vgd_eff_dTemp_t_GND=0.0;
  double Vgs_eff=0.0;
     double d_Vgs_eff_dV_gi_bi=0.0;
     double d_Vgs_eff_dV_di_bi=0.0;
     double d_Vgs_eff_dV_si_bi=0.0;
     double d_Vgs_eff_dTemp_t_GND=0.0;
  double Dr=0.0;
     double d_Dr_dTemp_t_GND=0.0;
     double d_Dr_dV_di_bi=0.0;
     double d_Dr_dV_si_bi=0.0;
     double d_Dr_dV_gi_bi=0.0;
  double Rdsi=0.0;
     double d_Rdsi_dTemp_t_GND=0.0;
     double d_Rdsi_dV_gi_bi=0.0;
     double d_Rdsi_dV_di_bi=0.0;
     double d_Rdsi_dV_si_bi=0.0;
  double Rdrain=0.0;
     double d_Rdrain_dTemp_t_GND=0.0;
     double d_Rdrain_dV_gi_bi=0.0;
     double d_Rdrain_dV_di_bi=0.0;
     double d_Rdrain_dV_si_bi=0.0;
  double Rsource=0.0;
     double d_Rsource_dTemp_t_GND=0.0;
     double d_Rsource_dV_gi_bi=0.0;
     double d_Rsource_dV_di_bi=0.0;
     double d_Rsource_dV_si_bi=0.0;
  double Dptwg=0.0;
     double d_Dptwg_dV_gi_bi=0.0;
     double d_Dptwg_dV_di_bi=0.0;
     double d_Dptwg_dV_si_bi=0.0;
     double d_Dptwg_dTemp_t_GND=0.0;
  double Dvsat=0.0;
     double d_Dvsat_dV_dbulk_di=0.0;
     double d_Dvsat_dV_sbulk_si=0.0;
     double d_Dvsat_dV_gi_bi=0.0;
     double d_Dvsat_dV_di_bi=0.0;
     double d_Dvsat_dV_si_bi=0.0;
     double d_Dvsat_dTemp_t_GND=0.0;
  double Mscbe=0.0;
     double d_Mscbe_dV_di_bi=0.0;
     double d_Mscbe_dV_si_bi=0.0;
     double d_Mscbe_dV_gi_bi=0.0;
     double d_Mscbe_dTemp_t_GND=0.0;
  double VaSCBE=0.0;
     double d_VaSCBE_dV_gi_bi=0.0;
     double d_VaSCBE_dV_di_bi=0.0;
     double d_VaSCBE_dV_si_bi=0.0;
     double d_VaSCBE_dTemp_t_GND=0.0;
  double VaDITS=0.0;
     double d_VaDITS_dV_gi_bi=0.0;
     double d_VaDITS_dV_di_bi=0.0;
     double d_VaDITS_dV_si_bi=0.0;
     double d_VaDITS_dTemp_t_GND=0.0;
  double MdL=0.0;
     double d_MdL_dV_dbulk_di=0.0;
     double d_MdL_dV_sbulk_si=0.0;
     double d_MdL_dV_gi_bi=0.0;
     double d_MdL_dV_di_bi=0.0;
     double d_MdL_dV_si_bi=0.0;
     double d_MdL_dTemp_t_GND=0.0;
  double Vasat=0.0;
     double d_Vasat_dV_dbulk_di=0.0;
     double d_Vasat_dV_sbulk_si=0.0;
     double d_Vasat_dV_gi_bi=0.0;
     double d_Vasat_dV_di_bi=0.0;
     double d_Vasat_dV_si_bi=0.0;
     double d_Vasat_dTemp_t_GND=0.0;
  double Fp=0.0;
     double d_Fp_dV_di_bi=0.0;
     double d_Fp_dV_si_bi=0.0;
     double d_Fp_dTemp_t_GND=0.0;
     double d_Fp_dV_gi_bi=0.0;
  double Moc=0.0;
     double d_Moc_dV_di_bi=0.0;
     double d_Moc_dV_si_bi=0.0;
     double d_Moc_dV_gi_bi=0.0;
     double d_Moc_dTemp_t_GND=0.0;
  double VaDIBL=0.0;
     double d_VaDIBL_dV_di_bi=0.0;
     double d_VaDIBL_dV_si_bi=0.0;
     double d_VaDIBL_dTemp_t_GND=0.0;
     double d_VaDIBL_dV_gi_bi=0.0;
  double Vgst2Vtm=0.0;
     double d_Vgst2Vtm_dV_di_bi=0.0;
     double d_Vgst2Vtm_dV_si_bi=0.0;
     double d_Vgst2Vtm_dTemp_t_GND=0.0;
     double d_Vgst2Vtm_dV_gi_bi=0.0;
  double diffVds=0.0;
     double d_diffVds_dV_dbulk_di=0.0;
     double d_diffVds_dV_sbulk_si=0.0;
     double d_diffVds_dV_di_bi=0.0;
     double d_diffVds_dV_si_bi=0.0;
     double d_diffVds_dV_gi_bi=0.0;
     double d_diffVds_dTemp_t_GND=0.0;
  double DIBLfactor=0.0;
     double d_DIBLfactor_dV_di_bi=0.0;
     double d_DIBLfactor_dV_si_bi=0.0;
     double d_DIBLfactor_dTemp_t_GND=0.0;
  double PVAGfactor=0.0;
     double d_PVAGfactor_dV_di_bi=0.0;
     double d_PVAGfactor_dV_si_bi=0.0;
     double d_PVAGfactor_dTemp_t_GND=0.0;
     double d_PVAGfactor_dV_gi_bi=0.0;
  double EsatL=0.0;
     double d_EsatL_dV_dbulk_di=0.0;
     double d_EsatL_dV_sbulk_si=0.0;
     double d_EsatL_dTemp_t_GND=0.0;
     double d_EsatL_dV_di_bi=0.0;
     double d_EsatL_dV_si_bi=0.0;
     double d_EsatL_dV_gi_bi=0.0;
  double Esat=0.0;
     double d_Esat_dV_dbulk_di=0.0;
     double d_Esat_dV_sbulk_si=0.0;
     double d_Esat_dTemp_t_GND=0.0;
     double d_Esat_dV_di_bi=0.0;
     double d_Esat_dV_si_bi=0.0;
     double d_Esat_dV_gi_bi=0.0;
  double Dmob=0.0;
     double d_Dmob_dV_dbulk_di=0.0;
     double d_Dmob_dV_sbulk_si=0.0;
     double d_Dmob_dV_gi_bi=0.0;
     double d_Dmob_dV_di_bi=0.0;
     double d_Dmob_dV_si_bi=0.0;
     double d_Dmob_dTemp_t_GND=0.0;
  double Eeffm=0.0;
     double d_Eeffm_dV_dbulk_di=0.0;
     double d_Eeffm_dV_sbulk_si=0.0;
     double d_Eeffm_dV_di_bi=0.0;
     double d_Eeffm_dV_si_bi=0.0;
     double d_Eeffm_dTemp_t_GND=0.0;
     double d_Eeffm_dV_gi_bi=0.0;
  double qia=0.0;
     double d_qia_dV_dbulk_di=0.0;
     double d_qia_dV_sbulk_si=0.0;
     double d_qia_dV_di_bi=0.0;
     double d_qia_dV_si_bi=0.0;
     double d_qia_dTemp_t_GND=0.0;
     double d_qia_dV_gi_bi=0.0;
  double qba=0.0;
     double d_qba_dV_di_bi=0.0;
     double d_qba_dV_si_bi=0.0;
     double d_qba_dTemp_t_GND=0.0;
     double d_qba_dV_gi_bi=0.0;
  double Qd=0.0;
     double d_Qd_dV_dbulk_di=0.0;
     double d_Qd_dV_sbulk_si=0.0;
     double d_Qd_dV_gi_bi=0.0;
     double d_Qd_dV_di_bi=0.0;
     double d_Qd_dV_si_bi=0.0;
     double d_Qd_dTemp_t_GND=0.0;
  double Qs=0.0;
     double d_Qs_dV_dbulk_di=0.0;
     double d_Qs_dV_sbulk_si=0.0;
     double d_Qs_dV_gi_bi=0.0;
     double d_Qs_dV_di_bi=0.0;
     double d_Qs_dV_si_bi=0.0;
     double d_Qs_dTemp_t_GND=0.0;
  double Qb=0.0;
     double d_Qb_dV_dbulk_di=0.0;
     double d_Qb_dV_sbulk_si=0.0;
     double d_Qb_dV_gi_bi=0.0;
     double d_Qb_dV_di_bi=0.0;
     double d_Qb_dV_si_bi=0.0;
     double d_Qb_dTemp_t_GND=0.0;
  double DQSD2=0.0;
     double d_DQSD2_dV_dbulk_di=0.0;
     double d_DQSD2_dV_sbulk_si=0.0;
     double d_DQSD2_dV_gi_bi=0.0;
     double d_DQSD2_dV_di_bi=0.0;
     double d_DQSD2_dV_si_bi=0.0;
     double d_DQSD2_dTemp_t_GND=0.0;
  double qdeff=0.0;
     double d_qdeff_dV_gm_si=0.0;
     double d_qdeff_dV_gm_di=0.0;
     double d_qdeff_dV_dbulk_di=0.0;
     double d_qdeff_dV_sbulk_si=0.0;
     double d_qdeff_dV_gi_bi=0.0;
     double d_qdeff_dV_di_bi=0.0;
     double d_qdeff_dV_si_bi=0.0;
     double d_qdeff_dTemp_t_GND=0.0;
  double vdeff=0.0;
     double d_vdeff_dV_gm_di=0.0;
     double d_vdeff_dV_gm_si=0.0;
     double d_vdeff_dV_dbulk_di=0.0;
     double d_vdeff_dV_sbulk_si=0.0;
     double d_vdeff_dV_di_bi=0.0;
     double d_vdeff_dV_si_bi=0.0;
     double d_vdeff_dV_gi_bi=0.0;
     double d_vdeff_dTemp_t_GND=0.0;
  double Vdseff=0.0;
     double d_Vdseff_dV_gm_di=0.0;
     double d_Vdseff_dV_gm_si=0.0;
     double d_Vdseff_dV_dbulk_di=0.0;
     double d_Vdseff_dV_sbulk_si=0.0;
     double d_Vdseff_dV_di_bi=0.0;
     double d_Vdseff_dV_si_bi=0.0;
     double d_Vdseff_dV_gi_bi=0.0;
     double d_Vdseff_dTemp_t_GND=0.0;
  double Vdssat=0.0;
     double d_Vdssat_dV_gi_bi=0.0;
     double d_Vdssat_dV_di_bi=0.0;
     double d_Vdssat_dV_si_bi=0.0;
     double d_Vdssat_dTemp_t_GND=0.0;
  double Vdsat=0.0;
     double d_Vdsat_dV_gi_bi=0.0;
     double d_Vdsat_dV_di_bi=0.0;
     double d_Vdsat_dV_si_bi=0.0;
     double d_Vdsat_dTemp_t_GND=0.0;
  double vdsat=0.0;
     double d_vdsat_dV_gi_bi=0.0;
     double d_vdsat_dV_di_bi=0.0;
     double d_vdsat_dV_si_bi=0.0;
     double d_vdsat_dTemp_t_GND=0.0;
  double qdsat=0.0;
     double d_qdsat_dV_dbulk_di=0.0;
     double d_qdsat_dV_sbulk_si=0.0;
     double d_qdsat_dV_gi_bi=0.0;
     double d_qdsat_dV_di_bi=0.0;
     double d_qdsat_dV_si_bi=0.0;
     double d_qdsat_dTemp_t_GND=0.0;
  double ln_T1_T2=0.0;
     double d_ln_T1_T2_dV_gi_bi=0.0;
     double d_ln_T1_T2_dV_di_bi=0.0;
     double d_ln_T1_T2_dV_si_bi=0.0;
     double d_ln_T1_T2_dTemp_t_GND=0.0;
  double T12=0.0;
     double d_T12_dV_gi_bi=0.0;
     double d_T12_dTemp_t_GND=0.0;
     double d_T12_dV_di_bi=0.0;
     double d_T12_dV_si_bi=0.0;
  double T11=0.0;
     double d_T11_dV_gi_bi=0.0;
     double d_T11_dTemp_t_GND=0.0;
     double d_T11_dV_di_bi=0.0;
     double d_T11_dV_si_bi=0.0;
  double LambdaC=0.0;
     double d_LambdaC_dV_dbulk_di=0.0;
     double d_LambdaC_dV_sbulk_si=0.0;
     double d_LambdaC_dTemp_t_GND=0.0;
     double d_LambdaC_dV_di_bi=0.0;
     double d_LambdaC_dV_si_bi=0.0;
     double d_LambdaC_dV_gi_bi=0.0;
  double Rdss=0.0;
     double d_Rdss_dV_gi_bi=0.0;
     double d_Rdss_dV_di_bi=0.0;
     double d_Rdss_dV_si_bi=0.0;
     double d_Rdss_dTemp_t_GND=0.0;
  double WeffWRFactor=0.0;
  double Dmobs=0.0;
     double d_Dmobs_dV_dbulk_di=0.0;
     double d_Dmobs_dV_sbulk_si=0.0;
     double d_Dmobs_dV_gi_bi=0.0;
     double d_Dmobs_dV_di_bi=0.0;
     double d_Dmobs_dV_si_bi=0.0;
     double d_Dmobs_dTemp_t_GND=0.0;
  double Eeffs=0.0;
     double d_Eeffs_dV_dbulk_di=0.0;
     double d_Eeffs_dV_sbulk_si=0.0;
     double d_Eeffs_dV_gi_bi=0.0;
     double d_Eeffs_dV_di_bi=0.0;
     double d_Eeffs_dV_si_bi=0.0;
     double d_Eeffs_dTemp_t_GND=0.0;
  double qis=0.0;
     double d_qis_dV_dbulk_di=0.0;
     double d_qis_dV_sbulk_si=0.0;
     double d_qis_dV_gi_bi=0.0;
     double d_qis_dTemp_t_GND=0.0;
     double d_qis_dV_di_bi=0.0;
     double d_qis_dV_si_bi=0.0;
  double qbs=0.0;
     double d_qbs_dV_dbulk_di=0.0;
     double d_qbs_dV_sbulk_si=0.0;
     double d_qbs_dV_gi_bi=0.0;
     double d_qbs_dV_di_bi=0.0;
     double d_qbs_dV_si_bi=0.0;
     double d_qbs_dTemp_t_GND=0.0;
  double EeffFactor=0.0;
  double psiavg=0.0;
     double d_psiavg_dV_gm_di=0.0;
     double d_psiavg_dV_gm_si=0.0;
     double d_psiavg_dV_dbulk_di=0.0;
     double d_psiavg_dV_sbulk_si=0.0;
     double d_psiavg_dV_gi_bi=0.0;
     double d_psiavg_dV_di_bi=0.0;
     double d_psiavg_dV_si_bi=0.0;
     double d_psiavg_dTemp_t_GND=0.0;
  double psipclamp=0.0;
     double d_psipclamp_dV_gm_di=0.0;
     double d_psipclamp_dV_gm_si=0.0;
     double d_psipclamp_dV_dbulk_di=0.0;
     double d_psipclamp_dV_sbulk_si=0.0;
     double d_psipclamp_dV_gi_bi=0.0;
     double d_psipclamp_dV_di_bi=0.0;
     double d_psipclamp_dV_si_bi=0.0;
     double d_psipclamp_dTemp_t_GND=0.0;
  double qs=0.0;
     double d_qs_dV_gm_si=0.0;
     double d_qs_dV_gm_di=0.0;
     double d_qs_dV_dbulk_di=0.0;
     double d_qs_dV_sbulk_si=0.0;
     double d_qs_dV_gi_bi=0.0;
     double d_qs_dV_di_bi=0.0;
     double d_qs_dV_si_bi=0.0;
     double d_qs_dTemp_t_GND=0.0;
  double T6=0.0;
     double d_T6_dV_gm_di=0.0;
     double d_T6_dV_gm_si=0.0;
     double d_T6_dV_dbulk_di=0.0;
     double d_T6_dV_sbulk_si=0.0;
     double d_T6_dV_gi_bi=0.0;
     double d_T6_dV_di_bi=0.0;
     double d_T6_dV_si_bi=0.0;
     double d_T6_dTemp_t_GND=0.0;
  double T5=0.0;
     double d_T5_dV_gm_si=0.0;
     double d_T5_dV_gm_di=0.0;
     double d_T5_dV_dbulk_di=0.0;
     double d_T5_dV_sbulk_si=0.0;
     double d_T5_dV_gi_bi=0.0;
     double d_T5_dV_di_bi=0.0;
     double d_T5_dV_si_bi=0.0;
     double d_T5_dTemp_t_GND=0.0;
  double T7=0.0;
     double d_T7_dV_gm_si=0.0;
     double d_T7_dV_gm_di=0.0;
     double d_T7_dV_dbulk_di=0.0;
     double d_T7_dV_sbulk_si=0.0;
     double d_T7_dV_gi_bi=0.0;
     double d_T7_dV_di_bi=0.0;
     double d_T7_dV_si_bi=0.0;
     double d_T7_dTemp_t_GND=0.0;
  double sqrtpsisainv=0.0;
     double d_sqrtpsisainv_dV_gm_di=0.0;
     double d_sqrtpsisainv_dV_gm_si=0.0;
     double d_sqrtpsisainv_dV_dbulk_di=0.0;
     double d_sqrtpsisainv_dV_sbulk_si=0.0;
     double d_sqrtpsisainv_dV_gi_bi=0.0;
     double d_sqrtpsisainv_dV_di_bi=0.0;
     double d_sqrtpsisainv_dV_si_bi=0.0;
     double d_sqrtpsisainv_dTemp_t_GND=0.0;
  double sqrtpsisa=0.0;
     double d_sqrtpsisa_dV_gm_di=0.0;
     double d_sqrtpsisa_dV_gm_si=0.0;
     double d_sqrtpsisa_dV_dbulk_di=0.0;
     double d_sqrtpsisa_dV_sbulk_si=0.0;
     double d_sqrtpsisa_dV_gi_bi=0.0;
     double d_sqrtpsisa_dV_di_bi=0.0;
     double d_sqrtpsisa_dV_si_bi=0.0;
     double d_sqrtpsisa_dTemp_t_GND=0.0;
  double T9=0.0;
     double d_T9_dV_gm_si=0.0;
     double d_T9_dV_gm_di=0.0;
     double d_T9_dV_dbulk_di=0.0;
     double d_T9_dV_sbulk_si=0.0;
     double d_T9_dV_di_bi=0.0;
     double d_T9_dV_si_bi=0.0;
     double d_T9_dTemp_t_GND=0.0;
     double d_T9_dV_gi_bi=0.0;
  double sqrtpsip=0.0;
     double d_sqrtpsip_dV_gm_di=0.0;
     double d_sqrtpsip_dV_gm_si=0.0;
     double d_sqrtpsip_dV_dbulk_di=0.0;
     double d_sqrtpsip_dV_sbulk_si=0.0;
     double d_sqrtpsip_dV_gi_bi=0.0;
     double d_sqrtpsip_dV_di_bi=0.0;
     double d_sqrtpsip_dV_si_bi=0.0;
     double d_sqrtpsip_dTemp_t_GND=0.0;
  double T8=0.0;
     double d_T8_dV_gm_di=0.0;
     double d_T8_dV_gm_si=0.0;
     double d_T8_dV_dbulk_di=0.0;
     double d_T8_dV_sbulk_si=0.0;
     double d_T8_dV_gi_bi=0.0;
     double d_T8_dV_di_bi=0.0;
     double d_T8_dV_si_bi=0.0;
     double d_T8_dTemp_t_GND=0.0;
  double psip=0.0;
     double d_psip_dV_gm_di=0.0;
     double d_psip_dV_gm_si=0.0;
     double d_psip_dV_dbulk_di=0.0;
     double d_psip_dV_sbulk_si=0.0;
     double d_psip_dV_gi_bi=0.0;
     double d_psip_dV_di_bi=0.0;
     double d_psip_dV_si_bi=0.0;
     double d_psip_dTemp_t_GND=0.0;
  double gammaPD=0.0;
     double d_gammaPD_dV_gm_si=0.0;
     double d_gammaPD_dV_dbulk_di=0.0;
     double d_gammaPD_dV_sbulk_si=0.0;
     double d_gammaPD_dV_gi_bi=0.0;
     double d_gammaPD_dV_di_bi=0.0;
     double d_gammaPD_dV_si_bi=0.0;
     double d_gammaPD_dTemp_t_GND=0.0;
  double vgfbPD=0.0;
     double d_vgfbPD_dV_gm_si=0.0;
     double d_vgfbPD_dV_dbulk_di=0.0;
     double d_vgfbPD_dV_sbulk_si=0.0;
     double d_vgfbPD_dV_gi_bi=0.0;
     double d_vgfbPD_dV_di_bi=0.0;
     double d_vgfbPD_dV_si_bi=0.0;
     double d_vgfbPD_dTemp_t_GND=0.0;
  double phib_n=0.0;
     double d_phib_n_dV_gm_si=0.0;
     double d_phib_n_dV_dbulk_di=0.0;
     double d_phib_n_dV_sbulk_si=0.0;
     double d_phib_n_dV_gi_bi=0.0;
     double d_phib_n_dTemp_t_GND=0.0;
     double d_phib_n_dV_di_bi=0.0;
     double d_phib_n_dV_si_bi=0.0;
  double inv_gam=0.0;
     double d_inv_gam_dV_gm_si=0.0;
     double d_inv_gam_dV_dbulk_di=0.0;
     double d_inv_gam_dV_sbulk_si=0.0;
     double d_inv_gam_dV_gi_bi=0.0;
     double d_inv_gam_dV_di_bi=0.0;
     double d_inv_gam_dV_si_bi=0.0;
     double d_inv_gam_dTemp_t_GND=0.0;
  double psip_th=0.0;
  double nq=0.0;
     double d_nq_dV_gm_si=0.0;
     double d_nq_dV_gm_di=0.0;
     double d_nq_dV_dbulk_di=0.0;
     double d_nq_dV_sbulk_si=0.0;
     double d_nq_dV_gi_bi=0.0;
     double d_nq_dTemp_t_GND=0.0;
     double d_nq_dV_di_bi=0.0;
     double d_nq_dV_si_bi=0.0;
  double q_vth=0.0;
  double gam=0.0;
     double d_gam_dV_gm_si=0.0;
     double d_gam_dV_dbulk_di=0.0;
     double d_gam_dV_sbulk_si=0.0;
     double d_gam_dV_gi_bi=0.0;
     double d_gam_dV_di_bi=0.0;
     double d_gam_dV_si_bi=0.0;
     double d_gam_dTemp_t_GND=0.0;
  double vgfb=0.0;
     double d_vgfb_dV_gm_si=0.0;
     double d_vgfb_dV_dbulk_di=0.0;
     double d_vgfb_dV_sbulk_si=0.0;
     double d_vgfb_dV_gi_bi=0.0;
     double d_vgfb_dV_di_bi=0.0;
     double d_vgfb_dV_si_bi=0.0;
     double d_vgfb_dTemp_t_GND=0.0;
  double Vth_shift=0.0;
     double d_Vth_shift_dTemp_t_GND=0.0;
     double d_Vth_shift_dV_di_bi=0.0;
     double d_Vth_shift_dV_si_bi=0.0;
  double dVth_VNUD=0.0;
     double d_dVth_VNUD_dTemp_t_GND=0.0;
     double d_dVth_VNUD_dV_di_bi=0.0;
     double d_dVth_VNUD_dV_si_bi=0.0;
  double vfb=0.0;
     double d_vfb_dV_gm_si=0.0;
     double d_vfb_dV_dbulk_di=0.0;
     double d_vfb_dV_sbulk_si=0.0;
     double d_vfb_dV_gi_bi=0.0;
     double d_vfb_dV_di_bi=0.0;
     double d_vfb_dV_si_bi=0.0;
     double d_vfb_dTemp_t_GND=0.0;
  double vs=0.0;
     double d_vs_dV_gm_si=0.0;
     double d_vs_dV_dbulk_di=0.0;
     double d_vs_dV_sbulk_si=0.0;
     double d_vs_dV_gi_bi=0.0;
     double d_vs_dV_di_bi=0.0;
     double d_vs_dV_si_bi=0.0;
     double d_vs_dTemp_t_GND=0.0;
  double vg=0.0;
     double d_vg_dV_gm_si=0.0;
     double d_vg_dV_dbulk_di=0.0;
     double d_vg_dV_sbulk_si=0.0;
     double d_vg_dV_gi_bi=0.0;
     double d_vg_dV_di_bi=0.0;
     double d_vg_dV_si_bi=0.0;
     double d_vg_dTemp_t_GND=0.0;
  double T4=0.0;
     double d_T4_dV_gm_si=0.0;
     double d_T4_dV_gm_di=0.0;
     double d_T4_dV_dbulk_di=0.0;
     double d_T4_dV_sbulk_si=0.0;
     double d_T4_dV_gi_bi=0.0;
     double d_T4_dV_di_bi=0.0;
     double d_T4_dV_si_bi=0.0;
     double d_T4_dTemp_t_GND=0.0;
  double dVth_ldop=0.0;
     double d_dVth_ldop_dV_di_bi=0.0;
     double d_dVth_ldop_dV_si_bi=0.0;
     double d_dVth_ldop_dTemp_t_GND=0.0;
  double dvth_temp=0.0;
     double d_dvth_temp_dV_di_bi=0.0;
     double d_dvth_temp_dV_si_bi=0.0;
     double d_dvth_temp_dTemp_t_GND=0.0;
  double dVth_dibl=0.0;
     double d_dVth_dibl_dTemp_t_GND=0.0;
     double d_dVth_dibl_dV_di_bi=0.0;
     double d_dVth_dibl_dV_si_bi=0.0;
  double inv_nVt=0.0;
     double d_inv_nVt_dV_gm_si=0.0;
     double d_inv_nVt_dV_dbulk_di=0.0;
     double d_inv_nVt_dV_sbulk_si=0.0;
     double d_inv_nVt_dV_gi_bi=0.0;
     double d_inv_nVt_dV_di_bi=0.0;
     double d_inv_nVt_dV_si_bi=0.0;
     double d_inv_nVt_dTemp_t_GND=0.0;
  double nVt=0.0;
     double d_nVt_dV_gm_si=0.0;
     double d_nVt_dV_dbulk_di=0.0;
     double d_nVt_dV_sbulk_si=0.0;
     double d_nVt_dV_gi_bi=0.0;
     double d_nVt_dV_di_bi=0.0;
     double d_nVt_dV_si_bi=0.0;
     double d_nVt_dTemp_t_GND=0.0;
  double n=0.0;
     double d_n_dV_gm_si=0.0;
     double d_n_dV_dbulk_di=0.0;
     double d_n_dV_sbulk_si=0.0;
     double d_n_dV_gi_bi=0.0;
     double d_n_dV_di_bi=0.0;
     double d_n_dV_si_bi=0.0;
     double d_n_dTemp_t_GND=0.0;
  double cdsc=0.0;
     double d_cdsc_dTemp_t_GND=0.0;
     double d_cdsc_dV_di_bi=0.0;
     double d_cdsc_dV_si_bi=0.0;
  double Cdep=0.0;
     double d_Cdep_dTemp_t_GND=0.0;
     double d_Cdep_dV_di_bi=0.0;
     double d_Cdep_dV_si_bi=0.0;
  double Xdep=0.0;
     double d_Xdep_dTemp_t_GND=0.0;
     double d_Xdep_dV_di_bi=0.0;
     double d_Xdep_dV_si_bi=0.0;
  double sqrtPhistVbs=0.0;
     double d_sqrtPhistVbs_dTemp_t_GND=0.0;
     double d_sqrtPhistVbs_dV_di_bi=0.0;
     double d_sqrtPhistVbs_dV_si_bi=0.0;
  double PhistVbs=0.0;
     double d_PhistVbs_dTemp_t_GND=0.0;
     double d_PhistVbs_dV_di_bi=0.0;
     double d_PhistVbs_dV_si_bi=0.0;
  double UCS_a=0.0;
     double d_UCS_a_dTemp_t_GND=0.0;
     double d_UCS_a_dV_di_bi=0.0;
     double d_UCS_a_dV_si_bi=0.0;
  double UC_a=0.0;
     double d_UC_a_dTemp_t_GND=0.0;
     double d_UC_a_dV_di_bi=0.0;
     double d_UC_a_dV_si_bi=0.0;
  double UA_a=0.0;
     double d_UA_a_dTemp_t_GND=0.0;
     double d_UA_a_dV_di_bi=0.0;
     double d_UA_a_dV_si_bi=0.0;
  double U0_a=0.0;
     double d_U0_a_dTemp_t_GND=0.0;
     double d_U0_a_dV_di_bi=0.0;
     double d_U0_a_dV_si_bi=0.0;
  double PTWG_a=0.0;
     double d_PTWG_a_dTemp_t_GND=0.0;
     double d_PTWG_a_dV_di_bi=0.0;
     double d_PTWG_a_dV_si_bi=0.0;
  double VSAT_a=0.0;
     double d_VSAT_a_dTemp_t_GND=0.0;
     double d_VSAT_a_dV_di_bi=0.0;
     double d_VSAT_a_dV_si_bi=0.0;
  double PSAT_a=0.0;
     double d_PSAT_a_dV_di_bi=0.0;
     double d_PSAT_a_dV_si_bi=0.0;
     double d_PSAT_a_dTemp_t_GND=0.0;
  double PCLM_a=0.0;
     double d_PCLM_a_dV_di_bi=0.0;
     double d_PCLM_a_dV_si_bi=0.0;
     double d_PCLM_a_dTemp_t_GND=0.0;
  double PDIBLC_a=0.0;
     double d_PDIBLC_a_dV_di_bi=0.0;
     double d_PDIBLC_a_dV_si_bi=0.0;
     double d_PDIBLC_a_dTemp_t_GND=0.0;
  double ETA0_a=0.0;
     double d_ETA0_a_dTemp_t_GND=0.0;
     double d_ETA0_a_dV_di_bi=0.0;
     double d_ETA0_a_dV_si_bi=0.0;
  double CDSCD_a=0.0;
     double d_CDSCD_a_dV_di_bi=0.0;
     double d_CDSCD_a_dV_si_bi=0.0;
     double d_CDSCD_a_dTemp_t_GND=0.0;
  double wr=0.0;
     double d_wr_dV_di_bi=0.0;
     double d_wr_dV_si_bi=0.0;
     double d_wr_dTemp_t_GND=0.0;
  double wf=0.0;
     double d_wf_dV_di_bi=0.0;
     double d_wf_dV_si_bi=0.0;
     double d_wf_dTemp_t_GND=0.0;
  double Vbsx=0.0;
     double d_Vbsx_dV_di_bi=0.0;
     double d_Vbsx_dV_si_bi=0.0;
  double Vdsx=0.0;
     double d_Vdsx_dV_di_bi=0.0;
     double d_Vdsx_dV_si_bi=0.0;
  double sigvds=0.0;
  double Vgs_ov_noswap=0.0;
     double d_Vgs_ov_noswap_dV_gm_si=0.0;
  double Vgd_ov_noswap=0.0;
     double d_Vgd_ov_noswap_dV_gm_di=0.0;
  double Vgs_noswap=0.0;
     double d_Vgs_noswap_dV_gi_bi=0.0;
     double d_Vgs_noswap_dV_si_bi=0.0;
  double Vgd_noswap=0.0;
     double d_Vgd_noswap_dV_gi_bi=0.0;
     double d_Vgd_noswap_dV_di_bi=0.0;
  double Vbd_jct=0.0;
     double d_Vbd_jct_dV_dbulk_di=0.0;
  double Vbs_jct=0.0;
     double d_Vbs_jct_dV_sbulk_si=0.0;
  double Vdb_noswap=0.0;
     double d_Vdb_noswap_dV_di_bi=0.0;
  double Vsb_noswap=0.0;
     double d_Vsb_noswap_dV_si_bi=0.0;
  double Vds_noswap=0.0;
     double d_Vds_noswap_dV_di_bi=0.0;
     double d_Vds_noswap_dV_si_bi=0.0;
  double Vds=0.0;
     double d_Vds_dV_di_bi=0.0;
     double d_Vds_dV_si_bi=0.0;
  double Vs=0.0;
     double d_Vs_dV_di_bi=0.0;
     double d_Vs_dV_si_bi=0.0;
  double Vd=0.0;
     double d_Vd_dV_si_bi=0.0;
     double d_Vd_dV_di_bi=0.0;
  double Vg=0.0;
     double d_Vg_dV_gi_bi=0.0;
  double mu_well=0.0;
     double d_mu_well_dTemp_t_GND=0.0;
  double k2_well=0.0;
     double d_k2_well_dTemp_t_GND=0.0;
  double vth0_well=0.0;
     double d_vth0_well_dTemp_t_GND=0.0;
  double Wdrn=0.0;
  double local_scc=0.0;
     double d_local_scc_dTemp_t_GND=0.0;
  double local_scb=0.0;
     double d_local_scb_dTemp_t_GND=0.0;
  double local_sca=0.0;
     double d_local_sca_dTemp_t_GND=0.0;
  double eta_stress=0.0;
     double d_eta_stress_dTemp_t_GND=0.0;
  double k2_stress=0.0;
     double d_k2_stress_dTemp_t_GND=0.0;
  double vth0_stress=0.0;
     double d_vth0_stress_dTemp_t_GND=0.0;
  double vsat_mult=0.0;
     double d_vsat_mult_dTemp_t_GND=0.0;
  double mu0_mult=0.0;
     double d_mu0_mult_dTemp_t_GND=0.0;
  double rho=0.0;
     double d_rho_dTemp_t_GND=0.0;
  double Inv_od=0.0;
     double d_Inv_od_dTemp_t_GND=0.0;
  double rho_ref=0.0;
     double d_rho_ref_dTemp_t_GND=0.0;
  double Inv_odref=0.0;
  double Inv_sbref=0.0;
  double Inv_saref=0.0;
  int i=0.0;
  double Inv_sb=0.0;
     double d_Inv_sb_dTemp_t_GND=0.0;
  double Inv_sa=0.0;
     double d_Inv_sa_dTemp_t_GND=0.0;
  double ku0_temp=0.0;
     double d_ku0_temp_dTemp_t_GND=0.0;
  double kstress_vth0=0.0;
     double d_kstress_vth0_dTemp_t_GND=0.0;
  double tmp1_stress_vth=0.0;
     double d_tmp1_stress_vth_dTemp_t_GND=0.0;
  double kstress_u0=0.0;
     double d_kstress_u0_dTemp_t_GND=0.0;
  double tmp1_stress=0.0;
     double d_tmp1_stress_dTemp_t_GND=0.0;
  double W_tmp_stress=0.0;
  double Czbdswg=0.0;
     double d_Czbdswg_dTemp_t_GND=0.0;
  double Czbdsw=0.0;
     double d_Czbdsw_dTemp_t_GND=0.0;
  double Czbd=0.0;
     double d_Czbd_dTemp_t_GND=0.0;
  double Czbsswg=0.0;
     double d_Czbsswg_dTemp_t_GND=0.0;
  double Czbssw=0.0;
     double d_Czbssw_dTemp_t_GND=0.0;
  double Czbs=0.0;
     double d_Czbs_dTemp_t_GND=0.0;
  double DslpRev=0.0;
     double d_DslpRev_dTemp_t_GND=0.0;
  double IVjdmRev=0.0;
     double d_IVjdmRev_dTemp_t_GND=0.0;
  double VjdmRev=0.0;
     double d_VjdmRev_dTemp_t_GND=0.0;
  double DslpFwd=0.0;
     double d_DslpFwd_dTemp_t_GND=0.0;
  double IVjdmFwd=0.0;
     double d_IVjdmFwd_dTemp_t_GND=0.0;
  double VjdmFwd=0.0;
     double d_VjdmFwd_dTemp_t_GND=0.0;
  double XExpBVD=0.0;
     double d_XExpBVD_dTemp_t_GND=0.0;
  double Nvtmd=0.0;
     double d_Nvtmd_dTemp_t_GND=0.0;
  double Isbd=0.0;
     double d_Isbd_dTemp_t_GND=0.0;
  double SslpRev=0.0;
     double d_SslpRev_dTemp_t_GND=0.0;
  double IVjsmRev=0.0;
     double d_IVjsmRev_dTemp_t_GND=0.0;
  double VjsmRev=0.0;
     double d_VjsmRev_dTemp_t_GND=0.0;
  double SslpFwd=0.0;
     double d_SslpFwd_dTemp_t_GND=0.0;
  double IVjsmFwd=0.0;
     double d_IVjsmFwd_dTemp_t_GND=0.0;
  double VjsmFwd=0.0;
     double d_VjsmFwd_dTemp_t_GND=0.0;
  double Tb=0.0;
     double d_Tb_dTemp_t_GND=0.0;
  double XExpBVS=0.0;
     double d_XExpBVS_dTemp_t_GND=0.0;
  double Nvtms=0.0;
     double d_Nvtms_dTemp_t_GND=0.0;
  double Isbs=0.0;
     double d_Isbs_dTemp_t_GND=0.0;
  double PDeff=0.0;
     double d_PDeff_dTemp_t_GND=0.0;
  double PSeff=0.0;
     double d_PSeff_dTemp_t_GND=0.0;
  double ADeff=0.0;
     double d_ADeff_dTemp_t_GND=0.0;
  double ASeff=0.0;
     double d_ASeff_dTemp_t_GND=0.0;
  double PSiso=0.0;
     double d_PSiso_dTemp_t_GND=0.0;
  double PDiso=0.0;
     double d_PDiso_dTemp_t_GND=0.0;
  double PSsha=0.0;
     double d_PSsha_dTemp_t_GND=0.0;
  double PDsha=0.0;
     double d_PDsha_dTemp_t_GND=0.0;
  double PSmer=0.0;
  double PDmer=0.0;
  double ASiso=0.0;
     double d_ASiso_dTemp_t_GND=0.0;
  double ADiso=0.0;
     double d_ADiso_dTemp_t_GND=0.0;
  double ASsha=0.0;
  double ADsha=0.0;
  double ASmer=0.0;
  double ADmer=0.0;
  double temp_ADeff=0.0;
     double d_temp_ADeff_dTemp_t_GND=0.0;
  double temp_ASeff=0.0;
     double d_temp_ASeff_dTemp_t_GND=0.0;
  double temp_PDeff=0.0;
     double d_temp_PDeff_dTemp_t_GND=0.0;
  double temp_PSeff=0.0;
     double d_temp_PSeff_dTemp_t_GND=0.0;
  double NJTSSWGD_t=0.0;
     double d_NJTSSWGD_t_dTemp_t_GND=0.0;
  double NJTSSWD_t=0.0;
     double d_NJTSSWD_t_dTemp_t_GND=0.0;
  double NJTSD_t=0.0;
     double d_NJTSD_t_dTemp_t_GND=0.0;
  double NJTSSWG_t=0.0;
     double d_NJTSSWG_t_dTemp_t_GND=0.0;
  double NJTSSW_t=0.0;
     double d_NJTSSW_t_dTemp_t_GND=0.0;
  double NJTS_t=0.0;
     double d_NJTS_t_dTemp_t_GND=0.0;
  double JTSSWGD_t=0.0;
     double d_JTSSWGD_t_dTemp_t_GND=0.0;
  double JTSSWD_t=0.0;
     double d_JTSSWD_t_dTemp_t_GND=0.0;
  double JTSD_t=0.0;
     double d_JTSD_t_dTemp_t_GND=0.0;
  double JTSSWGS_t=0.0;
     double d_JTSSWGS_t_dTemp_t_GND=0.0;
  double JTSSWS_t=0.0;
     double d_JTSSWS_t_dTemp_t_GND=0.0;
  double JTSS_t=0.0;
     double d_JTSS_t_dTemp_t_GND=0.0;
  double JSWGD_t=0.0;
     double d_JSWGD_t_dTemp_t_GND=0.0;
  double JSWD_t=0.0;
     double d_JSWD_t_dTemp_t_GND=0.0;
  double JSD_t=0.0;
     double d_JSD_t_dTemp_t_GND=0.0;
  double JSWGS_t=0.0;
     double d_JSWGS_t_dTemp_t_GND=0.0;
  double JSWS_t=0.0;
     double d_JSWS_t_dTemp_t_GND=0.0;
  double JSS_t=0.0;
     double d_JSS_t_dTemp_t_GND=0.0;
  double T3=0.0;
     double d_T3_dV_gm_si=0.0;
     double d_T3_dV_gm_di=0.0;
     double d_T3_dV_dbulk_di=0.0;
     double d_T3_dV_sbulk_si=0.0;
     double d_T3_dV_gi_bi=0.0;
     double d_T3_dV_di_bi=0.0;
     double d_T3_dV_si_bi=0.0;
     double d_T3_dTemp_t_GND=0.0;
  double PBSWGD_t=0.0;
     double d_PBSWGD_t_dTemp_t_GND=0.0;
  double PBSWGS_t=0.0;
     double d_PBSWGS_t_dTemp_t_GND=0.0;
  double PBSWD_t=0.0;
     double d_PBSWD_t_dTemp_t_GND=0.0;
  double PBSWS_t=0.0;
     double d_PBSWS_t_dTemp_t_GND=0.0;
  double PBD_t=0.0;
     double d_PBD_t_dTemp_t_GND=0.0;
  double PBS_t=0.0;
     double d_PBS_t_dTemp_t_GND=0.0;
  double CJSWGD_t=0.0;
     double d_CJSWGD_t_dTemp_t_GND=0.0;
  double CJSWGS_t=0.0;
     double d_CJSWGS_t_dTemp_t_GND=0.0;
  double CJSWD_t=0.0;
     double d_CJSWD_t_dTemp_t_GND=0.0;
  double CJSWS_t=0.0;
     double d_CJSWS_t_dTemp_t_GND=0.0;
  double CJD_t=0.0;
     double d_CJD_t_dTemp_t_GND=0.0;
  double CJS_t=0.0;
     double d_CJS_t_dTemp_t_GND=0.0;
  double igtemp=0.0;
     double d_igtemp_dTemp_t_GND=0.0;
  double BGISL_t=0.0;
     double d_BGISL_t_dTemp_t_GND=0.0;
  double BGIDL_t=0.0;
     double d_BGIDL_t_dTemp_t_GND=0.0;
  double BETA0_t=0.0;
     double d_BETA0_t_dTemp_t_GND=0.0;
  double A2_t=0.0;
     double d_A2_t_dTemp_t_GND=0.0;
  double A1_t=0.0;
     double d_A1_t_dTemp_t_GND=0.0;
  double PTWG_t=0.0;
     double d_PTWG_t_dTemp_t_GND=0.0;
  double DELTA_t=0.0;
     double d_DELTA_t_dTemp_t_GND=0.0;
  double VSATCV_t=0.0;
     double d_VSATCV_t_dTemp_t_GND=0.0;
  double VSAT_t=0.0;
     double d_VSAT_t_dTemp_t_GND=0.0;
  double rdstemp=0.0;
     double d_rdstemp_dTemp_t_GND=0.0;
  double UCS_t=0.0;
     double d_UCS_t_dTemp_t_GND=0.0;
  double UD_t=0.0;
     double d_UD_t_dTemp_t_GND=0.0;
  double UC_t=0.0;
     double d_UC_t_dTemp_t_GND=0.0;
  double UA_t=0.0;
     double d_UA_t_dTemp_t_GND=0.0;
  double U0_t=0.0;
     double d_U0_t_dTemp_t_GND=0.0;
  double eta_mu=0.0;
  double ETA0_t=0.0;
     double d_ETA0_t_dTemp_t_GND=0.0;
  double NFACTOR_t=0.0;
     double d_NFACTOR_t_dTemp_t_GND=0.0;
  double litl=0.0;
  double T1DEP=0.0;
  double sqrtPhist=0.0;
     double d_sqrtPhist_dTemp_t_GND=0.0;
  double Phist=0.0;
     double d_Phist_dTemp_t_GND=0.0;
  double Vfbsdr=0.0;
     double d_Vfbsdr_dTemp_t_GND=0.0;
  double Vbi=0.0;
     double d_Vbi_dTemp_t_GND=0.0;
  double phib=0.0;
     double d_phib_dTemp_t_GND=0.0;
  double ni=0.0;
     double d_ni_dTemp_t_GND=0.0;
  double Eg0=0.0;
  double Eg=0.0;
     double d_Eg_dTemp_t_GND=0.0;
  double Vtm0=0.0;
  double Vtm=0.0;
     double d_Vtm_dTemp_t_GND=0.0;
  double delTemp=0.0;
     double d_delTemp_dTemp_t_GND=0.0;
  double TRatio=0.0;
     double d_TRatio_dTemp_t_GND=0.0;
  double inv_Vt=0.0;
     double d_inv_Vt_dTemp_t_GND=0.0;
  double Vt=0.0;
     double d_Vt_dTemp_t_GND=0.0;
  double delTemp1=0.0;
     double d_delTemp1_dTemp_t_GND=0.0;
  double DevTemp=0.0;
     double d_DevTemp_dTemp_t_GND=0.0;
  double Tnom=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (29))
  {
    probeVars.resize(29);
    d_probeVars.resize(29);
    for (int i=0;i<29;i++)
    {
      d_probeVars[i].resize(29);
      for (int j=0;j<29;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(14+0);
    d_staticContributions.resize(14+0);
    for (int i=0;i<14+0;i++)
      d_staticContributions[i].resize(29);
    dynamicContributions.resize(14+0);
    d_dynamicContributions.resize(14+0);
    for (int i=0;i<14+0;i++)
      d_dynamicContributions[i].resize(29);
  }

    noiseContribsPower.resize(16);
    noiseContribsExponent.resize(16);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 14+0 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<29;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<29;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_bi_dbulk] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_dbulk];
d_probeVars[admsProbeID_V_bi_dbulk][admsProbeID_V_bi_dbulk] = 1.0;
probeVars[admsProbeID_V_b_dbulk] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_dbulk];
d_probeVars[admsProbeID_V_b_dbulk][admsProbeID_V_b_dbulk] = 1.0;
probeVars[admsProbeID_V_b_bi] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_b_bi][admsProbeID_V_b_bi] = 1.0;
probeVars[admsProbeID_V_b_sbulk] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_sbulk];
d_probeVars[admsProbeID_V_b_sbulk][admsProbeID_V_b_sbulk] = 1.0;
probeVars[admsProbeID_V_bi_sbulk] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_sbulk];
d_probeVars[admsProbeID_V_bi_sbulk][admsProbeID_V_bi_sbulk] = 1.0;
probeVars[admsProbeID_V_gm_gi] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_gi];
d_probeVars[admsProbeID_V_gm_gi][admsProbeID_V_gm_gi] = 1.0;
probeVars[admsProbeID_V_g_gm] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_gm];
d_probeVars[admsProbeID_V_g_gm][admsProbeID_V_g_gm] = 1.0;
probeVars[admsProbeID_V_s_si] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si] = 1.0;
probeVars[admsProbeID_V_d_di] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di] = 1.0;
probeVars[admsProbeID_V_gi_si] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si] = 1.0;
probeVars[admsProbeID_V_di_si] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si] = 1.0;
probeVars[admsProbeID_V_dbulk_GND] = (*solVectorPtr)[li_dbulk];
d_probeVars[admsProbeID_V_dbulk_GND][admsProbeID_V_dbulk_GND] = 1.0;
probeVars[admsProbeID_V_sbulk_GND] = (*solVectorPtr)[li_sbulk];
d_probeVars[admsProbeID_V_sbulk_GND][admsProbeID_V_sbulk_GND] = 1.0;
probeVars[admsProbeID_V_gm_GND] = (*solVectorPtr)[li_gm];
d_probeVars[admsProbeID_V_gm_GND][admsProbeID_V_gm_GND] = 1.0;
probeVars[admsProbeID_V_gi_GND] = (*solVectorPtr)[li_gi];
d_probeVars[admsProbeID_V_gi_GND][admsProbeID_V_gi_GND] = 1.0;
probeVars[admsProbeID_V_bi_GND] = (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_bi_GND][admsProbeID_V_bi_GND] = 1.0;
probeVars[admsProbeID_V_di_GND] = (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_di_GND][admsProbeID_V_di_GND] = 1.0;
probeVars[admsProbeID_V_si_GND] = (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_si_GND][admsProbeID_V_si_GND] = 1.0;
probeVars[admsProbeID_V_gm_bi] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_gm_bi][admsProbeID_V_gm_bi] = 1.0;
probeVars[admsProbeID_V_N1_GND] = (*solVectorPtr)[li_N1];
d_probeVars[admsProbeID_V_N1_GND][admsProbeID_V_N1_GND] = 1.0;
probeVars[admsProbeID_V_N2_GND] = (*solVectorPtr)[li_N2];
d_probeVars[admsProbeID_V_N2_GND][admsProbeID_V_N2_GND] = 1.0;
probeVars[admsProbeID_V_gm_si] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_gm_si][admsProbeID_V_gm_si] = 1.0;
probeVars[admsProbeID_V_gm_di] = (*solVectorPtr)[li_gm] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_gm_di][admsProbeID_V_gm_di] = 1.0;
probeVars[admsProbeID_V_dbulk_di] = (*solVectorPtr)[li_dbulk] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_dbulk_di][admsProbeID_V_dbulk_di] = 1.0;
probeVars[admsProbeID_V_sbulk_si] = (*solVectorPtr)[li_sbulk] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_sbulk_si][admsProbeID_V_sbulk_si] = 1.0;
probeVars[admsProbeID_V_si_bi] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_si_bi][admsProbeID_V_si_bi] = 1.0;
probeVars[admsProbeID_V_di_bi] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_di_bi][admsProbeID_V_di_bi] = 1.0;
probeVars[admsProbeID_V_gi_bi] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_gi_bi][admsProbeID_V_gi_bi] = 1.0;
probeVars[admsProbeID_Temp_t_GND] = ((collapseNode_t)?(0):((*solVectorPtr)[li_t]));
d_probeVars[admsProbeID_Temp_t_GND][admsProbeID_Temp_t_GND] = 1.0;
// -- code converted from analog/code block
if (((model_.TNOM)<=(-273.15)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (300.15-273.15);
UserInfo(*this)  << "Warning: TNOM = %e C <= %e C. Setting TNOM to %e C." << " " << (model_.TNOM) << " " << (-273.15) << " " << T0 << " " <<  std::endl; 
Tnom = 300.15;
}
else
{
Tnom = ((model_.TNOM)+273.15);
}

d_DevTemp_dTemp_t_GND =  0.0;
DevTemp = (admsTemperature+(model_.DTEMP));
if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
{

d_delTemp1_dTemp_t_GND = d_probeVars[admsProbeID_Temp_t_GND][admsProbeID_Temp_t_GND];
delTemp1 = (probeVars[admsProbeID_Temp_t_GND]);
}
else
{

d_delTemp1_dTemp_t_GND =  0.0;
delTemp1 = 0;
}

d_DevTemp_dTemp_t_GND = (d_delTemp1_dTemp_t_GND+d_DevTemp_dTemp_t_GND);
DevTemp = (delTemp1+DevTemp);
TK = DevTemp;

d_Vt_dTemp_t_GND = 0.0;
Vt = adms_vt(DevTemp);

d_inv_Vt_dTemp_t_GND = (-d_Vt_dTemp_t_GND/Vt/Vt);
inv_Vt = (1.0/Vt);

d_TRatio_dTemp_t_GND = (d_DevTemp_dTemp_t_GND/Tnom);
TRatio = (DevTemp/Tnom);

d_delTemp_dTemp_t_GND = d_DevTemp_dTemp_t_GND;
delTemp = (DevTemp-Tnom);

d_Vtm_dTemp_t_GND = 8.617087e-5*d_DevTemp_dTemp_t_GND;
Vtm = (8.617087e-5*DevTemp);
Vtm0 = (8.617087e-5*Tnom);

d_Eg_dTemp_t_GND = (-(((DevTemp+(model_.TBGBSUB))*(((model_.TBGASUB)*DevTemp)*d_DevTemp_dTemp_t_GND+(model_.TBGASUB)*d_DevTemp_dTemp_t_GND*DevTemp)-(((model_.TBGASUB)*DevTemp)*DevTemp)*d_DevTemp_dTemp_t_GND)/(DevTemp+(model_.TBGBSUB))/(DevTemp+(model_.TBGBSUB))));
Eg = ((model_.BG0SUB)-((((model_.TBGASUB)*DevTemp)*DevTemp)/(DevTemp+(model_.TBGBSUB))));
Eg0 = ((model_.BG0SUB)-((((model_.TBGASUB)*Tnom)*Tnom)/(Tnom+(model_.TBGBSUB))));
{
double value_sqrt_0 = sqrt((DevTemp/Tnom));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = ((DevTemp/Tnom)*(deriv_sqrt_0_d0*((d_DevTemp_dTemp_t_GND/Tnom)))+(d_DevTemp_dTemp_t_GND/Tnom)*value_sqrt_0);
T1 = ((DevTemp/Tnom)*value_sqrt_0);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm))));

d_ni_dTemp_t_GND = (((model_.NI0SUB)*T1)*evaluator_lexp_0.getDerivs(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm))),((d_Eg_dTemp_t_GND/(2.0*Vtm0))-(((2.0*Vtm)*d_Eg_dTemp_t_GND-Eg*2.0*d_Vtm_dTemp_t_GND)/(2.0*Vtm)/(2.0*Vtm))))+(model_.NI0SUB)*d_T1_dTemp_t_GND*evaluator_lexp_0.getValues(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))));
ni = (((model_.NI0SUB)*T1)*evaluator_lexp_0.getValues(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))));
}
if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((NDEP_i/ni));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = evaluator_lln_0.getDerivs((NDEP_i/ni),(-NDEP_i*d_ni_dTemp_t_GND/ni/ni));
T0 = evaluator_lln_0.getValues((NDEP_i/ni));
}
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0E-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_phib_dTemp_t_GND = (deriv_sqrt_0_d0*((T0*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*T0)));
phib = value_sqrt_0;
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((NDEP_i/ni));

d_phib_dTemp_t_GND = evaluator_lln_0.getDerivs((NDEP_i/ni),(-NDEP_i*d_ni_dTemp_t_GND/ni/ni));
phib = evaluator_lln_0.getValues((NDEP_i/ni));
}
}
if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((NDEP_i*(model_.NSD))/ni)*ni));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = evaluator_lln_0.getDerivs((((NDEP_i*(model_.NSD))/ni)*ni),(((NDEP_i*(model_.NSD))/ni)*d_ni_dTemp_t_GND+(-(NDEP_i*(model_.NSD))*d_ni_dTemp_t_GND/ni/ni)*ni));
T0 = evaluator_lln_0.getValues((((NDEP_i*(model_.NSD))/ni)*ni));
}
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0E-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vbi_dTemp_t_GND = (deriv_sqrt_0_d0*((T0*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*T0)));
Vbi = value_sqrt_0;
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((NDEP_i*(model_.NSD))/ni)*ni));

d_Vbi_dTemp_t_GND = evaluator_lln_0.getDerivs((((NDEP_i*(model_.NSD))/ni)*ni),(((NDEP_i*(model_.NSD))/ni)*d_ni_dTemp_t_GND+(-(NDEP_i*(model_.NSD))*d_ni_dTemp_t_GND/ni/ni)*ni));
Vbi = evaluator_lln_0.getValues((((NDEP_i*(model_.NSD))/ni)*ni));
}
}
if ((NGATE_i>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((NGATE_i/NSD_i));

d_Vfbsdr_dTemp_t_GND = (-devsign)*d_Vt_dTemp_t_GND*evaluator_lln_0.getValues((NGATE_i/NSD_i));
Vfbsdr = ((((-devsign)*Vt)*evaluator_lln_0.getValues((NGATE_i/NSD_i)))+VFBSDOFF);
}
}
else
{

d_Vfbsdr_dTemp_t_GND =  0.0;
Vfbsdr = 0.0;
}
{
double value_max_0 = std::max(((0.4+(Vt*phib))+PHIN_i),static_cast<double>(0.4));
double  deriv_max_0_d0 = ((((0.4+(Vt*phib))+PHIN_i)>=0.4)?1.0:0.0);

d_Phist_dTemp_t_GND = (deriv_max_0_d0*((Vt*d_phib_dTemp_t_GND+d_Vt_dTemp_t_GND*phib)));
Phist = value_max_0;
}
{
double value_sqrt_0 = sqrt(Phist);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtPhist_dTemp_t_GND = (deriv_sqrt_0_d0*(d_Phist_dTemp_t_GND));
sqrtPhist = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt(((2.0*epssi)/(1.60219e-19*NDEP_i)));
T1DEP = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((epssi/epsox)*(model_.TOXE))*XJ_i));
litl = value_sqrt_0;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((1.0+((model_.TNFACTOR)*(TRatio-1.0))),1e-3);

d_NFACTOR_t_dTemp_t_GND = NFACTOR_i*evaluator_hypsmooth_0.getDerivs((1.0+((model_.TNFACTOR)*(TRatio-1.0))),1e-3,(model_.TNFACTOR)*d_TRatio_dTemp_t_GND,0.0);
NFACTOR_t = (NFACTOR_i*evaluator_hypsmooth_0.getValues((1.0+((model_.TNFACTOR)*(TRatio-1.0))),1e-3));
}

d_ETA0_t_dTemp_t_GND = ETA0_i*(model_.TETA0)*d_TRatio_dTemp_t_GND;
ETA0_t = (ETA0_i*(1.0+((model_.TETA0)*(TRatio-1.0))));
if (((model_.ASYMMOD)!=0))
{

d_ETA0R_t_dTemp_t_GND = ETA0R_i*(model_.TETA0)*d_TRatio_dTemp_t_GND;
ETA0R_t = (ETA0R_i*(1.0+((model_.TETA0)*(TRatio-1.0))));
}
eta_mu = (((model_.TYPE)!=1)?(0.33333333333333333*(model_.ETAMOB)):(0.5*(model_.ETAMOB)));
{
double value_pow_0 = pow(TRatio,UTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UTE_i/TRatio));

d_U0_t_dTemp_t_GND = U0_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
U0_t = (U0_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3);

d_UA_t_dTemp_t_GND = UA_i*evaluator_hypsmooth_0.getDerivs(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3,UA1_i*d_delTemp_dTemp_t_GND,0.0);
UA_t = (UA_i*evaluator_hypsmooth_0.getValues(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3);

d_UC_t_dTemp_t_GND = UC_i*evaluator_hypsmooth_0.getDerivs(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3,UC1_i*d_delTemp_dTemp_t_GND,0.0);
UC_t = (UC_i*evaluator_hypsmooth_0.getValues(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3));
}
{
double value_pow_0 = pow(TRatio,UD1_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UD1_i/TRatio));

d_UD_t_dTemp_t_GND = UD_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
UD_t = (UD_i*value_pow_0);
}
{
double value_pow_0 = pow(TRatio,UCSTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UCSTE_i/TRatio));

d_UCS_t_dTemp_t_GND = UCS_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
UCS_t = (UCS_i*value_pow_0);
}
if (((model_.ASYMMOD)!=0))
{
{
double value_pow_0 = pow(TRatio,UTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UTE_i/TRatio));

d_U0R_t_dTemp_t_GND = U0R_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
U0R_t = (U0R_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3);

d_UAR_t_dTemp_t_GND = UAR_i*evaluator_hypsmooth_0.getDerivs(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3,UA1_i*d_delTemp_dTemp_t_GND,0.0);
UAR_t = (UAR_i*evaluator_hypsmooth_0.getValues(((1.0+(UA1_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3);

d_UCR_t_dTemp_t_GND = UCR_i*evaluator_hypsmooth_0.getDerivs(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3,UC1_i*d_delTemp_dTemp_t_GND,0.0);
UCR_t = (UCR_i*evaluator_hypsmooth_0.getValues(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3));
}
{
double value_pow_0 = pow(TRatio,UD1_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UD1_i/TRatio));

d_UDR_t_dTemp_t_GND = UDR_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
UDR_t = (UDR_i*value_pow_0);
}
{
double value_pow_0 = pow(TRatio,UCSTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UCSTE_i/TRatio));

d_UCSR_t_dTemp_t_GND = UCSR_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
UCSR_t = (UCSR_i*value_pow_0);
}
}
{
double value_pow_0 = pow(TRatio,PRT_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*PRT_i/TRatio));

d_rdstemp_dTemp_t_GND = (deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
rdstemp = value_pow_0;
}
{
double value_pow_0 = pow(TRatio,(-AT_i));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(-AT_i)/TRatio));

d_VSAT_t_dTemp_t_GND = VSAT_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
VSAT_t = (VSAT_i*value_pow_0);
}
if ((VSAT_t<100.0))
{
UserInfo(*this)  << "Warning: VSAT(%f) = %e is less than 100, setting it to 100." << " " << DevTemp << " " << VSAT_t << " " <<  std::endl; 

d_VSAT_t_dTemp_t_GND =  0.0;
VSAT_t = 100.0;
}
if (((model_.ASYMMOD)!=0))
{
{
double value_pow_0 = pow(TRatio,(-AT_i));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(-AT_i)/TRatio));

d_VSATR_t_dTemp_t_GND = VSATR_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
VSATR_t = (VSATR_i*value_pow_0);
}
if ((VSATR_t<100.0))
{
UserInfo(*this)  << "Warning: VSATR(%f) = %e is less than 100, setting it to 100." << " " << DevTemp << " " << VSATR_t << " " <<  std::endl; 

d_VSATR_t_dTemp_t_GND =  0.0;
VSATR_t = 100.0;
}
}
{
double value_pow_0 = pow(TRatio,(-AT_i));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(-AT_i)/TRatio));

d_VSATCV_t_dTemp_t_GND = VSATCV_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
VSATCV_t = (VSATCV_i*value_pow_0);
}
if ((VSATCV_t<100.0))
{
UserInfo(*this)  << "Warning: VSATCV(%f) = %e is less than 100, setting it to 100." << " " << DevTemp << " " << VSATCV_t << " " <<  std::endl; 

d_VSATCV_t_dTemp_t_GND =  0.0;
VSATCV_t = 100.0;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((1.0/DELTA_i)*(1.0+((model_.TDELTA)*delTemp)))-2.0),1.0E-3);

d_DELTA_t_dTemp_t_GND = (-evaluator_hypsmooth_0.getDerivs((((1.0/DELTA_i)*(1.0+((model_.TDELTA)*delTemp)))-2.0),1.0E-3,(1.0/DELTA_i)*(model_.TDELTA)*d_delTemp_dTemp_t_GND,0.0)/(evaluator_hypsmooth_0.getValues((((1.0/DELTA_i)*(1.0+((model_.TDELTA)*delTemp)))-2.0),1.0E-3)+2.0)/(evaluator_hypsmooth_0.getValues((((1.0/DELTA_i)*(1.0+((model_.TDELTA)*delTemp)))-2.0),1.0E-3)+2.0));
DELTA_t = (1.0/(evaluator_hypsmooth_0.getValues((((1.0/DELTA_i)*(1.0+((model_.TDELTA)*delTemp)))-2.0),1.0E-3)+2.0));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3);

d_PTWG_t_dTemp_t_GND = PTWG_i*evaluator_hypsmooth_0.getDerivs(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3,(-PTWGT_i*d_delTemp_dTemp_t_GND),0.0);
PTWG_t = (PTWG_i*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3);

d_PTWGR_t_dTemp_t_GND = PTWGR_i*evaluator_hypsmooth_0.getDerivs(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3,(-PTWGT_i*d_delTemp_dTemp_t_GND),0.0);
PTWGR_t = (PTWGR_i*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(A11_i*delTemp))-1.0E-6),1.0E-3);

d_A1_t_dTemp_t_GND = A1_i*evaluator_hypsmooth_0.getDerivs(((1.0+(A11_i*delTemp))-1.0E-6),1.0E-3,A11_i*d_delTemp_dTemp_t_GND,0.0);
A1_t = (A1_i*evaluator_hypsmooth_0.getValues(((1.0+(A11_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(A21_i*delTemp))-1.0E-6),1.0E-3);

d_A2_t_dTemp_t_GND = A2_i*evaluator_hypsmooth_0.getDerivs(((1.0+(A21_i*delTemp))-1.0E-6),1.0E-3,A21_i*d_delTemp_dTemp_t_GND,0.0);
A2_t = (A2_i*evaluator_hypsmooth_0.getValues(((1.0+(A21_i*delTemp))-1.0E-6),1.0E-3));
}
{
double value_pow_0 = pow(TRatio,IIT_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*IIT_i/TRatio));

d_BETA0_t_dTemp_t_GND = BETA0_i*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
BETA0_t = (BETA0_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3);

d_BGIDL_t_dTemp_t_GND = BGIDL_i*evaluator_hypsmooth_0.getDerivs(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3,TGIDL_i*d_delTemp_dTemp_t_GND,0.0);
BGIDL_t = (BGIDL_i*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3);

d_BGISL_t_dTemp_t_GND = BGISL_i*evaluator_hypsmooth_0.getDerivs(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3,TGIDL_i*d_delTemp_dTemp_t_GND,0.0);
BGISL_t = (BGISL_i*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((IGT_i*evaluator_lln_0.getValues(TRatio)));

d_igtemp_dTemp_t_GND = evaluator_lexp_1.getDerivs((IGT_i*evaluator_lln_0.getValues(TRatio)),IGT_i*evaluator_lln_0.getDerivs(TRatio,d_TRatio_dTemp_t_GND));
igtemp = evaluator_lexp_1.getValues((IGT_i*evaluator_lln_0.getValues(TRatio)));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3);

d_CJS_t_dTemp_t_GND = (model_.CJS)*evaluator_hypsmooth_0.getDerivs(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3,(model_.TCJ)*d_delTemp_dTemp_t_GND,0.0);
CJS_t = ((model_.CJS)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3);

d_CJD_t_dTemp_t_GND = (model_.CJD)*evaluator_hypsmooth_0.getDerivs(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3,(model_.TCJ)*d_delTemp_dTemp_t_GND,0.0);
CJD_t = ((model_.CJD)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3);

d_CJSWS_t_dTemp_t_GND = (model_.CJSWS)*evaluator_hypsmooth_0.getDerivs(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3,(model_.TCJSW)*d_delTemp_dTemp_t_GND,0.0);
CJSWS_t = ((model_.CJSWS)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3);

d_CJSWD_t_dTemp_t_GND = (model_.CJSWD)*evaluator_hypsmooth_0.getDerivs(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3,(model_.TCJSW)*d_delTemp_dTemp_t_GND,0.0);
CJSWD_t = ((model_.CJSWD)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3);

d_CJSWGS_t_dTemp_t_GND = (model_.CJSWGS)*evaluator_hypsmooth_0.getDerivs(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3,(model_.TCJSWG)*d_delTemp_dTemp_t_GND,0.0);
CJSWGS_t = ((model_.CJSWGS)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3);

d_CJSWGD_t_dTemp_t_GND = (model_.CJSWGD)*evaluator_hypsmooth_0.getDerivs(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3,(model_.TCJSWG)*d_delTemp_dTemp_t_GND,0.0);
CJSWGD_t = ((model_.CJSWGD)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBS)-((model_.TPB)*delTemp))-0.01),1.0E-3);

d_PBS_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.PBS)-((model_.TPB)*delTemp))-0.01),1.0E-3,(-(model_.TPB)*d_delTemp_dTemp_t_GND),0.0);
PBS_t = (evaluator_hypsmooth_0.getValues((((model_.PBS)-((model_.TPB)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBD)-((model_.TPB)*delTemp))-0.01),1.0E-3);

d_PBD_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.PBD)-((model_.TPB)*delTemp))-0.01),1.0E-3,(-(model_.TPB)*d_delTemp_dTemp_t_GND),0.0);
PBD_t = (evaluator_hypsmooth_0.getValues((((model_.PBD)-((model_.TPB)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWS)-((model_.TPBSW)*delTemp))-0.01),1.0E-3);

d_PBSWS_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.PBSWS)-((model_.TPBSW)*delTemp))-0.01),1.0E-3,(-(model_.TPBSW)*d_delTemp_dTemp_t_GND),0.0);
PBSWS_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWS)-((model_.TPBSW)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWD)-((model_.TPBSW)*delTemp))-0.01),1.0E-3);

d_PBSWD_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.PBSWD)-((model_.TPBSW)*delTemp))-0.01),1.0E-3,(-(model_.TPBSW)*d_delTemp_dTemp_t_GND),0.0);
PBSWD_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWD)-((model_.TPBSW)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWGS)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3);

d_PBSWGS_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.PBSWGS)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3,(-(model_.TPBSWG)*d_delTemp_dTemp_t_GND),0.0);
PBSWGS_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWGS)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWGD)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3);

d_PBSWGD_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.PBSWGD)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3,(-(model_.TPBSWG)*d_delTemp_dTemp_t_GND),0.0);
PBSWGD_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWGD)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3)+0.01);
}

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((Vtm*d_Eg_dTemp_t_GND-Eg*d_Vtm_dTemp_t_GND)/Vtm/Vtm));
T0 = ((Eg0/Vtm0)-(Eg/Vtm));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = evaluator_lln_0.getDerivs(TRatio,d_TRatio_dTemp_t_GND);
T1 = evaluator_lln_0.getValues(TRatio);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0+((model_.XTIS)*T1))/(model_.NJS)));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi =  0.0;
d_T3_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0+((model_.XTIS)*T1))/(model_.NJS)),((d_T0_dTemp_t_GND+(model_.XTIS)*d_T1_dTemp_t_GND)/(model_.NJS)));
T3 = evaluator_lexp_0.getValues(((T0+((model_.XTIS)*T1))/(model_.NJS)));
}

d_JSS_t_dTemp_t_GND = (model_.JSS)*d_T3_dTemp_t_GND;
JSS_t = ((model_.JSS)*T3);

d_JSWS_t_dTemp_t_GND = (model_.JSWS)*d_T3_dTemp_t_GND;
JSWS_t = ((model_.JSWS)*T3);

d_JSWGS_t_dTemp_t_GND = (model_.JSWGS)*d_T3_dTemp_t_GND;
JSWGS_t = ((model_.JSWGS)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0+((model_.XTID)*T1))/(model_.NJD)));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi =  0.0;
d_T3_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0+((model_.XTID)*T1))/(model_.NJD)),((d_T0_dTemp_t_GND+(model_.XTID)*d_T1_dTemp_t_GND)/(model_.NJD)));
T3 = evaluator_lexp_0.getValues(((T0+((model_.XTID)*T1))/(model_.NJD)));
}

d_JSD_t_dTemp_t_GND = (model_.JSD)*d_T3_dTemp_t_GND;
JSD_t = ((model_.JSD)*T3);

d_JSWD_t_dTemp_t_GND = (model_.JSWD)*d_T3_dTemp_t_GND;
JSWD_t = ((model_.JSWD)*T3);

d_JSWGD_t_dTemp_t_GND = (model_.JSWGD)*d_T3_dTemp_t_GND;
JSWGD_t = ((model_.JSWGD)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSS))*(TRatio-1.0))/Vtm));

d_JTSS_t_dTemp_t_GND = (model_.JTSS)*evaluator_lexp_0.getDerivs((((Eg0*(model_.XTSS))*(TRatio-1.0))/Vtm),((Vtm*(Eg0*(model_.XTSS))*d_TRatio_dTemp_t_GND-((Eg0*(model_.XTSS))*(TRatio-1.0))*d_Vtm_dTemp_t_GND)/Vtm/Vtm));
JTSS_t = ((model_.JTSS)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSS))*(TRatio-1.0))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSSWS))*(TRatio-1.0))/Vtm));

d_JTSSWS_t_dTemp_t_GND = (model_.JTSSWS)*evaluator_lexp_0.getDerivs((((Eg0*(model_.XTSSWS))*(TRatio-1.0))/Vtm),((Vtm*(Eg0*(model_.XTSSWS))*d_TRatio_dTemp_t_GND-((Eg0*(model_.XTSSWS))*(TRatio-1.0))*d_Vtm_dTemp_t_GND)/Vtm/Vtm));
JTSSWS_t = ((model_.JTSSWS)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSSWS))*(TRatio-1.0))/Vtm)));
}
{
double value_sqrt_0 = sqrt(((model_.JTWEFF)/Weffcj));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*(model_.XTSSWGS))*(TRatio-1))/Vtm));

d_JTSSWGS_t_dTemp_t_GND = ((model_.JTSSWGS)*(value_sqrt_0+1.0))*evaluator_lexp_1.getDerivs((((Eg0*(model_.XTSSWGS))*(TRatio-1))/Vtm),((Vtm*(Eg0*(model_.XTSSWGS))*d_TRatio_dTemp_t_GND-((Eg0*(model_.XTSSWGS))*(TRatio-1))*d_Vtm_dTemp_t_GND)/Vtm/Vtm));
JTSSWGS_t = (((model_.JTSSWGS)*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*(model_.XTSSWGS))*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSD))*(TRatio-1.0))/Vtm));

d_JTSD_t_dTemp_t_GND = (model_.JTSD)*evaluator_lexp_0.getDerivs((((Eg0*(model_.XTSD))*(TRatio-1.0))/Vtm),((Vtm*(Eg0*(model_.XTSD))*d_TRatio_dTemp_t_GND-((Eg0*(model_.XTSD))*(TRatio-1.0))*d_Vtm_dTemp_t_GND)/Vtm/Vtm));
JTSD_t = ((model_.JTSD)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSD))*(TRatio-1.0))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSSWD))*(TRatio-1.0))/Vtm));

d_JTSSWD_t_dTemp_t_GND = (model_.JTSSWD)*evaluator_lexp_0.getDerivs((((Eg0*(model_.XTSSWD))*(TRatio-1.0))/Vtm),((Vtm*(Eg0*(model_.XTSSWD))*d_TRatio_dTemp_t_GND-((Eg0*(model_.XTSSWD))*(TRatio-1.0))*d_Vtm_dTemp_t_GND)/Vtm/Vtm));
JTSSWD_t = ((model_.JTSSWD)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSSWD))*(TRatio-1.0))/Vtm)));
}
{
double value_sqrt_0 = sqrt(((model_.JTWEFF)/Weffcj));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*(model_.XTSSWGD))*(TRatio-1))/Vtm));

d_JTSSWGD_t_dTemp_t_GND = ((model_.JTSSWGD)*(value_sqrt_0+1.0))*evaluator_lexp_1.getDerivs((((Eg0*(model_.XTSSWGD))*(TRatio-1))/Vtm),((Vtm*(Eg0*(model_.XTSSWGD))*d_TRatio_dTemp_t_GND-((Eg0*(model_.XTSSWGD))*(TRatio-1))*d_Vtm_dTemp_t_GND)/Vtm/Vtm));
JTSSWGD_t = (((model_.JTSSWGD)*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*(model_.XTSSWGD))*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTS)*(1.0+((model_.TNJTS)*(TRatio-1.0))))-0.01),1.0E-3);

d_NJTS_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.NJTS)*(1.0+((model_.TNJTS)*(TRatio-1.0))))-0.01),1.0E-3,(model_.NJTS)*(model_.TNJTS)*d_TRatio_dTemp_t_GND,0.0);
NJTS_t = (evaluator_hypsmooth_0.getValues((((model_.NJTS)*(1.0+((model_.TNJTS)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSW)*(1.0+((model_.TNJTSSW)*(TRatio-1.0))))-0.01),1.0E-3);

d_NJTSSW_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.NJTSSW)*(1.0+((model_.TNJTSSW)*(TRatio-1.0))))-0.01),1.0E-3,(model_.NJTSSW)*(model_.TNJTSSW)*d_TRatio_dTemp_t_GND,0.0);
NJTSSW_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSW)*(1.0+((model_.TNJTSSW)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSWG)*(1.0+((model_.TNJTSSWG)*(TRatio-1.0))))-0.01),1.0E-3);

d_NJTSSWG_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.NJTSSWG)*(1.0+((model_.TNJTSSWG)*(TRatio-1.0))))-0.01),1.0E-3,(model_.NJTSSWG)*(model_.TNJTSSWG)*d_TRatio_dTemp_t_GND,0.0);
NJTSSWG_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSWG)*(1.0+((model_.TNJTSSWG)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSD)*(1.0+((model_.TNJTSD)*(TRatio-1.0))))-0.01),1.0E-3);

d_NJTSD_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.NJTSD)*(1.0+((model_.TNJTSD)*(TRatio-1.0))))-0.01),1.0E-3,(model_.NJTSD)*(model_.TNJTSD)*d_TRatio_dTemp_t_GND,0.0);
NJTSD_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSD)*(1.0+((model_.TNJTSD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSWD)*(1.0+((model_.TNJTSSWD)*(TRatio-1.0))))-0.01),1.0E-3);

d_NJTSSWD_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.NJTSSWD)*(1.0+((model_.TNJTSSWD)*(TRatio-1.0))))-0.01),1.0E-3,(model_.NJTSSWD)*(model_.TNJTSSWD)*d_TRatio_dTemp_t_GND,0.0);
NJTSSWD_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSWD)*(1.0+((model_.TNJTSSWD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSWGD)*(1.0+((model_.TNJTSSWGD)*(TRatio-1.0))))-0.01),1.0E-3);

d_NJTSSWGD_t_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.NJTSSWGD)*(1.0+((model_.TNJTSSWGD)*(TRatio-1.0))))-0.01),1.0E-3,(model_.NJTSSWGD)*(model_.TNJTSSWGD)*d_TRatio_dTemp_t_GND,0.0);
NJTSSWGD_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSWGD)*(1.0+((model_.TNJTSSWGD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
if ((GEOMOD<9))
{
if (((NF%2)!=0))
{
nuEndD = 1.0;
nuEndS = 1.0;
{
double value_max_0 = std::max(((NF-1.0)/2.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuIntS = nuIntD;
}
else
{
if ((MINZ==1))
{
nuEndD = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntD = (2.0*value_max_0);
}
nuEndS = 0.0;
nuIntS = NF;
}
else
{
nuEndD = 0.0;
nuIntD = NF;
nuEndS = 2.0;
{
double value_max_0 = std::max(((NF/2.0)-1.0),static_cast<double>(0.0));
nuIntS = (2.0*value_max_0);
}
}
}
}

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (DMCGeff+DMCIeff);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (DMCGeff+DMCGeff);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = (DMDGeff+DMDGeff);

d_PSiso_dTemp_t_GND = (d_T0_dTemp_t_GND+d_T0_dTemp_t_GND);
PSiso = ((T0+T0)+Weffcj);

d_PDiso_dTemp_t_GND = (d_T0_dTemp_t_GND+d_T0_dTemp_t_GND);
PDiso = ((T0+T0)+Weffcj);

d_PSsha_dTemp_t_GND = d_T1_dTemp_t_GND;
PSsha = T1;

d_PDsha_dTemp_t_GND = d_T1_dTemp_t_GND;
PDsha = T1;
PSmer = T2;
PDmer = T2;

d_ASiso_dTemp_t_GND = d_T0_dTemp_t_GND*Weffcj;
ASiso = (T0*Weffcj);

d_ADiso_dTemp_t_GND = d_T0_dTemp_t_GND*Weffcj;
ADiso = (T0*Weffcj);
ASsha = (DMCGeff*Weffcj);
ADsha = (DMCGeff*Weffcj);
ASmer = (DMDGeff*Weffcj);
ADmer = (DMDGeff*Weffcj);
if ( GEOMOD == (0))
{

d_temp_PSeff_dTemp_t_GND = (nuEndS*d_PSiso_dTemp_t_GND+nuIntS*d_PSsha_dTemp_t_GND);
temp_PSeff = ((nuEndS*PSiso)+(nuIntS*PSsha));

d_temp_PDeff_dTemp_t_GND = (nuEndD*d_PDiso_dTemp_t_GND+nuIntD*d_PDsha_dTemp_t_GND);
temp_PDeff = ((nuEndD*PDiso)+(nuIntD*PDsha));

d_temp_ASeff_dTemp_t_GND = nuEndS*d_ASiso_dTemp_t_GND;
temp_ASeff = ((nuEndS*ASiso)+(nuIntS*ASsha));

d_temp_ADeff_dTemp_t_GND = nuEndD*d_ADiso_dTemp_t_GND;
temp_ADeff = ((nuEndD*ADiso)+(nuIntD*ADsha));
}
else
if ( GEOMOD == (1))
{

d_temp_PSeff_dTemp_t_GND = (nuEndS*d_PSiso_dTemp_t_GND+nuIntS*d_PSsha_dTemp_t_GND);
temp_PSeff = ((nuEndS*PSiso)+(nuIntS*PSsha));

d_temp_PDeff_dTemp_t_GND = (nuEndD+nuIntD)*d_PDsha_dTemp_t_GND;
temp_PDeff = ((nuEndD+nuIntD)*PDsha);

d_temp_ASeff_dTemp_t_GND = nuEndS*d_ASiso_dTemp_t_GND;
temp_ASeff = ((nuEndS*ASiso)+(nuIntS*ASsha));

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = ((nuEndD+nuIntD)*ADsha);
}
else
if ( GEOMOD == (2))
{

d_temp_PSeff_dTemp_t_GND = (nuEndS+nuIntS)*d_PSsha_dTemp_t_GND;
temp_PSeff = ((nuEndS+nuIntS)*PSsha);

d_temp_PDeff_dTemp_t_GND = (nuEndD*d_PDiso_dTemp_t_GND+nuIntD*d_PDsha_dTemp_t_GND);
temp_PDeff = ((nuEndD*PDiso)+(nuIntD*PDsha));

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = ((nuEndS+nuIntS)*ASsha);

d_temp_ADeff_dTemp_t_GND = nuEndD*d_ADiso_dTemp_t_GND;
temp_ADeff = ((nuEndD*ADiso)+(nuIntD*ADsha));
}
else
if ( GEOMOD == (3))
{

d_temp_PSeff_dTemp_t_GND = (nuEndS+nuIntS)*d_PSsha_dTemp_t_GND;
temp_PSeff = ((nuEndS+nuIntS)*PSsha);

d_temp_PDeff_dTemp_t_GND = (nuEndD+nuIntD)*d_PDsha_dTemp_t_GND;
temp_PDeff = ((nuEndD+nuIntD)*PDsha);

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = ((nuEndS+nuIntS)*ASsha);

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = ((nuEndD+nuIntD)*ADsha);
}
else
if ( GEOMOD == (4))
{

d_temp_PSeff_dTemp_t_GND = (nuEndS*d_PSiso_dTemp_t_GND+nuIntS*d_PSsha_dTemp_t_GND);
temp_PSeff = ((nuEndS*PSiso)+(nuIntS*PSsha));

d_temp_PDeff_dTemp_t_GND = nuIntD*d_PDsha_dTemp_t_GND;
temp_PDeff = ((nuEndD*PDmer)+(nuIntD*PDsha));

d_temp_ASeff_dTemp_t_GND = nuEndS*d_ASiso_dTemp_t_GND;
temp_ASeff = ((nuEndS*ASiso)+(nuIntS*ASsha));

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = ((nuEndD*ADmer)+(nuIntD*ADsha));
}
else
if ( GEOMOD == (5))
{

d_temp_PSeff_dTemp_t_GND = (nuEndS+nuIntS)*d_PSsha_dTemp_t_GND;
temp_PSeff = ((nuEndS+nuIntS)*PSsha);

d_temp_PDeff_dTemp_t_GND = nuIntD*d_PDsha_dTemp_t_GND;
temp_PDeff = ((nuEndD*PDmer)+(nuIntD*PDsha));

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = ((nuEndS+nuIntS)*ASsha);

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = ((nuEndD*ADmer)+(nuIntD*ADsha));
}
else
if ( GEOMOD == (6))
{

d_temp_PSeff_dTemp_t_GND = nuIntS*d_PSsha_dTemp_t_GND;
temp_PSeff = ((nuEndS*PSmer)+(nuIntS*PSsha));

d_temp_PDeff_dTemp_t_GND = (nuEndD*d_PDiso_dTemp_t_GND+nuIntD*d_PDsha_dTemp_t_GND);
temp_PDeff = ((nuEndD*PDiso)+(nuIntD*PDsha));

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = ((nuEndS*ASmer)+(nuIntS*ASsha));

d_temp_ADeff_dTemp_t_GND = nuEndD*d_ADiso_dTemp_t_GND;
temp_ADeff = ((nuEndD*ADiso)+(nuIntD*ADsha));
}
else
if ( GEOMOD == (7))
{

d_temp_PSeff_dTemp_t_GND = nuIntS*d_PSsha_dTemp_t_GND;
temp_PSeff = ((nuEndS*PSmer)+(nuIntS*PSsha));

d_temp_PDeff_dTemp_t_GND = (nuEndD+nuIntD)*d_PDsha_dTemp_t_GND;
temp_PDeff = ((nuEndD+nuIntD)*PDsha);

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = ((nuEndS*ASmer)+(nuIntS*ASsha));

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = ((nuEndD+nuIntD)*ADsha);
}
else
if ( GEOMOD == (8))
{

d_temp_PSeff_dTemp_t_GND = nuIntS*d_PSsha_dTemp_t_GND;
temp_PSeff = ((nuEndS*PSmer)+(nuIntS*PSsha));

d_temp_PDeff_dTemp_t_GND = nuIntD*d_PDsha_dTemp_t_GND;
temp_PDeff = ((nuEndD*PDmer)+(nuIntD*PDsha));

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = ((nuEndS*ASmer)+(nuIntS*ASsha));

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = ((nuEndD*ADmer)+(nuIntD*ADsha));
}
else
if ( GEOMOD == (9))
{

d_temp_PSeff_dTemp_t_GND = (d_PSiso_dTemp_t_GND+(NF-1.0)*d_PSsha_dTemp_t_GND);
temp_PSeff = (PSiso+((NF-1.0)*PSsha));

d_temp_PDeff_dTemp_t_GND = NF*d_PDsha_dTemp_t_GND;
temp_PDeff = (NF*PDsha);

d_temp_ASeff_dTemp_t_GND = d_ASiso_dTemp_t_GND;
temp_ASeff = (ASiso+((NF-1.0)*ASsha));

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = (NF*ADsha);
}
else
if ( GEOMOD == (10))
{

d_temp_PSeff_dTemp_t_GND = NF*d_PSsha_dTemp_t_GND;
temp_PSeff = (NF*PSsha);

d_temp_PDeff_dTemp_t_GND = (d_PDiso_dTemp_t_GND+(NF-1.0)*d_PDsha_dTemp_t_GND);
temp_PDeff = (PDiso+((NF-1.0)*PDsha));

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = (NF*ASsha);

d_temp_ADeff_dTemp_t_GND = d_ADiso_dTemp_t_GND;
temp_ADeff = (ADiso+((NF-1.0)*ADsha));
}
else
{

d_temp_PSeff_dTemp_t_GND =  0.0;
temp_PSeff = 0;

d_temp_PDeff_dTemp_t_GND =  0.0;
temp_PDeff = 0;

d_temp_ASeff_dTemp_t_GND =  0.0;
temp_ASeff = 0;

d_temp_ADeff_dTemp_t_GND =  0.0;
temp_ADeff = 0;
}
}
if (given("AS"))
{

d_ASeff_dTemp_t_GND =  0.0;
ASeff = ((AS*(model_.WMLT))*(model_.LMLT));
}
else
{

d_ASeff_dTemp_t_GND = d_temp_ASeff_dTemp_t_GND;
ASeff = temp_ASeff;
}
if ((ASeff<0.0))
{
UserInfo(*this)  << "Warning: (instance %M) ASeff = %e is negative, set to zero." << " " << ASeff << " " <<  std::endl; 

d_ASeff_dTemp_t_GND =  0.0;
ASeff = 0.0;
}
if (given("AD"))
{

d_ADeff_dTemp_t_GND =  0.0;
ADeff = ((AD*(model_.WMLT))*(model_.LMLT));
}
else
{

d_ADeff_dTemp_t_GND = d_temp_ADeff_dTemp_t_GND;
ADeff = temp_ADeff;
}
if ((ADeff<0.0))
{
UserInfo(*this)  << "Warning: (instance %M) ADeff = %e is negative, set to zero." << " " << ADeff << " " <<  std::endl; 

d_ADeff_dTemp_t_GND =  0.0;
ADeff = 0.0;
}
if (given("PS"))
{
if (((model_.PERMOD)==0))
{

d_PSeff_dTemp_t_GND =  0.0;
PSeff = (PS*(model_.WMLT));
}
else
{
{
double value_max_0 = std::max(((PS*(model_.WMLT))-(Weffcj*NF)),static_cast<double>(0.0));

d_PSeff_dTemp_t_GND =  0.0;
PSeff = value_max_0;
}
}
}
else
{

d_PSeff_dTemp_t_GND = d_temp_PSeff_dTemp_t_GND;
PSeff = temp_PSeff;
if ((PSeff<0.0))
{
UserInfo(*this)  << "Warning: (instance %M) PSeff = %e is negative.Set to 0.0" << " " << PSeff << " " <<  std::endl; 

d_PSeff_dTemp_t_GND =  0.0;
PSeff = 0.0;
}
}
if (given("PD"))
{
if (((model_.PERMOD)==0))
{

d_PDeff_dTemp_t_GND =  0.0;
PDeff = (PD*(model_.WMLT));
}
else
{
{
double value_max_0 = std::max(((PD*(model_.WMLT))-(Weffcj*NF)),static_cast<double>(0.0));

d_PDeff_dTemp_t_GND =  0.0;
PDeff = value_max_0;
}
}
}
else
{

d_PDeff_dTemp_t_GND = d_temp_PDeff_dTemp_t_GND;
PDeff = temp_PDeff;
if ((PDeff<0.0))
{
UserInfo(*this)  << "Warning: (instance %M) PDeff = %e is negative.Set to 0.0" << " " << PDeff << " " <<  std::endl; 

d_PDeff_dTemp_t_GND =  0.0;
PDeff = 0.0;
}
}

d_Isbs_dTemp_t_GND = (((ASeff*d_JSS_t_dTemp_t_GND+d_ASeff_dTemp_t_GND*JSS_t)+(PSeff*d_JSWS_t_dTemp_t_GND+d_PSeff_dTemp_t_GND*JSWS_t))+(Weffcj*NF)*d_JSWGS_t_dTemp_t_GND);
Isbs = (((ASeff*JSS_t)+(PSeff*JSWS_t))+((Weffcj*NF)*JSWGS_t));
if ((Isbs>0.0))
{

d_Nvtms_dTemp_t_GND = d_Vtm_dTemp_t_GND*(model_.NJS);
Nvtms = (Vtm*(model_.NJS));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(model_.BVS))/Nvtms));

d_XExpBVS_dTemp_t_GND = evaluator_lexp_0.getDerivs(((-(model_.BVS))/Nvtms),(-(-(model_.BVS))*d_Nvtms_dTemp_t_GND/Nvtms/Nvtms))*(model_.XJBVS);
XExpBVS = (evaluator_lexp_0.getValues(((-(model_.BVS))/Nvtms))*(model_.XJBVS));
}
{
double value_max_0 = std::max(((model_.IJTHSFWD)/Isbs),static_cast<double>(10.0));
double  deriv_max_0_d0 = ((((model_.IJTHSFWD)/Isbs)>=10.0)?1.0:0.0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi =  0.0;
d_T2_dTemp_t_GND = (deriv_max_0_d0*((-(model_.IJTHSFWD)*d_Isbs_dTemp_t_GND/Isbs/Isbs)));
T2 = value_max_0;
}

d_Tb_dTemp_t_GND = (d_T2_dTemp_t_GND-d_XExpBVS_dTemp_t_GND);
Tb = ((1.0+T2)-XExpBVS);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVS)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_VjsmFwd_dTemp_t_GND = (Nvtms*evaluator_lln_1.getDerivs((0.5*(Tb+value_sqrt_0)),0.5*(d_Tb_dTemp_t_GND+(deriv_sqrt_0_d0*(((Tb*d_Tb_dTemp_t_GND+d_Tb_dTemp_t_GND*Tb)+4*d_XExpBVS_dTemp_t_GND)))))+d_Nvtms_dTemp_t_GND*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
VjsmFwd = (Nvtms*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjsmFwd/Nvtms));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = evaluator_lexp_0.getDerivs((VjsmFwd/Nvtms),((Nvtms*d_VjsmFwd_dTemp_t_GND-VjsmFwd*d_Nvtms_dTemp_t_GND)/Nvtms/Nvtms));
T0 = evaluator_lexp_0.getValues((VjsmFwd/Nvtms));
}

d_IVjsmFwd_dTemp_t_GND = (Isbs*((d_T0_dTemp_t_GND-((T0*d_XExpBVS_dTemp_t_GND-XExpBVS*d_T0_dTemp_t_GND)/T0/T0))+d_XExpBVS_dTemp_t_GND)+d_Isbs_dTemp_t_GND*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
IVjsmFwd = (Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));

d_SslpFwd_dTemp_t_GND = ((Nvtms*(Isbs*(d_T0_dTemp_t_GND+((T0*d_XExpBVS_dTemp_t_GND-XExpBVS*d_T0_dTemp_t_GND)/T0/T0))+d_Isbs_dTemp_t_GND*(T0+(XExpBVS/T0)))-(Isbs*(T0+(XExpBVS/T0)))*d_Nvtms_dTemp_t_GND)/Nvtms/Nvtms);
SslpFwd = ((Isbs*(T0+(XExpBVS/T0)))/Nvtms);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.IJTHSREV)/Isbs)-10.0),1.0E-3);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi =  0.0;
d_T2_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.IJTHSREV)/Isbs)-10.0),1.0E-3,(-(model_.IJTHSREV)*d_Isbs_dTemp_t_GND/Isbs/Isbs),0.0);
T2 = (evaluator_hypsmooth_0.getValues((((model_.IJTHSREV)/Isbs)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((T2-1.0)/(model_.XJBVS)));

d_VjsmRev_dTemp_t_GND = (-(Nvtms*evaluator_lln_0.getDerivs(((T2-1.0)/(model_.XJBVS)),(d_T2_dTemp_t_GND/(model_.XJBVS)))+d_Nvtms_dTemp_t_GND*evaluator_lln_0.getValues(((T2-1.0)/(model_.XJBVS)))));
VjsmRev = ((-(model_.BVS))-(Nvtms*evaluator_lln_0.getValues(((T2-1.0)/(model_.XJBVS)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-((model_.BVS)+VjsmRev))/Nvtms));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (model_.XJBVS)*evaluator_lexp_0.getDerivs(((-((model_.BVS)+VjsmRev))/Nvtms),((Nvtms*(-d_VjsmRev_dTemp_t_GND)-(-((model_.BVS)+VjsmRev))*d_Nvtms_dTemp_t_GND)/Nvtms/Nvtms));
T1 = ((model_.XJBVS)*evaluator_lexp_0.getValues(((-((model_.BVS)+VjsmRev))/Nvtms)));
}

d_IVjsmRev_dTemp_t_GND = (Isbs*d_T1_dTemp_t_GND+d_Isbs_dTemp_t_GND*(1.0+T1));
IVjsmRev = (Isbs*(1.0+T1));

d_SslpRev_dTemp_t_GND = ((Nvtms*((-Isbs)*d_T1_dTemp_t_GND+(-d_Isbs_dTemp_t_GND)*T1)-((-Isbs)*T1)*d_Nvtms_dTemp_t_GND)/Nvtms/Nvtms);
SslpRev = (((-Isbs)*T1)/Nvtms);
}
else
{

d_Nvtms_dTemp_t_GND =  0.0;
Nvtms = 0;

d_XExpBVS_dTemp_t_GND =  0.0;
XExpBVS = 0;

d_VjsmFwd_dTemp_t_GND =  0.0;
VjsmFwd = 0;

d_IVjsmFwd_dTemp_t_GND =  0.0;
IVjsmFwd = 0;

d_SslpFwd_dTemp_t_GND =  0.0;
SslpFwd = 0;

d_VjsmRev_dTemp_t_GND =  0.0;
VjsmRev = 0;

d_IVjsmRev_dTemp_t_GND =  0.0;
IVjsmRev = 0;

d_SslpRev_dTemp_t_GND =  0.0;
SslpRev = 0;
}

d_Isbd_dTemp_t_GND = (((ADeff*d_JSD_t_dTemp_t_GND+d_ADeff_dTemp_t_GND*JSD_t)+(PDeff*d_JSWD_t_dTemp_t_GND+d_PDeff_dTemp_t_GND*JSWD_t))+(Weffcj*NF)*d_JSWGD_t_dTemp_t_GND);
Isbd = (((ADeff*JSD_t)+(PDeff*JSWD_t))+((Weffcj*NF)*JSWGD_t));
if ((Isbd>0.0))
{

d_Nvtmd_dTemp_t_GND = d_Vtm_dTemp_t_GND*(model_.NJD);
Nvtmd = (Vtm*(model_.NJD));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(model_.BVD))/Nvtmd));

d_XExpBVD_dTemp_t_GND = evaluator_lexp_0.getDerivs(((-(model_.BVD))/Nvtmd),(-(-(model_.BVD))*d_Nvtmd_dTemp_t_GND/Nvtmd/Nvtmd))*(model_.XJBVD);
XExpBVD = (evaluator_lexp_0.getValues(((-(model_.BVD))/Nvtmd))*(model_.XJBVD));
}
{
double value_max_0 = std::max(((model_.IJTHDFWD)/Isbd),static_cast<double>(10.0));
double  deriv_max_0_d0 = ((((model_.IJTHDFWD)/Isbd)>=10.0)?1.0:0.0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi =  0.0;
d_T2_dTemp_t_GND = (deriv_max_0_d0*((-(model_.IJTHDFWD)*d_Isbd_dTemp_t_GND/Isbd/Isbd)));
T2 = value_max_0;
}

d_Tb_dTemp_t_GND = (d_T2_dTemp_t_GND-d_XExpBVD_dTemp_t_GND);
Tb = ((1.0+T2)-XExpBVD);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVD)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_VjdmFwd_dTemp_t_GND = (Nvtmd*evaluator_lln_1.getDerivs((0.5*(Tb+value_sqrt_0)),0.5*(d_Tb_dTemp_t_GND+(deriv_sqrt_0_d0*(((Tb*d_Tb_dTemp_t_GND+d_Tb_dTemp_t_GND*Tb)+4*d_XExpBVD_dTemp_t_GND)))))+d_Nvtmd_dTemp_t_GND*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
VjdmFwd = (Nvtmd*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjdmFwd/Nvtmd));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = evaluator_lexp_0.getDerivs((VjdmFwd/Nvtmd),((Nvtmd*d_VjdmFwd_dTemp_t_GND-VjdmFwd*d_Nvtmd_dTemp_t_GND)/Nvtmd/Nvtmd));
T0 = evaluator_lexp_0.getValues((VjdmFwd/Nvtmd));
}

d_IVjdmFwd_dTemp_t_GND = (Isbd*((d_T0_dTemp_t_GND-((T0*d_XExpBVD_dTemp_t_GND-XExpBVD*d_T0_dTemp_t_GND)/T0/T0))+d_XExpBVD_dTemp_t_GND)+d_Isbd_dTemp_t_GND*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
IVjdmFwd = (Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));

d_DslpFwd_dTemp_t_GND = ((Nvtmd*(Isbd*(d_T0_dTemp_t_GND+((T0*d_XExpBVD_dTemp_t_GND-XExpBVD*d_T0_dTemp_t_GND)/T0/T0))+d_Isbd_dTemp_t_GND*(T0+(XExpBVD/T0)))-(Isbd*(T0+(XExpBVD/T0)))*d_Nvtmd_dTemp_t_GND)/Nvtmd/Nvtmd);
DslpFwd = ((Isbd*(T0+(XExpBVD/T0)))/Nvtmd);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.IJTHDREV)/Isbd)-10.0),1.0E-3);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi =  0.0;
d_T2_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((((model_.IJTHDREV)/Isbd)-10.0),1.0E-3,(-(model_.IJTHDREV)*d_Isbd_dTemp_t_GND/Isbd/Isbd),0.0);
T2 = (evaluator_hypsmooth_0.getValues((((model_.IJTHDREV)/Isbd)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((T2-1.0)/(model_.XJBVD)));

d_VjdmRev_dTemp_t_GND = (-(Nvtmd*evaluator_lln_0.getDerivs(((T2-1.0)/(model_.XJBVD)),(d_T2_dTemp_t_GND/(model_.XJBVD)))+d_Nvtmd_dTemp_t_GND*evaluator_lln_0.getValues(((T2-1.0)/(model_.XJBVD)))));
VjdmRev = ((-(model_.BVD))-(Nvtmd*evaluator_lln_0.getValues(((T2-1.0)/(model_.XJBVD)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-((model_.BVD)+VjdmRev))/Nvtmd));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (model_.XJBVD)*evaluator_lexp_0.getDerivs(((-((model_.BVD)+VjdmRev))/Nvtmd),((Nvtmd*(-d_VjdmRev_dTemp_t_GND)-(-((model_.BVD)+VjdmRev))*d_Nvtmd_dTemp_t_GND)/Nvtmd/Nvtmd));
T1 = ((model_.XJBVD)*evaluator_lexp_0.getValues(((-((model_.BVD)+VjdmRev))/Nvtmd)));
}

d_IVjdmRev_dTemp_t_GND = (Isbd*d_T1_dTemp_t_GND+d_Isbd_dTemp_t_GND*(1.0+T1));
IVjdmRev = (Isbd*(1.0+T1));

d_DslpRev_dTemp_t_GND = ((Nvtmd*((-Isbd)*d_T1_dTemp_t_GND+(-d_Isbd_dTemp_t_GND)*T1)-((-Isbd)*T1)*d_Nvtmd_dTemp_t_GND)/Nvtmd/Nvtmd);
DslpRev = (((-Isbd)*T1)/Nvtmd);
}
else
{

d_Nvtmd_dTemp_t_GND =  0.0;
Nvtmd = 0;

d_XExpBVD_dTemp_t_GND =  0.0;
XExpBVD = 0;

d_VjdmFwd_dTemp_t_GND =  0.0;
VjdmFwd = 0;

d_IVjdmFwd_dTemp_t_GND =  0.0;
IVjdmFwd = 0;

d_DslpFwd_dTemp_t_GND =  0.0;
DslpFwd = 0;

d_VjdmRev_dTemp_t_GND =  0.0;
VjdmRev = 0;

d_IVjdmRev_dTemp_t_GND =  0.0;
IVjdmRev = 0;

d_DslpRev_dTemp_t_GND =  0.0;
DslpRev = 0;
}

d_Czbs_dTemp_t_GND = (CJS_t*d_ASeff_dTemp_t_GND+d_CJS_t_dTemp_t_GND*ASeff);
Czbs = (CJS_t*ASeff);

d_Czbssw_dTemp_t_GND = (CJSWS_t*d_PSeff_dTemp_t_GND+d_CJSWS_t_dTemp_t_GND*PSeff);
Czbssw = (CJSWS_t*PSeff);

d_Czbsswg_dTemp_t_GND = d_CJSWGS_t_dTemp_t_GND*Weffcj*NF;
Czbsswg = ((CJSWGS_t*Weffcj)*NF);

d_Czbd_dTemp_t_GND = (CJD_t*d_ADeff_dTemp_t_GND+d_CJD_t_dTemp_t_GND*ADeff);
Czbd = (CJD_t*ADeff);

d_Czbdsw_dTemp_t_GND = (CJSWD_t*d_PDeff_dTemp_t_GND+d_CJSWD_t_dTemp_t_GND*PDeff);
Czbdsw = (CJSWD_t*PDeff);

d_Czbdswg_dTemp_t_GND = d_CJSWGD_t_dTemp_t_GND*Weffcj*NF;
Czbdswg = ((CJSWGD_t*Weffcj)*NF);
if (((((((model_.KU0)!=0)||((model_.KVSAT)!=0))||((model_.KVTH0)!=0))||((model_.STK2)!=0))||((model_.STETA0)!=0)))
{
{
double value_pow_0 = pow(Lnew,(model_.LLODKU0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = value_pow_0;
}
W_tmp_stress = (Wnew+(model_.WLOD));
{
double value_pow_0 = pow(W_tmp_stress,(model_.WLODKU0));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = value_pow_0;
}

d_tmp1_stress_dTemp_t_GND = (((-(model_.LKU0)*d_T0_dTemp_t_GND/T0/T0)+(-(model_.WKU0)*d_T1_dTemp_t_GND/T1/T1))+(-(model_.PKU0)*(T0*d_T1_dTemp_t_GND+d_T0_dTemp_t_GND*T1)/(T0*T1)/(T0*T1)));
tmp1_stress = ((((model_.LKU0)/T0)+((model_.WKU0)/T1))+((model_.PKU0)/(T0*T1)));

d_kstress_u0_dTemp_t_GND = d_tmp1_stress_dTemp_t_GND;
kstress_u0 = (1.0+tmp1_stress);
{
double value_pow_0 = pow(Lnew,(model_.LLODVTH));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = value_pow_0;
}
{
double value_pow_0 = pow(W_tmp_stress,(model_.WLODVTH));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = value_pow_0;
}

d_tmp1_stress_vth_dTemp_t_GND = (((-(model_.LKVTH0)*d_T0_dTemp_t_GND/T0/T0)+(-(model_.WKVTH0)*d_T1_dTemp_t_GND/T1/T1))+(-(model_.PKVTH0)*(T0*d_T1_dTemp_t_GND+d_T0_dTemp_t_GND*T1)/(T0*T1)/(T0*T1)));
tmp1_stress_vth = ((((model_.LKVTH0)/T0)+((model_.WKVTH0)/T1))+((model_.PKVTH0)/(T0*T1)));

d_kstress_vth0_dTemp_t_GND = d_tmp1_stress_vth_dTemp_t_GND;
kstress_vth0 = (1.0+tmp1_stress_vth);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = d_TRatio_dTemp_t_GND;
T0 = (TRatio-1.0);

d_ku0_temp_dTemp_t_GND = (kstress_u0*(model_.TKU0)*d_T0_dTemp_t_GND+d_kstress_u0_dTemp_t_GND*(1.0+((model_.TKU0)*T0)));
ku0_temp = ((kstress_u0*(1.0+((model_.TKU0)*T0)))+1.0e-9);

d_Inv_sa_dTemp_t_GND =  0.0;
Inv_sa = 0;

d_Inv_sb_dTemp_t_GND =  0.0;
Inv_sb = 0;
for (i=0;(i<NF);i=(i+1) )//Begin block forloop
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = ((1.0/NF)/((SA+(0.5*L_mult))+(i*(SD+L_mult))));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = ((1.0/NF)/((SB+(0.5*L_mult))+(i*(SD+L_mult))));

d_Inv_sa_dTemp_t_GND = (d_Inv_sa_dTemp_t_GND+d_T0_dTemp_t_GND);
Inv_sa = (Inv_sa+T0);

d_Inv_sb_dTemp_t_GND = (d_Inv_sb_dTemp_t_GND+d_T1_dTemp_t_GND);
Inv_sb = (Inv_sb+T1);
}
// End block forloop
Inv_saref = (1.0/((model_.SAREF)+(0.5*L_mult)));
Inv_sbref = (1.0/((model_.SBREF)+(0.5*L_mult)));
Inv_odref = (Inv_saref+Inv_sbref);

d_rho_ref_dTemp_t_GND = (-(model_.KU0)*d_ku0_temp_dTemp_t_GND/ku0_temp/ku0_temp)*Inv_odref;
rho_ref = (((model_.KU0)/ku0_temp)*Inv_odref);

d_Inv_od_dTemp_t_GND = (d_Inv_sa_dTemp_t_GND+d_Inv_sb_dTemp_t_GND);
Inv_od = (Inv_sa+Inv_sb);

d_rho_dTemp_t_GND = (((model_.KU0)/ku0_temp)*d_Inv_od_dTemp_t_GND+(-(model_.KU0)*d_ku0_temp_dTemp_t_GND/ku0_temp/ku0_temp)*Inv_od);
rho = (((model_.KU0)/ku0_temp)*Inv_od);

d_mu0_mult_dTemp_t_GND = (((1.0+rho_ref)*d_rho_dTemp_t_GND-(1.0+rho)*d_rho_ref_dTemp_t_GND)/(1.0+rho_ref)/(1.0+rho_ref));
mu0_mult = ((1.0+rho)/(1.0+rho_ref));

d_vsat_mult_dTemp_t_GND = (((1.0+(rho_ref*(model_.KVSAT)))*d_rho_dTemp_t_GND*(model_.KVSAT)-(1.0+(rho*(model_.KVSAT)))*d_rho_ref_dTemp_t_GND*(model_.KVSAT))/(1.0+(rho_ref*(model_.KVSAT)))/(1.0+(rho_ref*(model_.KVSAT))));
vsat_mult = ((1.0+(rho*(model_.KVSAT)))/(1.0+(rho_ref*(model_.KVSAT))));

d_vth0_stress_dTemp_t_GND = (((model_.KVTH0)/kstress_vth0)*d_Inv_od_dTemp_t_GND+(-(model_.KVTH0)*d_kstress_vth0_dTemp_t_GND/kstress_vth0/kstress_vth0)*(Inv_od-Inv_odref));
vth0_stress = (((model_.KVTH0)/kstress_vth0)*(Inv_od-Inv_odref));
{
double value_pow_0 = pow(kstress_vth0,(model_.LODK2));
double  deriv_pow_0_d0 = ((kstress_vth0 == 0.0)?0.0:(value_pow_0*(model_.LODK2)/kstress_vth0));

d_k2_stress_dTemp_t_GND = (((model_.STK2)/value_pow_0)*d_Inv_od_dTemp_t_GND+(-(model_.STK2)*(deriv_pow_0_d0*(d_kstress_vth0_dTemp_t_GND))/value_pow_0/value_pow_0)*(Inv_od-Inv_odref));
k2_stress = (((model_.STK2)/value_pow_0)*(Inv_od-Inv_odref));
}
{
double value_pow_0 = pow(kstress_vth0,(model_.LODETA0));
double  deriv_pow_0_d0 = ((kstress_vth0 == 0.0)?0.0:(value_pow_0*(model_.LODETA0)/kstress_vth0));

d_eta_stress_dTemp_t_GND = (((model_.STETA0)/value_pow_0)*d_Inv_od_dTemp_t_GND+(-(model_.STETA0)*(deriv_pow_0_d0*(d_kstress_vth0_dTemp_t_GND))/value_pow_0/value_pow_0)*(Inv_od-Inv_odref));
eta_stress = (((model_.STETA0)/value_pow_0)*(Inv_od-Inv_odref));
}

d_U0_t_dTemp_t_GND = (U0_t*d_mu0_mult_dTemp_t_GND+d_U0_t_dTemp_t_GND*mu0_mult);
U0_t = (U0_t*mu0_mult);

d_VSAT_t_dTemp_t_GND = (VSAT_t*d_vsat_mult_dTemp_t_GND+d_VSAT_t_dTemp_t_GND*vsat_mult);
VSAT_t = (VSAT_t*vsat_mult);

d_K2_i_dTemp_t_GND = (d_K2_i_dTemp_t_GND+d_k2_stress_dTemp_t_GND);
K2_i = (K2_i+k2_stress);

d_ETA0_t_dTemp_t_GND = (d_ETA0_t_dTemp_t_GND+d_eta_stress_dTemp_t_GND);
ETA0_t = (ETA0_t+eta_stress);
}
else
{

d_vth0_stress_dTemp_t_GND =  0.0;
vth0_stress = 0;
}

d_local_sca_dTemp_t_GND =  0.0;
local_sca = 0.0;

d_local_scb_dTemp_t_GND =  0.0;
local_scb = 0.0;

d_local_scc_dTemp_t_GND =  0.0;
local_scc = 0.0;
if ((model_.WPEMOD))
{
Wdrn = (W/NF);

d_local_sca_dTemp_t_GND =  0.0;
local_sca = SCA;

d_local_scb_dTemp_t_GND =  0.0;
local_scb = SCB;

d_local_scc_dTemp_t_GND =  0.0;
local_scc = SCC;
if ((((!given("SCA"))&&(!given("SCB")))&&(!given("SCC"))))
{
if ((given("SC")&&(SC>0.0)))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (SC+Wdrn);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = (1.0/(model_.SCREF));

d_local_sca_dTemp_t_GND = (-((model_.SCREF)*(model_.SCREF))*SC*d_T1_dTemp_t_GND/(SC*T1)/(SC*T1));
local_sca = (((model_.SCREF)*(model_.SCREF))/(SC*T1));
{
double value_exp_0 = exp((((-10.0)*SC)*T2));
double value_exp_1 = exp((((-10.0)*T1)*T2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;

d_local_scb_dTemp_t_GND = ((((0.1*SC)+(0.01*(model_.SCREF)))*(deriv_exp_0_d0*(((-10.0)*SC)*d_T2_dTemp_t_GND))-(((0.1*T1)+(0.01*(model_.SCREF)))*(deriv_exp_1_d0*((((-10.0)*T1)*d_T2_dTemp_t_GND+(-10.0)*d_T1_dTemp_t_GND*T2)))+0.1*d_T1_dTemp_t_GND*value_exp_1))/Wdrn);
local_scb = (((((0.1*SC)+(0.01*(model_.SCREF)))*value_exp_0)-(((0.1*T1)+(0.01*(model_.SCREF)))*value_exp_1))/Wdrn);
}
{
double value_exp_0 = exp((((-20.0)*SC)*T2));
double value_exp_1 = exp((((-20.0)*T1)*T2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;

d_local_scc_dTemp_t_GND = ((((0.05*SC)+(0.0025*(model_.SCREF)))*(deriv_exp_0_d0*(((-20.0)*SC)*d_T2_dTemp_t_GND))-(((0.05*T1)+(0.0025*(model_.SCREF)))*(deriv_exp_1_d0*((((-20.0)*T1)*d_T2_dTemp_t_GND+(-20.0)*d_T1_dTemp_t_GND*T2)))+0.05*d_T1_dTemp_t_GND*value_exp_1))/Wdrn);
local_scc = (((((0.05*SC)+(0.0025*(model_.SCREF)))*value_exp_0)-(((0.05*T1)+(0.0025*(model_.SCREF)))*value_exp_1))/Wdrn);
}
}
else
{
}
}
}

d_vth0_well_dTemp_t_GND = KVTH0WE_i*((d_local_sca_dTemp_t_GND+(model_.WEB)*d_local_scb_dTemp_t_GND)+(model_.WEC)*d_local_scc_dTemp_t_GND);
vth0_well = (KVTH0WE_i*((local_sca+((model_.WEB)*local_scb))+((model_.WEC)*local_scc)));

d_k2_well_dTemp_t_GND = K2WE_i*((d_local_sca_dTemp_t_GND+(model_.WEB)*d_local_scb_dTemp_t_GND)+(model_.WEC)*d_local_scc_dTemp_t_GND);
k2_well = (K2WE_i*((local_sca+((model_.WEB)*local_scb))+((model_.WEC)*local_scc)));

d_mu_well_dTemp_t_GND = KU0WE_i*((d_local_sca_dTemp_t_GND+(model_.WEB)*d_local_scb_dTemp_t_GND)+(model_.WEC)*d_local_scc_dTemp_t_GND);
mu_well = (1.0+(KU0WE_i*((local_sca+((model_.WEB)*local_scb))+((model_.WEC)*local_scc))));

d_U0_t_dTemp_t_GND = (U0_t*d_mu_well_dTemp_t_GND+d_U0_t_dTemp_t_GND*mu_well);
U0_t = (U0_t*mu_well);

d_K2_i_dTemp_t_GND = (d_K2_i_dTemp_t_GND+d_k2_well_dTemp_t_GND);
K2_i = (K2_i+k2_well);

d_Vg_dV_gi_bi = devsign*d_probeVars[admsProbeID_V_gi_bi][admsProbeID_V_gi_bi];
Vg = (devsign*(probeVars[admsProbeID_V_gi_bi]));

d_Vd_dV_si_bi =  0.0;
d_Vd_dV_di_bi = devsign*d_probeVars[admsProbeID_V_di_bi][admsProbeID_V_di_bi];
Vd = (devsign*(probeVars[admsProbeID_V_di_bi]));

d_Vs_dV_di_bi =  0.0;
d_Vs_dV_si_bi = devsign*d_probeVars[admsProbeID_V_si_bi][admsProbeID_V_si_bi];
Vs = (devsign*(probeVars[admsProbeID_V_si_bi]));

d_Vds_dV_si_bi = (d_Vd_dV_si_bi-d_Vs_dV_si_bi);
d_Vds_dV_di_bi = (d_Vd_dV_di_bi-d_Vs_dV_di_bi);
Vds = (Vd-Vs);

d_Vds_noswap_dV_si_bi = d_Vds_dV_si_bi;
d_Vds_noswap_dV_di_bi = d_Vds_dV_di_bi;
Vds_noswap = Vds;

d_Vsb_noswap_dV_si_bi = d_Vs_dV_si_bi;
Vsb_noswap = Vs;

d_Vdb_noswap_dV_di_bi = d_Vd_dV_di_bi;
Vdb_noswap = Vd;

d_Vbs_jct_dV_sbulk_si = devsign*d_probeVars[admsProbeID_V_sbulk_si][admsProbeID_V_sbulk_si];
Vbs_jct = (devsign*(probeVars[admsProbeID_V_sbulk_si]));

d_Vbd_jct_dV_dbulk_di = devsign*d_probeVars[admsProbeID_V_dbulk_di][admsProbeID_V_dbulk_di];
Vbd_jct = (devsign*(probeVars[admsProbeID_V_dbulk_di]));

d_Vgd_noswap_dV_di_bi = (-d_Vd_dV_di_bi);
d_Vgd_noswap_dV_gi_bi = d_Vg_dV_gi_bi;
Vgd_noswap = (Vg-Vd);

d_Vgs_noswap_dV_si_bi = (-d_Vs_dV_si_bi);
d_Vgs_noswap_dV_gi_bi = d_Vg_dV_gi_bi;
Vgs_noswap = (Vg-Vs);

d_Vgd_ov_noswap_dV_gm_di = devsign*d_probeVars[admsProbeID_V_gm_di][admsProbeID_V_gm_di];
Vgd_ov_noswap = (devsign*(probeVars[admsProbeID_V_gm_di]));

d_Vgs_ov_noswap_dV_gm_si = devsign*d_probeVars[admsProbeID_V_gm_si][admsProbeID_V_gm_si];
Vgs_ov_noswap = (devsign*(probeVars[admsProbeID_V_gm_si]));
sigvds = 1.0;
if ((Vds<0.0))
{
sigvds = (-1.0);

d_Vd_dV_di_bi =  0.0;
d_Vd_dV_si_bi = devsign*d_probeVars[admsProbeID_V_si_bi][admsProbeID_V_si_bi];
Vd = (devsign*(probeVars[admsProbeID_V_si_bi]));

d_Vs_dV_si_bi =  0.0;
d_Vs_dV_di_bi = devsign*d_probeVars[admsProbeID_V_di_bi][admsProbeID_V_di_bi];
Vs = (devsign*(probeVars[admsProbeID_V_di_bi]));
}

d_Vds_dV_di_bi = (d_Vd_dV_di_bi-d_Vs_dV_di_bi);
d_Vds_dV_si_bi = (d_Vd_dV_si_bi-d_Vs_dV_si_bi);
Vds = (Vd-Vs);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdsx_dV_si_bi = (deriv_sqrt_0_d0*((Vds*d_Vds_dV_si_bi+d_Vds_dV_si_bi*Vds)));
d_Vdsx_dV_di_bi = (deriv_sqrt_0_d0*((Vds*d_Vds_dV_di_bi+d_Vds_dV_di_bi*Vds)));
Vdsx = (value_sqrt_0-0.1);
}

d_Vbsx_dV_si_bi = (-(d_Vs_dV_si_bi+0.5*(d_Vds_dV_si_bi-d_Vdsx_dV_si_bi)));
d_Vbsx_dV_di_bi = (-(d_Vs_dV_di_bi+0.5*(d_Vds_dV_di_bi-d_Vdsx_dV_di_bi)));
Vbsx = (-(Vs+(0.5*(Vds-Vdsx))));
{
double value_tanh_0 = tanh(((0.6*Vds_noswap)/Vtm));
double  deriv_tanh_0_d0 = (1.0/cosh(((0.6*Vds_noswap)/Vtm))/cosh(((0.6*Vds_noswap)/Vtm)));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi =  0.0;
d_T0_dTemp_t_GND = (deriv_tanh_0_d0*((-(0.6*Vds_noswap)*d_Vtm_dTemp_t_GND/Vtm/Vtm)));
d_T0_dV_si_bi = (deriv_tanh_0_d0*((0.6*d_Vds_noswap_dV_si_bi/Vtm)));
d_T0_dV_di_bi = (deriv_tanh_0_d0*((0.6*d_Vds_noswap_dV_di_bi/Vtm)));
T0 = value_tanh_0;
}

d_wf_dTemp_t_GND = 0.5*d_T0_dTemp_t_GND;
d_wf_dV_si_bi = 0.5*d_T0_dV_si_bi;
d_wf_dV_di_bi = 0.5*d_T0_dV_di_bi;
wf = (0.5+(0.5*T0));

d_wr_dTemp_t_GND = (-d_wf_dTemp_t_GND);
d_wr_dV_si_bi = (-d_wf_dV_si_bi);
d_wr_dV_di_bi = (-d_wf_dV_di_bi);
wr = (1.0-wf);
if (((model_.ASYMMOD)!=0))
{

d_CDSCD_a_dTemp_t_GND = (CDSCDR_i*d_wr_dTemp_t_GND+CDSCD_i*d_wf_dTemp_t_GND);
d_CDSCD_a_dV_si_bi = (CDSCDR_i*d_wr_dV_si_bi+CDSCD_i*d_wf_dV_si_bi);
d_CDSCD_a_dV_di_bi = (CDSCDR_i*d_wr_dV_di_bi+CDSCD_i*d_wf_dV_di_bi);
CDSCD_a = ((CDSCDR_i*wr)+(CDSCD_i*wf));

d_ETA0_a_dV_si_bi = (ETA0R_t*d_wr_dV_si_bi+ETA0_t*d_wf_dV_si_bi);
d_ETA0_a_dV_di_bi = (ETA0R_t*d_wr_dV_di_bi+ETA0_t*d_wf_dV_di_bi);
d_ETA0_a_dTemp_t_GND = ((ETA0R_t*d_wr_dTemp_t_GND+d_ETA0R_t_dTemp_t_GND*wr)+(ETA0_t*d_wf_dTemp_t_GND+d_ETA0_t_dTemp_t_GND*wf));
ETA0_a = ((ETA0R_t*wr)+(ETA0_t*wf));

d_PDIBLC_a_dTemp_t_GND = (PDIBLCR_i*d_wr_dTemp_t_GND+PDIBLC_i*d_wf_dTemp_t_GND);
d_PDIBLC_a_dV_si_bi = (PDIBLCR_i*d_wr_dV_si_bi+PDIBLC_i*d_wf_dV_si_bi);
d_PDIBLC_a_dV_di_bi = (PDIBLCR_i*d_wr_dV_di_bi+PDIBLC_i*d_wf_dV_di_bi);
PDIBLC_a = ((PDIBLCR_i*wr)+(PDIBLC_i*wf));

d_PCLM_a_dTemp_t_GND = (PCLMR_i*d_wr_dTemp_t_GND+PCLM_i*d_wf_dTemp_t_GND);
d_PCLM_a_dV_si_bi = (PCLMR_i*d_wr_dV_si_bi+PCLM_i*d_wf_dV_si_bi);
d_PCLM_a_dV_di_bi = (PCLMR_i*d_wr_dV_di_bi+PCLM_i*d_wf_dV_di_bi);
PCLM_a = ((PCLMR_i*wr)+(PCLM_i*wf));

d_PSAT_a_dTemp_t_GND = (PSATR_i*d_wr_dTemp_t_GND+PSAT_i*d_wf_dTemp_t_GND);
d_PSAT_a_dV_si_bi = (PSATR_i*d_wr_dV_si_bi+PSAT_i*d_wf_dV_si_bi);
d_PSAT_a_dV_di_bi = (PSATR_i*d_wr_dV_di_bi+PSAT_i*d_wf_dV_di_bi);
PSAT_a = ((PSATR_i*wr)+(PSAT_i*wf));

d_VSAT_a_dV_si_bi = (VSATR_t*d_wr_dV_si_bi+VSAT_t*d_wf_dV_si_bi);
d_VSAT_a_dV_di_bi = (VSATR_t*d_wr_dV_di_bi+VSAT_t*d_wf_dV_di_bi);
d_VSAT_a_dTemp_t_GND = ((VSATR_t*d_wr_dTemp_t_GND+d_VSATR_t_dTemp_t_GND*wr)+(VSAT_t*d_wf_dTemp_t_GND+d_VSAT_t_dTemp_t_GND*wf));
VSAT_a = ((VSATR_t*wr)+(VSAT_t*wf));

d_PTWG_a_dV_si_bi = (PTWGR_t*d_wr_dV_si_bi+PTWG_t*d_wf_dV_si_bi);
d_PTWG_a_dV_di_bi = (PTWGR_t*d_wr_dV_di_bi+PTWG_t*d_wf_dV_di_bi);
d_PTWG_a_dTemp_t_GND = ((PTWGR_t*d_wr_dTemp_t_GND+d_PTWGR_t_dTemp_t_GND*wr)+(PTWG_t*d_wf_dTemp_t_GND+d_PTWG_t_dTemp_t_GND*wf));
PTWG_a = ((PTWGR_t*wr)+(PTWG_t*wf));

d_U0_a_dV_si_bi = (U0R_t*d_wr_dV_si_bi+U0_t*d_wf_dV_si_bi);
d_U0_a_dV_di_bi = (U0R_t*d_wr_dV_di_bi+U0_t*d_wf_dV_di_bi);
d_U0_a_dTemp_t_GND = ((U0R_t*d_wr_dTemp_t_GND+d_U0R_t_dTemp_t_GND*wr)+(U0_t*d_wf_dTemp_t_GND+d_U0_t_dTemp_t_GND*wf));
U0_a = ((U0R_t*wr)+(U0_t*wf));

d_UA_a_dV_si_bi = (UAR_t*d_wr_dV_si_bi+UA_t*d_wf_dV_si_bi);
d_UA_a_dV_di_bi = (UAR_t*d_wr_dV_di_bi+UA_t*d_wf_dV_di_bi);
d_UA_a_dTemp_t_GND = ((UAR_t*d_wr_dTemp_t_GND+d_UAR_t_dTemp_t_GND*wr)+(UA_t*d_wf_dTemp_t_GND+d_UA_t_dTemp_t_GND*wf));
UA_a = ((UAR_t*wr)+(UA_t*wf));

d_UC_a_dV_si_bi = (UCR_t*d_wr_dV_si_bi+UC_t*d_wf_dV_si_bi);
d_UC_a_dV_di_bi = (UCR_t*d_wr_dV_di_bi+UC_t*d_wf_dV_di_bi);
d_UC_a_dTemp_t_GND = ((UCR_t*d_wr_dTemp_t_GND+d_UCR_t_dTemp_t_GND*wr)+(UC_t*d_wf_dTemp_t_GND+d_UC_t_dTemp_t_GND*wf));
UC_a = ((UCR_t*wr)+(UC_t*wf));

d_UD_a_dV_si_bi = (UDR_t*d_wr_dV_si_bi+UD_t*d_wf_dV_si_bi);
d_UD_a_dV_di_bi = (UDR_t*d_wr_dV_di_bi+UD_t*d_wf_dV_di_bi);
d_UD_a_dTemp_t_GND = ((UDR_t*d_wr_dTemp_t_GND+d_UDR_t_dTemp_t_GND*wr)+(UD_t*d_wf_dTemp_t_GND+d_UD_t_dTemp_t_GND*wf));
UD_a = ((UDR_t*wr)+(UD_t*wf));

d_UCS_a_dV_si_bi = (UCSR_t*d_wr_dV_si_bi+UCS_t*d_wf_dV_si_bi);
d_UCS_a_dV_di_bi = (UCSR_t*d_wr_dV_di_bi+UCS_t*d_wf_dV_di_bi);
d_UCS_a_dTemp_t_GND = ((UCSR_t*d_wr_dTemp_t_GND+d_UCSR_t_dTemp_t_GND*wr)+(UCS_t*d_wf_dTemp_t_GND+d_UCS_t_dTemp_t_GND*wf));
UCS_a = ((UCSR_t*wr)+(UCS_t*wf));
}
else
{

d_CDSCD_a_dV_di_bi = d_CDSCD_a_dV_si_bi = d_CDSCD_a_dTemp_t_GND =  0.0;
CDSCD_a = CDSCD_i;

d_ETA0_a_dTemp_t_GND = d_ETA0_a_dV_di_bi = d_ETA0_a_dV_si_bi =  0.0;
ETA0_a = ETA0_i;

d_PDIBLC_a_dV_di_bi = d_PDIBLC_a_dV_si_bi = d_PDIBLC_a_dTemp_t_GND =  0.0;
PDIBLC_a = PDIBLC_i;

d_PCLM_a_dV_di_bi = d_PCLM_a_dV_si_bi = d_PCLM_a_dTemp_t_GND =  0.0;
PCLM_a = PCLM_i;

d_PSAT_a_dV_di_bi = d_PSAT_a_dV_si_bi = d_PSAT_a_dTemp_t_GND =  0.0;
PSAT_a = PSAT_i;

d_VSAT_a_dV_di_bi = d_VSAT_a_dV_si_bi =  0.0;
d_VSAT_a_dTemp_t_GND = d_VSAT_t_dTemp_t_GND;
VSAT_a = VSAT_t;

d_PTWG_a_dV_di_bi = d_PTWG_a_dV_si_bi =  0.0;
d_PTWG_a_dTemp_t_GND = d_PTWG_t_dTemp_t_GND;
PTWG_a = PTWG_t;

d_U0_a_dV_di_bi = d_U0_a_dV_si_bi =  0.0;
d_U0_a_dTemp_t_GND = d_U0_t_dTemp_t_GND;
U0_a = U0_t;

d_UA_a_dV_di_bi = d_UA_a_dV_si_bi =  0.0;
d_UA_a_dTemp_t_GND = d_UA_t_dTemp_t_GND;
UA_a = UA_t;

d_UC_a_dV_di_bi = d_UC_a_dV_si_bi =  0.0;
d_UC_a_dTemp_t_GND = d_UC_t_dTemp_t_GND;
UC_a = UC_t;

d_UD_a_dV_di_bi = d_UD_a_dV_si_bi =  0.0;
d_UD_a_dTemp_t_GND = d_UD_t_dTemp_t_GND;
UD_a = UD_t;

d_UCS_a_dV_di_bi = d_UCS_a_dV_si_bi =  0.0;
d_UCS_a_dTemp_t_GND = d_UCS_t_dTemp_t_GND;
UCS_a = UCS_t;
}
{
double value_sqrt_0 = sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_PhistVbs_dV_si_bi = 0.5*((-d_Vbsx_dV_si_bi)+(deriv_sqrt_0_d0*((((Phist-Vbsx)-0.05)*(-d_Vbsx_dV_si_bi)+(-d_Vbsx_dV_si_bi)*((Phist-Vbsx)-0.05)))));
d_PhistVbs_dV_di_bi = 0.5*((-d_Vbsx_dV_di_bi)+(deriv_sqrt_0_d0*((((Phist-Vbsx)-0.05)*(-d_Vbsx_dV_di_bi)+(-d_Vbsx_dV_di_bi)*((Phist-Vbsx)-0.05)))));
d_PhistVbs_dTemp_t_GND = 0.5*(d_Phist_dTemp_t_GND+(deriv_sqrt_0_d0*((((Phist-Vbsx)-0.05)*d_Phist_dTemp_t_GND+d_Phist_dTemp_t_GND*((Phist-Vbsx)-0.05)))));
PhistVbs = (0.5*(((Phist-Vbsx)+0.05)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(PhistVbs);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtPhistVbs_dV_si_bi = (deriv_sqrt_0_d0*(d_PhistVbs_dV_si_bi));
d_sqrtPhistVbs_dV_di_bi = (deriv_sqrt_0_d0*(d_PhistVbs_dV_di_bi));
d_sqrtPhistVbs_dTemp_t_GND = (deriv_sqrt_0_d0*(d_PhistVbs_dTemp_t_GND));
sqrtPhistVbs = value_sqrt_0;
}

d_Xdep_dV_si_bi = T1DEP*d_sqrtPhistVbs_dV_si_bi;
d_Xdep_dV_di_bi = T1DEP*d_sqrtPhistVbs_dV_di_bi;
d_Xdep_dTemp_t_GND = T1DEP*d_sqrtPhistVbs_dTemp_t_GND;
Xdep = (T1DEP*sqrtPhistVbs);

d_Cdep_dV_si_bi = (-epssi*d_Xdep_dV_si_bi/Xdep/Xdep);
d_Cdep_dV_di_bi = (-epssi*d_Xdep_dV_di_bi/Xdep/Xdep);
d_Cdep_dTemp_t_GND = (-epssi*d_Xdep_dTemp_t_GND/Xdep/Xdep);
Cdep = (epssi/Xdep);

d_cdsc_dV_si_bi = ((CDSCD_a*d_Vdsx_dV_si_bi+d_CDSCD_a_dV_si_bi*Vdsx)-CDSCB_i*d_Vbsx_dV_si_bi);
d_cdsc_dV_di_bi = ((CDSCD_a*d_Vdsx_dV_di_bi+d_CDSCD_a_dV_di_bi*Vdsx)-CDSCB_i*d_Vbsx_dV_di_bi);
d_cdsc_dTemp_t_GND = (d_NFACTOR_t_dTemp_t_GND+d_CDSCD_a_dTemp_t_GND*Vdsx);
cdsc = (((CIT_i+NFACTOR_t)+(CDSCD_a*Vdsx))-(CDSCB_i*Vbsx));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi =  0.0;
d_T1_dV_si_bi = (d_cdsc_dV_si_bi/Cox);
d_T1_dV_di_bi = (d_cdsc_dV_di_bi/Cox);
d_T1_dTemp_t_GND = (d_cdsc_dTemp_t_GND/Cox);
T1 = (1.0+(cdsc/Cox));
{
double value_sqrt_0 = sqrt((((T1-1)*(T1-1))+((0.25*0.05)*0.05)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_n_dV_gm_si = d_n_dV_dbulk_di = d_n_dV_sbulk_si = d_n_dV_gi_bi =  0.0;
d_n_dTemp_t_GND = 0.5*(d_T1_dTemp_t_GND+(deriv_sqrt_0_d0*(((T1-1)*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*(T1-1)))));
d_n_dV_si_bi = 0.5*(d_T1_dV_si_bi+(deriv_sqrt_0_d0*(((T1-1)*d_T1_dV_si_bi+d_T1_dV_si_bi*(T1-1)))));
d_n_dV_di_bi = 0.5*(d_T1_dV_di_bi+(deriv_sqrt_0_d0*(((T1-1)*d_T1_dV_di_bi+d_T1_dV_di_bi*(T1-1)))));
n = (0.5*((T1+1)+value_sqrt_0));
}

d_nVt_dV_gm_si = d_nVt_dV_dbulk_di = d_nVt_dV_sbulk_si = d_nVt_dV_gi_bi =  0.0;
d_nVt_dTemp_t_GND = (n*d_Vt_dTemp_t_GND+d_n_dTemp_t_GND*Vt);
d_nVt_dV_si_bi = d_n_dV_si_bi*Vt;
d_nVt_dV_di_bi = d_n_dV_di_bi*Vt;
nVt = (n*Vt);

d_inv_nVt_dV_gm_si = d_inv_nVt_dV_dbulk_di = d_inv_nVt_dV_sbulk_si = d_inv_nVt_dV_gi_bi =  0.0;
d_inv_nVt_dTemp_t_GND = (-d_nVt_dTemp_t_GND/nVt/nVt);
d_inv_nVt_dV_si_bi = (-d_nVt_dV_si_bi/nVt/nVt);
d_inv_nVt_dV_di_bi = (-d_nVt_dV_di_bi/nVt/nVt);
inv_nVt = (1.0/nVt);

d_dVth_dibl_dV_si_bi = ((-(ETA0_a+(ETAB_i*Vbsx)))*d_Vdsx_dV_si_bi+(-(d_ETA0_a_dV_si_bi+ETAB_i*d_Vbsx_dV_si_bi))*Vdsx);
d_dVth_dibl_dV_di_bi = ((-(ETA0_a+(ETAB_i*Vbsx)))*d_Vdsx_dV_di_bi+(-(d_ETA0_a_dV_di_bi+ETAB_i*d_Vbsx_dV_di_bi))*Vdsx);
d_dVth_dibl_dTemp_t_GND = (-d_ETA0_a_dTemp_t_GND)*Vdsx;
dVth_dibl = ((-(ETA0_a+(ETAB_i*Vbsx)))*Vdsx);
{
double value_pow_0 = pow(TRatio,(model_.KT1EXP));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(model_.KT1EXP)/TRatio));

d_dvth_temp_dTemp_t_GND = ((KT1_i+((model_.KT1L)/Leff))+(KT2_i*Vbsx))*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
d_dvth_temp_dV_si_bi = KT2_i*d_Vbsx_dV_si_bi*(value_pow_0-1.0);
d_dvth_temp_dV_di_bi = KT2_i*d_Vbsx_dV_di_bi*(value_pow_0-1.0);
dvth_temp = (((KT1_i+((model_.KT1L)/Leff))+(KT2_i*Vbsx))*(value_pow_0-1.0));
}
{
double value_sqrt_0 = sqrt((((dVth_dibl)*(dVth_dibl))+((0.25*5.0e-5)*5.0e-5)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_dVth_dibl_dV_si_bi = 0.5*(d_dVth_dibl_dV_si_bi-(deriv_sqrt_0_d0*(((dVth_dibl)*d_dVth_dibl_dV_si_bi+d_dVth_dibl_dV_si_bi*(dVth_dibl)))));
d_dVth_dibl_dV_di_bi = 0.5*(d_dVth_dibl_dV_di_bi-(deriv_sqrt_0_d0*(((dVth_dibl)*d_dVth_dibl_dV_di_bi+d_dVth_dibl_dV_di_bi*(dVth_dibl)))));
d_dVth_dibl_dTemp_t_GND = 0.5*(d_dVth_dibl_dTemp_t_GND-(deriv_sqrt_0_d0*(((dVth_dibl)*d_dVth_dibl_dTemp_t_GND+d_dVth_dibl_dTemp_t_GND*(dVth_dibl)))));
dVth_dibl = ((0.5*(dVth_dibl-value_sqrt_0))+(0.25*5.0e-5));
}
if ((DVTP0_i>0.0))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dTemp_t_GND =  0.0;
d_T0_dV_si_bi = (-DVTP1_i)*d_Vdsx_dV_si_bi;
d_T0_dV_di_bi = (-DVTP1_i)*d_Vdsx_dV_di_bi;
T0 = ((-DVTP1_i)*Vdsx);
if ((T0<(-80.0)))
{

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = 1.804851387e-35;
}
else
{
{
double value_exp_0 = exp(T0);
double  deriv_exp_0_d0 = value_exp_0;

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi =  0.0;
d_T2_dTemp_t_GND = (deriv_exp_0_d0*(d_T0_dTemp_t_GND));
d_T2_dV_si_bi = (deriv_exp_0_d0*(d_T0_dV_si_bi));
d_T2_dV_di_bi = (deriv_exp_0_d0*(d_T0_dV_di_bi));
T2 = value_exp_0;
}
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi =  0.0;
d_T3_dTemp_t_GND = DVTP0_i*d_T2_dTemp_t_GND;
d_T3_dV_si_bi = DVTP0_i*d_T2_dV_si_bi;
d_T3_dV_di_bi = DVTP0_i*d_T2_dV_di_bi;
T3 = (Leff+(DVTP0_i*(1.0+T2)));
{
AnalogFunctions::llnEvaluator evaluator_lln_0((Leff/T3));

d_dVth_ldop_dTemp_t_GND = ((-nVt)*evaluator_lln_0.getDerivs((Leff/T3),(-Leff*d_T3_dTemp_t_GND/T3/T3))+(-d_nVt_dTemp_t_GND)*evaluator_lln_0.getValues((Leff/T3)));
d_dVth_ldop_dV_si_bi = ((-nVt)*evaluator_lln_0.getDerivs((Leff/T3),(-Leff*d_T3_dV_si_bi/T3/T3))+(-d_nVt_dV_si_bi)*evaluator_lln_0.getValues((Leff/T3)));
d_dVth_ldop_dV_di_bi = ((-nVt)*evaluator_lln_0.getDerivs((Leff/T3),(-Leff*d_T3_dV_di_bi/T3/T3))+(-d_nVt_dV_di_bi)*evaluator_lln_0.getValues((Leff/T3)));
dVth_ldop = ((-nVt)*evaluator_lln_0.getValues((Leff/T3)));
}
}
else
{

d_dVth_ldop_dV_di_bi = d_dVth_ldop_dV_si_bi = d_dVth_ldop_dTemp_t_GND =  0.0;
dVth_ldop = 0;
}
{
double value_pow_0 = pow(Leff,DVTP3_i);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dV_di_bi = d_T4_dV_si_bi = d_T4_dTemp_t_GND =  0.0;
T4 = (DVTP5_i+(DVTP2_i/value_pow_0));
}
{
double value_tanh_0 = tanh((DVTP4_i*Vdsx));
double  deriv_tanh_0_d0 = (1.0/cosh((DVTP4_i*Vdsx))/cosh((DVTP4_i*Vdsx)));

d_dVth_ldop_dTemp_t_GND = (d_dVth_ldop_dTemp_t_GND-d_T4_dTemp_t_GND*value_tanh_0);
d_dVth_ldop_dV_si_bi = (d_dVth_ldop_dV_si_bi-(T4*(deriv_tanh_0_d0*(DVTP4_i*d_Vdsx_dV_si_bi))+d_T4_dV_si_bi*value_tanh_0));
d_dVth_ldop_dV_di_bi = (d_dVth_ldop_dV_di_bi-(T4*(deriv_tanh_0_d0*(DVTP4_i*d_Vdsx_dV_di_bi))+d_T4_dV_di_bi*value_tanh_0));
dVth_ldop = (dVth_ldop-(T4*value_tanh_0));
}
VFB_i = (VFB_i+(model_.DELVT0));

d_vg_dV_gm_si = d_vg_dV_dbulk_di = d_vg_dV_sbulk_si =  0.0;
d_vg_dTemp_t_GND = Vg*d_inv_nVt_dTemp_t_GND;
d_vg_dV_si_bi = Vg*d_inv_nVt_dV_si_bi;
d_vg_dV_di_bi = Vg*d_inv_nVt_dV_di_bi;
d_vg_dV_gi_bi = (Vg*d_inv_nVt_dV_gi_bi+d_Vg_dV_gi_bi*inv_nVt);
vg = (Vg*inv_nVt);

d_vs_dV_gm_si = d_vs_dV_dbulk_di = d_vs_dV_sbulk_si = d_vs_dV_gi_bi =  0.0;
d_vs_dTemp_t_GND = Vs*d_inv_nVt_dTemp_t_GND;
d_vs_dV_si_bi = (Vs*d_inv_nVt_dV_si_bi+d_Vs_dV_si_bi*inv_nVt);
d_vs_dV_di_bi = (Vs*d_inv_nVt_dV_di_bi+d_Vs_dV_di_bi*inv_nVt);
vs = (Vs*inv_nVt);

d_vfb_dV_gm_si = d_vfb_dV_dbulk_di = d_vfb_dV_sbulk_si = d_vfb_dV_gi_bi =  0.0;
d_vfb_dTemp_t_GND = VFB_i*d_inv_nVt_dTemp_t_GND;
d_vfb_dV_si_bi = VFB_i*d_inv_nVt_dV_si_bi;
d_vfb_dV_di_bi = VFB_i*d_inv_nVt_dV_di_bi;
vfb = (VFB_i*inv_nVt);

d_dVth_VNUD_dV_si_bi = (K1_i*d_sqrtPhistVbs_dV_si_bi-K2_i*d_Vbsx_dV_si_bi);
d_dVth_VNUD_dV_di_bi = (K1_i*d_sqrtPhistVbs_dV_di_bi-K2_i*d_Vbsx_dV_di_bi);
d_dVth_VNUD_dTemp_t_GND = (K1_i*(d_sqrtPhistVbs_dTemp_t_GND-d_sqrtPhist_dTemp_t_GND)-d_K2_i_dTemp_t_GND*Vbsx);
dVth_VNUD = ((K1_i*(sqrtPhistVbs-sqrtPhist))-(K2_i*Vbsx));

d_Vth_shift_dV_si_bi = (((d_dVth_dibl_dV_si_bi+d_dVth_ldop_dV_si_bi)+d_dVth_VNUD_dV_si_bi)-d_dvth_temp_dV_si_bi);
d_Vth_shift_dV_di_bi = (((d_dVth_dibl_dV_di_bi+d_dVth_ldop_dV_di_bi)+d_dVth_VNUD_dV_di_bi)-d_dvth_temp_dV_di_bi);
d_Vth_shift_dTemp_t_GND = (((((d_dVth_dibl_dTemp_t_GND+d_dVth_ldop_dTemp_t_GND)+d_dVth_VNUD_dTemp_t_GND)-d_dvth_temp_dTemp_t_GND)+d_vth0_stress_dTemp_t_GND)+d_vth0_well_dTemp_t_GND);
Vth_shift = (((((dVth_dibl+dVth_ldop)+dVth_VNUD)-dvth_temp)+vth0_stress)+vth0_well);

d_vgfb_dV_gm_si = d_vgfb_dV_dbulk_di = d_vgfb_dV_sbulk_si =  0.0;
d_vgfb_dTemp_t_GND = ((d_vg_dTemp_t_GND-d_vfb_dTemp_t_GND)-(Vth_shift*d_inv_nVt_dTemp_t_GND+d_Vth_shift_dTemp_t_GND*inv_nVt));
d_vgfb_dV_si_bi = ((d_vg_dV_si_bi-d_vfb_dV_si_bi)-(Vth_shift*d_inv_nVt_dV_si_bi+d_Vth_shift_dV_si_bi*inv_nVt));
d_vgfb_dV_di_bi = ((d_vg_dV_di_bi-d_vfb_dV_di_bi)-(Vth_shift*d_inv_nVt_dV_di_bi+d_Vth_shift_dV_di_bi*inv_nVt));
d_vgfb_dV_gi_bi = ((d_vg_dV_gi_bi-d_vfb_dV_gi_bi)-Vth_shift*d_inv_nVt_dV_gi_bi);
vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_Vt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_gam_dV_gm_si = d_gam_dV_dbulk_di = d_gam_dV_sbulk_si = d_gam_dV_gi_bi = d_gam_dV_di_bi = d_gam_dV_si_bi =  0.0;
d_gam_dTemp_t_GND = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_Vt_dTemp_t_GND))/Cox);
gam = (value_sqrt_0/Cox);
}
q_vth = 0.5;
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((2*phib)+(Vs*inv_Vt)),1e-3);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi =  0.0;
d_T0_dV_si_bi = evaluator_hypsmooth_0.getDerivs(((2*phib)+(Vs*inv_Vt)),1e-3,d_Vs_dV_si_bi*inv_Vt,0.0);
d_T0_dV_di_bi = evaluator_hypsmooth_0.getDerivs(((2*phib)+(Vs*inv_Vt)),1e-3,d_Vs_dV_di_bi*inv_Vt,0.0);
d_T0_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs(((2*phib)+(Vs*inv_Vt)),1e-3,(2*d_phib_dTemp_t_GND+Vs*d_inv_Vt_dTemp_t_GND),0.0);
T0 = evaluator_hypsmooth_0.getValues(((2*phib)+(Vs*inv_Vt)),1e-3);
}
{
double value_sqrt_0 = sqrt(T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_nq_dV_gm_si = d_nq_dV_gm_di = d_nq_dV_dbulk_di = d_nq_dV_sbulk_si = d_nq_dV_gi_bi =  0.0;
d_nq_dV_si_bi = (((2.0*value_sqrt_0)*d_gam_dV_si_bi-gam*2.0*(deriv_sqrt_0_d0*(d_T0_dV_si_bi)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
d_nq_dV_di_bi = (((2.0*value_sqrt_0)*d_gam_dV_di_bi-gam*2.0*(deriv_sqrt_0_d0*(d_T0_dV_di_bi)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
d_nq_dTemp_t_GND = (((2.0*value_sqrt_0)*d_gam_dTemp_t_GND-gam*2.0*(deriv_sqrt_0_d0*(d_T0_dTemp_t_GND)))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
nq = (1.0+(gam/(2.0*value_sqrt_0)));
}
{
double value_log_0 = log(q_vth);
double value_sqrt_1 = sqrt(T0);
double value_log_2 = log((((2*nq)/gam)*((((2*q_vth)*nq)/gam)+(2*value_sqrt_1))));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_3((((((Vs*inv_Vt)+(2*phib))+value_log_0)+(2*q_vth))+value_log_2),1e-3);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(((2*nq)/gam)*((((2*q_vth)*nq)/gam)+(2*value_sqrt_1))));
psip_th = evaluator_hypsmooth_3.getValues((((((Vs*inv_Vt)+(2*phib))+value_log_0)+(2*q_vth))+value_log_2),1e-3);
}
{
double value_sqrt_0 = sqrt(psip_th);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
VTH = (((VFB_i+((psip_th-(Vs*inv_Vt))*Vt))+((Vt*gam)*value_sqrt_0))+Vth_shift);
}
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_gam_dV_gm_si = d_gam_dV_dbulk_di = d_gam_dV_sbulk_si = d_gam_dV_gi_bi =  0.0;
d_gam_dTemp_t_GND = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dTemp_t_GND))/Cox);
d_gam_dV_si_bi = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_si_bi))/Cox);
d_gam_dV_di_bi = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_di_bi))/Cox);
gam = (value_sqrt_0/Cox);
}

d_inv_gam_dV_gm_si = d_inv_gam_dV_dbulk_di = d_inv_gam_dV_sbulk_si = d_inv_gam_dV_gi_bi =  0.0;
d_inv_gam_dTemp_t_GND = (-d_gam_dTemp_t_GND/gam/gam);
d_inv_gam_dV_si_bi = (-d_gam_dV_si_bi/gam/gam);
d_inv_gam_dV_di_bi = (-d_gam_dV_di_bi/gam/gam);
inv_gam = (1.0/gam);

d_phib_n_dV_gm_si = d_phib_n_dV_dbulk_di = d_phib_n_dV_sbulk_si = d_phib_n_dV_gi_bi =  0.0;
d_phib_n_dV_si_bi = (-phib*d_n_dV_si_bi/n/n);
d_phib_n_dV_di_bi = (-phib*d_n_dV_di_bi/n/n);
d_phib_n_dTemp_t_GND = ((n*d_phib_dTemp_t_GND-phib*d_n_dTemp_t_GND)/n/n);
phib_n = (phib/n);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = 1.0;

d_vgfbPD_dV_gm_si = d_vgfbPD_dV_dbulk_di = d_vgfbPD_dV_sbulk_si =  0.0;
d_vgfbPD_dTemp_t_GND = ((T1*d_vgfb_dTemp_t_GND-vgfb*d_T1_dTemp_t_GND)/T1/T1);
d_vgfbPD_dV_si_bi = ((T1*d_vgfb_dV_si_bi-vgfb*d_T1_dV_si_bi)/T1/T1);
d_vgfbPD_dV_di_bi = ((T1*d_vgfb_dV_di_bi-vgfb*d_T1_dV_di_bi)/T1/T1);
d_vgfbPD_dV_gi_bi = ((T1*d_vgfb_dV_gi_bi-vgfb*d_T1_dV_gi_bi)/T1/T1);
vgfbPD = (vgfb/T1);

d_gammaPD_dV_gm_si = d_gammaPD_dV_dbulk_di = d_gammaPD_dV_sbulk_si = d_gammaPD_dV_gi_bi =  0.0;
d_gammaPD_dTemp_t_GND = ((T1*d_gam_dTemp_t_GND-gam*d_T1_dTemp_t_GND)/T1/T1);
d_gammaPD_dV_si_bi = ((T1*d_gam_dV_si_bi-gam*d_T1_dV_si_bi)/T1/T1);
d_gammaPD_dV_di_bi = ((T1*d_gam_dV_di_bi-gam*d_T1_dV_di_bi)/T1/T1);
gammaPD = (gam/T1);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = (0.5*d_vgfbPD_dTemp_t_GND-3.0*(d_gammaPD_dTemp_t_GND/1.41421356237309504880));
d_T1_dV_si_bi = (0.5*d_vgfbPD_dV_si_bi-3.0*(d_gammaPD_dV_si_bi/1.41421356237309504880));
d_T1_dV_di_bi = (0.5*d_vgfbPD_dV_di_bi-3.0*(d_gammaPD_dV_di_bi/1.41421356237309504880));
d_T1_dV_gi_bi = (0.5*d_vgfbPD_dV_gi_bi-3.0*(d_gammaPD_dV_gi_bi/1.41421356237309504880));
T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
{
double value_sqrt_0 = sqrt(((T1*T1)+(6.0*vgfbPD)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND+(deriv_sqrt_0_d0*(((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)+6.0*d_vgfbPD_dTemp_t_GND))));
d_T2_dV_si_bi = (d_T1_dV_si_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)+6.0*d_vgfbPD_dV_si_bi))));
d_T2_dV_di_bi = (d_T1_dV_di_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)+6.0*d_vgfbPD_dV_di_bi))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)+6.0*d_vgfbPD_dV_gi_bi))));
T2 = (T1+value_sqrt_0);
}
if ((vgfbPD<0.0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = ((gammaPD*(d_vgfbPD_dTemp_t_GND-d_T2_dTemp_t_GND)-(vgfbPD-T2)*d_gammaPD_dTemp_t_GND)/gammaPD/gammaPD);
d_T3_dV_si_bi = ((gammaPD*(d_vgfbPD_dV_si_bi-d_T2_dV_si_bi)-(vgfbPD-T2)*d_gammaPD_dV_si_bi)/gammaPD/gammaPD);
d_T3_dV_di_bi = ((gammaPD*(d_vgfbPD_dV_di_bi-d_T2_dV_di_bi)-(vgfbPD-T2)*d_gammaPD_dV_di_bi)/gammaPD/gammaPD);
d_T3_dV_gi_bi = ((gammaPD*(d_vgfbPD_dV_gi_bi-d_T2_dV_gi_bi)-(vgfbPD-T2)*d_gammaPD_dV_gi_bi)/gammaPD/gammaPD);
T3 = ((vgfbPD-T2)/gammaPD);
{
double value_log_0 = log(((1.0-T2)+(T3*T3)));
double  deriv_log_0_d0 = (1.0/((1.0-T2)+(T3*T3)));

d_psip_dV_gm_di = d_psip_dV_gm_si = d_psip_dV_dbulk_di = d_psip_dV_sbulk_si =  0.0;
d_psip_dTemp_t_GND = (-(deriv_log_0_d0*(((-d_T2_dTemp_t_GND)+(T3*d_T3_dTemp_t_GND+d_T3_dTemp_t_GND*T3)))));
d_psip_dV_si_bi = (-(deriv_log_0_d0*(((-d_T2_dV_si_bi)+(T3*d_T3_dV_si_bi+d_T3_dV_si_bi*T3)))));
d_psip_dV_di_bi = (-(deriv_log_0_d0*(((-d_T2_dV_di_bi)+(T3*d_T3_dV_di_bi+d_T3_dV_di_bi*T3)))));
d_psip_dV_gi_bi = (-(deriv_log_0_d0*(((-d_T2_dV_gi_bi)+(T3*d_T3_dV_gi_bi+d_T3_dV_gi_bi*T3)))));
psip = (-value_log_0);
}
}
else
{
{
double value_exp_0 = exp((-T2));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*((-d_T2_dTemp_t_GND)));
d_T3_dV_si_bi = (deriv_exp_0_d0*((-d_T2_dV_si_bi)));
d_T3_dV_di_bi = (deriv_exp_0_d0*((-d_T2_dV_di_bi)));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((-d_T2_dV_gi_bi)));
T3 = value_exp_0;
}

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi =  0.0;
d_T1_dTemp_t_GND = 0.5*d_gammaPD_dTemp_t_GND;
d_T1_dV_si_bi = 0.5*d_gammaPD_dV_si_bi;
d_T1_dV_di_bi = 0.5*d_gammaPD_dV_di_bi;
T1 = (0.5*gammaPD);
{
double value_sqrt_0 = sqrt((((vgfbPD-1.0)+T3)+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = ((deriv_sqrt_0_d0*(((d_vgfbPD_dTemp_t_GND+d_T3_dTemp_t_GND)+(T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1))))-d_T1_dTemp_t_GND);
d_T2_dV_si_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_si_bi+d_T3_dV_si_bi)+(T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1))))-d_T1_dV_si_bi);
d_T2_dV_di_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_di_bi+d_T3_dV_di_bi)+(T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1))))-d_T1_dV_di_bi);
d_T2_dV_gi_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_gi_bi+d_T3_dV_gi_bi)+(T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1))))-d_T1_dV_gi_bi);
T2 = (value_sqrt_0-T1);
}

d_psip_dV_gm_di = d_psip_dV_gm_si = d_psip_dV_dbulk_di = d_psip_dV_sbulk_si =  0.0;
d_psip_dTemp_t_GND = ((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2)-d_T3_dTemp_t_GND);
d_psip_dV_si_bi = ((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2)-d_T3_dV_si_bi);
d_psip_dV_di_bi = ((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2)-d_T3_dV_di_bi);
d_psip_dV_gi_bi = ((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2)-d_T3_dV_gi_bi);
psip = (((T2*T2)+1.0)-T3);
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si = d_T8_dV_dbulk_di = d_T8_dV_sbulk_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_T8_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_T8_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_T8_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dV_gm_di = d_sqrtpsip_dV_gm_si = d_sqrtpsip_dV_dbulk_di = d_sqrtpsip_dV_sbulk_si =  0.0;
d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T8_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_T8_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_T8_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_T8_dV_gi_bi));
sqrtpsip = value_sqrt_0;
}

d_T9_dV_gm_si = d_T9_dV_gm_di = d_T9_dV_dbulk_di = d_T9_dV_sbulk_si =  0.0;
d_T9_dV_gi_bi = (((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dTemp_t_GND = (((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_si_bi = (((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_di_bi = (((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gi_bi)/gam/gam);
d_T0_dTemp_t_GND = ((gam*(((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dTemp_t_GND)/gam/gam);
d_T0_dV_si_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_si_bi)/gam/gam);
d_T0_dV_di_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_di_bi)/gam/gam);
T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_n_dTemp_t_GND)-d_vs_dTemp_t_GND);
d_T1_dV_si_bi = ((d_psip_dV_si_bi-2.0*d_phib_n_dV_si_bi)-d_vs_dV_si_bi);
d_T1_dV_di_bi = ((d_psip_dV_di_bi-2.0*d_phib_n_dV_di_bi)-d_vs_dV_di_bi);
d_T1_dV_gi_bi = ((d_psip_dV_gi_bi-2.0*d_phib_n_dV_gi_bi)-d_vs_dV_gi_bi);
T1 = ((psip-(2.0*phib_n))-vs);
{
double value_log_0 = log(((4.0*T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*T0)*sqrtpsip));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dTemp_t_GND+4.0*d_T0_dTemp_t_GND*sqrtpsip))));
d_T2_dV_si_bi = (d_T1_dV_si_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_si_bi+4.0*d_T0_dV_si_bi*sqrtpsip))));
d_T2_dV_di_bi = (d_T1_dV_di_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_di_bi+4.0*d_T0_dV_di_bi*sqrtpsip))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gi_bi+4.0*d_T0_dV_gi_bi*sqrtpsip))));
T2 = (T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((T2*(T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si = d_T8_dV_dbulk_di = d_T8_dV_sbulk_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND-(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*(T2+0.402982)))));
d_T8_dV_si_bi = 0.5*(d_T2_dV_si_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*(T2+0.402982)))));
d_T8_dV_di_bi = 0.5*(d_T2_dV_di_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*(T2+0.402982)))));
d_T8_dV_gi_bi = 0.5*(d_T2_dV_gi_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*(T2+0.402982)))));
T8 = (0.5*((T2-0.201491)-value_sqrt_0));
}

d_sqrtpsisa_dV_gm_di = d_sqrtpsisa_dV_gm_si = d_sqrtpsisa_dV_dbulk_di = d_sqrtpsisa_dV_sbulk_si =  0.0;
d_sqrtpsisa_dTemp_t_GND = d_sqrtpsip_dTemp_t_GND;
d_sqrtpsisa_dV_si_bi = d_sqrtpsip_dV_si_bi;
d_sqrtpsisa_dV_di_bi = d_sqrtpsip_dV_di_bi;
d_sqrtpsisa_dV_gi_bi = d_sqrtpsip_dV_gi_bi;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dV_di_bi = d_T4_dV_si_bi = d_T4_dTemp_t_GND =  0.0;
T4 = (-100.0);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
T3 = value_exp_0;
}
}
else
{

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = ((T5*(d_T8_dTemp_t_GND-d_T4_dTemp_t_GND)-(T8-T4)*d_T5_dTemp_t_GND)/T5/T5);
d_T2_dV_si_bi = ((T5*(d_T8_dV_si_bi-d_T4_dV_si_bi)-(T8-T4)*d_T5_dV_si_bi)/T5/T5);
d_T2_dV_di_bi = ((T5*(d_T8_dV_di_bi-d_T4_dV_di_bi)-(T8-T4)*d_T5_dV_di_bi)/T5/T5);
d_T2_dV_gi_bi = ((T5*(d_T8_dV_gi_bi-d_T4_dV_gi_bi)-(T8-T4)*d_T5_dV_gi_bi)/T5/T5);
T2 = ((T8-T4)/T5);

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2);
d_T6_dV_si_bi = (T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2);
d_T6_dV_di_bi = (T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2);
d_T6_dV_gi_bi = (T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2);
T6 = (T2*T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*((d_T4_dTemp_t_GND+(T5*(0.5*d_T2_dTemp_t_GND+(T6*(-(T6*(-d_T6_dTemp_t_GND)+d_T6_dTemp_t_GND*(1.25-T6)))+d_T6_dTemp_t_GND*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dTemp_t_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_si_bi = (deriv_exp_0_d0*((d_T4_dV_si_bi+(T5*(0.5*d_T2_dV_si_bi+(T6*(-(T6*(-d_T6_dV_si_bi)+d_T6_dV_si_bi*(1.25-T6)))+d_T6_dV_si_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_si_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_di_bi = (deriv_exp_0_d0*((d_T4_dV_di_bi+(T5*(0.5*d_T2_dV_di_bi+(T6*(-(T6*(-d_T6_dV_di_bi)+d_T6_dV_di_bi*(1.25-T6)))+d_T6_dV_di_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_di_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((d_T4_dV_gi_bi+(T5*(0.5*d_T2_dV_gi_bi+(T6*(-(T6*(-d_T6_dV_gi_bi)+d_T6_dV_gi_bi*(1.25-T6)))+d_T6_dV_gi_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_qs_dV_gm_si = d_qs_dV_gm_di = d_qs_dV_dbulk_di = d_qs_dV_sbulk_si =  0.0;
d_qs_dTemp_t_GND = (T3*((d_T1_dTemp_t_GND-d_T8_dTemp_t_GND)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+2.0*d_T0_dTemp_t_GND*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dTemp_t_GND*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_si_bi = (T3*((d_T1_dV_si_bi-d_T8_dV_si_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+2.0*d_T0_dV_si_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_si_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_di_bi = (T3*((d_T1_dV_di_bi-d_T8_dV_di_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+2.0*d_T0_dV_di_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_di_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_gi_bi = (T3*((d_T1_dV_gi_bi-d_T8_dV_gi_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+2.0*d_T0_dV_gi_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gi_bi*(((1.0+T1)-T8)-value_log_0));
qs = (T3*(((1.0+T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
T3 = value_exp_0;
}

d_sqrtpsisainv_dV_gm_di = d_sqrtpsisainv_dV_gm_si = d_sqrtpsisainv_dV_dbulk_di = d_sqrtpsisainv_dV_sbulk_si =  0.0;
d_sqrtpsisainv_dTemp_t_GND = (-d_sqrtpsisa_dTemp_t_GND/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_si_bi = (-d_sqrtpsisa_dV_si_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_di_bi = (-d_sqrtpsisa_dV_di_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gi_bi = (-d_sqrtpsisa_dV_gi_bi/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T3_dTemp_t_GND-((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5));
d_T3_dV_si_bi = (d_T3_dV_si_bi-((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5));
d_T3_dV_di_bi = (d_T3_dV_di_bi-((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5));
d_T3_dV_gi_bi = (d_T3_dV_gi_bi-((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_si_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_di_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gi_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T7_dV_gm_si = d_T7_dV_gm_di = d_T7_dV_dbulk_di = d_T7_dV_sbulk_si =  0.0;
d_T7_dTemp_t_GND = (((-((1.0/T3)*(-d_T3_dTemp_t_GND/T3/T3)+(-d_T3_dTemp_t_GND/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dTemp_t_GND+(sqrtpsisa*d_sqrtpsisa_dTemp_t_GND+d_sqrtpsisa_dTemp_t_GND*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dTemp_t_GND);
d_T7_dV_si_bi = (((-((1.0/T3)*(-d_T3_dV_si_bi/T3/T3)+(-d_T3_dV_si_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_si_bi+(sqrtpsisa*d_sqrtpsisa_dV_si_bi+d_sqrtpsisa_dV_si_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_si_bi);
d_T7_dV_di_bi = (((-((1.0/T3)*(-d_T3_dV_di_bi/T3/T3)+(-d_T3_dV_di_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_di_bi+(sqrtpsisa*d_sqrtpsisa_dV_di_bi+d_sqrtpsisa_dV_di_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_di_bi);
d_T7_dV_gi_bi = (((-((1.0/T3)*(-d_T3_dV_gi_bi/T3/T3)+(-d_T3_dV_gi_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gi_bi+(sqrtpsisa*d_sqrtpsisa_dV_gi_bi+d_sqrtpsisa_dV_gi_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gi_bi);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);

d_qs_dV_gm_si = d_qs_dV_gm_di = d_qs_dV_dbulk_di = d_qs_dV_sbulk_si =  0.0;
d_qs_dTemp_t_GND = (d_T3_dTemp_t_GND-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dTemp_t_GND+d_T4_dTemp_t_GND*T7)-(T4*T7)*((2.0*T5)*d_T5_dTemp_t_GND+2.0*d_T5_dTemp_t_GND*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_si_bi = (d_T3_dV_si_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_si_bi+d_T4_dV_si_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_si_bi+2.0*d_T5_dV_si_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_di_bi = (d_T3_dV_di_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_di_bi+d_T4_dV_di_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_di_bi+2.0*d_T5_dV_di_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_gi_bi = (d_T3_dV_gi_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gi_bi+d_T4_dV_gi_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gi_bi+2.0*d_T5_dV_gi_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psipclamp_dV_gm_di = d_psipclamp_dV_gm_si = d_psipclamp_dV_dbulk_di = d_psipclamp_dV_sbulk_si =  0.0;
d_psipclamp_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_psipclamp_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_psipclamp_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_psipclamp_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
psipclamp = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(psipclamp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dV_gm_di = d_sqrtpsip_dV_gm_si = d_sqrtpsip_dV_dbulk_di = d_sqrtpsip_dV_sbulk_si =  0.0;
d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_psipclamp_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_gi_bi));
sqrtpsip = value_sqrt_0;
}

d_psiavg_dV_gm_di = d_psiavg_dV_gm_si = d_psiavg_dV_dbulk_di = d_psiavg_dV_sbulk_si =  0.0;
d_psiavg_dTemp_t_GND = (d_psip_dTemp_t_GND-2.0*d_qs_dTemp_t_GND);
d_psiavg_dV_si_bi = (d_psip_dV_si_bi-2.0*d_qs_dV_si_bi);
d_psiavg_dV_di_bi = (d_psip_dV_di_bi-2.0*d_qs_dV_di_bi);
d_psiavg_dV_gi_bi = (d_psip_dV_gi_bi-2.0*d_qs_dV_gi_bi);
psiavg = (psip-(2.0*qs));
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = 0.5*(d_psiavg_dTemp_t_GND+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dTemp_t_GND+d_psiavg_dTemp_t_GND*(psiavg-1.0)))));
d_T0_dV_si_bi = 0.5*(d_psiavg_dV_si_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_si_bi+d_psiavg_dV_si_bi*(psiavg-1.0)))));
d_T0_dV_di_bi = 0.5*(d_psiavg_dV_di_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_di_bi+d_psiavg_dV_di_bi*(psiavg-1.0)))));
d_T0_dV_gi_bi = 0.5*(d_psiavg_dV_gi_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_gi_bi+d_psiavg_dV_gi_bi*(psiavg-1.0)))));
T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_nq_dV_gm_si = d_nq_dV_gm_di = d_nq_dV_dbulk_di = d_nq_dV_sbulk_si =  0.0;
d_nq_dV_gi_bi = (((sqrtpsip+value_sqrt_0)*d_gam_dV_gi_bi-gam*(d_sqrtpsip_dV_gi_bi+(deriv_sqrt_0_d0*(d_T0_dV_gi_bi))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dTemp_t_GND = (((sqrtpsip+value_sqrt_0)*d_gam_dTemp_t_GND-gam*(d_sqrtpsip_dTemp_t_GND+(deriv_sqrt_0_d0*(d_T0_dTemp_t_GND))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dV_si_bi = (((sqrtpsip+value_sqrt_0)*d_gam_dV_si_bi-gam*(d_sqrtpsip_dV_si_bi+(deriv_sqrt_0_d0*(d_T0_dV_si_bi))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dV_di_bi = (((sqrtpsip+value_sqrt_0)*d_gam_dV_di_bi-gam*(d_sqrtpsip_dV_di_bi+(deriv_sqrt_0_d0*(d_T0_dV_di_bi))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
nq = (1.0+(gam/(sqrtpsip+value_sqrt_0)));
}
EeffFactor = (1.0e-8/(epsratio*(model_.TOXE)));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = (nVt*((d_vgfb_dV_gi_bi-d_psip_dV_gi_bi)-((2.0*qs)*d_nq_dV_gi_bi+2.0*d_qs_dV_gi_bi*(nq-1.0)))+d_nVt_dV_gi_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
d_T0_dTemp_t_GND = (nVt*((d_vgfb_dTemp_t_GND-d_psip_dTemp_t_GND)-((2.0*qs)*d_nq_dTemp_t_GND+2.0*d_qs_dTemp_t_GND*(nq-1.0)))+d_nVt_dTemp_t_GND*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
d_T0_dV_si_bi = (nVt*((d_vgfb_dV_si_bi-d_psip_dV_si_bi)-((2.0*qs)*d_nq_dV_si_bi+2.0*d_qs_dV_si_bi*(nq-1.0)))+d_nVt_dV_si_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
d_T0_dV_di_bi = (nVt*((d_vgfb_dV_di_bi-d_psip_dV_di_bi)-((2.0*qs)*d_nq_dV_di_bi+2.0*d_qs_dV_di_bi*(nq-1.0)))+d_nVt_dV_di_bi*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
T0 = (nVt*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((T0)*(T0))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qbs_dV_dbulk_di = d_qbs_dV_sbulk_si =  0.0;
d_qbs_dTemp_t_GND = 0.5*(d_T0_dTemp_t_GND+(deriv_sqrt_0_d0*(((T0)*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*(T0)))));
d_qbs_dV_si_bi = 0.5*(d_T0_dV_si_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_si_bi+d_T0_dV_si_bi*(T0)))));
d_qbs_dV_di_bi = 0.5*(d_T0_dV_di_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_di_bi+d_T0_dV_di_bi*(T0)))));
d_qbs_dV_gi_bi = 0.5*(d_T0_dV_gi_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_gi_bi+d_T0_dV_gi_bi*(T0)))));
qbs = (0.5*(T0+value_sqrt_0));
}

d_qis_dV_dbulk_di = d_qis_dV_sbulk_si =  0.0;
d_qis_dV_si_bi = (((2.0*nq)*nVt)*d_qs_dV_si_bi+((2.0*nq)*d_nVt_dV_si_bi+2.0*d_nq_dV_si_bi*nVt)*qs);
d_qis_dV_di_bi = (((2.0*nq)*nVt)*d_qs_dV_di_bi+((2.0*nq)*d_nVt_dV_di_bi+2.0*d_nq_dV_di_bi*nVt)*qs);
d_qis_dTemp_t_GND = (((2.0*nq)*nVt)*d_qs_dTemp_t_GND+((2.0*nq)*d_nVt_dTemp_t_GND+2.0*d_nq_dTemp_t_GND*nVt)*qs);
d_qis_dV_gi_bi = (((2.0*nq)*nVt)*d_qs_dV_gi_bi+((2.0*nq)*d_nVt_dV_gi_bi+2.0*d_nq_dV_gi_bi*nVt)*qs);
qis = (((2.0*nq)*nVt)*qs);

d_Eeffs_dV_dbulk_di = d_Eeffs_dV_sbulk_si =  0.0;
d_Eeffs_dTemp_t_GND = EeffFactor*(d_qbs_dTemp_t_GND+eta_mu*d_qis_dTemp_t_GND);
d_Eeffs_dV_si_bi = EeffFactor*(d_qbs_dV_si_bi+eta_mu*d_qis_dV_si_bi);
d_Eeffs_dV_di_bi = EeffFactor*(d_qbs_dV_di_bi+eta_mu*d_qis_dV_di_bi);
d_Eeffs_dV_gi_bi = EeffFactor*(d_qbs_dV_gi_bi+eta_mu*d_qis_dV_gi_bi);
Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
{
double value_pow_0 = pow((0.5*(1.0+(qis/qbs))),UCS_a);
double  deriv_pow_0_d0 = (((0.5*(1.0+(qis/qbs))) == 0.0)?0.0:(value_pow_0*UCS_a/(0.5*(1.0+(qis/qbs)))));
double  deriv_pow_0_d1 = ((0.5*(1.0+(qis/qbs))) == 0.0)?0.0:(log((0.5*(1.0+(qis/qbs))))*value_pow_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_si_bi = ((deriv_pow_0_d0*(0.5*((qbs*d_qis_dV_si_bi-qis*d_qbs_dV_si_bi)/qbs/qbs)))+(deriv_pow_0_d1*(d_UCS_a_dV_si_bi)));
d_T2_dV_di_bi = ((deriv_pow_0_d0*(0.5*((qbs*d_qis_dV_di_bi-qis*d_qbs_dV_di_bi)/qbs/qbs)))+(deriv_pow_0_d1*(d_UCS_a_dV_di_bi)));
d_T2_dTemp_t_GND = ((deriv_pow_0_d0*(0.5*((qbs*d_qis_dTemp_t_GND-qis*d_qbs_dTemp_t_GND)/qbs/qbs)))+(deriv_pow_0_d1*(d_UCS_a_dTemp_t_GND)));
d_T2_dV_gi_bi = (deriv_pow_0_d0*(0.5*((qbs*d_qis_dV_gi_bi-qis*d_qbs_dV_gi_bi)/qbs/qbs)));
T2 = value_pow_0;
}
{
double value_pow_0 = pow(Eeffs,EU_i);
double  deriv_pow_0_d0 = ((Eeffs == 0.0)?0.0:(value_pow_0*EU_i/Eeffs));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dV_gi_bi = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_gi_bi))+(-UD_a*d_T2_dV_gi_bi/T2/T2));
d_T3_dV_si_bi = (((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_si_bi))+(d_UA_a_dV_si_bi+(UC_a*d_Vbsx_dV_si_bi+d_UC_a_dV_si_bi*Vbsx))*value_pow_0)+((T2*d_UD_a_dV_si_bi-UD_a*d_T2_dV_si_bi)/T2/T2));
d_T3_dV_di_bi = (((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_di_bi))+(d_UA_a_dV_di_bi+(UC_a*d_Vbsx_dV_di_bi+d_UC_a_dV_di_bi*Vbsx))*value_pow_0)+((T2*d_UD_a_dV_di_bi-UD_a*d_T2_dV_di_bi)/T2/T2));
d_T3_dTemp_t_GND = (((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dTemp_t_GND))+(d_UA_a_dTemp_t_GND+d_UC_a_dTemp_t_GND*Vbsx)*value_pow_0)+((T2*d_UD_a_dTemp_t_GND-UD_a*d_T2_dTemp_t_GND)/T2/T2));
T3 = (((UA_a+(UC_a*Vbsx))*value_pow_0)+(UD_a/T2));
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = d_T3_dTemp_t_GND;
d_T4_dV_si_bi = d_T3_dV_si_bi;
d_T4_dV_di_bi = d_T3_dV_di_bi;
d_T4_dV_gi_bi = d_T3_dV_gi_bi;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Dmobs_dV_dbulk_di = d_Dmobs_dV_sbulk_si =  0.0;
d_Dmobs_dTemp_t_GND = 0.5*(d_T4_dTemp_t_GND+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dTemp_t_GND+d_T4_dTemp_t_GND*(T4-1.0)))));
d_Dmobs_dV_si_bi = 0.5*(d_T4_dV_si_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_si_bi+d_T4_dV_si_bi*(T4-1.0)))));
d_Dmobs_dV_di_bi = 0.5*(d_T4_dV_di_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_di_bi+d_T4_dV_di_bi*(T4-1.0)))));
d_Dmobs_dV_gi_bi = 0.5*(d_T4_dV_gi_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_gi_bi+d_T4_dV_gi_bi*(T4-1.0)))));
Dmobs = (0.5*((T4+1.0)+value_sqrt_0));
}
{
double value_pow_0 = pow((Weff*1.0e6),WR_i);
WeffWRFactor = (1.0/(value_pow_0*NF));
}
if (((model_.RDSMOD)==1))
{

d_Rdss_dV_gi_bi = d_Rdss_dV_di_bi = d_Rdss_dV_si_bi = d_Rdss_dTemp_t_GND =  0.0;
Rdss = 0.0;
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_si_bi = PRWG_i*d_qis_dV_si_bi;
d_T0_dV_di_bi = PRWG_i*d_qis_dV_di_bi;
d_T0_dTemp_t_GND = PRWG_i*d_qis_dTemp_t_GND;
d_T0_dV_gi_bi = PRWG_i*d_qis_dV_gi_bi;
T0 = (1.0+(PRWG_i*qis));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi =  0.0;
d_T1_dV_si_bi = PRWB_i*d_sqrtPhistVbs_dV_si_bi;
d_T1_dV_di_bi = PRWB_i*d_sqrtPhistVbs_dV_di_bi;
d_T1_dTemp_t_GND = PRWB_i*(d_sqrtPhistVbs_dTemp_t_GND-d_sqrtPhist_dTemp_t_GND);
T1 = (PRWB_i*(sqrtPhistVbs-sqrtPhist));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = ((-d_T0_dTemp_t_GND/T0/T0)+d_T1_dTemp_t_GND);
d_T2_dV_si_bi = ((-d_T0_dV_si_bi/T0/T0)+d_T1_dV_si_bi);
d_T2_dV_di_bi = ((-d_T0_dV_di_bi/T0/T0)+d_T1_dV_di_bi);
d_T2_dV_gi_bi = ((-d_T0_dV_gi_bi/T0/T0)+d_T1_dV_gi_bi);
T2 = ((1.0/T0)+T1);
{
double value_sqrt_0 = sqrt(((T2*T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2))));
d_T3_dV_si_bi = (d_T2_dV_si_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2))));
d_T3_dV_di_bi = (d_T2_dV_di_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2))));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2))));
T3 = (T2+value_sqrt_0);
}

d_Rdss_dTemp_t_GND = ((((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF)*d_rdstemp_dTemp_t_GND+RDSW_i*d_T3_dTemp_t_GND*WeffWRFactor*NF*rdstemp);
d_Rdss_dV_si_bi = RDSW_i*d_T3_dV_si_bi*WeffWRFactor*NF*rdstemp;
d_Rdss_dV_di_bi = RDSW_i*d_T3_dV_di_bi*WeffWRFactor*NF*rdstemp;
d_Rdss_dV_gi_bi = RDSW_i*d_T3_dV_gi_bi*WeffWRFactor*NF*rdstemp;
Rdss = ((((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF)*rdstemp);
if (((model_.RDSMOD)==2))
{

d_Rdss_dTemp_t_GND = (((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF))+RDrainGeo)*d_rdstemp_dTemp_t_GND+RDSW_i*d_T3_dTemp_t_GND*WeffWRFactor*NF*rdstemp);
d_Rdss_dV_si_bi = RDSW_i*d_T3_dV_si_bi*WeffWRFactor*NF*rdstemp;
d_Rdss_dV_di_bi = RDSW_i*d_T3_dV_di_bi*WeffWRFactor*NF*rdstemp;
d_Rdss_dV_gi_bi = RDSW_i*d_T3_dV_gi_bi*WeffWRFactor*NF*rdstemp;
Rdss = (((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF))+RDrainGeo)*rdstemp);
}
}
{
double value_pow_0 = pow(Dmobs,(1.0/PSAT_a));
double  deriv_pow_0_d0 = ((Dmobs == 0.0)?0.0:(value_pow_0*(1.0/PSAT_a)/Dmobs));
double  deriv_pow_0_d1 = (Dmobs == 0.0)?0.0:(log(Dmobs)*value_pow_0);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = ((deriv_pow_0_d0*(d_Dmobs_dTemp_t_GND))+(deriv_pow_0_d1*((-d_PSAT_a_dTemp_t_GND/PSAT_a/PSAT_a))));
d_T0_dV_si_bi = ((deriv_pow_0_d0*(d_Dmobs_dV_si_bi))+(deriv_pow_0_d1*((-d_PSAT_a_dV_si_bi/PSAT_a/PSAT_a))));
d_T0_dV_di_bi = ((deriv_pow_0_d0*(d_Dmobs_dV_di_bi))+(deriv_pow_0_d1*((-d_PSAT_a_dV_di_bi/PSAT_a/PSAT_a))));
d_T0_dV_gi_bi = (deriv_pow_0_d0*(d_Dmobs_dV_gi_bi));
T0 = value_pow_0;
}
if ((PSATB_i<0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dTemp_t_GND =  0.0;
d_T1_dV_si_bi = (-PSATB_i*d_Vbsx_dV_si_bi/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
d_T1_dV_di_bi = (-PSATB_i*d_Vbsx_dV_di_bi/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
T1 = (1.0/(1.0+(PSATB_i*Vbsx)));
}
else
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dTemp_t_GND =  0.0;
d_T1_dV_si_bi = (-PSATB_i*d_Vbsx_dV_si_bi);
d_T1_dV_di_bi = (-PSATB_i*d_Vbsx_dV_di_bi);
T1 = (1.0-(PSATB_i*Vbsx));
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = ((((10.0*(model_.PSATX))+(qs*T1))*(((10.0*(model_.PSATX))*qs)*d_T1_dTemp_t_GND+(10.0*(model_.PSATX))*d_qs_dTemp_t_GND*T1)-(((10.0*(model_.PSATX))*qs)*T1)*(qs*d_T1_dTemp_t_GND+d_qs_dTemp_t_GND*T1))/((10.0*(model_.PSATX))+(qs*T1))/((10.0*(model_.PSATX))+(qs*T1)));
d_T2_dV_si_bi = ((((10.0*(model_.PSATX))+(qs*T1))*(((10.0*(model_.PSATX))*qs)*d_T1_dV_si_bi+(10.0*(model_.PSATX))*d_qs_dV_si_bi*T1)-(((10.0*(model_.PSATX))*qs)*T1)*(qs*d_T1_dV_si_bi+d_qs_dV_si_bi*T1))/((10.0*(model_.PSATX))+(qs*T1))/((10.0*(model_.PSATX))+(qs*T1)));
d_T2_dV_di_bi = ((((10.0*(model_.PSATX))+(qs*T1))*(((10.0*(model_.PSATX))*qs)*d_T1_dV_di_bi+(10.0*(model_.PSATX))*d_qs_dV_di_bi*T1)-(((10.0*(model_.PSATX))*qs)*T1)*(qs*d_T1_dV_di_bi+d_qs_dV_di_bi*T1))/((10.0*(model_.PSATX))+(qs*T1))/((10.0*(model_.PSATX))+(qs*T1)));
d_T2_dV_gi_bi = ((((10.0*(model_.PSATX))+(qs*T1))*(((10.0*(model_.PSATX))*qs)*d_T1_dV_gi_bi+(10.0*(model_.PSATX))*d_qs_dV_gi_bi*T1)-(((10.0*(model_.PSATX))*qs)*T1)*(qs*d_T1_dV_gi_bi+d_qs_dV_gi_bi*T1))/((10.0*(model_.PSATX))+(qs*T1))/((10.0*(model_.PSATX))+(qs*T1)));
T2 = ((((10.0*(model_.PSATX))*qs)*T1)/((10.0*(model_.PSATX))+(qs*T1)));
if ((PTWG_a<0))
{

d_LambdaC_dV_dbulk_di = d_LambdaC_dV_sbulk_si =  0.0;
d_LambdaC_dV_gi_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-PTWG_a*d_T2_dV_gi_bi)/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((U0_a/T0)*d_nVt_dV_gi_bi+(-U0_a*d_T0_dV_gi_bi/T0/T0)*nVt)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
d_LambdaC_dV_si_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*d_T2_dV_si_bi+d_PTWG_a_dV_si_bi*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_si_bi+((T0*d_U0_a_dV_si_bi-U0_a*d_T0_dV_si_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_si_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
d_LambdaC_dV_di_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*d_T2_dV_di_bi+d_PTWG_a_dV_di_bi*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_di_bi+((T0*d_U0_a_dV_di_bi-U0_a*d_T0_dV_di_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_di_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
d_LambdaC_dTemp_t_GND = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*d_T2_dTemp_t_GND+d_PTWG_a_dTemp_t_GND*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dTemp_t_GND+((T0*d_U0_a_dTemp_t_GND-U0_a*d_T0_dTemp_t_GND)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dTemp_t_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))));
}
else
{

d_LambdaC_dV_dbulk_di = d_LambdaC_dV_sbulk_si =  0.0;
d_LambdaC_dV_gi_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*PTWG_a*d_T2_dV_gi_bi+2.0*(((U0_a/T0)*d_nVt_dV_gi_bi+(-U0_a*d_T0_dV_gi_bi/T0/T0)*nVt)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
d_LambdaC_dV_si_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*d_T2_dV_si_bi+d_PTWG_a_dV_si_bi*T2)+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_si_bi+((T0*d_U0_a_dV_si_bi-U0_a*d_T0_dV_si_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_si_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
d_LambdaC_dV_di_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*d_T2_dV_di_bi+d_PTWG_a_dV_di_bi*T2)+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_di_bi+((T0*d_U0_a_dV_di_bi-U0_a*d_T0_dV_di_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_di_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
d_LambdaC_dTemp_t_GND = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*d_T2_dTemp_t_GND+d_PTWG_a_dTemp_t_GND*T2)+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dTemp_t_GND+((T0*d_U0_a_dTemp_t_GND-U0_a*d_T0_dTemp_t_GND)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dTemp_t_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)));
}
if ((Rdss==0))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dV_gi_bi+d_qs_dV_gi_bi*qs)+d_qs_dV_gi_bi)+0.5*d_LambdaC_dV_gi_bi*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dV_gi_bi+0.5*d_LambdaC_dV_gi_bi*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
d_T0_dV_si_bi = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dV_si_bi+d_qs_dV_si_bi*qs)+d_qs_dV_si_bi)+0.5*d_LambdaC_dV_si_bi*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dV_si_bi+0.5*d_LambdaC_dV_si_bi*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
d_T0_dV_di_bi = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dV_di_bi+d_qs_dV_di_bi*qs)+d_qs_dV_di_bi)+0.5*d_LambdaC_dV_di_bi*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dV_di_bi+0.5*d_LambdaC_dV_di_bi*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
d_T0_dTemp_t_GND = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dTemp_t_GND+d_qs_dTemp_t_GND*qs)+d_qs_dTemp_t_GND)+0.5*d_LambdaC_dTemp_t_GND*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dTemp_t_GND+0.5*d_LambdaC_dTemp_t_GND*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((2.0*LambdaC)*(d_qs_dV_gi_bi-d_T0_dV_gi_bi)+2.0*d_LambdaC_dV_gi_bi*(qs-T0));
d_T1_dV_si_bi = ((2.0*LambdaC)*(d_qs_dV_si_bi-d_T0_dV_si_bi)+2.0*d_LambdaC_dV_si_bi*(qs-T0));
d_T1_dV_di_bi = ((2.0*LambdaC)*(d_qs_dV_di_bi-d_T0_dV_di_bi)+2.0*d_LambdaC_dV_di_bi*(qs-T0));
d_T1_dTemp_t_GND = ((2.0*LambdaC)*(d_qs_dTemp_t_GND-d_T0_dTemp_t_GND)+2.0*d_LambdaC_dTemp_t_GND*(qs-T0));
T1 = ((2.0*LambdaC)*(qs-T0));
{
double value_sqrt_0 = sqrt((1.0+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)));
T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(T1*T1+1.0)));

d_ln_T1_T2_dTemp_t_GND = (deriv_asinh_0_d0*(d_T1_dTemp_t_GND));
d_ln_T1_T2_dV_si_bi = (deriv_asinh_0_d0*(d_T1_dV_si_bi));
d_ln_T1_T2_dV_di_bi = (deriv_asinh_0_d0*(d_T1_dV_di_bi));
d_ln_T1_T2_dV_gi_bi = (deriv_asinh_0_d0*(d_T1_dV_gi_bi));
ln_T1_T2 = value_asinh_0;
}
if ((T1!=0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+((1.0/T1)*d_ln_T1_T2_dTemp_t_GND+(-d_T1_dTemp_t_GND/T1/T1)*ln_T1_T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+((1.0/T1)*d_ln_T1_T2_dV_si_bi+(-d_T1_dV_si_bi/T1/T1)*ln_T1_T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+((1.0/T1)*d_ln_T1_T2_dV_di_bi+(-d_T1_dV_di_bi/T1/T1)*ln_T1_T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+((1.0/T1)*d_ln_T1_T2_dV_gi_bi+(-d_T1_dV_gi_bi/T1/T1)*ln_T1_T2));
T3 = (T2+((1.0/T1)*ln_T1_T2));
}
else
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+(-d_T2_dTemp_t_GND/T2/T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+(-d_T2_dV_si_bi/T2/T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+(-d_T2_dV_di_bi/T2/T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+(-d_T2_dV_gi_bi/T2/T2));
T3 = (T2+(1.0/T2));
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)-(LambdaC*(((qs*d_qs_dTemp_t_GND+d_qs_dTemp_t_GND*qs)+d_qs_dTemp_t_GND)-((T0*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*T0)+d_T0_dTemp_t_GND))+d_LambdaC_dTemp_t_GND*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_si_bi = ((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)-(LambdaC*(((qs*d_qs_dV_si_bi+d_qs_dV_si_bi*qs)+d_qs_dV_si_bi)-((T0*d_T0_dV_si_bi+d_T0_dV_si_bi*T0)+d_T0_dV_si_bi))+d_LambdaC_dV_si_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_di_bi = ((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)-(LambdaC*(((qs*d_qs_dV_di_bi+d_qs_dV_di_bi*qs)+d_qs_dV_di_bi)-((T0*d_T0_dV_di_bi+d_T0_dV_di_bi*T0)+d_T0_dV_di_bi))+d_LambdaC_dV_di_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_gi_bi = ((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)-(LambdaC*(((qs*d_qs_dV_gi_bi+d_qs_dV_gi_bi*qs)+d_qs_dV_gi_bi)-((T0*d_T0_dV_gi_bi+d_T0_dV_gi_bi*T0)+d_T0_dV_gi_bi))+d_LambdaC_dV_gi_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
T4 = ((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
if ((T1!=0))
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_gi_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_gi_bi+d_T1_dV_gi_bi*T2)-d_ln_T1_T2_dV_gi_bi)+(-2.0)*d_LambdaC_dV_gi_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_si_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_si_bi+d_T1_dV_si_bi*T2)-d_ln_T1_T2_dV_si_bi)+(-2.0)*d_LambdaC_dV_si_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_di_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_di_bi+d_T1_dV_di_bi*T2)-d_ln_T1_T2_dV_di_bi)+(-2.0)*d_LambdaC_dV_di_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dTemp_t_GND = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dTemp_t_GND+d_T1_dTemp_t_GND*T2)-d_ln_T1_T2_dTemp_t_GND)+(-2.0)*d_LambdaC_dTemp_t_GND*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1))/(T1*T1)/(T1*T1));
T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
}
else
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_gi_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_gi_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dV_si_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_si_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dV_di_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_di_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dTemp_t_GND = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+(-2.0)*d_LambdaC_dTemp_t_GND*(T1/T2))*(T1/T2))*(T1/T2));
T5 = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
}

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (((T0*d_T5_dTemp_t_GND+d_T0_dTemp_t_GND*T5)+d_T3_dTemp_t_GND)+(LambdaC*2.0*d_T0_dTemp_t_GND+d_LambdaC_dTemp_t_GND*((2.0*T0)+1.0)));
d_T6_dV_si_bi = (((T0*d_T5_dV_si_bi+d_T0_dV_si_bi*T5)+d_T3_dV_si_bi)+(LambdaC*2.0*d_T0_dV_si_bi+d_LambdaC_dV_si_bi*((2.0*T0)+1.0)));
d_T6_dV_di_bi = (((T0*d_T5_dV_di_bi+d_T0_dV_di_bi*T5)+d_T3_dV_di_bi)+(LambdaC*2.0*d_T0_dV_di_bi+d_LambdaC_dV_di_bi*((2.0*T0)+1.0)));
d_T6_dV_gi_bi = (((T0*d_T5_dV_gi_bi+d_T0_dV_gi_bi*T5)+d_T3_dV_gi_bi)+(LambdaC*2.0*d_T0_dV_gi_bi+d_LambdaC_dV_gi_bi*((2.0*T0)+1.0)));
T6 = (((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0)));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = (d_T0_dTemp_t_GND-((T6*d_T4_dTemp_t_GND-T4*d_T6_dTemp_t_GND)/T6/T6));
d_T0_dV_si_bi = (d_T0_dV_si_bi-((T6*d_T4_dV_si_bi-T4*d_T6_dV_si_bi)/T6/T6));
d_T0_dV_di_bi = (d_T0_dV_di_bi-((T6*d_T4_dV_di_bi-T4*d_T6_dV_di_bi)/T6/T6));
d_T0_dV_gi_bi = (d_T0_dV_gi_bi-((T6*d_T4_dV_gi_bi-T4*d_T6_dV_gi_bi)/T6/T6));
T0 = (T0-(T4/T6));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((2.0*LambdaC)*(d_qs_dV_gi_bi-d_T0_dV_gi_bi)+2.0*d_LambdaC_dV_gi_bi*(qs-T0));
d_T1_dV_si_bi = ((2.0*LambdaC)*(d_qs_dV_si_bi-d_T0_dV_si_bi)+2.0*d_LambdaC_dV_si_bi*(qs-T0));
d_T1_dV_di_bi = ((2.0*LambdaC)*(d_qs_dV_di_bi-d_T0_dV_di_bi)+2.0*d_LambdaC_dV_di_bi*(qs-T0));
d_T1_dTemp_t_GND = ((2.0*LambdaC)*(d_qs_dTemp_t_GND-d_T0_dTemp_t_GND)+2.0*d_LambdaC_dTemp_t_GND*(qs-T0));
T1 = ((2.0*LambdaC)*(qs-T0));
{
double value_sqrt_0 = sqrt((1.0+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)));
T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(T1*T1+1.0)));

d_ln_T1_T2_dTemp_t_GND = (deriv_asinh_0_d0*(d_T1_dTemp_t_GND));
d_ln_T1_T2_dV_si_bi = (deriv_asinh_0_d0*(d_T1_dV_si_bi));
d_ln_T1_T2_dV_di_bi = (deriv_asinh_0_d0*(d_T1_dV_di_bi));
d_ln_T1_T2_dV_gi_bi = (deriv_asinh_0_d0*(d_T1_dV_gi_bi));
ln_T1_T2 = value_asinh_0;
}
if ((T1!=0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+((1.0/T1)*d_ln_T1_T2_dTemp_t_GND+(-d_T1_dTemp_t_GND/T1/T1)*ln_T1_T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+((1.0/T1)*d_ln_T1_T2_dV_si_bi+(-d_T1_dV_si_bi/T1/T1)*ln_T1_T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+((1.0/T1)*d_ln_T1_T2_dV_di_bi+(-d_T1_dV_di_bi/T1/T1)*ln_T1_T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+((1.0/T1)*d_ln_T1_T2_dV_gi_bi+(-d_T1_dV_gi_bi/T1/T1)*ln_T1_T2));
T3 = (T2+((1.0/T1)*ln_T1_T2));
}
else
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+(-d_T2_dTemp_t_GND/T2/T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+(-d_T2_dV_si_bi/T2/T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+(-d_T2_dV_di_bi/T2/T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+(-d_T2_dV_gi_bi/T2/T2));
T3 = (T2+(1.0/T2));
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)-(LambdaC*(((qs*d_qs_dTemp_t_GND+d_qs_dTemp_t_GND*qs)+d_qs_dTemp_t_GND)-((T0*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*T0)+d_T0_dTemp_t_GND))+d_LambdaC_dTemp_t_GND*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_si_bi = ((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)-(LambdaC*(((qs*d_qs_dV_si_bi+d_qs_dV_si_bi*qs)+d_qs_dV_si_bi)-((T0*d_T0_dV_si_bi+d_T0_dV_si_bi*T0)+d_T0_dV_si_bi))+d_LambdaC_dV_si_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_di_bi = ((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)-(LambdaC*(((qs*d_qs_dV_di_bi+d_qs_dV_di_bi*qs)+d_qs_dV_di_bi)-((T0*d_T0_dV_di_bi+d_T0_dV_di_bi*T0)+d_T0_dV_di_bi))+d_LambdaC_dV_di_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_gi_bi = ((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)-(LambdaC*(((qs*d_qs_dV_gi_bi+d_qs_dV_gi_bi*qs)+d_qs_dV_gi_bi)-((T0*d_T0_dV_gi_bi+d_T0_dV_gi_bi*T0)+d_T0_dV_gi_bi))+d_LambdaC_dV_gi_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
T4 = ((T0*T3)-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
if ((T1!=0))
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_gi_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_gi_bi+d_T1_dV_gi_bi*T2)-d_ln_T1_T2_dV_gi_bi)+(-2.0)*d_LambdaC_dV_gi_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_si_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_si_bi+d_T1_dV_si_bi*T2)-d_ln_T1_T2_dV_si_bi)+(-2.0)*d_LambdaC_dV_si_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_di_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_di_bi+d_T1_dV_di_bi*T2)-d_ln_T1_T2_dV_di_bi)+(-2.0)*d_LambdaC_dV_di_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dTemp_t_GND = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dTemp_t_GND+d_T1_dTemp_t_GND*T2)-d_ln_T1_T2_dTemp_t_GND)+(-2.0)*d_LambdaC_dTemp_t_GND*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1))/(T1*T1)/(T1*T1));
T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
}
else
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = (((T1/T2)*(T1/T2))*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+((T1/T2)*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)*(T1/T2))*(T1/T2));
d_T5_dV_si_bi = (((T1/T2)*(T1/T2))*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+((T1/T2)*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)*(T1/T2))*(T1/T2));
d_T5_dV_di_bi = (((T1/T2)*(T1/T2))*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+((T1/T2)*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)*(T1/T2))*(T1/T2));
d_T5_dV_gi_bi = (((T1/T2)*(T1/T2))*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+((T1/T2)*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)*(T1/T2))*(T1/T2));
T5 = (((T1/T2)*(T1/T2))*(T1/T2));
}

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (((T0*d_T5_dTemp_t_GND+d_T0_dTemp_t_GND*T5)+d_T3_dTemp_t_GND)+(LambdaC*2.0*d_T0_dTemp_t_GND+d_LambdaC_dTemp_t_GND*((2.0*T0)+1.0)));
d_T6_dV_si_bi = (((T0*d_T5_dV_si_bi+d_T0_dV_si_bi*T5)+d_T3_dV_si_bi)+(LambdaC*2.0*d_T0_dV_si_bi+d_LambdaC_dV_si_bi*((2.0*T0)+1.0)));
d_T6_dV_di_bi = (((T0*d_T5_dV_di_bi+d_T0_dV_di_bi*T5)+d_T3_dV_di_bi)+(LambdaC*2.0*d_T0_dV_di_bi+d_LambdaC_dV_di_bi*((2.0*T0)+1.0)));
d_T6_dV_gi_bi = (((T0*d_T5_dV_gi_bi+d_T0_dV_gi_bi*T5)+d_T3_dV_gi_bi)+(LambdaC*2.0*d_T0_dV_gi_bi+d_LambdaC_dV_gi_bi*((2.0*T0)+1.0)));
T6 = (((T0*T5)+T3)+(LambdaC*((2.0*T0)+1.0)));

d_qdsat_dV_dbulk_di = d_qdsat_dV_sbulk_si =  0.0;
d_qdsat_dTemp_t_GND = (d_T0_dTemp_t_GND-((T6*d_T4_dTemp_t_GND-T4*d_T6_dTemp_t_GND)/T6/T6));
d_qdsat_dV_si_bi = (d_T0_dV_si_bi-((T6*d_T4_dV_si_bi-T4*d_T6_dV_si_bi)/T6/T6));
d_qdsat_dV_di_bi = (d_T0_dV_di_bi-((T6*d_T4_dV_di_bi-T4*d_T6_dV_di_bi)/T6/T6));
d_qdsat_dV_gi_bi = (d_T0_dV_gi_bi-((T6*d_T4_dV_gi_bi-T4*d_T6_dV_gi_bi)/T6/T6));
qdsat = (T0-(T4/T6));
}
else
{

d_T11_dV_si_bi = (((((Weff*2.0)*nq)*Cox)*nVt)*d_VSAT_a_dV_si_bi+((((Weff*2.0)*nq)*Cox)*d_nVt_dV_si_bi+(Weff*2.0)*d_nq_dV_si_bi*Cox*nVt)*VSAT_a);
d_T11_dV_di_bi = (((((Weff*2.0)*nq)*Cox)*nVt)*d_VSAT_a_dV_di_bi+((((Weff*2.0)*nq)*Cox)*d_nVt_dV_di_bi+(Weff*2.0)*d_nq_dV_di_bi*Cox*nVt)*VSAT_a);
d_T11_dTemp_t_GND = (((((Weff*2.0)*nq)*Cox)*nVt)*d_VSAT_a_dTemp_t_GND+((((Weff*2.0)*nq)*Cox)*d_nVt_dTemp_t_GND+(Weff*2.0)*d_nq_dTemp_t_GND*Cox*nVt)*VSAT_a);
d_T11_dV_gi_bi = ((((Weff*2.0)*nq)*Cox)*d_nVt_dV_gi_bi+(Weff*2.0)*d_nq_dV_gi_bi*Cox*nVt)*VSAT_a;
T11 = (((((Weff*2.0)*nq)*Cox)*nVt)*VSAT_a);

d_T12_dV_si_bi = (((2.0*nVt)*((T11*LambdaC)*d_Rdss_dV_si_bi+(T11*d_LambdaC_dV_si_bi+d_T11_dV_si_bi*LambdaC)*Rdss)-((T11*LambdaC)*Rdss)*2.0*d_nVt_dV_si_bi)/(2.0*nVt)/(2.0*nVt));
d_T12_dV_di_bi = (((2.0*nVt)*((T11*LambdaC)*d_Rdss_dV_di_bi+(T11*d_LambdaC_dV_di_bi+d_T11_dV_di_bi*LambdaC)*Rdss)-((T11*LambdaC)*Rdss)*2.0*d_nVt_dV_di_bi)/(2.0*nVt)/(2.0*nVt));
d_T12_dTemp_t_GND = (((2.0*nVt)*((T11*LambdaC)*d_Rdss_dTemp_t_GND+(T11*d_LambdaC_dTemp_t_GND+d_T11_dTemp_t_GND*LambdaC)*Rdss)-((T11*LambdaC)*Rdss)*2.0*d_nVt_dTemp_t_GND)/(2.0*nVt)/(2.0*nVt));
d_T12_dV_gi_bi = (((2.0*nVt)*((T11*LambdaC)*d_Rdss_dV_gi_bi+(T11*d_LambdaC_dV_gi_bi+d_T11_dV_gi_bi*LambdaC)*Rdss)-((T11*LambdaC)*Rdss)*2.0*d_nVt_dV_gi_bi)/(2.0*nVt)/(2.0*nVt));
T12 = (((T11*LambdaC)*Rdss)/(2.0*nVt));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dV_gi_bi+d_qs_dV_gi_bi*qs)+d_qs_dV_gi_bi)+0.5*d_LambdaC_dV_gi_bi*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dV_gi_bi+0.5*d_LambdaC_dV_gi_bi*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
d_T0_dV_si_bi = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dV_si_bi+d_qs_dV_si_bi*qs)+d_qs_dV_si_bi)+0.5*d_LambdaC_dV_si_bi*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dV_si_bi+0.5*d_LambdaC_dV_si_bi*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
d_T0_dV_di_bi = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dV_di_bi+d_qs_dV_di_bi*qs)+d_qs_dV_di_bi)+0.5*d_LambdaC_dV_di_bi*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dV_di_bi+0.5*d_LambdaC_dV_di_bi*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
d_T0_dTemp_t_GND = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dTemp_t_GND+d_qs_dTemp_t_GND*qs)+d_qs_dTemp_t_GND)+0.5*d_LambdaC_dTemp_t_GND*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dTemp_t_GND+0.5*d_LambdaC_dTemp_t_GND*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((2.0*LambdaC)*(d_qs_dV_gi_bi-d_T0_dV_gi_bi)+2.0*d_LambdaC_dV_gi_bi*(qs-T0));
d_T1_dV_si_bi = ((2.0*LambdaC)*(d_qs_dV_si_bi-d_T0_dV_si_bi)+2.0*d_LambdaC_dV_si_bi*(qs-T0));
d_T1_dV_di_bi = ((2.0*LambdaC)*(d_qs_dV_di_bi-d_T0_dV_di_bi)+2.0*d_LambdaC_dV_di_bi*(qs-T0));
d_T1_dTemp_t_GND = ((2.0*LambdaC)*(d_qs_dTemp_t_GND-d_T0_dTemp_t_GND)+2.0*d_LambdaC_dTemp_t_GND*(qs-T0));
T1 = ((2.0*LambdaC)*(qs-T0));
{
double value_sqrt_0 = sqrt((1.0+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)));
T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(T1*T1+1.0)));

d_ln_T1_T2_dTemp_t_GND = (deriv_asinh_0_d0*(d_T1_dTemp_t_GND));
d_ln_T1_T2_dV_si_bi = (deriv_asinh_0_d0*(d_T1_dV_si_bi));
d_ln_T1_T2_dV_di_bi = (deriv_asinh_0_d0*(d_T1_dV_di_bi));
d_ln_T1_T2_dV_gi_bi = (deriv_asinh_0_d0*(d_T1_dV_gi_bi));
ln_T1_T2 = value_asinh_0;
}
if ((T1!=0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+((1.0/T1)*d_ln_T1_T2_dTemp_t_GND+(-d_T1_dTemp_t_GND/T1/T1)*ln_T1_T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+((1.0/T1)*d_ln_T1_T2_dV_si_bi+(-d_T1_dV_si_bi/T1/T1)*ln_T1_T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+((1.0/T1)*d_ln_T1_T2_dV_di_bi+(-d_T1_dV_di_bi/T1/T1)*ln_T1_T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+((1.0/T1)*d_ln_T1_T2_dV_gi_bi+(-d_T1_dV_gi_bi/T1/T1)*ln_T1_T2));
T3 = (T2+((1.0/T1)*ln_T1_T2));
}
else
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+(-d_T2_dTemp_t_GND/T2/T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+(-d_T2_dV_si_bi/T2/T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+(-d_T2_dV_di_bi/T2/T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+(-d_T2_dV_gi_bi/T2/T2));
T3 = (T2+(1.0/T2));
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = (((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+((T12*T0)*(d_qs_dTemp_t_GND+d_T0_dTemp_t_GND)+(T12*d_T0_dTemp_t_GND+d_T12_dTemp_t_GND*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dTemp_t_GND+d_qs_dTemp_t_GND*qs)+d_qs_dTemp_t_GND)-((T0*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*T0)+d_T0_dTemp_t_GND))+d_LambdaC_dTemp_t_GND*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_si_bi = (((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+((T12*T0)*(d_qs_dV_si_bi+d_T0_dV_si_bi)+(T12*d_T0_dV_si_bi+d_T12_dV_si_bi*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dV_si_bi+d_qs_dV_si_bi*qs)+d_qs_dV_si_bi)-((T0*d_T0_dV_si_bi+d_T0_dV_si_bi*T0)+d_T0_dV_si_bi))+d_LambdaC_dV_si_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_di_bi = (((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+((T12*T0)*(d_qs_dV_di_bi+d_T0_dV_di_bi)+(T12*d_T0_dV_di_bi+d_T12_dV_di_bi*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dV_di_bi+d_qs_dV_di_bi*qs)+d_qs_dV_di_bi)-((T0*d_T0_dV_di_bi+d_T0_dV_di_bi*T0)+d_T0_dV_di_bi))+d_LambdaC_dV_di_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_gi_bi = (((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+((T12*T0)*(d_qs_dV_gi_bi+d_T0_dV_gi_bi)+(T12*d_T0_dV_gi_bi+d_T12_dV_gi_bi*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dV_gi_bi+d_qs_dV_gi_bi*qs)+d_qs_dV_gi_bi)-((T0*d_T0_dV_gi_bi+d_T0_dV_gi_bi*T0)+d_T0_dV_gi_bi))+d_LambdaC_dV_gi_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
T4 = (((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
if ((T1!=0))
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_gi_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_gi_bi+d_T1_dV_gi_bi*T2)-d_ln_T1_T2_dV_gi_bi)+(-2.0)*d_LambdaC_dV_gi_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_si_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_si_bi+d_T1_dV_si_bi*T2)-d_ln_T1_T2_dV_si_bi)+(-2.0)*d_LambdaC_dV_si_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_di_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_di_bi+d_T1_dV_di_bi*T2)-d_ln_T1_T2_dV_di_bi)+(-2.0)*d_LambdaC_dV_di_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dTemp_t_GND = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dTemp_t_GND+d_T1_dTemp_t_GND*T2)-d_ln_T1_T2_dTemp_t_GND)+(-2.0)*d_LambdaC_dTemp_t_GND*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1))/(T1*T1)/(T1*T1));
T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
}
else
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_gi_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_gi_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dV_si_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_si_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dV_di_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_di_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dTemp_t_GND = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+(-2.0)*d_LambdaC_dTemp_t_GND*(T1/T2))*(T1/T2))*(T1/T2));
T5 = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
}

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = ((((T0*d_T5_dTemp_t_GND+d_T0_dTemp_t_GND*T5)+d_T3_dTemp_t_GND)+(T12*(d_qs_dTemp_t_GND+2.0*d_T0_dTemp_t_GND)+d_T12_dTemp_t_GND*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dTemp_t_GND+d_LambdaC_dTemp_t_GND*((2.0*T0)+1.0)));
d_T6_dV_si_bi = ((((T0*d_T5_dV_si_bi+d_T0_dV_si_bi*T5)+d_T3_dV_si_bi)+(T12*(d_qs_dV_si_bi+2.0*d_T0_dV_si_bi)+d_T12_dV_si_bi*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dV_si_bi+d_LambdaC_dV_si_bi*((2.0*T0)+1.0)));
d_T6_dV_di_bi = ((((T0*d_T5_dV_di_bi+d_T0_dV_di_bi*T5)+d_T3_dV_di_bi)+(T12*(d_qs_dV_di_bi+2.0*d_T0_dV_di_bi)+d_T12_dV_di_bi*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dV_di_bi+d_LambdaC_dV_di_bi*((2.0*T0)+1.0)));
d_T6_dV_gi_bi = ((((T0*d_T5_dV_gi_bi+d_T0_dV_gi_bi*T5)+d_T3_dV_gi_bi)+(T12*(d_qs_dV_gi_bi+2.0*d_T0_dV_gi_bi)+d_T12_dV_gi_bi*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dV_gi_bi+d_LambdaC_dV_gi_bi*((2.0*T0)+1.0)));
T6 = ((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0)));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = (d_T0_dTemp_t_GND-((T6*d_T4_dTemp_t_GND-T4*d_T6_dTemp_t_GND)/T6/T6));
d_T0_dV_si_bi = (d_T0_dV_si_bi-((T6*d_T4_dV_si_bi-T4*d_T6_dV_si_bi)/T6/T6));
d_T0_dV_di_bi = (d_T0_dV_di_bi-((T6*d_T4_dV_di_bi-T4*d_T6_dV_di_bi)/T6/T6));
d_T0_dV_gi_bi = (d_T0_dV_gi_bi-((T6*d_T4_dV_gi_bi-T4*d_T6_dV_gi_bi)/T6/T6));
T0 = (T0-(T4/T6));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((2.0*LambdaC)*(d_qs_dV_gi_bi-d_T0_dV_gi_bi)+2.0*d_LambdaC_dV_gi_bi*(qs-T0));
d_T1_dV_si_bi = ((2.0*LambdaC)*(d_qs_dV_si_bi-d_T0_dV_si_bi)+2.0*d_LambdaC_dV_si_bi*(qs-T0));
d_T1_dV_di_bi = ((2.0*LambdaC)*(d_qs_dV_di_bi-d_T0_dV_di_bi)+2.0*d_LambdaC_dV_di_bi*(qs-T0));
d_T1_dTemp_t_GND = ((2.0*LambdaC)*(d_qs_dTemp_t_GND-d_T0_dTemp_t_GND)+2.0*d_LambdaC_dTemp_t_GND*(qs-T0));
T1 = ((2.0*LambdaC)*(qs-T0));
{
double value_sqrt_0 = sqrt((1.0+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)));
T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(T1*T1+1.0)));

d_ln_T1_T2_dTemp_t_GND = (deriv_asinh_0_d0*(d_T1_dTemp_t_GND));
d_ln_T1_T2_dV_si_bi = (deriv_asinh_0_d0*(d_T1_dV_si_bi));
d_ln_T1_T2_dV_di_bi = (deriv_asinh_0_d0*(d_T1_dV_di_bi));
d_ln_T1_T2_dV_gi_bi = (deriv_asinh_0_d0*(d_T1_dV_gi_bi));
ln_T1_T2 = value_asinh_0;
}
if ((T1!=0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+((1.0/T1)*d_ln_T1_T2_dTemp_t_GND+(-d_T1_dTemp_t_GND/T1/T1)*ln_T1_T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+((1.0/T1)*d_ln_T1_T2_dV_si_bi+(-d_T1_dV_si_bi/T1/T1)*ln_T1_T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+((1.0/T1)*d_ln_T1_T2_dV_di_bi+(-d_T1_dV_di_bi/T1/T1)*ln_T1_T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+((1.0/T1)*d_ln_T1_T2_dV_gi_bi+(-d_T1_dV_gi_bi/T1/T1)*ln_T1_T2));
T3 = (T2+((1.0/T1)*ln_T1_T2));
}
else
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T2_dTemp_t_GND+(-d_T2_dTemp_t_GND/T2/T2));
d_T3_dV_si_bi = (d_T2_dV_si_bi+(-d_T2_dV_si_bi/T2/T2));
d_T3_dV_di_bi = (d_T2_dV_di_bi+(-d_T2_dV_di_bi/T2/T2));
d_T3_dV_gi_bi = (d_T2_dV_gi_bi+(-d_T2_dV_gi_bi/T2/T2));
T3 = (T2+(1.0/T2));
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = (((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+((T12*T0)*(d_qs_dTemp_t_GND+d_T0_dTemp_t_GND)+(T12*d_T0_dTemp_t_GND+d_T12_dTemp_t_GND*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dTemp_t_GND+d_qs_dTemp_t_GND*qs)+d_qs_dTemp_t_GND)-((T0*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*T0)+d_T0_dTemp_t_GND))+d_LambdaC_dTemp_t_GND*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_si_bi = (((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+((T12*T0)*(d_qs_dV_si_bi+d_T0_dV_si_bi)+(T12*d_T0_dV_si_bi+d_T12_dV_si_bi*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dV_si_bi+d_qs_dV_si_bi*qs)+d_qs_dV_si_bi)-((T0*d_T0_dV_si_bi+d_T0_dV_si_bi*T0)+d_T0_dV_si_bi))+d_LambdaC_dV_si_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_di_bi = (((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+((T12*T0)*(d_qs_dV_di_bi+d_T0_dV_di_bi)+(T12*d_T0_dV_di_bi+d_T12_dV_di_bi*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dV_di_bi+d_qs_dV_di_bi*qs)+d_qs_dV_di_bi)-((T0*d_T0_dV_di_bi+d_T0_dV_di_bi*T0)+d_T0_dV_di_bi))+d_LambdaC_dV_di_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
d_T4_dV_gi_bi = (((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+((T12*T0)*(d_qs_dV_gi_bi+d_T0_dV_gi_bi)+(T12*d_T0_dV_gi_bi+d_T12_dV_gi_bi*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*d_qs_dV_gi_bi+d_qs_dV_gi_bi*qs)+d_qs_dV_gi_bi)-((T0*d_T0_dV_gi_bi+d_T0_dV_gi_bi*T0)+d_T0_dV_gi_bi))+d_LambdaC_dV_gi_bi*(((qs*qs)+qs)-((T0*T0)+T0))));
T4 = (((T0*T3)+((T12*T0)*((qs+T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((T0*T0)+T0))));
if ((T1!=0))
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_gi_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_gi_bi+d_T1_dV_gi_bi*T2)-d_ln_T1_T2_dV_gi_bi)+(-2.0)*d_LambdaC_dV_gi_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_si_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_si_bi+d_T1_dV_si_bi*T2)-d_ln_T1_T2_dV_si_bi)+(-2.0)*d_LambdaC_dV_si_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dV_di_bi = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dV_di_bi+d_T1_dV_di_bi*T2)-d_ln_T1_T2_dV_di_bi)+(-2.0)*d_LambdaC_dV_di_bi*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1))/(T1*T1)/(T1*T1));
d_T5_dTemp_t_GND = (((T1*T1)*(((-2.0)*LambdaC)*((T1*d_T2_dTemp_t_GND+d_T1_dTemp_t_GND*T2)-d_ln_T1_T2_dTemp_t_GND)+(-2.0)*d_LambdaC_dTemp_t_GND*((T1*T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))*(T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1))/(T1*T1)/(T1*T1));
T5 = ((((-2.0)*LambdaC)*((T1*T2)-ln_T1_T2))/(T1*T1));
}
else
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_gi_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_gi_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dV_si_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_si_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dV_di_bi = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)+(-2.0)*d_LambdaC_dV_di_bi*(T1/T2))*(T1/T2))*(T1/T2));
d_T5_dTemp_t_GND = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+((((-2.0)*LambdaC)*(T1/T2))*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+(((-2.0)*LambdaC)*((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)+(-2.0)*d_LambdaC_dTemp_t_GND*(T1/T2))*(T1/T2))*(T1/T2));
T5 = (((((-2.0)*LambdaC)*(T1/T2))*(T1/T2))*(T1/T2));
}

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = ((((T0*d_T5_dTemp_t_GND+d_T0_dTemp_t_GND*T5)+d_T3_dTemp_t_GND)+(T12*(d_qs_dTemp_t_GND+2.0*d_T0_dTemp_t_GND)+d_T12_dTemp_t_GND*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dTemp_t_GND+d_LambdaC_dTemp_t_GND*((2.0*T0)+1.0)));
d_T6_dV_si_bi = ((((T0*d_T5_dV_si_bi+d_T0_dV_si_bi*T5)+d_T3_dV_si_bi)+(T12*(d_qs_dV_si_bi+2.0*d_T0_dV_si_bi)+d_T12_dV_si_bi*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dV_si_bi+d_LambdaC_dV_si_bi*((2.0*T0)+1.0)));
d_T6_dV_di_bi = ((((T0*d_T5_dV_di_bi+d_T0_dV_di_bi*T5)+d_T3_dV_di_bi)+(T12*(d_qs_dV_di_bi+2.0*d_T0_dV_di_bi)+d_T12_dV_di_bi*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dV_di_bi+d_LambdaC_dV_di_bi*((2.0*T0)+1.0)));
d_T6_dV_gi_bi = ((((T0*d_T5_dV_gi_bi+d_T0_dV_gi_bi*T5)+d_T3_dV_gi_bi)+(T12*(d_qs_dV_gi_bi+2.0*d_T0_dV_gi_bi)+d_T12_dV_gi_bi*((qs+(2.0*T0))+1.0)))+(LambdaC*2.0*d_T0_dV_gi_bi+d_LambdaC_dV_gi_bi*((2.0*T0)+1.0)));
T6 = ((((T0*T5)+T3)+(T12*((qs+(2.0*T0))+1.0)))+(LambdaC*((2.0*T0)+1.0)));

d_qdsat_dV_dbulk_di = d_qdsat_dV_sbulk_si =  0.0;
d_qdsat_dTemp_t_GND = (d_T0_dTemp_t_GND-((T6*d_T4_dTemp_t_GND-T4*d_T6_dTemp_t_GND)/T6/T6));
d_qdsat_dV_si_bi = (d_T0_dV_si_bi-((T6*d_T4_dV_si_bi-T4*d_T6_dV_si_bi)/T6/T6));
d_qdsat_dV_di_bi = (d_T0_dV_di_bi-((T6*d_T4_dV_di_bi-T4*d_T6_dV_di_bi)/T6/T6));
d_qdsat_dV_gi_bi = (d_T0_dV_gi_bi-((T6*d_T4_dV_gi_bi-T4*d_T6_dV_gi_bi)/T6/T6));
qdsat = (T0-(T4/T6));
}
{
double value_log_0 = log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));
double  deriv_log_0_d0 = (1.0/((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));

d_vdsat_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_n_dTemp_t_GND)-(2.0*d_qdsat_dTemp_t_GND+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dTemp_t_GND+((qdsat*2.0)*d_nq_dTemp_t_GND+d_qdsat_dTemp_t_GND*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dTemp_t_GND-gam*d_nq_dTemp_t_GND)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dTemp_t_GND+((qdsat*2.0)*d_nq_dTemp_t_GND+d_qdsat_dTemp_t_GND*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsat_dV_si_bi = ((d_psip_dV_si_bi-2.0*d_phib_n_dV_si_bi)-(2.0*d_qdsat_dV_si_bi+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_si_bi+((qdsat*2.0)*d_nq_dV_si_bi+d_qdsat_dV_si_bi*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_si_bi-gam*d_nq_dV_si_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_si_bi+((qdsat*2.0)*d_nq_dV_si_bi+d_qdsat_dV_si_bi*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsat_dV_di_bi = ((d_psip_dV_di_bi-2.0*d_phib_n_dV_di_bi)-(2.0*d_qdsat_dV_di_bi+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_di_bi+((qdsat*2.0)*d_nq_dV_di_bi+d_qdsat_dV_di_bi*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_di_bi-gam*d_nq_dV_di_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_di_bi+((qdsat*2.0)*d_nq_dV_di_bi+d_qdsat_dV_di_bi*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsat_dV_gi_bi = ((d_psip_dV_gi_bi-2.0*d_phib_n_dV_gi_bi)-(2.0*d_qdsat_dV_gi_bi+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_gi_bi+((qdsat*2.0)*d_nq_dV_gi_bi+d_qdsat_dV_gi_bi*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_gi_bi-gam*d_nq_dV_gi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_gi_bi+((qdsat*2.0)*d_nq_dV_gi_bi+d_qdsat_dV_gi_bi*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
vdsat = ((psip-(2.0*phib_n))-((2.0*qdsat)+value_log_0));
}

d_Vdsat_dTemp_t_GND = (vdsat*d_nVt_dTemp_t_GND+d_vdsat_dTemp_t_GND*nVt);
d_Vdsat_dV_si_bi = (vdsat*d_nVt_dV_si_bi+d_vdsat_dV_si_bi*nVt);
d_Vdsat_dV_di_bi = (vdsat*d_nVt_dV_di_bi+d_vdsat_dV_di_bi*nVt);
d_Vdsat_dV_gi_bi = (vdsat*d_nVt_dV_gi_bi+d_vdsat_dV_gi_bi*nVt);
Vdsat = (vdsat*nVt);
{
double value_sqrt_0 = sqrt(((((Vdsat-Vs))*((Vdsat-Vs)))+((0.25*1e-3)*1e-3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdssat_dTemp_t_GND = 0.5*(d_Vdsat_dTemp_t_GND+(deriv_sqrt_0_d0*((((Vdsat-Vs))*d_Vdsat_dTemp_t_GND+d_Vdsat_dTemp_t_GND*((Vdsat-Vs))))));
d_Vdssat_dV_si_bi = 0.5*((d_Vdsat_dV_si_bi-d_Vs_dV_si_bi)+(deriv_sqrt_0_d0*((((Vdsat-Vs))*(d_Vdsat_dV_si_bi-d_Vs_dV_si_bi)+(d_Vdsat_dV_si_bi-d_Vs_dV_si_bi)*((Vdsat-Vs))))));
d_Vdssat_dV_di_bi = 0.5*((d_Vdsat_dV_di_bi-d_Vs_dV_di_bi)+(deriv_sqrt_0_d0*((((Vdsat-Vs))*(d_Vdsat_dV_di_bi-d_Vs_dV_di_bi)+(d_Vdsat_dV_di_bi-d_Vs_dV_di_bi)*((Vdsat-Vs))))));
d_Vdssat_dV_gi_bi = 0.5*(d_Vdsat_dV_gi_bi+(deriv_sqrt_0_d0*((((Vdsat-Vs))*d_Vdsat_dV_gi_bi+d_Vdsat_dV_gi_bi*((Vdsat-Vs))))));
Vdssat = (0.5*((Vdsat-Vs)+value_sqrt_0));
}
{
double value_pow_0 = pow((Vds/Vdssat),(1.0/DELTA_t));
double  deriv_pow_0_d0 = (((Vds/Vdssat) == 0.0)?0.0:(value_pow_0*(1.0/DELTA_t)/(Vds/Vdssat)));
double  deriv_pow_0_d1 = ((Vds/Vdssat) == 0.0)?0.0:(log((Vds/Vdssat))*value_pow_0);

d_T7_dV_gm_si = d_T7_dV_gm_di = d_T7_dV_dbulk_di = d_T7_dV_sbulk_si =  0.0;
d_T7_dTemp_t_GND = ((deriv_pow_0_d0*((-Vds*d_Vdssat_dTemp_t_GND/Vdssat/Vdssat)))+(deriv_pow_0_d1*((-d_DELTA_t_dTemp_t_GND/DELTA_t/DELTA_t))));
d_T7_dV_gi_bi = (deriv_pow_0_d0*((-Vds*d_Vdssat_dV_gi_bi/Vdssat/Vdssat)));
d_T7_dV_si_bi = (deriv_pow_0_d0*(((Vdssat*d_Vds_dV_si_bi-Vds*d_Vdssat_dV_si_bi)/Vdssat/Vdssat)));
d_T7_dV_di_bi = (deriv_pow_0_d0*(((Vdssat*d_Vds_dV_di_bi-Vds*d_Vdssat_dV_di_bi)/Vdssat/Vdssat)));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),(-DELTA_t));
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*(-DELTA_t)/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);

d_T8_dV_gm_di = d_T8_dV_gm_si = d_T8_dV_dbulk_di = d_T8_dV_sbulk_si =  0.0;
d_T8_dTemp_t_GND = ((deriv_pow_0_d0*(d_T7_dTemp_t_GND))+(deriv_pow_0_d1*((-d_DELTA_t_dTemp_t_GND))));
d_T8_dV_si_bi = (deriv_pow_0_d0*(d_T7_dV_si_bi));
d_T8_dV_di_bi = (deriv_pow_0_d0*(d_T7_dV_di_bi));
d_T8_dV_gi_bi = (deriv_pow_0_d0*(d_T7_dV_gi_bi));
T8 = value_pow_0;
}

d_Vdseff_dV_gm_di = d_Vdseff_dV_gm_si = d_Vdseff_dV_dbulk_di = d_Vdseff_dV_sbulk_si =  0.0;
d_Vdseff_dTemp_t_GND = Vds*d_T8_dTemp_t_GND;
d_Vdseff_dV_gi_bi = Vds*d_T8_dV_gi_bi;
d_Vdseff_dV_si_bi = (Vds*d_T8_dV_si_bi+d_Vds_dV_si_bi*T8);
d_Vdseff_dV_di_bi = (Vds*d_T8_dV_di_bi+d_Vds_dV_di_bi*T8);
Vdseff = (Vds*T8);

d_vdeff_dV_gm_di = d_vdeff_dV_gm_si = d_vdeff_dV_dbulk_di = d_vdeff_dV_sbulk_si =  0.0;
d_vdeff_dTemp_t_GND = ((Vdseff+Vs)*d_inv_nVt_dTemp_t_GND+d_Vdseff_dTemp_t_GND*inv_nVt);
d_vdeff_dV_gi_bi = ((Vdseff+Vs)*d_inv_nVt_dV_gi_bi+d_Vdseff_dV_gi_bi*inv_nVt);
d_vdeff_dV_si_bi = ((Vdseff+Vs)*d_inv_nVt_dV_si_bi+(d_Vdseff_dV_si_bi+d_Vs_dV_si_bi)*inv_nVt);
d_vdeff_dV_di_bi = ((Vdseff+Vs)*d_inv_nVt_dV_di_bi+(d_Vdseff_dV_di_bi+d_Vs_dV_di_bi)*inv_nVt);
vdeff = ((Vdseff+Vs)*inv_nVt);
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si = d_T8_dV_dbulk_di = d_T8_dV_sbulk_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_T8_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_T8_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_T8_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dV_gm_di = d_sqrtpsip_dV_gm_si = d_sqrtpsip_dV_dbulk_di = d_sqrtpsip_dV_sbulk_si =  0.0;
d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T8_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_T8_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_T8_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_T8_dV_gi_bi));
sqrtpsip = value_sqrt_0;
}

d_T9_dV_gm_si = d_T9_dV_gm_di = d_T9_dV_dbulk_di = d_T9_dV_sbulk_si =  0.0;
d_T9_dV_gi_bi = (((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dTemp_t_GND = (((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_si_bi = (((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_di_bi = (((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gi_bi)/gam/gam);
d_T0_dTemp_t_GND = ((gam*(((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dTemp_t_GND)/gam/gam);
d_T0_dV_si_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_si_bi)/gam/gam);
d_T0_dV_di_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_di_bi)/gam/gam);
T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_n_dTemp_t_GND)-d_vdeff_dTemp_t_GND);
d_T1_dV_si_bi = ((d_psip_dV_si_bi-2.0*d_phib_n_dV_si_bi)-d_vdeff_dV_si_bi);
d_T1_dV_di_bi = ((d_psip_dV_di_bi-2.0*d_phib_n_dV_di_bi)-d_vdeff_dV_di_bi);
d_T1_dV_gi_bi = ((d_psip_dV_gi_bi-2.0*d_phib_n_dV_gi_bi)-d_vdeff_dV_gi_bi);
T1 = ((psip-(2.0*phib_n))-vdeff);
{
double value_log_0 = log(((4.0*T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*T0)*sqrtpsip));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dTemp_t_GND+4.0*d_T0_dTemp_t_GND*sqrtpsip))));
d_T2_dV_si_bi = (d_T1_dV_si_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_si_bi+4.0*d_T0_dV_si_bi*sqrtpsip))));
d_T2_dV_di_bi = (d_T1_dV_di_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_di_bi+4.0*d_T0_dV_di_bi*sqrtpsip))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gi_bi+4.0*d_T0_dV_gi_bi*sqrtpsip))));
T2 = (T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((T2*(T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si = d_T8_dV_dbulk_di = d_T8_dV_sbulk_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND-(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*(T2+0.402982)))));
d_T8_dV_si_bi = 0.5*(d_T2_dV_si_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*(T2+0.402982)))));
d_T8_dV_di_bi = 0.5*(d_T2_dV_di_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*(T2+0.402982)))));
d_T8_dV_gi_bi = 0.5*(d_T2_dV_gi_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*(T2+0.402982)))));
T8 = (0.5*((T2-0.201491)-value_sqrt_0));
}

d_sqrtpsisa_dV_gm_di = d_sqrtpsisa_dV_gm_si = d_sqrtpsisa_dV_dbulk_di = d_sqrtpsisa_dV_sbulk_si =  0.0;
d_sqrtpsisa_dTemp_t_GND = d_sqrtpsip_dTemp_t_GND;
d_sqrtpsisa_dV_si_bi = d_sqrtpsip_dV_si_bi;
d_sqrtpsisa_dV_di_bi = d_sqrtpsip_dV_di_bi;
d_sqrtpsisa_dV_gi_bi = d_sqrtpsip_dV_gi_bi;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dV_di_bi = d_T4_dV_si_bi = d_T4_dTemp_t_GND =  0.0;
T4 = (-100.0);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T4_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T4_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T4_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T4_dV_gi_bi));
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
T3 = value_exp_0;
}
}
else
{

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = ((T5*(d_T8_dTemp_t_GND-d_T4_dTemp_t_GND)-(T8-T4)*d_T5_dTemp_t_GND)/T5/T5);
d_T2_dV_si_bi = ((T5*(d_T8_dV_si_bi-d_T4_dV_si_bi)-(T8-T4)*d_T5_dV_si_bi)/T5/T5);
d_T2_dV_di_bi = ((T5*(d_T8_dV_di_bi-d_T4_dV_di_bi)-(T8-T4)*d_T5_dV_di_bi)/T5/T5);
d_T2_dV_gi_bi = ((T5*(d_T8_dV_gi_bi-d_T4_dV_gi_bi)-(T8-T4)*d_T5_dV_gi_bi)/T5/T5);
T2 = ((T8-T4)/T5);

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2);
d_T6_dV_si_bi = (T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2);
d_T6_dV_di_bi = (T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2);
d_T6_dV_gi_bi = (T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2);
T6 = (T2*T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*((d_T4_dTemp_t_GND+(T5*(0.5*d_T2_dTemp_t_GND+(T6*(-(T6*(-d_T6_dTemp_t_GND)+d_T6_dTemp_t_GND*(1.25-T6)))+d_T6_dTemp_t_GND*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dTemp_t_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_si_bi = (deriv_exp_0_d0*((d_T4_dV_si_bi+(T5*(0.5*d_T2_dV_si_bi+(T6*(-(T6*(-d_T6_dV_si_bi)+d_T6_dV_si_bi*(1.25-T6)))+d_T6_dV_si_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_si_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_di_bi = (deriv_exp_0_d0*((d_T4_dV_di_bi+(T5*(0.5*d_T2_dV_di_bi+(T6*(-(T6*(-d_T6_dV_di_bi)+d_T6_dV_di_bi*(1.25-T6)))+d_T6_dV_di_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_di_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((d_T4_dV_gi_bi+(T5*(0.5*d_T2_dV_gi_bi+(T6*(-(T6*(-d_T6_dV_gi_bi)+d_T6_dV_gi_bi*(1.25-T6)))+d_T6_dV_gi_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_qdeff_dV_gm_si = d_qdeff_dV_gm_di = d_qdeff_dV_dbulk_di = d_qdeff_dV_sbulk_si =  0.0;
d_qdeff_dTemp_t_GND = (T3*((d_T1_dTemp_t_GND-d_T8_dTemp_t_GND)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+2.0*d_T0_dTemp_t_GND*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dTemp_t_GND*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_si_bi = (T3*((d_T1_dV_si_bi-d_T8_dV_si_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+2.0*d_T0_dV_si_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_si_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_di_bi = (T3*((d_T1_dV_di_bi-d_T8_dV_di_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+2.0*d_T0_dV_di_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_di_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_gi_bi = (T3*((d_T1_dV_gi_bi-d_T8_dV_gi_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+2.0*d_T0_dV_gi_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gi_bi*(((1.0+T1)-T8)-value_log_0));
qdeff = (T3*(((1.0+T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
T3 = value_exp_0;
}

d_sqrtpsisainv_dV_gm_di = d_sqrtpsisainv_dV_gm_si = d_sqrtpsisainv_dV_dbulk_di = d_sqrtpsisainv_dV_sbulk_si =  0.0;
d_sqrtpsisainv_dTemp_t_GND = (-d_sqrtpsisa_dTemp_t_GND/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_si_bi = (-d_sqrtpsisa_dV_si_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_di_bi = (-d_sqrtpsisa_dV_di_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gi_bi = (-d_sqrtpsisa_dV_gi_bi/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T3_dTemp_t_GND-((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5));
d_T3_dV_si_bi = (d_T3_dV_si_bi-((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5));
d_T3_dV_di_bi = (d_T3_dV_di_bi-((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5));
d_T3_dV_gi_bi = (d_T3_dV_gi_bi-((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_si_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_di_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gi_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T7_dV_gm_si = d_T7_dV_gm_di = d_T7_dV_dbulk_di = d_T7_dV_sbulk_si =  0.0;
d_T7_dTemp_t_GND = (((-((1.0/T3)*(-d_T3_dTemp_t_GND/T3/T3)+(-d_T3_dTemp_t_GND/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dTemp_t_GND+(sqrtpsisa*d_sqrtpsisa_dTemp_t_GND+d_sqrtpsisa_dTemp_t_GND*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dTemp_t_GND);
d_T7_dV_si_bi = (((-((1.0/T3)*(-d_T3_dV_si_bi/T3/T3)+(-d_T3_dV_si_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_si_bi+(sqrtpsisa*d_sqrtpsisa_dV_si_bi+d_sqrtpsisa_dV_si_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_si_bi);
d_T7_dV_di_bi = (((-((1.0/T3)*(-d_T3_dV_di_bi/T3/T3)+(-d_T3_dV_di_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_di_bi+(sqrtpsisa*d_sqrtpsisa_dV_di_bi+d_sqrtpsisa_dV_di_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_di_bi);
d_T7_dV_gi_bi = (((-((1.0/T3)*(-d_T3_dV_gi_bi/T3/T3)+(-d_T3_dV_gi_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gi_bi+(sqrtpsisa*d_sqrtpsisa_dV_gi_bi+d_sqrtpsisa_dV_gi_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gi_bi);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);

d_qdeff_dV_gm_si = d_qdeff_dV_gm_di = d_qdeff_dV_dbulk_di = d_qdeff_dV_sbulk_si =  0.0;
d_qdeff_dTemp_t_GND = (d_T3_dTemp_t_GND-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dTemp_t_GND+d_T4_dTemp_t_GND*T7)-(T4*T7)*((2.0*T5)*d_T5_dTemp_t_GND+2.0*d_T5_dTemp_t_GND*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_si_bi = (d_T3_dV_si_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_si_bi+d_T4_dV_si_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_si_bi+2.0*d_T5_dV_si_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_di_bi = (d_T3_dV_di_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_di_bi+d_T4_dV_di_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_di_bi+2.0*d_T5_dV_di_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_gi_bi = (d_T3_dV_gi_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gi_bi+d_T4_dV_gi_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gi_bi+2.0*d_T5_dV_gi_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}

d_psiavg_dV_gm_di = d_psiavg_dV_gm_si = d_psiavg_dV_dbulk_di = d_psiavg_dV_sbulk_si =  0.0;
d_psiavg_dTemp_t_GND = ((d_psip_dTemp_t_GND-d_qs_dTemp_t_GND)-d_qdeff_dTemp_t_GND);
d_psiavg_dV_si_bi = ((d_psip_dV_si_bi-d_qs_dV_si_bi)-d_qdeff_dV_si_bi);
d_psiavg_dV_di_bi = ((d_psip_dV_di_bi-d_qs_dV_di_bi)-d_qdeff_dV_di_bi);
d_psiavg_dV_gi_bi = ((d_psip_dV_gi_bi-d_qs_dV_gi_bi)-d_qdeff_dV_gi_bi);
psiavg = (((psip-qs)-qdeff)-1.0);
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = 0.5*(d_psiavg_dTemp_t_GND+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dTemp_t_GND+d_psiavg_dTemp_t_GND*(psiavg-1.0)))));
d_T0_dV_si_bi = 0.5*(d_psiavg_dV_si_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_si_bi+d_psiavg_dV_si_bi*(psiavg-1.0)))));
d_T0_dV_di_bi = 0.5*(d_psiavg_dV_di_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_di_bi+d_psiavg_dV_di_bi*(psiavg-1.0)))));
d_T0_dV_gi_bi = 0.5*(d_psiavg_dV_gi_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_gi_bi+d_psiavg_dV_gi_bi*(psiavg-1.0)))));
T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T0_dTemp_t_GND));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*(d_T0_dV_si_bi));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*(d_T0_dV_di_bi));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*(d_T0_dV_gi_bi));
T2 = value_sqrt_0;
}

d_nq_dV_gm_si = d_nq_dV_gm_di = d_nq_dV_dbulk_di = d_nq_dV_sbulk_si =  0.0;
d_nq_dV_gi_bi = (((sqrtpsip+T2)*d_gam_dV_gi_bi-gam*(d_sqrtpsip_dV_gi_bi+d_T2_dV_gi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dTemp_t_GND = (((sqrtpsip+T2)*d_gam_dTemp_t_GND-gam*(d_sqrtpsip_dTemp_t_GND+d_T2_dTemp_t_GND))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_si_bi = (((sqrtpsip+T2)*d_gam_dV_si_bi-gam*(d_sqrtpsip_dV_si_bi+d_T2_dV_si_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_di_bi = (((sqrtpsip+T2)*d_gam_dV_di_bi-gam*(d_sqrtpsip_dV_di_bi+d_T2_dV_di_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
nq = (1.0+(gam/(sqrtpsip+T2)));

d_DQSD2_dV_dbulk_di = d_DQSD2_dV_sbulk_si =  0.0;
d_DQSD2_dTemp_t_GND = ((qs-qdeff)*(d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND)+(d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND)*(qs-qdeff));
d_DQSD2_dV_si_bi = ((qs-qdeff)*(d_qs_dV_si_bi-d_qdeff_dV_si_bi)+(d_qs_dV_si_bi-d_qdeff_dV_si_bi)*(qs-qdeff));
d_DQSD2_dV_di_bi = ((qs-qdeff)*(d_qs_dV_di_bi-d_qdeff_dV_di_bi)+(d_qs_dV_di_bi-d_qdeff_dV_di_bi)*(qs-qdeff));
d_DQSD2_dV_gi_bi = ((qs-qdeff)*(d_qs_dV_gi_bi-d_qdeff_dV_gi_bi)+(d_qs_dV_gi_bi-d_qdeff_dV_gi_bi)*(qs-qdeff));
DQSD2 = ((qs-qdeff)*(qs-qdeff));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = (-(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T0_dV_si_bi = (-(d_qs_dV_si_bi+d_qdeff_dV_si_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T0_dV_di_bi = (-(d_qs_dV_di_bi+d_qdeff_dV_di_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T0_dV_gi_bi = (-(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
T0 = (1.0/((1.0+qs)+qdeff));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = (DQSD2*d_T0_dTemp_t_GND+d_DQSD2_dTemp_t_GND*T0);
d_T1_dV_si_bi = (DQSD2*d_T0_dV_si_bi+d_DQSD2_dV_si_bi*T0);
d_T1_dV_di_bi = (DQSD2*d_T0_dV_di_bi+d_DQSD2_dV_di_bi*T0);
d_T1_dV_gi_bi = (DQSD2*d_T0_dV_gi_bi+d_DQSD2_dV_gi_bi*T0);
T1 = (DQSD2*T0);

d_Qb_dV_dbulk_di = d_Qb_dV_sbulk_si =  0.0;
d_Qb_dTemp_t_GND = ((d_vgfb_dTemp_t_GND-d_psip_dTemp_t_GND)-((nq-1.0)*((d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+0.33333333333333333*d_T1_dTemp_t_GND)+d_nq_dTemp_t_GND*((qs+qdeff)+(0.33333333333333333*T1))));
d_Qb_dV_si_bi = ((d_vgfb_dV_si_bi-d_psip_dV_si_bi)-((nq-1.0)*((d_qs_dV_si_bi+d_qdeff_dV_si_bi)+0.33333333333333333*d_T1_dV_si_bi)+d_nq_dV_si_bi*((qs+qdeff)+(0.33333333333333333*T1))));
d_Qb_dV_di_bi = ((d_vgfb_dV_di_bi-d_psip_dV_di_bi)-((nq-1.0)*((d_qs_dV_di_bi+d_qdeff_dV_di_bi)+0.33333333333333333*d_T1_dV_di_bi)+d_nq_dV_di_bi*((qs+qdeff)+(0.33333333333333333*T1))));
d_Qb_dV_gi_bi = ((d_vgfb_dV_gi_bi-d_psip_dV_gi_bi)-((nq-1.0)*((d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+0.33333333333333333*d_T1_dV_gi_bi)+d_nq_dV_gi_bi*((qs+qdeff)+(0.33333333333333333*T1))));
Qb = ((vgfb-psip)-((nq-1.0)*((qs+qdeff)+(0.33333333333333333*T1))));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_si_bi = 0.33333333333333333*d_nq_dV_si_bi;
d_T2_dV_di_bi = 0.33333333333333333*d_nq_dV_di_bi;
d_T2_dTemp_t_GND = 0.33333333333333333*d_nq_dTemp_t_GND;
d_T2_dV_gi_bi = 0.33333333333333333*d_nq_dV_gi_bi;
T2 = (0.33333333333333333*nq);

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (T1*d_T0_dTemp_t_GND+d_T1_dTemp_t_GND*T0);
d_T3_dV_si_bi = (T1*d_T0_dV_si_bi+d_T1_dV_si_bi*T0);
d_T3_dV_di_bi = (T1*d_T0_dV_di_bi+d_T1_dV_di_bi*T0);
d_T3_dV_gi_bi = (T1*d_T0_dV_gi_bi+d_T1_dV_gi_bi*T0);
T3 = (T1*T0);

d_Qs_dV_dbulk_di = d_Qs_dV_sbulk_si =  0.0;
d_Qs_dTemp_t_GND = (T2*((2.0*d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*d_T3_dTemp_t_GND+0.5*(0.8*d_qs_dTemp_t_GND+1.2*d_qdeff_dTemp_t_GND)*T3))+d_T2_dTemp_t_GND*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
d_Qs_dV_si_bi = (T2*((2.0*d_qs_dV_si_bi+d_qdeff_dV_si_bi)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*d_T3_dV_si_bi+0.5*(0.8*d_qs_dV_si_bi+1.2*d_qdeff_dV_si_bi)*T3))+d_T2_dV_si_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
d_Qs_dV_di_bi = (T2*((2.0*d_qs_dV_di_bi+d_qdeff_dV_di_bi)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*d_T3_dV_di_bi+0.5*(0.8*d_qs_dV_di_bi+1.2*d_qdeff_dV_di_bi)*T3))+d_T2_dV_di_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
d_Qs_dV_gi_bi = (T2*((2.0*d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*d_T3_dV_gi_bi+0.5*(0.8*d_qs_dV_gi_bi+1.2*d_qdeff_dV_gi_bi)*T3))+d_T2_dV_gi_bi*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
Qs = (T2*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));

d_Qd_dV_dbulk_di = d_Qd_dV_sbulk_si =  0.0;
d_Qd_dTemp_t_GND = (T2*((d_qs_dTemp_t_GND+2.0*d_qdeff_dTemp_t_GND)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*d_T3_dTemp_t_GND+0.5*(1.2*d_qs_dTemp_t_GND+0.8*d_qdeff_dTemp_t_GND)*T3))+d_T2_dTemp_t_GND*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
d_Qd_dV_si_bi = (T2*((d_qs_dV_si_bi+2.0*d_qdeff_dV_si_bi)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*d_T3_dV_si_bi+0.5*(1.2*d_qs_dV_si_bi+0.8*d_qdeff_dV_si_bi)*T3))+d_T2_dV_si_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
d_Qd_dV_di_bi = (T2*((d_qs_dV_di_bi+2.0*d_qdeff_dV_di_bi)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*d_T3_dV_di_bi+0.5*(1.2*d_qs_dV_di_bi+0.8*d_qdeff_dV_di_bi)*T3))+d_T2_dV_di_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
d_Qd_dV_gi_bi = (T2*((d_qs_dV_gi_bi+2.0*d_qdeff_dV_gi_bi)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*d_T3_dV_gi_bi+0.5*(1.2*d_qs_dV_gi_bi+0.8*d_qdeff_dV_gi_bi)*T3))+d_T2_dV_gi_bi*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
Qd = (T2*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
{
double value_sqrt_0 = sqrt(((((nVt*Qb))*((nVt*Qb)))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qba_dV_gi_bi = 0.5*((nVt*d_Qb_dV_gi_bi+d_nVt_dV_gi_bi*Qb)+(deriv_sqrt_0_d0*((((nVt*Qb))*(nVt*d_Qb_dV_gi_bi+d_nVt_dV_gi_bi*Qb)+(nVt*d_Qb_dV_gi_bi+d_nVt_dV_gi_bi*Qb)*((nVt*Qb))))));
d_qba_dTemp_t_GND = 0.5*((nVt*d_Qb_dTemp_t_GND+d_nVt_dTemp_t_GND*Qb)+(deriv_sqrt_0_d0*((((nVt*Qb))*(nVt*d_Qb_dTemp_t_GND+d_nVt_dTemp_t_GND*Qb)+(nVt*d_Qb_dTemp_t_GND+d_nVt_dTemp_t_GND*Qb)*((nVt*Qb))))));
d_qba_dV_si_bi = 0.5*((nVt*d_Qb_dV_si_bi+d_nVt_dV_si_bi*Qb)+(deriv_sqrt_0_d0*((((nVt*Qb))*(nVt*d_Qb_dV_si_bi+d_nVt_dV_si_bi*Qb)+(nVt*d_Qb_dV_si_bi+d_nVt_dV_si_bi*Qb)*((nVt*Qb))))));
d_qba_dV_di_bi = 0.5*((nVt*d_Qb_dV_di_bi+d_nVt_dV_di_bi*Qb)+(deriv_sqrt_0_d0*((((nVt*Qb))*(nVt*d_Qb_dV_di_bi+d_nVt_dV_di_bi*Qb)+(nVt*d_Qb_dV_di_bi+d_nVt_dV_di_bi*Qb)*((nVt*Qb))))));
qba = (0.5*((nVt*Qb)+value_sqrt_0));
}

d_qia_dV_dbulk_di = d_qia_dV_sbulk_si =  0.0;
d_qia_dV_gi_bi = (nVt*(d_Qs_dV_gi_bi+d_Qd_dV_gi_bi)+d_nVt_dV_gi_bi*(Qs+Qd));
d_qia_dTemp_t_GND = (nVt*(d_Qs_dTemp_t_GND+d_Qd_dTemp_t_GND)+d_nVt_dTemp_t_GND*(Qs+Qd));
d_qia_dV_si_bi = (nVt*(d_Qs_dV_si_bi+d_Qd_dV_si_bi)+d_nVt_dV_si_bi*(Qs+Qd));
d_qia_dV_di_bi = (nVt*(d_Qs_dV_di_bi+d_Qd_dV_di_bi)+d_nVt_dV_di_bi*(Qs+Qd));
qia = (nVt*(Qs+Qd));

d_Eeffm_dV_dbulk_di = d_Eeffm_dV_sbulk_si =  0.0;
d_Eeffm_dV_gi_bi = EeffFactor*(d_qba_dV_gi_bi+eta_mu*d_qia_dV_gi_bi);
d_Eeffm_dTemp_t_GND = EeffFactor*(d_qba_dTemp_t_GND+eta_mu*d_qia_dTemp_t_GND);
d_Eeffm_dV_si_bi = EeffFactor*(d_qba_dV_si_bi+eta_mu*d_qia_dV_si_bi);
d_Eeffm_dV_di_bi = EeffFactor*(d_qba_dV_di_bi+eta_mu*d_qia_dV_di_bi);
Eeffm = (EeffFactor*(qba+(eta_mu*qia)));
{
double value_pow_0 = pow((0.5*(1.0+(qia/qba))),UCS_a);
double  deriv_pow_0_d0 = (((0.5*(1.0+(qia/qba))) == 0.0)?0.0:(value_pow_0*UCS_a/(0.5*(1.0+(qia/qba)))));
double  deriv_pow_0_d1 = ((0.5*(1.0+(qia/qba))) == 0.0)?0.0:(log((0.5*(1.0+(qia/qba))))*value_pow_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_gi_bi = (deriv_pow_0_d0*(0.5*((qba*d_qia_dV_gi_bi-qia*d_qba_dV_gi_bi)/qba/qba)));
d_T2_dTemp_t_GND = ((deriv_pow_0_d0*(0.5*((qba*d_qia_dTemp_t_GND-qia*d_qba_dTemp_t_GND)/qba/qba)))+(deriv_pow_0_d1*(d_UCS_a_dTemp_t_GND)));
d_T2_dV_si_bi = ((deriv_pow_0_d0*(0.5*((qba*d_qia_dV_si_bi-qia*d_qba_dV_si_bi)/qba/qba)))+(deriv_pow_0_d1*(d_UCS_a_dV_si_bi)));
d_T2_dV_di_bi = ((deriv_pow_0_d0*(0.5*((qba*d_qia_dV_di_bi-qia*d_qba_dV_di_bi)/qba/qba)))+(deriv_pow_0_d1*(d_UCS_a_dV_di_bi)));
T2 = value_pow_0;
}
{
double value_pow_0 = pow(Eeffm,EU_i);
double  deriv_pow_0_d0 = ((Eeffm == 0.0)?0.0:(value_pow_0*EU_i/Eeffm));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dV_gi_bi = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_gi_bi))+(-UD_a*d_T2_dV_gi_bi/T2/T2));
d_T3_dV_si_bi = (((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_si_bi))+(d_UA_a_dV_si_bi+(UC_a*d_Vbsx_dV_si_bi+d_UC_a_dV_si_bi*Vbsx))*value_pow_0)+((T2*d_UD_a_dV_si_bi-UD_a*d_T2_dV_si_bi)/T2/T2));
d_T3_dV_di_bi = (((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_di_bi))+(d_UA_a_dV_di_bi+(UC_a*d_Vbsx_dV_di_bi+d_UC_a_dV_di_bi*Vbsx))*value_pow_0)+((T2*d_UD_a_dV_di_bi-UD_a*d_T2_dV_di_bi)/T2/T2));
d_T3_dTemp_t_GND = (((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dTemp_t_GND))+(d_UA_a_dTemp_t_GND+d_UC_a_dTemp_t_GND*Vbsx)*value_pow_0)+((T2*d_UD_a_dTemp_t_GND-UD_a*d_T2_dTemp_t_GND)/T2/T2));
T3 = (((UA_a+(UC_a*Vbsx))*value_pow_0)+(UD_a/T2));
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = d_T3_dTemp_t_GND;
d_T4_dV_si_bi = d_T3_dV_si_bi;
d_T4_dV_di_bi = d_T3_dV_di_bi;
d_T4_dV_gi_bi = d_T3_dV_gi_bi;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Dmob_dV_dbulk_di = d_Dmob_dV_sbulk_si =  0.0;
d_Dmob_dTemp_t_GND = 0.5*(d_T4_dTemp_t_GND+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dTemp_t_GND+d_T4_dTemp_t_GND*(T4-1.0)))));
d_Dmob_dV_si_bi = 0.5*(d_T4_dV_si_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_si_bi+d_T4_dV_si_bi*(T4-1.0)))));
d_Dmob_dV_di_bi = 0.5*(d_T4_dV_di_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_di_bi+d_T4_dV_di_bi*(T4-1.0)))));
d_Dmob_dV_gi_bi = 0.5*(d_T4_dV_gi_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_gi_bi+d_T4_dV_gi_bi*(T4-1.0)))));
Dmob = (0.5*((T4+1.0)+value_sqrt_0));
}

d_Esat_dV_dbulk_di = d_Esat_dV_sbulk_si =  0.0;
d_Esat_dV_gi_bi = (-(2.0*VSAT_a)*(-U0_a*d_Dmob_dV_gi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dV_si_bi = (((U0_a/Dmob)*2.0*d_VSAT_a_dV_si_bi-(2.0*VSAT_a)*((Dmob*d_U0_a_dV_si_bi-U0_a*d_Dmob_dV_si_bi)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dV_di_bi = (((U0_a/Dmob)*2.0*d_VSAT_a_dV_di_bi-(2.0*VSAT_a)*((Dmob*d_U0_a_dV_di_bi-U0_a*d_Dmob_dV_di_bi)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dTemp_t_GND = (((U0_a/Dmob)*2.0*d_VSAT_a_dTemp_t_GND-(2.0*VSAT_a)*((Dmob*d_U0_a_dTemp_t_GND-U0_a*d_Dmob_dTemp_t_GND)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
Esat = ((2.0*VSAT_a)/(U0_a/Dmob));

d_EsatL_dV_dbulk_di = d_EsatL_dV_sbulk_si =  0.0;
d_EsatL_dV_gi_bi = d_Esat_dV_gi_bi*Leff;
d_EsatL_dV_si_bi = d_Esat_dV_si_bi*Leff;
d_EsatL_dV_di_bi = d_Esat_dV_di_bi*Leff;
d_EsatL_dTemp_t_GND = d_Esat_dTemp_t_GND*Leff;
EsatL = (Esat*Leff);
if ((PVAG_i>0))
{

d_PVAGfactor_dV_gi_bi = ((EsatL*PVAG_i*d_qia_dV_gi_bi-(PVAG_i*qia)*d_EsatL_dV_gi_bi)/EsatL/EsatL);
d_PVAGfactor_dTemp_t_GND = ((EsatL*PVAG_i*d_qia_dTemp_t_GND-(PVAG_i*qia)*d_EsatL_dTemp_t_GND)/EsatL/EsatL);
d_PVAGfactor_dV_si_bi = ((EsatL*PVAG_i*d_qia_dV_si_bi-(PVAG_i*qia)*d_EsatL_dV_si_bi)/EsatL/EsatL);
d_PVAGfactor_dV_di_bi = ((EsatL*PVAG_i*d_qia_dV_di_bi-(PVAG_i*qia)*d_EsatL_dV_di_bi)/EsatL/EsatL);
PVAGfactor = (1.0+((PVAG_i*qia)/EsatL));
}
else
{

d_PVAGfactor_dV_gi_bi = (-(-((EsatL*PVAG_i*d_qia_dV_gi_bi-(PVAG_i*qia)*d_EsatL_dV_gi_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
d_PVAGfactor_dTemp_t_GND = (-(-((EsatL*PVAG_i*d_qia_dTemp_t_GND-(PVAG_i*qia)*d_EsatL_dTemp_t_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
d_PVAGfactor_dV_si_bi = (-(-((EsatL*PVAG_i*d_qia_dV_si_bi-(PVAG_i*qia)*d_EsatL_dV_si_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
d_PVAGfactor_dV_di_bi = (-(-((EsatL*PVAG_i*d_qia_dV_di_bi-(PVAG_i*qia)*d_EsatL_dV_di_bi)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
PVAGfactor = (1.0/(1.0-((PVAG_i*qia)/EsatL)));
}

d_DIBLfactor_dTemp_t_GND = d_PDIBLC_a_dTemp_t_GND;
d_DIBLfactor_dV_si_bi = d_PDIBLC_a_dV_si_bi;
d_DIBLfactor_dV_di_bi = d_PDIBLC_a_dV_di_bi;
DIBLfactor = PDIBLC_a;

d_diffVds_dV_dbulk_di = d_diffVds_dV_sbulk_si =  0.0;
d_diffVds_dTemp_t_GND = (-d_Vdseff_dTemp_t_GND);
d_diffVds_dV_gi_bi = (-d_Vdseff_dV_gi_bi);
d_diffVds_dV_si_bi = (d_Vds_dV_si_bi-d_Vdseff_dV_si_bi);
d_diffVds_dV_di_bi = (d_Vds_dV_di_bi-d_Vdseff_dV_di_bi);
diffVds = (Vds-Vdseff);

d_Vgst2Vtm_dV_gi_bi = (d_qia_dV_gi_bi+2.0*d_nVt_dV_gi_bi);
d_Vgst2Vtm_dTemp_t_GND = (d_qia_dTemp_t_GND+2.0*d_nVt_dTemp_t_GND);
d_Vgst2Vtm_dV_si_bi = (d_qia_dV_si_bi+2.0*d_nVt_dV_si_bi);
d_Vgst2Vtm_dV_di_bi = (d_qia_dV_di_bi+2.0*d_nVt_dV_di_bi);
Vgst2Vtm = (qia+(2.0*nVt));
if ((DIBLfactor>0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dV_gi_bi = (((Vdssat+Vgst2Vtm)*d_Vgst2Vtm_dV_gi_bi-Vgst2Vtm*(d_Vdssat_dV_gi_bi+d_Vgst2Vtm_dV_gi_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
d_T3_dTemp_t_GND = (((Vdssat+Vgst2Vtm)*d_Vgst2Vtm_dTemp_t_GND-Vgst2Vtm*(d_Vdssat_dTemp_t_GND+d_Vgst2Vtm_dTemp_t_GND))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
d_T3_dV_si_bi = (((Vdssat+Vgst2Vtm)*d_Vgst2Vtm_dV_si_bi-Vgst2Vtm*(d_Vdssat_dV_si_bi+d_Vgst2Vtm_dV_si_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
d_T3_dV_di_bi = (((Vdssat+Vgst2Vtm)*d_Vgst2Vtm_dV_di_bi-Vgst2Vtm*(d_Vdssat_dV_di_bi+d_Vgst2Vtm_dV_di_bi))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
T3 = (Vgst2Vtm/(Vdssat+Vgst2Vtm));
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((1.0+(PDIBLCB_i*Vbsx)),1e-3);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dTemp_t_GND =  0.0;
d_T4_dV_si_bi = evaluator_hypsmooth_0.getDerivs((1.0+(PDIBLCB_i*Vbsx)),1e-3,PDIBLCB_i*d_Vbsx_dV_si_bi,0.0);
d_T4_dV_di_bi = evaluator_hypsmooth_0.getDerivs((1.0+(PDIBLCB_i*Vbsx)),1e-3,PDIBLCB_i*d_Vbsx_dV_di_bi,0.0);
T4 = evaluator_hypsmooth_0.getValues((1.0+(PDIBLCB_i*Vbsx)),1e-3);
}

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = (-1*d_T4_dTemp_t_GND/T4/T4);
d_T5_dV_si_bi = (-1*d_T4_dV_si_bi/T4/T4);
d_T5_dV_di_bi = (-1*d_T4_dV_di_bi/T4/T4);
d_T5_dV_gi_bi = (-1*d_T4_dV_gi_bi/T4/T4);
T5 = (1/T4);

d_VaDIBL_dV_gi_bi = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*d_T5_dV_gi_bi+(((Vgst2Vtm/DIBLfactor)*T3)*d_PVAGfactor_dV_gi_bi+((Vgst2Vtm/DIBLfactor)*d_T3_dV_gi_bi+(d_Vgst2Vtm_dV_gi_bi/DIBLfactor)*T3)*PVAGfactor)*T5);
d_VaDIBL_dTemp_t_GND = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*d_T5_dTemp_t_GND+(((Vgst2Vtm/DIBLfactor)*T3)*d_PVAGfactor_dTemp_t_GND+((Vgst2Vtm/DIBLfactor)*d_T3_dTemp_t_GND+((DIBLfactor*d_Vgst2Vtm_dTemp_t_GND-Vgst2Vtm*d_DIBLfactor_dTemp_t_GND)/DIBLfactor/DIBLfactor)*T3)*PVAGfactor)*T5);
d_VaDIBL_dV_si_bi = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*d_T5_dV_si_bi+(((Vgst2Vtm/DIBLfactor)*T3)*d_PVAGfactor_dV_si_bi+((Vgst2Vtm/DIBLfactor)*d_T3_dV_si_bi+((DIBLfactor*d_Vgst2Vtm_dV_si_bi-Vgst2Vtm*d_DIBLfactor_dV_si_bi)/DIBLfactor/DIBLfactor)*T3)*PVAGfactor)*T5);
d_VaDIBL_dV_di_bi = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*d_T5_dV_di_bi+(((Vgst2Vtm/DIBLfactor)*T3)*d_PVAGfactor_dV_di_bi+((Vgst2Vtm/DIBLfactor)*d_T3_dV_di_bi+((DIBLfactor*d_Vgst2Vtm_dV_di_bi-Vgst2Vtm*d_DIBLfactor_dV_di_bi)/DIBLfactor/DIBLfactor)*T3)*PVAGfactor)*T5);
VaDIBL = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5);

d_Moc_dTemp_t_GND = ((VaDIBL*d_diffVds_dTemp_t_GND-diffVds*d_VaDIBL_dTemp_t_GND)/VaDIBL/VaDIBL);
d_Moc_dV_gi_bi = ((VaDIBL*d_diffVds_dV_gi_bi-diffVds*d_VaDIBL_dV_gi_bi)/VaDIBL/VaDIBL);
d_Moc_dV_si_bi = ((VaDIBL*d_diffVds_dV_si_bi-diffVds*d_VaDIBL_dV_si_bi)/VaDIBL/VaDIBL);
d_Moc_dV_di_bi = ((VaDIBL*d_diffVds_dV_di_bi-diffVds*d_VaDIBL_dV_di_bi)/VaDIBL/VaDIBL);
Moc = (1.0+(diffVds/VaDIBL));
}
else
{

d_Moc_dV_di_bi = d_Moc_dV_si_bi = d_Moc_dV_gi_bi = d_Moc_dTemp_t_GND =  0.0;
Moc = 1.0;
}
if ((FPROUT_i<=0.0))
{

d_Fp_dV_di_bi = d_Fp_dV_si_bi = d_Fp_dTemp_t_GND = d_Fp_dV_gi_bi =  0.0;
Fp = 1.0;
}
else
{
{
double value_sqrt_0 = sqrt(Leff);

d_T9_dV_gm_si = d_T9_dV_gm_di = d_T9_dV_dbulk_di = d_T9_dV_sbulk_si =  0.0;
d_T9_dV_gi_bi = (-(FPROUT_i*value_sqrt_0)*d_Vgst2Vtm_dV_gi_bi/Vgst2Vtm/Vgst2Vtm);
d_T9_dTemp_t_GND = (-(FPROUT_i*value_sqrt_0)*d_Vgst2Vtm_dTemp_t_GND/Vgst2Vtm/Vgst2Vtm);
d_T9_dV_si_bi = (-(FPROUT_i*value_sqrt_0)*d_Vgst2Vtm_dV_si_bi/Vgst2Vtm/Vgst2Vtm);
d_T9_dV_di_bi = (-(FPROUT_i*value_sqrt_0)*d_Vgst2Vtm_dV_di_bi/Vgst2Vtm/Vgst2Vtm);
T9 = ((FPROUT_i*value_sqrt_0)/Vgst2Vtm);
}

d_Fp_dV_gi_bi = (-d_T9_dV_gi_bi/(1.0+T9)/(1.0+T9));
d_Fp_dTemp_t_GND = (-d_T9_dTemp_t_GND/(1.0+T9)/(1.0+T9));
d_Fp_dV_si_bi = (-d_T9_dV_si_bi/(1.0+T9)/(1.0+T9));
d_Fp_dV_di_bi = (-d_T9_dV_di_bi/(1.0+T9)/(1.0+T9));
Fp = (1.0/(1.0+T9));
}

d_Vasat_dV_dbulk_di = d_Vasat_dV_sbulk_si =  0.0;
d_Vasat_dTemp_t_GND = (d_Vdssat_dTemp_t_GND+d_EsatL_dTemp_t_GND);
d_Vasat_dV_si_bi = (d_Vdssat_dV_si_bi+d_EsatL_dV_si_bi);
d_Vasat_dV_di_bi = (d_Vdssat_dV_di_bi+d_EsatL_dV_di_bi);
d_Vasat_dV_gi_bi = (d_Vdssat_dV_gi_bi+d_EsatL_dV_gi_bi);
Vasat = (Vdssat+EsatL);
if ((PCLM_a!=0))
{
if (((model_.PCLMG)<0.0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((Fp*(-PCLM_a*(-((EsatL*(model_.PCLMG)*d_qia_dV_gi_bi-((model_.PCLMG)*qia)*d_EsatL_dV_gi_bi)/EsatL/EsatL))/(1.0-(((model_.PCLMG)*qia)/EsatL))/(1.0-(((model_.PCLMG)*qia)/EsatL)))-(PCLM_a/(1.0-(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dV_gi_bi)/Fp/Fp);
d_T1_dTemp_t_GND = ((Fp*(((1.0-(((model_.PCLMG)*qia)/EsatL))*d_PCLM_a_dTemp_t_GND-PCLM_a*(-((EsatL*(model_.PCLMG)*d_qia_dTemp_t_GND-((model_.PCLMG)*qia)*d_EsatL_dTemp_t_GND)/EsatL/EsatL)))/(1.0-(((model_.PCLMG)*qia)/EsatL))/(1.0-(((model_.PCLMG)*qia)/EsatL)))-(PCLM_a/(1.0-(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dTemp_t_GND)/Fp/Fp);
d_T1_dV_si_bi = ((Fp*(((1.0-(((model_.PCLMG)*qia)/EsatL))*d_PCLM_a_dV_si_bi-PCLM_a*(-((EsatL*(model_.PCLMG)*d_qia_dV_si_bi-((model_.PCLMG)*qia)*d_EsatL_dV_si_bi)/EsatL/EsatL)))/(1.0-(((model_.PCLMG)*qia)/EsatL))/(1.0-(((model_.PCLMG)*qia)/EsatL)))-(PCLM_a/(1.0-(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dV_si_bi)/Fp/Fp);
d_T1_dV_di_bi = ((Fp*(((1.0-(((model_.PCLMG)*qia)/EsatL))*d_PCLM_a_dV_di_bi-PCLM_a*(-((EsatL*(model_.PCLMG)*d_qia_dV_di_bi-((model_.PCLMG)*qia)*d_EsatL_dV_di_bi)/EsatL/EsatL)))/(1.0-(((model_.PCLMG)*qia)/EsatL))/(1.0-(((model_.PCLMG)*qia)/EsatL)))-(PCLM_a/(1.0-(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dV_di_bi)/Fp/Fp);
T1 = ((PCLM_a/(1.0-(((model_.PCLMG)*qia)/EsatL)))/Fp);
}
else
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((Fp*PCLM_a*((EsatL*(model_.PCLMG)*d_qia_dV_gi_bi-((model_.PCLMG)*qia)*d_EsatL_dV_gi_bi)/EsatL/EsatL)-(PCLM_a*(1.0+(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dV_gi_bi)/Fp/Fp);
d_T1_dTemp_t_GND = ((Fp*(PCLM_a*((EsatL*(model_.PCLMG)*d_qia_dTemp_t_GND-((model_.PCLMG)*qia)*d_EsatL_dTemp_t_GND)/EsatL/EsatL)+d_PCLM_a_dTemp_t_GND*(1.0+(((model_.PCLMG)*qia)/EsatL)))-(PCLM_a*(1.0+(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dTemp_t_GND)/Fp/Fp);
d_T1_dV_si_bi = ((Fp*(PCLM_a*((EsatL*(model_.PCLMG)*d_qia_dV_si_bi-((model_.PCLMG)*qia)*d_EsatL_dV_si_bi)/EsatL/EsatL)+d_PCLM_a_dV_si_bi*(1.0+(((model_.PCLMG)*qia)/EsatL)))-(PCLM_a*(1.0+(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dV_si_bi)/Fp/Fp);
d_T1_dV_di_bi = ((Fp*(PCLM_a*((EsatL*(model_.PCLMG)*d_qia_dV_di_bi-((model_.PCLMG)*qia)*d_EsatL_dV_di_bi)/EsatL/EsatL)+d_PCLM_a_dV_di_bi*(1.0+(((model_.PCLMG)*qia)/EsatL)))-(PCLM_a*(1.0+(((model_.PCLMG)*qia)/EsatL)))*d_Fp_dV_di_bi)/Fp/Fp);
T1 = ((PCLM_a*(1.0+(((model_.PCLMG)*qia)/EsatL)))/Fp);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+((diffVds/T1)/Vasat)));

d_MdL_dV_dbulk_di = d_MdL_dV_sbulk_si =  0.0;
d_MdL_dTemp_t_GND = (T1*evaluator_lln_0.getDerivs((1.0+((diffVds/T1)/Vasat)),((Vasat*((T1*d_diffVds_dTemp_t_GND-diffVds*d_T1_dTemp_t_GND)/T1/T1)-(diffVds/T1)*d_Vasat_dTemp_t_GND)/Vasat/Vasat))+d_T1_dTemp_t_GND*evaluator_lln_0.getValues((1.0+((diffVds/T1)/Vasat))));
d_MdL_dV_si_bi = (T1*evaluator_lln_0.getDerivs((1.0+((diffVds/T1)/Vasat)),((Vasat*((T1*d_diffVds_dV_si_bi-diffVds*d_T1_dV_si_bi)/T1/T1)-(diffVds/T1)*d_Vasat_dV_si_bi)/Vasat/Vasat))+d_T1_dV_si_bi*evaluator_lln_0.getValues((1.0+((diffVds/T1)/Vasat))));
d_MdL_dV_di_bi = (T1*evaluator_lln_0.getDerivs((1.0+((diffVds/T1)/Vasat)),((Vasat*((T1*d_diffVds_dV_di_bi-diffVds*d_T1_dV_di_bi)/T1/T1)-(diffVds/T1)*d_Vasat_dV_di_bi)/Vasat/Vasat))+d_T1_dV_di_bi*evaluator_lln_0.getValues((1.0+((diffVds/T1)/Vasat))));
d_MdL_dV_gi_bi = (T1*evaluator_lln_0.getDerivs((1.0+((diffVds/T1)/Vasat)),((Vasat*((T1*d_diffVds_dV_gi_bi-diffVds*d_T1_dV_gi_bi)/T1/T1)-(diffVds/T1)*d_Vasat_dV_gi_bi)/Vasat/Vasat))+d_T1_dV_gi_bi*evaluator_lln_0.getValues((1.0+((diffVds/T1)/Vasat))));
MdL = (1.0+(T1*evaluator_lln_0.getValues((1.0+((diffVds/T1)/Vasat)))));
}
}
else
{

d_MdL_dV_dbulk_di = d_MdL_dV_sbulk_si = d_MdL_dV_gi_bi = d_MdL_dV_di_bi = d_MdL_dV_si_bi = d_MdL_dTemp_t_GND =  0.0;
MdL = 1.0;
}

d_Moc_dTemp_t_GND = (Moc*d_MdL_dTemp_t_GND+d_Moc_dTemp_t_GND*MdL);
d_Moc_dV_gi_bi = (Moc*d_MdL_dV_gi_bi+d_Moc_dV_gi_bi*MdL);
d_Moc_dV_si_bi = (Moc*d_MdL_dV_si_bi+d_Moc_dV_si_bi*MdL);
d_Moc_dV_di_bi = (Moc*d_MdL_dV_di_bi+d_Moc_dV_di_bi*MdL);
Moc = (Moc*MdL);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((PDITSD_i*Vds));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dTemp_t_GND =  0.0;
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs((PDITSD_i*Vds),PDITSD_i*d_Vds_dV_si_bi);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs((PDITSD_i*Vds),PDITSD_i*d_Vds_dV_di_bi);
T1 = evaluator_lexp_0.getValues((PDITSD_i*Vds));
}
if ((PDITS_i>0.0))
{

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = (1.0+((model_.PDITSL)*Leff));

d_VaDITS_dTemp_t_GND = ((T2*d_T1_dTemp_t_GND+d_T2_dTemp_t_GND*T1)/PDITS_i);
d_VaDITS_dV_si_bi = ((T2*d_T1_dV_si_bi+d_T2_dV_si_bi*T1)/PDITS_i);
d_VaDITS_dV_di_bi = ((T2*d_T1_dV_di_bi+d_T2_dV_di_bi*T1)/PDITS_i);
d_VaDITS_dV_gi_bi = ((T2*d_T1_dV_gi_bi+d_T2_dV_gi_bi*T1)/PDITS_i);
VaDITS = ((1.0+(T2*T1))/PDITS_i);

d_VaDITS_dTemp_t_GND = (VaDITS*d_Fp_dTemp_t_GND+d_VaDITS_dTemp_t_GND*Fp);
d_VaDITS_dV_si_bi = (VaDITS*d_Fp_dV_si_bi+d_VaDITS_dV_si_bi*Fp);
d_VaDITS_dV_di_bi = (VaDITS*d_Fp_dV_di_bi+d_VaDITS_dV_di_bi*Fp);
d_VaDITS_dV_gi_bi = (VaDITS*d_Fp_dV_gi_bi+d_VaDITS_dV_gi_bi*Fp);
VaDITS = (VaDITS*Fp);
}
else
{

d_VaDITS_dV_gi_bi = d_VaDITS_dV_di_bi = d_VaDITS_dV_si_bi = d_VaDITS_dTemp_t_GND =  0.0;
VaDITS = 5.540622384e+34;
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((VaDITS*d_diffVds_dTemp_t_GND-diffVds*d_VaDITS_dTemp_t_GND)/VaDITS/VaDITS);
d_T4_dV_gi_bi = ((VaDITS*d_diffVds_dV_gi_bi-diffVds*d_VaDITS_dV_gi_bi)/VaDITS/VaDITS);
d_T4_dV_si_bi = ((VaDITS*d_diffVds_dV_si_bi-diffVds*d_VaDITS_dV_si_bi)/VaDITS/VaDITS);
d_T4_dV_di_bi = ((VaDITS*d_diffVds_dV_di_bi-diffVds*d_VaDITS_dV_di_bi)/VaDITS/VaDITS);
T4 = (diffVds/VaDITS);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = d_T4_dTemp_t_GND;
d_T0_dV_si_bi = d_T4_dV_si_bi;
d_T0_dV_di_bi = d_T4_dV_di_bi;
d_T0_dV_gi_bi = d_T4_dV_gi_bi;
T0 = (1.0+T4);

d_Moc_dTemp_t_GND = (Moc*d_T0_dTemp_t_GND+d_Moc_dTemp_t_GND*T0);
d_Moc_dV_gi_bi = (Moc*d_T0_dV_gi_bi+d_Moc_dV_gi_bi*T0);
d_Moc_dV_si_bi = (Moc*d_T0_dV_si_bi+d_Moc_dV_si_bi*T0);
d_Moc_dV_di_bi = (Moc*d_T0_dV_di_bi+d_Moc_dV_di_bi*T0);
Moc = (Moc*T0);
if ((PSCBE2_i>0.0))
{
if ((diffVds>((PSCBE1_i*litl)/80.0)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = (-(PSCBE1_i*litl)*d_diffVds_dTemp_t_GND/diffVds/diffVds);
d_T0_dV_gi_bi = (-(PSCBE1_i*litl)*d_diffVds_dV_gi_bi/diffVds/diffVds);
d_T0_dV_si_bi = (-(PSCBE1_i*litl)*d_diffVds_dV_si_bi/diffVds/diffVds);
d_T0_dV_di_bi = (-(PSCBE1_i*litl)*d_diffVds_dV_di_bi/diffVds/diffVds);
T0 = ((PSCBE1_i*litl)/diffVds);
{
double value_exp_0 = exp(T0);
double  deriv_exp_0_d0 = value_exp_0;

d_VaSCBE_dTemp_t_GND = (Leff*(deriv_exp_0_d0*(d_T0_dTemp_t_GND))/PSCBE2_i);
d_VaSCBE_dV_si_bi = (Leff*(deriv_exp_0_d0*(d_T0_dV_si_bi))/PSCBE2_i);
d_VaSCBE_dV_di_bi = (Leff*(deriv_exp_0_d0*(d_T0_dV_di_bi))/PSCBE2_i);
d_VaSCBE_dV_gi_bi = (Leff*(deriv_exp_0_d0*(d_T0_dV_gi_bi))/PSCBE2_i);
VaSCBE = ((Leff*value_exp_0)/PSCBE2_i);
}
}
else
{

d_VaSCBE_dV_gi_bi = d_VaSCBE_dV_di_bi = d_VaSCBE_dV_si_bi = d_VaSCBE_dTemp_t_GND =  0.0;
VaSCBE = ((5.540622384e+34*Leff)/PSCBE2_i);
}
}
else
{

d_VaSCBE_dV_gi_bi = d_VaSCBE_dV_di_bi = d_VaSCBE_dV_si_bi = d_VaSCBE_dTemp_t_GND =  0.0;
VaSCBE = 5.540622384e+34;
}

d_Mscbe_dTemp_t_GND = ((VaSCBE*d_diffVds_dTemp_t_GND-diffVds*d_VaSCBE_dTemp_t_GND)/VaSCBE/VaSCBE);
d_Mscbe_dV_gi_bi = ((VaSCBE*d_diffVds_dV_gi_bi-diffVds*d_VaSCBE_dV_gi_bi)/VaSCBE/VaSCBE);
d_Mscbe_dV_si_bi = ((VaSCBE*d_diffVds_dV_si_bi-diffVds*d_VaSCBE_dV_si_bi)/VaSCBE/VaSCBE);
d_Mscbe_dV_di_bi = ((VaSCBE*d_diffVds_dV_di_bi-diffVds*d_VaSCBE_dV_di_bi)/VaSCBE/VaSCBE);
Mscbe = (1.0+(diffVds/VaSCBE));

d_Moc_dTemp_t_GND = (Moc*d_Mscbe_dTemp_t_GND+d_Moc_dTemp_t_GND*Mscbe);
d_Moc_dV_gi_bi = (Moc*d_Mscbe_dV_gi_bi+d_Moc_dV_gi_bi*Mscbe);
d_Moc_dV_si_bi = (Moc*d_Mscbe_dV_si_bi+d_Moc_dV_si_bi*Mscbe);
d_Moc_dV_di_bi = (Moc*d_Mscbe_dV_di_bi+d_Moc_dV_di_bi*Mscbe);
Moc = (Moc*Mscbe);
{
double value_pow_0 = pow(Dmob,(1.0/PSAT_a));
double  deriv_pow_0_d0 = ((Dmob == 0.0)?0.0:(value_pow_0*(1.0/PSAT_a)/Dmob));
double  deriv_pow_0_d1 = (Dmob == 0.0)?0.0:(log(Dmob)*value_pow_0);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = ((deriv_pow_0_d0*(d_Dmob_dTemp_t_GND))+(deriv_pow_0_d1*((-d_PSAT_a_dTemp_t_GND/PSAT_a/PSAT_a))));
d_T0_dV_si_bi = ((deriv_pow_0_d0*(d_Dmob_dV_si_bi))+(deriv_pow_0_d1*((-d_PSAT_a_dV_si_bi/PSAT_a/PSAT_a))));
d_T0_dV_di_bi = ((deriv_pow_0_d0*(d_Dmob_dV_di_bi))+(deriv_pow_0_d1*((-d_PSAT_a_dV_di_bi/PSAT_a/PSAT_a))));
d_T0_dV_gi_bi = (deriv_pow_0_d0*(d_Dmob_dV_gi_bi));
T0 = value_pow_0;
}
if ((PSATB_i<0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dTemp_t_GND =  0.0;
d_T1_dV_si_bi = (-PSATB_i*d_Vbsx_dV_si_bi/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
d_T1_dV_di_bi = (-PSATB_i*d_Vbsx_dV_di_bi/(1.0+(PSATB_i*Vbsx))/(1.0+(PSATB_i*Vbsx)));
T1 = (1.0/(1.0+(PSATB_i*Vbsx)));
}
else
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dTemp_t_GND =  0.0;
d_T1_dV_si_bi = (-PSATB_i*d_Vbsx_dV_si_bi);
d_T1_dV_di_bi = (-PSATB_i*d_Vbsx_dV_di_bi);
T1 = (1.0-(PSATB_i*Vbsx));
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_gi_bi = ((((10.0*(model_.PSATX))+(qia*T1))*(((10.0*(model_.PSATX))*qia)*d_T1_dV_gi_bi+(10.0*(model_.PSATX))*d_qia_dV_gi_bi*T1)-(((10.0*(model_.PSATX))*qia)*T1)*(qia*d_T1_dV_gi_bi+d_qia_dV_gi_bi*T1))/((10.0*(model_.PSATX))+(qia*T1))/((10.0*(model_.PSATX))+(qia*T1)));
d_T2_dTemp_t_GND = ((((10.0*(model_.PSATX))+(qia*T1))*(((10.0*(model_.PSATX))*qia)*d_T1_dTemp_t_GND+(10.0*(model_.PSATX))*d_qia_dTemp_t_GND*T1)-(((10.0*(model_.PSATX))*qia)*T1)*(qia*d_T1_dTemp_t_GND+d_qia_dTemp_t_GND*T1))/((10.0*(model_.PSATX))+(qia*T1))/((10.0*(model_.PSATX))+(qia*T1)));
d_T2_dV_si_bi = ((((10.0*(model_.PSATX))+(qia*T1))*(((10.0*(model_.PSATX))*qia)*d_T1_dV_si_bi+(10.0*(model_.PSATX))*d_qia_dV_si_bi*T1)-(((10.0*(model_.PSATX))*qia)*T1)*(qia*d_T1_dV_si_bi+d_qia_dV_si_bi*T1))/((10.0*(model_.PSATX))+(qia*T1))/((10.0*(model_.PSATX))+(qia*T1)));
d_T2_dV_di_bi = ((((10.0*(model_.PSATX))+(qia*T1))*(((10.0*(model_.PSATX))*qia)*d_T1_dV_di_bi+(10.0*(model_.PSATX))*d_qia_dV_di_bi*T1)-(((10.0*(model_.PSATX))*qia)*T1)*(qia*d_T1_dV_di_bi+d_qia_dV_di_bi*T1))/((10.0*(model_.PSATX))+(qia*T1))/((10.0*(model_.PSATX))+(qia*T1)));
T2 = ((((10.0*(model_.PSATX))*qia)*T1)/((10.0*(model_.PSATX))+(qia*T1)));
if ((PTWG_a<0))
{

d_LambdaC_dV_dbulk_di = d_LambdaC_dV_sbulk_si =  0.0;
d_LambdaC_dV_gi_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-PTWG_a*d_T2_dV_gi_bi)/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((U0_a/T0)*d_nVt_dV_gi_bi+(-U0_a*d_T0_dV_gi_bi/T0/T0)*nVt)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
d_LambdaC_dV_si_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*d_T2_dV_si_bi+d_PTWG_a_dV_si_bi*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_si_bi+((T0*d_U0_a_dV_si_bi-U0_a*d_T0_dV_si_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_si_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
d_LambdaC_dV_di_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*d_T2_dV_di_bi+d_PTWG_a_dV_di_bi*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_di_bi+((T0*d_U0_a_dV_di_bi-U0_a*d_T0_dV_di_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_di_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
d_LambdaC_dTemp_t_GND = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(-(-(PTWG_a*d_T2_dTemp_t_GND+d_PTWG_a_dTemp_t_GND*T2))/(1.0-(PTWG_a*T2))/(1.0-(PTWG_a*T2)))+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dTemp_t_GND+((T0*d_U0_a_dTemp_t_GND-U0_a*d_T0_dTemp_t_GND)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dTemp_t_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0/(1.0-(PTWG_a*T2))));
LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0/(1.0-(PTWG_a*T2))));
}
else
{

d_LambdaC_dV_dbulk_di = d_LambdaC_dV_sbulk_si =  0.0;
d_LambdaC_dV_gi_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*PTWG_a*d_T2_dV_gi_bi+2.0*(((U0_a/T0)*d_nVt_dV_gi_bi+(-U0_a*d_T0_dV_gi_bi/T0/T0)*nVt)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
d_LambdaC_dV_si_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*d_T2_dV_si_bi+d_PTWG_a_dV_si_bi*T2)+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_si_bi+((T0*d_U0_a_dV_si_bi-U0_a*d_T0_dV_si_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_si_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
d_LambdaC_dV_di_bi = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*d_T2_dV_di_bi+d_PTWG_a_dV_di_bi*T2)+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dV_di_bi+((T0*d_U0_a_dV_di_bi-U0_a*d_T0_dV_di_bi)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dV_di_bi*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
d_LambdaC_dTemp_t_GND = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(PTWG_a*d_T2_dTemp_t_GND+d_PTWG_a_dTemp_t_GND*T2)+2.0*(((VSAT_a*Leff)*((U0_a/T0)*d_nVt_dTemp_t_GND+((T0*d_U0_a_dTemp_t_GND-U0_a*d_T0_dTemp_t_GND)/T0/T0)*nVt)-((U0_a/T0)*nVt)*d_VSAT_a_dTemp_t_GND*Leff)/(VSAT_a*Leff)/(VSAT_a*Leff))*(1.0+(PTWG_a*T2)));
LambdaC = ((2.0*(((U0_a/T0)*nVt)/(VSAT_a*Leff)))*(1.0+(PTWG_a*T2)));
}

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((2.0*LambdaC)*(d_qs_dV_gi_bi-d_qdeff_dV_gi_bi)+2.0*d_LambdaC_dV_gi_bi*(qs-qdeff));
d_T1_dV_si_bi = ((2.0*LambdaC)*(d_qs_dV_si_bi-d_qdeff_dV_si_bi)+2.0*d_LambdaC_dV_si_bi*(qs-qdeff));
d_T1_dV_di_bi = ((2.0*LambdaC)*(d_qs_dV_di_bi-d_qdeff_dV_di_bi)+2.0*d_LambdaC_dV_di_bi*(qs-qdeff));
d_T1_dTemp_t_GND = ((2.0*LambdaC)*(d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND)+2.0*d_LambdaC_dTemp_t_GND*(qs-qdeff));
T1 = ((2.0*LambdaC)*(qs-qdeff));
{
double value_sqrt_0 = sqrt((1.0+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)));
T2 = value_sqrt_0;
}
if ((T1!=0))
{
{
double value_asinh_0 = asinh(T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(T1*T1+1.0)));

d_Dvsat_dV_dbulk_di = d_Dvsat_dV_sbulk_si =  0.0;
d_Dvsat_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND+((1.0/T1)*(deriv_asinh_0_d0*(d_T1_dTemp_t_GND))+(-d_T1_dTemp_t_GND/T1/T1)*value_asinh_0));
d_Dvsat_dV_si_bi = 0.5*(d_T2_dV_si_bi+((1.0/T1)*(deriv_asinh_0_d0*(d_T1_dV_si_bi))+(-d_T1_dV_si_bi/T1/T1)*value_asinh_0));
d_Dvsat_dV_di_bi = 0.5*(d_T2_dV_di_bi+((1.0/T1)*(deriv_asinh_0_d0*(d_T1_dV_di_bi))+(-d_T1_dV_di_bi/T1/T1)*value_asinh_0));
d_Dvsat_dV_gi_bi = 0.5*(d_T2_dV_gi_bi+((1.0/T1)*(deriv_asinh_0_d0*(d_T1_dV_gi_bi))+(-d_T1_dV_gi_bi/T1/T1)*value_asinh_0));
Dvsat = (0.5*(T2+((1.0/T1)*value_asinh_0)));
}
}
else
{

d_Dvsat_dV_dbulk_di = d_Dvsat_dV_sbulk_si =  0.0;
d_Dvsat_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND+(-d_T2_dTemp_t_GND/T2/T2));
d_Dvsat_dV_si_bi = 0.5*(d_T2_dV_si_bi+(-d_T2_dV_si_bi/T2/T2));
d_Dvsat_dV_di_bi = 0.5*(d_T2_dV_di_bi+(-d_T2_dV_di_bi/T2/T2));
d_Dvsat_dV_gi_bi = 0.5*(d_T2_dV_gi_bi+(-d_T2_dV_gi_bi/T2/T2));
Dvsat = (0.5*(T2+(1.0/T2)));
}

d_Dptwg_dTemp_t_GND = d_Dvsat_dTemp_t_GND;
d_Dptwg_dV_si_bi = d_Dvsat_dV_si_bi;
d_Dptwg_dV_di_bi = d_Dvsat_dV_di_bi;
d_Dptwg_dV_gi_bi = d_Dvsat_dV_gi_bi;
Dptwg = Dvsat;

d_Rsource_dTemp_t_GND = d_Rsource_dV_gi_bi = d_Rsource_dV_di_bi = d_Rsource_dV_si_bi =  0.0;
Rsource = 0.0;

d_Rdrain_dTemp_t_GND = d_Rdrain_dV_gi_bi = d_Rdrain_dV_di_bi = d_Rdrain_dV_si_bi =  0.0;
Rdrain = 0.0;
if (((model_.RDSMOD)==1))
{

d_Rdsi_dTemp_t_GND = d_Rdsi_dV_gi_bi = d_Rdsi_dV_di_bi = d_Rdsi_dV_si_bi =  0.0;
Rdsi = 0.0;

d_Dr_dTemp_t_GND = d_Dr_dV_di_bi = d_Dr_dV_si_bi = d_Dr_dV_gi_bi =  0.0;
Dr = 1.0;

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_di_bi =  0.0;
d_T2_dTemp_t_GND = (-d_Vfbsdr_dTemp_t_GND);
d_T2_dV_si_bi = d_Vgs_noswap_dV_si_bi;
d_T2_dV_gi_bi = d_Vgs_noswap_dV_gi_bi;
T2 = (Vgs_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((T2*T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2)));
d_T3_dV_si_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2)));
d_T3_dV_di_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2)));
d_T3_dV_gi_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2)));
T3 = value_sqrt_0;
}

d_Vgs_eff_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND+d_T3_dTemp_t_GND);
d_Vgs_eff_dV_si_bi = 0.5*(d_T2_dV_si_bi+d_T3_dV_si_bi);
d_Vgs_eff_dV_di_bi = 0.5*(d_T2_dV_di_bi+d_T3_dV_di_bi);
d_Vgs_eff_dV_gi_bi = 0.5*(d_T2_dV_gi_bi+d_T3_dV_gi_bi);
Vgs_eff = (0.5*(T2+T3));

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = PRWG_i*d_Vgs_eff_dTemp_t_GND;
d_T5_dV_si_bi = PRWG_i*d_Vgs_eff_dV_si_bi;
d_T5_dV_di_bi = PRWG_i*d_Vgs_eff_dV_di_bi;
d_T5_dV_gi_bi = PRWG_i*d_Vgs_eff_dV_gi_bi;
T5 = (1.0+(PRWG_i*Vgs_eff));

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (-d_T5_dTemp_t_GND/T5/T5);
d_T6_dV_si_bi = ((-d_T5_dV_si_bi/T5/T5)+PRWB_i*d_Vsb_noswap_dV_si_bi);
d_T6_dV_di_bi = (-d_T5_dV_di_bi/T5/T5);
d_T6_dV_gi_bi = (-d_T5_dV_gi_bi/T5/T5);
T6 = ((1.0/T5)+(PRWB_i*Vsb_noswap));
{
double value_sqrt_0 = sqrt(((T6*T6)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = 0.5*(d_T6_dTemp_t_GND+(deriv_sqrt_0_d0*((T6*d_T6_dTemp_t_GND+d_T6_dTemp_t_GND*T6))));
d_T4_dV_si_bi = 0.5*(d_T6_dV_si_bi+(deriv_sqrt_0_d0*((T6*d_T6_dV_si_bi+d_T6_dV_si_bi*T6))));
d_T4_dV_di_bi = 0.5*(d_T6_dV_di_bi+(deriv_sqrt_0_d0*((T6*d_T6_dV_di_bi+d_T6_dV_di_bi*T6))));
d_T4_dV_gi_bi = 0.5*(d_T6_dV_gi_bi+(deriv_sqrt_0_d0*((T6*d_T6_dV_gi_bi+d_T6_dV_gi_bi*T6))));
T4 = (0.5*(T6+value_sqrt_0));
}

d_Rsource_dV_si_bi = rdstemp*RSW_i*d_T4_dV_si_bi*WeffWRFactor;
d_Rsource_dV_di_bi = rdstemp*RSW_i*d_T4_dV_di_bi*WeffWRFactor;
d_Rsource_dV_gi_bi = rdstemp*RSW_i*d_T4_dV_gi_bi*WeffWRFactor;
d_Rsource_dTemp_t_GND = (rdstemp*RSW_i*d_T4_dTemp_t_GND*WeffWRFactor+d_rdstemp_dTemp_t_GND*(RSourceGeo+((RSWMIN_i+(RSW_i*T4))*WeffWRFactor)));
Rsource = (rdstemp*(RSourceGeo+((RSWMIN_i+(RSW_i*T4))*WeffWRFactor)));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_si_bi =  0.0;
d_T2_dTemp_t_GND = (-d_Vfbsdr_dTemp_t_GND);
d_T2_dV_di_bi = d_Vgd_noswap_dV_di_bi;
d_T2_dV_gi_bi = d_Vgd_noswap_dV_gi_bi;
T2 = (Vgd_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((T2*T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2)));
d_T3_dV_si_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2)));
d_T3_dV_di_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2)));
d_T3_dV_gi_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2)));
T3 = value_sqrt_0;
}

d_Vgd_eff_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND+d_T3_dTemp_t_GND);
d_Vgd_eff_dV_si_bi = 0.5*(d_T2_dV_si_bi+d_T3_dV_si_bi);
d_Vgd_eff_dV_di_bi = 0.5*(d_T2_dV_di_bi+d_T3_dV_di_bi);
d_Vgd_eff_dV_gi_bi = 0.5*(d_T2_dV_gi_bi+d_T3_dV_gi_bi);
Vgd_eff = (0.5*(T2+T3));

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = PRWG_i*d_Vgd_eff_dTemp_t_GND;
d_T5_dV_si_bi = PRWG_i*d_Vgd_eff_dV_si_bi;
d_T5_dV_di_bi = PRWG_i*d_Vgd_eff_dV_di_bi;
d_T5_dV_gi_bi = PRWG_i*d_Vgd_eff_dV_gi_bi;
T5 = (1.0+(PRWG_i*Vgd_eff));

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (-d_T5_dTemp_t_GND/T5/T5);
d_T6_dV_si_bi = (-d_T5_dV_si_bi/T5/T5);
d_T6_dV_di_bi = ((-d_T5_dV_di_bi/T5/T5)+PRWB_i*d_Vdb_noswap_dV_di_bi);
d_T6_dV_gi_bi = (-d_T5_dV_gi_bi/T5/T5);
T6 = ((1.0/T5)+(PRWB_i*Vdb_noswap));
{
double value_sqrt_0 = sqrt(((T6*T6)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = 0.5*(d_T6_dTemp_t_GND+(deriv_sqrt_0_d0*((T6*d_T6_dTemp_t_GND+d_T6_dTemp_t_GND*T6))));
d_T4_dV_si_bi = 0.5*(d_T6_dV_si_bi+(deriv_sqrt_0_d0*((T6*d_T6_dV_si_bi+d_T6_dV_si_bi*T6))));
d_T4_dV_di_bi = 0.5*(d_T6_dV_di_bi+(deriv_sqrt_0_d0*((T6*d_T6_dV_di_bi+d_T6_dV_di_bi*T6))));
d_T4_dV_gi_bi = 0.5*(d_T6_dV_gi_bi+(deriv_sqrt_0_d0*((T6*d_T6_dV_gi_bi+d_T6_dV_gi_bi*T6))));
T4 = (0.5*(T6+value_sqrt_0));
}

d_Rdrain_dV_si_bi = rdstemp*RDW_i*d_T4_dV_si_bi*WeffWRFactor;
d_Rdrain_dV_di_bi = rdstemp*RDW_i*d_T4_dV_di_bi*WeffWRFactor;
d_Rdrain_dV_gi_bi = rdstemp*RDW_i*d_T4_dV_gi_bi*WeffWRFactor;
d_Rdrain_dTemp_t_GND = (rdstemp*RDW_i*d_T4_dTemp_t_GND*WeffWRFactor+d_rdstemp_dTemp_t_GND*(RDrainGeo+((RDWMIN_i+(RDW_i*T4))*WeffWRFactor)));
Rdrain = (rdstemp*(RDrainGeo+((RDWMIN_i+(RDW_i*T4))*WeffWRFactor)));
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = PRWG_i*d_qia_dV_gi_bi;
d_T0_dTemp_t_GND = PRWG_i*d_qia_dTemp_t_GND;
d_T0_dV_si_bi = PRWG_i*d_qia_dV_si_bi;
d_T0_dV_di_bi = PRWG_i*d_qia_dV_di_bi;
T0 = (1.0+(PRWG_i*qia));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi =  0.0;
d_T1_dV_si_bi = PRWB_i*d_sqrtPhistVbs_dV_si_bi;
d_T1_dV_di_bi = PRWB_i*d_sqrtPhistVbs_dV_di_bi;
d_T1_dTemp_t_GND = PRWB_i*(d_sqrtPhistVbs_dTemp_t_GND-d_sqrtPhist_dTemp_t_GND);
T1 = (PRWB_i*(sqrtPhistVbs-sqrtPhist));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = ((-d_T0_dTemp_t_GND/T0/T0)+d_T1_dTemp_t_GND);
d_T2_dV_si_bi = ((-d_T0_dV_si_bi/T0/T0)+d_T1_dV_si_bi);
d_T2_dV_di_bi = ((-d_T0_dV_di_bi/T0/T0)+d_T1_dV_di_bi);
d_T2_dV_gi_bi = ((-d_T0_dV_gi_bi/T0/T0)+d_T1_dV_gi_bi);
T2 = ((1.0/T0)+T1);
{
double value_sqrt_0 = sqrt(((T2*T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND+(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2))));
d_T3_dV_si_bi = 0.5*(d_T2_dV_si_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2))));
d_T3_dV_di_bi = 0.5*(d_T2_dV_di_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2))));
d_T3_dV_gi_bi = 0.5*(d_T2_dV_gi_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2))));
T3 = (0.5*(T2+value_sqrt_0));
}

d_Rdsi_dV_si_bi = rdstemp*RDSW_i*d_T3_dV_si_bi*WeffWRFactor*NF;
d_Rdsi_dV_di_bi = rdstemp*RDSW_i*d_T3_dV_di_bi*WeffWRFactor*NF;
d_Rdsi_dV_gi_bi = rdstemp*RDSW_i*d_T3_dV_gi_bi*WeffWRFactor*NF;
d_Rdsi_dTemp_t_GND = (rdstemp*RDSW_i*d_T3_dTemp_t_GND+d_rdstemp_dTemp_t_GND*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor*NF;
Rdsi = (((rdstemp*(RDSWMIN_i+(RDSW_i*T3)))*WeffWRFactor)*NF);

d_Rdrain_dTemp_t_GND = d_Rdrain_dV_gi_bi = d_Rdrain_dV_di_bi = d_Rdrain_dV_si_bi =  0.0;
Rdrain = RDrainGeo;

d_Rsource_dTemp_t_GND = d_Rsource_dV_gi_bi = d_Rsource_dV_di_bi = d_Rsource_dV_si_bi =  0.0;
Rsource = RSourceGeo;

d_Dr_dV_gi_bi = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dV_gi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dV_gi_bi+((-U0_a*(Dvsat*d_Dmob_dV_gi_bi+d_Dvsat_dV_gi_bi*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
d_Dr_dV_si_bi = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dV_si_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dV_si_bi+((((Dvsat*Dmob)*d_U0_a_dV_si_bi-U0_a*(Dvsat*d_Dmob_dV_si_bi+d_Dvsat_dV_si_bi*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
d_Dr_dV_di_bi = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dV_di_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dV_di_bi+((((Dvsat*Dmob)*d_U0_a_dV_di_bi-U0_a*(Dvsat*d_Dmob_dV_di_bi+d_Dvsat_dV_di_bi*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
d_Dr_dTemp_t_GND = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dTemp_t_GND+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dTemp_t_GND+((((Dvsat*Dmob)*d_U0_a_dTemp_t_GND-U0_a*(Dvsat*d_Dmob_dTemp_t_GND+d_Dvsat_dTemp_t_GND*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi));
if (((model_.RDSMOD)==2))
{

d_Rdsi_dV_si_bi = rdstemp*RDSW_i*d_T3_dV_si_bi*WeffWRFactor*NF;
d_Rdsi_dV_di_bi = rdstemp*RDSW_i*d_T3_dV_di_bi*WeffWRFactor*NF;
d_Rdsi_dV_gi_bi = rdstemp*RDSW_i*d_T3_dV_gi_bi*WeffWRFactor*NF;
d_Rdsi_dTemp_t_GND = (rdstemp*RDSW_i*d_T3_dTemp_t_GND*WeffWRFactor*NF+d_rdstemp_dTemp_t_GND*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF))+RDrainGeo));
Rdsi = (rdstemp*((RSourceGeo+(((RDSWMIN_i+(RDSW_i*T3))*WeffWRFactor)*NF))+RDrainGeo));

d_Rdrain_dTemp_t_GND = d_Rdrain_dV_gi_bi = d_Rdrain_dV_di_bi = d_Rdrain_dV_si_bi =  0.0;
Rdrain = 0;

d_Rsource_dTemp_t_GND = d_Rsource_dV_gi_bi = d_Rsource_dV_di_bi = d_Rsource_dV_si_bi =  0.0;
Rsource = 0;

d_Dr_dV_gi_bi = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dV_gi_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dV_gi_bi+((-U0_a*(Dvsat*d_Dmob_dV_gi_bi+d_Dvsat_dV_gi_bi*Dmob)/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
d_Dr_dV_si_bi = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dV_si_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dV_si_bi+((((Dvsat*Dmob)*d_U0_a_dV_si_bi-U0_a*(Dvsat*d_Dmob_dV_si_bi+d_Dvsat_dV_si_bi*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
d_Dr_dV_di_bi = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dV_di_bi+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dV_di_bi+((((Dvsat*Dmob)*d_U0_a_dV_di_bi-U0_a*(Dvsat*d_Dmob_dV_di_bi+d_Dvsat_dV_di_bi*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
d_Dr_dTemp_t_GND = ((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*d_Rdsi_dTemp_t_GND+(((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*d_qia_dTemp_t_GND+((((Dvsat*Dmob)*d_U0_a_dTemp_t_GND-U0_a*(Dvsat*d_Dmob_dTemp_t_GND+d_Dvsat_dTemp_t_GND*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*Cox*Weff/Leff)*qia)*Rdsi);
Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*Cox)*Weff)/Leff)*qia)*Rdsi));
}
}

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = (-A2_t*(d_qia_dV_gi_bi+2.0*d_n_dV_gi_bi*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm)));
d_T0_dV_si_bi = (-A2_t*(d_qia_dV_si_bi+2.0*d_n_dV_si_bi*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm)));
d_T0_dV_di_bi = (-A2_t*(d_qia_dV_di_bi+2.0*d_n_dV_di_bi*Vtm)/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm)));
d_T0_dTemp_t_GND = (d_A1_t_dTemp_t_GND+(((qia+((2.0*n)*Vtm))*d_A2_t_dTemp_t_GND-A2_t*(d_qia_dTemp_t_GND+((2.0*n)*d_Vtm_dTemp_t_GND+2.0*d_n_dTemp_t_GND*Vtm)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
T0 = (A1_t+(A2_t/(qia+((2.0*n)*Vtm))));

d_DQSD_dV_dbulk_di = d_DQSD_dV_sbulk_si =  0.0;
d_DQSD_dTemp_t_GND = (d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND);
d_DQSD_dV_si_bi = (d_qs_dV_si_bi-d_qdeff_dV_si_bi);
d_DQSD_dV_di_bi = (d_qs_dV_di_bi-d_qdeff_dV_di_bi);
d_DQSD_dV_gi_bi = (d_qs_dV_gi_bi-d_qdeff_dV_gi_bi);
DQSD = (qs-qdeff);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = ((T0*DQSD)*d_DQSD_dTemp_t_GND+(T0*d_DQSD_dTemp_t_GND+d_T0_dTemp_t_GND*DQSD)*DQSD);
d_T1_dV_si_bi = ((T0*DQSD)*d_DQSD_dV_si_bi+(T0*d_DQSD_dV_si_bi+d_T0_dV_si_bi*DQSD)*DQSD);
d_T1_dV_di_bi = ((T0*DQSD)*d_DQSD_dV_di_bi+(T0*d_DQSD_dV_di_bi+d_T0_dV_di_bi*DQSD)*DQSD);
d_T1_dV_gi_bi = ((T0*DQSD)*d_DQSD_dV_gi_bi+(T0*d_DQSD_dV_gi_bi+d_T0_dV_gi_bi*DQSD)*DQSD);
T1 = ((T0*DQSD)*DQSD);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = d_T1_dTemp_t_GND;
d_T2_dV_si_bi = d_T1_dV_si_bi;
d_T2_dV_di_bi = d_T1_dV_di_bi;
d_T2_dV_gi_bi = d_T1_dV_gi_bi;
T2 = ((T1+1.0)-0.001);
{
double value_sqrt_0 = sqrt(((T2*T2)+0.004));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND+(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2))));
d_T3_dV_si_bi = 0.5*(d_T2_dV_si_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2))));
d_T3_dV_di_bi = 0.5*(d_T2_dV_di_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2))));
d_T3_dV_gi_bi = 0.5*(d_T2_dV_gi_bi+(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2))));
T3 = ((-1.0)+(0.5*(T2+value_sqrt_0)));
}
{
double value_sqrt_0 = sqrt((1.0+T3));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Nsat_dTemp_t_GND = 0.5*(deriv_sqrt_0_d0*(d_T3_dTemp_t_GND));
d_Nsat_dV_si_bi = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_si_bi));
d_Nsat_dV_di_bi = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_di_bi));
d_Nsat_dV_gi_bi = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_gi_bi));
Nsat = (0.5*(1.0+value_sqrt_0));
}

d_Dtot_dTemp_t_GND = ((Dmob*Dvsat)*d_Dr_dTemp_t_GND+(Dmob*d_Dvsat_dTemp_t_GND+d_Dmob_dTemp_t_GND*Dvsat)*Dr);
d_Dtot_dV_si_bi = ((Dmob*Dvsat)*d_Dr_dV_si_bi+(Dmob*d_Dvsat_dV_si_bi+d_Dmob_dV_si_bi*Dvsat)*Dr);
d_Dtot_dV_di_bi = ((Dmob*Dvsat)*d_Dr_dV_di_bi+(Dmob*d_Dvsat_dV_di_bi+d_Dmob_dV_di_bi*Dvsat)*Dr);
d_Dtot_dV_gi_bi = ((Dmob*Dvsat)*d_Dr_dV_gi_bi+(Dmob*d_Dvsat_dV_gi_bi+d_Dmob_dV_gi_bi*Dvsat)*Dr);
Dtot = ((Dmob*Dvsat)*Dr);

d_ueff_dV_gi_bi = (-U0_a*d_Dtot_dV_gi_bi/Dtot/Dtot);
d_ueff_dV_si_bi = ((Dtot*d_U0_a_dV_si_bi-U0_a*d_Dtot_dV_si_bi)/Dtot/Dtot);
d_ueff_dV_di_bi = ((Dtot*d_U0_a_dV_di_bi-U0_a*d_Dtot_dV_di_bi)/Dtot/Dtot);
d_ueff_dTemp_t_GND = ((Dtot*d_U0_a_dTemp_t_GND-U0_a*d_Dtot_dTemp_t_GND)/Dtot/Dtot);
ueff = (U0_a/Dtot);

d_ids_dV_gm_si = d_ids_dV_gm_di = d_ids_dV_dbulk_di = d_ids_dV_sbulk_si =  0.0;
d_ids_dV_si_bi = ((Nsat*((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dV_si_bi+(((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_si_bi+d_qdeff_dV_si_bi)+(d_qs_dV_si_bi-d_qdeff_dV_si_bi)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*d_nVt_dV_si_bi+(((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*d_nVt_dV_si_bi+((((2.0*NF)*nq)*d_ueff_dV_si_bi+(2.0*NF)*d_nq_dV_si_bi*ueff)*Weff/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)-((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*d_Nsat_dV_si_bi)/Nsat/Nsat);
d_ids_dV_di_bi = ((Nsat*((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dV_di_bi+(((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_di_bi+d_qdeff_dV_di_bi)+(d_qs_dV_di_bi-d_qdeff_dV_di_bi)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*d_nVt_dV_di_bi+(((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*d_nVt_dV_di_bi+((((2.0*NF)*nq)*d_ueff_dV_di_bi+(2.0*NF)*d_nq_dV_di_bi*ueff)*Weff/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)-((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*d_Nsat_dV_di_bi)/Nsat/Nsat);
d_ids_dTemp_t_GND = ((Nsat*((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dTemp_t_GND+(((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+(d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*d_nVt_dTemp_t_GND+(((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*d_nVt_dTemp_t_GND+((((2.0*NF)*nq)*d_ueff_dTemp_t_GND+(2.0*NF)*d_nq_dTemp_t_GND*ueff)*Weff/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)-((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*d_Nsat_dTemp_t_GND)/Nsat/Nsat);
d_ids_dV_gi_bi = ((Nsat*((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dV_gi_bi+(((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+(d_qs_dV_gi_bi-d_qdeff_dV_gi_bi)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*d_nVt_dV_gi_bi+(((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*d_nVt_dV_gi_bi+((((2.0*NF)*nq)*d_ueff_dV_gi_bi+(2.0*NF)*d_nq_dV_gi_bi*ueff)*Weff/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)-((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*d_Nsat_dV_gi_bi)/Nsat/Nsat);
ids = (((((((((((2.0*NF)*nq)*ueff)*Weff)/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat);

d_Gcrg_dV_gi_bi = d_Gcrg_dV_di_bi = d_Gcrg_dV_si_bi = d_Gcrg_dTemp_t_GND =  0.0;
Gcrg = 0.0;
if ((RGATEMOD>1))
{

d_idsovvds_dV_gi_bi = ((((ueff*Weff)/Leff)*Cox)*d_qia_dV_gi_bi+(d_ueff_dV_gi_bi*Weff/Leff)*Cox*qia);
d_idsovvds_dV_si_bi = ((((ueff*Weff)/Leff)*Cox)*d_qia_dV_si_bi+(d_ueff_dV_si_bi*Weff/Leff)*Cox*qia);
d_idsovvds_dV_di_bi = ((((ueff*Weff)/Leff)*Cox)*d_qia_dV_di_bi+(d_ueff_dV_di_bi*Weff/Leff)*Cox*qia);
d_idsovvds_dTemp_t_GND = ((((ueff*Weff)/Leff)*Cox)*d_qia_dTemp_t_GND+(d_ueff_dTemp_t_GND*Weff/Leff)*Cox*qia);
idsovvds = ((((ueff*Weff)/Leff)*Cox)*qia);

d_T9_dV_gm_si = d_T9_dV_gm_di = d_T9_dV_dbulk_di = d_T9_dV_sbulk_si = d_T9_dV_di_bi = d_T9_dV_si_bi = d_T9_dV_gi_bi =  0.0;
d_T9_dTemp_t_GND = (model_.XRCRG2)*d_Vt_dTemp_t_GND;
T9 = ((model_.XRCRG2)*Vt);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = ((T9*d_ueff_dV_gi_bi+d_T9_dV_gi_bi*ueff)*Weff/Leff)*Cox;
d_T0_dTemp_t_GND = ((T9*d_ueff_dTemp_t_GND+d_T9_dTemp_t_GND*ueff)*Weff/Leff)*Cox;
d_T0_dV_si_bi = ((T9*d_ueff_dV_si_bi+d_T9_dV_si_bi*ueff)*Weff/Leff)*Cox;
d_T0_dV_di_bi = ((T9*d_ueff_dV_di_bi+d_T9_dV_di_bi*ueff)*Weff/Leff)*Cox;
T0 = ((((T9*ueff)*Weff)/Leff)*Cox);

d_Gcrg_dTemp_t_GND = ((model_.XRCRG1)*NF)*(d_T0_dTemp_t_GND+d_idsovvds_dTemp_t_GND);
d_Gcrg_dV_si_bi = ((model_.XRCRG1)*NF)*(d_T0_dV_si_bi+d_idsovvds_dV_si_bi);
d_Gcrg_dV_di_bi = ((model_.XRCRG1)*NF)*(d_T0_dV_di_bi+d_idsovvds_dV_di_bi);
d_Gcrg_dV_gi_bi = ((model_.XRCRG1)*NF)*(d_T0_dV_gi_bi+d_idsovvds_dV_gi_bi);
Gcrg = (((model_.XRCRG1)*NF)*(T0+idsovvds));
if ((RGATEMOD==2))
{

d_T11_dTemp_t_GND = d_Gcrg_dTemp_t_GND;
d_T11_dV_si_bi = d_Gcrg_dV_si_bi;
d_T11_dV_di_bi = d_Gcrg_dV_di_bi;
d_T11_dV_gi_bi = d_Gcrg_dV_gi_bi;
T11 = (Grgeltd+Gcrg);

d_Gcrg_dTemp_t_GND = ((T11*Grgeltd*d_Gcrg_dTemp_t_GND-(Grgeltd*Gcrg)*d_T11_dTemp_t_GND)/T11/T11);
d_Gcrg_dV_si_bi = ((T11*Grgeltd*d_Gcrg_dV_si_bi-(Grgeltd*Gcrg)*d_T11_dV_si_bi)/T11/T11);
d_Gcrg_dV_di_bi = ((T11*Grgeltd*d_Gcrg_dV_di_bi-(Grgeltd*Gcrg)*d_T11_dV_di_bi)/T11/T11);
d_Gcrg_dV_gi_bi = ((T11*Grgeltd*d_Gcrg_dV_gi_bi-(Grgeltd*Gcrg)*d_T11_dV_gi_bi)/T11/T11);
Gcrg = ((Grgeltd*Gcrg)/T11);
}
}
if (((ALPHA0_i<=0.0)||(BETA0_t<=0.0)))
{

d_Iii_dV_di_bi = d_Iii_dV_si_bi = d_Iii_dV_gi_bi = d_Iii_dTemp_t_GND =  0.0;
Iii = 0.0;
}
else
{
if ((diffVds>(BETA0_t/80.0)))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = (-(-BETA0_t)*d_diffVds_dV_gi_bi/diffVds/diffVds);
d_T1_dV_si_bi = (-(-BETA0_t)*d_diffVds_dV_si_bi/diffVds/diffVds);
d_T1_dV_di_bi = (-(-BETA0_t)*d_diffVds_dV_di_bi/diffVds/diffVds);
d_T1_dTemp_t_GND = ((diffVds*(-d_BETA0_t_dTemp_t_GND)-(-BETA0_t)*d_diffVds_dTemp_t_GND)/diffVds/diffVds);
T1 = ((-BETA0_t)/diffVds);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);

d_Iii_dTemp_t_GND = ((Mscbe*(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dTemp_t_GND)+((ALPHA0_i*diffVds)*d_ids_dTemp_t_GND+ALPHA0_i*d_diffVds_dTemp_t_GND*ids)*evaluator_lexp_0.getValues(T1))-(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getValues(T1))*d_Mscbe_dTemp_t_GND)/Mscbe/Mscbe);
d_Iii_dV_gi_bi = ((Mscbe*(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_gi_bi)+((ALPHA0_i*diffVds)*d_ids_dV_gi_bi+ALPHA0_i*d_diffVds_dV_gi_bi*ids)*evaluator_lexp_0.getValues(T1))-(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getValues(T1))*d_Mscbe_dV_gi_bi)/Mscbe/Mscbe);
d_Iii_dV_si_bi = ((Mscbe*(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_si_bi)+((ALPHA0_i*diffVds)*d_ids_dV_si_bi+ALPHA0_i*d_diffVds_dV_si_bi*ids)*evaluator_lexp_0.getValues(T1))-(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getValues(T1))*d_Mscbe_dV_si_bi)/Mscbe/Mscbe);
d_Iii_dV_di_bi = ((Mscbe*(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_di_bi)+((ALPHA0_i*diffVds)*d_ids_dV_di_bi+ALPHA0_i*d_diffVds_dV_di_bi*ids)*evaluator_lexp_0.getValues(T1))-(((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getValues(T1))*d_Mscbe_dV_di_bi)/Mscbe/Mscbe);
Iii = ((((ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getValues(T1))/Mscbe);
}
}
else
{

d_Iii_dTemp_t_GND = ((Mscbe*((ALPHA0_i*diffVds)*d_ids_dTemp_t_GND+ALPHA0_i*d_diffVds_dTemp_t_GND*ids)*1.804851387e-35-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*d_Mscbe_dTemp_t_GND)/Mscbe/Mscbe);
d_Iii_dV_gi_bi = ((Mscbe*((ALPHA0_i*diffVds)*d_ids_dV_gi_bi+ALPHA0_i*d_diffVds_dV_gi_bi*ids)*1.804851387e-35-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*d_Mscbe_dV_gi_bi)/Mscbe/Mscbe);
d_Iii_dV_si_bi = ((Mscbe*((ALPHA0_i*diffVds)*d_ids_dV_si_bi+ALPHA0_i*d_diffVds_dV_si_bi*ids)*1.804851387e-35-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*d_Mscbe_dV_si_bi)/Mscbe/Mscbe);
d_Iii_dV_di_bi = ((Mscbe*((ALPHA0_i*diffVds)*d_ids_dV_di_bi+ALPHA0_i*d_diffVds_dV_di_bi*ids)*1.804851387e-35-(((ALPHA0_i*diffVds)*ids)*1.804851387e-35)*d_Mscbe_dV_di_bi)/Mscbe/Mscbe);
Iii = ((((ALPHA0_i*diffVds)*ids)*1.804851387e-35)/Mscbe);
}
}

d_ISUB_dTemp_t_GND = d_Iii_dTemp_t_GND*devsign;
d_ISUB_dV_gi_bi = d_Iii_dV_gi_bi*devsign;
d_ISUB_dV_si_bi = d_Iii_dV_si_bi*devsign;
d_ISUB_dV_di_bi = d_Iii_dV_di_bi*devsign;
ISUB = (Iii*devsign);

d_igbinv_dV_gi_bi = d_igbinv_dV_di_bi = d_igbinv_dV_si_bi = d_igbinv_dTemp_t_GND =  0.0;
igbinv = 0.0;

d_igbacc_dV_gi_bi = d_igbacc_dV_di_bi = d_igbacc_dV_si_bi = d_igbacc_dTemp_t_GND =  0.0;
igbacc = 0.0;

d_igb_dV_gi_bi = d_igb_dV_di_bi = d_igb_dV_si_bi = d_igb_dTemp_t_GND =  0.0;
igb = 0.0;

d_igcs_dV_gi_bi = d_igcs_dV_di_bi = d_igcs_dV_si_bi = d_igcs_dTemp_t_GND =  0.0;
igcs = 0.0;

d_igcd_dV_gi_bi = d_igcd_dV_di_bi = d_igcd_dV_si_bi = d_igcd_dTemp_t_GND =  0.0;
igcd = 0.0;

d_igs_dTemp_t_GND = d_igs_dV_gi_bi = d_igs_dV_si_bi = d_igs_dV_di_bi =  0.0;
igs = 0.0;

d_igd_dTemp_t_GND = d_igd_dV_gi_bi = d_igd_dV_di_bi = d_igd_dV_si_bi =  0.0;
igd = 0.0;
if ((((model_.IGCMOD)!=0)||((model_.IGBMOD)!=0)))
{

d_Voxm_dV_gi_bi = (nVt*(((d_vgfb_dV_gi_bi-d_psip_dV_gi_bi)+d_qs_dV_gi_bi)+d_qdeff_dV_gi_bi)+d_nVt_dV_gi_bi*(((vgfb-psip)+qs)+qdeff));
d_Voxm_dTemp_t_GND = (nVt*(((d_vgfb_dTemp_t_GND-d_psip_dTemp_t_GND)+d_qs_dTemp_t_GND)+d_qdeff_dTemp_t_GND)+d_nVt_dTemp_t_GND*(((vgfb-psip)+qs)+qdeff));
d_Voxm_dV_si_bi = (nVt*(((d_vgfb_dV_si_bi-d_psip_dV_si_bi)+d_qs_dV_si_bi)+d_qdeff_dV_si_bi)+d_nVt_dV_si_bi*(((vgfb-psip)+qs)+qdeff));
d_Voxm_dV_di_bi = (nVt*(((d_vgfb_dV_di_bi-d_psip_dV_di_bi)+d_qs_dV_di_bi)+d_qdeff_dV_di_bi)+d_nVt_dV_di_bi*(((vgfb-psip)+qs)+qdeff));
Voxm = (nVt*(((vgfb-psip)+qs)+qdeff));
{
double value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0E-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_gi_bi+d_Voxm_dV_gi_bi*Voxm)));
d_T1_dTemp_t_GND = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dTemp_t_GND+d_Voxm_dTemp_t_GND*Voxm)));
d_T1_dV_si_bi = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_si_bi+d_Voxm_dV_si_bi*Voxm)));
d_T1_dV_di_bi = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_di_bi+d_Voxm_dV_di_bi*Voxm)));
T1 = value_sqrt_0;
}

d_Voxmacc_dV_gi_bi = 0.5*((-d_Voxm_dV_gi_bi)+d_T1_dV_gi_bi);
d_Voxmacc_dTemp_t_GND = 0.5*((-d_Voxm_dTemp_t_GND)+d_T1_dTemp_t_GND);
d_Voxmacc_dV_si_bi = 0.5*((-d_Voxm_dV_si_bi)+d_T1_dV_si_bi);
d_Voxmacc_dV_di_bi = 0.5*((-d_Voxm_dV_di_bi)+d_T1_dV_di_bi);
Voxmacc = (0.5*((-Voxm)+T1));

d_Voxminv_dV_gi_bi = 0.5*(d_Voxm_dV_gi_bi+d_T1_dV_gi_bi);
d_Voxminv_dTemp_t_GND = 0.5*(d_Voxm_dTemp_t_GND+d_T1_dTemp_t_GND);
d_Voxminv_dV_si_bi = 0.5*(d_Voxm_dV_si_bi+d_T1_dV_si_bi);
d_Voxminv_dV_di_bi = 0.5*(d_Voxm_dV_di_bi+d_T1_dV_di_bi);
Voxminv = (0.5*(Voxm+T1));
if (((model_.IGBMOD)!=0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((d_Voxmacc_dV_gi_bi/NIGBACC_i)/Vt);
d_T1_dTemp_t_GND = ((Vt*(d_Voxmacc_dTemp_t_GND/NIGBACC_i)-(Voxmacc/NIGBACC_i)*d_Vt_dTemp_t_GND)/Vt/Vt);
d_T1_dV_si_bi = ((d_Voxmacc_dV_si_bi/NIGBACC_i)/Vt);
d_T1_dV_di_bi = ((d_Voxmacc_dV_di_bi/NIGBACC_i)/Vt);
T1 = ((Voxmacc/NIGBACC_i)/Vt);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues((-T1))));

d_Vaux_Igbacc_dV_si_bi = (NIGBACC_i*Vt)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues((-T1))),evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_si_bi)));
d_Vaux_Igbacc_dV_di_bi = (NIGBACC_i*Vt)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues((-T1))),evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_bi)));
d_Vaux_Igbacc_dV_gi_bi = (NIGBACC_i*Vt)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues((-T1))),evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_gi_bi)));
d_Vaux_Igbacc_dTemp_t_GND = ((NIGBACC_i*Vt)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues((-T1))),evaluator_lexp_0.getDerivs((-T1),(-d_T1_dTemp_t_GND)))+NIGBACC_i*d_Vt_dTemp_t_GND*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues((-T1)))));
Vaux_Igbacc = ((NIGBACC_i*Vt)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues((-T1)))));
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_gi_bi = (-BIGBACC_i*d_Voxmacc_dV_gi_bi);
d_T2_dTemp_t_GND = (-BIGBACC_i*d_Voxmacc_dTemp_t_GND);
d_T2_dV_si_bi = (-BIGBACC_i*d_Voxmacc_dV_si_bi);
d_T2_dV_di_bi = (-BIGBACC_i*d_Voxmacc_dV_di_bi);
T2 = (AIGBACC_i-(BIGBACC_i*Voxmacc));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dV_gi_bi = CIGBACC_i*d_Voxmacc_dV_gi_bi;
d_T3_dTemp_t_GND = CIGBACC_i*d_Voxmacc_dTemp_t_GND;
d_T3_dV_si_bi = CIGBACC_i*d_Voxmacc_dV_si_bi;
d_T3_dV_di_bi = CIGBACC_i*d_Voxmacc_dV_di_bi;
T3 = (1.0+(CIGBACC_i*Voxmacc));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((((-7.45669e11)*(model_.TOXE))*T2)*d_T3_dTemp_t_GND+((-7.45669e11)*(model_.TOXE))*d_T2_dTemp_t_GND*T3);
d_T4_dV_si_bi = ((((-7.45669e11)*(model_.TOXE))*T2)*d_T3_dV_si_bi+((-7.45669e11)*(model_.TOXE))*d_T2_dV_si_bi*T3);
d_T4_dV_di_bi = ((((-7.45669e11)*(model_.TOXE))*T2)*d_T3_dV_di_bi+((-7.45669e11)*(model_.TOXE))*d_T2_dV_di_bi*T3);
d_T4_dV_gi_bi = ((((-7.45669e11)*(model_.TOXE))*T2)*d_T3_dV_gi_bi+((-7.45669e11)*(model_.TOXE))*d_T2_dV_gi_bi*T3);
T4 = ((((-7.45669e11)*(model_.TOXE))*T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = evaluator_lexp_0.getDerivs(T4,d_T4_dTemp_t_GND);
d_T5_dV_si_bi = evaluator_lexp_0.getDerivs(T4,d_T4_dV_si_bi);
d_T5_dV_di_bi = evaluator_lexp_0.getDerivs(T4,d_T4_dV_di_bi);
d_T5_dV_gi_bi = evaluator_lexp_0.getDerivs(T4,d_T4_dV_gi_bi);
T5 = evaluator_lexp_0.getValues(T4);
}

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si = d_T6_dV_gi_bi = d_T6_dV_di_bi = d_T6_dV_si_bi = d_T6_dTemp_t_GND =  0.0;
T6 = 4.97232e-7;

d_igbacc_dTemp_t_GND = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*d_T5_dTemp_t_GND+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbacc_dTemp_t_GND+((NF*Weff)*Leff)*d_T6_dTemp_t_GND*ToxRatio*Vg*Vaux_Igbacc)*T5);
d_igbacc_dV_si_bi = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*d_T5_dV_si_bi+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbacc_dV_si_bi+((NF*Weff)*Leff)*d_T6_dV_si_bi*ToxRatio*Vg*Vaux_Igbacc)*T5);
d_igbacc_dV_di_bi = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*d_T5_dV_di_bi+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbacc_dV_di_bi+((NF*Weff)*Leff)*d_T6_dV_di_bi*ToxRatio*Vg*Vaux_Igbacc)*T5);
d_igbacc_dV_gi_bi = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*d_T5_dV_gi_bi+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbacc_dV_gi_bi+(((((NF*Weff)*Leff)*T6)*ToxRatio)*d_Vg_dV_gi_bi+((NF*Weff)*Leff)*d_T6_dV_gi_bi*ToxRatio*Vg)*Vaux_Igbacc)*T5);
igbacc = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbacc)*T5);

d_igbacc_dTemp_t_GND = (igbacc*d_igtemp_dTemp_t_GND+d_igbacc_dTemp_t_GND*igtemp);
d_igbacc_dV_si_bi = d_igbacc_dV_si_bi*igtemp;
d_igbacc_dV_di_bi = d_igbacc_dV_di_bi*igtemp;
d_igbacc_dV_gi_bi = d_igbacc_dV_gi_bi*igtemp;
igbacc = (igbacc*igtemp);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = ((d_Voxminv_dV_gi_bi/NIGBINV_i)/Vt);
d_T1_dTemp_t_GND = ((Vt*(d_Voxminv_dTemp_t_GND/NIGBINV_i)-((Voxminv-EIGBINV_i)/NIGBINV_i)*d_Vt_dTemp_t_GND)/Vt/Vt);
d_T1_dV_si_bi = ((d_Voxminv_dV_si_bi/NIGBINV_i)/Vt);
d_T1_dV_di_bi = ((d_Voxminv_dV_di_bi/NIGBINV_i)/Vt);
T1 = (((Voxminv-EIGBINV_i)/NIGBINV_i)/Vt);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+evaluator_lexp_0.getValues(T1)));

d_Vaux_Igbinv_dV_si_bi = (NIGBINV_i*Vt)*evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_si_bi));
d_Vaux_Igbinv_dV_di_bi = (NIGBINV_i*Vt)*evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_di_bi));
d_Vaux_Igbinv_dV_gi_bi = (NIGBINV_i*Vt)*evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_gi_bi));
d_Vaux_Igbinv_dTemp_t_GND = ((NIGBINV_i*Vt)*evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dTemp_t_GND))+NIGBINV_i*d_Vt_dTemp_t_GND*evaluator_lln_1.getValues((1.0+evaluator_lexp_0.getValues(T1))));
Vaux_Igbinv = ((NIGBINV_i*Vt)*evaluator_lln_1.getValues((1.0+evaluator_lexp_0.getValues(T1))));
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_gi_bi = (-BIGBINV_i*d_Voxminv_dV_gi_bi);
d_T2_dTemp_t_GND = (-BIGBINV_i*d_Voxminv_dTemp_t_GND);
d_T2_dV_si_bi = (-BIGBINV_i*d_Voxminv_dV_si_bi);
d_T2_dV_di_bi = (-BIGBINV_i*d_Voxminv_dV_di_bi);
T2 = (AIGBINV_i-(BIGBINV_i*Voxminv));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dV_gi_bi = CIGBINV_i*d_Voxminv_dV_gi_bi;
d_T3_dTemp_t_GND = CIGBINV_i*d_Voxminv_dTemp_t_GND;
d_T3_dV_si_bi = CIGBINV_i*d_Voxminv_dV_si_bi;
d_T3_dV_di_bi = CIGBINV_i*d_Voxminv_dV_di_bi;
T3 = (1.0+(CIGBINV_i*Voxminv));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = ((((-9.82222e11)*(model_.TOXE))*T2)*d_T3_dTemp_t_GND+((-9.82222e11)*(model_.TOXE))*d_T2_dTemp_t_GND*T3);
d_T4_dV_si_bi = ((((-9.82222e11)*(model_.TOXE))*T2)*d_T3_dV_si_bi+((-9.82222e11)*(model_.TOXE))*d_T2_dV_si_bi*T3);
d_T4_dV_di_bi = ((((-9.82222e11)*(model_.TOXE))*T2)*d_T3_dV_di_bi+((-9.82222e11)*(model_.TOXE))*d_T2_dV_di_bi*T3);
d_T4_dV_gi_bi = ((((-9.82222e11)*(model_.TOXE))*T2)*d_T3_dV_gi_bi+((-9.82222e11)*(model_.TOXE))*d_T2_dV_gi_bi*T3);
T4 = ((((-9.82222e11)*(model_.TOXE))*T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = evaluator_lexp_0.getDerivs(T4,d_T4_dTemp_t_GND);
d_T5_dV_si_bi = evaluator_lexp_0.getDerivs(T4,d_T4_dV_si_bi);
d_T5_dV_di_bi = evaluator_lexp_0.getDerivs(T4,d_T4_dV_di_bi);
d_T5_dV_gi_bi = evaluator_lexp_0.getDerivs(T4,d_T4_dV_gi_bi);
T5 = evaluator_lexp_0.getValues(T4);
}

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si = d_T6_dV_gi_bi = d_T6_dV_di_bi = d_T6_dV_si_bi = d_T6_dTemp_t_GND =  0.0;
T6 = 3.75956e-7;

d_igbinv_dTemp_t_GND = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*d_T5_dTemp_t_GND+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbinv_dTemp_t_GND+((NF*Weff)*Leff)*d_T6_dTemp_t_GND*ToxRatio*Vg*Vaux_Igbinv)*T5);
d_igbinv_dV_si_bi = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*d_T5_dV_si_bi+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbinv_dV_si_bi+((NF*Weff)*Leff)*d_T6_dV_si_bi*ToxRatio*Vg*Vaux_Igbinv)*T5);
d_igbinv_dV_di_bi = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*d_T5_dV_di_bi+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbinv_dV_di_bi+((NF*Weff)*Leff)*d_T6_dV_di_bi*ToxRatio*Vg*Vaux_Igbinv)*T5);
d_igbinv_dV_gi_bi = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*d_T5_dV_gi_bi+((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*d_Vaux_Igbinv_dV_gi_bi+(((((NF*Weff)*Leff)*T6)*ToxRatio)*d_Vg_dV_gi_bi+((NF*Weff)*Leff)*d_T6_dV_gi_bi*ToxRatio*Vg)*Vaux_Igbinv)*T5);
igbinv = (((((((NF*Weff)*Leff)*T6)*ToxRatio)*Vg)*Vaux_Igbinv)*T5);

d_igbinv_dTemp_t_GND = (igbinv*d_igtemp_dTemp_t_GND+d_igbinv_dTemp_t_GND*igtemp);
d_igbinv_dV_si_bi = d_igbinv_dV_si_bi*igtemp;
d_igbinv_dV_di_bi = d_igbinv_dV_di_bi*igtemp;
d_igbinv_dV_gi_bi = d_igbinv_dV_gi_bi*igtemp;
igbinv = (igbinv*igtemp);

d_igb_dTemp_t_GND = (d_igbacc_dTemp_t_GND+d_igbinv_dTemp_t_GND);
d_igb_dV_si_bi = (d_igbacc_dV_si_bi+d_igbinv_dV_si_bi);
d_igb_dV_di_bi = (d_igbacc_dV_di_bi+d_igbinv_dV_di_bi);
d_igb_dV_gi_bi = (d_igbacc_dV_gi_bi+d_igbinv_dV_gi_bi);
igb = (igbacc+igbinv);
}
if (((model_.IGCMOD)!=0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_gi_bi = (-BIGC_i*d_Voxminv_dV_gi_bi);
d_T1_dTemp_t_GND = (-BIGC_i*d_Voxminv_dTemp_t_GND);
d_T1_dV_si_bi = (-BIGC_i*d_Voxminv_dV_si_bi);
d_T1_dV_di_bi = (-BIGC_i*d_Voxminv_dV_di_bi);
T1 = (AIGC_i-(BIGC_i*Voxminv));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_gi_bi = CIGC_i*d_Voxminv_dV_gi_bi;
d_T2_dTemp_t_GND = CIGC_i*d_Voxminv_dTemp_t_GND;
d_T2_dV_si_bi = CIGC_i*d_Voxminv_dV_si_bi;
d_T2_dV_di_bi = CIGC_i*d_Voxminv_dV_di_bi;
T2 = (1.0+(CIGC_i*Voxminv));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = ((Bechvb*T1)*d_T2_dTemp_t_GND+Bechvb*d_T1_dTemp_t_GND*T2);
d_T3_dV_si_bi = ((Bechvb*T1)*d_T2_dV_si_bi+Bechvb*d_T1_dV_si_bi*T2);
d_T3_dV_di_bi = ((Bechvb*T1)*d_T2_dV_di_bi+Bechvb*d_T1_dV_di_bi*T2);
d_T3_dV_gi_bi = ((Bechvb*T1)*d_T2_dV_gi_bi+Bechvb*d_T1_dV_gi_bi*T2);
T3 = ((Bechvb*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dV_si_bi = (((nq*nVt)*(qs+qdeff))*evaluator_lexp_0.getDerivs(T3,d_T3_dV_si_bi)+((nq*nVt)*(d_qs_dV_si_bi+d_qdeff_dV_si_bi)+(nq*d_nVt_dV_si_bi+d_nq_dV_si_bi*nVt)*(qs+qdeff))*evaluator_lexp_0.getValues(T3));
d_T4_dV_di_bi = (((nq*nVt)*(qs+qdeff))*evaluator_lexp_0.getDerivs(T3,d_T3_dV_di_bi)+((nq*nVt)*(d_qs_dV_di_bi+d_qdeff_dV_di_bi)+(nq*d_nVt_dV_di_bi+d_nq_dV_di_bi*nVt)*(qs+qdeff))*evaluator_lexp_0.getValues(T3));
d_T4_dTemp_t_GND = (((nq*nVt)*(qs+qdeff))*evaluator_lexp_0.getDerivs(T3,d_T3_dTemp_t_GND)+((nq*nVt)*(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+(nq*d_nVt_dTemp_t_GND+d_nq_dTemp_t_GND*nVt)*(qs+qdeff))*evaluator_lexp_0.getValues(T3));
d_T4_dV_gi_bi = (((nq*nVt)*(qs+qdeff))*evaluator_lexp_0.getDerivs(T3,d_T3_dV_gi_bi)+((nq*nVt)*(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+(nq*d_nVt_dV_gi_bi+d_nq_dV_gi_bi*nVt)*(qs+qdeff))*evaluator_lexp_0.getValues(T3));
T4 = (((nq*nVt)*(qs+qdeff))*evaluator_lexp_0.getValues(T3));
}

d_igc0_dTemp_t_GND = ((((NF*Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*d_igtemp_dTemp_t_GND+(NF*Aechvb)*d_T4_dTemp_t_GND*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd)))*igtemp);
d_igc0_dV_si_bi = (((NF*Aechvb)*T4)*(0.5*d_Vdsx_dV_si_bi-0.5*(d_Vs_dV_si_bi+d_Vd_dV_si_bi))+(NF*Aechvb)*d_T4_dV_si_bi*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp;
d_igc0_dV_di_bi = (((NF*Aechvb)*T4)*(0.5*d_Vdsx_dV_di_bi-0.5*(d_Vs_dV_di_bi+d_Vd_dV_di_bi))+(NF*Aechvb)*d_T4_dV_di_bi*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp;
d_igc0_dV_gi_bi = (((NF*Aechvb)*T4)*d_Vg_dV_gi_bi+(NF*Aechvb)*d_T4_dV_gi_bi*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp;
igc0 = ((((NF*Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp);
{
double value_sqrt_0 = sqrt(((Vdseff*Vdseff)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdseffx_dTemp_t_GND = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dTemp_t_GND+d_Vdseff_dTemp_t_GND*Vdseff)));
d_Vdseffx_dV_gi_bi = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_gi_bi+d_Vdseff_dV_gi_bi*Vdseff)));
d_Vdseffx_dV_si_bi = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_si_bi+d_Vdseff_dV_si_bi*Vdseff)));
d_Vdseffx_dV_di_bi = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_di_bi+d_Vdseff_dV_di_bi*Vdseff)));
Vdseffx = (value_sqrt_0-0.1);
}

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = PIGCD_i*d_Vdseffx_dTemp_t_GND;
d_T1_dV_gi_bi = PIGCD_i*d_Vdseffx_dV_gi_bi;
d_T1_dV_si_bi = PIGCD_i*d_Vdseffx_dV_si_bi;
d_T1_dV_di_bi = PIGCD_i*d_Vdseffx_dV_di_bi;
T1 = (PIGCD_i*Vdseffx);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));

d_T1_exp_dTemp_t_GND = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dTemp_t_GND));
d_T1_exp_dV_si_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_si_bi));
d_T1_exp_dV_di_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_bi));
d_T1_exp_dV_gi_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_gi_bi));
T1_exp = evaluator_lexp_0.getValues((-T1));
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = (d_T1_dTemp_t_GND+d_T1_exp_dTemp_t_GND);
d_T3_dV_si_bi = (d_T1_dV_si_bi+d_T1_exp_dV_si_bi);
d_T3_dV_di_bi = (d_T1_dV_di_bi+d_T1_exp_dV_di_bi);
d_T3_dV_gi_bi = (d_T1_dV_gi_bi+d_T1_exp_dV_gi_bi);
T3 = (((T1+T1_exp)-1.0)+1.0E-4);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = (-((T1+1.0)*d_T1_exp_dTemp_t_GND+d_T1_dTemp_t_GND*T1_exp));
d_T4_dV_si_bi = (-((T1+1.0)*d_T1_exp_dV_si_bi+d_T1_dV_si_bi*T1_exp));
d_T4_dV_di_bi = (-((T1+1.0)*d_T1_exp_dV_di_bi+d_T1_dV_di_bi*T1_exp));
d_T4_dV_gi_bi = (-((T1+1.0)*d_T1_exp_dV_gi_bi+d_T1_dV_gi_bi*T1_exp));
T4 = ((1.0-((T1+1.0)*T1_exp))+1.0E-4);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = (T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1);
d_T5_dV_si_bi = (T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1);
d_T5_dV_di_bi = (T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1);
d_T5_dV_gi_bi = (T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1);
T5 = ((T1*T1)+2.0E-4);
if ((sigvds>0))
{

d_igcd_dTemp_t_GND = ((T5*(igc0*d_T4_dTemp_t_GND+d_igc0_dTemp_t_GND*T4)-(igc0*T4)*d_T5_dTemp_t_GND)/T5/T5);
d_igcd_dV_si_bi = ((T5*(igc0*d_T4_dV_si_bi+d_igc0_dV_si_bi*T4)-(igc0*T4)*d_T5_dV_si_bi)/T5/T5);
d_igcd_dV_di_bi = ((T5*(igc0*d_T4_dV_di_bi+d_igc0_dV_di_bi*T4)-(igc0*T4)*d_T5_dV_di_bi)/T5/T5);
d_igcd_dV_gi_bi = ((T5*(igc0*d_T4_dV_gi_bi+d_igc0_dV_gi_bi*T4)-(igc0*T4)*d_T5_dV_gi_bi)/T5/T5);
igcd = ((igc0*T4)/T5);

d_igcs_dTemp_t_GND = ((T5*(igc0*d_T3_dTemp_t_GND+d_igc0_dTemp_t_GND*T3)-(igc0*T3)*d_T5_dTemp_t_GND)/T5/T5);
d_igcs_dV_si_bi = ((T5*(igc0*d_T3_dV_si_bi+d_igc0_dV_si_bi*T3)-(igc0*T3)*d_T5_dV_si_bi)/T5/T5);
d_igcs_dV_di_bi = ((T5*(igc0*d_T3_dV_di_bi+d_igc0_dV_di_bi*T3)-(igc0*T3)*d_T5_dV_di_bi)/T5/T5);
d_igcs_dV_gi_bi = ((T5*(igc0*d_T3_dV_gi_bi+d_igc0_dV_gi_bi*T3)-(igc0*T3)*d_T5_dV_gi_bi)/T5/T5);
igcs = ((igc0*T3)/T5);
}
else
{

d_igcs_dTemp_t_GND = ((T5*(igc0*d_T4_dTemp_t_GND+d_igc0_dTemp_t_GND*T4)-(igc0*T4)*d_T5_dTemp_t_GND)/T5/T5);
d_igcs_dV_si_bi = ((T5*(igc0*d_T4_dV_si_bi+d_igc0_dV_si_bi*T4)-(igc0*T4)*d_T5_dV_si_bi)/T5/T5);
d_igcs_dV_di_bi = ((T5*(igc0*d_T4_dV_di_bi+d_igc0_dV_di_bi*T4)-(igc0*T4)*d_T5_dV_di_bi)/T5/T5);
d_igcs_dV_gi_bi = ((T5*(igc0*d_T4_dV_gi_bi+d_igc0_dV_gi_bi*T4)-(igc0*T4)*d_T5_dV_gi_bi)/T5/T5);
igcs = ((igc0*T4)/T5);

d_igcd_dTemp_t_GND = ((T5*(igc0*d_T3_dTemp_t_GND+d_igc0_dTemp_t_GND*T3)-(igc0*T3)*d_T5_dTemp_t_GND)/T5/T5);
d_igcd_dV_si_bi = ((T5*(igc0*d_T3_dV_si_bi+d_igc0_dV_si_bi*T3)-(igc0*T3)*d_T5_dV_si_bi)/T5/T5);
d_igcd_dV_di_bi = ((T5*(igc0*d_T3_dV_di_bi+d_igc0_dV_di_bi*T3)-(igc0*T3)*d_T5_dV_di_bi)/T5/T5);
d_igcd_dV_gi_bi = ((T5*(igc0*d_T3_dV_gi_bi+d_igc0_dV_gi_bi*T3)-(igc0*T3)*d_T5_dV_gi_bi)/T5/T5);
igcd = ((igc0*T3)/T5);
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_di_bi =  0.0;
d_T2_dTemp_t_GND = (-d_Vfbsdr_dTemp_t_GND);
d_T2_dV_si_bi = d_Vgs_noswap_dV_si_bi;
d_T2_dV_gi_bi = d_Vgs_noswap_dV_gi_bi;
T2 = (Vgs_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vgs_eff_dTemp_t_GND = (deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2)));
d_Vgs_eff_dV_si_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2)));
d_Vgs_eff_dV_di_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2)));
d_Vgs_eff_dV_gi_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2)));
Vgs_eff = value_sqrt_0;
}

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = (-BIGS_i*d_Vgs_eff_dTemp_t_GND);
d_T1_dV_si_bi = (-BIGS_i*d_Vgs_eff_dV_si_bi);
d_T1_dV_di_bi = (-BIGS_i*d_Vgs_eff_dV_di_bi);
d_T1_dV_gi_bi = (-BIGS_i*d_Vgs_eff_dV_gi_bi);
T1 = (AIGS_i-(BIGS_i*Vgs_eff));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = CIGS_i*d_Vgs_eff_dTemp_t_GND;
d_T2_dV_si_bi = CIGS_i*d_Vgs_eff_dV_si_bi;
d_T2_dV_di_bi = CIGS_i*d_Vgs_eff_dV_di_bi;
d_T2_dV_gi_bi = CIGS_i*d_Vgs_eff_dV_gi_bi;
T2 = (1.0+(CIGS_i*Vgs_eff));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = ((BechvbEdge*T1)*d_T2_dTemp_t_GND+BechvbEdge*d_T1_dTemp_t_GND*T2);
d_T3_dV_si_bi = ((BechvbEdge*T1)*d_T2_dV_si_bi+BechvbEdge*d_T1_dV_si_bi*T2);
d_T3_dV_di_bi = ((BechvbEdge*T1)*d_T2_dV_di_bi+BechvbEdge*d_T1_dV_di_bi*T2);
d_T3_dV_gi_bi = ((BechvbEdge*T1)*d_T2_dV_gi_bi+BechvbEdge*d_T1_dV_gi_bi*T2);
T3 = ((BechvbEdge*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = evaluator_lexp_0.getDerivs(T3,d_T3_dTemp_t_GND);
d_T4_dV_si_bi = evaluator_lexp_0.getDerivs(T3,d_T3_dV_si_bi);
d_T4_dV_di_bi = evaluator_lexp_0.getDerivs(T3,d_T3_dV_di_bi);
d_T4_dV_gi_bi = evaluator_lexp_0.getDerivs(T3,d_T3_dV_gi_bi);
T4 = evaluator_lexp_0.getValues(T3);
}

d_igs_mult_dTemp_t_GND = d_igtemp_dTemp_t_GND*NF*AechvbEdge*DLCIG_i;
igs_mult = (((igtemp*NF)*AechvbEdge)*DLCIG_i);

d_igs_dV_di_bi = (((igs_mult*Vgs_noswap)*Vgs_eff)*d_T4_dV_di_bi+(igs_mult*Vgs_noswap)*d_Vgs_eff_dV_di_bi*T4);
d_igs_dV_si_bi = (((igs_mult*Vgs_noswap)*Vgs_eff)*d_T4_dV_si_bi+((igs_mult*Vgs_noswap)*d_Vgs_eff_dV_si_bi+igs_mult*d_Vgs_noswap_dV_si_bi*Vgs_eff)*T4);
d_igs_dV_gi_bi = (((igs_mult*Vgs_noswap)*Vgs_eff)*d_T4_dV_gi_bi+((igs_mult*Vgs_noswap)*d_Vgs_eff_dV_gi_bi+igs_mult*d_Vgs_noswap_dV_gi_bi*Vgs_eff)*T4);
d_igs_dTemp_t_GND = (((igs_mult*Vgs_noswap)*Vgs_eff)*d_T4_dTemp_t_GND+((igs_mult*Vgs_noswap)*d_Vgs_eff_dTemp_t_GND+d_igs_mult_dTemp_t_GND*Vgs_noswap*Vgs_eff)*T4);
igs = (((igs_mult*Vgs_noswap)*Vgs_eff)*T4);

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_si_bi =  0.0;
d_T2_dTemp_t_GND = (-d_Vfbsdr_dTemp_t_GND);
d_T2_dV_di_bi = d_Vgd_noswap_dV_di_bi;
d_T2_dV_gi_bi = d_Vgd_noswap_dV_gi_bi;
T2 = (Vgd_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vgd_eff_dTemp_t_GND = (deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2)));
d_Vgd_eff_dV_si_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2)));
d_Vgd_eff_dV_di_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2)));
d_Vgd_eff_dV_gi_bi = (deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2)));
Vgd_eff = value_sqrt_0;
}

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = (-BIGD_i*d_Vgd_eff_dTemp_t_GND);
d_T1_dV_si_bi = (-BIGD_i*d_Vgd_eff_dV_si_bi);
d_T1_dV_di_bi = (-BIGD_i*d_Vgd_eff_dV_di_bi);
d_T1_dV_gi_bi = (-BIGD_i*d_Vgd_eff_dV_gi_bi);
T1 = (AIGD_i-(BIGD_i*Vgd_eff));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dTemp_t_GND = CIGD_i*d_Vgd_eff_dTemp_t_GND;
d_T2_dV_si_bi = CIGD_i*d_Vgd_eff_dV_si_bi;
d_T2_dV_di_bi = CIGD_i*d_Vgd_eff_dV_di_bi;
d_T2_dV_gi_bi = CIGD_i*d_Vgd_eff_dV_gi_bi;
T2 = (1.0+(CIGD_i*Vgd_eff));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dTemp_t_GND = ((BechvbEdge*T1)*d_T2_dTemp_t_GND+BechvbEdge*d_T1_dTemp_t_GND*T2);
d_T3_dV_si_bi = ((BechvbEdge*T1)*d_T2_dV_si_bi+BechvbEdge*d_T1_dV_si_bi*T2);
d_T3_dV_di_bi = ((BechvbEdge*T1)*d_T2_dV_di_bi+BechvbEdge*d_T1_dV_di_bi*T2);
d_T3_dV_gi_bi = ((BechvbEdge*T1)*d_T2_dV_gi_bi+BechvbEdge*d_T1_dV_gi_bi*T2);
T3 = ((BechvbEdge*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = evaluator_lexp_0.getDerivs(T3,d_T3_dTemp_t_GND);
d_T4_dV_si_bi = evaluator_lexp_0.getDerivs(T3,d_T3_dV_si_bi);
d_T4_dV_di_bi = evaluator_lexp_0.getDerivs(T3,d_T3_dV_di_bi);
d_T4_dV_gi_bi = evaluator_lexp_0.getDerivs(T3,d_T3_dV_gi_bi);
T4 = evaluator_lexp_0.getValues(T3);
}

d_igd_mult_dTemp_t_GND = d_igtemp_dTemp_t_GND*NF*AechvbEdge*DLCIGD_i;
igd_mult = (((igtemp*NF)*AechvbEdge)*DLCIGD_i);

d_igd_dV_si_bi = (((igd_mult*Vgd_noswap)*Vgd_eff)*d_T4_dV_si_bi+(igd_mult*Vgd_noswap)*d_Vgd_eff_dV_si_bi*T4);
d_igd_dV_di_bi = (((igd_mult*Vgd_noswap)*Vgd_eff)*d_T4_dV_di_bi+((igd_mult*Vgd_noswap)*d_Vgd_eff_dV_di_bi+igd_mult*d_Vgd_noswap_dV_di_bi*Vgd_eff)*T4);
d_igd_dV_gi_bi = (((igd_mult*Vgd_noswap)*Vgd_eff)*d_T4_dV_gi_bi+((igd_mult*Vgd_noswap)*d_Vgd_eff_dV_gi_bi+igd_mult*d_Vgd_noswap_dV_gi_bi*Vgd_eff)*T4);
d_igd_dTemp_t_GND = (((igd_mult*Vgd_noswap)*Vgd_eff)*d_T4_dTemp_t_GND+((igd_mult*Vgd_noswap)*d_Vgd_eff_dTemp_t_GND+d_igd_mult_dTemp_t_GND*Vgd_noswap*Vgd_eff)*T4);
igd = (((igd_mult*Vgd_noswap)*Vgd_eff)*T4);
}
}

d_IGS_dV_di_bi = devsign*d_igs_dV_di_bi;
d_IGS_dV_si_bi = devsign*d_igs_dV_si_bi;
d_IGS_dV_gi_bi = devsign*d_igs_dV_gi_bi;
d_IGS_dTemp_t_GND = devsign*d_igs_dTemp_t_GND;
IGS = (devsign*igs);

d_IGD_dV_si_bi = devsign*d_igd_dV_si_bi;
d_IGD_dV_di_bi = devsign*d_igd_dV_di_bi;
d_IGD_dV_gi_bi = devsign*d_igd_dV_gi_bi;
d_IGD_dTemp_t_GND = devsign*d_igd_dTemp_t_GND;
IGD = (devsign*igd);

d_IGB_dTemp_t_GND = devsign*d_igb_dTemp_t_GND;
d_IGB_dV_si_bi = devsign*d_igb_dV_si_bi;
d_IGB_dV_di_bi = devsign*d_igb_dV_di_bi;
d_IGB_dV_gi_bi = devsign*d_igb_dV_gi_bi;
IGB = (devsign*igb);

d_IGCS_dTemp_t_GND = devsign*d_igcs_dTemp_t_GND;
d_IGCS_dV_si_bi = devsign*d_igcs_dV_si_bi;
d_IGCS_dV_di_bi = devsign*d_igcs_dV_di_bi;
d_IGCS_dV_gi_bi = devsign*d_igcs_dV_gi_bi;
IGCS = (devsign*igcs);

d_IGCD_dTemp_t_GND = devsign*d_igcd_dTemp_t_GND;
d_IGCD_dV_si_bi = devsign*d_igcd_dV_si_bi;
d_IGCD_dV_di_bi = devsign*d_igcd_dV_di_bi;
d_IGCD_dV_gi_bi = devsign*d_igcd_dV_gi_bi;
IGCD = (devsign*igcd);

d_igisl_dV_gi_bi = d_igisl_dV_di_bi = d_igisl_dV_si_bi = d_igisl_dTemp_t_GND =  0.0;
igisl = 0.0;

d_igidl_dV_gi_bi = d_igidl_dV_di_bi = d_igidl_dV_si_bi = d_igidl_dTemp_t_GND =  0.0;
igidl = 0.0;
if (((model_.GIDLMOD)!=0))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi = d_T0_dTemp_t_GND =  0.0;
T0 = (epsratio*(model_.TOXE));
if ((((AGIDL_i<=0.0)||(BGIDL_t<=0.0))||(CGIDL_i<0.0)))
{

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si = d_T6_dV_gi_bi = d_T6_dV_di_bi = d_T6_dV_si_bi = d_T6_dTemp_t_GND =  0.0;
T6 = 0.0;
}
else
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_si_bi = (-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*d_T0_dV_si_bi/T0/T0);
d_T1_dTemp_t_GND = ((T0*d_Vfbsdr_dTemp_t_GND-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*d_T0_dTemp_t_GND)/T0/T0);
d_T1_dV_di_bi = ((T0*(-d_Vgd_noswap_dV_di_bi)-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*d_T0_dV_di_bi)/T0/T0);
d_T1_dV_gi_bi = ((T0*(-d_Vgd_noswap_dV_gi_bi)-(((-Vgd_noswap)-EGIDL_i)+Vfbsdr)*d_T0_dV_gi_bi)/T0/T0);
T1 = ((((-Vgd_noswap)-EGIDL_i)+Vfbsdr)/T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-2);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dTemp_t_GND,0.0);
d_T1_dV_si_bi = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_si_bi,0.0);
d_T1_dV_di_bi = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_di_bi,0.0);
d_T1_dV_gi_bi = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_gi_bi,0.0);
T1 = evaluator_hypsmooth_0.getValues(T1,1.0E-2);
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_si_bi = (-BGIDL_t*d_T1_dV_si_bi/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_di_bi = (-BGIDL_t*d_T1_dV_di_bi/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_gi_bi = (-BGIDL_t*d_T1_dV_gi_bi/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dTemp_t_GND = (((T1+1.0E-3)*d_BGIDL_t_dTemp_t_GND-BGIDL_t*d_T1_dTemp_t_GND)/(T1+1.0E-3)/(T1+1.0E-3));
T2 = (BGIDL_t/(T1+1.0E-3));
if ((CGIDL_i!=0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
d_T3_dV_di_bi = ((Vdb_noswap*Vdb_noswap)*d_Vdb_noswap_dV_di_bi+(Vdb_noswap*d_Vdb_noswap_dV_di_bi+d_Vdb_noswap_dV_di_bi*Vdb_noswap)*Vdb_noswap);
T3 = ((Vdb_noswap*Vdb_noswap)*Vdb_noswap);
{
double value_fabs_0 = fabs(T3);
double  deriv_fabs_0_d0 = (((T3)>=0)?(+1.0):(-1.0));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = (deriv_fabs_0_d0*(d_T3_dTemp_t_GND));
d_T4_dV_si_bi = (deriv_fabs_0_d0*(d_T3_dV_si_bi));
d_T4_dV_di_bi = (deriv_fabs_0_d0*(d_T3_dV_di_bi));
d_T4_dV_gi_bi = (deriv_fabs_0_d0*(d_T3_dV_gi_bi));
T4 = ((CGIDL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T3/T4),1.0E-6);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dTemp_t_GND-T3*d_T4_dTemp_t_GND)/T4/T4),0.0);
d_T5_dV_si_bi = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dV_si_bi-T3*d_T4_dV_si_bi)/T4/T4),0.0);
d_T5_dV_di_bi = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dV_di_bi-T3*d_T4_dV_di_bi)/T4/T4),0.0);
d_T5_dV_gi_bi = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dV_gi_bi-T3*d_T4_dV_gi_bi)/T4/T4),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T3/T4),1.0E-6)-1.0E-6);
}
}
else
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 1.0;
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = ((((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dTemp_t_GND+(((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dTemp_t_GND))+(AGIDL_i*Weff)*d_T1_dTemp_t_GND*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_si_bi = ((((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_si_bi+(((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_si_bi))+(AGIDL_i*Weff)*d_T1_dV_si_bi*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_di_bi = ((((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_di_bi+(((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_bi))+(AGIDL_i*Weff)*d_T1_dV_di_bi*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_gi_bi = ((((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_gi_bi+(((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_gi_bi))+(AGIDL_i*Weff)*d_T1_dV_gi_bi*evaluator_lexp_0.getValues((-T2)))*T5);
T6 = ((((AGIDL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*T5);
}
}

d_igidl_dTemp_t_GND = d_T6_dTemp_t_GND;
d_igidl_dV_si_bi = d_T6_dV_si_bi;
d_igidl_dV_di_bi = d_T6_dV_di_bi;
d_igidl_dV_gi_bi = d_T6_dV_gi_bi;
igidl = T6;
if ((((AGISL_i<=0.0)||(BGISL_t<=0.0))||(CGISL_i<0.0)))
{

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si = d_T6_dV_gi_bi = d_T6_dV_di_bi = d_T6_dV_si_bi = d_T6_dTemp_t_GND =  0.0;
T6 = 0.0;
}
else
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_di_bi = (-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*d_T0_dV_di_bi/T0/T0);
d_T1_dTemp_t_GND = ((T0*d_Vfbsdr_dTemp_t_GND-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*d_T0_dTemp_t_GND)/T0/T0);
d_T1_dV_si_bi = ((T0*(-d_Vgs_noswap_dV_si_bi)-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*d_T0_dV_si_bi)/T0/T0);
d_T1_dV_gi_bi = ((T0*(-d_Vgs_noswap_dV_gi_bi)-(((-Vgs_noswap)-EGISL_i)+Vfbsdr)*d_T0_dV_gi_bi)/T0/T0);
T1 = ((((-Vgs_noswap)-EGISL_i)+Vfbsdr)/T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-2);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dTemp_t_GND,0.0);
d_T1_dV_si_bi = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_si_bi,0.0);
d_T1_dV_di_bi = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_di_bi,0.0);
d_T1_dV_gi_bi = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_gi_bi,0.0);
T1 = evaluator_hypsmooth_0.getValues(T1,1.0E-2);
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si =  0.0;
d_T2_dV_si_bi = (-BGISL_t*d_T1_dV_si_bi/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_di_bi = (-BGISL_t*d_T1_dV_di_bi/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_gi_bi = (-BGISL_t*d_T1_dV_gi_bi/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dTemp_t_GND = (((T1+1.0E-3)*d_BGISL_t_dTemp_t_GND-BGISL_t*d_T1_dTemp_t_GND)/(T1+1.0E-3)/(T1+1.0E-3));
T2 = (BGISL_t/(T1+1.0E-3));
if ((CGISL_i!=0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dTemp_t_GND =  0.0;
d_T3_dV_si_bi = ((Vsb_noswap*Vsb_noswap)*d_Vsb_noswap_dV_si_bi+(Vsb_noswap*d_Vsb_noswap_dV_si_bi+d_Vsb_noswap_dV_si_bi*Vsb_noswap)*Vsb_noswap);
T3 = ((Vsb_noswap*Vsb_noswap)*Vsb_noswap);
{
double value_fabs_0 = fabs(T3);
double  deriv_fabs_0_d0 = (((T3)>=0)?(+1.0):(-1.0));

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dTemp_t_GND = (deriv_fabs_0_d0*(d_T3_dTemp_t_GND));
d_T4_dV_si_bi = (deriv_fabs_0_d0*(d_T3_dV_si_bi));
d_T4_dV_di_bi = (deriv_fabs_0_d0*(d_T3_dV_di_bi));
d_T4_dV_gi_bi = (deriv_fabs_0_d0*(d_T3_dV_gi_bi));
T4 = ((CGISL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T3/T4),1.0E-6);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dTemp_t_GND = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dTemp_t_GND-T3*d_T4_dTemp_t_GND)/T4/T4),0.0);
d_T5_dV_si_bi = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dV_si_bi-T3*d_T4_dV_si_bi)/T4/T4),0.0);
d_T5_dV_di_bi = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dV_di_bi-T3*d_T4_dV_di_bi)/T4/T4),0.0);
d_T5_dV_gi_bi = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dV_gi_bi-T3*d_T4_dV_gi_bi)/T4/T4),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T3/T4),1.0E-6)-1.0E-6);
}
}
else
{

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 1.0;
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = ((((AGISL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dTemp_t_GND+(((AGISL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dTemp_t_GND))+(AGISL_i*Weff)*d_T1_dTemp_t_GND*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_si_bi = ((((AGISL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_si_bi+(((AGISL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_si_bi))+(AGISL_i*Weff)*d_T1_dV_si_bi*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_di_bi = ((((AGISL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_di_bi+(((AGISL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_bi))+(AGISL_i*Weff)*d_T1_dV_di_bi*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_gi_bi = ((((AGISL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_gi_bi+(((AGISL_i*Weff)*T1)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_gi_bi))+(AGISL_i*Weff)*d_T1_dV_gi_bi*evaluator_lexp_0.getValues((-T2)))*T5);
T6 = ((((AGISL_i*Weff)*T1)*evaluator_lexp_0.getValues((-T2)))*T5);
}
}

d_igisl_dTemp_t_GND = d_T6_dTemp_t_GND;
d_igisl_dV_si_bi = d_T6_dV_si_bi;
d_igisl_dV_di_bi = d_T6_dV_di_bi;
d_igisl_dV_gi_bi = d_T6_dV_gi_bi;
igisl = T6;
}

d_IGIDL_dTemp_t_GND = (devsign*NF)*d_igidl_dTemp_t_GND;
d_IGIDL_dV_si_bi = (devsign*NF)*d_igidl_dV_si_bi;
d_IGIDL_dV_di_bi = (devsign*NF)*d_igidl_dV_di_bi;
d_IGIDL_dV_gi_bi = (devsign*NF)*d_igidl_dV_gi_bi;
IGIDL = ((devsign*NF)*igidl);

d_IGISL_dTemp_t_GND = (devsign*NF)*d_igisl_dTemp_t_GND;
d_IGISL_dV_si_bi = (devsign*NF)*d_igisl_dV_si_bi;
d_IGISL_dV_di_bi = (devsign*NF)*d_igisl_dV_di_bi;
d_IGISL_dV_gi_bi = (devsign*NF)*d_igisl_dV_gi_bi;
IGISL = ((devsign*NF)*igisl);
if ((Isbs>0.0))
{
if ((Vbs_jct<VjsmRev))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-Vbs_jct*d_Nvtms_dTemp_t_GND/Nvtms/Nvtms);
d_T0_dV_sbulk_si = (d_Vbs_jct_dV_sbulk_si/Nvtms);
T0 = (Vbs_jct/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(T0,d_T0_dTemp_t_GND);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(T0,d_T0_dV_si_bi);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_bi);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(T0,d_T0_dV_gi_bi);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_sbulk_si);
T1 = (evaluator_lexp_0.getValues(T0)-1.0);
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi =  0.0;
d_T2_dV_sbulk_si = SslpRev*d_Vbs_jct_dV_sbulk_si;
d_T2_dTemp_t_GND = (d_IVjsmRev_dTemp_t_GND+(SslpRev*(-d_VjsmRev_dTemp_t_GND)+d_SslpRev_dTemp_t_GND*(Vbs_jct-VjsmRev)));
T2 = (IVjsmRev+(SslpRev*(Vbs_jct-VjsmRev)));

d_Ibs_dTemp_t_GND = (T1*d_T2_dTemp_t_GND+d_T1_dTemp_t_GND*T2);
d_Ibs_dV_si_bi = (T1*d_T2_dV_si_bi+d_T1_dV_si_bi*T2);
d_Ibs_dV_di_bi = (T1*d_T2_dV_di_bi+d_T1_dV_di_bi*T2);
d_Ibs_dV_gi_bi = (T1*d_T2_dV_gi_bi+d_T1_dV_gi_bi*T2);
d_Ibs_dV_sbulk_si = (T1*d_T2_dV_sbulk_si+d_T1_dV_sbulk_si*T2);
Ibs = (T1*T2);
}
else
{
if ((Vbs_jct<=VjsmFwd))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-Vbs_jct*d_Nvtms_dTemp_t_GND/Nvtms/Nvtms);
d_T0_dV_sbulk_si = (d_Vbs_jct_dV_sbulk_si/Nvtms);
T0 = (Vbs_jct/Nvtms);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-((model_.BVS)+Vbs_jct)*d_Nvtms_dTemp_t_GND/Nvtms/Nvtms);
d_T1_dV_sbulk_si = (d_Vbs_jct_dV_sbulk_si/Nvtms);
T1 = (((model_.BVS)+Vbs_jct)/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di =  0.0;
d_T2_dTemp_t_GND = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dTemp_t_GND));
d_T2_dV_si_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_si_bi));
d_T2_dV_di_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_bi));
d_T2_dV_gi_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_gi_bi));
d_T2_dV_sbulk_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_sbulk_si));
T2 = evaluator_lexp_0.getValues((-T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_Ibs_dV_si_bi = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_si_bi)-(model_.XJBVS)*d_T2_dV_si_bi);
d_Ibs_dV_di_bi = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_bi)-(model_.XJBVS)*d_T2_dV_di_bi);
d_Ibs_dV_gi_bi = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_gi_bi)-(model_.XJBVS)*d_T2_dV_gi_bi);
d_Ibs_dV_sbulk_si = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_sbulk_si)-(model_.XJBVS)*d_T2_dV_sbulk_si);
d_Ibs_dTemp_t_GND = (Isbs*((evaluator_lexp_0.getDerivs(T0,d_T0_dTemp_t_GND)+d_XExpBVS_dTemp_t_GND)-(model_.XJBVS)*d_T2_dTemp_t_GND)+d_Isbs_dTemp_t_GND*(((evaluator_lexp_0.getValues(T0)+XExpBVS)-1.0)-((model_.XJBVS)*T2)));
Ibs = (Isbs*(((evaluator_lexp_0.getValues(T0)+XExpBVS)-1.0)-((model_.XJBVS)*T2)));
}
}
else
{

d_Ibs_dV_gi_bi = d_Ibs_dV_di_bi = d_Ibs_dV_si_bi =  0.0;
d_Ibs_dV_sbulk_si = SslpFwd*d_Vbs_jct_dV_sbulk_si;
d_Ibs_dTemp_t_GND = (d_IVjsmFwd_dTemp_t_GND+(SslpFwd*(-d_VjsmFwd_dTemp_t_GND)+d_SslpFwd_dTemp_t_GND*(Vbs_jct-VjsmFwd)));
Ibs = (IVjsmFwd+(SslpFwd*(Vbs_jct-VjsmFwd)));
}
}
}
else
{

d_Ibs_dV_sbulk_si = d_Ibs_dV_gi_bi = d_Ibs_dV_di_bi = d_Ibs_dV_si_bi = d_Ibs_dTemp_t_GND =  0.0;
Ibs = 0.0;
}
if ((JTSS_t>0.0))
{
if ((((model_.VTSS)-Vbs_jct)<((model_.VTSS)*1.0e-3)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbs_jct)/Vtm0)*d_NJTS_t_dTemp_t_GND/NJTS_t/NJTS_t);
d_T0_dV_sbulk_si = (((-d_Vbs_jct_dV_sbulk_si)/Vtm0)/NJTS_t);
T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dTemp_t_GND*1.0e+3);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_si_bi*1.0e+3);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_bi*1.0e+3);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_gi_bi*1.0e+3);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_sbulk_si*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ibs_dTemp_t_GND = (d_Ibs_dTemp_t_GND-((ASeff*JTSS_t)*d_T1_dTemp_t_GND+(ASeff*d_JTSS_t_dTemp_t_GND+d_ASeff_dTemp_t_GND*JTSS_t)*T1));
d_Ibs_dV_si_bi = (d_Ibs_dV_si_bi-(ASeff*JTSS_t)*d_T1_dV_si_bi);
d_Ibs_dV_di_bi = (d_Ibs_dV_di_bi-(ASeff*JTSS_t)*d_T1_dV_di_bi);
d_Ibs_dV_gi_bi = (d_Ibs_dV_gi_bi-(ASeff*JTSS_t)*d_T1_dV_gi_bi);
d_Ibs_dV_sbulk_si = (d_Ibs_dV_sbulk_si-(ASeff*JTSS_t)*d_T1_dV_sbulk_si);
Ibs = (Ibs-((ASeff*JTSS_t)*T1));
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbs_jct)/Vtm0)*d_NJTS_t_dTemp_t_GND/NJTS_t/NJTS_t);
d_T0_dV_sbulk_si = (((-d_Vbs_jct_dV_sbulk_si)/Vtm0)/NJTS_t);
T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)),(d_T0_dTemp_t_GND*(model_.VTSS)/((model_.VTSS)-Vbs_jct)));
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)),(d_T0_dV_si_bi*(model_.VTSS)/((model_.VTSS)-Vbs_jct)));
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)),(d_T0_dV_di_bi*(model_.VTSS)/((model_.VTSS)-Vbs_jct)));
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)),(d_T0_dV_gi_bi*(model_.VTSS)/((model_.VTSS)-Vbs_jct)));
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)),((((model_.VTSS)-Vbs_jct)*d_T0_dV_sbulk_si*(model_.VTSS)-(T0*(model_.VTSS))*(-d_Vbs_jct_dV_sbulk_si))/((model_.VTSS)-Vbs_jct)/((model_.VTSS)-Vbs_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSS))/((model_.VTSS)-Vbs_jct)))-1.0);
}

d_Ibs_dTemp_t_GND = (d_Ibs_dTemp_t_GND-((ASeff*JTSS_t)*d_T1_dTemp_t_GND+(ASeff*d_JTSS_t_dTemp_t_GND+d_ASeff_dTemp_t_GND*JTSS_t)*T1));
d_Ibs_dV_si_bi = (d_Ibs_dV_si_bi-(ASeff*JTSS_t)*d_T1_dV_si_bi);
d_Ibs_dV_di_bi = (d_Ibs_dV_di_bi-(ASeff*JTSS_t)*d_T1_dV_di_bi);
d_Ibs_dV_gi_bi = (d_Ibs_dV_gi_bi-(ASeff*JTSS_t)*d_T1_dV_gi_bi);
d_Ibs_dV_sbulk_si = (d_Ibs_dV_sbulk_si-(ASeff*JTSS_t)*d_T1_dV_sbulk_si);
Ibs = (Ibs-((ASeff*JTSS_t)*T1));
}
}
if ((JTSSWS_t>0.0))
{
if ((((model_.VTSSWS)-Vbs_jct)<((model_.VTSSWS)*1.0e-3)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbs_jct)/Vtm0)*d_NJTSSW_t_dTemp_t_GND/NJTSSW_t/NJTSSW_t);
d_T0_dV_sbulk_si = (((-d_Vbs_jct_dV_sbulk_si)/Vtm0)/NJTSSW_t);
T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dTemp_t_GND*1.0e+3);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_si_bi*1.0e+3);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_bi*1.0e+3);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_gi_bi*1.0e+3);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_sbulk_si*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ibs_dTemp_t_GND = (d_Ibs_dTemp_t_GND-((PSeff*JTSSWS_t)*d_T1_dTemp_t_GND+(PSeff*d_JTSSWS_t_dTemp_t_GND+d_PSeff_dTemp_t_GND*JTSSWS_t)*T1));
d_Ibs_dV_si_bi = (d_Ibs_dV_si_bi-(PSeff*JTSSWS_t)*d_T1_dV_si_bi);
d_Ibs_dV_di_bi = (d_Ibs_dV_di_bi-(PSeff*JTSSWS_t)*d_T1_dV_di_bi);
d_Ibs_dV_gi_bi = (d_Ibs_dV_gi_bi-(PSeff*JTSSWS_t)*d_T1_dV_gi_bi);
d_Ibs_dV_sbulk_si = (d_Ibs_dV_sbulk_si-(PSeff*JTSSWS_t)*d_T1_dV_sbulk_si);
Ibs = (Ibs-((PSeff*JTSSWS_t)*T1));
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbs_jct)/Vtm0)*d_NJTSSW_t_dTemp_t_GND/NJTSSW_t/NJTSSW_t);
d_T0_dV_sbulk_si = (((-d_Vbs_jct_dV_sbulk_si)/Vtm0)/NJTSSW_t);
T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)),(d_T0_dTemp_t_GND*(model_.VTSSWS)/((model_.VTSSWS)-Vbs_jct)));
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)),(d_T0_dV_si_bi*(model_.VTSSWS)/((model_.VTSSWS)-Vbs_jct)));
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)),(d_T0_dV_di_bi*(model_.VTSSWS)/((model_.VTSSWS)-Vbs_jct)));
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)),(d_T0_dV_gi_bi*(model_.VTSSWS)/((model_.VTSSWS)-Vbs_jct)));
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)),((((model_.VTSSWS)-Vbs_jct)*d_T0_dV_sbulk_si*(model_.VTSSWS)-(T0*(model_.VTSSWS))*(-d_Vbs_jct_dV_sbulk_si))/((model_.VTSSWS)-Vbs_jct)/((model_.VTSSWS)-Vbs_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWS))/((model_.VTSSWS)-Vbs_jct)))-1.0);
}

d_Ibs_dTemp_t_GND = (d_Ibs_dTemp_t_GND-((PSeff*JTSSWS_t)*d_T1_dTemp_t_GND+(PSeff*d_JTSSWS_t_dTemp_t_GND+d_PSeff_dTemp_t_GND*JTSSWS_t)*T1));
d_Ibs_dV_si_bi = (d_Ibs_dV_si_bi-(PSeff*JTSSWS_t)*d_T1_dV_si_bi);
d_Ibs_dV_di_bi = (d_Ibs_dV_di_bi-(PSeff*JTSSWS_t)*d_T1_dV_di_bi);
d_Ibs_dV_gi_bi = (d_Ibs_dV_gi_bi-(PSeff*JTSSWS_t)*d_T1_dV_gi_bi);
d_Ibs_dV_sbulk_si = (d_Ibs_dV_sbulk_si-(PSeff*JTSSWS_t)*d_T1_dV_sbulk_si);
Ibs = (Ibs-((PSeff*JTSSWS_t)*T1));
}
}
if ((JTSSWGS_t>0.0))
{
if ((((model_.VTSSWGS)-Vbs_jct)<((model_.VTSSWGS)*1.0e-3)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbs_jct)/Vtm0)*d_NJTSSWG_t_dTemp_t_GND/NJTSSWG_t/NJTSSWG_t);
d_T0_dV_sbulk_si = (((-d_Vbs_jct_dV_sbulk_si)/Vtm0)/NJTSSWG_t);
T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dTemp_t_GND*1.0e+3);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_si_bi*1.0e+3);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_bi*1.0e+3);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_gi_bi*1.0e+3);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_sbulk_si*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ibs_dTemp_t_GND = (d_Ibs_dTemp_t_GND-(((Weffcj*NF)*JTSSWGS_t)*d_T1_dTemp_t_GND+(Weffcj*NF)*d_JTSSWGS_t_dTemp_t_GND*T1));
d_Ibs_dV_si_bi = (d_Ibs_dV_si_bi-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_si_bi);
d_Ibs_dV_di_bi = (d_Ibs_dV_di_bi-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_di_bi);
d_Ibs_dV_gi_bi = (d_Ibs_dV_gi_bi-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_gi_bi);
d_Ibs_dV_sbulk_si = (d_Ibs_dV_sbulk_si-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_sbulk_si);
Ibs = (Ibs-(((Weffcj*NF)*JTSSWGS_t)*T1));
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbs_jct)/Vtm0)*d_NJTSSWG_t_dTemp_t_GND/NJTSSWG_t/NJTSSWG_t);
d_T0_dV_sbulk_si = (((-d_Vbs_jct_dV_sbulk_si)/Vtm0)/NJTSSWG_t);
T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)),(d_T0_dTemp_t_GND*(model_.VTSSWGS)/((model_.VTSSWGS)-Vbs_jct)));
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)),(d_T0_dV_si_bi*(model_.VTSSWGS)/((model_.VTSSWGS)-Vbs_jct)));
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)),(d_T0_dV_di_bi*(model_.VTSSWGS)/((model_.VTSSWGS)-Vbs_jct)));
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)),(d_T0_dV_gi_bi*(model_.VTSSWGS)/((model_.VTSSWGS)-Vbs_jct)));
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)),((((model_.VTSSWGS)-Vbs_jct)*d_T0_dV_sbulk_si*(model_.VTSSWGS)-(T0*(model_.VTSSWGS))*(-d_Vbs_jct_dV_sbulk_si))/((model_.VTSSWGS)-Vbs_jct)/((model_.VTSSWGS)-Vbs_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-Vbs_jct)))-1.0);
}

d_Ibs_dTemp_t_GND = (d_Ibs_dTemp_t_GND-(((Weffcj*NF)*JTSSWGS_t)*d_T1_dTemp_t_GND+(Weffcj*NF)*d_JTSSWGS_t_dTemp_t_GND*T1));
d_Ibs_dV_si_bi = (d_Ibs_dV_si_bi-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_si_bi);
d_Ibs_dV_di_bi = (d_Ibs_dV_di_bi-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_di_bi);
d_Ibs_dV_gi_bi = (d_Ibs_dV_gi_bi-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_gi_bi);
d_Ibs_dV_sbulk_si = (d_Ibs_dV_sbulk_si-((Weffcj*NF)*JTSSWGS_t)*d_T1_dV_sbulk_si);
Ibs = (Ibs-(((Weffcj*NF)*JTSSWGS_t)*T1));
}
}
if ((Isbd>0.0))
{
if ((Vbd_jct<VjdmRev))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-Vbd_jct*d_Nvtmd_dTemp_t_GND/Nvtmd/Nvtmd);
d_T0_dV_dbulk_di = (d_Vbd_jct_dV_dbulk_di/Nvtmd);
T0 = (Vbd_jct/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(T0,d_T0_dTemp_t_GND);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(T0,d_T0_dV_si_bi);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_bi);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(T0,d_T0_dV_gi_bi);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_sbulk_si);
d_T1_dV_dbulk_di = evaluator_lexp_0.getDerivs(T0,d_T0_dV_dbulk_di);
T1 = (evaluator_lexp_0.getValues(T0)-1.0);
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi =  0.0;
d_T2_dV_dbulk_di = DslpRev*d_Vbd_jct_dV_dbulk_di;
d_T2_dTemp_t_GND = (d_IVjdmRev_dTemp_t_GND+(DslpRev*(-d_VjdmRev_dTemp_t_GND)+d_DslpRev_dTemp_t_GND*(Vbd_jct-VjdmRev)));
T2 = (IVjdmRev+(DslpRev*(Vbd_jct-VjdmRev)));

d_Ibd_dTemp_t_GND = (T1*d_T2_dTemp_t_GND+d_T1_dTemp_t_GND*T2);
d_Ibd_dV_si_bi = (T1*d_T2_dV_si_bi+d_T1_dV_si_bi*T2);
d_Ibd_dV_di_bi = (T1*d_T2_dV_di_bi+d_T1_dV_di_bi*T2);
d_Ibd_dV_gi_bi = (T1*d_T2_dV_gi_bi+d_T1_dV_gi_bi*T2);
d_Ibd_dV_sbulk_si = (T1*d_T2_dV_sbulk_si+d_T1_dV_sbulk_si*T2);
d_Ibd_dV_dbulk_di = (T1*d_T2_dV_dbulk_di+d_T1_dV_dbulk_di*T2);
Ibd = (T1*T2);
}
else
{
if ((Vbd_jct<=VjdmFwd))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-Vbd_jct*d_Nvtmd_dTemp_t_GND/Nvtmd/Nvtmd);
d_T0_dV_dbulk_di = (d_Vbd_jct_dV_dbulk_di/Nvtmd);
T0 = (Vbd_jct/Nvtmd);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-((model_.BVD)+Vbd_jct)*d_Nvtmd_dTemp_t_GND/Nvtmd/Nvtmd);
d_T1_dV_dbulk_di = (d_Vbd_jct_dV_dbulk_di/Nvtmd);
T1 = (((model_.BVD)+Vbd_jct)/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dTemp_t_GND));
d_T2_dV_si_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_si_bi));
d_T2_dV_di_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_bi));
d_T2_dV_gi_bi = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_gi_bi));
d_T2_dV_sbulk_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_sbulk_si));
d_T2_dV_dbulk_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_dbulk_di));
T2 = evaluator_lexp_0.getValues((-T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_Ibd_dV_si_bi = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_si_bi)-(model_.XJBVD)*d_T2_dV_si_bi);
d_Ibd_dV_di_bi = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_bi)-(model_.XJBVD)*d_T2_dV_di_bi);
d_Ibd_dV_gi_bi = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_gi_bi)-(model_.XJBVD)*d_T2_dV_gi_bi);
d_Ibd_dV_sbulk_si = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_sbulk_si)-(model_.XJBVD)*d_T2_dV_sbulk_si);
d_Ibd_dV_dbulk_di = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_dbulk_di)-(model_.XJBVD)*d_T2_dV_dbulk_di);
d_Ibd_dTemp_t_GND = (Isbd*((evaluator_lexp_0.getDerivs(T0,d_T0_dTemp_t_GND)+d_XExpBVD_dTemp_t_GND)-(model_.XJBVD)*d_T2_dTemp_t_GND)+d_Isbd_dTemp_t_GND*(((evaluator_lexp_0.getValues(T0)+XExpBVD)-1.0)-((model_.XJBVD)*T2)));
Ibd = (Isbd*(((evaluator_lexp_0.getValues(T0)+XExpBVD)-1.0)-((model_.XJBVD)*T2)));
}
}
else
{

d_Ibd_dV_sbulk_si = d_Ibd_dV_gi_bi = d_Ibd_dV_di_bi = d_Ibd_dV_si_bi =  0.0;
d_Ibd_dV_dbulk_di = DslpFwd*d_Vbd_jct_dV_dbulk_di;
d_Ibd_dTemp_t_GND = (d_IVjdmFwd_dTemp_t_GND+(DslpFwd*(-d_VjdmFwd_dTemp_t_GND)+d_DslpFwd_dTemp_t_GND*(Vbd_jct-VjdmFwd)));
Ibd = (IVjdmFwd+(DslpFwd*(Vbd_jct-VjdmFwd)));
}
}
}
else
{

d_Ibd_dV_dbulk_di = d_Ibd_dV_sbulk_si = d_Ibd_dV_gi_bi = d_Ibd_dV_di_bi = d_Ibd_dV_si_bi = d_Ibd_dTemp_t_GND =  0.0;
Ibd = 0.0;
}
if ((JTSD_t>0.0))
{
if ((((model_.VTSD)-Vbd_jct)<((model_.VTSD)*1.0e-3)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbd_jct)/Vtm0)*d_NJTSD_t_dTemp_t_GND/NJTSD_t/NJTSD_t);
d_T0_dV_dbulk_di = (((-d_Vbd_jct_dV_dbulk_di)/Vtm0)/NJTSD_t);
T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dTemp_t_GND*1.0e+3);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_si_bi*1.0e+3);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_bi*1.0e+3);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_gi_bi*1.0e+3);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_sbulk_si*1.0e+3);
d_T1_dV_dbulk_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_dbulk_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ibd_dTemp_t_GND = (d_Ibd_dTemp_t_GND-((ADeff*JTSD_t)*d_T1_dTemp_t_GND+(ADeff*d_JTSD_t_dTemp_t_GND+d_ADeff_dTemp_t_GND*JTSD_t)*T1));
d_Ibd_dV_si_bi = (d_Ibd_dV_si_bi-(ADeff*JTSD_t)*d_T1_dV_si_bi);
d_Ibd_dV_di_bi = (d_Ibd_dV_di_bi-(ADeff*JTSD_t)*d_T1_dV_di_bi);
d_Ibd_dV_gi_bi = (d_Ibd_dV_gi_bi-(ADeff*JTSD_t)*d_T1_dV_gi_bi);
d_Ibd_dV_sbulk_si = (d_Ibd_dV_sbulk_si-(ADeff*JTSD_t)*d_T1_dV_sbulk_si);
d_Ibd_dV_dbulk_di = (d_Ibd_dV_dbulk_di-(ADeff*JTSD_t)*d_T1_dV_dbulk_di);
Ibd = (Ibd-((ADeff*JTSD_t)*T1));
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbd_jct)/Vtm0)*d_NJTSD_t_dTemp_t_GND/NJTSD_t/NJTSD_t);
d_T0_dV_dbulk_di = (((-d_Vbd_jct_dV_dbulk_di)/Vtm0)/NJTSD_t);
T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)));

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)),(d_T0_dTemp_t_GND*(model_.VTSD)/((model_.VTSD)-Vbd_jct)));
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)),(d_T0_dV_si_bi*(model_.VTSD)/((model_.VTSD)-Vbd_jct)));
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)),(d_T0_dV_di_bi*(model_.VTSD)/((model_.VTSD)-Vbd_jct)));
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)),(d_T0_dV_gi_bi*(model_.VTSD)/((model_.VTSD)-Vbd_jct)));
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)),(d_T0_dV_sbulk_si*(model_.VTSD)/((model_.VTSD)-Vbd_jct)));
d_T1_dV_dbulk_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)),((((model_.VTSD)-Vbd_jct)*d_T0_dV_dbulk_di*(model_.VTSD)-(T0*(model_.VTSD))*(-d_Vbd_jct_dV_dbulk_di))/((model_.VTSD)-Vbd_jct)/((model_.VTSD)-Vbd_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSD))/((model_.VTSD)-Vbd_jct)))-1.0);
}

d_Ibd_dTemp_t_GND = (d_Ibd_dTemp_t_GND-((ADeff*JTSD_t)*d_T1_dTemp_t_GND+(ADeff*d_JTSD_t_dTemp_t_GND+d_ADeff_dTemp_t_GND*JTSD_t)*T1));
d_Ibd_dV_si_bi = (d_Ibd_dV_si_bi-(ADeff*JTSD_t)*d_T1_dV_si_bi);
d_Ibd_dV_di_bi = (d_Ibd_dV_di_bi-(ADeff*JTSD_t)*d_T1_dV_di_bi);
d_Ibd_dV_gi_bi = (d_Ibd_dV_gi_bi-(ADeff*JTSD_t)*d_T1_dV_gi_bi);
d_Ibd_dV_sbulk_si = (d_Ibd_dV_sbulk_si-(ADeff*JTSD_t)*d_T1_dV_sbulk_si);
d_Ibd_dV_dbulk_di = (d_Ibd_dV_dbulk_di-(ADeff*JTSD_t)*d_T1_dV_dbulk_di);
Ibd = (Ibd-((ADeff*JTSD_t)*T1));
}
}
if ((JTSSWD_t>0.0))
{
if ((((model_.VTSSWD)-Vbd_jct)<((model_.VTSSWD)*1.0e-3)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbd_jct)/Vtm0)*d_NJTSSWD_t_dTemp_t_GND/NJTSSWD_t/NJTSSWD_t);
d_T0_dV_dbulk_di = (((-d_Vbd_jct_dV_dbulk_di)/Vtm0)/NJTSSWD_t);
T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dTemp_t_GND*1.0e+3);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_si_bi*1.0e+3);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_bi*1.0e+3);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_gi_bi*1.0e+3);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_sbulk_si*1.0e+3);
d_T1_dV_dbulk_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_dbulk_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ibd_dTemp_t_GND = (d_Ibd_dTemp_t_GND-((PDeff*JTSSWD_t)*d_T1_dTemp_t_GND+(PDeff*d_JTSSWD_t_dTemp_t_GND+d_PDeff_dTemp_t_GND*JTSSWD_t)*T1));
d_Ibd_dV_si_bi = (d_Ibd_dV_si_bi-(PDeff*JTSSWD_t)*d_T1_dV_si_bi);
d_Ibd_dV_di_bi = (d_Ibd_dV_di_bi-(PDeff*JTSSWD_t)*d_T1_dV_di_bi);
d_Ibd_dV_gi_bi = (d_Ibd_dV_gi_bi-(PDeff*JTSSWD_t)*d_T1_dV_gi_bi);
d_Ibd_dV_sbulk_si = (d_Ibd_dV_sbulk_si-(PDeff*JTSSWD_t)*d_T1_dV_sbulk_si);
d_Ibd_dV_dbulk_di = (d_Ibd_dV_dbulk_di-(PDeff*JTSSWD_t)*d_T1_dV_dbulk_di);
Ibd = (Ibd-((PDeff*JTSSWD_t)*T1));
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbd_jct)/Vtm0)*d_NJTSSWD_t_dTemp_t_GND/NJTSSWD_t/NJTSSWD_t);
d_T0_dV_dbulk_di = (((-d_Vbd_jct_dV_dbulk_di)/Vtm0)/NJTSSWD_t);
T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)));

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)),(d_T0_dTemp_t_GND*(model_.VTSSWD)/((model_.VTSSWD)-Vbd_jct)));
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)),(d_T0_dV_si_bi*(model_.VTSSWD)/((model_.VTSSWD)-Vbd_jct)));
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)),(d_T0_dV_di_bi*(model_.VTSSWD)/((model_.VTSSWD)-Vbd_jct)));
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)),(d_T0_dV_gi_bi*(model_.VTSSWD)/((model_.VTSSWD)-Vbd_jct)));
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)),(d_T0_dV_sbulk_si*(model_.VTSSWD)/((model_.VTSSWD)-Vbd_jct)));
d_T1_dV_dbulk_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)),((((model_.VTSSWD)-Vbd_jct)*d_T0_dV_dbulk_di*(model_.VTSSWD)-(T0*(model_.VTSSWD))*(-d_Vbd_jct_dV_dbulk_di))/((model_.VTSSWD)-Vbd_jct)/((model_.VTSSWD)-Vbd_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWD))/((model_.VTSSWD)-Vbd_jct)))-1.0);
}

d_Ibd_dTemp_t_GND = (d_Ibd_dTemp_t_GND-((PDeff*JTSSWD_t)*d_T1_dTemp_t_GND+(PDeff*d_JTSSWD_t_dTemp_t_GND+d_PDeff_dTemp_t_GND*JTSSWD_t)*T1));
d_Ibd_dV_si_bi = (d_Ibd_dV_si_bi-(PDeff*JTSSWD_t)*d_T1_dV_si_bi);
d_Ibd_dV_di_bi = (d_Ibd_dV_di_bi-(PDeff*JTSSWD_t)*d_T1_dV_di_bi);
d_Ibd_dV_gi_bi = (d_Ibd_dV_gi_bi-(PDeff*JTSSWD_t)*d_T1_dV_gi_bi);
d_Ibd_dV_sbulk_si = (d_Ibd_dV_sbulk_si-(PDeff*JTSSWD_t)*d_T1_dV_sbulk_si);
d_Ibd_dV_dbulk_di = (d_Ibd_dV_dbulk_di-(PDeff*JTSSWD_t)*d_T1_dV_dbulk_di);
Ibd = (Ibd-((PDeff*JTSSWD_t)*T1));
}
}
if ((JTSSWGD_t>0.0))
{
if ((((model_.VTSSWGD)-Vbd_jct)<((model_.VTSSWGD)*1.0e-3)))
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbd_jct)/Vtm0)*d_NJTSSWGD_t_dTemp_t_GND/NJTSSWGD_t/NJTSSWGD_t);
d_T0_dV_dbulk_di = (((-d_Vbd_jct_dV_dbulk_di)/Vtm0)/NJTSSWGD_t);
T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dTemp_t_GND*1.0e+3);
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_si_bi*1.0e+3);
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_bi*1.0e+3);
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_gi_bi*1.0e+3);
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_sbulk_si*1.0e+3);
d_T1_dV_dbulk_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_dbulk_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ibd_dTemp_t_GND = (d_Ibd_dTemp_t_GND-(((Weffcj*NF)*JTSSWGD_t)*d_T1_dTemp_t_GND+(Weffcj*NF)*d_JTSSWGD_t_dTemp_t_GND*T1));
d_Ibd_dV_si_bi = (d_Ibd_dV_si_bi-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_si_bi);
d_Ibd_dV_di_bi = (d_Ibd_dV_di_bi-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_di_bi);
d_Ibd_dV_gi_bi = (d_Ibd_dV_gi_bi-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_gi_bi);
d_Ibd_dV_sbulk_si = (d_Ibd_dV_sbulk_si-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_sbulk_si);
d_Ibd_dV_dbulk_di = (d_Ibd_dV_dbulk_di-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_dbulk_di);
Ibd = (Ibd-(((Weffcj*NF)*JTSSWGD_t)*T1));
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (-((-Vbd_jct)/Vtm0)*d_NJTSSWGD_t_dTemp_t_GND/NJTSSWGD_t/NJTSSWGD_t);
d_T0_dV_dbulk_di = (((-d_Vbd_jct_dV_dbulk_di)/Vtm0)/NJTSSWGD_t);
T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)));

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)),(d_T0_dTemp_t_GND*(model_.VTSSWGD)/((model_.VTSSWGD)-Vbd_jct)));
d_T1_dV_si_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)),(d_T0_dV_si_bi*(model_.VTSSWGD)/((model_.VTSSWGD)-Vbd_jct)));
d_T1_dV_di_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)),(d_T0_dV_di_bi*(model_.VTSSWGD)/((model_.VTSSWGD)-Vbd_jct)));
d_T1_dV_gi_bi = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)),(d_T0_dV_gi_bi*(model_.VTSSWGD)/((model_.VTSSWGD)-Vbd_jct)));
d_T1_dV_sbulk_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)),(d_T0_dV_sbulk_si*(model_.VTSSWGD)/((model_.VTSSWGD)-Vbd_jct)));
d_T1_dV_dbulk_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)),((((model_.VTSSWGD)-Vbd_jct)*d_T0_dV_dbulk_di*(model_.VTSSWGD)-(T0*(model_.VTSSWGD))*(-d_Vbd_jct_dV_dbulk_di))/((model_.VTSSWGD)-Vbd_jct)/((model_.VTSSWGD)-Vbd_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-Vbd_jct)))-1.0);
}

d_Ibd_dTemp_t_GND = (d_Ibd_dTemp_t_GND-(((Weffcj*NF)*JTSSWGD_t)*d_T1_dTemp_t_GND+(Weffcj*NF)*d_JTSSWGD_t_dTemp_t_GND*T1));
d_Ibd_dV_si_bi = (d_Ibd_dV_si_bi-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_si_bi);
d_Ibd_dV_di_bi = (d_Ibd_dV_di_bi-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_di_bi);
d_Ibd_dV_gi_bi = (d_Ibd_dV_gi_bi-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_gi_bi);
d_Ibd_dV_sbulk_si = (d_Ibd_dV_sbulk_si-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_sbulk_si);
d_Ibd_dV_dbulk_di = (d_Ibd_dV_dbulk_di-((Weffcj*NF)*JTSSWGD_t)*d_T1_dV_dbulk_di);
Ibd = (Ibd-(((Weffcj*NF)*JTSSWGD_t)*T1));
}
}
if ((Czbs>0.0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-Vbs_jct*d_PBS_t_dTemp_t_GND/PBS_t/PBS_t);
d_T1_dV_sbulk_si = (d_Vbs_jct_dV_sbulk_si/PBS_t);
T1 = (Vbs_jct/PBS_t);
if ((T1<0.9))
{

d_arg_dTemp_t_GND = (-d_T1_dTemp_t_GND);
d_arg_dV_si_bi = (-d_T1_dV_si_bi);
d_arg_dV_di_bi = (-d_T1_dV_di_bi);
d_arg_dV_gi_bi = (-d_T1_dV_gi_bi);
d_arg_dV_sbulk_si = (-d_T1_dV_sbulk_si);
d_arg_dV_dbulk_di = (-d_T1_dV_dbulk_di);
arg = (1.0-T1);
if (((model_.MJS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dTemp_t_GND = (-(deriv_sqrt_0_d0*(d_arg_dTemp_t_GND))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_si_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_si_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_di_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_di_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_gi_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_gi_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_sbulk_si = (-(deriv_sqrt_0_d0*(d_arg_dV_sbulk_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_dbulk_di = (-(deriv_sqrt_0_d0*(d_arg_dV_dbulk_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));

d_sarg_dTemp_t_GND = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dTemp_t_GND));
d_sarg_dV_si_bi = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_si_bi));
d_sarg_dV_di_bi = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_bi));
d_sarg_dV_gi_bi = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_gi_bi));
d_sarg_dV_sbulk_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_sbulk_si));
d_sarg_dV_dbulk_di = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_dbulk_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qbs_dV_si_bi = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_si_bi+d_arg_dV_si_bi*sarg))/(1.0-(model_.MJS)));
d_Qbs_dV_di_bi = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_di_bi+d_arg_dV_di_bi*sarg))/(1.0-(model_.MJS)));
d_Qbs_dV_gi_bi = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_gi_bi+d_arg_dV_gi_bi*sarg))/(1.0-(model_.MJS)));
d_Qbs_dV_sbulk_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_sbulk_si+d_arg_dV_sbulk_si*sarg))/(1.0-(model_.MJS)));
d_Qbs_dV_dbulk_di = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_dbulk_di+d_arg_dV_dbulk_di*sarg))/(1.0-(model_.MJS)));
d_Qbs_dTemp_t_GND = (((PBS_t*Czbs)*(-(arg*d_sarg_dTemp_t_GND+d_arg_dTemp_t_GND*sarg))+(PBS_t*d_Czbs_dTemp_t_GND+d_PBS_t_dTemp_t_GND*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
Qbs = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
}
else
{
{
double value_pow_0 = pow(0.1,(-(model_.MJS)));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = value_pow_0;
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
T3 = (1.0/(1.0-(model_.MJS)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dTemp_t_GND+(T2*d_T1_dTemp_t_GND+d_T2_dTemp_t_GND*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_si_bi = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_si_bi+(T2*d_T1_dV_si_bi+d_T2_dV_si_bi*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_di_bi = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_di_bi+(T2*d_T1_dV_di_bi+d_T2_dV_di_bi*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_gi_bi = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_gi_bi+(T2*d_T1_dV_gi_bi+d_T2_dV_gi_bi*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_sbulk_si = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_sbulk_si+(T2*d_T1_dV_sbulk_si+d_T2_dV_sbulk_si*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_dbulk_di = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_dbulk_di+(T2*d_T1_dV_dbulk_di+d_T2_dV_dbulk_di*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dV_sbulk_si = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_sbulk_si)+d_T3_dV_sbulk_si*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_dbulk_di = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_dbulk_di)+d_T3_dV_dbulk_di*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dTemp_t_GND = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dTemp_t_GND)+d_T3_dTemp_t_GND*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_si_bi = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_si_bi)+d_T3_dV_si_bi*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_di_bi = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_di_bi)+d_T3_dV_di_bi*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_gi_bi = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_gi_bi)+d_T3_dV_gi_bi*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));

d_Qbs_dV_si_bi = (PBS_t*Czbs)*(d_T4_dV_si_bi+d_T5_dV_si_bi);
d_Qbs_dV_di_bi = (PBS_t*Czbs)*(d_T4_dV_di_bi+d_T5_dV_di_bi);
d_Qbs_dV_gi_bi = (PBS_t*Czbs)*(d_T4_dV_gi_bi+d_T5_dV_gi_bi);
d_Qbs_dV_sbulk_si = (PBS_t*Czbs)*(d_T4_dV_sbulk_si+d_T5_dV_sbulk_si);
d_Qbs_dV_dbulk_di = (PBS_t*Czbs)*(d_T4_dV_dbulk_di+d_T5_dV_dbulk_di);
d_Qbs_dTemp_t_GND = ((PBS_t*Czbs)*(d_T4_dTemp_t_GND+d_T5_dTemp_t_GND)+(PBS_t*d_Czbs_dTemp_t_GND+d_PBS_t_dTemp_t_GND*Czbs)*(T4+T5));
Qbs = ((PBS_t*Czbs)*(T4+T5));
}
}
else
{

d_Qbs_dTemp_t_GND = d_Qbs_dV_dbulk_di = d_Qbs_dV_sbulk_si = d_Qbs_dV_gi_bi = d_Qbs_dV_di_bi = d_Qbs_dV_si_bi =  0.0;
Qbs = 0.0;
}
if ((Czbssw>0.0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-Vbs_jct*d_PBSWS_t_dTemp_t_GND/PBSWS_t/PBSWS_t);
d_T1_dV_sbulk_si = (d_Vbs_jct_dV_sbulk_si/PBSWS_t);
T1 = (Vbs_jct/PBSWS_t);
if ((T1<0.9))
{

d_arg_dTemp_t_GND = (-d_T1_dTemp_t_GND);
d_arg_dV_si_bi = (-d_T1_dV_si_bi);
d_arg_dV_di_bi = (-d_T1_dV_di_bi);
d_arg_dV_gi_bi = (-d_T1_dV_gi_bi);
d_arg_dV_sbulk_si = (-d_T1_dV_sbulk_si);
d_arg_dV_dbulk_di = (-d_T1_dV_dbulk_di);
arg = (1.0-T1);
if (((model_.MJSWS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dTemp_t_GND = (-(deriv_sqrt_0_d0*(d_arg_dTemp_t_GND))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_si_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_si_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_di_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_di_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_gi_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_gi_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_sbulk_si = (-(deriv_sqrt_0_d0*(d_arg_dV_sbulk_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_dbulk_di = (-(deriv_sqrt_0_d0*(d_arg_dV_dbulk_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));

d_sarg_dTemp_t_GND = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dTemp_t_GND));
d_sarg_dV_si_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_si_bi));
d_sarg_dV_di_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_bi));
d_sarg_dV_gi_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_gi_bi));
d_sarg_dV_sbulk_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_sbulk_si));
d_sarg_dV_dbulk_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_dbulk_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qbs_dV_si_bi = (d_Qbs_dV_si_bi+((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_si_bi+d_arg_dV_si_bi*sarg))/(1.0-(model_.MJSWS))));
d_Qbs_dV_di_bi = (d_Qbs_dV_di_bi+((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_di_bi+d_arg_dV_di_bi*sarg))/(1.0-(model_.MJSWS))));
d_Qbs_dV_gi_bi = (d_Qbs_dV_gi_bi+((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_gi_bi+d_arg_dV_gi_bi*sarg))/(1.0-(model_.MJSWS))));
d_Qbs_dV_sbulk_si = (d_Qbs_dV_sbulk_si+((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_sbulk_si+d_arg_dV_sbulk_si*sarg))/(1.0-(model_.MJSWS))));
d_Qbs_dV_dbulk_di = (d_Qbs_dV_dbulk_di+((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_dbulk_di+d_arg_dV_dbulk_di*sarg))/(1.0-(model_.MJSWS))));
d_Qbs_dTemp_t_GND = (d_Qbs_dTemp_t_GND+(((PBSWS_t*Czbssw)*(-(arg*d_sarg_dTemp_t_GND+d_arg_dTemp_t_GND*sarg))+(PBSWS_t*d_Czbssw_dTemp_t_GND+d_PBSWS_t_dTemp_t_GND*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS))));
Qbs = (Qbs+(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS))));
}
else
{
{
double value_pow_0 = pow(0.1,(-(model_.MJSWS)));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = value_pow_0;
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
T3 = (1.0/(1.0-(model_.MJSWS)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dTemp_t_GND+(T2*d_T1_dTemp_t_GND+d_T2_dTemp_t_GND*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_si_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_si_bi+(T2*d_T1_dV_si_bi+d_T2_dV_si_bi*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_di_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_di_bi+(T2*d_T1_dV_di_bi+d_T2_dV_di_bi*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_gi_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_gi_bi+(T2*d_T1_dV_gi_bi+d_T2_dV_gi_bi*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_sbulk_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_sbulk_si+(T2*d_T1_dV_sbulk_si+d_T2_dV_sbulk_si*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_dbulk_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_dbulk_di+(T2*d_T1_dV_dbulk_di+d_T2_dV_dbulk_di*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dV_sbulk_si = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_sbulk_si)+d_T3_dV_sbulk_si*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_dbulk_di = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_dbulk_di)+d_T3_dV_dbulk_di*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dTemp_t_GND = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dTemp_t_GND)+d_T3_dTemp_t_GND*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_si_bi = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_si_bi)+d_T3_dV_si_bi*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_di_bi = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_di_bi)+d_T3_dV_di_bi*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_gi_bi = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_gi_bi)+d_T3_dV_gi_bi*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));

d_Qbs_dV_si_bi = (d_Qbs_dV_si_bi+(PBSWS_t*Czbssw)*(d_T4_dV_si_bi+d_T5_dV_si_bi));
d_Qbs_dV_di_bi = (d_Qbs_dV_di_bi+(PBSWS_t*Czbssw)*(d_T4_dV_di_bi+d_T5_dV_di_bi));
d_Qbs_dV_gi_bi = (d_Qbs_dV_gi_bi+(PBSWS_t*Czbssw)*(d_T4_dV_gi_bi+d_T5_dV_gi_bi));
d_Qbs_dV_sbulk_si = (d_Qbs_dV_sbulk_si+(PBSWS_t*Czbssw)*(d_T4_dV_sbulk_si+d_T5_dV_sbulk_si));
d_Qbs_dV_dbulk_di = (d_Qbs_dV_dbulk_di+(PBSWS_t*Czbssw)*(d_T4_dV_dbulk_di+d_T5_dV_dbulk_di));
d_Qbs_dTemp_t_GND = (d_Qbs_dTemp_t_GND+((PBSWS_t*Czbssw)*(d_T4_dTemp_t_GND+d_T5_dTemp_t_GND)+(PBSWS_t*d_Czbssw_dTemp_t_GND+d_PBSWS_t_dTemp_t_GND*Czbssw)*(T4+T5)));
Qbs = (Qbs+((PBSWS_t*Czbssw)*(T4+T5)));
}
}
if ((Czbsswg>0.0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-Vbs_jct*d_PBSWGS_t_dTemp_t_GND/PBSWGS_t/PBSWGS_t);
d_T1_dV_sbulk_si = (d_Vbs_jct_dV_sbulk_si/PBSWGS_t);
T1 = (Vbs_jct/PBSWGS_t);
if ((T1<0.9))
{

d_arg_dTemp_t_GND = (-d_T1_dTemp_t_GND);
d_arg_dV_si_bi = (-d_T1_dV_si_bi);
d_arg_dV_di_bi = (-d_T1_dV_di_bi);
d_arg_dV_gi_bi = (-d_T1_dV_gi_bi);
d_arg_dV_sbulk_si = (-d_T1_dV_sbulk_si);
d_arg_dV_dbulk_di = (-d_T1_dV_dbulk_di);
arg = (1.0-T1);
if (((model_.MJSWGS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dTemp_t_GND = (-(deriv_sqrt_0_d0*(d_arg_dTemp_t_GND))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_si_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_si_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_di_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_di_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_gi_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_gi_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_sbulk_si = (-(deriv_sqrt_0_d0*(d_arg_dV_sbulk_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_dbulk_di = (-(deriv_sqrt_0_d0*(d_arg_dV_dbulk_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));

d_sarg_dTemp_t_GND = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dTemp_t_GND));
d_sarg_dV_si_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_si_bi));
d_sarg_dV_di_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_bi));
d_sarg_dV_gi_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_gi_bi));
d_sarg_dV_sbulk_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_sbulk_si));
d_sarg_dV_dbulk_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_dbulk_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qbs_dV_si_bi = (d_Qbs_dV_si_bi+((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_si_bi+d_arg_dV_si_bi*sarg))/(1.0-(model_.MJSWGS))));
d_Qbs_dV_di_bi = (d_Qbs_dV_di_bi+((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_di_bi+d_arg_dV_di_bi*sarg))/(1.0-(model_.MJSWGS))));
d_Qbs_dV_gi_bi = (d_Qbs_dV_gi_bi+((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_gi_bi+d_arg_dV_gi_bi*sarg))/(1.0-(model_.MJSWGS))));
d_Qbs_dV_sbulk_si = (d_Qbs_dV_sbulk_si+((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_sbulk_si+d_arg_dV_sbulk_si*sarg))/(1.0-(model_.MJSWGS))));
d_Qbs_dV_dbulk_di = (d_Qbs_dV_dbulk_di+((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_dbulk_di+d_arg_dV_dbulk_di*sarg))/(1.0-(model_.MJSWGS))));
d_Qbs_dTemp_t_GND = (d_Qbs_dTemp_t_GND+(((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dTemp_t_GND+d_arg_dTemp_t_GND*sarg))+(PBSWGS_t*d_Czbsswg_dTemp_t_GND+d_PBSWGS_t_dTemp_t_GND*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS))));
Qbs = (Qbs+(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS))));
}
else
{
{
double value_pow_0 = pow(0.1,(-(model_.MJSWGS)));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = value_pow_0;
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
T3 = (1.0/(1.0-(model_.MJSWGS)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dTemp_t_GND+(T2*d_T1_dTemp_t_GND+d_T2_dTemp_t_GND*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_si_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_si_bi+(T2*d_T1_dV_si_bi+d_T2_dV_si_bi*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_di_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_di_bi+(T2*d_T1_dV_di_bi+d_T2_dV_di_bi*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_gi_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_gi_bi+(T2*d_T1_dV_gi_bi+d_T2_dV_gi_bi*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_sbulk_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_sbulk_si+(T2*d_T1_dV_sbulk_si+d_T2_dV_sbulk_si*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_dbulk_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_dbulk_di+(T2*d_T1_dV_dbulk_di+d_T2_dV_dbulk_di*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dV_sbulk_si = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_sbulk_si)+d_T3_dV_sbulk_si*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_dbulk_di = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_dbulk_di)+d_T3_dV_dbulk_di*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dTemp_t_GND = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dTemp_t_GND)+d_T3_dTemp_t_GND*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_si_bi = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_si_bi)+d_T3_dV_si_bi*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_di_bi = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_di_bi)+d_T3_dV_di_bi*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_gi_bi = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_gi_bi)+d_T3_dV_gi_bi*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));

d_Qbs_dV_si_bi = (d_Qbs_dV_si_bi+(PBSWGS_t*Czbsswg)*(d_T4_dV_si_bi+d_T5_dV_si_bi));
d_Qbs_dV_di_bi = (d_Qbs_dV_di_bi+(PBSWGS_t*Czbsswg)*(d_T4_dV_di_bi+d_T5_dV_di_bi));
d_Qbs_dV_gi_bi = (d_Qbs_dV_gi_bi+(PBSWGS_t*Czbsswg)*(d_T4_dV_gi_bi+d_T5_dV_gi_bi));
d_Qbs_dV_sbulk_si = (d_Qbs_dV_sbulk_si+(PBSWGS_t*Czbsswg)*(d_T4_dV_sbulk_si+d_T5_dV_sbulk_si));
d_Qbs_dV_dbulk_di = (d_Qbs_dV_dbulk_di+(PBSWGS_t*Czbsswg)*(d_T4_dV_dbulk_di+d_T5_dV_dbulk_di));
d_Qbs_dTemp_t_GND = (d_Qbs_dTemp_t_GND+((PBSWGS_t*Czbsswg)*(d_T4_dTemp_t_GND+d_T5_dTemp_t_GND)+(PBSWGS_t*d_Czbsswg_dTemp_t_GND+d_PBSWGS_t_dTemp_t_GND*Czbsswg)*(T4+T5)));
Qbs = (Qbs+((PBSWGS_t*Czbsswg)*(T4+T5)));
}
}
if ((Czbd>0.0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-Vbd_jct*d_PBD_t_dTemp_t_GND/PBD_t/PBD_t);
d_T1_dV_dbulk_di = (d_Vbd_jct_dV_dbulk_di/PBD_t);
T1 = (Vbd_jct/PBD_t);
if ((T1<0.9))
{

d_arg_dTemp_t_GND = (-d_T1_dTemp_t_GND);
d_arg_dV_si_bi = (-d_T1_dV_si_bi);
d_arg_dV_di_bi = (-d_T1_dV_di_bi);
d_arg_dV_gi_bi = (-d_T1_dV_gi_bi);
d_arg_dV_sbulk_si = (-d_T1_dV_sbulk_si);
d_arg_dV_dbulk_di = (-d_T1_dV_dbulk_di);
arg = (1.0-T1);
if (((model_.MJD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dTemp_t_GND = (-(deriv_sqrt_0_d0*(d_arg_dTemp_t_GND))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_si_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_si_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_di_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_di_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_gi_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_gi_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_sbulk_si = (-(deriv_sqrt_0_d0*(d_arg_dV_sbulk_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_dbulk_di = (-(deriv_sqrt_0_d0*(d_arg_dV_dbulk_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));

d_sarg_dTemp_t_GND = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dTemp_t_GND));
d_sarg_dV_si_bi = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_si_bi));
d_sarg_dV_di_bi = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_bi));
d_sarg_dV_gi_bi = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_gi_bi));
d_sarg_dV_sbulk_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_sbulk_si));
d_sarg_dV_dbulk_di = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_dbulk_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qbd_dV_si_bi = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_si_bi+d_arg_dV_si_bi*sarg))/(1.0-(model_.MJD)));
d_Qbd_dV_di_bi = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_di_bi+d_arg_dV_di_bi*sarg))/(1.0-(model_.MJD)));
d_Qbd_dV_gi_bi = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_gi_bi+d_arg_dV_gi_bi*sarg))/(1.0-(model_.MJD)));
d_Qbd_dV_sbulk_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_sbulk_si+d_arg_dV_sbulk_si*sarg))/(1.0-(model_.MJD)));
d_Qbd_dV_dbulk_di = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_dbulk_di+d_arg_dV_dbulk_di*sarg))/(1.0-(model_.MJD)));
d_Qbd_dTemp_t_GND = (((PBD_t*Czbd)*(-(arg*d_sarg_dTemp_t_GND+d_arg_dTemp_t_GND*sarg))+(PBD_t*d_Czbd_dTemp_t_GND+d_PBD_t_dTemp_t_GND*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
Qbd = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
}
else
{
{
double value_pow_0 = pow(0.1,(-(model_.MJD)));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = value_pow_0;
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
T3 = (1.0/(1.0-(model_.MJD)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dTemp_t_GND+(T2*d_T1_dTemp_t_GND+d_T2_dTemp_t_GND*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_si_bi = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_si_bi+(T2*d_T1_dV_si_bi+d_T2_dV_si_bi*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_di_bi = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_di_bi+(T2*d_T1_dV_di_bi+d_T2_dV_di_bi*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_gi_bi = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_gi_bi+(T2*d_T1_dV_gi_bi+d_T2_dV_gi_bi*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_sbulk_si = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_sbulk_si+(T2*d_T1_dV_sbulk_si+d_T2_dV_sbulk_si*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_dbulk_di = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_dbulk_di+(T2*d_T1_dV_dbulk_di+d_T2_dV_dbulk_di*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dV_sbulk_si = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_sbulk_si)+d_T3_dV_sbulk_si*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_dbulk_di = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_dbulk_di)+d_T3_dV_dbulk_di*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dTemp_t_GND = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dTemp_t_GND)+d_T3_dTemp_t_GND*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_si_bi = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_si_bi)+d_T3_dV_si_bi*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_di_bi = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_di_bi)+d_T3_dV_di_bi*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_gi_bi = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_gi_bi)+d_T3_dV_gi_bi*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));

d_Qbd_dV_si_bi = (PBD_t*Czbd)*(d_T4_dV_si_bi+d_T5_dV_si_bi);
d_Qbd_dV_di_bi = (PBD_t*Czbd)*(d_T4_dV_di_bi+d_T5_dV_di_bi);
d_Qbd_dV_gi_bi = (PBD_t*Czbd)*(d_T4_dV_gi_bi+d_T5_dV_gi_bi);
d_Qbd_dV_sbulk_si = (PBD_t*Czbd)*(d_T4_dV_sbulk_si+d_T5_dV_sbulk_si);
d_Qbd_dV_dbulk_di = (PBD_t*Czbd)*(d_T4_dV_dbulk_di+d_T5_dV_dbulk_di);
d_Qbd_dTemp_t_GND = ((PBD_t*Czbd)*(d_T4_dTemp_t_GND+d_T5_dTemp_t_GND)+(PBD_t*d_Czbd_dTemp_t_GND+d_PBD_t_dTemp_t_GND*Czbd)*(T4+T5));
Qbd = ((PBD_t*Czbd)*(T4+T5));
}
}
else
{

d_Qbd_dTemp_t_GND = d_Qbd_dV_dbulk_di = d_Qbd_dV_sbulk_si = d_Qbd_dV_gi_bi = d_Qbd_dV_di_bi = d_Qbd_dV_si_bi =  0.0;
Qbd = 0.0;
}
if ((Czbdsw>0.0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-Vbd_jct*d_PBSWD_t_dTemp_t_GND/PBSWD_t/PBSWD_t);
d_T1_dV_dbulk_di = (d_Vbd_jct_dV_dbulk_di/PBSWD_t);
T1 = (Vbd_jct/PBSWD_t);
if ((T1<0.9))
{

d_arg_dTemp_t_GND = (-d_T1_dTemp_t_GND);
d_arg_dV_si_bi = (-d_T1_dV_si_bi);
d_arg_dV_di_bi = (-d_T1_dV_di_bi);
d_arg_dV_gi_bi = (-d_T1_dV_gi_bi);
d_arg_dV_sbulk_si = (-d_T1_dV_sbulk_si);
d_arg_dV_dbulk_di = (-d_T1_dV_dbulk_di);
arg = (1.0-T1);
if (((model_.MJSWD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dTemp_t_GND = (-(deriv_sqrt_0_d0*(d_arg_dTemp_t_GND))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_si_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_si_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_di_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_di_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_gi_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_gi_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_sbulk_si = (-(deriv_sqrt_0_d0*(d_arg_dV_sbulk_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_dbulk_di = (-(deriv_sqrt_0_d0*(d_arg_dV_dbulk_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));

d_sarg_dTemp_t_GND = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dTemp_t_GND));
d_sarg_dV_si_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_si_bi));
d_sarg_dV_di_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_bi));
d_sarg_dV_gi_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_gi_bi));
d_sarg_dV_sbulk_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_sbulk_si));
d_sarg_dV_dbulk_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_dbulk_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qbd_dV_si_bi = (d_Qbd_dV_si_bi+((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_si_bi+d_arg_dV_si_bi*sarg))/(1.0-(model_.MJSWD))));
d_Qbd_dV_di_bi = (d_Qbd_dV_di_bi+((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_di_bi+d_arg_dV_di_bi*sarg))/(1.0-(model_.MJSWD))));
d_Qbd_dV_gi_bi = (d_Qbd_dV_gi_bi+((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_gi_bi+d_arg_dV_gi_bi*sarg))/(1.0-(model_.MJSWD))));
d_Qbd_dV_sbulk_si = (d_Qbd_dV_sbulk_si+((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_sbulk_si+d_arg_dV_sbulk_si*sarg))/(1.0-(model_.MJSWD))));
d_Qbd_dV_dbulk_di = (d_Qbd_dV_dbulk_di+((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_dbulk_di+d_arg_dV_dbulk_di*sarg))/(1.0-(model_.MJSWD))));
d_Qbd_dTemp_t_GND = (d_Qbd_dTemp_t_GND+(((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dTemp_t_GND+d_arg_dTemp_t_GND*sarg))+(PBSWD_t*d_Czbdsw_dTemp_t_GND+d_PBSWD_t_dTemp_t_GND*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD))));
Qbd = (Qbd+(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD))));
}
else
{
{
double value_pow_0 = pow(0.1,(-(model_.MJSWD)));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = value_pow_0;
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
T3 = (1.0/(1.0-(model_.MJSWD)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dTemp_t_GND+(T2*d_T1_dTemp_t_GND+d_T2_dTemp_t_GND*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_si_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_si_bi+(T2*d_T1_dV_si_bi+d_T2_dV_si_bi*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_di_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_di_bi+(T2*d_T1_dV_di_bi+d_T2_dV_di_bi*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_gi_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_gi_bi+(T2*d_T1_dV_gi_bi+d_T2_dV_gi_bi*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_sbulk_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_sbulk_si+(T2*d_T1_dV_sbulk_si+d_T2_dV_sbulk_si*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_dbulk_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_dbulk_di+(T2*d_T1_dV_dbulk_di+d_T2_dV_dbulk_di*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dV_sbulk_si = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_sbulk_si)+d_T3_dV_sbulk_si*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_dbulk_di = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_dbulk_di)+d_T3_dV_dbulk_di*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dTemp_t_GND = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dTemp_t_GND)+d_T3_dTemp_t_GND*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_si_bi = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_si_bi)+d_T3_dV_si_bi*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_di_bi = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_di_bi)+d_T3_dV_di_bi*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_gi_bi = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_gi_bi)+d_T3_dV_gi_bi*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));

d_Qbd_dV_si_bi = (d_Qbd_dV_si_bi+(PBSWD_t*Czbdsw)*(d_T4_dV_si_bi+d_T5_dV_si_bi));
d_Qbd_dV_di_bi = (d_Qbd_dV_di_bi+(PBSWD_t*Czbdsw)*(d_T4_dV_di_bi+d_T5_dV_di_bi));
d_Qbd_dV_gi_bi = (d_Qbd_dV_gi_bi+(PBSWD_t*Czbdsw)*(d_T4_dV_gi_bi+d_T5_dV_gi_bi));
d_Qbd_dV_sbulk_si = (d_Qbd_dV_sbulk_si+(PBSWD_t*Czbdsw)*(d_T4_dV_sbulk_si+d_T5_dV_sbulk_si));
d_Qbd_dV_dbulk_di = (d_Qbd_dV_dbulk_di+(PBSWD_t*Czbdsw)*(d_T4_dV_dbulk_di+d_T5_dV_dbulk_di));
d_Qbd_dTemp_t_GND = (d_Qbd_dTemp_t_GND+((PBSWD_t*Czbdsw)*(d_T4_dTemp_t_GND+d_T5_dTemp_t_GND)+(PBSWD_t*d_Czbdsw_dTemp_t_GND+d_PBSWD_t_dTemp_t_GND*Czbdsw)*(T4+T5)));
Qbd = (Qbd+((PBSWD_t*Czbdsw)*(T4+T5)));
}
}
if ((Czbdswg>0.0))
{

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi =  0.0;
d_T1_dTemp_t_GND = (-Vbd_jct*d_PBSWGD_t_dTemp_t_GND/PBSWGD_t/PBSWGD_t);
d_T1_dV_dbulk_di = (d_Vbd_jct_dV_dbulk_di/PBSWGD_t);
T1 = (Vbd_jct/PBSWGD_t);
if ((T1<0.9))
{

d_arg_dTemp_t_GND = (-d_T1_dTemp_t_GND);
d_arg_dV_si_bi = (-d_T1_dV_si_bi);
d_arg_dV_di_bi = (-d_T1_dV_di_bi);
d_arg_dV_gi_bi = (-d_T1_dV_gi_bi);
d_arg_dV_sbulk_si = (-d_T1_dV_sbulk_si);
d_arg_dV_dbulk_di = (-d_T1_dV_dbulk_di);
arg = (1.0-T1);
if (((model_.MJSWGD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dTemp_t_GND = (-(deriv_sqrt_0_d0*(d_arg_dTemp_t_GND))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_si_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_si_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_di_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_di_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_gi_bi = (-(deriv_sqrt_0_d0*(d_arg_dV_gi_bi))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_sbulk_si = (-(deriv_sqrt_0_d0*(d_arg_dV_sbulk_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_dbulk_di = (-(deriv_sqrt_0_d0*(d_arg_dV_dbulk_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));

d_sarg_dTemp_t_GND = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dTemp_t_GND));
d_sarg_dV_si_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_si_bi));
d_sarg_dV_di_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_bi));
d_sarg_dV_gi_bi = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_gi_bi));
d_sarg_dV_sbulk_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_sbulk_si));
d_sarg_dV_dbulk_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_dbulk_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qbd_dV_si_bi = (d_Qbd_dV_si_bi+((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_si_bi+d_arg_dV_si_bi*sarg))/(1.0-(model_.MJSWGD))));
d_Qbd_dV_di_bi = (d_Qbd_dV_di_bi+((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_di_bi+d_arg_dV_di_bi*sarg))/(1.0-(model_.MJSWGD))));
d_Qbd_dV_gi_bi = (d_Qbd_dV_gi_bi+((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_gi_bi+d_arg_dV_gi_bi*sarg))/(1.0-(model_.MJSWGD))));
d_Qbd_dV_sbulk_si = (d_Qbd_dV_sbulk_si+((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_sbulk_si+d_arg_dV_sbulk_si*sarg))/(1.0-(model_.MJSWGD))));
d_Qbd_dV_dbulk_di = (d_Qbd_dV_dbulk_di+((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_dbulk_di+d_arg_dV_dbulk_di*sarg))/(1.0-(model_.MJSWGD))));
d_Qbd_dTemp_t_GND = (d_Qbd_dTemp_t_GND+(((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dTemp_t_GND+d_arg_dTemp_t_GND*sarg))+(PBSWGD_t*d_Czbdswg_dTemp_t_GND+d_PBSWGD_t_dTemp_t_GND*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD))));
Qbd = (Qbd+(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD))));
}
else
{
{
double value_pow_0 = pow(0.1,(-(model_.MJSWGD)));

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = value_pow_0;
}

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si = d_T3_dV_gi_bi = d_T3_dV_di_bi = d_T3_dV_si_bi = d_T3_dTemp_t_GND =  0.0;
T3 = (1.0/(1.0-(model_.MJSWGD)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dTemp_t_GND+(T2*d_T1_dTemp_t_GND+d_T2_dTemp_t_GND*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_si_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_si_bi+(T2*d_T1_dV_si_bi+d_T2_dV_si_bi*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_di_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_di_bi+(T2*d_T1_dV_di_bi+d_T2_dV_di_bi*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_gi_bi = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_gi_bi+(T2*d_T1_dV_gi_bi+d_T2_dV_gi_bi*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_sbulk_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_sbulk_si+(T2*d_T1_dV_sbulk_si+d_T2_dV_sbulk_si*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_dbulk_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_dbulk_di+(T2*d_T1_dV_dbulk_di+d_T2_dV_dbulk_di*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dV_sbulk_si = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_sbulk_si)+d_T3_dV_sbulk_si*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_dbulk_di = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_dbulk_di)+d_T3_dV_dbulk_di*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dTemp_t_GND = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dTemp_t_GND)+d_T3_dTemp_t_GND*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_si_bi = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_si_bi)+d_T3_dV_si_bi*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_di_bi = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_di_bi)+d_T3_dV_di_bi*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_gi_bi = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_gi_bi)+d_T3_dV_gi_bi*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));

d_Qbd_dV_si_bi = (d_Qbd_dV_si_bi+(PBSWGD_t*Czbdswg)*(d_T4_dV_si_bi+d_T5_dV_si_bi));
d_Qbd_dV_di_bi = (d_Qbd_dV_di_bi+(PBSWGD_t*Czbdswg)*(d_T4_dV_di_bi+d_T5_dV_di_bi));
d_Qbd_dV_gi_bi = (d_Qbd_dV_gi_bi+(PBSWGD_t*Czbdswg)*(d_T4_dV_gi_bi+d_T5_dV_gi_bi));
d_Qbd_dV_sbulk_si = (d_Qbd_dV_sbulk_si+(PBSWGD_t*Czbdswg)*(d_T4_dV_sbulk_si+d_T5_dV_sbulk_si));
d_Qbd_dV_dbulk_di = (d_Qbd_dV_dbulk_di+(PBSWGD_t*Czbdswg)*(d_T4_dV_dbulk_di+d_T5_dV_dbulk_di));
d_Qbd_dTemp_t_GND = (d_Qbd_dTemp_t_GND+((PBSWGD_t*Czbdswg)*(d_T4_dTemp_t_GND+d_T5_dTemp_t_GND)+(PBSWGD_t*d_Czbdswg_dTemp_t_GND+d_PBSWGD_t_dTemp_t_GND*Czbdswg)*(T4+T5)));
Qbd = (Qbd+((PBSWGD_t*Czbdswg)*(T4+T5)));
}
}

d_Nt_dTemp_t_GND = 4.0*d_Vt_dTemp_t_GND*1.60219e-19;
Nt = ((4.0*Vt)*1.60219e-19);
if (((model_.LINTNOI)>=(Leff/2.0)))
{
UserInfo(*this)  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << " " << (model_.LINTNOI) << " " <<  std::endl; 
LINTNOI_i = 0;
}
else
{
LINTNOI_i = (model_.LINTNOI);
}

d_Esatnoi_dV_gi_bi = (-(2.0*VSAT_a)*d_ueff_dV_gi_bi/ueff/ueff);
d_Esatnoi_dV_si_bi = ((ueff*2.0*d_VSAT_a_dV_si_bi-(2.0*VSAT_a)*d_ueff_dV_si_bi)/ueff/ueff);
d_Esatnoi_dV_di_bi = ((ueff*2.0*d_VSAT_a_dV_di_bi-(2.0*VSAT_a)*d_ueff_dV_di_bi)/ueff/ueff);
d_Esatnoi_dTemp_t_GND = ((ueff*2.0*d_VSAT_a_dTemp_t_GND-(2.0*VSAT_a)*d_ueff_dTemp_t_GND)/ueff/ueff);
Esatnoi = ((2.0*VSAT_a)/ueff);
if (((((model_.NOIA)>0)||((model_.NOIB)>0))||((model_.NOIC)>0)))
{
Leffnoi = (Leff-(2.0*LINTNOI_i));
Leffnoisq = (Leffnoi*Leffnoi);
if (((model_.EM)<=0.0))
{

d_DelClm_dV_dbulk_di = d_DelClm_dV_sbulk_si = d_DelClm_dV_gi_bi = d_DelClm_dV_di_bi = d_DelClm_dV_si_bi = d_DelClm_dTemp_t_GND =  0.0;
DelClm = 0.0;
}
else
{

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dTemp_t_GND = ((Esatnoi*(d_diffVds_dTemp_t_GND/litl)-((diffVds/litl)+(model_.EM))*d_Esatnoi_dTemp_t_GND)/Esatnoi/Esatnoi);
d_T0_dV_gi_bi = ((Esatnoi*(d_diffVds_dV_gi_bi/litl)-((diffVds/litl)+(model_.EM))*d_Esatnoi_dV_gi_bi)/Esatnoi/Esatnoi);
d_T0_dV_si_bi = ((Esatnoi*(d_diffVds_dV_si_bi/litl)-((diffVds/litl)+(model_.EM))*d_Esatnoi_dV_si_bi)/Esatnoi/Esatnoi);
d_T0_dV_di_bi = ((Esatnoi*(d_diffVds_dV_di_bi/litl)-((diffVds/litl)+(model_.EM))*d_Esatnoi_dV_di_bi)/Esatnoi/Esatnoi);
T0 = (((diffVds/litl)+(model_.EM))/Esatnoi);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(T0);

d_DelClm_dTemp_t_GND = litl*evaluator_lln_0.getDerivs(T0,d_T0_dTemp_t_GND);
d_DelClm_dV_si_bi = litl*evaluator_lln_0.getDerivs(T0,d_T0_dV_si_bi);
d_DelClm_dV_di_bi = litl*evaluator_lln_0.getDerivs(T0,d_T0_dV_di_bi);
d_DelClm_dV_gi_bi = litl*evaluator_lln_0.getDerivs(T0,d_T0_dV_gi_bi);
d_DelClm_dV_sbulk_si = litl*evaluator_lln_0.getDerivs(T0,d_T0_dV_sbulk_si);
d_DelClm_dV_dbulk_di = litl*evaluator_lln_0.getDerivs(T0,d_T0_dV_dbulk_di);
DelClm = (litl*evaluator_lln_0.getValues(T0));
}
if ((DelClm<0.0))
{

d_DelClm_dV_dbulk_di = d_DelClm_dV_sbulk_si = d_DelClm_dV_gi_bi = d_DelClm_dV_di_bi = d_DelClm_dV_si_bi = d_DelClm_dTemp_t_GND =  0.0;
DelClm = 0.0;
}
}
{
double value_fabs_0 = fabs(ids);
double  deriv_fabs_0_d0 = (((ids)>=0)?(+1.0):(-1.0));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dV_si_bi = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*value_fabs_0)*d_ueff_dV_si_bi+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(deriv_fabs_0_d0*(d_ids_dV_si_bi))*ueff);
d_T1_dV_di_bi = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*value_fabs_0)*d_ueff_dV_di_bi+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(deriv_fabs_0_d0*(d_ids_dV_di_bi))*ueff);
d_T1_dV_gi_bi = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*value_fabs_0)*d_ueff_dV_gi_bi+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(deriv_fabs_0_d0*(d_ids_dV_gi_bi))*ueff);
d_T1_dTemp_t_GND = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*value_fabs_0)*d_ueff_dTemp_t_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*(deriv_fabs_0_d0*(d_ids_dTemp_t_GND))+((1.60219e-19*1.60219e-19)*1.60219e-19)*d_Vt_dTemp_t_GND*value_fabs_0)*ueff);
T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*value_fabs_0)*ueff);
}

d_T2_dV_gm_di = d_T2_dV_gm_si = d_T2_dV_dbulk_di = d_T2_dV_sbulk_si = d_T2_dV_gi_bi = d_T2_dV_di_bi = d_T2_dV_si_bi = d_T2_dTemp_t_GND =  0.0;
T2 = ((1.0e10*Cox)*Leffnoisq);

d_N0_dV_si_bi = (((((2.0*nq)*Cox)*Vt)*d_qs_dV_si_bi+2.0*d_nq_dV_si_bi*Cox*Vt*qs)/1.60219e-19);
d_N0_dV_di_bi = (((((2.0*nq)*Cox)*Vt)*d_qs_dV_di_bi+2.0*d_nq_dV_di_bi*Cox*Vt*qs)/1.60219e-19);
d_N0_dTemp_t_GND = (((((2.0*nq)*Cox)*Vt)*d_qs_dTemp_t_GND+(((2.0*nq)*Cox)*d_Vt_dTemp_t_GND+2.0*d_nq_dTemp_t_GND*Cox*Vt)*qs)/1.60219e-19);
d_N0_dV_gi_bi = (((((2.0*nq)*Cox)*Vt)*d_qs_dV_gi_bi+2.0*d_nq_dV_gi_bi*Cox*Vt*qs)/1.60219e-19);
N0 = (((((2.0*nq)*Cox)*Vt)*qs)/1.60219e-19);

d_Nl_dV_si_bi = (((((2.0*nq)*Cox)*Vt)*d_qdeff_dV_si_bi+2.0*d_nq_dV_si_bi*Cox*Vt*qdeff)/1.60219e-19);
d_Nl_dV_di_bi = (((((2.0*nq)*Cox)*Vt)*d_qdeff_dV_di_bi+2.0*d_nq_dV_di_bi*Cox*Vt*qdeff)/1.60219e-19);
d_Nl_dTemp_t_GND = (((((2.0*nq)*Cox)*Vt)*d_qdeff_dTemp_t_GND+(((2.0*nq)*Cox)*d_Vt_dTemp_t_GND+2.0*d_nq_dTemp_t_GND*Cox*Vt)*qdeff)/1.60219e-19);
d_Nl_dV_gi_bi = (((((2.0*nq)*Cox)*Vt)*d_qdeff_dV_gi_bi+2.0*d_nq_dV_gi_bi*Cox*Vt*qdeff)/1.60219e-19);
Nl = (((((2.0*nq)*Cox)*Vt)*qdeff)/1.60219e-19);

d_Nstar_dV_si_bi = (Vt/1.60219e-19)*d_Cdep_dV_si_bi;
d_Nstar_dV_di_bi = (Vt/1.60219e-19)*d_Cdep_dV_di_bi;
d_Nstar_dTemp_t_GND = ((Vt/1.60219e-19)*d_Cdep_dTemp_t_GND+(d_Vt_dTemp_t_GND/1.60219e-19)*((Cox+Cdep)+(model_.CIT)));
Nstar = ((Vt/1.60219e-19)*((Cox+Cdep)+(model_.CIT)));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((N0+Nstar)/(Nl+Nstar)));

d_T3_dV_gm_si = d_T3_dV_gm_di = d_T3_dV_dbulk_di = d_T3_dV_sbulk_si =  0.0;
d_T3_dV_si_bi = (model_.NOIA)*evaluator_lln_0.getDerivs(((N0+Nstar)/(Nl+Nstar)),(((Nl+Nstar)*(d_N0_dV_si_bi+d_Nstar_dV_si_bi)-(N0+Nstar)*(d_Nl_dV_si_bi+d_Nstar_dV_si_bi))/(Nl+Nstar)/(Nl+Nstar)));
d_T3_dV_di_bi = (model_.NOIA)*evaluator_lln_0.getDerivs(((N0+Nstar)/(Nl+Nstar)),(((Nl+Nstar)*(d_N0_dV_di_bi+d_Nstar_dV_di_bi)-(N0+Nstar)*(d_Nl_dV_di_bi+d_Nstar_dV_di_bi))/(Nl+Nstar)/(Nl+Nstar)));
d_T3_dTemp_t_GND = (model_.NOIA)*evaluator_lln_0.getDerivs(((N0+Nstar)/(Nl+Nstar)),(((Nl+Nstar)*(d_N0_dTemp_t_GND+d_Nstar_dTemp_t_GND)-(N0+Nstar)*(d_Nl_dTemp_t_GND+d_Nstar_dTemp_t_GND))/(Nl+Nstar)/(Nl+Nstar)));
d_T3_dV_gi_bi = (model_.NOIA)*evaluator_lln_0.getDerivs(((N0+Nstar)/(Nl+Nstar)),(((Nl+Nstar)*d_N0_dV_gi_bi-(N0+Nstar)*d_Nl_dV_gi_bi)/(Nl+Nstar)/(Nl+Nstar)));
T3 = ((model_.NOIA)*evaluator_lln_0.getValues(((N0+Nstar)/(Nl+Nstar))));
}

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si =  0.0;
d_T4_dV_si_bi = (model_.NOIB)*(d_N0_dV_si_bi-d_Nl_dV_si_bi);
d_T4_dV_di_bi = (model_.NOIB)*(d_N0_dV_di_bi-d_Nl_dV_di_bi);
d_T4_dTemp_t_GND = (model_.NOIB)*(d_N0_dTemp_t_GND-d_Nl_dTemp_t_GND);
d_T4_dV_gi_bi = (model_.NOIB)*(d_N0_dV_gi_bi-d_Nl_dV_gi_bi);
T4 = ((model_.NOIB)*(N0-Nl));

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si =  0.0;
d_T5_dV_si_bi = (0.5*(model_.NOIC))*((N0*d_N0_dV_si_bi+d_N0_dV_si_bi*N0)-(Nl*d_Nl_dV_si_bi+d_Nl_dV_si_bi*Nl));
d_T5_dV_di_bi = (0.5*(model_.NOIC))*((N0*d_N0_dV_di_bi+d_N0_dV_di_bi*N0)-(Nl*d_Nl_dV_di_bi+d_Nl_dV_di_bi*Nl));
d_T5_dTemp_t_GND = (0.5*(model_.NOIC))*((N0*d_N0_dTemp_t_GND+d_N0_dTemp_t_GND*N0)-(Nl*d_Nl_dTemp_t_GND+d_Nl_dTemp_t_GND*Nl));
d_T5_dV_gi_bi = (0.5*(model_.NOIC))*((N0*d_N0_dV_gi_bi+d_N0_dV_gi_bi*N0)-(Nl*d_Nl_dV_gi_bi+d_Nl_dV_gi_bi*Nl));
T5 = ((0.5*(model_.NOIC))*((N0*N0)-(Nl*Nl)));

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dV_si_bi = (((1.60219e-19*Vt)*ids)*d_ids_dV_si_bi+(1.60219e-19*Vt)*d_ids_dV_si_bi*ids);
d_T6_dV_di_bi = (((1.60219e-19*Vt)*ids)*d_ids_dV_di_bi+(1.60219e-19*Vt)*d_ids_dV_di_bi*ids);
d_T6_dV_gi_bi = (((1.60219e-19*Vt)*ids)*d_ids_dV_gi_bi+(1.60219e-19*Vt)*d_ids_dV_gi_bi*ids);
d_T6_dTemp_t_GND = (((1.60219e-19*Vt)*ids)*d_ids_dTemp_t_GND+((1.60219e-19*Vt)*d_ids_dTemp_t_GND+1.60219e-19*d_Vt_dTemp_t_GND*ids)*ids);
T6 = (((1.60219e-19*Vt)*ids)*ids);

d_T7_dV_gm_si = d_T7_dV_gm_di = d_T7_dV_dbulk_di = d_T7_dV_sbulk_si = d_T7_dV_gi_bi = d_T7_dV_di_bi = d_T7_dV_si_bi = d_T7_dTemp_t_GND =  0.0;
T7 = (((1.0e10*Leffnoisq)*Weff)*NF);

d_T8_dV_gm_di = d_T8_dV_gm_si = d_T8_dV_dbulk_di = d_T8_dV_sbulk_si =  0.0;
d_T8_dV_si_bi = ((model_.NOIB)*d_Nl_dV_si_bi+(((model_.NOIC)*Nl)*d_Nl_dV_si_bi+(model_.NOIC)*d_Nl_dV_si_bi*Nl));
d_T8_dV_di_bi = ((model_.NOIB)*d_Nl_dV_di_bi+(((model_.NOIC)*Nl)*d_Nl_dV_di_bi+(model_.NOIC)*d_Nl_dV_di_bi*Nl));
d_T8_dTemp_t_GND = ((model_.NOIB)*d_Nl_dTemp_t_GND+(((model_.NOIC)*Nl)*d_Nl_dTemp_t_GND+(model_.NOIC)*d_Nl_dTemp_t_GND*Nl));
d_T8_dV_gi_bi = ((model_.NOIB)*d_Nl_dV_gi_bi+(((model_.NOIC)*Nl)*d_Nl_dV_gi_bi+(model_.NOIC)*d_Nl_dV_gi_bi*Nl));
T8 = (((model_.NOIA)+((model_.NOIB)*Nl))+(((model_.NOIC)*Nl)*Nl));

d_T9_dV_gm_si = d_T9_dV_gm_di = d_T9_dV_dbulk_di = d_T9_dV_sbulk_si =  0.0;
d_T9_dV_si_bi = ((Nl+Nstar)*(d_Nl_dV_si_bi+d_Nstar_dV_si_bi)+(d_Nl_dV_si_bi+d_Nstar_dV_si_bi)*(Nl+Nstar));
d_T9_dV_di_bi = ((Nl+Nstar)*(d_Nl_dV_di_bi+d_Nstar_dV_di_bi)+(d_Nl_dV_di_bi+d_Nstar_dV_di_bi)*(Nl+Nstar));
d_T9_dTemp_t_GND = ((Nl+Nstar)*(d_Nl_dTemp_t_GND+d_Nstar_dTemp_t_GND)+(d_Nl_dTemp_t_GND+d_Nstar_dTemp_t_GND)*(Nl+Nstar));
d_T9_dV_gi_bi = ((Nl+Nstar)*d_Nl_dV_gi_bi+d_Nl_dV_gi_bi*(Nl+Nstar));
T9 = ((Nl+Nstar)*(Nl+Nstar));

d_Ssi_dTemp_t_GND = (((T1/T2)*((d_T3_dTemp_t_GND+d_T4_dTemp_t_GND)+d_T5_dTemp_t_GND)+((T2*d_T1_dTemp_t_GND-T1*d_T2_dTemp_t_GND)/T2/T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dTemp_t_GND+((T6/T7)*d_DelClm_dTemp_t_GND+((T7*d_T6_dTemp_t_GND-T6*d_T7_dTemp_t_GND)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dTemp_t_GND)/T9/T9));
d_Ssi_dV_si_bi = (((T1/T2)*((d_T3_dV_si_bi+d_T4_dV_si_bi)+d_T5_dV_si_bi)+((T2*d_T1_dV_si_bi-T1*d_T2_dV_si_bi)/T2/T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dV_si_bi+((T6/T7)*d_DelClm_dV_si_bi+((T7*d_T6_dV_si_bi-T6*d_T7_dV_si_bi)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dV_si_bi)/T9/T9));
d_Ssi_dV_di_bi = (((T1/T2)*((d_T3_dV_di_bi+d_T4_dV_di_bi)+d_T5_dV_di_bi)+((T2*d_T1_dV_di_bi-T1*d_T2_dV_di_bi)/T2/T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dV_di_bi+((T6/T7)*d_DelClm_dV_di_bi+((T7*d_T6_dV_di_bi-T6*d_T7_dV_di_bi)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dV_di_bi)/T9/T9));
d_Ssi_dV_gi_bi = (((T1/T2)*((d_T3_dV_gi_bi+d_T4_dV_gi_bi)+d_T5_dV_gi_bi)+((T2*d_T1_dV_gi_bi-T1*d_T2_dV_gi_bi)/T2/T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dV_gi_bi+((T6/T7)*d_DelClm_dV_gi_bi+((T7*d_T6_dV_gi_bi-T6*d_T7_dV_gi_bi)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dV_gi_bi)/T9/T9));
d_Ssi_dV_sbulk_si = (((T1/T2)*((d_T3_dV_sbulk_si+d_T4_dV_sbulk_si)+d_T5_dV_sbulk_si)+((T2*d_T1_dV_sbulk_si-T1*d_T2_dV_sbulk_si)/T2/T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dV_sbulk_si+((T6/T7)*d_DelClm_dV_sbulk_si+((T7*d_T6_dV_sbulk_si-T6*d_T7_dV_sbulk_si)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dV_sbulk_si)/T9/T9));
d_Ssi_dV_dbulk_di = (((T1/T2)*((d_T3_dV_dbulk_di+d_T4_dV_dbulk_di)+d_T5_dV_dbulk_di)+((T2*d_T1_dV_dbulk_di-T1*d_T2_dV_dbulk_di)/T2/T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dV_dbulk_di+((T6/T7)*d_DelClm_dV_dbulk_di+((T7*d_T6_dV_dbulk_di-T6*d_T7_dV_dbulk_di)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dV_dbulk_di)/T9/T9));
Ssi = (((T1/T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));

d_T10_dV_dbulk_di = d_T10_dV_sbulk_si = d_T10_dV_gi_bi = d_T10_dV_di_bi = d_T10_dV_si_bi =  0.0;
d_T10_dTemp_t_GND = ((model_.NOIA)*1.60219e-19)*d_Vt_dTemp_t_GND;
T10 = (((model_.NOIA)*1.60219e-19)*Vt);

d_T11_dV_gi_bi =  0.0;
d_T11_dV_si_bi = (((((Weff*NF)*Leffnoi)*1.0e10)*Nstar)*d_Nstar_dV_si_bi+(((Weff*NF)*Leffnoi)*1.0e10)*d_Nstar_dV_si_bi*Nstar);
d_T11_dV_di_bi = (((((Weff*NF)*Leffnoi)*1.0e10)*Nstar)*d_Nstar_dV_di_bi+(((Weff*NF)*Leffnoi)*1.0e10)*d_Nstar_dV_di_bi*Nstar);
d_T11_dTemp_t_GND = (((((Weff*NF)*Leffnoi)*1.0e10)*Nstar)*d_Nstar_dTemp_t_GND+(((Weff*NF)*Leffnoi)*1.0e10)*d_Nstar_dTemp_t_GND*Nstar);
T11 = (((((Weff*NF)*Leffnoi)*1.0e10)*Nstar)*Nstar);

d_Swi_dV_si_bi = (((T10/T11)*ids)*d_ids_dV_si_bi+((T10/T11)*d_ids_dV_si_bi+((T11*d_T10_dV_si_bi-T10*d_T11_dV_si_bi)/T11/T11)*ids)*ids);
d_Swi_dV_di_bi = (((T10/T11)*ids)*d_ids_dV_di_bi+((T10/T11)*d_ids_dV_di_bi+((T11*d_T10_dV_di_bi-T10*d_T11_dV_di_bi)/T11/T11)*ids)*ids);
d_Swi_dV_gi_bi = (((T10/T11)*ids)*d_ids_dV_gi_bi+((T10/T11)*d_ids_dV_gi_bi+((T11*d_T10_dV_gi_bi-T10*d_T11_dV_gi_bi)/T11/T11)*ids)*ids);
d_Swi_dTemp_t_GND = (((T10/T11)*ids)*d_ids_dTemp_t_GND+((T10/T11)*d_ids_dTemp_t_GND+((T11*d_T10_dTemp_t_GND-T10*d_T11_dTemp_t_GND)/T11/T11)*ids)*ids);
Swi = (((T10/T11)*ids)*ids);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dV_sbulk_si = d_Ssi_dV_sbulk_si;
d_T1_dV_dbulk_di = d_Ssi_dV_dbulk_di;
d_T1_dV_si_bi = (d_Swi_dV_si_bi+d_Ssi_dV_si_bi);
d_T1_dV_di_bi = (d_Swi_dV_di_bi+d_Ssi_dV_di_bi);
d_T1_dV_gi_bi = (d_Swi_dV_gi_bi+d_Ssi_dV_gi_bi);
d_T1_dTemp_t_GND = (d_Swi_dTemp_t_GND+d_Ssi_dTemp_t_GND);
T1 = (Swi+Ssi);
if ((T1>0.0))
{
FNPowerAt1Hz = ((Ssi*Swi)/T1);
}
else
{
FNPowerAt1Hz = 0.0;
}
}
else
{
FNPowerAt1Hz = 0.0;
}
// I(di,si) <+ (flicker_noise((m*FNPowerAt1Hz),EF,"1overf"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[0]= (m*FNPowerAt1Hz);
  noiseContribsExponent[0]= (model_.EF);
}

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = (((Esatnoi*d_qia_dV_gi_bi-qia*d_Esatnoi_dV_gi_bi)/Esatnoi/Esatnoi)/Leff);
d_T0_dTemp_t_GND = (((Esatnoi*d_qia_dTemp_t_GND-qia*d_Esatnoi_dTemp_t_GND)/Esatnoi/Esatnoi)/Leff);
d_T0_dV_si_bi = (((Esatnoi*d_qia_dV_si_bi-qia*d_Esatnoi_dV_si_bi)/Esatnoi/Esatnoi)/Leff);
d_T0_dV_di_bi = (((Esatnoi*d_qia_dV_di_bi-qia*d_Esatnoi_dV_di_bi)/Esatnoi/Esatnoi)/Leff);
T0 = ((qia/Esatnoi)/Leff);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = (T0*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*T0);
d_T1_dV_si_bi = (T0*d_T0_dV_si_bi+d_T0_dV_si_bi*T0);
d_T1_dV_di_bi = (T0*d_T0_dV_di_bi+d_T0_dV_di_bi*T0);
d_T1_dV_gi_bi = (T0*d_T0_dV_gi_bi+d_T0_dV_gi_bi*T0);
d_T1_dV_sbulk_si = (T0*d_T0_dV_sbulk_si+d_T0_dV_sbulk_si*T0);
d_T1_dV_dbulk_di = (T0*d_T0_dV_dbulk_di+d_T0_dV_dbulk_di*T0);
T1 = (T0*T0);

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (model_.RNOIA)*((model_.TNOIA)*Leff)*d_T1_dTemp_t_GND;
d_T3_dV_si_bi = (model_.RNOIA)*((model_.TNOIA)*Leff)*d_T1_dV_si_bi;
d_T3_dV_di_bi = (model_.RNOIA)*((model_.TNOIA)*Leff)*d_T1_dV_di_bi;
d_T3_dV_gi_bi = (model_.RNOIA)*((model_.TNOIA)*Leff)*d_T1_dV_gi_bi;
d_T3_dV_sbulk_si = (model_.RNOIA)*((model_.TNOIA)*Leff)*d_T1_dV_sbulk_si;
d_T3_dV_dbulk_di = (model_.RNOIA)*((model_.TNOIA)*Leff)*d_T1_dV_dbulk_di;
T3 = ((model_.RNOIA)*(1.0+(((model_.TNOIA)*Leff)*T1)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = (model_.RNOIB)*((model_.TNOIB)*Leff)*d_T1_dTemp_t_GND;
d_T4_dV_si_bi = (model_.RNOIB)*((model_.TNOIB)*Leff)*d_T1_dV_si_bi;
d_T4_dV_di_bi = (model_.RNOIB)*((model_.TNOIB)*Leff)*d_T1_dV_di_bi;
d_T4_dV_gi_bi = (model_.RNOIB)*((model_.TNOIB)*Leff)*d_T1_dV_gi_bi;
d_T4_dV_sbulk_si = (model_.RNOIB)*((model_.TNOIB)*Leff)*d_T1_dV_sbulk_si;
d_T4_dV_dbulk_di = (model_.RNOIB)*((model_.TNOIB)*Leff)*d_T1_dV_dbulk_di;
T4 = ((model_.RNOIB)*(1.0+(((model_.TNOIB)*Leff)*T1)));
ctnoi = ((model_.RNOIC)*(1.0+(((model_.TNOIC)*Leff)*T1)));

d_betanoisq_dTemp_t_GND = (T3*d_T3_dTemp_t_GND+d_T3_dTemp_t_GND*T3);
d_betanoisq_dV_si_bi = (T3*d_T3_dV_si_bi+d_T3_dV_si_bi*T3);
d_betanoisq_dV_di_bi = (T3*d_T3_dV_di_bi+d_T3_dV_di_bi*T3);
d_betanoisq_dV_gi_bi = (T3*d_T3_dV_gi_bi+d_T3_dV_gi_bi*T3);
d_betanoisq_dV_sbulk_si = (T3*d_T3_dV_sbulk_si+d_T3_dV_sbulk_si*T3);
d_betanoisq_dV_dbulk_di = (T3*d_T3_dV_dbulk_di+d_T3_dV_dbulk_di*T3);
betanoisq = (T3*T3);

d_thetanoisq_dTemp_t_GND = (T4*d_T4_dTemp_t_GND+d_T4_dTemp_t_GND*T4);
d_thetanoisq_dV_si_bi = (T4*d_T4_dV_si_bi+d_T4_dV_si_bi*T4);
d_thetanoisq_dV_di_bi = (T4*d_T4_dV_di_bi+d_T4_dV_di_bi*T4);
d_thetanoisq_dV_gi_bi = (T4*d_T4_dV_gi_bi+d_T4_dV_gi_bi*T4);
d_thetanoisq_dV_sbulk_si = (T4*d_T4_dV_sbulk_si+d_T4_dV_sbulk_si*T4);
d_thetanoisq_dV_dbulk_di = (T4*d_T4_dV_dbulk_di+d_T4_dV_dbulk_di*T4);
thetanoisq = (T4*T4);
cm_igid = 0;
if ( (model_.TNOIMOD) == (0))
{

d_QSi_dV_dbulk_di = d_QSi_dV_sbulk_si =  0.0;
d_QSi_dV_si_bi = (((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qs_dV_si_bi;
d_QSi_dV_di_bi = (((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qs_dV_di_bi;
d_QSi_dV_gi_bi = (((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qs_dV_gi_bi;
d_QSi_dTemp_t_GND = ((((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qs_dTemp_t_GND+((((-NF)*Weff)*Leff)*Cox)*d_Vt_dTemp_t_GND*Qs);
QSi = ((((((-NF)*Weff)*Leff)*Cox)*Vt)*Qs);

d_QDi_dV_dbulk_di = d_QDi_dV_sbulk_si =  0.0;
d_QDi_dV_si_bi = (((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qd_dV_si_bi;
d_QDi_dV_di_bi = (((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qd_dV_di_bi;
d_QDi_dV_gi_bi = (((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qd_dV_gi_bi;
d_QDi_dTemp_t_GND = ((((((-NF)*Weff)*Leff)*Cox)*Vt)*d_Qd_dTemp_t_GND+((((-NF)*Weff)*Leff)*Cox)*d_Vt_dTemp_t_GND*Qd);
QDi = ((((((-NF)*Weff)*Leff)*Cox)*Vt)*Qd);
{
double value_fabs_0 = fabs((QSi+QDi));
double  deriv_fabs_0_d0 = ((((QSi+QDi))>=0)?(+1.0):(-1.0));

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = (ueff*(deriv_fabs_0_d0*((d_QSi_dV_gi_bi+d_QDi_dV_gi_bi)))+d_ueff_dV_gi_bi*value_fabs_0);
d_T0_dV_si_bi = (ueff*(deriv_fabs_0_d0*((d_QSi_dV_si_bi+d_QDi_dV_si_bi)))+d_ueff_dV_si_bi*value_fabs_0);
d_T0_dV_di_bi = (ueff*(deriv_fabs_0_d0*((d_QSi_dV_di_bi+d_QDi_dV_di_bi)))+d_ueff_dV_di_bi*value_fabs_0);
d_T0_dTemp_t_GND = (ueff*(deriv_fabs_0_d0*((d_QSi_dTemp_t_GND+d_QDi_dTemp_t_GND)))+d_ueff_dTemp_t_GND*value_fabs_0);
T0 = (ueff*value_fabs_0);
}

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = (T0*d_Rdsi_dTemp_t_GND+d_T0_dTemp_t_GND*Rdsi);
d_T1_dV_si_bi = (T0*d_Rdsi_dV_si_bi+d_T0_dV_si_bi*Rdsi);
d_T1_dV_di_bi = (T0*d_Rdsi_dV_di_bi+d_T0_dV_di_bi*Rdsi);
d_T1_dV_gi_bi = (T0*d_Rdsi_dV_gi_bi+d_T0_dV_gi_bi*Rdsi);
d_T1_dV_sbulk_si = d_T0_dV_sbulk_si*Rdsi;
d_T1_dV_dbulk_di = d_T0_dV_dbulk_di*Rdsi;
T1 = ((T0*Rdsi)+(Leff*Leff));
Gtnoi = ((T0/T1)*(model_.NTNOI));
sidn = (Nt*Gtnoi);
// I(di,si) <+ (white_noise((m*sidn),"id"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[1]= (m*sidn);
}
}
else
if ( (model_.TNOIMOD) == (1))
{

d_Vtn_dV_si_bi = ((2.0*nq)*d_nVt_dV_si_bi+2.0*d_nq_dV_si_bi*nVt);
d_Vtn_dV_di_bi = ((2.0*nq)*d_nVt_dV_di_bi+2.0*d_nq_dV_di_bi*nVt);
d_Vtn_dTemp_t_GND = ((2.0*nq)*d_nVt_dTemp_t_GND+2.0*d_nq_dTemp_t_GND*nVt);
d_Vtn_dV_gi_bi = ((2.0*nq)*d_nVt_dV_gi_bi+2.0*d_nq_dV_gi_bi*nVt);
Vtn = ((2.0*nq)*nVt);

d_T0_dV_gm_di = d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si =  0.0;
d_T0_dV_gi_bi = ((((ueff*Dptwg)*Moc)*Cox)*d_Vtn_dV_gi_bi+((ueff*Dptwg)*d_Moc_dV_gi_bi+(ueff*d_Dptwg_dV_gi_bi+d_ueff_dV_gi_bi*Dptwg)*Moc)*Cox*Vtn);
d_T0_dV_si_bi = ((((ueff*Dptwg)*Moc)*Cox)*d_Vtn_dV_si_bi+((ueff*Dptwg)*d_Moc_dV_si_bi+(ueff*d_Dptwg_dV_si_bi+d_ueff_dV_si_bi*Dptwg)*Moc)*Cox*Vtn);
d_T0_dV_di_bi = ((((ueff*Dptwg)*Moc)*Cox)*d_Vtn_dV_di_bi+((ueff*Dptwg)*d_Moc_dV_di_bi+(ueff*d_Dptwg_dV_di_bi+d_ueff_dV_di_bi*Dptwg)*Moc)*Cox*Vtn);
d_T0_dTemp_t_GND = ((((ueff*Dptwg)*Moc)*Cox)*d_Vtn_dTemp_t_GND+((ueff*Dptwg)*d_Moc_dTemp_t_GND+(ueff*d_Dptwg_dTemp_t_GND+d_ueff_dTemp_t_GND*Dptwg)*Moc)*Cox*Vtn);
T0 = ((((ueff*Dptwg)*Moc)*Cox)*Vtn);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si =  0.0;
d_T1_dTemp_t_GND = 0.5*(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND);
d_T1_dV_si_bi = 0.5*(d_qs_dV_si_bi+d_qdeff_dV_si_bi);
d_T1_dV_di_bi = 0.5*(d_qs_dV_di_bi+d_qdeff_dV_di_bi);
d_T1_dV_gi_bi = 0.5*(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi);
T1 = (0.5*(qs+qdeff));

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = d_T1_dTemp_t_GND;
d_T3_dV_si_bi = d_T1_dV_si_bi;
d_T3_dV_di_bi = d_T1_dV_di_bi;
d_T3_dV_gi_bi = d_T1_dV_gi_bi;
d_T3_dV_sbulk_si = d_T1_dV_sbulk_si;
d_T3_dV_dbulk_di = d_T1_dV_dbulk_di;
T3 = (T1+0.5);

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = (T3*d_T3_dTemp_t_GND+d_T3_dTemp_t_GND*T3);
d_T4_dV_si_bi = (T3*d_T3_dV_si_bi+d_T3_dV_si_bi*T3);
d_T4_dV_di_bi = (T3*d_T3_dV_di_bi+d_T3_dV_di_bi*T3);
d_T4_dV_gi_bi = (T3*d_T3_dV_gi_bi+d_T3_dV_gi_bi*T3);
d_T4_dV_sbulk_si = (T3*d_T3_dV_sbulk_si+d_T3_dV_sbulk_si*T3);
d_T4_dV_dbulk_di = (T3*d_T3_dV_dbulk_di+d_T3_dV_dbulk_di*T3);
T4 = (T3*T3);

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dTemp_t_GND = (T4*d_T3_dTemp_t_GND+d_T4_dTemp_t_GND*T3);
d_T5_dV_si_bi = (T4*d_T3_dV_si_bi+d_T4_dV_si_bi*T3);
d_T5_dV_di_bi = (T4*d_T3_dV_di_bi+d_T4_dV_di_bi*T3);
d_T5_dV_gi_bi = (T4*d_T3_dV_gi_bi+d_T4_dV_gi_bi*T3);
d_T5_dV_sbulk_si = (T4*d_T3_dV_sbulk_si+d_T4_dV_sbulk_si*T3);
d_T5_dV_dbulk_di = (T4*d_T3_dV_dbulk_di+d_T4_dV_dbulk_di*T3);
T5 = (T4*T3);

d_T6_dV_gm_di = d_T6_dV_gm_si = d_T6_dV_dbulk_di = d_T6_dV_sbulk_si =  0.0;
d_T6_dTemp_t_GND = (d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND);
d_T6_dV_si_bi = (d_qs_dV_si_bi-d_qdeff_dV_si_bi);
d_T6_dV_di_bi = (d_qs_dV_di_bi-d_qdeff_dV_di_bi);
d_T6_dV_gi_bi = (d_qs_dV_gi_bi-d_qdeff_dV_gi_bi);
T6 = (qs-qdeff);

d_T7_dV_gm_si = d_T7_dV_gm_di = d_T7_dV_dbulk_di = d_T7_dV_sbulk_si =  0.0;
d_T7_dTemp_t_GND = (T6*d_T6_dTemp_t_GND+d_T6_dTemp_t_GND*T6);
d_T7_dV_si_bi = (T6*d_T6_dV_si_bi+d_T6_dV_si_bi*T6);
d_T7_dV_di_bi = (T6*d_T6_dV_di_bi+d_T6_dV_di_bi*T6);
d_T7_dV_gi_bi = (T6*d_T6_dV_gi_bi+d_T6_dV_gi_bi*T6);
T7 = (T6*T6);

d_T8_dV_gm_di = d_T8_dV_gm_si = d_T8_dV_dbulk_di = d_T8_dV_sbulk_si =  0.0;
d_T8_dTemp_t_GND = (T7*d_T6_dTemp_t_GND+d_T7_dTemp_t_GND*T6);
d_T8_dV_si_bi = (T7*d_T6_dV_si_bi+d_T7_dV_si_bi*T6);
d_T8_dV_di_bi = (T7*d_T6_dV_di_bi+d_T7_dV_di_bi*T6);
d_T8_dV_gi_bi = (T7*d_T6_dV_gi_bi+d_T7_dV_gi_bi*T6);
T8 = (T7*T6);

d_T9_dV_gm_si = d_T9_dV_gm_di =  0.0;
d_T9_dTemp_t_GND = (((6.0*T1)+0.5)*d_T7_dTemp_t_GND+6.0*d_T1_dTemp_t_GND*T7);
d_T9_dV_si_bi = (((6.0*T1)+0.5)*d_T7_dV_si_bi+6.0*d_T1_dV_si_bi*T7);
d_T9_dV_di_bi = (((6.0*T1)+0.5)*d_T7_dV_di_bi+6.0*d_T1_dV_di_bi*T7);
d_T9_dV_gi_bi = (((6.0*T1)+0.5)*d_T7_dV_gi_bi+6.0*d_T1_dV_gi_bi*T7);
d_T9_dV_sbulk_si = (((6.0*T1)+0.5)*d_T7_dV_sbulk_si+6.0*d_T1_dV_sbulk_si*T7);
d_T9_dV_dbulk_di = (((6.0*T1)+0.5)*d_T7_dV_dbulk_di+6.0*d_T1_dV_dbulk_di*T7);
T9 = (((6.0*T1)+0.5)*T7);

d_Lvsat_dTemp_t_GND = Leff*d_Dptwg_dTemp_t_GND;
d_Lvsat_dV_si_bi = Leff*d_Dptwg_dV_si_bi;
d_Lvsat_dV_di_bi = Leff*d_Dptwg_dV_di_bi;
d_Lvsat_dV_gi_bi = Leff*d_Dptwg_dV_gi_bi;
Lvsat = (Leff*Dptwg);

d_T10_dV_dbulk_di = d_T10_dV_sbulk_si =  0.0;
d_T10_dTemp_t_GND = (d_Lvsat_dTemp_t_GND/Leff);
d_T10_dV_si_bi = (d_Lvsat_dV_si_bi/Leff);
d_T10_dV_di_bi = (d_Lvsat_dV_di_bi/Leff);
d_T10_dV_gi_bi = (d_Lvsat_dV_gi_bi/Leff);
T10 = (Lvsat/Leff);

d_mid_dTemp_t_GND = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*d_betanoisq_dTemp_t_GND+((((T0*NF)*Weff)/Lvsat)*(d_T1_dTemp_t_GND+(((12.0*T3)*d_T7_dTemp_t_GND-T7*12.0*d_T3_dTemp_t_GND)/(12.0*T3)/(12.0*T3)))+((Lvsat*d_T0_dTemp_t_GND*NF*Weff-((T0*NF)*Weff)*d_Lvsat_dTemp_t_GND)/Lvsat/Lvsat)*(T1+(T7/(12.0*T3))))*3.0*betanoisq);
d_mid_dV_si_bi = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*d_betanoisq_dV_si_bi+((((T0*NF)*Weff)/Lvsat)*(d_T1_dV_si_bi+(((12.0*T3)*d_T7_dV_si_bi-T7*12.0*d_T3_dV_si_bi)/(12.0*T3)/(12.0*T3)))+((Lvsat*d_T0_dV_si_bi*NF*Weff-((T0*NF)*Weff)*d_Lvsat_dV_si_bi)/Lvsat/Lvsat)*(T1+(T7/(12.0*T3))))*3.0*betanoisq);
d_mid_dV_di_bi = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*d_betanoisq_dV_di_bi+((((T0*NF)*Weff)/Lvsat)*(d_T1_dV_di_bi+(((12.0*T3)*d_T7_dV_di_bi-T7*12.0*d_T3_dV_di_bi)/(12.0*T3)/(12.0*T3)))+((Lvsat*d_T0_dV_di_bi*NF*Weff-((T0*NF)*Weff)*d_Lvsat_dV_di_bi)/Lvsat/Lvsat)*(T1+(T7/(12.0*T3))))*3.0*betanoisq);
d_mid_dV_gi_bi = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*d_betanoisq_dV_gi_bi+((((T0*NF)*Weff)/Lvsat)*(d_T1_dV_gi_bi+(((12.0*T3)*d_T7_dV_gi_bi-T7*12.0*d_T3_dV_gi_bi)/(12.0*T3)/(12.0*T3)))+((Lvsat*d_T0_dV_gi_bi*NF*Weff-((T0*NF)*Weff)*d_Lvsat_dV_gi_bi)/Lvsat/Lvsat)*(T1+(T7/(12.0*T3))))*3.0*betanoisq);
d_mid_dV_sbulk_si = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*d_betanoisq_dV_sbulk_si+((((T0*NF)*Weff)/Lvsat)*(d_T1_dV_sbulk_si+(((12.0*T3)*d_T7_dV_sbulk_si-T7*12.0*d_T3_dV_sbulk_si)/(12.0*T3)/(12.0*T3)))+(d_T0_dV_sbulk_si*NF*Weff/Lvsat)*(T1+(T7/(12.0*T3))))*3.0*betanoisq);
d_mid_dV_dbulk_di = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*d_betanoisq_dV_dbulk_di+((((T0*NF)*Weff)/Lvsat)*(d_T1_dV_dbulk_di+(((12.0*T3)*d_T7_dV_dbulk_di-T7*12.0*d_T3_dV_dbulk_di)/(12.0*T3)/(12.0*T3)))+(d_T0_dV_dbulk_di*NF*Weff/Lvsat)*(T1+(T7/(12.0*T3))))*3.0*betanoisq);
mid = ((((((T0*NF)*Weff)/Lvsat)*(T1+(T7/(12.0*T3))))*3.0)*betanoisq);

d_mig_dV_sbulk_si = (((((NF*Weff)*12.0)*T0)*((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*d_thetanoisq_dV_sbulk_si+((((Lvsat*T10)*T10)*((((T4*d_T1_dV_sbulk_si-T1*d_T4_dV_sbulk_si)/T4/T4)-((((60.0*T4)*T4)*d_T9_dV_sbulk_si-T9*((60.0*T4)*d_T4_dV_sbulk_si+60.0*d_T4_dV_sbulk_si*T4))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((144.0*T4)*T5)*(T7*d_T7_dV_sbulk_si+d_T7_dV_sbulk_si*T7)-(T7*T7)*((144.0*T4)*d_T5_dV_sbulk_si+144.0*d_T4_dV_sbulk_si*T5))/((144.0*T4)*T5)/((144.0*T4)*T5)))+((Lvsat*T10)*d_T10_dV_sbulk_si+Lvsat*d_T10_dV_sbulk_si*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0/4.0)*thetanoisq)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*((NF*Weff)*12.0)*d_T0_dV_sbulk_si)/(((NF*Weff)*12.0)*T0)/(((NF*Weff)*12.0)*T0));
d_mig_dV_dbulk_di = (((((NF*Weff)*12.0)*T0)*((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*d_thetanoisq_dV_dbulk_di+((((Lvsat*T10)*T10)*((((T4*d_T1_dV_dbulk_di-T1*d_T4_dV_dbulk_di)/T4/T4)-((((60.0*T4)*T4)*d_T9_dV_dbulk_di-T9*((60.0*T4)*d_T4_dV_dbulk_di+60.0*d_T4_dV_dbulk_di*T4))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((144.0*T4)*T5)*(T7*d_T7_dV_dbulk_di+d_T7_dV_dbulk_di*T7)-(T7*T7)*((144.0*T4)*d_T5_dV_dbulk_di+144.0*d_T4_dV_dbulk_di*T5))/((144.0*T4)*T5)/((144.0*T4)*T5)))+((Lvsat*T10)*d_T10_dV_dbulk_di+Lvsat*d_T10_dV_dbulk_di*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0/4.0)*thetanoisq)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*((NF*Weff)*12.0)*d_T0_dV_dbulk_di)/(((NF*Weff)*12.0)*T0)/(((NF*Weff)*12.0)*T0));
d_mig_dTemp_t_GND = (((((NF*Weff)*12.0)*T0)*((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*d_thetanoisq_dTemp_t_GND+((((Lvsat*T10)*T10)*((((T4*d_T1_dTemp_t_GND-T1*d_T4_dTemp_t_GND)/T4/T4)-((((60.0*T4)*T4)*d_T9_dTemp_t_GND-T9*((60.0*T4)*d_T4_dTemp_t_GND+60.0*d_T4_dTemp_t_GND*T4))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((144.0*T4)*T5)*(T7*d_T7_dTemp_t_GND+d_T7_dTemp_t_GND*T7)-(T7*T7)*((144.0*T4)*d_T5_dTemp_t_GND+144.0*d_T4_dTemp_t_GND*T5))/((144.0*T4)*T5)/((144.0*T4)*T5)))+((Lvsat*T10)*d_T10_dTemp_t_GND+(Lvsat*d_T10_dTemp_t_GND+d_Lvsat_dTemp_t_GND*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0/4.0)*thetanoisq)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*((NF*Weff)*12.0)*d_T0_dTemp_t_GND)/(((NF*Weff)*12.0)*T0)/(((NF*Weff)*12.0)*T0));
d_mig_dV_si_bi = (((((NF*Weff)*12.0)*T0)*((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*d_thetanoisq_dV_si_bi+((((Lvsat*T10)*T10)*((((T4*d_T1_dV_si_bi-T1*d_T4_dV_si_bi)/T4/T4)-((((60.0*T4)*T4)*d_T9_dV_si_bi-T9*((60.0*T4)*d_T4_dV_si_bi+60.0*d_T4_dV_si_bi*T4))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((144.0*T4)*T5)*(T7*d_T7_dV_si_bi+d_T7_dV_si_bi*T7)-(T7*T7)*((144.0*T4)*d_T5_dV_si_bi+144.0*d_T4_dV_si_bi*T5))/((144.0*T4)*T5)/((144.0*T4)*T5)))+((Lvsat*T10)*d_T10_dV_si_bi+(Lvsat*d_T10_dV_si_bi+d_Lvsat_dV_si_bi*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0/4.0)*thetanoisq)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*((NF*Weff)*12.0)*d_T0_dV_si_bi)/(((NF*Weff)*12.0)*T0)/(((NF*Weff)*12.0)*T0));
d_mig_dV_di_bi = (((((NF*Weff)*12.0)*T0)*((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*d_thetanoisq_dV_di_bi+((((Lvsat*T10)*T10)*((((T4*d_T1_dV_di_bi-T1*d_T4_dV_di_bi)/T4/T4)-((((60.0*T4)*T4)*d_T9_dV_di_bi-T9*((60.0*T4)*d_T4_dV_di_bi+60.0*d_T4_dV_di_bi*T4))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((144.0*T4)*T5)*(T7*d_T7_dV_di_bi+d_T7_dV_di_bi*T7)-(T7*T7)*((144.0*T4)*d_T5_dV_di_bi+144.0*d_T4_dV_di_bi*T5))/((144.0*T4)*T5)/((144.0*T4)*T5)))+((Lvsat*T10)*d_T10_dV_di_bi+(Lvsat*d_T10_dV_di_bi+d_Lvsat_dV_di_bi*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0/4.0)*thetanoisq)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*((NF*Weff)*12.0)*d_T0_dV_di_bi)/(((NF*Weff)*12.0)*T0)/(((NF*Weff)*12.0)*T0));
d_mig_dV_gi_bi = (((((NF*Weff)*12.0)*T0)*((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*d_thetanoisq_dV_gi_bi+((((Lvsat*T10)*T10)*((((T4*d_T1_dV_gi_bi-T1*d_T4_dV_gi_bi)/T4/T4)-((((60.0*T4)*T4)*d_T9_dV_gi_bi-T9*((60.0*T4)*d_T4_dV_gi_bi+60.0*d_T4_dV_gi_bi*T4))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((144.0*T4)*T5)*(T7*d_T7_dV_gi_bi+d_T7_dV_gi_bi*T7)-(T7*T7)*((144.0*T4)*d_T5_dV_gi_bi+144.0*d_T4_dV_gi_bi*T5))/((144.0*T4)*T5)/((144.0*T4)*T5)))+((Lvsat*T10)*d_T10_dV_gi_bi+(Lvsat*d_T10_dV_gi_bi+d_Lvsat_dV_gi_bi*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0/4.0)*thetanoisq)-((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*((NF*Weff)*12.0)*d_T0_dV_gi_bi)/(((NF*Weff)*12.0)*T0)/(((NF*Weff)*12.0)*T0));
mig = (((((((Lvsat*T10)*T10)*(((T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)/(((NF*Weff)*12.0)*T0));
migid = (((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi)/0.395);
{
double value_sqrt_0 = sqrt((Nt*mid));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqid_dV_si_bi = (deriv_sqrt_0_d0*(Nt*d_mid_dV_si_bi));
d_sqid_dV_di_bi = (deriv_sqrt_0_d0*(Nt*d_mid_dV_di_bi));
d_sqid_dV_gi_bi = (deriv_sqrt_0_d0*(Nt*d_mid_dV_gi_bi));
d_sqid_dV_sbulk_si = (deriv_sqrt_0_d0*(Nt*d_mid_dV_sbulk_si));
d_sqid_dV_dbulk_di = (deriv_sqrt_0_d0*(Nt*d_mid_dV_dbulk_di));
d_sqid_dTemp_t_GND = (deriv_sqrt_0_d0*((Nt*d_mid_dTemp_t_GND+d_Nt_dTemp_t_GND*mid)));
sqid = value_sqrt_0;
}
if ((mig==0))
{

d_sqig_dTemp_t_GND = d_sqig_dV_gi_bi = d_sqig_dV_di_bi = d_sqig_dV_si_bi = d_sqig_dV_dbulk_di = d_sqig_dV_sbulk_si =  0.0;
sqig = 0.0;
cm_igid = 0.0;
}
else
{
{
double value_sqrt_0 = sqrt((Nt/mig));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqig_dV_sbulk_si = (deriv_sqrt_0_d0*((-Nt*d_mig_dV_sbulk_si/mig/mig)));
d_sqig_dV_dbulk_di = (deriv_sqrt_0_d0*((-Nt*d_mig_dV_dbulk_di/mig/mig)));
d_sqig_dV_si_bi = (deriv_sqrt_0_d0*((-Nt*d_mig_dV_si_bi/mig/mig)));
d_sqig_dV_di_bi = (deriv_sqrt_0_d0*((-Nt*d_mig_dV_di_bi/mig/mig)));
d_sqig_dV_gi_bi = (deriv_sqrt_0_d0*((-Nt*d_mig_dV_gi_bi/mig/mig)));
d_sqig_dTemp_t_GND = (deriv_sqrt_0_d0*(((mig*d_Nt_dTemp_t_GND-Nt*d_mig_dTemp_t_GND)/mig/mig)));
sqig = value_sqrt_0;
}
if ((sqid==0))
{
cm_igid = 0.0;
}
else
{
cm_igid = ((migid*sqig)/sqid);
}
}
// I(N2,GND) <+ (white_noise((m*cm_igid),"corl"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[2]= (m*cm_igid);
}
// I(N1,GND) <+ (white_noise((((m*sqig)*sqig)*(1.0-cm_igid)),"corl"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[3]= (((m*sqig)*sqig)*(1.0-cm_igid));
}
// I(N1,GND) <+ ((m*((-sqig)*V(N2,GND))))
staticContributions[admsNodeID_N1] += (m*((-sqig)*(probeVars[admsProbeID_V_N2_GND])));
d_staticContributions[admsNodeID_N1][admsProbeID_V_N2_GND] += m*(-sqig)*d_probeVars[admsProbeID_V_N2_GND][admsProbeID_V_N2_GND];
d_staticContributions[admsNodeID_N1][admsProbeID_V_sbulk_si] += m*(-d_sqig_dV_sbulk_si)*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_N1][admsProbeID_V_dbulk_di] += m*(-d_sqig_dV_dbulk_di)*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_N1][admsProbeID_V_si_bi] += m*(-d_sqig_dV_si_bi)*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_N1][admsProbeID_V_di_bi] += m*(-d_sqig_dV_di_bi)*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_bi] += m*(-d_sqig_dV_gi_bi)*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_N1][admsProbeID_Temp_t_GND] += m*(-d_sqig_dTemp_t_GND)*(probeVars[admsProbeID_V_N2_GND]);
// I(N1,GND) <+ (ddt(((((((m*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND))))
dynamicContributions[admsNodeID_N1] += (((((((m*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND])));
d_dynamicContributions[admsNodeID_N1][admsProbeID_V_N1_GND] += ((((((m*mig)*Cox)*Weff)*NF)*Leff)*d_probeVars[admsProbeID_V_N1_GND][admsProbeID_V_N1_GND]);
d_dynamicContributions[admsNodeID_N1][admsProbeID_V_sbulk_si] += (m*d_mig_dV_sbulk_si*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_N1][admsProbeID_V_dbulk_di] += (m*d_mig_dV_dbulk_di*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_N1][admsProbeID_Temp_t_GND] += (m*d_mig_dTemp_t_GND*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_N1][admsProbeID_V_si_bi] += (m*d_mig_dV_si_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_bi] += (m*d_mig_dV_di_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_bi] += (m*d_mig_dV_gi_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
// I(di,si) <+ (white_noise((((m*sqid)*sqid)*(1.0-cm_igid)),"id"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[4]= (((m*sqid)*sqid)*(1.0-cm_igid));
}
// I(di,si) <+ (((m*sqid)*V(N2,GND)))
staticContributions[admsNodeID_di] += ((m*sqid)*(probeVars[admsProbeID_V_N2_GND]));
d_staticContributions[admsNodeID_di][admsProbeID_V_N2_GND] += (m*sqid)*d_probeVars[admsProbeID_V_N2_GND][admsProbeID_V_N2_GND];
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] += m*d_sqid_dV_si_bi*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] += m*d_sqid_dV_di_bi*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] += m*d_sqid_dV_gi_bi*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si] += m*d_sqid_dV_sbulk_si*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di] += m*d_sqid_dV_dbulk_di*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] += m*d_sqid_dTemp_t_GND*(probeVars[admsProbeID_V_N2_GND]);
staticContributions[admsNodeID_si] -= ((m*sqid)*(probeVars[admsProbeID_V_N2_GND]));
d_staticContributions[admsNodeID_si][admsProbeID_V_N2_GND] -= (m*sqid)*d_probeVars[admsProbeID_V_N2_GND][admsProbeID_V_N2_GND];
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] -= m*d_sqid_dV_si_bi*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -= m*d_sqid_dV_di_bi*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= m*d_sqid_dV_gi_bi*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= m*d_sqid_dV_sbulk_si*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_di] -= m*d_sqid_dV_dbulk_di*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= m*d_sqid_dTemp_t_GND*(probeVars[admsProbeID_V_N2_GND]);
// I(gi,si) <+ (ddt(((m*0.5)*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
dynamicContributions[admsNodeID_gi] += (((m*0.5)*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_N1_GND] += ((m*0.5)*((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*d_probeVars[admsProbeID_V_N1_GND][admsProbeID_V_N1_GND]);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si] += ((m*0.5)*(1.0+sigvds)*d_mig_dV_sbulk_si*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di] += ((m*0.5)*(1.0+sigvds)*d_mig_dV_dbulk_di*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] += ((m*0.5)*(1.0+sigvds)*d_mig_dTemp_t_GND*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi] += ((m*0.5)*(1.0+sigvds)*d_mig_dV_si_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] += ((m*0.5)*(1.0+sigvds)*d_mig_dV_di_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi] += ((m*0.5)*(1.0+sigvds)*d_mig_dV_gi_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
dynamicContributions[admsNodeID_si] -= (((m*0.5)*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_N1_GND] -= ((m*0.5)*((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*d_probeVars[admsProbeID_V_N1_GND][admsProbeID_V_N1_GND]);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= ((m*0.5)*(1.0+sigvds)*d_mig_dV_sbulk_si*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di] -= ((m*0.5)*(1.0+sigvds)*d_mig_dV_dbulk_di*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= ((m*0.5)*(1.0+sigvds)*d_mig_dTemp_t_GND*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] -= ((m*0.5)*(1.0+sigvds)*d_mig_dV_si_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -= ((m*0.5)*(1.0+sigvds)*d_mig_dV_di_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= ((m*0.5)*(1.0+sigvds)*d_mig_dV_gi_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
// I(gi,di) <+ (ddt(((m*0.5)*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
dynamicContributions[admsNodeID_gi] += (((m*0.5)*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_N1_GND] += ((m*0.5)*((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*d_probeVars[admsProbeID_V_N1_GND][admsProbeID_V_N1_GND]);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si] += ((m*0.5)*(1.0-sigvds)*d_mig_dV_sbulk_si*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di] += ((m*0.5)*(1.0-sigvds)*d_mig_dV_dbulk_di*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] += ((m*0.5)*(1.0-sigvds)*d_mig_dTemp_t_GND*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi] += ((m*0.5)*(1.0-sigvds)*d_mig_dV_si_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] += ((m*0.5)*(1.0-sigvds)*d_mig_dV_di_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi] += ((m*0.5)*(1.0-sigvds)*d_mig_dV_gi_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
dynamicContributions[admsNodeID_di] -= (((m*0.5)*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*(probeVars[admsProbeID_V_N1_GND]))));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_N1_GND] -= ((m*0.5)*((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*d_probeVars[admsProbeID_V_N1_GND][admsProbeID_V_N1_GND]);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si] -= ((m*0.5)*(1.0-sigvds)*d_mig_dV_sbulk_si*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di] -= ((m*0.5)*(1.0-sigvds)*d_mig_dV_dbulk_di*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= ((m*0.5)*(1.0-sigvds)*d_mig_dTemp_t_GND*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] -= ((m*0.5)*(1.0-sigvds)*d_mig_dV_si_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -= ((m*0.5)*(1.0-sigvds)*d_mig_dV_di_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= ((m*0.5)*(1.0-sigvds)*d_mig_dV_gi_bi*Cox*Weff*NF*Leff*(probeVars[admsProbeID_V_N1_GND]));
}
else
{
 // no default
}
// I(N2,GND) <+ ((m*V(N2,GND)))
staticContributions[admsNodeID_N2] += (m*(probeVars[admsProbeID_V_N2_GND]));
d_staticContributions[admsNodeID_N2][admsProbeID_V_N2_GND] += m*d_probeVars[admsProbeID_V_N2_GND][admsProbeID_V_N2_GND];
// I(N1,GND) <+ ((m*V(N1,GND)))
staticContributions[admsNodeID_N1] += (m*(probeVars[admsProbeID_V_N1_GND]));
d_staticContributions[admsNodeID_N1][admsProbeID_V_N1_GND] += m*d_probeVars[admsProbeID_V_N1_GND][admsProbeID_V_N1_GND];
if (((model_.IGCMOD)!=0))
{
// I(gi,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcs+igs))),"igs"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs((igcs+igs));
  noiseContribsPower[5]= (((m*2.0)*1.60219e-19)*value_fabs_0);
}
// I(gi,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcd+igd))),"igd"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs((igcd+igd));
  noiseContribsPower[6]= (((m*2.0)*1.60219e-19)*value_fabs_0);
}
}
if (((model_.IGBMOD)!=0))
{
// I(gi,bi) <+ (white_noise((((m*2.0)*1.60219e-19)*abs(igb)),"igb"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(igb);
  noiseContribsPower[7]= (((m*2.0)*1.60219e-19)*value_fabs_0);
}
}

d_vgfbCV_dTemp_t_GND = d_vgfb_dTemp_t_GND;
d_vgfbCV_dV_si_bi = d_vgfb_dV_si_bi;
d_vgfbCV_dV_di_bi = d_vgfb_dV_di_bi;
d_vgfbCV_dV_gi_bi = d_vgfb_dV_gi_bi;
vgfbCV = vgfb;

d_gamg2_dTemp_t_GND = (-(((2.0*1.60219e-19)*epssi)*NGATE_i)*(Cox*Cox)*d_Vt_dTemp_t_GND/((Cox*Cox)*Vt)/((Cox*Cox)*Vt));
gamg2 = ((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt));

d_invgamg2_dTemp_t_GND = ((NGATE_i>0)?(-d_gamg2_dTemp_t_GND/gamg2/gamg2):0.0);
invgamg2 = ((NGATE_i>0)?(1.0/gamg2):0.0);
if (((model_.CVMOD)==1))
{
VFBCV_i = (VFBCV_i+(model_.DELVT0));

d_vg_dV_gm_si = d_vg_dV_dbulk_di = d_vg_dV_sbulk_si = d_vg_dV_di_bi = d_vg_dV_si_bi =  0.0;
d_vg_dTemp_t_GND = Vg*d_inv_Vt_dTemp_t_GND;
d_vg_dV_gi_bi = d_Vg_dV_gi_bi*inv_Vt;
vg = (Vg*inv_Vt);

d_vs_dV_gm_si = d_vs_dV_dbulk_di = d_vs_dV_sbulk_si = d_vs_dV_gi_bi =  0.0;
d_vs_dTemp_t_GND = Vs*d_inv_Vt_dTemp_t_GND;
d_vs_dV_si_bi = d_Vs_dV_si_bi*inv_Vt;
d_vs_dV_di_bi = d_Vs_dV_di_bi*inv_Vt;
vs = (Vs*inv_Vt);

d_vfb_dV_gm_si = d_vfb_dV_dbulk_di = d_vfb_dV_sbulk_si = d_vfb_dV_gi_bi = d_vfb_dV_di_bi = d_vfb_dV_si_bi =  0.0;
d_vfb_dTemp_t_GND = VFBCV_i*d_inv_Vt_dTemp_t_GND;
vfb = (VFBCV_i*inv_Vt);

d_vgfbCV_dTemp_t_GND = (d_vg_dTemp_t_GND-d_vfb_dTemp_t_GND);
d_vgfbCV_dV_si_bi = (d_vg_dV_si_bi-d_vfb_dV_si_bi);
d_vgfbCV_dV_di_bi = (d_vg_dV_di_bi-d_vfb_dV_di_bi);
d_vgfbCV_dV_gi_bi = (d_vg_dV_gi_bi-d_vfb_dV_gi_bi);
vgfbCV = (vg-vfb);
{
double value_log_0 = log((NDEPCV_i/ni));
double  deriv_log_0_d0 = (1.0/(NDEPCV_i/ni));

d_phib_dTemp_t_GND = (deriv_log_0_d0*((-NDEPCV_i*d_ni_dTemp_t_GND/ni/ni)));
phib = value_log_0;
}
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*epssi)*NDEPCV_i)*inv_Vt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_gam_dV_gm_si = d_gam_dV_dbulk_di = d_gam_dV_sbulk_si = d_gam_dV_gi_bi = d_gam_dV_di_bi = d_gam_dV_si_bi =  0.0;
d_gam_dTemp_t_GND = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEPCV_i)*d_inv_Vt_dTemp_t_GND))/Cox);
gam = (value_sqrt_0/Cox);
}

d_inv_gam_dV_gm_si = d_inv_gam_dV_dbulk_di = d_inv_gam_dV_sbulk_si = d_inv_gam_dV_gi_bi =  0.0;
d_inv_gam_dTemp_t_GND = (-d_gam_dTemp_t_GND/gam/gam);
d_inv_gam_dV_si_bi = (-d_gam_dV_si_bi/gam/gam);
d_inv_gam_dV_di_bi = (-d_gam_dV_di_bi/gam/gam);
inv_gam = (1.0/gam);

d_gamg2_dTemp_t_GND = (-(((2.0*1.60219e-19)*epssi)*NGATE_i)*(Cox*Cox)*d_Vt_dTemp_t_GND/((Cox*Cox)*Vt)/((Cox*Cox)*Vt));
gamg2 = ((((2.0*1.60219e-19)*epssi)*NGATE_i)/((Cox*Cox)*Vt));

d_invgamg2_dTemp_t_GND = ((NGATE_i>0)?(-d_gamg2_dTemp_t_GND/gamg2/gamg2):0.0);
invgamg2 = ((NGATE_i>0)?(1.0/gamg2):0.0);
DPD = ((NGATE_i>0)?(NDEPCV_i/NGATE_i):0.0);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = (1.0+DPD);

d_vgfbPD_dV_gm_si =  0.0;
d_vgfbPD_dV_sbulk_si = (-vgfbCV*d_T1_dV_sbulk_si/T1/T1);
d_vgfbPD_dV_dbulk_di = (-vgfbCV*d_T1_dV_dbulk_di/T1/T1);
d_vgfbPD_dTemp_t_GND = ((T1*d_vgfbCV_dTemp_t_GND-vgfbCV*d_T1_dTemp_t_GND)/T1/T1);
d_vgfbPD_dV_si_bi = ((T1*d_vgfbCV_dV_si_bi-vgfbCV*d_T1_dV_si_bi)/T1/T1);
d_vgfbPD_dV_di_bi = ((T1*d_vgfbCV_dV_di_bi-vgfbCV*d_T1_dV_di_bi)/T1/T1);
d_vgfbPD_dV_gi_bi = ((T1*d_vgfbCV_dV_gi_bi-vgfbCV*d_T1_dV_gi_bi)/T1/T1);
vgfbPD = (vgfbCV/T1);

d_gammaPD_dV_gm_si =  0.0;
d_gammaPD_dV_gi_bi = ((T1*d_gam_dV_gi_bi-gam*d_T1_dV_gi_bi)/T1/T1);
d_gammaPD_dV_sbulk_si = ((T1*d_gam_dV_sbulk_si-gam*d_T1_dV_sbulk_si)/T1/T1);
d_gammaPD_dV_dbulk_di = ((T1*d_gam_dV_dbulk_di-gam*d_T1_dV_dbulk_di)/T1/T1);
d_gammaPD_dTemp_t_GND = ((T1*d_gam_dTemp_t_GND-gam*d_T1_dTemp_t_GND)/T1/T1);
d_gammaPD_dV_si_bi = ((T1*d_gam_dV_si_bi-gam*d_T1_dV_si_bi)/T1/T1);
d_gammaPD_dV_di_bi = ((T1*d_gam_dV_di_bi-gam*d_T1_dV_di_bi)/T1/T1);
gammaPD = (gam/T1);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = (0.5*d_vgfbPD_dTemp_t_GND-3.0*(d_gammaPD_dTemp_t_GND/1.41421356237309504880));
d_T1_dV_si_bi = (0.5*d_vgfbPD_dV_si_bi-3.0*(d_gammaPD_dV_si_bi/1.41421356237309504880));
d_T1_dV_di_bi = (0.5*d_vgfbPD_dV_di_bi-3.0*(d_gammaPD_dV_di_bi/1.41421356237309504880));
d_T1_dV_gi_bi = (0.5*d_vgfbPD_dV_gi_bi-3.0*(d_gammaPD_dV_gi_bi/1.41421356237309504880));
d_T1_dV_sbulk_si = (0.5*d_vgfbPD_dV_sbulk_si-3.0*(d_gammaPD_dV_sbulk_si/1.41421356237309504880));
d_T1_dV_dbulk_di = (0.5*d_vgfbPD_dV_dbulk_di-3.0*(d_gammaPD_dV_dbulk_di/1.41421356237309504880));
T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
{
double value_sqrt_0 = sqrt(((T1*T1)+(6.0*vgfbPD)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND+(deriv_sqrt_0_d0*(((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)+6.0*d_vgfbPD_dTemp_t_GND))));
d_T2_dV_si_bi = (d_T1_dV_si_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)+6.0*d_vgfbPD_dV_si_bi))));
d_T2_dV_di_bi = (d_T1_dV_di_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)+6.0*d_vgfbPD_dV_di_bi))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)+6.0*d_vgfbPD_dV_gi_bi))));
d_T2_dV_sbulk_si = (d_T1_dV_sbulk_si+(deriv_sqrt_0_d0*(((T1*d_T1_dV_sbulk_si+d_T1_dV_sbulk_si*T1)+6.0*d_vgfbPD_dV_sbulk_si))));
d_T2_dV_dbulk_di = (d_T1_dV_dbulk_di+(deriv_sqrt_0_d0*(((T1*d_T1_dV_dbulk_di+d_T1_dV_dbulk_di*T1)+6.0*d_vgfbPD_dV_dbulk_di))));
T2 = (T1+value_sqrt_0);
}
if ((vgfbPD<0.0))
{

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = ((gammaPD*(d_vgfbPD_dTemp_t_GND-d_T2_dTemp_t_GND)-(vgfbPD-T2)*d_gammaPD_dTemp_t_GND)/gammaPD/gammaPD);
d_T3_dV_si_bi = ((gammaPD*(d_vgfbPD_dV_si_bi-d_T2_dV_si_bi)-(vgfbPD-T2)*d_gammaPD_dV_si_bi)/gammaPD/gammaPD);
d_T3_dV_di_bi = ((gammaPD*(d_vgfbPD_dV_di_bi-d_T2_dV_di_bi)-(vgfbPD-T2)*d_gammaPD_dV_di_bi)/gammaPD/gammaPD);
d_T3_dV_gi_bi = ((gammaPD*(d_vgfbPD_dV_gi_bi-d_T2_dV_gi_bi)-(vgfbPD-T2)*d_gammaPD_dV_gi_bi)/gammaPD/gammaPD);
d_T3_dV_sbulk_si = ((gammaPD*(d_vgfbPD_dV_sbulk_si-d_T2_dV_sbulk_si)-(vgfbPD-T2)*d_gammaPD_dV_sbulk_si)/gammaPD/gammaPD);
d_T3_dV_dbulk_di = ((gammaPD*(d_vgfbPD_dV_dbulk_di-d_T2_dV_dbulk_di)-(vgfbPD-T2)*d_gammaPD_dV_dbulk_di)/gammaPD/gammaPD);
T3 = ((vgfbPD-T2)/gammaPD);
{
double value_log_0 = log(((1.0-T2)+(T3*T3)));
double  deriv_log_0_d0 = (1.0/((1.0-T2)+(T3*T3)));

d_psip_dV_gm_di = d_psip_dV_gm_si =  0.0;
d_psip_dTemp_t_GND = (-(deriv_log_0_d0*(((-d_T2_dTemp_t_GND)+(T3*d_T3_dTemp_t_GND+d_T3_dTemp_t_GND*T3)))));
d_psip_dV_si_bi = (-(deriv_log_0_d0*(((-d_T2_dV_si_bi)+(T3*d_T3_dV_si_bi+d_T3_dV_si_bi*T3)))));
d_psip_dV_di_bi = (-(deriv_log_0_d0*(((-d_T2_dV_di_bi)+(T3*d_T3_dV_di_bi+d_T3_dV_di_bi*T3)))));
d_psip_dV_gi_bi = (-(deriv_log_0_d0*(((-d_T2_dV_gi_bi)+(T3*d_T3_dV_gi_bi+d_T3_dV_gi_bi*T3)))));
d_psip_dV_sbulk_si = (-(deriv_log_0_d0*(((-d_T2_dV_sbulk_si)+(T3*d_T3_dV_sbulk_si+d_T3_dV_sbulk_si*T3)))));
d_psip_dV_dbulk_di = (-(deriv_log_0_d0*(((-d_T2_dV_dbulk_di)+(T3*d_T3_dV_dbulk_di+d_T3_dV_dbulk_di*T3)))));
psip = (-value_log_0);
}
}
else
{
{
double value_exp_0 = exp((-T2));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*((-d_T2_dTemp_t_GND)));
d_T3_dV_si_bi = (deriv_exp_0_d0*((-d_T2_dV_si_bi)));
d_T3_dV_di_bi = (deriv_exp_0_d0*((-d_T2_dV_di_bi)));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((-d_T2_dV_gi_bi)));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*((-d_T2_dV_sbulk_si)));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*((-d_T2_dV_dbulk_di)));
T3 = value_exp_0;
}

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = 0.5*d_gammaPD_dTemp_t_GND;
d_T1_dV_si_bi = 0.5*d_gammaPD_dV_si_bi;
d_T1_dV_di_bi = 0.5*d_gammaPD_dV_di_bi;
d_T1_dV_gi_bi = 0.5*d_gammaPD_dV_gi_bi;
d_T1_dV_sbulk_si = 0.5*d_gammaPD_dV_sbulk_si;
d_T1_dV_dbulk_di = 0.5*d_gammaPD_dV_dbulk_di;
T1 = (0.5*gammaPD);
{
double value_sqrt_0 = sqrt((((vgfbPD-1.0)+T3)+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = ((deriv_sqrt_0_d0*(((d_vgfbPD_dTemp_t_GND+d_T3_dTemp_t_GND)+(T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1))))-d_T1_dTemp_t_GND);
d_T2_dV_si_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_si_bi+d_T3_dV_si_bi)+(T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1))))-d_T1_dV_si_bi);
d_T2_dV_di_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_di_bi+d_T3_dV_di_bi)+(T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1))))-d_T1_dV_di_bi);
d_T2_dV_gi_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_gi_bi+d_T3_dV_gi_bi)+(T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1))))-d_T1_dV_gi_bi);
d_T2_dV_sbulk_si = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_sbulk_si+d_T3_dV_sbulk_si)+(T1*d_T1_dV_sbulk_si+d_T1_dV_sbulk_si*T1))))-d_T1_dV_sbulk_si);
d_T2_dV_dbulk_di = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_dbulk_di+d_T3_dV_dbulk_di)+(T1*d_T1_dV_dbulk_di+d_T1_dV_dbulk_di*T1))))-d_T1_dV_dbulk_di);
T2 = (value_sqrt_0-T1);
}

d_psip_dV_gm_di = d_psip_dV_gm_si =  0.0;
d_psip_dTemp_t_GND = ((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2)-d_T3_dTemp_t_GND);
d_psip_dV_si_bi = ((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2)-d_T3_dV_si_bi);
d_psip_dV_di_bi = ((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2)-d_T3_dV_di_bi);
d_psip_dV_gi_bi = ((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2)-d_T3_dV_gi_bi);
d_psip_dV_sbulk_si = ((T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*T2)-d_T3_dV_sbulk_si);
d_psip_dV_dbulk_di = ((T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*T2)-d_T3_dV_dbulk_di);
psip = (((T2*T2)+1.0)-T3);
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_T8_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_T8_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_T8_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
d_T8_dV_sbulk_si = 0.5*(d_psip_dV_sbulk_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_sbulk_si+d_psip_dV_sbulk_si*(psip-1.0)))));
d_T8_dV_dbulk_di = 0.5*(d_psip_dV_dbulk_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_dbulk_di+d_psip_dV_dbulk_di*(psip-1.0)))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dV_gm_di = d_sqrtpsip_dV_gm_si =  0.0;
d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T8_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_T8_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_T8_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_T8_dV_gi_bi));
d_sqrtpsip_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T8_dV_sbulk_si));
d_sqrtpsip_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T8_dV_dbulk_di));
sqrtpsip = value_sqrt_0;
}

d_T9_dV_gm_si = d_T9_dV_gm_di =  0.0;
d_T9_dV_gi_bi = (((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_sbulk_si = (((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_dbulk_di = (((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dTemp_t_GND = (((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_si_bi = (((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_di_bi = (((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));

d_T0_dV_gm_di = d_T0_dV_gm_si =  0.0;
d_T0_dV_gi_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gi_bi)/gam/gam);
d_T0_dV_sbulk_si = ((gam*(((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_sbulk_si)/gam/gam);
d_T0_dV_dbulk_di = ((gam*(((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_dbulk_di)/gam/gam);
d_T0_dTemp_t_GND = ((gam*(((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dTemp_t_GND)/gam/gam);
d_T0_dV_si_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_si_bi)/gam/gam);
d_T0_dV_di_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_di_bi)/gam/gam);
T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_dTemp_t_GND)-d_vs_dTemp_t_GND);
d_T1_dV_si_bi = (d_psip_dV_si_bi-d_vs_dV_si_bi);
d_T1_dV_di_bi = (d_psip_dV_di_bi-d_vs_dV_di_bi);
d_T1_dV_gi_bi = (d_psip_dV_gi_bi-d_vs_dV_gi_bi);
d_T1_dV_sbulk_si = (d_psip_dV_sbulk_si-d_vs_dV_sbulk_si);
d_T1_dV_dbulk_di = (d_psip_dV_dbulk_di-d_vs_dV_dbulk_di);
T1 = ((psip-(2.0*phib))-vs);
{
double value_log_0 = log(((4.0*T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*T0)*sqrtpsip));

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dTemp_t_GND+4.0*d_T0_dTemp_t_GND*sqrtpsip))));
d_T2_dV_si_bi = (d_T1_dV_si_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_si_bi+4.0*d_T0_dV_si_bi*sqrtpsip))));
d_T2_dV_di_bi = (d_T1_dV_di_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_di_bi+4.0*d_T0_dV_di_bi*sqrtpsip))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gi_bi+4.0*d_T0_dV_gi_bi*sqrtpsip))));
d_T2_dV_sbulk_si = (d_T1_dV_sbulk_si-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_sbulk_si+4.0*d_T0_dV_sbulk_si*sqrtpsip))));
d_T2_dV_dbulk_di = (d_T1_dV_dbulk_di-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_dbulk_di+4.0*d_T0_dV_dbulk_di*sqrtpsip))));
T2 = (T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((T2*(T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND-(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*(T2+0.402982)))));
d_T8_dV_si_bi = 0.5*(d_T2_dV_si_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*(T2+0.402982)))));
d_T8_dV_di_bi = 0.5*(d_T2_dV_di_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*(T2+0.402982)))));
d_T8_dV_gi_bi = 0.5*(d_T2_dV_gi_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*(T2+0.402982)))));
d_T8_dV_sbulk_si = 0.5*(d_T2_dV_sbulk_si-(deriv_sqrt_0_d0*((T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*(T2+0.402982)))));
d_T8_dV_dbulk_di = 0.5*(d_T2_dV_dbulk_di-(deriv_sqrt_0_d0*((T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*(T2+0.402982)))));
T8 = (0.5*((T2-0.201491)-value_sqrt_0));
}

d_sqrtpsisa_dV_gm_di = d_sqrtpsisa_dV_gm_si =  0.0;
d_sqrtpsisa_dTemp_t_GND = d_sqrtpsip_dTemp_t_GND;
d_sqrtpsisa_dV_si_bi = d_sqrtpsip_dV_si_bi;
d_sqrtpsisa_dV_di_bi = d_sqrtpsip_dV_di_bi;
d_sqrtpsisa_dV_gi_bi = d_sqrtpsip_dV_gi_bi;
d_sqrtpsisa_dV_sbulk_si = d_sqrtpsip_dV_sbulk_si;
d_sqrtpsisa_dV_dbulk_di = d_sqrtpsip_dV_dbulk_di;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dV_di_bi = d_T4_dV_si_bi = d_T4_dTemp_t_GND =  0.0;
T4 = (-100.0);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T4_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T4_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T4_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T4_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T4_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T4_dV_dbulk_di));
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
T3 = value_exp_0;
}
}
else
{

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = ((T5*(d_T8_dTemp_t_GND-d_T4_dTemp_t_GND)-(T8-T4)*d_T5_dTemp_t_GND)/T5/T5);
d_T2_dV_si_bi = ((T5*(d_T8_dV_si_bi-d_T4_dV_si_bi)-(T8-T4)*d_T5_dV_si_bi)/T5/T5);
d_T2_dV_di_bi = ((T5*(d_T8_dV_di_bi-d_T4_dV_di_bi)-(T8-T4)*d_T5_dV_di_bi)/T5/T5);
d_T2_dV_gi_bi = ((T5*(d_T8_dV_gi_bi-d_T4_dV_gi_bi)-(T8-T4)*d_T5_dV_gi_bi)/T5/T5);
d_T2_dV_sbulk_si = ((T5*(d_T8_dV_sbulk_si-d_T4_dV_sbulk_si)-(T8-T4)*d_T5_dV_sbulk_si)/T5/T5);
d_T2_dV_dbulk_di = ((T5*(d_T8_dV_dbulk_di-d_T4_dV_dbulk_di)-(T8-T4)*d_T5_dV_dbulk_di)/T5/T5);
T2 = ((T8-T4)/T5);

d_T6_dV_gm_di = d_T6_dV_gm_si =  0.0;
d_T6_dTemp_t_GND = (T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2);
d_T6_dV_si_bi = (T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2);
d_T6_dV_di_bi = (T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2);
d_T6_dV_gi_bi = (T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2);
d_T6_dV_sbulk_si = (T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*T2);
d_T6_dV_dbulk_di = (T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*T2);
T6 = (T2*T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*((d_T4_dTemp_t_GND+(T5*(0.5*d_T2_dTemp_t_GND+(T6*(-(T6*(-d_T6_dTemp_t_GND)+d_T6_dTemp_t_GND*(1.25-T6)))+d_T6_dTemp_t_GND*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dTemp_t_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_si_bi = (deriv_exp_0_d0*((d_T4_dV_si_bi+(T5*(0.5*d_T2_dV_si_bi+(T6*(-(T6*(-d_T6_dV_si_bi)+d_T6_dV_si_bi*(1.25-T6)))+d_T6_dV_si_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_si_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_di_bi = (deriv_exp_0_d0*((d_T4_dV_di_bi+(T5*(0.5*d_T2_dV_di_bi+(T6*(-(T6*(-d_T6_dV_di_bi)+d_T6_dV_di_bi*(1.25-T6)))+d_T6_dV_di_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_di_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((d_T4_dV_gi_bi+(T5*(0.5*d_T2_dV_gi_bi+(T6*(-(T6*(-d_T6_dV_gi_bi)+d_T6_dV_gi_bi*(1.25-T6)))+d_T6_dV_gi_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*((d_T4_dV_sbulk_si+(T5*(0.5*d_T2_dV_sbulk_si+(T6*(-(T6*(-d_T6_dV_sbulk_si)+d_T6_dV_sbulk_si*(1.25-T6)))+d_T6_dV_sbulk_si*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_sbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*((d_T4_dV_dbulk_di+(T5*(0.5*d_T2_dV_dbulk_di+(T6*(-(T6*(-d_T6_dV_dbulk_di)+d_T6_dV_dbulk_di*(1.25-T6)))+d_T6_dV_dbulk_di*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_dbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_qs_dV_gm_si = d_qs_dV_gm_di =  0.0;
d_qs_dTemp_t_GND = (T3*((d_T1_dTemp_t_GND-d_T8_dTemp_t_GND)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+2.0*d_T0_dTemp_t_GND*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dTemp_t_GND*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_si_bi = (T3*((d_T1_dV_si_bi-d_T8_dV_si_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+2.0*d_T0_dV_si_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_si_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_di_bi = (T3*((d_T1_dV_di_bi-d_T8_dV_di_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+2.0*d_T0_dV_di_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_di_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_gi_bi = (T3*((d_T1_dV_gi_bi-d_T8_dV_gi_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+2.0*d_T0_dV_gi_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gi_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_sbulk_si = (T3*((d_T1_dV_sbulk_si-d_T8_dV_sbulk_si)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+2.0*d_T0_dV_sbulk_si*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_sbulk_si*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_dbulk_di = (T3*((d_T1_dV_dbulk_di-d_T8_dV_dbulk_di)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+2.0*d_T0_dV_dbulk_di*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_dbulk_di*(((1.0+T1)-T8)-value_log_0));
qs = (T3*(((1.0+T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
T3 = value_exp_0;
}

d_sqrtpsisainv_dV_gm_di = d_sqrtpsisainv_dV_gm_si =  0.0;
d_sqrtpsisainv_dTemp_t_GND = (-d_sqrtpsisa_dTemp_t_GND/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_si_bi = (-d_sqrtpsisa_dV_si_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_di_bi = (-d_sqrtpsisa_dV_di_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gi_bi = (-d_sqrtpsisa_dV_gi_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_sbulk_si = (-d_sqrtpsisa_dV_sbulk_si/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_dbulk_di = (-d_sqrtpsisa_dV_dbulk_di/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (d_T3_dTemp_t_GND-((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5));
d_T3_dV_si_bi = (d_T3_dV_si_bi-((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5));
d_T3_dV_di_bi = (d_T3_dV_di_bi-((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5));
d_T3_dV_gi_bi = (d_T3_dV_gi_bi-((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5));
d_T3_dV_sbulk_si = (d_T3_dV_sbulk_si-((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5));
d_T3_dV_dbulk_di = (d_T3_dV_dbulk_di-((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T6_dV_gm_di = d_T6_dV_gm_si =  0.0;
d_T6_dTemp_t_GND = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_si_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_di_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gi_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_sbulk_si = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_dbulk_di = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T7_dV_gm_si = d_T7_dV_gm_di =  0.0;
d_T7_dTemp_t_GND = (((-((1.0/T3)*(-d_T3_dTemp_t_GND/T3/T3)+(-d_T3_dTemp_t_GND/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dTemp_t_GND+(sqrtpsisa*d_sqrtpsisa_dTemp_t_GND+d_sqrtpsisa_dTemp_t_GND*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dTemp_t_GND);
d_T7_dV_si_bi = (((-((1.0/T3)*(-d_T3_dV_si_bi/T3/T3)+(-d_T3_dV_si_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_si_bi+(sqrtpsisa*d_sqrtpsisa_dV_si_bi+d_sqrtpsisa_dV_si_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_si_bi);
d_T7_dV_di_bi = (((-((1.0/T3)*(-d_T3_dV_di_bi/T3/T3)+(-d_T3_dV_di_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_di_bi+(sqrtpsisa*d_sqrtpsisa_dV_di_bi+d_sqrtpsisa_dV_di_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_di_bi);
d_T7_dV_gi_bi = (((-((1.0/T3)*(-d_T3_dV_gi_bi/T3/T3)+(-d_T3_dV_gi_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gi_bi+(sqrtpsisa*d_sqrtpsisa_dV_gi_bi+d_sqrtpsisa_dV_gi_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gi_bi);
d_T7_dV_sbulk_si = (((-((1.0/T3)*(-d_T3_dV_sbulk_si/T3/T3)+(-d_T3_dV_sbulk_si/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_sbulk_si+(sqrtpsisa*d_sqrtpsisa_dV_sbulk_si+d_sqrtpsisa_dV_sbulk_si*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_sbulk_si);
d_T7_dV_dbulk_di = (((-((1.0/T3)*(-d_T3_dV_dbulk_di/T3/T3)+(-d_T3_dV_dbulk_di/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_dbulk_di+(sqrtpsisa*d_sqrtpsisa_dV_dbulk_di+d_sqrtpsisa_dV_dbulk_di*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_dbulk_di);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);

d_qs_dV_gm_si = d_qs_dV_gm_di =  0.0;
d_qs_dTemp_t_GND = (d_T3_dTemp_t_GND-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dTemp_t_GND+d_T4_dTemp_t_GND*T7)-(T4*T7)*((2.0*T5)*d_T5_dTemp_t_GND+2.0*d_T5_dTemp_t_GND*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_si_bi = (d_T3_dV_si_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_si_bi+d_T4_dV_si_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_si_bi+2.0*d_T5_dV_si_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_di_bi = (d_T3_dV_di_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_di_bi+d_T4_dV_di_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_di_bi+2.0*d_T5_dV_di_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_gi_bi = (d_T3_dV_gi_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gi_bi+d_T4_dV_gi_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gi_bi+2.0*d_T5_dV_gi_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_sbulk_si = (d_T3_dV_sbulk_si-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_sbulk_si+d_T4_dV_sbulk_si*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_sbulk_si+2.0*d_T5_dV_sbulk_si*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_dbulk_di = (d_T3_dV_dbulk_di-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_dbulk_di+d_T4_dV_dbulk_di*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_dbulk_di+2.0*d_T5_dV_dbulk_di*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psipclamp_dV_gm_di = d_psipclamp_dV_gm_si =  0.0;
d_psipclamp_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_psipclamp_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_psipclamp_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_psipclamp_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
d_psipclamp_dV_sbulk_si = 0.5*(d_psip_dV_sbulk_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_sbulk_si+d_psip_dV_sbulk_si*(psip-1.0)))));
d_psipclamp_dV_dbulk_di = 0.5*(d_psip_dV_dbulk_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_dbulk_di+d_psip_dV_dbulk_di*(psip-1.0)))));
psipclamp = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(psipclamp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dV_gm_di = d_sqrtpsip_dV_gm_si =  0.0;
d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_psipclamp_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_gi_bi));
d_sqrtpsip_dV_sbulk_si = (deriv_sqrt_0_d0*(d_psipclamp_dV_sbulk_si));
d_sqrtpsip_dV_dbulk_di = (deriv_sqrt_0_d0*(d_psipclamp_dV_dbulk_di));
sqrtpsip = value_sqrt_0;
}

d_psiavg_dV_gm_di = d_psiavg_dV_gm_si =  0.0;
d_psiavg_dTemp_t_GND = (d_psip_dTemp_t_GND-2.0*d_qs_dTemp_t_GND);
d_psiavg_dV_si_bi = (d_psip_dV_si_bi-2.0*d_qs_dV_si_bi);
d_psiavg_dV_di_bi = (d_psip_dV_di_bi-2.0*d_qs_dV_di_bi);
d_psiavg_dV_gi_bi = (d_psip_dV_gi_bi-2.0*d_qs_dV_gi_bi);
d_psiavg_dV_sbulk_si = (d_psip_dV_sbulk_si-2.0*d_qs_dV_sbulk_si);
d_psiavg_dV_dbulk_di = (d_psip_dV_dbulk_di-2.0*d_qs_dV_dbulk_di);
psiavg = (psip-(2.0*qs));
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_gm_di = d_T0_dV_gm_si =  0.0;
d_T0_dTemp_t_GND = 0.5*(d_psiavg_dTemp_t_GND+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dTemp_t_GND+d_psiavg_dTemp_t_GND*(psiavg-1.0)))));
d_T0_dV_si_bi = 0.5*(d_psiavg_dV_si_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_si_bi+d_psiavg_dV_si_bi*(psiavg-1.0)))));
d_T0_dV_di_bi = 0.5*(d_psiavg_dV_di_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_di_bi+d_psiavg_dV_di_bi*(psiavg-1.0)))));
d_T0_dV_gi_bi = 0.5*(d_psiavg_dV_gi_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_gi_bi+d_psiavg_dV_gi_bi*(psiavg-1.0)))));
d_T0_dV_sbulk_si = 0.5*(d_psiavg_dV_sbulk_si+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_sbulk_si+d_psiavg_dV_sbulk_si*(psiavg-1.0)))));
d_T0_dV_dbulk_di = 0.5*(d_psiavg_dV_dbulk_di+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_dbulk_di+d_psiavg_dV_dbulk_di*(psiavg-1.0)))));
T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_nq_dV_gm_si = d_nq_dV_gm_di =  0.0;
d_nq_dV_gi_bi = (((sqrtpsip+value_sqrt_0)*d_gam_dV_gi_bi-gam*(d_sqrtpsip_dV_gi_bi+(deriv_sqrt_0_d0*(d_T0_dV_gi_bi))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dV_sbulk_si = (((sqrtpsip+value_sqrt_0)*d_gam_dV_sbulk_si-gam*(d_sqrtpsip_dV_sbulk_si+(deriv_sqrt_0_d0*(d_T0_dV_sbulk_si))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dV_dbulk_di = (((sqrtpsip+value_sqrt_0)*d_gam_dV_dbulk_di-gam*(d_sqrtpsip_dV_dbulk_di+(deriv_sqrt_0_d0*(d_T0_dV_dbulk_di))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dTemp_t_GND = (((sqrtpsip+value_sqrt_0)*d_gam_dTemp_t_GND-gam*(d_sqrtpsip_dTemp_t_GND+(deriv_sqrt_0_d0*(d_T0_dTemp_t_GND))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dV_si_bi = (((sqrtpsip+value_sqrt_0)*d_gam_dV_si_bi-gam*(d_sqrtpsip_dV_si_bi+(deriv_sqrt_0_d0*(d_T0_dV_si_bi))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
d_nq_dV_di_bi = (((sqrtpsip+value_sqrt_0)*d_gam_dV_di_bi-gam*(d_sqrtpsip_dV_di_bi+(deriv_sqrt_0_d0*(d_T0_dV_di_bi))))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
nq = (1.0+(gam/(sqrtpsip+value_sqrt_0)));
}

d_T0_dV_gm_di = d_T0_dV_gm_si =  0.0;
d_T0_dV_sbulk_si = Vt*((-d_psip_dV_sbulk_si)-((2.0*qs)*d_nq_dV_sbulk_si+2.0*d_qs_dV_sbulk_si*(nq-1.0)));
d_T0_dV_dbulk_di = Vt*((-d_psip_dV_dbulk_di)-((2.0*qs)*d_nq_dV_dbulk_di+2.0*d_qs_dV_dbulk_di*(nq-1.0)));
d_T0_dV_si_bi = Vt*((d_vgfbCV_dV_si_bi-d_psip_dV_si_bi)-((2.0*qs)*d_nq_dV_si_bi+2.0*d_qs_dV_si_bi*(nq-1.0)));
d_T0_dV_di_bi = Vt*((d_vgfbCV_dV_di_bi-d_psip_dV_di_bi)-((2.0*qs)*d_nq_dV_di_bi+2.0*d_qs_dV_di_bi*(nq-1.0)));
d_T0_dV_gi_bi = Vt*((d_vgfbCV_dV_gi_bi-d_psip_dV_gi_bi)-((2.0*qs)*d_nq_dV_gi_bi+2.0*d_qs_dV_gi_bi*(nq-1.0)));
d_T0_dTemp_t_GND = (Vt*((d_vgfbCV_dTemp_t_GND-d_psip_dTemp_t_GND)-((2.0*qs)*d_nq_dTemp_t_GND+2.0*d_qs_dTemp_t_GND*(nq-1.0)))+d_Vt_dTemp_t_GND*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((T0)*(T0))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qbs_dTemp_t_GND = 0.5*(d_T0_dTemp_t_GND+(deriv_sqrt_0_d0*(((T0)*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*(T0)))));
d_qbs_dV_si_bi = 0.5*(d_T0_dV_si_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_si_bi+d_T0_dV_si_bi*(T0)))));
d_qbs_dV_di_bi = 0.5*(d_T0_dV_di_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_di_bi+d_T0_dV_di_bi*(T0)))));
d_qbs_dV_gi_bi = 0.5*(d_T0_dV_gi_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_gi_bi+d_T0_dV_gi_bi*(T0)))));
d_qbs_dV_sbulk_si = 0.5*(d_T0_dV_sbulk_si+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_sbulk_si+d_T0_dV_sbulk_si*(T0)))));
d_qbs_dV_dbulk_di = 0.5*(d_T0_dV_dbulk_di+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_dbulk_di+d_T0_dV_dbulk_di*(T0)))));
qbs = (0.5*(T0+value_sqrt_0));
}

d_qis_dV_si_bi = (((2.0*nq)*Vt)*d_qs_dV_si_bi+2.0*d_nq_dV_si_bi*Vt*qs);
d_qis_dV_di_bi = (((2.0*nq)*Vt)*d_qs_dV_di_bi+2.0*d_nq_dV_di_bi*Vt*qs);
d_qis_dTemp_t_GND = (((2.0*nq)*Vt)*d_qs_dTemp_t_GND+((2.0*nq)*d_Vt_dTemp_t_GND+2.0*d_nq_dTemp_t_GND*Vt)*qs);
d_qis_dV_gi_bi = (((2.0*nq)*Vt)*d_qs_dV_gi_bi+2.0*d_nq_dV_gi_bi*Vt*qs);
d_qis_dV_sbulk_si = (((2.0*nq)*Vt)*d_qs_dV_sbulk_si+2.0*d_nq_dV_sbulk_si*Vt*qs);
d_qis_dV_dbulk_di = (((2.0*nq)*Vt)*d_qs_dV_dbulk_di+2.0*d_nq_dV_dbulk_di*Vt*qs);
qis = (((2.0*nq)*Vt)*qs);

d_Eeffs_dTemp_t_GND = EeffFactor*(d_qbs_dTemp_t_GND+eta_mu*d_qis_dTemp_t_GND);
d_Eeffs_dV_si_bi = EeffFactor*(d_qbs_dV_si_bi+eta_mu*d_qis_dV_si_bi);
d_Eeffs_dV_di_bi = EeffFactor*(d_qbs_dV_di_bi+eta_mu*d_qis_dV_di_bi);
d_Eeffs_dV_gi_bi = EeffFactor*(d_qbs_dV_gi_bi+eta_mu*d_qis_dV_gi_bi);
d_Eeffs_dV_sbulk_si = EeffFactor*(d_qbs_dV_sbulk_si+eta_mu*d_qis_dV_sbulk_si);
d_Eeffs_dV_dbulk_di = EeffFactor*(d_qbs_dV_dbulk_di+eta_mu*d_qis_dV_dbulk_di);
Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
{
double value_pow_0 = pow(Eeffs,EU_i);
double  deriv_pow_0_d0 = ((Eeffs == 0.0)?0.0:(value_pow_0*EU_i/Eeffs));

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dV_gi_bi = (UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_gi_bi));
d_T3_dV_sbulk_si = (UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_sbulk_si));
d_T3_dV_dbulk_di = (UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_dbulk_di));
d_T3_dV_si_bi = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_si_bi))+(d_UA_a_dV_si_bi+(UC_a*d_Vbsx_dV_si_bi+d_UC_a_dV_si_bi*Vbsx))*value_pow_0);
d_T3_dV_di_bi = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dV_di_bi))+(d_UA_a_dV_di_bi+(UC_a*d_Vbsx_dV_di_bi+d_UC_a_dV_di_bi*Vbsx))*value_pow_0);
d_T3_dTemp_t_GND = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffs_dTemp_t_GND))+(d_UA_a_dTemp_t_GND+d_UC_a_dTemp_t_GND*Vbsx)*value_pow_0);
T3 = ((UA_a+(UC_a*Vbsx))*value_pow_0);
}

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = d_T3_dTemp_t_GND;
d_T4_dV_si_bi = d_T3_dV_si_bi;
d_T4_dV_di_bi = d_T3_dV_di_bi;
d_T4_dV_gi_bi = d_T3_dV_gi_bi;
d_T4_dV_sbulk_si = d_T3_dV_sbulk_si;
d_T4_dV_dbulk_di = d_T3_dV_dbulk_di;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Dmobs_dTemp_t_GND = 0.5*(d_T4_dTemp_t_GND+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dTemp_t_GND+d_T4_dTemp_t_GND*(T4-1.0)))));
d_Dmobs_dV_si_bi = 0.5*(d_T4_dV_si_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_si_bi+d_T4_dV_si_bi*(T4-1.0)))));
d_Dmobs_dV_di_bi = 0.5*(d_T4_dV_di_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_di_bi+d_T4_dV_di_bi*(T4-1.0)))));
d_Dmobs_dV_gi_bi = 0.5*(d_T4_dV_gi_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_gi_bi+d_T4_dV_gi_bi*(T4-1.0)))));
d_Dmobs_dV_sbulk_si = 0.5*(d_T4_dV_sbulk_si+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_sbulk_si+d_T4_dV_sbulk_si*(T4-1.0)))));
d_Dmobs_dV_dbulk_di = 0.5*(d_T4_dV_dbulk_di+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_dbulk_di+d_T4_dV_dbulk_di*(T4-1.0)))));
Dmobs = (0.5*((T4+1.0)+value_sqrt_0));
}

d_LambdaC_by2_dV_gi_bi = ((-U0_a*d_Dmobs_dV_gi_bi/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
d_LambdaC_by2_dV_sbulk_si = ((-U0_a*d_Dmobs_dV_sbulk_si/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
d_LambdaC_by2_dV_dbulk_di = ((-U0_a*d_Dmobs_dV_dbulk_di/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
d_LambdaC_by2_dV_si_bi = (((Dmobs*d_U0_a_dV_si_bi-U0_a*d_Dmobs_dV_si_bi)/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
d_LambdaC_by2_dV_di_bi = (((Dmobs*d_U0_a_dV_di_bi-U0_a*d_Dmobs_dV_di_bi)/Dmobs/Dmobs)*Vt/(VSATCV_t*Lact));
d_LambdaC_by2_dTemp_t_GND = (((VSATCV_t*Lact)*((U0_a/Dmobs)*d_Vt_dTemp_t_GND+((Dmobs*d_U0_a_dTemp_t_GND-U0_a*d_Dmobs_dTemp_t_GND)/Dmobs/Dmobs)*Vt)-((U0_a/Dmobs)*Vt)*d_VSATCV_t_dTemp_t_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
LambdaC_by2 = (((U0_a/Dmobs)*Vt)/(VSATCV_t*Lact));

d_qdsat_dV_gi_bi = (((1.0+(LambdaC_by2*(1.0+qs)))*(LambdaC_by2*((qs*d_qs_dV_gi_bi+d_qs_dV_gi_bi*qs)+d_qs_dV_gi_bi)+d_LambdaC_by2_dV_gi_bi*((qs*qs)+qs))-(LambdaC_by2*((qs*qs)+qs))*(LambdaC_by2*d_qs_dV_gi_bi+d_LambdaC_by2_dV_gi_bi*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
d_qdsat_dV_sbulk_si = (((1.0+(LambdaC_by2*(1.0+qs)))*(LambdaC_by2*((qs*d_qs_dV_sbulk_si+d_qs_dV_sbulk_si*qs)+d_qs_dV_sbulk_si)+d_LambdaC_by2_dV_sbulk_si*((qs*qs)+qs))-(LambdaC_by2*((qs*qs)+qs))*(LambdaC_by2*d_qs_dV_sbulk_si+d_LambdaC_by2_dV_sbulk_si*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
d_qdsat_dV_dbulk_di = (((1.0+(LambdaC_by2*(1.0+qs)))*(LambdaC_by2*((qs*d_qs_dV_dbulk_di+d_qs_dV_dbulk_di*qs)+d_qs_dV_dbulk_di)+d_LambdaC_by2_dV_dbulk_di*((qs*qs)+qs))-(LambdaC_by2*((qs*qs)+qs))*(LambdaC_by2*d_qs_dV_dbulk_di+d_LambdaC_by2_dV_dbulk_di*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
d_qdsat_dV_si_bi = (((1.0+(LambdaC_by2*(1.0+qs)))*(LambdaC_by2*((qs*d_qs_dV_si_bi+d_qs_dV_si_bi*qs)+d_qs_dV_si_bi)+d_LambdaC_by2_dV_si_bi*((qs*qs)+qs))-(LambdaC_by2*((qs*qs)+qs))*(LambdaC_by2*d_qs_dV_si_bi+d_LambdaC_by2_dV_si_bi*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
d_qdsat_dV_di_bi = (((1.0+(LambdaC_by2*(1.0+qs)))*(LambdaC_by2*((qs*d_qs_dV_di_bi+d_qs_dV_di_bi*qs)+d_qs_dV_di_bi)+d_LambdaC_by2_dV_di_bi*((qs*qs)+qs))-(LambdaC_by2*((qs*qs)+qs))*(LambdaC_by2*d_qs_dV_di_bi+d_LambdaC_by2_dV_di_bi*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
d_qdsat_dTemp_t_GND = (((1.0+(LambdaC_by2*(1.0+qs)))*(LambdaC_by2*((qs*d_qs_dTemp_t_GND+d_qs_dTemp_t_GND*qs)+d_qs_dTemp_t_GND)+d_LambdaC_by2_dTemp_t_GND*((qs*qs)+qs))-(LambdaC_by2*((qs*qs)+qs))*(LambdaC_by2*d_qs_dTemp_t_GND+d_LambdaC_by2_dTemp_t_GND*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
qdsat = ((LambdaC_by2*((qs*qs)+qs))/(1.0+(LambdaC_by2*(1.0+qs))));
{
double value_log_0 = log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));
double  deriv_log_0_d0 = (1.0/((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));

d_vdsatcv_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_dTemp_t_GND)-(2.0*d_qdsat_dTemp_t_GND+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dTemp_t_GND+((qdsat*2.0)*d_nq_dTemp_t_GND+d_qdsat_dTemp_t_GND*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dTemp_t_GND-gam*d_nq_dTemp_t_GND)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dTemp_t_GND+((qdsat*2.0)*d_nq_dTemp_t_GND+d_qdsat_dTemp_t_GND*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsatcv_dV_si_bi = (d_psip_dV_si_bi-(2.0*d_qdsat_dV_si_bi+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_si_bi+((qdsat*2.0)*d_nq_dV_si_bi+d_qdsat_dV_si_bi*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_si_bi-gam*d_nq_dV_si_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_si_bi+((qdsat*2.0)*d_nq_dV_si_bi+d_qdsat_dV_si_bi*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsatcv_dV_di_bi = (d_psip_dV_di_bi-(2.0*d_qdsat_dV_di_bi+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_di_bi+((qdsat*2.0)*d_nq_dV_di_bi+d_qdsat_dV_di_bi*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_di_bi-gam*d_nq_dV_di_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_di_bi+((qdsat*2.0)*d_nq_dV_di_bi+d_qdsat_dV_di_bi*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsatcv_dV_gi_bi = (d_psip_dV_gi_bi-(2.0*d_qdsat_dV_gi_bi+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_gi_bi+((qdsat*2.0)*d_nq_dV_gi_bi+d_qdsat_dV_gi_bi*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_gi_bi-gam*d_nq_dV_gi_bi)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_gi_bi+((qdsat*2.0)*d_nq_dV_gi_bi+d_qdsat_dV_gi_bi*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsatcv_dV_sbulk_si = (d_psip_dV_sbulk_si-(2.0*d_qdsat_dV_sbulk_si+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_sbulk_si+((qdsat*2.0)*d_nq_dV_sbulk_si+d_qdsat_dV_sbulk_si*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_sbulk_si-gam*d_nq_dV_sbulk_si)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_sbulk_si+((qdsat*2.0)*d_nq_dV_sbulk_si+d_qdsat_dV_sbulk_si*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
d_vdsatcv_dV_dbulk_di = (d_psip_dV_dbulk_di-(2.0*d_qdsat_dV_dbulk_di+(deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dV_dbulk_di+((qdsat*2.0)*d_nq_dV_dbulk_di+d_qdsat_dV_dbulk_di*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dV_dbulk_di-gam*d_nq_dV_dbulk_di)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dV_dbulk_di+((qdsat*2.0)*d_nq_dV_dbulk_di+d_qdsat_dV_dbulk_di*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0))))))));
vdsatcv = ((psip-(2.0*phib))-((2.0*qdsat)+value_log_0));
}

d_VdsatCV_dTemp_t_GND = (vdsatcv*d_Vt_dTemp_t_GND+d_vdsatcv_dTemp_t_GND*Vt);
d_VdsatCV_dV_si_bi = d_vdsatcv_dV_si_bi*Vt;
d_VdsatCV_dV_di_bi = d_vdsatcv_dV_di_bi*Vt;
d_VdsatCV_dV_gi_bi = d_vdsatcv_dV_gi_bi*Vt;
d_VdsatCV_dV_sbulk_si = d_vdsatcv_dV_sbulk_si*Vt;
d_VdsatCV_dV_dbulk_di = d_vdsatcv_dV_dbulk_di*Vt;
VdsatCV = (vdsatcv*Vt);
{
double value_sqrt_0 = sqrt(((((VdsatCV-Vs))*((VdsatCV-Vs)))+((0.25*1e-3)*1e-3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_VdssatCV_dTemp_t_GND = 0.5*(d_VdsatCV_dTemp_t_GND+(deriv_sqrt_0_d0*((((VdsatCV-Vs))*d_VdsatCV_dTemp_t_GND+d_VdsatCV_dTemp_t_GND*((VdsatCV-Vs))))));
d_VdssatCV_dV_si_bi = 0.5*((d_VdsatCV_dV_si_bi-d_Vs_dV_si_bi)+(deriv_sqrt_0_d0*((((VdsatCV-Vs))*(d_VdsatCV_dV_si_bi-d_Vs_dV_si_bi)+(d_VdsatCV_dV_si_bi-d_Vs_dV_si_bi)*((VdsatCV-Vs))))));
d_VdssatCV_dV_di_bi = 0.5*((d_VdsatCV_dV_di_bi-d_Vs_dV_di_bi)+(deriv_sqrt_0_d0*((((VdsatCV-Vs))*(d_VdsatCV_dV_di_bi-d_Vs_dV_di_bi)+(d_VdsatCV_dV_di_bi-d_Vs_dV_di_bi)*((VdsatCV-Vs))))));
d_VdssatCV_dV_gi_bi = 0.5*(d_VdsatCV_dV_gi_bi+(deriv_sqrt_0_d0*((((VdsatCV-Vs))*d_VdsatCV_dV_gi_bi+d_VdsatCV_dV_gi_bi*((VdsatCV-Vs))))));
d_VdssatCV_dV_sbulk_si = 0.5*(d_VdsatCV_dV_sbulk_si+(deriv_sqrt_0_d0*((((VdsatCV-Vs))*d_VdsatCV_dV_sbulk_si+d_VdsatCV_dV_sbulk_si*((VdsatCV-Vs))))));
d_VdssatCV_dV_dbulk_di = 0.5*(d_VdsatCV_dV_dbulk_di+(deriv_sqrt_0_d0*((((VdsatCV-Vs))*d_VdsatCV_dV_dbulk_di+d_VdsatCV_dV_dbulk_di*((VdsatCV-Vs))))));
VdssatCV = (0.5*((VdsatCV-Vs)+value_sqrt_0));
}
{
double value_pow_0 = pow((Vds/VdssatCV),(1.0/DELTA_t));
double  deriv_pow_0_d0 = (((Vds/VdssatCV) == 0.0)?0.0:(value_pow_0*(1.0/DELTA_t)/(Vds/VdssatCV)));
double  deriv_pow_0_d1 = ((Vds/VdssatCV) == 0.0)?0.0:(log((Vds/VdssatCV))*value_pow_0);

d_T7_dV_gm_si = d_T7_dV_gm_di =  0.0;
d_T7_dTemp_t_GND = ((deriv_pow_0_d0*((-Vds*d_VdssatCV_dTemp_t_GND/VdssatCV/VdssatCV)))+(deriv_pow_0_d1*((-d_DELTA_t_dTemp_t_GND/DELTA_t/DELTA_t))));
d_T7_dV_gi_bi = (deriv_pow_0_d0*((-Vds*d_VdssatCV_dV_gi_bi/VdssatCV/VdssatCV)));
d_T7_dV_sbulk_si = (deriv_pow_0_d0*((-Vds*d_VdssatCV_dV_sbulk_si/VdssatCV/VdssatCV)));
d_T7_dV_dbulk_di = (deriv_pow_0_d0*((-Vds*d_VdssatCV_dV_dbulk_di/VdssatCV/VdssatCV)));
d_T7_dV_si_bi = (deriv_pow_0_d0*(((VdssatCV*d_Vds_dV_si_bi-Vds*d_VdssatCV_dV_si_bi)/VdssatCV/VdssatCV)));
d_T7_dV_di_bi = (deriv_pow_0_d0*(((VdssatCV*d_Vds_dV_di_bi-Vds*d_VdssatCV_dV_di_bi)/VdssatCV/VdssatCV)));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),(-DELTA_t));
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*(-DELTA_t)/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);

d_T8_dV_gm_di = d_T8_dV_gm_si =  0.0;
d_T8_dTemp_t_GND = ((deriv_pow_0_d0*(d_T7_dTemp_t_GND))+(deriv_pow_0_d1*((-d_DELTA_t_dTemp_t_GND))));
d_T8_dV_si_bi = (deriv_pow_0_d0*(d_T7_dV_si_bi));
d_T8_dV_di_bi = (deriv_pow_0_d0*(d_T7_dV_di_bi));
d_T8_dV_gi_bi = (deriv_pow_0_d0*(d_T7_dV_gi_bi));
d_T8_dV_sbulk_si = (deriv_pow_0_d0*(d_T7_dV_sbulk_si));
d_T8_dV_dbulk_di = (deriv_pow_0_d0*(d_T7_dV_dbulk_di));
T8 = value_pow_0;
}

d_Vdseff_dV_gm_di = d_Vdseff_dV_gm_si =  0.0;
d_Vdseff_dTemp_t_GND = Vds*d_T8_dTemp_t_GND;
d_Vdseff_dV_gi_bi = Vds*d_T8_dV_gi_bi;
d_Vdseff_dV_sbulk_si = Vds*d_T8_dV_sbulk_si;
d_Vdseff_dV_dbulk_di = Vds*d_T8_dV_dbulk_di;
d_Vdseff_dV_si_bi = (Vds*d_T8_dV_si_bi+d_Vds_dV_si_bi*T8);
d_Vdseff_dV_di_bi = (Vds*d_T8_dV_di_bi+d_Vds_dV_di_bi*T8);
Vdseff = (Vds*T8);

d_vdeff_dV_gm_di = d_vdeff_dV_gm_si =  0.0;
d_vdeff_dTemp_t_GND = ((Vdseff+Vs)*d_inv_Vt_dTemp_t_GND+d_Vdseff_dTemp_t_GND*inv_Vt);
d_vdeff_dV_gi_bi = d_Vdseff_dV_gi_bi*inv_Vt;
d_vdeff_dV_si_bi = (d_Vdseff_dV_si_bi+d_Vs_dV_si_bi)*inv_Vt;
d_vdeff_dV_di_bi = (d_Vdseff_dV_di_bi+d_Vs_dV_di_bi)*inv_Vt;
d_vdeff_dV_sbulk_si = d_Vdseff_dV_sbulk_si*inv_Vt;
d_vdeff_dV_dbulk_di = d_Vdseff_dV_dbulk_di*inv_Vt;
vdeff = ((Vdseff+Vs)*inv_Vt);
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_T8_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_T8_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_T8_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
d_T8_dV_sbulk_si = 0.5*(d_psip_dV_sbulk_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_sbulk_si+d_psip_dV_sbulk_si*(psip-1.0)))));
d_T8_dV_dbulk_di = 0.5*(d_psip_dV_dbulk_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_dbulk_di+d_psip_dV_dbulk_di*(psip-1.0)))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dV_gm_di = d_sqrtpsip_dV_gm_si =  0.0;
d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T8_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_T8_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_T8_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_T8_dV_gi_bi));
d_sqrtpsip_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T8_dV_sbulk_si));
d_sqrtpsip_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T8_dV_dbulk_di));
sqrtpsip = value_sqrt_0;
}

d_T9_dV_gm_si = d_T9_dV_gm_di =  0.0;
d_T9_dV_gi_bi = (((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_sbulk_si = (((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_dbulk_di = (((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dTemp_t_GND = (((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_si_bi = (((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_di_bi = (((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));

d_T0_dV_gm_di = d_T0_dV_gm_si =  0.0;
d_T0_dV_gi_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gi_bi)/gam/gam);
d_T0_dV_sbulk_si = ((gam*(((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_sbulk_si)/gam/gam);
d_T0_dV_dbulk_di = ((gam*(((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_dbulk_di)/gam/gam);
d_T0_dTemp_t_GND = ((gam*(((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dTemp_t_GND)/gam/gam);
d_T0_dV_si_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_si_bi)/gam/gam);
d_T0_dV_di_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_di_bi)/gam/gam);
T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_dTemp_t_GND)-d_vdeff_dTemp_t_GND);
d_T1_dV_si_bi = (d_psip_dV_si_bi-d_vdeff_dV_si_bi);
d_T1_dV_di_bi = (d_psip_dV_di_bi-d_vdeff_dV_di_bi);
d_T1_dV_gi_bi = (d_psip_dV_gi_bi-d_vdeff_dV_gi_bi);
d_T1_dV_sbulk_si = (d_psip_dV_sbulk_si-d_vdeff_dV_sbulk_si);
d_T1_dV_dbulk_di = (d_psip_dV_dbulk_di-d_vdeff_dV_dbulk_di);
T1 = ((psip-(2.0*phib))-vdeff);
{
double value_log_0 = log(((4.0*T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*T0)*sqrtpsip));

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dTemp_t_GND+4.0*d_T0_dTemp_t_GND*sqrtpsip))));
d_T2_dV_si_bi = (d_T1_dV_si_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_si_bi+4.0*d_T0_dV_si_bi*sqrtpsip))));
d_T2_dV_di_bi = (d_T1_dV_di_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_di_bi+4.0*d_T0_dV_di_bi*sqrtpsip))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gi_bi+4.0*d_T0_dV_gi_bi*sqrtpsip))));
d_T2_dV_sbulk_si = (d_T1_dV_sbulk_si-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_sbulk_si+4.0*d_T0_dV_sbulk_si*sqrtpsip))));
d_T2_dV_dbulk_di = (d_T1_dV_dbulk_di-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_dbulk_di+4.0*d_T0_dV_dbulk_di*sqrtpsip))));
T2 = (T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((T2*(T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dV_gm_di = d_T8_dV_gm_si =  0.0;
d_T8_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND-(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*(T2+0.402982)))));
d_T8_dV_si_bi = 0.5*(d_T2_dV_si_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*(T2+0.402982)))));
d_T8_dV_di_bi = 0.5*(d_T2_dV_di_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*(T2+0.402982)))));
d_T8_dV_gi_bi = 0.5*(d_T2_dV_gi_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*(T2+0.402982)))));
d_T8_dV_sbulk_si = 0.5*(d_T2_dV_sbulk_si-(deriv_sqrt_0_d0*((T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*(T2+0.402982)))));
d_T8_dV_dbulk_di = 0.5*(d_T2_dV_dbulk_di-(deriv_sqrt_0_d0*((T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*(T2+0.402982)))));
T8 = (0.5*((T2-0.201491)-value_sqrt_0));
}

d_sqrtpsisa_dV_gm_di = d_sqrtpsisa_dV_gm_si =  0.0;
d_sqrtpsisa_dTemp_t_GND = d_sqrtpsip_dTemp_t_GND;
d_sqrtpsisa_dV_si_bi = d_sqrtpsip_dV_si_bi;
d_sqrtpsisa_dV_di_bi = d_sqrtpsip_dV_di_bi;
d_sqrtpsisa_dV_gi_bi = d_sqrtpsip_dV_gi_bi;
d_sqrtpsisa_dV_sbulk_si = d_sqrtpsip_dV_sbulk_si;
d_sqrtpsisa_dV_dbulk_di = d_sqrtpsip_dV_dbulk_di;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dV_di_bi = d_T4_dV_si_bi = d_T4_dTemp_t_GND =  0.0;
T4 = (-100.0);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T4_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T4_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T4_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T4_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T4_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T4_dV_dbulk_di));
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
T3 = value_exp_0;
}
}
else
{

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = ((T5*(d_T8_dTemp_t_GND-d_T4_dTemp_t_GND)-(T8-T4)*d_T5_dTemp_t_GND)/T5/T5);
d_T2_dV_si_bi = ((T5*(d_T8_dV_si_bi-d_T4_dV_si_bi)-(T8-T4)*d_T5_dV_si_bi)/T5/T5);
d_T2_dV_di_bi = ((T5*(d_T8_dV_di_bi-d_T4_dV_di_bi)-(T8-T4)*d_T5_dV_di_bi)/T5/T5);
d_T2_dV_gi_bi = ((T5*(d_T8_dV_gi_bi-d_T4_dV_gi_bi)-(T8-T4)*d_T5_dV_gi_bi)/T5/T5);
d_T2_dV_sbulk_si = ((T5*(d_T8_dV_sbulk_si-d_T4_dV_sbulk_si)-(T8-T4)*d_T5_dV_sbulk_si)/T5/T5);
d_T2_dV_dbulk_di = ((T5*(d_T8_dV_dbulk_di-d_T4_dV_dbulk_di)-(T8-T4)*d_T5_dV_dbulk_di)/T5/T5);
T2 = ((T8-T4)/T5);

d_T6_dV_gm_di = d_T6_dV_gm_si =  0.0;
d_T6_dTemp_t_GND = (T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2);
d_T6_dV_si_bi = (T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2);
d_T6_dV_di_bi = (T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2);
d_T6_dV_gi_bi = (T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2);
d_T6_dV_sbulk_si = (T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*T2);
d_T6_dV_dbulk_di = (T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*T2);
T6 = (T2*T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*((d_T4_dTemp_t_GND+(T5*(0.5*d_T2_dTemp_t_GND+(T6*(-(T6*(-d_T6_dTemp_t_GND)+d_T6_dTemp_t_GND*(1.25-T6)))+d_T6_dTemp_t_GND*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dTemp_t_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_si_bi = (deriv_exp_0_d0*((d_T4_dV_si_bi+(T5*(0.5*d_T2_dV_si_bi+(T6*(-(T6*(-d_T6_dV_si_bi)+d_T6_dV_si_bi*(1.25-T6)))+d_T6_dV_si_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_si_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_di_bi = (deriv_exp_0_d0*((d_T4_dV_di_bi+(T5*(0.5*d_T2_dV_di_bi+(T6*(-(T6*(-d_T6_dV_di_bi)+d_T6_dV_di_bi*(1.25-T6)))+d_T6_dV_di_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_di_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((d_T4_dV_gi_bi+(T5*(0.5*d_T2_dV_gi_bi+(T6*(-(T6*(-d_T6_dV_gi_bi)+d_T6_dV_gi_bi*(1.25-T6)))+d_T6_dV_gi_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*((d_T4_dV_sbulk_si+(T5*(0.5*d_T2_dV_sbulk_si+(T6*(-(T6*(-d_T6_dV_sbulk_si)+d_T6_dV_sbulk_si*(1.25-T6)))+d_T6_dV_sbulk_si*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_sbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*((d_T4_dV_dbulk_di+(T5*(0.5*d_T2_dV_dbulk_di+(T6*(-(T6*(-d_T6_dV_dbulk_di)+d_T6_dV_dbulk_di*(1.25-T6)))+d_T6_dV_dbulk_di*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_dbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_qdeff_dV_gm_si = d_qdeff_dV_gm_di =  0.0;
d_qdeff_dTemp_t_GND = (T3*((d_T1_dTemp_t_GND-d_T8_dTemp_t_GND)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+2.0*d_T0_dTemp_t_GND*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dTemp_t_GND*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_si_bi = (T3*((d_T1_dV_si_bi-d_T8_dV_si_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+2.0*d_T0_dV_si_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_si_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_di_bi = (T3*((d_T1_dV_di_bi-d_T8_dV_di_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+2.0*d_T0_dV_di_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_di_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_gi_bi = (T3*((d_T1_dV_gi_bi-d_T8_dV_gi_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+2.0*d_T0_dV_gi_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gi_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_sbulk_si = (T3*((d_T1_dV_sbulk_si-d_T8_dV_sbulk_si)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+2.0*d_T0_dV_sbulk_si*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_sbulk_si*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_dbulk_di = (T3*((d_T1_dV_dbulk_di-d_T8_dV_dbulk_di)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+2.0*d_T0_dV_dbulk_di*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_dbulk_di*(((1.0+T1)-T8)-value_log_0));
qdeff = (T3*(((1.0+T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
T3 = value_exp_0;
}

d_sqrtpsisainv_dV_gm_di = d_sqrtpsisainv_dV_gm_si =  0.0;
d_sqrtpsisainv_dTemp_t_GND = (-d_sqrtpsisa_dTemp_t_GND/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_si_bi = (-d_sqrtpsisa_dV_si_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_di_bi = (-d_sqrtpsisa_dV_di_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gi_bi = (-d_sqrtpsisa_dV_gi_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_sbulk_si = (-d_sqrtpsisa_dV_sbulk_si/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_dbulk_di = (-d_sqrtpsisa_dV_dbulk_di/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (d_T3_dTemp_t_GND-((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5));
d_T3_dV_si_bi = (d_T3_dV_si_bi-((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5));
d_T3_dV_di_bi = (d_T3_dV_di_bi-((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5));
d_T3_dV_gi_bi = (d_T3_dV_gi_bi-((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5));
d_T3_dV_sbulk_si = (d_T3_dV_sbulk_si-((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5));
d_T3_dV_dbulk_di = (d_T3_dV_dbulk_di-((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T6_dV_gm_di = d_T6_dV_gm_si =  0.0;
d_T6_dTemp_t_GND = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_si_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_di_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gi_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_sbulk_si = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_dbulk_di = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T7_dV_gm_si = d_T7_dV_gm_di =  0.0;
d_T7_dTemp_t_GND = (((-((1.0/T3)*(-d_T3_dTemp_t_GND/T3/T3)+(-d_T3_dTemp_t_GND/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dTemp_t_GND+(sqrtpsisa*d_sqrtpsisa_dTemp_t_GND+d_sqrtpsisa_dTemp_t_GND*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dTemp_t_GND);
d_T7_dV_si_bi = (((-((1.0/T3)*(-d_T3_dV_si_bi/T3/T3)+(-d_T3_dV_si_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_si_bi+(sqrtpsisa*d_sqrtpsisa_dV_si_bi+d_sqrtpsisa_dV_si_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_si_bi);
d_T7_dV_di_bi = (((-((1.0/T3)*(-d_T3_dV_di_bi/T3/T3)+(-d_T3_dV_di_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_di_bi+(sqrtpsisa*d_sqrtpsisa_dV_di_bi+d_sqrtpsisa_dV_di_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_di_bi);
d_T7_dV_gi_bi = (((-((1.0/T3)*(-d_T3_dV_gi_bi/T3/T3)+(-d_T3_dV_gi_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gi_bi+(sqrtpsisa*d_sqrtpsisa_dV_gi_bi+d_sqrtpsisa_dV_gi_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gi_bi);
d_T7_dV_sbulk_si = (((-((1.0/T3)*(-d_T3_dV_sbulk_si/T3/T3)+(-d_T3_dV_sbulk_si/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_sbulk_si+(sqrtpsisa*d_sqrtpsisa_dV_sbulk_si+d_sqrtpsisa_dV_sbulk_si*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_sbulk_si);
d_T7_dV_dbulk_di = (((-((1.0/T3)*(-d_T3_dV_dbulk_di/T3/T3)+(-d_T3_dV_dbulk_di/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_dbulk_di+(sqrtpsisa*d_sqrtpsisa_dV_dbulk_di+d_sqrtpsisa_dV_dbulk_di*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_dbulk_di);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);

d_qdeff_dV_gm_si = d_qdeff_dV_gm_di =  0.0;
d_qdeff_dTemp_t_GND = (d_T3_dTemp_t_GND-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dTemp_t_GND+d_T4_dTemp_t_GND*T7)-(T4*T7)*((2.0*T5)*d_T5_dTemp_t_GND+2.0*d_T5_dTemp_t_GND*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_si_bi = (d_T3_dV_si_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_si_bi+d_T4_dV_si_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_si_bi+2.0*d_T5_dV_si_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_di_bi = (d_T3_dV_di_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_di_bi+d_T4_dV_di_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_di_bi+2.0*d_T5_dV_di_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_gi_bi = (d_T3_dV_gi_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gi_bi+d_T4_dV_gi_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gi_bi+2.0*d_T5_dV_gi_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_sbulk_si = (d_T3_dV_sbulk_si-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_sbulk_si+d_T4_dV_sbulk_si*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_sbulk_si+2.0*d_T5_dV_sbulk_si*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_dbulk_di = (d_T3_dV_dbulk_di-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_dbulk_di+d_T4_dV_dbulk_di*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_dbulk_di+2.0*d_T5_dV_dbulk_di*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}

d_psiavg_dV_gm_di = d_psiavg_dV_gm_si =  0.0;
d_psiavg_dTemp_t_GND = ((d_psip_dTemp_t_GND-d_qs_dTemp_t_GND)-d_qdeff_dTemp_t_GND);
d_psiavg_dV_si_bi = ((d_psip_dV_si_bi-d_qs_dV_si_bi)-d_qdeff_dV_si_bi);
d_psiavg_dV_di_bi = ((d_psip_dV_di_bi-d_qs_dV_di_bi)-d_qdeff_dV_di_bi);
d_psiavg_dV_gi_bi = ((d_psip_dV_gi_bi-d_qs_dV_gi_bi)-d_qdeff_dV_gi_bi);
d_psiavg_dV_sbulk_si = ((d_psip_dV_sbulk_si-d_qs_dV_sbulk_si)-d_qdeff_dV_sbulk_si);
d_psiavg_dV_dbulk_di = ((d_psip_dV_dbulk_di-d_qs_dV_dbulk_di)-d_qdeff_dV_dbulk_di);
psiavg = (((psip-qs)-qdeff)-1.0);
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_gm_di = d_T0_dV_gm_si =  0.0;
d_T0_dTemp_t_GND = 0.5*(d_psiavg_dTemp_t_GND+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dTemp_t_GND+d_psiavg_dTemp_t_GND*(psiavg-1.0)))));
d_T0_dV_si_bi = 0.5*(d_psiavg_dV_si_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_si_bi+d_psiavg_dV_si_bi*(psiavg-1.0)))));
d_T0_dV_di_bi = 0.5*(d_psiavg_dV_di_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_di_bi+d_psiavg_dV_di_bi*(psiavg-1.0)))));
d_T0_dV_gi_bi = 0.5*(d_psiavg_dV_gi_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_gi_bi+d_psiavg_dV_gi_bi*(psiavg-1.0)))));
d_T0_dV_sbulk_si = 0.5*(d_psiavg_dV_sbulk_si+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_sbulk_si+d_psiavg_dV_sbulk_si*(psiavg-1.0)))));
d_T0_dV_dbulk_di = 0.5*(d_psiavg_dV_dbulk_di+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_dbulk_di+d_psiavg_dV_dbulk_di*(psiavg-1.0)))));
T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T0_dTemp_t_GND));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*(d_T0_dV_si_bi));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*(d_T0_dV_di_bi));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*(d_T0_dV_gi_bi));
d_T2_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T0_dV_sbulk_si));
d_T2_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T0_dV_dbulk_di));
T2 = value_sqrt_0;
}

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dV_gi_bi = (((sqrtpsip+T2)*d_gam_dV_gi_bi-gam*(d_sqrtpsip_dV_gi_bi+d_T2_dV_gi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_T3_dV_sbulk_si = (((sqrtpsip+T2)*d_gam_dV_sbulk_si-gam*(d_sqrtpsip_dV_sbulk_si+d_T2_dV_sbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_T3_dV_dbulk_di = (((sqrtpsip+T2)*d_gam_dV_dbulk_di-gam*(d_sqrtpsip_dV_dbulk_di+d_T2_dV_dbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_T3_dTemp_t_GND = (((sqrtpsip+T2)*d_gam_dTemp_t_GND-gam*(d_sqrtpsip_dTemp_t_GND+d_T2_dTemp_t_GND))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_T3_dV_si_bi = (((sqrtpsip+T2)*d_gam_dV_si_bi-gam*(d_sqrtpsip_dV_si_bi+d_T2_dV_si_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_T3_dV_di_bi = (((sqrtpsip+T2)*d_gam_dV_di_bi-gam*(d_sqrtpsip_dV_di_bi+d_T2_dV_di_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
T3 = ((1.0+DPD)+(gam/(sqrtpsip+T2)));

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = ((DPD*T2)*d_inv_gam_dTemp_t_GND+DPD*d_T2_dTemp_t_GND*inv_gam);
d_T4_dV_si_bi = ((DPD*T2)*d_inv_gam_dV_si_bi+DPD*d_T2_dV_si_bi*inv_gam);
d_T4_dV_di_bi = ((DPD*T2)*d_inv_gam_dV_di_bi+DPD*d_T2_dV_di_bi*inv_gam);
d_T4_dV_gi_bi = ((DPD*T2)*d_inv_gam_dV_gi_bi+DPD*d_T2_dV_gi_bi*inv_gam);
d_T4_dV_sbulk_si = ((DPD*T2)*d_inv_gam_dV_sbulk_si+DPD*d_T2_dV_sbulk_si*inv_gam);
d_T4_dV_dbulk_di = ((DPD*T2)*d_inv_gam_dV_dbulk_di+DPD*d_T2_dV_dbulk_di*inv_gam);
T4 = (0.5+((DPD*T2)*inv_gam));
{
double value_sqrt_0 = sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dTemp_t_GND = (deriv_sqrt_0_d0*(((T4*d_T4_dTemp_t_GND+d_T4_dTemp_t_GND*T4)+((T3*(qs+qdeff))*d_invgamg2_dTemp_t_GND+(T3*(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+d_T3_dTemp_t_GND*(qs+qdeff))*invgamg2))));
d_T5_dV_si_bi = (deriv_sqrt_0_d0*(((T4*d_T4_dV_si_bi+d_T4_dV_si_bi*T4)+(T3*(d_qs_dV_si_bi+d_qdeff_dV_si_bi)+d_T3_dV_si_bi*(qs+qdeff))*invgamg2)));
d_T5_dV_di_bi = (deriv_sqrt_0_d0*(((T4*d_T4_dV_di_bi+d_T4_dV_di_bi*T4)+(T3*(d_qs_dV_di_bi+d_qdeff_dV_di_bi)+d_T3_dV_di_bi*(qs+qdeff))*invgamg2)));
d_T5_dV_gi_bi = (deriv_sqrt_0_d0*(((T4*d_T4_dV_gi_bi+d_T4_dV_gi_bi*T4)+(T3*(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+d_T3_dV_gi_bi*(qs+qdeff))*invgamg2)));
d_T5_dV_sbulk_si = (deriv_sqrt_0_d0*(((T4*d_T4_dV_sbulk_si+d_T4_dV_sbulk_si*T4)+(T3*(d_qs_dV_sbulk_si+d_qdeff_dV_sbulk_si)+d_T3_dV_sbulk_si*(qs+qdeff))*invgamg2)));
d_T5_dV_dbulk_di = (deriv_sqrt_0_d0*(((T4*d_T4_dV_dbulk_di+d_T4_dV_dbulk_di*T4)+(T3*(d_qs_dV_dbulk_di+d_qdeff_dV_dbulk_di)+d_T3_dV_dbulk_di*(qs+qdeff))*invgamg2)));
T5 = value_sqrt_0;
}

d_nq_dV_gm_si = d_nq_dV_gm_di =  0.0;
d_nq_dTemp_t_GND = (((T4+T5)*d_T3_dTemp_t_GND-T3*(d_T4_dTemp_t_GND+d_T5_dTemp_t_GND))/(T4+T5)/(T4+T5));
d_nq_dV_si_bi = (((T4+T5)*d_T3_dV_si_bi-T3*(d_T4_dV_si_bi+d_T5_dV_si_bi))/(T4+T5)/(T4+T5));
d_nq_dV_di_bi = (((T4+T5)*d_T3_dV_di_bi-T3*(d_T4_dV_di_bi+d_T5_dV_di_bi))/(T4+T5)/(T4+T5));
d_nq_dV_gi_bi = (((T4+T5)*d_T3_dV_gi_bi-T3*(d_T4_dV_gi_bi+d_T5_dV_gi_bi))/(T4+T5)/(T4+T5));
d_nq_dV_sbulk_si = (((T4+T5)*d_T3_dV_sbulk_si-T3*(d_T4_dV_sbulk_si+d_T5_dV_sbulk_si))/(T4+T5)/(T4+T5));
d_nq_dV_dbulk_di = (((T4+T5)*d_T3_dV_dbulk_di-T3*(d_T4_dV_dbulk_di+d_T5_dV_dbulk_di))/(T4+T5)/(T4+T5));
nq = (T3/(T4+T5));

d_T0_dV_gm_di = d_T0_dV_gm_si =  0.0;
d_T0_dV_sbulk_si = Vt*((-d_psip_dV_sbulk_si)-((2.0*qs)*d_nq_dV_sbulk_si+2.0*d_qs_dV_sbulk_si*(nq-1.0)));
d_T0_dV_dbulk_di = Vt*((-d_psip_dV_dbulk_di)-((2.0*qs)*d_nq_dV_dbulk_di+2.0*d_qs_dV_dbulk_di*(nq-1.0)));
d_T0_dV_si_bi = Vt*((d_vgfbCV_dV_si_bi-d_psip_dV_si_bi)-((2.0*qs)*d_nq_dV_si_bi+2.0*d_qs_dV_si_bi*(nq-1.0)));
d_T0_dV_di_bi = Vt*((d_vgfbCV_dV_di_bi-d_psip_dV_di_bi)-((2.0*qs)*d_nq_dV_di_bi+2.0*d_qs_dV_di_bi*(nq-1.0)));
d_T0_dV_gi_bi = Vt*((d_vgfbCV_dV_gi_bi-d_psip_dV_gi_bi)-((2.0*qs)*d_nq_dV_gi_bi+2.0*d_qs_dV_gi_bi*(nq-1.0)));
d_T0_dTemp_t_GND = (Vt*((d_vgfbCV_dTemp_t_GND-d_psip_dTemp_t_GND)-((2.0*qs)*d_nq_dTemp_t_GND+2.0*d_qs_dTemp_t_GND*(nq-1.0)))+d_Vt_dTemp_t_GND*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((T0)*(T0))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qbs_dTemp_t_GND = 0.5*(d_T0_dTemp_t_GND+(deriv_sqrt_0_d0*(((T0)*d_T0_dTemp_t_GND+d_T0_dTemp_t_GND*(T0)))));
d_qbs_dV_si_bi = 0.5*(d_T0_dV_si_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_si_bi+d_T0_dV_si_bi*(T0)))));
d_qbs_dV_di_bi = 0.5*(d_T0_dV_di_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_di_bi+d_T0_dV_di_bi*(T0)))));
d_qbs_dV_gi_bi = 0.5*(d_T0_dV_gi_bi+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_gi_bi+d_T0_dV_gi_bi*(T0)))));
d_qbs_dV_sbulk_si = 0.5*(d_T0_dV_sbulk_si+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_sbulk_si+d_T0_dV_sbulk_si*(T0)))));
d_qbs_dV_dbulk_di = 0.5*(d_T0_dV_dbulk_di+(deriv_sqrt_0_d0*(((T0)*d_T0_dV_dbulk_di+d_T0_dV_dbulk_di*(T0)))));
qbs = (0.5*(T0+value_sqrt_0));
}

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dV_sbulk_si = Vt*((-d_psip_dV_sbulk_si)-((2.0*qdeff)*d_nq_dV_sbulk_si+2.0*d_qdeff_dV_sbulk_si*(nq-1.0)));
d_T1_dV_dbulk_di = Vt*((-d_psip_dV_dbulk_di)-((2.0*qdeff)*d_nq_dV_dbulk_di+2.0*d_qdeff_dV_dbulk_di*(nq-1.0)));
d_T1_dV_si_bi = Vt*((d_vgfbCV_dV_si_bi-d_psip_dV_si_bi)-((2.0*qdeff)*d_nq_dV_si_bi+2.0*d_qdeff_dV_si_bi*(nq-1.0)));
d_T1_dV_di_bi = Vt*((d_vgfbCV_dV_di_bi-d_psip_dV_di_bi)-((2.0*qdeff)*d_nq_dV_di_bi+2.0*d_qdeff_dV_di_bi*(nq-1.0)));
d_T1_dV_gi_bi = Vt*((d_vgfbCV_dV_gi_bi-d_psip_dV_gi_bi)-((2.0*qdeff)*d_nq_dV_gi_bi+2.0*d_qdeff_dV_gi_bi*(nq-1.0)));
d_T1_dTemp_t_GND = (Vt*((d_vgfbCV_dTemp_t_GND-d_psip_dTemp_t_GND)-((2.0*qdeff)*d_nq_dTemp_t_GND+2.0*d_qdeff_dTemp_t_GND*(nq-1.0)))+d_Vt_dTemp_t_GND*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))));
T1 = (Vt*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((T1)*(T1))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qbd_dTemp_t_GND = 0.5*(d_T1_dTemp_t_GND+(deriv_sqrt_0_d0*(((T1)*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*(T1)))));
d_qbd_dV_si_bi = 0.5*(d_T1_dV_si_bi+(deriv_sqrt_0_d0*(((T1)*d_T1_dV_si_bi+d_T1_dV_si_bi*(T1)))));
d_qbd_dV_di_bi = 0.5*(d_T1_dV_di_bi+(deriv_sqrt_0_d0*(((T1)*d_T1_dV_di_bi+d_T1_dV_di_bi*(T1)))));
d_qbd_dV_gi_bi = 0.5*(d_T1_dV_gi_bi+(deriv_sqrt_0_d0*(((T1)*d_T1_dV_gi_bi+d_T1_dV_gi_bi*(T1)))));
d_qbd_dV_sbulk_si = 0.5*(d_T1_dV_sbulk_si+(deriv_sqrt_0_d0*(((T1)*d_T1_dV_sbulk_si+d_T1_dV_sbulk_si*(T1)))));
d_qbd_dV_dbulk_di = 0.5*(d_T1_dV_dbulk_di+(deriv_sqrt_0_d0*(((T1)*d_T1_dV_dbulk_di+d_T1_dV_dbulk_di*(T1)))));
qbd = (0.5*(T1+value_sqrt_0));
}

d_qb_dTemp_t_GND = 0.5*(d_qbs_dTemp_t_GND+d_qbd_dTemp_t_GND);
d_qb_dV_si_bi = 0.5*(d_qbs_dV_si_bi+d_qbd_dV_si_bi);
d_qb_dV_di_bi = 0.5*(d_qbs_dV_di_bi+d_qbd_dV_di_bi);
d_qb_dV_gi_bi = 0.5*(d_qbs_dV_gi_bi+d_qbd_dV_gi_bi);
d_qb_dV_sbulk_si = 0.5*(d_qbs_dV_sbulk_si+d_qbd_dV_sbulk_si);
d_qb_dV_dbulk_di = 0.5*(d_qbs_dV_dbulk_di+d_qbd_dV_dbulk_di);
qb = (0.5*(qbs+qbd));

d_qia_dV_si_bi = ((nq*Vt)*(d_qs_dV_si_bi+d_qdeff_dV_si_bi)+d_nq_dV_si_bi*Vt*(qs+qdeff));
d_qia_dV_di_bi = ((nq*Vt)*(d_qs_dV_di_bi+d_qdeff_dV_di_bi)+d_nq_dV_di_bi*Vt*(qs+qdeff));
d_qia_dTemp_t_GND = ((nq*Vt)*(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+(nq*d_Vt_dTemp_t_GND+d_nq_dTemp_t_GND*Vt)*(qs+qdeff));
d_qia_dV_gi_bi = ((nq*Vt)*(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+d_nq_dV_gi_bi*Vt*(qs+qdeff));
d_qia_dV_sbulk_si = ((nq*Vt)*(d_qs_dV_sbulk_si+d_qdeff_dV_sbulk_si)+d_nq_dV_sbulk_si*Vt*(qs+qdeff));
d_qia_dV_dbulk_di = ((nq*Vt)*(d_qs_dV_dbulk_di+d_qdeff_dV_dbulk_di)+d_nq_dV_dbulk_di*Vt*(qs+qdeff));
qia = ((nq*Vt)*(qs+qdeff));

d_Eeffm_dTemp_t_GND = EeffFactor*(d_qb_dTemp_t_GND+eta_mu*d_qia_dTemp_t_GND);
d_Eeffm_dV_si_bi = EeffFactor*(d_qb_dV_si_bi+eta_mu*d_qia_dV_si_bi);
d_Eeffm_dV_di_bi = EeffFactor*(d_qb_dV_di_bi+eta_mu*d_qia_dV_di_bi);
d_Eeffm_dV_gi_bi = EeffFactor*(d_qb_dV_gi_bi+eta_mu*d_qia_dV_gi_bi);
d_Eeffm_dV_sbulk_si = EeffFactor*(d_qb_dV_sbulk_si+eta_mu*d_qia_dV_sbulk_si);
d_Eeffm_dV_dbulk_di = EeffFactor*(d_qb_dV_dbulk_di+eta_mu*d_qia_dV_dbulk_di);
Eeffm = (EeffFactor*(qb+(eta_mu*qia)));
{
double value_pow_0 = pow(Eeffm,EU_i);
double  deriv_pow_0_d0 = ((Eeffm == 0.0)?0.0:(value_pow_0*EU_i/Eeffm));

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dV_gi_bi = (UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_gi_bi));
d_T3_dV_sbulk_si = (UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_sbulk_si));
d_T3_dV_dbulk_di = (UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_dbulk_di));
d_T3_dV_si_bi = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_si_bi))+(d_UA_a_dV_si_bi+(UC_a*d_Vbsx_dV_si_bi+d_UC_a_dV_si_bi*Vbsx))*value_pow_0);
d_T3_dV_di_bi = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dV_di_bi))+(d_UA_a_dV_di_bi+(UC_a*d_Vbsx_dV_di_bi+d_UC_a_dV_di_bi*Vbsx))*value_pow_0);
d_T3_dTemp_t_GND = ((UA_a+(UC_a*Vbsx))*(deriv_pow_0_d0*(d_Eeffm_dTemp_t_GND))+(d_UA_a_dTemp_t_GND+d_UC_a_dTemp_t_GND*Vbsx)*value_pow_0);
T3 = ((UA_a+(UC_a*Vbsx))*value_pow_0);
}

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = d_T3_dTemp_t_GND;
d_T4_dV_si_bi = d_T3_dV_si_bi;
d_T4_dV_di_bi = d_T3_dV_di_bi;
d_T4_dV_gi_bi = d_T3_dV_gi_bi;
d_T4_dV_sbulk_si = d_T3_dV_sbulk_si;
d_T4_dV_dbulk_di = d_T3_dV_dbulk_di;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Dmob_dTemp_t_GND = 0.5*(d_T4_dTemp_t_GND+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dTemp_t_GND+d_T4_dTemp_t_GND*(T4-1.0)))));
d_Dmob_dV_si_bi = 0.5*(d_T4_dV_si_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_si_bi+d_T4_dV_si_bi*(T4-1.0)))));
d_Dmob_dV_di_bi = 0.5*(d_T4_dV_di_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_di_bi+d_T4_dV_di_bi*(T4-1.0)))));
d_Dmob_dV_gi_bi = 0.5*(d_T4_dV_gi_bi+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_gi_bi+d_T4_dV_gi_bi*(T4-1.0)))));
d_Dmob_dV_sbulk_si = 0.5*(d_T4_dV_sbulk_si+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_sbulk_si+d_T4_dV_sbulk_si*(T4-1.0)))));
d_Dmob_dV_dbulk_di = 0.5*(d_T4_dV_dbulk_di+(deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dV_dbulk_di+d_T4_dV_dbulk_di*(T4-1.0)))));
Dmob = (0.5*((T4+1.0)+value_sqrt_0));
}

d_LambdaC_dV_gi_bi = (2.0*(-U0_a*d_Dmob_dV_gi_bi/Dmob/Dmob)*Vt/(VSATCV_t*Lact));
d_LambdaC_dV_sbulk_si = (2.0*(-U0_a*d_Dmob_dV_sbulk_si/Dmob/Dmob)*Vt/(VSATCV_t*Lact));
d_LambdaC_dV_dbulk_di = (2.0*(-U0_a*d_Dmob_dV_dbulk_di/Dmob/Dmob)*Vt/(VSATCV_t*Lact));
d_LambdaC_dV_si_bi = (2.0*((Dmob*d_U0_a_dV_si_bi-U0_a*d_Dmob_dV_si_bi)/Dmob/Dmob)*Vt/(VSATCV_t*Lact));
d_LambdaC_dV_di_bi = (2.0*((Dmob*d_U0_a_dV_di_bi-U0_a*d_Dmob_dV_di_bi)/Dmob/Dmob)*Vt/(VSATCV_t*Lact));
d_LambdaC_dTemp_t_GND = (((VSATCV_t*Lact)*((2.0*(U0_a/Dmob))*d_Vt_dTemp_t_GND+2.0*((Dmob*d_U0_a_dTemp_t_GND-U0_a*d_Dmob_dTemp_t_GND)/Dmob/Dmob)*Vt)-((2.0*(U0_a/Dmob))*Vt)*d_VSATCV_t_dTemp_t_GND*Lact)/(VSATCV_t*Lact)/(VSATCV_t*Lact));
LambdaC = (((2.0*(U0_a/Dmob))*Vt)/(VSATCV_t*Lact));

d_dps_dTemp_t_GND = (d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND);
d_dps_dV_si_bi = (d_qs_dV_si_bi-d_qdeff_dV_si_bi);
d_dps_dV_di_bi = (d_qs_dV_di_bi-d_qdeff_dV_di_bi);
d_dps_dV_gi_bi = (d_qs_dV_gi_bi-d_qdeff_dV_gi_bi);
d_dps_dV_sbulk_si = (d_qs_dV_sbulk_si-d_qdeff_dV_sbulk_si);
d_dps_dV_dbulk_di = (d_qs_dV_dbulk_di-d_qdeff_dV_dbulk_di);
dps = (qs-qdeff);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dV_gi_bi = ((2.0*(LambdaC*dps))*(LambdaC*d_dps_dV_gi_bi+d_LambdaC_dV_gi_bi*dps)+2.0*(LambdaC*d_dps_dV_gi_bi+d_LambdaC_dV_gi_bi*dps)*(LambdaC*dps));
d_T1_dV_si_bi = ((2.0*(LambdaC*dps))*(LambdaC*d_dps_dV_si_bi+d_LambdaC_dV_si_bi*dps)+2.0*(LambdaC*d_dps_dV_si_bi+d_LambdaC_dV_si_bi*dps)*(LambdaC*dps));
d_T1_dV_di_bi = ((2.0*(LambdaC*dps))*(LambdaC*d_dps_dV_di_bi+d_LambdaC_dV_di_bi*dps)+2.0*(LambdaC*d_dps_dV_di_bi+d_LambdaC_dV_di_bi*dps)*(LambdaC*dps));
d_T1_dTemp_t_GND = ((2.0*(LambdaC*dps))*(LambdaC*d_dps_dTemp_t_GND+d_LambdaC_dTemp_t_GND*dps)+2.0*(LambdaC*d_dps_dTemp_t_GND+d_LambdaC_dTemp_t_GND*dps)*(LambdaC*dps));
d_T1_dV_sbulk_si = ((2.0*(LambdaC*dps))*(LambdaC*d_dps_dV_sbulk_si+d_LambdaC_dV_sbulk_si*dps)+2.0*(LambdaC*d_dps_dV_sbulk_si+d_LambdaC_dV_sbulk_si*dps)*(LambdaC*dps));
d_T1_dV_dbulk_di = ((2.0*(LambdaC*dps))*(LambdaC*d_dps_dV_dbulk_di+d_LambdaC_dV_dbulk_di*dps)+2.0*(LambdaC*d_dps_dV_dbulk_di+d_LambdaC_dV_dbulk_di*dps)*(LambdaC*dps));
T1 = ((2.0*(LambdaC*dps))*(LambdaC*dps));
{
double value_sqrt_0 = sqrt((1.0+T1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zsat_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T1_dTemp_t_GND));
d_zsat_dV_si_bi = (deriv_sqrt_0_d0*(d_T1_dV_si_bi));
d_zsat_dV_di_bi = (deriv_sqrt_0_d0*(d_T1_dV_di_bi));
d_zsat_dV_gi_bi = (deriv_sqrt_0_d0*(d_T1_dV_gi_bi));
d_zsat_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T1_dV_sbulk_si));
d_zsat_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T1_dV_dbulk_di));
zsat = value_sqrt_0;
}

d_Dvsat_dTemp_t_GND = 0.5*d_zsat_dTemp_t_GND;
d_Dvsat_dV_si_bi = 0.5*d_zsat_dV_si_bi;
d_Dvsat_dV_di_bi = 0.5*d_zsat_dV_di_bi;
d_Dvsat_dV_gi_bi = 0.5*d_zsat_dV_gi_bi;
d_Dvsat_dV_sbulk_si = 0.5*d_zsat_dV_sbulk_si;
d_Dvsat_dV_dbulk_di = 0.5*d_zsat_dV_dbulk_di;
Dvsat = (0.5*(1.0+zsat));

d_Esat_dV_gi_bi = (-(2.0*VSATCV_t)*(-U0_a*d_Dmob_dV_gi_bi/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dV_sbulk_si = (-(2.0*VSATCV_t)*(-U0_a*d_Dmob_dV_sbulk_si/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dV_dbulk_di = (-(2.0*VSATCV_t)*(-U0_a*d_Dmob_dV_dbulk_di/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dV_si_bi = (-(2.0*VSATCV_t)*((Dmob*d_U0_a_dV_si_bi-U0_a*d_Dmob_dV_si_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dV_di_bi = (-(2.0*VSATCV_t)*((Dmob*d_U0_a_dV_di_bi-U0_a*d_Dmob_dV_di_bi)/Dmob/Dmob)/(U0_a/Dmob)/(U0_a/Dmob));
d_Esat_dTemp_t_GND = (((U0_a/Dmob)*2.0*d_VSATCV_t_dTemp_t_GND-(2.0*VSATCV_t)*((Dmob*d_U0_a_dTemp_t_GND-U0_a*d_Dmob_dTemp_t_GND)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
Esat = ((2.0*VSATCV_t)/(U0_a/Dmob));

d_EsatL_dV_gi_bi = d_Esat_dV_gi_bi*Lact;
d_EsatL_dV_si_bi = d_Esat_dV_si_bi*Lact;
d_EsatL_dV_di_bi = d_Esat_dV_di_bi*Lact;
d_EsatL_dTemp_t_GND = d_Esat_dTemp_t_GND*Lact;
d_EsatL_dV_sbulk_si = d_Esat_dV_sbulk_si*Lact;
d_EsatL_dV_dbulk_di = d_Esat_dV_dbulk_di*Lact;
EsatL = (Esat*Lact);

d_Vasat_dTemp_t_GND = (d_VdssatCV_dTemp_t_GND+d_EsatL_dTemp_t_GND);
d_Vasat_dV_si_bi = (d_VdssatCV_dV_si_bi+d_EsatL_dV_si_bi);
d_Vasat_dV_di_bi = (d_VdssatCV_dV_di_bi+d_EsatL_dV_di_bi);
d_Vasat_dV_gi_bi = (d_VdssatCV_dV_gi_bi+d_EsatL_dV_gi_bi);
d_Vasat_dV_sbulk_si = (d_VdssatCV_dV_sbulk_si+d_EsatL_dV_sbulk_si);
d_Vasat_dV_dbulk_di = (d_VdssatCV_dV_dbulk_di+d_EsatL_dV_dbulk_di);
Vasat = (VdssatCV+EsatL);

d_diffVds_dTemp_t_GND = (-d_Vdseff_dTemp_t_GND);
d_diffVds_dV_gi_bi = (-d_Vdseff_dV_gi_bi);
d_diffVds_dV_sbulk_si = (-d_Vdseff_dV_sbulk_si);
d_diffVds_dV_dbulk_di = (-d_Vdseff_dV_dbulk_di);
d_diffVds_dV_si_bi = (d_Vds_dV_si_bi-d_Vdseff_dV_si_bi);
d_diffVds_dV_di_bi = (d_Vds_dV_di_bi-d_Vdseff_dV_di_bi);
diffVds = (Vds-Vdseff);
}
if ((PCLMCV_i!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+((diffVds/PCLMCV_i)/Vasat)));

d_MdL_dTemp_t_GND = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+((diffVds/PCLMCV_i)/Vasat)),((Vasat*(d_diffVds_dTemp_t_GND/PCLMCV_i)-(diffVds/PCLMCV_i)*d_Vasat_dTemp_t_GND)/Vasat/Vasat));
d_MdL_dV_gi_bi = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+((diffVds/PCLMCV_i)/Vasat)),((Vasat*(d_diffVds_dV_gi_bi/PCLMCV_i)-(diffVds/PCLMCV_i)*d_Vasat_dV_gi_bi)/Vasat/Vasat));
d_MdL_dV_si_bi = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+((diffVds/PCLMCV_i)/Vasat)),((Vasat*(d_diffVds_dV_si_bi/PCLMCV_i)-(diffVds/PCLMCV_i)*d_Vasat_dV_si_bi)/Vasat/Vasat));
d_MdL_dV_di_bi = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+((diffVds/PCLMCV_i)/Vasat)),((Vasat*(d_diffVds_dV_di_bi/PCLMCV_i)-(diffVds/PCLMCV_i)*d_Vasat_dV_di_bi)/Vasat/Vasat));
d_MdL_dV_sbulk_si = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+((diffVds/PCLMCV_i)/Vasat)),((Vasat*(d_diffVds_dV_sbulk_si/PCLMCV_i)-(diffVds/PCLMCV_i)*d_Vasat_dV_sbulk_si)/Vasat/Vasat));
d_MdL_dV_dbulk_di = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+((diffVds/PCLMCV_i)/Vasat)),((Vasat*(d_diffVds_dV_dbulk_di/PCLMCV_i)-(diffVds/PCLMCV_i)*d_Vasat_dV_dbulk_di)/Vasat/Vasat));
MdL = (1.0+(PCLMCV_i*evaluator_lln_0.getValues((1.0+((diffVds/PCLMCV_i)/Vasat)))));
}
}
else
{

d_MdL_dV_dbulk_di = d_MdL_dV_sbulk_si = d_MdL_dV_gi_bi = d_MdL_dV_di_bi = d_MdL_dV_si_bi = d_MdL_dTemp_t_GND =  0.0;
MdL = 1.0;
}

d_MdL_2_dTemp_t_GND = (MdL*d_MdL_dTemp_t_GND+d_MdL_dTemp_t_GND*MdL);
d_MdL_2_dV_si_bi = (MdL*d_MdL_dV_si_bi+d_MdL_dV_si_bi*MdL);
d_MdL_2_dV_di_bi = (MdL*d_MdL_dV_di_bi+d_MdL_dV_di_bi*MdL);
d_MdL_2_dV_gi_bi = (MdL*d_MdL_dV_gi_bi+d_MdL_dV_gi_bi*MdL);
d_MdL_2_dV_sbulk_si = (MdL*d_MdL_dV_sbulk_si+d_MdL_dV_sbulk_si*MdL);
d_MdL_2_dV_dbulk_di = (MdL*d_MdL_dV_dbulk_di+d_MdL_dV_dbulk_di*MdL);
MdL_2 = (MdL*MdL);

d_inv_MdL_dTemp_t_GND = (-d_MdL_dTemp_t_GND/MdL/MdL);
d_inv_MdL_dV_si_bi = (-d_MdL_dV_si_bi/MdL/MdL);
d_inv_MdL_dV_di_bi = (-d_MdL_dV_di_bi/MdL/MdL);
d_inv_MdL_dV_gi_bi = (-d_MdL_dV_gi_bi/MdL/MdL);
d_inv_MdL_dV_sbulk_si = (-d_MdL_dV_sbulk_si/MdL/MdL);
d_inv_MdL_dV_dbulk_di = (-d_MdL_dV_dbulk_di/MdL/MdL);
inv_MdL = (1.0/MdL);

d_inv_MdL_2_dTemp_t_GND = (-d_MdL_2_dTemp_t_GND/MdL_2/MdL_2);
d_inv_MdL_2_dV_si_bi = (-d_MdL_2_dV_si_bi/MdL_2/MdL_2);
d_inv_MdL_2_dV_di_bi = (-d_MdL_2_dV_di_bi/MdL_2/MdL_2);
d_inv_MdL_2_dV_gi_bi = (-d_MdL_2_dV_gi_bi/MdL_2/MdL_2);
d_inv_MdL_2_dV_sbulk_si = (-d_MdL_2_dV_sbulk_si/MdL_2/MdL_2);
d_inv_MdL_2_dV_dbulk_di = (-d_MdL_2_dV_dbulk_di/MdL_2/MdL_2);
inv_MdL_2 = (1.0/MdL_2);

d_MdL_less_1_dTemp_t_GND = d_MdL_dTemp_t_GND;
d_MdL_less_1_dV_si_bi = d_MdL_dV_si_bi;
d_MdL_less_1_dV_di_bi = d_MdL_dV_di_bi;
d_MdL_less_1_dV_gi_bi = d_MdL_dV_gi_bi;
d_MdL_less_1_dV_sbulk_si = d_MdL_dV_sbulk_si;
d_MdL_less_1_dV_dbulk_di = d_MdL_dV_dbulk_di;
MdL_less_1 = (MdL-1.0);

d_vgpqm_dV_sbulk_si = (-d_psip_dV_sbulk_si);
d_vgpqm_dV_dbulk_di = (-d_psip_dV_dbulk_di);
d_vgpqm_dTemp_t_GND = (d_vgfbCV_dTemp_t_GND-d_psip_dTemp_t_GND);
d_vgpqm_dV_si_bi = (d_vgfbCV_dV_si_bi-d_psip_dV_si_bi);
d_vgpqm_dV_di_bi = (d_vgfbCV_dV_di_bi-d_psip_dV_di_bi);
d_vgpqm_dV_gi_bi = (d_vgfbCV_dV_gi_bi-d_psip_dV_gi_bi);
vgpqm = (vgfbCV-psip);

d_DQSD_dTemp_t_GND = (d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND);
d_DQSD_dV_si_bi = (d_qs_dV_si_bi-d_qdeff_dV_si_bi);
d_DQSD_dV_di_bi = (d_qs_dV_di_bi-d_qdeff_dV_di_bi);
d_DQSD_dV_gi_bi = (d_qs_dV_gi_bi-d_qdeff_dV_gi_bi);
d_DQSD_dV_sbulk_si = (d_qs_dV_sbulk_si-d_qdeff_dV_sbulk_si);
d_DQSD_dV_dbulk_di = (d_qs_dV_dbulk_di-d_qdeff_dV_dbulk_di);
DQSD = (qs-qdeff);

d_DQSD2_dTemp_t_GND = ((qs-qdeff)*(d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND)+(d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND)*(qs-qdeff));
d_DQSD2_dV_si_bi = ((qs-qdeff)*(d_qs_dV_si_bi-d_qdeff_dV_si_bi)+(d_qs_dV_si_bi-d_qdeff_dV_si_bi)*(qs-qdeff));
d_DQSD2_dV_di_bi = ((qs-qdeff)*(d_qs_dV_di_bi-d_qdeff_dV_di_bi)+(d_qs_dV_di_bi-d_qdeff_dV_di_bi)*(qs-qdeff));
d_DQSD2_dV_gi_bi = ((qs-qdeff)*(d_qs_dV_gi_bi-d_qdeff_dV_gi_bi)+(d_qs_dV_gi_bi-d_qdeff_dV_gi_bi)*(qs-qdeff));
d_DQSD2_dV_sbulk_si = ((qs-qdeff)*(d_qs_dV_sbulk_si-d_qdeff_dV_sbulk_si)+(d_qs_dV_sbulk_si-d_qdeff_dV_sbulk_si)*(qs-qdeff));
d_DQSD2_dV_dbulk_di = ((qs-qdeff)*(d_qs_dV_dbulk_di-d_qdeff_dV_dbulk_di)+(d_qs_dV_dbulk_di-d_qdeff_dV_dbulk_di)*(qs-qdeff));
DQSD2 = ((qs-qdeff)*(qs-qdeff));

d_sis_dV_sbulk_si = (d_vgpqm_dV_sbulk_si+2.0*d_qs_dV_sbulk_si);
d_sis_dV_dbulk_di = (d_vgpqm_dV_dbulk_di+2.0*d_qs_dV_dbulk_di);
d_sis_dTemp_t_GND = (d_vgpqm_dTemp_t_GND+2.0*d_qs_dTemp_t_GND);
d_sis_dV_si_bi = (d_vgpqm_dV_si_bi+2.0*d_qs_dV_si_bi);
d_sis_dV_di_bi = (d_vgpqm_dV_di_bi+2.0*d_qs_dV_di_bi);
d_sis_dV_gi_bi = (d_vgpqm_dV_gi_bi+2.0*d_qs_dV_gi_bi);
sis = (vgpqm+(2.0*qs));

d_sid_dV_sbulk_si = (d_vgpqm_dV_sbulk_si+2.0*d_qdeff_dV_sbulk_si);
d_sid_dV_dbulk_di = (d_vgpqm_dV_dbulk_di+2.0*d_qdeff_dV_dbulk_di);
d_sid_dTemp_t_GND = (d_vgpqm_dTemp_t_GND+2.0*d_qdeff_dTemp_t_GND);
d_sid_dV_si_bi = (d_vgpqm_dV_si_bi+2.0*d_qdeff_dV_si_bi);
d_sid_dV_di_bi = (d_vgpqm_dV_di_bi+2.0*d_qdeff_dV_di_bi);
d_sid_dV_gi_bi = (d_vgpqm_dV_gi_bi+2.0*d_qdeff_dV_gi_bi);
sid = (vgpqm+(2.0*qdeff));
{
double value_sqrt_0 = sqrt((((sis)*(sis))+((0.25*0.5)*0.5)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dV_sbulk_si = 0.5*(d_sis_dV_sbulk_si+(deriv_sqrt_0_d0*(((sis)*d_sis_dV_sbulk_si+d_sis_dV_sbulk_si*(sis)))));
d_T1_dV_dbulk_di = 0.5*(d_sis_dV_dbulk_di+(deriv_sqrt_0_d0*(((sis)*d_sis_dV_dbulk_di+d_sis_dV_dbulk_di*(sis)))));
d_T1_dTemp_t_GND = 0.5*(d_sis_dTemp_t_GND+(deriv_sqrt_0_d0*(((sis)*d_sis_dTemp_t_GND+d_sis_dTemp_t_GND*(sis)))));
d_T1_dV_si_bi = 0.5*(d_sis_dV_si_bi+(deriv_sqrt_0_d0*(((sis)*d_sis_dV_si_bi+d_sis_dV_si_bi*(sis)))));
d_T1_dV_di_bi = 0.5*(d_sis_dV_di_bi+(deriv_sqrt_0_d0*(((sis)*d_sis_dV_di_bi+d_sis_dV_di_bi*(sis)))));
d_T1_dV_gi_bi = 0.5*(d_sis_dV_gi_bi+(deriv_sqrt_0_d0*(((sis)*d_sis_dV_gi_bi+d_sis_dV_gi_bi*(sis)))));
T1 = (0.5*(sis+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((sid)*(sid))+((0.25*0.5)*0.5)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dV_sbulk_si = 0.5*(d_sid_dV_sbulk_si+(deriv_sqrt_0_d0*(((sid)*d_sid_dV_sbulk_si+d_sid_dV_sbulk_si*(sid)))));
d_T2_dV_dbulk_di = 0.5*(d_sid_dV_dbulk_di+(deriv_sqrt_0_d0*(((sid)*d_sid_dV_dbulk_di+d_sid_dV_dbulk_di*(sid)))));
d_T2_dTemp_t_GND = 0.5*(d_sid_dTemp_t_GND+(deriv_sqrt_0_d0*(((sid)*d_sid_dTemp_t_GND+d_sid_dTemp_t_GND*(sid)))));
d_T2_dV_si_bi = 0.5*(d_sid_dV_si_bi+(deriv_sqrt_0_d0*(((sid)*d_sid_dV_si_bi+d_sid_dV_si_bi*(sid)))));
d_T2_dV_di_bi = 0.5*(d_sid_dV_di_bi+(deriv_sqrt_0_d0*(((sid)*d_sid_dV_di_bi+d_sid_dV_di_bi*(sid)))));
d_T2_dV_gi_bi = 0.5*(d_sid_dV_gi_bi+(deriv_sqrt_0_d0*(((sid)*d_sid_dV_gi_bi+d_sid_dV_gi_bi*(sid)))));
T2 = (0.5*(sid+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((0.25+(T1*invgamg2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Temps_dTemp_t_GND = (deriv_sqrt_0_d0*((T1*d_invgamg2_dTemp_t_GND+d_T1_dTemp_t_GND*invgamg2)));
d_Temps_dV_si_bi = (deriv_sqrt_0_d0*(d_T1_dV_si_bi*invgamg2));
d_Temps_dV_di_bi = (deriv_sqrt_0_d0*(d_T1_dV_di_bi*invgamg2));
d_Temps_dV_gi_bi = (deriv_sqrt_0_d0*(d_T1_dV_gi_bi*invgamg2));
d_Temps_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T1_dV_sbulk_si*invgamg2));
d_Temps_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T1_dV_dbulk_di*invgamg2));
Temps = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((0.25+(T2*invgamg2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Tempd_dTemp_t_GND = (deriv_sqrt_0_d0*((T2*d_invgamg2_dTemp_t_GND+d_T2_dTemp_t_GND*invgamg2)));
d_Tempd_dV_si_bi = (deriv_sqrt_0_d0*(d_T2_dV_si_bi*invgamg2));
d_Tempd_dV_di_bi = (deriv_sqrt_0_d0*(d_T2_dV_di_bi*invgamg2));
d_Tempd_dV_gi_bi = (deriv_sqrt_0_d0*(d_T2_dV_gi_bi*invgamg2));
d_Tempd_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T2_dV_sbulk_si*invgamg2));
d_Tempd_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T2_dV_dbulk_di*invgamg2));
Tempd = value_sqrt_0;
}

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dV_sbulk_si = (((1.0+(2.0*Temps))*d_sis_dV_sbulk_si-sis*2.0*d_Temps_dV_sbulk_si)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
d_T1_dV_dbulk_di = (((1.0+(2.0*Temps))*d_sis_dV_dbulk_di-sis*2.0*d_Temps_dV_dbulk_di)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
d_T1_dTemp_t_GND = (((1.0+(2.0*Temps))*d_sis_dTemp_t_GND-sis*2.0*d_Temps_dTemp_t_GND)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
d_T1_dV_si_bi = (((1.0+(2.0*Temps))*d_sis_dV_si_bi-sis*2.0*d_Temps_dV_si_bi)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
d_T1_dV_di_bi = (((1.0+(2.0*Temps))*d_sis_dV_di_bi-sis*2.0*d_Temps_dV_di_bi)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
d_T1_dV_gi_bi = (((1.0+(2.0*Temps))*d_sis_dV_gi_bi-sis*2.0*d_Temps_dV_gi_bi)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
T1 = (sis/(1.0+(2.0*Temps)));

d_T2_dV_gm_di = d_T2_dV_gm_si =  0.0;
d_T2_dV_sbulk_si = (((1.0+(2.0*Tempd))*d_sid_dV_sbulk_si-sid*2.0*d_Tempd_dV_sbulk_si)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
d_T2_dV_dbulk_di = (((1.0+(2.0*Tempd))*d_sid_dV_dbulk_di-sid*2.0*d_Tempd_dV_dbulk_di)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
d_T2_dTemp_t_GND = (((1.0+(2.0*Tempd))*d_sid_dTemp_t_GND-sid*2.0*d_Tempd_dTemp_t_GND)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
d_T2_dV_si_bi = (((1.0+(2.0*Tempd))*d_sid_dV_si_bi-sid*2.0*d_Tempd_dV_si_bi)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
d_T2_dV_di_bi = (((1.0+(2.0*Tempd))*d_sid_dV_di_bi-sid*2.0*d_Tempd_dV_di_bi)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
d_T2_dV_gi_bi = (((1.0+(2.0*Tempd))*d_sid_dV_gi_bi-sid*2.0*d_Tempd_dV_gi_bi)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
T2 = (sid/(1.0+(2.0*Tempd)));

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (d_Temps_dTemp_t_GND+d_Tempd_dTemp_t_GND);
d_T3_dV_si_bi = (d_Temps_dV_si_bi+d_Tempd_dV_si_bi);
d_T3_dV_di_bi = (d_Temps_dV_di_bi+d_Tempd_dV_di_bi);
d_T3_dV_gi_bi = (d_Temps_dV_gi_bi+d_Tempd_dV_gi_bi);
d_T3_dV_sbulk_si = (d_Temps_dV_sbulk_si+d_Tempd_dV_sbulk_si);
d_T3_dV_dbulk_di = (d_Temps_dV_dbulk_di+d_Tempd_dV_dbulk_di);
T3 = (Temps+Tempd);

d_T4_dV_gm_si = d_T4_dV_gm_di =  0.0;
d_T4_dTemp_t_GND = 0.33333333333333333*((((T3*T3)*T3)*d_DQSD2_dTemp_t_GND-DQSD2*((T3*T3)*d_T3_dTemp_t_GND+(T3*d_T3_dTemp_t_GND+d_T3_dTemp_t_GND*T3)*T3))/((T3*T3)*T3)/((T3*T3)*T3));
d_T4_dV_si_bi = 0.33333333333333333*((((T3*T3)*T3)*d_DQSD2_dV_si_bi-DQSD2*((T3*T3)*d_T3_dV_si_bi+(T3*d_T3_dV_si_bi+d_T3_dV_si_bi*T3)*T3))/((T3*T3)*T3)/((T3*T3)*T3));
d_T4_dV_di_bi = 0.33333333333333333*((((T3*T3)*T3)*d_DQSD2_dV_di_bi-DQSD2*((T3*T3)*d_T3_dV_di_bi+(T3*d_T3_dV_di_bi+d_T3_dV_di_bi*T3)*T3))/((T3*T3)*T3)/((T3*T3)*T3));
d_T4_dV_gi_bi = 0.33333333333333333*((((T3*T3)*T3)*d_DQSD2_dV_gi_bi-DQSD2*((T3*T3)*d_T3_dV_gi_bi+(T3*d_T3_dV_gi_bi+d_T3_dV_gi_bi*T3)*T3))/((T3*T3)*T3)/((T3*T3)*T3));
d_T4_dV_sbulk_si = 0.33333333333333333*((((T3*T3)*T3)*d_DQSD2_dV_sbulk_si-DQSD2*((T3*T3)*d_T3_dV_sbulk_si+(T3*d_T3_dV_sbulk_si+d_T3_dV_sbulk_si*T3)*T3))/((T3*T3)*T3)/((T3*T3)*T3));
d_T4_dV_dbulk_di = 0.33333333333333333*((((T3*T3)*T3)*d_DQSD2_dV_dbulk_di-DQSD2*((T3*T3)*d_T3_dV_dbulk_di+(T3*d_T3_dV_dbulk_di+d_T3_dV_dbulk_di*T3)*T3))/((T3*T3)*T3)/((T3*T3)*T3));
T4 = (0.33333333333333333*(DQSD2/((T3*T3)*T3)));

d_T5_dV_gm_si = d_T5_dV_gm_di =  0.0;
d_T5_dTemp_t_GND = ((((1.0+qs)+qdeff)*(Dvsat*d_inv_MdL_dTemp_t_GND+d_Dvsat_dTemp_t_GND*inv_MdL)-(Dvsat*inv_MdL)*(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T5_dV_si_bi = ((((1.0+qs)+qdeff)*(Dvsat*d_inv_MdL_dV_si_bi+d_Dvsat_dV_si_bi*inv_MdL)-(Dvsat*inv_MdL)*(d_qs_dV_si_bi+d_qdeff_dV_si_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T5_dV_di_bi = ((((1.0+qs)+qdeff)*(Dvsat*d_inv_MdL_dV_di_bi+d_Dvsat_dV_di_bi*inv_MdL)-(Dvsat*inv_MdL)*(d_qs_dV_di_bi+d_qdeff_dV_di_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T5_dV_gi_bi = ((((1.0+qs)+qdeff)*(Dvsat*d_inv_MdL_dV_gi_bi+d_Dvsat_dV_gi_bi*inv_MdL)-(Dvsat*inv_MdL)*(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T5_dV_sbulk_si = ((((1.0+qs)+qdeff)*(Dvsat*d_inv_MdL_dV_sbulk_si+d_Dvsat_dV_sbulk_si*inv_MdL)-(Dvsat*inv_MdL)*(d_qs_dV_sbulk_si+d_qdeff_dV_sbulk_si))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
d_T5_dV_dbulk_di = ((((1.0+qs)+qdeff)*(Dvsat*d_inv_MdL_dV_dbulk_di+d_Dvsat_dV_dbulk_di*inv_MdL)-(Dvsat*inv_MdL)*(d_qs_dV_dbulk_di+d_qdeff_dV_dbulk_di))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
T5 = ((Dvsat*inv_MdL)/((1.0+qs)+qdeff));

d_T6_dV_gm_di = d_T6_dV_gm_si =  0.0;
d_T6_dTemp_t_GND = ((0.8*((T3*T3)+(Temps*Tempd)))*d_T5_dTemp_t_GND+0.8*((T3*d_T3_dTemp_t_GND+d_T3_dTemp_t_GND*T3)+(Temps*d_Tempd_dTemp_t_GND+d_Temps_dTemp_t_GND*Tempd))*T5);
d_T6_dV_si_bi = ((0.8*((T3*T3)+(Temps*Tempd)))*d_T5_dV_si_bi+0.8*((T3*d_T3_dV_si_bi+d_T3_dV_si_bi*T3)+(Temps*d_Tempd_dV_si_bi+d_Temps_dV_si_bi*Tempd))*T5);
d_T6_dV_di_bi = ((0.8*((T3*T3)+(Temps*Tempd)))*d_T5_dV_di_bi+0.8*((T3*d_T3_dV_di_bi+d_T3_dV_di_bi*T3)+(Temps*d_Tempd_dV_di_bi+d_Temps_dV_di_bi*Tempd))*T5);
d_T6_dV_gi_bi = ((0.8*((T3*T3)+(Temps*Tempd)))*d_T5_dV_gi_bi+0.8*((T3*d_T3_dV_gi_bi+d_T3_dV_gi_bi*T3)+(Temps*d_Tempd_dV_gi_bi+d_Temps_dV_gi_bi*Tempd))*T5);
d_T6_dV_sbulk_si = ((0.8*((T3*T3)+(Temps*Tempd)))*d_T5_dV_sbulk_si+0.8*((T3*d_T3_dV_sbulk_si+d_T3_dV_sbulk_si*T3)+(Temps*d_Tempd_dV_sbulk_si+d_Temps_dV_sbulk_si*Tempd))*T5);
d_T6_dV_dbulk_di = ((0.8*((T3*T3)+(Temps*Tempd)))*d_T5_dV_dbulk_di+0.8*((T3*d_T3_dV_dbulk_di+d_T3_dV_dbulk_di*T3)+(Temps*d_Tempd_dV_dbulk_di+d_Temps_dV_dbulk_di*Tempd))*T5);
T6 = ((0.8*((T3*T3)+(Temps*Tempd)))*T5);

d_T7_dV_gm_si = d_T7_dV_gm_di =  0.0;
d_T7_dTemp_t_GND = (d_T6_dTemp_t_GND+2.0*d_invgamg2_dTemp_t_GND);
d_T7_dV_si_bi = d_T6_dV_si_bi;
d_T7_dV_di_bi = d_T6_dV_di_bi;
d_T7_dV_gi_bi = d_T6_dV_gi_bi;
d_T7_dV_sbulk_si = d_T6_dV_sbulk_si;
d_T7_dV_dbulk_di = d_T6_dV_dbulk_di;
T7 = (T6+(2.0*invgamg2));

d_T8_dV_gm_di = d_T8_dV_gm_si =  0.0;
d_T8_dTemp_t_GND = ((0.33333333333333333*DQSD2)*d_T5_dTemp_t_GND+0.33333333333333333*d_DQSD2_dTemp_t_GND*T5);
d_T8_dV_si_bi = ((0.33333333333333333*DQSD2)*d_T5_dV_si_bi+0.33333333333333333*d_DQSD2_dV_si_bi*T5);
d_T8_dV_di_bi = ((0.33333333333333333*DQSD2)*d_T5_dV_di_bi+0.33333333333333333*d_DQSD2_dV_di_bi*T5);
d_T8_dV_gi_bi = ((0.33333333333333333*DQSD2)*d_T5_dV_gi_bi+0.33333333333333333*d_DQSD2_dV_gi_bi*T5);
d_T8_dV_sbulk_si = ((0.33333333333333333*DQSD2)*d_T5_dV_sbulk_si+0.33333333333333333*d_DQSD2_dV_sbulk_si*T5);
d_T8_dV_dbulk_di = ((0.33333333333333333*DQSD2)*d_T5_dV_dbulk_di+0.33333333333333333*d_DQSD2_dV_dbulk_di*T5);
T8 = ((0.33333333333333333*DQSD2)*T5);

d_dqgeff_dV_sbulk_si = ((((2.0*Tempd)+1.0)*(sid*2.0*d_Tempd_dV_sbulk_si+d_sid_dV_sbulk_si*((2.0*Tempd)-1.0))-(sid*((2.0*Tempd)-1.0))*2.0*d_Tempd_dV_sbulk_si)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
d_dqgeff_dV_dbulk_di = ((((2.0*Tempd)+1.0)*(sid*2.0*d_Tempd_dV_dbulk_di+d_sid_dV_dbulk_di*((2.0*Tempd)-1.0))-(sid*((2.0*Tempd)-1.0))*2.0*d_Tempd_dV_dbulk_di)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
d_dqgeff_dTemp_t_GND = ((((2.0*Tempd)+1.0)*(sid*2.0*d_Tempd_dTemp_t_GND+d_sid_dTemp_t_GND*((2.0*Tempd)-1.0))-(sid*((2.0*Tempd)-1.0))*2.0*d_Tempd_dTemp_t_GND)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
d_dqgeff_dV_si_bi = ((((2.0*Tempd)+1.0)*(sid*2.0*d_Tempd_dV_si_bi+d_sid_dV_si_bi*((2.0*Tempd)-1.0))-(sid*((2.0*Tempd)-1.0))*2.0*d_Tempd_dV_si_bi)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
d_dqgeff_dV_di_bi = ((((2.0*Tempd)+1.0)*(sid*2.0*d_Tempd_dV_di_bi+d_sid_dV_di_bi*((2.0*Tempd)-1.0))-(sid*((2.0*Tempd)-1.0))*2.0*d_Tempd_dV_di_bi)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
d_dqgeff_dV_gi_bi = ((((2.0*Tempd)+1.0)*(sid*2.0*d_Tempd_dV_gi_bi+d_sid_dV_gi_bi*((2.0*Tempd)-1.0))-(sid*((2.0*Tempd)-1.0))*2.0*d_Tempd_dV_gi_bi)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
dqgeff = ((sid*((2.0*Tempd)-1.0))/((2.0*Tempd)+1.0));

d_qbeff_dV_sbulk_si = ((d_vgpqm_dV_sbulk_si-((2.0*(nq-1.0))*d_qdeff_dV_sbulk_si+2.0*d_nq_dV_sbulk_si*qdeff))+d_dqgeff_dV_sbulk_si);
d_qbeff_dV_dbulk_di = ((d_vgpqm_dV_dbulk_di-((2.0*(nq-1.0))*d_qdeff_dV_dbulk_di+2.0*d_nq_dV_dbulk_di*qdeff))+d_dqgeff_dV_dbulk_di);
d_qbeff_dTemp_t_GND = ((d_vgpqm_dTemp_t_GND-((2.0*(nq-1.0))*d_qdeff_dTemp_t_GND+2.0*d_nq_dTemp_t_GND*qdeff))+d_dqgeff_dTemp_t_GND);
d_qbeff_dV_si_bi = ((d_vgpqm_dV_si_bi-((2.0*(nq-1.0))*d_qdeff_dV_si_bi+2.0*d_nq_dV_si_bi*qdeff))+d_dqgeff_dV_si_bi);
d_qbeff_dV_di_bi = ((d_vgpqm_dV_di_bi-((2.0*(nq-1.0))*d_qdeff_dV_di_bi+2.0*d_nq_dV_di_bi*qdeff))+d_dqgeff_dV_di_bi);
d_qbeff_dV_gi_bi = ((d_vgpqm_dV_gi_bi-((2.0*(nq-1.0))*d_qdeff_dV_gi_bi+2.0*d_nq_dV_gi_bi*qdeff))+d_dqgeff_dV_gi_bi);
qbeff = ((vgpqm-((2.0*(nq-1.0))*qdeff))+dqgeff);

d_Qb_dTemp_t_GND = ((inv_MdL*((d_T1_dTemp_t_GND+d_T2_dTemp_t_GND)+((T4*d_T7_dTemp_t_GND+d_T4_dTemp_t_GND*T7)-(nq*((d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+d_T8_dTemp_t_GND)+d_nq_dTemp_t_GND*((qs+qdeff)+T8))))+d_inv_MdL_dTemp_t_GND*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*d_qbeff_dTemp_t_GND+d_MdL_less_1_dTemp_t_GND*qbeff));
d_Qb_dV_si_bi = ((inv_MdL*((d_T1_dV_si_bi+d_T2_dV_si_bi)+((T4*d_T7_dV_si_bi+d_T4_dV_si_bi*T7)-(nq*((d_qs_dV_si_bi+d_qdeff_dV_si_bi)+d_T8_dV_si_bi)+d_nq_dV_si_bi*((qs+qdeff)+T8))))+d_inv_MdL_dV_si_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*d_qbeff_dV_si_bi+d_MdL_less_1_dV_si_bi*qbeff));
d_Qb_dV_di_bi = ((inv_MdL*((d_T1_dV_di_bi+d_T2_dV_di_bi)+((T4*d_T7_dV_di_bi+d_T4_dV_di_bi*T7)-(nq*((d_qs_dV_di_bi+d_qdeff_dV_di_bi)+d_T8_dV_di_bi)+d_nq_dV_di_bi*((qs+qdeff)+T8))))+d_inv_MdL_dV_di_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*d_qbeff_dV_di_bi+d_MdL_less_1_dV_di_bi*qbeff));
d_Qb_dV_gi_bi = ((inv_MdL*((d_T1_dV_gi_bi+d_T2_dV_gi_bi)+((T4*d_T7_dV_gi_bi+d_T4_dV_gi_bi*T7)-(nq*((d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+d_T8_dV_gi_bi)+d_nq_dV_gi_bi*((qs+qdeff)+T8))))+d_inv_MdL_dV_gi_bi*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*d_qbeff_dV_gi_bi+d_MdL_less_1_dV_gi_bi*qbeff));
d_Qb_dV_sbulk_si = ((inv_MdL*((d_T1_dV_sbulk_si+d_T2_dV_sbulk_si)+((T4*d_T7_dV_sbulk_si+d_T4_dV_sbulk_si*T7)-(nq*((d_qs_dV_sbulk_si+d_qdeff_dV_sbulk_si)+d_T8_dV_sbulk_si)+d_nq_dV_sbulk_si*((qs+qdeff)+T8))))+d_inv_MdL_dV_sbulk_si*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*d_qbeff_dV_sbulk_si+d_MdL_less_1_dV_sbulk_si*qbeff));
d_Qb_dV_dbulk_di = ((inv_MdL*((d_T1_dV_dbulk_di+d_T2_dV_dbulk_di)+((T4*d_T7_dV_dbulk_di+d_T4_dV_dbulk_di*T7)-(nq*((d_qs_dV_dbulk_di+d_qdeff_dV_dbulk_di)+d_T8_dV_dbulk_di)+d_nq_dV_dbulk_di*((qs+qdeff)+T8))))+d_inv_MdL_dV_dbulk_di*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*d_qbeff_dV_dbulk_di+d_MdL_less_1_dV_dbulk_di*qbeff));
Qb = ((inv_MdL*((T1+T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*qbeff));

d_T9_dV_gm_si = d_T9_dV_gm_di =  0.0;
d_T9_dTemp_t_GND = (d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND);
d_T9_dV_si_bi = (d_qs_dV_si_bi+d_qdeff_dV_si_bi);
d_T9_dV_di_bi = (d_qs_dV_di_bi+d_qdeff_dV_di_bi);
d_T9_dV_gi_bi = (d_qs_dV_gi_bi+d_qdeff_dV_gi_bi);
d_T9_dV_sbulk_si = (d_qs_dV_sbulk_si+d_qdeff_dV_sbulk_si);
d_T9_dV_dbulk_di = (d_qs_dV_dbulk_di+d_qdeff_dV_dbulk_di);
T9 = (qs+qdeff);

d_T10_dTemp_t_GND = ((DQSD2*T5)*d_T5_dTemp_t_GND+(DQSD2*d_T5_dTemp_t_GND+d_DQSD2_dTemp_t_GND*T5)*T5);
d_T10_dV_si_bi = ((DQSD2*T5)*d_T5_dV_si_bi+(DQSD2*d_T5_dV_si_bi+d_DQSD2_dV_si_bi*T5)*T5);
d_T10_dV_di_bi = ((DQSD2*T5)*d_T5_dV_di_bi+(DQSD2*d_T5_dV_di_bi+d_DQSD2_dV_di_bi*T5)*T5);
d_T10_dV_gi_bi = ((DQSD2*T5)*d_T5_dV_gi_bi+(DQSD2*d_T5_dV_gi_bi+d_DQSD2_dV_gi_bi*T5)*T5);
d_T10_dV_sbulk_si = ((DQSD2*T5)*d_T5_dV_sbulk_si+(DQSD2*d_T5_dV_sbulk_si+d_DQSD2_dV_sbulk_si*T5)*T5);
d_T10_dV_dbulk_di = ((DQSD2*T5)*d_T5_dV_dbulk_di+(DQSD2*d_T5_dV_dbulk_di+d_DQSD2_dV_dbulk_di*T5)*T5);
T10 = ((DQSD2*T5)*T5);

d_Qi_dV_si_bi = (((nq*inv_MdL)*(d_T9_dV_si_bi+((0.33333333333333333*DQSD2)*d_T5_dV_si_bi+0.33333333333333333*d_DQSD2_dV_si_bi*T5))+(nq*d_inv_MdL_dV_si_bi+d_nq_dV_si_bi*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*d_qdeff_dV_si_bi+((2.0*nq)*d_MdL_less_1_dV_si_bi+2.0*d_nq_dV_si_bi*MdL_less_1)*qdeff));
d_Qi_dV_di_bi = (((nq*inv_MdL)*(d_T9_dV_di_bi+((0.33333333333333333*DQSD2)*d_T5_dV_di_bi+0.33333333333333333*d_DQSD2_dV_di_bi*T5))+(nq*d_inv_MdL_dV_di_bi+d_nq_dV_di_bi*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*d_qdeff_dV_di_bi+((2.0*nq)*d_MdL_less_1_dV_di_bi+2.0*d_nq_dV_di_bi*MdL_less_1)*qdeff));
d_Qi_dTemp_t_GND = (((nq*inv_MdL)*(d_T9_dTemp_t_GND+((0.33333333333333333*DQSD2)*d_T5_dTemp_t_GND+0.33333333333333333*d_DQSD2_dTemp_t_GND*T5))+(nq*d_inv_MdL_dTemp_t_GND+d_nq_dTemp_t_GND*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*d_qdeff_dTemp_t_GND+((2.0*nq)*d_MdL_less_1_dTemp_t_GND+2.0*d_nq_dTemp_t_GND*MdL_less_1)*qdeff));
d_Qi_dV_gi_bi = (((nq*inv_MdL)*(d_T9_dV_gi_bi+((0.33333333333333333*DQSD2)*d_T5_dV_gi_bi+0.33333333333333333*d_DQSD2_dV_gi_bi*T5))+(nq*d_inv_MdL_dV_gi_bi+d_nq_dV_gi_bi*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*d_qdeff_dV_gi_bi+((2.0*nq)*d_MdL_less_1_dV_gi_bi+2.0*d_nq_dV_gi_bi*MdL_less_1)*qdeff));
d_Qi_dV_sbulk_si = (((nq*inv_MdL)*(d_T9_dV_sbulk_si+((0.33333333333333333*DQSD2)*d_T5_dV_sbulk_si+0.33333333333333333*d_DQSD2_dV_sbulk_si*T5))+(nq*d_inv_MdL_dV_sbulk_si+d_nq_dV_sbulk_si*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*d_qdeff_dV_sbulk_si+((2.0*nq)*d_MdL_less_1_dV_sbulk_si+2.0*d_nq_dV_sbulk_si*MdL_less_1)*qdeff));
d_Qi_dV_dbulk_di = (((nq*inv_MdL)*(d_T9_dV_dbulk_di+((0.33333333333333333*DQSD2)*d_T5_dV_dbulk_di+0.33333333333333333*d_DQSD2_dV_dbulk_di*T5))+(nq*d_inv_MdL_dV_dbulk_di+d_nq_dV_dbulk_di*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*d_qdeff_dV_dbulk_di+((2.0*nq)*d_MdL_less_1_dV_dbulk_di+2.0*d_nq_dV_dbulk_di*MdL_less_1)*qdeff));
Qi = (((nq*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*qdeff));

d_Qd1_dV_si_bi = ((nq*inv_MdL_2)*(0.5*d_T9_dV_si_bi-((DQSD/6.0)*((-(DQSD*d_T5_dV_si_bi+d_DQSD_dV_si_bi*T5))-0.2*d_T10_dV_si_bi)+(d_DQSD_dV_si_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+(nq*d_inv_MdL_2_dV_si_bi+d_nq_dV_si_bi*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
d_Qd1_dV_di_bi = ((nq*inv_MdL_2)*(0.5*d_T9_dV_di_bi-((DQSD/6.0)*((-(DQSD*d_T5_dV_di_bi+d_DQSD_dV_di_bi*T5))-0.2*d_T10_dV_di_bi)+(d_DQSD_dV_di_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+(nq*d_inv_MdL_2_dV_di_bi+d_nq_dV_di_bi*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
d_Qd1_dTemp_t_GND = ((nq*inv_MdL_2)*(0.5*d_T9_dTemp_t_GND-((DQSD/6.0)*((-(DQSD*d_T5_dTemp_t_GND+d_DQSD_dTemp_t_GND*T5))-0.2*d_T10_dTemp_t_GND)+(d_DQSD_dTemp_t_GND/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+(nq*d_inv_MdL_2_dTemp_t_GND+d_nq_dTemp_t_GND*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
d_Qd1_dV_gi_bi = ((nq*inv_MdL_2)*(0.5*d_T9_dV_gi_bi-((DQSD/6.0)*((-(DQSD*d_T5_dV_gi_bi+d_DQSD_dV_gi_bi*T5))-0.2*d_T10_dV_gi_bi)+(d_DQSD_dV_gi_bi/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+(nq*d_inv_MdL_2_dV_gi_bi+d_nq_dV_gi_bi*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
d_Qd1_dV_sbulk_si = ((nq*inv_MdL_2)*(0.5*d_T9_dV_sbulk_si-((DQSD/6.0)*((-(DQSD*d_T5_dV_sbulk_si+d_DQSD_dV_sbulk_si*T5))-0.2*d_T10_dV_sbulk_si)+(d_DQSD_dV_sbulk_si/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+(nq*d_inv_MdL_2_dV_sbulk_si+d_nq_dV_sbulk_si*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
d_Qd1_dV_dbulk_di = ((nq*inv_MdL_2)*(0.5*d_T9_dV_dbulk_di-((DQSD/6.0)*((-(DQSD*d_T5_dV_dbulk_di+d_DQSD_dV_dbulk_di*T5))-0.2*d_T10_dV_dbulk_di)+(d_DQSD_dV_dbulk_di/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+(nq*d_inv_MdL_2_dV_dbulk_di+d_nq_dV_dbulk_di*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
Qd1 = ((nq*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));

d_Qd2_dV_si_bi = ((nq*(MdL-inv_MdL))*d_qdeff_dV_si_bi+(nq*(d_MdL_dV_si_bi-d_inv_MdL_dV_si_bi)+d_nq_dV_si_bi*(MdL-inv_MdL))*qdeff);
d_Qd2_dV_di_bi = ((nq*(MdL-inv_MdL))*d_qdeff_dV_di_bi+(nq*(d_MdL_dV_di_bi-d_inv_MdL_dV_di_bi)+d_nq_dV_di_bi*(MdL-inv_MdL))*qdeff);
d_Qd2_dTemp_t_GND = ((nq*(MdL-inv_MdL))*d_qdeff_dTemp_t_GND+(nq*(d_MdL_dTemp_t_GND-d_inv_MdL_dTemp_t_GND)+d_nq_dTemp_t_GND*(MdL-inv_MdL))*qdeff);
d_Qd2_dV_gi_bi = ((nq*(MdL-inv_MdL))*d_qdeff_dV_gi_bi+(nq*(d_MdL_dV_gi_bi-d_inv_MdL_dV_gi_bi)+d_nq_dV_gi_bi*(MdL-inv_MdL))*qdeff);
d_Qd2_dV_sbulk_si = ((nq*(MdL-inv_MdL))*d_qdeff_dV_sbulk_si+(nq*(d_MdL_dV_sbulk_si-d_inv_MdL_dV_sbulk_si)+d_nq_dV_sbulk_si*(MdL-inv_MdL))*qdeff);
d_Qd2_dV_dbulk_di = ((nq*(MdL-inv_MdL))*d_qdeff_dV_dbulk_di+(nq*(d_MdL_dV_dbulk_di-d_inv_MdL_dV_dbulk_di)+d_nq_dV_dbulk_di*(MdL-inv_MdL))*qdeff);
Qd2 = ((nq*(MdL-inv_MdL))*qdeff);

d_Qd_dV_si_bi = (d_Qd1_dV_si_bi+d_Qd2_dV_si_bi);
d_Qd_dV_di_bi = (d_Qd1_dV_di_bi+d_Qd2_dV_di_bi);
d_Qd_dTemp_t_GND = (d_Qd1_dTemp_t_GND+d_Qd2_dTemp_t_GND);
d_Qd_dV_gi_bi = (d_Qd1_dV_gi_bi+d_Qd2_dV_gi_bi);
d_Qd_dV_sbulk_si = (d_Qd1_dV_sbulk_si+d_Qd2_dV_sbulk_si);
d_Qd_dV_dbulk_di = (d_Qd1_dV_dbulk_di+d_Qd2_dV_dbulk_di);
Qd = (Qd1+Qd2);

d_Qs_dV_si_bi = (d_Qi_dV_si_bi-d_Qd_dV_si_bi);
d_Qs_dV_di_bi = (d_Qi_dV_di_bi-d_Qd_dV_di_bi);
d_Qs_dTemp_t_GND = (d_Qi_dTemp_t_GND-d_Qd_dTemp_t_GND);
d_Qs_dV_gi_bi = (d_Qi_dV_gi_bi-d_Qd_dV_gi_bi);
d_Qs_dV_sbulk_si = (d_Qi_dV_sbulk_si-d_Qd_dV_sbulk_si);
d_Qs_dV_dbulk_di = (d_Qi_dV_dbulk_di-d_Qd_dV_dbulk_di);
Qs = (Qi-Qd);
{
double value_sqrt_0 = sqrt(((((Vt*Qb))*((Vt*Qb)))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qbaCV_dV_si_bi = 0.5*(Vt*d_Qb_dV_si_bi+(deriv_sqrt_0_d0*((((Vt*Qb))*Vt*d_Qb_dV_si_bi+Vt*d_Qb_dV_si_bi*((Vt*Qb))))));
d_qbaCV_dV_di_bi = 0.5*(Vt*d_Qb_dV_di_bi+(deriv_sqrt_0_d0*((((Vt*Qb))*Vt*d_Qb_dV_di_bi+Vt*d_Qb_dV_di_bi*((Vt*Qb))))));
d_qbaCV_dV_gi_bi = 0.5*(Vt*d_Qb_dV_gi_bi+(deriv_sqrt_0_d0*((((Vt*Qb))*Vt*d_Qb_dV_gi_bi+Vt*d_Qb_dV_gi_bi*((Vt*Qb))))));
d_qbaCV_dV_sbulk_si = 0.5*(Vt*d_Qb_dV_sbulk_si+(deriv_sqrt_0_d0*((((Vt*Qb))*Vt*d_Qb_dV_sbulk_si+Vt*d_Qb_dV_sbulk_si*((Vt*Qb))))));
d_qbaCV_dV_dbulk_di = 0.5*(Vt*d_Qb_dV_dbulk_di+(deriv_sqrt_0_d0*((((Vt*Qb))*Vt*d_Qb_dV_dbulk_di+Vt*d_Qb_dV_dbulk_di*((Vt*Qb))))));
d_qbaCV_dTemp_t_GND = 0.5*((Vt*d_Qb_dTemp_t_GND+d_Vt_dTemp_t_GND*Qb)+(deriv_sqrt_0_d0*((((Vt*Qb))*(Vt*d_Qb_dTemp_t_GND+d_Vt_dTemp_t_GND*Qb)+(Vt*d_Qb_dTemp_t_GND+d_Vt_dTemp_t_GND*Qb)*((Vt*Qb))))));
qbaCV = (0.5*((Vt*Qb)+value_sqrt_0));
}

d_qiaCV_dV_si_bi = Vt*(d_Qs_dV_si_bi+d_Qd_dV_si_bi);
d_qiaCV_dV_di_bi = Vt*(d_Qs_dV_di_bi+d_Qd_dV_di_bi);
d_qiaCV_dV_gi_bi = Vt*(d_Qs_dV_gi_bi+d_Qd_dV_gi_bi);
d_qiaCV_dV_sbulk_si = Vt*(d_Qs_dV_sbulk_si+d_Qd_dV_sbulk_si);
d_qiaCV_dV_dbulk_di = Vt*(d_Qs_dV_dbulk_di+d_Qd_dV_dbulk_di);
d_qiaCV_dTemp_t_GND = (Vt*(d_Qs_dTemp_t_GND+d_Qd_dTemp_t_GND)+d_Vt_dTemp_t_GND*(Qs+Qd));
qiaCV = (Vt*(Qs+Qd));

d_T0_dV_gm_di = d_T0_dV_gm_si =  0.0;
d_T0_dV_si_bi = ((d_qiaCV_dV_si_bi+(model_.ETAQM)*d_qbaCV_dV_si_bi)/(model_.QM0));
d_T0_dV_di_bi = ((d_qiaCV_dV_di_bi+(model_.ETAQM)*d_qbaCV_dV_di_bi)/(model_.QM0));
d_T0_dV_gi_bi = ((d_qiaCV_dV_gi_bi+(model_.ETAQM)*d_qbaCV_dV_gi_bi)/(model_.QM0));
d_T0_dV_sbulk_si = ((d_qiaCV_dV_sbulk_si+(model_.ETAQM)*d_qbaCV_dV_sbulk_si)/(model_.QM0));
d_T0_dV_dbulk_di = ((d_qiaCV_dV_dbulk_di+(model_.ETAQM)*d_qbaCV_dV_dbulk_di)/(model_.QM0));
d_T0_dTemp_t_GND = ((d_qiaCV_dTemp_t_GND+(model_.ETAQM)*d_qbaCV_dTemp_t_GND)/(model_.QM0));
T0 = ((qiaCV+((model_.ETAQM)*qbaCV))/(model_.QM0));
{
double value_pow_0 = pow(T0,(0.7*(model_.BDOS)));
double  deriv_pow_0_d0 = ((T0 == 0.0)?0.0:(value_pow_0*(0.7*(model_.BDOS))/T0));

d_T1_dV_gm_di = d_T1_dV_gm_si =  0.0;
d_T1_dTemp_t_GND = (deriv_pow_0_d0*(d_T0_dTemp_t_GND));
d_T1_dV_si_bi = (deriv_pow_0_d0*(d_T0_dV_si_bi));
d_T1_dV_di_bi = (deriv_pow_0_d0*(d_T0_dV_di_bi));
d_T1_dV_gi_bi = (deriv_pow_0_d0*(d_T0_dV_gi_bi));
d_T1_dV_sbulk_si = (deriv_pow_0_d0*(d_T0_dV_sbulk_si));
d_T1_dV_dbulk_di = (deriv_pow_0_d0*(d_T0_dV_dbulk_di));
T1 = (1.0+value_pow_0);
}

d_XDCinv_dTemp_t_GND = (-((model_.ADOS)*1.9e-9)*d_T1_dTemp_t_GND/T1/T1);
d_XDCinv_dV_si_bi = (-((model_.ADOS)*1.9e-9)*d_T1_dV_si_bi/T1/T1);
d_XDCinv_dV_di_bi = (-((model_.ADOS)*1.9e-9)*d_T1_dV_di_bi/T1/T1);
d_XDCinv_dV_gi_bi = (-((model_.ADOS)*1.9e-9)*d_T1_dV_gi_bi/T1/T1);
d_XDCinv_dV_sbulk_si = (-((model_.ADOS)*1.9e-9)*d_T1_dV_sbulk_si/T1/T1);
d_XDCinv_dV_dbulk_di = (-((model_.ADOS)*1.9e-9)*d_T1_dV_dbulk_di/T1/T1);
XDCinv = (((model_.ADOS)*1.9e-9)/T1);

d_Coxeffinv_dTemp_t_GND = (-(3.9*8.85418e-12)*(d_XDCinv_dTemp_t_GND/epsratio)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio))/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));
d_Coxeffinv_dV_si_bi = (-(3.9*8.85418e-12)*(d_XDCinv_dV_si_bi/epsratio)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio))/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));
d_Coxeffinv_dV_di_bi = (-(3.9*8.85418e-12)*(d_XDCinv_dV_di_bi/epsratio)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio))/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));
d_Coxeffinv_dV_gi_bi = (-(3.9*8.85418e-12)*(d_XDCinv_dV_gi_bi/epsratio)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio))/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));
d_Coxeffinv_dV_sbulk_si = (-(3.9*8.85418e-12)*(d_XDCinv_dV_sbulk_si/epsratio)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio))/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));
d_Coxeffinv_dV_dbulk_di = (-(3.9*8.85418e-12)*(d_XDCinv_dV_dbulk_di/epsratio)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio))/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));
Coxeffinv = ((3.9*8.85418e-12)/(((BSIM6TOXP*3.9)/(model_.EPSROX))+(XDCinv/epsratio)));

d_QBi_dV_si_bi = (((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*d_Qb_dV_si_bi;
d_QBi_dV_di_bi = (((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*d_Qb_dV_di_bi;
d_QBi_dV_gi_bi = (((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*d_Qb_dV_gi_bi;
d_QBi_dV_sbulk_si = (((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*d_Qb_dV_sbulk_si;
d_QBi_dV_dbulk_di = (((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*d_Qb_dV_dbulk_di;
d_QBi_dTemp_t_GND = ((((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*d_Qb_dTemp_t_GND+((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*d_Vt_dTemp_t_GND*Qb);
QBi = ((((((-NF)*Wact)*Lact)*((8.85418e-12*(model_.EPSROX))/BSIM6TOXP))*Vt)*Qb);

d_WLCOXVtinv_dTemp_t_GND = ((((NF*Wact)*Lact)*Coxeffinv)*d_Vt_dTemp_t_GND+((NF*Wact)*Lact)*d_Coxeffinv_dTemp_t_GND*Vt);
d_WLCOXVtinv_dV_si_bi = ((NF*Wact)*Lact)*d_Coxeffinv_dV_si_bi*Vt;
d_WLCOXVtinv_dV_di_bi = ((NF*Wact)*Lact)*d_Coxeffinv_dV_di_bi*Vt;
d_WLCOXVtinv_dV_gi_bi = ((NF*Wact)*Lact)*d_Coxeffinv_dV_gi_bi*Vt;
d_WLCOXVtinv_dV_sbulk_si = ((NF*Wact)*Lact)*d_Coxeffinv_dV_sbulk_si*Vt;
d_WLCOXVtinv_dV_dbulk_di = ((NF*Wact)*Lact)*d_Coxeffinv_dV_dbulk_di*Vt;
WLCOXVtinv = ((((NF*Wact)*Lact)*Coxeffinv)*Vt);

d_QSi_dTemp_t_GND = ((-WLCOXVtinv)*d_Qs_dTemp_t_GND+(-d_WLCOXVtinv_dTemp_t_GND)*Qs);
d_QSi_dV_si_bi = ((-WLCOXVtinv)*d_Qs_dV_si_bi+(-d_WLCOXVtinv_dV_si_bi)*Qs);
d_QSi_dV_di_bi = ((-WLCOXVtinv)*d_Qs_dV_di_bi+(-d_WLCOXVtinv_dV_di_bi)*Qs);
d_QSi_dV_gi_bi = ((-WLCOXVtinv)*d_Qs_dV_gi_bi+(-d_WLCOXVtinv_dV_gi_bi)*Qs);
d_QSi_dV_sbulk_si = ((-WLCOXVtinv)*d_Qs_dV_sbulk_si+(-d_WLCOXVtinv_dV_sbulk_si)*Qs);
d_QSi_dV_dbulk_di = ((-WLCOXVtinv)*d_Qs_dV_dbulk_di+(-d_WLCOXVtinv_dV_dbulk_di)*Qs);
QSi = ((-WLCOXVtinv)*Qs);

d_QDi_dTemp_t_GND = ((-WLCOXVtinv)*d_Qd_dTemp_t_GND+(-d_WLCOXVtinv_dTemp_t_GND)*Qd);
d_QDi_dV_si_bi = ((-WLCOXVtinv)*d_Qd_dV_si_bi+(-d_WLCOXVtinv_dV_si_bi)*Qd);
d_QDi_dV_di_bi = ((-WLCOXVtinv)*d_Qd_dV_di_bi+(-d_WLCOXVtinv_dV_di_bi)*Qd);
d_QDi_dV_gi_bi = ((-WLCOXVtinv)*d_Qd_dV_gi_bi+(-d_WLCOXVtinv_dV_gi_bi)*Qd);
d_QDi_dV_sbulk_si = ((-WLCOXVtinv)*d_Qd_dV_sbulk_si+(-d_WLCOXVtinv_dV_sbulk_si)*Qd);
d_QDi_dV_dbulk_di = ((-WLCOXVtinv)*d_Qd_dV_dbulk_di+(-d_WLCOXVtinv_dV_dbulk_di)*Qd);
QDi = ((-WLCOXVtinv)*Qd);

d_QGi_dV_si_bi = (-((d_QBi_dV_si_bi+d_QSi_dV_si_bi)+d_QDi_dV_si_bi));
d_QGi_dV_di_bi = (-((d_QBi_dV_di_bi+d_QSi_dV_di_bi)+d_QDi_dV_di_bi));
d_QGi_dV_gi_bi = (-((d_QBi_dV_gi_bi+d_QSi_dV_gi_bi)+d_QDi_dV_gi_bi));
d_QGi_dV_sbulk_si = (-((d_QBi_dV_sbulk_si+d_QSi_dV_sbulk_si)+d_QDi_dV_sbulk_si));
d_QGi_dV_dbulk_di = (-((d_QBi_dV_dbulk_di+d_QSi_dV_dbulk_di)+d_QDi_dV_dbulk_di));
d_QGi_dTemp_t_GND = (-((d_QBi_dTemp_t_GND+d_QSi_dTemp_t_GND)+d_QDi_dTemp_t_GND));
QGi = (-((QBi+QSi)+QDi));
if ((!(model_.given("CF"))))
{
{
double value_log_0 = log(((model_.CFRCOEFF)*(1.0+(0.4e-6/(model_.TOXE)))));
CF_i = ((((2.0*(model_.EPSROX))*8.85418e-12)/3.14159265358979323846)*value_log_0);
}
}
Cgsof = ((model_.CGSO)+CF_i);
Cgdof = ((model_.CGDO)+CF_i);
if (((model_.COVMOD)==0))
{

d_Qovs_dTemp_t_GND = d_Qovs_dV_dbulk_di = d_Qovs_dV_sbulk_si = d_Qovs_dV_gi_bi = d_Qovs_dV_di_bi = d_Qovs_dV_si_bi =  0.0;
d_Qovs_dV_gm_si = (((-Wact)*NF)*Cgsof)*d_Vgs_ov_noswap_dV_gm_si;
Qovs = ((((-Wact)*NF)*Cgsof)*Vgs_ov_noswap);

d_Qovd_dTemp_t_GND = d_Qovd_dV_gm_si = d_Qovd_dV_dbulk_di = d_Qovd_dV_sbulk_si = d_Qovd_dV_gi_bi = d_Qovd_dV_di_bi = d_Qovd_dV_si_bi =  0.0;
d_Qovd_dV_gm_di = (((-Wact)*NF)*Cgdof)*d_Vgd_ov_noswap_dV_gm_di;
Qovd = ((((-Wact)*NF)*Cgdof)*Vgd_ov_noswap);
}
else
{
{
double value_sqrt_0 = sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_gm_di = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (deriv_sqrt_0_d0*((((Vgs_ov_noswap-Vfbsdr)+0.02)*(-d_Vfbsdr_dTemp_t_GND)+(-d_Vfbsdr_dTemp_t_GND)*((Vgs_ov_noswap-Vfbsdr)+0.02))));
d_T0_dV_gm_si = (deriv_sqrt_0_d0*((((Vgs_ov_noswap-Vfbsdr)+0.02)*d_Vgs_ov_noswap_dV_gm_si+d_Vgs_ov_noswap_dV_gm_si*((Vgs_ov_noswap-Vfbsdr)+0.02))));
T0 = value_sqrt_0;
}

d_Vgsov_dV_si_bi = 0.5*(-d_T0_dV_si_bi);
d_Vgsov_dV_di_bi = 0.5*(-d_T0_dV_di_bi);
d_Vgsov_dV_gi_bi = 0.5*(-d_T0_dV_gi_bi);
d_Vgsov_dV_sbulk_si = 0.5*(-d_T0_dV_sbulk_si);
d_Vgsov_dV_dbulk_di = 0.5*(-d_T0_dV_dbulk_di);
d_Vgsov_dTemp_t_GND = 0.5*((-d_Vfbsdr_dTemp_t_GND)-d_T0_dTemp_t_GND);
d_Vgsov_dV_gm_si = 0.5*(d_Vgs_ov_noswap_dV_gm_si-d_T0_dV_gm_si);
Vgsov = (0.5*(((Vgs_ov_noswap-Vfbsdr)+0.02)-T0));
{
double value_sqrt_0 = sqrt((1.0-((4.0*Vgsov)/CKAPPAS_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T1_dV_gm_di =  0.0;
d_T1_dV_si_bi = (deriv_sqrt_0_d0*((-(4.0*d_Vgsov_dV_si_bi/CKAPPAS_i))));
d_T1_dV_di_bi = (deriv_sqrt_0_d0*((-(4.0*d_Vgsov_dV_di_bi/CKAPPAS_i))));
d_T1_dV_gi_bi = (deriv_sqrt_0_d0*((-(4.0*d_Vgsov_dV_gi_bi/CKAPPAS_i))));
d_T1_dV_sbulk_si = (deriv_sqrt_0_d0*((-(4.0*d_Vgsov_dV_sbulk_si/CKAPPAS_i))));
d_T1_dV_dbulk_di = (deriv_sqrt_0_d0*((-(4.0*d_Vgsov_dV_dbulk_di/CKAPPAS_i))));
d_T1_dTemp_t_GND = (deriv_sqrt_0_d0*((-(4.0*d_Vgsov_dTemp_t_GND/CKAPPAS_i))));
d_T1_dV_gm_si = (deriv_sqrt_0_d0*((-(4.0*d_Vgsov_dV_gm_si/CKAPPAS_i))));
T1 = value_sqrt_0;
}

d_Qovs_dV_si_bi = ((-Wact)*NF)*CGSL_i*((-d_Vgsov_dV_si_bi)-(0.5*CKAPPAS_i)*d_T1_dV_si_bi);
d_Qovs_dV_di_bi = ((-Wact)*NF)*CGSL_i*((-d_Vgsov_dV_di_bi)-(0.5*CKAPPAS_i)*d_T1_dV_di_bi);
d_Qovs_dV_gi_bi = ((-Wact)*NF)*CGSL_i*((-d_Vgsov_dV_gi_bi)-(0.5*CKAPPAS_i)*d_T1_dV_gi_bi);
d_Qovs_dV_sbulk_si = ((-Wact)*NF)*CGSL_i*((-d_Vgsov_dV_sbulk_si)-(0.5*CKAPPAS_i)*d_T1_dV_sbulk_si);
d_Qovs_dV_dbulk_di = ((-Wact)*NF)*CGSL_i*((-d_Vgsov_dV_dbulk_di)-(0.5*CKAPPAS_i)*d_T1_dV_dbulk_di);
d_Qovs_dTemp_t_GND = ((-Wact)*NF)*CGSL_i*(((-d_Vfbsdr_dTemp_t_GND)-d_Vgsov_dTemp_t_GND)-(0.5*CKAPPAS_i)*d_T1_dTemp_t_GND);
d_Qovs_dV_gm_si = ((-Wact)*NF)*(Cgsof*d_Vgs_ov_noswap_dV_gm_si+CGSL_i*((d_Vgs_ov_noswap_dV_gm_si-d_Vgsov_dV_gm_si)-(0.5*CKAPPAS_i)*d_T1_dV_gm_si));
Qovs = (((-Wact)*NF)*((Cgsof*Vgs_ov_noswap)+(CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*CKAPPAS_i)*((-1.0)+T1))))));
{
double value_sqrt_0 = sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_gm_si = d_T0_dV_dbulk_di = d_T0_dV_sbulk_si = d_T0_dV_gi_bi = d_T0_dV_di_bi = d_T0_dV_si_bi =  0.0;
d_T0_dTemp_t_GND = (deriv_sqrt_0_d0*((((Vgd_ov_noswap-Vfbsdr)+0.02)*(-d_Vfbsdr_dTemp_t_GND)+(-d_Vfbsdr_dTemp_t_GND)*((Vgd_ov_noswap-Vfbsdr)+0.02))));
d_T0_dV_gm_di = (deriv_sqrt_0_d0*((((Vgd_ov_noswap-Vfbsdr)+0.02)*d_Vgd_ov_noswap_dV_gm_di+d_Vgd_ov_noswap_dV_gm_di*((Vgd_ov_noswap-Vfbsdr)+0.02))));
T0 = value_sqrt_0;
}

d_Vgdov_dV_si_bi = 0.5*(-d_T0_dV_si_bi);
d_Vgdov_dV_di_bi = 0.5*(-d_T0_dV_di_bi);
d_Vgdov_dV_gi_bi = 0.5*(-d_T0_dV_gi_bi);
d_Vgdov_dV_sbulk_si = 0.5*(-d_T0_dV_sbulk_si);
d_Vgdov_dV_dbulk_di = 0.5*(-d_T0_dV_dbulk_di);
d_Vgdov_dV_gm_si = 0.5*(-d_T0_dV_gm_si);
d_Vgdov_dTemp_t_GND = 0.5*((-d_Vfbsdr_dTemp_t_GND)-d_T0_dTemp_t_GND);
d_Vgdov_dV_gm_di = 0.5*(d_Vgd_ov_noswap_dV_gm_di-d_T0_dV_gm_di);
Vgdov = (0.5*(((Vgd_ov_noswap-Vfbsdr)+0.02)-T0));
{
double value_sqrt_0 = sqrt((1.0-((4.0*Vgdov)/CKAPPAD_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_si_bi = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dV_si_bi/CKAPPAD_i))));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dV_di_bi/CKAPPAD_i))));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dV_gi_bi/CKAPPAD_i))));
d_T2_dV_sbulk_si = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dV_sbulk_si/CKAPPAD_i))));
d_T2_dV_dbulk_di = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dV_dbulk_di/CKAPPAD_i))));
d_T2_dV_gm_si = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dV_gm_si/CKAPPAD_i))));
d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dTemp_t_GND/CKAPPAD_i))));
d_T2_dV_gm_di = (deriv_sqrt_0_d0*((-(4.0*d_Vgdov_dV_gm_di/CKAPPAD_i))));
T2 = value_sqrt_0;
}

d_Qovd_dV_si_bi = ((-Wact)*NF)*CGDL_i*((-d_Vgdov_dV_si_bi)-(0.5*CKAPPAD_i)*d_T2_dV_si_bi);
d_Qovd_dV_di_bi = ((-Wact)*NF)*CGDL_i*((-d_Vgdov_dV_di_bi)-(0.5*CKAPPAD_i)*d_T2_dV_di_bi);
d_Qovd_dV_gi_bi = ((-Wact)*NF)*CGDL_i*((-d_Vgdov_dV_gi_bi)-(0.5*CKAPPAD_i)*d_T2_dV_gi_bi);
d_Qovd_dV_sbulk_si = ((-Wact)*NF)*CGDL_i*((-d_Vgdov_dV_sbulk_si)-(0.5*CKAPPAD_i)*d_T2_dV_sbulk_si);
d_Qovd_dV_dbulk_di = ((-Wact)*NF)*CGDL_i*((-d_Vgdov_dV_dbulk_di)-(0.5*CKAPPAD_i)*d_T2_dV_dbulk_di);
d_Qovd_dV_gm_si = ((-Wact)*NF)*CGDL_i*((-d_Vgdov_dV_gm_si)-(0.5*CKAPPAD_i)*d_T2_dV_gm_si);
d_Qovd_dTemp_t_GND = ((-Wact)*NF)*CGDL_i*(((-d_Vfbsdr_dTemp_t_GND)-d_Vgdov_dTemp_t_GND)-(0.5*CKAPPAD_i)*d_T2_dTemp_t_GND);
d_Qovd_dV_gm_di = ((-Wact)*NF)*(Cgdof*d_Vgd_ov_noswap_dV_gm_di+CGDL_i*((d_Vgd_ov_noswap_dV_gm_di-d_Vgdov_dV_gm_di)-(0.5*CKAPPAD_i)*d_T2_dV_gm_di));
Qovd = (((-Wact)*NF)*((Cgdof*Vgd_ov_noswap)+(CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*CKAPPAD_i)*((-1.0)+T2))))));
}

d_Qovb_dV_gm_bi = ((((-devsign)*NF)*Lact)*(model_.CGBO))*d_probeVars[admsProbeID_V_gm_bi][admsProbeID_V_gm_bi];
Qovb = (((((-devsign)*NF)*Lact)*(model_.CGBO))*(probeVars[admsProbeID_V_gm_bi]));

d_Qovg_dV_gm_bi = (-d_Qovb_dV_gm_bi);
d_Qovg_dV_gm_di = (-d_Qovd_dV_gm_di);
d_Qovg_dV_gm_si = (-(d_Qovs_dV_gm_si+d_Qovd_dV_gm_si));
d_Qovg_dV_si_bi = (-(d_Qovs_dV_si_bi+d_Qovd_dV_si_bi));
d_Qovg_dV_di_bi = (-(d_Qovs_dV_di_bi+d_Qovd_dV_di_bi));
d_Qovg_dV_gi_bi = (-(d_Qovs_dV_gi_bi+d_Qovd_dV_gi_bi));
d_Qovg_dV_sbulk_si = (-(d_Qovs_dV_sbulk_si+d_Qovd_dV_sbulk_si));
d_Qovg_dV_dbulk_di = (-(d_Qovs_dV_dbulk_di+d_Qovd_dV_dbulk_di));
d_Qovg_dTemp_t_GND = (-(d_Qovs_dTemp_t_GND+d_Qovd_dTemp_t_GND));
Qovg = (-((Qovs+Qovd)+Qovb));
if (((model_.EDGEFET)==1))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((1.0+((model_.TNFACTOREDGE)*(TRatio-1.0))),1e-3);

d_NFACTOREDGE_t_dTemp_t_GND = (model_.NFACTOREDGE)*evaluator_hypsmooth_0.getDerivs((1.0+((model_.TNFACTOREDGE)*(TRatio-1.0))),1e-3,(model_.TNFACTOREDGE)*d_TRatio_dTemp_t_GND,0.0);
NFACTOREDGE_t = ((model_.NFACTOREDGE)*evaluator_hypsmooth_0.getValues((1.0+((model_.TNFACTOREDGE)*(TRatio-1.0))),1e-3));
}

d_ETA0EDGE_t_dTemp_t_GND = (model_.ETA0EDGE)*(model_.TETA0EDGE)*d_TRatio_dTemp_t_GND;
ETA0EDGE_t = ((model_.ETA0EDGE)*(1.0+((model_.TETA0EDGE)*(TRatio-1.0))));

d_cdsc_dV_si_bi = ((model_.CDSCDEDGE)*d_Vdsx_dV_si_bi-(model_.CDSCBEDGE)*d_Vbsx_dV_si_bi);
d_cdsc_dV_di_bi = ((model_.CDSCDEDGE)*d_Vdsx_dV_di_bi-(model_.CDSCBEDGE)*d_Vbsx_dV_di_bi);
d_cdsc_dTemp_t_GND = d_NFACTOREDGE_t_dTemp_t_GND;
cdsc = ((((model_.CITEDGE)+NFACTOREDGE_t)+((model_.CDSCDEDGE)*Vdsx))-((model_.CDSCBEDGE)*Vbsx));

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi =  0.0;
d_T1_dV_si_bi = (d_cdsc_dV_si_bi/Cox);
d_T1_dV_di_bi = (d_cdsc_dV_di_bi/Cox);
d_T1_dTemp_t_GND = (d_cdsc_dTemp_t_GND/Cox);
T1 = (1.0+(cdsc/Cox));
{
double value_sqrt_0 = sqrt((((T1-1.0)*(T1-1.0))+((0.25*0.05)*0.05)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_n_dTemp_t_GND = 0.5*(d_T1_dTemp_t_GND+(deriv_sqrt_0_d0*(((T1-1.0)*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*(T1-1.0)))));
d_n_dV_si_bi = 0.5*(d_T1_dV_si_bi+(deriv_sqrt_0_d0*(((T1-1.0)*d_T1_dV_si_bi+d_T1_dV_si_bi*(T1-1.0)))));
d_n_dV_di_bi = 0.5*(d_T1_dV_di_bi+(deriv_sqrt_0_d0*(((T1-1.0)*d_T1_dV_di_bi+d_T1_dV_di_bi*(T1-1.0)))));
d_n_dV_gi_bi = 0.5*(d_T1_dV_gi_bi+(deriv_sqrt_0_d0*(((T1-1.0)*d_T1_dV_gi_bi+d_T1_dV_gi_bi*(T1-1.0)))));
d_n_dV_sbulk_si = 0.5*(d_T1_dV_sbulk_si+(deriv_sqrt_0_d0*(((T1-1.0)*d_T1_dV_sbulk_si+d_T1_dV_sbulk_si*(T1-1.0)))));
d_n_dV_dbulk_di = 0.5*(d_T1_dV_dbulk_di+(deriv_sqrt_0_d0*(((T1-1.0)*d_T1_dV_dbulk_di+d_T1_dV_dbulk_di*(T1-1.0)))));
d_n_dV_gm_si = 0.5*(d_T1_dV_gm_si+(deriv_sqrt_0_d0*(((T1-1.0)*d_T1_dV_gm_si+d_T1_dV_gm_si*(T1-1.0)))));
n = (0.5*((T1+1.0)+value_sqrt_0));
}

d_nVt_dTemp_t_GND = (n*d_Vt_dTemp_t_GND+d_n_dTemp_t_GND*Vt);
d_nVt_dV_si_bi = d_n_dV_si_bi*Vt;
d_nVt_dV_di_bi = d_n_dV_di_bi*Vt;
d_nVt_dV_gi_bi = d_n_dV_gi_bi*Vt;
d_nVt_dV_sbulk_si = d_n_dV_sbulk_si*Vt;
d_nVt_dV_dbulk_di = d_n_dV_dbulk_di*Vt;
d_nVt_dV_gm_si = d_n_dV_gm_si*Vt;
nVt = (n*Vt);

d_inv_nVt_dTemp_t_GND = (-d_nVt_dTemp_t_GND/nVt/nVt);
d_inv_nVt_dV_si_bi = (-d_nVt_dV_si_bi/nVt/nVt);
d_inv_nVt_dV_di_bi = (-d_nVt_dV_di_bi/nVt/nVt);
d_inv_nVt_dV_gi_bi = (-d_nVt_dV_gi_bi/nVt/nVt);
d_inv_nVt_dV_sbulk_si = (-d_nVt_dV_sbulk_si/nVt/nVt);
d_inv_nVt_dV_dbulk_di = (-d_nVt_dV_dbulk_di/nVt/nVt);
d_inv_nVt_dV_gm_si = (-d_nVt_dV_gm_si/nVt/nVt);
inv_nVt = (1.0/nVt);

d_vg_dTemp_t_GND = Vg*d_inv_nVt_dTemp_t_GND;
d_vg_dV_si_bi = Vg*d_inv_nVt_dV_si_bi;
d_vg_dV_di_bi = Vg*d_inv_nVt_dV_di_bi;
d_vg_dV_sbulk_si = Vg*d_inv_nVt_dV_sbulk_si;
d_vg_dV_dbulk_di = Vg*d_inv_nVt_dV_dbulk_di;
d_vg_dV_gm_si = Vg*d_inv_nVt_dV_gm_si;
d_vg_dV_gi_bi = (Vg*d_inv_nVt_dV_gi_bi+d_Vg_dV_gi_bi*inv_nVt);
vg = (Vg*inv_nVt);

d_vs_dTemp_t_GND = Vs*d_inv_nVt_dTemp_t_GND;
d_vs_dV_gi_bi = Vs*d_inv_nVt_dV_gi_bi;
d_vs_dV_sbulk_si = Vs*d_inv_nVt_dV_sbulk_si;
d_vs_dV_dbulk_di = Vs*d_inv_nVt_dV_dbulk_di;
d_vs_dV_gm_si = Vs*d_inv_nVt_dV_gm_si;
d_vs_dV_si_bi = (Vs*d_inv_nVt_dV_si_bi+d_Vs_dV_si_bi*inv_nVt);
d_vs_dV_di_bi = (Vs*d_inv_nVt_dV_di_bi+d_Vs_dV_di_bi*inv_nVt);
vs = (Vs*inv_nVt);

d_vfb_dTemp_t_GND = VFB_i*d_inv_nVt_dTemp_t_GND;
d_vfb_dV_si_bi = VFB_i*d_inv_nVt_dV_si_bi;
d_vfb_dV_di_bi = VFB_i*d_inv_nVt_dV_di_bi;
d_vfb_dV_gi_bi = VFB_i*d_inv_nVt_dV_gi_bi;
d_vfb_dV_sbulk_si = VFB_i*d_inv_nVt_dV_sbulk_si;
d_vfb_dV_dbulk_di = VFB_i*d_inv_nVt_dV_dbulk_di;
d_vfb_dV_gm_si = VFB_i*d_inv_nVt_dV_gm_si;
vfb = (VFB_i*inv_nVt);

d_dvth_dibl_dV_si_bi = ((-(ETA0EDGE_t+((model_.ETABEDGE)*Vbsx)))*d_Vdsx_dV_si_bi+(-(model_.ETABEDGE)*d_Vbsx_dV_si_bi)*Vdsx);
d_dvth_dibl_dV_di_bi = ((-(ETA0EDGE_t+((model_.ETABEDGE)*Vbsx)))*d_Vdsx_dV_di_bi+(-(model_.ETABEDGE)*d_Vbsx_dV_di_bi)*Vdsx);
d_dvth_dibl_dTemp_t_GND = (-d_ETA0EDGE_t_dTemp_t_GND)*Vdsx;
dvth_dibl = ((-(ETA0EDGE_t+((model_.ETABEDGE)*Vbsx)))*Vdsx);
{
double value_pow_0 = pow(TRatio,(model_.KT1EXPEDGE));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(model_.KT1EXPEDGE)/TRatio));

d_dvth_temp_dTemp_t_GND = (((model_.KT1EDGE)+((model_.KT1LEDGE)/Leff))+((model_.KT2EDGE)*Vbsx))*(deriv_pow_0_d0*(d_TRatio_dTemp_t_GND));
d_dvth_temp_dV_si_bi = (model_.KT2EDGE)*d_Vbsx_dV_si_bi*(value_pow_0-1.0);
d_dvth_temp_dV_di_bi = (model_.KT2EDGE)*d_Vbsx_dV_di_bi*(value_pow_0-1.0);
dvth_temp = ((((model_.KT1EDGE)+((model_.KT1LEDGE)/Leff))+((model_.KT2EDGE)*Vbsx))*(value_pow_0-1.0));
}

d_litl_edge_dV_si_bi = litl*(model_.DVT2EDGE)*d_Vbsx_dV_si_bi;
d_litl_edge_dV_di_bi = litl*(model_.DVT2EDGE)*d_Vbsx_dV_di_bi;
litl_edge = (litl*(1.0+((model_.DVT2EDGE)*Vbsx)));
{
double value_cosh_0 = cosh((((model_.DVT1EDGE)*Leff)/litl_edge));
double  deriv_cosh_0_d0 = (sinh((((model_.DVT1EDGE)*Leff)/litl_edge)));

d_theta_sce_edge_dV_si_bi = (-(0.5*(model_.DVT0EDGE))*(deriv_cosh_0_d0*((-((model_.DVT1EDGE)*Leff)*d_litl_edge_dV_si_bi/litl_edge/litl_edge)))/(value_cosh_0-1.0)/(value_cosh_0-1.0));
d_theta_sce_edge_dV_di_bi = (-(0.5*(model_.DVT0EDGE))*(deriv_cosh_0_d0*((-((model_.DVT1EDGE)*Leff)*d_litl_edge_dV_di_bi/litl_edge/litl_edge)))/(value_cosh_0-1.0)/(value_cosh_0-1.0));
theta_sce_edge = ((0.5*(model_.DVT0EDGE))/(value_cosh_0-1.0));
}

d_dvth_sce_dTemp_t_GND = theta_sce_edge*(d_Vbi_dTemp_t_GND-d_Phist_dTemp_t_GND);
d_dvth_sce_dV_si_bi = d_theta_sce_edge_dV_si_bi*(Vbi-Phist);
d_dvth_sce_dV_di_bi = d_theta_sce_edge_dV_di_bi*(Vbi-Phist);
dvth_sce = (theta_sce_edge*(Vbi-Phist));

d_Vth_shift_dV_si_bi = ((d_dvth_dibl_dV_si_bi-d_dvth_temp_dV_si_bi)+d_dvth_sce_dV_si_bi);
d_Vth_shift_dV_di_bi = ((d_dvth_dibl_dV_di_bi-d_dvth_temp_dV_di_bi)+d_dvth_sce_dV_di_bi);
d_Vth_shift_dTemp_t_GND = ((d_dvth_dibl_dTemp_t_GND-d_dvth_temp_dTemp_t_GND)+d_dvth_sce_dTemp_t_GND);
Vth_shift = (((dvth_dibl-dvth_temp)+dvth_sce)+(model_.DVTEDGE));

d_vgfb_dTemp_t_GND = ((d_vg_dTemp_t_GND-d_vfb_dTemp_t_GND)-(Vth_shift*d_inv_nVt_dTemp_t_GND+d_Vth_shift_dTemp_t_GND*inv_nVt));
d_vgfb_dV_si_bi = ((d_vg_dV_si_bi-d_vfb_dV_si_bi)-(Vth_shift*d_inv_nVt_dV_si_bi+d_Vth_shift_dV_si_bi*inv_nVt));
d_vgfb_dV_di_bi = ((d_vg_dV_di_bi-d_vfb_dV_di_bi)-(Vth_shift*d_inv_nVt_dV_di_bi+d_Vth_shift_dV_di_bi*inv_nVt));
d_vgfb_dV_gi_bi = ((d_vg_dV_gi_bi-d_vfb_dV_gi_bi)-Vth_shift*d_inv_nVt_dV_gi_bi);
d_vgfb_dV_sbulk_si = ((d_vg_dV_sbulk_si-d_vfb_dV_sbulk_si)-Vth_shift*d_inv_nVt_dV_sbulk_si);
d_vgfb_dV_dbulk_di = ((d_vg_dV_dbulk_di-d_vfb_dV_dbulk_di)-Vth_shift*d_inv_nVt_dV_dbulk_di);
d_vgfb_dV_gm_si = ((d_vg_dV_gm_si-d_vfb_dV_gm_si)-Vth_shift*d_inv_nVt_dV_gm_si);
vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
{
double value_pow_0 = pow(Leff,(-(model_.DGAMMAEDGELEXP)));
DGAMMAEDGE_i = ((model_.DGAMMAEDGE)*(1.0+((model_.DGAMMAEDGEL)*value_pow_0)));
}
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*epssi)*NDEP_i)*inv_nVt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_gam_dTemp_t_GND = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dTemp_t_GND))/Cox);
d_gam_dV_si_bi = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_si_bi))/Cox);
d_gam_dV_di_bi = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_di_bi))/Cox);
d_gam_dV_gi_bi = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_gi_bi))/Cox);
d_gam_dV_sbulk_si = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_sbulk_si))/Cox);
d_gam_dV_dbulk_di = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_dbulk_di))/Cox);
d_gam_dV_gm_si = ((deriv_sqrt_0_d0*((((2.0*1.60219e-19)*epssi)*NDEP_i)*d_inv_nVt_dV_gm_si))/Cox);
gam = (value_sqrt_0/Cox);
}

d_gam_dTemp_t_GND = d_gam_dTemp_t_GND*(1.0+DGAMMAEDGE_i);
d_gam_dV_si_bi = d_gam_dV_si_bi*(1.0+DGAMMAEDGE_i);
d_gam_dV_di_bi = d_gam_dV_di_bi*(1.0+DGAMMAEDGE_i);
d_gam_dV_gi_bi = d_gam_dV_gi_bi*(1.0+DGAMMAEDGE_i);
d_gam_dV_sbulk_si = d_gam_dV_sbulk_si*(1.0+DGAMMAEDGE_i);
d_gam_dV_dbulk_di = d_gam_dV_dbulk_di*(1.0+DGAMMAEDGE_i);
d_gam_dV_gm_si = d_gam_dV_gm_si*(1.0+DGAMMAEDGE_i);
gam = (gam*(1.0+DGAMMAEDGE_i));

d_inv_gam_dTemp_t_GND = (-d_gam_dTemp_t_GND/gam/gam);
d_inv_gam_dV_si_bi = (-d_gam_dV_si_bi/gam/gam);
d_inv_gam_dV_di_bi = (-d_gam_dV_di_bi/gam/gam);
d_inv_gam_dV_gi_bi = (-d_gam_dV_gi_bi/gam/gam);
d_inv_gam_dV_sbulk_si = (-d_gam_dV_sbulk_si/gam/gam);
d_inv_gam_dV_dbulk_di = (-d_gam_dV_dbulk_di/gam/gam);
d_inv_gam_dV_gm_si = (-d_gam_dV_gm_si/gam/gam);
inv_gam = (1.0/gam);

d_phib_n_dV_si_bi = (-phib*d_n_dV_si_bi/n/n);
d_phib_n_dV_di_bi = (-phib*d_n_dV_di_bi/n/n);
d_phib_n_dV_gi_bi = (-phib*d_n_dV_gi_bi/n/n);
d_phib_n_dV_sbulk_si = (-phib*d_n_dV_sbulk_si/n/n);
d_phib_n_dV_dbulk_di = (-phib*d_n_dV_dbulk_di/n/n);
d_phib_n_dV_gm_si = (-phib*d_n_dV_gm_si/n/n);
d_phib_n_dTemp_t_GND = ((n*d_phib_dTemp_t_GND-phib*d_n_dTemp_t_GND)/n/n);
phib_n = (phib/n);

d_T1_dV_gm_di = d_T1_dV_gm_si = d_T1_dV_dbulk_di = d_T1_dV_sbulk_si = d_T1_dV_gi_bi = d_T1_dV_di_bi = d_T1_dV_si_bi = d_T1_dTemp_t_GND =  0.0;
T1 = 1.0;

d_vgfbPD_dTemp_t_GND = ((T1*d_vgfb_dTemp_t_GND-vgfb*d_T1_dTemp_t_GND)/T1/T1);
d_vgfbPD_dV_si_bi = ((T1*d_vgfb_dV_si_bi-vgfb*d_T1_dV_si_bi)/T1/T1);
d_vgfbPD_dV_di_bi = ((T1*d_vgfb_dV_di_bi-vgfb*d_T1_dV_di_bi)/T1/T1);
d_vgfbPD_dV_gi_bi = ((T1*d_vgfb_dV_gi_bi-vgfb*d_T1_dV_gi_bi)/T1/T1);
d_vgfbPD_dV_sbulk_si = ((T1*d_vgfb_dV_sbulk_si-vgfb*d_T1_dV_sbulk_si)/T1/T1);
d_vgfbPD_dV_dbulk_di = ((T1*d_vgfb_dV_dbulk_di-vgfb*d_T1_dV_dbulk_di)/T1/T1);
d_vgfbPD_dV_gm_si = ((T1*d_vgfb_dV_gm_si-vgfb*d_T1_dV_gm_si)/T1/T1);
vgfbPD = (vgfb/T1);

d_gammaPD_dTemp_t_GND = ((T1*d_gam_dTemp_t_GND-gam*d_T1_dTemp_t_GND)/T1/T1);
d_gammaPD_dV_si_bi = ((T1*d_gam_dV_si_bi-gam*d_T1_dV_si_bi)/T1/T1);
d_gammaPD_dV_di_bi = ((T1*d_gam_dV_di_bi-gam*d_T1_dV_di_bi)/T1/T1);
d_gammaPD_dV_gi_bi = ((T1*d_gam_dV_gi_bi-gam*d_T1_dV_gi_bi)/T1/T1);
d_gammaPD_dV_sbulk_si = ((T1*d_gam_dV_sbulk_si-gam*d_T1_dV_sbulk_si)/T1/T1);
d_gammaPD_dV_dbulk_di = ((T1*d_gam_dV_dbulk_di-gam*d_T1_dV_dbulk_di)/T1/T1);
d_gammaPD_dV_gm_si = ((T1*d_gam_dV_gm_si-gam*d_T1_dV_gm_si)/T1/T1);
gammaPD = (gam/T1);

d_T1_dV_gm_di =  0.0;
d_T1_dTemp_t_GND = (0.5*d_vgfbPD_dTemp_t_GND-3.0*(d_gammaPD_dTemp_t_GND/1.41421356237309504880));
d_T1_dV_si_bi = (0.5*d_vgfbPD_dV_si_bi-3.0*(d_gammaPD_dV_si_bi/1.41421356237309504880));
d_T1_dV_di_bi = (0.5*d_vgfbPD_dV_di_bi-3.0*(d_gammaPD_dV_di_bi/1.41421356237309504880));
d_T1_dV_gi_bi = (0.5*d_vgfbPD_dV_gi_bi-3.0*(d_gammaPD_dV_gi_bi/1.41421356237309504880));
d_T1_dV_sbulk_si = (0.5*d_vgfbPD_dV_sbulk_si-3.0*(d_gammaPD_dV_sbulk_si/1.41421356237309504880));
d_T1_dV_dbulk_di = (0.5*d_vgfbPD_dV_dbulk_di-3.0*(d_gammaPD_dV_dbulk_di/1.41421356237309504880));
d_T1_dV_gm_si = (0.5*d_vgfbPD_dV_gm_si-3.0*(d_gammaPD_dV_gm_si/1.41421356237309504880));
T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
{
double value_sqrt_0 = sqrt(((T1*T1)+(6.0*vgfbPD)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di =  0.0;
d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND+(deriv_sqrt_0_d0*(((T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1)+6.0*d_vgfbPD_dTemp_t_GND))));
d_T2_dV_si_bi = (d_T1_dV_si_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1)+6.0*d_vgfbPD_dV_si_bi))));
d_T2_dV_di_bi = (d_T1_dV_di_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1)+6.0*d_vgfbPD_dV_di_bi))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi+(deriv_sqrt_0_d0*(((T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1)+6.0*d_vgfbPD_dV_gi_bi))));
d_T2_dV_sbulk_si = (d_T1_dV_sbulk_si+(deriv_sqrt_0_d0*(((T1*d_T1_dV_sbulk_si+d_T1_dV_sbulk_si*T1)+6.0*d_vgfbPD_dV_sbulk_si))));
d_T2_dV_dbulk_di = (d_T1_dV_dbulk_di+(deriv_sqrt_0_d0*(((T1*d_T1_dV_dbulk_di+d_T1_dV_dbulk_di*T1)+6.0*d_vgfbPD_dV_dbulk_di))));
d_T2_dV_gm_si = (d_T1_dV_gm_si+(deriv_sqrt_0_d0*(((T1*d_T1_dV_gm_si+d_T1_dV_gm_si*T1)+6.0*d_vgfbPD_dV_gm_si))));
T2 = (T1+value_sqrt_0);
}
if ((vgfbPD<0.0))
{

d_T3_dV_gm_di = ((-d_T2_dV_gm_di)/gammaPD);
d_T3_dTemp_t_GND = ((gammaPD*(d_vgfbPD_dTemp_t_GND-d_T2_dTemp_t_GND)-(vgfbPD-T2)*d_gammaPD_dTemp_t_GND)/gammaPD/gammaPD);
d_T3_dV_si_bi = ((gammaPD*(d_vgfbPD_dV_si_bi-d_T2_dV_si_bi)-(vgfbPD-T2)*d_gammaPD_dV_si_bi)/gammaPD/gammaPD);
d_T3_dV_di_bi = ((gammaPD*(d_vgfbPD_dV_di_bi-d_T2_dV_di_bi)-(vgfbPD-T2)*d_gammaPD_dV_di_bi)/gammaPD/gammaPD);
d_T3_dV_gi_bi = ((gammaPD*(d_vgfbPD_dV_gi_bi-d_T2_dV_gi_bi)-(vgfbPD-T2)*d_gammaPD_dV_gi_bi)/gammaPD/gammaPD);
d_T3_dV_sbulk_si = ((gammaPD*(d_vgfbPD_dV_sbulk_si-d_T2_dV_sbulk_si)-(vgfbPD-T2)*d_gammaPD_dV_sbulk_si)/gammaPD/gammaPD);
d_T3_dV_dbulk_di = ((gammaPD*(d_vgfbPD_dV_dbulk_di-d_T2_dV_dbulk_di)-(vgfbPD-T2)*d_gammaPD_dV_dbulk_di)/gammaPD/gammaPD);
d_T3_dV_gm_si = ((gammaPD*(d_vgfbPD_dV_gm_si-d_T2_dV_gm_si)-(vgfbPD-T2)*d_gammaPD_dV_gm_si)/gammaPD/gammaPD);
T3 = ((vgfbPD-T2)/gammaPD);
{
double value_log_0 = log(((1.0-T2)+(T3*T3)));
double  deriv_log_0_d0 = (1.0/((1.0-T2)+(T3*T3)));

d_psip_dTemp_t_GND = (-(deriv_log_0_d0*(((-d_T2_dTemp_t_GND)+(T3*d_T3_dTemp_t_GND+d_T3_dTemp_t_GND*T3)))));
d_psip_dV_si_bi = (-(deriv_log_0_d0*(((-d_T2_dV_si_bi)+(T3*d_T3_dV_si_bi+d_T3_dV_si_bi*T3)))));
d_psip_dV_di_bi = (-(deriv_log_0_d0*(((-d_T2_dV_di_bi)+(T3*d_T3_dV_di_bi+d_T3_dV_di_bi*T3)))));
d_psip_dV_gi_bi = (-(deriv_log_0_d0*(((-d_T2_dV_gi_bi)+(T3*d_T3_dV_gi_bi+d_T3_dV_gi_bi*T3)))));
d_psip_dV_sbulk_si = (-(deriv_log_0_d0*(((-d_T2_dV_sbulk_si)+(T3*d_T3_dV_sbulk_si+d_T3_dV_sbulk_si*T3)))));
d_psip_dV_dbulk_di = (-(deriv_log_0_d0*(((-d_T2_dV_dbulk_di)+(T3*d_T3_dV_dbulk_di+d_T3_dV_dbulk_di*T3)))));
d_psip_dV_gm_si = (-(deriv_log_0_d0*(((-d_T2_dV_gm_si)+(T3*d_T3_dV_gm_si+d_T3_dV_gm_si*T3)))));
d_psip_dV_gm_di = (-(deriv_log_0_d0*(((-d_T2_dV_gm_di)+(T3*d_T3_dV_gm_di+d_T3_dV_gm_di*T3)))));
psip = (-value_log_0);
}
}
else
{
{
double value_exp_0 = exp((-T2));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dTemp_t_GND = (deriv_exp_0_d0*((-d_T2_dTemp_t_GND)));
d_T3_dV_si_bi = (deriv_exp_0_d0*((-d_T2_dV_si_bi)));
d_T3_dV_di_bi = (deriv_exp_0_d0*((-d_T2_dV_di_bi)));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((-d_T2_dV_gi_bi)));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*((-d_T2_dV_sbulk_si)));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*((-d_T2_dV_dbulk_di)));
d_T3_dV_gm_si = (deriv_exp_0_d0*((-d_T2_dV_gm_si)));
d_T3_dV_gm_di = (deriv_exp_0_d0*((-d_T2_dV_gm_di)));
T3 = value_exp_0;
}

d_T1_dV_gm_di =  0.0;
d_T1_dTemp_t_GND = 0.5*d_gammaPD_dTemp_t_GND;
d_T1_dV_si_bi = 0.5*d_gammaPD_dV_si_bi;
d_T1_dV_di_bi = 0.5*d_gammaPD_dV_di_bi;
d_T1_dV_gi_bi = 0.5*d_gammaPD_dV_gi_bi;
d_T1_dV_sbulk_si = 0.5*d_gammaPD_dV_sbulk_si;
d_T1_dV_dbulk_di = 0.5*d_gammaPD_dV_dbulk_di;
d_T1_dV_gm_si = 0.5*d_gammaPD_dV_gm_si;
T1 = (0.5*gammaPD);
{
double value_sqrt_0 = sqrt((((vgfbPD-1.0)+T3)+(T1*T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_gm_di = ((deriv_sqrt_0_d0*((d_T3_dV_gm_di+(T1*d_T1_dV_gm_di+d_T1_dV_gm_di*T1))))-d_T1_dV_gm_di);
d_T2_dTemp_t_GND = ((deriv_sqrt_0_d0*(((d_vgfbPD_dTemp_t_GND+d_T3_dTemp_t_GND)+(T1*d_T1_dTemp_t_GND+d_T1_dTemp_t_GND*T1))))-d_T1_dTemp_t_GND);
d_T2_dV_si_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_si_bi+d_T3_dV_si_bi)+(T1*d_T1_dV_si_bi+d_T1_dV_si_bi*T1))))-d_T1_dV_si_bi);
d_T2_dV_di_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_di_bi+d_T3_dV_di_bi)+(T1*d_T1_dV_di_bi+d_T1_dV_di_bi*T1))))-d_T1_dV_di_bi);
d_T2_dV_gi_bi = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_gi_bi+d_T3_dV_gi_bi)+(T1*d_T1_dV_gi_bi+d_T1_dV_gi_bi*T1))))-d_T1_dV_gi_bi);
d_T2_dV_sbulk_si = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_sbulk_si+d_T3_dV_sbulk_si)+(T1*d_T1_dV_sbulk_si+d_T1_dV_sbulk_si*T1))))-d_T1_dV_sbulk_si);
d_T2_dV_dbulk_di = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_dbulk_di+d_T3_dV_dbulk_di)+(T1*d_T1_dV_dbulk_di+d_T1_dV_dbulk_di*T1))))-d_T1_dV_dbulk_di);
d_T2_dV_gm_si = ((deriv_sqrt_0_d0*(((d_vgfbPD_dV_gm_si+d_T3_dV_gm_si)+(T1*d_T1_dV_gm_si+d_T1_dV_gm_si*T1))))-d_T1_dV_gm_si);
T2 = (value_sqrt_0-T1);
}

d_psip_dTemp_t_GND = ((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2)-d_T3_dTemp_t_GND);
d_psip_dV_si_bi = ((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2)-d_T3_dV_si_bi);
d_psip_dV_di_bi = ((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2)-d_T3_dV_di_bi);
d_psip_dV_gi_bi = ((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2)-d_T3_dV_gi_bi);
d_psip_dV_sbulk_si = ((T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*T2)-d_T3_dV_sbulk_si);
d_psip_dV_dbulk_di = ((T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*T2)-d_T3_dV_dbulk_di);
d_psip_dV_gm_si = ((T2*d_T2_dV_gm_si+d_T2_dV_gm_si*T2)-d_T3_dV_gm_si);
d_psip_dV_gm_di = ((T2*d_T2_dV_gm_di+d_T2_dV_gm_di*T2)-d_T3_dV_gm_di);
psip = (((T2*T2)+1.0)-T3);
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_T8_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_T8_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_T8_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
d_T8_dV_sbulk_si = 0.5*(d_psip_dV_sbulk_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_sbulk_si+d_psip_dV_sbulk_si*(psip-1.0)))));
d_T8_dV_dbulk_di = 0.5*(d_psip_dV_dbulk_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_dbulk_di+d_psip_dV_dbulk_di*(psip-1.0)))));
d_T8_dV_gm_si = 0.5*(d_psip_dV_gm_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gm_si+d_psip_dV_gm_si*(psip-1.0)))));
d_T8_dV_gm_di = 0.5*(d_psip_dV_gm_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gm_di+d_psip_dV_gm_di*(psip-1.0)))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T8_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_T8_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_T8_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_T8_dV_gi_bi));
d_sqrtpsip_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T8_dV_sbulk_si));
d_sqrtpsip_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T8_dV_dbulk_di));
d_sqrtpsip_dV_gm_si = (deriv_sqrt_0_d0*(d_T8_dV_gm_si));
d_sqrtpsip_dV_gm_di = (deriv_sqrt_0_d0*(d_T8_dV_gm_di));
sqrtpsip = value_sqrt_0;
}

d_T9_dV_gm_di = (-gam*2.0*d_sqrtpsip_dV_gm_di/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dTemp_t_GND = (((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_si_bi = (((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_di_bi = (((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_gi_bi = (((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_sbulk_si = (((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_dbulk_di = (((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_gm_si = (((2.0*sqrtpsip)*d_gam_dV_gm_si-gam*2.0*d_sqrtpsip_dV_gm_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));

d_T0_dV_gm_di = ((-gam*2.0*d_sqrtpsip_dV_gm_di/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam);
d_T0_dTemp_t_GND = ((gam*(((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dTemp_t_GND)/gam/gam);
d_T0_dV_si_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_si_bi)/gam/gam);
d_T0_dV_di_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_di_bi)/gam/gam);
d_T0_dV_gi_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gi_bi)/gam/gam);
d_T0_dV_sbulk_si = ((gam*(((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_sbulk_si)/gam/gam);
d_T0_dV_dbulk_di = ((gam*(((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_dbulk_di)/gam/gam);
d_T0_dV_gm_si = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gm_si-gam*2.0*d_sqrtpsip_dV_gm_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gm_si)/gam/gam);
T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);

d_T1_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_n_dTemp_t_GND)-d_vs_dTemp_t_GND);
d_T1_dV_si_bi = ((d_psip_dV_si_bi-2.0*d_phib_n_dV_si_bi)-d_vs_dV_si_bi);
d_T1_dV_di_bi = ((d_psip_dV_di_bi-2.0*d_phib_n_dV_di_bi)-d_vs_dV_di_bi);
d_T1_dV_gi_bi = ((d_psip_dV_gi_bi-2.0*d_phib_n_dV_gi_bi)-d_vs_dV_gi_bi);
d_T1_dV_sbulk_si = ((d_psip_dV_sbulk_si-2.0*d_phib_n_dV_sbulk_si)-d_vs_dV_sbulk_si);
d_T1_dV_dbulk_di = ((d_psip_dV_dbulk_di-2.0*d_phib_n_dV_dbulk_di)-d_vs_dV_dbulk_di);
d_T1_dV_gm_si = ((d_psip_dV_gm_si-2.0*d_phib_n_dV_gm_si)-d_vs_dV_gm_si);
d_T1_dV_gm_di = d_psip_dV_gm_di;
T1 = ((psip-(2.0*phib_n))-vs);
{
double value_log_0 = log(((4.0*T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*T0)*sqrtpsip));

d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dTemp_t_GND+4.0*d_T0_dTemp_t_GND*sqrtpsip))));
d_T2_dV_si_bi = (d_T1_dV_si_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_si_bi+4.0*d_T0_dV_si_bi*sqrtpsip))));
d_T2_dV_di_bi = (d_T1_dV_di_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_di_bi+4.0*d_T0_dV_di_bi*sqrtpsip))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gi_bi+4.0*d_T0_dV_gi_bi*sqrtpsip))));
d_T2_dV_sbulk_si = (d_T1_dV_sbulk_si-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_sbulk_si+4.0*d_T0_dV_sbulk_si*sqrtpsip))));
d_T2_dV_dbulk_di = (d_T1_dV_dbulk_di-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_dbulk_di+4.0*d_T0_dV_dbulk_di*sqrtpsip))));
d_T2_dV_gm_si = (d_T1_dV_gm_si-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gm_si+4.0*d_T0_dV_gm_si*sqrtpsip))));
d_T2_dV_gm_di = (d_T1_dV_gm_di-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gm_di+4.0*d_T0_dV_gm_di*sqrtpsip))));
T2 = (T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((T2*(T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND-(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*(T2+0.402982)))));
d_T8_dV_si_bi = 0.5*(d_T2_dV_si_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*(T2+0.402982)))));
d_T8_dV_di_bi = 0.5*(d_T2_dV_di_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*(T2+0.402982)))));
d_T8_dV_gi_bi = 0.5*(d_T2_dV_gi_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*(T2+0.402982)))));
d_T8_dV_sbulk_si = 0.5*(d_T2_dV_sbulk_si-(deriv_sqrt_0_d0*((T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*(T2+0.402982)))));
d_T8_dV_dbulk_di = 0.5*(d_T2_dV_dbulk_di-(deriv_sqrt_0_d0*((T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*(T2+0.402982)))));
d_T8_dV_gm_si = 0.5*(d_T2_dV_gm_si-(deriv_sqrt_0_d0*((T2*d_T2_dV_gm_si+d_T2_dV_gm_si*(T2+0.402982)))));
d_T8_dV_gm_di = 0.5*(d_T2_dV_gm_di-(deriv_sqrt_0_d0*((T2*d_T2_dV_gm_di+d_T2_dV_gm_di*(T2+0.402982)))));
T8 = (0.5*((T2-0.201491)-value_sqrt_0));
}

d_sqrtpsisa_dTemp_t_GND = d_sqrtpsip_dTemp_t_GND;
d_sqrtpsisa_dV_si_bi = d_sqrtpsip_dV_si_bi;
d_sqrtpsisa_dV_di_bi = d_sqrtpsip_dV_di_bi;
d_sqrtpsisa_dV_gi_bi = d_sqrtpsip_dV_gi_bi;
d_sqrtpsisa_dV_sbulk_si = d_sqrtpsip_dV_sbulk_si;
d_sqrtpsisa_dV_dbulk_di = d_sqrtpsip_dV_dbulk_di;
d_sqrtpsisa_dV_gm_si = d_sqrtpsip_dV_gm_si;
d_sqrtpsisa_dV_gm_di = d_sqrtpsip_dV_gm_di;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dV_di_bi = d_T4_dV_si_bi = d_T4_dTemp_t_GND =  0.0;
T4 = (-100.0);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = d_T3_dV_gm_di =  0.0;
d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T4_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T4_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T4_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T4_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T4_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T4_dV_dbulk_di));
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
d_T3_dV_gm_si = (deriv_exp_0_d0*(d_T8_dV_gm_si));
d_T3_dV_gm_di = (deriv_exp_0_d0*(d_T8_dV_gm_di));
T3 = value_exp_0;
}
}
else
{

d_T2_dTemp_t_GND = ((T5*(d_T8_dTemp_t_GND-d_T4_dTemp_t_GND)-(T8-T4)*d_T5_dTemp_t_GND)/T5/T5);
d_T2_dV_si_bi = ((T5*(d_T8_dV_si_bi-d_T4_dV_si_bi)-(T8-T4)*d_T5_dV_si_bi)/T5/T5);
d_T2_dV_di_bi = ((T5*(d_T8_dV_di_bi-d_T4_dV_di_bi)-(T8-T4)*d_T5_dV_di_bi)/T5/T5);
d_T2_dV_gi_bi = ((T5*(d_T8_dV_gi_bi-d_T4_dV_gi_bi)-(T8-T4)*d_T5_dV_gi_bi)/T5/T5);
d_T2_dV_sbulk_si = ((T5*(d_T8_dV_sbulk_si-d_T4_dV_sbulk_si)-(T8-T4)*d_T5_dV_sbulk_si)/T5/T5);
d_T2_dV_dbulk_di = ((T5*(d_T8_dV_dbulk_di-d_T4_dV_dbulk_di)-(T8-T4)*d_T5_dV_dbulk_di)/T5/T5);
d_T2_dV_gm_si = ((T5*(d_T8_dV_gm_si-d_T4_dV_gm_si)-(T8-T4)*d_T5_dV_gm_si)/T5/T5);
d_T2_dV_gm_di = ((T5*(d_T8_dV_gm_di-d_T4_dV_gm_di)-(T8-T4)*d_T5_dV_gm_di)/T5/T5);
T2 = ((T8-T4)/T5);

d_T6_dTemp_t_GND = (T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2);
d_T6_dV_si_bi = (T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2);
d_T6_dV_di_bi = (T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2);
d_T6_dV_gi_bi = (T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2);
d_T6_dV_sbulk_si = (T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*T2);
d_T6_dV_dbulk_di = (T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*T2);
d_T6_dV_gm_si = (T2*d_T2_dV_gm_si+d_T2_dV_gm_si*T2);
d_T6_dV_gm_di = (T2*d_T2_dV_gm_di+d_T2_dV_gm_di*T2);
T6 = (T2*T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dV_gm_si = (deriv_exp_0_d0*((d_T4_dV_gm_si+(T5*(0.5*d_T2_dV_gm_si+(T6*(-(T6*(-d_T6_dV_gm_si)+d_T6_dV_gm_si*(1.25-T6)))+d_T6_dV_gm_si*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gm_di = (deriv_exp_0_d0*((d_T4_dV_gm_di+(T5*(0.5*d_T2_dV_gm_di+(T6*(-(T6*(-d_T6_dV_gm_di)+d_T6_dV_gm_di*(1.25-T6)))+d_T6_dV_gm_di*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dTemp_t_GND = (deriv_exp_0_d0*((d_T4_dTemp_t_GND+(T5*(0.5*d_T2_dTemp_t_GND+(T6*(-(T6*(-d_T6_dTemp_t_GND)+d_T6_dTemp_t_GND*(1.25-T6)))+d_T6_dTemp_t_GND*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dTemp_t_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_si_bi = (deriv_exp_0_d0*((d_T4_dV_si_bi+(T5*(0.5*d_T2_dV_si_bi+(T6*(-(T6*(-d_T6_dV_si_bi)+d_T6_dV_si_bi*(1.25-T6)))+d_T6_dV_si_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_si_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_di_bi = (deriv_exp_0_d0*((d_T4_dV_di_bi+(T5*(0.5*d_T2_dV_di_bi+(T6*(-(T6*(-d_T6_dV_di_bi)+d_T6_dV_di_bi*(1.25-T6)))+d_T6_dV_di_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_di_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((d_T4_dV_gi_bi+(T5*(0.5*d_T2_dV_gi_bi+(T6*(-(T6*(-d_T6_dV_gi_bi)+d_T6_dV_gi_bi*(1.25-T6)))+d_T6_dV_gi_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*((d_T4_dV_sbulk_si+(T5*(0.5*d_T2_dV_sbulk_si+(T6*(-(T6*(-d_T6_dV_sbulk_si)+d_T6_dV_sbulk_si*(1.25-T6)))+d_T6_dV_sbulk_si*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_sbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*((d_T4_dV_dbulk_di+(T5*(0.5*d_T2_dV_dbulk_di+(T6*(-(T6*(-d_T6_dV_dbulk_di)+d_T6_dV_dbulk_di*(1.25-T6)))+d_T6_dV_dbulk_di*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_dbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_qs_dTemp_t_GND = (T3*((d_T1_dTemp_t_GND-d_T8_dTemp_t_GND)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+2.0*d_T0_dTemp_t_GND*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dTemp_t_GND*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_si_bi = (T3*((d_T1_dV_si_bi-d_T8_dV_si_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+2.0*d_T0_dV_si_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_si_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_di_bi = (T3*((d_T1_dV_di_bi-d_T8_dV_di_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+2.0*d_T0_dV_di_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_di_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_gi_bi = (T3*((d_T1_dV_gi_bi-d_T8_dV_gi_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+2.0*d_T0_dV_gi_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gi_bi*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_sbulk_si = (T3*((d_T1_dV_sbulk_si-d_T8_dV_sbulk_si)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+2.0*d_T0_dV_sbulk_si*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_sbulk_si*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_dbulk_di = (T3*((d_T1_dV_dbulk_di-d_T8_dV_dbulk_di)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+2.0*d_T0_dV_dbulk_di*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_dbulk_di*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_gm_di = (T3*((d_T1_dV_gm_di-d_T8_dV_gm_di)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_di)+2.0*d_T0_dV_gm_di*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gm_di*(((1.0+T1)-T8)-value_log_0));
d_qs_dV_gm_si = (T3*((d_T1_dV_gm_si-d_T8_dV_gm_si)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_si)+2.0*d_T0_dV_gm_si*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gm_si*(((1.0+T1)-T8)-value_log_0));
qs = (T3*(((1.0+T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
d_T3_dV_gm_si = (deriv_exp_0_d0*(d_T8_dV_gm_si));
d_T3_dV_gm_di = (deriv_exp_0_d0*(d_T8_dV_gm_di));
T3 = value_exp_0;
}

d_sqrtpsisainv_dTemp_t_GND = (-d_sqrtpsisa_dTemp_t_GND/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_si_bi = (-d_sqrtpsisa_dV_si_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_di_bi = (-d_sqrtpsisa_dV_di_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gi_bi = (-d_sqrtpsisa_dV_gi_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_sbulk_si = (-d_sqrtpsisa_dV_sbulk_si/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_dbulk_di = (-d_sqrtpsisa_dV_dbulk_di/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gm_si = (-d_sqrtpsisa_dV_gm_si/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gm_di = (-d_sqrtpsisa_dV_gm_di/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
d_T4_dV_gm_di = ((2.0*d_T3_dV_gm_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_di)+((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_di);
d_T4_dV_gm_si = ((2.0*d_T3_dV_gm_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_si)+((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_si);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_di = ((-d_T3_dV_gm_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_si = ((-d_T3_dV_gm_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T3_dTemp_t_GND = (d_T3_dTemp_t_GND-((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5));
d_T3_dV_si_bi = (d_T3_dV_si_bi-((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5));
d_T3_dV_di_bi = (d_T3_dV_di_bi-((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5));
d_T3_dV_gi_bi = (d_T3_dV_gi_bi-((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5));
d_T3_dV_sbulk_si = (d_T3_dV_sbulk_si-((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5));
d_T3_dV_dbulk_di = (d_T3_dV_dbulk_di-((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5));
d_T3_dV_gm_di = (d_T3_dV_gm_di-((T5*d_T4_dV_gm_di-T4*d_T5_dV_gm_di)/T5/T5));
d_T3_dV_gm_si = (d_T3_dV_gm_si-((T5*d_T4_dV_gm_si-T4*d_T5_dV_gm_si)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
d_T4_dV_gm_di = ((2.0*d_T3_dV_gm_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_di)+((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_di);
d_T4_dV_gm_si = ((2.0*d_T3_dV_gm_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_si)+((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_si);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_di = ((-d_T3_dV_gm_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_si = ((-d_T3_dV_gm_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T6_dTemp_t_GND = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_si_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_di_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gi_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_sbulk_si = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_dbulk_di = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gm_si = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gm_di = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T7_dTemp_t_GND = (((-((1.0/T3)*(-d_T3_dTemp_t_GND/T3/T3)+(-d_T3_dTemp_t_GND/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dTemp_t_GND+(sqrtpsisa*d_sqrtpsisa_dTemp_t_GND+d_sqrtpsisa_dTemp_t_GND*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dTemp_t_GND);
d_T7_dV_si_bi = (((-((1.0/T3)*(-d_T3_dV_si_bi/T3/T3)+(-d_T3_dV_si_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_si_bi+(sqrtpsisa*d_sqrtpsisa_dV_si_bi+d_sqrtpsisa_dV_si_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_si_bi);
d_T7_dV_di_bi = (((-((1.0/T3)*(-d_T3_dV_di_bi/T3/T3)+(-d_T3_dV_di_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_di_bi+(sqrtpsisa*d_sqrtpsisa_dV_di_bi+d_sqrtpsisa_dV_di_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_di_bi);
d_T7_dV_gi_bi = (((-((1.0/T3)*(-d_T3_dV_gi_bi/T3/T3)+(-d_T3_dV_gi_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gi_bi+(sqrtpsisa*d_sqrtpsisa_dV_gi_bi+d_sqrtpsisa_dV_gi_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gi_bi);
d_T7_dV_sbulk_si = (((-((1.0/T3)*(-d_T3_dV_sbulk_si/T3/T3)+(-d_T3_dV_sbulk_si/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_sbulk_si+(sqrtpsisa*d_sqrtpsisa_dV_sbulk_si+d_sqrtpsisa_dV_sbulk_si*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_sbulk_si);
d_T7_dV_dbulk_di = (((-((1.0/T3)*(-d_T3_dV_dbulk_di/T3/T3)+(-d_T3_dV_dbulk_di/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_dbulk_di+(sqrtpsisa*d_sqrtpsisa_dV_dbulk_di+d_sqrtpsisa_dV_dbulk_di*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_dbulk_di);
d_T7_dV_gm_di = (((-((1.0/T3)*(-d_T3_dV_gm_di/T3/T3)+(-d_T3_dV_gm_di/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gm_di+(sqrtpsisa*d_sqrtpsisa_dV_gm_di+d_sqrtpsisa_dV_gm_di*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gm_di);
d_T7_dV_gm_si = (((-((1.0/T3)*(-d_T3_dV_gm_si/T3/T3)+(-d_T3_dV_gm_si/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gm_si+(sqrtpsisa*d_sqrtpsisa_dV_gm_si+d_sqrtpsisa_dV_gm_si*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gm_si);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);

d_qs_dTemp_t_GND = (d_T3_dTemp_t_GND-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dTemp_t_GND+d_T4_dTemp_t_GND*T7)-(T4*T7)*((2.0*T5)*d_T5_dTemp_t_GND+2.0*d_T5_dTemp_t_GND*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_si_bi = (d_T3_dV_si_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_si_bi+d_T4_dV_si_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_si_bi+2.0*d_T5_dV_si_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_di_bi = (d_T3_dV_di_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_di_bi+d_T4_dV_di_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_di_bi+2.0*d_T5_dV_di_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_gi_bi = (d_T3_dV_gi_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gi_bi+d_T4_dV_gi_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gi_bi+2.0*d_T5_dV_gi_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_sbulk_si = (d_T3_dV_sbulk_si-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_sbulk_si+d_T4_dV_sbulk_si*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_sbulk_si+2.0*d_T5_dV_sbulk_si*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_dbulk_di = (d_T3_dV_dbulk_di-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_dbulk_di+d_T4_dV_dbulk_di*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_dbulk_di+2.0*d_T5_dV_dbulk_di*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_gm_di = (d_T3_dV_gm_di-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gm_di+d_T4_dV_gm_di*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gm_di+2.0*d_T5_dV_gm_di*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gm_di-T4*d_T5_dV_gm_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qs_dV_gm_si = (d_T3_dV_gm_si-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gm_si+d_T4_dV_gm_si*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gm_si+2.0*d_T5_dV_gm_si*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gm_si-T4*d_T5_dV_gm_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}

d_vdsatedge_dV_gm_di = (2.0*nVt)*d_qs_dV_gm_di;
d_vdsatedge_dTemp_t_GND = (((2.0*nVt)*d_qs_dTemp_t_GND+2.0*d_nVt_dTemp_t_GND*qs)+2.0*d_nVt_dTemp_t_GND);
d_vdsatedge_dV_si_bi = (((2.0*nVt)*d_qs_dV_si_bi+2.0*d_nVt_dV_si_bi*qs)+2.0*d_nVt_dV_si_bi);
d_vdsatedge_dV_di_bi = (((2.0*nVt)*d_qs_dV_di_bi+2.0*d_nVt_dV_di_bi*qs)+2.0*d_nVt_dV_di_bi);
d_vdsatedge_dV_gi_bi = (((2.0*nVt)*d_qs_dV_gi_bi+2.0*d_nVt_dV_gi_bi*qs)+2.0*d_nVt_dV_gi_bi);
d_vdsatedge_dV_sbulk_si = (((2.0*nVt)*d_qs_dV_sbulk_si+2.0*d_nVt_dV_sbulk_si*qs)+2.0*d_nVt_dV_sbulk_si);
d_vdsatedge_dV_dbulk_di = (((2.0*nVt)*d_qs_dV_dbulk_di+2.0*d_nVt_dV_dbulk_di*qs)+2.0*d_nVt_dV_dbulk_di);
d_vdsatedge_dV_gm_si = (((2.0*nVt)*d_qs_dV_gm_si+2.0*d_nVt_dV_gm_si*qs)+2.0*d_nVt_dV_gm_si);
vdsatedge = (((2.0*nVt)*qs)+(2.0*nVt));

d_Vdsatedge_dV_gm_di = d_vdsatedge_dV_gm_di;
d_Vdsatedge_dTemp_t_GND = d_vdsatedge_dTemp_t_GND;
d_Vdsatedge_dV_si_bi = d_vdsatedge_dV_si_bi;
d_Vdsatedge_dV_di_bi = d_vdsatedge_dV_di_bi;
d_Vdsatedge_dV_gi_bi = d_vdsatedge_dV_gi_bi;
d_Vdsatedge_dV_sbulk_si = d_vdsatedge_dV_sbulk_si;
d_Vdsatedge_dV_dbulk_di = d_vdsatedge_dV_dbulk_di;
d_Vdsatedge_dV_gm_si = d_vdsatedge_dV_gm_si;
Vdsatedge = vdsatedge;

d_Vdsatedge_dV_si_bi = (d_Vdsatedge_dV_si_bi+d_Vs_dV_si_bi);
d_Vdsatedge_dV_di_bi = (d_Vdsatedge_dV_di_bi+d_Vs_dV_di_bi);
Vdsatedge = (Vdsatedge+Vs);
{
double value_sqrt_0 = sqrt(((((Vdsatedge-Vs))*((Vdsatedge-Vs)))+((0.25*1.0e-3)*1.0e-3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdssate_dV_gm_di = 0.5*(d_Vdsatedge_dV_gm_di+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*d_Vdsatedge_dV_gm_di+d_Vdsatedge_dV_gm_di*((Vdsatedge-Vs))))));
d_Vdssate_dTemp_t_GND = 0.5*(d_Vdsatedge_dTemp_t_GND+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*d_Vdsatedge_dTemp_t_GND+d_Vdsatedge_dTemp_t_GND*((Vdsatedge-Vs))))));
d_Vdssate_dV_si_bi = 0.5*((d_Vdsatedge_dV_si_bi-d_Vs_dV_si_bi)+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*(d_Vdsatedge_dV_si_bi-d_Vs_dV_si_bi)+(d_Vdsatedge_dV_si_bi-d_Vs_dV_si_bi)*((Vdsatedge-Vs))))));
d_Vdssate_dV_di_bi = 0.5*((d_Vdsatedge_dV_di_bi-d_Vs_dV_di_bi)+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*(d_Vdsatedge_dV_di_bi-d_Vs_dV_di_bi)+(d_Vdsatedge_dV_di_bi-d_Vs_dV_di_bi)*((Vdsatedge-Vs))))));
d_Vdssate_dV_gi_bi = 0.5*(d_Vdsatedge_dV_gi_bi+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*d_Vdsatedge_dV_gi_bi+d_Vdsatedge_dV_gi_bi*((Vdsatedge-Vs))))));
d_Vdssate_dV_sbulk_si = 0.5*(d_Vdsatedge_dV_sbulk_si+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*d_Vdsatedge_dV_sbulk_si+d_Vdsatedge_dV_sbulk_si*((Vdsatedge-Vs))))));
d_Vdssate_dV_dbulk_di = 0.5*(d_Vdsatedge_dV_dbulk_di+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*d_Vdsatedge_dV_dbulk_di+d_Vdsatedge_dV_dbulk_di*((Vdsatedge-Vs))))));
d_Vdssate_dV_gm_si = 0.5*(d_Vdsatedge_dV_gm_si+(deriv_sqrt_0_d0*((((Vdsatedge-Vs))*d_Vdsatedge_dV_gm_si+d_Vdsatedge_dV_gm_si*((Vdsatedge-Vs))))));
Vdssate = (0.5*((Vdsatedge-Vs)+value_sqrt_0));
}
{
double value_pow_0 = pow((Vds/Vdssate),(1.0/DELTA_t));
double  deriv_pow_0_d0 = (((Vds/Vdssate) == 0.0)?0.0:(value_pow_0*(1.0/DELTA_t)/(Vds/Vdssate)));
double  deriv_pow_0_d1 = ((Vds/Vdssate) == 0.0)?0.0:(log((Vds/Vdssate))*value_pow_0);

d_T7_dV_gm_di = (deriv_pow_0_d0*((-Vds*d_Vdssate_dV_gm_di/Vdssate/Vdssate)));
d_T7_dTemp_t_GND = ((deriv_pow_0_d0*((-Vds*d_Vdssate_dTemp_t_GND/Vdssate/Vdssate)))+(deriv_pow_0_d1*((-d_DELTA_t_dTemp_t_GND/DELTA_t/DELTA_t))));
d_T7_dV_gi_bi = (deriv_pow_0_d0*((-Vds*d_Vdssate_dV_gi_bi/Vdssate/Vdssate)));
d_T7_dV_sbulk_si = (deriv_pow_0_d0*((-Vds*d_Vdssate_dV_sbulk_si/Vdssate/Vdssate)));
d_T7_dV_dbulk_di = (deriv_pow_0_d0*((-Vds*d_Vdssate_dV_dbulk_di/Vdssate/Vdssate)));
d_T7_dV_gm_si = (deriv_pow_0_d0*((-Vds*d_Vdssate_dV_gm_si/Vdssate/Vdssate)));
d_T7_dV_si_bi = (deriv_pow_0_d0*(((Vdssate*d_Vds_dV_si_bi-Vds*d_Vdssate_dV_si_bi)/Vdssate/Vdssate)));
d_T7_dV_di_bi = (deriv_pow_0_d0*(((Vdssate*d_Vds_dV_di_bi-Vds*d_Vdssate_dV_di_bi)/Vdssate/Vdssate)));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),(-DELTA_t));
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*(-DELTA_t)/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);

d_T8_dTemp_t_GND = ((deriv_pow_0_d0*(d_T7_dTemp_t_GND))+(deriv_pow_0_d1*((-d_DELTA_t_dTemp_t_GND))));
d_T8_dV_si_bi = (deriv_pow_0_d0*(d_T7_dV_si_bi));
d_T8_dV_di_bi = (deriv_pow_0_d0*(d_T7_dV_di_bi));
d_T8_dV_gi_bi = (deriv_pow_0_d0*(d_T7_dV_gi_bi));
d_T8_dV_sbulk_si = (deriv_pow_0_d0*(d_T7_dV_sbulk_si));
d_T8_dV_dbulk_di = (deriv_pow_0_d0*(d_T7_dV_dbulk_di));
d_T8_dV_gm_di = (deriv_pow_0_d0*(d_T7_dV_gm_di));
d_T8_dV_gm_si = (deriv_pow_0_d0*(d_T7_dV_gm_si));
T8 = value_pow_0;
}

d_Vdseff_dTemp_t_GND = Vds*d_T8_dTemp_t_GND;
d_Vdseff_dV_gi_bi = Vds*d_T8_dV_gi_bi;
d_Vdseff_dV_sbulk_si = Vds*d_T8_dV_sbulk_si;
d_Vdseff_dV_dbulk_di = Vds*d_T8_dV_dbulk_di;
d_Vdseff_dV_gm_si = Vds*d_T8_dV_gm_si;
d_Vdseff_dV_gm_di = Vds*d_T8_dV_gm_di;
d_Vdseff_dV_si_bi = (Vds*d_T8_dV_si_bi+d_Vds_dV_si_bi*T8);
d_Vdseff_dV_di_bi = (Vds*d_T8_dV_di_bi+d_Vds_dV_di_bi*T8);
Vdseff = (Vds*T8);

d_vdeff_dTemp_t_GND = ((Vdseff+Vs)*d_inv_nVt_dTemp_t_GND+d_Vdseff_dTemp_t_GND*inv_nVt);
d_vdeff_dV_gi_bi = ((Vdseff+Vs)*d_inv_nVt_dV_gi_bi+d_Vdseff_dV_gi_bi*inv_nVt);
d_vdeff_dV_si_bi = ((Vdseff+Vs)*d_inv_nVt_dV_si_bi+(d_Vdseff_dV_si_bi+d_Vs_dV_si_bi)*inv_nVt);
d_vdeff_dV_di_bi = ((Vdseff+Vs)*d_inv_nVt_dV_di_bi+(d_Vdseff_dV_di_bi+d_Vs_dV_di_bi)*inv_nVt);
d_vdeff_dV_sbulk_si = ((Vdseff+Vs)*d_inv_nVt_dV_sbulk_si+d_Vdseff_dV_sbulk_si*inv_nVt);
d_vdeff_dV_dbulk_di = ((Vdseff+Vs)*d_inv_nVt_dV_dbulk_di+d_Vdseff_dV_dbulk_di*inv_nVt);
d_vdeff_dV_gm_si = ((Vdseff+Vs)*d_inv_nVt_dV_gm_si+d_Vdseff_dV_gm_si*inv_nVt);
d_vdeff_dV_gm_di = d_Vdseff_dV_gm_di*inv_nVt;
vdeff = ((Vdseff+Vs)*inv_nVt);
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_T8_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_T8_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_T8_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
d_T8_dV_sbulk_si = 0.5*(d_psip_dV_sbulk_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_sbulk_si+d_psip_dV_sbulk_si*(psip-1.0)))));
d_T8_dV_dbulk_di = 0.5*(d_psip_dV_dbulk_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_dbulk_di+d_psip_dV_dbulk_di*(psip-1.0)))));
d_T8_dV_gm_si = 0.5*(d_psip_dV_gm_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gm_si+d_psip_dV_gm_si*(psip-1.0)))));
d_T8_dV_gm_di = 0.5*(d_psip_dV_gm_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gm_di+d_psip_dV_gm_di*(psip-1.0)))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T8_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_T8_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_T8_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_T8_dV_gi_bi));
d_sqrtpsip_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T8_dV_sbulk_si));
d_sqrtpsip_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T8_dV_dbulk_di));
d_sqrtpsip_dV_gm_si = (deriv_sqrt_0_d0*(d_T8_dV_gm_si));
d_sqrtpsip_dV_gm_di = (deriv_sqrt_0_d0*(d_T8_dV_gm_di));
sqrtpsip = value_sqrt_0;
}

d_T9_dV_gm_di = (-gam*2.0*d_sqrtpsip_dV_gm_di/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dTemp_t_GND = (((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_si_bi = (((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_di_bi = (((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_gi_bi = (((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_sbulk_si = (((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_dbulk_di = (((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
d_T9_dV_gm_si = (((2.0*sqrtpsip)*d_gam_dV_gm_si-gam*2.0*d_sqrtpsip_dV_gm_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));

d_T0_dV_gm_di = ((-gam*2.0*d_sqrtpsip_dV_gm_di/(2.0*sqrtpsip)/(2.0*sqrtpsip))/gam);
d_T0_dTemp_t_GND = ((gam*(((2.0*sqrtpsip)*d_gam_dTemp_t_GND-gam*2.0*d_sqrtpsip_dTemp_t_GND)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dTemp_t_GND)/gam/gam);
d_T0_dV_si_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_si_bi-gam*2.0*d_sqrtpsip_dV_si_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_si_bi)/gam/gam);
d_T0_dV_di_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_di_bi-gam*2.0*d_sqrtpsip_dV_di_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_di_bi)/gam/gam);
d_T0_dV_gi_bi = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gi_bi-gam*2.0*d_sqrtpsip_dV_gi_bi)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gi_bi)/gam/gam);
d_T0_dV_sbulk_si = ((gam*(((2.0*sqrtpsip)*d_gam_dV_sbulk_si-gam*2.0*d_sqrtpsip_dV_sbulk_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_sbulk_si)/gam/gam);
d_T0_dV_dbulk_di = ((gam*(((2.0*sqrtpsip)*d_gam_dV_dbulk_di-gam*2.0*d_sqrtpsip_dV_dbulk_di)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_dbulk_di)/gam/gam);
d_T0_dV_gm_si = ((gam*(((2.0*sqrtpsip)*d_gam_dV_gm_si-gam*2.0*d_sqrtpsip_dV_gm_si)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dV_gm_si)/gam/gam);
T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);

d_T1_dTemp_t_GND = ((d_psip_dTemp_t_GND-2.0*d_phib_n_dTemp_t_GND)-d_vdeff_dTemp_t_GND);
d_T1_dV_si_bi = ((d_psip_dV_si_bi-2.0*d_phib_n_dV_si_bi)-d_vdeff_dV_si_bi);
d_T1_dV_di_bi = ((d_psip_dV_di_bi-2.0*d_phib_n_dV_di_bi)-d_vdeff_dV_di_bi);
d_T1_dV_gi_bi = ((d_psip_dV_gi_bi-2.0*d_phib_n_dV_gi_bi)-d_vdeff_dV_gi_bi);
d_T1_dV_sbulk_si = ((d_psip_dV_sbulk_si-2.0*d_phib_n_dV_sbulk_si)-d_vdeff_dV_sbulk_si);
d_T1_dV_dbulk_di = ((d_psip_dV_dbulk_di-2.0*d_phib_n_dV_dbulk_di)-d_vdeff_dV_dbulk_di);
d_T1_dV_gm_si = ((d_psip_dV_gm_si-2.0*d_phib_n_dV_gm_si)-d_vdeff_dV_gm_si);
d_T1_dV_gm_di = (d_psip_dV_gm_di-d_vdeff_dV_gm_di);
T1 = ((psip-(2.0*phib_n))-vdeff);
{
double value_log_0 = log(((4.0*T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*T0)*sqrtpsip));

d_T2_dTemp_t_GND = (d_T1_dTemp_t_GND-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dTemp_t_GND+4.0*d_T0_dTemp_t_GND*sqrtpsip))));
d_T2_dV_si_bi = (d_T1_dV_si_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_si_bi+4.0*d_T0_dV_si_bi*sqrtpsip))));
d_T2_dV_di_bi = (d_T1_dV_di_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_di_bi+4.0*d_T0_dV_di_bi*sqrtpsip))));
d_T2_dV_gi_bi = (d_T1_dV_gi_bi-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gi_bi+4.0*d_T0_dV_gi_bi*sqrtpsip))));
d_T2_dV_sbulk_si = (d_T1_dV_sbulk_si-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_sbulk_si+4.0*d_T0_dV_sbulk_si*sqrtpsip))));
d_T2_dV_dbulk_di = (d_T1_dV_dbulk_di-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_dbulk_di+4.0*d_T0_dV_dbulk_di*sqrtpsip))));
d_T2_dV_gm_si = (d_T1_dV_gm_si-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gm_si+4.0*d_T0_dV_gm_si*sqrtpsip))));
d_T2_dV_gm_di = (d_T1_dV_gm_di-(deriv_log_0_d0*(((4.0*T0)*d_sqrtpsip_dV_gm_di+4.0*d_T0_dV_gm_di*sqrtpsip))));
T2 = (T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((T2*(T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T8_dTemp_t_GND = 0.5*(d_T2_dTemp_t_GND-(deriv_sqrt_0_d0*((T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*(T2+0.402982)))));
d_T8_dV_si_bi = 0.5*(d_T2_dV_si_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_si_bi+d_T2_dV_si_bi*(T2+0.402982)))));
d_T8_dV_di_bi = 0.5*(d_T2_dV_di_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_di_bi+d_T2_dV_di_bi*(T2+0.402982)))));
d_T8_dV_gi_bi = 0.5*(d_T2_dV_gi_bi-(deriv_sqrt_0_d0*((T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*(T2+0.402982)))));
d_T8_dV_sbulk_si = 0.5*(d_T2_dV_sbulk_si-(deriv_sqrt_0_d0*((T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*(T2+0.402982)))));
d_T8_dV_dbulk_di = 0.5*(d_T2_dV_dbulk_di-(deriv_sqrt_0_d0*((T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*(T2+0.402982)))));
d_T8_dV_gm_si = 0.5*(d_T2_dV_gm_si-(deriv_sqrt_0_d0*((T2*d_T2_dV_gm_si+d_T2_dV_gm_si*(T2+0.402982)))));
d_T8_dV_gm_di = 0.5*(d_T2_dV_gm_di-(deriv_sqrt_0_d0*((T2*d_T2_dV_gm_di+d_T2_dV_gm_di*(T2+0.402982)))));
T8 = (0.5*((T2-0.201491)-value_sqrt_0));
}

d_sqrtpsisa_dTemp_t_GND = d_sqrtpsip_dTemp_t_GND;
d_sqrtpsisa_dV_si_bi = d_sqrtpsip_dV_si_bi;
d_sqrtpsisa_dV_di_bi = d_sqrtpsip_dV_di_bi;
d_sqrtpsisa_dV_gi_bi = d_sqrtpsip_dV_gi_bi;
d_sqrtpsisa_dV_sbulk_si = d_sqrtpsip_dV_sbulk_si;
d_sqrtpsisa_dV_dbulk_di = d_sqrtpsip_dV_dbulk_di;
d_sqrtpsisa_dV_gm_si = d_sqrtpsip_dV_gm_si;
d_sqrtpsisa_dV_gm_di = d_sqrtpsip_dV_gm_di;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{

d_T4_dV_gm_si = d_T4_dV_gm_di = d_T4_dV_dbulk_di = d_T4_dV_sbulk_si = d_T4_dV_gi_bi = d_T4_dV_di_bi = d_T4_dV_si_bi = d_T4_dTemp_t_GND =  0.0;
T4 = (-100.0);

d_T5_dV_gm_si = d_T5_dV_gm_di = d_T5_dV_dbulk_di = d_T5_dV_sbulk_si = d_T5_dV_gi_bi = d_T5_dV_di_bi = d_T5_dV_si_bi = d_T5_dTemp_t_GND =  0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T4_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T4_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T4_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T4_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T4_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T4_dV_dbulk_di));
d_T3_dV_gm_di = (deriv_exp_0_d0*(d_T4_dV_gm_di));
d_T3_dV_gm_si = (deriv_exp_0_d0*(d_T4_dV_gm_si));
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
d_T3_dV_gm_si = (deriv_exp_0_d0*(d_T8_dV_gm_si));
d_T3_dV_gm_di = (deriv_exp_0_d0*(d_T8_dV_gm_di));
T3 = value_exp_0;
}
}
else
{

d_T2_dTemp_t_GND = ((T5*(d_T8_dTemp_t_GND-d_T4_dTemp_t_GND)-(T8-T4)*d_T5_dTemp_t_GND)/T5/T5);
d_T2_dV_si_bi = ((T5*(d_T8_dV_si_bi-d_T4_dV_si_bi)-(T8-T4)*d_T5_dV_si_bi)/T5/T5);
d_T2_dV_di_bi = ((T5*(d_T8_dV_di_bi-d_T4_dV_di_bi)-(T8-T4)*d_T5_dV_di_bi)/T5/T5);
d_T2_dV_gi_bi = ((T5*(d_T8_dV_gi_bi-d_T4_dV_gi_bi)-(T8-T4)*d_T5_dV_gi_bi)/T5/T5);
d_T2_dV_sbulk_si = ((T5*(d_T8_dV_sbulk_si-d_T4_dV_sbulk_si)-(T8-T4)*d_T5_dV_sbulk_si)/T5/T5);
d_T2_dV_dbulk_di = ((T5*(d_T8_dV_dbulk_di-d_T4_dV_dbulk_di)-(T8-T4)*d_T5_dV_dbulk_di)/T5/T5);
d_T2_dV_gm_si = ((T5*(d_T8_dV_gm_si-d_T4_dV_gm_si)-(T8-T4)*d_T5_dV_gm_si)/T5/T5);
d_T2_dV_gm_di = ((T5*(d_T8_dV_gm_di-d_T4_dV_gm_di)-(T8-T4)*d_T5_dV_gm_di)/T5/T5);
T2 = ((T8-T4)/T5);

d_T6_dTemp_t_GND = (T2*d_T2_dTemp_t_GND+d_T2_dTemp_t_GND*T2);
d_T6_dV_si_bi = (T2*d_T2_dV_si_bi+d_T2_dV_si_bi*T2);
d_T6_dV_di_bi = (T2*d_T2_dV_di_bi+d_T2_dV_di_bi*T2);
d_T6_dV_gi_bi = (T2*d_T2_dV_gi_bi+d_T2_dV_gi_bi*T2);
d_T6_dV_sbulk_si = (T2*d_T2_dV_sbulk_si+d_T2_dV_sbulk_si*T2);
d_T6_dV_dbulk_di = (T2*d_T2_dV_dbulk_di+d_T2_dV_dbulk_di*T2);
d_T6_dV_gm_si = (T2*d_T2_dV_gm_si+d_T2_dV_gm_si*T2);
d_T6_dV_gm_di = (T2*d_T2_dV_gm_di+d_T2_dV_gm_di*T2);
T6 = (T2*T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dTemp_t_GND = (deriv_exp_0_d0*((d_T4_dTemp_t_GND+(T5*(0.5*d_T2_dTemp_t_GND+(T6*(-(T6*(-d_T6_dTemp_t_GND)+d_T6_dTemp_t_GND*(1.25-T6)))+d_T6_dTemp_t_GND*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dTemp_t_GND*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_si_bi = (deriv_exp_0_d0*((d_T4_dV_si_bi+(T5*(0.5*d_T2_dV_si_bi+(T6*(-(T6*(-d_T6_dV_si_bi)+d_T6_dV_si_bi*(1.25-T6)))+d_T6_dV_si_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_si_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_di_bi = (deriv_exp_0_d0*((d_T4_dV_di_bi+(T5*(0.5*d_T2_dV_di_bi+(T6*(-(T6*(-d_T6_dV_di_bi)+d_T6_dV_di_bi*(1.25-T6)))+d_T6_dV_di_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_di_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gi_bi = (deriv_exp_0_d0*((d_T4_dV_gi_bi+(T5*(0.5*d_T2_dV_gi_bi+(T6*(-(T6*(-d_T6_dV_gi_bi)+d_T6_dV_gi_bi*(1.25-T6)))+d_T6_dV_gi_bi*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gi_bi*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*((d_T4_dV_sbulk_si+(T5*(0.5*d_T2_dV_sbulk_si+(T6*(-(T6*(-d_T6_dV_sbulk_si)+d_T6_dV_sbulk_si*(1.25-T6)))+d_T6_dV_sbulk_si*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_sbulk_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*((d_T4_dV_dbulk_di+(T5*(0.5*d_T2_dV_dbulk_di+(T6*(-(T6*(-d_T6_dV_dbulk_di)+d_T6_dV_dbulk_di*(1.25-T6)))+d_T6_dV_dbulk_di*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_dbulk_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gm_di = (deriv_exp_0_d0*((d_T4_dV_gm_di+(T5*(0.5*d_T2_dV_gm_di+(T6*(-(T6*(-d_T6_dV_gm_di)+d_T6_dV_gm_di*(1.25-T6)))+d_T6_dV_gm_di*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gm_di*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
d_T3_dV_gm_si = (deriv_exp_0_d0*((d_T4_dV_gm_si+(T5*(0.5*d_T2_dV_gm_si+(T6*(-(T6*(-d_T6_dV_gm_si)+d_T6_dV_gm_si*(1.25-T6)))+d_T6_dV_gm_si*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dV_gm_si*(((5.0/64.0)+(0.5*T2))+(T6*((15.0/16.0)-(T6*(1.25-T6)))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_qdeff_dTemp_t_GND = (T3*((d_T1_dTemp_t_GND-d_T8_dTemp_t_GND)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+2.0*d_T0_dTemp_t_GND*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dTemp_t_GND*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_si_bi = (T3*((d_T1_dV_si_bi-d_T8_dV_si_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+2.0*d_T0_dV_si_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_si_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_di_bi = (T3*((d_T1_dV_di_bi-d_T8_dV_di_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+2.0*d_T0_dV_di_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_di_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_gi_bi = (T3*((d_T1_dV_gi_bi-d_T8_dV_gi_bi)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+2.0*d_T0_dV_gi_bi*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gi_bi*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_sbulk_si = (T3*((d_T1_dV_sbulk_si-d_T8_dV_sbulk_si)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+2.0*d_T0_dV_sbulk_si*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_sbulk_si*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_dbulk_di = (T3*((d_T1_dV_dbulk_di-d_T8_dV_dbulk_di)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+2.0*d_T0_dV_dbulk_di*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_dbulk_di*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_gm_di = (T3*((d_T1_dV_gm_di-d_T8_dV_gm_di)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_di)+2.0*d_T0_dV_gm_di*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gm_di*(((1.0+T1)-T8)-value_log_0));
d_qdeff_dV_gm_si = (T3*((d_T1_dV_gm_si-d_T8_dV_gm_si)-(deriv_log_0_d0*(((2.0*T0)*(((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_si)+2.0*d_T0_dV_gm_si*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))+d_T3_dV_gm_si*(((1.0+T1)-T8)-value_log_0));
qdeff = (T3*(((1.0+T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;

d_T3_dTemp_t_GND = (deriv_exp_0_d0*(d_T8_dTemp_t_GND));
d_T3_dV_si_bi = (deriv_exp_0_d0*(d_T8_dV_si_bi));
d_T3_dV_di_bi = (deriv_exp_0_d0*(d_T8_dV_di_bi));
d_T3_dV_gi_bi = (deriv_exp_0_d0*(d_T8_dV_gi_bi));
d_T3_dV_sbulk_si = (deriv_exp_0_d0*(d_T8_dV_sbulk_si));
d_T3_dV_dbulk_di = (deriv_exp_0_d0*(d_T8_dV_dbulk_di));
d_T3_dV_gm_si = (deriv_exp_0_d0*(d_T8_dV_gm_si));
d_T3_dV_gm_di = (deriv_exp_0_d0*(d_T8_dV_gm_di));
T3 = value_exp_0;
}

d_sqrtpsisainv_dTemp_t_GND = (-d_sqrtpsisa_dTemp_t_GND/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_si_bi = (-d_sqrtpsisa_dV_si_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_di_bi = (-d_sqrtpsisa_dV_di_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gi_bi = (-d_sqrtpsisa_dV_gi_bi/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_sbulk_si = (-d_sqrtpsisa_dV_sbulk_si/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_dbulk_di = (-d_sqrtpsisa_dV_dbulk_di/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gm_si = (-d_sqrtpsisa_dV_gm_si/sqrtpsisa/sqrtpsisa);
d_sqrtpsisainv_dV_gm_di = (-d_sqrtpsisa_dV_gm_di/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
d_T4_dV_gm_di = ((2.0*d_T3_dV_gm_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_di)+((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_di);
d_T4_dV_gm_si = ((2.0*d_T3_dV_gm_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_si)+((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_si);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_di = ((-d_T3_dV_gm_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_si = ((-d_T3_dV_gm_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T3_dTemp_t_GND = (d_T3_dTemp_t_GND-((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5));
d_T3_dV_si_bi = (d_T3_dV_si_bi-((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5));
d_T3_dV_di_bi = (d_T3_dV_di_bi-((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5));
d_T3_dV_gi_bi = (d_T3_dV_gi_bi-((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5));
d_T3_dV_sbulk_si = (d_T3_dV_sbulk_si-((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5));
d_T3_dV_dbulk_di = (d_T3_dV_dbulk_di-((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5));
d_T3_dV_gm_di = (d_T3_dV_gm_di-((T5*d_T4_dV_gm_di-T4*d_T5_dV_gm_di)/T5/T5));
d_T3_dV_gm_si = (d_T3_dV_gm_si-((T5*d_T4_dV_gm_si-T4*d_T5_dV_gm_si)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))));

d_T4_dTemp_t_GND = ((2.0*d_T3_dTemp_t_GND+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)+2.0*d_sqrtpsisa_dTemp_t_GND)+((T3*2.0)*d_T0_dTemp_t_GND+d_T3_dTemp_t_GND*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dTemp_t_GND);
d_T4_dV_si_bi = ((2.0*d_T3_dV_si_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_si_bi)+((T3*2.0)*d_T0_dV_si_bi+d_T3_dV_si_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_si_bi);
d_T4_dV_di_bi = ((2.0*d_T3_dV_di_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_di_bi)+((T3*2.0)*d_T0_dV_di_bi+d_T3_dV_di_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_di_bi);
d_T4_dV_gi_bi = ((2.0*d_T3_dV_gi_bi+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)+2.0*d_sqrtpsisa_dV_gi_bi)+((T3*2.0)*d_T0_dV_gi_bi+d_T3_dV_gi_bi*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gi_bi);
d_T4_dV_sbulk_si = ((2.0*d_T3_dV_sbulk_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)+2.0*d_sqrtpsisa_dV_sbulk_si)+((T3*2.0)*d_T0_dV_sbulk_si+d_T3_dV_sbulk_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_sbulk_si);
d_T4_dV_dbulk_di = ((2.0*d_T3_dV_dbulk_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)+2.0*d_sqrtpsisa_dV_dbulk_di)+((T3*2.0)*d_T0_dV_dbulk_di+d_T3_dV_dbulk_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_dbulk_di);
d_T4_dV_gm_di = ((2.0*d_T3_dV_gm_di+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_di)+((T3*2.0)*d_T0_dV_gm_di+d_T3_dV_gm_di*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_di);
d_T4_dV_gm_si = ((2.0*d_T3_dV_gm_si+(deriv_log_0_d0*((((T3*2.0)*T0)*(((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)+2.0*d_sqrtpsisa_dV_gm_si)+((T3*2.0)*d_T0_dV_gm_si+d_T3_dV_gm_si*2.0*T0)*(((T3*2.0)*T0)+(2.0*sqrtpsisa))))))-d_T1_dV_gm_si);
T4 = (((2.0*T3)+value_log_0)-T1);
}

d_T5_dTemp_t_GND = ((-d_T3_dTemp_t_GND/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_si_bi = ((-d_T3_dV_si_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_di_bi = ((-d_T3_dV_di_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gi_bi = ((-d_T3_dV_gi_bi/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_sbulk_si = ((-d_T3_dV_sbulk_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_dbulk_di = ((-d_T3_dV_dbulk_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_di = ((-d_T3_dV_gm_di/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
d_T5_dV_gm_si = ((-d_T3_dV_gm_si/T3/T3)+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T6_dTemp_t_GND = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dTemp_t_GND-d_sqrtpsisainv_dTemp_t_GND)-(T0-sqrtpsisainv)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_si_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_si_bi-d_sqrtpsisainv_dV_si_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_di_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_di_bi-d_sqrtpsisainv_dV_di_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gi_bi = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gi_bi-d_sqrtpsisainv_dV_gi_bi)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_sbulk_si = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_sbulk_si-d_sqrtpsisainv_dV_sbulk_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_dbulk_di = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_dbulk_di-d_sqrtpsisainv_dV_dbulk_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gm_si = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_si-d_sqrtpsisainv_dV_gm_si)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
d_T6_dV_gm_di = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))+((((T0*T3)+sqrtpsisa)*(d_T0_dV_gm_di-d_sqrtpsisainv_dV_gm_di)-(T0-sqrtpsisainv)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di))/((T0*T3)+sqrtpsisa)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));
T6 = (((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa))*((T0-sqrtpsisainv)/((T0*T3)+sqrtpsisa)));

d_T7_dTemp_t_GND = (((-((1.0/T3)*(-d_T3_dTemp_t_GND/T3/T3)+(-d_T3_dTemp_t_GND/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dTemp_t_GND+d_T0_dTemp_t_GND*T3)+d_sqrtpsisa_dTemp_t_GND)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dTemp_t_GND+(sqrtpsisa*d_sqrtpsisa_dTemp_t_GND+d_sqrtpsisa_dTemp_t_GND*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dTemp_t_GND);
d_T7_dV_si_bi = (((-((1.0/T3)*(-d_T3_dV_si_bi/T3/T3)+(-d_T3_dV_si_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_si_bi+d_T0_dV_si_bi*T3)+d_sqrtpsisa_dV_si_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_si_bi+(sqrtpsisa*d_sqrtpsisa_dV_si_bi+d_sqrtpsisa_dV_si_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_si_bi);
d_T7_dV_di_bi = (((-((1.0/T3)*(-d_T3_dV_di_bi/T3/T3)+(-d_T3_dV_di_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_di_bi+d_T0_dV_di_bi*T3)+d_sqrtpsisa_dV_di_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_di_bi+(sqrtpsisa*d_sqrtpsisa_dV_di_bi+d_sqrtpsisa_dV_di_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_di_bi);
d_T7_dV_gi_bi = (((-((1.0/T3)*(-d_T3_dV_gi_bi/T3/T3)+(-d_T3_dV_gi_bi/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gi_bi+d_T0_dV_gi_bi*T3)+d_sqrtpsisa_dV_gi_bi)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gi_bi+(sqrtpsisa*d_sqrtpsisa_dV_gi_bi+d_sqrtpsisa_dV_gi_bi*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gi_bi);
d_T7_dV_sbulk_si = (((-((1.0/T3)*(-d_T3_dV_sbulk_si/T3/T3)+(-d_T3_dV_sbulk_si/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_sbulk_si+d_T0_dV_sbulk_si*T3)+d_sqrtpsisa_dV_sbulk_si)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_sbulk_si+(sqrtpsisa*d_sqrtpsisa_dV_sbulk_si+d_sqrtpsisa_dV_sbulk_si*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_sbulk_si);
d_T7_dV_dbulk_di = (((-((1.0/T3)*(-d_T3_dV_dbulk_di/T3/T3)+(-d_T3_dV_dbulk_di/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_dbulk_di+d_T0_dV_dbulk_di*T3)+d_sqrtpsisa_dV_dbulk_di)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_dbulk_di+(sqrtpsisa*d_sqrtpsisa_dV_dbulk_di+d_sqrtpsisa_dV_dbulk_di*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_dbulk_di);
d_T7_dV_gm_di = (((-((1.0/T3)*(-d_T3_dV_gm_di/T3/T3)+(-d_T3_dV_gm_di/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gm_di+d_T0_dV_gm_di*T3)+d_sqrtpsisa_dV_gm_di)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gm_di+(sqrtpsisa*d_sqrtpsisa_dV_gm_di+d_sqrtpsisa_dV_gm_di*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gm_di);
d_T7_dV_gm_si = (((-((1.0/T3)*(-d_T3_dV_gm_si/T3/T3)+(-d_T3_dV_gm_si/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*d_T3_dV_gm_si+d_T0_dV_gm_si*T3)+d_sqrtpsisa_dV_gm_si)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dV_gm_si+(sqrtpsisa*d_sqrtpsisa_dV_gm_si+d_sqrtpsisa_dV_gm_si*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-d_T6_dV_gm_si);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((T0*T3)+sqrtpsisa))))-T6);

d_qdeff_dTemp_t_GND = (d_T3_dTemp_t_GND-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dTemp_t_GND+d_T4_dTemp_t_GND*T7)-(T4*T7)*((2.0*T5)*d_T5_dTemp_t_GND+2.0*d_T5_dTemp_t_GND*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dTemp_t_GND-T4*d_T5_dTemp_t_GND)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_si_bi = (d_T3_dV_si_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_si_bi+d_T4_dV_si_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_si_bi+2.0*d_T5_dV_si_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_si_bi-T4*d_T5_dV_si_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_di_bi = (d_T3_dV_di_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_di_bi+d_T4_dV_di_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_di_bi+2.0*d_T5_dV_di_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_di_bi-T4*d_T5_dV_di_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_gi_bi = (d_T3_dV_gi_bi-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gi_bi+d_T4_dV_gi_bi*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gi_bi+2.0*d_T5_dV_gi_bi*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gi_bi-T4*d_T5_dV_gi_bi)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_sbulk_si = (d_T3_dV_sbulk_si-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_sbulk_si+d_T4_dV_sbulk_si*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_sbulk_si+2.0*d_T5_dV_sbulk_si*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_sbulk_si-T4*d_T5_dV_sbulk_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_dbulk_di = (d_T3_dV_dbulk_di-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_dbulk_di+d_T4_dV_dbulk_di*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_dbulk_di+2.0*d_T5_dV_dbulk_di*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_dbulk_di-T4*d_T5_dV_dbulk_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_gm_di = (d_T3_dV_gm_di-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gm_di+d_T4_dV_gm_di*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gm_di+2.0*d_T5_dV_gm_di*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gm_di-T4*d_T5_dV_gm_di)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
d_qdeff_dV_gm_si = (d_T3_dV_gm_si-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dV_gm_si+d_T4_dV_gm_si*T7)-(T4*T7)*((2.0*T5)*d_T5_dV_gm_si+2.0*d_T5_dV_gm_si*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dV_gm_si-T4*d_T5_dV_gm_si)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psipclamp_dTemp_t_GND = 0.5*(d_psip_dTemp_t_GND+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dTemp_t_GND+d_psip_dTemp_t_GND*(psip-1.0)))));
d_psipclamp_dV_si_bi = 0.5*(d_psip_dV_si_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_si_bi+d_psip_dV_si_bi*(psip-1.0)))));
d_psipclamp_dV_di_bi = 0.5*(d_psip_dV_di_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_di_bi+d_psip_dV_di_bi*(psip-1.0)))));
d_psipclamp_dV_gi_bi = 0.5*(d_psip_dV_gi_bi+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gi_bi+d_psip_dV_gi_bi*(psip-1.0)))));
d_psipclamp_dV_sbulk_si = 0.5*(d_psip_dV_sbulk_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_sbulk_si+d_psip_dV_sbulk_si*(psip-1.0)))));
d_psipclamp_dV_dbulk_di = 0.5*(d_psip_dV_dbulk_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_dbulk_di+d_psip_dV_dbulk_di*(psip-1.0)))));
d_psipclamp_dV_gm_si = 0.5*(d_psip_dV_gm_si+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gm_si+d_psip_dV_gm_si*(psip-1.0)))));
d_psipclamp_dV_gm_di = 0.5*(d_psip_dV_gm_di+(deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dV_gm_di+d_psip_dV_gm_di*(psip-1.0)))));
psipclamp = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(psipclamp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqrtpsip_dTemp_t_GND = (deriv_sqrt_0_d0*(d_psipclamp_dTemp_t_GND));
d_sqrtpsip_dV_si_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_si_bi));
d_sqrtpsip_dV_di_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_di_bi));
d_sqrtpsip_dV_gi_bi = (deriv_sqrt_0_d0*(d_psipclamp_dV_gi_bi));
d_sqrtpsip_dV_sbulk_si = (deriv_sqrt_0_d0*(d_psipclamp_dV_sbulk_si));
d_sqrtpsip_dV_dbulk_di = (deriv_sqrt_0_d0*(d_psipclamp_dV_dbulk_di));
d_sqrtpsip_dV_gm_si = (deriv_sqrt_0_d0*(d_psipclamp_dV_gm_si));
d_sqrtpsip_dV_gm_di = (deriv_sqrt_0_d0*(d_psipclamp_dV_gm_di));
sqrtpsip = value_sqrt_0;
}

d_psiavg_dTemp_t_GND = ((d_psip_dTemp_t_GND-d_qs_dTemp_t_GND)-d_qdeff_dTemp_t_GND);
d_psiavg_dV_si_bi = ((d_psip_dV_si_bi-d_qs_dV_si_bi)-d_qdeff_dV_si_bi);
d_psiavg_dV_di_bi = ((d_psip_dV_di_bi-d_qs_dV_di_bi)-d_qdeff_dV_di_bi);
d_psiavg_dV_gi_bi = ((d_psip_dV_gi_bi-d_qs_dV_gi_bi)-d_qdeff_dV_gi_bi);
d_psiavg_dV_sbulk_si = ((d_psip_dV_sbulk_si-d_qs_dV_sbulk_si)-d_qdeff_dV_sbulk_si);
d_psiavg_dV_dbulk_di = ((d_psip_dV_dbulk_di-d_qs_dV_dbulk_di)-d_qdeff_dV_dbulk_di);
d_psiavg_dV_gm_si = ((d_psip_dV_gm_si-d_qs_dV_gm_si)-d_qdeff_dV_gm_si);
d_psiavg_dV_gm_di = ((d_psip_dV_gm_di-d_qs_dV_gm_di)-d_qdeff_dV_gm_di);
psiavg = (((psip-qs)-qdeff)-1.0);
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dTemp_t_GND = 0.5*(d_psiavg_dTemp_t_GND+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dTemp_t_GND+d_psiavg_dTemp_t_GND*(psiavg-1.0)))));
d_T0_dV_si_bi = 0.5*(d_psiavg_dV_si_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_si_bi+d_psiavg_dV_si_bi*(psiavg-1.0)))));
d_T0_dV_di_bi = 0.5*(d_psiavg_dV_di_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_di_bi+d_psiavg_dV_di_bi*(psiavg-1.0)))));
d_T0_dV_gi_bi = 0.5*(d_psiavg_dV_gi_bi+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_gi_bi+d_psiavg_dV_gi_bi*(psiavg-1.0)))));
d_T0_dV_sbulk_si = 0.5*(d_psiavg_dV_sbulk_si+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_sbulk_si+d_psiavg_dV_sbulk_si*(psiavg-1.0)))));
d_T0_dV_dbulk_di = 0.5*(d_psiavg_dV_dbulk_di+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_dbulk_di+d_psiavg_dV_dbulk_di*(psiavg-1.0)))));
d_T0_dV_gm_si = 0.5*(d_psiavg_dV_gm_si+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_gm_si+d_psiavg_dV_gm_si*(psiavg-1.0)))));
d_T0_dV_gm_di = 0.5*(d_psiavg_dV_gm_di+(deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dV_gm_di+d_psiavg_dV_gm_di*(psiavg-1.0)))));
T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dTemp_t_GND = (deriv_sqrt_0_d0*(d_T0_dTemp_t_GND));
d_T2_dV_si_bi = (deriv_sqrt_0_d0*(d_T0_dV_si_bi));
d_T2_dV_di_bi = (deriv_sqrt_0_d0*(d_T0_dV_di_bi));
d_T2_dV_gi_bi = (deriv_sqrt_0_d0*(d_T0_dV_gi_bi));
d_T2_dV_sbulk_si = (deriv_sqrt_0_d0*(d_T0_dV_sbulk_si));
d_T2_dV_dbulk_di = (deriv_sqrt_0_d0*(d_T0_dV_dbulk_di));
d_T2_dV_gm_si = (deriv_sqrt_0_d0*(d_T0_dV_gm_si));
d_T2_dV_gm_di = (deriv_sqrt_0_d0*(d_T0_dV_gm_di));
T2 = value_sqrt_0;
}

d_nq_dV_gm_di = (-gam*(d_sqrtpsip_dV_gm_di+d_T2_dV_gm_di)/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dTemp_t_GND = (((sqrtpsip+T2)*d_gam_dTemp_t_GND-gam*(d_sqrtpsip_dTemp_t_GND+d_T2_dTemp_t_GND))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_si_bi = (((sqrtpsip+T2)*d_gam_dV_si_bi-gam*(d_sqrtpsip_dV_si_bi+d_T2_dV_si_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_di_bi = (((sqrtpsip+T2)*d_gam_dV_di_bi-gam*(d_sqrtpsip_dV_di_bi+d_T2_dV_di_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_gi_bi = (((sqrtpsip+T2)*d_gam_dV_gi_bi-gam*(d_sqrtpsip_dV_gi_bi+d_T2_dV_gi_bi))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_sbulk_si = (((sqrtpsip+T2)*d_gam_dV_sbulk_si-gam*(d_sqrtpsip_dV_sbulk_si+d_T2_dV_sbulk_si))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_dbulk_di = (((sqrtpsip+T2)*d_gam_dV_dbulk_di-gam*(d_sqrtpsip_dV_dbulk_di+d_T2_dV_dbulk_di))/(sqrtpsip+T2)/(sqrtpsip+T2));
d_nq_dV_gm_si = (((sqrtpsip+T2)*d_gam_dV_gm_si-gam*(d_sqrtpsip_dV_gm_si+d_T2_dV_gm_si))/(sqrtpsip+T2)/(sqrtpsip+T2));
nq = (1.0+(gam/(sqrtpsip+T2)));

d_ids_edge_dV_si_bi = ((((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dV_si_bi+(((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_si_bi+d_qdeff_dV_si_bi)+(d_qs_dV_si_bi-d_qdeff_dV_si_bi)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*d_nVt_dV_si_bi+(((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*d_nVt_dV_si_bi+((((2.0*NF)*nq)*d_ueff_dV_si_bi+(2.0*NF)*d_nq_dV_si_bi*ueff)*(model_.WEDGE)/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
d_ids_edge_dV_di_bi = ((((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dV_di_bi+(((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_di_bi+d_qdeff_dV_di_bi)+(d_qs_dV_di_bi-d_qdeff_dV_di_bi)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*d_nVt_dV_di_bi+(((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*d_nVt_dV_di_bi+((((2.0*NF)*nq)*d_ueff_dV_di_bi+(2.0*NF)*d_nq_dV_di_bi*ueff)*(model_.WEDGE)/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
d_ids_edge_dTemp_t_GND = ((((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dTemp_t_GND+(((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dTemp_t_GND+d_qdeff_dTemp_t_GND)+(d_qs_dTemp_t_GND-d_qdeff_dTemp_t_GND)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*d_nVt_dTemp_t_GND+(((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*d_nVt_dTemp_t_GND+((((2.0*NF)*nq)*d_ueff_dTemp_t_GND+(2.0*NF)*d_nq_dTemp_t_GND*ueff)*(model_.WEDGE)/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
d_ids_edge_dV_gi_bi = ((((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dV_gi_bi+(((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_gi_bi+d_qdeff_dV_gi_bi)+(d_qs_dV_gi_bi-d_qdeff_dV_gi_bi)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*d_nVt_dV_gi_bi+(((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*d_nVt_dV_gi_bi+((((2.0*NF)*nq)*d_ueff_dV_gi_bi+(2.0*NF)*d_nq_dV_gi_bi*ueff)*(model_.WEDGE)/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
d_ids_edge_dV_sbulk_si = (((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_sbulk_si+d_qdeff_dV_sbulk_si)+(d_qs_dV_sbulk_si-d_qdeff_dV_sbulk_si)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*d_nVt_dV_sbulk_si+(((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*d_nVt_dV_sbulk_si+((2.0*NF)*d_nq_dV_sbulk_si*ueff*(model_.WEDGE)/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc;
d_ids_edge_dV_dbulk_di = (((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_dbulk_di+d_qdeff_dV_dbulk_di)+(d_qs_dV_dbulk_di-d_qdeff_dV_dbulk_di)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*d_nVt_dV_dbulk_di+(((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*d_nVt_dV_dbulk_di+((2.0*NF)*d_nq_dV_dbulk_di*ueff*(model_.WEDGE)/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc;
d_ids_edge_dV_gm_di = (((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_gm_di+d_qdeff_dV_gm_di)+(d_qs_dV_gm_di-d_qdeff_dV_gm_di)*((1.0+qs)+qdeff))+((2.0*NF)*d_nq_dV_gm_di*ueff*(model_.WEDGE)/Leff)*Cox*nVt*nVt*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc;
d_ids_edge_dV_gm_si = (((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dV_gm_si+d_qdeff_dV_gm_si)+(d_qs_dV_gm_si-d_qdeff_dV_gm_si)*((1.0+qs)+qdeff))+((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*d_nVt_dV_gm_si+(((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*d_nVt_dV_gm_si+((2.0*NF)*d_nq_dV_gm_si*ueff*(model_.WEDGE)/Leff)*Cox*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc;
ids_edge = ((((((((((2.0*NF)*nq)*ueff)*(model_.WEDGE))/Leff)*Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);

d_ids_dV_si_bi = (d_ids_edge_dV_si_bi+d_ids_dV_si_bi);
d_ids_dV_di_bi = (d_ids_edge_dV_di_bi+d_ids_dV_di_bi);
d_ids_dTemp_t_GND = (d_ids_edge_dTemp_t_GND+d_ids_dTemp_t_GND);
d_ids_dV_gi_bi = (d_ids_edge_dV_gi_bi+d_ids_dV_gi_bi);
d_ids_dV_sbulk_si = (d_ids_edge_dV_sbulk_si+d_ids_dV_sbulk_si);
d_ids_dV_dbulk_di = (d_ids_edge_dV_dbulk_di+d_ids_dV_dbulk_di);
d_ids_dV_gm_di = (d_ids_edge_dV_gm_di+d_ids_dV_gm_di);
d_ids_dV_gm_si = (d_ids_edge_dV_gm_si+d_ids_dV_gm_si);
ids = (ids_edge+ids);
}

d_QB_dV_gm_bi = devsign*d_Qovb_dV_gm_bi;
d_QB_dV_si_bi = devsign*((d_QBi_dV_si_bi+d_Qbs_dV_si_bi)+d_Qbd_dV_si_bi);
d_QB_dV_di_bi = devsign*((d_QBi_dV_di_bi+d_Qbs_dV_di_bi)+d_Qbd_dV_di_bi);
d_QB_dV_gi_bi = devsign*((d_QBi_dV_gi_bi+d_Qbs_dV_gi_bi)+d_Qbd_dV_gi_bi);
d_QB_dV_sbulk_si = devsign*((d_QBi_dV_sbulk_si+d_Qbs_dV_sbulk_si)+d_Qbd_dV_sbulk_si);
d_QB_dV_dbulk_di = devsign*((d_QBi_dV_dbulk_di+d_Qbs_dV_dbulk_di)+d_Qbd_dV_dbulk_di);
d_QB_dTemp_t_GND = devsign*((d_QBi_dTemp_t_GND+d_Qbs_dTemp_t_GND)+d_Qbd_dTemp_t_GND);
QB = (devsign*(((QBi+Qovb)+Qbs)+Qbd));
if ((sigvds>0))
{

d_QSI_dV_si_bi = devsign*d_QSi_dV_si_bi;
d_QSI_dV_di_bi = devsign*d_QSi_dV_di_bi;
d_QSI_dV_gi_bi = devsign*d_QSi_dV_gi_bi;
d_QSI_dTemp_t_GND = devsign*d_QSi_dTemp_t_GND;
d_QSI_dV_sbulk_si = devsign*d_QSi_dV_sbulk_si;
d_QSI_dV_dbulk_di = devsign*d_QSi_dV_dbulk_di;
QSI = (devsign*QSi);

d_QDI_dV_si_bi = devsign*d_QDi_dV_si_bi;
d_QDI_dV_di_bi = devsign*d_QDi_dV_di_bi;
d_QDI_dV_gi_bi = devsign*d_QDi_dV_gi_bi;
d_QDI_dTemp_t_GND = devsign*d_QDi_dTemp_t_GND;
d_QDI_dV_sbulk_si = devsign*d_QDi_dV_sbulk_si;
d_QDI_dV_dbulk_di = devsign*d_QDi_dV_dbulk_di;
QDI = (devsign*QDi);

d_QS_dV_gm_si = devsign*d_Qovs_dV_gm_si;
d_QS_dV_si_bi = devsign*((d_QSi_dV_si_bi+d_Qovs_dV_si_bi)-d_Qbs_dV_si_bi);
d_QS_dV_di_bi = devsign*((d_QSi_dV_di_bi+d_Qovs_dV_di_bi)-d_Qbs_dV_di_bi);
d_QS_dV_gi_bi = devsign*((d_QSi_dV_gi_bi+d_Qovs_dV_gi_bi)-d_Qbs_dV_gi_bi);
d_QS_dTemp_t_GND = devsign*((d_QSi_dTemp_t_GND+d_Qovs_dTemp_t_GND)-d_Qbs_dTemp_t_GND);
d_QS_dV_sbulk_si = devsign*((d_QSi_dV_sbulk_si+d_Qovs_dV_sbulk_si)-d_Qbs_dV_sbulk_si);
d_QS_dV_dbulk_di = devsign*((d_QSi_dV_dbulk_di+d_Qovs_dV_dbulk_di)-d_Qbs_dV_dbulk_di);
QS = (devsign*((QSi+Qovs)-Qbs));

d_QD_dV_gm_di = devsign*d_Qovd_dV_gm_di;
d_QD_dV_gm_si = devsign*d_Qovd_dV_gm_si;
d_QD_dV_si_bi = devsign*((d_QDi_dV_si_bi+d_Qovd_dV_si_bi)-d_Qbd_dV_si_bi);
d_QD_dV_di_bi = devsign*((d_QDi_dV_di_bi+d_Qovd_dV_di_bi)-d_Qbd_dV_di_bi);
d_QD_dV_gi_bi = devsign*((d_QDi_dV_gi_bi+d_Qovd_dV_gi_bi)-d_Qbd_dV_gi_bi);
d_QD_dTemp_t_GND = devsign*((d_QDi_dTemp_t_GND+d_Qovd_dTemp_t_GND)-d_Qbd_dTemp_t_GND);
d_QD_dV_sbulk_si = devsign*((d_QDi_dV_sbulk_si+d_Qovd_dV_sbulk_si)-d_Qbd_dV_sbulk_si);
d_QD_dV_dbulk_di = devsign*((d_QDi_dV_dbulk_di+d_Qovd_dV_dbulk_di)-d_Qbd_dV_dbulk_di);
QD = (devsign*((QDi+Qovd)-Qbd));
}
else
{

d_QSI_dV_si_bi = devsign*d_QDi_dV_si_bi;
d_QSI_dV_di_bi = devsign*d_QDi_dV_di_bi;
d_QSI_dV_gi_bi = devsign*d_QDi_dV_gi_bi;
d_QSI_dTemp_t_GND = devsign*d_QDi_dTemp_t_GND;
d_QSI_dV_sbulk_si = devsign*d_QDi_dV_sbulk_si;
d_QSI_dV_dbulk_di = devsign*d_QDi_dV_dbulk_di;
QSI = (devsign*QDi);

d_QDI_dV_si_bi = devsign*d_QSi_dV_si_bi;
d_QDI_dV_di_bi = devsign*d_QSi_dV_di_bi;
d_QDI_dV_gi_bi = devsign*d_QSi_dV_gi_bi;
d_QDI_dTemp_t_GND = devsign*d_QSi_dTemp_t_GND;
d_QDI_dV_sbulk_si = devsign*d_QSi_dV_sbulk_si;
d_QDI_dV_dbulk_di = devsign*d_QSi_dV_dbulk_di;
QDI = (devsign*QSi);

d_QS_dV_gm_si = devsign*d_Qovs_dV_gm_si;
d_QS_dV_si_bi = devsign*((d_QDi_dV_si_bi+d_Qovs_dV_si_bi)-d_Qbs_dV_si_bi);
d_QS_dV_di_bi = devsign*((d_QDi_dV_di_bi+d_Qovs_dV_di_bi)-d_Qbs_dV_di_bi);
d_QS_dV_gi_bi = devsign*((d_QDi_dV_gi_bi+d_Qovs_dV_gi_bi)-d_Qbs_dV_gi_bi);
d_QS_dTemp_t_GND = devsign*((d_QDi_dTemp_t_GND+d_Qovs_dTemp_t_GND)-d_Qbs_dTemp_t_GND);
d_QS_dV_sbulk_si = devsign*((d_QDi_dV_sbulk_si+d_Qovs_dV_sbulk_si)-d_Qbs_dV_sbulk_si);
d_QS_dV_dbulk_di = devsign*((d_QDi_dV_dbulk_di+d_Qovs_dV_dbulk_di)-d_Qbs_dV_dbulk_di);
QS = (devsign*((QDi+Qovs)-Qbs));

d_QD_dV_gm_di = devsign*d_Qovd_dV_gm_di;
d_QD_dV_gm_si = devsign*d_Qovd_dV_gm_si;
d_QD_dV_si_bi = devsign*((d_QSi_dV_si_bi+d_Qovd_dV_si_bi)-d_Qbd_dV_si_bi);
d_QD_dV_di_bi = devsign*((d_QSi_dV_di_bi+d_Qovd_dV_di_bi)-d_Qbd_dV_di_bi);
d_QD_dV_gi_bi = devsign*((d_QSi_dV_gi_bi+d_Qovd_dV_gi_bi)-d_Qbd_dV_gi_bi);
d_QD_dTemp_t_GND = devsign*((d_QSi_dTemp_t_GND+d_Qovd_dTemp_t_GND)-d_Qbd_dTemp_t_GND);
d_QD_dV_sbulk_si = devsign*((d_QSi_dV_sbulk_si+d_Qovd_dV_sbulk_si)-d_Qbd_dV_sbulk_si);
d_QD_dV_dbulk_di = devsign*((d_QSi_dV_dbulk_di+d_Qovd_dV_dbulk_di)-d_Qbd_dV_dbulk_di);
QD = (devsign*((QSi+Qovd)-Qbd));
}

d_QG_dV_gm_bi = devsign*d_Qovg_dV_gm_bi;
d_QG_dV_gm_di = devsign*d_Qovg_dV_gm_di;
d_QG_dV_gm_si = devsign*d_Qovg_dV_gm_si;
d_QG_dV_si_bi = devsign*(d_QGi_dV_si_bi+d_Qovg_dV_si_bi);
d_QG_dV_di_bi = devsign*(d_QGi_dV_di_bi+d_Qovg_dV_di_bi);
d_QG_dV_gi_bi = devsign*(d_QGi_dV_gi_bi+d_Qovg_dV_gi_bi);
d_QG_dV_sbulk_si = devsign*(d_QGi_dV_sbulk_si+d_Qovg_dV_sbulk_si);
d_QG_dV_dbulk_di = devsign*(d_QGi_dV_dbulk_di+d_Qovg_dV_dbulk_di);
d_QG_dTemp_t_GND = devsign*(d_QGi_dTemp_t_GND+d_Qovg_dTemp_t_GND);
QG = (devsign*(QGi+Qovg));

d_QBI_dV_si_bi = devsign*d_QBi_dV_si_bi;
d_QBI_dV_di_bi = devsign*d_QBi_dV_di_bi;
d_QBI_dV_gi_bi = devsign*d_QBi_dV_gi_bi;
d_QBI_dV_sbulk_si = devsign*d_QBi_dV_sbulk_si;
d_QBI_dV_dbulk_di = devsign*d_QBi_dV_dbulk_di;
d_QBI_dTemp_t_GND = devsign*d_QBi_dTemp_t_GND;
QBI = (devsign*QBi);

d_QGI_dV_si_bi = devsign*d_QGi_dV_si_bi;
d_QGI_dV_di_bi = devsign*d_QGi_dV_di_bi;
d_QGI_dV_gi_bi = devsign*d_QGi_dV_gi_bi;
d_QGI_dV_sbulk_si = devsign*d_QGi_dV_sbulk_si;
d_QGI_dV_dbulk_di = devsign*d_QGi_dV_dbulk_di;
d_QGI_dTemp_t_GND = devsign*d_QGi_dTemp_t_GND;
QGI = (devsign*QGi);
CGSI = (-(+d_QGI_dV_si_bi-d_QGI_dV_sbulk_si));
CGDI = (-(+d_QGI_dV_di_bi-d_QGI_dV_dbulk_di));
CGBI = (-(-d_QGI_dV_si_bi-d_QGI_dV_di_bi-d_QGI_dV_gi_bi));
CGGI = (+d_QGI_dV_gi_bi);
CSSI = (+d_QSI_dV_si_bi-d_QSI_dV_sbulk_si);
CSDI = (-(+d_QSI_dV_di_bi-d_QSI_dV_dbulk_di));
CSBI = (-(-d_QSI_dV_si_bi-d_QSI_dV_di_bi-d_QSI_dV_gi_bi));
CSGI = (-(+d_QSI_dV_gi_bi));
CDSI = (-(+d_QDI_dV_si_bi-d_QDI_dV_sbulk_si));
CDDI = (+d_QDI_dV_di_bi-d_QDI_dV_dbulk_di);
CDBI = (-(-d_QDI_dV_si_bi-d_QDI_dV_di_bi-d_QDI_dV_gi_bi));
CDGI = (-(+d_QDI_dV_gi_bi));
CBSI = (-(+d_QBI_dV_si_bi-d_QBI_dV_sbulk_si));
CBDI = (-(+d_QBI_dV_di_bi-d_QBI_dV_dbulk_di));
CBBI = (-d_QBI_dV_si_bi-d_QBI_dV_di_bi-d_QBI_dV_gi_bi);
CBGI = (-(+d_QBI_dV_gi_bi));
CGS = (-(-d_QG_dV_gm_si+d_QG_dV_si_bi-d_QG_dV_sbulk_si));
CGD = (-(-d_QG_dV_gm_di+d_QG_dV_di_bi-d_QG_dV_dbulk_di));
CGB = (-(-d_QG_dV_gm_bi-d_QG_dV_si_bi-d_QG_dV_di_bi-d_QG_dV_gi_bi));
CGG = (CGGI+(+devsign*d_Qovg_dV_gm_bi+devsign*d_Qovg_dV_gm_di+devsign*d_Qovg_dV_gm_si));
CSS = (-d_QS_dV_gm_si+d_QS_dV_si_bi-d_QS_dV_sbulk_si);
CSD = (-(+d_QS_dV_di_bi-d_QS_dV_dbulk_di));
CSB = (CSBI-(+(d_QS_dV_sbulk_si-d_QSI_dV_sbulk_si)));
CSG = (CSGI-(+d_QS_dV_gm_si));
CDS = (-(-d_QD_dV_gm_si+d_QD_dV_si_bi-d_QD_dV_sbulk_si));
CDD = (-d_QD_dV_gm_di+d_QD_dV_di_bi-d_QD_dV_dbulk_di);
CDB = (CDBI-(+(d_QD_dV_dbulk_di-d_QDI_dV_dbulk_di)));
CDG = (CDGI-(+d_QD_dV_gm_di+d_QD_dV_gm_si));
CBS = (-(+d_QB_dV_si_bi-d_QB_dV_sbulk_si));
CBD = (-(+d_QB_dV_di_bi-d_QB_dV_dbulk_di));
CBB = (((CBBI+(+d_QB_dV_sbulk_si))+(+d_QB_dV_dbulk_di))+(-devsign*d_Qovb_dV_gm_bi));
CBG = ((-(+d_QB_dV_gi_bi))-(+devsign*d_Qovb_dV_gm_bi));
CGSEXT = ((-devsign)*(-d_Qovg_dV_gm_si+d_Qovg_dV_si_bi-d_Qovg_dV_sbulk_si));
CGDEXT = ((-devsign)*(-d_Qovg_dV_gm_di+d_Qovg_dV_di_bi-d_Qovg_dV_dbulk_di));
CGBOV = ((-devsign)*(-d_Qovg_dV_gm_bi-d_Qovg_dV_si_bi-d_Qovg_dV_di_bi-d_Qovg_dV_gi_bi));
CAPBS = ((-devsign)*(+d_Qbs_dV_si_bi-d_Qbs_dV_sbulk_si));
CAPBD = ((-devsign)*(+d_Qbd_dV_di_bi-d_Qbd_dV_dbulk_di));
WEFF = Weff;
LEFF = Leff;
WEFFCV = Wact;
LEFFCV = Lact;
if ((sigvds>0))
{

d_IDS_dV_si_bi = devsign*d_ids_dV_si_bi;
d_IDS_dV_di_bi = devsign*d_ids_dV_di_bi;
d_IDS_dTemp_t_GND = devsign*d_ids_dTemp_t_GND;
d_IDS_dV_gi_bi = devsign*d_ids_dV_gi_bi;
d_IDS_dV_sbulk_si = devsign*d_ids_dV_sbulk_si;
d_IDS_dV_dbulk_di = devsign*d_ids_dV_dbulk_di;
d_IDS_dV_gm_di = devsign*d_ids_dV_gm_di;
d_IDS_dV_gm_si = devsign*d_ids_dV_gm_si;
IDS = (devsign*ids);
IDEFF = (((IDS-(IGD+IGCD))+ISUB)+IGIDL);
ISEFF = (((-IDS)-(IGS+IGCS))+IGISL);
}
else
{

d_IDS_dV_si_bi = (-devsign)*d_ids_dV_si_bi;
d_IDS_dV_di_bi = (-devsign)*d_ids_dV_di_bi;
d_IDS_dTemp_t_GND = (-devsign)*d_ids_dTemp_t_GND;
d_IDS_dV_gi_bi = (-devsign)*d_ids_dV_gi_bi;
d_IDS_dV_sbulk_si = (-devsign)*d_ids_dV_sbulk_si;
d_IDS_dV_dbulk_di = (-devsign)*d_ids_dV_dbulk_di;
d_IDS_dV_gm_di = (-devsign)*d_ids_dV_gm_di;
d_IDS_dV_gm_si = (-devsign)*d_ids_dV_gm_si;
IDS = ((-devsign)*ids);
IDEFF = ((IDS-(IGD+IGCD))+IGIDL);
ISEFF = ((((-IDS)-(IGS+IGCS))+ISUB)+IGISL);
}
IGEFF = ((((IGB+IGS)+IGCS)+IGD)+IGCD);
IBS = ((-devsign)*Ibs);
IBD = ((-devsign)*Ibd);
VDS = (probeVars[admsProbeID_V_di_si]);
VGS = (probeVars[admsProbeID_V_gi_si]);
VBS = (-(probeVars[admsProbeID_V_si_bi]));
VDSAT = Vdssat;
GM = (+d_IDS_dV_gi_bi);
GMBS = (-d_IDS_dV_si_bi-d_IDS_dV_di_bi-d_IDS_dV_gi_bi);
GDS = (+d_IDS_dV_di_bi-d_IDS_dV_dbulk_di-d_IDS_dV_gm_di);
// I(gi,bi) <+ (ddt((m*QGI)))
dynamicContributions[admsNodeID_gi] += ((m*QGI));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi] += (m*d_QGI_dV_si_bi);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] += (m*d_QGI_dV_di_bi);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi] += (m*d_QGI_dV_gi_bi);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si] += (m*d_QGI_dV_sbulk_si);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di] += (m*d_QGI_dV_dbulk_di);
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] += (m*d_QGI_dTemp_t_GND);
dynamicContributions[admsNodeID_bi] -= ((m*QGI));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= (m*d_QGI_dV_si_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= (m*d_QGI_dV_di_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= (m*d_QGI_dV_gi_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] -= (m*d_QGI_dV_sbulk_si);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] -= (m*d_QGI_dV_dbulk_di);
d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= (m*d_QGI_dTemp_t_GND);
// I(si,bi) <+ (ddt((m*QSI)))
dynamicContributions[admsNodeID_si] += ((m*QSI));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] += (m*d_QSI_dV_si_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] += (m*d_QSI_dV_di_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] += (m*d_QSI_dV_gi_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND] += (m*d_QSI_dTemp_t_GND);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si] += (m*d_QSI_dV_sbulk_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di] += (m*d_QSI_dV_dbulk_di);
dynamicContributions[admsNodeID_bi] -= ((m*QSI));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= (m*d_QSI_dV_si_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= (m*d_QSI_dV_di_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= (m*d_QSI_dV_gi_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= (m*d_QSI_dTemp_t_GND);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] -= (m*d_QSI_dV_sbulk_si);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] -= (m*d_QSI_dV_dbulk_di);
// I(di,bi) <+ (ddt((m*QDI)))
dynamicContributions[admsNodeID_di] += ((m*QDI));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] += (m*d_QDI_dV_si_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] += (m*d_QDI_dV_di_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] += (m*d_QDI_dV_gi_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND] += (m*d_QDI_dTemp_t_GND);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si] += (m*d_QDI_dV_sbulk_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di] += (m*d_QDI_dV_dbulk_di);
dynamicContributions[admsNodeID_bi] -= ((m*QDI));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= (m*d_QDI_dV_si_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= (m*d_QDI_dV_di_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= (m*d_QDI_dV_gi_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= (m*d_QDI_dTemp_t_GND);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] -= (m*d_QDI_dV_sbulk_si);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] -= (m*d_QDI_dV_dbulk_di);
// I(gm,si) <+ (ddt((m*((-devsign)*Qovs))))
dynamicContributions[admsNodeID_gm] += ((m*((-devsign)*Qovs)));
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_si] += (m*(-devsign)*d_Qovs_dV_gm_si);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_bi] += (m*(-devsign)*d_Qovs_dV_si_bi);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_bi] += (m*(-devsign)*d_Qovs_dV_di_bi);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_bi] += (m*(-devsign)*d_Qovs_dV_gi_bi);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_si] += (m*(-devsign)*d_Qovs_dV_sbulk_si);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_di] += (m*(-devsign)*d_Qovs_dV_dbulk_di);
d_dynamicContributions[admsNodeID_gm][admsProbeID_Temp_t_GND] += (m*(-devsign)*d_Qovs_dTemp_t_GND);
dynamicContributions[admsNodeID_si] -= ((m*((-devsign)*Qovs)));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_si] -= (m*(-devsign)*d_Qovs_dV_gm_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] -= (m*(-devsign)*d_Qovs_dV_si_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -= (m*(-devsign)*d_Qovs_dV_di_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= (m*(-devsign)*d_Qovs_dV_gi_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= (m*(-devsign)*d_Qovs_dV_sbulk_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di] -= (m*(-devsign)*d_Qovs_dV_dbulk_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= (m*(-devsign)*d_Qovs_dTemp_t_GND);
// I(gm,di) <+ (ddt((m*((-devsign)*Qovd))))
dynamicContributions[admsNodeID_gm] += ((m*((-devsign)*Qovd)));
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_di] += (m*(-devsign)*d_Qovd_dV_gm_di);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_bi] += (m*(-devsign)*d_Qovd_dV_si_bi);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_bi] += (m*(-devsign)*d_Qovd_dV_di_bi);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_bi] += (m*(-devsign)*d_Qovd_dV_gi_bi);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_si] += (m*(-devsign)*d_Qovd_dV_sbulk_si);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_di] += (m*(-devsign)*d_Qovd_dV_dbulk_di);
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_si] += (m*(-devsign)*d_Qovd_dV_gm_si);
d_dynamicContributions[admsNodeID_gm][admsProbeID_Temp_t_GND] += (m*(-devsign)*d_Qovd_dTemp_t_GND);
dynamicContributions[admsNodeID_di] -= ((m*((-devsign)*Qovd)));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_di] -= (m*(-devsign)*d_Qovd_dV_gm_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] -= (m*(-devsign)*d_Qovd_dV_si_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -= (m*(-devsign)*d_Qovd_dV_di_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= (m*(-devsign)*d_Qovd_dV_gi_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si] -= (m*(-devsign)*d_Qovd_dV_sbulk_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di] -= (m*(-devsign)*d_Qovd_dV_dbulk_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_si] -= (m*(-devsign)*d_Qovd_dV_gm_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= (m*(-devsign)*d_Qovd_dTemp_t_GND);
// I(gm,bi) <+ (ddt((m*((-devsign)*Qovb))))
dynamicContributions[admsNodeID_gm] += ((m*((-devsign)*Qovb)));
d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_bi] += (m*(-devsign)*d_Qovb_dV_gm_bi);
dynamicContributions[admsNodeID_bi] -= ((m*((-devsign)*Qovb)));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_bi] -= (m*(-devsign)*d_Qovb_dV_gm_bi);
// I(di,si) <+ ((((m*devsign)*sigvds)*ids))
staticContributions[admsNodeID_di] += (((m*devsign)*sigvds)*ids);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] += ((m*devsign)*sigvds)*d_ids_dV_si_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] += ((m*devsign)*sigvds)*d_ids_dV_di_bi;
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] += ((m*devsign)*sigvds)*d_ids_dTemp_t_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] += ((m*devsign)*sigvds)*d_ids_dV_gi_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si] += ((m*devsign)*sigvds)*d_ids_dV_sbulk_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di] += ((m*devsign)*sigvds)*d_ids_dV_dbulk_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_gm_di] += ((m*devsign)*sigvds)*d_ids_dV_gm_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_gm_si] += ((m*devsign)*sigvds)*d_ids_dV_gm_si;
staticContributions[admsNodeID_si] -= (((m*devsign)*sigvds)*ids);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] -= ((m*devsign)*sigvds)*d_ids_dV_si_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -= ((m*devsign)*sigvds)*d_ids_dV_di_bi;
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= ((m*devsign)*sigvds)*d_ids_dTemp_t_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= ((m*devsign)*sigvds)*d_ids_dV_gi_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= ((m*devsign)*sigvds)*d_ids_dV_sbulk_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_di] -= ((m*devsign)*sigvds)*d_ids_dV_dbulk_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_gm_di] -= ((m*devsign)*sigvds)*d_ids_dV_gm_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_gm_si] -= ((m*devsign)*sigvds)*d_ids_dV_gm_si;
if (((model_.IGBMOD)!=0))
{
// I(gi,bi) <+ ((m*IGB))
staticContributions[admsNodeID_gi] += (m*IGB);
d_staticContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] += m*d_IGB_dTemp_t_GND;
d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi] += m*d_IGB_dV_si_bi;
d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi] += m*d_IGB_dV_di_bi;
d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi] += m*d_IGB_dV_gi_bi;
staticContributions[admsNodeID_bi] -= (m*IGB);
d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= m*d_IGB_dTemp_t_GND;
d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= m*d_IGB_dV_si_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= m*d_IGB_dV_di_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= m*d_IGB_dV_gi_bi;
}
if (((model_.IGCMOD)!=0))
{
// I(gi,si) <+ ((m*(IGS+IGCS)))
staticContributions[admsNodeID_gi] += (m*(IGS+IGCS));
d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi] += m*(d_IGS_dV_di_bi+d_IGCS_dV_di_bi);
d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi] += m*(d_IGS_dV_si_bi+d_IGCS_dV_si_bi);
d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi] += m*(d_IGS_dV_gi_bi+d_IGCS_dV_gi_bi);
d_staticContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] += m*(d_IGS_dTemp_t_GND+d_IGCS_dTemp_t_GND);
staticContributions[admsNodeID_si] -= (m*(IGS+IGCS));
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -= m*(d_IGS_dV_di_bi+d_IGCS_dV_di_bi);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] -= m*(d_IGS_dV_si_bi+d_IGCS_dV_si_bi);
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= m*(d_IGS_dV_gi_bi+d_IGCS_dV_gi_bi);
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= m*(d_IGS_dTemp_t_GND+d_IGCS_dTemp_t_GND);
// I(gi,di) <+ ((m*(IGD+IGCD)))
staticContributions[admsNodeID_gi] += (m*(IGD+IGCD));
d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi] += m*(d_IGD_dV_si_bi+d_IGCD_dV_si_bi);
d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi] += m*(d_IGD_dV_di_bi+d_IGCD_dV_di_bi);
d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi] += m*(d_IGD_dV_gi_bi+d_IGCD_dV_gi_bi);
d_staticContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] += m*(d_IGD_dTemp_t_GND+d_IGCD_dTemp_t_GND);
staticContributions[admsNodeID_di] -= (m*(IGD+IGCD));
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] -= m*(d_IGD_dV_si_bi+d_IGCD_dV_si_bi);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] -= m*(d_IGD_dV_di_bi+d_IGCD_dV_di_bi);
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= m*(d_IGD_dV_gi_bi+d_IGCD_dV_gi_bi);
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= m*(d_IGD_dTemp_t_GND+d_IGCD_dTemp_t_GND);
}
if ((sigvds>0))
{
// I(di,bi) <+ ((m*(ISUB+IGIDL)))
staticContributions[admsNodeID_di] += (m*(ISUB+IGIDL));
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] += m*(d_ISUB_dTemp_t_GND+d_IGIDL_dTemp_t_GND);
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] += m*(d_ISUB_dV_gi_bi+d_IGIDL_dV_gi_bi);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] += m*(d_ISUB_dV_si_bi+d_IGIDL_dV_si_bi);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] += m*(d_ISUB_dV_di_bi+d_IGIDL_dV_di_bi);
staticContributions[admsNodeID_bi] -= (m*(ISUB+IGIDL));
d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= m*(d_ISUB_dTemp_t_GND+d_IGIDL_dTemp_t_GND);
d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= m*(d_ISUB_dV_gi_bi+d_IGIDL_dV_gi_bi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= m*(d_ISUB_dV_si_bi+d_IGIDL_dV_si_bi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= m*(d_ISUB_dV_di_bi+d_IGIDL_dV_di_bi);
// I(si,bi) <+ ((m*IGISL))
staticContributions[admsNodeID_si] += (m*IGISL);
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] += m*d_IGISL_dTemp_t_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] += m*d_IGISL_dV_si_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] += m*d_IGISL_dV_di_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] += m*d_IGISL_dV_gi_bi;
staticContributions[admsNodeID_bi] -= (m*IGISL);
d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= m*d_IGISL_dTemp_t_GND;
d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= m*d_IGISL_dV_si_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= m*d_IGISL_dV_di_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= m*d_IGISL_dV_gi_bi;
}
else
{
// I(di,bi) <+ ((m*IGIDL))
staticContributions[admsNodeID_di] += (m*IGIDL);
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] += m*d_IGIDL_dTemp_t_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] += m*d_IGIDL_dV_si_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] += m*d_IGIDL_dV_di_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] += m*d_IGIDL_dV_gi_bi;
staticContributions[admsNodeID_bi] -= (m*IGIDL);
d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= m*d_IGIDL_dTemp_t_GND;
d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= m*d_IGIDL_dV_si_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= m*d_IGIDL_dV_di_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= m*d_IGIDL_dV_gi_bi;
// I(si,bi) <+ ((m*(ISUB+IGISL)))
staticContributions[admsNodeID_si] += (m*(ISUB+IGISL));
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] += m*(d_ISUB_dTemp_t_GND+d_IGISL_dTemp_t_GND);
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] += m*(d_ISUB_dV_gi_bi+d_IGISL_dV_gi_bi);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] += m*(d_ISUB_dV_si_bi+d_IGISL_dV_si_bi);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] += m*(d_ISUB_dV_di_bi+d_IGISL_dV_di_bi);
staticContributions[admsNodeID_bi] -= (m*(ISUB+IGISL));
d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] -= m*(d_ISUB_dTemp_t_GND+d_IGISL_dTemp_t_GND);
d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -= m*(d_ISUB_dV_gi_bi+d_IGISL_dV_gi_bi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] -= m*(d_ISUB_dV_si_bi+d_IGISL_dV_si_bi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] -= m*(d_ISUB_dV_di_bi+d_IGISL_dV_di_bi);
}
if (((model_.RDSMOD)!=2))
{

d_gdpr_dV_si_bi = (-d_Rdrain_dV_si_bi/Rdrain/Rdrain);
d_gdpr_dV_di_bi = (-d_Rdrain_dV_di_bi/Rdrain/Rdrain);
d_gdpr_dV_gi_bi = (-d_Rdrain_dV_gi_bi/Rdrain/Rdrain);
d_gdpr_dTemp_t_GND = (-d_Rdrain_dTemp_t_GND/Rdrain/Rdrain);
gdpr = (1.0/Rdrain);

d_gspr_dV_si_bi = (-d_Rsource_dV_si_bi/Rsource/Rsource);
d_gspr_dV_di_bi = (-d_Rsource_dV_di_bi/Rsource/Rsource);
d_gspr_dV_gi_bi = (-d_Rsource_dV_gi_bi/Rsource/Rsource);
d_gspr_dTemp_t_GND = (-d_Rsource_dTemp_t_GND/Rsource/Rsource);
gspr = (1.0/Rsource);
// I(d,di) <+ (((m*V(d,di))*gdpr))
staticContributions[admsNodeID_d] += ((m*(probeVars[admsProbeID_V_d_di]))*gdpr);
d_staticContributions[admsNodeID_d][admsProbeID_V_si_bi] += (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dV_si_bi;
d_staticContributions[admsNodeID_d][admsProbeID_V_di_bi] += (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dV_di_bi;
d_staticContributions[admsNodeID_d][admsProbeID_V_gi_bi] += (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dV_gi_bi;
d_staticContributions[admsNodeID_d][admsProbeID_Temp_t_GND] += (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dTemp_t_GND;
d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] += m*d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di]*gdpr;
staticContributions[admsNodeID_di] -= ((m*(probeVars[admsProbeID_V_d_di]))*gdpr);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] -= (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dV_si_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] -= (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dV_di_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dV_gi_bi;
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= (m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dTemp_t_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] -= m*d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di]*gdpr;
// I(s,si) <+ (((m*V(s,si))*gspr))
staticContributions[admsNodeID_s] += ((m*(probeVars[admsProbeID_V_s_si]))*gspr);
d_staticContributions[admsNodeID_s][admsProbeID_V_si_bi] += (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dV_si_bi;
d_staticContributions[admsNodeID_s][admsProbeID_V_di_bi] += (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dV_di_bi;
d_staticContributions[admsNodeID_s][admsProbeID_V_gi_bi] += (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dV_gi_bi;
d_staticContributions[admsNodeID_s][admsProbeID_Temp_t_GND] += (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dTemp_t_GND;
d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] += m*d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si]*gspr;
staticContributions[admsNodeID_si] -= ((m*(probeVars[admsProbeID_V_s_si]))*gspr);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] -= (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dV_si_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -= (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dV_di_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dV_gi_bi;
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= (m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dTemp_t_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] -= m*d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si]*gspr;
// I(d,di) <+ (white_noise(((m*Nt)*gdpr),"rd"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[8]= ((m*Nt)*gdpr);
}
// I(s,si) <+ (white_noise(((m*Nt)*gspr),"rs"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[9]= ((m*Nt)*gspr);
}
}
else
{
// V(d,di) <+ (0)
// do nothing at all
// V(s,si) <+ (0)
// do nothing at all
}
if ((RGATEMOD==0))
{
// V(g,gm) <+ (0)
// do nothing at all
}
else
//Begin block rgate
{
//Block-local variables for block rgate
double Ggate=0.0;
     double d_Ggate_dV_gi_bi=0.0;
     double d_Ggate_dV_di_bi=0.0;
     double d_Ggate_dV_si_bi=0.0;
     double d_Ggate_dTemp_t_GND=0.0;
double Gnoise=0.0;
//End of Block-local variables
if ((RGATEMOD==2))
{

d_Ggate_dTemp_t_GND = d_Gcrg_dTemp_t_GND;
d_Ggate_dV_si_bi = d_Gcrg_dV_si_bi;
d_Ggate_dV_di_bi = d_Gcrg_dV_di_bi;
d_Ggate_dV_gi_bi = d_Gcrg_dV_gi_bi;
Ggate = Gcrg;
Gnoise = ((Gcrg*Gcrg)/Grgeltd);
}
else
{

d_Ggate_dV_gi_bi = d_Ggate_dV_di_bi = d_Ggate_dV_si_bi = d_Ggate_dTemp_t_GND =  0.0;
Ggate = Grgeltd;
Gnoise = Grgeltd;
}
// I(g,gm) <+ (((m*V(g,gm))*Ggate))
staticContributions[admsNodeID_g] += ((m*(probeVars[admsProbeID_V_g_gm]))*Ggate);
d_staticContributions[admsNodeID_g][admsProbeID_Temp_t_GND] += (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dTemp_t_GND;
d_staticContributions[admsNodeID_g][admsProbeID_V_si_bi] += (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dV_si_bi;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_bi] += (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dV_di_bi;
d_staticContributions[admsNodeID_g][admsProbeID_V_gi_bi] += (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dV_gi_bi;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_gm] += m*d_probeVars[admsProbeID_V_g_gm][admsProbeID_V_g_gm]*Ggate;
staticContributions[admsNodeID_gm] -= ((m*(probeVars[admsProbeID_V_g_gm]))*Ggate);
d_staticContributions[admsNodeID_gm][admsProbeID_Temp_t_GND] -= (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dTemp_t_GND;
d_staticContributions[admsNodeID_gm][admsProbeID_V_si_bi] -= (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dV_si_bi;
d_staticContributions[admsNodeID_gm][admsProbeID_V_di_bi] -= (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dV_di_bi;
d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_bi] -= (m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dV_gi_bi;
d_staticContributions[admsNodeID_gm][admsProbeID_V_g_gm] -= m*d_probeVars[admsProbeID_V_g_gm][admsProbeID_V_g_gm]*Ggate;
// I(g,gm) <+ (white_noise(((m*Nt)*Gnoise),"rg"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[10]= ((m*Nt)*Gnoise);
}
}
// End block rgate
if ((RGATEMOD==3))
{
// I(gm,gi) <+ (((m*V(gm,gi))*Gcrg))
staticContributions[admsNodeID_gm] += ((m*(probeVars[admsProbeID_V_gm_gi]))*Gcrg);
d_staticContributions[admsNodeID_gm][admsProbeID_Temp_t_GND] += (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dTemp_t_GND;
d_staticContributions[admsNodeID_gm][admsProbeID_V_si_bi] += (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dV_si_bi;
d_staticContributions[admsNodeID_gm][admsProbeID_V_di_bi] += (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dV_di_bi;
d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_bi] += (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dV_gi_bi;
d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_gi] += m*d_probeVars[admsProbeID_V_gm_gi][admsProbeID_V_gm_gi]*Gcrg;
staticContributions[admsNodeID_gi] -= ((m*(probeVars[admsProbeID_V_gm_gi]))*Gcrg);
d_staticContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] -= (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dTemp_t_GND;
d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi] -= (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dV_si_bi;
d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi] -= (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dV_di_bi;
d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi] -= (m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dV_gi_bi;
d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_gi] -= m*d_probeVars[admsProbeID_V_gm_gi][admsProbeID_V_gm_gi]*Gcrg;
}
else
{
// V(gm,gi) <+ (0)
// do nothing at all
}
if ((((model_.SHMOD)!=0)&&((model_.RTH0)>0)))
{
if (((model_.RDSMOD)!=2))
{
// Pwr(t,GND) <+ ((m*((-(((((devsign*sigvds)*ids)*V(di,si))+((V(d,di)*V(d,di))/Rdrain))+((V(s,si)*V(s,si))/Rsource)))+(delTemp1*gth))))
staticContributions[admsNodeID_t] += (m*((-(((((devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si]))+(((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))/Rdrain))+(((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))/Rsource)))+(delTemp1*gth)));
d_staticContributions[admsNodeID_t][admsProbeID_V_s_si] += m*(-(((probeVars[admsProbeID_V_s_si])*d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si]+d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si]*(probeVars[admsProbeID_V_s_si]))/Rsource));
d_staticContributions[admsNodeID_t][admsProbeID_V_d_di] += m*(-(((probeVars[admsProbeID_V_d_di])*d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di]+d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di]*(probeVars[admsProbeID_V_d_di]))/Rdrain));
d_staticContributions[admsNodeID_t][admsProbeID_V_di_si] += m*(-((devsign*sigvds)*ids)*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si]);
d_staticContributions[admsNodeID_t][admsProbeID_V_si_bi] += m*(-(((devsign*sigvds)*d_ids_dV_si_bi*(probeVars[admsProbeID_V_di_si])+(-((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))*d_Rdrain_dV_si_bi/Rdrain/Rdrain))+(-((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))*d_Rsource_dV_si_bi/Rsource/Rsource)));
d_staticContributions[admsNodeID_t][admsProbeID_V_di_bi] += m*(-(((devsign*sigvds)*d_ids_dV_di_bi*(probeVars[admsProbeID_V_di_si])+(-((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))*d_Rdrain_dV_di_bi/Rdrain/Rdrain))+(-((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))*d_Rsource_dV_di_bi/Rsource/Rsource)));
d_staticContributions[admsNodeID_t][admsProbeID_Temp_t_GND] += m*((-(((devsign*sigvds)*d_ids_dTemp_t_GND*(probeVars[admsProbeID_V_di_si])+(-((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))*d_Rdrain_dTemp_t_GND/Rdrain/Rdrain))+(-((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))*d_Rsource_dTemp_t_GND/Rsource/Rsource)))+d_delTemp1_dTemp_t_GND*gth);
d_staticContributions[admsNodeID_t][admsProbeID_V_gi_bi] += m*(-(((devsign*sigvds)*d_ids_dV_gi_bi*(probeVars[admsProbeID_V_di_si])+(-((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))*d_Rdrain_dV_gi_bi/Rdrain/Rdrain))+(-((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))*d_Rsource_dV_gi_bi/Rsource/Rsource)));
d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_si] += m*(-(devsign*sigvds)*d_ids_dV_sbulk_si*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_di] += m*(-(devsign*sigvds)*d_ids_dV_dbulk_di*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_gm_di] += m*(-(devsign*sigvds)*d_ids_dV_gm_di*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_gm_si] += m*(-(devsign*sigvds)*d_ids_dV_gm_si*(probeVars[admsProbeID_V_di_si]));
// Pwr(t,GND) <+ (ddt(((m*delTemp1)*cth)))
dynamicContributions[admsNodeID_t] += (((m*delTemp1)*cth));
d_dynamicContributions[admsNodeID_t][admsProbeID_Temp_t_GND] += (m*d_delTemp1_dTemp_t_GND*cth);
}
else
{
// Pwr(t,GND) <+ ((m*((-(((devsign*sigvds)*ids)*V(di,si)))+(delTemp1*gth))))
staticContributions[admsNodeID_t] += (m*((-(((devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si])))+(delTemp1*gth)));
d_staticContributions[admsNodeID_t][admsProbeID_V_di_si] += m*(-((devsign*sigvds)*ids)*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si]);
d_staticContributions[admsNodeID_t][admsProbeID_V_si_bi] += m*(-(devsign*sigvds)*d_ids_dV_si_bi*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_di_bi] += m*(-(devsign*sigvds)*d_ids_dV_di_bi*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_Temp_t_GND] += m*((-(devsign*sigvds)*d_ids_dTemp_t_GND*(probeVars[admsProbeID_V_di_si]))+d_delTemp1_dTemp_t_GND*gth);
d_staticContributions[admsNodeID_t][admsProbeID_V_gi_bi] += m*(-(devsign*sigvds)*d_ids_dV_gi_bi*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_si] += m*(-(devsign*sigvds)*d_ids_dV_sbulk_si*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_di] += m*(-(devsign*sigvds)*d_ids_dV_dbulk_di*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_gm_di] += m*(-(devsign*sigvds)*d_ids_dV_gm_di*(probeVars[admsProbeID_V_di_si]));
d_staticContributions[admsNodeID_t][admsProbeID_V_gm_si] += m*(-(devsign*sigvds)*d_ids_dV_gm_si*(probeVars[admsProbeID_V_di_si]));
// Pwr(t,GND) <+ (ddt(((m*delTemp1)*cth)))
dynamicContributions[admsNodeID_t] += (((m*delTemp1)*cth));
d_dynamicContributions[admsNodeID_t][admsProbeID_Temp_t_GND] += (m*d_delTemp1_dTemp_t_GND*cth);
}
}
else
{
// Temp(t,GND) <+ (0)
// do nothing at all
}
if ((RBODYMOD!=0))
{
// I(bi,sbulk) <+ (((m*V(bi,sbulk))*Grbps))
staticContributions[admsNodeID_bi] += ((m*(probeVars[admsProbeID_V_bi_sbulk]))*Grbps);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_sbulk] += m*d_probeVars[admsProbeID_V_bi_sbulk][admsProbeID_V_bi_sbulk]*Grbps;
staticContributions[admsNodeID_sbulk] -= ((m*(probeVars[admsProbeID_V_bi_sbulk]))*Grbps);
d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_sbulk] -= m*d_probeVars[admsProbeID_V_bi_sbulk][admsProbeID_V_bi_sbulk]*Grbps;
// I(b,sbulk) <+ (((m*V(b,sbulk))*Grbsb))
staticContributions[admsNodeID_b] += ((m*(probeVars[admsProbeID_V_b_sbulk]))*Grbsb);
d_staticContributions[admsNodeID_b][admsProbeID_V_b_sbulk] += m*d_probeVars[admsProbeID_V_b_sbulk][admsProbeID_V_b_sbulk]*Grbsb;
staticContributions[admsNodeID_sbulk] -= ((m*(probeVars[admsProbeID_V_b_sbulk]))*Grbsb);
d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_sbulk] -= m*d_probeVars[admsProbeID_V_b_sbulk][admsProbeID_V_b_sbulk]*Grbsb;
// I(b,bi) <+ (((m*V(b,bi))*Grbpb))
staticContributions[admsNodeID_b] += ((m*(probeVars[admsProbeID_V_b_bi]))*Grbpb);
d_staticContributions[admsNodeID_b][admsProbeID_V_b_bi] += m*d_probeVars[admsProbeID_V_b_bi][admsProbeID_V_b_bi]*Grbpb;
staticContributions[admsNodeID_bi] -= ((m*(probeVars[admsProbeID_V_b_bi]))*Grbpb);
d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bi] -= m*d_probeVars[admsProbeID_V_b_bi][admsProbeID_V_b_bi]*Grbpb;
// I(b,dbulk) <+ (((m*V(b,dbulk))*Grbdb))
staticContributions[admsNodeID_b] += ((m*(probeVars[admsProbeID_V_b_dbulk]))*Grbdb);
d_staticContributions[admsNodeID_b][admsProbeID_V_b_dbulk] += m*d_probeVars[admsProbeID_V_b_dbulk][admsProbeID_V_b_dbulk]*Grbdb;
staticContributions[admsNodeID_dbulk] -= ((m*(probeVars[admsProbeID_V_b_dbulk]))*Grbdb);
d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_dbulk] -= m*d_probeVars[admsProbeID_V_b_dbulk][admsProbeID_V_b_dbulk]*Grbdb;
// I(bi,dbulk) <+ (((m*V(bi,dbulk))*Grbpd))
staticContributions[admsNodeID_bi] += ((m*(probeVars[admsProbeID_V_bi_dbulk]))*Grbpd);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_dbulk] += m*d_probeVars[admsProbeID_V_bi_dbulk][admsProbeID_V_bi_dbulk]*Grbpd;
staticContributions[admsNodeID_dbulk] -= ((m*(probeVars[admsProbeID_V_bi_dbulk]))*Grbpd);
d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_dbulk] -= m*d_probeVars[admsProbeID_V_bi_dbulk][admsProbeID_V_bi_dbulk]*Grbpd;
// I(sbulk,bi) <+ (white_noise(((m*Nt)*Grbps),"rbps"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[11]= ((m*Nt)*Grbps);
}
// I(sbulk,b) <+ (white_noise(((m*Nt)*Grbsb),"rbsb"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[12]= ((m*Nt)*Grbsb);
}
// I(b,bi) <+ (white_noise(((m*Nt)*Grbpb),"rbpb"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[13]= ((m*Nt)*Grbpb);
}
// I(dbulk,bi) <+ (white_noise(((m*Nt)*Grbpd),"rbpd"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[14]= ((m*Nt)*Grbpd);
}
// I(dbulk,b) <+ (white_noise(((m*Nt)*Grbdb),"rbdb"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[15]= ((m*Nt)*Grbdb);
}
}
else
{
// V(b,sbulk) <+ (0)
// do nothing at all
// V(b,bi) <+ (0)
// do nothing at all
// V(b,dbulk) <+ (0)
// do nothing at all
}
if ((RBODYMOD!=0))
{
// I(sbulk,si) <+ (((m*devsign)*Ibs))
staticContributions[admsNodeID_sbulk] += ((m*devsign)*Ibs);
d_staticContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND] += (m*devsign)*d_Ibs_dTemp_t_GND;
d_staticContributions[admsNodeID_sbulk][admsProbeID_V_si_bi] += (m*devsign)*d_Ibs_dV_si_bi;
d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] += (m*devsign)*d_Ibs_dV_di_bi;
d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] += (m*devsign)*d_Ibs_dV_gi_bi;
d_staticContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] += (m*devsign)*d_Ibs_dV_sbulk_si;
staticContributions[admsNodeID_si] -= ((m*devsign)*Ibs);
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= (m*devsign)*d_Ibs_dTemp_t_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] -= (m*devsign)*d_Ibs_dV_si_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -= (m*devsign)*d_Ibs_dV_di_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= (m*devsign)*d_Ibs_dV_gi_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= (m*devsign)*d_Ibs_dV_sbulk_si;
// I(dbulk,di) <+ (((m*devsign)*Ibd))
staticContributions[admsNodeID_dbulk] += ((m*devsign)*Ibd);
d_staticContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND] += (m*devsign)*d_Ibd_dTemp_t_GND;
d_staticContributions[admsNodeID_dbulk][admsProbeID_V_si_bi] += (m*devsign)*d_Ibd_dV_si_bi;
d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] += (m*devsign)*d_Ibd_dV_di_bi;
d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] += (m*devsign)*d_Ibd_dV_gi_bi;
d_staticContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] += (m*devsign)*d_Ibd_dV_sbulk_si;
d_staticContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] += (m*devsign)*d_Ibd_dV_dbulk_di;
staticContributions[admsNodeID_di] -= ((m*devsign)*Ibd);
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= (m*devsign)*d_Ibd_dTemp_t_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] -= (m*devsign)*d_Ibd_dV_si_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] -= (m*devsign)*d_Ibd_dV_di_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= (m*devsign)*d_Ibd_dV_gi_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si] -= (m*devsign)*d_Ibd_dV_sbulk_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di] -= (m*devsign)*d_Ibd_dV_dbulk_di;
// I(sbulk,si) <+ (((m*devsign)*ddt(Qbs)))
dynamicContributions[admsNodeID_sbulk] += ((m*devsign)*(Qbs));
d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_si_bi] += (m*devsign)*(d_Qbs_dV_si_bi);
d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] += (m*devsign)*(d_Qbs_dV_di_bi);
d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] += (m*devsign)*(d_Qbs_dV_gi_bi);
d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] += (m*devsign)*(d_Qbs_dV_sbulk_si);
d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_di] += (m*devsign)*(d_Qbs_dV_dbulk_di);
d_dynamicContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND] += (m*devsign)*(d_Qbs_dTemp_t_GND);
dynamicContributions[admsNodeID_si] -= ((m*devsign)*(Qbs));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] -= (m*devsign)*(d_Qbs_dV_si_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -= (m*devsign)*(d_Qbs_dV_di_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= (m*devsign)*(d_Qbs_dV_gi_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= (m*devsign)*(d_Qbs_dV_sbulk_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di] -= (m*devsign)*(d_Qbs_dV_dbulk_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= (m*devsign)*(d_Qbs_dTemp_t_GND);
// I(dbulk,di) <+ (((m*devsign)*ddt(Qbd)))
dynamicContributions[admsNodeID_dbulk] += ((m*devsign)*(Qbd));
d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_si_bi] += (m*devsign)*(d_Qbd_dV_si_bi);
d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] += (m*devsign)*(d_Qbd_dV_di_bi);
d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] += (m*devsign)*(d_Qbd_dV_gi_bi);
d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] += (m*devsign)*(d_Qbd_dV_sbulk_si);
d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] += (m*devsign)*(d_Qbd_dV_dbulk_di);
d_dynamicContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND] += (m*devsign)*(d_Qbd_dTemp_t_GND);
dynamicContributions[admsNodeID_di] -= ((m*devsign)*(Qbd));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] -= (m*devsign)*(d_Qbd_dV_si_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -= (m*devsign)*(d_Qbd_dV_di_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= (m*devsign)*(d_Qbd_dV_gi_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si] -= (m*devsign)*(d_Qbd_dV_sbulk_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di] -= (m*devsign)*(d_Qbd_dV_dbulk_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= (m*devsign)*(d_Qbd_dTemp_t_GND);
}
else
{
// I(bi,si) <+ (((m*devsign)*Ibs))
staticContributions[admsNodeID_bi] += ((m*devsign)*Ibs);
d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] += (m*devsign)*d_Ibs_dTemp_t_GND;
d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] += (m*devsign)*d_Ibs_dV_si_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] += (m*devsign)*d_Ibs_dV_di_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] += (m*devsign)*d_Ibs_dV_gi_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] += (m*devsign)*d_Ibs_dV_sbulk_si;
staticContributions[admsNodeID_si] -= ((m*devsign)*Ibs);
d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= (m*devsign)*d_Ibs_dTemp_t_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] -= (m*devsign)*d_Ibs_dV_si_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -= (m*devsign)*d_Ibs_dV_di_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= (m*devsign)*d_Ibs_dV_gi_bi;
d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= (m*devsign)*d_Ibs_dV_sbulk_si;
// I(bi,di) <+ (((m*devsign)*Ibd))
staticContributions[admsNodeID_bi] += ((m*devsign)*Ibd);
d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] += (m*devsign)*d_Ibd_dTemp_t_GND;
d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] += (m*devsign)*d_Ibd_dV_si_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] += (m*devsign)*d_Ibd_dV_di_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] += (m*devsign)*d_Ibd_dV_gi_bi;
d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] += (m*devsign)*d_Ibd_dV_sbulk_si;
d_staticContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] += (m*devsign)*d_Ibd_dV_dbulk_di;
staticContributions[admsNodeID_di] -= ((m*devsign)*Ibd);
d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= (m*devsign)*d_Ibd_dTemp_t_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] -= (m*devsign)*d_Ibd_dV_si_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] -= (m*devsign)*d_Ibd_dV_di_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= (m*devsign)*d_Ibd_dV_gi_bi;
d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si] -= (m*devsign)*d_Ibd_dV_sbulk_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di] -= (m*devsign)*d_Ibd_dV_dbulk_di;
// I(bi,si) <+ (((m*devsign)*ddt(Qbs)))
dynamicContributions[admsNodeID_bi] += ((m*devsign)*(Qbs));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi] += (m*devsign)*(d_Qbs_dV_si_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] += (m*devsign)*(d_Qbs_dV_di_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] += (m*devsign)*(d_Qbs_dV_gi_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] += (m*devsign)*(d_Qbs_dV_sbulk_si);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] += (m*devsign)*(d_Qbs_dV_dbulk_di);
d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] += (m*devsign)*(d_Qbs_dTemp_t_GND);
dynamicContributions[admsNodeID_si] -= ((m*devsign)*(Qbs));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] -= (m*devsign)*(d_Qbs_dV_si_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -= (m*devsign)*(d_Qbs_dV_di_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] -= (m*devsign)*(d_Qbs_dV_gi_bi);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si] -= (m*devsign)*(d_Qbs_dV_sbulk_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di] -= (m*devsign)*(d_Qbs_dV_dbulk_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND] -= (m*devsign)*(d_Qbs_dTemp_t_GND);
// I(bi,di) <+ (((m*devsign)*ddt(Qbd)))
dynamicContributions[admsNodeID_bi] += ((m*devsign)*(Qbd));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi] += (m*devsign)*(d_Qbd_dV_si_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] += (m*devsign)*(d_Qbd_dV_di_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] += (m*devsign)*(d_Qbd_dV_gi_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] += (m*devsign)*(d_Qbd_dV_sbulk_si);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] += (m*devsign)*(d_Qbd_dV_dbulk_di);
d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] += (m*devsign)*(d_Qbd_dTemp_t_GND);
dynamicContributions[admsNodeID_di] -= ((m*devsign)*(Qbd));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] -= (m*devsign)*(d_Qbd_dV_si_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -= (m*devsign)*(d_Qbd_dV_di_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] -= (m*devsign)*(d_Qbd_dV_gi_bi);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si] -= (m*devsign)*(d_Qbd_dV_sbulk_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di] -= (m*devsign)*(d_Qbd_dV_dbulk_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND] -= (m*devsign)*(d_Qbd_dTemp_t_GND);
}


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_bi_dbulk] =  "
         <<probeVars[admsProbeID_V_bi_dbulk] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_dbulk] =  "
         <<probeVars[admsProbeID_V_b_dbulk] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_bi] =  "
         <<probeVars[admsProbeID_V_b_bi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_sbulk] =  "
         <<probeVars[admsProbeID_V_b_sbulk] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_sbulk] =  "
         <<probeVars[admsProbeID_V_bi_sbulk] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_gi] =  "
         <<probeVars[admsProbeID_V_gm_gi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_gm] =  "
         <<probeVars[admsProbeID_V_g_gm] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_si] =  "
         <<probeVars[admsProbeID_V_s_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_di] =  "
         <<probeVars[admsProbeID_V_d_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_si] =  "
         <<probeVars[admsProbeID_V_gi_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_si] =  "
         <<probeVars[admsProbeID_V_di_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_dbulk_GND] =  "
         <<probeVars[admsProbeID_V_dbulk_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_sbulk_GND] =  "
         <<probeVars[admsProbeID_V_sbulk_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_GND] =  "
         <<probeVars[admsProbeID_V_gm_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_GND] =  "
         <<probeVars[admsProbeID_V_gi_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_GND] =  "
         <<probeVars[admsProbeID_V_bi_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_GND] =  "
         <<probeVars[admsProbeID_V_di_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_GND] =  "
         <<probeVars[admsProbeID_V_si_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_bi] =  "
         <<probeVars[admsProbeID_V_gm_bi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_N1_GND] =  "
         <<probeVars[admsProbeID_V_N1_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_N2_GND] =  "
         <<probeVars[admsProbeID_V_N2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_si] =  "
         <<probeVars[admsProbeID_V_gm_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gm_di] =  "
         <<probeVars[admsProbeID_V_gm_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_dbulk_di] =  "
         <<probeVars[admsProbeID_V_dbulk_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_sbulk_si] =  "
         <<probeVars[admsProbeID_V_sbulk_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_bi] =  "
         <<probeVars[admsProbeID_V_si_bi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_bi] =  "
         <<probeVars[admsProbeID_V_di_bi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_bi] =  "
         <<probeVars[admsProbeID_V_gi_bi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_Temp_t_GND] =  "
         <<probeVars[admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_d] =  "
         <<staticContributions[admsNodeID_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_d] =  "
         <<dynamicContributions[admsNodeID_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_g] =  "
         <<staticContributions[admsNodeID_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_g] =  "
         <<dynamicContributions[admsNodeID_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
         <<staticContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
         <<dynamicContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
         <<staticContributions[admsNodeID_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
         <<dynamicContributions[admsNodeID_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_t] =  "
         <<staticContributions[admsNodeID_t] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_t][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_t] =  "
         <<dynamicContributions[admsNodeID_t] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_t].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_t][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_di] =  "
         <<staticContributions[admsNodeID_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_di] =  "
         <<dynamicContributions[admsNodeID_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
         <<staticContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
         <<dynamicContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_gi] =  "
         <<staticContributions[admsNodeID_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_gi] =  "
         <<dynamicContributions[admsNodeID_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_gm] =  "
         <<staticContributions[admsNodeID_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_gm][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_gm] =  "
         <<dynamicContributions[admsNodeID_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gm].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_gm][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
         <<staticContributions[admsNodeID_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
         <<dynamicContributions[admsNodeID_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_sbulk] =  "
         <<staticContributions[admsNodeID_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_sbulk] =  "
         <<dynamicContributions[admsNodeID_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_sbulk].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dbulk] =  "
         <<staticContributions[admsNodeID_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dbulk] =  "
         <<dynamicContributions[admsNodeID_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dbulk].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_N1] =  "
         <<staticContributions[admsNodeID_N1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_N1][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_N1] =  "
         <<dynamicContributions[admsNodeID_N1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N1].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_N1][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_N2] =  "
         <<staticContributions[admsNodeID_N2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_bi_dbulk) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_dbulk) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_bi) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_b_sbulk) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_bi_sbulk) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_gi) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_g_gm) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_bi) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_N1_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_si) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gm_di) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND) =  " <<d_staticContributions[admsNodeID_N2][admsProbeID_Temp_t_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_N2] =  "
         <<dynamicContributions[admsNodeID_N2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_bi_dbulk) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_bi_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_dbulk) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_b_dbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_bi) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_b_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_b_sbulk) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_b_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_bi_sbulk) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_bi_sbulk] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_gi) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gm_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_g_gm) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_g_gm] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_dbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_sbulk_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gm_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_bi) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gm_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_N1_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_N1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_N2_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_N2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_si) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gm_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gm_di) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gm_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_dbulk_di) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_dbulk_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_sbulk_si) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_sbulk_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_si_bi) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_si_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_di_bi) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_di_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_V_gi_bi) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_V_gi_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_N2].dx(admsProbeID_Temp_t_GND) =  " <<d_dynamicContributions[admsNodeID_N2][admsProbeID_Temp_t_GND] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 5 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 14; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 5 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
return 16;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
int numSources=getNumNoiseSources();
noiseData.numSources = numSources;
noiseData.resize(numSources);

noiseData.deviceName = getName().getEncodedName();
std::string theNoiseName;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_di_si")+std::string("_")+std::string("1overf");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[0]=theNoiseName;
noiseData.li_Pos[0]=li_di;
noiseData.li_Neg[0]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_di_si")+std::string("_")+std::string("id");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[1]=theNoiseName;
noiseData.li_Pos[1]=li_di;
noiseData.li_Neg[1]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_N2_GND")+std::string("_")+std::string("corl");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[2]=theNoiseName;
noiseData.li_Pos[2]=li_N2;
noiseData.li_Neg[2]=-1;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_N1_GND")+std::string("_")+std::string("corl");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[3]=theNoiseName;
noiseData.li_Pos[3]=li_N1;
noiseData.li_Neg[3]=-1;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_di_si")+std::string("_")+std::string("id");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[4]=theNoiseName;
noiseData.li_Pos[4]=li_di;
noiseData.li_Neg[4]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_gi_si")+std::string("_")+std::string("igs");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[5]=theNoiseName;
noiseData.li_Pos[5]=li_gi;
noiseData.li_Neg[5]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_gi_di")+std::string("_")+std::string("igd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[6]=theNoiseName;
noiseData.li_Pos[6]=li_gi;
noiseData.li_Neg[6]=li_di;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_gi_bi")+std::string("_")+std::string("igb");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[7]=theNoiseName;
noiseData.li_Pos[7]=li_gi;
noiseData.li_Neg[7]=li_bi;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_d_di")+std::string("_")+std::string("rd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[8]=theNoiseName;
noiseData.li_Pos[8]=li_d;
noiseData.li_Neg[8]=li_di;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_s_si")+std::string("_")+std::string("rs");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[9]=theNoiseName;
noiseData.li_Pos[9]=li_s;
noiseData.li_Neg[9]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_gm")+std::string("_")+std::string("rg");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[10]=theNoiseName;
noiseData.li_Pos[10]=li_g;
noiseData.li_Neg[10]=li_gm;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_sbulk_bi")+std::string("_")+std::string("rbps");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[11]=theNoiseName;
noiseData.li_Pos[11]=li_sbulk;
noiseData.li_Neg[11]=li_bi;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_sbulk_b")+std::string("_")+std::string("rbsb");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[12]=theNoiseName;
noiseData.li_Pos[12]=li_sbulk;
noiseData.li_Neg[12]=li_b;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b_bi")+std::string("_")+std::string("rbpb");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[13]=theNoiseName;
noiseData.li_Pos[13]=li_b;
noiseData.li_Neg[13]=li_bi;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_dbulk_bi")+std::string("_")+std::string("rbpd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[14]=theNoiseName;
noiseData.li_Pos[14]=li_dbulk;
noiseData.li_Neg[14]=li_bi;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_dbulk_b")+std::string("_")+std::string("rbdb");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[15]=theNoiseName;
noiseData.li_Pos[15]=li_dbulk;
noiseData.li_Neg[15]=li_b;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];

      noiseData.noiseDens[0] /= pow(noiseData.freq,noiseContribsExponent[0]);noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
noiseData.noiseDens[1] = noiseContribsPower[1];
noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
noiseData.noiseDens[2] = noiseContribsPower[2];
noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
noiseData.noiseDens[3] = noiseContribsPower[3];
noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
noiseData.noiseDens[4] = noiseContribsPower[4];
noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
noiseData.noiseDens[5] = noiseContribsPower[5];
noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
noiseData.noiseDens[6] = noiseContribsPower[6];
noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
noiseData.noiseDens[7] = noiseContribsPower[7];
noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
noiseData.noiseDens[8] = noiseContribsPower[8];
noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
noiseData.noiseDens[9] = noiseContribsPower[9];
noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
noiseData.noiseDens[10] = noiseContribsPower[10];
noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
noiseData.noiseDens[11] = noiseContribsPower[11];
noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
noiseData.noiseDens[12] = noiseContribsPower[12];
noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
noiseData.noiseDens[13] = noiseContribsPower[13];
noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
noiseData.noiseDens[14] = noiseContribsPower[14];
noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
noiseData.noiseDens[15] = noiseContribsPower[15];
noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
if (!collapseNode_t)
{
  (*f_di_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  (*f_si_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND];
}
  (*f_di_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_gm_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi];
  (*f_di_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi];
  (*f_si_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_gm_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi];
  (*f_si_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi];
  (*f_di_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_gm_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi];
  (*f_si_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_gm_di] -d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi];
  (*f_di_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi];
  (*f_si_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi];
  (*f_di_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si];
  (*f_si_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si];
  (*f_di_Equ_dbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di];
  (*f_si_Equ_dbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_di];
  (*f_N2_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_sbulk_si];
  (*f_N2_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_si_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_sbulk_si];
  (*f_N2_Equ_dbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_dbulk_di];
  (*f_N2_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_dbulk_di];
if (!collapseNode_t)
{
  (*f_N2_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_N2][admsProbeID_Temp_t_GND];
}
  (*f_N2_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_N2][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_si_bi];
  (*f_N2_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_gi_bi];
  (*f_N1_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  (*f_N1_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_si_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  (*f_N1_Equ_dbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  (*f_N1_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  (*f_N1_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_si_bi];
  (*f_N1_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  (*f_N1_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_Temp_t_GND];
}
  (*f_N1_Equ_N2_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_N2_GND];
  (*f_N1_Equ_N1_Node_Ptr) +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_N1_GND];
  (*f_di_Equ_N2_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_N2_GND];
  (*f_si_Equ_N2_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_N2_GND];
  (*f_gi_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi];
  (*f_gi_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi];
if (!collapseNode_t)
{
  (*f_gi_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_gi][admsProbeID_Temp_t_GND];
}
  (*f_gi_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi];
  (*f_gi_Equ_gi_Node_Ptr) +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_gi] +d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi];
  (*f_N2_Equ_N2_Node_Ptr) +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_N2_GND];
if (!collapseNode_t)
{
  (*f_bi_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND];
}
  (*f_bi_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  (*f_bi_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_dbulk] -d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bi] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_sbulk] -d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  (*f_bi_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi];
  (*f_bi_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi];
  (*f_bi_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_sbulk];
  (*f_bi_Equ_dbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_dbulk];
  (*f_gm_Equ_gm_Node_Ptr) +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_gi] -d_staticContributions[admsNodeID_gm][admsProbeID_V_g_gm];
  (*f_gm_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_si_bi];
  (*f_si_Equ_gm_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_gm_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_gm_di];
  (*f_gm_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_gm][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_gm][admsProbeID_V_si_bi];
  (*f_gm_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_di_bi];
  (*f_gm_Equ_gi_Node_Ptr) +=  -d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_gi] +d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  (*f_gm_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_gm][admsProbeID_Temp_t_GND];
}
  (*f_di_Equ_gm_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_gm_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_gm_di];
  (*f_d_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_si_bi];
  (*f_d_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_d][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_d][admsProbeID_V_si_bi];
  (*f_d_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] +d_staticContributions[admsNodeID_d][admsProbeID_V_di_bi];
  (*f_d_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  (*f_d_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_Temp_t_GND];
}
  (*f_d_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_d_di];
  (*f_di_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_d_di];
  (*f_s_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] +d_staticContributions[admsNodeID_s][admsProbeID_V_si_bi];
  (*f_s_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_s][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_s][admsProbeID_V_si_bi];
  (*f_s_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_di_bi];
  (*f_s_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  (*f_s_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_Temp_t_GND];
}
  (*f_s_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_s_si];
  (*f_si_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_s_si];
if (!collapseNode_t)
{
  (*f_g_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_Temp_t_GND];
}
  (*f_g_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_si_bi];
  (*f_g_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_g][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_g][admsProbeID_V_si_bi];
  (*f_g_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_di_bi];
  (*f_g_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_gi_bi];
  (*f_g_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_g_gm];
  (*f_g_Equ_gm_Node_Ptr) +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_g_gm];
  (*f_gm_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_g_gm];
  (*f_gi_Equ_gm_Node_Ptr) +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_gi];
if (!collapseNode_t)
{
  (*f_t_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_s_si];
}
if (!collapseNode_t)
{
  (*f_t_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_t][admsProbeID_V_gm_si] -d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_t][admsProbeID_V_si_bi] -d_staticContributions[admsNodeID_t][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_t][admsProbeID_V_s_si];
}
if (!collapseNode_t)
{
  (*f_t_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_d_di];
}
if (!collapseNode_t)
{
  (*f_t_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_t][admsProbeID_V_gm_di] -d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_t][admsProbeID_V_di_bi] +d_staticContributions[admsNodeID_t][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_t][admsProbeID_V_d_di];
}
if (!collapseNode_t)
{
  (*f_t_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_t][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_t][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_t][admsProbeID_V_si_bi];
}
if (!collapseNode_t)
{
  (*f_t_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_t][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  (*f_t_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_gi_bi];
}
if (!collapseNode_t)
{
  (*f_t_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_si];
}
if (!collapseNode_t)
{
  (*f_t_Equ_dbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_di];
}
if (!collapseNode_t)
{
  (*f_t_Equ_gm_Node_Ptr) +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_gm_si] +d_staticContributions[admsNodeID_t][admsProbeID_V_gm_di];
}
  (*f_sbulk_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_si_bi] +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_sbulk];
  (*f_sbulk_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_sbulk] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_sbulk];
  (*f_b_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_dbulk] +d_staticContributions[admsNodeID_b][admsProbeID_V_b_bi] +d_staticContributions[admsNodeID_b][admsProbeID_V_b_sbulk];
  (*f_b_Equ_sbulk_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_sbulk];
  (*f_sbulk_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_sbulk];
  (*f_b_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_bi];
  (*f_bi_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bi];
  (*f_b_Equ_dbulk_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_dbulk];
  (*f_dbulk_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_dbulk];
  (*f_dbulk_Equ_dbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_dbulk] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_dbulk];
  (*f_dbulk_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_si_bi] +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_dbulk];
if (!collapseNode_t)
{
  (*f_sbulk_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  (*f_b_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  (*f_dbulk_Equ_t_Node_Ptr) +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND];
}
  (*f_sbulk_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_si_bi];
  (*f_sbulk_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_bi];
  (*f_sbulk_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi];
  (*f_dbulk_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_si_bi];
  (*f_dbulk_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_bi];
  (*f_dbulk_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi];
  (*f_dbulk_Equ_sbulk_Node_Ptr) +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si];

#else
  //use the offsets instead of pointers
if (!collapseNode_t)
{
  dFdx[li_di][A_di_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  dFdx[li_si][A_si_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_Temp_t_GND];
}
  dFdx[li_di][A_di_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_gm_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi];
  dFdx[li_di][A_di_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_di][admsProbeID_V_si_bi];
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_gm_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi];
  dFdx[li_si][A_si_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_bi];
  dFdx[li_di][A_di_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_gm_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_di][admsProbeID_V_di_bi];
  dFdx[li_si][A_si_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_gm_di] -d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_si][admsProbeID_V_di_bi];
  dFdx[li_di][A_di_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_gi_bi];
  dFdx[li_si][A_si_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_gi_bi];
  dFdx[li_di][A_di_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_sbulk_si];
  dFdx[li_si][A_si_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_sbulk_si];
  dFdx[li_di][A_di_Equ_dbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_dbulk_di];
  dFdx[li_si][A_si_Equ_dbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_dbulk_di];
  dFdx[li_N2][A_N2_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_sbulk_si];
  dFdx[li_N2][A_N2_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_si_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_sbulk_si];
  dFdx[li_N2][A_N2_Equ_dbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_dbulk_di];
  dFdx[li_N2][A_N2_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_dbulk_di];
if (!collapseNode_t)
{
  dFdx[li_N2][A_N2_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_N2][admsProbeID_Temp_t_GND];
}
  dFdx[li_N2][A_N2_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_N2][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N2][admsProbeID_V_si_bi];
  dFdx[li_N2][A_N2_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_gi_bi];
  dFdx[li_N1][A_N1_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  dFdx[li_N1][A_N1_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_si_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  dFdx[li_N1][A_N1_Equ_dbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  dFdx[li_N1][A_N1_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  dFdx[li_N1][A_N1_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_N1][admsProbeID_V_si_bi];
  dFdx[li_N1][A_N1_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  dFdx[li_N1][A_N1_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_Temp_t_GND];
}
  dFdx[li_N1][A_N1_Equ_N2_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_N2_GND];
  dFdx[li_N1][A_N1_Equ_N1_NodeOffset] +=  +d_staticContributions[admsNodeID_N1][admsProbeID_V_N1_GND];
  dFdx[li_di][A_di_Equ_N2_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_N2_GND];
  dFdx[li_si][A_si_Equ_N2_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_N2_GND];
  dFdx[li_gi][A_gi_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi];
  dFdx[li_gi][A_gi_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi];
if (!collapseNode_t)
{
  dFdx[li_gi][A_gi_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_gi][admsProbeID_Temp_t_GND];
}
  dFdx[li_gi][A_gi_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_gi][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_gi][admsProbeID_V_si_bi];
  dFdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_gi] +d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_bi];
  dFdx[li_N2][A_N2_Equ_N2_NodeOffset] +=  +d_staticContributions[admsNodeID_N2][admsProbeID_V_N2_GND];
if (!collapseNode_t)
{
  dFdx[li_bi][A_bi_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_Temp_t_GND];
}
  dFdx[li_bi][A_bi_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_dbulk] -d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bi] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_sbulk] -d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  dFdx[li_bi][A_bi_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_bi][admsProbeID_V_di_bi];
  dFdx[li_bi][A_bi_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_gi_bi];
  dFdx[li_bi][A_bi_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_sbulk];
  dFdx[li_bi][A_bi_Equ_dbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_dbulk];
  dFdx[li_gm][A_gm_Equ_gm_NodeOffset] +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_gi] -d_staticContributions[admsNodeID_gm][admsProbeID_V_g_gm];
  dFdx[li_gm][A_gm_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_si_bi];
  dFdx[li_si][A_si_Equ_gm_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_gm_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_gm_di];
  dFdx[li_gm][A_gm_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_gm][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_gm][admsProbeID_V_si_bi];
  dFdx[li_gm][A_gm_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_di_bi];
  dFdx[li_gm][A_gm_Equ_gi_NodeOffset] +=  -d_staticContributions[admsNodeID_gm][admsProbeID_V_gm_gi] +d_staticContributions[admsNodeID_gm][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  dFdx[li_gm][A_gm_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_gm][admsProbeID_Temp_t_GND];
}
  dFdx[li_di][A_di_Equ_gm_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_gm_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_gm_di];
  dFdx[li_d][A_d_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_si_bi];
  dFdx[li_d][A_d_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_d][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_d][admsProbeID_V_si_bi];
  dFdx[li_d][A_d_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] +d_staticContributions[admsNodeID_d][admsProbeID_V_di_bi];
  dFdx[li_d][A_d_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  dFdx[li_d][A_d_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_Temp_t_GND];
}
  dFdx[li_d][A_d_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_d_di];
  dFdx[li_di][A_di_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_d_di];
  dFdx[li_s][A_s_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] +d_staticContributions[admsNodeID_s][admsProbeID_V_si_bi];
  dFdx[li_s][A_s_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_s][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_s][admsProbeID_V_si_bi];
  dFdx[li_s][A_s_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_di_bi];
  dFdx[li_s][A_s_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  dFdx[li_s][A_s_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_Temp_t_GND];
}
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_s_si];
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_s_si];
if (!collapseNode_t)
{
  dFdx[li_g][A_g_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_Temp_t_GND];
}
  dFdx[li_g][A_g_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_si_bi];
  dFdx[li_g][A_g_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_g][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_g][admsProbeID_V_si_bi];
  dFdx[li_g][A_g_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_di_bi];
  dFdx[li_g][A_g_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_gi_bi];
  dFdx[li_g][A_g_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_g_gm];
  dFdx[li_g][A_g_Equ_gm_NodeOffset] +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_g_gm];
  dFdx[li_gm][A_gm_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_gm][admsProbeID_V_g_gm];
  dFdx[li_gi][A_gi_Equ_gm_NodeOffset] +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_gm_gi];
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_s_si];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_t][admsProbeID_V_gm_si] -d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_t][admsProbeID_V_si_bi] -d_staticContributions[admsNodeID_t][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_t][admsProbeID_V_s_si];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_d_di];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_t][admsProbeID_V_gm_di] -d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_t][admsProbeID_V_di_bi] +d_staticContributions[admsNodeID_t][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_t][admsProbeID_V_d_di];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_t][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_t][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_t][admsProbeID_V_si_bi];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_t][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_gi_bi];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_sbulk_si];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_dbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_dbulk_di];
}
if (!collapseNode_t)
{
  dFdx[li_t][A_t_Equ_gm_NodeOffset] +=  +d_staticContributions[admsNodeID_t][admsProbeID_V_gm_si] +d_staticContributions[admsNodeID_t][admsProbeID_V_gm_di];
}
  dFdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_si_bi] +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_sbulk];
  dFdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_sbulk] -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_bi_sbulk];
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_dbulk] +d_staticContributions[admsNodeID_b][admsProbeID_V_b_bi] +d_staticContributions[admsNodeID_b][admsProbeID_V_b_sbulk];
  dFdx[li_b][A_b_Equ_sbulk_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_sbulk];
  dFdx[li_sbulk][A_sbulk_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_b_sbulk];
  dFdx[li_b][A_b_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_bi];
  dFdx[li_bi][A_bi_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bi];
  dFdx[li_b][A_b_Equ_dbulk_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_dbulk];
  dFdx[li_dbulk][A_dbulk_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_dbulk];
  dFdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_dbulk] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_b_dbulk];
  dFdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_si_bi] +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_bi_dbulk];
if (!collapseNode_t)
{
  dFdx[li_sbulk][A_sbulk_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  dFdx[li_b][A_b_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  dFdx[li_dbulk][A_dbulk_Equ_t_NodeOffset] +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND];
}
  dFdx[li_sbulk][A_sbulk_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_si_bi];
  dFdx[li_sbulk][A_sbulk_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_di_bi];
  dFdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi];
  dFdx[li_dbulk][A_dbulk_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_si_bi];
  dFdx[li_dbulk][A_dbulk_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_di_bi];
  dFdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi];
  dFdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset] +=  +d_staticContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
if (!collapseNode_t)
{
  (*q_di_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  (*q_si_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND];
}
  (*q_di_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si];
  (*q_di_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi];
  (*q_si_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_si] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si];
  (*q_si_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi];
  (*q_di_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_di] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di];
  (*q_si_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di];
  (*q_di_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi];
  (*q_si_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi];
  (*q_di_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si];
  (*q_si_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si];
  (*q_di_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di];
  (*q_si_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di];
  (*q_N1_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  (*q_N1_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  (*q_N1_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  (*q_N1_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  (*q_N1_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_si_bi];
  (*q_N1_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  (*q_N1_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_Temp_t_GND];
}
  (*q_N1_Equ_N1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_N1_GND];
  (*q_gi_Equ_N1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_N1_GND];
  (*q_si_Equ_N1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_N1_GND];
  (*q_gi_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si];
  (*q_gi_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si];
  (*q_gi_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di];
  (*q_gi_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di];
if (!collapseNode_t)
{
  (*q_gi_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_t_GND];
}
  (*q_gi_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi];
  (*q_gi_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi];
  (*q_di_Equ_N1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_N1_GND];
if (!collapseNode_t)
{
  (*q_bi_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND];
}
  (*q_bi_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  (*q_bi_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_bi] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  (*q_bi_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi];
  (*q_bi_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi];
  (*q_bi_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si];
  (*q_bi_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di];
  (*q_gm_Equ_gm_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_bi] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_di] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_si];
  (*q_gm_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_si];
  (*q_si_Equ_gm_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_si];
  (*q_gm_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_bi];
  (*q_gm_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_di] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_bi];
  (*q_gm_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_bi];
  (*q_gm_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_si];
  (*q_gm_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_di];
if (!collapseNode_t)
{
  (*q_gm_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_Temp_t_GND];
}
  (*q_di_Equ_gm_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_di];
  (*q_bi_Equ_gm_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_bi];
if (!collapseNode_t)
{
  (*q_t_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_t][admsProbeID_Temp_t_GND];
}
  (*q_sbulk_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_si_bi];
  (*q_sbulk_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si];
  (*q_dbulk_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di];
  (*q_dbulk_Equ_bi_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_si_bi];
if (!collapseNode_t)
{
  (*q_sbulk_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  (*q_dbulk_Equ_t_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND];
}
  (*q_sbulk_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_si_bi];
  (*q_sbulk_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_bi];
  (*q_sbulk_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi];
  (*q_dbulk_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_si_bi];
  (*q_dbulk_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_bi];
  (*q_dbulk_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi];
  (*q_dbulk_Equ_sbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si];
  (*q_sbulk_Equ_dbulk_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_di];

#else
  //use the offsets instead of pointers
if (!collapseNode_t)
{
  dQdx[li_di][A_di_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  dQdx[li_si][A_si_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_t_GND];
}
  dQdx[li_di][A_di_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si];
  dQdx[li_di][A_di_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_bi];
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_si] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si];
  dQdx[li_si][A_si_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_bi];
  dQdx[li_di][A_di_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_di] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di];
  dQdx[li_si][A_si_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di];
  dQdx[li_di][A_di_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_bi];
  dQdx[li_si][A_si_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_bi];
  dQdx[li_di][A_di_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_sbulk_si];
  dQdx[li_si][A_si_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_sbulk_si];
  dQdx[li_di][A_di_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_dbulk_di];
  dQdx[li_si][A_si_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_dbulk_di];
  dQdx[li_N1][A_N1_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  dQdx[li_N1][A_N1_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_sbulk_si];
  dQdx[li_N1][A_N1_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  dQdx[li_N1][A_N1_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_dbulk_di];
  dQdx[li_N1][A_N1_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_N1][admsProbeID_V_si_bi];
  dQdx[li_N1][A_N1_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_gi_bi];
if (!collapseNode_t)
{
  dQdx[li_N1][A_N1_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_Temp_t_GND];
}
  dQdx[li_N1][A_N1_Equ_N1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_N1][admsProbeID_V_N1_GND];
  dQdx[li_gi][A_gi_Equ_N1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_N1_GND];
  dQdx[li_si][A_si_Equ_N1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_N1_GND];
  dQdx[li_gi][A_gi_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si];
  dQdx[li_gi][A_gi_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_sbulk_si];
  dQdx[li_gi][A_gi_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di];
  dQdx[li_gi][A_gi_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_dbulk_di];
if (!collapseNode_t)
{
  dQdx[li_gi][A_gi_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_t_GND];
}
  dQdx[li_gi][A_gi_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_bi];
  dQdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_bi];
  dQdx[li_di][A_di_Equ_N1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_N1_GND];
if (!collapseNode_t)
{
  dQdx[li_bi][A_bi_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_Temp_t_GND];
}
  dQdx[li_bi][A_bi_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_bi] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_bi];
  dQdx[li_bi][A_bi_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_di_bi];
  dQdx[li_bi][A_bi_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gi_bi];
  dQdx[li_bi][A_bi_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_sbulk_si];
  dQdx[li_bi][A_bi_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_dbulk_di];
  dQdx[li_gm][A_gm_Equ_gm_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_bi] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_di] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_si];
  dQdx[li_gm][A_gm_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_si];
  dQdx[li_si][A_si_Equ_gm_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gm_si];
  dQdx[li_gm][A_gm_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_si_bi];
  dQdx[li_gm][A_gm_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gm_di] -d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_di_bi];
  dQdx[li_gm][A_gm_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_gi_bi];
  dQdx[li_gm][A_gm_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_sbulk_si];
  dQdx[li_gm][A_gm_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_V_dbulk_di];
if (!collapseNode_t)
{
  dQdx[li_gm][A_gm_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gm][admsProbeID_Temp_t_GND];
}
  dQdx[li_di][A_di_Equ_gm_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gm_di];
  dQdx[li_bi][A_bi_Equ_gm_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_gm_bi];
if (!collapseNode_t)
{
  dQdx[li_t][A_t_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_t][admsProbeID_Temp_t_GND];
}
  dQdx[li_sbulk][A_sbulk_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_si_bi];
  dQdx[li_sbulk][A_sbulk_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si];
  dQdx[li_dbulk][A_dbulk_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di];
  dQdx[li_dbulk][A_dbulk_Equ_bi_NodeOffset] +=  -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi] -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_bi] -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_si_bi];
if (!collapseNode_t)
{
  dQdx[li_sbulk][A_sbulk_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_Temp_t_GND];
}
if (!collapseNode_t)
{
  dQdx[li_dbulk][A_dbulk_Equ_t_NodeOffset] +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_Temp_t_GND];
}
  dQdx[li_sbulk][A_sbulk_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_si_bi];
  dQdx[li_sbulk][A_sbulk_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_di_bi];
  dQdx[li_sbulk][A_sbulk_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_gi_bi];
  dQdx[li_dbulk][A_dbulk_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si] +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_si_bi];
  dQdx[li_dbulk][A_dbulk_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_dbulk_di] +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_di_bi];
  dQdx[li_dbulk][A_dbulk_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_gi_bi];
  dQdx[li_dbulk][A_dbulk_Equ_sbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_dbulk][admsProbeID_V_sbulk_si];
  dQdx[li_sbulk][A_sbulk_Equ_dbulk_NodeOffset] +=  +d_dynamicContributions[admsNodeID_sbulk][admsProbeID_V_dbulk_di];


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

// set internal model type based on model card type
if (getType() == "pmos" || getType() == "PMOS")
    TYPE = -1;
  if (!given("TOXP"))
  {
  TOXP = TOXE;
  }
  if (!given("NDEPCV"))
  {
  NDEPCV = NDEP;
  }
  if (!given("NDEPCVL1"))
  {
  NDEPCVL1 = NDEPL1;
  }
  if (!given("NDEPCVLEXP1"))
  {
  NDEPCVLEXP1 = NDEPLEXP1;
  }
  if (!given("NDEPCVL2"))
  {
  NDEPCVL2 = NDEPL2;
  }
  if (!given("NDEPCVLEXP2"))
  {
  NDEPCVLEXP2 = NDEPLEXP2;
  }
  if (!given("NDEPCVW"))
  {
  NDEPCVW = NDEPW;
  }
  if (!given("NDEPCVWEXP"))
  {
  NDEPCVWEXP = NDEPWEXP;
  }
  if (!given("NDEPCVWL"))
  {
  NDEPCVWL = NDEPWL;
  }
  if (!given("NDEPCVWLEXP"))
  {
  NDEPCVWLEXP = NDEPWLEXP;
  }
  if (!given("LNDEPCV"))
  {
  LNDEPCV = LNDEP;
  }
  if (!given("WNDEPCV"))
  {
  WNDEPCV = WNDEP;
  }
  if (!given("PNDEPCV"))
  {
  PNDEPCV = PNDEP;
  }
  if (!given("VFBCV"))
  {
  VFBCV = VFB;
  }
  if (!given("LVFBCV"))
  {
  LVFBCV = LVFB;
  }
  if (!given("WVFBCV"))
  {
  WVFBCV = WVFB;
  }
  if (!given("PVFBCV"))
  {
  PVFBCV = PVFB;
  }
  if (!given("DWJ"))
  {
  DWJ = DWC;
  }
  if (!given("ETA0R"))
  {
  ETA0R = ETA0;
  }
  if (!given("LETA0R"))
  {
  LETA0R = LETA0;
  }
  if (!given("WETA0R"))
  {
  WETA0R = WETA0;
  }
  if (!given("PETA0R"))
  {
  PETA0R = PETA0;
  }
  if (!given("CDSCDR"))
  {
  CDSCDR = CDSCD;
  }
  if (!given("CDSCDLR"))
  {
  CDSCDLR = CDSCDL;
  }
  if (!given("LCDSCDR"))
  {
  LCDSCDR = LCDSCD;
  }
  if (!given("WCDSCDR"))
  {
  WCDSCDR = WCDSCD;
  }
  if (!given("PCDSCDR"))
  {
  PCDSCDR = PCDSCD;
  }
  if (!given("VSATR"))
  {
  VSATR = VSAT;
  }
  if (!given("LVSATR"))
  {
  LVSATR = LVSAT;
  }
  if (!given("WVSATR"))
  {
  WVSATR = WVSAT;
  }
  if (!given("PVSATR"))
  {
  PVSATR = PVSAT;
  }
  if (!given("VSATCV"))
  {
  VSATCV = VSAT;
  }
  if (!given("LVSATCV"))
  {
  LVSATCV = LVSAT;
  }
  if (!given("WVSATCV"))
  {
  WVSATCV = WVSAT;
  }
  if (!given("PVSATCV"))
  {
  PVSATCV = PVSAT;
  }
  if (!given("VSATCVL"))
  {
  VSATCVL = VSATL;
  }
  if (!given("VSATCVLEXP"))
  {
  VSATCVLEXP = VSATLEXP;
  }
  if (!given("VSATCVW"))
  {
  VSATCVW = VSATW;
  }
  if (!given("VSATCVWEXP"))
  {
  VSATCVWEXP = VSATWEXP;
  }
  if (!given("VSATCVWL"))
  {
  VSATCVWL = VSATWL;
  }
  if (!given("VSATCVWLEXP"))
  {
  VSATCVWLEXP = VSATWLEXP;
  }
  if (!given("U0R"))
  {
  U0R = U0;
  }
  if (!given("LU0R"))
  {
  LU0R = LU0;
  }
  if (!given("WU0R"))
  {
  WU0R = WU0;
  }
  if (!given("PU0R"))
  {
  PU0R = PU0;
  }
  if (!given("UAR"))
  {
  UAR = UA;
  }
  if (!given("LUAR"))
  {
  LUAR = LUA;
  }
  if (!given("WUAR"))
  {
  WUAR = WUA;
  }
  if (!given("PUAR"))
  {
  PUAR = PUA;
  }
  if (!given("UDR"))
  {
  UDR = UD;
  }
  if (!given("LUDR"))
  {
  LUDR = LUD;
  }
  if (!given("WUDR"))
  {
  WUDR = WUD;
  }
  if (!given("PUDR"))
  {
  PUDR = PUD;
  }
  if (!given("UCSR"))
  {
  UCSR = UCS;
  }
  if (!given("LUCSR"))
  {
  LUCSR = LUCS;
  }
  if (!given("WUCSR"))
  {
  WUCSR = WUCS;
  }
  if (!given("PUCSR"))
  {
  PUCSR = PUCS;
  }
  if (!given("UCR"))
  {
  UCR = UC;
  }
  if (!given("LUCR"))
  {
  LUCR = LUC;
  }
  if (!given("WUCR"))
  {
  WUCR = WUC;
  }
  if (!given("PUCR"))
  {
  PUCR = PUC;
  }
  if (!given("PCLMR"))
  {
  PCLMR = PCLM;
  }
  if (!given("LPCLMR"))
  {
  LPCLMR = LPCLM;
  }
  if (!given("WPCLMR"))
  {
  WPCLMR = WPCLM;
  }
  if (!given("PPCLMR"))
  {
  PPCLMR = PPCLM;
  }
  if (!given("PCLMCV"))
  {
  PCLMCV = PCLM;
  }
  if (!given("PCLMCVL"))
  {
  PCLMCVL = PCLML;
  }
  if (!given("PCLMCVLEXP"))
  {
  PCLMCVLEXP = PCLMLEXP;
  }
  if (!given("LPCLMCV"))
  {
  LPCLMCV = LPCLM;
  }
  if (!given("WPCLMCV"))
  {
  WPCLMCV = WPCLM;
  }
  if (!given("PPCLMCV"))
  {
  PPCLMCV = PPCLM;
  }
  if (!given("RDWMIN"))
  {
  RDWMIN = RSWMIN;
  }
  if (!given("LRDWMIN"))
  {
  LRDWMIN = LRSWMIN;
  }
  if (!given("WRDWMIN"))
  {
  WRDWMIN = WRSWMIN;
  }
  if (!given("PRDWMIN"))
  {
  PRDWMIN = PRSWMIN;
  }
  if (!given("RDW"))
  {
  RDW = RSW;
  }
  if (!given("LRDW"))
  {
  LRDW = LRSW;
  }
  if (!given("WRDW"))
  {
  WRDW = WRSW;
  }
  if (!given("PRDW"))
  {
  PRDW = PRSW;
  }
  if (!given("RDWL"))
  {
  RDWL = RSWL;
  }
  if (!given("RDWLEXP"))
  {
  RDWLEXP = RSWLEXP;
  }
  if (!given("PSATR"))
  {
  PSATR = PSAT;
  }
  if (!given("LPSATR"))
  {
  LPSATR = LPSAT;
  }
  if (!given("WPSATR"))
  {
  WPSATR = WPSAT;
  }
  if (!given("PPSATR"))
  {
  PPSATR = PPSAT;
  }
  if (!given("PTWGR"))
  {
  PTWGR = PTWG;
  }
  if (!given("LPTWGR"))
  {
  LPTWGR = LPTWG;
  }
  if (!given("WPTWGR"))
  {
  WPTWGR = WPTWG;
  }
  if (!given("PPTWGR"))
  {
  PPTWGR = PPTWG;
  }
  if (!given("PTWGLR"))
  {
  PTWGLR = PTWGL;
  }
  if (!given("PTWGLEXPR"))
  {
  PTWGLEXPR = PTWGLEXP;
  }
  if (!given("PDIBLCLR"))
  {
  PDIBLCLR = PDIBLCL;
  }
  if (!given("PDIBLCLEXPR"))
  {
  PDIBLCLEXPR = PDIBLCLEXP;
  }
  if (!given("LPDIBLCR"))
  {
  LPDIBLCR = LPDIBLC;
  }
  if (!given("WPDIBLCR"))
  {
  WPDIBLCR = WPDIBLC;
  }
  if (!given("PPDIBLCR"))
  {
  PPDIBLCR = PPDIBLC;
  }
  if (!given("AIGC"))
  {
  AIGC = ((TYPE==1)?1.36e-2:9.8e-3);
  }
  if (!given("BIGC"))
  {
  BIGC = ((TYPE==1)?1.71e-3:7.59e-4);
  }
  if (!given("CIGC"))
  {
  CIGC = ((TYPE==1)?0.075:0.03);
  }
  if (!given("AIGS"))
  {
  AIGS = ((TYPE==1)?1.36e-2:9.8e-3);
  }
  if (!given("BIGS"))
  {
  BIGS = ((TYPE==1)?1.71e-3:7.59e-4);
  }
  if (!given("CIGS"))
  {
  CIGS = ((TYPE==1)?0.075:0.03);
  }
  if (!given("AIGD"))
  {
  AIGD = ((TYPE==1)?1.36e-2:9.8e-3);
  }
  if (!given("BIGD"))
  {
  BIGD = ((TYPE==1)?1.71e-3:7.59e-4);
  }
  if (!given("CIGD"))
  {
  CIGD = ((TYPE==1)?0.075:0.03);
  }
  if (!given("DLCIG"))
  {
  DLCIG = LINT;
  }
  if (!given("DLCIGD"))
  {
  DLCIGD = DLCIG;
  }
  if (!given("AGISL"))
  {
  AGISL = AGIDL;
  }
  if (!given("AGISLL"))
  {
  AGISLL = AGIDLL;
  }
  if (!given("AGISLW"))
  {
  AGISLW = AGIDLW;
  }
  if (!given("LAGISL"))
  {
  LAGISL = LAGIDL;
  }
  if (!given("WAGISL"))
  {
  WAGISL = WAGIDL;
  }
  if (!given("PAGISL"))
  {
  PAGISL = PAGIDL;
  }
  if (!given("BGISL"))
  {
  BGISL = BGIDL;
  }
  if (!given("LBGISL"))
  {
  LBGISL = LBGIDL;
  }
  if (!given("WBGISL"))
  {
  WBGISL = WBGIDL;
  }
  if (!given("PBGISL"))
  {
  PBGISL = PBGIDL;
  }
  if (!given("CGISL"))
  {
  CGISL = CGIDL;
  }
  if (!given("LCGISL"))
  {
  LCGISL = LCGIDL;
  }
  if (!given("WCGISL"))
  {
  WCGISL = WCGIDL;
  }
  if (!given("PCGISL"))
  {
  PCGISL = PCGIDL;
  }
  if (!given("EGISL"))
  {
  EGISL = EGIDL;
  }
  if (!given("LEGISL"))
  {
  LEGISL = LEGIDL;
  }
  if (!given("WEGISL"))
  {
  WEGISL = WEGIDL;
  }
  if (!given("PEGISL"))
  {
  PEGISL = PEGIDL;
  }
  if (!given("DMCI"))
  {
  DMCI = DMCG;
  }
  if (!given("CJD"))
  {
  CJD = CJS;
  }
  if (!given("CJSWD"))
  {
  CJSWD = CJSWS;
  }
  if (!given("CJSWGD"))
  {
  CJSWGD = CJSWGS;
  }
  if (!given("PBD"))
  {
  PBD = PBS;
  }
  if (!given("PBSWD"))
  {
  PBSWD = PBSWS;
  }
  if (!given("PBSWGS"))
  {
  PBSWGS = PBSWS;
  }
  if (!given("PBSWGD"))
  {
  PBSWGD = PBSWGS;
  }
  if (!given("MJD"))
  {
  MJD = MJS;
  }
  if (!given("MJSWD"))
  {
  MJSWD = MJSWS;
  }
  if (!given("MJSWGS"))
  {
  MJSWGS = MJSWS;
  }
  if (!given("MJSWGD"))
  {
  MJSWGD = MJSWGS;
  }
  if (!given("JSD"))
  {
  JSD = JSS;
  }
  if (!given("JSWD"))
  {
  JSWD = JSWS;
  }
  if (!given("JSWGD"))
  {
  JSWGD = JSWGS;
  }
  if (!given("NJD"))
  {
  NJD = NJS;
  }
  if (!given("IJTHDFWD"))
  {
  IJTHDFWD = IJTHSFWD;
  }
  if (!given("IJTHDREV"))
  {
  IJTHDREV = IJTHSREV;
  }
  if (!given("BVD"))
  {
  BVD = BVS;
  }
  if (!given("XJBVD"))
  {
  XJBVD = XJBVS;
  }
  if (!given("JTSD"))
  {
  JTSD = JTSS;
  }
  if (!given("JTSSWD"))
  {
  JTSSWD = JTSSWS;
  }
  if (!given("JTSSWGD"))
  {
  JTSSWGD = JTSSWGS;
  }
  if (!given("NJTSD"))
  {
  NJTSD = NJTS;
  }
  if (!given("NJTSSWD"))
  {
  NJTSSWD = NJTSSW;
  }
  if (!given("NJTSSWGD"))
  {
  NJTSSWGD = NJTSSWG;
  }
  if (!given("VTSD"))
  {
  VTSD = VTSS;
  }
  if (!given("VTSSWD"))
  {
  VTSSWD = VTSSWS;
  }
  if (!given("VTSSWGD"))
  {
  VTSSWGD = VTSSWGS;
  }
  if (!given("XTID"))
  {
  XTID = XTIS;
  }
  if (!given("XTSD"))
  {
  XTSD = XTSS;
  }
  if (!given("XTSSWD"))
  {
  XTSSWD = XTSSWS;
  }
  if (!given("XTSSWGD"))
  {
  XTSSWGD = XTSSWGS;
  }
  if (!given("TNJTSD"))
  {
  TNJTSD = TNJTS;
  }
  if (!given("TNJTSSWD"))
  {
  TNJTSSWD = TNJTSSW;
  }
  if (!given("TNJTSSWGD"))
  {
  TNJTSSWGD = TNJTSSWG;
  }
  if (!given("NFACTOREDGE"))
  {
  NFACTOREDGE = NFACTOR;
  }
  if (!given("CITEDGE"))
  {
  CITEDGE = CIT;
  }
  if (!given("CDSCDEDGE"))
  {
  CDSCDEDGE = CDSCD;
  }
  if (!given("CDSCBEDGE"))
  {
  CDSCBEDGE = CDSCB;
  }
  if (!given("ETA0EDGE"))
  {
  ETA0EDGE = ETA0;
  }
  if (!given("ETABEDGE"))
  {
  ETABEDGE = ETAB;
  }
  if (!given("KT1EDGE"))
  {
  KT1EDGE = KT1;
  }
  if (!given("KT1LEDGE"))
  {
  KT1LEDGE = KT1L;
  }
  if (!given("KT2EDGE"))
  {
  KT2EDGE = KT2;
  }
  if (!given("KT1EXPEDGE"))
  {
  KT1EXPEDGE = KT1EXP;
  }
  if (!given("TNFACTOREDGE"))
  {
  TNFACTOREDGE = TNFACTOR;
  }
  if (!given("TETA0EDGE"))
  {
  TETA0EDGE = TETA0;
  }



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter L : ] 0,  (+inf) [
  if ( (!((L >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter L value " << L << " out of range ] 0,  (+inf) [";
  }

//    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

//    Parameter RGATEMOD : [ 0, 3 ]
  if ( (!((RGATEMOD >=0 && RGATEMOD <=3 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RGATEMOD value " << RGATEMOD << " out of range [ 0, 3 ]";
  }

//    Parameter RBODYMOD : [ 0, 2 ]
  if ( (!((RBODYMOD >=0 && RBODYMOD <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBODYMOD value " << RBODYMOD << " out of range [ 0, 2 ]";
  }

//    Parameter GEOMOD : [ 0, 10 ]
  if ( (!((GEOMOD >=0 && GEOMOD <=10 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter GEOMOD value " << GEOMOD << " out of range [ 0, 10 ]";
  }

//    Parameter RGEOMOD : [ 0, 8 ]
  if ( (!((RGEOMOD >=0 && RGEOMOD <=8 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RGEOMOD value " << RGEOMOD << " out of range [ 0, 8 ]";
  }

//    Parameter RBPB : [ 0,  (+inf) [
  if ( (!((RBPB >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPB value " << RBPB << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPD : [ 0,  (+inf) [
  if ( (!((RBPD >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPD value " << RBPD << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPS : [ 0,  (+inf) [
  if ( (!((RBPS >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPS value " << RBPS << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBDB : [ 0,  (+inf) [
  if ( (!((RBDB >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBDB value " << RBDB << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSB : [ 0,  (+inf) [
  if ( (!((RBSB >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSB value " << RBSB << " out of range [ 0,  (+inf) [";
  }

//    Parameter SCA :  ] (-inf)  (+inf) [

//    Parameter SCB :  ] (-inf)  (+inf) [

//    Parameter SCC :  ] (-inf)  (+inf) [

//    Parameter SC :  ] (-inf)  (+inf) [

//    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

//    Parameter CVMOD : [ 0, 1 ]
  if ( (!((CVMOD >=0 && CVMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter CVMOD value " << CVMOD << " out of range [ 0, 1 ]";
  }

//    Parameter COVMOD : [ 0, 1 ]
  if ( (!((COVMOD >=0 && COVMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter COVMOD value " << COVMOD << " out of range [ 0, 1 ]";
  }

//    Parameter RDSMOD : [ 0, 2 ]
  if ( (!((RDSMOD >=0 && RDSMOD <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RDSMOD value " << RDSMOD << " out of range [ 0, 2 ]";
  }

//    Parameter WPEMOD : [ 0, 1 ]
  if ( (!((WPEMOD >=0 && WPEMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter WPEMOD value " << WPEMOD << " out of range [ 0, 1 ]";
  }

//    Parameter ASYMMOD : [ 0, 1 ]
  if ( (!((ASYMMOD >=0 && ASYMMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter ASYMMOD value " << ASYMMOD << " out of range [ 0, 1 ]";
  }

//    Parameter GIDLMOD : [ 0, 1 ]
  if ( (!((GIDLMOD >=0 && GIDLMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter GIDLMOD value " << GIDLMOD << " out of range [ 0, 1 ]";
  }

//    Parameter IGCMOD : [ 0, 1 ]
  if ( (!((IGCMOD >=0 && IGCMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter IGCMOD value " << IGCMOD << " out of range [ 0, 1 ]";
  }

//    Parameter IGBMOD : [ 0, 1 ]
  if ( (!((IGBMOD >=0 && IGBMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter IGBMOD value " << IGBMOD << " out of range [ 0, 1 ]";
  }

//    Parameter TNOIMOD : [ 0, 1 ]
  if ( (!((TNOIMOD >=0 && TNOIMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter TNOIMOD value " << TNOIMOD << " out of range [ 0, 1 ]";
  }

//    Parameter SHMOD : [ 0, 1 ]
  if ( (!((SHMOD >=0 && SHMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter SHMOD value " << SHMOD << " out of range [ 0, 1 ]";
  }

//    Parameter MOBSCALE : [ 0, 1 ]
  if ( (!((MOBSCALE >=0 && MOBSCALE <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter MOBSCALE value " << MOBSCALE << " out of range [ 0, 1 ]";
  }

//    Parameter LLONG : ] 0,  (+inf) [
  if ( (!((LLONG >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter LLONG value " << LLONG << " out of range ] 0,  (+inf) [";
  }

//    Parameter LMLT : ] 0,  (+inf) [
  if ( (!((LMLT >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter LMLT value " << LMLT << " out of range ] 0,  (+inf) [";
  }

//    Parameter WMLT : ] 0,  (+inf) [
  if ( (!((WMLT >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter WMLT value " << WMLT << " out of range ] 0,  (+inf) [";
  }

//    Parameter WWIDE : ] 0,  (+inf) [
  if ( (!((WWIDE >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter WWIDE value " << WWIDE << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPLEXP1 : ] 0,  (+inf) [
  if ( (!((NDEPLEXP1 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPLEXP1 value " << NDEPLEXP1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPLEXP2 : ] 0,  (+inf) [
  if ( (!((NDEPLEXP2 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPLEXP2 value " << NDEPLEXP2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPWEXP : ] 0,  (+inf) [
  if ( (!((NDEPWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPWEXP value " << NDEPWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPWLEXP : ] 0,  (+inf) [
  if ( (!((NDEPWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPWLEXP value " << NDEPWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPCVLEXP1 : ] 0,  (+inf) [
  if ( (!((NDEPCVLEXP1 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPCVLEXP1 value " << NDEPCVLEXP1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPCVLEXP2 : ] 0,  (+inf) [
  if ( (!((NDEPCVLEXP2 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPCVLEXP2 value " << NDEPCVLEXP2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPCVWEXP : ] 0,  (+inf) [
  if ( (!((NDEPCVWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPCVWEXP value " << NDEPCVWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter NDEPCVWLEXP : ] 0,  (+inf) [
  if ( (!((NDEPCVWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NDEPCVWLEXP value " << NDEPCVWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VFBCVLEXP : ] 0,  (+inf) [
  if ( (!((VFBCVLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VFBCVLEXP value " << VFBCVLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VFBCVWEXP : ] 0,  (+inf) [
  if ( (!((VFBCVWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VFBCVWEXP value " << VFBCVWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VFBCVWLEXP : ] 0,  (+inf) [
  if ( (!((VFBCVWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VFBCVWLEXP value " << VFBCVWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PERMOD : [ 0, 1 ]
  if ( (!((PERMOD >=0 && PERMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PERMOD value " << PERMOD << " out of range [ 0, 1 ]";
  }

//    Parameter ETABEXP : ] 0,  (+inf) [
  if ( (!((ETABEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter ETABEXP value " << ETABEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter K1LEXP : ] 0,  (+inf) [
  if ( (!((K1LEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter K1LEXP value " << K1LEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter K1WEXP : ] 0,  (+inf) [
  if ( (!((K1WEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter K1WEXP value " << K1WEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter K1WLEXP : ] 0,  (+inf) [
  if ( (!((K1WLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter K1WLEXP value " << K1WLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter K2LEXP : ] 0,  (+inf) [
  if ( (!((K2LEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter K2LEXP value " << K2LEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter K2WEXP : ] 0,  (+inf) [
  if ( (!((K2WEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter K2WEXP value " << K2WEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter K2WLEXP : ] 0,  (+inf) [
  if ( (!((K2WLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter K2WLEXP value " << K2WLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter ADOS : [ 0,  (+inf) [
  if ( (!((ADOS >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter ADOS value " << ADOS << " out of range [ 0,  (+inf) [";
  }

//    Parameter BDOS : [ 0,  (+inf) [
  if ( (!((BDOS >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter BDOS value " << BDOS << " out of range [ 0,  (+inf) [";
  }

//    Parameter QM0 : ] 0,  (+inf) [
  if ( (!((QM0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter QM0 value " << QM0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter ETAQM : [ 0,  (+inf) [
  if ( (!((ETAQM >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter ETAQM value " << ETAQM << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFACTORLEXP : ] 0,  (+inf) [
  if ( (!((NFACTORLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NFACTORLEXP value " << NFACTORLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter NFACTORWEXP : ] 0,  (+inf) [
  if ( (!((NFACTORWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NFACTORWEXP value " << NFACTORWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter NFACTORWLEXP : ] 0,  (+inf) [
  if ( (!((NFACTORWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NFACTORWLEXP value " << NFACTORWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter CDSCDLEXP : ] 0,  (+inf) [
  if ( (!((CDSCDLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter CDSCDLEXP value " << CDSCDLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter CDSCBLEXP : ] 0,  (+inf) [
  if ( (!((CDSCBLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter CDSCBLEXP value " << CDSCBLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VSATLEXP : ] 0,  (+inf) [
  if ( (!((VSATLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VSATLEXP value " << VSATLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VSATWEXP : ] 0,  (+inf) [
  if ( (!((VSATWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VSATWEXP value " << VSATWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VSATWLEXP : ] 0,  (+inf) [
  if ( (!((VSATWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VSATWLEXP value " << VSATWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter DELTALEXP : ] 0,  (+inf) [
  if ( (!((DELTALEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter DELTALEXP value " << DELTALEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VSATCVLEXP : ] 0,  (+inf) [
  if ( (!((VSATCVLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VSATCVLEXP value " << VSATCVLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VSATCVWEXP : ] 0,  (+inf) [
  if ( (!((VSATCVWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VSATCVWEXP value " << VSATCVWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter VSATCVWLEXP : ] 0,  (+inf) [
  if ( (!((VSATCVWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter VSATCVWLEXP value " << VSATCVWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UP1 :  ] (-inf)  (+inf) [

//    Parameter LP1 :  ] (-inf)  (+inf) [

//    Parameter UP2 :  ] (-inf)  (+inf) [

//    Parameter LP2 :  ] (-inf)  (+inf) [

//    Parameter U0LEXP : ] 0,  (+inf) [
  if ( (!((U0LEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter U0LEXP value " << U0LEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UALEXP : ] 0,  (+inf) [
  if ( (!((UALEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter UALEXP value " << UALEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UAWEXP : ] 0,  (+inf) [
  if ( (!((UAWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter UAWEXP value " << UAWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UAWLEXP : ] 0,  (+inf) [
  if ( (!((UAWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter UAWLEXP value " << UAWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter EULEXP : ] 0,  (+inf) [
  if ( (!((EULEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter EULEXP value " << EULEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter EUWEXP : ] 0,  (+inf) [
  if ( (!((EUWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter EUWEXP value " << EUWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter EUWLEXP : ] 0,  (+inf) [
  if ( (!((EUWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter EUWLEXP value " << EUWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UDLEXP : ] 0,  (+inf) [
  if ( (!((UDLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter UDLEXP value " << UDLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UCLEXP : ] 0,  (+inf) [
  if ( (!((UCLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter UCLEXP value " << UCLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UCWEXP : ] 0,  (+inf) [
  if ( (!((UCWEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter UCWEXP value " << UCWEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter UCWLEXP : ] 0,  (+inf) [
  if ( (!((UCWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter UCWLEXP value " << UCWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PCLMLEXP : ] 0,  (+inf) [
  if ( (!((PCLMLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PCLMLEXP value " << PCLMLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PCLMCVLEXP : ] 0,  (+inf) [
  if ( (!((PCLMCVLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PCLMCVLEXP value " << PCLMCVLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PDITSL : [ 0,  (+inf) [
  if ( (!((PDITSL >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PDITSL value " << PDITSL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSH : [ 0,  (+inf) [
  if ( (!((RSH >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RSH value " << RSH << " out of range [ 0,  (+inf) [";
  }

//    Parameter PRWBLEXP : ] 0,  (+inf) [
  if ( (!((PRWBLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PRWBLEXP value " << PRWBLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter RSWLEXP : ] 0,  (+inf) [
  if ( (!((RSWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RSWLEXP value " << RSWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter RDWLEXP : ] 0,  (+inf) [
  if ( (!((RDWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RDWLEXP value " << RDWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter RDSWLEXP : ] 0,  (+inf) [
  if ( (!((RDSWLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RDSWLEXP value " << RDSWLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PSATLEXP : ] 0,  (+inf) [
  if ( (!((PSATLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PSATLEXP value " << PSATLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PSATX : ] 0,  (+inf) [
  if ( (!((PSATX >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PSATX value " << PSATX << " out of range ] 0,  (+inf) [";
  }

//    Parameter PTWGLEXP : ] 0,  (+inf) [
  if ( (!((PTWGLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PTWGLEXP value " << PTWGLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PTWGLEXPR : ] 0,  (+inf) [
  if ( (!((PTWGLEXPR >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PTWGLEXPR value " << PTWGLEXPR << " out of range ] 0,  (+inf) [";
  }

//    Parameter PDIBLCLEXP : ] 0,  (+inf) [
  if ( (!((PDIBLCLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PDIBLCLEXP value " << PDIBLCLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter PDIBLCLEXPR : ] 0,  (+inf) [
  if ( (!((PDIBLCLEXPR >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PDIBLCLEXPR value " << PDIBLCLEXPR << " out of range ] 0,  (+inf) [";
  }

//    Parameter FPROUTLEXP : ] 0,  (+inf) [
  if ( (!((FPROUTLEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter FPROUTLEXP value " << FPROUTLEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter ALPHA0LEXP : ] 0,  (+inf) [
  if ( (!((ALPHA0LEXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter ALPHA0LEXP value " << ALPHA0LEXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter TOXREF : ] 0,  (+inf) [
  if ( (!((TOXREF >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter TOXREF value " << TOXREF << " out of range ] 0,  (+inf) [";
  }

//    Parameter PIGCD : [ (-50), 50 ]
  if ( (!((PIGCD >=(-50) && PIGCD <=50 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter PIGCD value " << PIGCD << " out of range [ (-50), 50 ]";
  }

//    Parameter CFRCOEFF : [ 1.0,  (+inf) [
  if ( (!((CFRCOEFF >=1.0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter CFRCOEFF value " << CFRCOEFF << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter XGL :  ] (-inf) ((L*LMLT)+XL) [
  if ( (!((XGL <((L*LMLT)+XL) ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter XGL value " << XGL << " out of range  ] (-inf) ((L*LMLT)+XL) [";
  }

//    Parameter RSHG : [ 0,  (+inf) [
  if ( (!((RSHG >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RSHG value " << RSHG << " out of range [ 0,  (+inf) [";
  }

//    Parameter GBMIN : [ 0,  (+inf) [
  if ( (!((GBMIN >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter GBMIN value " << GBMIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPS0 : ] 0,  (+inf) [
  if ( (!((RBPS0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPS0 value " << RBPS0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBPSL : [ 0,  (+inf) [
  if ( (!((RBPSL >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPSL value " << RBPSL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPSW : [ 0,  (+inf) [
  if ( (!((RBPSW >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPSW value " << RBPSW << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPSNF : [ 0,  (+inf) [
  if ( (!((RBPSNF >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPSNF value " << RBPSNF << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPD0 : ] 0,  (+inf) [
  if ( (!((RBPD0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPD0 value " << RBPD0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBPDL : [ 0,  (+inf) [
  if ( (!((RBPDL >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPDL value " << RBPDL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPDW : [ 0,  (+inf) [
  if ( (!((RBPDW >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPDW value " << RBPDW << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPDNF : [ 0,  (+inf) [
  if ( (!((RBPDNF >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPDNF value " << RBPDNF << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPBX0 : ] 0,  (+inf) [
  if ( (!((RBPBX0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBX0 value " << RBPBX0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBPBXL : [ 0,  (+inf) [
  if ( (!((RBPBXL >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBXL value " << RBPBXL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPBXW : [ 0,  (+inf) [
  if ( (!((RBPBXW >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBXW value " << RBPBXW << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPBXNF : [ 0,  (+inf) [
  if ( (!((RBPBXNF >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBXNF value " << RBPBXNF << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPBY0 : ] 0,  (+inf) [
  if ( (!((RBPBY0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBY0 value " << RBPBY0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBPBYL : [ 0,  (+inf) [
  if ( (!((RBPBYL >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBYL value " << RBPBYL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPBYW : [ 0,  (+inf) [
  if ( (!((RBPBYW >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBYW value " << RBPBYW << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBPBYNF : [ 0,  (+inf) [
  if ( (!((RBPBYNF >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBPBYNF value " << RBPBYNF << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSBX0 : ] 0,  (+inf) [
  if ( (!((RBSBX0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSBX0 value " << RBSBX0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBSBY0 : ] 0,  (+inf) [
  if ( (!((RBSBY0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSBY0 value " << RBSBY0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBDBX0 : ] 0,  (+inf) [
  if ( (!((RBDBX0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBDBX0 value " << RBDBX0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBDBY0 : ] 0,  (+inf) [
  if ( (!((RBDBY0 >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBDBY0 value " << RBDBY0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter RBSDBXL : [ 0,  (+inf) [
  if ( (!((RBSDBXL >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSDBXL value " << RBSDBXL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSDBXW : [ 0,  (+inf) [
  if ( (!((RBSDBXW >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSDBXW value " << RBSDBXW << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSDBXNF : [ 0,  (+inf) [
  if ( (!((RBSDBXNF >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSDBXNF value " << RBSDBXNF << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSDBYL : [ 0,  (+inf) [
  if ( (!((RBSDBYL >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSDBYL value " << RBSDBYL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSDBYW : [ 0,  (+inf) [
  if ( (!((RBSDBYW >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSDBYW value " << RBSDBYW << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBSDBYNF : [ 0,  (+inf) [
  if ( (!((RBSDBYNF >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter RBSDBYNF value " << RBSDBYNF << " out of range [ 0,  (+inf) [";
  }

//    Parameter EF : ] 0, 2 ]
  if ( (!((EF >0 && EF <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter EF value " << EF << " out of range ] 0, 2 ]";
  }

//    Parameter NTNOI : [ 0,  (+inf) [
  if ( (!((NTNOI >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter NTNOI value " << NTNOI << " out of range [ 0,  (+inf) [";
  }

//    Parameter TNOIA :  ] (-inf)  (+inf) [

//    Parameter TNOIB :  ] (-inf)  (+inf) [

//    Parameter TNOIC :  ] (-inf)  (+inf) [

//    Parameter BINUNIT : [ 0, 1 ]
  if ( (!((BINUNIT >=0 && BINUNIT <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter BINUNIT value " << BINUNIT << " out of range [ 0, 1 ]";
  }

//    Parameter KT1EXP : ] 0,  (+inf) [
  if ( (!((KT1EXP >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter KT1EXP value " << KT1EXP << " out of range ] 0,  (+inf) [";
  }

//    Parameter SAREF : ] 0,  (+inf) [
  if ( (!((SAREF >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter SAREF value " << SAREF << " out of range ] 0,  (+inf) [";
  }

//    Parameter SBREF : ] 0,  (+inf) [
  if ( (!((SBREF >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter SBREF value " << SBREF << " out of range ] 0,  (+inf) [";
  }

//    Parameter WLOD : [ 0,  (+inf) [
  if ( (!((WLOD >=0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter WLOD value " << WLOD << " out of range [ 0,  (+inf) [";
  }

//    Parameter SCREF : ] 0,  (+inf) [
  if ( (!((SCREF >0))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter SCREF value " << SCREF << " out of range ] 0,  (+inf) [";
  }

//    Parameter EDGEFET : [ 0, 1 ]
  if ( (!((EDGEFET >=0 && EDGEFET <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter EDGEFET value " << EDGEFET << " out of range [ 0, 1 ]";
  }

//    Parameter WEDGE : [ 1.0e-9,  (+inf) [
  if ( (!((WEDGE >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsim6: Parameter WEDGE value " << WEDGE << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter DGAMMAEDGE :  ] (-inf)  (+inf) [

//    Parameter DGAMMAEDGEL :  ] (-inf)  (+inf) [

//    Parameter DGAMMAEDGELEXP :  ] (-inf)  (+inf) [

//    Parameter DVTEDGE :  ] (-inf)  (+inf) [

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    L(10*1.0e-6),
    VFBSDOFF(0.0),
    XGW(0.0),
    NGCON(1),
    RGATEMOD(0),
    RBODYMOD(0),
    GEOMOD(0),
    RGEOMOD(0),
    RBPB(50.0),
    RBPD(50.0),
    RBPS(50.0),
    RBDB(50.0),
    RBSB(50.0),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    TYPE(1),
    CVMOD(0),
    COVMOD(0),
    RDSMOD(0),
    WPEMOD(0),
    ASYMMOD(0),
    GIDLMOD(0),
    IGCMOD(0),
    IGBMOD(0),
    TNOIMOD(0),
    SHMOD(0),
    MOBSCALE(0),
    LLONG(10*1.0e-6),
    LMLT(1.0),
    WMLT(1.0),
    XL(0.0),
    WWIDE(10*1.0e-6),
    XW(0.0),
    LINT(0.0),
    LL(0.0),
    LW(0.0),
    LWL(0.0),
    LLN(1.0),
    LWN(1.0),
    WINT(0.0),
    WL(0.0),
    WW(0.0),
    WWL(0.0),
    WLN(1.0),
    WWN(1.0),
    DLC(0.0),
    LLC(0.0),
    LWC(0.0),
    LWLC(0.0),
    DWC(0.0),
    WLC(0.0),
    WWC(0.0),
    WWLC(0.0),
    TOXE(3.0e-9),
    TOXP(0.0),
    DTOX(0.0),
    NDEP(1e24),
    NDEPL1(0.0),
    NDEPLEXP1(1.0),
    NDEPL2(0.0),
    NDEPLEXP2(2.0),
    NDEPW(0.0),
    NDEPWEXP(1.0),
    NDEPWL(0.0),
    NDEPWLEXP(1.0),
    LNDEP(0.0),
    WNDEP(0.0),
    PNDEP(0.0),
    NDEPCV(0.0),
    NDEPCVL1(0.0),
    NDEPCVLEXP1(0.0),
    NDEPCVL2(0.0),
    NDEPCVLEXP2(0.0),
    NDEPCVW(0.0),
    NDEPCVWEXP(0.0),
    NDEPCVWL(0.0),
    NDEPCVWLEXP(0.0),
    LNDEPCV(0.0),
    WNDEPCV(0.0),
    PNDEPCV(0.0),
    NGATE(5e25),
    LNGATE(0.0),
    WNGATE(0.0),
    PNGATE(0.0),
    EASUB(4.05),
    NI0SUB(1.1e16),
    BG0SUB(1.17),
    EPSRSUB(11.9),
    EPSROX(3.9),
    XJ(1.5e-7),
    LXJ(0.0),
    WXJ(0.0),
    PXJ(0.0),
    LVFB(0.0),
    WVFB(0.0),
    PVFB(0.0),
    VFB((-0.5)),
    VFBCV(0.0),
    LVFBCV(0.0),
    WVFBCV(0.0),
    PVFBCV(0.0),
    VFBCVL(0.0),
    VFBCVLEXP(1.0),
    VFBCVW(0.0),
    VFBCVWEXP(1.0),
    VFBCVWL(0.0),
    VFBCVWLEXP(1.0),
    PERMOD(1),
    DWJ(0.0),
    NSD(1e26),
    LNSD(0.0),
    WNSD(0.0),
    PNSD(0.0),
    DELVT0(0.0),
    DVTP0(0.0),
    LDVTP0(0),
    WDVTP0(0),
    PDVTP0(0),
    DVTP1(0.0),
    LDVTP1(0),
    WDVTP1(0),
    PDVTP1(0),
    DVTP2(0.0),
    LDVTP2(0),
    WDVTP2(0),
    PDVTP2(0),
    DVTP3(0.0),
    LDVTP3(0),
    WDVTP3(0),
    PDVTP3(0),
    DVTP4(0.0),
    LDVTP4(0),
    WDVTP4(0),
    PDVTP4(0),
    DVTP5(0.0),
    LDVTP5(0),
    WDVTP5(0),
    PDVTP5(0),
    PHIN(0.045),
    LPHIN(0.0),
    WPHIN(0.0),
    PPHIN(0.0),
    ETA0(0.08),
    LETA0(0.0),
    WETA0(0.0),
    PETA0(0.0),
    ETA0R(0.0),
    LETA0R(0.0),
    WETA0R(0.0),
    PETA0R(0.0),
    DSUB(1.0),
    ETAB((-0.07)),
    ETABEXP(1.0),
    LETAB(0.0),
    WETAB(0.0),
    PETAB(0.0),
    K1(0.0),
    K1L(0.0),
    K1LEXP(1.0),
    K1W(0.0),
    K1WEXP(1.0),
    K1WL(0.0),
    K1WLEXP(1.0),
    LK1(0.0),
    WK1(0.0),
    PK1(0.0),
    K2(0.0),
    K2L(0.0),
    K2LEXP(1.0),
    K2W(0.0),
    K2WEXP(1.0),
    K2WL(0.0),
    K2WLEXP(1.0),
    LK2(0.0),
    WK2(0.0),
    PK2(0.0),
    ADOS(0.0),
    BDOS(1.0),
    QM0(1.0e-3),
    ETAQM(0.54),
    CIT(0.0),
    LCIT(0.0),
    WCIT(0.0),
    PCIT(0.0),
    NFACTOR(0.0),
    NFACTORL(0.0),
    NFACTORLEXP(1.0),
    NFACTORW(0.0),
    NFACTORWEXP(1.0),
    NFACTORWL(0.0),
    NFACTORWLEXP(1.0),
    LNFACTOR(0.0),
    WNFACTOR(0.0),
    PNFACTOR(0.0),
    CDSCD(1e-9),
    CDSCDL(0.0),
    CDSCDLEXP(1.0),
    LCDSCD(0.0),
    WCDSCD(0.0),
    PCDSCD(0.0),
    CDSCDR(0.0),
    CDSCDLR(0.0),
    LCDSCDR(0.0),
    WCDSCDR(0.0),
    PCDSCDR(0.0),
    CDSCB(0.0),
    CDSCBL(0.0),
    CDSCBLEXP(1.0),
    LCDSCB(0.0),
    WCDSCB(0.0),
    PCDSCB(0.0),
    VSAT(1e5),
    LVSAT(0.0),
    WVSAT(0.0),
    PVSAT(0.0),
    VSATL(0.0),
    VSATLEXP(1.0),
    VSATW(0.0),
    VSATWEXP(1.0),
    VSATWL(0.0),
    VSATWLEXP(1.0),
    VSATR(0.0),
    LVSATR(0.0),
    WVSATR(0.0),
    PVSATR(0.0),
    DELTA(0.125),
    LDELTA(0.0),
    WDELTA(0.0),
    PDELTA(0.0),
    DELTAL(0.0),
    DELTALEXP(1.0),
    VSATCV(0.0),
    LVSATCV(0.0),
    WVSATCV(0.0),
    PVSATCV(0.0),
    VSATCVL(0.0),
    VSATCVLEXP(0.0),
    VSATCVW(0.0),
    VSATCVWEXP(0.0),
    VSATCVWL(0.0),
    VSATCVWLEXP(0.0),
    UP1(0.0),
    LP1(1.0e-8),
    UP2(0.0),
    LP2(1.0e-8),
    MULU0(1.0),
    U0(67.0e-3),
    U0L(0.0),
    U0LEXP(1.0),
    LU0(0.0),
    WU0(0.0),
    PU0(0.0),
    U0R(0.0),
    LU0R(0.0),
    WU0R(0.0),
    PU0R(0.0),
    ETAMOB(1.0),
    UA(0.001),
    UAL(0.0),
    UALEXP(1.0),
    UAW(0.0),
    UAWEXP(1.0),
    UAWL(0.0),
    UAWLEXP(1.0),
    LUA(0.0),
    WUA(0.0),
    PUA(0.0),
    UAR(0.0),
    LUAR(0.0),
    WUAR(0.0),
    PUAR(0.0),
    EU(1.5),
    LEU(0.0),
    WEU(0.0),
    PEU(0.0),
    EUL(0.0),
    EULEXP(1.0),
    EUW(0.0),
    EUWEXP(1.0),
    EUWL(0.0),
    EUWLEXP(1.0),
    UD(0.001),
    UDL(0.0),
    UDLEXP(1.0),
    LUD(0.0),
    WUD(0.0),
    PUD(0.0),
    UDR(0.0),
    LUDR(0.0),
    WUDR(0.0),
    PUDR(0.0),
    UCS(2.0),
    LUCS(0.0),
    WUCS(0.0),
    PUCS(0.0),
    UCSR(0.0),
    LUCSR(0.0),
    WUCSR(0.0),
    PUCSR(0.0),
    UC(0.0),
    UCL(0.0),
    UCLEXP(1.0),
    UCW(0.0),
    UCWEXP(1.0),
    UCWL(0.0),
    UCWLEXP(1.0),
    LUC(0.0),
    WUC(0.0),
    PUC(0.0),
    UCR(0.0),
    LUCR(0.0),
    WUCR(0.0),
    PUCR(0.0),
    PCLM(0.0),
    PCLML(0.0),
    PCLMLEXP(1.0),
    LPCLM(0.0),
    WPCLM(0.0),
    PPCLM(0.0),
    PCLMR(0.0),
    LPCLMR(0.0),
    WPCLMR(0.0),
    PPCLMR(0.0),
    PCLMG(0.0),
    PCLMCV(0.0),
    PCLMCVL(0.0),
    PCLMCVLEXP(0.0),
    LPCLMCV(0.0),
    WPCLMCV(0.0),
    PPCLMCV(0.0),
    PSCBE1(4.24e8),
    LPSCBE1(0.0),
    WPSCBE1(0.0),
    PPSCBE1(0.0),
    PSCBE2(1.0e-8),
    LPSCBE2(0.0),
    WPSCBE2(0.0),
    PPSCBE2(0.0),
    PDITS(0.0),
    LPDITS(0.0),
    WPDITS(0.0),
    PPDITS(0.0),
    PDITSL(0.0),
    PDITSD(0.0),
    LPDITSD(0.0),
    WPDITSD(0.0),
    PPDITSD(0.0),
    RSH(0.0),
    PRWG(1.0),
    LPRWG(0.0),
    WPRWG(0.0),
    PPRWG(0.0),
    PRWB(0.0),
    LPRWB(0.0),
    WPRWB(0.0),
    PPRWB(0.0),
    PRWBL(0.0),
    PRWBLEXP(1.0),
    WR(1.0),
    LWR(0.0),
    WWR(0.0),
    PWR(0.0),
    RSWMIN(0.0),
    LRSWMIN(0.0),
    WRSWMIN(0.0),
    PRSWMIN(0.0),
    RSW(10.0),
    LRSW(0.0),
    WRSW(0.0),
    PRSW(0.0),
    RSWL(0.0),
    RSWLEXP(1.0),
    RDWMIN(0.0),
    LRDWMIN(0.0),
    WRDWMIN(0.0),
    PRDWMIN(0.0),
    RDW(0.0),
    LRDW(0.0),
    WRDW(0.0),
    PRDW(0.0),
    RDWL(0.0),
    RDWLEXP(0.0),
    RDSWMIN(0.0),
    LRDSWMIN(0.0),
    WRDSWMIN(0.0),
    PRDSWMIN(0.0),
    RDSW(20.0),
    RDSWL(0.0),
    RDSWLEXP(1.0),
    LRDSW(0.0),
    WRDSW(0.0),
    PRDSW(0.0),
    PSAT(1.0),
    LPSAT(0.0),
    WPSAT(0.0),
    PPSAT(0.0),
    PSATL(0.0),
    PSATLEXP(1.0),
    PSATB(0.0),
    PSATR(0.0),
    LPSATR(0.0),
    WPSATR(0.0),
    PPSATR(0.0),
    LPSATB(0.0),
    WPSATB(0.0),
    PPSATB(0.0),
    PSATX(1.0),
    PTWG(0.0),
    LPTWG(0.0),
    WPTWG(0.0),
    PPTWG(0.0),
    PTWGL(0.0),
    PTWGLEXP(1.0),
    PTWGR(0.0),
    LPTWGR(0.0),
    WPTWGR(0.0),
    PPTWGR(0.0),
    PTWGLR(0.0),
    PTWGLEXPR(0.0),
    A1(0.0),
    LA1(0.0),
    WA1(0.0),
    PA1(0.0),
    A11(0.0),
    LA11(0.0),
    WA11(0.0),
    PA11(0.0),
    A2(0.0),
    LA2(0.0),
    WA2(0.0),
    PA2(0.0),
    A21(0.0),
    LA21(0.0),
    WA21(0.0),
    PA21(0.0),
    PDIBLC(0.0),
    PDIBLCL(0.0),
    PDIBLCLEXP(1.0),
    LPDIBLC(0.0),
    WPDIBLC(0.0),
    PPDIBLC(0.0),
    PDIBLCR(0.0),
    PDIBLCLR(0.0),
    PDIBLCLEXPR(0.0),
    LPDIBLCR(0.0),
    WPDIBLCR(0.0),
    PPDIBLCR(0.0),
    PDIBLCB(0.0),
    LPDIBLCB(0.0),
    WPDIBLCB(0.0),
    PPDIBLCB(0.0),
    PVAG(1.0),
    LPVAG(0.0),
    WPVAG(0.0),
    PPVAG(0.0),
    FPROUT(0.0),
    FPROUTL(0.0),
    FPROUTLEXP(1.0),
    LFPROUT(0.0),
    WFPROUT(0.0),
    PFPROUT(0.0),
    ALPHA0(0.0),
    ALPHA0L(0.0),
    ALPHA0LEXP(1.0),
    LALPHA0(0.0),
    WALPHA0(0.0),
    PALPHA0(0.0),
    BETA0(0.0),
    LBETA0(0.0),
    WBETA0(0.0),
    PBETA0(0.0),
    AIGBACC(1.36e-2),
    BIGBACC(1.71e-3),
    CIGBACC(0.075),
    NIGBACC(1.0),
    AIGBINV(1.11e-2),
    BIGBINV(9.49e-4),
    CIGBINV(0.006),
    EIGBINV(1.1),
    NIGBINV(3.0),
    AIGC(0.0),
    BIGC(0.0),
    CIGC(0.0),
    AIGS(0.0),
    BIGS(0.0),
    CIGS(0.0),
    AIGD(0.0),
    BIGD(0.0),
    CIGD(0.0),
    DLCIG(0.0),
    DLCIGD(0.0),
    POXEDGE(1.0),
    NTOX(1.0),
    TOXREF(3.0e-9),
    PIGCD(1.0),
    AIGCL(0.0),
    AIGCW(0.0),
    AIGSL(0.0),
    AIGSW(0.0),
    AIGDL(0.0),
    AIGDW(0.0),
    PIGCDL(0.0),
    LAIGBINV(0.0),
    WAIGBINV(0.0),
    PAIGBINV(0.0),
    LBIGBINV(0.0),
    WBIGBINV(0.0),
    PBIGBINV(0.0),
    LCIGBINV(0.0),
    WCIGBINV(0.0),
    PCIGBINV(0.0),
    LEIGBINV(0.0),
    WEIGBINV(0.0),
    PEIGBINV(0.0),
    LNIGBINV(0.0),
    WNIGBINV(0.0),
    PNIGBINV(0.0),
    LAIGBACC(0.0),
    WAIGBACC(0.0),
    PAIGBACC(0.0),
    LBIGBACC(0.0),
    WBIGBACC(0.0),
    PBIGBACC(0.0),
    LCIGBACC(0.0),
    WCIGBACC(0.0),
    PCIGBACC(0.0),
    LNIGBACC(0.0),
    WNIGBACC(0.0),
    PNIGBACC(0.0),
    LAIGC(0.0),
    WAIGC(0.0),
    PAIGC(0.0),
    LBIGC(0.0),
    WBIGC(0.0),
    PBIGC(0.0),
    LCIGC(0.0),
    WCIGC(0.0),
    PCIGC(0.0),
    LAIGS(0.0),
    WAIGS(0.0),
    PAIGS(0.0),
    LBIGS(0.0),
    WBIGS(0.0),
    PBIGS(0.0),
    LCIGS(0.0),
    WCIGS(0.0),
    PCIGS(0.0),
    LAIGD(0.0),
    WAIGD(0.0),
    PAIGD(0.0),
    LBIGD(0.0),
    WBIGD(0.0),
    PBIGD(0.0),
    LCIGD(0.0),
    WCIGD(0.0),
    PCIGD(0.0),
    LPOXEDGE(0.0),
    WPOXEDGE(0.0),
    PPOXEDGE(0.0),
    LDLCIG(0.0),
    WDLCIG(0.0),
    PDLCIG(0.0),
    LDLCIGD(0.0),
    WDLCIGD(0.0),
    PDLCIGD(0.0),
    LNTOX(0.0),
    WNTOX(0.0),
    PNTOX(0.0),
    AGIDL(0.0),
    AGIDLL(0.0),
    AGIDLW(0.0),
    LAGIDL(0.0),
    WAGIDL(0.0),
    PAGIDL(0.0),
    BGIDL(2.3e9),
    LBGIDL(0.0),
    WBGIDL(0.0),
    PBGIDL(0.0),
    CGIDL(0.5),
    LCGIDL(0.0),
    WCGIDL(0.0),
    PCGIDL(0.0),
    EGIDL(0.8),
    LEGIDL(0.0),
    WEGIDL(0.0),
    PEGIDL(0.0),
    AGISL(0.0),
    AGISLL(0.0),
    AGISLW(0.0),
    LAGISL(0.0),
    WAGISL(0.0),
    PAGISL(0.0),
    BGISL(0.0),
    LBGISL(0.0),
    WBGISL(0.0),
    PBGISL(0.0),
    CGISL(0.0),
    LCGISL(0.0),
    WCGISL(0.0),
    PCGISL(0.0),
    EGISL(0.0),
    LEGISL(0.0),
    WEGISL(0.0),
    PEGISL(0.0),
    CF(0.0),
    LCF(0.0),
    WCF(0.0),
    PCF(0.0),
    CFRCOEFF(1.0),
    CGSO(0.0),
    CGDO(0.0),
    CGBO(0.0),
    CGSL(0.0),
    LCGSL(0.0),
    WCGSL(0.0),
    PCGSL(0.0),
    CGDL(0.0),
    LCGDL(0.0),
    WCGDL(0.0),
    PCGDL(0.0),
    CKAPPAS(0.6),
    LCKAPPAS(0.0),
    WCKAPPAS(0.0),
    PCKAPPAS(0.0),
    CKAPPAD(0.6),
    LCKAPPAD(0.0),
    WCKAPPAD(0.0),
    PCKAPPAD(0.0),
    DMCG(0.0),
    DMCI(0.0),
    DMDG(0.0),
    DMCGT(0.0),
    XGL(0.0),
    RSHG(0.1),
    CJS(5.0e-4),
    CJD(0.0),
    CJSWS(5.0e-10),
    CJSWD(0.0),
    CJSWGS(0.0),
    CJSWGD(0.0),
    PBS(1.0),
    PBD(0.0),
    PBSWS(1.0),
    PBSWD(0.0),
    PBSWGS(0.0),
    PBSWGD(0.0),
    MJS(0.5),
    MJD(0.0),
    MJSWS(0.33),
    MJSWD(0.0),
    MJSWGS(0.0),
    MJSWGD(0.0),
    JSS(1.0e-4),
    JSD(0.0),
    JSWS(0.0),
    JSWD(0.0),
    JSWGS(0.0),
    JSWGD(0.0),
    NJS(1.0),
    NJD(0.0),
    IJTHSFWD(0.1),
    IJTHDFWD(0.0),
    IJTHSREV(0.1),
    IJTHDREV(0.0),
    BVS(10.0),
    BVD(0.0),
    XJBVS(1.0),
    XJBVD(0.0),
    JTSS(0.0),
    JTSD(0.0),
    JTSSWS(0.0),
    JTSSWD(0.0),
    JTSSWGS(0.0),
    JTSSWGD(0.0),
    JTWEFF(0.0),
    NJTS(20.0),
    NJTSD(0.0),
    NJTSSW(20.0),
    NJTSSWD(0.0),
    NJTSSWG(20.0),
    NJTSSWGD(0.0),
    VTSS(10.0),
    VTSD(0.0),
    VTSSWS(10.0),
    VTSSWD(0.0),
    VTSSWGS(10.0),
    VTSSWGD(0.0),
    XRCRG1(12.0),
    XRCRG2(1.0),
    GBMIN(1.0e-12),
    RBPS0(50.0),
    RBPSL(0.0),
    RBPSW(0.0),
    RBPSNF(0.0),
    RBPD0(50.0),
    RBPDL(0.0),
    RBPDW(0.0),
    RBPDNF(0.0),
    RBPBX0(100.0),
    RBPBXL(0.0),
    RBPBXW(0.0),
    RBPBXNF(0.0),
    RBPBY0(100.0),
    RBPBYL(0.0),
    RBPBYW(0.0),
    RBPBYNF(0.0),
    RBSBX0(100.0),
    RBSBY0(100.0),
    RBDBX0(100.0),
    RBDBY0(100.0),
    RBSDBXL(0.0),
    RBSDBXW(0.0),
    RBSDBXNF(0.0),
    RBSDBYL(0.0),
    RBSDBYW(0.0),
    RBSDBYNF(0.0),
    EF(1.0),
    EM(4.1e7),
    NOIA(6.250e+40),
    NOIB(3.125e+25),
    NOIC(8.750e+8),
    LINTNOI(0.0),
    NTNOI(1.0),
    RNOIA(0.577),
    RNOIB(0.5164),
    RNOIC(0.395),
    TNOIA(0.0),
    TNOIB(0.0),
    TNOIC(0.0),
    BINUNIT(1),
    DLBIN(0.0),
    DWBIN(0.0),
    TNOM(27.0),
    DTEMP(0.0),
    TBGASUB(4.73e-4),
    TBGBSUB(636.0),
    TNFACTOR(0.0),
    UTE((-1.5)),
    LUTE(0.0),
    WUTE(0.0),
    PUTE(0.0),
    UTEL(0.0),
    UA1(1.0e-3),
    LUA1(0.0),
    WUA1(0.0),
    PUA1(0.0),
    UA1L(0.0),
    UC1(0.056e-9),
    LUC1(0.0),
    WUC1(0.0),
    PUC1(0.0),
    UD1(0.0),
    LUD1(0.0),
    WUD1(0.0),
    PUD1(0.0),
    UD1L(0.0),
    UCSTE((-4.775e-3)),
    LUCSTE(0.0),
    WUCSTE(0.0),
    PUCSTE(0.0),
    TETA0(0.0),
    PRT(0.0),
    LPRT(0.0),
    WPRT(0.0),
    PPRT(0.0),
    AT((-1.56e-3)),
    LAT(0.0),
    WAT(0.0),
    PAT(0.0),
    ATL(0.0),
    TDELTA(0.0),
    PTWGT(0.0),
    LPTWGT(0.0),
    WPTWGT(0.0),
    PPTWGT(0.0),
    PTWGTL(0.0),
    KT1((-0.11)),
    KT1EXP(1.0),
    KT1L(0.0),
    LKT1(0.0),
    WKT1(0.0),
    PKT1(0.0),
    KT2(0.022),
    LKT2(0.0),
    WKT2(0.0),
    PKT2(0.0),
    IIT(0.0),
    LIIT(0.0),
    WIIT(0.0),
    PIIT(0.0),
    IGT(2.5),
    LIGT(0.0),
    WIGT(0.0),
    PIGT(0.0),
    TGIDL(0.0),
    LTGIDL(0.0),
    WTGIDL(0.0),
    PTGIDL(0.0),
    TCJ(0.0),
    TCJSW(0.0),
    TCJSWG(0.0),
    TPB(0.0),
    TPBSW(0.0),
    TPBSWG(0.0),
    XTIS(3.0),
    XTID(0.0),
    XTSS(0.02),
    XTSD(0.0),
    XTSSWS(0.02),
    XTSSWD(0.0),
    XTSSWGS(0.02),
    XTSSWGD(0.0),
    TNJTS(0.0),
    TNJTSD(0.0),
    TNJTSSW(0.0),
    TNJTSSWD(0.0),
    TNJTSSWG(0.0),
    TNJTSSWGD(0.0),
    RTH0(0.0),
    CTH0(1.0E-05),
    WTH0(0.0),
    SAREF(1.0e-6),
    SBREF(1.0e-6),
    WLOD(0.0),
    KU0(0.0),
    KVSAT(0.0),
    TKU0(0.0),
    LKU0(0.0),
    WKU0(0.0),
    PKU0(0.0),
    LLODKU0(0.0),
    WLODKU0(0.0),
    KVTH0(0.0),
    LKVTH0(0.0),
    WKVTH0(0.0),
    PKVTH0(0.0),
    LLODVTH(0.0),
    WLODVTH(0.0),
    STK2(0.0),
    LODK2(0.0),
    STETA0(0.0),
    LODETA0(0.0),
    WEB(0.0),
    WEC(0.0),
    KVTH0WE(0.0),
    LKVTH0WE(0.0),
    WKVTH0WE(0.0),
    PKVTH0WE(0.0),
    K2WE(0.0),
    LK2WE(0.0),
    WK2WE(0.0),
    PK2WE(0.0),
    KU0WE(0.0),
    LKU0WE(0.0),
    WKU0WE(0.0),
    PKU0WE(0.0),
    SCREF(1.0e-6),
    EDGEFET(1),
    WEDGE(10.0e-9),
    DGAMMAEDGE(0.0),
    DGAMMAEDGEL(0.0),
    DGAMMAEDGELEXP(1.0),
    DVTEDGE(0.0),
    NFACTOREDGE(0.0),
    CITEDGE(0.0),
    CDSCDEDGE(0.0),
    CDSCBEDGE(0.0),
    ETA0EDGE(0.0),
    ETABEDGE(0.0),
    KT1EDGE(0.0),
    KT1LEDGE(0.0),
    KT2EDGE(0.0),
    KT1EXPEDGE(0.0),
    TNFACTOREDGE(0.0),
    TETA0EDGE(0.0),
    DVT0EDGE(2.2),
    DVT1EDGE(0.53),
    DVT2EDGE(0.0),
    LMIN(0.0),
    WMIN(0.0),
    LMAX(100.0),
    WMAX(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
      os << "L  =  " << (*iter)->L << std::endl;
      os << "W  =  " << (*iter)->W << std::endl;
      os << "NF  =  " << (*iter)->NF << std::endl;
      os << "NRS  =  " << (*iter)->NRS << std::endl;
      os << "NRD  =  " << (*iter)->NRD << std::endl;
      os << "VFBSDOFF  =  " << (*iter)->VFBSDOFF << std::endl;
      os << "MINZ  =  " << (*iter)->MINZ << std::endl;
      os << "XGW  =  " << (*iter)->XGW << std::endl;
      os << "NGCON  =  " << (*iter)->NGCON << std::endl;
      os << "RGATEMOD  =  " << (*iter)->RGATEMOD << std::endl;
      os << "RBODYMOD  =  " << (*iter)->RBODYMOD << std::endl;
      os << "GEOMOD  =  " << (*iter)->GEOMOD << std::endl;
      os << "RGEOMOD  =  " << (*iter)->RGEOMOD << std::endl;
      os << "RBPB  =  " << (*iter)->RBPB << std::endl;
      os << "RBPD  =  " << (*iter)->RBPD << std::endl;
      os << "RBPS  =  " << (*iter)->RBPS << std::endl;
      os << "RBDB  =  " << (*iter)->RBDB << std::endl;
      os << "RBSB  =  " << (*iter)->RBSB << std::endl;
      os << "SA  =  " << (*iter)->SA << std::endl;
      os << "SB  =  " << (*iter)->SB << std::endl;
      os << "SD  =  " << (*iter)->SD << std::endl;
      os << "SCA  =  " << (*iter)->SCA << std::endl;
      os << "SCB  =  " << (*iter)->SCB << std::endl;
      os << "SCC  =  " << (*iter)->SCC << std::endl;
      os << "SC  =  " << (*iter)->SC << std::endl;
      os << "AS  =  " << (*iter)->AS << std::endl;
      os << "AD  =  " << (*iter)->AD << std::endl;
      os << "PS  =  " << (*iter)->PS << std::endl;
      os << "PD  =  " << (*iter)->PD << std::endl;
      os << "M  =  " << (*iter)->m << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("M") != deviceMap.end() && (levelSet.find(77)!=levelSet.end()))))
{
MOSFET1::registerDevice();
  Config<Traits>::addConfiguration()
    .registerDevice("m", 77)
    .registerModelType("nmos", 77)
    .registerModelType("pmos", 77);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
const int admsNodeID_d,
const int admsNodeID_g,
const int admsNodeID_s,
const int admsNodeID_b,
const int admsNodeID_t,
const int admsNodeID_di,
const int admsNodeID_si,
const int admsNodeID_gi,
const int admsNodeID_gm,
const int admsNodeID_bi,
const int admsNodeID_sbulk,
const int admsNodeID_dbulk,
const int admsNodeID_N1,
const int admsNodeID_N2,
 const std::vector<bool> & portsConnected_,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  double ToxRatioEdge=0.0;
double d_ToxRatioEdge_dX=0.0;
  double Rbpby=0.0;
double d_Rbpby_dX=0.0;
  double Rbpbx=0.0;
double d_Rbpbx_dX=0.0;
  double Rbdby=0.0;
double d_Rbdby_dX=0.0;
  double Rbdbx=0.0;
double d_Rbdbx_dX=0.0;
  double Rbsby=0.0;
double d_Rbsby_dX=0.0;
  double Rbsbx=0.0;
double d_Rbsbx_dX=0.0;
  double Rbsb=0.0;
double d_Rbsb_dX=0.0;
  double Rbdb=0.0;
double d_Rbdb_dX=0.0;
  double Rbps=0.0;
double d_Rbps_dX=0.0;
  double Rbpd=0.0;
double d_Rbpd_dX=0.0;
  double Rbpb=0.0;
double d_Rbpb_dX=0.0;
  double Bodymode=0.0;
  double Lnnf=0.0;
double d_Lnnf_dX=0.0;
  double Lnw=0.0;
double d_Lnw_dX=0.0;
  double Lnl=0.0;
double d_Lnl_dX=0.0;
  double Rtot=0.0;
double d_Rtot_dX=0.0;
  double Rint=0.0;
double d_Rint_dX=0.0;
  double Rend=0.0;
double d_Rend_dX=0.0;
  double NTOX_i=0.0;
double d_NTOX_i_dX=0.0;
  double POXEDGE_i=0.0;
double d_POXEDGE_i_dX=0.0;
  double BIN_WL=0.0;
double d_BIN_WL_dX=0.0;
  double BIN_W=0.0;
double d_BIN_W_dX=0.0;
  double BIN_L=0.0;
double d_BIN_L_dX=0.0;
  double Weff1=0.0;
double d_Weff1_dX=0.0;
  double Leff1=0.0;
double d_Leff1_dX=0.0;
  double dWB=0.0;
double d_dWB_dX=0.0;
  double LW_WLN_WWN1=0.0;
double d_LW_WLN_WWN1_dX=0.0;
  double dLB=0.0;
double d_dLB_dX=0.0;
  double LW_LLN_LWN1=0.0;
double d_LW_LLN_LWN1_dX=0.0;
  double Inv_WL=0.0;
double d_Inv_WL_dX=0.0;
  double Inv_Wwide=0.0;
double d_Inv_Wwide_dX=0.0;
  double Inv_Llong=0.0;
double d_Inv_Llong_dX=0.0;
  double Inv_Wact=0.0;
double d_Inv_Wact_dX=0.0;
  double Inv_Lact=0.0;
double d_Inv_Lact_dX=0.0;
  double Inv_W=0.0;
double d_Inv_W_dX=0.0;
  double Inv_L=0.0;
double d_Inv_L_dX=0.0;
  double dWJ=0.0;
double d_dWJ_dX=0.0;
  double dWCV=0.0;
double d_dWCV_dX=0.0;
  double dLCV=0.0;
double d_dLCV_dX=0.0;
  double dWIV=0.0;
double d_dWIV_dX=0.0;
  double LW_WLN_WWN=0.0;
double d_LW_WLN_WWN_dX=0.0;
  double W_WWN=0.0;
double d_W_WWN_dX=0.0;
  double L_WLN=0.0;
double d_L_WLN_dX=0.0;
  double dLIV=0.0;
double d_dLIV_dX=0.0;
  double LW_LLN_LWN=0.0;
double d_LW_LLN_LWN_dX=0.0;
  double W_LWN=0.0;
double d_W_LWN_dX=0.0;
  double L_LLN=0.0;
double d_L_LLN_dX=0.0;
  double W_by_NF=0.0;
double d_W_by_NF_dX=0.0;
  double W_mult=0.0;
double d_W_mult_dX=0.0;
  double W_WWN1=0.0;
double d_W_WWN1_dX=0.0;
  double W_LWN1=0.0;
double d_W_LWN1_dX=0.0;
  double L_WLN1=0.0;
double d_L_WLN1_dX=0.0;
  double L_LLN1=0.0;
double d_L_LLN1_dX=0.0;
//Begin block initial_instance
{
instanceStruct.d_instanceVar_CDSCDR_i_dX = 0.0;
instanceStruct.instanceVar_CDSCDR_i = 0;
instanceStruct.d_instanceVar_ETA0R_i_dX = 0.0;
instanceStruct.instanceVar_ETA0R_i = 0;
instanceStruct.d_instanceVar_ETA0R_t_dX = 0.0;
instanceStruct.instanceVar_ETA0R_t = 0;
d_L_LLN1_dX = 0.0;
L_LLN1 = 0;
d_L_WLN1_dX = 0.0;
L_WLN1 = 0;
instanceStruct.d_instanceVar_PCLMR_i_dX = 0.0;
instanceStruct.instanceVar_PCLMR_i = 0;
instanceStruct.d_instanceVar_PDIBLCR_i_dX = 0.0;
instanceStruct.instanceVar_PDIBLCR_i = 0;
instanceStruct.d_instanceVar_PSATR_i_dX = 0.0;
instanceStruct.instanceVar_PSATR_i = 0;
instanceStruct.d_instanceVar_PTWGR_i_dX = 0.0;
instanceStruct.instanceVar_PTWGR_i = 0;
instanceStruct.d_instanceVar_PTWGR_t_dX = 0.0;
instanceStruct.instanceVar_PTWGR_t = 0;
instanceStruct.d_instanceVar_U0R_i_dX = 0.0;
instanceStruct.instanceVar_U0R_i = 0;
instanceStruct.d_instanceVar_U0R_t_dX = 0.0;
instanceStruct.instanceVar_U0R_t = 0;
instanceStruct.d_instanceVar_UAR_i_dX = 0.0;
instanceStruct.instanceVar_UAR_i = 0;
instanceStruct.d_instanceVar_UAR_t_dX = 0.0;
instanceStruct.instanceVar_UAR_t = 0;
instanceStruct.d_instanceVar_UCR_i_dX = 0.0;
instanceStruct.instanceVar_UCR_i = 0;
instanceStruct.d_instanceVar_UCR_t_dX = 0.0;
instanceStruct.instanceVar_UCR_t = 0;
instanceStruct.d_instanceVar_UCSR_i_dX = 0.0;
instanceStruct.instanceVar_UCSR_i = 0;
instanceStruct.d_instanceVar_UCSR_t_dX = 0.0;
instanceStruct.instanceVar_UCSR_t = 0;
instanceStruct.d_instanceVar_UDR_i_dX = 0.0;
instanceStruct.instanceVar_UDR_i = 0;
instanceStruct.d_instanceVar_UDR_t_dX = 0.0;
instanceStruct.instanceVar_UDR_t = 0;
instanceStruct.d_instanceVar_UD_a_dX = 0.0;
instanceStruct.instanceVar_UD_a = 0;
instanceStruct.d_instanceVar_VSATR_i_dX = 0.0;
instanceStruct.instanceVar_VSATR_i = 0;
instanceStruct.d_instanceVar_VSATR_t_dX = 0.0;
instanceStruct.instanceVar_VSATR_t = 0;
d_W_LWN1_dX = 0.0;
W_LWN1 = 0;
d_W_WWN1_dX = 0.0;
W_WWN1 = 0;
if ((modelStruct.modelPar_TYPE==1))
{
instanceStruct.instanceVar_devsign = 1;
}
else
{
instanceStruct.instanceVar_devsign = (-1);
}
instanceStruct.d_instanceVar_epssi_dX = modelStruct.d_modelPar_EPSRSUB_dX*8.85418e-12;
instanceStruct.instanceVar_epssi = (modelStruct.modelPar_EPSRSUB*8.85418e-12);
instanceStruct.d_instanceVar_epsox_dX = modelStruct.d_modelPar_EPSROX_dX*8.85418e-12;
instanceStruct.instanceVar_epsox = (modelStruct.modelPar_EPSROX*8.85418e-12);
instanceStruct.d_instanceVar_Cox_dX = ((modelStruct.modelPar_TOXE*modelStruct.d_modelPar_EPSROX_dX*8.85418e-12-(modelStruct.modelPar_EPSROX*8.85418e-12)*modelStruct.d_modelPar_TOXE_dX)/modelStruct.modelPar_TOXE/modelStruct.modelPar_TOXE);
instanceStruct.instanceVar_Cox = ((modelStruct.modelPar_EPSROX*8.85418e-12)/modelStruct.modelPar_TOXE);
instanceStruct.d_instanceVar_epsratio_dX = ((modelStruct.modelPar_EPSROX*modelStruct.d_modelPar_EPSRSUB_dX-modelStruct.modelPar_EPSRSUB*modelStruct.d_modelPar_EPSROX_dX)/modelStruct.modelPar_EPSROX/modelStruct.modelPar_EPSROX);
instanceStruct.instanceVar_epsratio = (modelStruct.modelPar_EPSRSUB/modelStruct.modelPar_EPSROX);
if ((!modelStruct.modelPar_given_TOXP))
{
instanceStruct.d_instanceVar_BSIM6TOXP_dX = (((modelStruct.modelPar_TOXE*modelStruct.d_modelPar_EPSROX_dX+modelStruct.d_modelPar_TOXE_dX*modelStruct.modelPar_EPSROX)/3.9)-modelStruct.d_modelPar_DTOX_dX);
instanceStruct.instanceVar_BSIM6TOXP = (((modelStruct.modelPar_TOXE*modelStruct.modelPar_EPSROX)/3.9)-modelStruct.modelPar_DTOX);
}
else
{
instanceStruct.d_instanceVar_BSIM6TOXP_dX = modelStruct.d_modelPar_TOXP_dX;
instanceStruct.instanceVar_BSIM6TOXP = modelStruct.modelPar_TOXP;
}
instanceStruct.d_instanceVar_L_mult_dX = (instanceStruct.instancePar_L*modelStruct.d_modelPar_LMLT_dX+instanceStruct.d_instancePar_L_dX*modelStruct.modelPar_LMLT);
instanceStruct.instanceVar_L_mult = (instanceStruct.instancePar_L*modelStruct.modelPar_LMLT);
d_W_mult_dX = (instanceStruct.instancePar_W*modelStruct.d_modelPar_WMLT_dX+instanceStruct.d_instancePar_W_dX*modelStruct.modelPar_WMLT);
W_mult = (instanceStruct.instancePar_W*modelStruct.modelPar_WMLT);
instanceStruct.d_instanceVar_Lnew_dX = (instanceStruct.d_instanceVar_L_mult_dX+modelStruct.d_modelPar_XL_dX);
instanceStruct.instanceVar_Lnew = (instanceStruct.instanceVar_L_mult+modelStruct.modelPar_XL);
if ((instanceStruct.instanceVar_Lnew<=0))
{
UserInfo(theInstance)  << "Fatal: Ldrawn*LMLT+XL = %e for  %M is non-positive" << " " << instanceStruct.instanceVar_Lnew << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
d_W_by_NF_dX = (d_W_mult_dX/instanceStruct.instancePar_NF);
W_by_NF = (W_mult/instanceStruct.instancePar_NF);
instanceStruct.d_instanceVar_Wnew_dX = (d_W_by_NF_dX+modelStruct.d_modelPar_XW_dX);
instanceStruct.instanceVar_Wnew = (W_by_NF+modelStruct.modelPar_XW);
if ((instanceStruct.instanceVar_Wnew<=0))
{
UserInfo(theInstance)  << "Fatal: W/NF*WMLT+XW = %e for  %M is non-positive" << " " << instanceStruct.instanceVar_Wnew << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
{
double value_pow_0 = pow(instanceStruct.instanceVar_Lnew,(-modelStruct.modelPar_LLN));
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Lnew == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_LLN)/instanceStruct.instanceVar_Lnew));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Lnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Lnew)*value_pow_0);
d_L_LLN_dX = ((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Lnew_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_LLN_dX))));
L_LLN = value_pow_0;
}
{
double value_pow_0 = pow(instanceStruct.instanceVar_Wnew,(-modelStruct.modelPar_LWN));
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Wnew == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_LWN)/instanceStruct.instanceVar_Wnew));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Wnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Wnew)*value_pow_0);
d_W_LWN_dX = ((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Wnew_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_LWN_dX))));
W_LWN = value_pow_0;
}
d_LW_LLN_LWN_dX = (L_LLN*d_W_LWN_dX+d_L_LLN_dX*W_LWN);
LW_LLN_LWN = (L_LLN*W_LWN);
d_dLIV_dX = (((modelStruct.d_modelPar_LINT_dX+(modelStruct.modelPar_LL*d_L_LLN_dX+modelStruct.d_modelPar_LL_dX*L_LLN))+(modelStruct.modelPar_LW*d_W_LWN_dX+modelStruct.d_modelPar_LW_dX*W_LWN))+(modelStruct.modelPar_LWL*d_LW_LLN_LWN_dX+modelStruct.d_modelPar_LWL_dX*LW_LLN_LWN));
dLIV = (((modelStruct.modelPar_LINT+(modelStruct.modelPar_LL*L_LLN))+(modelStruct.modelPar_LW*W_LWN))+(modelStruct.modelPar_LWL*LW_LLN_LWN));
{
double value_pow_0 = pow(instanceStruct.instanceVar_Lnew,(-modelStruct.modelPar_WLN));
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Lnew == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_WLN)/instanceStruct.instanceVar_Lnew));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Lnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Lnew)*value_pow_0);
d_L_WLN_dX = ((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Lnew_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_WLN_dX))));
L_WLN = value_pow_0;
}
{
double value_pow_0 = pow(instanceStruct.instanceVar_Wnew,(-modelStruct.modelPar_WWN));
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Wnew == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_WWN)/instanceStruct.instanceVar_Wnew));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Wnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Wnew)*value_pow_0);
d_W_WWN_dX = ((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Wnew_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_WWN_dX))));
W_WWN = value_pow_0;
}
d_LW_WLN_WWN_dX = (L_WLN*d_W_WWN_dX+d_L_WLN_dX*W_WWN);
LW_WLN_WWN = (L_WLN*W_WWN);
d_dWIV_dX = (((modelStruct.d_modelPar_WINT_dX+(modelStruct.modelPar_WL*d_L_WLN_dX+modelStruct.d_modelPar_WL_dX*L_WLN))+(modelStruct.modelPar_WW*d_W_WWN_dX+modelStruct.d_modelPar_WW_dX*W_WWN))+(modelStruct.modelPar_WWL*d_LW_WLN_WWN_dX+modelStruct.d_modelPar_WWL_dX*LW_WLN_WWN));
dWIV = (((modelStruct.modelPar_WINT+(modelStruct.modelPar_WL*L_WLN))+(modelStruct.modelPar_WW*W_WWN))+(modelStruct.modelPar_WWL*LW_WLN_WWN));
instanceStruct.d_instanceVar_Leff_dX = (instanceStruct.d_instanceVar_Lnew_dX-2.0*d_dLIV_dX);
instanceStruct.instanceVar_Leff = (instanceStruct.instanceVar_Lnew-(2.0*dLIV));
if ((instanceStruct.instanceVar_Leff<=0))
{
UserInfo(theInstance)  << "Fatal: Effective channel length = %e for  %M is non-positive" << " " << instanceStruct.instanceVar_Leff << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
else
{
if ((instanceStruct.instanceVar_Leff<=1.0e-9))
{
UserInfo(theInstance)  << "Warning: Effective channel length = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << " " << instanceStruct.instanceVar_Leff << " " <<  std::endl; 
}
}
instanceStruct.d_instanceVar_Weff_dX = (instanceStruct.d_instanceVar_Wnew_dX-2.0*d_dWIV_dX);
instanceStruct.instanceVar_Weff = (instanceStruct.instanceVar_Wnew-(2.0*dWIV));
if ((instanceStruct.instanceVar_Weff<=0))
{
UserInfo(theInstance)  << "Fatal: Effective channel Width = %e for  %M is non-positive" << " " << instanceStruct.instanceVar_Weff << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
else
{
if ((instanceStruct.instanceVar_Weff<=1.0e-9))
{
UserInfo(theInstance)  << "Warning: Effective channel width = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << " " << instanceStruct.instanceVar_Leff << " " <<  std::endl; 
}
}
d_dLCV_dX = (((modelStruct.d_modelPar_DLC_dX+(modelStruct.modelPar_LLC*d_L_LLN_dX+modelStruct.d_modelPar_LLC_dX*L_LLN))+(modelStruct.modelPar_LWC*d_W_LWN_dX+modelStruct.d_modelPar_LWC_dX*W_LWN))+(modelStruct.modelPar_LWLC*d_LW_LLN_LWN_dX+modelStruct.d_modelPar_LWLC_dX*LW_LLN_LWN));
dLCV = (((modelStruct.modelPar_DLC+(modelStruct.modelPar_LLC*L_LLN))+(modelStruct.modelPar_LWC*W_LWN))+(modelStruct.modelPar_LWLC*LW_LLN_LWN));
d_dWCV_dX = (((modelStruct.d_modelPar_DWC_dX+(modelStruct.modelPar_WLC*d_L_WLN_dX+modelStruct.d_modelPar_WLC_dX*L_WLN))+(modelStruct.modelPar_WWC*d_W_WWN_dX+modelStruct.d_modelPar_WWC_dX*W_WWN))+(modelStruct.modelPar_WWLC*d_LW_WLN_WWN_dX+modelStruct.d_modelPar_WWLC_dX*LW_WLN_WWN));
dWCV = (((modelStruct.modelPar_DWC+(modelStruct.modelPar_WLC*L_WLN))+(modelStruct.modelPar_WWC*W_WWN))+(modelStruct.modelPar_WWLC*LW_WLN_WWN));
instanceStruct.d_instanceVar_Lact_dX = (instanceStruct.d_instanceVar_Lnew_dX-2.0*d_dLCV_dX);
instanceStruct.instanceVar_Lact = (instanceStruct.instanceVar_Lnew-(2.0*dLCV));
if ((instanceStruct.instanceVar_Lact<=0))
{
UserInfo(theInstance)  << "Fatal: Effective channel length for CV = %e for  %M is non-positive" << " " << instanceStruct.instanceVar_Lact << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
else
{
if ((instanceStruct.instanceVar_Lact<=1.0e-9))
{
UserInfo(theInstance)  << "Warning: Effective channel length for CV = %e for  %M is <= 1.0e-9. Recommended Leff >= 1e-8" << " " << instanceStruct.instanceVar_Leff << " " <<  std::endl; 
}
}
instanceStruct.d_instanceVar_Wact_dX = (instanceStruct.d_instanceVar_Wnew_dX-2.0*d_dWCV_dX);
instanceStruct.instanceVar_Wact = (instanceStruct.instanceVar_Wnew-(2.0*dWCV));
if ((instanceStruct.instanceVar_Wact<=0))
{
UserInfo(theInstance)  << "Fatal: Effective channel width for CV = %e for  %M is non-positive" << " " << instanceStruct.instanceVar_Wact << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
else
{
if ((instanceStruct.instanceVar_Wact<=1.0e-9))
{
UserInfo(theInstance)  << "Warning: Effective channel width for CV = %e for  %M is <= 1.0e-9. Recommended Weff >= 1e-8" << " " << instanceStruct.instanceVar_Leff << " " <<  std::endl; 
}
}
{
double value_pow_0 = pow(instanceStruct.instanceVar_Lnew,modelStruct.modelPar_WLN);
double value_pow_1 = pow(instanceStruct.instanceVar_Wnew,modelStruct.modelPar_WWN);
double value_pow_2 = pow(instanceStruct.instanceVar_Lnew,modelStruct.modelPar_WLN);
double value_pow_3 = pow(instanceStruct.instanceVar_Wnew,modelStruct.modelPar_WWN);
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Lnew == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_WLN/instanceStruct.instanceVar_Lnew));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Lnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Lnew)*value_pow_0);
double  deriv_pow_1_d0 = ((instanceStruct.instanceVar_Wnew == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_WWN/instanceStruct.instanceVar_Wnew));
double  deriv_pow_1_d1 = (instanceStruct.instanceVar_Wnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Wnew)*value_pow_1);
double  deriv_pow_2_d0 = ((instanceStruct.instanceVar_Lnew == 0.0)?0.0:(value_pow_2*modelStruct.modelPar_WLN/instanceStruct.instanceVar_Lnew));
double  deriv_pow_2_d1 = (instanceStruct.instanceVar_Lnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Lnew)*value_pow_2);
double  deriv_pow_3_d0 = ((instanceStruct.instanceVar_Wnew == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_WWN/instanceStruct.instanceVar_Wnew));
double  deriv_pow_3_d1 = (instanceStruct.instanceVar_Wnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Wnew)*value_pow_3);
d_dWJ_dX = (((modelStruct.d_modelPar_DWJ_dX+((value_pow_0*modelStruct.d_modelPar_WLC_dX-modelStruct.modelPar_WLC*((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Lnew_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_WLN_dX))))/value_pow_0/value_pow_0))+((value_pow_1*modelStruct.d_modelPar_WWC_dX-modelStruct.modelPar_WWC*((deriv_pow_1_d0*(instanceStruct.d_instanceVar_Wnew_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_WWN_dX))))/value_pow_1/value_pow_1))+((value_pow_3*((value_pow_2*modelStruct.d_modelPar_WWLC_dX-modelStruct.modelPar_WWLC*((deriv_pow_2_d0*(instanceStruct.d_instanceVar_Lnew_dX))+(deriv_pow_2_d1*(modelStruct.d_modelPar_WLN_dX))))/value_pow_2/value_pow_2)-(modelStruct.modelPar_WWLC/value_pow_2)*((deriv_pow_3_d0*(instanceStruct.d_instanceVar_Wnew_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_WWN_dX))))/value_pow_3/value_pow_3));
dWJ = (((modelStruct.modelPar_DWJ+(modelStruct.modelPar_WLC/value_pow_0))+(modelStruct.modelPar_WWC/value_pow_1))+((modelStruct.modelPar_WWLC/value_pow_2)/value_pow_3));
}
instanceStruct.d_instanceVar_Weffcj_dX = (instanceStruct.d_instanceVar_Wnew_dX-2.0*d_dWJ_dX);
instanceStruct.instanceVar_Weffcj = (instanceStruct.instanceVar_Wnew-(2.0*dWJ));
if ((instanceStruct.instanceVar_Weffcj<=0))
{
UserInfo(theInstance)  << "Fatal: Effective channel width for S/D junctions = %e for  %M is non-positive" << " " << instanceStruct.instanceVar_Weffcj << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
d_Inv_L_dX = (-1.0e-6*instanceStruct.d_instanceVar_Leff_dX/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff);
Inv_L = (1.0e-6/instanceStruct.instanceVar_Leff);
d_Inv_W_dX = (-1.0e-6*instanceStruct.d_instanceVar_Weff_dX/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Inv_W = (1.0e-6/instanceStruct.instanceVar_Weff);
d_Inv_Lact_dX = (-1.0e-6*instanceStruct.d_instanceVar_Lact_dX/instanceStruct.instanceVar_Lact/instanceStruct.instanceVar_Lact);
Inv_Lact = (1.0e-6/instanceStruct.instanceVar_Lact);
d_Inv_Wact_dX = (-1.0e-6*instanceStruct.d_instanceVar_Wact_dX/instanceStruct.instanceVar_Wact/instanceStruct.instanceVar_Wact);
Inv_Wact = (1.0e-6/instanceStruct.instanceVar_Wact);
d_Inv_Llong_dX = (-1.0e-6*modelStruct.d_modelPar_LLONG_dX/modelStruct.modelPar_LLONG/modelStruct.modelPar_LLONG);
Inv_Llong = (1.0e-6/modelStruct.modelPar_LLONG);
d_Inv_Wwide_dX = (-1.0e-6*modelStruct.d_modelPar_WWIDE_dX/modelStruct.modelPar_WWIDE/modelStruct.modelPar_WWIDE);
Inv_Wwide = (1.0e-6/modelStruct.modelPar_WWIDE);
d_Inv_WL_dX = (Inv_L*d_Inv_W_dX+d_Inv_L_dX*Inv_W);
Inv_WL = (Inv_L*Inv_W);
d_L_LLN1_dX = d_L_LLN_dX;
L_LLN1 = L_LLN;
d_L_WLN1_dX = d_L_WLN_dX;
L_WLN1 = L_WLN;
if ((modelStruct.modelPar_DLBIN!=0))
{
if ((modelStruct.modelPar_DLBIN<=(-instanceStruct.instanceVar_Lnew)))
{
UserInfo(theInstance)  << "Fatal: DLBIN for  %M = %e is <= -Ldrawn*LMLT" << " " << modelStruct.modelPar_DLBIN << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
else
{
{
double value_pow_0 = pow((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN),(-modelStruct.modelPar_LLN));
double  deriv_pow_0_d0 = (((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_LLN)/(instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN)));
double  deriv_pow_0_d1 = ((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN) == 0.0)?0.0:(log((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN))*value_pow_0);
d_L_LLN1_dX = ((deriv_pow_0_d0*((instanceStruct.d_instanceVar_Lnew_dX+modelStruct.d_modelPar_DLBIN_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_LLN_dX))));
L_LLN1 = value_pow_0;
}
{
double value_pow_0 = pow((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN),(-modelStruct.modelPar_WLN));
double  deriv_pow_0_d0 = (((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_WLN)/(instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN)));
double  deriv_pow_0_d1 = ((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN) == 0.0)?0.0:(log((instanceStruct.instanceVar_Lnew+modelStruct.modelPar_DLBIN))*value_pow_0);
d_L_WLN1_dX = ((deriv_pow_0_d0*((instanceStruct.d_instanceVar_Lnew_dX+modelStruct.d_modelPar_DLBIN_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_WLN_dX))));
L_WLN1 = value_pow_0;
}
}
}
d_W_LWN1_dX = d_W_LWN_dX;
W_LWN1 = W_LWN;
d_W_WWN1_dX = d_W_WWN_dX;
W_WWN1 = W_WWN;
if ((modelStruct.modelPar_DWBIN!=0))
{
if ((modelStruct.modelPar_DWBIN<=(-instanceStruct.instanceVar_Wnew)))
{
UserInfo(theInstance)  << "Fatal: DWBIN for  %M = %e is <= -Wdrawn*WMLT" << " " << modelStruct.modelPar_DWBIN << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
else
{
{
double value_pow_0 = pow((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN),(-modelStruct.modelPar_LWN));
double  deriv_pow_0_d0 = (((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_LWN)/(instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN)));
double  deriv_pow_0_d1 = ((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN) == 0.0)?0.0:(log((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN))*value_pow_0);
d_W_LWN1_dX = ((deriv_pow_0_d0*((instanceStruct.d_instanceVar_Wnew_dX+modelStruct.d_modelPar_DWBIN_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_LWN_dX))));
W_LWN1 = value_pow_0;
}
{
double value_pow_0 = pow((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN),(-modelStruct.modelPar_WWN));
double  deriv_pow_0_d0 = (((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_WWN)/(instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN)));
double  deriv_pow_0_d1 = ((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN) == 0.0)?0.0:(log((instanceStruct.instanceVar_Wnew+modelStruct.modelPar_DWBIN))*value_pow_0);
d_W_WWN1_dX = ((deriv_pow_0_d0*((instanceStruct.d_instanceVar_Wnew_dX+modelStruct.d_modelPar_DWBIN_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_WWN_dX))));
W_WWN1 = value_pow_0;
}
}
}
d_LW_LLN_LWN1_dX = (L_LLN1*d_W_LWN1_dX+d_L_LLN1_dX*W_LWN1);
LW_LLN_LWN1 = (L_LLN1*W_LWN1);
d_dLB_dX = (((modelStruct.d_modelPar_LINT_dX+(modelStruct.modelPar_LL*d_L_LLN1_dX+modelStruct.d_modelPar_LL_dX*L_LLN1))+(modelStruct.modelPar_LW*d_W_LWN1_dX+modelStruct.d_modelPar_LW_dX*W_LWN1))+(modelStruct.modelPar_LWL*d_LW_LLN_LWN1_dX+modelStruct.d_modelPar_LWL_dX*LW_LLN_LWN1));
dLB = (((modelStruct.modelPar_LINT+(modelStruct.modelPar_LL*L_LLN1))+(modelStruct.modelPar_LW*W_LWN1))+(modelStruct.modelPar_LWL*LW_LLN_LWN1));
d_LW_WLN_WWN1_dX = (L_WLN1*d_W_WWN1_dX+d_L_WLN1_dX*W_WWN1);
LW_WLN_WWN1 = (L_WLN1*W_WWN1);
d_dWB_dX = (((modelStruct.d_modelPar_WINT_dX+(modelStruct.modelPar_WL*d_L_WLN1_dX+modelStruct.d_modelPar_WL_dX*L_WLN1))+(modelStruct.modelPar_WW*d_W_WWN1_dX+modelStruct.d_modelPar_WW_dX*W_WWN1))+(modelStruct.modelPar_WWL*d_LW_WLN_WWN1_dX+modelStruct.d_modelPar_WWL_dX*LW_WLN_WWN1));
dWB = (((modelStruct.modelPar_WINT+(modelStruct.modelPar_WL*L_WLN1))+(modelStruct.modelPar_WW*W_WWN1))+(modelStruct.modelPar_WWL*LW_WLN_WWN1));
d_Leff1_dX = ((instanceStruct.d_instanceVar_Lnew_dX-2.0*d_dLB_dX)+modelStruct.d_modelPar_DLBIN_dX);
Leff1 = ((instanceStruct.instanceVar_Lnew-(2.0*dLB))+modelStruct.modelPar_DLBIN);
if ((Leff1<=0))
{
UserInfo(theInstance)  << "Fatal: Effective channel length for binning = %e for  %M is non-positive" << " " << Leff1 << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
d_Weff1_dX = ((instanceStruct.d_instanceVar_Wnew_dX-2.0*d_dWB_dX)+modelStruct.d_modelPar_DWBIN_dX);
Weff1 = ((instanceStruct.instanceVar_Wnew-(2.0*dWB))+modelStruct.modelPar_DWBIN);
if ((Weff1<=0))
{
UserInfo(theInstance)  << "Fatal: Effective channel width for binning = %e for  %M is non-positive" << " " << Weff1 << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((modelStruct.modelPar_BINUNIT==1))
{
d_BIN_L_dX = (-1.0e-6*d_Leff1_dX/Leff1/Leff1);
BIN_L = (1.0e-6/Leff1);
d_BIN_W_dX = (-1.0e-6*d_Weff1_dX/Weff1/Weff1);
BIN_W = (1.0e-6/Weff1);
}
else
{
d_BIN_L_dX = (-d_Leff1_dX/Leff1/Leff1);
BIN_L = (1.0/Leff1);
d_BIN_W_dX = (-d_Weff1_dX/Weff1/Weff1);
BIN_W = (1.0/Weff1);
}
d_BIN_WL_dX = (BIN_L*d_BIN_W_dX+d_BIN_L_dX*BIN_W);
BIN_WL = (BIN_L*BIN_W);
instanceStruct.d_instanceVar_VFB_i_dX = (((modelStruct.d_modelPar_VFB_dX+(BIN_L*modelStruct.d_modelPar_LVFB_dX+d_BIN_L_dX*modelStruct.modelPar_LVFB))+(BIN_W*modelStruct.d_modelPar_WVFB_dX+d_BIN_W_dX*modelStruct.modelPar_WVFB))+(BIN_WL*modelStruct.d_modelPar_PVFB_dX+d_BIN_WL_dX*modelStruct.modelPar_PVFB));
instanceStruct.instanceVar_VFB_i = (((modelStruct.modelPar_VFB+(BIN_L*modelStruct.modelPar_LVFB))+(BIN_W*modelStruct.modelPar_WVFB))+(BIN_WL*modelStruct.modelPar_PVFB));
instanceStruct.d_instanceVar_VFBCV_i_dX = (((modelStruct.d_modelPar_VFBCV_dX+(BIN_L*modelStruct.d_modelPar_LVFBCV_dX+d_BIN_L_dX*modelStruct.modelPar_LVFBCV))+(BIN_W*modelStruct.d_modelPar_WVFBCV_dX+d_BIN_W_dX*modelStruct.modelPar_WVFBCV))+(BIN_WL*modelStruct.d_modelPar_PVFBCV_dX+d_BIN_WL_dX*modelStruct.modelPar_PVFBCV));
instanceStruct.instanceVar_VFBCV_i = (((modelStruct.modelPar_VFBCV+(BIN_L*modelStruct.modelPar_LVFBCV))+(BIN_W*modelStruct.modelPar_WVFBCV))+(BIN_WL*modelStruct.modelPar_PVFBCV));
instanceStruct.d_instanceVar_NSD_i_dX = (((modelStruct.d_modelPar_NSD_dX+(BIN_L*modelStruct.d_modelPar_LNSD_dX+d_BIN_L_dX*modelStruct.modelPar_LNSD))+(BIN_W*modelStruct.d_modelPar_WNSD_dX+d_BIN_W_dX*modelStruct.modelPar_WNSD))+(BIN_WL*modelStruct.d_modelPar_PNSD_dX+d_BIN_WL_dX*modelStruct.modelPar_PNSD));
instanceStruct.instanceVar_NSD_i = (((modelStruct.modelPar_NSD+(BIN_L*modelStruct.modelPar_LNSD))+(BIN_W*modelStruct.modelPar_WNSD))+(BIN_WL*modelStruct.modelPar_PNSD));
instanceStruct.d_instanceVar_NDEP_i_dX = (((modelStruct.d_modelPar_NDEP_dX+(BIN_L*modelStruct.d_modelPar_LNDEP_dX+d_BIN_L_dX*modelStruct.modelPar_LNDEP))+(BIN_W*modelStruct.d_modelPar_WNDEP_dX+d_BIN_W_dX*modelStruct.modelPar_WNDEP))+(BIN_WL*modelStruct.d_modelPar_PNDEP_dX+d_BIN_WL_dX*modelStruct.modelPar_PNDEP));
instanceStruct.instanceVar_NDEP_i = (((modelStruct.modelPar_NDEP+(BIN_L*modelStruct.modelPar_LNDEP))+(BIN_W*modelStruct.modelPar_WNDEP))+(BIN_WL*modelStruct.modelPar_PNDEP));
instanceStruct.d_instanceVar_NDEPCV_i_dX = (((modelStruct.d_modelPar_NDEPCV_dX+(BIN_L*modelStruct.d_modelPar_LNDEPCV_dX+d_BIN_L_dX*modelStruct.modelPar_LNDEPCV))+(BIN_W*modelStruct.d_modelPar_WNDEPCV_dX+d_BIN_W_dX*modelStruct.modelPar_WNDEPCV))+(BIN_WL*modelStruct.d_modelPar_PNDEPCV_dX+d_BIN_WL_dX*modelStruct.modelPar_PNDEPCV));
instanceStruct.instanceVar_NDEPCV_i = (((modelStruct.modelPar_NDEPCV+(BIN_L*modelStruct.modelPar_LNDEPCV))+(BIN_W*modelStruct.modelPar_WNDEPCV))+(BIN_WL*modelStruct.modelPar_PNDEPCV));
instanceStruct.d_instanceVar_NGATE_i_dX = (((modelStruct.d_modelPar_NGATE_dX+(BIN_L*modelStruct.d_modelPar_LNGATE_dX+d_BIN_L_dX*modelStruct.modelPar_LNGATE))+(BIN_W*modelStruct.d_modelPar_WNGATE_dX+d_BIN_W_dX*modelStruct.modelPar_WNGATE))+(BIN_WL*modelStruct.d_modelPar_PNGATE_dX+d_BIN_WL_dX*modelStruct.modelPar_PNGATE));
instanceStruct.instanceVar_NGATE_i = (((modelStruct.modelPar_NGATE+(BIN_L*modelStruct.modelPar_LNGATE))+(BIN_W*modelStruct.modelPar_WNGATE))+(BIN_WL*modelStruct.modelPar_PNGATE));
instanceStruct.d_instanceVar_CIT_i_dX = (((modelStruct.d_modelPar_CIT_dX+(BIN_L*modelStruct.d_modelPar_LCIT_dX+d_BIN_L_dX*modelStruct.modelPar_LCIT))+(BIN_W*modelStruct.d_modelPar_WCIT_dX+d_BIN_W_dX*modelStruct.modelPar_WCIT))+(BIN_WL*modelStruct.d_modelPar_PCIT_dX+d_BIN_WL_dX*modelStruct.modelPar_PCIT));
instanceStruct.instanceVar_CIT_i = (((modelStruct.modelPar_CIT+(BIN_L*modelStruct.modelPar_LCIT))+(BIN_W*modelStruct.modelPar_WCIT))+(BIN_WL*modelStruct.modelPar_PCIT));
instanceStruct.d_instanceVar_NFACTOR_i_dX = (((modelStruct.d_modelPar_NFACTOR_dX+(BIN_L*modelStruct.d_modelPar_LNFACTOR_dX+d_BIN_L_dX*modelStruct.modelPar_LNFACTOR))+(BIN_W*modelStruct.d_modelPar_WNFACTOR_dX+d_BIN_W_dX*modelStruct.modelPar_WNFACTOR))+(BIN_WL*modelStruct.d_modelPar_PNFACTOR_dX+d_BIN_WL_dX*modelStruct.modelPar_PNFACTOR));
instanceStruct.instanceVar_NFACTOR_i = (((modelStruct.modelPar_NFACTOR+(BIN_L*modelStruct.modelPar_LNFACTOR))+(BIN_W*modelStruct.modelPar_WNFACTOR))+(BIN_WL*modelStruct.modelPar_PNFACTOR));
instanceStruct.d_instanceVar_CDSCD_i_dX = (((modelStruct.d_modelPar_CDSCD_dX+(BIN_L*modelStruct.d_modelPar_LCDSCD_dX+d_BIN_L_dX*modelStruct.modelPar_LCDSCD))+(BIN_W*modelStruct.d_modelPar_WCDSCD_dX+d_BIN_W_dX*modelStruct.modelPar_WCDSCD))+(BIN_WL*modelStruct.d_modelPar_PCDSCD_dX+d_BIN_WL_dX*modelStruct.modelPar_PCDSCD));
instanceStruct.instanceVar_CDSCD_i = (((modelStruct.modelPar_CDSCD+(BIN_L*modelStruct.modelPar_LCDSCD))+(BIN_W*modelStruct.modelPar_WCDSCD))+(BIN_WL*modelStruct.modelPar_PCDSCD));
instanceStruct.d_instanceVar_CDSCB_i_dX = (((modelStruct.d_modelPar_CDSCB_dX+(BIN_L*modelStruct.d_modelPar_LCDSCB_dX+d_BIN_L_dX*modelStruct.modelPar_LCDSCB))+(BIN_W*modelStruct.d_modelPar_WCDSCB_dX+d_BIN_W_dX*modelStruct.modelPar_WCDSCB))+(BIN_WL*modelStruct.d_modelPar_PCDSCB_dX+d_BIN_WL_dX*modelStruct.modelPar_PCDSCB));
instanceStruct.instanceVar_CDSCB_i = (((modelStruct.modelPar_CDSCB+(BIN_L*modelStruct.modelPar_LCDSCB))+(BIN_W*modelStruct.modelPar_WCDSCB))+(BIN_WL*modelStruct.modelPar_PCDSCB));
instanceStruct.d_instanceVar_DVTP0_i_dX = (((modelStruct.d_modelPar_DVTP0_dX+(BIN_L*modelStruct.d_modelPar_LDVTP0_dX+d_BIN_L_dX*modelStruct.modelPar_LDVTP0))+(BIN_W*modelStruct.d_modelPar_WDVTP0_dX+d_BIN_W_dX*modelStruct.modelPar_WDVTP0))+(BIN_WL*modelStruct.d_modelPar_PDVTP0_dX+d_BIN_WL_dX*modelStruct.modelPar_PDVTP0));
instanceStruct.instanceVar_DVTP0_i = (((modelStruct.modelPar_DVTP0+(BIN_L*modelStruct.modelPar_LDVTP0))+(BIN_W*modelStruct.modelPar_WDVTP0))+(BIN_WL*modelStruct.modelPar_PDVTP0));
instanceStruct.d_instanceVar_DVTP1_i_dX = (((modelStruct.d_modelPar_DVTP1_dX+(BIN_L*modelStruct.d_modelPar_LDVTP1_dX+d_BIN_L_dX*modelStruct.modelPar_LDVTP1))+(BIN_W*modelStruct.d_modelPar_WDVTP1_dX+d_BIN_W_dX*modelStruct.modelPar_WDVTP1))+(BIN_WL*modelStruct.d_modelPar_PDVTP1_dX+d_BIN_WL_dX*modelStruct.modelPar_PDVTP1));
instanceStruct.instanceVar_DVTP1_i = (((modelStruct.modelPar_DVTP1+(BIN_L*modelStruct.modelPar_LDVTP1))+(BIN_W*modelStruct.modelPar_WDVTP1))+(BIN_WL*modelStruct.modelPar_PDVTP1));
instanceStruct.d_instanceVar_DVTP2_i_dX = (((modelStruct.d_modelPar_DVTP2_dX+(BIN_L*modelStruct.d_modelPar_LDVTP2_dX+d_BIN_L_dX*modelStruct.modelPar_LDVTP2))+(BIN_W*modelStruct.d_modelPar_WDVTP2_dX+d_BIN_W_dX*modelStruct.modelPar_WDVTP2))+(BIN_WL*modelStruct.d_modelPar_PDVTP2_dX+d_BIN_WL_dX*modelStruct.modelPar_PDVTP2));
instanceStruct.instanceVar_DVTP2_i = (((modelStruct.modelPar_DVTP2+(BIN_L*modelStruct.modelPar_LDVTP2))+(BIN_W*modelStruct.modelPar_WDVTP2))+(BIN_WL*modelStruct.modelPar_PDVTP2));
instanceStruct.d_instanceVar_DVTP3_i_dX = (((modelStruct.d_modelPar_DVTP3_dX+(BIN_L*modelStruct.d_modelPar_LDVTP3_dX+d_BIN_L_dX*modelStruct.modelPar_LDVTP3))+(BIN_W*modelStruct.d_modelPar_WDVTP3_dX+d_BIN_W_dX*modelStruct.modelPar_WDVTP3))+(BIN_WL*modelStruct.d_modelPar_PDVTP3_dX+d_BIN_WL_dX*modelStruct.modelPar_PDVTP3));
instanceStruct.instanceVar_DVTP3_i = (((modelStruct.modelPar_DVTP3+(BIN_L*modelStruct.modelPar_LDVTP3))+(BIN_W*modelStruct.modelPar_WDVTP3))+(BIN_WL*modelStruct.modelPar_PDVTP3));
instanceStruct.d_instanceVar_DVTP4_i_dX = (((modelStruct.d_modelPar_DVTP4_dX+(BIN_L*modelStruct.d_modelPar_LDVTP4_dX+d_BIN_L_dX*modelStruct.modelPar_LDVTP4))+(BIN_W*modelStruct.d_modelPar_WDVTP4_dX+d_BIN_W_dX*modelStruct.modelPar_WDVTP4))+(BIN_WL*modelStruct.d_modelPar_PDVTP4_dX+d_BIN_WL_dX*modelStruct.modelPar_PDVTP4));
instanceStruct.instanceVar_DVTP4_i = (((modelStruct.modelPar_DVTP4+(BIN_L*modelStruct.modelPar_LDVTP4))+(BIN_W*modelStruct.modelPar_WDVTP4))+(BIN_WL*modelStruct.modelPar_PDVTP4));
instanceStruct.d_instanceVar_DVTP5_i_dX = (((modelStruct.d_modelPar_DVTP5_dX+(BIN_L*modelStruct.d_modelPar_LDVTP5_dX+d_BIN_L_dX*modelStruct.modelPar_LDVTP5))+(BIN_W*modelStruct.d_modelPar_WDVTP5_dX+d_BIN_W_dX*modelStruct.modelPar_WDVTP5))+(BIN_WL*modelStruct.d_modelPar_PDVTP5_dX+d_BIN_WL_dX*modelStruct.modelPar_PDVTP5));
instanceStruct.instanceVar_DVTP5_i = (((modelStruct.modelPar_DVTP5+(BIN_L*modelStruct.modelPar_LDVTP5))+(BIN_W*modelStruct.modelPar_WDVTP5))+(BIN_WL*modelStruct.modelPar_PDVTP5));
instanceStruct.d_instanceVar_K2_i_dX = (((modelStruct.d_modelPar_K2_dX+(BIN_L*modelStruct.d_modelPar_LK2_dX+d_BIN_L_dX*modelStruct.modelPar_LK2))+(BIN_W*modelStruct.d_modelPar_WK2_dX+d_BIN_W_dX*modelStruct.modelPar_WK2))+(BIN_WL*modelStruct.d_modelPar_PK2_dX+d_BIN_WL_dX*modelStruct.modelPar_PK2));
instanceStruct.instanceVar_K2_i = (((modelStruct.modelPar_K2+(BIN_L*modelStruct.modelPar_LK2))+(BIN_W*modelStruct.modelPar_WK2))+(BIN_WL*modelStruct.modelPar_PK2));
instanceStruct.d_instanceVar_K1_i_dX = (((modelStruct.d_modelPar_K1_dX+(BIN_L*modelStruct.d_modelPar_LK1_dX+d_BIN_L_dX*modelStruct.modelPar_LK1))+(BIN_W*modelStruct.d_modelPar_WK1_dX+d_BIN_W_dX*modelStruct.modelPar_WK1))+(BIN_WL*modelStruct.d_modelPar_PK1_dX+d_BIN_WL_dX*modelStruct.modelPar_PK1));
instanceStruct.instanceVar_K1_i = (((modelStruct.modelPar_K1+(BIN_L*modelStruct.modelPar_LK1))+(BIN_W*modelStruct.modelPar_WK1))+(BIN_WL*modelStruct.modelPar_PK1));
instanceStruct.d_instanceVar_XJ_i_dX = (((modelStruct.d_modelPar_XJ_dX+(BIN_L*modelStruct.d_modelPar_LXJ_dX+d_BIN_L_dX*modelStruct.modelPar_LXJ))+(BIN_W*modelStruct.d_modelPar_WXJ_dX+d_BIN_W_dX*modelStruct.modelPar_WXJ))+(BIN_WL*modelStruct.d_modelPar_PXJ_dX+d_BIN_WL_dX*modelStruct.modelPar_PXJ));
instanceStruct.instanceVar_XJ_i = (((modelStruct.modelPar_XJ+(BIN_L*modelStruct.modelPar_LXJ))+(BIN_W*modelStruct.modelPar_WXJ))+(BIN_WL*modelStruct.modelPar_PXJ));
instanceStruct.d_instanceVar_PHIN_i_dX = (((modelStruct.d_modelPar_PHIN_dX+(BIN_L*modelStruct.d_modelPar_LPHIN_dX+d_BIN_L_dX*modelStruct.modelPar_LPHIN))+(BIN_W*modelStruct.d_modelPar_WPHIN_dX+d_BIN_W_dX*modelStruct.modelPar_WPHIN))+(BIN_WL*modelStruct.d_modelPar_PPHIN_dX+d_BIN_WL_dX*modelStruct.modelPar_PPHIN));
instanceStruct.instanceVar_PHIN_i = (((modelStruct.modelPar_PHIN+(BIN_L*modelStruct.modelPar_LPHIN))+(BIN_W*modelStruct.modelPar_WPHIN))+(BIN_WL*modelStruct.modelPar_PPHIN));
instanceStruct.d_instanceVar_ETA0_i_dX = (((modelStruct.d_modelPar_ETA0_dX+(BIN_L*modelStruct.d_modelPar_LETA0_dX+d_BIN_L_dX*modelStruct.modelPar_LETA0))+(BIN_W*modelStruct.d_modelPar_WETA0_dX+d_BIN_W_dX*modelStruct.modelPar_WETA0))+(BIN_WL*modelStruct.d_modelPar_PETA0_dX+d_BIN_WL_dX*modelStruct.modelPar_PETA0));
instanceStruct.instanceVar_ETA0_i = (((modelStruct.modelPar_ETA0+(BIN_L*modelStruct.modelPar_LETA0))+(BIN_W*modelStruct.modelPar_WETA0))+(BIN_WL*modelStruct.modelPar_PETA0));
instanceStruct.d_instanceVar_ETAB_i_dX = (((modelStruct.d_modelPar_ETAB_dX+(BIN_L*modelStruct.d_modelPar_LETAB_dX+d_BIN_L_dX*modelStruct.modelPar_LETAB))+(BIN_W*modelStruct.d_modelPar_WETAB_dX+d_BIN_W_dX*modelStruct.modelPar_WETAB))+(BIN_WL*modelStruct.d_modelPar_PETAB_dX+d_BIN_WL_dX*modelStruct.modelPar_PETAB));
instanceStruct.instanceVar_ETAB_i = (((modelStruct.modelPar_ETAB+(BIN_L*modelStruct.modelPar_LETAB))+(BIN_W*modelStruct.modelPar_WETAB))+(BIN_WL*modelStruct.modelPar_PETAB));
instanceStruct.d_instanceVar_DELTA_i_dX = (((modelStruct.d_modelPar_DELTA_dX+(BIN_L*modelStruct.d_modelPar_LDELTA_dX+d_BIN_L_dX*modelStruct.modelPar_LDELTA))+(BIN_W*modelStruct.d_modelPar_WDELTA_dX+d_BIN_W_dX*modelStruct.modelPar_WDELTA))+(BIN_WL*modelStruct.d_modelPar_PDELTA_dX+d_BIN_WL_dX*modelStruct.modelPar_PDELTA));
instanceStruct.instanceVar_DELTA_i = (((modelStruct.modelPar_DELTA+(BIN_L*modelStruct.modelPar_LDELTA))+(BIN_W*modelStruct.modelPar_WDELTA))+(BIN_WL*modelStruct.modelPar_PDELTA));
instanceStruct.d_instanceVar_U0_i_dX = (((modelStruct.d_modelPar_U0_dX+(BIN_L*modelStruct.d_modelPar_LU0_dX+d_BIN_L_dX*modelStruct.modelPar_LU0))+(BIN_W*modelStruct.d_modelPar_WU0_dX+d_BIN_W_dX*modelStruct.modelPar_WU0))+(BIN_WL*modelStruct.d_modelPar_PU0_dX+d_BIN_WL_dX*modelStruct.modelPar_PU0));
instanceStruct.instanceVar_U0_i = (((modelStruct.modelPar_U0+(BIN_L*modelStruct.modelPar_LU0))+(BIN_W*modelStruct.modelPar_WU0))+(BIN_WL*modelStruct.modelPar_PU0));
instanceStruct.d_instanceVar_UA_i_dX = (((modelStruct.d_modelPar_UA_dX+(BIN_L*modelStruct.d_modelPar_LUA_dX+d_BIN_L_dX*modelStruct.modelPar_LUA))+(BIN_W*modelStruct.d_modelPar_WUA_dX+d_BIN_W_dX*modelStruct.modelPar_WUA))+(BIN_WL*modelStruct.d_modelPar_PUA_dX+d_BIN_WL_dX*modelStruct.modelPar_PUA));
instanceStruct.instanceVar_UA_i = (((modelStruct.modelPar_UA+(BIN_L*modelStruct.modelPar_LUA))+(BIN_W*modelStruct.modelPar_WUA))+(BIN_WL*modelStruct.modelPar_PUA));
instanceStruct.d_instanceVar_UD_i_dX = (((modelStruct.d_modelPar_UD_dX+(BIN_L*modelStruct.d_modelPar_LUD_dX+d_BIN_L_dX*modelStruct.modelPar_LUD))+(BIN_W*modelStruct.d_modelPar_WUD_dX+d_BIN_W_dX*modelStruct.modelPar_WUD))+(BIN_WL*modelStruct.d_modelPar_PUD_dX+d_BIN_WL_dX*modelStruct.modelPar_PUD));
instanceStruct.instanceVar_UD_i = (((modelStruct.modelPar_UD+(BIN_L*modelStruct.modelPar_LUD))+(BIN_W*modelStruct.modelPar_WUD))+(BIN_WL*modelStruct.modelPar_PUD));
instanceStruct.d_instanceVar_EU_i_dX = (((modelStruct.d_modelPar_EU_dX+(BIN_L*modelStruct.d_modelPar_LEU_dX+d_BIN_L_dX*modelStruct.modelPar_LEU))+(BIN_W*modelStruct.d_modelPar_WEU_dX+d_BIN_W_dX*modelStruct.modelPar_WEU))+(BIN_WL*modelStruct.d_modelPar_PEU_dX+d_BIN_WL_dX*modelStruct.modelPar_PEU));
instanceStruct.instanceVar_EU_i = (((modelStruct.modelPar_EU+(BIN_L*modelStruct.modelPar_LEU))+(BIN_W*modelStruct.modelPar_WEU))+(BIN_WL*modelStruct.modelPar_PEU));
instanceStruct.d_instanceVar_UCS_i_dX = (((modelStruct.d_modelPar_UCS_dX+(BIN_L*modelStruct.d_modelPar_LUCS_dX+d_BIN_L_dX*modelStruct.modelPar_LUCS))+(BIN_W*modelStruct.d_modelPar_WUCS_dX+d_BIN_W_dX*modelStruct.modelPar_WUCS))+(BIN_WL*modelStruct.d_modelPar_PUCS_dX+d_BIN_WL_dX*modelStruct.modelPar_PUCS));
instanceStruct.instanceVar_UCS_i = (((modelStruct.modelPar_UCS+(BIN_L*modelStruct.modelPar_LUCS))+(BIN_W*modelStruct.modelPar_WUCS))+(BIN_WL*modelStruct.modelPar_PUCS));
instanceStruct.d_instanceVar_UC_i_dX = (((modelStruct.d_modelPar_UC_dX+(BIN_L*modelStruct.d_modelPar_LUC_dX+d_BIN_L_dX*modelStruct.modelPar_LUC))+(BIN_W*modelStruct.d_modelPar_WUC_dX+d_BIN_W_dX*modelStruct.modelPar_WUC))+(BIN_WL*modelStruct.d_modelPar_PUC_dX+d_BIN_WL_dX*modelStruct.modelPar_PUC));
instanceStruct.instanceVar_UC_i = (((modelStruct.modelPar_UC+(BIN_L*modelStruct.modelPar_LUC))+(BIN_W*modelStruct.modelPar_WUC))+(BIN_WL*modelStruct.modelPar_PUC));
instanceStruct.d_instanceVar_PCLM_i_dX = (((modelStruct.d_modelPar_PCLM_dX+(BIN_L*modelStruct.d_modelPar_LPCLM_dX+d_BIN_L_dX*modelStruct.modelPar_LPCLM))+(BIN_W*modelStruct.d_modelPar_WPCLM_dX+d_BIN_W_dX*modelStruct.modelPar_WPCLM))+(BIN_WL*modelStruct.d_modelPar_PPCLM_dX+d_BIN_WL_dX*modelStruct.modelPar_PPCLM));
instanceStruct.instanceVar_PCLM_i = (((modelStruct.modelPar_PCLM+(BIN_L*modelStruct.modelPar_LPCLM))+(BIN_W*modelStruct.modelPar_WPCLM))+(BIN_WL*modelStruct.modelPar_PPCLM));
instanceStruct.d_instanceVar_PCLMCV_i_dX = (((modelStruct.d_modelPar_PCLMCV_dX+(BIN_L*modelStruct.d_modelPar_LPCLMCV_dX+d_BIN_L_dX*modelStruct.modelPar_LPCLMCV))+(BIN_W*modelStruct.d_modelPar_WPCLMCV_dX+d_BIN_W_dX*modelStruct.modelPar_WPCLMCV))+(BIN_WL*modelStruct.d_modelPar_PPCLMCV_dX+d_BIN_WL_dX*modelStruct.modelPar_PPCLMCV));
instanceStruct.instanceVar_PCLMCV_i = (((modelStruct.modelPar_PCLMCV+(BIN_L*modelStruct.modelPar_LPCLMCV))+(BIN_W*modelStruct.modelPar_WPCLMCV))+(BIN_WL*modelStruct.modelPar_PPCLMCV));
instanceStruct.d_instanceVar_RSW_i_dX = (((modelStruct.d_modelPar_RSW_dX+(BIN_L*modelStruct.d_modelPar_LRSW_dX+d_BIN_L_dX*modelStruct.modelPar_LRSW))+(BIN_W*modelStruct.d_modelPar_WRSW_dX+d_BIN_W_dX*modelStruct.modelPar_WRSW))+(BIN_WL*modelStruct.d_modelPar_PRSW_dX+d_BIN_WL_dX*modelStruct.modelPar_PRSW));
instanceStruct.instanceVar_RSW_i = (((modelStruct.modelPar_RSW+(BIN_L*modelStruct.modelPar_LRSW))+(BIN_W*modelStruct.modelPar_WRSW))+(BIN_WL*modelStruct.modelPar_PRSW));
instanceStruct.d_instanceVar_RDW_i_dX = (((modelStruct.d_modelPar_RDW_dX+(BIN_L*modelStruct.d_modelPar_LRDW_dX+d_BIN_L_dX*modelStruct.modelPar_LRDW))+(BIN_W*modelStruct.d_modelPar_WRDW_dX+d_BIN_W_dX*modelStruct.modelPar_WRDW))+(BIN_WL*modelStruct.d_modelPar_PRDW_dX+d_BIN_WL_dX*modelStruct.modelPar_PRDW));
instanceStruct.instanceVar_RDW_i = (((modelStruct.modelPar_RDW+(BIN_L*modelStruct.modelPar_LRDW))+(BIN_W*modelStruct.modelPar_WRDW))+(BIN_WL*modelStruct.modelPar_PRDW));
instanceStruct.d_instanceVar_PRWG_i_dX = (((modelStruct.d_modelPar_PRWG_dX+(BIN_L*modelStruct.d_modelPar_LPRWG_dX+d_BIN_L_dX*modelStruct.modelPar_LPRWG))+(BIN_W*modelStruct.d_modelPar_WPRWG_dX+d_BIN_W_dX*modelStruct.modelPar_WPRWG))+(BIN_WL*modelStruct.d_modelPar_PPRWG_dX+d_BIN_WL_dX*modelStruct.modelPar_PPRWG));
instanceStruct.instanceVar_PRWG_i = (((modelStruct.modelPar_PRWG+(BIN_L*modelStruct.modelPar_LPRWG))+(BIN_W*modelStruct.modelPar_WPRWG))+(BIN_WL*modelStruct.modelPar_PPRWG));
instanceStruct.d_instanceVar_PRWB_i_dX = (((modelStruct.d_modelPar_PRWB_dX+(BIN_L*modelStruct.d_modelPar_LPRWB_dX+d_BIN_L_dX*modelStruct.modelPar_LPRWB))+(BIN_W*modelStruct.d_modelPar_WPRWB_dX+d_BIN_W_dX*modelStruct.modelPar_WPRWB))+(BIN_WL*modelStruct.d_modelPar_PPRWB_dX+d_BIN_WL_dX*modelStruct.modelPar_PPRWB));
instanceStruct.instanceVar_PRWB_i = (((modelStruct.modelPar_PRWB+(BIN_L*modelStruct.modelPar_LPRWB))+(BIN_W*modelStruct.modelPar_WPRWB))+(BIN_WL*modelStruct.modelPar_PPRWB));
instanceStruct.d_instanceVar_WR_i_dX = (((modelStruct.d_modelPar_WR_dX+(BIN_L*modelStruct.d_modelPar_LWR_dX+d_BIN_L_dX*modelStruct.modelPar_LWR))+(BIN_W*modelStruct.d_modelPar_WWR_dX+d_BIN_W_dX*modelStruct.modelPar_WWR))+(BIN_WL*modelStruct.d_modelPar_PWR_dX+d_BIN_WL_dX*modelStruct.modelPar_PWR));
instanceStruct.instanceVar_WR_i = (((modelStruct.modelPar_WR+(BIN_L*modelStruct.modelPar_LWR))+(BIN_W*modelStruct.modelPar_WWR))+(BIN_WL*modelStruct.modelPar_PWR));
instanceStruct.d_instanceVar_RSWMIN_i_dX = (((modelStruct.d_modelPar_RSWMIN_dX+(BIN_L*modelStruct.d_modelPar_LRSWMIN_dX+d_BIN_L_dX*modelStruct.modelPar_LRSWMIN))+(BIN_W*modelStruct.d_modelPar_WRSWMIN_dX+d_BIN_W_dX*modelStruct.modelPar_WRSWMIN))+(BIN_WL*modelStruct.d_modelPar_PRSWMIN_dX+d_BIN_WL_dX*modelStruct.modelPar_PRSWMIN));
instanceStruct.instanceVar_RSWMIN_i = (((modelStruct.modelPar_RSWMIN+(BIN_L*modelStruct.modelPar_LRSWMIN))+(BIN_W*modelStruct.modelPar_WRSWMIN))+(BIN_WL*modelStruct.modelPar_PRSWMIN));
instanceStruct.d_instanceVar_RDWMIN_i_dX = (((modelStruct.d_modelPar_RDWMIN_dX+(BIN_L*modelStruct.d_modelPar_LRDWMIN_dX+d_BIN_L_dX*modelStruct.modelPar_LRDWMIN))+(BIN_W*modelStruct.d_modelPar_WRDWMIN_dX+d_BIN_W_dX*modelStruct.modelPar_WRDWMIN))+(BIN_WL*modelStruct.d_modelPar_PRDWMIN_dX+d_BIN_WL_dX*modelStruct.modelPar_PRDWMIN));
instanceStruct.instanceVar_RDWMIN_i = (((modelStruct.modelPar_RDWMIN+(BIN_L*modelStruct.modelPar_LRDWMIN))+(BIN_W*modelStruct.modelPar_WRDWMIN))+(BIN_WL*modelStruct.modelPar_PRDWMIN));
instanceStruct.d_instanceVar_RDSW_i_dX = (((modelStruct.d_modelPar_RDSW_dX+(BIN_L*modelStruct.d_modelPar_LRDSW_dX+d_BIN_L_dX*modelStruct.modelPar_LRDSW))+(BIN_W*modelStruct.d_modelPar_WRDSW_dX+d_BIN_W_dX*modelStruct.modelPar_WRDSW))+(BIN_WL*modelStruct.d_modelPar_PRDSW_dX+d_BIN_WL_dX*modelStruct.modelPar_PRDSW));
instanceStruct.instanceVar_RDSW_i = (((modelStruct.modelPar_RDSW+(BIN_L*modelStruct.modelPar_LRDSW))+(BIN_W*modelStruct.modelPar_WRDSW))+(BIN_WL*modelStruct.modelPar_PRDSW));
instanceStruct.d_instanceVar_RDSWMIN_i_dX = (((modelStruct.d_modelPar_RDSWMIN_dX+(BIN_L*modelStruct.d_modelPar_LRDSWMIN_dX+d_BIN_L_dX*modelStruct.modelPar_LRDSWMIN))+(BIN_W*modelStruct.d_modelPar_WRDSWMIN_dX+d_BIN_W_dX*modelStruct.modelPar_WRDSWMIN))+(BIN_WL*modelStruct.d_modelPar_PRDSWMIN_dX+d_BIN_WL_dX*modelStruct.modelPar_PRDSWMIN));
instanceStruct.instanceVar_RDSWMIN_i = (((modelStruct.modelPar_RDSWMIN+(BIN_L*modelStruct.modelPar_LRDSWMIN))+(BIN_W*modelStruct.modelPar_WRDSWMIN))+(BIN_WL*modelStruct.modelPar_PRDSWMIN));
instanceStruct.d_instanceVar_PTWG_i_dX = (((modelStruct.d_modelPar_PTWG_dX+(BIN_L*modelStruct.d_modelPar_LPTWG_dX+d_BIN_L_dX*modelStruct.modelPar_LPTWG))+(BIN_W*modelStruct.d_modelPar_WPTWG_dX+d_BIN_W_dX*modelStruct.modelPar_WPTWG))+(BIN_WL*modelStruct.d_modelPar_PPTWG_dX+d_BIN_WL_dX*modelStruct.modelPar_PPTWG));
instanceStruct.instanceVar_PTWG_i = (((modelStruct.modelPar_PTWG+(BIN_L*modelStruct.modelPar_LPTWG))+(BIN_W*modelStruct.modelPar_WPTWG))+(BIN_WL*modelStruct.modelPar_PPTWG));
instanceStruct.d_instanceVar_PDIBLC_i_dX = (((modelStruct.d_modelPar_PDIBLC_dX+(BIN_L*modelStruct.d_modelPar_LPDIBLC_dX+d_BIN_L_dX*modelStruct.modelPar_LPDIBLC))+(BIN_W*modelStruct.d_modelPar_WPDIBLC_dX+d_BIN_W_dX*modelStruct.modelPar_WPDIBLC))+(BIN_WL*modelStruct.d_modelPar_PPDIBLC_dX+d_BIN_WL_dX*modelStruct.modelPar_PPDIBLC));
instanceStruct.instanceVar_PDIBLC_i = (((modelStruct.modelPar_PDIBLC+(BIN_L*modelStruct.modelPar_LPDIBLC))+(BIN_W*modelStruct.modelPar_WPDIBLC))+(BIN_WL*modelStruct.modelPar_PPDIBLC));
instanceStruct.d_instanceVar_PDIBLCB_i_dX = (((modelStruct.d_modelPar_PDIBLCB_dX+(BIN_L*modelStruct.d_modelPar_LPDIBLCB_dX+d_BIN_L_dX*modelStruct.modelPar_LPDIBLCB))+(BIN_W*modelStruct.d_modelPar_WPDIBLCB_dX+d_BIN_W_dX*modelStruct.modelPar_WPDIBLCB))+(BIN_WL*modelStruct.d_modelPar_PPDIBLCB_dX+d_BIN_WL_dX*modelStruct.modelPar_PPDIBLCB));
instanceStruct.instanceVar_PDIBLCB_i = (((modelStruct.modelPar_PDIBLCB+(BIN_L*modelStruct.modelPar_LPDIBLCB))+(BIN_W*modelStruct.modelPar_WPDIBLCB))+(BIN_WL*modelStruct.modelPar_PPDIBLCB));
instanceStruct.d_instanceVar_PSCBE1_i_dX = (((modelStruct.d_modelPar_PSCBE1_dX+(BIN_L*modelStruct.d_modelPar_LPSCBE1_dX+d_BIN_L_dX*modelStruct.modelPar_LPSCBE1))+(BIN_W*modelStruct.d_modelPar_WPSCBE1_dX+d_BIN_W_dX*modelStruct.modelPar_WPSCBE1))+(BIN_WL*modelStruct.d_modelPar_PPSCBE1_dX+d_BIN_WL_dX*modelStruct.modelPar_PPSCBE1));
instanceStruct.instanceVar_PSCBE1_i = (((modelStruct.modelPar_PSCBE1+(BIN_L*modelStruct.modelPar_LPSCBE1))+(BIN_W*modelStruct.modelPar_WPSCBE1))+(BIN_WL*modelStruct.modelPar_PPSCBE1));
instanceStruct.d_instanceVar_PSCBE2_i_dX = (((modelStruct.d_modelPar_PSCBE2_dX+(BIN_L*modelStruct.d_modelPar_LPSCBE2_dX+d_BIN_L_dX*modelStruct.modelPar_LPSCBE2))+(BIN_W*modelStruct.d_modelPar_WPSCBE2_dX+d_BIN_W_dX*modelStruct.modelPar_WPSCBE2))+(BIN_WL*modelStruct.d_modelPar_PPSCBE2_dX+d_BIN_WL_dX*modelStruct.modelPar_PPSCBE2));
instanceStruct.instanceVar_PSCBE2_i = (((modelStruct.modelPar_PSCBE2+(BIN_L*modelStruct.modelPar_LPSCBE2))+(BIN_W*modelStruct.modelPar_WPSCBE2))+(BIN_WL*modelStruct.modelPar_PPSCBE2));
instanceStruct.d_instanceVar_PDITS_i_dX = (((modelStruct.d_modelPar_PDITS_dX+(BIN_L*modelStruct.d_modelPar_LPDITS_dX+d_BIN_L_dX*modelStruct.modelPar_LPDITS))+(BIN_W*modelStruct.d_modelPar_WPDITS_dX+d_BIN_W_dX*modelStruct.modelPar_WPDITS))+(BIN_WL*modelStruct.d_modelPar_PPDITS_dX+d_BIN_WL_dX*modelStruct.modelPar_PPDITS));
instanceStruct.instanceVar_PDITS_i = (((modelStruct.modelPar_PDITS+(BIN_L*modelStruct.modelPar_LPDITS))+(BIN_W*modelStruct.modelPar_WPDITS))+(BIN_WL*modelStruct.modelPar_PPDITS));
instanceStruct.d_instanceVar_PDITSD_i_dX = (((modelStruct.d_modelPar_PDITSD_dX+(BIN_L*modelStruct.d_modelPar_LPDITSD_dX+d_BIN_L_dX*modelStruct.modelPar_LPDITSD))+(BIN_W*modelStruct.d_modelPar_WPDITSD_dX+d_BIN_W_dX*modelStruct.modelPar_WPDITSD))+(BIN_WL*modelStruct.d_modelPar_PPDITSD_dX+d_BIN_WL_dX*modelStruct.modelPar_PPDITSD));
instanceStruct.instanceVar_PDITSD_i = (((modelStruct.modelPar_PDITSD+(BIN_L*modelStruct.modelPar_LPDITSD))+(BIN_W*modelStruct.modelPar_WPDITSD))+(BIN_WL*modelStruct.modelPar_PPDITSD));
instanceStruct.d_instanceVar_FPROUT_i_dX = (((modelStruct.d_modelPar_FPROUT_dX+(BIN_L*modelStruct.d_modelPar_LFPROUT_dX+d_BIN_L_dX*modelStruct.modelPar_LFPROUT))+(BIN_W*modelStruct.d_modelPar_WFPROUT_dX+d_BIN_W_dX*modelStruct.modelPar_WFPROUT))+(BIN_WL*modelStruct.d_modelPar_PFPROUT_dX+d_BIN_WL_dX*modelStruct.modelPar_PFPROUT));
instanceStruct.instanceVar_FPROUT_i = (((modelStruct.modelPar_FPROUT+(BIN_L*modelStruct.modelPar_LFPROUT))+(BIN_W*modelStruct.modelPar_WFPROUT))+(BIN_WL*modelStruct.modelPar_PFPROUT));
instanceStruct.d_instanceVar_PVAG_i_dX = (((modelStruct.d_modelPar_PVAG_dX+(BIN_L*modelStruct.d_modelPar_LPVAG_dX+d_BIN_L_dX*modelStruct.modelPar_LPVAG))+(BIN_W*modelStruct.d_modelPar_WPVAG_dX+d_BIN_W_dX*modelStruct.modelPar_WPVAG))+(BIN_WL*modelStruct.d_modelPar_PPVAG_dX+d_BIN_WL_dX*modelStruct.modelPar_PPVAG));
instanceStruct.instanceVar_PVAG_i = (((modelStruct.modelPar_PVAG+(BIN_L*modelStruct.modelPar_LPVAG))+(BIN_W*modelStruct.modelPar_WPVAG))+(BIN_WL*modelStruct.modelPar_PPVAG));
instanceStruct.d_instanceVar_VSAT_i_dX = (((modelStruct.d_modelPar_VSAT_dX+(BIN_L*modelStruct.d_modelPar_LVSAT_dX+d_BIN_L_dX*modelStruct.modelPar_LVSAT))+(BIN_W*modelStruct.d_modelPar_WVSAT_dX+d_BIN_W_dX*modelStruct.modelPar_WVSAT))+(BIN_WL*modelStruct.d_modelPar_PVSAT_dX+d_BIN_WL_dX*modelStruct.modelPar_PVSAT));
instanceStruct.instanceVar_VSAT_i = (((modelStruct.modelPar_VSAT+(BIN_L*modelStruct.modelPar_LVSAT))+(BIN_W*modelStruct.modelPar_WVSAT))+(BIN_WL*modelStruct.modelPar_PVSAT));
instanceStruct.d_instanceVar_PSAT_i_dX = (((modelStruct.d_modelPar_PSAT_dX+(BIN_L*modelStruct.d_modelPar_LPSAT_dX+d_BIN_L_dX*modelStruct.modelPar_LPSAT))+(BIN_W*modelStruct.d_modelPar_WPSAT_dX+d_BIN_W_dX*modelStruct.modelPar_WPSAT))+(BIN_WL*modelStruct.d_modelPar_PPSAT_dX+d_BIN_WL_dX*modelStruct.modelPar_PPSAT));
instanceStruct.instanceVar_PSAT_i = (((modelStruct.modelPar_PSAT+(BIN_L*modelStruct.modelPar_LPSAT))+(BIN_W*modelStruct.modelPar_WPSAT))+(BIN_WL*modelStruct.modelPar_PPSAT));
instanceStruct.d_instanceVar_VSATCV_i_dX = (((modelStruct.d_modelPar_VSATCV_dX+(BIN_L*modelStruct.d_modelPar_LVSATCV_dX+d_BIN_L_dX*modelStruct.modelPar_LVSATCV))+(BIN_W*modelStruct.d_modelPar_WVSATCV_dX+d_BIN_W_dX*modelStruct.modelPar_WVSATCV))+(BIN_WL*modelStruct.d_modelPar_PVSATCV_dX+d_BIN_WL_dX*modelStruct.modelPar_PVSATCV));
instanceStruct.instanceVar_VSATCV_i = (((modelStruct.modelPar_VSATCV+(BIN_L*modelStruct.modelPar_LVSATCV))+(BIN_W*modelStruct.modelPar_WVSATCV))+(BIN_WL*modelStruct.modelPar_PVSATCV));
instanceStruct.d_instanceVar_CF_i_dX = (((modelStruct.d_modelPar_CF_dX+(BIN_L*modelStruct.d_modelPar_LCF_dX+d_BIN_L_dX*modelStruct.modelPar_LCF))+(BIN_W*modelStruct.d_modelPar_WCF_dX+d_BIN_W_dX*modelStruct.modelPar_WCF))+(BIN_WL*modelStruct.d_modelPar_PCF_dX+d_BIN_WL_dX*modelStruct.modelPar_PCF));
instanceStruct.instanceVar_CF_i = (((modelStruct.modelPar_CF+(BIN_L*modelStruct.modelPar_LCF))+(BIN_W*modelStruct.modelPar_WCF))+(BIN_WL*modelStruct.modelPar_PCF));
instanceStruct.d_instanceVar_CGSL_i_dX = (((modelStruct.d_modelPar_CGSL_dX+(BIN_L*modelStruct.d_modelPar_LCGSL_dX+d_BIN_L_dX*modelStruct.modelPar_LCGSL))+(BIN_W*modelStruct.d_modelPar_WCGSL_dX+d_BIN_W_dX*modelStruct.modelPar_WCGSL))+(BIN_WL*modelStruct.d_modelPar_PCGSL_dX+d_BIN_WL_dX*modelStruct.modelPar_PCGSL));
instanceStruct.instanceVar_CGSL_i = (((modelStruct.modelPar_CGSL+(BIN_L*modelStruct.modelPar_LCGSL))+(BIN_W*modelStruct.modelPar_WCGSL))+(BIN_WL*modelStruct.modelPar_PCGSL));
instanceStruct.d_instanceVar_CGDL_i_dX = (((modelStruct.d_modelPar_CGDL_dX+(BIN_L*modelStruct.d_modelPar_LCGDL_dX+d_BIN_L_dX*modelStruct.modelPar_LCGDL))+(BIN_W*modelStruct.d_modelPar_WCGDL_dX+d_BIN_W_dX*modelStruct.modelPar_WCGDL))+(BIN_WL*modelStruct.d_modelPar_PCGDL_dX+d_BIN_WL_dX*modelStruct.modelPar_PCGDL));
instanceStruct.instanceVar_CGDL_i = (((modelStruct.modelPar_CGDL+(BIN_L*modelStruct.modelPar_LCGDL))+(BIN_W*modelStruct.modelPar_WCGDL))+(BIN_WL*modelStruct.modelPar_PCGDL));
instanceStruct.d_instanceVar_CKAPPAS_i_dX = (((modelStruct.d_modelPar_CKAPPAS_dX+(BIN_L*modelStruct.d_modelPar_LCKAPPAS_dX+d_BIN_L_dX*modelStruct.modelPar_LCKAPPAS))+(BIN_W*modelStruct.d_modelPar_WCKAPPAS_dX+d_BIN_W_dX*modelStruct.modelPar_WCKAPPAS))+(BIN_WL*modelStruct.d_modelPar_PCKAPPAS_dX+d_BIN_WL_dX*modelStruct.modelPar_PCKAPPAS));
instanceStruct.instanceVar_CKAPPAS_i = (((modelStruct.modelPar_CKAPPAS+(BIN_L*modelStruct.modelPar_LCKAPPAS))+(BIN_W*modelStruct.modelPar_WCKAPPAS))+(BIN_WL*modelStruct.modelPar_PCKAPPAS));
instanceStruct.d_instanceVar_CKAPPAD_i_dX = (((modelStruct.d_modelPar_CKAPPAD_dX+(BIN_L*modelStruct.d_modelPar_LCKAPPAD_dX+d_BIN_L_dX*modelStruct.modelPar_LCKAPPAD))+(BIN_W*modelStruct.d_modelPar_WCKAPPAD_dX+d_BIN_W_dX*modelStruct.modelPar_WCKAPPAD))+(BIN_WL*modelStruct.d_modelPar_PCKAPPAD_dX+d_BIN_WL_dX*modelStruct.modelPar_PCKAPPAD));
instanceStruct.instanceVar_CKAPPAD_i = (((modelStruct.modelPar_CKAPPAD+(BIN_L*modelStruct.modelPar_LCKAPPAD))+(BIN_W*modelStruct.modelPar_WCKAPPAD))+(BIN_WL*modelStruct.modelPar_PCKAPPAD));
instanceStruct.d_instanceVar_ALPHA0_i_dX = (((modelStruct.d_modelPar_ALPHA0_dX+(BIN_L*modelStruct.d_modelPar_LALPHA0_dX+d_BIN_L_dX*modelStruct.modelPar_LALPHA0))+(BIN_W*modelStruct.d_modelPar_WALPHA0_dX+d_BIN_W_dX*modelStruct.modelPar_WALPHA0))+(BIN_WL*modelStruct.d_modelPar_PALPHA0_dX+d_BIN_WL_dX*modelStruct.modelPar_PALPHA0));
instanceStruct.instanceVar_ALPHA0_i = (((modelStruct.modelPar_ALPHA0+(BIN_L*modelStruct.modelPar_LALPHA0))+(BIN_W*modelStruct.modelPar_WALPHA0))+(BIN_WL*modelStruct.modelPar_PALPHA0));
instanceStruct.d_instanceVar_BETA0_i_dX = (((modelStruct.d_modelPar_BETA0_dX+(BIN_L*modelStruct.d_modelPar_LBETA0_dX+d_BIN_L_dX*modelStruct.modelPar_LBETA0))+(BIN_W*modelStruct.d_modelPar_WBETA0_dX+d_BIN_W_dX*modelStruct.modelPar_WBETA0))+(BIN_WL*modelStruct.d_modelPar_PBETA0_dX+d_BIN_WL_dX*modelStruct.modelPar_PBETA0));
instanceStruct.instanceVar_BETA0_i = (((modelStruct.modelPar_BETA0+(BIN_L*modelStruct.modelPar_LBETA0))+(BIN_W*modelStruct.modelPar_WBETA0))+(BIN_WL*modelStruct.modelPar_PBETA0));
instanceStruct.d_instanceVar_KVTH0WE_i_dX = (((modelStruct.d_modelPar_KVTH0WE_dX+(BIN_L*modelStruct.d_modelPar_LKVTH0WE_dX+d_BIN_L_dX*modelStruct.modelPar_LKVTH0WE))+(BIN_W*modelStruct.d_modelPar_WKVTH0WE_dX+d_BIN_W_dX*modelStruct.modelPar_WKVTH0WE))+(BIN_WL*modelStruct.d_modelPar_PKVTH0WE_dX+d_BIN_WL_dX*modelStruct.modelPar_PKVTH0WE));
instanceStruct.instanceVar_KVTH0WE_i = (((modelStruct.modelPar_KVTH0WE+(BIN_L*modelStruct.modelPar_LKVTH0WE))+(BIN_W*modelStruct.modelPar_WKVTH0WE))+(BIN_WL*modelStruct.modelPar_PKVTH0WE));
instanceStruct.d_instanceVar_K2WE_i_dX = (((modelStruct.d_modelPar_K2WE_dX+(BIN_L*modelStruct.d_modelPar_LK2WE_dX+d_BIN_L_dX*modelStruct.modelPar_LK2WE))+(BIN_W*modelStruct.d_modelPar_WK2WE_dX+d_BIN_W_dX*modelStruct.modelPar_WK2WE))+(BIN_WL*modelStruct.d_modelPar_PK2WE_dX+d_BIN_WL_dX*modelStruct.modelPar_PK2WE));
instanceStruct.instanceVar_K2WE_i = (((modelStruct.modelPar_K2WE+(BIN_L*modelStruct.modelPar_LK2WE))+(BIN_W*modelStruct.modelPar_WK2WE))+(BIN_WL*modelStruct.modelPar_PK2WE));
instanceStruct.d_instanceVar_KU0WE_i_dX = (((modelStruct.d_modelPar_KU0WE_dX+(BIN_L*modelStruct.d_modelPar_LKU0WE_dX+d_BIN_L_dX*modelStruct.modelPar_LKU0WE))+(BIN_W*modelStruct.d_modelPar_WKU0WE_dX+d_BIN_W_dX*modelStruct.modelPar_WKU0WE))+(BIN_WL*modelStruct.d_modelPar_PKU0WE_dX+d_BIN_WL_dX*modelStruct.modelPar_PKU0WE));
instanceStruct.instanceVar_KU0WE_i = (((modelStruct.modelPar_KU0WE+(BIN_L*modelStruct.modelPar_LKU0WE))+(BIN_W*modelStruct.modelPar_WKU0WE))+(BIN_WL*modelStruct.modelPar_PKU0WE));
instanceStruct.d_instanceVar_AGIDL_i_dX = (((modelStruct.d_modelPar_AGIDL_dX+(BIN_L*modelStruct.d_modelPar_LAGIDL_dX+d_BIN_L_dX*modelStruct.modelPar_LAGIDL))+(BIN_W*modelStruct.d_modelPar_WAGIDL_dX+d_BIN_W_dX*modelStruct.modelPar_WAGIDL))+(BIN_WL*modelStruct.d_modelPar_PAGIDL_dX+d_BIN_WL_dX*modelStruct.modelPar_PAGIDL));
instanceStruct.instanceVar_AGIDL_i = (((modelStruct.modelPar_AGIDL+(BIN_L*modelStruct.modelPar_LAGIDL))+(BIN_W*modelStruct.modelPar_WAGIDL))+(BIN_WL*modelStruct.modelPar_PAGIDL));
instanceStruct.d_instanceVar_BGIDL_i_dX = (((modelStruct.d_modelPar_BGIDL_dX+(BIN_L*modelStruct.d_modelPar_LBGIDL_dX+d_BIN_L_dX*modelStruct.modelPar_LBGIDL))+(BIN_W*modelStruct.d_modelPar_WBGIDL_dX+d_BIN_W_dX*modelStruct.modelPar_WBGIDL))+(BIN_WL*modelStruct.d_modelPar_PBGIDL_dX+d_BIN_WL_dX*modelStruct.modelPar_PBGIDL));
instanceStruct.instanceVar_BGIDL_i = (((modelStruct.modelPar_BGIDL+(BIN_L*modelStruct.modelPar_LBGIDL))+(BIN_W*modelStruct.modelPar_WBGIDL))+(BIN_WL*modelStruct.modelPar_PBGIDL));
instanceStruct.d_instanceVar_CGIDL_i_dX = (((modelStruct.d_modelPar_CGIDL_dX+(BIN_L*modelStruct.d_modelPar_LCGIDL_dX+d_BIN_L_dX*modelStruct.modelPar_LCGIDL))+(BIN_W*modelStruct.d_modelPar_WCGIDL_dX+d_BIN_W_dX*modelStruct.modelPar_WCGIDL))+(BIN_WL*modelStruct.d_modelPar_PCGIDL_dX+d_BIN_WL_dX*modelStruct.modelPar_PCGIDL));
instanceStruct.instanceVar_CGIDL_i = (((modelStruct.modelPar_CGIDL+(BIN_L*modelStruct.modelPar_LCGIDL))+(BIN_W*modelStruct.modelPar_WCGIDL))+(BIN_WL*modelStruct.modelPar_PCGIDL));
instanceStruct.d_instanceVar_EGIDL_i_dX = (((modelStruct.d_modelPar_EGIDL_dX+(BIN_L*modelStruct.d_modelPar_LEGIDL_dX+d_BIN_L_dX*modelStruct.modelPar_LEGIDL))+(BIN_W*modelStruct.d_modelPar_WEGIDL_dX+d_BIN_W_dX*modelStruct.modelPar_WEGIDL))+(BIN_WL*modelStruct.d_modelPar_PEGIDL_dX+d_BIN_WL_dX*modelStruct.modelPar_PEGIDL));
instanceStruct.instanceVar_EGIDL_i = (((modelStruct.modelPar_EGIDL+(BIN_L*modelStruct.modelPar_LEGIDL))+(BIN_W*modelStruct.modelPar_WEGIDL))+(BIN_WL*modelStruct.modelPar_PEGIDL));
instanceStruct.d_instanceVar_AGISL_i_dX = (((modelStruct.d_modelPar_AGISL_dX+(BIN_L*modelStruct.d_modelPar_LAGISL_dX+d_BIN_L_dX*modelStruct.modelPar_LAGISL))+(BIN_W*modelStruct.d_modelPar_WAGISL_dX+d_BIN_W_dX*modelStruct.modelPar_WAGISL))+(BIN_WL*modelStruct.d_modelPar_PAGISL_dX+d_BIN_WL_dX*modelStruct.modelPar_PAGISL));
instanceStruct.instanceVar_AGISL_i = (((modelStruct.modelPar_AGISL+(BIN_L*modelStruct.modelPar_LAGISL))+(BIN_W*modelStruct.modelPar_WAGISL))+(BIN_WL*modelStruct.modelPar_PAGISL));
instanceStruct.d_instanceVar_BGISL_i_dX = (((modelStruct.d_modelPar_BGISL_dX+(BIN_L*modelStruct.d_modelPar_LBGISL_dX+d_BIN_L_dX*modelStruct.modelPar_LBGISL))+(BIN_W*modelStruct.d_modelPar_WBGISL_dX+d_BIN_W_dX*modelStruct.modelPar_WBGISL))+(BIN_WL*modelStruct.d_modelPar_PBGISL_dX+d_BIN_WL_dX*modelStruct.modelPar_PBGISL));
instanceStruct.instanceVar_BGISL_i = (((modelStruct.modelPar_BGISL+(BIN_L*modelStruct.modelPar_LBGISL))+(BIN_W*modelStruct.modelPar_WBGISL))+(BIN_WL*modelStruct.modelPar_PBGISL));
instanceStruct.d_instanceVar_CGISL_i_dX = (((modelStruct.d_modelPar_CGISL_dX+(BIN_L*modelStruct.d_modelPar_LCGISL_dX+d_BIN_L_dX*modelStruct.modelPar_LCGISL))+(BIN_W*modelStruct.d_modelPar_WCGISL_dX+d_BIN_W_dX*modelStruct.modelPar_WCGISL))+(BIN_WL*modelStruct.d_modelPar_PCGISL_dX+d_BIN_WL_dX*modelStruct.modelPar_PCGISL));
instanceStruct.instanceVar_CGISL_i = (((modelStruct.modelPar_CGISL+(BIN_L*modelStruct.modelPar_LCGISL))+(BIN_W*modelStruct.modelPar_WCGISL))+(BIN_WL*modelStruct.modelPar_PCGISL));
instanceStruct.d_instanceVar_EGISL_i_dX = (((modelStruct.d_modelPar_EGISL_dX+(BIN_L*modelStruct.d_modelPar_LEGISL_dX+d_BIN_L_dX*modelStruct.modelPar_LEGISL))+(BIN_W*modelStruct.d_modelPar_WEGISL_dX+d_BIN_W_dX*modelStruct.modelPar_WEGISL))+(BIN_WL*modelStruct.d_modelPar_PEGISL_dX+d_BIN_WL_dX*modelStruct.modelPar_PEGISL));
instanceStruct.instanceVar_EGISL_i = (((modelStruct.modelPar_EGISL+(BIN_L*modelStruct.modelPar_LEGISL))+(BIN_W*modelStruct.modelPar_WEGISL))+(BIN_WL*modelStruct.modelPar_PEGISL));
instanceStruct.d_instanceVar_UTE_i_dX = (((modelStruct.d_modelPar_UTE_dX+(BIN_L*modelStruct.d_modelPar_LUTE_dX+d_BIN_L_dX*modelStruct.modelPar_LUTE))+(BIN_W*modelStruct.d_modelPar_WUTE_dX+d_BIN_W_dX*modelStruct.modelPar_WUTE))+(BIN_WL*modelStruct.d_modelPar_PUTE_dX+d_BIN_WL_dX*modelStruct.modelPar_PUTE));
instanceStruct.instanceVar_UTE_i = (((modelStruct.modelPar_UTE+(BIN_L*modelStruct.modelPar_LUTE))+(BIN_W*modelStruct.modelPar_WUTE))+(BIN_WL*modelStruct.modelPar_PUTE));
instanceStruct.d_instanceVar_UA1_i_dX = (((modelStruct.d_modelPar_UA1_dX+(BIN_L*modelStruct.d_modelPar_LUA1_dX+d_BIN_L_dX*modelStruct.modelPar_LUA1))+(BIN_W*modelStruct.d_modelPar_WUA1_dX+d_BIN_W_dX*modelStruct.modelPar_WUA1))+(BIN_WL*modelStruct.d_modelPar_PUA1_dX+d_BIN_WL_dX*modelStruct.modelPar_PUA1));
instanceStruct.instanceVar_UA1_i = (((modelStruct.modelPar_UA1+(BIN_L*modelStruct.modelPar_LUA1))+(BIN_W*modelStruct.modelPar_WUA1))+(BIN_WL*modelStruct.modelPar_PUA1));
instanceStruct.d_instanceVar_UC1_i_dX = (((modelStruct.d_modelPar_UC1_dX+(BIN_L*modelStruct.d_modelPar_LUC1_dX+d_BIN_L_dX*modelStruct.modelPar_LUC1))+(BIN_W*modelStruct.d_modelPar_WUC1_dX+d_BIN_W_dX*modelStruct.modelPar_WUC1))+(BIN_WL*modelStruct.d_modelPar_PUC1_dX+d_BIN_WL_dX*modelStruct.modelPar_PUC1));
instanceStruct.instanceVar_UC1_i = (((modelStruct.modelPar_UC1+(BIN_L*modelStruct.modelPar_LUC1))+(BIN_W*modelStruct.modelPar_WUC1))+(BIN_WL*modelStruct.modelPar_PUC1));
instanceStruct.d_instanceVar_UD1_i_dX = (((modelStruct.d_modelPar_UD1_dX+(BIN_L*modelStruct.d_modelPar_LUD1_dX+d_BIN_L_dX*modelStruct.modelPar_LUD1))+(BIN_W*modelStruct.d_modelPar_WUD1_dX+d_BIN_W_dX*modelStruct.modelPar_WUD1))+(BIN_WL*modelStruct.d_modelPar_PUD1_dX+d_BIN_WL_dX*modelStruct.modelPar_PUD1));
instanceStruct.instanceVar_UD1_i = (((modelStruct.modelPar_UD1+(BIN_L*modelStruct.modelPar_LUD1))+(BIN_W*modelStruct.modelPar_WUD1))+(BIN_WL*modelStruct.modelPar_PUD1));
instanceStruct.d_instanceVar_UCSTE_i_dX = (((modelStruct.d_modelPar_UCSTE_dX+(BIN_L*modelStruct.d_modelPar_LUCSTE_dX+d_BIN_L_dX*modelStruct.modelPar_LUCSTE))+(BIN_W*modelStruct.d_modelPar_WUCSTE_dX+d_BIN_W_dX*modelStruct.modelPar_WUCSTE))+(BIN_WL*modelStruct.d_modelPar_PUCSTE_dX+d_BIN_WL_dX*modelStruct.modelPar_PUCSTE));
instanceStruct.instanceVar_UCSTE_i = (((modelStruct.modelPar_UCSTE+(BIN_L*modelStruct.modelPar_LUCSTE))+(BIN_W*modelStruct.modelPar_WUCSTE))+(BIN_WL*modelStruct.modelPar_PUCSTE));
instanceStruct.d_instanceVar_PRT_i_dX = (((modelStruct.d_modelPar_PRT_dX+(BIN_L*modelStruct.d_modelPar_LPRT_dX+d_BIN_L_dX*modelStruct.modelPar_LPRT))+(BIN_W*modelStruct.d_modelPar_WPRT_dX+d_BIN_W_dX*modelStruct.modelPar_WPRT))+(BIN_WL*modelStruct.d_modelPar_PPRT_dX+d_BIN_WL_dX*modelStruct.modelPar_PPRT));
instanceStruct.instanceVar_PRT_i = (((modelStruct.modelPar_PRT+(BIN_L*modelStruct.modelPar_LPRT))+(BIN_W*modelStruct.modelPar_WPRT))+(BIN_WL*modelStruct.modelPar_PPRT));
instanceStruct.d_instanceVar_AT_i_dX = (((modelStruct.d_modelPar_AT_dX+(BIN_L*modelStruct.d_modelPar_LAT_dX+d_BIN_L_dX*modelStruct.modelPar_LAT))+(BIN_W*modelStruct.d_modelPar_WAT_dX+d_BIN_W_dX*modelStruct.modelPar_WAT))+(BIN_WL*modelStruct.d_modelPar_PAT_dX+d_BIN_WL_dX*modelStruct.modelPar_PAT));
instanceStruct.instanceVar_AT_i = (((modelStruct.modelPar_AT+(BIN_L*modelStruct.modelPar_LAT))+(BIN_W*modelStruct.modelPar_WAT))+(BIN_WL*modelStruct.modelPar_PAT));
instanceStruct.d_instanceVar_PTWGT_i_dX = (((modelStruct.d_modelPar_PTWGT_dX+(BIN_L*modelStruct.d_modelPar_LPTWGT_dX+d_BIN_L_dX*modelStruct.modelPar_LPTWGT))+(BIN_W*modelStruct.d_modelPar_WPTWGT_dX+d_BIN_W_dX*modelStruct.modelPar_WPTWGT))+(BIN_WL*modelStruct.d_modelPar_PPTWGT_dX+d_BIN_WL_dX*modelStruct.modelPar_PPTWGT));
instanceStruct.instanceVar_PTWGT_i = (((modelStruct.modelPar_PTWGT+(BIN_L*modelStruct.modelPar_LPTWGT))+(BIN_W*modelStruct.modelPar_WPTWGT))+(BIN_WL*modelStruct.modelPar_PPTWGT));
instanceStruct.d_instanceVar_IIT_i_dX = (((modelStruct.d_modelPar_IIT_dX+(BIN_L*modelStruct.d_modelPar_LIIT_dX+d_BIN_L_dX*modelStruct.modelPar_LIIT))+(BIN_W*modelStruct.d_modelPar_WIIT_dX+d_BIN_W_dX*modelStruct.modelPar_WIIT))+(BIN_WL*modelStruct.d_modelPar_PIIT_dX+d_BIN_WL_dX*modelStruct.modelPar_PIIT));
instanceStruct.instanceVar_IIT_i = (((modelStruct.modelPar_IIT+(BIN_L*modelStruct.modelPar_LIIT))+(BIN_W*modelStruct.modelPar_WIIT))+(BIN_WL*modelStruct.modelPar_PIIT));
instanceStruct.d_instanceVar_TGIDL_i_dX = (((modelStruct.d_modelPar_TGIDL_dX+(BIN_L*modelStruct.d_modelPar_LTGIDL_dX+d_BIN_L_dX*modelStruct.modelPar_LTGIDL))+(BIN_W*modelStruct.d_modelPar_WTGIDL_dX+d_BIN_W_dX*modelStruct.modelPar_WTGIDL))+(BIN_WL*modelStruct.d_modelPar_PTGIDL_dX+d_BIN_WL_dX*modelStruct.modelPar_PTGIDL));
instanceStruct.instanceVar_TGIDL_i = (((modelStruct.modelPar_TGIDL+(BIN_L*modelStruct.modelPar_LTGIDL))+(BIN_W*modelStruct.modelPar_WTGIDL))+(BIN_WL*modelStruct.modelPar_PTGIDL));
instanceStruct.d_instanceVar_IGT_i_dX = (((modelStruct.d_modelPar_IGT_dX+(BIN_L*modelStruct.d_modelPar_LIGT_dX+d_BIN_L_dX*modelStruct.modelPar_LIGT))+(BIN_W*modelStruct.d_modelPar_WIGT_dX+d_BIN_W_dX*modelStruct.modelPar_WIGT))+(BIN_WL*modelStruct.d_modelPar_PIGT_dX+d_BIN_WL_dX*modelStruct.modelPar_PIGT));
instanceStruct.instanceVar_IGT_i = (((modelStruct.modelPar_IGT+(BIN_L*modelStruct.modelPar_LIGT))+(BIN_W*modelStruct.modelPar_WIGT))+(BIN_WL*modelStruct.modelPar_PIGT));
instanceStruct.d_instanceVar_AIGBINV_i_dX = (((modelStruct.d_modelPar_AIGBINV_dX+(BIN_L*modelStruct.d_modelPar_LAIGBINV_dX+d_BIN_L_dX*modelStruct.modelPar_LAIGBINV))+(BIN_W*modelStruct.d_modelPar_WAIGBINV_dX+d_BIN_W_dX*modelStruct.modelPar_WAIGBINV))+(BIN_WL*modelStruct.d_modelPar_PAIGBINV_dX+d_BIN_WL_dX*modelStruct.modelPar_PAIGBINV));
instanceStruct.instanceVar_AIGBINV_i = (((modelStruct.modelPar_AIGBINV+(BIN_L*modelStruct.modelPar_LAIGBINV))+(BIN_W*modelStruct.modelPar_WAIGBINV))+(BIN_WL*modelStruct.modelPar_PAIGBINV));
instanceStruct.d_instanceVar_BIGBINV_i_dX = (((modelStruct.d_modelPar_BIGBINV_dX+(BIN_L*modelStruct.d_modelPar_LBIGBINV_dX+d_BIN_L_dX*modelStruct.modelPar_LBIGBINV))+(BIN_W*modelStruct.d_modelPar_WBIGBINV_dX+d_BIN_W_dX*modelStruct.modelPar_WBIGBINV))+(BIN_WL*modelStruct.d_modelPar_PBIGBINV_dX+d_BIN_WL_dX*modelStruct.modelPar_PBIGBINV));
instanceStruct.instanceVar_BIGBINV_i = (((modelStruct.modelPar_BIGBINV+(BIN_L*modelStruct.modelPar_LBIGBINV))+(BIN_W*modelStruct.modelPar_WBIGBINV))+(BIN_WL*modelStruct.modelPar_PBIGBINV));
instanceStruct.d_instanceVar_CIGBINV_i_dX = (((modelStruct.d_modelPar_CIGBINV_dX+(BIN_L*modelStruct.d_modelPar_LCIGBINV_dX+d_BIN_L_dX*modelStruct.modelPar_LCIGBINV))+(BIN_W*modelStruct.d_modelPar_WCIGBINV_dX+d_BIN_W_dX*modelStruct.modelPar_WCIGBINV))+(BIN_WL*modelStruct.d_modelPar_PCIGBINV_dX+d_BIN_WL_dX*modelStruct.modelPar_PCIGBINV));
instanceStruct.instanceVar_CIGBINV_i = (((modelStruct.modelPar_CIGBINV+(BIN_L*modelStruct.modelPar_LCIGBINV))+(BIN_W*modelStruct.modelPar_WCIGBINV))+(BIN_WL*modelStruct.modelPar_PCIGBINV));
instanceStruct.d_instanceVar_EIGBINV_i_dX = (((modelStruct.d_modelPar_EIGBINV_dX+(BIN_L*modelStruct.d_modelPar_LEIGBINV_dX+d_BIN_L_dX*modelStruct.modelPar_LEIGBINV))+(BIN_W*modelStruct.d_modelPar_WEIGBINV_dX+d_BIN_W_dX*modelStruct.modelPar_WEIGBINV))+(BIN_WL*modelStruct.d_modelPar_PEIGBINV_dX+d_BIN_WL_dX*modelStruct.modelPar_PEIGBINV));
instanceStruct.instanceVar_EIGBINV_i = (((modelStruct.modelPar_EIGBINV+(BIN_L*modelStruct.modelPar_LEIGBINV))+(BIN_W*modelStruct.modelPar_WEIGBINV))+(BIN_WL*modelStruct.modelPar_PEIGBINV));
instanceStruct.d_instanceVar_NIGBINV_i_dX = (((modelStruct.d_modelPar_NIGBINV_dX+(BIN_L*modelStruct.d_modelPar_LNIGBINV_dX+d_BIN_L_dX*modelStruct.modelPar_LNIGBINV))+(BIN_W*modelStruct.d_modelPar_WNIGBINV_dX+d_BIN_W_dX*modelStruct.modelPar_WNIGBINV))+(BIN_WL*modelStruct.d_modelPar_PNIGBINV_dX+d_BIN_WL_dX*modelStruct.modelPar_PNIGBINV));
instanceStruct.instanceVar_NIGBINV_i = (((modelStruct.modelPar_NIGBINV+(BIN_L*modelStruct.modelPar_LNIGBINV))+(BIN_W*modelStruct.modelPar_WNIGBINV))+(BIN_WL*modelStruct.modelPar_PNIGBINV));
instanceStruct.d_instanceVar_AIGBACC_i_dX = (((modelStruct.d_modelPar_AIGBACC_dX+(BIN_L*modelStruct.d_modelPar_LAIGBACC_dX+d_BIN_L_dX*modelStruct.modelPar_LAIGBACC))+(BIN_W*modelStruct.d_modelPar_WAIGBACC_dX+d_BIN_W_dX*modelStruct.modelPar_WAIGBACC))+(BIN_WL*modelStruct.d_modelPar_PAIGBACC_dX+d_BIN_WL_dX*modelStruct.modelPar_PAIGBACC));
instanceStruct.instanceVar_AIGBACC_i = (((modelStruct.modelPar_AIGBACC+(BIN_L*modelStruct.modelPar_LAIGBACC))+(BIN_W*modelStruct.modelPar_WAIGBACC))+(BIN_WL*modelStruct.modelPar_PAIGBACC));
instanceStruct.d_instanceVar_BIGBACC_i_dX = (((modelStruct.d_modelPar_BIGBACC_dX+(BIN_L*modelStruct.d_modelPar_LBIGBACC_dX+d_BIN_L_dX*modelStruct.modelPar_LBIGBACC))+(BIN_W*modelStruct.d_modelPar_WBIGBACC_dX+d_BIN_W_dX*modelStruct.modelPar_WBIGBACC))+(BIN_WL*modelStruct.d_modelPar_PBIGBACC_dX+d_BIN_WL_dX*modelStruct.modelPar_PBIGBACC));
instanceStruct.instanceVar_BIGBACC_i = (((modelStruct.modelPar_BIGBACC+(BIN_L*modelStruct.modelPar_LBIGBACC))+(BIN_W*modelStruct.modelPar_WBIGBACC))+(BIN_WL*modelStruct.modelPar_PBIGBACC));
instanceStruct.d_instanceVar_CIGBACC_i_dX = (((modelStruct.d_modelPar_CIGBACC_dX+(BIN_L*modelStruct.d_modelPar_LCIGBACC_dX+d_BIN_L_dX*modelStruct.modelPar_LCIGBACC))+(BIN_W*modelStruct.d_modelPar_WCIGBACC_dX+d_BIN_W_dX*modelStruct.modelPar_WCIGBACC))+(BIN_WL*modelStruct.d_modelPar_PCIGBACC_dX+d_BIN_WL_dX*modelStruct.modelPar_PCIGBACC));
instanceStruct.instanceVar_CIGBACC_i = (((modelStruct.modelPar_CIGBACC+(BIN_L*modelStruct.modelPar_LCIGBACC))+(BIN_W*modelStruct.modelPar_WCIGBACC))+(BIN_WL*modelStruct.modelPar_PCIGBACC));
instanceStruct.d_instanceVar_NIGBACC_i_dX = (((modelStruct.d_modelPar_NIGBACC_dX+(BIN_L*modelStruct.d_modelPar_LNIGBACC_dX+d_BIN_L_dX*modelStruct.modelPar_LNIGBACC))+(BIN_W*modelStruct.d_modelPar_WNIGBACC_dX+d_BIN_W_dX*modelStruct.modelPar_WNIGBACC))+(BIN_WL*modelStruct.d_modelPar_PNIGBACC_dX+d_BIN_WL_dX*modelStruct.modelPar_PNIGBACC));
instanceStruct.instanceVar_NIGBACC_i = (((modelStruct.modelPar_NIGBACC+(BIN_L*modelStruct.modelPar_LNIGBACC))+(BIN_W*modelStruct.modelPar_WNIGBACC))+(BIN_WL*modelStruct.modelPar_PNIGBACC));
instanceStruct.d_instanceVar_AIGC_i_dX = (((modelStruct.d_modelPar_AIGC_dX+(BIN_L*modelStruct.d_modelPar_LAIGC_dX+d_BIN_L_dX*modelStruct.modelPar_LAIGC))+(BIN_W*modelStruct.d_modelPar_WAIGC_dX+d_BIN_W_dX*modelStruct.modelPar_WAIGC))+(BIN_WL*modelStruct.d_modelPar_PAIGC_dX+d_BIN_WL_dX*modelStruct.modelPar_PAIGC));
instanceStruct.instanceVar_AIGC_i = (((modelStruct.modelPar_AIGC+(BIN_L*modelStruct.modelPar_LAIGC))+(BIN_W*modelStruct.modelPar_WAIGC))+(BIN_WL*modelStruct.modelPar_PAIGC));
instanceStruct.d_instanceVar_BIGC_i_dX = (((modelStruct.d_modelPar_BIGC_dX+(BIN_L*modelStruct.d_modelPar_LBIGC_dX+d_BIN_L_dX*modelStruct.modelPar_LBIGC))+(BIN_W*modelStruct.d_modelPar_WBIGC_dX+d_BIN_W_dX*modelStruct.modelPar_WBIGC))+(BIN_WL*modelStruct.d_modelPar_PBIGC_dX+d_BIN_WL_dX*modelStruct.modelPar_PBIGC));
instanceStruct.instanceVar_BIGC_i = (((modelStruct.modelPar_BIGC+(BIN_L*modelStruct.modelPar_LBIGC))+(BIN_W*modelStruct.modelPar_WBIGC))+(BIN_WL*modelStruct.modelPar_PBIGC));
instanceStruct.d_instanceVar_CIGC_i_dX = (((modelStruct.d_modelPar_CIGC_dX+(BIN_L*modelStruct.d_modelPar_LCIGC_dX+d_BIN_L_dX*modelStruct.modelPar_LCIGC))+(BIN_W*modelStruct.d_modelPar_WCIGC_dX+d_BIN_W_dX*modelStruct.modelPar_WCIGC))+(BIN_WL*modelStruct.d_modelPar_PCIGC_dX+d_BIN_WL_dX*modelStruct.modelPar_PCIGC));
instanceStruct.instanceVar_CIGC_i = (((modelStruct.modelPar_CIGC+(BIN_L*modelStruct.modelPar_LCIGC))+(BIN_W*modelStruct.modelPar_WCIGC))+(BIN_WL*modelStruct.modelPar_PCIGC));
instanceStruct.d_instanceVar_AIGS_i_dX = (((modelStruct.d_modelPar_AIGS_dX+(BIN_L*modelStruct.d_modelPar_LAIGS_dX+d_BIN_L_dX*modelStruct.modelPar_LAIGS))+(BIN_W*modelStruct.d_modelPar_WAIGS_dX+d_BIN_W_dX*modelStruct.modelPar_WAIGS))+(BIN_WL*modelStruct.d_modelPar_PAIGS_dX+d_BIN_WL_dX*modelStruct.modelPar_PAIGS));
instanceStruct.instanceVar_AIGS_i = (((modelStruct.modelPar_AIGS+(BIN_L*modelStruct.modelPar_LAIGS))+(BIN_W*modelStruct.modelPar_WAIGS))+(BIN_WL*modelStruct.modelPar_PAIGS));
instanceStruct.d_instanceVar_BIGS_i_dX = (((modelStruct.d_modelPar_BIGS_dX+(BIN_L*modelStruct.d_modelPar_LBIGS_dX+d_BIN_L_dX*modelStruct.modelPar_LBIGS))+(BIN_W*modelStruct.d_modelPar_WBIGS_dX+d_BIN_W_dX*modelStruct.modelPar_WBIGS))+(BIN_WL*modelStruct.d_modelPar_PBIGS_dX+d_BIN_WL_dX*modelStruct.modelPar_PBIGS));
instanceStruct.instanceVar_BIGS_i = (((modelStruct.modelPar_BIGS+(BIN_L*modelStruct.modelPar_LBIGS))+(BIN_W*modelStruct.modelPar_WBIGS))+(BIN_WL*modelStruct.modelPar_PBIGS));
instanceStruct.d_instanceVar_CIGS_i_dX = (((modelStruct.d_modelPar_CIGS_dX+(BIN_L*modelStruct.d_modelPar_LCIGS_dX+d_BIN_L_dX*modelStruct.modelPar_LCIGS))+(BIN_W*modelStruct.d_modelPar_WCIGS_dX+d_BIN_W_dX*modelStruct.modelPar_WCIGS))+(BIN_WL*modelStruct.d_modelPar_PCIGS_dX+d_BIN_WL_dX*modelStruct.modelPar_PCIGS));
instanceStruct.instanceVar_CIGS_i = (((modelStruct.modelPar_CIGS+(BIN_L*modelStruct.modelPar_LCIGS))+(BIN_W*modelStruct.modelPar_WCIGS))+(BIN_WL*modelStruct.modelPar_PCIGS));
instanceStruct.d_instanceVar_AIGD_i_dX = (((modelStruct.d_modelPar_AIGD_dX+(BIN_L*modelStruct.d_modelPar_LAIGD_dX+d_BIN_L_dX*modelStruct.modelPar_LAIGD))+(BIN_W*modelStruct.d_modelPar_WAIGD_dX+d_BIN_W_dX*modelStruct.modelPar_WAIGD))+(BIN_WL*modelStruct.d_modelPar_PAIGD_dX+d_BIN_WL_dX*modelStruct.modelPar_PAIGD));
instanceStruct.instanceVar_AIGD_i = (((modelStruct.modelPar_AIGD+(BIN_L*modelStruct.modelPar_LAIGD))+(BIN_W*modelStruct.modelPar_WAIGD))+(BIN_WL*modelStruct.modelPar_PAIGD));
instanceStruct.d_instanceVar_BIGD_i_dX = (((modelStruct.d_modelPar_BIGD_dX+(BIN_L*modelStruct.d_modelPar_LBIGD_dX+d_BIN_L_dX*modelStruct.modelPar_LBIGD))+(BIN_W*modelStruct.d_modelPar_WBIGD_dX+d_BIN_W_dX*modelStruct.modelPar_WBIGD))+(BIN_WL*modelStruct.d_modelPar_PBIGD_dX+d_BIN_WL_dX*modelStruct.modelPar_PBIGD));
instanceStruct.instanceVar_BIGD_i = (((modelStruct.modelPar_BIGD+(BIN_L*modelStruct.modelPar_LBIGD))+(BIN_W*modelStruct.modelPar_WBIGD))+(BIN_WL*modelStruct.modelPar_PBIGD));
instanceStruct.d_instanceVar_CIGD_i_dX = (((modelStruct.d_modelPar_CIGD_dX+(BIN_L*modelStruct.d_modelPar_LCIGD_dX+d_BIN_L_dX*modelStruct.modelPar_LCIGD))+(BIN_W*modelStruct.d_modelPar_WCIGD_dX+d_BIN_W_dX*modelStruct.modelPar_WCIGD))+(BIN_WL*modelStruct.d_modelPar_PCIGD_dX+d_BIN_WL_dX*modelStruct.modelPar_PCIGD));
instanceStruct.instanceVar_CIGD_i = (((modelStruct.modelPar_CIGD+(BIN_L*modelStruct.modelPar_LCIGD))+(BIN_W*modelStruct.modelPar_WCIGD))+(BIN_WL*modelStruct.modelPar_PCIGD));
d_POXEDGE_i_dX = (((modelStruct.d_modelPar_POXEDGE_dX+(BIN_L*modelStruct.d_modelPar_LPOXEDGE_dX+d_BIN_L_dX*modelStruct.modelPar_LPOXEDGE))+(BIN_W*modelStruct.d_modelPar_WPOXEDGE_dX+d_BIN_W_dX*modelStruct.modelPar_WPOXEDGE))+(BIN_WL*modelStruct.d_modelPar_PPOXEDGE_dX+d_BIN_WL_dX*modelStruct.modelPar_PPOXEDGE));
POXEDGE_i = (((modelStruct.modelPar_POXEDGE+(BIN_L*modelStruct.modelPar_LPOXEDGE))+(BIN_W*modelStruct.modelPar_WPOXEDGE))+(BIN_WL*modelStruct.modelPar_PPOXEDGE));
instanceStruct.d_instanceVar_DLCIG_i_dX = (((modelStruct.d_modelPar_DLCIG_dX+(BIN_L*modelStruct.d_modelPar_LDLCIG_dX+d_BIN_L_dX*modelStruct.modelPar_LDLCIG))+(BIN_W*modelStruct.d_modelPar_WDLCIG_dX+d_BIN_W_dX*modelStruct.modelPar_WDLCIG))+(BIN_WL*modelStruct.d_modelPar_PDLCIG_dX+d_BIN_WL_dX*modelStruct.modelPar_PDLCIG));
instanceStruct.instanceVar_DLCIG_i = (((modelStruct.modelPar_DLCIG+(BIN_L*modelStruct.modelPar_LDLCIG))+(BIN_W*modelStruct.modelPar_WDLCIG))+(BIN_WL*modelStruct.modelPar_PDLCIG));
instanceStruct.d_instanceVar_DLCIGD_i_dX = (((modelStruct.d_modelPar_DLCIGD_dX+(BIN_L*modelStruct.d_modelPar_LDLCIGD_dX+d_BIN_L_dX*modelStruct.modelPar_LDLCIGD))+(BIN_W*modelStruct.d_modelPar_WDLCIGD_dX+d_BIN_W_dX*modelStruct.modelPar_WDLCIGD))+(BIN_WL*modelStruct.d_modelPar_PDLCIGD_dX+d_BIN_WL_dX*modelStruct.modelPar_PDLCIGD));
instanceStruct.instanceVar_DLCIGD_i = (((modelStruct.modelPar_DLCIGD+(BIN_L*modelStruct.modelPar_LDLCIGD))+(BIN_W*modelStruct.modelPar_WDLCIGD))+(BIN_WL*modelStruct.modelPar_PDLCIGD));
d_NTOX_i_dX = (((modelStruct.d_modelPar_NTOX_dX+(BIN_L*modelStruct.d_modelPar_LNTOX_dX+d_BIN_L_dX*modelStruct.modelPar_LNTOX))+(BIN_W*modelStruct.d_modelPar_WNTOX_dX+d_BIN_W_dX*modelStruct.modelPar_WNTOX))+(BIN_WL*modelStruct.d_modelPar_PNTOX_dX+d_BIN_WL_dX*modelStruct.modelPar_PNTOX));
NTOX_i = (((modelStruct.modelPar_NTOX+(BIN_L*modelStruct.modelPar_LNTOX))+(BIN_W*modelStruct.modelPar_WNTOX))+(BIN_WL*modelStruct.modelPar_PNTOX));
instanceStruct.d_instanceVar_KT1_i_dX = (((modelStruct.d_modelPar_KT1_dX+(BIN_L*modelStruct.d_modelPar_LKT1_dX+d_BIN_L_dX*modelStruct.modelPar_LKT1))+(BIN_W*modelStruct.d_modelPar_WKT1_dX+d_BIN_W_dX*modelStruct.modelPar_WKT1))+(BIN_WL*modelStruct.d_modelPar_PKT1_dX+d_BIN_WL_dX*modelStruct.modelPar_PKT1));
instanceStruct.instanceVar_KT1_i = (((modelStruct.modelPar_KT1+(BIN_L*modelStruct.modelPar_LKT1))+(BIN_W*modelStruct.modelPar_WKT1))+(BIN_WL*modelStruct.modelPar_PKT1));
instanceStruct.d_instanceVar_KT2_i_dX = (((modelStruct.d_modelPar_KT2_dX+(BIN_L*modelStruct.d_modelPar_LKT2_dX+d_BIN_L_dX*modelStruct.modelPar_LKT2))+(BIN_W*modelStruct.d_modelPar_WKT2_dX+d_BIN_W_dX*modelStruct.modelPar_WKT2))+(BIN_WL*modelStruct.d_modelPar_PKT2_dX+d_BIN_WL_dX*modelStruct.modelPar_PKT2));
instanceStruct.instanceVar_KT2_i = (((modelStruct.modelPar_KT2+(BIN_L*modelStruct.modelPar_LKT2))+(BIN_W*modelStruct.modelPar_WKT2))+(BIN_WL*modelStruct.modelPar_PKT2));
instanceStruct.d_instanceVar_PSATB_i_dX = (((modelStruct.d_modelPar_PSATB_dX+(BIN_L*modelStruct.d_modelPar_LPSATB_dX+d_BIN_L_dX*modelStruct.modelPar_LPSATB))+(BIN_W*modelStruct.d_modelPar_WPSATB_dX+d_BIN_W_dX*modelStruct.modelPar_WPSATB))+(BIN_WL*modelStruct.d_modelPar_PPSATB_dX+d_BIN_WL_dX*modelStruct.modelPar_PPSATB));
instanceStruct.instanceVar_PSATB_i = (((modelStruct.modelPar_PSATB+(BIN_L*modelStruct.modelPar_LPSATB))+(BIN_W*modelStruct.modelPar_WPSATB))+(BIN_WL*modelStruct.modelPar_PPSATB));
instanceStruct.d_instanceVar_A1_i_dX = (((modelStruct.d_modelPar_A1_dX+(BIN_L*modelStruct.d_modelPar_LA1_dX+d_BIN_L_dX*modelStruct.modelPar_LA1))+(BIN_W*modelStruct.d_modelPar_WA1_dX+d_BIN_W_dX*modelStruct.modelPar_WA1))+(BIN_WL*modelStruct.d_modelPar_PA1_dX+d_BIN_WL_dX*modelStruct.modelPar_PA1));
instanceStruct.instanceVar_A1_i = (((modelStruct.modelPar_A1+(BIN_L*modelStruct.modelPar_LA1))+(BIN_W*modelStruct.modelPar_WA1))+(BIN_WL*modelStruct.modelPar_PA1));
instanceStruct.d_instanceVar_A11_i_dX = (((modelStruct.d_modelPar_A11_dX+(BIN_L*modelStruct.d_modelPar_LA11_dX+d_BIN_L_dX*modelStruct.modelPar_LA11))+(BIN_W*modelStruct.d_modelPar_WA11_dX+d_BIN_W_dX*modelStruct.modelPar_WA11))+(BIN_WL*modelStruct.d_modelPar_PA11_dX+d_BIN_WL_dX*modelStruct.modelPar_PA11));
instanceStruct.instanceVar_A11_i = (((modelStruct.modelPar_A11+(BIN_L*modelStruct.modelPar_LA11))+(BIN_W*modelStruct.modelPar_WA11))+(BIN_WL*modelStruct.modelPar_PA11));
instanceStruct.d_instanceVar_A2_i_dX = (((modelStruct.d_modelPar_A2_dX+(BIN_L*modelStruct.d_modelPar_LA2_dX+d_BIN_L_dX*modelStruct.modelPar_LA2))+(BIN_W*modelStruct.d_modelPar_WA2_dX+d_BIN_W_dX*modelStruct.modelPar_WA2))+(BIN_WL*modelStruct.d_modelPar_PA2_dX+d_BIN_WL_dX*modelStruct.modelPar_PA2));
instanceStruct.instanceVar_A2_i = (((modelStruct.modelPar_A2+(BIN_L*modelStruct.modelPar_LA2))+(BIN_W*modelStruct.modelPar_WA2))+(BIN_WL*modelStruct.modelPar_PA2));
instanceStruct.d_instanceVar_A21_i_dX = (((modelStruct.d_modelPar_A21_dX+(BIN_L*modelStruct.d_modelPar_LA21_dX+d_BIN_L_dX*modelStruct.modelPar_LA21))+(BIN_W*modelStruct.d_modelPar_WA21_dX+d_BIN_W_dX*modelStruct.modelPar_WA21))+(BIN_WL*modelStruct.d_modelPar_PA21_dX+d_BIN_WL_dX*modelStruct.modelPar_PA21));
instanceStruct.instanceVar_A21_i = (((modelStruct.modelPar_A21+(BIN_L*modelStruct.modelPar_LA21))+(BIN_W*modelStruct.modelPar_WA21))+(BIN_WL*modelStruct.modelPar_PA21));
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_CDSCDR_i_dX = (((modelStruct.d_modelPar_CDSCDR_dX+(BIN_L*modelStruct.d_modelPar_LCDSCDR_dX+d_BIN_L_dX*modelStruct.modelPar_LCDSCDR))+(BIN_W*modelStruct.d_modelPar_WCDSCDR_dX+d_BIN_W_dX*modelStruct.modelPar_WCDSCDR))+(BIN_WL*modelStruct.d_modelPar_PCDSCDR_dX+d_BIN_WL_dX*modelStruct.modelPar_PCDSCDR));
instanceStruct.instanceVar_CDSCDR_i = (((modelStruct.modelPar_CDSCDR+(BIN_L*modelStruct.modelPar_LCDSCDR))+(BIN_W*modelStruct.modelPar_WCDSCDR))+(BIN_WL*modelStruct.modelPar_PCDSCDR));
instanceStruct.d_instanceVar_ETA0R_i_dX = (((modelStruct.d_modelPar_ETA0R_dX+(BIN_L*modelStruct.d_modelPar_LETA0R_dX+d_BIN_L_dX*modelStruct.modelPar_LETA0R))+(BIN_W*modelStruct.d_modelPar_WETA0R_dX+d_BIN_W_dX*modelStruct.modelPar_WETA0R))+(BIN_WL*modelStruct.d_modelPar_PETA0R_dX+d_BIN_WL_dX*modelStruct.modelPar_PETA0R));
instanceStruct.instanceVar_ETA0R_i = (((modelStruct.modelPar_ETA0R+(BIN_L*modelStruct.modelPar_LETA0R))+(BIN_W*modelStruct.modelPar_WETA0R))+(BIN_WL*modelStruct.modelPar_PETA0R));
instanceStruct.d_instanceVar_U0R_i_dX = (((modelStruct.d_modelPar_U0R_dX+(BIN_L*modelStruct.d_modelPar_LU0R_dX+d_BIN_L_dX*modelStruct.modelPar_LU0R))+(BIN_W*modelStruct.d_modelPar_WU0R_dX+d_BIN_W_dX*modelStruct.modelPar_WU0R))+(BIN_WL*modelStruct.d_modelPar_PU0R_dX+d_BIN_WL_dX*modelStruct.modelPar_PU0R));
instanceStruct.instanceVar_U0R_i = (((modelStruct.modelPar_U0R+(BIN_L*modelStruct.modelPar_LU0R))+(BIN_W*modelStruct.modelPar_WU0R))+(BIN_WL*modelStruct.modelPar_PU0R));
instanceStruct.d_instanceVar_UAR_i_dX = (((modelStruct.d_modelPar_UAR_dX+(BIN_L*modelStruct.d_modelPar_LUAR_dX+d_BIN_L_dX*modelStruct.modelPar_LUAR))+(BIN_W*modelStruct.d_modelPar_WUAR_dX+d_BIN_W_dX*modelStruct.modelPar_WUAR))+(BIN_WL*modelStruct.d_modelPar_PUAR_dX+d_BIN_WL_dX*modelStruct.modelPar_PUAR));
instanceStruct.instanceVar_UAR_i = (((modelStruct.modelPar_UAR+(BIN_L*modelStruct.modelPar_LUAR))+(BIN_W*modelStruct.modelPar_WUAR))+(BIN_WL*modelStruct.modelPar_PUAR));
instanceStruct.d_instanceVar_UDR_i_dX = (((modelStruct.d_modelPar_UDR_dX+(BIN_L*modelStruct.d_modelPar_LUDR_dX+d_BIN_L_dX*modelStruct.modelPar_LUDR))+(BIN_W*modelStruct.d_modelPar_WUDR_dX+d_BIN_W_dX*modelStruct.modelPar_WUDR))+(BIN_WL*modelStruct.d_modelPar_PUDR_dX+d_BIN_WL_dX*modelStruct.modelPar_PUDR));
instanceStruct.instanceVar_UDR_i = (((modelStruct.modelPar_UDR+(BIN_L*modelStruct.modelPar_LUDR))+(BIN_W*modelStruct.modelPar_WUDR))+(BIN_WL*modelStruct.modelPar_PUDR));
instanceStruct.d_instanceVar_UCSR_i_dX = (((modelStruct.d_modelPar_UCSR_dX+(BIN_L*modelStruct.d_modelPar_LUCSR_dX+d_BIN_L_dX*modelStruct.modelPar_LUCSR))+(BIN_W*modelStruct.d_modelPar_WUCSR_dX+d_BIN_W_dX*modelStruct.modelPar_WUCSR))+(BIN_WL*modelStruct.d_modelPar_PUCSR_dX+d_BIN_WL_dX*modelStruct.modelPar_PUCSR));
instanceStruct.instanceVar_UCSR_i = (((modelStruct.modelPar_UCSR+(BIN_L*modelStruct.modelPar_LUCSR))+(BIN_W*modelStruct.modelPar_WUCSR))+(BIN_WL*modelStruct.modelPar_PUCSR));
instanceStruct.d_instanceVar_UCR_i_dX = (((modelStruct.d_modelPar_UCR_dX+(BIN_L*modelStruct.d_modelPar_LUCR_dX+d_BIN_L_dX*modelStruct.modelPar_LUCR))+(BIN_W*modelStruct.d_modelPar_WUCR_dX+d_BIN_W_dX*modelStruct.modelPar_WUCR))+(BIN_WL*modelStruct.d_modelPar_PUCR_dX+d_BIN_WL_dX*modelStruct.modelPar_PUCR));
instanceStruct.instanceVar_UCR_i = (((modelStruct.modelPar_UCR+(BIN_L*modelStruct.modelPar_LUCR))+(BIN_W*modelStruct.modelPar_WUCR))+(BIN_WL*modelStruct.modelPar_PUCR));
instanceStruct.d_instanceVar_PCLMR_i_dX = (((modelStruct.d_modelPar_PCLMR_dX+(BIN_L*modelStruct.d_modelPar_LPCLMR_dX+d_BIN_L_dX*modelStruct.modelPar_LPCLMR))+(BIN_W*modelStruct.d_modelPar_WPCLMR_dX+d_BIN_W_dX*modelStruct.modelPar_WPCLMR))+(BIN_WL*modelStruct.d_modelPar_PPCLMR_dX+d_BIN_WL_dX*modelStruct.modelPar_PPCLMR));
instanceStruct.instanceVar_PCLMR_i = (((modelStruct.modelPar_PCLMR+(BIN_L*modelStruct.modelPar_LPCLMR))+(BIN_W*modelStruct.modelPar_WPCLMR))+(BIN_WL*modelStruct.modelPar_PPCLMR));
instanceStruct.d_instanceVar_PDIBLCR_i_dX = (((modelStruct.d_modelPar_PDIBLCR_dX+(BIN_L*modelStruct.d_modelPar_LPDIBLCR_dX+d_BIN_L_dX*modelStruct.modelPar_LPDIBLCR))+(BIN_W*modelStruct.d_modelPar_WPDIBLCR_dX+d_BIN_W_dX*modelStruct.modelPar_WPDIBLCR))+(BIN_WL*modelStruct.d_modelPar_PPDIBLCR_dX+d_BIN_WL_dX*modelStruct.modelPar_PPDIBLCR));
instanceStruct.instanceVar_PDIBLCR_i = (((modelStruct.modelPar_PDIBLCR+(BIN_L*modelStruct.modelPar_LPDIBLCR))+(BIN_W*modelStruct.modelPar_WPDIBLCR))+(BIN_WL*modelStruct.modelPar_PPDIBLCR));
instanceStruct.d_instanceVar_VSATR_i_dX = (((modelStruct.d_modelPar_VSATR_dX+(BIN_L*modelStruct.d_modelPar_LVSATR_dX+d_BIN_L_dX*modelStruct.modelPar_LVSATR))+(BIN_W*modelStruct.d_modelPar_WVSATR_dX+d_BIN_W_dX*modelStruct.modelPar_WVSATR))+(BIN_WL*modelStruct.d_modelPar_PVSATR_dX+d_BIN_WL_dX*modelStruct.modelPar_PVSATR));
instanceStruct.instanceVar_VSATR_i = (((modelStruct.modelPar_VSATR+(BIN_L*modelStruct.modelPar_LVSATR))+(BIN_W*modelStruct.modelPar_WVSATR))+(BIN_WL*modelStruct.modelPar_PVSATR));
instanceStruct.d_instanceVar_PSATR_i_dX = (((modelStruct.d_modelPar_PSATR_dX+(BIN_L*modelStruct.d_modelPar_LPSATR_dX+d_BIN_L_dX*modelStruct.modelPar_LPSATR))+(BIN_W*modelStruct.d_modelPar_WPSATR_dX+d_BIN_W_dX*modelStruct.modelPar_WPSATR))+(BIN_WL*modelStruct.d_modelPar_PPSATR_dX+d_BIN_WL_dX*modelStruct.modelPar_PPSATR));
instanceStruct.instanceVar_PSATR_i = (((modelStruct.modelPar_PSATR+(BIN_L*modelStruct.modelPar_LPSATR))+(BIN_W*modelStruct.modelPar_WPSATR))+(BIN_WL*modelStruct.modelPar_PPSATR));
instanceStruct.d_instanceVar_PTWGR_i_dX = (((modelStruct.d_modelPar_PTWGR_dX+(BIN_L*modelStruct.d_modelPar_LPTWGR_dX+d_BIN_L_dX*modelStruct.modelPar_LPTWGR))+(BIN_W*modelStruct.d_modelPar_WPTWGR_dX+d_BIN_W_dX*modelStruct.modelPar_WPTWGR))+(BIN_WL*modelStruct.d_modelPar_PPTWGR_dX+d_BIN_WL_dX*modelStruct.modelPar_PPTWGR));
instanceStruct.instanceVar_PTWGR_i = (((modelStruct.modelPar_PTWGR+(BIN_L*modelStruct.modelPar_LPTWGR))+(BIN_W*modelStruct.modelPar_WPTWGR))+(BIN_WL*modelStruct.modelPar_PPTWGR));
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_NDEPLEXP1);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_NDEPLEXP1);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_L,modelStruct.modelPar_NDEPLEXP2);
double value_pow_4 = pow(Inv_Llong,modelStruct.modelPar_NDEPLEXP2);
double value_max_5 = std::max((value_pow_3-value_pow_4),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_NDEPLEXP1/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_NDEPLEXP1/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_L == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_NDEPLEXP2/Inv_L));
double  deriv_pow_3_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_3);
double  deriv_pow_4_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_4*modelStruct.modelPar_NDEPLEXP2/Inv_Llong));
double  deriv_pow_4_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_4);
double  deriv_max_5_d0 = (((value_pow_3-value_pow_4)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = ((modelStruct.modelPar_NDEPL1*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_NDEPLEXP1_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_NDEPLEXP1_dX))))))+modelStruct.d_modelPar_NDEPL1_dX*value_max_2)+(modelStruct.modelPar_NDEPL2*(deriv_max_5_d0*((((deriv_pow_3_d0*(d_Inv_L_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_NDEPLEXP2_dX)))-((deriv_pow_4_d0*(d_Inv_Llong_dX))+(deriv_pow_4_d1*(modelStruct.d_modelPar_NDEPLEXP2_dX))))))+modelStruct.d_modelPar_NDEPL2_dX*value_max_5));
instanceStruct.instanceVar_T0 = ((modelStruct.modelPar_NDEPL1*value_max_2)+(modelStruct.modelPar_NDEPL2*value_max_5));
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_NDEPWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_NDEPWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow((Inv_W*Inv_L),modelStruct.modelPar_NDEPWLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_NDEPWEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_NDEPWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = (((Inv_W*Inv_L) == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_NDEPWLEXP/(Inv_W*Inv_L)));
double  deriv_pow_3_d1 = ((Inv_W*Inv_L) == 0.0)?0.0:(log((Inv_W*Inv_L))*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_NDEPW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_NDEPWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_NDEPWEXP_dX))))))+modelStruct.d_modelPar_NDEPW_dX*value_max_2)+(modelStruct.modelPar_NDEPWL*((deriv_pow_3_d0*((Inv_W*d_Inv_L_dX+d_Inv_W_dX*Inv_L)))+(deriv_pow_3_d1*(modelStruct.d_modelPar_NDEPWLEXP_dX)))+modelStruct.d_modelPar_NDEPWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_NDEPW*value_max_2)+(modelStruct.modelPar_NDEPWL*value_pow_3));
}
instanceStruct.d_instanceVar_NDEP_i_dX = (instanceStruct.instanceVar_NDEP_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_NDEP_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_NDEP_i = (instanceStruct.instanceVar_NDEP_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_NFACTORLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_NFACTORLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_NFACTORLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_NFACTORLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_NFACTORL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_NFACTORLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_NFACTORLEXP_dX))))))+modelStruct.d_modelPar_NFACTORL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_NFACTORL*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_NFACTORWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_NFACTORWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_NFACTORWLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_NFACTORWEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_NFACTORWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_NFACTORWLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_NFACTORW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_NFACTORWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_NFACTORWEXP_dX))))))+modelStruct.d_modelPar_NFACTORW_dX*value_max_2)+(modelStruct.modelPar_NFACTORWL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_NFACTORWLEXP_dX)))+modelStruct.d_modelPar_NFACTORWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_NFACTORW*value_max_2)+(modelStruct.modelPar_NFACTORWL*value_pow_3));
}
instanceStruct.d_instanceVar_NFACTOR_i_dX = (instanceStruct.instanceVar_NFACTOR_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_NFACTOR_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_NFACTOR_i = (instanceStruct.instanceVar_NFACTOR_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_CDSCDLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_CDSCDLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CDSCDLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_CDSCDLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_CDSCDL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CDSCDLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_CDSCDLEXP_dX))))))+modelStruct.d_modelPar_CDSCDL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (1.0+(modelStruct.modelPar_CDSCDL*value_max_2));
}
instanceStruct.d_instanceVar_CDSCD_i_dX = (instanceStruct.instanceVar_CDSCD_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_CDSCD_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_CDSCD_i = (instanceStruct.instanceVar_CDSCD_i*instanceStruct.instanceVar_T0);
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_CDSCDR_i_dX = (instanceStruct.instanceVar_CDSCDR_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_CDSCDR_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_CDSCDR_i = (instanceStruct.instanceVar_CDSCDR_i*instanceStruct.instanceVar_T0);
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_CDSCBLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_CDSCBLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CDSCBLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_CDSCBLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_CDSCB_i_dX = (instanceStruct.instanceVar_CDSCB_i*(modelStruct.modelPar_CDSCBL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CDSCBLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_CDSCBLEXP_dX))))))+modelStruct.d_modelPar_CDSCBL_dX*value_max_2)+instanceStruct.d_instanceVar_CDSCB_i_dX*(1.0+(modelStruct.modelPar_CDSCBL*value_max_2)));
instanceStruct.instanceVar_CDSCB_i = (instanceStruct.instanceVar_CDSCB_i*(1.0+(modelStruct.modelPar_CDSCBL*value_max_2)));
}
instanceStruct.d_instanceVar_U0_i_dX = (modelStruct.modelPar_MULU0*instanceStruct.d_instanceVar_U0_i_dX+modelStruct.d_modelPar_MULU0_dX*instanceStruct.instanceVar_U0_i);
instanceStruct.instanceVar_U0_i = (modelStruct.modelPar_MULU0*instanceStruct.instanceVar_U0_i);
if ((modelStruct.modelPar_MOBSCALE!=1))
{
if ((modelStruct.modelPar_U0LEXP>0))
{
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_U0LEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_U0LEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_U0LEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_U0LEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_U0_i_dX = (instanceStruct.instanceVar_U0_i*(-(modelStruct.modelPar_U0L*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_U0LEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_U0LEXP_dX))))))+modelStruct.d_modelPar_U0L_dX*value_max_2))+instanceStruct.d_instanceVar_U0_i_dX*(1.0-(modelStruct.modelPar_U0L*value_max_2)));
instanceStruct.instanceVar_U0_i = (instanceStruct.instanceVar_U0_i*(1.0-(modelStruct.modelPar_U0L*value_max_2)));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_U0LEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_U0LEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_U0LEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_U0LEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_U0R_i_dX = (instanceStruct.instanceVar_U0R_i*(-(modelStruct.modelPar_U0L*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_U0LEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_U0LEXP_dX))))))+modelStruct.d_modelPar_U0L_dX*value_max_2))+instanceStruct.d_instanceVar_U0R_i_dX*(1.0-(modelStruct.modelPar_U0L*value_max_2)));
instanceStruct.instanceVar_U0R_i = (instanceStruct.instanceVar_U0R_i*(1.0-(modelStruct.modelPar_U0L*value_max_2)));
}
}
}
else
{
instanceStruct.d_instanceVar_U0_i_dX = (instanceStruct.instanceVar_U0_i*(-modelStruct.d_modelPar_U0L_dX)+instanceStruct.d_instanceVar_U0_i_dX*(1.0-modelStruct.modelPar_U0L));
instanceStruct.instanceVar_U0_i = (instanceStruct.instanceVar_U0_i*(1.0-modelStruct.modelPar_U0L));
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_U0R_i_dX = (instanceStruct.instanceVar_U0R_i*(-modelStruct.d_modelPar_U0L_dX)+instanceStruct.d_instanceVar_U0R_i_dX*(1.0-modelStruct.modelPar_U0L));
instanceStruct.instanceVar_U0R_i = (instanceStruct.instanceVar_U0R_i*(1.0-modelStruct.modelPar_U0L));
}
}
}
else
{
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_Leff)/modelStruct.modelPar_LP1));
double value_exp_1 = exp(((-instanceStruct.instanceVar_Leff)/modelStruct.modelPar_LP2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_U0_i_dX = (instanceStruct.instanceVar_U0_i*((-(modelStruct.modelPar_UP1*deriv_exp_0_d0*(((modelStruct.modelPar_LP1*(-instanceStruct.d_instanceVar_Leff_dX)-(-instanceStruct.instanceVar_Leff)*modelStruct.d_modelPar_LP1_dX)/modelStruct.modelPar_LP1/modelStruct.modelPar_LP1))+modelStruct.d_modelPar_UP1_dX*value_exp_0))-(modelStruct.modelPar_UP2*deriv_exp_1_d0*(((modelStruct.modelPar_LP2*(-instanceStruct.d_instanceVar_Leff_dX)-(-instanceStruct.instanceVar_Leff)*modelStruct.d_modelPar_LP2_dX)/modelStruct.modelPar_LP2/modelStruct.modelPar_LP2))+modelStruct.d_modelPar_UP2_dX*value_exp_1))+instanceStruct.d_instanceVar_U0_i_dX*((1.0-(modelStruct.modelPar_UP1*value_exp_0))-(modelStruct.modelPar_UP2*value_exp_1)));
instanceStruct.instanceVar_U0_i = (instanceStruct.instanceVar_U0_i*((1.0-(modelStruct.modelPar_UP1*value_exp_0))-(modelStruct.modelPar_UP2*value_exp_1)));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_Leff)/modelStruct.modelPar_LP1));
double value_exp_1 = exp(((-instanceStruct.instanceVar_Leff)/modelStruct.modelPar_LP2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_U0R_i_dX = (instanceStruct.instanceVar_U0R_i*((-(modelStruct.modelPar_UP1*deriv_exp_0_d0*(((modelStruct.modelPar_LP1*(-instanceStruct.d_instanceVar_Leff_dX)-(-instanceStruct.instanceVar_Leff)*modelStruct.d_modelPar_LP1_dX)/modelStruct.modelPar_LP1/modelStruct.modelPar_LP1))+modelStruct.d_modelPar_UP1_dX*value_exp_0))-(modelStruct.modelPar_UP2*deriv_exp_1_d0*(((modelStruct.modelPar_LP2*(-instanceStruct.d_instanceVar_Leff_dX)-(-instanceStruct.instanceVar_Leff)*modelStruct.d_modelPar_LP2_dX)/modelStruct.modelPar_LP2/modelStruct.modelPar_LP2))+modelStruct.d_modelPar_UP2_dX*value_exp_1))+instanceStruct.d_instanceVar_U0R_i_dX*((1.0-(modelStruct.modelPar_UP1*value_exp_0))-(modelStruct.modelPar_UP2*value_exp_1)));
instanceStruct.instanceVar_U0R_i = (instanceStruct.instanceVar_U0R_i*((1.0-(modelStruct.modelPar_UP1*value_exp_0))-(modelStruct.modelPar_UP2*value_exp_1)));
}
}
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_UALEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_UALEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_UALEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_UALEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_UAL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_UALEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_UALEXP_dX))))))+modelStruct.d_modelPar_UAL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_UAL*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_UAWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_UAWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_UAWLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_UAWEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_UAWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_UAWLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_UAW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_UAWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_UAWEXP_dX))))))+modelStruct.d_modelPar_UAW_dX*value_max_2)+(modelStruct.modelPar_UAWL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_UAWLEXP_dX)))+modelStruct.d_modelPar_UAWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_UAW*value_max_2)+(modelStruct.modelPar_UAWL*value_pow_3));
}
instanceStruct.d_instanceVar_UA_i_dX = (instanceStruct.instanceVar_UA_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_UA_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_UA_i = (instanceStruct.instanceVar_UA_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_UAR_i_dX = (instanceStruct.instanceVar_UAR_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_UAR_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_UAR_i = (instanceStruct.instanceVar_UAR_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_EULEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_EULEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_EULEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_EULEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_EUL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_EULEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_EULEXP_dX))))))+modelStruct.d_modelPar_EUL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_EUL*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_EUWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_EUWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_EUWLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_EUWEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_EUWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_EUWLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_EUW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_EUWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_EUWEXP_dX))))))+modelStruct.d_modelPar_EUW_dX*value_max_2)+(modelStruct.modelPar_EUWL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_EUWLEXP_dX)))+modelStruct.d_modelPar_EUWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_EUW*value_max_2)+(modelStruct.modelPar_EUWL*value_pow_3));
}
instanceStruct.d_instanceVar_EU_i_dX = (instanceStruct.instanceVar_EU_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_EU_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_EU_i = (instanceStruct.instanceVar_EU_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_UDLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_UDLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_UDLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_UDLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_UDL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_UDLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_UDLEXP_dX))))))+modelStruct.d_modelPar_UDL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (1.0+(modelStruct.modelPar_UDL*value_max_2));
}
instanceStruct.d_instanceVar_UD_i_dX = (instanceStruct.instanceVar_UD_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_UD_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_UD_i = (instanceStruct.instanceVar_UD_i*instanceStruct.instanceVar_T0);
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_UDR_i_dX = (instanceStruct.instanceVar_UDR_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_UDR_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_UDR_i = (instanceStruct.instanceVar_UDR_i*instanceStruct.instanceVar_T0);
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_UCLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_UCLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_UCLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_UCLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_UCL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_UCLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_UCLEXP_dX))))))+modelStruct.d_modelPar_UCL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_UCL*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_UCWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_UCWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_UCWLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_UCWEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_UCWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_UCWLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_UCW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_UCWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_UCWEXP_dX))))))+modelStruct.d_modelPar_UCW_dX*value_max_2)+(modelStruct.modelPar_UCWL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_UCWLEXP_dX)))+modelStruct.d_modelPar_UCWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_UCW*value_max_2)+(modelStruct.modelPar_UCWL*value_pow_3));
}
instanceStruct.d_instanceVar_UC_i_dX = (instanceStruct.instanceVar_UC_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_UC_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_UC_i = (instanceStruct.instanceVar_UC_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_UCR_i_dX = (instanceStruct.instanceVar_UCR_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_UCR_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_UCR_i = (instanceStruct.instanceVar_UCR_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_DSUB);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_DSUB);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_DSUB/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_DSUB/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_DSUB_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_DSUB_dX))))));
instanceStruct.instanceVar_T0 = value_max_2;
}
instanceStruct.d_instanceVar_ETA0_i_dX = (instanceStruct.instanceVar_ETA0_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_ETA0_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_ETA0_i = (instanceStruct.instanceVar_ETA0_i*instanceStruct.instanceVar_T0);
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_ETA0R_i_dX = (instanceStruct.instanceVar_ETA0R_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_ETA0R_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_ETA0R_i = (instanceStruct.instanceVar_ETA0R_i*instanceStruct.instanceVar_T0);
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_ETABEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_ETABEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ETABEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_ETABEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_ETAB_i_dX = (instanceStruct.instanceVar_ETAB_i*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ETABEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_ETABEXP_dX))))))+instanceStruct.d_instanceVar_ETAB_i_dX*value_max_2);
instanceStruct.instanceVar_ETAB_i = (instanceStruct.instanceVar_ETAB_i*value_max_2);
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_PDIBLCLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_PDIBLCLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PDIBLCLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_PDIBLCLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_PDIBLCL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PDIBLCLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_PDIBLCLEXP_dX))))))+modelStruct.d_modelPar_PDIBLCL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (1.0+(modelStruct.modelPar_PDIBLCL*value_max_2));
}
instanceStruct.d_instanceVar_PDIBLC_i_dX = (instanceStruct.instanceVar_PDIBLC_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_PDIBLC_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_PDIBLC_i = (instanceStruct.instanceVar_PDIBLC_i*instanceStruct.instanceVar_T0);
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_PDIBLCR_i_dX = (instanceStruct.instanceVar_PDIBLCR_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_PDIBLCR_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_PDIBLCR_i = (instanceStruct.instanceVar_PDIBLCR_i*instanceStruct.instanceVar_T0);
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_DELTALEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_DELTALEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_DELTALEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_DELTALEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (instanceStruct.instanceVar_DELTA_i*(modelStruct.modelPar_DELTAL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_DELTALEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_DELTALEXP_dX))))))+modelStruct.d_modelPar_DELTAL_dX*value_max_2)+instanceStruct.d_instanceVar_DELTA_i_dX*(1.0+(modelStruct.modelPar_DELTAL*value_max_2)));
instanceStruct.instanceVar_T0 = (instanceStruct.instanceVar_DELTA_i*(1.0+(modelStruct.modelPar_DELTAL*value_max_2)));
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_T0,static_cast<double>(0.5));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_T0<=0.5)?1.0:0.0);
instanceStruct.d_instanceVar_DELTA_i_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_T0_dX));
instanceStruct.instanceVar_DELTA_i = value_min_0;
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_FPROUTLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_FPROUTLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_FPROUTLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_FPROUTLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_FPROUT_i_dX = (instanceStruct.instanceVar_FPROUT_i*(modelStruct.modelPar_FPROUTL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_FPROUTLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_FPROUTLEXP_dX))))))+modelStruct.d_modelPar_FPROUTL_dX*value_max_2)+instanceStruct.d_instanceVar_FPROUT_i_dX*(1.0+(modelStruct.modelPar_FPROUTL*value_max_2)));
instanceStruct.instanceVar_FPROUT_i = (instanceStruct.instanceVar_FPROUT_i*(1.0+(modelStruct.modelPar_FPROUTL*value_max_2)));
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_PCLMLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_PCLMLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PCLMLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_PCLMLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_PCLML*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PCLMLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_PCLMLEXP_dX))))))+modelStruct.d_modelPar_PCLML_dX*value_max_2);
instanceStruct.instanceVar_T0 = (1.0+(modelStruct.modelPar_PCLML*value_max_2));
}
instanceStruct.d_instanceVar_PCLM_i_dX = (instanceStruct.instanceVar_PCLM_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_PCLM_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_PCLM_i = (instanceStruct.instanceVar_PCLM_i*instanceStruct.instanceVar_T0);
{
double value_max_0 = std::max(instanceStruct.instanceVar_PCLM_i,static_cast<double>(0));
double  deriv_max_0_d0 = ((instanceStruct.instanceVar_PCLM_i>=0)?1.0:0.0);
instanceStruct.d_instanceVar_PCLM_i_dX = (deriv_max_0_d0*(instanceStruct.d_instanceVar_PCLM_i_dX));
instanceStruct.instanceVar_PCLM_i = value_max_0;
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_PCLMR_i_dX = (instanceStruct.instanceVar_PCLMR_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_PCLMR_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_PCLMR_i = (instanceStruct.instanceVar_PCLMR_i*instanceStruct.instanceVar_T0);
{
double value_max_0 = std::max(instanceStruct.instanceVar_PCLMR_i,static_cast<double>(0));
double  deriv_max_0_d0 = ((instanceStruct.instanceVar_PCLMR_i>=0)?1.0:0.0);
instanceStruct.d_instanceVar_PCLMR_i_dX = (deriv_max_0_d0*(instanceStruct.d_instanceVar_PCLMR_i_dX));
instanceStruct.instanceVar_PCLMR_i = value_max_0;
}
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_VSATLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_VSATLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_VSATLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_VSATLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_VSATL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_VSATLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_VSATLEXP_dX))))))+modelStruct.d_modelPar_VSATL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_VSATL*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_VSATWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_VSATWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_VSATWLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_VSATWEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_VSATWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_VSATWLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_VSATW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_VSATWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_VSATWEXP_dX))))))+modelStruct.d_modelPar_VSATW_dX*value_max_2)+(modelStruct.modelPar_VSATWL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_VSATWLEXP_dX)))+modelStruct.d_modelPar_VSATWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_VSATW*value_max_2)+(modelStruct.modelPar_VSATWL*value_pow_3));
}
instanceStruct.d_instanceVar_VSAT_i_dX = (instanceStruct.instanceVar_VSAT_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_VSAT_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_VSAT_i = (instanceStruct.instanceVar_VSAT_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_VSATR_i_dX = (instanceStruct.instanceVar_VSATR_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_VSATR_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_VSATR_i = (instanceStruct.instanceVar_VSATR_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_PSATLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_PSATLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_max_3 = std::max((instanceStruct.instanceVar_PSAT_i*(1.0+(modelStruct.modelPar_PSATL*value_max_2))),static_cast<double>(0.25));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PSATLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_PSATLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_max_3_d0 = (((instanceStruct.instanceVar_PSAT_i*(1.0+(modelStruct.modelPar_PSATL*value_max_2)))>=0.25)?1.0:0.0);
instanceStruct.d_instanceVar_PSAT_i_dX = (deriv_max_3_d0*((instanceStruct.instanceVar_PSAT_i*(modelStruct.modelPar_PSATL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PSATLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_PSATLEXP_dX))))))+modelStruct.d_modelPar_PSATL_dX*value_max_2)+instanceStruct.d_instanceVar_PSAT_i_dX*(1.0+(modelStruct.modelPar_PSATL*value_max_2)))));
instanceStruct.instanceVar_PSAT_i = value_max_3;
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_PSATLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_PSATLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_max_3 = std::max((instanceStruct.instanceVar_PSATR_i*(1.0+(modelStruct.modelPar_PSATL*value_max_2))),static_cast<double>(0.25));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PSATLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_PSATLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_max_3_d0 = (((instanceStruct.instanceVar_PSATR_i*(1.0+(modelStruct.modelPar_PSATL*value_max_2)))>=0.25)?1.0:0.0);
instanceStruct.d_instanceVar_PSATR_i_dX = (deriv_max_3_d0*((instanceStruct.instanceVar_PSATR_i*(modelStruct.modelPar_PSATL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PSATLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_PSATLEXP_dX))))))+modelStruct.d_modelPar_PSATL_dX*value_max_2)+instanceStruct.d_instanceVar_PSATR_i_dX*(1.0+(modelStruct.modelPar_PSATL*value_max_2)))));
instanceStruct.instanceVar_PSATR_i = value_max_3;
}
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_PTWGLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_PTWGLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PTWGLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_PTWGLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_PTWGL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PTWGLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_PTWGLEXP_dX))))))+modelStruct.d_modelPar_PTWGL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (1.0+(modelStruct.modelPar_PTWGL*value_max_2));
}
instanceStruct.d_instanceVar_PTWG_i_dX = (instanceStruct.instanceVar_PTWG_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_PTWG_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_PTWG_i = (instanceStruct.instanceVar_PTWG_i*instanceStruct.instanceVar_T0);
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_PTWGR_i_dX = (instanceStruct.instanceVar_PTWGR_i*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_PTWGR_i_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_PTWGR_i = (instanceStruct.instanceVar_PTWGR_i*instanceStruct.instanceVar_T0);
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_ALPHA0LEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_ALPHA0LEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALPHA0LEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_ALPHA0LEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_ALPHA0_i_dX = (instanceStruct.instanceVar_ALPHA0_i*(modelStruct.modelPar_ALPHA0L*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALPHA0LEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_ALPHA0LEXP_dX))))))+modelStruct.d_modelPar_ALPHA0L_dX*value_max_2)+instanceStruct.d_instanceVar_ALPHA0_i_dX*(1.0+(modelStruct.modelPar_ALPHA0L*value_max_2)));
instanceStruct.instanceVar_ALPHA0_i = (instanceStruct.instanceVar_ALPHA0_i*(1.0+(modelStruct.modelPar_ALPHA0L*value_max_2)));
}
instanceStruct.d_instanceVar_AGIDL_i_dX = (instanceStruct.instanceVar_AGIDL_i*((modelStruct.modelPar_AGIDLL*d_Inv_L_dX+modelStruct.d_modelPar_AGIDLL_dX*Inv_L)+(modelStruct.modelPar_AGIDLW*d_Inv_W_dX+modelStruct.d_modelPar_AGIDLW_dX*Inv_W))+instanceStruct.d_instanceVar_AGIDL_i_dX*((1.0+(modelStruct.modelPar_AGIDLL*Inv_L))+(modelStruct.modelPar_AGIDLW*Inv_W)));
instanceStruct.instanceVar_AGIDL_i = (instanceStruct.instanceVar_AGIDL_i*((1.0+(modelStruct.modelPar_AGIDLL*Inv_L))+(modelStruct.modelPar_AGIDLW*Inv_W)));
instanceStruct.d_instanceVar_AGISL_i_dX = (instanceStruct.instanceVar_AGISL_i*((modelStruct.modelPar_AGISLL*d_Inv_L_dX+modelStruct.d_modelPar_AGISLL_dX*Inv_L)+(modelStruct.modelPar_AGISLW*d_Inv_W_dX+modelStruct.d_modelPar_AGISLW_dX*Inv_W))+instanceStruct.d_instanceVar_AGISL_i_dX*((1.0+(modelStruct.modelPar_AGISLL*Inv_L))+(modelStruct.modelPar_AGISLW*Inv_W)));
instanceStruct.instanceVar_AGISL_i = (instanceStruct.instanceVar_AGISL_i*((1.0+(modelStruct.modelPar_AGISLL*Inv_L))+(modelStruct.modelPar_AGISLW*Inv_W)));
instanceStruct.d_instanceVar_AIGC_i_dX = (instanceStruct.instanceVar_AIGC_i*((modelStruct.modelPar_AIGCL*d_Inv_L_dX+modelStruct.d_modelPar_AIGCL_dX*Inv_L)+(modelStruct.modelPar_AIGCW*d_Inv_W_dX+modelStruct.d_modelPar_AIGCW_dX*Inv_W))+instanceStruct.d_instanceVar_AIGC_i_dX*((1.0+(modelStruct.modelPar_AIGCL*Inv_L))+(modelStruct.modelPar_AIGCW*Inv_W)));
instanceStruct.instanceVar_AIGC_i = (instanceStruct.instanceVar_AIGC_i*((1.0+(modelStruct.modelPar_AIGCL*Inv_L))+(modelStruct.modelPar_AIGCW*Inv_W)));
instanceStruct.d_instanceVar_AIGS_i_dX = (instanceStruct.instanceVar_AIGS_i*((modelStruct.modelPar_AIGSL*d_Inv_L_dX+modelStruct.d_modelPar_AIGSL_dX*Inv_L)+(modelStruct.modelPar_AIGSW*d_Inv_W_dX+modelStruct.d_modelPar_AIGSW_dX*Inv_W))+instanceStruct.d_instanceVar_AIGS_i_dX*((1.0+(modelStruct.modelPar_AIGSL*Inv_L))+(modelStruct.modelPar_AIGSW*Inv_W)));
instanceStruct.instanceVar_AIGS_i = (instanceStruct.instanceVar_AIGS_i*((1.0+(modelStruct.modelPar_AIGSL*Inv_L))+(modelStruct.modelPar_AIGSW*Inv_W)));
instanceStruct.d_instanceVar_AIGD_i_dX = (instanceStruct.instanceVar_AIGD_i*((modelStruct.modelPar_AIGDL*d_Inv_L_dX+modelStruct.d_modelPar_AIGDL_dX*Inv_L)+(modelStruct.modelPar_AIGDW*d_Inv_W_dX+modelStruct.d_modelPar_AIGDW_dX*Inv_W))+instanceStruct.d_instanceVar_AIGD_i_dX*((1.0+(modelStruct.modelPar_AIGDL*Inv_L))+(modelStruct.modelPar_AIGDW*Inv_W)));
instanceStruct.instanceVar_AIGD_i = (instanceStruct.instanceVar_AIGD_i*((1.0+(modelStruct.modelPar_AIGDL*Inv_L))+(modelStruct.modelPar_AIGDW*Inv_W)));
instanceStruct.d_instanceVar_PIGCD_i_dX = (modelStruct.modelPar_PIGCD*(modelStruct.modelPar_PIGCDL*d_Inv_L_dX+modelStruct.d_modelPar_PIGCDL_dX*Inv_L)+modelStruct.d_modelPar_PIGCD_dX*(1.0+(modelStruct.modelPar_PIGCDL*Inv_L)));
instanceStruct.instanceVar_PIGCD_i = (modelStruct.modelPar_PIGCD*(1.0+(modelStruct.modelPar_PIGCDL*Inv_L)));
{
double value_pow_0 = pow(Inv_Lact,modelStruct.modelPar_NDEPCVLEXP1);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_NDEPCVLEXP1);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_Lact,modelStruct.modelPar_NDEPCVLEXP2);
double value_pow_4 = pow(Inv_Llong,modelStruct.modelPar_NDEPCVLEXP2);
double value_max_5 = std::max((value_pow_3-value_pow_4),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_Lact == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_NDEPCVLEXP1/Inv_Lact));
double  deriv_pow_0_d1 = (Inv_Lact == 0.0)?0.0:(log(Inv_Lact)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_NDEPCVLEXP1/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_Lact == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_NDEPCVLEXP2/Inv_Lact));
double  deriv_pow_3_d1 = (Inv_Lact == 0.0)?0.0:(log(Inv_Lact)*value_pow_3);
double  deriv_pow_4_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_4*modelStruct.modelPar_NDEPCVLEXP2/Inv_Llong));
double  deriv_pow_4_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_4);
double  deriv_max_5_d0 = (((value_pow_3-value_pow_4)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = ((modelStruct.modelPar_NDEPCVL1*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_Lact_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_NDEPCVLEXP1_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_NDEPCVLEXP1_dX))))))+modelStruct.d_modelPar_NDEPCVL1_dX*value_max_2)+(modelStruct.modelPar_NDEPCVL2*(deriv_max_5_d0*((((deriv_pow_3_d0*(d_Inv_Lact_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_NDEPCVLEXP2_dX)))-((deriv_pow_4_d0*(d_Inv_Llong_dX))+(deriv_pow_4_d1*(modelStruct.d_modelPar_NDEPCVLEXP2_dX))))))+modelStruct.d_modelPar_NDEPCVL2_dX*value_max_5));
instanceStruct.instanceVar_T0 = ((modelStruct.modelPar_NDEPCVL1*value_max_2)+(modelStruct.modelPar_NDEPCVL2*value_max_5));
}
{
double value_pow_0 = pow(Inv_Wact,modelStruct.modelPar_NDEPCVWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_NDEPCVWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow((Inv_Wact*Inv_Lact),modelStruct.modelPar_NDEPCVWLEXP);
double  deriv_pow_0_d0 = ((Inv_Wact == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_NDEPCVWEXP/Inv_Wact));
double  deriv_pow_0_d1 = (Inv_Wact == 0.0)?0.0:(log(Inv_Wact)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_NDEPCVWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = (((Inv_Wact*Inv_Lact) == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_NDEPCVWLEXP/(Inv_Wact*Inv_Lact)));
double  deriv_pow_3_d1 = ((Inv_Wact*Inv_Lact) == 0.0)?0.0:(log((Inv_Wact*Inv_Lact))*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_NDEPCVW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_Wact_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_NDEPCVWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_NDEPCVWEXP_dX))))))+modelStruct.d_modelPar_NDEPCVW_dX*value_max_2)+(modelStruct.modelPar_NDEPCVWL*((deriv_pow_3_d0*((Inv_Wact*d_Inv_Lact_dX+d_Inv_Wact_dX*Inv_Lact)))+(deriv_pow_3_d1*(modelStruct.d_modelPar_NDEPCVWLEXP_dX)))+modelStruct.d_modelPar_NDEPCVWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_NDEPCVW*value_max_2)+(modelStruct.modelPar_NDEPCVWL*value_pow_3));
}
instanceStruct.d_instanceVar_NDEPCV_i_dX = (instanceStruct.instanceVar_NDEPCV_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_NDEPCV_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_NDEPCV_i = (instanceStruct.instanceVar_NDEPCV_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_Lact,modelStruct.modelPar_VFBCVLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_VFBCVLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_Lact == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_VFBCVLEXP/Inv_Lact));
double  deriv_pow_0_d1 = (Inv_Lact == 0.0)?0.0:(log(Inv_Lact)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_VFBCVLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_VFBCVL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_Lact_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_VFBCVLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_VFBCVLEXP_dX))))))+modelStruct.d_modelPar_VFBCVL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_VFBCVL*value_max_2);
}
{
double value_pow_0 = pow(Inv_Wact,modelStruct.modelPar_VFBCVWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_VFBCVWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_VFBCVWLEXP);
double  deriv_pow_0_d0 = ((Inv_Wact == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_VFBCVWEXP/Inv_Wact));
double  deriv_pow_0_d1 = (Inv_Wact == 0.0)?0.0:(log(Inv_Wact)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_VFBCVWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_VFBCVWLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_VFBCVW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_Wact_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_VFBCVWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_VFBCVWEXP_dX))))))+modelStruct.d_modelPar_VFBCVW_dX*value_max_2)+(modelStruct.modelPar_VFBCVWL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_VFBCVWLEXP_dX)))+modelStruct.d_modelPar_VFBCVWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_VFBCVW*value_max_2)+(modelStruct.modelPar_VFBCVWL*value_pow_3));
}
instanceStruct.d_instanceVar_VFBCV_i_dX = (instanceStruct.instanceVar_VFBCV_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_VFBCV_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_VFBCV_i = (instanceStruct.instanceVar_VFBCV_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_Lact,modelStruct.modelPar_VSATCVLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_VSATCVLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_Lact == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_VSATCVLEXP/Inv_Lact));
double  deriv_pow_0_d1 = (Inv_Lact == 0.0)?0.0:(log(Inv_Lact)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_VSATCVLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_VSATCVL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_Lact_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_VSATCVLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_VSATCVLEXP_dX))))))+modelStruct.d_modelPar_VSATCVL_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_VSATCVL*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_VSATCVWEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_VSATCVWEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_VSATCVWLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_VSATCVWEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_VSATCVWEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_VSATCVWLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_VSATCVW*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_VSATCVWEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_VSATCVWEXP_dX))))))+modelStruct.d_modelPar_VSATCVW_dX*value_max_2)+(modelStruct.modelPar_VSATCVWL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_VSATCVWLEXP_dX)))+modelStruct.d_modelPar_VSATCVWL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_VSATCVW*value_max_2)+(modelStruct.modelPar_VSATCVWL*value_pow_3));
}
instanceStruct.d_instanceVar_VSATCV_i_dX = (instanceStruct.instanceVar_VSATCV_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_VSATCV_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_VSATCV_i = (instanceStruct.instanceVar_VSATCV_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_Lact,modelStruct.modelPar_PCLMCVLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_PCLMCVLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_Lact == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PCLMCVLEXP/Inv_Lact));
double  deriv_pow_0_d1 = (Inv_Lact == 0.0)?0.0:(log(Inv_Lact)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_PCLMCVLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_PCLMCV_i_dX = (instanceStruct.instanceVar_PCLMCV_i*(modelStruct.modelPar_PCLMCVL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_Lact_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PCLMCVLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_PCLMCVLEXP_dX))))))+modelStruct.d_modelPar_PCLMCVL_dX*value_max_2)+instanceStruct.d_instanceVar_PCLMCV_i_dX*(1.0+(modelStruct.modelPar_PCLMCVL*value_max_2)));
instanceStruct.instanceVar_PCLMCV_i = (instanceStruct.instanceVar_PCLMCV_i*(1.0+(modelStruct.modelPar_PCLMCVL*value_max_2)));
}
{
double value_max_0 = std::max(instanceStruct.instanceVar_PCLMCV_i,static_cast<double>(0));
double  deriv_max_0_d0 = ((instanceStruct.instanceVar_PCLMCV_i>=0)?1.0:0.0);
instanceStruct.d_instanceVar_PCLMCV_i_dX = (deriv_max_0_d0*(instanceStruct.d_instanceVar_PCLMCV_i_dX));
instanceStruct.instanceVar_PCLMCV_i = value_max_0;
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_K1LEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_K1LEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_K1LEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_K1LEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_K1L*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_K1LEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_K1LEXP_dX))))))+modelStruct.d_modelPar_K1L_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_K1L*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_K1WEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_K1WEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_K1WLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_K1WEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_K1WEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_K1WLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_K1W*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_K1WEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_K1WEXP_dX))))))+modelStruct.d_modelPar_K1W_dX*value_max_2)+(modelStruct.modelPar_K1WL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_K1WLEXP_dX)))+modelStruct.d_modelPar_K1WL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_K1W*value_max_2)+(modelStruct.modelPar_K1WL*value_pow_3));
}
instanceStruct.d_instanceVar_K1_i_dX = (instanceStruct.instanceVar_K1_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_K1_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_K1_i = (instanceStruct.instanceVar_K1_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_K2LEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_K2LEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_K2LEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_K2LEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_K2L*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_K2LEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_K2LEXP_dX))))))+modelStruct.d_modelPar_K2L_dX*value_max_2);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_K2L*value_max_2);
}
{
double value_pow_0 = pow(Inv_W,modelStruct.modelPar_K2WEXP);
double value_pow_1 = pow(Inv_Wwide,modelStruct.modelPar_K2WEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double value_pow_3 = pow(Inv_WL,modelStruct.modelPar_K2WLEXP);
double  deriv_pow_0_d0 = ((Inv_W == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_K2WEXP/Inv_W));
double  deriv_pow_0_d1 = (Inv_W == 0.0)?0.0:(log(Inv_W)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Wwide == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_K2WEXP/Inv_Wwide));
double  deriv_pow_1_d1 = (Inv_Wwide == 0.0)?0.0:(log(Inv_Wwide)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
double  deriv_pow_3_d0 = ((Inv_WL == 0.0)?0.0:(value_pow_3*modelStruct.modelPar_K2WLEXP/Inv_WL));
double  deriv_pow_3_d1 = (Inv_WL == 0.0)?0.0:(log(Inv_WL)*value_pow_3);
instanceStruct.d_instanceVar_T1_dX = ((modelStruct.modelPar_K2W*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_W_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_K2WEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Wwide_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_K2WEXP_dX))))))+modelStruct.d_modelPar_K2W_dX*value_max_2)+(modelStruct.modelPar_K2WL*((deriv_pow_3_d0*(d_Inv_WL_dX))+(deriv_pow_3_d1*(modelStruct.d_modelPar_K2WLEXP_dX)))+modelStruct.d_modelPar_K2WL_dX*value_pow_3));
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_K2W*value_max_2)+(modelStruct.modelPar_K2WL*value_pow_3));
}
instanceStruct.d_instanceVar_K2_i_dX = (instanceStruct.instanceVar_K2_i*(instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX)+instanceStruct.d_instanceVar_K2_i_dX*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_K2_i = (instanceStruct.instanceVar_K2_i*((1.0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1));
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_PRWBLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_PRWBLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PRWBLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_PRWBLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_PRWB_i_dX = (instanceStruct.instanceVar_PRWB_i*(modelStruct.modelPar_PRWBL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PRWBLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_PRWBLEXP_dX))))))+modelStruct.d_modelPar_PRWBL_dX*value_max_2)+instanceStruct.d_instanceVar_PRWB_i_dX*(1.0+(modelStruct.modelPar_PRWBL*value_max_2)));
instanceStruct.instanceVar_PRWB_i = (instanceStruct.instanceVar_PRWB_i*(1.0+(modelStruct.modelPar_PRWBL*value_max_2)));
}
instanceStruct.d_instanceVar_UTE_i_dX = (instanceStruct.instanceVar_UTE_i*(Inv_L*modelStruct.d_modelPar_UTEL_dX+d_Inv_L_dX*modelStruct.modelPar_UTEL)+instanceStruct.d_instanceVar_UTE_i_dX*(1.0+(Inv_L*modelStruct.modelPar_UTEL)));
instanceStruct.instanceVar_UTE_i = (instanceStruct.instanceVar_UTE_i*(1.0+(Inv_L*modelStruct.modelPar_UTEL)));
instanceStruct.d_instanceVar_UA1_i_dX = (instanceStruct.instanceVar_UA1_i*(Inv_L*modelStruct.d_modelPar_UA1L_dX+d_Inv_L_dX*modelStruct.modelPar_UA1L)+instanceStruct.d_instanceVar_UA1_i_dX*(1.0+(Inv_L*modelStruct.modelPar_UA1L)));
instanceStruct.instanceVar_UA1_i = (instanceStruct.instanceVar_UA1_i*(1.0+(Inv_L*modelStruct.modelPar_UA1L)));
instanceStruct.d_instanceVar_UD1_i_dX = (instanceStruct.instanceVar_UD1_i*(Inv_L*modelStruct.d_modelPar_UD1L_dX+d_Inv_L_dX*modelStruct.modelPar_UD1L)+instanceStruct.d_instanceVar_UD1_i_dX*(1.0+(Inv_L*modelStruct.modelPar_UD1L)));
instanceStruct.instanceVar_UD1_i = (instanceStruct.instanceVar_UD1_i*(1.0+(Inv_L*modelStruct.modelPar_UD1L)));
instanceStruct.d_instanceVar_AT_i_dX = (instanceStruct.instanceVar_AT_i*(Inv_L*modelStruct.d_modelPar_ATL_dX+d_Inv_L_dX*modelStruct.modelPar_ATL)+instanceStruct.d_instanceVar_AT_i_dX*(1.0+(Inv_L*modelStruct.modelPar_ATL)));
instanceStruct.instanceVar_AT_i = (instanceStruct.instanceVar_AT_i*(1.0+(Inv_L*modelStruct.modelPar_ATL)));
instanceStruct.d_instanceVar_PTWGT_i_dX = (instanceStruct.instanceVar_PTWGT_i*(Inv_L*modelStruct.d_modelPar_PTWGTL_dX+d_Inv_L_dX*modelStruct.modelPar_PTWGTL)+instanceStruct.d_instanceVar_PTWGT_i_dX*(1.0+(Inv_L*modelStruct.modelPar_PTWGTL)));
instanceStruct.instanceVar_PTWGT_i = (instanceStruct.instanceVar_PTWGT_i*(1.0+(Inv_L*modelStruct.modelPar_PTWGTL)));
if ((portsConnected_[admsNodeID_t]==0))
{
}
if ((modelStruct.modelPar_RDSMOD==1))
{
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_RSWLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_RSWLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_RSWLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_RSWLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_RSW_i_dX = (instanceStruct.instanceVar_RSW_i*(modelStruct.modelPar_RSWL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_RSWLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_RSWLEXP_dX))))))+modelStruct.d_modelPar_RSWL_dX*value_max_2)+instanceStruct.d_instanceVar_RSW_i_dX*(1.0+(modelStruct.modelPar_RSWL*value_max_2)));
instanceStruct.instanceVar_RSW_i = (instanceStruct.instanceVar_RSW_i*(1.0+(modelStruct.modelPar_RSWL*value_max_2)));
}
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_RDWLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_RDWLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_RDWLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_RDWLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_RDW_i_dX = (instanceStruct.instanceVar_RDW_i*(modelStruct.modelPar_RDWL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_RDWLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_RDWLEXP_dX))))))+modelStruct.d_modelPar_RDWL_dX*value_max_2)+instanceStruct.d_instanceVar_RDW_i_dX*(1.0+(modelStruct.modelPar_RDWL*value_max_2)));
instanceStruct.instanceVar_RDW_i = (instanceStruct.instanceVar_RDW_i*(1.0+(modelStruct.modelPar_RDWL*value_max_2)));
}
}
else
{
{
double value_pow_0 = pow(Inv_L,modelStruct.modelPar_RDSWLEXP);
double value_pow_1 = pow(Inv_Llong,modelStruct.modelPar_RDSWLEXP);
double value_max_2 = std::max((value_pow_0-value_pow_1),static_cast<double>(0));
double  deriv_pow_0_d0 = ((Inv_L == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_RDSWLEXP/Inv_L));
double  deriv_pow_0_d1 = (Inv_L == 0.0)?0.0:(log(Inv_L)*value_pow_0);
double  deriv_pow_1_d0 = ((Inv_Llong == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_RDSWLEXP/Inv_Llong));
double  deriv_pow_1_d1 = (Inv_Llong == 0.0)?0.0:(log(Inv_Llong)*value_pow_1);
double  deriv_max_2_d0 = (((value_pow_0-value_pow_1)>=0)?1.0:0.0);
instanceStruct.d_instanceVar_RDSW_i_dX = (instanceStruct.instanceVar_RDSW_i*(modelStruct.modelPar_RDSWL*(deriv_max_2_d0*((((deriv_pow_0_d0*(d_Inv_L_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_RDSWLEXP_dX)))-((deriv_pow_1_d0*(d_Inv_Llong_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_RDSWLEXP_dX))))))+modelStruct.d_modelPar_RDSWL_dX*value_max_2)+instanceStruct.d_instanceVar_RDSW_i_dX*(1.0+(modelStruct.modelPar_RDSWL*value_max_2)));
instanceStruct.instanceVar_RDSW_i = (instanceStruct.instanceVar_RDSW_i*(1.0+(modelStruct.modelPar_RDSWL*value_max_2)));
}
}
if ((instanceStruct.instanceVar_UCS_i<1.0))
{
instanceStruct.d_instanceVar_UCS_i_dX = 0.0;
instanceStruct.instanceVar_UCS_i = 1.0;
}
else
{
if ((instanceStruct.instanceVar_UCS_i>2.0))
{
instanceStruct.d_instanceVar_UCS_i_dX = 0.0;
instanceStruct.instanceVar_UCS_i = 2.0;
}
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
if ((instanceStruct.instanceVar_UCSR_i<1.0))
{
instanceStruct.d_instanceVar_UCSR_i_dX = 0.0;
instanceStruct.instanceVar_UCSR_i = 1.0;
}
else
{
if ((instanceStruct.instanceVar_UCSR_i>2.0))
{
instanceStruct.d_instanceVar_UCSR_i_dX = 0.0;
instanceStruct.instanceVar_UCSR_i = 2.0;
}
}
if ((instanceStruct.instanceVar_UCR_i<0))
{
UserInfo(theInstance)  << "Fatal: UCR_i = %e is negative." << " " << instanceStruct.instanceVar_UCR_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
}
if ((instanceStruct.instanceVar_CGIDL_i<0))
{
UserInfo(theInstance)  << "Fatal: CGIDL_i = %e is negative." << " " << instanceStruct.instanceVar_CGIDL_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_CGISL_i<0))
{
UserInfo(theInstance)  << "Fatal: CGISL_i = %e is negative." << " " << instanceStruct.instanceVar_CGISL_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_CKAPPAD_i<=0))
{
UserInfo(theInstance)  << "Fatal: CKAPPAD_i = %e is non-positive." << " " << instanceStruct.instanceVar_CKAPPAD_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_CKAPPAS_i<=0))
{
UserInfo(theInstance)  << "Fatal: CKAPPAS_i = %e is non-positive." << " " << instanceStruct.instanceVar_CKAPPAS_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_PDITS_i<0))
{
UserInfo(theInstance)  << "Fatal: PDITS_i = %e is negative." << " " << instanceStruct.instanceVar_PDITS_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_CIT_i<0))
{
UserInfo(theInstance)  << "Fatal: CIT_i = %e is negative." << " " << instanceStruct.instanceVar_CIT_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_NFACTOR_i<0))
{
UserInfo(theInstance)  << "Fatal: NFACTOR_i = %e is negative." << " " << instanceStruct.instanceVar_NFACTOR_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_K1_i<0))
{
UserInfo(theInstance)  << "Fatal: K1_i = %e is positive." << " " << instanceStruct.instanceVar_K1_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_NSD_i<=0))
{
UserInfo(theInstance)  << "Fatal: NSD_i = %e is non-positive." << " " << instanceStruct.instanceVar_NSD_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_NDEP_i<=0))
{
UserInfo(theInstance)  << "Fatal: NDEP_i = %e is non-positive." << " " << instanceStruct.instanceVar_NDEP_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_NDEPCV_i<=0))
{
UserInfo(theInstance)  << "Fatal: NDEPCV_i = %e is non-positive." << " " << instanceStruct.instanceVar_NDEPCV_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((modelStruct.modelPar_IGBMOD!=0))
{
if ((instanceStruct.instanceVar_NIGBINV_i<=0))
{
UserInfo(theInstance)  << "Fatal: NIGBINV_i = %e is non-positive." << " " << instanceStruct.instanceVar_NIGBINV_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((instanceStruct.instanceVar_NIGBACC_i<=0))
{
UserInfo(theInstance)  << "Fatal: NIGBACC_i = %e is non-positive." << " " << instanceStruct.instanceVar_NIGBACC_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
}
if ((modelStruct.modelPar_IGCMOD!=0))
{
if ((POXEDGE_i<=0))
{
UserInfo(theInstance)  << "Fatal: POXEDGE_i = %e is non-positive." << " " << POXEDGE_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
}
if ((instanceStruct.instanceVar_CDSCD_i<0))
{
UserInfo(theInstance)  << "Fatal: CDSCD_i = %e is negative." << " " << instanceStruct.instanceVar_CDSCD_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
if ((instanceStruct.instanceVar_CDSCDR_i<0))
{
UserInfo(theInstance)  << "Fatal: CDSCDR_i = %e is negative." << " " << instanceStruct.instanceVar_CDSCDR_i << " " <<  std::endl; 
 UserError(theInstance) << "$finish called." << std::endl; 
}
}
instanceStruct.instanceVar_nuEndD = 0;
instanceStruct.instanceVar_nuEndS = 0;
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = 0;
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = 0;
d_Rend_dX = 0.0;
Rend = 0;
d_Rint_dX = 0.0;
Rint = 0;
instanceStruct.d_instanceVar_DMCGeff_dX = (modelStruct.d_modelPar_DMCG_dX-modelStruct.d_modelPar_DMCGT_dX);
instanceStruct.instanceVar_DMCGeff = (modelStruct.modelPar_DMCG-modelStruct.modelPar_DMCGT);
instanceStruct.d_instanceVar_DMCIeff_dX = modelStruct.d_modelPar_DMCI_dX;
instanceStruct.instanceVar_DMCIeff = modelStruct.modelPar_DMCI;
instanceStruct.d_instanceVar_DMDGeff_dX = (modelStruct.d_modelPar_DMDG_dX-modelStruct.d_modelPar_DMCGT_dX);
instanceStruct.instanceVar_DMDGeff = (modelStruct.modelPar_DMDG-modelStruct.modelPar_DMCGT);
if ((modelStruct.modelPar_RSH>0))
{
if (((!instanceStruct.instancePar_given_NRD)&&(instanceStruct.instancePar_RGEOMOD!=0)))
{
if ((instanceStruct.instancePar_GEOMOD<9))
{
if (((instanceStruct.instancePar_NF%2)!=0))
{
instanceStruct.instanceVar_nuEndD = 1.0;
instanceStruct.instanceVar_nuEndS = 1.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF-1.0)/2.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.d_instanceVar_nuIntS_dX = instanceStruct.d_instanceVar_nuIntD_dX;
instanceStruct.instanceVar_nuIntS = instanceStruct.instanceVar_nuIntD;
}
else
{
if ((instanceStruct.instancePar_MINZ==1))
{
instanceStruct.instanceVar_nuEndD = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.instanceVar_nuEndS = 0.0;
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = instanceStruct.instancePar_NF;
}
else
{
instanceStruct.instanceVar_nuEndD = 0.0;
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = instanceStruct.instancePar_NF;
instanceStruct.instanceVar_nuEndS = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = (2.0*value_max_0);
}
}
}
if ((0==1))
{
if ((instanceStruct.instanceVar_nuIntS==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntS_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntS))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
}
}
else
{
if ((instanceStruct.instanceVar_nuIntD==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntD_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntD))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
}
}
}
if ( instanceStruct.instancePar_GEOMOD == (0))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (1))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (2))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (3))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (4))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (5))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((instanceStruct.instanceVar_nuEndD==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (6))
{
if ((0==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (7))
{
if ((0==1))
{
if ((instanceStruct.instanceVar_nuEndS==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (8))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
if ( instanceStruct.instancePar_GEOMOD == (9))
{
if ((0==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (10))
{
if ((0==1))
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
}
else
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
if ((Rint<=0.0))
{
d_Rtot_dX = d_Rend_dX;
Rtot = Rend;
}
else
{
if ((Rend<=0.0))
{
d_Rtot_dX = d_Rint_dX;
Rtot = Rint;
}
else
{
d_Rtot_dX = (((Rint+Rend)*(Rint*d_Rend_dX+d_Rint_dX*Rend)-(Rint*Rend)*(d_Rint_dX+d_Rend_dX))/(Rint+Rend)/(Rint+Rend));
Rtot = ((Rint*Rend)/(Rint+Rend));
}
}
if ((Rtot==0.0))
{
}
}
}
if ((modelStruct.modelPar_RSH>0))
{
if (((!instanceStruct.instancePar_given_NRS)&&(instanceStruct.instancePar_RGEOMOD!=0)))
{
if ((instanceStruct.instancePar_GEOMOD<9))
{
if (((instanceStruct.instancePar_NF%2)!=0))
{
instanceStruct.instanceVar_nuEndD = 1.0;
instanceStruct.instanceVar_nuEndS = 1.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF-1.0)/2.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.d_instanceVar_nuIntS_dX = instanceStruct.d_instanceVar_nuIntD_dX;
instanceStruct.instanceVar_nuIntS = instanceStruct.instanceVar_nuIntD;
}
else
{
if ((instanceStruct.instancePar_MINZ==1))
{
instanceStruct.instanceVar_nuEndD = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.instanceVar_nuEndS = 0.0;
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = instanceStruct.instancePar_NF;
}
else
{
instanceStruct.instanceVar_nuEndD = 0.0;
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = instanceStruct.instancePar_NF;
instanceStruct.instanceVar_nuEndS = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = (2.0*value_max_0);
}
}
}
if ((1==1))
{
if ((instanceStruct.instanceVar_nuIntS==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntS_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntS))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
}
}
else
{
if ((instanceStruct.instanceVar_nuIntD==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntD_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntD))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
}
}
}
if ( instanceStruct.instancePar_GEOMOD == (0))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (1))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (2))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (3))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (4))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (5))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((instanceStruct.instanceVar_nuEndD==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (6))
{
if ((1==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (7))
{
if ((1==1))
{
if ((instanceStruct.instanceVar_nuEndS==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (8))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
if ( instanceStruct.instancePar_GEOMOD == (9))
{
if ((1==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (10))
{
if ((1==1))
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
}
else
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
if ((Rint<=0.0))
{
d_Rtot_dX = d_Rend_dX;
Rtot = Rend;
}
else
{
if ((Rend<=0.0))
{
d_Rtot_dX = d_Rint_dX;
Rtot = Rint;
}
else
{
d_Rtot_dX = (((Rint+Rend)*(Rint*d_Rend_dX+d_Rint_dX*Rend)-(Rint*Rend)*(d_Rint_dX+d_Rend_dX))/(Rint+Rend)/(Rint+Rend));
Rtot = ((Rint*Rend)/(Rint+Rend));
}
}
if ((Rtot==0.0))
{
}
}
}
if (instanceStruct.instancePar_given_NRS)
{
instanceStruct.d_instanceVar_RSourceGeo_dX = (modelStruct.modelPar_RSH*instanceStruct.d_instancePar_NRS_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instancePar_NRS);
instanceStruct.instanceVar_RSourceGeo = (modelStruct.modelPar_RSH*instanceStruct.instancePar_NRS);
}
else
{
if ((instanceStruct.instancePar_RGEOMOD>0))
{
{
if ((instanceStruct.instancePar_GEOMOD<9))
{
if (((instanceStruct.instancePar_NF%2)!=0))
{
instanceStruct.instanceVar_nuEndD = 1.0;
instanceStruct.instanceVar_nuEndS = 1.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF-1.0)/2.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.d_instanceVar_nuIntS_dX = instanceStruct.d_instanceVar_nuIntD_dX;
instanceStruct.instanceVar_nuIntS = instanceStruct.instanceVar_nuIntD;
}
else
{
if ((instanceStruct.instancePar_MINZ==1))
{
instanceStruct.instanceVar_nuEndD = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.instanceVar_nuEndS = 0.0;
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = instanceStruct.instancePar_NF;
}
else
{
instanceStruct.instanceVar_nuEndD = 0.0;
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = instanceStruct.instancePar_NF;
instanceStruct.instanceVar_nuEndS = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = (2.0*value_max_0);
}
}
}
if ((1==1))
{
if ((instanceStruct.instanceVar_nuIntS==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntS_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntS))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
}
}
else
{
if ((instanceStruct.instanceVar_nuIntD==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntD_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntD))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
}
}
}
if ( instanceStruct.instancePar_GEOMOD == (0))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (1))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (2))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (3))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (4))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (5))
{
if ((1==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((instanceStruct.instanceVar_nuEndD==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (6))
{
if ((1==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (7))
{
if ((1==1))
{
if ((instanceStruct.instanceVar_nuEndS==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (8))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
if ( instanceStruct.instancePar_GEOMOD == (9))
{
if ((1==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (10))
{
if ((1==1))
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
}
else
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
if ((Rint<=0.0))
{
instanceStruct.d_instanceVar_RSourceGeo_dX = d_Rend_dX;
instanceStruct.instanceVar_RSourceGeo = Rend;
}
else
{
if ((Rend<=0.0))
{
instanceStruct.d_instanceVar_RSourceGeo_dX = d_Rint_dX;
instanceStruct.instanceVar_RSourceGeo = Rint;
}
else
{
instanceStruct.d_instanceVar_RSourceGeo_dX = (((Rint+Rend)*(Rint*d_Rend_dX+d_Rint_dX*Rend)-(Rint*Rend)*(d_Rint_dX+d_Rend_dX))/(Rint+Rend)/(Rint+Rend));
instanceStruct.instanceVar_RSourceGeo = ((Rint*Rend)/(Rint+Rend));
}
}
if ((instanceStruct.instanceVar_RSourceGeo==0.0))
{
}
}
}
else
{
instanceStruct.d_instanceVar_RSourceGeo_dX = 0.0;
instanceStruct.instanceVar_RSourceGeo = 0.0;
}
}
if (instanceStruct.instancePar_given_NRD)
{
instanceStruct.d_instanceVar_RDrainGeo_dX = (modelStruct.modelPar_RSH*instanceStruct.d_instancePar_NRD_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instancePar_NRD);
instanceStruct.instanceVar_RDrainGeo = (modelStruct.modelPar_RSH*instanceStruct.instancePar_NRD);
}
else
{
if ((instanceStruct.instancePar_RGEOMOD>0))
{
{
if ((instanceStruct.instancePar_GEOMOD<9))
{
if (((instanceStruct.instancePar_NF%2)!=0))
{
instanceStruct.instanceVar_nuEndD = 1.0;
instanceStruct.instanceVar_nuEndS = 1.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF-1.0)/2.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.d_instanceVar_nuIntS_dX = instanceStruct.d_instanceVar_nuIntD_dX;
instanceStruct.instanceVar_nuIntS = instanceStruct.instanceVar_nuIntD;
}
else
{
if ((instanceStruct.instancePar_MINZ==1))
{
instanceStruct.instanceVar_nuEndD = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.instanceVar_nuEndS = 0.0;
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = instanceStruct.instancePar_NF;
}
else
{
instanceStruct.instanceVar_nuEndD = 0.0;
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = instanceStruct.instancePar_NF;
instanceStruct.instanceVar_nuEndS = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = (2.0*value_max_0);
}
}
}
if ((0==1))
{
if ((instanceStruct.instanceVar_nuIntS==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntS_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntS))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntS));
}
}
else
{
if ((instanceStruct.instanceVar_nuIntD==0.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_nuIntD_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuIntD))/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuIntD));
}
}
}
if ( instanceStruct.instancePar_GEOMOD == (0))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (1))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (2))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (3))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (4))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndS)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (5))
{
if ((0==1))
{
if ((1==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndS==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndS)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
else
{
if ((instanceStruct.instanceVar_nuEndD==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (6))
{
if ((0==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if (((instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff))/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((3.0*instanceStruct.instanceVar_nuEndD)*(instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (7))
{
if ((0==1))
{
if ((instanceStruct.instanceVar_nuEndS==0))
{
d_Rend_dX = 0.0;
Rend = 0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndS));
}
}
else
{
if ((0==1))
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (5))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (6))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
else
{
if ( instanceStruct.instancePar_RGEOMOD == (1)||instanceStruct.instancePar_RGEOMOD == (3)||instanceStruct.instancePar_RGEOMOD == (7))
{
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_nuEndD));
}
}
else
if ( instanceStruct.instancePar_RGEOMOD == (2)||instanceStruct.instancePar_RGEOMOD == (4)||instanceStruct.instancePar_RGEOMOD == (8))
{
if ((instanceStruct.instanceVar_DMCGeff==0.0))
{
}
if ((instanceStruct.instanceVar_nuEndD==0.0))
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
else
{
d_Rend_dX = ((((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_Weff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_Weff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)*(6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.d_instanceVar_DMCGeff_dX)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_Weff)/((6.0*instanceStruct.instanceVar_nuEndD)*instanceStruct.instanceVar_DMCGeff));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
}
}
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (8))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMDGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMDGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMDGeff)/instanceStruct.instanceVar_Weff);
}
else
if ( instanceStruct.instancePar_GEOMOD == (9))
{
if ((0==1))
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
else
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
}
else
if ( instanceStruct.instancePar_GEOMOD == (10))
{
if ((0==1))
{
d_Rend_dX = 0.0;
Rend = 0.0;
d_Rint_dX = (((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF));
}
else
{
d_Rend_dX = ((instanceStruct.instanceVar_Weff*((0.5*modelStruct.modelPar_RSH)*instanceStruct.d_instanceVar_DMCGeff_dX+0.5*modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX)/instanceStruct.instanceVar_Weff/instanceStruct.instanceVar_Weff);
Rend = (((0.5*modelStruct.modelPar_RSH)*instanceStruct.instanceVar_DMCGeff)/instanceStruct.instanceVar_Weff);
if ((instanceStruct.instancePar_NF==2.0))
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
else
{
d_Rint_dX = (((instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))*(modelStruct.modelPar_RSH*instanceStruct.d_instanceVar_DMCGeff_dX+modelStruct.d_modelPar_RSH_dX*instanceStruct.instanceVar_DMCGeff)-(modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)*instanceStruct.d_instanceVar_Weff_dX*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0))/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
Rint = ((modelStruct.modelPar_RSH*instanceStruct.instanceVar_DMCGeff)/(instanceStruct.instanceVar_Weff*(instanceStruct.instancePar_NF-2.0)));
}
}
}
else
{
d_Rint_dX = 0.0;
Rint = 0.0;
}
if ((Rint<=0.0))
{
instanceStruct.d_instanceVar_RDrainGeo_dX = d_Rend_dX;
instanceStruct.instanceVar_RDrainGeo = Rend;
}
else
{
if ((Rend<=0.0))
{
instanceStruct.d_instanceVar_RDrainGeo_dX = d_Rint_dX;
instanceStruct.instanceVar_RDrainGeo = Rint;
}
else
{
instanceStruct.d_instanceVar_RDrainGeo_dX = (((Rint+Rend)*(Rint*d_Rend_dX+d_Rint_dX*Rend)-(Rint*Rend)*(d_Rint_dX+d_Rend_dX))/(Rint+Rend)/(Rint+Rend));
instanceStruct.instanceVar_RDrainGeo = ((Rint*Rend)/(Rint+Rend));
}
}
if ((instanceStruct.instanceVar_RDrainGeo==0.0))
{
}
}
}
else
{
instanceStruct.d_instanceVar_RDrainGeo_dX = 0.0;
instanceStruct.instanceVar_RDrainGeo = 0.0;
}
}
if ((instanceStruct.instanceVar_RSourceGeo<=1.0e-3))
{
instanceStruct.d_instanceVar_RSourceGeo_dX = 0.0;
instanceStruct.instanceVar_RSourceGeo = 1.0e-3;
}
if ((instanceStruct.instanceVar_RDrainGeo<=1.0e-3))
{
instanceStruct.d_instanceVar_RDrainGeo_dX = 0.0;
instanceStruct.instanceVar_RDrainGeo = 1.0e-3;
}
if ((modelStruct.modelPar_RDSMOD==1))
{
if ((instanceStruct.instanceVar_RSWMIN_i<=0))
{
instanceStruct.d_instanceVar_RSWMIN_i_dX = 0.0;
instanceStruct.instanceVar_RSWMIN_i = 0;
}
if ((instanceStruct.instanceVar_RDWMIN_i<=0))
{
instanceStruct.d_instanceVar_RDWMIN_i_dX = 0.0;
instanceStruct.instanceVar_RDWMIN_i = 0;
}
if ((instanceStruct.instanceVar_RSW_i<=0))
{
instanceStruct.d_instanceVar_RSW_i_dX = 0.0;
instanceStruct.instanceVar_RSW_i = 0;
}
if ((instanceStruct.instanceVar_RDW_i<=0))
{
instanceStruct.d_instanceVar_RDW_i_dX = 0.0;
instanceStruct.instanceVar_RDW_i = 0;
}
}
else
{
if ((instanceStruct.instanceVar_RDSWMIN_i<=0))
{
instanceStruct.d_instanceVar_RDSWMIN_i_dX = 0.0;
instanceStruct.instanceVar_RDSWMIN_i = 0;
}
if ((instanceStruct.instanceVar_RDSW_i<=0))
{
instanceStruct.d_instanceVar_RDSW_i_dX = 0.0;
instanceStruct.instanceVar_RDSW_i = 0;
}
}
instanceStruct.d_instanceVar_Grbsb_dX = 0.0;
instanceStruct.instanceVar_Grbsb = 0.0;
instanceStruct.d_instanceVar_Grbdb_dX = 0.0;
instanceStruct.instanceVar_Grbdb = 0.0;
instanceStruct.d_instanceVar_Grbpb_dX = 0.0;
instanceStruct.instanceVar_Grbpb = 0.0;
instanceStruct.d_instanceVar_Grbps_dX = 0.0;
instanceStruct.instanceVar_Grbps = 0.0;
instanceStruct.d_instanceVar_Grbpd_dX = 0.0;
instanceStruct.instanceVar_Grbpd = 0.0;
if ((instanceStruct.instancePar_RBODYMOD!=0))
{
{
double value_log_0 = log((instanceStruct.instanceVar_Leff*1.0e6));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_Leff*1.0e6));
d_Lnl_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_Leff_dX*1.0e6);
Lnl = value_log_0;
}
{
double value_log_0 = log((instanceStruct.instanceVar_Weff*1.0e6));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_Weff*1.0e6));
d_Lnw_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_Weff_dX*1.0e6);
Lnw = value_log_0;
}
{
double value_log_0 = log(static_cast<double>(instanceStruct.instancePar_NF));
d_Lnnf_dX = 0.0;
Lnnf = value_log_0;
}
Bodymode = 5;
d_Rbpb_dX = instanceStruct.d_instancePar_RBPB_dX;
Rbpb = instanceStruct.instancePar_RBPB;
d_Rbpd_dX = instanceStruct.d_instancePar_RBPD_dX;
Rbpd = instanceStruct.instancePar_RBPD;
d_Rbps_dX = instanceStruct.d_instancePar_RBPS_dX;
Rbps = instanceStruct.instancePar_RBPS;
d_Rbdb_dX = instanceStruct.d_instancePar_RBDB_dX;
Rbdb = instanceStruct.instancePar_RBDB;
d_Rbsb_dX = instanceStruct.d_instancePar_RBSB_dX;
Rbsb = instanceStruct.instancePar_RBSB;
if (((!modelStruct.modelPar_given_RBPS0)||(!modelStruct.modelPar_given_RBPD0)))
{
Bodymode = 1;
}
else
{
if ((((!modelStruct.modelPar_given_RBSBX0)&&(!modelStruct.modelPar_given_RBSBY0))||((!modelStruct.modelPar_given_RBDBX0)&&(!modelStruct.modelPar_given_RBDBY0))))
{
Bodymode = 3;
}
}
if ((instanceStruct.instancePar_RBODYMOD==2))
{
if ((Bodymode==5))
{
{
double value_exp_0 = exp((((modelStruct.modelPar_RBSDBXL*Lnl)+(modelStruct.modelPar_RBSDBXW*Lnw))+(modelStruct.modelPar_RBSDBXNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbsbx_dX = (modelStruct.modelPar_RBSBX0*deriv_exp_0_d0*((((modelStruct.modelPar_RBSDBXL*d_Lnl_dX+modelStruct.d_modelPar_RBSDBXL_dX*Lnl)+(modelStruct.modelPar_RBSDBXW*d_Lnw_dX+modelStruct.d_modelPar_RBSDBXW_dX*Lnw))+(modelStruct.modelPar_RBSDBXNF*d_Lnnf_dX+modelStruct.d_modelPar_RBSDBXNF_dX*Lnnf)))+modelStruct.d_modelPar_RBSBX0_dX*value_exp_0);
Rbsbx = (modelStruct.modelPar_RBSBX0*value_exp_0);
}
{
double value_exp_0 = exp((((modelStruct.modelPar_RBSDBYL*Lnl)+(modelStruct.modelPar_RBSDBYW*Lnw))+(modelStruct.modelPar_RBSDBYNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbsby_dX = (modelStruct.modelPar_RBSBY0*deriv_exp_0_d0*((((modelStruct.modelPar_RBSDBYL*d_Lnl_dX+modelStruct.d_modelPar_RBSDBYL_dX*Lnl)+(modelStruct.modelPar_RBSDBYW*d_Lnw_dX+modelStruct.d_modelPar_RBSDBYW_dX*Lnw))+(modelStruct.modelPar_RBSDBYNF*d_Lnnf_dX+modelStruct.d_modelPar_RBSDBYNF_dX*Lnnf)))+modelStruct.d_modelPar_RBSBY0_dX*value_exp_0);
Rbsby = (modelStruct.modelPar_RBSBY0*value_exp_0);
}
d_Rbsb_dX = (((Rbsbx+Rbsby)*(Rbsbx*d_Rbsby_dX+d_Rbsbx_dX*Rbsby)-(Rbsbx*Rbsby)*(d_Rbsbx_dX+d_Rbsby_dX))/(Rbsbx+Rbsby)/(Rbsbx+Rbsby));
Rbsb = ((Rbsbx*Rbsby)/(Rbsbx+Rbsby));
{
double value_exp_0 = exp((((modelStruct.modelPar_RBSDBXL*Lnl)+(modelStruct.modelPar_RBSDBXW*Lnw))+(modelStruct.modelPar_RBSDBXNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbdbx_dX = (modelStruct.modelPar_RBDBX0*deriv_exp_0_d0*((((modelStruct.modelPar_RBSDBXL*d_Lnl_dX+modelStruct.d_modelPar_RBSDBXL_dX*Lnl)+(modelStruct.modelPar_RBSDBXW*d_Lnw_dX+modelStruct.d_modelPar_RBSDBXW_dX*Lnw))+(modelStruct.modelPar_RBSDBXNF*d_Lnnf_dX+modelStruct.d_modelPar_RBSDBXNF_dX*Lnnf)))+modelStruct.d_modelPar_RBDBX0_dX*value_exp_0);
Rbdbx = (modelStruct.modelPar_RBDBX0*value_exp_0);
}
{
double value_exp_0 = exp((((modelStruct.modelPar_RBSDBYL*Lnl)+(modelStruct.modelPar_RBSDBYW*Lnw))+(modelStruct.modelPar_RBSDBYNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbdby_dX = (modelStruct.modelPar_RBDBY0*deriv_exp_0_d0*((((modelStruct.modelPar_RBSDBYL*d_Lnl_dX+modelStruct.d_modelPar_RBSDBYL_dX*Lnl)+(modelStruct.modelPar_RBSDBYW*d_Lnw_dX+modelStruct.d_modelPar_RBSDBYW_dX*Lnw))+(modelStruct.modelPar_RBSDBYNF*d_Lnnf_dX+modelStruct.d_modelPar_RBSDBYNF_dX*Lnnf)))+modelStruct.d_modelPar_RBDBY0_dX*value_exp_0);
Rbdby = (modelStruct.modelPar_RBDBY0*value_exp_0);
}
d_Rbdb_dX = (((Rbdbx+Rbdby)*(Rbdbx*d_Rbdby_dX+d_Rbdbx_dX*Rbdby)-(Rbdbx*Rbdby)*(d_Rbdbx_dX+d_Rbdby_dX))/(Rbdbx+Rbdby)/(Rbdbx+Rbdby));
Rbdb = ((Rbdbx*Rbdby)/(Rbdbx+Rbdby));
}
if (((Bodymode==3)||(Bodymode==5)))
{
{
double value_exp_0 = exp((((modelStruct.modelPar_RBPSL*Lnl)+(modelStruct.modelPar_RBPSW*Lnw))+(modelStruct.modelPar_RBPSNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbps_dX = (modelStruct.modelPar_RBPS0*deriv_exp_0_d0*((((modelStruct.modelPar_RBPSL*d_Lnl_dX+modelStruct.d_modelPar_RBPSL_dX*Lnl)+(modelStruct.modelPar_RBPSW*d_Lnw_dX+modelStruct.d_modelPar_RBPSW_dX*Lnw))+(modelStruct.modelPar_RBPSNF*d_Lnnf_dX+modelStruct.d_modelPar_RBPSNF_dX*Lnnf)))+modelStruct.d_modelPar_RBPS0_dX*value_exp_0);
Rbps = (modelStruct.modelPar_RBPS0*value_exp_0);
}
{
double value_exp_0 = exp((((modelStruct.modelPar_RBPDL*Lnl)+(modelStruct.modelPar_RBPDW*Lnw))+(modelStruct.modelPar_RBPDNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbpd_dX = (modelStruct.modelPar_RBPD0*deriv_exp_0_d0*((((modelStruct.modelPar_RBPDL*d_Lnl_dX+modelStruct.d_modelPar_RBPDL_dX*Lnl)+(modelStruct.modelPar_RBPDW*d_Lnw_dX+modelStruct.d_modelPar_RBPDW_dX*Lnw))+(modelStruct.modelPar_RBPDNF*d_Lnnf_dX+modelStruct.d_modelPar_RBPDNF_dX*Lnnf)))+modelStruct.d_modelPar_RBPD0_dX*value_exp_0);
Rbpd = (modelStruct.modelPar_RBPD0*value_exp_0);
}
}
{
double value_exp_0 = exp((((modelStruct.modelPar_RBPBXL*Lnl)+(modelStruct.modelPar_RBPBXW*Lnw))+(modelStruct.modelPar_RBPBXNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbpbx_dX = (modelStruct.modelPar_RBPBX0*deriv_exp_0_d0*((((modelStruct.modelPar_RBPBXL*d_Lnl_dX+modelStruct.d_modelPar_RBPBXL_dX*Lnl)+(modelStruct.modelPar_RBPBXW*d_Lnw_dX+modelStruct.d_modelPar_RBPBXW_dX*Lnw))+(modelStruct.modelPar_RBPBXNF*d_Lnnf_dX+modelStruct.d_modelPar_RBPBXNF_dX*Lnnf)))+modelStruct.d_modelPar_RBPBX0_dX*value_exp_0);
Rbpbx = (modelStruct.modelPar_RBPBX0*value_exp_0);
}
{
double value_exp_0 = exp((((modelStruct.modelPar_RBPBYL*Lnl)+(modelStruct.modelPar_RBPBYW*Lnw))+(modelStruct.modelPar_RBPBYNF*Lnnf)));
double  deriv_exp_0_d0 = value_exp_0;
d_Rbpby_dX = (modelStruct.modelPar_RBPBY0*deriv_exp_0_d0*((((modelStruct.modelPar_RBPBYL*d_Lnl_dX+modelStruct.d_modelPar_RBPBYL_dX*Lnl)+(modelStruct.modelPar_RBPBYW*d_Lnw_dX+modelStruct.d_modelPar_RBPBYW_dX*Lnw))+(modelStruct.modelPar_RBPBYNF*d_Lnnf_dX+modelStruct.d_modelPar_RBPBYNF_dX*Lnnf)))+modelStruct.d_modelPar_RBPBY0_dX*value_exp_0);
Rbpby = (modelStruct.modelPar_RBPBY0*value_exp_0);
}
d_Rbpb_dX = (((Rbpbx+Rbpby)*(Rbpbx*d_Rbpby_dX+d_Rbpbx_dX*Rbpby)-(Rbpbx*Rbpby)*(d_Rbpbx_dX+d_Rbpby_dX))/(Rbpbx+Rbpby)/(Rbpbx+Rbpby));
Rbpb = ((Rbpbx*Rbpby)/(Rbpbx+Rbpby));
}
if (((instanceStruct.instancePar_RBODYMOD==1)||((instanceStruct.instancePar_RBODYMOD==2)&&(Bodymode==5))))
{
if ((Rbdb<1.0e-3))
{
instanceStruct.d_instanceVar_Grbdb_dX = 0.0;
instanceStruct.instanceVar_Grbdb = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbdb_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbdb_dX/Rbdb/Rbdb));
instanceStruct.instanceVar_Grbdb = (modelStruct.modelPar_GBMIN+(1.0/Rbdb));
}
if ((Rbpb<1.0e-3))
{
instanceStruct.d_instanceVar_Grbpb_dX = 0.0;
instanceStruct.instanceVar_Grbpb = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbpb_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbpb_dX/Rbpb/Rbpb));
instanceStruct.instanceVar_Grbpb = (modelStruct.modelPar_GBMIN+(1.0/Rbpb));
}
if ((Rbps<1.0e-3))
{
instanceStruct.d_instanceVar_Grbps_dX = 0.0;
instanceStruct.instanceVar_Grbps = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbps_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbps_dX/Rbps/Rbps));
instanceStruct.instanceVar_Grbps = (modelStruct.modelPar_GBMIN+(1.0/Rbps));
}
if ((Rbsb<1.0e-3))
{
instanceStruct.d_instanceVar_Grbsb_dX = 0.0;
instanceStruct.instanceVar_Grbsb = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbsb_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbsb_dX/Rbsb/Rbsb));
instanceStruct.instanceVar_Grbsb = (modelStruct.modelPar_GBMIN+(1.0/Rbsb));
}
if ((Rbpd<1.0e-3))
{
instanceStruct.d_instanceVar_Grbpd_dX = 0.0;
instanceStruct.instanceVar_Grbpd = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbpd_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbpd_dX/Rbpd/Rbpd));
instanceStruct.instanceVar_Grbpd = (modelStruct.modelPar_GBMIN+(1.0/Rbpd));
}
}
else
{
if (((instanceStruct.instancePar_RBODYMOD==2)&&(Bodymode==3)))
{
instanceStruct.d_instanceVar_Grbdb_dX = modelStruct.d_modelPar_GBMIN_dX;
instanceStruct.instanceVar_Grbdb = modelStruct.modelPar_GBMIN;
instanceStruct.d_instanceVar_Grbsb_dX = modelStruct.d_modelPar_GBMIN_dX;
instanceStruct.instanceVar_Grbsb = modelStruct.modelPar_GBMIN;
if ((Rbpb<1.0e-3))
{
instanceStruct.d_instanceVar_Grbpb_dX = 0.0;
instanceStruct.instanceVar_Grbpb = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbpb_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbpb_dX/Rbpb/Rbpb));
instanceStruct.instanceVar_Grbpb = (modelStruct.modelPar_GBMIN+(1.0/Rbpb));
}
if ((Rbps<1.0e-3))
{
instanceStruct.d_instanceVar_Grbps_dX = 0.0;
instanceStruct.instanceVar_Grbps = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbps_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbps_dX/Rbps/Rbps));
instanceStruct.instanceVar_Grbps = (modelStruct.modelPar_GBMIN+(1.0/Rbps));
}
if ((Rbpd<1.0e-3))
{
instanceStruct.d_instanceVar_Grbpd_dX = 0.0;
instanceStruct.instanceVar_Grbpd = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbpd_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbpd_dX/Rbpd/Rbpd));
instanceStruct.instanceVar_Grbpd = (modelStruct.modelPar_GBMIN+(1.0/Rbpd));
}
}
else
{
if (((instanceStruct.instancePar_RBODYMOD==2)&&(Bodymode==1)))
{
instanceStruct.d_instanceVar_Grbdb_dX = modelStruct.d_modelPar_GBMIN_dX;
instanceStruct.instanceVar_Grbdb = modelStruct.modelPar_GBMIN;
instanceStruct.d_instanceVar_Grbsb_dX = modelStruct.d_modelPar_GBMIN_dX;
instanceStruct.instanceVar_Grbsb = modelStruct.modelPar_GBMIN;
instanceStruct.d_instanceVar_Grbps_dX = 0.0;
instanceStruct.instanceVar_Grbps = 1.0e3;
instanceStruct.d_instanceVar_Grbpd_dX = 0.0;
instanceStruct.instanceVar_Grbpd = 1.0e3;
if ((Rbpb<1.0e-3))
{
instanceStruct.d_instanceVar_Grbpb_dX = 0.0;
instanceStruct.instanceVar_Grbpb = 1.0e3;
}
else
{
instanceStruct.d_instanceVar_Grbpb_dX = (modelStruct.d_modelPar_GBMIN_dX+(-d_Rbpb_dX/Rbpb/Rbpb));
instanceStruct.instanceVar_Grbpb = (modelStruct.modelPar_GBMIN+(1.0/Rbpb));
}
}
}
}
}
instanceStruct.d_instanceVar_Grgeltd_dX = ((((instanceStruct.instancePar_NGCON*instanceStruct.instancePar_NF)*(instanceStruct.instanceVar_Lnew-modelStruct.modelPar_XGL))*(modelStruct.modelPar_RSHG*(instanceStruct.d_instancePar_XGW_dX+((instanceStruct.d_instanceVar_Weffcj_dX/3.0)/instanceStruct.instancePar_NGCON))+modelStruct.d_modelPar_RSHG_dX*(instanceStruct.instancePar_XGW+((instanceStruct.instanceVar_Weffcj/3.0)/instanceStruct.instancePar_NGCON)))-(modelStruct.modelPar_RSHG*(instanceStruct.instancePar_XGW+((instanceStruct.instanceVar_Weffcj/3.0)/instanceStruct.instancePar_NGCON)))*(instanceStruct.instancePar_NGCON*instanceStruct.instancePar_NF)*(instanceStruct.d_instanceVar_Lnew_dX-modelStruct.d_modelPar_XGL_dX))/((instanceStruct.instancePar_NGCON*instanceStruct.instancePar_NF)*(instanceStruct.instanceVar_Lnew-modelStruct.modelPar_XGL))/((instanceStruct.instancePar_NGCON*instanceStruct.instancePar_NF)*(instanceStruct.instanceVar_Lnew-modelStruct.modelPar_XGL)));
instanceStruct.instanceVar_Grgeltd = ((modelStruct.modelPar_RSHG*(instanceStruct.instancePar_XGW+((instanceStruct.instanceVar_Weffcj/3.0)/instanceStruct.instancePar_NGCON)))/((instanceStruct.instancePar_NGCON*instanceStruct.instancePar_NF)*(instanceStruct.instanceVar_Lnew-modelStruct.modelPar_XGL)));
if ((instanceStruct.instanceVar_Grgeltd>0.0))
{
instanceStruct.d_instanceVar_Grgeltd_dX = (-instanceStruct.d_instanceVar_Grgeltd_dX/instanceStruct.instanceVar_Grgeltd/instanceStruct.instanceVar_Grgeltd);
instanceStruct.instanceVar_Grgeltd = (1.0/instanceStruct.instanceVar_Grgeltd);
}
else
{
instanceStruct.d_instanceVar_Grgeltd_dX = 0.0;
instanceStruct.instanceVar_Grgeltd = 1.0e3;
if ((instanceStruct.instancePar_RGATEMOD!=0))
{
}
}
instanceStruct.d_instanceVar_T0_dX = (modelStruct.modelPar_TOXE*modelStruct.d_modelPar_TOXE_dX+modelStruct.d_modelPar_TOXE_dX*modelStruct.modelPar_TOXE);
instanceStruct.instanceVar_T0 = (modelStruct.modelPar_TOXE*modelStruct.modelPar_TOXE);
instanceStruct.d_instanceVar_T1_dX = (modelStruct.modelPar_TOXE*d_POXEDGE_i_dX+modelStruct.d_modelPar_TOXE_dX*POXEDGE_i);
instanceStruct.instanceVar_T1 = (modelStruct.modelPar_TOXE*POXEDGE_i);
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1);
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1);
{
double value_log_0 = log((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXE));
double value_exp_1 = exp((NTOX_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXE));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_ToxRatio_dX = ((instanceStruct.instanceVar_T0*deriv_exp_1_d0*((NTOX_i*deriv_log_0_d0*(((modelStruct.modelPar_TOXE*modelStruct.d_modelPar_TOXREF_dX-modelStruct.modelPar_TOXREF*modelStruct.d_modelPar_TOXE_dX)/modelStruct.modelPar_TOXE/modelStruct.modelPar_TOXE))+d_NTOX_i_dX*value_log_0))-value_exp_1*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_ToxRatio = (value_exp_1/instanceStruct.instanceVar_T0);
}
{
double value_log_0 = log((modelStruct.modelPar_TOXREF/instanceStruct.instanceVar_T1));
double value_exp_1 = exp((NTOX_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_TOXREF/instanceStruct.instanceVar_T1));
double  deriv_exp_1_d0 = value_exp_1;
d_ToxRatioEdge_dX = ((instanceStruct.instanceVar_T2*deriv_exp_1_d0*((NTOX_i*deriv_log_0_d0*(((instanceStruct.instanceVar_T1*modelStruct.d_modelPar_TOXREF_dX-modelStruct.modelPar_TOXREF*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1))+d_NTOX_i_dX*value_log_0))-value_exp_1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2);
ToxRatioEdge = (value_exp_1/instanceStruct.instanceVar_T2);
}
instanceStruct.d_instanceVar_Aechvb_dX = 0.0;
instanceStruct.instanceVar_Aechvb = ((modelStruct.modelPar_TYPE==1)?4.97232e-7:3.42537e-7);
instanceStruct.d_instanceVar_Bechvb_dX = 0.0;
instanceStruct.instanceVar_Bechvb = ((modelStruct.modelPar_TYPE==1)?7.45669e11:1.16645e12);
instanceStruct.d_instanceVar_AechvbEdge_dX = ((instanceStruct.instanceVar_Aechvb*instanceStruct.instanceVar_Weff)*d_ToxRatioEdge_dX+(instanceStruct.instanceVar_Aechvb*instanceStruct.d_instanceVar_Weff_dX+instanceStruct.d_instanceVar_Aechvb_dX*instanceStruct.instanceVar_Weff)*ToxRatioEdge);
instanceStruct.instanceVar_AechvbEdge = ((instanceStruct.instanceVar_Aechvb*instanceStruct.instanceVar_Weff)*ToxRatioEdge);
instanceStruct.d_instanceVar_BechvbEdge_dX = (((-instanceStruct.instanceVar_Bechvb)*modelStruct.modelPar_TOXE)*d_POXEDGE_i_dX+((-instanceStruct.instanceVar_Bechvb)*modelStruct.d_modelPar_TOXE_dX+(-instanceStruct.d_instanceVar_Bechvb_dX)*modelStruct.modelPar_TOXE)*POXEDGE_i);
instanceStruct.instanceVar_BechvbEdge = (((-instanceStruct.instanceVar_Bechvb)*modelStruct.modelPar_TOXE)*POXEDGE_i);
instanceStruct.d_instanceVar_Aechvb_dX = (instanceStruct.instanceVar_Aechvb*((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_ToxRatio_dX+(instanceStruct.instanceVar_Weff*instanceStruct.d_instanceVar_Leff_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_ToxRatio)+instanceStruct.d_instanceVar_Aechvb_dX*((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_ToxRatio));
instanceStruct.instanceVar_Aechvb = (instanceStruct.instanceVar_Aechvb*((instanceStruct.instanceVar_Weff*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_ToxRatio));
instanceStruct.d_instanceVar_Bechvb_dX = (instanceStruct.instanceVar_Bechvb*(-modelStruct.d_modelPar_TOXE_dX)+instanceStruct.d_instanceVar_Bechvb_dX*(-modelStruct.modelPar_TOXE));
instanceStruct.instanceVar_Bechvb = (instanceStruct.instanceVar_Bechvb*(-modelStruct.modelPar_TOXE));
if (((modelStruct.modelPar_SHMOD!=0)&&(modelStruct.modelPar_RTH0>0)))
{
instanceStruct.d_instanceVar_gth_dX = ((modelStruct.modelPar_RTH0*(modelStruct.d_modelPar_WTH0_dX+instanceStruct.d_instanceVar_Weff_dX)*instanceStruct.instancePar_NF-((modelStruct.modelPar_WTH0+instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*modelStruct.d_modelPar_RTH0_dX)/modelStruct.modelPar_RTH0/modelStruct.modelPar_RTH0);
instanceStruct.instanceVar_gth = (((modelStruct.modelPar_WTH0+instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)/modelStruct.modelPar_RTH0);
instanceStruct.d_instanceVar_cth_dX = (modelStruct.modelPar_CTH0*(modelStruct.d_modelPar_WTH0_dX+instanceStruct.d_instanceVar_Weff_dX)+modelStruct.d_modelPar_CTH0_dX*(modelStruct.modelPar_WTH0+instanceStruct.instanceVar_Weff))*instanceStruct.instancePar_NF;
instanceStruct.instanceVar_cth = ((modelStruct.modelPar_CTH0*(modelStruct.modelPar_WTH0+instanceStruct.instanceVar_Weff))*instanceStruct.instancePar_NF);
}
else
{
instanceStruct.d_instanceVar_gth_dX = 0.0;
instanceStruct.instanceVar_gth = 1.0;
instanceStruct.d_instanceVar_cth_dX = 0.0;
instanceStruct.instanceVar_cth = 0.0;
}
}
// End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_bi_dbulk,
const int admsProbeID_V_b_dbulk,
const int admsProbeID_V_b_bi,
const int admsProbeID_V_b_sbulk,
const int admsProbeID_V_bi_sbulk,
const int admsProbeID_V_gm_gi,
const int admsProbeID_V_g_gm,
const int admsProbeID_V_s_si,
const int admsProbeID_V_d_di,
const int admsProbeID_V_gi_si,
const int admsProbeID_V_di_si,
const int admsProbeID_V_dbulk_GND,
const int admsProbeID_V_sbulk_GND,
const int admsProbeID_V_gm_GND,
const int admsProbeID_V_gi_GND,
const int admsProbeID_V_bi_GND,
const int admsProbeID_V_di_GND,
const int admsProbeID_V_si_GND,
const int admsProbeID_V_gm_bi,
const int admsProbeID_V_N1_GND,
const int admsProbeID_V_N2_GND,
const int admsProbeID_V_gm_si,
const int admsProbeID_V_gm_di,
const int admsProbeID_V_dbulk_di,
const int admsProbeID_V_sbulk_si,
const int admsProbeID_V_si_bi,
const int admsProbeID_V_di_bi,
const int admsProbeID_V_gi_bi,
const int admsProbeID_Temp_t_GND,
// node constants
const int admsNodeID_d,
const int admsNodeID_g,
const int admsNodeID_s,
const int admsNodeID_b,
const int admsNodeID_t,
const int admsNodeID_di,
const int admsNodeID_si,
const int admsNodeID_gi,
const int admsNodeID_gm,
const int admsNodeID_bi,
const int admsNodeID_sbulk,
const int admsNodeID_dbulk,
const int admsNodeID_N1,
const int admsNodeID_N2,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
const std::vector<bool> & portsConnected_,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double gspr=0.0;
double d_gspr_dX=0.0;
  double gdpr=0.0;
double d_gdpr_dX=0.0;
  double ids_edge=0.0;
double d_ids_edge_dX=0.0;
  double Vdssate=0.0;
double d_Vdssate_dX=0.0;
  double Vdsatedge=0.0;
double d_Vdsatedge_dX=0.0;
  double vdsatedge=0.0;
double d_vdsatedge_dX=0.0;
  double DGAMMAEDGE_i=0.0;
double d_DGAMMAEDGE_i_dX=0.0;
  double dvth_sce=0.0;
double d_dvth_sce_dX=0.0;
  double theta_sce_edge=0.0;
double d_theta_sce_edge_dX=0.0;
  double litl_edge=0.0;
double d_litl_edge_dX=0.0;
  double dvth_dibl=0.0;
double d_dvth_dibl_dX=0.0;
  double ETA0EDGE_t=0.0;
double d_ETA0EDGE_t_dX=0.0;
  double NFACTOREDGE_t=0.0;
double d_NFACTOREDGE_t_dX=0.0;
  double Qovg=0.0;
double d_Qovg_dX=0.0;
  double Qovb=0.0;
double d_Qovb_dX=0.0;
  double Qovd=0.0;
double d_Qovd_dX=0.0;
  double Qovs=0.0;
double d_Qovs_dX=0.0;
  double Vgdov=0.0;
double d_Vgdov_dX=0.0;
  double Vgsov=0.0;
double d_Vgsov_dX=0.0;
  double Cgdof=0.0;
double d_Cgdof_dX=0.0;
  double Cgsof=0.0;
double d_Cgsof_dX=0.0;
  double QGi=0.0;
double d_QGi_dX=0.0;
  double WLCOXVtinv=0.0;
double d_WLCOXVtinv_dX=0.0;
  double QBi=0.0;
double d_QBi_dX=0.0;
  double Coxeffinv=0.0;
double d_Coxeffinv_dX=0.0;
  double XDCinv=0.0;
double d_XDCinv_dX=0.0;
  double qiaCV=0.0;
double d_qiaCV_dX=0.0;
  double qbaCV=0.0;
double d_qbaCV_dX=0.0;
  double Qd2=0.0;
double d_Qd2_dX=0.0;
  double Qd1=0.0;
double d_Qd1_dX=0.0;
  double Qi=0.0;
double d_Qi_dX=0.0;
  double qbeff=0.0;
double d_qbeff_dX=0.0;
  double dqgeff=0.0;
double d_dqgeff_dX=0.0;
  double Tempd=0.0;
double d_Tempd_dX=0.0;
  double Temps=0.0;
double d_Temps_dX=0.0;
  double sid=0.0;
double d_sid_dX=0.0;
  double sis=0.0;
double d_sis_dX=0.0;
  double vgpqm=0.0;
double d_vgpqm_dX=0.0;
  double MdL_less_1=0.0;
double d_MdL_less_1_dX=0.0;
  double inv_MdL_2=0.0;
double d_inv_MdL_2_dX=0.0;
  double inv_MdL=0.0;
double d_inv_MdL_dX=0.0;
  double MdL_2=0.0;
double d_MdL_2_dX=0.0;
  double zsat=0.0;
double d_zsat_dX=0.0;
  double dps=0.0;
double d_dps_dX=0.0;
  double qb=0.0;
double d_qb_dX=0.0;
  double qbd=0.0;
double d_qbd_dX=0.0;
  double VdssatCV=0.0;
double d_VdssatCV_dX=0.0;
  double VdsatCV=0.0;
double d_VdsatCV_dX=0.0;
  double vdsatcv=0.0;
double d_vdsatcv_dX=0.0;
  double LambdaC_by2=0.0;
double d_LambdaC_by2_dX=0.0;
  double DPD=0.0;
double d_DPD_dX=0.0;
  double invgamg2=0.0;
double d_invgamg2_dX=0.0;
  double gamg2=0.0;
double d_gamg2_dX=0.0;
  double vgfbCV=0.0;
double d_vgfbCV_dX=0.0;
  double QSi=0.0;
double d_QSi_dX=0.0;
  double QDi=0.0;
double d_QDi_dX=0.0;
  double Gtnoi=0.0;
double d_Gtnoi_dX=0.0;
  double sidn=0.0;
double d_sidn_dX=0.0;
  double Vtn=0.0;
double d_Vtn_dX=0.0;
  double Lvsat=0.0;
double d_Lvsat_dX=0.0;
  double mid=0.0;
double d_mid_dX=0.0;
  double mig=0.0;
double d_mig_dX=0.0;
  double migid=0.0;
double d_migid_dX=0.0;
  double sqid=0.0;
double d_sqid_dX=0.0;
  double sqig=0.0;
double d_sqig_dX=0.0;
  double cm_igid=0.0;
double d_cm_igid_dX=0.0;
  double thetanoisq=0.0;
double d_thetanoisq_dX=0.0;
  double betanoisq=0.0;
double d_betanoisq_dX=0.0;
  double ctnoi=0.0;
double d_ctnoi_dX=0.0;
  double FNPowerAt1Hz=0.0;
double d_FNPowerAt1Hz_dX=0.0;
  double Swi=0.0;
double d_Swi_dX=0.0;
  double T10=0.0;
double d_T10_dX=0.0;
  double Ssi=0.0;
double d_Ssi_dX=0.0;
  double Nstar=0.0;
double d_Nstar_dX=0.0;
  double Nl=0.0;
double d_Nl_dX=0.0;
  double N0=0.0;
double d_N0_dX=0.0;
  double DelClm=0.0;
double d_DelClm_dX=0.0;
  double Leffnoisq=0.0;
double d_Leffnoisq_dX=0.0;
  double Leffnoi=0.0;
double d_Leffnoi_dX=0.0;
  double Esatnoi=0.0;
double d_Esatnoi_dX=0.0;
  double LINTNOI_i=0.0;
double d_LINTNOI_i_dX=0.0;
  double Nt=0.0;
double d_Nt_dX=0.0;
  double Qbd=0.0;
double d_Qbd_dX=0.0;
  double Qbs=0.0;
double d_Qbs_dX=0.0;
  double sarg=0.0;
double d_sarg_dX=0.0;
  double arg=0.0;
double d_arg_dX=0.0;
  double Ibd=0.0;
double d_Ibd_dX=0.0;
  double Ibs=0.0;
double d_Ibs_dX=0.0;
  double igidl=0.0;
double d_igidl_dX=0.0;
  double igisl=0.0;
double d_igisl_dX=0.0;
  double igd_mult=0.0;
double d_igd_mult_dX=0.0;
  double igs_mult=0.0;
double d_igs_mult_dX=0.0;
  double T1_exp=0.0;
double d_T1_exp_dX=0.0;
  double Vdseffx=0.0;
double d_Vdseffx_dX=0.0;
  double igc0=0.0;
double d_igc0_dX=0.0;
  double Vaux_Igbinv=0.0;
double d_Vaux_Igbinv_dX=0.0;
  double Vaux_Igbacc=0.0;
double d_Vaux_Igbacc_dX=0.0;
  double Voxminv=0.0;
double d_Voxminv_dX=0.0;
  double Voxmacc=0.0;
double d_Voxmacc_dX=0.0;
  double Voxm=0.0;
double d_Voxm_dX=0.0;
  double igd=0.0;
double d_igd_dX=0.0;
  double igs=0.0;
double d_igs_dX=0.0;
  double igcd=0.0;
double d_igcd_dX=0.0;
  double igcs=0.0;
double d_igcs_dX=0.0;
  double igb=0.0;
double d_igb_dX=0.0;
  double igbacc=0.0;
double d_igbacc_dX=0.0;
  double igbinv=0.0;
double d_igbinv_dX=0.0;
  double Iii=0.0;
double d_Iii_dX=0.0;
  double idsovvds=0.0;
double d_idsovvds_dX=0.0;
  double Gcrg=0.0;
double d_Gcrg_dX=0.0;
  double ids=0.0;
double d_ids_dX=0.0;
  double ueff=0.0;
double d_ueff_dX=0.0;
  double Dtot=0.0;
double d_Dtot_dX=0.0;
  double Nsat=0.0;
double d_Nsat_dX=0.0;
  double DQSD=0.0;
double d_DQSD_dX=0.0;
  double Vgd_eff=0.0;
double d_Vgd_eff_dX=0.0;
  double Vgs_eff=0.0;
double d_Vgs_eff_dX=0.0;
  double Dr=0.0;
double d_Dr_dX=0.0;
  double Rdsi=0.0;
double d_Rdsi_dX=0.0;
  double Rdrain=0.0;
double d_Rdrain_dX=0.0;
  double Rsource=0.0;
double d_Rsource_dX=0.0;
  double Dptwg=0.0;
double d_Dptwg_dX=0.0;
  double Dvsat=0.0;
double d_Dvsat_dX=0.0;
  double Mscbe=0.0;
double d_Mscbe_dX=0.0;
  double VaSCBE=0.0;
double d_VaSCBE_dX=0.0;
  double VaDITS=0.0;
double d_VaDITS_dX=0.0;
  double MdL=0.0;
double d_MdL_dX=0.0;
  double Vasat=0.0;
double d_Vasat_dX=0.0;
  double Fp=0.0;
double d_Fp_dX=0.0;
  double Moc=0.0;
double d_Moc_dX=0.0;
  double VaDIBL=0.0;
double d_VaDIBL_dX=0.0;
  double Vgst2Vtm=0.0;
double d_Vgst2Vtm_dX=0.0;
  double diffVds=0.0;
double d_diffVds_dX=0.0;
  double DIBLfactor=0.0;
double d_DIBLfactor_dX=0.0;
  double PVAGfactor=0.0;
double d_PVAGfactor_dX=0.0;
  double EsatL=0.0;
double d_EsatL_dX=0.0;
  double Esat=0.0;
double d_Esat_dX=0.0;
  double Dmob=0.0;
double d_Dmob_dX=0.0;
  double Eeffm=0.0;
double d_Eeffm_dX=0.0;
  double qia=0.0;
double d_qia_dX=0.0;
  double qba=0.0;
double d_qba_dX=0.0;
  double Qd=0.0;
double d_Qd_dX=0.0;
  double Qs=0.0;
double d_Qs_dX=0.0;
  double Qb=0.0;
double d_Qb_dX=0.0;
  double DQSD2=0.0;
double d_DQSD2_dX=0.0;
  double qdeff=0.0;
double d_qdeff_dX=0.0;
  double vdeff=0.0;
double d_vdeff_dX=0.0;
  double Vdseff=0.0;
double d_Vdseff_dX=0.0;
  double Vdssat=0.0;
double d_Vdssat_dX=0.0;
  double Vdsat=0.0;
double d_Vdsat_dX=0.0;
  double vdsat=0.0;
double d_vdsat_dX=0.0;
  double qdsat=0.0;
double d_qdsat_dX=0.0;
  double ln_T1_T2=0.0;
double d_ln_T1_T2_dX=0.0;
  double T12=0.0;
double d_T12_dX=0.0;
  double T11=0.0;
double d_T11_dX=0.0;
  double LambdaC=0.0;
double d_LambdaC_dX=0.0;
  double Rdss=0.0;
double d_Rdss_dX=0.0;
  double WeffWRFactor=0.0;
double d_WeffWRFactor_dX=0.0;
  double Dmobs=0.0;
double d_Dmobs_dX=0.0;
  double Eeffs=0.0;
double d_Eeffs_dX=0.0;
  double qis=0.0;
double d_qis_dX=0.0;
  double qbs=0.0;
double d_qbs_dX=0.0;
  double EeffFactor=0.0;
double d_EeffFactor_dX=0.0;
  double psiavg=0.0;
double d_psiavg_dX=0.0;
  double psipclamp=0.0;
double d_psipclamp_dX=0.0;
  double qs=0.0;
double d_qs_dX=0.0;
  double T6=0.0;
double d_T6_dX=0.0;
  double T5=0.0;
double d_T5_dX=0.0;
  double T7=0.0;
double d_T7_dX=0.0;
  double sqrtpsisainv=0.0;
double d_sqrtpsisainv_dX=0.0;
  double sqrtpsisa=0.0;
double d_sqrtpsisa_dX=0.0;
  double T9=0.0;
double d_T9_dX=0.0;
  double sqrtpsip=0.0;
double d_sqrtpsip_dX=0.0;
  double T8=0.0;
double d_T8_dX=0.0;
  double psip=0.0;
double d_psip_dX=0.0;
  double gammaPD=0.0;
double d_gammaPD_dX=0.0;
  double vgfbPD=0.0;
double d_vgfbPD_dX=0.0;
  double phib_n=0.0;
double d_phib_n_dX=0.0;
  double inv_gam=0.0;
double d_inv_gam_dX=0.0;
  double psip_th=0.0;
double d_psip_th_dX=0.0;
  double nq=0.0;
double d_nq_dX=0.0;
  double q_vth=0.0;
  double gam=0.0;
double d_gam_dX=0.0;
  double vgfb=0.0;
double d_vgfb_dX=0.0;
  double Vth_shift=0.0;
double d_Vth_shift_dX=0.0;
  double dVth_VNUD=0.0;
double d_dVth_VNUD_dX=0.0;
  double vfb=0.0;
double d_vfb_dX=0.0;
  double vs=0.0;
double d_vs_dX=0.0;
  double vg=0.0;
double d_vg_dX=0.0;
  double T4=0.0;
double d_T4_dX=0.0;
  double dVth_ldop=0.0;
double d_dVth_ldop_dX=0.0;
  double dvth_temp=0.0;
double d_dvth_temp_dX=0.0;
  double dVth_dibl=0.0;
double d_dVth_dibl_dX=0.0;
  double inv_nVt=0.0;
double d_inv_nVt_dX=0.0;
  double nVt=0.0;
double d_nVt_dX=0.0;
  double n=0.0;
double d_n_dX=0.0;
  double cdsc=0.0;
double d_cdsc_dX=0.0;
  double Cdep=0.0;
double d_Cdep_dX=0.0;
  double Xdep=0.0;
double d_Xdep_dX=0.0;
  double sqrtPhistVbs=0.0;
double d_sqrtPhistVbs_dX=0.0;
  double PhistVbs=0.0;
double d_PhistVbs_dX=0.0;
  double UCS_a=0.0;
double d_UCS_a_dX=0.0;
  double UC_a=0.0;
double d_UC_a_dX=0.0;
  double UA_a=0.0;
double d_UA_a_dX=0.0;
  double U0_a=0.0;
double d_U0_a_dX=0.0;
  double PTWG_a=0.0;
double d_PTWG_a_dX=0.0;
  double VSAT_a=0.0;
double d_VSAT_a_dX=0.0;
  double PSAT_a=0.0;
double d_PSAT_a_dX=0.0;
  double PCLM_a=0.0;
double d_PCLM_a_dX=0.0;
  double PDIBLC_a=0.0;
double d_PDIBLC_a_dX=0.0;
  double ETA0_a=0.0;
double d_ETA0_a_dX=0.0;
  double CDSCD_a=0.0;
double d_CDSCD_a_dX=0.0;
  double wr=0.0;
double d_wr_dX=0.0;
  double wf=0.0;
double d_wf_dX=0.0;
  double Vbsx=0.0;
  double Vdsx=0.0;
  double sigvds=0.0;
  double Vgs_ov_noswap=0.0;
  double Vgd_ov_noswap=0.0;
  double Vgs_noswap=0.0;
  double Vgd_noswap=0.0;
  double Vbd_jct=0.0;
  double Vbs_jct=0.0;
  double Vdb_noswap=0.0;
  double Vsb_noswap=0.0;
  double Vds_noswap=0.0;
  double Vds=0.0;
  double Vs=0.0;
  double Vd=0.0;
  double Vg=0.0;
  double mu_well=0.0;
double d_mu_well_dX=0.0;
  double k2_well=0.0;
double d_k2_well_dX=0.0;
  double vth0_well=0.0;
double d_vth0_well_dX=0.0;
  double Wdrn=0.0;
double d_Wdrn_dX=0.0;
  double local_scc=0.0;
double d_local_scc_dX=0.0;
  double local_scb=0.0;
double d_local_scb_dX=0.0;
  double local_sca=0.0;
double d_local_sca_dX=0.0;
  double eta_stress=0.0;
double d_eta_stress_dX=0.0;
  double k2_stress=0.0;
double d_k2_stress_dX=0.0;
  double vth0_stress=0.0;
double d_vth0_stress_dX=0.0;
  double vsat_mult=0.0;
double d_vsat_mult_dX=0.0;
  double mu0_mult=0.0;
double d_mu0_mult_dX=0.0;
  double rho=0.0;
double d_rho_dX=0.0;
  double Inv_od=0.0;
double d_Inv_od_dX=0.0;
  double rho_ref=0.0;
double d_rho_ref_dX=0.0;
  double Inv_odref=0.0;
double d_Inv_odref_dX=0.0;
  double Inv_sbref=0.0;
double d_Inv_sbref_dX=0.0;
  double Inv_saref=0.0;
double d_Inv_saref_dX=0.0;
  int i=0.0;
  double Inv_sb=0.0;
double d_Inv_sb_dX=0.0;
  double Inv_sa=0.0;
double d_Inv_sa_dX=0.0;
  double ku0_temp=0.0;
double d_ku0_temp_dX=0.0;
  double kstress_vth0=0.0;
double d_kstress_vth0_dX=0.0;
  double tmp1_stress_vth=0.0;
double d_tmp1_stress_vth_dX=0.0;
  double kstress_u0=0.0;
double d_kstress_u0_dX=0.0;
  double tmp1_stress=0.0;
double d_tmp1_stress_dX=0.0;
  double W_tmp_stress=0.0;
double d_W_tmp_stress_dX=0.0;
  double Czbdswg=0.0;
double d_Czbdswg_dX=0.0;
  double Czbdsw=0.0;
double d_Czbdsw_dX=0.0;
  double Czbd=0.0;
double d_Czbd_dX=0.0;
  double Czbsswg=0.0;
double d_Czbsswg_dX=0.0;
  double Czbssw=0.0;
double d_Czbssw_dX=0.0;
  double Czbs=0.0;
double d_Czbs_dX=0.0;
  double DslpRev=0.0;
double d_DslpRev_dX=0.0;
  double IVjdmRev=0.0;
double d_IVjdmRev_dX=0.0;
  double VjdmRev=0.0;
double d_VjdmRev_dX=0.0;
  double DslpFwd=0.0;
double d_DslpFwd_dX=0.0;
  double IVjdmFwd=0.0;
double d_IVjdmFwd_dX=0.0;
  double VjdmFwd=0.0;
double d_VjdmFwd_dX=0.0;
  double XExpBVD=0.0;
double d_XExpBVD_dX=0.0;
  double Nvtmd=0.0;
double d_Nvtmd_dX=0.0;
  double Isbd=0.0;
double d_Isbd_dX=0.0;
  double SslpRev=0.0;
double d_SslpRev_dX=0.0;
  double IVjsmRev=0.0;
double d_IVjsmRev_dX=0.0;
  double VjsmRev=0.0;
double d_VjsmRev_dX=0.0;
  double SslpFwd=0.0;
double d_SslpFwd_dX=0.0;
  double IVjsmFwd=0.0;
double d_IVjsmFwd_dX=0.0;
  double VjsmFwd=0.0;
double d_VjsmFwd_dX=0.0;
  double Tb=0.0;
double d_Tb_dX=0.0;
  double XExpBVS=0.0;
double d_XExpBVS_dX=0.0;
  double Nvtms=0.0;
double d_Nvtms_dX=0.0;
  double Isbs=0.0;
double d_Isbs_dX=0.0;
  double PDeff=0.0;
double d_PDeff_dX=0.0;
  double PSeff=0.0;
double d_PSeff_dX=0.0;
  double ADeff=0.0;
double d_ADeff_dX=0.0;
  double ASeff=0.0;
double d_ASeff_dX=0.0;
  double PSiso=0.0;
double d_PSiso_dX=0.0;
  double PDiso=0.0;
double d_PDiso_dX=0.0;
  double PSsha=0.0;
double d_PSsha_dX=0.0;
  double PDsha=0.0;
double d_PDsha_dX=0.0;
  double PSmer=0.0;
double d_PSmer_dX=0.0;
  double PDmer=0.0;
double d_PDmer_dX=0.0;
  double ASiso=0.0;
double d_ASiso_dX=0.0;
  double ADiso=0.0;
double d_ADiso_dX=0.0;
  double ASsha=0.0;
double d_ASsha_dX=0.0;
  double ADsha=0.0;
double d_ADsha_dX=0.0;
  double ASmer=0.0;
double d_ASmer_dX=0.0;
  double ADmer=0.0;
double d_ADmer_dX=0.0;
  double temp_ADeff=0.0;
double d_temp_ADeff_dX=0.0;
  double temp_ASeff=0.0;
double d_temp_ASeff_dX=0.0;
  double temp_PDeff=0.0;
double d_temp_PDeff_dX=0.0;
  double temp_PSeff=0.0;
double d_temp_PSeff_dX=0.0;
  double NJTSSWGD_t=0.0;
double d_NJTSSWGD_t_dX=0.0;
  double NJTSSWD_t=0.0;
double d_NJTSSWD_t_dX=0.0;
  double NJTSD_t=0.0;
double d_NJTSD_t_dX=0.0;
  double NJTSSWG_t=0.0;
double d_NJTSSWG_t_dX=0.0;
  double NJTSSW_t=0.0;
double d_NJTSSW_t_dX=0.0;
  double NJTS_t=0.0;
double d_NJTS_t_dX=0.0;
  double JTSSWGD_t=0.0;
double d_JTSSWGD_t_dX=0.0;
  double JTSSWD_t=0.0;
double d_JTSSWD_t_dX=0.0;
  double JTSD_t=0.0;
double d_JTSD_t_dX=0.0;
  double JTSSWGS_t=0.0;
double d_JTSSWGS_t_dX=0.0;
  double JTSSWS_t=0.0;
double d_JTSSWS_t_dX=0.0;
  double JTSS_t=0.0;
double d_JTSS_t_dX=0.0;
  double JSWGD_t=0.0;
double d_JSWGD_t_dX=0.0;
  double JSWD_t=0.0;
double d_JSWD_t_dX=0.0;
  double JSD_t=0.0;
double d_JSD_t_dX=0.0;
  double JSWGS_t=0.0;
double d_JSWGS_t_dX=0.0;
  double JSWS_t=0.0;
double d_JSWS_t_dX=0.0;
  double JSS_t=0.0;
double d_JSS_t_dX=0.0;
  double T3=0.0;
double d_T3_dX=0.0;
  double PBSWGD_t=0.0;
double d_PBSWGD_t_dX=0.0;
  double PBSWGS_t=0.0;
double d_PBSWGS_t_dX=0.0;
  double PBSWD_t=0.0;
double d_PBSWD_t_dX=0.0;
  double PBSWS_t=0.0;
double d_PBSWS_t_dX=0.0;
  double PBD_t=0.0;
double d_PBD_t_dX=0.0;
  double PBS_t=0.0;
double d_PBS_t_dX=0.0;
  double CJSWGD_t=0.0;
double d_CJSWGD_t_dX=0.0;
  double CJSWGS_t=0.0;
double d_CJSWGS_t_dX=0.0;
  double CJSWD_t=0.0;
double d_CJSWD_t_dX=0.0;
  double CJSWS_t=0.0;
double d_CJSWS_t_dX=0.0;
  double CJD_t=0.0;
double d_CJD_t_dX=0.0;
  double CJS_t=0.0;
double d_CJS_t_dX=0.0;
  double igtemp=0.0;
double d_igtemp_dX=0.0;
  double BGISL_t=0.0;
double d_BGISL_t_dX=0.0;
  double BGIDL_t=0.0;
double d_BGIDL_t_dX=0.0;
  double BETA0_t=0.0;
double d_BETA0_t_dX=0.0;
  double A2_t=0.0;
double d_A2_t_dX=0.0;
  double A1_t=0.0;
double d_A1_t_dX=0.0;
  double PTWG_t=0.0;
double d_PTWG_t_dX=0.0;
  double DELTA_t=0.0;
double d_DELTA_t_dX=0.0;
  double VSATCV_t=0.0;
double d_VSATCV_t_dX=0.0;
  double VSAT_t=0.0;
double d_VSAT_t_dX=0.0;
  double rdstemp=0.0;
double d_rdstemp_dX=0.0;
  double UCS_t=0.0;
double d_UCS_t_dX=0.0;
  double UD_t=0.0;
double d_UD_t_dX=0.0;
  double UC_t=0.0;
double d_UC_t_dX=0.0;
  double UA_t=0.0;
double d_UA_t_dX=0.0;
  double U0_t=0.0;
double d_U0_t_dX=0.0;
  double eta_mu=0.0;
double d_eta_mu_dX=0.0;
  double ETA0_t=0.0;
double d_ETA0_t_dX=0.0;
  double NFACTOR_t=0.0;
double d_NFACTOR_t_dX=0.0;
  double litl=0.0;
double d_litl_dX=0.0;
  double T1DEP=0.0;
double d_T1DEP_dX=0.0;
  double sqrtPhist=0.0;
double d_sqrtPhist_dX=0.0;
  double Phist=0.0;
double d_Phist_dX=0.0;
  double Vfbsdr=0.0;
double d_Vfbsdr_dX=0.0;
  double Vbi=0.0;
double d_Vbi_dX=0.0;
  double phib=0.0;
double d_phib_dX=0.0;
  double ni=0.0;
double d_ni_dX=0.0;
  double Eg0=0.0;
double d_Eg0_dX=0.0;
  double Eg=0.0;
double d_Eg_dX=0.0;
  double Vtm0=0.0;
double d_Vtm0_dX=0.0;
  double Vtm=0.0;
double d_Vtm_dX=0.0;
  double delTemp=0.0;
double d_delTemp_dX=0.0;
  double TRatio=0.0;
double d_TRatio_dX=0.0;
  double inv_Vt=0.0;
double d_inv_Vt_dX=0.0;
  double Vt=0.0;
double d_Vt_dX=0.0;
  double delTemp1=0.0;
  double DevTemp=0.0;
double d_DevTemp_dX=0.0;
  double Tnom=0.0;
double d_Tnom_dX=0.0;


  // -- code converted from analog/code block
if ((modelStruct.modelPar_TNOM<=(-273.15)))
{
instanceStruct.d_instanceVar_T0_dX = 0.0;
instanceStruct.instanceVar_T0 = (300.15-273.15);
UserInfo(theInstance)  << "Warning: TNOM = %e C <= %e C. Setting TNOM to %e C." << " " << modelStruct.modelPar_TNOM << " " << (-273.15) << " " << instanceStruct.instanceVar_T0 << " " <<  std::endl; 
d_Tnom_dX = 0.0;
Tnom = 300.15;
}
else
{
d_Tnom_dX = modelStruct.d_modelPar_TNOM_dX;
Tnom = (modelStruct.modelPar_TNOM+273.15);
}
d_DevTemp_dX = modelStruct.d_modelPar_DTEMP_dX;
DevTemp = (admsTemperature+modelStruct.modelPar_DTEMP);
if (((modelStruct.modelPar_SHMOD!=0)&&(modelStruct.modelPar_RTH0>0)))
{
delTemp1 = (probeVars[admsProbeID_Temp_t_GND]);
}
else
{
delTemp1 = 0;
}
DevTemp = (delTemp1+DevTemp);
d_Vt_dX = 0.0;
Vt = adms_vt(DevTemp);
d_inv_Vt_dX = (-d_Vt_dX/Vt/Vt);
inv_Vt = (1.0/Vt);
d_TRatio_dX = ((Tnom*d_DevTemp_dX-DevTemp*d_Tnom_dX)/Tnom/Tnom);
TRatio = (DevTemp/Tnom);
d_delTemp_dX = (d_DevTemp_dX-d_Tnom_dX);
delTemp = (DevTemp-Tnom);
d_Vtm_dX = 8.617087e-5*d_DevTemp_dX;
Vtm = (8.617087e-5*DevTemp);
d_Vtm0_dX = 8.617087e-5*d_Tnom_dX;
Vtm0 = (8.617087e-5*Tnom);
d_Eg_dX = (modelStruct.d_modelPar_BG0SUB_dX-(((DevTemp+modelStruct.modelPar_TBGBSUB)*((modelStruct.modelPar_TBGASUB*DevTemp)*d_DevTemp_dX+(modelStruct.modelPar_TBGASUB*d_DevTemp_dX+modelStruct.d_modelPar_TBGASUB_dX*DevTemp)*DevTemp)-((modelStruct.modelPar_TBGASUB*DevTemp)*DevTemp)*(d_DevTemp_dX+modelStruct.d_modelPar_TBGBSUB_dX))/(DevTemp+modelStruct.modelPar_TBGBSUB)/(DevTemp+modelStruct.modelPar_TBGBSUB)));
Eg = (modelStruct.modelPar_BG0SUB-(((modelStruct.modelPar_TBGASUB*DevTemp)*DevTemp)/(DevTemp+modelStruct.modelPar_TBGBSUB)));
d_Eg0_dX = (modelStruct.d_modelPar_BG0SUB_dX-(((Tnom+modelStruct.modelPar_TBGBSUB)*((modelStruct.modelPar_TBGASUB*Tnom)*d_Tnom_dX+(modelStruct.modelPar_TBGASUB*d_Tnom_dX+modelStruct.d_modelPar_TBGASUB_dX*Tnom)*Tnom)-((modelStruct.modelPar_TBGASUB*Tnom)*Tnom)*(d_Tnom_dX+modelStruct.d_modelPar_TBGBSUB_dX))/(Tnom+modelStruct.modelPar_TBGBSUB)/(Tnom+modelStruct.modelPar_TBGBSUB)));
Eg0 = (modelStruct.modelPar_BG0SUB-(((modelStruct.modelPar_TBGASUB*Tnom)*Tnom)/(Tnom+modelStruct.modelPar_TBGBSUB)));
{
double value_sqrt_0 = sqrt((DevTemp/Tnom));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T1_dX = ((DevTemp/Tnom)*deriv_sqrt_0_d0*(((Tnom*d_DevTemp_dX-DevTemp*d_Tnom_dX)/Tnom/Tnom))+((Tnom*d_DevTemp_dX-DevTemp*d_Tnom_dX)/Tnom/Tnom)*value_sqrt_0);
instanceStruct.instanceVar_T1 = ((DevTemp/Tnom)*value_sqrt_0);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm))));
d_ni_dX = ((modelStruct.modelPar_NI0SUB*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getDerivs(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm))),((((2.0*Vtm0)*d_Eg_dX-Eg*2.0*d_Vtm0_dX)/(2.0*Vtm0)/(2.0*Vtm0))-(((2.0*Vtm)*d_Eg_dX-Eg*2.0*d_Vtm_dX)/(2.0*Vtm)/(2.0*Vtm))))+(modelStruct.modelPar_NI0SUB*instanceStruct.d_instanceVar_T1_dX+modelStruct.d_modelPar_NI0SUB_dX*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))));
ni = ((modelStruct.modelPar_NI0SUB*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues(((Eg/(2.0*Vtm0))-(Eg/(2.0*Vtm)))));
}
if (((modelStruct.modelPar_SHMOD!=0)&&(modelStruct.modelPar_RTH0>0)))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((instanceStruct.instanceVar_NDEP_i/ni));
instanceStruct.d_instanceVar_T0_dX = evaluator_lln_0.getDerivs((instanceStruct.instanceVar_NDEP_i/ni),((ni*instanceStruct.d_instanceVar_NDEP_i_dX-instanceStruct.instanceVar_NDEP_i*d_ni_dX)/ni/ni));
instanceStruct.instanceVar_T0 = evaluator_lln_0.getValues((instanceStruct.instanceVar_NDEP_i/ni));
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+1.0E-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_phib_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T0));
phib = value_sqrt_0;
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((instanceStruct.instanceVar_NDEP_i/ni));
d_phib_dX = evaluator_lln_0.getDerivs((instanceStruct.instanceVar_NDEP_i/ni),((ni*instanceStruct.d_instanceVar_NDEP_i_dX-instanceStruct.instanceVar_NDEP_i*d_ni_dX)/ni/ni));
phib = evaluator_lln_0.getValues((instanceStruct.instanceVar_NDEP_i/ni));
}
}
if (((modelStruct.modelPar_SHMOD!=0)&&(modelStruct.modelPar_RTH0>0)))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*ni));
instanceStruct.d_instanceVar_T0_dX = evaluator_lln_0.getDerivs((((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*ni),(((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*d_ni_dX+((ni*(instanceStruct.instanceVar_NDEP_i*modelStruct.d_modelPar_NSD_dX+instanceStruct.d_instanceVar_NDEP_i_dX*modelStruct.modelPar_NSD)-(instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)*d_ni_dX)/ni/ni)*ni));
instanceStruct.instanceVar_T0 = evaluator_lln_0.getValues((((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*ni));
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+1.0E-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vbi_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T0));
Vbi = value_sqrt_0;
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*ni));
d_Vbi_dX = evaluator_lln_0.getDerivs((((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*ni),(((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*d_ni_dX+((ni*(instanceStruct.instanceVar_NDEP_i*modelStruct.d_modelPar_NSD_dX+instanceStruct.d_instanceVar_NDEP_i_dX*modelStruct.modelPar_NSD)-(instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)*d_ni_dX)/ni/ni)*ni));
Vbi = evaluator_lln_0.getValues((((instanceStruct.instanceVar_NDEP_i*modelStruct.modelPar_NSD)/ni)*ni));
}
}
if ((instanceStruct.instanceVar_NGATE_i>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((instanceStruct.instanceVar_NGATE_i/instanceStruct.instanceVar_NSD_i));
d_Vfbsdr_dX = ((((-instanceStruct.instanceVar_devsign)*Vt)*evaluator_lln_0.getDerivs((instanceStruct.instanceVar_NGATE_i/instanceStruct.instanceVar_NSD_i),((instanceStruct.instanceVar_NSD_i*instanceStruct.d_instanceVar_NGATE_i_dX-instanceStruct.instanceVar_NGATE_i*instanceStruct.d_instanceVar_NSD_i_dX)/instanceStruct.instanceVar_NSD_i/instanceStruct.instanceVar_NSD_i))+(-instanceStruct.instanceVar_devsign)*d_Vt_dX*evaluator_lln_0.getValues((instanceStruct.instanceVar_NGATE_i/instanceStruct.instanceVar_NSD_i)))+instanceStruct.d_instancePar_VFBSDOFF_dX);
Vfbsdr = ((((-instanceStruct.instanceVar_devsign)*Vt)*evaluator_lln_0.getValues((instanceStruct.instanceVar_NGATE_i/instanceStruct.instanceVar_NSD_i)))+instanceStruct.instancePar_VFBSDOFF);
}
}
else
{
d_Vfbsdr_dX = 0.0;
Vfbsdr = 0.0;
}
{
double value_max_0 = std::max(((0.4+(Vt*phib))+instanceStruct.instanceVar_PHIN_i),static_cast<double>(0.4));
double  deriv_max_0_d0 = ((((0.4+(Vt*phib))+instanceStruct.instanceVar_PHIN_i)>=0.4)?1.0:0.0);
d_Phist_dX = (deriv_max_0_d0*(((Vt*d_phib_dX+d_Vt_dX*phib)+instanceStruct.d_instanceVar_PHIN_i_dX)));
Phist = value_max_0;
}
{
double value_sqrt_0 = sqrt(Phist);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtPhist_dX = deriv_sqrt_0_d0*(d_Phist_dX);
sqrtPhist = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt(((2.0*instanceStruct.instanceVar_epssi)/(1.60219e-19*instanceStruct.instanceVar_NDEP_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T1DEP_dX = deriv_sqrt_0_d0*((((1.60219e-19*instanceStruct.instanceVar_NDEP_i)*2.0*instanceStruct.d_instanceVar_epssi_dX-(2.0*instanceStruct.instanceVar_epssi)*1.60219e-19*instanceStruct.d_instanceVar_NDEP_i_dX)/(1.60219e-19*instanceStruct.instanceVar_NDEP_i)/(1.60219e-19*instanceStruct.instanceVar_NDEP_i)));
T1DEP = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_epssi/instanceStruct.instanceVar_epsox)*modelStruct.modelPar_TOXE)*instanceStruct.instanceVar_XJ_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_litl_dX = deriv_sqrt_0_d0*((((instanceStruct.instanceVar_epssi/instanceStruct.instanceVar_epsox)*modelStruct.modelPar_TOXE)*instanceStruct.d_instanceVar_XJ_i_dX+((instanceStruct.instanceVar_epssi/instanceStruct.instanceVar_epsox)*modelStruct.d_modelPar_TOXE_dX+((instanceStruct.instanceVar_epsox*instanceStruct.d_instanceVar_epssi_dX-instanceStruct.instanceVar_epssi*instanceStruct.d_instanceVar_epsox_dX)/instanceStruct.instanceVar_epsox/instanceStruct.instanceVar_epsox)*modelStruct.modelPar_TOXE)*instanceStruct.instanceVar_XJ_i));
litl = value_sqrt_0;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((1.0+(modelStruct.modelPar_TNFACTOR*(TRatio-1.0))),1e-3);
d_NFACTOR_t_dX = (instanceStruct.instanceVar_NFACTOR_i*evaluator_hypsmooth_0.getDerivs((1.0+(modelStruct.modelPar_TNFACTOR*(TRatio-1.0))),1e-3,(modelStruct.modelPar_TNFACTOR*d_TRatio_dX+modelStruct.d_modelPar_TNFACTOR_dX*(TRatio-1.0)),0.0)+instanceStruct.d_instanceVar_NFACTOR_i_dX*evaluator_hypsmooth_0.getValues((1.0+(modelStruct.modelPar_TNFACTOR*(TRatio-1.0))),1e-3));
NFACTOR_t = (instanceStruct.instanceVar_NFACTOR_i*evaluator_hypsmooth_0.getValues((1.0+(modelStruct.modelPar_TNFACTOR*(TRatio-1.0))),1e-3));
}
d_ETA0_t_dX = (instanceStruct.instanceVar_ETA0_i*(modelStruct.modelPar_TETA0*d_TRatio_dX+modelStruct.d_modelPar_TETA0_dX*(TRatio-1.0))+instanceStruct.d_instanceVar_ETA0_i_dX*(1.0+(modelStruct.modelPar_TETA0*(TRatio-1.0))));
ETA0_t = (instanceStruct.instanceVar_ETA0_i*(1.0+(modelStruct.modelPar_TETA0*(TRatio-1.0))));
if ((modelStruct.modelPar_ASYMMOD!=0))
{
instanceStruct.d_instanceVar_ETA0R_t_dX = (instanceStruct.instanceVar_ETA0R_i*(modelStruct.modelPar_TETA0*d_TRatio_dX+modelStruct.d_modelPar_TETA0_dX*(TRatio-1.0))+instanceStruct.d_instanceVar_ETA0R_i_dX*(1.0+(modelStruct.modelPar_TETA0*(TRatio-1.0))));
instanceStruct.instanceVar_ETA0R_t = (instanceStruct.instanceVar_ETA0R_i*(1.0+(modelStruct.modelPar_TETA0*(TRatio-1.0))));
}
d_eta_mu_dX = ((modelStruct.modelPar_TYPE!=1)?0.33333333333333333*modelStruct.d_modelPar_ETAMOB_dX:0.5*modelStruct.d_modelPar_ETAMOB_dX);
eta_mu = ((modelStruct.modelPar_TYPE!=1)?(0.33333333333333333*modelStruct.modelPar_ETAMOB):(0.5*modelStruct.modelPar_ETAMOB));
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_UTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_UTE_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_U0_t_dX = (instanceStruct.instanceVar_U0_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_UTE_i_dX)))+instanceStruct.d_instanceVar_U0_i_dX*value_pow_0);
U0_t = (instanceStruct.instanceVar_U0_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3);
d_UA_t_dX = (instanceStruct.instanceVar_UA_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_UA1_i*d_delTemp_dX+instanceStruct.d_instanceVar_UA1_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_UA_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3));
UA_t = (instanceStruct.instanceVar_UA_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3);
d_UC_t_dX = (instanceStruct.instanceVar_UC_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_UC1_i*d_delTemp_dX+instanceStruct.d_instanceVar_UC1_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_UC_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3));
UC_t = (instanceStruct.instanceVar_UC_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3));
}
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_UD1_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_UD1_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_UD_t_dX = (instanceStruct.instanceVar_UD_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_UD1_i_dX)))+instanceStruct.d_instanceVar_UD_i_dX*value_pow_0);
UD_t = (instanceStruct.instanceVar_UD_i*value_pow_0);
}
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_UCSTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_UCSTE_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_UCS_t_dX = (instanceStruct.instanceVar_UCS_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_UCSTE_i_dX)))+instanceStruct.d_instanceVar_UCS_i_dX*value_pow_0);
UCS_t = (instanceStruct.instanceVar_UCS_i*value_pow_0);
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_UTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_UTE_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
instanceStruct.d_instanceVar_U0R_t_dX = (instanceStruct.instanceVar_U0R_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_UTE_i_dX)))+instanceStruct.d_instanceVar_U0R_i_dX*value_pow_0);
instanceStruct.instanceVar_U0R_t = (instanceStruct.instanceVar_U0R_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3);
instanceStruct.d_instanceVar_UAR_t_dX = (instanceStruct.instanceVar_UAR_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_UA1_i*d_delTemp_dX+instanceStruct.d_instanceVar_UA1_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_UAR_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3));
instanceStruct.instanceVar_UAR_t = (instanceStruct.instanceVar_UAR_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UA1_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3);
instanceStruct.d_instanceVar_UCR_t_dX = (instanceStruct.instanceVar_UCR_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_UC1_i*d_delTemp_dX+instanceStruct.d_instanceVar_UC1_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_UCR_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3));
instanceStruct.instanceVar_UCR_t = (instanceStruct.instanceVar_UCR_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_UC1_i*delTemp))-1.0E-6),1.0E-3));
}
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_UD1_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_UD1_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
instanceStruct.d_instanceVar_UDR_t_dX = (instanceStruct.instanceVar_UDR_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_UD1_i_dX)))+instanceStruct.d_instanceVar_UDR_i_dX*value_pow_0);
instanceStruct.instanceVar_UDR_t = (instanceStruct.instanceVar_UDR_i*value_pow_0);
}
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_UCSTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_UCSTE_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
instanceStruct.d_instanceVar_UCSR_t_dX = (instanceStruct.instanceVar_UCSR_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_UCSTE_i_dX)))+instanceStruct.d_instanceVar_UCSR_i_dX*value_pow_0);
instanceStruct.instanceVar_UCSR_t = (instanceStruct.instanceVar_UCSR_i*value_pow_0);
}
}
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_PRT_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_PRT_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_rdstemp_dX = ((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_PRT_i_dX)));
rdstemp = value_pow_0;
}
{
double value_pow_0 = pow(TRatio,(-instanceStruct.instanceVar_AT_i));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_AT_i)/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_VSAT_t_dX = (instanceStruct.instanceVar_VSAT_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_AT_i_dX))))+instanceStruct.d_instanceVar_VSAT_i_dX*value_pow_0);
VSAT_t = (instanceStruct.instanceVar_VSAT_i*value_pow_0);
}
if ((VSAT_t<100.0))
{
UserInfo(theInstance)  << "Warning: VSAT(%f) = %e is less than 100, setting it to 100." << " " << DevTemp << " " << VSAT_t << " " <<  std::endl; 
d_VSAT_t_dX = 0.0;
VSAT_t = 100.0;
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
double value_pow_0 = pow(TRatio,(-instanceStruct.instanceVar_AT_i));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_AT_i)/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
instanceStruct.d_instanceVar_VSATR_t_dX = (instanceStruct.instanceVar_VSATR_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_AT_i_dX))))+instanceStruct.d_instanceVar_VSATR_i_dX*value_pow_0);
instanceStruct.instanceVar_VSATR_t = (instanceStruct.instanceVar_VSATR_i*value_pow_0);
}
if ((instanceStruct.instanceVar_VSATR_t<100.0))
{
UserInfo(theInstance)  << "Warning: VSATR(%f) = %e is less than 100, setting it to 100." << " " << DevTemp << " " << instanceStruct.instanceVar_VSATR_t << " " <<  std::endl; 
instanceStruct.d_instanceVar_VSATR_t_dX = 0.0;
instanceStruct.instanceVar_VSATR_t = 100.0;
}
}
{
double value_pow_0 = pow(TRatio,(-instanceStruct.instanceVar_AT_i));
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_AT_i)/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_VSATCV_t_dX = (instanceStruct.instanceVar_VSATCV_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_AT_i_dX))))+instanceStruct.d_instanceVar_VSATCV_i_dX*value_pow_0);
VSATCV_t = (instanceStruct.instanceVar_VSATCV_i*value_pow_0);
}
if ((VSATCV_t<100.0))
{
UserInfo(theInstance)  << "Warning: VSATCV(%f) = %e is less than 100, setting it to 100." << " " << DevTemp << " " << VSATCV_t << " " <<  std::endl; 
d_VSATCV_t_dX = 0.0;
VSATCV_t = 100.0;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((1.0/instanceStruct.instanceVar_DELTA_i)*(1.0+(modelStruct.modelPar_TDELTA*delTemp)))-2.0),1.0E-3);
d_DELTA_t_dX = (-evaluator_hypsmooth_0.getDerivs((((1.0/instanceStruct.instanceVar_DELTA_i)*(1.0+(modelStruct.modelPar_TDELTA*delTemp)))-2.0),1.0E-3,((1.0/instanceStruct.instanceVar_DELTA_i)*(modelStruct.modelPar_TDELTA*d_delTemp_dX+modelStruct.d_modelPar_TDELTA_dX*delTemp)+(-instanceStruct.d_instanceVar_DELTA_i_dX/instanceStruct.instanceVar_DELTA_i/instanceStruct.instanceVar_DELTA_i)*(1.0+(modelStruct.modelPar_TDELTA*delTemp))),0.0)/(evaluator_hypsmooth_0.getValues((((1.0/instanceStruct.instanceVar_DELTA_i)*(1.0+(modelStruct.modelPar_TDELTA*delTemp)))-2.0),1.0E-3)+2.0)/(evaluator_hypsmooth_0.getValues((((1.0/instanceStruct.instanceVar_DELTA_i)*(1.0+(modelStruct.modelPar_TDELTA*delTemp)))-2.0),1.0E-3)+2.0));
DELTA_t = (1.0/(evaluator_hypsmooth_0.getValues((((1.0/instanceStruct.instanceVar_DELTA_i)*(1.0+(modelStruct.modelPar_TDELTA*delTemp)))-2.0),1.0E-3)+2.0));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3);
d_PTWG_t_dX = (instanceStruct.instanceVar_PTWG_i*evaluator_hypsmooth_0.getDerivs(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3,(-(instanceStruct.instanceVar_PTWGT_i*d_delTemp_dX+instanceStruct.d_instanceVar_PTWGT_i_dX*delTemp)),0.0)+instanceStruct.d_instanceVar_PTWG_i_dX*evaluator_hypsmooth_0.getValues(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3));
PTWG_t = (instanceStruct.instanceVar_PTWG_i*evaluator_hypsmooth_0.getValues(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3);
instanceStruct.d_instanceVar_PTWGR_t_dX = (instanceStruct.instanceVar_PTWGR_i*evaluator_hypsmooth_0.getDerivs(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3,(-(instanceStruct.instanceVar_PTWGT_i*d_delTemp_dX+instanceStruct.d_instanceVar_PTWGT_i_dX*delTemp)),0.0)+instanceStruct.d_instanceVar_PTWGR_i_dX*evaluator_hypsmooth_0.getValues(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3));
instanceStruct.instanceVar_PTWGR_t = (instanceStruct.instanceVar_PTWGR_i*evaluator_hypsmooth_0.getValues(((1.0-(instanceStruct.instanceVar_PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_A11_i*delTemp))-1.0E-6),1.0E-3);
d_A1_t_dX = (instanceStruct.instanceVar_A1_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_A11_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_A11_i*d_delTemp_dX+instanceStruct.d_instanceVar_A11_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_A1_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_A11_i*delTemp))-1.0E-6),1.0E-3));
A1_t = (instanceStruct.instanceVar_A1_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_A11_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_A21_i*delTemp))-1.0E-6),1.0E-3);
d_A2_t_dX = (instanceStruct.instanceVar_A2_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_A21_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_A21_i*d_delTemp_dX+instanceStruct.d_instanceVar_A21_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_A2_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_A21_i*delTemp))-1.0E-6),1.0E-3));
A2_t = (instanceStruct.instanceVar_A2_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_A21_i*delTemp))-1.0E-6),1.0E-3));
}
{
double value_pow_0 = pow(TRatio,instanceStruct.instanceVar_IIT_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_IIT_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_BETA0_t_dX = (instanceStruct.instanceVar_BETA0_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_IIT_i_dX)))+instanceStruct.d_instanceVar_BETA0_i_dX*value_pow_0);
BETA0_t = (instanceStruct.instanceVar_BETA0_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3);
d_BGIDL_t_dX = (instanceStruct.instanceVar_BGIDL_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_TGIDL_i*d_delTemp_dX+instanceStruct.d_instanceVar_TGIDL_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_BGIDL_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3));
BGIDL_t = (instanceStruct.instanceVar_BGIDL_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3);
d_BGISL_t_dX = (instanceStruct.instanceVar_BGISL_i*evaluator_hypsmooth_0.getDerivs(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3,(instanceStruct.instanceVar_TGIDL_i*d_delTemp_dX+instanceStruct.d_instanceVar_TGIDL_i_dX*delTemp),0.0)+instanceStruct.d_instanceVar_BGISL_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3));
BGISL_t = (instanceStruct.instanceVar_BGISL_i*evaluator_hypsmooth_0.getValues(((1.0+(instanceStruct.instanceVar_TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((instanceStruct.instanceVar_IGT_i*evaluator_lln_0.getValues(TRatio)));
d_igtemp_dX = evaluator_lexp_1.getDerivs((instanceStruct.instanceVar_IGT_i*evaluator_lln_0.getValues(TRatio)),(instanceStruct.instanceVar_IGT_i*evaluator_lln_0.getDerivs(TRatio,d_TRatio_dX)+instanceStruct.d_instanceVar_IGT_i_dX*evaluator_lln_0.getValues(TRatio)));
igtemp = evaluator_lexp_1.getValues((instanceStruct.instanceVar_IGT_i*evaluator_lln_0.getValues(TRatio)));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3);
d_CJS_t_dX = (modelStruct.modelPar_CJS*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJ*d_delTemp_dX+modelStruct.d_modelPar_TCJ_dX*delTemp),0.0)+modelStruct.d_modelPar_CJS_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
CJS_t = (modelStruct.modelPar_CJS*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3);
d_CJD_t_dX = (modelStruct.modelPar_CJD*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJ*d_delTemp_dX+modelStruct.d_modelPar_TCJ_dX*delTemp),0.0)+modelStruct.d_modelPar_CJD_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
CJD_t = (modelStruct.modelPar_CJD*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3);
d_CJSWS_t_dX = (modelStruct.modelPar_CJSWS*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSW*d_delTemp_dX+modelStruct.d_modelPar_TCJSW_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWS_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
CJSWS_t = (modelStruct.modelPar_CJSWS*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3);
d_CJSWD_t_dX = (modelStruct.modelPar_CJSWD*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSW*d_delTemp_dX+modelStruct.d_modelPar_TCJSW_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWD_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
CJSWD_t = (modelStruct.modelPar_CJSWD*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3);
d_CJSWGS_t_dX = (modelStruct.modelPar_CJSWGS*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSWG*d_delTemp_dX+modelStruct.d_modelPar_TCJSWG_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWGS_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
CJSWGS_t = (modelStruct.modelPar_CJSWGS*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3);
d_CJSWGD_t_dX = (modelStruct.modelPar_CJSWGD*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSWG*d_delTemp_dX+modelStruct.d_modelPar_TCJSWG_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWGD_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
CJSWGD_t = (modelStruct.modelPar_CJSWGD*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBS-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3);
d_PBS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBS-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBS_dX-(modelStruct.modelPar_TPB*d_delTemp_dX+modelStruct.d_modelPar_TPB_dX*delTemp)),0.0);
PBS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBS-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBD-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3);
d_PBD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBD-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBD_dX-(modelStruct.modelPar_TPB*d_delTemp_dX+modelStruct.d_modelPar_TPB_dX*delTemp)),0.0);
PBD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBD-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWS-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3);
d_PBSWS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWS-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWS_dX-(modelStruct.modelPar_TPBSW*d_delTemp_dX+modelStruct.d_modelPar_TPBSW_dX*delTemp)),0.0);
PBSWS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWS-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWD-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3);
d_PBSWD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWD-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWD_dX-(modelStruct.modelPar_TPBSW*d_delTemp_dX+modelStruct.d_modelPar_TPBSW_dX*delTemp)),0.0);
PBSWD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWD-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWGS-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3);
d_PBSWGS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWGS-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWGS_dX-(modelStruct.modelPar_TPBSWG*d_delTemp_dX+modelStruct.d_modelPar_TPBSWG_dX*delTemp)),0.0);
PBSWGS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWGS-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWGD-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3);
d_PBSWGD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWGD-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWGD_dX-(modelStruct.modelPar_TPBSWG*d_delTemp_dX+modelStruct.d_modelPar_TPBSWG_dX*delTemp)),0.0);
PBSWGD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWGD-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3)+0.01);
}
instanceStruct.d_instanceVar_T0_dX = (((Vtm0*d_Eg0_dX-Eg0*d_Vtm0_dX)/Vtm0/Vtm0)-((Vtm*d_Eg_dX-Eg*d_Vtm_dX)/Vtm/Vtm));
instanceStruct.instanceVar_T0 = ((Eg0/Vtm0)-(Eg/Vtm));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);
instanceStruct.d_instanceVar_T1_dX = evaluator_lln_0.getDerivs(TRatio,d_TRatio_dX);
instanceStruct.instanceVar_T1 = evaluator_lln_0.getValues(TRatio);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTIS*instanceStruct.instanceVar_T1))/modelStruct.modelPar_NJS));
d_T3_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTIS*instanceStruct.instanceVar_T1))/modelStruct.modelPar_NJS),((modelStruct.modelPar_NJS*(instanceStruct.d_instanceVar_T0_dX+(modelStruct.modelPar_XTIS*instanceStruct.d_instanceVar_T1_dX+modelStruct.d_modelPar_XTIS_dX*instanceStruct.instanceVar_T1))-(instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTIS*instanceStruct.instanceVar_T1))*modelStruct.d_modelPar_NJS_dX)/modelStruct.modelPar_NJS/modelStruct.modelPar_NJS));
T3 = evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTIS*instanceStruct.instanceVar_T1))/modelStruct.modelPar_NJS));
}
d_JSS_t_dX = (modelStruct.modelPar_JSS*d_T3_dX+modelStruct.d_modelPar_JSS_dX*T3);
JSS_t = (modelStruct.modelPar_JSS*T3);
d_JSWS_t_dX = (modelStruct.modelPar_JSWS*d_T3_dX+modelStruct.d_modelPar_JSWS_dX*T3);
JSWS_t = (modelStruct.modelPar_JSWS*T3);
d_JSWGS_t_dX = (modelStruct.modelPar_JSWGS*d_T3_dX+modelStruct.d_modelPar_JSWGS_dX*T3);
JSWGS_t = (modelStruct.modelPar_JSWGS*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTID*instanceStruct.instanceVar_T1))/modelStruct.modelPar_NJD));
d_T3_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTID*instanceStruct.instanceVar_T1))/modelStruct.modelPar_NJD),((modelStruct.modelPar_NJD*(instanceStruct.d_instanceVar_T0_dX+(modelStruct.modelPar_XTID*instanceStruct.d_instanceVar_T1_dX+modelStruct.d_modelPar_XTID_dX*instanceStruct.instanceVar_T1))-(instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTID*instanceStruct.instanceVar_T1))*modelStruct.d_modelPar_NJD_dX)/modelStruct.modelPar_NJD/modelStruct.modelPar_NJD));
T3 = evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0+(modelStruct.modelPar_XTID*instanceStruct.instanceVar_T1))/modelStruct.modelPar_NJD));
}
d_JSD_t_dX = (modelStruct.modelPar_JSD*d_T3_dX+modelStruct.d_modelPar_JSD_dX*T3);
JSD_t = (modelStruct.modelPar_JSD*T3);
d_JSWD_t_dX = (modelStruct.modelPar_JSWD*d_T3_dX+modelStruct.d_modelPar_JSWD_dX*T3);
JSWD_t = (modelStruct.modelPar_JSWD*T3);
d_JSWGD_t_dX = (modelStruct.modelPar_JSWGD*d_T3_dX+modelStruct.d_modelPar_JSWGD_dX*T3);
JSWGD_t = (modelStruct.modelPar_JSWGD*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1.0))/Vtm));
d_JTSS_t_dX = (modelStruct.modelPar_JTSS*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1.0))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSS)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSS_dX+d_Eg0_dX*modelStruct.modelPar_XTSS)*(TRatio-1.0))-((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1.0))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSS_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1.0))/Vtm)));
JTSS_t = (modelStruct.modelPar_JTSS*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1.0))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1.0))/Vtm));
d_JTSSWS_t_dX = (modelStruct.modelPar_JTSSWS*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1.0))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWS)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWS_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWS)*(TRatio-1.0))-((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1.0))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSSWS_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1.0))/Vtm)));
JTSSWS_t = (modelStruct.modelPar_JTSSWS*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1.0))/Vtm)));
}
{
double value_sqrt_0 = sqrt((modelStruct.modelPar_JTWEFF/instanceStruct.instanceVar_Weffcj));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_JTSSWGS_t_dX = ((modelStruct.modelPar_JTSSWGS*(value_sqrt_0+1.0))*evaluator_lexp_1.getDerivs((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWGS)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWGS_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWGS)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+(modelStruct.modelPar_JTSSWGS*deriv_sqrt_0_d0*(((instanceStruct.instanceVar_Weffcj*modelStruct.d_modelPar_JTWEFF_dX-modelStruct.modelPar_JTWEFF*instanceStruct.d_instanceVar_Weffcj_dX)/instanceStruct.instanceVar_Weffcj/instanceStruct.instanceVar_Weffcj))+modelStruct.d_modelPar_JTSSWGS_dX*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm)));
JTSSWGS_t = ((modelStruct.modelPar_JTSSWGS*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1.0))/Vtm));
d_JTSD_t_dX = (modelStruct.modelPar_JTSD*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1.0))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSD)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSD_dX+d_Eg0_dX*modelStruct.modelPar_XTSD)*(TRatio-1.0))-((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1.0))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSD_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1.0))/Vtm)));
JTSD_t = (modelStruct.modelPar_JTSD*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1.0))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1.0))/Vtm));
d_JTSSWD_t_dX = (modelStruct.modelPar_JTSSWD*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1.0))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWD)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWD_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWD)*(TRatio-1.0))-((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1.0))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSSWD_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1.0))/Vtm)));
JTSSWD_t = (modelStruct.modelPar_JTSSWD*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1.0))/Vtm)));
}
{
double value_sqrt_0 = sqrt((modelStruct.modelPar_JTWEFF/instanceStruct.instanceVar_Weffcj));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_JTSSWGD_t_dX = ((modelStruct.modelPar_JTSSWGD*(value_sqrt_0+1.0))*evaluator_lexp_1.getDerivs((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWGD)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWGD_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWGD)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+(modelStruct.modelPar_JTSSWGD*deriv_sqrt_0_d0*(((instanceStruct.instanceVar_Weffcj*modelStruct.d_modelPar_JTWEFF_dX-modelStruct.modelPar_JTWEFF*instanceStruct.d_instanceVar_Weffcj_dX)/instanceStruct.instanceVar_Weffcj/instanceStruct.instanceVar_Weffcj))+modelStruct.d_modelPar_JTSSWGD_dX*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm)));
JTSSWGD_t = ((modelStruct.modelPar_JTSSWGD*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTS*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTS*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTS*(modelStruct.modelPar_TNJTS*d_TRatio_dX+modelStruct.d_modelPar_TNJTS_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTS_dX*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0)))),0.0);
NJTS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTS*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSW*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSW_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSW*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSW*(modelStruct.modelPar_TNJTSSW*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSW_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSW_dX*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0)))),0.0);
NJTSSW_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSW*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSWG*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSWG_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSWG*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSWG*(modelStruct.modelPar_TNJTSSWG*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSWG_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSWG_dX*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0)))),0.0);
NJTSSWG_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSWG*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSD*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSD*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSD*(modelStruct.modelPar_TNJTSD*d_TRatio_dX+modelStruct.d_modelPar_TNJTSD_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSD_dX*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0)))),0.0);
NJTSD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSD*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSWD*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSWD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSWD*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSWD*(modelStruct.modelPar_TNJTSSWD*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSWD_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSWD_dX*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0)))),0.0);
NJTSSWD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSWD*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSWGD*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSWGD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSWGD*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSWGD*(modelStruct.modelPar_TNJTSSWGD*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSWGD_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSWGD_dX*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0)))),0.0);
NJTSSWGD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSWGD*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
if ((instanceStruct.instancePar_GEOMOD<9))
{
if (((instanceStruct.instancePar_NF%2)!=0))
{
instanceStruct.instanceVar_nuEndD = 1.0;
instanceStruct.instanceVar_nuEndS = 1.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF-1.0)/2.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.d_instanceVar_nuIntS_dX = instanceStruct.d_instanceVar_nuIntD_dX;
instanceStruct.instanceVar_nuIntS = instanceStruct.instanceVar_nuIntD;
}
else
{
if ((instanceStruct.instancePar_MINZ==1))
{
instanceStruct.instanceVar_nuEndD = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = (2.0*value_max_0);
}
instanceStruct.instanceVar_nuEndS = 0.0;
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = instanceStruct.instancePar_NF;
}
else
{
instanceStruct.instanceVar_nuEndD = 0.0;
instanceStruct.d_instanceVar_nuIntD_dX = 0.0;
instanceStruct.instanceVar_nuIntD = instanceStruct.instancePar_NF;
instanceStruct.instanceVar_nuEndS = 2.0;
{
double value_max_0 = std::max(((instanceStruct.instancePar_NF/2.0)-1.0),static_cast<double>(0.0));
instanceStruct.d_instanceVar_nuIntS_dX = 0.0;
instanceStruct.instanceVar_nuIntS = (2.0*value_max_0);
}
}
}
}
instanceStruct.d_instanceVar_T0_dX = (instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCIeff_dX);
instanceStruct.instanceVar_T0 = (instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCIeff);
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.d_instanceVar_DMCGeff_dX+instanceStruct.d_instanceVar_DMCGeff_dX);
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_DMCGeff+instanceStruct.instanceVar_DMCGeff);
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_DMDGeff_dX+instanceStruct.d_instanceVar_DMDGeff_dX);
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_DMDGeff+instanceStruct.instanceVar_DMDGeff);
d_PSiso_dX = ((instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX)+instanceStruct.d_instanceVar_Weffcj_dX);
PSiso = ((instanceStruct.instanceVar_T0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_Weffcj);
d_PDiso_dX = ((instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX)+instanceStruct.d_instanceVar_Weffcj_dX);
PDiso = ((instanceStruct.instanceVar_T0+instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_Weffcj);
d_PSsha_dX = instanceStruct.d_instanceVar_T1_dX;
PSsha = instanceStruct.instanceVar_T1;
d_PDsha_dX = instanceStruct.d_instanceVar_T1_dX;
PDsha = instanceStruct.instanceVar_T1;
d_PSmer_dX = instanceStruct.d_instanceVar_T2_dX;
PSmer = instanceStruct.instanceVar_T2;
d_PDmer_dX = instanceStruct.d_instanceVar_T2_dX;
PDmer = instanceStruct.instanceVar_T2;
d_ASiso_dX = (instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_Weffcj_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_Weffcj);
ASiso = (instanceStruct.instanceVar_T0*instanceStruct.instanceVar_Weffcj);
d_ADiso_dX = (instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_Weffcj_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_Weffcj);
ADiso = (instanceStruct.instanceVar_T0*instanceStruct.instanceVar_Weffcj);
d_ASsha_dX = (instanceStruct.instanceVar_DMCGeff*instanceStruct.d_instanceVar_Weffcj_dX+instanceStruct.d_instanceVar_DMCGeff_dX*instanceStruct.instanceVar_Weffcj);
ASsha = (instanceStruct.instanceVar_DMCGeff*instanceStruct.instanceVar_Weffcj);
d_ADsha_dX = (instanceStruct.instanceVar_DMCGeff*instanceStruct.d_instanceVar_Weffcj_dX+instanceStruct.d_instanceVar_DMCGeff_dX*instanceStruct.instanceVar_Weffcj);
ADsha = (instanceStruct.instanceVar_DMCGeff*instanceStruct.instanceVar_Weffcj);
d_ASmer_dX = (instanceStruct.instanceVar_DMDGeff*instanceStruct.d_instanceVar_Weffcj_dX+instanceStruct.d_instanceVar_DMDGeff_dX*instanceStruct.instanceVar_Weffcj);
ASmer = (instanceStruct.instanceVar_DMDGeff*instanceStruct.instanceVar_Weffcj);
d_ADmer_dX = (instanceStruct.instanceVar_DMDGeff*instanceStruct.d_instanceVar_Weffcj_dX+instanceStruct.d_instanceVar_DMDGeff_dX*instanceStruct.instanceVar_Weffcj);
ADmer = (instanceStruct.instanceVar_DMDGeff*instanceStruct.instanceVar_Weffcj);
if ( instanceStruct.instancePar_GEOMOD == (0))
{
d_temp_PSeff_dX = (instanceStruct.instanceVar_nuEndS*d_PSiso_dX+(instanceStruct.instanceVar_nuIntS*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha));
temp_PSeff = ((instanceStruct.instanceVar_nuEndS*PSiso)+(instanceStruct.instanceVar_nuIntS*PSsha));
d_temp_PDeff_dX = (instanceStruct.instanceVar_nuEndD*d_PDiso_dX+(instanceStruct.instanceVar_nuIntD*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha));
temp_PDeff = ((instanceStruct.instanceVar_nuEndD*PDiso)+(instanceStruct.instanceVar_nuIntD*PDsha));
d_temp_ASeff_dX = (instanceStruct.instanceVar_nuEndS*d_ASiso_dX+(instanceStruct.instanceVar_nuIntS*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha));
temp_ASeff = ((instanceStruct.instanceVar_nuEndS*ASiso)+(instanceStruct.instanceVar_nuIntS*ASsha));
d_temp_ADeff_dX = (instanceStruct.instanceVar_nuEndD*d_ADiso_dX+(instanceStruct.instanceVar_nuIntD*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha));
temp_ADeff = ((instanceStruct.instanceVar_nuEndD*ADiso)+(instanceStruct.instanceVar_nuIntD*ADsha));
}
else
if ( instanceStruct.instancePar_GEOMOD == (1))
{
d_temp_PSeff_dX = (instanceStruct.instanceVar_nuEndS*d_PSiso_dX+(instanceStruct.instanceVar_nuIntS*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha));
temp_PSeff = ((instanceStruct.instanceVar_nuEndS*PSiso)+(instanceStruct.instanceVar_nuIntS*PSsha));
d_temp_PDeff_dX = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha);
temp_PDeff = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*PDsha);
d_temp_ASeff_dX = (instanceStruct.instanceVar_nuEndS*d_ASiso_dX+(instanceStruct.instanceVar_nuIntS*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha));
temp_ASeff = ((instanceStruct.instanceVar_nuEndS*ASiso)+(instanceStruct.instanceVar_nuIntS*ASsha));
d_temp_ADeff_dX = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha);
temp_ADeff = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*ADsha);
}
else
if ( instanceStruct.instancePar_GEOMOD == (2))
{
d_temp_PSeff_dX = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha);
temp_PSeff = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*PSsha);
d_temp_PDeff_dX = (instanceStruct.instanceVar_nuEndD*d_PDiso_dX+(instanceStruct.instanceVar_nuIntD*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha));
temp_PDeff = ((instanceStruct.instanceVar_nuEndD*PDiso)+(instanceStruct.instanceVar_nuIntD*PDsha));
d_temp_ASeff_dX = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha);
temp_ASeff = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*ASsha);
d_temp_ADeff_dX = (instanceStruct.instanceVar_nuEndD*d_ADiso_dX+(instanceStruct.instanceVar_nuIntD*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha));
temp_ADeff = ((instanceStruct.instanceVar_nuEndD*ADiso)+(instanceStruct.instanceVar_nuIntD*ADsha));
}
else
if ( instanceStruct.instancePar_GEOMOD == (3))
{
d_temp_PSeff_dX = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha);
temp_PSeff = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*PSsha);
d_temp_PDeff_dX = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha);
temp_PDeff = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*PDsha);
d_temp_ASeff_dX = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha);
temp_ASeff = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*ASsha);
d_temp_ADeff_dX = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha);
temp_ADeff = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*ADsha);
}
else
if ( instanceStruct.instancePar_GEOMOD == (4))
{
d_temp_PSeff_dX = (instanceStruct.instanceVar_nuEndS*d_PSiso_dX+(instanceStruct.instanceVar_nuIntS*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha));
temp_PSeff = ((instanceStruct.instanceVar_nuEndS*PSiso)+(instanceStruct.instanceVar_nuIntS*PSsha));
d_temp_PDeff_dX = (instanceStruct.instanceVar_nuEndD*d_PDmer_dX+(instanceStruct.instanceVar_nuIntD*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha));
temp_PDeff = ((instanceStruct.instanceVar_nuEndD*PDmer)+(instanceStruct.instanceVar_nuIntD*PDsha));
d_temp_ASeff_dX = (instanceStruct.instanceVar_nuEndS*d_ASiso_dX+(instanceStruct.instanceVar_nuIntS*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha));
temp_ASeff = ((instanceStruct.instanceVar_nuEndS*ASiso)+(instanceStruct.instanceVar_nuIntS*ASsha));
d_temp_ADeff_dX = (instanceStruct.instanceVar_nuEndD*d_ADmer_dX+(instanceStruct.instanceVar_nuIntD*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha));
temp_ADeff = ((instanceStruct.instanceVar_nuEndD*ADmer)+(instanceStruct.instanceVar_nuIntD*ADsha));
}
else
if ( instanceStruct.instancePar_GEOMOD == (5))
{
d_temp_PSeff_dX = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha);
temp_PSeff = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*PSsha);
d_temp_PDeff_dX = (instanceStruct.instanceVar_nuEndD*d_PDmer_dX+(instanceStruct.instanceVar_nuIntD*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha));
temp_PDeff = ((instanceStruct.instanceVar_nuEndD*PDmer)+(instanceStruct.instanceVar_nuIntD*PDsha));
d_temp_ASeff_dX = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha);
temp_ASeff = ((instanceStruct.instanceVar_nuEndS+instanceStruct.instanceVar_nuIntS)*ASsha);
d_temp_ADeff_dX = (instanceStruct.instanceVar_nuEndD*d_ADmer_dX+(instanceStruct.instanceVar_nuIntD*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha));
temp_ADeff = ((instanceStruct.instanceVar_nuEndD*ADmer)+(instanceStruct.instanceVar_nuIntD*ADsha));
}
else
if ( instanceStruct.instancePar_GEOMOD == (6))
{
d_temp_PSeff_dX = (instanceStruct.instanceVar_nuEndS*d_PSmer_dX+(instanceStruct.instanceVar_nuIntS*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha));
temp_PSeff = ((instanceStruct.instanceVar_nuEndS*PSmer)+(instanceStruct.instanceVar_nuIntS*PSsha));
d_temp_PDeff_dX = (instanceStruct.instanceVar_nuEndD*d_PDiso_dX+(instanceStruct.instanceVar_nuIntD*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha));
temp_PDeff = ((instanceStruct.instanceVar_nuEndD*PDiso)+(instanceStruct.instanceVar_nuIntD*PDsha));
d_temp_ASeff_dX = (instanceStruct.instanceVar_nuEndS*d_ASmer_dX+(instanceStruct.instanceVar_nuIntS*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha));
temp_ASeff = ((instanceStruct.instanceVar_nuEndS*ASmer)+(instanceStruct.instanceVar_nuIntS*ASsha));
d_temp_ADeff_dX = (instanceStruct.instanceVar_nuEndD*d_ADiso_dX+(instanceStruct.instanceVar_nuIntD*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha));
temp_ADeff = ((instanceStruct.instanceVar_nuEndD*ADiso)+(instanceStruct.instanceVar_nuIntD*ADsha));
}
else
if ( instanceStruct.instancePar_GEOMOD == (7))
{
d_temp_PSeff_dX = (instanceStruct.instanceVar_nuEndS*d_PSmer_dX+(instanceStruct.instanceVar_nuIntS*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha));
temp_PSeff = ((instanceStruct.instanceVar_nuEndS*PSmer)+(instanceStruct.instanceVar_nuIntS*PSsha));
d_temp_PDeff_dX = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha);
temp_PDeff = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*PDsha);
d_temp_ASeff_dX = (instanceStruct.instanceVar_nuEndS*d_ASmer_dX+(instanceStruct.instanceVar_nuIntS*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha));
temp_ASeff = ((instanceStruct.instanceVar_nuEndS*ASmer)+(instanceStruct.instanceVar_nuIntS*ASsha));
d_temp_ADeff_dX = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha);
temp_ADeff = ((instanceStruct.instanceVar_nuEndD+instanceStruct.instanceVar_nuIntD)*ADsha);
}
else
if ( instanceStruct.instancePar_GEOMOD == (8))
{
d_temp_PSeff_dX = (instanceStruct.instanceVar_nuEndS*d_PSmer_dX+(instanceStruct.instanceVar_nuIntS*d_PSsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*PSsha));
temp_PSeff = ((instanceStruct.instanceVar_nuEndS*PSmer)+(instanceStruct.instanceVar_nuIntS*PSsha));
d_temp_PDeff_dX = (instanceStruct.instanceVar_nuEndD*d_PDmer_dX+(instanceStruct.instanceVar_nuIntD*d_PDsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*PDsha));
temp_PDeff = ((instanceStruct.instanceVar_nuEndD*PDmer)+(instanceStruct.instanceVar_nuIntD*PDsha));
d_temp_ASeff_dX = (instanceStruct.instanceVar_nuEndS*d_ASmer_dX+(instanceStruct.instanceVar_nuIntS*d_ASsha_dX+instanceStruct.d_instanceVar_nuIntS_dX*ASsha));
temp_ASeff = ((instanceStruct.instanceVar_nuEndS*ASmer)+(instanceStruct.instanceVar_nuIntS*ASsha));
d_temp_ADeff_dX = (instanceStruct.instanceVar_nuEndD*d_ADmer_dX+(instanceStruct.instanceVar_nuIntD*d_ADsha_dX+instanceStruct.d_instanceVar_nuIntD_dX*ADsha));
temp_ADeff = ((instanceStruct.instanceVar_nuEndD*ADmer)+(instanceStruct.instanceVar_nuIntD*ADsha));
}
else
if ( instanceStruct.instancePar_GEOMOD == (9))
{
d_temp_PSeff_dX = (d_PSiso_dX+(instanceStruct.instancePar_NF-1.0)*d_PSsha_dX);
temp_PSeff = (PSiso+((instanceStruct.instancePar_NF-1.0)*PSsha));
d_temp_PDeff_dX = instanceStruct.instancePar_NF*d_PDsha_dX;
temp_PDeff = (instanceStruct.instancePar_NF*PDsha);
d_temp_ASeff_dX = (d_ASiso_dX+(instanceStruct.instancePar_NF-1.0)*d_ASsha_dX);
temp_ASeff = (ASiso+((instanceStruct.instancePar_NF-1.0)*ASsha));
d_temp_ADeff_dX = instanceStruct.instancePar_NF*d_ADsha_dX;
temp_ADeff = (instanceStruct.instancePar_NF*ADsha);
}
else
if ( instanceStruct.instancePar_GEOMOD == (10))
{
d_temp_PSeff_dX = instanceStruct.instancePar_NF*d_PSsha_dX;
temp_PSeff = (instanceStruct.instancePar_NF*PSsha);
d_temp_PDeff_dX = (d_PDiso_dX+(instanceStruct.instancePar_NF-1.0)*d_PDsha_dX);
temp_PDeff = (PDiso+((instanceStruct.instancePar_NF-1.0)*PDsha));
d_temp_ASeff_dX = instanceStruct.instancePar_NF*d_ASsha_dX;
temp_ASeff = (instanceStruct.instancePar_NF*ASsha);
d_temp_ADeff_dX = (d_ADiso_dX+(instanceStruct.instancePar_NF-1.0)*d_ADsha_dX);
temp_ADeff = (ADiso+((instanceStruct.instancePar_NF-1.0)*ADsha));
}
else
{
d_temp_PSeff_dX = 0.0;
temp_PSeff = 0;
d_temp_PDeff_dX = 0.0;
temp_PDeff = 0;
d_temp_ASeff_dX = 0.0;
temp_ASeff = 0;
d_temp_ADeff_dX = 0.0;
temp_ADeff = 0;
}
}
if (instanceStruct.instancePar_given_AS)
{
d_ASeff_dX = ((instanceStruct.instancePar_AS*modelStruct.modelPar_WMLT)*modelStruct.d_modelPar_LMLT_dX+(instanceStruct.instancePar_AS*modelStruct.d_modelPar_WMLT_dX+instanceStruct.d_instancePar_AS_dX*modelStruct.modelPar_WMLT)*modelStruct.modelPar_LMLT);
ASeff = ((instanceStruct.instancePar_AS*modelStruct.modelPar_WMLT)*modelStruct.modelPar_LMLT);
}
else
{
d_ASeff_dX = d_temp_ASeff_dX;
ASeff = temp_ASeff;
}
if ((ASeff<0.0))
{
UserInfo(theInstance)  << "Warning: (instance %M) ASeff = %e is negative, set to zero." << " " << ASeff << " " <<  std::endl; 
d_ASeff_dX = 0.0;
ASeff = 0.0;
}
if (instanceStruct.instancePar_given_AD)
{
d_ADeff_dX = ((instanceStruct.instancePar_AD*modelStruct.modelPar_WMLT)*modelStruct.d_modelPar_LMLT_dX+(instanceStruct.instancePar_AD*modelStruct.d_modelPar_WMLT_dX+instanceStruct.d_instancePar_AD_dX*modelStruct.modelPar_WMLT)*modelStruct.modelPar_LMLT);
ADeff = ((instanceStruct.instancePar_AD*modelStruct.modelPar_WMLT)*modelStruct.modelPar_LMLT);
}
else
{
d_ADeff_dX = d_temp_ADeff_dX;
ADeff = temp_ADeff;
}
if ((ADeff<0.0))
{
UserInfo(theInstance)  << "Warning: (instance %M) ADeff = %e is negative, set to zero." << " " << ADeff << " " <<  std::endl; 
d_ADeff_dX = 0.0;
ADeff = 0.0;
}
if (instanceStruct.instancePar_given_PS)
{
if ((modelStruct.modelPar_PERMOD==0))
{
d_PSeff_dX = (instanceStruct.instancePar_PS*modelStruct.d_modelPar_WMLT_dX+instanceStruct.d_instancePar_PS_dX*modelStruct.modelPar_WMLT);
PSeff = (instanceStruct.instancePar_PS*modelStruct.modelPar_WMLT);
}
else
{
{
double value_max_0 = std::max(((instanceStruct.instancePar_PS*modelStruct.modelPar_WMLT)-(instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)),static_cast<double>(0.0));
double  deriv_max_0_d0 = ((((instanceStruct.instancePar_PS*modelStruct.modelPar_WMLT)-(instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF))>=0.0)?1.0:0.0);
d_PSeff_dX = (deriv_max_0_d0*(((instanceStruct.instancePar_PS*modelStruct.d_modelPar_WMLT_dX+instanceStruct.d_instancePar_PS_dX*modelStruct.modelPar_WMLT)-instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF)));
PSeff = value_max_0;
}
}
}
else
{
d_PSeff_dX = d_temp_PSeff_dX;
PSeff = temp_PSeff;
if ((PSeff<0.0))
{
UserInfo(theInstance)  << "Warning: (instance %M) PSeff = %e is negative.Set to 0.0" << " " << PSeff << " " <<  std::endl; 
d_PSeff_dX = 0.0;
PSeff = 0.0;
}
}
if (instanceStruct.instancePar_given_PD)
{
if ((modelStruct.modelPar_PERMOD==0))
{
d_PDeff_dX = (instanceStruct.instancePar_PD*modelStruct.d_modelPar_WMLT_dX+instanceStruct.d_instancePar_PD_dX*modelStruct.modelPar_WMLT);
PDeff = (instanceStruct.instancePar_PD*modelStruct.modelPar_WMLT);
}
else
{
{
double value_max_0 = std::max(((instanceStruct.instancePar_PD*modelStruct.modelPar_WMLT)-(instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)),static_cast<double>(0.0));
double  deriv_max_0_d0 = ((((instanceStruct.instancePar_PD*modelStruct.modelPar_WMLT)-(instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF))>=0.0)?1.0:0.0);
d_PDeff_dX = (deriv_max_0_d0*(((instanceStruct.instancePar_PD*modelStruct.d_modelPar_WMLT_dX+instanceStruct.d_instancePar_PD_dX*modelStruct.modelPar_WMLT)-instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF)));
PDeff = value_max_0;
}
}
}
else
{
d_PDeff_dX = d_temp_PDeff_dX;
PDeff = temp_PDeff;
if ((PDeff<0.0))
{
UserInfo(theInstance)  << "Warning: (instance %M) PDeff = %e is negative.Set to 0.0" << " " << PDeff << " " <<  std::endl; 
d_PDeff_dX = 0.0;
PDeff = 0.0;
}
}
d_Isbs_dX = (((ASeff*d_JSS_t_dX+d_ASeff_dX*JSS_t)+(PSeff*d_JSWS_t_dX+d_PSeff_dX*JSWS_t))+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*d_JSWGS_t_dX+instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF*JSWGS_t));
Isbs = (((ASeff*JSS_t)+(PSeff*JSWS_t))+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JSWGS_t));
if ((Isbs>0.0))
{
d_Nvtms_dX = (Vtm*modelStruct.d_modelPar_NJS_dX+d_Vtm_dX*modelStruct.modelPar_NJS);
Nvtms = (Vtm*modelStruct.modelPar_NJS);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-modelStruct.modelPar_BVS)/Nvtms));
d_XExpBVS_dX = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVS)/Nvtms))*modelStruct.d_modelPar_XJBVS_dX+evaluator_lexp_0.getDerivs(((-modelStruct.modelPar_BVS)/Nvtms),((Nvtms*(-modelStruct.d_modelPar_BVS_dX)-(-modelStruct.modelPar_BVS)*d_Nvtms_dX)/Nvtms/Nvtms))*modelStruct.modelPar_XJBVS);
XExpBVS = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVS)/Nvtms))*modelStruct.modelPar_XJBVS);
}
{
double value_max_0 = std::max((modelStruct.modelPar_IJTHSFWD/Isbs),static_cast<double>(10.0));
double  deriv_max_0_d0 = (((modelStruct.modelPar_IJTHSFWD/Isbs)>=10.0)?1.0:0.0);
instanceStruct.d_instanceVar_T2_dX = (deriv_max_0_d0*(((Isbs*modelStruct.d_modelPar_IJTHSFWD_dX-modelStruct.modelPar_IJTHSFWD*d_Isbs_dX)/Isbs/Isbs)));
instanceStruct.instanceVar_T2 = value_max_0;
}
d_Tb_dX = (instanceStruct.d_instanceVar_T2_dX-d_XExpBVS_dX);
Tb = ((1.0+instanceStruct.instanceVar_T2)-XExpBVS);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVS)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_VjsmFwd_dX = (Nvtms*evaluator_lln_1.getDerivs((0.5*(Tb+value_sqrt_0)),0.5*(d_Tb_dX+deriv_sqrt_0_d0*(((Tb*d_Tb_dX+d_Tb_dX*Tb)+4*d_XExpBVS_dX))))+d_Nvtms_dX*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
VjsmFwd = (Nvtms*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjsmFwd/Nvtms));
instanceStruct.d_instanceVar_T0_dX = evaluator_lexp_0.getDerivs((VjsmFwd/Nvtms),((Nvtms*d_VjsmFwd_dX-VjsmFwd*d_Nvtms_dX)/Nvtms/Nvtms));
instanceStruct.instanceVar_T0 = evaluator_lexp_0.getValues((VjsmFwd/Nvtms));
}
d_IVjsmFwd_dX = (Isbs*((instanceStruct.d_instanceVar_T0_dX-((instanceStruct.instanceVar_T0*d_XExpBVS_dX-XExpBVS*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0))+d_XExpBVS_dX)+d_Isbs_dX*(((instanceStruct.instanceVar_T0-(XExpBVS/instanceStruct.instanceVar_T0))+XExpBVS)-1.0));
IVjsmFwd = (Isbs*(((instanceStruct.instanceVar_T0-(XExpBVS/instanceStruct.instanceVar_T0))+XExpBVS)-1.0));
d_SslpFwd_dX = ((Nvtms*(Isbs*(instanceStruct.d_instanceVar_T0_dX+((instanceStruct.instanceVar_T0*d_XExpBVS_dX-XExpBVS*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0))+d_Isbs_dX*(instanceStruct.instanceVar_T0+(XExpBVS/instanceStruct.instanceVar_T0)))-(Isbs*(instanceStruct.instanceVar_T0+(XExpBVS/instanceStruct.instanceVar_T0)))*d_Nvtms_dX)/Nvtms/Nvtms);
SslpFwd = ((Isbs*(instanceStruct.instanceVar_T0+(XExpBVS/instanceStruct.instanceVar_T0)))/Nvtms);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_IJTHSREV/Isbs)-10.0),1.0E-3);
instanceStruct.d_instanceVar_T2_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_IJTHSREV/Isbs)-10.0),1.0E-3,((Isbs*modelStruct.d_modelPar_IJTHSREV_dX-modelStruct.modelPar_IJTHSREV*d_Isbs_dX)/Isbs/Isbs),0.0);
instanceStruct.instanceVar_T2 = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_IJTHSREV/Isbs)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVS));
d_VjsmRev_dX = ((-modelStruct.d_modelPar_BVS_dX)-(Nvtms*evaluator_lln_0.getDerivs(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVS),((modelStruct.modelPar_XJBVS*instanceStruct.d_instanceVar_T2_dX-(instanceStruct.instanceVar_T2-1.0)*modelStruct.d_modelPar_XJBVS_dX)/modelStruct.modelPar_XJBVS/modelStruct.modelPar_XJBVS))+d_Nvtms_dX*evaluator_lln_0.getValues(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVS))));
VjsmRev = ((-modelStruct.modelPar_BVS)-(Nvtms*evaluator_lln_0.getValues(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVS))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms));
instanceStruct.d_instanceVar_T1_dX = (modelStruct.modelPar_XJBVS*evaluator_lexp_0.getDerivs(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms),((Nvtms*(-(modelStruct.d_modelPar_BVS_dX+d_VjsmRev_dX))-(-(modelStruct.modelPar_BVS+VjsmRev))*d_Nvtms_dX)/Nvtms/Nvtms))+modelStruct.d_modelPar_XJBVS_dX*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms)));
instanceStruct.instanceVar_T1 = (modelStruct.modelPar_XJBVS*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms)));
}
d_IVjsmRev_dX = (Isbs*instanceStruct.d_instanceVar_T1_dX+d_Isbs_dX*(1.0+instanceStruct.instanceVar_T1));
IVjsmRev = (Isbs*(1.0+instanceStruct.instanceVar_T1));
d_SslpRev_dX = ((Nvtms*((-Isbs)*instanceStruct.d_instanceVar_T1_dX+(-d_Isbs_dX)*instanceStruct.instanceVar_T1)-((-Isbs)*instanceStruct.instanceVar_T1)*d_Nvtms_dX)/Nvtms/Nvtms);
SslpRev = (((-Isbs)*instanceStruct.instanceVar_T1)/Nvtms);
}
else
{
d_Nvtms_dX = 0.0;
Nvtms = 0;
d_XExpBVS_dX = 0.0;
XExpBVS = 0;
d_VjsmFwd_dX = 0.0;
VjsmFwd = 0;
d_IVjsmFwd_dX = 0.0;
IVjsmFwd = 0;
d_SslpFwd_dX = 0.0;
SslpFwd = 0;
d_VjsmRev_dX = 0.0;
VjsmRev = 0;
d_IVjsmRev_dX = 0.0;
IVjsmRev = 0;
d_SslpRev_dX = 0.0;
SslpRev = 0;
}
d_Isbd_dX = (((ADeff*d_JSD_t_dX+d_ADeff_dX*JSD_t)+(PDeff*d_JSWD_t_dX+d_PDeff_dX*JSWD_t))+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*d_JSWGD_t_dX+instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF*JSWGD_t));
Isbd = (((ADeff*JSD_t)+(PDeff*JSWD_t))+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JSWGD_t));
if ((Isbd>0.0))
{
d_Nvtmd_dX = (Vtm*modelStruct.d_modelPar_NJD_dX+d_Vtm_dX*modelStruct.modelPar_NJD);
Nvtmd = (Vtm*modelStruct.modelPar_NJD);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-modelStruct.modelPar_BVD)/Nvtmd));
d_XExpBVD_dX = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVD)/Nvtmd))*modelStruct.d_modelPar_XJBVD_dX+evaluator_lexp_0.getDerivs(((-modelStruct.modelPar_BVD)/Nvtmd),((Nvtmd*(-modelStruct.d_modelPar_BVD_dX)-(-modelStruct.modelPar_BVD)*d_Nvtmd_dX)/Nvtmd/Nvtmd))*modelStruct.modelPar_XJBVD);
XExpBVD = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVD)/Nvtmd))*modelStruct.modelPar_XJBVD);
}
{
double value_max_0 = std::max((modelStruct.modelPar_IJTHDFWD/Isbd),static_cast<double>(10.0));
double  deriv_max_0_d0 = (((modelStruct.modelPar_IJTHDFWD/Isbd)>=10.0)?1.0:0.0);
instanceStruct.d_instanceVar_T2_dX = (deriv_max_0_d0*(((Isbd*modelStruct.d_modelPar_IJTHDFWD_dX-modelStruct.modelPar_IJTHDFWD*d_Isbd_dX)/Isbd/Isbd)));
instanceStruct.instanceVar_T2 = value_max_0;
}
d_Tb_dX = (instanceStruct.d_instanceVar_T2_dX-d_XExpBVD_dX);
Tb = ((1.0+instanceStruct.instanceVar_T2)-XExpBVD);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVD)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_VjdmFwd_dX = (Nvtmd*evaluator_lln_1.getDerivs((0.5*(Tb+value_sqrt_0)),0.5*(d_Tb_dX+deriv_sqrt_0_d0*(((Tb*d_Tb_dX+d_Tb_dX*Tb)+4*d_XExpBVD_dX))))+d_Nvtmd_dX*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
VjdmFwd = (Nvtmd*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjdmFwd/Nvtmd));
instanceStruct.d_instanceVar_T0_dX = evaluator_lexp_0.getDerivs((VjdmFwd/Nvtmd),((Nvtmd*d_VjdmFwd_dX-VjdmFwd*d_Nvtmd_dX)/Nvtmd/Nvtmd));
instanceStruct.instanceVar_T0 = evaluator_lexp_0.getValues((VjdmFwd/Nvtmd));
}
d_IVjdmFwd_dX = (Isbd*((instanceStruct.d_instanceVar_T0_dX-((instanceStruct.instanceVar_T0*d_XExpBVD_dX-XExpBVD*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0))+d_XExpBVD_dX)+d_Isbd_dX*(((instanceStruct.instanceVar_T0-(XExpBVD/instanceStruct.instanceVar_T0))+XExpBVD)-1.0));
IVjdmFwd = (Isbd*(((instanceStruct.instanceVar_T0-(XExpBVD/instanceStruct.instanceVar_T0))+XExpBVD)-1.0));
d_DslpFwd_dX = ((Nvtmd*(Isbd*(instanceStruct.d_instanceVar_T0_dX+((instanceStruct.instanceVar_T0*d_XExpBVD_dX-XExpBVD*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0))+d_Isbd_dX*(instanceStruct.instanceVar_T0+(XExpBVD/instanceStruct.instanceVar_T0)))-(Isbd*(instanceStruct.instanceVar_T0+(XExpBVD/instanceStruct.instanceVar_T0)))*d_Nvtmd_dX)/Nvtmd/Nvtmd);
DslpFwd = ((Isbd*(instanceStruct.instanceVar_T0+(XExpBVD/instanceStruct.instanceVar_T0)))/Nvtmd);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_IJTHDREV/Isbd)-10.0),1.0E-3);
instanceStruct.d_instanceVar_T2_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_IJTHDREV/Isbd)-10.0),1.0E-3,((Isbd*modelStruct.d_modelPar_IJTHDREV_dX-modelStruct.modelPar_IJTHDREV*d_Isbd_dX)/Isbd/Isbd),0.0);
instanceStruct.instanceVar_T2 = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_IJTHDREV/Isbd)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVD));
d_VjdmRev_dX = ((-modelStruct.d_modelPar_BVD_dX)-(Nvtmd*evaluator_lln_0.getDerivs(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVD),((modelStruct.modelPar_XJBVD*instanceStruct.d_instanceVar_T2_dX-(instanceStruct.instanceVar_T2-1.0)*modelStruct.d_modelPar_XJBVD_dX)/modelStruct.modelPar_XJBVD/modelStruct.modelPar_XJBVD))+d_Nvtmd_dX*evaluator_lln_0.getValues(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVD))));
VjdmRev = ((-modelStruct.modelPar_BVD)-(Nvtmd*evaluator_lln_0.getValues(((instanceStruct.instanceVar_T2-1.0)/modelStruct.modelPar_XJBVD))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd));
instanceStruct.d_instanceVar_T1_dX = (modelStruct.modelPar_XJBVD*evaluator_lexp_0.getDerivs(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd),((Nvtmd*(-(modelStruct.d_modelPar_BVD_dX+d_VjdmRev_dX))-(-(modelStruct.modelPar_BVD+VjdmRev))*d_Nvtmd_dX)/Nvtmd/Nvtmd))+modelStruct.d_modelPar_XJBVD_dX*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd)));
instanceStruct.instanceVar_T1 = (modelStruct.modelPar_XJBVD*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd)));
}
d_IVjdmRev_dX = (Isbd*instanceStruct.d_instanceVar_T1_dX+d_Isbd_dX*(1.0+instanceStruct.instanceVar_T1));
IVjdmRev = (Isbd*(1.0+instanceStruct.instanceVar_T1));
d_DslpRev_dX = ((Nvtmd*((-Isbd)*instanceStruct.d_instanceVar_T1_dX+(-d_Isbd_dX)*instanceStruct.instanceVar_T1)-((-Isbd)*instanceStruct.instanceVar_T1)*d_Nvtmd_dX)/Nvtmd/Nvtmd);
DslpRev = (((-Isbd)*instanceStruct.instanceVar_T1)/Nvtmd);
}
else
{
d_Nvtmd_dX = 0.0;
Nvtmd = 0;
d_XExpBVD_dX = 0.0;
XExpBVD = 0;
d_VjdmFwd_dX = 0.0;
VjdmFwd = 0;
d_IVjdmFwd_dX = 0.0;
IVjdmFwd = 0;
d_DslpFwd_dX = 0.0;
DslpFwd = 0;
d_VjdmRev_dX = 0.0;
VjdmRev = 0;
d_IVjdmRev_dX = 0.0;
IVjdmRev = 0;
d_DslpRev_dX = 0.0;
DslpRev = 0;
}
d_Czbs_dX = (CJS_t*d_ASeff_dX+d_CJS_t_dX*ASeff);
Czbs = (CJS_t*ASeff);
d_Czbssw_dX = (CJSWS_t*d_PSeff_dX+d_CJSWS_t_dX*PSeff);
Czbssw = (CJSWS_t*PSeff);
d_Czbsswg_dX = (CJSWGS_t*instanceStruct.d_instanceVar_Weffcj_dX+d_CJSWGS_t_dX*instanceStruct.instanceVar_Weffcj)*instanceStruct.instancePar_NF;
Czbsswg = ((CJSWGS_t*instanceStruct.instanceVar_Weffcj)*instanceStruct.instancePar_NF);
d_Czbd_dX = (CJD_t*d_ADeff_dX+d_CJD_t_dX*ADeff);
Czbd = (CJD_t*ADeff);
d_Czbdsw_dX = (CJSWD_t*d_PDeff_dX+d_CJSWD_t_dX*PDeff);
Czbdsw = (CJSWD_t*PDeff);
d_Czbdswg_dX = (CJSWGD_t*instanceStruct.d_instanceVar_Weffcj_dX+d_CJSWGD_t_dX*instanceStruct.instanceVar_Weffcj)*instanceStruct.instancePar_NF;
Czbdswg = ((CJSWGD_t*instanceStruct.instanceVar_Weffcj)*instanceStruct.instancePar_NF);
if ((((((modelStruct.modelPar_KU0!=0)||(modelStruct.modelPar_KVSAT!=0))||(modelStruct.modelPar_KVTH0!=0))||(modelStruct.modelPar_STK2!=0))||(modelStruct.modelPar_STETA0!=0)))
{
{
double value_pow_0 = pow(instanceStruct.instanceVar_Lnew,modelStruct.modelPar_LLODKU0);
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Lnew == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_LLODKU0/instanceStruct.instanceVar_Lnew));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Lnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Lnew)*value_pow_0);
instanceStruct.d_instanceVar_T0_dX = ((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Lnew_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_LLODKU0_dX)));
instanceStruct.instanceVar_T0 = value_pow_0;
}
d_W_tmp_stress_dX = (instanceStruct.d_instanceVar_Wnew_dX+modelStruct.d_modelPar_WLOD_dX);
W_tmp_stress = (instanceStruct.instanceVar_Wnew+modelStruct.modelPar_WLOD);
{
double value_pow_0 = pow(W_tmp_stress,modelStruct.modelPar_WLODKU0);
double  deriv_pow_0_d0 = ((W_tmp_stress == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_WLODKU0/W_tmp_stress));
double  deriv_pow_0_d1 = (W_tmp_stress == 0.0)?0.0:(log(W_tmp_stress)*value_pow_0);
instanceStruct.d_instanceVar_T1_dX = ((deriv_pow_0_d0*(d_W_tmp_stress_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_WLODKU0_dX)));
instanceStruct.instanceVar_T1 = value_pow_0;
}
d_tmp1_stress_dX = ((((instanceStruct.instanceVar_T0*modelStruct.d_modelPar_LKU0_dX-modelStruct.modelPar_LKU0*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)+((instanceStruct.instanceVar_T1*modelStruct.d_modelPar_WKU0_dX-modelStruct.modelPar_WKU0*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1))+(((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)*modelStruct.d_modelPar_PKU0_dX-modelStruct.modelPar_PKU0*(instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T1))/(instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)/(instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)));
tmp1_stress = (((modelStruct.modelPar_LKU0/instanceStruct.instanceVar_T0)+(modelStruct.modelPar_WKU0/instanceStruct.instanceVar_T1))+(modelStruct.modelPar_PKU0/(instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)));
d_kstress_u0_dX = d_tmp1_stress_dX;
kstress_u0 = (1.0+tmp1_stress);
{
double value_pow_0 = pow(instanceStruct.instanceVar_Lnew,modelStruct.modelPar_LLODVTH);
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Lnew == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_LLODVTH/instanceStruct.instanceVar_Lnew));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Lnew == 0.0)?0.0:(log(instanceStruct.instanceVar_Lnew)*value_pow_0);
instanceStruct.d_instanceVar_T0_dX = ((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Lnew_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_LLODVTH_dX)));
instanceStruct.instanceVar_T0 = value_pow_0;
}
{
double value_pow_0 = pow(W_tmp_stress,modelStruct.modelPar_WLODVTH);
double  deriv_pow_0_d0 = ((W_tmp_stress == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_WLODVTH/W_tmp_stress));
double  deriv_pow_0_d1 = (W_tmp_stress == 0.0)?0.0:(log(W_tmp_stress)*value_pow_0);
instanceStruct.d_instanceVar_T1_dX = ((deriv_pow_0_d0*(d_W_tmp_stress_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_WLODVTH_dX)));
instanceStruct.instanceVar_T1 = value_pow_0;
}
d_tmp1_stress_vth_dX = ((((instanceStruct.instanceVar_T0*modelStruct.d_modelPar_LKVTH0_dX-modelStruct.modelPar_LKVTH0*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)+((instanceStruct.instanceVar_T1*modelStruct.d_modelPar_WKVTH0_dX-modelStruct.modelPar_WKVTH0*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1))+(((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)*modelStruct.d_modelPar_PKVTH0_dX-modelStruct.modelPar_PKVTH0*(instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T1))/(instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)/(instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)));
tmp1_stress_vth = (((modelStruct.modelPar_LKVTH0/instanceStruct.instanceVar_T0)+(modelStruct.modelPar_WKVTH0/instanceStruct.instanceVar_T1))+(modelStruct.modelPar_PKVTH0/(instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T1)));
d_kstress_vth0_dX = d_tmp1_stress_vth_dX;
kstress_vth0 = (1.0+tmp1_stress_vth);
instanceStruct.d_instanceVar_T0_dX = d_TRatio_dX;
instanceStruct.instanceVar_T0 = (TRatio-1.0);
d_ku0_temp_dX = (kstress_u0*(modelStruct.modelPar_TKU0*instanceStruct.d_instanceVar_T0_dX+modelStruct.d_modelPar_TKU0_dX*instanceStruct.instanceVar_T0)+d_kstress_u0_dX*(1.0+(modelStruct.modelPar_TKU0*instanceStruct.instanceVar_T0)));
ku0_temp = ((kstress_u0*(1.0+(modelStruct.modelPar_TKU0*instanceStruct.instanceVar_T0)))+1.0e-9);
d_Inv_sa_dX = 0.0;
Inv_sa = 0;
d_Inv_sb_dX = 0.0;
Inv_sb = 0;
for (i=0;(i<instanceStruct.instancePar_NF);i=(i+1) )//Begin block forloop
{
instanceStruct.d_instanceVar_T0_dX = (-(1.0/instanceStruct.instancePar_NF)*((instanceStruct.d_instancePar_SA_dX+0.5*instanceStruct.d_instanceVar_L_mult_dX)+i*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instanceVar_L_mult_dX))/((instanceStruct.instancePar_SA+(0.5*instanceStruct.instanceVar_L_mult))+(i*(instanceStruct.instancePar_SD+instanceStruct.instanceVar_L_mult)))/((instanceStruct.instancePar_SA+(0.5*instanceStruct.instanceVar_L_mult))+(i*(instanceStruct.instancePar_SD+instanceStruct.instanceVar_L_mult))));
instanceStruct.instanceVar_T0 = ((1.0/instanceStruct.instancePar_NF)/((instanceStruct.instancePar_SA+(0.5*instanceStruct.instanceVar_L_mult))+(i*(instanceStruct.instancePar_SD+instanceStruct.instanceVar_L_mult))));
instanceStruct.d_instanceVar_T1_dX = (-(1.0/instanceStruct.instancePar_NF)*((instanceStruct.d_instancePar_SB_dX+0.5*instanceStruct.d_instanceVar_L_mult_dX)+i*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instanceVar_L_mult_dX))/((instanceStruct.instancePar_SB+(0.5*instanceStruct.instanceVar_L_mult))+(i*(instanceStruct.instancePar_SD+instanceStruct.instanceVar_L_mult)))/((instanceStruct.instancePar_SB+(0.5*instanceStruct.instanceVar_L_mult))+(i*(instanceStruct.instancePar_SD+instanceStruct.instanceVar_L_mult))));
instanceStruct.instanceVar_T1 = ((1.0/instanceStruct.instancePar_NF)/((instanceStruct.instancePar_SB+(0.5*instanceStruct.instanceVar_L_mult))+(i*(instanceStruct.instancePar_SD+instanceStruct.instanceVar_L_mult))));
d_Inv_sa_dX = (d_Inv_sa_dX+instanceStruct.d_instanceVar_T0_dX);
Inv_sa = (Inv_sa+instanceStruct.instanceVar_T0);
d_Inv_sb_dX = (d_Inv_sb_dX+instanceStruct.d_instanceVar_T1_dX);
Inv_sb = (Inv_sb+instanceStruct.instanceVar_T1);
}
// End block forloop
d_Inv_saref_dX = (-(modelStruct.d_modelPar_SAREF_dX+0.5*instanceStruct.d_instanceVar_L_mult_dX)/(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instanceVar_L_mult))/(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instanceVar_L_mult)));
Inv_saref = (1.0/(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instanceVar_L_mult)));
d_Inv_sbref_dX = (-(modelStruct.d_modelPar_SBREF_dX+0.5*instanceStruct.d_instanceVar_L_mult_dX)/(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instanceVar_L_mult))/(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instanceVar_L_mult)));
Inv_sbref = (1.0/(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instanceVar_L_mult)));
d_Inv_odref_dX = (d_Inv_saref_dX+d_Inv_sbref_dX);
Inv_odref = (Inv_saref+Inv_sbref);
d_rho_ref_dX = ((modelStruct.modelPar_KU0/ku0_temp)*d_Inv_odref_dX+((ku0_temp*modelStruct.d_modelPar_KU0_dX-modelStruct.modelPar_KU0*d_ku0_temp_dX)/ku0_temp/ku0_temp)*Inv_odref);
rho_ref = ((modelStruct.modelPar_KU0/ku0_temp)*Inv_odref);
d_Inv_od_dX = (d_Inv_sa_dX+d_Inv_sb_dX);
Inv_od = (Inv_sa+Inv_sb);
d_rho_dX = ((modelStruct.modelPar_KU0/ku0_temp)*d_Inv_od_dX+((ku0_temp*modelStruct.d_modelPar_KU0_dX-modelStruct.modelPar_KU0*d_ku0_temp_dX)/ku0_temp/ku0_temp)*Inv_od);
rho = ((modelStruct.modelPar_KU0/ku0_temp)*Inv_od);
d_mu0_mult_dX = (((1.0+rho_ref)*d_rho_dX-(1.0+rho)*d_rho_ref_dX)/(1.0+rho_ref)/(1.0+rho_ref));
mu0_mult = ((1.0+rho)/(1.0+rho_ref));
d_vsat_mult_dX = (((1.0+(rho_ref*modelStruct.modelPar_KVSAT))*(rho*modelStruct.d_modelPar_KVSAT_dX+d_rho_dX*modelStruct.modelPar_KVSAT)-(1.0+(rho*modelStruct.modelPar_KVSAT))*(rho_ref*modelStruct.d_modelPar_KVSAT_dX+d_rho_ref_dX*modelStruct.modelPar_KVSAT))/(1.0+(rho_ref*modelStruct.modelPar_KVSAT))/(1.0+(rho_ref*modelStruct.modelPar_KVSAT)));
vsat_mult = ((1.0+(rho*modelStruct.modelPar_KVSAT))/(1.0+(rho_ref*modelStruct.modelPar_KVSAT)));
d_vth0_stress_dX = ((modelStruct.modelPar_KVTH0/kstress_vth0)*(d_Inv_od_dX-d_Inv_odref_dX)+((kstress_vth0*modelStruct.d_modelPar_KVTH0_dX-modelStruct.modelPar_KVTH0*d_kstress_vth0_dX)/kstress_vth0/kstress_vth0)*(Inv_od-Inv_odref));
vth0_stress = ((modelStruct.modelPar_KVTH0/kstress_vth0)*(Inv_od-Inv_odref));
{
double value_pow_0 = pow(kstress_vth0,modelStruct.modelPar_LODK2);
double  deriv_pow_0_d0 = ((kstress_vth0 == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_LODK2/kstress_vth0));
double  deriv_pow_0_d1 = (kstress_vth0 == 0.0)?0.0:(log(kstress_vth0)*value_pow_0);
d_k2_stress_dX = ((modelStruct.modelPar_STK2/value_pow_0)*(d_Inv_od_dX-d_Inv_odref_dX)+((value_pow_0*modelStruct.d_modelPar_STK2_dX-modelStruct.modelPar_STK2*((deriv_pow_0_d0*(d_kstress_vth0_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_LODK2_dX))))/value_pow_0/value_pow_0)*(Inv_od-Inv_odref));
k2_stress = ((modelStruct.modelPar_STK2/value_pow_0)*(Inv_od-Inv_odref));
}
{
double value_pow_0 = pow(kstress_vth0,modelStruct.modelPar_LODETA0);
double  deriv_pow_0_d0 = ((kstress_vth0 == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_LODETA0/kstress_vth0));
double  deriv_pow_0_d1 = (kstress_vth0 == 0.0)?0.0:(log(kstress_vth0)*value_pow_0);
d_eta_stress_dX = ((modelStruct.modelPar_STETA0/value_pow_0)*(d_Inv_od_dX-d_Inv_odref_dX)+((value_pow_0*modelStruct.d_modelPar_STETA0_dX-modelStruct.modelPar_STETA0*((deriv_pow_0_d0*(d_kstress_vth0_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_LODETA0_dX))))/value_pow_0/value_pow_0)*(Inv_od-Inv_odref));
eta_stress = ((modelStruct.modelPar_STETA0/value_pow_0)*(Inv_od-Inv_odref));
}
d_U0_t_dX = (U0_t*d_mu0_mult_dX+d_U0_t_dX*mu0_mult);
U0_t = (U0_t*mu0_mult);
d_VSAT_t_dX = (VSAT_t*d_vsat_mult_dX+d_VSAT_t_dX*vsat_mult);
VSAT_t = (VSAT_t*vsat_mult);
instanceStruct.d_instanceVar_K2_i_dX = (instanceStruct.d_instanceVar_K2_i_dX+d_k2_stress_dX);
instanceStruct.instanceVar_K2_i = (instanceStruct.instanceVar_K2_i+k2_stress);
d_ETA0_t_dX = (d_ETA0_t_dX+d_eta_stress_dX);
ETA0_t = (ETA0_t+eta_stress);
}
else
{
d_vth0_stress_dX = 0.0;
vth0_stress = 0;
}
d_local_sca_dX = 0.0;
local_sca = 0.0;
d_local_scb_dX = 0.0;
local_scb = 0.0;
d_local_scc_dX = 0.0;
local_scc = 0.0;
if (modelStruct.modelPar_WPEMOD)
{
d_Wdrn_dX = (instanceStruct.d_instancePar_W_dX/instanceStruct.instancePar_NF);
Wdrn = (instanceStruct.instancePar_W/instanceStruct.instancePar_NF);
d_local_sca_dX = 0.0;
local_sca = instanceStruct.instancePar_SCA;
d_local_scb_dX = 0.0;
local_scb = instanceStruct.instancePar_SCB;
d_local_scc_dX = 0.0;
local_scc = instanceStruct.instancePar_SCC;
if ((((!instanceStruct.instancePar_given_SCA)&&(!instanceStruct.instancePar_given_SCB))&&(!instanceStruct.instancePar_given_SCC)))
{
if ((instanceStruct.instancePar_given_SC&&(instanceStruct.instancePar_SC>0.0)))
{
instanceStruct.d_instanceVar_T1_dX = d_Wdrn_dX;
instanceStruct.instanceVar_T1 = (instanceStruct.instancePar_SC+Wdrn);
instanceStruct.d_instanceVar_T2_dX = (-modelStruct.d_modelPar_SCREF_dX/modelStruct.modelPar_SCREF/modelStruct.modelPar_SCREF);
instanceStruct.instanceVar_T2 = (1.0/modelStruct.modelPar_SCREF);
d_local_sca_dX = (((instanceStruct.instancePar_SC*instanceStruct.instanceVar_T1)*(modelStruct.modelPar_SCREF*modelStruct.d_modelPar_SCREF_dX+modelStruct.d_modelPar_SCREF_dX*modelStruct.modelPar_SCREF)-(modelStruct.modelPar_SCREF*modelStruct.modelPar_SCREF)*instanceStruct.instancePar_SC*instanceStruct.d_instanceVar_T1_dX)/(instanceStruct.instancePar_SC*instanceStruct.instanceVar_T1)/(instanceStruct.instancePar_SC*instanceStruct.instanceVar_T1));
local_sca = ((modelStruct.modelPar_SCREF*modelStruct.modelPar_SCREF)/(instanceStruct.instancePar_SC*instanceStruct.instanceVar_T1));
{
double value_exp_0 = exp((((-10.0)*instanceStruct.instancePar_SC)*instanceStruct.instanceVar_T2));
double value_exp_1 = exp((((-10.0)*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_local_scb_dX = ((Wdrn*((((0.1*instanceStruct.instancePar_SC)+(0.01*modelStruct.modelPar_SCREF))*deriv_exp_0_d0*(((-10.0)*instanceStruct.instancePar_SC)*instanceStruct.d_instanceVar_T2_dX)+0.01*modelStruct.d_modelPar_SCREF_dX*value_exp_0)-(((0.1*instanceStruct.instanceVar_T1)+(0.01*modelStruct.modelPar_SCREF))*deriv_exp_1_d0*((((-10.0)*instanceStruct.instanceVar_T1)*instanceStruct.d_instanceVar_T2_dX+(-10.0)*instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2))+(0.1*instanceStruct.d_instanceVar_T1_dX+0.01*modelStruct.d_modelPar_SCREF_dX)*value_exp_1))-((((0.1*instanceStruct.instancePar_SC)+(0.01*modelStruct.modelPar_SCREF))*value_exp_0)-(((0.1*instanceStruct.instanceVar_T1)+(0.01*modelStruct.modelPar_SCREF))*value_exp_1))*d_Wdrn_dX)/Wdrn/Wdrn);
local_scb = (((((0.1*instanceStruct.instancePar_SC)+(0.01*modelStruct.modelPar_SCREF))*value_exp_0)-(((0.1*instanceStruct.instanceVar_T1)+(0.01*modelStruct.modelPar_SCREF))*value_exp_1))/Wdrn);
}
{
double value_exp_0 = exp((((-20.0)*instanceStruct.instancePar_SC)*instanceStruct.instanceVar_T2));
double value_exp_1 = exp((((-20.0)*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_local_scc_dX = ((Wdrn*((((0.05*instanceStruct.instancePar_SC)+(0.0025*modelStruct.modelPar_SCREF))*deriv_exp_0_d0*(((-20.0)*instanceStruct.instancePar_SC)*instanceStruct.d_instanceVar_T2_dX)+0.0025*modelStruct.d_modelPar_SCREF_dX*value_exp_0)-(((0.05*instanceStruct.instanceVar_T1)+(0.0025*modelStruct.modelPar_SCREF))*deriv_exp_1_d0*((((-20.0)*instanceStruct.instanceVar_T1)*instanceStruct.d_instanceVar_T2_dX+(-20.0)*instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2))+(0.05*instanceStruct.d_instanceVar_T1_dX+0.0025*modelStruct.d_modelPar_SCREF_dX)*value_exp_1))-((((0.05*instanceStruct.instancePar_SC)+(0.0025*modelStruct.modelPar_SCREF))*value_exp_0)-(((0.05*instanceStruct.instanceVar_T1)+(0.0025*modelStruct.modelPar_SCREF))*value_exp_1))*d_Wdrn_dX)/Wdrn/Wdrn);
local_scc = (((((0.05*instanceStruct.instancePar_SC)+(0.0025*modelStruct.modelPar_SCREF))*value_exp_0)-(((0.05*instanceStruct.instanceVar_T1)+(0.0025*modelStruct.modelPar_SCREF))*value_exp_1))/Wdrn);
}
}
else
{
}
}
}
d_vth0_well_dX = (instanceStruct.instanceVar_KVTH0WE_i*((d_local_sca_dX+(modelStruct.modelPar_WEB*d_local_scb_dX+modelStruct.d_modelPar_WEB_dX*local_scb))+(modelStruct.modelPar_WEC*d_local_scc_dX+modelStruct.d_modelPar_WEC_dX*local_scc))+instanceStruct.d_instanceVar_KVTH0WE_i_dX*((local_sca+(modelStruct.modelPar_WEB*local_scb))+(modelStruct.modelPar_WEC*local_scc)));
vth0_well = (instanceStruct.instanceVar_KVTH0WE_i*((local_sca+(modelStruct.modelPar_WEB*local_scb))+(modelStruct.modelPar_WEC*local_scc)));
d_k2_well_dX = (instanceStruct.instanceVar_K2WE_i*((d_local_sca_dX+(modelStruct.modelPar_WEB*d_local_scb_dX+modelStruct.d_modelPar_WEB_dX*local_scb))+(modelStruct.modelPar_WEC*d_local_scc_dX+modelStruct.d_modelPar_WEC_dX*local_scc))+instanceStruct.d_instanceVar_K2WE_i_dX*((local_sca+(modelStruct.modelPar_WEB*local_scb))+(modelStruct.modelPar_WEC*local_scc)));
k2_well = (instanceStruct.instanceVar_K2WE_i*((local_sca+(modelStruct.modelPar_WEB*local_scb))+(modelStruct.modelPar_WEC*local_scc)));
d_mu_well_dX = (instanceStruct.instanceVar_KU0WE_i*((d_local_sca_dX+(modelStruct.modelPar_WEB*d_local_scb_dX+modelStruct.d_modelPar_WEB_dX*local_scb))+(modelStruct.modelPar_WEC*d_local_scc_dX+modelStruct.d_modelPar_WEC_dX*local_scc))+instanceStruct.d_instanceVar_KU0WE_i_dX*((local_sca+(modelStruct.modelPar_WEB*local_scb))+(modelStruct.modelPar_WEC*local_scc)));
mu_well = (1.0+(instanceStruct.instanceVar_KU0WE_i*((local_sca+(modelStruct.modelPar_WEB*local_scb))+(modelStruct.modelPar_WEC*local_scc))));
d_U0_t_dX = (U0_t*d_mu_well_dX+d_U0_t_dX*mu_well);
U0_t = (U0_t*mu_well);
instanceStruct.d_instanceVar_K2_i_dX = (instanceStruct.d_instanceVar_K2_i_dX+d_k2_well_dX);
instanceStruct.instanceVar_K2_i = (instanceStruct.instanceVar_K2_i+k2_well);
Vg = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_gi_bi]));
Vd = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_di_bi]));
Vs = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_si_bi]));
Vds = (Vd-Vs);
Vds_noswap = Vds;
Vsb_noswap = Vs;
Vdb_noswap = Vd;
Vbs_jct = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_sbulk_si]));
Vbd_jct = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_dbulk_di]));
Vgd_noswap = (Vg-Vd);
Vgs_noswap = (Vg-Vs);
Vgd_ov_noswap = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_gm_di]));
Vgs_ov_noswap = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_gm_si]));
sigvds = 1.0;
if ((Vds<0.0))
{
sigvds = (-1.0);
Vd = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_si_bi]));
Vs = (instanceStruct.instanceVar_devsign*(probeVars[admsProbeID_V_di_bi]));
}
Vds = (Vd-Vs);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
Vdsx = (value_sqrt_0-0.1);
}
Vbsx = (-(Vs+(0.5*(Vds-Vdsx))));
{
double value_tanh_0 = tanh(((0.6*Vds_noswap)/Vtm));
double  deriv_tanh_0_d0 = (1.0/cosh(((0.6*Vds_noswap)/Vtm))/cosh(((0.6*Vds_noswap)/Vtm)));
instanceStruct.d_instanceVar_T0_dX = deriv_tanh_0_d0*((-(0.6*Vds_noswap)*d_Vtm_dX/Vtm/Vtm));
instanceStruct.instanceVar_T0 = value_tanh_0;
}
d_wf_dX = 0.5*instanceStruct.d_instanceVar_T0_dX;
wf = (0.5+(0.5*instanceStruct.instanceVar_T0));
d_wr_dX = (-d_wf_dX);
wr = (1.0-wf);
if ((modelStruct.modelPar_ASYMMOD!=0))
{
d_CDSCD_a_dX = ((instanceStruct.instanceVar_CDSCDR_i*d_wr_dX+instanceStruct.d_instanceVar_CDSCDR_i_dX*wr)+(instanceStruct.instanceVar_CDSCD_i*d_wf_dX+instanceStruct.d_instanceVar_CDSCD_i_dX*wf));
CDSCD_a = ((instanceStruct.instanceVar_CDSCDR_i*wr)+(instanceStruct.instanceVar_CDSCD_i*wf));
d_ETA0_a_dX = ((instanceStruct.instanceVar_ETA0R_t*d_wr_dX+instanceStruct.d_instanceVar_ETA0R_t_dX*wr)+(ETA0_t*d_wf_dX+d_ETA0_t_dX*wf));
ETA0_a = ((instanceStruct.instanceVar_ETA0R_t*wr)+(ETA0_t*wf));
d_PDIBLC_a_dX = ((instanceStruct.instanceVar_PDIBLCR_i*d_wr_dX+instanceStruct.d_instanceVar_PDIBLCR_i_dX*wr)+(instanceStruct.instanceVar_PDIBLC_i*d_wf_dX+instanceStruct.d_instanceVar_PDIBLC_i_dX*wf));
PDIBLC_a = ((instanceStruct.instanceVar_PDIBLCR_i*wr)+(instanceStruct.instanceVar_PDIBLC_i*wf));
d_PCLM_a_dX = ((instanceStruct.instanceVar_PCLMR_i*d_wr_dX+instanceStruct.d_instanceVar_PCLMR_i_dX*wr)+(instanceStruct.instanceVar_PCLM_i*d_wf_dX+instanceStruct.d_instanceVar_PCLM_i_dX*wf));
PCLM_a = ((instanceStruct.instanceVar_PCLMR_i*wr)+(instanceStruct.instanceVar_PCLM_i*wf));
d_PSAT_a_dX = ((instanceStruct.instanceVar_PSATR_i*d_wr_dX+instanceStruct.d_instanceVar_PSATR_i_dX*wr)+(instanceStruct.instanceVar_PSAT_i*d_wf_dX+instanceStruct.d_instanceVar_PSAT_i_dX*wf));
PSAT_a = ((instanceStruct.instanceVar_PSATR_i*wr)+(instanceStruct.instanceVar_PSAT_i*wf));
d_VSAT_a_dX = ((instanceStruct.instanceVar_VSATR_t*d_wr_dX+instanceStruct.d_instanceVar_VSATR_t_dX*wr)+(VSAT_t*d_wf_dX+d_VSAT_t_dX*wf));
VSAT_a = ((instanceStruct.instanceVar_VSATR_t*wr)+(VSAT_t*wf));
d_PTWG_a_dX = ((instanceStruct.instanceVar_PTWGR_t*d_wr_dX+instanceStruct.d_instanceVar_PTWGR_t_dX*wr)+(PTWG_t*d_wf_dX+d_PTWG_t_dX*wf));
PTWG_a = ((instanceStruct.instanceVar_PTWGR_t*wr)+(PTWG_t*wf));
d_U0_a_dX = ((instanceStruct.instanceVar_U0R_t*d_wr_dX+instanceStruct.d_instanceVar_U0R_t_dX*wr)+(U0_t*d_wf_dX+d_U0_t_dX*wf));
U0_a = ((instanceStruct.instanceVar_U0R_t*wr)+(U0_t*wf));
d_UA_a_dX = ((instanceStruct.instanceVar_UAR_t*d_wr_dX+instanceStruct.d_instanceVar_UAR_t_dX*wr)+(UA_t*d_wf_dX+d_UA_t_dX*wf));
UA_a = ((instanceStruct.instanceVar_UAR_t*wr)+(UA_t*wf));
d_UC_a_dX = ((instanceStruct.instanceVar_UCR_t*d_wr_dX+instanceStruct.d_instanceVar_UCR_t_dX*wr)+(UC_t*d_wf_dX+d_UC_t_dX*wf));
UC_a = ((instanceStruct.instanceVar_UCR_t*wr)+(UC_t*wf));
instanceStruct.d_instanceVar_UD_a_dX = ((instanceStruct.instanceVar_UDR_t*d_wr_dX+instanceStruct.d_instanceVar_UDR_t_dX*wr)+(UD_t*d_wf_dX+d_UD_t_dX*wf));
instanceStruct.instanceVar_UD_a = ((instanceStruct.instanceVar_UDR_t*wr)+(UD_t*wf));
d_UCS_a_dX = ((instanceStruct.instanceVar_UCSR_t*d_wr_dX+instanceStruct.d_instanceVar_UCSR_t_dX*wr)+(UCS_t*d_wf_dX+d_UCS_t_dX*wf));
UCS_a = ((instanceStruct.instanceVar_UCSR_t*wr)+(UCS_t*wf));
}
else
{
d_CDSCD_a_dX = instanceStruct.d_instanceVar_CDSCD_i_dX;
CDSCD_a = instanceStruct.instanceVar_CDSCD_i;
d_ETA0_a_dX = instanceStruct.d_instanceVar_ETA0_i_dX;
ETA0_a = instanceStruct.instanceVar_ETA0_i;
d_PDIBLC_a_dX = instanceStruct.d_instanceVar_PDIBLC_i_dX;
PDIBLC_a = instanceStruct.instanceVar_PDIBLC_i;
d_PCLM_a_dX = instanceStruct.d_instanceVar_PCLM_i_dX;
PCLM_a = instanceStruct.instanceVar_PCLM_i;
d_PSAT_a_dX = instanceStruct.d_instanceVar_PSAT_i_dX;
PSAT_a = instanceStruct.instanceVar_PSAT_i;
d_VSAT_a_dX = d_VSAT_t_dX;
VSAT_a = VSAT_t;
d_PTWG_a_dX = d_PTWG_t_dX;
PTWG_a = PTWG_t;
d_U0_a_dX = d_U0_t_dX;
U0_a = U0_t;
d_UA_a_dX = d_UA_t_dX;
UA_a = UA_t;
d_UC_a_dX = d_UC_t_dX;
UC_a = UC_t;
instanceStruct.d_instanceVar_UD_a_dX = d_UD_t_dX;
instanceStruct.instanceVar_UD_a = UD_t;
d_UCS_a_dX = d_UCS_t_dX;
UCS_a = UCS_t;
}
{
double value_sqrt_0 = sqrt(((((Phist-Vbsx)-0.05)*((Phist-Vbsx)-0.05))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_PhistVbs_dX = 0.5*(d_Phist_dX+deriv_sqrt_0_d0*((((Phist-Vbsx)-0.05)*d_Phist_dX+d_Phist_dX*((Phist-Vbsx)-0.05))));
PhistVbs = (0.5*(((Phist-Vbsx)+0.05)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(PhistVbs);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtPhistVbs_dX = deriv_sqrt_0_d0*(d_PhistVbs_dX);
sqrtPhistVbs = value_sqrt_0;
}
d_Xdep_dX = (T1DEP*d_sqrtPhistVbs_dX+d_T1DEP_dX*sqrtPhistVbs);
Xdep = (T1DEP*sqrtPhistVbs);
d_Cdep_dX = ((Xdep*instanceStruct.d_instanceVar_epssi_dX-instanceStruct.instanceVar_epssi*d_Xdep_dX)/Xdep/Xdep);
Cdep = (instanceStruct.instanceVar_epssi/Xdep);
d_cdsc_dX = (((instanceStruct.d_instanceVar_CIT_i_dX+d_NFACTOR_t_dX)+d_CDSCD_a_dX*Vdsx)-instanceStruct.d_instanceVar_CDSCB_i_dX*Vbsx);
cdsc = (((instanceStruct.instanceVar_CIT_i+NFACTOR_t)+(CDSCD_a*Vdsx))-(instanceStruct.instanceVar_CDSCB_i*Vbsx));
instanceStruct.d_instanceVar_T1_dX = ((instanceStruct.instanceVar_Cox*d_cdsc_dX-cdsc*instanceStruct.d_instanceVar_Cox_dX)/instanceStruct.instanceVar_Cox/instanceStruct.instanceVar_Cox);
instanceStruct.instanceVar_T1 = (1.0+(cdsc/instanceStruct.instanceVar_Cox));
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_T1-1)*(instanceStruct.instanceVar_T1-1))+((0.25*0.05)*0.05)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_n_dX = 0.5*(instanceStruct.d_instanceVar_T1_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T1-1)*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*(instanceStruct.instanceVar_T1-1))));
n = (0.5*((instanceStruct.instanceVar_T1+1)+value_sqrt_0));
}
d_nVt_dX = (n*d_Vt_dX+d_n_dX*Vt);
nVt = (n*Vt);
d_inv_nVt_dX = (-d_nVt_dX/nVt/nVt);
inv_nVt = (1.0/nVt);
d_dVth_dibl_dX = (-(d_ETA0_a_dX+instanceStruct.d_instanceVar_ETAB_i_dX*Vbsx))*Vdsx;
dVth_dibl = ((-(ETA0_a+(instanceStruct.instanceVar_ETAB_i*Vbsx)))*Vdsx);
{
double value_pow_0 = pow(TRatio,modelStruct.modelPar_KT1EXP);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_KT1EXP/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_dvth_temp_dX = (((instanceStruct.instanceVar_KT1_i+(modelStruct.modelPar_KT1L/instanceStruct.instanceVar_Leff))+(instanceStruct.instanceVar_KT2_i*Vbsx))*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_KT1EXP_dX)))+((instanceStruct.d_instanceVar_KT1_i_dX+((instanceStruct.instanceVar_Leff*modelStruct.d_modelPar_KT1L_dX-modelStruct.modelPar_KT1L*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff))+instanceStruct.d_instanceVar_KT2_i_dX*Vbsx)*(value_pow_0-1.0));
dvth_temp = (((instanceStruct.instanceVar_KT1_i+(modelStruct.modelPar_KT1L/instanceStruct.instanceVar_Leff))+(instanceStruct.instanceVar_KT2_i*Vbsx))*(value_pow_0-1.0));
}
{
double value_sqrt_0 = sqrt((((dVth_dibl)*(dVth_dibl))+((0.25*5.0e-5)*5.0e-5)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dVth_dibl_dX = 0.5*(d_dVth_dibl_dX-deriv_sqrt_0_d0*(((dVth_dibl)*d_dVth_dibl_dX+d_dVth_dibl_dX*(dVth_dibl))));
dVth_dibl = ((0.5*(dVth_dibl-value_sqrt_0))+(0.25*5.0e-5));
}
if ((instanceStruct.instanceVar_DVTP0_i>0.0))
{
instanceStruct.d_instanceVar_T0_dX = (-instanceStruct.d_instanceVar_DVTP1_i_dX)*Vdsx;
instanceStruct.instanceVar_T0 = ((-instanceStruct.instanceVar_DVTP1_i)*Vdsx);
if ((instanceStruct.instanceVar_T0<(-80.0)))
{
instanceStruct.d_instanceVar_T2_dX = 0.0;
instanceStruct.instanceVar_T2 = 1.804851387e-35;
}
else
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_T0);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_T2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_T0_dX);
instanceStruct.instanceVar_T2 = value_exp_0;
}
}
d_T3_dX = (instanceStruct.d_instanceVar_Leff_dX+(instanceStruct.instanceVar_DVTP0_i*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_DVTP0_i_dX*(1.0+instanceStruct.instanceVar_T2)));
T3 = (instanceStruct.instanceVar_Leff+(instanceStruct.instanceVar_DVTP0_i*(1.0+instanceStruct.instanceVar_T2)));
{
AnalogFunctions::llnEvaluator evaluator_lln_0((instanceStruct.instanceVar_Leff/T3));
d_dVth_ldop_dX = ((-nVt)*evaluator_lln_0.getDerivs((instanceStruct.instanceVar_Leff/T3),((T3*instanceStruct.d_instanceVar_Leff_dX-instanceStruct.instanceVar_Leff*d_T3_dX)/T3/T3))+(-d_nVt_dX)*evaluator_lln_0.getValues((instanceStruct.instanceVar_Leff/T3)));
dVth_ldop = ((-nVt)*evaluator_lln_0.getValues((instanceStruct.instanceVar_Leff/T3)));
}
}
else
{
d_dVth_ldop_dX = 0.0;
dVth_ldop = 0;
}
{
double value_pow_0 = pow(instanceStruct.instanceVar_Leff,instanceStruct.instanceVar_DVTP3_i);
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Leff == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_DVTP3_i/instanceStruct.instanceVar_Leff));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Leff == 0.0)?0.0:(log(instanceStruct.instanceVar_Leff)*value_pow_0);
d_T4_dX = (instanceStruct.d_instanceVar_DVTP5_i_dX+((value_pow_0*instanceStruct.d_instanceVar_DVTP2_i_dX-instanceStruct.instanceVar_DVTP2_i*((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Leff_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_DVTP3_i_dX))))/value_pow_0/value_pow_0));
T4 = (instanceStruct.instanceVar_DVTP5_i+(instanceStruct.instanceVar_DVTP2_i/value_pow_0));
}
{
double value_tanh_0 = tanh((instanceStruct.instanceVar_DVTP4_i*Vdsx));
double  deriv_tanh_0_d0 = (1.0/cosh((instanceStruct.instanceVar_DVTP4_i*Vdsx))/cosh((instanceStruct.instanceVar_DVTP4_i*Vdsx)));
d_dVth_ldop_dX = (d_dVth_ldop_dX-(T4*deriv_tanh_0_d0*(instanceStruct.d_instanceVar_DVTP4_i_dX*Vdsx)+d_T4_dX*value_tanh_0));
dVth_ldop = (dVth_ldop-(T4*value_tanh_0));
}
instanceStruct.d_instanceVar_VFB_i_dX = (instanceStruct.d_instanceVar_VFB_i_dX+modelStruct.d_modelPar_DELVT0_dX);
instanceStruct.instanceVar_VFB_i = (instanceStruct.instanceVar_VFB_i+modelStruct.modelPar_DELVT0);
d_vg_dX = Vg*d_inv_nVt_dX;
vg = (Vg*inv_nVt);
d_vs_dX = Vs*d_inv_nVt_dX;
vs = (Vs*inv_nVt);
d_vfb_dX = (instanceStruct.instanceVar_VFB_i*d_inv_nVt_dX+instanceStruct.d_instanceVar_VFB_i_dX*inv_nVt);
vfb = (instanceStruct.instanceVar_VFB_i*inv_nVt);
d_dVth_VNUD_dX = ((instanceStruct.instanceVar_K1_i*(d_sqrtPhistVbs_dX-d_sqrtPhist_dX)+instanceStruct.d_instanceVar_K1_i_dX*(sqrtPhistVbs-sqrtPhist))-instanceStruct.d_instanceVar_K2_i_dX*Vbsx);
dVth_VNUD = ((instanceStruct.instanceVar_K1_i*(sqrtPhistVbs-sqrtPhist))-(instanceStruct.instanceVar_K2_i*Vbsx));
d_Vth_shift_dX = (((((d_dVth_dibl_dX+d_dVth_ldop_dX)+d_dVth_VNUD_dX)-d_dvth_temp_dX)+d_vth0_stress_dX)+d_vth0_well_dX);
Vth_shift = (((((dVth_dibl+dVth_ldop)+dVth_VNUD)-dvth_temp)+vth0_stress)+vth0_well);
d_vgfb_dX = ((d_vg_dX-d_vfb_dX)-(Vth_shift*d_inv_nVt_dX+d_Vth_shift_dX*inv_nVt));
vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEP_i)*inv_Vt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_gam_dX = ((instanceStruct.instanceVar_Cox*deriv_sqrt_0_d0*(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEP_i)*d_inv_Vt_dX+(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.d_instanceVar_NDEP_i_dX+(2.0*1.60219e-19)*instanceStruct.d_instanceVar_epssi_dX*instanceStruct.instanceVar_NDEP_i)*inv_Vt))-value_sqrt_0*instanceStruct.d_instanceVar_Cox_dX)/instanceStruct.instanceVar_Cox/instanceStruct.instanceVar_Cox);
gam = (value_sqrt_0/instanceStruct.instanceVar_Cox);
}
q_vth = 0.5;
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((2*phib)+(Vs*inv_Vt)),1e-3);
instanceStruct.d_instanceVar_T0_dX = evaluator_hypsmooth_0.getDerivs(((2*phib)+(Vs*inv_Vt)),1e-3,(2*d_phib_dX+Vs*d_inv_Vt_dX),0.0);
instanceStruct.instanceVar_T0 = evaluator_hypsmooth_0.getValues(((2*phib)+(Vs*inv_Vt)),1e-3);
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_nq_dX = (((2.0*value_sqrt_0)*d_gam_dX-gam*2.0*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_T0_dX))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
nq = (1.0+(gam/(2.0*value_sqrt_0)));
}
{
double value_log_0 = log(q_vth);
double value_sqrt_1 = sqrt(instanceStruct.instanceVar_T0);
double value_log_2 = log((((2*nq)/gam)*((((2*q_vth)*nq)/gam)+(2*value_sqrt_1))));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_3((((((Vs*inv_Vt)+(2*phib))+value_log_0)+(2*q_vth))+value_log_2),1e-3);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(((2*nq)/gam)*((((2*q_vth)*nq)/gam)+(2*value_sqrt_1))));
d_psip_th_dX = evaluator_hypsmooth_3.getDerivs((((((Vs*inv_Vt)+(2*phib))+value_log_0)+(2*q_vth))+value_log_2),1e-3,((Vs*d_inv_Vt_dX+2*d_phib_dX)+deriv_log_2_d0*((((2*nq)/gam)*(((gam*(2*q_vth)*d_nq_dX-((2*q_vth)*nq)*d_gam_dX)/gam/gam)+2*deriv_sqrt_1_d0*(instanceStruct.d_instanceVar_T0_dX))+((gam*2*d_nq_dX-(2*nq)*d_gam_dX)/gam/gam)*((((2*q_vth)*nq)/gam)+(2*value_sqrt_1))))),0.0);
psip_th = evaluator_hypsmooth_3.getValues((((((Vs*inv_Vt)+(2*phib))+value_log_0)+(2*q_vth))+value_log_2),1e-3);
}
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEP_i)*inv_nVt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_gam_dX = ((instanceStruct.instanceVar_Cox*deriv_sqrt_0_d0*(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEP_i)*d_inv_nVt_dX+(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.d_instanceVar_NDEP_i_dX+(2.0*1.60219e-19)*instanceStruct.d_instanceVar_epssi_dX*instanceStruct.instanceVar_NDEP_i)*inv_nVt))-value_sqrt_0*instanceStruct.d_instanceVar_Cox_dX)/instanceStruct.instanceVar_Cox/instanceStruct.instanceVar_Cox);
gam = (value_sqrt_0/instanceStruct.instanceVar_Cox);
}
d_inv_gam_dX = (-d_gam_dX/gam/gam);
inv_gam = (1.0/gam);
d_phib_n_dX = ((n*d_phib_dX-phib*d_n_dX)/n/n);
phib_n = (phib/n);
instanceStruct.d_instanceVar_T1_dX = 0.0;
instanceStruct.instanceVar_T1 = 1.0;
d_vgfbPD_dX = ((instanceStruct.instanceVar_T1*d_vgfb_dX-vgfb*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
vgfbPD = (vgfb/instanceStruct.instanceVar_T1);
d_gammaPD_dX = ((instanceStruct.instanceVar_T1*d_gam_dX-gam*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
gammaPD = (gam/instanceStruct.instanceVar_T1);
instanceStruct.d_instanceVar_T1_dX = (0.5*d_vgfbPD_dX-3.0*(d_gammaPD_dX/1.41421356237309504880));
instanceStruct.instanceVar_T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)+(6.0*vgfbPD)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1)+6.0*d_vgfbPD_dX)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1+value_sqrt_0);
}
if ((vgfbPD<0.0))
{
d_T3_dX = ((gammaPD*(d_vgfbPD_dX-instanceStruct.d_instanceVar_T2_dX)-(vgfbPD-instanceStruct.instanceVar_T2)*d_gammaPD_dX)/gammaPD/gammaPD);
T3 = ((vgfbPD-instanceStruct.instanceVar_T2)/gammaPD);
{
double value_log_0 = log(((1.0-instanceStruct.instanceVar_T2)+(T3*T3)));
double  deriv_log_0_d0 = (1.0/((1.0-instanceStruct.instanceVar_T2)+(T3*T3)));
d_psip_dX = (-deriv_log_0_d0*(((-instanceStruct.d_instanceVar_T2_dX)+(T3*d_T3_dX+d_T3_dX*T3))));
psip = (-value_log_0);
}
}
else
{
{
double value_exp_0 = exp((-instanceStruct.instanceVar_T2));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((-instanceStruct.d_instanceVar_T2_dX));
T3 = value_exp_0;
}
instanceStruct.d_instanceVar_T1_dX = 0.5*d_gammaPD_dX;
instanceStruct.instanceVar_T1 = (0.5*gammaPD);
{
double value_sqrt_0 = sqrt((((vgfbPD-1.0)+T3)+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_sqrt_0_d0*(((d_vgfbPD_dX+d_T3_dX)+(instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1)))-instanceStruct.d_instanceVar_T1_dX);
instanceStruct.instanceVar_T2 = (value_sqrt_0-instanceStruct.instanceVar_T1);
}
d_psip_dX = ((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2)-d_T3_dX);
psip = (((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+1.0)-T3);
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_T8_dX);
sqrtpsip = value_sqrt_0;
}
d_T9_dX = (((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));
instanceStruct.d_instanceVar_T0_dX = ((gam*(((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dX)/gam/gam);
instanceStruct.instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
instanceStruct.d_instanceVar_T1_dX = ((d_psip_dX-2.0*d_phib_n_dX)-d_vs_dX);
instanceStruct.instanceVar_T1 = ((psip-(2.0*phib_n))-vs);
{
double value_log_0 = log(((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX-deriv_log_0_d0*(((4.0*instanceStruct.instanceVar_T0)*d_sqrtpsip_dX+4.0*instanceStruct.d_instanceVar_T0_dX*sqrtpsip)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX-deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T2+0.402982))));
T8 = (0.5*((instanceStruct.instanceVar_T2-0.201491)-value_sqrt_0));
}
d_sqrtpsisa_dX = d_sqrtpsip_dX;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{
d_T4_dX = 0.0;
T4 = (-100.0);
d_T5_dX = 0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T4_dX);
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_T2_dX = ((T5*(d_T8_dX-d_T4_dX)-(T8-T4)*d_T5_dX)/T5/T5);
instanceStruct.instanceVar_T2 = ((T8-T4)/T5);
d_T6_dX = (instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2);
T6 = (instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((d_T4_dX+(T5*(0.5*instanceStruct.d_instanceVar_T2_dX+(T6*(-(T6*(-d_T6_dX)+d_T6_dX*(1.25-T6)))+d_T6_dX*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dX*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_qs_dX = (T3*((instanceStruct.d_instanceVar_T1_dX-d_T8_dX)-deriv_log_0_d0*(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+2.0*instanceStruct.d_instanceVar_T0_dX*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))+d_T3_dX*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
qs = (T3*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
d_sqrtpsisainv_dX = (-d_sqrtpsisa_dX/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T3_dX = (d_T3_dX-((T5*d_T4_dX-T4*d_T5_dX)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T6_dX = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T6 = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T7_dX = (((-((1.0/T3)*(-d_T3_dX/T3/T3)+(-d_T3_dX/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dX+(sqrtpsisa*d_sqrtpsisa_dX+d_sqrtpsisa_dX*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-d_T6_dX);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-T6);
d_qs_dX = (d_T3_dX-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dX+d_T4_dX*T7)-(T4*T7)*((2.0*T5)*d_T5_dX+2.0*d_T5_dX*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dX-T4*d_T5_dX)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psipclamp_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
psipclamp = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(psipclamp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_psipclamp_dX);
sqrtpsip = value_sqrt_0;
}
d_psiavg_dX = (d_psip_dX-2.0*d_qs_dX);
psiavg = (psip-(2.0*qs));
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T0_dX = 0.5*(d_psiavg_dX+deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dX+d_psiavg_dX*(psiavg-1.0))));
instanceStruct.instanceVar_T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_nq_dX = (((sqrtpsip+value_sqrt_0)*d_gam_dX-gam*(d_sqrtpsip_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_T0_dX)))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
nq = (1.0+(gam/(sqrtpsip+value_sqrt_0)));
}
d_EeffFactor_dX = (-1.0e-8*(instanceStruct.instanceVar_epsratio*modelStruct.d_modelPar_TOXE_dX+instanceStruct.d_instanceVar_epsratio_dX*modelStruct.modelPar_TOXE)/(instanceStruct.instanceVar_epsratio*modelStruct.modelPar_TOXE)/(instanceStruct.instanceVar_epsratio*modelStruct.modelPar_TOXE));
EeffFactor = (1.0e-8/(instanceStruct.instanceVar_epsratio*modelStruct.modelPar_TOXE));
instanceStruct.d_instanceVar_T0_dX = (nVt*((d_vgfb_dX-d_psip_dX)-((2.0*qs)*d_nq_dX+2.0*d_qs_dX*(nq-1.0)))+d_nVt_dX*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
instanceStruct.instanceVar_T0 = (nVt*((vgfb-psip)-((2.0*qs)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_T0)*(instanceStruct.instanceVar_T0))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qbs_dX = 0.5*(instanceStruct.d_instanceVar_T0_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T0)*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*(instanceStruct.instanceVar_T0))));
qbs = (0.5*(instanceStruct.instanceVar_T0+value_sqrt_0));
}
d_qis_dX = (((2.0*nq)*nVt)*d_qs_dX+((2.0*nq)*d_nVt_dX+2.0*d_nq_dX*nVt)*qs);
qis = (((2.0*nq)*nVt)*qs);
d_Eeffs_dX = (EeffFactor*(d_qbs_dX+(eta_mu*d_qis_dX+d_eta_mu_dX*qis))+d_EeffFactor_dX*(qbs+(eta_mu*qis)));
Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
{
double value_pow_0 = pow((0.5*(1.0+(qis/qbs))),UCS_a);
double  deriv_pow_0_d0 = (((0.5*(1.0+(qis/qbs))) == 0.0)?0.0:(value_pow_0*UCS_a/(0.5*(1.0+(qis/qbs)))));
double  deriv_pow_0_d1 = ((0.5*(1.0+(qis/qbs))) == 0.0)?0.0:(log((0.5*(1.0+(qis/qbs))))*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = ((deriv_pow_0_d0*(0.5*((qbs*d_qis_dX-qis*d_qbs_dX)/qbs/qbs)))+(deriv_pow_0_d1*(d_UCS_a_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
{
double value_pow_0 = pow(Eeffs,instanceStruct.instanceVar_EU_i);
double  deriv_pow_0_d0 = ((Eeffs == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_EU_i/Eeffs));
double  deriv_pow_0_d1 = (Eeffs == 0.0)?0.0:(log(Eeffs)*value_pow_0);
d_T3_dX = (((UA_a+(UC_a*Vbsx))*((deriv_pow_0_d0*(d_Eeffs_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_EU_i_dX)))+(d_UA_a_dX+d_UC_a_dX*Vbsx)*value_pow_0)+((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_UD_a_dX-instanceStruct.instanceVar_UD_a*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2));
T3 = (((UA_a+(UC_a*Vbsx))*value_pow_0)+(instanceStruct.instanceVar_UD_a/instanceStruct.instanceVar_T2));
}
d_T4_dX = d_T3_dX;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Dmobs_dX = 0.5*(d_T4_dX+deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dX+d_T4_dX*(T4-1.0))));
Dmobs = (0.5*((T4+1.0)+value_sqrt_0));
}
{
double value_pow_0 = pow((instanceStruct.instanceVar_Weff*1.0e6),instanceStruct.instanceVar_WR_i);
double  deriv_pow_0_d0 = (((instanceStruct.instanceVar_Weff*1.0e6) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_WR_i/(instanceStruct.instanceVar_Weff*1.0e6)));
double  deriv_pow_0_d1 = ((instanceStruct.instanceVar_Weff*1.0e6) == 0.0)?0.0:(log((instanceStruct.instanceVar_Weff*1.0e6))*value_pow_0);
d_WeffWRFactor_dX = (-((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Weff_dX*1.0e6))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_WR_i_dX)))*instanceStruct.instancePar_NF/(value_pow_0*instanceStruct.instancePar_NF)/(value_pow_0*instanceStruct.instancePar_NF));
WeffWRFactor = (1.0/(value_pow_0*instanceStruct.instancePar_NF));
}
if ((modelStruct.modelPar_RDSMOD==1))
{
d_Rdss_dX = 0.0;
Rdss = 0.0;
}
else
{
instanceStruct.d_instanceVar_T0_dX = (instanceStruct.instanceVar_PRWG_i*d_qis_dX+instanceStruct.d_instanceVar_PRWG_i_dX*qis);
instanceStruct.instanceVar_T0 = (1.0+(instanceStruct.instanceVar_PRWG_i*qis));
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.instanceVar_PRWB_i*(d_sqrtPhistVbs_dX-d_sqrtPhist_dX)+instanceStruct.d_instanceVar_PRWB_i_dX*(sqrtPhistVbs-sqrtPhist));
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_PRWB_i*(sqrtPhistVbs-sqrtPhist));
instanceStruct.d_instanceVar_T2_dX = ((-instanceStruct.d_instanceVar_T0_dX/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)+instanceStruct.d_instanceVar_T1_dX);
instanceStruct.instanceVar_T2 = ((1.0/instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1);
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2)));
T3 = (instanceStruct.instanceVar_T2+value_sqrt_0);
}
d_Rdss_dX = ((((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*WeffWRFactor)*instanceStruct.instancePar_NF)*d_rdstemp_dX+((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*d_WeffWRFactor_dX+(instanceStruct.d_instanceVar_RDSWMIN_i_dX+(instanceStruct.instanceVar_RDSW_i*d_T3_dX+instanceStruct.d_instanceVar_RDSW_i_dX*T3))*WeffWRFactor)*instanceStruct.instancePar_NF*rdstemp);
Rdss = ((((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*WeffWRFactor)*instanceStruct.instancePar_NF)*rdstemp);
if ((modelStruct.modelPar_RDSMOD==2))
{
d_Rdss_dX = (((instanceStruct.instanceVar_RSourceGeo+(((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*WeffWRFactor)*instanceStruct.instancePar_NF))+instanceStruct.instanceVar_RDrainGeo)*d_rdstemp_dX+((instanceStruct.d_instanceVar_RSourceGeo_dX+((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*d_WeffWRFactor_dX+(instanceStruct.d_instanceVar_RDSWMIN_i_dX+(instanceStruct.instanceVar_RDSW_i*d_T3_dX+instanceStruct.d_instanceVar_RDSW_i_dX*T3))*WeffWRFactor)*instanceStruct.instancePar_NF)+instanceStruct.d_instanceVar_RDrainGeo_dX)*rdstemp);
Rdss = (((instanceStruct.instanceVar_RSourceGeo+(((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*WeffWRFactor)*instanceStruct.instancePar_NF))+instanceStruct.instanceVar_RDrainGeo)*rdstemp);
}
}
{
double value_pow_0 = pow(Dmobs,(1.0/PSAT_a));
double  deriv_pow_0_d0 = ((Dmobs == 0.0)?0.0:(value_pow_0*(1.0/PSAT_a)/Dmobs));
double  deriv_pow_0_d1 = (Dmobs == 0.0)?0.0:(log(Dmobs)*value_pow_0);
instanceStruct.d_instanceVar_T0_dX = ((deriv_pow_0_d0*(d_Dmobs_dX))+(deriv_pow_0_d1*((-d_PSAT_a_dX/PSAT_a/PSAT_a))));
instanceStruct.instanceVar_T0 = value_pow_0;
}
if ((instanceStruct.instanceVar_PSATB_i<0))
{
instanceStruct.d_instanceVar_T1_dX = (-instanceStruct.d_instanceVar_PSATB_i_dX*Vbsx/(1.0+(instanceStruct.instanceVar_PSATB_i*Vbsx))/(1.0+(instanceStruct.instanceVar_PSATB_i*Vbsx)));
instanceStruct.instanceVar_T1 = (1.0/(1.0+(instanceStruct.instanceVar_PSATB_i*Vbsx)));
}
else
{
instanceStruct.d_instanceVar_T1_dX = (-instanceStruct.d_instanceVar_PSATB_i_dX*Vbsx);
instanceStruct.instanceVar_T1 = (1.0-(instanceStruct.instanceVar_PSATB_i*Vbsx));
}
instanceStruct.d_instanceVar_T2_dX = ((((10.0*modelStruct.modelPar_PSATX)+(qs*instanceStruct.instanceVar_T1))*(((10.0*modelStruct.modelPar_PSATX)*qs)*instanceStruct.d_instanceVar_T1_dX+((10.0*modelStruct.modelPar_PSATX)*d_qs_dX+10.0*modelStruct.d_modelPar_PSATX_dX*qs)*instanceStruct.instanceVar_T1)-(((10.0*modelStruct.modelPar_PSATX)*qs)*instanceStruct.instanceVar_T1)*(10.0*modelStruct.d_modelPar_PSATX_dX+(qs*instanceStruct.d_instanceVar_T1_dX+d_qs_dX*instanceStruct.instanceVar_T1)))/((10.0*modelStruct.modelPar_PSATX)+(qs*instanceStruct.instanceVar_T1))/((10.0*modelStruct.modelPar_PSATX)+(qs*instanceStruct.instanceVar_T1)));
instanceStruct.instanceVar_T2 = ((((10.0*modelStruct.modelPar_PSATX)*qs)*instanceStruct.instanceVar_T1)/((10.0*modelStruct.modelPar_PSATX)+(qs*instanceStruct.instanceVar_T1)));
if ((PTWG_a<0))
{
d_LambdaC_dX = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(-(-(PTWG_a*instanceStruct.d_instanceVar_T2_dX+d_PTWG_a_dX*instanceStruct.instanceVar_T2))/(1.0-(PTWG_a*instanceStruct.instanceVar_T2))/(1.0-(PTWG_a*instanceStruct.instanceVar_T2)))+2.0*(((VSAT_a*instanceStruct.instanceVar_Leff)*((U0_a/instanceStruct.instanceVar_T0)*d_nVt_dX+((instanceStruct.instanceVar_T0*d_U0_a_dX-U0_a*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)*nVt)-((U0_a/instanceStruct.instanceVar_T0)*nVt)*(VSAT_a*instanceStruct.d_instanceVar_Leff_dX+d_VSAT_a_dX*instanceStruct.instanceVar_Leff))/(VSAT_a*instanceStruct.instanceVar_Leff)/(VSAT_a*instanceStruct.instanceVar_Leff))*(1.0/(1.0-(PTWG_a*instanceStruct.instanceVar_T2))));
LambdaC = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(1.0/(1.0-(PTWG_a*instanceStruct.instanceVar_T2))));
}
else
{
d_LambdaC_dX = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(PTWG_a*instanceStruct.d_instanceVar_T2_dX+d_PTWG_a_dX*instanceStruct.instanceVar_T2)+2.0*(((VSAT_a*instanceStruct.instanceVar_Leff)*((U0_a/instanceStruct.instanceVar_T0)*d_nVt_dX+((instanceStruct.instanceVar_T0*d_U0_a_dX-U0_a*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)*nVt)-((U0_a/instanceStruct.instanceVar_T0)*nVt)*(VSAT_a*instanceStruct.d_instanceVar_Leff_dX+d_VSAT_a_dX*instanceStruct.instanceVar_Leff))/(VSAT_a*instanceStruct.instanceVar_Leff)/(VSAT_a*instanceStruct.instanceVar_Leff))*(1.0+(PTWG_a*instanceStruct.instanceVar_T2)));
LambdaC = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(1.0+(PTWG_a*instanceStruct.instanceVar_T2)));
}
if ((Rdss==0))
{
instanceStruct.d_instanceVar_T0_dX = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dX+d_qs_dX*qs)+d_qs_dX)+0.5*d_LambdaC_dX*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dX+0.5*d_LambdaC_dX*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
instanceStruct.instanceVar_T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
instanceStruct.d_instanceVar_T1_dX = ((2.0*LambdaC)*(d_qs_dX-instanceStruct.d_instanceVar_T0_dX)+2.0*d_LambdaC_dX*(qs-instanceStruct.instanceVar_T0));
instanceStruct.instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceStruct.instanceVar_T0));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(instanceStruct.instanceVar_T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1+1.0)));
d_ln_T1_T2_dX = deriv_asinh_0_d0*(instanceStruct.d_instanceVar_T1_dX);
ln_T1_T2 = value_asinh_0;
}
if ((instanceStruct.instanceVar_T1!=0))
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+((1.0/instanceStruct.instanceVar_T1)*d_ln_T1_T2_dX+(-instanceStruct.d_instanceVar_T1_dX/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1)*ln_T1_T2));
T3 = (instanceStruct.instanceVar_T2+((1.0/instanceStruct.instanceVar_T1)*ln_T1_T2));
}
else
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+(-instanceStruct.d_instanceVar_T2_dX/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2));
T3 = (instanceStruct.instanceVar_T2+(1.0/instanceStruct.instanceVar_T2));
}
d_T4_dX = ((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)-(LambdaC*(((qs*d_qs_dX+d_qs_dX*qs)+d_qs_dX)-((instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T0)+instanceStruct.d_instanceVar_T0_dX))+d_LambdaC_dX*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
T4 = ((instanceStruct.instanceVar_T0*T3)-(LambdaC*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
if ((instanceStruct.instanceVar_T1!=0))
{
d_T5_dX = (((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)*(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2)-d_ln_T1_T2_dX)+(-2.0)*d_LambdaC_dX*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))*(instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
T5 = ((((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
}
else
{
d_T5_dX = (((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+(-2.0)*d_LambdaC_dX*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
T5 = (((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
}
d_T6_dX = (((instanceStruct.instanceVar_T0*d_T5_dX+instanceStruct.d_instanceVar_T0_dX*T5)+d_T3_dX)+(LambdaC*2.0*instanceStruct.d_instanceVar_T0_dX+d_LambdaC_dX*((2.0*instanceStruct.instanceVar_T0)+1.0)));
T6 = (((instanceStruct.instanceVar_T0*T5)+T3)+(LambdaC*((2.0*instanceStruct.instanceVar_T0)+1.0)));
instanceStruct.d_instanceVar_T0_dX = (instanceStruct.d_instanceVar_T0_dX-((T6*d_T4_dX-T4*d_T6_dX)/T6/T6));
instanceStruct.instanceVar_T0 = (instanceStruct.instanceVar_T0-(T4/T6));
instanceStruct.d_instanceVar_T1_dX = ((2.0*LambdaC)*(d_qs_dX-instanceStruct.d_instanceVar_T0_dX)+2.0*d_LambdaC_dX*(qs-instanceStruct.instanceVar_T0));
instanceStruct.instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceStruct.instanceVar_T0));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(instanceStruct.instanceVar_T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1+1.0)));
d_ln_T1_T2_dX = deriv_asinh_0_d0*(instanceStruct.d_instanceVar_T1_dX);
ln_T1_T2 = value_asinh_0;
}
if ((instanceStruct.instanceVar_T1!=0))
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+((1.0/instanceStruct.instanceVar_T1)*d_ln_T1_T2_dX+(-instanceStruct.d_instanceVar_T1_dX/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1)*ln_T1_T2));
T3 = (instanceStruct.instanceVar_T2+((1.0/instanceStruct.instanceVar_T1)*ln_T1_T2));
}
else
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+(-instanceStruct.d_instanceVar_T2_dX/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2));
T3 = (instanceStruct.instanceVar_T2+(1.0/instanceStruct.instanceVar_T2));
}
d_T4_dX = ((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)-(LambdaC*(((qs*d_qs_dX+d_qs_dX*qs)+d_qs_dX)-((instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T0)+instanceStruct.d_instanceVar_T0_dX))+d_LambdaC_dX*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
T4 = ((instanceStruct.instanceVar_T0*T3)-(LambdaC*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
if ((instanceStruct.instanceVar_T1!=0))
{
d_T5_dX = (((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)*(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2)-d_ln_T1_T2_dX)+(-2.0)*d_LambdaC_dX*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))*(instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
T5 = ((((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
}
else
{
d_T5_dX = (((instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+((instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2)*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
T5 = (((instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
}
d_T6_dX = (((instanceStruct.instanceVar_T0*d_T5_dX+instanceStruct.d_instanceVar_T0_dX*T5)+d_T3_dX)+(LambdaC*2.0*instanceStruct.d_instanceVar_T0_dX+d_LambdaC_dX*((2.0*instanceStruct.instanceVar_T0)+1.0)));
T6 = (((instanceStruct.instanceVar_T0*T5)+T3)+(LambdaC*((2.0*instanceStruct.instanceVar_T0)+1.0)));
d_qdsat_dX = (instanceStruct.d_instanceVar_T0_dX-((T6*d_T4_dX-T4*d_T6_dX)/T6/T6));
qdsat = (instanceStruct.instanceVar_T0-(T4/T6));
}
else
{
d_T11_dX = (((((instanceStruct.instanceVar_Weff*2.0)*nq)*instanceStruct.instanceVar_Cox)*nVt)*d_VSAT_a_dX+((((instanceStruct.instanceVar_Weff*2.0)*nq)*instanceStruct.instanceVar_Cox)*d_nVt_dX+(((instanceStruct.instanceVar_Weff*2.0)*nq)*instanceStruct.d_instanceVar_Cox_dX+((instanceStruct.instanceVar_Weff*2.0)*d_nq_dX+instanceStruct.d_instanceVar_Weff_dX*2.0*nq)*instanceStruct.instanceVar_Cox)*nVt)*VSAT_a);
T11 = (((((instanceStruct.instanceVar_Weff*2.0)*nq)*instanceStruct.instanceVar_Cox)*nVt)*VSAT_a);
d_T12_dX = (((2.0*nVt)*((T11*LambdaC)*d_Rdss_dX+(T11*d_LambdaC_dX+d_T11_dX*LambdaC)*Rdss)-((T11*LambdaC)*Rdss)*2.0*d_nVt_dX)/(2.0*nVt)/(2.0*nVt));
T12 = (((T11*LambdaC)*Rdss)/(2.0*nVt));
instanceStruct.d_instanceVar_T0_dX = (((1.0+((0.5*LambdaC)*(1.0+qs)))*((0.5*LambdaC)*((qs*d_qs_dX+d_qs_dX*qs)+d_qs_dX)+0.5*d_LambdaC_dX*((qs*qs)+qs))-((0.5*LambdaC)*((qs*qs)+qs))*((0.5*LambdaC)*d_qs_dX+0.5*d_LambdaC_dX*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs)))/(1.0+((0.5*LambdaC)*(1.0+qs))));
instanceStruct.instanceVar_T0 = (((0.5*LambdaC)*((qs*qs)+qs))/(1.0+((0.5*LambdaC)*(1.0+qs))));
instanceStruct.d_instanceVar_T1_dX = ((2.0*LambdaC)*(d_qs_dX-instanceStruct.d_instanceVar_T0_dX)+2.0*d_LambdaC_dX*(qs-instanceStruct.instanceVar_T0));
instanceStruct.instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceStruct.instanceVar_T0));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(instanceStruct.instanceVar_T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1+1.0)));
d_ln_T1_T2_dX = deriv_asinh_0_d0*(instanceStruct.d_instanceVar_T1_dX);
ln_T1_T2 = value_asinh_0;
}
if ((instanceStruct.instanceVar_T1!=0))
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+((1.0/instanceStruct.instanceVar_T1)*d_ln_T1_T2_dX+(-instanceStruct.d_instanceVar_T1_dX/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1)*ln_T1_T2));
T3 = (instanceStruct.instanceVar_T2+((1.0/instanceStruct.instanceVar_T1)*ln_T1_T2));
}
else
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+(-instanceStruct.d_instanceVar_T2_dX/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2));
T3 = (instanceStruct.instanceVar_T2+(1.0/instanceStruct.instanceVar_T2));
}
d_T4_dX = (((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+((T12*instanceStruct.instanceVar_T0)*(d_qs_dX+instanceStruct.d_instanceVar_T0_dX)+(T12*instanceStruct.d_instanceVar_T0_dX+d_T12_dX*instanceStruct.instanceVar_T0)*((qs+instanceStruct.instanceVar_T0)+1.0)))-(LambdaC*(((qs*d_qs_dX+d_qs_dX*qs)+d_qs_dX)-((instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T0)+instanceStruct.d_instanceVar_T0_dX))+d_LambdaC_dX*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
T4 = (((instanceStruct.instanceVar_T0*T3)+((T12*instanceStruct.instanceVar_T0)*((qs+instanceStruct.instanceVar_T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
if ((instanceStruct.instanceVar_T1!=0))
{
d_T5_dX = (((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)*(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2)-d_ln_T1_T2_dX)+(-2.0)*d_LambdaC_dX*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))*(instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
T5 = ((((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
}
else
{
d_T5_dX = (((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+(-2.0)*d_LambdaC_dX*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
T5 = (((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
}
d_T6_dX = ((((instanceStruct.instanceVar_T0*d_T5_dX+instanceStruct.d_instanceVar_T0_dX*T5)+d_T3_dX)+(T12*(d_qs_dX+2.0*instanceStruct.d_instanceVar_T0_dX)+d_T12_dX*((qs+(2.0*instanceStruct.instanceVar_T0))+1.0)))+(LambdaC*2.0*instanceStruct.d_instanceVar_T0_dX+d_LambdaC_dX*((2.0*instanceStruct.instanceVar_T0)+1.0)));
T6 = ((((instanceStruct.instanceVar_T0*T5)+T3)+(T12*((qs+(2.0*instanceStruct.instanceVar_T0))+1.0)))+(LambdaC*((2.0*instanceStruct.instanceVar_T0)+1.0)));
instanceStruct.d_instanceVar_T0_dX = (instanceStruct.d_instanceVar_T0_dX-((T6*d_T4_dX-T4*d_T6_dX)/T6/T6));
instanceStruct.instanceVar_T0 = (instanceStruct.instanceVar_T0-(T4/T6));
instanceStruct.d_instanceVar_T1_dX = ((2.0*LambdaC)*(d_qs_dX-instanceStruct.d_instanceVar_T0_dX)+2.0*d_LambdaC_dX*(qs-instanceStruct.instanceVar_T0));
instanceStruct.instanceVar_T1 = ((2.0*LambdaC)*(qs-instanceStruct.instanceVar_T0));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
{
double value_asinh_0 = asinh(instanceStruct.instanceVar_T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1+1.0)));
d_ln_T1_T2_dX = deriv_asinh_0_d0*(instanceStruct.d_instanceVar_T1_dX);
ln_T1_T2 = value_asinh_0;
}
if ((instanceStruct.instanceVar_T1!=0))
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+((1.0/instanceStruct.instanceVar_T1)*d_ln_T1_T2_dX+(-instanceStruct.d_instanceVar_T1_dX/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1)*ln_T1_T2));
T3 = (instanceStruct.instanceVar_T2+((1.0/instanceStruct.instanceVar_T1)*ln_T1_T2));
}
else
{
d_T3_dX = (instanceStruct.d_instanceVar_T2_dX+(-instanceStruct.d_instanceVar_T2_dX/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2));
T3 = (instanceStruct.instanceVar_T2+(1.0/instanceStruct.instanceVar_T2));
}
d_T4_dX = (((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+((T12*instanceStruct.instanceVar_T0)*(d_qs_dX+instanceStruct.d_instanceVar_T0_dX)+(T12*instanceStruct.d_instanceVar_T0_dX+d_T12_dX*instanceStruct.instanceVar_T0)*((qs+instanceStruct.instanceVar_T0)+1.0)))-(LambdaC*(((qs*d_qs_dX+d_qs_dX*qs)+d_qs_dX)-((instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T0)+instanceStruct.d_instanceVar_T0_dX))+d_LambdaC_dX*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
T4 = (((instanceStruct.instanceVar_T0*T3)+((T12*instanceStruct.instanceVar_T0)*((qs+instanceStruct.instanceVar_T0)+1.0)))-(LambdaC*(((qs*qs)+qs)-((instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T0))));
if ((instanceStruct.instanceVar_T1!=0))
{
d_T5_dX = (((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)*(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2)-d_ln_T1_T2_dX)+(-2.0)*d_LambdaC_dX*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))-(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))*(instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
T5 = ((((-2.0)*LambdaC)*((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2)-ln_T1_T2))/(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1));
}
else
{
d_T5_dX = (((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+(((-2.0)*LambdaC)*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)+(-2.0)*d_LambdaC_dX*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
T5 = (((((-2.0)*LambdaC)*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2))*(instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2));
}
d_T6_dX = ((((instanceStruct.instanceVar_T0*d_T5_dX+instanceStruct.d_instanceVar_T0_dX*T5)+d_T3_dX)+(T12*(d_qs_dX+2.0*instanceStruct.d_instanceVar_T0_dX)+d_T12_dX*((qs+(2.0*instanceStruct.instanceVar_T0))+1.0)))+(LambdaC*2.0*instanceStruct.d_instanceVar_T0_dX+d_LambdaC_dX*((2.0*instanceStruct.instanceVar_T0)+1.0)));
T6 = ((((instanceStruct.instanceVar_T0*T5)+T3)+(T12*((qs+(2.0*instanceStruct.instanceVar_T0))+1.0)))+(LambdaC*((2.0*instanceStruct.instanceVar_T0)+1.0)));
d_qdsat_dX = (instanceStruct.d_instanceVar_T0_dX-((T6*d_T4_dX-T4*d_T6_dX)/T6/T6));
qdsat = (instanceStruct.instanceVar_T0-(T4/T6));
}
{
double value_log_0 = log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));
double  deriv_log_0_d0 = (1.0/((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));
d_vdsat_dX = ((d_psip_dX-2.0*d_phib_n_dX)-(2.0*d_qdsat_dX+deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dX+((qdsat*2.0)*d_nq_dX+d_qdsat_dX*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dX-gam*d_nq_dX)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dX+((qdsat*2.0)*d_nq_dX+d_qdsat_dX*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
vdsat = ((psip-(2.0*phib_n))-((2.0*qdsat)+value_log_0));
}
d_Vdsat_dX = (vdsat*d_nVt_dX+d_vdsat_dX*nVt);
Vdsat = (vdsat*nVt);
{
double value_sqrt_0 = sqrt(((((Vdsat-Vs))*((Vdsat-Vs)))+((0.25*1e-3)*1e-3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdssat_dX = 0.5*(d_Vdsat_dX+deriv_sqrt_0_d0*((((Vdsat-Vs))*d_Vdsat_dX+d_Vdsat_dX*((Vdsat-Vs)))));
Vdssat = (0.5*((Vdsat-Vs)+value_sqrt_0));
}
{
double value_pow_0 = pow((Vds/Vdssat),(1.0/DELTA_t));
double  deriv_pow_0_d0 = (((Vds/Vdssat) == 0.0)?0.0:(value_pow_0*(1.0/DELTA_t)/(Vds/Vdssat)));
double  deriv_pow_0_d1 = ((Vds/Vdssat) == 0.0)?0.0:(log((Vds/Vdssat))*value_pow_0);
d_T7_dX = ((deriv_pow_0_d0*((-Vds*d_Vdssat_dX/Vdssat/Vdssat)))+(deriv_pow_0_d1*((-d_DELTA_t_dX/DELTA_t/DELTA_t))));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),(-DELTA_t));
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*(-DELTA_t)/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);
d_T8_dX = ((deriv_pow_0_d0*(d_T7_dX))+(deriv_pow_0_d1*((-d_DELTA_t_dX))));
T8 = value_pow_0;
}
d_Vdseff_dX = Vds*d_T8_dX;
Vdseff = (Vds*T8);
d_vdeff_dX = ((Vdseff+Vs)*d_inv_nVt_dX+d_Vdseff_dX*inv_nVt);
vdeff = ((Vdseff+Vs)*inv_nVt);
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_T8_dX);
sqrtpsip = value_sqrt_0;
}
d_T9_dX = (((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));
instanceStruct.d_instanceVar_T0_dX = ((gam*(((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dX)/gam/gam);
instanceStruct.instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
instanceStruct.d_instanceVar_T1_dX = ((d_psip_dX-2.0*d_phib_n_dX)-d_vdeff_dX);
instanceStruct.instanceVar_T1 = ((psip-(2.0*phib_n))-vdeff);
{
double value_log_0 = log(((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX-deriv_log_0_d0*(((4.0*instanceStruct.instanceVar_T0)*d_sqrtpsip_dX+4.0*instanceStruct.d_instanceVar_T0_dX*sqrtpsip)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX-deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T2+0.402982))));
T8 = (0.5*((instanceStruct.instanceVar_T2-0.201491)-value_sqrt_0));
}
d_sqrtpsisa_dX = d_sqrtpsip_dX;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{
d_T4_dX = 0.0;
T4 = (-100.0);
d_T5_dX = 0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T4_dX);
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_T2_dX = ((T5*(d_T8_dX-d_T4_dX)-(T8-T4)*d_T5_dX)/T5/T5);
instanceStruct.instanceVar_T2 = ((T8-T4)/T5);
d_T6_dX = (instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2);
T6 = (instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((d_T4_dX+(T5*(0.5*instanceStruct.d_instanceVar_T2_dX+(T6*(-(T6*(-d_T6_dX)+d_T6_dX*(1.25-T6)))+d_T6_dX*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dX*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_qdeff_dX = (T3*((instanceStruct.d_instanceVar_T1_dX-d_T8_dX)-deriv_log_0_d0*(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+2.0*instanceStruct.d_instanceVar_T0_dX*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))+d_T3_dX*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
qdeff = (T3*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
d_sqrtpsisainv_dX = (-d_sqrtpsisa_dX/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T3_dX = (d_T3_dX-((T5*d_T4_dX-T4*d_T5_dX)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T6_dX = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T6 = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T7_dX = (((-((1.0/T3)*(-d_T3_dX/T3/T3)+(-d_T3_dX/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dX+(sqrtpsisa*d_sqrtpsisa_dX+d_sqrtpsisa_dX*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-d_T6_dX);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-T6);
d_qdeff_dX = (d_T3_dX-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dX+d_T4_dX*T7)-(T4*T7)*((2.0*T5)*d_T5_dX+2.0*d_T5_dX*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dX-T4*d_T5_dX)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
d_psiavg_dX = ((d_psip_dX-d_qs_dX)-d_qdeff_dX);
psiavg = (((psip-qs)-qdeff)-1.0);
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T0_dX = 0.5*(d_psiavg_dX+deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dX+d_psiavg_dX*(psiavg-1.0))));
instanceStruct.instanceVar_T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_T0_dX);
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
d_nq_dX = (((sqrtpsip+instanceStruct.instanceVar_T2)*d_gam_dX-gam*(d_sqrtpsip_dX+instanceStruct.d_instanceVar_T2_dX))/(sqrtpsip+instanceStruct.instanceVar_T2)/(sqrtpsip+instanceStruct.instanceVar_T2));
nq = (1.0+(gam/(sqrtpsip+instanceStruct.instanceVar_T2)));
d_DQSD2_dX = ((qs-qdeff)*(d_qs_dX-d_qdeff_dX)+(d_qs_dX-d_qdeff_dX)*(qs-qdeff));
DQSD2 = ((qs-qdeff)*(qs-qdeff));
instanceStruct.d_instanceVar_T0_dX = (-(d_qs_dX+d_qdeff_dX)/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
instanceStruct.instanceVar_T0 = (1.0/((1.0+qs)+qdeff));
instanceStruct.d_instanceVar_T1_dX = (DQSD2*instanceStruct.d_instanceVar_T0_dX+d_DQSD2_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_T1 = (DQSD2*instanceStruct.instanceVar_T0);
d_Qb_dX = ((d_vgfb_dX-d_psip_dX)-((nq-1.0)*((d_qs_dX+d_qdeff_dX)+0.33333333333333333*instanceStruct.d_instanceVar_T1_dX)+d_nq_dX*((qs+qdeff)+(0.33333333333333333*instanceStruct.instanceVar_T1))));
Qb = ((vgfb-psip)-((nq-1.0)*((qs+qdeff)+(0.33333333333333333*instanceStruct.instanceVar_T1))));
instanceStruct.d_instanceVar_T2_dX = 0.33333333333333333*d_nq_dX;
instanceStruct.instanceVar_T2 = (0.33333333333333333*nq);
d_T3_dX = (instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T0);
T3 = (instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T0);
d_Qs_dX = (instanceStruct.instanceVar_T2*((2.0*d_qs_dX+d_qdeff_dX)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*d_T3_dX+0.5*(0.8*d_qs_dX+1.2*d_qdeff_dX)*T3))+instanceStruct.d_instanceVar_T2_dX*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
Qs = (instanceStruct.instanceVar_T2*(((2.0*qs)+qdeff)+((0.5*((1.0+(0.8*qs))+(1.2*qdeff)))*T3)));
d_Qd_dX = (instanceStruct.instanceVar_T2*((d_qs_dX+2.0*d_qdeff_dX)+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*d_T3_dX+0.5*(1.2*d_qs_dX+0.8*d_qdeff_dX)*T3))+instanceStruct.d_instanceVar_T2_dX*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
Qd = (instanceStruct.instanceVar_T2*((qs+(2.0*qdeff))+((0.5*((1.0+(1.2*qs))+(0.8*qdeff)))*T3)));
{
double value_sqrt_0 = sqrt(((((nVt*Qb))*((nVt*Qb)))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qba_dX = 0.5*((nVt*d_Qb_dX+d_nVt_dX*Qb)+deriv_sqrt_0_d0*((((nVt*Qb))*(nVt*d_Qb_dX+d_nVt_dX*Qb)+(nVt*d_Qb_dX+d_nVt_dX*Qb)*((nVt*Qb)))));
qba = (0.5*((nVt*Qb)+value_sqrt_0));
}
d_qia_dX = (nVt*(d_Qs_dX+d_Qd_dX)+d_nVt_dX*(Qs+Qd));
qia = (nVt*(Qs+Qd));
d_Eeffm_dX = (EeffFactor*(d_qba_dX+(eta_mu*d_qia_dX+d_eta_mu_dX*qia))+d_EeffFactor_dX*(qba+(eta_mu*qia)));
Eeffm = (EeffFactor*(qba+(eta_mu*qia)));
{
double value_pow_0 = pow((0.5*(1.0+(qia/qba))),UCS_a);
double  deriv_pow_0_d0 = (((0.5*(1.0+(qia/qba))) == 0.0)?0.0:(value_pow_0*UCS_a/(0.5*(1.0+(qia/qba)))));
double  deriv_pow_0_d1 = ((0.5*(1.0+(qia/qba))) == 0.0)?0.0:(log((0.5*(1.0+(qia/qba))))*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = ((deriv_pow_0_d0*(0.5*((qba*d_qia_dX-qia*d_qba_dX)/qba/qba)))+(deriv_pow_0_d1*(d_UCS_a_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
{
double value_pow_0 = pow(Eeffm,instanceStruct.instanceVar_EU_i);
double  deriv_pow_0_d0 = ((Eeffm == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_EU_i/Eeffm));
double  deriv_pow_0_d1 = (Eeffm == 0.0)?0.0:(log(Eeffm)*value_pow_0);
d_T3_dX = (((UA_a+(UC_a*Vbsx))*((deriv_pow_0_d0*(d_Eeffm_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_EU_i_dX)))+(d_UA_a_dX+d_UC_a_dX*Vbsx)*value_pow_0)+((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_UD_a_dX-instanceStruct.instanceVar_UD_a*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2));
T3 = (((UA_a+(UC_a*Vbsx))*value_pow_0)+(instanceStruct.instanceVar_UD_a/instanceStruct.instanceVar_T2));
}
d_T4_dX = d_T3_dX;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Dmob_dX = 0.5*(d_T4_dX+deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dX+d_T4_dX*(T4-1.0))));
Dmob = (0.5*((T4+1.0)+value_sqrt_0));
}
d_Esat_dX = (((U0_a/Dmob)*2.0*d_VSAT_a_dX-(2.0*VSAT_a)*((Dmob*d_U0_a_dX-U0_a*d_Dmob_dX)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
Esat = ((2.0*VSAT_a)/(U0_a/Dmob));
d_EsatL_dX = (Esat*instanceStruct.d_instanceVar_Leff_dX+d_Esat_dX*instanceStruct.instanceVar_Leff);
EsatL = (Esat*instanceStruct.instanceVar_Leff);
if ((instanceStruct.instanceVar_PVAG_i>0))
{
d_PVAGfactor_dX = ((EsatL*(instanceStruct.instanceVar_PVAG_i*d_qia_dX+instanceStruct.d_instanceVar_PVAG_i_dX*qia)-(instanceStruct.instanceVar_PVAG_i*qia)*d_EsatL_dX)/EsatL/EsatL);
PVAGfactor = (1.0+((instanceStruct.instanceVar_PVAG_i*qia)/EsatL));
}
else
{
d_PVAGfactor_dX = (-(-((EsatL*(instanceStruct.instanceVar_PVAG_i*d_qia_dX+instanceStruct.d_instanceVar_PVAG_i_dX*qia)-(instanceStruct.instanceVar_PVAG_i*qia)*d_EsatL_dX)/EsatL/EsatL))/(1.0-((instanceStruct.instanceVar_PVAG_i*qia)/EsatL))/(1.0-((instanceStruct.instanceVar_PVAG_i*qia)/EsatL)));
PVAGfactor = (1.0/(1.0-((instanceStruct.instanceVar_PVAG_i*qia)/EsatL)));
}
d_DIBLfactor_dX = d_PDIBLC_a_dX;
DIBLfactor = PDIBLC_a;
d_diffVds_dX = (-d_Vdseff_dX);
diffVds = (Vds-Vdseff);
d_Vgst2Vtm_dX = (d_qia_dX+2.0*d_nVt_dX);
Vgst2Vtm = (qia+(2.0*nVt));
if ((DIBLfactor>0))
{
d_T3_dX = (((Vdssat+Vgst2Vtm)*d_Vgst2Vtm_dX-Vgst2Vtm*(d_Vdssat_dX+d_Vgst2Vtm_dX))/(Vdssat+Vgst2Vtm)/(Vdssat+Vgst2Vtm));
T3 = (Vgst2Vtm/(Vdssat+Vgst2Vtm));
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((1.0+(instanceStruct.instanceVar_PDIBLCB_i*Vbsx)),1e-3);
d_T4_dX = evaluator_hypsmooth_0.getDerivs((1.0+(instanceStruct.instanceVar_PDIBLCB_i*Vbsx)),1e-3,instanceStruct.d_instanceVar_PDIBLCB_i_dX*Vbsx,0.0);
T4 = evaluator_hypsmooth_0.getValues((1.0+(instanceStruct.instanceVar_PDIBLCB_i*Vbsx)),1e-3);
}
d_T5_dX = (-1*d_T4_dX/T4/T4);
T5 = (1/T4);
d_VaDIBL_dX = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*d_T5_dX+(((Vgst2Vtm/DIBLfactor)*T3)*d_PVAGfactor_dX+((Vgst2Vtm/DIBLfactor)*d_T3_dX+((DIBLfactor*d_Vgst2Vtm_dX-Vgst2Vtm*d_DIBLfactor_dX)/DIBLfactor/DIBLfactor)*T3)*PVAGfactor)*T5);
VaDIBL = ((((Vgst2Vtm/DIBLfactor)*T3)*PVAGfactor)*T5);
d_Moc_dX = ((VaDIBL*d_diffVds_dX-diffVds*d_VaDIBL_dX)/VaDIBL/VaDIBL);
Moc = (1.0+(diffVds/VaDIBL));
}
else
{
d_Moc_dX = 0.0;
Moc = 1.0;
}
if ((instanceStruct.instanceVar_FPROUT_i<=0.0))
{
d_Fp_dX = 0.0;
Fp = 1.0;
}
else
{
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_Leff);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T9_dX = ((Vgst2Vtm*(instanceStruct.instanceVar_FPROUT_i*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_Leff_dX)+instanceStruct.d_instanceVar_FPROUT_i_dX*value_sqrt_0)-(instanceStruct.instanceVar_FPROUT_i*value_sqrt_0)*d_Vgst2Vtm_dX)/Vgst2Vtm/Vgst2Vtm);
T9 = ((instanceStruct.instanceVar_FPROUT_i*value_sqrt_0)/Vgst2Vtm);
}
d_Fp_dX = (-d_T9_dX/(1.0+T9)/(1.0+T9));
Fp = (1.0/(1.0+T9));
}
d_Vasat_dX = (d_Vdssat_dX+d_EsatL_dX);
Vasat = (Vdssat+EsatL);
if ((PCLM_a!=0))
{
if ((modelStruct.modelPar_PCLMG<0.0))
{
instanceStruct.d_instanceVar_T1_dX = ((Fp*(((1.0-((modelStruct.modelPar_PCLMG*qia)/EsatL))*d_PCLM_a_dX-PCLM_a*(-((EsatL*(modelStruct.modelPar_PCLMG*d_qia_dX+modelStruct.d_modelPar_PCLMG_dX*qia)-(modelStruct.modelPar_PCLMG*qia)*d_EsatL_dX)/EsatL/EsatL)))/(1.0-((modelStruct.modelPar_PCLMG*qia)/EsatL))/(1.0-((modelStruct.modelPar_PCLMG*qia)/EsatL)))-(PCLM_a/(1.0-((modelStruct.modelPar_PCLMG*qia)/EsatL)))*d_Fp_dX)/Fp/Fp);
instanceStruct.instanceVar_T1 = ((PCLM_a/(1.0-((modelStruct.modelPar_PCLMG*qia)/EsatL)))/Fp);
}
else
{
instanceStruct.d_instanceVar_T1_dX = ((Fp*(PCLM_a*((EsatL*(modelStruct.modelPar_PCLMG*d_qia_dX+modelStruct.d_modelPar_PCLMG_dX*qia)-(modelStruct.modelPar_PCLMG*qia)*d_EsatL_dX)/EsatL/EsatL)+d_PCLM_a_dX*(1.0+((modelStruct.modelPar_PCLMG*qia)/EsatL)))-(PCLM_a*(1.0+((modelStruct.modelPar_PCLMG*qia)/EsatL)))*d_Fp_dX)/Fp/Fp);
instanceStruct.instanceVar_T1 = ((PCLM_a*(1.0+((modelStruct.modelPar_PCLMG*qia)/EsatL)))/Fp);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+((diffVds/instanceStruct.instanceVar_T1)/Vasat)));
d_MdL_dX = (instanceStruct.instanceVar_T1*evaluator_lln_0.getDerivs((1.0+((diffVds/instanceStruct.instanceVar_T1)/Vasat)),((Vasat*((instanceStruct.instanceVar_T1*d_diffVds_dX-diffVds*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1)-(diffVds/instanceStruct.instanceVar_T1)*d_Vasat_dX)/Vasat/Vasat))+instanceStruct.d_instanceVar_T1_dX*evaluator_lln_0.getValues((1.0+((diffVds/instanceStruct.instanceVar_T1)/Vasat))));
MdL = (1.0+(instanceStruct.instanceVar_T1*evaluator_lln_0.getValues((1.0+((diffVds/instanceStruct.instanceVar_T1)/Vasat)))));
}
}
else
{
d_MdL_dX = 0.0;
MdL = 1.0;
}
d_Moc_dX = (Moc*d_MdL_dX+d_Moc_dX*MdL);
Moc = (Moc*MdL);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((instanceStruct.instanceVar_PDITSD_i*Vds));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs((instanceStruct.instanceVar_PDITSD_i*Vds),instanceStruct.d_instanceVar_PDITSD_i_dX*Vds);
instanceStruct.instanceVar_T1 = evaluator_lexp_0.getValues((instanceStruct.instanceVar_PDITSD_i*Vds));
}
if ((instanceStruct.instanceVar_PDITS_i>0.0))
{
instanceStruct.d_instanceVar_T2_dX = (modelStruct.modelPar_PDITSL*instanceStruct.d_instanceVar_Leff_dX+modelStruct.d_modelPar_PDITSL_dX*instanceStruct.instanceVar_Leff);
instanceStruct.instanceVar_T2 = (1.0+(modelStruct.modelPar_PDITSL*instanceStruct.instanceVar_Leff));
d_VaDITS_dX = ((instanceStruct.instanceVar_PDITS_i*(instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T1)-(1.0+(instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T1))*instanceStruct.d_instanceVar_PDITS_i_dX)/instanceStruct.instanceVar_PDITS_i/instanceStruct.instanceVar_PDITS_i);
VaDITS = ((1.0+(instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T1))/instanceStruct.instanceVar_PDITS_i);
d_VaDITS_dX = (VaDITS*d_Fp_dX+d_VaDITS_dX*Fp);
VaDITS = (VaDITS*Fp);
}
else
{
d_VaDITS_dX = 0.0;
VaDITS = 5.540622384e+34;
}
d_T4_dX = ((VaDITS*d_diffVds_dX-diffVds*d_VaDITS_dX)/VaDITS/VaDITS);
T4 = (diffVds/VaDITS);
instanceStruct.d_instanceVar_T0_dX = d_T4_dX;
instanceStruct.instanceVar_T0 = (1.0+T4);
d_Moc_dX = (Moc*instanceStruct.d_instanceVar_T0_dX+d_Moc_dX*instanceStruct.instanceVar_T0);
Moc = (Moc*instanceStruct.instanceVar_T0);
if ((instanceStruct.instanceVar_PSCBE2_i>0.0))
{
if ((diffVds>((instanceStruct.instanceVar_PSCBE1_i*litl)/80.0)))
{
instanceStruct.d_instanceVar_T0_dX = ((diffVds*(instanceStruct.instanceVar_PSCBE1_i*d_litl_dX+instanceStruct.d_instanceVar_PSCBE1_i_dX*litl)-(instanceStruct.instanceVar_PSCBE1_i*litl)*d_diffVds_dX)/diffVds/diffVds);
instanceStruct.instanceVar_T0 = ((instanceStruct.instanceVar_PSCBE1_i*litl)/diffVds);
{
double value_exp_0 = exp(instanceStruct.instanceVar_T0);
double  deriv_exp_0_d0 = value_exp_0;
d_VaSCBE_dX = ((instanceStruct.instanceVar_PSCBE2_i*(instanceStruct.instanceVar_Leff*deriv_exp_0_d0*(instanceStruct.d_instanceVar_T0_dX)+instanceStruct.d_instanceVar_Leff_dX*value_exp_0)-(instanceStruct.instanceVar_Leff*value_exp_0)*instanceStruct.d_instanceVar_PSCBE2_i_dX)/instanceStruct.instanceVar_PSCBE2_i/instanceStruct.instanceVar_PSCBE2_i);
VaSCBE = ((instanceStruct.instanceVar_Leff*value_exp_0)/instanceStruct.instanceVar_PSCBE2_i);
}
}
else
{
d_VaSCBE_dX = ((instanceStruct.instanceVar_PSCBE2_i*5.540622384e+34*instanceStruct.d_instanceVar_Leff_dX-(5.540622384e+34*instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_PSCBE2_i_dX)/instanceStruct.instanceVar_PSCBE2_i/instanceStruct.instanceVar_PSCBE2_i);
VaSCBE = ((5.540622384e+34*instanceStruct.instanceVar_Leff)/instanceStruct.instanceVar_PSCBE2_i);
}
}
else
{
d_VaSCBE_dX = 0.0;
VaSCBE = 5.540622384e+34;
}
d_Mscbe_dX = ((VaSCBE*d_diffVds_dX-diffVds*d_VaSCBE_dX)/VaSCBE/VaSCBE);
Mscbe = (1.0+(diffVds/VaSCBE));
d_Moc_dX = (Moc*d_Mscbe_dX+d_Moc_dX*Mscbe);
Moc = (Moc*Mscbe);
{
double value_pow_0 = pow(Dmob,(1.0/PSAT_a));
double  deriv_pow_0_d0 = ((Dmob == 0.0)?0.0:(value_pow_0*(1.0/PSAT_a)/Dmob));
double  deriv_pow_0_d1 = (Dmob == 0.0)?0.0:(log(Dmob)*value_pow_0);
instanceStruct.d_instanceVar_T0_dX = ((deriv_pow_0_d0*(d_Dmob_dX))+(deriv_pow_0_d1*((-d_PSAT_a_dX/PSAT_a/PSAT_a))));
instanceStruct.instanceVar_T0 = value_pow_0;
}
if ((instanceStruct.instanceVar_PSATB_i<0))
{
instanceStruct.d_instanceVar_T1_dX = (-instanceStruct.d_instanceVar_PSATB_i_dX*Vbsx/(1.0+(instanceStruct.instanceVar_PSATB_i*Vbsx))/(1.0+(instanceStruct.instanceVar_PSATB_i*Vbsx)));
instanceStruct.instanceVar_T1 = (1.0/(1.0+(instanceStruct.instanceVar_PSATB_i*Vbsx)));
}
else
{
instanceStruct.d_instanceVar_T1_dX = (-instanceStruct.d_instanceVar_PSATB_i_dX*Vbsx);
instanceStruct.instanceVar_T1 = (1.0-(instanceStruct.instanceVar_PSATB_i*Vbsx));
}
instanceStruct.d_instanceVar_T2_dX = ((((10.0*modelStruct.modelPar_PSATX)+(qia*instanceStruct.instanceVar_T1))*(((10.0*modelStruct.modelPar_PSATX)*qia)*instanceStruct.d_instanceVar_T1_dX+((10.0*modelStruct.modelPar_PSATX)*d_qia_dX+10.0*modelStruct.d_modelPar_PSATX_dX*qia)*instanceStruct.instanceVar_T1)-(((10.0*modelStruct.modelPar_PSATX)*qia)*instanceStruct.instanceVar_T1)*(10.0*modelStruct.d_modelPar_PSATX_dX+(qia*instanceStruct.d_instanceVar_T1_dX+d_qia_dX*instanceStruct.instanceVar_T1)))/((10.0*modelStruct.modelPar_PSATX)+(qia*instanceStruct.instanceVar_T1))/((10.0*modelStruct.modelPar_PSATX)+(qia*instanceStruct.instanceVar_T1)));
instanceStruct.instanceVar_T2 = ((((10.0*modelStruct.modelPar_PSATX)*qia)*instanceStruct.instanceVar_T1)/((10.0*modelStruct.modelPar_PSATX)+(qia*instanceStruct.instanceVar_T1)));
if ((PTWG_a<0))
{
d_LambdaC_dX = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(-(-(PTWG_a*instanceStruct.d_instanceVar_T2_dX+d_PTWG_a_dX*instanceStruct.instanceVar_T2))/(1.0-(PTWG_a*instanceStruct.instanceVar_T2))/(1.0-(PTWG_a*instanceStruct.instanceVar_T2)))+2.0*(((VSAT_a*instanceStruct.instanceVar_Leff)*((U0_a/instanceStruct.instanceVar_T0)*d_nVt_dX+((instanceStruct.instanceVar_T0*d_U0_a_dX-U0_a*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)*nVt)-((U0_a/instanceStruct.instanceVar_T0)*nVt)*(VSAT_a*instanceStruct.d_instanceVar_Leff_dX+d_VSAT_a_dX*instanceStruct.instanceVar_Leff))/(VSAT_a*instanceStruct.instanceVar_Leff)/(VSAT_a*instanceStruct.instanceVar_Leff))*(1.0/(1.0-(PTWG_a*instanceStruct.instanceVar_T2))));
LambdaC = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(1.0/(1.0-(PTWG_a*instanceStruct.instanceVar_T2))));
}
else
{
d_LambdaC_dX = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(PTWG_a*instanceStruct.d_instanceVar_T2_dX+d_PTWG_a_dX*instanceStruct.instanceVar_T2)+2.0*(((VSAT_a*instanceStruct.instanceVar_Leff)*((U0_a/instanceStruct.instanceVar_T0)*d_nVt_dX+((instanceStruct.instanceVar_T0*d_U0_a_dX-U0_a*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)*nVt)-((U0_a/instanceStruct.instanceVar_T0)*nVt)*(VSAT_a*instanceStruct.d_instanceVar_Leff_dX+d_VSAT_a_dX*instanceStruct.instanceVar_Leff))/(VSAT_a*instanceStruct.instanceVar_Leff)/(VSAT_a*instanceStruct.instanceVar_Leff))*(1.0+(PTWG_a*instanceStruct.instanceVar_T2)));
LambdaC = ((2.0*(((U0_a/instanceStruct.instanceVar_T0)*nVt)/(VSAT_a*instanceStruct.instanceVar_Leff)))*(1.0+(PTWG_a*instanceStruct.instanceVar_T2)));
}
instanceStruct.d_instanceVar_T1_dX = ((2.0*LambdaC)*(d_qs_dX-d_qdeff_dX)+2.0*d_LambdaC_dX*(qs-qdeff));
instanceStruct.instanceVar_T1 = ((2.0*LambdaC)*(qs-qdeff));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1));
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
if ((instanceStruct.instanceVar_T1!=0))
{
{
double value_asinh_0 = asinh(instanceStruct.instanceVar_T1);
double  deriv_asinh_0_d0 = (1.0/(sqrt(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1+1.0)));
d_Dvsat_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX+((1.0/instanceStruct.instanceVar_T1)*deriv_asinh_0_d0*(instanceStruct.d_instanceVar_T1_dX)+(-instanceStruct.d_instanceVar_T1_dX/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1)*value_asinh_0));
Dvsat = (0.5*(instanceStruct.instanceVar_T2+((1.0/instanceStruct.instanceVar_T1)*value_asinh_0)));
}
}
else
{
d_Dvsat_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX+(-instanceStruct.d_instanceVar_T2_dX/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2));
Dvsat = (0.5*(instanceStruct.instanceVar_T2+(1.0/instanceStruct.instanceVar_T2)));
}
d_Dptwg_dX = d_Dvsat_dX;
Dptwg = Dvsat;
d_Rsource_dX = 0.0;
Rsource = 0.0;
d_Rdrain_dX = 0.0;
Rdrain = 0.0;
if ((modelStruct.modelPar_RDSMOD==1))
{
d_Rdsi_dX = 0.0;
Rdsi = 0.0;
d_Dr_dX = 0.0;
Dr = 1.0;
instanceStruct.d_instanceVar_T2_dX = (-d_Vfbsdr_dX);
instanceStruct.instanceVar_T2 = (Vgs_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2));
T3 = value_sqrt_0;
}
d_Vgs_eff_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX+d_T3_dX);
Vgs_eff = (0.5*(instanceStruct.instanceVar_T2+T3));
d_T5_dX = (instanceStruct.instanceVar_PRWG_i*d_Vgs_eff_dX+instanceStruct.d_instanceVar_PRWG_i_dX*Vgs_eff);
T5 = (1.0+(instanceStruct.instanceVar_PRWG_i*Vgs_eff));
d_T6_dX = ((-d_T5_dX/T5/T5)+instanceStruct.d_instanceVar_PRWB_i_dX*Vsb_noswap);
T6 = ((1.0/T5)+(instanceStruct.instanceVar_PRWB_i*Vsb_noswap));
{
double value_sqrt_0 = sqrt(((T6*T6)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T4_dX = 0.5*(d_T6_dX+deriv_sqrt_0_d0*((T6*d_T6_dX+d_T6_dX*T6)));
T4 = (0.5*(T6+value_sqrt_0));
}
d_Rsource_dX = (rdstemp*(instanceStruct.d_instanceVar_RSourceGeo_dX+((instanceStruct.instanceVar_RSWMIN_i+(instanceStruct.instanceVar_RSW_i*T4))*d_WeffWRFactor_dX+(instanceStruct.d_instanceVar_RSWMIN_i_dX+(instanceStruct.instanceVar_RSW_i*d_T4_dX+instanceStruct.d_instanceVar_RSW_i_dX*T4))*WeffWRFactor))+d_rdstemp_dX*(instanceStruct.instanceVar_RSourceGeo+((instanceStruct.instanceVar_RSWMIN_i+(instanceStruct.instanceVar_RSW_i*T4))*WeffWRFactor)));
Rsource = (rdstemp*(instanceStruct.instanceVar_RSourceGeo+((instanceStruct.instanceVar_RSWMIN_i+(instanceStruct.instanceVar_RSW_i*T4))*WeffWRFactor)));
instanceStruct.d_instanceVar_T2_dX = (-d_Vfbsdr_dX);
instanceStruct.instanceVar_T2 = (Vgd_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2));
T3 = value_sqrt_0;
}
d_Vgd_eff_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX+d_T3_dX);
Vgd_eff = (0.5*(instanceStruct.instanceVar_T2+T3));
d_T5_dX = (instanceStruct.instanceVar_PRWG_i*d_Vgd_eff_dX+instanceStruct.d_instanceVar_PRWG_i_dX*Vgd_eff);
T5 = (1.0+(instanceStruct.instanceVar_PRWG_i*Vgd_eff));
d_T6_dX = ((-d_T5_dX/T5/T5)+instanceStruct.d_instanceVar_PRWB_i_dX*Vdb_noswap);
T6 = ((1.0/T5)+(instanceStruct.instanceVar_PRWB_i*Vdb_noswap));
{
double value_sqrt_0 = sqrt(((T6*T6)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T4_dX = 0.5*(d_T6_dX+deriv_sqrt_0_d0*((T6*d_T6_dX+d_T6_dX*T6)));
T4 = (0.5*(T6+value_sqrt_0));
}
d_Rdrain_dX = (rdstemp*(instanceStruct.d_instanceVar_RDrainGeo_dX+((instanceStruct.instanceVar_RDWMIN_i+(instanceStruct.instanceVar_RDW_i*T4))*d_WeffWRFactor_dX+(instanceStruct.d_instanceVar_RDWMIN_i_dX+(instanceStruct.instanceVar_RDW_i*d_T4_dX+instanceStruct.d_instanceVar_RDW_i_dX*T4))*WeffWRFactor))+d_rdstemp_dX*(instanceStruct.instanceVar_RDrainGeo+((instanceStruct.instanceVar_RDWMIN_i+(instanceStruct.instanceVar_RDW_i*T4))*WeffWRFactor)));
Rdrain = (rdstemp*(instanceStruct.instanceVar_RDrainGeo+((instanceStruct.instanceVar_RDWMIN_i+(instanceStruct.instanceVar_RDW_i*T4))*WeffWRFactor)));
}
else
{
instanceStruct.d_instanceVar_T0_dX = (instanceStruct.instanceVar_PRWG_i*d_qia_dX+instanceStruct.d_instanceVar_PRWG_i_dX*qia);
instanceStruct.instanceVar_T0 = (1.0+(instanceStruct.instanceVar_PRWG_i*qia));
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.instanceVar_PRWB_i*(d_sqrtPhistVbs_dX-d_sqrtPhist_dX)+instanceStruct.d_instanceVar_PRWB_i_dX*(sqrtPhistVbs-sqrtPhist));
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_PRWB_i*(sqrtPhistVbs-sqrtPhist));
instanceStruct.d_instanceVar_T2_dX = ((-instanceStruct.d_instanceVar_T0_dX/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0)+instanceStruct.d_instanceVar_T1_dX);
instanceStruct.instanceVar_T2 = ((1.0/instanceStruct.instanceVar_T0)+instanceStruct.instanceVar_T1);
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX+deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2)));
T3 = (0.5*(instanceStruct.instanceVar_T2+value_sqrt_0));
}
d_Rdsi_dX = ((rdstemp*(instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3)))*d_WeffWRFactor_dX+(rdstemp*(instanceStruct.d_instanceVar_RDSWMIN_i_dX+(instanceStruct.instanceVar_RDSW_i*d_T3_dX+instanceStruct.d_instanceVar_RDSW_i_dX*T3))+d_rdstemp_dX*(instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3)))*WeffWRFactor)*instanceStruct.instancePar_NF;
Rdsi = (((rdstemp*(instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3)))*WeffWRFactor)*instanceStruct.instancePar_NF);
d_Rdrain_dX = instanceStruct.d_instanceVar_RDrainGeo_dX;
Rdrain = instanceStruct.instanceVar_RDrainGeo;
d_Rsource_dX = instanceStruct.d_instanceVar_RSourceGeo_dX;
Rsource = instanceStruct.instanceVar_RSourceGeo;
d_Dr_dX = ((((((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*qia)*d_Rdsi_dX+(((((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*d_qia_dX+((instanceStruct.instanceVar_Leff*(((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.d_instanceVar_Weff_dX+((U0_a/(Dvsat*Dmob))*instanceStruct.d_instanceVar_Cox_dX+(((Dvsat*Dmob)*d_U0_a_dX-U0_a*(Dvsat*d_Dmob_dX+d_Dvsat_dX*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)-(((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff)*qia)*Rdsi);
Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*qia)*Rdsi));
if ((modelStruct.modelPar_RDSMOD==2))
{
d_Rdsi_dX = (rdstemp*((instanceStruct.d_instanceVar_RSourceGeo_dX+((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*d_WeffWRFactor_dX+(instanceStruct.d_instanceVar_RDSWMIN_i_dX+(instanceStruct.instanceVar_RDSW_i*d_T3_dX+instanceStruct.d_instanceVar_RDSW_i_dX*T3))*WeffWRFactor)*instanceStruct.instancePar_NF)+instanceStruct.d_instanceVar_RDrainGeo_dX)+d_rdstemp_dX*((instanceStruct.instanceVar_RSourceGeo+(((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*WeffWRFactor)*instanceStruct.instancePar_NF))+instanceStruct.instanceVar_RDrainGeo));
Rdsi = (rdstemp*((instanceStruct.instanceVar_RSourceGeo+(((instanceStruct.instanceVar_RDSWMIN_i+(instanceStruct.instanceVar_RDSW_i*T3))*WeffWRFactor)*instanceStruct.instancePar_NF))+instanceStruct.instanceVar_RDrainGeo));
d_Rdrain_dX = 0.0;
Rdrain = 0;
d_Rsource_dX = 0.0;
Rsource = 0;
d_Dr_dX = ((((((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*qia)*d_Rdsi_dX+(((((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*d_qia_dX+((instanceStruct.instanceVar_Leff*(((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.d_instanceVar_Weff_dX+((U0_a/(Dvsat*Dmob))*instanceStruct.d_instanceVar_Cox_dX+(((Dvsat*Dmob)*d_U0_a_dX-U0_a*(Dvsat*d_Dmob_dX+d_Dvsat_dX*Dmob))/(Dvsat*Dmob)/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)-(((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff)*qia)*Rdsi);
Dr = (1.0+((((((U0_a/(Dvsat*Dmob))*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*qia)*Rdsi));
}
}
instanceStruct.d_instanceVar_T0_dX = (d_A1_t_dX+(((qia+((2.0*n)*Vtm))*d_A2_t_dX-A2_t*(d_qia_dX+((2.0*n)*d_Vtm_dX+2.0*d_n_dX*Vtm)))/(qia+((2.0*n)*Vtm))/(qia+((2.0*n)*Vtm))));
instanceStruct.instanceVar_T0 = (A1_t+(A2_t/(qia+((2.0*n)*Vtm))));
d_DQSD_dX = (d_qs_dX-d_qdeff_dX);
DQSD = (qs-qdeff);
instanceStruct.d_instanceVar_T1_dX = ((instanceStruct.instanceVar_T0*DQSD)*d_DQSD_dX+(instanceStruct.instanceVar_T0*d_DQSD_dX+instanceStruct.d_instanceVar_T0_dX*DQSD)*DQSD);
instanceStruct.instanceVar_T1 = ((instanceStruct.instanceVar_T0*DQSD)*DQSD);
instanceStruct.d_instanceVar_T2_dX = instanceStruct.d_instanceVar_T1_dX;
instanceStruct.instanceVar_T2 = ((instanceStruct.instanceVar_T1+1.0)-0.001);
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+0.004));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX+deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2)));
T3 = ((-1.0)+(0.5*(instanceStruct.instanceVar_T2+value_sqrt_0)));
}
{
double value_sqrt_0 = sqrt((1.0+T3));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Nsat_dX = 0.5*deriv_sqrt_0_d0*(d_T3_dX);
Nsat = (0.5*(1.0+value_sqrt_0));
}
d_Dtot_dX = ((Dmob*Dvsat)*d_Dr_dX+(Dmob*d_Dvsat_dX+d_Dmob_dX*Dvsat)*Dr);
Dtot = ((Dmob*Dvsat)*Dr);
d_ueff_dX = ((Dtot*d_U0_a_dX-U0_a*d_Dtot_dX)/Dtot/Dtot);
ueff = (U0_a/Dtot);
d_ids_dX = ((Nsat*((((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dX+(((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dX+d_qdeff_dX)+(d_qs_dX-d_qdeff_dX)*((1.0+qs)+qdeff))+((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*d_nVt_dX+(((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*d_nVt_dX+((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_Cox_dX+((instanceStruct.instanceVar_Leff*((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.d_instanceVar_Weff_dX+(((2.0*instanceStruct.instancePar_NF)*nq)*d_ueff_dX+(2.0*instanceStruct.instancePar_NF)*d_nq_dX*ueff)*instanceStruct.instanceVar_Weff)-((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)-((((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)*d_Nsat_dX)/Nsat/Nsat);
ids = (((((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc)/Nsat);
d_Gcrg_dX = 0.0;
Gcrg = 0.0;
if ((instanceStruct.instancePar_RGATEMOD>1))
{
d_idsovvds_dX = ((((ueff*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*d_qia_dX+(((ueff*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_Cox_dX+((instanceStruct.instanceVar_Leff*(ueff*instanceStruct.d_instanceVar_Weff_dX+d_ueff_dX*instanceStruct.instanceVar_Weff)-(ueff*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*qia);
idsovvds = ((((ueff*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*qia);
d_T9_dX = (modelStruct.modelPar_XRCRG2*d_Vt_dX+modelStruct.d_modelPar_XRCRG2_dX*Vt);
T9 = (modelStruct.modelPar_XRCRG2*Vt);
instanceStruct.d_instanceVar_T0_dX = ((((T9*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_Cox_dX+((instanceStruct.instanceVar_Leff*((T9*ueff)*instanceStruct.d_instanceVar_Weff_dX+(T9*d_ueff_dX+d_T9_dX*ueff)*instanceStruct.instanceVar_Weff)-((T9*ueff)*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox);
instanceStruct.instanceVar_T0 = ((((T9*ueff)*instanceStruct.instanceVar_Weff)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox);
d_Gcrg_dX = ((modelStruct.modelPar_XRCRG1*instanceStruct.instancePar_NF)*(instanceStruct.d_instanceVar_T0_dX+d_idsovvds_dX)+modelStruct.d_modelPar_XRCRG1_dX*instanceStruct.instancePar_NF*(instanceStruct.instanceVar_T0+idsovvds));
Gcrg = ((modelStruct.modelPar_XRCRG1*instanceStruct.instancePar_NF)*(instanceStruct.instanceVar_T0+idsovvds));
if ((instanceStruct.instancePar_RGATEMOD==2))
{
d_T11_dX = (instanceStruct.d_instanceVar_Grgeltd_dX+d_Gcrg_dX);
T11 = (instanceStruct.instanceVar_Grgeltd+Gcrg);
d_Gcrg_dX = ((T11*(instanceStruct.instanceVar_Grgeltd*d_Gcrg_dX+instanceStruct.d_instanceVar_Grgeltd_dX*Gcrg)-(instanceStruct.instanceVar_Grgeltd*Gcrg)*d_T11_dX)/T11/T11);
Gcrg = ((instanceStruct.instanceVar_Grgeltd*Gcrg)/T11);
}
}
if (((instanceStruct.instanceVar_ALPHA0_i<=0.0)||(BETA0_t<=0.0)))
{
d_Iii_dX = 0.0;
Iii = 0.0;
}
else
{
if ((diffVds>(BETA0_t/80.0)))
{
instanceStruct.d_instanceVar_T1_dX = ((diffVds*(-d_BETA0_t_dX)-(-BETA0_t)*d_diffVds_dX)/diffVds/diffVds);
instanceStruct.instanceVar_T1 = ((-BETA0_t)/diffVds);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(instanceStruct.instanceVar_T1);
d_Iii_dX = ((Mscbe*(((instanceStruct.instanceVar_ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getDerivs(instanceStruct.instanceVar_T1,instanceStruct.d_instanceVar_T1_dX)+((instanceStruct.instanceVar_ALPHA0_i*diffVds)*d_ids_dX+(instanceStruct.instanceVar_ALPHA0_i*d_diffVds_dX+instanceStruct.d_instanceVar_ALPHA0_i_dX*diffVds)*ids)*evaluator_lexp_0.getValues(instanceStruct.instanceVar_T1))-(((instanceStruct.instanceVar_ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getValues(instanceStruct.instanceVar_T1))*d_Mscbe_dX)/Mscbe/Mscbe);
Iii = ((((instanceStruct.instanceVar_ALPHA0_i*diffVds)*ids)*evaluator_lexp_0.getValues(instanceStruct.instanceVar_T1))/Mscbe);
}
}
else
{
d_Iii_dX = ((Mscbe*((instanceStruct.instanceVar_ALPHA0_i*diffVds)*d_ids_dX+(instanceStruct.instanceVar_ALPHA0_i*d_diffVds_dX+instanceStruct.d_instanceVar_ALPHA0_i_dX*diffVds)*ids)*1.804851387e-35-(((instanceStruct.instanceVar_ALPHA0_i*diffVds)*ids)*1.804851387e-35)*d_Mscbe_dX)/Mscbe/Mscbe);
Iii = ((((instanceStruct.instanceVar_ALPHA0_i*diffVds)*ids)*1.804851387e-35)/Mscbe);
}
}
instanceStruct.d_instanceVar_ISUB_dX = d_Iii_dX*instanceStruct.instanceVar_devsign;
instanceStruct.instanceVar_ISUB = (Iii*instanceStruct.instanceVar_devsign);
d_igbinv_dX = 0.0;
igbinv = 0.0;
d_igbacc_dX = 0.0;
igbacc = 0.0;
d_igb_dX = 0.0;
igb = 0.0;
d_igcs_dX = 0.0;
igcs = 0.0;
d_igcd_dX = 0.0;
igcd = 0.0;
d_igs_dX = 0.0;
igs = 0.0;
d_igd_dX = 0.0;
igd = 0.0;
if (((modelStruct.modelPar_IGCMOD!=0)||(modelStruct.modelPar_IGBMOD!=0)))
{
d_Voxm_dX = (nVt*(((d_vgfb_dX-d_psip_dX)+d_qs_dX)+d_qdeff_dX)+d_nVt_dX*(((vgfb-psip)+qs)+qdeff));
Voxm = (nVt*(((vgfb-psip)+qs)+qdeff));
{
double value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0E-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T1_dX = deriv_sqrt_0_d0*((Voxm*d_Voxm_dX+d_Voxm_dX*Voxm));
instanceStruct.instanceVar_T1 = value_sqrt_0;
}
d_Voxmacc_dX = 0.5*((-d_Voxm_dX)+instanceStruct.d_instanceVar_T1_dX);
Voxmacc = (0.5*((-Voxm)+instanceStruct.instanceVar_T1));
d_Voxminv_dX = 0.5*(d_Voxm_dX+instanceStruct.d_instanceVar_T1_dX);
Voxminv = (0.5*(Voxm+instanceStruct.instanceVar_T1));
if ((modelStruct.modelPar_IGBMOD!=0))
{
instanceStruct.d_instanceVar_T1_dX = ((Vt*((instanceStruct.instanceVar_NIGBACC_i*d_Voxmacc_dX-Voxmacc*instanceStruct.d_instanceVar_NIGBACC_i_dX)/instanceStruct.instanceVar_NIGBACC_i/instanceStruct.instanceVar_NIGBACC_i)-(Voxmacc/instanceStruct.instanceVar_NIGBACC_i)*d_Vt_dX)/Vt/Vt);
instanceStruct.instanceVar_T1 = ((Voxmacc/instanceStruct.instanceVar_NIGBACC_i)/Vt);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-instanceStruct.instanceVar_T1));
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T1))));
d_Vaux_Igbacc_dX = ((instanceStruct.instanceVar_NIGBACC_i*Vt)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T1))),evaluator_lexp_0.getDerivs((-instanceStruct.instanceVar_T1),(-instanceStruct.d_instanceVar_T1_dX)))+(instanceStruct.instanceVar_NIGBACC_i*d_Vt_dX+instanceStruct.d_instanceVar_NIGBACC_i_dX*Vt)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T1)))));
Vaux_Igbacc = ((instanceStruct.instanceVar_NIGBACC_i*Vt)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T1)))));
}
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_AIGBACC_i_dX-(instanceStruct.instanceVar_BIGBACC_i*d_Voxmacc_dX+instanceStruct.d_instanceVar_BIGBACC_i_dX*Voxmacc));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_AIGBACC_i-(instanceStruct.instanceVar_BIGBACC_i*Voxmacc));
d_T3_dX = (instanceStruct.instanceVar_CIGBACC_i*d_Voxmacc_dX+instanceStruct.d_instanceVar_CIGBACC_i_dX*Voxmacc);
T3 = (1.0+(instanceStruct.instanceVar_CIGBACC_i*Voxmacc));
d_T4_dX = ((((-7.45669e11)*modelStruct.modelPar_TOXE)*instanceStruct.instanceVar_T2)*d_T3_dX+(((-7.45669e11)*modelStruct.modelPar_TOXE)*instanceStruct.d_instanceVar_T2_dX+(-7.45669e11)*modelStruct.d_modelPar_TOXE_dX*instanceStruct.instanceVar_T2)*T3);
T4 = ((((-7.45669e11)*modelStruct.modelPar_TOXE)*instanceStruct.instanceVar_T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);
d_T5_dX = evaluator_lexp_0.getDerivs(T4,d_T4_dX);
T5 = evaluator_lexp_0.getValues(T4);
}
d_T6_dX = 0.0;
T6 = 4.97232e-7;
d_igbacc_dX = (((((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg)*Vaux_Igbacc)*d_T5_dX+((((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg)*d_Vaux_Igbacc_dX+((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.d_instanceVar_ToxRatio_dX+(((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*d_T6_dX+((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX+instanceStruct.instancePar_NF*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg*Vaux_Igbacc)*T5);
igbacc = (((((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg)*Vaux_Igbacc)*T5);
d_igbacc_dX = (igbacc*d_igtemp_dX+d_igbacc_dX*igtemp);
igbacc = (igbacc*igtemp);
instanceStruct.d_instanceVar_T1_dX = ((Vt*((instanceStruct.instanceVar_NIGBINV_i*(d_Voxminv_dX-instanceStruct.d_instanceVar_EIGBINV_i_dX)-(Voxminv-instanceStruct.instanceVar_EIGBINV_i)*instanceStruct.d_instanceVar_NIGBINV_i_dX)/instanceStruct.instanceVar_NIGBINV_i/instanceStruct.instanceVar_NIGBINV_i)-((Voxminv-instanceStruct.instanceVar_EIGBINV_i)/instanceStruct.instanceVar_NIGBINV_i)*d_Vt_dX)/Vt/Vt);
instanceStruct.instanceVar_T1 = (((Voxminv-instanceStruct.instanceVar_EIGBINV_i)/instanceStruct.instanceVar_NIGBINV_i)/Vt);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(instanceStruct.instanceVar_T1);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+evaluator_lexp_0.getValues(instanceStruct.instanceVar_T1)));
d_Vaux_Igbinv_dX = ((instanceStruct.instanceVar_NIGBINV_i*Vt)*evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(instanceStruct.instanceVar_T1)),evaluator_lexp_0.getDerivs(instanceStruct.instanceVar_T1,instanceStruct.d_instanceVar_T1_dX))+(instanceStruct.instanceVar_NIGBINV_i*d_Vt_dX+instanceStruct.d_instanceVar_NIGBINV_i_dX*Vt)*evaluator_lln_1.getValues((1.0+evaluator_lexp_0.getValues(instanceStruct.instanceVar_T1))));
Vaux_Igbinv = ((instanceStruct.instanceVar_NIGBINV_i*Vt)*evaluator_lln_1.getValues((1.0+evaluator_lexp_0.getValues(instanceStruct.instanceVar_T1))));
}
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_AIGBINV_i_dX-(instanceStruct.instanceVar_BIGBINV_i*d_Voxminv_dX+instanceStruct.d_instanceVar_BIGBINV_i_dX*Voxminv));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_AIGBINV_i-(instanceStruct.instanceVar_BIGBINV_i*Voxminv));
d_T3_dX = (instanceStruct.instanceVar_CIGBINV_i*d_Voxminv_dX+instanceStruct.d_instanceVar_CIGBINV_i_dX*Voxminv);
T3 = (1.0+(instanceStruct.instanceVar_CIGBINV_i*Voxminv));
d_T4_dX = ((((-9.82222e11)*modelStruct.modelPar_TOXE)*instanceStruct.instanceVar_T2)*d_T3_dX+(((-9.82222e11)*modelStruct.modelPar_TOXE)*instanceStruct.d_instanceVar_T2_dX+(-9.82222e11)*modelStruct.d_modelPar_TOXE_dX*instanceStruct.instanceVar_T2)*T3);
T4 = ((((-9.82222e11)*modelStruct.modelPar_TOXE)*instanceStruct.instanceVar_T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);
d_T5_dX = evaluator_lexp_0.getDerivs(T4,d_T4_dX);
T5 = evaluator_lexp_0.getValues(T4);
}
d_T6_dX = 0.0;
T6 = 3.75956e-7;
d_igbinv_dX = (((((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg)*Vaux_Igbinv)*d_T5_dX+((((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg)*d_Vaux_Igbinv_dX+((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.d_instanceVar_ToxRatio_dX+(((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*d_T6_dX+((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX+instanceStruct.instancePar_NF*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg*Vaux_Igbinv)*T5);
igbinv = (((((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*T6)*instanceStruct.instanceVar_ToxRatio)*Vg)*Vaux_Igbinv)*T5);
d_igbinv_dX = (igbinv*d_igtemp_dX+d_igbinv_dX*igtemp);
igbinv = (igbinv*igtemp);
d_igb_dX = (d_igbacc_dX+d_igbinv_dX);
igb = (igbacc+igbinv);
}
if ((modelStruct.modelPar_IGCMOD!=0))
{
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.d_instanceVar_AIGC_i_dX-(instanceStruct.instanceVar_BIGC_i*d_Voxminv_dX+instanceStruct.d_instanceVar_BIGC_i_dX*Voxminv));
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_AIGC_i-(instanceStruct.instanceVar_BIGC_i*Voxminv));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.instanceVar_CIGC_i*d_Voxminv_dX+instanceStruct.d_instanceVar_CIGC_i_dX*Voxminv);
instanceStruct.instanceVar_T2 = (1.0+(instanceStruct.instanceVar_CIGC_i*Voxminv));
d_T3_dX = ((instanceStruct.instanceVar_Bechvb*instanceStruct.instanceVar_T1)*instanceStruct.d_instanceVar_T2_dX+(instanceStruct.instanceVar_Bechvb*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_Bechvb_dX*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2);
T3 = ((instanceStruct.instanceVar_Bechvb*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);
d_T4_dX = (((nq*nVt)*(qs+qdeff))*evaluator_lexp_0.getDerivs(T3,d_T3_dX)+((nq*nVt)*(d_qs_dX+d_qdeff_dX)+(nq*d_nVt_dX+d_nq_dX*nVt)*(qs+qdeff))*evaluator_lexp_0.getValues(T3));
T4 = (((nq*nVt)*(qs+qdeff))*evaluator_lexp_0.getValues(T3));
}
d_igc0_dX = ((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*d_igtemp_dX+((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Aechvb)*d_T4_dX+instanceStruct.instancePar_NF*instanceStruct.d_instanceVar_Aechvb_dX*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd)))*igtemp);
igc0 = ((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Aechvb)*T4)*((Vg+(0.5*Vdsx))-(0.5*(Vs+Vd))))*igtemp);
{
double value_sqrt_0 = sqrt(((Vdseff*Vdseff)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdseffx_dX = deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dX+d_Vdseff_dX*Vdseff));
Vdseffx = (value_sqrt_0-0.1);
}
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.instanceVar_PIGCD_i*d_Vdseffx_dX+instanceStruct.d_instanceVar_PIGCD_i_dX*Vdseffx);
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_PIGCD_i*Vdseffx);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-instanceStruct.instanceVar_T1));
d_T1_exp_dX = evaluator_lexp_0.getDerivs((-instanceStruct.instanceVar_T1),(-instanceStruct.d_instanceVar_T1_dX));
T1_exp = evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T1));
}
d_T3_dX = (instanceStruct.d_instanceVar_T1_dX+d_T1_exp_dX);
T3 = (((instanceStruct.instanceVar_T1+T1_exp)-1.0)+1.0E-4);
d_T4_dX = (-((instanceStruct.instanceVar_T1+1.0)*d_T1_exp_dX+instanceStruct.d_instanceVar_T1_dX*T1_exp));
T4 = ((1.0-((instanceStruct.instanceVar_T1+1.0)*T1_exp))+1.0E-4);
d_T5_dX = (instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1);
T5 = ((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)+2.0E-4);
if ((sigvds>0))
{
d_igcd_dX = ((T5*(igc0*d_T4_dX+d_igc0_dX*T4)-(igc0*T4)*d_T5_dX)/T5/T5);
igcd = ((igc0*T4)/T5);
d_igcs_dX = ((T5*(igc0*d_T3_dX+d_igc0_dX*T3)-(igc0*T3)*d_T5_dX)/T5/T5);
igcs = ((igc0*T3)/T5);
}
else
{
d_igcs_dX = ((T5*(igc0*d_T4_dX+d_igc0_dX*T4)-(igc0*T4)*d_T5_dX)/T5/T5);
igcs = ((igc0*T4)/T5);
d_igcd_dX = ((T5*(igc0*d_T3_dX+d_igc0_dX*T3)-(igc0*T3)*d_T5_dX)/T5/T5);
igcd = ((igc0*T3)/T5);
}
instanceStruct.d_instanceVar_T2_dX = (-d_Vfbsdr_dX);
instanceStruct.instanceVar_T2 = (Vgs_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vgs_eff_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2));
Vgs_eff = value_sqrt_0;
}
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.d_instanceVar_AIGS_i_dX-(instanceStruct.instanceVar_BIGS_i*d_Vgs_eff_dX+instanceStruct.d_instanceVar_BIGS_i_dX*Vgs_eff));
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_AIGS_i-(instanceStruct.instanceVar_BIGS_i*Vgs_eff));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.instanceVar_CIGS_i*d_Vgs_eff_dX+instanceStruct.d_instanceVar_CIGS_i_dX*Vgs_eff);
instanceStruct.instanceVar_T2 = (1.0+(instanceStruct.instanceVar_CIGS_i*Vgs_eff));
d_T3_dX = ((instanceStruct.instanceVar_BechvbEdge*instanceStruct.instanceVar_T1)*instanceStruct.d_instanceVar_T2_dX+(instanceStruct.instanceVar_BechvbEdge*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_BechvbEdge_dX*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2);
T3 = ((instanceStruct.instanceVar_BechvbEdge*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);
d_T4_dX = evaluator_lexp_0.getDerivs(T3,d_T3_dX);
T4 = evaluator_lexp_0.getValues(T3);
}
d_igs_mult_dX = (((igtemp*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_AechvbEdge)*instanceStruct.d_instanceVar_DLCIG_i_dX+((igtemp*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_AechvbEdge_dX+d_igtemp_dX*instanceStruct.instancePar_NF*instanceStruct.instanceVar_AechvbEdge)*instanceStruct.instanceVar_DLCIG_i);
igs_mult = (((igtemp*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_AechvbEdge)*instanceStruct.instanceVar_DLCIG_i);
d_igs_dX = (((igs_mult*Vgs_noswap)*Vgs_eff)*d_T4_dX+((igs_mult*Vgs_noswap)*d_Vgs_eff_dX+d_igs_mult_dX*Vgs_noswap*Vgs_eff)*T4);
igs = (((igs_mult*Vgs_noswap)*Vgs_eff)*T4);
instanceStruct.d_instanceVar_T2_dX = (-d_Vfbsdr_dX);
instanceStruct.instanceVar_T2 = (Vgd_noswap-Vfbsdr);
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vgd_eff_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2));
Vgd_eff = value_sqrt_0;
}
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.d_instanceVar_AIGD_i_dX-(instanceStruct.instanceVar_BIGD_i*d_Vgd_eff_dX+instanceStruct.d_instanceVar_BIGD_i_dX*Vgd_eff));
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_AIGD_i-(instanceStruct.instanceVar_BIGD_i*Vgd_eff));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.instanceVar_CIGD_i*d_Vgd_eff_dX+instanceStruct.d_instanceVar_CIGD_i_dX*Vgd_eff);
instanceStruct.instanceVar_T2 = (1.0+(instanceStruct.instanceVar_CIGD_i*Vgd_eff));
d_T3_dX = ((instanceStruct.instanceVar_BechvbEdge*instanceStruct.instanceVar_T1)*instanceStruct.d_instanceVar_T2_dX+(instanceStruct.instanceVar_BechvbEdge*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_BechvbEdge_dX*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2);
T3 = ((instanceStruct.instanceVar_BechvbEdge*instanceStruct.instanceVar_T1)*instanceStruct.instanceVar_T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);
d_T4_dX = evaluator_lexp_0.getDerivs(T3,d_T3_dX);
T4 = evaluator_lexp_0.getValues(T3);
}
d_igd_mult_dX = (((igtemp*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_AechvbEdge)*instanceStruct.d_instanceVar_DLCIGD_i_dX+((igtemp*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_AechvbEdge_dX+d_igtemp_dX*instanceStruct.instancePar_NF*instanceStruct.instanceVar_AechvbEdge)*instanceStruct.instanceVar_DLCIGD_i);
igd_mult = (((igtemp*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_AechvbEdge)*instanceStruct.instanceVar_DLCIGD_i);
d_igd_dX = (((igd_mult*Vgd_noswap)*Vgd_eff)*d_T4_dX+((igd_mult*Vgd_noswap)*d_Vgd_eff_dX+d_igd_mult_dX*Vgd_noswap*Vgd_eff)*T4);
igd = (((igd_mult*Vgd_noswap)*Vgd_eff)*T4);
}
}
instanceStruct.d_instanceVar_IGS_dX = instanceStruct.instanceVar_devsign*d_igs_dX;
instanceStruct.instanceVar_IGS = (instanceStruct.instanceVar_devsign*igs);
instanceStruct.d_instanceVar_IGD_dX = instanceStruct.instanceVar_devsign*d_igd_dX;
instanceStruct.instanceVar_IGD = (instanceStruct.instanceVar_devsign*igd);
instanceStruct.d_instanceVar_IGB_dX = instanceStruct.instanceVar_devsign*d_igb_dX;
instanceStruct.instanceVar_IGB = (instanceStruct.instanceVar_devsign*igb);
instanceStruct.d_instanceVar_IGCS_dX = instanceStruct.instanceVar_devsign*d_igcs_dX;
instanceStruct.instanceVar_IGCS = (instanceStruct.instanceVar_devsign*igcs);
instanceStruct.d_instanceVar_IGCD_dX = instanceStruct.instanceVar_devsign*d_igcd_dX;
instanceStruct.instanceVar_IGCD = (instanceStruct.instanceVar_devsign*igcd);
d_igisl_dX = 0.0;
igisl = 0.0;
d_igidl_dX = 0.0;
igidl = 0.0;
if ((modelStruct.modelPar_GIDLMOD!=0))
{
instanceStruct.d_instanceVar_T0_dX = (instanceStruct.instanceVar_epsratio*modelStruct.d_modelPar_TOXE_dX+instanceStruct.d_instanceVar_epsratio_dX*modelStruct.modelPar_TOXE);
instanceStruct.instanceVar_T0 = (instanceStruct.instanceVar_epsratio*modelStruct.modelPar_TOXE);
if ((((instanceStruct.instanceVar_AGIDL_i<=0.0)||(BGIDL_t<=0.0))||(instanceStruct.instanceVar_CGIDL_i<0.0)))
{
d_T6_dX = 0.0;
T6 = 0.0;
}
else
{
instanceStruct.d_instanceVar_T1_dX = ((instanceStruct.instanceVar_T0*((-instanceStruct.d_instanceVar_EGIDL_i_dX)+d_Vfbsdr_dX)-(((-Vgd_noswap)-instanceStruct.instanceVar_EGIDL_i)+Vfbsdr)*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_T1 = ((((-Vgd_noswap)-instanceStruct.instanceVar_EGIDL_i)+Vfbsdr)/instanceStruct.instanceVar_T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(instanceStruct.instanceVar_T1,1.0E-2);
instanceStruct.d_instanceVar_T1_dX = evaluator_hypsmooth_0.getDerivs(instanceStruct.instanceVar_T1,1.0E-2,instanceStruct.d_instanceVar_T1_dX,0.0);
instanceStruct.instanceVar_T1 = evaluator_hypsmooth_0.getValues(instanceStruct.instanceVar_T1,1.0E-2);
}
instanceStruct.d_instanceVar_T2_dX = (((instanceStruct.instanceVar_T1+1.0E-3)*d_BGIDL_t_dX-BGIDL_t*instanceStruct.d_instanceVar_T1_dX)/(instanceStruct.instanceVar_T1+1.0E-3)/(instanceStruct.instanceVar_T1+1.0E-3));
instanceStruct.instanceVar_T2 = (BGIDL_t/(instanceStruct.instanceVar_T1+1.0E-3));
if ((instanceStruct.instanceVar_CGIDL_i!=0))
{
d_T3_dX = 0.0;
T3 = ((Vdb_noswap*Vdb_noswap)*Vdb_noswap);
{
double value_fabs_0 = fabs(T3);
double  deriv_fabs_0_d0 = (((T3)>=0)?(+1.0):(-1.0));
d_T4_dX = (instanceStruct.d_instanceVar_CGIDL_i_dX+deriv_fabs_0_d0*(d_T3_dX));
T4 = ((instanceStruct.instanceVar_CGIDL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T3/T4),1.0E-6);
d_T5_dX = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dX-T3*d_T4_dX)/T4/T4),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T3/T4),1.0E-6)-1.0E-6);
}
}
else
{
d_T5_dX = 0.0;
T5 = 1.0;
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-instanceStruct.instanceVar_T2));
d_T6_dX = ((((instanceStruct.instanceVar_AGIDL_i*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T2)))*d_T5_dX+(((instanceStruct.instanceVar_AGIDL_i*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getDerivs((-instanceStruct.instanceVar_T2),(-instanceStruct.d_instanceVar_T2_dX))+((instanceStruct.instanceVar_AGIDL_i*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_T1_dX+(instanceStruct.instanceVar_AGIDL_i*instanceStruct.d_instanceVar_Weff_dX+instanceStruct.d_instanceVar_AGIDL_i_dX*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T2)))*T5);
T6 = ((((instanceStruct.instanceVar_AGIDL_i*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T2)))*T5);
}
}
d_igidl_dX = d_T6_dX;
igidl = T6;
if ((((instanceStruct.instanceVar_AGISL_i<=0.0)||(BGISL_t<=0.0))||(instanceStruct.instanceVar_CGISL_i<0.0)))
{
d_T6_dX = 0.0;
T6 = 0.0;
}
else
{
instanceStruct.d_instanceVar_T1_dX = ((instanceStruct.instanceVar_T0*((-instanceStruct.d_instanceVar_EGISL_i_dX)+d_Vfbsdr_dX)-(((-Vgs_noswap)-instanceStruct.instanceVar_EGISL_i)+Vfbsdr)*instanceStruct.d_instanceVar_T0_dX)/instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_T1 = ((((-Vgs_noswap)-instanceStruct.instanceVar_EGISL_i)+Vfbsdr)/instanceStruct.instanceVar_T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(instanceStruct.instanceVar_T1,1.0E-2);
instanceStruct.d_instanceVar_T1_dX = evaluator_hypsmooth_0.getDerivs(instanceStruct.instanceVar_T1,1.0E-2,instanceStruct.d_instanceVar_T1_dX,0.0);
instanceStruct.instanceVar_T1 = evaluator_hypsmooth_0.getValues(instanceStruct.instanceVar_T1,1.0E-2);
}
instanceStruct.d_instanceVar_T2_dX = (((instanceStruct.instanceVar_T1+1.0E-3)*d_BGISL_t_dX-BGISL_t*instanceStruct.d_instanceVar_T1_dX)/(instanceStruct.instanceVar_T1+1.0E-3)/(instanceStruct.instanceVar_T1+1.0E-3));
instanceStruct.instanceVar_T2 = (BGISL_t/(instanceStruct.instanceVar_T1+1.0E-3));
if ((instanceStruct.instanceVar_CGISL_i!=0))
{
d_T3_dX = 0.0;
T3 = ((Vsb_noswap*Vsb_noswap)*Vsb_noswap);
{
double value_fabs_0 = fabs(T3);
double  deriv_fabs_0_d0 = (((T3)>=0)?(+1.0):(-1.0));
d_T4_dX = (instanceStruct.d_instanceVar_CGISL_i_dX+deriv_fabs_0_d0*(d_T3_dX));
T4 = ((instanceStruct.instanceVar_CGISL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T3/T4),1.0E-6);
d_T5_dX = evaluator_hypsmooth_0.getDerivs((T3/T4),1.0E-6,((T4*d_T3_dX-T3*d_T4_dX)/T4/T4),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T3/T4),1.0E-6)-1.0E-6);
}
}
else
{
d_T5_dX = 0.0;
T5 = 1.0;
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-instanceStruct.instanceVar_T2));
d_T6_dX = ((((instanceStruct.instanceVar_AGISL_i*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T2)))*d_T5_dX+(((instanceStruct.instanceVar_AGISL_i*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getDerivs((-instanceStruct.instanceVar_T2),(-instanceStruct.d_instanceVar_T2_dX))+((instanceStruct.instanceVar_AGISL_i*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_T1_dX+(instanceStruct.instanceVar_AGISL_i*instanceStruct.d_instanceVar_Weff_dX+instanceStruct.d_instanceVar_AGISL_i_dX*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T2)))*T5);
T6 = ((((instanceStruct.instanceVar_AGISL_i*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_T1)*evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T2)))*T5);
}
}
d_igisl_dX = d_T6_dX;
igisl = T6;
}
instanceStruct.d_instanceVar_IGIDL_dX = (instanceStruct.instanceVar_devsign*instanceStruct.instancePar_NF)*d_igidl_dX;
instanceStruct.instanceVar_IGIDL = ((instanceStruct.instanceVar_devsign*instanceStruct.instancePar_NF)*igidl);
instanceStruct.d_instanceVar_IGISL_dX = (instanceStruct.instanceVar_devsign*instanceStruct.instancePar_NF)*d_igisl_dX;
instanceStruct.instanceVar_IGISL = ((instanceStruct.instanceVar_devsign*instanceStruct.instancePar_NF)*igisl);
if ((Isbs>0.0))
{
if ((Vbs_jct<VjsmRev))
{
instanceStruct.d_instanceVar_T0_dX = (-Vbs_jct*d_Nvtms_dX/Nvtms/Nvtms);
instanceStruct.instanceVar_T0 = (Vbs_jct/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(instanceStruct.instanceVar_T0);
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(instanceStruct.instanceVar_T0,instanceStruct.d_instanceVar_T0_dX);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(instanceStruct.instanceVar_T0)-1.0);
}
instanceStruct.d_instanceVar_T2_dX = (d_IVjsmRev_dX+(SslpRev*(-d_VjsmRev_dX)+d_SslpRev_dX*(Vbs_jct-VjsmRev)));
instanceStruct.instanceVar_T2 = (IVjsmRev+(SslpRev*(Vbs_jct-VjsmRev)));
d_Ibs_dX = (instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2);
Ibs = (instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2);
}
else
{
if ((Vbs_jct<=VjsmFwd))
{
instanceStruct.d_instanceVar_T0_dX = (-Vbs_jct*d_Nvtms_dX/Nvtms/Nvtms);
instanceStruct.instanceVar_T0 = (Vbs_jct/Nvtms);
instanceStruct.d_instanceVar_T1_dX = ((Nvtms*modelStruct.d_modelPar_BVS_dX-(modelStruct.modelPar_BVS+Vbs_jct)*d_Nvtms_dX)/Nvtms/Nvtms);
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_BVS+Vbs_jct)/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-instanceStruct.instanceVar_T1));
instanceStruct.d_instanceVar_T2_dX = evaluator_lexp_0.getDerivs((-instanceStruct.instanceVar_T1),(-instanceStruct.d_instanceVar_T1_dX));
instanceStruct.instanceVar_T2 = evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(instanceStruct.instanceVar_T0);
d_Ibs_dX = (Isbs*((evaluator_lexp_0.getDerivs(instanceStruct.instanceVar_T0,instanceStruct.d_instanceVar_T0_dX)+d_XExpBVS_dX)-(modelStruct.modelPar_XJBVS*instanceStruct.d_instanceVar_T2_dX+modelStruct.d_modelPar_XJBVS_dX*instanceStruct.instanceVar_T2))+d_Isbs_dX*(((evaluator_lexp_0.getValues(instanceStruct.instanceVar_T0)+XExpBVS)-1.0)-(modelStruct.modelPar_XJBVS*instanceStruct.instanceVar_T2)));
Ibs = (Isbs*(((evaluator_lexp_0.getValues(instanceStruct.instanceVar_T0)+XExpBVS)-1.0)-(modelStruct.modelPar_XJBVS*instanceStruct.instanceVar_T2)));
}
}
else
{
d_Ibs_dX = (d_IVjsmFwd_dX+(SslpFwd*(-d_VjsmFwd_dX)+d_SslpFwd_dX*(Vbs_jct-VjsmFwd)));
Ibs = (IVjsmFwd+(SslpFwd*(Vbs_jct-VjsmFwd)));
}
}
}
else
{
d_Ibs_dX = 0.0;
Ibs = 0.0;
}
if ((JTSS_t>0.0))
{
if (((modelStruct.modelPar_VTSS-Vbs_jct)<(modelStruct.modelPar_VTSS*1.0e-3)))
{
instanceStruct.d_instanceVar_T0_dX = ((NJTS_t*(-(-Vbs_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbs_jct)/Vtm0)*d_NJTS_t_dX)/NJTS_t/NJTS_t);
instanceStruct.instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((instanceStruct.instanceVar_T0*1.0e+3));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs((instanceStruct.instanceVar_T0*1.0e+3),instanceStruct.d_instanceVar_T0_dX*1.0e+3);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues((instanceStruct.instanceVar_T0*1.0e+3))-1.0);
}
d_Ibs_dX = (d_Ibs_dX-((ASeff*JTSS_t)*instanceStruct.d_instanceVar_T1_dX+(ASeff*d_JTSS_t_dX+d_ASeff_dX*JTSS_t)*instanceStruct.instanceVar_T1));
Ibs = (Ibs-((ASeff*JTSS_t)*instanceStruct.instanceVar_T1));
}
else
{
instanceStruct.d_instanceVar_T0_dX = ((NJTS_t*(-(-Vbs_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbs_jct)/Vtm0)*d_NJTS_t_dX)/NJTS_t/NJTS_t);
instanceStruct.instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSS)/(modelStruct.modelPar_VTSS-Vbs_jct)));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSS)/(modelStruct.modelPar_VTSS-Vbs_jct)),(((modelStruct.modelPar_VTSS-Vbs_jct)*(instanceStruct.instanceVar_T0*modelStruct.d_modelPar_VTSS_dX+instanceStruct.d_instanceVar_T0_dX*modelStruct.modelPar_VTSS)-(instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSS)*modelStruct.d_modelPar_VTSS_dX)/(modelStruct.modelPar_VTSS-Vbs_jct)/(modelStruct.modelPar_VTSS-Vbs_jct)));
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSS)/(modelStruct.modelPar_VTSS-Vbs_jct)))-1.0);
}
d_Ibs_dX = (d_Ibs_dX-((ASeff*JTSS_t)*instanceStruct.d_instanceVar_T1_dX+(ASeff*d_JTSS_t_dX+d_ASeff_dX*JTSS_t)*instanceStruct.instanceVar_T1));
Ibs = (Ibs-((ASeff*JTSS_t)*instanceStruct.instanceVar_T1));
}
}
if ((JTSSWS_t>0.0))
{
if (((modelStruct.modelPar_VTSSWS-Vbs_jct)<(modelStruct.modelPar_VTSSWS*1.0e-3)))
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSW_t*(-(-Vbs_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbs_jct)/Vtm0)*d_NJTSSW_t_dX)/NJTSSW_t/NJTSSW_t);
instanceStruct.instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((instanceStruct.instanceVar_T0*1.0e+3));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs((instanceStruct.instanceVar_T0*1.0e+3),instanceStruct.d_instanceVar_T0_dX*1.0e+3);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues((instanceStruct.instanceVar_T0*1.0e+3))-1.0);
}
d_Ibs_dX = (d_Ibs_dX-((PSeff*JTSSWS_t)*instanceStruct.d_instanceVar_T1_dX+(PSeff*d_JTSSWS_t_dX+d_PSeff_dX*JTSSWS_t)*instanceStruct.instanceVar_T1));
Ibs = (Ibs-((PSeff*JTSSWS_t)*instanceStruct.instanceVar_T1));
}
else
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSW_t*(-(-Vbs_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbs_jct)/Vtm0)*d_NJTSSW_t_dX)/NJTSSW_t/NJTSSW_t);
instanceStruct.instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWS)/(modelStruct.modelPar_VTSSWS-Vbs_jct)));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWS)/(modelStruct.modelPar_VTSSWS-Vbs_jct)),(((modelStruct.modelPar_VTSSWS-Vbs_jct)*(instanceStruct.instanceVar_T0*modelStruct.d_modelPar_VTSSWS_dX+instanceStruct.d_instanceVar_T0_dX*modelStruct.modelPar_VTSSWS)-(instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWS)*modelStruct.d_modelPar_VTSSWS_dX)/(modelStruct.modelPar_VTSSWS-Vbs_jct)/(modelStruct.modelPar_VTSSWS-Vbs_jct)));
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWS)/(modelStruct.modelPar_VTSSWS-Vbs_jct)))-1.0);
}
d_Ibs_dX = (d_Ibs_dX-((PSeff*JTSSWS_t)*instanceStruct.d_instanceVar_T1_dX+(PSeff*d_JTSSWS_t_dX+d_PSeff_dX*JTSSWS_t)*instanceStruct.instanceVar_T1));
Ibs = (Ibs-((PSeff*JTSSWS_t)*instanceStruct.instanceVar_T1));
}
}
if ((JTSSWGS_t>0.0))
{
if (((modelStruct.modelPar_VTSSWGS-Vbs_jct)<(modelStruct.modelPar_VTSSWGS*1.0e-3)))
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSWG_t*(-(-Vbs_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbs_jct)/Vtm0)*d_NJTSSWG_t_dX)/NJTSSWG_t/NJTSSWG_t);
instanceStruct.instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((instanceStruct.instanceVar_T0*1.0e+3));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs((instanceStruct.instanceVar_T0*1.0e+3),instanceStruct.d_instanceVar_T0_dX*1.0e+3);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues((instanceStruct.instanceVar_T0*1.0e+3))-1.0);
}
d_Ibs_dX = (d_Ibs_dX-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGS_t)*instanceStruct.d_instanceVar_T1_dX+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*d_JTSSWGS_t_dX+instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF*JTSSWGS_t)*instanceStruct.instanceVar_T1));
Ibs = (Ibs-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGS_t)*instanceStruct.instanceVar_T1));
}
else
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSWG_t*(-(-Vbs_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbs_jct)/Vtm0)*d_NJTSSWG_t_dX)/NJTSSWG_t/NJTSSWG_t);
instanceStruct.instanceVar_T0 = (((-Vbs_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGS)/(modelStruct.modelPar_VTSSWGS-Vbs_jct)));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGS)/(modelStruct.modelPar_VTSSWGS-Vbs_jct)),(((modelStruct.modelPar_VTSSWGS-Vbs_jct)*(instanceStruct.instanceVar_T0*modelStruct.d_modelPar_VTSSWGS_dX+instanceStruct.d_instanceVar_T0_dX*modelStruct.modelPar_VTSSWGS)-(instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGS)*modelStruct.d_modelPar_VTSSWGS_dX)/(modelStruct.modelPar_VTSSWGS-Vbs_jct)/(modelStruct.modelPar_VTSSWGS-Vbs_jct)));
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGS)/(modelStruct.modelPar_VTSSWGS-Vbs_jct)))-1.0);
}
d_Ibs_dX = (d_Ibs_dX-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGS_t)*instanceStruct.d_instanceVar_T1_dX+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*d_JTSSWGS_t_dX+instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF*JTSSWGS_t)*instanceStruct.instanceVar_T1));
Ibs = (Ibs-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGS_t)*instanceStruct.instanceVar_T1));
}
}
if ((Isbd>0.0))
{
if ((Vbd_jct<VjdmRev))
{
instanceStruct.d_instanceVar_T0_dX = (-Vbd_jct*d_Nvtmd_dX/Nvtmd/Nvtmd);
instanceStruct.instanceVar_T0 = (Vbd_jct/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(instanceStruct.instanceVar_T0);
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(instanceStruct.instanceVar_T0,instanceStruct.d_instanceVar_T0_dX);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(instanceStruct.instanceVar_T0)-1.0);
}
instanceStruct.d_instanceVar_T2_dX = (d_IVjdmRev_dX+(DslpRev*(-d_VjdmRev_dX)+d_DslpRev_dX*(Vbd_jct-VjdmRev)));
instanceStruct.instanceVar_T2 = (IVjdmRev+(DslpRev*(Vbd_jct-VjdmRev)));
d_Ibd_dX = (instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T2);
Ibd = (instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T2);
}
else
{
if ((Vbd_jct<=VjdmFwd))
{
instanceStruct.d_instanceVar_T0_dX = (-Vbd_jct*d_Nvtmd_dX/Nvtmd/Nvtmd);
instanceStruct.instanceVar_T0 = (Vbd_jct/Nvtmd);
instanceStruct.d_instanceVar_T1_dX = ((Nvtmd*modelStruct.d_modelPar_BVD_dX-(modelStruct.modelPar_BVD+Vbd_jct)*d_Nvtmd_dX)/Nvtmd/Nvtmd);
instanceStruct.instanceVar_T1 = ((modelStruct.modelPar_BVD+Vbd_jct)/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-instanceStruct.instanceVar_T1));
instanceStruct.d_instanceVar_T2_dX = evaluator_lexp_0.getDerivs((-instanceStruct.instanceVar_T1),(-instanceStruct.d_instanceVar_T1_dX));
instanceStruct.instanceVar_T2 = evaluator_lexp_0.getValues((-instanceStruct.instanceVar_T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(instanceStruct.instanceVar_T0);
d_Ibd_dX = (Isbd*((evaluator_lexp_0.getDerivs(instanceStruct.instanceVar_T0,instanceStruct.d_instanceVar_T0_dX)+d_XExpBVD_dX)-(modelStruct.modelPar_XJBVD*instanceStruct.d_instanceVar_T2_dX+modelStruct.d_modelPar_XJBVD_dX*instanceStruct.instanceVar_T2))+d_Isbd_dX*(((evaluator_lexp_0.getValues(instanceStruct.instanceVar_T0)+XExpBVD)-1.0)-(modelStruct.modelPar_XJBVD*instanceStruct.instanceVar_T2)));
Ibd = (Isbd*(((evaluator_lexp_0.getValues(instanceStruct.instanceVar_T0)+XExpBVD)-1.0)-(modelStruct.modelPar_XJBVD*instanceStruct.instanceVar_T2)));
}
}
else
{
d_Ibd_dX = (d_IVjdmFwd_dX+(DslpFwd*(-d_VjdmFwd_dX)+d_DslpFwd_dX*(Vbd_jct-VjdmFwd)));
Ibd = (IVjdmFwd+(DslpFwd*(Vbd_jct-VjdmFwd)));
}
}
}
else
{
d_Ibd_dX = 0.0;
Ibd = 0.0;
}
if ((JTSD_t>0.0))
{
if (((modelStruct.modelPar_VTSD-Vbd_jct)<(modelStruct.modelPar_VTSD*1.0e-3)))
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSD_t*(-(-Vbd_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbd_jct)/Vtm0)*d_NJTSD_t_dX)/NJTSD_t/NJTSD_t);
instanceStruct.instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((instanceStruct.instanceVar_T0*1.0e+3));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs((instanceStruct.instanceVar_T0*1.0e+3),instanceStruct.d_instanceVar_T0_dX*1.0e+3);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues((instanceStruct.instanceVar_T0*1.0e+3))-1.0);
}
d_Ibd_dX = (d_Ibd_dX-((ADeff*JTSD_t)*instanceStruct.d_instanceVar_T1_dX+(ADeff*d_JTSD_t_dX+d_ADeff_dX*JTSD_t)*instanceStruct.instanceVar_T1));
Ibd = (Ibd-((ADeff*JTSD_t)*instanceStruct.instanceVar_T1));
}
else
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSD_t*(-(-Vbd_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbd_jct)/Vtm0)*d_NJTSD_t_dX)/NJTSD_t/NJTSD_t);
instanceStruct.instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSD)/(modelStruct.modelPar_VTSD-Vbd_jct)));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSD)/(modelStruct.modelPar_VTSD-Vbd_jct)),(((modelStruct.modelPar_VTSD-Vbd_jct)*(instanceStruct.instanceVar_T0*modelStruct.d_modelPar_VTSD_dX+instanceStruct.d_instanceVar_T0_dX*modelStruct.modelPar_VTSD)-(instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSD)*modelStruct.d_modelPar_VTSD_dX)/(modelStruct.modelPar_VTSD-Vbd_jct)/(modelStruct.modelPar_VTSD-Vbd_jct)));
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSD)/(modelStruct.modelPar_VTSD-Vbd_jct)))-1.0);
}
d_Ibd_dX = (d_Ibd_dX-((ADeff*JTSD_t)*instanceStruct.d_instanceVar_T1_dX+(ADeff*d_JTSD_t_dX+d_ADeff_dX*JTSD_t)*instanceStruct.instanceVar_T1));
Ibd = (Ibd-((ADeff*JTSD_t)*instanceStruct.instanceVar_T1));
}
}
if ((JTSSWD_t>0.0))
{
if (((modelStruct.modelPar_VTSSWD-Vbd_jct)<(modelStruct.modelPar_VTSSWD*1.0e-3)))
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSWD_t*(-(-Vbd_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbd_jct)/Vtm0)*d_NJTSSWD_t_dX)/NJTSSWD_t/NJTSSWD_t);
instanceStruct.instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((instanceStruct.instanceVar_T0*1.0e+3));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs((instanceStruct.instanceVar_T0*1.0e+3),instanceStruct.d_instanceVar_T0_dX*1.0e+3);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues((instanceStruct.instanceVar_T0*1.0e+3))-1.0);
}
d_Ibd_dX = (d_Ibd_dX-((PDeff*JTSSWD_t)*instanceStruct.d_instanceVar_T1_dX+(PDeff*d_JTSSWD_t_dX+d_PDeff_dX*JTSSWD_t)*instanceStruct.instanceVar_T1));
Ibd = (Ibd-((PDeff*JTSSWD_t)*instanceStruct.instanceVar_T1));
}
else
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSWD_t*(-(-Vbd_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbd_jct)/Vtm0)*d_NJTSSWD_t_dX)/NJTSSWD_t/NJTSSWD_t);
instanceStruct.instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWD)/(modelStruct.modelPar_VTSSWD-Vbd_jct)));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWD)/(modelStruct.modelPar_VTSSWD-Vbd_jct)),(((modelStruct.modelPar_VTSSWD-Vbd_jct)*(instanceStruct.instanceVar_T0*modelStruct.d_modelPar_VTSSWD_dX+instanceStruct.d_instanceVar_T0_dX*modelStruct.modelPar_VTSSWD)-(instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWD)*modelStruct.d_modelPar_VTSSWD_dX)/(modelStruct.modelPar_VTSSWD-Vbd_jct)/(modelStruct.modelPar_VTSSWD-Vbd_jct)));
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWD)/(modelStruct.modelPar_VTSSWD-Vbd_jct)))-1.0);
}
d_Ibd_dX = (d_Ibd_dX-((PDeff*JTSSWD_t)*instanceStruct.d_instanceVar_T1_dX+(PDeff*d_JTSSWD_t_dX+d_PDeff_dX*JTSSWD_t)*instanceStruct.instanceVar_T1));
Ibd = (Ibd-((PDeff*JTSSWD_t)*instanceStruct.instanceVar_T1));
}
}
if ((JTSSWGD_t>0.0))
{
if (((modelStruct.modelPar_VTSSWGD-Vbd_jct)<(modelStruct.modelPar_VTSSWGD*1.0e-3)))
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSWGD_t*(-(-Vbd_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbd_jct)/Vtm0)*d_NJTSSWGD_t_dX)/NJTSSWGD_t/NJTSSWGD_t);
instanceStruct.instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((instanceStruct.instanceVar_T0*1.0e+3));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs((instanceStruct.instanceVar_T0*1.0e+3),instanceStruct.d_instanceVar_T0_dX*1.0e+3);
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues((instanceStruct.instanceVar_T0*1.0e+3))-1.0);
}
d_Ibd_dX = (d_Ibd_dX-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGD_t)*instanceStruct.d_instanceVar_T1_dX+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*d_JTSSWGD_t_dX+instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF*JTSSWGD_t)*instanceStruct.instanceVar_T1));
Ibd = (Ibd-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGD_t)*instanceStruct.instanceVar_T1));
}
else
{
instanceStruct.d_instanceVar_T0_dX = ((NJTSSWGD_t*(-(-Vbd_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-Vbd_jct)/Vtm0)*d_NJTSSWGD_t_dX)/NJTSSWGD_t/NJTSSWGD_t);
instanceStruct.instanceVar_T0 = (((-Vbd_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGD)/(modelStruct.modelPar_VTSSWGD-Vbd_jct)));
instanceStruct.d_instanceVar_T1_dX = evaluator_lexp_0.getDerivs(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGD)/(modelStruct.modelPar_VTSSWGD-Vbd_jct)),(((modelStruct.modelPar_VTSSWGD-Vbd_jct)*(instanceStruct.instanceVar_T0*modelStruct.d_modelPar_VTSSWGD_dX+instanceStruct.d_instanceVar_T0_dX*modelStruct.modelPar_VTSSWGD)-(instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGD)*modelStruct.d_modelPar_VTSSWGD_dX)/(modelStruct.modelPar_VTSSWGD-Vbd_jct)/(modelStruct.modelPar_VTSSWGD-Vbd_jct)));
instanceStruct.instanceVar_T1 = (evaluator_lexp_0.getValues(((instanceStruct.instanceVar_T0*modelStruct.modelPar_VTSSWGD)/(modelStruct.modelPar_VTSSWGD-Vbd_jct)))-1.0);
}
d_Ibd_dX = (d_Ibd_dX-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGD_t)*instanceStruct.d_instanceVar_T1_dX+((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*d_JTSSWGD_t_dX+instanceStruct.d_instanceVar_Weffcj_dX*instanceStruct.instancePar_NF*JTSSWGD_t)*instanceStruct.instanceVar_T1));
Ibd = (Ibd-(((instanceStruct.instanceVar_Weffcj*instanceStruct.instancePar_NF)*JTSSWGD_t)*instanceStruct.instanceVar_T1));
}
}
if ((Czbs>0.0))
{
instanceStruct.d_instanceVar_T1_dX = (-Vbs_jct*d_PBS_t_dX/PBS_t/PBS_t);
instanceStruct.instanceVar_T1 = (Vbs_jct/PBS_t);
if ((instanceStruct.instanceVar_T1<0.9))
{
d_arg_dX = (-instanceStruct.d_instanceVar_T1_dX);
arg = (1.0-instanceStruct.instanceVar_T1);
if ((modelStruct.modelPar_MJS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qbs_dX = (((1.0-modelStruct.modelPar_MJS)*((PBS_t*Czbs)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBS_t*d_Czbs_dX+d_PBS_t_dX*Czbs)*(1.0-(arg*sarg)))-((PBS_t*Czbs)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJS_dX))/(1.0-modelStruct.modelPar_MJS)/(1.0-modelStruct.modelPar_MJS));
Qbs = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJS));
}
else
{
{
double value_pow_0 = pow(0.1,(-modelStruct.modelPar_MJS));
double  deriv_pow_0_d1 = (0.1 == 0.0)?0.0:(log(0.1)*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_pow_0_d1*((-modelStruct.d_modelPar_MJS_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJS_dX)/(1.0-modelStruct.modelPar_MJS)/(1.0-modelStruct.modelPar_MJS));
T3 = (1.0/(1.0-modelStruct.modelPar_MJS));
d_T4_dX = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJS)*instanceStruct.d_instanceVar_T1_dX+5.0*modelStruct.d_modelPar_MJS_dX*(instanceStruct.instanceVar_T1-1.0))+modelStruct.d_modelPar_MJS_dX)+(instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJS)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJS)));
T4 = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJS)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJS)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJS)*(1.0+modelStruct.modelPar_MJS))*instanceStruct.d_instanceVar_T2_dX+((0.05*modelStruct.modelPar_MJS)*modelStruct.d_modelPar_MJS_dX+0.05*modelStruct.d_modelPar_MJS_dX*(1.0+modelStruct.modelPar_MJS))*instanceStruct.instanceVar_T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJS)*(1.0+modelStruct.modelPar_MJS))*instanceStruct.instanceVar_T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJS)*(1.0+modelStruct.modelPar_MJS))*instanceStruct.instanceVar_T2)));
d_Qbs_dX = ((PBS_t*Czbs)*(d_T4_dX+d_T5_dX)+(PBS_t*d_Czbs_dX+d_PBS_t_dX*Czbs)*(T4+T5));
Qbs = ((PBS_t*Czbs)*(T4+T5));
}
}
else
{
d_Qbs_dX = 0.0;
Qbs = 0.0;
}
if ((Czbssw>0.0))
{
instanceStruct.d_instanceVar_T1_dX = (-Vbs_jct*d_PBSWS_t_dX/PBSWS_t/PBSWS_t);
instanceStruct.instanceVar_T1 = (Vbs_jct/PBSWS_t);
if ((instanceStruct.instanceVar_T1<0.9))
{
d_arg_dX = (-instanceStruct.d_instanceVar_T1_dX);
arg = (1.0-instanceStruct.instanceVar_T1);
if ((modelStruct.modelPar_MJSWS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qbs_dX = (d_Qbs_dX+(((1.0-modelStruct.modelPar_MJSWS)*((PBSWS_t*Czbssw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWS_t*d_Czbssw_dX+d_PBSWS_t_dX*Czbssw)*(1.0-(arg*sarg)))-((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWS_dX))/(1.0-modelStruct.modelPar_MJSWS)/(1.0-modelStruct.modelPar_MJSWS)));
Qbs = (Qbs+(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWS)));
}
else
{
{
double value_pow_0 = pow(0.1,(-modelStruct.modelPar_MJSWS));
double  deriv_pow_0_d1 = (0.1 == 0.0)?0.0:(log(0.1)*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_pow_0_d1*((-modelStruct.d_modelPar_MJSWS_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWS_dX)/(1.0-modelStruct.modelPar_MJSWS)/(1.0-modelStruct.modelPar_MJSWS));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWS));
d_T4_dX = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWS)*instanceStruct.d_instanceVar_T1_dX+5.0*modelStruct.d_modelPar_MJSWS_dX*(instanceStruct.instanceVar_T1-1.0))+modelStruct.d_modelPar_MJSWS_dX)+(instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWS)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWS)));
T4 = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWS)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWS)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWS)*(1.0+modelStruct.modelPar_MJSWS))*instanceStruct.d_instanceVar_T2_dX+((0.05*modelStruct.modelPar_MJSWS)*modelStruct.d_modelPar_MJSWS_dX+0.05*modelStruct.d_modelPar_MJSWS_dX*(1.0+modelStruct.modelPar_MJSWS))*instanceStruct.instanceVar_T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWS)*(1.0+modelStruct.modelPar_MJSWS))*instanceStruct.instanceVar_T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWS)*(1.0+modelStruct.modelPar_MJSWS))*instanceStruct.instanceVar_T2)));
d_Qbs_dX = (d_Qbs_dX+((PBSWS_t*Czbssw)*(d_T4_dX+d_T5_dX)+(PBSWS_t*d_Czbssw_dX+d_PBSWS_t_dX*Czbssw)*(T4+T5)));
Qbs = (Qbs+((PBSWS_t*Czbssw)*(T4+T5)));
}
}
if ((Czbsswg>0.0))
{
instanceStruct.d_instanceVar_T1_dX = (-Vbs_jct*d_PBSWGS_t_dX/PBSWGS_t/PBSWGS_t);
instanceStruct.instanceVar_T1 = (Vbs_jct/PBSWGS_t);
if ((instanceStruct.instanceVar_T1<0.9))
{
d_arg_dX = (-instanceStruct.d_instanceVar_T1_dX);
arg = (1.0-instanceStruct.instanceVar_T1);
if ((modelStruct.modelPar_MJSWGS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qbs_dX = (d_Qbs_dX+(((1.0-modelStruct.modelPar_MJSWGS)*((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGS_t*d_Czbsswg_dX+d_PBSWGS_t_dX*Czbsswg)*(1.0-(arg*sarg)))-((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGS_dX))/(1.0-modelStruct.modelPar_MJSWGS)/(1.0-modelStruct.modelPar_MJSWGS)));
Qbs = (Qbs+(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGS)));
}
else
{
{
double value_pow_0 = pow(0.1,(-modelStruct.modelPar_MJSWGS));
double  deriv_pow_0_d1 = (0.1 == 0.0)?0.0:(log(0.1)*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_pow_0_d1*((-modelStruct.d_modelPar_MJSWGS_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWGS_dX)/(1.0-modelStruct.modelPar_MJSWGS)/(1.0-modelStruct.modelPar_MJSWGS));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWGS));
d_T4_dX = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGS)*instanceStruct.d_instanceVar_T1_dX+5.0*modelStruct.d_modelPar_MJSWGS_dX*(instanceStruct.instanceVar_T1-1.0))+modelStruct.d_modelPar_MJSWGS_dX)+(instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGS)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWGS)));
T4 = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGS)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWGS)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWGS)*(1.0+modelStruct.modelPar_MJSWGS))*instanceStruct.d_instanceVar_T2_dX+((0.05*modelStruct.modelPar_MJSWGS)*modelStruct.d_modelPar_MJSWGS_dX+0.05*modelStruct.d_modelPar_MJSWGS_dX*(1.0+modelStruct.modelPar_MJSWGS))*instanceStruct.instanceVar_T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWGS)*(1.0+modelStruct.modelPar_MJSWGS))*instanceStruct.instanceVar_T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWGS)*(1.0+modelStruct.modelPar_MJSWGS))*instanceStruct.instanceVar_T2)));
d_Qbs_dX = (d_Qbs_dX+((PBSWGS_t*Czbsswg)*(d_T4_dX+d_T5_dX)+(PBSWGS_t*d_Czbsswg_dX+d_PBSWGS_t_dX*Czbsswg)*(T4+T5)));
Qbs = (Qbs+((PBSWGS_t*Czbsswg)*(T4+T5)));
}
}
if ((Czbd>0.0))
{
instanceStruct.d_instanceVar_T1_dX = (-Vbd_jct*d_PBD_t_dX/PBD_t/PBD_t);
instanceStruct.instanceVar_T1 = (Vbd_jct/PBD_t);
if ((instanceStruct.instanceVar_T1<0.9))
{
d_arg_dX = (-instanceStruct.d_instanceVar_T1_dX);
arg = (1.0-instanceStruct.instanceVar_T1);
if ((modelStruct.modelPar_MJD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qbd_dX = (((1.0-modelStruct.modelPar_MJD)*((PBD_t*Czbd)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBD_t*d_Czbd_dX+d_PBD_t_dX*Czbd)*(1.0-(arg*sarg)))-((PBD_t*Czbd)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJD_dX))/(1.0-modelStruct.modelPar_MJD)/(1.0-modelStruct.modelPar_MJD));
Qbd = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJD));
}
else
{
{
double value_pow_0 = pow(0.1,(-modelStruct.modelPar_MJD));
double  deriv_pow_0_d1 = (0.1 == 0.0)?0.0:(log(0.1)*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_pow_0_d1*((-modelStruct.d_modelPar_MJD_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJD_dX)/(1.0-modelStruct.modelPar_MJD)/(1.0-modelStruct.modelPar_MJD));
T3 = (1.0/(1.0-modelStruct.modelPar_MJD));
d_T4_dX = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJD)*instanceStruct.d_instanceVar_T1_dX+5.0*modelStruct.d_modelPar_MJD_dX*(instanceStruct.instanceVar_T1-1.0))+modelStruct.d_modelPar_MJD_dX)+(instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJD)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJD)));
T4 = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJD)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJD)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJD)*(1.0+modelStruct.modelPar_MJD))*instanceStruct.d_instanceVar_T2_dX+((0.05*modelStruct.modelPar_MJD)*modelStruct.d_modelPar_MJD_dX+0.05*modelStruct.d_modelPar_MJD_dX*(1.0+modelStruct.modelPar_MJD))*instanceStruct.instanceVar_T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJD)*(1.0+modelStruct.modelPar_MJD))*instanceStruct.instanceVar_T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJD)*(1.0+modelStruct.modelPar_MJD))*instanceStruct.instanceVar_T2)));
d_Qbd_dX = ((PBD_t*Czbd)*(d_T4_dX+d_T5_dX)+(PBD_t*d_Czbd_dX+d_PBD_t_dX*Czbd)*(T4+T5));
Qbd = ((PBD_t*Czbd)*(T4+T5));
}
}
else
{
d_Qbd_dX = 0.0;
Qbd = 0.0;
}
if ((Czbdsw>0.0))
{
instanceStruct.d_instanceVar_T1_dX = (-Vbd_jct*d_PBSWD_t_dX/PBSWD_t/PBSWD_t);
instanceStruct.instanceVar_T1 = (Vbd_jct/PBSWD_t);
if ((instanceStruct.instanceVar_T1<0.9))
{
d_arg_dX = (-instanceStruct.d_instanceVar_T1_dX);
arg = (1.0-instanceStruct.instanceVar_T1);
if ((modelStruct.modelPar_MJSWD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qbd_dX = (d_Qbd_dX+(((1.0-modelStruct.modelPar_MJSWD)*((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWD_t*d_Czbdsw_dX+d_PBSWD_t_dX*Czbdsw)*(1.0-(arg*sarg)))-((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWD_dX))/(1.0-modelStruct.modelPar_MJSWD)/(1.0-modelStruct.modelPar_MJSWD)));
Qbd = (Qbd+(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWD)));
}
else
{
{
double value_pow_0 = pow(0.1,(-modelStruct.modelPar_MJSWD));
double  deriv_pow_0_d1 = (0.1 == 0.0)?0.0:(log(0.1)*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_pow_0_d1*((-modelStruct.d_modelPar_MJSWD_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWD_dX)/(1.0-modelStruct.modelPar_MJSWD)/(1.0-modelStruct.modelPar_MJSWD));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWD));
d_T4_dX = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWD)*instanceStruct.d_instanceVar_T1_dX+5.0*modelStruct.d_modelPar_MJSWD_dX*(instanceStruct.instanceVar_T1-1.0))+modelStruct.d_modelPar_MJSWD_dX)+(instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWD)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWD)));
T4 = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWD)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWD)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWD)*(1.0+modelStruct.modelPar_MJSWD))*instanceStruct.d_instanceVar_T2_dX+((0.05*modelStruct.modelPar_MJSWD)*modelStruct.d_modelPar_MJSWD_dX+0.05*modelStruct.d_modelPar_MJSWD_dX*(1.0+modelStruct.modelPar_MJSWD))*instanceStruct.instanceVar_T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWD)*(1.0+modelStruct.modelPar_MJSWD))*instanceStruct.instanceVar_T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWD)*(1.0+modelStruct.modelPar_MJSWD))*instanceStruct.instanceVar_T2)));
d_Qbd_dX = (d_Qbd_dX+((PBSWD_t*Czbdsw)*(d_T4_dX+d_T5_dX)+(PBSWD_t*d_Czbdsw_dX+d_PBSWD_t_dX*Czbdsw)*(T4+T5)));
Qbd = (Qbd+((PBSWD_t*Czbdsw)*(T4+T5)));
}
}
if ((Czbdswg>0.0))
{
instanceStruct.d_instanceVar_T1_dX = (-Vbd_jct*d_PBSWGD_t_dX/PBSWGD_t/PBSWGD_t);
instanceStruct.instanceVar_T1 = (Vbd_jct/PBSWGD_t);
if ((instanceStruct.instanceVar_T1<0.9))
{
d_arg_dX = (-instanceStruct.d_instanceVar_T1_dX);
arg = (1.0-instanceStruct.instanceVar_T1);
if ((modelStruct.modelPar_MJSWGD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qbd_dX = (d_Qbd_dX+(((1.0-modelStruct.modelPar_MJSWGD)*((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGD_t*d_Czbdswg_dX+d_PBSWGD_t_dX*Czbdswg)*(1.0-(arg*sarg)))-((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGD_dX))/(1.0-modelStruct.modelPar_MJSWGD)/(1.0-modelStruct.modelPar_MJSWGD)));
Qbd = (Qbd+(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGD)));
}
else
{
{
double value_pow_0 = pow(0.1,(-modelStruct.modelPar_MJSWGD));
double  deriv_pow_0_d1 = (0.1 == 0.0)?0.0:(log(0.1)*value_pow_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_pow_0_d1*((-modelStruct.d_modelPar_MJSWGD_dX)));
instanceStruct.instanceVar_T2 = value_pow_0;
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWGD_dX)/(1.0-modelStruct.modelPar_MJSWGD)/(1.0-modelStruct.modelPar_MJSWGD));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWGD));
d_T4_dX = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGD)*instanceStruct.d_instanceVar_T1_dX+5.0*modelStruct.d_modelPar_MJSWGD_dX*(instanceStruct.instanceVar_T1-1.0))+modelStruct.d_modelPar_MJSWGD_dX)+(instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGD)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWGD)));
T4 = ((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGD)*(instanceStruct.instanceVar_T1-1.0))+(1.0+modelStruct.modelPar_MJSWGD)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWGD)*(1.0+modelStruct.modelPar_MJSWGD))*instanceStruct.d_instanceVar_T2_dX+((0.05*modelStruct.modelPar_MJSWGD)*modelStruct.d_modelPar_MJSWGD_dX+0.05*modelStruct.d_modelPar_MJSWGD_dX*(1.0+modelStruct.modelPar_MJSWGD))*instanceStruct.instanceVar_T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWGD)*(1.0+modelStruct.modelPar_MJSWGD))*instanceStruct.instanceVar_T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWGD)*(1.0+modelStruct.modelPar_MJSWGD))*instanceStruct.instanceVar_T2)));
d_Qbd_dX = (d_Qbd_dX+((PBSWGD_t*Czbdswg)*(d_T4_dX+d_T5_dX)+(PBSWGD_t*d_Czbdswg_dX+d_PBSWGD_t_dX*Czbdswg)*(T4+T5)));
Qbd = (Qbd+((PBSWGD_t*Czbdswg)*(T4+T5)));
}
}
d_Nt_dX = 4.0*d_Vt_dX*1.60219e-19;
Nt = ((4.0*Vt)*1.60219e-19);
if ((modelStruct.modelPar_LINTNOI>=(instanceStruct.instanceVar_Leff/2.0)))
{
UserInfo(theInstance)  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << " " << modelStruct.modelPar_LINTNOI << " " <<  std::endl; 
d_LINTNOI_i_dX = 0.0;
LINTNOI_i = 0;
}
else
{
d_LINTNOI_i_dX = modelStruct.d_modelPar_LINTNOI_dX;
LINTNOI_i = modelStruct.modelPar_LINTNOI;
}
d_Esatnoi_dX = ((ueff*2.0*d_VSAT_a_dX-(2.0*VSAT_a)*d_ueff_dX)/ueff/ueff);
Esatnoi = ((2.0*VSAT_a)/ueff);
if ((((modelStruct.modelPar_NOIA>0)||(modelStruct.modelPar_NOIB>0))||(modelStruct.modelPar_NOIC>0)))
{
d_Leffnoi_dX = (instanceStruct.d_instanceVar_Leff_dX-2.0*d_LINTNOI_i_dX);
Leffnoi = (instanceStruct.instanceVar_Leff-(2.0*LINTNOI_i));
d_Leffnoisq_dX = (Leffnoi*d_Leffnoi_dX+d_Leffnoi_dX*Leffnoi);
Leffnoisq = (Leffnoi*Leffnoi);
if ((modelStruct.modelPar_EM<=0.0))
{
d_DelClm_dX = 0.0;
DelClm = 0.0;
}
else
{
instanceStruct.d_instanceVar_T0_dX = ((Esatnoi*(((litl*d_diffVds_dX-diffVds*d_litl_dX)/litl/litl)+modelStruct.d_modelPar_EM_dX)-((diffVds/litl)+modelStruct.modelPar_EM)*d_Esatnoi_dX)/Esatnoi/Esatnoi);
instanceStruct.instanceVar_T0 = (((diffVds/litl)+modelStruct.modelPar_EM)/Esatnoi);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(instanceStruct.instanceVar_T0);
d_DelClm_dX = (litl*evaluator_lln_0.getDerivs(instanceStruct.instanceVar_T0,instanceStruct.d_instanceVar_T0_dX)+d_litl_dX*evaluator_lln_0.getValues(instanceStruct.instanceVar_T0));
DelClm = (litl*evaluator_lln_0.getValues(instanceStruct.instanceVar_T0));
}
if ((DelClm<0.0))
{
d_DelClm_dX = 0.0;
DelClm = 0.0;
}
}
{
double value_fabs_0 = fabs(ids);
double  deriv_fabs_0_d0 = (((ids)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_T1_dX = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*value_fabs_0)*d_ueff_dX+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*deriv_fabs_0_d0*(d_ids_dX)+((1.60219e-19*1.60219e-19)*1.60219e-19)*d_Vt_dX*value_fabs_0)*ueff);
instanceStruct.instanceVar_T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vt)*value_fabs_0)*ueff);
}
instanceStruct.d_instanceVar_T2_dX = ((1.0e10*instanceStruct.instanceVar_Cox)*d_Leffnoisq_dX+1.0e10*instanceStruct.d_instanceVar_Cox_dX*Leffnoisq);
instanceStruct.instanceVar_T2 = ((1.0e10*instanceStruct.instanceVar_Cox)*Leffnoisq);
d_N0_dX = (((((2.0*nq)*instanceStruct.instanceVar_Cox)*Vt)*d_qs_dX+(((2.0*nq)*instanceStruct.instanceVar_Cox)*d_Vt_dX+((2.0*nq)*instanceStruct.d_instanceVar_Cox_dX+2.0*d_nq_dX*instanceStruct.instanceVar_Cox)*Vt)*qs)/1.60219e-19);
N0 = (((((2.0*nq)*instanceStruct.instanceVar_Cox)*Vt)*qs)/1.60219e-19);
d_Nl_dX = (((((2.0*nq)*instanceStruct.instanceVar_Cox)*Vt)*d_qdeff_dX+(((2.0*nq)*instanceStruct.instanceVar_Cox)*d_Vt_dX+((2.0*nq)*instanceStruct.d_instanceVar_Cox_dX+2.0*d_nq_dX*instanceStruct.instanceVar_Cox)*Vt)*qdeff)/1.60219e-19);
Nl = (((((2.0*nq)*instanceStruct.instanceVar_Cox)*Vt)*qdeff)/1.60219e-19);
d_Nstar_dX = ((Vt/1.60219e-19)*((instanceStruct.d_instanceVar_Cox_dX+d_Cdep_dX)+modelStruct.d_modelPar_CIT_dX)+(d_Vt_dX/1.60219e-19)*((instanceStruct.instanceVar_Cox+Cdep)+modelStruct.modelPar_CIT));
Nstar = ((Vt/1.60219e-19)*((instanceStruct.instanceVar_Cox+Cdep)+modelStruct.modelPar_CIT));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((N0+Nstar)/(Nl+Nstar)));
d_T3_dX = (modelStruct.modelPar_NOIA*evaluator_lln_0.getDerivs(((N0+Nstar)/(Nl+Nstar)),(((Nl+Nstar)*(d_N0_dX+d_Nstar_dX)-(N0+Nstar)*(d_Nl_dX+d_Nstar_dX))/(Nl+Nstar)/(Nl+Nstar)))+modelStruct.d_modelPar_NOIA_dX*evaluator_lln_0.getValues(((N0+Nstar)/(Nl+Nstar))));
T3 = (modelStruct.modelPar_NOIA*evaluator_lln_0.getValues(((N0+Nstar)/(Nl+Nstar))));
}
d_T4_dX = (modelStruct.modelPar_NOIB*(d_N0_dX-d_Nl_dX)+modelStruct.d_modelPar_NOIB_dX*(N0-Nl));
T4 = (modelStruct.modelPar_NOIB*(N0-Nl));
d_T5_dX = ((0.5*modelStruct.modelPar_NOIC)*((N0*d_N0_dX+d_N0_dX*N0)-(Nl*d_Nl_dX+d_Nl_dX*Nl))+0.5*modelStruct.d_modelPar_NOIC_dX*((N0*N0)-(Nl*Nl)));
T5 = ((0.5*modelStruct.modelPar_NOIC)*((N0*N0)-(Nl*Nl)));
d_T6_dX = (((1.60219e-19*Vt)*ids)*d_ids_dX+((1.60219e-19*Vt)*d_ids_dX+1.60219e-19*d_Vt_dX*ids)*ids);
T6 = (((1.60219e-19*Vt)*ids)*ids);
d_T7_dX = ((1.0e10*Leffnoisq)*instanceStruct.d_instanceVar_Weff_dX+1.0e10*d_Leffnoisq_dX*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF;
T7 = (((1.0e10*Leffnoisq)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF);
d_T8_dX = ((modelStruct.d_modelPar_NOIA_dX+(modelStruct.modelPar_NOIB*d_Nl_dX+modelStruct.d_modelPar_NOIB_dX*Nl))+((modelStruct.modelPar_NOIC*Nl)*d_Nl_dX+(modelStruct.modelPar_NOIC*d_Nl_dX+modelStruct.d_modelPar_NOIC_dX*Nl)*Nl));
T8 = ((modelStruct.modelPar_NOIA+(modelStruct.modelPar_NOIB*Nl))+((modelStruct.modelPar_NOIC*Nl)*Nl));
d_T9_dX = ((Nl+Nstar)*(d_Nl_dX+d_Nstar_dX)+(d_Nl_dX+d_Nstar_dX)*(Nl+Nstar));
T9 = ((Nl+Nstar)*(Nl+Nstar));
d_Ssi_dX = (((instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2)*((d_T3_dX+d_T4_dX)+d_T5_dX)+((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T2_dX)/instanceStruct.instanceVar_T2/instanceStruct.instanceVar_T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dX+((T6/T7)*d_DelClm_dX+((T7*d_T6_dX-T6*d_T7_dX)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dX)/T9/T9));
Ssi = (((instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
d_T10_dX = ((modelStruct.modelPar_NOIA*1.60219e-19)*d_Vt_dX+modelStruct.d_modelPar_NOIA_dX*1.60219e-19*Vt);
T10 = ((modelStruct.modelPar_NOIA*1.60219e-19)*Vt);
d_T11_dX = (((((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*Leffnoi)*1.0e10)*Nstar)*d_Nstar_dX+((((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*Leffnoi)*1.0e10)*d_Nstar_dX+((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*d_Leffnoi_dX+instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instancePar_NF*Leffnoi)*1.0e10*Nstar)*Nstar);
T11 = (((((instanceStruct.instanceVar_Weff*instanceStruct.instancePar_NF)*Leffnoi)*1.0e10)*Nstar)*Nstar);
d_Swi_dX = (((T10/T11)*ids)*d_ids_dX+((T10/T11)*d_ids_dX+((T11*d_T10_dX-T10*d_T11_dX)/T11/T11)*ids)*ids);
Swi = (((T10/T11)*ids)*ids);
instanceStruct.d_instanceVar_T1_dX = (d_Swi_dX+d_Ssi_dX);
instanceStruct.instanceVar_T1 = (Swi+Ssi);
if ((instanceStruct.instanceVar_T1>0.0))
{
d_FNPowerAt1Hz_dX = ((instanceStruct.instanceVar_T1*(Ssi*d_Swi_dX+d_Ssi_dX*Swi)-(Ssi*Swi)*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
FNPowerAt1Hz = ((Ssi*Swi)/instanceStruct.instanceVar_T1);
}
else
{
d_FNPowerAt1Hz_dX = 0.0;
FNPowerAt1Hz = 0.0;
}
}
else
{
d_FNPowerAt1Hz_dX = 0.0;
FNPowerAt1Hz = 0.0;
}
// I(di,si) <+ (flicker_noise((m*FNPowerAt1Hz),EF,"1overf"))
instanceStruct.d_instanceVar_T0_dX = ((instanceStruct.instanceVar_Leff*((Esatnoi*d_qia_dX-qia*d_Esatnoi_dX)/Esatnoi/Esatnoi)-(qia/Esatnoi)*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff);
instanceStruct.instanceVar_T0 = ((qia/Esatnoi)/instanceStruct.instanceVar_Leff);
instanceStruct.d_instanceVar_T1_dX = (instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instanceVar_T0);
instanceStruct.instanceVar_T1 = (instanceStruct.instanceVar_T0*instanceStruct.instanceVar_T0);
d_T3_dX = (modelStruct.modelPar_RNOIA*((modelStruct.modelPar_TNOIA*instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_T1_dX+(modelStruct.modelPar_TNOIA*instanceStruct.d_instanceVar_Leff_dX+modelStruct.d_modelPar_TNOIA_dX*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)+modelStruct.d_modelPar_RNOIA_dX*(1.0+((modelStruct.modelPar_TNOIA*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)));
T3 = (modelStruct.modelPar_RNOIA*(1.0+((modelStruct.modelPar_TNOIA*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)));
d_T4_dX = (modelStruct.modelPar_RNOIB*((modelStruct.modelPar_TNOIB*instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_T1_dX+(modelStruct.modelPar_TNOIB*instanceStruct.d_instanceVar_Leff_dX+modelStruct.d_modelPar_TNOIB_dX*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)+modelStruct.d_modelPar_RNOIB_dX*(1.0+((modelStruct.modelPar_TNOIB*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)));
T4 = (modelStruct.modelPar_RNOIB*(1.0+((modelStruct.modelPar_TNOIB*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)));
d_ctnoi_dX = (modelStruct.modelPar_RNOIC*((modelStruct.modelPar_TNOIC*instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_T1_dX+(modelStruct.modelPar_TNOIC*instanceStruct.d_instanceVar_Leff_dX+modelStruct.d_modelPar_TNOIC_dX*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)+modelStruct.d_modelPar_RNOIC_dX*(1.0+((modelStruct.modelPar_TNOIC*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)));
ctnoi = (modelStruct.modelPar_RNOIC*(1.0+((modelStruct.modelPar_TNOIC*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_T1)));
d_betanoisq_dX = (T3*d_T3_dX+d_T3_dX*T3);
betanoisq = (T3*T3);
d_thetanoisq_dX = (T4*d_T4_dX+d_T4_dX*T4);
thetanoisq = (T4*T4);
d_cm_igid_dX = 0.0;
cm_igid = 0;
if ( modelStruct.modelPar_TNOIMOD == (0))
{
d_QSi_dX = ((((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*Vt)*d_Qs_dX+(((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*d_Vt_dX+((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_Cox_dX+(((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX+(-instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*Vt)*Qs);
QSi = ((((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*Vt)*Qs);
d_QDi_dX = ((((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*Vt)*d_Qd_dX+(((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*d_Vt_dX+((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_Cox_dX+(((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.d_instanceVar_Leff_dX+(-instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Weff_dX*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*Vt)*Qd);
QDi = ((((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*Vt)*Qd);
{
double value_fabs_0 = fabs((QSi+QDi));
double  deriv_fabs_0_d0 = ((((QSi+QDi))>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_T0_dX = (ueff*deriv_fabs_0_d0*((d_QSi_dX+d_QDi_dX))+d_ueff_dX*value_fabs_0);
instanceStruct.instanceVar_T0 = (ueff*value_fabs_0);
}
instanceStruct.d_instanceVar_T1_dX = ((instanceStruct.instanceVar_T0*d_Rdsi_dX+instanceStruct.d_instanceVar_T0_dX*Rdsi)+(instanceStruct.instanceVar_Leff*instanceStruct.d_instanceVar_Leff_dX+instanceStruct.d_instanceVar_Leff_dX*instanceStruct.instanceVar_Leff));
instanceStruct.instanceVar_T1 = ((instanceStruct.instanceVar_T0*Rdsi)+(instanceStruct.instanceVar_Leff*instanceStruct.instanceVar_Leff));
d_Gtnoi_dX = ((instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T1)*modelStruct.d_modelPar_NTNOI_dX+((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T0_dX-instanceStruct.instanceVar_T0*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1)*modelStruct.modelPar_NTNOI);
Gtnoi = ((instanceStruct.instanceVar_T0/instanceStruct.instanceVar_T1)*modelStruct.modelPar_NTNOI);
d_sidn_dX = (Nt*d_Gtnoi_dX+d_Nt_dX*Gtnoi);
sidn = (Nt*Gtnoi);
// I(di,si) <+ (white_noise((m*sidn),"id"))
}
else
if ( modelStruct.modelPar_TNOIMOD == (1))
{
d_Vtn_dX = ((2.0*nq)*d_nVt_dX+2.0*d_nq_dX*nVt);
Vtn = ((2.0*nq)*nVt);
instanceStruct.d_instanceVar_T0_dX = ((((ueff*Dptwg)*Moc)*instanceStruct.instanceVar_Cox)*d_Vtn_dX+(((ueff*Dptwg)*Moc)*instanceStruct.d_instanceVar_Cox_dX+((ueff*Dptwg)*d_Moc_dX+(ueff*d_Dptwg_dX+d_ueff_dX*Dptwg)*Moc)*instanceStruct.instanceVar_Cox)*Vtn);
instanceStruct.instanceVar_T0 = ((((ueff*Dptwg)*Moc)*instanceStruct.instanceVar_Cox)*Vtn);
instanceStruct.d_instanceVar_T1_dX = 0.5*(d_qs_dX+d_qdeff_dX);
instanceStruct.instanceVar_T1 = (0.5*(qs+qdeff));
d_T3_dX = instanceStruct.d_instanceVar_T1_dX;
T3 = (instanceStruct.instanceVar_T1+0.5);
d_T4_dX = (T3*d_T3_dX+d_T3_dX*T3);
T4 = (T3*T3);
d_T5_dX = (T4*d_T3_dX+d_T4_dX*T3);
T5 = (T4*T3);
d_T6_dX = (d_qs_dX-d_qdeff_dX);
T6 = (qs-qdeff);
d_T7_dX = (T6*d_T6_dX+d_T6_dX*T6);
T7 = (T6*T6);
d_T8_dX = (T7*d_T6_dX+d_T7_dX*T6);
T8 = (T7*T6);
d_T9_dX = (((6.0*instanceStruct.instanceVar_T1)+0.5)*d_T7_dX+6.0*instanceStruct.d_instanceVar_T1_dX*T7);
T9 = (((6.0*instanceStruct.instanceVar_T1)+0.5)*T7);
d_Lvsat_dX = (instanceStruct.instanceVar_Leff*d_Dptwg_dX+instanceStruct.d_instanceVar_Leff_dX*Dptwg);
Lvsat = (instanceStruct.instanceVar_Leff*Dptwg);
d_T10_dX = ((instanceStruct.instanceVar_Leff*d_Lvsat_dX-Lvsat*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff);
T10 = (Lvsat/instanceStruct.instanceVar_Leff);
d_mid_dX = ((((((instanceStruct.instanceVar_T0*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)/Lvsat)*(instanceStruct.instanceVar_T1+(T7/(12.0*T3))))*3.0)*d_betanoisq_dX+((((instanceStruct.instanceVar_T0*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)/Lvsat)*(instanceStruct.d_instanceVar_T1_dX+(((12.0*T3)*d_T7_dX-T7*12.0*d_T3_dX)/(12.0*T3)/(12.0*T3)))+((Lvsat*((instanceStruct.instanceVar_T0*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Weff_dX+instanceStruct.d_instanceVar_T0_dX*instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)-((instanceStruct.instanceVar_T0*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)*d_Lvsat_dX)/Lvsat/Lvsat)*(instanceStruct.instanceVar_T1+(T7/(12.0*T3))))*3.0*betanoisq);
mid = ((((((instanceStruct.instanceVar_T0*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Weff)/Lvsat)*(instanceStruct.instanceVar_T1+(T7/(12.0*T3))))*3.0)*betanoisq);
d_mig_dX = (((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*12.0)*instanceStruct.instanceVar_T0)*((((((Lvsat*T10)*T10)*(((instanceStruct.instanceVar_T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*d_thetanoisq_dX+((((Lvsat*T10)*T10)*((((T4*instanceStruct.d_instanceVar_T1_dX-instanceStruct.instanceVar_T1*d_T4_dX)/T4/T4)-((((60.0*T4)*T4)*d_T9_dX-T9*((60.0*T4)*d_T4_dX+60.0*d_T4_dX*T4))/((60.0*T4)*T4)/((60.0*T4)*T4)))+((((144.0*T4)*T5)*(T7*d_T7_dX+d_T7_dX*T7)-(T7*T7)*((144.0*T4)*d_T5_dX+144.0*d_T4_dX*T5))/((144.0*T4)*T5)/((144.0*T4)*T5)))+((Lvsat*T10)*d_T10_dX+(Lvsat*d_T10_dX+d_Lvsat_dX*T10)*T10)*(((instanceStruct.instanceVar_T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0/4.0)*thetanoisq)-((((((Lvsat*T10)*T10)*(((instanceStruct.instanceVar_T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)*(((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*12.0)*instanceStruct.d_instanceVar_T0_dX+instanceStruct.instancePar_NF*instanceStruct.d_instanceVar_Weff_dX*12.0*instanceStruct.instanceVar_T0))/(((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*12.0)*instanceStruct.instanceVar_T0)/(((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*12.0)*instanceStruct.instanceVar_T0));
mig = (((((((Lvsat*T10)*T10)*(((instanceStruct.instanceVar_T1/T4)-(T9/((60.0*T4)*T4)))+((T7*T7)/((144.0*T4)*T5))))*15.0)/4.0)*thetanoisq)/(((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Weff)*12.0)*instanceStruct.instanceVar_T0));
d_migid_dX = (((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*d_ctnoi_dX+(T10*((((12.0*T3)*d_T6_dX-T6*12.0*d_T3_dX)/(12.0*T3)/(12.0*T3))-(((144.0*T5)*d_T8_dX-T8*144.0*d_T5_dX)/(144.0*T5)/(144.0*T5)))+d_T10_dX*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi)/0.395);
migid = (((T10*((T6/(12.0*T3))-(T8/(144.0*T5))))*ctnoi)/0.395);
{
double value_sqrt_0 = sqrt((Nt*mid));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqid_dX = deriv_sqrt_0_d0*((Nt*d_mid_dX+d_Nt_dX*mid));
sqid = value_sqrt_0;
}
if ((mig==0))
{
d_sqig_dX = 0.0;
sqig = 0.0;
d_cm_igid_dX = 0.0;
cm_igid = 0.0;
}
else
{
{
double value_sqrt_0 = sqrt((Nt/mig));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqig_dX = deriv_sqrt_0_d0*(((mig*d_Nt_dX-Nt*d_mig_dX)/mig/mig));
sqig = value_sqrt_0;
}
if ((sqid==0))
{
d_cm_igid_dX = 0.0;
cm_igid = 0.0;
}
else
{
d_cm_igid_dX = ((sqid*(migid*d_sqig_dX+d_migid_dX*sqig)-(migid*sqig)*d_sqid_dX)/sqid/sqid);
cm_igid = ((migid*sqig)/sqid);
}
}
// I(N2,GND) <+ (white_noise((m*cm_igid),"corl"))
// I(N1,GND) <+ (white_noise((((m*sqig)*sqig)*(1.0-cm_igid)),"corl"))
// I(N1,GND) <+ ((m*((-sqig)*V(N2,GND))))
d_staticContributions_dX[admsNodeID_N1]+= (instanceStruct.instancePar_m*(-d_sqig_dX)*(probeVars[admsProbeID_V_N2_GND])+instanceStruct.d_instancePar_m_dX*((-sqig)*(probeVars[admsProbeID_V_N2_GND])));
// I(N1,GND) <+ (ddt(((((((m*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND))))
d_dynamicContributions_dX[admsNodeID_N1]+= ((((((instanceStruct.instancePar_m*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Leff_dX+(((instanceStruct.instancePar_m*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.d_instanceVar_Weff_dX+((instanceStruct.instancePar_m*mig)*instanceStruct.d_instanceVar_Cox_dX+(instanceStruct.instancePar_m*d_mig_dX+instanceStruct.d_instancePar_m_dX*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]));
// I(di,si) <+ (white_noise((((m*sqid)*sqid)*(1.0-cm_igid)),"id"))
// I(di,si) <+ (((m*sqid)*V(N2,GND)))
d_staticContributions_dX[admsNodeID_di]+= (instanceStruct.instancePar_m*d_sqid_dX+instanceStruct.d_instancePar_m_dX*sqid)*(probeVars[admsProbeID_V_N2_GND]);
d_staticContributions_dX[(admsNodeID_si)]-= (instanceStruct.instancePar_m*d_sqid_dX+instanceStruct.d_instancePar_m_dX*sqid)*(probeVars[admsProbeID_V_N2_GND]);
// I(gi,si) <+ (ddt(((m*0.5)*(((((((1.0+sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
d_dynamicContributions_dX[admsNodeID_gi]+= (((instanceStruct.instancePar_m*0.5)*((((((1.0+sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Leff_dX+((((1.0+sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.d_instanceVar_Weff_dX+(((1.0+sigvds)*mig)*instanceStruct.d_instanceVar_Cox_dX+(1.0+sigvds)*d_mig_dX*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND])+instanceStruct.d_instancePar_m_dX*0.5*(((((((1.0+sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
d_dynamicContributions_dX[(admsNodeID_si)]-= (((instanceStruct.instancePar_m*0.5)*((((((1.0+sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Leff_dX+((((1.0+sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.d_instanceVar_Weff_dX+(((1.0+sigvds)*mig)*instanceStruct.d_instanceVar_Cox_dX+(1.0+sigvds)*d_mig_dX*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND])+instanceStruct.d_instancePar_m_dX*0.5*(((((((1.0+sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
// I(gi,di) <+ (ddt(((m*0.5)*(((((((1.0-sigvds)*mig)*Cox)*Weff)*NF)*Leff)*V(N1,GND)))))
d_dynamicContributions_dX[admsNodeID_gi]+= (((instanceStruct.instancePar_m*0.5)*((((((1.0-sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Leff_dX+((((1.0-sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.d_instanceVar_Weff_dX+(((1.0-sigvds)*mig)*instanceStruct.d_instanceVar_Cox_dX+(1.0-sigvds)*d_mig_dX*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND])+instanceStruct.d_instancePar_m_dX*0.5*(((((((1.0-sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
d_dynamicContributions_dX[(admsNodeID_di)]-= (((instanceStruct.instancePar_m*0.5)*((((((1.0-sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Leff_dX+((((1.0-sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.d_instanceVar_Weff_dX+(((1.0-sigvds)*mig)*instanceStruct.d_instanceVar_Cox_dX+(1.0-sigvds)*d_mig_dX*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND])+instanceStruct.d_instancePar_m_dX*0.5*(((((((1.0-sigvds)*mig)*instanceStruct.instanceVar_Cox)*instanceStruct.instanceVar_Weff)*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Leff)*(probeVars[admsProbeID_V_N1_GND]))));
}
else
{
 // no default
}
// I(N2,GND) <+ ((m*V(N2,GND)))
d_staticContributions_dX[admsNodeID_N2]+= instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_N2_GND]);
// I(N1,GND) <+ ((m*V(N1,GND)))
d_staticContributions_dX[admsNodeID_N1]+= instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_N1_GND]);
if ((modelStruct.modelPar_IGCMOD!=0))
{
// I(gi,si) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcs+igs))),"igs"))
// I(gi,di) <+ (white_noise((((m*2.0)*1.60219e-19)*abs((igcd+igd))),"igd"))
}
if ((modelStruct.modelPar_IGBMOD!=0))
{
// I(gi,bi) <+ (white_noise((((m*2.0)*1.60219e-19)*abs(igb)),"igb"))
}
d_vgfbCV_dX = d_vgfb_dX;
vgfbCV = vgfb;
d_gamg2_dX = ((((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt)*(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.d_instanceVar_NGATE_i_dX+(2.0*1.60219e-19)*instanceStruct.d_instanceVar_epssi_dX*instanceStruct.instanceVar_NGATE_i)-(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NGATE_i)*((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*d_Vt_dX+(instanceStruct.instanceVar_Cox*instanceStruct.d_instanceVar_Cox_dX+instanceStruct.d_instanceVar_Cox_dX*instanceStruct.instanceVar_Cox)*Vt))/((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt)/((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt));
gamg2 = ((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NGATE_i)/((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt));
d_invgamg2_dX = ((instanceStruct.instanceVar_NGATE_i>0)?(-d_gamg2_dX/gamg2/gamg2):0.0);
invgamg2 = ((instanceStruct.instanceVar_NGATE_i>0)?(1.0/gamg2):0.0);
if ((modelStruct.modelPar_CVMOD==1))
{
instanceStruct.d_instanceVar_VFBCV_i_dX = (instanceStruct.d_instanceVar_VFBCV_i_dX+modelStruct.d_modelPar_DELVT0_dX);
instanceStruct.instanceVar_VFBCV_i = (instanceStruct.instanceVar_VFBCV_i+modelStruct.modelPar_DELVT0);
d_vg_dX = Vg*d_inv_Vt_dX;
vg = (Vg*inv_Vt);
d_vs_dX = Vs*d_inv_Vt_dX;
vs = (Vs*inv_Vt);
d_vfb_dX = (instanceStruct.instanceVar_VFBCV_i*d_inv_Vt_dX+instanceStruct.d_instanceVar_VFBCV_i_dX*inv_Vt);
vfb = (instanceStruct.instanceVar_VFBCV_i*inv_Vt);
d_vgfbCV_dX = (d_vg_dX-d_vfb_dX);
vgfbCV = (vg-vfb);
{
double value_log_0 = log((instanceStruct.instanceVar_NDEPCV_i/ni));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_NDEPCV_i/ni));
d_phib_dX = deriv_log_0_d0*(((ni*instanceStruct.d_instanceVar_NDEPCV_i_dX-instanceStruct.instanceVar_NDEPCV_i*d_ni_dX)/ni/ni));
phib = value_log_0;
}
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEPCV_i)*inv_Vt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_gam_dX = ((instanceStruct.instanceVar_Cox*deriv_sqrt_0_d0*(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEPCV_i)*d_inv_Vt_dX+(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.d_instanceVar_NDEPCV_i_dX+(2.0*1.60219e-19)*instanceStruct.d_instanceVar_epssi_dX*instanceStruct.instanceVar_NDEPCV_i)*inv_Vt))-value_sqrt_0*instanceStruct.d_instanceVar_Cox_dX)/instanceStruct.instanceVar_Cox/instanceStruct.instanceVar_Cox);
gam = (value_sqrt_0/instanceStruct.instanceVar_Cox);
}
d_inv_gam_dX = (-d_gam_dX/gam/gam);
inv_gam = (1.0/gam);
d_gamg2_dX = ((((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt)*(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.d_instanceVar_NGATE_i_dX+(2.0*1.60219e-19)*instanceStruct.d_instanceVar_epssi_dX*instanceStruct.instanceVar_NGATE_i)-(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NGATE_i)*((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*d_Vt_dX+(instanceStruct.instanceVar_Cox*instanceStruct.d_instanceVar_Cox_dX+instanceStruct.d_instanceVar_Cox_dX*instanceStruct.instanceVar_Cox)*Vt))/((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt)/((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt));
gamg2 = ((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NGATE_i)/((instanceStruct.instanceVar_Cox*instanceStruct.instanceVar_Cox)*Vt));
d_invgamg2_dX = ((instanceStruct.instanceVar_NGATE_i>0)?(-d_gamg2_dX/gamg2/gamg2):0.0);
invgamg2 = ((instanceStruct.instanceVar_NGATE_i>0)?(1.0/gamg2):0.0);
d_DPD_dX = ((instanceStruct.instanceVar_NGATE_i>0)?((instanceStruct.instanceVar_NGATE_i*instanceStruct.d_instanceVar_NDEPCV_i_dX-instanceStruct.instanceVar_NDEPCV_i*instanceStruct.d_instanceVar_NGATE_i_dX)/instanceStruct.instanceVar_NGATE_i/instanceStruct.instanceVar_NGATE_i):0.0);
DPD = ((instanceStruct.instanceVar_NGATE_i>0)?(instanceStruct.instanceVar_NDEPCV_i/instanceStruct.instanceVar_NGATE_i):0.0);
instanceStruct.d_instanceVar_T1_dX = d_DPD_dX;
instanceStruct.instanceVar_T1 = (1.0+DPD);
d_vgfbPD_dX = ((instanceStruct.instanceVar_T1*d_vgfbCV_dX-vgfbCV*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
vgfbPD = (vgfbCV/instanceStruct.instanceVar_T1);
d_gammaPD_dX = ((instanceStruct.instanceVar_T1*d_gam_dX-gam*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
gammaPD = (gam/instanceStruct.instanceVar_T1);
instanceStruct.d_instanceVar_T1_dX = (0.5*d_vgfbPD_dX-3.0*(d_gammaPD_dX/1.41421356237309504880));
instanceStruct.instanceVar_T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)+(6.0*vgfbPD)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1)+6.0*d_vgfbPD_dX)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1+value_sqrt_0);
}
if ((vgfbPD<0.0))
{
d_T3_dX = ((gammaPD*(d_vgfbPD_dX-instanceStruct.d_instanceVar_T2_dX)-(vgfbPD-instanceStruct.instanceVar_T2)*d_gammaPD_dX)/gammaPD/gammaPD);
T3 = ((vgfbPD-instanceStruct.instanceVar_T2)/gammaPD);
{
double value_log_0 = log(((1.0-instanceStruct.instanceVar_T2)+(T3*T3)));
double  deriv_log_0_d0 = (1.0/((1.0-instanceStruct.instanceVar_T2)+(T3*T3)));
d_psip_dX = (-deriv_log_0_d0*(((-instanceStruct.d_instanceVar_T2_dX)+(T3*d_T3_dX+d_T3_dX*T3))));
psip = (-value_log_0);
}
}
else
{
{
double value_exp_0 = exp((-instanceStruct.instanceVar_T2));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((-instanceStruct.d_instanceVar_T2_dX));
T3 = value_exp_0;
}
instanceStruct.d_instanceVar_T1_dX = 0.5*d_gammaPD_dX;
instanceStruct.instanceVar_T1 = (0.5*gammaPD);
{
double value_sqrt_0 = sqrt((((vgfbPD-1.0)+T3)+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_sqrt_0_d0*(((d_vgfbPD_dX+d_T3_dX)+(instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1)))-instanceStruct.d_instanceVar_T1_dX);
instanceStruct.instanceVar_T2 = (value_sqrt_0-instanceStruct.instanceVar_T1);
}
d_psip_dX = ((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2)-d_T3_dX);
psip = (((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+1.0)-T3);
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_T8_dX);
sqrtpsip = value_sqrt_0;
}
d_T9_dX = (((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));
instanceStruct.d_instanceVar_T0_dX = ((gam*(((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dX)/gam/gam);
instanceStruct.instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
instanceStruct.d_instanceVar_T1_dX = ((d_psip_dX-2.0*d_phib_dX)-d_vs_dX);
instanceStruct.instanceVar_T1 = ((psip-(2.0*phib))-vs);
{
double value_log_0 = log(((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX-deriv_log_0_d0*(((4.0*instanceStruct.instanceVar_T0)*d_sqrtpsip_dX+4.0*instanceStruct.d_instanceVar_T0_dX*sqrtpsip)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX-deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T2+0.402982))));
T8 = (0.5*((instanceStruct.instanceVar_T2-0.201491)-value_sqrt_0));
}
d_sqrtpsisa_dX = d_sqrtpsip_dX;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{
d_T4_dX = 0.0;
T4 = (-100.0);
d_T5_dX = 0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T4_dX);
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_T2_dX = ((T5*(d_T8_dX-d_T4_dX)-(T8-T4)*d_T5_dX)/T5/T5);
instanceStruct.instanceVar_T2 = ((T8-T4)/T5);
d_T6_dX = (instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2);
T6 = (instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((d_T4_dX+(T5*(0.5*instanceStruct.d_instanceVar_T2_dX+(T6*(-(T6*(-d_T6_dX)+d_T6_dX*(1.25-T6)))+d_T6_dX*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dX*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_qs_dX = (T3*((instanceStruct.d_instanceVar_T1_dX-d_T8_dX)-deriv_log_0_d0*(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+2.0*instanceStruct.d_instanceVar_T0_dX*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))+d_T3_dX*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
qs = (T3*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
d_sqrtpsisainv_dX = (-d_sqrtpsisa_dX/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T3_dX = (d_T3_dX-((T5*d_T4_dX-T4*d_T5_dX)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T6_dX = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T6 = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T7_dX = (((-((1.0/T3)*(-d_T3_dX/T3/T3)+(-d_T3_dX/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dX+(sqrtpsisa*d_sqrtpsisa_dX+d_sqrtpsisa_dX*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-d_T6_dX);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-T6);
d_qs_dX = (d_T3_dX-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dX+d_T4_dX*T7)-(T4*T7)*((2.0*T5)*d_T5_dX+2.0*d_T5_dX*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dX-T4*d_T5_dX)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psipclamp_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
psipclamp = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(psipclamp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_psipclamp_dX);
sqrtpsip = value_sqrt_0;
}
d_psiavg_dX = (d_psip_dX-2.0*d_qs_dX);
psiavg = (psip-(2.0*qs));
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T0_dX = 0.5*(d_psiavg_dX+deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dX+d_psiavg_dX*(psiavg-1.0))));
instanceStruct.instanceVar_T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_nq_dX = (((sqrtpsip+value_sqrt_0)*d_gam_dX-gam*(d_sqrtpsip_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_T0_dX)))/(sqrtpsip+value_sqrt_0)/(sqrtpsip+value_sqrt_0));
nq = (1.0+(gam/(sqrtpsip+value_sqrt_0)));
}
instanceStruct.d_instanceVar_T0_dX = (Vt*((d_vgfbCV_dX-d_psip_dX)-((2.0*qs)*d_nq_dX+2.0*d_qs_dX*(nq-1.0)))+d_Vt_dX*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
instanceStruct.instanceVar_T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_T0)*(instanceStruct.instanceVar_T0))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qbs_dX = 0.5*(instanceStruct.d_instanceVar_T0_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T0)*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*(instanceStruct.instanceVar_T0))));
qbs = (0.5*(instanceStruct.instanceVar_T0+value_sqrt_0));
}
d_qis_dX = (((2.0*nq)*Vt)*d_qs_dX+((2.0*nq)*d_Vt_dX+2.0*d_nq_dX*Vt)*qs);
qis = (((2.0*nq)*Vt)*qs);
d_Eeffs_dX = (EeffFactor*(d_qbs_dX+(eta_mu*d_qis_dX+d_eta_mu_dX*qis))+d_EeffFactor_dX*(qbs+(eta_mu*qis)));
Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
{
double value_pow_0 = pow(Eeffs,instanceStruct.instanceVar_EU_i);
double  deriv_pow_0_d0 = ((Eeffs == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_EU_i/Eeffs));
double  deriv_pow_0_d1 = (Eeffs == 0.0)?0.0:(log(Eeffs)*value_pow_0);
d_T3_dX = ((UA_a+(UC_a*Vbsx))*((deriv_pow_0_d0*(d_Eeffs_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_EU_i_dX)))+(d_UA_a_dX+d_UC_a_dX*Vbsx)*value_pow_0);
T3 = ((UA_a+(UC_a*Vbsx))*value_pow_0);
}
d_T4_dX = d_T3_dX;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Dmobs_dX = 0.5*(d_T4_dX+deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dX+d_T4_dX*(T4-1.0))));
Dmobs = (0.5*((T4+1.0)+value_sqrt_0));
}
d_LambdaC_by2_dX = (((VSATCV_t*instanceStruct.instanceVar_Lact)*((U0_a/Dmobs)*d_Vt_dX+((Dmobs*d_U0_a_dX-U0_a*d_Dmobs_dX)/Dmobs/Dmobs)*Vt)-((U0_a/Dmobs)*Vt)*(VSATCV_t*instanceStruct.d_instanceVar_Lact_dX+d_VSATCV_t_dX*instanceStruct.instanceVar_Lact))/(VSATCV_t*instanceStruct.instanceVar_Lact)/(VSATCV_t*instanceStruct.instanceVar_Lact));
LambdaC_by2 = (((U0_a/Dmobs)*Vt)/(VSATCV_t*instanceStruct.instanceVar_Lact));
d_qdsat_dX = (((1.0+(LambdaC_by2*(1.0+qs)))*(LambdaC_by2*((qs*d_qs_dX+d_qs_dX*qs)+d_qs_dX)+d_LambdaC_by2_dX*((qs*qs)+qs))-(LambdaC_by2*((qs*qs)+qs))*(LambdaC_by2*d_qs_dX+d_LambdaC_by2_dX*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs)))/(1.0+(LambdaC_by2*(1.0+qs))));
qdsat = ((LambdaC_by2*((qs*qs)+qs))/(1.0+(LambdaC_by2*(1.0+qs))));
{
double value_log_0 = log(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));
double  deriv_log_0_d0 = (1.0/((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))));
d_vdsatcv_dX = ((d_psip_dX-2.0*d_phib_dX)-(2.0*d_qdsat_dX+deriv_log_0_d0*(((((qdsat*2.0)*nq)*inv_gam)*((((qdsat*2.0)*nq)*d_inv_gam_dX+((qdsat*2.0)*d_nq_dX+d_qdsat_dX*2.0*nq)*inv_gam)+(((nq-1.0)*d_gam_dX-gam*d_nq_dX)/(nq-1.0)/(nq-1.0)))+(((qdsat*2.0)*nq)*d_inv_gam_dX+((qdsat*2.0)*d_nq_dX+d_qdsat_dX*2.0*nq)*inv_gam)*((((qdsat*2.0)*nq)*inv_gam)+(gam/(nq-1.0)))))));
vdsatcv = ((psip-(2.0*phib))-((2.0*qdsat)+value_log_0));
}
d_VdsatCV_dX = (vdsatcv*d_Vt_dX+d_vdsatcv_dX*Vt);
VdsatCV = (vdsatcv*Vt);
{
double value_sqrt_0 = sqrt(((((VdsatCV-Vs))*((VdsatCV-Vs)))+((0.25*1e-3)*1e-3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_VdssatCV_dX = 0.5*(d_VdsatCV_dX+deriv_sqrt_0_d0*((((VdsatCV-Vs))*d_VdsatCV_dX+d_VdsatCV_dX*((VdsatCV-Vs)))));
VdssatCV = (0.5*((VdsatCV-Vs)+value_sqrt_0));
}
{
double value_pow_0 = pow((Vds/VdssatCV),(1.0/DELTA_t));
double  deriv_pow_0_d0 = (((Vds/VdssatCV) == 0.0)?0.0:(value_pow_0*(1.0/DELTA_t)/(Vds/VdssatCV)));
double  deriv_pow_0_d1 = ((Vds/VdssatCV) == 0.0)?0.0:(log((Vds/VdssatCV))*value_pow_0);
d_T7_dX = ((deriv_pow_0_d0*((-Vds*d_VdssatCV_dX/VdssatCV/VdssatCV)))+(deriv_pow_0_d1*((-d_DELTA_t_dX/DELTA_t/DELTA_t))));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),(-DELTA_t));
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*(-DELTA_t)/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);
d_T8_dX = ((deriv_pow_0_d0*(d_T7_dX))+(deriv_pow_0_d1*((-d_DELTA_t_dX))));
T8 = value_pow_0;
}
d_Vdseff_dX = Vds*d_T8_dX;
Vdseff = (Vds*T8);
d_vdeff_dX = ((Vdseff+Vs)*d_inv_Vt_dX+d_Vdseff_dX*inv_Vt);
vdeff = ((Vdseff+Vs)*inv_Vt);
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_T8_dX);
sqrtpsip = value_sqrt_0;
}
d_T9_dX = (((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));
instanceStruct.d_instanceVar_T0_dX = ((gam*(((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dX)/gam/gam);
instanceStruct.instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
instanceStruct.d_instanceVar_T1_dX = ((d_psip_dX-2.0*d_phib_dX)-d_vdeff_dX);
instanceStruct.instanceVar_T1 = ((psip-(2.0*phib))-vdeff);
{
double value_log_0 = log(((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX-deriv_log_0_d0*(((4.0*instanceStruct.instanceVar_T0)*d_sqrtpsip_dX+4.0*instanceStruct.d_instanceVar_T0_dX*sqrtpsip)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX-deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T2+0.402982))));
T8 = (0.5*((instanceStruct.instanceVar_T2-0.201491)-value_sqrt_0));
}
d_sqrtpsisa_dX = d_sqrtpsip_dX;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{
d_T4_dX = 0.0;
T4 = (-100.0);
d_T5_dX = 0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T4_dX);
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_T2_dX = ((T5*(d_T8_dX-d_T4_dX)-(T8-T4)*d_T5_dX)/T5/T5);
instanceStruct.instanceVar_T2 = ((T8-T4)/T5);
d_T6_dX = (instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2);
T6 = (instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((d_T4_dX+(T5*(0.5*instanceStruct.d_instanceVar_T2_dX+(T6*(-(T6*(-d_T6_dX)+d_T6_dX*(1.25-T6)))+d_T6_dX*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dX*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_qdeff_dX = (T3*((instanceStruct.d_instanceVar_T1_dX-d_T8_dX)-deriv_log_0_d0*(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+2.0*instanceStruct.d_instanceVar_T0_dX*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))+d_T3_dX*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
qdeff = (T3*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
d_sqrtpsisainv_dX = (-d_sqrtpsisa_dX/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T3_dX = (d_T3_dX-((T5*d_T4_dX-T4*d_T5_dX)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T6_dX = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T6 = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T7_dX = (((-((1.0/T3)*(-d_T3_dX/T3/T3)+(-d_T3_dX/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dX+(sqrtpsisa*d_sqrtpsisa_dX+d_sqrtpsisa_dX*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-d_T6_dX);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-T6);
d_qdeff_dX = (d_T3_dX-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dX+d_T4_dX*T7)-(T4*T7)*((2.0*T5)*d_T5_dX+2.0*d_T5_dX*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dX-T4*d_T5_dX)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
d_psiavg_dX = ((d_psip_dX-d_qs_dX)-d_qdeff_dX);
psiavg = (((psip-qs)-qdeff)-1.0);
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T0_dX = 0.5*(d_psiavg_dX+deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dX+d_psiavg_dX*(psiavg-1.0))));
instanceStruct.instanceVar_T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_T0_dX);
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
d_T3_dX = (d_DPD_dX+(((sqrtpsip+instanceStruct.instanceVar_T2)*d_gam_dX-gam*(d_sqrtpsip_dX+instanceStruct.d_instanceVar_T2_dX))/(sqrtpsip+instanceStruct.instanceVar_T2)/(sqrtpsip+instanceStruct.instanceVar_T2)));
T3 = ((1.0+DPD)+(gam/(sqrtpsip+instanceStruct.instanceVar_T2)));
d_T4_dX = ((DPD*instanceStruct.instanceVar_T2)*d_inv_gam_dX+(DPD*instanceStruct.d_instanceVar_T2_dX+d_DPD_dX*instanceStruct.instanceVar_T2)*inv_gam);
T4 = (0.5+((DPD*instanceStruct.instanceVar_T2)*inv_gam));
{
double value_sqrt_0 = sqrt(((T4*T4)+((T3*(qs+qdeff))*invgamg2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T5_dX = deriv_sqrt_0_d0*(((T4*d_T4_dX+d_T4_dX*T4)+((T3*(qs+qdeff))*d_invgamg2_dX+(T3*(d_qs_dX+d_qdeff_dX)+d_T3_dX*(qs+qdeff))*invgamg2)));
T5 = value_sqrt_0;
}
d_nq_dX = (((T4+T5)*d_T3_dX-T3*(d_T4_dX+d_T5_dX))/(T4+T5)/(T4+T5));
nq = (T3/(T4+T5));
instanceStruct.d_instanceVar_T0_dX = (Vt*((d_vgfbCV_dX-d_psip_dX)-((2.0*qs)*d_nq_dX+2.0*d_qs_dX*(nq-1.0)))+d_Vt_dX*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
instanceStruct.instanceVar_T0 = (Vt*((vgfbCV-psip)-((2.0*qs)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_T0)*(instanceStruct.instanceVar_T0))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qbs_dX = 0.5*(instanceStruct.d_instanceVar_T0_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T0)*instanceStruct.d_instanceVar_T0_dX+instanceStruct.d_instanceVar_T0_dX*(instanceStruct.instanceVar_T0))));
qbs = (0.5*(instanceStruct.instanceVar_T0+value_sqrt_0));
}
instanceStruct.d_instanceVar_T1_dX = (Vt*((d_vgfbCV_dX-d_psip_dX)-((2.0*qdeff)*d_nq_dX+2.0*d_qdeff_dX*(nq-1.0)))+d_Vt_dX*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))));
instanceStruct.instanceVar_T1 = (Vt*((vgfbCV-psip)-((2.0*qdeff)*(nq-1.0))));
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_T1)*(instanceStruct.instanceVar_T1))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qbd_dX = 0.5*(instanceStruct.d_instanceVar_T1_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T1)*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*(instanceStruct.instanceVar_T1))));
qbd = (0.5*(instanceStruct.instanceVar_T1+value_sqrt_0));
}
d_qb_dX = 0.5*(d_qbs_dX+d_qbd_dX);
qb = (0.5*(qbs+qbd));
d_qia_dX = ((nq*Vt)*(d_qs_dX+d_qdeff_dX)+(nq*d_Vt_dX+d_nq_dX*Vt)*(qs+qdeff));
qia = ((nq*Vt)*(qs+qdeff));
d_Eeffm_dX = (EeffFactor*(d_qb_dX+(eta_mu*d_qia_dX+d_eta_mu_dX*qia))+d_EeffFactor_dX*(qb+(eta_mu*qia)));
Eeffm = (EeffFactor*(qb+(eta_mu*qia)));
{
double value_pow_0 = pow(Eeffm,instanceStruct.instanceVar_EU_i);
double  deriv_pow_0_d0 = ((Eeffm == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_EU_i/Eeffm));
double  deriv_pow_0_d1 = (Eeffm == 0.0)?0.0:(log(Eeffm)*value_pow_0);
d_T3_dX = ((UA_a+(UC_a*Vbsx))*((deriv_pow_0_d0*(d_Eeffm_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_EU_i_dX)))+(d_UA_a_dX+d_UC_a_dX*Vbsx)*value_pow_0);
T3 = ((UA_a+(UC_a*Vbsx))*value_pow_0);
}
d_T4_dX = d_T3_dX;
T4 = (1.0+T3);
{
double value_sqrt_0 = sqrt((((T4-1.0)*(T4-1.0))+((0.25*0.0015)*0.0015)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Dmob_dX = 0.5*(d_T4_dX+deriv_sqrt_0_d0*(((T4-1.0)*d_T4_dX+d_T4_dX*(T4-1.0))));
Dmob = (0.5*((T4+1.0)+value_sqrt_0));
}
d_LambdaC_dX = (((VSATCV_t*instanceStruct.instanceVar_Lact)*((2.0*(U0_a/Dmob))*d_Vt_dX+2.0*((Dmob*d_U0_a_dX-U0_a*d_Dmob_dX)/Dmob/Dmob)*Vt)-((2.0*(U0_a/Dmob))*Vt)*(VSATCV_t*instanceStruct.d_instanceVar_Lact_dX+d_VSATCV_t_dX*instanceStruct.instanceVar_Lact))/(VSATCV_t*instanceStruct.instanceVar_Lact)/(VSATCV_t*instanceStruct.instanceVar_Lact));
LambdaC = (((2.0*(U0_a/Dmob))*Vt)/(VSATCV_t*instanceStruct.instanceVar_Lact));
d_dps_dX = (d_qs_dX-d_qdeff_dX);
dps = (qs-qdeff);
instanceStruct.d_instanceVar_T1_dX = ((2.0*(LambdaC*dps))*(LambdaC*d_dps_dX+d_LambdaC_dX*dps)+2.0*(LambdaC*d_dps_dX+d_LambdaC_dX*dps)*(LambdaC*dps));
instanceStruct.instanceVar_T1 = ((2.0*(LambdaC*dps))*(LambdaC*dps));
{
double value_sqrt_0 = sqrt((1.0+instanceStruct.instanceVar_T1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zsat_dX = deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_T1_dX);
zsat = value_sqrt_0;
}
d_Dvsat_dX = 0.5*d_zsat_dX;
Dvsat = (0.5*(1.0+zsat));
d_Esat_dX = (((U0_a/Dmob)*2.0*d_VSATCV_t_dX-(2.0*VSATCV_t)*((Dmob*d_U0_a_dX-U0_a*d_Dmob_dX)/Dmob/Dmob))/(U0_a/Dmob)/(U0_a/Dmob));
Esat = ((2.0*VSATCV_t)/(U0_a/Dmob));
d_EsatL_dX = (Esat*instanceStruct.d_instanceVar_Lact_dX+d_Esat_dX*instanceStruct.instanceVar_Lact);
EsatL = (Esat*instanceStruct.instanceVar_Lact);
d_Vasat_dX = (d_VdssatCV_dX+d_EsatL_dX);
Vasat = (VdssatCV+EsatL);
d_diffVds_dX = (-d_Vdseff_dX);
diffVds = (Vds-Vdseff);
}
if ((instanceStruct.instanceVar_PCLMCV_i!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+((diffVds/instanceStruct.instanceVar_PCLMCV_i)/Vasat)));
d_MdL_dX = (instanceStruct.instanceVar_PCLMCV_i*evaluator_lln_0.getDerivs((1.0+((diffVds/instanceStruct.instanceVar_PCLMCV_i)/Vasat)),((Vasat*((instanceStruct.instanceVar_PCLMCV_i*d_diffVds_dX-diffVds*instanceStruct.d_instanceVar_PCLMCV_i_dX)/instanceStruct.instanceVar_PCLMCV_i/instanceStruct.instanceVar_PCLMCV_i)-(diffVds/instanceStruct.instanceVar_PCLMCV_i)*d_Vasat_dX)/Vasat/Vasat))+instanceStruct.d_instanceVar_PCLMCV_i_dX*evaluator_lln_0.getValues((1.0+((diffVds/instanceStruct.instanceVar_PCLMCV_i)/Vasat))));
MdL = (1.0+(instanceStruct.instanceVar_PCLMCV_i*evaluator_lln_0.getValues((1.0+((diffVds/instanceStruct.instanceVar_PCLMCV_i)/Vasat)))));
}
}
else
{
d_MdL_dX = 0.0;
MdL = 1.0;
}
d_MdL_2_dX = (MdL*d_MdL_dX+d_MdL_dX*MdL);
MdL_2 = (MdL*MdL);
d_inv_MdL_dX = (-d_MdL_dX/MdL/MdL);
inv_MdL = (1.0/MdL);
d_inv_MdL_2_dX = (-d_MdL_2_dX/MdL_2/MdL_2);
inv_MdL_2 = (1.0/MdL_2);
d_MdL_less_1_dX = d_MdL_dX;
MdL_less_1 = (MdL-1.0);
d_vgpqm_dX = (d_vgfbCV_dX-d_psip_dX);
vgpqm = (vgfbCV-psip);
d_DQSD_dX = (d_qs_dX-d_qdeff_dX);
DQSD = (qs-qdeff);
d_DQSD2_dX = ((qs-qdeff)*(d_qs_dX-d_qdeff_dX)+(d_qs_dX-d_qdeff_dX)*(qs-qdeff));
DQSD2 = ((qs-qdeff)*(qs-qdeff));
d_sis_dX = (d_vgpqm_dX+2.0*d_qs_dX);
sis = (vgpqm+(2.0*qs));
d_sid_dX = (d_vgpqm_dX+2.0*d_qdeff_dX);
sid = (vgpqm+(2.0*qdeff));
{
double value_sqrt_0 = sqrt((((sis)*(sis))+((0.25*0.5)*0.5)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T1_dX = 0.5*(d_sis_dX+deriv_sqrt_0_d0*(((sis)*d_sis_dX+d_sis_dX*(sis))));
instanceStruct.instanceVar_T1 = (0.5*(sis+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((sid)*(sid))+((0.25*0.5)*0.5)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = 0.5*(d_sid_dX+deriv_sqrt_0_d0*(((sid)*d_sid_dX+d_sid_dX*(sid))));
instanceStruct.instanceVar_T2 = (0.5*(sid+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((0.25+(instanceStruct.instanceVar_T1*invgamg2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Temps_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T1*d_invgamg2_dX+instanceStruct.d_instanceVar_T1_dX*invgamg2));
Temps = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((0.25+(instanceStruct.instanceVar_T2*invgamg2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Tempd_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*d_invgamg2_dX+instanceStruct.d_instanceVar_T2_dX*invgamg2));
Tempd = value_sqrt_0;
}
instanceStruct.d_instanceVar_T1_dX = (((1.0+(2.0*Temps))*d_sis_dX-sis*2.0*d_Temps_dX)/(1.0+(2.0*Temps))/(1.0+(2.0*Temps)));
instanceStruct.instanceVar_T1 = (sis/(1.0+(2.0*Temps)));
instanceStruct.d_instanceVar_T2_dX = (((1.0+(2.0*Tempd))*d_sid_dX-sid*2.0*d_Tempd_dX)/(1.0+(2.0*Tempd))/(1.0+(2.0*Tempd)));
instanceStruct.instanceVar_T2 = (sid/(1.0+(2.0*Tempd)));
d_T3_dX = (d_Temps_dX+d_Tempd_dX);
T3 = (Temps+Tempd);
d_T4_dX = 0.33333333333333333*((((T3*T3)*T3)*d_DQSD2_dX-DQSD2*((T3*T3)*d_T3_dX+(T3*d_T3_dX+d_T3_dX*T3)*T3))/((T3*T3)*T3)/((T3*T3)*T3));
T4 = (0.33333333333333333*(DQSD2/((T3*T3)*T3)));
d_T5_dX = ((((1.0+qs)+qdeff)*(Dvsat*d_inv_MdL_dX+d_Dvsat_dX*inv_MdL)-(Dvsat*inv_MdL)*(d_qs_dX+d_qdeff_dX))/((1.0+qs)+qdeff)/((1.0+qs)+qdeff));
T5 = ((Dvsat*inv_MdL)/((1.0+qs)+qdeff));
d_T6_dX = ((0.8*((T3*T3)+(Temps*Tempd)))*d_T5_dX+0.8*((T3*d_T3_dX+d_T3_dX*T3)+(Temps*d_Tempd_dX+d_Temps_dX*Tempd))*T5);
T6 = ((0.8*((T3*T3)+(Temps*Tempd)))*T5);
d_T7_dX = (d_T6_dX+2.0*d_invgamg2_dX);
T7 = (T6+(2.0*invgamg2));
d_T8_dX = ((0.33333333333333333*DQSD2)*d_T5_dX+0.33333333333333333*d_DQSD2_dX*T5);
T8 = ((0.33333333333333333*DQSD2)*T5);
d_dqgeff_dX = ((((2.0*Tempd)+1.0)*(sid*2.0*d_Tempd_dX+d_sid_dX*((2.0*Tempd)-1.0))-(sid*((2.0*Tempd)-1.0))*2.0*d_Tempd_dX)/((2.0*Tempd)+1.0)/((2.0*Tempd)+1.0));
dqgeff = ((sid*((2.0*Tempd)-1.0))/((2.0*Tempd)+1.0));
d_qbeff_dX = ((d_vgpqm_dX-((2.0*(nq-1.0))*d_qdeff_dX+2.0*d_nq_dX*qdeff))+d_dqgeff_dX);
qbeff = ((vgpqm-((2.0*(nq-1.0))*qdeff))+dqgeff);
d_Qb_dX = ((inv_MdL*((instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T2_dX)+((T4*d_T7_dX+d_T4_dX*T7)-(nq*((d_qs_dX+d_qdeff_dX)+d_T8_dX)+d_nq_dX*((qs+qdeff)+T8))))+d_inv_MdL_dX*((instanceStruct.instanceVar_T1+instanceStruct.instanceVar_T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*d_qbeff_dX+d_MdL_less_1_dX*qbeff));
Qb = ((inv_MdL*((instanceStruct.instanceVar_T1+instanceStruct.instanceVar_T2)+((T4*T7)-(nq*((qs+qdeff)+T8)))))+(MdL_less_1*qbeff));
d_T9_dX = (d_qs_dX+d_qdeff_dX);
T9 = (qs+qdeff);
d_T10_dX = ((DQSD2*T5)*d_T5_dX+(DQSD2*d_T5_dX+d_DQSD2_dX*T5)*T5);
T10 = ((DQSD2*T5)*T5);
d_Qi_dX = (((nq*inv_MdL)*(d_T9_dX+((0.33333333333333333*DQSD2)*d_T5_dX+0.33333333333333333*d_DQSD2_dX*T5))+(nq*d_inv_MdL_dX+d_nq_dX*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*d_qdeff_dX+((2.0*nq)*d_MdL_less_1_dX+2.0*d_nq_dX*MdL_less_1)*qdeff));
Qi = (((nq*inv_MdL)*(T9+((0.33333333333333333*DQSD2)*T5)))+(((2.0*nq)*MdL_less_1)*qdeff));
d_Qd1_dX = ((nq*inv_MdL_2)*(0.5*d_T9_dX-((DQSD/6.0)*((-(DQSD*d_T5_dX+d_DQSD_dX*T5))-0.2*d_T10_dX)+(d_DQSD_dX/6.0)*((1.0-(DQSD*T5))-(0.2*T10))))+(nq*d_inv_MdL_2_dX+d_nq_dX*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
Qd1 = ((nq*inv_MdL_2)*((0.5*T9)-((DQSD/6.0)*((1.0-(DQSD*T5))-(0.2*T10)))));
d_Qd2_dX = ((nq*(MdL-inv_MdL))*d_qdeff_dX+(nq*(d_MdL_dX-d_inv_MdL_dX)+d_nq_dX*(MdL-inv_MdL))*qdeff);
Qd2 = ((nq*(MdL-inv_MdL))*qdeff);
d_Qd_dX = (d_Qd1_dX+d_Qd2_dX);
Qd = (Qd1+Qd2);
d_Qs_dX = (d_Qi_dX-d_Qd_dX);
Qs = (Qi-Qd);
{
double value_sqrt_0 = sqrt(((((Vt*Qb))*((Vt*Qb)))+((0.25*0.1)*0.1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qbaCV_dX = 0.5*((Vt*d_Qb_dX+d_Vt_dX*Qb)+deriv_sqrt_0_d0*((((Vt*Qb))*(Vt*d_Qb_dX+d_Vt_dX*Qb)+(Vt*d_Qb_dX+d_Vt_dX*Qb)*((Vt*Qb)))));
qbaCV = (0.5*((Vt*Qb)+value_sqrt_0));
}
d_qiaCV_dX = (Vt*(d_Qs_dX+d_Qd_dX)+d_Vt_dX*(Qs+Qd));
qiaCV = (Vt*(Qs+Qd));
instanceStruct.d_instanceVar_T0_dX = ((modelStruct.modelPar_QM0*(d_qiaCV_dX+(modelStruct.modelPar_ETAQM*d_qbaCV_dX+modelStruct.d_modelPar_ETAQM_dX*qbaCV))-(qiaCV+(modelStruct.modelPar_ETAQM*qbaCV))*modelStruct.d_modelPar_QM0_dX)/modelStruct.modelPar_QM0/modelStruct.modelPar_QM0);
instanceStruct.instanceVar_T0 = ((qiaCV+(modelStruct.modelPar_ETAQM*qbaCV))/modelStruct.modelPar_QM0);
{
double value_pow_0 = pow(instanceStruct.instanceVar_T0,(0.7*modelStruct.modelPar_BDOS));
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_T0 == 0.0)?0.0:(value_pow_0*(0.7*modelStruct.modelPar_BDOS)/instanceStruct.instanceVar_T0));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_T0 == 0.0)?0.0:(log(instanceStruct.instanceVar_T0)*value_pow_0);
instanceStruct.d_instanceVar_T1_dX = ((deriv_pow_0_d0*(instanceStruct.d_instanceVar_T0_dX))+(deriv_pow_0_d1*(0.7*modelStruct.d_modelPar_BDOS_dX)));
instanceStruct.instanceVar_T1 = (1.0+value_pow_0);
}
d_XDCinv_dX = ((instanceStruct.instanceVar_T1*modelStruct.d_modelPar_ADOS_dX*1.9e-9-(modelStruct.modelPar_ADOS*1.9e-9)*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
XDCinv = ((modelStruct.modelPar_ADOS*1.9e-9)/instanceStruct.instanceVar_T1);
d_Coxeffinv_dX = (-(3.9*8.85418e-12)*(((modelStruct.modelPar_EPSROX*instanceStruct.d_instanceVar_BSIM6TOXP_dX*3.9-(instanceStruct.instanceVar_BSIM6TOXP*3.9)*modelStruct.d_modelPar_EPSROX_dX)/modelStruct.modelPar_EPSROX/modelStruct.modelPar_EPSROX)+((instanceStruct.instanceVar_epsratio*d_XDCinv_dX-XDCinv*instanceStruct.d_instanceVar_epsratio_dX)/instanceStruct.instanceVar_epsratio/instanceStruct.instanceVar_epsratio))/(((instanceStruct.instanceVar_BSIM6TOXP*3.9)/modelStruct.modelPar_EPSROX)+(XDCinv/instanceStruct.instanceVar_epsratio))/(((instanceStruct.instanceVar_BSIM6TOXP*3.9)/modelStruct.modelPar_EPSROX)+(XDCinv/instanceStruct.instanceVar_epsratio)));
Coxeffinv = ((3.9*8.85418e-12)/(((instanceStruct.instanceVar_BSIM6TOXP*3.9)/modelStruct.modelPar_EPSROX)+(XDCinv/instanceStruct.instanceVar_epsratio)));
d_QBi_dX = ((((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Wact)*instanceStruct.instanceVar_Lact)*((8.85418e-12*modelStruct.modelPar_EPSROX)/instanceStruct.instanceVar_BSIM6TOXP))*Vt)*d_Qb_dX+(((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Wact)*instanceStruct.instanceVar_Lact)*((8.85418e-12*modelStruct.modelPar_EPSROX)/instanceStruct.instanceVar_BSIM6TOXP))*d_Vt_dX+((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Wact)*instanceStruct.instanceVar_Lact)*((instanceStruct.instanceVar_BSIM6TOXP*8.85418e-12*modelStruct.d_modelPar_EPSROX_dX-(8.85418e-12*modelStruct.modelPar_EPSROX)*instanceStruct.d_instanceVar_BSIM6TOXP_dX)/instanceStruct.instanceVar_BSIM6TOXP/instanceStruct.instanceVar_BSIM6TOXP)+(((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Wact)*instanceStruct.d_instanceVar_Lact_dX+(-instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Wact_dX*instanceStruct.instanceVar_Lact)*((8.85418e-12*modelStruct.modelPar_EPSROX)/instanceStruct.instanceVar_BSIM6TOXP))*Vt)*Qb);
QBi = ((((((-instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Wact)*instanceStruct.instanceVar_Lact)*((8.85418e-12*modelStruct.modelPar_EPSROX)/instanceStruct.instanceVar_BSIM6TOXP))*Vt)*Qb);
d_WLCOXVtinv_dX = ((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Wact)*instanceStruct.instanceVar_Lact)*Coxeffinv)*d_Vt_dX+(((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Wact)*instanceStruct.instanceVar_Lact)*d_Coxeffinv_dX+((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Wact)*instanceStruct.d_instanceVar_Lact_dX+instanceStruct.instancePar_NF*instanceStruct.d_instanceVar_Wact_dX*instanceStruct.instanceVar_Lact)*Coxeffinv)*Vt);
WLCOXVtinv = ((((instanceStruct.instancePar_NF*instanceStruct.instanceVar_Wact)*instanceStruct.instanceVar_Lact)*Coxeffinv)*Vt);
d_QSi_dX = ((-WLCOXVtinv)*d_Qs_dX+(-d_WLCOXVtinv_dX)*Qs);
QSi = ((-WLCOXVtinv)*Qs);
d_QDi_dX = ((-WLCOXVtinv)*d_Qd_dX+(-d_WLCOXVtinv_dX)*Qd);
QDi = ((-WLCOXVtinv)*Qd);
d_QGi_dX = (-((d_QBi_dX+d_QSi_dX)+d_QDi_dX));
QGi = (-((QBi+QSi)+QDi));
if ((!modelStruct.modelPar_given_CF))
{
{
double value_log_0 = log((modelStruct.modelPar_CFRCOEFF*(1.0+(0.4e-6/modelStruct.modelPar_TOXE))));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_CFRCOEFF*(1.0+(0.4e-6/modelStruct.modelPar_TOXE))));
instanceStruct.d_instanceVar_CF_i_dX = ((((2.0*modelStruct.modelPar_EPSROX)*8.85418e-12)/3.14159265358979323846)*deriv_log_0_d0*((modelStruct.modelPar_CFRCOEFF*(-0.4e-6*modelStruct.d_modelPar_TOXE_dX/modelStruct.modelPar_TOXE/modelStruct.modelPar_TOXE)+modelStruct.d_modelPar_CFRCOEFF_dX*(1.0+(0.4e-6/modelStruct.modelPar_TOXE))))+(2.0*modelStruct.d_modelPar_EPSROX_dX*8.85418e-12/3.14159265358979323846)*value_log_0);
instanceStruct.instanceVar_CF_i = ((((2.0*modelStruct.modelPar_EPSROX)*8.85418e-12)/3.14159265358979323846)*value_log_0);
}
}
d_Cgsof_dX = (modelStruct.d_modelPar_CGSO_dX+instanceStruct.d_instanceVar_CF_i_dX);
Cgsof = (modelStruct.modelPar_CGSO+instanceStruct.instanceVar_CF_i);
d_Cgdof_dX = (modelStruct.d_modelPar_CGDO_dX+instanceStruct.d_instanceVar_CF_i_dX);
Cgdof = (modelStruct.modelPar_CGDO+instanceStruct.instanceVar_CF_i);
if ((modelStruct.modelPar_COVMOD==0))
{
d_Qovs_dX = (((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*d_Cgsof_dX+(-instanceStruct.d_instanceVar_Wact_dX)*instanceStruct.instancePar_NF*Cgsof)*Vgs_ov_noswap;
Qovs = ((((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*Cgsof)*Vgs_ov_noswap);
d_Qovd_dX = (((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*d_Cgdof_dX+(-instanceStruct.d_instanceVar_Wact_dX)*instanceStruct.instancePar_NF*Cgdof)*Vgd_ov_noswap;
Qovd = ((((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*Cgdof)*Vgd_ov_noswap);
}
else
{
{
double value_sqrt_0 = sqrt(((((Vgs_ov_noswap-Vfbsdr)+0.02)*((Vgs_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T0_dX = deriv_sqrt_0_d0*((((Vgs_ov_noswap-Vfbsdr)+0.02)*(-d_Vfbsdr_dX)+(-d_Vfbsdr_dX)*((Vgs_ov_noswap-Vfbsdr)+0.02)));
instanceStruct.instanceVar_T0 = value_sqrt_0;
}
d_Vgsov_dX = 0.5*((-d_Vfbsdr_dX)-instanceStruct.d_instanceVar_T0_dX);
Vgsov = (0.5*(((Vgs_ov_noswap-Vfbsdr)+0.02)-instanceStruct.instanceVar_T0));
{
double value_sqrt_0 = sqrt((1.0-((4.0*Vgsov)/instanceStruct.instanceVar_CKAPPAS_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T1_dX = deriv_sqrt_0_d0*((-((instanceStruct.instanceVar_CKAPPAS_i*4.0*d_Vgsov_dX-(4.0*Vgsov)*instanceStruct.d_instanceVar_CKAPPAS_i_dX)/instanceStruct.instanceVar_CKAPPAS_i/instanceStruct.instanceVar_CKAPPAS_i)));
instanceStruct.instanceVar_T1 = value_sqrt_0;
}
d_Qovs_dX = (((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*(d_Cgsof_dX*Vgs_ov_noswap+(instanceStruct.instanceVar_CGSL_i*(((-d_Vfbsdr_dX)-d_Vgsov_dX)-((0.5*instanceStruct.instanceVar_CKAPPAS_i)*instanceStruct.d_instanceVar_T1_dX+0.5*instanceStruct.d_instanceVar_CKAPPAS_i_dX*((-1.0)+instanceStruct.instanceVar_T1)))+instanceStruct.d_instanceVar_CGSL_i_dX*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*instanceStruct.instanceVar_CKAPPAS_i)*((-1.0)+instanceStruct.instanceVar_T1)))))+(-instanceStruct.d_instanceVar_Wact_dX)*instanceStruct.instancePar_NF*((Cgsof*Vgs_ov_noswap)+(instanceStruct.instanceVar_CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*instanceStruct.instanceVar_CKAPPAS_i)*((-1.0)+instanceStruct.instanceVar_T1))))));
Qovs = (((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*((Cgsof*Vgs_ov_noswap)+(instanceStruct.instanceVar_CGSL_i*(((Vgs_ov_noswap-Vfbsdr)-Vgsov)-((0.5*instanceStruct.instanceVar_CKAPPAS_i)*((-1.0)+instanceStruct.instanceVar_T1))))));
{
double value_sqrt_0 = sqrt(((((Vgd_ov_noswap-Vfbsdr)+0.02)*((Vgd_ov_noswap-Vfbsdr)+0.02))+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T0_dX = deriv_sqrt_0_d0*((((Vgd_ov_noswap-Vfbsdr)+0.02)*(-d_Vfbsdr_dX)+(-d_Vfbsdr_dX)*((Vgd_ov_noswap-Vfbsdr)+0.02)));
instanceStruct.instanceVar_T0 = value_sqrt_0;
}
d_Vgdov_dX = 0.5*((-d_Vfbsdr_dX)-instanceStruct.d_instanceVar_T0_dX);
Vgdov = (0.5*(((Vgd_ov_noswap-Vfbsdr)+0.02)-instanceStruct.instanceVar_T0));
{
double value_sqrt_0 = sqrt((1.0-((4.0*Vgdov)/instanceStruct.instanceVar_CKAPPAD_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*((-((instanceStruct.instanceVar_CKAPPAD_i*4.0*d_Vgdov_dX-(4.0*Vgdov)*instanceStruct.d_instanceVar_CKAPPAD_i_dX)/instanceStruct.instanceVar_CKAPPAD_i/instanceStruct.instanceVar_CKAPPAD_i)));
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
d_Qovd_dX = (((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*(d_Cgdof_dX*Vgd_ov_noswap+(instanceStruct.instanceVar_CGDL_i*(((-d_Vfbsdr_dX)-d_Vgdov_dX)-((0.5*instanceStruct.instanceVar_CKAPPAD_i)*instanceStruct.d_instanceVar_T2_dX+0.5*instanceStruct.d_instanceVar_CKAPPAD_i_dX*((-1.0)+instanceStruct.instanceVar_T2)))+instanceStruct.d_instanceVar_CGDL_i_dX*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*instanceStruct.instanceVar_CKAPPAD_i)*((-1.0)+instanceStruct.instanceVar_T2)))))+(-instanceStruct.d_instanceVar_Wact_dX)*instanceStruct.instancePar_NF*((Cgdof*Vgd_ov_noswap)+(instanceStruct.instanceVar_CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*instanceStruct.instanceVar_CKAPPAD_i)*((-1.0)+instanceStruct.instanceVar_T2))))));
Qovd = (((-instanceStruct.instanceVar_Wact)*instanceStruct.instancePar_NF)*((Cgdof*Vgd_ov_noswap)+(instanceStruct.instanceVar_CGDL_i*(((Vgd_ov_noswap-Vfbsdr)-Vgdov)-((0.5*instanceStruct.instanceVar_CKAPPAD_i)*((-1.0)+instanceStruct.instanceVar_T2))))));
}
d_Qovb_dX = ((((-instanceStruct.instanceVar_devsign)*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Lact)*modelStruct.d_modelPar_CGBO_dX+((-instanceStruct.instanceVar_devsign)*instanceStruct.instancePar_NF)*instanceStruct.d_instanceVar_Lact_dX*modelStruct.modelPar_CGBO)*(probeVars[admsProbeID_V_gm_bi]);
Qovb = (((((-instanceStruct.instanceVar_devsign)*instanceStruct.instancePar_NF)*instanceStruct.instanceVar_Lact)*modelStruct.modelPar_CGBO)*(probeVars[admsProbeID_V_gm_bi]));
d_Qovg_dX = (-((d_Qovs_dX+d_Qovd_dX)+d_Qovb_dX));
Qovg = (-((Qovs+Qovd)+Qovb));
if ((modelStruct.modelPar_EDGEFET==1))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((1.0+(modelStruct.modelPar_TNFACTOREDGE*(TRatio-1.0))),1e-3);
d_NFACTOREDGE_t_dX = (modelStruct.modelPar_NFACTOREDGE*evaluator_hypsmooth_0.getDerivs((1.0+(modelStruct.modelPar_TNFACTOREDGE*(TRatio-1.0))),1e-3,(modelStruct.modelPar_TNFACTOREDGE*d_TRatio_dX+modelStruct.d_modelPar_TNFACTOREDGE_dX*(TRatio-1.0)),0.0)+modelStruct.d_modelPar_NFACTOREDGE_dX*evaluator_hypsmooth_0.getValues((1.0+(modelStruct.modelPar_TNFACTOREDGE*(TRatio-1.0))),1e-3));
NFACTOREDGE_t = (modelStruct.modelPar_NFACTOREDGE*evaluator_hypsmooth_0.getValues((1.0+(modelStruct.modelPar_TNFACTOREDGE*(TRatio-1.0))),1e-3));
}
d_ETA0EDGE_t_dX = (modelStruct.modelPar_ETA0EDGE*(modelStruct.modelPar_TETA0EDGE*d_TRatio_dX+modelStruct.d_modelPar_TETA0EDGE_dX*(TRatio-1.0))+modelStruct.d_modelPar_ETA0EDGE_dX*(1.0+(modelStruct.modelPar_TETA0EDGE*(TRatio-1.0))));
ETA0EDGE_t = (modelStruct.modelPar_ETA0EDGE*(1.0+(modelStruct.modelPar_TETA0EDGE*(TRatio-1.0))));
d_cdsc_dX = (((modelStruct.d_modelPar_CITEDGE_dX+d_NFACTOREDGE_t_dX)+modelStruct.d_modelPar_CDSCDEDGE_dX*Vdsx)-modelStruct.d_modelPar_CDSCBEDGE_dX*Vbsx);
cdsc = (((modelStruct.modelPar_CITEDGE+NFACTOREDGE_t)+(modelStruct.modelPar_CDSCDEDGE*Vdsx))-(modelStruct.modelPar_CDSCBEDGE*Vbsx));
instanceStruct.d_instanceVar_T1_dX = ((instanceStruct.instanceVar_Cox*d_cdsc_dX-cdsc*instanceStruct.d_instanceVar_Cox_dX)/instanceStruct.instanceVar_Cox/instanceStruct.instanceVar_Cox);
instanceStruct.instanceVar_T1 = (1.0+(cdsc/instanceStruct.instanceVar_Cox));
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_T1-1.0)*(instanceStruct.instanceVar_T1-1.0))+((0.25*0.05)*0.05)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_n_dX = 0.5*(instanceStruct.d_instanceVar_T1_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T1-1.0)*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*(instanceStruct.instanceVar_T1-1.0))));
n = (0.5*((instanceStruct.instanceVar_T1+1.0)+value_sqrt_0));
}
d_nVt_dX = (n*d_Vt_dX+d_n_dX*Vt);
nVt = (n*Vt);
d_inv_nVt_dX = (-d_nVt_dX/nVt/nVt);
inv_nVt = (1.0/nVt);
d_vg_dX = Vg*d_inv_nVt_dX;
vg = (Vg*inv_nVt);
d_vs_dX = Vs*d_inv_nVt_dX;
vs = (Vs*inv_nVt);
d_vfb_dX = (instanceStruct.instanceVar_VFB_i*d_inv_nVt_dX+instanceStruct.d_instanceVar_VFB_i_dX*inv_nVt);
vfb = (instanceStruct.instanceVar_VFB_i*inv_nVt);
d_dvth_dibl_dX = (-(d_ETA0EDGE_t_dX+modelStruct.d_modelPar_ETABEDGE_dX*Vbsx))*Vdsx;
dvth_dibl = ((-(ETA0EDGE_t+(modelStruct.modelPar_ETABEDGE*Vbsx)))*Vdsx);
{
double value_pow_0 = pow(TRatio,modelStruct.modelPar_KT1EXPEDGE);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_KT1EXPEDGE/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_dvth_temp_dX = (((modelStruct.modelPar_KT1EDGE+(modelStruct.modelPar_KT1LEDGE/instanceStruct.instanceVar_Leff))+(modelStruct.modelPar_KT2EDGE*Vbsx))*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_KT1EXPEDGE_dX)))+((modelStruct.d_modelPar_KT1EDGE_dX+((instanceStruct.instanceVar_Leff*modelStruct.d_modelPar_KT1LEDGE_dX-modelStruct.modelPar_KT1LEDGE*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff))+modelStruct.d_modelPar_KT2EDGE_dX*Vbsx)*(value_pow_0-1.0));
dvth_temp = (((modelStruct.modelPar_KT1EDGE+(modelStruct.modelPar_KT1LEDGE/instanceStruct.instanceVar_Leff))+(modelStruct.modelPar_KT2EDGE*Vbsx))*(value_pow_0-1.0));
}
d_litl_edge_dX = (litl*modelStruct.d_modelPar_DVT2EDGE_dX*Vbsx+d_litl_dX*(1.0+(modelStruct.modelPar_DVT2EDGE*Vbsx)));
litl_edge = (litl*(1.0+(modelStruct.modelPar_DVT2EDGE*Vbsx)));
{
double value_cosh_0 = cosh(((modelStruct.modelPar_DVT1EDGE*instanceStruct.instanceVar_Leff)/litl_edge));
double  deriv_cosh_0_d0 = (sinh(((modelStruct.modelPar_DVT1EDGE*instanceStruct.instanceVar_Leff)/litl_edge)));
d_theta_sce_edge_dX = (((value_cosh_0-1.0)*0.5*modelStruct.d_modelPar_DVT0EDGE_dX-(0.5*modelStruct.modelPar_DVT0EDGE)*deriv_cosh_0_d0*(((litl_edge*(modelStruct.modelPar_DVT1EDGE*instanceStruct.d_instanceVar_Leff_dX+modelStruct.d_modelPar_DVT1EDGE_dX*instanceStruct.instanceVar_Leff)-(modelStruct.modelPar_DVT1EDGE*instanceStruct.instanceVar_Leff)*d_litl_edge_dX)/litl_edge/litl_edge)))/(value_cosh_0-1.0)/(value_cosh_0-1.0));
theta_sce_edge = ((0.5*modelStruct.modelPar_DVT0EDGE)/(value_cosh_0-1.0));
}
d_dvth_sce_dX = (theta_sce_edge*(d_Vbi_dX-d_Phist_dX)+d_theta_sce_edge_dX*(Vbi-Phist));
dvth_sce = (theta_sce_edge*(Vbi-Phist));
d_Vth_shift_dX = (((d_dvth_dibl_dX-d_dvth_temp_dX)+d_dvth_sce_dX)+modelStruct.d_modelPar_DVTEDGE_dX);
Vth_shift = (((dvth_dibl-dvth_temp)+dvth_sce)+modelStruct.modelPar_DVTEDGE);
d_vgfb_dX = ((d_vg_dX-d_vfb_dX)-(Vth_shift*d_inv_nVt_dX+d_Vth_shift_dX*inv_nVt));
vgfb = ((vg-vfb)-(Vth_shift*inv_nVt));
{
double value_pow_0 = pow(instanceStruct.instanceVar_Leff,(-modelStruct.modelPar_DGAMMAEDGELEXP));
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_Leff == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_DGAMMAEDGELEXP)/instanceStruct.instanceVar_Leff));
double  deriv_pow_0_d1 = (instanceStruct.instanceVar_Leff == 0.0)?0.0:(log(instanceStruct.instanceVar_Leff)*value_pow_0);
d_DGAMMAEDGE_i_dX = (modelStruct.modelPar_DGAMMAEDGE*(modelStruct.modelPar_DGAMMAEDGEL*((deriv_pow_0_d0*(instanceStruct.d_instanceVar_Leff_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_DGAMMAEDGELEXP_dX))))+modelStruct.d_modelPar_DGAMMAEDGEL_dX*value_pow_0)+modelStruct.d_modelPar_DGAMMAEDGE_dX*(1.0+(modelStruct.modelPar_DGAMMAEDGEL*value_pow_0)));
DGAMMAEDGE_i = (modelStruct.modelPar_DGAMMAEDGE*(1.0+(modelStruct.modelPar_DGAMMAEDGEL*value_pow_0)));
}
{
double value_sqrt_0 = sqrt(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEP_i)*inv_nVt));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_gam_dX = ((instanceStruct.instanceVar_Cox*deriv_sqrt_0_d0*(((((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.instanceVar_NDEP_i)*d_inv_nVt_dX+(((2.0*1.60219e-19)*instanceStruct.instanceVar_epssi)*instanceStruct.d_instanceVar_NDEP_i_dX+(2.0*1.60219e-19)*instanceStruct.d_instanceVar_epssi_dX*instanceStruct.instanceVar_NDEP_i)*inv_nVt))-value_sqrt_0*instanceStruct.d_instanceVar_Cox_dX)/instanceStruct.instanceVar_Cox/instanceStruct.instanceVar_Cox);
gam = (value_sqrt_0/instanceStruct.instanceVar_Cox);
}
d_gam_dX = (gam*d_DGAMMAEDGE_i_dX+d_gam_dX*(1.0+DGAMMAEDGE_i));
gam = (gam*(1.0+DGAMMAEDGE_i));
d_inv_gam_dX = (-d_gam_dX/gam/gam);
inv_gam = (1.0/gam);
d_phib_n_dX = ((n*d_phib_dX-phib*d_n_dX)/n/n);
phib_n = (phib/n);
instanceStruct.d_instanceVar_T1_dX = 0.0;
instanceStruct.instanceVar_T1 = 1.0;
d_vgfbPD_dX = ((instanceStruct.instanceVar_T1*d_vgfb_dX-vgfb*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
vgfbPD = (vgfb/instanceStruct.instanceVar_T1);
d_gammaPD_dX = ((instanceStruct.instanceVar_T1*d_gam_dX-gam*instanceStruct.d_instanceVar_T1_dX)/instanceStruct.instanceVar_T1/instanceStruct.instanceVar_T1);
gammaPD = (gam/instanceStruct.instanceVar_T1);
instanceStruct.d_instanceVar_T1_dX = (0.5*d_vgfbPD_dX-3.0*(d_gammaPD_dX/1.41421356237309504880));
instanceStruct.instanceVar_T1 = ((0.5*vgfbPD)-(3.0*(1.0+(gammaPD/1.41421356237309504880))));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)+(6.0*vgfbPD)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1)+6.0*d_vgfbPD_dX)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1+value_sqrt_0);
}
if ((vgfbPD<0.0))
{
d_T3_dX = ((gammaPD*(d_vgfbPD_dX-instanceStruct.d_instanceVar_T2_dX)-(vgfbPD-instanceStruct.instanceVar_T2)*d_gammaPD_dX)/gammaPD/gammaPD);
T3 = ((vgfbPD-instanceStruct.instanceVar_T2)/gammaPD);
{
double value_log_0 = log(((1.0-instanceStruct.instanceVar_T2)+(T3*T3)));
double  deriv_log_0_d0 = (1.0/((1.0-instanceStruct.instanceVar_T2)+(T3*T3)));
d_psip_dX = (-deriv_log_0_d0*(((-instanceStruct.d_instanceVar_T2_dX)+(T3*d_T3_dX+d_T3_dX*T3))));
psip = (-value_log_0);
}
}
else
{
{
double value_exp_0 = exp((-instanceStruct.instanceVar_T2));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((-instanceStruct.d_instanceVar_T2_dX));
T3 = value_exp_0;
}
instanceStruct.d_instanceVar_T1_dX = 0.5*d_gammaPD_dX;
instanceStruct.instanceVar_T1 = (0.5*gammaPD);
{
double value_sqrt_0 = sqrt((((vgfbPD-1.0)+T3)+(instanceStruct.instanceVar_T1*instanceStruct.instanceVar_T1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = (deriv_sqrt_0_d0*(((d_vgfbPD_dX+d_T3_dX)+(instanceStruct.instanceVar_T1*instanceStruct.d_instanceVar_T1_dX+instanceStruct.d_instanceVar_T1_dX*instanceStruct.instanceVar_T1)))-instanceStruct.d_instanceVar_T1_dX);
instanceStruct.instanceVar_T2 = (value_sqrt_0-instanceStruct.instanceVar_T1);
}
d_psip_dX = ((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2)-d_T3_dX);
psip = (((instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2)+1.0)-T3);
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_T8_dX);
sqrtpsip = value_sqrt_0;
}
d_T9_dX = (((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));
instanceStruct.d_instanceVar_T0_dX = ((gam*(((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dX)/gam/gam);
instanceStruct.instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
instanceStruct.d_instanceVar_T1_dX = ((d_psip_dX-2.0*d_phib_n_dX)-d_vs_dX);
instanceStruct.instanceVar_T1 = ((psip-(2.0*phib_n))-vs);
{
double value_log_0 = log(((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX-deriv_log_0_d0*(((4.0*instanceStruct.instanceVar_T0)*d_sqrtpsip_dX+4.0*instanceStruct.d_instanceVar_T0_dX*sqrtpsip)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX-deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T2+0.402982))));
T8 = (0.5*((instanceStruct.instanceVar_T2-0.201491)-value_sqrt_0));
}
d_sqrtpsisa_dX = d_sqrtpsip_dX;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{
d_T4_dX = 0.0;
T4 = (-100.0);
d_T5_dX = 0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T4_dX);
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_T2_dX = ((T5*(d_T8_dX-d_T4_dX)-(T8-T4)*d_T5_dX)/T5/T5);
instanceStruct.instanceVar_T2 = ((T8-T4)/T5);
d_T6_dX = (instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2);
T6 = (instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((d_T4_dX+(T5*(0.5*instanceStruct.d_instanceVar_T2_dX+(T6*(-(T6*(-d_T6_dX)+d_T6_dX*(1.25-T6)))+d_T6_dX*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dX*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_qs_dX = (T3*((instanceStruct.d_instanceVar_T1_dX-d_T8_dX)-deriv_log_0_d0*(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+2.0*instanceStruct.d_instanceVar_T0_dX*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))+d_T3_dX*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
qs = (T3*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
d_sqrtpsisainv_dX = (-d_sqrtpsisa_dX/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T3_dX = (d_T3_dX-((T5*d_T4_dX-T4*d_T5_dX)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T6_dX = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T6 = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T7_dX = (((-((1.0/T3)*(-d_T3_dX/T3/T3)+(-d_T3_dX/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dX+(sqrtpsisa*d_sqrtpsisa_dX+d_sqrtpsisa_dX*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-d_T6_dX);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-T6);
d_qs_dX = (d_T3_dX-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dX+d_T4_dX*T7)-(T4*T7)*((2.0*T5)*d_T5_dX+2.0*d_T5_dX*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dX-T4*d_T5_dX)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qs = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
d_vdsatedge_dX = (((2.0*nVt)*d_qs_dX+2.0*d_nVt_dX*qs)+2.0*d_nVt_dX);
vdsatedge = (((2.0*nVt)*qs)+(2.0*nVt));
d_Vdsatedge_dX = d_vdsatedge_dX;
Vdsatedge = vdsatedge;
Vdsatedge = (Vdsatedge+Vs);
{
double value_sqrt_0 = sqrt(((((Vdsatedge-Vs))*((Vdsatedge-Vs)))+((0.25*1.0e-3)*1.0e-3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdssate_dX = 0.5*(d_Vdsatedge_dX+deriv_sqrt_0_d0*((((Vdsatedge-Vs))*d_Vdsatedge_dX+d_Vdsatedge_dX*((Vdsatedge-Vs)))));
Vdssate = (0.5*((Vdsatedge-Vs)+value_sqrt_0));
}
{
double value_pow_0 = pow((Vds/Vdssate),(1.0/DELTA_t));
double  deriv_pow_0_d0 = (((Vds/Vdssate) == 0.0)?0.0:(value_pow_0*(1.0/DELTA_t)/(Vds/Vdssate)));
double  deriv_pow_0_d1 = ((Vds/Vdssate) == 0.0)?0.0:(log((Vds/Vdssate))*value_pow_0);
d_T7_dX = ((deriv_pow_0_d0*((-Vds*d_Vdssate_dX/Vdssate/Vdssate)))+(deriv_pow_0_d1*((-d_DELTA_t_dX/DELTA_t/DELTA_t))));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),(-DELTA_t));
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*(-DELTA_t)/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);
d_T8_dX = ((deriv_pow_0_d0*(d_T7_dX))+(deriv_pow_0_d1*((-d_DELTA_t_dX))));
T8 = value_pow_0;
}
d_Vdseff_dX = Vds*d_T8_dX;
Vdseff = (Vds*T8);
d_vdeff_dX = ((Vdseff+Vs)*d_inv_nVt_dX+d_Vdseff_dX*inv_nVt);
vdeff = ((Vdseff+Vs)*inv_nVt);
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2)*2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
T8 = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(T8);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_T8_dX);
sqrtpsip = value_sqrt_0;
}
d_T9_dX = (((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip));
T9 = (1.0+(gam/(2.0*sqrtpsip)));
instanceStruct.d_instanceVar_T0_dX = ((gam*(((2.0*sqrtpsip)*d_gam_dX-gam*2.0*d_sqrtpsip_dX)/(2.0*sqrtpsip)/(2.0*sqrtpsip))-(1.0+(gam/(2.0*sqrtpsip)))*d_gam_dX)/gam/gam);
instanceStruct.instanceVar_T0 = ((1.0+(gam/(2.0*sqrtpsip)))/gam);
instanceStruct.d_instanceVar_T1_dX = ((d_psip_dX-2.0*d_phib_n_dX)-d_vdeff_dX);
instanceStruct.instanceVar_T1 = ((psip-(2.0*phib_n))-vdeff);
{
double value_log_0 = log(((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
double  deriv_log_0_d0 = (1.0/((4.0*instanceStruct.instanceVar_T0)*sqrtpsip));
instanceStruct.d_instanceVar_T2_dX = (instanceStruct.d_instanceVar_T1_dX-deriv_log_0_d0*(((4.0*instanceStruct.instanceVar_T0)*d_sqrtpsip_dX+4.0*instanceStruct.d_instanceVar_T0_dX*sqrtpsip)));
instanceStruct.instanceVar_T2 = (instanceStruct.instanceVar_T1-value_log_0);
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_T2*(instanceStruct.instanceVar_T2+0.402982))+2.446562));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T8_dX = 0.5*(instanceStruct.d_instanceVar_T2_dX-deriv_sqrt_0_d0*((instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*(instanceStruct.instanceVar_T2+0.402982))));
T8 = (0.5*((instanceStruct.instanceVar_T2-0.201491)-value_sqrt_0));
}
d_sqrtpsisa_dX = d_sqrtpsip_dX;
sqrtpsisa = sqrtpsip;
if ((T8<=(-68.0)))
{
d_T4_dX = 0.0;
T4 = (-100.0);
d_T5_dX = 0.0;
T5 = 20.0;
if ((T8<(T4-(0.5*T5))))
{
{
double value_exp_0 = exp(T4);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T4_dX);
T3 = value_exp_0;
}
}
else
{
if ((T8>(T4+(0.5*T5))))
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_T2_dX = ((T5*(d_T8_dX-d_T4_dX)-(T8-T4)*d_T5_dX)/T5/T5);
instanceStruct.instanceVar_T2 = ((T8-T4)/T5);
d_T6_dX = (instanceStruct.instanceVar_T2*instanceStruct.d_instanceVar_T2_dX+instanceStruct.d_instanceVar_T2_dX*instanceStruct.instanceVar_T2);
T6 = (instanceStruct.instanceVar_T2*instanceStruct.instanceVar_T2);
{
double value_exp_0 = exp((T4+(T5*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*((d_T4_dX+(T5*(0.5*instanceStruct.d_instanceVar_T2_dX+(T6*(-(T6*(-d_T6_dX)+d_T6_dX*(1.25-T6)))+d_T6_dX*((15.0/16.0)-(T6*(1.25-T6)))))+d_T5_dX*(((5.0/64.0)+(0.5*instanceStruct.instanceVar_T2))+(T6*((15.0/16.0)-(T6*(1.25-T6))))))));
T3 = value_exp_0;
}
}
}
{
double value_log_0 = log(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_qdeff_dX = (T3*((instanceStruct.d_instanceVar_T1_dX-d_T8_dX)-deriv_log_0_d0*(((2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+2.0*instanceStruct.d_instanceVar_T0_dX*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))+d_T3_dX*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
qdeff = (T3*(((1.0+instanceStruct.instanceVar_T1)-T8)-value_log_0));
}
}
else
{
{
double value_exp_0 = exp(T8);
double  deriv_exp_0_d0 = value_exp_0;
d_T3_dX = deriv_exp_0_d0*(d_T8_dX);
T3 = value_exp_0;
}
d_sqrtpsisainv_dX = (-d_sqrtpsisa_dX/sqrtpsisa/sqrtpsisa);
sqrtpsisainv = (1.0/sqrtpsisa);
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T3_dX = (d_T3_dX-((T5*d_T4_dX-T4*d_T5_dX)/T5/T5));
T3 = (T3-(T4/T5));
{
double value_log_0 = log((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
double  deriv_log_0_d0 = (1.0/(((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa))));
d_T4_dX = ((2.0*d_T3_dX+deriv_log_0_d0*((((T3*2.0)*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)+2.0*d_sqrtpsisa_dX)+((T3*2.0)*instanceStruct.d_instanceVar_T0_dX+d_T3_dX*2.0*instanceStruct.instanceVar_T0)*(((T3*2.0)*instanceStruct.instanceVar_T0)+(2.0*sqrtpsisa)))))-instanceStruct.d_instanceVar_T1_dX);
T4 = (((2.0*T3)+value_log_0)-instanceStruct.instanceVar_T1);
}
d_T5_dX = ((-d_T3_dX/T3/T3)+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T5 = ((2.0+(1.0/T3))+((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T6_dX = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))+((((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)*(instanceStruct.d_instanceVar_T0_dX-d_sqrtpsisainv_dX)-(instanceStruct.instanceVar_T0-sqrtpsisainv)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX))/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
T6 = (((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))*((instanceStruct.instanceVar_T0-sqrtpsisainv)/((instanceStruct.instanceVar_T0*T3)+sqrtpsisa)));
d_T7_dX = (((-((1.0/T3)*(-d_T3_dX/T3/T3)+(-d_T3_dX/T3/T3)*(1.0/T3)))-(-(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*d_T3_dX+instanceStruct.d_instanceVar_T0_dX*T3)+d_sqrtpsisa_dX)+((sqrtpsisa*sqrtpsisa)*d_sqrtpsisa_dX+(sqrtpsisa*d_sqrtpsisa_dX+d_sqrtpsisa_dX*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-d_T6_dX);
T7 = (((-((1.0/T3)*(1.0/T3)))-(1.0/(((sqrtpsisa*sqrtpsisa)*sqrtpsisa)*((instanceStruct.instanceVar_T0*T3)+sqrtpsisa))))-T6);
d_qdeff_dX = (d_T3_dX-((T4/T5)*((((2.0*T5)*T5)*(T4*d_T7_dX+d_T4_dX*T7)-(T4*T7)*((2.0*T5)*d_T5_dX+2.0*d_T5_dX*T5))/((2.0*T5)*T5)/((2.0*T5)*T5))+((T5*d_T4_dX-T4*d_T5_dX)/T5/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
qdeff = (T3-((T4/T5)*(1.0+((T4*T7)/((2.0*T5)*T5)))));
}
{
double value_sqrt_0 = sqrt((((psip-1.0)*(psip-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psipclamp_dX = 0.5*(d_psip_dX+deriv_sqrt_0_d0*(((psip-1.0)*d_psip_dX+d_psip_dX*(psip-1.0))));
psipclamp = (0.5*((psip+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(psipclamp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqrtpsip_dX = deriv_sqrt_0_d0*(d_psipclamp_dX);
sqrtpsip = value_sqrt_0;
}
d_psiavg_dX = ((d_psip_dX-d_qs_dX)-d_qdeff_dX);
psiavg = (((psip-qs)-qdeff)-1.0);
{
double value_sqrt_0 = sqrt((((psiavg-1.0)*(psiavg-1.0))+((0.25*2.0)*2.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T0_dX = 0.5*(d_psiavg_dX+deriv_sqrt_0_d0*(((psiavg-1.0)*d_psiavg_dX+d_psiavg_dX*(psiavg-1.0))));
instanceStruct.instanceVar_T0 = (0.5*((psiavg+1.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_T0);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_T2_dX = deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_T0_dX);
instanceStruct.instanceVar_T2 = value_sqrt_0;
}
d_nq_dX = (((sqrtpsip+instanceStruct.instanceVar_T2)*d_gam_dX-gam*(d_sqrtpsip_dX+instanceStruct.d_instanceVar_T2_dX))/(sqrtpsip+instanceStruct.instanceVar_T2)/(sqrtpsip+instanceStruct.instanceVar_T2));
nq = (1.0+(gam/(sqrtpsip+instanceStruct.instanceVar_T2)));
d_ids_edge_dX = ((((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.modelPar_WEDGE)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*d_Moc_dX+(((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.modelPar_WEDGE)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*(d_qs_dX+d_qdeff_dX)+(d_qs_dX-d_qdeff_dX)*((1.0+qs)+qdeff))+((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.modelPar_WEDGE)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*d_nVt_dX+(((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.modelPar_WEDGE)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*d_nVt_dX+((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.modelPar_WEDGE)/instanceStruct.instanceVar_Leff)*instanceStruct.d_instanceVar_Cox_dX+((instanceStruct.instanceVar_Leff*((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.d_modelPar_WEDGE_dX+(((2.0*instanceStruct.instancePar_NF)*nq)*d_ueff_dX+(2.0*instanceStruct.instancePar_NF)*d_nq_dX*ueff)*modelStruct.modelPar_WEDGE)-((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.modelPar_WEDGE)*instanceStruct.d_instanceVar_Leff_dX)/instanceStruct.instanceVar_Leff/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
ids_edge = ((((((((((2.0*instanceStruct.instancePar_NF)*nq)*ueff)*modelStruct.modelPar_WEDGE)/instanceStruct.instanceVar_Leff)*instanceStruct.instanceVar_Cox)*nVt)*nVt)*((qs-qdeff)*((1.0+qs)+qdeff)))*Moc);
d_ids_dX = (d_ids_edge_dX+d_ids_dX);
ids = (ids_edge+ids);
}
if ((sigvds>0))
{
instanceStruct.d_instanceVar_QSI_dX = instanceStruct.instanceVar_devsign*d_QSi_dX;
instanceStruct.instanceVar_QSI = (instanceStruct.instanceVar_devsign*QSi);
instanceStruct.d_instanceVar_QDI_dX = instanceStruct.instanceVar_devsign*d_QDi_dX;
instanceStruct.instanceVar_QDI = (instanceStruct.instanceVar_devsign*QDi);
}
else
{
instanceStruct.d_instanceVar_QSI_dX = instanceStruct.instanceVar_devsign*d_QDi_dX;
instanceStruct.instanceVar_QSI = (instanceStruct.instanceVar_devsign*QDi);
instanceStruct.d_instanceVar_QDI_dX = instanceStruct.instanceVar_devsign*d_QSi_dX;
instanceStruct.instanceVar_QDI = (instanceStruct.instanceVar_devsign*QSi);
}
instanceStruct.d_instanceVar_QGI_dX = instanceStruct.instanceVar_devsign*d_QGi_dX;
instanceStruct.instanceVar_QGI = (instanceStruct.instanceVar_devsign*QGi);
if ((sigvds>0))
{
}
else
{
}
// I(gi,bi) <+ (ddt((m*QGI)))
d_dynamicContributions_dX[admsNodeID_gi]+= ((instanceStruct.instancePar_m*instanceStruct.d_instanceVar_QGI_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_QGI));
d_dynamicContributions_dX[(admsNodeID_bi)]-= ((instanceStruct.instancePar_m*instanceStruct.d_instanceVar_QGI_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_QGI));
// I(si,bi) <+ (ddt((m*QSI)))
d_dynamicContributions_dX[admsNodeID_si]+= ((instanceStruct.instancePar_m*instanceStruct.d_instanceVar_QSI_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_QSI));
d_dynamicContributions_dX[(admsNodeID_bi)]-= ((instanceStruct.instancePar_m*instanceStruct.d_instanceVar_QSI_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_QSI));
// I(di,bi) <+ (ddt((m*QDI)))
d_dynamicContributions_dX[admsNodeID_di]+= ((instanceStruct.instancePar_m*instanceStruct.d_instanceVar_QDI_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_QDI));
d_dynamicContributions_dX[(admsNodeID_bi)]-= ((instanceStruct.instancePar_m*instanceStruct.d_instanceVar_QDI_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_QDI));
// I(gm,si) <+ (ddt((m*((-devsign)*Qovs))))
d_dynamicContributions_dX[admsNodeID_gm]+= ((instanceStruct.instancePar_m*(-instanceStruct.instanceVar_devsign)*d_Qovs_dX+instanceStruct.d_instancePar_m_dX*((-instanceStruct.instanceVar_devsign)*Qovs)));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((instanceStruct.instancePar_m*(-instanceStruct.instanceVar_devsign)*d_Qovs_dX+instanceStruct.d_instancePar_m_dX*((-instanceStruct.instanceVar_devsign)*Qovs)));
// I(gm,di) <+ (ddt((m*((-devsign)*Qovd))))
d_dynamicContributions_dX[admsNodeID_gm]+= ((instanceStruct.instancePar_m*(-instanceStruct.instanceVar_devsign)*d_Qovd_dX+instanceStruct.d_instancePar_m_dX*((-instanceStruct.instanceVar_devsign)*Qovd)));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((instanceStruct.instancePar_m*(-instanceStruct.instanceVar_devsign)*d_Qovd_dX+instanceStruct.d_instancePar_m_dX*((-instanceStruct.instanceVar_devsign)*Qovd)));
// I(gm,bi) <+ (ddt((m*((-devsign)*Qovb))))
d_dynamicContributions_dX[admsNodeID_gm]+= ((instanceStruct.instancePar_m*(-instanceStruct.instanceVar_devsign)*d_Qovb_dX+instanceStruct.d_instancePar_m_dX*((-instanceStruct.instanceVar_devsign)*Qovb)));
d_dynamicContributions_dX[(admsNodeID_bi)]-= ((instanceStruct.instancePar_m*(-instanceStruct.instanceVar_devsign)*d_Qovb_dX+instanceStruct.d_instancePar_m_dX*((-instanceStruct.instanceVar_devsign)*Qovb)));
// I(di,si) <+ ((((m*devsign)*sigvds)*ids))
d_staticContributions_dX[admsNodeID_di]+= (((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*sigvds)*d_ids_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*sigvds*ids);
d_staticContributions_dX[(admsNodeID_si)]-= (((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*sigvds)*d_ids_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*sigvds*ids);
if ((modelStruct.modelPar_IGBMOD!=0))
{
// I(gi,bi) <+ ((m*IGB))
d_staticContributions_dX[admsNodeID_gi]+= (instanceStruct.instancePar_m*instanceStruct.d_instanceVar_IGB_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_IGB);
d_staticContributions_dX[(admsNodeID_bi)]-= (instanceStruct.instancePar_m*instanceStruct.d_instanceVar_IGB_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_IGB);
}
if ((modelStruct.modelPar_IGCMOD!=0))
{
// I(gi,si) <+ ((m*(IGS+IGCS)))
d_staticContributions_dX[admsNodeID_gi]+= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_IGS_dX+instanceStruct.d_instanceVar_IGCS_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_IGS+instanceStruct.instanceVar_IGCS));
d_staticContributions_dX[(admsNodeID_si)]-= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_IGS_dX+instanceStruct.d_instanceVar_IGCS_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_IGS+instanceStruct.instanceVar_IGCS));
// I(gi,di) <+ ((m*(IGD+IGCD)))
d_staticContributions_dX[admsNodeID_gi]+= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_IGD_dX+instanceStruct.d_instanceVar_IGCD_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_IGD+instanceStruct.instanceVar_IGCD));
d_staticContributions_dX[(admsNodeID_di)]-= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_IGD_dX+instanceStruct.d_instanceVar_IGCD_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_IGD+instanceStruct.instanceVar_IGCD));
}
if ((sigvds>0))
{
// I(di,bi) <+ ((m*(ISUB+IGIDL)))
d_staticContributions_dX[admsNodeID_di]+= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_ISUB_dX+instanceStruct.d_instanceVar_IGIDL_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_ISUB+instanceStruct.instanceVar_IGIDL));
d_staticContributions_dX[(admsNodeID_bi)]-= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_ISUB_dX+instanceStruct.d_instanceVar_IGIDL_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_ISUB+instanceStruct.instanceVar_IGIDL));
// I(si,bi) <+ ((m*IGISL))
d_staticContributions_dX[admsNodeID_si]+= (instanceStruct.instancePar_m*instanceStruct.d_instanceVar_IGISL_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_IGISL);
d_staticContributions_dX[(admsNodeID_bi)]-= (instanceStruct.instancePar_m*instanceStruct.d_instanceVar_IGISL_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_IGISL);
}
else
{
// I(di,bi) <+ ((m*IGIDL))
d_staticContributions_dX[admsNodeID_di]+= (instanceStruct.instancePar_m*instanceStruct.d_instanceVar_IGIDL_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_IGIDL);
d_staticContributions_dX[(admsNodeID_bi)]-= (instanceStruct.instancePar_m*instanceStruct.d_instanceVar_IGIDL_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_IGIDL);
// I(si,bi) <+ ((m*(ISUB+IGISL)))
d_staticContributions_dX[admsNodeID_si]+= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_ISUB_dX+instanceStruct.d_instanceVar_IGISL_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_ISUB+instanceStruct.instanceVar_IGISL));
d_staticContributions_dX[(admsNodeID_bi)]-= (instanceStruct.instancePar_m*(instanceStruct.d_instanceVar_ISUB_dX+instanceStruct.d_instanceVar_IGISL_dX)+instanceStruct.d_instancePar_m_dX*(instanceStruct.instanceVar_ISUB+instanceStruct.instanceVar_IGISL));
}
if ((modelStruct.modelPar_RDSMOD!=2))
{
d_gdpr_dX = (-d_Rdrain_dX/Rdrain/Rdrain);
gdpr = (1.0/Rdrain);
d_gspr_dX = (-d_Rsource_dX/Rsource/Rsource);
gspr = (1.0/Rsource);
// I(d,di) <+ (((m*V(d,di))*gdpr))
d_staticContributions_dX[admsNodeID_d]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_d_di])*gdpr);
d_staticContributions_dX[(admsNodeID_di)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_d_di]))*d_gdpr_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_d_di])*gdpr);
// I(s,si) <+ (((m*V(s,si))*gspr))
d_staticContributions_dX[admsNodeID_s]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_s_si])*gspr);
d_staticContributions_dX[(admsNodeID_si)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_s_si]))*d_gspr_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_s_si])*gspr);
// I(d,di) <+ (white_noise(((m*Nt)*gdpr),"rd"))
// I(s,si) <+ (white_noise(((m*Nt)*gspr),"rs"))
}
else
{
// V(d,di) <+ (0)
// do nothing at all
// V(s,si) <+ (0)
// do nothing at all
}
if ((instanceStruct.instancePar_RGATEMOD==0))
{
// V(g,gm) <+ (0)
// do nothing at all
}
else
//Begin block rgate
{
//Block-local variables for block rgate
double Ggate=0.0;
double d_Ggate_dX=0.0;
double Gnoise=0.0;
double d_Gnoise_dX=0.0;
//End of Block-local variables
if ((instanceStruct.instancePar_RGATEMOD==2))
{
d_Ggate_dX = d_Gcrg_dX;
Ggate = Gcrg;
d_Gnoise_dX = ((instanceStruct.instanceVar_Grgeltd*(Gcrg*d_Gcrg_dX+d_Gcrg_dX*Gcrg)-(Gcrg*Gcrg)*instanceStruct.d_instanceVar_Grgeltd_dX)/instanceStruct.instanceVar_Grgeltd/instanceStruct.instanceVar_Grgeltd);
Gnoise = ((Gcrg*Gcrg)/instanceStruct.instanceVar_Grgeltd);
}
else
{
d_Ggate_dX = instanceStruct.d_instanceVar_Grgeltd_dX;
Ggate = instanceStruct.instanceVar_Grgeltd;
d_Gnoise_dX = instanceStruct.d_instanceVar_Grgeltd_dX;
Gnoise = instanceStruct.instanceVar_Grgeltd;
}
// I(g,gm) <+ (((m*V(g,gm))*Ggate))
d_staticContributions_dX[admsNodeID_g]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_g_gm])*Ggate);
d_staticContributions_dX[(admsNodeID_gm)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_g_gm]))*d_Ggate_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_g_gm])*Ggate);
// I(g,gm) <+ (white_noise(((m*Nt)*Gnoise),"rg"))
}
// End block rgate
if ((instanceStruct.instancePar_RGATEMOD==3))
{
// I(gm,gi) <+ (((m*V(gm,gi))*Gcrg))
d_staticContributions_dX[admsNodeID_gm]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_gm_gi])*Gcrg);
d_staticContributions_dX[(admsNodeID_gi)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_gm_gi]))*d_Gcrg_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_gm_gi])*Gcrg);
}
else
{
// V(gm,gi) <+ (0)
// do nothing at all
}
if (((modelStruct.modelPar_SHMOD!=0)&&(modelStruct.modelPar_RTH0>0)))
{
if ((modelStruct.modelPar_RDSMOD!=2))
{
// Pwr(t,GND) <+ ((m*((-(((((devsign*sigvds)*ids)*V(di,si))+((V(d,di)*V(d,di))/Rdrain))+((V(s,si)*V(s,si))/Rsource)))+(delTemp1*gth))))
d_staticContributions_dX[admsNodeID_t]+= (instanceStruct.instancePar_m*((-(((instanceStruct.instanceVar_devsign*sigvds)*d_ids_dX*(probeVars[admsProbeID_V_di_si])+(-((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))*d_Rdrain_dX/Rdrain/Rdrain))+(-((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))*d_Rsource_dX/Rsource/Rsource)))+delTemp1*instanceStruct.d_instanceVar_gth_dX)+instanceStruct.d_instancePar_m_dX*((-(((((instanceStruct.instanceVar_devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si]))+(((probeVars[admsProbeID_V_d_di])*(probeVars[admsProbeID_V_d_di]))/Rdrain))+(((probeVars[admsProbeID_V_s_si])*(probeVars[admsProbeID_V_s_si]))/Rsource)))+(delTemp1*instanceStruct.instanceVar_gth)));
// Pwr(t,GND) <+ (ddt(((m*delTemp1)*cth)))
d_dynamicContributions_dX[admsNodeID_t]+= (((instanceStruct.instancePar_m*delTemp1)*instanceStruct.d_instanceVar_cth_dX+instanceStruct.d_instancePar_m_dX*delTemp1*instanceStruct.instanceVar_cth));
}
else
{
// Pwr(t,GND) <+ ((m*((-(((devsign*sigvds)*ids)*V(di,si)))+(delTemp1*gth))))
d_staticContributions_dX[admsNodeID_t]+= (instanceStruct.instancePar_m*((-(instanceStruct.instanceVar_devsign*sigvds)*d_ids_dX*(probeVars[admsProbeID_V_di_si]))+delTemp1*instanceStruct.d_instanceVar_gth_dX)+instanceStruct.d_instancePar_m_dX*((-(((instanceStruct.instanceVar_devsign*sigvds)*ids)*(probeVars[admsProbeID_V_di_si])))+(delTemp1*instanceStruct.instanceVar_gth)));
// Pwr(t,GND) <+ (ddt(((m*delTemp1)*cth)))
d_dynamicContributions_dX[admsNodeID_t]+= (((instanceStruct.instancePar_m*delTemp1)*instanceStruct.d_instanceVar_cth_dX+instanceStruct.d_instancePar_m_dX*delTemp1*instanceStruct.instanceVar_cth));
}
}
else
{
// Temp(t,GND) <+ (0)
// do nothing at all
}
if ((instanceStruct.instancePar_RBODYMOD!=0))
{
// I(bi,sbulk) <+ (((m*V(bi,sbulk))*Grbps))
d_staticContributions_dX[admsNodeID_bi]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_bi_sbulk]))*instanceStruct.d_instanceVar_Grbps_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_bi_sbulk])*instanceStruct.instanceVar_Grbps);
d_staticContributions_dX[(admsNodeID_sbulk)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_bi_sbulk]))*instanceStruct.d_instanceVar_Grbps_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_bi_sbulk])*instanceStruct.instanceVar_Grbps);
// I(b,sbulk) <+ (((m*V(b,sbulk))*Grbsb))
d_staticContributions_dX[admsNodeID_b]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_b_sbulk]))*instanceStruct.d_instanceVar_Grbsb_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_b_sbulk])*instanceStruct.instanceVar_Grbsb);
d_staticContributions_dX[(admsNodeID_sbulk)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_b_sbulk]))*instanceStruct.d_instanceVar_Grbsb_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_b_sbulk])*instanceStruct.instanceVar_Grbsb);
// I(b,bi) <+ (((m*V(b,bi))*Grbpb))
d_staticContributions_dX[admsNodeID_b]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_b_bi]))*instanceStruct.d_instanceVar_Grbpb_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_b_bi])*instanceStruct.instanceVar_Grbpb);
d_staticContributions_dX[(admsNodeID_bi)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_b_bi]))*instanceStruct.d_instanceVar_Grbpb_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_b_bi])*instanceStruct.instanceVar_Grbpb);
// I(b,dbulk) <+ (((m*V(b,dbulk))*Grbdb))
d_staticContributions_dX[admsNodeID_b]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_b_dbulk]))*instanceStruct.d_instanceVar_Grbdb_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_b_dbulk])*instanceStruct.instanceVar_Grbdb);
d_staticContributions_dX[(admsNodeID_dbulk)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_b_dbulk]))*instanceStruct.d_instanceVar_Grbdb_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_b_dbulk])*instanceStruct.instanceVar_Grbdb);
// I(bi,dbulk) <+ (((m*V(bi,dbulk))*Grbpd))
d_staticContributions_dX[admsNodeID_bi]+= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_bi_dbulk]))*instanceStruct.d_instanceVar_Grbpd_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_bi_dbulk])*instanceStruct.instanceVar_Grbpd);
d_staticContributions_dX[(admsNodeID_dbulk)]-= ((instanceStruct.instancePar_m*(probeVars[admsProbeID_V_bi_dbulk]))*instanceStruct.d_instanceVar_Grbpd_dX+instanceStruct.d_instancePar_m_dX*(probeVars[admsProbeID_V_bi_dbulk])*instanceStruct.instanceVar_Grbpd);
// I(sbulk,bi) <+ (white_noise(((m*Nt)*Grbps),"rbps"))
// I(sbulk,b) <+ (white_noise(((m*Nt)*Grbsb),"rbsb"))
// I(b,bi) <+ (white_noise(((m*Nt)*Grbpb),"rbpb"))
// I(dbulk,bi) <+ (white_noise(((m*Nt)*Grbpd),"rbpd"))
// I(dbulk,b) <+ (white_noise(((m*Nt)*Grbdb),"rbdb"))
}
else
{
// V(b,sbulk) <+ (0)
// do nothing at all
// V(b,bi) <+ (0)
// do nothing at all
// V(b,dbulk) <+ (0)
// do nothing at all
}
if ((instanceStruct.instancePar_RBODYMOD!=0))
{
// I(sbulk,si) <+ (((m*devsign)*Ibs))
d_staticContributions_dX[admsNodeID_sbulk]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibs_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibs);
d_staticContributions_dX[(admsNodeID_si)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibs_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibs);
// I(dbulk,di) <+ (((m*devsign)*Ibd))
d_staticContributions_dX[admsNodeID_dbulk]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibd_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibd);
d_staticContributions_dX[(admsNodeID_di)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibd_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibd);
// I(sbulk,si) <+ (((m*devsign)*ddt(Qbs)))
d_dynamicContributions_dX[admsNodeID_sbulk]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbs_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbs));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbs_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbs));
// I(dbulk,di) <+ (((m*devsign)*ddt(Qbd)))
d_dynamicContributions_dX[admsNodeID_dbulk]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbd_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbd));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbd_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbd));
}
else
{
// I(bi,si) <+ (((m*devsign)*Ibs))
d_staticContributions_dX[admsNodeID_bi]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibs_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibs);
d_staticContributions_dX[(admsNodeID_si)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibs_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibs);
// I(bi,di) <+ (((m*devsign)*Ibd))
d_staticContributions_dX[admsNodeID_bi]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibd_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibd);
d_staticContributions_dX[(admsNodeID_di)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*d_Ibd_dX+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*Ibd);
// I(bi,si) <+ (((m*devsign)*ddt(Qbs)))
d_dynamicContributions_dX[admsNodeID_bi]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbs_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbs));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbs_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbs));
// I(bi,di) <+ (((m*devsign)*ddt(Qbd)))
d_dynamicContributions_dX[admsNodeID_bi]+= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbd_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbd));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((instanceStruct.instancePar_m*instanceStruct.instanceVar_devsign)*(d_Qbd_dX)+instanceStruct.d_instancePar_m_dX*instanceStruct.instanceVar_devsign*(Qbd));
}
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(14+0);
dqdp.resize(14+0);
Findices.resize(14+0);
Qindices.resize(14+0);

std::vector <double> probeVars(29);
std::vector <double> d_staticContributions_dX(14+0);
std::vector <double> d_dynamicContributions_dX(14+0);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 14+0 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_L=mod.L;
modelStruct.d_modelPar_L_dX=0.0;
modelStruct.modelPar_given_L=mod.given("L");
modelStruct.modelPar_VFBSDOFF=mod.VFBSDOFF;
modelStruct.d_modelPar_VFBSDOFF_dX=0.0;
modelStruct.modelPar_given_VFBSDOFF=mod.given("VFBSDOFF");
modelStruct.modelPar_XGW=mod.XGW;
modelStruct.d_modelPar_XGW_dX=0.0;
modelStruct.modelPar_given_XGW=mod.given("XGW");
modelStruct.modelPar_RBPB=mod.RBPB;
modelStruct.d_modelPar_RBPB_dX=0.0;
modelStruct.modelPar_given_RBPB=mod.given("RBPB");
modelStruct.modelPar_RBPD=mod.RBPD;
modelStruct.d_modelPar_RBPD_dX=0.0;
modelStruct.modelPar_given_RBPD=mod.given("RBPD");
modelStruct.modelPar_RBPS=mod.RBPS;
modelStruct.d_modelPar_RBPS_dX=0.0;
modelStruct.modelPar_given_RBPS=mod.given("RBPS");
modelStruct.modelPar_RBDB=mod.RBDB;
modelStruct.d_modelPar_RBDB_dX=0.0;
modelStruct.modelPar_given_RBDB=mod.given("RBDB");
modelStruct.modelPar_RBSB=mod.RBSB;
modelStruct.d_modelPar_RBSB_dX=0.0;
modelStruct.modelPar_given_RBSB=mod.given("RBSB");
modelStruct.modelPar_SA=mod.SA;
modelStruct.d_modelPar_SA_dX=0.0;
modelStruct.modelPar_given_SA=mod.given("SA");
modelStruct.modelPar_SB=mod.SB;
modelStruct.d_modelPar_SB_dX=0.0;
modelStruct.modelPar_given_SB=mod.given("SB");
modelStruct.modelPar_SD=mod.SD;
modelStruct.d_modelPar_SD_dX=0.0;
modelStruct.modelPar_given_SD=mod.given("SD");
modelStruct.modelPar_LLONG=mod.LLONG;
modelStruct.d_modelPar_LLONG_dX=0.0;
modelStruct.modelPar_given_LLONG=mod.given("LLONG");
modelStruct.modelPar_LMLT=mod.LMLT;
modelStruct.d_modelPar_LMLT_dX=0.0;
modelStruct.modelPar_given_LMLT=mod.given("LMLT");
modelStruct.modelPar_WMLT=mod.WMLT;
modelStruct.d_modelPar_WMLT_dX=0.0;
modelStruct.modelPar_given_WMLT=mod.given("WMLT");
modelStruct.modelPar_XL=mod.XL;
modelStruct.d_modelPar_XL_dX=0.0;
modelStruct.modelPar_given_XL=mod.given("XL");
modelStruct.modelPar_WWIDE=mod.WWIDE;
modelStruct.d_modelPar_WWIDE_dX=0.0;
modelStruct.modelPar_given_WWIDE=mod.given("WWIDE");
modelStruct.modelPar_XW=mod.XW;
modelStruct.d_modelPar_XW_dX=0.0;
modelStruct.modelPar_given_XW=mod.given("XW");
modelStruct.modelPar_LINT=mod.LINT;
modelStruct.d_modelPar_LINT_dX=0.0;
modelStruct.modelPar_given_LINT=mod.given("LINT");
modelStruct.modelPar_LL=mod.LL;
modelStruct.d_modelPar_LL_dX=0.0;
modelStruct.modelPar_given_LL=mod.given("LL");
modelStruct.modelPar_LW=mod.LW;
modelStruct.d_modelPar_LW_dX=0.0;
modelStruct.modelPar_given_LW=mod.given("LW");
modelStruct.modelPar_LWL=mod.LWL;
modelStruct.d_modelPar_LWL_dX=0.0;
modelStruct.modelPar_given_LWL=mod.given("LWL");
modelStruct.modelPar_LLN=mod.LLN;
modelStruct.d_modelPar_LLN_dX=0.0;
modelStruct.modelPar_given_LLN=mod.given("LLN");
modelStruct.modelPar_LWN=mod.LWN;
modelStruct.d_modelPar_LWN_dX=0.0;
modelStruct.modelPar_given_LWN=mod.given("LWN");
modelStruct.modelPar_WINT=mod.WINT;
modelStruct.d_modelPar_WINT_dX=0.0;
modelStruct.modelPar_given_WINT=mod.given("WINT");
modelStruct.modelPar_WL=mod.WL;
modelStruct.d_modelPar_WL_dX=0.0;
modelStruct.modelPar_given_WL=mod.given("WL");
modelStruct.modelPar_WW=mod.WW;
modelStruct.d_modelPar_WW_dX=0.0;
modelStruct.modelPar_given_WW=mod.given("WW");
modelStruct.modelPar_WWL=mod.WWL;
modelStruct.d_modelPar_WWL_dX=0.0;
modelStruct.modelPar_given_WWL=mod.given("WWL");
modelStruct.modelPar_WLN=mod.WLN;
modelStruct.d_modelPar_WLN_dX=0.0;
modelStruct.modelPar_given_WLN=mod.given("WLN");
modelStruct.modelPar_WWN=mod.WWN;
modelStruct.d_modelPar_WWN_dX=0.0;
modelStruct.modelPar_given_WWN=mod.given("WWN");
modelStruct.modelPar_DLC=mod.DLC;
modelStruct.d_modelPar_DLC_dX=0.0;
modelStruct.modelPar_given_DLC=mod.given("DLC");
modelStruct.modelPar_LLC=mod.LLC;
modelStruct.d_modelPar_LLC_dX=0.0;
modelStruct.modelPar_given_LLC=mod.given("LLC");
modelStruct.modelPar_LWC=mod.LWC;
modelStruct.d_modelPar_LWC_dX=0.0;
modelStruct.modelPar_given_LWC=mod.given("LWC");
modelStruct.modelPar_LWLC=mod.LWLC;
modelStruct.d_modelPar_LWLC_dX=0.0;
modelStruct.modelPar_given_LWLC=mod.given("LWLC");
modelStruct.modelPar_DWC=mod.DWC;
modelStruct.d_modelPar_DWC_dX=0.0;
modelStruct.modelPar_given_DWC=mod.given("DWC");
modelStruct.modelPar_WLC=mod.WLC;
modelStruct.d_modelPar_WLC_dX=0.0;
modelStruct.modelPar_given_WLC=mod.given("WLC");
modelStruct.modelPar_WWC=mod.WWC;
modelStruct.d_modelPar_WWC_dX=0.0;
modelStruct.modelPar_given_WWC=mod.given("WWC");
modelStruct.modelPar_WWLC=mod.WWLC;
modelStruct.d_modelPar_WWLC_dX=0.0;
modelStruct.modelPar_given_WWLC=mod.given("WWLC");
modelStruct.modelPar_TOXE=mod.TOXE;
modelStruct.d_modelPar_TOXE_dX=0.0;
modelStruct.modelPar_given_TOXE=mod.given("TOXE");
modelStruct.modelPar_TOXP=mod.TOXP;
modelStruct.d_modelPar_TOXP_dX=0.0;
modelStruct.modelPar_given_TOXP=mod.given("TOXP");
modelStruct.modelPar_DTOX=mod.DTOX;
modelStruct.d_modelPar_DTOX_dX=0.0;
modelStruct.modelPar_given_DTOX=mod.given("DTOX");
modelStruct.modelPar_NDEP=mod.NDEP;
modelStruct.d_modelPar_NDEP_dX=0.0;
modelStruct.modelPar_given_NDEP=mod.given("NDEP");
modelStruct.modelPar_NDEPL1=mod.NDEPL1;
modelStruct.d_modelPar_NDEPL1_dX=0.0;
modelStruct.modelPar_given_NDEPL1=mod.given("NDEPL1");
modelStruct.modelPar_NDEPLEXP1=mod.NDEPLEXP1;
modelStruct.d_modelPar_NDEPLEXP1_dX=0.0;
modelStruct.modelPar_given_NDEPLEXP1=mod.given("NDEPLEXP1");
modelStruct.modelPar_NDEPL2=mod.NDEPL2;
modelStruct.d_modelPar_NDEPL2_dX=0.0;
modelStruct.modelPar_given_NDEPL2=mod.given("NDEPL2");
modelStruct.modelPar_NDEPLEXP2=mod.NDEPLEXP2;
modelStruct.d_modelPar_NDEPLEXP2_dX=0.0;
modelStruct.modelPar_given_NDEPLEXP2=mod.given("NDEPLEXP2");
modelStruct.modelPar_NDEPW=mod.NDEPW;
modelStruct.d_modelPar_NDEPW_dX=0.0;
modelStruct.modelPar_given_NDEPW=mod.given("NDEPW");
modelStruct.modelPar_NDEPWEXP=mod.NDEPWEXP;
modelStruct.d_modelPar_NDEPWEXP_dX=0.0;
modelStruct.modelPar_given_NDEPWEXP=mod.given("NDEPWEXP");
modelStruct.modelPar_NDEPWL=mod.NDEPWL;
modelStruct.d_modelPar_NDEPWL_dX=0.0;
modelStruct.modelPar_given_NDEPWL=mod.given("NDEPWL");
modelStruct.modelPar_NDEPWLEXP=mod.NDEPWLEXP;
modelStruct.d_modelPar_NDEPWLEXP_dX=0.0;
modelStruct.modelPar_given_NDEPWLEXP=mod.given("NDEPWLEXP");
modelStruct.modelPar_LNDEP=mod.LNDEP;
modelStruct.d_modelPar_LNDEP_dX=0.0;
modelStruct.modelPar_given_LNDEP=mod.given("LNDEP");
modelStruct.modelPar_WNDEP=mod.WNDEP;
modelStruct.d_modelPar_WNDEP_dX=0.0;
modelStruct.modelPar_given_WNDEP=mod.given("WNDEP");
modelStruct.modelPar_PNDEP=mod.PNDEP;
modelStruct.d_modelPar_PNDEP_dX=0.0;
modelStruct.modelPar_given_PNDEP=mod.given("PNDEP");
modelStruct.modelPar_NDEPCV=mod.NDEPCV;
modelStruct.d_modelPar_NDEPCV_dX=0.0;
modelStruct.modelPar_given_NDEPCV=mod.given("NDEPCV");
modelStruct.modelPar_NDEPCVL1=mod.NDEPCVL1;
modelStruct.d_modelPar_NDEPCVL1_dX=0.0;
modelStruct.modelPar_given_NDEPCVL1=mod.given("NDEPCVL1");
modelStruct.modelPar_NDEPCVLEXP1=mod.NDEPCVLEXP1;
modelStruct.d_modelPar_NDEPCVLEXP1_dX=0.0;
modelStruct.modelPar_given_NDEPCVLEXP1=mod.given("NDEPCVLEXP1");
modelStruct.modelPar_NDEPCVL2=mod.NDEPCVL2;
modelStruct.d_modelPar_NDEPCVL2_dX=0.0;
modelStruct.modelPar_given_NDEPCVL2=mod.given("NDEPCVL2");
modelStruct.modelPar_NDEPCVLEXP2=mod.NDEPCVLEXP2;
modelStruct.d_modelPar_NDEPCVLEXP2_dX=0.0;
modelStruct.modelPar_given_NDEPCVLEXP2=mod.given("NDEPCVLEXP2");
modelStruct.modelPar_NDEPCVW=mod.NDEPCVW;
modelStruct.d_modelPar_NDEPCVW_dX=0.0;
modelStruct.modelPar_given_NDEPCVW=mod.given("NDEPCVW");
modelStruct.modelPar_NDEPCVWEXP=mod.NDEPCVWEXP;
modelStruct.d_modelPar_NDEPCVWEXP_dX=0.0;
modelStruct.modelPar_given_NDEPCVWEXP=mod.given("NDEPCVWEXP");
modelStruct.modelPar_NDEPCVWL=mod.NDEPCVWL;
modelStruct.d_modelPar_NDEPCVWL_dX=0.0;
modelStruct.modelPar_given_NDEPCVWL=mod.given("NDEPCVWL");
modelStruct.modelPar_NDEPCVWLEXP=mod.NDEPCVWLEXP;
modelStruct.d_modelPar_NDEPCVWLEXP_dX=0.0;
modelStruct.modelPar_given_NDEPCVWLEXP=mod.given("NDEPCVWLEXP");
modelStruct.modelPar_LNDEPCV=mod.LNDEPCV;
modelStruct.d_modelPar_LNDEPCV_dX=0.0;
modelStruct.modelPar_given_LNDEPCV=mod.given("LNDEPCV");
modelStruct.modelPar_WNDEPCV=mod.WNDEPCV;
modelStruct.d_modelPar_WNDEPCV_dX=0.0;
modelStruct.modelPar_given_WNDEPCV=mod.given("WNDEPCV");
modelStruct.modelPar_PNDEPCV=mod.PNDEPCV;
modelStruct.d_modelPar_PNDEPCV_dX=0.0;
modelStruct.modelPar_given_PNDEPCV=mod.given("PNDEPCV");
modelStruct.modelPar_NGATE=mod.NGATE;
modelStruct.d_modelPar_NGATE_dX=0.0;
modelStruct.modelPar_given_NGATE=mod.given("NGATE");
modelStruct.modelPar_LNGATE=mod.LNGATE;
modelStruct.d_modelPar_LNGATE_dX=0.0;
modelStruct.modelPar_given_LNGATE=mod.given("LNGATE");
modelStruct.modelPar_WNGATE=mod.WNGATE;
modelStruct.d_modelPar_WNGATE_dX=0.0;
modelStruct.modelPar_given_WNGATE=mod.given("WNGATE");
modelStruct.modelPar_PNGATE=mod.PNGATE;
modelStruct.d_modelPar_PNGATE_dX=0.0;
modelStruct.modelPar_given_PNGATE=mod.given("PNGATE");
modelStruct.modelPar_EASUB=mod.EASUB;
modelStruct.d_modelPar_EASUB_dX=0.0;
modelStruct.modelPar_given_EASUB=mod.given("EASUB");
modelStruct.modelPar_NI0SUB=mod.NI0SUB;
modelStruct.d_modelPar_NI0SUB_dX=0.0;
modelStruct.modelPar_given_NI0SUB=mod.given("NI0SUB");
modelStruct.modelPar_BG0SUB=mod.BG0SUB;
modelStruct.d_modelPar_BG0SUB_dX=0.0;
modelStruct.modelPar_given_BG0SUB=mod.given("BG0SUB");
modelStruct.modelPar_EPSRSUB=mod.EPSRSUB;
modelStruct.d_modelPar_EPSRSUB_dX=0.0;
modelStruct.modelPar_given_EPSRSUB=mod.given("EPSRSUB");
modelStruct.modelPar_EPSROX=mod.EPSROX;
modelStruct.d_modelPar_EPSROX_dX=0.0;
modelStruct.modelPar_given_EPSROX=mod.given("EPSROX");
modelStruct.modelPar_XJ=mod.XJ;
modelStruct.d_modelPar_XJ_dX=0.0;
modelStruct.modelPar_given_XJ=mod.given("XJ");
modelStruct.modelPar_LXJ=mod.LXJ;
modelStruct.d_modelPar_LXJ_dX=0.0;
modelStruct.modelPar_given_LXJ=mod.given("LXJ");
modelStruct.modelPar_WXJ=mod.WXJ;
modelStruct.d_modelPar_WXJ_dX=0.0;
modelStruct.modelPar_given_WXJ=mod.given("WXJ");
modelStruct.modelPar_PXJ=mod.PXJ;
modelStruct.d_modelPar_PXJ_dX=0.0;
modelStruct.modelPar_given_PXJ=mod.given("PXJ");
modelStruct.modelPar_LVFB=mod.LVFB;
modelStruct.d_modelPar_LVFB_dX=0.0;
modelStruct.modelPar_given_LVFB=mod.given("LVFB");
modelStruct.modelPar_WVFB=mod.WVFB;
modelStruct.d_modelPar_WVFB_dX=0.0;
modelStruct.modelPar_given_WVFB=mod.given("WVFB");
modelStruct.modelPar_PVFB=mod.PVFB;
modelStruct.d_modelPar_PVFB_dX=0.0;
modelStruct.modelPar_given_PVFB=mod.given("PVFB");
modelStruct.modelPar_VFB=mod.VFB;
modelStruct.d_modelPar_VFB_dX=0.0;
modelStruct.modelPar_given_VFB=mod.given("VFB");
modelStruct.modelPar_VFBCV=mod.VFBCV;
modelStruct.d_modelPar_VFBCV_dX=0.0;
modelStruct.modelPar_given_VFBCV=mod.given("VFBCV");
modelStruct.modelPar_LVFBCV=mod.LVFBCV;
modelStruct.d_modelPar_LVFBCV_dX=0.0;
modelStruct.modelPar_given_LVFBCV=mod.given("LVFBCV");
modelStruct.modelPar_WVFBCV=mod.WVFBCV;
modelStruct.d_modelPar_WVFBCV_dX=0.0;
modelStruct.modelPar_given_WVFBCV=mod.given("WVFBCV");
modelStruct.modelPar_PVFBCV=mod.PVFBCV;
modelStruct.d_modelPar_PVFBCV_dX=0.0;
modelStruct.modelPar_given_PVFBCV=mod.given("PVFBCV");
modelStruct.modelPar_VFBCVL=mod.VFBCVL;
modelStruct.d_modelPar_VFBCVL_dX=0.0;
modelStruct.modelPar_given_VFBCVL=mod.given("VFBCVL");
modelStruct.modelPar_VFBCVLEXP=mod.VFBCVLEXP;
modelStruct.d_modelPar_VFBCVLEXP_dX=0.0;
modelStruct.modelPar_given_VFBCVLEXP=mod.given("VFBCVLEXP");
modelStruct.modelPar_VFBCVW=mod.VFBCVW;
modelStruct.d_modelPar_VFBCVW_dX=0.0;
modelStruct.modelPar_given_VFBCVW=mod.given("VFBCVW");
modelStruct.modelPar_VFBCVWEXP=mod.VFBCVWEXP;
modelStruct.d_modelPar_VFBCVWEXP_dX=0.0;
modelStruct.modelPar_given_VFBCVWEXP=mod.given("VFBCVWEXP");
modelStruct.modelPar_VFBCVWL=mod.VFBCVWL;
modelStruct.d_modelPar_VFBCVWL_dX=0.0;
modelStruct.modelPar_given_VFBCVWL=mod.given("VFBCVWL");
modelStruct.modelPar_VFBCVWLEXP=mod.VFBCVWLEXP;
modelStruct.d_modelPar_VFBCVWLEXP_dX=0.0;
modelStruct.modelPar_given_VFBCVWLEXP=mod.given("VFBCVWLEXP");
modelStruct.modelPar_DWJ=mod.DWJ;
modelStruct.d_modelPar_DWJ_dX=0.0;
modelStruct.modelPar_given_DWJ=mod.given("DWJ");
modelStruct.modelPar_NSD=mod.NSD;
modelStruct.d_modelPar_NSD_dX=0.0;
modelStruct.modelPar_given_NSD=mod.given("NSD");
modelStruct.modelPar_LNSD=mod.LNSD;
modelStruct.d_modelPar_LNSD_dX=0.0;
modelStruct.modelPar_given_LNSD=mod.given("LNSD");
modelStruct.modelPar_WNSD=mod.WNSD;
modelStruct.d_modelPar_WNSD_dX=0.0;
modelStruct.modelPar_given_WNSD=mod.given("WNSD");
modelStruct.modelPar_PNSD=mod.PNSD;
modelStruct.d_modelPar_PNSD_dX=0.0;
modelStruct.modelPar_given_PNSD=mod.given("PNSD");
modelStruct.modelPar_DELVT0=mod.DELVT0;
modelStruct.d_modelPar_DELVT0_dX=0.0;
modelStruct.modelPar_given_DELVT0=mod.given("DELVT0");
modelStruct.modelPar_DVTP0=mod.DVTP0;
modelStruct.d_modelPar_DVTP0_dX=0.0;
modelStruct.modelPar_given_DVTP0=mod.given("DVTP0");
modelStruct.modelPar_LDVTP0=mod.LDVTP0;
modelStruct.d_modelPar_LDVTP0_dX=0.0;
modelStruct.modelPar_given_LDVTP0=mod.given("LDVTP0");
modelStruct.modelPar_WDVTP0=mod.WDVTP0;
modelStruct.d_modelPar_WDVTP0_dX=0.0;
modelStruct.modelPar_given_WDVTP0=mod.given("WDVTP0");
modelStruct.modelPar_PDVTP0=mod.PDVTP0;
modelStruct.d_modelPar_PDVTP0_dX=0.0;
modelStruct.modelPar_given_PDVTP0=mod.given("PDVTP0");
modelStruct.modelPar_DVTP1=mod.DVTP1;
modelStruct.d_modelPar_DVTP1_dX=0.0;
modelStruct.modelPar_given_DVTP1=mod.given("DVTP1");
modelStruct.modelPar_LDVTP1=mod.LDVTP1;
modelStruct.d_modelPar_LDVTP1_dX=0.0;
modelStruct.modelPar_given_LDVTP1=mod.given("LDVTP1");
modelStruct.modelPar_WDVTP1=mod.WDVTP1;
modelStruct.d_modelPar_WDVTP1_dX=0.0;
modelStruct.modelPar_given_WDVTP1=mod.given("WDVTP1");
modelStruct.modelPar_PDVTP1=mod.PDVTP1;
modelStruct.d_modelPar_PDVTP1_dX=0.0;
modelStruct.modelPar_given_PDVTP1=mod.given("PDVTP1");
modelStruct.modelPar_DVTP2=mod.DVTP2;
modelStruct.d_modelPar_DVTP2_dX=0.0;
modelStruct.modelPar_given_DVTP2=mod.given("DVTP2");
modelStruct.modelPar_LDVTP2=mod.LDVTP2;
modelStruct.d_modelPar_LDVTP2_dX=0.0;
modelStruct.modelPar_given_LDVTP2=mod.given("LDVTP2");
modelStruct.modelPar_WDVTP2=mod.WDVTP2;
modelStruct.d_modelPar_WDVTP2_dX=0.0;
modelStruct.modelPar_given_WDVTP2=mod.given("WDVTP2");
modelStruct.modelPar_PDVTP2=mod.PDVTP2;
modelStruct.d_modelPar_PDVTP2_dX=0.0;
modelStruct.modelPar_given_PDVTP2=mod.given("PDVTP2");
modelStruct.modelPar_DVTP3=mod.DVTP3;
modelStruct.d_modelPar_DVTP3_dX=0.0;
modelStruct.modelPar_given_DVTP3=mod.given("DVTP3");
modelStruct.modelPar_LDVTP3=mod.LDVTP3;
modelStruct.d_modelPar_LDVTP3_dX=0.0;
modelStruct.modelPar_given_LDVTP3=mod.given("LDVTP3");
modelStruct.modelPar_WDVTP3=mod.WDVTP3;
modelStruct.d_modelPar_WDVTP3_dX=0.0;
modelStruct.modelPar_given_WDVTP3=mod.given("WDVTP3");
modelStruct.modelPar_PDVTP3=mod.PDVTP3;
modelStruct.d_modelPar_PDVTP3_dX=0.0;
modelStruct.modelPar_given_PDVTP3=mod.given("PDVTP3");
modelStruct.modelPar_DVTP4=mod.DVTP4;
modelStruct.d_modelPar_DVTP4_dX=0.0;
modelStruct.modelPar_given_DVTP4=mod.given("DVTP4");
modelStruct.modelPar_LDVTP4=mod.LDVTP4;
modelStruct.d_modelPar_LDVTP4_dX=0.0;
modelStruct.modelPar_given_LDVTP4=mod.given("LDVTP4");
modelStruct.modelPar_WDVTP4=mod.WDVTP4;
modelStruct.d_modelPar_WDVTP4_dX=0.0;
modelStruct.modelPar_given_WDVTP4=mod.given("WDVTP4");
modelStruct.modelPar_PDVTP4=mod.PDVTP4;
modelStruct.d_modelPar_PDVTP4_dX=0.0;
modelStruct.modelPar_given_PDVTP4=mod.given("PDVTP4");
modelStruct.modelPar_DVTP5=mod.DVTP5;
modelStruct.d_modelPar_DVTP5_dX=0.0;
modelStruct.modelPar_given_DVTP5=mod.given("DVTP5");
modelStruct.modelPar_LDVTP5=mod.LDVTP5;
modelStruct.d_modelPar_LDVTP5_dX=0.0;
modelStruct.modelPar_given_LDVTP5=mod.given("LDVTP5");
modelStruct.modelPar_WDVTP5=mod.WDVTP5;
modelStruct.d_modelPar_WDVTP5_dX=0.0;
modelStruct.modelPar_given_WDVTP5=mod.given("WDVTP5");
modelStruct.modelPar_PDVTP5=mod.PDVTP5;
modelStruct.d_modelPar_PDVTP5_dX=0.0;
modelStruct.modelPar_given_PDVTP5=mod.given("PDVTP5");
modelStruct.modelPar_PHIN=mod.PHIN;
modelStruct.d_modelPar_PHIN_dX=0.0;
modelStruct.modelPar_given_PHIN=mod.given("PHIN");
modelStruct.modelPar_LPHIN=mod.LPHIN;
modelStruct.d_modelPar_LPHIN_dX=0.0;
modelStruct.modelPar_given_LPHIN=mod.given("LPHIN");
modelStruct.modelPar_WPHIN=mod.WPHIN;
modelStruct.d_modelPar_WPHIN_dX=0.0;
modelStruct.modelPar_given_WPHIN=mod.given("WPHIN");
modelStruct.modelPar_PPHIN=mod.PPHIN;
modelStruct.d_modelPar_PPHIN_dX=0.0;
modelStruct.modelPar_given_PPHIN=mod.given("PPHIN");
modelStruct.modelPar_ETA0=mod.ETA0;
modelStruct.d_modelPar_ETA0_dX=0.0;
modelStruct.modelPar_given_ETA0=mod.given("ETA0");
modelStruct.modelPar_LETA0=mod.LETA0;
modelStruct.d_modelPar_LETA0_dX=0.0;
modelStruct.modelPar_given_LETA0=mod.given("LETA0");
modelStruct.modelPar_WETA0=mod.WETA0;
modelStruct.d_modelPar_WETA0_dX=0.0;
modelStruct.modelPar_given_WETA0=mod.given("WETA0");
modelStruct.modelPar_PETA0=mod.PETA0;
modelStruct.d_modelPar_PETA0_dX=0.0;
modelStruct.modelPar_given_PETA0=mod.given("PETA0");
modelStruct.modelPar_ETA0R=mod.ETA0R;
modelStruct.d_modelPar_ETA0R_dX=0.0;
modelStruct.modelPar_given_ETA0R=mod.given("ETA0R");
modelStruct.modelPar_LETA0R=mod.LETA0R;
modelStruct.d_modelPar_LETA0R_dX=0.0;
modelStruct.modelPar_given_LETA0R=mod.given("LETA0R");
modelStruct.modelPar_WETA0R=mod.WETA0R;
modelStruct.d_modelPar_WETA0R_dX=0.0;
modelStruct.modelPar_given_WETA0R=mod.given("WETA0R");
modelStruct.modelPar_PETA0R=mod.PETA0R;
modelStruct.d_modelPar_PETA0R_dX=0.0;
modelStruct.modelPar_given_PETA0R=mod.given("PETA0R");
modelStruct.modelPar_DSUB=mod.DSUB;
modelStruct.d_modelPar_DSUB_dX=0.0;
modelStruct.modelPar_given_DSUB=mod.given("DSUB");
modelStruct.modelPar_ETAB=mod.ETAB;
modelStruct.d_modelPar_ETAB_dX=0.0;
modelStruct.modelPar_given_ETAB=mod.given("ETAB");
modelStruct.modelPar_ETABEXP=mod.ETABEXP;
modelStruct.d_modelPar_ETABEXP_dX=0.0;
modelStruct.modelPar_given_ETABEXP=mod.given("ETABEXP");
modelStruct.modelPar_LETAB=mod.LETAB;
modelStruct.d_modelPar_LETAB_dX=0.0;
modelStruct.modelPar_given_LETAB=mod.given("LETAB");
modelStruct.modelPar_WETAB=mod.WETAB;
modelStruct.d_modelPar_WETAB_dX=0.0;
modelStruct.modelPar_given_WETAB=mod.given("WETAB");
modelStruct.modelPar_PETAB=mod.PETAB;
modelStruct.d_modelPar_PETAB_dX=0.0;
modelStruct.modelPar_given_PETAB=mod.given("PETAB");
modelStruct.modelPar_K1=mod.K1;
modelStruct.d_modelPar_K1_dX=0.0;
modelStruct.modelPar_given_K1=mod.given("K1");
modelStruct.modelPar_K1L=mod.K1L;
modelStruct.d_modelPar_K1L_dX=0.0;
modelStruct.modelPar_given_K1L=mod.given("K1L");
modelStruct.modelPar_K1LEXP=mod.K1LEXP;
modelStruct.d_modelPar_K1LEXP_dX=0.0;
modelStruct.modelPar_given_K1LEXP=mod.given("K1LEXP");
modelStruct.modelPar_K1W=mod.K1W;
modelStruct.d_modelPar_K1W_dX=0.0;
modelStruct.modelPar_given_K1W=mod.given("K1W");
modelStruct.modelPar_K1WEXP=mod.K1WEXP;
modelStruct.d_modelPar_K1WEXP_dX=0.0;
modelStruct.modelPar_given_K1WEXP=mod.given("K1WEXP");
modelStruct.modelPar_K1WL=mod.K1WL;
modelStruct.d_modelPar_K1WL_dX=0.0;
modelStruct.modelPar_given_K1WL=mod.given("K1WL");
modelStruct.modelPar_K1WLEXP=mod.K1WLEXP;
modelStruct.d_modelPar_K1WLEXP_dX=0.0;
modelStruct.modelPar_given_K1WLEXP=mod.given("K1WLEXP");
modelStruct.modelPar_LK1=mod.LK1;
modelStruct.d_modelPar_LK1_dX=0.0;
modelStruct.modelPar_given_LK1=mod.given("LK1");
modelStruct.modelPar_WK1=mod.WK1;
modelStruct.d_modelPar_WK1_dX=0.0;
modelStruct.modelPar_given_WK1=mod.given("WK1");
modelStruct.modelPar_PK1=mod.PK1;
modelStruct.d_modelPar_PK1_dX=0.0;
modelStruct.modelPar_given_PK1=mod.given("PK1");
modelStruct.modelPar_K2=mod.K2;
modelStruct.d_modelPar_K2_dX=0.0;
modelStruct.modelPar_given_K2=mod.given("K2");
modelStruct.modelPar_K2L=mod.K2L;
modelStruct.d_modelPar_K2L_dX=0.0;
modelStruct.modelPar_given_K2L=mod.given("K2L");
modelStruct.modelPar_K2LEXP=mod.K2LEXP;
modelStruct.d_modelPar_K2LEXP_dX=0.0;
modelStruct.modelPar_given_K2LEXP=mod.given("K2LEXP");
modelStruct.modelPar_K2W=mod.K2W;
modelStruct.d_modelPar_K2W_dX=0.0;
modelStruct.modelPar_given_K2W=mod.given("K2W");
modelStruct.modelPar_K2WEXP=mod.K2WEXP;
modelStruct.d_modelPar_K2WEXP_dX=0.0;
modelStruct.modelPar_given_K2WEXP=mod.given("K2WEXP");
modelStruct.modelPar_K2WL=mod.K2WL;
modelStruct.d_modelPar_K2WL_dX=0.0;
modelStruct.modelPar_given_K2WL=mod.given("K2WL");
modelStruct.modelPar_K2WLEXP=mod.K2WLEXP;
modelStruct.d_modelPar_K2WLEXP_dX=0.0;
modelStruct.modelPar_given_K2WLEXP=mod.given("K2WLEXP");
modelStruct.modelPar_LK2=mod.LK2;
modelStruct.d_modelPar_LK2_dX=0.0;
modelStruct.modelPar_given_LK2=mod.given("LK2");
modelStruct.modelPar_WK2=mod.WK2;
modelStruct.d_modelPar_WK2_dX=0.0;
modelStruct.modelPar_given_WK2=mod.given("WK2");
modelStruct.modelPar_PK2=mod.PK2;
modelStruct.d_modelPar_PK2_dX=0.0;
modelStruct.modelPar_given_PK2=mod.given("PK2");
modelStruct.modelPar_ADOS=mod.ADOS;
modelStruct.d_modelPar_ADOS_dX=0.0;
modelStruct.modelPar_given_ADOS=mod.given("ADOS");
modelStruct.modelPar_BDOS=mod.BDOS;
modelStruct.d_modelPar_BDOS_dX=0.0;
modelStruct.modelPar_given_BDOS=mod.given("BDOS");
modelStruct.modelPar_QM0=mod.QM0;
modelStruct.d_modelPar_QM0_dX=0.0;
modelStruct.modelPar_given_QM0=mod.given("QM0");
modelStruct.modelPar_ETAQM=mod.ETAQM;
modelStruct.d_modelPar_ETAQM_dX=0.0;
modelStruct.modelPar_given_ETAQM=mod.given("ETAQM");
modelStruct.modelPar_CIT=mod.CIT;
modelStruct.d_modelPar_CIT_dX=0.0;
modelStruct.modelPar_given_CIT=mod.given("CIT");
modelStruct.modelPar_LCIT=mod.LCIT;
modelStruct.d_modelPar_LCIT_dX=0.0;
modelStruct.modelPar_given_LCIT=mod.given("LCIT");
modelStruct.modelPar_WCIT=mod.WCIT;
modelStruct.d_modelPar_WCIT_dX=0.0;
modelStruct.modelPar_given_WCIT=mod.given("WCIT");
modelStruct.modelPar_PCIT=mod.PCIT;
modelStruct.d_modelPar_PCIT_dX=0.0;
modelStruct.modelPar_given_PCIT=mod.given("PCIT");
modelStruct.modelPar_NFACTOR=mod.NFACTOR;
modelStruct.d_modelPar_NFACTOR_dX=0.0;
modelStruct.modelPar_given_NFACTOR=mod.given("NFACTOR");
modelStruct.modelPar_NFACTORL=mod.NFACTORL;
modelStruct.d_modelPar_NFACTORL_dX=0.0;
modelStruct.modelPar_given_NFACTORL=mod.given("NFACTORL");
modelStruct.modelPar_NFACTORLEXP=mod.NFACTORLEXP;
modelStruct.d_modelPar_NFACTORLEXP_dX=0.0;
modelStruct.modelPar_given_NFACTORLEXP=mod.given("NFACTORLEXP");
modelStruct.modelPar_NFACTORW=mod.NFACTORW;
modelStruct.d_modelPar_NFACTORW_dX=0.0;
modelStruct.modelPar_given_NFACTORW=mod.given("NFACTORW");
modelStruct.modelPar_NFACTORWEXP=mod.NFACTORWEXP;
modelStruct.d_modelPar_NFACTORWEXP_dX=0.0;
modelStruct.modelPar_given_NFACTORWEXP=mod.given("NFACTORWEXP");
modelStruct.modelPar_NFACTORWL=mod.NFACTORWL;
modelStruct.d_modelPar_NFACTORWL_dX=0.0;
modelStruct.modelPar_given_NFACTORWL=mod.given("NFACTORWL");
modelStruct.modelPar_NFACTORWLEXP=mod.NFACTORWLEXP;
modelStruct.d_modelPar_NFACTORWLEXP_dX=0.0;
modelStruct.modelPar_given_NFACTORWLEXP=mod.given("NFACTORWLEXP");
modelStruct.modelPar_LNFACTOR=mod.LNFACTOR;
modelStruct.d_modelPar_LNFACTOR_dX=0.0;
modelStruct.modelPar_given_LNFACTOR=mod.given("LNFACTOR");
modelStruct.modelPar_WNFACTOR=mod.WNFACTOR;
modelStruct.d_modelPar_WNFACTOR_dX=0.0;
modelStruct.modelPar_given_WNFACTOR=mod.given("WNFACTOR");
modelStruct.modelPar_PNFACTOR=mod.PNFACTOR;
modelStruct.d_modelPar_PNFACTOR_dX=0.0;
modelStruct.modelPar_given_PNFACTOR=mod.given("PNFACTOR");
modelStruct.modelPar_CDSCD=mod.CDSCD;
modelStruct.d_modelPar_CDSCD_dX=0.0;
modelStruct.modelPar_given_CDSCD=mod.given("CDSCD");
modelStruct.modelPar_CDSCDL=mod.CDSCDL;
modelStruct.d_modelPar_CDSCDL_dX=0.0;
modelStruct.modelPar_given_CDSCDL=mod.given("CDSCDL");
modelStruct.modelPar_CDSCDLEXP=mod.CDSCDLEXP;
modelStruct.d_modelPar_CDSCDLEXP_dX=0.0;
modelStruct.modelPar_given_CDSCDLEXP=mod.given("CDSCDLEXP");
modelStruct.modelPar_LCDSCD=mod.LCDSCD;
modelStruct.d_modelPar_LCDSCD_dX=0.0;
modelStruct.modelPar_given_LCDSCD=mod.given("LCDSCD");
modelStruct.modelPar_WCDSCD=mod.WCDSCD;
modelStruct.d_modelPar_WCDSCD_dX=0.0;
modelStruct.modelPar_given_WCDSCD=mod.given("WCDSCD");
modelStruct.modelPar_PCDSCD=mod.PCDSCD;
modelStruct.d_modelPar_PCDSCD_dX=0.0;
modelStruct.modelPar_given_PCDSCD=mod.given("PCDSCD");
modelStruct.modelPar_CDSCDR=mod.CDSCDR;
modelStruct.d_modelPar_CDSCDR_dX=0.0;
modelStruct.modelPar_given_CDSCDR=mod.given("CDSCDR");
modelStruct.modelPar_CDSCDLR=mod.CDSCDLR;
modelStruct.d_modelPar_CDSCDLR_dX=0.0;
modelStruct.modelPar_given_CDSCDLR=mod.given("CDSCDLR");
modelStruct.modelPar_LCDSCDR=mod.LCDSCDR;
modelStruct.d_modelPar_LCDSCDR_dX=0.0;
modelStruct.modelPar_given_LCDSCDR=mod.given("LCDSCDR");
modelStruct.modelPar_WCDSCDR=mod.WCDSCDR;
modelStruct.d_modelPar_WCDSCDR_dX=0.0;
modelStruct.modelPar_given_WCDSCDR=mod.given("WCDSCDR");
modelStruct.modelPar_PCDSCDR=mod.PCDSCDR;
modelStruct.d_modelPar_PCDSCDR_dX=0.0;
modelStruct.modelPar_given_PCDSCDR=mod.given("PCDSCDR");
modelStruct.modelPar_CDSCB=mod.CDSCB;
modelStruct.d_modelPar_CDSCB_dX=0.0;
modelStruct.modelPar_given_CDSCB=mod.given("CDSCB");
modelStruct.modelPar_CDSCBL=mod.CDSCBL;
modelStruct.d_modelPar_CDSCBL_dX=0.0;
modelStruct.modelPar_given_CDSCBL=mod.given("CDSCBL");
modelStruct.modelPar_CDSCBLEXP=mod.CDSCBLEXP;
modelStruct.d_modelPar_CDSCBLEXP_dX=0.0;
modelStruct.modelPar_given_CDSCBLEXP=mod.given("CDSCBLEXP");
modelStruct.modelPar_LCDSCB=mod.LCDSCB;
modelStruct.d_modelPar_LCDSCB_dX=0.0;
modelStruct.modelPar_given_LCDSCB=mod.given("LCDSCB");
modelStruct.modelPar_WCDSCB=mod.WCDSCB;
modelStruct.d_modelPar_WCDSCB_dX=0.0;
modelStruct.modelPar_given_WCDSCB=mod.given("WCDSCB");
modelStruct.modelPar_PCDSCB=mod.PCDSCB;
modelStruct.d_modelPar_PCDSCB_dX=0.0;
modelStruct.modelPar_given_PCDSCB=mod.given("PCDSCB");
modelStruct.modelPar_VSAT=mod.VSAT;
modelStruct.d_modelPar_VSAT_dX=0.0;
modelStruct.modelPar_given_VSAT=mod.given("VSAT");
modelStruct.modelPar_LVSAT=mod.LVSAT;
modelStruct.d_modelPar_LVSAT_dX=0.0;
modelStruct.modelPar_given_LVSAT=mod.given("LVSAT");
modelStruct.modelPar_WVSAT=mod.WVSAT;
modelStruct.d_modelPar_WVSAT_dX=0.0;
modelStruct.modelPar_given_WVSAT=mod.given("WVSAT");
modelStruct.modelPar_PVSAT=mod.PVSAT;
modelStruct.d_modelPar_PVSAT_dX=0.0;
modelStruct.modelPar_given_PVSAT=mod.given("PVSAT");
modelStruct.modelPar_VSATL=mod.VSATL;
modelStruct.d_modelPar_VSATL_dX=0.0;
modelStruct.modelPar_given_VSATL=mod.given("VSATL");
modelStruct.modelPar_VSATLEXP=mod.VSATLEXP;
modelStruct.d_modelPar_VSATLEXP_dX=0.0;
modelStruct.modelPar_given_VSATLEXP=mod.given("VSATLEXP");
modelStruct.modelPar_VSATW=mod.VSATW;
modelStruct.d_modelPar_VSATW_dX=0.0;
modelStruct.modelPar_given_VSATW=mod.given("VSATW");
modelStruct.modelPar_VSATWEXP=mod.VSATWEXP;
modelStruct.d_modelPar_VSATWEXP_dX=0.0;
modelStruct.modelPar_given_VSATWEXP=mod.given("VSATWEXP");
modelStruct.modelPar_VSATWL=mod.VSATWL;
modelStruct.d_modelPar_VSATWL_dX=0.0;
modelStruct.modelPar_given_VSATWL=mod.given("VSATWL");
modelStruct.modelPar_VSATWLEXP=mod.VSATWLEXP;
modelStruct.d_modelPar_VSATWLEXP_dX=0.0;
modelStruct.modelPar_given_VSATWLEXP=mod.given("VSATWLEXP");
modelStruct.modelPar_VSATR=mod.VSATR;
modelStruct.d_modelPar_VSATR_dX=0.0;
modelStruct.modelPar_given_VSATR=mod.given("VSATR");
modelStruct.modelPar_LVSATR=mod.LVSATR;
modelStruct.d_modelPar_LVSATR_dX=0.0;
modelStruct.modelPar_given_LVSATR=mod.given("LVSATR");
modelStruct.modelPar_WVSATR=mod.WVSATR;
modelStruct.d_modelPar_WVSATR_dX=0.0;
modelStruct.modelPar_given_WVSATR=mod.given("WVSATR");
modelStruct.modelPar_PVSATR=mod.PVSATR;
modelStruct.d_modelPar_PVSATR_dX=0.0;
modelStruct.modelPar_given_PVSATR=mod.given("PVSATR");
modelStruct.modelPar_DELTA=mod.DELTA;
modelStruct.d_modelPar_DELTA_dX=0.0;
modelStruct.modelPar_given_DELTA=mod.given("DELTA");
modelStruct.modelPar_LDELTA=mod.LDELTA;
modelStruct.d_modelPar_LDELTA_dX=0.0;
modelStruct.modelPar_given_LDELTA=mod.given("LDELTA");
modelStruct.modelPar_WDELTA=mod.WDELTA;
modelStruct.d_modelPar_WDELTA_dX=0.0;
modelStruct.modelPar_given_WDELTA=mod.given("WDELTA");
modelStruct.modelPar_PDELTA=mod.PDELTA;
modelStruct.d_modelPar_PDELTA_dX=0.0;
modelStruct.modelPar_given_PDELTA=mod.given("PDELTA");
modelStruct.modelPar_DELTAL=mod.DELTAL;
modelStruct.d_modelPar_DELTAL_dX=0.0;
modelStruct.modelPar_given_DELTAL=mod.given("DELTAL");
modelStruct.modelPar_DELTALEXP=mod.DELTALEXP;
modelStruct.d_modelPar_DELTALEXP_dX=0.0;
modelStruct.modelPar_given_DELTALEXP=mod.given("DELTALEXP");
modelStruct.modelPar_VSATCV=mod.VSATCV;
modelStruct.d_modelPar_VSATCV_dX=0.0;
modelStruct.modelPar_given_VSATCV=mod.given("VSATCV");
modelStruct.modelPar_LVSATCV=mod.LVSATCV;
modelStruct.d_modelPar_LVSATCV_dX=0.0;
modelStruct.modelPar_given_LVSATCV=mod.given("LVSATCV");
modelStruct.modelPar_WVSATCV=mod.WVSATCV;
modelStruct.d_modelPar_WVSATCV_dX=0.0;
modelStruct.modelPar_given_WVSATCV=mod.given("WVSATCV");
modelStruct.modelPar_PVSATCV=mod.PVSATCV;
modelStruct.d_modelPar_PVSATCV_dX=0.0;
modelStruct.modelPar_given_PVSATCV=mod.given("PVSATCV");
modelStruct.modelPar_VSATCVL=mod.VSATCVL;
modelStruct.d_modelPar_VSATCVL_dX=0.0;
modelStruct.modelPar_given_VSATCVL=mod.given("VSATCVL");
modelStruct.modelPar_VSATCVLEXP=mod.VSATCVLEXP;
modelStruct.d_modelPar_VSATCVLEXP_dX=0.0;
modelStruct.modelPar_given_VSATCVLEXP=mod.given("VSATCVLEXP");
modelStruct.modelPar_VSATCVW=mod.VSATCVW;
modelStruct.d_modelPar_VSATCVW_dX=0.0;
modelStruct.modelPar_given_VSATCVW=mod.given("VSATCVW");
modelStruct.modelPar_VSATCVWEXP=mod.VSATCVWEXP;
modelStruct.d_modelPar_VSATCVWEXP_dX=0.0;
modelStruct.modelPar_given_VSATCVWEXP=mod.given("VSATCVWEXP");
modelStruct.modelPar_VSATCVWL=mod.VSATCVWL;
modelStruct.d_modelPar_VSATCVWL_dX=0.0;
modelStruct.modelPar_given_VSATCVWL=mod.given("VSATCVWL");
modelStruct.modelPar_VSATCVWLEXP=mod.VSATCVWLEXP;
modelStruct.d_modelPar_VSATCVWLEXP_dX=0.0;
modelStruct.modelPar_given_VSATCVWLEXP=mod.given("VSATCVWLEXP");
modelStruct.modelPar_UP1=mod.UP1;
modelStruct.d_modelPar_UP1_dX=0.0;
modelStruct.modelPar_given_UP1=mod.given("UP1");
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modelStruct.modelPar_UP2=mod.UP2;
modelStruct.d_modelPar_UP2_dX=0.0;
modelStruct.modelPar_given_UP2=mod.given("UP2");
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modelStruct.modelPar_MULU0=mod.MULU0;
modelStruct.d_modelPar_MULU0_dX=0.0;
modelStruct.modelPar_given_MULU0=mod.given("MULU0");
modelStruct.modelPar_U0=mod.U0;
modelStruct.d_modelPar_U0_dX=0.0;
modelStruct.modelPar_given_U0=mod.given("U0");
modelStruct.modelPar_U0L=mod.U0L;
modelStruct.d_modelPar_U0L_dX=0.0;
modelStruct.modelPar_given_U0L=mod.given("U0L");
modelStruct.modelPar_U0LEXP=mod.U0LEXP;
modelStruct.d_modelPar_U0LEXP_dX=0.0;
modelStruct.modelPar_given_U0LEXP=mod.given("U0LEXP");
modelStruct.modelPar_LU0=mod.LU0;
modelStruct.d_modelPar_LU0_dX=0.0;
modelStruct.modelPar_given_LU0=mod.given("LU0");
modelStruct.modelPar_WU0=mod.WU0;
modelStruct.d_modelPar_WU0_dX=0.0;
modelStruct.modelPar_given_WU0=mod.given("WU0");
modelStruct.modelPar_PU0=mod.PU0;
modelStruct.d_modelPar_PU0_dX=0.0;
modelStruct.modelPar_given_PU0=mod.given("PU0");
modelStruct.modelPar_U0R=mod.U0R;
modelStruct.d_modelPar_U0R_dX=0.0;
modelStruct.modelPar_given_U0R=mod.given("U0R");
modelStruct.modelPar_LU0R=mod.LU0R;
modelStruct.d_modelPar_LU0R_dX=0.0;
modelStruct.modelPar_given_LU0R=mod.given("LU0R");
modelStruct.modelPar_WU0R=mod.WU0R;
modelStruct.d_modelPar_WU0R_dX=0.0;
modelStruct.modelPar_given_WU0R=mod.given("WU0R");
modelStruct.modelPar_PU0R=mod.PU0R;
modelStruct.d_modelPar_PU0R_dX=0.0;
modelStruct.modelPar_given_PU0R=mod.given("PU0R");
modelStruct.modelPar_ETAMOB=mod.ETAMOB;
modelStruct.d_modelPar_ETAMOB_dX=0.0;
modelStruct.modelPar_given_ETAMOB=mod.given("ETAMOB");
modelStruct.modelPar_UA=mod.UA;
modelStruct.d_modelPar_UA_dX=0.0;
modelStruct.modelPar_given_UA=mod.given("UA");
modelStruct.modelPar_UAL=mod.UAL;
modelStruct.d_modelPar_UAL_dX=0.0;
modelStruct.modelPar_given_UAL=mod.given("UAL");
modelStruct.modelPar_UALEXP=mod.UALEXP;
modelStruct.d_modelPar_UALEXP_dX=0.0;
modelStruct.modelPar_given_UALEXP=mod.given("UALEXP");
modelStruct.modelPar_UAW=mod.UAW;
modelStruct.d_modelPar_UAW_dX=0.0;
modelStruct.modelPar_given_UAW=mod.given("UAW");
modelStruct.modelPar_UAWEXP=mod.UAWEXP;
modelStruct.d_modelPar_UAWEXP_dX=0.0;
modelStruct.modelPar_given_UAWEXP=mod.given("UAWEXP");
modelStruct.modelPar_UAWL=mod.UAWL;
modelStruct.d_modelPar_UAWL_dX=0.0;
modelStruct.modelPar_given_UAWL=mod.given("UAWL");
modelStruct.modelPar_UAWLEXP=mod.UAWLEXP;
modelStruct.d_modelPar_UAWLEXP_dX=0.0;
modelStruct.modelPar_given_UAWLEXP=mod.given("UAWLEXP");
modelStruct.modelPar_LUA=mod.LUA;
modelStruct.d_modelPar_LUA_dX=0.0;
modelStruct.modelPar_given_LUA=mod.given("LUA");
modelStruct.modelPar_WUA=mod.WUA;
modelStruct.d_modelPar_WUA_dX=0.0;
modelStruct.modelPar_given_WUA=mod.given("WUA");
modelStruct.modelPar_PUA=mod.PUA;
modelStruct.d_modelPar_PUA_dX=0.0;
modelStruct.modelPar_given_PUA=mod.given("PUA");
modelStruct.modelPar_UAR=mod.UAR;
modelStruct.d_modelPar_UAR_dX=0.0;
modelStruct.modelPar_given_UAR=mod.given("UAR");
modelStruct.modelPar_LUAR=mod.LUAR;
modelStruct.d_modelPar_LUAR_dX=0.0;
modelStruct.modelPar_given_LUAR=mod.given("LUAR");
modelStruct.modelPar_WUAR=mod.WUAR;
modelStruct.d_modelPar_WUAR_dX=0.0;
modelStruct.modelPar_given_WUAR=mod.given("WUAR");
modelStruct.modelPar_PUAR=mod.PUAR;
modelStruct.d_modelPar_PUAR_dX=0.0;
modelStruct.modelPar_given_PUAR=mod.given("PUAR");
modelStruct.modelPar_EU=mod.EU;
modelStruct.d_modelPar_EU_dX=0.0;
modelStruct.modelPar_given_EU=mod.given("EU");
modelStruct.modelPar_LEU=mod.LEU;
modelStruct.d_modelPar_LEU_dX=0.0;
modelStruct.modelPar_given_LEU=mod.given("LEU");
modelStruct.modelPar_WEU=mod.WEU;
modelStruct.d_modelPar_WEU_dX=0.0;
modelStruct.modelPar_given_WEU=mod.given("WEU");
modelStruct.modelPar_PEU=mod.PEU;
modelStruct.d_modelPar_PEU_dX=0.0;
modelStruct.modelPar_given_PEU=mod.given("PEU");
modelStruct.modelPar_EUL=mod.EUL;
modelStruct.d_modelPar_EUL_dX=0.0;
modelStruct.modelPar_given_EUL=mod.given("EUL");
modelStruct.modelPar_EULEXP=mod.EULEXP;
modelStruct.d_modelPar_EULEXP_dX=0.0;
modelStruct.modelPar_given_EULEXP=mod.given("EULEXP");
modelStruct.modelPar_EUW=mod.EUW;
modelStruct.d_modelPar_EUW_dX=0.0;
modelStruct.modelPar_given_EUW=mod.given("EUW");
modelStruct.modelPar_EUWEXP=mod.EUWEXP;
modelStruct.d_modelPar_EUWEXP_dX=0.0;
modelStruct.modelPar_given_EUWEXP=mod.given("EUWEXP");
modelStruct.modelPar_EUWL=mod.EUWL;
modelStruct.d_modelPar_EUWL_dX=0.0;
modelStruct.modelPar_given_EUWL=mod.given("EUWL");
modelStruct.modelPar_EUWLEXP=mod.EUWLEXP;
modelStruct.d_modelPar_EUWLEXP_dX=0.0;
modelStruct.modelPar_given_EUWLEXP=mod.given("EUWLEXP");
modelStruct.modelPar_UD=mod.UD;
modelStruct.d_modelPar_UD_dX=0.0;
modelStruct.modelPar_given_UD=mod.given("UD");
modelStruct.modelPar_UDL=mod.UDL;
modelStruct.d_modelPar_UDL_dX=0.0;
modelStruct.modelPar_given_UDL=mod.given("UDL");
modelStruct.modelPar_UDLEXP=mod.UDLEXP;
modelStruct.d_modelPar_UDLEXP_dX=0.0;
modelStruct.modelPar_given_UDLEXP=mod.given("UDLEXP");
modelStruct.modelPar_LUD=mod.LUD;
modelStruct.d_modelPar_LUD_dX=0.0;
modelStruct.modelPar_given_LUD=mod.given("LUD");
modelStruct.modelPar_WUD=mod.WUD;
modelStruct.d_modelPar_WUD_dX=0.0;
modelStruct.modelPar_given_WUD=mod.given("WUD");
modelStruct.modelPar_PUD=mod.PUD;
modelStruct.d_modelPar_PUD_dX=0.0;
modelStruct.modelPar_given_PUD=mod.given("PUD");
modelStruct.modelPar_UDR=mod.UDR;
modelStruct.d_modelPar_UDR_dX=0.0;
modelStruct.modelPar_given_UDR=mod.given("UDR");
modelStruct.modelPar_LUDR=mod.LUDR;
modelStruct.d_modelPar_LUDR_dX=0.0;
modelStruct.modelPar_given_LUDR=mod.given("LUDR");
modelStruct.modelPar_WUDR=mod.WUDR;
modelStruct.d_modelPar_WUDR_dX=0.0;
modelStruct.modelPar_given_WUDR=mod.given("WUDR");
modelStruct.modelPar_PUDR=mod.PUDR;
modelStruct.d_modelPar_PUDR_dX=0.0;
modelStruct.modelPar_given_PUDR=mod.given("PUDR");
modelStruct.modelPar_UCS=mod.UCS;
modelStruct.d_modelPar_UCS_dX=0.0;
modelStruct.modelPar_given_UCS=mod.given("UCS");
modelStruct.modelPar_LUCS=mod.LUCS;
modelStruct.d_modelPar_LUCS_dX=0.0;
modelStruct.modelPar_given_LUCS=mod.given("LUCS");
modelStruct.modelPar_WUCS=mod.WUCS;
modelStruct.d_modelPar_WUCS_dX=0.0;
modelStruct.modelPar_given_WUCS=mod.given("WUCS");
modelStruct.modelPar_PUCS=mod.PUCS;
modelStruct.d_modelPar_PUCS_dX=0.0;
modelStruct.modelPar_given_PUCS=mod.given("PUCS");
modelStruct.modelPar_UCSR=mod.UCSR;
modelStruct.d_modelPar_UCSR_dX=0.0;
modelStruct.modelPar_given_UCSR=mod.given("UCSR");
modelStruct.modelPar_LUCSR=mod.LUCSR;
modelStruct.d_modelPar_LUCSR_dX=0.0;
modelStruct.modelPar_given_LUCSR=mod.given("LUCSR");
modelStruct.modelPar_WUCSR=mod.WUCSR;
modelStruct.d_modelPar_WUCSR_dX=0.0;
modelStruct.modelPar_given_WUCSR=mod.given("WUCSR");
modelStruct.modelPar_PUCSR=mod.PUCSR;
modelStruct.d_modelPar_PUCSR_dX=0.0;
modelStruct.modelPar_given_PUCSR=mod.given("PUCSR");
modelStruct.modelPar_UC=mod.UC;
modelStruct.d_modelPar_UC_dX=0.0;
modelStruct.modelPar_given_UC=mod.given("UC");
modelStruct.modelPar_UCL=mod.UCL;
modelStruct.d_modelPar_UCL_dX=0.0;
modelStruct.modelPar_given_UCL=mod.given("UCL");
modelStruct.modelPar_UCLEXP=mod.UCLEXP;
modelStruct.d_modelPar_UCLEXP_dX=0.0;
modelStruct.modelPar_given_UCLEXP=mod.given("UCLEXP");
modelStruct.modelPar_UCW=mod.UCW;
modelStruct.d_modelPar_UCW_dX=0.0;
modelStruct.modelPar_given_UCW=mod.given("UCW");
modelStruct.modelPar_UCWEXP=mod.UCWEXP;
modelStruct.d_modelPar_UCWEXP_dX=0.0;
modelStruct.modelPar_given_UCWEXP=mod.given("UCWEXP");
modelStruct.modelPar_UCWL=mod.UCWL;
modelStruct.d_modelPar_UCWL_dX=0.0;
modelStruct.modelPar_given_UCWL=mod.given("UCWL");
modelStruct.modelPar_UCWLEXP=mod.UCWLEXP;
modelStruct.d_modelPar_UCWLEXP_dX=0.0;
modelStruct.modelPar_given_UCWLEXP=mod.given("UCWLEXP");
modelStruct.modelPar_LUC=mod.LUC;
modelStruct.d_modelPar_LUC_dX=0.0;
modelStruct.modelPar_given_LUC=mod.given("LUC");
modelStruct.modelPar_WUC=mod.WUC;
modelStruct.d_modelPar_WUC_dX=0.0;
modelStruct.modelPar_given_WUC=mod.given("WUC");
modelStruct.modelPar_PUC=mod.PUC;
modelStruct.d_modelPar_PUC_dX=0.0;
modelStruct.modelPar_given_PUC=mod.given("PUC");
modelStruct.modelPar_UCR=mod.UCR;
modelStruct.d_modelPar_UCR_dX=0.0;
modelStruct.modelPar_given_UCR=mod.given("UCR");
modelStruct.modelPar_LUCR=mod.LUCR;
modelStruct.d_modelPar_LUCR_dX=0.0;
modelStruct.modelPar_given_LUCR=mod.given("LUCR");
modelStruct.modelPar_WUCR=mod.WUCR;
modelStruct.d_modelPar_WUCR_dX=0.0;
modelStruct.modelPar_given_WUCR=mod.given("WUCR");
modelStruct.modelPar_PUCR=mod.PUCR;
modelStruct.d_modelPar_PUCR_dX=0.0;
modelStruct.modelPar_given_PUCR=mod.given("PUCR");
modelStruct.modelPar_PCLM=mod.PCLM;
modelStruct.d_modelPar_PCLM_dX=0.0;
modelStruct.modelPar_given_PCLM=mod.given("PCLM");
modelStruct.modelPar_PCLML=mod.PCLML;
modelStruct.d_modelPar_PCLML_dX=0.0;
modelStruct.modelPar_given_PCLML=mod.given("PCLML");
modelStruct.modelPar_PCLMLEXP=mod.PCLMLEXP;
modelStruct.d_modelPar_PCLMLEXP_dX=0.0;
modelStruct.modelPar_given_PCLMLEXP=mod.given("PCLMLEXP");
modelStruct.modelPar_LPCLM=mod.LPCLM;
modelStruct.d_modelPar_LPCLM_dX=0.0;
modelStruct.modelPar_given_LPCLM=mod.given("LPCLM");
modelStruct.modelPar_WPCLM=mod.WPCLM;
modelStruct.d_modelPar_WPCLM_dX=0.0;
modelStruct.modelPar_given_WPCLM=mod.given("WPCLM");
modelStruct.modelPar_PPCLM=mod.PPCLM;
modelStruct.d_modelPar_PPCLM_dX=0.0;
modelStruct.modelPar_given_PPCLM=mod.given("PPCLM");
modelStruct.modelPar_PCLMR=mod.PCLMR;
modelStruct.d_modelPar_PCLMR_dX=0.0;
modelStruct.modelPar_given_PCLMR=mod.given("PCLMR");
modelStruct.modelPar_LPCLMR=mod.LPCLMR;
modelStruct.d_modelPar_LPCLMR_dX=0.0;
modelStruct.modelPar_given_LPCLMR=mod.given("LPCLMR");
modelStruct.modelPar_WPCLMR=mod.WPCLMR;
modelStruct.d_modelPar_WPCLMR_dX=0.0;
modelStruct.modelPar_given_WPCLMR=mod.given("WPCLMR");
modelStruct.modelPar_PPCLMR=mod.PPCLMR;
modelStruct.d_modelPar_PPCLMR_dX=0.0;
modelStruct.modelPar_given_PPCLMR=mod.given("PPCLMR");
modelStruct.modelPar_PCLMG=mod.PCLMG;
modelStruct.d_modelPar_PCLMG_dX=0.0;
modelStruct.modelPar_given_PCLMG=mod.given("PCLMG");
modelStruct.modelPar_PCLMCV=mod.PCLMCV;
modelStruct.d_modelPar_PCLMCV_dX=0.0;
modelStruct.modelPar_given_PCLMCV=mod.given("PCLMCV");
modelStruct.modelPar_PCLMCVL=mod.PCLMCVL;
modelStruct.d_modelPar_PCLMCVL_dX=0.0;
modelStruct.modelPar_given_PCLMCVL=mod.given("PCLMCVL");
modelStruct.modelPar_PCLMCVLEXP=mod.PCLMCVLEXP;
modelStruct.d_modelPar_PCLMCVLEXP_dX=0.0;
modelStruct.modelPar_given_PCLMCVLEXP=mod.given("PCLMCVLEXP");
modelStruct.modelPar_LPCLMCV=mod.LPCLMCV;
modelStruct.d_modelPar_LPCLMCV_dX=0.0;
modelStruct.modelPar_given_LPCLMCV=mod.given("LPCLMCV");
modelStruct.modelPar_WPCLMCV=mod.WPCLMCV;
modelStruct.d_modelPar_WPCLMCV_dX=0.0;
modelStruct.modelPar_given_WPCLMCV=mod.given("WPCLMCV");
modelStruct.modelPar_PPCLMCV=mod.PPCLMCV;
modelStruct.d_modelPar_PPCLMCV_dX=0.0;
modelStruct.modelPar_given_PPCLMCV=mod.given("PPCLMCV");
modelStruct.modelPar_PSCBE1=mod.PSCBE1;
modelStruct.d_modelPar_PSCBE1_dX=0.0;
modelStruct.modelPar_given_PSCBE1=mod.given("PSCBE1");
modelStruct.modelPar_LPSCBE1=mod.LPSCBE1;
modelStruct.d_modelPar_LPSCBE1_dX=0.0;
modelStruct.modelPar_given_LPSCBE1=mod.given("LPSCBE1");
modelStruct.modelPar_WPSCBE1=mod.WPSCBE1;
modelStruct.d_modelPar_WPSCBE1_dX=0.0;
modelStruct.modelPar_given_WPSCBE1=mod.given("WPSCBE1");
modelStruct.modelPar_PPSCBE1=mod.PPSCBE1;
modelStruct.d_modelPar_PPSCBE1_dX=0.0;
modelStruct.modelPar_given_PPSCBE1=mod.given("PPSCBE1");
modelStruct.modelPar_PSCBE2=mod.PSCBE2;
modelStruct.d_modelPar_PSCBE2_dX=0.0;
modelStruct.modelPar_given_PSCBE2=mod.given("PSCBE2");
modelStruct.modelPar_LPSCBE2=mod.LPSCBE2;
modelStruct.d_modelPar_LPSCBE2_dX=0.0;
modelStruct.modelPar_given_LPSCBE2=mod.given("LPSCBE2");
modelStruct.modelPar_WPSCBE2=mod.WPSCBE2;
modelStruct.d_modelPar_WPSCBE2_dX=0.0;
modelStruct.modelPar_given_WPSCBE2=mod.given("WPSCBE2");
modelStruct.modelPar_PPSCBE2=mod.PPSCBE2;
modelStruct.d_modelPar_PPSCBE2_dX=0.0;
modelStruct.modelPar_given_PPSCBE2=mod.given("PPSCBE2");
modelStruct.modelPar_PDITS=mod.PDITS;
modelStruct.d_modelPar_PDITS_dX=0.0;
modelStruct.modelPar_given_PDITS=mod.given("PDITS");
modelStruct.modelPar_LPDITS=mod.LPDITS;
modelStruct.d_modelPar_LPDITS_dX=0.0;
modelStruct.modelPar_given_LPDITS=mod.given("LPDITS");
modelStruct.modelPar_WPDITS=mod.WPDITS;
modelStruct.d_modelPar_WPDITS_dX=0.0;
modelStruct.modelPar_given_WPDITS=mod.given("WPDITS");
modelStruct.modelPar_PPDITS=mod.PPDITS;
modelStruct.d_modelPar_PPDITS_dX=0.0;
modelStruct.modelPar_given_PPDITS=mod.given("PPDITS");
modelStruct.modelPar_PDITSL=mod.PDITSL;
modelStruct.d_modelPar_PDITSL_dX=0.0;
modelStruct.modelPar_given_PDITSL=mod.given("PDITSL");
modelStruct.modelPar_PDITSD=mod.PDITSD;
modelStruct.d_modelPar_PDITSD_dX=0.0;
modelStruct.modelPar_given_PDITSD=mod.given("PDITSD");
modelStruct.modelPar_LPDITSD=mod.LPDITSD;
modelStruct.d_modelPar_LPDITSD_dX=0.0;
modelStruct.modelPar_given_LPDITSD=mod.given("LPDITSD");
modelStruct.modelPar_WPDITSD=mod.WPDITSD;
modelStruct.d_modelPar_WPDITSD_dX=0.0;
modelStruct.modelPar_given_WPDITSD=mod.given("WPDITSD");
modelStruct.modelPar_PPDITSD=mod.PPDITSD;
modelStruct.d_modelPar_PPDITSD_dX=0.0;
modelStruct.modelPar_given_PPDITSD=mod.given("PPDITSD");
modelStruct.modelPar_RSH=mod.RSH;
modelStruct.d_modelPar_RSH_dX=0.0;
modelStruct.modelPar_given_RSH=mod.given("RSH");
modelStruct.modelPar_PRWG=mod.PRWG;
modelStruct.d_modelPar_PRWG_dX=0.0;
modelStruct.modelPar_given_PRWG=mod.given("PRWG");
modelStruct.modelPar_LPRWG=mod.LPRWG;
modelStruct.d_modelPar_LPRWG_dX=0.0;
modelStruct.modelPar_given_LPRWG=mod.given("LPRWG");
modelStruct.modelPar_WPRWG=mod.WPRWG;
modelStruct.d_modelPar_WPRWG_dX=0.0;
modelStruct.modelPar_given_WPRWG=mod.given("WPRWG");
modelStruct.modelPar_PPRWG=mod.PPRWG;
modelStruct.d_modelPar_PPRWG_dX=0.0;
modelStruct.modelPar_given_PPRWG=mod.given("PPRWG");
modelStruct.modelPar_PRWB=mod.PRWB;
modelStruct.d_modelPar_PRWB_dX=0.0;
modelStruct.modelPar_given_PRWB=mod.given("PRWB");
modelStruct.modelPar_LPRWB=mod.LPRWB;
modelStruct.d_modelPar_LPRWB_dX=0.0;
modelStruct.modelPar_given_LPRWB=mod.given("LPRWB");
modelStruct.modelPar_WPRWB=mod.WPRWB;
modelStruct.d_modelPar_WPRWB_dX=0.0;
modelStruct.modelPar_given_WPRWB=mod.given("WPRWB");
modelStruct.modelPar_PPRWB=mod.PPRWB;
modelStruct.d_modelPar_PPRWB_dX=0.0;
modelStruct.modelPar_given_PPRWB=mod.given("PPRWB");
modelStruct.modelPar_PRWBL=mod.PRWBL;
modelStruct.d_modelPar_PRWBL_dX=0.0;
modelStruct.modelPar_given_PRWBL=mod.given("PRWBL");
modelStruct.modelPar_PRWBLEXP=mod.PRWBLEXP;
modelStruct.d_modelPar_PRWBLEXP_dX=0.0;
modelStruct.modelPar_given_PRWBLEXP=mod.given("PRWBLEXP");
modelStruct.modelPar_WR=mod.WR;
modelStruct.d_modelPar_WR_dX=0.0;
modelStruct.modelPar_given_WR=mod.given("WR");
modelStruct.modelPar_LWR=mod.LWR;
modelStruct.d_modelPar_LWR_dX=0.0;
modelStruct.modelPar_given_LWR=mod.given("LWR");
modelStruct.modelPar_WWR=mod.WWR;
modelStruct.d_modelPar_WWR_dX=0.0;
modelStruct.modelPar_given_WWR=mod.given("WWR");
modelStruct.modelPar_PWR=mod.PWR;
modelStruct.d_modelPar_PWR_dX=0.0;
modelStruct.modelPar_given_PWR=mod.given("PWR");
modelStruct.modelPar_RSWMIN=mod.RSWMIN;
modelStruct.d_modelPar_RSWMIN_dX=0.0;
modelStruct.modelPar_given_RSWMIN=mod.given("RSWMIN");
modelStruct.modelPar_LRSWMIN=mod.LRSWMIN;
modelStruct.d_modelPar_LRSWMIN_dX=0.0;
modelStruct.modelPar_given_LRSWMIN=mod.given("LRSWMIN");
modelStruct.modelPar_WRSWMIN=mod.WRSWMIN;
modelStruct.d_modelPar_WRSWMIN_dX=0.0;
modelStruct.modelPar_given_WRSWMIN=mod.given("WRSWMIN");
modelStruct.modelPar_PRSWMIN=mod.PRSWMIN;
modelStruct.d_modelPar_PRSWMIN_dX=0.0;
modelStruct.modelPar_given_PRSWMIN=mod.given("PRSWMIN");
modelStruct.modelPar_RSW=mod.RSW;
modelStruct.d_modelPar_RSW_dX=0.0;
modelStruct.modelPar_given_RSW=mod.given("RSW");
modelStruct.modelPar_LRSW=mod.LRSW;
modelStruct.d_modelPar_LRSW_dX=0.0;
modelStruct.modelPar_given_LRSW=mod.given("LRSW");
modelStruct.modelPar_WRSW=mod.WRSW;
modelStruct.d_modelPar_WRSW_dX=0.0;
modelStruct.modelPar_given_WRSW=mod.given("WRSW");
modelStruct.modelPar_PRSW=mod.PRSW;
modelStruct.d_modelPar_PRSW_dX=0.0;
modelStruct.modelPar_given_PRSW=mod.given("PRSW");
modelStruct.modelPar_RSWL=mod.RSWL;
modelStruct.d_modelPar_RSWL_dX=0.0;
modelStruct.modelPar_given_RSWL=mod.given("RSWL");
modelStruct.modelPar_RSWLEXP=mod.RSWLEXP;
modelStruct.d_modelPar_RSWLEXP_dX=0.0;
modelStruct.modelPar_given_RSWLEXP=mod.given("RSWLEXP");
modelStruct.modelPar_RDWMIN=mod.RDWMIN;
modelStruct.d_modelPar_RDWMIN_dX=0.0;
modelStruct.modelPar_given_RDWMIN=mod.given("RDWMIN");
modelStruct.modelPar_LRDWMIN=mod.LRDWMIN;
modelStruct.d_modelPar_LRDWMIN_dX=0.0;
modelStruct.modelPar_given_LRDWMIN=mod.given("LRDWMIN");
modelStruct.modelPar_WRDWMIN=mod.WRDWMIN;
modelStruct.d_modelPar_WRDWMIN_dX=0.0;
modelStruct.modelPar_given_WRDWMIN=mod.given("WRDWMIN");
modelStruct.modelPar_PRDWMIN=mod.PRDWMIN;
modelStruct.d_modelPar_PRDWMIN_dX=0.0;
modelStruct.modelPar_given_PRDWMIN=mod.given("PRDWMIN");
modelStruct.modelPar_RDW=mod.RDW;
modelStruct.d_modelPar_RDW_dX=0.0;
modelStruct.modelPar_given_RDW=mod.given("RDW");
modelStruct.modelPar_LRDW=mod.LRDW;
modelStruct.d_modelPar_LRDW_dX=0.0;
modelStruct.modelPar_given_LRDW=mod.given("LRDW");
modelStruct.modelPar_WRDW=mod.WRDW;
modelStruct.d_modelPar_WRDW_dX=0.0;
modelStruct.modelPar_given_WRDW=mod.given("WRDW");
modelStruct.modelPar_PRDW=mod.PRDW;
modelStruct.d_modelPar_PRDW_dX=0.0;
modelStruct.modelPar_given_PRDW=mod.given("PRDW");
modelStruct.modelPar_RDWL=mod.RDWL;
modelStruct.d_modelPar_RDWL_dX=0.0;
modelStruct.modelPar_given_RDWL=mod.given("RDWL");
modelStruct.modelPar_RDWLEXP=mod.RDWLEXP;
modelStruct.d_modelPar_RDWLEXP_dX=0.0;
modelStruct.modelPar_given_RDWLEXP=mod.given("RDWLEXP");
modelStruct.modelPar_RDSWMIN=mod.RDSWMIN;
modelStruct.d_modelPar_RDSWMIN_dX=0.0;
modelStruct.modelPar_given_RDSWMIN=mod.given("RDSWMIN");
modelStruct.modelPar_LRDSWMIN=mod.LRDSWMIN;
modelStruct.d_modelPar_LRDSWMIN_dX=0.0;
modelStruct.modelPar_given_LRDSWMIN=mod.given("LRDSWMIN");
modelStruct.modelPar_WRDSWMIN=mod.WRDSWMIN;
modelStruct.d_modelPar_WRDSWMIN_dX=0.0;
modelStruct.modelPar_given_WRDSWMIN=mod.given("WRDSWMIN");
modelStruct.modelPar_PRDSWMIN=mod.PRDSWMIN;
modelStruct.d_modelPar_PRDSWMIN_dX=0.0;
modelStruct.modelPar_given_PRDSWMIN=mod.given("PRDSWMIN");
modelStruct.modelPar_RDSW=mod.RDSW;
modelStruct.d_modelPar_RDSW_dX=0.0;
modelStruct.modelPar_given_RDSW=mod.given("RDSW");
modelStruct.modelPar_RDSWL=mod.RDSWL;
modelStruct.d_modelPar_RDSWL_dX=0.0;
modelStruct.modelPar_given_RDSWL=mod.given("RDSWL");
modelStruct.modelPar_RDSWLEXP=mod.RDSWLEXP;
modelStruct.d_modelPar_RDSWLEXP_dX=0.0;
modelStruct.modelPar_given_RDSWLEXP=mod.given("RDSWLEXP");
modelStruct.modelPar_LRDSW=mod.LRDSW;
modelStruct.d_modelPar_LRDSW_dX=0.0;
modelStruct.modelPar_given_LRDSW=mod.given("LRDSW");
modelStruct.modelPar_WRDSW=mod.WRDSW;
modelStruct.d_modelPar_WRDSW_dX=0.0;
modelStruct.modelPar_given_WRDSW=mod.given("WRDSW");
modelStruct.modelPar_PRDSW=mod.PRDSW;
modelStruct.d_modelPar_PRDSW_dX=0.0;
modelStruct.modelPar_given_PRDSW=mod.given("PRDSW");
modelStruct.modelPar_PSAT=mod.PSAT;
modelStruct.d_modelPar_PSAT_dX=0.0;
modelStruct.modelPar_given_PSAT=mod.given("PSAT");
modelStruct.modelPar_LPSAT=mod.LPSAT;
modelStruct.d_modelPar_LPSAT_dX=0.0;
modelStruct.modelPar_given_LPSAT=mod.given("LPSAT");
modelStruct.modelPar_WPSAT=mod.WPSAT;
modelStruct.d_modelPar_WPSAT_dX=0.0;
modelStruct.modelPar_given_WPSAT=mod.given("WPSAT");
modelStruct.modelPar_PPSAT=mod.PPSAT;
modelStruct.d_modelPar_PPSAT_dX=0.0;
modelStruct.modelPar_given_PPSAT=mod.given("PPSAT");
modelStruct.modelPar_PSATL=mod.PSATL;
modelStruct.d_modelPar_PSATL_dX=0.0;
modelStruct.modelPar_given_PSATL=mod.given("PSATL");
modelStruct.modelPar_PSATLEXP=mod.PSATLEXP;
modelStruct.d_modelPar_PSATLEXP_dX=0.0;
modelStruct.modelPar_given_PSATLEXP=mod.given("PSATLEXP");
modelStruct.modelPar_PSATB=mod.PSATB;
modelStruct.d_modelPar_PSATB_dX=0.0;
modelStruct.modelPar_given_PSATB=mod.given("PSATB");
modelStruct.modelPar_PSATR=mod.PSATR;
modelStruct.d_modelPar_PSATR_dX=0.0;
modelStruct.modelPar_given_PSATR=mod.given("PSATR");
modelStruct.modelPar_LPSATR=mod.LPSATR;
modelStruct.d_modelPar_LPSATR_dX=0.0;
modelStruct.modelPar_given_LPSATR=mod.given("LPSATR");
modelStruct.modelPar_WPSATR=mod.WPSATR;
modelStruct.d_modelPar_WPSATR_dX=0.0;
modelStruct.modelPar_given_WPSATR=mod.given("WPSATR");
modelStruct.modelPar_PPSATR=mod.PPSATR;
modelStruct.d_modelPar_PPSATR_dX=0.0;
modelStruct.modelPar_given_PPSATR=mod.given("PPSATR");
modelStruct.modelPar_LPSATB=mod.LPSATB;
modelStruct.d_modelPar_LPSATB_dX=0.0;
modelStruct.modelPar_given_LPSATB=mod.given("LPSATB");
modelStruct.modelPar_WPSATB=mod.WPSATB;
modelStruct.d_modelPar_WPSATB_dX=0.0;
modelStruct.modelPar_given_WPSATB=mod.given("WPSATB");
modelStruct.modelPar_PPSATB=mod.PPSATB;
modelStruct.d_modelPar_PPSATB_dX=0.0;
modelStruct.modelPar_given_PPSATB=mod.given("PPSATB");
modelStruct.modelPar_PSATX=mod.PSATX;
modelStruct.d_modelPar_PSATX_dX=0.0;
modelStruct.modelPar_given_PSATX=mod.given("PSATX");
modelStruct.modelPar_PTWG=mod.PTWG;
modelStruct.d_modelPar_PTWG_dX=0.0;
modelStruct.modelPar_given_PTWG=mod.given("PTWG");
modelStruct.modelPar_LPTWG=mod.LPTWG;
modelStruct.d_modelPar_LPTWG_dX=0.0;
modelStruct.modelPar_given_LPTWG=mod.given("LPTWG");
modelStruct.modelPar_WPTWG=mod.WPTWG;
modelStruct.d_modelPar_WPTWG_dX=0.0;
modelStruct.modelPar_given_WPTWG=mod.given("WPTWG");
modelStruct.modelPar_PPTWG=mod.PPTWG;
modelStruct.d_modelPar_PPTWG_dX=0.0;
modelStruct.modelPar_given_PPTWG=mod.given("PPTWG");
modelStruct.modelPar_PTWGL=mod.PTWGL;
modelStruct.d_modelPar_PTWGL_dX=0.0;
modelStruct.modelPar_given_PTWGL=mod.given("PTWGL");
modelStruct.modelPar_PTWGLEXP=mod.PTWGLEXP;
modelStruct.d_modelPar_PTWGLEXP_dX=0.0;
modelStruct.modelPar_given_PTWGLEXP=mod.given("PTWGLEXP");
modelStruct.modelPar_PTWGR=mod.PTWGR;
modelStruct.d_modelPar_PTWGR_dX=0.0;
modelStruct.modelPar_given_PTWGR=mod.given("PTWGR");
modelStruct.modelPar_LPTWGR=mod.LPTWGR;
modelStruct.d_modelPar_LPTWGR_dX=0.0;
modelStruct.modelPar_given_LPTWGR=mod.given("LPTWGR");
modelStruct.modelPar_WPTWGR=mod.WPTWGR;
modelStruct.d_modelPar_WPTWGR_dX=0.0;
modelStruct.modelPar_given_WPTWGR=mod.given("WPTWGR");
modelStruct.modelPar_PPTWGR=mod.PPTWGR;
modelStruct.d_modelPar_PPTWGR_dX=0.0;
modelStruct.modelPar_given_PPTWGR=mod.given("PPTWGR");
modelStruct.modelPar_PTWGLR=mod.PTWGLR;
modelStruct.d_modelPar_PTWGLR_dX=0.0;
modelStruct.modelPar_given_PTWGLR=mod.given("PTWGLR");
modelStruct.modelPar_PTWGLEXPR=mod.PTWGLEXPR;
modelStruct.d_modelPar_PTWGLEXPR_dX=0.0;
modelStruct.modelPar_given_PTWGLEXPR=mod.given("PTWGLEXPR");
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modelStruct.modelPar_LA1=mod.LA1;
modelStruct.d_modelPar_LA1_dX=0.0;
modelStruct.modelPar_given_LA1=mod.given("LA1");
modelStruct.modelPar_WA1=mod.WA1;
modelStruct.d_modelPar_WA1_dX=0.0;
modelStruct.modelPar_given_WA1=mod.given("WA1");
modelStruct.modelPar_PA1=mod.PA1;
modelStruct.d_modelPar_PA1_dX=0.0;
modelStruct.modelPar_given_PA1=mod.given("PA1");
modelStruct.modelPar_A11=mod.A11;
modelStruct.d_modelPar_A11_dX=0.0;
modelStruct.modelPar_given_A11=mod.given("A11");
modelStruct.modelPar_LA11=mod.LA11;
modelStruct.d_modelPar_LA11_dX=0.0;
modelStruct.modelPar_given_LA11=mod.given("LA11");
modelStruct.modelPar_WA11=mod.WA11;
modelStruct.d_modelPar_WA11_dX=0.0;
modelStruct.modelPar_given_WA11=mod.given("WA11");
modelStruct.modelPar_PA11=mod.PA11;
modelStruct.d_modelPar_PA11_dX=0.0;
modelStruct.modelPar_given_PA11=mod.given("PA11");
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modelStruct.modelPar_LA2=mod.LA2;
modelStruct.d_modelPar_LA2_dX=0.0;
modelStruct.modelPar_given_LA2=mod.given("LA2");
modelStruct.modelPar_WA2=mod.WA2;
modelStruct.d_modelPar_WA2_dX=0.0;
modelStruct.modelPar_given_WA2=mod.given("WA2");
modelStruct.modelPar_PA2=mod.PA2;
modelStruct.d_modelPar_PA2_dX=0.0;
modelStruct.modelPar_given_PA2=mod.given("PA2");
modelStruct.modelPar_A21=mod.A21;
modelStruct.d_modelPar_A21_dX=0.0;
modelStruct.modelPar_given_A21=mod.given("A21");
modelStruct.modelPar_LA21=mod.LA21;
modelStruct.d_modelPar_LA21_dX=0.0;
modelStruct.modelPar_given_LA21=mod.given("LA21");
modelStruct.modelPar_WA21=mod.WA21;
modelStruct.d_modelPar_WA21_dX=0.0;
modelStruct.modelPar_given_WA21=mod.given("WA21");
modelStruct.modelPar_PA21=mod.PA21;
modelStruct.d_modelPar_PA21_dX=0.0;
modelStruct.modelPar_given_PA21=mod.given("PA21");
modelStruct.modelPar_PDIBLC=mod.PDIBLC;
modelStruct.d_modelPar_PDIBLC_dX=0.0;
modelStruct.modelPar_given_PDIBLC=mod.given("PDIBLC");
modelStruct.modelPar_PDIBLCL=mod.PDIBLCL;
modelStruct.d_modelPar_PDIBLCL_dX=0.0;
modelStruct.modelPar_given_PDIBLCL=mod.given("PDIBLCL");
modelStruct.modelPar_PDIBLCLEXP=mod.PDIBLCLEXP;
modelStruct.d_modelPar_PDIBLCLEXP_dX=0.0;
modelStruct.modelPar_given_PDIBLCLEXP=mod.given("PDIBLCLEXP");
modelStruct.modelPar_LPDIBLC=mod.LPDIBLC;
modelStruct.d_modelPar_LPDIBLC_dX=0.0;
modelStruct.modelPar_given_LPDIBLC=mod.given("LPDIBLC");
modelStruct.modelPar_WPDIBLC=mod.WPDIBLC;
modelStruct.d_modelPar_WPDIBLC_dX=0.0;
modelStruct.modelPar_given_WPDIBLC=mod.given("WPDIBLC");
modelStruct.modelPar_PPDIBLC=mod.PPDIBLC;
modelStruct.d_modelPar_PPDIBLC_dX=0.0;
modelStruct.modelPar_given_PPDIBLC=mod.given("PPDIBLC");
modelStruct.modelPar_PDIBLCR=mod.PDIBLCR;
modelStruct.d_modelPar_PDIBLCR_dX=0.0;
modelStruct.modelPar_given_PDIBLCR=mod.given("PDIBLCR");
modelStruct.modelPar_PDIBLCLR=mod.PDIBLCLR;
modelStruct.d_modelPar_PDIBLCLR_dX=0.0;
modelStruct.modelPar_given_PDIBLCLR=mod.given("PDIBLCLR");
modelStruct.modelPar_PDIBLCLEXPR=mod.PDIBLCLEXPR;
modelStruct.d_modelPar_PDIBLCLEXPR_dX=0.0;
modelStruct.modelPar_given_PDIBLCLEXPR=mod.given("PDIBLCLEXPR");
modelStruct.modelPar_LPDIBLCR=mod.LPDIBLCR;
modelStruct.d_modelPar_LPDIBLCR_dX=0.0;
modelStruct.modelPar_given_LPDIBLCR=mod.given("LPDIBLCR");
modelStruct.modelPar_WPDIBLCR=mod.WPDIBLCR;
modelStruct.d_modelPar_WPDIBLCR_dX=0.0;
modelStruct.modelPar_given_WPDIBLCR=mod.given("WPDIBLCR");
modelStruct.modelPar_PPDIBLCR=mod.PPDIBLCR;
modelStruct.d_modelPar_PPDIBLCR_dX=0.0;
modelStruct.modelPar_given_PPDIBLCR=mod.given("PPDIBLCR");
modelStruct.modelPar_PDIBLCB=mod.PDIBLCB;
modelStruct.d_modelPar_PDIBLCB_dX=0.0;
modelStruct.modelPar_given_PDIBLCB=mod.given("PDIBLCB");
modelStruct.modelPar_LPDIBLCB=mod.LPDIBLCB;
modelStruct.d_modelPar_LPDIBLCB_dX=0.0;
modelStruct.modelPar_given_LPDIBLCB=mod.given("LPDIBLCB");
modelStruct.modelPar_WPDIBLCB=mod.WPDIBLCB;
modelStruct.d_modelPar_WPDIBLCB_dX=0.0;
modelStruct.modelPar_given_WPDIBLCB=mod.given("WPDIBLCB");
modelStruct.modelPar_PPDIBLCB=mod.PPDIBLCB;
modelStruct.d_modelPar_PPDIBLCB_dX=0.0;
modelStruct.modelPar_given_PPDIBLCB=mod.given("PPDIBLCB");
modelStruct.modelPar_PVAG=mod.PVAG;
modelStruct.d_modelPar_PVAG_dX=0.0;
modelStruct.modelPar_given_PVAG=mod.given("PVAG");
modelStruct.modelPar_LPVAG=mod.LPVAG;
modelStruct.d_modelPar_LPVAG_dX=0.0;
modelStruct.modelPar_given_LPVAG=mod.given("LPVAG");
modelStruct.modelPar_WPVAG=mod.WPVAG;
modelStruct.d_modelPar_WPVAG_dX=0.0;
modelStruct.modelPar_given_WPVAG=mod.given("WPVAG");
modelStruct.modelPar_PPVAG=mod.PPVAG;
modelStruct.d_modelPar_PPVAG_dX=0.0;
modelStruct.modelPar_given_PPVAG=mod.given("PPVAG");
modelStruct.modelPar_FPROUT=mod.FPROUT;
modelStruct.d_modelPar_FPROUT_dX=0.0;
modelStruct.modelPar_given_FPROUT=mod.given("FPROUT");
modelStruct.modelPar_FPROUTL=mod.FPROUTL;
modelStruct.d_modelPar_FPROUTL_dX=0.0;
modelStruct.modelPar_given_FPROUTL=mod.given("FPROUTL");
modelStruct.modelPar_FPROUTLEXP=mod.FPROUTLEXP;
modelStruct.d_modelPar_FPROUTLEXP_dX=0.0;
modelStruct.modelPar_given_FPROUTLEXP=mod.given("FPROUTLEXP");
modelStruct.modelPar_LFPROUT=mod.LFPROUT;
modelStruct.d_modelPar_LFPROUT_dX=0.0;
modelStruct.modelPar_given_LFPROUT=mod.given("LFPROUT");
modelStruct.modelPar_WFPROUT=mod.WFPROUT;
modelStruct.d_modelPar_WFPROUT_dX=0.0;
modelStruct.modelPar_given_WFPROUT=mod.given("WFPROUT");
modelStruct.modelPar_PFPROUT=mod.PFPROUT;
modelStruct.d_modelPar_PFPROUT_dX=0.0;
modelStruct.modelPar_given_PFPROUT=mod.given("PFPROUT");
modelStruct.modelPar_ALPHA0=mod.ALPHA0;
modelStruct.d_modelPar_ALPHA0_dX=0.0;
modelStruct.modelPar_given_ALPHA0=mod.given("ALPHA0");
modelStruct.modelPar_ALPHA0L=mod.ALPHA0L;
modelStruct.d_modelPar_ALPHA0L_dX=0.0;
modelStruct.modelPar_given_ALPHA0L=mod.given("ALPHA0L");
modelStruct.modelPar_ALPHA0LEXP=mod.ALPHA0LEXP;
modelStruct.d_modelPar_ALPHA0LEXP_dX=0.0;
modelStruct.modelPar_given_ALPHA0LEXP=mod.given("ALPHA0LEXP");
modelStruct.modelPar_LALPHA0=mod.LALPHA0;
modelStruct.d_modelPar_LALPHA0_dX=0.0;
modelStruct.modelPar_given_LALPHA0=mod.given("LALPHA0");
modelStruct.modelPar_WALPHA0=mod.WALPHA0;
modelStruct.d_modelPar_WALPHA0_dX=0.0;
modelStruct.modelPar_given_WALPHA0=mod.given("WALPHA0");
modelStruct.modelPar_PALPHA0=mod.PALPHA0;
modelStruct.d_modelPar_PALPHA0_dX=0.0;
modelStruct.modelPar_given_PALPHA0=mod.given("PALPHA0");
modelStruct.modelPar_BETA0=mod.BETA0;
modelStruct.d_modelPar_BETA0_dX=0.0;
modelStruct.modelPar_given_BETA0=mod.given("BETA0");
modelStruct.modelPar_LBETA0=mod.LBETA0;
modelStruct.d_modelPar_LBETA0_dX=0.0;
modelStruct.modelPar_given_LBETA0=mod.given("LBETA0");
modelStruct.modelPar_WBETA0=mod.WBETA0;
modelStruct.d_modelPar_WBETA0_dX=0.0;
modelStruct.modelPar_given_WBETA0=mod.given("WBETA0");
modelStruct.modelPar_PBETA0=mod.PBETA0;
modelStruct.d_modelPar_PBETA0_dX=0.0;
modelStruct.modelPar_given_PBETA0=mod.given("PBETA0");
modelStruct.modelPar_AIGBACC=mod.AIGBACC;
modelStruct.d_modelPar_AIGBACC_dX=0.0;
modelStruct.modelPar_given_AIGBACC=mod.given("AIGBACC");
modelStruct.modelPar_BIGBACC=mod.BIGBACC;
modelStruct.d_modelPar_BIGBACC_dX=0.0;
modelStruct.modelPar_given_BIGBACC=mod.given("BIGBACC");
modelStruct.modelPar_CIGBACC=mod.CIGBACC;
modelStruct.d_modelPar_CIGBACC_dX=0.0;
modelStruct.modelPar_given_CIGBACC=mod.given("CIGBACC");
modelStruct.modelPar_NIGBACC=mod.NIGBACC;
modelStruct.d_modelPar_NIGBACC_dX=0.0;
modelStruct.modelPar_given_NIGBACC=mod.given("NIGBACC");
modelStruct.modelPar_AIGBINV=mod.AIGBINV;
modelStruct.d_modelPar_AIGBINV_dX=0.0;
modelStruct.modelPar_given_AIGBINV=mod.given("AIGBINV");
modelStruct.modelPar_BIGBINV=mod.BIGBINV;
modelStruct.d_modelPar_BIGBINV_dX=0.0;
modelStruct.modelPar_given_BIGBINV=mod.given("BIGBINV");
modelStruct.modelPar_CIGBINV=mod.CIGBINV;
modelStruct.d_modelPar_CIGBINV_dX=0.0;
modelStruct.modelPar_given_CIGBINV=mod.given("CIGBINV");
modelStruct.modelPar_EIGBINV=mod.EIGBINV;
modelStruct.d_modelPar_EIGBINV_dX=0.0;
modelStruct.modelPar_given_EIGBINV=mod.given("EIGBINV");
modelStruct.modelPar_NIGBINV=mod.NIGBINV;
modelStruct.d_modelPar_NIGBINV_dX=0.0;
modelStruct.modelPar_given_NIGBINV=mod.given("NIGBINV");
modelStruct.modelPar_AIGC=mod.AIGC;
modelStruct.d_modelPar_AIGC_dX=0.0;
modelStruct.modelPar_given_AIGC=mod.given("AIGC");
modelStruct.modelPar_BIGC=mod.BIGC;
modelStruct.d_modelPar_BIGC_dX=0.0;
modelStruct.modelPar_given_BIGC=mod.given("BIGC");
modelStruct.modelPar_CIGC=mod.CIGC;
modelStruct.d_modelPar_CIGC_dX=0.0;
modelStruct.modelPar_given_CIGC=mod.given("CIGC");
modelStruct.modelPar_AIGS=mod.AIGS;
modelStruct.d_modelPar_AIGS_dX=0.0;
modelStruct.modelPar_given_AIGS=mod.given("AIGS");
modelStruct.modelPar_BIGS=mod.BIGS;
modelStruct.d_modelPar_BIGS_dX=0.0;
modelStruct.modelPar_given_BIGS=mod.given("BIGS");
modelStruct.modelPar_CIGS=mod.CIGS;
modelStruct.d_modelPar_CIGS_dX=0.0;
modelStruct.modelPar_given_CIGS=mod.given("CIGS");
modelStruct.modelPar_AIGD=mod.AIGD;
modelStruct.d_modelPar_AIGD_dX=0.0;
modelStruct.modelPar_given_AIGD=mod.given("AIGD");
modelStruct.modelPar_BIGD=mod.BIGD;
modelStruct.d_modelPar_BIGD_dX=0.0;
modelStruct.modelPar_given_BIGD=mod.given("BIGD");
modelStruct.modelPar_CIGD=mod.CIGD;
modelStruct.d_modelPar_CIGD_dX=0.0;
modelStruct.modelPar_given_CIGD=mod.given("CIGD");
modelStruct.modelPar_DLCIG=mod.DLCIG;
modelStruct.d_modelPar_DLCIG_dX=0.0;
modelStruct.modelPar_given_DLCIG=mod.given("DLCIG");
modelStruct.modelPar_DLCIGD=mod.DLCIGD;
modelStruct.d_modelPar_DLCIGD_dX=0.0;
modelStruct.modelPar_given_DLCIGD=mod.given("DLCIGD");
modelStruct.modelPar_POXEDGE=mod.POXEDGE;
modelStruct.d_modelPar_POXEDGE_dX=0.0;
modelStruct.modelPar_given_POXEDGE=mod.given("POXEDGE");
modelStruct.modelPar_NTOX=mod.NTOX;
modelStruct.d_modelPar_NTOX_dX=0.0;
modelStruct.modelPar_given_NTOX=mod.given("NTOX");
modelStruct.modelPar_TOXREF=mod.TOXREF;
modelStruct.d_modelPar_TOXREF_dX=0.0;
modelStruct.modelPar_given_TOXREF=mod.given("TOXREF");
modelStruct.modelPar_PIGCD=mod.PIGCD;
modelStruct.d_modelPar_PIGCD_dX=0.0;
modelStruct.modelPar_given_PIGCD=mod.given("PIGCD");
modelStruct.modelPar_AIGCL=mod.AIGCL;
modelStruct.d_modelPar_AIGCL_dX=0.0;
modelStruct.modelPar_given_AIGCL=mod.given("AIGCL");
modelStruct.modelPar_AIGCW=mod.AIGCW;
modelStruct.d_modelPar_AIGCW_dX=0.0;
modelStruct.modelPar_given_AIGCW=mod.given("AIGCW");
modelStruct.modelPar_AIGSL=mod.AIGSL;
modelStruct.d_modelPar_AIGSL_dX=0.0;
modelStruct.modelPar_given_AIGSL=mod.given("AIGSL");
modelStruct.modelPar_AIGSW=mod.AIGSW;
modelStruct.d_modelPar_AIGSW_dX=0.0;
modelStruct.modelPar_given_AIGSW=mod.given("AIGSW");
modelStruct.modelPar_AIGDL=mod.AIGDL;
modelStruct.d_modelPar_AIGDL_dX=0.0;
modelStruct.modelPar_given_AIGDL=mod.given("AIGDL");
modelStruct.modelPar_AIGDW=mod.AIGDW;
modelStruct.d_modelPar_AIGDW_dX=0.0;
modelStruct.modelPar_given_AIGDW=mod.given("AIGDW");
modelStruct.modelPar_PIGCDL=mod.PIGCDL;
modelStruct.d_modelPar_PIGCDL_dX=0.0;
modelStruct.modelPar_given_PIGCDL=mod.given("PIGCDL");
modelStruct.modelPar_LAIGBINV=mod.LAIGBINV;
modelStruct.d_modelPar_LAIGBINV_dX=0.0;
modelStruct.modelPar_given_LAIGBINV=mod.given("LAIGBINV");
modelStruct.modelPar_WAIGBINV=mod.WAIGBINV;
modelStruct.d_modelPar_WAIGBINV_dX=0.0;
modelStruct.modelPar_given_WAIGBINV=mod.given("WAIGBINV");
modelStruct.modelPar_PAIGBINV=mod.PAIGBINV;
modelStruct.d_modelPar_PAIGBINV_dX=0.0;
modelStruct.modelPar_given_PAIGBINV=mod.given("PAIGBINV");
modelStruct.modelPar_LBIGBINV=mod.LBIGBINV;
modelStruct.d_modelPar_LBIGBINV_dX=0.0;
modelStruct.modelPar_given_LBIGBINV=mod.given("LBIGBINV");
modelStruct.modelPar_WBIGBINV=mod.WBIGBINV;
modelStruct.d_modelPar_WBIGBINV_dX=0.0;
modelStruct.modelPar_given_WBIGBINV=mod.given("WBIGBINV");
modelStruct.modelPar_PBIGBINV=mod.PBIGBINV;
modelStruct.d_modelPar_PBIGBINV_dX=0.0;
modelStruct.modelPar_given_PBIGBINV=mod.given("PBIGBINV");
modelStruct.modelPar_LCIGBINV=mod.LCIGBINV;
modelStruct.d_modelPar_LCIGBINV_dX=0.0;
modelStruct.modelPar_given_LCIGBINV=mod.given("LCIGBINV");
modelStruct.modelPar_WCIGBINV=mod.WCIGBINV;
modelStruct.d_modelPar_WCIGBINV_dX=0.0;
modelStruct.modelPar_given_WCIGBINV=mod.given("WCIGBINV");
modelStruct.modelPar_PCIGBINV=mod.PCIGBINV;
modelStruct.d_modelPar_PCIGBINV_dX=0.0;
modelStruct.modelPar_given_PCIGBINV=mod.given("PCIGBINV");
modelStruct.modelPar_LEIGBINV=mod.LEIGBINV;
modelStruct.d_modelPar_LEIGBINV_dX=0.0;
modelStruct.modelPar_given_LEIGBINV=mod.given("LEIGBINV");
modelStruct.modelPar_WEIGBINV=mod.WEIGBINV;
modelStruct.d_modelPar_WEIGBINV_dX=0.0;
modelStruct.modelPar_given_WEIGBINV=mod.given("WEIGBINV");
modelStruct.modelPar_PEIGBINV=mod.PEIGBINV;
modelStruct.d_modelPar_PEIGBINV_dX=0.0;
modelStruct.modelPar_given_PEIGBINV=mod.given("PEIGBINV");
modelStruct.modelPar_LNIGBINV=mod.LNIGBINV;
modelStruct.d_modelPar_LNIGBINV_dX=0.0;
modelStruct.modelPar_given_LNIGBINV=mod.given("LNIGBINV");
modelStruct.modelPar_WNIGBINV=mod.WNIGBINV;
modelStruct.d_modelPar_WNIGBINV_dX=0.0;
modelStruct.modelPar_given_WNIGBINV=mod.given("WNIGBINV");
modelStruct.modelPar_PNIGBINV=mod.PNIGBINV;
modelStruct.d_modelPar_PNIGBINV_dX=0.0;
modelStruct.modelPar_given_PNIGBINV=mod.given("PNIGBINV");
modelStruct.modelPar_LAIGBACC=mod.LAIGBACC;
modelStruct.d_modelPar_LAIGBACC_dX=0.0;
modelStruct.modelPar_given_LAIGBACC=mod.given("LAIGBACC");
modelStruct.modelPar_WAIGBACC=mod.WAIGBACC;
modelStruct.d_modelPar_WAIGBACC_dX=0.0;
modelStruct.modelPar_given_WAIGBACC=mod.given("WAIGBACC");
modelStruct.modelPar_PAIGBACC=mod.PAIGBACC;
modelStruct.d_modelPar_PAIGBACC_dX=0.0;
modelStruct.modelPar_given_PAIGBACC=mod.given("PAIGBACC");
modelStruct.modelPar_LBIGBACC=mod.LBIGBACC;
modelStruct.d_modelPar_LBIGBACC_dX=0.0;
modelStruct.modelPar_given_LBIGBACC=mod.given("LBIGBACC");
modelStruct.modelPar_WBIGBACC=mod.WBIGBACC;
modelStruct.d_modelPar_WBIGBACC_dX=0.0;
modelStruct.modelPar_given_WBIGBACC=mod.given("WBIGBACC");
modelStruct.modelPar_PBIGBACC=mod.PBIGBACC;
modelStruct.d_modelPar_PBIGBACC_dX=0.0;
modelStruct.modelPar_given_PBIGBACC=mod.given("PBIGBACC");
modelStruct.modelPar_LCIGBACC=mod.LCIGBACC;
modelStruct.d_modelPar_LCIGBACC_dX=0.0;
modelStruct.modelPar_given_LCIGBACC=mod.given("LCIGBACC");
modelStruct.modelPar_WCIGBACC=mod.WCIGBACC;
modelStruct.d_modelPar_WCIGBACC_dX=0.0;
modelStruct.modelPar_given_WCIGBACC=mod.given("WCIGBACC");
modelStruct.modelPar_PCIGBACC=mod.PCIGBACC;
modelStruct.d_modelPar_PCIGBACC_dX=0.0;
modelStruct.modelPar_given_PCIGBACC=mod.given("PCIGBACC");
modelStruct.modelPar_LNIGBACC=mod.LNIGBACC;
modelStruct.d_modelPar_LNIGBACC_dX=0.0;
modelStruct.modelPar_given_LNIGBACC=mod.given("LNIGBACC");
modelStruct.modelPar_WNIGBACC=mod.WNIGBACC;
modelStruct.d_modelPar_WNIGBACC_dX=0.0;
modelStruct.modelPar_given_WNIGBACC=mod.given("WNIGBACC");
modelStruct.modelPar_PNIGBACC=mod.PNIGBACC;
modelStruct.d_modelPar_PNIGBACC_dX=0.0;
modelStruct.modelPar_given_PNIGBACC=mod.given("PNIGBACC");
modelStruct.modelPar_LAIGC=mod.LAIGC;
modelStruct.d_modelPar_LAIGC_dX=0.0;
modelStruct.modelPar_given_LAIGC=mod.given("LAIGC");
modelStruct.modelPar_WAIGC=mod.WAIGC;
modelStruct.d_modelPar_WAIGC_dX=0.0;
modelStruct.modelPar_given_WAIGC=mod.given("WAIGC");
modelStruct.modelPar_PAIGC=mod.PAIGC;
modelStruct.d_modelPar_PAIGC_dX=0.0;
modelStruct.modelPar_given_PAIGC=mod.given("PAIGC");
modelStruct.modelPar_LBIGC=mod.LBIGC;
modelStruct.d_modelPar_LBIGC_dX=0.0;
modelStruct.modelPar_given_LBIGC=mod.given("LBIGC");
modelStruct.modelPar_WBIGC=mod.WBIGC;
modelStruct.d_modelPar_WBIGC_dX=0.0;
modelStruct.modelPar_given_WBIGC=mod.given("WBIGC");
modelStruct.modelPar_PBIGC=mod.PBIGC;
modelStruct.d_modelPar_PBIGC_dX=0.0;
modelStruct.modelPar_given_PBIGC=mod.given("PBIGC");
modelStruct.modelPar_LCIGC=mod.LCIGC;
modelStruct.d_modelPar_LCIGC_dX=0.0;
modelStruct.modelPar_given_LCIGC=mod.given("LCIGC");
modelStruct.modelPar_WCIGC=mod.WCIGC;
modelStruct.d_modelPar_WCIGC_dX=0.0;
modelStruct.modelPar_given_WCIGC=mod.given("WCIGC");
modelStruct.modelPar_PCIGC=mod.PCIGC;
modelStruct.d_modelPar_PCIGC_dX=0.0;
modelStruct.modelPar_given_PCIGC=mod.given("PCIGC");
modelStruct.modelPar_LAIGS=mod.LAIGS;
modelStruct.d_modelPar_LAIGS_dX=0.0;
modelStruct.modelPar_given_LAIGS=mod.given("LAIGS");
modelStruct.modelPar_WAIGS=mod.WAIGS;
modelStruct.d_modelPar_WAIGS_dX=0.0;
modelStruct.modelPar_given_WAIGS=mod.given("WAIGS");
modelStruct.modelPar_PAIGS=mod.PAIGS;
modelStruct.d_modelPar_PAIGS_dX=0.0;
modelStruct.modelPar_given_PAIGS=mod.given("PAIGS");
modelStruct.modelPar_LBIGS=mod.LBIGS;
modelStruct.d_modelPar_LBIGS_dX=0.0;
modelStruct.modelPar_given_LBIGS=mod.given("LBIGS");
modelStruct.modelPar_WBIGS=mod.WBIGS;
modelStruct.d_modelPar_WBIGS_dX=0.0;
modelStruct.modelPar_given_WBIGS=mod.given("WBIGS");
modelStruct.modelPar_PBIGS=mod.PBIGS;
modelStruct.d_modelPar_PBIGS_dX=0.0;
modelStruct.modelPar_given_PBIGS=mod.given("PBIGS");
modelStruct.modelPar_LCIGS=mod.LCIGS;
modelStruct.d_modelPar_LCIGS_dX=0.0;
modelStruct.modelPar_given_LCIGS=mod.given("LCIGS");
modelStruct.modelPar_WCIGS=mod.WCIGS;
modelStruct.d_modelPar_WCIGS_dX=0.0;
modelStruct.modelPar_given_WCIGS=mod.given("WCIGS");
modelStruct.modelPar_PCIGS=mod.PCIGS;
modelStruct.d_modelPar_PCIGS_dX=0.0;
modelStruct.modelPar_given_PCIGS=mod.given("PCIGS");
modelStruct.modelPar_LAIGD=mod.LAIGD;
modelStruct.d_modelPar_LAIGD_dX=0.0;
modelStruct.modelPar_given_LAIGD=mod.given("LAIGD");
modelStruct.modelPar_WAIGD=mod.WAIGD;
modelStruct.d_modelPar_WAIGD_dX=0.0;
modelStruct.modelPar_given_WAIGD=mod.given("WAIGD");
modelStruct.modelPar_PAIGD=mod.PAIGD;
modelStruct.d_modelPar_PAIGD_dX=0.0;
modelStruct.modelPar_given_PAIGD=mod.given("PAIGD");
modelStruct.modelPar_LBIGD=mod.LBIGD;
modelStruct.d_modelPar_LBIGD_dX=0.0;
modelStruct.modelPar_given_LBIGD=mod.given("LBIGD");
modelStruct.modelPar_WBIGD=mod.WBIGD;
modelStruct.d_modelPar_WBIGD_dX=0.0;
modelStruct.modelPar_given_WBIGD=mod.given("WBIGD");
modelStruct.modelPar_PBIGD=mod.PBIGD;
modelStruct.d_modelPar_PBIGD_dX=0.0;
modelStruct.modelPar_given_PBIGD=mod.given("PBIGD");
modelStruct.modelPar_LCIGD=mod.LCIGD;
modelStruct.d_modelPar_LCIGD_dX=0.0;
modelStruct.modelPar_given_LCIGD=mod.given("LCIGD");
modelStruct.modelPar_WCIGD=mod.WCIGD;
modelStruct.d_modelPar_WCIGD_dX=0.0;
modelStruct.modelPar_given_WCIGD=mod.given("WCIGD");
modelStruct.modelPar_PCIGD=mod.PCIGD;
modelStruct.d_modelPar_PCIGD_dX=0.0;
modelStruct.modelPar_given_PCIGD=mod.given("PCIGD");
modelStruct.modelPar_LPOXEDGE=mod.LPOXEDGE;
modelStruct.d_modelPar_LPOXEDGE_dX=0.0;
modelStruct.modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
modelStruct.modelPar_WPOXEDGE=mod.WPOXEDGE;
modelStruct.d_modelPar_WPOXEDGE_dX=0.0;
modelStruct.modelPar_given_WPOXEDGE=mod.given("WPOXEDGE");
modelStruct.modelPar_PPOXEDGE=mod.PPOXEDGE;
modelStruct.d_modelPar_PPOXEDGE_dX=0.0;
modelStruct.modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
modelStruct.modelPar_LDLCIG=mod.LDLCIG;
modelStruct.d_modelPar_LDLCIG_dX=0.0;
modelStruct.modelPar_given_LDLCIG=mod.given("LDLCIG");
modelStruct.modelPar_WDLCIG=mod.WDLCIG;
modelStruct.d_modelPar_WDLCIG_dX=0.0;
modelStruct.modelPar_given_WDLCIG=mod.given("WDLCIG");
modelStruct.modelPar_PDLCIG=mod.PDLCIG;
modelStruct.d_modelPar_PDLCIG_dX=0.0;
modelStruct.modelPar_given_PDLCIG=mod.given("PDLCIG");
modelStruct.modelPar_LDLCIGD=mod.LDLCIGD;
modelStruct.d_modelPar_LDLCIGD_dX=0.0;
modelStruct.modelPar_given_LDLCIGD=mod.given("LDLCIGD");
modelStruct.modelPar_WDLCIGD=mod.WDLCIGD;
modelStruct.d_modelPar_WDLCIGD_dX=0.0;
modelStruct.modelPar_given_WDLCIGD=mod.given("WDLCIGD");
modelStruct.modelPar_PDLCIGD=mod.PDLCIGD;
modelStruct.d_modelPar_PDLCIGD_dX=0.0;
modelStruct.modelPar_given_PDLCIGD=mod.given("PDLCIGD");
modelStruct.modelPar_LNTOX=mod.LNTOX;
modelStruct.d_modelPar_LNTOX_dX=0.0;
modelStruct.modelPar_given_LNTOX=mod.given("LNTOX");
modelStruct.modelPar_WNTOX=mod.WNTOX;
modelStruct.d_modelPar_WNTOX_dX=0.0;
modelStruct.modelPar_given_WNTOX=mod.given("WNTOX");
modelStruct.modelPar_PNTOX=mod.PNTOX;
modelStruct.d_modelPar_PNTOX_dX=0.0;
modelStruct.modelPar_given_PNTOX=mod.given("PNTOX");
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modelStruct.modelPar_AGIDLL=mod.AGIDLL;
modelStruct.d_modelPar_AGIDLL_dX=0.0;
modelStruct.modelPar_given_AGIDLL=mod.given("AGIDLL");
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modelStruct.modelPar_LAGIDL=mod.LAGIDL;
modelStruct.d_modelPar_LAGIDL_dX=0.0;
modelStruct.modelPar_given_LAGIDL=mod.given("LAGIDL");
modelStruct.modelPar_WAGIDL=mod.WAGIDL;
modelStruct.d_modelPar_WAGIDL_dX=0.0;
modelStruct.modelPar_given_WAGIDL=mod.given("WAGIDL");
modelStruct.modelPar_PAGIDL=mod.PAGIDL;
modelStruct.d_modelPar_PAGIDL_dX=0.0;
modelStruct.modelPar_given_PAGIDL=mod.given("PAGIDL");
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modelStruct.modelPar_LBGIDL=mod.LBGIDL;
modelStruct.d_modelPar_LBGIDL_dX=0.0;
modelStruct.modelPar_given_LBGIDL=mod.given("LBGIDL");
modelStruct.modelPar_WBGIDL=mod.WBGIDL;
modelStruct.d_modelPar_WBGIDL_dX=0.0;
modelStruct.modelPar_given_WBGIDL=mod.given("WBGIDL");
modelStruct.modelPar_PBGIDL=mod.PBGIDL;
modelStruct.d_modelPar_PBGIDL_dX=0.0;
modelStruct.modelPar_given_PBGIDL=mod.given("PBGIDL");
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modelStruct.modelPar_LCGIDL=mod.LCGIDL;
modelStruct.d_modelPar_LCGIDL_dX=0.0;
modelStruct.modelPar_given_LCGIDL=mod.given("LCGIDL");
modelStruct.modelPar_WCGIDL=mod.WCGIDL;
modelStruct.d_modelPar_WCGIDL_dX=0.0;
modelStruct.modelPar_given_WCGIDL=mod.given("WCGIDL");
modelStruct.modelPar_PCGIDL=mod.PCGIDL;
modelStruct.d_modelPar_PCGIDL_dX=0.0;
modelStruct.modelPar_given_PCGIDL=mod.given("PCGIDL");
modelStruct.modelPar_EGIDL=mod.EGIDL;
modelStruct.d_modelPar_EGIDL_dX=0.0;
modelStruct.modelPar_given_EGIDL=mod.given("EGIDL");
modelStruct.modelPar_LEGIDL=mod.LEGIDL;
modelStruct.d_modelPar_LEGIDL_dX=0.0;
modelStruct.modelPar_given_LEGIDL=mod.given("LEGIDL");
modelStruct.modelPar_WEGIDL=mod.WEGIDL;
modelStruct.d_modelPar_WEGIDL_dX=0.0;
modelStruct.modelPar_given_WEGIDL=mod.given("WEGIDL");
modelStruct.modelPar_PEGIDL=mod.PEGIDL;
modelStruct.d_modelPar_PEGIDL_dX=0.0;
modelStruct.modelPar_given_PEGIDL=mod.given("PEGIDL");
modelStruct.modelPar_AGISL=mod.AGISL;
modelStruct.d_modelPar_AGISL_dX=0.0;
modelStruct.modelPar_given_AGISL=mod.given("AGISL");
modelStruct.modelPar_AGISLL=mod.AGISLL;
modelStruct.d_modelPar_AGISLL_dX=0.0;
modelStruct.modelPar_given_AGISLL=mod.given("AGISLL");
modelStruct.modelPar_AGISLW=mod.AGISLW;
modelStruct.d_modelPar_AGISLW_dX=0.0;
modelStruct.modelPar_given_AGISLW=mod.given("AGISLW");
modelStruct.modelPar_LAGISL=mod.LAGISL;
modelStruct.d_modelPar_LAGISL_dX=0.0;
modelStruct.modelPar_given_LAGISL=mod.given("LAGISL");
modelStruct.modelPar_WAGISL=mod.WAGISL;
modelStruct.d_modelPar_WAGISL_dX=0.0;
modelStruct.modelPar_given_WAGISL=mod.given("WAGISL");
modelStruct.modelPar_PAGISL=mod.PAGISL;
modelStruct.d_modelPar_PAGISL_dX=0.0;
modelStruct.modelPar_given_PAGISL=mod.given("PAGISL");
modelStruct.modelPar_BGISL=mod.BGISL;
modelStruct.d_modelPar_BGISL_dX=0.0;
modelStruct.modelPar_given_BGISL=mod.given("BGISL");
modelStruct.modelPar_LBGISL=mod.LBGISL;
modelStruct.d_modelPar_LBGISL_dX=0.0;
modelStruct.modelPar_given_LBGISL=mod.given("LBGISL");
modelStruct.modelPar_WBGISL=mod.WBGISL;
modelStruct.d_modelPar_WBGISL_dX=0.0;
modelStruct.modelPar_given_WBGISL=mod.given("WBGISL");
modelStruct.modelPar_PBGISL=mod.PBGISL;
modelStruct.d_modelPar_PBGISL_dX=0.0;
modelStruct.modelPar_given_PBGISL=mod.given("PBGISL");
modelStruct.modelPar_CGISL=mod.CGISL;
modelStruct.d_modelPar_CGISL_dX=0.0;
modelStruct.modelPar_given_CGISL=mod.given("CGISL");
modelStruct.modelPar_LCGISL=mod.LCGISL;
modelStruct.d_modelPar_LCGISL_dX=0.0;
modelStruct.modelPar_given_LCGISL=mod.given("LCGISL");
modelStruct.modelPar_WCGISL=mod.WCGISL;
modelStruct.d_modelPar_WCGISL_dX=0.0;
modelStruct.modelPar_given_WCGISL=mod.given("WCGISL");
modelStruct.modelPar_PCGISL=mod.PCGISL;
modelStruct.d_modelPar_PCGISL_dX=0.0;
modelStruct.modelPar_given_PCGISL=mod.given("PCGISL");
modelStruct.modelPar_EGISL=mod.EGISL;
modelStruct.d_modelPar_EGISL_dX=0.0;
modelStruct.modelPar_given_EGISL=mod.given("EGISL");
modelStruct.modelPar_LEGISL=mod.LEGISL;
modelStruct.d_modelPar_LEGISL_dX=0.0;
modelStruct.modelPar_given_LEGISL=mod.given("LEGISL");
modelStruct.modelPar_WEGISL=mod.WEGISL;
modelStruct.d_modelPar_WEGISL_dX=0.0;
modelStruct.modelPar_given_WEGISL=mod.given("WEGISL");
modelStruct.modelPar_PEGISL=mod.PEGISL;
modelStruct.d_modelPar_PEGISL_dX=0.0;
modelStruct.modelPar_given_PEGISL=mod.given("PEGISL");
modelStruct.modelPar_CF=mod.CF;
modelStruct.d_modelPar_CF_dX=0.0;
modelStruct.modelPar_given_CF=mod.given("CF");
modelStruct.modelPar_LCF=mod.LCF;
modelStruct.d_modelPar_LCF_dX=0.0;
modelStruct.modelPar_given_LCF=mod.given("LCF");
modelStruct.modelPar_WCF=mod.WCF;
modelStruct.d_modelPar_WCF_dX=0.0;
modelStruct.modelPar_given_WCF=mod.given("WCF");
modelStruct.modelPar_PCF=mod.PCF;
modelStruct.d_modelPar_PCF_dX=0.0;
modelStruct.modelPar_given_PCF=mod.given("PCF");
modelStruct.modelPar_CFRCOEFF=mod.CFRCOEFF;
modelStruct.d_modelPar_CFRCOEFF_dX=0.0;
modelStruct.modelPar_given_CFRCOEFF=mod.given("CFRCOEFF");
modelStruct.modelPar_CGSO=mod.CGSO;
modelStruct.d_modelPar_CGSO_dX=0.0;
modelStruct.modelPar_given_CGSO=mod.given("CGSO");
modelStruct.modelPar_CGDO=mod.CGDO;
modelStruct.d_modelPar_CGDO_dX=0.0;
modelStruct.modelPar_given_CGDO=mod.given("CGDO");
modelStruct.modelPar_CGBO=mod.CGBO;
modelStruct.d_modelPar_CGBO_dX=0.0;
modelStruct.modelPar_given_CGBO=mod.given("CGBO");
modelStruct.modelPar_CGSL=mod.CGSL;
modelStruct.d_modelPar_CGSL_dX=0.0;
modelStruct.modelPar_given_CGSL=mod.given("CGSL");
modelStruct.modelPar_LCGSL=mod.LCGSL;
modelStruct.d_modelPar_LCGSL_dX=0.0;
modelStruct.modelPar_given_LCGSL=mod.given("LCGSL");
modelStruct.modelPar_WCGSL=mod.WCGSL;
modelStruct.d_modelPar_WCGSL_dX=0.0;
modelStruct.modelPar_given_WCGSL=mod.given("WCGSL");
modelStruct.modelPar_PCGSL=mod.PCGSL;
modelStruct.d_modelPar_PCGSL_dX=0.0;
modelStruct.modelPar_given_PCGSL=mod.given("PCGSL");
modelStruct.modelPar_CGDL=mod.CGDL;
modelStruct.d_modelPar_CGDL_dX=0.0;
modelStruct.modelPar_given_CGDL=mod.given("CGDL");
modelStruct.modelPar_LCGDL=mod.LCGDL;
modelStruct.d_modelPar_LCGDL_dX=0.0;
modelStruct.modelPar_given_LCGDL=mod.given("LCGDL");
modelStruct.modelPar_WCGDL=mod.WCGDL;
modelStruct.d_modelPar_WCGDL_dX=0.0;
modelStruct.modelPar_given_WCGDL=mod.given("WCGDL");
modelStruct.modelPar_PCGDL=mod.PCGDL;
modelStruct.d_modelPar_PCGDL_dX=0.0;
modelStruct.modelPar_given_PCGDL=mod.given("PCGDL");
modelStruct.modelPar_CKAPPAS=mod.CKAPPAS;
modelStruct.d_modelPar_CKAPPAS_dX=0.0;
modelStruct.modelPar_given_CKAPPAS=mod.given("CKAPPAS");
modelStruct.modelPar_LCKAPPAS=mod.LCKAPPAS;
modelStruct.d_modelPar_LCKAPPAS_dX=0.0;
modelStruct.modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
modelStruct.modelPar_WCKAPPAS=mod.WCKAPPAS;
modelStruct.d_modelPar_WCKAPPAS_dX=0.0;
modelStruct.modelPar_given_WCKAPPAS=mod.given("WCKAPPAS");
modelStruct.modelPar_PCKAPPAS=mod.PCKAPPAS;
modelStruct.d_modelPar_PCKAPPAS_dX=0.0;
modelStruct.modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
modelStruct.modelPar_CKAPPAD=mod.CKAPPAD;
modelStruct.d_modelPar_CKAPPAD_dX=0.0;
modelStruct.modelPar_given_CKAPPAD=mod.given("CKAPPAD");
modelStruct.modelPar_LCKAPPAD=mod.LCKAPPAD;
modelStruct.d_modelPar_LCKAPPAD_dX=0.0;
modelStruct.modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
modelStruct.modelPar_WCKAPPAD=mod.WCKAPPAD;
modelStruct.d_modelPar_WCKAPPAD_dX=0.0;
modelStruct.modelPar_given_WCKAPPAD=mod.given("WCKAPPAD");
modelStruct.modelPar_PCKAPPAD=mod.PCKAPPAD;
modelStruct.d_modelPar_PCKAPPAD_dX=0.0;
modelStruct.modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
modelStruct.modelPar_DMCG=mod.DMCG;
modelStruct.d_modelPar_DMCG_dX=0.0;
modelStruct.modelPar_given_DMCG=mod.given("DMCG");
modelStruct.modelPar_DMCI=mod.DMCI;
modelStruct.d_modelPar_DMCI_dX=0.0;
modelStruct.modelPar_given_DMCI=mod.given("DMCI");
modelStruct.modelPar_DMDG=mod.DMDG;
modelStruct.d_modelPar_DMDG_dX=0.0;
modelStruct.modelPar_given_DMDG=mod.given("DMDG");
modelStruct.modelPar_DMCGT=mod.DMCGT;
modelStruct.d_modelPar_DMCGT_dX=0.0;
modelStruct.modelPar_given_DMCGT=mod.given("DMCGT");
modelStruct.modelPar_XGL=mod.XGL;
modelStruct.d_modelPar_XGL_dX=0.0;
modelStruct.modelPar_given_XGL=mod.given("XGL");
modelStruct.modelPar_RSHG=mod.RSHG;
modelStruct.d_modelPar_RSHG_dX=0.0;
modelStruct.modelPar_given_RSHG=mod.given("RSHG");
modelStruct.modelPar_CJS=mod.CJS;
modelStruct.d_modelPar_CJS_dX=0.0;
modelStruct.modelPar_given_CJS=mod.given("CJS");
modelStruct.modelPar_CJD=mod.CJD;
modelStruct.d_modelPar_CJD_dX=0.0;
modelStruct.modelPar_given_CJD=mod.given("CJD");
modelStruct.modelPar_CJSWS=mod.CJSWS;
modelStruct.d_modelPar_CJSWS_dX=0.0;
modelStruct.modelPar_given_CJSWS=mod.given("CJSWS");
modelStruct.modelPar_CJSWD=mod.CJSWD;
modelStruct.d_modelPar_CJSWD_dX=0.0;
modelStruct.modelPar_given_CJSWD=mod.given("CJSWD");
modelStruct.modelPar_CJSWGS=mod.CJSWGS;
modelStruct.d_modelPar_CJSWGS_dX=0.0;
modelStruct.modelPar_given_CJSWGS=mod.given("CJSWGS");
modelStruct.modelPar_CJSWGD=mod.CJSWGD;
modelStruct.d_modelPar_CJSWGD_dX=0.0;
modelStruct.modelPar_given_CJSWGD=mod.given("CJSWGD");
modelStruct.modelPar_PBS=mod.PBS;
modelStruct.d_modelPar_PBS_dX=0.0;
modelStruct.modelPar_given_PBS=mod.given("PBS");
modelStruct.modelPar_PBD=mod.PBD;
modelStruct.d_modelPar_PBD_dX=0.0;
modelStruct.modelPar_given_PBD=mod.given("PBD");
modelStruct.modelPar_PBSWS=mod.PBSWS;
modelStruct.d_modelPar_PBSWS_dX=0.0;
modelStruct.modelPar_given_PBSWS=mod.given("PBSWS");
modelStruct.modelPar_PBSWD=mod.PBSWD;
modelStruct.d_modelPar_PBSWD_dX=0.0;
modelStruct.modelPar_given_PBSWD=mod.given("PBSWD");
modelStruct.modelPar_PBSWGS=mod.PBSWGS;
modelStruct.d_modelPar_PBSWGS_dX=0.0;
modelStruct.modelPar_given_PBSWGS=mod.given("PBSWGS");
modelStruct.modelPar_PBSWGD=mod.PBSWGD;
modelStruct.d_modelPar_PBSWGD_dX=0.0;
modelStruct.modelPar_given_PBSWGD=mod.given("PBSWGD");
modelStruct.modelPar_MJS=mod.MJS;
modelStruct.d_modelPar_MJS_dX=0.0;
modelStruct.modelPar_given_MJS=mod.given("MJS");
modelStruct.modelPar_MJD=mod.MJD;
modelStruct.d_modelPar_MJD_dX=0.0;
modelStruct.modelPar_given_MJD=mod.given("MJD");
modelStruct.modelPar_MJSWS=mod.MJSWS;
modelStruct.d_modelPar_MJSWS_dX=0.0;
modelStruct.modelPar_given_MJSWS=mod.given("MJSWS");
modelStruct.modelPar_MJSWD=mod.MJSWD;
modelStruct.d_modelPar_MJSWD_dX=0.0;
modelStruct.modelPar_given_MJSWD=mod.given("MJSWD");
modelStruct.modelPar_MJSWGS=mod.MJSWGS;
modelStruct.d_modelPar_MJSWGS_dX=0.0;
modelStruct.modelPar_given_MJSWGS=mod.given("MJSWGS");
modelStruct.modelPar_MJSWGD=mod.MJSWGD;
modelStruct.d_modelPar_MJSWGD_dX=0.0;
modelStruct.modelPar_given_MJSWGD=mod.given("MJSWGD");
modelStruct.modelPar_JSS=mod.JSS;
modelStruct.d_modelPar_JSS_dX=0.0;
modelStruct.modelPar_given_JSS=mod.given("JSS");
modelStruct.modelPar_JSD=mod.JSD;
modelStruct.d_modelPar_JSD_dX=0.0;
modelStruct.modelPar_given_JSD=mod.given("JSD");
modelStruct.modelPar_JSWS=mod.JSWS;
modelStruct.d_modelPar_JSWS_dX=0.0;
modelStruct.modelPar_given_JSWS=mod.given("JSWS");
modelStruct.modelPar_JSWD=mod.JSWD;
modelStruct.d_modelPar_JSWD_dX=0.0;
modelStruct.modelPar_given_JSWD=mod.given("JSWD");
modelStruct.modelPar_JSWGS=mod.JSWGS;
modelStruct.d_modelPar_JSWGS_dX=0.0;
modelStruct.modelPar_given_JSWGS=mod.given("JSWGS");
modelStruct.modelPar_JSWGD=mod.JSWGD;
modelStruct.d_modelPar_JSWGD_dX=0.0;
modelStruct.modelPar_given_JSWGD=mod.given("JSWGD");
modelStruct.modelPar_NJS=mod.NJS;
modelStruct.d_modelPar_NJS_dX=0.0;
modelStruct.modelPar_given_NJS=mod.given("NJS");
modelStruct.modelPar_NJD=mod.NJD;
modelStruct.d_modelPar_NJD_dX=0.0;
modelStruct.modelPar_given_NJD=mod.given("NJD");
modelStruct.modelPar_IJTHSFWD=mod.IJTHSFWD;
modelStruct.d_modelPar_IJTHSFWD_dX=0.0;
modelStruct.modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
modelStruct.modelPar_IJTHDFWD=mod.IJTHDFWD;
modelStruct.d_modelPar_IJTHDFWD_dX=0.0;
modelStruct.modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
modelStruct.modelPar_IJTHSREV=mod.IJTHSREV;
modelStruct.d_modelPar_IJTHSREV_dX=0.0;
modelStruct.modelPar_given_IJTHSREV=mod.given("IJTHSREV");
modelStruct.modelPar_IJTHDREV=mod.IJTHDREV;
modelStruct.d_modelPar_IJTHDREV_dX=0.0;
modelStruct.modelPar_given_IJTHDREV=mod.given("IJTHDREV");
modelStruct.modelPar_BVS=mod.BVS;
modelStruct.d_modelPar_BVS_dX=0.0;
modelStruct.modelPar_given_BVS=mod.given("BVS");
modelStruct.modelPar_BVD=mod.BVD;
modelStruct.d_modelPar_BVD_dX=0.0;
modelStruct.modelPar_given_BVD=mod.given("BVD");
modelStruct.modelPar_XJBVS=mod.XJBVS;
modelStruct.d_modelPar_XJBVS_dX=0.0;
modelStruct.modelPar_given_XJBVS=mod.given("XJBVS");
modelStruct.modelPar_XJBVD=mod.XJBVD;
modelStruct.d_modelPar_XJBVD_dX=0.0;
modelStruct.modelPar_given_XJBVD=mod.given("XJBVD");
modelStruct.modelPar_JTSS=mod.JTSS;
modelStruct.d_modelPar_JTSS_dX=0.0;
modelStruct.modelPar_given_JTSS=mod.given("JTSS");
modelStruct.modelPar_JTSD=mod.JTSD;
modelStruct.d_modelPar_JTSD_dX=0.0;
modelStruct.modelPar_given_JTSD=mod.given("JTSD");
modelStruct.modelPar_JTSSWS=mod.JTSSWS;
modelStruct.d_modelPar_JTSSWS_dX=0.0;
modelStruct.modelPar_given_JTSSWS=mod.given("JTSSWS");
modelStruct.modelPar_JTSSWD=mod.JTSSWD;
modelStruct.d_modelPar_JTSSWD_dX=0.0;
modelStruct.modelPar_given_JTSSWD=mod.given("JTSSWD");
modelStruct.modelPar_JTSSWGS=mod.JTSSWGS;
modelStruct.d_modelPar_JTSSWGS_dX=0.0;
modelStruct.modelPar_given_JTSSWGS=mod.given("JTSSWGS");
modelStruct.modelPar_JTSSWGD=mod.JTSSWGD;
modelStruct.d_modelPar_JTSSWGD_dX=0.0;
modelStruct.modelPar_given_JTSSWGD=mod.given("JTSSWGD");
modelStruct.modelPar_JTWEFF=mod.JTWEFF;
modelStruct.d_modelPar_JTWEFF_dX=0.0;
modelStruct.modelPar_given_JTWEFF=mod.given("JTWEFF");
modelStruct.modelPar_NJTS=mod.NJTS;
modelStruct.d_modelPar_NJTS_dX=0.0;
modelStruct.modelPar_given_NJTS=mod.given("NJTS");
modelStruct.modelPar_NJTSD=mod.NJTSD;
modelStruct.d_modelPar_NJTSD_dX=0.0;
modelStruct.modelPar_given_NJTSD=mod.given("NJTSD");
modelStruct.modelPar_NJTSSW=mod.NJTSSW;
modelStruct.d_modelPar_NJTSSW_dX=0.0;
modelStruct.modelPar_given_NJTSSW=mod.given("NJTSSW");
modelStruct.modelPar_NJTSSWD=mod.NJTSSWD;
modelStruct.d_modelPar_NJTSSWD_dX=0.0;
modelStruct.modelPar_given_NJTSSWD=mod.given("NJTSSWD");
modelStruct.modelPar_NJTSSWG=mod.NJTSSWG;
modelStruct.d_modelPar_NJTSSWG_dX=0.0;
modelStruct.modelPar_given_NJTSSWG=mod.given("NJTSSWG");
modelStruct.modelPar_NJTSSWGD=mod.NJTSSWGD;
modelStruct.d_modelPar_NJTSSWGD_dX=0.0;
modelStruct.modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
modelStruct.modelPar_VTSS=mod.VTSS;
modelStruct.d_modelPar_VTSS_dX=0.0;
modelStruct.modelPar_given_VTSS=mod.given("VTSS");
modelStruct.modelPar_VTSD=mod.VTSD;
modelStruct.d_modelPar_VTSD_dX=0.0;
modelStruct.modelPar_given_VTSD=mod.given("VTSD");
modelStruct.modelPar_VTSSWS=mod.VTSSWS;
modelStruct.d_modelPar_VTSSWS_dX=0.0;
modelStruct.modelPar_given_VTSSWS=mod.given("VTSSWS");
modelStruct.modelPar_VTSSWD=mod.VTSSWD;
modelStruct.d_modelPar_VTSSWD_dX=0.0;
modelStruct.modelPar_given_VTSSWD=mod.given("VTSSWD");
modelStruct.modelPar_VTSSWGS=mod.VTSSWGS;
modelStruct.d_modelPar_VTSSWGS_dX=0.0;
modelStruct.modelPar_given_VTSSWGS=mod.given("VTSSWGS");
modelStruct.modelPar_VTSSWGD=mod.VTSSWGD;
modelStruct.d_modelPar_VTSSWGD_dX=0.0;
modelStruct.modelPar_given_VTSSWGD=mod.given("VTSSWGD");
modelStruct.modelPar_XRCRG1=mod.XRCRG1;
modelStruct.d_modelPar_XRCRG1_dX=0.0;
modelStruct.modelPar_given_XRCRG1=mod.given("XRCRG1");
modelStruct.modelPar_XRCRG2=mod.XRCRG2;
modelStruct.d_modelPar_XRCRG2_dX=0.0;
modelStruct.modelPar_given_XRCRG2=mod.given("XRCRG2");
modelStruct.modelPar_GBMIN=mod.GBMIN;
modelStruct.d_modelPar_GBMIN_dX=0.0;
modelStruct.modelPar_given_GBMIN=mod.given("GBMIN");
modelStruct.modelPar_RBPS0=mod.RBPS0;
modelStruct.d_modelPar_RBPS0_dX=0.0;
modelStruct.modelPar_given_RBPS0=mod.given("RBPS0");
modelStruct.modelPar_RBPSL=mod.RBPSL;
modelStruct.d_modelPar_RBPSL_dX=0.0;
modelStruct.modelPar_given_RBPSL=mod.given("RBPSL");
modelStruct.modelPar_RBPSW=mod.RBPSW;
modelStruct.d_modelPar_RBPSW_dX=0.0;
modelStruct.modelPar_given_RBPSW=mod.given("RBPSW");
modelStruct.modelPar_RBPSNF=mod.RBPSNF;
modelStruct.d_modelPar_RBPSNF_dX=0.0;
modelStruct.modelPar_given_RBPSNF=mod.given("RBPSNF");
modelStruct.modelPar_RBPD0=mod.RBPD0;
modelStruct.d_modelPar_RBPD0_dX=0.0;
modelStruct.modelPar_given_RBPD0=mod.given("RBPD0");
modelStruct.modelPar_RBPDL=mod.RBPDL;
modelStruct.d_modelPar_RBPDL_dX=0.0;
modelStruct.modelPar_given_RBPDL=mod.given("RBPDL");
modelStruct.modelPar_RBPDW=mod.RBPDW;
modelStruct.d_modelPar_RBPDW_dX=0.0;
modelStruct.modelPar_given_RBPDW=mod.given("RBPDW");
modelStruct.modelPar_RBPDNF=mod.RBPDNF;
modelStruct.d_modelPar_RBPDNF_dX=0.0;
modelStruct.modelPar_given_RBPDNF=mod.given("RBPDNF");
modelStruct.modelPar_RBPBX0=mod.RBPBX0;
modelStruct.d_modelPar_RBPBX0_dX=0.0;
modelStruct.modelPar_given_RBPBX0=mod.given("RBPBX0");
modelStruct.modelPar_RBPBXL=mod.RBPBXL;
modelStruct.d_modelPar_RBPBXL_dX=0.0;
modelStruct.modelPar_given_RBPBXL=mod.given("RBPBXL");
modelStruct.modelPar_RBPBXW=mod.RBPBXW;
modelStruct.d_modelPar_RBPBXW_dX=0.0;
modelStruct.modelPar_given_RBPBXW=mod.given("RBPBXW");
modelStruct.modelPar_RBPBXNF=mod.RBPBXNF;
modelStruct.d_modelPar_RBPBXNF_dX=0.0;
modelStruct.modelPar_given_RBPBXNF=mod.given("RBPBXNF");
modelStruct.modelPar_RBPBY0=mod.RBPBY0;
modelStruct.d_modelPar_RBPBY0_dX=0.0;
modelStruct.modelPar_given_RBPBY0=mod.given("RBPBY0");
modelStruct.modelPar_RBPBYL=mod.RBPBYL;
modelStruct.d_modelPar_RBPBYL_dX=0.0;
modelStruct.modelPar_given_RBPBYL=mod.given("RBPBYL");
modelStruct.modelPar_RBPBYW=mod.RBPBYW;
modelStruct.d_modelPar_RBPBYW_dX=0.0;
modelStruct.modelPar_given_RBPBYW=mod.given("RBPBYW");
modelStruct.modelPar_RBPBYNF=mod.RBPBYNF;
modelStruct.d_modelPar_RBPBYNF_dX=0.0;
modelStruct.modelPar_given_RBPBYNF=mod.given("RBPBYNF");
modelStruct.modelPar_RBSBX0=mod.RBSBX0;
modelStruct.d_modelPar_RBSBX0_dX=0.0;
modelStruct.modelPar_given_RBSBX0=mod.given("RBSBX0");
modelStruct.modelPar_RBSBY0=mod.RBSBY0;
modelStruct.d_modelPar_RBSBY0_dX=0.0;
modelStruct.modelPar_given_RBSBY0=mod.given("RBSBY0");
modelStruct.modelPar_RBDBX0=mod.RBDBX0;
modelStruct.d_modelPar_RBDBX0_dX=0.0;
modelStruct.modelPar_given_RBDBX0=mod.given("RBDBX0");
modelStruct.modelPar_RBDBY0=mod.RBDBY0;
modelStruct.d_modelPar_RBDBY0_dX=0.0;
modelStruct.modelPar_given_RBDBY0=mod.given("RBDBY0");
modelStruct.modelPar_RBSDBXL=mod.RBSDBXL;
modelStruct.d_modelPar_RBSDBXL_dX=0.0;
modelStruct.modelPar_given_RBSDBXL=mod.given("RBSDBXL");
modelStruct.modelPar_RBSDBXW=mod.RBSDBXW;
modelStruct.d_modelPar_RBSDBXW_dX=0.0;
modelStruct.modelPar_given_RBSDBXW=mod.given("RBSDBXW");
modelStruct.modelPar_RBSDBXNF=mod.RBSDBXNF;
modelStruct.d_modelPar_RBSDBXNF_dX=0.0;
modelStruct.modelPar_given_RBSDBXNF=mod.given("RBSDBXNF");
modelStruct.modelPar_RBSDBYL=mod.RBSDBYL;
modelStruct.d_modelPar_RBSDBYL_dX=0.0;
modelStruct.modelPar_given_RBSDBYL=mod.given("RBSDBYL");
modelStruct.modelPar_RBSDBYW=mod.RBSDBYW;
modelStruct.d_modelPar_RBSDBYW_dX=0.0;
modelStruct.modelPar_given_RBSDBYW=mod.given("RBSDBYW");
modelStruct.modelPar_RBSDBYNF=mod.RBSDBYNF;
modelStruct.d_modelPar_RBSDBYNF_dX=0.0;
modelStruct.modelPar_given_RBSDBYNF=mod.given("RBSDBYNF");
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modelStruct.modelPar_EM=mod.EM;
modelStruct.d_modelPar_EM_dX=0.0;
modelStruct.modelPar_given_EM=mod.given("EM");
modelStruct.modelPar_NOIA=mod.NOIA;
modelStruct.d_modelPar_NOIA_dX=0.0;
modelStruct.modelPar_given_NOIA=mod.given("NOIA");
modelStruct.modelPar_NOIB=mod.NOIB;
modelStruct.d_modelPar_NOIB_dX=0.0;
modelStruct.modelPar_given_NOIB=mod.given("NOIB");
modelStruct.modelPar_NOIC=mod.NOIC;
modelStruct.d_modelPar_NOIC_dX=0.0;
modelStruct.modelPar_given_NOIC=mod.given("NOIC");
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modelStruct.modelPar_NTNOI=mod.NTNOI;
modelStruct.d_modelPar_NTNOI_dX=0.0;
modelStruct.modelPar_given_NTNOI=mod.given("NTNOI");
modelStruct.modelPar_RNOIA=mod.RNOIA;
modelStruct.d_modelPar_RNOIA_dX=0.0;
modelStruct.modelPar_given_RNOIA=mod.given("RNOIA");
modelStruct.modelPar_RNOIB=mod.RNOIB;
modelStruct.d_modelPar_RNOIB_dX=0.0;
modelStruct.modelPar_given_RNOIB=mod.given("RNOIB");
modelStruct.modelPar_RNOIC=mod.RNOIC;
modelStruct.d_modelPar_RNOIC_dX=0.0;
modelStruct.modelPar_given_RNOIC=mod.given("RNOIC");
modelStruct.modelPar_TNOIA=mod.TNOIA;
modelStruct.d_modelPar_TNOIA_dX=0.0;
modelStruct.modelPar_given_TNOIA=mod.given("TNOIA");
modelStruct.modelPar_TNOIB=mod.TNOIB;
modelStruct.d_modelPar_TNOIB_dX=0.0;
modelStruct.modelPar_given_TNOIB=mod.given("TNOIB");
modelStruct.modelPar_TNOIC=mod.TNOIC;
modelStruct.d_modelPar_TNOIC_dX=0.0;
modelStruct.modelPar_given_TNOIC=mod.given("TNOIC");
modelStruct.modelPar_DLBIN=mod.DLBIN;
modelStruct.d_modelPar_DLBIN_dX=0.0;
modelStruct.modelPar_given_DLBIN=mod.given("DLBIN");
modelStruct.modelPar_DWBIN=mod.DWBIN;
modelStruct.d_modelPar_DWBIN_dX=0.0;
modelStruct.modelPar_given_DWBIN=mod.given("DWBIN");
modelStruct.modelPar_TNOM=mod.TNOM;
modelStruct.d_modelPar_TNOM_dX=0.0;
modelStruct.modelPar_given_TNOM=mod.given("TNOM");
modelStruct.modelPar_DTEMP=mod.DTEMP;
modelStruct.d_modelPar_DTEMP_dX=0.0;
modelStruct.modelPar_given_DTEMP=mod.given("DTEMP");
modelStruct.modelPar_TBGASUB=mod.TBGASUB;
modelStruct.d_modelPar_TBGASUB_dX=0.0;
modelStruct.modelPar_given_TBGASUB=mod.given("TBGASUB");
modelStruct.modelPar_TBGBSUB=mod.TBGBSUB;
modelStruct.d_modelPar_TBGBSUB_dX=0.0;
modelStruct.modelPar_given_TBGBSUB=mod.given("TBGBSUB");
modelStruct.modelPar_TNFACTOR=mod.TNFACTOR;
modelStruct.d_modelPar_TNFACTOR_dX=0.0;
modelStruct.modelPar_given_TNFACTOR=mod.given("TNFACTOR");
modelStruct.modelPar_UTE=mod.UTE;
modelStruct.d_modelPar_UTE_dX=0.0;
modelStruct.modelPar_given_UTE=mod.given("UTE");
modelStruct.modelPar_LUTE=mod.LUTE;
modelStruct.d_modelPar_LUTE_dX=0.0;
modelStruct.modelPar_given_LUTE=mod.given("LUTE");
modelStruct.modelPar_WUTE=mod.WUTE;
modelStruct.d_modelPar_WUTE_dX=0.0;
modelStruct.modelPar_given_WUTE=mod.given("WUTE");
modelStruct.modelPar_PUTE=mod.PUTE;
modelStruct.d_modelPar_PUTE_dX=0.0;
modelStruct.modelPar_given_PUTE=mod.given("PUTE");
modelStruct.modelPar_UTEL=mod.UTEL;
modelStruct.d_modelPar_UTEL_dX=0.0;
modelStruct.modelPar_given_UTEL=mod.given("UTEL");
modelStruct.modelPar_UA1=mod.UA1;
modelStruct.d_modelPar_UA1_dX=0.0;
modelStruct.modelPar_given_UA1=mod.given("UA1");
modelStruct.modelPar_LUA1=mod.LUA1;
modelStruct.d_modelPar_LUA1_dX=0.0;
modelStruct.modelPar_given_LUA1=mod.given("LUA1");
modelStruct.modelPar_WUA1=mod.WUA1;
modelStruct.d_modelPar_WUA1_dX=0.0;
modelStruct.modelPar_given_WUA1=mod.given("WUA1");
modelStruct.modelPar_PUA1=mod.PUA1;
modelStruct.d_modelPar_PUA1_dX=0.0;
modelStruct.modelPar_given_PUA1=mod.given("PUA1");
modelStruct.modelPar_UA1L=mod.UA1L;
modelStruct.d_modelPar_UA1L_dX=0.0;
modelStruct.modelPar_given_UA1L=mod.given("UA1L");
modelStruct.modelPar_UC1=mod.UC1;
modelStruct.d_modelPar_UC1_dX=0.0;
modelStruct.modelPar_given_UC1=mod.given("UC1");
modelStruct.modelPar_LUC1=mod.LUC1;
modelStruct.d_modelPar_LUC1_dX=0.0;
modelStruct.modelPar_given_LUC1=mod.given("LUC1");
modelStruct.modelPar_WUC1=mod.WUC1;
modelStruct.d_modelPar_WUC1_dX=0.0;
modelStruct.modelPar_given_WUC1=mod.given("WUC1");
modelStruct.modelPar_PUC1=mod.PUC1;
modelStruct.d_modelPar_PUC1_dX=0.0;
modelStruct.modelPar_given_PUC1=mod.given("PUC1");
modelStruct.modelPar_UD1=mod.UD1;
modelStruct.d_modelPar_UD1_dX=0.0;
modelStruct.modelPar_given_UD1=mod.given("UD1");
modelStruct.modelPar_LUD1=mod.LUD1;
modelStruct.d_modelPar_LUD1_dX=0.0;
modelStruct.modelPar_given_LUD1=mod.given("LUD1");
modelStruct.modelPar_WUD1=mod.WUD1;
modelStruct.d_modelPar_WUD1_dX=0.0;
modelStruct.modelPar_given_WUD1=mod.given("WUD1");
modelStruct.modelPar_PUD1=mod.PUD1;
modelStruct.d_modelPar_PUD1_dX=0.0;
modelStruct.modelPar_given_PUD1=mod.given("PUD1");
modelStruct.modelPar_UD1L=mod.UD1L;
modelStruct.d_modelPar_UD1L_dX=0.0;
modelStruct.modelPar_given_UD1L=mod.given("UD1L");
modelStruct.modelPar_UCSTE=mod.UCSTE;
modelStruct.d_modelPar_UCSTE_dX=0.0;
modelStruct.modelPar_given_UCSTE=mod.given("UCSTE");
modelStruct.modelPar_LUCSTE=mod.LUCSTE;
modelStruct.d_modelPar_LUCSTE_dX=0.0;
modelStruct.modelPar_given_LUCSTE=mod.given("LUCSTE");
modelStruct.modelPar_WUCSTE=mod.WUCSTE;
modelStruct.d_modelPar_WUCSTE_dX=0.0;
modelStruct.modelPar_given_WUCSTE=mod.given("WUCSTE");
modelStruct.modelPar_PUCSTE=mod.PUCSTE;
modelStruct.d_modelPar_PUCSTE_dX=0.0;
modelStruct.modelPar_given_PUCSTE=mod.given("PUCSTE");
modelStruct.modelPar_TETA0=mod.TETA0;
modelStruct.d_modelPar_TETA0_dX=0.0;
modelStruct.modelPar_given_TETA0=mod.given("TETA0");
modelStruct.modelPar_PRT=mod.PRT;
modelStruct.d_modelPar_PRT_dX=0.0;
modelStruct.modelPar_given_PRT=mod.given("PRT");
modelStruct.modelPar_LPRT=mod.LPRT;
modelStruct.d_modelPar_LPRT_dX=0.0;
modelStruct.modelPar_given_LPRT=mod.given("LPRT");
modelStruct.modelPar_WPRT=mod.WPRT;
modelStruct.d_modelPar_WPRT_dX=0.0;
modelStruct.modelPar_given_WPRT=mod.given("WPRT");
modelStruct.modelPar_PPRT=mod.PPRT;
modelStruct.d_modelPar_PPRT_dX=0.0;
modelStruct.modelPar_given_PPRT=mod.given("PPRT");
modelStruct.modelPar_AT=mod.AT;
modelStruct.d_modelPar_AT_dX=0.0;
modelStruct.modelPar_given_AT=mod.given("AT");
modelStruct.modelPar_LAT=mod.LAT;
modelStruct.d_modelPar_LAT_dX=0.0;
modelStruct.modelPar_given_LAT=mod.given("LAT");
modelStruct.modelPar_WAT=mod.WAT;
modelStruct.d_modelPar_WAT_dX=0.0;
modelStruct.modelPar_given_WAT=mod.given("WAT");
modelStruct.modelPar_PAT=mod.PAT;
modelStruct.d_modelPar_PAT_dX=0.0;
modelStruct.modelPar_given_PAT=mod.given("PAT");
modelStruct.modelPar_ATL=mod.ATL;
modelStruct.d_modelPar_ATL_dX=0.0;
modelStruct.modelPar_given_ATL=mod.given("ATL");
modelStruct.modelPar_TDELTA=mod.TDELTA;
modelStruct.d_modelPar_TDELTA_dX=0.0;
modelStruct.modelPar_given_TDELTA=mod.given("TDELTA");
modelStruct.modelPar_PTWGT=mod.PTWGT;
modelStruct.d_modelPar_PTWGT_dX=0.0;
modelStruct.modelPar_given_PTWGT=mod.given("PTWGT");
modelStruct.modelPar_LPTWGT=mod.LPTWGT;
modelStruct.d_modelPar_LPTWGT_dX=0.0;
modelStruct.modelPar_given_LPTWGT=mod.given("LPTWGT");
modelStruct.modelPar_WPTWGT=mod.WPTWGT;
modelStruct.d_modelPar_WPTWGT_dX=0.0;
modelStruct.modelPar_given_WPTWGT=mod.given("WPTWGT");
modelStruct.modelPar_PPTWGT=mod.PPTWGT;
modelStruct.d_modelPar_PPTWGT_dX=0.0;
modelStruct.modelPar_given_PPTWGT=mod.given("PPTWGT");
modelStruct.modelPar_PTWGTL=mod.PTWGTL;
modelStruct.d_modelPar_PTWGTL_dX=0.0;
modelStruct.modelPar_given_PTWGTL=mod.given("PTWGTL");
modelStruct.modelPar_KT1=mod.KT1;
modelStruct.d_modelPar_KT1_dX=0.0;
modelStruct.modelPar_given_KT1=mod.given("KT1");
modelStruct.modelPar_KT1EXP=mod.KT1EXP;
modelStruct.d_modelPar_KT1EXP_dX=0.0;
modelStruct.modelPar_given_KT1EXP=mod.given("KT1EXP");
modelStruct.modelPar_KT1L=mod.KT1L;
modelStruct.d_modelPar_KT1L_dX=0.0;
modelStruct.modelPar_given_KT1L=mod.given("KT1L");
modelStruct.modelPar_LKT1=mod.LKT1;
modelStruct.d_modelPar_LKT1_dX=0.0;
modelStruct.modelPar_given_LKT1=mod.given("LKT1");
modelStruct.modelPar_WKT1=mod.WKT1;
modelStruct.d_modelPar_WKT1_dX=0.0;
modelStruct.modelPar_given_WKT1=mod.given("WKT1");
modelStruct.modelPar_PKT1=mod.PKT1;
modelStruct.d_modelPar_PKT1_dX=0.0;
modelStruct.modelPar_given_PKT1=mod.given("PKT1");
modelStruct.modelPar_KT2=mod.KT2;
modelStruct.d_modelPar_KT2_dX=0.0;
modelStruct.modelPar_given_KT2=mod.given("KT2");
modelStruct.modelPar_LKT2=mod.LKT2;
modelStruct.d_modelPar_LKT2_dX=0.0;
modelStruct.modelPar_given_LKT2=mod.given("LKT2");
modelStruct.modelPar_WKT2=mod.WKT2;
modelStruct.d_modelPar_WKT2_dX=0.0;
modelStruct.modelPar_given_WKT2=mod.given("WKT2");
modelStruct.modelPar_PKT2=mod.PKT2;
modelStruct.d_modelPar_PKT2_dX=0.0;
modelStruct.modelPar_given_PKT2=mod.given("PKT2");
modelStruct.modelPar_IIT=mod.IIT;
modelStruct.d_modelPar_IIT_dX=0.0;
modelStruct.modelPar_given_IIT=mod.given("IIT");
modelStruct.modelPar_LIIT=mod.LIIT;
modelStruct.d_modelPar_LIIT_dX=0.0;
modelStruct.modelPar_given_LIIT=mod.given("LIIT");
modelStruct.modelPar_WIIT=mod.WIIT;
modelStruct.d_modelPar_WIIT_dX=0.0;
modelStruct.modelPar_given_WIIT=mod.given("WIIT");
modelStruct.modelPar_PIIT=mod.PIIT;
modelStruct.d_modelPar_PIIT_dX=0.0;
modelStruct.modelPar_given_PIIT=mod.given("PIIT");
modelStruct.modelPar_IGT=mod.IGT;
modelStruct.d_modelPar_IGT_dX=0.0;
modelStruct.modelPar_given_IGT=mod.given("IGT");
modelStruct.modelPar_LIGT=mod.LIGT;
modelStruct.d_modelPar_LIGT_dX=0.0;
modelStruct.modelPar_given_LIGT=mod.given("LIGT");
modelStruct.modelPar_WIGT=mod.WIGT;
modelStruct.d_modelPar_WIGT_dX=0.0;
modelStruct.modelPar_given_WIGT=mod.given("WIGT");
modelStruct.modelPar_PIGT=mod.PIGT;
modelStruct.d_modelPar_PIGT_dX=0.0;
modelStruct.modelPar_given_PIGT=mod.given("PIGT");
modelStruct.modelPar_TGIDL=mod.TGIDL;
modelStruct.d_modelPar_TGIDL_dX=0.0;
modelStruct.modelPar_given_TGIDL=mod.given("TGIDL");
modelStruct.modelPar_LTGIDL=mod.LTGIDL;
modelStruct.d_modelPar_LTGIDL_dX=0.0;
modelStruct.modelPar_given_LTGIDL=mod.given("LTGIDL");
modelStruct.modelPar_WTGIDL=mod.WTGIDL;
modelStruct.d_modelPar_WTGIDL_dX=0.0;
modelStruct.modelPar_given_WTGIDL=mod.given("WTGIDL");
modelStruct.modelPar_PTGIDL=mod.PTGIDL;
modelStruct.d_modelPar_PTGIDL_dX=0.0;
modelStruct.modelPar_given_PTGIDL=mod.given("PTGIDL");
modelStruct.modelPar_TCJ=mod.TCJ;
modelStruct.d_modelPar_TCJ_dX=0.0;
modelStruct.modelPar_given_TCJ=mod.given("TCJ");
modelStruct.modelPar_TCJSW=mod.TCJSW;
modelStruct.d_modelPar_TCJSW_dX=0.0;
modelStruct.modelPar_given_TCJSW=mod.given("TCJSW");
modelStruct.modelPar_TCJSWG=mod.TCJSWG;
modelStruct.d_modelPar_TCJSWG_dX=0.0;
modelStruct.modelPar_given_TCJSWG=mod.given("TCJSWG");
modelStruct.modelPar_TPB=mod.TPB;
modelStruct.d_modelPar_TPB_dX=0.0;
modelStruct.modelPar_given_TPB=mod.given("TPB");
modelStruct.modelPar_TPBSW=mod.TPBSW;
modelStruct.d_modelPar_TPBSW_dX=0.0;
modelStruct.modelPar_given_TPBSW=mod.given("TPBSW");
modelStruct.modelPar_TPBSWG=mod.TPBSWG;
modelStruct.d_modelPar_TPBSWG_dX=0.0;
modelStruct.modelPar_given_TPBSWG=mod.given("TPBSWG");
modelStruct.modelPar_XTIS=mod.XTIS;
modelStruct.d_modelPar_XTIS_dX=0.0;
modelStruct.modelPar_given_XTIS=mod.given("XTIS");
modelStruct.modelPar_XTID=mod.XTID;
modelStruct.d_modelPar_XTID_dX=0.0;
modelStruct.modelPar_given_XTID=mod.given("XTID");
modelStruct.modelPar_XTSS=mod.XTSS;
modelStruct.d_modelPar_XTSS_dX=0.0;
modelStruct.modelPar_given_XTSS=mod.given("XTSS");
modelStruct.modelPar_XTSD=mod.XTSD;
modelStruct.d_modelPar_XTSD_dX=0.0;
modelStruct.modelPar_given_XTSD=mod.given("XTSD");
modelStruct.modelPar_XTSSWS=mod.XTSSWS;
modelStruct.d_modelPar_XTSSWS_dX=0.0;
modelStruct.modelPar_given_XTSSWS=mod.given("XTSSWS");
modelStruct.modelPar_XTSSWD=mod.XTSSWD;
modelStruct.d_modelPar_XTSSWD_dX=0.0;
modelStruct.modelPar_given_XTSSWD=mod.given("XTSSWD");
modelStruct.modelPar_XTSSWGS=mod.XTSSWGS;
modelStruct.d_modelPar_XTSSWGS_dX=0.0;
modelStruct.modelPar_given_XTSSWGS=mod.given("XTSSWGS");
modelStruct.modelPar_XTSSWGD=mod.XTSSWGD;
modelStruct.d_modelPar_XTSSWGD_dX=0.0;
modelStruct.modelPar_given_XTSSWGD=mod.given("XTSSWGD");
modelStruct.modelPar_TNJTS=mod.TNJTS;
modelStruct.d_modelPar_TNJTS_dX=0.0;
modelStruct.modelPar_given_TNJTS=mod.given("TNJTS");
modelStruct.modelPar_TNJTSD=mod.TNJTSD;
modelStruct.d_modelPar_TNJTSD_dX=0.0;
modelStruct.modelPar_given_TNJTSD=mod.given("TNJTSD");
modelStruct.modelPar_TNJTSSW=mod.TNJTSSW;
modelStruct.d_modelPar_TNJTSSW_dX=0.0;
modelStruct.modelPar_given_TNJTSSW=mod.given("TNJTSSW");
modelStruct.modelPar_TNJTSSWD=mod.TNJTSSWD;
modelStruct.d_modelPar_TNJTSSWD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
modelStruct.modelPar_TNJTSSWG=mod.TNJTSSWG;
modelStruct.d_modelPar_TNJTSSWG_dX=0.0;
modelStruct.modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
modelStruct.modelPar_TNJTSSWGD=mod.TNJTSSWGD;
modelStruct.d_modelPar_TNJTSSWGD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
modelStruct.modelPar_RTH0=mod.RTH0;
modelStruct.d_modelPar_RTH0_dX=0.0;
modelStruct.modelPar_given_RTH0=mod.given("RTH0");
modelStruct.modelPar_CTH0=mod.CTH0;
modelStruct.d_modelPar_CTH0_dX=0.0;
modelStruct.modelPar_given_CTH0=mod.given("CTH0");
modelStruct.modelPar_WTH0=mod.WTH0;
modelStruct.d_modelPar_WTH0_dX=0.0;
modelStruct.modelPar_given_WTH0=mod.given("WTH0");
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modelStruct.modelPar_KU0=mod.KU0;
modelStruct.d_modelPar_KU0_dX=0.0;
modelStruct.modelPar_given_KU0=mod.given("KU0");
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modelStruct.modelPar_TKU0=mod.TKU0;
modelStruct.d_modelPar_TKU0_dX=0.0;
modelStruct.modelPar_given_TKU0=mod.given("TKU0");
modelStruct.modelPar_LKU0=mod.LKU0;
modelStruct.d_modelPar_LKU0_dX=0.0;
modelStruct.modelPar_given_LKU0=mod.given("LKU0");
modelStruct.modelPar_WKU0=mod.WKU0;
modelStruct.d_modelPar_WKU0_dX=0.0;
modelStruct.modelPar_given_WKU0=mod.given("WKU0");
modelStruct.modelPar_PKU0=mod.PKU0;
modelStruct.d_modelPar_PKU0_dX=0.0;
modelStruct.modelPar_given_PKU0=mod.given("PKU0");
modelStruct.modelPar_LLODKU0=mod.LLODKU0;
modelStruct.d_modelPar_LLODKU0_dX=0.0;
modelStruct.modelPar_given_LLODKU0=mod.given("LLODKU0");
modelStruct.modelPar_WLODKU0=mod.WLODKU0;
modelStruct.d_modelPar_WLODKU0_dX=0.0;
modelStruct.modelPar_given_WLODKU0=mod.given("WLODKU0");
modelStruct.modelPar_KVTH0=mod.KVTH0;
modelStruct.d_modelPar_KVTH0_dX=0.0;
modelStruct.modelPar_given_KVTH0=mod.given("KVTH0");
modelStruct.modelPar_LKVTH0=mod.LKVTH0;
modelStruct.d_modelPar_LKVTH0_dX=0.0;
modelStruct.modelPar_given_LKVTH0=mod.given("LKVTH0");
modelStruct.modelPar_WKVTH0=mod.WKVTH0;
modelStruct.d_modelPar_WKVTH0_dX=0.0;
modelStruct.modelPar_given_WKVTH0=mod.given("WKVTH0");
modelStruct.modelPar_PKVTH0=mod.PKVTH0;
modelStruct.d_modelPar_PKVTH0_dX=0.0;
modelStruct.modelPar_given_PKVTH0=mod.given("PKVTH0");
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modelStruct.modelPar_STK2=mod.STK2;
modelStruct.d_modelPar_STK2_dX=0.0;
modelStruct.modelPar_given_STK2=mod.given("STK2");
modelStruct.modelPar_LODK2=mod.LODK2;
modelStruct.d_modelPar_LODK2_dX=0.0;
modelStruct.modelPar_given_LODK2=mod.given("LODK2");
modelStruct.modelPar_STETA0=mod.STETA0;
modelStruct.d_modelPar_STETA0_dX=0.0;
modelStruct.modelPar_given_STETA0=mod.given("STETA0");
modelStruct.modelPar_LODETA0=mod.LODETA0;
modelStruct.d_modelPar_LODETA0_dX=0.0;
modelStruct.modelPar_given_LODETA0=mod.given("LODETA0");
modelStruct.modelPar_WEB=mod.WEB;
modelStruct.d_modelPar_WEB_dX=0.0;
modelStruct.modelPar_given_WEB=mod.given("WEB");
modelStruct.modelPar_WEC=mod.WEC;
modelStruct.d_modelPar_WEC_dX=0.0;
modelStruct.modelPar_given_WEC=mod.given("WEC");
modelStruct.modelPar_KVTH0WE=mod.KVTH0WE;
modelStruct.d_modelPar_KVTH0WE_dX=0.0;
modelStruct.modelPar_given_KVTH0WE=mod.given("KVTH0WE");
modelStruct.modelPar_LKVTH0WE=mod.LKVTH0WE;
modelStruct.d_modelPar_LKVTH0WE_dX=0.0;
modelStruct.modelPar_given_LKVTH0WE=mod.given("LKVTH0WE");
modelStruct.modelPar_WKVTH0WE=mod.WKVTH0WE;
modelStruct.d_modelPar_WKVTH0WE_dX=0.0;
modelStruct.modelPar_given_WKVTH0WE=mod.given("WKVTH0WE");
modelStruct.modelPar_PKVTH0WE=mod.PKVTH0WE;
modelStruct.d_modelPar_PKVTH0WE_dX=0.0;
modelStruct.modelPar_given_PKVTH0WE=mod.given("PKVTH0WE");
modelStruct.modelPar_K2WE=mod.K2WE;
modelStruct.d_modelPar_K2WE_dX=0.0;
modelStruct.modelPar_given_K2WE=mod.given("K2WE");
modelStruct.modelPar_LK2WE=mod.LK2WE;
modelStruct.d_modelPar_LK2WE_dX=0.0;
modelStruct.modelPar_given_LK2WE=mod.given("LK2WE");
modelStruct.modelPar_WK2WE=mod.WK2WE;
modelStruct.d_modelPar_WK2WE_dX=0.0;
modelStruct.modelPar_given_WK2WE=mod.given("WK2WE");
modelStruct.modelPar_PK2WE=mod.PK2WE;
modelStruct.d_modelPar_PK2WE_dX=0.0;
modelStruct.modelPar_given_PK2WE=mod.given("PK2WE");
modelStruct.modelPar_KU0WE=mod.KU0WE;
modelStruct.d_modelPar_KU0WE_dX=0.0;
modelStruct.modelPar_given_KU0WE=mod.given("KU0WE");
modelStruct.modelPar_LKU0WE=mod.LKU0WE;
modelStruct.d_modelPar_LKU0WE_dX=0.0;
modelStruct.modelPar_given_LKU0WE=mod.given("LKU0WE");
modelStruct.modelPar_WKU0WE=mod.WKU0WE;
modelStruct.d_modelPar_WKU0WE_dX=0.0;
modelStruct.modelPar_given_WKU0WE=mod.given("WKU0WE");
modelStruct.modelPar_PKU0WE=mod.PKU0WE;
modelStruct.d_modelPar_PKU0WE_dX=0.0;
modelStruct.modelPar_given_PKU0WE=mod.given("PKU0WE");
modelStruct.modelPar_SCREF=mod.SCREF;
modelStruct.d_modelPar_SCREF_dX=0.0;
modelStruct.modelPar_given_SCREF=mod.given("SCREF");
modelStruct.modelPar_WEDGE=mod.WEDGE;
modelStruct.d_modelPar_WEDGE_dX=0.0;
modelStruct.modelPar_given_WEDGE=mod.given("WEDGE");
modelStruct.modelPar_DGAMMAEDGE=mod.DGAMMAEDGE;
modelStruct.d_modelPar_DGAMMAEDGE_dX=0.0;
modelStruct.modelPar_given_DGAMMAEDGE=mod.given("DGAMMAEDGE");
modelStruct.modelPar_DGAMMAEDGEL=mod.DGAMMAEDGEL;
modelStruct.d_modelPar_DGAMMAEDGEL_dX=0.0;
modelStruct.modelPar_given_DGAMMAEDGEL=mod.given("DGAMMAEDGEL");
modelStruct.modelPar_DGAMMAEDGELEXP=mod.DGAMMAEDGELEXP;
modelStruct.d_modelPar_DGAMMAEDGELEXP_dX=0.0;
modelStruct.modelPar_given_DGAMMAEDGELEXP=mod.given("DGAMMAEDGELEXP");
modelStruct.modelPar_DVTEDGE=mod.DVTEDGE;
modelStruct.d_modelPar_DVTEDGE_dX=0.0;
modelStruct.modelPar_given_DVTEDGE=mod.given("DVTEDGE");
modelStruct.modelPar_NFACTOREDGE=mod.NFACTOREDGE;
modelStruct.d_modelPar_NFACTOREDGE_dX=0.0;
modelStruct.modelPar_given_NFACTOREDGE=mod.given("NFACTOREDGE");
modelStruct.modelPar_CITEDGE=mod.CITEDGE;
modelStruct.d_modelPar_CITEDGE_dX=0.0;
modelStruct.modelPar_given_CITEDGE=mod.given("CITEDGE");
modelStruct.modelPar_CDSCDEDGE=mod.CDSCDEDGE;
modelStruct.d_modelPar_CDSCDEDGE_dX=0.0;
modelStruct.modelPar_given_CDSCDEDGE=mod.given("CDSCDEDGE");
modelStruct.modelPar_CDSCBEDGE=mod.CDSCBEDGE;
modelStruct.d_modelPar_CDSCBEDGE_dX=0.0;
modelStruct.modelPar_given_CDSCBEDGE=mod.given("CDSCBEDGE");
modelStruct.modelPar_ETA0EDGE=mod.ETA0EDGE;
modelStruct.d_modelPar_ETA0EDGE_dX=0.0;
modelStruct.modelPar_given_ETA0EDGE=mod.given("ETA0EDGE");
modelStruct.modelPar_ETABEDGE=mod.ETABEDGE;
modelStruct.d_modelPar_ETABEDGE_dX=0.0;
modelStruct.modelPar_given_ETABEDGE=mod.given("ETABEDGE");
modelStruct.modelPar_KT1EDGE=mod.KT1EDGE;
modelStruct.d_modelPar_KT1EDGE_dX=0.0;
modelStruct.modelPar_given_KT1EDGE=mod.given("KT1EDGE");
modelStruct.modelPar_KT1LEDGE=mod.KT1LEDGE;
modelStruct.d_modelPar_KT1LEDGE_dX=0.0;
modelStruct.modelPar_given_KT1LEDGE=mod.given("KT1LEDGE");
modelStruct.modelPar_KT2EDGE=mod.KT2EDGE;
modelStruct.d_modelPar_KT2EDGE_dX=0.0;
modelStruct.modelPar_given_KT2EDGE=mod.given("KT2EDGE");
modelStruct.modelPar_KT1EXPEDGE=mod.KT1EXPEDGE;
modelStruct.d_modelPar_KT1EXPEDGE_dX=0.0;
modelStruct.modelPar_given_KT1EXPEDGE=mod.given("KT1EXPEDGE");
modelStruct.modelPar_TNFACTOREDGE=mod.TNFACTOREDGE;
modelStruct.d_modelPar_TNFACTOREDGE_dX=0.0;
modelStruct.modelPar_given_TNFACTOREDGE=mod.given("TNFACTOREDGE");
modelStruct.modelPar_TETA0EDGE=mod.TETA0EDGE;
modelStruct.d_modelPar_TETA0EDGE_dX=0.0;
modelStruct.modelPar_given_TETA0EDGE=mod.given("TETA0EDGE");
modelStruct.modelPar_DVT0EDGE=mod.DVT0EDGE;
modelStruct.d_modelPar_DVT0EDGE_dX=0.0;
modelStruct.modelPar_given_DVT0EDGE=mod.given("DVT0EDGE");
modelStruct.modelPar_DVT1EDGE=mod.DVT1EDGE;
modelStruct.d_modelPar_DVT1EDGE_dX=0.0;
modelStruct.modelPar_given_DVT1EDGE=mod.given("DVT1EDGE");
modelStruct.modelPar_DVT2EDGE=mod.DVT2EDGE;
modelStruct.d_modelPar_DVT2EDGE_dX=0.0;
modelStruct.modelPar_given_DVT2EDGE=mod.given("DVT2EDGE");
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_NGCON=mod.NGCON;
modelStruct.modelPar_given_NGCON=mod.given("NGCON");
modelStruct.modelPar_RGATEMOD=mod.RGATEMOD;
modelStruct.modelPar_given_RGATEMOD=mod.given("RGATEMOD");
modelStruct.modelPar_RBODYMOD=mod.RBODYMOD;
modelStruct.modelPar_given_RBODYMOD=mod.given("RBODYMOD");
modelStruct.modelPar_GEOMOD=mod.GEOMOD;
modelStruct.modelPar_given_GEOMOD=mod.given("GEOMOD");
modelStruct.modelPar_RGEOMOD=mod.RGEOMOD;
modelStruct.modelPar_given_RGEOMOD=mod.given("RGEOMOD");
modelStruct.modelPar_SCA=mod.SCA;
modelStruct.modelPar_given_SCA=mod.given("SCA");
modelStruct.modelPar_SCB=mod.SCB;
modelStruct.modelPar_given_SCB=mod.given("SCB");
modelStruct.modelPar_SCC=mod.SCC;
modelStruct.modelPar_given_SCC=mod.given("SCC");
modelStruct.modelPar_SC=mod.SC;
modelStruct.modelPar_given_SC=mod.given("SC");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_CVMOD=mod.CVMOD;
modelStruct.modelPar_given_CVMOD=mod.given("CVMOD");
modelStruct.modelPar_COVMOD=mod.COVMOD;
modelStruct.modelPar_given_COVMOD=mod.given("COVMOD");
modelStruct.modelPar_RDSMOD=mod.RDSMOD;
modelStruct.modelPar_given_RDSMOD=mod.given("RDSMOD");
modelStruct.modelPar_WPEMOD=mod.WPEMOD;
modelStruct.modelPar_given_WPEMOD=mod.given("WPEMOD");
modelStruct.modelPar_ASYMMOD=mod.ASYMMOD;
modelStruct.modelPar_given_ASYMMOD=mod.given("ASYMMOD");
modelStruct.modelPar_GIDLMOD=mod.GIDLMOD;
modelStruct.modelPar_given_GIDLMOD=mod.given("GIDLMOD");
modelStruct.modelPar_IGCMOD=mod.IGCMOD;
modelStruct.modelPar_given_IGCMOD=mod.given("IGCMOD");
modelStruct.modelPar_IGBMOD=mod.IGBMOD;
modelStruct.modelPar_given_IGBMOD=mod.given("IGBMOD");
modelStruct.modelPar_TNOIMOD=mod.TNOIMOD;
modelStruct.modelPar_given_TNOIMOD=mod.given("TNOIMOD");
modelStruct.modelPar_SHMOD=mod.SHMOD;
modelStruct.modelPar_given_SHMOD=mod.given("SHMOD");
modelStruct.modelPar_MOBSCALE=mod.MOBSCALE;
modelStruct.modelPar_given_MOBSCALE=mod.given("MOBSCALE");
modelStruct.modelPar_PERMOD=mod.PERMOD;
modelStruct.modelPar_given_PERMOD=mod.given("PERMOD");
modelStruct.modelPar_BINUNIT=mod.BINUNIT;
modelStruct.modelPar_given_BINUNIT=mod.given("BINUNIT");
modelStruct.modelPar_EDGEFET=mod.EDGEFET;
modelStruct.modelPar_given_EDGEFET=mod.given("EDGEFET");



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
inParamMap["L"] = &(instanceStruct.d_instancePar_L_dX);
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
inParamMap["W"] = &(instanceStruct.d_instancePar_W_dX);
instanceStruct.instancePar_NRS=in.NRS;
instanceStruct.d_instancePar_NRS_dX=0.0;
instanceStruct.instancePar_given_NRS=in.given("NRS");
inParamMap["NRS"] = &(instanceStruct.d_instancePar_NRS_dX);
instanceStruct.instancePar_NRD=in.NRD;
instanceStruct.d_instancePar_NRD_dX=0.0;
instanceStruct.instancePar_given_NRD=in.given("NRD");
inParamMap["NRD"] = &(instanceStruct.d_instancePar_NRD_dX);
instanceStruct.instancePar_VFBSDOFF=in.VFBSDOFF;
instanceStruct.d_instancePar_VFBSDOFF_dX=0.0;
instanceStruct.instancePar_given_VFBSDOFF=in.given("VFBSDOFF");
inParamMap["VFBSDOFF"] = &(instanceStruct.d_instancePar_VFBSDOFF_dX);
instanceStruct.instancePar_XGW=in.XGW;
instanceStruct.d_instancePar_XGW_dX=0.0;
instanceStruct.instancePar_given_XGW=in.given("XGW");
inParamMap["XGW"] = &(instanceStruct.d_instancePar_XGW_dX);
instanceStruct.instancePar_RBPB=in.RBPB;
instanceStruct.d_instancePar_RBPB_dX=0.0;
instanceStruct.instancePar_given_RBPB=in.given("RBPB");
inParamMap["RBPB"] = &(instanceStruct.d_instancePar_RBPB_dX);
instanceStruct.instancePar_RBPD=in.RBPD;
instanceStruct.d_instancePar_RBPD_dX=0.0;
instanceStruct.instancePar_given_RBPD=in.given("RBPD");
inParamMap["RBPD"] = &(instanceStruct.d_instancePar_RBPD_dX);
instanceStruct.instancePar_RBPS=in.RBPS;
instanceStruct.d_instancePar_RBPS_dX=0.0;
instanceStruct.instancePar_given_RBPS=in.given("RBPS");
inParamMap["RBPS"] = &(instanceStruct.d_instancePar_RBPS_dX);
instanceStruct.instancePar_RBDB=in.RBDB;
instanceStruct.d_instancePar_RBDB_dX=0.0;
instanceStruct.instancePar_given_RBDB=in.given("RBDB");
inParamMap["RBDB"] = &(instanceStruct.d_instancePar_RBDB_dX);
instanceStruct.instancePar_RBSB=in.RBSB;
instanceStruct.d_instancePar_RBSB_dX=0.0;
instanceStruct.instancePar_given_RBSB=in.given("RBSB");
inParamMap["RBSB"] = &(instanceStruct.d_instancePar_RBSB_dX);
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
inParamMap["SA"] = &(instanceStruct.d_instancePar_SA_dX);
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
inParamMap["SB"] = &(instanceStruct.d_instancePar_SB_dX);
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
inParamMap["SD"] = &(instanceStruct.d_instancePar_SD_dX);
instanceStruct.instancePar_AS=in.AS;
instanceStruct.d_instancePar_AS_dX=0.0;
instanceStruct.instancePar_given_AS=in.given("AS");
inParamMap["AS"] = &(instanceStruct.d_instancePar_AS_dX);
instanceStruct.instancePar_AD=in.AD;
instanceStruct.d_instancePar_AD_dX=0.0;
instanceStruct.instancePar_given_AD=in.given("AD");
inParamMap["AD"] = &(instanceStruct.d_instancePar_AD_dX);
instanceStruct.instancePar_PS=in.PS;
instanceStruct.d_instancePar_PS_dX=0.0;
instanceStruct.instancePar_given_PS=in.given("PS");
inParamMap["PS"] = &(instanceStruct.d_instancePar_PS_dX);
instanceStruct.instancePar_PD=in.PD;
instanceStruct.d_instancePar_PD_dX=0.0;
instanceStruct.instancePar_given_PD=in.given("PD");
inParamMap["PD"] = &(instanceStruct.d_instancePar_PD_dX);
instanceStruct.instancePar_m=in.m;
instanceStruct.d_instancePar_m_dX=0.0;
instanceStruct.instancePar_given_m=in.given("m");
inParamMap["m"] = &(instanceStruct.d_instancePar_m_dX);


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_NF=in.NF;
instanceStruct.instancePar_given_NF=in.given("NF");
instanceStruct.instancePar_MINZ=in.MINZ;
instanceStruct.instancePar_given_MINZ=in.given("MINZ");
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");
instanceStruct.instancePar_RGATEMOD=in.RGATEMOD;
instanceStruct.instancePar_given_RGATEMOD=in.given("RGATEMOD");
instanceStruct.instancePar_RBODYMOD=in.RBODYMOD;
instanceStruct.instancePar_given_RBODYMOD=in.given("RBODYMOD");
instanceStruct.instancePar_GEOMOD=in.GEOMOD;
instanceStruct.instancePar_given_GEOMOD=in.given("GEOMOD");
instanceStruct.instancePar_RGEOMOD=in.RGEOMOD;
instanceStruct.instancePar_given_RGEOMOD=in.given("RGEOMOD");
instanceStruct.instancePar_SCA=in.SCA;
instanceStruct.instancePar_given_SCA=in.given("SCA");
instanceStruct.instancePar_SCB=in.SCB;
instanceStruct.instancePar_given_SCB=in.given("SCB");
instanceStruct.instancePar_SCC=in.SCC;
instanceStruct.instancePar_given_SCC=in.given("SCC");
instanceStruct.instancePar_SC=in.SC;
instanceStruct.instancePar_given_SC=in.given("SC");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals
instanceStruct.instanceVar_T0=in.T0;
instanceStruct.d_instanceVar_T0_dX=0.0;
instanceStruct.instanceVar_T1=in.T1;
instanceStruct.d_instanceVar_T1_dX=0.0;
instanceStruct.instanceVar_T2=in.T2;
instanceStruct.d_instanceVar_T2_dX=0.0;
instanceStruct.instanceVar_epssi=in.epssi;
instanceStruct.d_instanceVar_epssi_dX=0.0;
instanceStruct.instanceVar_epsox=in.epsox;
instanceStruct.d_instanceVar_epsox_dX=0.0;
instanceStruct.instanceVar_Weff=in.Weff;
instanceStruct.d_instanceVar_Weff_dX=0.0;
instanceStruct.instanceVar_Leff=in.Leff;
instanceStruct.d_instanceVar_Leff_dX=0.0;
instanceStruct.instanceVar_Wact=in.Wact;
instanceStruct.d_instanceVar_Wact_dX=0.0;
instanceStruct.instanceVar_Lact=in.Lact;
instanceStruct.d_instanceVar_Lact_dX=0.0;
instanceStruct.instanceVar_Weffcj=in.Weffcj;
instanceStruct.d_instanceVar_Weffcj_dX=0.0;
instanceStruct.instanceVar_Cox=in.Cox;
instanceStruct.d_instanceVar_Cox_dX=0.0;
instanceStruct.instanceVar_epsratio=in.epsratio;
instanceStruct.d_instanceVar_epsratio_dX=0.0;
instanceStruct.instanceVar_Lnew=in.Lnew;
instanceStruct.d_instanceVar_Lnew_dX=0.0;
instanceStruct.instanceVar_L_mult=in.L_mult;
instanceStruct.d_instanceVar_L_mult_dX=0.0;
instanceStruct.instanceVar_Wnew=in.Wnew;
instanceStruct.d_instanceVar_Wnew_dX=0.0;
instanceStruct.instanceVar_DVTP0_i=in.DVTP0_i;
instanceStruct.d_instanceVar_DVTP0_i_dX=0.0;
instanceStruct.instanceVar_DVTP1_i=in.DVTP1_i;
instanceStruct.d_instanceVar_DVTP1_i_dX=0.0;
instanceStruct.instanceVar_DVTP2_i=in.DVTP2_i;
instanceStruct.d_instanceVar_DVTP2_i_dX=0.0;
instanceStruct.instanceVar_DVTP3_i=in.DVTP3_i;
instanceStruct.d_instanceVar_DVTP3_i_dX=0.0;
instanceStruct.instanceVar_DVTP4_i=in.DVTP4_i;
instanceStruct.d_instanceVar_DVTP4_i_dX=0.0;
instanceStruct.instanceVar_DVTP5_i=in.DVTP5_i;
instanceStruct.d_instanceVar_DVTP5_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_A11_i=in.A11_i;
instanceStruct.d_instanceVar_A11_i_dX=0.0;
instanceStruct.instanceVar_A2_i=in.A2_i;
instanceStruct.d_instanceVar_A2_i_dX=0.0;
instanceStruct.instanceVar_A21_i=in.A21_i;
instanceStruct.d_instanceVar_A21_i_dX=0.0;
instanceStruct.instanceVar_PSAT_i=in.PSAT_i;
instanceStruct.d_instanceVar_PSAT_i_dX=0.0;
instanceStruct.instanceVar_PSATR_i=in.PSATR_i;
instanceStruct.d_instanceVar_PSATR_i_dX=0.0;
instanceStruct.instanceVar_BSIM6TOXP=in.BSIM6TOXP;
instanceStruct.d_instanceVar_BSIM6TOXP_dX=0.0;
instanceStruct.instanceVar_DMCGeff=in.DMCGeff;
instanceStruct.d_instanceVar_DMCGeff_dX=0.0;
instanceStruct.instanceVar_DMDGeff=in.DMDGeff;
instanceStruct.d_instanceVar_DMDGeff_dX=0.0;
instanceStruct.instanceVar_DMCIeff=in.DMCIeff;
instanceStruct.d_instanceVar_DMCIeff_dX=0.0;
instanceStruct.instanceVar_RSourceGeo=in.RSourceGeo;
instanceStruct.d_instanceVar_RSourceGeo_dX=0.0;
instanceStruct.instanceVar_RDrainGeo=in.RDrainGeo;
instanceStruct.d_instanceVar_RDrainGeo_dX=0.0;
instanceStruct.instanceVar_Grgeltd=in.Grgeltd;
instanceStruct.d_instanceVar_Grgeltd_dX=0.0;
instanceStruct.instanceVar_Grbsb=in.Grbsb;
instanceStruct.d_instanceVar_Grbsb_dX=0.0;
instanceStruct.instanceVar_Grbdb=in.Grbdb;
instanceStruct.d_instanceVar_Grbdb_dX=0.0;
instanceStruct.instanceVar_Grbpb=in.Grbpb;
instanceStruct.d_instanceVar_Grbpb_dX=0.0;
instanceStruct.instanceVar_Grbps=in.Grbps;
instanceStruct.d_instanceVar_Grbps_dX=0.0;
instanceStruct.instanceVar_Grbpd=in.Grbpd;
instanceStruct.d_instanceVar_Grbpd_dX=0.0;
instanceStruct.instanceVar_Aechvb=in.Aechvb;
instanceStruct.d_instanceVar_Aechvb_dX=0.0;
instanceStruct.instanceVar_Bechvb=in.Bechvb;
instanceStruct.d_instanceVar_Bechvb_dX=0.0;
instanceStruct.instanceVar_AechvbEdge=in.AechvbEdge;
instanceStruct.d_instanceVar_AechvbEdge_dX=0.0;
instanceStruct.instanceVar_BechvbEdge=in.BechvbEdge;
instanceStruct.d_instanceVar_BechvbEdge_dX=0.0;
instanceStruct.instanceVar_ToxRatio=in.ToxRatio;
instanceStruct.d_instanceVar_ToxRatio_dX=0.0;
instanceStruct.instanceVar_U0R_t=in.U0R_t;
instanceStruct.d_instanceVar_U0R_t_dX=0.0;
instanceStruct.instanceVar_UAR_t=in.UAR_t;
instanceStruct.d_instanceVar_UAR_t_dX=0.0;
instanceStruct.instanceVar_UCR_t=in.UCR_t;
instanceStruct.d_instanceVar_UCR_t_dX=0.0;
instanceStruct.instanceVar_UDR_t=in.UDR_t;
instanceStruct.d_instanceVar_UDR_t_dX=0.0;
instanceStruct.instanceVar_UCSR_t=in.UCSR_t;
instanceStruct.d_instanceVar_UCSR_t_dX=0.0;
instanceStruct.instanceVar_VSATR_t=in.VSATR_t;
instanceStruct.d_instanceVar_VSATR_t_dX=0.0;
instanceStruct.instanceVar_PTWGR_t=in.PTWGR_t;
instanceStruct.d_instanceVar_PTWGR_t_dX=0.0;
instanceStruct.instanceVar_ETA0R_t=in.ETA0R_t;
instanceStruct.d_instanceVar_ETA0R_t_dX=0.0;
instanceStruct.instanceVar_PSATB_i=in.PSATB_i;
instanceStruct.d_instanceVar_PSATB_i_dX=0.0;
instanceStruct.instanceVar_KT1_i=in.KT1_i;
instanceStruct.d_instanceVar_KT1_i_dX=0.0;
instanceStruct.instanceVar_KT2_i=in.KT2_i;
instanceStruct.d_instanceVar_KT2_i_dX=0.0;
instanceStruct.instanceVar_NGATE_i=in.NGATE_i;
instanceStruct.d_instanceVar_NGATE_i_dX=0.0;
instanceStruct.instanceVar_NSD_i=in.NSD_i;
instanceStruct.d_instanceVar_NSD_i_dX=0.0;
instanceStruct.instanceVar_NDEP_i=in.NDEP_i;
instanceStruct.d_instanceVar_NDEP_i_dX=0.0;
instanceStruct.instanceVar_VFB_i=in.VFB_i;
instanceStruct.d_instanceVar_VFB_i_dX=0.0;
instanceStruct.instanceVar_CIT_i=in.CIT_i;
instanceStruct.d_instanceVar_CIT_i_dX=0.0;
instanceStruct.instanceVar_CDSCD_i=in.CDSCD_i;
instanceStruct.d_instanceVar_CDSCD_i_dX=0.0;
instanceStruct.instanceVar_CDSCDR_i=in.CDSCDR_i;
instanceStruct.d_instanceVar_CDSCDR_i_dX=0.0;
instanceStruct.instanceVar_CDSCB_i=in.CDSCB_i;
instanceStruct.d_instanceVar_CDSCB_i_dX=0.0;
instanceStruct.instanceVar_NFACTOR_i=in.NFACTOR_i;
instanceStruct.d_instanceVar_NFACTOR_i_dX=0.0;
instanceStruct.instanceVar_PHIN_i=in.PHIN_i;
instanceStruct.d_instanceVar_PHIN_i_dX=0.0;
instanceStruct.instanceVar_ETA0_i=in.ETA0_i;
instanceStruct.d_instanceVar_ETA0_i_dX=0.0;
instanceStruct.instanceVar_ETA0R_i=in.ETA0R_i;
instanceStruct.d_instanceVar_ETA0R_i_dX=0.0;
instanceStruct.instanceVar_ETAB_i=in.ETAB_i;
instanceStruct.d_instanceVar_ETAB_i_dX=0.0;
instanceStruct.instanceVar_K2_i=in.K2_i;
instanceStruct.d_instanceVar_K2_i_dX=0.0;
instanceStruct.instanceVar_K1_i=in.K1_i;
instanceStruct.d_instanceVar_K1_i_dX=0.0;
instanceStruct.instanceVar_DELTA_i=in.DELTA_i;
instanceStruct.d_instanceVar_DELTA_i_dX=0.0;
instanceStruct.instanceVar_U0_i=in.U0_i;
instanceStruct.d_instanceVar_U0_i_dX=0.0;
instanceStruct.instanceVar_U0R_i=in.U0R_i;
instanceStruct.d_instanceVar_U0R_i_dX=0.0;
instanceStruct.instanceVar_VSAT_i=in.VSAT_i;
instanceStruct.d_instanceVar_VSAT_i_dX=0.0;
instanceStruct.instanceVar_VSATR_i=in.VSATR_i;
instanceStruct.d_instanceVar_VSATR_i_dX=0.0;
instanceStruct.instanceVar_VSATCV_i=in.VSATCV_i;
instanceStruct.d_instanceVar_VSATCV_i_dX=0.0;
instanceStruct.instanceVar_UA_i=in.UA_i;
instanceStruct.d_instanceVar_UA_i_dX=0.0;
instanceStruct.instanceVar_UAR_i=in.UAR_i;
instanceStruct.d_instanceVar_UAR_i_dX=0.0;
instanceStruct.instanceVar_EU_i=in.EU_i;
instanceStruct.d_instanceVar_EU_i_dX=0.0;
instanceStruct.instanceVar_UD_i=in.UD_i;
instanceStruct.d_instanceVar_UD_i_dX=0.0;
instanceStruct.instanceVar_UDR_i=in.UDR_i;
instanceStruct.d_instanceVar_UDR_i_dX=0.0;
instanceStruct.instanceVar_UD_a=in.UD_a;
instanceStruct.d_instanceVar_UD_a_dX=0.0;
instanceStruct.instanceVar_UCS_i=in.UCS_i;
instanceStruct.d_instanceVar_UCS_i_dX=0.0;
instanceStruct.instanceVar_UCSR_i=in.UCSR_i;
instanceStruct.d_instanceVar_UCSR_i_dX=0.0;
instanceStruct.instanceVar_UC_i=in.UC_i;
instanceStruct.d_instanceVar_UC_i_dX=0.0;
instanceStruct.instanceVar_UCR_i=in.UCR_i;
instanceStruct.d_instanceVar_UCR_i_dX=0.0;
instanceStruct.instanceVar_PDIBLC_i=in.PDIBLC_i;
instanceStruct.d_instanceVar_PDIBLC_i_dX=0.0;
instanceStruct.instanceVar_PDIBLCR_i=in.PDIBLCR_i;
instanceStruct.d_instanceVar_PDIBLCR_i_dX=0.0;
instanceStruct.instanceVar_PDIBLCB_i=in.PDIBLCB_i;
instanceStruct.d_instanceVar_PDIBLCB_i_dX=0.0;
instanceStruct.instanceVar_PSCBE1_i=in.PSCBE1_i;
instanceStruct.d_instanceVar_PSCBE1_i_dX=0.0;
instanceStruct.instanceVar_PSCBE2_i=in.PSCBE2_i;
instanceStruct.d_instanceVar_PSCBE2_i_dX=0.0;
instanceStruct.instanceVar_PDITS_i=in.PDITS_i;
instanceStruct.d_instanceVar_PDITS_i_dX=0.0;
instanceStruct.instanceVar_PDITSD_i=in.PDITSD_i;
instanceStruct.d_instanceVar_PDITSD_i_dX=0.0;
instanceStruct.instanceVar_FPROUT_i=in.FPROUT_i;
instanceStruct.d_instanceVar_FPROUT_i_dX=0.0;
instanceStruct.instanceVar_PRWG_i=in.PRWG_i;
instanceStruct.d_instanceVar_PRWG_i_dX=0.0;
instanceStruct.instanceVar_WR_i=in.WR_i;
instanceStruct.d_instanceVar_WR_i_dX=0.0;
instanceStruct.instanceVar_RDWMIN_i=in.RDWMIN_i;
instanceStruct.d_instanceVar_RDWMIN_i_dX=0.0;
instanceStruct.instanceVar_RSWMIN_i=in.RSWMIN_i;
instanceStruct.d_instanceVar_RSWMIN_i_dX=0.0;
instanceStruct.instanceVar_RDW_i=in.RDW_i;
instanceStruct.d_instanceVar_RDW_i_dX=0.0;
instanceStruct.instanceVar_RSW_i=in.RSW_i;
instanceStruct.d_instanceVar_RSW_i_dX=0.0;
instanceStruct.instanceVar_RDSW_i=in.RDSW_i;
instanceStruct.d_instanceVar_RDSW_i_dX=0.0;
instanceStruct.instanceVar_RDSWMIN_i=in.RDSWMIN_i;
instanceStruct.d_instanceVar_RDSWMIN_i_dX=0.0;
instanceStruct.instanceVar_PTWG_i=in.PTWG_i;
instanceStruct.d_instanceVar_PTWG_i_dX=0.0;
instanceStruct.instanceVar_PTWGR_i=in.PTWGR_i;
instanceStruct.d_instanceVar_PTWGR_i_dX=0.0;
instanceStruct.instanceVar_PVAG_i=in.PVAG_i;
instanceStruct.d_instanceVar_PVAG_i_dX=0.0;
instanceStruct.instanceVar_XJ_i=in.XJ_i;
instanceStruct.d_instanceVar_XJ_i_dX=0.0;
instanceStruct.instanceVar_PCLM_i=in.PCLM_i;
instanceStruct.d_instanceVar_PCLM_i_dX=0.0;
instanceStruct.instanceVar_PCLMR_i=in.PCLMR_i;
instanceStruct.d_instanceVar_PCLMR_i_dX=0.0;
instanceStruct.instanceVar_PCLMCV_i=in.PCLMCV_i;
instanceStruct.d_instanceVar_PCLMCV_i_dX=0.0;
instanceStruct.instanceVar_PRWB_i=in.PRWB_i;
instanceStruct.d_instanceVar_PRWB_i_dX=0.0;
instanceStruct.instanceVar_CF_i=in.CF_i;
instanceStruct.d_instanceVar_CF_i_dX=0.0;
instanceStruct.instanceVar_CGSL_i=in.CGSL_i;
instanceStruct.d_instanceVar_CGSL_i_dX=0.0;
instanceStruct.instanceVar_CGDL_i=in.CGDL_i;
instanceStruct.d_instanceVar_CGDL_i_dX=0.0;
instanceStruct.instanceVar_CKAPPAS_i=in.CKAPPAS_i;
instanceStruct.d_instanceVar_CKAPPAS_i_dX=0.0;
instanceStruct.instanceVar_CKAPPAD_i=in.CKAPPAD_i;
instanceStruct.d_instanceVar_CKAPPAD_i_dX=0.0;
instanceStruct.instanceVar_VFBCV_i=in.VFBCV_i;
instanceStruct.d_instanceVar_VFBCV_i_dX=0.0;
instanceStruct.instanceVar_NDEPCV_i=in.NDEPCV_i;
instanceStruct.d_instanceVar_NDEPCV_i_dX=0.0;
instanceStruct.instanceVar_ALPHA0_i=in.ALPHA0_i;
instanceStruct.d_instanceVar_ALPHA0_i_dX=0.0;
instanceStruct.instanceVar_BETA0_i=in.BETA0_i;
instanceStruct.d_instanceVar_BETA0_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_BGIDL_i=in.BGIDL_i;
instanceStruct.d_instanceVar_BGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_EGIDL_i=in.EGIDL_i;
instanceStruct.d_instanceVar_EGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGISL_i=in.AGISL_i;
instanceStruct.d_instanceVar_AGISL_i_dX=0.0;
instanceStruct.instanceVar_BGISL_i=in.BGISL_i;
instanceStruct.d_instanceVar_BGISL_i_dX=0.0;
instanceStruct.instanceVar_CGISL_i=in.CGISL_i;
instanceStruct.d_instanceVar_CGISL_i_dX=0.0;
instanceStruct.instanceVar_EGISL_i=in.EGISL_i;
instanceStruct.d_instanceVar_EGISL_i_dX=0.0;
instanceStruct.instanceVar_UTE_i=in.UTE_i;
instanceStruct.d_instanceVar_UTE_i_dX=0.0;
instanceStruct.instanceVar_UA1_i=in.UA1_i;
instanceStruct.d_instanceVar_UA1_i_dX=0.0;
instanceStruct.instanceVar_UC1_i=in.UC1_i;
instanceStruct.d_instanceVar_UC1_i_dX=0.0;
instanceStruct.instanceVar_UD1_i=in.UD1_i;
instanceStruct.d_instanceVar_UD1_i_dX=0.0;
instanceStruct.instanceVar_UCSTE_i=in.UCSTE_i;
instanceStruct.d_instanceVar_UCSTE_i_dX=0.0;
instanceStruct.instanceVar_PRT_i=in.PRT_i;
instanceStruct.d_instanceVar_PRT_i_dX=0.0;
instanceStruct.instanceVar_AT_i=in.AT_i;
instanceStruct.d_instanceVar_AT_i_dX=0.0;
instanceStruct.instanceVar_PTWGT_i=in.PTWGT_i;
instanceStruct.d_instanceVar_PTWGT_i_dX=0.0;
instanceStruct.instanceVar_IIT_i=in.IIT_i;
instanceStruct.d_instanceVar_IIT_i_dX=0.0;
instanceStruct.instanceVar_TGIDL_i=in.TGIDL_i;
instanceStruct.d_instanceVar_TGIDL_i_dX=0.0;
instanceStruct.instanceVar_KVTH0WE_i=in.KVTH0WE_i;
instanceStruct.d_instanceVar_KVTH0WE_i_dX=0.0;
instanceStruct.instanceVar_K2WE_i=in.K2WE_i;
instanceStruct.d_instanceVar_K2WE_i_dX=0.0;
instanceStruct.instanceVar_KU0WE_i=in.KU0WE_i;
instanceStruct.d_instanceVar_KU0WE_i_dX=0.0;
instanceStruct.instanceVar_AIGBINV_i=in.AIGBINV_i;
instanceStruct.d_instanceVar_AIGBINV_i_dX=0.0;
instanceStruct.instanceVar_BIGBINV_i=in.BIGBINV_i;
instanceStruct.d_instanceVar_BIGBINV_i_dX=0.0;
instanceStruct.instanceVar_CIGBINV_i=in.CIGBINV_i;
instanceStruct.d_instanceVar_CIGBINV_i_dX=0.0;
instanceStruct.instanceVar_EIGBINV_i=in.EIGBINV_i;
instanceStruct.d_instanceVar_EIGBINV_i_dX=0.0;
instanceStruct.instanceVar_NIGBINV_i=in.NIGBINV_i;
instanceStruct.d_instanceVar_NIGBINV_i_dX=0.0;
instanceStruct.instanceVar_AIGBACC_i=in.AIGBACC_i;
instanceStruct.d_instanceVar_AIGBACC_i_dX=0.0;
instanceStruct.instanceVar_BIGBACC_i=in.BIGBACC_i;
instanceStruct.d_instanceVar_BIGBACC_i_dX=0.0;
instanceStruct.instanceVar_CIGBACC_i=in.CIGBACC_i;
instanceStruct.d_instanceVar_CIGBACC_i_dX=0.0;
instanceStruct.instanceVar_NIGBACC_i=in.NIGBACC_i;
instanceStruct.d_instanceVar_NIGBACC_i_dX=0.0;
instanceStruct.instanceVar_AIGC_i=in.AIGC_i;
instanceStruct.d_instanceVar_AIGC_i_dX=0.0;
instanceStruct.instanceVar_BIGC_i=in.BIGC_i;
instanceStruct.d_instanceVar_BIGC_i_dX=0.0;
instanceStruct.instanceVar_CIGC_i=in.CIGC_i;
instanceStruct.d_instanceVar_CIGC_i_dX=0.0;
instanceStruct.instanceVar_AIGS_i=in.AIGS_i;
instanceStruct.d_instanceVar_AIGS_i_dX=0.0;
instanceStruct.instanceVar_BIGS_i=in.BIGS_i;
instanceStruct.d_instanceVar_BIGS_i_dX=0.0;
instanceStruct.instanceVar_CIGS_i=in.CIGS_i;
instanceStruct.d_instanceVar_CIGS_i_dX=0.0;
instanceStruct.instanceVar_AIGD_i=in.AIGD_i;
instanceStruct.d_instanceVar_AIGD_i_dX=0.0;
instanceStruct.instanceVar_BIGD_i=in.BIGD_i;
instanceStruct.d_instanceVar_BIGD_i_dX=0.0;
instanceStruct.instanceVar_CIGD_i=in.CIGD_i;
instanceStruct.d_instanceVar_CIGD_i_dX=0.0;
instanceStruct.instanceVar_PIGCD_i=in.PIGCD_i;
instanceStruct.d_instanceVar_PIGCD_i_dX=0.0;
instanceStruct.instanceVar_DLCIG_i=in.DLCIG_i;
instanceStruct.d_instanceVar_DLCIG_i_dX=0.0;
instanceStruct.instanceVar_DLCIGD_i=in.DLCIGD_i;
instanceStruct.d_instanceVar_DLCIGD_i_dX=0.0;
instanceStruct.instanceVar_IGT_i=in.IGT_i;
instanceStruct.d_instanceVar_IGT_i_dX=0.0;
instanceStruct.instanceVar_nuIntD=in.nuIntD;
instanceStruct.d_instanceVar_nuIntD_dX=0.0;
instanceStruct.instanceVar_nuEndD=in.nuEndD;
instanceStruct.instanceVar_nuIntS=in.nuIntS;
instanceStruct.d_instanceVar_nuIntS_dX=0.0;
instanceStruct.instanceVar_nuEndS=in.nuEndS;
instanceStruct.instanceVar_gth=in.gth;
instanceStruct.d_instanceVar_gth_dX=0.0;
instanceStruct.instanceVar_cth=in.cth;
instanceStruct.d_instanceVar_cth_dX=0.0;
instanceStruct.instanceVar_QSI=in.QSI;
instanceStruct.d_instanceVar_QSI_dX=0.0;
instanceStruct.instanceVar_QDI=in.QDI;
instanceStruct.d_instanceVar_QDI_dX=0.0;
instanceStruct.instanceVar_QGI=in.QGI;
instanceStruct.d_instanceVar_QGI_dX=0.0;
instanceStruct.instanceVar_ISUB=in.ISUB;
instanceStruct.d_instanceVar_ISUB_dX=0.0;
instanceStruct.instanceVar_IGIDL=in.IGIDL;
instanceStruct.d_instanceVar_IGIDL_dX=0.0;
instanceStruct.instanceVar_IGISL=in.IGISL;
instanceStruct.d_instanceVar_IGISL_dX=0.0;
instanceStruct.instanceVar_IGS=in.IGS;
instanceStruct.d_instanceVar_IGS_dX=0.0;
instanceStruct.instanceVar_IGD=in.IGD;
instanceStruct.d_instanceVar_IGD_dX=0.0;
instanceStruct.instanceVar_IGCS=in.IGCS;
instanceStruct.d_instanceVar_IGCS_dX=0.0;
instanceStruct.instanceVar_IGCD=in.IGCD;
instanceStruct.d_instanceVar_IGCD_dX=0.0;
instanceStruct.instanceVar_IGB=in.IGB;
instanceStruct.d_instanceVar_IGB_dX=0.0;


//non-reals
instanceStruct.instanceVar_devsign=in.devsign;


//make local copies of all model vars
//reals


// non-reals



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_bi_dbulk] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_dbulk];
probeVars[in.admsProbeID_V_b_dbulk] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_dbulk];
probeVars[in.admsProbeID_V_b_bi] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_b_sbulk] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_sbulk];
probeVars[in.admsProbeID_V_bi_sbulk] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_sbulk];
probeVars[in.admsProbeID_V_gm_gi] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_g_gm] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_gm];
probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_gi_si] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_dbulk_GND] = (*solVectorPtr)[in.li_dbulk];
probeVars[in.admsProbeID_V_sbulk_GND] = (*solVectorPtr)[in.li_sbulk];
probeVars[in.admsProbeID_V_gm_GND] = (*solVectorPtr)[in.li_gm];
probeVars[in.admsProbeID_V_gi_GND] = (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_bi_GND] = (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_di_GND] = (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_gm_bi] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_N1_GND] = (*solVectorPtr)[in.li_N1];
probeVars[in.admsProbeID_V_N2_GND] = (*solVectorPtr)[in.li_N2];
probeVars[in.admsProbeID_V_gm_si] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_gm_di] = (*solVectorPtr)[in.li_gm]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_dbulk_di] = (*solVectorPtr)[in.li_dbulk]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_sbulk_si] = (*solVectorPtr)[in.li_sbulk]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_si_bi] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_di_bi] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_gi_bi] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_Temp_t_GND] = (in.collapseNode_t)?(0):((*solVectorPtr)[in.li_t]);


evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_b,
in.admsNodeID_t,
in.admsNodeID_di,
in.admsNodeID_si,
in.admsNodeID_gi,
in.admsNodeID_gm,
in.admsNodeID_bi,
in.admsNodeID_sbulk,
in.admsNodeID_dbulk,
in.admsNodeID_N1,
in.admsNodeID_N2,
 in.portsConnected_,
in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_bi_dbulk,
in.admsProbeID_V_b_dbulk,
in.admsProbeID_V_b_bi,
in.admsProbeID_V_b_sbulk,
in.admsProbeID_V_bi_sbulk,
in.admsProbeID_V_gm_gi,
in.admsProbeID_V_g_gm,
in.admsProbeID_V_s_si,
in.admsProbeID_V_d_di,
in.admsProbeID_V_gi_si,
in.admsProbeID_V_di_si,
in.admsProbeID_V_dbulk_GND,
in.admsProbeID_V_sbulk_GND,
in.admsProbeID_V_gm_GND,
in.admsProbeID_V_gi_GND,
in.admsProbeID_V_bi_GND,
in.admsProbeID_V_di_GND,
in.admsProbeID_V_si_GND,
in.admsProbeID_V_gm_bi,
in.admsProbeID_V_N1_GND,
in.admsProbeID_V_N2_GND,
in.admsProbeID_V_gm_si,
in.admsProbeID_V_gm_di,
in.admsProbeID_V_dbulk_di,
in.admsProbeID_V_sbulk_si,
in.admsProbeID_V_si_bi,
in.admsProbeID_V_di_bi,
in.admsProbeID_V_gi_bi,
in.admsProbeID_Temp_t_GND,

// node constants
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_b,
in.admsNodeID_t,
in.admsNodeID_di,
in.admsNodeID_si,
in.admsNodeID_gi,
in.admsNodeID_gm,
in.admsNodeID_bi,
in.admsNodeID_sbulk,
in.admsNodeID_dbulk,
in.admsNodeID_N1,
in.admsNodeID_N2,
instanceStruct,
modelStruct,
in.portsConnected_,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d] += d_staticContributions_dX[in.admsNodeID_d];
    dqdp[in.admsNodeID_d] += d_dynamicContributions_dX[in.admsNodeID_d];
    Findices[in.admsNodeID_d] = in.li_d;
    Qindices[in.admsNodeID_d] = in.li_d;
    dfdp[in.admsNodeID_g] += d_staticContributions_dX[in.admsNodeID_g];
    dqdp[in.admsNodeID_g] += d_dynamicContributions_dX[in.admsNodeID_g];
    Findices[in.admsNodeID_g] = in.li_g;
    Qindices[in.admsNodeID_g] = in.li_g;
    dfdp[in.admsNodeID_s] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s] = in.li_s;
    Qindices[in.admsNodeID_s] = in.li_s;
    dfdp[in.admsNodeID_b] += d_staticContributions_dX[in.admsNodeID_b];
    dqdp[in.admsNodeID_b] += d_dynamicContributions_dX[in.admsNodeID_b];
    Findices[in.admsNodeID_b] = in.li_b;
    Qindices[in.admsNodeID_b] = in.li_b;
    dfdp[in.admsNodeID_t] += d_staticContributions_dX[in.admsNodeID_t];
    dqdp[in.admsNodeID_t] += d_dynamicContributions_dX[in.admsNodeID_t];
    Findices[in.admsNodeID_t] = in.li_t;
    Qindices[in.admsNodeID_t] = in.li_t;
    dfdp[in.admsNodeID_di] += d_staticContributions_dX[in.admsNodeID_di];
    dqdp[in.admsNodeID_di] += d_dynamicContributions_dX[in.admsNodeID_di];
    Findices[in.admsNodeID_di] = in.li_di;
    Qindices[in.admsNodeID_di] = in.li_di;
    dfdp[in.admsNodeID_si] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si] = in.li_si;
    Qindices[in.admsNodeID_si] = in.li_si;
    dfdp[in.admsNodeID_gi] += d_staticContributions_dX[in.admsNodeID_gi];
    dqdp[in.admsNodeID_gi] += d_dynamicContributions_dX[in.admsNodeID_gi];
    Findices[in.admsNodeID_gi] = in.li_gi;
    Qindices[in.admsNodeID_gi] = in.li_gi;
    dfdp[in.admsNodeID_gm] += d_staticContributions_dX[in.admsNodeID_gm];
    dqdp[in.admsNodeID_gm] += d_dynamicContributions_dX[in.admsNodeID_gm];
    Findices[in.admsNodeID_gm] = in.li_gm;
    Qindices[in.admsNodeID_gm] = in.li_gm;
    dfdp[in.admsNodeID_bi] += d_staticContributions_dX[in.admsNodeID_bi];
    dqdp[in.admsNodeID_bi] += d_dynamicContributions_dX[in.admsNodeID_bi];
    Findices[in.admsNodeID_bi] = in.li_bi;
    Qindices[in.admsNodeID_bi] = in.li_bi;
    dfdp[in.admsNodeID_sbulk] += d_staticContributions_dX[in.admsNodeID_sbulk];
    dqdp[in.admsNodeID_sbulk] += d_dynamicContributions_dX[in.admsNodeID_sbulk];
    Findices[in.admsNodeID_sbulk] = in.li_sbulk;
    Qindices[in.admsNodeID_sbulk] = in.li_sbulk;
    dfdp[in.admsNodeID_dbulk] += d_staticContributions_dX[in.admsNodeID_dbulk];
    dqdp[in.admsNodeID_dbulk] += d_dynamicContributions_dX[in.admsNodeID_dbulk];
    Findices[in.admsNodeID_dbulk] = in.li_dbulk;
    Qindices[in.admsNodeID_dbulk] = in.li_dbulk;
    dfdp[in.admsNodeID_N1] += d_staticContributions_dX[in.admsNodeID_N1];
    dqdp[in.admsNodeID_N1] += d_dynamicContributions_dX[in.admsNodeID_N1];
    Findices[in.admsNodeID_N1] = in.li_N1;
    Qindices[in.admsNodeID_N1] = in.li_N1;
    dfdp[in.admsNodeID_N2] += d_staticContributions_dX[in.admsNodeID_N2];
    dqdp[in.admsNodeID_N2] += d_dynamicContributions_dX[in.admsNodeID_N2];
    Findices[in.admsNodeID_N2] = in.li_N2;
    Qindices[in.admsNodeID_N2] = in.li_N2;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((14+0)*sizeInstance);
dqdp.resize((14+0)*sizeInstance);
Findices.resize((14+0)*sizeInstance);
Qindices.resize((14+0)*sizeInstance);

std::vector <double> probeVars(29);
std::vector <double> d_staticContributions_dX(14+0);
std::vector <double> d_dynamicContributions_dX(14+0);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_L=mod.L;
modelStruct.d_modelPar_L_dX=0.0;
modelStruct.modelPar_given_L=mod.given("L");
modParamMap["L"] = &(modelStruct.d_modelPar_L_dX);
modelStruct.modelPar_VFBSDOFF=mod.VFBSDOFF;
modelStruct.d_modelPar_VFBSDOFF_dX=0.0;
modelStruct.modelPar_given_VFBSDOFF=mod.given("VFBSDOFF");
modParamMap["VFBSDOFF"] = &(modelStruct.d_modelPar_VFBSDOFF_dX);
modelStruct.modelPar_XGW=mod.XGW;
modelStruct.d_modelPar_XGW_dX=0.0;
modelStruct.modelPar_given_XGW=mod.given("XGW");
modParamMap["XGW"] = &(modelStruct.d_modelPar_XGW_dX);
modelStruct.modelPar_RBPB=mod.RBPB;
modelStruct.d_modelPar_RBPB_dX=0.0;
modelStruct.modelPar_given_RBPB=mod.given("RBPB");
modParamMap["RBPB"] = &(modelStruct.d_modelPar_RBPB_dX);
modelStruct.modelPar_RBPD=mod.RBPD;
modelStruct.d_modelPar_RBPD_dX=0.0;
modelStruct.modelPar_given_RBPD=mod.given("RBPD");
modParamMap["RBPD"] = &(modelStruct.d_modelPar_RBPD_dX);
modelStruct.modelPar_RBPS=mod.RBPS;
modelStruct.d_modelPar_RBPS_dX=0.0;
modelStruct.modelPar_given_RBPS=mod.given("RBPS");
modParamMap["RBPS"] = &(modelStruct.d_modelPar_RBPS_dX);
modelStruct.modelPar_RBDB=mod.RBDB;
modelStruct.d_modelPar_RBDB_dX=0.0;
modelStruct.modelPar_given_RBDB=mod.given("RBDB");
modParamMap["RBDB"] = &(modelStruct.d_modelPar_RBDB_dX);
modelStruct.modelPar_RBSB=mod.RBSB;
modelStruct.d_modelPar_RBSB_dX=0.0;
modelStruct.modelPar_given_RBSB=mod.given("RBSB");
modParamMap["RBSB"] = &(modelStruct.d_modelPar_RBSB_dX);
modelStruct.modelPar_SA=mod.SA;
modelStruct.d_modelPar_SA_dX=0.0;
modelStruct.modelPar_given_SA=mod.given("SA");
modParamMap["SA"] = &(modelStruct.d_modelPar_SA_dX);
modelStruct.modelPar_SB=mod.SB;
modelStruct.d_modelPar_SB_dX=0.0;
modelStruct.modelPar_given_SB=mod.given("SB");
modParamMap["SB"] = &(modelStruct.d_modelPar_SB_dX);
modelStruct.modelPar_SD=mod.SD;
modelStruct.d_modelPar_SD_dX=0.0;
modelStruct.modelPar_given_SD=mod.given("SD");
modParamMap["SD"] = &(modelStruct.d_modelPar_SD_dX);
modelStruct.modelPar_LLONG=mod.LLONG;
modelStruct.d_modelPar_LLONG_dX=0.0;
modelStruct.modelPar_given_LLONG=mod.given("LLONG");
modParamMap["LLONG"] = &(modelStruct.d_modelPar_LLONG_dX);
modelStruct.modelPar_LMLT=mod.LMLT;
modelStruct.d_modelPar_LMLT_dX=0.0;
modelStruct.modelPar_given_LMLT=mod.given("LMLT");
modParamMap["LMLT"] = &(modelStruct.d_modelPar_LMLT_dX);
modelStruct.modelPar_WMLT=mod.WMLT;
modelStruct.d_modelPar_WMLT_dX=0.0;
modelStruct.modelPar_given_WMLT=mod.given("WMLT");
modParamMap["WMLT"] = &(modelStruct.d_modelPar_WMLT_dX);
modelStruct.modelPar_XL=mod.XL;
modelStruct.d_modelPar_XL_dX=0.0;
modelStruct.modelPar_given_XL=mod.given("XL");
modParamMap["XL"] = &(modelStruct.d_modelPar_XL_dX);
modelStruct.modelPar_WWIDE=mod.WWIDE;
modelStruct.d_modelPar_WWIDE_dX=0.0;
modelStruct.modelPar_given_WWIDE=mod.given("WWIDE");
modParamMap["WWIDE"] = &(modelStruct.d_modelPar_WWIDE_dX);
modelStruct.modelPar_XW=mod.XW;
modelStruct.d_modelPar_XW_dX=0.0;
modelStruct.modelPar_given_XW=mod.given("XW");
modParamMap["XW"] = &(modelStruct.d_modelPar_XW_dX);
modelStruct.modelPar_LINT=mod.LINT;
modelStruct.d_modelPar_LINT_dX=0.0;
modelStruct.modelPar_given_LINT=mod.given("LINT");
modParamMap["LINT"] = &(modelStruct.d_modelPar_LINT_dX);
modelStruct.modelPar_LL=mod.LL;
modelStruct.d_modelPar_LL_dX=0.0;
modelStruct.modelPar_given_LL=mod.given("LL");
modParamMap["LL"] = &(modelStruct.d_modelPar_LL_dX);
modelStruct.modelPar_LW=mod.LW;
modelStruct.d_modelPar_LW_dX=0.0;
modelStruct.modelPar_given_LW=mod.given("LW");
modParamMap["LW"] = &(modelStruct.d_modelPar_LW_dX);
modelStruct.modelPar_LWL=mod.LWL;
modelStruct.d_modelPar_LWL_dX=0.0;
modelStruct.modelPar_given_LWL=mod.given("LWL");
modParamMap["LWL"] = &(modelStruct.d_modelPar_LWL_dX);
modelStruct.modelPar_LLN=mod.LLN;
modelStruct.d_modelPar_LLN_dX=0.0;
modelStruct.modelPar_given_LLN=mod.given("LLN");
modParamMap["LLN"] = &(modelStruct.d_modelPar_LLN_dX);
modelStruct.modelPar_LWN=mod.LWN;
modelStruct.d_modelPar_LWN_dX=0.0;
modelStruct.modelPar_given_LWN=mod.given("LWN");
modParamMap["LWN"] = &(modelStruct.d_modelPar_LWN_dX);
modelStruct.modelPar_WINT=mod.WINT;
modelStruct.d_modelPar_WINT_dX=0.0;
modelStruct.modelPar_given_WINT=mod.given("WINT");
modParamMap["WINT"] = &(modelStruct.d_modelPar_WINT_dX);
modelStruct.modelPar_WL=mod.WL;
modelStruct.d_modelPar_WL_dX=0.0;
modelStruct.modelPar_given_WL=mod.given("WL");
modParamMap["WL"] = &(modelStruct.d_modelPar_WL_dX);
modelStruct.modelPar_WW=mod.WW;
modelStruct.d_modelPar_WW_dX=0.0;
modelStruct.modelPar_given_WW=mod.given("WW");
modParamMap["WW"] = &(modelStruct.d_modelPar_WW_dX);
modelStruct.modelPar_WWL=mod.WWL;
modelStruct.d_modelPar_WWL_dX=0.0;
modelStruct.modelPar_given_WWL=mod.given("WWL");
modParamMap["WWL"] = &(modelStruct.d_modelPar_WWL_dX);
modelStruct.modelPar_WLN=mod.WLN;
modelStruct.d_modelPar_WLN_dX=0.0;
modelStruct.modelPar_given_WLN=mod.given("WLN");
modParamMap["WLN"] = &(modelStruct.d_modelPar_WLN_dX);
modelStruct.modelPar_WWN=mod.WWN;
modelStruct.d_modelPar_WWN_dX=0.0;
modelStruct.modelPar_given_WWN=mod.given("WWN");
modParamMap["WWN"] = &(modelStruct.d_modelPar_WWN_dX);
modelStruct.modelPar_DLC=mod.DLC;
modelStruct.d_modelPar_DLC_dX=0.0;
modelStruct.modelPar_given_DLC=mod.given("DLC");
modParamMap["DLC"] = &(modelStruct.d_modelPar_DLC_dX);
modelStruct.modelPar_LLC=mod.LLC;
modelStruct.d_modelPar_LLC_dX=0.0;
modelStruct.modelPar_given_LLC=mod.given("LLC");
modParamMap["LLC"] = &(modelStruct.d_modelPar_LLC_dX);
modelStruct.modelPar_LWC=mod.LWC;
modelStruct.d_modelPar_LWC_dX=0.0;
modelStruct.modelPar_given_LWC=mod.given("LWC");
modParamMap["LWC"] = &(modelStruct.d_modelPar_LWC_dX);
modelStruct.modelPar_LWLC=mod.LWLC;
modelStruct.d_modelPar_LWLC_dX=0.0;
modelStruct.modelPar_given_LWLC=mod.given("LWLC");
modParamMap["LWLC"] = &(modelStruct.d_modelPar_LWLC_dX);
modelStruct.modelPar_DWC=mod.DWC;
modelStruct.d_modelPar_DWC_dX=0.0;
modelStruct.modelPar_given_DWC=mod.given("DWC");
modParamMap["DWC"] = &(modelStruct.d_modelPar_DWC_dX);
modelStruct.modelPar_WLC=mod.WLC;
modelStruct.d_modelPar_WLC_dX=0.0;
modelStruct.modelPar_given_WLC=mod.given("WLC");
modParamMap["WLC"] = &(modelStruct.d_modelPar_WLC_dX);
modelStruct.modelPar_WWC=mod.WWC;
modelStruct.d_modelPar_WWC_dX=0.0;
modelStruct.modelPar_given_WWC=mod.given("WWC");
modParamMap["WWC"] = &(modelStruct.d_modelPar_WWC_dX);
modelStruct.modelPar_WWLC=mod.WWLC;
modelStruct.d_modelPar_WWLC_dX=0.0;
modelStruct.modelPar_given_WWLC=mod.given("WWLC");
modParamMap["WWLC"] = &(modelStruct.d_modelPar_WWLC_dX);
modelStruct.modelPar_TOXE=mod.TOXE;
modelStruct.d_modelPar_TOXE_dX=0.0;
modelStruct.modelPar_given_TOXE=mod.given("TOXE");
modParamMap["TOXE"] = &(modelStruct.d_modelPar_TOXE_dX);
modelStruct.modelPar_TOXP=mod.TOXP;
modelStruct.d_modelPar_TOXP_dX=0.0;
modelStruct.modelPar_given_TOXP=mod.given("TOXP");
modParamMap["TOXP"] = &(modelStruct.d_modelPar_TOXP_dX);
modelStruct.modelPar_DTOX=mod.DTOX;
modelStruct.d_modelPar_DTOX_dX=0.0;
modelStruct.modelPar_given_DTOX=mod.given("DTOX");
modParamMap["DTOX"] = &(modelStruct.d_modelPar_DTOX_dX);
modelStruct.modelPar_NDEP=mod.NDEP;
modelStruct.d_modelPar_NDEP_dX=0.0;
modelStruct.modelPar_given_NDEP=mod.given("NDEP");
modParamMap["NDEP"] = &(modelStruct.d_modelPar_NDEP_dX);
modelStruct.modelPar_NDEPL1=mod.NDEPL1;
modelStruct.d_modelPar_NDEPL1_dX=0.0;
modelStruct.modelPar_given_NDEPL1=mod.given("NDEPL1");
modParamMap["NDEPL1"] = &(modelStruct.d_modelPar_NDEPL1_dX);
modelStruct.modelPar_NDEPLEXP1=mod.NDEPLEXP1;
modelStruct.d_modelPar_NDEPLEXP1_dX=0.0;
modelStruct.modelPar_given_NDEPLEXP1=mod.given("NDEPLEXP1");
modParamMap["NDEPLEXP1"] = &(modelStruct.d_modelPar_NDEPLEXP1_dX);
modelStruct.modelPar_NDEPL2=mod.NDEPL2;
modelStruct.d_modelPar_NDEPL2_dX=0.0;
modelStruct.modelPar_given_NDEPL2=mod.given("NDEPL2");
modParamMap["NDEPL2"] = &(modelStruct.d_modelPar_NDEPL2_dX);
modelStruct.modelPar_NDEPLEXP2=mod.NDEPLEXP2;
modelStruct.d_modelPar_NDEPLEXP2_dX=0.0;
modelStruct.modelPar_given_NDEPLEXP2=mod.given("NDEPLEXP2");
modParamMap["NDEPLEXP2"] = &(modelStruct.d_modelPar_NDEPLEXP2_dX);
modelStruct.modelPar_NDEPW=mod.NDEPW;
modelStruct.d_modelPar_NDEPW_dX=0.0;
modelStruct.modelPar_given_NDEPW=mod.given("NDEPW");
modParamMap["NDEPW"] = &(modelStruct.d_modelPar_NDEPW_dX);
modelStruct.modelPar_NDEPWEXP=mod.NDEPWEXP;
modelStruct.d_modelPar_NDEPWEXP_dX=0.0;
modelStruct.modelPar_given_NDEPWEXP=mod.given("NDEPWEXP");
modParamMap["NDEPWEXP"] = &(modelStruct.d_modelPar_NDEPWEXP_dX);
modelStruct.modelPar_NDEPWL=mod.NDEPWL;
modelStruct.d_modelPar_NDEPWL_dX=0.0;
modelStruct.modelPar_given_NDEPWL=mod.given("NDEPWL");
modParamMap["NDEPWL"] = &(modelStruct.d_modelPar_NDEPWL_dX);
modelStruct.modelPar_NDEPWLEXP=mod.NDEPWLEXP;
modelStruct.d_modelPar_NDEPWLEXP_dX=0.0;
modelStruct.modelPar_given_NDEPWLEXP=mod.given("NDEPWLEXP");
modParamMap["NDEPWLEXP"] = &(modelStruct.d_modelPar_NDEPWLEXP_dX);
modelStruct.modelPar_LNDEP=mod.LNDEP;
modelStruct.d_modelPar_LNDEP_dX=0.0;
modelStruct.modelPar_given_LNDEP=mod.given("LNDEP");
modParamMap["LNDEP"] = &(modelStruct.d_modelPar_LNDEP_dX);
modelStruct.modelPar_WNDEP=mod.WNDEP;
modelStruct.d_modelPar_WNDEP_dX=0.0;
modelStruct.modelPar_given_WNDEP=mod.given("WNDEP");
modParamMap["WNDEP"] = &(modelStruct.d_modelPar_WNDEP_dX);
modelStruct.modelPar_PNDEP=mod.PNDEP;
modelStruct.d_modelPar_PNDEP_dX=0.0;
modelStruct.modelPar_given_PNDEP=mod.given("PNDEP");
modParamMap["PNDEP"] = &(modelStruct.d_modelPar_PNDEP_dX);
modelStruct.modelPar_NDEPCV=mod.NDEPCV;
modelStruct.d_modelPar_NDEPCV_dX=0.0;
modelStruct.modelPar_given_NDEPCV=mod.given("NDEPCV");
modParamMap["NDEPCV"] = &(modelStruct.d_modelPar_NDEPCV_dX);
modelStruct.modelPar_NDEPCVL1=mod.NDEPCVL1;
modelStruct.d_modelPar_NDEPCVL1_dX=0.0;
modelStruct.modelPar_given_NDEPCVL1=mod.given("NDEPCVL1");
modParamMap["NDEPCVL1"] = &(modelStruct.d_modelPar_NDEPCVL1_dX);
modelStruct.modelPar_NDEPCVLEXP1=mod.NDEPCVLEXP1;
modelStruct.d_modelPar_NDEPCVLEXP1_dX=0.0;
modelStruct.modelPar_given_NDEPCVLEXP1=mod.given("NDEPCVLEXP1");
modParamMap["NDEPCVLEXP1"] = &(modelStruct.d_modelPar_NDEPCVLEXP1_dX);
modelStruct.modelPar_NDEPCVL2=mod.NDEPCVL2;
modelStruct.d_modelPar_NDEPCVL2_dX=0.0;
modelStruct.modelPar_given_NDEPCVL2=mod.given("NDEPCVL2");
modParamMap["NDEPCVL2"] = &(modelStruct.d_modelPar_NDEPCVL2_dX);
modelStruct.modelPar_NDEPCVLEXP2=mod.NDEPCVLEXP2;
modelStruct.d_modelPar_NDEPCVLEXP2_dX=0.0;
modelStruct.modelPar_given_NDEPCVLEXP2=mod.given("NDEPCVLEXP2");
modParamMap["NDEPCVLEXP2"] = &(modelStruct.d_modelPar_NDEPCVLEXP2_dX);
modelStruct.modelPar_NDEPCVW=mod.NDEPCVW;
modelStruct.d_modelPar_NDEPCVW_dX=0.0;
modelStruct.modelPar_given_NDEPCVW=mod.given("NDEPCVW");
modParamMap["NDEPCVW"] = &(modelStruct.d_modelPar_NDEPCVW_dX);
modelStruct.modelPar_NDEPCVWEXP=mod.NDEPCVWEXP;
modelStruct.d_modelPar_NDEPCVWEXP_dX=0.0;
modelStruct.modelPar_given_NDEPCVWEXP=mod.given("NDEPCVWEXP");
modParamMap["NDEPCVWEXP"] = &(modelStruct.d_modelPar_NDEPCVWEXP_dX);
modelStruct.modelPar_NDEPCVWL=mod.NDEPCVWL;
modelStruct.d_modelPar_NDEPCVWL_dX=0.0;
modelStruct.modelPar_given_NDEPCVWL=mod.given("NDEPCVWL");
modParamMap["NDEPCVWL"] = &(modelStruct.d_modelPar_NDEPCVWL_dX);
modelStruct.modelPar_NDEPCVWLEXP=mod.NDEPCVWLEXP;
modelStruct.d_modelPar_NDEPCVWLEXP_dX=0.0;
modelStruct.modelPar_given_NDEPCVWLEXP=mod.given("NDEPCVWLEXP");
modParamMap["NDEPCVWLEXP"] = &(modelStruct.d_modelPar_NDEPCVWLEXP_dX);
modelStruct.modelPar_LNDEPCV=mod.LNDEPCV;
modelStruct.d_modelPar_LNDEPCV_dX=0.0;
modelStruct.modelPar_given_LNDEPCV=mod.given("LNDEPCV");
modParamMap["LNDEPCV"] = &(modelStruct.d_modelPar_LNDEPCV_dX);
modelStruct.modelPar_WNDEPCV=mod.WNDEPCV;
modelStruct.d_modelPar_WNDEPCV_dX=0.0;
modelStruct.modelPar_given_WNDEPCV=mod.given("WNDEPCV");
modParamMap["WNDEPCV"] = &(modelStruct.d_modelPar_WNDEPCV_dX);
modelStruct.modelPar_PNDEPCV=mod.PNDEPCV;
modelStruct.d_modelPar_PNDEPCV_dX=0.0;
modelStruct.modelPar_given_PNDEPCV=mod.given("PNDEPCV");
modParamMap["PNDEPCV"] = &(modelStruct.d_modelPar_PNDEPCV_dX);
modelStruct.modelPar_NGATE=mod.NGATE;
modelStruct.d_modelPar_NGATE_dX=0.0;
modelStruct.modelPar_given_NGATE=mod.given("NGATE");
modParamMap["NGATE"] = &(modelStruct.d_modelPar_NGATE_dX);
modelStruct.modelPar_LNGATE=mod.LNGATE;
modelStruct.d_modelPar_LNGATE_dX=0.0;
modelStruct.modelPar_given_LNGATE=mod.given("LNGATE");
modParamMap["LNGATE"] = &(modelStruct.d_modelPar_LNGATE_dX);
modelStruct.modelPar_WNGATE=mod.WNGATE;
modelStruct.d_modelPar_WNGATE_dX=0.0;
modelStruct.modelPar_given_WNGATE=mod.given("WNGATE");
modParamMap["WNGATE"] = &(modelStruct.d_modelPar_WNGATE_dX);
modelStruct.modelPar_PNGATE=mod.PNGATE;
modelStruct.d_modelPar_PNGATE_dX=0.0;
modelStruct.modelPar_given_PNGATE=mod.given("PNGATE");
modParamMap["PNGATE"] = &(modelStruct.d_modelPar_PNGATE_dX);
modelStruct.modelPar_EASUB=mod.EASUB;
modelStruct.d_modelPar_EASUB_dX=0.0;
modelStruct.modelPar_given_EASUB=mod.given("EASUB");
modParamMap["EASUB"] = &(modelStruct.d_modelPar_EASUB_dX);
modelStruct.modelPar_NI0SUB=mod.NI0SUB;
modelStruct.d_modelPar_NI0SUB_dX=0.0;
modelStruct.modelPar_given_NI0SUB=mod.given("NI0SUB");
modParamMap["NI0SUB"] = &(modelStruct.d_modelPar_NI0SUB_dX);
modelStruct.modelPar_BG0SUB=mod.BG0SUB;
modelStruct.d_modelPar_BG0SUB_dX=0.0;
modelStruct.modelPar_given_BG0SUB=mod.given("BG0SUB");
modParamMap["BG0SUB"] = &(modelStruct.d_modelPar_BG0SUB_dX);
modelStruct.modelPar_EPSRSUB=mod.EPSRSUB;
modelStruct.d_modelPar_EPSRSUB_dX=0.0;
modelStruct.modelPar_given_EPSRSUB=mod.given("EPSRSUB");
modParamMap["EPSRSUB"] = &(modelStruct.d_modelPar_EPSRSUB_dX);
modelStruct.modelPar_EPSROX=mod.EPSROX;
modelStruct.d_modelPar_EPSROX_dX=0.0;
modelStruct.modelPar_given_EPSROX=mod.given("EPSROX");
modParamMap["EPSROX"] = &(modelStruct.d_modelPar_EPSROX_dX);
modelStruct.modelPar_XJ=mod.XJ;
modelStruct.d_modelPar_XJ_dX=0.0;
modelStruct.modelPar_given_XJ=mod.given("XJ");
modParamMap["XJ"] = &(modelStruct.d_modelPar_XJ_dX);
modelStruct.modelPar_LXJ=mod.LXJ;
modelStruct.d_modelPar_LXJ_dX=0.0;
modelStruct.modelPar_given_LXJ=mod.given("LXJ");
modParamMap["LXJ"] = &(modelStruct.d_modelPar_LXJ_dX);
modelStruct.modelPar_WXJ=mod.WXJ;
modelStruct.d_modelPar_WXJ_dX=0.0;
modelStruct.modelPar_given_WXJ=mod.given("WXJ");
modParamMap["WXJ"] = &(modelStruct.d_modelPar_WXJ_dX);
modelStruct.modelPar_PXJ=mod.PXJ;
modelStruct.d_modelPar_PXJ_dX=0.0;
modelStruct.modelPar_given_PXJ=mod.given("PXJ");
modParamMap["PXJ"] = &(modelStruct.d_modelPar_PXJ_dX);
modelStruct.modelPar_LVFB=mod.LVFB;
modelStruct.d_modelPar_LVFB_dX=0.0;
modelStruct.modelPar_given_LVFB=mod.given("LVFB");
modParamMap["LVFB"] = &(modelStruct.d_modelPar_LVFB_dX);
modelStruct.modelPar_WVFB=mod.WVFB;
modelStruct.d_modelPar_WVFB_dX=0.0;
modelStruct.modelPar_given_WVFB=mod.given("WVFB");
modParamMap["WVFB"] = &(modelStruct.d_modelPar_WVFB_dX);
modelStruct.modelPar_PVFB=mod.PVFB;
modelStruct.d_modelPar_PVFB_dX=0.0;
modelStruct.modelPar_given_PVFB=mod.given("PVFB");
modParamMap["PVFB"] = &(modelStruct.d_modelPar_PVFB_dX);
modelStruct.modelPar_VFB=mod.VFB;
modelStruct.d_modelPar_VFB_dX=0.0;
modelStruct.modelPar_given_VFB=mod.given("VFB");
modParamMap["VFB"] = &(modelStruct.d_modelPar_VFB_dX);
modelStruct.modelPar_VFBCV=mod.VFBCV;
modelStruct.d_modelPar_VFBCV_dX=0.0;
modelStruct.modelPar_given_VFBCV=mod.given("VFBCV");
modParamMap["VFBCV"] = &(modelStruct.d_modelPar_VFBCV_dX);
modelStruct.modelPar_LVFBCV=mod.LVFBCV;
modelStruct.d_modelPar_LVFBCV_dX=0.0;
modelStruct.modelPar_given_LVFBCV=mod.given("LVFBCV");
modParamMap["LVFBCV"] = &(modelStruct.d_modelPar_LVFBCV_dX);
modelStruct.modelPar_WVFBCV=mod.WVFBCV;
modelStruct.d_modelPar_WVFBCV_dX=0.0;
modelStruct.modelPar_given_WVFBCV=mod.given("WVFBCV");
modParamMap["WVFBCV"] = &(modelStruct.d_modelPar_WVFBCV_dX);
modelStruct.modelPar_PVFBCV=mod.PVFBCV;
modelStruct.d_modelPar_PVFBCV_dX=0.0;
modelStruct.modelPar_given_PVFBCV=mod.given("PVFBCV");
modParamMap["PVFBCV"] = &(modelStruct.d_modelPar_PVFBCV_dX);
modelStruct.modelPar_VFBCVL=mod.VFBCVL;
modelStruct.d_modelPar_VFBCVL_dX=0.0;
modelStruct.modelPar_given_VFBCVL=mod.given("VFBCVL");
modParamMap["VFBCVL"] = &(modelStruct.d_modelPar_VFBCVL_dX);
modelStruct.modelPar_VFBCVLEXP=mod.VFBCVLEXP;
modelStruct.d_modelPar_VFBCVLEXP_dX=0.0;
modelStruct.modelPar_given_VFBCVLEXP=mod.given("VFBCVLEXP");
modParamMap["VFBCVLEXP"] = &(modelStruct.d_modelPar_VFBCVLEXP_dX);
modelStruct.modelPar_VFBCVW=mod.VFBCVW;
modelStruct.d_modelPar_VFBCVW_dX=0.0;
modelStruct.modelPar_given_VFBCVW=mod.given("VFBCVW");
modParamMap["VFBCVW"] = &(modelStruct.d_modelPar_VFBCVW_dX);
modelStruct.modelPar_VFBCVWEXP=mod.VFBCVWEXP;
modelStruct.d_modelPar_VFBCVWEXP_dX=0.0;
modelStruct.modelPar_given_VFBCVWEXP=mod.given("VFBCVWEXP");
modParamMap["VFBCVWEXP"] = &(modelStruct.d_modelPar_VFBCVWEXP_dX);
modelStruct.modelPar_VFBCVWL=mod.VFBCVWL;
modelStruct.d_modelPar_VFBCVWL_dX=0.0;
modelStruct.modelPar_given_VFBCVWL=mod.given("VFBCVWL");
modParamMap["VFBCVWL"] = &(modelStruct.d_modelPar_VFBCVWL_dX);
modelStruct.modelPar_VFBCVWLEXP=mod.VFBCVWLEXP;
modelStruct.d_modelPar_VFBCVWLEXP_dX=0.0;
modelStruct.modelPar_given_VFBCVWLEXP=mod.given("VFBCVWLEXP");
modParamMap["VFBCVWLEXP"] = &(modelStruct.d_modelPar_VFBCVWLEXP_dX);
modelStruct.modelPar_DWJ=mod.DWJ;
modelStruct.d_modelPar_DWJ_dX=0.0;
modelStruct.modelPar_given_DWJ=mod.given("DWJ");
modParamMap["DWJ"] = &(modelStruct.d_modelPar_DWJ_dX);
modelStruct.modelPar_NSD=mod.NSD;
modelStruct.d_modelPar_NSD_dX=0.0;
modelStruct.modelPar_given_NSD=mod.given("NSD");
modParamMap["NSD"] = &(modelStruct.d_modelPar_NSD_dX);
modelStruct.modelPar_LNSD=mod.LNSD;
modelStruct.d_modelPar_LNSD_dX=0.0;
modelStruct.modelPar_given_LNSD=mod.given("LNSD");
modParamMap["LNSD"] = &(modelStruct.d_modelPar_LNSD_dX);
modelStruct.modelPar_WNSD=mod.WNSD;
modelStruct.d_modelPar_WNSD_dX=0.0;
modelStruct.modelPar_given_WNSD=mod.given("WNSD");
modParamMap["WNSD"] = &(modelStruct.d_modelPar_WNSD_dX);
modelStruct.modelPar_PNSD=mod.PNSD;
modelStruct.d_modelPar_PNSD_dX=0.0;
modelStruct.modelPar_given_PNSD=mod.given("PNSD");
modParamMap["PNSD"] = &(modelStruct.d_modelPar_PNSD_dX);
modelStruct.modelPar_DELVT0=mod.DELVT0;
modelStruct.d_modelPar_DELVT0_dX=0.0;
modelStruct.modelPar_given_DELVT0=mod.given("DELVT0");
modParamMap["DELVT0"] = &(modelStruct.d_modelPar_DELVT0_dX);
modelStruct.modelPar_DVTP0=mod.DVTP0;
modelStruct.d_modelPar_DVTP0_dX=0.0;
modelStruct.modelPar_given_DVTP0=mod.given("DVTP0");
modParamMap["DVTP0"] = &(modelStruct.d_modelPar_DVTP0_dX);
modelStruct.modelPar_LDVTP0=mod.LDVTP0;
modelStruct.d_modelPar_LDVTP0_dX=0.0;
modelStruct.modelPar_given_LDVTP0=mod.given("LDVTP0");
modParamMap["LDVTP0"] = &(modelStruct.d_modelPar_LDVTP0_dX);
modelStruct.modelPar_WDVTP0=mod.WDVTP0;
modelStruct.d_modelPar_WDVTP0_dX=0.0;
modelStruct.modelPar_given_WDVTP0=mod.given("WDVTP0");
modParamMap["WDVTP0"] = &(modelStruct.d_modelPar_WDVTP0_dX);
modelStruct.modelPar_PDVTP0=mod.PDVTP0;
modelStruct.d_modelPar_PDVTP0_dX=0.0;
modelStruct.modelPar_given_PDVTP0=mod.given("PDVTP0");
modParamMap["PDVTP0"] = &(modelStruct.d_modelPar_PDVTP0_dX);
modelStruct.modelPar_DVTP1=mod.DVTP1;
modelStruct.d_modelPar_DVTP1_dX=0.0;
modelStruct.modelPar_given_DVTP1=mod.given("DVTP1");
modParamMap["DVTP1"] = &(modelStruct.d_modelPar_DVTP1_dX);
modelStruct.modelPar_LDVTP1=mod.LDVTP1;
modelStruct.d_modelPar_LDVTP1_dX=0.0;
modelStruct.modelPar_given_LDVTP1=mod.given("LDVTP1");
modParamMap["LDVTP1"] = &(modelStruct.d_modelPar_LDVTP1_dX);
modelStruct.modelPar_WDVTP1=mod.WDVTP1;
modelStruct.d_modelPar_WDVTP1_dX=0.0;
modelStruct.modelPar_given_WDVTP1=mod.given("WDVTP1");
modParamMap["WDVTP1"] = &(modelStruct.d_modelPar_WDVTP1_dX);
modelStruct.modelPar_PDVTP1=mod.PDVTP1;
modelStruct.d_modelPar_PDVTP1_dX=0.0;
modelStruct.modelPar_given_PDVTP1=mod.given("PDVTP1");
modParamMap["PDVTP1"] = &(modelStruct.d_modelPar_PDVTP1_dX);
modelStruct.modelPar_DVTP2=mod.DVTP2;
modelStruct.d_modelPar_DVTP2_dX=0.0;
modelStruct.modelPar_given_DVTP2=mod.given("DVTP2");
modParamMap["DVTP2"] = &(modelStruct.d_modelPar_DVTP2_dX);
modelStruct.modelPar_LDVTP2=mod.LDVTP2;
modelStruct.d_modelPar_LDVTP2_dX=0.0;
modelStruct.modelPar_given_LDVTP2=mod.given("LDVTP2");
modParamMap["LDVTP2"] = &(modelStruct.d_modelPar_LDVTP2_dX);
modelStruct.modelPar_WDVTP2=mod.WDVTP2;
modelStruct.d_modelPar_WDVTP2_dX=0.0;
modelStruct.modelPar_given_WDVTP2=mod.given("WDVTP2");
modParamMap["WDVTP2"] = &(modelStruct.d_modelPar_WDVTP2_dX);
modelStruct.modelPar_PDVTP2=mod.PDVTP2;
modelStruct.d_modelPar_PDVTP2_dX=0.0;
modelStruct.modelPar_given_PDVTP2=mod.given("PDVTP2");
modParamMap["PDVTP2"] = &(modelStruct.d_modelPar_PDVTP2_dX);
modelStruct.modelPar_DVTP3=mod.DVTP3;
modelStruct.d_modelPar_DVTP3_dX=0.0;
modelStruct.modelPar_given_DVTP3=mod.given("DVTP3");
modParamMap["DVTP3"] = &(modelStruct.d_modelPar_DVTP3_dX);
modelStruct.modelPar_LDVTP3=mod.LDVTP3;
modelStruct.d_modelPar_LDVTP3_dX=0.0;
modelStruct.modelPar_given_LDVTP3=mod.given("LDVTP3");
modParamMap["LDVTP3"] = &(modelStruct.d_modelPar_LDVTP3_dX);
modelStruct.modelPar_WDVTP3=mod.WDVTP3;
modelStruct.d_modelPar_WDVTP3_dX=0.0;
modelStruct.modelPar_given_WDVTP3=mod.given("WDVTP3");
modParamMap["WDVTP3"] = &(modelStruct.d_modelPar_WDVTP3_dX);
modelStruct.modelPar_PDVTP3=mod.PDVTP3;
modelStruct.d_modelPar_PDVTP3_dX=0.0;
modelStruct.modelPar_given_PDVTP3=mod.given("PDVTP3");
modParamMap["PDVTP3"] = &(modelStruct.d_modelPar_PDVTP3_dX);
modelStruct.modelPar_DVTP4=mod.DVTP4;
modelStruct.d_modelPar_DVTP4_dX=0.0;
modelStruct.modelPar_given_DVTP4=mod.given("DVTP4");
modParamMap["DVTP4"] = &(modelStruct.d_modelPar_DVTP4_dX);
modelStruct.modelPar_LDVTP4=mod.LDVTP4;
modelStruct.d_modelPar_LDVTP4_dX=0.0;
modelStruct.modelPar_given_LDVTP4=mod.given("LDVTP4");
modParamMap["LDVTP4"] = &(modelStruct.d_modelPar_LDVTP4_dX);
modelStruct.modelPar_WDVTP4=mod.WDVTP4;
modelStruct.d_modelPar_WDVTP4_dX=0.0;
modelStruct.modelPar_given_WDVTP4=mod.given("WDVTP4");
modParamMap["WDVTP4"] = &(modelStruct.d_modelPar_WDVTP4_dX);
modelStruct.modelPar_PDVTP4=mod.PDVTP4;
modelStruct.d_modelPar_PDVTP4_dX=0.0;
modelStruct.modelPar_given_PDVTP4=mod.given("PDVTP4");
modParamMap["PDVTP4"] = &(modelStruct.d_modelPar_PDVTP4_dX);
modelStruct.modelPar_DVTP5=mod.DVTP5;
modelStruct.d_modelPar_DVTP5_dX=0.0;
modelStruct.modelPar_given_DVTP5=mod.given("DVTP5");
modParamMap["DVTP5"] = &(modelStruct.d_modelPar_DVTP5_dX);
modelStruct.modelPar_LDVTP5=mod.LDVTP5;
modelStruct.d_modelPar_LDVTP5_dX=0.0;
modelStruct.modelPar_given_LDVTP5=mod.given("LDVTP5");
modParamMap["LDVTP5"] = &(modelStruct.d_modelPar_LDVTP5_dX);
modelStruct.modelPar_WDVTP5=mod.WDVTP5;
modelStruct.d_modelPar_WDVTP5_dX=0.0;
modelStruct.modelPar_given_WDVTP5=mod.given("WDVTP5");
modParamMap["WDVTP5"] = &(modelStruct.d_modelPar_WDVTP5_dX);
modelStruct.modelPar_PDVTP5=mod.PDVTP5;
modelStruct.d_modelPar_PDVTP5_dX=0.0;
modelStruct.modelPar_given_PDVTP5=mod.given("PDVTP5");
modParamMap["PDVTP5"] = &(modelStruct.d_modelPar_PDVTP5_dX);
modelStruct.modelPar_PHIN=mod.PHIN;
modelStruct.d_modelPar_PHIN_dX=0.0;
modelStruct.modelPar_given_PHIN=mod.given("PHIN");
modParamMap["PHIN"] = &(modelStruct.d_modelPar_PHIN_dX);
modelStruct.modelPar_LPHIN=mod.LPHIN;
modelStruct.d_modelPar_LPHIN_dX=0.0;
modelStruct.modelPar_given_LPHIN=mod.given("LPHIN");
modParamMap["LPHIN"] = &(modelStruct.d_modelPar_LPHIN_dX);
modelStruct.modelPar_WPHIN=mod.WPHIN;
modelStruct.d_modelPar_WPHIN_dX=0.0;
modelStruct.modelPar_given_WPHIN=mod.given("WPHIN");
modParamMap["WPHIN"] = &(modelStruct.d_modelPar_WPHIN_dX);
modelStruct.modelPar_PPHIN=mod.PPHIN;
modelStruct.d_modelPar_PPHIN_dX=0.0;
modelStruct.modelPar_given_PPHIN=mod.given("PPHIN");
modParamMap["PPHIN"] = &(modelStruct.d_modelPar_PPHIN_dX);
modelStruct.modelPar_ETA0=mod.ETA0;
modelStruct.d_modelPar_ETA0_dX=0.0;
modelStruct.modelPar_given_ETA0=mod.given("ETA0");
modParamMap["ETA0"] = &(modelStruct.d_modelPar_ETA0_dX);
modelStruct.modelPar_LETA0=mod.LETA0;
modelStruct.d_modelPar_LETA0_dX=0.0;
modelStruct.modelPar_given_LETA0=mod.given("LETA0");
modParamMap["LETA0"] = &(modelStruct.d_modelPar_LETA0_dX);
modelStruct.modelPar_WETA0=mod.WETA0;
modelStruct.d_modelPar_WETA0_dX=0.0;
modelStruct.modelPar_given_WETA0=mod.given("WETA0");
modParamMap["WETA0"] = &(modelStruct.d_modelPar_WETA0_dX);
modelStruct.modelPar_PETA0=mod.PETA0;
modelStruct.d_modelPar_PETA0_dX=0.0;
modelStruct.modelPar_given_PETA0=mod.given("PETA0");
modParamMap["PETA0"] = &(modelStruct.d_modelPar_PETA0_dX);
modelStruct.modelPar_ETA0R=mod.ETA0R;
modelStruct.d_modelPar_ETA0R_dX=0.0;
modelStruct.modelPar_given_ETA0R=mod.given("ETA0R");
modParamMap["ETA0R"] = &(modelStruct.d_modelPar_ETA0R_dX);
modelStruct.modelPar_LETA0R=mod.LETA0R;
modelStruct.d_modelPar_LETA0R_dX=0.0;
modelStruct.modelPar_given_LETA0R=mod.given("LETA0R");
modParamMap["LETA0R"] = &(modelStruct.d_modelPar_LETA0R_dX);
modelStruct.modelPar_WETA0R=mod.WETA0R;
modelStruct.d_modelPar_WETA0R_dX=0.0;
modelStruct.modelPar_given_WETA0R=mod.given("WETA0R");
modParamMap["WETA0R"] = &(modelStruct.d_modelPar_WETA0R_dX);
modelStruct.modelPar_PETA0R=mod.PETA0R;
modelStruct.d_modelPar_PETA0R_dX=0.0;
modelStruct.modelPar_given_PETA0R=mod.given("PETA0R");
modParamMap["PETA0R"] = &(modelStruct.d_modelPar_PETA0R_dX);
modelStruct.modelPar_DSUB=mod.DSUB;
modelStruct.d_modelPar_DSUB_dX=0.0;
modelStruct.modelPar_given_DSUB=mod.given("DSUB");
modParamMap["DSUB"] = &(modelStruct.d_modelPar_DSUB_dX);
modelStruct.modelPar_ETAB=mod.ETAB;
modelStruct.d_modelPar_ETAB_dX=0.0;
modelStruct.modelPar_given_ETAB=mod.given("ETAB");
modParamMap["ETAB"] = &(modelStruct.d_modelPar_ETAB_dX);
modelStruct.modelPar_ETABEXP=mod.ETABEXP;
modelStruct.d_modelPar_ETABEXP_dX=0.0;
modelStruct.modelPar_given_ETABEXP=mod.given("ETABEXP");
modParamMap["ETABEXP"] = &(modelStruct.d_modelPar_ETABEXP_dX);
modelStruct.modelPar_LETAB=mod.LETAB;
modelStruct.d_modelPar_LETAB_dX=0.0;
modelStruct.modelPar_given_LETAB=mod.given("LETAB");
modParamMap["LETAB"] = &(modelStruct.d_modelPar_LETAB_dX);
modelStruct.modelPar_WETAB=mod.WETAB;
modelStruct.d_modelPar_WETAB_dX=0.0;
modelStruct.modelPar_given_WETAB=mod.given("WETAB");
modParamMap["WETAB"] = &(modelStruct.d_modelPar_WETAB_dX);
modelStruct.modelPar_PETAB=mod.PETAB;
modelStruct.d_modelPar_PETAB_dX=0.0;
modelStruct.modelPar_given_PETAB=mod.given("PETAB");
modParamMap["PETAB"] = &(modelStruct.d_modelPar_PETAB_dX);
modelStruct.modelPar_K1=mod.K1;
modelStruct.d_modelPar_K1_dX=0.0;
modelStruct.modelPar_given_K1=mod.given("K1");
modParamMap["K1"] = &(modelStruct.d_modelPar_K1_dX);
modelStruct.modelPar_K1L=mod.K1L;
modelStruct.d_modelPar_K1L_dX=0.0;
modelStruct.modelPar_given_K1L=mod.given("K1L");
modParamMap["K1L"] = &(modelStruct.d_modelPar_K1L_dX);
modelStruct.modelPar_K1LEXP=mod.K1LEXP;
modelStruct.d_modelPar_K1LEXP_dX=0.0;
modelStruct.modelPar_given_K1LEXP=mod.given("K1LEXP");
modParamMap["K1LEXP"] = &(modelStruct.d_modelPar_K1LEXP_dX);
modelStruct.modelPar_K1W=mod.K1W;
modelStruct.d_modelPar_K1W_dX=0.0;
modelStruct.modelPar_given_K1W=mod.given("K1W");
modParamMap["K1W"] = &(modelStruct.d_modelPar_K1W_dX);
modelStruct.modelPar_K1WEXP=mod.K1WEXP;
modelStruct.d_modelPar_K1WEXP_dX=0.0;
modelStruct.modelPar_given_K1WEXP=mod.given("K1WEXP");
modParamMap["K1WEXP"] = &(modelStruct.d_modelPar_K1WEXP_dX);
modelStruct.modelPar_K1WL=mod.K1WL;
modelStruct.d_modelPar_K1WL_dX=0.0;
modelStruct.modelPar_given_K1WL=mod.given("K1WL");
modParamMap["K1WL"] = &(modelStruct.d_modelPar_K1WL_dX);
modelStruct.modelPar_K1WLEXP=mod.K1WLEXP;
modelStruct.d_modelPar_K1WLEXP_dX=0.0;
modelStruct.modelPar_given_K1WLEXP=mod.given("K1WLEXP");
modParamMap["K1WLEXP"] = &(modelStruct.d_modelPar_K1WLEXP_dX);
modelStruct.modelPar_LK1=mod.LK1;
modelStruct.d_modelPar_LK1_dX=0.0;
modelStruct.modelPar_given_LK1=mod.given("LK1");
modParamMap["LK1"] = &(modelStruct.d_modelPar_LK1_dX);
modelStruct.modelPar_WK1=mod.WK1;
modelStruct.d_modelPar_WK1_dX=0.0;
modelStruct.modelPar_given_WK1=mod.given("WK1");
modParamMap["WK1"] = &(modelStruct.d_modelPar_WK1_dX);
modelStruct.modelPar_PK1=mod.PK1;
modelStruct.d_modelPar_PK1_dX=0.0;
modelStruct.modelPar_given_PK1=mod.given("PK1");
modParamMap["PK1"] = &(modelStruct.d_modelPar_PK1_dX);
modelStruct.modelPar_K2=mod.K2;
modelStruct.d_modelPar_K2_dX=0.0;
modelStruct.modelPar_given_K2=mod.given("K2");
modParamMap["K2"] = &(modelStruct.d_modelPar_K2_dX);
modelStruct.modelPar_K2L=mod.K2L;
modelStruct.d_modelPar_K2L_dX=0.0;
modelStruct.modelPar_given_K2L=mod.given("K2L");
modParamMap["K2L"] = &(modelStruct.d_modelPar_K2L_dX);
modelStruct.modelPar_K2LEXP=mod.K2LEXP;
modelStruct.d_modelPar_K2LEXP_dX=0.0;
modelStruct.modelPar_given_K2LEXP=mod.given("K2LEXP");
modParamMap["K2LEXP"] = &(modelStruct.d_modelPar_K2LEXP_dX);
modelStruct.modelPar_K2W=mod.K2W;
modelStruct.d_modelPar_K2W_dX=0.0;
modelStruct.modelPar_given_K2W=mod.given("K2W");
modParamMap["K2W"] = &(modelStruct.d_modelPar_K2W_dX);
modelStruct.modelPar_K2WEXP=mod.K2WEXP;
modelStruct.d_modelPar_K2WEXP_dX=0.0;
modelStruct.modelPar_given_K2WEXP=mod.given("K2WEXP");
modParamMap["K2WEXP"] = &(modelStruct.d_modelPar_K2WEXP_dX);
modelStruct.modelPar_K2WL=mod.K2WL;
modelStruct.d_modelPar_K2WL_dX=0.0;
modelStruct.modelPar_given_K2WL=mod.given("K2WL");
modParamMap["K2WL"] = &(modelStruct.d_modelPar_K2WL_dX);
modelStruct.modelPar_K2WLEXP=mod.K2WLEXP;
modelStruct.d_modelPar_K2WLEXP_dX=0.0;
modelStruct.modelPar_given_K2WLEXP=mod.given("K2WLEXP");
modParamMap["K2WLEXP"] = &(modelStruct.d_modelPar_K2WLEXP_dX);
modelStruct.modelPar_LK2=mod.LK2;
modelStruct.d_modelPar_LK2_dX=0.0;
modelStruct.modelPar_given_LK2=mod.given("LK2");
modParamMap["LK2"] = &(modelStruct.d_modelPar_LK2_dX);
modelStruct.modelPar_WK2=mod.WK2;
modelStruct.d_modelPar_WK2_dX=0.0;
modelStruct.modelPar_given_WK2=mod.given("WK2");
modParamMap["WK2"] = &(modelStruct.d_modelPar_WK2_dX);
modelStruct.modelPar_PK2=mod.PK2;
modelStruct.d_modelPar_PK2_dX=0.0;
modelStruct.modelPar_given_PK2=mod.given("PK2");
modParamMap["PK2"] = &(modelStruct.d_modelPar_PK2_dX);
modelStruct.modelPar_ADOS=mod.ADOS;
modelStruct.d_modelPar_ADOS_dX=0.0;
modelStruct.modelPar_given_ADOS=mod.given("ADOS");
modParamMap["ADOS"] = &(modelStruct.d_modelPar_ADOS_dX);
modelStruct.modelPar_BDOS=mod.BDOS;
modelStruct.d_modelPar_BDOS_dX=0.0;
modelStruct.modelPar_given_BDOS=mod.given("BDOS");
modParamMap["BDOS"] = &(modelStruct.d_modelPar_BDOS_dX);
modelStruct.modelPar_QM0=mod.QM0;
modelStruct.d_modelPar_QM0_dX=0.0;
modelStruct.modelPar_given_QM0=mod.given("QM0");
modParamMap["QM0"] = &(modelStruct.d_modelPar_QM0_dX);
modelStruct.modelPar_ETAQM=mod.ETAQM;
modelStruct.d_modelPar_ETAQM_dX=0.0;
modelStruct.modelPar_given_ETAQM=mod.given("ETAQM");
modParamMap["ETAQM"] = &(modelStruct.d_modelPar_ETAQM_dX);
modelStruct.modelPar_CIT=mod.CIT;
modelStruct.d_modelPar_CIT_dX=0.0;
modelStruct.modelPar_given_CIT=mod.given("CIT");
modParamMap["CIT"] = &(modelStruct.d_modelPar_CIT_dX);
modelStruct.modelPar_LCIT=mod.LCIT;
modelStruct.d_modelPar_LCIT_dX=0.0;
modelStruct.modelPar_given_LCIT=mod.given("LCIT");
modParamMap["LCIT"] = &(modelStruct.d_modelPar_LCIT_dX);
modelStruct.modelPar_WCIT=mod.WCIT;
modelStruct.d_modelPar_WCIT_dX=0.0;
modelStruct.modelPar_given_WCIT=mod.given("WCIT");
modParamMap["WCIT"] = &(modelStruct.d_modelPar_WCIT_dX);
modelStruct.modelPar_PCIT=mod.PCIT;
modelStruct.d_modelPar_PCIT_dX=0.0;
modelStruct.modelPar_given_PCIT=mod.given("PCIT");
modParamMap["PCIT"] = &(modelStruct.d_modelPar_PCIT_dX);
modelStruct.modelPar_NFACTOR=mod.NFACTOR;
modelStruct.d_modelPar_NFACTOR_dX=0.0;
modelStruct.modelPar_given_NFACTOR=mod.given("NFACTOR");
modParamMap["NFACTOR"] = &(modelStruct.d_modelPar_NFACTOR_dX);
modelStruct.modelPar_NFACTORL=mod.NFACTORL;
modelStruct.d_modelPar_NFACTORL_dX=0.0;
modelStruct.modelPar_given_NFACTORL=mod.given("NFACTORL");
modParamMap["NFACTORL"] = &(modelStruct.d_modelPar_NFACTORL_dX);
modelStruct.modelPar_NFACTORLEXP=mod.NFACTORLEXP;
modelStruct.d_modelPar_NFACTORLEXP_dX=0.0;
modelStruct.modelPar_given_NFACTORLEXP=mod.given("NFACTORLEXP");
modParamMap["NFACTORLEXP"] = &(modelStruct.d_modelPar_NFACTORLEXP_dX);
modelStruct.modelPar_NFACTORW=mod.NFACTORW;
modelStruct.d_modelPar_NFACTORW_dX=0.0;
modelStruct.modelPar_given_NFACTORW=mod.given("NFACTORW");
modParamMap["NFACTORW"] = &(modelStruct.d_modelPar_NFACTORW_dX);
modelStruct.modelPar_NFACTORWEXP=mod.NFACTORWEXP;
modelStruct.d_modelPar_NFACTORWEXP_dX=0.0;
modelStruct.modelPar_given_NFACTORWEXP=mod.given("NFACTORWEXP");
modParamMap["NFACTORWEXP"] = &(modelStruct.d_modelPar_NFACTORWEXP_dX);
modelStruct.modelPar_NFACTORWL=mod.NFACTORWL;
modelStruct.d_modelPar_NFACTORWL_dX=0.0;
modelStruct.modelPar_given_NFACTORWL=mod.given("NFACTORWL");
modParamMap["NFACTORWL"] = &(modelStruct.d_modelPar_NFACTORWL_dX);
modelStruct.modelPar_NFACTORWLEXP=mod.NFACTORWLEXP;
modelStruct.d_modelPar_NFACTORWLEXP_dX=0.0;
modelStruct.modelPar_given_NFACTORWLEXP=mod.given("NFACTORWLEXP");
modParamMap["NFACTORWLEXP"] = &(modelStruct.d_modelPar_NFACTORWLEXP_dX);
modelStruct.modelPar_LNFACTOR=mod.LNFACTOR;
modelStruct.d_modelPar_LNFACTOR_dX=0.0;
modelStruct.modelPar_given_LNFACTOR=mod.given("LNFACTOR");
modParamMap["LNFACTOR"] = &(modelStruct.d_modelPar_LNFACTOR_dX);
modelStruct.modelPar_WNFACTOR=mod.WNFACTOR;
modelStruct.d_modelPar_WNFACTOR_dX=0.0;
modelStruct.modelPar_given_WNFACTOR=mod.given("WNFACTOR");
modParamMap["WNFACTOR"] = &(modelStruct.d_modelPar_WNFACTOR_dX);
modelStruct.modelPar_PNFACTOR=mod.PNFACTOR;
modelStruct.d_modelPar_PNFACTOR_dX=0.0;
modelStruct.modelPar_given_PNFACTOR=mod.given("PNFACTOR");
modParamMap["PNFACTOR"] = &(modelStruct.d_modelPar_PNFACTOR_dX);
modelStruct.modelPar_CDSCD=mod.CDSCD;
modelStruct.d_modelPar_CDSCD_dX=0.0;
modelStruct.modelPar_given_CDSCD=mod.given("CDSCD");
modParamMap["CDSCD"] = &(modelStruct.d_modelPar_CDSCD_dX);
modelStruct.modelPar_CDSCDL=mod.CDSCDL;
modelStruct.d_modelPar_CDSCDL_dX=0.0;
modelStruct.modelPar_given_CDSCDL=mod.given("CDSCDL");
modParamMap["CDSCDL"] = &(modelStruct.d_modelPar_CDSCDL_dX);
modelStruct.modelPar_CDSCDLEXP=mod.CDSCDLEXP;
modelStruct.d_modelPar_CDSCDLEXP_dX=0.0;
modelStruct.modelPar_given_CDSCDLEXP=mod.given("CDSCDLEXP");
modParamMap["CDSCDLEXP"] = &(modelStruct.d_modelPar_CDSCDLEXP_dX);
modelStruct.modelPar_LCDSCD=mod.LCDSCD;
modelStruct.d_modelPar_LCDSCD_dX=0.0;
modelStruct.modelPar_given_LCDSCD=mod.given("LCDSCD");
modParamMap["LCDSCD"] = &(modelStruct.d_modelPar_LCDSCD_dX);
modelStruct.modelPar_WCDSCD=mod.WCDSCD;
modelStruct.d_modelPar_WCDSCD_dX=0.0;
modelStruct.modelPar_given_WCDSCD=mod.given("WCDSCD");
modParamMap["WCDSCD"] = &(modelStruct.d_modelPar_WCDSCD_dX);
modelStruct.modelPar_PCDSCD=mod.PCDSCD;
modelStruct.d_modelPar_PCDSCD_dX=0.0;
modelStruct.modelPar_given_PCDSCD=mod.given("PCDSCD");
modParamMap["PCDSCD"] = &(modelStruct.d_modelPar_PCDSCD_dX);
modelStruct.modelPar_CDSCDR=mod.CDSCDR;
modelStruct.d_modelPar_CDSCDR_dX=0.0;
modelStruct.modelPar_given_CDSCDR=mod.given("CDSCDR");
modParamMap["CDSCDR"] = &(modelStruct.d_modelPar_CDSCDR_dX);
modelStruct.modelPar_CDSCDLR=mod.CDSCDLR;
modelStruct.d_modelPar_CDSCDLR_dX=0.0;
modelStruct.modelPar_given_CDSCDLR=mod.given("CDSCDLR");
modParamMap["CDSCDLR"] = &(modelStruct.d_modelPar_CDSCDLR_dX);
modelStruct.modelPar_LCDSCDR=mod.LCDSCDR;
modelStruct.d_modelPar_LCDSCDR_dX=0.0;
modelStruct.modelPar_given_LCDSCDR=mod.given("LCDSCDR");
modParamMap["LCDSCDR"] = &(modelStruct.d_modelPar_LCDSCDR_dX);
modelStruct.modelPar_WCDSCDR=mod.WCDSCDR;
modelStruct.d_modelPar_WCDSCDR_dX=0.0;
modelStruct.modelPar_given_WCDSCDR=mod.given("WCDSCDR");
modParamMap["WCDSCDR"] = &(modelStruct.d_modelPar_WCDSCDR_dX);
modelStruct.modelPar_PCDSCDR=mod.PCDSCDR;
modelStruct.d_modelPar_PCDSCDR_dX=0.0;
modelStruct.modelPar_given_PCDSCDR=mod.given("PCDSCDR");
modParamMap["PCDSCDR"] = &(modelStruct.d_modelPar_PCDSCDR_dX);
modelStruct.modelPar_CDSCB=mod.CDSCB;
modelStruct.d_modelPar_CDSCB_dX=0.0;
modelStruct.modelPar_given_CDSCB=mod.given("CDSCB");
modParamMap["CDSCB"] = &(modelStruct.d_modelPar_CDSCB_dX);
modelStruct.modelPar_CDSCBL=mod.CDSCBL;
modelStruct.d_modelPar_CDSCBL_dX=0.0;
modelStruct.modelPar_given_CDSCBL=mod.given("CDSCBL");
modParamMap["CDSCBL"] = &(modelStruct.d_modelPar_CDSCBL_dX);
modelStruct.modelPar_CDSCBLEXP=mod.CDSCBLEXP;
modelStruct.d_modelPar_CDSCBLEXP_dX=0.0;
modelStruct.modelPar_given_CDSCBLEXP=mod.given("CDSCBLEXP");
modParamMap["CDSCBLEXP"] = &(modelStruct.d_modelPar_CDSCBLEXP_dX);
modelStruct.modelPar_LCDSCB=mod.LCDSCB;
modelStruct.d_modelPar_LCDSCB_dX=0.0;
modelStruct.modelPar_given_LCDSCB=mod.given("LCDSCB");
modParamMap["LCDSCB"] = &(modelStruct.d_modelPar_LCDSCB_dX);
modelStruct.modelPar_WCDSCB=mod.WCDSCB;
modelStruct.d_modelPar_WCDSCB_dX=0.0;
modelStruct.modelPar_given_WCDSCB=mod.given("WCDSCB");
modParamMap["WCDSCB"] = &(modelStruct.d_modelPar_WCDSCB_dX);
modelStruct.modelPar_PCDSCB=mod.PCDSCB;
modelStruct.d_modelPar_PCDSCB_dX=0.0;
modelStruct.modelPar_given_PCDSCB=mod.given("PCDSCB");
modParamMap["PCDSCB"] = &(modelStruct.d_modelPar_PCDSCB_dX);
modelStruct.modelPar_VSAT=mod.VSAT;
modelStruct.d_modelPar_VSAT_dX=0.0;
modelStruct.modelPar_given_VSAT=mod.given("VSAT");
modParamMap["VSAT"] = &(modelStruct.d_modelPar_VSAT_dX);
modelStruct.modelPar_LVSAT=mod.LVSAT;
modelStruct.d_modelPar_LVSAT_dX=0.0;
modelStruct.modelPar_given_LVSAT=mod.given("LVSAT");
modParamMap["LVSAT"] = &(modelStruct.d_modelPar_LVSAT_dX);
modelStruct.modelPar_WVSAT=mod.WVSAT;
modelStruct.d_modelPar_WVSAT_dX=0.0;
modelStruct.modelPar_given_WVSAT=mod.given("WVSAT");
modParamMap["WVSAT"] = &(modelStruct.d_modelPar_WVSAT_dX);
modelStruct.modelPar_PVSAT=mod.PVSAT;
modelStruct.d_modelPar_PVSAT_dX=0.0;
modelStruct.modelPar_given_PVSAT=mod.given("PVSAT");
modParamMap["PVSAT"] = &(modelStruct.d_modelPar_PVSAT_dX);
modelStruct.modelPar_VSATL=mod.VSATL;
modelStruct.d_modelPar_VSATL_dX=0.0;
modelStruct.modelPar_given_VSATL=mod.given("VSATL");
modParamMap["VSATL"] = &(modelStruct.d_modelPar_VSATL_dX);
modelStruct.modelPar_VSATLEXP=mod.VSATLEXP;
modelStruct.d_modelPar_VSATLEXP_dX=0.0;
modelStruct.modelPar_given_VSATLEXP=mod.given("VSATLEXP");
modParamMap["VSATLEXP"] = &(modelStruct.d_modelPar_VSATLEXP_dX);
modelStruct.modelPar_VSATW=mod.VSATW;
modelStruct.d_modelPar_VSATW_dX=0.0;
modelStruct.modelPar_given_VSATW=mod.given("VSATW");
modParamMap["VSATW"] = &(modelStruct.d_modelPar_VSATW_dX);
modelStruct.modelPar_VSATWEXP=mod.VSATWEXP;
modelStruct.d_modelPar_VSATWEXP_dX=0.0;
modelStruct.modelPar_given_VSATWEXP=mod.given("VSATWEXP");
modParamMap["VSATWEXP"] = &(modelStruct.d_modelPar_VSATWEXP_dX);
modelStruct.modelPar_VSATWL=mod.VSATWL;
modelStruct.d_modelPar_VSATWL_dX=0.0;
modelStruct.modelPar_given_VSATWL=mod.given("VSATWL");
modParamMap["VSATWL"] = &(modelStruct.d_modelPar_VSATWL_dX);
modelStruct.modelPar_VSATWLEXP=mod.VSATWLEXP;
modelStruct.d_modelPar_VSATWLEXP_dX=0.0;
modelStruct.modelPar_given_VSATWLEXP=mod.given("VSATWLEXP");
modParamMap["VSATWLEXP"] = &(modelStruct.d_modelPar_VSATWLEXP_dX);
modelStruct.modelPar_VSATR=mod.VSATR;
modelStruct.d_modelPar_VSATR_dX=0.0;
modelStruct.modelPar_given_VSATR=mod.given("VSATR");
modParamMap["VSATR"] = &(modelStruct.d_modelPar_VSATR_dX);
modelStruct.modelPar_LVSATR=mod.LVSATR;
modelStruct.d_modelPar_LVSATR_dX=0.0;
modelStruct.modelPar_given_LVSATR=mod.given("LVSATR");
modParamMap["LVSATR"] = &(modelStruct.d_modelPar_LVSATR_dX);
modelStruct.modelPar_WVSATR=mod.WVSATR;
modelStruct.d_modelPar_WVSATR_dX=0.0;
modelStruct.modelPar_given_WVSATR=mod.given("WVSATR");
modParamMap["WVSATR"] = &(modelStruct.d_modelPar_WVSATR_dX);
modelStruct.modelPar_PVSATR=mod.PVSATR;
modelStruct.d_modelPar_PVSATR_dX=0.0;
modelStruct.modelPar_given_PVSATR=mod.given("PVSATR");
modParamMap["PVSATR"] = &(modelStruct.d_modelPar_PVSATR_dX);
modelStruct.modelPar_DELTA=mod.DELTA;
modelStruct.d_modelPar_DELTA_dX=0.0;
modelStruct.modelPar_given_DELTA=mod.given("DELTA");
modParamMap["DELTA"] = &(modelStruct.d_modelPar_DELTA_dX);
modelStruct.modelPar_LDELTA=mod.LDELTA;
modelStruct.d_modelPar_LDELTA_dX=0.0;
modelStruct.modelPar_given_LDELTA=mod.given("LDELTA");
modParamMap["LDELTA"] = &(modelStruct.d_modelPar_LDELTA_dX);
modelStruct.modelPar_WDELTA=mod.WDELTA;
modelStruct.d_modelPar_WDELTA_dX=0.0;
modelStruct.modelPar_given_WDELTA=mod.given("WDELTA");
modParamMap["WDELTA"] = &(modelStruct.d_modelPar_WDELTA_dX);
modelStruct.modelPar_PDELTA=mod.PDELTA;
modelStruct.d_modelPar_PDELTA_dX=0.0;
modelStruct.modelPar_given_PDELTA=mod.given("PDELTA");
modParamMap["PDELTA"] = &(modelStruct.d_modelPar_PDELTA_dX);
modelStruct.modelPar_DELTAL=mod.DELTAL;
modelStruct.d_modelPar_DELTAL_dX=0.0;
modelStruct.modelPar_given_DELTAL=mod.given("DELTAL");
modParamMap["DELTAL"] = &(modelStruct.d_modelPar_DELTAL_dX);
modelStruct.modelPar_DELTALEXP=mod.DELTALEXP;
modelStruct.d_modelPar_DELTALEXP_dX=0.0;
modelStruct.modelPar_given_DELTALEXP=mod.given("DELTALEXP");
modParamMap["DELTALEXP"] = &(modelStruct.d_modelPar_DELTALEXP_dX);
modelStruct.modelPar_VSATCV=mod.VSATCV;
modelStruct.d_modelPar_VSATCV_dX=0.0;
modelStruct.modelPar_given_VSATCV=mod.given("VSATCV");
modParamMap["VSATCV"] = &(modelStruct.d_modelPar_VSATCV_dX);
modelStruct.modelPar_LVSATCV=mod.LVSATCV;
modelStruct.d_modelPar_LVSATCV_dX=0.0;
modelStruct.modelPar_given_LVSATCV=mod.given("LVSATCV");
modParamMap["LVSATCV"] = &(modelStruct.d_modelPar_LVSATCV_dX);
modelStruct.modelPar_WVSATCV=mod.WVSATCV;
modelStruct.d_modelPar_WVSATCV_dX=0.0;
modelStruct.modelPar_given_WVSATCV=mod.given("WVSATCV");
modParamMap["WVSATCV"] = &(modelStruct.d_modelPar_WVSATCV_dX);
modelStruct.modelPar_PVSATCV=mod.PVSATCV;
modelStruct.d_modelPar_PVSATCV_dX=0.0;
modelStruct.modelPar_given_PVSATCV=mod.given("PVSATCV");
modParamMap["PVSATCV"] = &(modelStruct.d_modelPar_PVSATCV_dX);
modelStruct.modelPar_VSATCVL=mod.VSATCVL;
modelStruct.d_modelPar_VSATCVL_dX=0.0;
modelStruct.modelPar_given_VSATCVL=mod.given("VSATCVL");
modParamMap["VSATCVL"] = &(modelStruct.d_modelPar_VSATCVL_dX);
modelStruct.modelPar_VSATCVLEXP=mod.VSATCVLEXP;
modelStruct.d_modelPar_VSATCVLEXP_dX=0.0;
modelStruct.modelPar_given_VSATCVLEXP=mod.given("VSATCVLEXP");
modParamMap["VSATCVLEXP"] = &(modelStruct.d_modelPar_VSATCVLEXP_dX);
modelStruct.modelPar_VSATCVW=mod.VSATCVW;
modelStruct.d_modelPar_VSATCVW_dX=0.0;
modelStruct.modelPar_given_VSATCVW=mod.given("VSATCVW");
modParamMap["VSATCVW"] = &(modelStruct.d_modelPar_VSATCVW_dX);
modelStruct.modelPar_VSATCVWEXP=mod.VSATCVWEXP;
modelStruct.d_modelPar_VSATCVWEXP_dX=0.0;
modelStruct.modelPar_given_VSATCVWEXP=mod.given("VSATCVWEXP");
modParamMap["VSATCVWEXP"] = &(modelStruct.d_modelPar_VSATCVWEXP_dX);
modelStruct.modelPar_VSATCVWL=mod.VSATCVWL;
modelStruct.d_modelPar_VSATCVWL_dX=0.0;
modelStruct.modelPar_given_VSATCVWL=mod.given("VSATCVWL");
modParamMap["VSATCVWL"] = &(modelStruct.d_modelPar_VSATCVWL_dX);
modelStruct.modelPar_VSATCVWLEXP=mod.VSATCVWLEXP;
modelStruct.d_modelPar_VSATCVWLEXP_dX=0.0;
modelStruct.modelPar_given_VSATCVWLEXP=mod.given("VSATCVWLEXP");
modParamMap["VSATCVWLEXP"] = &(modelStruct.d_modelPar_VSATCVWLEXP_dX);
modelStruct.modelPar_UP1=mod.UP1;
modelStruct.d_modelPar_UP1_dX=0.0;
modelStruct.modelPar_given_UP1=mod.given("UP1");
modParamMap["UP1"] = &(modelStruct.d_modelPar_UP1_dX);
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modParamMap["LP1"] = &(modelStruct.d_modelPar_LP1_dX);
modelStruct.modelPar_UP2=mod.UP2;
modelStruct.d_modelPar_UP2_dX=0.0;
modelStruct.modelPar_given_UP2=mod.given("UP2");
modParamMap["UP2"] = &(modelStruct.d_modelPar_UP2_dX);
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modParamMap["LP2"] = &(modelStruct.d_modelPar_LP2_dX);
modelStruct.modelPar_MULU0=mod.MULU0;
modelStruct.d_modelPar_MULU0_dX=0.0;
modelStruct.modelPar_given_MULU0=mod.given("MULU0");
modParamMap["MULU0"] = &(modelStruct.d_modelPar_MULU0_dX);
modelStruct.modelPar_U0=mod.U0;
modelStruct.d_modelPar_U0_dX=0.0;
modelStruct.modelPar_given_U0=mod.given("U0");
modParamMap["U0"] = &(modelStruct.d_modelPar_U0_dX);
modelStruct.modelPar_U0L=mod.U0L;
modelStruct.d_modelPar_U0L_dX=0.0;
modelStruct.modelPar_given_U0L=mod.given("U0L");
modParamMap["U0L"] = &(modelStruct.d_modelPar_U0L_dX);
modelStruct.modelPar_U0LEXP=mod.U0LEXP;
modelStruct.d_modelPar_U0LEXP_dX=0.0;
modelStruct.modelPar_given_U0LEXP=mod.given("U0LEXP");
modParamMap["U0LEXP"] = &(modelStruct.d_modelPar_U0LEXP_dX);
modelStruct.modelPar_LU0=mod.LU0;
modelStruct.d_modelPar_LU0_dX=0.0;
modelStruct.modelPar_given_LU0=mod.given("LU0");
modParamMap["LU0"] = &(modelStruct.d_modelPar_LU0_dX);
modelStruct.modelPar_WU0=mod.WU0;
modelStruct.d_modelPar_WU0_dX=0.0;
modelStruct.modelPar_given_WU0=mod.given("WU0");
modParamMap["WU0"] = &(modelStruct.d_modelPar_WU0_dX);
modelStruct.modelPar_PU0=mod.PU0;
modelStruct.d_modelPar_PU0_dX=0.0;
modelStruct.modelPar_given_PU0=mod.given("PU0");
modParamMap["PU0"] = &(modelStruct.d_modelPar_PU0_dX);
modelStruct.modelPar_U0R=mod.U0R;
modelStruct.d_modelPar_U0R_dX=0.0;
modelStruct.modelPar_given_U0R=mod.given("U0R");
modParamMap["U0R"] = &(modelStruct.d_modelPar_U0R_dX);
modelStruct.modelPar_LU0R=mod.LU0R;
modelStruct.d_modelPar_LU0R_dX=0.0;
modelStruct.modelPar_given_LU0R=mod.given("LU0R");
modParamMap["LU0R"] = &(modelStruct.d_modelPar_LU0R_dX);
modelStruct.modelPar_WU0R=mod.WU0R;
modelStruct.d_modelPar_WU0R_dX=0.0;
modelStruct.modelPar_given_WU0R=mod.given("WU0R");
modParamMap["WU0R"] = &(modelStruct.d_modelPar_WU0R_dX);
modelStruct.modelPar_PU0R=mod.PU0R;
modelStruct.d_modelPar_PU0R_dX=0.0;
modelStruct.modelPar_given_PU0R=mod.given("PU0R");
modParamMap["PU0R"] = &(modelStruct.d_modelPar_PU0R_dX);
modelStruct.modelPar_ETAMOB=mod.ETAMOB;
modelStruct.d_modelPar_ETAMOB_dX=0.0;
modelStruct.modelPar_given_ETAMOB=mod.given("ETAMOB");
modParamMap["ETAMOB"] = &(modelStruct.d_modelPar_ETAMOB_dX);
modelStruct.modelPar_UA=mod.UA;
modelStruct.d_modelPar_UA_dX=0.0;
modelStruct.modelPar_given_UA=mod.given("UA");
modParamMap["UA"] = &(modelStruct.d_modelPar_UA_dX);
modelStruct.modelPar_UAL=mod.UAL;
modelStruct.d_modelPar_UAL_dX=0.0;
modelStruct.modelPar_given_UAL=mod.given("UAL");
modParamMap["UAL"] = &(modelStruct.d_modelPar_UAL_dX);
modelStruct.modelPar_UALEXP=mod.UALEXP;
modelStruct.d_modelPar_UALEXP_dX=0.0;
modelStruct.modelPar_given_UALEXP=mod.given("UALEXP");
modParamMap["UALEXP"] = &(modelStruct.d_modelPar_UALEXP_dX);
modelStruct.modelPar_UAW=mod.UAW;
modelStruct.d_modelPar_UAW_dX=0.0;
modelStruct.modelPar_given_UAW=mod.given("UAW");
modParamMap["UAW"] = &(modelStruct.d_modelPar_UAW_dX);
modelStruct.modelPar_UAWEXP=mod.UAWEXP;
modelStruct.d_modelPar_UAWEXP_dX=0.0;
modelStruct.modelPar_given_UAWEXP=mod.given("UAWEXP");
modParamMap["UAWEXP"] = &(modelStruct.d_modelPar_UAWEXP_dX);
modelStruct.modelPar_UAWL=mod.UAWL;
modelStruct.d_modelPar_UAWL_dX=0.0;
modelStruct.modelPar_given_UAWL=mod.given("UAWL");
modParamMap["UAWL"] = &(modelStruct.d_modelPar_UAWL_dX);
modelStruct.modelPar_UAWLEXP=mod.UAWLEXP;
modelStruct.d_modelPar_UAWLEXP_dX=0.0;
modelStruct.modelPar_given_UAWLEXP=mod.given("UAWLEXP");
modParamMap["UAWLEXP"] = &(modelStruct.d_modelPar_UAWLEXP_dX);
modelStruct.modelPar_LUA=mod.LUA;
modelStruct.d_modelPar_LUA_dX=0.0;
modelStruct.modelPar_given_LUA=mod.given("LUA");
modParamMap["LUA"] = &(modelStruct.d_modelPar_LUA_dX);
modelStruct.modelPar_WUA=mod.WUA;
modelStruct.d_modelPar_WUA_dX=0.0;
modelStruct.modelPar_given_WUA=mod.given("WUA");
modParamMap["WUA"] = &(modelStruct.d_modelPar_WUA_dX);
modelStruct.modelPar_PUA=mod.PUA;
modelStruct.d_modelPar_PUA_dX=0.0;
modelStruct.modelPar_given_PUA=mod.given("PUA");
modParamMap["PUA"] = &(modelStruct.d_modelPar_PUA_dX);
modelStruct.modelPar_UAR=mod.UAR;
modelStruct.d_modelPar_UAR_dX=0.0;
modelStruct.modelPar_given_UAR=mod.given("UAR");
modParamMap["UAR"] = &(modelStruct.d_modelPar_UAR_dX);
modelStruct.modelPar_LUAR=mod.LUAR;
modelStruct.d_modelPar_LUAR_dX=0.0;
modelStruct.modelPar_given_LUAR=mod.given("LUAR");
modParamMap["LUAR"] = &(modelStruct.d_modelPar_LUAR_dX);
modelStruct.modelPar_WUAR=mod.WUAR;
modelStruct.d_modelPar_WUAR_dX=0.0;
modelStruct.modelPar_given_WUAR=mod.given("WUAR");
modParamMap["WUAR"] = &(modelStruct.d_modelPar_WUAR_dX);
modelStruct.modelPar_PUAR=mod.PUAR;
modelStruct.d_modelPar_PUAR_dX=0.0;
modelStruct.modelPar_given_PUAR=mod.given("PUAR");
modParamMap["PUAR"] = &(modelStruct.d_modelPar_PUAR_dX);
modelStruct.modelPar_EU=mod.EU;
modelStruct.d_modelPar_EU_dX=0.0;
modelStruct.modelPar_given_EU=mod.given("EU");
modParamMap["EU"] = &(modelStruct.d_modelPar_EU_dX);
modelStruct.modelPar_LEU=mod.LEU;
modelStruct.d_modelPar_LEU_dX=0.0;
modelStruct.modelPar_given_LEU=mod.given("LEU");
modParamMap["LEU"] = &(modelStruct.d_modelPar_LEU_dX);
modelStruct.modelPar_WEU=mod.WEU;
modelStruct.d_modelPar_WEU_dX=0.0;
modelStruct.modelPar_given_WEU=mod.given("WEU");
modParamMap["WEU"] = &(modelStruct.d_modelPar_WEU_dX);
modelStruct.modelPar_PEU=mod.PEU;
modelStruct.d_modelPar_PEU_dX=0.0;
modelStruct.modelPar_given_PEU=mod.given("PEU");
modParamMap["PEU"] = &(modelStruct.d_modelPar_PEU_dX);
modelStruct.modelPar_EUL=mod.EUL;
modelStruct.d_modelPar_EUL_dX=0.0;
modelStruct.modelPar_given_EUL=mod.given("EUL");
modParamMap["EUL"] = &(modelStruct.d_modelPar_EUL_dX);
modelStruct.modelPar_EULEXP=mod.EULEXP;
modelStruct.d_modelPar_EULEXP_dX=0.0;
modelStruct.modelPar_given_EULEXP=mod.given("EULEXP");
modParamMap["EULEXP"] = &(modelStruct.d_modelPar_EULEXP_dX);
modelStruct.modelPar_EUW=mod.EUW;
modelStruct.d_modelPar_EUW_dX=0.0;
modelStruct.modelPar_given_EUW=mod.given("EUW");
modParamMap["EUW"] = &(modelStruct.d_modelPar_EUW_dX);
modelStruct.modelPar_EUWEXP=mod.EUWEXP;
modelStruct.d_modelPar_EUWEXP_dX=0.0;
modelStruct.modelPar_given_EUWEXP=mod.given("EUWEXP");
modParamMap["EUWEXP"] = &(modelStruct.d_modelPar_EUWEXP_dX);
modelStruct.modelPar_EUWL=mod.EUWL;
modelStruct.d_modelPar_EUWL_dX=0.0;
modelStruct.modelPar_given_EUWL=mod.given("EUWL");
modParamMap["EUWL"] = &(modelStruct.d_modelPar_EUWL_dX);
modelStruct.modelPar_EUWLEXP=mod.EUWLEXP;
modelStruct.d_modelPar_EUWLEXP_dX=0.0;
modelStruct.modelPar_given_EUWLEXP=mod.given("EUWLEXP");
modParamMap["EUWLEXP"] = &(modelStruct.d_modelPar_EUWLEXP_dX);
modelStruct.modelPar_UD=mod.UD;
modelStruct.d_modelPar_UD_dX=0.0;
modelStruct.modelPar_given_UD=mod.given("UD");
modParamMap["UD"] = &(modelStruct.d_modelPar_UD_dX);
modelStruct.modelPar_UDL=mod.UDL;
modelStruct.d_modelPar_UDL_dX=0.0;
modelStruct.modelPar_given_UDL=mod.given("UDL");
modParamMap["UDL"] = &(modelStruct.d_modelPar_UDL_dX);
modelStruct.modelPar_UDLEXP=mod.UDLEXP;
modelStruct.d_modelPar_UDLEXP_dX=0.0;
modelStruct.modelPar_given_UDLEXP=mod.given("UDLEXP");
modParamMap["UDLEXP"] = &(modelStruct.d_modelPar_UDLEXP_dX);
modelStruct.modelPar_LUD=mod.LUD;
modelStruct.d_modelPar_LUD_dX=0.0;
modelStruct.modelPar_given_LUD=mod.given("LUD");
modParamMap["LUD"] = &(modelStruct.d_modelPar_LUD_dX);
modelStruct.modelPar_WUD=mod.WUD;
modelStruct.d_modelPar_WUD_dX=0.0;
modelStruct.modelPar_given_WUD=mod.given("WUD");
modParamMap["WUD"] = &(modelStruct.d_modelPar_WUD_dX);
modelStruct.modelPar_PUD=mod.PUD;
modelStruct.d_modelPar_PUD_dX=0.0;
modelStruct.modelPar_given_PUD=mod.given("PUD");
modParamMap["PUD"] = &(modelStruct.d_modelPar_PUD_dX);
modelStruct.modelPar_UDR=mod.UDR;
modelStruct.d_modelPar_UDR_dX=0.0;
modelStruct.modelPar_given_UDR=mod.given("UDR");
modParamMap["UDR"] = &(modelStruct.d_modelPar_UDR_dX);
modelStruct.modelPar_LUDR=mod.LUDR;
modelStruct.d_modelPar_LUDR_dX=0.0;
modelStruct.modelPar_given_LUDR=mod.given("LUDR");
modParamMap["LUDR"] = &(modelStruct.d_modelPar_LUDR_dX);
modelStruct.modelPar_WUDR=mod.WUDR;
modelStruct.d_modelPar_WUDR_dX=0.0;
modelStruct.modelPar_given_WUDR=mod.given("WUDR");
modParamMap["WUDR"] = &(modelStruct.d_modelPar_WUDR_dX);
modelStruct.modelPar_PUDR=mod.PUDR;
modelStruct.d_modelPar_PUDR_dX=0.0;
modelStruct.modelPar_given_PUDR=mod.given("PUDR");
modParamMap["PUDR"] = &(modelStruct.d_modelPar_PUDR_dX);
modelStruct.modelPar_UCS=mod.UCS;
modelStruct.d_modelPar_UCS_dX=0.0;
modelStruct.modelPar_given_UCS=mod.given("UCS");
modParamMap["UCS"] = &(modelStruct.d_modelPar_UCS_dX);
modelStruct.modelPar_LUCS=mod.LUCS;
modelStruct.d_modelPar_LUCS_dX=0.0;
modelStruct.modelPar_given_LUCS=mod.given("LUCS");
modParamMap["LUCS"] = &(modelStruct.d_modelPar_LUCS_dX);
modelStruct.modelPar_WUCS=mod.WUCS;
modelStruct.d_modelPar_WUCS_dX=0.0;
modelStruct.modelPar_given_WUCS=mod.given("WUCS");
modParamMap["WUCS"] = &(modelStruct.d_modelPar_WUCS_dX);
modelStruct.modelPar_PUCS=mod.PUCS;
modelStruct.d_modelPar_PUCS_dX=0.0;
modelStruct.modelPar_given_PUCS=mod.given("PUCS");
modParamMap["PUCS"] = &(modelStruct.d_modelPar_PUCS_dX);
modelStruct.modelPar_UCSR=mod.UCSR;
modelStruct.d_modelPar_UCSR_dX=0.0;
modelStruct.modelPar_given_UCSR=mod.given("UCSR");
modParamMap["UCSR"] = &(modelStruct.d_modelPar_UCSR_dX);
modelStruct.modelPar_LUCSR=mod.LUCSR;
modelStruct.d_modelPar_LUCSR_dX=0.0;
modelStruct.modelPar_given_LUCSR=mod.given("LUCSR");
modParamMap["LUCSR"] = &(modelStruct.d_modelPar_LUCSR_dX);
modelStruct.modelPar_WUCSR=mod.WUCSR;
modelStruct.d_modelPar_WUCSR_dX=0.0;
modelStruct.modelPar_given_WUCSR=mod.given("WUCSR");
modParamMap["WUCSR"] = &(modelStruct.d_modelPar_WUCSR_dX);
modelStruct.modelPar_PUCSR=mod.PUCSR;
modelStruct.d_modelPar_PUCSR_dX=0.0;
modelStruct.modelPar_given_PUCSR=mod.given("PUCSR");
modParamMap["PUCSR"] = &(modelStruct.d_modelPar_PUCSR_dX);
modelStruct.modelPar_UC=mod.UC;
modelStruct.d_modelPar_UC_dX=0.0;
modelStruct.modelPar_given_UC=mod.given("UC");
modParamMap["UC"] = &(modelStruct.d_modelPar_UC_dX);
modelStruct.modelPar_UCL=mod.UCL;
modelStruct.d_modelPar_UCL_dX=0.0;
modelStruct.modelPar_given_UCL=mod.given("UCL");
modParamMap["UCL"] = &(modelStruct.d_modelPar_UCL_dX);
modelStruct.modelPar_UCLEXP=mod.UCLEXP;
modelStruct.d_modelPar_UCLEXP_dX=0.0;
modelStruct.modelPar_given_UCLEXP=mod.given("UCLEXP");
modParamMap["UCLEXP"] = &(modelStruct.d_modelPar_UCLEXP_dX);
modelStruct.modelPar_UCW=mod.UCW;
modelStruct.d_modelPar_UCW_dX=0.0;
modelStruct.modelPar_given_UCW=mod.given("UCW");
modParamMap["UCW"] = &(modelStruct.d_modelPar_UCW_dX);
modelStruct.modelPar_UCWEXP=mod.UCWEXP;
modelStruct.d_modelPar_UCWEXP_dX=0.0;
modelStruct.modelPar_given_UCWEXP=mod.given("UCWEXP");
modParamMap["UCWEXP"] = &(modelStruct.d_modelPar_UCWEXP_dX);
modelStruct.modelPar_UCWL=mod.UCWL;
modelStruct.d_modelPar_UCWL_dX=0.0;
modelStruct.modelPar_given_UCWL=mod.given("UCWL");
modParamMap["UCWL"] = &(modelStruct.d_modelPar_UCWL_dX);
modelStruct.modelPar_UCWLEXP=mod.UCWLEXP;
modelStruct.d_modelPar_UCWLEXP_dX=0.0;
modelStruct.modelPar_given_UCWLEXP=mod.given("UCWLEXP");
modParamMap["UCWLEXP"] = &(modelStruct.d_modelPar_UCWLEXP_dX);
modelStruct.modelPar_LUC=mod.LUC;
modelStruct.d_modelPar_LUC_dX=0.0;
modelStruct.modelPar_given_LUC=mod.given("LUC");
modParamMap["LUC"] = &(modelStruct.d_modelPar_LUC_dX);
modelStruct.modelPar_WUC=mod.WUC;
modelStruct.d_modelPar_WUC_dX=0.0;
modelStruct.modelPar_given_WUC=mod.given("WUC");
modParamMap["WUC"] = &(modelStruct.d_modelPar_WUC_dX);
modelStruct.modelPar_PUC=mod.PUC;
modelStruct.d_modelPar_PUC_dX=0.0;
modelStruct.modelPar_given_PUC=mod.given("PUC");
modParamMap["PUC"] = &(modelStruct.d_modelPar_PUC_dX);
modelStruct.modelPar_UCR=mod.UCR;
modelStruct.d_modelPar_UCR_dX=0.0;
modelStruct.modelPar_given_UCR=mod.given("UCR");
modParamMap["UCR"] = &(modelStruct.d_modelPar_UCR_dX);
modelStruct.modelPar_LUCR=mod.LUCR;
modelStruct.d_modelPar_LUCR_dX=0.0;
modelStruct.modelPar_given_LUCR=mod.given("LUCR");
modParamMap["LUCR"] = &(modelStruct.d_modelPar_LUCR_dX);
modelStruct.modelPar_WUCR=mod.WUCR;
modelStruct.d_modelPar_WUCR_dX=0.0;
modelStruct.modelPar_given_WUCR=mod.given("WUCR");
modParamMap["WUCR"] = &(modelStruct.d_modelPar_WUCR_dX);
modelStruct.modelPar_PUCR=mod.PUCR;
modelStruct.d_modelPar_PUCR_dX=0.0;
modelStruct.modelPar_given_PUCR=mod.given("PUCR");
modParamMap["PUCR"] = &(modelStruct.d_modelPar_PUCR_dX);
modelStruct.modelPar_PCLM=mod.PCLM;
modelStruct.d_modelPar_PCLM_dX=0.0;
modelStruct.modelPar_given_PCLM=mod.given("PCLM");
modParamMap["PCLM"] = &(modelStruct.d_modelPar_PCLM_dX);
modelStruct.modelPar_PCLML=mod.PCLML;
modelStruct.d_modelPar_PCLML_dX=0.0;
modelStruct.modelPar_given_PCLML=mod.given("PCLML");
modParamMap["PCLML"] = &(modelStruct.d_modelPar_PCLML_dX);
modelStruct.modelPar_PCLMLEXP=mod.PCLMLEXP;
modelStruct.d_modelPar_PCLMLEXP_dX=0.0;
modelStruct.modelPar_given_PCLMLEXP=mod.given("PCLMLEXP");
modParamMap["PCLMLEXP"] = &(modelStruct.d_modelPar_PCLMLEXP_dX);
modelStruct.modelPar_LPCLM=mod.LPCLM;
modelStruct.d_modelPar_LPCLM_dX=0.0;
modelStruct.modelPar_given_LPCLM=mod.given("LPCLM");
modParamMap["LPCLM"] = &(modelStruct.d_modelPar_LPCLM_dX);
modelStruct.modelPar_WPCLM=mod.WPCLM;
modelStruct.d_modelPar_WPCLM_dX=0.0;
modelStruct.modelPar_given_WPCLM=mod.given("WPCLM");
modParamMap["WPCLM"] = &(modelStruct.d_modelPar_WPCLM_dX);
modelStruct.modelPar_PPCLM=mod.PPCLM;
modelStruct.d_modelPar_PPCLM_dX=0.0;
modelStruct.modelPar_given_PPCLM=mod.given("PPCLM");
modParamMap["PPCLM"] = &(modelStruct.d_modelPar_PPCLM_dX);
modelStruct.modelPar_PCLMR=mod.PCLMR;
modelStruct.d_modelPar_PCLMR_dX=0.0;
modelStruct.modelPar_given_PCLMR=mod.given("PCLMR");
modParamMap["PCLMR"] = &(modelStruct.d_modelPar_PCLMR_dX);
modelStruct.modelPar_LPCLMR=mod.LPCLMR;
modelStruct.d_modelPar_LPCLMR_dX=0.0;
modelStruct.modelPar_given_LPCLMR=mod.given("LPCLMR");
modParamMap["LPCLMR"] = &(modelStruct.d_modelPar_LPCLMR_dX);
modelStruct.modelPar_WPCLMR=mod.WPCLMR;
modelStruct.d_modelPar_WPCLMR_dX=0.0;
modelStruct.modelPar_given_WPCLMR=mod.given("WPCLMR");
modParamMap["WPCLMR"] = &(modelStruct.d_modelPar_WPCLMR_dX);
modelStruct.modelPar_PPCLMR=mod.PPCLMR;
modelStruct.d_modelPar_PPCLMR_dX=0.0;
modelStruct.modelPar_given_PPCLMR=mod.given("PPCLMR");
modParamMap["PPCLMR"] = &(modelStruct.d_modelPar_PPCLMR_dX);
modelStruct.modelPar_PCLMG=mod.PCLMG;
modelStruct.d_modelPar_PCLMG_dX=0.0;
modelStruct.modelPar_given_PCLMG=mod.given("PCLMG");
modParamMap["PCLMG"] = &(modelStruct.d_modelPar_PCLMG_dX);
modelStruct.modelPar_PCLMCV=mod.PCLMCV;
modelStruct.d_modelPar_PCLMCV_dX=0.0;
modelStruct.modelPar_given_PCLMCV=mod.given("PCLMCV");
modParamMap["PCLMCV"] = &(modelStruct.d_modelPar_PCLMCV_dX);
modelStruct.modelPar_PCLMCVL=mod.PCLMCVL;
modelStruct.d_modelPar_PCLMCVL_dX=0.0;
modelStruct.modelPar_given_PCLMCVL=mod.given("PCLMCVL");
modParamMap["PCLMCVL"] = &(modelStruct.d_modelPar_PCLMCVL_dX);
modelStruct.modelPar_PCLMCVLEXP=mod.PCLMCVLEXP;
modelStruct.d_modelPar_PCLMCVLEXP_dX=0.0;
modelStruct.modelPar_given_PCLMCVLEXP=mod.given("PCLMCVLEXP");
modParamMap["PCLMCVLEXP"] = &(modelStruct.d_modelPar_PCLMCVLEXP_dX);
modelStruct.modelPar_LPCLMCV=mod.LPCLMCV;
modelStruct.d_modelPar_LPCLMCV_dX=0.0;
modelStruct.modelPar_given_LPCLMCV=mod.given("LPCLMCV");
modParamMap["LPCLMCV"] = &(modelStruct.d_modelPar_LPCLMCV_dX);
modelStruct.modelPar_WPCLMCV=mod.WPCLMCV;
modelStruct.d_modelPar_WPCLMCV_dX=0.0;
modelStruct.modelPar_given_WPCLMCV=mod.given("WPCLMCV");
modParamMap["WPCLMCV"] = &(modelStruct.d_modelPar_WPCLMCV_dX);
modelStruct.modelPar_PPCLMCV=mod.PPCLMCV;
modelStruct.d_modelPar_PPCLMCV_dX=0.0;
modelStruct.modelPar_given_PPCLMCV=mod.given("PPCLMCV");
modParamMap["PPCLMCV"] = &(modelStruct.d_modelPar_PPCLMCV_dX);
modelStruct.modelPar_PSCBE1=mod.PSCBE1;
modelStruct.d_modelPar_PSCBE1_dX=0.0;
modelStruct.modelPar_given_PSCBE1=mod.given("PSCBE1");
modParamMap["PSCBE1"] = &(modelStruct.d_modelPar_PSCBE1_dX);
modelStruct.modelPar_LPSCBE1=mod.LPSCBE1;
modelStruct.d_modelPar_LPSCBE1_dX=0.0;
modelStruct.modelPar_given_LPSCBE1=mod.given("LPSCBE1");
modParamMap["LPSCBE1"] = &(modelStruct.d_modelPar_LPSCBE1_dX);
modelStruct.modelPar_WPSCBE1=mod.WPSCBE1;
modelStruct.d_modelPar_WPSCBE1_dX=0.0;
modelStruct.modelPar_given_WPSCBE1=mod.given("WPSCBE1");
modParamMap["WPSCBE1"] = &(modelStruct.d_modelPar_WPSCBE1_dX);
modelStruct.modelPar_PPSCBE1=mod.PPSCBE1;
modelStruct.d_modelPar_PPSCBE1_dX=0.0;
modelStruct.modelPar_given_PPSCBE1=mod.given("PPSCBE1");
modParamMap["PPSCBE1"] = &(modelStruct.d_modelPar_PPSCBE1_dX);
modelStruct.modelPar_PSCBE2=mod.PSCBE2;
modelStruct.d_modelPar_PSCBE2_dX=0.0;
modelStruct.modelPar_given_PSCBE2=mod.given("PSCBE2");
modParamMap["PSCBE2"] = &(modelStruct.d_modelPar_PSCBE2_dX);
modelStruct.modelPar_LPSCBE2=mod.LPSCBE2;
modelStruct.d_modelPar_LPSCBE2_dX=0.0;
modelStruct.modelPar_given_LPSCBE2=mod.given("LPSCBE2");
modParamMap["LPSCBE2"] = &(modelStruct.d_modelPar_LPSCBE2_dX);
modelStruct.modelPar_WPSCBE2=mod.WPSCBE2;
modelStruct.d_modelPar_WPSCBE2_dX=0.0;
modelStruct.modelPar_given_WPSCBE2=mod.given("WPSCBE2");
modParamMap["WPSCBE2"] = &(modelStruct.d_modelPar_WPSCBE2_dX);
modelStruct.modelPar_PPSCBE2=mod.PPSCBE2;
modelStruct.d_modelPar_PPSCBE2_dX=0.0;
modelStruct.modelPar_given_PPSCBE2=mod.given("PPSCBE2");
modParamMap["PPSCBE2"] = &(modelStruct.d_modelPar_PPSCBE2_dX);
modelStruct.modelPar_PDITS=mod.PDITS;
modelStruct.d_modelPar_PDITS_dX=0.0;
modelStruct.modelPar_given_PDITS=mod.given("PDITS");
modParamMap["PDITS"] = &(modelStruct.d_modelPar_PDITS_dX);
modelStruct.modelPar_LPDITS=mod.LPDITS;
modelStruct.d_modelPar_LPDITS_dX=0.0;
modelStruct.modelPar_given_LPDITS=mod.given("LPDITS");
modParamMap["LPDITS"] = &(modelStruct.d_modelPar_LPDITS_dX);
modelStruct.modelPar_WPDITS=mod.WPDITS;
modelStruct.d_modelPar_WPDITS_dX=0.0;
modelStruct.modelPar_given_WPDITS=mod.given("WPDITS");
modParamMap["WPDITS"] = &(modelStruct.d_modelPar_WPDITS_dX);
modelStruct.modelPar_PPDITS=mod.PPDITS;
modelStruct.d_modelPar_PPDITS_dX=0.0;
modelStruct.modelPar_given_PPDITS=mod.given("PPDITS");
modParamMap["PPDITS"] = &(modelStruct.d_modelPar_PPDITS_dX);
modelStruct.modelPar_PDITSL=mod.PDITSL;
modelStruct.d_modelPar_PDITSL_dX=0.0;
modelStruct.modelPar_given_PDITSL=mod.given("PDITSL");
modParamMap["PDITSL"] = &(modelStruct.d_modelPar_PDITSL_dX);
modelStruct.modelPar_PDITSD=mod.PDITSD;
modelStruct.d_modelPar_PDITSD_dX=0.0;
modelStruct.modelPar_given_PDITSD=mod.given("PDITSD");
modParamMap["PDITSD"] = &(modelStruct.d_modelPar_PDITSD_dX);
modelStruct.modelPar_LPDITSD=mod.LPDITSD;
modelStruct.d_modelPar_LPDITSD_dX=0.0;
modelStruct.modelPar_given_LPDITSD=mod.given("LPDITSD");
modParamMap["LPDITSD"] = &(modelStruct.d_modelPar_LPDITSD_dX);
modelStruct.modelPar_WPDITSD=mod.WPDITSD;
modelStruct.d_modelPar_WPDITSD_dX=0.0;
modelStruct.modelPar_given_WPDITSD=mod.given("WPDITSD");
modParamMap["WPDITSD"] = &(modelStruct.d_modelPar_WPDITSD_dX);
modelStruct.modelPar_PPDITSD=mod.PPDITSD;
modelStruct.d_modelPar_PPDITSD_dX=0.0;
modelStruct.modelPar_given_PPDITSD=mod.given("PPDITSD");
modParamMap["PPDITSD"] = &(modelStruct.d_modelPar_PPDITSD_dX);
modelStruct.modelPar_RSH=mod.RSH;
modelStruct.d_modelPar_RSH_dX=0.0;
modelStruct.modelPar_given_RSH=mod.given("RSH");
modParamMap["RSH"] = &(modelStruct.d_modelPar_RSH_dX);
modelStruct.modelPar_PRWG=mod.PRWG;
modelStruct.d_modelPar_PRWG_dX=0.0;
modelStruct.modelPar_given_PRWG=mod.given("PRWG");
modParamMap["PRWG"] = &(modelStruct.d_modelPar_PRWG_dX);
modelStruct.modelPar_LPRWG=mod.LPRWG;
modelStruct.d_modelPar_LPRWG_dX=0.0;
modelStruct.modelPar_given_LPRWG=mod.given("LPRWG");
modParamMap["LPRWG"] = &(modelStruct.d_modelPar_LPRWG_dX);
modelStruct.modelPar_WPRWG=mod.WPRWG;
modelStruct.d_modelPar_WPRWG_dX=0.0;
modelStruct.modelPar_given_WPRWG=mod.given("WPRWG");
modParamMap["WPRWG"] = &(modelStruct.d_modelPar_WPRWG_dX);
modelStruct.modelPar_PPRWG=mod.PPRWG;
modelStruct.d_modelPar_PPRWG_dX=0.0;
modelStruct.modelPar_given_PPRWG=mod.given("PPRWG");
modParamMap["PPRWG"] = &(modelStruct.d_modelPar_PPRWG_dX);
modelStruct.modelPar_PRWB=mod.PRWB;
modelStruct.d_modelPar_PRWB_dX=0.0;
modelStruct.modelPar_given_PRWB=mod.given("PRWB");
modParamMap["PRWB"] = &(modelStruct.d_modelPar_PRWB_dX);
modelStruct.modelPar_LPRWB=mod.LPRWB;
modelStruct.d_modelPar_LPRWB_dX=0.0;
modelStruct.modelPar_given_LPRWB=mod.given("LPRWB");
modParamMap["LPRWB"] = &(modelStruct.d_modelPar_LPRWB_dX);
modelStruct.modelPar_WPRWB=mod.WPRWB;
modelStruct.d_modelPar_WPRWB_dX=0.0;
modelStruct.modelPar_given_WPRWB=mod.given("WPRWB");
modParamMap["WPRWB"] = &(modelStruct.d_modelPar_WPRWB_dX);
modelStruct.modelPar_PPRWB=mod.PPRWB;
modelStruct.d_modelPar_PPRWB_dX=0.0;
modelStruct.modelPar_given_PPRWB=mod.given("PPRWB");
modParamMap["PPRWB"] = &(modelStruct.d_modelPar_PPRWB_dX);
modelStruct.modelPar_PRWBL=mod.PRWBL;
modelStruct.d_modelPar_PRWBL_dX=0.0;
modelStruct.modelPar_given_PRWBL=mod.given("PRWBL");
modParamMap["PRWBL"] = &(modelStruct.d_modelPar_PRWBL_dX);
modelStruct.modelPar_PRWBLEXP=mod.PRWBLEXP;
modelStruct.d_modelPar_PRWBLEXP_dX=0.0;
modelStruct.modelPar_given_PRWBLEXP=mod.given("PRWBLEXP");
modParamMap["PRWBLEXP"] = &(modelStruct.d_modelPar_PRWBLEXP_dX);
modelStruct.modelPar_WR=mod.WR;
modelStruct.d_modelPar_WR_dX=0.0;
modelStruct.modelPar_given_WR=mod.given("WR");
modParamMap["WR"] = &(modelStruct.d_modelPar_WR_dX);
modelStruct.modelPar_LWR=mod.LWR;
modelStruct.d_modelPar_LWR_dX=0.0;
modelStruct.modelPar_given_LWR=mod.given("LWR");
modParamMap["LWR"] = &(modelStruct.d_modelPar_LWR_dX);
modelStruct.modelPar_WWR=mod.WWR;
modelStruct.d_modelPar_WWR_dX=0.0;
modelStruct.modelPar_given_WWR=mod.given("WWR");
modParamMap["WWR"] = &(modelStruct.d_modelPar_WWR_dX);
modelStruct.modelPar_PWR=mod.PWR;
modelStruct.d_modelPar_PWR_dX=0.0;
modelStruct.modelPar_given_PWR=mod.given("PWR");
modParamMap["PWR"] = &(modelStruct.d_modelPar_PWR_dX);
modelStruct.modelPar_RSWMIN=mod.RSWMIN;
modelStruct.d_modelPar_RSWMIN_dX=0.0;
modelStruct.modelPar_given_RSWMIN=mod.given("RSWMIN");
modParamMap["RSWMIN"] = &(modelStruct.d_modelPar_RSWMIN_dX);
modelStruct.modelPar_LRSWMIN=mod.LRSWMIN;
modelStruct.d_modelPar_LRSWMIN_dX=0.0;
modelStruct.modelPar_given_LRSWMIN=mod.given("LRSWMIN");
modParamMap["LRSWMIN"] = &(modelStruct.d_modelPar_LRSWMIN_dX);
modelStruct.modelPar_WRSWMIN=mod.WRSWMIN;
modelStruct.d_modelPar_WRSWMIN_dX=0.0;
modelStruct.modelPar_given_WRSWMIN=mod.given("WRSWMIN");
modParamMap["WRSWMIN"] = &(modelStruct.d_modelPar_WRSWMIN_dX);
modelStruct.modelPar_PRSWMIN=mod.PRSWMIN;
modelStruct.d_modelPar_PRSWMIN_dX=0.0;
modelStruct.modelPar_given_PRSWMIN=mod.given("PRSWMIN");
modParamMap["PRSWMIN"] = &(modelStruct.d_modelPar_PRSWMIN_dX);
modelStruct.modelPar_RSW=mod.RSW;
modelStruct.d_modelPar_RSW_dX=0.0;
modelStruct.modelPar_given_RSW=mod.given("RSW");
modParamMap["RSW"] = &(modelStruct.d_modelPar_RSW_dX);
modelStruct.modelPar_LRSW=mod.LRSW;
modelStruct.d_modelPar_LRSW_dX=0.0;
modelStruct.modelPar_given_LRSW=mod.given("LRSW");
modParamMap["LRSW"] = &(modelStruct.d_modelPar_LRSW_dX);
modelStruct.modelPar_WRSW=mod.WRSW;
modelStruct.d_modelPar_WRSW_dX=0.0;
modelStruct.modelPar_given_WRSW=mod.given("WRSW");
modParamMap["WRSW"] = &(modelStruct.d_modelPar_WRSW_dX);
modelStruct.modelPar_PRSW=mod.PRSW;
modelStruct.d_modelPar_PRSW_dX=0.0;
modelStruct.modelPar_given_PRSW=mod.given("PRSW");
modParamMap["PRSW"] = &(modelStruct.d_modelPar_PRSW_dX);
modelStruct.modelPar_RSWL=mod.RSWL;
modelStruct.d_modelPar_RSWL_dX=0.0;
modelStruct.modelPar_given_RSWL=mod.given("RSWL");
modParamMap["RSWL"] = &(modelStruct.d_modelPar_RSWL_dX);
modelStruct.modelPar_RSWLEXP=mod.RSWLEXP;
modelStruct.d_modelPar_RSWLEXP_dX=0.0;
modelStruct.modelPar_given_RSWLEXP=mod.given("RSWLEXP");
modParamMap["RSWLEXP"] = &(modelStruct.d_modelPar_RSWLEXP_dX);
modelStruct.modelPar_RDWMIN=mod.RDWMIN;
modelStruct.d_modelPar_RDWMIN_dX=0.0;
modelStruct.modelPar_given_RDWMIN=mod.given("RDWMIN");
modParamMap["RDWMIN"] = &(modelStruct.d_modelPar_RDWMIN_dX);
modelStruct.modelPar_LRDWMIN=mod.LRDWMIN;
modelStruct.d_modelPar_LRDWMIN_dX=0.0;
modelStruct.modelPar_given_LRDWMIN=mod.given("LRDWMIN");
modParamMap["LRDWMIN"] = &(modelStruct.d_modelPar_LRDWMIN_dX);
modelStruct.modelPar_WRDWMIN=mod.WRDWMIN;
modelStruct.d_modelPar_WRDWMIN_dX=0.0;
modelStruct.modelPar_given_WRDWMIN=mod.given("WRDWMIN");
modParamMap["WRDWMIN"] = &(modelStruct.d_modelPar_WRDWMIN_dX);
modelStruct.modelPar_PRDWMIN=mod.PRDWMIN;
modelStruct.d_modelPar_PRDWMIN_dX=0.0;
modelStruct.modelPar_given_PRDWMIN=mod.given("PRDWMIN");
modParamMap["PRDWMIN"] = &(modelStruct.d_modelPar_PRDWMIN_dX);
modelStruct.modelPar_RDW=mod.RDW;
modelStruct.d_modelPar_RDW_dX=0.0;
modelStruct.modelPar_given_RDW=mod.given("RDW");
modParamMap["RDW"] = &(modelStruct.d_modelPar_RDW_dX);
modelStruct.modelPar_LRDW=mod.LRDW;
modelStruct.d_modelPar_LRDW_dX=0.0;
modelStruct.modelPar_given_LRDW=mod.given("LRDW");
modParamMap["LRDW"] = &(modelStruct.d_modelPar_LRDW_dX);
modelStruct.modelPar_WRDW=mod.WRDW;
modelStruct.d_modelPar_WRDW_dX=0.0;
modelStruct.modelPar_given_WRDW=mod.given("WRDW");
modParamMap["WRDW"] = &(modelStruct.d_modelPar_WRDW_dX);
modelStruct.modelPar_PRDW=mod.PRDW;
modelStruct.d_modelPar_PRDW_dX=0.0;
modelStruct.modelPar_given_PRDW=mod.given("PRDW");
modParamMap["PRDW"] = &(modelStruct.d_modelPar_PRDW_dX);
modelStruct.modelPar_RDWL=mod.RDWL;
modelStruct.d_modelPar_RDWL_dX=0.0;
modelStruct.modelPar_given_RDWL=mod.given("RDWL");
modParamMap["RDWL"] = &(modelStruct.d_modelPar_RDWL_dX);
modelStruct.modelPar_RDWLEXP=mod.RDWLEXP;
modelStruct.d_modelPar_RDWLEXP_dX=0.0;
modelStruct.modelPar_given_RDWLEXP=mod.given("RDWLEXP");
modParamMap["RDWLEXP"] = &(modelStruct.d_modelPar_RDWLEXP_dX);
modelStruct.modelPar_RDSWMIN=mod.RDSWMIN;
modelStruct.d_modelPar_RDSWMIN_dX=0.0;
modelStruct.modelPar_given_RDSWMIN=mod.given("RDSWMIN");
modParamMap["RDSWMIN"] = &(modelStruct.d_modelPar_RDSWMIN_dX);
modelStruct.modelPar_LRDSWMIN=mod.LRDSWMIN;
modelStruct.d_modelPar_LRDSWMIN_dX=0.0;
modelStruct.modelPar_given_LRDSWMIN=mod.given("LRDSWMIN");
modParamMap["LRDSWMIN"] = &(modelStruct.d_modelPar_LRDSWMIN_dX);
modelStruct.modelPar_WRDSWMIN=mod.WRDSWMIN;
modelStruct.d_modelPar_WRDSWMIN_dX=0.0;
modelStruct.modelPar_given_WRDSWMIN=mod.given("WRDSWMIN");
modParamMap["WRDSWMIN"] = &(modelStruct.d_modelPar_WRDSWMIN_dX);
modelStruct.modelPar_PRDSWMIN=mod.PRDSWMIN;
modelStruct.d_modelPar_PRDSWMIN_dX=0.0;
modelStruct.modelPar_given_PRDSWMIN=mod.given("PRDSWMIN");
modParamMap["PRDSWMIN"] = &(modelStruct.d_modelPar_PRDSWMIN_dX);
modelStruct.modelPar_RDSW=mod.RDSW;
modelStruct.d_modelPar_RDSW_dX=0.0;
modelStruct.modelPar_given_RDSW=mod.given("RDSW");
modParamMap["RDSW"] = &(modelStruct.d_modelPar_RDSW_dX);
modelStruct.modelPar_RDSWL=mod.RDSWL;
modelStruct.d_modelPar_RDSWL_dX=0.0;
modelStruct.modelPar_given_RDSWL=mod.given("RDSWL");
modParamMap["RDSWL"] = &(modelStruct.d_modelPar_RDSWL_dX);
modelStruct.modelPar_RDSWLEXP=mod.RDSWLEXP;
modelStruct.d_modelPar_RDSWLEXP_dX=0.0;
modelStruct.modelPar_given_RDSWLEXP=mod.given("RDSWLEXP");
modParamMap["RDSWLEXP"] = &(modelStruct.d_modelPar_RDSWLEXP_dX);
modelStruct.modelPar_LRDSW=mod.LRDSW;
modelStruct.d_modelPar_LRDSW_dX=0.0;
modelStruct.modelPar_given_LRDSW=mod.given("LRDSW");
modParamMap["LRDSW"] = &(modelStruct.d_modelPar_LRDSW_dX);
modelStruct.modelPar_WRDSW=mod.WRDSW;
modelStruct.d_modelPar_WRDSW_dX=0.0;
modelStruct.modelPar_given_WRDSW=mod.given("WRDSW");
modParamMap["WRDSW"] = &(modelStruct.d_modelPar_WRDSW_dX);
modelStruct.modelPar_PRDSW=mod.PRDSW;
modelStruct.d_modelPar_PRDSW_dX=0.0;
modelStruct.modelPar_given_PRDSW=mod.given("PRDSW");
modParamMap["PRDSW"] = &(modelStruct.d_modelPar_PRDSW_dX);
modelStruct.modelPar_PSAT=mod.PSAT;
modelStruct.d_modelPar_PSAT_dX=0.0;
modelStruct.modelPar_given_PSAT=mod.given("PSAT");
modParamMap["PSAT"] = &(modelStruct.d_modelPar_PSAT_dX);
modelStruct.modelPar_LPSAT=mod.LPSAT;
modelStruct.d_modelPar_LPSAT_dX=0.0;
modelStruct.modelPar_given_LPSAT=mod.given("LPSAT");
modParamMap["LPSAT"] = &(modelStruct.d_modelPar_LPSAT_dX);
modelStruct.modelPar_WPSAT=mod.WPSAT;
modelStruct.d_modelPar_WPSAT_dX=0.0;
modelStruct.modelPar_given_WPSAT=mod.given("WPSAT");
modParamMap["WPSAT"] = &(modelStruct.d_modelPar_WPSAT_dX);
modelStruct.modelPar_PPSAT=mod.PPSAT;
modelStruct.d_modelPar_PPSAT_dX=0.0;
modelStruct.modelPar_given_PPSAT=mod.given("PPSAT");
modParamMap["PPSAT"] = &(modelStruct.d_modelPar_PPSAT_dX);
modelStruct.modelPar_PSATL=mod.PSATL;
modelStruct.d_modelPar_PSATL_dX=0.0;
modelStruct.modelPar_given_PSATL=mod.given("PSATL");
modParamMap["PSATL"] = &(modelStruct.d_modelPar_PSATL_dX);
modelStruct.modelPar_PSATLEXP=mod.PSATLEXP;
modelStruct.d_modelPar_PSATLEXP_dX=0.0;
modelStruct.modelPar_given_PSATLEXP=mod.given("PSATLEXP");
modParamMap["PSATLEXP"] = &(modelStruct.d_modelPar_PSATLEXP_dX);
modelStruct.modelPar_PSATB=mod.PSATB;
modelStruct.d_modelPar_PSATB_dX=0.0;
modelStruct.modelPar_given_PSATB=mod.given("PSATB");
modParamMap["PSATB"] = &(modelStruct.d_modelPar_PSATB_dX);
modelStruct.modelPar_PSATR=mod.PSATR;
modelStruct.d_modelPar_PSATR_dX=0.0;
modelStruct.modelPar_given_PSATR=mod.given("PSATR");
modParamMap["PSATR"] = &(modelStruct.d_modelPar_PSATR_dX);
modelStruct.modelPar_LPSATR=mod.LPSATR;
modelStruct.d_modelPar_LPSATR_dX=0.0;
modelStruct.modelPar_given_LPSATR=mod.given("LPSATR");
modParamMap["LPSATR"] = &(modelStruct.d_modelPar_LPSATR_dX);
modelStruct.modelPar_WPSATR=mod.WPSATR;
modelStruct.d_modelPar_WPSATR_dX=0.0;
modelStruct.modelPar_given_WPSATR=mod.given("WPSATR");
modParamMap["WPSATR"] = &(modelStruct.d_modelPar_WPSATR_dX);
modelStruct.modelPar_PPSATR=mod.PPSATR;
modelStruct.d_modelPar_PPSATR_dX=0.0;
modelStruct.modelPar_given_PPSATR=mod.given("PPSATR");
modParamMap["PPSATR"] = &(modelStruct.d_modelPar_PPSATR_dX);
modelStruct.modelPar_LPSATB=mod.LPSATB;
modelStruct.d_modelPar_LPSATB_dX=0.0;
modelStruct.modelPar_given_LPSATB=mod.given("LPSATB");
modParamMap["LPSATB"] = &(modelStruct.d_modelPar_LPSATB_dX);
modelStruct.modelPar_WPSATB=mod.WPSATB;
modelStruct.d_modelPar_WPSATB_dX=0.0;
modelStruct.modelPar_given_WPSATB=mod.given("WPSATB");
modParamMap["WPSATB"] = &(modelStruct.d_modelPar_WPSATB_dX);
modelStruct.modelPar_PPSATB=mod.PPSATB;
modelStruct.d_modelPar_PPSATB_dX=0.0;
modelStruct.modelPar_given_PPSATB=mod.given("PPSATB");
modParamMap["PPSATB"] = &(modelStruct.d_modelPar_PPSATB_dX);
modelStruct.modelPar_PSATX=mod.PSATX;
modelStruct.d_modelPar_PSATX_dX=0.0;
modelStruct.modelPar_given_PSATX=mod.given("PSATX");
modParamMap["PSATX"] = &(modelStruct.d_modelPar_PSATX_dX);
modelStruct.modelPar_PTWG=mod.PTWG;
modelStruct.d_modelPar_PTWG_dX=0.0;
modelStruct.modelPar_given_PTWG=mod.given("PTWG");
modParamMap["PTWG"] = &(modelStruct.d_modelPar_PTWG_dX);
modelStruct.modelPar_LPTWG=mod.LPTWG;
modelStruct.d_modelPar_LPTWG_dX=0.0;
modelStruct.modelPar_given_LPTWG=mod.given("LPTWG");
modParamMap["LPTWG"] = &(modelStruct.d_modelPar_LPTWG_dX);
modelStruct.modelPar_WPTWG=mod.WPTWG;
modelStruct.d_modelPar_WPTWG_dX=0.0;
modelStruct.modelPar_given_WPTWG=mod.given("WPTWG");
modParamMap["WPTWG"] = &(modelStruct.d_modelPar_WPTWG_dX);
modelStruct.modelPar_PPTWG=mod.PPTWG;
modelStruct.d_modelPar_PPTWG_dX=0.0;
modelStruct.modelPar_given_PPTWG=mod.given("PPTWG");
modParamMap["PPTWG"] = &(modelStruct.d_modelPar_PPTWG_dX);
modelStruct.modelPar_PTWGL=mod.PTWGL;
modelStruct.d_modelPar_PTWGL_dX=0.0;
modelStruct.modelPar_given_PTWGL=mod.given("PTWGL");
modParamMap["PTWGL"] = &(modelStruct.d_modelPar_PTWGL_dX);
modelStruct.modelPar_PTWGLEXP=mod.PTWGLEXP;
modelStruct.d_modelPar_PTWGLEXP_dX=0.0;
modelStruct.modelPar_given_PTWGLEXP=mod.given("PTWGLEXP");
modParamMap["PTWGLEXP"] = &(modelStruct.d_modelPar_PTWGLEXP_dX);
modelStruct.modelPar_PTWGR=mod.PTWGR;
modelStruct.d_modelPar_PTWGR_dX=0.0;
modelStruct.modelPar_given_PTWGR=mod.given("PTWGR");
modParamMap["PTWGR"] = &(modelStruct.d_modelPar_PTWGR_dX);
modelStruct.modelPar_LPTWGR=mod.LPTWGR;
modelStruct.d_modelPar_LPTWGR_dX=0.0;
modelStruct.modelPar_given_LPTWGR=mod.given("LPTWGR");
modParamMap["LPTWGR"] = &(modelStruct.d_modelPar_LPTWGR_dX);
modelStruct.modelPar_WPTWGR=mod.WPTWGR;
modelStruct.d_modelPar_WPTWGR_dX=0.0;
modelStruct.modelPar_given_WPTWGR=mod.given("WPTWGR");
modParamMap["WPTWGR"] = &(modelStruct.d_modelPar_WPTWGR_dX);
modelStruct.modelPar_PPTWGR=mod.PPTWGR;
modelStruct.d_modelPar_PPTWGR_dX=0.0;
modelStruct.modelPar_given_PPTWGR=mod.given("PPTWGR");
modParamMap["PPTWGR"] = &(modelStruct.d_modelPar_PPTWGR_dX);
modelStruct.modelPar_PTWGLR=mod.PTWGLR;
modelStruct.d_modelPar_PTWGLR_dX=0.0;
modelStruct.modelPar_given_PTWGLR=mod.given("PTWGLR");
modParamMap["PTWGLR"] = &(modelStruct.d_modelPar_PTWGLR_dX);
modelStruct.modelPar_PTWGLEXPR=mod.PTWGLEXPR;
modelStruct.d_modelPar_PTWGLEXPR_dX=0.0;
modelStruct.modelPar_given_PTWGLEXPR=mod.given("PTWGLEXPR");
modParamMap["PTWGLEXPR"] = &(modelStruct.d_modelPar_PTWGLEXPR_dX);
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modParamMap["A1"] = &(modelStruct.d_modelPar_A1_dX);
modelStruct.modelPar_LA1=mod.LA1;
modelStruct.d_modelPar_LA1_dX=0.0;
modelStruct.modelPar_given_LA1=mod.given("LA1");
modParamMap["LA1"] = &(modelStruct.d_modelPar_LA1_dX);
modelStruct.modelPar_WA1=mod.WA1;
modelStruct.d_modelPar_WA1_dX=0.0;
modelStruct.modelPar_given_WA1=mod.given("WA1");
modParamMap["WA1"] = &(modelStruct.d_modelPar_WA1_dX);
modelStruct.modelPar_PA1=mod.PA1;
modelStruct.d_modelPar_PA1_dX=0.0;
modelStruct.modelPar_given_PA1=mod.given("PA1");
modParamMap["PA1"] = &(modelStruct.d_modelPar_PA1_dX);
modelStruct.modelPar_A11=mod.A11;
modelStruct.d_modelPar_A11_dX=0.0;
modelStruct.modelPar_given_A11=mod.given("A11");
modParamMap["A11"] = &(modelStruct.d_modelPar_A11_dX);
modelStruct.modelPar_LA11=mod.LA11;
modelStruct.d_modelPar_LA11_dX=0.0;
modelStruct.modelPar_given_LA11=mod.given("LA11");
modParamMap["LA11"] = &(modelStruct.d_modelPar_LA11_dX);
modelStruct.modelPar_WA11=mod.WA11;
modelStruct.d_modelPar_WA11_dX=0.0;
modelStruct.modelPar_given_WA11=mod.given("WA11");
modParamMap["WA11"] = &(modelStruct.d_modelPar_WA11_dX);
modelStruct.modelPar_PA11=mod.PA11;
modelStruct.d_modelPar_PA11_dX=0.0;
modelStruct.modelPar_given_PA11=mod.given("PA11");
modParamMap["PA11"] = &(modelStruct.d_modelPar_PA11_dX);
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modParamMap["A2"] = &(modelStruct.d_modelPar_A2_dX);
modelStruct.modelPar_LA2=mod.LA2;
modelStruct.d_modelPar_LA2_dX=0.0;
modelStruct.modelPar_given_LA2=mod.given("LA2");
modParamMap["LA2"] = &(modelStruct.d_modelPar_LA2_dX);
modelStruct.modelPar_WA2=mod.WA2;
modelStruct.d_modelPar_WA2_dX=0.0;
modelStruct.modelPar_given_WA2=mod.given("WA2");
modParamMap["WA2"] = &(modelStruct.d_modelPar_WA2_dX);
modelStruct.modelPar_PA2=mod.PA2;
modelStruct.d_modelPar_PA2_dX=0.0;
modelStruct.modelPar_given_PA2=mod.given("PA2");
modParamMap["PA2"] = &(modelStruct.d_modelPar_PA2_dX);
modelStruct.modelPar_A21=mod.A21;
modelStruct.d_modelPar_A21_dX=0.0;
modelStruct.modelPar_given_A21=mod.given("A21");
modParamMap["A21"] = &(modelStruct.d_modelPar_A21_dX);
modelStruct.modelPar_LA21=mod.LA21;
modelStruct.d_modelPar_LA21_dX=0.0;
modelStruct.modelPar_given_LA21=mod.given("LA21");
modParamMap["LA21"] = &(modelStruct.d_modelPar_LA21_dX);
modelStruct.modelPar_WA21=mod.WA21;
modelStruct.d_modelPar_WA21_dX=0.0;
modelStruct.modelPar_given_WA21=mod.given("WA21");
modParamMap["WA21"] = &(modelStruct.d_modelPar_WA21_dX);
modelStruct.modelPar_PA21=mod.PA21;
modelStruct.d_modelPar_PA21_dX=0.0;
modelStruct.modelPar_given_PA21=mod.given("PA21");
modParamMap["PA21"] = &(modelStruct.d_modelPar_PA21_dX);
modelStruct.modelPar_PDIBLC=mod.PDIBLC;
modelStruct.d_modelPar_PDIBLC_dX=0.0;
modelStruct.modelPar_given_PDIBLC=mod.given("PDIBLC");
modParamMap["PDIBLC"] = &(modelStruct.d_modelPar_PDIBLC_dX);
modelStruct.modelPar_PDIBLCL=mod.PDIBLCL;
modelStruct.d_modelPar_PDIBLCL_dX=0.0;
modelStruct.modelPar_given_PDIBLCL=mod.given("PDIBLCL");
modParamMap["PDIBLCL"] = &(modelStruct.d_modelPar_PDIBLCL_dX);
modelStruct.modelPar_PDIBLCLEXP=mod.PDIBLCLEXP;
modelStruct.d_modelPar_PDIBLCLEXP_dX=0.0;
modelStruct.modelPar_given_PDIBLCLEXP=mod.given("PDIBLCLEXP");
modParamMap["PDIBLCLEXP"] = &(modelStruct.d_modelPar_PDIBLCLEXP_dX);
modelStruct.modelPar_LPDIBLC=mod.LPDIBLC;
modelStruct.d_modelPar_LPDIBLC_dX=0.0;
modelStruct.modelPar_given_LPDIBLC=mod.given("LPDIBLC");
modParamMap["LPDIBLC"] = &(modelStruct.d_modelPar_LPDIBLC_dX);
modelStruct.modelPar_WPDIBLC=mod.WPDIBLC;
modelStruct.d_modelPar_WPDIBLC_dX=0.0;
modelStruct.modelPar_given_WPDIBLC=mod.given("WPDIBLC");
modParamMap["WPDIBLC"] = &(modelStruct.d_modelPar_WPDIBLC_dX);
modelStruct.modelPar_PPDIBLC=mod.PPDIBLC;
modelStruct.d_modelPar_PPDIBLC_dX=0.0;
modelStruct.modelPar_given_PPDIBLC=mod.given("PPDIBLC");
modParamMap["PPDIBLC"] = &(modelStruct.d_modelPar_PPDIBLC_dX);
modelStruct.modelPar_PDIBLCR=mod.PDIBLCR;
modelStruct.d_modelPar_PDIBLCR_dX=0.0;
modelStruct.modelPar_given_PDIBLCR=mod.given("PDIBLCR");
modParamMap["PDIBLCR"] = &(modelStruct.d_modelPar_PDIBLCR_dX);
modelStruct.modelPar_PDIBLCLR=mod.PDIBLCLR;
modelStruct.d_modelPar_PDIBLCLR_dX=0.0;
modelStruct.modelPar_given_PDIBLCLR=mod.given("PDIBLCLR");
modParamMap["PDIBLCLR"] = &(modelStruct.d_modelPar_PDIBLCLR_dX);
modelStruct.modelPar_PDIBLCLEXPR=mod.PDIBLCLEXPR;
modelStruct.d_modelPar_PDIBLCLEXPR_dX=0.0;
modelStruct.modelPar_given_PDIBLCLEXPR=mod.given("PDIBLCLEXPR");
modParamMap["PDIBLCLEXPR"] = &(modelStruct.d_modelPar_PDIBLCLEXPR_dX);
modelStruct.modelPar_LPDIBLCR=mod.LPDIBLCR;
modelStruct.d_modelPar_LPDIBLCR_dX=0.0;
modelStruct.modelPar_given_LPDIBLCR=mod.given("LPDIBLCR");
modParamMap["LPDIBLCR"] = &(modelStruct.d_modelPar_LPDIBLCR_dX);
modelStruct.modelPar_WPDIBLCR=mod.WPDIBLCR;
modelStruct.d_modelPar_WPDIBLCR_dX=0.0;
modelStruct.modelPar_given_WPDIBLCR=mod.given("WPDIBLCR");
modParamMap["WPDIBLCR"] = &(modelStruct.d_modelPar_WPDIBLCR_dX);
modelStruct.modelPar_PPDIBLCR=mod.PPDIBLCR;
modelStruct.d_modelPar_PPDIBLCR_dX=0.0;
modelStruct.modelPar_given_PPDIBLCR=mod.given("PPDIBLCR");
modParamMap["PPDIBLCR"] = &(modelStruct.d_modelPar_PPDIBLCR_dX);
modelStruct.modelPar_PDIBLCB=mod.PDIBLCB;
modelStruct.d_modelPar_PDIBLCB_dX=0.0;
modelStruct.modelPar_given_PDIBLCB=mod.given("PDIBLCB");
modParamMap["PDIBLCB"] = &(modelStruct.d_modelPar_PDIBLCB_dX);
modelStruct.modelPar_LPDIBLCB=mod.LPDIBLCB;
modelStruct.d_modelPar_LPDIBLCB_dX=0.0;
modelStruct.modelPar_given_LPDIBLCB=mod.given("LPDIBLCB");
modParamMap["LPDIBLCB"] = &(modelStruct.d_modelPar_LPDIBLCB_dX);
modelStruct.modelPar_WPDIBLCB=mod.WPDIBLCB;
modelStruct.d_modelPar_WPDIBLCB_dX=0.0;
modelStruct.modelPar_given_WPDIBLCB=mod.given("WPDIBLCB");
modParamMap["WPDIBLCB"] = &(modelStruct.d_modelPar_WPDIBLCB_dX);
modelStruct.modelPar_PPDIBLCB=mod.PPDIBLCB;
modelStruct.d_modelPar_PPDIBLCB_dX=0.0;
modelStruct.modelPar_given_PPDIBLCB=mod.given("PPDIBLCB");
modParamMap["PPDIBLCB"] = &(modelStruct.d_modelPar_PPDIBLCB_dX);
modelStruct.modelPar_PVAG=mod.PVAG;
modelStruct.d_modelPar_PVAG_dX=0.0;
modelStruct.modelPar_given_PVAG=mod.given("PVAG");
modParamMap["PVAG"] = &(modelStruct.d_modelPar_PVAG_dX);
modelStruct.modelPar_LPVAG=mod.LPVAG;
modelStruct.d_modelPar_LPVAG_dX=0.0;
modelStruct.modelPar_given_LPVAG=mod.given("LPVAG");
modParamMap["LPVAG"] = &(modelStruct.d_modelPar_LPVAG_dX);
modelStruct.modelPar_WPVAG=mod.WPVAG;
modelStruct.d_modelPar_WPVAG_dX=0.0;
modelStruct.modelPar_given_WPVAG=mod.given("WPVAG");
modParamMap["WPVAG"] = &(modelStruct.d_modelPar_WPVAG_dX);
modelStruct.modelPar_PPVAG=mod.PPVAG;
modelStruct.d_modelPar_PPVAG_dX=0.0;
modelStruct.modelPar_given_PPVAG=mod.given("PPVAG");
modParamMap["PPVAG"] = &(modelStruct.d_modelPar_PPVAG_dX);
modelStruct.modelPar_FPROUT=mod.FPROUT;
modelStruct.d_modelPar_FPROUT_dX=0.0;
modelStruct.modelPar_given_FPROUT=mod.given("FPROUT");
modParamMap["FPROUT"] = &(modelStruct.d_modelPar_FPROUT_dX);
modelStruct.modelPar_FPROUTL=mod.FPROUTL;
modelStruct.d_modelPar_FPROUTL_dX=0.0;
modelStruct.modelPar_given_FPROUTL=mod.given("FPROUTL");
modParamMap["FPROUTL"] = &(modelStruct.d_modelPar_FPROUTL_dX);
modelStruct.modelPar_FPROUTLEXP=mod.FPROUTLEXP;
modelStruct.d_modelPar_FPROUTLEXP_dX=0.0;
modelStruct.modelPar_given_FPROUTLEXP=mod.given("FPROUTLEXP");
modParamMap["FPROUTLEXP"] = &(modelStruct.d_modelPar_FPROUTLEXP_dX);
modelStruct.modelPar_LFPROUT=mod.LFPROUT;
modelStruct.d_modelPar_LFPROUT_dX=0.0;
modelStruct.modelPar_given_LFPROUT=mod.given("LFPROUT");
modParamMap["LFPROUT"] = &(modelStruct.d_modelPar_LFPROUT_dX);
modelStruct.modelPar_WFPROUT=mod.WFPROUT;
modelStruct.d_modelPar_WFPROUT_dX=0.0;
modelStruct.modelPar_given_WFPROUT=mod.given("WFPROUT");
modParamMap["WFPROUT"] = &(modelStruct.d_modelPar_WFPROUT_dX);
modelStruct.modelPar_PFPROUT=mod.PFPROUT;
modelStruct.d_modelPar_PFPROUT_dX=0.0;
modelStruct.modelPar_given_PFPROUT=mod.given("PFPROUT");
modParamMap["PFPROUT"] = &(modelStruct.d_modelPar_PFPROUT_dX);
modelStruct.modelPar_ALPHA0=mod.ALPHA0;
modelStruct.d_modelPar_ALPHA0_dX=0.0;
modelStruct.modelPar_given_ALPHA0=mod.given("ALPHA0");
modParamMap["ALPHA0"] = &(modelStruct.d_modelPar_ALPHA0_dX);
modelStruct.modelPar_ALPHA0L=mod.ALPHA0L;
modelStruct.d_modelPar_ALPHA0L_dX=0.0;
modelStruct.modelPar_given_ALPHA0L=mod.given("ALPHA0L");
modParamMap["ALPHA0L"] = &(modelStruct.d_modelPar_ALPHA0L_dX);
modelStruct.modelPar_ALPHA0LEXP=mod.ALPHA0LEXP;
modelStruct.d_modelPar_ALPHA0LEXP_dX=0.0;
modelStruct.modelPar_given_ALPHA0LEXP=mod.given("ALPHA0LEXP");
modParamMap["ALPHA0LEXP"] = &(modelStruct.d_modelPar_ALPHA0LEXP_dX);
modelStruct.modelPar_LALPHA0=mod.LALPHA0;
modelStruct.d_modelPar_LALPHA0_dX=0.0;
modelStruct.modelPar_given_LALPHA0=mod.given("LALPHA0");
modParamMap["LALPHA0"] = &(modelStruct.d_modelPar_LALPHA0_dX);
modelStruct.modelPar_WALPHA0=mod.WALPHA0;
modelStruct.d_modelPar_WALPHA0_dX=0.0;
modelStruct.modelPar_given_WALPHA0=mod.given("WALPHA0");
modParamMap["WALPHA0"] = &(modelStruct.d_modelPar_WALPHA0_dX);
modelStruct.modelPar_PALPHA0=mod.PALPHA0;
modelStruct.d_modelPar_PALPHA0_dX=0.0;
modelStruct.modelPar_given_PALPHA0=mod.given("PALPHA0");
modParamMap["PALPHA0"] = &(modelStruct.d_modelPar_PALPHA0_dX);
modelStruct.modelPar_BETA0=mod.BETA0;
modelStruct.d_modelPar_BETA0_dX=0.0;
modelStruct.modelPar_given_BETA0=mod.given("BETA0");
modParamMap["BETA0"] = &(modelStruct.d_modelPar_BETA0_dX);
modelStruct.modelPar_LBETA0=mod.LBETA0;
modelStruct.d_modelPar_LBETA0_dX=0.0;
modelStruct.modelPar_given_LBETA0=mod.given("LBETA0");
modParamMap["LBETA0"] = &(modelStruct.d_modelPar_LBETA0_dX);
modelStruct.modelPar_WBETA0=mod.WBETA0;
modelStruct.d_modelPar_WBETA0_dX=0.0;
modelStruct.modelPar_given_WBETA0=mod.given("WBETA0");
modParamMap["WBETA0"] = &(modelStruct.d_modelPar_WBETA0_dX);
modelStruct.modelPar_PBETA0=mod.PBETA0;
modelStruct.d_modelPar_PBETA0_dX=0.0;
modelStruct.modelPar_given_PBETA0=mod.given("PBETA0");
modParamMap["PBETA0"] = &(modelStruct.d_modelPar_PBETA0_dX);
modelStruct.modelPar_AIGBACC=mod.AIGBACC;
modelStruct.d_modelPar_AIGBACC_dX=0.0;
modelStruct.modelPar_given_AIGBACC=mod.given("AIGBACC");
modParamMap["AIGBACC"] = &(modelStruct.d_modelPar_AIGBACC_dX);
modelStruct.modelPar_BIGBACC=mod.BIGBACC;
modelStruct.d_modelPar_BIGBACC_dX=0.0;
modelStruct.modelPar_given_BIGBACC=mod.given("BIGBACC");
modParamMap["BIGBACC"] = &(modelStruct.d_modelPar_BIGBACC_dX);
modelStruct.modelPar_CIGBACC=mod.CIGBACC;
modelStruct.d_modelPar_CIGBACC_dX=0.0;
modelStruct.modelPar_given_CIGBACC=mod.given("CIGBACC");
modParamMap["CIGBACC"] = &(modelStruct.d_modelPar_CIGBACC_dX);
modelStruct.modelPar_NIGBACC=mod.NIGBACC;
modelStruct.d_modelPar_NIGBACC_dX=0.0;
modelStruct.modelPar_given_NIGBACC=mod.given("NIGBACC");
modParamMap["NIGBACC"] = &(modelStruct.d_modelPar_NIGBACC_dX);
modelStruct.modelPar_AIGBINV=mod.AIGBINV;
modelStruct.d_modelPar_AIGBINV_dX=0.0;
modelStruct.modelPar_given_AIGBINV=mod.given("AIGBINV");
modParamMap["AIGBINV"] = &(modelStruct.d_modelPar_AIGBINV_dX);
modelStruct.modelPar_BIGBINV=mod.BIGBINV;
modelStruct.d_modelPar_BIGBINV_dX=0.0;
modelStruct.modelPar_given_BIGBINV=mod.given("BIGBINV");
modParamMap["BIGBINV"] = &(modelStruct.d_modelPar_BIGBINV_dX);
modelStruct.modelPar_CIGBINV=mod.CIGBINV;
modelStruct.d_modelPar_CIGBINV_dX=0.0;
modelStruct.modelPar_given_CIGBINV=mod.given("CIGBINV");
modParamMap["CIGBINV"] = &(modelStruct.d_modelPar_CIGBINV_dX);
modelStruct.modelPar_EIGBINV=mod.EIGBINV;
modelStruct.d_modelPar_EIGBINV_dX=0.0;
modelStruct.modelPar_given_EIGBINV=mod.given("EIGBINV");
modParamMap["EIGBINV"] = &(modelStruct.d_modelPar_EIGBINV_dX);
modelStruct.modelPar_NIGBINV=mod.NIGBINV;
modelStruct.d_modelPar_NIGBINV_dX=0.0;
modelStruct.modelPar_given_NIGBINV=mod.given("NIGBINV");
modParamMap["NIGBINV"] = &(modelStruct.d_modelPar_NIGBINV_dX);
modelStruct.modelPar_AIGC=mod.AIGC;
modelStruct.d_modelPar_AIGC_dX=0.0;
modelStruct.modelPar_given_AIGC=mod.given("AIGC");
modParamMap["AIGC"] = &(modelStruct.d_modelPar_AIGC_dX);
modelStruct.modelPar_BIGC=mod.BIGC;
modelStruct.d_modelPar_BIGC_dX=0.0;
modelStruct.modelPar_given_BIGC=mod.given("BIGC");
modParamMap["BIGC"] = &(modelStruct.d_modelPar_BIGC_dX);
modelStruct.modelPar_CIGC=mod.CIGC;
modelStruct.d_modelPar_CIGC_dX=0.0;
modelStruct.modelPar_given_CIGC=mod.given("CIGC");
modParamMap["CIGC"] = &(modelStruct.d_modelPar_CIGC_dX);
modelStruct.modelPar_AIGS=mod.AIGS;
modelStruct.d_modelPar_AIGS_dX=0.0;
modelStruct.modelPar_given_AIGS=mod.given("AIGS");
modParamMap["AIGS"] = &(modelStruct.d_modelPar_AIGS_dX);
modelStruct.modelPar_BIGS=mod.BIGS;
modelStruct.d_modelPar_BIGS_dX=0.0;
modelStruct.modelPar_given_BIGS=mod.given("BIGS");
modParamMap["BIGS"] = &(modelStruct.d_modelPar_BIGS_dX);
modelStruct.modelPar_CIGS=mod.CIGS;
modelStruct.d_modelPar_CIGS_dX=0.0;
modelStruct.modelPar_given_CIGS=mod.given("CIGS");
modParamMap["CIGS"] = &(modelStruct.d_modelPar_CIGS_dX);
modelStruct.modelPar_AIGD=mod.AIGD;
modelStruct.d_modelPar_AIGD_dX=0.0;
modelStruct.modelPar_given_AIGD=mod.given("AIGD");
modParamMap["AIGD"] = &(modelStruct.d_modelPar_AIGD_dX);
modelStruct.modelPar_BIGD=mod.BIGD;
modelStruct.d_modelPar_BIGD_dX=0.0;
modelStruct.modelPar_given_BIGD=mod.given("BIGD");
modParamMap["BIGD"] = &(modelStruct.d_modelPar_BIGD_dX);
modelStruct.modelPar_CIGD=mod.CIGD;
modelStruct.d_modelPar_CIGD_dX=0.0;
modelStruct.modelPar_given_CIGD=mod.given("CIGD");
modParamMap["CIGD"] = &(modelStruct.d_modelPar_CIGD_dX);
modelStruct.modelPar_DLCIG=mod.DLCIG;
modelStruct.d_modelPar_DLCIG_dX=0.0;
modelStruct.modelPar_given_DLCIG=mod.given("DLCIG");
modParamMap["DLCIG"] = &(modelStruct.d_modelPar_DLCIG_dX);
modelStruct.modelPar_DLCIGD=mod.DLCIGD;
modelStruct.d_modelPar_DLCIGD_dX=0.0;
modelStruct.modelPar_given_DLCIGD=mod.given("DLCIGD");
modParamMap["DLCIGD"] = &(modelStruct.d_modelPar_DLCIGD_dX);
modelStruct.modelPar_POXEDGE=mod.POXEDGE;
modelStruct.d_modelPar_POXEDGE_dX=0.0;
modelStruct.modelPar_given_POXEDGE=mod.given("POXEDGE");
modParamMap["POXEDGE"] = &(modelStruct.d_modelPar_POXEDGE_dX);
modelStruct.modelPar_NTOX=mod.NTOX;
modelStruct.d_modelPar_NTOX_dX=0.0;
modelStruct.modelPar_given_NTOX=mod.given("NTOX");
modParamMap["NTOX"] = &(modelStruct.d_modelPar_NTOX_dX);
modelStruct.modelPar_TOXREF=mod.TOXREF;
modelStruct.d_modelPar_TOXREF_dX=0.0;
modelStruct.modelPar_given_TOXREF=mod.given("TOXREF");
modParamMap["TOXREF"] = &(modelStruct.d_modelPar_TOXREF_dX);
modelStruct.modelPar_PIGCD=mod.PIGCD;
modelStruct.d_modelPar_PIGCD_dX=0.0;
modelStruct.modelPar_given_PIGCD=mod.given("PIGCD");
modParamMap["PIGCD"] = &(modelStruct.d_modelPar_PIGCD_dX);
modelStruct.modelPar_AIGCL=mod.AIGCL;
modelStruct.d_modelPar_AIGCL_dX=0.0;
modelStruct.modelPar_given_AIGCL=mod.given("AIGCL");
modParamMap["AIGCL"] = &(modelStruct.d_modelPar_AIGCL_dX);
modelStruct.modelPar_AIGCW=mod.AIGCW;
modelStruct.d_modelPar_AIGCW_dX=0.0;
modelStruct.modelPar_given_AIGCW=mod.given("AIGCW");
modParamMap["AIGCW"] = &(modelStruct.d_modelPar_AIGCW_dX);
modelStruct.modelPar_AIGSL=mod.AIGSL;
modelStruct.d_modelPar_AIGSL_dX=0.0;
modelStruct.modelPar_given_AIGSL=mod.given("AIGSL");
modParamMap["AIGSL"] = &(modelStruct.d_modelPar_AIGSL_dX);
modelStruct.modelPar_AIGSW=mod.AIGSW;
modelStruct.d_modelPar_AIGSW_dX=0.0;
modelStruct.modelPar_given_AIGSW=mod.given("AIGSW");
modParamMap["AIGSW"] = &(modelStruct.d_modelPar_AIGSW_dX);
modelStruct.modelPar_AIGDL=mod.AIGDL;
modelStruct.d_modelPar_AIGDL_dX=0.0;
modelStruct.modelPar_given_AIGDL=mod.given("AIGDL");
modParamMap["AIGDL"] = &(modelStruct.d_modelPar_AIGDL_dX);
modelStruct.modelPar_AIGDW=mod.AIGDW;
modelStruct.d_modelPar_AIGDW_dX=0.0;
modelStruct.modelPar_given_AIGDW=mod.given("AIGDW");
modParamMap["AIGDW"] = &(modelStruct.d_modelPar_AIGDW_dX);
modelStruct.modelPar_PIGCDL=mod.PIGCDL;
modelStruct.d_modelPar_PIGCDL_dX=0.0;
modelStruct.modelPar_given_PIGCDL=mod.given("PIGCDL");
modParamMap["PIGCDL"] = &(modelStruct.d_modelPar_PIGCDL_dX);
modelStruct.modelPar_LAIGBINV=mod.LAIGBINV;
modelStruct.d_modelPar_LAIGBINV_dX=0.0;
modelStruct.modelPar_given_LAIGBINV=mod.given("LAIGBINV");
modParamMap["LAIGBINV"] = &(modelStruct.d_modelPar_LAIGBINV_dX);
modelStruct.modelPar_WAIGBINV=mod.WAIGBINV;
modelStruct.d_modelPar_WAIGBINV_dX=0.0;
modelStruct.modelPar_given_WAIGBINV=mod.given("WAIGBINV");
modParamMap["WAIGBINV"] = &(modelStruct.d_modelPar_WAIGBINV_dX);
modelStruct.modelPar_PAIGBINV=mod.PAIGBINV;
modelStruct.d_modelPar_PAIGBINV_dX=0.0;
modelStruct.modelPar_given_PAIGBINV=mod.given("PAIGBINV");
modParamMap["PAIGBINV"] = &(modelStruct.d_modelPar_PAIGBINV_dX);
modelStruct.modelPar_LBIGBINV=mod.LBIGBINV;
modelStruct.d_modelPar_LBIGBINV_dX=0.0;
modelStruct.modelPar_given_LBIGBINV=mod.given("LBIGBINV");
modParamMap["LBIGBINV"] = &(modelStruct.d_modelPar_LBIGBINV_dX);
modelStruct.modelPar_WBIGBINV=mod.WBIGBINV;
modelStruct.d_modelPar_WBIGBINV_dX=0.0;
modelStruct.modelPar_given_WBIGBINV=mod.given("WBIGBINV");
modParamMap["WBIGBINV"] = &(modelStruct.d_modelPar_WBIGBINV_dX);
modelStruct.modelPar_PBIGBINV=mod.PBIGBINV;
modelStruct.d_modelPar_PBIGBINV_dX=0.0;
modelStruct.modelPar_given_PBIGBINV=mod.given("PBIGBINV");
modParamMap["PBIGBINV"] = &(modelStruct.d_modelPar_PBIGBINV_dX);
modelStruct.modelPar_LCIGBINV=mod.LCIGBINV;
modelStruct.d_modelPar_LCIGBINV_dX=0.0;
modelStruct.modelPar_given_LCIGBINV=mod.given("LCIGBINV");
modParamMap["LCIGBINV"] = &(modelStruct.d_modelPar_LCIGBINV_dX);
modelStruct.modelPar_WCIGBINV=mod.WCIGBINV;
modelStruct.d_modelPar_WCIGBINV_dX=0.0;
modelStruct.modelPar_given_WCIGBINV=mod.given("WCIGBINV");
modParamMap["WCIGBINV"] = &(modelStruct.d_modelPar_WCIGBINV_dX);
modelStruct.modelPar_PCIGBINV=mod.PCIGBINV;
modelStruct.d_modelPar_PCIGBINV_dX=0.0;
modelStruct.modelPar_given_PCIGBINV=mod.given("PCIGBINV");
modParamMap["PCIGBINV"] = &(modelStruct.d_modelPar_PCIGBINV_dX);
modelStruct.modelPar_LEIGBINV=mod.LEIGBINV;
modelStruct.d_modelPar_LEIGBINV_dX=0.0;
modelStruct.modelPar_given_LEIGBINV=mod.given("LEIGBINV");
modParamMap["LEIGBINV"] = &(modelStruct.d_modelPar_LEIGBINV_dX);
modelStruct.modelPar_WEIGBINV=mod.WEIGBINV;
modelStruct.d_modelPar_WEIGBINV_dX=0.0;
modelStruct.modelPar_given_WEIGBINV=mod.given("WEIGBINV");
modParamMap["WEIGBINV"] = &(modelStruct.d_modelPar_WEIGBINV_dX);
modelStruct.modelPar_PEIGBINV=mod.PEIGBINV;
modelStruct.d_modelPar_PEIGBINV_dX=0.0;
modelStruct.modelPar_given_PEIGBINV=mod.given("PEIGBINV");
modParamMap["PEIGBINV"] = &(modelStruct.d_modelPar_PEIGBINV_dX);
modelStruct.modelPar_LNIGBINV=mod.LNIGBINV;
modelStruct.d_modelPar_LNIGBINV_dX=0.0;
modelStruct.modelPar_given_LNIGBINV=mod.given("LNIGBINV");
modParamMap["LNIGBINV"] = &(modelStruct.d_modelPar_LNIGBINV_dX);
modelStruct.modelPar_WNIGBINV=mod.WNIGBINV;
modelStruct.d_modelPar_WNIGBINV_dX=0.0;
modelStruct.modelPar_given_WNIGBINV=mod.given("WNIGBINV");
modParamMap["WNIGBINV"] = &(modelStruct.d_modelPar_WNIGBINV_dX);
modelStruct.modelPar_PNIGBINV=mod.PNIGBINV;
modelStruct.d_modelPar_PNIGBINV_dX=0.0;
modelStruct.modelPar_given_PNIGBINV=mod.given("PNIGBINV");
modParamMap["PNIGBINV"] = &(modelStruct.d_modelPar_PNIGBINV_dX);
modelStruct.modelPar_LAIGBACC=mod.LAIGBACC;
modelStruct.d_modelPar_LAIGBACC_dX=0.0;
modelStruct.modelPar_given_LAIGBACC=mod.given("LAIGBACC");
modParamMap["LAIGBACC"] = &(modelStruct.d_modelPar_LAIGBACC_dX);
modelStruct.modelPar_WAIGBACC=mod.WAIGBACC;
modelStruct.d_modelPar_WAIGBACC_dX=0.0;
modelStruct.modelPar_given_WAIGBACC=mod.given("WAIGBACC");
modParamMap["WAIGBACC"] = &(modelStruct.d_modelPar_WAIGBACC_dX);
modelStruct.modelPar_PAIGBACC=mod.PAIGBACC;
modelStruct.d_modelPar_PAIGBACC_dX=0.0;
modelStruct.modelPar_given_PAIGBACC=mod.given("PAIGBACC");
modParamMap["PAIGBACC"] = &(modelStruct.d_modelPar_PAIGBACC_dX);
modelStruct.modelPar_LBIGBACC=mod.LBIGBACC;
modelStruct.d_modelPar_LBIGBACC_dX=0.0;
modelStruct.modelPar_given_LBIGBACC=mod.given("LBIGBACC");
modParamMap["LBIGBACC"] = &(modelStruct.d_modelPar_LBIGBACC_dX);
modelStruct.modelPar_WBIGBACC=mod.WBIGBACC;
modelStruct.d_modelPar_WBIGBACC_dX=0.0;
modelStruct.modelPar_given_WBIGBACC=mod.given("WBIGBACC");
modParamMap["WBIGBACC"] = &(modelStruct.d_modelPar_WBIGBACC_dX);
modelStruct.modelPar_PBIGBACC=mod.PBIGBACC;
modelStruct.d_modelPar_PBIGBACC_dX=0.0;
modelStruct.modelPar_given_PBIGBACC=mod.given("PBIGBACC");
modParamMap["PBIGBACC"] = &(modelStruct.d_modelPar_PBIGBACC_dX);
modelStruct.modelPar_LCIGBACC=mod.LCIGBACC;
modelStruct.d_modelPar_LCIGBACC_dX=0.0;
modelStruct.modelPar_given_LCIGBACC=mod.given("LCIGBACC");
modParamMap["LCIGBACC"] = &(modelStruct.d_modelPar_LCIGBACC_dX);
modelStruct.modelPar_WCIGBACC=mod.WCIGBACC;
modelStruct.d_modelPar_WCIGBACC_dX=0.0;
modelStruct.modelPar_given_WCIGBACC=mod.given("WCIGBACC");
modParamMap["WCIGBACC"] = &(modelStruct.d_modelPar_WCIGBACC_dX);
modelStruct.modelPar_PCIGBACC=mod.PCIGBACC;
modelStruct.d_modelPar_PCIGBACC_dX=0.0;
modelStruct.modelPar_given_PCIGBACC=mod.given("PCIGBACC");
modParamMap["PCIGBACC"] = &(modelStruct.d_modelPar_PCIGBACC_dX);
modelStruct.modelPar_LNIGBACC=mod.LNIGBACC;
modelStruct.d_modelPar_LNIGBACC_dX=0.0;
modelStruct.modelPar_given_LNIGBACC=mod.given("LNIGBACC");
modParamMap["LNIGBACC"] = &(modelStruct.d_modelPar_LNIGBACC_dX);
modelStruct.modelPar_WNIGBACC=mod.WNIGBACC;
modelStruct.d_modelPar_WNIGBACC_dX=0.0;
modelStruct.modelPar_given_WNIGBACC=mod.given("WNIGBACC");
modParamMap["WNIGBACC"] = &(modelStruct.d_modelPar_WNIGBACC_dX);
modelStruct.modelPar_PNIGBACC=mod.PNIGBACC;
modelStruct.d_modelPar_PNIGBACC_dX=0.0;
modelStruct.modelPar_given_PNIGBACC=mod.given("PNIGBACC");
modParamMap["PNIGBACC"] = &(modelStruct.d_modelPar_PNIGBACC_dX);
modelStruct.modelPar_LAIGC=mod.LAIGC;
modelStruct.d_modelPar_LAIGC_dX=0.0;
modelStruct.modelPar_given_LAIGC=mod.given("LAIGC");
modParamMap["LAIGC"] = &(modelStruct.d_modelPar_LAIGC_dX);
modelStruct.modelPar_WAIGC=mod.WAIGC;
modelStruct.d_modelPar_WAIGC_dX=0.0;
modelStruct.modelPar_given_WAIGC=mod.given("WAIGC");
modParamMap["WAIGC"] = &(modelStruct.d_modelPar_WAIGC_dX);
modelStruct.modelPar_PAIGC=mod.PAIGC;
modelStruct.d_modelPar_PAIGC_dX=0.0;
modelStruct.modelPar_given_PAIGC=mod.given("PAIGC");
modParamMap["PAIGC"] = &(modelStruct.d_modelPar_PAIGC_dX);
modelStruct.modelPar_LBIGC=mod.LBIGC;
modelStruct.d_modelPar_LBIGC_dX=0.0;
modelStruct.modelPar_given_LBIGC=mod.given("LBIGC");
modParamMap["LBIGC"] = &(modelStruct.d_modelPar_LBIGC_dX);
modelStruct.modelPar_WBIGC=mod.WBIGC;
modelStruct.d_modelPar_WBIGC_dX=0.0;
modelStruct.modelPar_given_WBIGC=mod.given("WBIGC");
modParamMap["WBIGC"] = &(modelStruct.d_modelPar_WBIGC_dX);
modelStruct.modelPar_PBIGC=mod.PBIGC;
modelStruct.d_modelPar_PBIGC_dX=0.0;
modelStruct.modelPar_given_PBIGC=mod.given("PBIGC");
modParamMap["PBIGC"] = &(modelStruct.d_modelPar_PBIGC_dX);
modelStruct.modelPar_LCIGC=mod.LCIGC;
modelStruct.d_modelPar_LCIGC_dX=0.0;
modelStruct.modelPar_given_LCIGC=mod.given("LCIGC");
modParamMap["LCIGC"] = &(modelStruct.d_modelPar_LCIGC_dX);
modelStruct.modelPar_WCIGC=mod.WCIGC;
modelStruct.d_modelPar_WCIGC_dX=0.0;
modelStruct.modelPar_given_WCIGC=mod.given("WCIGC");
modParamMap["WCIGC"] = &(modelStruct.d_modelPar_WCIGC_dX);
modelStruct.modelPar_PCIGC=mod.PCIGC;
modelStruct.d_modelPar_PCIGC_dX=0.0;
modelStruct.modelPar_given_PCIGC=mod.given("PCIGC");
modParamMap["PCIGC"] = &(modelStruct.d_modelPar_PCIGC_dX);
modelStruct.modelPar_LAIGS=mod.LAIGS;
modelStruct.d_modelPar_LAIGS_dX=0.0;
modelStruct.modelPar_given_LAIGS=mod.given("LAIGS");
modParamMap["LAIGS"] = &(modelStruct.d_modelPar_LAIGS_dX);
modelStruct.modelPar_WAIGS=mod.WAIGS;
modelStruct.d_modelPar_WAIGS_dX=0.0;
modelStruct.modelPar_given_WAIGS=mod.given("WAIGS");
modParamMap["WAIGS"] = &(modelStruct.d_modelPar_WAIGS_dX);
modelStruct.modelPar_PAIGS=mod.PAIGS;
modelStruct.d_modelPar_PAIGS_dX=0.0;
modelStruct.modelPar_given_PAIGS=mod.given("PAIGS");
modParamMap["PAIGS"] = &(modelStruct.d_modelPar_PAIGS_dX);
modelStruct.modelPar_LBIGS=mod.LBIGS;
modelStruct.d_modelPar_LBIGS_dX=0.0;
modelStruct.modelPar_given_LBIGS=mod.given("LBIGS");
modParamMap["LBIGS"] = &(modelStruct.d_modelPar_LBIGS_dX);
modelStruct.modelPar_WBIGS=mod.WBIGS;
modelStruct.d_modelPar_WBIGS_dX=0.0;
modelStruct.modelPar_given_WBIGS=mod.given("WBIGS");
modParamMap["WBIGS"] = &(modelStruct.d_modelPar_WBIGS_dX);
modelStruct.modelPar_PBIGS=mod.PBIGS;
modelStruct.d_modelPar_PBIGS_dX=0.0;
modelStruct.modelPar_given_PBIGS=mod.given("PBIGS");
modParamMap["PBIGS"] = &(modelStruct.d_modelPar_PBIGS_dX);
modelStruct.modelPar_LCIGS=mod.LCIGS;
modelStruct.d_modelPar_LCIGS_dX=0.0;
modelStruct.modelPar_given_LCIGS=mod.given("LCIGS");
modParamMap["LCIGS"] = &(modelStruct.d_modelPar_LCIGS_dX);
modelStruct.modelPar_WCIGS=mod.WCIGS;
modelStruct.d_modelPar_WCIGS_dX=0.0;
modelStruct.modelPar_given_WCIGS=mod.given("WCIGS");
modParamMap["WCIGS"] = &(modelStruct.d_modelPar_WCIGS_dX);
modelStruct.modelPar_PCIGS=mod.PCIGS;
modelStruct.d_modelPar_PCIGS_dX=0.0;
modelStruct.modelPar_given_PCIGS=mod.given("PCIGS");
modParamMap["PCIGS"] = &(modelStruct.d_modelPar_PCIGS_dX);
modelStruct.modelPar_LAIGD=mod.LAIGD;
modelStruct.d_modelPar_LAIGD_dX=0.0;
modelStruct.modelPar_given_LAIGD=mod.given("LAIGD");
modParamMap["LAIGD"] = &(modelStruct.d_modelPar_LAIGD_dX);
modelStruct.modelPar_WAIGD=mod.WAIGD;
modelStruct.d_modelPar_WAIGD_dX=0.0;
modelStruct.modelPar_given_WAIGD=mod.given("WAIGD");
modParamMap["WAIGD"] = &(modelStruct.d_modelPar_WAIGD_dX);
modelStruct.modelPar_PAIGD=mod.PAIGD;
modelStruct.d_modelPar_PAIGD_dX=0.0;
modelStruct.modelPar_given_PAIGD=mod.given("PAIGD");
modParamMap["PAIGD"] = &(modelStruct.d_modelPar_PAIGD_dX);
modelStruct.modelPar_LBIGD=mod.LBIGD;
modelStruct.d_modelPar_LBIGD_dX=0.0;
modelStruct.modelPar_given_LBIGD=mod.given("LBIGD");
modParamMap["LBIGD"] = &(modelStruct.d_modelPar_LBIGD_dX);
modelStruct.modelPar_WBIGD=mod.WBIGD;
modelStruct.d_modelPar_WBIGD_dX=0.0;
modelStruct.modelPar_given_WBIGD=mod.given("WBIGD");
modParamMap["WBIGD"] = &(modelStruct.d_modelPar_WBIGD_dX);
modelStruct.modelPar_PBIGD=mod.PBIGD;
modelStruct.d_modelPar_PBIGD_dX=0.0;
modelStruct.modelPar_given_PBIGD=mod.given("PBIGD");
modParamMap["PBIGD"] = &(modelStruct.d_modelPar_PBIGD_dX);
modelStruct.modelPar_LCIGD=mod.LCIGD;
modelStruct.d_modelPar_LCIGD_dX=0.0;
modelStruct.modelPar_given_LCIGD=mod.given("LCIGD");
modParamMap["LCIGD"] = &(modelStruct.d_modelPar_LCIGD_dX);
modelStruct.modelPar_WCIGD=mod.WCIGD;
modelStruct.d_modelPar_WCIGD_dX=0.0;
modelStruct.modelPar_given_WCIGD=mod.given("WCIGD");
modParamMap["WCIGD"] = &(modelStruct.d_modelPar_WCIGD_dX);
modelStruct.modelPar_PCIGD=mod.PCIGD;
modelStruct.d_modelPar_PCIGD_dX=0.0;
modelStruct.modelPar_given_PCIGD=mod.given("PCIGD");
modParamMap["PCIGD"] = &(modelStruct.d_modelPar_PCIGD_dX);
modelStruct.modelPar_LPOXEDGE=mod.LPOXEDGE;
modelStruct.d_modelPar_LPOXEDGE_dX=0.0;
modelStruct.modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
modParamMap["LPOXEDGE"] = &(modelStruct.d_modelPar_LPOXEDGE_dX);
modelStruct.modelPar_WPOXEDGE=mod.WPOXEDGE;
modelStruct.d_modelPar_WPOXEDGE_dX=0.0;
modelStruct.modelPar_given_WPOXEDGE=mod.given("WPOXEDGE");
modParamMap["WPOXEDGE"] = &(modelStruct.d_modelPar_WPOXEDGE_dX);
modelStruct.modelPar_PPOXEDGE=mod.PPOXEDGE;
modelStruct.d_modelPar_PPOXEDGE_dX=0.0;
modelStruct.modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
modParamMap["PPOXEDGE"] = &(modelStruct.d_modelPar_PPOXEDGE_dX);
modelStruct.modelPar_LDLCIG=mod.LDLCIG;
modelStruct.d_modelPar_LDLCIG_dX=0.0;
modelStruct.modelPar_given_LDLCIG=mod.given("LDLCIG");
modParamMap["LDLCIG"] = &(modelStruct.d_modelPar_LDLCIG_dX);
modelStruct.modelPar_WDLCIG=mod.WDLCIG;
modelStruct.d_modelPar_WDLCIG_dX=0.0;
modelStruct.modelPar_given_WDLCIG=mod.given("WDLCIG");
modParamMap["WDLCIG"] = &(modelStruct.d_modelPar_WDLCIG_dX);
modelStruct.modelPar_PDLCIG=mod.PDLCIG;
modelStruct.d_modelPar_PDLCIG_dX=0.0;
modelStruct.modelPar_given_PDLCIG=mod.given("PDLCIG");
modParamMap["PDLCIG"] = &(modelStruct.d_modelPar_PDLCIG_dX);
modelStruct.modelPar_LDLCIGD=mod.LDLCIGD;
modelStruct.d_modelPar_LDLCIGD_dX=0.0;
modelStruct.modelPar_given_LDLCIGD=mod.given("LDLCIGD");
modParamMap["LDLCIGD"] = &(modelStruct.d_modelPar_LDLCIGD_dX);
modelStruct.modelPar_WDLCIGD=mod.WDLCIGD;
modelStruct.d_modelPar_WDLCIGD_dX=0.0;
modelStruct.modelPar_given_WDLCIGD=mod.given("WDLCIGD");
modParamMap["WDLCIGD"] = &(modelStruct.d_modelPar_WDLCIGD_dX);
modelStruct.modelPar_PDLCIGD=mod.PDLCIGD;
modelStruct.d_modelPar_PDLCIGD_dX=0.0;
modelStruct.modelPar_given_PDLCIGD=mod.given("PDLCIGD");
modParamMap["PDLCIGD"] = &(modelStruct.d_modelPar_PDLCIGD_dX);
modelStruct.modelPar_LNTOX=mod.LNTOX;
modelStruct.d_modelPar_LNTOX_dX=0.0;
modelStruct.modelPar_given_LNTOX=mod.given("LNTOX");
modParamMap["LNTOX"] = &(modelStruct.d_modelPar_LNTOX_dX);
modelStruct.modelPar_WNTOX=mod.WNTOX;
modelStruct.d_modelPar_WNTOX_dX=0.0;
modelStruct.modelPar_given_WNTOX=mod.given("WNTOX");
modParamMap["WNTOX"] = &(modelStruct.d_modelPar_WNTOX_dX);
modelStruct.modelPar_PNTOX=mod.PNTOX;
modelStruct.d_modelPar_PNTOX_dX=0.0;
modelStruct.modelPar_given_PNTOX=mod.given("PNTOX");
modParamMap["PNTOX"] = &(modelStruct.d_modelPar_PNTOX_dX);
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modParamMap["AGIDL"] = &(modelStruct.d_modelPar_AGIDL_dX);
modelStruct.modelPar_AGIDLL=mod.AGIDLL;
modelStruct.d_modelPar_AGIDLL_dX=0.0;
modelStruct.modelPar_given_AGIDLL=mod.given("AGIDLL");
modParamMap["AGIDLL"] = &(modelStruct.d_modelPar_AGIDLL_dX);
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modParamMap["AGIDLW"] = &(modelStruct.d_modelPar_AGIDLW_dX);
modelStruct.modelPar_LAGIDL=mod.LAGIDL;
modelStruct.d_modelPar_LAGIDL_dX=0.0;
modelStruct.modelPar_given_LAGIDL=mod.given("LAGIDL");
modParamMap["LAGIDL"] = &(modelStruct.d_modelPar_LAGIDL_dX);
modelStruct.modelPar_WAGIDL=mod.WAGIDL;
modelStruct.d_modelPar_WAGIDL_dX=0.0;
modelStruct.modelPar_given_WAGIDL=mod.given("WAGIDL");
modParamMap["WAGIDL"] = &(modelStruct.d_modelPar_WAGIDL_dX);
modelStruct.modelPar_PAGIDL=mod.PAGIDL;
modelStruct.d_modelPar_PAGIDL_dX=0.0;
modelStruct.modelPar_given_PAGIDL=mod.given("PAGIDL");
modParamMap["PAGIDL"] = &(modelStruct.d_modelPar_PAGIDL_dX);
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modParamMap["BGIDL"] = &(modelStruct.d_modelPar_BGIDL_dX);
modelStruct.modelPar_LBGIDL=mod.LBGIDL;
modelStruct.d_modelPar_LBGIDL_dX=0.0;
modelStruct.modelPar_given_LBGIDL=mod.given("LBGIDL");
modParamMap["LBGIDL"] = &(modelStruct.d_modelPar_LBGIDL_dX);
modelStruct.modelPar_WBGIDL=mod.WBGIDL;
modelStruct.d_modelPar_WBGIDL_dX=0.0;
modelStruct.modelPar_given_WBGIDL=mod.given("WBGIDL");
modParamMap["WBGIDL"] = &(modelStruct.d_modelPar_WBGIDL_dX);
modelStruct.modelPar_PBGIDL=mod.PBGIDL;
modelStruct.d_modelPar_PBGIDL_dX=0.0;
modelStruct.modelPar_given_PBGIDL=mod.given("PBGIDL");
modParamMap["PBGIDL"] = &(modelStruct.d_modelPar_PBGIDL_dX);
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modParamMap["CGIDL"] = &(modelStruct.d_modelPar_CGIDL_dX);
modelStruct.modelPar_LCGIDL=mod.LCGIDL;
modelStruct.d_modelPar_LCGIDL_dX=0.0;
modelStruct.modelPar_given_LCGIDL=mod.given("LCGIDL");
modParamMap["LCGIDL"] = &(modelStruct.d_modelPar_LCGIDL_dX);
modelStruct.modelPar_WCGIDL=mod.WCGIDL;
modelStruct.d_modelPar_WCGIDL_dX=0.0;
modelStruct.modelPar_given_WCGIDL=mod.given("WCGIDL");
modParamMap["WCGIDL"] = &(modelStruct.d_modelPar_WCGIDL_dX);
modelStruct.modelPar_PCGIDL=mod.PCGIDL;
modelStruct.d_modelPar_PCGIDL_dX=0.0;
modelStruct.modelPar_given_PCGIDL=mod.given("PCGIDL");
modParamMap["PCGIDL"] = &(modelStruct.d_modelPar_PCGIDL_dX);
modelStruct.modelPar_EGIDL=mod.EGIDL;
modelStruct.d_modelPar_EGIDL_dX=0.0;
modelStruct.modelPar_given_EGIDL=mod.given("EGIDL");
modParamMap["EGIDL"] = &(modelStruct.d_modelPar_EGIDL_dX);
modelStruct.modelPar_LEGIDL=mod.LEGIDL;
modelStruct.d_modelPar_LEGIDL_dX=0.0;
modelStruct.modelPar_given_LEGIDL=mod.given("LEGIDL");
modParamMap["LEGIDL"] = &(modelStruct.d_modelPar_LEGIDL_dX);
modelStruct.modelPar_WEGIDL=mod.WEGIDL;
modelStruct.d_modelPar_WEGIDL_dX=0.0;
modelStruct.modelPar_given_WEGIDL=mod.given("WEGIDL");
modParamMap["WEGIDL"] = &(modelStruct.d_modelPar_WEGIDL_dX);
modelStruct.modelPar_PEGIDL=mod.PEGIDL;
modelStruct.d_modelPar_PEGIDL_dX=0.0;
modelStruct.modelPar_given_PEGIDL=mod.given("PEGIDL");
modParamMap["PEGIDL"] = &(modelStruct.d_modelPar_PEGIDL_dX);
modelStruct.modelPar_AGISL=mod.AGISL;
modelStruct.d_modelPar_AGISL_dX=0.0;
modelStruct.modelPar_given_AGISL=mod.given("AGISL");
modParamMap["AGISL"] = &(modelStruct.d_modelPar_AGISL_dX);
modelStruct.modelPar_AGISLL=mod.AGISLL;
modelStruct.d_modelPar_AGISLL_dX=0.0;
modelStruct.modelPar_given_AGISLL=mod.given("AGISLL");
modParamMap["AGISLL"] = &(modelStruct.d_modelPar_AGISLL_dX);
modelStruct.modelPar_AGISLW=mod.AGISLW;
modelStruct.d_modelPar_AGISLW_dX=0.0;
modelStruct.modelPar_given_AGISLW=mod.given("AGISLW");
modParamMap["AGISLW"] = &(modelStruct.d_modelPar_AGISLW_dX);
modelStruct.modelPar_LAGISL=mod.LAGISL;
modelStruct.d_modelPar_LAGISL_dX=0.0;
modelStruct.modelPar_given_LAGISL=mod.given("LAGISL");
modParamMap["LAGISL"] = &(modelStruct.d_modelPar_LAGISL_dX);
modelStruct.modelPar_WAGISL=mod.WAGISL;
modelStruct.d_modelPar_WAGISL_dX=0.0;
modelStruct.modelPar_given_WAGISL=mod.given("WAGISL");
modParamMap["WAGISL"] = &(modelStruct.d_modelPar_WAGISL_dX);
modelStruct.modelPar_PAGISL=mod.PAGISL;
modelStruct.d_modelPar_PAGISL_dX=0.0;
modelStruct.modelPar_given_PAGISL=mod.given("PAGISL");
modParamMap["PAGISL"] = &(modelStruct.d_modelPar_PAGISL_dX);
modelStruct.modelPar_BGISL=mod.BGISL;
modelStruct.d_modelPar_BGISL_dX=0.0;
modelStruct.modelPar_given_BGISL=mod.given("BGISL");
modParamMap["BGISL"] = &(modelStruct.d_modelPar_BGISL_dX);
modelStruct.modelPar_LBGISL=mod.LBGISL;
modelStruct.d_modelPar_LBGISL_dX=0.0;
modelStruct.modelPar_given_LBGISL=mod.given("LBGISL");
modParamMap["LBGISL"] = &(modelStruct.d_modelPar_LBGISL_dX);
modelStruct.modelPar_WBGISL=mod.WBGISL;
modelStruct.d_modelPar_WBGISL_dX=0.0;
modelStruct.modelPar_given_WBGISL=mod.given("WBGISL");
modParamMap["WBGISL"] = &(modelStruct.d_modelPar_WBGISL_dX);
modelStruct.modelPar_PBGISL=mod.PBGISL;
modelStruct.d_modelPar_PBGISL_dX=0.0;
modelStruct.modelPar_given_PBGISL=mod.given("PBGISL");
modParamMap["PBGISL"] = &(modelStruct.d_modelPar_PBGISL_dX);
modelStruct.modelPar_CGISL=mod.CGISL;
modelStruct.d_modelPar_CGISL_dX=0.0;
modelStruct.modelPar_given_CGISL=mod.given("CGISL");
modParamMap["CGISL"] = &(modelStruct.d_modelPar_CGISL_dX);
modelStruct.modelPar_LCGISL=mod.LCGISL;
modelStruct.d_modelPar_LCGISL_dX=0.0;
modelStruct.modelPar_given_LCGISL=mod.given("LCGISL");
modParamMap["LCGISL"] = &(modelStruct.d_modelPar_LCGISL_dX);
modelStruct.modelPar_WCGISL=mod.WCGISL;
modelStruct.d_modelPar_WCGISL_dX=0.0;
modelStruct.modelPar_given_WCGISL=mod.given("WCGISL");
modParamMap["WCGISL"] = &(modelStruct.d_modelPar_WCGISL_dX);
modelStruct.modelPar_PCGISL=mod.PCGISL;
modelStruct.d_modelPar_PCGISL_dX=0.0;
modelStruct.modelPar_given_PCGISL=mod.given("PCGISL");
modParamMap["PCGISL"] = &(modelStruct.d_modelPar_PCGISL_dX);
modelStruct.modelPar_EGISL=mod.EGISL;
modelStruct.d_modelPar_EGISL_dX=0.0;
modelStruct.modelPar_given_EGISL=mod.given("EGISL");
modParamMap["EGISL"] = &(modelStruct.d_modelPar_EGISL_dX);
modelStruct.modelPar_LEGISL=mod.LEGISL;
modelStruct.d_modelPar_LEGISL_dX=0.0;
modelStruct.modelPar_given_LEGISL=mod.given("LEGISL");
modParamMap["LEGISL"] = &(modelStruct.d_modelPar_LEGISL_dX);
modelStruct.modelPar_WEGISL=mod.WEGISL;
modelStruct.d_modelPar_WEGISL_dX=0.0;
modelStruct.modelPar_given_WEGISL=mod.given("WEGISL");
modParamMap["WEGISL"] = &(modelStruct.d_modelPar_WEGISL_dX);
modelStruct.modelPar_PEGISL=mod.PEGISL;
modelStruct.d_modelPar_PEGISL_dX=0.0;
modelStruct.modelPar_given_PEGISL=mod.given("PEGISL");
modParamMap["PEGISL"] = &(modelStruct.d_modelPar_PEGISL_dX);
modelStruct.modelPar_CF=mod.CF;
modelStruct.d_modelPar_CF_dX=0.0;
modelStruct.modelPar_given_CF=mod.given("CF");
modParamMap["CF"] = &(modelStruct.d_modelPar_CF_dX);
modelStruct.modelPar_LCF=mod.LCF;
modelStruct.d_modelPar_LCF_dX=0.0;
modelStruct.modelPar_given_LCF=mod.given("LCF");
modParamMap["LCF"] = &(modelStruct.d_modelPar_LCF_dX);
modelStruct.modelPar_WCF=mod.WCF;
modelStruct.d_modelPar_WCF_dX=0.0;
modelStruct.modelPar_given_WCF=mod.given("WCF");
modParamMap["WCF"] = &(modelStruct.d_modelPar_WCF_dX);
modelStruct.modelPar_PCF=mod.PCF;
modelStruct.d_modelPar_PCF_dX=0.0;
modelStruct.modelPar_given_PCF=mod.given("PCF");
modParamMap["PCF"] = &(modelStruct.d_modelPar_PCF_dX);
modelStruct.modelPar_CFRCOEFF=mod.CFRCOEFF;
modelStruct.d_modelPar_CFRCOEFF_dX=0.0;
modelStruct.modelPar_given_CFRCOEFF=mod.given("CFRCOEFF");
modParamMap["CFRCOEFF"] = &(modelStruct.d_modelPar_CFRCOEFF_dX);
modelStruct.modelPar_CGSO=mod.CGSO;
modelStruct.d_modelPar_CGSO_dX=0.0;
modelStruct.modelPar_given_CGSO=mod.given("CGSO");
modParamMap["CGSO"] = &(modelStruct.d_modelPar_CGSO_dX);
modelStruct.modelPar_CGDO=mod.CGDO;
modelStruct.d_modelPar_CGDO_dX=0.0;
modelStruct.modelPar_given_CGDO=mod.given("CGDO");
modParamMap["CGDO"] = &(modelStruct.d_modelPar_CGDO_dX);
modelStruct.modelPar_CGBO=mod.CGBO;
modelStruct.d_modelPar_CGBO_dX=0.0;
modelStruct.modelPar_given_CGBO=mod.given("CGBO");
modParamMap["CGBO"] = &(modelStruct.d_modelPar_CGBO_dX);
modelStruct.modelPar_CGSL=mod.CGSL;
modelStruct.d_modelPar_CGSL_dX=0.0;
modelStruct.modelPar_given_CGSL=mod.given("CGSL");
modParamMap["CGSL"] = &(modelStruct.d_modelPar_CGSL_dX);
modelStruct.modelPar_LCGSL=mod.LCGSL;
modelStruct.d_modelPar_LCGSL_dX=0.0;
modelStruct.modelPar_given_LCGSL=mod.given("LCGSL");
modParamMap["LCGSL"] = &(modelStruct.d_modelPar_LCGSL_dX);
modelStruct.modelPar_WCGSL=mod.WCGSL;
modelStruct.d_modelPar_WCGSL_dX=0.0;
modelStruct.modelPar_given_WCGSL=mod.given("WCGSL");
modParamMap["WCGSL"] = &(modelStruct.d_modelPar_WCGSL_dX);
modelStruct.modelPar_PCGSL=mod.PCGSL;
modelStruct.d_modelPar_PCGSL_dX=0.0;
modelStruct.modelPar_given_PCGSL=mod.given("PCGSL");
modParamMap["PCGSL"] = &(modelStruct.d_modelPar_PCGSL_dX);
modelStruct.modelPar_CGDL=mod.CGDL;
modelStruct.d_modelPar_CGDL_dX=0.0;
modelStruct.modelPar_given_CGDL=mod.given("CGDL");
modParamMap["CGDL"] = &(modelStruct.d_modelPar_CGDL_dX);
modelStruct.modelPar_LCGDL=mod.LCGDL;
modelStruct.d_modelPar_LCGDL_dX=0.0;
modelStruct.modelPar_given_LCGDL=mod.given("LCGDL");
modParamMap["LCGDL"] = &(modelStruct.d_modelPar_LCGDL_dX);
modelStruct.modelPar_WCGDL=mod.WCGDL;
modelStruct.d_modelPar_WCGDL_dX=0.0;
modelStruct.modelPar_given_WCGDL=mod.given("WCGDL");
modParamMap["WCGDL"] = &(modelStruct.d_modelPar_WCGDL_dX);
modelStruct.modelPar_PCGDL=mod.PCGDL;
modelStruct.d_modelPar_PCGDL_dX=0.0;
modelStruct.modelPar_given_PCGDL=mod.given("PCGDL");
modParamMap["PCGDL"] = &(modelStruct.d_modelPar_PCGDL_dX);
modelStruct.modelPar_CKAPPAS=mod.CKAPPAS;
modelStruct.d_modelPar_CKAPPAS_dX=0.0;
modelStruct.modelPar_given_CKAPPAS=mod.given("CKAPPAS");
modParamMap["CKAPPAS"] = &(modelStruct.d_modelPar_CKAPPAS_dX);
modelStruct.modelPar_LCKAPPAS=mod.LCKAPPAS;
modelStruct.d_modelPar_LCKAPPAS_dX=0.0;
modelStruct.modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
modParamMap["LCKAPPAS"] = &(modelStruct.d_modelPar_LCKAPPAS_dX);
modelStruct.modelPar_WCKAPPAS=mod.WCKAPPAS;
modelStruct.d_modelPar_WCKAPPAS_dX=0.0;
modelStruct.modelPar_given_WCKAPPAS=mod.given("WCKAPPAS");
modParamMap["WCKAPPAS"] = &(modelStruct.d_modelPar_WCKAPPAS_dX);
modelStruct.modelPar_PCKAPPAS=mod.PCKAPPAS;
modelStruct.d_modelPar_PCKAPPAS_dX=0.0;
modelStruct.modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
modParamMap["PCKAPPAS"] = &(modelStruct.d_modelPar_PCKAPPAS_dX);
modelStruct.modelPar_CKAPPAD=mod.CKAPPAD;
modelStruct.d_modelPar_CKAPPAD_dX=0.0;
modelStruct.modelPar_given_CKAPPAD=mod.given("CKAPPAD");
modParamMap["CKAPPAD"] = &(modelStruct.d_modelPar_CKAPPAD_dX);
modelStruct.modelPar_LCKAPPAD=mod.LCKAPPAD;
modelStruct.d_modelPar_LCKAPPAD_dX=0.0;
modelStruct.modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
modParamMap["LCKAPPAD"] = &(modelStruct.d_modelPar_LCKAPPAD_dX);
modelStruct.modelPar_WCKAPPAD=mod.WCKAPPAD;
modelStruct.d_modelPar_WCKAPPAD_dX=0.0;
modelStruct.modelPar_given_WCKAPPAD=mod.given("WCKAPPAD");
modParamMap["WCKAPPAD"] = &(modelStruct.d_modelPar_WCKAPPAD_dX);
modelStruct.modelPar_PCKAPPAD=mod.PCKAPPAD;
modelStruct.d_modelPar_PCKAPPAD_dX=0.0;
modelStruct.modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
modParamMap["PCKAPPAD"] = &(modelStruct.d_modelPar_PCKAPPAD_dX);
modelStruct.modelPar_DMCG=mod.DMCG;
modelStruct.d_modelPar_DMCG_dX=0.0;
modelStruct.modelPar_given_DMCG=mod.given("DMCG");
modParamMap["DMCG"] = &(modelStruct.d_modelPar_DMCG_dX);
modelStruct.modelPar_DMCI=mod.DMCI;
modelStruct.d_modelPar_DMCI_dX=0.0;
modelStruct.modelPar_given_DMCI=mod.given("DMCI");
modParamMap["DMCI"] = &(modelStruct.d_modelPar_DMCI_dX);
modelStruct.modelPar_DMDG=mod.DMDG;
modelStruct.d_modelPar_DMDG_dX=0.0;
modelStruct.modelPar_given_DMDG=mod.given("DMDG");
modParamMap["DMDG"] = &(modelStruct.d_modelPar_DMDG_dX);
modelStruct.modelPar_DMCGT=mod.DMCGT;
modelStruct.d_modelPar_DMCGT_dX=0.0;
modelStruct.modelPar_given_DMCGT=mod.given("DMCGT");
modParamMap["DMCGT"] = &(modelStruct.d_modelPar_DMCGT_dX);
modelStruct.modelPar_XGL=mod.XGL;
modelStruct.d_modelPar_XGL_dX=0.0;
modelStruct.modelPar_given_XGL=mod.given("XGL");
modParamMap["XGL"] = &(modelStruct.d_modelPar_XGL_dX);
modelStruct.modelPar_RSHG=mod.RSHG;
modelStruct.d_modelPar_RSHG_dX=0.0;
modelStruct.modelPar_given_RSHG=mod.given("RSHG");
modParamMap["RSHG"] = &(modelStruct.d_modelPar_RSHG_dX);
modelStruct.modelPar_CJS=mod.CJS;
modelStruct.d_modelPar_CJS_dX=0.0;
modelStruct.modelPar_given_CJS=mod.given("CJS");
modParamMap["CJS"] = &(modelStruct.d_modelPar_CJS_dX);
modelStruct.modelPar_CJD=mod.CJD;
modelStruct.d_modelPar_CJD_dX=0.0;
modelStruct.modelPar_given_CJD=mod.given("CJD");
modParamMap["CJD"] = &(modelStruct.d_modelPar_CJD_dX);
modelStruct.modelPar_CJSWS=mod.CJSWS;
modelStruct.d_modelPar_CJSWS_dX=0.0;
modelStruct.modelPar_given_CJSWS=mod.given("CJSWS");
modParamMap["CJSWS"] = &(modelStruct.d_modelPar_CJSWS_dX);
modelStruct.modelPar_CJSWD=mod.CJSWD;
modelStruct.d_modelPar_CJSWD_dX=0.0;
modelStruct.modelPar_given_CJSWD=mod.given("CJSWD");
modParamMap["CJSWD"] = &(modelStruct.d_modelPar_CJSWD_dX);
modelStruct.modelPar_CJSWGS=mod.CJSWGS;
modelStruct.d_modelPar_CJSWGS_dX=0.0;
modelStruct.modelPar_given_CJSWGS=mod.given("CJSWGS");
modParamMap["CJSWGS"] = &(modelStruct.d_modelPar_CJSWGS_dX);
modelStruct.modelPar_CJSWGD=mod.CJSWGD;
modelStruct.d_modelPar_CJSWGD_dX=0.0;
modelStruct.modelPar_given_CJSWGD=mod.given("CJSWGD");
modParamMap["CJSWGD"] = &(modelStruct.d_modelPar_CJSWGD_dX);
modelStruct.modelPar_PBS=mod.PBS;
modelStruct.d_modelPar_PBS_dX=0.0;
modelStruct.modelPar_given_PBS=mod.given("PBS");
modParamMap["PBS"] = &(modelStruct.d_modelPar_PBS_dX);
modelStruct.modelPar_PBD=mod.PBD;
modelStruct.d_modelPar_PBD_dX=0.0;
modelStruct.modelPar_given_PBD=mod.given("PBD");
modParamMap["PBD"] = &(modelStruct.d_modelPar_PBD_dX);
modelStruct.modelPar_PBSWS=mod.PBSWS;
modelStruct.d_modelPar_PBSWS_dX=0.0;
modelStruct.modelPar_given_PBSWS=mod.given("PBSWS");
modParamMap["PBSWS"] = &(modelStruct.d_modelPar_PBSWS_dX);
modelStruct.modelPar_PBSWD=mod.PBSWD;
modelStruct.d_modelPar_PBSWD_dX=0.0;
modelStruct.modelPar_given_PBSWD=mod.given("PBSWD");
modParamMap["PBSWD"] = &(modelStruct.d_modelPar_PBSWD_dX);
modelStruct.modelPar_PBSWGS=mod.PBSWGS;
modelStruct.d_modelPar_PBSWGS_dX=0.0;
modelStruct.modelPar_given_PBSWGS=mod.given("PBSWGS");
modParamMap["PBSWGS"] = &(modelStruct.d_modelPar_PBSWGS_dX);
modelStruct.modelPar_PBSWGD=mod.PBSWGD;
modelStruct.d_modelPar_PBSWGD_dX=0.0;
modelStruct.modelPar_given_PBSWGD=mod.given("PBSWGD");
modParamMap["PBSWGD"] = &(modelStruct.d_modelPar_PBSWGD_dX);
modelStruct.modelPar_MJS=mod.MJS;
modelStruct.d_modelPar_MJS_dX=0.0;
modelStruct.modelPar_given_MJS=mod.given("MJS");
modParamMap["MJS"] = &(modelStruct.d_modelPar_MJS_dX);
modelStruct.modelPar_MJD=mod.MJD;
modelStruct.d_modelPar_MJD_dX=0.0;
modelStruct.modelPar_given_MJD=mod.given("MJD");
modParamMap["MJD"] = &(modelStruct.d_modelPar_MJD_dX);
modelStruct.modelPar_MJSWS=mod.MJSWS;
modelStruct.d_modelPar_MJSWS_dX=0.0;
modelStruct.modelPar_given_MJSWS=mod.given("MJSWS");
modParamMap["MJSWS"] = &(modelStruct.d_modelPar_MJSWS_dX);
modelStruct.modelPar_MJSWD=mod.MJSWD;
modelStruct.d_modelPar_MJSWD_dX=0.0;
modelStruct.modelPar_given_MJSWD=mod.given("MJSWD");
modParamMap["MJSWD"] = &(modelStruct.d_modelPar_MJSWD_dX);
modelStruct.modelPar_MJSWGS=mod.MJSWGS;
modelStruct.d_modelPar_MJSWGS_dX=0.0;
modelStruct.modelPar_given_MJSWGS=mod.given("MJSWGS");
modParamMap["MJSWGS"] = &(modelStruct.d_modelPar_MJSWGS_dX);
modelStruct.modelPar_MJSWGD=mod.MJSWGD;
modelStruct.d_modelPar_MJSWGD_dX=0.0;
modelStruct.modelPar_given_MJSWGD=mod.given("MJSWGD");
modParamMap["MJSWGD"] = &(modelStruct.d_modelPar_MJSWGD_dX);
modelStruct.modelPar_JSS=mod.JSS;
modelStruct.d_modelPar_JSS_dX=0.0;
modelStruct.modelPar_given_JSS=mod.given("JSS");
modParamMap["JSS"] = &(modelStruct.d_modelPar_JSS_dX);
modelStruct.modelPar_JSD=mod.JSD;
modelStruct.d_modelPar_JSD_dX=0.0;
modelStruct.modelPar_given_JSD=mod.given("JSD");
modParamMap["JSD"] = &(modelStruct.d_modelPar_JSD_dX);
modelStruct.modelPar_JSWS=mod.JSWS;
modelStruct.d_modelPar_JSWS_dX=0.0;
modelStruct.modelPar_given_JSWS=mod.given("JSWS");
modParamMap["JSWS"] = &(modelStruct.d_modelPar_JSWS_dX);
modelStruct.modelPar_JSWD=mod.JSWD;
modelStruct.d_modelPar_JSWD_dX=0.0;
modelStruct.modelPar_given_JSWD=mod.given("JSWD");
modParamMap["JSWD"] = &(modelStruct.d_modelPar_JSWD_dX);
modelStruct.modelPar_JSWGS=mod.JSWGS;
modelStruct.d_modelPar_JSWGS_dX=0.0;
modelStruct.modelPar_given_JSWGS=mod.given("JSWGS");
modParamMap["JSWGS"] = &(modelStruct.d_modelPar_JSWGS_dX);
modelStruct.modelPar_JSWGD=mod.JSWGD;
modelStruct.d_modelPar_JSWGD_dX=0.0;
modelStruct.modelPar_given_JSWGD=mod.given("JSWGD");
modParamMap["JSWGD"] = &(modelStruct.d_modelPar_JSWGD_dX);
modelStruct.modelPar_NJS=mod.NJS;
modelStruct.d_modelPar_NJS_dX=0.0;
modelStruct.modelPar_given_NJS=mod.given("NJS");
modParamMap["NJS"] = &(modelStruct.d_modelPar_NJS_dX);
modelStruct.modelPar_NJD=mod.NJD;
modelStruct.d_modelPar_NJD_dX=0.0;
modelStruct.modelPar_given_NJD=mod.given("NJD");
modParamMap["NJD"] = &(modelStruct.d_modelPar_NJD_dX);
modelStruct.modelPar_IJTHSFWD=mod.IJTHSFWD;
modelStruct.d_modelPar_IJTHSFWD_dX=0.0;
modelStruct.modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
modParamMap["IJTHSFWD"] = &(modelStruct.d_modelPar_IJTHSFWD_dX);
modelStruct.modelPar_IJTHDFWD=mod.IJTHDFWD;
modelStruct.d_modelPar_IJTHDFWD_dX=0.0;
modelStruct.modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
modParamMap["IJTHDFWD"] = &(modelStruct.d_modelPar_IJTHDFWD_dX);
modelStruct.modelPar_IJTHSREV=mod.IJTHSREV;
modelStruct.d_modelPar_IJTHSREV_dX=0.0;
modelStruct.modelPar_given_IJTHSREV=mod.given("IJTHSREV");
modParamMap["IJTHSREV"] = &(modelStruct.d_modelPar_IJTHSREV_dX);
modelStruct.modelPar_IJTHDREV=mod.IJTHDREV;
modelStruct.d_modelPar_IJTHDREV_dX=0.0;
modelStruct.modelPar_given_IJTHDREV=mod.given("IJTHDREV");
modParamMap["IJTHDREV"] = &(modelStruct.d_modelPar_IJTHDREV_dX);
modelStruct.modelPar_BVS=mod.BVS;
modelStruct.d_modelPar_BVS_dX=0.0;
modelStruct.modelPar_given_BVS=mod.given("BVS");
modParamMap["BVS"] = &(modelStruct.d_modelPar_BVS_dX);
modelStruct.modelPar_BVD=mod.BVD;
modelStruct.d_modelPar_BVD_dX=0.0;
modelStruct.modelPar_given_BVD=mod.given("BVD");
modParamMap["BVD"] = &(modelStruct.d_modelPar_BVD_dX);
modelStruct.modelPar_XJBVS=mod.XJBVS;
modelStruct.d_modelPar_XJBVS_dX=0.0;
modelStruct.modelPar_given_XJBVS=mod.given("XJBVS");
modParamMap["XJBVS"] = &(modelStruct.d_modelPar_XJBVS_dX);
modelStruct.modelPar_XJBVD=mod.XJBVD;
modelStruct.d_modelPar_XJBVD_dX=0.0;
modelStruct.modelPar_given_XJBVD=mod.given("XJBVD");
modParamMap["XJBVD"] = &(modelStruct.d_modelPar_XJBVD_dX);
modelStruct.modelPar_JTSS=mod.JTSS;
modelStruct.d_modelPar_JTSS_dX=0.0;
modelStruct.modelPar_given_JTSS=mod.given("JTSS");
modParamMap["JTSS"] = &(modelStruct.d_modelPar_JTSS_dX);
modelStruct.modelPar_JTSD=mod.JTSD;
modelStruct.d_modelPar_JTSD_dX=0.0;
modelStruct.modelPar_given_JTSD=mod.given("JTSD");
modParamMap["JTSD"] = &(modelStruct.d_modelPar_JTSD_dX);
modelStruct.modelPar_JTSSWS=mod.JTSSWS;
modelStruct.d_modelPar_JTSSWS_dX=0.0;
modelStruct.modelPar_given_JTSSWS=mod.given("JTSSWS");
modParamMap["JTSSWS"] = &(modelStruct.d_modelPar_JTSSWS_dX);
modelStruct.modelPar_JTSSWD=mod.JTSSWD;
modelStruct.d_modelPar_JTSSWD_dX=0.0;
modelStruct.modelPar_given_JTSSWD=mod.given("JTSSWD");
modParamMap["JTSSWD"] = &(modelStruct.d_modelPar_JTSSWD_dX);
modelStruct.modelPar_JTSSWGS=mod.JTSSWGS;
modelStruct.d_modelPar_JTSSWGS_dX=0.0;
modelStruct.modelPar_given_JTSSWGS=mod.given("JTSSWGS");
modParamMap["JTSSWGS"] = &(modelStruct.d_modelPar_JTSSWGS_dX);
modelStruct.modelPar_JTSSWGD=mod.JTSSWGD;
modelStruct.d_modelPar_JTSSWGD_dX=0.0;
modelStruct.modelPar_given_JTSSWGD=mod.given("JTSSWGD");
modParamMap["JTSSWGD"] = &(modelStruct.d_modelPar_JTSSWGD_dX);
modelStruct.modelPar_JTWEFF=mod.JTWEFF;
modelStruct.d_modelPar_JTWEFF_dX=0.0;
modelStruct.modelPar_given_JTWEFF=mod.given("JTWEFF");
modParamMap["JTWEFF"] = &(modelStruct.d_modelPar_JTWEFF_dX);
modelStruct.modelPar_NJTS=mod.NJTS;
modelStruct.d_modelPar_NJTS_dX=0.0;
modelStruct.modelPar_given_NJTS=mod.given("NJTS");
modParamMap["NJTS"] = &(modelStruct.d_modelPar_NJTS_dX);
modelStruct.modelPar_NJTSD=mod.NJTSD;
modelStruct.d_modelPar_NJTSD_dX=0.0;
modelStruct.modelPar_given_NJTSD=mod.given("NJTSD");
modParamMap["NJTSD"] = &(modelStruct.d_modelPar_NJTSD_dX);
modelStruct.modelPar_NJTSSW=mod.NJTSSW;
modelStruct.d_modelPar_NJTSSW_dX=0.0;
modelStruct.modelPar_given_NJTSSW=mod.given("NJTSSW");
modParamMap["NJTSSW"] = &(modelStruct.d_modelPar_NJTSSW_dX);
modelStruct.modelPar_NJTSSWD=mod.NJTSSWD;
modelStruct.d_modelPar_NJTSSWD_dX=0.0;
modelStruct.modelPar_given_NJTSSWD=mod.given("NJTSSWD");
modParamMap["NJTSSWD"] = &(modelStruct.d_modelPar_NJTSSWD_dX);
modelStruct.modelPar_NJTSSWG=mod.NJTSSWG;
modelStruct.d_modelPar_NJTSSWG_dX=0.0;
modelStruct.modelPar_given_NJTSSWG=mod.given("NJTSSWG");
modParamMap["NJTSSWG"] = &(modelStruct.d_modelPar_NJTSSWG_dX);
modelStruct.modelPar_NJTSSWGD=mod.NJTSSWGD;
modelStruct.d_modelPar_NJTSSWGD_dX=0.0;
modelStruct.modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
modParamMap["NJTSSWGD"] = &(modelStruct.d_modelPar_NJTSSWGD_dX);
modelStruct.modelPar_VTSS=mod.VTSS;
modelStruct.d_modelPar_VTSS_dX=0.0;
modelStruct.modelPar_given_VTSS=mod.given("VTSS");
modParamMap["VTSS"] = &(modelStruct.d_modelPar_VTSS_dX);
modelStruct.modelPar_VTSD=mod.VTSD;
modelStruct.d_modelPar_VTSD_dX=0.0;
modelStruct.modelPar_given_VTSD=mod.given("VTSD");
modParamMap["VTSD"] = &(modelStruct.d_modelPar_VTSD_dX);
modelStruct.modelPar_VTSSWS=mod.VTSSWS;
modelStruct.d_modelPar_VTSSWS_dX=0.0;
modelStruct.modelPar_given_VTSSWS=mod.given("VTSSWS");
modParamMap["VTSSWS"] = &(modelStruct.d_modelPar_VTSSWS_dX);
modelStruct.modelPar_VTSSWD=mod.VTSSWD;
modelStruct.d_modelPar_VTSSWD_dX=0.0;
modelStruct.modelPar_given_VTSSWD=mod.given("VTSSWD");
modParamMap["VTSSWD"] = &(modelStruct.d_modelPar_VTSSWD_dX);
modelStruct.modelPar_VTSSWGS=mod.VTSSWGS;
modelStruct.d_modelPar_VTSSWGS_dX=0.0;
modelStruct.modelPar_given_VTSSWGS=mod.given("VTSSWGS");
modParamMap["VTSSWGS"] = &(modelStruct.d_modelPar_VTSSWGS_dX);
modelStruct.modelPar_VTSSWGD=mod.VTSSWGD;
modelStruct.d_modelPar_VTSSWGD_dX=0.0;
modelStruct.modelPar_given_VTSSWGD=mod.given("VTSSWGD");
modParamMap["VTSSWGD"] = &(modelStruct.d_modelPar_VTSSWGD_dX);
modelStruct.modelPar_XRCRG1=mod.XRCRG1;
modelStruct.d_modelPar_XRCRG1_dX=0.0;
modelStruct.modelPar_given_XRCRG1=mod.given("XRCRG1");
modParamMap["XRCRG1"] = &(modelStruct.d_modelPar_XRCRG1_dX);
modelStruct.modelPar_XRCRG2=mod.XRCRG2;
modelStruct.d_modelPar_XRCRG2_dX=0.0;
modelStruct.modelPar_given_XRCRG2=mod.given("XRCRG2");
modParamMap["XRCRG2"] = &(modelStruct.d_modelPar_XRCRG2_dX);
modelStruct.modelPar_GBMIN=mod.GBMIN;
modelStruct.d_modelPar_GBMIN_dX=0.0;
modelStruct.modelPar_given_GBMIN=mod.given("GBMIN");
modParamMap["GBMIN"] = &(modelStruct.d_modelPar_GBMIN_dX);
modelStruct.modelPar_RBPS0=mod.RBPS0;
modelStruct.d_modelPar_RBPS0_dX=0.0;
modelStruct.modelPar_given_RBPS0=mod.given("RBPS0");
modParamMap["RBPS0"] = &(modelStruct.d_modelPar_RBPS0_dX);
modelStruct.modelPar_RBPSL=mod.RBPSL;
modelStruct.d_modelPar_RBPSL_dX=0.0;
modelStruct.modelPar_given_RBPSL=mod.given("RBPSL");
modParamMap["RBPSL"] = &(modelStruct.d_modelPar_RBPSL_dX);
modelStruct.modelPar_RBPSW=mod.RBPSW;
modelStruct.d_modelPar_RBPSW_dX=0.0;
modelStruct.modelPar_given_RBPSW=mod.given("RBPSW");
modParamMap["RBPSW"] = &(modelStruct.d_modelPar_RBPSW_dX);
modelStruct.modelPar_RBPSNF=mod.RBPSNF;
modelStruct.d_modelPar_RBPSNF_dX=0.0;
modelStruct.modelPar_given_RBPSNF=mod.given("RBPSNF");
modParamMap["RBPSNF"] = &(modelStruct.d_modelPar_RBPSNF_dX);
modelStruct.modelPar_RBPD0=mod.RBPD0;
modelStruct.d_modelPar_RBPD0_dX=0.0;
modelStruct.modelPar_given_RBPD0=mod.given("RBPD0");
modParamMap["RBPD0"] = &(modelStruct.d_modelPar_RBPD0_dX);
modelStruct.modelPar_RBPDL=mod.RBPDL;
modelStruct.d_modelPar_RBPDL_dX=0.0;
modelStruct.modelPar_given_RBPDL=mod.given("RBPDL");
modParamMap["RBPDL"] = &(modelStruct.d_modelPar_RBPDL_dX);
modelStruct.modelPar_RBPDW=mod.RBPDW;
modelStruct.d_modelPar_RBPDW_dX=0.0;
modelStruct.modelPar_given_RBPDW=mod.given("RBPDW");
modParamMap["RBPDW"] = &(modelStruct.d_modelPar_RBPDW_dX);
modelStruct.modelPar_RBPDNF=mod.RBPDNF;
modelStruct.d_modelPar_RBPDNF_dX=0.0;
modelStruct.modelPar_given_RBPDNF=mod.given("RBPDNF");
modParamMap["RBPDNF"] = &(modelStruct.d_modelPar_RBPDNF_dX);
modelStruct.modelPar_RBPBX0=mod.RBPBX0;
modelStruct.d_modelPar_RBPBX0_dX=0.0;
modelStruct.modelPar_given_RBPBX0=mod.given("RBPBX0");
modParamMap["RBPBX0"] = &(modelStruct.d_modelPar_RBPBX0_dX);
modelStruct.modelPar_RBPBXL=mod.RBPBXL;
modelStruct.d_modelPar_RBPBXL_dX=0.0;
modelStruct.modelPar_given_RBPBXL=mod.given("RBPBXL");
modParamMap["RBPBXL"] = &(modelStruct.d_modelPar_RBPBXL_dX);
modelStruct.modelPar_RBPBXW=mod.RBPBXW;
modelStruct.d_modelPar_RBPBXW_dX=0.0;
modelStruct.modelPar_given_RBPBXW=mod.given("RBPBXW");
modParamMap["RBPBXW"] = &(modelStruct.d_modelPar_RBPBXW_dX);
modelStruct.modelPar_RBPBXNF=mod.RBPBXNF;
modelStruct.d_modelPar_RBPBXNF_dX=0.0;
modelStruct.modelPar_given_RBPBXNF=mod.given("RBPBXNF");
modParamMap["RBPBXNF"] = &(modelStruct.d_modelPar_RBPBXNF_dX);
modelStruct.modelPar_RBPBY0=mod.RBPBY0;
modelStruct.d_modelPar_RBPBY0_dX=0.0;
modelStruct.modelPar_given_RBPBY0=mod.given("RBPBY0");
modParamMap["RBPBY0"] = &(modelStruct.d_modelPar_RBPBY0_dX);
modelStruct.modelPar_RBPBYL=mod.RBPBYL;
modelStruct.d_modelPar_RBPBYL_dX=0.0;
modelStruct.modelPar_given_RBPBYL=mod.given("RBPBYL");
modParamMap["RBPBYL"] = &(modelStruct.d_modelPar_RBPBYL_dX);
modelStruct.modelPar_RBPBYW=mod.RBPBYW;
modelStruct.d_modelPar_RBPBYW_dX=0.0;
modelStruct.modelPar_given_RBPBYW=mod.given("RBPBYW");
modParamMap["RBPBYW"] = &(modelStruct.d_modelPar_RBPBYW_dX);
modelStruct.modelPar_RBPBYNF=mod.RBPBYNF;
modelStruct.d_modelPar_RBPBYNF_dX=0.0;
modelStruct.modelPar_given_RBPBYNF=mod.given("RBPBYNF");
modParamMap["RBPBYNF"] = &(modelStruct.d_modelPar_RBPBYNF_dX);
modelStruct.modelPar_RBSBX0=mod.RBSBX0;
modelStruct.d_modelPar_RBSBX0_dX=0.0;
modelStruct.modelPar_given_RBSBX0=mod.given("RBSBX0");
modParamMap["RBSBX0"] = &(modelStruct.d_modelPar_RBSBX0_dX);
modelStruct.modelPar_RBSBY0=mod.RBSBY0;
modelStruct.d_modelPar_RBSBY0_dX=0.0;
modelStruct.modelPar_given_RBSBY0=mod.given("RBSBY0");
modParamMap["RBSBY0"] = &(modelStruct.d_modelPar_RBSBY0_dX);
modelStruct.modelPar_RBDBX0=mod.RBDBX0;
modelStruct.d_modelPar_RBDBX0_dX=0.0;
modelStruct.modelPar_given_RBDBX0=mod.given("RBDBX0");
modParamMap["RBDBX0"] = &(modelStruct.d_modelPar_RBDBX0_dX);
modelStruct.modelPar_RBDBY0=mod.RBDBY0;
modelStruct.d_modelPar_RBDBY0_dX=0.0;
modelStruct.modelPar_given_RBDBY0=mod.given("RBDBY0");
modParamMap["RBDBY0"] = &(modelStruct.d_modelPar_RBDBY0_dX);
modelStruct.modelPar_RBSDBXL=mod.RBSDBXL;
modelStruct.d_modelPar_RBSDBXL_dX=0.0;
modelStruct.modelPar_given_RBSDBXL=mod.given("RBSDBXL");
modParamMap["RBSDBXL"] = &(modelStruct.d_modelPar_RBSDBXL_dX);
modelStruct.modelPar_RBSDBXW=mod.RBSDBXW;
modelStruct.d_modelPar_RBSDBXW_dX=0.0;
modelStruct.modelPar_given_RBSDBXW=mod.given("RBSDBXW");
modParamMap["RBSDBXW"] = &(modelStruct.d_modelPar_RBSDBXW_dX);
modelStruct.modelPar_RBSDBXNF=mod.RBSDBXNF;
modelStruct.d_modelPar_RBSDBXNF_dX=0.0;
modelStruct.modelPar_given_RBSDBXNF=mod.given("RBSDBXNF");
modParamMap["RBSDBXNF"] = &(modelStruct.d_modelPar_RBSDBXNF_dX);
modelStruct.modelPar_RBSDBYL=mod.RBSDBYL;
modelStruct.d_modelPar_RBSDBYL_dX=0.0;
modelStruct.modelPar_given_RBSDBYL=mod.given("RBSDBYL");
modParamMap["RBSDBYL"] = &(modelStruct.d_modelPar_RBSDBYL_dX);
modelStruct.modelPar_RBSDBYW=mod.RBSDBYW;
modelStruct.d_modelPar_RBSDBYW_dX=0.0;
modelStruct.modelPar_given_RBSDBYW=mod.given("RBSDBYW");
modParamMap["RBSDBYW"] = &(modelStruct.d_modelPar_RBSDBYW_dX);
modelStruct.modelPar_RBSDBYNF=mod.RBSDBYNF;
modelStruct.d_modelPar_RBSDBYNF_dX=0.0;
modelStruct.modelPar_given_RBSDBYNF=mod.given("RBSDBYNF");
modParamMap["RBSDBYNF"] = &(modelStruct.d_modelPar_RBSDBYNF_dX);
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modParamMap["EF"] = &(modelStruct.d_modelPar_EF_dX);
modelStruct.modelPar_EM=mod.EM;
modelStruct.d_modelPar_EM_dX=0.0;
modelStruct.modelPar_given_EM=mod.given("EM");
modParamMap["EM"] = &(modelStruct.d_modelPar_EM_dX);
modelStruct.modelPar_NOIA=mod.NOIA;
modelStruct.d_modelPar_NOIA_dX=0.0;
modelStruct.modelPar_given_NOIA=mod.given("NOIA");
modParamMap["NOIA"] = &(modelStruct.d_modelPar_NOIA_dX);
modelStruct.modelPar_NOIB=mod.NOIB;
modelStruct.d_modelPar_NOIB_dX=0.0;
modelStruct.modelPar_given_NOIB=mod.given("NOIB");
modParamMap["NOIB"] = &(modelStruct.d_modelPar_NOIB_dX);
modelStruct.modelPar_NOIC=mod.NOIC;
modelStruct.d_modelPar_NOIC_dX=0.0;
modelStruct.modelPar_given_NOIC=mod.given("NOIC");
modParamMap["NOIC"] = &(modelStruct.d_modelPar_NOIC_dX);
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modParamMap["LINTNOI"] = &(modelStruct.d_modelPar_LINTNOI_dX);
modelStruct.modelPar_NTNOI=mod.NTNOI;
modelStruct.d_modelPar_NTNOI_dX=0.0;
modelStruct.modelPar_given_NTNOI=mod.given("NTNOI");
modParamMap["NTNOI"] = &(modelStruct.d_modelPar_NTNOI_dX);
modelStruct.modelPar_RNOIA=mod.RNOIA;
modelStruct.d_modelPar_RNOIA_dX=0.0;
modelStruct.modelPar_given_RNOIA=mod.given("RNOIA");
modParamMap["RNOIA"] = &(modelStruct.d_modelPar_RNOIA_dX);
modelStruct.modelPar_RNOIB=mod.RNOIB;
modelStruct.d_modelPar_RNOIB_dX=0.0;
modelStruct.modelPar_given_RNOIB=mod.given("RNOIB");
modParamMap["RNOIB"] = &(modelStruct.d_modelPar_RNOIB_dX);
modelStruct.modelPar_RNOIC=mod.RNOIC;
modelStruct.d_modelPar_RNOIC_dX=0.0;
modelStruct.modelPar_given_RNOIC=mod.given("RNOIC");
modParamMap["RNOIC"] = &(modelStruct.d_modelPar_RNOIC_dX);
modelStruct.modelPar_TNOIA=mod.TNOIA;
modelStruct.d_modelPar_TNOIA_dX=0.0;
modelStruct.modelPar_given_TNOIA=mod.given("TNOIA");
modParamMap["TNOIA"] = &(modelStruct.d_modelPar_TNOIA_dX);
modelStruct.modelPar_TNOIB=mod.TNOIB;
modelStruct.d_modelPar_TNOIB_dX=0.0;
modelStruct.modelPar_given_TNOIB=mod.given("TNOIB");
modParamMap["TNOIB"] = &(modelStruct.d_modelPar_TNOIB_dX);
modelStruct.modelPar_TNOIC=mod.TNOIC;
modelStruct.d_modelPar_TNOIC_dX=0.0;
modelStruct.modelPar_given_TNOIC=mod.given("TNOIC");
modParamMap["TNOIC"] = &(modelStruct.d_modelPar_TNOIC_dX);
modelStruct.modelPar_DLBIN=mod.DLBIN;
modelStruct.d_modelPar_DLBIN_dX=0.0;
modelStruct.modelPar_given_DLBIN=mod.given("DLBIN");
modParamMap["DLBIN"] = &(modelStruct.d_modelPar_DLBIN_dX);
modelStruct.modelPar_DWBIN=mod.DWBIN;
modelStruct.d_modelPar_DWBIN_dX=0.0;
modelStruct.modelPar_given_DWBIN=mod.given("DWBIN");
modParamMap["DWBIN"] = &(modelStruct.d_modelPar_DWBIN_dX);
modelStruct.modelPar_TNOM=mod.TNOM;
modelStruct.d_modelPar_TNOM_dX=0.0;
modelStruct.modelPar_given_TNOM=mod.given("TNOM");
modParamMap["TNOM"] = &(modelStruct.d_modelPar_TNOM_dX);
modelStruct.modelPar_DTEMP=mod.DTEMP;
modelStruct.d_modelPar_DTEMP_dX=0.0;
modelStruct.modelPar_given_DTEMP=mod.given("DTEMP");
modParamMap["DTEMP"] = &(modelStruct.d_modelPar_DTEMP_dX);
modelStruct.modelPar_TBGASUB=mod.TBGASUB;
modelStruct.d_modelPar_TBGASUB_dX=0.0;
modelStruct.modelPar_given_TBGASUB=mod.given("TBGASUB");
modParamMap["TBGASUB"] = &(modelStruct.d_modelPar_TBGASUB_dX);
modelStruct.modelPar_TBGBSUB=mod.TBGBSUB;
modelStruct.d_modelPar_TBGBSUB_dX=0.0;
modelStruct.modelPar_given_TBGBSUB=mod.given("TBGBSUB");
modParamMap["TBGBSUB"] = &(modelStruct.d_modelPar_TBGBSUB_dX);
modelStruct.modelPar_TNFACTOR=mod.TNFACTOR;
modelStruct.d_modelPar_TNFACTOR_dX=0.0;
modelStruct.modelPar_given_TNFACTOR=mod.given("TNFACTOR");
modParamMap["TNFACTOR"] = &(modelStruct.d_modelPar_TNFACTOR_dX);
modelStruct.modelPar_UTE=mod.UTE;
modelStruct.d_modelPar_UTE_dX=0.0;
modelStruct.modelPar_given_UTE=mod.given("UTE");
modParamMap["UTE"] = &(modelStruct.d_modelPar_UTE_dX);
modelStruct.modelPar_LUTE=mod.LUTE;
modelStruct.d_modelPar_LUTE_dX=0.0;
modelStruct.modelPar_given_LUTE=mod.given("LUTE");
modParamMap["LUTE"] = &(modelStruct.d_modelPar_LUTE_dX);
modelStruct.modelPar_WUTE=mod.WUTE;
modelStruct.d_modelPar_WUTE_dX=0.0;
modelStruct.modelPar_given_WUTE=mod.given("WUTE");
modParamMap["WUTE"] = &(modelStruct.d_modelPar_WUTE_dX);
modelStruct.modelPar_PUTE=mod.PUTE;
modelStruct.d_modelPar_PUTE_dX=0.0;
modelStruct.modelPar_given_PUTE=mod.given("PUTE");
modParamMap["PUTE"] = &(modelStruct.d_modelPar_PUTE_dX);
modelStruct.modelPar_UTEL=mod.UTEL;
modelStruct.d_modelPar_UTEL_dX=0.0;
modelStruct.modelPar_given_UTEL=mod.given("UTEL");
modParamMap["UTEL"] = &(modelStruct.d_modelPar_UTEL_dX);
modelStruct.modelPar_UA1=mod.UA1;
modelStruct.d_modelPar_UA1_dX=0.0;
modelStruct.modelPar_given_UA1=mod.given("UA1");
modParamMap["UA1"] = &(modelStruct.d_modelPar_UA1_dX);
modelStruct.modelPar_LUA1=mod.LUA1;
modelStruct.d_modelPar_LUA1_dX=0.0;
modelStruct.modelPar_given_LUA1=mod.given("LUA1");
modParamMap["LUA1"] = &(modelStruct.d_modelPar_LUA1_dX);
modelStruct.modelPar_WUA1=mod.WUA1;
modelStruct.d_modelPar_WUA1_dX=0.0;
modelStruct.modelPar_given_WUA1=mod.given("WUA1");
modParamMap["WUA1"] = &(modelStruct.d_modelPar_WUA1_dX);
modelStruct.modelPar_PUA1=mod.PUA1;
modelStruct.d_modelPar_PUA1_dX=0.0;
modelStruct.modelPar_given_PUA1=mod.given("PUA1");
modParamMap["PUA1"] = &(modelStruct.d_modelPar_PUA1_dX);
modelStruct.modelPar_UA1L=mod.UA1L;
modelStruct.d_modelPar_UA1L_dX=0.0;
modelStruct.modelPar_given_UA1L=mod.given("UA1L");
modParamMap["UA1L"] = &(modelStruct.d_modelPar_UA1L_dX);
modelStruct.modelPar_UC1=mod.UC1;
modelStruct.d_modelPar_UC1_dX=0.0;
modelStruct.modelPar_given_UC1=mod.given("UC1");
modParamMap["UC1"] = &(modelStruct.d_modelPar_UC1_dX);
modelStruct.modelPar_LUC1=mod.LUC1;
modelStruct.d_modelPar_LUC1_dX=0.0;
modelStruct.modelPar_given_LUC1=mod.given("LUC1");
modParamMap["LUC1"] = &(modelStruct.d_modelPar_LUC1_dX);
modelStruct.modelPar_WUC1=mod.WUC1;
modelStruct.d_modelPar_WUC1_dX=0.0;
modelStruct.modelPar_given_WUC1=mod.given("WUC1");
modParamMap["WUC1"] = &(modelStruct.d_modelPar_WUC1_dX);
modelStruct.modelPar_PUC1=mod.PUC1;
modelStruct.d_modelPar_PUC1_dX=0.0;
modelStruct.modelPar_given_PUC1=mod.given("PUC1");
modParamMap["PUC1"] = &(modelStruct.d_modelPar_PUC1_dX);
modelStruct.modelPar_UD1=mod.UD1;
modelStruct.d_modelPar_UD1_dX=0.0;
modelStruct.modelPar_given_UD1=mod.given("UD1");
modParamMap["UD1"] = &(modelStruct.d_modelPar_UD1_dX);
modelStruct.modelPar_LUD1=mod.LUD1;
modelStruct.d_modelPar_LUD1_dX=0.0;
modelStruct.modelPar_given_LUD1=mod.given("LUD1");
modParamMap["LUD1"] = &(modelStruct.d_modelPar_LUD1_dX);
modelStruct.modelPar_WUD1=mod.WUD1;
modelStruct.d_modelPar_WUD1_dX=0.0;
modelStruct.modelPar_given_WUD1=mod.given("WUD1");
modParamMap["WUD1"] = &(modelStruct.d_modelPar_WUD1_dX);
modelStruct.modelPar_PUD1=mod.PUD1;
modelStruct.d_modelPar_PUD1_dX=0.0;
modelStruct.modelPar_given_PUD1=mod.given("PUD1");
modParamMap["PUD1"] = &(modelStruct.d_modelPar_PUD1_dX);
modelStruct.modelPar_UD1L=mod.UD1L;
modelStruct.d_modelPar_UD1L_dX=0.0;
modelStruct.modelPar_given_UD1L=mod.given("UD1L");
modParamMap["UD1L"] = &(modelStruct.d_modelPar_UD1L_dX);
modelStruct.modelPar_UCSTE=mod.UCSTE;
modelStruct.d_modelPar_UCSTE_dX=0.0;
modelStruct.modelPar_given_UCSTE=mod.given("UCSTE");
modParamMap["UCSTE"] = &(modelStruct.d_modelPar_UCSTE_dX);
modelStruct.modelPar_LUCSTE=mod.LUCSTE;
modelStruct.d_modelPar_LUCSTE_dX=0.0;
modelStruct.modelPar_given_LUCSTE=mod.given("LUCSTE");
modParamMap["LUCSTE"] = &(modelStruct.d_modelPar_LUCSTE_dX);
modelStruct.modelPar_WUCSTE=mod.WUCSTE;
modelStruct.d_modelPar_WUCSTE_dX=0.0;
modelStruct.modelPar_given_WUCSTE=mod.given("WUCSTE");
modParamMap["WUCSTE"] = &(modelStruct.d_modelPar_WUCSTE_dX);
modelStruct.modelPar_PUCSTE=mod.PUCSTE;
modelStruct.d_modelPar_PUCSTE_dX=0.0;
modelStruct.modelPar_given_PUCSTE=mod.given("PUCSTE");
modParamMap["PUCSTE"] = &(modelStruct.d_modelPar_PUCSTE_dX);
modelStruct.modelPar_TETA0=mod.TETA0;
modelStruct.d_modelPar_TETA0_dX=0.0;
modelStruct.modelPar_given_TETA0=mod.given("TETA0");
modParamMap["TETA0"] = &(modelStruct.d_modelPar_TETA0_dX);
modelStruct.modelPar_PRT=mod.PRT;
modelStruct.d_modelPar_PRT_dX=0.0;
modelStruct.modelPar_given_PRT=mod.given("PRT");
modParamMap["PRT"] = &(modelStruct.d_modelPar_PRT_dX);
modelStruct.modelPar_LPRT=mod.LPRT;
modelStruct.d_modelPar_LPRT_dX=0.0;
modelStruct.modelPar_given_LPRT=mod.given("LPRT");
modParamMap["LPRT"] = &(modelStruct.d_modelPar_LPRT_dX);
modelStruct.modelPar_WPRT=mod.WPRT;
modelStruct.d_modelPar_WPRT_dX=0.0;
modelStruct.modelPar_given_WPRT=mod.given("WPRT");
modParamMap["WPRT"] = &(modelStruct.d_modelPar_WPRT_dX);
modelStruct.modelPar_PPRT=mod.PPRT;
modelStruct.d_modelPar_PPRT_dX=0.0;
modelStruct.modelPar_given_PPRT=mod.given("PPRT");
modParamMap["PPRT"] = &(modelStruct.d_modelPar_PPRT_dX);
modelStruct.modelPar_AT=mod.AT;
modelStruct.d_modelPar_AT_dX=0.0;
modelStruct.modelPar_given_AT=mod.given("AT");
modParamMap["AT"] = &(modelStruct.d_modelPar_AT_dX);
modelStruct.modelPar_LAT=mod.LAT;
modelStruct.d_modelPar_LAT_dX=0.0;
modelStruct.modelPar_given_LAT=mod.given("LAT");
modParamMap["LAT"] = &(modelStruct.d_modelPar_LAT_dX);
modelStruct.modelPar_WAT=mod.WAT;
modelStruct.d_modelPar_WAT_dX=0.0;
modelStruct.modelPar_given_WAT=mod.given("WAT");
modParamMap["WAT"] = &(modelStruct.d_modelPar_WAT_dX);
modelStruct.modelPar_PAT=mod.PAT;
modelStruct.d_modelPar_PAT_dX=0.0;
modelStruct.modelPar_given_PAT=mod.given("PAT");
modParamMap["PAT"] = &(modelStruct.d_modelPar_PAT_dX);
modelStruct.modelPar_ATL=mod.ATL;
modelStruct.d_modelPar_ATL_dX=0.0;
modelStruct.modelPar_given_ATL=mod.given("ATL");
modParamMap["ATL"] = &(modelStruct.d_modelPar_ATL_dX);
modelStruct.modelPar_TDELTA=mod.TDELTA;
modelStruct.d_modelPar_TDELTA_dX=0.0;
modelStruct.modelPar_given_TDELTA=mod.given("TDELTA");
modParamMap["TDELTA"] = &(modelStruct.d_modelPar_TDELTA_dX);
modelStruct.modelPar_PTWGT=mod.PTWGT;
modelStruct.d_modelPar_PTWGT_dX=0.0;
modelStruct.modelPar_given_PTWGT=mod.given("PTWGT");
modParamMap["PTWGT"] = &(modelStruct.d_modelPar_PTWGT_dX);
modelStruct.modelPar_LPTWGT=mod.LPTWGT;
modelStruct.d_modelPar_LPTWGT_dX=0.0;
modelStruct.modelPar_given_LPTWGT=mod.given("LPTWGT");
modParamMap["LPTWGT"] = &(modelStruct.d_modelPar_LPTWGT_dX);
modelStruct.modelPar_WPTWGT=mod.WPTWGT;
modelStruct.d_modelPar_WPTWGT_dX=0.0;
modelStruct.modelPar_given_WPTWGT=mod.given("WPTWGT");
modParamMap["WPTWGT"] = &(modelStruct.d_modelPar_WPTWGT_dX);
modelStruct.modelPar_PPTWGT=mod.PPTWGT;
modelStruct.d_modelPar_PPTWGT_dX=0.0;
modelStruct.modelPar_given_PPTWGT=mod.given("PPTWGT");
modParamMap["PPTWGT"] = &(modelStruct.d_modelPar_PPTWGT_dX);
modelStruct.modelPar_PTWGTL=mod.PTWGTL;
modelStruct.d_modelPar_PTWGTL_dX=0.0;
modelStruct.modelPar_given_PTWGTL=mod.given("PTWGTL");
modParamMap["PTWGTL"] = &(modelStruct.d_modelPar_PTWGTL_dX);
modelStruct.modelPar_KT1=mod.KT1;
modelStruct.d_modelPar_KT1_dX=0.0;
modelStruct.modelPar_given_KT1=mod.given("KT1");
modParamMap["KT1"] = &(modelStruct.d_modelPar_KT1_dX);
modelStruct.modelPar_KT1EXP=mod.KT1EXP;
modelStruct.d_modelPar_KT1EXP_dX=0.0;
modelStruct.modelPar_given_KT1EXP=mod.given("KT1EXP");
modParamMap["KT1EXP"] = &(modelStruct.d_modelPar_KT1EXP_dX);
modelStruct.modelPar_KT1L=mod.KT1L;
modelStruct.d_modelPar_KT1L_dX=0.0;
modelStruct.modelPar_given_KT1L=mod.given("KT1L");
modParamMap["KT1L"] = &(modelStruct.d_modelPar_KT1L_dX);
modelStruct.modelPar_LKT1=mod.LKT1;
modelStruct.d_modelPar_LKT1_dX=0.0;
modelStruct.modelPar_given_LKT1=mod.given("LKT1");
modParamMap["LKT1"] = &(modelStruct.d_modelPar_LKT1_dX);
modelStruct.modelPar_WKT1=mod.WKT1;
modelStruct.d_modelPar_WKT1_dX=0.0;
modelStruct.modelPar_given_WKT1=mod.given("WKT1");
modParamMap["WKT1"] = &(modelStruct.d_modelPar_WKT1_dX);
modelStruct.modelPar_PKT1=mod.PKT1;
modelStruct.d_modelPar_PKT1_dX=0.0;
modelStruct.modelPar_given_PKT1=mod.given("PKT1");
modParamMap["PKT1"] = &(modelStruct.d_modelPar_PKT1_dX);
modelStruct.modelPar_KT2=mod.KT2;
modelStruct.d_modelPar_KT2_dX=0.0;
modelStruct.modelPar_given_KT2=mod.given("KT2");
modParamMap["KT2"] = &(modelStruct.d_modelPar_KT2_dX);
modelStruct.modelPar_LKT2=mod.LKT2;
modelStruct.d_modelPar_LKT2_dX=0.0;
modelStruct.modelPar_given_LKT2=mod.given("LKT2");
modParamMap["LKT2"] = &(modelStruct.d_modelPar_LKT2_dX);
modelStruct.modelPar_WKT2=mod.WKT2;
modelStruct.d_modelPar_WKT2_dX=0.0;
modelStruct.modelPar_given_WKT2=mod.given("WKT2");
modParamMap["WKT2"] = &(modelStruct.d_modelPar_WKT2_dX);
modelStruct.modelPar_PKT2=mod.PKT2;
modelStruct.d_modelPar_PKT2_dX=0.0;
modelStruct.modelPar_given_PKT2=mod.given("PKT2");
modParamMap["PKT2"] = &(modelStruct.d_modelPar_PKT2_dX);
modelStruct.modelPar_IIT=mod.IIT;
modelStruct.d_modelPar_IIT_dX=0.0;
modelStruct.modelPar_given_IIT=mod.given("IIT");
modParamMap["IIT"] = &(modelStruct.d_modelPar_IIT_dX);
modelStruct.modelPar_LIIT=mod.LIIT;
modelStruct.d_modelPar_LIIT_dX=0.0;
modelStruct.modelPar_given_LIIT=mod.given("LIIT");
modParamMap["LIIT"] = &(modelStruct.d_modelPar_LIIT_dX);
modelStruct.modelPar_WIIT=mod.WIIT;
modelStruct.d_modelPar_WIIT_dX=0.0;
modelStruct.modelPar_given_WIIT=mod.given("WIIT");
modParamMap["WIIT"] = &(modelStruct.d_modelPar_WIIT_dX);
modelStruct.modelPar_PIIT=mod.PIIT;
modelStruct.d_modelPar_PIIT_dX=0.0;
modelStruct.modelPar_given_PIIT=mod.given("PIIT");
modParamMap["PIIT"] = &(modelStruct.d_modelPar_PIIT_dX);
modelStruct.modelPar_IGT=mod.IGT;
modelStruct.d_modelPar_IGT_dX=0.0;
modelStruct.modelPar_given_IGT=mod.given("IGT");
modParamMap["IGT"] = &(modelStruct.d_modelPar_IGT_dX);
modelStruct.modelPar_LIGT=mod.LIGT;
modelStruct.d_modelPar_LIGT_dX=0.0;
modelStruct.modelPar_given_LIGT=mod.given("LIGT");
modParamMap["LIGT"] = &(modelStruct.d_modelPar_LIGT_dX);
modelStruct.modelPar_WIGT=mod.WIGT;
modelStruct.d_modelPar_WIGT_dX=0.0;
modelStruct.modelPar_given_WIGT=mod.given("WIGT");
modParamMap["WIGT"] = &(modelStruct.d_modelPar_WIGT_dX);
modelStruct.modelPar_PIGT=mod.PIGT;
modelStruct.d_modelPar_PIGT_dX=0.0;
modelStruct.modelPar_given_PIGT=mod.given("PIGT");
modParamMap["PIGT"] = &(modelStruct.d_modelPar_PIGT_dX);
modelStruct.modelPar_TGIDL=mod.TGIDL;
modelStruct.d_modelPar_TGIDL_dX=0.0;
modelStruct.modelPar_given_TGIDL=mod.given("TGIDL");
modParamMap["TGIDL"] = &(modelStruct.d_modelPar_TGIDL_dX);
modelStruct.modelPar_LTGIDL=mod.LTGIDL;
modelStruct.d_modelPar_LTGIDL_dX=0.0;
modelStruct.modelPar_given_LTGIDL=mod.given("LTGIDL");
modParamMap["LTGIDL"] = &(modelStruct.d_modelPar_LTGIDL_dX);
modelStruct.modelPar_WTGIDL=mod.WTGIDL;
modelStruct.d_modelPar_WTGIDL_dX=0.0;
modelStruct.modelPar_given_WTGIDL=mod.given("WTGIDL");
modParamMap["WTGIDL"] = &(modelStruct.d_modelPar_WTGIDL_dX);
modelStruct.modelPar_PTGIDL=mod.PTGIDL;
modelStruct.d_modelPar_PTGIDL_dX=0.0;
modelStruct.modelPar_given_PTGIDL=mod.given("PTGIDL");
modParamMap["PTGIDL"] = &(modelStruct.d_modelPar_PTGIDL_dX);
modelStruct.modelPar_TCJ=mod.TCJ;
modelStruct.d_modelPar_TCJ_dX=0.0;
modelStruct.modelPar_given_TCJ=mod.given("TCJ");
modParamMap["TCJ"] = &(modelStruct.d_modelPar_TCJ_dX);
modelStruct.modelPar_TCJSW=mod.TCJSW;
modelStruct.d_modelPar_TCJSW_dX=0.0;
modelStruct.modelPar_given_TCJSW=mod.given("TCJSW");
modParamMap["TCJSW"] = &(modelStruct.d_modelPar_TCJSW_dX);
modelStruct.modelPar_TCJSWG=mod.TCJSWG;
modelStruct.d_modelPar_TCJSWG_dX=0.0;
modelStruct.modelPar_given_TCJSWG=mod.given("TCJSWG");
modParamMap["TCJSWG"] = &(modelStruct.d_modelPar_TCJSWG_dX);
modelStruct.modelPar_TPB=mod.TPB;
modelStruct.d_modelPar_TPB_dX=0.0;
modelStruct.modelPar_given_TPB=mod.given("TPB");
modParamMap["TPB"] = &(modelStruct.d_modelPar_TPB_dX);
modelStruct.modelPar_TPBSW=mod.TPBSW;
modelStruct.d_modelPar_TPBSW_dX=0.0;
modelStruct.modelPar_given_TPBSW=mod.given("TPBSW");
modParamMap["TPBSW"] = &(modelStruct.d_modelPar_TPBSW_dX);
modelStruct.modelPar_TPBSWG=mod.TPBSWG;
modelStruct.d_modelPar_TPBSWG_dX=0.0;
modelStruct.modelPar_given_TPBSWG=mod.given("TPBSWG");
modParamMap["TPBSWG"] = &(modelStruct.d_modelPar_TPBSWG_dX);
modelStruct.modelPar_XTIS=mod.XTIS;
modelStruct.d_modelPar_XTIS_dX=0.0;
modelStruct.modelPar_given_XTIS=mod.given("XTIS");
modParamMap["XTIS"] = &(modelStruct.d_modelPar_XTIS_dX);
modelStruct.modelPar_XTID=mod.XTID;
modelStruct.d_modelPar_XTID_dX=0.0;
modelStruct.modelPar_given_XTID=mod.given("XTID");
modParamMap["XTID"] = &(modelStruct.d_modelPar_XTID_dX);
modelStruct.modelPar_XTSS=mod.XTSS;
modelStruct.d_modelPar_XTSS_dX=0.0;
modelStruct.modelPar_given_XTSS=mod.given("XTSS");
modParamMap["XTSS"] = &(modelStruct.d_modelPar_XTSS_dX);
modelStruct.modelPar_XTSD=mod.XTSD;
modelStruct.d_modelPar_XTSD_dX=0.0;
modelStruct.modelPar_given_XTSD=mod.given("XTSD");
modParamMap["XTSD"] = &(modelStruct.d_modelPar_XTSD_dX);
modelStruct.modelPar_XTSSWS=mod.XTSSWS;
modelStruct.d_modelPar_XTSSWS_dX=0.0;
modelStruct.modelPar_given_XTSSWS=mod.given("XTSSWS");
modParamMap["XTSSWS"] = &(modelStruct.d_modelPar_XTSSWS_dX);
modelStruct.modelPar_XTSSWD=mod.XTSSWD;
modelStruct.d_modelPar_XTSSWD_dX=0.0;
modelStruct.modelPar_given_XTSSWD=mod.given("XTSSWD");
modParamMap["XTSSWD"] = &(modelStruct.d_modelPar_XTSSWD_dX);
modelStruct.modelPar_XTSSWGS=mod.XTSSWGS;
modelStruct.d_modelPar_XTSSWGS_dX=0.0;
modelStruct.modelPar_given_XTSSWGS=mod.given("XTSSWGS");
modParamMap["XTSSWGS"] = &(modelStruct.d_modelPar_XTSSWGS_dX);
modelStruct.modelPar_XTSSWGD=mod.XTSSWGD;
modelStruct.d_modelPar_XTSSWGD_dX=0.0;
modelStruct.modelPar_given_XTSSWGD=mod.given("XTSSWGD");
modParamMap["XTSSWGD"] = &(modelStruct.d_modelPar_XTSSWGD_dX);
modelStruct.modelPar_TNJTS=mod.TNJTS;
modelStruct.d_modelPar_TNJTS_dX=0.0;
modelStruct.modelPar_given_TNJTS=mod.given("TNJTS");
modParamMap["TNJTS"] = &(modelStruct.d_modelPar_TNJTS_dX);
modelStruct.modelPar_TNJTSD=mod.TNJTSD;
modelStruct.d_modelPar_TNJTSD_dX=0.0;
modelStruct.modelPar_given_TNJTSD=mod.given("TNJTSD");
modParamMap["TNJTSD"] = &(modelStruct.d_modelPar_TNJTSD_dX);
modelStruct.modelPar_TNJTSSW=mod.TNJTSSW;
modelStruct.d_modelPar_TNJTSSW_dX=0.0;
modelStruct.modelPar_given_TNJTSSW=mod.given("TNJTSSW");
modParamMap["TNJTSSW"] = &(modelStruct.d_modelPar_TNJTSSW_dX);
modelStruct.modelPar_TNJTSSWD=mod.TNJTSSWD;
modelStruct.d_modelPar_TNJTSSWD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
modParamMap["TNJTSSWD"] = &(modelStruct.d_modelPar_TNJTSSWD_dX);
modelStruct.modelPar_TNJTSSWG=mod.TNJTSSWG;
modelStruct.d_modelPar_TNJTSSWG_dX=0.0;
modelStruct.modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
modParamMap["TNJTSSWG"] = &(modelStruct.d_modelPar_TNJTSSWG_dX);
modelStruct.modelPar_TNJTSSWGD=mod.TNJTSSWGD;
modelStruct.d_modelPar_TNJTSSWGD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
modParamMap["TNJTSSWGD"] = &(modelStruct.d_modelPar_TNJTSSWGD_dX);
modelStruct.modelPar_RTH0=mod.RTH0;
modelStruct.d_modelPar_RTH0_dX=0.0;
modelStruct.modelPar_given_RTH0=mod.given("RTH0");
modParamMap["RTH0"] = &(modelStruct.d_modelPar_RTH0_dX);
modelStruct.modelPar_CTH0=mod.CTH0;
modelStruct.d_modelPar_CTH0_dX=0.0;
modelStruct.modelPar_given_CTH0=mod.given("CTH0");
modParamMap["CTH0"] = &(modelStruct.d_modelPar_CTH0_dX);
modelStruct.modelPar_WTH0=mod.WTH0;
modelStruct.d_modelPar_WTH0_dX=0.0;
modelStruct.modelPar_given_WTH0=mod.given("WTH0");
modParamMap["WTH0"] = &(modelStruct.d_modelPar_WTH0_dX);
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modParamMap["SAREF"] = &(modelStruct.d_modelPar_SAREF_dX);
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modParamMap["SBREF"] = &(modelStruct.d_modelPar_SBREF_dX);
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modParamMap["WLOD"] = &(modelStruct.d_modelPar_WLOD_dX);
modelStruct.modelPar_KU0=mod.KU0;
modelStruct.d_modelPar_KU0_dX=0.0;
modelStruct.modelPar_given_KU0=mod.given("KU0");
modParamMap["KU0"] = &(modelStruct.d_modelPar_KU0_dX);
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modParamMap["KVSAT"] = &(modelStruct.d_modelPar_KVSAT_dX);
modelStruct.modelPar_TKU0=mod.TKU0;
modelStruct.d_modelPar_TKU0_dX=0.0;
modelStruct.modelPar_given_TKU0=mod.given("TKU0");
modParamMap["TKU0"] = &(modelStruct.d_modelPar_TKU0_dX);
modelStruct.modelPar_LKU0=mod.LKU0;
modelStruct.d_modelPar_LKU0_dX=0.0;
modelStruct.modelPar_given_LKU0=mod.given("LKU0");
modParamMap["LKU0"] = &(modelStruct.d_modelPar_LKU0_dX);
modelStruct.modelPar_WKU0=mod.WKU0;
modelStruct.d_modelPar_WKU0_dX=0.0;
modelStruct.modelPar_given_WKU0=mod.given("WKU0");
modParamMap["WKU0"] = &(modelStruct.d_modelPar_WKU0_dX);
modelStruct.modelPar_PKU0=mod.PKU0;
modelStruct.d_modelPar_PKU0_dX=0.0;
modelStruct.modelPar_given_PKU0=mod.given("PKU0");
modParamMap["PKU0"] = &(modelStruct.d_modelPar_PKU0_dX);
modelStruct.modelPar_LLODKU0=mod.LLODKU0;
modelStruct.d_modelPar_LLODKU0_dX=0.0;
modelStruct.modelPar_given_LLODKU0=mod.given("LLODKU0");
modParamMap["LLODKU0"] = &(modelStruct.d_modelPar_LLODKU0_dX);
modelStruct.modelPar_WLODKU0=mod.WLODKU0;
modelStruct.d_modelPar_WLODKU0_dX=0.0;
modelStruct.modelPar_given_WLODKU0=mod.given("WLODKU0");
modParamMap["WLODKU0"] = &(modelStruct.d_modelPar_WLODKU0_dX);
modelStruct.modelPar_KVTH0=mod.KVTH0;
modelStruct.d_modelPar_KVTH0_dX=0.0;
modelStruct.modelPar_given_KVTH0=mod.given("KVTH0");
modParamMap["KVTH0"] = &(modelStruct.d_modelPar_KVTH0_dX);
modelStruct.modelPar_LKVTH0=mod.LKVTH0;
modelStruct.d_modelPar_LKVTH0_dX=0.0;
modelStruct.modelPar_given_LKVTH0=mod.given("LKVTH0");
modParamMap["LKVTH0"] = &(modelStruct.d_modelPar_LKVTH0_dX);
modelStruct.modelPar_WKVTH0=mod.WKVTH0;
modelStruct.d_modelPar_WKVTH0_dX=0.0;
modelStruct.modelPar_given_WKVTH0=mod.given("WKVTH0");
modParamMap["WKVTH0"] = &(modelStruct.d_modelPar_WKVTH0_dX);
modelStruct.modelPar_PKVTH0=mod.PKVTH0;
modelStruct.d_modelPar_PKVTH0_dX=0.0;
modelStruct.modelPar_given_PKVTH0=mod.given("PKVTH0");
modParamMap["PKVTH0"] = &(modelStruct.d_modelPar_PKVTH0_dX);
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modParamMap["LLODVTH"] = &(modelStruct.d_modelPar_LLODVTH_dX);
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modParamMap["WLODVTH"] = &(modelStruct.d_modelPar_WLODVTH_dX);
modelStruct.modelPar_STK2=mod.STK2;
modelStruct.d_modelPar_STK2_dX=0.0;
modelStruct.modelPar_given_STK2=mod.given("STK2");
modParamMap["STK2"] = &(modelStruct.d_modelPar_STK2_dX);
modelStruct.modelPar_LODK2=mod.LODK2;
modelStruct.d_modelPar_LODK2_dX=0.0;
modelStruct.modelPar_given_LODK2=mod.given("LODK2");
modParamMap["LODK2"] = &(modelStruct.d_modelPar_LODK2_dX);
modelStruct.modelPar_STETA0=mod.STETA0;
modelStruct.d_modelPar_STETA0_dX=0.0;
modelStruct.modelPar_given_STETA0=mod.given("STETA0");
modParamMap["STETA0"] = &(modelStruct.d_modelPar_STETA0_dX);
modelStruct.modelPar_LODETA0=mod.LODETA0;
modelStruct.d_modelPar_LODETA0_dX=0.0;
modelStruct.modelPar_given_LODETA0=mod.given("LODETA0");
modParamMap["LODETA0"] = &(modelStruct.d_modelPar_LODETA0_dX);
modelStruct.modelPar_WEB=mod.WEB;
modelStruct.d_modelPar_WEB_dX=0.0;
modelStruct.modelPar_given_WEB=mod.given("WEB");
modParamMap["WEB"] = &(modelStruct.d_modelPar_WEB_dX);
modelStruct.modelPar_WEC=mod.WEC;
modelStruct.d_modelPar_WEC_dX=0.0;
modelStruct.modelPar_given_WEC=mod.given("WEC");
modParamMap["WEC"] = &(modelStruct.d_modelPar_WEC_dX);
modelStruct.modelPar_KVTH0WE=mod.KVTH0WE;
modelStruct.d_modelPar_KVTH0WE_dX=0.0;
modelStruct.modelPar_given_KVTH0WE=mod.given("KVTH0WE");
modParamMap["KVTH0WE"] = &(modelStruct.d_modelPar_KVTH0WE_dX);
modelStruct.modelPar_LKVTH0WE=mod.LKVTH0WE;
modelStruct.d_modelPar_LKVTH0WE_dX=0.0;
modelStruct.modelPar_given_LKVTH0WE=mod.given("LKVTH0WE");
modParamMap["LKVTH0WE"] = &(modelStruct.d_modelPar_LKVTH0WE_dX);
modelStruct.modelPar_WKVTH0WE=mod.WKVTH0WE;
modelStruct.d_modelPar_WKVTH0WE_dX=0.0;
modelStruct.modelPar_given_WKVTH0WE=mod.given("WKVTH0WE");
modParamMap["WKVTH0WE"] = &(modelStruct.d_modelPar_WKVTH0WE_dX);
modelStruct.modelPar_PKVTH0WE=mod.PKVTH0WE;
modelStruct.d_modelPar_PKVTH0WE_dX=0.0;
modelStruct.modelPar_given_PKVTH0WE=mod.given("PKVTH0WE");
modParamMap["PKVTH0WE"] = &(modelStruct.d_modelPar_PKVTH0WE_dX);
modelStruct.modelPar_K2WE=mod.K2WE;
modelStruct.d_modelPar_K2WE_dX=0.0;
modelStruct.modelPar_given_K2WE=mod.given("K2WE");
modParamMap["K2WE"] = &(modelStruct.d_modelPar_K2WE_dX);
modelStruct.modelPar_LK2WE=mod.LK2WE;
modelStruct.d_modelPar_LK2WE_dX=0.0;
modelStruct.modelPar_given_LK2WE=mod.given("LK2WE");
modParamMap["LK2WE"] = &(modelStruct.d_modelPar_LK2WE_dX);
modelStruct.modelPar_WK2WE=mod.WK2WE;
modelStruct.d_modelPar_WK2WE_dX=0.0;
modelStruct.modelPar_given_WK2WE=mod.given("WK2WE");
modParamMap["WK2WE"] = &(modelStruct.d_modelPar_WK2WE_dX);
modelStruct.modelPar_PK2WE=mod.PK2WE;
modelStruct.d_modelPar_PK2WE_dX=0.0;
modelStruct.modelPar_given_PK2WE=mod.given("PK2WE");
modParamMap["PK2WE"] = &(modelStruct.d_modelPar_PK2WE_dX);
modelStruct.modelPar_KU0WE=mod.KU0WE;
modelStruct.d_modelPar_KU0WE_dX=0.0;
modelStruct.modelPar_given_KU0WE=mod.given("KU0WE");
modParamMap["KU0WE"] = &(modelStruct.d_modelPar_KU0WE_dX);
modelStruct.modelPar_LKU0WE=mod.LKU0WE;
modelStruct.d_modelPar_LKU0WE_dX=0.0;
modelStruct.modelPar_given_LKU0WE=mod.given("LKU0WE");
modParamMap["LKU0WE"] = &(modelStruct.d_modelPar_LKU0WE_dX);
modelStruct.modelPar_WKU0WE=mod.WKU0WE;
modelStruct.d_modelPar_WKU0WE_dX=0.0;
modelStruct.modelPar_given_WKU0WE=mod.given("WKU0WE");
modParamMap["WKU0WE"] = &(modelStruct.d_modelPar_WKU0WE_dX);
modelStruct.modelPar_PKU0WE=mod.PKU0WE;
modelStruct.d_modelPar_PKU0WE_dX=0.0;
modelStruct.modelPar_given_PKU0WE=mod.given("PKU0WE");
modParamMap["PKU0WE"] = &(modelStruct.d_modelPar_PKU0WE_dX);
modelStruct.modelPar_SCREF=mod.SCREF;
modelStruct.d_modelPar_SCREF_dX=0.0;
modelStruct.modelPar_given_SCREF=mod.given("SCREF");
modParamMap["SCREF"] = &(modelStruct.d_modelPar_SCREF_dX);
modelStruct.modelPar_WEDGE=mod.WEDGE;
modelStruct.d_modelPar_WEDGE_dX=0.0;
modelStruct.modelPar_given_WEDGE=mod.given("WEDGE");
modParamMap["WEDGE"] = &(modelStruct.d_modelPar_WEDGE_dX);
modelStruct.modelPar_DGAMMAEDGE=mod.DGAMMAEDGE;
modelStruct.d_modelPar_DGAMMAEDGE_dX=0.0;
modelStruct.modelPar_given_DGAMMAEDGE=mod.given("DGAMMAEDGE");
modParamMap["DGAMMAEDGE"] = &(modelStruct.d_modelPar_DGAMMAEDGE_dX);
modelStruct.modelPar_DGAMMAEDGEL=mod.DGAMMAEDGEL;
modelStruct.d_modelPar_DGAMMAEDGEL_dX=0.0;
modelStruct.modelPar_given_DGAMMAEDGEL=mod.given("DGAMMAEDGEL");
modParamMap["DGAMMAEDGEL"] = &(modelStruct.d_modelPar_DGAMMAEDGEL_dX);
modelStruct.modelPar_DGAMMAEDGELEXP=mod.DGAMMAEDGELEXP;
modelStruct.d_modelPar_DGAMMAEDGELEXP_dX=0.0;
modelStruct.modelPar_given_DGAMMAEDGELEXP=mod.given("DGAMMAEDGELEXP");
modParamMap["DGAMMAEDGELEXP"] = &(modelStruct.d_modelPar_DGAMMAEDGELEXP_dX);
modelStruct.modelPar_DVTEDGE=mod.DVTEDGE;
modelStruct.d_modelPar_DVTEDGE_dX=0.0;
modelStruct.modelPar_given_DVTEDGE=mod.given("DVTEDGE");
modParamMap["DVTEDGE"] = &(modelStruct.d_modelPar_DVTEDGE_dX);
modelStruct.modelPar_NFACTOREDGE=mod.NFACTOREDGE;
modelStruct.d_modelPar_NFACTOREDGE_dX=0.0;
modelStruct.modelPar_given_NFACTOREDGE=mod.given("NFACTOREDGE");
modParamMap["NFACTOREDGE"] = &(modelStruct.d_modelPar_NFACTOREDGE_dX);
modelStruct.modelPar_CITEDGE=mod.CITEDGE;
modelStruct.d_modelPar_CITEDGE_dX=0.0;
modelStruct.modelPar_given_CITEDGE=mod.given("CITEDGE");
modParamMap["CITEDGE"] = &(modelStruct.d_modelPar_CITEDGE_dX);
modelStruct.modelPar_CDSCDEDGE=mod.CDSCDEDGE;
modelStruct.d_modelPar_CDSCDEDGE_dX=0.0;
modelStruct.modelPar_given_CDSCDEDGE=mod.given("CDSCDEDGE");
modParamMap["CDSCDEDGE"] = &(modelStruct.d_modelPar_CDSCDEDGE_dX);
modelStruct.modelPar_CDSCBEDGE=mod.CDSCBEDGE;
modelStruct.d_modelPar_CDSCBEDGE_dX=0.0;
modelStruct.modelPar_given_CDSCBEDGE=mod.given("CDSCBEDGE");
modParamMap["CDSCBEDGE"] = &(modelStruct.d_modelPar_CDSCBEDGE_dX);
modelStruct.modelPar_ETA0EDGE=mod.ETA0EDGE;
modelStruct.d_modelPar_ETA0EDGE_dX=0.0;
modelStruct.modelPar_given_ETA0EDGE=mod.given("ETA0EDGE");
modParamMap["ETA0EDGE"] = &(modelStruct.d_modelPar_ETA0EDGE_dX);
modelStruct.modelPar_ETABEDGE=mod.ETABEDGE;
modelStruct.d_modelPar_ETABEDGE_dX=0.0;
modelStruct.modelPar_given_ETABEDGE=mod.given("ETABEDGE");
modParamMap["ETABEDGE"] = &(modelStruct.d_modelPar_ETABEDGE_dX);
modelStruct.modelPar_KT1EDGE=mod.KT1EDGE;
modelStruct.d_modelPar_KT1EDGE_dX=0.0;
modelStruct.modelPar_given_KT1EDGE=mod.given("KT1EDGE");
modParamMap["KT1EDGE"] = &(modelStruct.d_modelPar_KT1EDGE_dX);
modelStruct.modelPar_KT1LEDGE=mod.KT1LEDGE;
modelStruct.d_modelPar_KT1LEDGE_dX=0.0;
modelStruct.modelPar_given_KT1LEDGE=mod.given("KT1LEDGE");
modParamMap["KT1LEDGE"] = &(modelStruct.d_modelPar_KT1LEDGE_dX);
modelStruct.modelPar_KT2EDGE=mod.KT2EDGE;
modelStruct.d_modelPar_KT2EDGE_dX=0.0;
modelStruct.modelPar_given_KT2EDGE=mod.given("KT2EDGE");
modParamMap["KT2EDGE"] = &(modelStruct.d_modelPar_KT2EDGE_dX);
modelStruct.modelPar_KT1EXPEDGE=mod.KT1EXPEDGE;
modelStruct.d_modelPar_KT1EXPEDGE_dX=0.0;
modelStruct.modelPar_given_KT1EXPEDGE=mod.given("KT1EXPEDGE");
modParamMap["KT1EXPEDGE"] = &(modelStruct.d_modelPar_KT1EXPEDGE_dX);
modelStruct.modelPar_TNFACTOREDGE=mod.TNFACTOREDGE;
modelStruct.d_modelPar_TNFACTOREDGE_dX=0.0;
modelStruct.modelPar_given_TNFACTOREDGE=mod.given("TNFACTOREDGE");
modParamMap["TNFACTOREDGE"] = &(modelStruct.d_modelPar_TNFACTOREDGE_dX);
modelStruct.modelPar_TETA0EDGE=mod.TETA0EDGE;
modelStruct.d_modelPar_TETA0EDGE_dX=0.0;
modelStruct.modelPar_given_TETA0EDGE=mod.given("TETA0EDGE");
modParamMap["TETA0EDGE"] = &(modelStruct.d_modelPar_TETA0EDGE_dX);
modelStruct.modelPar_DVT0EDGE=mod.DVT0EDGE;
modelStruct.d_modelPar_DVT0EDGE_dX=0.0;
modelStruct.modelPar_given_DVT0EDGE=mod.given("DVT0EDGE");
modParamMap["DVT0EDGE"] = &(modelStruct.d_modelPar_DVT0EDGE_dX);
modelStruct.modelPar_DVT1EDGE=mod.DVT1EDGE;
modelStruct.d_modelPar_DVT1EDGE_dX=0.0;
modelStruct.modelPar_given_DVT1EDGE=mod.given("DVT1EDGE");
modParamMap["DVT1EDGE"] = &(modelStruct.d_modelPar_DVT1EDGE_dX);
modelStruct.modelPar_DVT2EDGE=mod.DVT2EDGE;
modelStruct.d_modelPar_DVT2EDGE_dX=0.0;
modelStruct.modelPar_given_DVT2EDGE=mod.given("DVT2EDGE");
modParamMap["DVT2EDGE"] = &(modelStruct.d_modelPar_DVT2EDGE_dX);
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modParamMap["LMIN"] = &(modelStruct.d_modelPar_LMIN_dX);
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modParamMap["WMIN"] = &(modelStruct.d_modelPar_WMIN_dX);
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modParamMap["LMAX"] = &(modelStruct.d_modelPar_LMAX_dX);
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");
modParamMap["WMAX"] = &(modelStruct.d_modelPar_WMAX_dX);


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_NGCON=mod.NGCON;
modelStruct.modelPar_given_NGCON=mod.given("NGCON");
modelStruct.modelPar_RGATEMOD=mod.RGATEMOD;
modelStruct.modelPar_given_RGATEMOD=mod.given("RGATEMOD");
modelStruct.modelPar_RBODYMOD=mod.RBODYMOD;
modelStruct.modelPar_given_RBODYMOD=mod.given("RBODYMOD");
modelStruct.modelPar_GEOMOD=mod.GEOMOD;
modelStruct.modelPar_given_GEOMOD=mod.given("GEOMOD");
modelStruct.modelPar_RGEOMOD=mod.RGEOMOD;
modelStruct.modelPar_given_RGEOMOD=mod.given("RGEOMOD");
modelStruct.modelPar_SCA=mod.SCA;
modelStruct.modelPar_given_SCA=mod.given("SCA");
modelStruct.modelPar_SCB=mod.SCB;
modelStruct.modelPar_given_SCB=mod.given("SCB");
modelStruct.modelPar_SCC=mod.SCC;
modelStruct.modelPar_given_SCC=mod.given("SCC");
modelStruct.modelPar_SC=mod.SC;
modelStruct.modelPar_given_SC=mod.given("SC");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_CVMOD=mod.CVMOD;
modelStruct.modelPar_given_CVMOD=mod.given("CVMOD");
modelStruct.modelPar_COVMOD=mod.COVMOD;
modelStruct.modelPar_given_COVMOD=mod.given("COVMOD");
modelStruct.modelPar_RDSMOD=mod.RDSMOD;
modelStruct.modelPar_given_RDSMOD=mod.given("RDSMOD");
modelStruct.modelPar_WPEMOD=mod.WPEMOD;
modelStruct.modelPar_given_WPEMOD=mod.given("WPEMOD");
modelStruct.modelPar_ASYMMOD=mod.ASYMMOD;
modelStruct.modelPar_given_ASYMMOD=mod.given("ASYMMOD");
modelStruct.modelPar_GIDLMOD=mod.GIDLMOD;
modelStruct.modelPar_given_GIDLMOD=mod.given("GIDLMOD");
modelStruct.modelPar_IGCMOD=mod.IGCMOD;
modelStruct.modelPar_given_IGCMOD=mod.given("IGCMOD");
modelStruct.modelPar_IGBMOD=mod.IGBMOD;
modelStruct.modelPar_given_IGBMOD=mod.given("IGBMOD");
modelStruct.modelPar_TNOIMOD=mod.TNOIMOD;
modelStruct.modelPar_given_TNOIMOD=mod.given("TNOIMOD");
modelStruct.modelPar_SHMOD=mod.SHMOD;
modelStruct.modelPar_given_SHMOD=mod.given("SHMOD");
modelStruct.modelPar_MOBSCALE=mod.MOBSCALE;
modelStruct.modelPar_given_MOBSCALE=mod.given("MOBSCALE");
modelStruct.modelPar_PERMOD=mod.PERMOD;
modelStruct.modelPar_given_PERMOD=mod.given("PERMOD");
modelStruct.modelPar_BINUNIT=mod.BINUNIT;
modelStruct.modelPar_given_BINUNIT=mod.given("BINUNIT");
modelStruct.modelPar_EDGEFET=mod.EDGEFET;
modelStruct.modelPar_given_EDGEFET=mod.given("EDGEFET");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals


// non-reals



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 14+0 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
instanceStruct.instancePar_NRS=in.NRS;
instanceStruct.d_instancePar_NRS_dX=0.0;
instanceStruct.instancePar_given_NRS=in.given("NRS");
instanceStruct.instancePar_NRD=in.NRD;
instanceStruct.d_instancePar_NRD_dX=0.0;
instanceStruct.instancePar_given_NRD=in.given("NRD");
instanceStruct.instancePar_VFBSDOFF=in.VFBSDOFF;
instanceStruct.d_instancePar_VFBSDOFF_dX=0.0;
instanceStruct.instancePar_given_VFBSDOFF=in.given("VFBSDOFF");
instanceStruct.instancePar_XGW=in.XGW;
instanceStruct.d_instancePar_XGW_dX=0.0;
instanceStruct.instancePar_given_XGW=in.given("XGW");
instanceStruct.instancePar_RBPB=in.RBPB;
instanceStruct.d_instancePar_RBPB_dX=0.0;
instanceStruct.instancePar_given_RBPB=in.given("RBPB");
instanceStruct.instancePar_RBPD=in.RBPD;
instanceStruct.d_instancePar_RBPD_dX=0.0;
instanceStruct.instancePar_given_RBPD=in.given("RBPD");
instanceStruct.instancePar_RBPS=in.RBPS;
instanceStruct.d_instancePar_RBPS_dX=0.0;
instanceStruct.instancePar_given_RBPS=in.given("RBPS");
instanceStruct.instancePar_RBDB=in.RBDB;
instanceStruct.d_instancePar_RBDB_dX=0.0;
instanceStruct.instancePar_given_RBDB=in.given("RBDB");
instanceStruct.instancePar_RBSB=in.RBSB;
instanceStruct.d_instancePar_RBSB_dX=0.0;
instanceStruct.instancePar_given_RBSB=in.given("RBSB");
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
instanceStruct.instancePar_AS=in.AS;
instanceStruct.d_instancePar_AS_dX=0.0;
instanceStruct.instancePar_given_AS=in.given("AS");
instanceStruct.instancePar_AD=in.AD;
instanceStruct.d_instancePar_AD_dX=0.0;
instanceStruct.instancePar_given_AD=in.given("AD");
instanceStruct.instancePar_PS=in.PS;
instanceStruct.d_instancePar_PS_dX=0.0;
instanceStruct.instancePar_given_PS=in.given("PS");
instanceStruct.instancePar_PD=in.PD;
instanceStruct.d_instancePar_PD_dX=0.0;
instanceStruct.instancePar_given_PD=in.given("PD");
instanceStruct.instancePar_m=in.m;
instanceStruct.d_instancePar_m_dX=0.0;
instanceStruct.instancePar_given_m=in.given("m");


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_NF=in.NF;
instanceStruct.instancePar_given_NF=in.given("NF");
instanceStruct.instancePar_MINZ=in.MINZ;
instanceStruct.instancePar_given_MINZ=in.given("MINZ");
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");
instanceStruct.instancePar_RGATEMOD=in.RGATEMOD;
instanceStruct.instancePar_given_RGATEMOD=in.given("RGATEMOD");
instanceStruct.instancePar_RBODYMOD=in.RBODYMOD;
instanceStruct.instancePar_given_RBODYMOD=in.given("RBODYMOD");
instanceStruct.instancePar_GEOMOD=in.GEOMOD;
instanceStruct.instancePar_given_GEOMOD=in.given("GEOMOD");
instanceStruct.instancePar_RGEOMOD=in.RGEOMOD;
instanceStruct.instancePar_given_RGEOMOD=in.given("RGEOMOD");
instanceStruct.instancePar_SCA=in.SCA;
instanceStruct.instancePar_given_SCA=in.given("SCA");
instanceStruct.instancePar_SCB=in.SCB;
instanceStruct.instancePar_given_SCB=in.given("SCB");
instanceStruct.instancePar_SCC=in.SCC;
instanceStruct.instancePar_given_SCC=in.given("SCC");
instanceStruct.instancePar_SC=in.SC;
instanceStruct.instancePar_given_SC=in.given("SC");




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.
   if (!(in.given("L")))
   {
      instanceStruct.instancePar_L = modelStruct.modelPar_L;
      instanceStruct.d_instancePar_L_dX = modelStruct.d_modelPar_L_dX;
   }
   if (!(in.given("VFBSDOFF")))
   {
      instanceStruct.instancePar_VFBSDOFF = modelStruct.modelPar_VFBSDOFF;
      instanceStruct.d_instancePar_VFBSDOFF_dX = modelStruct.d_modelPar_VFBSDOFF_dX;
   }
   if (!(in.given("XGW")))
   {
      instanceStruct.instancePar_XGW = modelStruct.modelPar_XGW;
      instanceStruct.d_instancePar_XGW_dX = modelStruct.d_modelPar_XGW_dX;
   }
   if (!(in.given("NGCON")))
   {
      instanceStruct.instancePar_NGCON = modelStruct.modelPar_NGCON;
   }
   if (!(in.given("RGATEMOD")))
   {
      instanceStruct.instancePar_RGATEMOD = modelStruct.modelPar_RGATEMOD;
   }
   if (!(in.given("RBODYMOD")))
   {
      instanceStruct.instancePar_RBODYMOD = modelStruct.modelPar_RBODYMOD;
   }
   if (!(in.given("GEOMOD")))
   {
      instanceStruct.instancePar_GEOMOD = modelStruct.modelPar_GEOMOD;
   }
   if (!(in.given("RGEOMOD")))
   {
      instanceStruct.instancePar_RGEOMOD = modelStruct.modelPar_RGEOMOD;
   }
   if (!(in.given("RBPB")))
   {
      instanceStruct.instancePar_RBPB = modelStruct.modelPar_RBPB;
      instanceStruct.d_instancePar_RBPB_dX = modelStruct.d_modelPar_RBPB_dX;
   }
   if (!(in.given("RBPD")))
   {
      instanceStruct.instancePar_RBPD = modelStruct.modelPar_RBPD;
      instanceStruct.d_instancePar_RBPD_dX = modelStruct.d_modelPar_RBPD_dX;
   }
   if (!(in.given("RBPS")))
   {
      instanceStruct.instancePar_RBPS = modelStruct.modelPar_RBPS;
      instanceStruct.d_instancePar_RBPS_dX = modelStruct.d_modelPar_RBPS_dX;
   }
   if (!(in.given("RBDB")))
   {
      instanceStruct.instancePar_RBDB = modelStruct.modelPar_RBDB;
      instanceStruct.d_instancePar_RBDB_dX = modelStruct.d_modelPar_RBDB_dX;
   }
   if (!(in.given("RBSB")))
   {
      instanceStruct.instancePar_RBSB = modelStruct.modelPar_RBSB;
      instanceStruct.d_instancePar_RBSB_dX = modelStruct.d_modelPar_RBSB_dX;
   }
   if (!(in.given("SA")))
   {
      instanceStruct.instancePar_SA = modelStruct.modelPar_SA;
      instanceStruct.d_instancePar_SA_dX = modelStruct.d_modelPar_SA_dX;
   }
   if (!(in.given("SB")))
   {
      instanceStruct.instancePar_SB = modelStruct.modelPar_SB;
      instanceStruct.d_instancePar_SB_dX = modelStruct.d_modelPar_SB_dX;
   }
   if (!(in.given("SD")))
   {
      instanceStruct.instancePar_SD = modelStruct.modelPar_SD;
      instanceStruct.d_instancePar_SD_dX = modelStruct.d_modelPar_SD_dX;
   }
   if (!(in.given("SCA")))
   {
      instanceStruct.instancePar_SCA = modelStruct.modelPar_SCA;
   }
   if (!(in.given("SCB")))
   {
      instanceStruct.instancePar_SCB = modelStruct.modelPar_SCB;
   }
   if (!(in.given("SCC")))
   {
      instanceStruct.instancePar_SCC = modelStruct.modelPar_SCC;
   }
   if (!(in.given("SC")))
   {
      instanceStruct.instancePar_SC = modelStruct.modelPar_SC;
   }


  //make local copies of all instance vars
  //reals
instanceStruct.instanceVar_T0=in.T0;
instanceStruct.d_instanceVar_T0_dX=0.0;
instanceStruct.instanceVar_T1=in.T1;
instanceStruct.d_instanceVar_T1_dX=0.0;
instanceStruct.instanceVar_T2=in.T2;
instanceStruct.d_instanceVar_T2_dX=0.0;
instanceStruct.instanceVar_epssi=in.epssi;
instanceStruct.d_instanceVar_epssi_dX=0.0;
instanceStruct.instanceVar_epsox=in.epsox;
instanceStruct.d_instanceVar_epsox_dX=0.0;
instanceStruct.instanceVar_Weff=in.Weff;
instanceStruct.d_instanceVar_Weff_dX=0.0;
instanceStruct.instanceVar_Leff=in.Leff;
instanceStruct.d_instanceVar_Leff_dX=0.0;
instanceStruct.instanceVar_Wact=in.Wact;
instanceStruct.d_instanceVar_Wact_dX=0.0;
instanceStruct.instanceVar_Lact=in.Lact;
instanceStruct.d_instanceVar_Lact_dX=0.0;
instanceStruct.instanceVar_Weffcj=in.Weffcj;
instanceStruct.d_instanceVar_Weffcj_dX=0.0;
instanceStruct.instanceVar_Cox=in.Cox;
instanceStruct.d_instanceVar_Cox_dX=0.0;
instanceStruct.instanceVar_epsratio=in.epsratio;
instanceStruct.d_instanceVar_epsratio_dX=0.0;
instanceStruct.instanceVar_Lnew=in.Lnew;
instanceStruct.d_instanceVar_Lnew_dX=0.0;
instanceStruct.instanceVar_L_mult=in.L_mult;
instanceStruct.d_instanceVar_L_mult_dX=0.0;
instanceStruct.instanceVar_Wnew=in.Wnew;
instanceStruct.d_instanceVar_Wnew_dX=0.0;
instanceStruct.instanceVar_DVTP0_i=in.DVTP0_i;
instanceStruct.d_instanceVar_DVTP0_i_dX=0.0;
instanceStruct.instanceVar_DVTP1_i=in.DVTP1_i;
instanceStruct.d_instanceVar_DVTP1_i_dX=0.0;
instanceStruct.instanceVar_DVTP2_i=in.DVTP2_i;
instanceStruct.d_instanceVar_DVTP2_i_dX=0.0;
instanceStruct.instanceVar_DVTP3_i=in.DVTP3_i;
instanceStruct.d_instanceVar_DVTP3_i_dX=0.0;
instanceStruct.instanceVar_DVTP4_i=in.DVTP4_i;
instanceStruct.d_instanceVar_DVTP4_i_dX=0.0;
instanceStruct.instanceVar_DVTP5_i=in.DVTP5_i;
instanceStruct.d_instanceVar_DVTP5_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_A11_i=in.A11_i;
instanceStruct.d_instanceVar_A11_i_dX=0.0;
instanceStruct.instanceVar_A2_i=in.A2_i;
instanceStruct.d_instanceVar_A2_i_dX=0.0;
instanceStruct.instanceVar_A21_i=in.A21_i;
instanceStruct.d_instanceVar_A21_i_dX=0.0;
instanceStruct.instanceVar_PSAT_i=in.PSAT_i;
instanceStruct.d_instanceVar_PSAT_i_dX=0.0;
instanceStruct.instanceVar_PSATR_i=in.PSATR_i;
instanceStruct.d_instanceVar_PSATR_i_dX=0.0;
instanceStruct.instanceVar_BSIM6TOXP=in.BSIM6TOXP;
instanceStruct.d_instanceVar_BSIM6TOXP_dX=0.0;
instanceStruct.instanceVar_DMCGeff=in.DMCGeff;
instanceStruct.d_instanceVar_DMCGeff_dX=0.0;
instanceStruct.instanceVar_DMDGeff=in.DMDGeff;
instanceStruct.d_instanceVar_DMDGeff_dX=0.0;
instanceStruct.instanceVar_DMCIeff=in.DMCIeff;
instanceStruct.d_instanceVar_DMCIeff_dX=0.0;
instanceStruct.instanceVar_RSourceGeo=in.RSourceGeo;
instanceStruct.d_instanceVar_RSourceGeo_dX=0.0;
instanceStruct.instanceVar_RDrainGeo=in.RDrainGeo;
instanceStruct.d_instanceVar_RDrainGeo_dX=0.0;
instanceStruct.instanceVar_Grgeltd=in.Grgeltd;
instanceStruct.d_instanceVar_Grgeltd_dX=0.0;
instanceStruct.instanceVar_Grbsb=in.Grbsb;
instanceStruct.d_instanceVar_Grbsb_dX=0.0;
instanceStruct.instanceVar_Grbdb=in.Grbdb;
instanceStruct.d_instanceVar_Grbdb_dX=0.0;
instanceStruct.instanceVar_Grbpb=in.Grbpb;
instanceStruct.d_instanceVar_Grbpb_dX=0.0;
instanceStruct.instanceVar_Grbps=in.Grbps;
instanceStruct.d_instanceVar_Grbps_dX=0.0;
instanceStruct.instanceVar_Grbpd=in.Grbpd;
instanceStruct.d_instanceVar_Grbpd_dX=0.0;
instanceStruct.instanceVar_Aechvb=in.Aechvb;
instanceStruct.d_instanceVar_Aechvb_dX=0.0;
instanceStruct.instanceVar_Bechvb=in.Bechvb;
instanceStruct.d_instanceVar_Bechvb_dX=0.0;
instanceStruct.instanceVar_AechvbEdge=in.AechvbEdge;
instanceStruct.d_instanceVar_AechvbEdge_dX=0.0;
instanceStruct.instanceVar_BechvbEdge=in.BechvbEdge;
instanceStruct.d_instanceVar_BechvbEdge_dX=0.0;
instanceStruct.instanceVar_ToxRatio=in.ToxRatio;
instanceStruct.d_instanceVar_ToxRatio_dX=0.0;
instanceStruct.instanceVar_U0R_t=in.U0R_t;
instanceStruct.d_instanceVar_U0R_t_dX=0.0;
instanceStruct.instanceVar_UAR_t=in.UAR_t;
instanceStruct.d_instanceVar_UAR_t_dX=0.0;
instanceStruct.instanceVar_UCR_t=in.UCR_t;
instanceStruct.d_instanceVar_UCR_t_dX=0.0;
instanceStruct.instanceVar_UDR_t=in.UDR_t;
instanceStruct.d_instanceVar_UDR_t_dX=0.0;
instanceStruct.instanceVar_UCSR_t=in.UCSR_t;
instanceStruct.d_instanceVar_UCSR_t_dX=0.0;
instanceStruct.instanceVar_VSATR_t=in.VSATR_t;
instanceStruct.d_instanceVar_VSATR_t_dX=0.0;
instanceStruct.instanceVar_PTWGR_t=in.PTWGR_t;
instanceStruct.d_instanceVar_PTWGR_t_dX=0.0;
instanceStruct.instanceVar_ETA0R_t=in.ETA0R_t;
instanceStruct.d_instanceVar_ETA0R_t_dX=0.0;
instanceStruct.instanceVar_PSATB_i=in.PSATB_i;
instanceStruct.d_instanceVar_PSATB_i_dX=0.0;
instanceStruct.instanceVar_KT1_i=in.KT1_i;
instanceStruct.d_instanceVar_KT1_i_dX=0.0;
instanceStruct.instanceVar_KT2_i=in.KT2_i;
instanceStruct.d_instanceVar_KT2_i_dX=0.0;
instanceStruct.instanceVar_NGATE_i=in.NGATE_i;
instanceStruct.d_instanceVar_NGATE_i_dX=0.0;
instanceStruct.instanceVar_NSD_i=in.NSD_i;
instanceStruct.d_instanceVar_NSD_i_dX=0.0;
instanceStruct.instanceVar_NDEP_i=in.NDEP_i;
instanceStruct.d_instanceVar_NDEP_i_dX=0.0;
instanceStruct.instanceVar_VFB_i=in.VFB_i;
instanceStruct.d_instanceVar_VFB_i_dX=0.0;
instanceStruct.instanceVar_CIT_i=in.CIT_i;
instanceStruct.d_instanceVar_CIT_i_dX=0.0;
instanceStruct.instanceVar_CDSCD_i=in.CDSCD_i;
instanceStruct.d_instanceVar_CDSCD_i_dX=0.0;
instanceStruct.instanceVar_CDSCDR_i=in.CDSCDR_i;
instanceStruct.d_instanceVar_CDSCDR_i_dX=0.0;
instanceStruct.instanceVar_CDSCB_i=in.CDSCB_i;
instanceStruct.d_instanceVar_CDSCB_i_dX=0.0;
instanceStruct.instanceVar_NFACTOR_i=in.NFACTOR_i;
instanceStruct.d_instanceVar_NFACTOR_i_dX=0.0;
instanceStruct.instanceVar_PHIN_i=in.PHIN_i;
instanceStruct.d_instanceVar_PHIN_i_dX=0.0;
instanceStruct.instanceVar_ETA0_i=in.ETA0_i;
instanceStruct.d_instanceVar_ETA0_i_dX=0.0;
instanceStruct.instanceVar_ETA0R_i=in.ETA0R_i;
instanceStruct.d_instanceVar_ETA0R_i_dX=0.0;
instanceStruct.instanceVar_ETAB_i=in.ETAB_i;
instanceStruct.d_instanceVar_ETAB_i_dX=0.0;
instanceStruct.instanceVar_K2_i=in.K2_i;
instanceStruct.d_instanceVar_K2_i_dX=0.0;
instanceStruct.instanceVar_K1_i=in.K1_i;
instanceStruct.d_instanceVar_K1_i_dX=0.0;
instanceStruct.instanceVar_DELTA_i=in.DELTA_i;
instanceStruct.d_instanceVar_DELTA_i_dX=0.0;
instanceStruct.instanceVar_U0_i=in.U0_i;
instanceStruct.d_instanceVar_U0_i_dX=0.0;
instanceStruct.instanceVar_U0R_i=in.U0R_i;
instanceStruct.d_instanceVar_U0R_i_dX=0.0;
instanceStruct.instanceVar_VSAT_i=in.VSAT_i;
instanceStruct.d_instanceVar_VSAT_i_dX=0.0;
instanceStruct.instanceVar_VSATR_i=in.VSATR_i;
instanceStruct.d_instanceVar_VSATR_i_dX=0.0;
instanceStruct.instanceVar_VSATCV_i=in.VSATCV_i;
instanceStruct.d_instanceVar_VSATCV_i_dX=0.0;
instanceStruct.instanceVar_UA_i=in.UA_i;
instanceStruct.d_instanceVar_UA_i_dX=0.0;
instanceStruct.instanceVar_UAR_i=in.UAR_i;
instanceStruct.d_instanceVar_UAR_i_dX=0.0;
instanceStruct.instanceVar_EU_i=in.EU_i;
instanceStruct.d_instanceVar_EU_i_dX=0.0;
instanceStruct.instanceVar_UD_i=in.UD_i;
instanceStruct.d_instanceVar_UD_i_dX=0.0;
instanceStruct.instanceVar_UDR_i=in.UDR_i;
instanceStruct.d_instanceVar_UDR_i_dX=0.0;
instanceStruct.instanceVar_UD_a=in.UD_a;
instanceStruct.d_instanceVar_UD_a_dX=0.0;
instanceStruct.instanceVar_UCS_i=in.UCS_i;
instanceStruct.d_instanceVar_UCS_i_dX=0.0;
instanceStruct.instanceVar_UCSR_i=in.UCSR_i;
instanceStruct.d_instanceVar_UCSR_i_dX=0.0;
instanceStruct.instanceVar_UC_i=in.UC_i;
instanceStruct.d_instanceVar_UC_i_dX=0.0;
instanceStruct.instanceVar_UCR_i=in.UCR_i;
instanceStruct.d_instanceVar_UCR_i_dX=0.0;
instanceStruct.instanceVar_PDIBLC_i=in.PDIBLC_i;
instanceStruct.d_instanceVar_PDIBLC_i_dX=0.0;
instanceStruct.instanceVar_PDIBLCR_i=in.PDIBLCR_i;
instanceStruct.d_instanceVar_PDIBLCR_i_dX=0.0;
instanceStruct.instanceVar_PDIBLCB_i=in.PDIBLCB_i;
instanceStruct.d_instanceVar_PDIBLCB_i_dX=0.0;
instanceStruct.instanceVar_PSCBE1_i=in.PSCBE1_i;
instanceStruct.d_instanceVar_PSCBE1_i_dX=0.0;
instanceStruct.instanceVar_PSCBE2_i=in.PSCBE2_i;
instanceStruct.d_instanceVar_PSCBE2_i_dX=0.0;
instanceStruct.instanceVar_PDITS_i=in.PDITS_i;
instanceStruct.d_instanceVar_PDITS_i_dX=0.0;
instanceStruct.instanceVar_PDITSD_i=in.PDITSD_i;
instanceStruct.d_instanceVar_PDITSD_i_dX=0.0;
instanceStruct.instanceVar_FPROUT_i=in.FPROUT_i;
instanceStruct.d_instanceVar_FPROUT_i_dX=0.0;
instanceStruct.instanceVar_PRWG_i=in.PRWG_i;
instanceStruct.d_instanceVar_PRWG_i_dX=0.0;
instanceStruct.instanceVar_WR_i=in.WR_i;
instanceStruct.d_instanceVar_WR_i_dX=0.0;
instanceStruct.instanceVar_RDWMIN_i=in.RDWMIN_i;
instanceStruct.d_instanceVar_RDWMIN_i_dX=0.0;
instanceStruct.instanceVar_RSWMIN_i=in.RSWMIN_i;
instanceStruct.d_instanceVar_RSWMIN_i_dX=0.0;
instanceStruct.instanceVar_RDW_i=in.RDW_i;
instanceStruct.d_instanceVar_RDW_i_dX=0.0;
instanceStruct.instanceVar_RSW_i=in.RSW_i;
instanceStruct.d_instanceVar_RSW_i_dX=0.0;
instanceStruct.instanceVar_RDSW_i=in.RDSW_i;
instanceStruct.d_instanceVar_RDSW_i_dX=0.0;
instanceStruct.instanceVar_RDSWMIN_i=in.RDSWMIN_i;
instanceStruct.d_instanceVar_RDSWMIN_i_dX=0.0;
instanceStruct.instanceVar_PTWG_i=in.PTWG_i;
instanceStruct.d_instanceVar_PTWG_i_dX=0.0;
instanceStruct.instanceVar_PTWGR_i=in.PTWGR_i;
instanceStruct.d_instanceVar_PTWGR_i_dX=0.0;
instanceStruct.instanceVar_PVAG_i=in.PVAG_i;
instanceStruct.d_instanceVar_PVAG_i_dX=0.0;
instanceStruct.instanceVar_XJ_i=in.XJ_i;
instanceStruct.d_instanceVar_XJ_i_dX=0.0;
instanceStruct.instanceVar_PCLM_i=in.PCLM_i;
instanceStruct.d_instanceVar_PCLM_i_dX=0.0;
instanceStruct.instanceVar_PCLMR_i=in.PCLMR_i;
instanceStruct.d_instanceVar_PCLMR_i_dX=0.0;
instanceStruct.instanceVar_PCLMCV_i=in.PCLMCV_i;
instanceStruct.d_instanceVar_PCLMCV_i_dX=0.0;
instanceStruct.instanceVar_PRWB_i=in.PRWB_i;
instanceStruct.d_instanceVar_PRWB_i_dX=0.0;
instanceStruct.instanceVar_CF_i=in.CF_i;
instanceStruct.d_instanceVar_CF_i_dX=0.0;
instanceStruct.instanceVar_CGSL_i=in.CGSL_i;
instanceStruct.d_instanceVar_CGSL_i_dX=0.0;
instanceStruct.instanceVar_CGDL_i=in.CGDL_i;
instanceStruct.d_instanceVar_CGDL_i_dX=0.0;
instanceStruct.instanceVar_CKAPPAS_i=in.CKAPPAS_i;
instanceStruct.d_instanceVar_CKAPPAS_i_dX=0.0;
instanceStruct.instanceVar_CKAPPAD_i=in.CKAPPAD_i;
instanceStruct.d_instanceVar_CKAPPAD_i_dX=0.0;
instanceStruct.instanceVar_VFBCV_i=in.VFBCV_i;
instanceStruct.d_instanceVar_VFBCV_i_dX=0.0;
instanceStruct.instanceVar_NDEPCV_i=in.NDEPCV_i;
instanceStruct.d_instanceVar_NDEPCV_i_dX=0.0;
instanceStruct.instanceVar_ALPHA0_i=in.ALPHA0_i;
instanceStruct.d_instanceVar_ALPHA0_i_dX=0.0;
instanceStruct.instanceVar_BETA0_i=in.BETA0_i;
instanceStruct.d_instanceVar_BETA0_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_BGIDL_i=in.BGIDL_i;
instanceStruct.d_instanceVar_BGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_EGIDL_i=in.EGIDL_i;
instanceStruct.d_instanceVar_EGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGISL_i=in.AGISL_i;
instanceStruct.d_instanceVar_AGISL_i_dX=0.0;
instanceStruct.instanceVar_BGISL_i=in.BGISL_i;
instanceStruct.d_instanceVar_BGISL_i_dX=0.0;
instanceStruct.instanceVar_CGISL_i=in.CGISL_i;
instanceStruct.d_instanceVar_CGISL_i_dX=0.0;
instanceStruct.instanceVar_EGISL_i=in.EGISL_i;
instanceStruct.d_instanceVar_EGISL_i_dX=0.0;
instanceStruct.instanceVar_UTE_i=in.UTE_i;
instanceStruct.d_instanceVar_UTE_i_dX=0.0;
instanceStruct.instanceVar_UA1_i=in.UA1_i;
instanceStruct.d_instanceVar_UA1_i_dX=0.0;
instanceStruct.instanceVar_UC1_i=in.UC1_i;
instanceStruct.d_instanceVar_UC1_i_dX=0.0;
instanceStruct.instanceVar_UD1_i=in.UD1_i;
instanceStruct.d_instanceVar_UD1_i_dX=0.0;
instanceStruct.instanceVar_UCSTE_i=in.UCSTE_i;
instanceStruct.d_instanceVar_UCSTE_i_dX=0.0;
instanceStruct.instanceVar_PRT_i=in.PRT_i;
instanceStruct.d_instanceVar_PRT_i_dX=0.0;
instanceStruct.instanceVar_AT_i=in.AT_i;
instanceStruct.d_instanceVar_AT_i_dX=0.0;
instanceStruct.instanceVar_PTWGT_i=in.PTWGT_i;
instanceStruct.d_instanceVar_PTWGT_i_dX=0.0;
instanceStruct.instanceVar_IIT_i=in.IIT_i;
instanceStruct.d_instanceVar_IIT_i_dX=0.0;
instanceStruct.instanceVar_TGIDL_i=in.TGIDL_i;
instanceStruct.d_instanceVar_TGIDL_i_dX=0.0;
instanceStruct.instanceVar_KVTH0WE_i=in.KVTH0WE_i;
instanceStruct.d_instanceVar_KVTH0WE_i_dX=0.0;
instanceStruct.instanceVar_K2WE_i=in.K2WE_i;
instanceStruct.d_instanceVar_K2WE_i_dX=0.0;
instanceStruct.instanceVar_KU0WE_i=in.KU0WE_i;
instanceStruct.d_instanceVar_KU0WE_i_dX=0.0;
instanceStruct.instanceVar_AIGBINV_i=in.AIGBINV_i;
instanceStruct.d_instanceVar_AIGBINV_i_dX=0.0;
instanceStruct.instanceVar_BIGBINV_i=in.BIGBINV_i;
instanceStruct.d_instanceVar_BIGBINV_i_dX=0.0;
instanceStruct.instanceVar_CIGBINV_i=in.CIGBINV_i;
instanceStruct.d_instanceVar_CIGBINV_i_dX=0.0;
instanceStruct.instanceVar_EIGBINV_i=in.EIGBINV_i;
instanceStruct.d_instanceVar_EIGBINV_i_dX=0.0;
instanceStruct.instanceVar_NIGBINV_i=in.NIGBINV_i;
instanceStruct.d_instanceVar_NIGBINV_i_dX=0.0;
instanceStruct.instanceVar_AIGBACC_i=in.AIGBACC_i;
instanceStruct.d_instanceVar_AIGBACC_i_dX=0.0;
instanceStruct.instanceVar_BIGBACC_i=in.BIGBACC_i;
instanceStruct.d_instanceVar_BIGBACC_i_dX=0.0;
instanceStruct.instanceVar_CIGBACC_i=in.CIGBACC_i;
instanceStruct.d_instanceVar_CIGBACC_i_dX=0.0;
instanceStruct.instanceVar_NIGBACC_i=in.NIGBACC_i;
instanceStruct.d_instanceVar_NIGBACC_i_dX=0.0;
instanceStruct.instanceVar_AIGC_i=in.AIGC_i;
instanceStruct.d_instanceVar_AIGC_i_dX=0.0;
instanceStruct.instanceVar_BIGC_i=in.BIGC_i;
instanceStruct.d_instanceVar_BIGC_i_dX=0.0;
instanceStruct.instanceVar_CIGC_i=in.CIGC_i;
instanceStruct.d_instanceVar_CIGC_i_dX=0.0;
instanceStruct.instanceVar_AIGS_i=in.AIGS_i;
instanceStruct.d_instanceVar_AIGS_i_dX=0.0;
instanceStruct.instanceVar_BIGS_i=in.BIGS_i;
instanceStruct.d_instanceVar_BIGS_i_dX=0.0;
instanceStruct.instanceVar_CIGS_i=in.CIGS_i;
instanceStruct.d_instanceVar_CIGS_i_dX=0.0;
instanceStruct.instanceVar_AIGD_i=in.AIGD_i;
instanceStruct.d_instanceVar_AIGD_i_dX=0.0;
instanceStruct.instanceVar_BIGD_i=in.BIGD_i;
instanceStruct.d_instanceVar_BIGD_i_dX=0.0;
instanceStruct.instanceVar_CIGD_i=in.CIGD_i;
instanceStruct.d_instanceVar_CIGD_i_dX=0.0;
instanceStruct.instanceVar_PIGCD_i=in.PIGCD_i;
instanceStruct.d_instanceVar_PIGCD_i_dX=0.0;
instanceStruct.instanceVar_DLCIG_i=in.DLCIG_i;
instanceStruct.d_instanceVar_DLCIG_i_dX=0.0;
instanceStruct.instanceVar_DLCIGD_i=in.DLCIGD_i;
instanceStruct.d_instanceVar_DLCIGD_i_dX=0.0;
instanceStruct.instanceVar_IGT_i=in.IGT_i;
instanceStruct.d_instanceVar_IGT_i_dX=0.0;
instanceStruct.instanceVar_nuIntD=in.nuIntD;
instanceStruct.d_instanceVar_nuIntD_dX=0.0;
instanceStruct.instanceVar_nuEndD=in.nuEndD;
instanceStruct.instanceVar_nuIntS=in.nuIntS;
instanceStruct.d_instanceVar_nuIntS_dX=0.0;
instanceStruct.instanceVar_nuEndS=in.nuEndS;
instanceStruct.instanceVar_gth=in.gth;
instanceStruct.d_instanceVar_gth_dX=0.0;
instanceStruct.instanceVar_cth=in.cth;
instanceStruct.d_instanceVar_cth_dX=0.0;
instanceStruct.instanceVar_QSI=in.QSI;
instanceStruct.d_instanceVar_QSI_dX=0.0;
instanceStruct.instanceVar_QDI=in.QDI;
instanceStruct.d_instanceVar_QDI_dX=0.0;
instanceStruct.instanceVar_QGI=in.QGI;
instanceStruct.d_instanceVar_QGI_dX=0.0;
instanceStruct.instanceVar_ISUB=in.ISUB;
instanceStruct.d_instanceVar_ISUB_dX=0.0;
instanceStruct.instanceVar_IGIDL=in.IGIDL;
instanceStruct.d_instanceVar_IGIDL_dX=0.0;
instanceStruct.instanceVar_IGISL=in.IGISL;
instanceStruct.d_instanceVar_IGISL_dX=0.0;
instanceStruct.instanceVar_IGS=in.IGS;
instanceStruct.d_instanceVar_IGS_dX=0.0;
instanceStruct.instanceVar_IGD=in.IGD;
instanceStruct.d_instanceVar_IGD_dX=0.0;
instanceStruct.instanceVar_IGCS=in.IGCS;
instanceStruct.d_instanceVar_IGCS_dX=0.0;
instanceStruct.instanceVar_IGCD=in.IGCD;
instanceStruct.d_instanceVar_IGCD_dX=0.0;
instanceStruct.instanceVar_IGB=in.IGB;
instanceStruct.d_instanceVar_IGB_dX=0.0;


  //non-reals
instanceStruct.instanceVar_devsign=in.devsign;



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_bi_dbulk] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_dbulk];
probeVars[in.admsProbeID_V_b_dbulk] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_dbulk];
probeVars[in.admsProbeID_V_b_bi] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_b_sbulk] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_sbulk];
probeVars[in.admsProbeID_V_bi_sbulk] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_sbulk];
probeVars[in.admsProbeID_V_gm_gi] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_g_gm] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_gm];
probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_gi_si] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_dbulk_GND] = (*solVectorPtr)[in.li_dbulk];
probeVars[in.admsProbeID_V_sbulk_GND] = (*solVectorPtr)[in.li_sbulk];
probeVars[in.admsProbeID_V_gm_GND] = (*solVectorPtr)[in.li_gm];
probeVars[in.admsProbeID_V_gi_GND] = (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_bi_GND] = (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_di_GND] = (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_gm_bi] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_N1_GND] = (*solVectorPtr)[in.li_N1];
probeVars[in.admsProbeID_V_N2_GND] = (*solVectorPtr)[in.li_N2];
probeVars[in.admsProbeID_V_gm_si] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_gm_di] = (*solVectorPtr)[in.li_gm] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_dbulk_di] = (*solVectorPtr)[in.li_dbulk] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_sbulk_si] = (*solVectorPtr)[in.li_sbulk] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_si_bi] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_di_bi] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_gi_bi] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_Temp_t_GND] = (in.collapseNode_t)?(0):((*solVectorPtr)[in.li_t]);


evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_b,
in.admsNodeID_t,
in.admsNodeID_di,
in.admsNodeID_si,
in.admsNodeID_gi,
in.admsNodeID_gm,
in.admsNodeID_bi,
in.admsNodeID_sbulk,
in.admsNodeID_dbulk,
in.admsNodeID_N1,
in.admsNodeID_N2,
 in.portsConnected_,
in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_bi_dbulk,
in.admsProbeID_V_b_dbulk,
in.admsProbeID_V_b_bi,
in.admsProbeID_V_b_sbulk,
in.admsProbeID_V_bi_sbulk,
in.admsProbeID_V_gm_gi,
in.admsProbeID_V_g_gm,
in.admsProbeID_V_s_si,
in.admsProbeID_V_d_di,
in.admsProbeID_V_gi_si,
in.admsProbeID_V_di_si,
in.admsProbeID_V_dbulk_GND,
in.admsProbeID_V_sbulk_GND,
in.admsProbeID_V_gm_GND,
in.admsProbeID_V_gi_GND,
in.admsProbeID_V_bi_GND,
in.admsProbeID_V_di_GND,
in.admsProbeID_V_si_GND,
in.admsProbeID_V_gm_bi,
in.admsProbeID_V_N1_GND,
in.admsProbeID_V_N2_GND,
in.admsProbeID_V_gm_si,
in.admsProbeID_V_gm_di,
in.admsProbeID_V_dbulk_di,
in.admsProbeID_V_sbulk_si,
in.admsProbeID_V_si_bi,
in.admsProbeID_V_di_bi,
in.admsProbeID_V_gi_bi,
in.admsProbeID_Temp_t_GND,

// node constants
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_b,
in.admsNodeID_t,
in.admsNodeID_di,
in.admsNodeID_si,
in.admsNodeID_gi,
in.admsNodeID_gm,
in.admsNodeID_bi,
in.admsNodeID_sbulk,
in.admsNodeID_dbulk,
in.admsNodeID_N1,
in.admsNodeID_N2,
instanceStruct,
modelStruct,
 in.portsConnected_,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_d];
    dqdp[in.admsNodeID_d+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_d];
    Findices[in.admsNodeID_d+inst*(14+0)] = in.li_d;
    Qindices[in.admsNodeID_d+inst*(14+0)] = in.li_d;
    dfdp[in.admsNodeID_g+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_g];
    dqdp[in.admsNodeID_g+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_g];
    Findices[in.admsNodeID_g+inst*(14+0)] = in.li_g;
    Qindices[in.admsNodeID_g+inst*(14+0)] = in.li_g;
    dfdp[in.admsNodeID_s+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s+inst*(14+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(14+0)] = in.li_s;
    dfdp[in.admsNodeID_b+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_b];
    dqdp[in.admsNodeID_b+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_b];
    Findices[in.admsNodeID_b+inst*(14+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(14+0)] = in.li_b;
    dfdp[in.admsNodeID_t+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_t];
    dqdp[in.admsNodeID_t+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_t];
    Findices[in.admsNodeID_t+inst*(14+0)] = in.li_t;
    Qindices[in.admsNodeID_t+inst*(14+0)] = in.li_t;
    dfdp[in.admsNodeID_di+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_di];
    dqdp[in.admsNodeID_di+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_di];
    Findices[in.admsNodeID_di+inst*(14+0)] = in.li_di;
    Qindices[in.admsNodeID_di+inst*(14+0)] = in.li_di;
    dfdp[in.admsNodeID_si+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si+inst*(14+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(14+0)] = in.li_si;
    dfdp[in.admsNodeID_gi+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_gi];
    dqdp[in.admsNodeID_gi+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_gi];
    Findices[in.admsNodeID_gi+inst*(14+0)] = in.li_gi;
    Qindices[in.admsNodeID_gi+inst*(14+0)] = in.li_gi;
    dfdp[in.admsNodeID_gm+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_gm];
    dqdp[in.admsNodeID_gm+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_gm];
    Findices[in.admsNodeID_gm+inst*(14+0)] = in.li_gm;
    Qindices[in.admsNodeID_gm+inst*(14+0)] = in.li_gm;
    dfdp[in.admsNodeID_bi+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_bi];
    dqdp[in.admsNodeID_bi+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_bi];
    Findices[in.admsNodeID_bi+inst*(14+0)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(14+0)] = in.li_bi;
    dfdp[in.admsNodeID_sbulk+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_sbulk];
    dqdp[in.admsNodeID_sbulk+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_sbulk];
    Findices[in.admsNodeID_sbulk+inst*(14+0)] = in.li_sbulk;
    Qindices[in.admsNodeID_sbulk+inst*(14+0)] = in.li_sbulk;
    dfdp[in.admsNodeID_dbulk+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_dbulk];
    dqdp[in.admsNodeID_dbulk+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_dbulk];
    Findices[in.admsNodeID_dbulk+inst*(14+0)] = in.li_dbulk;
    Qindices[in.admsNodeID_dbulk+inst*(14+0)] = in.li_dbulk;
    dfdp[in.admsNodeID_N1+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_N1];
    dqdp[in.admsNodeID_N1+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_N1];
    Findices[in.admsNodeID_N1+inst*(14+0)] = in.li_N1;
    Qindices[in.admsNodeID_N1+inst*(14+0)] = in.li_N1;
    dfdp[in.admsNodeID_N2+inst*(14+0)] += d_staticContributions_dX[in.admsNodeID_N2];
    dqdp[in.admsNodeID_N2+inst*(14+0)] += d_dynamicContributions_dX[in.admsNodeID_N2];
    Findices[in.admsNodeID_N2+inst*(14+0)] = in.li_N2;
    Qindices[in.admsNodeID_N2+inst*(14+0)] = in.li_N2;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSbsim6
} // namespace Device
} // namespace Xyce
