
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file bsimcmg.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:28
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSbsimcmg.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

  #include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMSbsimcmg {
namespace AnalogFunctions {
// Derivative of Analog Function lexp
double d_lexp(double x  , double d_x )
{
// Function return variable and total deriv
double lexp;
double d_lexp;
// Derivatives of return value w.r.t input vars
double d_lexp_d_x;
{
if((x>80.0))
{
d_lexp_d_x=(5.540622384e+34);
lexp=(5.540622384e+34*((1.0+x)-80.0));
}
else
{
if((x<(-80.0)))
{
d_lexp_d_x=0.0;
lexp=1.804851387e-35;
}
else
{
d_lexp_d_x=exp(x);
lexp=exp(x);
}
}
}
d_lexp = d_lexp_d_x*d_x;
return(d_lexp);
}

// Evaluator class implementations for Analog Function lexp
  // Constructor
  lexpEvaluator::lexpEvaluator(double x)
  {
    lexpReturn_ = evaluator_(x);
  }
  // method to get precomputed values into double vars 
  double lexpEvaluator::getValues(double  x)
  {
    // Silence unused argument warnings
    (void) x;
    // Copy all precomputed values into corresponding output
    return(lexpReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double lexpEvaluator::getDerivs(double x  , double d_x)
  {
    // Function total deriv
    double d_lexp;
    // Silence unused argument warnings
    (void) x;
    d_lexp = lexpReturn_.deriv_WRT_x*d_x;
    return(d_lexp);
  }
  // method that actually performs our computations.
  lexpEvaluator::returnType lexpEvaluator::evaluator_(double x)
  {
  // Function value and derivs variables, and a returnType to store everything
  double lexp;
  lexpEvaluator::returnType lexpReturn;
  // Derivatives of return value w.r.t input vars
  double d_lexp_d_x;
  // declared local variables
{
if((x>80.0))
{
d_lexp_d_x=(5.540622384e+34);
lexp=(5.540622384e+34*((1.0+x)-80.0));
}
else
{
if((x<(-80.0)))
{
d_lexp_d_x=0.0;
lexp=1.804851387e-35;
}
else
{
d_lexp_d_x=exp(x);
lexp=exp(x);
}
}
}
  // now save outputs and derivs into appropriate return vars
  lexpReturn.value=lexp;
  lexpReturn.deriv_WRT_x = d_lexp_d_x;
  return(lexpReturn);
  }

// Derivative of Analog Function lln
double d_lln(double x  , double d_x )
{
// Function return variable and total deriv
double lln;
double d_lln;
// Derivatives of return value w.r.t input vars
double d_lln_d_x;
{
d_lln_d_x=(1.0/std::max( static_cast<double>(x), static_cast<double>(1.0e-38)))*((x>=1.0e-38)?1.0:0.0);
lln=log(std::max( static_cast<double>(x), static_cast<double>(1.0e-38)));
}
d_lln = d_lln_d_x*d_x;
return(d_lln);
}

// Evaluator class implementations for Analog Function lln
  // Constructor
  llnEvaluator::llnEvaluator(double x)
  {
    llnReturn_ = evaluator_(x);
  }
  // method to get precomputed values into double vars 
  double llnEvaluator::getValues(double  x)
  {
    // Silence unused argument warnings
    (void) x;
    // Copy all precomputed values into corresponding output
    return(llnReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double llnEvaluator::getDerivs(double x  , double d_x)
  {
    // Function total deriv
    double d_lln;
    // Silence unused argument warnings
    (void) x;
    d_lln = llnReturn_.deriv_WRT_x*d_x;
    return(d_lln);
  }
  // method that actually performs our computations.
  llnEvaluator::returnType llnEvaluator::evaluator_(double x)
  {
  // Function value and derivs variables, and a returnType to store everything
  double lln;
  llnEvaluator::returnType llnReturn;
  // Derivatives of return value w.r.t input vars
  double d_lln_d_x;
  // declared local variables
{
d_lln_d_x=(1.0/std::max( static_cast<double>(x), static_cast<double>(1.0e-38)))*((x>=1.0e-38)?1.0:0.0);
lln=log(std::max( static_cast<double>(x), static_cast<double>(1.0e-38)));
}
  // now save outputs and derivs into appropriate return vars
  llnReturn.value=lln;
  llnReturn.deriv_WRT_x = d_lln_d_x;
  return(llnReturn);
  }

// Derivative of Analog Function hypsmooth
double d_hypsmooth(double x , double c  , double d_x , double d_c )
{
// Function return variable and total deriv
double hypsmooth;
double d_hypsmooth;
// Derivatives of return value w.r.t input vars
double d_hypsmooth_d_x;
double d_hypsmooth_d_c;
{
d_hypsmooth_d_x=(0.5*(1.0+(0.5/sqrt(((x*x)+((4*c)*c))))*(x+x)));
d_hypsmooth_d_c=(0.5*(0.5/sqrt(((x*x)+((4*c)*c))))*((4*c)+c*(4)));
hypsmooth=(0.5*(x+sqrt(((x*x)+((4*c)*c)))));
}
d_hypsmooth = d_hypsmooth_d_x*d_x+d_hypsmooth_d_c*d_c;
return(d_hypsmooth);
}

// Evaluator class implementations for Analog Function hypsmooth
  // Constructor
  hypsmoothEvaluator::hypsmoothEvaluator(double x, double c)
  {
    hypsmoothReturn_ = evaluator_(x, c);
  }
  // method to get precomputed values into double vars 
  double hypsmoothEvaluator::getValues(double  x, double  c)
  {
    // Silence unused argument warnings
    (void) x;
    (void) c;
    // Copy all precomputed values into corresponding output
    return(hypsmoothReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double hypsmoothEvaluator::getDerivs(double x , double c  , double d_x, double d_c)
  {
    // Function total deriv
    double d_hypsmooth;
    // Silence unused argument warnings
    (void) x;
    (void) c;
    d_hypsmooth = hypsmoothReturn_.deriv_WRT_x*d_x+hypsmoothReturn_.deriv_WRT_c*d_c;
    return(d_hypsmooth);
  }
  // method that actually performs our computations.
  hypsmoothEvaluator::returnType hypsmoothEvaluator::evaluator_(double x, double c)
  {
  // Function value and derivs variables, and a returnType to store everything
  double hypsmooth;
  hypsmoothEvaluator::returnType hypsmoothReturn;
  // Derivatives of return value w.r.t input vars
  double d_hypsmooth_d_x;
  double d_hypsmooth_d_c;
  // declared local variables
{
d_hypsmooth_d_x=(0.5*(1.0+(0.5/sqrt(((x*x)+((4*c)*c))))*(x+x)));
d_hypsmooth_d_c=(0.5*(0.5/sqrt(((x*x)+((4*c)*c))))*((4*c)+c*(4)));
hypsmooth=(0.5*(x+sqrt(((x*x)+((4*c)*c)))));
}
  // now save outputs and derivs into appropriate return vars
  hypsmoothReturn.value=hypsmooth;
  hypsmoothReturn.deriv_WRT_x = d_hypsmooth_d_x;
  hypsmoothReturn.deriv_WRT_c = d_hypsmooth_d_c;
  return(hypsmoothReturn);
  }

// Derivative of Analog Function hypmax
double d_hypmax(double x , double xmin , double c  , double d_x , double d_xmin , double d_c )
{
// Function return variable and total deriv
double hypmax;
double d_hypmax;
// Derivatives of return value w.r.t input vars
double d_hypmax_d_x;
double d_hypmax_d_xmin;
double d_hypmax_d_c;
{
d_hypmax_d_x=(0.5*(1.0+(0.5/sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))*(((x-xmin)-c)+((x-xmin)-c))));
d_hypmax_d_xmin=(1.0+(0.5*((-1.0)+(0.5/sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))*(((((x-xmin)-c)*(-1.0))+((-1.0)*((x-xmin)-c)))-((4)*c)))));
d_hypmax_d_c=(0.5*((-1.0)+(0.5/sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))*(((((x-xmin)-c)*(-1.0))+((-1.0)*((x-xmin)-c)))-((4*xmin)))));
hypmax=(xmin+(0.5*(((x-xmin)-c)+sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))));
}
d_hypmax = d_hypmax_d_x*d_x+d_hypmax_d_xmin*d_xmin+d_hypmax_d_c*d_c;
return(d_hypmax);
}

// Evaluator class implementations for Analog Function hypmax
  // Constructor
  hypmaxEvaluator::hypmaxEvaluator(double x, double xmin, double c)
  {
    hypmaxReturn_ = evaluator_(x, xmin, c);
  }
  // method to get precomputed values into double vars 
  double hypmaxEvaluator::getValues(double  x, double  xmin, double  c)
  {
    // Silence unused argument warnings
    (void) x;
    (void) xmin;
    (void) c;
    // Copy all precomputed values into corresponding output
    return(hypmaxReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double hypmaxEvaluator::getDerivs(double x , double xmin , double c  , double d_x, double d_xmin, double d_c)
  {
    // Function total deriv
    double d_hypmax;
    // Silence unused argument warnings
    (void) x;
    (void) xmin;
    (void) c;
    d_hypmax = hypmaxReturn_.deriv_WRT_x*d_x+hypmaxReturn_.deriv_WRT_xmin*d_xmin+hypmaxReturn_.deriv_WRT_c*d_c;
    return(d_hypmax);
  }
  // method that actually performs our computations.
  hypmaxEvaluator::returnType hypmaxEvaluator::evaluator_(double x, double xmin, double c)
  {
  // Function value and derivs variables, and a returnType to store everything
  double hypmax;
  hypmaxEvaluator::returnType hypmaxReturn;
  // Derivatives of return value w.r.t input vars
  double d_hypmax_d_x;
  double d_hypmax_d_xmin;
  double d_hypmax_d_c;
  // declared local variables
{
d_hypmax_d_x=(0.5*(1.0+(0.5/sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))*(((x-xmin)-c)+((x-xmin)-c))));
d_hypmax_d_xmin=(1.0+(0.5*((-1.0)+(0.5/sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))*(((((x-xmin)-c)*(-1.0))+((-1.0)*((x-xmin)-c)))-((4)*c)))));
d_hypmax_d_c=(0.5*((-1.0)+(0.5/sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))*(((((x-xmin)-c)*(-1.0))+((-1.0)*((x-xmin)-c)))-((4*xmin)))));
hypmax=(xmin+(0.5*(((x-xmin)-c)+sqrt(((((x-xmin)-c)*((x-xmin)-c))-((4*xmin)*c))))));
}
  // now save outputs and derivs into appropriate return vars
  hypmaxReturn.value=hypmax;
  hypmaxReturn.deriv_WRT_x = d_hypmax_d_x;
  hypmaxReturn.deriv_WRT_xmin = d_hypmax_d_xmin;
  hypmaxReturn.deriv_WRT_c = d_hypmax_d_c;
  return(hypmaxReturn);
  }

} // namepace AnalogFunctions
JacobianStamp Instance::jacStamp;
IdVector Instance::nodeMap;
PairMap Instance::pairToJacStampMap;


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_d;
    const int Instance::admsNodeID_g;
    const int Instance::admsNodeID_s;
    const int Instance::admsNodeID_e;
    const int Instance::admsNodeID_di;
    const int Instance::admsNodeID_si;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSbsimcmg::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSbsimcmg::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(30*1.0e-9), &ADMSbsimcmg::Instance::L)
    .setDescription("Designed Gate Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("D", static_cast<double>(40*1.0e-9), &ADMSbsimcmg::Instance::D)
    .setDescription("Diameter of the cylinder (GEOMOD=3)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TFIN", static_cast<double>(15*1.0e-9), &ADMSbsimcmg::Instance::TFIN)
    .setDescription("Body (Fin) thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FPITCH", static_cast<double>(80*1.0e-9), &ADMSbsimcmg::Instance::FPITCH)
    .setDescription("Fin pitch")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFIN", static_cast<double>(1.0), &ADMSbsimcmg::Instance::NFIN)
    .setDescription("Number of fins per finger (real number enables optimization)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsimcmg::Instance::NGCON)
    .setDescription("number of gate contact (1 or 2 sided)");
  p.addPar("ASEO", static_cast<double>(0), &ADMSbsimcmg::Instance::ASEO)
    .setDescription("Source to substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ADEO", static_cast<double>(0), &ADMSbsimcmg::Instance::ADEO)
    .setDescription("Drain to substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSEO", static_cast<double>(0), &ADMSbsimcmg::Instance::PSEO)
    .setDescription("Perimeter of source to substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDEO", static_cast<double>(0), &ADMSbsimcmg::Instance::PDEO)
    .setDescription("Perimeter of drain to substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ASEJ", static_cast<double>(0), &ADMSbsimcmg::Instance::ASEJ)
    .setDescription("Source junction area (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ADEJ", static_cast<double>(0), &ADMSbsimcmg::Instance::ADEJ)
    .setDescription("Drain junction area (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSEJ", static_cast<double>(0), &ADMSbsimcmg::Instance::PSEJ)
    .setDescription("Source to substrate PN junction perimeter (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDEJ", static_cast<double>(0), &ADMSbsimcmg::Instance::PDEJ)
    .setDescription("Drain to substrate PN junction perimeter (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVS", static_cast<double>(0), &ADMSbsimcmg::Instance::COVS)
    .setDescription("Constant g/s overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVD", 0.0, &ADMSbsimcmg::Instance::COVD)
    .setDescription("Constant g/d overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGSP", static_cast<double>(0.0), &ADMSbsimcmg::Instance::CGSP)
    .setDescription("Constant gate-to-source fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGDP", static_cast<double>(0.0), &ADMSbsimcmg::Instance::CGDP)
    .setDescription("Constant gate-to-drain fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSP", static_cast<double>(0.0), &ADMSbsimcmg::Instance::CDSP)
    .setDescription("Constant drain-to-source fringe capacitance (All CGEOMOD)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRS", static_cast<double>(0.0), &ADMSbsimcmg::Instance::NRS)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRD", static_cast<double>(0.0), &ADMSbsimcmg::Instance::NRD)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRSD", 0.0, &ADMSbsimcmg::Instance::LRSD)
    .setDescription("Length of the source/drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTRAND", static_cast<double>(0), &ADMSbsimcmg::Instance::DELVTRAND)
    .setDescription("Variability in Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0MULT", static_cast<double>(1), &ADMSbsimcmg::Instance::U0MULT)
    .setDescription("Variability in carrier mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;


}

void Traits::loadModelParameters(ParametricData<ADMSbsimcmg::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSbsimcmg::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("L", static_cast<double>(30*1.0e-9), &ADMSbsimcmg::Model::L)
    .setDescription("Designed Gate Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("D", static_cast<double>(40*1.0e-9), &ADMSbsimcmg::Model::D)
    .setDescription("Diameter of the cylinder (GEOMOD=3)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TFIN", static_cast<double>(15*1.0e-9), &ADMSbsimcmg::Model::TFIN)
    .setDescription("Body (Fin) thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FPITCH", static_cast<double>(80*1.0e-9), &ADMSbsimcmg::Model::FPITCH)
    .setDescription("Fin pitch")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NF", static_cast<int>(1), &ADMSbsimcmg::Model::NF)
    .setDescription("Number of fingers");
  p.addPar("NFIN", static_cast<double>(1.0), &ADMSbsimcmg::Model::NFIN)
    .setDescription("Number of fins per finger (real number enables optimization)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGCON", static_cast<int>(1), &ADMSbsimcmg::Model::NGCON)
    .setDescription("number of gate contact (1 or 2 sided)");
  p.addPar("ASEO", static_cast<double>(0), &ADMSbsimcmg::Model::ASEO)
    .setDescription("Source to substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ADEO", static_cast<double>(0), &ADMSbsimcmg::Model::ADEO)
    .setDescription("Drain to substrate overlap area through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSEO", static_cast<double>(0), &ADMSbsimcmg::Model::PSEO)
    .setDescription("Perimeter of source to substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDEO", static_cast<double>(0), &ADMSbsimcmg::Model::PDEO)
    .setDescription("Perimeter of drain to substrate overlap region through oxide")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ASEJ", static_cast<double>(0), &ADMSbsimcmg::Model::ASEJ)
    .setDescription("Source junction area (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ADEJ", static_cast<double>(0), &ADMSbsimcmg::Model::ADEJ)
    .setDescription("Drain junction area (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSEJ", static_cast<double>(0), &ADMSbsimcmg::Model::PSEJ)
    .setDescription("Source to substrate PN junction perimeter (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDEJ", static_cast<double>(0), &ADMSbsimcmg::Model::PDEJ)
    .setDescription("Drain to substrate PN junction perimeter (BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVS", static_cast<double>(0), &ADMSbsimcmg::Model::COVS)
    .setDescription("Constant g/s overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVD", 0.0, &ADMSbsimcmg::Model::COVD)
    .setDescription("Constant g/d overlap capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGSP", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGSP)
    .setDescription("Constant gate-to-source fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGDP", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGDP)
    .setDescription("Constant gate-to-drain fringe capacitance (CGEOMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSP", static_cast<double>(0.0), &ADMSbsimcmg::Model::CDSP)
    .setDescription("Constant drain-to-source fringe capacitance (All CGEOMOD)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRS", static_cast<double>(0.0), &ADMSbsimcmg::Model::NRS)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRD", static_cast<double>(0.0), &ADMSbsimcmg::Model::NRD)
    .setDescription("Number of source diffusion squares")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRSD", 0.0, &ADMSbsimcmg::Model::LRSD)
    .setDescription("Length of the source/drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XL", static_cast<double>(0), &ADMSbsimcmg::Model::XL)
    .setDescription("L offset for channel length due to mask/etch effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DTEMP", static_cast<double>(0), &ADMSbsimcmg::Model::DTEMP)
    .setDescription("Variability in Device Temperature	")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTRAND", static_cast<double>(0), &ADMSbsimcmg::Model::DELVTRAND)
    .setDescription("Variability in Vth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0MULT", static_cast<double>(1), &ADMSbsimcmg::Model::U0MULT)
    .setDescription("Variability in carrier mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDS0MULT", static_cast<double>(1), &ADMSbsimcmg::Model::IDS0MULT)
    .setDescription("Variability in Drain current for misc. reasons	")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DEVTYPE", static_cast<int>(1), &ADMSbsimcmg::Model::DEVTYPE);
  p.addPar("BULKMOD", static_cast<int>(0), &ADMSbsimcmg::Model::BULKMOD)
    .setDescription("Bulk model");
  p.addPar("COREMOD", static_cast<int>(0), &ADMSbsimcmg::Model::COREMOD)
    .setDescription("Surface potential algorithm");
  p.addPar("GEOMOD", static_cast<int>(1), &ADMSbsimcmg::Model::GEOMOD)
    .setDescription("Geometry mode selector");
  p.addPar("CGEO1SW", static_cast<int>(0), &ADMSbsimcmg::Model::CGEO1SW);
  p.addPar("RDSMOD", static_cast<int>(0), &ADMSbsimcmg::Model::RDSMOD)
    .setDescription("Resistance model selector");
  p.addPar("ASYMMOD", static_cast<int>(0), &ADMSbsimcmg::Model::ASYMMOD)
    .setDescription("Asymmetric model selector");
  p.addPar("IGCMOD", static_cast<int>(0), &ADMSbsimcmg::Model::IGCMOD)
    .setDescription("model selector for Igc, Igs, and Igd");
  p.addPar("IGBMOD", static_cast<int>(0), &ADMSbsimcmg::Model::IGBMOD)
    .setDescription("model selector for Igb");
  p.addPar("GIDLMOD", static_cast<int>(0), &ADMSbsimcmg::Model::GIDLMOD)
    .setDescription("GIDL/GISL current switcher");
  p.addPar("IIMOD", static_cast<int>(0), &ADMSbsimcmg::Model::IIMOD)
    .setDescription("Impact ionization model switch");
  p.addPar("NQSMOD", static_cast<int>(0), &ADMSbsimcmg::Model::NQSMOD);
  p.addPar("SHMOD", static_cast<int>(0), &ADMSbsimcmg::Model::SHMOD)
    .setDescription("Self heating and T node switcher --- NOT USED IN XYCE");
  p.addPar("RGATEMOD", static_cast<int>(0), &ADMSbsimcmg::Model::RGATEMOD)
    .setDescription("Gate electrode resistor and ge node switcher --- NOT USED IN XYCE");
  p.addPar("RGEOMOD", static_cast<int>(0), &ADMSbsimcmg::Model::RGEOMOD)
    .setDescription("Bias independent parasitic resistance model selector");
  p.addPar("CGEOMOD", static_cast<int>(0), &ADMSbsimcmg::Model::CGEOMOD)
    .setDescription("parasitic capacitance model selector");
  p.addPar("CAPMOD", static_cast<int>(0), &ADMSbsimcmg::Model::CAPMOD)
    .setDescription("Accumulation region capacitance model selector");
  p.addPar("LINT", static_cast<double>(0), &ADMSbsimcmg::Model::LINT)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LL", static_cast<double>(0), &ADMSbsimcmg::Model::LL)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLN", static_cast<double>(1), &ADMSbsimcmg::Model::LLN)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLC", static_cast<double>(0), &ADMSbsimcmg::Model::DLC)
    .setDescription("Delta L for C-V model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLCACC", static_cast<double>(0), &ADMSbsimcmg::Model::DLCACC)
    .setDescription("Delta L for C-V model in accumulation region (CAPMOD=1, BULKMOD=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLBIN", static_cast<double>(0), &ADMSbsimcmg::Model::DLBIN)
    .setDescription("Delta L for Binning")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLC", static_cast<double>(0), &ADMSbsimcmg::Model::LLC)
    .setDescription("Length reduction parameter (dopant diffusion effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EOT", static_cast<double>(1.0*1.0e-9), &ADMSbsimcmg::Model::EOT)
    .setDescription("equivalent oxide thickness in meters")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXP", static_cast<double>(1.2*1.0e-9), &ADMSbsimcmg::Model::TOXP)
    .setDescription("physical oxide thickness in meters")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EOTBOX", static_cast<double>(140*1.0e-9), &ADMSbsimcmg::Model::EOTBOX)
    .setDescription("equivalent oxide thickness of the buried oxide (SOI FinFET) or STI (bulk FinFET) in meters")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("HFIN", static_cast<double>(30*1.0e-9), &ADMSbsimcmg::Model::HFIN)
    .setDescription("Fin height in meters")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FECH", static_cast<double>(1), &ADMSbsimcmg::Model::FECH)
    .setDescription("End-channel factor, for different orientation/shape")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTAW", static_cast<double>(0), &ADMSbsimcmg::Model::DELTAW)
    .setDescription("change of effective width due to shape of fin/cylinder")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FECHCV", static_cast<double>(1), &ADMSbsimcmg::Model::FECHCV)
    .setDescription("CV end-channel factor, for different orientaion/shape")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTAWCV", static_cast<double>(0), &ADMSbsimcmg::Model::DELTAWCV)
    .setDescription("CV change of effective width due to shape of fin/cylinder")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBODY", static_cast<double>(1e22), &ADMSbsimcmg::Model::NBODY)
    .setDescription("channel (body) doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBODYN1", static_cast<double>(0), &ADMSbsimcmg::Model::NBODYN1)
    .setDescription("NFIN dependence of channel (body) doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBODYN2", static_cast<double>(1.0e5), &ADMSbsimcmg::Model::NBODYN2)
    .setDescription("NFIN dependence of channel (body) doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSD", static_cast<double>(2e26), &ADMSbsimcmg::Model::NSD)
    .setDescription("Source/drain active doping concentration in m-3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIG", static_cast<double>(4.61), &ADMSbsimcmg::Model::PHIG)
    .setDescription("Gate workfunction, eV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGL", static_cast<double>(0), &ADMSbsimcmg::Model::PHIGL)
    .setDescription("Length dependence of Gate workfunction, eV/m")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGN1", static_cast<double>(0), &ADMSbsimcmg::Model::PHIGN1)
    .setDescription("NFIN dependence of Gate workfunction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGN2", static_cast<double>(1.0e5), &ADMSbsimcmg::Model::PHIGN2)
    .setDescription("NFIN dependence of Gate workfunction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSROX", static_cast<double>(3.9), &ADMSbsimcmg::Model::EPSROX)
    .setDescription("Relative dielectric constant of the gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSRSUB", static_cast<double>(11.9), &ADMSbsimcmg::Model::EPSRSUB)
    .setDescription("Relative dielectric constant of the channel material")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EASUB", static_cast<double>(4.05), &ADMSbsimcmg::Model::EASUB)
    .setDescription("Electron affinity of substrate, eV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NI0SUB", static_cast<double>(1.1e16), &ADMSbsimcmg::Model::NI0SUB)
    .setDescription("Intrinsic carrier constant at 300.15K, m-3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BG0SUB", static_cast<double>(1.12), &ADMSbsimcmg::Model::BG0SUB)
    .setDescription("Band gap of substrate at 300.15K, eV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NC0SUB", static_cast<double>(2.86e25), &ADMSbsimcmg::Model::NC0SUB)
    .setDescription("Conduction band density of states, m-3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGATE", static_cast<double>(0.0), &ADMSbsimcmg::Model::NGATE)
    .setDescription("Parameter for Poly Gate Doping, for metal gate please set NGATE = 0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IMIN", static_cast<double>(1.0E-15), &ADMSbsimcmg::Model::Imin)
    .setDescription("Parameter for Vgs Clamping for inversion region calc. in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIT", static_cast<double>(0.0), &ADMSbsimcmg::Model::CIT)
    .setDescription("parameter for interface trap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSC", static_cast<double>(7e-3), &ADMSbsimcmg::Model::CDSC)
    .setDescription("coupling capacitance between S/D and channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCN1", static_cast<double>(0), &ADMSbsimcmg::Model::CDSCN1)
    .setDescription("NFIN dependence of CDSC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCN2", static_cast<double>(1.0e5), &ADMSbsimcmg::Model::CDSCN2)
    .setDescription("NFIN dependence of CDSC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCD", static_cast<double>(7e-3), &ADMSbsimcmg::Model::CDSCD)
    .setDescription("drain-bias sensitivity of CDSC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDN1", static_cast<double>(0), &ADMSbsimcmg::Model::CDSCDN1)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDN2", static_cast<double>(1.0e5), &ADMSbsimcmg::Model::CDSCDN2)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDR", 0.0, &ADMSbsimcmg::Model::CDSCDR)
    .setDescription("Reverse-mode drain-bais sensitivity of CDSC (Experimental)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDRN1", 0.0, &ADMSbsimcmg::Model::CDSCDRN1)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CDSCDRN2", 0.0, &ADMSbsimcmg::Model::CDSCDRN2)
    .setDescription("NFIN dependence of CDSCD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVT0", static_cast<double>(0.0), &ADMSbsimcmg::Model::DVT0)
    .setDescription("SCE coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVT1", static_cast<double>(0.60), &ADMSbsimcmg::Model::DVT1)
    .setDescription("SCE exponent coefficient, after binning should be in (0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVT1SS", 0.0, &ADMSbsimcmg::Model::DVT1SS)
    .setDescription("Subthreshold Swing exponent coefficient, after binning should be in (0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIN", static_cast<double>(0.05), &ADMSbsimcmg::Model::PHIN)
    .setDescription("Nonuniform vertical doping effect on surface potential, V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETA0", static_cast<double>(0.60), &ADMSbsimcmg::Model::ETA0)
    .setDescription("DIBL coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETA0N1", static_cast<double>(0), &ADMSbsimcmg::Model::ETA0N1)
    .setDescription("NFIN dependence of ETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETA0N2", static_cast<double>(1.0e5), &ADMSbsimcmg::Model::ETA0N2)
    .setDescription("NFIN dependence of ETA0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TETA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::TETA0)
    .setDescription("Temperature dependence of DIBL coefficient, 1/K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETA0R", 0.0, &ADMSbsimcmg::Model::ETA0R)
    .setDescription("Reverse-mode DIBL coefficient (Experimental)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TETA0R", 0.0, &ADMSbsimcmg::Model::TETA0R)
    .setDescription("Temperature dependence of Reverse-mode DIBL coefficient, 1/K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DSUB", static_cast<double>(1.06), &ADMSbsimcmg::Model::DSUB)
    .setDescription("DIBL exponent coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP0", static_cast<double>(0), &ADMSbsimcmg::Model::DVTP0)
    .setDescription("Coefficient for Drain-Induced Vth Shift (DITS)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTP1", static_cast<double>(0), &ADMSbsimcmg::Model::DVTP1)
    .setDescription("DITS exponent coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1RSCE", static_cast<double>(0.0), &ADMSbsimcmg::Model::K1RSCE)
    .setDescription("K1 for reverse short channel effect calculation ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPE0", static_cast<double>(5.0*1.0e-9), &ADMSbsimcmg::Model::LPE0)
    .setDescription("Equivalent length of pocket region at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVTSHIFT", static_cast<double>(0), &ADMSbsimcmg::Model::DVTSHIFT)
    .setDescription("Vth shift handle")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K0", static_cast<double>(0.0), &ADMSbsimcmg::Model::K0)
    .setDescription("Lateral NUD voltage parameter, V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K01", static_cast<double>(0.0), &ADMSbsimcmg::Model::K01)
    .setDescription("Temperature dependence of lateral NUD voltage parameter, V/K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K0SI", static_cast<double>(1.0), &ADMSbsimcmg::Model::K0SI)
    .setDescription("Correction factor for strong inversion, used in Mnud, after binnig should be from (0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K0SI1", static_cast<double>(0.0), &ADMSbsimcmg::Model::K0SI1)
    .setDescription("Temperature dependence of K0SI, 1/K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1SI", 0.0, &ADMSbsimcmg::Model::K1SI)
    .setDescription("Correction factor for strong inversion, used in Mob")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1SI1", 0.0, &ADMSbsimcmg::Model::K1SI1)
    .setDescription("Temperature dependence of K1SI, 1/K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIBE", static_cast<double>(0.7), &ADMSbsimcmg::Model::PHIBE)
    .setDescription("Body effect voltage parameter, V, after binnig should be from [0.2:1.2]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1", static_cast<double>(0.0), &ADMSbsimcmg::Model::K1)
    .setDescription("Body effect coefficient for sub-threshold region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K11", static_cast<double>(0.0), &ADMSbsimcmg::Model::K11)
    .setDescription("Temperature dependence of K1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1SAT", static_cast<double>(0.0), &ADMSbsimcmg::Model::K1SAT)
    .setDescription("Correction factor for K1 in saturation (high Vds)		")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("K1SAT1", static_cast<double>(0.0), &ADMSbsimcmg::Model::K1SAT1)
    .setDescription("Temperature dependence of K1SAT1	")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg::Model::QMFACTOR)
    .setDescription("Prefactor + switch for QM Vth correction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QMTCENIV", static_cast<double>(0.0), &ADMSbsimcmg::Model::QMTCENIV)
    .setDescription("Prefactor + switch for QM Width correction for IV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg::Model::QMTCENCV)
    .setDescription("Prefactor + switch for QM Width and Toxeff correction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg::Model::QMTCENCVA)
    .setDescription("Prefactor + switch for QM Width and Toxeff correction for CV (accumulation region)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AQMTCEN", static_cast<double>(0.0), &ADMSbsimcmg::Model::AQMTCEN)
    .setDescription("Parameter for Geometric dependence of Tcen on R/TFIN/HFIN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BQMTCEN", static_cast<double>(12.0e-9), &ADMSbsimcmg::Model::BQMTCEN)
    .setDescription("Parameter for Geometric dependence of Tcen on R/TFIN/HFIN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETAQM", static_cast<double>(0.54), &ADMSbsimcmg::Model::ETAQM)
    .setDescription("Bulk charge coefficient for Tcen")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QM0", static_cast<double>(1.00e-3), &ADMSbsimcmg::Model::QM0)
    .setDescription("Knee-Point for Tcen in inversion (Charge normalized to Cox)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PQM", static_cast<double>(0.66), &ADMSbsimcmg::Model::PQM)
    .setDescription("Slope of normalized Tcen in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QM0ACC", static_cast<double>(1.00e-3), &ADMSbsimcmg::Model::QM0ACC)
    .setDescription("Knee-Point for Tcen in accumulation (Charge normalized to Cox)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PQMACC", static_cast<double>(0.66), &ADMSbsimcmg::Model::PQMACC)
    .setDescription("Slope of normalized Tcen in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT", static_cast<double>(85000), &ADMSbsimcmg::Model::VSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATN1", static_cast<double>(0), &ADMSbsimcmg::Model::VSATN1)
    .setDescription("NFIN dependence of VSAT ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATN2", static_cast<double>(1.0e5), &ADMSbsimcmg::Model::VSATN2)
    .setDescription("NFIN dependence of VSAT ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AVSAT", static_cast<double>(0.0), &ADMSbsimcmg::Model::AVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BVSAT", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT1", 0.0, &ADMSbsimcmg::Model::VSAT1)
    .setDescription("Velocity Saturation parameter for I_on degradation - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT1N1", 0.0, &ADMSbsimcmg::Model::VSAT1N1)
    .setDescription("NFIN dependence of VSAT1 ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT1N2", 0.0, &ADMSbsimcmg::Model::VSAT1N2)
    .setDescription("NFIN dependence of VSAT1 ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT1R", 0.0, &ADMSbsimcmg::Model::VSAT1R)
    .setDescription("Velocity Saturation parameter for I_on degradation - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT1RN1", 0.0, &ADMSbsimcmg::Model::VSAT1RN1)
    .setDescription("NFIN dependence of VSAT1R ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSAT1RN2", 0.0, &ADMSbsimcmg::Model::VSAT1RN2)
    .setDescription("NFIN dependence of VSAT1R ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AVSAT1", 0.0, &ADMSbsimcmg::Model::AVSAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BVSAT1", 0.0, &ADMSbsimcmg::Model::BVSAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTAVSAT", static_cast<double>(1.0), &ADMSbsimcmg::Model::DELTAVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSAT", static_cast<double>(2.0), &ADMSbsimcmg::Model::PSAT)
    .setDescription("Velocity saturation exponent, after binnig should be from [2.0:inf)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("APSAT", static_cast<double>(0.0), &ADMSbsimcmg::Model::APSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BPSAT", static_cast<double>(1.0), &ADMSbsimcmg::Model::BPSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KSATIV", static_cast<double>(1.0), &ADMSbsimcmg::Model::KSATIV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSATCV", 0.0, &ADMSbsimcmg::Model::VSATCV)
    .setDescription("Velocity Saturation parameter for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AVSATCV", 0.0, &ADMSbsimcmg::Model::AVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BVSATCV", 0.0, &ADMSbsimcmg::Model::BVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTAVSATCV", 0.0, &ADMSbsimcmg::Model::DELTAVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSATCV", 0.0, &ADMSbsimcmg::Model::PSATCV)
    .setDescription("Velocity saturation exponent for C-V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("APSATCV", 0.0, &ADMSbsimcmg::Model::APSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BPSATCV", 0.0, &ADMSbsimcmg::Model::BPSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEXP", static_cast<double>(4.0), &ADMSbsimcmg::Model::MEXP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AMEXP", static_cast<double>(0.0), &ADMSbsimcmg::Model::AMEXP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BMEXP", static_cast<double>(1.0), &ADMSbsimcmg::Model::BMEXP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEXPR", 0.0, &ADMSbsimcmg::Model::MEXPR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AMEXPR", 0.0, &ADMSbsimcmg::Model::AMEXPR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BMEXPR", 0.0, &ADMSbsimcmg::Model::BMEXPR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::PTWG)
    .setDescription("Gmsat degradation parameter - forward mode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGR", 0.0, &ADMSbsimcmg::Model::PTWGR)
    .setDescription("Gmsat degradation parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("APTWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::APTWG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BPTWG", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BPTWG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AT", static_cast<double>((-1.56e-3)), &ADMSbsimcmg::Model::AT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TMEXP", static_cast<double>(0.0), &ADMSbsimcmg::Model::TMEXP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TMEXPR", 0.0, &ADMSbsimcmg::Model::TMEXPR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTWGT", static_cast<double>(0.004), &ADMSbsimcmg::Model::PTWGT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0", static_cast<double>(0.03), &ADMSbsimcmg::Model::U0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0N1", static_cast<double>(0), &ADMSbsimcmg::Model::U0N1)
    .setDescription("NFIN dependence of U0 ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("U0N2", static_cast<double>(1.0e5), &ADMSbsimcmg::Model::U0N2)
    .setDescription("NFIN dependence of U0 ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ETAMOB", static_cast<double>(2.0), &ADMSbsimcmg::Model::ETAMOB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UP", static_cast<double>(0), &ADMSbsimcmg::Model::UP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPA", static_cast<double>(1.0), &ADMSbsimcmg::Model::LPA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UA", static_cast<double>(0.3), &ADMSbsimcmg::Model::UA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AUA", static_cast<double>(0.0), &ADMSbsimcmg::Model::AUA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BUA", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BUA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UC", static_cast<double>(0.0), &ADMSbsimcmg::Model::UC)
    .setDescription("Body effect for mobility degradation parameter - BULKMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EU", static_cast<double>(2.5), &ADMSbsimcmg::Model::EU)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AEU", static_cast<double>(0.0), &ADMSbsimcmg::Model::AEU)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BEU", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BEU)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UD", static_cast<double>(0.0), &ADMSbsimcmg::Model::UD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AUD", static_cast<double>(0.0), &ADMSbsimcmg::Model::AUD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BUD", static_cast<double>(50.0e-9), &ADMSbsimcmg::Model::BUD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCS", static_cast<double>(1.0), &ADMSbsimcmg::Model::UCS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UTE", static_cast<double>(0.0), &ADMSbsimcmg::Model::UTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UTL", static_cast<double>((-1.5e-3)), &ADMSbsimcmg::Model::UTL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EMOBT", static_cast<double>(0.0), &ADMSbsimcmg::Model::EMOBT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UA1", static_cast<double>(1.032e-3), &ADMSbsimcmg::Model::UA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UC1", static_cast<double>(0.056e-9), &ADMSbsimcmg::Model::UC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UD1", static_cast<double>(0.0), &ADMSbsimcmg::Model::UD1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UCSTE", static_cast<double>((-4.775e-3)), &ADMSbsimcmg::Model::UCSTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CHARGEWF", static_cast<double>(0), &ADMSbsimcmg::Model::CHARGEWF)
    .setDescription("Average Channel Charge Weighting Factor, +1:source-side, 0:middle, -1:drain-side  ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDSWMIN", static_cast<double>(0.0), &ADMSbsimcmg::Model::RDSWMIN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDSW", static_cast<double>(100.0), &ADMSbsimcmg::Model::RDSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ARDSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::ARDSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BRDSW", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BRDSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSWMIN", static_cast<double>(0.0), &ADMSbsimcmg::Model::RSWMIN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW", static_cast<double>(50.0), &ADMSbsimcmg::Model::RSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ARSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::ARSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BRSW", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BRSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDWMIN", static_cast<double>(0.0), &ADMSbsimcmg::Model::RDWMIN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDW", static_cast<double>(50.0), &ADMSbsimcmg::Model::RDW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ARDW", static_cast<double>(0.0), &ADMSbsimcmg::Model::ARDW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BRDW", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BRDW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSDR", static_cast<double>(0.0), &ADMSbsimcmg::Model::RSDR)
    .setDescription("Source side drift resistance parameter - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSDRR", 0.0, &ADMSbsimcmg::Model::RSDRR)
    .setDescription("Source side drift resistance parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDDR", 0.0, &ADMSbsimcmg::Model::RDDR)
    .setDescription("Drain side drift resistance parameter - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDDRR", 0.0, &ADMSbsimcmg::Model::RDDRR)
    .setDescription("Drain side drift resistance parameter - reverse mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRSDR", static_cast<double>(1.0), &ADMSbsimcmg::Model::PRSDR)
    .setDescription("Source side quasi-saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRDDR", 0.0, &ADMSbsimcmg::Model::PRDDR)
    .setDescription("Drain side quasi-saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRWGS", static_cast<double>(0.0), &ADMSbsimcmg::Model::PRWGS)
    .setUnit(U_VOLTM1)
    .setDescription("Gate bias dependence of source extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRWGD", 0.0, &ADMSbsimcmg::Model::PRWGD)
    .setUnit(U_VOLTM1)
    .setDescription("Gate bias dependence of drain extension resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WR", static_cast<double>(1.0), &ADMSbsimcmg::Model::WR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRT", static_cast<double>(0.001), &ADMSbsimcmg::Model::PRT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TRSDR", static_cast<double>(0.0), &ADMSbsimcmg::Model::TRSDR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TRDDR", 0.0, &ADMSbsimcmg::Model::TRDDR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBL1", static_cast<double>(1.30), &ADMSbsimcmg::Model::PDIBL1)
    .setDescription("DIBL Output Conductance parameter - forward mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBL1R", 0.0, &ADMSbsimcmg::Model::PDIBL1R)
    .setDescription("DIBL Output Conductance parameter - reverse mode ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDIBL2", static_cast<double>(2.0e-4), &ADMSbsimcmg::Model::PDIBL2)
    .setDescription("DIBL Output Conductance parameter ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DROUT", static_cast<double>(1.06), &ADMSbsimcmg::Model::DROUT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVAG", static_cast<double>(1.0), &ADMSbsimcmg::Model::PVAG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLM", static_cast<double>(0.013), &ADMSbsimcmg::Model::PCLM)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("APCLM", static_cast<double>(0.0), &ADMSbsimcmg::Model::APCLM)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BPCLM", static_cast<double>(100.0e-9), &ADMSbsimcmg::Model::BPCLM)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMG", static_cast<double>(0.0), &ADMSbsimcmg::Model::PCLMG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCLMCV", 0.0, &ADMSbsimcmg::Model::PCLMCV)
    .setDescription("CLM parameter for Short Channel CV ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1", static_cast<double>(0.0), &ADMSbsimcmg::Model::A1)
    .setDescription("Non-saturation effect parameter for strong inversion region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A11", static_cast<double>(0.0), &ADMSbsimcmg::Model::A11)
    .setDescription("Temperature dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A2", static_cast<double>(0.0), &ADMSbsimcmg::Model::A2)
    .setDescription("Non-saturation effect parameter for moderate inversion region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A21", static_cast<double>(0.0), &ADMSbsimcmg::Model::A21)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGEXT", static_cast<double>(0.0), &ADMSbsimcmg::Model::RGEXT)
    .setDescription("Effective gate electrode external resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGFIN", static_cast<double>(1.0e-3), &ADMSbsimcmg::Model::RGFIN)
    .setDescription("Effective gate electrode per finger per fin resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSHS", static_cast<double>(0.0), &ADMSbsimcmg::Model::RSHS)
    .setDescription("Source-side sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSHD", 0.0, &ADMSbsimcmg::Model::RSHD)
    .setDescription("Drain-side sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("HEPI", static_cast<double>(10.0*1.0e-9), &ADMSbsimcmg::Model::HEPI)
    .setDescription("Height of the raised source/drain on top of the fin")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TSILI", static_cast<double>(10.0*1.0e-9), &ADMSbsimcmg::Model::TSILI)
    .setDescription("Thickness of the silicide on top of the raised source/drain")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RHOC", static_cast<double>(1.0e-12), &ADMSbsimcmg::Model::RHOC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RHORSD", static_cast<double>(1.0), &ADMSbsimcmg::Model::RHORSD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CRATIO", static_cast<double>(0.5), &ADMSbsimcmg::Model::CRATIO)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTAPRSD", static_cast<double>(0.0), &ADMSbsimcmg::Model::DELTAPRSD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SDTERM", static_cast<int>(0), &ADMSbsimcmg::Model::SDTERM);
  p.addPar("LSP", 0.0, &ADMSbsimcmg::Model::LSP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSRSP", static_cast<double>(3.9), &ADMSbsimcmg::Model::EPSRSP)
    .setDescription("Relative dielectric constant of the spacer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TGATE", static_cast<double>(30.0*1.0e-9), &ADMSbsimcmg::Model::TGATE)
    .setDescription("Gate height on top of the hard mask")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TMASK", static_cast<double>(30.0*1.0e-9), &ADMSbsimcmg::Model::TMASK)
    .setDescription("Height of hard mask on top of the fin")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ASILIEND", static_cast<double>(0.0), &ADMSbsimcmg::Model::ASILIEND)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ARSDEND", static_cast<double>(0.0), &ADMSbsimcmg::Model::ARSDEND)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRSDEND", static_cast<double>(0.0), &ADMSbsimcmg::Model::PRSDEND)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSDE", static_cast<double>(2e25), &ADMSbsimcmg::Model::NSDE)
    .setDescription("Source/drain active doping concentration at Leff edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGEOA", static_cast<double>(1.0), &ADMSbsimcmg::Model::RGEOA)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGEOB", static_cast<double>(0.0), &ADMSbsimcmg::Model::RGEOB)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGEOC", static_cast<double>(0.0), &ADMSbsimcmg::Model::RGEOC)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGEOD", static_cast<double>(0.0), &ADMSbsimcmg::Model::RGEOD)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGEOE", static_cast<double>(0.0), &ADMSbsimcmg::Model::RGEOE)
    .setDescription("Fitting parameter for RGEOMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGEOA", static_cast<double>(1.0), &ADMSbsimcmg::Model::CGEOA)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGEOB", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGEOB)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGEOC", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGEOC)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGEOD", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGEOD)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGEOE", static_cast<double>(1.0), &ADMSbsimcmg::Model::CGEOE)
    .setDescription("Fitting parameter for CGEOMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGBINV", static_cast<double>(1.11e-2), &ADMSbsimcmg::Model::AIGBINV)
    .setDescription("parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGBINV1", static_cast<double>(0), &ADMSbsimcmg::Model::AIGBINV1)
    .setDescription("parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGBINV", static_cast<double>(9.49e-4), &ADMSbsimcmg::Model::BIGBINV)
    .setDescription("parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGBINV", static_cast<double>(6.00e-3), &ADMSbsimcmg::Model::CIGBINV)
    .setDescription("parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EIGBINV", static_cast<double>(1.1), &ADMSbsimcmg::Model::EIGBINV)
    .setDescription("parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIGBINV", static_cast<double>(3.0), &ADMSbsimcmg::Model::NIGBINV)
    .setDescription("parameter for Igb in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGBACC", static_cast<double>(1.36e-2), &ADMSbsimcmg::Model::AIGBACC)
    .setDescription("parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGBACC1", static_cast<double>(0), &ADMSbsimcmg::Model::AIGBACC1)
    .setDescription("parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGBACC", static_cast<double>(1.71e-3), &ADMSbsimcmg::Model::BIGBACC)
    .setDescription("parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGBACC", static_cast<double>(7.5e-2), &ADMSbsimcmg::Model::CIGBACC)
    .setDescription("parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIGBACC", static_cast<double>(1.0), &ADMSbsimcmg::Model::NIGBACC)
    .setDescription("parameter for Igb in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGC", static_cast<double>(1.36e-2), &ADMSbsimcmg::Model::AIGC)
    .setDescription("parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGC1", static_cast<double>(0), &ADMSbsimcmg::Model::AIGC1)
    .setDescription("parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGC", static_cast<double>(1.71e-3), &ADMSbsimcmg::Model::BIGC)
    .setDescription("parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGC", static_cast<double>(0.075), &ADMSbsimcmg::Model::CIGC)
    .setDescription("parameter for Igc in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PIGCD", static_cast<double>(1.0), &ADMSbsimcmg::Model::PIGCD)
    .setDescription("parameter for Igc partition")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLCIGS", static_cast<double>(0), &ADMSbsimcmg::Model::DLCIGS)
    .setDescription("Delta L for Igs model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGS", static_cast<double>(1.36e-2), &ADMSbsimcmg::Model::AIGS)
    .setDescription("parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGS1", static_cast<double>(0), &ADMSbsimcmg::Model::AIGS1)
    .setDescription("parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGS", static_cast<double>(1.71e-3), &ADMSbsimcmg::Model::BIGS)
    .setDescription("parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGS", static_cast<double>(0.075), &ADMSbsimcmg::Model::CIGS)
    .setDescription("parameter for Igs in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLCIGD", 0.0, &ADMSbsimcmg::Model::DLCIGD)
    .setDescription("Delta L for Igd model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGD", 0.0, &ADMSbsimcmg::Model::AIGD)
    .setDescription("parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGD1", 0.0, &ADMSbsimcmg::Model::AIGD1)
    .setDescription("parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGD", 0.0, &ADMSbsimcmg::Model::BIGD)
    .setDescription("parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIGD", 0.0, &ADMSbsimcmg::Model::CIGD)
    .setDescription("parameter for Igd in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXREF", static_cast<double>(1.2*1.0e-9), &ADMSbsimcmg::Model::TOXREF)
    .setDescription("Target tox value [m]")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXG", 0.0, &ADMSbsimcmg::Model::TOXG)
    .setUnit(U_METER)
    .setDescription("oxide thickness for gate current model in meters, Introduced in BSIM-CMG106.1.0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTOX", static_cast<double>(1.0), &ADMSbsimcmg::Model::NTOX)
    .setDescription("Exponent for Tox ratio")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POXEDGE", static_cast<double>(1.0), &ADMSbsimcmg::Model::POXEDGE)
    .setDescription("Factor for the gate edge Tox")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGISL", static_cast<double>(6.055*1.0e-12), &ADMSbsimcmg::Model::AGISL)
    .setDescription("pre-exponential coeff. for GISL in mho")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGISL", static_cast<double>(0.3e9), &ADMSbsimcmg::Model::BGISL)
    .setUnit(U_VMM1)
    .setDescription("exponential coeff. for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGISL", static_cast<double>(0.5), &ADMSbsimcmg::Model::CGISL)
    .setUnit(U_VOLT3)
    .setDescription("parameter for body-effect of GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EGISL", static_cast<double>(0.2), &ADMSbsimcmg::Model::EGISL)
    .setUnit(U_VOLT)
    .setDescription("band bending parameter for GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGISL", static_cast<double>(1.0), &ADMSbsimcmg::Model::PGISL)
    .setDescription("parameter for body-bias effect on GISL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDL", 0.0, &ADMSbsimcmg::Model::AGIDL)
    .setDescription("pre-exponential coeff. for GIDL in mho")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDL", 0.0, &ADMSbsimcmg::Model::BGIDL)
    .setUnit(U_VMM1)
    .setDescription("exponential coeff. for GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDL", 0.0, &ADMSbsimcmg::Model::CGIDL)
    .setUnit(U_VOLT3)
    .setDescription("parameter for body-effect of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EGIDL", 0.0, &ADMSbsimcmg::Model::EGIDL)
    .setUnit(U_VOLT)
    .setDescription("band bending parameter for GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGIDL", 0.0, &ADMSbsimcmg::Model::PGIDL)
    .setDescription("parameter for body-bias effect on GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHA0)
    .setUnit(U_MVM1)
    .setDescription("first parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA01", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHA01)
    .setDescription("Temperature dependence of ALPHA0, m/V/degrees")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA1", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHA1)
    .setUnit(U_VOLTM1)
    .setDescription("L scaling parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA11", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHA11)
    .setDescription("Temperature dependence ALPHA1, 1/V/degree")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::BETA0)
    .setUnit(U_VOLTM1)
    .setDescription("Vds dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHAII0)
    .setDescription("first parameter of Iii for IIMOD=2, m/V												")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAII01", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHAII01)
    .setDescription("Temperature dependence of ALPHAII0, m/V/degrees")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHAII1)
    .setUnit(U_VOLTM1)
    .setDescription("L scaling parameter of Iii for IIMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAII11", static_cast<double>(0.0), &ADMSbsimcmg::Model::ALPHAII11)
    .setDescription("Temperature dependence of ALPHAII1, 1/V/degrees")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::BETAII0)
    .setUnit(U_VOLTM1)
    .setDescription("Vds dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::BETAII1)
    .setDescription("Vds dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETAII2", static_cast<double>(0.1), &ADMSbsimcmg::Model::BETAII2)
    .setDescription("Vds dependent parameter of Iii, V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ESATII", static_cast<double>(1.0e7), &ADMSbsimcmg::Model::ESATII)
    .setUnit(U_VMM1)
    .setDescription("Saturation channel E-Field for Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LII", static_cast<double>(0.5E-9), &ADMSbsimcmg::Model::LII)
    .setUnit(U_VM)
    .setDescription("Channel length dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SII0", static_cast<double>(0.5), &ADMSbsimcmg::Model::SII0)
    .setUnit(U_VOLTM1)
    .setDescription("Vgs dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SII1", static_cast<double>(0.1), &ADMSbsimcmg::Model::SII1)
    .setUnit(U_VOLTM1)
    .setDescription("1st Vgs dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SII2", static_cast<double>(0.0), &ADMSbsimcmg::Model::SII2)
    .setDescription("2nd Vgs dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SIID", static_cast<double>(0.0), &ADMSbsimcmg::Model::SIID)
    .setUnit(U_VOLTM1)
    .setDescription("3rd Vds dependent parameter of Iii")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EOTACC", 0.0, &ADMSbsimcmg::Model::EOTACC)
    .setUnit(U_METER)
    .setDescription("equivalent oxide thickness for accumulation region in meters")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVFBACC", static_cast<double>(0.0), &ADMSbsimcmg::Model::DELVFBACC)
    .setDescription("Change in Flatband Voltage; Vfb_accumulation-Vfb_inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFS", static_cast<double>(2.5e-11), &ADMSbsimcmg::Model::CFS)
    .setDescription("Outer Fringe Cap (source side)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFD", 0.0, &ADMSbsimcmg::Model::CFD)
    .setDescription("Outer Fringe Cap (drain side)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGSO", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGSO)
    .setDescription("Non LDD region source-gate overlap capacitance per unit channel width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGDO", 0.0, &ADMSbsimcmg::Model::CGDO)
    .setDescription("Non LDD region drain-gate overlap capacitance per unit channel width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGSL", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGSL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGDL", 0.0, &ADMSbsimcmg::Model::CGDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CKAPPAS", static_cast<double>(0.6), &ADMSbsimcmg::Model::CKAPPAS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CKAPPAD", 0.0, &ADMSbsimcmg::Model::CKAPPAD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBO", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGBO)
    .setDescription("Gate to substrate overlap cap per unit channel length per finger per NGCON	")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBN", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGBN)
    .setDescription("Gate to substrate overlap cap per unit channel length per fin per finger")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBL", static_cast<double>(0.0), &ADMSbsimcmg::Model::CGBL)
    .setDescription("Bias dependent component of Gate to substrate overlap cap ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CKAPPAB", static_cast<double>(0.6), &ADMSbsimcmg::Model::CKAPPAB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSDESW", static_cast<double>(0.0), &ADMSbsimcmg::Model::CSDESW)
    .setDescription("Coefficient for source/drain to substrate sidewall cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJS", static_cast<double>(5.0e-4), &ADMSbsimcmg::Model::CJS)
    .setDescription("Unit area source-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJD", 0.0, &ADMSbsimcmg::Model::CJD)
    .setDescription("Unit area drain-side junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWS", static_cast<double>(5.0e-10), &ADMSbsimcmg::Model::CJSWS)
    .setDescription("Unit length source-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWD", 0.0, &ADMSbsimcmg::Model::CJSWD)
    .setDescription("Unit length drain-side sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWGS", static_cast<double>(0.0), &ADMSbsimcmg::Model::CJSWGS)
    .setDescription("Unit length source-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJSWGD", 0.0, &ADMSbsimcmg::Model::CJSWGD)
    .setDescription("Unit length drain-side gate sidewall junction capacitance at zero bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBS", static_cast<double>(1.0), &ADMSbsimcmg::Model::PBS)
    .setDescription("Source-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBD", 0.0, &ADMSbsimcmg::Model::PBD)
    .setDescription("Drain-side bulk junction built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWS", static_cast<double>(1.0), &ADMSbsimcmg::Model::PBSWS)
    .setDescription("Built-in potential for Source-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWD", 0.0, &ADMSbsimcmg::Model::PBSWD)
    .setDescription("Built-in potential for Drain-side sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWGS", 0.0, &ADMSbsimcmg::Model::PBSWGS)
    .setDescription("Built-in potential for Source-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBSWGD", 0.0, &ADMSbsimcmg::Model::PBSWGD)
    .setDescription("Built-in potential for Drain-side gate sidewall junction capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJS", static_cast<double>(0.5), &ADMSbsimcmg::Model::MJS)
    .setDescription("Source bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJD", 0.0, &ADMSbsimcmg::Model::MJD)
    .setDescription("Drain bottom junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWS", static_cast<double>(0.33), &ADMSbsimcmg::Model::MJSWS)
    .setDescription("Source sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWD", 0.0, &ADMSbsimcmg::Model::MJSWD)
    .setDescription("Drain sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWGS", 0.0, &ADMSbsimcmg::Model::MJSWGS)
    .setDescription("Source-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWGD", 0.0, &ADMSbsimcmg::Model::MJSWGD)
    .setDescription("Drain-side gate sidewall junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SJS", static_cast<double>(0.0), &ADMSbsimcmg::Model::SJS)
    .setDescription("Constant for source-side two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SJD", 0.0, &ADMSbsimcmg::Model::SJD)
    .setDescription("Constant for drain-side two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SJSWS", static_cast<double>(0.0), &ADMSbsimcmg::Model::SJSWS)
    .setDescription("Constant for source-side sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SJSWD", 0.0, &ADMSbsimcmg::Model::SJSWD)
    .setDescription("Constant for drain-side sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SJSWGS", static_cast<double>(0.0), &ADMSbsimcmg::Model::SJSWGS)
    .setDescription("Constant for source-side gate sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SJSWGD", 0.0, &ADMSbsimcmg::Model::SJSWGD)
    .setDescription("Constant for source-side gate sidewall two-step second junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJS2", static_cast<double>(0.125), &ADMSbsimcmg::Model::MJS2)
    .setDescription("Source bottom two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJD2", 0.0, &ADMSbsimcmg::Model::MJD2)
    .setDescription("Drain bottom two-step second junction capacitance grading coefficient		")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWS2", static_cast<double>(0.083), &ADMSbsimcmg::Model::MJSWS2)
    .setDescription("Source sidewall two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWD2", 0.0, &ADMSbsimcmg::Model::MJSWD2)
    .setDescription("Drain sidewall two-step second junction capacitance grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWGS2", 0.0, &ADMSbsimcmg::Model::MJSWGS2)
    .setDescription("Source-side gate sidewall two-step")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MJSWGD2", 0.0, &ADMSbsimcmg::Model::MJSWGD2)
    .setDescription("Drain-side gate sidewall two-step")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSS", static_cast<double>(1.0e-4), &ADMSbsimcmg::Model::JSS)
    .setDescription("Bottom source junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSD", 0.0, &ADMSbsimcmg::Model::JSD)
    .setDescription("Bottom drain junction reverse saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWS", static_cast<double>(0.0), &ADMSbsimcmg::Model::JSWS)
    .setDescription("Unit length reverse saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWD", 0.0, &ADMSbsimcmg::Model::JSWD)
    .setDescription("Unit length reverse saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWGS", static_cast<double>(0.0), &ADMSbsimcmg::Model::JSWGS)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JSWGD", 0.0, &ADMSbsimcmg::Model::JSWGD)
    .setDescription("Unit length reverse saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJS", static_cast<double>(1.0), &ADMSbsimcmg::Model::NJS)
    .setDescription("Source junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJD", 0.0, &ADMSbsimcmg::Model::NJD)
    .setDescription("Drain junction emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHSFWD", static_cast<double>(0.1), &ADMSbsimcmg::Model::IJTHSFWD)
    .setDescription("Forward source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHDFWD", 0.0, &ADMSbsimcmg::Model::IJTHDFWD)
    .setDescription("Forward drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHSREV", static_cast<double>(0.1), &ADMSbsimcmg::Model::IJTHSREV)
    .setDescription("Reverse source diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJTHDREV", 0.0, &ADMSbsimcmg::Model::IJTHDREV)
    .setDescription("Reverse drain diode breakdown limiting current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BVS", static_cast<double>(10.0), &ADMSbsimcmg::Model::BVS)
    .setDescription("Source diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BVD", 0.0, &ADMSbsimcmg::Model::BVD)
    .setDescription("Drain diode breakdown voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJBVS", static_cast<double>(1.0), &ADMSbsimcmg::Model::XJBVS)
    .setDescription("Fitting parameter for source diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJBVD", 0.0, &ADMSbsimcmg::Model::XJBVD)
    .setDescription("Fitting parameter for drain diode breakdown current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSS", static_cast<double>(0.0), &ADMSbsimcmg::Model::JTSS)
    .setDescription("Bottom source junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSD", 0.0, &ADMSbsimcmg::Model::JTSD)
    .setDescription("Bottom drain junction trap-assisted saturation current density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWS", static_cast<double>(0.0), &ADMSbsimcmg::Model::JTSSWS)
    .setDescription("Unit length trap-assisted saturation current for sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWD", 0.0, &ADMSbsimcmg::Model::JTSSWD)
    .setDescription("Unit length trap-assisted saturation current for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWGS", static_cast<double>(0.0), &ADMSbsimcmg::Model::JTSSWGS)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTSSWGD", 0.0, &ADMSbsimcmg::Model::JTSSWGD)
    .setDescription("Unit length trap-assisted saturation current for gate-edge sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JTWEFF", static_cast<double>(0.0), &ADMSbsimcmg::Model::JTWEFF)
    .setDescription("Trap assisted tunneling current width dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTS", static_cast<double>(20.0), &ADMSbsimcmg::Model::NJTS)
    .setDescription("Non-ideality factor for JTSS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSD", 0.0, &ADMSbsimcmg::Model::NJTSD)
    .setDescription("Non-ideality factor for JTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSW", static_cast<double>(20.0), &ADMSbsimcmg::Model::NJTSSW)
    .setDescription("Non-ideality factor for JTSSWS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSWD", 0.0, &ADMSbsimcmg::Model::NJTSSWD)
    .setDescription("Non-ideality factor for JTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSWG", static_cast<double>(20.0), &ADMSbsimcmg::Model::NJTSSWG)
    .setDescription("Non-ideality factor for JTSSWGS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJTSSWGD", 0.0, &ADMSbsimcmg::Model::NJTSSWGD)
    .setDescription("Non-ideality factor for JTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSS", static_cast<double>(10.0), &ADMSbsimcmg::Model::VTSS)
    .setDescription("Bottom source junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSD", 0.0, &ADMSbsimcmg::Model::VTSD)
    .setDescription("Bottom drain junction trap-assisted current voltage dependent parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWS", static_cast<double>(10.0), &ADMSbsimcmg::Model::VTSSWS)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall source junction ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWD", 0.0, &ADMSbsimcmg::Model::VTSSWD)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for sidewall drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWGS", static_cast<double>(10.0), &ADMSbsimcmg::Model::VTSSWGS)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTSSWGD", 0.0, &ADMSbsimcmg::Model::VTSSWGD)
    .setDescription("Unit length trap-assisted current voltage dependent parameter for gate-edge sidewall drain junction ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LINTIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::LINTIGEN)
    .setDescription("Lint for Thermal Generation Current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTGEN", static_cast<double>(1.0), &ADMSbsimcmg::Model::NTGEN)
    .setDescription("Thermal Generation Current Parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::AIGEN)
    .setDescription("Thermal Generation Current Parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::BIGEN)
    .setDescription("Thermal Generation Current Parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XRCRG1", static_cast<double>(12.0), &ADMSbsimcmg::Model::XRCRG1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XRCRG2", static_cast<double>(1.0), &ADMSbsimcmg::Model::XRCRG2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSEG", static_cast<int>(4), &ADMSbsimcmg::Model::NSEG)
    .setDescription("Number of segments for NQSMOD=3 (3,5 and 10 supported)");
  p.addPar("EF", static_cast<double>(1.0), &ADMSbsimcmg::Model::EF)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EM", static_cast<double>(4.1e7), &ADMSbsimcmg::Model::EM)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOIA", static_cast<double>(6.250e+39), &ADMSbsimcmg::Model::NOIA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOIB", static_cast<double>(3.125e+24), &ADMSbsimcmg::Model::NOIB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOIC", static_cast<double>(8.750e+07), &ADMSbsimcmg::Model::NOIC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTNOI", static_cast<double>(1.0), &ADMSbsimcmg::Model::NTNOI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSbsimcmg::Model::TNOM)
    .setDescription("Temperature at which the model is extracted (degrees)")
   .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBGASUB", static_cast<double>(7.02e-4), &ADMSbsimcmg::Model::TBGASUB)
    .setDescription("Bandgap Temperature Coefficient (eV / degrees)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBGBSUB", static_cast<double>(1108.0), &ADMSbsimcmg::Model::TBGBSUB)
    .setDescription("Bandgap Temperature Coefficient (degrees)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1", static_cast<double>(0.0), &ADMSbsimcmg::Model::KT1)
    .setDescription("Vth Temperature Coefficient (V)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT1L", static_cast<double>(0.0), &ADMSbsimcmg::Model::KT1L)
    .setDescription("Vth Temperature L Coefficient (m-V)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TSS", static_cast<double>(0.0), &ADMSbsimcmg::Model::TSS)
    .setDescription("SSwing Temperature Coefficient (/ degrees)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IIT", static_cast<double>((-0.5)), &ADMSbsimcmg::Model::IIT)
    .setDescription("Impact Ionization Temperature Dependence, IIMOD=1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TII", static_cast<double>(0.0), &ADMSbsimcmg::Model::TII)
    .setDescription("Impact Ionization Temperature Dependence, IIMOD=2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TGIDL", static_cast<double>((-0.003)), &ADMSbsimcmg::Model::TGIDL)
    .setDescription("GIDL/GISL Temperature Dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGT", static_cast<double>(2.5), &ADMSbsimcmg::Model::IGT)
    .setDescription("Gate Current Temperature Dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TCJ", static_cast<double>(0.0), &ADMSbsimcmg::Model::TCJ)
    .setDescription("Temperature coefficient for CJS/CJD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TCJSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::TCJSW)
    .setDescription("Temperature coefficient for CJSWS/CJSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TCJSWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::TCJSWG)
    .setDescription("Temperature coefficient for CJSWGS/CJSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TPB", static_cast<double>(0.0), &ADMSbsimcmg::Model::TPB)
    .setDescription("Temperature coefficient for PBS/PBD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TPBSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::TPBSW)
    .setDescription("Temperature coefficient for PBSWS/PBSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TPBSWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::TPBSWG)
    .setDescription("Temperature coefficient for PBSWGS/PBSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTIS", static_cast<double>(3.0), &ADMSbsimcmg::Model::XTIS)
    .setDescription("Source junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTID", 0.0, &ADMSbsimcmg::Model::XTID)
    .setDescription("Drain junction current temperature exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSS", static_cast<double>(0.02), &ADMSbsimcmg::Model::XTSS)
    .setDescription("Power dependence of JTSS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSD", 0.0, &ADMSbsimcmg::Model::XTSD)
    .setDescription("Power dependence of JTSD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWS", static_cast<double>(0.02), &ADMSbsimcmg::Model::XTSSWS)
    .setDescription("Power dependence of JTSSWS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWD", 0.0, &ADMSbsimcmg::Model::XTSSWD)
    .setDescription("Power dependence of JTSSWD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWGS", static_cast<double>(0.02), &ADMSbsimcmg::Model::XTSSWGS)
    .setDescription("Power dependence of JTSSWGS on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTSSWGD", 0.0, &ADMSbsimcmg::Model::XTSSWGD)
    .setDescription("Power dependence of JTSSWGD on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTS", static_cast<double>(0.0), &ADMSbsimcmg::Model::TNJTS)
    .setDescription("Temperature coefficient for NJTS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSD", 0.0, &ADMSbsimcmg::Model::TNJTSD)
    .setDescription("Temperature coefficient for NJTSD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::TNJTSSW)
    .setDescription("Temperature coefficient for NJTSSW")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSWD", 0.0, &ADMSbsimcmg::Model::TNJTSSWD)
    .setDescription("NTemperature coefficient for NJTSSWD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::TNJTSSWG)
    .setDescription("Temperature coefficient for NJTSSWG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNJTSSWGD", 0.0, &ADMSbsimcmg::Model::TNJTSSWGD)
    .setDescription("Temperature coefficient for NJTSSWGD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTH0", static_cast<double>(0.01), &ADMSbsimcmg::Model::RTH0)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTH0", static_cast<double>(1.0E-05), &ADMSbsimcmg::Model::CTH0)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WTH0", static_cast<double>(0.0), &ADMSbsimcmg::Model::WTH0)
    .setDescription("Width dependence coefficient for Rth and Cth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMIN", static_cast<double>(0), &ADMSbsimcmg::Model::LMIN)
    .setDescription("Minimum length for which this model should be used.")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMAX", static_cast<double>(100), &ADMSbsimcmg::Model::LMAX)
    .setDescription("Maximum length for which this model should be used.")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFINMIN", static_cast<double>(0), &ADMSbsimcmg::Model::NFINMIN)
    .setDescription("Minimum NFIN for which this model should be used.")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFINMAX", static_cast<double>(100), &ADMSbsimcmg::Model::NFINMAX)
    .setDescription("Maximum NFIN for which this model should be used.")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNBODY", static_cast<double>(0), &ADMSbsimcmg::Model::LNBODY)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NNBODY", static_cast<double>(0), &ADMSbsimcmg::Model::NNBODY)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNBODY", static_cast<double>(0), &ADMSbsimcmg::Model::PNBODY)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPHIG", static_cast<double>(0), &ADMSbsimcmg::Model::LPHIG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPHIG", static_cast<double>(0), &ADMSbsimcmg::Model::NPHIG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPHIG", static_cast<double>(0), &ADMSbsimcmg::Model::PPHIG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNGATE", static_cast<double>(0), &ADMSbsimcmg::Model::LNGATE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NNGATE", static_cast<double>(0), &ADMSbsimcmg::Model::NNGATE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNGATE", static_cast<double>(0), &ADMSbsimcmg::Model::PNGATE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIT", static_cast<double>(0), &ADMSbsimcmg::Model::LCIT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCIT", static_cast<double>(0), &ADMSbsimcmg::Model::NCIT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIT", static_cast<double>(0), &ADMSbsimcmg::Model::PCIT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCDSC", static_cast<double>(0), &ADMSbsimcmg::Model::LCDSC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCDSC", static_cast<double>(0), &ADMSbsimcmg::Model::NCDSC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCDSC", static_cast<double>(0), &ADMSbsimcmg::Model::PCDSC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCDSCD", static_cast<double>(0), &ADMSbsimcmg::Model::LCDSCD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCDSCD", static_cast<double>(0), &ADMSbsimcmg::Model::NCDSCD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCDSCD", static_cast<double>(0), &ADMSbsimcmg::Model::PCDSCD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCDSCDR", 0.0, &ADMSbsimcmg::Model::LCDSCDR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCDSCDR", 0.0, &ADMSbsimcmg::Model::NCDSCDR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCDSCDR", 0.0, &ADMSbsimcmg::Model::PCDSCDR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVT0", static_cast<double>(0), &ADMSbsimcmg::Model::LDVT0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDVT0", static_cast<double>(0), &ADMSbsimcmg::Model::NDVT0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVT0", static_cast<double>(0), &ADMSbsimcmg::Model::PDVT0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVT1", static_cast<double>(0), &ADMSbsimcmg::Model::LDVT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDVT1", static_cast<double>(0), &ADMSbsimcmg::Model::NDVT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVT1", static_cast<double>(0), &ADMSbsimcmg::Model::PDVT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVT1SS", static_cast<double>(0), &ADMSbsimcmg::Model::LDVT1SS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDVT1SS", static_cast<double>(0), &ADMSbsimcmg::Model::NDVT1SS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVT1SS", static_cast<double>(0), &ADMSbsimcmg::Model::PDVT1SS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPHIN", static_cast<double>(0), &ADMSbsimcmg::Model::LPHIN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPHIN", static_cast<double>(0), &ADMSbsimcmg::Model::NPHIN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPHIN", static_cast<double>(0), &ADMSbsimcmg::Model::PPHIN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LETA0", static_cast<double>(0), &ADMSbsimcmg::Model::LETA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NETA0", static_cast<double>(0), &ADMSbsimcmg::Model::NETA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PETA0", static_cast<double>(0), &ADMSbsimcmg::Model::PETA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LETA0R", 0.0, &ADMSbsimcmg::Model::LETA0R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NETA0R", 0.0, &ADMSbsimcmg::Model::NETA0R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PETA0R", 0.0, &ADMSbsimcmg::Model::PETA0R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDSUB", static_cast<double>(0), &ADMSbsimcmg::Model::LDSUB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDSUB", static_cast<double>(0), &ADMSbsimcmg::Model::NDSUB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDSUB", static_cast<double>(0), &ADMSbsimcmg::Model::PDSUB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK1RSCE", static_cast<double>(0), &ADMSbsimcmg::Model::LK1RSCE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK1RSCE", static_cast<double>(0), &ADMSbsimcmg::Model::NK1RSCE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK1RSCE", static_cast<double>(0), &ADMSbsimcmg::Model::PK1RSCE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLPE0", static_cast<double>(0), &ADMSbsimcmg::Model::LLPE0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NLPE0", static_cast<double>(0), &ADMSbsimcmg::Model::NLPE0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLPE0", static_cast<double>(0), &ADMSbsimcmg::Model::PLPE0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTSHIFT", static_cast<double>(0), &ADMSbsimcmg::Model::LDVTSHIFT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDVTSHIFT", static_cast<double>(0), &ADMSbsimcmg::Model::NDVTSHIFT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTSHIFT", static_cast<double>(0), &ADMSbsimcmg::Model::PDVTSHIFT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPHIBE", static_cast<double>(0), &ADMSbsimcmg::Model::LPHIBE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPHIBE", static_cast<double>(0), &ADMSbsimcmg::Model::NPHIBE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPHIBE", static_cast<double>(0), &ADMSbsimcmg::Model::PPHIBE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK0", static_cast<double>(0), &ADMSbsimcmg::Model::LK0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK0", static_cast<double>(0), &ADMSbsimcmg::Model::NK0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK0", static_cast<double>(0), &ADMSbsimcmg::Model::PK0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK01", static_cast<double>(0), &ADMSbsimcmg::Model::LK01)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK01", static_cast<double>(0), &ADMSbsimcmg::Model::NK01)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK01", static_cast<double>(0), &ADMSbsimcmg::Model::PK01)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK0SI", static_cast<double>(0), &ADMSbsimcmg::Model::LK0SI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK0SI", static_cast<double>(0), &ADMSbsimcmg::Model::NK0SI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK0SI", static_cast<double>(0), &ADMSbsimcmg::Model::PK0SI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK0SI1", static_cast<double>(0), &ADMSbsimcmg::Model::LK0SI1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK0SI1", static_cast<double>(0), &ADMSbsimcmg::Model::NK0SI1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK0SI1", static_cast<double>(0), &ADMSbsimcmg::Model::PK0SI1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK1SI", static_cast<double>(0), &ADMSbsimcmg::Model::LK1SI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK1SI", static_cast<double>(0), &ADMSbsimcmg::Model::NK1SI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK1SI", static_cast<double>(0), &ADMSbsimcmg::Model::PK1SI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK1SI1", static_cast<double>(0), &ADMSbsimcmg::Model::LK1SI1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK1SI1", static_cast<double>(0), &ADMSbsimcmg::Model::NK1SI1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK1SI1", static_cast<double>(0), &ADMSbsimcmg::Model::PK1SI1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK1", static_cast<double>(0), &ADMSbsimcmg::Model::LK1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK1", static_cast<double>(0), &ADMSbsimcmg::Model::NK1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK1", static_cast<double>(0), &ADMSbsimcmg::Model::PK1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK11", static_cast<double>(0), &ADMSbsimcmg::Model::LK11)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK11", static_cast<double>(0), &ADMSbsimcmg::Model::NK11)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK11", static_cast<double>(0), &ADMSbsimcmg::Model::PK11)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK1SAT", static_cast<double>(0), &ADMSbsimcmg::Model::LK1SAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK1SAT", static_cast<double>(0), &ADMSbsimcmg::Model::NK1SAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK1SAT", static_cast<double>(0), &ADMSbsimcmg::Model::PK1SAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LK1SAT1", static_cast<double>(0), &ADMSbsimcmg::Model::LK1SAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NK1SAT1", static_cast<double>(0), &ADMSbsimcmg::Model::NK1SAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PK1SAT1", static_cast<double>(0), &ADMSbsimcmg::Model::PK1SAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDVTB", static_cast<double>(0), &ADMSbsimcmg::Model::LDVTB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDVTB", static_cast<double>(0), &ADMSbsimcmg::Model::NDVTB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDVTB", static_cast<double>(0), &ADMSbsimcmg::Model::PDVTB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLPEB", static_cast<double>(0), &ADMSbsimcmg::Model::LLPEB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NLPEB", static_cast<double>(0), &ADMSbsimcmg::Model::NLPEB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLPEB", static_cast<double>(0), &ADMSbsimcmg::Model::PLPEB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LQMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg::Model::LQMFACTOR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NQMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg::Model::NQMFACTOR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PQMFACTOR", static_cast<double>(0.0), &ADMSbsimcmg::Model::PQMFACTOR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LQMTCENIV", static_cast<double>(0.0), &ADMSbsimcmg::Model::LQMTCENIV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NQMTCENIV", static_cast<double>(0.0), &ADMSbsimcmg::Model::NQMTCENIV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PQMTCENIV", static_cast<double>(0.0), &ADMSbsimcmg::Model::PQMTCENIV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LQMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg::Model::LQMTCENCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NQMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg::Model::NQMTCENCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PQMTCENCV", static_cast<double>(0.0), &ADMSbsimcmg::Model::PQMTCENCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LQMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg::Model::LQMTCENCVA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NQMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg::Model::NQMTCENCVA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PQMTCENCVA", static_cast<double>(0.0), &ADMSbsimcmg::Model::PQMTCENCVA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVSAT", static_cast<double>(0), &ADMSbsimcmg::Model::LVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NVSAT", static_cast<double>(0), &ADMSbsimcmg::Model::NVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVSAT", static_cast<double>(0), &ADMSbsimcmg::Model::PVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVSAT1", 0.0, &ADMSbsimcmg::Model::LVSAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NVSAT1", 0.0, &ADMSbsimcmg::Model::NVSAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVSAT1", 0.0, &ADMSbsimcmg::Model::PVSAT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVSAT1R", 0.0, &ADMSbsimcmg::Model::LVSAT1R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NVSAT1R", 0.0, &ADMSbsimcmg::Model::NVSAT1R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVSAT1R", 0.0, &ADMSbsimcmg::Model::PVSAT1R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPSAT", static_cast<double>(0), &ADMSbsimcmg::Model::LPSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPSAT", static_cast<double>(0), &ADMSbsimcmg::Model::NPSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPSAT", static_cast<double>(0), &ADMSbsimcmg::Model::PPSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDELTAVSAT", static_cast<double>(0), &ADMSbsimcmg::Model::LDELTAVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDELTAVSAT", static_cast<double>(0), &ADMSbsimcmg::Model::NDELTAVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDELTAVSAT", static_cast<double>(0), &ADMSbsimcmg::Model::PDELTAVSAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKSATIV", static_cast<double>(0), &ADMSbsimcmg::Model::LKSATIV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NKSATIV", static_cast<double>(0), &ADMSbsimcmg::Model::NKSATIV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKSATIV", static_cast<double>(0), &ADMSbsimcmg::Model::PKSATIV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::LVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NVSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::NVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PVSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::PVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::LPSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::NPSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::PPSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDELTAVSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::LDELTAVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDELTAVSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::NDELTAVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDELTAVSATCV", static_cast<double>(0), &ADMSbsimcmg::Model::PDELTAVSATCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMEXP", static_cast<double>(0), &ADMSbsimcmg::Model::LMEXP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NMEXP", static_cast<double>(0), &ADMSbsimcmg::Model::NMEXP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PMEXP", static_cast<double>(0), &ADMSbsimcmg::Model::PMEXP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMEXPR", static_cast<double>(0), &ADMSbsimcmg::Model::LMEXPR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NMEXPR", static_cast<double>(0), &ADMSbsimcmg::Model::NMEXPR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PMEXPR", static_cast<double>(0), &ADMSbsimcmg::Model::PMEXPR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPTWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::LPTWG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPTWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::NPTWG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPTWG", static_cast<double>(0.0), &ADMSbsimcmg::Model::PPTWG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPTWGR", 0.0, &ADMSbsimcmg::Model::LPTWGR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPTWGR", 0.0, &ADMSbsimcmg::Model::NPTWGR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPTWGR", 0.0, &ADMSbsimcmg::Model::PPTWGR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LU0", static_cast<double>(0), &ADMSbsimcmg::Model::LU0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NU0", static_cast<double>(0), &ADMSbsimcmg::Model::NU0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PU0", static_cast<double>(0), &ADMSbsimcmg::Model::PU0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LETAMOB", static_cast<double>(0), &ADMSbsimcmg::Model::LETAMOB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NETAMOB", static_cast<double>(0), &ADMSbsimcmg::Model::NETAMOB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PETAMOB", static_cast<double>(0), &ADMSbsimcmg::Model::PETAMOB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUP", static_cast<double>(0), &ADMSbsimcmg::Model::LUP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUP", static_cast<double>(0), &ADMSbsimcmg::Model::NUP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUP", static_cast<double>(0), &ADMSbsimcmg::Model::PUP)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUA", static_cast<double>(0), &ADMSbsimcmg::Model::LUA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUA", static_cast<double>(0), &ADMSbsimcmg::Model::NUA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUA", static_cast<double>(0), &ADMSbsimcmg::Model::PUA)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUC", static_cast<double>(0), &ADMSbsimcmg::Model::LUC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUC", static_cast<double>(0), &ADMSbsimcmg::Model::NUC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUC", static_cast<double>(0), &ADMSbsimcmg::Model::PUC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEU", static_cast<double>(0), &ADMSbsimcmg::Model::LEU)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NEU", static_cast<double>(0), &ADMSbsimcmg::Model::NEU)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEU", static_cast<double>(0), &ADMSbsimcmg::Model::PEU)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUD", static_cast<double>(0), &ADMSbsimcmg::Model::LUD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUD", static_cast<double>(0), &ADMSbsimcmg::Model::NUD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUD", static_cast<double>(0), &ADMSbsimcmg::Model::PUD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUCS", static_cast<double>(0), &ADMSbsimcmg::Model::LUCS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUCS", static_cast<double>(0), &ADMSbsimcmg::Model::NUCS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUCS", static_cast<double>(0), &ADMSbsimcmg::Model::PUCS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCLM", static_cast<double>(0), &ADMSbsimcmg::Model::LPCLM)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPCLM", static_cast<double>(0), &ADMSbsimcmg::Model::NPCLM)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPCLM", static_cast<double>(0), &ADMSbsimcmg::Model::PPCLM)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCLMG", static_cast<double>(0), &ADMSbsimcmg::Model::LPCLMG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPCLMG", static_cast<double>(0), &ADMSbsimcmg::Model::NPCLMG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPCLMG", static_cast<double>(0), &ADMSbsimcmg::Model::PPCLMG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCLMCV", static_cast<double>(0), &ADMSbsimcmg::Model::LPCLMCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPCLMCV", static_cast<double>(0), &ADMSbsimcmg::Model::NPCLMCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPCLMCV", static_cast<double>(0), &ADMSbsimcmg::Model::PPCLMCV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA1", static_cast<double>(0), &ADMSbsimcmg::Model::LA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NA1", static_cast<double>(0), &ADMSbsimcmg::Model::NA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA1", static_cast<double>(0), &ADMSbsimcmg::Model::PA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA11", static_cast<double>(0), &ADMSbsimcmg::Model::LA11)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NA11", static_cast<double>(0), &ADMSbsimcmg::Model::NA11)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA11", static_cast<double>(0), &ADMSbsimcmg::Model::PA11)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA2", static_cast<double>(0), &ADMSbsimcmg::Model::LA2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NA2", static_cast<double>(0), &ADMSbsimcmg::Model::NA2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA2", static_cast<double>(0), &ADMSbsimcmg::Model::PA2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LA21", static_cast<double>(0), &ADMSbsimcmg::Model::LA21)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NA21", static_cast<double>(0), &ADMSbsimcmg::Model::NA21)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PA21", static_cast<double>(0), &ADMSbsimcmg::Model::PA21)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRDSW", static_cast<double>(0), &ADMSbsimcmg::Model::LRDSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRDSW", static_cast<double>(0), &ADMSbsimcmg::Model::NRDSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRDSW", static_cast<double>(0), &ADMSbsimcmg::Model::PRDSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::LRSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::NRSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRSW", static_cast<double>(0.0), &ADMSbsimcmg::Model::PRSW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LRDW", static_cast<double>(0.0), &ADMSbsimcmg::Model::LRDW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRDW", static_cast<double>(0.0), &ADMSbsimcmg::Model::NRDW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PRDW", static_cast<double>(0.0), &ADMSbsimcmg::Model::PRDW)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPRWGS", static_cast<double>(0), &ADMSbsimcmg::Model::LPRWGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPRWGS", static_cast<double>(0), &ADMSbsimcmg::Model::NPRWGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPRWGS", static_cast<double>(0), &ADMSbsimcmg::Model::PPRWGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPRWGD", static_cast<double>(0), &ADMSbsimcmg::Model::LPRWGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPRWGD", static_cast<double>(0), &ADMSbsimcmg::Model::NPRWGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPRWGD", static_cast<double>(0), &ADMSbsimcmg::Model::PPRWGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LWR", static_cast<double>(0), &ADMSbsimcmg::Model::LWR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NWR", static_cast<double>(0), &ADMSbsimcmg::Model::NWR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWR", static_cast<double>(0), &ADMSbsimcmg::Model::PWR)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDIBL1", static_cast<double>(0), &ADMSbsimcmg::Model::LPDIBL1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPDIBL1", static_cast<double>(0), &ADMSbsimcmg::Model::NPDIBL1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDIBL1", static_cast<double>(0), &ADMSbsimcmg::Model::PPDIBL1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDIBL1R", 0.0, &ADMSbsimcmg::Model::LPDIBL1R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPDIBL1R", 0.0, &ADMSbsimcmg::Model::NPDIBL1R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDIBL1R", 0.0, &ADMSbsimcmg::Model::PPDIBL1R)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPDIBL2", static_cast<double>(0), &ADMSbsimcmg::Model::LPDIBL2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPDIBL2", static_cast<double>(0), &ADMSbsimcmg::Model::NPDIBL2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPDIBL2", static_cast<double>(0), &ADMSbsimcmg::Model::PPDIBL2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LDROUT", static_cast<double>(0), &ADMSbsimcmg::Model::LDROUT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDROUT", static_cast<double>(0), &ADMSbsimcmg::Model::NDROUT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDROUT", static_cast<double>(0), &ADMSbsimcmg::Model::PDROUT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPVAG", static_cast<double>(0), &ADMSbsimcmg::Model::LPVAG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPVAG", static_cast<double>(0), &ADMSbsimcmg::Model::NPVAG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPVAG", static_cast<double>(0), &ADMSbsimcmg::Model::PPVAG)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGBINV1", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGBINV1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGBINV1", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGBINV1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGBINV1", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGBINV1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::LBIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::NBIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::PBIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::LCIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::NCIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::PCIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::LEIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NEIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::NEIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::PEIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::LNIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NNIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::NNIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNIGBINV", static_cast<double>(0), &ADMSbsimcmg::Model::PNIGBINV)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGBACC1", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGBACC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGBACC1", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGBACC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGBACC1", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGBACC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::LBIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::NBIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::PBIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::LCIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::NCIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::PCIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::LNIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NNIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::NNIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNIGBACC", static_cast<double>(0), &ADMSbsimcmg::Model::PNIGBACC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGC", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGC", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGC", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGC1", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGC1", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGC1", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGC", static_cast<double>(0), &ADMSbsimcmg::Model::LBIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBIGC", static_cast<double>(0), &ADMSbsimcmg::Model::NBIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGC", static_cast<double>(0), &ADMSbsimcmg::Model::PBIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGC", static_cast<double>(0), &ADMSbsimcmg::Model::LCIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCIGC", static_cast<double>(0), &ADMSbsimcmg::Model::NCIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGC", static_cast<double>(0), &ADMSbsimcmg::Model::PCIGC)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPIGCD", static_cast<double>(0), &ADMSbsimcmg::Model::LPIGCD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPIGCD", static_cast<double>(0), &ADMSbsimcmg::Model::NPIGCD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPIGCD", static_cast<double>(0), &ADMSbsimcmg::Model::PPIGCD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGS", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGS", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGS", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGS1", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGS1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGS1", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGS1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGS1", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGS1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGS", static_cast<double>(0), &ADMSbsimcmg::Model::LBIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBIGS", static_cast<double>(0), &ADMSbsimcmg::Model::NBIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGS", static_cast<double>(0), &ADMSbsimcmg::Model::PBIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGS", static_cast<double>(0), &ADMSbsimcmg::Model::LCIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCIGS", static_cast<double>(0), &ADMSbsimcmg::Model::NCIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGS", static_cast<double>(0), &ADMSbsimcmg::Model::PCIGS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGD", 0.0, &ADMSbsimcmg::Model::LAIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGD", 0.0, &ADMSbsimcmg::Model::NAIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGD", 0.0, &ADMSbsimcmg::Model::PAIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGD1", 0.0, &ADMSbsimcmg::Model::LAIGD1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGD1", 0.0, &ADMSbsimcmg::Model::NAIGD1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGD1", 0.0, &ADMSbsimcmg::Model::PAIGD1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGD", 0.0, &ADMSbsimcmg::Model::LBIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBIGD", 0.0, &ADMSbsimcmg::Model::NBIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGD", 0.0, &ADMSbsimcmg::Model::PBIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCIGD", 0.0, &ADMSbsimcmg::Model::LCIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCIGD", 0.0, &ADMSbsimcmg::Model::NCIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCIGD", 0.0, &ADMSbsimcmg::Model::PCIGD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNTOX", static_cast<double>(0), &ADMSbsimcmg::Model::LNTOX)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NNTOX", static_cast<double>(0), &ADMSbsimcmg::Model::NNTOX)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNTOX", static_cast<double>(0), &ADMSbsimcmg::Model::PNTOX)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPOXEDGE", static_cast<double>(0), &ADMSbsimcmg::Model::LPOXEDGE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPOXEDGE", static_cast<double>(0), &ADMSbsimcmg::Model::NPOXEDGE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPOXEDGE", static_cast<double>(0), &ADMSbsimcmg::Model::PPOXEDGE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAGISL", static_cast<double>(0), &ADMSbsimcmg::Model::LAGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAGISL", static_cast<double>(0), &ADMSbsimcmg::Model::NAGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAGISL", static_cast<double>(0), &ADMSbsimcmg::Model::PAGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBGISL", static_cast<double>(0), &ADMSbsimcmg::Model::LBGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBGISL", static_cast<double>(0), &ADMSbsimcmg::Model::NBGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBGISL", static_cast<double>(0), &ADMSbsimcmg::Model::PBGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGISL", static_cast<double>(0), &ADMSbsimcmg::Model::LCGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCGISL", static_cast<double>(0), &ADMSbsimcmg::Model::NCGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGISL", static_cast<double>(0), &ADMSbsimcmg::Model::PCGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEGISL", static_cast<double>(0), &ADMSbsimcmg::Model::LEGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NEGISL", static_cast<double>(0), &ADMSbsimcmg::Model::NEGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEGISL", static_cast<double>(0), &ADMSbsimcmg::Model::PEGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPGISL", static_cast<double>(0), &ADMSbsimcmg::Model::LPGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPGISL", static_cast<double>(0), &ADMSbsimcmg::Model::NPGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPGISL", static_cast<double>(0), &ADMSbsimcmg::Model::PPGISL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAGIDL", 0.0, &ADMSbsimcmg::Model::LAGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAGIDL", 0.0, &ADMSbsimcmg::Model::NAGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAGIDL", 0.0, &ADMSbsimcmg::Model::PAGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBGIDL", 0.0, &ADMSbsimcmg::Model::LBGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBGIDL", 0.0, &ADMSbsimcmg::Model::NBGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBGIDL", 0.0, &ADMSbsimcmg::Model::PBGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGIDL", 0.0, &ADMSbsimcmg::Model::LCGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCGIDL", 0.0, &ADMSbsimcmg::Model::NCGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGIDL", 0.0, &ADMSbsimcmg::Model::PCGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEGIDL", 0.0, &ADMSbsimcmg::Model::LEGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NEGIDL", 0.0, &ADMSbsimcmg::Model::NEGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEGIDL", 0.0, &ADMSbsimcmg::Model::PEGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPGIDL", 0.0, &ADMSbsimcmg::Model::LPGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPGIDL", 0.0, &ADMSbsimcmg::Model::NPGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPGIDL", 0.0, &ADMSbsimcmg::Model::PPGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LALPHA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::LALPHA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NALPHA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::NALPHA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PALPHA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::PALPHA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LALPHA1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LALPHA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NALPHA1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NALPHA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PALPHA1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PALPHA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::LALPHAII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::NALPHAII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PALPHAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::PALPHAII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LALPHAII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NALPHAII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PALPHAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PALPHAII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBETA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::LBETA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBETA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::NBETA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBETA0", static_cast<double>(0.0), &ADMSbsimcmg::Model::PBETA0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBETAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::LBETAII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBETAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::NBETAII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBETAII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::PBETAII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBETAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LBETAII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBETAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NBETAII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBETAII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PBETAII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBETAII2", static_cast<double>(0.0), &ADMSbsimcmg::Model::LBETAII2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBETAII2", static_cast<double>(0.0), &ADMSbsimcmg::Model::NBETAII2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBETAII2", static_cast<double>(0.0), &ADMSbsimcmg::Model::PBETAII2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LESATII", static_cast<double>(0.0), &ADMSbsimcmg::Model::LESATII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NESATII", static_cast<double>(0.0), &ADMSbsimcmg::Model::NESATII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PESATII", static_cast<double>(0.0), &ADMSbsimcmg::Model::PESATII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLII", static_cast<double>(0.0), &ADMSbsimcmg::Model::LLII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NLII", static_cast<double>(0.0), &ADMSbsimcmg::Model::NLII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLII", static_cast<double>(0.0), &ADMSbsimcmg::Model::PLII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::LSII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::NSII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSII0", static_cast<double>(0.0), &ADMSbsimcmg::Model::PSII0)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LSII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NSII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSII1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PSII1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSII2", static_cast<double>(0.0), &ADMSbsimcmg::Model::LSII2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSII2", static_cast<double>(0.0), &ADMSbsimcmg::Model::NSII2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSII2", static_cast<double>(0.0), &ADMSbsimcmg::Model::PSII2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSIID", static_cast<double>(0.0), &ADMSbsimcmg::Model::LSIID)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSIID", static_cast<double>(0.0), &ADMSbsimcmg::Model::NSIID)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSIID", static_cast<double>(0.0), &ADMSbsimcmg::Model::PSIID)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCFS", static_cast<double>(0.0), &ADMSbsimcmg::Model::LCFS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCFS", static_cast<double>(0.0), &ADMSbsimcmg::Model::NCFS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCFS", static_cast<double>(0.0), &ADMSbsimcmg::Model::PCFS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCFD", 0.0, &ADMSbsimcmg::Model::LCFD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCFD", 0.0, &ADMSbsimcmg::Model::NCFD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCFD", 0.0, &ADMSbsimcmg::Model::PCFD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCOVS", static_cast<double>(0.0), &ADMSbsimcmg::Model::LCOVS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCOVS", static_cast<double>(0.0), &ADMSbsimcmg::Model::NCOVS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCOVS", static_cast<double>(0.0), &ADMSbsimcmg::Model::PCOVS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCOVD", 0.0, &ADMSbsimcmg::Model::LCOVD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCOVD", 0.0, &ADMSbsimcmg::Model::NCOVD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCOVD", 0.0, &ADMSbsimcmg::Model::PCOVD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGSL", static_cast<double>(0.0), &ADMSbsimcmg::Model::LCGSL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCGSL", static_cast<double>(0.0), &ADMSbsimcmg::Model::NCGSL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGSL", static_cast<double>(0.0), &ADMSbsimcmg::Model::PCGSL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGDL", 0.0, &ADMSbsimcmg::Model::LCGDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCGDL", 0.0, &ADMSbsimcmg::Model::NCGDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGDL", 0.0, &ADMSbsimcmg::Model::PCGDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCKAPPAS", static_cast<double>(0.0), &ADMSbsimcmg::Model::LCKAPPAS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCKAPPAS", static_cast<double>(0.0), &ADMSbsimcmg::Model::NCKAPPAS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCKAPPAS", static_cast<double>(0.0), &ADMSbsimcmg::Model::PCKAPPAS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCKAPPAD", 0.0, &ADMSbsimcmg::Model::LCKAPPAD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCKAPPAD", 0.0, &ADMSbsimcmg::Model::NCKAPPAD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCKAPPAD", 0.0, &ADMSbsimcmg::Model::PCKAPPAD)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCGBL", static_cast<double>(0.0), &ADMSbsimcmg::Model::LCGBL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCGBL", static_cast<double>(0.0), &ADMSbsimcmg::Model::NCGBL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCGBL", static_cast<double>(0.0), &ADMSbsimcmg::Model::PCGBL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LCKAPPAB", static_cast<double>(0.0), &ADMSbsimcmg::Model::LCKAPPAB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCKAPPAB", static_cast<double>(0.0), &ADMSbsimcmg::Model::NCKAPPAB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PCKAPPAB", static_cast<double>(0.0), &ADMSbsimcmg::Model::PCKAPPAB)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LNTGEN", static_cast<double>(0), &ADMSbsimcmg::Model::LNTGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NNTGEN", static_cast<double>(0), &ADMSbsimcmg::Model::NNTGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNTGEN", static_cast<double>(0), &ADMSbsimcmg::Model::PNTGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::LAIGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::NAIGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::PAIGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LBIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::LBIGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NBIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::NBIGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBIGEN", static_cast<double>(0), &ADMSbsimcmg::Model::PBIGEN)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LXRCRG1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LXRCRG1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NXRCRG1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NXRCRG1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PXRCRG1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PXRCRG1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LXRCRG2", static_cast<double>(0.0), &ADMSbsimcmg::Model::LXRCRG2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NXRCRG2", static_cast<double>(0.0), &ADMSbsimcmg::Model::NXRCRG2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PXRCRG2", static_cast<double>(0.0), &ADMSbsimcmg::Model::PXRCRG2)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSbsimcmg::Model::LINTNOI)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUTE", static_cast<double>(0.0), &ADMSbsimcmg::Model::LUTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUTE", static_cast<double>(0.0), &ADMSbsimcmg::Model::NUTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUTE", static_cast<double>(0.0), &ADMSbsimcmg::Model::PUTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUTL", static_cast<double>(0.0), &ADMSbsimcmg::Model::LUTL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUTL", static_cast<double>(0.0), &ADMSbsimcmg::Model::NUTL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUTL", static_cast<double>(0.0), &ADMSbsimcmg::Model::PUTL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LEMOBT", static_cast<double>(0), &ADMSbsimcmg::Model::LEMOBT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NEMOBT", static_cast<double>(0), &ADMSbsimcmg::Model::NEMOBT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PEMOBT", static_cast<double>(0), &ADMSbsimcmg::Model::PEMOBT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUA1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LUA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUA1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NUA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUA1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PUA1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUC1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LUC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUC1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NUC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUC1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PUC1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUD1", static_cast<double>(0.0), &ADMSbsimcmg::Model::LUD1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUD1", static_cast<double>(0.0), &ADMSbsimcmg::Model::NUD1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUD1", static_cast<double>(0.0), &ADMSbsimcmg::Model::PUD1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LUCSTE", static_cast<double>(0.0), &ADMSbsimcmg::Model::LUCSTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NUCSTE", static_cast<double>(0.0), &ADMSbsimcmg::Model::NUCSTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PUCSTE", static_cast<double>(0.0), &ADMSbsimcmg::Model::PUCSTE)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPTWGT", static_cast<double>(0), &ADMSbsimcmg::Model::LPTWGT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPTWGT", static_cast<double>(0), &ADMSbsimcmg::Model::NPTWGT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPTWGT", static_cast<double>(0), &ADMSbsimcmg::Model::PPTWGT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAT", static_cast<double>(0), &ADMSbsimcmg::Model::LAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NAT", static_cast<double>(0), &ADMSbsimcmg::Model::NAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PAT", static_cast<double>(0), &ADMSbsimcmg::Model::PAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSTTHETASAT", static_cast<double>(0), &ADMSbsimcmg::Model::LSTTHETASAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSTTHETASAT", static_cast<double>(0), &ADMSbsimcmg::Model::NSTTHETASAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSTTHETASAT", static_cast<double>(0), &ADMSbsimcmg::Model::PSTTHETASAT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPRT", static_cast<double>(0), &ADMSbsimcmg::Model::LPRT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPRT", static_cast<double>(0), &ADMSbsimcmg::Model::NPRT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PPRT", static_cast<double>(0), &ADMSbsimcmg::Model::PPRT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKT1", static_cast<double>(0), &ADMSbsimcmg::Model::LKT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NKT1", static_cast<double>(0), &ADMSbsimcmg::Model::NKT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKT1", static_cast<double>(0), &ADMSbsimcmg::Model::PKT1)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LTSS", static_cast<double>(0), &ADMSbsimcmg::Model::LTSS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTSS", static_cast<double>(0), &ADMSbsimcmg::Model::NTSS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTSS", static_cast<double>(0), &ADMSbsimcmg::Model::PTSS)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LIIT", static_cast<double>(0), &ADMSbsimcmg::Model::LIIT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIIT", static_cast<double>(0), &ADMSbsimcmg::Model::NIIT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PIIT", static_cast<double>(0), &ADMSbsimcmg::Model::PIIT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LTII", static_cast<double>(0.0), &ADMSbsimcmg::Model::LTII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTII", static_cast<double>(0.0), &ADMSbsimcmg::Model::NTII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTII", static_cast<double>(0.0), &ADMSbsimcmg::Model::PTII)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LTGIDL", static_cast<double>(0), &ADMSbsimcmg::Model::LTGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NTGIDL", static_cast<double>(0), &ADMSbsimcmg::Model::NTGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PTGIDL", static_cast<double>(0), &ADMSbsimcmg::Model::PTGIDL)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LIGT", static_cast<double>(0), &ADMSbsimcmg::Model::LIGT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIGT", static_cast<double>(0), &ADMSbsimcmg::Model::NIGT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PIGT", static_cast<double>(0), &ADMSbsimcmg::Model::PIGT)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:
   if (!(given("L")))
   {
      L = model_.L;
   }
   if (!(given("D")))
   {
      D = model_.D;
   }
   if (!(given("TFIN")))
   {
      TFIN = model_.TFIN;
   }
   if (!(given("FPITCH")))
   {
      FPITCH = model_.FPITCH;
   }
   if (!(given("NFIN")))
   {
      NFIN = model_.NFIN;
   }
   if (!(given("NGCON")))
   {
      NGCON = model_.NGCON;
   }
   if (!(given("ASEO")))
   {
      ASEO = model_.ASEO;
   }
   if (!(given("ADEO")))
   {
      ADEO = model_.ADEO;
   }
   if (!(given("PSEO")))
   {
      PSEO = model_.PSEO;
   }
   if (!(given("PDEO")))
   {
      PDEO = model_.PDEO;
   }
   if (!(given("ASEJ")))
   {
      ASEJ = model_.ASEJ;
   }
   if (!(given("ADEJ")))
   {
      ADEJ = model_.ADEJ;
   }
   if (!(given("PSEJ")))
   {
      PSEJ = model_.PSEJ;
   }
   if (!(given("PDEJ")))
   {
      PDEJ = model_.PDEJ;
   }
   if (!(given("COVS")))
   {
      COVS = model_.COVS;
   }
   if (!(given("COVD")))
   {
      COVD = model_.COVD;
   }
   if (!(given("CGSP")))
   {
      CGSP = model_.CGSP;
   }
   if (!(given("CGDP")))
   {
      CGDP = model_.CGDP;
   }
   if (!(given("CDSP")))
   {
      CDSP = model_.CDSP;
   }
   if (!(given("NRS")))
   {
      NRS = model_.NRS;
   }
   if (!(given("NRD")))
   {
      NRD = model_.NRD;
   }
   if (!(given("LRSD")))
   {
      LRSD = model_.LRSD;
   }
   if (!(given("DELVTRAND")))
   {
      DELVTRAND = model_.DELVTRAND;
   }
   if (!(given("U0MULT")))
   {
      U0MULT = model_.U0MULT;
   }



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:
  if (!given("COVD"))
  {
  COVD = COVS;
  }
  if (!given("LRSD"))
  {
  LRSD = L;
  }


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter L : [ 1*1.0e-9,  (+inf) [
  if ( (!((L >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter L value " << L << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter D : [ 1*1.0e-9,  (+inf) [
  if ( (!((D >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter D value " << D << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter TFIN : [ 1*1.0e-9,  (+inf) [
  if ( (!((TFIN >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter TFIN value " << TFIN << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter FPITCH : [ TFIN,  (+inf) [
  if ( (!((FPITCH >=TFIN))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter FPITCH value " << FPITCH << " out of range [ TFIN,  (+inf) [";
  }

//    Parameter NFIN : ] 0,  (+inf) [
  if ( (!((NFIN >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NFIN value " << NFIN << " out of range ] 0,  (+inf) [";
  }

//    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

//    Parameter ASEO : [ 0,  (+inf) [
  if ( (!((ASEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ASEO value " << ASEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter ADEO : [ 0,  (+inf) [
  if ( (!((ADEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ADEO value " << ADEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSEO : [ 0,  (+inf) [
  if ( (!((PSEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PSEO value " << PSEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter PDEO : [ 0,  (+inf) [
  if ( (!((PDEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PDEO value " << PDEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter ASEJ : [ 0,  (+inf) [
  if ( (!((ASEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ASEJ value " << ASEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter ADEJ : [ 0,  (+inf) [
  if ( (!((ADEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ADEJ value " << ADEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSEJ : [ 0,  (+inf) [
  if ( (!((PSEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PSEJ value " << PSEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter PDEJ : [ 0,  (+inf) [
  if ( (!((PDEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PDEJ value " << PDEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter COVS : [ 0,  (+inf) [
  if ( (!((COVS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter COVS value " << COVS << " out of range [ 0,  (+inf) [";
  }

//    Parameter COVD : [ 0,  (+inf) [
  if ( (!((COVD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter COVD value " << COVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGSP : [ 0,  (+inf) [
  if ( (!((CGSP >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGSP value " << CGSP << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGDP : [ 0,  (+inf) [
  if ( (!((CGDP >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGDP value " << CGDP << " out of range [ 0,  (+inf) [";
  }

//    Parameter CDSP : [ 0,  (+inf) [
  if ( (!((CDSP >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSP value " << CDSP << " out of range [ 0,  (+inf) [";
  }

//    Parameter NRS : [ 0,  (+inf) [
  if ( (!((NRS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NRS value " << NRS << " out of range [ 0,  (+inf) [";
  }

//    Parameter NRD : [ 0,  (+inf) [
  if ( (!((NRD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NRD value " << NRD << " out of range [ 0,  (+inf) [";
  }

//    Parameter LRSD : ] 0,  (+inf) [
  if ( (!((LRSD >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter LRSD value " << LRSD << " out of range ] 0,  (+inf) [";
  }

//    Parameter U0MULT : [ 0,  (+inf) [
  if ( (!((U0MULT >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter U0MULT value " << U0MULT << " out of range [ 0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(30*1.0e-9),
    D(40*1.0e-9),
    TFIN(15*1.0e-9),
    FPITCH(80*1.0e-9),
    NFIN(1.0),
    NGCON(1),
    ASEO(0),
    ADEO(0),
    PSEO(0),
    PDEO(0),
    ASEJ(0),
    ADEJ(0),
    PSEJ(0),
    PDEJ(0),
    COVS(0),
    COVD(0.0),
    CGSP(0.0),
    CGDP(0.0),
    CDSP(0.0),
    NRS(0.0),
    NRD(0.0),
    LRSD(0.0),
    DELVTRAND(0),
    U0MULT(1),
    WEFF(0.0),
    LEFF(0.0),
    WEFFCV(0.0),
    LEFFCV(0.0),
    IDS(0.0),
d_IDS_dV_e_si(0.0),
d_IDS_dV_e_di(0.0),
d_IDS_dV_g_e(0.0),
d_IDS_dV_g_si(0.0),
d_IDS_dV_di_si(0.0),
d_IDS_dV_g_di(0.0),
    IDEFF(0.0),
    ISEFF(0.0),
    IGTOT(0.0),
    IDSGEN(0.0),
    III(0.0),
    IGIDL(0.0),
    IGISL(0.0),
    IJSB(0.0),
    IJDB(0.0),
    ISUB(0.0),
    BETA(0.0),
    VTH(0.0),
    VDSSAT(0.0),
    VFB(0.0),
    GM(0.0),
    GDS(0.0),
    GMBS(0.0),
    QGI(0.0),
d_QGI_dV_di_si(0.0),
d_QGI_dV_e_si(0.0),
d_QGI_dV_e_di(0.0),
d_QGI_dV_g_e(0.0),
d_QGI_dV_g_si(0.0),
d_QGI_dV_g_di(0.0),
    QDI(0.0),
d_QDI_dV_di_si(0.0),
d_QDI_dV_e_si(0.0),
d_QDI_dV_e_di(0.0),
d_QDI_dV_g_e(0.0),
d_QDI_dV_g_si(0.0),
d_QDI_dV_g_di(0.0),
    QSI(0.0),
d_QSI_dV_di_si(0.0),
d_QSI_dV_e_si(0.0),
d_QSI_dV_e_di(0.0),
d_QSI_dV_g_e(0.0),
d_QSI_dV_g_si(0.0),
d_QSI_dV_g_di(0.0),
    QBI(0.0),
d_QBI_dV_e_si(0.0),
d_QBI_dV_e_di(0.0),
d_QBI_dV_g_e(0.0),
d_QBI_dV_g_si(0.0),
d_QBI_dV_di_si(0.0),
d_QBI_dV_g_di(0.0),
    QG(0.0),
d_QG_dV_di_si(0.0),
d_QG_dV_e_si(0.0),
d_QG_dV_e_di(0.0),
d_QG_dV_g_e(0.0),
d_QG_dV_g_si(0.0),
d_QG_dV_g_di(0.0),
d_QG_dV_g_s(0.0),
d_QG_dV_g_d(0.0),
d_QG_dV_e_g(0.0),
    QD(0.0),
d_QD_dV_di_si(0.0),
d_QD_dV_e_si(0.0),
d_QD_dV_e_di(0.0),
d_QD_dV_g_e(0.0),
d_QD_dV_g_si(0.0),
d_QD_dV_g_di(0.0),
d_QD_dV_g_d(0.0),
d_QD_dV_di_d(0.0),
d_QD_dV_si_s(0.0),
    QS(0.0),
d_QS_dV_di_si(0.0),
d_QS_dV_e_si(0.0),
d_QS_dV_e_di(0.0),
d_QS_dV_g_e(0.0),
d_QS_dV_g_si(0.0),
d_QS_dV_g_di(0.0),
d_QS_dV_g_s(0.0),
d_QS_dV_di_d(0.0),
d_QS_dV_si_s(0.0),
    QB(0.0),
d_QB_dV_e_si(0.0),
d_QB_dV_e_di(0.0),
d_QB_dV_g_e(0.0),
d_QB_dV_g_si(0.0),
d_QB_dV_di_si(0.0),
d_QB_dV_g_di(0.0),
d_QB_dV_e_g(0.0),
d_QB_dV_di_d(0.0),
d_QB_dV_si_s(0.0),
    CGGI(0.0),
    CGSI(0.0),
    CGDI(0.0),
    CGEI(0.0),
    CDGI(0.0),
    CDDI(0.0),
    CDSI(0.0),
    CDEI(0.0),
    CSGI(0.0),
    CSDI(0.0),
    CSSI(0.0),
    CSEI(0.0),
    CEGI(0.0),
    CEDI(0.0),
    CESI(0.0),
    CEEI(0.0),
    CGG(0.0),
    CGS(0.0),
    CGD(0.0),
    CGE(0.0),
    CDG(0.0),
    CDD(0.0),
    CDS(0.0),
    CDE(0.0),
    CSG(0.0),
    CSD(0.0),
    CSS(0.0),
    CSE(0.0),
    CEG(0.0),
    CED(0.0),
    CES(0.0),
    CEE(0.0),
    CGSEXT(0.0),
    CGDEXT(0.0),
    CGBOV(0.0),
    CJST(0.0),
    CJDT(0.0),
    RSGEO(0.0),
    RDGEO(0.0),
    CFGEO(0.0),
    li_d(-1),
    li_g(-1),
    li_s(-1),
    li_e(-1),
    li_di(-1),
    li_si(-1),
    li_branch_id(-1),
    li_branch_ig(-1),
    li_branch_is(-1),
    li_branch_ie(-1),
    f_di_Equ_g_Node_Ptr(0),
    f_di_Equ_di_Node_Ptr(0),
    f_si_Equ_g_Node_Ptr(0),
    f_si_Equ_di_Node_Ptr(0),
    f_di_Equ_si_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_di_Equ_e_Node_Ptr(0),
    f_si_Equ_e_Node_Ptr(0),
    f_g_Equ_g_Node_Ptr(0),
    f_g_Equ_di_Node_Ptr(0),
    f_g_Equ_si_Node_Ptr(0),
    f_g_Equ_e_Node_Ptr(0),
    f_g_Equ_s_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_g_Equ_d_Node_Ptr(0),
    f_si_Equ_d_Node_Ptr(0),
    f_di_Equ_s_Node_Ptr(0),
    f_di_Equ_d_Node_Ptr(0),
    f_e_Equ_g_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_e_Equ_di_Node_Ptr(0),
    f_e_Equ_si_Node_Ptr(0),
    f_e_Equ_s_Node_Ptr(0),
    f_e_Equ_d_Node_Ptr(0),
    f_d_Equ_d_Node_Ptr(0),
    f_d_Equ_s_Node_Ptr(0),
    f_s_Equ_d_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_di_Node_Ptr(0),
    f_s_Equ_si_Node_Ptr(0),
    f_s_Equ_g_Node_Ptr(0),
    f_s_Equ_e_Node_Ptr(0),
    f_d_Equ_di_Node_Ptr(0),
    f_d_Equ_si_Node_Ptr(0),
    f_d_Equ_g_Node_Ptr(0),
    f_d_Equ_e_Node_Ptr(0),
    q_di_Equ_g_Node_Ptr(0),
    q_di_Equ_di_Node_Ptr(0),
    q_si_Equ_g_Node_Ptr(0),
    q_si_Equ_di_Node_Ptr(0),
    q_di_Equ_si_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_di_Equ_e_Node_Ptr(0),
    q_si_Equ_e_Node_Ptr(0),
    q_g_Equ_g_Node_Ptr(0),
    q_g_Equ_di_Node_Ptr(0),
    q_g_Equ_si_Node_Ptr(0),
    q_g_Equ_e_Node_Ptr(0),
    q_g_Equ_s_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_g_Equ_d_Node_Ptr(0),
    q_si_Equ_d_Node_Ptr(0),
    q_di_Equ_s_Node_Ptr(0),
    q_di_Equ_d_Node_Ptr(0),
    q_e_Equ_g_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_e_Equ_di_Node_Ptr(0),
    q_e_Equ_si_Node_Ptr(0),
    q_e_Equ_s_Node_Ptr(0),
    q_e_Equ_d_Node_Ptr(0),
    q_d_Equ_d_Node_Ptr(0),
    q_d_Equ_s_Node_Ptr(0),
    q_s_Equ_d_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_di_Node_Ptr(0),
    q_s_Equ_si_Node_Ptr(0),
    q_s_Equ_g_Node_Ptr(0),
    q_s_Equ_e_Node_Ptr(0),
    q_d_Equ_di_Node_Ptr(0),
    q_d_Equ_si_Node_Ptr(0),
    q_d_Equ_g_Node_Ptr(0),
    q_d_Equ_e_Node_Ptr(0),
    A_di_Equ_g_NodeOffset(-1),
    A_di_Equ_di_NodeOffset(-1),
    A_si_Equ_g_NodeOffset(-1),
    A_si_Equ_di_NodeOffset(-1),
    A_di_Equ_si_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_di_Equ_e_NodeOffset(-1),
    A_si_Equ_e_NodeOffset(-1),
    A_g_Equ_g_NodeOffset(-1),
    A_g_Equ_di_NodeOffset(-1),
    A_g_Equ_si_NodeOffset(-1),
    A_g_Equ_e_NodeOffset(-1),
    A_g_Equ_s_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_g_Equ_d_NodeOffset(-1),
    A_si_Equ_d_NodeOffset(-1),
    A_di_Equ_s_NodeOffset(-1),
    A_di_Equ_d_NodeOffset(-1),
    A_e_Equ_g_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_e_Equ_di_NodeOffset(-1),
    A_e_Equ_si_NodeOffset(-1),
    A_e_Equ_s_NodeOffset(-1),
    A_e_Equ_d_NodeOffset(-1),
    A_d_Equ_d_NodeOffset(-1),
    A_d_Equ_s_NodeOffset(-1),
    A_s_Equ_d_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_di_NodeOffset(-1),
    A_s_Equ_si_NodeOffset(-1),
    A_s_Equ_g_NodeOffset(-1),
    A_s_Equ_e_NodeOffset(-1),
    A_d_Equ_di_NodeOffset(-1),
    A_d_Equ_si_NodeOffset(-1),
    A_d_Equ_g_NodeOffset(-1),
    A_d_Equ_e_NodeOffset(-1),
    li_store_WEFF(-1),
    li_store_LEFF(-1),
    li_store_WEFFCV(-1),
    li_store_LEFFCV(-1),
    li_store_IDS(-1),
    li_store_IDEFF(-1),
    li_store_ISEFF(-1),
    li_store_IGTOT(-1),
    li_store_IDSGEN(-1),
    li_store_III(-1),
    li_store_IGIDL(-1),
    li_store_IGISL(-1),
    li_store_IJSB(-1),
    li_store_IJDB(-1),
    li_store_ISUB(-1),
    li_store_BETA(-1),
    li_store_VTH(-1),
    li_store_VDSSAT(-1),
    li_store_VFB(-1),
    li_store_GM(-1),
    li_store_GDS(-1),
    li_store_GMBS(-1),
    li_store_QGI(-1),
    li_store_QDI(-1),
    li_store_QSI(-1),
    li_store_QBI(-1),
    li_store_QG(-1),
    li_store_QD(-1),
    li_store_QS(-1),
    li_store_QB(-1),
    li_store_CGGI(-1),
    li_store_CGSI(-1),
    li_store_CGDI(-1),
    li_store_CGEI(-1),
    li_store_CDGI(-1),
    li_store_CDDI(-1),
    li_store_CDSI(-1),
    li_store_CDEI(-1),
    li_store_CSGI(-1),
    li_store_CSDI(-1),
    li_store_CSSI(-1),
    li_store_CSEI(-1),
    li_store_CEGI(-1),
    li_store_CEDI(-1),
    li_store_CESI(-1),
    li_store_CEEI(-1),
    li_store_CGG(-1),
    li_store_CGS(-1),
    li_store_CGD(-1),
    li_store_CGE(-1),
    li_store_CDG(-1),
    li_store_CDD(-1),
    li_store_CDS(-1),
    li_store_CDE(-1),
    li_store_CSG(-1),
    li_store_CSD(-1),
    li_store_CSS(-1),
    li_store_CSE(-1),
    li_store_CEG(-1),
    li_store_CED(-1),
    li_store_CES(-1),
    li_store_CEE(-1),
    li_store_CGSEXT(-1),
    li_store_CGDEXT(-1),
    li_store_CGBOV(-1),
    li_store_CJST(-1),
    li_store_CJDT(-1),
    li_store_RSGEO(-1),
    li_store_RDGEO(-1),
    li_store_CFGEO(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 2 + 0;
    numExtVars = 4;

  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+70);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_d));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 6+0;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSbsimcmg::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_d = localLIDVec[nodeMap[admsNodeID_d]];
  li_g = localLIDVec[nodeMap[admsNodeID_g]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_di = localLIDVec[nodeMap[admsNodeID_di]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_d = " << li_d << std::endl;
      Xyce::dout() << "\nli_g = " << li_g << std::endl;
      Xyce::dout() << "\nli_s = " << li_s << std::endl;
      Xyce::dout() << "\nli_e = " << li_e << std::endl;
      Xyce::dout() << "\nli_di = " << li_di << std::endl;
      Xyce::dout() << "\nli_si = " << li_si << std::endl;

    Xyce::dout() << "\nEnd of ADMSbsimcmg::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    addInternalNode(symbol_table, li_di, getName(), "di");
    addInternalNode(symbol_table, li_si, getName(), "si");
    addStoreNode(symbol_table, li_store_WEFF, getName().getEncodedName() + ":WEFF");
    addStoreNode(symbol_table, li_store_LEFF, getName().getEncodedName() + ":LEFF");
    addStoreNode(symbol_table, li_store_WEFFCV, getName().getEncodedName() + ":WEFFCV");
    addStoreNode(symbol_table, li_store_LEFFCV, getName().getEncodedName() + ":LEFFCV");
    addStoreNode(symbol_table, li_store_IDS, getName().getEncodedName() + ":IDS");
    addStoreNode(symbol_table, li_store_IDEFF, getName().getEncodedName() + ":IDEFF");
    addStoreNode(symbol_table, li_store_ISEFF, getName().getEncodedName() + ":ISEFF");
    addStoreNode(symbol_table, li_store_IGTOT, getName().getEncodedName() + ":IGTOT");
    addStoreNode(symbol_table, li_store_IDSGEN, getName().getEncodedName() + ":IDSGEN");
    addStoreNode(symbol_table, li_store_III, getName().getEncodedName() + ":III");
    addStoreNode(symbol_table, li_store_IGIDL, getName().getEncodedName() + ":IGIDL");
    addStoreNode(symbol_table, li_store_IGISL, getName().getEncodedName() + ":IGISL");
    addStoreNode(symbol_table, li_store_IJSB, getName().getEncodedName() + ":IJSB");
    addStoreNode(symbol_table, li_store_IJDB, getName().getEncodedName() + ":IJDB");
    addStoreNode(symbol_table, li_store_ISUB, getName().getEncodedName() + ":ISUB");
    addStoreNode(symbol_table, li_store_BETA, getName().getEncodedName() + ":BETA");
    addStoreNode(symbol_table, li_store_VTH, getName().getEncodedName() + ":VTH");
    addStoreNode(symbol_table, li_store_VDSSAT, getName().getEncodedName() + ":VDSSAT");
    addStoreNode(symbol_table, li_store_VFB, getName().getEncodedName() + ":VFB");
    addStoreNode(symbol_table, li_store_GM, getName().getEncodedName() + ":GM");
    addStoreNode(symbol_table, li_store_GDS, getName().getEncodedName() + ":GDS");
    addStoreNode(symbol_table, li_store_GMBS, getName().getEncodedName() + ":GMBS");
    addStoreNode(symbol_table, li_store_QGI, getName().getEncodedName() + ":QGI");
    addStoreNode(symbol_table, li_store_QDI, getName().getEncodedName() + ":QDI");
    addStoreNode(symbol_table, li_store_QSI, getName().getEncodedName() + ":QSI");
    addStoreNode(symbol_table, li_store_QBI, getName().getEncodedName() + ":QBI");
    addStoreNode(symbol_table, li_store_QG, getName().getEncodedName() + ":QG");
    addStoreNode(symbol_table, li_store_QD, getName().getEncodedName() + ":QD");
    addStoreNode(symbol_table, li_store_QS, getName().getEncodedName() + ":QS");
    addStoreNode(symbol_table, li_store_QB, getName().getEncodedName() + ":QB");
    addStoreNode(symbol_table, li_store_CGGI, getName().getEncodedName() + ":CGGI");
    addStoreNode(symbol_table, li_store_CGSI, getName().getEncodedName() + ":CGSI");
    addStoreNode(symbol_table, li_store_CGDI, getName().getEncodedName() + ":CGDI");
    addStoreNode(symbol_table, li_store_CGEI, getName().getEncodedName() + ":CGEI");
    addStoreNode(symbol_table, li_store_CDGI, getName().getEncodedName() + ":CDGI");
    addStoreNode(symbol_table, li_store_CDDI, getName().getEncodedName() + ":CDDI");
    addStoreNode(symbol_table, li_store_CDSI, getName().getEncodedName() + ":CDSI");
    addStoreNode(symbol_table, li_store_CDEI, getName().getEncodedName() + ":CDEI");
    addStoreNode(symbol_table, li_store_CSGI, getName().getEncodedName() + ":CSGI");
    addStoreNode(symbol_table, li_store_CSDI, getName().getEncodedName() + ":CSDI");
    addStoreNode(symbol_table, li_store_CSSI, getName().getEncodedName() + ":CSSI");
    addStoreNode(symbol_table, li_store_CSEI, getName().getEncodedName() + ":CSEI");
    addStoreNode(symbol_table, li_store_CEGI, getName().getEncodedName() + ":CEGI");
    addStoreNode(symbol_table, li_store_CEDI, getName().getEncodedName() + ":CEDI");
    addStoreNode(symbol_table, li_store_CESI, getName().getEncodedName() + ":CESI");
    addStoreNode(symbol_table, li_store_CEEI, getName().getEncodedName() + ":CEEI");
    addStoreNode(symbol_table, li_store_CGG, getName().getEncodedName() + ":CGG");
    addStoreNode(symbol_table, li_store_CGS, getName().getEncodedName() + ":CGS");
    addStoreNode(symbol_table, li_store_CGD, getName().getEncodedName() + ":CGD");
    addStoreNode(symbol_table, li_store_CGE, getName().getEncodedName() + ":CGE");
    addStoreNode(symbol_table, li_store_CDG, getName().getEncodedName() + ":CDG");
    addStoreNode(symbol_table, li_store_CDD, getName().getEncodedName() + ":CDD");
    addStoreNode(symbol_table, li_store_CDS, getName().getEncodedName() + ":CDS");
    addStoreNode(symbol_table, li_store_CDE, getName().getEncodedName() + ":CDE");
    addStoreNode(symbol_table, li_store_CSG, getName().getEncodedName() + ":CSG");
    addStoreNode(symbol_table, li_store_CSD, getName().getEncodedName() + ":CSD");
    addStoreNode(symbol_table, li_store_CSS, getName().getEncodedName() + ":CSS");
    addStoreNode(symbol_table, li_store_CSE, getName().getEncodedName() + ":CSE");
    addStoreNode(symbol_table, li_store_CEG, getName().getEncodedName() + ":CEG");
    addStoreNode(symbol_table, li_store_CED, getName().getEncodedName() + ":CED");
    addStoreNode(symbol_table, li_store_CES, getName().getEncodedName() + ":CES");
    addStoreNode(symbol_table, li_store_CEE, getName().getEncodedName() + ":CEE");
    addStoreNode(symbol_table, li_store_CGSEXT, getName().getEncodedName() + ":CGSEXT");
    addStoreNode(symbol_table, li_store_CGDEXT, getName().getEncodedName() + ":CGDEXT");
    addStoreNode(symbol_table, li_store_CGBOV, getName().getEncodedName() + ":CGBOV");
    addStoreNode(symbol_table, li_store_CJST, getName().getEncodedName() + ":CJST");
    addStoreNode(symbol_table, li_store_CJDT, getName().getEncodedName() + ":CJDT");
    addStoreNode(symbol_table, li_store_RSGEO, getName().getEncodedName() + ":RSGEO");
    addStoreNode(symbol_table, li_store_RDGEO, getName().getEncodedName() + ":RDGEO");
    addStoreNode(symbol_table, li_store_CFGEO, getName().getEncodedName() + ":CFGEO");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_id, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_ig, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_WEFF= stoLIDVec[i++];
      li_store_LEFF= stoLIDVec[i++];
      li_store_WEFFCV= stoLIDVec[i++];
      li_store_LEFFCV= stoLIDVec[i++];
      li_store_IDS= stoLIDVec[i++];
      li_store_IDEFF= stoLIDVec[i++];
      li_store_ISEFF= stoLIDVec[i++];
      li_store_IGTOT= stoLIDVec[i++];
      li_store_IDSGEN= stoLIDVec[i++];
      li_store_III= stoLIDVec[i++];
      li_store_IGIDL= stoLIDVec[i++];
      li_store_IGISL= stoLIDVec[i++];
      li_store_IJSB= stoLIDVec[i++];
      li_store_IJDB= stoLIDVec[i++];
      li_store_ISUB= stoLIDVec[i++];
      li_store_BETA= stoLIDVec[i++];
      li_store_VTH= stoLIDVec[i++];
      li_store_VDSSAT= stoLIDVec[i++];
      li_store_VFB= stoLIDVec[i++];
      li_store_GM= stoLIDVec[i++];
      li_store_GDS= stoLIDVec[i++];
      li_store_GMBS= stoLIDVec[i++];
      li_store_QGI= stoLIDVec[i++];
      li_store_QDI= stoLIDVec[i++];
      li_store_QSI= stoLIDVec[i++];
      li_store_QBI= stoLIDVec[i++];
      li_store_QG= stoLIDVec[i++];
      li_store_QD= stoLIDVec[i++];
      li_store_QS= stoLIDVec[i++];
      li_store_QB= stoLIDVec[i++];
      li_store_CGGI= stoLIDVec[i++];
      li_store_CGSI= stoLIDVec[i++];
      li_store_CGDI= stoLIDVec[i++];
      li_store_CGEI= stoLIDVec[i++];
      li_store_CDGI= stoLIDVec[i++];
      li_store_CDDI= stoLIDVec[i++];
      li_store_CDSI= stoLIDVec[i++];
      li_store_CDEI= stoLIDVec[i++];
      li_store_CSGI= stoLIDVec[i++];
      li_store_CSDI= stoLIDVec[i++];
      li_store_CSSI= stoLIDVec[i++];
      li_store_CSEI= stoLIDVec[i++];
      li_store_CEGI= stoLIDVec[i++];
      li_store_CEDI= stoLIDVec[i++];
      li_store_CESI= stoLIDVec[i++];
      li_store_CEEI= stoLIDVec[i++];
      li_store_CGG= stoLIDVec[i++];
      li_store_CGS= stoLIDVec[i++];
      li_store_CGD= stoLIDVec[i++];
      li_store_CGE= stoLIDVec[i++];
      li_store_CDG= stoLIDVec[i++];
      li_store_CDD= stoLIDVec[i++];
      li_store_CDS= stoLIDVec[i++];
      li_store_CDE= stoLIDVec[i++];
      li_store_CSG= stoLIDVec[i++];
      li_store_CSD= stoLIDVec[i++];
      li_store_CSS= stoLIDVec[i++];
      li_store_CSE= stoLIDVec[i++];
      li_store_CEG= stoLIDVec[i++];
      li_store_CED= stoLIDVec[i++];
      li_store_CES= stoLIDVec[i++];
      li_store_CEE= stoLIDVec[i++];
      li_store_CGSEXT= stoLIDVec[i++];
      li_store_CGDEXT= stoLIDVec[i++];
      li_store_CGBOV= stoLIDVec[i++];
      li_store_CJST= stoLIDVec[i++];
      li_store_CJDT= stoLIDVec[i++];
      li_store_RSGEO= stoLIDVec[i++];
      li_store_RDGEO= stoLIDVec[i++];
      li_store_CFGEO= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_id = branchLIDVecRef[i++];
    li_branch_ig = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_d)];
    A_d_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_s)];
    A_d_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_di)];
    A_d_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_si)];
    A_d_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_g)];
    A_d_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_e)];
    A_d_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_g)];
    A_g_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_di)];
    A_g_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_si)];
    A_g_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_e)];
    A_g_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_s)];
    A_g_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_d)];
    A_g_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_d)];
    A_s_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
    A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_di)];
    A_s_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_si)];
    A_s_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_g)];
    A_s_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_e)];
    A_s_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_g)];
    A_e_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
    A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_di)];
    A_e_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_si)];
    A_e_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_s)];
    A_e_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_d)];
    A_e_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_g)];
    A_di_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_di)];
    A_di_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_si)];
    A_di_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_e)];
    A_di_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_s)];
    A_di_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_d)];
    A_di_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_g)];
    A_si_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_di)];
    A_si_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
    A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_e)];
    A_si_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
    A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_d)];
    A_si_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
    f_d_Equ_d_Node_Ptr = &(dFdx[li_d][A_d_Equ_d_NodeOffset]);
    q_d_Equ_d_Node_Ptr = &(dQdx[li_d][A_d_Equ_d_NodeOffset]);
    f_d_Equ_s_Node_Ptr = &(dFdx[li_d][A_d_Equ_s_NodeOffset]);
    q_d_Equ_s_Node_Ptr = &(dQdx[li_d][A_d_Equ_s_NodeOffset]);
    f_d_Equ_di_Node_Ptr = &(dFdx[li_d][A_d_Equ_di_NodeOffset]);
    q_d_Equ_di_Node_Ptr = &(dQdx[li_d][A_d_Equ_di_NodeOffset]);
    f_d_Equ_si_Node_Ptr = &(dFdx[li_d][A_d_Equ_si_NodeOffset]);
    q_d_Equ_si_Node_Ptr = &(dQdx[li_d][A_d_Equ_si_NodeOffset]);
    f_d_Equ_g_Node_Ptr = &(dFdx[li_d][A_d_Equ_g_NodeOffset]);
    q_d_Equ_g_Node_Ptr = &(dQdx[li_d][A_d_Equ_g_NodeOffset]);
    f_d_Equ_e_Node_Ptr = &(dFdx[li_d][A_d_Equ_e_NodeOffset]);
    q_d_Equ_e_Node_Ptr = &(dQdx[li_d][A_d_Equ_e_NodeOffset]);
    f_g_Equ_g_Node_Ptr = &(dFdx[li_g][A_g_Equ_g_NodeOffset]);
    q_g_Equ_g_Node_Ptr = &(dQdx[li_g][A_g_Equ_g_NodeOffset]);
    f_g_Equ_di_Node_Ptr = &(dFdx[li_g][A_g_Equ_di_NodeOffset]);
    q_g_Equ_di_Node_Ptr = &(dQdx[li_g][A_g_Equ_di_NodeOffset]);
    f_g_Equ_si_Node_Ptr = &(dFdx[li_g][A_g_Equ_si_NodeOffset]);
    q_g_Equ_si_Node_Ptr = &(dQdx[li_g][A_g_Equ_si_NodeOffset]);
    f_g_Equ_e_Node_Ptr = &(dFdx[li_g][A_g_Equ_e_NodeOffset]);
    q_g_Equ_e_Node_Ptr = &(dQdx[li_g][A_g_Equ_e_NodeOffset]);
    f_g_Equ_s_Node_Ptr = &(dFdx[li_g][A_g_Equ_s_NodeOffset]);
    q_g_Equ_s_Node_Ptr = &(dQdx[li_g][A_g_Equ_s_NodeOffset]);
    f_g_Equ_d_Node_Ptr = &(dFdx[li_g][A_g_Equ_d_NodeOffset]);
    q_g_Equ_d_Node_Ptr = &(dQdx[li_g][A_g_Equ_d_NodeOffset]);
    f_s_Equ_d_Node_Ptr = &(dFdx[li_s][A_s_Equ_d_NodeOffset]);
    q_s_Equ_d_Node_Ptr = &(dQdx[li_s][A_s_Equ_d_NodeOffset]);
    f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
    q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
    f_s_Equ_di_Node_Ptr = &(dFdx[li_s][A_s_Equ_di_NodeOffset]);
    q_s_Equ_di_Node_Ptr = &(dQdx[li_s][A_s_Equ_di_NodeOffset]);
    f_s_Equ_si_Node_Ptr = &(dFdx[li_s][A_s_Equ_si_NodeOffset]);
    q_s_Equ_si_Node_Ptr = &(dQdx[li_s][A_s_Equ_si_NodeOffset]);
    f_s_Equ_g_Node_Ptr = &(dFdx[li_s][A_s_Equ_g_NodeOffset]);
    q_s_Equ_g_Node_Ptr = &(dQdx[li_s][A_s_Equ_g_NodeOffset]);
    f_s_Equ_e_Node_Ptr = &(dFdx[li_s][A_s_Equ_e_NodeOffset]);
    q_s_Equ_e_Node_Ptr = &(dQdx[li_s][A_s_Equ_e_NodeOffset]);
    f_e_Equ_g_Node_Ptr = &(dFdx[li_e][A_e_Equ_g_NodeOffset]);
    q_e_Equ_g_Node_Ptr = &(dQdx[li_e][A_e_Equ_g_NodeOffset]);
    f_e_Equ_e_Node_Ptr = &(dFdx[li_e][A_e_Equ_e_NodeOffset]);
    q_e_Equ_e_Node_Ptr = &(dQdx[li_e][A_e_Equ_e_NodeOffset]);
    f_e_Equ_di_Node_Ptr = &(dFdx[li_e][A_e_Equ_di_NodeOffset]);
    q_e_Equ_di_Node_Ptr = &(dQdx[li_e][A_e_Equ_di_NodeOffset]);
    f_e_Equ_si_Node_Ptr = &(dFdx[li_e][A_e_Equ_si_NodeOffset]);
    q_e_Equ_si_Node_Ptr = &(dQdx[li_e][A_e_Equ_si_NodeOffset]);
    f_e_Equ_s_Node_Ptr = &(dFdx[li_e][A_e_Equ_s_NodeOffset]);
    q_e_Equ_s_Node_Ptr = &(dQdx[li_e][A_e_Equ_s_NodeOffset]);
    f_e_Equ_d_Node_Ptr = &(dFdx[li_e][A_e_Equ_d_NodeOffset]);
    q_e_Equ_d_Node_Ptr = &(dQdx[li_e][A_e_Equ_d_NodeOffset]);
    f_di_Equ_g_Node_Ptr = &(dFdx[li_di][A_di_Equ_g_NodeOffset]);
    q_di_Equ_g_Node_Ptr = &(dQdx[li_di][A_di_Equ_g_NodeOffset]);
    f_di_Equ_di_Node_Ptr = &(dFdx[li_di][A_di_Equ_di_NodeOffset]);
    q_di_Equ_di_Node_Ptr = &(dQdx[li_di][A_di_Equ_di_NodeOffset]);
    f_di_Equ_si_Node_Ptr = &(dFdx[li_di][A_di_Equ_si_NodeOffset]);
    q_di_Equ_si_Node_Ptr = &(dQdx[li_di][A_di_Equ_si_NodeOffset]);
    f_di_Equ_e_Node_Ptr = &(dFdx[li_di][A_di_Equ_e_NodeOffset]);
    q_di_Equ_e_Node_Ptr = &(dQdx[li_di][A_di_Equ_e_NodeOffset]);
    f_di_Equ_s_Node_Ptr = &(dFdx[li_di][A_di_Equ_s_NodeOffset]);
    q_di_Equ_s_Node_Ptr = &(dQdx[li_di][A_di_Equ_s_NodeOffset]);
    f_di_Equ_d_Node_Ptr = &(dFdx[li_di][A_di_Equ_d_NodeOffset]);
    q_di_Equ_d_Node_Ptr = &(dQdx[li_di][A_di_Equ_d_NodeOffset]);
    f_si_Equ_g_Node_Ptr = &(dFdx[li_si][A_si_Equ_g_NodeOffset]);
    q_si_Equ_g_Node_Ptr = &(dQdx[li_si][A_si_Equ_g_NodeOffset]);
    f_si_Equ_di_Node_Ptr = &(dFdx[li_si][A_si_Equ_di_NodeOffset]);
    q_si_Equ_di_Node_Ptr = &(dQdx[li_si][A_si_Equ_di_NodeOffset]);
    f_si_Equ_si_Node_Ptr = &(dFdx[li_si][A_si_Equ_si_NodeOffset]);
    q_si_Equ_si_Node_Ptr = &(dQdx[li_si][A_si_Equ_si_NodeOffset]);
    f_si_Equ_e_Node_Ptr = &(dFdx[li_si][A_si_Equ_e_NodeOffset]);
    q_si_Equ_e_Node_Ptr = &(dQdx[li_si][A_si_Equ_e_NodeOffset]);
    f_si_Equ_s_Node_Ptr = &(dFdx[li_si][A_si_Equ_s_NodeOffset]);
    q_si_Equ_s_Node_Ptr = &(dQdx[li_si][A_si_Equ_s_NodeOffset]);
    f_si_Equ_d_Node_Ptr = &(dFdx[li_si][A_si_Equ_d_NodeOffset]);
    q_si_Equ_d_Node_Ptr = &(dQdx[li_si][A_si_Equ_d_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_d] += staticContributions[admsNodeID_d];
(*extData.daeFVectorPtr)[li_g] += staticContributions[admsNodeID_g];
(*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s];
(*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e];
(*extData.daeFVectorPtr)[li_di] += staticContributions[admsNodeID_di];
(*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_id] = leadCurrentF[admsNodeID_d];
    leadF[li_branch_ig] = leadCurrentF[admsNodeID_g];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_id] = solVec[li_d] - solVec[li_s];
        junctionV[li_branch_ig] = solVec[li_g] - solVec[li_s];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_d] += dynamicContributions[admsNodeID_d];
(*extData.daeQVectorPtr)[li_g] += dynamicContributions[admsNodeID_g];
(*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s];
(*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e];
(*extData.daeQVectorPtr)[li_di] += dynamicContributions[admsNodeID_di];
(*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_id] = leadCurrentQ[admsNodeID_d];
    leadQ[li_branch_ig] = leadCurrentQ[admsNodeID_g];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_WEFF] = WEFF;
  stoVec[li_store_LEFF] = LEFF;
  stoVec[li_store_WEFFCV] = WEFFCV;
  stoVec[li_store_LEFFCV] = LEFFCV;
  stoVec[li_store_IDS] = IDS;
  stoVec[li_store_IDEFF] = IDEFF;
  stoVec[li_store_ISEFF] = ISEFF;
  stoVec[li_store_IGTOT] = IGTOT;
  stoVec[li_store_IDSGEN] = IDSGEN;
  stoVec[li_store_III] = III;
  stoVec[li_store_IGIDL] = IGIDL;
  stoVec[li_store_IGISL] = IGISL;
  stoVec[li_store_IJSB] = IJSB;
  stoVec[li_store_IJDB] = IJDB;
  stoVec[li_store_ISUB] = ISUB;
  stoVec[li_store_BETA] = BETA;
  stoVec[li_store_VTH] = VTH;
  stoVec[li_store_VDSSAT] = VDSSAT;
  stoVec[li_store_VFB] = VFB;
  stoVec[li_store_GM] = GM;
  stoVec[li_store_GDS] = GDS;
  stoVec[li_store_GMBS] = GMBS;
  stoVec[li_store_QGI] = QGI;
  stoVec[li_store_QDI] = QDI;
  stoVec[li_store_QSI] = QSI;
  stoVec[li_store_QBI] = QBI;
  stoVec[li_store_QG] = QG;
  stoVec[li_store_QD] = QD;
  stoVec[li_store_QS] = QS;
  stoVec[li_store_QB] = QB;
  stoVec[li_store_CGGI] = CGGI;
  stoVec[li_store_CGSI] = CGSI;
  stoVec[li_store_CGDI] = CGDI;
  stoVec[li_store_CGEI] = CGEI;
  stoVec[li_store_CDGI] = CDGI;
  stoVec[li_store_CDDI] = CDDI;
  stoVec[li_store_CDSI] = CDSI;
  stoVec[li_store_CDEI] = CDEI;
  stoVec[li_store_CSGI] = CSGI;
  stoVec[li_store_CSDI] = CSDI;
  stoVec[li_store_CSSI] = CSSI;
  stoVec[li_store_CSEI] = CSEI;
  stoVec[li_store_CEGI] = CEGI;
  stoVec[li_store_CEDI] = CEDI;
  stoVec[li_store_CESI] = CESI;
  stoVec[li_store_CEEI] = CEEI;
  stoVec[li_store_CGG] = CGG;
  stoVec[li_store_CGS] = CGS;
  stoVec[li_store_CGD] = CGD;
  stoVec[li_store_CGE] = CGE;
  stoVec[li_store_CDG] = CDG;
  stoVec[li_store_CDD] = CDD;
  stoVec[li_store_CDS] = CDS;
  stoVec[li_store_CDE] = CDE;
  stoVec[li_store_CSG] = CSG;
  stoVec[li_store_CSD] = CSD;
  stoVec[li_store_CSS] = CSS;
  stoVec[li_store_CSE] = CSE;
  stoVec[li_store_CEG] = CEG;
  stoVec[li_store_CED] = CED;
  stoVec[li_store_CES] = CES;
  stoVec[li_store_CEE] = CEE;
  stoVec[li_store_CGSEXT] = CGSEXT;
  stoVec[li_store_CGDEXT] = CGDEXT;
  stoVec[li_store_CGBOV] = CGBOV;
  stoVec[li_store_CJST] = CJST;
  stoVec[li_store_CJDT] = CJDT;
  stoVec[li_store_RSGEO] = RSGEO;
  stoVec[li_store_RDGEO] = RDGEO;
  stoVec[li_store_CFGEO] = CFGEO;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one bsimcmg instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSbsimcmg::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double qith=0.0;
  double sid=0.0;
  double Swi=0.0;
  double T10=0.0;
  double Ssi=0.0;
  double Nstar=0.0;
  double Nl=0.0;
  double N0=0.0;
  double DelClm=0.0;
  double Leffnoisq=0.0;
  double Leffnoi=0.0;
  double Esatnoi=0.0;
  double IdovVds=0.0;
  double vge_overlap=0.0;
     double d_vge_overlap_dV_g_di=0.0;
     double d_vge_overlap_dV_e_si=0.0;
     double d_vge_overlap_dV_e_di=0.0;
     double d_vge_overlap_dV_g_e=0.0;
     double d_vge_overlap_dV_g_si=0.0;
     double d_vge_overlap_dV_di_si=0.0;
  double Qedj3=0.0;
     double d_Qedj3_dV_di_d=0.0;
     double d_Qedj3_dV_si_s=0.0;
     double d_Qedj3_dV_g_di=0.0;
     double d_Qedj3_dV_e_si=0.0;
     double d_Qedj3_dV_e_di=0.0;
     double d_Qedj3_dV_g_e=0.0;
     double d_Qedj3_dV_g_si=0.0;
     double d_Qedj3_dV_di_si=0.0;
  double Qedj2=0.0;
     double d_Qedj2_dV_di_d=0.0;
     double d_Qedj2_dV_si_s=0.0;
     double d_Qedj2_dV_g_di=0.0;
     double d_Qedj2_dV_e_si=0.0;
     double d_Qedj2_dV_e_di=0.0;
     double d_Qedj2_dV_g_e=0.0;
     double d_Qedj2_dV_g_si=0.0;
     double d_Qedj2_dV_di_si=0.0;
  double Qedj1=0.0;
     double d_Qedj1_dV_di_d=0.0;
     double d_Qedj1_dV_si_s=0.0;
     double d_Qedj1_dV_g_di=0.0;
     double d_Qedj1_dV_e_si=0.0;
     double d_Qedj1_dV_e_di=0.0;
     double d_Qedj1_dV_g_e=0.0;
     double d_Qedj1_dV_g_si=0.0;
     double d_Qedj1_dV_di_si=0.0;
  double Qesj3=0.0;
     double d_Qesj3_dV_di_d=0.0;
     double d_Qesj3_dV_si_s=0.0;
     double d_Qesj3_dV_g_di=0.0;
     double d_Qesj3_dV_e_si=0.0;
     double d_Qesj3_dV_e_di=0.0;
     double d_Qesj3_dV_g_e=0.0;
     double d_Qesj3_dV_g_si=0.0;
     double d_Qesj3_dV_di_si=0.0;
  double Qesj2=0.0;
     double d_Qesj2_dV_di_d=0.0;
     double d_Qesj2_dV_si_s=0.0;
     double d_Qesj2_dV_g_di=0.0;
     double d_Qesj2_dV_e_si=0.0;
     double d_Qesj2_dV_e_di=0.0;
     double d_Qesj2_dV_g_e=0.0;
     double d_Qesj2_dV_g_si=0.0;
     double d_Qesj2_dV_di_si=0.0;
  double vec=0.0;
  double pb2=0.0;
  double Qec=0.0;
     double d_Qec_dV_g_di=0.0;
     double d_Qec_dV_e_si=0.0;
     double d_Qec_dV_e_di=0.0;
     double d_Qec_dV_g_e=0.0;
     double d_Qec_dV_g_si=0.0;
     double d_Qec_dV_di_si=0.0;
  double arg=0.0;
     double d_arg_dV_g_di=0.0;
     double d_arg_dV_e_si=0.0;
     double d_arg_dV_e_di=0.0;
     double d_arg_dV_g_e=0.0;
     double d_arg_dV_g_si=0.0;
     double d_arg_dV_di_si=0.0;
  double sarg=0.0;
     double d_sarg_dV_g_di=0.0;
     double d_sarg_dV_e_si=0.0;
     double d_sarg_dV_e_di=0.0;
     double d_sarg_dV_g_e=0.0;
     double d_sarg_dV_g_si=0.0;
     double d_sarg_dV_di_si=0.0;
  double Qesj1=0.0;
     double d_Qesj1_dV_di_d=0.0;
     double d_Qesj1_dV_si_s=0.0;
     double d_Qesj1_dV_g_di=0.0;
     double d_Qesj1_dV_e_si=0.0;
     double d_Qesj1_dV_e_di=0.0;
     double d_Qesj1_dV_g_e=0.0;
     double d_Qesj1_dV_g_si=0.0;
     double d_Qesj1_dV_di_si=0.0;
  double T4a=0.0;
     double d_T4a_dV_g_di=0.0;
     double d_T4a_dV_di_si=0.0;
     double d_T4a_dV_e_si=0.0;
     double d_T4a_dV_e_di=0.0;
     double d_T4a_dV_g_e=0.0;
     double d_T4a_dV_g_si=0.0;
  double T1_exp=0.0;
     double d_T1_exp_dV_g_di=0.0;
     double d_T1_exp_dV_e_si=0.0;
     double d_T1_exp_dV_e_di=0.0;
     double d_T1_exp_dV_g_e=0.0;
     double d_T1_exp_dV_g_si=0.0;
     double d_T1_exp_dV_di_si=0.0;
  double Vdseffx=0.0;
     double d_Vdseffx_dV_di_si=0.0;
     double d_Vdseffx_dV_e_si=0.0;
     double d_Vdseffx_dV_e_di=0.0;
     double d_Vdseffx_dV_g_e=0.0;
     double d_Vdseffx_dV_g_si=0.0;
  double igc0=0.0;
     double d_igc0_dV_g_di=0.0;
     double d_igc0_dV_di_si=0.0;
     double d_igc0_dV_e_si=0.0;
     double d_igc0_dV_e_di=0.0;
     double d_igc0_dV_g_e=0.0;
     double d_igc0_dV_g_si=0.0;
     double d_igc0_dV_di_d=0.0;
     double d_igc0_dV_si_s=0.0;
  double Voxacc=0.0;
     double d_Voxacc_dV_g_di=0.0;
     double d_Voxacc_dV_e_si=0.0;
     double d_Voxacc_dV_e_di=0.0;
     double d_Voxacc_dV_g_e=0.0;
     double d_Voxacc_dV_g_si=0.0;
     double d_Voxacc_dV_di_si=0.0;
  double Vaux_Igbacc=0.0;
     double d_Vaux_Igbacc_dV_g_di=0.0;
     double d_Vaux_Igbacc_dV_e_si=0.0;
     double d_Vaux_Igbacc_dV_e_di=0.0;
     double d_Vaux_Igbacc_dV_g_e=0.0;
     double d_Vaux_Igbacc_dV_g_si=0.0;
     double d_Vaux_Igbacc_dV_di_si=0.0;
  double vfbzb=0.0;
  double Vaux_Igbinv=0.0;
     double d_Vaux_Igbinv_dV_g_di=0.0;
     double d_Vaux_Igbinv_dV_e_si=0.0;
     double d_Vaux_Igbinv_dV_e_di=0.0;
     double d_Vaux_Igbinv_dV_g_e=0.0;
     double d_Vaux_Igbinv_dV_g_si=0.0;
     double d_Vaux_Igbinv_dV_di_si=0.0;
  double ALPHAII=0.0;
  double VgsStep=0.0;
     double d_VgsStep_dV_g_di=0.0;
     double d_VgsStep_dV_e_si=0.0;
     double d_VgsStep_dV_e_di=0.0;
     double d_VgsStep_dV_g_e=0.0;
     double d_VgsStep_dV_g_si=0.0;
     double d_VgsStep_dV_di_si=0.0;
  double Vdsatii=0.0;
     double d_Vdsatii_dV_g_di=0.0;
     double d_Vdsatii_dV_e_si=0.0;
     double d_Vdsatii_dV_e_di=0.0;
     double d_Vdsatii_dV_g_e=0.0;
     double d_Vdsatii_dV_g_si=0.0;
     double d_Vdsatii_dV_di_si=0.0;
  double Vdiff=0.0;
     double d_Vdiff_dV_di_si=0.0;
     double d_Vdiff_dV_g_di=0.0;
     double d_Vdiff_dV_e_si=0.0;
     double d_Vdiff_dV_e_di=0.0;
     double d_Vdiff_dV_g_e=0.0;
     double d_Vdiff_dV_g_si=0.0;
  double Ratio=0.0;
     double d_Ratio_dV_g_di=0.0;
     double d_Ratio_dV_g_e=0.0;
     double d_Ratio_dV_g_si=0.0;
     double d_Ratio_dV_e_si=0.0;
     double d_Ratio_dV_e_di=0.0;
     double d_Ratio_dV_di_si=0.0;
  double cgsp=0.0;
     double d_cgsp_dV_g_di=0.0;
     double d_cgsp_dV_e_si=0.0;
     double d_cgsp_dV_e_di=0.0;
     double d_cgsp_dV_g_e=0.0;
     double d_cgsp_dV_g_si=0.0;
     double d_cgsp_dV_di_si=0.0;
  double cgdp=0.0;
     double d_cgdp_dV_g_di=0.0;
     double d_cgdp_dV_e_si=0.0;
     double d_cgdp_dV_e_di=0.0;
     double d_cgdp_dV_g_e=0.0;
     double d_cgdp_dV_g_si=0.0;
     double d_cgdp_dV_di_si=0.0;
  double vgd_overlap=0.0;
     double d_vgd_overlap_dV_g_di=0.0;
     double d_vgd_overlap_dV_e_si=0.0;
     double d_vgd_overlap_dV_e_di=0.0;
     double d_vgd_overlap_dV_g_e=0.0;
     double d_vgd_overlap_dV_g_si=0.0;
     double d_vgd_overlap_dV_di_si=0.0;
  double vgs_overlap=0.0;
     double d_vgs_overlap_dV_g_di=0.0;
     double d_vgs_overlap_dV_e_si=0.0;
     double d_vgs_overlap_dV_e_di=0.0;
     double d_vgs_overlap_dV_g_e=0.0;
     double d_vgs_overlap_dV_g_si=0.0;
     double d_vgs_overlap_dV_di_si=0.0;
  double qgd_ov=0.0;
     double d_qgd_ov_dV_g_di=0.0;
     double d_qgd_ov_dV_e_si=0.0;
     double d_qgd_ov_dV_e_di=0.0;
     double d_qgd_ov_dV_g_e=0.0;
     double d_qgd_ov_dV_g_si=0.0;
     double d_qgd_ov_dV_di_si=0.0;
  double qgs_ov=0.0;
     double d_qgs_ov_dV_g_di=0.0;
     double d_qgs_ov_dV_e_si=0.0;
     double d_qgs_ov_dV_e_di=0.0;
     double d_qgs_ov_dV_g_e=0.0;
     double d_qgs_ov_dV_g_si=0.0;
     double d_qgs_ov_dV_di_si=0.0;
  double qinv=0.0;
     double d_qinv_dV_di_si=0.0;
     double d_qinv_dV_e_si=0.0;
     double d_qinv_dV_e_di=0.0;
     double d_qinv_dV_g_e=0.0;
     double d_qinv_dV_g_si=0.0;
     double d_qinv_dV_g_di=0.0;
  double inv_MclmCV=0.0;
     double d_inv_MclmCV_dV_di_si=0.0;
     double d_inv_MclmCV_dV_e_si=0.0;
     double d_inv_MclmCV_dV_e_di=0.0;
     double d_inv_MclmCV_dV_g_e=0.0;
     double d_inv_MclmCV_dV_g_si=0.0;
  double dqi_idscv=0.0;
     double d_dqi_idscv_dV_di_si=0.0;
     double d_dqi_idscv_dV_e_si=0.0;
     double d_dqi_idscv_dV_e_di=0.0;
     double d_dqi_idscv_dV_g_e=0.0;
     double d_dqi_idscv_dV_g_si=0.0;
  double beta_cv=0.0;
  double idscv=0.0;
     double d_idscv_dV_di_si=0.0;
     double d_idscv_dV_e_si=0.0;
     double d_idscv_dV_e_di=0.0;
     double d_idscv_dV_g_e=0.0;
     double d_idscv_dV_g_si=0.0;
  double Tcom=0.0;
     double d_Tcom_dV_di_si=0.0;
     double d_Tcom_dV_e_si=0.0;
     double d_Tcom_dV_e_di=0.0;
     double d_Tcom_dV_g_e=0.0;
     double d_Tcom_dV_g_si=0.0;
  double vgd_eff=0.0;
     double d_vgd_eff_dV_g_di=0.0;
     double d_vgd_eff_dV_g_e=0.0;
     double d_vgd_eff_dV_g_si=0.0;
     double d_vgd_eff_dV_e_si=0.0;
     double d_vgd_eff_dV_e_di=0.0;
     double d_vgd_eff_dV_di_si=0.0;
  double vgs_eff=0.0;
     double d_vgs_eff_dV_g_di=0.0;
     double d_vgs_eff_dV_g_e=0.0;
     double d_vgs_eff_dV_g_si=0.0;
     double d_vgs_eff_dV_e_si=0.0;
     double d_vgs_eff_dV_e_di=0.0;
     double d_vgs_eff_dV_di_si=0.0;
  double Dr=0.0;
     double d_Dr_dV_e_si=0.0;
     double d_Dr_dV_e_di=0.0;
     double d_Dr_dV_g_e=0.0;
     double d_Dr_dV_g_si=0.0;
     double d_Dr_dV_di_si=0.0;
     double d_Dr_dV_g_di=0.0;
  double Rdsi=0.0;
     double d_Rdsi_dV_g_di=0.0;
     double d_Rdsi_dV_e_si=0.0;
     double d_Rdsi_dV_e_di=0.0;
     double d_Rdsi_dV_g_e=0.0;
     double d_Rdsi_dV_g_si=0.0;
     double d_Rdsi_dV_di_si=0.0;
  double ids0_ov_dqi=0.0;
     double d_ids0_ov_dqi_dV_g_di=0.0;
     double d_ids0_ov_dqi_dV_di_si=0.0;
     double d_ids0_ov_dqi_dV_g_e=0.0;
     double d_ids0_ov_dqi_dV_g_si=0.0;
     double d_ids0_ov_dqi_dV_e_si=0.0;
     double d_ids0_ov_dqi_dV_e_di=0.0;
  double ids0=0.0;
     double d_ids0_dV_g_di=0.0;
     double d_ids0_dV_e_si=0.0;
     double d_ids0_dV_e_di=0.0;
     double d_ids0_dV_g_e=0.0;
     double d_ids0_dV_g_si=0.0;
     double d_ids0_dV_di_si=0.0;
  double MclmCV=0.0;
     double d_MclmCV_dV_di_si=0.0;
     double d_MclmCV_dV_e_si=0.0;
     double d_MclmCV_dV_e_di=0.0;
     double d_MclmCV_dV_g_e=0.0;
     double d_MclmCV_dV_g_si=0.0;
  double DvsatCV=0.0;
     double d_DvsatCV_dV_e_si=0.0;
     double d_DvsatCV_dV_e_di=0.0;
     double d_DvsatCV_dV_g_e=0.0;
     double d_DvsatCV_dV_g_si=0.0;
     double d_DvsatCV_dV_di_si=0.0;
  double EsatCVL=0.0;
     double d_EsatCVL_dV_g_e=0.0;
     double d_EsatCVL_dV_g_si=0.0;
     double d_EsatCVL_dV_e_si=0.0;
     double d_EsatCVL_dV_e_di=0.0;
     double d_EsatCVL_dV_di_si=0.0;
  double EsatCV=0.0;
     double d_EsatCV_dV_g_e=0.0;
     double d_EsatCV_dV_g_si=0.0;
     double d_EsatCV_dV_e_si=0.0;
     double d_EsatCV_dV_e_di=0.0;
     double d_EsatCV_dV_di_si=0.0;
  double Mob=0.0;
     double d_Mob_dV_e_si=0.0;
     double d_Mob_dV_e_di=0.0;
     double d_Mob_dV_g_e=0.0;
     double d_Mob_dV_g_si=0.0;
     double d_Mob_dV_di_si=0.0;
  double Mnud=0.0;
     double d_Mnud_dV_e_si=0.0;
     double d_Mnud_dV_e_di=0.0;
     double d_Mnud_dV_g_e=0.0;
     double d_Mnud_dV_g_si=0.0;
     double d_Mnud_dV_di_si=0.0;
  double Nsat=0.0;
     double d_Nsat_dV_g_e=0.0;
     double d_Nsat_dV_g_si=0.0;
     double d_Nsat_dV_e_si=0.0;
     double d_Nsat_dV_e_di=0.0;
     double d_Nsat_dV_di_si=0.0;
  double Dvsat=0.0;
     double d_Dvsat_dV_e_si=0.0;
     double d_Dvsat_dV_e_di=0.0;
     double d_Dvsat_dV_g_e=0.0;
     double d_Dvsat_dV_g_si=0.0;
     double d_Dvsat_dV_di_si=0.0;
  double Esat1L=0.0;
     double d_Esat1L_dV_di_si=0.0;
     double d_Esat1L_dV_g_e=0.0;
     double d_Esat1L_dV_g_si=0.0;
     double d_Esat1L_dV_e_si=0.0;
     double d_Esat1L_dV_e_di=0.0;
  double Esat1=0.0;
     double d_Esat1_dV_di_si=0.0;
     double d_Esat1_dV_g_e=0.0;
     double d_Esat1_dV_g_si=0.0;
     double d_Esat1_dV_e_si=0.0;
     double d_Esat1_dV_e_di=0.0;
  double Mclm=0.0;
     double d_Mclm_dV_e_si=0.0;
     double d_Mclm_dV_e_di=0.0;
     double d_Mclm_dV_g_e=0.0;
     double d_Mclm_dV_g_si=0.0;
     double d_Mclm_dV_di_si=0.0;
  double Moc=0.0;
     double d_Moc_dV_di_si=0.0;
     double d_Moc_dV_e_si=0.0;
     double d_Moc_dV_e_di=0.0;
     double d_Moc_dV_g_e=0.0;
     double d_Moc_dV_g_si=0.0;
  double VaDIBL=0.0;
     double d_VaDIBL_dV_e_si=0.0;
     double d_VaDIBL_dV_e_di=0.0;
     double d_VaDIBL_dV_g_e=0.0;
     double d_VaDIBL_dV_g_si=0.0;
     double d_VaDIBL_dV_di_si=0.0;
  double Vgst2Vtm=0.0;
     double d_Vgst2Vtm_dV_di_si=0.0;
     double d_Vgst2Vtm_dV_e_si=0.0;
     double d_Vgst2Vtm_dV_e_di=0.0;
     double d_Vgst2Vtm_dV_g_e=0.0;
     double d_Vgst2Vtm_dV_g_si=0.0;
  double diffVds=0.0;
     double d_diffVds_dV_di_si=0.0;
     double d_diffVds_dV_e_si=0.0;
     double d_diffVds_dV_e_di=0.0;
     double d_diffVds_dV_g_e=0.0;
     double d_diffVds_dV_g_si=0.0;
  double PVAGfactor=0.0;
     double d_PVAGfactor_dV_di_si=0.0;
     double d_PVAGfactor_dV_e_si=0.0;
     double d_PVAGfactor_dV_e_di=0.0;
     double d_PVAGfactor_dV_g_e=0.0;
     double d_PVAGfactor_dV_g_si=0.0;
  double DIBLfactor=0.0;
     double d_DIBLfactor_dV_di_si=0.0;
  double Dmob_cv=0.0;
     double d_Dmob_cv_dV_g_e=0.0;
     double d_Dmob_cv_dV_g_si=0.0;
     double d_Dmob_cv_dV_e_si=0.0;
     double d_Dmob_cv_dV_e_di=0.0;
     double d_Dmob_cv_dV_di_si=0.0;
  double Eeffm_cv=0.0;
     double d_Eeffm_cv_dV_di_si=0.0;
     double d_Eeffm_cv_dV_e_si=0.0;
     double d_Eeffm_cv_dV_e_di=0.0;
     double d_Eeffm_cv_dV_g_e=0.0;
     double d_Eeffm_cv_dV_g_si=0.0;
  double ueff=0.0;
     double d_ueff_dV_g_e=0.0;
     double d_ueff_dV_g_si=0.0;
     double d_ueff_dV_e_si=0.0;
     double d_ueff_dV_e_di=0.0;
     double d_ueff_dV_di_si=0.0;
  double Dmob=0.0;
     double d_Dmob_dV_g_e=0.0;
     double d_Dmob_dV_g_si=0.0;
     double d_Dmob_dV_e_si=0.0;
     double d_Dmob_dV_e_di=0.0;
     double d_Dmob_dV_di_si=0.0;
  double Eeffm=0.0;
     double d_Eeffm_dV_di_si=0.0;
     double d_Eeffm_dV_e_si=0.0;
     double d_Eeffm_dV_e_di=0.0;
     double d_Eeffm_dV_g_e=0.0;
     double d_Eeffm_dV_g_si=0.0;
  double beta=0.0;
     double d_beta_dV_e_si=0.0;
     double d_beta_dV_e_di=0.0;
     double d_beta_dV_g_e=0.0;
     double d_beta_dV_g_si=0.0;
     double d_beta_dV_di_si=0.0;
  double coxeff=0.0;
     double d_coxeff_dV_e_si=0.0;
     double d_coxeff_dV_e_di=0.0;
     double d_coxeff_dV_g_e=0.0;
     double d_coxeff_dV_g_si=0.0;
     double d_coxeff_dV_di_si=0.0;
  double qia2=0.0;
     double d_qia2_dV_di_si=0.0;
     double d_qia2_dV_e_si=0.0;
     double d_qia2_dV_e_di=0.0;
     double d_qia2_dV_g_e=0.0;
     double d_qia2_dV_g_si=0.0;
  double dqi=0.0;
     double d_dqi_dV_di_si=0.0;
     double d_dqi_dV_e_si=0.0;
     double d_dqi_dV_e_di=0.0;
     double d_dqi_dV_g_e=0.0;
     double d_dqi_dV_g_si=0.0;
  double qia=0.0;
     double d_qia_dV_di_si=0.0;
     double d_qia_dV_e_si=0.0;
     double d_qia_dV_e_di=0.0;
     double d_qia_dV_g_e=0.0;
     double d_qia_dV_g_si=0.0;
  double qba=0.0;
  double phid=0.0;
     double d_phid_dV_di_si=0.0;
     double d_phid_dV_e_si=0.0;
     double d_phid_dV_e_di=0.0;
     double d_phid_dV_g_e=0.0;
     double d_phid_dV_g_si=0.0;
  double vpolyd=0.0;
     double d_vpolyd_dV_di_si=0.0;
     double d_vpolyd_dV_e_si=0.0;
     double d_vpolyd_dV_e_di=0.0;
     double d_vpolyd_dV_g_e=0.0;
     double d_vpolyd_dV_g_si=0.0;
  double Vdseff=0.0;
     double d_Vdseff_dV_di_si=0.0;
     double d_Vdseff_dV_e_si=0.0;
     double d_Vdseff_dV_e_di=0.0;
     double d_Vdseff_dV_g_e=0.0;
     double d_Vdseff_dV_g_si=0.0;
  double Vdsat=0.0;
     double d_Vdsat_dV_g_e=0.0;
     double d_Vdsat_dV_g_si=0.0;
     double d_Vdsat_dV_e_si=0.0;
     double d_Vdsat_dV_e_di=0.0;
     double d_Vdsat_dV_di_si=0.0;
  double Tc=0.0;
     double d_Tc_dV_g_si=0.0;
     double d_Tc_dV_di_si=0.0;
     double d_Tc_dV_e_si=0.0;
     double d_Tc_dV_e_di=0.0;
     double d_Tc_dV_g_e=0.0;
  double Ta=0.0;
     double d_Ta_dV_e_si=0.0;
     double d_Ta_dV_e_di=0.0;
     double d_Ta_dV_g_e=0.0;
     double d_Ta_dV_g_si=0.0;
     double d_Ta_dV_di_si=0.0;
  double WVCox=0.0;
  double T6=0.0;
     double d_T6_dV_g_di=0.0;
     double d_T6_dV_di_d=0.0;
     double d_T6_dV_si_s=0.0;
     double d_T6_dV_g_si=0.0;
     double d_T6_dV_di_si=0.0;
     double d_T6_dV_e_si=0.0;
     double d_T6_dV_e_di=0.0;
     double d_T6_dV_g_e=0.0;
  double EsatL=0.0;
     double d_EsatL_dV_g_e=0.0;
     double d_EsatL_dV_g_si=0.0;
     double d_EsatL_dV_e_si=0.0;
     double d_EsatL_dV_e_di=0.0;
     double d_EsatL_dV_di_si=0.0;
  double Esat=0.0;
     double d_Esat_dV_g_e=0.0;
     double d_Esat_dV_g_si=0.0;
     double d_Esat_dV_e_si=0.0;
     double d_Esat_dV_e_di=0.0;
     double d_Esat_dV_di_si=0.0;
  double Rdss=0.0;
     double d_Rdss_dV_e_si=0.0;
     double d_Rdss_dV_e_di=0.0;
     double d_Rdss_dV_g_e=0.0;
     double d_Rdss_dV_g_si=0.0;
     double d_Rdss_dV_di_si=0.0;
  double Dmobs=0.0;
     double d_Dmobs_dV_g_e=0.0;
     double d_Dmobs_dV_g_si=0.0;
     double d_Dmobs_dV_e_si=0.0;
     double d_Dmobs_dV_e_di=0.0;
     double d_Dmobs_dV_di_si=0.0;
  double qb0=0.0;
  double Eeffs=0.0;
     double d_Eeffs_dV_di_si=0.0;
     double d_Eeffs_dV_e_si=0.0;
     double d_Eeffs_dV_e_di=0.0;
     double d_Eeffs_dV_g_e=0.0;
     double d_Eeffs_dV_g_si=0.0;
  double phis=0.0;
     double d_phis_dV_di_si=0.0;
     double d_phis_dV_e_si=0.0;
     double d_phis_dV_e_di=0.0;
     double d_phis_dV_g_e=0.0;
     double d_phis_dV_g_si=0.0;
  double TA=0.0;
     double d_TA_dV_e_si=0.0;
     double d_TA_dV_e_di=0.0;
     double d_TA_dV_g_e=0.0;
     double d_TA_dV_g_si=0.0;
     double d_TA_dV_di_si=0.0;
  double T9=0.0;
     double d_T9_dV_e_si=0.0;
     double d_T9_dV_e_di=0.0;
     double d_T9_dV_g_e=0.0;
     double d_T9_dV_g_si=0.0;
     double d_T9_dV_di_si=0.0;
  double T8=0.0;
     double d_T8_dV_e_si=0.0;
     double d_T8_dV_e_di=0.0;
     double d_T8_dV_g_e=0.0;
     double d_T8_dV_g_si=0.0;
     double d_T8_dV_di_si=0.0;
  double T7=0.0;
     double d_T7_dV_e_si=0.0;
     double d_T7_dV_e_di=0.0;
     double d_T7_dV_g_e=0.0;
     double d_T7_dV_g_si=0.0;
     double d_T7_dV_di_si=0.0;
  double T5=0.0;
     double d_T5_dV_g_di=0.0;
     double d_T5_dV_di_d=0.0;
     double d_T5_dV_si_s=0.0;
     double d_T5_dV_e_si=0.0;
     double d_T5_dV_e_di=0.0;
     double d_T5_dV_g_e=0.0;
     double d_T5_dV_g_si=0.0;
     double d_T5_dV_di_si=0.0;
  double T4=0.0;
     double d_T4_dV_g_di=0.0;
     double d_T4_dV_di_si=0.0;
     double d_T4_dV_e_si=0.0;
     double d_T4_dV_e_di=0.0;
     double d_T4_dV_g_e=0.0;
     double d_T4_dV_g_si=0.0;
  double secg0=0.0;
     double d_secg0_dV_e_si=0.0;
     double d_secg0_dV_e_di=0.0;
     double d_secg0_dV_g_e=0.0;
     double d_secg0_dV_g_si=0.0;
     double d_secg0_dV_di_si=0.0;
  double cosg0=0.0;
     double d_cosg0_dV_e_si=0.0;
     double d_cosg0_dV_e_di=0.0;
     double d_cosg0_dV_g_e=0.0;
     double d_cosg0_dV_g_si=0.0;
     double d_cosg0_dV_di_si=0.0;
  double guessB=0.0;
     double d_guessB_dV_e_si=0.0;
     double d_guessB_dV_e_di=0.0;
     double d_guessB_dV_g_e=0.0;
     double d_guessB_dV_g_si=0.0;
     double d_guessB_dV_di_si=0.0;
  double guessA=0.0;
     double d_guessA_dV_e_si=0.0;
     double d_guessA_dV_e_di=0.0;
     double d_guessA_dV_g_e=0.0;
     double d_guessA_dV_g_si=0.0;
     double d_guessA_dV_di_si=0.0;
  double vpolys=0.0;
     double d_vpolys_dV_di_si=0.0;
     double d_vpolys_dV_e_si=0.0;
     double d_vpolys_dV_e_di=0.0;
     double d_vpolys_dV_g_e=0.0;
     double d_vpolys_dV_g_si=0.0;
  double vch=0.0;
     double d_vch_dV_di_si=0.0;
     double d_vch_dV_e_si=0.0;
     double d_vch_dV_e_di=0.0;
     double d_vch_dV_g_e=0.0;
     double d_vch_dV_g_si=0.0;
  double tang0a=0.0;
     double d_tang0a_dV_g_e=0.0;
     double d_tang0a_dV_g_si=0.0;
     double d_tang0a_dV_di_si=0.0;
  double g0a=0.0;
     double d_g0a_dV_e_si=0.0;
     double d_g0a_dV_e_di=0.0;
     double d_g0a_dV_g_e=0.0;
     double d_g0a_dV_g_si=0.0;
     double d_g0a_dV_di_si=0.0;
  double e3=0.0;
     double d_e3_dV_e_si=0.0;
     double d_e3_dV_e_di=0.0;
     double d_e3_dV_g_e=0.0;
     double d_e3_dV_g_si=0.0;
     double d_e3_dV_di_si=0.0;
  double e2=0.0;
     double d_e2_dV_e_si=0.0;
     double d_e2_dV_e_di=0.0;
     double d_e2_dV_g_e=0.0;
     double d_e2_dV_g_si=0.0;
     double d_e2_dV_di_si=0.0;
  double e1=0.0;
     double d_e1_dV_e_si=0.0;
     double d_e1_dV_e_di=0.0;
     double d_e1_dV_g_e=0.0;
     double d_e1_dV_g_si=0.0;
     double d_e1_dV_di_si=0.0;
  double e0=0.0;
     double d_e0_dV_e_si=0.0;
     double d_e0_dV_e_di=0.0;
     double d_e0_dV_g_e=0.0;
     double d_e0_dV_g_si=0.0;
     double d_e0_dV_di_si=0.0;
  double inv_g0=0.0;
     double d_inv_g0_dV_e_si=0.0;
     double d_inv_g0_dV_e_di=0.0;
     double d_inv_g0_dV_g_e=0.0;
     double d_inv_g0_dV_g_si=0.0;
     double d_inv_g0_dV_di_si=0.0;
  double lncosg0=0.0;
     double d_lncosg0_dV_e_si=0.0;
     double d_lncosg0_dV_e_di=0.0;
     double d_lncosg0_dV_g_e=0.0;
     double d_lncosg0_dV_g_si=0.0;
     double d_lncosg0_dV_di_si=0.0;
  double secg0sq=0.0;
     double d_secg0sq_dV_e_si=0.0;
     double d_secg0sq_dV_e_di=0.0;
     double d_secg0sq_dV_g_e=0.0;
     double d_secg0sq_dV_g_si=0.0;
     double d_secg0sq_dV_di_si=0.0;
  double lng0=0.0;
     double d_lng0_dV_e_si=0.0;
     double d_lng0_dV_e_di=0.0;
     double d_lng0_dV_g_e=0.0;
     double d_lng0_dV_g_si=0.0;
     double d_lng0_dV_di_si=0.0;
  double tang0=0.0;
     double d_tang0_dV_e_si=0.0;
     double d_tang0_dV_e_di=0.0;
     double d_tang0_dV_g_e=0.0;
     double d_tang0_dV_g_si=0.0;
     double d_tang0_dV_di_si=0.0;
  double g0=0.0;
     double d_g0_dV_di_d=0.0;
     double d_g0_dV_si_s=0.0;
     double d_g0_dV_g_di=0.0;
     double d_g0_dV_e_si=0.0;
     double d_g0_dV_e_di=0.0;
     double d_g0_dV_g_e=0.0;
     double d_g0_dV_g_si=0.0;
     double d_g0_dV_di_si=0.0;
  double z2=0.0;
     double d_z2_dV_e_si=0.0;
     double d_z2_dV_e_di=0.0;
     double d_z2_dV_g_e=0.0;
     double d_z2_dV_g_si=0.0;
     double d_z2_dV_di_si=0.0;
  double z1=0.0;
     double d_z1_dV_e_si=0.0;
     double d_z1_dV_e_di=0.0;
     double d_z1_dV_g_e=0.0;
     double d_z1_dV_g_si=0.0;
     double d_z1_dV_di_si=0.0;
  double expff=0.0;
     double d_expff_dV_e_si=0.0;
     double d_expff_dV_e_di=0.0;
     double d_expff_dV_g_e=0.0;
     double d_expff_dV_g_si=0.0;
     double d_expff_dV_di_si=0.0;
  double F0=0.0;
     double d_F0_dV_di_d=0.0;
     double d_F0_dV_si_s=0.0;
     double d_F0_dV_g_di=0.0;
     double d_F0_dV_e_si=0.0;
     double d_F0_dV_e_di=0.0;
     double d_F0_dV_g_e=0.0;
     double d_F0_dV_g_si=0.0;
     double d_F0_dV_di_si=0.0;
  double inv_g0sq=0.0;
     double d_inv_g0sq_dV_e_si=0.0;
     double d_inv_g0sq_dV_e_di=0.0;
     double d_inv_g0sq_dV_g_e=0.0;
     double d_inv_g0sq_dV_g_si=0.0;
     double d_inv_g0sq_dV_di_si=0.0;
  double vgsfbeff=0.0;
     double d_vgsfbeff_dV_g_si=0.0;
     double d_vgsfbeff_dV_di_si=0.0;
  double cdop=0.0;
     double d_cdop_dV_di_si=0.0;
  double vtdop_acc=0.0;
     double d_vtdop_acc_dV_di_si=0.0;
  double vtdop=0.0;
     double d_vtdop_dV_di_si=0.0;
  double dvth_all=0.0;
     double d_dvth_all_dV_di_si=0.0;
  double dvth_rsce=0.0;
  double dvth_dibl=0.0;
     double d_dvth_dibl_dV_di_si=0.0;
  double dvth_vtroll=0.0;
  double nVtm=0.0;
     double d_nVtm_dV_di_si=0.0;
  double cdsc=0.0;
     double d_cdsc_dV_di_si=0.0;
  double phist=0.0;
  double inv_MEXP=0.0;
     double d_inv_MEXP_dV_di_si=0.0;
  double RDDR_a=0.0;
     double d_RDDR_a_dV_di_si=0.0;
  double RSDR_a=0.0;
     double d_RSDR_a_dV_di_si=0.0;
  double VSAT1_a=0.0;
     double d_VSAT1_a_dV_di_si=0.0;
  double PTWG_a=0.0;
     double d_PTWG_a_dV_di_si=0.0;
  double MEXP_a=0.0;
     double d_MEXP_a_dV_di_si=0.0;
  double PDIBL1_a=0.0;
     double d_PDIBL1_a_dV_di_si=0.0;
  double ETA0_a=0.0;
     double d_ETA0_a_dV_di_si=0.0;
  double CDSCD_a=0.0;
     double d_CDSCD_a_dV_di_si=0.0;
  double wr=0.0;
     double d_wr_dV_di_si=0.0;
  double wf=0.0;
     double d_wf_dV_di_si=0.0;
  double veseff=0.0;
     double d_veseff_dV_e_si=0.0;
     double d_veseff_dV_e_di=0.0;
     double d_veseff_dV_di_si=0.0;
  double vesmax=0.0;
  double vesx=0.0;
     double d_vesx_dV_e_si=0.0;
     double d_vesx_dV_e_di=0.0;
     double d_vesx_dV_di_si=0.0;
  double vdsx=0.0;
     double d_vdsx_dV_di_si=0.0;
  double Qedj=0.0;
     double d_Qedj_dV_di_d=0.0;
     double d_Qedj_dV_si_s=0.0;
     double d_Qedj_dV_g_di=0.0;
     double d_Qedj_dV_e_si=0.0;
     double d_Qedj_dV_e_di=0.0;
     double d_Qedj_dV_g_e=0.0;
     double d_Qedj_dV_g_si=0.0;
     double d_Qedj_dV_di_si=0.0;
  double Qesj=0.0;
     double d_Qesj_dV_di_d=0.0;
     double d_Qesj_dV_si_s=0.0;
     double d_Qesj_dV_g_di=0.0;
     double d_Qesj_dV_e_si=0.0;
     double d_Qesj_dV_e_di=0.0;
     double d_Qesj_dV_g_e=0.0;
     double d_Qesj_dV_g_si=0.0;
     double d_Qesj_dV_di_si=0.0;
  double etaiv=0.0;
     double d_etaiv_dV_di_si=0.0;
     double d_etaiv_dV_e_si=0.0;
     double d_etaiv_dV_e_di=0.0;
     double d_etaiv_dV_g_e=0.0;
     double d_etaiv_dV_g_si=0.0;
  double vgsfb=0.0;
     double d_vgsfb_dV_g_si=0.0;
     double d_vgsfb_dV_di_si=0.0;
  double ves=0.0;
     double d_ves_dV_e_si=0.0;
     double d_ves_dV_e_di=0.0;
  double vgd=0.0;
  double vds=0.0;
     double d_vds_dV_di_si=0.0;
  double vgs=0.0;
     double d_vgs_dV_g_si=0.0;
     double d_vgs_dV_di_si=0.0;
  double vge=0.0;
     double d_vge_dV_g_e=0.0;
  double ved_jct=0.0;
     double d_ved_jct_dV_e_di=0.0;
  double ves_jct=0.0;
     double d_ves_jct_dV_e_si=0.0;
  double vgd_noswap=0.0;
     double d_vgd_noswap_dV_g_di=0.0;
  double vds_noswap=0.0;
     double d_vds_noswap_dV_di_si=0.0;
  double vgs_noswap=0.0;
     double d_vgs_noswap_dV_g_si=0.0;
  double TRatio=0.0;
  double delTemp=0.0;
  double Vtm=0.0;
  double Vtm0=0.0;
  double Eg=0.0;
  double Eg0=0.0;
  double ni=0.0;
  double Nc=0.0;
  double ThetaSS=0.0;
  double kT=0.0;
  double E0=0.0;
  double E0prime=0.0;
  double E1=0.0;
  double E1prime=0.0;
  double gam0=0.0;
  double gam1=0.0;
  double dvch_qm=0.0;
  double ETA0_t=0.0;
  double ETA0R_t=0.0;
  double U0_t=0.0;
  double u0=0.0;
  double ETAMOB_t=0.0;
  double UA_t=0.0;
  double UC_t=0.0;
  double UD_t=0.0;
  double UCS_t=0.0;
  double rdstemp=0.0;
  double RSDR_t=0.0;
  double RSDRR_t=0.0;
  double RDDR_t=0.0;
  double RDDRR_t=0.0;
  double VSAT_t=0.0;
  double VSAT1_t=0.0;
  double VSAT1R_t=0.0;
  double VSATCV_t=0.0;
  double MEXP_t=0.0;
  double MEXPR_t=0.0;
  double PTWG_t=0.0;
  double PTWGR_t=0.0;
  double dvth_temp=0.0;
  double BETA0_t=0.0;
  double SII0_t=0.0;
  double K0_t=0.0;
  double K0SI_t=0.0;
  double K1SI_t=0.0;
  double K1_t=0.0;
  double K1SAT_t=0.0;
  double A1_t=0.0;
  double A2_t=0.0;
  double AIGBINV_t=0.0;
  double AIGBACC_t=0.0;
  double AIGC_t=0.0;
  double AIGS_t=0.0;
  double AIGD_t=0.0;
  double BGIDL_t=0.0;
  double BGISL_t=0.0;
  double ALPHA0_t=0.0;
  double ALPHA1_t=0.0;
  double ALPHAII0_t=0.0;
  double ALPHAII1_t=0.0;
  double igtemp=0.0;
  double igsd_mult=0.0;
  double beta0=0.0;
  double vfbsd=0.0;
  double phib=0.0;
  double vbi=0.0;
  double deltaPhi=0.0;
  double vpoly0=0.0;
  double cpoly=0.0;
  double kpoly=0.0;
  double g0max=0.0;
  double g0min=0.0;
  double r2=0.0;
  double eta_mu=0.0;
  double eta_mu_cv=0.0;
  double Tb=0.0;
     double d_Tb_dV_g_si=0.0;
     double d_Tb_dV_di_si=0.0;
     double d_Tb_dV_e_si=0.0;
     double d_Tb_dV_e_di=0.0;
     double d_Tb_dV_g_e=0.0;
  double igentemp=0.0;
  double DevTemp=0.0;
  int initialized=0.0;
  double R=0.0;
  double vgsfbeff_acc=0.0;
     double d_vgsfbeff_acc_dV_g_e=0.0;
     double d_vgsfbeff_acc_dV_g_si=0.0;
     double d_vgsfbeff_acc_dV_di_si=0.0;
  double vt0=0.0;
     double d_vt0_dV_di_si=0.0;
  double vt0_acc=0.0;
     double d_vt0_acc_dV_di_si=0.0;
  double F1=0.0;
     double d_F1_dV_di_si=0.0;
  double F1_acc=0.0;
  double cdop_acc=0.0;
     double d_cdop_acc_dV_di_si=0.0;
  double qid=0.0;
     double d_qid_dV_di_si=0.0;
     double d_qid_dV_e_si=0.0;
     double d_qid_dV_e_di=0.0;
     double d_qid_dV_g_e=0.0;
     double d_qid_dV_g_si=0.0;
  double qis=0.0;
     double d_qis_dV_di_si=0.0;
     double d_qis_dV_e_si=0.0;
     double d_qis_dV_e_di=0.0;
     double d_qis_dV_g_e=0.0;
     double d_qis_dV_g_si=0.0;
  double tang0d=0.0;
     double d_tang0d_dV_e_si=0.0;
     double d_tang0d_dV_e_di=0.0;
     double d_tang0d_dV_g_e=0.0;
     double d_tang0d_dV_g_si=0.0;
     double d_tang0d_dV_di_si=0.0;
  double tang0s=0.0;
     double d_tang0s_dV_e_si=0.0;
     double d_tang0s_dV_e_di=0.0;
     double d_tang0s_dV_g_e=0.0;
     double d_tang0s_dV_g_si=0.0;
     double d_tang0s_dV_di_si=0.0;
  double T11=0.0;
  double T12=0.0;
     double d_T12_dV_di_si=0.0;
  double T13=0.0;
     double d_T13_dV_di_si=0.0;
  double T14=0.0;
     double d_T14_dV_di_si=0.0;
  double ids=0.0;
     double d_ids_dV_e_si=0.0;
     double d_ids_dV_e_di=0.0;
     double d_ids_dV_g_e=0.0;
     double d_ids_dV_g_si=0.0;
     double d_ids_dV_di_si=0.0;
     double d_ids_dV_g_di=0.0;
  double sigvds=0.0;
  double Iii=0.0;
     double d_Iii_dV_g_di=0.0;
     double d_Iii_dV_e_si=0.0;
     double d_Iii_dV_e_di=0.0;
     double d_Iii_dV_g_e=0.0;
     double d_Iii_dV_g_si=0.0;
     double d_Iii_dV_di_si=0.0;
  double qd=0.0;
     double d_qd_dV_di_si=0.0;
     double d_qd_dV_e_si=0.0;
     double d_qd_dV_e_di=0.0;
     double d_qd_dV_g_e=0.0;
     double d_qd_dV_g_si=0.0;
     double d_qd_dV_g_di=0.0;
  double qg=0.0;
     double d_qg_dV_di_si=0.0;
     double d_qg_dV_e_si=0.0;
     double d_qg_dV_e_di=0.0;
     double d_qg_dV_g_e=0.0;
     double d_qg_dV_g_si=0.0;
     double d_qg_dV_g_di=0.0;
  double qs=0.0;
     double d_qs_dV_di_si=0.0;
     double d_qs_dV_e_si=0.0;
     double d_qs_dV_e_di=0.0;
     double d_qs_dV_g_e=0.0;
     double d_qs_dV_g_si=0.0;
     double d_qs_dV_g_di=0.0;
  double qb=0.0;
  double Qbul=0.0;
  double aab=0.0;
     double d_aab_dV_di_si=0.0;
  double Weff0=0.0;
  double WeffCV0=0.0;
  double Weff=0.0;
     double d_Weff_dV_e_si=0.0;
     double d_Weff_dV_e_di=0.0;
     double d_Weff_dV_g_e=0.0;
     double d_Weff_dV_g_si=0.0;
     double d_Weff_dV_di_si=0.0;
  double WeffCV=0.0;
     double d_WeffCV_dV_e_si=0.0;
     double d_WeffCV_dV_e_di=0.0;
     double d_WeffCV_dV_g_e=0.0;
     double d_WeffCV_dV_g_si=0.0;
     double d_WeffCV_dV_di_si=0.0;
  double CJS_t=0.0;
  double CJSWS_t=0.0;
  double CJSWGS_t=0.0;
  double CJD_t=0.0;
  double CJSWD_t=0.0;
  double CJSWGD_t=0.0;
  double PBS_t=0.0;
  double PBSWS_t=0.0;
  double PBSWGS_t=0.0;
  double PBD_t=0.0;
  double PBSWD_t=0.0;
  double PBSWGD_t=0.0;
  double JSS_t=0.0;
  double JSWS_t=0.0;
  double JSWGS_t=0.0;
  double JSD_t=0.0;
  double JSWD_t=0.0;
  double JSWGD_t=0.0;
  double JTSS_t=0.0;
  double JTSSWS_t=0.0;
  double JTSSWGS_t=0.0;
  double JTSD_t=0.0;
  double JTSSWD_t=0.0;
  double JTSSWGD_t=0.0;
  double NJTS_t=0.0;
  double NJTSSW_t=0.0;
  double NJTSSWG_t=0.0;
  double NJTSD_t=0.0;
  double NJTSSWD_t=0.0;
  double NJTSSWGD_t=0.0;
  double Ies=0.0;
     double d_Ies_dV_g_di=0.0;
     double d_Ies_dV_e_si=0.0;
     double d_Ies_dV_e_di=0.0;
     double d_Ies_dV_g_e=0.0;
     double d_Ies_dV_g_si=0.0;
     double d_Ies_dV_di_si=0.0;
  double Ied=0.0;
     double d_Ied_dV_g_di=0.0;
     double d_Ied_dV_e_si=0.0;
     double d_Ied_dV_e_di=0.0;
     double d_Ied_dV_g_e=0.0;
     double d_Ied_dV_g_si=0.0;
     double d_Ied_dV_di_si=0.0;
  double Czbs=0.0;
  double Czbssw=0.0;
  double Czbsswg=0.0;
  double Czbd=0.0;
  double Czbdsw=0.0;
  double Czbdswg=0.0;
  double Qes=0.0;
     double d_Qes_dV_di_d=0.0;
     double d_Qes_dV_si_s=0.0;
     double d_Qes_dV_g_di=0.0;
     double d_Qes_dV_e_si=0.0;
     double d_Qes_dV_e_di=0.0;
     double d_Qes_dV_g_e=0.0;
     double d_Qes_dV_g_si=0.0;
     double d_Qes_dV_di_si=0.0;
  double Qed=0.0;
     double d_Qed_dV_di_d=0.0;
     double d_Qed_dV_si_s=0.0;
     double d_Qed_dV_g_di=0.0;
     double d_Qed_dV_e_si=0.0;
     double d_Qed_dV_e_di=0.0;
     double d_Qed_dV_g_e=0.0;
     double d_Qed_dV_g_si=0.0;
     double d_Qed_dV_di_si=0.0;
  double Qeg=0.0;
     double d_Qeg_dV_g_di=0.0;
     double d_Qeg_dV_g_e=0.0;
     double d_Qeg_dV_g_si=0.0;
     double d_Qeg_dV_e_si=0.0;
     double d_Qeg_dV_e_di=0.0;
     double d_Qeg_dV_di_si=0.0;
     double d_Qeg_dV_e_g=0.0;
  double Isbs=0.0;
  double Isbd=0.0;
  double Nvtms=0.0;
  double Nvtmd=0.0;
  double SslpRev=0.0;
  double IVjsmRev=0.0;
  double VjsmRev=0.0;
  double SslpFwd=0.0;
  double IVjsmFwd=0.0;
  double VjsmFwd=0.0;
  double DslpRev=0.0;
  double IVjdmRev=0.0;
  double VjdmRev=0.0;
  double DslpFwd=0.0;
  double IVjdmFwd=0.0;
  double VjdmFwd=0.0;
  double XExpBVS=0.0;
  double XExpBVD=0.0;
  double idsgen=0.0;
     double d_idsgen_dV_g_di=0.0;
     double d_idsgen_dV_e_si=0.0;
     double d_idsgen_dV_e_di=0.0;
     double d_idsgen_dV_g_e=0.0;
     double d_idsgen_dV_g_si=0.0;
     double d_idsgen_dV_di_si=0.0;
  double phibulk=0.0;
  double phipert=0.0;
  double g0s=0.0;
     double d_g0s_dV_e_si=0.0;
     double d_g0s_dV_e_di=0.0;
     double d_g0s_dV_g_e=0.0;
     double d_g0s_dV_g_si=0.0;
     double d_g0s_dV_di_si=0.0;
  double g0d=0.0;
     double d_g0d_dV_e_si=0.0;
     double d_g0d_dV_e_di=0.0;
     double d_g0d_dV_g_e=0.0;
     double d_g0d_dV_g_si=0.0;
     double d_g0d_dV_di_si=0.0;
  double r1=0.0;
  double q0=0.0;
     double d_q0_dV_di_si=0.0;
  double F2=0.0;
  double Inv_r1pi=0.0;
  double Tcen=0.0;
     double d_Tcen_dV_e_si=0.0;
     double d_Tcen_dV_e_di=0.0;
     double d_Tcen_dV_g_e=0.0;
     double d_Tcen_dV_g_si=0.0;
     double d_Tcen_dV_di_si=0.0;
  double MTcen=0.0;
  double Rdrain=0.0;
     double d_Rdrain_dV_di_d=0.0;
     double d_Rdrain_dV_si_s=0.0;
     double d_Rdrain_dV_e_si=0.0;
     double d_Rdrain_dV_e_di=0.0;
     double d_Rdrain_dV_g_e=0.0;
     double d_Rdrain_dV_g_si=0.0;
     double d_Rdrain_dV_di_si=0.0;
     double d_Rdrain_dV_g_di=0.0;
  double Rsource=0.0;
     double d_Rsource_dV_di_d=0.0;
     double d_Rsource_dV_g_di=0.0;
     double d_Rsource_dV_si_s=0.0;
     double d_Rsource_dV_e_si=0.0;
     double d_Rsource_dV_e_di=0.0;
     double d_Rsource_dV_g_e=0.0;
     double d_Rsource_dV_g_si=0.0;
     double d_Rsource_dV_di_si=0.0;
  double Cfr_geo=0.0;
  double igbinv=0.0;
     double d_igbinv_dV_g_si=0.0;
     double d_igbinv_dV_di_si=0.0;
     double d_igbinv_dV_e_si=0.0;
     double d_igbinv_dV_e_di=0.0;
     double d_igbinv_dV_g_e=0.0;
     double d_igbinv_dV_g_di=0.0;
     double d_igbinv_dV_di_d=0.0;
     double d_igbinv_dV_si_s=0.0;
  double igbs=0.0;
     double d_igbs_dV_g_si=0.0;
     double d_igbs_dV_di_si=0.0;
     double d_igbs_dV_e_si=0.0;
     double d_igbs_dV_e_di=0.0;
     double d_igbs_dV_g_e=0.0;
     double d_igbs_dV_g_di=0.0;
     double d_igbs_dV_di_d=0.0;
     double d_igbs_dV_si_s=0.0;
  double igbd=0.0;
     double d_igbd_dV_g_si=0.0;
     double d_igbd_dV_di_si=0.0;
     double d_igbd_dV_e_si=0.0;
     double d_igbd_dV_e_di=0.0;
     double d_igbd_dV_g_e=0.0;
     double d_igbd_dV_g_di=0.0;
     double d_igbd_dV_di_d=0.0;
     double d_igbd_dV_si_s=0.0;
  double igbacc=0.0;
     double d_igbacc_dV_g_si=0.0;
     double d_igbacc_dV_di_si=0.0;
     double d_igbacc_dV_e_si=0.0;
     double d_igbacc_dV_e_di=0.0;
     double d_igbacc_dV_g_e=0.0;
     double d_igbacc_dV_g_di=0.0;
     double d_igbacc_dV_di_d=0.0;
     double d_igbacc_dV_si_s=0.0;
  double igcs=0.0;
     double d_igcs_dV_g_di=0.0;
     double d_igcs_dV_di_si=0.0;
     double d_igcs_dV_e_si=0.0;
     double d_igcs_dV_e_di=0.0;
     double d_igcs_dV_g_e=0.0;
     double d_igcs_dV_g_si=0.0;
     double d_igcs_dV_di_d=0.0;
     double d_igcs_dV_si_s=0.0;
  double igcd=0.0;
     double d_igcd_dV_g_di=0.0;
     double d_igcd_dV_di_si=0.0;
     double d_igcd_dV_e_si=0.0;
     double d_igcd_dV_e_di=0.0;
     double d_igcd_dV_g_e=0.0;
     double d_igcd_dV_g_si=0.0;
     double d_igcd_dV_di_d=0.0;
     double d_igcd_dV_si_s=0.0;
  double igidl=0.0;
     double d_igidl_dV_g_di=0.0;
     double d_igidl_dV_di_d=0.0;
     double d_igidl_dV_si_s=0.0;
     double d_igidl_dV_g_si=0.0;
     double d_igidl_dV_di_si=0.0;
     double d_igidl_dV_e_si=0.0;
     double d_igidl_dV_e_di=0.0;
     double d_igidl_dV_g_e=0.0;
  double igisl=0.0;
     double d_igisl_dV_g_di=0.0;
     double d_igisl_dV_di_d=0.0;
     double d_igisl_dV_si_s=0.0;
     double d_igisl_dV_g_si=0.0;
     double d_igisl_dV_di_si=0.0;
     double d_igisl_dV_e_si=0.0;
     double d_igisl_dV_e_di=0.0;
     double d_igisl_dV_g_e=0.0;
  double igs=0.0;
     double d_igs_dV_g_si=0.0;
     double d_igs_dV_g_di=0.0;
     double d_igs_dV_g_e=0.0;
     double d_igs_dV_e_si=0.0;
     double d_igs_dV_e_di=0.0;
     double d_igs_dV_di_si=0.0;
  double igd=0.0;
     double d_igd_dV_g_si=0.0;
     double d_igd_dV_g_di=0.0;
     double d_igd_dV_g_e=0.0;
     double d_igd_dV_e_si=0.0;
     double d_igd_dV_e_di=0.0;
     double d_igd_dV_di_si=0.0;
  double cox_acc=0.0;
     double d_cox_acc_dV_e_si=0.0;
     double d_cox_acc_dV_e_di=0.0;
     double d_cox_acc_dV_g_e=0.0;
     double d_cox_acc_dV_g_si=0.0;
     double d_cox_acc_dV_di_si=0.0;
  double r1_acc=0.0;
  double Inv_r1pi_acc=0.0;
  double CGSO_i=0.0;
  double CGDO_i=0.0;
  double q0_acc=0.0;
  double qb_acc=0.0;
     double d_qb_acc_dV_e_si=0.0;
     double d_qb_acc_dV_e_di=0.0;
     double d_qb_acc_dV_g_e=0.0;
     double d_qb_acc_dV_g_si=0.0;
     double d_qb_acc_dV_di_si=0.0;
     double d_qb_acc_dV_g_di=0.0;
  double qg_acc=0.0;
     double d_qg_acc_dV_e_si=0.0;
     double d_qg_acc_dV_e_di=0.0;
     double d_qg_acc_dV_g_e=0.0;
     double d_qg_acc_dV_g_si=0.0;
     double d_qg_acc_dV_di_si=0.0;
     double d_qg_acc_dV_g_di=0.0;
  double qi_acc=0.0;
     double d_qi_acc_dV_e_si=0.0;
     double d_qi_acc_dV_e_di=0.0;
     double d_qi_acc_dV_g_e=0.0;
     double d_qi_acc_dV_g_si=0.0;
     double d_qi_acc_dV_di_si=0.0;
  double qgs_fr=0.0;
     double d_qgs_fr_dV_g_s=0.0;
     double d_qgs_fr_dV_g_di=0.0;
     double d_qgs_fr_dV_e_si=0.0;
     double d_qgs_fr_dV_e_di=0.0;
     double d_qgs_fr_dV_g_e=0.0;
     double d_qgs_fr_dV_g_si=0.0;
     double d_qgs_fr_dV_di_si=0.0;
  double qgd_fr=0.0;
     double d_qgd_fr_dV_g_d=0.0;
     double d_qgd_fr_dV_g_di=0.0;
     double d_qgd_fr_dV_e_si=0.0;
     double d_qgd_fr_dV_e_di=0.0;
     double d_qgd_fr_dV_g_e=0.0;
     double d_qgd_fr_dV_g_si=0.0;
     double d_qgd_fr_dV_di_si=0.0;
  double qds_fr=0.0;
     double d_qds_fr_dV_d_s=0.0;
  double qgs_parasitic=0.0;
     double d_qgs_parasitic_dV_g_s=0.0;
     double d_qgs_parasitic_dV_g_di=0.0;
     double d_qgs_parasitic_dV_e_si=0.0;
     double d_qgs_parasitic_dV_e_di=0.0;
     double d_qgs_parasitic_dV_g_e=0.0;
     double d_qgs_parasitic_dV_g_si=0.0;
     double d_qgs_parasitic_dV_di_si=0.0;
  double qgd_parasitic=0.0;
     double d_qgd_parasitic_dV_g_d=0.0;
     double d_qgd_parasitic_dV_g_di=0.0;
     double d_qgd_parasitic_dV_e_si=0.0;
     double d_qgd_parasitic_dV_e_di=0.0;
     double d_qgd_parasitic_dV_g_e=0.0;
     double d_qgd_parasitic_dV_g_si=0.0;
     double d_qgd_parasitic_dV_di_si=0.0;
  double FNPowerAt1Hz=0.0;
  double Gtnoi=0.0;
  double gspr=0.0;
  double gdpr=0.0;
  int devsign=0.0;
  double epssub=0.0;
  double epssp=0.0;
  double cox=0.0;
  double csi=0.0;
  double cbox=0.0;
  double epsratio=0.0;
  double scl=0.0;
  double heff=0.0;
  double mx=0.0;
  double mxprime=0.0;
  double md=0.0;
  double mdprime=0.0;
  double gprime=0.0;
  double gfactor=0.0;
  double Lg=0.0;
  double deltaL=0.0;
  double deltaLCV=0.0;
  double Leff=0.0;
  double LeffCV=0.0;
  double LeffCV_acc=0.0;
  double NFINtotal=0.0;
  double Inv_L=0.0;
  double Inv_NFIN=0.0;
  double Inv_LNFIN=0.0;
  double NBODY_i=0.0;
  double PHIG_i=0.0;
  double NGATE_i=0.0;
  double CIT_i=0.0;
  double CDSC_i=0.0;
  double CDSCD_i=0.0;
  double DVT0_i=0.0;
  double DVT1_i=0.0;
  double DVT1SS_i=0.0;
  double PHIN_i=0.0;
  double ETA0_i=0.0;
  double DSUB_i=0.0;
  double K1RSCE_i=0.0;
  double LPE0_i=0.0;
  double DVTSHIFT_i=0.0;
  double K0_i=0.0;
  double K01_i=0.0;
  double K0SI_i=0.0;
  double K0SI1_i=0.0;
  double K1SI_i=0.0;
  double K1SI1_i=0.0;
  double PHIBE_i=0.0;
  double K1_i=0.0;
  double K11_i=0.0;
  double K1SAT_i=0.0;
  double K1SAT1_i=0.0;
  double QMFACTOR_i=0.0;
  double QMTCENIV_i=0.0;
  double QMTCENCV_i=0.0;
  double QMTCENCVA_i=0.0;
  double VSAT_i=0.0;
  double VSAT1_i=0.0;
  double VSATCV_i=0.0;
  double DELTAVSAT_i=0.0;
  double PSAT_i=0.0;
  double DELTAVSATCV_i=0.0;
  double PSATCV_i=0.0;
  double KSATIV_i=0.0;
  double MEXP_i=0.0;
  double PTWG_i=0.0;
  double U0_i=0.0;
  double ETAMOB_i=0.0;
  double UP_i=0.0;
  double UA_i=0.0;
  double UC_i=0.0;
  double EU_i=0.0;
  double UD_i=0.0;
  double UCS_i=0.0;
  double PCLM_i=0.0;
  double PCLMG_i=0.0;
  double PCLMCV_i=0.0;
  double A1_i=0.0;
  double A11_i=0.0;
  double A2_i=0.0;
  double A21_i=0.0;
  double RDSW_i=0.0;
  double RSW_i=0.0;
  double RDW_i=0.0;
  double PRWGD_i=0.0;
  double PRWGS_i=0.0;
  double WR_i=0.0;
  double PDIBL1_i=0.0;
  double PDIBL2_i=0.0;
  double DROUT_i=0.0;
  double PVAG_i=0.0;
  double AIGBINV_i=0.0;
  double AIGBINV1_i=0.0;
  double BIGBINV_i=0.0;
  double CIGBINV_i=0.0;
  double EIGBINV_i=0.0;
  double NIGBINV_i=0.0;
  double AIGBACC_i=0.0;
  double AIGBACC1_i=0.0;
  double BIGBACC_i=0.0;
  double CIGBACC_i=0.0;
  double NIGBACC_i=0.0;
  double AIGC_i=0.0;
  double AIGC1_i=0.0;
  double BIGC_i=0.0;
  double CIGC_i=0.0;
  double PIGCD_i=0.0;
  double AIGS_i=0.0;
  double AIGS1_i=0.0;
  double BIGS_i=0.0;
  double CIGS_i=0.0;
  double AIGD_i=0.0;
  double AIGD1_i=0.0;
  double BIGD_i=0.0;
  double CIGD_i=0.0;
  double NTOX_i=0.0;
  double POXEDGE_i=0.0;
  double AGIDL_i=0.0;
  double BGIDL_i=0.0;
  double CGIDL_i=0.0;
  double EGIDL_i=0.0;
  double PGIDL_i=0.0;
  double AGISL_i=0.0;
  double BGISL_i=0.0;
  double CGISL_i=0.0;
  double EGISL_i=0.0;
  double PGISL_i=0.0;
  double ALPHA0_i=0.0;
  double ALPHA1_i=0.0;
  double ALPHAII0_i=0.0;
  double ALPHAII1_i=0.0;
  double BETA0_i=0.0;
  double BETAII0_i=0.0;
  double BETAII1_i=0.0;
  double BETAII2_i=0.0;
  double ESATII_i=0.0;
  double LII_i=0.0;
  double SII0_i=0.0;
  double SII1_i=0.0;
  double SII2_i=0.0;
  double SIID_i=0.0;
  double TII_i=0.0;
  double CFS_i=0.0;
  double CFD_i=0.0;
  double COVS_i=0.0;
     double d_COVS_i_dV_g_di=0.0;
     double d_COVS_i_dV_e_si=0.0;
     double d_COVS_i_dV_e_di=0.0;
     double d_COVS_i_dV_g_e=0.0;
     double d_COVS_i_dV_g_si=0.0;
     double d_COVS_i_dV_di_si=0.0;
  double COVD_i=0.0;
     double d_COVD_i_dV_g_di=0.0;
     double d_COVD_i_dV_e_si=0.0;
     double d_COVD_i_dV_e_di=0.0;
     double d_COVD_i_dV_g_e=0.0;
     double d_COVD_i_dV_g_si=0.0;
     double d_COVD_i_dV_di_si=0.0;
  double CGSL_i=0.0;
  double CGDL_i=0.0;
  double CGBL_i=0.0;
  double CKAPPAS_i=0.0;
  double CKAPPAD_i=0.0;
  double CKAPPAB_i=0.0;
  double NTGEN_i=0.0;
  double AIGEN_i=0.0;
  double BIGEN_i=0.0;
  double CDSCDR_i=0.0;
  double ETA0R_i=0.0;
  double VSAT1R_i=0.0;
  double MEXPR_i=0.0;
  double PTWGR_i=0.0;
  double PDIBL1R_i=0.0;
  double UTE_i=0.0;
  double UTL_i=0.0;
  double EMOBT_i=0.0;
  double UA1_i=0.0;
  double UC1_i=0.0;
  double UD1_i=0.0;
  double UCSTE_i=0.0;
  double PTWGT_i=0.0;
  double AT_i=0.0;
  double PRT_i=0.0;
  double KT1_i=0.0;
  double TSS_i=0.0;
  double IIT_i=0.0;
  double TGIDL_i=0.0;
  double IGT_i=0.0;
  double Tcen0=0.0;
  double RDSWMIN_i=0.0;
  double RSWMIN_i=0.0;
  double RDWMIN_i=0.0;
  double LINTIGEN_i=0.0;
  double LINTNOI_i=0.0;
  double NTNOI_i=0.0;
  double Arsd=0.0;
  double Prsd=0.0;
  double mu_max=0.0;
  double mu_rsd=0.0;
  double rhorsd=0.0;
  double thetarsp=0.0;
  double afin=0.0;
  double T1=0.0;
     double d_T1_dV_di_d=0.0;
     double d_T1_dV_si_s=0.0;
     double d_T1_dV_g_di=0.0;
     double d_T1_dV_e_si=0.0;
     double d_T1_dV_e_di=0.0;
     double d_T1_dV_g_e=0.0;
     double d_T1_dV_g_si=0.0;
     double d_T1_dV_di_si=0.0;
  double Rsp=0.0;
  double arsd_total=0.0;
  double prsd_total=0.0;
  double lt=0.0;
  double alpha=0.0;
  double T0=0.0;
     double d_T0_dV_g_di=0.0;
     double d_T0_dV_e_si=0.0;
     double d_T0_dV_e_di=0.0;
     double d_T0_dV_g_e=0.0;
     double d_T0_dV_g_si=0.0;
     double d_T0_dV_di_si=0.0;
  double eta=0.0;
  double T2=0.0;
     double d_T2_dV_di_d=0.0;
     double d_T2_dV_si_s=0.0;
     double d_T2_dV_g_di=0.0;
     double d_T2_dV_g_e=0.0;
     double d_T2_dV_g_si=0.0;
     double d_T2_dV_e_si=0.0;
     double d_T2_dV_e_di=0.0;
     double d_T2_dV_di_si=0.0;
  double T3=0.0;
     double d_T3_dV_g_di=0.0;
     double d_T3_dV_g_e=0.0;
     double d_T3_dV_g_si=0.0;
     double d_T3_dV_e_si=0.0;
     double d_T3_dV_e_di=0.0;
     double d_T3_dV_di_si=0.0;
  double RrsdTML=0.0;
  double Rrsdside=0.0;
  double Rrsd=0.0;
  double Rdsgeo=0.0;
  double RSourceGeo=0.0;
  double RDrainGeo=0.0;
  double Hg=0.0;
  double Trsd=0.0;
  double Wg=0.0;
  double Hrsd=0.0;
  double Cgg_top=0.0;
  double Cgg_side=0.0;
  double Acorner=0.0;
  double Ccorner=0.0;
  double csbox=0.0;
  double cdbox=0.0;
  double cgbox=0.0;
  double EeffFactor=0.0;
  double WeffWRFactor=0.0;
  double litl=0.0;
  double tmp=0.0;
  double Theta_SCE=0.0;
  double Theta_SW=0.0;
  double Theta_DIBL=0.0;
  double Theta_RSCE=0.0;
  double nbody=0.0;
  double qbs=0.0;
  double Aechvb=0.0;
  double Bechvb=0.0;
  double Toxratio=0.0;
  double Toxratioedge=0.0;
  double igsd_mult0=0.0;
  double Tnom=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (18))
  {
    probeVars.resize(18);
    d_probeVars.resize(18);
    for (int i=0;i<18;i++)
    {
      d_probeVars[i].resize(18);
      for (int j=0;j<18;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(6+0);
    d_staticContributions.resize(6+0);
    for (int i=0;i<6+0;i++)
      d_staticContributions[i].resize(18);
    dynamicContributions.resize(6+0);
    d_dynamicContributions.resize(6+0);
    for (int i=0;i<6+0;i++)
      d_dynamicContributions[i].resize(18);
  }

    noiseContribsPower.resize(11);
    noiseContribsExponent.resize(11);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 6+0 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<18;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<18;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_si_GND] = (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_si_GND][admsProbeID_V_si_GND] = 1.0;
probeVars[admsProbeID_V_e_GND] = (*solVectorPtr)[li_e];
d_probeVars[admsProbeID_V_e_GND][admsProbeID_V_e_GND] = 1.0;
probeVars[admsProbeID_V_di_GND] = (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_di_GND][admsProbeID_V_di_GND] = 1.0;
probeVars[admsProbeID_V_g_GND] = (*solVectorPtr)[li_g];
d_probeVars[admsProbeID_V_g_GND][admsProbeID_V_g_GND] = 1.0;
probeVars[admsProbeID_V_s_si] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si] = 1.0;
probeVars[admsProbeID_V_d_di] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di] = 1.0;
probeVars[admsProbeID_V_e_g] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_g];
d_probeVars[admsProbeID_V_e_g][admsProbeID_V_e_g] = 1.0;
probeVars[admsProbeID_V_d_s] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_d_s][admsProbeID_V_d_s] = 1.0;
probeVars[admsProbeID_V_g_d] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_d];
d_probeVars[admsProbeID_V_g_d][admsProbeID_V_g_d] = 1.0;
probeVars[admsProbeID_V_g_s] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_g_s][admsProbeID_V_g_s] = 1.0;
probeVars[admsProbeID_V_di_d] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_d];
d_probeVars[admsProbeID_V_di_d][admsProbeID_V_di_d] = 1.0;
probeVars[admsProbeID_V_si_s] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s] = 1.0;
probeVars[admsProbeID_V_g_e] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_e];
d_probeVars[admsProbeID_V_g_e][admsProbeID_V_g_e] = 1.0;
probeVars[admsProbeID_V_e_di] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_e_di][admsProbeID_V_e_di] = 1.0;
probeVars[admsProbeID_V_e_si] = (*solVectorPtr)[li_e] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_e_si][admsProbeID_V_e_si] = 1.0;
probeVars[admsProbeID_V_g_di] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_g_di][admsProbeID_V_g_di] = 1.0;
probeVars[admsProbeID_V_di_si] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si] = 1.0;
probeVars[admsProbeID_V_g_si] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_g_si][admsProbeID_V_g_si] = 1.0;
// -- code converted from analog/code block
//Begin block CMGBiasIndepCalc
{
initialized = 1;
R = 0;

d_vgsfbeff_acc_dV_g_e = d_vgsfbeff_acc_dV_g_si = d_vgsfbeff_acc_dV_di_si =  0.0;
vgsfbeff_acc = 0;

d_vt0_dV_di_si =  0.0;
vt0 = 0;

d_vt0_acc_dV_di_si =  0.0;
vt0_acc = 0;

d_F1_dV_di_si =  0.0;
F1 = 0;
F1_acc = 0;

d_cdop_acc_dV_di_si =  0.0;
cdop_acc = 0;

d_qid_dV_di_si = d_qid_dV_e_si = d_qid_dV_e_di = d_qid_dV_g_e = d_qid_dV_g_si =  0.0;
qid = 0;

d_qis_dV_di_si = d_qis_dV_e_si = d_qis_dV_e_di = d_qis_dV_g_e = d_qis_dV_g_si =  0.0;
qis = 0;

d_tang0d_dV_e_si = d_tang0d_dV_e_di = d_tang0d_dV_g_e = d_tang0d_dV_g_si = d_tang0d_dV_di_si =  0.0;
tang0d = 0;

d_tang0s_dV_e_si = d_tang0s_dV_e_di = d_tang0s_dV_g_e = d_tang0s_dV_g_si = d_tang0s_dV_di_si =  0.0;
tang0s = 0;
T11 = 0;

d_T12_dV_di_si =  0.0;
T12 = 0;

d_T13_dV_di_si =  0.0;
T13 = 0;

d_T14_dV_di_si =  0.0;
T14 = 0;

d_ids_dV_e_si = d_ids_dV_e_di = d_ids_dV_g_e = d_ids_dV_g_si = d_ids_dV_di_si = d_ids_dV_g_di =  0.0;
ids = 0;
sigvds = 0;

d_Iii_dV_g_di = d_Iii_dV_e_si = d_Iii_dV_e_di = d_Iii_dV_g_e = d_Iii_dV_g_si = d_Iii_dV_di_si =  0.0;
Iii = 0;

d_qd_dV_di_si = d_qd_dV_e_si = d_qd_dV_e_di = d_qd_dV_g_e = d_qd_dV_g_si = d_qd_dV_g_di =  0.0;
qd = 0;

d_qg_dV_di_si = d_qg_dV_e_si = d_qg_dV_e_di = d_qg_dV_g_e = d_qg_dV_g_si = d_qg_dV_g_di =  0.0;
qg = 0;

d_qs_dV_di_si = d_qs_dV_e_si = d_qs_dV_e_di = d_qs_dV_g_e = d_qs_dV_g_si = d_qs_dV_g_di =  0.0;
qs = 0;
qb = 0;
Qbul = 0;

d_aab_dV_di_si =  0.0;
aab = 0;
Weff0 = 0;
WeffCV0 = 0;

d_Weff_dV_e_si = d_Weff_dV_e_di = d_Weff_dV_g_e = d_Weff_dV_g_si = d_Weff_dV_di_si =  0.0;
Weff = 0;

d_WeffCV_dV_e_si = d_WeffCV_dV_e_di = d_WeffCV_dV_g_e = d_WeffCV_dV_g_si = d_WeffCV_dV_di_si =  0.0;
WeffCV = 0;
CJS_t = 0;
CJSWS_t = 0;
CJSWGS_t = 0;
CJD_t = 0;
CJSWD_t = 0;
CJSWGD_t = 0;
PBS_t = 0;
PBSWS_t = 0;
PBSWGS_t = 0;
PBD_t = 0;
PBSWD_t = 0;
PBSWGD_t = 0;
JSS_t = 0;
JSWS_t = 0;
JSWGS_t = 0;
JSD_t = 0;
JSWD_t = 0;
JSWGD_t = 0;
JTSS_t = 0;
JTSSWS_t = 0;
JTSSWGS_t = 0;
JTSD_t = 0;
JTSSWD_t = 0;
JTSSWGD_t = 0;
NJTS_t = 0;
NJTSSW_t = 0;
NJTSSWG_t = 0;
NJTSD_t = 0;
NJTSSWD_t = 0;
NJTSSWGD_t = 0;

d_Ies_dV_g_di = d_Ies_dV_e_si = d_Ies_dV_e_di = d_Ies_dV_g_e = d_Ies_dV_g_si = d_Ies_dV_di_si =  0.0;
Ies = 0;

d_Ied_dV_g_di = d_Ied_dV_e_si = d_Ied_dV_e_di = d_Ied_dV_g_e = d_Ied_dV_g_si = d_Ied_dV_di_si =  0.0;
Ied = 0;
Czbs = 0;
Czbssw = 0;
Czbsswg = 0;
Czbd = 0;
Czbdsw = 0;
Czbdswg = 0;

d_Qes_dV_di_d = d_Qes_dV_si_s = d_Qes_dV_g_di = d_Qes_dV_e_si = d_Qes_dV_e_di = d_Qes_dV_g_e = d_Qes_dV_g_si = d_Qes_dV_di_si =  0.0;
Qes = 0;

d_Qed_dV_di_d = d_Qed_dV_si_s = d_Qed_dV_g_di = d_Qed_dV_e_si = d_Qed_dV_e_di = d_Qed_dV_g_e = d_Qed_dV_g_si = d_Qed_dV_di_si =  0.0;
Qed = 0;

d_Qeg_dV_g_di = d_Qeg_dV_g_e = d_Qeg_dV_g_si = d_Qeg_dV_e_si = d_Qeg_dV_e_di = d_Qeg_dV_di_si = d_Qeg_dV_e_g =  0.0;
Qeg = 0;
Isbs = 0;
Isbd = 0;
Nvtms = 0;
Nvtmd = 0;
SslpRev = 0;
IVjsmRev = 0;
VjsmRev = 0;
SslpFwd = 0;
IVjsmFwd = 0;
VjsmFwd = 0;
DslpRev = 0;
IVjdmRev = 0;
VjdmRev = 0;
DslpFwd = 0;
IVjdmFwd = 0;
VjdmFwd = 0;
XExpBVS = 0;
XExpBVD = 0;

d_idsgen_dV_g_di = d_idsgen_dV_e_si = d_idsgen_dV_e_di = d_idsgen_dV_g_e = d_idsgen_dV_g_si = d_idsgen_dV_di_si =  0.0;
idsgen = 0;
phibulk = 0;
phipert = 0;

d_g0s_dV_e_si = d_g0s_dV_e_di = d_g0s_dV_g_e = d_g0s_dV_g_si = d_g0s_dV_di_si =  0.0;
g0s = 0;

d_g0d_dV_e_si = d_g0d_dV_e_di = d_g0d_dV_g_e = d_g0d_dV_g_si = d_g0d_dV_di_si =  0.0;
g0d = 0;
r1 = 0;

d_q0_dV_di_si =  0.0;
q0 = 0;
F2 = 0;
Inv_r1pi = 0;

d_Tcen_dV_e_si = d_Tcen_dV_e_di = d_Tcen_dV_g_e = d_Tcen_dV_g_si = d_Tcen_dV_di_si =  0.0;
Tcen = 0;
MTcen = 0;

d_Rdrain_dV_di_d = d_Rdrain_dV_si_s = d_Rdrain_dV_e_si = d_Rdrain_dV_e_di = d_Rdrain_dV_g_e = d_Rdrain_dV_g_si = d_Rdrain_dV_di_si = d_Rdrain_dV_g_di =  0.0;
Rdrain = 0;

d_Rsource_dV_di_d = d_Rsource_dV_g_di = d_Rsource_dV_si_s = d_Rsource_dV_e_si = d_Rsource_dV_e_di = d_Rsource_dV_g_e = d_Rsource_dV_g_si = d_Rsource_dV_di_si =  0.0;
Rsource = 0;
Cfr_geo = 0;

d_igbinv_dV_g_si = d_igbinv_dV_di_si = d_igbinv_dV_e_si = d_igbinv_dV_e_di = d_igbinv_dV_g_e = d_igbinv_dV_g_di = d_igbinv_dV_di_d = d_igbinv_dV_si_s =  0.0;
igbinv = 0;

d_igbs_dV_g_si = d_igbs_dV_di_si = d_igbs_dV_e_si = d_igbs_dV_e_di = d_igbs_dV_g_e = d_igbs_dV_g_di = d_igbs_dV_di_d = d_igbs_dV_si_s =  0.0;
igbs = 0;

d_igbd_dV_g_si = d_igbd_dV_di_si = d_igbd_dV_e_si = d_igbd_dV_e_di = d_igbd_dV_g_e = d_igbd_dV_g_di = d_igbd_dV_di_d = d_igbd_dV_si_s =  0.0;
igbd = 0;

d_igbacc_dV_g_si = d_igbacc_dV_di_si = d_igbacc_dV_e_si = d_igbacc_dV_e_di = d_igbacc_dV_g_e = d_igbacc_dV_g_di = d_igbacc_dV_di_d = d_igbacc_dV_si_s =  0.0;
igbacc = 0;

d_igcs_dV_g_di = d_igcs_dV_di_si = d_igcs_dV_e_si = d_igcs_dV_e_di = d_igcs_dV_g_e = d_igcs_dV_g_si = d_igcs_dV_di_d = d_igcs_dV_si_s =  0.0;
igcs = 0;

d_igcd_dV_g_di = d_igcd_dV_di_si = d_igcd_dV_e_si = d_igcd_dV_e_di = d_igcd_dV_g_e = d_igcd_dV_g_si = d_igcd_dV_di_d = d_igcd_dV_si_s =  0.0;
igcd = 0;

d_igidl_dV_g_di = d_igidl_dV_di_d = d_igidl_dV_si_s = d_igidl_dV_g_si = d_igidl_dV_di_si = d_igidl_dV_e_si = d_igidl_dV_e_di = d_igidl_dV_g_e =  0.0;
igidl = 0;

d_igisl_dV_g_di = d_igisl_dV_di_d = d_igisl_dV_si_s = d_igisl_dV_g_si = d_igisl_dV_di_si = d_igisl_dV_e_si = d_igisl_dV_e_di = d_igisl_dV_g_e =  0.0;
igisl = 0;

d_igs_dV_g_si = d_igs_dV_g_di = d_igs_dV_g_e = d_igs_dV_e_si = d_igs_dV_e_di = d_igs_dV_di_si =  0.0;
igs = 0;

d_igd_dV_g_si = d_igd_dV_g_di = d_igd_dV_g_e = d_igd_dV_e_si = d_igd_dV_e_di = d_igd_dV_di_si =  0.0;
igd = 0;

d_cox_acc_dV_e_si = d_cox_acc_dV_e_di = d_cox_acc_dV_g_e = d_cox_acc_dV_g_si = d_cox_acc_dV_di_si =  0.0;
cox_acc = 0;
r1_acc = 0;
Inv_r1pi_acc = 0;
CGSO_i = 0;
CGDO_i = 0;
q0_acc = 0;

d_qb_acc_dV_e_si = d_qb_acc_dV_e_di = d_qb_acc_dV_g_e = d_qb_acc_dV_g_si = d_qb_acc_dV_di_si = d_qb_acc_dV_g_di =  0.0;
qb_acc = 0;

d_qg_acc_dV_e_si = d_qg_acc_dV_e_di = d_qg_acc_dV_g_e = d_qg_acc_dV_g_si = d_qg_acc_dV_di_si = d_qg_acc_dV_g_di =  0.0;
qg_acc = 0;

d_qi_acc_dV_e_si = d_qi_acc_dV_e_di = d_qi_acc_dV_g_e = d_qi_acc_dV_g_si = d_qi_acc_dV_di_si =  0.0;
qi_acc = 0;

d_qgs_fr_dV_g_s = d_qgs_fr_dV_g_di = d_qgs_fr_dV_e_si = d_qgs_fr_dV_e_di = d_qgs_fr_dV_g_e = d_qgs_fr_dV_g_si = d_qgs_fr_dV_di_si =  0.0;
qgs_fr = 0;

d_qgd_fr_dV_g_d = d_qgd_fr_dV_g_di = d_qgd_fr_dV_e_si = d_qgd_fr_dV_e_di = d_qgd_fr_dV_g_e = d_qgd_fr_dV_g_si = d_qgd_fr_dV_di_si =  0.0;
qgd_fr = 0;

d_qds_fr_dV_d_s =  0.0;
qds_fr = 0;

d_qgs_parasitic_dV_g_s = d_qgs_parasitic_dV_g_di = d_qgs_parasitic_dV_e_si = d_qgs_parasitic_dV_e_di = d_qgs_parasitic_dV_g_e = d_qgs_parasitic_dV_g_si = d_qgs_parasitic_dV_di_si =  0.0;
qgs_parasitic = 0;

d_qgd_parasitic_dV_g_d = d_qgd_parasitic_dV_g_di = d_qgd_parasitic_dV_e_si = d_qgd_parasitic_dV_e_di = d_qgd_parasitic_dV_g_e = d_qgd_parasitic_dV_g_si = d_qgd_parasitic_dV_di_si =  0.0;
qgd_parasitic = 0;
FNPowerAt1Hz = 0;
Gtnoi = 0;
gspr = 0;
gdpr = 0;
if ( (model_.GEOMOD) == (0))
{
Weff0 = ((2*(model_.HFIN))-(model_.DELTAW));
WeffCV0 = ((2*(model_.HFIN))-(model_.DELTAWCV));
}
else
if ( (model_.GEOMOD) == (1))
{
Weff0 = (((2*(model_.HFIN))+((model_.FECH)*TFIN))-(model_.DELTAW));
WeffCV0 = (((2*(model_.HFIN))+((model_.FECHCV)*TFIN))-(model_.DELTAWCV));
}
else
if ( (model_.GEOMOD) == (2))
{
Weff0 = (((2*(model_.HFIN))+((2*(model_.FECH))*TFIN))-(model_.DELTAW));
WeffCV0 = (((2*(model_.HFIN))+((2*(model_.FECHCV))*TFIN))-(model_.DELTAWCV));
}
else
if ( (model_.GEOMOD) == (3))
{
R = (D/2.0);
Weff0 = ((3.14159265358979323846*D)-(model_.DELTAW));
WeffCV0 = ((3.14159265358979323846*D)-(model_.DELTAWCV));
}
else
{
 // no default
}
if (((model_.DEVTYPE)==1))
{
devsign = 1;
}
else
{
devsign = (-1);
}
epssub = ((model_.EPSRSUB)*8.8542e-12);
epssp = ((model_.EPSRSP)*8.8542e-12);
cox = ((3.9*8.8542e-12)/(model_.EOT));
csi = (epssub/TFIN);
cbox = ((3.9*8.8542e-12)/(model_.EOTBOX));
epsratio = ((model_.EPSRSUB)/3.9);
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{

d_cox_acc_dV_e_si = d_cox_acc_dV_e_di = d_cox_acc_dV_g_e = d_cox_acc_dV_g_si = d_cox_acc_dV_di_si =  0.0;
cox_acc = ((3.9*8.8542e-12)/(model_.EOTACC));
}
{
double value_sqrt_0 = sqrt(((((0.5*epsratio)*TFIN)*(model_.EOT))*(1.0+(TFIN/((4.0*epsratio)*(model_.EOT))))));
scl = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((model_.HFIN)*((model_.HFIN)+((2*epsratio)*(model_.EOT))))/8.0));
heff = value_sqrt_0;
}
if ( (model_.GEOMOD) == (1))
{
{
double value_sqrt_0 = sqrt(((1.0/(scl*scl))+(0.25/(heff*heff))));
scl = (1.0/value_sqrt_0);
}
}
else
if ( (model_.GEOMOD) == (2))
{
{
double value_sqrt_0 = sqrt(((1.0/(scl*scl))+(0.25/(heff*heff))));
scl = (0.5/value_sqrt_0);
}
}
else
if ( (model_.GEOMOD) == (3))
{
{
double value_sqrt_0 = sqrt(((((0.5*epsratio)*R)*(model_.EOT))*(1.0+(R/((2.0*epsratio)*(model_.EOT))))));
scl = value_sqrt_0;
}
}
else
{
 // no default
}
mx = (0.916*9.11e-31);
mxprime = (0.190*9.11e-31);
md = (0.190*9.11e-31);
mdprime = (0.417*9.11e-31);
gprime = 4.0;
gfactor = 2.0;
Lg = (L+(model_.XL));
{
double value_pow_0 = pow(Lg,(-(model_.LLN)));
deltaL = ((model_.LINT)+((model_.LL)*value_pow_0));
}
{
double value_pow_0 = pow(Lg,(-(model_.LLN)));
deltaLCV = ((model_.DLC)+((model_.LLC)*value_pow_0));
}
Leff = (Lg-(2.0*deltaL));
LeffCV = (Lg-(2.0*deltaLCV));
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
LeffCV_acc = (LeffCV-(model_.DLCACC));
}
NFINtotal = (NFIN*(model_.NF));
Inv_L = (1.0e-6/(Leff+(model_.DLBIN)));
Inv_NFIN = (1.0/NFIN);
Inv_LNFIN = (1.0e-6/((Leff+(model_.DLBIN))*NFIN));
NBODY_i = ((((model_.NBODY)+(Inv_L*(model_.LNBODY)))+(Inv_NFIN*(model_.NNBODY)))+(Inv_LNFIN*(model_.PNBODY)));
PHIG_i = ((((model_.PHIG)+(Inv_L*(model_.LPHIG)))+(Inv_NFIN*(model_.NPHIG)))+(Inv_LNFIN*(model_.PPHIG)));
NGATE_i = ((((model_.NGATE)+(Inv_L*(model_.LNGATE)))+(Inv_NFIN*(model_.NNGATE)))+(Inv_LNFIN*(model_.PNGATE)));
CIT_i = ((((model_.CIT)+(Inv_L*(model_.LCIT)))+(Inv_NFIN*(model_.NCIT)))+(Inv_LNFIN*(model_.PCIT)));
CDSC_i = ((((model_.CDSC)+(Inv_L*(model_.LCDSC)))+(Inv_NFIN*(model_.NCDSC)))+(Inv_LNFIN*(model_.PCDSC)));
CDSCD_i = ((((model_.CDSCD)+(Inv_L*(model_.LCDSCD)))+(Inv_NFIN*(model_.NCDSCD)))+(Inv_LNFIN*(model_.PCDSCD)));
DVT0_i = ((((model_.DVT0)+(Inv_L*(model_.LDVT0)))+(Inv_NFIN*(model_.NDVT0)))+(Inv_LNFIN*(model_.PDVT0)));
DVT1_i = ((((model_.DVT1)+(Inv_L*(model_.LDVT1)))+(Inv_NFIN*(model_.NDVT1)))+(Inv_LNFIN*(model_.PDVT1)));
DVT1SS_i = ((((model_.DVT1SS)+(Inv_L*(model_.LDVT1SS)))+(Inv_NFIN*(model_.NDVT1SS)))+(Inv_LNFIN*(model_.PDVT1SS)));
PHIN_i = ((((model_.PHIN)+(Inv_L*(model_.LPHIN)))+(Inv_NFIN*(model_.NPHIN)))+(Inv_LNFIN*(model_.PPHIN)));
ETA0_i = ((((model_.ETA0)+(Inv_L*(model_.LETA0)))+(Inv_NFIN*(model_.NETA0)))+(Inv_LNFIN*(model_.PETA0)));
DSUB_i = ((((model_.DSUB)+(Inv_L*(model_.LDSUB)))+(Inv_NFIN*(model_.NDSUB)))+(Inv_LNFIN*(model_.PDSUB)));
K1RSCE_i = ((((model_.K1RSCE)+(Inv_L*(model_.LK1RSCE)))+(Inv_NFIN*(model_.NK1RSCE)))+(Inv_LNFIN*(model_.PK1RSCE)));
LPE0_i = ((((model_.LPE0)+(Inv_L*(model_.LLPE0)))+(Inv_NFIN*(model_.NLPE0)))+(Inv_LNFIN*(model_.PLPE0)));
DVTSHIFT_i = ((((model_.DVTSHIFT)+(Inv_L*(model_.LDVTSHIFT)))+(Inv_NFIN*(model_.NDVTSHIFT)))+(Inv_LNFIN*(model_.PDVTSHIFT)));
K0_i = ((((model_.K0)+(Inv_L*(model_.LK0)))+(Inv_NFIN*(model_.NK0)))+(Inv_LNFIN*(model_.PK0)));
K01_i = ((((model_.K01)+(Inv_L*(model_.LK01)))+(Inv_NFIN*(model_.NK01)))+(Inv_LNFIN*(model_.PK01)));
K0SI_i = ((((model_.K0SI)+(Inv_L*(model_.LK0SI)))+(Inv_NFIN*(model_.NK0SI)))+(Inv_LNFIN*(model_.PK0SI)));
K0SI1_i = ((((model_.K0SI1)+(Inv_L*(model_.LK0SI1)))+(Inv_NFIN*(model_.NK0SI1)))+(Inv_LNFIN*(model_.PK0SI1)));
K1SI_i = ((((model_.K1SI)+(Inv_L*(model_.LK1SI)))+(Inv_NFIN*(model_.NK1SI)))+(Inv_LNFIN*(model_.PK1SI)));
K1SI1_i = ((((model_.K1SI1)+(Inv_L*(model_.LK1SI1)))+(Inv_NFIN*(model_.NK1SI1)))+(Inv_LNFIN*(model_.PK1SI1)));
if (((model_.BULKMOD)!=0))
{
PHIBE_i = ((((model_.PHIBE)+(Inv_L*(model_.LPHIBE)))+(Inv_NFIN*(model_.NPHIBE)))+(Inv_LNFIN*(model_.PPHIBE)));
K1_i = ((((model_.K1)+(Inv_L*(model_.LK1)))+(Inv_NFIN*(model_.NK1)))+(Inv_LNFIN*(model_.PK1)));
K11_i = ((((model_.K11)+(Inv_L*(model_.LK11)))+(Inv_NFIN*(model_.NK11)))+(Inv_LNFIN*(model_.PK11)));
K1SAT_i = ((((model_.K1SAT)+(Inv_L*(model_.LK1SAT)))+(Inv_NFIN*(model_.NK1SAT)))+(Inv_LNFIN*(model_.PK1SAT)));
K1SAT1_i = ((((model_.K1SAT1)+(Inv_L*(model_.LK1SAT1)))+(Inv_NFIN*(model_.NK1SAT1)))+(Inv_LNFIN*(model_.PK1SAT1)));
}
QMFACTOR_i = ((((model_.QMFACTOR)+(Inv_L*(model_.LQMFACTOR)))+(Inv_NFIN*(model_.NQMFACTOR)))+(Inv_LNFIN*(model_.PQMFACTOR)));
QMTCENIV_i = ((((model_.QMTCENIV)+(Inv_L*(model_.LQMTCENIV)))+(Inv_NFIN*(model_.NQMTCENIV)))+(Inv_LNFIN*(model_.PQMTCENIV)));
QMTCENCV_i = ((((model_.QMTCENCV)+(Inv_L*(model_.LQMTCENCV)))+(Inv_NFIN*(model_.NQMTCENCV)))+(Inv_LNFIN*(model_.PQMTCENCV)));
QMTCENCVA_i = ((((model_.QMTCENCVA)+(Inv_L*(model_.LQMTCENCVA)))+(Inv_NFIN*(model_.NQMTCENCVA)))+(Inv_LNFIN*(model_.PQMTCENCVA)));
VSAT_i = ((((model_.VSAT)+(Inv_L*(model_.LVSAT)))+(Inv_NFIN*(model_.NVSAT)))+(Inv_LNFIN*(model_.PVSAT)));
VSAT1_i = ((((model_.VSAT1)+(Inv_L*(model_.LVSAT1)))+(Inv_NFIN*(model_.NVSAT1)))+(Inv_LNFIN*(model_.PVSAT1)));
VSATCV_i = ((((model_.VSATCV)+(Inv_L*(model_.LVSATCV)))+(Inv_NFIN*(model_.NVSATCV)))+(Inv_LNFIN*(model_.PVSATCV)));
DELTAVSAT_i = ((((model_.DELTAVSAT)+(Inv_L*(model_.LDELTAVSAT)))+(Inv_NFIN*(model_.NDELTAVSAT)))+(Inv_LNFIN*(model_.PDELTAVSAT)));
PSAT_i = ((((model_.PSAT)+(Inv_L*(model_.LPSAT)))+(Inv_NFIN*(model_.NPSAT)))+(Inv_LNFIN*(model_.PPSAT)));
DELTAVSATCV_i = ((((model_.DELTAVSATCV)+(Inv_L*(model_.LDELTAVSATCV)))+(Inv_NFIN*(model_.NDELTAVSATCV)))+(Inv_LNFIN*(model_.PDELTAVSATCV)));
PSATCV_i = ((((model_.PSATCV)+(Inv_L*(model_.LPSATCV)))+(Inv_NFIN*(model_.NPSATCV)))+(Inv_LNFIN*(model_.PPSATCV)));
KSATIV_i = ((((model_.KSATIV)+(Inv_L*(model_.LKSATIV)))+(Inv_NFIN*(model_.NKSATIV)))+(Inv_LNFIN*(model_.PKSATIV)));
MEXP_i = ((((model_.MEXP)+(Inv_L*(model_.LMEXP)))+(Inv_NFIN*(model_.NMEXP)))+(Inv_LNFIN*(model_.PMEXP)));
PTWG_i = ((((model_.PTWG)+(Inv_L*(model_.LPTWG)))+(Inv_NFIN*(model_.NPTWG)))+(Inv_LNFIN*(model_.PPTWG)));
U0_i = ((((model_.U0)+(Inv_L*(model_.LU0)))+(Inv_NFIN*(model_.NU0)))+(Inv_LNFIN*(model_.PU0)));
ETAMOB_i = ((((model_.ETAMOB)+(Inv_L*(model_.LETAMOB)))+(Inv_NFIN*(model_.NETAMOB)))+(Inv_LNFIN*(model_.PETAMOB)));
UP_i = ((((model_.UP)+(Inv_L*(model_.LUP)))+(Inv_NFIN*(model_.NUP)))+(Inv_LNFIN*(model_.PUP)));
UA_i = ((((model_.UA)+(Inv_L*(model_.LUA)))+(Inv_NFIN*(model_.NUA)))+(Inv_LNFIN*(model_.PUA)));
if (((model_.BULKMOD)!=0))
{
UC_i = ((((model_.UC)+(Inv_L*(model_.LUC)))+(Inv_NFIN*(model_.NUC)))+(Inv_LNFIN*(model_.PUC)));
}
EU_i = ((((model_.EU)+(Inv_L*(model_.LEU)))+(Inv_NFIN*(model_.NEU)))+(Inv_LNFIN*(model_.PEU)));
UD_i = ((((model_.UD)+(Inv_L*(model_.LUD)))+(Inv_NFIN*(model_.NUD)))+(Inv_LNFIN*(model_.PUD)));
UCS_i = ((((model_.UCS)+(Inv_L*(model_.LUCS)))+(Inv_NFIN*(model_.NUCS)))+(Inv_LNFIN*(model_.PUCS)));
PCLM_i = ((((model_.PCLM)+(Inv_L*(model_.LPCLM)))+(Inv_NFIN*(model_.NPCLM)))+(Inv_LNFIN*(model_.PPCLM)));
PCLMG_i = ((((model_.PCLMG)+(Inv_L*(model_.LPCLMG)))+(Inv_NFIN*(model_.NPCLMG)))+(Inv_LNFIN*(model_.PPCLMG)));
PCLMCV_i = ((((model_.PCLMCV)+(Inv_L*(model_.LPCLMCV)))+(Inv_NFIN*(model_.NPCLMCV)))+(Inv_LNFIN*(model_.PPCLMCV)));
A1_i = ((((model_.A1)+(Inv_L*(model_.LA1)))+(Inv_NFIN*(model_.NA1)))+(Inv_LNFIN*(model_.PA1)));
A11_i = ((((model_.A11)+(Inv_L*(model_.LA11)))+(Inv_NFIN*(model_.NA11)))+(Inv_LNFIN*(model_.PA11)));
A2_i = ((((model_.A2)+(Inv_L*(model_.LA2)))+(Inv_NFIN*(model_.NA2)))+(Inv_LNFIN*(model_.PA2)));
A21_i = ((((model_.A21)+(Inv_L*(model_.LA21)))+(Inv_NFIN*(model_.NA21)))+(Inv_LNFIN*(model_.PA21)));
RDSW_i = ((((model_.RDSW)+(Inv_L*(model_.LRDSW)))+(Inv_NFIN*(model_.NRDSW)))+(Inv_LNFIN*(model_.PRDSW)));
RSW_i = ((((model_.RSW)+(Inv_L*(model_.LRSW)))+(Inv_NFIN*(model_.NRSW)))+(Inv_LNFIN*(model_.PRSW)));
RDW_i = ((((model_.RDW)+(Inv_L*(model_.LRDW)))+(Inv_NFIN*(model_.NRDW)))+(Inv_LNFIN*(model_.PRDW)));
PRWGD_i = ((((model_.PRWGD)+(Inv_L*(model_.LPRWGD)))+(Inv_NFIN*(model_.NPRWGD)))+(Inv_LNFIN*(model_.PPRWGD)));
PRWGS_i = ((((model_.PRWGS)+(Inv_L*(model_.LPRWGS)))+(Inv_NFIN*(model_.NPRWGS)))+(Inv_LNFIN*(model_.PPRWGS)));
WR_i = ((((model_.WR)+(Inv_L*(model_.LWR)))+(Inv_NFIN*(model_.NWR)))+(Inv_LNFIN*(model_.PWR)));
PDIBL1_i = ((((model_.PDIBL1)+(Inv_L*(model_.LPDIBL1)))+(Inv_NFIN*(model_.NPDIBL1)))+(Inv_LNFIN*(model_.PPDIBL1)));
PDIBL2_i = ((((model_.PDIBL2)+(Inv_L*(model_.LPDIBL2)))+(Inv_NFIN*(model_.NPDIBL2)))+(Inv_LNFIN*(model_.PPDIBL2)));
DROUT_i = ((((model_.DROUT)+(Inv_L*(model_.LDROUT)))+(Inv_NFIN*(model_.NDROUT)))+(Inv_LNFIN*(model_.PDROUT)));
PVAG_i = ((((model_.PVAG)+(Inv_L*(model_.LPVAG)))+(Inv_NFIN*(model_.NPVAG)))+(Inv_LNFIN*(model_.PPVAG)));
AIGBINV_i = ((((model_.AIGBINV)+(Inv_L*(model_.LAIGBINV)))+(Inv_NFIN*(model_.NAIGBINV)))+(Inv_LNFIN*(model_.PAIGBINV)));
AIGBINV1_i = ((((model_.AIGBINV1)+(Inv_L*(model_.LAIGBINV1)))+(Inv_NFIN*(model_.NAIGBINV1)))+(Inv_LNFIN*(model_.PAIGBINV1)));
BIGBINV_i = ((((model_.BIGBINV)+(Inv_L*(model_.LBIGBINV)))+(Inv_NFIN*(model_.NBIGBINV)))+(Inv_LNFIN*(model_.PBIGBINV)));
CIGBINV_i = ((((model_.CIGBINV)+(Inv_L*(model_.LCIGBINV)))+(Inv_NFIN*(model_.NCIGBINV)))+(Inv_LNFIN*(model_.PCIGBINV)));
EIGBINV_i = ((((model_.EIGBINV)+(Inv_L*(model_.LEIGBINV)))+(Inv_NFIN*(model_.NEIGBINV)))+(Inv_LNFIN*(model_.PEIGBINV)));
NIGBINV_i = ((((model_.NIGBINV)+(Inv_L*(model_.LNIGBINV)))+(Inv_NFIN*(model_.NNIGBINV)))+(Inv_LNFIN*(model_.PNIGBINV)));
AIGBACC_i = ((((model_.AIGBACC)+(Inv_L*(model_.LAIGBACC)))+(Inv_NFIN*(model_.NAIGBACC)))+(Inv_LNFIN*(model_.PAIGBACC)));
AIGBACC1_i = ((((model_.AIGBACC1)+(Inv_L*(model_.LAIGBACC1)))+(Inv_NFIN*(model_.NAIGBACC1)))+(Inv_LNFIN*(model_.PAIGBACC1)));
BIGBACC_i = ((((model_.BIGBACC)+(Inv_L*(model_.LBIGBACC)))+(Inv_NFIN*(model_.NBIGBACC)))+(Inv_LNFIN*(model_.PBIGBACC)));
CIGBACC_i = ((((model_.CIGBACC)+(Inv_L*(model_.LCIGBACC)))+(Inv_NFIN*(model_.NCIGBACC)))+(Inv_LNFIN*(model_.PCIGBACC)));
NIGBACC_i = ((((model_.NIGBACC)+(Inv_L*(model_.LNIGBACC)))+(Inv_NFIN*(model_.NNIGBACC)))+(Inv_LNFIN*(model_.PNIGBACC)));
AIGC_i = ((((model_.AIGC)+(Inv_L*(model_.LAIGC)))+(Inv_NFIN*(model_.NAIGC)))+(Inv_LNFIN*(model_.PAIGC)));
AIGC1_i = ((((model_.AIGC1)+(Inv_L*(model_.LAIGC1)))+(Inv_NFIN*(model_.NAIGC1)))+(Inv_LNFIN*(model_.PAIGC1)));
BIGC_i = ((((model_.BIGC)+(Inv_L*(model_.LBIGC)))+(Inv_NFIN*(model_.NBIGC)))+(Inv_LNFIN*(model_.PBIGC)));
CIGC_i = ((((model_.CIGC)+(Inv_L*(model_.LCIGC)))+(Inv_NFIN*(model_.NCIGC)))+(Inv_LNFIN*(model_.PCIGC)));
PIGCD_i = ((((model_.PIGCD)+(Inv_L*(model_.LPIGCD)))+(Inv_NFIN*(model_.NPIGCD)))+(Inv_LNFIN*(model_.PPIGCD)));
AIGS_i = ((((model_.AIGS)+(Inv_L*(model_.LAIGS)))+(Inv_NFIN*(model_.NAIGS)))+(Inv_LNFIN*(model_.PAIGS)));
AIGS1_i = ((((model_.AIGS1)+(Inv_L*(model_.LAIGS1)))+(Inv_NFIN*(model_.NAIGS1)))+(Inv_LNFIN*(model_.PAIGS1)));
BIGS_i = ((((model_.BIGS)+(Inv_L*(model_.LBIGS)))+(Inv_NFIN*(model_.NBIGS)))+(Inv_LNFIN*(model_.PBIGS)));
CIGS_i = ((((model_.CIGS)+(Inv_L*(model_.LCIGS)))+(Inv_NFIN*(model_.NCIGS)))+(Inv_LNFIN*(model_.PCIGS)));
AIGD_i = ((((model_.AIGD)+(Inv_L*(model_.LAIGD)))+(Inv_NFIN*(model_.NAIGD)))+(Inv_LNFIN*(model_.PAIGD)));
AIGD1_i = ((((model_.AIGD1)+(Inv_L*(model_.LAIGD1)))+(Inv_NFIN*(model_.NAIGD1)))+(Inv_LNFIN*(model_.PAIGD1)));
BIGD_i = ((((model_.BIGD)+(Inv_L*(model_.LBIGD)))+(Inv_NFIN*(model_.NBIGD)))+(Inv_LNFIN*(model_.PBIGD)));
CIGD_i = ((((model_.CIGD)+(Inv_L*(model_.LCIGD)))+(Inv_NFIN*(model_.NCIGD)))+(Inv_LNFIN*(model_.PCIGD)));
NTOX_i = ((((model_.NTOX)+(Inv_L*(model_.LNTOX)))+(Inv_NFIN*(model_.NNTOX)))+(Inv_LNFIN*(model_.PNTOX)));
POXEDGE_i = ((((model_.POXEDGE)+(Inv_L*(model_.LPOXEDGE)))+(Inv_NFIN*(model_.NPOXEDGE)))+(Inv_LNFIN*(model_.PPOXEDGE)));
AGIDL_i = ((((model_.AGIDL)+(Inv_L*(model_.LAGIDL)))+(Inv_NFIN*(model_.NAGIDL)))+(Inv_LNFIN*(model_.PAGIDL)));
BGIDL_i = ((((model_.BGIDL)+(Inv_L*(model_.LBGIDL)))+(Inv_NFIN*(model_.NBGIDL)))+(Inv_LNFIN*(model_.PBGIDL)));
CGIDL_i = ((((model_.CGIDL)+(Inv_L*(model_.LCGIDL)))+(Inv_NFIN*(model_.NCGIDL)))+(Inv_LNFIN*(model_.PCGIDL)));
EGIDL_i = ((((model_.EGIDL)+(Inv_L*(model_.LEGIDL)))+(Inv_NFIN*(model_.NEGIDL)))+(Inv_LNFIN*(model_.PEGIDL)));
PGIDL_i = ((((model_.PGIDL)+(Inv_L*(model_.LPGIDL)))+(Inv_NFIN*(model_.NPGIDL)))+(Inv_LNFIN*(model_.PPGIDL)));
AGISL_i = ((((model_.AGISL)+(Inv_L*(model_.LAGISL)))+(Inv_NFIN*(model_.NAGISL)))+(Inv_LNFIN*(model_.PAGISL)));
BGISL_i = ((((model_.BGISL)+(Inv_L*(model_.LBGISL)))+(Inv_NFIN*(model_.NBGISL)))+(Inv_LNFIN*(model_.PBGISL)));
CGISL_i = ((((model_.CGISL)+(Inv_L*(model_.LCGISL)))+(Inv_NFIN*(model_.NCGISL)))+(Inv_LNFIN*(model_.PCGISL)));
EGISL_i = ((((model_.EGISL)+(Inv_L*(model_.LEGISL)))+(Inv_NFIN*(model_.NEGISL)))+(Inv_LNFIN*(model_.PEGISL)));
PGISL_i = ((((model_.PGISL)+(Inv_L*(model_.LPGISL)))+(Inv_NFIN*(model_.NPGISL)))+(Inv_LNFIN*(model_.PPGISL)));
ALPHA0_i = ((((model_.ALPHA0)+(Inv_L*(model_.LALPHA0)))+(Inv_NFIN*(model_.NALPHA0)))+(Inv_LNFIN*(model_.PALPHA0)));
ALPHA1_i = ((((model_.ALPHA1)+(Inv_L*(model_.LALPHA1)))+(Inv_NFIN*(model_.NALPHA1)))+(Inv_LNFIN*(model_.PALPHA1)));
ALPHAII0_i = ((((model_.ALPHAII0)+(Inv_L*(model_.LALPHAII0)))+(Inv_NFIN*(model_.NALPHAII0)))+(Inv_LNFIN*(model_.PALPHAII0)));
ALPHAII1_i = ((((model_.ALPHAII1)+(Inv_L*(model_.LALPHAII1)))+(Inv_NFIN*(model_.NALPHAII1)))+(Inv_LNFIN*(model_.PALPHAII1)));
BETA0_i = ((((model_.BETA0)+(Inv_L*(model_.LBETA0)))+(Inv_NFIN*(model_.NBETA0)))+(Inv_LNFIN*(model_.PBETA0)));
BETAII0_i = ((((model_.BETAII0)+(Inv_L*(model_.LBETAII0)))+(Inv_NFIN*(model_.NBETAII0)))+(Inv_LNFIN*(model_.PBETAII0)));
BETAII1_i = ((((model_.BETAII1)+(Inv_L*(model_.LBETAII1)))+(Inv_NFIN*(model_.NBETAII1)))+(Inv_LNFIN*(model_.PBETAII1)));
BETAII2_i = ((((model_.BETAII2)+(Inv_L*(model_.LBETAII2)))+(Inv_NFIN*(model_.NBETAII2)))+(Inv_LNFIN*(model_.PBETAII2)));
ESATII_i = ((((model_.ESATII)+(Inv_L*(model_.LESATII)))+(Inv_NFIN*(model_.NESATII)))+(Inv_LNFIN*(model_.PESATII)));
LII_i = ((((model_.LII)+(Inv_L*(model_.LLII)))+(Inv_NFIN*(model_.NLII)))+(Inv_LNFIN*(model_.PLII)));
SII0_i = ((((model_.SII0)+(Inv_L*(model_.LSII0)))+(Inv_NFIN*(model_.NSII0)))+(Inv_LNFIN*(model_.PSII0)));
SII1_i = ((((model_.SII1)+(Inv_L*(model_.LSII1)))+(Inv_NFIN*(model_.NSII1)))+(Inv_LNFIN*(model_.PSII1)));
SII2_i = ((((model_.SII2)+(Inv_L*(model_.LSII2)))+(Inv_NFIN*(model_.NSII2)))+(Inv_LNFIN*(model_.PSII2)));
SIID_i = ((((model_.SIID)+(Inv_L*(model_.LSIID)))+(Inv_NFIN*(model_.NSIID)))+(Inv_LNFIN*(model_.PSIID)));
TII_i = ((((model_.TII)+(Inv_L*(model_.LTII)))+(Inv_NFIN*(model_.NTII)))+(Inv_LNFIN*(model_.PTII)));
CFS_i = ((((model_.CFS)+(Inv_L*(model_.LCFS)))+(Inv_NFIN*(model_.NCFS)))+(Inv_LNFIN*(model_.PCFS)));
CFD_i = ((((model_.CFD)+(Inv_L*(model_.LCFD)))+(Inv_NFIN*(model_.NCFD)))+(Inv_LNFIN*(model_.PCFD)));

d_COVS_i_dV_g_di = d_COVS_i_dV_e_si = d_COVS_i_dV_e_di = d_COVS_i_dV_g_e = d_COVS_i_dV_g_si = d_COVS_i_dV_di_si =  0.0;
COVS_i = (((COVS+(Inv_L*(model_.LCOVS)))+(Inv_NFIN*(model_.NCOVS)))+(Inv_LNFIN*(model_.PCOVS)));

d_COVD_i_dV_g_di = d_COVD_i_dV_e_si = d_COVD_i_dV_e_di = d_COVD_i_dV_g_e = d_COVD_i_dV_g_si = d_COVD_i_dV_di_si =  0.0;
COVD_i = (((COVD+(Inv_L*(model_.LCOVD)))+(Inv_NFIN*(model_.NCOVD)))+(Inv_LNFIN*(model_.PCOVD)));
CGSL_i = ((((model_.CGSL)+(Inv_L*(model_.LCGSL)))+(Inv_NFIN*(model_.NCGSL)))+(Inv_LNFIN*(model_.PCGSL)));
CGDL_i = ((((model_.CGDL)+(Inv_L*(model_.LCGDL)))+(Inv_NFIN*(model_.NCGDL)))+(Inv_LNFIN*(model_.PCGDL)));
CGBL_i = ((((model_.CGBL)+(Inv_L*(model_.LCGBL)))+(Inv_NFIN*(model_.NCGBL)))+(Inv_LNFIN*(model_.PCGBL)));
CKAPPAS_i = ((((model_.CKAPPAS)+(Inv_L*(model_.LCKAPPAS)))+(Inv_NFIN*(model_.NCKAPPAS)))+(Inv_LNFIN*(model_.PCKAPPAS)));
CKAPPAD_i = ((((model_.CKAPPAD)+(Inv_L*(model_.LCKAPPAD)))+(Inv_NFIN*(model_.NCKAPPAD)))+(Inv_LNFIN*(model_.PCKAPPAD)));
CKAPPAB_i = ((((model_.CKAPPAB)+(Inv_L*(model_.LCKAPPAB)))+(Inv_NFIN*(model_.NCKAPPAB)))+(Inv_LNFIN*(model_.PCKAPPAB)));
NTGEN_i = ((((model_.NTGEN)+(Inv_L*(model_.LNTGEN)))+(Inv_NFIN*(model_.NNTGEN)))+(Inv_LNFIN*(model_.PNTGEN)));
AIGEN_i = ((((model_.AIGEN)+(Inv_L*(model_.LAIGEN)))+(Inv_NFIN*(model_.NAIGEN)))+(Inv_LNFIN*(model_.PAIGEN)));
BIGEN_i = ((((model_.BIGEN)+(Inv_L*(model_.LBIGEN)))+(Inv_NFIN*(model_.NBIGEN)))+(Inv_LNFIN*(model_.PBIGEN)));
if (((model_.ASYMMOD)!=0))
{
CDSCDR_i = ((((model_.CDSCDR)+(Inv_L*(model_.LCDSCDR)))+(Inv_NFIN*(model_.NCDSCDR)))+(Inv_LNFIN*(model_.PCDSCDR)));
ETA0R_i = ((((model_.ETA0R)+(Inv_L*(model_.LETA0R)))+(Inv_NFIN*(model_.NETA0R)))+(Inv_LNFIN*(model_.PETA0R)));
VSAT1R_i = ((((model_.VSAT1R)+(Inv_L*(model_.LVSAT1R)))+(Inv_NFIN*(model_.NVSAT1R)))+(Inv_LNFIN*(model_.PVSAT1R)));
MEXPR_i = ((((model_.MEXPR)+(Inv_L*(model_.LMEXPR)))+(Inv_NFIN*(model_.NMEXPR)))+(Inv_LNFIN*(model_.PMEXPR)));
PTWGR_i = ((((model_.PTWGR)+(Inv_L*(model_.LPTWGR)))+(Inv_NFIN*(model_.NPTWGR)))+(Inv_LNFIN*(model_.PPTWGR)));
PDIBL1R_i = ((((model_.PDIBL1R)+(Inv_L*(model_.LPDIBL1R)))+(Inv_NFIN*(model_.NPDIBL1R)))+(Inv_LNFIN*(model_.PPDIBL1R)));
}
if (((model_.NQSMOD)==1))
{
UserInfo(*this)  << "[bsimcmg] Although the model selector NQSMOD is set to 1, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD1__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
if (((model_.NQSMOD)==2))
{
UserInfo(*this)  << "[bsimcmg] Although the model selector NQSMOD is set to 2, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD2__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
UTE_i = ((((model_.UTE)+(Inv_L*(model_.LUTE)))+(Inv_NFIN*(model_.NUTE)))+(Inv_LNFIN*(model_.PUTE)));
UTL_i = ((((model_.UTL)+(Inv_L*(model_.LUTL)))+(Inv_NFIN*(model_.NUTL)))+(Inv_LNFIN*(model_.PUTL)));
EMOBT_i = ((((model_.EMOBT)+(Inv_L*(model_.LEMOBT)))+(Inv_NFIN*(model_.NEMOBT)))+(Inv_LNFIN*(model_.PEMOBT)));
UA1_i = ((((model_.UA1)+(Inv_L*(model_.LUA1)))+(Inv_NFIN*(model_.NUA1)))+(Inv_LNFIN*(model_.PUA1)));
if (((model_.BULKMOD)!=0))
{
UC1_i = ((((model_.UC1)+(Inv_L*(model_.LUC1)))+(Inv_NFIN*(model_.NUC1)))+(Inv_LNFIN*(model_.PUC1)));
}
UD1_i = ((((model_.UD1)+(Inv_L*(model_.LUD1)))+(Inv_NFIN*(model_.NUD1)))+(Inv_LNFIN*(model_.PUD1)));
UCSTE_i = ((((model_.UCSTE)+(Inv_L*(model_.LUCSTE)))+(Inv_NFIN*(model_.NUCSTE)))+(Inv_LNFIN*(model_.PUCSTE)));
PTWGT_i = ((((model_.PTWGT)+(Inv_L*(model_.LPTWGT)))+(Inv_NFIN*(model_.NPTWGT)))+(Inv_LNFIN*(model_.PPTWGT)));
AT_i = ((((model_.AT)+(Inv_L*(model_.LAT)))+(Inv_NFIN*(model_.NAT)))+(Inv_LNFIN*(model_.PAT)));
PRT_i = ((((model_.PRT)+(Inv_L*(model_.LPRT)))+(Inv_NFIN*(model_.NPRT)))+(Inv_LNFIN*(model_.PPRT)));
KT1_i = ((((model_.KT1)+(Inv_L*(model_.LKT1)))+(Inv_NFIN*(model_.NKT1)))+(Inv_LNFIN*(model_.PKT1)));
TSS_i = ((((model_.TSS)+(Inv_L*(model_.LTSS)))+(Inv_NFIN*(model_.NTSS)))+(Inv_LNFIN*(model_.PTSS)));
IIT_i = ((((model_.IIT)+(Inv_L*(model_.LIIT)))+(Inv_NFIN*(model_.NIIT)))+(Inv_LNFIN*(model_.PIIT)));
TGIDL_i = ((((model_.TGIDL)+(Inv_L*(model_.LTGIDL)))+(Inv_NFIN*(model_.NTGIDL)))+(Inv_LNFIN*(model_.PTGIDL)));
IGT_i = ((((model_.IGT)+(Inv_L*(model_.LIGT)))+(Inv_NFIN*(model_.NIGT)))+(Inv_LNFIN*(model_.PIGT)));
if (((model_.PHIGN1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.PHIGN2))));
PHIG_i = (PHIG_i*(1.0+(((model_.PHIGN1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.PHIGN2)))))));
}
}
if (((model_.ETA0N1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.ETA0N2))));
ETA0_i = (ETA0_i*(1.0+(((model_.ETA0N1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.ETA0N2)))))));
}
}
if (((model_.CDSCN1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.CDSCN2))));
CDSC_i = (CDSC_i*(1.0+(((model_.CDSCN1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.CDSCN2)))))));
}
}
if (((model_.CDSCDN1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.CDSCDN2))));
CDSCD_i = (CDSCD_i*(1.0+(((model_.CDSCDN1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.CDSCDN2)))))));
}
}
if (((model_.CDSCDRN1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.CDSCDRN2))));
CDSCDR_i = (CDSCDR_i*(1.0+(((model_.CDSCDRN1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.CDSCDRN2)))))));
}
}
if (((model_.NBODYN1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.NBODYN2))));
NBODY_i = (NBODY_i*(1.0+(((model_.NBODYN1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.NBODYN2)))))));
}
}
if (((model_.VSATN1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.VSATN2))));
VSAT_i = (VSAT_i*(1.0+(((model_.VSATN1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.VSATN2)))))));
}
}
if (((model_.VSAT1N1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.VSAT1N2))));
VSAT1_i = (VSAT1_i*(1.0+(((model_.VSAT1N1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.VSAT1N2)))))));
}
}
if (((model_.VSAT1RN1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.VSAT1RN2))));
VSAT1R_i = (VSAT1R_i*(1.0+(((model_.VSAT1RN1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.VSAT1RN2)))))));
}
}
if (((model_.U0N1)!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(NFIN/(model_.U0N2))));
U0_i = (U0_i*(1.0+(((model_.U0N1)/NFIN)*evaluator_lln_0.getValues((1.0+(NFIN/(model_.U0N2)))))));
}
}
PHIG_i = (PHIG_i+((model_.PHIGL)*Leff));
if (((model_.LPA)>0))
{
{
double value_pow_0 = pow(Leff,(-(model_.LPA)));
U0_i = (U0_i*(1-(UP_i*value_pow_0)));
}
}
else
{
U0_i = (U0_i*(1-UP_i));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BUA)));
UA_i = (UA_i+((model_.AUA)*evaluator_lexp_0.getValues(((-Leff)/(model_.BUA)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BUD)));
UD_i = (UD_i+((model_.AUD)*evaluator_lexp_0.getValues(((-Leff)/(model_.BUD)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BEU)));
EU_i = (EU_i+((model_.AEU)*evaluator_lexp_0.getValues(((-Leff)/(model_.BEU)))));
}
if (((model_.RDSMOD)==1))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BRSW)));
RSW_i = (RSW_i+((model_.ARSW)*evaluator_lexp_0.getValues(((-Leff)/(model_.BRSW)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BRDW)));
RDW_i = (RDW_i+((model_.ARDW)*evaluator_lexp_0.getValues(((-Leff)/(model_.BRDW)))));
}
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BRDSW)));
RDSW_i = (RDSW_i+((model_.ARDSW)*evaluator_lexp_0.getValues(((-Leff)/(model_.BRDSW)))));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BPCLM)));
PCLM_i = (PCLM_i+((model_.APCLM)*evaluator_lexp_0.getValues(((-Leff)/(model_.BPCLM)))));
}
{
double value_pow_0 = pow(Leff,(-(model_.BMEXP)));
MEXP_i = (MEXP_i+((model_.AMEXP)*value_pow_0));
}
if (((model_.ASYMMOD)!=0))
{
{
double value_pow_0 = pow(Leff,(-(model_.BMEXPR)));
MEXPR_i = (MEXPR_i+((model_.AMEXPR)*value_pow_0));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BPTWG)));
PTWG_i = (PTWG_i+((model_.APTWG)*evaluator_lexp_0.getValues(((-Leff)/(model_.BPTWG)))));
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BPTWG)));
PTWGR_i = (PTWGR_i+((model_.APTWG)*evaluator_lexp_0.getValues(((-Leff)/(model_.BPTWG)))));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BVSAT)));
VSAT_i = (VSAT_i+((model_.AVSAT)*evaluator_lexp_0.getValues(((-Leff)/(model_.BVSAT)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BVSAT1)));
VSAT1_i = (VSAT1_i+((model_.AVSAT1)*evaluator_lexp_0.getValues(((-Leff)/(model_.BVSAT1)))));
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BVSAT1)));
VSAT1R_i = (VSAT1R_i+((model_.AVSAT1)*evaluator_lexp_0.getValues(((-Leff)/(model_.BVSAT1)))));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BPSAT)));
PSAT_i = (PSAT_i+((model_.APSAT)*evaluator_lexp_0.getValues(((-Leff)/(model_.BPSAT)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/(model_.BPSATCV)));
PSATCV_i = (PSATCV_i+((model_.APSATCV)*evaluator_lexp_0.getValues(((-Leff)/(model_.BPSATCV)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-LeffCV)/(model_.BVSATCV)));
VSATCV_i = (VSATCV_i+((model_.AVSATCV)*evaluator_lexp_0.getValues(((-LeffCV)/(model_.BVSATCV)))));
}
if ((((QMTCENIV_i>0.0)||(QMTCENCV_i>0.0))||(QMTCENCVA_i>0.0)))
{
if ( (model_.GEOMOD) == (0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-TFIN)/(model_.BQMTCEN)));
MTcen = (1.0+((model_.AQMTCEN)*evaluator_lexp_0.getValues(((-TFIN)/(model_.BQMTCEN)))));
}
Tcen0 = (TFIN*MTcen);
}
else
if ( (model_.GEOMOD) == (1))
{
{
double value_min_0 = std::min((model_.HFIN),TFIN);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-value_min_0)/(model_.BQMTCEN)));
MTcen = (1.0+((model_.AQMTCEN)*evaluator_lexp_1.getValues(((-value_min_0)/(model_.BQMTCEN)))));
}
{
double value_min_0 = std::min(TFIN,(model_.HFIN));
Tcen0 = (value_min_0*MTcen);
}
}
else
if ( (model_.GEOMOD) == (2))
{
{
double value_min_0 = std::min((model_.HFIN),TFIN);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-value_min_0)/(model_.BQMTCEN)));
MTcen = (1.0+((model_.AQMTCEN)*evaluator_lexp_1.getValues(((-value_min_0)/(model_.BQMTCEN)))));
}
{
double value_min_0 = std::min(TFIN,(model_.HFIN));
Tcen0 = (value_min_0*MTcen);
}
}
else
if ( (model_.GEOMOD) == (3))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-R)/(model_.BQMTCEN)));
MTcen = (1.0+((model_.AQMTCEN)*evaluator_lexp_0.getValues(((-R)/(model_.BQMTCEN)))));
}
Tcen0 = (R*MTcen);
}
else
{
 // no default
}
}
if ((Leff<=0))
{
UserInfo(*this)  << "Fatal: Leff = %e is not positive." << " " << Leff << " " <<  std::endl; 
}
else
{
if ((Leff<=1e-9))
{
UserInfo(*this)  << "Warning: Leff = %e <= 1.0e-9." << " " << Leff << " " <<  std::endl; 
}
}
if ((LeffCV<=1e-9))
{
UserInfo(*this)  << "Warning: LeffCV = %e <= 1.0e-9." << " " << LeffCV << " " <<  std::endl; 
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
if ((LeffCV_acc<=1e-9))
{
UserInfo(*this)  << "Warning: LeffCV_acc = %e <= 1.0e-9." << " " << LeffCV_acc << " " <<  std::endl; 
}
}
if ((Weff0<=1e-9))
{
UserInfo(*this)  << "Warning: Weff0 = %e <= 1.0e-9." << " " << Weff0 << " " <<  std::endl; 
}
if ((WeffCV0<=1e-9))
{
UserInfo(*this)  << "Warning: WeffCV0 = %e <= 1.0e-9." << " " << WeffCV0 << " " <<  std::endl; 
}
if ((NBODY_i<=0))
{
UserInfo(*this)  << "Fatal: NBODY_i = %e is not positive." << " " << NBODY_i << " " <<  std::endl; 
}
else
{
if ((NBODY_i<=1e18))
{
UserInfo(*this)  << "Warning: NBODY_i = %e m^-3 may be too small." << " " << NBODY_i << " " <<  std::endl; 
}
}
if ((NGATE_i<0))
{
UserInfo(*this)  << "Fatal: NGATE_i = %e is negative." << " " << NGATE_i << " " <<  std::endl; 
}
else
{
if (((NGATE_i!=0)&&(NGATE_i<=1e24)))
{
UserInfo(*this)  << "Warning: NGATE_i = %e may be too small." << " " << NGATE_i << " " <<  std::endl; 
}
else
{
if ((NGATE_i>1e31))
{
UserInfo(*this)  << "Fatal: NGATE_i = %e is too high." << " " << NGATE_i << " " <<  std::endl; 
}
}
}
if ((DVT0_i<0))
{
UserInfo(*this)  << "Warning: DVT0_i = %e is negative." << " " << DVT0_i << " " <<  std::endl; 
}
if ((DVT1_i<=0))
{
UserInfo(*this)  << "Fatal: DVT1_i = %e is not positive." << " " << DVT1_i << " " <<  std::endl; 
}
if ((DVT1SS_i<=0))
{
UserInfo(*this)  << "Fatal: DVT1SS_i = %e is not positive." << " " << DVT1SS_i << " " <<  std::endl; 
}
if ((CDSC_i<0))
{
UserInfo(*this)  << "Warning: CDSC_i = %e is negative." << " " << CDSC_i << " " <<  std::endl; 
}
if ((CDSCD_i<0))
{
UserInfo(*this)  << "Warning: CDSCD_i = %e is negative." << " " << CDSCD_i << " " <<  std::endl; 
}
if ((DSUB_i<=0))
{
UserInfo(*this)  << "Fatal: DSUB_i = %e is not positive." << " " << DSUB_i << " " <<  std::endl; 
}
if ((ETA0_i<0))
{
UserInfo(*this)  << "Warning: ETA0_i = %e is negative." << " " << ETA0_i << " " <<  std::endl; 
}
if ((LPE0_i<(-Leff)))
{
UserInfo(*this)  << "Warning: LPE0_i = %e is less than -Leff. Clipping LPE0_i to 0" << " " << LPE0_i << " " <<  std::endl; 
LPE0_i = 0;
}
if ((K0SI_i<=0))
{
UserInfo(*this)  << "Warning: K0SI_i = %e is not positive, setting it to 0." << " " << K0SI_i << " " <<  std::endl; 
K0SI_i = 0;
}
if ((K1SI_i<=0))
{
UserInfo(*this)  << "Warning: K1SI_i = %e is not positive, setting it to 0." << " " << K1SI_i << " " <<  std::endl; 
K1SI_i = 0;
}
if (((PHIBE_i<0.2)&&((model_.BULKMOD)!=0)))
{
UserInfo(*this)  << "Warning: PHIBE_i = %e is less than 0.2, setting it to 0.2." << " " << PHIBE_i << " " <<  std::endl; 
PHIBE_i = 0.2;
}
if (((PHIBE_i>1.2)&&((model_.BULKMOD)!=0)))
{
UserInfo(*this)  << "Warning: PHIBE_i = %e is larger than 1.2, setting it to 1.2." << " " << PHIBE_i << " " <<  std::endl; 
PHIBE_i = 1.2;
}
if ((PSAT_i<2.0))
{
UserInfo(*this)  << "Warning: PSAT_i = %e is less than 2.0, setting it to 2.0." << " " << PSAT_i << " " <<  std::endl; 
PSAT_i = 2.0;
}
if ((PSATCV_i<2.0))
{
UserInfo(*this)  << "Warning: PSATCV_i = %e is less than 2.0, setting it to 2.0." << " " << PSATCV_i << " " <<  std::endl; 
PSATCV_i = 2.0;
}
if ((U0_i<0))
{
UserInfo(*this)  << "Warning: U0_i = %e is negative, setting it to 0." << " " << U0_i << " " <<  std::endl; 
U0_i = 0;
}
if ((UA_i<0))
{
UserInfo(*this)  << "Warning: UA_i = %e is negative, setting it to 0." << " " << UA_i << " " <<  std::endl; 
UA_i = 0;
}
if ((EU_i<0))
{
UserInfo(*this)  << "Warning: EU_i = %e is negative, setting it to 0." << " " << EU_i << " " <<  std::endl; 
EU_i = 0;
}
if ((UD_i<0))
{
UserInfo(*this)  << "Warning: UD_i = %e is negative, setting it to 0." << " " << UD_i << " " <<  std::endl; 
UD_i = 0;
}
if ((UCS_i<0))
{
UserInfo(*this)  << "Warning: UCS_i = %e is negative, setting it to 0." << " " << UCS_i << " " <<  std::endl; 
UCS_i = 0;
}
RDSWMIN_i = (model_.RDSWMIN);
if ((RDSWMIN_i<0))
{
UserInfo(*this)  << "Warning: RDSWMIN = %e is negative.  Set to zero" << " " << RDSWMIN_i << " " <<  std::endl; 
RDSWMIN_i = 0;
}
if ((RDSW_i<0))
{
UserInfo(*this)  << "Warning: RDSW_i = %e is negative.  Set to zero" << " " << RDSW_i << " " <<  std::endl; 
RDSW_i = 0;
}
RSWMIN_i = (model_.RSWMIN);
if ((RSWMIN_i<0))
{
UserInfo(*this)  << "Warning: RSWMIN = %e is negative.  Set to zero" << " " << RSWMIN_i << " " <<  std::endl; 
RSWMIN_i = 0;
}
if ((RSW_i<0))
{
UserInfo(*this)  << "Warning: RSW_i = %e is negative.  Set to zero" << " " << RSW_i << " " <<  std::endl; 
RSW_i = 0;
}
RDWMIN_i = (model_.RDWMIN);
if ((RDWMIN_i<0))
{
UserInfo(*this)  << "Warning: RDWMIN = %e is negative.  Set to zero" << " " << RDWMIN_i << " " <<  std::endl; 
RDWMIN_i = 0;
}
if ((RDW_i<0))
{
UserInfo(*this)  << "Warning: RDW_i = %e is negative.  Set to zero" << " " << RDW_i << " " <<  std::endl; 
RDW_i = 0;
}
if ((PRWGD_i<0))
{
UserInfo(*this)  << "Warning: PRWGD_i = %e is negative.  Set to zero" << " " << PRWGD_i << " " <<  std::endl; 
PRWGD_i = 0;
}
if ((PRWGS_i<0))
{
UserInfo(*this)  << "Warning: PRWGS_i = %e is negative.  Set to zero" << " " << PRWGS_i << " " <<  std::endl; 
PRWGS_i = 0;
}
if ((PCLM_i<0))
{
UserInfo(*this)  << "Warning: PCLM_i = %e is negative." << " " << PCLM_i << " " <<  std::endl; 
}
if ((PDIBL1_i<0))
{
UserInfo(*this)  << "Warning: PDIBL1_i = %e is negative." << " " << PDIBL1_i << " " <<  std::endl; 
}
if (((model_.ASYMMOD)!=0))
{
if ((PDIBL1R_i<0))
{
UserInfo(*this)  << "Warning: PDIBL1R_i = %e is negative." << " " << PDIBL1R_i << " " <<  std::endl; 
}
}
if ((PDIBL2_i<0))
{
UserInfo(*this)  << "Fatal: PDIBL2_i = %e is negative." << " " << PDIBL2_i << " " <<  std::endl; 
}
if ((DROUT_i<=0))
{
UserInfo(*this)  << "Fatal: DROUT_i = %e is non-positive." << " " << DROUT_i << " " <<  std::endl; 
}
if ((MEXP_i<2.0))
{
UserInfo(*this)  << "Warning: MEXP_i = %e < 2.  Setting MEXP_i = 2." << " " << MEXP_i << " " <<  std::endl; 
MEXP_i = 2.0;
}
if (((model_.ASYMMOD)!=0))
{
if ((MEXPR_i<2.0))
{
UserInfo(*this)  << "Warning: MEXPR_i = %e < 2.  Setting MEXPR_i = 2." << " " << MEXPR_i << " " <<  std::endl; 
MEXPR_i = 2.0;
}
}
if ((PTWG_i<0))
{
UserInfo(*this)  << "Warning: PTWG_i = %e is negative, setting it to 0." << " " << PTWG_i << " " <<  std::endl; 
PTWG_i = 0;
}
if (((QMTCENIV_i>0)||(QMTCENCV_i>0)))
{
if (((model_.QM0)<=0))
{
UserInfo(*this)  << "Fatal: QM0 = %e is non-positive." << " " << (model_.QM0) << " " <<  std::endl; 
}
}
if (((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0))&&(QMTCENCVA_i>0)))
{
if (((model_.QM0ACC)<=0))
{
UserInfo(*this)  << "Fatal: QM0ACC = %e is non-positive." << " " << (model_.QM0ACC) << " " <<  std::endl; 
}
}
if ((CGIDL_i<0.0))
{
UserInfo(*this)  << "Warning: CGIDL_i = %e < 0.  Setting CGIDL_i = 0." << " " << CGIDL_i << " " <<  std::endl; 
CGIDL_i = 0.0;
}
if ((CGISL_i<0.0))
{
UserInfo(*this)  << "Warning: CGISL_i = %e < 0.  Setting CGISL_i = 0." << " " << CGISL_i << " " <<  std::endl; 
CGISL_i = 0.0;
}
if (((model_.IGBMOD)!=0))
{
if ((NIGBINV_i<=0))
{
UserInfo(*this)  << "Fatal: NIGBINV_i = %e is non-positive." << " " << NIGBINV_i << " " <<  std::endl; 
}
if ((NIGBACC_i<=0))
{
UserInfo(*this)  << "Fatal: NIGBACC_i = %e is non-positive." << " " << NIGBACC_i << " " <<  std::endl; 
}
}
if (((model_.IGCMOD)!=0))
{
if ((POXEDGE_i<=0))
{
UserInfo(*this)  << "Fatal: POXEDGE_i = %e is non-positive." << " " << POXEDGE_i << " " <<  std::endl; 
}
if ((PIGCD_i<=0))
{
UserInfo(*this)  << "Fatal: PIGCD_i = %e is non-positive." << " " << PIGCD_i << " " <<  std::endl; 
}
}
if ((((model_.IGCMOD)!=0)||((model_.IGBMOD)!=0)))
{
if (((model_.TOXREF)<=0))
{
UserInfo(*this)  << "Fatal: TOXREF = %e is non-positive." << " " << (model_.TOXREF) << " " <<  std::endl; 
}
}
if (((model_.LINTIGEN)>=(Leff/2)))
{
UserInfo(*this)  << "Warning: LINTIGEN = %e is too large - Leff for r/g current is negative.  Re-setting LINTIGEN = 0." << " " << (model_.LINTIGEN) << " " <<  std::endl; 
LINTIGEN_i = 0;
}
else
{
LINTIGEN_i = (model_.LINTIGEN);
}
if ((NTGEN_i<=0))
{
UserInfo(*this)  << "Fatal: NTGEN_i = %e is non-positive." << " " << NTGEN_i << " " <<  std::endl; 
}
if (((model_.IIMOD)==2))
{
if ((BETAII0_i<0.0))
{
UserInfo(*this)  << "Warning:  BETAII0_i = %e is negative." << " " << BETAII0_i << " " <<  std::endl; 
}
if ((BETAII1_i<0.0))
{
UserInfo(*this)  << "Warning:  BETAII1_i = %e is negative." << " " << BETAII1_i << " " <<  std::endl; 
}
if ((BETAII2_i<0.0))
{
UserInfo(*this)  << "Warning:  BETAII2_i = %e is negative." << " " << BETAII2_i << " " <<  std::endl; 
}
if ((ESATII_i<0.0))
{
UserInfo(*this)  << "Warning:  ESATII_i = %e is negative." << " " << ESATII_i << " " <<  std::endl; 
}
if ((LII_i<0.0))
{
UserInfo(*this)  << "Warning:  LII_i = %e is negative." << " " << LII_i << " " <<  std::endl; 
}
if ((SII1_i<0.0))
{
UserInfo(*this)  << "Warning:  SII1_i = %e is negative." << " " << (model_.SII1) << " " <<  std::endl; 
}
if ((SII2_i<0.0))
{
UserInfo(*this)  << "Warning:  SII2_i = %e is negative." << " " << SII2_i << " " <<  std::endl; 
}
if ((SIID_i<0.0))
{
UserInfo(*this)  << "Warning:  SIID_i = %e is negative." << " " << SIID_i << " " <<  std::endl; 
}
}
if (((model_.EF)<=0))
{
UserInfo(*this)  << "Fatal: EF = %e is non-positive." << " " << (model_.EF) << " " <<  std::endl; 
}
else
{
if (((model_.EF)>2.0))
{
UserInfo(*this)  << "Fatal: EF = %e > 2.0." << " " << (model_.EF) << " " <<  std::endl; 
}
}
if (((model_.LINTNOI)>=(Leff/2)))
{
UserInfo(*this)  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << " " << (model_.LINTNOI) << " " <<  std::endl; 
LINTNOI_i = 0;
}
else
{
LINTNOI_i = (model_.LINTNOI);
}
if (((model_.NTNOI)<0))
{
UserInfo(*this)  << "Warning: NTNOI = %e is negative. Set to zero." << " " << (model_.NTNOI) << " " <<  std::endl; 
NTNOI_i = 0;
}
else
{
NTNOI_i = (model_.NTNOI);
}
if (((model_.SHMOD)!=0))
{
UserInfo(*this)  << "[bsimcmg] Although the model selector SHMOD is set to 1, the self heating model is not activated in the Verilog-A code.  Please uncomment `define __SHMOD__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
if (((model_.RGATEMOD)!=0))
{
UserInfo(*this)  << "[bsimcmg] Although the model selector RGATEMOD is set to 1, the gate electrode resistance model is not activated in the Verilog-A code.  Please uncomment `define __RGATEMOD__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
if (((model_.RGEOMOD)==0))
{
RSourceGeo = ((model_.RSHS)*NRS);
RDrainGeo = ((model_.RSHD)*NRD);
}
else
{
if (((model_.HEPI)>0))
{
Arsd = ((FPITCH*(model_.HFIN))+((TFIN+((FPITCH-TFIN)*(model_.CRATIO)))*(model_.HEPI)));
}
else
{
{
double value_max_0 = std::max(((model_.HFIN)+(model_.HEPI)),static_cast<double>(1.0e-9));
Arsd = (FPITCH*value_max_0);
}
}
Prsd = (FPITCH+(model_.DELTAPRSD));
if ((model_.given("RHORSD")))
{
rhorsd = (model_.RHORSD);
}
else
{
mu_max = (((model_.DEVTYPE)==1)?1417:470.5);
if (((model_.DEVTYPE)==1))
{
{
double value_pow_0 = pow(((model_.NSD)/9.68e22),0.680);
double value_pow_1 = pow((3.43e26/(model_.NSD)),2);
mu_rsd = (((52.2+((mu_max-52.2)/(1+value_pow_0)))-(43.4/(1.0+value_pow_1)))*1.0e-4);
}
}
else
{
{
double value_pow_0 = pow(((model_.NSD)/2.23e22),0.719);
double value_pow_1 = pow((6.10e26/(model_.NSD)),2);
mu_rsd = (((44.9+((mu_max-44.9)/(1+value_pow_0)))-(29.0/(1.0+value_pow_1)))*1.0e-4);
}
}
rhorsd = (1/((1.60219e-19*(model_.NSD))*mu_rsd));
}
thetarsp = ((55*3.14159265358979323846)/180);
{
double value_min_0 = std::min((model_.HEPI),static_cast<double>(0.0));
double value_max_1 = std::max((TFIN*((model_.HFIN)+value_min_0)),static_cast<double>(1.0e-18));
double value_min_2 = std::min(value_max_1,Arsd);
afin = value_min_2;
}
{
double value_tan_0 = tan(thetarsp);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = ((thetarsp>=(3.14159265358979323846/2))?0:((thetarsp<=((-3.14159265358979323846)/2))?0:(1.0/value_tan_0)));
}
{
double value_sqrt_0 = sqrt(static_cast<double>(3.14159265358979323846));
double value_sqrt_1 = sqrt(afin);
double value_sqrt_2 = sqrt(Arsd);
double value_sqrt_3 = sqrt((afin/(Arsd*Arsd)));
Rsp = (((rhorsd*T1)/(value_sqrt_0*NFIN))*(((1.0/value_sqrt_1)-(2.0/value_sqrt_2))+value_sqrt_3));
}
arsd_total = ((Arsd*NFIN)+(model_.ARSDEND));
prsd_total = ((Prsd*NFIN)+(model_.PRSDEND));
{
double value_sqrt_0 = sqrt((((model_.RHOC)*arsd_total)/(rhorsd*prsd_total)));
lt = value_sqrt_0;
}
alpha = (LRSD/lt);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((alpha+alpha));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = evaluator_lexp_0.getValues((alpha+alpha));
}
if (((model_.SDTERM)==1))
{
eta = ((rhorsd*lt)/(model_.RHOC));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = (T0*(1.0+eta));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = ((T1+1.0)-eta);

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = ((T1-1.0)+eta);
}
else
{

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = (T0+1.0);

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = (T0-1.0);
}
RrsdTML = (((rhorsd*lt)*T2)/(arsd_total*T3));
if (((model_.HEPI)<(-1.0e-10)))
{
Rrsdside = ((model_.RHOC)/(((-(model_.HEPI))*TFIN)*NFIN));
Rrsd = (((RrsdTML+Rsp)*Rrsdside)/((RrsdTML+Rsp)+Rrsdside));
}
else
{
Rrsd = (RrsdTML+Rsp);
}
{
double value_max_0 = std::max((((((model_.RGEOA)+((model_.RGEOB)*TFIN))+((model_.RGEOC)*FPITCH))+((model_.RGEOD)*LRSD))+((model_.RGEOE)*(model_.HEPI))),static_cast<double>(0.0));
Rdsgeo = ((Rrsd/(model_.NF))*value_max_0);
}
RSourceGeo = Rdsgeo;
RDrainGeo = Rdsgeo;
}
if ((RSourceGeo<=1.0e-3))
{
RSourceGeo = 1.0e-3;
}
if ((RDrainGeo<=1.0e-3))
{
RDrainGeo = 1.0e-3;
}
if (((model_.RDSMOD)!=0))
{
if ((RSWMIN_i<=0))
{
RSWMIN_i = 0;
}
if ((RDWMIN_i<=0))
{
RDWMIN_i = 0;
}
if ((RSW_i<=0))
{
RSW_i = 0;
}
if ((RDW_i<=0))
{
RDW_i = 0;
}
}
else
{
if ((RDSWMIN_i<=0))
{
RDSWMIN_i = 0;
}
if ((RDSW_i<=0))
{
RDSW_i = 0;
}
}
if (((model_.CGEOMOD)!=1))
{
if ((model_.given("CGSO")))
{
CGSO_i = (model_.CGSO);
}
else
{
if (((model_.given("DLC"))&&((model_.DLC)>0)))
{
{
double value_max_0 = std::max(static_cast<double>(0.0),(((model_.DLC)*cox)-CGSL_i));
CGSO_i = value_max_0;
}
}
else
{
CGSO_i = ((0.3*TFIN)*cox);
}
}
if ((model_.given("CGDO")))
{
CGDO_i = (model_.CGDO);
}
else
{
if (((model_.given("DLC"))&&((model_.DLC)>0)))
{
{
double value_max_0 = std::max(static_cast<double>(0.0),(((model_.DLC)*cox)-CGDL_i));
CGDO_i = value_max_0;
}
}
else
{
CGDO_i = ((0.3*TFIN)*cox);
}
}
}
if (((model_.CGEOMOD)==2))
{
Hg = ((model_.TGATE)+(model_.TMASK));
Trsd = (0.5*(FPITCH-TFIN));
{
double value_max_0 = std::max((Trsd-(model_.TOXP)),static_cast<double>(0.0));
Wg = value_max_0;
}
{
double value_max_0 = std::max(((model_.HEPI)+(model_.TSILI)),static_cast<double>(0.0));
Hrsd = value_max_0;
}
if (((model_.TMASK)>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((1.0e-7*(model_.EPSRSP))/(3.9*(model_.LSP))));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = (3.467e-11*evaluator_lln_0.getValues(((1.0e-7*(model_.EPSRSP))/(3.9*(model_.LSP)))));
}

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = (((0.942*Hrsd)*epssp)/(model_.LSP));
Cgg_top = ((T0+T1)*(TFIN+((FPITCH-TFIN)*(model_.CRATIO))));
}
else
{
//Begin block cfr_top_trigate
{
//Block-local variables for block cfr_top_trigate
double Hr=0.0;
double Lr=0.0;
double Hgdelta=0.0;
double Lmax=0.0;
double y=0.0;
double x=0.0;
//End of Block-local variables
//Block-local variables for block cfr_top_trigate
double CcgSat=0.0;
double Cnon=0.0;
double TT1=0.0;
double Ccg1=0.0;
double r1cf=0.0;
double Rcf=0.0;
double Ccg2=0.0;
//End of Block-local variables
//Block-local variables for block cfr_top_trigate
double Ccg=0.0;
double C1=0.0;
double C2=0.0;
double C3=0.0;
double Cfglog=0.0;
double dcf=0.0;
double TT0=0.0;
//End of Block-local variables
//Block-local variables for block cfr_top_trigate
double TT2=0.0;
double Cfgsat=0.0;
double delta=0.0;
double Cfg=0.0;
//End of Block-local variables
Hr = (2.3+((0.2*(Hg+(model_.TOXP)))/Hrsd));
Lr = 1.05;
{
double value_fabs_0 = fabs(((Hg+(model_.TOXP))-Hrsd));
Hgdelta = value_fabs_0;
}
Lmax = ((model_.LSP)*Lr);
{
double value_min_0 = std::min(Hrsd,(Hg+(model_.TOXP)));
y = value_min_0;
}
x = ((model_.LSP)/(Hr+1.0));
Cnon = 1.7e12;
CcgSat = ((epssp*(y-x))/(model_.LSP));
TT1 = (Cnon*CcgSat);
if ((TT1>80.0))
{
Ccg1 = CcgSat;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(TT1);
double value_log_1 = log((1.0+evaluator_lexp_0.getValues(TT1)));
Ccg1 = ((1.0/Cnon)*value_log_1);
}
}
{
double value_min_0 = std::min((Hrsd/(Hg+(model_.TOXP))),((Hg+(model_.TOXP))/Hrsd));
r1cf = (0.5*value_min_0);
}
Rcf = (Hgdelta*r1cf);
{
double value_log_0 = log((((model_.LSP)+((0.5*3.14159265358979323846)*Rcf))/(model_.LSP)));
Ccg2 = (((epssp*2)/3.14159265358979323846)*value_log_0);
}
Ccg = (TFIN*(Ccg1+Ccg2));
x = (Lmax/Hg);
{
double value_sqrt_0 = sqrt((2.0*(x+1)));
C1 = (4.0/(value_sqrt_0*3.14159265358979323846));
}
{
double value_sqrt_0 = sqrt(((((model_.TOXP)*(model_.TOXP))+((2.0*Hg)*(model_.TOXP)))+((Hg*Hg)*(x+1))));
double value_sqrt_1 = sqrt((x+1));
C2 = ((((value_sqrt_0*value_sqrt_1)+(model_.TOXP))+(Hg*x))+Hg);
}
{
double value_sqrt_0 = sqrt(((x+1)*(x+4)));
C3 = (((model_.TOXP)*value_sqrt_0)+((model_.TOXP)*(x+2)));
}
{
double value_log_0 = log((C2/C3));
Cfglog = (epssp*((C1*value_log_0)+12.27));
}
dcf = (Hr*Lr);
{
double value_sqrt_0 = sqrt(((dcf*dcf)+1.0));
TT0 = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((dcf*dcf)+1)*((((dcf*(model_.TOXP))*(dcf*(model_.TOXP)))+(((2*dcf)*Lmax)*(model_.TOXP)))+((((dcf*dcf)+1)*Lmax)*Lmax))));
TT1 = (((value_sqrt_0+(dcf*(model_.TOXP)))+((dcf*dcf)*Lmax))+Lmax);
}
TT2 = ((TT0+1.0)*(dcf*(model_.TOXP)));
{
double value_sqrt_0 = sqrt(static_cast<double>(2.0));
double value_log_1 = log((TT1/TT2));
Cfgsat = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)/TT0)*value_log_1);
}
delta = 1.2e-12;
TT1 = ((Cfgsat-Cfglog)-delta);
{
double value_sqrt_0 = sqrt(((TT1*TT1)+((4*delta)*Cfgsat)));
Cfg = (TFIN*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
}
Cgg_top = (Ccg+Cfg);
}
// End block cfr_top_trigate
}
if (((model_.TMASK)>0))
{
//Begin block cfr_side_dblgate
{
//Block-local variables for block cfr_side_dblgate
double Hr=0.0;
double Lr=0.0;
double Hgdelta=0.0;
double Lmax=0.0;
double y=0.0;
double x=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_dblgate
double CcgSat=0.0;
double Cnon=0.0;
double TT1=0.0;
double Ccg1=0.0;
double r1cf=0.0;
double Rcf=0.0;
double Ccg2=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_dblgate
double Ccg=0.0;
double C1=0.0;
double C2=0.0;
double C3=0.0;
double Cfglog=0.0;
double dcf=0.0;
double TT0=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_dblgate
double TT2=0.0;
double Cfgsat=0.0;
double delta=0.0;
double Cfg=0.0;
//End of Block-local variables
Hr = (2.3+((0.2*(Wg+(model_.TOXP)))/Trsd));
Lr = 1.05;
{
double value_fabs_0 = fabs(((Wg+(model_.TOXP))-Trsd));
Hgdelta = value_fabs_0;
}
Lmax = ((model_.LSP)*Lr);
{
double value_min_0 = std::min(Trsd,(Wg+(model_.TOXP)));
y = value_min_0;
}
x = ((model_.LSP)/(Hr+1.0));
Cnon = 1.7e12;
CcgSat = ((epssp*(y-x))/(model_.LSP));
TT1 = (Cnon*CcgSat);
if ((TT1>80.0))
{
Ccg1 = CcgSat;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(TT1);
double value_log_1 = log((1.0+evaluator_lexp_0.getValues(TT1)));
Ccg1 = ((1.0/Cnon)*value_log_1);
}
}
{
double value_min_0 = std::min((Trsd/(Wg+(model_.TOXP))),((Wg+(model_.TOXP))/Trsd));
r1cf = (0.5*value_min_0);
}
Rcf = (Hgdelta*r1cf);
{
double value_log_0 = log((((model_.LSP)+((0.5*3.14159265358979323846)*Rcf))/(model_.LSP)));
Ccg2 = (((epssp*2)/3.14159265358979323846)*value_log_0);
}
Ccg = ((model_.HFIN)*(Ccg1+Ccg2));
x = (Lmax/Wg);
{
double value_sqrt_0 = sqrt((2.0*(x+1)));
C1 = (4.0/(value_sqrt_0*3.14159265358979323846));
}
{
double value_sqrt_0 = sqrt(((((model_.TOXP)*(model_.TOXP))+((2.0*Wg)*(model_.TOXP)))+((Wg*Wg)*(x+1))));
double value_sqrt_1 = sqrt((x+1));
C2 = ((((value_sqrt_0*value_sqrt_1)+(model_.TOXP))+(Wg*x))+Wg);
}
{
double value_sqrt_0 = sqrt(((x+1)*(x+4)));
C3 = (((model_.TOXP)*value_sqrt_0)+((model_.TOXP)*(x+2)));
}
{
double value_log_0 = log((C2/C3));
Cfglog = (epssp*((C1*value_log_0)+12.27));
}
dcf = (Hr*Lr);
{
double value_sqrt_0 = sqrt(((dcf*dcf)+1.0));
TT0 = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((dcf*dcf)+1)*((((dcf*(model_.TOXP))*(dcf*(model_.TOXP)))+(((2*dcf)*Lmax)*(model_.TOXP)))+((((dcf*dcf)+1)*Lmax)*Lmax))));
TT1 = (((value_sqrt_0+(dcf*(model_.TOXP)))+((dcf*dcf)*Lmax))+Lmax);
}
TT2 = ((TT0+1.0)*(dcf*(model_.TOXP)));
{
double value_sqrt_0 = sqrt(static_cast<double>(2.0));
double value_log_1 = log((TT1/TT2));
Cfgsat = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.70)*dcf)/TT0)*value_log_1);
}
delta = 1.2e-12;
TT1 = ((Cfgsat-Cfglog)-delta);
{
double value_sqrt_0 = sqrt(((TT1*TT1)+((4*delta)*Cfgsat)));
Cfg = ((model_.HFIN)*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
}
Cgg_side = (Ccg+Cfg);
}
// End block cfr_side_dblgate
}
else
{
//Begin block cfr_side_trigate
{
//Block-local variables for block cfr_side_trigate
double Hr=0.0;
double Lr=0.0;
double Hgdelta=0.0;
double Lmax=0.0;
double y=0.0;
double x=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_trigate
double CcgSat=0.0;
double Cnon=0.0;
double TT1=0.0;
double Ccg1=0.0;
double r1cf=0.0;
double Rcf=0.0;
double Ccg2=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_trigate
double Ccg=0.0;
double C1=0.0;
double C2=0.0;
double C3=0.0;
double Cfglog=0.0;
double dcf=0.0;
double TT0=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_trigate
double TT2=0.0;
double Cfgsat=0.0;
double delta=0.0;
double Cfg=0.0;
//End of Block-local variables
Hr = (2.3+((0.2*(Wg+(model_.TOXP)))/Trsd));
Lr = 1.05;
{
double value_fabs_0 = fabs(((Wg+(model_.TOXP))-Trsd));
Hgdelta = value_fabs_0;
}
Lmax = ((model_.LSP)*Lr);
{
double value_min_0 = std::min(Trsd,(Wg+(model_.TOXP)));
y = value_min_0;
}
x = ((model_.LSP)/(Hr+1.0));
Cnon = 1.7e12;
CcgSat = ((epssp*(y-x))/(model_.LSP));
TT1 = (Cnon*CcgSat);
if ((TT1>80.0))
{
Ccg1 = CcgSat;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(TT1);
double value_log_1 = log((1.0+evaluator_lexp_0.getValues(TT1)));
Ccg1 = ((1.0/Cnon)*value_log_1);
}
}
{
double value_min_0 = std::min((Trsd/(Wg+(model_.TOXP))),((Wg+(model_.TOXP))/Trsd));
r1cf = (0.5*value_min_0);
}
Rcf = (Hgdelta*r1cf);
{
double value_log_0 = log((((model_.LSP)+((0.5*3.14159265358979323846)*Rcf))/(model_.LSP)));
Ccg2 = (((epssp*2)/3.14159265358979323846)*value_log_0);
}
Ccg = ((model_.HFIN)*(Ccg1+Ccg2));
x = (Lmax/Wg);
{
double value_sqrt_0 = sqrt((2.0*(x+1)));
C1 = (4.0/(value_sqrt_0*3.14159265358979323846));
}
{
double value_sqrt_0 = sqrt(((((model_.TOXP)*(model_.TOXP))+((2.0*Wg)*(model_.TOXP)))+((Wg*Wg)*(x+1))));
double value_sqrt_1 = sqrt((x+1));
C2 = ((((value_sqrt_0*value_sqrt_1)+(model_.TOXP))+(Wg*x))+Wg);
}
{
double value_sqrt_0 = sqrt(((x+1)*(x+4)));
C3 = (((model_.TOXP)*value_sqrt_0)+((model_.TOXP)*(x+2)));
}
{
double value_log_0 = log((C2/C3));
Cfglog = (epssp*((C1*value_log_0)+12.27));
}
dcf = (Hr*Lr);
{
double value_sqrt_0 = sqrt(((dcf*dcf)+1.0));
TT0 = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((dcf*dcf)+1)*((((dcf*(model_.TOXP))*(dcf*(model_.TOXP)))+(((2*dcf)*Lmax)*(model_.TOXP)))+((((dcf*dcf)+1)*Lmax)*Lmax))));
TT1 = (((value_sqrt_0+(dcf*(model_.TOXP)))+((dcf*dcf)*Lmax))+Lmax);
}
TT2 = ((TT0+1.0)*(dcf*(model_.TOXP)));
{
double value_sqrt_0 = sqrt(static_cast<double>(2.0));
double value_log_1 = log((TT1/TT2));
Cfgsat = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)/TT0)*value_log_1);
}
delta = 1.2e-12;
TT1 = ((Cfgsat-Cfglog)-delta);
{
double value_sqrt_0 = sqrt(((TT1*TT1)+((4*delta)*Cfgsat)));
Cfg = ((model_.HFIN)*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
}
Cgg_side = (Ccg+Cfg);
}
// End block cfr_side_trigate
}
if (((model_.TMASK)>0))
{
Acorner = 0.0;
}
else
{
if (((model_.HEPI)>0))
{
Acorner = ((FPITCH-TFIN)*(((model_.HEPI)*(model_.CRATIO))+(model_.TSILI)));
}
else
{
Acorner = ((FPITCH-TFIN)*Hrsd);
}
}
Ccorner = (((((NFIN*Acorner)+(model_.ARSDEND))+(model_.ASILIEND))*epssp)/(model_.LSP));
Cfr_geo = (((Ccorner+(Cgg_top*NFIN))+((((model_.CGEOE)*Cgg_side)*NFIN)*2.0))*(model_.NF));
{
double value_max_0 = std::max(((((model_.CGEOA)+((model_.CGEOB)*TFIN))+((model_.CGEOC)*FPITCH))+((model_.CGEOD)*LRSD)),static_cast<double>(0.0));
Cfr_geo = (Cfr_geo*value_max_0);
}
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+((model_.HFIN)/(model_.EOTBOX))));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((model_.CSDESW)*evaluator_lln_0.getValues((1.0+((model_.HFIN)/(model_.EOTBOX)))));
}
{
double value_max_0 = std::max(static_cast<double>(0.0),(PSEO-(FPITCH*NFINtotal)));
csbox = ((cbox*ASEO)+(T0*value_max_0));
}
{
double value_max_0 = std::max(static_cast<double>(0.0),(PDEO-(FPITCH*NFINtotal)));
cdbox = ((cbox*ADEO)+(T0*value_max_0));
}
cgbox = (((((model_.CGBO)*(model_.NF))*NGCON)+((model_.CGBN)*NFINtotal))*LeffCV);
EeffFactor = (1.0e-8/(epsratio*(model_.EOT)));
{
double value_pow_0 = pow((Weff0*1.0e6),WR_i);
WeffWRFactor = (1.0/(value_pow_0*NFINtotal));
}
{
double value_sqrt_0 = sqrt((((epsratio*(model_.EOT))*0.5)*TFIN));
litl = value_sqrt_0;
}
tmp = (((DVT1_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);
Theta_SCE = (0.5/(value_cosh_0-1.0));
}
}
else
{
{
double value_exp_0 = exp((-tmp));
Theta_SCE = value_exp_0;
}
}
tmp = (((DVT1SS_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);
Theta_SW = (0.5/(value_cosh_0-1.0));
}
}
else
{
{
double value_exp_0 = exp((-tmp));
Theta_SW = value_exp_0;
}
}
tmp = (((DSUB_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);
Theta_DIBL = (0.5/(value_cosh_0-1.0));
}
}
else
{
{
double value_exp_0 = exp((-tmp));
Theta_DIBL = value_exp_0;
}
}
{
double value_sqrt_0 = sqrt((1.0+(LPE0_i/Leff)));
Theta_RSCE = (value_sqrt_0-1.0);
}
if ((((model_.COREMOD)!=0)&&(NBODY_i>1e23)))
{
nbody = 1e23;
}
else
{
nbody = NBODY_i;
}
if (((model_.GEOMOD)!=3))
{
qbs = (((1.60219e-19*nbody)*TFIN)/(2*cox));
}
else
{
qbs = (((1.60219e-19*nbody)*R)/(2*cox));
}
if (((model_.GEOMOD)!=3))
{
phibulk = ((((1.60219e-19/(2*epssub))*nbody)*(TFIN/2))*(TFIN/2));
{
double value_sqrt_0 = sqrt(((((2*1.60219e-19)*nbody)*epssub)*phibulk));
Qbul = (((model_.COREMOD)!=0)?0:value_sqrt_0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((2.0/TFIN));
F2 = evaluator_lln_0.getValues((2.0/TFIN));
}
}
else
{
r1 = ((2*epssub)/(R*cox));
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
r1_acc = ((2.0*epssub)/(R*cox_acc));
}
}
if (((model_.DEVTYPE)==1))
{
Aechvb = 4.97232e-7;
}
else
{
Aechvb = 3.42537e-7;
}
if (((model_.DEVTYPE)==1))
{
Bechvb = 7.45669e11;
}
else
{
Bechvb = 1.16645e12;
}

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((model_.TOXG)*(model_.TOXG));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = ((model_.TOXG)*POXEDGE_i);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((model_.TOXREF)/(model_.TOXG)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((NTOX_i*evaluator_lln_0.getValues(((model_.TOXREF)/(model_.TOXG)))));
Toxratio = (evaluator_lexp_1.getValues((NTOX_i*evaluator_lln_0.getValues(((model_.TOXREF)/(model_.TOXG)))))/T0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((model_.TOXREF)/T1));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((NTOX_i*evaluator_lln_0.getValues(((model_.TOXREF)/T1))));
Toxratioedge = (evaluator_lexp_1.getValues((NTOX_i*evaluator_lln_0.getValues(((model_.TOXREF)/T1))))/T2);
}
igsd_mult0 = ((Weff0*Aechvb)*Toxratioedge);
if (((model_.TNOM)<(-273.15)))
{
UserInfo(*this)  << "Warning: (TNOM=%e) < -`P_CELSIUS0. Set to 27 C." << " " << (model_.TNOM) << " " <<  std::endl; 
Tnom = 300.15;
}
else
{
Tnom = ((model_.TNOM)+273.15);
}
}
// End block CMGBiasIndepCalc
DevTemp = (admsTemperature+(model_.DTEMP));
//Begin block CMGTempDepCalc
{
TRatio = (DevTemp/Tnom);
delTemp = (DevTemp-Tnom);
Vtm = (8.617087e-5*DevTemp);
Vtm0 = (8.617087e-5*Tnom);
Eg = ((model_.BG0SUB)-((((model_.TBGASUB)*DevTemp)*DevTemp)/(DevTemp+(model_.TBGBSUB))));
Eg0 = ((model_.BG0SUB)-((((model_.TBGASUB)*Tnom)*Tnom)/(Tnom+(model_.TBGBSUB))));
{
double value_sqrt_0 = sqrt((DevTemp/300.15));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = ((DevTemp/300.15)*value_sqrt_0);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((model_.BG0SUB)/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))));
ni = (((model_.NI0SUB)*T1)*evaluator_lexp_0.getValues((((model_.BG0SUB)/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm)))));
}
Nc = ((model_.NC0SUB)*T1);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TSS_i*delTemp))-1.0E-6),1.0E-3);
ThetaSS = evaluator_hypsmooth_0.getValues(((1.0+(TSS_i*delTemp))-1.0E-6),1.0E-3);
}
if (((model_.GEOMOD)!=3))
{
kT = (Vtm*1.60219e-19);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((1.05457e-34*3.14159265358979323846)/TFIN);
E0 = ((T0*T0)/(2.0*mx));
E0prime = ((T0*T0)/(2.0*mxprime));
E1 = (4.0*E0);
E1prime = (4.0*E0prime);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = ((gprime*mdprime)/(gfactor*md));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((E0-E0prime)/kT));
gam0 = (1.0+(T1*evaluator_lexp_0.getValues(((E0-E0prime)/kT))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((E0-E1)/kT));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((E0-E1prime)/kT));
gam1 = ((gam0+evaluator_lexp_0.getValues(((E0-E1)/kT)))+(T1*evaluator_lexp_1.getValues(((E0-E1prime)/kT))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/TFIN)*gam1));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = ((-Vtm)*evaluator_lln_0.getValues((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/TFIN)*gam1)));
}
dvch_qm = (QMFACTOR_i*((E0/1.60219e-19)+T2));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((1.05457e-34*2.4048)/R);
E0 = ((T0*T0)/(2.0*mx));
dvch_qm = ((QMFACTOR_i*E0)/1.60219e-19);
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0(((model_.TETA0)*delTemp),(-0.9),1e-4);
ETA0_t = (ETA0_i*(1.0+evaluator_hypmax_0.getValues(((model_.TETA0)*delTemp),(-0.9),1e-4)));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0(((model_.TETA0R)*delTemp),(-0.9),1e-4);
ETA0R_t = (ETA0R_i*(1.0+evaluator_hypmax_0.getValues(((model_.TETA0R)*delTemp),(-0.9),1e-4)));
}
{
double value_pow_0 = pow(TRatio,UTE_i);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = (U0_i*value_pow_0);
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((UTL_i*delTemp),((-0.9)*T1),1e-4);
U0_t = (T1+evaluator_hypmax_0.getValues((UTL_i*delTemp),((-0.9)*T1),1e-4));
}
u0 = U0_t;
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(EMOBT_i*delTemp))-1.0E-6),1.0E-3);
ETAMOB_t = (ETAMOB_i*evaluator_hypsmooth_0.getValues(((1.0+(EMOBT_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((UA1_i*delTemp),(-UA_i),1.0e-6);
UA_t = (UA_i+evaluator_hypmax_0.getValues((UA1_i*delTemp),(-UA_i),1.0e-6));
}
if (((model_.BULKMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3);
UC_t = (UC_i*evaluator_hypsmooth_0.getValues(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3));
}
}
{
double value_pow_0 = pow(TRatio,UD1_i);
UD_t = (UD_i*value_pow_0);
}
{
double value_pow_0 = pow(TRatio,UCSTE_i);
UCS_t = (UCS_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(PRT_i*delTemp))-1.0E-6),1.0E-3);
rdstemp = evaluator_hypsmooth_0.getValues(((1.0+(PRT_i*delTemp))-1.0E-6),1.0E-3);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TRSDR)*delTemp))-1.0E-6),1.0E-3);
RSDR_t = ((model_.RSDR)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TRSDR)*delTemp))-1.0E-6),1.0E-3));
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TRSDR)*delTemp))-1.0E-6),1.0E-3);
RSDRR_t = ((model_.RSDRR)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TRSDR)*delTemp))-1.0E-6),1.0E-3));
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TRDDR)*delTemp))-1.0E-6),1.0E-3);
RDDR_t = ((model_.RDDR)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TRDDR)*delTemp))-1.0E-6),1.0E-3));
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TRDDR)*delTemp))-1.0E-6),1.0E-3);
RDDRR_t = ((model_.RDDRR)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TRDDR)*delTemp))-1.0E-6),1.0E-3));
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
VSAT_t = (VSAT_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSAT_t<1000))
{
UserInfo(*this)  << "Warning: VSAT(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSAT_t << " " <<  std::endl; 
VSAT_t = 1000;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
VSAT1_t = (VSAT1_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSAT1_t<1000))
{
UserInfo(*this)  << "Warning: VSAT1(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSAT1_t << " " <<  std::endl; 
VSAT1_t = 1000;
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
VSAT1R_t = (VSAT1R_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSAT1R_t<1000))
{
UserInfo(*this)  << "Warning: VSAT1R(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSAT1R_t << " " <<  std::endl; 
VSAT1R_t = 1000;
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
VSATCV_t = (VSATCV_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSATCV_t<1000))
{
UserInfo(*this)  << "Warning: VSATCV(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSATCV_t << " " <<  std::endl; 
VSATCV_t = 1000;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((MEXP_i*(1.0+((model_.TMEXP)*delTemp)))-2.0),1.0E-3);
MEXP_t = (evaluator_hypsmooth_0.getValues(((MEXP_i*(1.0+((model_.TMEXP)*delTemp)))-2.0),1.0E-3)+2.0);
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((MEXPR_i*(1.0+((model_.TMEXPR)*delTemp)))-2.0),1.0E-3);
MEXPR_t = (evaluator_hypsmooth_0.getValues(((MEXPR_i*(1.0+((model_.TMEXPR)*delTemp)))-2.0),1.0E-3)+2.0);
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3);
PTWG_t = (PTWG_i*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
if (((model_.ASYMMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3);
PTWGR_t = (PTWGR_i*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
}
dvth_temp = ((KT1_i+((model_.KT1L)/Leff))*(TRatio-1.0));
{
double value_pow_0 = pow(TRatio,IIT_i);
BETA0_t = (BETA0_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1+(TII_i*(TRatio-1)))-0.01),1.0E-3);
SII0_t = (SII0_i*(evaluator_hypsmooth_0.getValues(((1+(TII_i*(TRatio-1)))-0.01),1.0E-3)+0.01));
}
K0_t = (K0_i+(K01_i*delTemp));
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((K0SI1_i*delTemp),(-K0SI_i),1E-6);
K0SI_t = (K0SI_i+evaluator_hypmax_0.getValues((K0SI1_i*delTemp),(-K0SI_i),1E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((K1SI1_i*delTemp),(-K1SI_i),1E-6);
K1SI_t = (K1SI_i+evaluator_hypmax_0.getValues((K1SI1_i*delTemp),(-K1SI_i),1E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((K11_i*delTemp),(-K1_i),1E-6);
K1_t = (K1_i+evaluator_hypmax_0.getValues((K11_i*delTemp),(-K1_i),1E-6));
}
K1SAT_t = (K1SAT_i+(K1SAT1_i*delTemp));
A1_t = (A1_i+(A11_i*delTemp));
A2_t = (A2_i+(A21_i*delTemp));
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0E-6);
AIGBINV_t = (AIGBINV_i+evaluator_hypmax_0.getValues((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0E-6);
AIGBACC_t = (AIGBACC_i+evaluator_hypmax_0.getValues((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGC1_i*delTemp),(-AIGC_i),1.0E-6);
AIGC_t = (AIGC_i+evaluator_hypmax_0.getValues((AIGC1_i*delTemp),(-AIGC_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGS1_i*delTemp),(-AIGS_i),1.0E-6);
AIGS_t = (AIGS_i+evaluator_hypmax_0.getValues((AIGS1_i*delTemp),(-AIGS_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGD1_i*delTemp),(-AIGD_i),1.0E-6);
AIGD_t = (AIGD_i+evaluator_hypmax_0.getValues((AIGD1_i*delTemp),(-AIGD_i),1.0E-6));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3);
BGIDL_t = (BGIDL_i*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3);
BGISL_t = (BGISL_i*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0(((model_.ALPHA01)*delTemp),(-ALPHA0_i),1.0E-6);
ALPHA0_t = (ALPHA0_i+evaluator_hypmax_0.getValues(((model_.ALPHA01)*delTemp),(-ALPHA0_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0(((model_.ALPHA11)*delTemp),(-ALPHA1_i),1.0E-6);
ALPHA1_t = (ALPHA1_i+evaluator_hypmax_0.getValues(((model_.ALPHA11)*delTemp),(-ALPHA1_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0(((model_.ALPHAII01)*delTemp),(-ALPHAII0_i),1.0E-6);
ALPHAII0_t = (ALPHAII0_i+evaluator_hypmax_0.getValues(((model_.ALPHAII01)*delTemp),(-ALPHAII0_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0(((model_.ALPHAII11)*delTemp),(-ALPHAII1_i),1.0E-6);
ALPHAII1_t = (ALPHAII1_i+evaluator_hypmax_0.getValues(((model_.ALPHAII11)*delTemp),(-ALPHAII1_i),1.0E-6));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((IGT_i*evaluator_lln_0.getValues(TRatio)));
igtemp = evaluator_lexp_1.getValues((IGT_i*evaluator_lln_0.getValues(TRatio)));
}
igsd_mult = (igsd_mult0*igtemp);
if (((model_.BULKMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3);
CJS_t = ((model_.CJS)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3);
CJD_t = ((model_.CJD)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJ)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3);
CJSWS_t = ((model_.CJSWS)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3);
CJSWD_t = ((model_.CJSWD)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSW)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3);
CJSWGS_t = ((model_.CJSWGS)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3);
CJSWGD_t = ((model_.CJSWGD)*evaluator_hypsmooth_0.getValues(((1.0+((model_.TCJSWG)*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBS)-((model_.TPB)*delTemp))-0.01),1.0E-3);
PBS_t = (evaluator_hypsmooth_0.getValues((((model_.PBS)-((model_.TPB)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBD)-((model_.TPB)*delTemp))-0.01),1.0E-3);
PBD_t = (evaluator_hypsmooth_0.getValues((((model_.PBD)-((model_.TPB)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWS)-((model_.TPBSW)*delTemp))-0.01),1.0E-3);
PBSWS_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWS)-((model_.TPBSW)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWD)-((model_.TPBSW)*delTemp))-0.01),1.0E-3);
PBSWD_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWD)-((model_.TPBSW)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWGS)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3);
PBSWGS_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWGS)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.PBSWGD)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3);
PBSWGD_t = (evaluator_hypsmooth_0.getValues((((model_.PBSWGD)-((model_.TPBSWG)*delTemp))-0.01),1.0E-3)+0.01);
}

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((Eg0/Vtm0)-(Eg/Vtm));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = evaluator_lln_0.getValues(TRatio);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0+((model_.XTIS)*T1))/(model_.NJS)));

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = evaluator_lexp_0.getValues(((T0+((model_.XTIS)*T1))/(model_.NJS)));
}
JSS_t = ((model_.JSS)*T3);
JSWS_t = ((model_.JSWS)*T3);
JSWGS_t = ((model_.JSWGS)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0+((model_.XTID)*T1))/(model_.NJD)));

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = evaluator_lexp_0.getValues(((T0+((model_.XTID)*T1))/(model_.NJD)));
}
JSD_t = ((model_.JSD)*T3);
JSWD_t = ((model_.JSWD)*T3);
JSWGD_t = ((model_.JSWGD)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSS))*(TRatio-1))/Vtm));
JTSS_t = ((model_.JTSS)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSS))*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSD))*(TRatio-1))/Vtm));
JTSD_t = ((model_.JTSD)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSD))*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSSWS))*(TRatio-1))/Vtm));
JTSSWS_t = ((model_.JTSSWS)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSSWS))*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*(model_.XTSSWD))*(TRatio-1))/Vtm));
JTSSWD_t = ((model_.JTSSWD)*evaluator_lexp_0.getValues((((Eg0*(model_.XTSSWD))*(TRatio-1))/Vtm)));
}
{
double value_sqrt_0 = sqrt(((model_.JTWEFF)/Weff0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*(model_.XTSSWGS))*(TRatio-1))/Vtm));
JTSSWGS_t = (((model_.JTSSWGS)*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*(model_.XTSSWGS))*(TRatio-1))/Vtm)));
}
{
double value_sqrt_0 = sqrt(((model_.JTWEFF)/Weff0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*(model_.XTSSWGD))*(TRatio-1))/Vtm));
JTSSWGD_t = (((model_.JTSSWGD)*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*(model_.XTSSWGD))*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTS)*(1.0+((model_.TNJTS)*(TRatio-1.0))))-0.01),1.0E-3);
NJTS_t = (evaluator_hypsmooth_0.getValues((((model_.NJTS)*(1.0+((model_.TNJTS)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSD)*(1.0+((model_.TNJTSD)*(TRatio-1.0))))-0.01),1.0E-3);
NJTSD_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSD)*(1.0+((model_.TNJTSD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSW)*(1.0+((model_.TNJTSSW)*(TRatio-1.0))))-0.01),1.0E-3);
NJTSSW_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSW)*(1.0+((model_.TNJTSSW)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSWD)*(1.0+((model_.TNJTSSWD)*(TRatio-1.0))))-0.01),1.0E-3);
NJTSSWD_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSWD)*(1.0+((model_.TNJTSSWD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSWG)*(1.0+((model_.TNJTSSWG)*(TRatio-1.0))))-0.01),1.0E-3);
NJTSSWG_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSWG)*(1.0+((model_.TNJTSSWG)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.NJTSSWGD)*(1.0+((model_.TNJTSSWGD)*(TRatio-1.0))))-0.01),1.0E-3);
NJTSSWGD_t = (evaluator_hypsmooth_0.getValues((((model_.NJTSSWGD)*(1.0+((model_.TNJTSSWGD)*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
}
beta0 = (((u0*cox)*Weff0)/Leff);
if (((model_.NGATE)>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((model_.NGATE)/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues(((model_.NGATE)/ni)))),1.0E-4);
AnalogFunctions::llnEvaluator evaluator_lln_2(((model_.NSD)/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_3(((0.5*Eg)-(Vtm*evaluator_lln_2.getValues(((model_.NSD)/ni)))),1.0E-4);
vfbsd = (devsign*(evaluator_hypsmooth_1.getValues(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues(((model_.NGATE)/ni)))),1.0E-4)-((0.5*Eg)-(devsign*((0.5*Eg)-evaluator_hypsmooth_3.getValues(((0.5*Eg)-(Vtm*evaluator_lln_2.getValues(((model_.NSD)/ni)))),1.0E-4))))));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((model_.NSD)/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues(((model_.NSD)/ni)))),1.0E-4);
vfbsd = (devsign*(PHIG_i-(((model_.EASUB)+(0.5*Eg))-(devsign*((0.5*Eg)-evaluator_hypsmooth_1.getValues(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues(((model_.NSD)/ni)))),1.0E-4))))));
}
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((nbody/ni));
phib = (Vtm*evaluator_lln_0.getValues((nbody/ni)));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((nbody*(model_.NSD))/(ni*ni)));
vbi = (Vtm*evaluator_lln_0.getValues(((nbody*(model_.NSD))/(ni*ni))));
}
if ((NGATE_i>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((NGATE_i/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((NGATE_i/ni)))),1.0E-4);
deltaPhi = evaluator_hypsmooth_1.getValues(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((NGATE_i/ni)))),1.0E-4);
}
if (((model_.GEOMOD)!=3))
{
vpoly0 = (((1.60219e-19*NGATE_i)*epssub)/((2.0*cox)*cox));
cpoly = (1.0/(4.0*vpoly0));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((R+(model_.EOT))/R);
vpoly0 = (((((1.60219e-19*NGATE_i)*epssub)*T0)*T0)/((2.0*cox)*cox));
cpoly = (1.0/(4.0*vpoly0));
}
kpoly = (1.0+((2.0*cpoly)*qbs));
}
else
{
deltaPhi = (devsign*(PHIG_i-((model_.EASUB)+(((model_.DEVTYPE)==1)?0:Eg))));
cpoly = 0.0;
vpoly0 = 0.0;
kpoly = 0.0;
}
if (((model_.GEOMOD)!=3))
{
r1 = ((2.0*epssub)/(cox*TFIN));
g0max = 1.57079;
g0min = 1e-37;
Inv_r1pi = (1.0/(r1*3.14159265358979323846));
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
r1_acc = ((2.0*epssub)/(cox_acc*TFIN));
Inv_r1pi_acc = (1.0/(r1_acc*3.14159265358979323846));
}
}
else
{
g0max = 700;
g0min = 1e-37;
}
if ((NGATE_i>0))
{
if (((model_.GEOMOD)!=3))
{
r2 = (((4.0*Vtm)*epssub)/(((1.60219e-19*TFIN)*TFIN)*NGATE_i));
}
else
{
r2 = ((((2.0*cpoly)*r1)*r1)*Vtm);
}
}
else
{
r2 = 0.0;
}
eta_mu = (0.5*ETAMOB_t);
eta_mu_cv = 0.5;
if (((model_.DEVTYPE)!=1))
{
eta_mu = ((1.0/3.0)*ETAMOB_t);
eta_mu_cv = (1.0/3.0);
}
if (((model_.BULKMOD)!=0))
{
Isbs = (((ASEJ*JSS_t)+(PSEJ*JSWS_t))+((Weff0*NFINtotal)*JSWGS_t));
if ((Isbs>0.0))
{
Nvtms = (Vtm*(model_.NJS));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(model_.BVS))/Nvtms));
XExpBVS = (evaluator_lexp_0.getValues(((-(model_.BVS))/Nvtms))*(model_.XJBVS));
}
{
double value_max_0 = std::max(((model_.IJTHSFWD)/Isbs),static_cast<double>(10.0));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = value_max_0;
}

d_Tb_dV_g_si = d_Tb_dV_di_si = d_Tb_dV_e_si = d_Tb_dV_e_di = d_Tb_dV_g_e =  0.0;
Tb = ((1.0+T2)-XExpBVS);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVS)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
VjsmFwd = (Nvtms*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjsmFwd/Nvtms));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = evaluator_lexp_0.getValues((VjsmFwd/Nvtms));
}
IVjsmFwd = (Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
SslpFwd = ((Isbs*(T0+(XExpBVS/T0)))/Nvtms);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.IJTHSREV)/Isbs)-10.0),1.0E-3);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = (evaluator_hypsmooth_0.getValues((((model_.IJTHSREV)/Isbs)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((T2-1.0)/(model_.XJBVS)));
VjsmRev = ((-(model_.BVS))-(Nvtms*evaluator_lln_0.getValues(((T2-1.0)/(model_.XJBVS)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-((model_.BVS)+VjsmRev))/Nvtms));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = ((model_.XJBVS)*evaluator_lexp_0.getValues(((-((model_.BVS)+VjsmRev))/Nvtms)));
}
IVjsmRev = (Isbs*(1.0+T1));
SslpRev = (((-Isbs)*T1)/Nvtms);
}
Isbd = (((ADEJ*JSD_t)+(PDEJ*JSWD_t))+((Weff0*NFINtotal)*JSWGD_t));
if ((Isbd>0.0))
{
Nvtmd = (Vtm*(model_.NJD));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(model_.BVD))/Nvtmd));
XExpBVD = (evaluator_lexp_0.getValues(((-(model_.BVD))/Nvtmd))*(model_.XJBVD));
}
{
double value_max_0 = std::max(((model_.IJTHDFWD)/Isbd),static_cast<double>(10.0));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = value_max_0;
}

d_Tb_dV_g_si = d_Tb_dV_di_si = d_Tb_dV_e_si = d_Tb_dV_e_di = d_Tb_dV_g_e =  0.0;
Tb = ((1.0+T2)-XExpBVD);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVD)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
VjdmFwd = (Nvtmd*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjdmFwd/Nvtmd));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = evaluator_lexp_0.getValues((VjdmFwd/Nvtmd));
}
IVjdmFwd = (Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
DslpFwd = ((Isbd*(T0+(XExpBVD/T0)))/Nvtmd);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((((model_.IJTHDREV)/Isbd)-10.0),1.0E-3);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = (evaluator_hypsmooth_0.getValues((((model_.IJTHDREV)/Isbd)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((T2-1.0)/(model_.XJBVD)));
VjdmRev = ((-(model_.BVD))-(Nvtmd*evaluator_lln_0.getValues(((T2-1.0)/(model_.XJBVD)))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-((model_.BVD)+VjdmRev))/Nvtmd));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = ((model_.XJBVD)*evaluator_lexp_0.getValues(((-((model_.BVD)+VjdmRev))/Nvtmd)));
}
IVjdmRev = (Isbd*(1.0+T1));
DslpRev = (((-Isbd)*T1)/Nvtmd);
}
Czbs = (CJS_t*ASEJ);
Czbssw = (CJSWS_t*PSEJ);
Czbsswg = ((CJSWGS_t*Weff0)*NFINtotal);
Czbd = (CJD_t*ADEJ);
Czbdsw = (CJSWD_t*PDEJ);
Czbdswg = ((CJSWGD_t*Weff0)*NFINtotal);
}

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((Eg/Vtm)*(TRatio-1.0));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = (T0/NTGEN_i);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
igentemp = evaluator_lexp_0.getValues(T1);
}
}
// End block CMGTempDepCalc
if ((!initialized))
{
UserInfo(*this)  << "Warning: initial_step is not triggered at the first execution of this code.  As a result, bias-independent variables may not be initialized.  Check your simulator for Verilog-A language compatibility." << " " <<  std::endl; 
}
else
{

d_vgs_noswap_dV_g_si = devsign*d_probeVars[admsProbeID_V_g_si][admsProbeID_V_g_si];
vgs_noswap = (devsign*(probeVars[admsProbeID_V_g_si]));

d_vds_noswap_dV_di_si = devsign*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si];
vds_noswap = (devsign*(probeVars[admsProbeID_V_di_si]));

d_vgd_noswap_dV_g_di = devsign*d_probeVars[admsProbeID_V_g_di][admsProbeID_V_g_di];
vgd_noswap = (devsign*(probeVars[admsProbeID_V_g_di]));

d_ves_jct_dV_e_si = devsign*d_probeVars[admsProbeID_V_e_si][admsProbeID_V_e_si];
ves_jct = (devsign*(probeVars[admsProbeID_V_e_si]));

d_ved_jct_dV_e_di = devsign*d_probeVars[admsProbeID_V_e_di][admsProbeID_V_e_di];
ved_jct = (devsign*(probeVars[admsProbeID_V_e_di]));

d_vge_dV_g_e = devsign*d_probeVars[admsProbeID_V_g_e][admsProbeID_V_g_e];
vge = (devsign*(probeVars[admsProbeID_V_g_e]));
sigvds = 1.0;
if ((vds_noswap<0.0))
{
sigvds = (-1.0);

d_vgs_dV_di_si = (-d_vds_noswap_dV_di_si);
d_vgs_dV_g_si = d_vgs_noswap_dV_g_si;
vgs = (vgs_noswap-vds_noswap);

d_vds_dV_di_si = (-1.0)*d_vds_noswap_dV_di_si;
vds = ((-1.0)*vds_noswap);
vgd = (vgd_noswap+vds_noswap);

d_ves_dV_e_si =  0.0;
d_ves_dV_e_di = d_ved_jct_dV_e_di;
ves = ved_jct;
}
else
{

d_vgs_dV_di_si =  0.0;
d_vgs_dV_g_si = d_vgs_noswap_dV_g_si;
vgs = vgs_noswap;

d_vds_dV_di_si = d_vds_noswap_dV_di_si;
vds = vds_noswap;
vgd = vgd_noswap;

d_ves_dV_e_di =  0.0;
d_ves_dV_e_si = d_ves_jct_dV_e_si;
ves = ves_jct;
}

d_vgsfb_dV_di_si = d_vgs_dV_di_si;
d_vgsfb_dV_g_si = d_vgs_dV_g_si;
vgsfb = (vgs-deltaPhi);

d_etaiv_dV_di_si = d_etaiv_dV_e_si = d_etaiv_dV_e_di = d_etaiv_dV_g_e = d_etaiv_dV_g_si =  0.0;
etaiv = 0.0;

d_Qes_dV_di_d = d_Qes_dV_si_s = d_Qes_dV_g_di = d_Qes_dV_e_si = d_Qes_dV_e_di = d_Qes_dV_g_e = d_Qes_dV_g_si = d_Qes_dV_di_si =  0.0;
Qes = 0.0;

d_Qesj_dV_di_d = d_Qesj_dV_si_s = d_Qesj_dV_g_di = d_Qesj_dV_e_si = d_Qesj_dV_e_di = d_Qesj_dV_g_e = d_Qesj_dV_g_si = d_Qesj_dV_di_si =  0.0;
Qesj = 0.0;

d_Qeg_dV_g_di = d_Qeg_dV_g_e = d_Qeg_dV_g_si = d_Qeg_dV_e_si = d_Qeg_dV_e_di = d_Qeg_dV_di_si = d_Qeg_dV_e_g =  0.0;
Qeg = 0.0;

d_Qed_dV_di_d = d_Qed_dV_si_s = d_Qed_dV_g_di = d_Qed_dV_e_si = d_Qed_dV_e_di = d_Qed_dV_g_e = d_Qed_dV_g_si = d_Qed_dV_di_si =  0.0;
Qed = 0.0;

d_Qedj_dV_di_d = d_Qedj_dV_si_s = d_Qedj_dV_g_di = d_Qedj_dV_e_si = d_Qedj_dV_e_di = d_Qedj_dV_g_e = d_Qedj_dV_g_si = d_Qedj_dV_di_si =  0.0;
Qedj = 0.0;
{
double value_sqrt_0 = sqrt(((vds*vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vdsx_dV_di_si = (deriv_sqrt_0_d0*((vds*d_vds_dV_di_si+d_vds_dV_di_si*vds)));
vdsx = (value_sqrt_0-0.1);
}
if (((model_.BULKMOD)!=0))
{

d_vesx_dV_di_si = (-0.5*(d_vds_dV_di_si-d_vdsx_dV_di_si));
d_vesx_dV_e_di = d_ves_dV_e_di;
d_vesx_dV_e_si = d_ves_dV_e_si;
vesx = (ves-(0.5*(vds-vdsx)));
vesmax = (0.95*PHIBE_i);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si =  0.0;
d_T2_dV_di_si = (-d_vesx_dV_di_si);
d_T2_dV_e_di = (-d_vesx_dV_e_di);
d_T2_dV_e_si = (-d_vesx_dV_e_si);
T2 = ((vesmax-vesx)-1.0E-3);
{
double value_sqrt_0 = sqrt(((T2*T2)+(0.004*vesmax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_veseff_dV_di_si = (-0.5*(d_T2_dV_di_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_di_si+d_T2_dV_di_si*T2)))));
d_veseff_dV_e_di = (-0.5*(d_T2_dV_e_di+(deriv_sqrt_0_d0*((T2*d_T2_dV_e_di+d_T2_dV_e_di*T2)))));
d_veseff_dV_e_si = (-0.5*(d_T2_dV_e_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_e_si+d_T2_dV_e_si*T2)))));
veseff = (vesmax-(0.5*(T2+value_sqrt_0)));
}
}
{
double value_tanh_0 = tanh(((0.6*vds_noswap)/Vtm));
double  deriv_tanh_0_d0 = (1.0/cosh(((0.6*vds_noswap)/Vtm))/cosh(((0.6*vds_noswap)/Vtm)));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = (deriv_tanh_0_d0*((0.6*d_vds_noswap_dV_di_si/Vtm)));
T0 = value_tanh_0;
}

d_wf_dV_di_si = 0.5*d_T0_dV_di_si;
wf = (0.5+(0.5*T0));

d_wr_dV_di_si = (-d_wf_dV_di_si);
wr = (1.0-wf);
if (((model_.ASYMMOD)!=0))
{

d_CDSCD_a_dV_di_si = (CDSCDR_i*d_wr_dV_di_si+CDSCD_i*d_wf_dV_di_si);
CDSCD_a = ((CDSCDR_i*wr)+(CDSCD_i*wf));

d_ETA0_a_dV_di_si = (ETA0R_t*d_wr_dV_di_si+ETA0_t*d_wf_dV_di_si);
ETA0_a = ((ETA0R_t*wr)+(ETA0_t*wf));

d_PDIBL1_a_dV_di_si = (PDIBL1R_i*d_wr_dV_di_si+PDIBL1_i*d_wf_dV_di_si);
PDIBL1_a = ((PDIBL1R_i*wr)+(PDIBL1_i*wf));

d_MEXP_a_dV_di_si = (MEXPR_t*d_wr_dV_di_si+MEXP_t*d_wf_dV_di_si);
MEXP_a = ((MEXPR_t*wr)+(MEXP_t*wf));

d_PTWG_a_dV_di_si = (PTWGR_t*d_wr_dV_di_si+PTWG_t*d_wf_dV_di_si);
PTWG_a = ((PTWGR_t*wr)+(PTWG_t*wf));

d_VSAT1_a_dV_di_si = (VSAT1R_t*d_wr_dV_di_si+VSAT1_t*d_wf_dV_di_si);
VSAT1_a = ((VSAT1R_t*wr)+(VSAT1_t*wf));

d_RSDR_a_dV_di_si = (RSDRR_t*d_wr_dV_di_si+RSDR_t*d_wf_dV_di_si);
RSDR_a = ((RSDRR_t*wr)+(RSDR_t*wf));

d_RDDR_a_dV_di_si = (RDDRR_t*d_wr_dV_di_si+RDDR_t*d_wf_dV_di_si);
RDDR_a = ((RDDRR_t*wr)+(RDDR_t*wf));
}
else
{

d_CDSCD_a_dV_di_si =  0.0;
CDSCD_a = CDSCD_i;

d_ETA0_a_dV_di_si =  0.0;
ETA0_a = ETA0_t;

d_PDIBL1_a_dV_di_si =  0.0;
PDIBL1_a = PDIBL1_i;

d_MEXP_a_dV_di_si =  0.0;
MEXP_a = MEXP_t;

d_PTWG_a_dV_di_si =  0.0;
PTWG_a = PTWG_t;

d_VSAT1_a_dV_di_si =  0.0;
VSAT1_a = VSAT1_t;

d_RSDR_a_dV_di_si =  0.0;
RSDR_a = RSDR_t;

d_RDDR_a_dV_di_si =  0.0;
RDDR_a = RDDR_t;
}

d_inv_MEXP_dV_di_si = (-d_MEXP_a_dV_di_si/MEXP_a/MEXP_a);
inv_MEXP = (1.0/MEXP_a);
phist = ((0.4+phib)+PHIN_i);
if (((model_.GEOMOD)!=3))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = (((2*cox)*csi)/((2*csi)+cox));
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = cox;
}

d_cdsc_dV_di_si = Theta_SW*(CDSCD_a*d_vdsx_dV_di_si+d_CDSCD_a_dV_di_si*vdsx);
cdsc = (Theta_SW*(CDSC_i+(CDSCD_a*vdsx)));

d_nVtm_dV_di_si = (Vtm*ThetaSS)*((T1*d_cdsc_dV_di_si-((CIT_i/TRatio)+cdsc)*d_T1_dV_di_si)/T1/T1);
nVtm = ((Vtm*ThetaSS)*(1.0+(((CIT_i/TRatio)+cdsc)/T1)));
dvth_vtroll = (((-DVT0_i)*Theta_SCE)*(vbi-phist));
{
double value_pow_0 = pow(vdsx,(model_.DVTP1));
double  deriv_pow_0_d0 = ((vdsx == 0.0)?0.0:(value_pow_0*(model_.DVTP1)/vdsx));

d_dvth_dibl_dV_di_si = ((((-ETA0_a)*Theta_DIBL)*d_vdsx_dV_di_si+(-d_ETA0_a_dV_di_si)*Theta_DIBL*vdsx)+(model_.DVTP0)*(deriv_pow_0_d0*(d_vdsx_dV_di_si)));
dvth_dibl = ((((-ETA0_a)*Theta_DIBL)*vdsx)+((model_.DVTP0)*value_pow_0));
}
{
double value_sqrt_0 = sqrt(phist);
dvth_rsce = ((K1RSCE_i*Theta_RSCE)*value_sqrt_0);
}

d_dvth_all_dV_di_si = d_dvth_dibl_dV_di_si;
dvth_all = ((((dvth_vtroll+dvth_dibl)+dvth_rsce)+dvth_temp)+DVTSHIFT_i);

d_vgsfb_dV_di_si = (d_vgsfb_dV_di_si-d_dvth_all_dV_di_si);
vgsfb = (vgsfb-dvth_all);
if (((model_.GEOMOD)!=3))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2*epssub)*nVtm)/(1.60219e-19*Nc)));

d_F1_dV_di_si = 0.5*evaluator_lln_0.getDerivs((((2*epssub)*nVtm)/(1.60219e-19*Nc)),((2*epssub)*d_nVtm_dV_di_si/(1.60219e-19*Nc)));
F1 = ((0.5*evaluator_lln_0.getValues((((2*epssub)*nVtm)/(1.60219e-19*Nc))))+F2);
}
if (((model_.COREMOD)!=0))
{

vgsfb = (vgsfb-((((0.5*1.60219e-19)*nbody)*TFIN)/cox));
}
else
{

d_q0_dV_di_si = (5.0*d_nVtm_dV_di_si*(epssub/TFIN)/cox);
q0 = ((((5.0*nVtm)*(epssub/TFIN))+(2.0*Qbul))/cox);
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2*epssub)*Vtm)/(1.60219e-19*Nc)));
F1_acc = ((0.5*evaluator_lln_0.getValues((((2*epssub)*Vtm)/(1.60219e-19*Nc))))+F2);
}
}

d_cdop_dV_di_si =  0.0;
cdop = 1.0;
}
else
{

d_q0_dV_di_si = 2.0*d_nVtm_dV_di_si*r1;
q0 = ((2.0*nVtm)*r1);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = (((1.60219e-19*nbody)*R)/cox);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((nVtm/T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-T0)/((2.0*r1)*nVtm)));
AnalogFunctions::llnEvaluator evaluator_lln_2((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))));

d_vtdop_dV_di_si = (((-nVtm)*evaluator_lln_0.getDerivs((nVtm/T0),((T0*d_nVtm_dV_di_si-nVtm*d_T0_dV_di_si)/T0/T0))+(-d_nVtm_dV_di_si)*evaluator_lln_0.getValues((nVtm/T0)))-(nVtm*evaluator_lln_2.getDerivs((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))),(-evaluator_lexp_1.getDerivs(((-T0)/((2.0*r1)*nVtm)),((((2.0*r1)*nVtm)*(-d_T0_dV_di_si)-(-T0)*(2.0*r1)*d_nVtm_dV_di_si)/((2.0*r1)*nVtm)/((2.0*r1)*nVtm)))))+d_nVtm_dV_di_si*evaluator_lln_2.getValues((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))))));
vtdop = (((-nVtm)*evaluator_lln_0.getValues((nVtm/T0)))-(nVtm*evaluator_lln_2.getValues((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-vtdop)/nVtm));

d_cdop_dV_di_si = (2.0*r1)*evaluator_lexp_0.getDerivs(((-vtdop)/nVtm),((nVtm*(-d_vtdop_dV_di_si)-(-vtdop)*d_nVtm_dV_di_si)/nVtm/nVtm));
cdop = ((2.0*r1)*evaluator_lexp_0.getValues(((-vtdop)/nVtm)));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((0.5*T0)/nVtm));

d_vt0_dV_di_si = (((0.5*d_T0_dV_di_si+((2.0*phib)*d_nVtm_dV_di_si/Vtm))-(nVtm*evaluator_lln_0.getDerivs(((0.5*T0)/nVtm),((nVtm*0.5*d_T0_dV_di_si-(0.5*T0)*d_nVtm_dV_di_si)/nVtm/nVtm))+d_nVtm_dV_di_si*evaluator_lln_0.getValues(((0.5*T0)/nVtm))))+d_vtdop_dV_di_si);
vt0 = ((((0.5*T0)+(((2.0*phib)*nVtm)/Vtm))-(nVtm*evaluator_lln_0.getValues(((0.5*T0)/nVtm))))+vtdop);
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
q0_acc = ((2.0*Vtm)*r1_acc);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = (((1.60219e-19*ni)*R)/cox_acc);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((Vtm/T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-T0)/((2.0*r1_acc)*Vtm)));
AnalogFunctions::llnEvaluator evaluator_lln_2((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1_acc)*Vtm)))));

d_vtdop_acc_dV_di_si = ((-Vtm)*evaluator_lln_0.getDerivs((Vtm/T0),(-Vtm*d_T0_dV_di_si/T0/T0))-Vtm*evaluator_lln_2.getDerivs((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1_acc)*Vtm)))),(-evaluator_lexp_1.getDerivs(((-T0)/((2.0*r1_acc)*Vtm)),((-d_T0_dV_di_si)/((2.0*r1_acc)*Vtm))))));
vtdop_acc = (((-Vtm)*evaluator_lln_0.getValues((Vtm/T0)))-(Vtm*evaluator_lln_2.getValues((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1_acc)*Vtm)))))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-vtdop_acc)/Vtm));

d_cdop_acc_dV_di_si = (2.0*r1_acc)*evaluator_lexp_0.getDerivs(((-vtdop_acc)/Vtm),((-d_vtdop_acc_dV_di_si)/Vtm));
cdop_acc = ((2.0*r1_acc)*evaluator_lexp_0.getValues(((-vtdop_acc)/Vtm)));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((0.5*T0)/Vtm));

d_vt0_acc_dV_di_si = ((0.5*d_T0_dV_di_si-Vtm*evaluator_lln_0.getDerivs(((0.5*T0)/Vtm),(0.5*d_T0_dV_di_si/Vtm)))+d_vtdop_acc_dV_di_si);
vt0_acc = (((0.5*T0)-(Vtm*evaluator_lln_0.getValues(((0.5*T0)/Vtm))))+vtdop_acc);
}
}
}
if (((model_.GEOMOD)!=3))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*Nc)*TFIN)));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = (-(nVtm*evaluator_lln_0.getDerivs((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*Nc)*TFIN)),(-((2.0*cox)*(model_.Imin))*beta0*d_nVtm_dV_di_si*1.60219e-19*Nc*TFIN/((((beta0*nVtm)*1.60219e-19)*Nc)*TFIN)/((((beta0*nVtm)*1.60219e-19)*Nc)*TFIN)))+d_nVtm_dV_di_si*evaluator_lln_0.getValues((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*Nc)*TFIN)))));
T0 = (-(dvch_qm+(nVtm*evaluator_lln_0.getValues((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*Nc)*TFIN))))));
}

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e =  0.0;
d_T1_dV_di_si = (d_vgsfb_dV_di_si+d_T0_dV_di_si);
d_T1_dV_g_si = (d_vgsfb_dV_g_si+d_T0_dV_g_si);
T1 = ((vgsfb+T0)+DELVTRAND);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);

d_vgsfbeff_dV_di_si = (evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_di_si,0.0)-d_T0_dV_di_si);
d_vgsfbeff_dV_g_si = (evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_g_si,0.0)-d_T0_dV_g_si);
vgsfbeff = (evaluator_hypsmooth_0.getValues(T1,1.0E-4)-T0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*ni)*R)));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = (-(nVtm*evaluator_lln_0.getDerivs((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*ni)*R)),(-((2.0*cox)*(model_.Imin))*beta0*d_nVtm_dV_di_si*1.60219e-19*ni*R/((((beta0*nVtm)*1.60219e-19)*ni)*R)/((((beta0*nVtm)*1.60219e-19)*ni)*R)))+d_nVtm_dV_di_si*evaluator_lln_0.getValues((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*ni)*R)))));
T0 = (-(dvch_qm+(nVtm*evaluator_lln_0.getValues((((2.0*cox)*(model_.Imin))/((((beta0*nVtm)*1.60219e-19)*ni)*R))))));
}

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e =  0.0;
d_T1_dV_di_si = ((d_vgsfb_dV_di_si+d_T0_dV_di_si)+(phib*d_nVtm_dV_di_si/Vtm));
d_T1_dV_g_si = (d_vgsfb_dV_g_si+d_T0_dV_g_si);
T1 = ((((vgsfb+DELVTRAND)+T0)+(0.5*Eg))+((phib*nVtm)/Vtm));
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);

d_vgsfbeff_dV_di_si = ((evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_di_si,0.0)-d_T0_dV_di_si)-d_vt0_dV_di_si);
d_vgsfbeff_dV_g_si = (evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_g_si,0.0)-d_T0_dV_g_si);
vgsfbeff = ((evaluator_hypsmooth_0.getValues(T1,1.0E-4)-T0)-vt0);
}
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_g_e = (-d_vge_dV_g_e);
T1 = ((((-vge)+deltaPhi)-(0.5*Eg))+(model_.DELVFBACC));
if (((model_.GEOMOD)!=3))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);

d_vgsfbeff_acc_dV_di_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_di_si,0.0);
d_vgsfbeff_acc_dV_g_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_g_si,0.0);
d_vgsfbeff_acc_dV_g_e = evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_g_e,0.0);
vgsfbeff_acc = (evaluator_hypsmooth_0.getValues(T1,1.0E-4)-(0.5*Eg));
}
}
else
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);

d_vgsfbeff_acc_dV_di_si = (evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_di_si,0.0)-d_vt0_acc_dV_di_si);
d_vgsfbeff_acc_dV_g_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_g_si,0.0);
d_vgsfbeff_acc_dV_g_e = evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dV_g_e,0.0);
vgsfbeff_acc = (evaluator_hypsmooth_0.getValues(T1,1.0E-4)-vt0_acc);
}
}
}
if (((model_.GEOMOD)!=3))
{

d_T14_dV_di_si = 2.0*d_nVtm_dV_di_si;
T14 = (2.0*nVtm);
if (((model_.COREMOD)==0))
{

d_aab_dV_di_si = (-phibulk*(nVtm*d_nVtm_dV_di_si+d_nVtm_dV_di_si*nVtm)/(nVtm*nVtm)/(nVtm*nVtm));
aab = (phibulk/(nVtm*nVtm));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = phibulk*d_aab_dV_di_si;
T0 = (phibulk*aab);
T11 = (((r1*phibulk)/nVtm)+(r2*T0));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((phibulk/(2.0*nVtm)));

d_T12_dV_di_si = evaluator_lexp_0.getDerivs((phibulk/(2.0*nVtm)),(-phibulk*2.0*d_nVtm_dV_di_si/(2.0*nVtm)/(2.0*nVtm)));
T12 = evaluator_lexp_0.getValues((phibulk/(2.0*nVtm)));
}

d_T13_dV_di_si = (T12*d_T12_dV_di_si+d_T12_dV_di_si*T12);
T13 = (T12*T12);
}
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
if (((model_.GEOMOD)!=3))
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di = d_F0_dV_e_si = d_F0_dV_e_di =  0.0;
d_F0_dV_di_si = (d_vgsfbeff_acc_dV_di_si/(2.0*Vtm));
d_F0_dV_g_si = (d_vgsfbeff_acc_dV_g_si/(2.0*Vtm));
d_F0_dV_g_e = (d_vgsfbeff_acc_dV_g_e/(2.0*Vtm));
F0 = ((vgsfbeff_acc/(2.0*Vtm))-F1_acc);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);

d_expff_dV_e_si = d_expff_dV_e_di =  0.0;
d_expff_dV_di_si = evaluator_lexp_0.getDerivs(F0,d_F0_dV_di_si);
d_expff_dV_g_si = evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_si);
d_expff_dV_g_e = evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_e);
expff = evaluator_lexp_0.getValues(F0);
}
{
double value_atan_0 = atan(expff);
double  deriv_atan_0_d0 = (+1.0/(1+expff*expff));

d_z1_dV_e_si = d_z1_dV_e_di =  0.0;
d_z1_dV_di_si = (deriv_atan_0_d0*(d_expff_dV_di_si));
d_z1_dV_g_si = (deriv_atan_0_d0*(d_expff_dV_g_si));
d_z1_dV_g_e = (deriv_atan_0_d0*(d_expff_dV_g_e));
z1 = value_atan_0;
}
if ((F0>80.0))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = d_F0_dV_di_si;
d_T0_dV_g_si = d_F0_dV_g_si;
d_T0_dV_g_e = d_F0_dV_g_e;
T0 = F0;
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+expff));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_di_si);
d_T0_dV_g_si = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_g_si);
d_T0_dV_g_e = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_g_e);
T0 = evaluator_lln_0.getValues((1.0+expff));
}
}
{
double value_atan_0 = atan(((2*T0)*Inv_r1pi_acc));
double  deriv_atan_0_d0 = (+1.0/(1+((2*T0)*Inv_r1pi_acc)*((2*T0)*Inv_r1pi_acc)));

d_z2_dV_e_si = d_z2_dV_e_di =  0.0;
d_z2_dV_di_si = (deriv_atan_0_d0*(2*d_T0_dV_di_si*Inv_r1pi_acc));
d_z2_dV_g_si = (deriv_atan_0_d0*(2*d_T0_dV_g_si*Inv_r1pi_acc));
d_z2_dV_g_e = (deriv_atan_0_d0*(2*d_T0_dV_g_e*Inv_r1pi_acc));
z2 = value_atan_0;
}
{
double value_max_0 = std::max(z2,static_cast<double>(1e-15));
double value_min_1 = std::min(z1,value_max_0);
double  deriv_max_0_d0 = ((z2>=1e-15)?1.0:0.0);
double  deriv_min_1_d0 = ((z1<=value_max_0)?1.0:0.0);
double  deriv_min_1_d1 = ((z1<=value_max_0)?0.0:1.0);

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = ((deriv_min_1_d0*(d_z1_dV_di_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_di_si)))));
d_g0_dV_g_si = ((deriv_min_1_d0*(d_z1_dV_g_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_g_si)))));
d_g0_dV_g_e = ((deriv_min_1_d0*(d_z1_dV_g_e))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_g_e)))));
g0 = value_min_1;
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_e_si = d_tang0_dV_e_di =  0.0;
d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);

d_lng0_dV_e_si = d_lng0_dV_e_di =  0.0;
d_lng0_dV_di_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si);
d_lng0_dV_g_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si);
d_lng0_dV_g_e = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e);
lng0 = evaluator_lln_0.getValues(g0);
}

d_secg0sq_dV_e_si = d_secg0sq_dV_e_di =  0.0;
d_secg0sq_dV_di_si = (tang0*d_tang0_dV_di_si+d_tang0_dV_di_si*tang0);
d_secg0sq_dV_g_si = (tang0*d_tang0_dV_g_si+d_tang0_dV_g_si*tang0);
d_secg0sq_dV_g_e = (tang0*d_tang0_dV_g_e+d_tang0_dV_g_e*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);

d_lncosg0_dV_e_si = d_lncosg0_dV_e_di =  0.0;
d_lncosg0_dV_di_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_di_si);
d_lncosg0_dV_g_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_si);
d_lncosg0_dV_g_e = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_e);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}

d_inv_g0_dV_e_si = d_inv_g0_dV_e_di =  0.0;
d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
inv_g0 = (1.0/g0);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
T0 = (g0*tang0);

d_e0_dV_e_si = d_e0_dV_e_di =  0.0;
d_e0_dV_di_si = (((d_lng0_dV_di_si-d_lncosg0_dV_di_si)+r1_acc*d_T0_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = (((d_lng0_dV_g_si-d_lncosg0_dV_g_si)+r1_acc*d_T0_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = (((d_lng0_dV_g_e-d_lncosg0_dV_g_e)+r1_acc*d_T0_dV_g_e)-d_F0_dV_g_e);
e0 = (((lng0-lncosg0)+(r1_acc*T0))-F0);

d_e1_dV_e_si = d_e1_dV_e_di =  0.0;
d_e1_dV_di_si = ((d_inv_g0_dV_di_si+(secg0sq*d_g0_dV_di_si+d_secg0sq_dV_di_si*g0)*r1_acc)+d_tang0_dV_di_si*(1.0+r1_acc));
d_e1_dV_g_si = ((d_inv_g0_dV_g_si+(secg0sq*d_g0_dV_g_si+d_secg0sq_dV_g_si*g0)*r1_acc)+d_tang0_dV_g_si*(1.0+r1_acc));
d_e1_dV_g_e = ((d_inv_g0_dV_g_e+(secg0sq*d_g0_dV_g_e+d_secg0sq_dV_g_e*g0)*r1_acc)+d_tang0_dV_g_e*(1.0+r1_acc));
e1 = ((inv_g0+((secg0sq*g0)*r1_acc))+(tang0*(1.0+r1_acc)));

d_e2_dV_e_si = d_e2_dV_e_di =  0.0;
d_e2_dV_di_si = ((secg0sq*2.0*d_T0_dV_di_si*r1_acc+d_secg0sq_dV_di_si*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0));
d_e2_dV_g_si = ((secg0sq*2.0*d_T0_dV_g_si*r1_acc+d_secg0sq_dV_g_si*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0));
d_e2_dV_g_e = ((secg0sq*2.0*d_T0_dV_g_e*r1_acc+d_secg0sq_dV_g_e*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0));
e2 = ((secg0sq*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*inv_g0));

d_e3_dV_e_si = d_e3_dV_e_di =  0.0;
d_e3_dV_di_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_di_si+((2.0*inv_g0)*d_inv_g0_dV_di_si+2.0*d_inv_g0_dV_di_si*inv_g0)*inv_g0)+(((2.0*g0)*secg0sq)*d_secg0sq_dV_di_si+((2.0*g0)*d_secg0sq_dV_di_si+2.0*d_g0_dV_di_si*secg0sq)*secg0sq)*r1_acc)+(((2.0*secg0sq)*tang0)*(2.0*r1_acc)*d_T0_dV_di_si+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
d_e3_dV_g_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_si+((2.0*inv_g0)*d_inv_g0_dV_g_si+2.0*d_inv_g0_dV_g_si*inv_g0)*inv_g0)+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_si+((2.0*g0)*d_secg0sq_dV_g_si+2.0*d_g0_dV_g_si*secg0sq)*secg0sq)*r1_acc)+(((2.0*secg0sq)*tang0)*(2.0*r1_acc)*d_T0_dV_g_si+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
d_e3_dV_g_e = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_e+((2.0*inv_g0)*d_inv_g0_dV_g_e+2.0*d_inv_g0_dV_g_e*inv_g0)*inv_g0)+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_e+((2.0*g0)*d_secg0sq_dV_g_e+2.0*d_g0_dV_g_e*secg0sq)*secg0sq)*r1_acc)+(((2.0*secg0sq)*tang0)*(2.0*r1_acc)*d_T0_dV_g_e+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*r1_acc))+(((2.0*secg0sq)*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_e_si = d_tang0_dV_e_di =  0.0;
d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);

d_lng0_dV_e_si = d_lng0_dV_e_di =  0.0;
d_lng0_dV_di_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si);
d_lng0_dV_g_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si);
d_lng0_dV_g_e = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e);
lng0 = evaluator_lln_0.getValues(g0);
}

d_secg0sq_dV_e_si = d_secg0sq_dV_e_di =  0.0;
d_secg0sq_dV_di_si = (tang0*d_tang0_dV_di_si+d_tang0_dV_di_si*tang0);
d_secg0sq_dV_g_si = (tang0*d_tang0_dV_g_si+d_tang0_dV_g_si*tang0);
d_secg0sq_dV_g_e = (tang0*d_tang0_dV_g_e+d_tang0_dV_g_e*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);

d_lncosg0_dV_e_si = d_lncosg0_dV_e_di =  0.0;
d_lncosg0_dV_di_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_di_si);
d_lncosg0_dV_g_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_si);
d_lncosg0_dV_g_e = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_e);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}

d_inv_g0_dV_e_si = d_inv_g0_dV_e_di =  0.0;
d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
inv_g0 = (1.0/g0);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
T0 = (g0*tang0);

d_e0_dV_e_si = d_e0_dV_e_di =  0.0;
d_e0_dV_di_si = (((d_lng0_dV_di_si-d_lncosg0_dV_di_si)+r1_acc*d_T0_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = (((d_lng0_dV_g_si-d_lncosg0_dV_g_si)+r1_acc*d_T0_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = (((d_lng0_dV_g_e-d_lncosg0_dV_g_e)+r1_acc*d_T0_dV_g_e)-d_F0_dV_g_e);
e0 = (((lng0-lncosg0)+(r1_acc*T0))-F0);

d_e1_dV_e_si = d_e1_dV_e_di =  0.0;
d_e1_dV_di_si = ((d_inv_g0_dV_di_si+(secg0sq*d_g0_dV_di_si+d_secg0sq_dV_di_si*g0)*r1_acc)+d_tang0_dV_di_si*(1.0+r1_acc));
d_e1_dV_g_si = ((d_inv_g0_dV_g_si+(secg0sq*d_g0_dV_g_si+d_secg0sq_dV_g_si*g0)*r1_acc)+d_tang0_dV_g_si*(1.0+r1_acc));
d_e1_dV_g_e = ((d_inv_g0_dV_g_e+(secg0sq*d_g0_dV_g_e+d_secg0sq_dV_g_e*g0)*r1_acc)+d_tang0_dV_g_e*(1.0+r1_acc));
e1 = ((inv_g0+((secg0sq*g0)*r1_acc))+(tang0*(1.0+r1_acc)));

d_e2_dV_e_si = d_e2_dV_e_di =  0.0;
d_e2_dV_di_si = ((secg0sq*2.0*d_T0_dV_di_si*r1_acc+d_secg0sq_dV_di_si*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0));
d_e2_dV_g_si = ((secg0sq*2.0*d_T0_dV_g_si*r1_acc+d_secg0sq_dV_g_si*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0));
d_e2_dV_g_e = ((secg0sq*2.0*d_T0_dV_g_e*r1_acc+d_secg0sq_dV_g_e*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0));
e2 = ((secg0sq*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*inv_g0));

d_e3_dV_e_si = d_e3_dV_e_di =  0.0;
d_e3_dV_di_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_di_si+((2.0*inv_g0)*d_inv_g0_dV_di_si+2.0*d_inv_g0_dV_di_si*inv_g0)*inv_g0)+(((2.0*g0)*secg0sq)*d_secg0sq_dV_di_si+((2.0*g0)*d_secg0sq_dV_di_si+2.0*d_g0_dV_di_si*secg0sq)*secg0sq)*r1_acc)+(((2.0*secg0sq)*tang0)*(2.0*r1_acc)*d_T0_dV_di_si+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
d_e3_dV_g_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_si+((2.0*inv_g0)*d_inv_g0_dV_g_si+2.0*d_inv_g0_dV_g_si*inv_g0)*inv_g0)+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_si+((2.0*g0)*d_secg0sq_dV_g_si+2.0*d_g0_dV_g_si*secg0sq)*secg0sq)*r1_acc)+(((2.0*secg0sq)*tang0)*(2.0*r1_acc)*d_T0_dV_g_si+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
d_e3_dV_g_e = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_e+((2.0*inv_g0)*d_inv_g0_dV_g_e+2.0*d_inv_g0_dV_g_e*inv_g0)*inv_g0)+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_e+((2.0*g0)*d_secg0sq_dV_g_e+2.0*d_g0_dV_g_e*secg0sq)*secg0sq)*r1_acc)+(((2.0*secg0sq)*tang0)*(2.0*r1_acc)*d_T0_dV_g_e+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*r1_acc))+(((2.0*secg0sq)*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_g0a_dV_e_si = d_g0a_dV_e_di =  0.0;
d_g0a_dV_di_si = d_g0_dV_di_si;
d_g0a_dV_g_si = d_g0_dV_g_si;
d_g0a_dV_g_e = d_g0_dV_g_e;
g0a = g0;
{
double value_tan_0 = tan(g0a);
double  deriv_tan_0_d0 = (1.0/cos(g0a)/cos(g0a));

d_tang0a_dV_di_si = (deriv_tan_0_d0*(d_g0a_dV_di_si));
d_tang0a_dV_g_si = (deriv_tan_0_d0*(d_g0a_dV_g_si));
d_tang0a_dV_g_e = (deriv_tan_0_d0*(d_g0a_dV_g_e));
tang0a = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0a);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(tang0a*tang0a)));

d_qi_acc_dV_e_si = d_qi_acc_dV_e_di =  0.0;
d_qi_acc_dV_di_si = (d_vgsfbeff_acc_dV_di_si-(2.0*Vtm)*(evaluator_lln_0.getDerivs(g0a,d_g0a_dV_di_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0a*tang0a)),(tang0a*d_tang0a_dV_di_si+d_tang0a_dV_di_si*tang0a))));
d_qi_acc_dV_g_si = (d_vgsfbeff_acc_dV_g_si-(2.0*Vtm)*(evaluator_lln_0.getDerivs(g0a,d_g0a_dV_g_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0a*tang0a)),(tang0a*d_tang0a_dV_g_si+d_tang0a_dV_g_si*tang0a))));
d_qi_acc_dV_g_e = (d_vgsfbeff_acc_dV_g_e-(2.0*Vtm)*(evaluator_lln_0.getDerivs(g0a,d_g0a_dV_g_e)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0a*tang0a)),(tang0a*d_tang0a_dV_g_e+d_tang0a_dV_g_e*tang0a))));
qi_acc = (vgsfbeff_acc-((2.0*Vtm)*((evaluator_lln_0.getValues(g0a)+(0.5*evaluator_lln_1.getValues((1.0+(tang0a*tang0a)))))+F1_acc)));
}
}
else
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di = d_F0_dV_e_si = d_F0_dV_e_di =  0.0;
d_F0_dV_di_si = (d_vgsfbeff_acc_dV_di_si/(2.0*Vtm));
d_F0_dV_g_si = (d_vgsfbeff_acc_dV_g_si/(2.0*Vtm));
d_F0_dV_g_e = (d_vgsfbeff_acc_dV_g_e/(2.0*Vtm));
F0 = (vgsfbeff_acc/(2.0*Vtm));
if ((F0>80.0))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = d_F0_dV_di_si;
d_T0_dV_g_si = d_F0_dV_g_si;
d_T0_dV_g_e = d_F0_dV_g_e;
T0 = F0;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(F0)));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_di_si));
d_T0_dV_g_si = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_si));
d_T0_dV_g_e = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_e));
T0 = evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(F0)));
}
}
if ((F0<(-10)))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((2*F0));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = evaluator_lexp_0.getDerivs((2*F0),2*d_F0_dV_di_si);
d_g0_dV_g_si = evaluator_lexp_0.getDerivs((2*F0),2*d_F0_dV_g_si);
d_g0_dV_g_e = evaluator_lexp_0.getDerivs((2*F0),2*d_F0_dV_g_e);
g0 = evaluator_lexp_0.getValues((2*F0));
}
}
else
{
if ((F0>10))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = (d_F0_dV_di_si/r1_acc);
d_g0_dV_g_si = (d_F0_dV_g_si/r1_acc);
d_g0_dV_g_e = (d_F0_dV_g_e/r1_acc);
g0 = (F0/r1_acc);
}
else
{
{
double value_sqrt_0 = sqrt((0.25+(((r1_acc*r1_acc)*T0)*T0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = ((deriv_sqrt_0_d0*((((r1_acc*r1_acc)*T0)*d_T0_dV_di_si+(r1_acc*r1_acc)*d_T0_dV_di_si*T0)))/(r1_acc*r1_acc));
d_g0_dV_g_si = ((deriv_sqrt_0_d0*((((r1_acc*r1_acc)*T0)*d_T0_dV_g_si+(r1_acc*r1_acc)*d_T0_dV_g_si*T0)))/(r1_acc*r1_acc));
d_g0_dV_g_e = ((deriv_sqrt_0_d0*((((r1_acc*r1_acc)*T0)*d_T0_dV_g_e+(r1_acc*r1_acc)*d_T0_dV_g_e*T0)))/(r1_acc*r1_acc));
g0 = ((value_sqrt_0-0.5)/(r1_acc*r1_acc));
}
}
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
if ((F0<(-50)))
{

d_g0a_dV_e_si = d_g0a_dV_e_di =  0.0;
d_g0a_dV_di_si = d_g0_dV_di_si;
d_g0a_dV_g_si = d_g0_dV_g_si;
d_g0a_dV_g_e = d_g0_dV_g_e;
g0a = g0;
}
else
{

d_inv_g0_dV_e_si = d_inv_g0_dV_e_di =  0.0;
d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
inv_g0 = (1.0/g0);

d_inv_g0sq_dV_e_si = d_inv_g0sq_dV_e_di =  0.0;
d_inv_g0sq_dV_di_si = (inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0);
d_inv_g0sq_dV_g_si = (inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0);
d_inv_g0sq_dV_g_e = (inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0);
inv_g0sq = (inv_g0*inv_g0);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_g_si = cdop_acc*d_g0_dV_g_si;
d_T0_dV_g_e = cdop_acc*d_g0_dV_g_e;
d_T0_dV_di_si = (cdop_acc*d_g0_dV_di_si+d_cdop_acc_dV_di_si*g0);
T0 = (1+(cdop_acc*g0));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di =  0.0;
d_T1_dV_g_si = (-cdop_acc*d_T0_dV_g_si/T0/T0);
d_T1_dV_g_e = (-cdop_acc*d_T0_dV_g_e/T0/T0);
d_T1_dV_di_si = ((T0*d_cdop_acc_dV_di_si-cdop_acc*d_T0_dV_di_si)/T0/T0);
T1 = (cdop_acc/T0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_e_si = d_T2_dV_e_di =  0.0;
d_T2_dV_di_si = (T1*d_T1_dV_di_si+d_T1_dV_di_si*T1);
d_T2_dV_g_si = (T1*d_T1_dV_g_si+d_T1_dV_g_si*T1);
d_T2_dV_g_e = (T1*d_T1_dV_g_e+d_T1_dV_g_e*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);

d_e0_dV_e_si = d_e0_dV_e_di =  0.0;
d_e0_dV_di_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_di_si))+r1_acc*d_g0_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_si))+r1_acc*d_g0_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_e))+r1_acc*d_g0_dV_g_e)-d_F0_dV_g_e);
e0 = ((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1_acc*g0))-F0);
}

d_e1_dV_e_si = d_e1_dV_e_di =  0.0;
d_e1_dV_di_si = (0.5*d_inv_g0_dV_di_si+0.5*d_T1_dV_di_si);
d_e1_dV_g_si = (0.5*d_inv_g0_dV_g_si+0.5*d_T1_dV_g_si);
d_e1_dV_g_e = (0.5*d_inv_g0_dV_g_e+0.5*d_T1_dV_g_e);
e1 = (((0.5*inv_g0)+(0.5*T1))+r1_acc);

d_e2_dV_e_di = ((-0.5)*d_inv_g0sq_dV_e_di-0.5*d_T2_dV_e_di);
d_e2_dV_e_si = ((-0.5)*d_inv_g0sq_dV_e_si-0.5*d_T2_dV_e_si);
d_e2_dV_di_si = ((-0.5)*d_inv_g0sq_dV_di_si-0.5*d_T2_dV_di_si);
d_e2_dV_g_si = ((-0.5)*d_inv_g0sq_dV_g_si-0.5*d_T2_dV_g_si);
d_e2_dV_g_e = ((-0.5)*d_inv_g0sq_dV_g_e-0.5*d_T2_dV_g_e);
e2 = (((-0.5)*inv_g0sq)-(0.5*T2));

d_e3_dV_e_di = ((inv_g0*d_inv_g0sq_dV_e_di+d_inv_g0_dV_e_di*inv_g0sq)+(T2*d_T1_dV_e_di+d_T2_dV_e_di*T1));
d_e3_dV_e_si = ((inv_g0*d_inv_g0sq_dV_e_si+d_inv_g0_dV_e_si*inv_g0sq)+(T2*d_T1_dV_e_si+d_T2_dV_e_si*T1));
d_e3_dV_di_si = ((inv_g0*d_inv_g0sq_dV_di_si+d_inv_g0_dV_di_si*inv_g0sq)+(T2*d_T1_dV_di_si+d_T2_dV_di_si*T1));
d_e3_dV_g_si = ((inv_g0*d_inv_g0sq_dV_g_si+d_inv_g0_dV_g_si*inv_g0sq)+(T2*d_T1_dV_g_si+d_T2_dV_g_si*T1));
d_e3_dV_g_e = ((inv_g0*d_inv_g0sq_dV_g_e+d_inv_g0_dV_g_e*inv_g0sq)+(T2*d_T1_dV_g_e+d_T2_dV_g_e*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_inv_g0sq_dV_di_si = (inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0);
d_inv_g0sq_dV_g_si = (inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0);
d_inv_g0sq_dV_g_e = (inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0);
d_inv_g0sq_dV_e_di = (inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0);
d_inv_g0sq_dV_e_si = (inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0);
inv_g0sq = (inv_g0*inv_g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = cdop_acc*d_g0_dV_g_si;
d_T0_dV_g_e = cdop_acc*d_g0_dV_g_e;
d_T0_dV_e_di = cdop_acc*d_g0_dV_e_di;
d_T0_dV_e_si = cdop_acc*d_g0_dV_e_si;
d_T0_dV_di_si = (cdop_acc*d_g0_dV_di_si+d_cdop_acc_dV_di_si*g0);
T0 = (1+(cdop_acc*g0));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-cdop_acc*d_T0_dV_g_si/T0/T0);
d_T1_dV_g_e = (-cdop_acc*d_T0_dV_g_e/T0/T0);
d_T1_dV_e_di = (-cdop_acc*d_T0_dV_e_di/T0/T0);
d_T1_dV_e_si = (-cdop_acc*d_T0_dV_e_si/T0/T0);
d_T1_dV_di_si = ((T0*d_cdop_acc_dV_di_si-cdop_acc*d_T0_dV_di_si)/T0/T0);
T1 = (cdop_acc/T0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (T1*d_T1_dV_di_si+d_T1_dV_di_si*T1);
d_T2_dV_g_si = (T1*d_T1_dV_g_si+d_T1_dV_g_si*T1);
d_T2_dV_g_e = (T1*d_T1_dV_g_e+d_T1_dV_g_e*T1);
d_T2_dV_e_di = (T1*d_T1_dV_e_di+d_T1_dV_e_di*T1);
d_T2_dV_e_si = (T1*d_T1_dV_e_si+d_T1_dV_e_si*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);

d_e0_dV_di_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_di_si))+r1_acc*d_g0_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_si))+r1_acc*d_g0_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_e))+r1_acc*d_g0_dV_g_e)-d_F0_dV_g_e);
d_e0_dV_e_di = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_di))+r1_acc*d_g0_dV_e_di)-d_F0_dV_e_di);
d_e0_dV_e_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_si))+r1_acc*d_g0_dV_e_si)-d_F0_dV_e_si);
e0 = ((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1_acc*g0))-F0);
}

d_e1_dV_di_si = (0.5*d_inv_g0_dV_di_si+0.5*d_T1_dV_di_si);
d_e1_dV_g_si = (0.5*d_inv_g0_dV_g_si+0.5*d_T1_dV_g_si);
d_e1_dV_g_e = (0.5*d_inv_g0_dV_g_e+0.5*d_T1_dV_g_e);
d_e1_dV_e_di = (0.5*d_inv_g0_dV_e_di+0.5*d_T1_dV_e_di);
d_e1_dV_e_si = (0.5*d_inv_g0_dV_e_si+0.5*d_T1_dV_e_si);
e1 = (((0.5*inv_g0)+(0.5*T1))+r1_acc);

d_e2_dV_di_si = ((-0.5)*d_inv_g0sq_dV_di_si-0.5*d_T2_dV_di_si);
d_e2_dV_g_si = ((-0.5)*d_inv_g0sq_dV_g_si-0.5*d_T2_dV_g_si);
d_e2_dV_g_e = ((-0.5)*d_inv_g0sq_dV_g_e-0.5*d_T2_dV_g_e);
d_e2_dV_e_di = ((-0.5)*d_inv_g0sq_dV_e_di-0.5*d_T2_dV_e_di);
d_e2_dV_e_si = ((-0.5)*d_inv_g0sq_dV_e_si-0.5*d_T2_dV_e_si);
e2 = (((-0.5)*inv_g0sq)-(0.5*T2));

d_e3_dV_di_si = ((inv_g0*d_inv_g0sq_dV_di_si+d_inv_g0_dV_di_si*inv_g0sq)+(T2*d_T1_dV_di_si+d_T2_dV_di_si*T1));
d_e3_dV_g_si = ((inv_g0*d_inv_g0sq_dV_g_si+d_inv_g0_dV_g_si*inv_g0sq)+(T2*d_T1_dV_g_si+d_T2_dV_g_si*T1));
d_e3_dV_g_e = ((inv_g0*d_inv_g0sq_dV_g_e+d_inv_g0_dV_g_e*inv_g0sq)+(T2*d_T1_dV_g_e+d_T2_dV_g_e*T1));
d_e3_dV_e_di = ((inv_g0*d_inv_g0sq_dV_e_di+d_inv_g0_dV_e_di*inv_g0sq)+(T2*d_T1_dV_e_di+d_T2_dV_e_di*T1));
d_e3_dV_e_si = ((inv_g0*d_inv_g0sq_dV_e_si+d_inv_g0_dV_e_si*inv_g0sq)+(T2*d_T1_dV_e_si+d_T2_dV_e_si*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_g0a_dV_di_si = d_g0_dV_di_si;
d_g0a_dV_g_si = d_g0_dV_g_si;
d_g0a_dV_g_e = d_g0_dV_g_e;
d_g0a_dV_e_di = d_g0_dV_e_di;
d_g0a_dV_e_si = d_g0_dV_e_si;
g0a = g0;
}

d_qi_acc_dV_di_si = q0_acc*d_g0a_dV_di_si;
d_qi_acc_dV_g_si = q0_acc*d_g0a_dV_g_si;
d_qi_acc_dV_g_e = q0_acc*d_g0a_dV_g_e;
d_qi_acc_dV_e_di = q0_acc*d_g0a_dV_e_di;
d_qi_acc_dV_e_si = q0_acc*d_g0a_dV_e_si;
qi_acc = (q0_acc*g0a);
}
}

d_vch_dV_di_si = d_vch_dV_e_si = d_vch_dV_e_di = d_vch_dV_g_e = d_vch_dV_g_si =  0.0;
vch = dvch_qm;
if (((model_.GEOMOD)!=3))
{
if (((model_.COREMOD)!=0))
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di = d_F0_dV_e_si = d_F0_dV_e_di = d_F0_dV_g_e =  0.0;
d_F0_dV_di_si = ((((2.0*nVtm)*(d_vgsfbeff_dV_di_si-d_vch_dV_di_si)-(vgsfbeff-vch)*2.0*d_nVtm_dV_di_si)/(2.0*nVtm)/(2.0*nVtm))-d_F1_dV_di_si);
d_F0_dV_g_si = ((d_vgsfbeff_dV_g_si-d_vch_dV_g_si)/(2.0*nVtm));
F0 = (((vgsfbeff-vch)/(2.0*nVtm))-F1);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);

d_expff_dV_e_si = d_expff_dV_e_di =  0.0;
d_expff_dV_di_si = evaluator_lexp_0.getDerivs(F0,d_F0_dV_di_si);
d_expff_dV_g_si = evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_si);
d_expff_dV_g_e = evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_e);
expff = evaluator_lexp_0.getValues(F0);
}
{
double value_atan_0 = atan(expff);
double  deriv_atan_0_d0 = (+1.0/(1+expff*expff));

d_z1_dV_e_si = d_z1_dV_e_di =  0.0;
d_z1_dV_di_si = (deriv_atan_0_d0*(d_expff_dV_di_si));
d_z1_dV_g_si = (deriv_atan_0_d0*(d_expff_dV_g_si));
d_z1_dV_g_e = (deriv_atan_0_d0*(d_expff_dV_g_e));
z1 = value_atan_0;
}
if ((F0>80.0))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = d_F0_dV_di_si;
d_T0_dV_g_si = d_F0_dV_g_si;
d_T0_dV_g_e = d_F0_dV_g_e;
T0 = F0;
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+expff));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_di_si);
d_T0_dV_g_si = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_g_si);
d_T0_dV_g_e = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_g_e);
T0 = evaluator_lln_0.getValues((1.0+expff));
}
}
{
double value_atan_0 = atan(((2*T0)*Inv_r1pi));
double  deriv_atan_0_d0 = (+1.0/(1+((2*T0)*Inv_r1pi)*((2*T0)*Inv_r1pi)));

d_z2_dV_di_si = (deriv_atan_0_d0*(2*d_T0_dV_di_si*Inv_r1pi));
d_z2_dV_g_si = (deriv_atan_0_d0*(2*d_T0_dV_g_si*Inv_r1pi));
d_z2_dV_g_e = (deriv_atan_0_d0*(2*d_T0_dV_g_e*Inv_r1pi));
d_z2_dV_e_di = (deriv_atan_0_d0*(2*d_T0_dV_e_di*Inv_r1pi));
d_z2_dV_e_si = (deriv_atan_0_d0*(2*d_T0_dV_e_si*Inv_r1pi));
z2 = value_atan_0;
}
{
double value_max_0 = std::max(z2,static_cast<double>(1e-15));
double value_min_1 = std::min(z1,value_max_0);
double  deriv_max_0_d0 = ((z2>=1e-15)?1.0:0.0);
double  deriv_min_1_d0 = ((z1<=value_max_0)?1.0:0.0);
double  deriv_min_1_d1 = ((z1<=value_max_0)?0.0:1.0);

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_e_di = ((deriv_min_1_d0*(d_z1_dV_e_di))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_e_di)))));
d_g0_dV_e_si = ((deriv_min_1_d0*(d_z1_dV_e_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_e_si)))));
d_g0_dV_di_si = ((deriv_min_1_d0*(d_z1_dV_di_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_di_si)))));
d_g0_dV_g_si = ((deriv_min_1_d0*(d_z1_dV_g_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_g_si)))));
d_g0_dV_g_e = ((deriv_min_1_d0*(d_z1_dV_g_e))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_g_e)))));
g0 = value_min_1;
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);

d_lng0_dV_di_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si);
d_lng0_dV_g_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si);
d_lng0_dV_g_e = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e);
d_lng0_dV_e_di = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di);
d_lng0_dV_e_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si);
lng0 = evaluator_lln_0.getValues(g0);
}

d_secg0sq_dV_di_si = (tang0*d_tang0_dV_di_si+d_tang0_dV_di_si*tang0);
d_secg0sq_dV_g_si = (tang0*d_tang0_dV_g_si+d_tang0_dV_g_si*tang0);
d_secg0sq_dV_g_e = (tang0*d_tang0_dV_g_e+d_tang0_dV_g_e*tang0);
d_secg0sq_dV_e_di = (tang0*d_tang0_dV_e_di+d_tang0_dV_e_di*tang0);
d_secg0sq_dV_e_si = (tang0*d_tang0_dV_e_si+d_tang0_dV_e_si*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);

d_lncosg0_dV_di_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_di_si);
d_lncosg0_dV_g_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_si);
d_lncosg0_dV_g_e = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_e);
d_lncosg0_dV_e_di = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_di);
d_lncosg0_dV_e_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_si);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (g0*tang0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (T0*d_T0_dV_di_si+d_T0_dV_di_si*T0);
d_T1_dV_g_si = (T0*d_T0_dV_g_si+d_T0_dV_g_si*T0);
d_T1_dV_g_e = (T0*d_T0_dV_g_e+d_T0_dV_g_e*T0);
d_T1_dV_e_di = (T0*d_T0_dV_e_di+d_T0_dV_e_di*T0);
d_T1_dV_e_si = (T0*d_T0_dV_e_si+d_T0_dV_e_si*T0);
T1 = (T0*T0);

d_e0_dV_di_si = ((((d_lng0_dV_di_si-d_lncosg0_dV_di_si)+r1*d_T0_dV_di_si)+r2*d_T1_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = ((((d_lng0_dV_g_si-d_lncosg0_dV_g_si)+r1*d_T0_dV_g_si)+r2*d_T1_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = ((((d_lng0_dV_g_e-d_lncosg0_dV_g_e)+r1*d_T0_dV_g_e)+r2*d_T1_dV_g_e)-d_F0_dV_g_e);
d_e0_dV_e_di = ((((d_lng0_dV_e_di-d_lncosg0_dV_e_di)+r1*d_T0_dV_e_di)+r2*d_T1_dV_e_di)-d_F0_dV_e_di);
d_e0_dV_e_si = ((((d_lng0_dV_e_si-d_lncosg0_dV_e_si)+r1*d_T0_dV_e_si)+r2*d_T1_dV_e_si)-d_F0_dV_e_si);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);

d_e1_dV_di_si = ((d_inv_g0_dV_di_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_di_si+(secg0sq*d_g0_dV_di_si+d_secg0sq_dV_di_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_di_si+d_tang0_dV_di_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_si = ((d_inv_g0_dV_g_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_si+(secg0sq*d_g0_dV_g_si+d_secg0sq_dV_g_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_si+d_tang0_dV_g_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_e = ((d_inv_g0_dV_g_e+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_e+(secg0sq*d_g0_dV_g_e+d_secg0sq_dV_g_e*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_e+d_tang0_dV_g_e*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_di = ((d_inv_g0_dV_e_di+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_di+(secg0sq*d_g0_dV_e_di+d_secg0sq_dV_e_di*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_di+d_tang0_dV_e_di*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_si = ((d_inv_g0_dV_e_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_si+(secg0sq*d_g0_dV_e_si+d_secg0sq_dV_e_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_si+d_tang0_dV_e_si*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));

d_e2_dV_di_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_di_si+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0)*secg0sq)+d_T0_dV_di_si*r1)+(2.0*r2)*(d_T1_dV_di_si+2.0*d_T0_dV_di_si))+d_secg0sq_dV_di_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_di_si*r2+(inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_si+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0)*secg0sq)+d_T0_dV_g_si*r1)+(2.0*r2)*(d_T1_dV_g_si+2.0*d_T0_dV_g_si))+d_secg0sq_dV_g_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_si*r2+(inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_e = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_e+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0)*secg0sq)+d_T0_dV_g_e*r1)+(2.0*r2)*(d_T1_dV_g_e+2.0*d_T0_dV_g_e))+d_secg0sq_dV_g_e*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_e*r2+(inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_di = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_di+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0)*secg0sq)+d_T0_dV_e_di*r1)+(2.0*r2)*(d_T1_dV_e_di+2.0*d_T0_dV_e_di))+d_secg0sq_dV_e_di*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_di*r2+(inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_si+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0)*secg0sq)+d_T0_dV_e_si*r1)+(2.0*r2)*(d_T1_dV_e_si+2.0*d_T0_dV_e_si))+d_secg0sq_dV_e_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_si*r2+(inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));

d_e3_dV_di_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_di_si+((2.0*inv_g0)*d_inv_g0_dV_di_si+2.0*d_inv_g0_dV_di_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_di_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_di_si+((2.0*g0)*d_secg0sq_dV_di_si+2.0*d_g0_dV_di_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_di_si+(2.0*r2)*(3.0*2.0*d_T0_dV_di_si+2.0*d_T1_dV_di_si))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_si+((2.0*inv_g0)*d_inv_g0_dV_g_si+2.0*d_inv_g0_dV_g_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_si+((2.0*g0)*d_secg0sq_dV_g_si+2.0*d_g0_dV_g_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_si+(2.0*r2)*(3.0*2.0*d_T0_dV_g_si+2.0*d_T1_dV_g_si))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_e = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_e+((2.0*inv_g0)*d_inv_g0_dV_g_e+2.0*d_inv_g0_dV_g_e*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_e+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_e+((2.0*g0)*d_secg0sq_dV_g_e+2.0*d_g0_dV_g_e*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_e+(2.0*r2)*(3.0*2.0*d_T0_dV_g_e+2.0*d_T1_dV_g_e))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_di = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_di+((2.0*inv_g0)*d_inv_g0_dV_e_di+2.0*d_inv_g0_dV_e_di*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_di+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_di+((2.0*g0)*d_secg0sq_dV_e_di+2.0*d_g0_dV_e_di*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_di+(2.0*r2)*(3.0*2.0*d_T0_dV_e_di+2.0*d_T1_dV_e_di))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_si+((2.0*inv_g0)*d_inv_g0_dV_e_si+2.0*d_inv_g0_dV_e_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_si+((2.0*g0)*d_secg0sq_dV_e_si+2.0*d_g0_dV_e_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_si+(2.0*r2)*(3.0*2.0*d_T0_dV_e_si+2.0*d_T1_dV_e_si))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);

d_lng0_dV_di_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si);
d_lng0_dV_g_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si);
d_lng0_dV_g_e = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e);
d_lng0_dV_e_di = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di);
d_lng0_dV_e_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si);
lng0 = evaluator_lln_0.getValues(g0);
}

d_secg0sq_dV_di_si = (tang0*d_tang0_dV_di_si+d_tang0_dV_di_si*tang0);
d_secg0sq_dV_g_si = (tang0*d_tang0_dV_g_si+d_tang0_dV_g_si*tang0);
d_secg0sq_dV_g_e = (tang0*d_tang0_dV_g_e+d_tang0_dV_g_e*tang0);
d_secg0sq_dV_e_di = (tang0*d_tang0_dV_e_di+d_tang0_dV_e_di*tang0);
d_secg0sq_dV_e_si = (tang0*d_tang0_dV_e_si+d_tang0_dV_e_si*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);

d_lncosg0_dV_di_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_di_si);
d_lncosg0_dV_g_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_si);
d_lncosg0_dV_g_e = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_e);
d_lncosg0_dV_e_di = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_di);
d_lncosg0_dV_e_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_si);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (g0*tang0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (T0*d_T0_dV_di_si+d_T0_dV_di_si*T0);
d_T1_dV_g_si = (T0*d_T0_dV_g_si+d_T0_dV_g_si*T0);
d_T1_dV_g_e = (T0*d_T0_dV_g_e+d_T0_dV_g_e*T0);
d_T1_dV_e_di = (T0*d_T0_dV_e_di+d_T0_dV_e_di*T0);
d_T1_dV_e_si = (T0*d_T0_dV_e_si+d_T0_dV_e_si*T0);
T1 = (T0*T0);

d_e0_dV_di_si = ((((d_lng0_dV_di_si-d_lncosg0_dV_di_si)+r1*d_T0_dV_di_si)+r2*d_T1_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = ((((d_lng0_dV_g_si-d_lncosg0_dV_g_si)+r1*d_T0_dV_g_si)+r2*d_T1_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = ((((d_lng0_dV_g_e-d_lncosg0_dV_g_e)+r1*d_T0_dV_g_e)+r2*d_T1_dV_g_e)-d_F0_dV_g_e);
d_e0_dV_e_di = ((((d_lng0_dV_e_di-d_lncosg0_dV_e_di)+r1*d_T0_dV_e_di)+r2*d_T1_dV_e_di)-d_F0_dV_e_di);
d_e0_dV_e_si = ((((d_lng0_dV_e_si-d_lncosg0_dV_e_si)+r1*d_T0_dV_e_si)+r2*d_T1_dV_e_si)-d_F0_dV_e_si);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);

d_e1_dV_di_si = ((d_inv_g0_dV_di_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_di_si+(secg0sq*d_g0_dV_di_si+d_secg0sq_dV_di_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_di_si+d_tang0_dV_di_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_si = ((d_inv_g0_dV_g_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_si+(secg0sq*d_g0_dV_g_si+d_secg0sq_dV_g_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_si+d_tang0_dV_g_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_e = ((d_inv_g0_dV_g_e+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_e+(secg0sq*d_g0_dV_g_e+d_secg0sq_dV_g_e*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_e+d_tang0_dV_g_e*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_di = ((d_inv_g0_dV_e_di+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_di+(secg0sq*d_g0_dV_e_di+d_secg0sq_dV_e_di*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_di+d_tang0_dV_e_di*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_si = ((d_inv_g0_dV_e_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_si+(secg0sq*d_g0_dV_e_si+d_secg0sq_dV_e_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_si+d_tang0_dV_e_si*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));

d_e2_dV_di_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_di_si+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0)*secg0sq)+d_T0_dV_di_si*r1)+(2.0*r2)*(d_T1_dV_di_si+2.0*d_T0_dV_di_si))+d_secg0sq_dV_di_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_di_si*r2+(inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_si+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0)*secg0sq)+d_T0_dV_g_si*r1)+(2.0*r2)*(d_T1_dV_g_si+2.0*d_T0_dV_g_si))+d_secg0sq_dV_g_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_si*r2+(inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_e = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_e+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0)*secg0sq)+d_T0_dV_g_e*r1)+(2.0*r2)*(d_T1_dV_g_e+2.0*d_T0_dV_g_e))+d_secg0sq_dV_g_e*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_e*r2+(inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_di = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_di+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0)*secg0sq)+d_T0_dV_e_di*r1)+(2.0*r2)*(d_T1_dV_e_di+2.0*d_T0_dV_e_di))+d_secg0sq_dV_e_di*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_di*r2+(inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_si+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0)*secg0sq)+d_T0_dV_e_si*r1)+(2.0*r2)*(d_T1_dV_e_si+2.0*d_T0_dV_e_si))+d_secg0sq_dV_e_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_si*r2+(inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));

d_e3_dV_di_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_di_si+((2.0*inv_g0)*d_inv_g0_dV_di_si+2.0*d_inv_g0_dV_di_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_di_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_di_si+((2.0*g0)*d_secg0sq_dV_di_si+2.0*d_g0_dV_di_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_di_si+(2.0*r2)*(3.0*2.0*d_T0_dV_di_si+2.0*d_T1_dV_di_si))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_si+((2.0*inv_g0)*d_inv_g0_dV_g_si+2.0*d_inv_g0_dV_g_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_si+((2.0*g0)*d_secg0sq_dV_g_si+2.0*d_g0_dV_g_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_si+(2.0*r2)*(3.0*2.0*d_T0_dV_g_si+2.0*d_T1_dV_g_si))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_e = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_e+((2.0*inv_g0)*d_inv_g0_dV_g_e+2.0*d_inv_g0_dV_g_e*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_e+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_e+((2.0*g0)*d_secg0sq_dV_g_e+2.0*d_g0_dV_g_e*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_e+(2.0*r2)*(3.0*2.0*d_T0_dV_g_e+2.0*d_T1_dV_g_e))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_di = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_di+((2.0*inv_g0)*d_inv_g0_dV_e_di+2.0*d_inv_g0_dV_e_di*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_di+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_di+((2.0*g0)*d_secg0sq_dV_e_di+2.0*d_g0_dV_e_di*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_di+(2.0*r2)*(3.0*2.0*d_T0_dV_e_di+2.0*d_T1_dV_e_di))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_si+((2.0*inv_g0)*d_inv_g0_dV_e_si+2.0*d_inv_g0_dV_e_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_si+((2.0*g0)*d_secg0sq_dV_e_si+2.0*d_g0_dV_e_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_si+(2.0*r2)*(3.0*2.0*d_T0_dV_e_si+2.0*d_T1_dV_e_si))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_g0s_dV_di_si = d_g0_dV_di_si;
d_g0s_dV_g_si = d_g0_dV_g_si;
d_g0s_dV_g_e = d_g0_dV_g_e;
d_g0s_dV_e_di = d_g0_dV_e_di;
d_g0s_dV_e_si = d_g0_dV_e_si;
g0s = g0;
{
double value_tan_0 = tan(g0s);
double  deriv_tan_0_d0 = (1.0/cos(g0s)/cos(g0s));

d_tang0s_dV_di_si = (deriv_tan_0_d0*(d_g0s_dV_di_si));
d_tang0s_dV_g_si = (deriv_tan_0_d0*(d_g0s_dV_g_si));
d_tang0s_dV_g_e = (deriv_tan_0_d0*(d_g0s_dV_g_e));
d_tang0s_dV_e_di = (deriv_tan_0_d0*(d_g0s_dV_e_di));
d_tang0s_dV_e_si = (deriv_tan_0_d0*(d_g0s_dV_e_si));
tang0s = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0s);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(tang0s*tang0s)));

d_phis_dV_g_si = (d_vch_dV_g_si+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0s,d_g0s_dV_g_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0s*tang0s)),(tang0s*d_tang0s_dV_g_si+d_tang0s_dV_g_si*tang0s))));
d_phis_dV_g_e = (d_vch_dV_g_e+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0s,d_g0s_dV_g_e)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0s*tang0s)),(tang0s*d_tang0s_dV_g_e+d_tang0s_dV_g_e*tang0s))));
d_phis_dV_e_di = (d_vch_dV_e_di+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0s,d_g0s_dV_e_di)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0s*tang0s)),(tang0s*d_tang0s_dV_e_di+d_tang0s_dV_e_di*tang0s))));
d_phis_dV_e_si = (d_vch_dV_e_si+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0s,d_g0s_dV_e_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0s*tang0s)),(tang0s*d_tang0s_dV_e_si+d_tang0s_dV_e_si*tang0s))));
d_phis_dV_di_si = (d_vch_dV_di_si+((2.0*nVtm)*((evaluator_lln_0.getDerivs(g0s,d_g0s_dV_di_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0s*tang0s)),(tang0s*d_tang0s_dV_di_si+d_tang0s_dV_di_si*tang0s)))+d_F1_dV_di_si)+2.0*d_nVtm_dV_di_si*((evaluator_lln_0.getValues(g0s)+(0.5*evaluator_lln_1.getValues((1.0+(tang0s*tang0s)))))+F1)));
phis = (vch+((2.0*nVtm)*((evaluator_lln_0.getValues(g0s)+(0.5*evaluator_lln_1.getValues((1.0+(tang0s*tang0s)))))+F1)));
}
}
else
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di = d_F0_dV_e_si = d_F0_dV_e_di = d_F0_dV_g_e =  0.0;
d_F0_dV_di_si = (((T14*(d_vgsfbeff_dV_di_si-d_vch_dV_di_si)-((vgsfbeff-phibulk)-vch)*d_T14_dV_di_si)/T14/T14)-d_F1_dV_di_si);
d_F0_dV_g_si = ((d_vgsfbeff_dV_g_si-d_vch_dV_g_si)/T14);
F0 = ((((vgsfbeff-phibulk)-vch)/T14)-F1);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = phibulk*d_aab_dV_di_si;
T0 = (phibulk*aab);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si =  0.0;
d_T1_dV_di_si = (-phibulk*d_T14_dV_di_si/T14/T14);
T1 = (phibulk/T14);

d_z1_dV_di_si = (((2.0*r1)-1.0)*d_T1_dV_di_si+r2*d_T0_dV_di_si);
d_z1_dV_g_si = (((2.0*r1)-1.0)*d_T1_dV_g_si+r2*d_T0_dV_g_si);
d_z1_dV_g_e = (((2.0*r1)-1.0)*d_T1_dV_g_e+r2*d_T0_dV_g_e);
d_z1_dV_e_di = (((2.0*r1)-1.0)*d_T1_dV_e_di+r2*d_T0_dV_e_di);
d_z1_dV_e_si = (((2.0*r1)-1.0)*d_T1_dV_e_si+r2*d_T0_dV_e_si);
z1 = ((((2.0*r1)-1.0)*T1)+(r2*T0));

d_guessA_dV_di_si = (2.0*r1)*d_T1_dV_di_si;
d_guessA_dV_g_si = (2.0*r1)*d_T1_dV_g_si;
d_guessA_dV_g_e = (2.0*r1)*d_T1_dV_g_e;
d_guessA_dV_e_di = (2.0*r1)*d_T1_dV_e_di;
d_guessA_dV_e_si = (2.0*r1)*d_T1_dV_e_si;
guessA = ((2.0*r1)*T1);
{
double value_exp_0 = exp((-guessA));
double  deriv_exp_0_d0 = value_exp_0;

d_guessA_dV_di_si = (((1.0-value_exp_0)*d_guessA_dV_di_si-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_di_si)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_g_si = (((1.0-value_exp_0)*d_guessA_dV_g_si-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_g_si)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_g_e = (((1.0-value_exp_0)*d_guessA_dV_g_e-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_g_e)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_e_di = (((1.0-value_exp_0)*d_guessA_dV_e_di-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_e_di)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_e_si = (((1.0-value_exp_0)*d_guessA_dV_e_si-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_e_si)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
guessA = (guessA/(1.0-value_exp_0));
}
{
double value_sqrt_0 = sqrt(guessA);
double value_log_1 = log((value_sqrt_0/r1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(value_sqrt_0/r1));

d_z2_dV_di_si = (d_z1_dV_di_si+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_di_si))/r1))));
d_z2_dV_g_si = (d_z1_dV_g_si+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_g_si))/r1))));
d_z2_dV_g_e = (d_z1_dV_g_e+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_g_e))/r1))));
d_z2_dV_e_di = (d_z1_dV_e_di+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_e_di))/r1))));
d_z2_dV_e_si = (d_z1_dV_e_si+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_e_si))/r1))));
z2 = (z1+value_log_1);
}
if (((F0-z2)>((-0.3)/T14)))
{
if (((F0-z2)<20))
{
{
double value_exp_0 = exp((2.0*(F0-z2)));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_di_si-d_z2_dV_di_si)))))+(-0.5*d_guessA_dV_di_si/guessA/guessA)*value_log_1);
d_T2_dV_g_si = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_g_si-d_z2_dV_g_si)))))+(-0.5*d_guessA_dV_g_si/guessA/guessA)*value_log_1);
d_T2_dV_g_e = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_g_e-d_z2_dV_g_e)))))+(-0.5*d_guessA_dV_g_e/guessA/guessA)*value_log_1);
d_T2_dV_e_di = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_e_di-d_z2_dV_e_di)))))+(-0.5*d_guessA_dV_e_di/guessA/guessA)*value_log_1);
d_T2_dV_e_si = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_e_si-d_z2_dV_e_si)))))+(-0.5*d_guessA_dV_e_si/guessA/guessA)*value_log_1);
T2 = (((0.5/guessA)*value_log_1)+1.0);
}
}
else
{

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = ((0.5/guessA)*2.0*(d_F0_dV_di_si-d_z2_dV_di_si)+(-0.5*d_guessA_dV_di_si/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_g_si = ((0.5/guessA)*2.0*(d_F0_dV_g_si-d_z2_dV_g_si)+(-0.5*d_guessA_dV_g_si/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_g_e = ((0.5/guessA)*2.0*(d_F0_dV_g_e-d_z2_dV_g_e)+(-0.5*d_guessA_dV_g_e/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_e_di = ((0.5/guessA)*2.0*(d_F0_dV_e_di-d_z2_dV_e_di)+(-0.5*d_guessA_dV_e_di/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_e_si = ((0.5/guessA)*2.0*(d_F0_dV_e_si-d_z2_dV_e_si)+(-0.5*d_guessA_dV_e_si/guessA/guessA)*(2.0*(F0-z2)));
T2 = (((0.5/guessA)*(2.0*(F0-z2)))+1.0);
}
{
double value_pow_0 = pow(T2,2.0);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*2.0/T2));

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (deriv_pow_0_d0*(d_T2_dV_di_si));
d_T3_dV_e_di = (deriv_pow_0_d0*(d_T2_dV_e_di));
d_T3_dV_e_si = (deriv_pow_0_d0*(d_T2_dV_e_si));
d_T3_dV_g_si = (deriv_pow_0_d0*(d_T2_dV_g_si));
d_T3_dV_g_e = (deriv_pow_0_d0*(d_T2_dV_g_e));
T3 = value_pow_0;
}
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_exp_1 = exp((-T1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_exp_1_d0 = value_exp_1;

d_guessB_dV_di_si = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_di_si)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_di_si))+(d_guessA_dV_di_si/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_g_si = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_g_si)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_si))+(d_guessA_dV_g_si/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_g_e = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_g_e)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_e))+(d_guessA_dV_g_e/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_e_di = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_e_di)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_di))+(d_guessA_dV_e_di/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_e_si = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_e_si)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_si))+(d_guessA_dV_e_si/r1)*value_sqrt_0)*value_exp_1);
guessB = (((guessA/r1)*value_sqrt_0)*value_exp_1);
}
}
else
{
{
double value_exp_0 = exp(((F0-z1)-T1));
double  deriv_exp_0_d0 = value_exp_0;

d_guessB_dV_e_di = (deriv_exp_0_d0*(((d_F0_dV_e_di-d_z1_dV_e_di)-d_T1_dV_e_di)));
d_guessB_dV_e_si = (deriv_exp_0_d0*(((d_F0_dV_e_si-d_z1_dV_e_si)-d_T1_dV_e_si)));
d_guessB_dV_di_si = (deriv_exp_0_d0*(((d_F0_dV_di_si-d_z1_dV_di_si)-d_T1_dV_di_si)));
d_guessB_dV_g_si = (deriv_exp_0_d0*(((d_F0_dV_g_si-d_z1_dV_g_si)-d_T1_dV_g_si)));
d_guessB_dV_g_e = (deriv_exp_0_d0*(((d_F0_dV_g_e-d_z1_dV_g_e)-d_T1_dV_g_e)));
guessB = value_exp_0;
}
}

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = d_guessB_dV_di_si;
d_g0_dV_g_si = d_guessB_dV_g_si;
d_g0_dV_g_e = d_guessB_dV_g_e;
d_g0_dV_e_di = d_guessB_dV_e_di;
d_g0_dV_e_si = d_guessB_dV_e_si;
g0 = guessB;
if ((g0>1e-60))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (-(-d_g0_dV_di_si/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_g_si = (-(-d_g0_dV_g_si/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_g_e = (-(-d_g0_dV_g_e/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_e_di = (-(-d_g0_dV_e_di/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_e_si = (-(-d_g0_dV_e_si/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
g0 = (1.0/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));

d_cosg0_dV_di_si = (deriv_cos_0_d0*(d_g0_dV_di_si));
d_cosg0_dV_g_si = (deriv_cos_0_d0*(d_g0_dV_g_si));
d_cosg0_dV_g_e = (deriv_cos_0_d0*(d_g0_dV_g_e));
d_cosg0_dV_e_di = (deriv_cos_0_d0*(d_g0_dV_e_di));
d_cosg0_dV_e_si = (deriv_cos_0_d0*(d_g0_dV_e_si));
cosg0 = value_cos_0;
}

d_secg0_dV_di_si = (-d_cosg0_dV_di_si/cosg0/cosg0);
d_secg0_dV_g_si = (-d_cosg0_dV_g_si/cosg0/cosg0);
d_secg0_dV_g_e = (-d_cosg0_dV_g_e/cosg0/cosg0);
d_secg0_dV_e_di = (-d_cosg0_dV_e_di/cosg0/cosg0);
d_secg0_dV_e_si = (-d_cosg0_dV_e_si/cosg0/cosg0);
secg0 = (1.0/cosg0);

d_secg0sq_dV_di_si = (secg0*d_secg0_dV_di_si+d_secg0_dV_di_si*secg0);
d_secg0sq_dV_g_si = (secg0*d_secg0_dV_g_si+d_secg0_dV_g_si*secg0);
d_secg0sq_dV_g_e = (secg0*d_secg0_dV_g_e+d_secg0_dV_g_e*secg0);
d_secg0sq_dV_e_di = (secg0*d_secg0_dV_e_di+d_secg0_dV_e_di*secg0);
d_secg0sq_dV_e_si = (secg0*d_secg0_dV_e_si+d_secg0_dV_e_si*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (((g0*g0)*(T13*d_secg0sq_dV_di_si+d_T13_dV_di_si*secg0sq)+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*((T13*secg0sq)-1.0))+(aab*(-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si)+d_T14_dV_di_si*evaluator_lln_0.getValues(cosg0)))+d_aab_dV_di_si*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
d_T1_dV_g_si = (((g0*g0)*T13*d_secg0sq_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si)));
d_T1_dV_g_e = (((g0*g0)*T13*d_secg0sq_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e)));
d_T1_dV_e_di = (((g0*g0)*T13*d_secg0sq_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di)));
d_T1_dV_e_si = (((g0*g0)*T13*d_secg0sq_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si)));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (deriv_sqrt_0_d0*(d_T1_dV_di_si));
d_T2_dV_g_si = (deriv_sqrt_0_d0*(d_T1_dV_g_si));
d_T2_dV_g_e = (deriv_sqrt_0_d0*(d_T1_dV_g_e));
d_T2_dV_e_di = (deriv_sqrt_0_d0*(d_T1_dV_e_di));
d_T2_dV_e_si = (deriv_sqrt_0_d0*(d_T1_dV_e_si));
T2 = value_sqrt_0;
}

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (((-2.0)*d_g0_dV_di_si+((aab*T14)*d_tang0_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_di_si+(((2.0*T13)*g0)*d_secg0sq_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*secg0sq)*T0));
d_T3_dV_g_si = (((-2.0)*d_g0_dV_g_si+(aab*T14)*d_tang0_dV_g_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_si+(((2.0*T13)*g0)*d_secg0sq_dV_g_si+(2.0*T13)*d_g0_dV_g_si*secg0sq)*T0));
d_T3_dV_g_e = (((-2.0)*d_g0_dV_g_e+(aab*T14)*d_tang0_dV_g_e)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_e+(((2.0*T13)*g0)*d_secg0sq_dV_g_e+(2.0*T13)*d_g0_dV_g_e*secg0sq)*T0));
d_T3_dV_e_di = (((-2.0)*d_g0_dV_e_di+(aab*T14)*d_tang0_dV_e_di)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_di+(((2.0*T13)*g0)*d_secg0sq_dV_e_di+(2.0*T13)*d_g0_dV_e_di*secg0sq)*T0));
d_T3_dV_e_si = (((-2.0)*d_g0_dV_e_si+(aab*T14)*d_tang0_dV_e_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_si+(((2.0*T13)*g0)*d_secg0sq_dV_e_si+(2.0*T13)*d_g0_dV_e_si*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_si+(((2.0*T13)*g0)*d_g0_dV_g_si+(2.0*T13)*d_g0_dV_g_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_si+(8.0*T13)*d_g0_dV_g_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_si+(((4.0*T13)*g0)*d_g0_dV_g_si+(4.0*T13)*d_g0_dV_g_si*g0)*tang0)*tang0))+d_secg0sq_dV_g_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_g_e = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_e+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_e+(((2.0*T13)*g0)*d_g0_dV_g_e+(2.0*T13)*d_g0_dV_g_e*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_e+(8.0*T13)*d_g0_dV_g_e*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_e+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_e+(((4.0*T13)*g0)*d_g0_dV_g_e+(4.0*T13)*d_g0_dV_g_e*g0)*tang0)*tang0))+d_secg0sq_dV_g_e*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_di = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_di+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_di+(((2.0*T13)*g0)*d_g0_dV_e_di+(2.0*T13)*d_g0_dV_e_di*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_di+(8.0*T13)*d_g0_dV_e_di*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_di+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_di+(((4.0*T13)*g0)*d_g0_dV_e_di+(4.0*T13)*d_g0_dV_e_di*g0)*tang0)*tang0))+d_secg0sq_dV_e_di*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_si+(((2.0*T13)*g0)*d_g0_dV_e_si+(2.0*T13)*d_g0_dV_e_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_si+(8.0*T13)*d_g0_dV_e_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_si+(((4.0*T13)*g0)*d_g0_dV_e_si+(4.0*T13)*d_g0_dV_e_si*g0)*tang0)*tang0))+d_secg0sq_dV_e_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_di_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_di_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_di_si+(((2.0*T13)*g0)*d_g0_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14))+(((8.0*T13)*g0)*d_tang0_dV_di_si+((8.0*T13)*d_g0_dV_di_si+8.0*d_T13_dV_di_si*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_di_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_di_si+(((4.0*T13)*g0)*d_g0_dV_di_si+((4.0*T13)*d_g0_dV_di_si+4.0*d_T13_dV_di_si*g0)*g0)*tang0)*tang0))+d_secg0sq_dV_di_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (((2.0*tang0)*d_T4_dV_di_si+2.0*d_tang0_dV_di_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_di_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_di_si+(((3.0*T13)*g0)*d_secg0sq_dV_di_si+((3.0*T13)*d_g0_dV_di_si+3.0*d_T13_dV_di_si*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dV_di_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_di_si+(((2.0*T13)*secg0sq)*d_T0_dV_di_si+((2.0*T13)*d_secg0sq_dV_di_si+2.0*d_T13_dV_di_si*secg0sq)*T0)*tang0)));
d_T5_dV_g_si = (((2.0*tang0)*d_T4_dV_g_si+2.0*d_tang0_dV_g_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_si+(((3.0*T13)*g0)*d_secg0sq_dV_g_si+(3.0*T13)*d_g0_dV_g_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_si+(((2.0*T13)*secg0sq)*d_T0_dV_g_si+(2.0*T13)*d_secg0sq_dV_g_si*T0)*tang0)));
d_T5_dV_g_e = (((2.0*tang0)*d_T4_dV_g_e+2.0*d_tang0_dV_g_e*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_e+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_e+(((3.0*T13)*g0)*d_secg0sq_dV_g_e+(3.0*T13)*d_g0_dV_g_e*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_e)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_e+(((2.0*T13)*secg0sq)*d_T0_dV_g_e+(2.0*T13)*d_secg0sq_dV_g_e*T0)*tang0)));
d_T5_dV_e_di = (((2.0*tang0)*d_T4_dV_e_di+2.0*d_tang0_dV_e_di*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_di+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_di+(((3.0*T13)*g0)*d_secg0sq_dV_e_di+(3.0*T13)*d_g0_dV_e_di*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_di)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_di+(((2.0*T13)*secg0sq)*d_T0_dV_e_di+(2.0*T13)*d_secg0sq_dV_e_di*T0)*tang0)));
d_T5_dV_e_si = (((2.0*tang0)*d_T4_dV_e_si+2.0*d_tang0_dV_e_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_si+(((3.0*T13)*g0)*d_secg0sq_dV_e_si+(3.0*T13)*d_g0_dV_e_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_si+(((2.0*T13)*secg0sq)*d_T0_dV_e_si+(2.0*T13)*d_secg0sq_dV_e_si*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T7_dV_di_si = ((((d_lng0_dV_di_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si))+r2*d_T1_dV_di_si)+r1*d_T2_dV_di_si)-d_F0_dV_di_si);
d_T7_dV_g_si = ((((d_lng0_dV_g_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si))+r2*d_T1_dV_g_si)+r1*d_T2_dV_g_si)-d_F0_dV_g_si);
d_T7_dV_g_e = ((((d_lng0_dV_g_e-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e))+r2*d_T1_dV_g_e)+r1*d_T2_dV_g_e)-d_F0_dV_g_e);
d_T7_dV_e_di = ((((d_lng0_dV_e_di-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di))+r2*d_T1_dV_e_di)+r1*d_T2_dV_e_di)-d_F0_dV_e_di);
d_T7_dV_e_si = ((((d_lng0_dV_e_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si))+r2*d_T1_dV_e_si)+r1*d_T2_dV_e_si)-d_F0_dV_e_si);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}

d_T8_dV_di_si = ((((-d_g0_dV_di_si/g0/g0)+d_tang0_dV_di_si)+r2*d_T3_dV_di_si)+(((2.0*T2)*r1*d_T3_dV_di_si-(r1*T3)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_si = ((((-d_g0_dV_g_si/g0/g0)+d_tang0_dV_g_si)+r2*d_T3_dV_g_si)+(((2.0*T2)*r1*d_T3_dV_g_si-(r1*T3)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_e = ((((-d_g0_dV_g_e/g0/g0)+d_tang0_dV_g_e)+r2*d_T3_dV_g_e)+(((2.0*T2)*r1*d_T3_dV_g_e-(r1*T3)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_di = ((((-d_g0_dV_e_di/g0/g0)+d_tang0_dV_e_di)+r2*d_T3_dV_e_di)+(((2.0*T2)*r1*d_T3_dV_e_di-(r1*T3)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_si = ((((-d_g0_dV_e_si/g0/g0)+d_tang0_dV_e_si)+r2*d_T3_dV_e_si)+(((2.0*T2)*r1*d_T3_dV_e_si-(r1*T3)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));

d_T9_dV_di_si = (((((-(-1.0)*(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_di_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_di_si+r1*d_T3_dV_di_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_di_si+((4*T2)*d_T2_dV_di_si+4*d_T2_dV_di_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_di_si-(r1*T4)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_di_si);
d_T9_dV_g_si = (((((-(-1.0)*(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_si+r1*d_T3_dV_g_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_si+((4*T2)*d_T2_dV_g_si+4*d_T2_dV_g_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_si-(r1*T4)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_si);
d_T9_dV_g_e = (((((-(-1.0)*(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_e)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_e+r1*d_T3_dV_g_e*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_e+((4*T2)*d_T2_dV_g_e+4*d_T2_dV_g_e*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_e-(r1*T4)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_e);
d_T9_dV_e_di = (((((-(-1.0)*(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_di)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_di+r1*d_T3_dV_e_di*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_di+((4*T2)*d_T2_dV_e_di+4*d_T2_dV_e_di*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_di-(r1*T4)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_di);
d_T9_dV_e_si = (((((-(-1.0)*(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_si+r1*d_T3_dV_e_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_si+((4*T2)*d_T2_dV_e_si+4*d_T2_dV_e_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_si-(r1*T4)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_si);
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));

d_TA_dV_di_si = (((((-2.0*((g0*g0)*d_g0_dV_di_si+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_di_si+d_T3_dV_di_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_di_si+2.0*d_T2_dV_di_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_di_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_di_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_di_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_di_si-(r1*T5)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_di_si);
d_TA_dV_g_si = (((((-2.0*((g0*g0)*d_g0_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_si+d_T3_dV_g_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_si+2.0*d_T2_dV_g_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_si-(r1*T5)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_si);
d_TA_dV_g_e = (((((-2.0*((g0*g0)*d_g0_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_e+d_T3_dV_g_e*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_e+2.0*d_T2_dV_g_e*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_e)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_e-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_e)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_e-(r1*T5)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_e);
d_TA_dV_e_di = (((((-2.0*((g0*g0)*d_g0_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_di+d_T3_dV_e_di*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_di+2.0*d_T2_dV_e_di*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_di)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_di-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_di)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_di-(r1*T5)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_di);
d_TA_dV_e_si = (((((-2.0*((g0*g0)*d_g0_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_si+d_T3_dV_e_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_si+2.0*d_T2_dV_e_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_si-(r1*T5)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_si);
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_di_si+d_T7_dV_di_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_di_si+2.0*d_T8_dV_di_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_di_si+3.0*d_T9_dV_di_si*T9)-(T8*d_TA_dV_di_si+d_T8_dV_di_si*TA))+(T7*d_T7_dV_di_si+d_T7_dV_di_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_di_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_di_si-T7*d_T8_dV_di_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_si+d_T7_dV_g_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_si+2.0*d_T8_dV_g_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_si+3.0*d_T9_dV_g_si*T9)-(T8*d_TA_dV_g_si+d_T8_dV_g_si*TA))+(T7*d_T7_dV_g_si+d_T7_dV_g_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_si-T7*d_T8_dV_g_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_e+d_T7_dV_g_e*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_e+2.0*d_T8_dV_g_e*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_e+3.0*d_T9_dV_g_e*T9)-(T8*d_TA_dV_g_e+d_T8_dV_g_e*TA))+(T7*d_T7_dV_g_e+d_T7_dV_g_e*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_e)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_e-T7*d_T8_dV_g_e)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_di+d_T7_dV_e_di*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_di+2.0*d_T8_dV_e_di*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_di+3.0*d_T9_dV_e_di*T9)-(T8*d_TA_dV_e_di+d_T8_dV_e_di*TA))+(T7*d_T7_dV_e_di+d_T7_dV_e_di*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_di)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_di-T7*d_T8_dV_e_di)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_si+d_T7_dV_e_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_si+2.0*d_T8_dV_e_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_si+3.0*d_T9_dV_e_si*T9)-(T8*d_TA_dV_e_si+d_T8_dV_e_si*TA))+(T7*d_T7_dV_e_si+d_T7_dV_e_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_si-T7*d_T8_dV_e_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));

d_cosg0_dV_di_si = (deriv_cos_0_d0*(d_g0_dV_di_si));
d_cosg0_dV_g_si = (deriv_cos_0_d0*(d_g0_dV_g_si));
d_cosg0_dV_g_e = (deriv_cos_0_d0*(d_g0_dV_g_e));
d_cosg0_dV_e_di = (deriv_cos_0_d0*(d_g0_dV_e_di));
d_cosg0_dV_e_si = (deriv_cos_0_d0*(d_g0_dV_e_si));
cosg0 = value_cos_0;
}

d_secg0_dV_di_si = (-d_cosg0_dV_di_si/cosg0/cosg0);
d_secg0_dV_g_si = (-d_cosg0_dV_g_si/cosg0/cosg0);
d_secg0_dV_g_e = (-d_cosg0_dV_g_e/cosg0/cosg0);
d_secg0_dV_e_di = (-d_cosg0_dV_e_di/cosg0/cosg0);
d_secg0_dV_e_si = (-d_cosg0_dV_e_si/cosg0/cosg0);
secg0 = (1.0/cosg0);

d_secg0sq_dV_di_si = (secg0*d_secg0_dV_di_si+d_secg0_dV_di_si*secg0);
d_secg0sq_dV_g_si = (secg0*d_secg0_dV_g_si+d_secg0_dV_g_si*secg0);
d_secg0sq_dV_g_e = (secg0*d_secg0_dV_g_e+d_secg0_dV_g_e*secg0);
d_secg0sq_dV_e_di = (secg0*d_secg0_dV_e_di+d_secg0_dV_e_di*secg0);
d_secg0sq_dV_e_si = (secg0*d_secg0_dV_e_si+d_secg0_dV_e_si*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (((g0*g0)*(T13*d_secg0sq_dV_di_si+d_T13_dV_di_si*secg0sq)+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*((T13*secg0sq)-1.0))+(aab*(-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si)+d_T14_dV_di_si*evaluator_lln_0.getValues(cosg0)))+d_aab_dV_di_si*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
d_T1_dV_g_si = (((g0*g0)*T13*d_secg0sq_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si)));
d_T1_dV_g_e = (((g0*g0)*T13*d_secg0sq_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e)));
d_T1_dV_e_di = (((g0*g0)*T13*d_secg0sq_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di)));
d_T1_dV_e_si = (((g0*g0)*T13*d_secg0sq_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si)));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (deriv_sqrt_0_d0*(d_T1_dV_di_si));
d_T2_dV_g_si = (deriv_sqrt_0_d0*(d_T1_dV_g_si));
d_T2_dV_g_e = (deriv_sqrt_0_d0*(d_T1_dV_g_e));
d_T2_dV_e_di = (deriv_sqrt_0_d0*(d_T1_dV_e_di));
d_T2_dV_e_si = (deriv_sqrt_0_d0*(d_T1_dV_e_si));
T2 = value_sqrt_0;
}

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (((-2.0)*d_g0_dV_di_si+((aab*T14)*d_tang0_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_di_si+(((2.0*T13)*g0)*d_secg0sq_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*secg0sq)*T0));
d_T3_dV_g_si = (((-2.0)*d_g0_dV_g_si+(aab*T14)*d_tang0_dV_g_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_si+(((2.0*T13)*g0)*d_secg0sq_dV_g_si+(2.0*T13)*d_g0_dV_g_si*secg0sq)*T0));
d_T3_dV_g_e = (((-2.0)*d_g0_dV_g_e+(aab*T14)*d_tang0_dV_g_e)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_e+(((2.0*T13)*g0)*d_secg0sq_dV_g_e+(2.0*T13)*d_g0_dV_g_e*secg0sq)*T0));
d_T3_dV_e_di = (((-2.0)*d_g0_dV_e_di+(aab*T14)*d_tang0_dV_e_di)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_di+(((2.0*T13)*g0)*d_secg0sq_dV_e_di+(2.0*T13)*d_g0_dV_e_di*secg0sq)*T0));
d_T3_dV_e_si = (((-2.0)*d_g0_dV_e_si+(aab*T14)*d_tang0_dV_e_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_si+(((2.0*T13)*g0)*d_secg0sq_dV_e_si+(2.0*T13)*d_g0_dV_e_si*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_si+(((2.0*T13)*g0)*d_g0_dV_g_si+(2.0*T13)*d_g0_dV_g_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_si+(8.0*T13)*d_g0_dV_g_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_si+(((4.0*T13)*g0)*d_g0_dV_g_si+(4.0*T13)*d_g0_dV_g_si*g0)*tang0)*tang0))+d_secg0sq_dV_g_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_g_e = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_e+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_e+(((2.0*T13)*g0)*d_g0_dV_g_e+(2.0*T13)*d_g0_dV_g_e*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_e+(8.0*T13)*d_g0_dV_g_e*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_e+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_e+(((4.0*T13)*g0)*d_g0_dV_g_e+(4.0*T13)*d_g0_dV_g_e*g0)*tang0)*tang0))+d_secg0sq_dV_g_e*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_di = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_di+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_di+(((2.0*T13)*g0)*d_g0_dV_e_di+(2.0*T13)*d_g0_dV_e_di*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_di+(8.0*T13)*d_g0_dV_e_di*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_di+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_di+(((4.0*T13)*g0)*d_g0_dV_e_di+(4.0*T13)*d_g0_dV_e_di*g0)*tang0)*tang0))+d_secg0sq_dV_e_di*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_si+(((2.0*T13)*g0)*d_g0_dV_e_si+(2.0*T13)*d_g0_dV_e_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_si+(8.0*T13)*d_g0_dV_e_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_si+(((4.0*T13)*g0)*d_g0_dV_e_si+(4.0*T13)*d_g0_dV_e_si*g0)*tang0)*tang0))+d_secg0sq_dV_e_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_di_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_di_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_di_si+(((2.0*T13)*g0)*d_g0_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14))+(((8.0*T13)*g0)*d_tang0_dV_di_si+((8.0*T13)*d_g0_dV_di_si+8.0*d_T13_dV_di_si*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_di_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_di_si+(((4.0*T13)*g0)*d_g0_dV_di_si+((4.0*T13)*d_g0_dV_di_si+4.0*d_T13_dV_di_si*g0)*g0)*tang0)*tang0))+d_secg0sq_dV_di_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (((2.0*tang0)*d_T4_dV_di_si+2.0*d_tang0_dV_di_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_di_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_di_si+(((3.0*T13)*g0)*d_secg0sq_dV_di_si+((3.0*T13)*d_g0_dV_di_si+3.0*d_T13_dV_di_si*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dV_di_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_di_si+(((2.0*T13)*secg0sq)*d_T0_dV_di_si+((2.0*T13)*d_secg0sq_dV_di_si+2.0*d_T13_dV_di_si*secg0sq)*T0)*tang0)));
d_T5_dV_g_si = (((2.0*tang0)*d_T4_dV_g_si+2.0*d_tang0_dV_g_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_si+(((3.0*T13)*g0)*d_secg0sq_dV_g_si+(3.0*T13)*d_g0_dV_g_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_si+(((2.0*T13)*secg0sq)*d_T0_dV_g_si+(2.0*T13)*d_secg0sq_dV_g_si*T0)*tang0)));
d_T5_dV_g_e = (((2.0*tang0)*d_T4_dV_g_e+2.0*d_tang0_dV_g_e*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_e+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_e+(((3.0*T13)*g0)*d_secg0sq_dV_g_e+(3.0*T13)*d_g0_dV_g_e*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_e)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_e+(((2.0*T13)*secg0sq)*d_T0_dV_g_e+(2.0*T13)*d_secg0sq_dV_g_e*T0)*tang0)));
d_T5_dV_e_di = (((2.0*tang0)*d_T4_dV_e_di+2.0*d_tang0_dV_e_di*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_di+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_di+(((3.0*T13)*g0)*d_secg0sq_dV_e_di+(3.0*T13)*d_g0_dV_e_di*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_di)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_di+(((2.0*T13)*secg0sq)*d_T0_dV_e_di+(2.0*T13)*d_secg0sq_dV_e_di*T0)*tang0)));
d_T5_dV_e_si = (((2.0*tang0)*d_T4_dV_e_si+2.0*d_tang0_dV_e_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_si+(((3.0*T13)*g0)*d_secg0sq_dV_e_si+(3.0*T13)*d_g0_dV_e_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_si+(((2.0*T13)*secg0sq)*d_T0_dV_e_si+(2.0*T13)*d_secg0sq_dV_e_si*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T7_dV_di_si = ((((d_lng0_dV_di_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si))+r2*d_T1_dV_di_si)+r1*d_T2_dV_di_si)-d_F0_dV_di_si);
d_T7_dV_g_si = ((((d_lng0_dV_g_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si))+r2*d_T1_dV_g_si)+r1*d_T2_dV_g_si)-d_F0_dV_g_si);
d_T7_dV_g_e = ((((d_lng0_dV_g_e-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e))+r2*d_T1_dV_g_e)+r1*d_T2_dV_g_e)-d_F0_dV_g_e);
d_T7_dV_e_di = ((((d_lng0_dV_e_di-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di))+r2*d_T1_dV_e_di)+r1*d_T2_dV_e_di)-d_F0_dV_e_di);
d_T7_dV_e_si = ((((d_lng0_dV_e_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si))+r2*d_T1_dV_e_si)+r1*d_T2_dV_e_si)-d_F0_dV_e_si);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}

d_T8_dV_di_si = ((((-d_g0_dV_di_si/g0/g0)+d_tang0_dV_di_si)+r2*d_T3_dV_di_si)+(((2.0*T2)*r1*d_T3_dV_di_si-(r1*T3)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_si = ((((-d_g0_dV_g_si/g0/g0)+d_tang0_dV_g_si)+r2*d_T3_dV_g_si)+(((2.0*T2)*r1*d_T3_dV_g_si-(r1*T3)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_e = ((((-d_g0_dV_g_e/g0/g0)+d_tang0_dV_g_e)+r2*d_T3_dV_g_e)+(((2.0*T2)*r1*d_T3_dV_g_e-(r1*T3)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_di = ((((-d_g0_dV_e_di/g0/g0)+d_tang0_dV_e_di)+r2*d_T3_dV_e_di)+(((2.0*T2)*r1*d_T3_dV_e_di-(r1*T3)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_si = ((((-d_g0_dV_e_si/g0/g0)+d_tang0_dV_e_si)+r2*d_T3_dV_e_si)+(((2.0*T2)*r1*d_T3_dV_e_si-(r1*T3)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));

d_T9_dV_di_si = (((((-(-1.0)*(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_di_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_di_si+r1*d_T3_dV_di_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_di_si+((4*T2)*d_T2_dV_di_si+4*d_T2_dV_di_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_di_si-(r1*T4)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_di_si);
d_T9_dV_g_si = (((((-(-1.0)*(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_si+r1*d_T3_dV_g_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_si+((4*T2)*d_T2_dV_g_si+4*d_T2_dV_g_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_si-(r1*T4)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_si);
d_T9_dV_g_e = (((((-(-1.0)*(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_e)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_e+r1*d_T3_dV_g_e*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_e+((4*T2)*d_T2_dV_g_e+4*d_T2_dV_g_e*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_e-(r1*T4)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_e);
d_T9_dV_e_di = (((((-(-1.0)*(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_di)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_di+r1*d_T3_dV_e_di*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_di+((4*T2)*d_T2_dV_e_di+4*d_T2_dV_e_di*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_di-(r1*T4)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_di);
d_T9_dV_e_si = (((((-(-1.0)*(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_si+r1*d_T3_dV_e_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_si+((4*T2)*d_T2_dV_e_si+4*d_T2_dV_e_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_si-(r1*T4)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_si);
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));

d_TA_dV_di_si = (((((-2.0*((g0*g0)*d_g0_dV_di_si+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_di_si+d_T3_dV_di_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_di_si+2.0*d_T2_dV_di_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_di_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_di_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_di_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_di_si-(r1*T5)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_di_si);
d_TA_dV_g_si = (((((-2.0*((g0*g0)*d_g0_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_si+d_T3_dV_g_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_si+2.0*d_T2_dV_g_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_si-(r1*T5)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_si);
d_TA_dV_g_e = (((((-2.0*((g0*g0)*d_g0_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_e+d_T3_dV_g_e*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_e+2.0*d_T2_dV_g_e*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_e)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_e-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_e)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_e-(r1*T5)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_e);
d_TA_dV_e_di = (((((-2.0*((g0*g0)*d_g0_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_di+d_T3_dV_e_di*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_di+2.0*d_T2_dV_e_di*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_di)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_di-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_di)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_di-(r1*T5)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_di);
d_TA_dV_e_si = (((((-2.0*((g0*g0)*d_g0_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_si+d_T3_dV_e_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_si+2.0*d_T2_dV_e_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_si-(r1*T5)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_si);
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_di_si+d_T7_dV_di_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_di_si+2.0*d_T8_dV_di_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_di_si+3.0*d_T9_dV_di_si*T9)-(T8*d_TA_dV_di_si+d_T8_dV_di_si*TA))+(T7*d_T7_dV_di_si+d_T7_dV_di_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_di_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_di_si-T7*d_T8_dV_di_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_si+d_T7_dV_g_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_si+2.0*d_T8_dV_g_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_si+3.0*d_T9_dV_g_si*T9)-(T8*d_TA_dV_g_si+d_T8_dV_g_si*TA))+(T7*d_T7_dV_g_si+d_T7_dV_g_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_si-T7*d_T8_dV_g_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_e+d_T7_dV_g_e*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_e+2.0*d_T8_dV_g_e*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_e+3.0*d_T9_dV_g_e*T9)-(T8*d_TA_dV_g_e+d_T8_dV_g_e*TA))+(T7*d_T7_dV_g_e+d_T7_dV_g_e*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_e)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_e-T7*d_T8_dV_g_e)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_di+d_T7_dV_e_di*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_di+2.0*d_T8_dV_e_di*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_di+3.0*d_T9_dV_e_di*T9)-(T8*d_TA_dV_e_di+d_T8_dV_e_di*TA))+(T7*d_T7_dV_e_di+d_T7_dV_e_di*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_di)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_di-T7*d_T8_dV_e_di)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_si+d_T7_dV_e_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_si+2.0*d_T8_dV_e_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_si+3.0*d_T9_dV_e_si*T9)-(T8*d_TA_dV_e_si+d_T8_dV_e_si*TA))+(T7*d_T7_dV_e_si+d_T7_dV_e_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_si-T7*d_T8_dV_e_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}
}
else
{
if ((g0>=1e-300))
{
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}
}
else
{
if (((F0-z2)>((-0.3)/T14)))
{
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_log_1 = log((1.0/((guessA/r1)*value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(1.0/((guessA/r1)*value_sqrt_0)));

d_lng0_dV_di_si = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_di_si))+(d_guessA_dV_di_si/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_di_si);
d_lng0_dV_g_si = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_si))+(d_guessA_dV_g_si/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_g_si);
d_lng0_dV_g_e = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_e))+(d_guessA_dV_g_e/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_g_e);
d_lng0_dV_e_di = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_di))+(d_guessA_dV_e_di/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_e_di);
d_lng0_dV_e_si = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_si))+(d_guessA_dV_e_si/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_e_si);
lng0 = ((-value_log_1)-T1);
}
}
else
{

d_lng0_dV_e_di = ((d_F0_dV_e_di-d_z1_dV_e_di)-d_T1_dV_e_di);
d_lng0_dV_e_si = ((d_F0_dV_e_si-d_z1_dV_e_si)-d_T1_dV_e_si);
d_lng0_dV_di_si = ((d_F0_dV_di_si-d_z1_dV_di_si)-d_T1_dV_di_si);
d_lng0_dV_g_si = ((d_F0_dV_g_si-d_z1_dV_g_si)-d_T1_dV_g_si);
d_lng0_dV_g_e = ((d_F0_dV_g_e-d_z1_dV_g_e)-d_T1_dV_g_e);
lng0 = ((F0-z1)-T1);
}
}
}
{
double value_cos_0 = cos(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(value_cos_0);
double  deriv_cos_0_d0 = (-sin(g0));

d_phis_dV_g_si = (d_vch_dV_g_si+T14*(d_lng0_dV_g_si-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_g_si)))));
d_phis_dV_g_e = (d_vch_dV_g_e+T14*(d_lng0_dV_g_e-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_g_e)))));
d_phis_dV_e_di = (d_vch_dV_e_di+T14*(d_lng0_dV_e_di-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_e_di)))));
d_phis_dV_e_si = (d_vch_dV_e_si+T14*(d_lng0_dV_e_si-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_e_si)))));
d_phis_dV_di_si = (d_vch_dV_di_si+(T14*((d_lng0_dV_di_si-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_di_si))))+d_F1_dV_di_si)+d_T14_dV_di_si*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)));
phis = ((vch+(T14*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)))+phibulk);
}
}
}
else
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di = d_F0_dV_e_si = d_F0_dV_e_di = d_F0_dV_g_e =  0.0;
d_F0_dV_di_si = (((2.0*nVtm)*(d_vgsfbeff_dV_di_si-d_vch_dV_di_si)-(vgsfbeff-vch)*2.0*d_nVtm_dV_di_si)/(2.0*nVtm)/(2.0*nVtm));
d_F0_dV_g_si = ((d_vgsfbeff_dV_g_si-d_vch_dV_g_si)/(2.0*nVtm));
F0 = ((vgsfbeff-vch)/(2.0*nVtm));
if ((F0<(-10)))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((2.0*F0));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_di_si);
d_g0_dV_g_si = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_g_si);
d_g0_dV_g_e = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_g_e);
g0 = evaluator_lexp_0.getValues((2.0*F0));
}
}
else
{
if ((F0>10))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di =  0.0;
d_g0_dV_di_si = (d_F0_dV_di_si/r1);
d_g0_dV_g_si = (d_F0_dV_g_si/r1);
d_g0_dV_g_e = (d_F0_dV_g_e/r1);
g0 = (F0/r1);
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(F0)));

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di =  0.0;
d_T0_dV_di_si = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_di_si));
d_T0_dV_g_si = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_si));
d_T0_dV_g_e = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_e));
T0 = evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(F0)));
}
{
double value_sqrt_0 = sqrt((0.25+(((r1*r1)*T0)*T0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_di_si+(r1*r1)*d_T0_dV_di_si*T0)))/(r1*r1));
d_g0_dV_g_si = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_g_si+(r1*r1)*d_T0_dV_g_si*T0)))/(r1*r1));
d_g0_dV_g_e = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_g_e+(r1*r1)*d_T0_dV_g_e*T0)))/(r1*r1));
d_g0_dV_e_di = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_e_di+(r1*r1)*d_T0_dV_e_di*T0)))/(r1*r1));
d_g0_dV_e_si = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_e_si+(r1*r1)*d_T0_dV_e_si*T0)))/(r1*r1));
g0 = ((value_sqrt_0-0.5)/(r1*r1));
}
}
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
if ((F0<(-50)))
{

d_g0s_dV_di_si = d_g0_dV_di_si;
d_g0s_dV_g_si = d_g0_dV_g_si;
d_g0s_dV_g_e = d_g0_dV_g_e;
d_g0s_dV_e_di = d_g0_dV_e_di;
d_g0s_dV_e_si = d_g0_dV_e_si;
g0s = g0;
}
else
{

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_inv_g0sq_dV_di_si = (inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0);
d_inv_g0sq_dV_g_si = (inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0);
d_inv_g0sq_dV_g_e = (inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0);
d_inv_g0sq_dV_e_di = (inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0);
d_inv_g0sq_dV_e_si = (inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0);
inv_g0sq = (inv_g0*inv_g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = cdop*d_g0_dV_g_si;
d_T0_dV_g_e = cdop*d_g0_dV_g_e;
d_T0_dV_e_di = cdop*d_g0_dV_e_di;
d_T0_dV_e_si = cdop*d_g0_dV_e_si;
d_T0_dV_di_si = (cdop*d_g0_dV_di_si+d_cdop_dV_di_si*g0);
T0 = (1+(cdop*g0));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-cdop*d_T0_dV_g_si/T0/T0);
d_T1_dV_g_e = (-cdop*d_T0_dV_g_e/T0/T0);
d_T1_dV_e_di = (-cdop*d_T0_dV_e_di/T0/T0);
d_T1_dV_e_si = (-cdop*d_T0_dV_e_si/T0/T0);
d_T1_dV_di_si = ((T0*d_cdop_dV_di_si-cdop*d_T0_dV_di_si)/T0/T0);
T1 = (cdop/T0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (T1*d_T1_dV_di_si+d_T1_dV_di_si*T1);
d_T2_dV_g_si = (T1*d_T1_dV_g_si+d_T1_dV_g_si*T1);
d_T2_dV_g_e = (T1*d_T1_dV_g_e+d_T1_dV_g_e*T1);
d_T2_dV_e_di = (T1*d_T1_dV_e_di+d_T1_dV_e_di*T1);
d_T2_dV_e_si = (T1*d_T1_dV_e_si+d_T1_dV_e_si*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);

d_e0_dV_di_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_di_si))+r1*d_g0_dV_di_si)+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0))-d_F0_dV_di_si);
d_e0_dV_g_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_si))+r1*d_g0_dV_g_si)+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0))-d_F0_dV_g_si);
d_e0_dV_g_e = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_e))+r1*d_g0_dV_g_e)+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0))-d_F0_dV_g_e);
d_e0_dV_e_di = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_di))+r1*d_g0_dV_e_di)+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0))-d_F0_dV_e_di);
d_e0_dV_e_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_si))+r1*d_g0_dV_e_si)+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0))-d_F0_dV_e_si);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}

d_e1_dV_di_si = ((0.5*d_inv_g0_dV_di_si+0.5*d_T1_dV_di_si)+(2*r2)*d_g0_dV_di_si);
d_e1_dV_g_si = ((0.5*d_inv_g0_dV_g_si+0.5*d_T1_dV_g_si)+(2*r2)*d_g0_dV_g_si);
d_e1_dV_g_e = ((0.5*d_inv_g0_dV_g_e+0.5*d_T1_dV_g_e)+(2*r2)*d_g0_dV_g_e);
d_e1_dV_e_di = ((0.5*d_inv_g0_dV_e_di+0.5*d_T1_dV_e_di)+(2*r2)*d_g0_dV_e_di);
d_e1_dV_e_si = ((0.5*d_inv_g0_dV_e_si+0.5*d_T1_dV_e_si)+(2*r2)*d_g0_dV_e_si);
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));

d_e2_dV_di_si = ((-0.5)*d_inv_g0sq_dV_di_si-0.5*d_T2_dV_di_si);
d_e2_dV_g_si = ((-0.5)*d_inv_g0sq_dV_g_si-0.5*d_T2_dV_g_si);
d_e2_dV_g_e = ((-0.5)*d_inv_g0sq_dV_g_e-0.5*d_T2_dV_g_e);
d_e2_dV_e_di = ((-0.5)*d_inv_g0sq_dV_e_di-0.5*d_T2_dV_e_di);
d_e2_dV_e_si = ((-0.5)*d_inv_g0sq_dV_e_si-0.5*d_T2_dV_e_si);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2*r2));

d_e3_dV_di_si = ((inv_g0*d_inv_g0sq_dV_di_si+d_inv_g0_dV_di_si*inv_g0sq)+(T2*d_T1_dV_di_si+d_T2_dV_di_si*T1));
d_e3_dV_g_si = ((inv_g0*d_inv_g0sq_dV_g_si+d_inv_g0_dV_g_si*inv_g0sq)+(T2*d_T1_dV_g_si+d_T2_dV_g_si*T1));
d_e3_dV_g_e = ((inv_g0*d_inv_g0sq_dV_g_e+d_inv_g0_dV_g_e*inv_g0sq)+(T2*d_T1_dV_g_e+d_T2_dV_g_e*T1));
d_e3_dV_e_di = ((inv_g0*d_inv_g0sq_dV_e_di+d_inv_g0_dV_e_di*inv_g0sq)+(T2*d_T1_dV_e_di+d_T2_dV_e_di*T1));
d_e3_dV_e_si = ((inv_g0*d_inv_g0sq_dV_e_si+d_inv_g0_dV_e_si*inv_g0sq)+(T2*d_T1_dV_e_si+d_T2_dV_e_si*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_inv_g0sq_dV_di_si = (inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0);
d_inv_g0sq_dV_g_si = (inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0);
d_inv_g0sq_dV_g_e = (inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0);
d_inv_g0sq_dV_e_di = (inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0);
d_inv_g0sq_dV_e_si = (inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0);
inv_g0sq = (inv_g0*inv_g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = cdop*d_g0_dV_g_si;
d_T0_dV_g_e = cdop*d_g0_dV_g_e;
d_T0_dV_e_di = cdop*d_g0_dV_e_di;
d_T0_dV_e_si = cdop*d_g0_dV_e_si;
d_T0_dV_di_si = (cdop*d_g0_dV_di_si+d_cdop_dV_di_si*g0);
T0 = (1+(cdop*g0));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-cdop*d_T0_dV_g_si/T0/T0);
d_T1_dV_g_e = (-cdop*d_T0_dV_g_e/T0/T0);
d_T1_dV_e_di = (-cdop*d_T0_dV_e_di/T0/T0);
d_T1_dV_e_si = (-cdop*d_T0_dV_e_si/T0/T0);
d_T1_dV_di_si = ((T0*d_cdop_dV_di_si-cdop*d_T0_dV_di_si)/T0/T0);
T1 = (cdop/T0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (T1*d_T1_dV_di_si+d_T1_dV_di_si*T1);
d_T2_dV_g_si = (T1*d_T1_dV_g_si+d_T1_dV_g_si*T1);
d_T2_dV_g_e = (T1*d_T1_dV_g_e+d_T1_dV_g_e*T1);
d_T2_dV_e_di = (T1*d_T1_dV_e_di+d_T1_dV_e_di*T1);
d_T2_dV_e_si = (T1*d_T1_dV_e_si+d_T1_dV_e_si*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);

d_e0_dV_di_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_di_si))+r1*d_g0_dV_di_si)+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0))-d_F0_dV_di_si);
d_e0_dV_g_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_si))+r1*d_g0_dV_g_si)+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0))-d_F0_dV_g_si);
d_e0_dV_g_e = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_e))+r1*d_g0_dV_g_e)+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0))-d_F0_dV_g_e);
d_e0_dV_e_di = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_di))+r1*d_g0_dV_e_di)+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0))-d_F0_dV_e_di);
d_e0_dV_e_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_si))+r1*d_g0_dV_e_si)+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0))-d_F0_dV_e_si);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}

d_e1_dV_di_si = ((0.5*d_inv_g0_dV_di_si+0.5*d_T1_dV_di_si)+(2*r2)*d_g0_dV_di_si);
d_e1_dV_g_si = ((0.5*d_inv_g0_dV_g_si+0.5*d_T1_dV_g_si)+(2*r2)*d_g0_dV_g_si);
d_e1_dV_g_e = ((0.5*d_inv_g0_dV_g_e+0.5*d_T1_dV_g_e)+(2*r2)*d_g0_dV_g_e);
d_e1_dV_e_di = ((0.5*d_inv_g0_dV_e_di+0.5*d_T1_dV_e_di)+(2*r2)*d_g0_dV_e_di);
d_e1_dV_e_si = ((0.5*d_inv_g0_dV_e_si+0.5*d_T1_dV_e_si)+(2*r2)*d_g0_dV_e_si);
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));

d_e2_dV_di_si = ((-0.5)*d_inv_g0sq_dV_di_si-0.5*d_T2_dV_di_si);
d_e2_dV_g_si = ((-0.5)*d_inv_g0sq_dV_g_si-0.5*d_T2_dV_g_si);
d_e2_dV_g_e = ((-0.5)*d_inv_g0sq_dV_g_e-0.5*d_T2_dV_g_e);
d_e2_dV_e_di = ((-0.5)*d_inv_g0sq_dV_e_di-0.5*d_T2_dV_e_di);
d_e2_dV_e_si = ((-0.5)*d_inv_g0sq_dV_e_si-0.5*d_T2_dV_e_si);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2.0*r2));

d_e3_dV_di_si = ((inv_g0*d_inv_g0sq_dV_di_si+d_inv_g0_dV_di_si*inv_g0sq)+(T2*d_T1_dV_di_si+d_T2_dV_di_si*T1));
d_e3_dV_g_si = ((inv_g0*d_inv_g0sq_dV_g_si+d_inv_g0_dV_g_si*inv_g0sq)+(T2*d_T1_dV_g_si+d_T2_dV_g_si*T1));
d_e3_dV_g_e = ((inv_g0*d_inv_g0sq_dV_g_e+d_inv_g0_dV_g_e*inv_g0sq)+(T2*d_T1_dV_g_e+d_T2_dV_g_e*T1));
d_e3_dV_e_di = ((inv_g0*d_inv_g0sq_dV_e_di+d_inv_g0_dV_e_di*inv_g0sq)+(T2*d_T1_dV_e_di+d_T2_dV_e_di*T1));
d_e3_dV_e_si = ((inv_g0*d_inv_g0sq_dV_e_si+d_inv_g0_dV_e_si*inv_g0sq)+(T2*d_T1_dV_e_si+d_T2_dV_e_si*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_g0s_dV_di_si = d_g0_dV_di_si;
d_g0s_dV_g_si = d_g0_dV_g_si;
d_g0s_dV_g_e = d_g0_dV_g_e;
d_g0s_dV_e_di = d_g0_dV_e_di;
d_g0s_dV_e_si = d_g0_dV_e_si;
g0s = g0;
}

d_vpolys_dV_g_si = ((((2.0*nVtm)*r2)*g0s)*d_g0s_dV_g_si+((2.0*nVtm)*r2)*d_g0s_dV_g_si*g0s);
d_vpolys_dV_g_e = ((((2.0*nVtm)*r2)*g0s)*d_g0s_dV_g_e+((2.0*nVtm)*r2)*d_g0s_dV_g_e*g0s);
d_vpolys_dV_e_di = ((((2.0*nVtm)*r2)*g0s)*d_g0s_dV_e_di+((2.0*nVtm)*r2)*d_g0s_dV_e_di*g0s);
d_vpolys_dV_e_si = ((((2.0*nVtm)*r2)*g0s)*d_g0s_dV_e_si+((2.0*nVtm)*r2)*d_g0s_dV_e_si*g0s);
d_vpolys_dV_di_si = ((((2.0*nVtm)*r2)*g0s)*d_g0s_dV_di_si+(((2.0*nVtm)*r2)*d_g0s_dV_di_si+2.0*d_nVtm_dV_di_si*r2*g0s)*g0s);
vpolys = ((((2.0*nVtm)*r2)*g0s)*g0s);

d_phis_dV_g_e = ((-((2.0*nVtm)*r1)*d_g0s_dV_g_e)-d_vpolys_dV_g_e);
d_phis_dV_e_di = ((-((2.0*nVtm)*r1)*d_g0s_dV_e_di)-d_vpolys_dV_e_di);
d_phis_dV_e_si = ((-((2.0*nVtm)*r1)*d_g0s_dV_e_si)-d_vpolys_dV_e_si);
d_phis_dV_di_si = ((d_vgsfbeff_dV_di_si-(((2.0*nVtm)*r1)*d_g0s_dV_di_si+2.0*d_nVtm_dV_di_si*r1*g0s))-d_vpolys_dV_di_si);
d_phis_dV_g_si = ((d_vgsfbeff_dV_g_si-((2.0*nVtm)*r1)*d_g0s_dV_g_si)-d_vpolys_dV_g_si);
phis = ((vgsfbeff-(((2.0*nVtm)*r1)*g0s))-vpolys);

d_qis_dV_g_si = q0*d_g0s_dV_g_si;
d_qis_dV_g_e = q0*d_g0s_dV_g_e;
d_qis_dV_e_di = q0*d_g0s_dV_e_di;
d_qis_dV_e_si = q0*d_g0s_dV_e_si;
d_qis_dV_di_si = (q0*d_g0s_dV_di_si+d_q0_dV_di_si*g0s);
qis = (q0*g0s);
}
if (((model_.GEOMOD)!=3))
{
if ((NGATE_i>0))
{
{
double value_sqrt_0 = sqrt((1.0+((vgsfbeff-phis)/vpoly0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_g_di =  0.0;
d_T0_dV_g_e = (deriv_sqrt_0_d0*(((-d_phis_dV_g_e)/vpoly0)));
d_T0_dV_e_di = (deriv_sqrt_0_d0*(((-d_phis_dV_e_di)/vpoly0)));
d_T0_dV_e_si = (deriv_sqrt_0_d0*(((-d_phis_dV_e_si)/vpoly0)));
d_T0_dV_di_si = (deriv_sqrt_0_d0*(((d_vgsfbeff_dV_di_si-d_phis_dV_di_si)/vpoly0)));
d_T0_dV_g_si = (deriv_sqrt_0_d0*(((d_vgsfbeff_dV_g_si-d_phis_dV_g_si)/vpoly0)));
T0 = (value_sqrt_0-1.0);
}

d_vpolys_dV_di_si = ((vpoly0*T0)*d_T0_dV_di_si+vpoly0*d_T0_dV_di_si*T0);
d_vpolys_dV_g_si = ((vpoly0*T0)*d_T0_dV_g_si+vpoly0*d_T0_dV_g_si*T0);
d_vpolys_dV_g_e = ((vpoly0*T0)*d_T0_dV_g_e+vpoly0*d_T0_dV_g_e*T0);
d_vpolys_dV_e_di = ((vpoly0*T0)*d_T0_dV_e_di+vpoly0*d_T0_dV_e_di*T0);
d_vpolys_dV_e_si = ((vpoly0*T0)*d_T0_dV_e_si+vpoly0*d_T0_dV_e_si*T0);
vpolys = ((vpoly0*T0)*T0);
}
else
{

d_vpolys_dV_di_si = d_vpolys_dV_e_si = d_vpolys_dV_e_di = d_vpolys_dV_g_e = d_vpolys_dV_g_si =  0.0;
vpolys = 0;
}

d_qis_dV_g_e = (((model_.COREMOD)!=0)?((-d_phis_dV_g_e)-d_vpolys_dV_g_e):((-d_phis_dV_g_e)-d_vpolys_dV_g_e));
d_qis_dV_e_di = (((model_.COREMOD)!=0)?((-d_phis_dV_e_di)-d_vpolys_dV_e_di):((-d_phis_dV_e_di)-d_vpolys_dV_e_di));
d_qis_dV_e_si = (((model_.COREMOD)!=0)?((-d_phis_dV_e_si)-d_vpolys_dV_e_si):((-d_phis_dV_e_si)-d_vpolys_dV_e_si));
d_qis_dV_di_si = (((model_.COREMOD)!=0)?((d_vgsfbeff_dV_di_si-d_phis_dV_di_si)-d_vpolys_dV_di_si):((d_vgsfbeff_dV_di_si-d_phis_dV_di_si)-d_vpolys_dV_di_si));
d_qis_dV_g_si = (((model_.COREMOD)!=0)?((d_vgsfbeff_dV_g_si-d_phis_dV_g_si)-d_vpolys_dV_g_si):((d_vgsfbeff_dV_g_si-d_phis_dV_g_si)-d_vpolys_dV_g_si));
qis = (((model_.COREMOD)!=0)?((vgsfbeff-phis)-vpolys):(((vgsfbeff-phis)-qbs)-vpolys));
}

d_Eeffs_dV_g_si = EeffFactor*eta_mu*d_qis_dV_g_si;
d_Eeffs_dV_g_e = EeffFactor*eta_mu*d_qis_dV_g_e;
d_Eeffs_dV_e_di = EeffFactor*eta_mu*d_qis_dV_e_di;
d_Eeffs_dV_e_si = EeffFactor*eta_mu*d_qis_dV_e_si;
d_Eeffs_dV_di_si = EeffFactor*eta_mu*d_qis_dV_di_si;
Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
qb0 = (1.0e-2/cox);
{
double value_fabs_0 = fabs((qis/qb0));
double value_pow_1 = pow((0.5*(1.0+value_fabs_0)),UCS_t);
double  deriv_fabs_0_d0 = ((((qis/qb0))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = (((0.5*(1.0+value_fabs_0)) == 0.0)?0.0:(value_pow_1*UCS_t/(0.5*(1.0+value_fabs_0))));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_g_si = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qis_dV_g_si/qb0)))));
d_T2_dV_g_e = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qis_dV_g_e/qb0)))));
d_T2_dV_e_di = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qis_dV_e_di/qb0)))));
d_T2_dV_e_si = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qis_dV_e_si/qb0)))));
d_T2_dV_di_si = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qis_dV_di_si/qb0)))));
T2 = value_pow_1;
}
if (((model_.BULKMOD)!=0))
{
{
double value_fabs_0 = fabs(Eeffs);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffs)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));

d_T3_dV_g_di =  0.0;
d_T3_dV_g_si = ((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_g_si))))+(-UD_t*d_T2_dV_g_si/T2/T2));
d_T3_dV_g_e = ((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_g_e))))+(-UD_t*d_T2_dV_g_e/T2/T2));
d_T3_dV_di_si = (((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_di_si))))+UC_t*d_veseff_dV_di_si*value_pow_1)+(-UD_t*d_T2_dV_di_si/T2/T2));
d_T3_dV_e_di = (((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_e_di))))+UC_t*d_veseff_dV_e_di*value_pow_1)+(-UD_t*d_T2_dV_e_di/T2/T2));
d_T3_dV_e_si = (((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_e_si))))+UC_t*d_veseff_dV_e_si*value_pow_1)+(-UD_t*d_T2_dV_e_si/T2/T2));
T3 = (((UA_t+(UC_t*veseff))*value_pow_1)+(UD_t/T2));
}
}
else
{
{
double value_fabs_0 = fabs(Eeffs);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffs)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));

d_T3_dV_g_di =  0.0;
d_T3_dV_g_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_g_si))))+(-UD_t*d_T2_dV_g_si/T2/T2));
d_T3_dV_g_e = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_g_e))))+(-UD_t*d_T2_dV_g_e/T2/T2));
d_T3_dV_e_di = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_e_di))))+(-UD_t*d_T2_dV_e_di/T2/T2));
d_T3_dV_e_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_e_si))))+(-UD_t*d_T2_dV_e_si/T2/T2));
d_T3_dV_di_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffs_dV_di_si))))+(-UD_t*d_T2_dV_di_si/T2/T2));
T3 = ((UA_t*value_pow_1)+(UD_t/T2));
}
}

d_Dmobs_dV_di_si = d_T3_dV_di_si;
d_Dmobs_dV_e_di = d_T3_dV_e_di;
d_Dmobs_dV_e_si = d_T3_dV_e_si;
d_Dmobs_dV_g_si = d_T3_dV_g_si;
d_Dmobs_dV_g_e = d_T3_dV_g_e;
Dmobs = (1.0+T3);

d_Dmobs_dV_di_si = (d_Dmobs_dV_di_si/U0MULT);
d_Dmobs_dV_e_di = (d_Dmobs_dV_e_di/U0MULT);
d_Dmobs_dV_e_si = (d_Dmobs_dV_e_si/U0MULT);
d_Dmobs_dV_g_si = (d_Dmobs_dV_g_si/U0MULT);
d_Dmobs_dV_g_e = (d_Dmobs_dV_g_e/U0MULT);
Dmobs = (Dmobs/U0MULT);
if (((model_.RDSMOD)!=0))
{

d_Rdss_dV_e_si = d_Rdss_dV_e_di = d_Rdss_dV_g_e = d_Rdss_dV_g_si = d_Rdss_dV_di_si =  0.0;
Rdss = 0.0;
}
else
{

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = PRWGS_i*d_qis_dV_g_si;
d_T4_dV_g_e = PRWGS_i*d_qis_dV_g_e;
d_T4_dV_e_di = PRWGS_i*d_qis_dV_e_di;
d_T4_dV_e_si = PRWGS_i*d_qis_dV_e_si;
d_T4_dV_di_si = PRWGS_i*d_qis_dV_di_si;
T4 = (1.0+(PRWGS_i*qis));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-d_T4_dV_g_si/T4/T4);
d_T1_dV_g_e = (-d_T4_dV_g_e/T4/T4);
d_T1_dV_e_di = (-d_T4_dV_e_di/T4/T4);
d_T1_dV_e_si = (-d_T4_dV_e_si/T4/T4);
d_T1_dV_di_si = (-d_T4_dV_di_si/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = 0.5*(d_T1_dV_di_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1))));
d_T0_dV_g_si = 0.5*(d_T1_dV_g_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1))));
d_T0_dV_g_e = 0.5*(d_T1_dV_g_e+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1))));
d_T0_dV_e_di = 0.5*(d_T1_dV_e_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1))));
d_T0_dV_e_si = 0.5*(d_T1_dV_e_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1))));
T0 = (0.5*(T1+value_sqrt_0));
}

d_Rdss_dV_di_si = RDSW_i*d_T0_dV_di_si*WeffWRFactor*NFINtotal*rdstemp;
d_Rdss_dV_g_si = RDSW_i*d_T0_dV_g_si*WeffWRFactor*NFINtotal*rdstemp;
d_Rdss_dV_g_e = RDSW_i*d_T0_dV_g_e*WeffWRFactor*NFINtotal*rdstemp;
d_Rdss_dV_e_di = RDSW_i*d_T0_dV_e_di*WeffWRFactor*NFINtotal*rdstemp;
d_Rdss_dV_e_si = RDSW_i*d_T0_dV_e_si*WeffWRFactor*NFINtotal*rdstemp;
Rdss = ((((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp);
}

d_Esat_dV_di_si = ((2*VSAT_t)/u0)*d_Dmobs_dV_di_si;
d_Esat_dV_e_di = ((2*VSAT_t)/u0)*d_Dmobs_dV_e_di;
d_Esat_dV_e_si = ((2*VSAT_t)/u0)*d_Dmobs_dV_e_si;
d_Esat_dV_g_si = ((2*VSAT_t)/u0)*d_Dmobs_dV_g_si;
d_Esat_dV_g_e = ((2*VSAT_t)/u0)*d_Dmobs_dV_g_e;
Esat = (((2*VSAT_t)/u0)*Dmobs);

d_EsatL_dV_di_si = d_Esat_dV_di_si*Leff;
d_EsatL_dV_e_di = d_Esat_dV_e_di*Leff;
d_EsatL_dV_e_si = d_Esat_dV_e_si*Leff;
d_EsatL_dV_g_si = d_Esat_dV_g_si*Leff;
d_EsatL_dV_g_e = d_Esat_dV_g_e*Leff;
EsatL = (Esat*Leff);

d_T6_dV_g_di = d_T6_dV_di_d = d_T6_dV_si_s =  0.0;
d_T6_dV_g_e = KSATIV_i*(-d_phis_dV_g_e);
d_T6_dV_e_di = KSATIV_i*(-d_phis_dV_e_di);
d_T6_dV_e_si = KSATIV_i*(-d_phis_dV_e_si);
d_T6_dV_di_si = KSATIV_i*(d_vgsfbeff_dV_di_si-d_phis_dV_di_si);
d_T6_dV_g_si = KSATIV_i*(d_vgsfbeff_dV_g_si-d_phis_dV_g_si);
T6 = (KSATIV_i*((vgsfbeff-phis)+(2*Vtm)));
if ((Rdss==0))
{

d_Vdsat_dV_di_si = (((EsatL+T6)*(EsatL*d_T6_dV_di_si+d_EsatL_dV_di_si*T6)-(EsatL*T6)*(d_EsatL_dV_di_si+d_T6_dV_di_si))/(EsatL+T6)/(EsatL+T6));
d_Vdsat_dV_e_di = (((EsatL+T6)*(EsatL*d_T6_dV_e_di+d_EsatL_dV_e_di*T6)-(EsatL*T6)*(d_EsatL_dV_e_di+d_T6_dV_e_di))/(EsatL+T6)/(EsatL+T6));
d_Vdsat_dV_e_si = (((EsatL+T6)*(EsatL*d_T6_dV_e_si+d_EsatL_dV_e_si*T6)-(EsatL*T6)*(d_EsatL_dV_e_si+d_T6_dV_e_si))/(EsatL+T6)/(EsatL+T6));
d_Vdsat_dV_g_si = (((EsatL+T6)*(EsatL*d_T6_dV_g_si+d_EsatL_dV_g_si*T6)-(EsatL*T6)*(d_EsatL_dV_g_si+d_T6_dV_g_si))/(EsatL+T6)/(EsatL+T6));
d_Vdsat_dV_g_e = (((EsatL+T6)*(EsatL*d_T6_dV_g_e+d_EsatL_dV_g_e*T6)-(EsatL*T6)*(d_EsatL_dV_g_e+d_T6_dV_g_e))/(EsatL+T6)/(EsatL+T6));
Vdsat = ((EsatL*T6)/(EsatL+T6));
}
else
{
WVCox = ((Weff0*VSAT_t)*cox);

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = WVCox*d_Rdss_dV_di_si;
d_T0_dV_g_si = WVCox*d_Rdss_dV_g_si;
d_T0_dV_g_e = WVCox*d_Rdss_dV_g_e;
d_T0_dV_e_di = WVCox*d_Rdss_dV_e_di;
d_T0_dV_e_si = WVCox*d_Rdss_dV_e_si;
T0 = (WVCox*Rdss);

d_Ta_dV_di_si = 2*d_T0_dV_di_si;
d_Ta_dV_g_si = 2*d_T0_dV_g_si;
d_Ta_dV_g_e = 2*d_T0_dV_g_e;
d_Ta_dV_e_di = 2*d_T0_dV_e_di;
d_Ta_dV_e_si = 2*d_T0_dV_e_si;
Ta = (2*T0);

d_Tb_dV_g_e = ((d_T6_dV_g_e+d_EsatL_dV_g_e)+((3*T6)*d_T0_dV_g_e+3*d_T6_dV_g_e*T0));
d_Tb_dV_e_di = ((d_T6_dV_e_di+d_EsatL_dV_e_di)+((3*T6)*d_T0_dV_e_di+3*d_T6_dV_e_di*T0));
d_Tb_dV_e_si = ((d_T6_dV_e_si+d_EsatL_dV_e_si)+((3*T6)*d_T0_dV_e_si+3*d_T6_dV_e_si*T0));
d_Tb_dV_di_si = ((d_T6_dV_di_si+d_EsatL_dV_di_si)+((3*T6)*d_T0_dV_di_si+3*d_T6_dV_di_si*T0));
d_Tb_dV_g_si = ((d_T6_dV_g_si+d_EsatL_dV_g_si)+((3*T6)*d_T0_dV_g_si+3*d_T6_dV_g_si*T0));
Tb = ((T6+EsatL)+((3*T6)*T0));

d_Tc_dV_g_e = (T6*(d_EsatL_dV_g_e+((2*T6)*d_T0_dV_g_e+2*d_T6_dV_g_e*T0))+d_T6_dV_g_e*(EsatL+((2*T6)*T0)));
d_Tc_dV_e_di = (T6*(d_EsatL_dV_e_di+((2*T6)*d_T0_dV_e_di+2*d_T6_dV_e_di*T0))+d_T6_dV_e_di*(EsatL+((2*T6)*T0)));
d_Tc_dV_e_si = (T6*(d_EsatL_dV_e_si+((2*T6)*d_T0_dV_e_si+2*d_T6_dV_e_si*T0))+d_T6_dV_e_si*(EsatL+((2*T6)*T0)));
d_Tc_dV_di_si = (T6*(d_EsatL_dV_di_si+((2*T6)*d_T0_dV_di_si+2*d_T6_dV_di_si*T0))+d_T6_dV_di_si*(EsatL+((2*T6)*T0)));
d_Tc_dV_g_si = (T6*(d_EsatL_dV_g_si+((2*T6)*d_T0_dV_g_si+2*d_T6_dV_g_si*T0))+d_T6_dV_g_si*(EsatL+((2*T6)*T0)));
Tc = (T6*(EsatL+((2*T6)*T0)));
{
double value_sqrt_0 = sqrt(((Tb*Tb)-((2*Ta)*Tc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdsat_dV_g_e = ((Ta*(d_Tb_dV_g_e-(deriv_sqrt_0_d0*(((Tb*d_Tb_dV_g_e+d_Tb_dV_g_e*Tb)-((2*Ta)*d_Tc_dV_g_e+2*d_Ta_dV_g_e*Tc)))))-(Tb-value_sqrt_0)*d_Ta_dV_g_e)/Ta/Ta);
d_Vdsat_dV_e_di = ((Ta*(d_Tb_dV_e_di-(deriv_sqrt_0_d0*(((Tb*d_Tb_dV_e_di+d_Tb_dV_e_di*Tb)-((2*Ta)*d_Tc_dV_e_di+2*d_Ta_dV_e_di*Tc)))))-(Tb-value_sqrt_0)*d_Ta_dV_e_di)/Ta/Ta);
d_Vdsat_dV_e_si = ((Ta*(d_Tb_dV_e_si-(deriv_sqrt_0_d0*(((Tb*d_Tb_dV_e_si+d_Tb_dV_e_si*Tb)-((2*Ta)*d_Tc_dV_e_si+2*d_Ta_dV_e_si*Tc)))))-(Tb-value_sqrt_0)*d_Ta_dV_e_si)/Ta/Ta);
d_Vdsat_dV_di_si = ((Ta*(d_Tb_dV_di_si-(deriv_sqrt_0_d0*(((Tb*d_Tb_dV_di_si+d_Tb_dV_di_si*Tb)-((2*Ta)*d_Tc_dV_di_si+2*d_Ta_dV_di_si*Tc)))))-(Tb-value_sqrt_0)*d_Ta_dV_di_si)/Ta/Ta);
d_Vdsat_dV_g_si = ((Ta*(d_Tb_dV_g_si-(deriv_sqrt_0_d0*(((Tb*d_Tb_dV_g_si+d_Tb_dV_g_si*Tb)-((2*Ta)*d_Tc_dV_g_si+2*d_Ta_dV_g_si*Tc)))))-(Tb-value_sqrt_0)*d_Ta_dV_g_si)/Ta/Ta);
Vdsat = ((Tb-value_sqrt_0)/Ta);
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((Vdsat-1.0E-3),1.0E-5);

d_Vdsat_dV_di_si = evaluator_hypsmooth_0.getDerivs((Vdsat-1.0E-3),1.0E-5,d_Vdsat_dV_di_si,0.0);
d_Vdsat_dV_e_di = evaluator_hypsmooth_0.getDerivs((Vdsat-1.0E-3),1.0E-5,d_Vdsat_dV_e_di,0.0);
d_Vdsat_dV_e_si = evaluator_hypsmooth_0.getDerivs((Vdsat-1.0E-3),1.0E-5,d_Vdsat_dV_e_si,0.0);
d_Vdsat_dV_g_si = evaluator_hypsmooth_0.getDerivs((Vdsat-1.0E-3),1.0E-5,d_Vdsat_dV_g_si,0.0);
d_Vdsat_dV_g_e = evaluator_hypsmooth_0.getDerivs((Vdsat-1.0E-3),1.0E-5,d_Vdsat_dV_g_e,0.0);
Vdsat = (evaluator_hypsmooth_0.getValues((Vdsat-1.0E-3),1.0E-5)+1.0E-3);
}
{
double value_pow_0 = pow((vds/Vdsat),MEXP_a);
double  deriv_pow_0_d0 = (((vds/Vdsat) == 0.0)?0.0:(value_pow_0*MEXP_a/(vds/Vdsat)));
double  deriv_pow_0_d1 = ((vds/Vdsat) == 0.0)?0.0:(log((vds/Vdsat))*value_pow_0);

d_T7_dV_e_di = (deriv_pow_0_d0*((-vds*d_Vdsat_dV_e_di/Vdsat/Vdsat)));
d_T7_dV_e_si = (deriv_pow_0_d0*((-vds*d_Vdsat_dV_e_si/Vdsat/Vdsat)));
d_T7_dV_g_si = (deriv_pow_0_d0*((-vds*d_Vdsat_dV_g_si/Vdsat/Vdsat)));
d_T7_dV_g_e = (deriv_pow_0_d0*((-vds*d_Vdsat_dV_g_e/Vdsat/Vdsat)));
d_T7_dV_di_si = ((deriv_pow_0_d0*(((Vdsat*d_vds_dV_di_si-vds*d_Vdsat_dV_di_si)/Vdsat/Vdsat)))+(deriv_pow_0_d1*(d_MEXP_a_dV_di_si)));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),inv_MEXP);
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*inv_MEXP/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);

d_T8_dV_di_si = ((deriv_pow_0_d0*(d_T7_dV_di_si))+(deriv_pow_0_d1*(d_inv_MEXP_dV_di_si)));
d_T8_dV_g_si = (deriv_pow_0_d0*(d_T7_dV_g_si));
d_T8_dV_g_e = (deriv_pow_0_d0*(d_T7_dV_g_e));
d_T8_dV_e_di = (deriv_pow_0_d0*(d_T7_dV_e_di));
d_T8_dV_e_si = (deriv_pow_0_d0*(d_T7_dV_e_si));
T8 = value_pow_0;
}

d_Vdseff_dV_g_si = (-vds*d_T8_dV_g_si/T8/T8);
d_Vdseff_dV_g_e = (-vds*d_T8_dV_g_e/T8/T8);
d_Vdseff_dV_e_di = (-vds*d_T8_dV_e_di/T8/T8);
d_Vdseff_dV_e_si = (-vds*d_T8_dV_e_si/T8/T8);
d_Vdseff_dV_di_si = ((T8*d_vds_dV_di_si-vds*d_T8_dV_di_si)/T8/T8);
Vdseff = (vds/T8);
if ((Vdseff>vds))
{

d_Vdseff_dV_e_si = d_Vdseff_dV_e_di = d_Vdseff_dV_g_e = d_Vdseff_dV_g_si =  0.0;
d_Vdseff_dV_di_si = d_vds_dV_di_si;
Vdseff = vds;
}

d_vch_dV_g_si = d_Vdseff_dV_g_si;
d_vch_dV_g_e = d_Vdseff_dV_g_e;
d_vch_dV_e_di = d_Vdseff_dV_e_di;
d_vch_dV_e_si = d_Vdseff_dV_e_si;
d_vch_dV_di_si = d_Vdseff_dV_di_si;
vch = (Vdseff+dvch_qm);
if (((model_.GEOMOD)!=3))
{
if (((model_.COREMOD)!=0))
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di =  0.0;
d_F0_dV_g_e = ((-d_vch_dV_g_e)/(2.0*nVtm));
d_F0_dV_e_di = ((-d_vch_dV_e_di)/(2.0*nVtm));
d_F0_dV_e_si = ((-d_vch_dV_e_si)/(2.0*nVtm));
d_F0_dV_di_si = ((((2.0*nVtm)*(d_vgsfbeff_dV_di_si-d_vch_dV_di_si)-(vgsfbeff-vch)*2.0*d_nVtm_dV_di_si)/(2.0*nVtm)/(2.0*nVtm))-d_F1_dV_di_si);
d_F0_dV_g_si = ((d_vgsfbeff_dV_g_si-d_vch_dV_g_si)/(2.0*nVtm));
F0 = (((vgsfbeff-vch)/(2.0*nVtm))-F1);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);

d_expff_dV_di_si = evaluator_lexp_0.getDerivs(F0,d_F0_dV_di_si);
d_expff_dV_g_si = evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_si);
d_expff_dV_g_e = evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_e);
d_expff_dV_e_di = evaluator_lexp_0.getDerivs(F0,d_F0_dV_e_di);
d_expff_dV_e_si = evaluator_lexp_0.getDerivs(F0,d_F0_dV_e_si);
expff = evaluator_lexp_0.getValues(F0);
}
{
double value_atan_0 = atan(expff);
double  deriv_atan_0_d0 = (+1.0/(1+expff*expff));

d_z1_dV_di_si = (deriv_atan_0_d0*(d_expff_dV_di_si));
d_z1_dV_g_si = (deriv_atan_0_d0*(d_expff_dV_g_si));
d_z1_dV_g_e = (deriv_atan_0_d0*(d_expff_dV_g_e));
d_z1_dV_e_di = (deriv_atan_0_d0*(d_expff_dV_e_di));
d_z1_dV_e_si = (deriv_atan_0_d0*(d_expff_dV_e_si));
z1 = value_atan_0;
}
if ((F0>80.0))
{

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = d_F0_dV_di_si;
d_T0_dV_g_si = d_F0_dV_g_si;
d_T0_dV_g_e = d_F0_dV_g_e;
d_T0_dV_e_di = d_F0_dV_e_di;
d_T0_dV_e_si = d_F0_dV_e_si;
T0 = F0;
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+expff));

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_di_si);
d_T0_dV_g_si = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_g_si);
d_T0_dV_g_e = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_g_e);
d_T0_dV_e_di = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_e_di);
d_T0_dV_e_si = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dV_e_si);
T0 = evaluator_lln_0.getValues((1.0+expff));
}
}
{
double value_atan_0 = atan(((2*T0)*Inv_r1pi));
double  deriv_atan_0_d0 = (+1.0/(1+((2*T0)*Inv_r1pi)*((2*T0)*Inv_r1pi)));

d_z2_dV_di_si = (deriv_atan_0_d0*(2*d_T0_dV_di_si*Inv_r1pi));
d_z2_dV_g_si = (deriv_atan_0_d0*(2*d_T0_dV_g_si*Inv_r1pi));
d_z2_dV_g_e = (deriv_atan_0_d0*(2*d_T0_dV_g_e*Inv_r1pi));
d_z2_dV_e_di = (deriv_atan_0_d0*(2*d_T0_dV_e_di*Inv_r1pi));
d_z2_dV_e_si = (deriv_atan_0_d0*(2*d_T0_dV_e_si*Inv_r1pi));
z2 = value_atan_0;
}
{
double value_max_0 = std::max(z2,static_cast<double>(1e-15));
double value_min_1 = std::min(z1,value_max_0);
double  deriv_max_0_d0 = ((z2>=1e-15)?1.0:0.0);
double  deriv_min_1_d0 = ((z1<=value_max_0)?1.0:0.0);
double  deriv_min_1_d1 = ((z1<=value_max_0)?0.0:1.0);

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = ((deriv_min_1_d0*(d_z1_dV_di_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_di_si)))));
d_g0_dV_g_si = ((deriv_min_1_d0*(d_z1_dV_g_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_g_si)))));
d_g0_dV_g_e = ((deriv_min_1_d0*(d_z1_dV_g_e))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_g_e)))));
d_g0_dV_e_di = ((deriv_min_1_d0*(d_z1_dV_e_di))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_e_di)))));
d_g0_dV_e_si = ((deriv_min_1_d0*(d_z1_dV_e_si))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dV_e_si)))));
g0 = value_min_1;
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);

d_lng0_dV_di_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si);
d_lng0_dV_g_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si);
d_lng0_dV_g_e = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e);
d_lng0_dV_e_di = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di);
d_lng0_dV_e_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si);
lng0 = evaluator_lln_0.getValues(g0);
}

d_secg0sq_dV_di_si = (tang0*d_tang0_dV_di_si+d_tang0_dV_di_si*tang0);
d_secg0sq_dV_g_si = (tang0*d_tang0_dV_g_si+d_tang0_dV_g_si*tang0);
d_secg0sq_dV_g_e = (tang0*d_tang0_dV_g_e+d_tang0_dV_g_e*tang0);
d_secg0sq_dV_e_di = (tang0*d_tang0_dV_e_di+d_tang0_dV_e_di*tang0);
d_secg0sq_dV_e_si = (tang0*d_tang0_dV_e_si+d_tang0_dV_e_si*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);

d_lncosg0_dV_di_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_di_si);
d_lncosg0_dV_g_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_si);
d_lncosg0_dV_g_e = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_e);
d_lncosg0_dV_e_di = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_di);
d_lncosg0_dV_e_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_si);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (g0*tang0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (T0*d_T0_dV_di_si+d_T0_dV_di_si*T0);
d_T1_dV_g_si = (T0*d_T0_dV_g_si+d_T0_dV_g_si*T0);
d_T1_dV_g_e = (T0*d_T0_dV_g_e+d_T0_dV_g_e*T0);
d_T1_dV_e_di = (T0*d_T0_dV_e_di+d_T0_dV_e_di*T0);
d_T1_dV_e_si = (T0*d_T0_dV_e_si+d_T0_dV_e_si*T0);
T1 = (T0*T0);

d_e0_dV_di_si = ((((d_lng0_dV_di_si-d_lncosg0_dV_di_si)+r1*d_T0_dV_di_si)+r2*d_T1_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = ((((d_lng0_dV_g_si-d_lncosg0_dV_g_si)+r1*d_T0_dV_g_si)+r2*d_T1_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = ((((d_lng0_dV_g_e-d_lncosg0_dV_g_e)+r1*d_T0_dV_g_e)+r2*d_T1_dV_g_e)-d_F0_dV_g_e);
d_e0_dV_e_di = ((((d_lng0_dV_e_di-d_lncosg0_dV_e_di)+r1*d_T0_dV_e_di)+r2*d_T1_dV_e_di)-d_F0_dV_e_di);
d_e0_dV_e_si = ((((d_lng0_dV_e_si-d_lncosg0_dV_e_si)+r1*d_T0_dV_e_si)+r2*d_T1_dV_e_si)-d_F0_dV_e_si);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);

d_e1_dV_di_si = ((d_inv_g0_dV_di_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_di_si+(secg0sq*d_g0_dV_di_si+d_secg0sq_dV_di_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_di_si+d_tang0_dV_di_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_si = ((d_inv_g0_dV_g_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_si+(secg0sq*d_g0_dV_g_si+d_secg0sq_dV_g_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_si+d_tang0_dV_g_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_e = ((d_inv_g0_dV_g_e+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_e+(secg0sq*d_g0_dV_g_e+d_secg0sq_dV_g_e*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_e+d_tang0_dV_g_e*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_di = ((d_inv_g0_dV_e_di+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_di+(secg0sq*d_g0_dV_e_di+d_secg0sq_dV_e_di*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_di+d_tang0_dV_e_di*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_si = ((d_inv_g0_dV_e_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_si+(secg0sq*d_g0_dV_e_si+d_secg0sq_dV_e_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_si+d_tang0_dV_e_si*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));

d_e2_dV_di_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_di_si+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0)*secg0sq)+d_T0_dV_di_si*r1)+(2.0*r2)*(d_T1_dV_di_si+2.0*d_T0_dV_di_si))+d_secg0sq_dV_di_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_di_si*r2+(inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_si+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0)*secg0sq)+d_T0_dV_g_si*r1)+(2.0*r2)*(d_T1_dV_g_si+2.0*d_T0_dV_g_si))+d_secg0sq_dV_g_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_si*r2+(inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_e = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_e+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0)*secg0sq)+d_T0_dV_g_e*r1)+(2.0*r2)*(d_T1_dV_g_e+2.0*d_T0_dV_g_e))+d_secg0sq_dV_g_e*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_e*r2+(inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_di = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_di+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0)*secg0sq)+d_T0_dV_e_di*r1)+(2.0*r2)*(d_T1_dV_e_di+2.0*d_T0_dV_e_di))+d_secg0sq_dV_e_di*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_di*r2+(inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_si+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0)*secg0sq)+d_T0_dV_e_si*r1)+(2.0*r2)*(d_T1_dV_e_si+2.0*d_T0_dV_e_si))+d_secg0sq_dV_e_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_si*r2+(inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));

d_e3_dV_di_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_di_si+((2.0*inv_g0)*d_inv_g0_dV_di_si+2.0*d_inv_g0_dV_di_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_di_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_di_si+((2.0*g0)*d_secg0sq_dV_di_si+2.0*d_g0_dV_di_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_di_si+(2.0*r2)*(3.0*2.0*d_T0_dV_di_si+2.0*d_T1_dV_di_si))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_si+((2.0*inv_g0)*d_inv_g0_dV_g_si+2.0*d_inv_g0_dV_g_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_si+((2.0*g0)*d_secg0sq_dV_g_si+2.0*d_g0_dV_g_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_si+(2.0*r2)*(3.0*2.0*d_T0_dV_g_si+2.0*d_T1_dV_g_si))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_e = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_e+((2.0*inv_g0)*d_inv_g0_dV_g_e+2.0*d_inv_g0_dV_g_e*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_e+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_e+((2.0*g0)*d_secg0sq_dV_g_e+2.0*d_g0_dV_g_e*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_e+(2.0*r2)*(3.0*2.0*d_T0_dV_g_e+2.0*d_T1_dV_g_e))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_di = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_di+((2.0*inv_g0)*d_inv_g0_dV_e_di+2.0*d_inv_g0_dV_e_di*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_di+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_di+((2.0*g0)*d_secg0sq_dV_e_di+2.0*d_g0_dV_e_di*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_di+(2.0*r2)*(3.0*2.0*d_T0_dV_e_di+2.0*d_T1_dV_e_di))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_si+((2.0*inv_g0)*d_inv_g0_dV_e_si+2.0*d_inv_g0_dV_e_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_si+((2.0*g0)*d_secg0sq_dV_e_si+2.0*d_g0_dV_e_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_si+(2.0*r2)*(3.0*2.0*d_T0_dV_e_si+2.0*d_T1_dV_e_si))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);

d_lng0_dV_di_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si);
d_lng0_dV_g_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si);
d_lng0_dV_g_e = evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e);
d_lng0_dV_e_di = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di);
d_lng0_dV_e_si = evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si);
lng0 = evaluator_lln_0.getValues(g0);
}

d_secg0sq_dV_di_si = (tang0*d_tang0_dV_di_si+d_tang0_dV_di_si*tang0);
d_secg0sq_dV_g_si = (tang0*d_tang0_dV_g_si+d_tang0_dV_g_si*tang0);
d_secg0sq_dV_g_e = (tang0*d_tang0_dV_g_e+d_tang0_dV_g_e*tang0);
d_secg0sq_dV_e_di = (tang0*d_tang0_dV_e_di+d_tang0_dV_e_di*tang0);
d_secg0sq_dV_e_si = (tang0*d_tang0_dV_e_si+d_tang0_dV_e_si*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);

d_lncosg0_dV_di_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_di_si);
d_lncosg0_dV_g_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_si);
d_lncosg0_dV_g_e = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_g_e);
d_lncosg0_dV_e_di = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_di);
d_lncosg0_dV_e_si = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dV_e_si);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (g0*tang0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (T0*d_T0_dV_di_si+d_T0_dV_di_si*T0);
d_T1_dV_g_si = (T0*d_T0_dV_g_si+d_T0_dV_g_si*T0);
d_T1_dV_g_e = (T0*d_T0_dV_g_e+d_T0_dV_g_e*T0);
d_T1_dV_e_di = (T0*d_T0_dV_e_di+d_T0_dV_e_di*T0);
d_T1_dV_e_si = (T0*d_T0_dV_e_si+d_T0_dV_e_si*T0);
T1 = (T0*T0);

d_e0_dV_di_si = ((((d_lng0_dV_di_si-d_lncosg0_dV_di_si)+r1*d_T0_dV_di_si)+r2*d_T1_dV_di_si)-d_F0_dV_di_si);
d_e0_dV_g_si = ((((d_lng0_dV_g_si-d_lncosg0_dV_g_si)+r1*d_T0_dV_g_si)+r2*d_T1_dV_g_si)-d_F0_dV_g_si);
d_e0_dV_g_e = ((((d_lng0_dV_g_e-d_lncosg0_dV_g_e)+r1*d_T0_dV_g_e)+r2*d_T1_dV_g_e)-d_F0_dV_g_e);
d_e0_dV_e_di = ((((d_lng0_dV_e_di-d_lncosg0_dV_e_di)+r1*d_T0_dV_e_di)+r2*d_T1_dV_e_di)-d_F0_dV_e_di);
d_e0_dV_e_si = ((((d_lng0_dV_e_si-d_lncosg0_dV_e_si)+r1*d_T0_dV_e_si)+r2*d_T1_dV_e_si)-d_F0_dV_e_si);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);

d_e1_dV_di_si = ((d_inv_g0_dV_di_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_di_si+(secg0sq*d_g0_dV_di_si+d_secg0sq_dV_di_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_di_si+d_tang0_dV_di_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_si = ((d_inv_g0_dV_g_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_si+(secg0sq*d_g0_dV_g_si+d_secg0sq_dV_g_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_si+d_tang0_dV_g_si*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_g_e = ((d_inv_g0_dV_g_e+((secg0sq*g0)*(2.0*r2)*d_T0_dV_g_e+(secg0sq*d_g0_dV_g_e+d_secg0sq_dV_g_e*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_g_e+d_tang0_dV_g_e*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_di = ((d_inv_g0_dV_e_di+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_di+(secg0sq*d_g0_dV_e_di+d_secg0sq_dV_e_di*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_di+d_tang0_dV_e_di*(1.0+(r1+((2.0*r2)*T0)))));
d_e1_dV_e_si = ((d_inv_g0_dV_e_si+((secg0sq*g0)*(2.0*r2)*d_T0_dV_e_si+(secg0sq*d_g0_dV_e_si+d_secg0sq_dV_e_si*g0)*(r1+((2.0*r2)*T0))))+(tang0*(2.0*r2)*d_T0_dV_e_si+d_tang0_dV_e_si*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));

d_e2_dV_di_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_di_si+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0)*secg0sq)+d_T0_dV_di_si*r1)+(2.0*r2)*(d_T1_dV_di_si+2.0*d_T0_dV_di_si))+d_secg0sq_dV_di_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_di_si*r2+(inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_si+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0)*secg0sq)+d_T0_dV_g_si*r1)+(2.0*r2)*(d_T1_dV_g_si+2.0*d_T0_dV_g_si))+d_secg0sq_dV_g_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_si*r2+(inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_g_e = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_g_e+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0)*secg0sq)+d_T0_dV_g_e*r1)+(2.0*r2)*(d_T1_dV_g_e+2.0*d_T0_dV_g_e))+d_secg0sq_dV_g_e*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_g_e*r2+(inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_di = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_di+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0)*secg0sq)+d_T0_dV_e_di*r1)+(2.0*r2)*(d_T1_dV_e_di+2.0*d_T0_dV_e_di))+d_secg0sq_dV_e_di*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_di*r2+(inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e2_dV_e_si = ((secg0sq*2.0*(((((r2*g0)*g0)*d_secg0sq_dV_e_si+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0)*secg0sq)+d_T0_dV_e_si*r1)+(2.0*r2)*(d_T1_dV_e_si+2.0*d_T0_dV_e_si))+d_secg0sq_dV_e_si*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*2.0*d_T1_dV_e_si*r2+(inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));

d_e3_dV_di_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_di_si+((2.0*inv_g0)*d_inv_g0_dV_di_si+2.0*d_inv_g0_dV_di_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_di_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_di_si+((2.0*g0)*d_secg0sq_dV_di_si+2.0*d_g0_dV_di_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_di_si+(2.0*r2)*(3.0*2.0*d_T0_dV_di_si+2.0*d_T1_dV_di_si))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_si+((2.0*inv_g0)*d_inv_g0_dV_g_si+2.0*d_inv_g0_dV_g_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_si+((2.0*g0)*d_secg0sq_dV_g_si+2.0*d_g0_dV_g_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_si+(2.0*r2)*(3.0*2.0*d_T0_dV_g_si+2.0*d_T1_dV_g_si))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_g_e = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_g_e+((2.0*inv_g0)*d_inv_g0_dV_g_e+2.0*d_inv_g0_dV_g_e*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_g_e+(((2.0*g0)*secg0sq)*d_secg0sq_dV_g_e+((2.0*g0)*d_secg0sq_dV_g_e+2.0*d_g0_dV_g_e*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_g_e+(2.0*r2)*(3.0*2.0*d_T0_dV_g_e+2.0*d_T1_dV_g_e))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_di = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_di+((2.0*inv_g0)*d_inv_g0_dV_e_di+2.0*d_inv_g0_dV_e_di*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_di+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_di+((2.0*g0)*d_secg0sq_dV_e_di+2.0*d_g0_dV_e_di*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_di+(2.0*r2)*(3.0*2.0*d_T0_dV_e_di+2.0*d_T1_dV_e_di))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_e3_dV_e_si = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dV_e_si+((2.0*inv_g0)*d_inv_g0_dV_e_si+2.0*d_inv_g0_dV_e_si*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(2.0*r2)*4.0*d_T0_dV_e_si+(((2.0*g0)*secg0sq)*d_secg0sq_dV_e_si+((2.0*g0)*d_secg0sq_dV_e_si+2.0*d_g0_dV_e_si*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((2.0*r1)*d_T0_dV_e_si+(2.0*r2)*(3.0*2.0*d_T0_dV_e_si+2.0*d_T1_dV_e_si))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_g0d_dV_di_si = d_g0_dV_di_si;
d_g0d_dV_g_si = d_g0_dV_g_si;
d_g0d_dV_g_e = d_g0_dV_g_e;
d_g0d_dV_e_di = d_g0_dV_e_di;
d_g0d_dV_e_si = d_g0_dV_e_si;
g0d = g0;
{
double value_tan_0 = tan(g0d);
double  deriv_tan_0_d0 = (1.0/cos(g0d)/cos(g0d));

d_tang0d_dV_di_si = (deriv_tan_0_d0*(d_g0d_dV_di_si));
d_tang0d_dV_g_si = (deriv_tan_0_d0*(d_g0d_dV_g_si));
d_tang0d_dV_g_e = (deriv_tan_0_d0*(d_g0d_dV_g_e));
d_tang0d_dV_e_di = (deriv_tan_0_d0*(d_g0d_dV_e_di));
d_tang0d_dV_e_si = (deriv_tan_0_d0*(d_g0d_dV_e_si));
tang0d = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0d);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(tang0d*tang0d)));

d_phid_dV_g_si = (d_vch_dV_g_si+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0d,d_g0d_dV_g_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0d*tang0d)),(tang0d*d_tang0d_dV_g_si+d_tang0d_dV_g_si*tang0d))));
d_phid_dV_g_e = (d_vch_dV_g_e+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0d,d_g0d_dV_g_e)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0d*tang0d)),(tang0d*d_tang0d_dV_g_e+d_tang0d_dV_g_e*tang0d))));
d_phid_dV_e_di = (d_vch_dV_e_di+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0d,d_g0d_dV_e_di)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0d*tang0d)),(tang0d*d_tang0d_dV_e_di+d_tang0d_dV_e_di*tang0d))));
d_phid_dV_e_si = (d_vch_dV_e_si+(2.0*nVtm)*(evaluator_lln_0.getDerivs(g0d,d_g0d_dV_e_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0d*tang0d)),(tang0d*d_tang0d_dV_e_si+d_tang0d_dV_e_si*tang0d))));
d_phid_dV_di_si = (d_vch_dV_di_si+((2.0*nVtm)*((evaluator_lln_0.getDerivs(g0d,d_g0d_dV_di_si)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0d*tang0d)),(tang0d*d_tang0d_dV_di_si+d_tang0d_dV_di_si*tang0d)))+d_F1_dV_di_si)+2.0*d_nVtm_dV_di_si*((evaluator_lln_0.getValues(g0d)+(0.5*evaluator_lln_1.getValues((1.0+(tang0d*tang0d)))))+F1)));
phid = (vch+((2.0*nVtm)*((evaluator_lln_0.getValues(g0d)+(0.5*evaluator_lln_1.getValues((1.0+(tang0d*tang0d)))))+F1)));
}
}
else
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di =  0.0;
d_F0_dV_g_e = ((-d_vch_dV_g_e)/T14);
d_F0_dV_e_di = ((-d_vch_dV_e_di)/T14);
d_F0_dV_e_si = ((-d_vch_dV_e_si)/T14);
d_F0_dV_di_si = (((T14*(d_vgsfbeff_dV_di_si-d_vch_dV_di_si)-((vgsfbeff-phibulk)-vch)*d_T14_dV_di_si)/T14/T14)-d_F1_dV_di_si);
d_F0_dV_g_si = ((d_vgsfbeff_dV_g_si-d_vch_dV_g_si)/T14);
F0 = ((((vgsfbeff-phibulk)-vch)/T14)-F1);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = phibulk*d_aab_dV_di_si;
T0 = (phibulk*aab);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si =  0.0;
d_T1_dV_di_si = (-phibulk*d_T14_dV_di_si/T14/T14);
T1 = (phibulk/T14);

d_z1_dV_di_si = (((2.0*r1)-1.0)*d_T1_dV_di_si+r2*d_T0_dV_di_si);
d_z1_dV_g_si = (((2.0*r1)-1.0)*d_T1_dV_g_si+r2*d_T0_dV_g_si);
d_z1_dV_g_e = (((2.0*r1)-1.0)*d_T1_dV_g_e+r2*d_T0_dV_g_e);
d_z1_dV_e_di = (((2.0*r1)-1.0)*d_T1_dV_e_di+r2*d_T0_dV_e_di);
d_z1_dV_e_si = (((2.0*r1)-1.0)*d_T1_dV_e_si+r2*d_T0_dV_e_si);
z1 = ((((2.0*r1)-1.0)*T1)+(r2*T0));

d_guessA_dV_di_si = (2.0*r1)*d_T1_dV_di_si;
d_guessA_dV_g_si = (2.0*r1)*d_T1_dV_g_si;
d_guessA_dV_g_e = (2.0*r1)*d_T1_dV_g_e;
d_guessA_dV_e_di = (2.0*r1)*d_T1_dV_e_di;
d_guessA_dV_e_si = (2.0*r1)*d_T1_dV_e_si;
guessA = ((2.0*r1)*T1);
{
double value_exp_0 = exp((-guessA));
double  deriv_exp_0_d0 = value_exp_0;

d_guessA_dV_di_si = (((1.0-value_exp_0)*d_guessA_dV_di_si-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_di_si)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_g_si = (((1.0-value_exp_0)*d_guessA_dV_g_si-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_g_si)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_g_e = (((1.0-value_exp_0)*d_guessA_dV_g_e-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_g_e)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_e_di = (((1.0-value_exp_0)*d_guessA_dV_e_di-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_e_di)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
d_guessA_dV_e_si = (((1.0-value_exp_0)*d_guessA_dV_e_si-guessA*(-(deriv_exp_0_d0*((-d_guessA_dV_e_si)))))/(1.0-value_exp_0)/(1.0-value_exp_0));
guessA = (guessA/(1.0-value_exp_0));
}
{
double value_sqrt_0 = sqrt(guessA);
double value_log_1 = log((value_sqrt_0/r1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(value_sqrt_0/r1));

d_z2_dV_di_si = (d_z1_dV_di_si+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_di_si))/r1))));
d_z2_dV_g_si = (d_z1_dV_g_si+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_g_si))/r1))));
d_z2_dV_g_e = (d_z1_dV_g_e+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_g_e))/r1))));
d_z2_dV_e_di = (d_z1_dV_e_di+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_e_di))/r1))));
d_z2_dV_e_si = (d_z1_dV_e_si+(deriv_log_1_d0*(((deriv_sqrt_0_d0*(d_guessA_dV_e_si))/r1))));
z2 = (z1+value_log_1);
}
if (((F0-z2)>((-0.3)/T14)))
{
if (((F0-z2)<20))
{
{
double value_exp_0 = exp((2.0*(F0-z2)));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_di_si-d_z2_dV_di_si)))))+(-0.5*d_guessA_dV_di_si/guessA/guessA)*value_log_1);
d_T2_dV_g_si = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_g_si-d_z2_dV_g_si)))))+(-0.5*d_guessA_dV_g_si/guessA/guessA)*value_log_1);
d_T2_dV_g_e = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_g_e-d_z2_dV_g_e)))))+(-0.5*d_guessA_dV_g_e/guessA/guessA)*value_log_1);
d_T2_dV_e_di = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_e_di-d_z2_dV_e_di)))))+(-0.5*d_guessA_dV_e_di/guessA/guessA)*value_log_1);
d_T2_dV_e_si = ((0.5/guessA)*(deriv_log_1_d0*((deriv_exp_0_d0*(2.0*(d_F0_dV_e_si-d_z2_dV_e_si)))))+(-0.5*d_guessA_dV_e_si/guessA/guessA)*value_log_1);
T2 = (((0.5/guessA)*value_log_1)+1.0);
}
}
else
{

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = ((0.5/guessA)*2.0*(d_F0_dV_di_si-d_z2_dV_di_si)+(-0.5*d_guessA_dV_di_si/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_g_si = ((0.5/guessA)*2.0*(d_F0_dV_g_si-d_z2_dV_g_si)+(-0.5*d_guessA_dV_g_si/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_g_e = ((0.5/guessA)*2.0*(d_F0_dV_g_e-d_z2_dV_g_e)+(-0.5*d_guessA_dV_g_e/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_e_di = ((0.5/guessA)*2.0*(d_F0_dV_e_di-d_z2_dV_e_di)+(-0.5*d_guessA_dV_e_di/guessA/guessA)*(2.0*(F0-z2)));
d_T2_dV_e_si = ((0.5/guessA)*2.0*(d_F0_dV_e_si-d_z2_dV_e_si)+(-0.5*d_guessA_dV_e_si/guessA/guessA)*(2.0*(F0-z2)));
T2 = (((0.5/guessA)*(2.0*(F0-z2)))+1.0);
}
{
double value_pow_0 = pow(T2,2.0);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*2.0/T2));

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (deriv_pow_0_d0*(d_T2_dV_di_si));
d_T3_dV_e_di = (deriv_pow_0_d0*(d_T2_dV_e_di));
d_T3_dV_e_si = (deriv_pow_0_d0*(d_T2_dV_e_si));
d_T3_dV_g_si = (deriv_pow_0_d0*(d_T2_dV_g_si));
d_T3_dV_g_e = (deriv_pow_0_d0*(d_T2_dV_g_e));
T3 = value_pow_0;
}
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_exp_1 = exp((-T1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_exp_1_d0 = value_exp_1;

d_guessB_dV_di_si = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_di_si)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_di_si))+(d_guessA_dV_di_si/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_g_si = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_g_si)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_si))+(d_guessA_dV_g_si/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_g_e = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_g_e)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_e))+(d_guessA_dV_g_e/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_e_di = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_e_di)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_di))+(d_guessA_dV_e_di/r1)*value_sqrt_0)*value_exp_1);
d_guessB_dV_e_si = (((guessA/r1)*value_sqrt_0)*(deriv_exp_1_d0*((-d_T1_dV_e_si)))+((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_si))+(d_guessA_dV_e_si/r1)*value_sqrt_0)*value_exp_1);
guessB = (((guessA/r1)*value_sqrt_0)*value_exp_1);
}
}
else
{
{
double value_exp_0 = exp(((F0-z1)-T1));
double  deriv_exp_0_d0 = value_exp_0;

d_guessB_dV_di_si = (deriv_exp_0_d0*(((d_F0_dV_di_si-d_z1_dV_di_si)-d_T1_dV_di_si)));
d_guessB_dV_g_si = (deriv_exp_0_d0*(((d_F0_dV_g_si-d_z1_dV_g_si)-d_T1_dV_g_si)));
d_guessB_dV_g_e = (deriv_exp_0_d0*(((d_F0_dV_g_e-d_z1_dV_g_e)-d_T1_dV_g_e)));
d_guessB_dV_e_di = (deriv_exp_0_d0*(((d_F0_dV_e_di-d_z1_dV_e_di)-d_T1_dV_e_di)));
d_guessB_dV_e_si = (deriv_exp_0_d0*(((d_F0_dV_e_si-d_z1_dV_e_si)-d_T1_dV_e_si)));
guessB = value_exp_0;
}
}

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = d_guessB_dV_di_si;
d_g0_dV_g_si = d_guessB_dV_g_si;
d_g0_dV_g_e = d_guessB_dV_g_e;
d_g0_dV_e_di = d_guessB_dV_e_di;
d_g0_dV_e_si = d_guessB_dV_e_si;
g0 = guessB;
if ((g0>1e-60))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (-(-d_g0_dV_di_si/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_g_si = (-(-d_g0_dV_g_si/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_g_e = (-(-d_g0_dV_g_e/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_e_di = (-(-d_g0_dV_e_di/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
d_g0_dV_e_si = (-(-d_g0_dV_e_si/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
g0 = (1.0/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));

d_cosg0_dV_di_si = (deriv_cos_0_d0*(d_g0_dV_di_si));
d_cosg0_dV_g_si = (deriv_cos_0_d0*(d_g0_dV_g_si));
d_cosg0_dV_g_e = (deriv_cos_0_d0*(d_g0_dV_g_e));
d_cosg0_dV_e_di = (deriv_cos_0_d0*(d_g0_dV_e_di));
d_cosg0_dV_e_si = (deriv_cos_0_d0*(d_g0_dV_e_si));
cosg0 = value_cos_0;
}

d_secg0_dV_di_si = (-d_cosg0_dV_di_si/cosg0/cosg0);
d_secg0_dV_g_si = (-d_cosg0_dV_g_si/cosg0/cosg0);
d_secg0_dV_g_e = (-d_cosg0_dV_g_e/cosg0/cosg0);
d_secg0_dV_e_di = (-d_cosg0_dV_e_di/cosg0/cosg0);
d_secg0_dV_e_si = (-d_cosg0_dV_e_si/cosg0/cosg0);
secg0 = (1.0/cosg0);

d_secg0sq_dV_di_si = (secg0*d_secg0_dV_di_si+d_secg0_dV_di_si*secg0);
d_secg0sq_dV_g_si = (secg0*d_secg0_dV_g_si+d_secg0_dV_g_si*secg0);
d_secg0sq_dV_g_e = (secg0*d_secg0_dV_g_e+d_secg0_dV_g_e*secg0);
d_secg0sq_dV_e_di = (secg0*d_secg0_dV_e_di+d_secg0_dV_e_di*secg0);
d_secg0sq_dV_e_si = (secg0*d_secg0_dV_e_si+d_secg0_dV_e_si*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (((g0*g0)*(T13*d_secg0sq_dV_di_si+d_T13_dV_di_si*secg0sq)+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*((T13*secg0sq)-1.0))+(aab*(-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si)+d_T14_dV_di_si*evaluator_lln_0.getValues(cosg0)))+d_aab_dV_di_si*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
d_T1_dV_g_si = (((g0*g0)*T13*d_secg0sq_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si)));
d_T1_dV_g_e = (((g0*g0)*T13*d_secg0sq_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e)));
d_T1_dV_e_di = (((g0*g0)*T13*d_secg0sq_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di)));
d_T1_dV_e_si = (((g0*g0)*T13*d_secg0sq_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si)));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (deriv_sqrt_0_d0*(d_T1_dV_di_si));
d_T2_dV_g_si = (deriv_sqrt_0_d0*(d_T1_dV_g_si));
d_T2_dV_g_e = (deriv_sqrt_0_d0*(d_T1_dV_g_e));
d_T2_dV_e_di = (deriv_sqrt_0_d0*(d_T1_dV_e_di));
d_T2_dV_e_si = (deriv_sqrt_0_d0*(d_T1_dV_e_si));
T2 = value_sqrt_0;
}

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (((-2.0)*d_g0_dV_di_si+((aab*T14)*d_tang0_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_di_si+(((2.0*T13)*g0)*d_secg0sq_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*secg0sq)*T0));
d_T3_dV_g_si = (((-2.0)*d_g0_dV_g_si+(aab*T14)*d_tang0_dV_g_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_si+(((2.0*T13)*g0)*d_secg0sq_dV_g_si+(2.0*T13)*d_g0_dV_g_si*secg0sq)*T0));
d_T3_dV_g_e = (((-2.0)*d_g0_dV_g_e+(aab*T14)*d_tang0_dV_g_e)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_e+(((2.0*T13)*g0)*d_secg0sq_dV_g_e+(2.0*T13)*d_g0_dV_g_e*secg0sq)*T0));
d_T3_dV_e_di = (((-2.0)*d_g0_dV_e_di+(aab*T14)*d_tang0_dV_e_di)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_di+(((2.0*T13)*g0)*d_secg0sq_dV_e_di+(2.0*T13)*d_g0_dV_e_di*secg0sq)*T0));
d_T3_dV_e_si = (((-2.0)*d_g0_dV_e_si+(aab*T14)*d_tang0_dV_e_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_si+(((2.0*T13)*g0)*d_secg0sq_dV_e_si+(2.0*T13)*d_g0_dV_e_si*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_si+(((2.0*T13)*g0)*d_g0_dV_g_si+(2.0*T13)*d_g0_dV_g_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_si+(8.0*T13)*d_g0_dV_g_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_si+(((4.0*T13)*g0)*d_g0_dV_g_si+(4.0*T13)*d_g0_dV_g_si*g0)*tang0)*tang0))+d_secg0sq_dV_g_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_g_e = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_e+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_e+(((2.0*T13)*g0)*d_g0_dV_g_e+(2.0*T13)*d_g0_dV_g_e*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_e+(8.0*T13)*d_g0_dV_g_e*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_e+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_e+(((4.0*T13)*g0)*d_g0_dV_g_e+(4.0*T13)*d_g0_dV_g_e*g0)*tang0)*tang0))+d_secg0sq_dV_g_e*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_di = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_di+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_di+(((2.0*T13)*g0)*d_g0_dV_e_di+(2.0*T13)*d_g0_dV_e_di*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_di+(8.0*T13)*d_g0_dV_e_di*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_di+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_di+(((4.0*T13)*g0)*d_g0_dV_e_di+(4.0*T13)*d_g0_dV_e_di*g0)*tang0)*tang0))+d_secg0sq_dV_e_di*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_si+(((2.0*T13)*g0)*d_g0_dV_e_si+(2.0*T13)*d_g0_dV_e_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_si+(8.0*T13)*d_g0_dV_e_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_si+(((4.0*T13)*g0)*d_g0_dV_e_si+(4.0*T13)*d_g0_dV_e_si*g0)*tang0)*tang0))+d_secg0sq_dV_e_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_di_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_di_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_di_si+(((2.0*T13)*g0)*d_g0_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14))+(((8.0*T13)*g0)*d_tang0_dV_di_si+((8.0*T13)*d_g0_dV_di_si+8.0*d_T13_dV_di_si*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_di_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_di_si+(((4.0*T13)*g0)*d_g0_dV_di_si+((4.0*T13)*d_g0_dV_di_si+4.0*d_T13_dV_di_si*g0)*g0)*tang0)*tang0))+d_secg0sq_dV_di_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (((2.0*tang0)*d_T4_dV_di_si+2.0*d_tang0_dV_di_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_di_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_di_si+(((3.0*T13)*g0)*d_secg0sq_dV_di_si+((3.0*T13)*d_g0_dV_di_si+3.0*d_T13_dV_di_si*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dV_di_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_di_si+(((2.0*T13)*secg0sq)*d_T0_dV_di_si+((2.0*T13)*d_secg0sq_dV_di_si+2.0*d_T13_dV_di_si*secg0sq)*T0)*tang0)));
d_T5_dV_g_si = (((2.0*tang0)*d_T4_dV_g_si+2.0*d_tang0_dV_g_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_si+(((3.0*T13)*g0)*d_secg0sq_dV_g_si+(3.0*T13)*d_g0_dV_g_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_si+(((2.0*T13)*secg0sq)*d_T0_dV_g_si+(2.0*T13)*d_secg0sq_dV_g_si*T0)*tang0)));
d_T5_dV_g_e = (((2.0*tang0)*d_T4_dV_g_e+2.0*d_tang0_dV_g_e*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_e+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_e+(((3.0*T13)*g0)*d_secg0sq_dV_g_e+(3.0*T13)*d_g0_dV_g_e*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_e)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_e+(((2.0*T13)*secg0sq)*d_T0_dV_g_e+(2.0*T13)*d_secg0sq_dV_g_e*T0)*tang0)));
d_T5_dV_e_di = (((2.0*tang0)*d_T4_dV_e_di+2.0*d_tang0_dV_e_di*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_di+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_di+(((3.0*T13)*g0)*d_secg0sq_dV_e_di+(3.0*T13)*d_g0_dV_e_di*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_di)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_di+(((2.0*T13)*secg0sq)*d_T0_dV_e_di+(2.0*T13)*d_secg0sq_dV_e_di*T0)*tang0)));
d_T5_dV_e_si = (((2.0*tang0)*d_T4_dV_e_si+2.0*d_tang0_dV_e_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_si+(((3.0*T13)*g0)*d_secg0sq_dV_e_si+(3.0*T13)*d_g0_dV_e_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_si+(((2.0*T13)*secg0sq)*d_T0_dV_e_si+(2.0*T13)*d_secg0sq_dV_e_si*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T7_dV_di_si = ((((d_lng0_dV_di_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si))+r2*d_T1_dV_di_si)+r1*d_T2_dV_di_si)-d_F0_dV_di_si);
d_T7_dV_g_si = ((((d_lng0_dV_g_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si))+r2*d_T1_dV_g_si)+r1*d_T2_dV_g_si)-d_F0_dV_g_si);
d_T7_dV_g_e = ((((d_lng0_dV_g_e-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e))+r2*d_T1_dV_g_e)+r1*d_T2_dV_g_e)-d_F0_dV_g_e);
d_T7_dV_e_di = ((((d_lng0_dV_e_di-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di))+r2*d_T1_dV_e_di)+r1*d_T2_dV_e_di)-d_F0_dV_e_di);
d_T7_dV_e_si = ((((d_lng0_dV_e_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si))+r2*d_T1_dV_e_si)+r1*d_T2_dV_e_si)-d_F0_dV_e_si);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}

d_T8_dV_di_si = ((((-d_g0_dV_di_si/g0/g0)+d_tang0_dV_di_si)+r2*d_T3_dV_di_si)+(((2.0*T2)*r1*d_T3_dV_di_si-(r1*T3)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_si = ((((-d_g0_dV_g_si/g0/g0)+d_tang0_dV_g_si)+r2*d_T3_dV_g_si)+(((2.0*T2)*r1*d_T3_dV_g_si-(r1*T3)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_e = ((((-d_g0_dV_g_e/g0/g0)+d_tang0_dV_g_e)+r2*d_T3_dV_g_e)+(((2.0*T2)*r1*d_T3_dV_g_e-(r1*T3)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_di = ((((-d_g0_dV_e_di/g0/g0)+d_tang0_dV_e_di)+r2*d_T3_dV_e_di)+(((2.0*T2)*r1*d_T3_dV_e_di-(r1*T3)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_si = ((((-d_g0_dV_e_si/g0/g0)+d_tang0_dV_e_si)+r2*d_T3_dV_e_si)+(((2.0*T2)*r1*d_T3_dV_e_si-(r1*T3)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));

d_T9_dV_di_si = (((((-(-1.0)*(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_di_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_di_si+r1*d_T3_dV_di_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_di_si+((4*T2)*d_T2_dV_di_si+4*d_T2_dV_di_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_di_si-(r1*T4)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_di_si);
d_T9_dV_g_si = (((((-(-1.0)*(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_si+r1*d_T3_dV_g_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_si+((4*T2)*d_T2_dV_g_si+4*d_T2_dV_g_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_si-(r1*T4)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_si);
d_T9_dV_g_e = (((((-(-1.0)*(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_e)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_e+r1*d_T3_dV_g_e*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_e+((4*T2)*d_T2_dV_g_e+4*d_T2_dV_g_e*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_e-(r1*T4)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_e);
d_T9_dV_e_di = (((((-(-1.0)*(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_di)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_di+r1*d_T3_dV_e_di*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_di+((4*T2)*d_T2_dV_e_di+4*d_T2_dV_e_di*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_di-(r1*T4)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_di);
d_T9_dV_e_si = (((((-(-1.0)*(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_si+r1*d_T3_dV_e_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_si+((4*T2)*d_T2_dV_e_si+4*d_T2_dV_e_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_si-(r1*T4)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_si);
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));

d_TA_dV_di_si = (((((-2.0*((g0*g0)*d_g0_dV_di_si+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_di_si+d_T3_dV_di_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_di_si+2.0*d_T2_dV_di_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_di_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_di_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_di_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_di_si-(r1*T5)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_di_si);
d_TA_dV_g_si = (((((-2.0*((g0*g0)*d_g0_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_si+d_T3_dV_g_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_si+2.0*d_T2_dV_g_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_si-(r1*T5)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_si);
d_TA_dV_g_e = (((((-2.0*((g0*g0)*d_g0_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_e+d_T3_dV_g_e*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_e+2.0*d_T2_dV_g_e*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_e)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_e-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_e)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_e-(r1*T5)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_e);
d_TA_dV_e_di = (((((-2.0*((g0*g0)*d_g0_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_di+d_T3_dV_e_di*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_di+2.0*d_T2_dV_e_di*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_di)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_di-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_di)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_di-(r1*T5)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_di);
d_TA_dV_e_si = (((((-2.0*((g0*g0)*d_g0_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_si+d_T3_dV_e_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_si+2.0*d_T2_dV_e_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_si-(r1*T5)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_si);
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_di_si+d_T7_dV_di_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_di_si+2.0*d_T8_dV_di_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_di_si+3.0*d_T9_dV_di_si*T9)-(T8*d_TA_dV_di_si+d_T8_dV_di_si*TA))+(T7*d_T7_dV_di_si+d_T7_dV_di_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_di_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_di_si-T7*d_T8_dV_di_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_si+d_T7_dV_g_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_si+2.0*d_T8_dV_g_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_si+3.0*d_T9_dV_g_si*T9)-(T8*d_TA_dV_g_si+d_T8_dV_g_si*TA))+(T7*d_T7_dV_g_si+d_T7_dV_g_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_si-T7*d_T8_dV_g_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_e+d_T7_dV_g_e*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_e+2.0*d_T8_dV_g_e*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_e+3.0*d_T9_dV_g_e*T9)-(T8*d_TA_dV_g_e+d_T8_dV_g_e*TA))+(T7*d_T7_dV_g_e+d_T7_dV_g_e*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_e)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_e-T7*d_T8_dV_g_e)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_di+d_T7_dV_e_di*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_di+2.0*d_T8_dV_e_di*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_di+3.0*d_T9_dV_e_di*T9)-(T8*d_TA_dV_e_di+d_T8_dV_e_di*TA))+(T7*d_T7_dV_e_di+d_T7_dV_e_di*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_di)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_di-T7*d_T8_dV_e_di)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_si+d_T7_dV_e_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_si+2.0*d_T8_dV_e_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_si+3.0*d_T9_dV_e_si*T9)-(T8*d_TA_dV_e_si+d_T8_dV_e_si*TA))+(T7*d_T7_dV_e_si+d_T7_dV_e_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_si-T7*d_T8_dV_e_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));

d_tang0_dV_di_si = (deriv_tan_0_d0*(d_g0_dV_di_si));
d_tang0_dV_g_si = (deriv_tan_0_d0*(d_g0_dV_g_si));
d_tang0_dV_g_e = (deriv_tan_0_d0*(d_g0_dV_g_e));
d_tang0_dV_e_di = (deriv_tan_0_d0*(d_g0_dV_e_di));
d_tang0_dV_e_si = (deriv_tan_0_d0*(d_g0_dV_e_si));
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));

d_cosg0_dV_di_si = (deriv_cos_0_d0*(d_g0_dV_di_si));
d_cosg0_dV_g_si = (deriv_cos_0_d0*(d_g0_dV_g_si));
d_cosg0_dV_g_e = (deriv_cos_0_d0*(d_g0_dV_g_e));
d_cosg0_dV_e_di = (deriv_cos_0_d0*(d_g0_dV_e_di));
d_cosg0_dV_e_si = (deriv_cos_0_d0*(d_g0_dV_e_si));
cosg0 = value_cos_0;
}

d_secg0_dV_di_si = (-d_cosg0_dV_di_si/cosg0/cosg0);
d_secg0_dV_g_si = (-d_cosg0_dV_g_si/cosg0/cosg0);
d_secg0_dV_g_e = (-d_cosg0_dV_g_e/cosg0/cosg0);
d_secg0_dV_e_di = (-d_cosg0_dV_e_di/cosg0/cosg0);
d_secg0_dV_e_si = (-d_cosg0_dV_e_si/cosg0/cosg0);
secg0 = (1.0/cosg0);

d_secg0sq_dV_di_si = (secg0*d_secg0_dV_di_si+d_secg0_dV_di_si*secg0);
d_secg0sq_dV_g_si = (secg0*d_secg0_dV_g_si+d_secg0_dV_g_si*secg0);
d_secg0sq_dV_g_e = (secg0*d_secg0_dV_g_e+d_secg0_dV_g_e*secg0);
d_secg0sq_dV_e_di = (secg0*d_secg0_dV_e_di+d_secg0_dV_e_di*secg0);
d_secg0sq_dV_e_si = (secg0*d_secg0_dV_e_si+d_secg0_dV_e_si*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (g0*d_tang0_dV_di_si+d_g0_dV_di_si*tang0);
d_T0_dV_g_si = (g0*d_tang0_dV_g_si+d_g0_dV_g_si*tang0);
d_T0_dV_g_e = (g0*d_tang0_dV_g_e+d_g0_dV_g_e*tang0);
d_T0_dV_e_di = (g0*d_tang0_dV_e_di+d_g0_dV_e_di*tang0);
d_T0_dV_e_si = (g0*d_tang0_dV_e_si+d_g0_dV_e_si*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (((g0*g0)*(T13*d_secg0sq_dV_di_si+d_T13_dV_di_si*secg0sq)+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*((T13*secg0sq)-1.0))+(aab*(-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si)+d_T14_dV_di_si*evaluator_lln_0.getValues(cosg0)))+d_aab_dV_di_si*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
d_T1_dV_g_si = (((g0*g0)*T13*d_secg0sq_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si)));
d_T1_dV_g_e = (((g0*g0)*T13*d_secg0sq_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e)));
d_T1_dV_e_di = (((g0*g0)*T13*d_secg0sq_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di)));
d_T1_dV_e_si = (((g0*g0)*T13*d_secg0sq_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*((T13*secg0sq)-1.0))+aab*(-T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si)));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (deriv_sqrt_0_d0*(d_T1_dV_di_si));
d_T2_dV_g_si = (deriv_sqrt_0_d0*(d_T1_dV_g_si));
d_T2_dV_g_e = (deriv_sqrt_0_d0*(d_T1_dV_g_e));
d_T2_dV_e_di = (deriv_sqrt_0_d0*(d_T1_dV_e_di));
d_T2_dV_e_si = (deriv_sqrt_0_d0*(d_T1_dV_e_si));
T2 = value_sqrt_0;
}

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (((-2.0)*d_g0_dV_di_si+((aab*T14)*d_tang0_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_di_si+(((2.0*T13)*g0)*d_secg0sq_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*secg0sq)*T0));
d_T3_dV_g_si = (((-2.0)*d_g0_dV_g_si+(aab*T14)*d_tang0_dV_g_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_si+(((2.0*T13)*g0)*d_secg0sq_dV_g_si+(2.0*T13)*d_g0_dV_g_si*secg0sq)*T0));
d_T3_dV_g_e = (((-2.0)*d_g0_dV_g_e+(aab*T14)*d_tang0_dV_g_e)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_g_e+(((2.0*T13)*g0)*d_secg0sq_dV_g_e+(2.0*T13)*d_g0_dV_g_e*secg0sq)*T0));
d_T3_dV_e_di = (((-2.0)*d_g0_dV_e_di+(aab*T14)*d_tang0_dV_e_di)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_di+(((2.0*T13)*g0)*d_secg0sq_dV_e_di+(2.0*T13)*d_g0_dV_e_di*secg0sq)*T0));
d_T3_dV_e_si = (((-2.0)*d_g0_dV_e_si+(aab*T14)*d_tang0_dV_e_si)+((((2.0*T13)*g0)*secg0sq)*d_T0_dV_e_si+(((2.0*T13)*g0)*d_secg0sq_dV_e_si+(2.0*T13)*d_g0_dV_e_si*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_si+(((2.0*T13)*g0)*d_g0_dV_g_si+(2.0*T13)*d_g0_dV_g_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_si+(8.0*T13)*d_g0_dV_g_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_si+(((4.0*T13)*g0)*d_g0_dV_g_si+(4.0*T13)*d_g0_dV_g_si*g0)*tang0)*tang0))+d_secg0sq_dV_g_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_g_e = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_g_e+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_g_e+(((2.0*T13)*g0)*d_g0_dV_g_e+(2.0*T13)*d_g0_dV_g_e*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_g_e+(8.0*T13)*d_g0_dV_g_e*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_g_e+((((4.0*T13)*g0)*g0)*d_tang0_dV_g_e+(((4.0*T13)*g0)*d_g0_dV_g_e+(4.0*T13)*d_g0_dV_g_e*g0)*tang0)*tang0))+d_secg0sq_dV_g_e*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_di = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_di+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_di+(((2.0*T13)*g0)*d_g0_dV_e_di+(2.0*T13)*d_g0_dV_e_di*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_di+(8.0*T13)*d_g0_dV_e_di*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_di+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_di+(((4.0*T13)*g0)*d_g0_dV_e_di+(4.0*T13)*d_g0_dV_e_di*g0)*tang0)*tang0))+d_secg0sq_dV_e_di*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_e_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_e_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_e_si+(((2.0*T13)*g0)*d_g0_dV_e_si+(2.0*T13)*d_g0_dV_e_si*g0)*secg0sq)*secg0sq)+(secg0sq*((((8.0*T13)*g0)*d_tang0_dV_e_si+(8.0*T13)*d_g0_dV_e_si*tang0)+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_e_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_e_si+(((4.0*T13)*g0)*d_g0_dV_e_si+(4.0*T13)*d_g0_dV_e_si*g0)*tang0)*tang0))+d_secg0sq_dV_e_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T4_dV_di_si = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dV_di_si+((((2.0*T13)*g0)*g0)*d_secg0sq_dV_di_si+(((2.0*T13)*g0)*d_g0_dV_di_si+((2.0*T13)*d_g0_dV_di_si+2.0*d_T13_dV_di_si*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dV_di_si+(aab*d_T14_dV_di_si+d_aab_dV_di_si*T14))+(((8.0*T13)*g0)*d_tang0_dV_di_si+((8.0*T13)*d_g0_dV_di_si+8.0*d_T13_dV_di_si*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dV_di_si+((((4.0*T13)*g0)*g0)*d_tang0_dV_di_si+(((4.0*T13)*g0)*d_g0_dV_di_si+((4.0*T13)*d_g0_dV_di_si+4.0*d_T13_dV_di_si*g0)*g0)*tang0)*tang0))+d_secg0sq_dV_di_si*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (((2.0*tang0)*d_T4_dV_di_si+2.0*d_tang0_dV_di_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_di_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_di_si+(((3.0*T13)*g0)*d_secg0sq_dV_di_si+((3.0*T13)*d_g0_dV_di_si+3.0*d_T13_dV_di_si*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dV_di_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_di_si+(((2.0*T13)*secg0sq)*d_T0_dV_di_si+((2.0*T13)*d_secg0sq_dV_di_si+2.0*d_T13_dV_di_si*secg0sq)*T0)*tang0)));
d_T5_dV_g_si = (((2.0*tang0)*d_T4_dV_g_si+2.0*d_tang0_dV_g_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_si+(((3.0*T13)*g0)*d_secg0sq_dV_g_si+(3.0*T13)*d_g0_dV_g_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_si+(((2.0*T13)*secg0sq)*d_T0_dV_g_si+(2.0*T13)*d_secg0sq_dV_g_si*T0)*tang0)));
d_T5_dV_g_e = (((2.0*tang0)*d_T4_dV_g_e+2.0*d_tang0_dV_g_e*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_g_e+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_g_e+(((3.0*T13)*g0)*d_secg0sq_dV_g_e+(3.0*T13)*d_g0_dV_g_e*secg0sq)*secg0sq)*T0)+d_tang0_dV_g_e)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_g_e+(((2.0*T13)*secg0sq)*d_T0_dV_g_e+(2.0*T13)*d_secg0sq_dV_g_e*T0)*tang0)));
d_T5_dV_e_di = (((2.0*tang0)*d_T4_dV_e_di+2.0*d_tang0_dV_e_di*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_di+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_di+(((3.0*T13)*g0)*d_secg0sq_dV_e_di+(3.0*T13)*d_g0_dV_e_di*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_di)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_di+(((2.0*T13)*secg0sq)*d_T0_dV_e_di+(2.0*T13)*d_secg0sq_dV_e_di*T0)*tang0)));
d_T5_dV_e_si = (((2.0*tang0)*d_T4_dV_e_si+2.0*d_tang0_dV_e_si*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dV_e_si+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dV_e_si+(((3.0*T13)*g0)*d_secg0sq_dV_e_si+(3.0*T13)*d_g0_dV_e_si*secg0sq)*secg0sq)*T0)+d_tang0_dV_e_si)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dV_e_si+(((2.0*T13)*secg0sq)*d_T0_dV_e_si+(2.0*T13)*d_secg0sq_dV_e_si*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);

d_T7_dV_di_si = ((((d_lng0_dV_di_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_di_si))+r2*d_T1_dV_di_si)+r1*d_T2_dV_di_si)-d_F0_dV_di_si);
d_T7_dV_g_si = ((((d_lng0_dV_g_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_si))+r2*d_T1_dV_g_si)+r1*d_T2_dV_g_si)-d_F0_dV_g_si);
d_T7_dV_g_e = ((((d_lng0_dV_g_e-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_g_e))+r2*d_T1_dV_g_e)+r1*d_T2_dV_g_e)-d_F0_dV_g_e);
d_T7_dV_e_di = ((((d_lng0_dV_e_di-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_di))+r2*d_T1_dV_e_di)+r1*d_T2_dV_e_di)-d_F0_dV_e_di);
d_T7_dV_e_si = ((((d_lng0_dV_e_si-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dV_e_si))+r2*d_T1_dV_e_si)+r1*d_T2_dV_e_si)-d_F0_dV_e_si);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}

d_T8_dV_di_si = ((((-d_g0_dV_di_si/g0/g0)+d_tang0_dV_di_si)+r2*d_T3_dV_di_si)+(((2.0*T2)*r1*d_T3_dV_di_si-(r1*T3)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_si = ((((-d_g0_dV_g_si/g0/g0)+d_tang0_dV_g_si)+r2*d_T3_dV_g_si)+(((2.0*T2)*r1*d_T3_dV_g_si-(r1*T3)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)));
d_T8_dV_g_e = ((((-d_g0_dV_g_e/g0/g0)+d_tang0_dV_g_e)+r2*d_T3_dV_g_e)+(((2.0*T2)*r1*d_T3_dV_g_e-(r1*T3)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_di = ((((-d_g0_dV_e_di/g0/g0)+d_tang0_dV_e_di)+r2*d_T3_dV_e_di)+(((2.0*T2)*r1*d_T3_dV_e_di-(r1*T3)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)));
d_T8_dV_e_si = ((((-d_g0_dV_e_si/g0/g0)+d_tang0_dV_e_si)+r2*d_T3_dV_e_si)+(((2.0*T2)*r1*d_T3_dV_e_si-(r1*T3)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));

d_T9_dV_di_si = (((((-(-1.0)*(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_di_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_di_si+r1*d_T3_dV_di_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_di_si+((4*T2)*d_T2_dV_di_si+4*d_T2_dV_di_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_di_si-(r1*T4)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_di_si);
d_T9_dV_g_si = (((((-(-1.0)*(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_si+r1*d_T3_dV_g_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_si+((4*T2)*d_T2_dV_g_si+4*d_T2_dV_g_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_si-(r1*T4)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_si);
d_T9_dV_g_e = (((((-(-1.0)*(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_g_e)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_g_e+r1*d_T3_dV_g_e*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_g_e+((4*T2)*d_T2_dV_g_e+4*d_T2_dV_g_e*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_g_e-(r1*T4)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_g_e);
d_T9_dV_e_di = (((((-(-1.0)*(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_di)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_di+r1*d_T3_dV_e_di*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_di+((4*T2)*d_T2_dV_e_di+4*d_T2_dV_e_di*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_di-(r1*T4)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_di);
d_T9_dV_e_si = (((((-(-1.0)*(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dV_e_si)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dV_e_si+r1*d_T3_dV_e_si*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dV_e_si+((4*T2)*d_T2_dV_e_si+4*d_T2_dV_e_si*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*r1*d_T4_dV_e_si-(r1*T4)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T4_dV_e_si);
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));

d_TA_dV_di_si = (((((-2.0*((g0*g0)*d_g0_dV_di_si+(g0*d_g0_dV_di_si+d_g0_dV_di_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_di_si+2.0*d_secg0sq_dV_di_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_di_si+d_T3_dV_di_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_di_si+2.0*d_T2_dV_di_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_di_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_di_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_di_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_di_si-(r1*T5)*2.0*d_T2_dV_di_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_di_si);
d_TA_dV_g_si = (((((-2.0*((g0*g0)*d_g0_dV_g_si+(g0*d_g0_dV_g_si+d_g0_dV_g_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_si+2.0*d_secg0sq_dV_g_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_si+d_T3_dV_g_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_si+2.0*d_T2_dV_g_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_si-(r1*T5)*2.0*d_T2_dV_g_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_si);
d_TA_dV_g_e = (((((-2.0*((g0*g0)*d_g0_dV_g_e+(g0*d_g0_dV_g_e+d_g0_dV_g_e*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_g_e+2.0*d_secg0sq_dV_g_e*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_g_e+d_T3_dV_g_e*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_g_e+2.0*d_T2_dV_g_e*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_g_e)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_g_e-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_g_e)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_g_e-(r1*T5)*2.0*d_T2_dV_g_e)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_g_e);
d_TA_dV_e_di = (((((-2.0*((g0*g0)*d_g0_dV_e_di+(g0*d_g0_dV_e_di+d_g0_dV_e_di*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_di+2.0*d_secg0sq_dV_e_di*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_di+d_T3_dV_e_di*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_di+2.0*d_T2_dV_e_di*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_di)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_di-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_di)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_di-(r1*T5)*2.0*d_T2_dV_e_di)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_di);
d_TA_dV_e_si = (((((-2.0*((g0*g0)*d_g0_dV_e_si+(g0*d_g0_dV_e_si+d_g0_dV_e_si*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dV_e_si+2.0*d_secg0sq_dV_e_si*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dV_e_si+d_T3_dV_e_si*T3)-(T3*T3)*((2.0*T2)*d_T2_dV_e_si+2.0*d_T2_dV_e_si*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dV_e_si)+(((4.0*value_pow_0)*(3.0*r1)*d_T3_dV_e_si-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dV_e_si)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*r1*d_T5_dV_e_si-(r1*T5)*2.0*d_T2_dV_e_si)/(2.0*T2)/(2.0*T2)))+r2*d_T5_dV_e_si);
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_di_si+d_T7_dV_di_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_di_si+2.0*d_T8_dV_di_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_di_si+3.0*d_T9_dV_di_si*T9)-(T8*d_TA_dV_di_si+d_T8_dV_di_si*TA))+(T7*d_T7_dV_di_si+d_T7_dV_di_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_di_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_di_si-T7*d_T8_dV_di_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_si+d_T7_dV_g_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_si+2.0*d_T8_dV_g_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_si+3.0*d_T9_dV_g_si*T9)-(T8*d_TA_dV_g_si+d_T8_dV_g_si*TA))+(T7*d_T7_dV_g_si+d_T7_dV_g_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_si-T7*d_T8_dV_g_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_g_e+d_T7_dV_g_e*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_g_e+2.0*d_T8_dV_g_e*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_g_e+3.0*d_T9_dV_g_e*T9)-(T8*d_TA_dV_g_e+d_T8_dV_g_e*TA))+(T7*d_T7_dV_g_e+d_T7_dV_g_e*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_g_e)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_g_e-T7*d_T8_dV_g_e)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_di+d_T7_dV_e_di*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_di+2.0*d_T8_dV_e_di*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_di+3.0*d_T9_dV_e_di*T9)-(T8*d_TA_dV_e_di+d_T8_dV_e_di*TA))+(T7*d_T7_dV_e_di+d_T7_dV_e_di*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_di)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_di-T7*d_T8_dV_e_di)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dV_e_si+d_T7_dV_e_si*T9)-(T7*T9)*((2.0*T8)*d_T8_dV_e_si+2.0*d_T8_dV_e_si*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dV_e_si+3.0*d_T9_dV_e_si*T9)-(T8*d_TA_dV_e_si+d_T8_dV_e_si*TA))+(T7*d_T7_dV_e_si+d_T7_dV_e_si*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dV_e_si)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dV_e_si-T7*d_T8_dV_e_si)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}
}
else
{
if ((g0>=1e-300))
{
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));

d_lng0_dV_di_si = (-(deriv_log_0_d0*((-d_g0_dV_di_si/g0/g0))));
d_lng0_dV_g_si = (-(deriv_log_0_d0*((-d_g0_dV_g_si/g0/g0))));
d_lng0_dV_g_e = (-(deriv_log_0_d0*((-d_g0_dV_g_e/g0/g0))));
d_lng0_dV_e_di = (-(deriv_log_0_d0*((-d_g0_dV_e_di/g0/g0))));
d_lng0_dV_e_si = (-(deriv_log_0_d0*((-d_g0_dV_e_si/g0/g0))));
lng0 = (-value_log_0);
}
}
else
{
if (((F0-z2)>((-0.3)/T14)))
{
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_log_1 = log((1.0/((guessA/r1)*value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(1.0/((guessA/r1)*value_sqrt_0)));

d_lng0_dV_di_si = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_di_si))+(d_guessA_dV_di_si/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_di_si);
d_lng0_dV_g_si = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_si))+(d_guessA_dV_g_si/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_g_si);
d_lng0_dV_g_e = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_g_e))+(d_guessA_dV_g_e/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_g_e);
d_lng0_dV_e_di = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_di))+(d_guessA_dV_e_di/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_e_di);
d_lng0_dV_e_si = ((-(deriv_log_1_d0*((-((guessA/r1)*(deriv_sqrt_0_d0*(d_T3_dV_e_si))+(d_guessA_dV_e_si/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)))))-d_T1_dV_e_si);
lng0 = ((-value_log_1)-T1);
}
}
else
{

d_lng0_dV_di_si = ((d_F0_dV_di_si-d_z1_dV_di_si)-d_T1_dV_di_si);
d_lng0_dV_g_si = ((d_F0_dV_g_si-d_z1_dV_g_si)-d_T1_dV_g_si);
d_lng0_dV_g_e = ((d_F0_dV_g_e-d_z1_dV_g_e)-d_T1_dV_g_e);
d_lng0_dV_e_di = ((d_F0_dV_e_di-d_z1_dV_e_di)-d_T1_dV_e_di);
d_lng0_dV_e_si = ((d_F0_dV_e_si-d_z1_dV_e_si)-d_T1_dV_e_si);
lng0 = ((F0-z1)-T1);
}
}
}
{
double value_cos_0 = cos(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(value_cos_0);
double  deriv_cos_0_d0 = (-sin(g0));

d_phid_dV_g_si = (d_vch_dV_g_si+T14*(d_lng0_dV_g_si-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_g_si)))));
d_phid_dV_g_e = (d_vch_dV_g_e+T14*(d_lng0_dV_g_e-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_g_e)))));
d_phid_dV_e_di = (d_vch_dV_e_di+T14*(d_lng0_dV_e_di-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_e_di)))));
d_phid_dV_e_si = (d_vch_dV_e_si+T14*(d_lng0_dV_e_si-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_e_si)))));
d_phid_dV_di_si = (d_vch_dV_di_si+(T14*((d_lng0_dV_di_si-evaluator_lln_1.getDerivs(value_cos_0,(deriv_cos_0_d0*(d_g0_dV_di_si))))+d_F1_dV_di_si)+d_T14_dV_di_si*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)));
phid = ((vch+(T14*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)))+phibulk);
}
}
}
else
{

d_F0_dV_di_d = d_F0_dV_si_s = d_F0_dV_g_di =  0.0;
d_F0_dV_g_e = ((-d_vch_dV_g_e)/(2.0*nVtm));
d_F0_dV_e_di = ((-d_vch_dV_e_di)/(2.0*nVtm));
d_F0_dV_e_si = ((-d_vch_dV_e_si)/(2.0*nVtm));
d_F0_dV_di_si = (((2.0*nVtm)*(d_vgsfbeff_dV_di_si-d_vch_dV_di_si)-(vgsfbeff-vch)*2.0*d_nVtm_dV_di_si)/(2.0*nVtm)/(2.0*nVtm));
d_F0_dV_g_si = ((d_vgsfbeff_dV_g_si-d_vch_dV_g_si)/(2.0*nVtm));
F0 = ((vgsfbeff-vch)/(2.0*nVtm));
if ((F0<(-10)))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((2.0*F0));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_di_si);
d_g0_dV_g_si = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_g_si);
d_g0_dV_g_e = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_g_e);
d_g0_dV_e_di = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_e_di);
d_g0_dV_e_si = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dV_e_si);
g0 = evaluator_lexp_0.getValues((2.0*F0));
}
}
else
{
if ((F0>10))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_F0_dV_di_si/r1);
d_g0_dV_g_si = (d_F0_dV_g_si/r1);
d_g0_dV_g_e = (d_F0_dV_g_e/r1);
d_g0_dV_e_di = (d_F0_dV_e_di/r1);
d_g0_dV_e_si = (d_F0_dV_e_si/r1);
g0 = (F0/r1);
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+evaluator_lexp_0.getValues(F0)));

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_di_si));
d_T0_dV_g_si = evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_si));
d_T0_dV_g_e = evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_g_e));
d_T0_dV_e_di = evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_e_di));
d_T0_dV_e_si = evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dV_e_si));
T0 = evaluator_lln_1.getValues((1.0+evaluator_lexp_0.getValues(F0)));
}
{
double value_sqrt_0 = sqrt((0.25+(((r1*r1)*T0)*T0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_di_si+(r1*r1)*d_T0_dV_di_si*T0)))/(r1*r1));
d_g0_dV_g_si = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_g_si+(r1*r1)*d_T0_dV_g_si*T0)))/(r1*r1));
d_g0_dV_g_e = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_g_e+(r1*r1)*d_T0_dV_g_e*T0)))/(r1*r1));
d_g0_dV_e_di = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_e_di+(r1*r1)*d_T0_dV_e_di*T0)))/(r1*r1));
d_g0_dV_e_si = ((deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dV_e_si+(r1*r1)*d_T0_dV_e_si*T0)))/(r1*r1));
g0 = ((value_sqrt_0-0.5)/(r1*r1));
}
}
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}
if ((F0<(-50)))
{

d_g0d_dV_di_si = d_g0_dV_di_si;
d_g0d_dV_g_si = d_g0_dV_g_si;
d_g0d_dV_g_e = d_g0_dV_g_e;
d_g0d_dV_e_di = d_g0_dV_e_di;
d_g0d_dV_e_si = d_g0_dV_e_si;
g0d = g0;
}
else
{

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_inv_g0sq_dV_di_si = (inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0);
d_inv_g0sq_dV_g_si = (inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0);
d_inv_g0sq_dV_g_e = (inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0);
d_inv_g0sq_dV_e_di = (inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0);
d_inv_g0sq_dV_e_si = (inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0);
inv_g0sq = (inv_g0*inv_g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = cdop*d_g0_dV_g_si;
d_T0_dV_g_e = cdop*d_g0_dV_g_e;
d_T0_dV_e_di = cdop*d_g0_dV_e_di;
d_T0_dV_e_si = cdop*d_g0_dV_e_si;
d_T0_dV_di_si = (cdop*d_g0_dV_di_si+d_cdop_dV_di_si*g0);
T0 = (1+(cdop*g0));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-cdop*d_T0_dV_g_si/T0/T0);
d_T1_dV_g_e = (-cdop*d_T0_dV_g_e/T0/T0);
d_T1_dV_e_di = (-cdop*d_T0_dV_e_di/T0/T0);
d_T1_dV_e_si = (-cdop*d_T0_dV_e_si/T0/T0);
d_T1_dV_di_si = ((T0*d_cdop_dV_di_si-cdop*d_T0_dV_di_si)/T0/T0);
T1 = (cdop/T0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (T1*d_T1_dV_di_si+d_T1_dV_di_si*T1);
d_T2_dV_g_si = (T1*d_T1_dV_g_si+d_T1_dV_g_si*T1);
d_T2_dV_g_e = (T1*d_T1_dV_g_e+d_T1_dV_g_e*T1);
d_T2_dV_e_di = (T1*d_T1_dV_e_di+d_T1_dV_e_di*T1);
d_T2_dV_e_si = (T1*d_T1_dV_e_si+d_T1_dV_e_si*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);

d_e0_dV_di_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_di_si))+r1*d_g0_dV_di_si)+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0))-d_F0_dV_di_si);
d_e0_dV_g_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_si))+r1*d_g0_dV_g_si)+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0))-d_F0_dV_g_si);
d_e0_dV_g_e = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_e))+r1*d_g0_dV_g_e)+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0))-d_F0_dV_g_e);
d_e0_dV_e_di = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_di))+r1*d_g0_dV_e_di)+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0))-d_F0_dV_e_di);
d_e0_dV_e_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_si))+r1*d_g0_dV_e_si)+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0))-d_F0_dV_e_si);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}

d_e1_dV_di_si = ((0.5*d_inv_g0_dV_di_si+0.5*d_T1_dV_di_si)+(2*r2)*d_g0_dV_di_si);
d_e1_dV_g_si = ((0.5*d_inv_g0_dV_g_si+0.5*d_T1_dV_g_si)+(2*r2)*d_g0_dV_g_si);
d_e1_dV_g_e = ((0.5*d_inv_g0_dV_g_e+0.5*d_T1_dV_g_e)+(2*r2)*d_g0_dV_g_e);
d_e1_dV_e_di = ((0.5*d_inv_g0_dV_e_di+0.5*d_T1_dV_e_di)+(2*r2)*d_g0_dV_e_di);
d_e1_dV_e_si = ((0.5*d_inv_g0_dV_e_si+0.5*d_T1_dV_e_si)+(2*r2)*d_g0_dV_e_si);
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));

d_e2_dV_di_si = ((-0.5)*d_inv_g0sq_dV_di_si-0.5*d_T2_dV_di_si);
d_e2_dV_g_si = ((-0.5)*d_inv_g0sq_dV_g_si-0.5*d_T2_dV_g_si);
d_e2_dV_g_e = ((-0.5)*d_inv_g0sq_dV_g_e-0.5*d_T2_dV_g_e);
d_e2_dV_e_di = ((-0.5)*d_inv_g0sq_dV_e_di-0.5*d_T2_dV_e_di);
d_e2_dV_e_si = ((-0.5)*d_inv_g0sq_dV_e_si-0.5*d_T2_dV_e_si);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2*r2));

d_e3_dV_di_si = ((inv_g0*d_inv_g0sq_dV_di_si+d_inv_g0_dV_di_si*inv_g0sq)+(T2*d_T1_dV_di_si+d_T2_dV_di_si*T1));
d_e3_dV_g_si = ((inv_g0*d_inv_g0sq_dV_g_si+d_inv_g0_dV_g_si*inv_g0sq)+(T2*d_T1_dV_g_si+d_T2_dV_g_si*T1));
d_e3_dV_g_e = ((inv_g0*d_inv_g0sq_dV_g_e+d_inv_g0_dV_g_e*inv_g0sq)+(T2*d_T1_dV_g_e+d_T2_dV_g_e*T1));
d_e3_dV_e_di = ((inv_g0*d_inv_g0sq_dV_e_di+d_inv_g0_dV_e_di*inv_g0sq)+(T2*d_T1_dV_e_di+d_T2_dV_e_di*T1));
d_e3_dV_e_si = ((inv_g0*d_inv_g0sq_dV_e_si+d_inv_g0_dV_e_si*inv_g0sq)+(T2*d_T1_dV_e_si+d_T2_dV_e_si*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_inv_g0_dV_di_si = (-d_g0_dV_di_si/g0/g0);
d_inv_g0_dV_g_si = (-d_g0_dV_g_si/g0/g0);
d_inv_g0_dV_g_e = (-d_g0_dV_g_e/g0/g0);
d_inv_g0_dV_e_di = (-d_g0_dV_e_di/g0/g0);
d_inv_g0_dV_e_si = (-d_g0_dV_e_si/g0/g0);
inv_g0 = (1.0/g0);

d_inv_g0sq_dV_di_si = (inv_g0*d_inv_g0_dV_di_si+d_inv_g0_dV_di_si*inv_g0);
d_inv_g0sq_dV_g_si = (inv_g0*d_inv_g0_dV_g_si+d_inv_g0_dV_g_si*inv_g0);
d_inv_g0sq_dV_g_e = (inv_g0*d_inv_g0_dV_g_e+d_inv_g0_dV_g_e*inv_g0);
d_inv_g0sq_dV_e_di = (inv_g0*d_inv_g0_dV_e_di+d_inv_g0_dV_e_di*inv_g0);
d_inv_g0sq_dV_e_si = (inv_g0*d_inv_g0_dV_e_si+d_inv_g0_dV_e_si*inv_g0);
inv_g0sq = (inv_g0*inv_g0);

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = cdop*d_g0_dV_g_si;
d_T0_dV_g_e = cdop*d_g0_dV_g_e;
d_T0_dV_e_di = cdop*d_g0_dV_e_di;
d_T0_dV_e_si = cdop*d_g0_dV_e_si;
d_T0_dV_di_si = (cdop*d_g0_dV_di_si+d_cdop_dV_di_si*g0);
T0 = (1+(cdop*g0));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-cdop*d_T0_dV_g_si/T0/T0);
d_T1_dV_g_e = (-cdop*d_T0_dV_g_e/T0/T0);
d_T1_dV_e_di = (-cdop*d_T0_dV_e_di/T0/T0);
d_T1_dV_e_si = (-cdop*d_T0_dV_e_si/T0/T0);
d_T1_dV_di_si = ((T0*d_cdop_dV_di_si-cdop*d_T0_dV_di_si)/T0/T0);
T1 = (cdop/T0);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (T1*d_T1_dV_di_si+d_T1_dV_di_si*T1);
d_T2_dV_g_si = (T1*d_T1_dV_g_si+d_T1_dV_g_si*T1);
d_T2_dV_g_e = (T1*d_T1_dV_g_e+d_T1_dV_g_e*T1);
d_T2_dV_e_di = (T1*d_T1_dV_e_di+d_T1_dV_e_di*T1);
d_T2_dV_e_si = (T1*d_T1_dV_e_si+d_T1_dV_e_si*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);

d_e0_dV_di_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_di_si))+r1*d_g0_dV_di_si)+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0))-d_F0_dV_di_si);
d_e0_dV_g_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_si))+r1*d_g0_dV_g_si)+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0))-d_F0_dV_g_si);
d_e0_dV_g_e = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_g_e))+r1*d_g0_dV_g_e)+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0))-d_F0_dV_g_e);
d_e0_dV_e_di = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_di))+r1*d_g0_dV_e_di)+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0))-d_F0_dV_e_di);
d_e0_dV_e_si = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dV_e_si))+r1*d_g0_dV_e_si)+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0))-d_F0_dV_e_si);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}

d_e1_dV_di_si = ((0.5*d_inv_g0_dV_di_si+0.5*d_T1_dV_di_si)+(2*r2)*d_g0_dV_di_si);
d_e1_dV_g_si = ((0.5*d_inv_g0_dV_g_si+0.5*d_T1_dV_g_si)+(2*r2)*d_g0_dV_g_si);
d_e1_dV_g_e = ((0.5*d_inv_g0_dV_g_e+0.5*d_T1_dV_g_e)+(2*r2)*d_g0_dV_g_e);
d_e1_dV_e_di = ((0.5*d_inv_g0_dV_e_di+0.5*d_T1_dV_e_di)+(2*r2)*d_g0_dV_e_di);
d_e1_dV_e_si = ((0.5*d_inv_g0_dV_e_si+0.5*d_T1_dV_e_si)+(2*r2)*d_g0_dV_e_si);
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));

d_e2_dV_di_si = ((-0.5)*d_inv_g0sq_dV_di_si-0.5*d_T2_dV_di_si);
d_e2_dV_g_si = ((-0.5)*d_inv_g0sq_dV_g_si-0.5*d_T2_dV_g_si);
d_e2_dV_g_e = ((-0.5)*d_inv_g0sq_dV_g_e-0.5*d_T2_dV_g_e);
d_e2_dV_e_di = ((-0.5)*d_inv_g0sq_dV_e_di-0.5*d_T2_dV_e_di);
d_e2_dV_e_si = ((-0.5)*d_inv_g0sq_dV_e_si-0.5*d_T2_dV_e_si);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2*r2));

d_e3_dV_di_si = ((inv_g0*d_inv_g0sq_dV_di_si+d_inv_g0_dV_di_si*inv_g0sq)+(T2*d_T1_dV_di_si+d_T2_dV_di_si*T1));
d_e3_dV_g_si = ((inv_g0*d_inv_g0sq_dV_g_si+d_inv_g0_dV_g_si*inv_g0sq)+(T2*d_T1_dV_g_si+d_T2_dV_g_si*T1));
d_e3_dV_g_e = ((inv_g0*d_inv_g0sq_dV_g_e+d_inv_g0_dV_g_e*inv_g0sq)+(T2*d_T1_dV_g_e+d_T2_dV_g_e*T1));
d_e3_dV_e_di = ((inv_g0*d_inv_g0sq_dV_e_di+d_inv_g0_dV_e_di*inv_g0sq)+(T2*d_T1_dV_e_di+d_T2_dV_e_di*T1));
d_e3_dV_e_si = ((inv_g0*d_inv_g0sq_dV_e_si+d_inv_g0_dV_e_si*inv_g0sq)+(T2*d_T1_dV_e_si+d_T2_dV_e_si*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di =  0.0;
d_g0_dV_di_si = (d_g0_dV_di_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_di_si+d_e0_dV_di_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_di_si+2.0*d_e1_dV_di_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_di_si+3.0*d_e2_dV_di_si*e2)-(e1*d_e3_dV_di_si+d_e1_dV_di_si*e3))+(e0*d_e0_dV_di_si+d_e0_dV_di_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_di_si+(((6.0*e1)*e1)*d_e1_dV_di_si+((6.0*e1)*d_e1_dV_di_si+6.0*d_e1_dV_di_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_di_si-e0*d_e1_dV_di_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_si = (d_g0_dV_g_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_si+d_e0_dV_g_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_si+2.0*d_e1_dV_g_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_si+3.0*d_e2_dV_g_si*e2)-(e1*d_e3_dV_g_si+d_e1_dV_g_si*e3))+(e0*d_e0_dV_g_si+d_e0_dV_g_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_si+(((6.0*e1)*e1)*d_e1_dV_g_si+((6.0*e1)*d_e1_dV_g_si+6.0*d_e1_dV_g_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_si-e0*d_e1_dV_g_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_g_e = (d_g0_dV_g_e-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_g_e+d_e0_dV_g_e*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_g_e+2.0*d_e1_dV_g_e*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_g_e+3.0*d_e2_dV_g_e*e2)-(e1*d_e3_dV_g_e+d_e1_dV_g_e*e3))+(e0*d_e0_dV_g_e+d_e0_dV_g_e*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_g_e+(((6.0*e1)*e1)*d_e1_dV_g_e+((6.0*e1)*d_e1_dV_g_e+6.0*d_e1_dV_g_e*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_g_e-e0*d_e1_dV_g_e)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_di = (d_g0_dV_e_di-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_di+d_e0_dV_e_di*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_di+2.0*d_e1_dV_e_di*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_di+3.0*d_e2_dV_e_di*e2)-(e1*d_e3_dV_e_di+d_e1_dV_e_di*e3))+(e0*d_e0_dV_e_di+d_e0_dV_e_di*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_di+(((6.0*e1)*e1)*d_e1_dV_e_di+((6.0*e1)*d_e1_dV_e_di+6.0*d_e1_dV_e_di*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_di-e0*d_e1_dV_e_di)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
d_g0_dV_e_si = (d_g0_dV_e_si-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dV_e_si+d_e0_dV_e_si*e2)-(e0*e2)*((2.0*e1)*d_e1_dV_e_si+2.0*d_e1_dV_e_si*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dV_e_si+3.0*d_e2_dV_e_si*e2)-(e1*d_e3_dV_e_si+d_e1_dV_e_si*e3))+(e0*d_e0_dV_e_si+d_e0_dV_e_si*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dV_e_si+(((6.0*e1)*e1)*d_e1_dV_e_si+((6.0*e1)*d_e1_dV_e_si+6.0*d_e1_dV_e_si*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dV_e_si-e0*d_e1_dV_e_si)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0max;
}
else
{

d_g0_dV_di_d = d_g0_dV_si_s = d_g0_dV_g_di = d_g0_dV_e_si = d_g0_dV_e_di = d_g0_dV_g_e = d_g0_dV_g_si = d_g0_dV_di_si =  0.0;
g0 = g0min;
}
}

d_g0d_dV_di_si = d_g0_dV_di_si;
d_g0d_dV_g_si = d_g0_dV_g_si;
d_g0d_dV_g_e = d_g0_dV_g_e;
d_g0d_dV_e_di = d_g0_dV_e_di;
d_g0d_dV_e_si = d_g0_dV_e_si;
g0d = g0;
}

d_vpolyd_dV_g_si = ((((2*nVtm)*r2)*g0d)*d_g0d_dV_g_si+((2*nVtm)*r2)*d_g0d_dV_g_si*g0d);
d_vpolyd_dV_g_e = ((((2*nVtm)*r2)*g0d)*d_g0d_dV_g_e+((2*nVtm)*r2)*d_g0d_dV_g_e*g0d);
d_vpolyd_dV_e_di = ((((2*nVtm)*r2)*g0d)*d_g0d_dV_e_di+((2*nVtm)*r2)*d_g0d_dV_e_di*g0d);
d_vpolyd_dV_e_si = ((((2*nVtm)*r2)*g0d)*d_g0d_dV_e_si+((2*nVtm)*r2)*d_g0d_dV_e_si*g0d);
d_vpolyd_dV_di_si = ((((2*nVtm)*r2)*g0d)*d_g0d_dV_di_si+(((2*nVtm)*r2)*d_g0d_dV_di_si+2*d_nVtm_dV_di_si*r2*g0d)*g0d);
vpolyd = ((((2*nVtm)*r2)*g0d)*g0d);

d_phid_dV_g_e = ((-((2*nVtm)*r1)*d_g0d_dV_g_e)-d_vpolyd_dV_g_e);
d_phid_dV_e_di = ((-((2*nVtm)*r1)*d_g0d_dV_e_di)-d_vpolyd_dV_e_di);
d_phid_dV_e_si = ((-((2*nVtm)*r1)*d_g0d_dV_e_si)-d_vpolyd_dV_e_si);
d_phid_dV_di_si = ((d_vgsfbeff_dV_di_si-(((2*nVtm)*r1)*d_g0d_dV_di_si+2*d_nVtm_dV_di_si*r1*g0d))-d_vpolyd_dV_di_si);
d_phid_dV_g_si = ((d_vgsfbeff_dV_g_si-((2*nVtm)*r1)*d_g0d_dV_g_si)-d_vpolyd_dV_g_si);
phid = ((vgsfbeff-(((2*nVtm)*r1)*g0d))-vpolyd);

d_qid_dV_g_si = q0*d_g0d_dV_g_si;
d_qid_dV_g_e = q0*d_g0d_dV_g_e;
d_qid_dV_e_di = q0*d_g0d_dV_e_di;
d_qid_dV_e_si = q0*d_g0d_dV_e_si;
d_qid_dV_di_si = (q0*d_g0d_dV_di_si+d_q0_dV_di_si*g0d);
qid = (q0*g0d);
}
qba = qbs;
if (((model_.GEOMOD)!=3))
{
if ((NGATE_i>0))
{
{
double value_sqrt_0 = sqrt((1+((vgsfbeff-phid)/vpoly0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_g_di =  0.0;
d_T0_dV_g_e = (deriv_sqrt_0_d0*(((-d_phid_dV_g_e)/vpoly0)));
d_T0_dV_e_di = (deriv_sqrt_0_d0*(((-d_phid_dV_e_di)/vpoly0)));
d_T0_dV_e_si = (deriv_sqrt_0_d0*(((-d_phid_dV_e_si)/vpoly0)));
d_T0_dV_di_si = (deriv_sqrt_0_d0*(((d_vgsfbeff_dV_di_si-d_phid_dV_di_si)/vpoly0)));
d_T0_dV_g_si = (deriv_sqrt_0_d0*(((d_vgsfbeff_dV_g_si-d_phid_dV_g_si)/vpoly0)));
T0 = (value_sqrt_0-1);
}

d_vpolyd_dV_di_si = ((vpoly0*T0)*d_T0_dV_di_si+vpoly0*d_T0_dV_di_si*T0);
d_vpolyd_dV_g_si = ((vpoly0*T0)*d_T0_dV_g_si+vpoly0*d_T0_dV_g_si*T0);
d_vpolyd_dV_g_e = ((vpoly0*T0)*d_T0_dV_g_e+vpoly0*d_T0_dV_g_e*T0);
d_vpolyd_dV_e_di = ((vpoly0*T0)*d_T0_dV_e_di+vpoly0*d_T0_dV_e_di*T0);
d_vpolyd_dV_e_si = ((vpoly0*T0)*d_T0_dV_e_si+vpoly0*d_T0_dV_e_si*T0);
vpolyd = ((vpoly0*T0)*T0);
}
else
{

d_vpolyd_dV_di_si = d_vpolyd_dV_e_si = d_vpolyd_dV_e_di = d_vpolyd_dV_g_e = d_vpolyd_dV_g_si =  0.0;
vpolyd = 0;
}

d_qid_dV_g_e = (((model_.COREMOD)!=0)?((-d_phid_dV_g_e)-d_vpolyd_dV_g_e):((-d_phid_dV_g_e)-d_vpolyd_dV_g_e));
d_qid_dV_e_di = (((model_.COREMOD)!=0)?((-d_phid_dV_e_di)-d_vpolyd_dV_e_di):((-d_phid_dV_e_di)-d_vpolyd_dV_e_di));
d_qid_dV_e_si = (((model_.COREMOD)!=0)?((-d_phid_dV_e_si)-d_vpolyd_dV_e_si):((-d_phid_dV_e_si)-d_vpolyd_dV_e_si));
d_qid_dV_di_si = (((model_.COREMOD)!=0)?((d_vgsfbeff_dV_di_si-d_phid_dV_di_si)-d_vpolyd_dV_di_si):((d_vgsfbeff_dV_di_si-d_phid_dV_di_si)-d_vpolyd_dV_di_si));
d_qid_dV_g_si = (((model_.COREMOD)!=0)?((d_vgsfbeff_dV_g_si-d_phid_dV_g_si)-d_vpolyd_dV_g_si):((d_vgsfbeff_dV_g_si-d_phid_dV_g_si)-d_vpolyd_dV_g_si));
qid = (((model_.COREMOD)!=0)?((vgsfbeff-phid)-vpolyd):(((vgsfbeff-phid)-qbs)-vpolyd));
}

d_qia_dV_g_si = 0.5*(d_qis_dV_g_si+d_qid_dV_g_si);
d_qia_dV_g_e = 0.5*(d_qis_dV_g_e+d_qid_dV_g_e);
d_qia_dV_e_di = 0.5*(d_qis_dV_e_di+d_qid_dV_e_di);
d_qia_dV_e_si = 0.5*(d_qis_dV_e_si+d_qid_dV_e_si);
d_qia_dV_di_si = 0.5*(d_qis_dV_di_si+d_qid_dV_di_si);
qia = (0.5*(qis+qid));

d_dqi_dV_g_si = (d_qis_dV_g_si-d_qid_dV_g_si);
d_dqi_dV_g_e = (d_qis_dV_g_e-d_qid_dV_g_e);
d_dqi_dV_e_di = (d_qis_dV_e_di-d_qid_dV_e_di);
d_dqi_dV_e_si = (d_qis_dV_e_si-d_qid_dV_e_si);
d_dqi_dV_di_si = (d_qis_dV_di_si-d_qid_dV_di_si);
dqi = (qis-qid);
{
double value_pow_0 = pow(Vdseff,2.0);
double  deriv_pow_0_d0 = ((Vdseff == 0.0)?0.0:(value_pow_0*2.0/Vdseff));

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = ((deriv_pow_0_d0*(d_Vdseff_dV_g_si))/6.25e-4);
d_T0_dV_g_e = ((deriv_pow_0_d0*(d_Vdseff_dV_g_e))/6.25e-4);
d_T0_dV_e_di = ((deriv_pow_0_d0*(d_Vdseff_dV_e_di))/6.25e-4);
d_T0_dV_e_si = ((deriv_pow_0_d0*(d_Vdseff_dV_e_si))/6.25e-4);
d_T0_dV_di_si = ((deriv_pow_0_d0*(d_Vdseff_dV_di_si))/6.25e-4);
T0 = (value_pow_0/6.25e-4);
}
if (((model_.CHARGEWF)!=0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T0));

d_qia2_dV_g_si = (0.5*(d_qis_dV_g_si+d_qid_dV_g_si)+((((model_.CHARGEWF)*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*d_dqi_dV_g_si+(model_.CHARGEWF)*(-evaluator_lexp_0.getDerivs((-T0),(-d_T0_dV_g_si)))*0.5*dqi));
d_qia2_dV_g_e = (0.5*(d_qis_dV_g_e+d_qid_dV_g_e)+((((model_.CHARGEWF)*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*d_dqi_dV_g_e+(model_.CHARGEWF)*(-evaluator_lexp_0.getDerivs((-T0),(-d_T0_dV_g_e)))*0.5*dqi));
d_qia2_dV_e_di = (0.5*(d_qis_dV_e_di+d_qid_dV_e_di)+((((model_.CHARGEWF)*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*d_dqi_dV_e_di+(model_.CHARGEWF)*(-evaluator_lexp_0.getDerivs((-T0),(-d_T0_dV_e_di)))*0.5*dqi));
d_qia2_dV_e_si = (0.5*(d_qis_dV_e_si+d_qid_dV_e_si)+((((model_.CHARGEWF)*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*d_dqi_dV_e_si+(model_.CHARGEWF)*(-evaluator_lexp_0.getDerivs((-T0),(-d_T0_dV_e_si)))*0.5*dqi));
d_qia2_dV_di_si = (0.5*(d_qis_dV_di_si+d_qid_dV_di_si)+((((model_.CHARGEWF)*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*d_dqi_dV_di_si+(model_.CHARGEWF)*(-evaluator_lexp_0.getDerivs((-T0),(-d_T0_dV_di_si)))*0.5*dqi));
qia2 = ((0.5*(qis+qid))+((((model_.CHARGEWF)*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*dqi));
}
}
else
{

d_qia2_dV_g_si = 0.5*(d_qis_dV_g_si+d_qid_dV_g_si);
d_qia2_dV_g_e = 0.5*(d_qis_dV_g_e+d_qid_dV_g_e);
d_qia2_dV_e_di = 0.5*(d_qis_dV_e_di+d_qid_dV_e_di);
d_qia2_dV_e_si = 0.5*(d_qis_dV_e_si+d_qid_dV_e_si);
d_qia2_dV_di_si = 0.5*(d_qis_dV_di_si+d_qid_dV_di_si);
qia2 = (0.5*(qis+qid));
}
if (((QMTCENIV_i>0.0)||(QMTCENCV_i>0.0)))
{

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = (d_qia_dV_g_si/(model_.QM0));
d_T4_dV_g_e = (d_qia_dV_g_e/(model_.QM0));
d_T4_dV_e_di = (d_qia_dV_e_di/(model_.QM0));
d_T4_dV_e_si = (d_qia_dV_e_si/(model_.QM0));
d_T4_dV_di_si = (d_qia_dV_di_si/(model_.QM0));
T4 = ((qia+((model_.ETAQM)*qba))/(model_.QM0));
{
double value_pow_0 = pow(T4,(model_.PQM));
double  deriv_pow_0_d0 = ((T4 == 0.0)?0.0:(value_pow_0*(model_.PQM)/T4));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_g_si = (deriv_pow_0_d0*(d_T4_dV_g_si));
d_T5_dV_g_e = (deriv_pow_0_d0*(d_T4_dV_g_e));
d_T5_dV_e_di = (deriv_pow_0_d0*(d_T4_dV_e_di));
d_T5_dV_e_si = (deriv_pow_0_d0*(d_T4_dV_e_si));
d_T5_dV_di_si = (deriv_pow_0_d0*(d_T4_dV_di_si));
T5 = (1.0+value_pow_0);
}

d_Tcen_dV_di_si = (-Tcen0*d_T5_dV_di_si/T5/T5);
d_Tcen_dV_g_si = (-Tcen0*d_T5_dV_g_si/T5/T5);
d_Tcen_dV_g_e = (-Tcen0*d_T5_dV_g_e/T5/T5);
d_Tcen_dV_e_di = (-Tcen0*d_T5_dV_e_di/T5/T5);
d_Tcen_dV_e_si = (-Tcen0*d_T5_dV_e_si/T5/T5);
Tcen = (Tcen0/T5);
if ( (model_.GEOMOD) == (0))
{

d_Weff_dV_e_si = d_Weff_dV_e_di = d_Weff_dV_g_e = d_Weff_dV_g_si = d_Weff_dV_di_si =  0.0;
Weff = Weff0;

d_WeffCV_dV_e_si = d_WeffCV_dV_e_di = d_WeffCV_dV_g_e = d_WeffCV_dV_g_si = d_WeffCV_dV_di_si =  0.0;
WeffCV = WeffCV0;
}
else
if ( (model_.GEOMOD) == (1))
{

d_Weff_dV_di_si = (-(4.0*QMTCENIV_i)*d_Tcen_dV_di_si);
d_Weff_dV_g_si = (-(4.0*QMTCENIV_i)*d_Tcen_dV_g_si);
d_Weff_dV_g_e = (-(4.0*QMTCENIV_i)*d_Tcen_dV_g_e);
d_Weff_dV_e_di = (-(4.0*QMTCENIV_i)*d_Tcen_dV_e_di);
d_Weff_dV_e_si = (-(4.0*QMTCENIV_i)*d_Tcen_dV_e_si);
Weff = (Weff0-((4.0*QMTCENIV_i)*Tcen));

d_WeffCV_dV_di_si = (-(4.0*QMTCENCV_i)*d_Tcen_dV_di_si);
d_WeffCV_dV_g_si = (-(4.0*QMTCENCV_i)*d_Tcen_dV_g_si);
d_WeffCV_dV_g_e = (-(4.0*QMTCENCV_i)*d_Tcen_dV_g_e);
d_WeffCV_dV_e_di = (-(4.0*QMTCENCV_i)*d_Tcen_dV_e_di);
d_WeffCV_dV_e_si = (-(4.0*QMTCENCV_i)*d_Tcen_dV_e_si);
WeffCV = (WeffCV0-((4.0*QMTCENCV_i)*Tcen));
}
else
if ( (model_.GEOMOD) == (2))
{

d_Weff_dV_di_si = (-(8.0*QMTCENIV_i)*d_Tcen_dV_di_si);
d_Weff_dV_g_si = (-(8.0*QMTCENIV_i)*d_Tcen_dV_g_si);
d_Weff_dV_g_e = (-(8.0*QMTCENIV_i)*d_Tcen_dV_g_e);
d_Weff_dV_e_di = (-(8.0*QMTCENIV_i)*d_Tcen_dV_e_di);
d_Weff_dV_e_si = (-(8.0*QMTCENIV_i)*d_Tcen_dV_e_si);
Weff = (Weff0-((8.0*QMTCENIV_i)*Tcen));

d_WeffCV_dV_di_si = (-(8.0*QMTCENCV_i)*d_Tcen_dV_di_si);
d_WeffCV_dV_g_si = (-(8.0*QMTCENCV_i)*d_Tcen_dV_g_si);
d_WeffCV_dV_g_e = (-(8.0*QMTCENCV_i)*d_Tcen_dV_g_e);
d_WeffCV_dV_e_di = (-(8.0*QMTCENCV_i)*d_Tcen_dV_e_di);
d_WeffCV_dV_e_si = (-(8.0*QMTCENCV_i)*d_Tcen_dV_e_si);
WeffCV = (WeffCV0-((8.0*QMTCENCV_i)*Tcen));
}
else
if ( (model_.GEOMOD) == (3))
{

d_Weff_dV_di_si = (-((2.0*3.14159265358979323846)*QMTCENIV_i)*d_Tcen_dV_di_si);
d_Weff_dV_g_si = (-((2.0*3.14159265358979323846)*QMTCENIV_i)*d_Tcen_dV_g_si);
d_Weff_dV_g_e = (-((2.0*3.14159265358979323846)*QMTCENIV_i)*d_Tcen_dV_g_e);
d_Weff_dV_e_di = (-((2.0*3.14159265358979323846)*QMTCENIV_i)*d_Tcen_dV_e_di);
d_Weff_dV_e_si = (-((2.0*3.14159265358979323846)*QMTCENIV_i)*d_Tcen_dV_e_si);
Weff = (Weff0-(((2.0*3.14159265358979323846)*QMTCENIV_i)*Tcen));

d_WeffCV_dV_di_si = (-((2.0*3.14159265358979323846)*QMTCENCV_i)*d_Tcen_dV_di_si);
d_WeffCV_dV_g_si = (-((2.0*3.14159265358979323846)*QMTCENCV_i)*d_Tcen_dV_g_si);
d_WeffCV_dV_g_e = (-((2.0*3.14159265358979323846)*QMTCENCV_i)*d_Tcen_dV_g_e);
d_WeffCV_dV_e_di = (-((2.0*3.14159265358979323846)*QMTCENCV_i)*d_Tcen_dV_e_di);
d_WeffCV_dV_e_si = (-((2.0*3.14159265358979323846)*QMTCENCV_i)*d_Tcen_dV_e_si);
WeffCV = (WeffCV0-(((2.0*3.14159265358979323846)*QMTCENCV_i)*Tcen));
}
else
{
 // no default
}
if (((model_.GEOMOD)!=3))
{

d_coxeff_dV_di_si = (-(3.9*8.8542e-12)*(d_Tcen_dV_di_si*QMTCENCV_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio)));
d_coxeff_dV_g_si = (-(3.9*8.8542e-12)*(d_Tcen_dV_g_si*QMTCENCV_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio)));
d_coxeff_dV_g_e = (-(3.9*8.8542e-12)*(d_Tcen_dV_g_e*QMTCENCV_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio)));
d_coxeff_dV_e_di = (-(3.9*8.8542e-12)*(d_Tcen_dV_e_di*QMTCENCV_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio)));
d_coxeff_dV_e_si = (-(3.9*8.8542e-12)*(d_Tcen_dV_e_si*QMTCENCV_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio)));
coxeff = ((3.9*8.8542e-12)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCV_i)/epsratio)));
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((R/(R-(Tcen*QMTCENCV_i))));
AnalogFunctions::llnEvaluator evaluator_lln_1((1+((model_.TOXP)/R)));

d_coxeff_dV_di_si = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCV_i))),(-R*(-d_Tcen_dV_di_si*QMTCENCV_i)/(R-(Tcen*QMTCENCV_i))/(R-(Tcen*QMTCENCV_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_coxeff_dV_g_si = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCV_i))),(-R*(-d_Tcen_dV_g_si*QMTCENCV_i)/(R-(Tcen*QMTCENCV_i))/(R-(Tcen*QMTCENCV_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_coxeff_dV_g_e = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCV_i))),(-R*(-d_Tcen_dV_g_e*QMTCENCV_i)/(R-(Tcen*QMTCENCV_i))/(R-(Tcen*QMTCENCV_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_coxeff_dV_e_di = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCV_i))),(-R*(-d_Tcen_dV_e_di*QMTCENCV_i)/(R-(Tcen*QMTCENCV_i))/(R-(Tcen*QMTCENCV_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_coxeff_dV_e_si = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCV_i))),(-R*(-d_Tcen_dV_e_si*QMTCENCV_i)/(R-(Tcen*QMTCENCV_i))/(R-(Tcen*QMTCENCV_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
coxeff = ((3.9*8.8542e-12)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
}
}
}
else
{

d_Weff_dV_e_si = d_Weff_dV_e_di = d_Weff_dV_g_e = d_Weff_dV_g_si = d_Weff_dV_di_si =  0.0;
Weff = Weff0;

d_WeffCV_dV_e_si = d_WeffCV_dV_e_di = d_WeffCV_dV_g_e = d_WeffCV_dV_g_si = d_WeffCV_dV_di_si =  0.0;
WeffCV = WeffCV0;

d_coxeff_dV_e_si = d_coxeff_dV_e_di = d_coxeff_dV_g_e = d_coxeff_dV_g_si = d_coxeff_dV_di_si =  0.0;
coxeff = cox;
}
if (((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0))&&(QMTCENCVA_i!=0)))
{
{
double value_pow_0 = pow((qi_acc/(model_.QM0ACC)),(model_.PQMACC));
double  deriv_pow_0_d0 = (((qi_acc/(model_.QM0ACC)) == 0.0)?0.0:(value_pow_0*(model_.PQMACC)/(qi_acc/(model_.QM0ACC))));

d_T6_dV_g_di = d_T6_dV_di_d = d_T6_dV_si_s =  0.0;
d_T6_dV_di_si = (deriv_pow_0_d0*((d_qi_acc_dV_di_si/(model_.QM0ACC))));
d_T6_dV_g_si = (deriv_pow_0_d0*((d_qi_acc_dV_g_si/(model_.QM0ACC))));
d_T6_dV_g_e = (deriv_pow_0_d0*((d_qi_acc_dV_g_e/(model_.QM0ACC))));
d_T6_dV_e_di = (deriv_pow_0_d0*((d_qi_acc_dV_e_di/(model_.QM0ACC))));
d_T6_dV_e_si = (deriv_pow_0_d0*((d_qi_acc_dV_e_si/(model_.QM0ACC))));
T6 = (1.0+value_pow_0);
}

d_Tcen_dV_g_e = (-Tcen0*d_T6_dV_g_e/T6/T6);
d_Tcen_dV_e_di = (-Tcen0*d_T6_dV_e_di/T6/T6);
d_Tcen_dV_e_si = (-Tcen0*d_T6_dV_e_si/T6/T6);
d_Tcen_dV_di_si = (-Tcen0*d_T6_dV_di_si/T6/T6);
d_Tcen_dV_g_si = (-Tcen0*d_T6_dV_g_si/T6/T6);
Tcen = (Tcen0/T6);
if (((model_.GEOMOD)!=3))
{

d_cox_acc_dV_di_si = (-(3.9*8.8542e-12)*(d_Tcen_dV_di_si*QMTCENCVA_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio)));
d_cox_acc_dV_g_si = (-(3.9*8.8542e-12)*(d_Tcen_dV_g_si*QMTCENCVA_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio)));
d_cox_acc_dV_g_e = (-(3.9*8.8542e-12)*(d_Tcen_dV_g_e*QMTCENCVA_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio)));
d_cox_acc_dV_e_di = (-(3.9*8.8542e-12)*(d_Tcen_dV_e_di*QMTCENCVA_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio)));
d_cox_acc_dV_e_si = (-(3.9*8.8542e-12)*(d_Tcen_dV_e_si*QMTCENCVA_i/epsratio)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio))/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio)));
cox_acc = ((3.9*8.8542e-12)/((((model_.TOXP)*3.9)/(model_.EPSROX))+((Tcen*QMTCENCVA_i)/epsratio)));
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((R/(R-(Tcen*QMTCENCVA_i))));
AnalogFunctions::llnEvaluator evaluator_lln_1((1+((model_.TOXP)/R)));

d_cox_acc_dV_di_si = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCVA_i))),(-R*(-d_Tcen_dV_di_si*QMTCENCVA_i)/(R-(Tcen*QMTCENCVA_i))/(R-(Tcen*QMTCENCVA_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_cox_acc_dV_g_si = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCVA_i))),(-R*(-d_Tcen_dV_g_si*QMTCENCVA_i)/(R-(Tcen*QMTCENCVA_i))/(R-(Tcen*QMTCENCVA_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_cox_acc_dV_g_e = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCVA_i))),(-R*(-d_Tcen_dV_g_e*QMTCENCVA_i)/(R-(Tcen*QMTCENCVA_i))/(R-(Tcen*QMTCENCVA_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_cox_acc_dV_e_di = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCVA_i))),(-R*(-d_Tcen_dV_e_di*QMTCENCVA_i)/(R-(Tcen*QMTCENCVA_i))/(R-(Tcen*QMTCENCVA_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
d_cox_acc_dV_e_si = (-(3.9*8.8542e-12)*R*(evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCVA_i))),(-R*(-d_Tcen_dV_e_si*QMTCENCVA_i)/(R-(Tcen*QMTCENCVA_i))/(R-(Tcen*QMTCENCVA_i))))/epsratio)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX))))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
cox_acc = ((3.9*8.8542e-12)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+((model_.TOXP)/R)))*3.9)/(model_.EPSROX)))));
}
}
}

d_beta_dV_di_si = ((u0*cox)*d_Weff_dV_di_si/Leff);
d_beta_dV_g_si = ((u0*cox)*d_Weff_dV_g_si/Leff);
d_beta_dV_g_e = ((u0*cox)*d_Weff_dV_g_e/Leff);
d_beta_dV_e_di = ((u0*cox)*d_Weff_dV_e_di/Leff);
d_beta_dV_e_si = ((u0*cox)*d_Weff_dV_e_si/Leff);
beta = (((u0*cox)*Weff)/Leff);

d_Eeffm_dV_g_si = EeffFactor*eta_mu*d_qia2_dV_g_si;
d_Eeffm_dV_g_e = EeffFactor*eta_mu*d_qia2_dV_g_e;
d_Eeffm_dV_e_di = EeffFactor*eta_mu*d_qia2_dV_e_di;
d_Eeffm_dV_e_si = EeffFactor*eta_mu*d_qia2_dV_e_si;
d_Eeffm_dV_di_si = EeffFactor*eta_mu*d_qia2_dV_di_si;
Eeffm = (EeffFactor*(qba+(eta_mu*qia2)));
{
double value_fabs_0 = fabs((qia2/qb0));
double value_pow_1 = pow((0.5*(1.0+value_fabs_0)),UCS_t);
double  deriv_fabs_0_d0 = ((((qia2/qb0))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = (((0.5*(1.0+value_fabs_0)) == 0.0)?0.0:(value_pow_1*UCS_t/(0.5*(1.0+value_fabs_0))));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_g_si = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qia2_dV_g_si/qb0)))));
d_T2_dV_g_e = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qia2_dV_g_e/qb0)))));
d_T2_dV_e_di = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qia2_dV_e_di/qb0)))));
d_T2_dV_e_si = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qia2_dV_e_si/qb0)))));
d_T2_dV_di_si = (deriv_pow_1_d0*(0.5*(deriv_fabs_0_d0*((d_qia2_dV_di_si/qb0)))));
T2 = value_pow_1;
}
if (((model_.BULKMOD)!=0))
{
{
double value_fabs_0 = fabs(Eeffm);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffm)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));

d_T3_dV_g_di =  0.0;
d_T3_dV_g_si = ((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_g_si))))+(-UD_t*d_T2_dV_g_si/T2/T2));
d_T3_dV_g_e = ((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_g_e))))+(-UD_t*d_T2_dV_g_e/T2/T2));
d_T3_dV_di_si = (((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_di_si))))+UC_t*d_veseff_dV_di_si*value_pow_1)+(-UD_t*d_T2_dV_di_si/T2/T2));
d_T3_dV_e_di = (((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_e_di))))+UC_t*d_veseff_dV_e_di*value_pow_1)+(-UD_t*d_T2_dV_e_di/T2/T2));
d_T3_dV_e_si = (((UA_t+(UC_t*veseff))*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_e_si))))+UC_t*d_veseff_dV_e_si*value_pow_1)+(-UD_t*d_T2_dV_e_si/T2/T2));
T3 = (((UA_t+(UC_t*veseff))*value_pow_1)+(UD_t/T2));
}
}
else
{
{
double value_fabs_0 = fabs(Eeffm);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffm)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));

d_T3_dV_g_di =  0.0;
d_T3_dV_g_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_g_si))))+(-UD_t*d_T2_dV_g_si/T2/T2));
d_T3_dV_g_e = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_g_e))))+(-UD_t*d_T2_dV_g_e/T2/T2));
d_T3_dV_e_di = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_e_di))))+(-UD_t*d_T2_dV_e_di/T2/T2));
d_T3_dV_e_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_e_si))))+(-UD_t*d_T2_dV_e_si/T2/T2));
d_T3_dV_di_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_dV_di_si))))+(-UD_t*d_T2_dV_di_si/T2/T2));
T3 = ((UA_t*value_pow_1)+(UD_t/T2));
}
}

d_Dmob_dV_di_si = d_T3_dV_di_si;
d_Dmob_dV_e_di = d_T3_dV_e_di;
d_Dmob_dV_e_si = d_T3_dV_e_si;
d_Dmob_dV_g_si = d_T3_dV_g_si;
d_Dmob_dV_g_e = d_T3_dV_g_e;
Dmob = (1.0+T3);

d_Dmob_dV_di_si = (d_Dmob_dV_di_si/U0MULT);
d_Dmob_dV_e_di = (d_Dmob_dV_e_di/U0MULT);
d_Dmob_dV_e_si = (d_Dmob_dV_e_si/U0MULT);
d_Dmob_dV_g_si = (d_Dmob_dV_g_si/U0MULT);
d_Dmob_dV_g_e = (d_Dmob_dV_g_e/U0MULT);
Dmob = (Dmob/U0MULT);

d_ueff_dV_di_si = (-u0*d_Dmob_dV_di_si/Dmob/Dmob);
d_ueff_dV_e_di = (-u0*d_Dmob_dV_e_di/Dmob/Dmob);
d_ueff_dV_e_si = (-u0*d_Dmob_dV_e_si/Dmob/Dmob);
d_ueff_dV_g_si = (-u0*d_Dmob_dV_g_si/Dmob/Dmob);
d_ueff_dV_g_e = (-u0*d_Dmob_dV_g_e/Dmob/Dmob);
ueff = (u0/Dmob);

d_Eeffm_cv_dV_g_si = EeffFactor*eta_mu_cv*d_qia2_dV_g_si;
d_Eeffm_cv_dV_g_e = EeffFactor*eta_mu_cv*d_qia2_dV_g_e;
d_Eeffm_cv_dV_e_di = EeffFactor*eta_mu_cv*d_qia2_dV_e_di;
d_Eeffm_cv_dV_e_si = EeffFactor*eta_mu_cv*d_qia2_dV_e_si;
d_Eeffm_cv_dV_di_si = EeffFactor*eta_mu_cv*d_qia2_dV_di_si;
Eeffm_cv = (EeffFactor*(qba+(eta_mu_cv*qia2)));
{
double value_fabs_0 = fabs(Eeffm_cv);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffm_cv)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));

d_T3_dV_g_di =  0.0;
d_T3_dV_g_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_cv_dV_g_si))))+(-UD_t*d_T2_dV_g_si/T2/T2));
d_T3_dV_g_e = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_cv_dV_g_e))))+(-UD_t*d_T2_dV_g_e/T2/T2));
d_T3_dV_e_di = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_cv_dV_e_di))))+(-UD_t*d_T2_dV_e_di/T2/T2));
d_T3_dV_e_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_cv_dV_e_si))))+(-UD_t*d_T2_dV_e_si/T2/T2));
d_T3_dV_di_si = (UA_t*(deriv_pow_1_d0*((deriv_fabs_0_d0*(d_Eeffm_cv_dV_di_si))))+(-UD_t*d_T2_dV_di_si/T2/T2));
T3 = ((UA_t*value_pow_1)+(UD_t/T2));
}

d_Dmob_cv_dV_di_si = d_T3_dV_di_si;
d_Dmob_cv_dV_e_di = d_T3_dV_e_di;
d_Dmob_cv_dV_e_si = d_T3_dV_e_si;
d_Dmob_cv_dV_g_si = d_T3_dV_g_si;
d_Dmob_cv_dV_g_e = d_T3_dV_g_e;
Dmob_cv = (1.0+T3);

d_Dmob_cv_dV_di_si = (d_Dmob_cv_dV_di_si/U0MULT);
d_Dmob_cv_dV_e_di = (d_Dmob_cv_dV_e_di/U0MULT);
d_Dmob_cv_dV_e_si = (d_Dmob_cv_dV_e_si/U0MULT);
d_Dmob_cv_dV_g_si = (d_Dmob_cv_dV_g_si/U0MULT);
d_Dmob_cv_dV_g_e = (d_Dmob_cv_dV_g_e/U0MULT);
Dmob_cv = (Dmob_cv/U0MULT);
tmp = (((DROUT_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);

d_DIBLfactor_dV_di_si = (0.5*d_PDIBL1_a_dV_di_si/(value_cosh_0-1.0));
DIBLfactor = (((0.5*PDIBL1_a)/(value_cosh_0-1.0))+PDIBL2_i);
}
}
else
{
{
double value_exp_0 = exp((-tmp));

d_DIBLfactor_dV_di_si = d_PDIBL1_a_dV_di_si*value_exp_0;
DIBLfactor = ((PDIBL1_a*value_exp_0)+PDIBL2_i);
}
}
if ((PVAG_i>0))
{

d_PVAGfactor_dV_g_si = ((EsatL*PVAG_i*d_qia_dV_g_si-(PVAG_i*qia)*d_EsatL_dV_g_si)/EsatL/EsatL);
d_PVAGfactor_dV_g_e = ((EsatL*PVAG_i*d_qia_dV_g_e-(PVAG_i*qia)*d_EsatL_dV_g_e)/EsatL/EsatL);
d_PVAGfactor_dV_e_di = ((EsatL*PVAG_i*d_qia_dV_e_di-(PVAG_i*qia)*d_EsatL_dV_e_di)/EsatL/EsatL);
d_PVAGfactor_dV_e_si = ((EsatL*PVAG_i*d_qia_dV_e_si-(PVAG_i*qia)*d_EsatL_dV_e_si)/EsatL/EsatL);
d_PVAGfactor_dV_di_si = ((EsatL*PVAG_i*d_qia_dV_di_si-(PVAG_i*qia)*d_EsatL_dV_di_si)/EsatL/EsatL);
PVAGfactor = (1.0+((PVAG_i*qia)/EsatL));
}
else
{

d_PVAGfactor_dV_g_si = (-(-((EsatL*PVAG_i*d_qia_dV_g_si-(PVAG_i*qia)*d_EsatL_dV_g_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
d_PVAGfactor_dV_g_e = (-(-((EsatL*PVAG_i*d_qia_dV_g_e-(PVAG_i*qia)*d_EsatL_dV_g_e)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
d_PVAGfactor_dV_e_di = (-(-((EsatL*PVAG_i*d_qia_dV_e_di-(PVAG_i*qia)*d_EsatL_dV_e_di)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
d_PVAGfactor_dV_e_si = (-(-((EsatL*PVAG_i*d_qia_dV_e_si-(PVAG_i*qia)*d_EsatL_dV_e_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
d_PVAGfactor_dV_di_si = (-(-((EsatL*PVAG_i*d_qia_dV_di_si-(PVAG_i*qia)*d_EsatL_dV_di_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
PVAGfactor = (1.0/(1.0-((PVAG_i*qia)/EsatL)));
}
if ((Vdseff>vds))
{

d_Vdseff_dV_e_si = d_Vdseff_dV_e_di = d_Vdseff_dV_g_e = d_Vdseff_dV_g_si =  0.0;
d_Vdseff_dV_di_si = d_vds_dV_di_si;
Vdseff = vds;
}

d_diffVds_dV_g_si = (-d_Vdseff_dV_g_si);
d_diffVds_dV_g_e = (-d_Vdseff_dV_g_e);
d_diffVds_dV_e_di = (-d_Vdseff_dV_e_di);
d_diffVds_dV_e_si = (-d_Vdseff_dV_e_si);
d_diffVds_dV_di_si = (d_vds_dV_di_si-d_Vdseff_dV_di_si);
diffVds = (vds-Vdseff);

d_Vgst2Vtm_dV_g_si = d_qia_dV_g_si;
d_Vgst2Vtm_dV_g_e = d_qia_dV_g_e;
d_Vgst2Vtm_dV_e_di = d_qia_dV_e_di;
d_Vgst2Vtm_dV_e_si = d_qia_dV_e_si;
d_Vgst2Vtm_dV_di_si = d_qia_dV_di_si;
Vgst2Vtm = (qia+(2.0*Vtm));
if ((DIBLfactor>0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = d_Vgst2Vtm_dV_g_si;
d_T1_dV_g_e = d_Vgst2Vtm_dV_g_e;
d_T1_dV_e_di = d_Vgst2Vtm_dV_e_di;
d_T1_dV_e_si = d_Vgst2Vtm_dV_e_si;
d_T1_dV_di_si = d_Vgst2Vtm_dV_di_si;
T1 = Vgst2Vtm;

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (((Vdsat+T1)*d_T1_dV_di_si-T1*(d_Vdsat_dV_di_si+d_T1_dV_di_si))/(Vdsat+T1)/(Vdsat+T1));
d_T3_dV_g_si = (((Vdsat+T1)*d_T1_dV_g_si-T1*(d_Vdsat_dV_g_si+d_T1_dV_g_si))/(Vdsat+T1)/(Vdsat+T1));
d_T3_dV_g_e = (((Vdsat+T1)*d_T1_dV_g_e-T1*(d_Vdsat_dV_g_e+d_T1_dV_g_e))/(Vdsat+T1)/(Vdsat+T1));
d_T3_dV_e_di = (((Vdsat+T1)*d_T1_dV_e_di-T1*(d_Vdsat_dV_e_di+d_T1_dV_e_di))/(Vdsat+T1)/(Vdsat+T1));
d_T3_dV_e_si = (((Vdsat+T1)*d_T1_dV_e_si-T1*(d_Vdsat_dV_e_si+d_T1_dV_e_si))/(Vdsat+T1)/(Vdsat+T1));
T3 = (T1/(Vdsat+T1));

d_VaDIBL_dV_di_si = (((T1/DIBLfactor)*T3)*d_PVAGfactor_dV_di_si+((T1/DIBLfactor)*d_T3_dV_di_si+((DIBLfactor*d_T1_dV_di_si-T1*d_DIBLfactor_dV_di_si)/DIBLfactor/DIBLfactor)*T3)*PVAGfactor);
d_VaDIBL_dV_g_si = (((T1/DIBLfactor)*T3)*d_PVAGfactor_dV_g_si+((T1/DIBLfactor)*d_T3_dV_g_si+(d_T1_dV_g_si/DIBLfactor)*T3)*PVAGfactor);
d_VaDIBL_dV_g_e = (((T1/DIBLfactor)*T3)*d_PVAGfactor_dV_g_e+((T1/DIBLfactor)*d_T3_dV_g_e+(d_T1_dV_g_e/DIBLfactor)*T3)*PVAGfactor);
d_VaDIBL_dV_e_di = (((T1/DIBLfactor)*T3)*d_PVAGfactor_dV_e_di+((T1/DIBLfactor)*d_T3_dV_e_di+(d_T1_dV_e_di/DIBLfactor)*T3)*PVAGfactor);
d_VaDIBL_dV_e_si = (((T1/DIBLfactor)*T3)*d_PVAGfactor_dV_e_si+((T1/DIBLfactor)*d_T3_dV_e_si+(d_T1_dV_e_si/DIBLfactor)*T3)*PVAGfactor);
VaDIBL = (((T1/DIBLfactor)*T3)*PVAGfactor);

d_Moc_dV_g_si = ((VaDIBL*d_diffVds_dV_g_si-diffVds*d_VaDIBL_dV_g_si)/VaDIBL/VaDIBL);
d_Moc_dV_g_e = ((VaDIBL*d_diffVds_dV_g_e-diffVds*d_VaDIBL_dV_g_e)/VaDIBL/VaDIBL);
d_Moc_dV_e_di = ((VaDIBL*d_diffVds_dV_e_di-diffVds*d_VaDIBL_dV_e_di)/VaDIBL/VaDIBL);
d_Moc_dV_e_si = ((VaDIBL*d_diffVds_dV_e_si-diffVds*d_VaDIBL_dV_e_si)/VaDIBL/VaDIBL);
d_Moc_dV_di_si = ((VaDIBL*d_diffVds_dV_di_si-diffVds*d_VaDIBL_dV_di_si)/VaDIBL/VaDIBL);
Moc = (1.0+(diffVds/VaDIBL));
}
else
{

d_Moc_dV_di_si = d_Moc_dV_e_si = d_Moc_dV_e_di = d_Moc_dV_g_e = d_Moc_dV_g_si =  0.0;
Moc = 1.0;
}
if ((PCLM_i>0))
{
if ((PCLMG_i<0.0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-(-PCLMG_i*d_qia_dV_g_si)/((1.0/PCLM_i)-(PCLMG_i*qia))/((1.0/PCLM_i)-(PCLMG_i*qia)));
d_T1_dV_g_e = (-(-PCLMG_i*d_qia_dV_g_e)/((1.0/PCLM_i)-(PCLMG_i*qia))/((1.0/PCLM_i)-(PCLMG_i*qia)));
d_T1_dV_e_di = (-(-PCLMG_i*d_qia_dV_e_di)/((1.0/PCLM_i)-(PCLMG_i*qia))/((1.0/PCLM_i)-(PCLMG_i*qia)));
d_T1_dV_e_si = (-(-PCLMG_i*d_qia_dV_e_si)/((1.0/PCLM_i)-(PCLMG_i*qia))/((1.0/PCLM_i)-(PCLMG_i*qia)));
d_T1_dV_di_si = (-(-PCLMG_i*d_qia_dV_di_si)/((1.0/PCLM_i)-(PCLMG_i*qia))/((1.0/PCLM_i)-(PCLMG_i*qia)));
T1 = (1.0/((1.0/PCLM_i)-(PCLMG_i*qia)));
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = PCLMG_i*d_qia_dV_g_si;
d_T1_dV_g_e = PCLMG_i*d_qia_dV_g_e;
d_T1_dV_e_di = PCLMG_i*d_qia_dV_e_di;
d_T1_dV_e_si = PCLMG_i*d_qia_dV_e_si;
d_T1_dV_di_si = PCLMG_i*d_qia_dV_di_si;
T1 = (PCLM_i+(PCLMG_i*qia));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))));

d_Mclm_dV_di_si = (T1*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((Vdsat+EsatL)*((T1*(d_vds_dV_di_si-d_Vdseff_dV_di_si)-(vds-Vdseff)*d_T1_dV_di_si)/T1/T1)-((vds-Vdseff)/T1)*(d_Vdsat_dV_di_si+d_EsatL_dV_di_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+d_T1_dV_di_si*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))));
d_Mclm_dV_g_si = (T1*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((Vdsat+EsatL)*((T1*(-d_Vdseff_dV_g_si)-(vds-Vdseff)*d_T1_dV_g_si)/T1/T1)-((vds-Vdseff)/T1)*(d_Vdsat_dV_g_si+d_EsatL_dV_g_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+d_T1_dV_g_si*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))));
d_Mclm_dV_g_e = (T1*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((Vdsat+EsatL)*((T1*(-d_Vdseff_dV_g_e)-(vds-Vdseff)*d_T1_dV_g_e)/T1/T1)-((vds-Vdseff)/T1)*(d_Vdsat_dV_g_e+d_EsatL_dV_g_e))/(Vdsat+EsatL)/(Vdsat+EsatL)))+d_T1_dV_g_e*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))));
d_Mclm_dV_e_di = (T1*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((Vdsat+EsatL)*((T1*(-d_Vdseff_dV_e_di)-(vds-Vdseff)*d_T1_dV_e_di)/T1/T1)-((vds-Vdseff)/T1)*(d_Vdsat_dV_e_di+d_EsatL_dV_e_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+d_T1_dV_e_di*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))));
d_Mclm_dV_e_si = (T1*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((Vdsat+EsatL)*((T1*(-d_Vdseff_dV_e_si)-(vds-Vdseff)*d_T1_dV_e_si)/T1/T1)-((vds-Vdseff)/T1)*(d_Vdsat_dV_e_si+d_EsatL_dV_e_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+d_T1_dV_e_si*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))));
Mclm = (1.0+(T1*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))));
}
}
else
{

d_Mclm_dV_e_si = d_Mclm_dV_e_di = d_Mclm_dV_g_e = d_Mclm_dV_g_si = d_Mclm_dV_di_si =  0.0;
Mclm = 1.0;
}

d_Moc_dV_g_si = (Moc*d_Mclm_dV_g_si+d_Moc_dV_g_si*Mclm);
d_Moc_dV_g_e = (Moc*d_Mclm_dV_g_e+d_Moc_dV_g_e*Mclm);
d_Moc_dV_e_di = (Moc*d_Mclm_dV_e_di+d_Moc_dV_e_di*Mclm);
d_Moc_dV_e_si = (Moc*d_Mclm_dV_e_si+d_Moc_dV_e_si*Mclm);
d_Moc_dV_di_si = (Moc*d_Mclm_dV_di_si+d_Moc_dV_di_si*Mclm);
Moc = (Moc*Mclm);

d_Esat1_dV_e_di = (-(2.0*VSAT1_a)*d_ueff_dV_e_di/ueff/ueff);
d_Esat1_dV_e_si = (-(2.0*VSAT1_a)*d_ueff_dV_e_si/ueff/ueff);
d_Esat1_dV_g_si = (-(2.0*VSAT1_a)*d_ueff_dV_g_si/ueff/ueff);
d_Esat1_dV_g_e = (-(2.0*VSAT1_a)*d_ueff_dV_g_e/ueff/ueff);
d_Esat1_dV_di_si = ((ueff*2.0*d_VSAT1_a_dV_di_si-(2.0*VSAT1_a)*d_ueff_dV_di_si)/ueff/ueff);
Esat1 = ((2.0*VSAT1_a)/ueff);

d_Esat1L_dV_e_di = d_Esat1_dV_e_di*Leff;
d_Esat1L_dV_e_si = d_Esat1_dV_e_si*Leff;
d_Esat1L_dV_g_si = d_Esat1_dV_g_si*Leff;
d_Esat1L_dV_g_e = d_Esat1_dV_g_e*Leff;
d_Esat1L_dV_di_si = d_Esat1_dV_di_si*Leff;
Esat1L = (Esat1*Leff);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((dqi/Esat1L));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))));

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = evaluator_lexp_1.getDerivs((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))),PSAT_i*evaluator_lln_0.getDerivs((dqi/Esat1L),((Esat1L*d_dqi_dV_g_si-dqi*d_Esat1L_dV_g_si)/Esat1L/Esat1L)));
d_T0_dV_g_e = evaluator_lexp_1.getDerivs((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))),PSAT_i*evaluator_lln_0.getDerivs((dqi/Esat1L),((Esat1L*d_dqi_dV_g_e-dqi*d_Esat1L_dV_g_e)/Esat1L/Esat1L)));
d_T0_dV_e_di = evaluator_lexp_1.getDerivs((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))),PSAT_i*evaluator_lln_0.getDerivs((dqi/Esat1L),((Esat1L*d_dqi_dV_e_di-dqi*d_Esat1L_dV_e_di)/Esat1L/Esat1L)));
d_T0_dV_e_si = evaluator_lexp_1.getDerivs((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))),PSAT_i*evaluator_lln_0.getDerivs((dqi/Esat1L),((Esat1L*d_dqi_dV_e_si-dqi*d_Esat1L_dV_e_si)/Esat1L/Esat1L)));
d_T0_dV_di_si = evaluator_lexp_1.getDerivs((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))),PSAT_i*evaluator_lln_0.getDerivs((dqi/Esat1L),((Esat1L*d_dqi_dV_di_si-dqi*d_Esat1L_dV_di_si)/Esat1L/Esat1L)));
T0 = evaluator_lexp_1.getValues((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(DELTAVSAT_i);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSAT_i)*evaluator_lln_0.getValues(DELTAVSAT_i)));

d_Ta_dV_e_si = d_Ta_dV_e_di = d_Ta_dV_g_e = d_Ta_dV_g_si = d_Ta_dV_di_si =  0.0;
Ta = (1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues(DELTAVSAT_i))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((DELTAVSAT_i+T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))));

d_Dvsat_dV_di_si = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))),(1.0/PSAT_i)*evaluator_lln_0.getDerivs((DELTAVSAT_i+T0),d_T0_dV_di_si))-(1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))*d_Ta_dV_di_si)/Ta/Ta);
d_Dvsat_dV_g_si = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))),(1.0/PSAT_i)*evaluator_lln_0.getDerivs((DELTAVSAT_i+T0),d_T0_dV_g_si))-(1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))*d_Ta_dV_g_si)/Ta/Ta);
d_Dvsat_dV_g_e = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))),(1.0/PSAT_i)*evaluator_lln_0.getDerivs((DELTAVSAT_i+T0),d_T0_dV_g_e))-(1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))*d_Ta_dV_g_e)/Ta/Ta);
d_Dvsat_dV_e_di = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))),(1.0/PSAT_i)*evaluator_lln_0.getDerivs((DELTAVSAT_i+T0),d_T0_dV_e_di))-(1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))*d_Ta_dV_e_di)/Ta/Ta);
d_Dvsat_dV_e_si = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))),(1.0/PSAT_i)*evaluator_lln_0.getDerivs((DELTAVSAT_i+T0),d_T0_dV_e_si))-(1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))*d_Ta_dV_e_si)/Ta/Ta);
Dvsat = ((1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))/Ta);
}

d_Dvsat_dV_di_si = (d_Dvsat_dV_di_si+((((0.5*PTWG_a)*qia)*dqi)*d_dqi_dV_di_si+(((0.5*PTWG_a)*qia)*d_dqi_dV_di_si+((0.5*PTWG_a)*d_qia_dV_di_si+0.5*d_PTWG_a_dV_di_si*qia)*dqi)*dqi));
d_Dvsat_dV_g_si = (d_Dvsat_dV_g_si+((((0.5*PTWG_a)*qia)*dqi)*d_dqi_dV_g_si+(((0.5*PTWG_a)*qia)*d_dqi_dV_g_si+(0.5*PTWG_a)*d_qia_dV_g_si*dqi)*dqi));
d_Dvsat_dV_g_e = (d_Dvsat_dV_g_e+((((0.5*PTWG_a)*qia)*dqi)*d_dqi_dV_g_e+(((0.5*PTWG_a)*qia)*d_dqi_dV_g_e+(0.5*PTWG_a)*d_qia_dV_g_e*dqi)*dqi));
d_Dvsat_dV_e_di = (d_Dvsat_dV_e_di+((((0.5*PTWG_a)*qia)*dqi)*d_dqi_dV_e_di+(((0.5*PTWG_a)*qia)*d_dqi_dV_e_di+(0.5*PTWG_a)*d_qia_dV_e_di*dqi)*dqi));
d_Dvsat_dV_e_si = (d_Dvsat_dV_e_si+((((0.5*PTWG_a)*qia)*dqi)*d_dqi_dV_e_si+(((0.5*PTWG_a)*qia)*d_dqi_dV_e_si+(0.5*PTWG_a)*d_qia_dV_e_si*dqi)*dqi));
Dvsat = (Dvsat+((((0.5*PTWG_a)*qia)*dqi)*dqi));

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = (-A2_t*d_qia_dV_g_si/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
d_T0_dV_g_e = (-A2_t*d_qia_dV_g_e/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
d_T0_dV_e_di = (-A2_t*d_qia_dV_e_di/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
d_T0_dV_e_si = (-A2_t*d_qia_dV_e_si/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
d_T0_dV_di_si = (-A2_t*(d_qia_dV_di_si+2.0*d_nVtm_dV_di_si)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
T0 = (A1_t+(A2_t/(qia+(2.0*nVtm))));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = ((T0*dqi)*d_dqi_dV_di_si+(T0*d_dqi_dV_di_si+d_T0_dV_di_si*dqi)*dqi);
d_T1_dV_g_si = ((T0*dqi)*d_dqi_dV_g_si+(T0*d_dqi_dV_g_si+d_T0_dV_g_si*dqi)*dqi);
d_T1_dV_g_e = ((T0*dqi)*d_dqi_dV_g_e+(T0*d_dqi_dV_g_e+d_T0_dV_g_e*dqi)*dqi);
d_T1_dV_e_di = ((T0*dqi)*d_dqi_dV_e_di+(T0*d_dqi_dV_e_di+d_T0_dV_e_di*dqi)*dqi);
d_T1_dV_e_si = ((T0*dqi)*d_dqi_dV_e_si+(T0*d_dqi_dV_e_si+d_T0_dV_e_si*dqi)*dqi);
T1 = ((T0*dqi)*dqi);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = d_T1_dV_di_si;
d_T2_dV_g_si = d_T1_dV_g_si;
d_T2_dV_g_e = d_T1_dV_g_e;
d_T2_dV_e_di = d_T1_dV_e_di;
d_T2_dV_e_si = d_T1_dV_e_si;
T2 = ((T1+1.0)-0.001);
{
double value_sqrt_0 = sqrt(((T2*T2)+0.004));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = 0.5*(d_T2_dV_di_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_di_si+d_T2_dV_di_si*T2))));
d_T3_dV_e_di = 0.5*(d_T2_dV_e_di+(deriv_sqrt_0_d0*((T2*d_T2_dV_e_di+d_T2_dV_e_di*T2))));
d_T3_dV_e_si = 0.5*(d_T2_dV_e_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_e_si+d_T2_dV_e_si*T2))));
d_T3_dV_g_si = 0.5*(d_T2_dV_g_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_g_si+d_T2_dV_g_si*T2))));
d_T3_dV_g_e = 0.5*(d_T2_dV_g_e+(deriv_sqrt_0_d0*((T2*d_T2_dV_g_e+d_T2_dV_g_e*T2))));
T3 = ((-1.0)+(0.5*(T2+value_sqrt_0)));
}
{
double value_sqrt_0 = sqrt((1.0+T3));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Nsat_dV_di_si = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_di_si));
d_Nsat_dV_e_di = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_e_di));
d_Nsat_dV_e_si = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_e_si));
d_Nsat_dV_g_si = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_g_si));
d_Nsat_dV_g_e = 0.5*(deriv_sqrt_0_d0*(d_T3_dV_g_e));
Nsat = (0.5*(1.0+value_sqrt_0));
}

d_Dvsat_dV_di_si = (Dvsat*d_Nsat_dV_di_si+d_Dvsat_dV_di_si*Nsat);
d_Dvsat_dV_g_si = (Dvsat*d_Nsat_dV_g_si+d_Dvsat_dV_g_si*Nsat);
d_Dvsat_dV_g_e = (Dvsat*d_Nsat_dV_g_e+d_Dvsat_dV_g_e*Nsat);
d_Dvsat_dV_e_di = (Dvsat*d_Nsat_dV_e_di+d_Dvsat_dV_e_di*Nsat);
d_Dvsat_dV_e_si = (Dvsat*d_Nsat_dV_e_si+d_Dvsat_dV_e_si*Nsat);
Dvsat = (Dvsat*Nsat);
if ((K0_t!=0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-K0_t*K0SI_t*d_qia_dV_g_si/((K0SI_t*qia)+(2.0*nVtm))/((K0SI_t*qia)+(2.0*nVtm)));
d_T1_dV_g_e = (-K0_t*K0SI_t*d_qia_dV_g_e/((K0SI_t*qia)+(2.0*nVtm))/((K0SI_t*qia)+(2.0*nVtm)));
d_T1_dV_e_di = (-K0_t*K0SI_t*d_qia_dV_e_di/((K0SI_t*qia)+(2.0*nVtm))/((K0SI_t*qia)+(2.0*nVtm)));
d_T1_dV_e_si = (-K0_t*K0SI_t*d_qia_dV_e_si/((K0SI_t*qia)+(2.0*nVtm))/((K0SI_t*qia)+(2.0*nVtm)));
d_T1_dV_di_si = (-K0_t*(K0SI_t*d_qia_dV_di_si+2.0*d_nVtm_dV_di_si)/((K0SI_t*qia)+(2.0*nVtm))/((K0SI_t*qia)+(2.0*nVtm)));
T1 = (K0_t/((K0SI_t*qia)+(2.0*nVtm)));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));

d_Mnud_dV_di_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_si));
d_Mnud_dV_g_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_si));
d_Mnud_dV_g_e = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_e));
d_Mnud_dV_e_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_di));
d_Mnud_dV_e_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_si));
Mnud = evaluator_lexp_0.getValues((-T1));
}
}
else
{

d_Mnud_dV_e_si = d_Mnud_dV_e_di = d_Mnud_dV_g_e = d_Mnud_dV_g_si = d_Mnud_dV_di_si =  0.0;
Mnud = 1.0;
}
if (((model_.BULKMOD)!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((K1_t+(K1SAT_t*vdsx)),1.0E-6);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = evaluator_hypsmooth_0.getDerivs((K1_t+(K1SAT_t*vdsx)),1.0E-6,K1SAT_t*d_vdsx_dV_di_si,0.0);
T0 = evaluator_hypsmooth_0.getValues((K1_t+(K1SAT_t*vdsx)),1.0E-6);
}

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = ((((K1SI_t*qia)+(2.0*nVtm))*d_T0_dV_di_si-T0*(K1SI_t*d_qia_dV_di_si+2.0*d_nVtm_dV_di_si))/((K1SI_t*qia)+(2.0*nVtm))/((K1SI_t*qia)+(2.0*nVtm)));
d_T1_dV_g_si = ((((K1SI_t*qia)+(2.0*nVtm))*d_T0_dV_g_si-T0*K1SI_t*d_qia_dV_g_si)/((K1SI_t*qia)+(2.0*nVtm))/((K1SI_t*qia)+(2.0*nVtm)));
d_T1_dV_g_e = ((((K1SI_t*qia)+(2.0*nVtm))*d_T0_dV_g_e-T0*K1SI_t*d_qia_dV_g_e)/((K1SI_t*qia)+(2.0*nVtm))/((K1SI_t*qia)+(2.0*nVtm)));
d_T1_dV_e_di = ((((K1SI_t*qia)+(2.0*nVtm))*d_T0_dV_e_di-T0*K1SI_t*d_qia_dV_e_di)/((K1SI_t*qia)+(2.0*nVtm))/((K1SI_t*qia)+(2.0*nVtm)));
d_T1_dV_e_si = ((((K1SI_t*qia)+(2.0*nVtm))*d_T0_dV_e_si-T0*K1SI_t*d_qia_dV_e_si)/((K1SI_t*qia)+(2.0*nVtm))/((K1SI_t*qia)+(2.0*nVtm)));
T1 = (T0/((K1SI_t*qia)+(2.0*nVtm)));
{
double value_sqrt_0 = sqrt((PHIBE_i-veseff));
double value_sqrt_1 = sqrt(PHIBE_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si =  0.0;
d_T3_dV_di_si = (deriv_sqrt_0_d0*((-d_veseff_dV_di_si)));
d_T3_dV_e_di = (deriv_sqrt_0_d0*((-d_veseff_dV_e_di)));
d_T3_dV_e_si = (deriv_sqrt_0_d0*((-d_veseff_dV_e_si)));
T3 = (value_sqrt_0-value_sqrt_1);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-T1)*T3));

d_Mob_dV_di_si = evaluator_lexp_0.getDerivs(((-T1)*T3),((-T1)*d_T3_dV_di_si+(-d_T1_dV_di_si)*T3));
d_Mob_dV_g_si = evaluator_lexp_0.getDerivs(((-T1)*T3),((-T1)*d_T3_dV_g_si+(-d_T1_dV_g_si)*T3));
d_Mob_dV_g_e = evaluator_lexp_0.getDerivs(((-T1)*T3),((-T1)*d_T3_dV_g_e+(-d_T1_dV_g_e)*T3));
d_Mob_dV_e_di = evaluator_lexp_0.getDerivs(((-T1)*T3),((-T1)*d_T3_dV_e_di+(-d_T1_dV_e_di)*T3));
d_Mob_dV_e_si = evaluator_lexp_0.getDerivs(((-T1)*T3),((-T1)*d_T3_dV_e_si+(-d_T1_dV_e_si)*T3));
Mob = evaluator_lexp_0.getValues(((-T1)*T3));
}
}
else
{

d_Mob_dV_e_si = d_Mob_dV_e_di = d_Mob_dV_g_e = d_Mob_dV_g_si = d_Mob_dV_di_si =  0.0;
Mob = 1.0;
}

d_EsatCV_dV_di_si = ((2.0*VSATCV_t)*d_Dmob_cv_dV_di_si/u0);
d_EsatCV_dV_e_di = ((2.0*VSATCV_t)*d_Dmob_cv_dV_e_di/u0);
d_EsatCV_dV_e_si = ((2.0*VSATCV_t)*d_Dmob_cv_dV_e_si/u0);
d_EsatCV_dV_g_si = ((2.0*VSATCV_t)*d_Dmob_cv_dV_g_si/u0);
d_EsatCV_dV_g_e = ((2.0*VSATCV_t)*d_Dmob_cv_dV_g_e/u0);
EsatCV = (((2.0*VSATCV_t)*Dmob_cv)/u0);

d_EsatCVL_dV_di_si = d_EsatCV_dV_di_si*LeffCV;
d_EsatCVL_dV_e_di = d_EsatCV_dV_e_di*LeffCV;
d_EsatCVL_dV_e_si = d_EsatCV_dV_e_si*LeffCV;
d_EsatCVL_dV_g_si = d_EsatCV_dV_g_si*LeffCV;
d_EsatCVL_dV_g_e = d_EsatCV_dV_g_e*LeffCV;
EsatCVL = (EsatCV*LeffCV);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((dqi/EsatCVL));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))));

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = evaluator_lexp_1.getDerivs((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))),PSATCV_i*evaluator_lln_0.getDerivs((dqi/EsatCVL),((EsatCVL*d_dqi_dV_g_si-dqi*d_EsatCVL_dV_g_si)/EsatCVL/EsatCVL)));
d_T0_dV_g_e = evaluator_lexp_1.getDerivs((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))),PSATCV_i*evaluator_lln_0.getDerivs((dqi/EsatCVL),((EsatCVL*d_dqi_dV_g_e-dqi*d_EsatCVL_dV_g_e)/EsatCVL/EsatCVL)));
d_T0_dV_e_di = evaluator_lexp_1.getDerivs((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))),PSATCV_i*evaluator_lln_0.getDerivs((dqi/EsatCVL),((EsatCVL*d_dqi_dV_e_di-dqi*d_EsatCVL_dV_e_di)/EsatCVL/EsatCVL)));
d_T0_dV_e_si = evaluator_lexp_1.getDerivs((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))),PSATCV_i*evaluator_lln_0.getDerivs((dqi/EsatCVL),((EsatCVL*d_dqi_dV_e_si-dqi*d_EsatCVL_dV_e_si)/EsatCVL/EsatCVL)));
d_T0_dV_di_si = evaluator_lexp_1.getDerivs((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))),PSATCV_i*evaluator_lln_0.getDerivs((dqi/EsatCVL),((EsatCVL*d_dqi_dV_di_si-dqi*d_EsatCVL_dV_di_si)/EsatCVL/EsatCVL)));
T0 = evaluator_lexp_1.getValues((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(DELTAVSATCV_i);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSATCV_i)*evaluator_lln_0.getValues(DELTAVSATCV_i)));

d_Ta_dV_e_si = d_Ta_dV_e_di = d_Ta_dV_g_e = d_Ta_dV_g_si = d_Ta_dV_di_si =  0.0;
Ta = (1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues(DELTAVSATCV_i))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((DELTAVSATCV_i+T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))));

d_DvsatCV_dV_di_si = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))),(1.0/PSATCV_i)*evaluator_lln_0.getDerivs((DELTAVSATCV_i+T0),d_T0_dV_di_si))-(1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))*d_Ta_dV_di_si)/Ta/Ta);
d_DvsatCV_dV_g_si = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))),(1.0/PSATCV_i)*evaluator_lln_0.getDerivs((DELTAVSATCV_i+T0),d_T0_dV_g_si))-(1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))*d_Ta_dV_g_si)/Ta/Ta);
d_DvsatCV_dV_g_e = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))),(1.0/PSATCV_i)*evaluator_lln_0.getDerivs((DELTAVSATCV_i+T0),d_T0_dV_g_e))-(1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))*d_Ta_dV_g_e)/Ta/Ta);
d_DvsatCV_dV_e_di = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))),(1.0/PSATCV_i)*evaluator_lln_0.getDerivs((DELTAVSATCV_i+T0),d_T0_dV_e_di))-(1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))*d_Ta_dV_e_di)/Ta/Ta);
d_DvsatCV_dV_e_si = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))),(1.0/PSATCV_i)*evaluator_lln_0.getDerivs((DELTAVSATCV_i+T0),d_T0_dV_e_si))-(1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))*d_Ta_dV_e_si)/Ta/Ta);
DvsatCV = ((1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))/Ta);
}
if ((PCLMCV_i!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))));

d_MclmCV_dV_g_si = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(((Vdsat+EsatCVL)*((-d_Vdseff_dV_g_si)/PCLMCV_i)-((vds-Vdseff)/PCLMCV_i)*(d_Vdsat_dV_g_si+d_EsatCVL_dV_g_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)));
d_MclmCV_dV_g_e = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(((Vdsat+EsatCVL)*((-d_Vdseff_dV_g_e)/PCLMCV_i)-((vds-Vdseff)/PCLMCV_i)*(d_Vdsat_dV_g_e+d_EsatCVL_dV_g_e))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)));
d_MclmCV_dV_e_di = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(((Vdsat+EsatCVL)*((-d_Vdseff_dV_e_di)/PCLMCV_i)-((vds-Vdseff)/PCLMCV_i)*(d_Vdsat_dV_e_di+d_EsatCVL_dV_e_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)));
d_MclmCV_dV_e_si = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(((Vdsat+EsatCVL)*((-d_Vdseff_dV_e_si)/PCLMCV_i)-((vds-Vdseff)/PCLMCV_i)*(d_Vdsat_dV_e_si+d_EsatCVL_dV_e_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)));
d_MclmCV_dV_di_si = PCLMCV_i*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(((Vdsat+EsatCVL)*((d_vds_dV_di_si-d_Vdseff_dV_di_si)/PCLMCV_i)-((vds-Vdseff)/PCLMCV_i)*(d_Vdsat_dV_di_si+d_EsatCVL_dV_di_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)));
MclmCV = (1.0+(PCLMCV_i*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))));
}
}
else
{

d_MclmCV_dV_di_si = d_MclmCV_dV_e_si = d_MclmCV_dV_e_di = d_MclmCV_dV_g_e = d_MclmCV_dV_g_si =  0.0;
MclmCV = 1.0;
}
if (((model_.GEOMOD)!=3))
{
qb = (((((-1.60219e-19)*nbody)*(model_.HFIN))*TFIN)*LeffCV);
}
else
{
qb = ((((((-1.60219e-19)*nbody)*3.14159265358979323846)*R)*R)*LeffCV);
}
if ((((model_.GEOMOD)!=3)&&((model_.COREMOD)!=0)))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((2.0*csi)/cox);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = (g0s*d_tang0s_dV_di_si+d_g0s_dV_di_si*tang0s);
d_T1_dV_g_si = (g0s*d_tang0s_dV_g_si+d_g0s_dV_g_si*tang0s);
d_T1_dV_g_e = (g0s*d_tang0s_dV_g_e+d_g0s_dV_g_e*tang0s);
d_T1_dV_e_di = (g0s*d_tang0s_dV_e_di+d_g0s_dV_e_di*tang0s);
d_T1_dV_e_si = (g0s*d_tang0s_dV_e_si+d_g0s_dV_e_si*tang0s);
T1 = (g0s*tang0s);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = (g0d*d_tang0d_dV_di_si+d_g0d_dV_di_si*tang0d);
d_T2_dV_g_si = (g0d*d_tang0d_dV_g_si+d_g0d_dV_g_si*tang0d);
d_T2_dV_g_e = (g0d*d_tang0d_dV_g_e+d_g0d_dV_g_e*tang0d);
d_T2_dV_e_di = (g0d*d_tang0d_dV_e_di+d_g0d_dV_e_di*tang0d);
d_T2_dV_e_si = (g0d*d_tang0d_dV_e_si+d_g0d_dV_e_si*tang0d);
T2 = (g0d*tang0d);
if ((NGATE_i>0.0))
{

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (((4.0*r2)*(((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1)+(T1*d_T2_dV_di_si+d_T1_dV_di_si*T2))+(T2*d_T2_dV_di_si+d_T2_dV_di_si*T2))/3.0)+(T0*(d_T1_dV_di_si+d_T2_dV_di_si)+d_T0_dV_di_si*(T1+T2)));
d_T3_dV_g_si = (((4.0*r2)*(((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1)+(T1*d_T2_dV_g_si+d_T1_dV_g_si*T2))+(T2*d_T2_dV_g_si+d_T2_dV_g_si*T2))/3.0)+(T0*(d_T1_dV_g_si+d_T2_dV_g_si)+d_T0_dV_g_si*(T1+T2)));
d_T3_dV_g_e = (((4.0*r2)*(((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1)+(T1*d_T2_dV_g_e+d_T1_dV_g_e*T2))+(T2*d_T2_dV_g_e+d_T2_dV_g_e*T2))/3.0)+(T0*(d_T1_dV_g_e+d_T2_dV_g_e)+d_T0_dV_g_e*(T1+T2)));
d_T3_dV_e_di = (((4.0*r2)*(((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1)+(T1*d_T2_dV_e_di+d_T1_dV_e_di*T2))+(T2*d_T2_dV_e_di+d_T2_dV_e_di*T2))/3.0)+(T0*(d_T1_dV_e_di+d_T2_dV_e_di)+d_T0_dV_e_di*(T1+T2)));
d_T3_dV_e_si = (((4.0*r2)*(((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1)+(T1*d_T2_dV_e_si+d_T1_dV_e_si*T2))+(T2*d_T2_dV_e_si+d_T2_dV_e_si*T2))/3.0)+(T0*(d_T1_dV_e_si+d_T2_dV_e_si)+d_T0_dV_e_si*(T1+T2)));
T3 = ((((4.0*r2)*(((T1*T1)+(T1*T2))+(T2*T2)))/3.0)+(T0*(T1+T2)));
}
else
{

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (T0*(d_T1_dV_di_si+d_T2_dV_di_si)+d_T0_dV_di_si*(T1+T2));
d_T3_dV_g_si = (T0*(d_T1_dV_g_si+d_T2_dV_g_si)+d_T0_dV_g_si*(T1+T2));
d_T3_dV_g_e = (T0*(d_T1_dV_g_e+d_T2_dV_g_e)+d_T0_dV_g_e*(T1+T2));
d_T3_dV_e_di = (T0*(d_T1_dV_e_di+d_T2_dV_e_di)+d_T0_dV_e_di*(T1+T2));
d_T3_dV_e_si = (T0*(d_T1_dV_e_si+d_T2_dV_e_si)+d_T0_dV_e_si*(T1+T2));
T3 = (T0*(T1+T2));
}

d_T6_dV_g_di = d_T6_dV_di_d = d_T6_dV_si_s =  0.0;
d_T6_dV_di_si = ((g0s*d_g0s_dV_di_si+d_g0s_dV_di_si*g0s)-(g0d*d_g0d_dV_di_si+d_g0d_dV_di_si*g0d));
d_T6_dV_g_si = ((g0s*d_g0s_dV_g_si+d_g0s_dV_g_si*g0s)-(g0d*d_g0d_dV_g_si+d_g0d_dV_g_si*g0d));
d_T6_dV_g_e = ((g0s*d_g0s_dV_g_e+d_g0s_dV_g_e*g0s)-(g0d*d_g0d_dV_g_e+d_g0d_dV_g_e*g0d));
d_T6_dV_e_di = ((g0s*d_g0s_dV_e_di+d_g0s_dV_e_di*g0s)-(g0d*d_g0d_dV_e_di+d_g0d_dV_e_di*g0d));
d_T6_dV_e_si = ((g0s*d_g0s_dV_e_si+d_g0s_dV_e_si*g0s)-(g0d*d_g0d_dV_e_si+d_g0d_dV_e_si*g0d));
T6 = ((g0s*g0s)-(g0d*g0d));

d_ids0_dV_g_di =  0.0;
d_ids0_dV_di_si = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(d_T1_dV_di_si-d_T2_dV_di_si)+d_T3_dV_di_si*(T1-T2))-d_T6_dV_di_si)+(((2.0*T0)*nVtm)*d_nVtm_dV_di_si+((2.0*T0)*d_nVtm_dV_di_si+2.0*d_T0_dV_di_si*nVtm)*nVtm)*(((T3+2.0)*(T1-T2))-T6));
d_ids0_dV_g_si = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(d_T1_dV_g_si-d_T2_dV_g_si)+d_T3_dV_g_si*(T1-T2))-d_T6_dV_g_si)+2.0*d_T0_dV_g_si*nVtm*nVtm*(((T3+2.0)*(T1-T2))-T6));
d_ids0_dV_g_e = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(d_T1_dV_g_e-d_T2_dV_g_e)+d_T3_dV_g_e*(T1-T2))-d_T6_dV_g_e)+2.0*d_T0_dV_g_e*nVtm*nVtm*(((T3+2.0)*(T1-T2))-T6));
d_ids0_dV_e_di = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(d_T1_dV_e_di-d_T2_dV_e_di)+d_T3_dV_e_di*(T1-T2))-d_T6_dV_e_di)+2.0*d_T0_dV_e_di*nVtm*nVtm*(((T3+2.0)*(T1-T2))-T6));
d_ids0_dV_e_si = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(d_T1_dV_e_si-d_T2_dV_e_si)+d_T3_dV_e_si*(T1-T2))-d_T6_dV_e_si)+2.0*d_T0_dV_e_si*nVtm*nVtm*(((T3+2.0)*(T1-T2))-T6));
ids0 = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(T1-T2))-T6));

d_ids0_ov_dqi_dV_g_di =  0.0;
d_ids0_ov_dqi_dV_e_di = (0.5*nVtm)*d_T3_dV_e_di;
d_ids0_ov_dqi_dV_e_si = (0.5*nVtm)*d_T3_dV_e_si;
d_ids0_ov_dqi_dV_g_si = (0.5*nVtm)*d_T3_dV_g_si;
d_ids0_ov_dqi_dV_g_e = (0.5*nVtm)*d_T3_dV_g_e;
d_ids0_ov_dqi_dV_di_si = ((0.5*nVtm)*d_T3_dV_di_si+0.5*d_nVtm_dV_di_si*(T3+1.0));
ids0_ov_dqi = ((0.5*nVtm)*(T3+1.0));
if (((model_.RDSMOD)!=0))
{

d_Rdsi_dV_g_di = d_Rdsi_dV_e_si = d_Rdsi_dV_e_di = d_Rdsi_dV_g_e = d_Rdsi_dV_g_si = d_Rdsi_dV_di_si =  0.0;
Rdsi = 0.0;

d_Dr_dV_e_si = d_Dr_dV_e_di = d_Dr_dV_g_e = d_Dr_dV_g_si = d_Dr_dV_di_si = d_Dr_dV_g_di =  0.0;
Dr = 1.0;

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_g_si = d_vgs_noswap_dV_g_si;
T2 = (vgs_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_si+d_T2_dV_di_si*T2)));
d_T3_dV_e_di = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_di+d_T2_dV_e_di*T2)));
d_T3_dV_e_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_si+d_T2_dV_e_si*T2)));
d_T3_dV_g_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_si+d_T2_dV_g_si*T2)));
d_T3_dV_g_e = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_e+d_T2_dV_g_e*T2)));
T3 = value_sqrt_0;
}

d_vgs_eff_dV_g_di =  0.0;
d_vgs_eff_dV_di_si = 0.5*(d_T2_dV_di_si+d_T3_dV_di_si);
d_vgs_eff_dV_e_di = 0.5*(d_T2_dV_e_di+d_T3_dV_e_di);
d_vgs_eff_dV_e_si = 0.5*(d_T2_dV_e_si+d_T3_dV_e_si);
d_vgs_eff_dV_g_si = 0.5*(d_T2_dV_g_si+d_T3_dV_g_si);
d_vgs_eff_dV_g_e = 0.5*(d_T2_dV_g_e+d_T3_dV_g_e);
vgs_eff = (0.5*(T2+T3));

d_T4_dV_g_di =  0.0;
d_T4_dV_di_si = PRWGS_i*d_vgs_eff_dV_di_si;
d_T4_dV_e_di = PRWGS_i*d_vgs_eff_dV_e_di;
d_T4_dV_e_si = PRWGS_i*d_vgs_eff_dV_e_si;
d_T4_dV_g_si = PRWGS_i*d_vgs_eff_dV_g_si;
d_T4_dV_g_e = PRWGS_i*d_vgs_eff_dV_g_e;
T4 = (1.0+(PRWGS_i*vgs_eff));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-d_T4_dV_g_si/T4/T4);
d_T1_dV_g_e = (-d_T4_dV_g_e/T4/T4);
d_T1_dV_e_di = (-d_T4_dV_e_di/T4/T4);
d_T1_dV_e_si = (-d_T4_dV_e_si/T4/T4);
d_T1_dV_di_si = (-d_T4_dV_di_si/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = 0.5*(d_T1_dV_di_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1))));
d_T0_dV_g_si = 0.5*(d_T1_dV_g_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1))));
d_T0_dV_g_e = 0.5*(d_T1_dV_g_e+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1))));
d_T0_dV_e_di = 0.5*(d_T1_dV_e_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1))));
d_T0_dV_e_si = 0.5*(d_T1_dV_e_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1))));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_e_si = d_T5_dV_e_di = d_T5_dV_g_e = d_T5_dV_g_si =  0.0;
d_T5_dV_si_s = RSW_i*RSDR_a*evaluator_lexp_1.getDerivs(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))),(0.5*(model_.PRSDR))*evaluator_lln_0.getDerivs((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6),((probeVars[admsProbeID_V_si_s])*d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]+d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]*(probeVars[admsProbeID_V_si_s]))));
d_T5_dV_di_si = RSW_i*d_RSDR_a_dV_di_si*evaluator_lexp_1.getValues(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))));
T5 = (RSW_i*(1.0+(RSDR_a*evaluator_lexp_1.getValues(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
}

d_Rsource_dV_di_d = d_Rsource_dV_g_di =  0.0;
d_Rsource_dV_di_si = rdstemp*(T5*d_T0_dV_di_si+d_T5_dV_di_si*T0)*WeffWRFactor;
d_Rsource_dV_g_si = rdstemp*(T5*d_T0_dV_g_si+d_T5_dV_g_si*T0)*WeffWRFactor;
d_Rsource_dV_g_e = rdstemp*(T5*d_T0_dV_g_e+d_T5_dV_g_e*T0)*WeffWRFactor;
d_Rsource_dV_e_di = rdstemp*(T5*d_T0_dV_e_di+d_T5_dV_e_di*T0)*WeffWRFactor;
d_Rsource_dV_e_si = rdstemp*(T5*d_T0_dV_e_si+d_T5_dV_e_si*T0)*WeffWRFactor;
d_Rsource_dV_si_s = rdstemp*d_T5_dV_si_s*T0*WeffWRFactor;
Rsource = (rdstemp*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_g_di = d_vgd_noswap_dV_g_di;
T2 = (vgd_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_di_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_si+d_T2_dV_di_si*T2)));
d_T3_dV_e_di = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_di+d_T2_dV_e_di*T2)));
d_T3_dV_e_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_si+d_T2_dV_e_si*T2)));
d_T3_dV_g_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_si+d_T2_dV_g_si*T2)));
d_T3_dV_g_e = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_e+d_T2_dV_g_e*T2)));
d_T3_dV_g_di = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_di+d_T2_dV_g_di*T2)));
T3 = value_sqrt_0;
}

d_vgd_eff_dV_di_si = 0.5*(d_T2_dV_di_si+d_T3_dV_di_si);
d_vgd_eff_dV_e_di = 0.5*(d_T2_dV_e_di+d_T3_dV_e_di);
d_vgd_eff_dV_e_si = 0.5*(d_T2_dV_e_si+d_T3_dV_e_si);
d_vgd_eff_dV_g_si = 0.5*(d_T2_dV_g_si+d_T3_dV_g_si);
d_vgd_eff_dV_g_e = 0.5*(d_T2_dV_g_e+d_T3_dV_g_e);
d_vgd_eff_dV_g_di = 0.5*(d_T2_dV_g_di+d_T3_dV_g_di);
vgd_eff = (0.5*(T2+T3));

d_T4_dV_di_si = PRWGD_i*d_vgd_eff_dV_di_si;
d_T4_dV_e_di = PRWGD_i*d_vgd_eff_dV_e_di;
d_T4_dV_e_si = PRWGD_i*d_vgd_eff_dV_e_si;
d_T4_dV_g_si = PRWGD_i*d_vgd_eff_dV_g_si;
d_T4_dV_g_e = PRWGD_i*d_vgd_eff_dV_g_e;
d_T4_dV_g_di = PRWGD_i*d_vgd_eff_dV_g_di;
T4 = (1.0+(PRWGD_i*vgd_eff));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_si = (-d_T4_dV_g_si/T4/T4);
d_T1_dV_g_e = (-d_T4_dV_g_e/T4/T4);
d_T1_dV_e_di = (-d_T4_dV_e_di/T4/T4);
d_T1_dV_e_si = (-d_T4_dV_e_si/T4/T4);
d_T1_dV_di_si = (-d_T4_dV_di_si/T4/T4);
d_T1_dV_g_di = (-d_T4_dV_g_di/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_di_si = 0.5*(d_T1_dV_di_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1))));
d_T0_dV_g_si = 0.5*(d_T1_dV_g_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1))));
d_T0_dV_g_e = 0.5*(d_T1_dV_g_e+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1))));
d_T0_dV_e_di = 0.5*(d_T1_dV_e_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1))));
d_T0_dV_e_si = 0.5*(d_T1_dV_e_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1))));
d_T0_dV_g_di = 0.5*(d_T1_dV_g_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_di+d_T1_dV_g_di*T1))));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))));

d_T5_dV_g_di = d_T5_dV_si_s = d_T5_dV_e_si = d_T5_dV_e_di = d_T5_dV_g_e = d_T5_dV_g_si =  0.0;
d_T5_dV_di_d = RDW_i*RDDR_a*evaluator_lexp_1.getDerivs(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))),(0.5*(model_.PRDDR))*evaluator_lln_0.getDerivs((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6),((probeVars[admsProbeID_V_di_d])*d_probeVars[admsProbeID_V_di_d][admsProbeID_V_di_d]+d_probeVars[admsProbeID_V_di_d][admsProbeID_V_di_d]*(probeVars[admsProbeID_V_di_d]))));
d_T5_dV_di_si = RDW_i*d_RDDR_a_dV_di_si*evaluator_lexp_1.getValues(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))));
T5 = (RDW_i*(1.0+(RDDR_a*evaluator_lexp_1.getValues(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
}

d_Rdrain_dV_g_di = rdstemp*(T5*d_T0_dV_g_di+d_T5_dV_g_di*T0)*WeffWRFactor;
d_Rdrain_dV_di_si = rdstemp*(T5*d_T0_dV_di_si+d_T5_dV_di_si*T0)*WeffWRFactor;
d_Rdrain_dV_g_si = rdstemp*(T5*d_T0_dV_g_si+d_T5_dV_g_si*T0)*WeffWRFactor;
d_Rdrain_dV_g_e = rdstemp*(T5*d_T0_dV_g_e+d_T5_dV_g_e*T0)*WeffWRFactor;
d_Rdrain_dV_e_di = rdstemp*(T5*d_T0_dV_e_di+d_T5_dV_e_di*T0)*WeffWRFactor;
d_Rdrain_dV_e_si = rdstemp*(T5*d_T0_dV_e_si+d_T5_dV_e_si*T0)*WeffWRFactor;
d_Rdrain_dV_si_s = rdstemp*d_T5_dV_si_s*T0*WeffWRFactor;
d_Rdrain_dV_di_d = rdstemp*d_T5_dV_di_d*T0*WeffWRFactor;
Rdrain = (rdstemp*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
}
else
{

d_Rsource_dV_di_d = d_Rsource_dV_g_di = d_Rsource_dV_si_s = d_Rsource_dV_e_si = d_Rsource_dV_e_di = d_Rsource_dV_g_e = d_Rsource_dV_g_si = d_Rsource_dV_di_si =  0.0;
Rsource = RSourceGeo;

d_Rdrain_dV_di_d = d_Rdrain_dV_si_s = d_Rdrain_dV_e_si = d_Rdrain_dV_e_di = d_Rdrain_dV_g_e = d_Rdrain_dV_g_si = d_Rdrain_dV_di_si = d_Rdrain_dV_g_di =  0.0;
Rdrain = RDrainGeo;

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = PRWGS_i*d_qia_dV_g_si;
d_T4_dV_g_e = PRWGS_i*d_qia_dV_g_e;
d_T4_dV_e_di = PRWGS_i*d_qia_dV_e_di;
d_T4_dV_e_si = PRWGS_i*d_qia_dV_e_si;
d_T4_dV_di_si = PRWGS_i*d_qia_dV_di_si;
T4 = (1.0+(PRWGS_i*qia));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_si = (-d_T4_dV_g_si/T4/T4);
d_T1_dV_g_e = (-d_T4_dV_g_e/T4/T4);
d_T1_dV_e_di = (-d_T4_dV_e_di/T4/T4);
d_T1_dV_e_si = (-d_T4_dV_e_si/T4/T4);
d_T1_dV_di_si = (-d_T4_dV_di_si/T4/T4);
d_T1_dV_g_di = (-d_T4_dV_g_di/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_di_si = 0.5*(d_T1_dV_di_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1))));
d_T0_dV_g_si = 0.5*(d_T1_dV_g_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1))));
d_T0_dV_g_e = 0.5*(d_T1_dV_g_e+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1))));
d_T0_dV_e_di = 0.5*(d_T1_dV_e_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1))));
d_T0_dV_e_si = 0.5*(d_T1_dV_e_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1))));
d_T0_dV_g_di = 0.5*(d_T1_dV_g_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_di+d_T1_dV_g_di*T1))));
T0 = (0.5*(T1+value_sqrt_0));
}

d_Rdsi_dV_di_si = rdstemp*RDSW_i*d_T0_dV_di_si*WeffWRFactor;
d_Rdsi_dV_g_si = rdstemp*RDSW_i*d_T0_dV_g_si*WeffWRFactor;
d_Rdsi_dV_g_e = rdstemp*RDSW_i*d_T0_dV_g_e*WeffWRFactor;
d_Rdsi_dV_e_di = rdstemp*RDSW_i*d_T0_dV_e_di*WeffWRFactor;
d_Rdsi_dV_e_si = rdstemp*RDSW_i*d_T0_dV_e_si*WeffWRFactor;
d_Rdsi_dV_g_di = rdstemp*RDSW_i*d_T0_dV_g_di*WeffWRFactor;
Rdsi = ((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);

d_Dr_dV_g_di = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_g_di+((NFINtotal*beta)*d_ids0_ov_dqi_dV_g_di/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_di_si = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_di_si+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_di_si+NFINtotal*d_beta_dV_di_si*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_di_si+d_Dmob_dV_di_si*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_g_si = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_g_si+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_g_si+NFINtotal*d_beta_dV_g_si*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_g_si+d_Dmob_dV_g_si*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_g_e = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_g_e+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_g_e+NFINtotal*d_beta_dV_g_e*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_g_e+d_Dmob_dV_g_e*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_e_di = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_e_di+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_e_di+NFINtotal*d_beta_dV_e_di*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_e_di+d_Dmob_dV_e_di*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_e_si = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_e_si+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_e_si+NFINtotal*d_beta_dV_e_si*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_e_si+d_Dmob_dV_e_si*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
Dr = (1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
}

d_ids_dV_g_di = ((((Dmob*Dvsat)*Dr)*(NFINtotal*beta)*d_ids0_dV_g_di*Moc*Mob*Mnud-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*(Dmob*Dvsat)*d_Dr_dV_g_di)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_di_si = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_di_si+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_di_si+(((NFINtotal*beta)*ids0)*d_Moc_dV_di_si+((NFINtotal*beta)*d_ids0_dV_di_si+NFINtotal*d_beta_dV_di_si*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_di_si+(Dmob*d_Dvsat_dV_di_si+d_Dmob_dV_di_si*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_g_si = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_g_si+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_g_si+(((NFINtotal*beta)*ids0)*d_Moc_dV_g_si+((NFINtotal*beta)*d_ids0_dV_g_si+NFINtotal*d_beta_dV_g_si*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_g_si+(Dmob*d_Dvsat_dV_g_si+d_Dmob_dV_g_si*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_g_e = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_g_e+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_g_e+(((NFINtotal*beta)*ids0)*d_Moc_dV_g_e+((NFINtotal*beta)*d_ids0_dV_g_e+NFINtotal*d_beta_dV_g_e*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_g_e+(Dmob*d_Dvsat_dV_g_e+d_Dmob_dV_g_e*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_e_di = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_e_di+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_e_di+(((NFINtotal*beta)*ids0)*d_Moc_dV_e_di+((NFINtotal*beta)*d_ids0_dV_e_di+NFINtotal*d_beta_dV_e_di*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_e_di+(Dmob*d_Dvsat_dV_e_di+d_Dmob_dV_e_di*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_e_si = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_e_si+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_e_si+(((NFINtotal*beta)*ids0)*d_Moc_dV_e_si+((NFINtotal*beta)*d_ids0_dV_e_si+NFINtotal*d_beta_dV_e_si*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_e_si+(Dmob*d_Dvsat_dV_e_si+d_Dmob_dV_e_si*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
ids = ((((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)/((Dmob*Dvsat)*Dr));

d_ids_dV_g_di = d_ids_dV_g_di*(model_.IDS0MULT);
d_ids_dV_di_si = d_ids_dV_di_si*(model_.IDS0MULT);
d_ids_dV_g_si = d_ids_dV_g_si*(model_.IDS0MULT);
d_ids_dV_g_e = d_ids_dV_g_e*(model_.IDS0MULT);
d_ids_dV_e_di = d_ids_dV_e_di*(model_.IDS0MULT);
d_ids_dV_e_si = d_ids_dV_e_si*(model_.IDS0MULT);
ids = (ids*(model_.IDS0MULT));
if ((NGATE_i>0.0))
{

d_Tcom_dV_g_si = (((qis*d_qis_dV_g_si+d_qis_dV_g_si*qis)+(qis*d_qid_dV_g_si+d_qis_dV_g_si*qid))+(qid*d_qid_dV_g_si+d_qid_dV_g_si*qid));
d_Tcom_dV_g_e = (((qis*d_qis_dV_g_e+d_qis_dV_g_e*qis)+(qis*d_qid_dV_g_e+d_qis_dV_g_e*qid))+(qid*d_qid_dV_g_e+d_qid_dV_g_e*qid));
d_Tcom_dV_e_di = (((qis*d_qis_dV_e_di+d_qis_dV_e_di*qis)+(qis*d_qid_dV_e_di+d_qis_dV_e_di*qid))+(qid*d_qid_dV_e_di+d_qid_dV_e_di*qid));
d_Tcom_dV_e_si = (((qis*d_qis_dV_e_si+d_qis_dV_e_si*qis)+(qis*d_qid_dV_e_si+d_qis_dV_e_si*qid))+(qid*d_qid_dV_e_si+d_qid_dV_e_si*qid));
d_Tcom_dV_di_si = (((qis*d_qis_dV_di_si+d_qis_dV_di_si*qis)+(qis*d_qid_dV_di_si+d_qis_dV_di_si*qid))+(qid*d_qid_dV_di_si+d_qid_dV_di_si*qid));
Tcom = (((qis*qis)+(qis*qid))+(qid*qid));
}
else
{

d_Tcom_dV_di_si = d_Tcom_dV_e_si = d_Tcom_dV_e_di = d_Tcom_dV_g_e = d_Tcom_dV_g_si =  0.0;
Tcom = 0.0;
}
if ((NGATE_i>0))
{

d_idscv_dV_g_si = ((((2.0*cpoly)*d_Tcom_dV_g_si/3.0)+kpoly*d_qia_dV_g_si)+(-d_etaiv_dV_g_si)*nVtm);
d_idscv_dV_g_e = ((((2.0*cpoly)*d_Tcom_dV_g_e/3.0)+kpoly*d_qia_dV_g_e)+(-d_etaiv_dV_g_e)*nVtm);
d_idscv_dV_e_di = ((((2.0*cpoly)*d_Tcom_dV_e_di/3.0)+kpoly*d_qia_dV_e_di)+(-d_etaiv_dV_e_di)*nVtm);
d_idscv_dV_e_si = ((((2.0*cpoly)*d_Tcom_dV_e_si/3.0)+kpoly*d_qia_dV_e_si)+(-d_etaiv_dV_e_si)*nVtm);
d_idscv_dV_di_si = ((((2.0*cpoly)*d_Tcom_dV_di_si/3.0)+kpoly*d_qia_dV_di_si)+((2.0-etaiv)*d_nVtm_dV_di_si+(-d_etaiv_dV_di_si)*nVtm));
idscv = (((((2.0*cpoly)*Tcom)/3.0)+(kpoly*qia))+((2.0-etaiv)*nVtm));
}
else
{

d_idscv_dV_g_si = (d_qia_dV_g_si+(-d_etaiv_dV_g_si)*nVtm);
d_idscv_dV_g_e = (d_qia_dV_g_e+(-d_etaiv_dV_g_e)*nVtm);
d_idscv_dV_e_di = (d_qia_dV_e_di+(-d_etaiv_dV_e_di)*nVtm);
d_idscv_dV_e_si = (d_qia_dV_e_si+(-d_etaiv_dV_e_si)*nVtm);
d_idscv_dV_di_si = (d_qia_dV_di_si+((2.0-etaiv)*d_nVtm_dV_di_si+(-d_etaiv_dV_di_si)*nVtm));
idscv = (qia+((2.0-etaiv)*nVtm));
}

d_idscv_dV_g_si = ((DvsatCV*d_idscv_dV_g_si-idscv*d_DvsatCV_dV_g_si)/DvsatCV/DvsatCV);
d_idscv_dV_g_e = ((DvsatCV*d_idscv_dV_g_e-idscv*d_DvsatCV_dV_g_e)/DvsatCV/DvsatCV);
d_idscv_dV_e_di = ((DvsatCV*d_idscv_dV_e_di-idscv*d_DvsatCV_dV_e_di)/DvsatCV/DvsatCV);
d_idscv_dV_e_si = ((DvsatCV*d_idscv_dV_e_si-idscv*d_DvsatCV_dV_e_si)/DvsatCV/DvsatCV);
d_idscv_dV_di_si = ((DvsatCV*d_idscv_dV_di_si-idscv*d_DvsatCV_dV_di_si)/DvsatCV/DvsatCV);
idscv = (idscv/DvsatCV);
beta_cv = (((u0*coxeff)*WeffCV)/LeffCV);

d_dqi_idscv_dV_g_si = ((idscv*d_dqi_dV_g_si-dqi*d_idscv_dV_g_si)/idscv/idscv);
d_dqi_idscv_dV_g_e = ((idscv*d_dqi_dV_g_e-dqi*d_idscv_dV_g_e)/idscv/idscv);
d_dqi_idscv_dV_e_di = ((idscv*d_dqi_dV_e_di-dqi*d_idscv_dV_e_di)/idscv/idscv);
d_dqi_idscv_dV_e_si = ((idscv*d_dqi_dV_e_si-dqi*d_idscv_dV_e_si)/idscv/idscv);
d_dqi_idscv_dV_di_si = ((idscv*d_dqi_dV_di_si-dqi*d_idscv_dV_di_si)/idscv/idscv);
dqi_idscv = (dqi/idscv);
if ((NGATE_i>0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (4.0*cpoly)*d_qia_dV_g_si;
d_T1_dV_g_e = (4.0*cpoly)*d_qia_dV_g_e;
d_T1_dV_e_di = (4.0*cpoly)*d_qia_dV_e_di;
d_T1_dV_e_si = (4.0*cpoly)*d_qia_dV_e_si;
d_T1_dV_di_si = (4.0*cpoly)*d_qia_dV_di_si;
T1 = (kpoly+((4.0*cpoly)*qia));
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = 1.0;
}

d_qg_dV_g_di = (d_T1_dV_g_di*dqi*dqi_idscv/12.0);
d_qg_dV_g_si = (d_qia_dV_g_si+(((T1*dqi)*d_dqi_idscv_dV_g_si+(T1*d_dqi_dV_g_si+d_T1_dV_g_si*dqi)*dqi_idscv)/12.0));
d_qg_dV_g_e = (d_qia_dV_g_e+(((T1*dqi)*d_dqi_idscv_dV_g_e+(T1*d_dqi_dV_g_e+d_T1_dV_g_e*dqi)*dqi_idscv)/12.0));
d_qg_dV_e_di = (d_qia_dV_e_di+(((T1*dqi)*d_dqi_idscv_dV_e_di+(T1*d_dqi_dV_e_di+d_T1_dV_e_di*dqi)*dqi_idscv)/12.0));
d_qg_dV_e_si = (d_qia_dV_e_si+(((T1*dqi)*d_dqi_idscv_dV_e_si+(T1*d_dqi_dV_e_si+d_T1_dV_e_si*dqi)*dqi_idscv)/12.0));
d_qg_dV_di_si = (d_qia_dV_di_si+(((T1*dqi)*d_dqi_idscv_dV_di_si+(T1*d_dqi_dV_di_si+d_T1_dV_di_si*dqi)*dqi_idscv)/12.0));
qg = (qia+(((T1*dqi)*dqi_idscv)/12.0));
if ((NGATE_i>0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = cpoly*(32.0*d_qid_dV_g_si+28.0*d_qis_dV_g_si);
d_T1_dV_g_e = cpoly*(32.0*d_qid_dV_g_e+28.0*d_qis_dV_g_e);
d_T1_dV_e_di = cpoly*(32.0*d_qid_dV_e_di+28.0*d_qis_dV_e_di);
d_T1_dV_e_si = cpoly*(32.0*d_qid_dV_e_si+28.0*d_qis_dV_e_si);
d_T1_dV_di_si = cpoly*(32.0*d_qid_dV_di_si+28.0*d_qis_dV_di_si);
T1 = ((15.0*kpoly)+(cpoly*((32.0*qid)+(28.0*qis))));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_g_si = (((126.0*cpoly)*kpoly)*d_qia_dV_g_si+(cpoly*cpoly)*(256.0*d_Tcom_dV_g_si+((240.0*qis)*d_qid_dV_g_si+240.0*d_qis_dV_g_si*qid)));
d_T2_dV_g_e = (((126.0*cpoly)*kpoly)*d_qia_dV_g_e+(cpoly*cpoly)*(256.0*d_Tcom_dV_g_e+((240.0*qis)*d_qid_dV_g_e+240.0*d_qis_dV_g_e*qid)));
d_T2_dV_e_di = (((126.0*cpoly)*kpoly)*d_qia_dV_e_di+(cpoly*cpoly)*(256.0*d_Tcom_dV_e_di+((240.0*qis)*d_qid_dV_e_di+240.0*d_qis_dV_e_di*qid)));
d_T2_dV_e_si = (((126.0*cpoly)*kpoly)*d_qia_dV_e_si+(cpoly*cpoly)*(256.0*d_Tcom_dV_e_si+((240.0*qis)*d_qid_dV_e_si+240.0*d_qis_dV_e_si*qid)));
d_T2_dV_di_si = (((126.0*cpoly)*kpoly)*d_qia_dV_di_si+(cpoly*cpoly)*(256.0*d_Tcom_dV_di_si+((240.0*qis)*d_qid_dV_di_si+240.0*d_qis_dV_di_si*qid)));
T2 = ((((63.0*kpoly)*kpoly)+(((126.0*cpoly)*kpoly)*qia))+((cpoly*cpoly)*((256.0*Tcom)+((240.0*qis)*qid))));
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = 15.0;

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = 63.0;
}

d_qd_dV_g_di = (-(dqi*((-(d_T1_dV_g_di*dqi_idscv/30.0))-(d_T2_dV_g_di*dqi_idscv*dqi_idscv/1260.0))/12.0));
d_qd_dV_g_si = (0.5*d_qia_dV_g_si-((dqi*((-((T1*d_dqi_idscv_dV_g_si+d_T1_dV_g_si*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_g_si+(T2*d_dqi_idscv_dV_g_si+d_T2_dV_g_si*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_g_si*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_g_e = (0.5*d_qia_dV_g_e-((dqi*((-((T1*d_dqi_idscv_dV_g_e+d_T1_dV_g_e*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_g_e+(T2*d_dqi_idscv_dV_g_e+d_T2_dV_g_e*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_g_e*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_e_di = (0.5*d_qia_dV_e_di-((dqi*((-((T1*d_dqi_idscv_dV_e_di+d_T1_dV_e_di*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_e_di+(T2*d_dqi_idscv_dV_e_di+d_T2_dV_e_di*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_e_di*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_e_si = (0.5*d_qia_dV_e_si-((dqi*((-((T1*d_dqi_idscv_dV_e_si+d_T1_dV_e_si*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_e_si+(T2*d_dqi_idscv_dV_e_si+d_T2_dV_e_si*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_e_si*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_di_si = (0.5*d_qia_dV_di_si-((dqi*((-((T1*d_dqi_idscv_dV_di_si+d_T1_dV_di_si*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_di_si+(T2*d_dqi_idscv_dV_di_si+d_T2_dV_di_si*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_di_si*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
qd = ((0.5*qia)-((dqi*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));

d_inv_MclmCV_dV_g_si = (-d_MclmCV_dV_g_si/MclmCV/MclmCV);
d_inv_MclmCV_dV_g_e = (-d_MclmCV_dV_g_e/MclmCV/MclmCV);
d_inv_MclmCV_dV_e_di = (-d_MclmCV_dV_e_di/MclmCV/MclmCV);
d_inv_MclmCV_dV_e_si = (-d_MclmCV_dV_e_si/MclmCV/MclmCV);
d_inv_MclmCV_dV_di_si = (-d_MclmCV_dV_di_si/MclmCV/MclmCV);
inv_MclmCV = (1.0/MclmCV);

d_qg_dV_g_di = inv_MclmCV*d_qg_dV_g_di;
d_qg_dV_g_si = ((inv_MclmCV*d_qg_dV_g_si+d_inv_MclmCV_dV_g_si*qg)+((MclmCV-1.0)*d_qid_dV_g_si+d_MclmCV_dV_g_si*qid));
d_qg_dV_g_e = ((inv_MclmCV*d_qg_dV_g_e+d_inv_MclmCV_dV_g_e*qg)+((MclmCV-1.0)*d_qid_dV_g_e+d_MclmCV_dV_g_e*qid));
d_qg_dV_e_di = ((inv_MclmCV*d_qg_dV_e_di+d_inv_MclmCV_dV_e_di*qg)+((MclmCV-1.0)*d_qid_dV_e_di+d_MclmCV_dV_e_di*qid));
d_qg_dV_e_si = ((inv_MclmCV*d_qg_dV_e_si+d_inv_MclmCV_dV_e_si*qg)+((MclmCV-1.0)*d_qid_dV_e_si+d_MclmCV_dV_e_si*qid));
d_qg_dV_di_si = ((inv_MclmCV*d_qg_dV_di_si+d_inv_MclmCV_dV_di_si*qg)+((MclmCV-1.0)*d_qid_dV_di_si+d_MclmCV_dV_di_si*qid));
qg = ((inv_MclmCV*qg)+((MclmCV-1.0)*qid));

d_qd_dV_g_di = (inv_MclmCV*inv_MclmCV)*d_qd_dV_g_di;
d_qd_dV_g_si = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_g_si+(inv_MclmCV*d_inv_MclmCV_dV_g_si+d_inv_MclmCV_dV_g_si*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_g_si+0.5*(d_MclmCV_dV_g_si-d_inv_MclmCV_dV_g_si)*qid));
d_qd_dV_g_e = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_g_e+(inv_MclmCV*d_inv_MclmCV_dV_g_e+d_inv_MclmCV_dV_g_e*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_g_e+0.5*(d_MclmCV_dV_g_e-d_inv_MclmCV_dV_g_e)*qid));
d_qd_dV_e_di = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_e_di+(inv_MclmCV*d_inv_MclmCV_dV_e_di+d_inv_MclmCV_dV_e_di*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_e_di+0.5*(d_MclmCV_dV_e_di-d_inv_MclmCV_dV_e_di)*qid));
d_qd_dV_e_si = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_e_si+(inv_MclmCV*d_inv_MclmCV_dV_e_si+d_inv_MclmCV_dV_e_si*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_e_si+0.5*(d_MclmCV_dV_e_si-d_inv_MclmCV_dV_e_si)*qid));
d_qd_dV_di_si = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_di_si+(inv_MclmCV*d_inv_MclmCV_dV_di_si+d_inv_MclmCV_dV_di_si*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_di_si+0.5*(d_MclmCV_dV_di_si-d_inv_MclmCV_dV_di_si)*qid));
qd = (((inv_MclmCV*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*qid));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = ((WeffCV*LeffCV)*d_coxeff_dV_di_si+d_WeffCV_dV_di_si*LeffCV*coxeff);
d_T1_dV_g_si = ((WeffCV*LeffCV)*d_coxeff_dV_g_si+d_WeffCV_dV_g_si*LeffCV*coxeff);
d_T1_dV_g_e = ((WeffCV*LeffCV)*d_coxeff_dV_g_e+d_WeffCV_dV_g_e*LeffCV*coxeff);
d_T1_dV_e_di = ((WeffCV*LeffCV)*d_coxeff_dV_e_di+d_WeffCV_dV_e_di*LeffCV*coxeff);
d_T1_dV_e_si = ((WeffCV*LeffCV)*d_coxeff_dV_e_si+d_WeffCV_dV_e_si*LeffCV*coxeff);
T1 = ((WeffCV*LeffCV)*coxeff);

d_qinv_dV_g_di = ((NFINtotal*qg)*d_T1_dV_g_di+NFINtotal*d_qg_dV_g_di*T1);
d_qinv_dV_g_si = ((NFINtotal*qg)*d_T1_dV_g_si+NFINtotal*d_qg_dV_g_si*T1);
d_qinv_dV_g_e = ((NFINtotal*qg)*d_T1_dV_g_e+NFINtotal*d_qg_dV_g_e*T1);
d_qinv_dV_e_di = ((NFINtotal*qg)*d_T1_dV_e_di+NFINtotal*d_qg_dV_e_di*T1);
d_qinv_dV_e_si = ((NFINtotal*qg)*d_T1_dV_e_si+NFINtotal*d_qg_dV_e_si*T1);
d_qinv_dV_di_si = ((NFINtotal*qg)*d_T1_dV_di_si+NFINtotal*d_qg_dV_di_si*T1);
qinv = ((NFINtotal*qg)*T1);

d_qd_dV_g_di = ((NFINtotal*qd)*d_T1_dV_g_di+NFINtotal*d_qd_dV_g_di*T1);
d_qd_dV_g_si = ((NFINtotal*qd)*d_T1_dV_g_si+NFINtotal*d_qd_dV_g_si*T1);
d_qd_dV_g_e = ((NFINtotal*qd)*d_T1_dV_g_e+NFINtotal*d_qd_dV_g_e*T1);
d_qd_dV_e_di = ((NFINtotal*qd)*d_T1_dV_e_di+NFINtotal*d_qd_dV_e_di*T1);
d_qd_dV_e_si = ((NFINtotal*qd)*d_T1_dV_e_si+NFINtotal*d_qd_dV_e_si*T1);
d_qd_dV_di_si = ((NFINtotal*qd)*d_T1_dV_di_si+NFINtotal*d_qd_dV_di_si*T1);
qd = ((NFINtotal*qd)*T1);

d_qg_dV_g_di = d_qinv_dV_g_di;
d_qg_dV_g_si = d_qinv_dV_g_si;
d_qg_dV_g_e = d_qinv_dV_g_e;
d_qg_dV_e_di = d_qinv_dV_e_di;
d_qg_dV_e_si = d_qinv_dV_e_si;
d_qg_dV_di_si = d_qinv_dV_di_si;
qg = (qinv-(NFINtotal*qb));

d_qd_dV_g_di = (-d_qd_dV_g_di);
d_qd_dV_g_si = (-d_qd_dV_g_si);
d_qd_dV_g_e = (-d_qd_dV_g_e);
d_qd_dV_e_di = (-d_qd_dV_e_di);
d_qd_dV_e_si = (-d_qd_dV_e_si);
d_qd_dV_di_si = (-d_qd_dV_di_si);
qd = (-qd);
qb = ((+NFINtotal)*qb);

d_qs_dV_g_di = ((-d_qg_dV_g_di)-d_qd_dV_g_di);
d_qs_dV_g_si = ((-d_qg_dV_g_si)-d_qd_dV_g_si);
d_qs_dV_g_e = ((-d_qg_dV_g_e)-d_qd_dV_g_e);
d_qs_dV_e_di = ((-d_qg_dV_e_di)-d_qd_dV_e_di);
d_qs_dV_e_si = ((-d_qg_dV_e_si)-d_qd_dV_e_si);
d_qs_dV_di_si = ((-d_qg_dV_di_si)-d_qd_dV_di_si);
qs = (((-qg)-qd)-qb);
if ((sigvds<0))
{

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_di = d_qd_dV_g_di;
d_T1_dV_g_si = d_qd_dV_g_si;
d_T1_dV_g_e = d_qd_dV_g_e;
d_T1_dV_e_di = d_qd_dV_e_di;
d_T1_dV_e_si = d_qd_dV_e_si;
d_T1_dV_di_si = d_qd_dV_di_si;
T1 = qd;

d_qd_dV_g_di = d_qs_dV_g_di;
d_qd_dV_g_si = d_qs_dV_g_si;
d_qd_dV_g_e = d_qs_dV_g_e;
d_qd_dV_e_di = d_qs_dV_e_di;
d_qd_dV_e_si = d_qs_dV_e_si;
d_qd_dV_di_si = d_qs_dV_di_si;
qd = qs;

d_qs_dV_di_si = d_T1_dV_di_si;
d_qs_dV_g_si = d_T1_dV_g_si;
d_qs_dV_g_e = d_T1_dV_g_e;
d_qs_dV_e_di = d_T1_dV_e_di;
d_qs_dV_e_si = d_T1_dV_e_si;
d_qs_dV_g_di = d_T1_dV_g_di;
qs = T1;
}
}
else
{
if (((model_.NQSMOD)==3))
{
UserInfo(*this)  << "[bsimcmg] Although the model selector NQSMOD is set to 3, the NQS charge segmentation model is not activated in the Verilog-A code.  Please uncomment `define __NQSMOD3__ in bsimcmg.va to activate it. Quasi-static calculations being performed instead" << " " <<  std::endl; 
}
if ((NGATE_i>0.0))
{

d_Tcom_dV_g_si = (((qis*d_qis_dV_g_si+d_qis_dV_g_si*qis)+(qis*d_qid_dV_g_si+d_qis_dV_g_si*qid))+(qid*d_qid_dV_g_si+d_qid_dV_g_si*qid));
d_Tcom_dV_g_e = (((qis*d_qis_dV_g_e+d_qis_dV_g_e*qis)+(qis*d_qid_dV_g_e+d_qis_dV_g_e*qid))+(qid*d_qid_dV_g_e+d_qid_dV_g_e*qid));
d_Tcom_dV_e_di = (((qis*d_qis_dV_e_di+d_qis_dV_e_di*qis)+(qis*d_qid_dV_e_di+d_qis_dV_e_di*qid))+(qid*d_qid_dV_e_di+d_qid_dV_e_di*qid));
d_Tcom_dV_e_si = (((qis*d_qis_dV_e_si+d_qis_dV_e_si*qis)+(qis*d_qid_dV_e_si+d_qis_dV_e_si*qid))+(qid*d_qid_dV_e_si+d_qid_dV_e_si*qid));
d_Tcom_dV_di_si = (((qis*d_qis_dV_di_si+d_qis_dV_di_si*qis)+(qis*d_qid_dV_di_si+d_qis_dV_di_si*qid))+(qid*d_qid_dV_di_si+d_qid_dV_di_si*qid));
Tcom = (((qis*qis)+(qis*qid))+(qid*qid));
}
else
{

d_Tcom_dV_di_si = d_Tcom_dV_e_si = d_Tcom_dV_e_di = d_Tcom_dV_g_e = d_Tcom_dV_g_si =  0.0;
Tcom = 0.0;
}
if ((NGATE_i>0))
{

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = ((2.0*cpoly)*d_Tcom_dV_g_si/3);
d_T0_dV_g_e = ((2.0*cpoly)*d_Tcom_dV_g_e/3);
d_T0_dV_e_di = ((2.0*cpoly)*d_Tcom_dV_e_di/3);
d_T0_dV_e_si = ((2.0*cpoly)*d_Tcom_dV_e_si/3);
d_T0_dV_di_si = ((2.0*cpoly)*d_Tcom_dV_di_si/3);
T0 = (((2.0*cpoly)*Tcom)/3);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = kpoly*d_qia_dV_g_si;
d_T1_dV_g_e = kpoly*d_qia_dV_g_e;
d_T1_dV_e_di = kpoly*d_qia_dV_e_di;
d_T1_dV_e_si = kpoly*d_qia_dV_e_si;
d_T1_dV_di_si = kpoly*d_qia_dV_di_si;
T1 = (kpoly*qia);
}
else
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = 0;

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = d_qia_dV_g_si;
d_T1_dV_g_e = d_qia_dV_g_e;
d_T1_dV_e_di = d_qia_dV_e_di;
d_T1_dV_e_si = d_qia_dV_e_si;
d_T1_dV_di_si = d_qia_dV_di_si;
T1 = qia;
}

d_etaiv_dV_g_si = (-q0*cdop*d_qia_dV_g_si/(q0+(cdop*qia))/(q0+(cdop*qia)));
d_etaiv_dV_g_e = (-q0*cdop*d_qia_dV_g_e/(q0+(cdop*qia))/(q0+(cdop*qia)));
d_etaiv_dV_e_di = (-q0*cdop*d_qia_dV_e_di/(q0+(cdop*qia))/(q0+(cdop*qia)));
d_etaiv_dV_e_si = (-q0*cdop*d_qia_dV_e_si/(q0+(cdop*qia))/(q0+(cdop*qia)));
d_etaiv_dV_di_si = (((q0+(cdop*qia))*d_q0_dV_di_si-q0*(d_q0_dV_di_si+(cdop*d_qia_dV_di_si+d_cdop_dV_di_si*qia)))/(q0+(cdop*qia))/(q0+(cdop*qia)));
etaiv = (q0/(q0+(cdop*qia)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_g_si = (-d_etaiv_dV_g_si)*nVtm;
d_T2_dV_g_e = (-d_etaiv_dV_g_e)*nVtm;
d_T2_dV_e_di = (-d_etaiv_dV_e_di)*nVtm;
d_T2_dV_e_si = (-d_etaiv_dV_e_si)*nVtm;
d_T2_dV_di_si = ((2.0-etaiv)*d_nVtm_dV_di_si+(-d_etaiv_dV_di_si)*nVtm);
T2 = ((2.0-etaiv)*nVtm);

d_ids0_ov_dqi_dV_di_si = ((d_T0_dV_di_si+d_T1_dV_di_si)+d_T2_dV_di_si);
d_ids0_ov_dqi_dV_g_si = ((d_T0_dV_g_si+d_T1_dV_g_si)+d_T2_dV_g_si);
d_ids0_ov_dqi_dV_g_e = ((d_T0_dV_g_e+d_T1_dV_g_e)+d_T2_dV_g_e);
d_ids0_ov_dqi_dV_e_di = ((d_T0_dV_e_di+d_T1_dV_e_di)+d_T2_dV_e_di);
d_ids0_ov_dqi_dV_e_si = ((d_T0_dV_e_si+d_T1_dV_e_si)+d_T2_dV_e_si);
d_ids0_ov_dqi_dV_g_di = ((d_T0_dV_g_di+d_T1_dV_g_di)+d_T2_dV_g_di);
ids0_ov_dqi = ((T0+T1)+T2);

d_ids0_dV_e_di = (ids0_ov_dqi*d_dqi_dV_e_di+d_ids0_ov_dqi_dV_e_di*dqi);
d_ids0_dV_e_si = (ids0_ov_dqi*d_dqi_dV_e_si+d_ids0_ov_dqi_dV_e_si*dqi);
d_ids0_dV_g_si = (ids0_ov_dqi*d_dqi_dV_g_si+d_ids0_ov_dqi_dV_g_si*dqi);
d_ids0_dV_g_e = (ids0_ov_dqi*d_dqi_dV_g_e+d_ids0_ov_dqi_dV_g_e*dqi);
d_ids0_dV_di_si = (ids0_ov_dqi*d_dqi_dV_di_si+d_ids0_ov_dqi_dV_di_si*dqi);
d_ids0_dV_g_di = d_ids0_ov_dqi_dV_g_di*dqi;
ids0 = (ids0_ov_dqi*dqi);
if (((model_.RDSMOD)!=0))
{

d_Rdsi_dV_g_di = d_Rdsi_dV_e_si = d_Rdsi_dV_e_di = d_Rdsi_dV_g_e = d_Rdsi_dV_g_si = d_Rdsi_dV_di_si =  0.0;
Rdsi = 0.0;

d_Dr_dV_e_si = d_Dr_dV_e_di = d_Dr_dV_g_e = d_Dr_dV_g_si = d_Dr_dV_di_si = d_Dr_dV_g_di =  0.0;
Dr = 1.0;

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_g_si = d_vgs_noswap_dV_g_si;
T2 = (vgs_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_di_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_si+d_T2_dV_di_si*T2)));
d_T3_dV_e_di = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_di+d_T2_dV_e_di*T2)));
d_T3_dV_e_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_si+d_T2_dV_e_si*T2)));
d_T3_dV_g_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_si+d_T2_dV_g_si*T2)));
d_T3_dV_g_e = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_e+d_T2_dV_g_e*T2)));
d_T3_dV_g_di = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_di+d_T2_dV_g_di*T2)));
T3 = value_sqrt_0;
}

d_vgs_eff_dV_di_si = 0.5*(d_T2_dV_di_si+d_T3_dV_di_si);
d_vgs_eff_dV_e_di = 0.5*(d_T2_dV_e_di+d_T3_dV_e_di);
d_vgs_eff_dV_e_si = 0.5*(d_T2_dV_e_si+d_T3_dV_e_si);
d_vgs_eff_dV_g_si = 0.5*(d_T2_dV_g_si+d_T3_dV_g_si);
d_vgs_eff_dV_g_e = 0.5*(d_T2_dV_g_e+d_T3_dV_g_e);
d_vgs_eff_dV_g_di = 0.5*(d_T2_dV_g_di+d_T3_dV_g_di);
vgs_eff = (0.5*(T2+T3));

d_T4_dV_di_si = PRWGS_i*d_vgs_eff_dV_di_si;
d_T4_dV_e_di = PRWGS_i*d_vgs_eff_dV_e_di;
d_T4_dV_e_si = PRWGS_i*d_vgs_eff_dV_e_si;
d_T4_dV_g_si = PRWGS_i*d_vgs_eff_dV_g_si;
d_T4_dV_g_e = PRWGS_i*d_vgs_eff_dV_g_e;
d_T4_dV_g_di = PRWGS_i*d_vgs_eff_dV_g_di;
T4 = (1.0+(PRWGS_i*vgs_eff));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_si = (-d_T4_dV_g_si/T4/T4);
d_T1_dV_g_e = (-d_T4_dV_g_e/T4/T4);
d_T1_dV_e_di = (-d_T4_dV_e_di/T4/T4);
d_T1_dV_e_si = (-d_T4_dV_e_si/T4/T4);
d_T1_dV_di_si = (-d_T4_dV_di_si/T4/T4);
d_T1_dV_g_di = (-d_T4_dV_g_di/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_di_si = 0.5*(d_T1_dV_di_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1))));
d_T0_dV_g_si = 0.5*(d_T1_dV_g_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1))));
d_T0_dV_g_e = 0.5*(d_T1_dV_g_e+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1))));
d_T0_dV_e_di = 0.5*(d_T1_dV_e_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1))));
d_T0_dV_e_si = 0.5*(d_T1_dV_e_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1))));
d_T0_dV_g_di = 0.5*(d_T1_dV_g_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_di+d_T1_dV_g_di*T1))));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_e_si = d_T5_dV_e_di = d_T5_dV_g_e = d_T5_dV_g_si =  0.0;
d_T5_dV_si_s = RSW_i*RSDR_a*evaluator_lexp_1.getDerivs(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))),(0.5*(model_.PRSDR))*evaluator_lln_0.getDerivs((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6),((probeVars[admsProbeID_V_si_s])*d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]+d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]*(probeVars[admsProbeID_V_si_s]))));
d_T5_dV_di_si = RSW_i*d_RSDR_a_dV_di_si*evaluator_lexp_1.getValues(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))));
T5 = (RSW_i*(1.0+(RSDR_a*evaluator_lexp_1.getValues(((0.5*(model_.PRSDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
}

d_Rsource_dV_g_di = rdstemp*(T5*d_T0_dV_g_di+d_T5_dV_g_di*T0)*WeffWRFactor;
d_Rsource_dV_di_si = rdstemp*(T5*d_T0_dV_di_si+d_T5_dV_di_si*T0)*WeffWRFactor;
d_Rsource_dV_g_si = rdstemp*(T5*d_T0_dV_g_si+d_T5_dV_g_si*T0)*WeffWRFactor;
d_Rsource_dV_g_e = rdstemp*(T5*d_T0_dV_g_e+d_T5_dV_g_e*T0)*WeffWRFactor;
d_Rsource_dV_e_di = rdstemp*(T5*d_T0_dV_e_di+d_T5_dV_e_di*T0)*WeffWRFactor;
d_Rsource_dV_e_si = rdstemp*(T5*d_T0_dV_e_si+d_T5_dV_e_si*T0)*WeffWRFactor;
d_Rsource_dV_si_s = rdstemp*d_T5_dV_si_s*T0*WeffWRFactor;
d_Rsource_dV_di_d = rdstemp*d_T5_dV_di_d*T0*WeffWRFactor;
Rsource = (rdstemp*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_g_di = d_vgd_noswap_dV_g_di;
T2 = (vgd_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T3_dV_di_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_di_si+d_T2_dV_di_si*T2)));
d_T3_dV_e_di = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_di+d_T2_dV_e_di*T2)));
d_T3_dV_e_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_e_si+d_T2_dV_e_si*T2)));
d_T3_dV_g_si = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_si+d_T2_dV_g_si*T2)));
d_T3_dV_g_e = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_e+d_T2_dV_g_e*T2)));
d_T3_dV_g_di = (deriv_sqrt_0_d0*((T2*d_T2_dV_g_di+d_T2_dV_g_di*T2)));
T3 = value_sqrt_0;
}

d_vgd_eff_dV_di_si = 0.5*(d_T2_dV_di_si+d_T3_dV_di_si);
d_vgd_eff_dV_e_di = 0.5*(d_T2_dV_e_di+d_T3_dV_e_di);
d_vgd_eff_dV_e_si = 0.5*(d_T2_dV_e_si+d_T3_dV_e_si);
d_vgd_eff_dV_g_si = 0.5*(d_T2_dV_g_si+d_T3_dV_g_si);
d_vgd_eff_dV_g_e = 0.5*(d_T2_dV_g_e+d_T3_dV_g_e);
d_vgd_eff_dV_g_di = 0.5*(d_T2_dV_g_di+d_T3_dV_g_di);
vgd_eff = (0.5*(T2+T3));

d_T4_dV_di_si = PRWGD_i*d_vgd_eff_dV_di_si;
d_T4_dV_e_di = PRWGD_i*d_vgd_eff_dV_e_di;
d_T4_dV_e_si = PRWGD_i*d_vgd_eff_dV_e_si;
d_T4_dV_g_si = PRWGD_i*d_vgd_eff_dV_g_si;
d_T4_dV_g_e = PRWGD_i*d_vgd_eff_dV_g_e;
d_T4_dV_g_di = PRWGD_i*d_vgd_eff_dV_g_di;
T4 = (1.0+(PRWGD_i*vgd_eff));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_si = (-d_T4_dV_g_si/T4/T4);
d_T1_dV_g_e = (-d_T4_dV_g_e/T4/T4);
d_T1_dV_e_di = (-d_T4_dV_e_di/T4/T4);
d_T1_dV_e_si = (-d_T4_dV_e_si/T4/T4);
d_T1_dV_di_si = (-d_T4_dV_di_si/T4/T4);
d_T1_dV_g_di = (-d_T4_dV_g_di/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_di_si = 0.5*(d_T1_dV_di_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1))));
d_T0_dV_g_si = 0.5*(d_T1_dV_g_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1))));
d_T0_dV_g_e = 0.5*(d_T1_dV_g_e+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1))));
d_T0_dV_e_di = 0.5*(d_T1_dV_e_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1))));
d_T0_dV_e_si = 0.5*(d_T1_dV_e_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1))));
d_T0_dV_g_di = 0.5*(d_T1_dV_g_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_di+d_T1_dV_g_di*T1))));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))));

d_T5_dV_g_di = d_T5_dV_si_s = d_T5_dV_e_si = d_T5_dV_e_di = d_T5_dV_g_e = d_T5_dV_g_si =  0.0;
d_T5_dV_di_d = RDW_i*RDDR_a*evaluator_lexp_1.getDerivs(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))),(0.5*(model_.PRDDR))*evaluator_lln_0.getDerivs((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6),((probeVars[admsProbeID_V_di_d])*d_probeVars[admsProbeID_V_di_d][admsProbeID_V_di_d]+d_probeVars[admsProbeID_V_di_d][admsProbeID_V_di_d]*(probeVars[admsProbeID_V_di_d]))));
d_T5_dV_di_si = RDW_i*d_RDDR_a_dV_di_si*evaluator_lexp_1.getValues(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))));
T5 = (RDW_i*(1.0+(RDDR_a*evaluator_lexp_1.getValues(((0.5*(model_.PRDDR))*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
}

d_Rdrain_dV_g_di = rdstemp*(T5*d_T0_dV_g_di+d_T5_dV_g_di*T0)*WeffWRFactor;
d_Rdrain_dV_di_si = rdstemp*(T5*d_T0_dV_di_si+d_T5_dV_di_si*T0)*WeffWRFactor;
d_Rdrain_dV_g_si = rdstemp*(T5*d_T0_dV_g_si+d_T5_dV_g_si*T0)*WeffWRFactor;
d_Rdrain_dV_g_e = rdstemp*(T5*d_T0_dV_g_e+d_T5_dV_g_e*T0)*WeffWRFactor;
d_Rdrain_dV_e_di = rdstemp*(T5*d_T0_dV_e_di+d_T5_dV_e_di*T0)*WeffWRFactor;
d_Rdrain_dV_e_si = rdstemp*(T5*d_T0_dV_e_si+d_T5_dV_e_si*T0)*WeffWRFactor;
d_Rdrain_dV_si_s = rdstemp*d_T5_dV_si_s*T0*WeffWRFactor;
d_Rdrain_dV_di_d = rdstemp*d_T5_dV_di_d*T0*WeffWRFactor;
Rdrain = (rdstemp*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
}
else
{

d_Rsource_dV_di_d = d_Rsource_dV_g_di = d_Rsource_dV_si_s = d_Rsource_dV_e_si = d_Rsource_dV_e_di = d_Rsource_dV_g_e = d_Rsource_dV_g_si = d_Rsource_dV_di_si =  0.0;
Rsource = RSourceGeo;

d_Rdrain_dV_di_d = d_Rdrain_dV_si_s = d_Rdrain_dV_e_si = d_Rdrain_dV_e_di = d_Rdrain_dV_g_e = d_Rdrain_dV_g_si = d_Rdrain_dV_di_si = d_Rdrain_dV_g_di =  0.0;
Rdrain = RDrainGeo;

d_T4_dV_g_di =  0.0;
d_T4_dV_g_si = PRWGS_i*d_qia_dV_g_si;
d_T4_dV_g_e = PRWGS_i*d_qia_dV_g_e;
d_T4_dV_e_di = PRWGS_i*d_qia_dV_e_di;
d_T4_dV_e_si = PRWGS_i*d_qia_dV_e_si;
d_T4_dV_di_si = PRWGS_i*d_qia_dV_di_si;
T4 = (1.0+(PRWGS_i*qia));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_si = (-d_T4_dV_g_si/T4/T4);
d_T1_dV_g_e = (-d_T4_dV_g_e/T4/T4);
d_T1_dV_e_di = (-d_T4_dV_e_di/T4/T4);
d_T1_dV_e_si = (-d_T4_dV_e_si/T4/T4);
d_T1_dV_di_si = (-d_T4_dV_di_si/T4/T4);
d_T1_dV_g_di = (-d_T4_dV_g_di/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T0_dV_di_si = 0.5*(d_T1_dV_di_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_di_si+d_T1_dV_di_si*T1))));
d_T0_dV_g_si = 0.5*(d_T1_dV_g_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_si+d_T1_dV_g_si*T1))));
d_T0_dV_g_e = 0.5*(d_T1_dV_g_e+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_e+d_T1_dV_g_e*T1))));
d_T0_dV_e_di = 0.5*(d_T1_dV_e_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_di+d_T1_dV_e_di*T1))));
d_T0_dV_e_si = 0.5*(d_T1_dV_e_si+(deriv_sqrt_0_d0*((T1*d_T1_dV_e_si+d_T1_dV_e_si*T1))));
d_T0_dV_g_di = 0.5*(d_T1_dV_g_di+(deriv_sqrt_0_d0*((T1*d_T1_dV_g_di+d_T1_dV_g_di*T1))));
T0 = (0.5*(T1+value_sqrt_0));
}

d_Rdsi_dV_di_si = rdstemp*RDSW_i*d_T0_dV_di_si*WeffWRFactor;
d_Rdsi_dV_g_si = rdstemp*RDSW_i*d_T0_dV_g_si*WeffWRFactor;
d_Rdsi_dV_g_e = rdstemp*RDSW_i*d_T0_dV_g_e*WeffWRFactor;
d_Rdsi_dV_e_di = rdstemp*RDSW_i*d_T0_dV_e_di*WeffWRFactor;
d_Rdsi_dV_e_si = rdstemp*RDSW_i*d_T0_dV_e_si*WeffWRFactor;
d_Rdsi_dV_g_di = rdstemp*RDSW_i*d_T0_dV_g_di*WeffWRFactor;
Rdsi = ((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);

d_Dr_dV_g_di = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_g_di+((NFINtotal*beta)*d_ids0_ov_dqi_dV_g_di/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_di_si = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_di_si+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_di_si+NFINtotal*d_beta_dV_di_si*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_di_si+d_Dmob_dV_di_si*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_g_si = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_g_si+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_g_si+NFINtotal*d_beta_dV_g_si*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_g_si+d_Dmob_dV_g_si*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_g_e = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_g_e+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_g_e+NFINtotal*d_beta_dV_g_e*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_g_e+d_Dmob_dV_g_e*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_e_di = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_e_di+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_e_di+NFINtotal*d_beta_dV_e_di*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_e_di+d_Dmob_dV_e_di*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
d_Dr_dV_e_si = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dV_e_si+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dV_e_si+NFINtotal*d_beta_dV_e_si*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dV_e_si+d_Dmob_dV_e_si*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
Dr = (1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
}

d_ids_dV_g_di = ((((Dmob*Dvsat)*Dr)*(NFINtotal*beta)*d_ids0_dV_g_di*Moc*Mob*Mnud-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*(Dmob*Dvsat)*d_Dr_dV_g_di)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_di_si = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_di_si+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_di_si+(((NFINtotal*beta)*ids0)*d_Moc_dV_di_si+((NFINtotal*beta)*d_ids0_dV_di_si+NFINtotal*d_beta_dV_di_si*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_di_si+(Dmob*d_Dvsat_dV_di_si+d_Dmob_dV_di_si*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_g_si = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_g_si+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_g_si+(((NFINtotal*beta)*ids0)*d_Moc_dV_g_si+((NFINtotal*beta)*d_ids0_dV_g_si+NFINtotal*d_beta_dV_g_si*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_g_si+(Dmob*d_Dvsat_dV_g_si+d_Dmob_dV_g_si*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_g_e = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_g_e+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_g_e+(((NFINtotal*beta)*ids0)*d_Moc_dV_g_e+((NFINtotal*beta)*d_ids0_dV_g_e+NFINtotal*d_beta_dV_g_e*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_g_e+(Dmob*d_Dvsat_dV_g_e+d_Dmob_dV_g_e*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_e_di = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_e_di+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_e_di+(((NFINtotal*beta)*ids0)*d_Moc_dV_e_di+((NFINtotal*beta)*d_ids0_dV_e_di+NFINtotal*d_beta_dV_e_di*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_e_di+(Dmob*d_Dvsat_dV_e_di+d_Dmob_dV_e_di*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
d_ids_dV_e_si = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dV_e_si+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dV_e_si+(((NFINtotal*beta)*ids0)*d_Moc_dV_e_si+((NFINtotal*beta)*d_ids0_dV_e_si+NFINtotal*d_beta_dV_e_si*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dV_e_si+(Dmob*d_Dvsat_dV_e_si+d_Dmob_dV_e_si*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
ids = ((((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)/((Dmob*Dvsat)*Dr));

d_ids_dV_g_di = d_ids_dV_g_di*(model_.IDS0MULT);
d_ids_dV_di_si = d_ids_dV_di_si*(model_.IDS0MULT);
d_ids_dV_g_si = d_ids_dV_g_si*(model_.IDS0MULT);
d_ids_dV_g_e = d_ids_dV_g_e*(model_.IDS0MULT);
d_ids_dV_e_di = d_ids_dV_e_di*(model_.IDS0MULT);
d_ids_dV_e_si = d_ids_dV_e_si*(model_.IDS0MULT);
ids = (ids*(model_.IDS0MULT));
if ((NGATE_i>0))
{

d_idscv_dV_g_si = ((((2.0*cpoly)*d_Tcom_dV_g_si/3.0)+kpoly*d_qia_dV_g_si)+(-d_etaiv_dV_g_si)*nVtm);
d_idscv_dV_g_e = ((((2.0*cpoly)*d_Tcom_dV_g_e/3.0)+kpoly*d_qia_dV_g_e)+(-d_etaiv_dV_g_e)*nVtm);
d_idscv_dV_e_di = ((((2.0*cpoly)*d_Tcom_dV_e_di/3.0)+kpoly*d_qia_dV_e_di)+(-d_etaiv_dV_e_di)*nVtm);
d_idscv_dV_e_si = ((((2.0*cpoly)*d_Tcom_dV_e_si/3.0)+kpoly*d_qia_dV_e_si)+(-d_etaiv_dV_e_si)*nVtm);
d_idscv_dV_di_si = ((((2.0*cpoly)*d_Tcom_dV_di_si/3.0)+kpoly*d_qia_dV_di_si)+((2.0-etaiv)*d_nVtm_dV_di_si+(-d_etaiv_dV_di_si)*nVtm));
idscv = (((((2.0*cpoly)*Tcom)/3.0)+(kpoly*qia))+((2.0-etaiv)*nVtm));
}
else
{

d_idscv_dV_g_si = (d_qia_dV_g_si+(-d_etaiv_dV_g_si)*nVtm);
d_idscv_dV_g_e = (d_qia_dV_g_e+(-d_etaiv_dV_g_e)*nVtm);
d_idscv_dV_e_di = (d_qia_dV_e_di+(-d_etaiv_dV_e_di)*nVtm);
d_idscv_dV_e_si = (d_qia_dV_e_si+(-d_etaiv_dV_e_si)*nVtm);
d_idscv_dV_di_si = (d_qia_dV_di_si+((2.0-etaiv)*d_nVtm_dV_di_si+(-d_etaiv_dV_di_si)*nVtm));
idscv = (qia+((2.0-etaiv)*nVtm));
}

d_idscv_dV_g_si = ((DvsatCV*d_idscv_dV_g_si-idscv*d_DvsatCV_dV_g_si)/DvsatCV/DvsatCV);
d_idscv_dV_g_e = ((DvsatCV*d_idscv_dV_g_e-idscv*d_DvsatCV_dV_g_e)/DvsatCV/DvsatCV);
d_idscv_dV_e_di = ((DvsatCV*d_idscv_dV_e_di-idscv*d_DvsatCV_dV_e_di)/DvsatCV/DvsatCV);
d_idscv_dV_e_si = ((DvsatCV*d_idscv_dV_e_si-idscv*d_DvsatCV_dV_e_si)/DvsatCV/DvsatCV);
d_idscv_dV_di_si = ((DvsatCV*d_idscv_dV_di_si-idscv*d_DvsatCV_dV_di_si)/DvsatCV/DvsatCV);
idscv = (idscv/DvsatCV);
beta_cv = (((u0*coxeff)*WeffCV)/LeffCV);

d_dqi_idscv_dV_g_si = ((idscv*d_dqi_dV_g_si-dqi*d_idscv_dV_g_si)/idscv/idscv);
d_dqi_idscv_dV_g_e = ((idscv*d_dqi_dV_g_e-dqi*d_idscv_dV_g_e)/idscv/idscv);
d_dqi_idscv_dV_e_di = ((idscv*d_dqi_dV_e_di-dqi*d_idscv_dV_e_di)/idscv/idscv);
d_dqi_idscv_dV_e_si = ((idscv*d_dqi_dV_e_si-dqi*d_idscv_dV_e_si)/idscv/idscv);
d_dqi_idscv_dV_di_si = ((idscv*d_dqi_dV_di_si-dqi*d_idscv_dV_di_si)/idscv/idscv);
dqi_idscv = (dqi/idscv);
if ((NGATE_i>0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (4.0*cpoly)*d_qia_dV_g_si;
d_T1_dV_g_e = (4.0*cpoly)*d_qia_dV_g_e;
d_T1_dV_e_di = (4.0*cpoly)*d_qia_dV_e_di;
d_T1_dV_e_si = (4.0*cpoly)*d_qia_dV_e_si;
d_T1_dV_di_si = (4.0*cpoly)*d_qia_dV_di_si;
T1 = (kpoly+((4.0*cpoly)*qia));
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = 1.0;
}

d_qg_dV_g_di = (d_T1_dV_g_di*dqi*dqi_idscv/12.0);
d_qg_dV_g_si = (d_qia_dV_g_si+(((T1*dqi)*d_dqi_idscv_dV_g_si+(T1*d_dqi_dV_g_si+d_T1_dV_g_si*dqi)*dqi_idscv)/12.0));
d_qg_dV_g_e = (d_qia_dV_g_e+(((T1*dqi)*d_dqi_idscv_dV_g_e+(T1*d_dqi_dV_g_e+d_T1_dV_g_e*dqi)*dqi_idscv)/12.0));
d_qg_dV_e_di = (d_qia_dV_e_di+(((T1*dqi)*d_dqi_idscv_dV_e_di+(T1*d_dqi_dV_e_di+d_T1_dV_e_di*dqi)*dqi_idscv)/12.0));
d_qg_dV_e_si = (d_qia_dV_e_si+(((T1*dqi)*d_dqi_idscv_dV_e_si+(T1*d_dqi_dV_e_si+d_T1_dV_e_si*dqi)*dqi_idscv)/12.0));
d_qg_dV_di_si = (d_qia_dV_di_si+(((T1*dqi)*d_dqi_idscv_dV_di_si+(T1*d_dqi_dV_di_si+d_T1_dV_di_si*dqi)*dqi_idscv)/12.0));
qg = (qia+(((T1*dqi)*dqi_idscv)/12.0));
if ((NGATE_i>0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = cpoly*(32.0*d_qid_dV_g_si+28.0*d_qis_dV_g_si);
d_T1_dV_g_e = cpoly*(32.0*d_qid_dV_g_e+28.0*d_qis_dV_g_e);
d_T1_dV_e_di = cpoly*(32.0*d_qid_dV_e_di+28.0*d_qis_dV_e_di);
d_T1_dV_e_si = cpoly*(32.0*d_qid_dV_e_si+28.0*d_qis_dV_e_si);
d_T1_dV_di_si = cpoly*(32.0*d_qid_dV_di_si+28.0*d_qis_dV_di_si);
T1 = ((15.0*kpoly)+(cpoly*((32.0*qid)+(28.0*qis))));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_g_si = (((126.0*cpoly)*kpoly)*d_qia_dV_g_si+(cpoly*cpoly)*(256.0*d_Tcom_dV_g_si+((240.0*qis)*d_qid_dV_g_si+240.0*d_qis_dV_g_si*qid)));
d_T2_dV_g_e = (((126.0*cpoly)*kpoly)*d_qia_dV_g_e+(cpoly*cpoly)*(256.0*d_Tcom_dV_g_e+((240.0*qis)*d_qid_dV_g_e+240.0*d_qis_dV_g_e*qid)));
d_T2_dV_e_di = (((126.0*cpoly)*kpoly)*d_qia_dV_e_di+(cpoly*cpoly)*(256.0*d_Tcom_dV_e_di+((240.0*qis)*d_qid_dV_e_di+240.0*d_qis_dV_e_di*qid)));
d_T2_dV_e_si = (((126.0*cpoly)*kpoly)*d_qia_dV_e_si+(cpoly*cpoly)*(256.0*d_Tcom_dV_e_si+((240.0*qis)*d_qid_dV_e_si+240.0*d_qis_dV_e_si*qid)));
d_T2_dV_di_si = (((126.0*cpoly)*kpoly)*d_qia_dV_di_si+(cpoly*cpoly)*(256.0*d_Tcom_dV_di_si+((240.0*qis)*d_qid_dV_di_si+240.0*d_qis_dV_di_si*qid)));
T2 = ((((63.0*kpoly)*kpoly)+(((126.0*cpoly)*kpoly)*qia))+((cpoly*cpoly)*((256.0*Tcom)+((240.0*qis)*qid))));
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = 15.0;

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = 63.0;
}

d_qd_dV_g_di = (-(dqi*((-(d_T1_dV_g_di*dqi_idscv/30.0))-(d_T2_dV_g_di*dqi_idscv*dqi_idscv/1260.0))/12.0));
d_qd_dV_g_si = (0.5*d_qia_dV_g_si-((dqi*((-((T1*d_dqi_idscv_dV_g_si+d_T1_dV_g_si*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_g_si+(T2*d_dqi_idscv_dV_g_si+d_T2_dV_g_si*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_g_si*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_g_e = (0.5*d_qia_dV_g_e-((dqi*((-((T1*d_dqi_idscv_dV_g_e+d_T1_dV_g_e*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_g_e+(T2*d_dqi_idscv_dV_g_e+d_T2_dV_g_e*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_g_e*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_e_di = (0.5*d_qia_dV_e_di-((dqi*((-((T1*d_dqi_idscv_dV_e_di+d_T1_dV_e_di*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_e_di+(T2*d_dqi_idscv_dV_e_di+d_T2_dV_e_di*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_e_di*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_e_si = (0.5*d_qia_dV_e_si-((dqi*((-((T1*d_dqi_idscv_dV_e_si+d_T1_dV_e_si*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_e_si+(T2*d_dqi_idscv_dV_e_si+d_T2_dV_e_si*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_e_si*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_qd_dV_di_si = (0.5*d_qia_dV_di_si-((dqi*((-((T1*d_dqi_idscv_dV_di_si+d_T1_dV_di_si*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dV_di_si+(T2*d_dqi_idscv_dV_di_si+d_T2_dV_di_si*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dV_di_si*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
qd = ((0.5*qia)-((dqi*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));

d_inv_MclmCV_dV_g_si = (-d_MclmCV_dV_g_si/MclmCV/MclmCV);
d_inv_MclmCV_dV_g_e = (-d_MclmCV_dV_g_e/MclmCV/MclmCV);
d_inv_MclmCV_dV_e_di = (-d_MclmCV_dV_e_di/MclmCV/MclmCV);
d_inv_MclmCV_dV_e_si = (-d_MclmCV_dV_e_si/MclmCV/MclmCV);
d_inv_MclmCV_dV_di_si = (-d_MclmCV_dV_di_si/MclmCV/MclmCV);
inv_MclmCV = (1.0/MclmCV);

d_qg_dV_g_di = inv_MclmCV*d_qg_dV_g_di;
d_qg_dV_g_si = ((inv_MclmCV*d_qg_dV_g_si+d_inv_MclmCV_dV_g_si*qg)+((MclmCV-1.0)*d_qid_dV_g_si+d_MclmCV_dV_g_si*qid));
d_qg_dV_g_e = ((inv_MclmCV*d_qg_dV_g_e+d_inv_MclmCV_dV_g_e*qg)+((MclmCV-1.0)*d_qid_dV_g_e+d_MclmCV_dV_g_e*qid));
d_qg_dV_e_di = ((inv_MclmCV*d_qg_dV_e_di+d_inv_MclmCV_dV_e_di*qg)+((MclmCV-1.0)*d_qid_dV_e_di+d_MclmCV_dV_e_di*qid));
d_qg_dV_e_si = ((inv_MclmCV*d_qg_dV_e_si+d_inv_MclmCV_dV_e_si*qg)+((MclmCV-1.0)*d_qid_dV_e_si+d_MclmCV_dV_e_si*qid));
d_qg_dV_di_si = ((inv_MclmCV*d_qg_dV_di_si+d_inv_MclmCV_dV_di_si*qg)+((MclmCV-1.0)*d_qid_dV_di_si+d_MclmCV_dV_di_si*qid));
qg = ((inv_MclmCV*qg)+((MclmCV-1.0)*qid));

d_qd_dV_g_di = (inv_MclmCV*inv_MclmCV)*d_qd_dV_g_di;
d_qd_dV_g_si = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_g_si+(inv_MclmCV*d_inv_MclmCV_dV_g_si+d_inv_MclmCV_dV_g_si*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_g_si+0.5*(d_MclmCV_dV_g_si-d_inv_MclmCV_dV_g_si)*qid));
d_qd_dV_g_e = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_g_e+(inv_MclmCV*d_inv_MclmCV_dV_g_e+d_inv_MclmCV_dV_g_e*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_g_e+0.5*(d_MclmCV_dV_g_e-d_inv_MclmCV_dV_g_e)*qid));
d_qd_dV_e_di = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_e_di+(inv_MclmCV*d_inv_MclmCV_dV_e_di+d_inv_MclmCV_dV_e_di*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_e_di+0.5*(d_MclmCV_dV_e_di-d_inv_MclmCV_dV_e_di)*qid));
d_qd_dV_e_si = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_e_si+(inv_MclmCV*d_inv_MclmCV_dV_e_si+d_inv_MclmCV_dV_e_si*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_e_si+0.5*(d_MclmCV_dV_e_si-d_inv_MclmCV_dV_e_si)*qid));
d_qd_dV_di_si = (((inv_MclmCV*inv_MclmCV)*d_qd_dV_di_si+(inv_MclmCV*d_inv_MclmCV_dV_di_si+d_inv_MclmCV_dV_di_si*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dV_di_si+0.5*(d_MclmCV_dV_di_si-d_inv_MclmCV_dV_di_si)*qid));
qd = (((inv_MclmCV*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*qid));

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = ((WeffCV*LeffCV)*d_coxeff_dV_di_si+d_WeffCV_dV_di_si*LeffCV*coxeff);
d_T1_dV_g_si = ((WeffCV*LeffCV)*d_coxeff_dV_g_si+d_WeffCV_dV_g_si*LeffCV*coxeff);
d_T1_dV_g_e = ((WeffCV*LeffCV)*d_coxeff_dV_g_e+d_WeffCV_dV_g_e*LeffCV*coxeff);
d_T1_dV_e_di = ((WeffCV*LeffCV)*d_coxeff_dV_e_di+d_WeffCV_dV_e_di*LeffCV*coxeff);
d_T1_dV_e_si = ((WeffCV*LeffCV)*d_coxeff_dV_e_si+d_WeffCV_dV_e_si*LeffCV*coxeff);
T1 = ((WeffCV*LeffCV)*coxeff);

d_qinv_dV_g_di = ((NFINtotal*qg)*d_T1_dV_g_di+NFINtotal*d_qg_dV_g_di*T1);
d_qinv_dV_g_si = ((NFINtotal*qg)*d_T1_dV_g_si+NFINtotal*d_qg_dV_g_si*T1);
d_qinv_dV_g_e = ((NFINtotal*qg)*d_T1_dV_g_e+NFINtotal*d_qg_dV_g_e*T1);
d_qinv_dV_e_di = ((NFINtotal*qg)*d_T1_dV_e_di+NFINtotal*d_qg_dV_e_di*T1);
d_qinv_dV_e_si = ((NFINtotal*qg)*d_T1_dV_e_si+NFINtotal*d_qg_dV_e_si*T1);
d_qinv_dV_di_si = ((NFINtotal*qg)*d_T1_dV_di_si+NFINtotal*d_qg_dV_di_si*T1);
qinv = ((NFINtotal*qg)*T1);

d_qd_dV_g_di = ((NFINtotal*qd)*d_T1_dV_g_di+NFINtotal*d_qd_dV_g_di*T1);
d_qd_dV_g_si = ((NFINtotal*qd)*d_T1_dV_g_si+NFINtotal*d_qd_dV_g_si*T1);
d_qd_dV_g_e = ((NFINtotal*qd)*d_T1_dV_g_e+NFINtotal*d_qd_dV_g_e*T1);
d_qd_dV_e_di = ((NFINtotal*qd)*d_T1_dV_e_di+NFINtotal*d_qd_dV_e_di*T1);
d_qd_dV_e_si = ((NFINtotal*qd)*d_T1_dV_e_si+NFINtotal*d_qd_dV_e_si*T1);
d_qd_dV_di_si = ((NFINtotal*qd)*d_T1_dV_di_si+NFINtotal*d_qd_dV_di_si*T1);
qd = ((NFINtotal*qd)*T1);

d_qg_dV_g_di = d_qinv_dV_g_di;
d_qg_dV_g_si = d_qinv_dV_g_si;
d_qg_dV_g_e = d_qinv_dV_g_e;
d_qg_dV_e_di = d_qinv_dV_e_di;
d_qg_dV_e_si = d_qinv_dV_e_si;
d_qg_dV_di_si = d_qinv_dV_di_si;
qg = (qinv-(NFINtotal*qb));

d_qd_dV_g_di = (-d_qd_dV_g_di);
d_qd_dV_g_si = (-d_qd_dV_g_si);
d_qd_dV_g_e = (-d_qd_dV_g_e);
d_qd_dV_e_di = (-d_qd_dV_e_di);
d_qd_dV_e_si = (-d_qd_dV_e_si);
d_qd_dV_di_si = (-d_qd_dV_di_si);
qd = (-qd);
qb = ((+NFINtotal)*qb);

d_qs_dV_g_di = ((-d_qg_dV_g_di)-d_qd_dV_g_di);
d_qs_dV_g_si = ((-d_qg_dV_g_si)-d_qd_dV_g_si);
d_qs_dV_g_e = ((-d_qg_dV_g_e)-d_qd_dV_g_e);
d_qs_dV_e_di = ((-d_qg_dV_e_di)-d_qd_dV_e_di);
d_qs_dV_e_si = ((-d_qg_dV_e_si)-d_qd_dV_e_si);
d_qs_dV_di_si = ((-d_qg_dV_di_si)-d_qd_dV_di_si);
qs = (((-qg)-qd)-qb);
if ((sigvds<0))
{

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_di = d_qd_dV_g_di;
d_T1_dV_g_si = d_qd_dV_g_si;
d_T1_dV_g_e = d_qd_dV_g_e;
d_T1_dV_e_di = d_qd_dV_e_di;
d_T1_dV_e_si = d_qd_dV_e_si;
d_T1_dV_di_si = d_qd_dV_di_si;
T1 = qd;

d_qd_dV_g_di = d_qs_dV_g_di;
d_qd_dV_g_si = d_qs_dV_g_si;
d_qd_dV_g_e = d_qs_dV_g_e;
d_qd_dV_e_di = d_qs_dV_e_di;
d_qd_dV_e_si = d_qs_dV_e_si;
d_qd_dV_di_si = d_qs_dV_di_si;
qd = qs;

d_qs_dV_di_si = d_T1_dV_di_si;
d_qs_dV_g_si = d_T1_dV_g_si;
d_qs_dV_g_e = d_T1_dV_g_e;
d_qs_dV_e_di = d_T1_dV_e_di;
d_qs_dV_e_si = d_T1_dV_e_si;
d_qs_dV_g_di = d_T1_dV_g_di;
qs = T1;
}
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = ((NFINtotal*WeffCV0)*LeffCV_acc)*d_cox_acc_dV_di_si;
d_T1_dV_g_si = ((NFINtotal*WeffCV0)*LeffCV_acc)*d_cox_acc_dV_g_si;
d_T1_dV_g_e = ((NFINtotal*WeffCV0)*LeffCV_acc)*d_cox_acc_dV_g_e;
d_T1_dV_e_di = ((NFINtotal*WeffCV0)*LeffCV_acc)*d_cox_acc_dV_e_di;
d_T1_dV_e_si = ((NFINtotal*WeffCV0)*LeffCV_acc)*d_cox_acc_dV_e_si;
T1 = (((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc);

d_qg_acc_dV_g_di = (-qi_acc)*d_T1_dV_g_di;
d_qg_acc_dV_di_si = ((-qi_acc)*d_T1_dV_di_si+(-d_qi_acc_dV_di_si)*T1);
d_qg_acc_dV_g_si = ((-qi_acc)*d_T1_dV_g_si+(-d_qi_acc_dV_g_si)*T1);
d_qg_acc_dV_g_e = ((-qi_acc)*d_T1_dV_g_e+(-d_qi_acc_dV_g_e)*T1);
d_qg_acc_dV_e_di = ((-qi_acc)*d_T1_dV_e_di+(-d_qi_acc_dV_e_di)*T1);
d_qg_acc_dV_e_si = ((-qi_acc)*d_T1_dV_e_si+(-d_qi_acc_dV_e_si)*T1);
qg_acc = ((-qi_acc)*T1);

d_qb_acc_dV_g_di = (+qi_acc)*d_T1_dV_g_di;
d_qb_acc_dV_di_si = ((+qi_acc)*d_T1_dV_di_si+(+d_qi_acc_dV_di_si)*T1);
d_qb_acc_dV_g_si = ((+qi_acc)*d_T1_dV_g_si+(+d_qi_acc_dV_g_si)*T1);
d_qb_acc_dV_g_e = ((+qi_acc)*d_T1_dV_g_e+(+d_qi_acc_dV_g_e)*T1);
d_qb_acc_dV_e_di = ((+qi_acc)*d_T1_dV_e_di+(+d_qi_acc_dV_e_di)*T1);
d_qb_acc_dV_e_si = ((+qi_acc)*d_T1_dV_e_si+(+d_qi_acc_dV_e_si)*T1);
qb_acc = ((+qi_acc)*T1);
}

d_qgs_ov_dV_g_di = d_qgs_ov_dV_e_si = d_qgs_ov_dV_e_di = d_qgs_ov_dV_g_e = d_qgs_ov_dV_g_si = d_qgs_ov_dV_di_si =  0.0;
qgs_ov = 0.0;

d_qgd_ov_dV_g_di = d_qgd_ov_dV_e_si = d_qgd_ov_dV_e_di = d_qgd_ov_dV_g_e = d_qgd_ov_dV_g_si = d_qgd_ov_dV_di_si =  0.0;
qgd_ov = 0.0;
if (((model_.CGEOMOD)!=1))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_di_si = NFINtotal*d_WeffCV_dV_di_si*devsign;
d_T1_dV_g_si = NFINtotal*d_WeffCV_dV_g_si*devsign;
d_T1_dV_g_e = NFINtotal*d_WeffCV_dV_g_e*devsign;
d_T1_dV_e_di = NFINtotal*d_WeffCV_dV_e_di*devsign;
d_T1_dV_e_si = NFINtotal*d_WeffCV_dV_e_si*devsign;
T1 = ((NFINtotal*WeffCV)*devsign);

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_g_si = devsign*d_probeVars[admsProbeID_V_g_si][admsProbeID_V_g_si];
T2 = (devsign*(probeVars[admsProbeID_V_g_si]));

d_T0_dV_di_si = d_T2_dV_di_si;
d_T0_dV_e_di = d_T2_dV_e_di;
d_T0_dV_e_si = d_T2_dV_e_si;
d_T0_dV_g_si = d_T2_dV_g_si;
d_T0_dV_g_e = d_T2_dV_g_e;
d_T0_dV_g_di = d_T2_dV_g_di;
T0 = ((T2-vfbsd)+0.02);
{
double value_sqrt_0 = sqrt(((T0*T0)+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vgs_overlap_dV_di_si = 0.5*(d_T0_dV_di_si-(deriv_sqrt_0_d0*((T0*d_T0_dV_di_si+d_T0_dV_di_si*T0))));
d_vgs_overlap_dV_g_si = 0.5*(d_T0_dV_g_si-(deriv_sqrt_0_d0*((T0*d_T0_dV_g_si+d_T0_dV_g_si*T0))));
d_vgs_overlap_dV_g_e = 0.5*(d_T0_dV_g_e-(deriv_sqrt_0_d0*((T0*d_T0_dV_g_e+d_T0_dV_g_e*T0))));
d_vgs_overlap_dV_e_di = 0.5*(d_T0_dV_e_di-(deriv_sqrt_0_d0*((T0*d_T0_dV_e_di+d_T0_dV_e_di*T0))));
d_vgs_overlap_dV_e_si = 0.5*(d_T0_dV_e_si-(deriv_sqrt_0_d0*((T0*d_T0_dV_e_si+d_T0_dV_e_si*T0))));
d_vgs_overlap_dV_g_di = 0.5*(d_T0_dV_g_di-(deriv_sqrt_0_d0*((T0*d_T0_dV_g_di+d_T0_dV_g_di*T0))));
vgs_overlap = (0.5*(T0-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qgs_ov_dV_di_si = (T1*(CGSL_i*((d_T2_dV_di_si-d_vgs_overlap_dV_di_si)-(0.5*CKAPPAS_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgs_overlap_dV_di_si/CKAPPAS_i)))))+CGSO_i*d_T2_dV_di_si)+d_T1_dV_di_si*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
d_qgs_ov_dV_g_si = (T1*(CGSL_i*((d_T2_dV_g_si-d_vgs_overlap_dV_g_si)-(0.5*CKAPPAS_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgs_overlap_dV_g_si/CKAPPAS_i)))))+CGSO_i*d_T2_dV_g_si)+d_T1_dV_g_si*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
d_qgs_ov_dV_g_e = (T1*(CGSL_i*((d_T2_dV_g_e-d_vgs_overlap_dV_g_e)-(0.5*CKAPPAS_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgs_overlap_dV_g_e/CKAPPAS_i)))))+CGSO_i*d_T2_dV_g_e)+d_T1_dV_g_e*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
d_qgs_ov_dV_e_di = (T1*(CGSL_i*((d_T2_dV_e_di-d_vgs_overlap_dV_e_di)-(0.5*CKAPPAS_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgs_overlap_dV_e_di/CKAPPAS_i)))))+CGSO_i*d_T2_dV_e_di)+d_T1_dV_e_di*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
d_qgs_ov_dV_e_si = (T1*(CGSL_i*((d_T2_dV_e_si-d_vgs_overlap_dV_e_si)-(0.5*CKAPPAS_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgs_overlap_dV_e_si/CKAPPAS_i)))))+CGSO_i*d_T2_dV_e_si)+d_T1_dV_e_si*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
d_qgs_ov_dV_g_di = (T1*(CGSL_i*((d_T2_dV_g_di-d_vgs_overlap_dV_g_di)-(0.5*CKAPPAS_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgs_overlap_dV_g_di/CKAPPAS_i)))))+CGSO_i*d_T2_dV_g_di)+d_T1_dV_g_di*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
qgs_ov = (T1*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
}

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_g_di = devsign*d_probeVars[admsProbeID_V_g_di][admsProbeID_V_g_di];
T2 = (devsign*(probeVars[admsProbeID_V_g_di]));

d_T0_dV_di_si = d_T2_dV_di_si;
d_T0_dV_e_di = d_T2_dV_e_di;
d_T0_dV_e_si = d_T2_dV_e_si;
d_T0_dV_g_si = d_T2_dV_g_si;
d_T0_dV_g_e = d_T2_dV_g_e;
d_T0_dV_g_di = d_T2_dV_g_di;
T0 = ((T2-vfbsd)+0.02);
{
double value_sqrt_0 = sqrt(((T0*T0)+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vgd_overlap_dV_di_si = 0.5*(d_T0_dV_di_si-(deriv_sqrt_0_d0*((T0*d_T0_dV_di_si+d_T0_dV_di_si*T0))));
d_vgd_overlap_dV_g_si = 0.5*(d_T0_dV_g_si-(deriv_sqrt_0_d0*((T0*d_T0_dV_g_si+d_T0_dV_g_si*T0))));
d_vgd_overlap_dV_g_e = 0.5*(d_T0_dV_g_e-(deriv_sqrt_0_d0*((T0*d_T0_dV_g_e+d_T0_dV_g_e*T0))));
d_vgd_overlap_dV_e_di = 0.5*(d_T0_dV_e_di-(deriv_sqrt_0_d0*((T0*d_T0_dV_e_di+d_T0_dV_e_di*T0))));
d_vgd_overlap_dV_e_si = 0.5*(d_T0_dV_e_si-(deriv_sqrt_0_d0*((T0*d_T0_dV_e_si+d_T0_dV_e_si*T0))));
d_vgd_overlap_dV_g_di = 0.5*(d_T0_dV_g_di-(deriv_sqrt_0_d0*((T0*d_T0_dV_g_di+d_T0_dV_g_di*T0))));
vgd_overlap = (0.5*(T0-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qgd_ov_dV_di_si = (T1*(CGDL_i*((d_T2_dV_di_si-d_vgd_overlap_dV_di_si)-(0.5*CKAPPAD_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgd_overlap_dV_di_si/CKAPPAD_i)))))+CGDO_i*d_T2_dV_di_si)+d_T1_dV_di_si*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
d_qgd_ov_dV_g_si = (T1*(CGDL_i*((d_T2_dV_g_si-d_vgd_overlap_dV_g_si)-(0.5*CKAPPAD_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgd_overlap_dV_g_si/CKAPPAD_i)))))+CGDO_i*d_T2_dV_g_si)+d_T1_dV_g_si*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
d_qgd_ov_dV_g_e = (T1*(CGDL_i*((d_T2_dV_g_e-d_vgd_overlap_dV_g_e)-(0.5*CKAPPAD_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgd_overlap_dV_g_e/CKAPPAD_i)))))+CGDO_i*d_T2_dV_g_e)+d_T1_dV_g_e*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
d_qgd_ov_dV_e_di = (T1*(CGDL_i*((d_T2_dV_e_di-d_vgd_overlap_dV_e_di)-(0.5*CKAPPAD_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgd_overlap_dV_e_di/CKAPPAD_i)))))+CGDO_i*d_T2_dV_e_di)+d_T1_dV_e_di*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
d_qgd_ov_dV_e_si = (T1*(CGDL_i*((d_T2_dV_e_si-d_vgd_overlap_dV_e_si)-(0.5*CKAPPAD_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgd_overlap_dV_e_si/CKAPPAD_i)))))+CGDO_i*d_T2_dV_e_si)+d_T1_dV_e_si*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
d_qgd_ov_dV_g_di = (T1*(CGDL_i*((d_T2_dV_g_di-d_vgd_overlap_dV_g_di)-(0.5*CKAPPAD_i)*(deriv_sqrt_0_d0*((-(4.0*d_vgd_overlap_dV_g_di/CKAPPAD_i)))))+CGDO_i*d_T2_dV_g_di)+d_T1_dV_g_di*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
qgd_ov = (T1*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
}
}
if (((model_.CGEOMOD)==0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
T1 = (NFINtotal*WeffCV0);

d_qgs_fr_dV_g_s =  0.0;
d_qgs_fr_dV_di_si = d_T1_dV_di_si*CFS_i*(probeVars[admsProbeID_V_g_si]);
d_qgs_fr_dV_g_si = ((T1*CFS_i)*d_probeVars[admsProbeID_V_g_si][admsProbeID_V_g_si]+d_T1_dV_g_si*CFS_i*(probeVars[admsProbeID_V_g_si]));
d_qgs_fr_dV_g_e = d_T1_dV_g_e*CFS_i*(probeVars[admsProbeID_V_g_si]);
d_qgs_fr_dV_e_di = d_T1_dV_e_di*CFS_i*(probeVars[admsProbeID_V_g_si]);
d_qgs_fr_dV_e_si = d_T1_dV_e_si*CFS_i*(probeVars[admsProbeID_V_g_si]);
d_qgs_fr_dV_g_di = d_T1_dV_g_di*CFS_i*(probeVars[admsProbeID_V_g_si]);
qgs_fr = ((T1*CFS_i)*(probeVars[admsProbeID_V_g_si]));

d_qgd_fr_dV_g_d =  0.0;
d_qgd_fr_dV_di_si = d_T1_dV_di_si*CFD_i*(probeVars[admsProbeID_V_g_di]);
d_qgd_fr_dV_g_si = d_T1_dV_g_si*CFD_i*(probeVars[admsProbeID_V_g_di]);
d_qgd_fr_dV_g_e = d_T1_dV_g_e*CFD_i*(probeVars[admsProbeID_V_g_di]);
d_qgd_fr_dV_e_di = d_T1_dV_e_di*CFD_i*(probeVars[admsProbeID_V_g_di]);
d_qgd_fr_dV_e_si = d_T1_dV_e_si*CFD_i*(probeVars[admsProbeID_V_g_di]);
d_qgd_fr_dV_g_di = ((T1*CFD_i)*d_probeVars[admsProbeID_V_g_di][admsProbeID_V_g_di]+d_T1_dV_g_di*CFD_i*(probeVars[admsProbeID_V_g_di]));
qgd_fr = ((T1*CFD_i)*(probeVars[admsProbeID_V_g_di]));

d_qgs_parasitic_dV_g_s =  0.0;
d_qgs_parasitic_dV_di_si = (d_qgs_ov_dV_di_si+d_qgs_fr_dV_di_si);
d_qgs_parasitic_dV_g_si = (d_qgs_ov_dV_g_si+d_qgs_fr_dV_g_si);
d_qgs_parasitic_dV_g_e = (d_qgs_ov_dV_g_e+d_qgs_fr_dV_g_e);
d_qgs_parasitic_dV_e_di = (d_qgs_ov_dV_e_di+d_qgs_fr_dV_e_di);
d_qgs_parasitic_dV_e_si = (d_qgs_ov_dV_e_si+d_qgs_fr_dV_e_si);
d_qgs_parasitic_dV_g_di = (d_qgs_ov_dV_g_di+d_qgs_fr_dV_g_di);
qgs_parasitic = (qgs_ov+qgs_fr);

d_qgd_parasitic_dV_g_d =  0.0;
d_qgd_parasitic_dV_di_si = (d_qgd_ov_dV_di_si+d_qgd_fr_dV_di_si);
d_qgd_parasitic_dV_g_si = (d_qgd_ov_dV_g_si+d_qgd_fr_dV_g_si);
d_qgd_parasitic_dV_g_e = (d_qgd_ov_dV_g_e+d_qgd_fr_dV_g_e);
d_qgd_parasitic_dV_e_di = (d_qgd_ov_dV_e_di+d_qgd_fr_dV_e_di);
d_qgd_parasitic_dV_e_si = (d_qgd_ov_dV_e_si+d_qgd_fr_dV_e_si);
d_qgd_parasitic_dV_g_di = (d_qgd_ov_dV_g_di+d_qgd_fr_dV_g_di);
qgd_parasitic = (qgd_ov+qgd_fr);
}
else
{
if (((model_.CGEOMOD)==1))
{
if (((model_.CGEO1SW)==1))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = (NFINtotal*WeffCV0);

d_COVS_i_dV_di_si = (T0*d_COVS_i_dV_di_si+d_T0_dV_di_si*COVS_i);
d_COVS_i_dV_g_si = (T0*d_COVS_i_dV_g_si+d_T0_dV_g_si*COVS_i);
d_COVS_i_dV_g_e = (T0*d_COVS_i_dV_g_e+d_T0_dV_g_e*COVS_i);
d_COVS_i_dV_e_di = (T0*d_COVS_i_dV_e_di+d_T0_dV_e_di*COVS_i);
d_COVS_i_dV_e_si = (T0*d_COVS_i_dV_e_si+d_T0_dV_e_si*COVS_i);
d_COVS_i_dV_g_di = (T0*d_COVS_i_dV_g_di+d_T0_dV_g_di*COVS_i);
COVS_i = (T0*COVS_i);

d_COVD_i_dV_di_si = (T0*d_COVD_i_dV_di_si+d_T0_dV_di_si*COVD_i);
d_COVD_i_dV_g_si = (T0*d_COVD_i_dV_g_si+d_T0_dV_g_si*COVD_i);
d_COVD_i_dV_g_e = (T0*d_COVD_i_dV_g_e+d_T0_dV_g_e*COVD_i);
d_COVD_i_dV_e_di = (T0*d_COVD_i_dV_e_di+d_T0_dV_e_di*COVD_i);
d_COVD_i_dV_e_si = (T0*d_COVD_i_dV_e_si+d_T0_dV_e_si*COVD_i);
d_COVD_i_dV_g_di = (T0*d_COVD_i_dV_g_di+d_T0_dV_g_di*COVD_i);
COVD_i = (T0*COVD_i);

d_cgsp_dV_di_si = d_T0_dV_di_si*CGSP;
d_cgsp_dV_g_si = d_T0_dV_g_si*CGSP;
d_cgsp_dV_g_e = d_T0_dV_g_e*CGSP;
d_cgsp_dV_e_di = d_T0_dV_e_di*CGSP;
d_cgsp_dV_e_si = d_T0_dV_e_si*CGSP;
d_cgsp_dV_g_di = d_T0_dV_g_di*CGSP;
cgsp = (T0*CGSP);

d_cgdp_dV_di_si = d_T0_dV_di_si*CGDP;
d_cgdp_dV_g_si = d_T0_dV_g_si*CGDP;
d_cgdp_dV_g_e = d_T0_dV_g_e*CGDP;
d_cgdp_dV_e_di = d_T0_dV_e_di*CGDP;
d_cgdp_dV_e_si = d_T0_dV_e_si*CGDP;
d_cgdp_dV_g_di = d_T0_dV_g_di*CGDP;
cgdp = (T0*CGDP);
}
else
{

d_cgsp_dV_g_di = d_cgsp_dV_e_si = d_cgsp_dV_e_di = d_cgsp_dV_g_e = d_cgsp_dV_g_si = d_cgsp_dV_di_si =  0.0;
cgsp = CGSP;

d_cgdp_dV_g_di = d_cgdp_dV_e_si = d_cgdp_dV_e_di = d_cgdp_dV_g_e = d_cgdp_dV_g_si = d_cgdp_dV_di_si =  0.0;
cgdp = CGDP;
}

d_qgs_ov_dV_di_si = d_COVS_i_dV_di_si*(probeVars[admsProbeID_V_g_si]);
d_qgs_ov_dV_g_si = (COVS_i*d_probeVars[admsProbeID_V_g_si][admsProbeID_V_g_si]+d_COVS_i_dV_g_si*(probeVars[admsProbeID_V_g_si]));
d_qgs_ov_dV_g_e = d_COVS_i_dV_g_e*(probeVars[admsProbeID_V_g_si]);
d_qgs_ov_dV_e_di = d_COVS_i_dV_e_di*(probeVars[admsProbeID_V_g_si]);
d_qgs_ov_dV_e_si = d_COVS_i_dV_e_si*(probeVars[admsProbeID_V_g_si]);
d_qgs_ov_dV_g_di = d_COVS_i_dV_g_di*(probeVars[admsProbeID_V_g_si]);
qgs_ov = (COVS_i*(probeVars[admsProbeID_V_g_si]));

d_qgd_ov_dV_di_si = d_COVD_i_dV_di_si*(probeVars[admsProbeID_V_g_di]);
d_qgd_ov_dV_g_si = d_COVD_i_dV_g_si*(probeVars[admsProbeID_V_g_di]);
d_qgd_ov_dV_g_e = d_COVD_i_dV_g_e*(probeVars[admsProbeID_V_g_di]);
d_qgd_ov_dV_e_di = d_COVD_i_dV_e_di*(probeVars[admsProbeID_V_g_di]);
d_qgd_ov_dV_e_si = d_COVD_i_dV_e_si*(probeVars[admsProbeID_V_g_di]);
d_qgd_ov_dV_g_di = (COVD_i*d_probeVars[admsProbeID_V_g_di][admsProbeID_V_g_di]+d_COVD_i_dV_g_di*(probeVars[admsProbeID_V_g_di]));
qgd_ov = (COVD_i*(probeVars[admsProbeID_V_g_di]));

d_qgs_parasitic_dV_g_s =  0.0;
d_qgs_parasitic_dV_di_si = d_qgs_ov_dV_di_si;
d_qgs_parasitic_dV_g_si = d_qgs_ov_dV_g_si;
d_qgs_parasitic_dV_g_e = d_qgs_ov_dV_g_e;
d_qgs_parasitic_dV_e_di = d_qgs_ov_dV_e_di;
d_qgs_parasitic_dV_e_si = d_qgs_ov_dV_e_si;
d_qgs_parasitic_dV_g_di = d_qgs_ov_dV_g_di;
qgs_parasitic = qgs_ov;

d_qgd_parasitic_dV_g_d =  0.0;
d_qgd_parasitic_dV_di_si = d_qgd_ov_dV_di_si;
d_qgd_parasitic_dV_g_si = d_qgd_ov_dV_g_si;
d_qgd_parasitic_dV_g_e = d_qgd_ov_dV_g_e;
d_qgd_parasitic_dV_e_di = d_qgd_ov_dV_e_di;
d_qgd_parasitic_dV_e_si = d_qgd_ov_dV_e_si;
d_qgd_parasitic_dV_g_di = d_qgd_ov_dV_g_di;
qgd_parasitic = qgd_ov;

d_qgs_fr_dV_g_s = cgsp*d_probeVars[admsProbeID_V_g_s][admsProbeID_V_g_s];
d_qgs_fr_dV_di_si = d_cgsp_dV_di_si*(probeVars[admsProbeID_V_g_s]);
d_qgs_fr_dV_g_si = d_cgsp_dV_g_si*(probeVars[admsProbeID_V_g_s]);
d_qgs_fr_dV_g_e = d_cgsp_dV_g_e*(probeVars[admsProbeID_V_g_s]);
d_qgs_fr_dV_e_di = d_cgsp_dV_e_di*(probeVars[admsProbeID_V_g_s]);
d_qgs_fr_dV_e_si = d_cgsp_dV_e_si*(probeVars[admsProbeID_V_g_s]);
d_qgs_fr_dV_g_di = d_cgsp_dV_g_di*(probeVars[admsProbeID_V_g_s]);
qgs_fr = (cgsp*(probeVars[admsProbeID_V_g_s]));

d_qgd_fr_dV_g_d = cgdp*d_probeVars[admsProbeID_V_g_d][admsProbeID_V_g_d];
d_qgd_fr_dV_di_si = d_cgdp_dV_di_si*(probeVars[admsProbeID_V_g_d]);
d_qgd_fr_dV_g_si = d_cgdp_dV_g_si*(probeVars[admsProbeID_V_g_d]);
d_qgd_fr_dV_g_e = d_cgdp_dV_g_e*(probeVars[admsProbeID_V_g_d]);
d_qgd_fr_dV_e_di = d_cgdp_dV_e_di*(probeVars[admsProbeID_V_g_d]);
d_qgd_fr_dV_e_si = d_cgdp_dV_e_si*(probeVars[admsProbeID_V_g_d]);
d_qgd_fr_dV_g_di = d_cgdp_dV_g_di*(probeVars[admsProbeID_V_g_d]);
qgd_fr = (cgdp*(probeVars[admsProbeID_V_g_d]));
}
else
{

d_qgs_fr_dV_g_s = d_qgs_fr_dV_g_di = d_qgs_fr_dV_e_si = d_qgs_fr_dV_e_di = d_qgs_fr_dV_g_e = d_qgs_fr_dV_di_si =  0.0;
d_qgs_fr_dV_g_si = Cfr_geo*d_probeVars[admsProbeID_V_g_si][admsProbeID_V_g_si];
qgs_fr = (Cfr_geo*(probeVars[admsProbeID_V_g_si]));

d_qgd_fr_dV_g_d = d_qgd_fr_dV_e_si = d_qgd_fr_dV_e_di = d_qgd_fr_dV_g_e = d_qgd_fr_dV_g_si = d_qgd_fr_dV_di_si =  0.0;
d_qgd_fr_dV_g_di = Cfr_geo*d_probeVars[admsProbeID_V_g_di][admsProbeID_V_g_di];
qgd_fr = (Cfr_geo*(probeVars[admsProbeID_V_g_di]));

d_qgs_parasitic_dV_g_s = d_qgs_fr_dV_g_s;
d_qgs_parasitic_dV_di_si = (d_qgs_ov_dV_di_si+d_qgs_fr_dV_di_si);
d_qgs_parasitic_dV_g_si = (d_qgs_ov_dV_g_si+d_qgs_fr_dV_g_si);
d_qgs_parasitic_dV_g_e = (d_qgs_ov_dV_g_e+d_qgs_fr_dV_g_e);
d_qgs_parasitic_dV_e_di = (d_qgs_ov_dV_e_di+d_qgs_fr_dV_e_di);
d_qgs_parasitic_dV_e_si = (d_qgs_ov_dV_e_si+d_qgs_fr_dV_e_si);
d_qgs_parasitic_dV_g_di = (d_qgs_ov_dV_g_di+d_qgs_fr_dV_g_di);
qgs_parasitic = (qgs_ov+qgs_fr);

d_qgd_parasitic_dV_g_d = d_qgd_fr_dV_g_d;
d_qgd_parasitic_dV_di_si = (d_qgd_ov_dV_di_si+d_qgd_fr_dV_di_si);
d_qgd_parasitic_dV_g_si = (d_qgd_ov_dV_g_si+d_qgd_fr_dV_g_si);
d_qgd_parasitic_dV_g_e = (d_qgd_ov_dV_g_e+d_qgd_fr_dV_g_e);
d_qgd_parasitic_dV_e_di = (d_qgd_ov_dV_e_di+d_qgd_fr_dV_e_di);
d_qgd_parasitic_dV_e_si = (d_qgd_ov_dV_e_si+d_qgd_fr_dV_e_si);
d_qgd_parasitic_dV_g_di = (d_qgd_ov_dV_g_di+d_qgd_fr_dV_g_di);
qgd_parasitic = (qgd_ov+qgd_fr);
}
}

d_qds_fr_dV_d_s = CDSP*d_probeVars[admsProbeID_V_d_s][admsProbeID_V_d_s];
qds_fr = (CDSP*(probeVars[admsProbeID_V_d_s]));

d_Iii_dV_g_di = d_Iii_dV_e_si = d_Iii_dV_e_di = d_Iii_dV_g_e = d_Iii_dV_g_si = d_Iii_dV_di_si =  0.0;
Iii = 0;
if (((model_.IIMOD)==1))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = ((ALPHA0_t+(ALPHA1_t*Leff))/Leff);
if (((T0<=0.0)||(BETA0_t<=0.0)))
{

d_Iii_dV_g_di = d_Iii_dV_e_si = d_Iii_dV_e_di = d_Iii_dV_g_e = d_Iii_dV_g_si = d_Iii_dV_di_si =  0.0;
Iii = 0.0;
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-(-BETA0_t)*d_diffVds_dV_g_si/(diffVds+1.0e-30)/(diffVds+1.0e-30));
d_T1_dV_g_e = (-(-BETA0_t)*d_diffVds_dV_g_e/(diffVds+1.0e-30)/(diffVds+1.0e-30));
d_T1_dV_e_di = (-(-BETA0_t)*d_diffVds_dV_e_di/(diffVds+1.0e-30)/(diffVds+1.0e-30));
d_T1_dV_e_si = (-(-BETA0_t)*d_diffVds_dV_e_si/(diffVds+1.0e-30)/(diffVds+1.0e-30));
d_T1_dV_di_si = (-(-BETA0_t)*d_diffVds_dV_di_si/(diffVds+1.0e-30)/(diffVds+1.0e-30));
T1 = ((-BETA0_t)/(diffVds+1.0e-30));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);

d_Iii_dV_di_si = (((T0*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_di_si)+((T0*diffVds)*d_ids_dV_di_si+(T0*d_diffVds_dV_di_si+d_T0_dV_di_si*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
d_Iii_dV_g_si = (((T0*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_si)+((T0*diffVds)*d_ids_dV_g_si+(T0*d_diffVds_dV_g_si+d_T0_dV_g_si*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
d_Iii_dV_g_e = (((T0*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_e)+((T0*diffVds)*d_ids_dV_g_e+(T0*d_diffVds_dV_g_e+d_T0_dV_g_e*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
d_Iii_dV_e_di = (((T0*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_e_di)+((T0*diffVds)*d_ids_dV_e_di+(T0*d_diffVds_dV_e_di+d_T0_dV_e_di*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
d_Iii_dV_e_si = (((T0*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_e_si)+((T0*diffVds)*d_ids_dV_e_si+(T0*d_diffVds_dV_e_si+d_T0_dV_e_si*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
d_Iii_dV_g_di = (((T0*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_di)+((T0*diffVds)*d_ids_dV_g_di+d_T0_dV_g_di*diffVds*ids)*evaluator_lexp_0.getValues(T1));
Iii = (((T0*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
}
}
}
else
{
if (((model_.IIMOD)==2))
{
ALPHAII = ((ALPHAII0_t+(ALPHAII1_t*Leff))/Leff);
if ((ALPHAII<=0.0))
{

d_Iii_dV_g_di = d_Iii_dV_e_si = d_Iii_dV_e_di = d_Iii_dV_g_e = d_Iii_dV_g_si = d_Iii_dV_di_si =  0.0;
Iii = 0.0;
}
else
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = (ESATII_i*Leff);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (((1.0+T0)*SII0_t*d_T0_dV_di_si-(SII0_t*T0)*d_T0_dV_di_si)/(1.0+T0)/(1.0+T0));
d_T1_dV_g_si = (((1.0+T0)*SII0_t*d_T0_dV_g_si-(SII0_t*T0)*d_T0_dV_g_si)/(1.0+T0)/(1.0+T0));
d_T1_dV_g_e = (((1.0+T0)*SII0_t*d_T0_dV_g_e-(SII0_t*T0)*d_T0_dV_g_e)/(1.0+T0)/(1.0+T0));
d_T1_dV_e_di = (((1.0+T0)*SII0_t*d_T0_dV_e_di-(SII0_t*T0)*d_T0_dV_e_di)/(1.0+T0)/(1.0+T0));
d_T1_dV_e_si = (((1.0+T0)*SII0_t*d_T0_dV_e_si-(SII0_t*T0)*d_T0_dV_e_si)/(1.0+T0)/(1.0+T0));
d_T1_dV_g_di = (((1.0+T0)*SII0_t*d_T0_dV_g_di-(SII0_t*T0)*d_T0_dV_g_di)/(1.0+T0)/(1.0+T0));
T1 = ((SII0_t*T0)/(1.0+T0));
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((SII1_i*vgsfbeff),1.0e-3);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e =  0.0;
d_T0_dV_di_si = (-evaluator_hypsmooth_0.getDerivs((SII1_i*vgsfbeff),1.0e-3,SII1_i*d_vgsfbeff_dV_di_si,0.0)/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3))/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3)));
d_T0_dV_g_si = (-evaluator_hypsmooth_0.getDerivs((SII1_i*vgsfbeff),1.0e-3,SII1_i*d_vgsfbeff_dV_g_si,0.0)/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3))/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3)));
T0 = (1.0/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3)));
}

d_T3_dV_di_si = d_T0_dV_di_si;
d_T3_dV_g_si = d_T0_dV_g_si;
d_T3_dV_g_e = d_T0_dV_g_e;
d_T3_dV_e_di = d_T0_dV_e_di;
d_T3_dV_e_si = d_T0_dV_e_si;
d_T3_dV_g_di = d_T0_dV_g_di;
T3 = (T0+SII2_i);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((vgsfbeff*T3),1.0e-3);

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_e_di = evaluator_hypsmooth_0.getDerivs((vgsfbeff*T3),1.0e-3,vgsfbeff*d_T3_dV_e_di,0.0);
d_T2_dV_e_si = evaluator_hypsmooth_0.getDerivs((vgsfbeff*T3),1.0e-3,vgsfbeff*d_T3_dV_e_si,0.0);
d_T2_dV_g_e = evaluator_hypsmooth_0.getDerivs((vgsfbeff*T3),1.0e-3,vgsfbeff*d_T3_dV_g_e,0.0);
d_T2_dV_g_di = evaluator_hypsmooth_0.getDerivs((vgsfbeff*T3),1.0e-3,vgsfbeff*d_T3_dV_g_di,0.0);
d_T2_dV_di_si = evaluator_hypsmooth_0.getDerivs((vgsfbeff*T3),1.0e-3,(vgsfbeff*d_T3_dV_di_si+d_vgsfbeff_dV_di_si*T3),0.0);
d_T2_dV_g_si = evaluator_hypsmooth_0.getDerivs((vgsfbeff*T3),1.0e-3,(vgsfbeff*d_T3_dV_g_si+d_vgsfbeff_dV_g_si*T3),0.0);
T2 = evaluator_hypsmooth_0.getValues((vgsfbeff*T3),1.0e-3);
}

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di =  0.0;
d_T3_dV_di_si = (-SIID_i*d_vds_dV_di_si/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
T3 = (1.0/(1.0+(SIID_i*vds)));

d_VgsStep_dV_di_si = ((T1*T2)*d_T3_dV_di_si+(T1*d_T2_dV_di_si+d_T1_dV_di_si*T2)*T3);
d_VgsStep_dV_g_si = ((T1*T2)*d_T3_dV_g_si+(T1*d_T2_dV_g_si+d_T1_dV_g_si*T2)*T3);
d_VgsStep_dV_g_e = ((T1*T2)*d_T3_dV_g_e+(T1*d_T2_dV_g_e+d_T1_dV_g_e*T2)*T3);
d_VgsStep_dV_e_di = ((T1*T2)*d_T3_dV_e_di+(T1*d_T2_dV_e_di+d_T1_dV_e_di*T2)*T3);
d_VgsStep_dV_e_si = ((T1*T2)*d_T3_dV_e_si+(T1*d_T2_dV_e_si+d_T1_dV_e_si*T2)*T3);
d_VgsStep_dV_g_di = ((T1*T2)*d_T3_dV_g_di+(T1*d_T2_dV_g_di+d_T1_dV_g_di*T2)*T3);
VgsStep = ((T1*T2)*T3);

d_Vdsatii_dV_di_si = d_VgsStep_dV_di_si*(1.0-(LII_i/Leff));
d_Vdsatii_dV_g_si = d_VgsStep_dV_g_si*(1.0-(LII_i/Leff));
d_Vdsatii_dV_g_e = d_VgsStep_dV_g_e*(1.0-(LII_i/Leff));
d_Vdsatii_dV_e_di = d_VgsStep_dV_e_di*(1.0-(LII_i/Leff));
d_Vdsatii_dV_e_si = d_VgsStep_dV_e_si*(1.0-(LII_i/Leff));
d_Vdsatii_dV_g_di = d_VgsStep_dV_g_di*(1.0-(LII_i/Leff));
Vdsatii = (VgsStep*(1.0-(LII_i/Leff)));

d_Vdiff_dV_g_si = (-d_Vdsatii_dV_g_si);
d_Vdiff_dV_g_e = (-d_Vdsatii_dV_g_e);
d_Vdiff_dV_e_di = (-d_Vdsatii_dV_e_di);
d_Vdiff_dV_e_si = (-d_Vdsatii_dV_e_si);
d_Vdiff_dV_g_di = (-d_Vdsatii_dV_g_di);
d_Vdiff_dV_di_si = (d_vds_dV_di_si-d_Vdsatii_dV_di_si);
Vdiff = (vds-Vdsatii);

d_T0_dV_g_si = (BETAII1_i*d_Vdiff_dV_g_si+((BETAII0_i*Vdiff)*d_Vdiff_dV_g_si+BETAII0_i*d_Vdiff_dV_g_si*Vdiff));
d_T0_dV_g_e = (BETAII1_i*d_Vdiff_dV_g_e+((BETAII0_i*Vdiff)*d_Vdiff_dV_g_e+BETAII0_i*d_Vdiff_dV_g_e*Vdiff));
d_T0_dV_e_di = (BETAII1_i*d_Vdiff_dV_e_di+((BETAII0_i*Vdiff)*d_Vdiff_dV_e_di+BETAII0_i*d_Vdiff_dV_e_di*Vdiff));
d_T0_dV_e_si = (BETAII1_i*d_Vdiff_dV_e_si+((BETAII0_i*Vdiff)*d_Vdiff_dV_e_si+BETAII0_i*d_Vdiff_dV_e_si*Vdiff));
d_T0_dV_g_di = (BETAII1_i*d_Vdiff_dV_g_di+((BETAII0_i*Vdiff)*d_Vdiff_dV_g_di+BETAII0_i*d_Vdiff_dV_g_di*Vdiff));
d_T0_dV_di_si = (BETAII1_i*d_Vdiff_dV_di_si+((BETAII0_i*Vdiff)*d_Vdiff_dV_di_si+BETAII0_i*d_Vdiff_dV_di_si*Vdiff));
T0 = ((BETAII2_i+(BETAII1_i*Vdiff))+((BETAII0_i*Vdiff)*Vdiff));
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0E-10));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_di_si+d_T0_dV_di_si*T0)));
d_T1_dV_g_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_si+d_T0_dV_g_si*T0)));
d_T1_dV_g_e = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_e+d_T0_dV_g_e*T0)));
d_T1_dV_e_di = (deriv_sqrt_0_d0*((T0*d_T0_dV_e_di+d_T0_dV_e_di*T0)));
d_T1_dV_e_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_e_si+d_T0_dV_e_si*T0)));
d_T1_dV_g_di = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_di+d_T0_dV_g_di*T0)));
T1 = value_sqrt_0;
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((Vdiff/T1));

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_g_si = (-ALPHAII*evaluator_lexp_0.getDerivs((Vdiff/T1),((T1*d_Vdiff_dV_g_si-Vdiff*d_T1_dV_g_si)/T1/T1)));
d_T2_dV_g_e = (-ALPHAII*evaluator_lexp_0.getDerivs((Vdiff/T1),((T1*d_Vdiff_dV_g_e-Vdiff*d_T1_dV_g_e)/T1/T1)));
d_T2_dV_e_di = (-ALPHAII*evaluator_lexp_0.getDerivs((Vdiff/T1),((T1*d_Vdiff_dV_e_di-Vdiff*d_T1_dV_e_di)/T1/T1)));
d_T2_dV_e_si = (-ALPHAII*evaluator_lexp_0.getDerivs((Vdiff/T1),((T1*d_Vdiff_dV_e_si-Vdiff*d_T1_dV_e_si)/T1/T1)));
d_T2_dV_g_di = (-ALPHAII*evaluator_lexp_0.getDerivs((Vdiff/T1),((T1*d_Vdiff_dV_g_di-Vdiff*d_T1_dV_g_di)/T1/T1)));
d_T2_dV_di_si = (-ALPHAII*evaluator_lexp_0.getDerivs((Vdiff/T1),((T1*d_Vdiff_dV_di_si-Vdiff*d_T1_dV_di_si)/T1/T1)));
T2 = ((10.0-(ALPHAII*evaluator_lexp_0.getValues((Vdiff/T1))))-0.01);
}
{
double value_sqrt_0 = sqrt(((T2*T2)+((4.0*10.0)*0.01)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Ratio_dV_di_si = (-0.5*(d_T2_dV_di_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_di_si+d_T2_dV_di_si*T2)))));
d_Ratio_dV_e_di = (-0.5*(d_T2_dV_e_di+(deriv_sqrt_0_d0*((T2*d_T2_dV_e_di+d_T2_dV_e_di*T2)))));
d_Ratio_dV_e_si = (-0.5*(d_T2_dV_e_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_e_si+d_T2_dV_e_si*T2)))));
d_Ratio_dV_g_si = (-0.5*(d_T2_dV_g_si+(deriv_sqrt_0_d0*((T2*d_T2_dV_g_si+d_T2_dV_g_si*T2)))));
d_Ratio_dV_g_e = (-0.5*(d_T2_dV_g_e+(deriv_sqrt_0_d0*((T2*d_T2_dV_g_e+d_T2_dV_g_e*T2)))));
d_Ratio_dV_g_di = (-0.5*(d_T2_dV_g_di+(deriv_sqrt_0_d0*((T2*d_T2_dV_g_di+d_T2_dV_g_di*T2)))));
Ratio = (10.0-(0.5*(T2+value_sqrt_0)));
}

d_Iii_dV_di_si = (Ratio*d_ids_dV_di_si+d_Ratio_dV_di_si*ids);
d_Iii_dV_e_di = (Ratio*d_ids_dV_e_di+d_Ratio_dV_e_di*ids);
d_Iii_dV_e_si = (Ratio*d_ids_dV_e_si+d_Ratio_dV_e_si*ids);
d_Iii_dV_g_si = (Ratio*d_ids_dV_g_si+d_Ratio_dV_g_si*ids);
d_Iii_dV_g_e = (Ratio*d_ids_dV_g_e+d_Ratio_dV_g_e*ids);
d_Iii_dV_g_di = (Ratio*d_ids_dV_g_di+d_Ratio_dV_g_di*ids);
Iii = (Ratio*ids);
}
}
}

d_igbinv_dV_g_si = d_igbinv_dV_di_si = d_igbinv_dV_e_si = d_igbinv_dV_e_di = d_igbinv_dV_g_e = d_igbinv_dV_g_di = d_igbinv_dV_di_d = d_igbinv_dV_si_s =  0.0;
igbinv = 0.0;

d_igbacc_dV_g_si = d_igbacc_dV_di_si = d_igbacc_dV_e_si = d_igbacc_dV_e_di = d_igbacc_dV_g_e = d_igbacc_dV_g_di = d_igbacc_dV_di_d = d_igbacc_dV_si_s =  0.0;
igbacc = 0.0;

d_igcs_dV_g_di = d_igcs_dV_di_si = d_igcs_dV_e_si = d_igcs_dV_e_di = d_igcs_dV_g_e = d_igcs_dV_g_si = d_igcs_dV_di_d = d_igcs_dV_si_s =  0.0;
igcs = 0.0;

d_igcd_dV_g_di = d_igcd_dV_di_si = d_igcd_dV_e_si = d_igcd_dV_e_di = d_igcd_dV_g_e = d_igcd_dV_g_si = d_igcd_dV_di_d = d_igcd_dV_si_s =  0.0;
igcd = 0.0;

d_igs_dV_g_si = d_igs_dV_g_di = d_igs_dV_g_e = d_igs_dV_e_si = d_igs_dV_e_di = d_igs_dV_di_si =  0.0;
igs = 0.0;

d_igd_dV_g_si = d_igd_dV_g_di = d_igd_dV_g_e = d_igd_dV_e_si = d_igd_dV_e_di = d_igd_dV_di_si =  0.0;
igd = 0.0;
if (((model_.IGBMOD)!=0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = ((d_qia_dV_g_si/NIGBINV_i)/Vtm);
d_T1_dV_g_e = ((d_qia_dV_g_e/NIGBINV_i)/Vtm);
d_T1_dV_e_di = ((d_qia_dV_e_di/NIGBINV_i)/Vtm);
d_T1_dV_e_si = ((d_qia_dV_e_si/NIGBINV_i)/Vtm);
d_T1_dV_di_si = ((d_qia_dV_di_si/NIGBINV_i)/Vtm);
T1 = (((qia-EIGBINV_i)/NIGBINV_i)/Vtm);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(T1)));

d_Vaux_Igbinv_dV_di_si = (NIGBINV_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_di_si));
d_Vaux_Igbinv_dV_g_si = (NIGBINV_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_si));
d_Vaux_Igbinv_dV_g_e = (NIGBINV_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_e));
d_Vaux_Igbinv_dV_e_di = (NIGBINV_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_e_di));
d_Vaux_Igbinv_dV_e_si = (NIGBINV_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_e_si));
d_Vaux_Igbinv_dV_g_di = (NIGBINV_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_di));
Vaux_Igbinv = ((NIGBINV_i*Vtm)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(T1))));
}

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_g_si = (-BIGBINV_i*d_qia_dV_g_si);
d_T2_dV_g_e = (-BIGBINV_i*d_qia_dV_g_e);
d_T2_dV_e_di = (-BIGBINV_i*d_qia_dV_e_di);
d_T2_dV_e_si = (-BIGBINV_i*d_qia_dV_e_si);
d_T2_dV_di_si = (-BIGBINV_i*d_qia_dV_di_si);
T2 = (AIGBINV_t-(BIGBINV_i*qia));

d_T3_dV_g_di =  0.0;
d_T3_dV_g_si = CIGBINV_i*d_qia_dV_g_si;
d_T3_dV_g_e = CIGBINV_i*d_qia_dV_g_e;
d_T3_dV_e_di = CIGBINV_i*d_qia_dV_e_di;
d_T3_dV_e_si = CIGBINV_i*d_qia_dV_e_si;
d_T3_dV_di_si = CIGBINV_i*d_qia_dV_di_si;
T3 = (1+(CIGBINV_i*qia));

d_T4_dV_di_si = ((((-9.82222e11)*(model_.TOXG))*T2)*d_T3_dV_di_si+((-9.82222e11)*(model_.TOXG))*d_T2_dV_di_si*T3);
d_T4_dV_e_di = ((((-9.82222e11)*(model_.TOXG))*T2)*d_T3_dV_e_di+((-9.82222e11)*(model_.TOXG))*d_T2_dV_e_di*T3);
d_T4_dV_e_si = ((((-9.82222e11)*(model_.TOXG))*T2)*d_T3_dV_e_si+((-9.82222e11)*(model_.TOXG))*d_T2_dV_e_si*T3);
d_T4_dV_g_si = ((((-9.82222e11)*(model_.TOXG))*T2)*d_T3_dV_g_si+((-9.82222e11)*(model_.TOXG))*d_T2_dV_g_si*T3);
d_T4_dV_g_e = ((((-9.82222e11)*(model_.TOXG))*T2)*d_T3_dV_g_e+((-9.82222e11)*(model_.TOXG))*d_T2_dV_g_e*T3);
d_T4_dV_g_di = ((((-9.82222e11)*(model_.TOXG))*T2)*d_T3_dV_g_di+((-9.82222e11)*(model_.TOXG))*d_T2_dV_g_di*T3);
T4 = ((((-9.82222e11)*(model_.TOXG))*T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_g_si = evaluator_lexp_0.getDerivs(T4,d_T4_dV_g_si);
d_T5_dV_g_e = evaluator_lexp_0.getDerivs(T4,d_T4_dV_g_e);
d_T5_dV_e_di = evaluator_lexp_0.getDerivs(T4,d_T4_dV_e_di);
d_T5_dV_e_si = evaluator_lexp_0.getDerivs(T4,d_T4_dV_e_si);
d_T5_dV_di_si = evaluator_lexp_0.getDerivs(T4,d_T4_dV_di_si);
d_T5_dV_g_di = evaluator_lexp_0.getDerivs(T4,d_T4_dV_g_di);
T5 = evaluator_lexp_0.getValues(T4);
}

d_T6_dV_g_di = d_T6_dV_di_d = d_T6_dV_si_s = d_T6_dV_g_si = d_T6_dV_di_si = d_T6_dV_e_si = d_T6_dV_e_di = d_T6_dV_g_e =  0.0;
T6 = 3.75956e-7;

d_igbinv_dV_si_s = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_si_s+(Weff0*Leff)*d_T6_dV_si_s*Toxratio*vge*Vaux_Igbinv*T5);
d_igbinv_dV_di_d = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_di_d+(Weff0*Leff)*d_T6_dV_di_d*Toxratio*vge*Vaux_Igbinv*T5);
d_igbinv_dV_g_di = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_g_di+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbinv_dV_g_di+(Weff0*Leff)*d_T6_dV_g_di*Toxratio*vge*Vaux_Igbinv)*T5);
d_igbinv_dV_g_e = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_g_e+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbinv_dV_g_e+((((Weff0*Leff)*T6)*Toxratio)*d_vge_dV_g_e+(Weff0*Leff)*d_T6_dV_g_e*Toxratio*vge)*Vaux_Igbinv)*T5);
d_igbinv_dV_e_di = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_e_di+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbinv_dV_e_di+(Weff0*Leff)*d_T6_dV_e_di*Toxratio*vge*Vaux_Igbinv)*T5);
d_igbinv_dV_e_si = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_e_si+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbinv_dV_e_si+(Weff0*Leff)*d_T6_dV_e_si*Toxratio*vge*Vaux_Igbinv)*T5);
d_igbinv_dV_di_si = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_di_si+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbinv_dV_di_si+(Weff0*Leff)*d_T6_dV_di_si*Toxratio*vge*Vaux_Igbinv)*T5);
d_igbinv_dV_g_si = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dV_g_si+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbinv_dV_g_si+(Weff0*Leff)*d_T6_dV_g_si*Toxratio*vge*Vaux_Igbinv)*T5);
igbinv = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5);

d_igbinv_dV_si_s = d_igbinv_dV_si_s*igtemp;
d_igbinv_dV_di_d = d_igbinv_dV_di_d*igtemp;
d_igbinv_dV_g_di = d_igbinv_dV_g_di*igtemp;
d_igbinv_dV_g_e = d_igbinv_dV_g_e*igtemp;
d_igbinv_dV_e_di = d_igbinv_dV_e_di*igtemp;
d_igbinv_dV_e_si = d_igbinv_dV_e_si*igtemp;
d_igbinv_dV_di_si = d_igbinv_dV_di_si*igtemp;
d_igbinv_dV_g_si = d_igbinv_dV_g_si*igtemp;
igbinv = (igbinv*igtemp);
vfbzb = ((deltaPhi-(Eg/2.0))-phib);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_g_e = (-d_vge_dV_g_e);
T0 = (vfbzb-vge);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = ((d_T0_dV_di_si/NIGBACC_i)/Vtm);
d_T1_dV_g_si = ((d_T0_dV_g_si/NIGBACC_i)/Vtm);
d_T1_dV_g_e = ((d_T0_dV_g_e/NIGBACC_i)/Vtm);
d_T1_dV_e_di = ((d_T0_dV_e_di/NIGBACC_i)/Vtm);
d_T1_dV_e_si = ((d_T0_dV_e_si/NIGBACC_i)/Vtm);
d_T1_dV_g_di = ((d_T0_dV_g_di/NIGBACC_i)/Vtm);
T1 = ((T0/NIGBACC_i)/Vtm);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(T1)));

d_Vaux_Igbacc_dV_di_si = (NIGBACC_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_di_si));
d_Vaux_Igbacc_dV_g_si = (NIGBACC_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_si));
d_Vaux_Igbacc_dV_g_e = (NIGBACC_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_e));
d_Vaux_Igbacc_dV_e_di = (NIGBACC_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_e_di));
d_Vaux_Igbacc_dV_e_si = (NIGBACC_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_e_si));
d_Vaux_Igbacc_dV_g_di = (NIGBACC_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dV_g_di));
Vaux_Igbacc = ((NIGBACC_i*Vtm)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(T1))));
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{

d_Voxacc_dV_g_di =  0.0;
d_Voxacc_dV_di_si = d_qi_acc_dV_di_si;
d_Voxacc_dV_g_si = d_qi_acc_dV_g_si;
d_Voxacc_dV_g_e = d_qi_acc_dV_g_e;
d_Voxacc_dV_e_di = d_qi_acc_dV_e_di;
d_Voxacc_dV_e_si = d_qi_acc_dV_e_si;
Voxacc = qi_acc;
}
else
{
if ((vfbzb<=0))
{
{
double value_sqrt_0 = sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Voxacc_dV_di_si = 0.5*(d_T0_dV_di_si+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_di_si+d_T0_dV_di_si*(T0-0.02)))));
d_Voxacc_dV_g_si = 0.5*(d_T0_dV_g_si+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_g_si+d_T0_dV_g_si*(T0-0.02)))));
d_Voxacc_dV_g_e = 0.5*(d_T0_dV_g_e+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_g_e+d_T0_dV_g_e*(T0-0.02)))));
d_Voxacc_dV_e_di = 0.5*(d_T0_dV_e_di+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_e_di+d_T0_dV_e_di*(T0-0.02)))));
d_Voxacc_dV_e_si = 0.5*(d_T0_dV_e_si+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_e_si+d_T0_dV_e_si*(T0-0.02)))));
d_Voxacc_dV_g_di = 0.5*(d_T0_dV_g_di+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_g_di+d_T0_dV_g_di*(T0-0.02)))));
Voxacc = (0.5*((T0-0.02)+value_sqrt_0));
}
}
else
{
{
double value_sqrt_0 = sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Voxacc_dV_di_si = 0.5*(d_T0_dV_di_si+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_di_si+d_T0_dV_di_si*(T0-0.02)))));
d_Voxacc_dV_g_si = 0.5*(d_T0_dV_g_si+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_g_si+d_T0_dV_g_si*(T0-0.02)))));
d_Voxacc_dV_g_e = 0.5*(d_T0_dV_g_e+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_g_e+d_T0_dV_g_e*(T0-0.02)))));
d_Voxacc_dV_e_di = 0.5*(d_T0_dV_e_di+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_e_di+d_T0_dV_e_di*(T0-0.02)))));
d_Voxacc_dV_e_si = 0.5*(d_T0_dV_e_si+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_e_si+d_T0_dV_e_si*(T0-0.02)))));
d_Voxacc_dV_g_di = 0.5*(d_T0_dV_g_di+(deriv_sqrt_0_d0*(((T0-0.02)*d_T0_dV_g_di+d_T0_dV_g_di*(T0-0.02)))));
Voxacc = (0.5*((T0-0.02)+value_sqrt_0));
}
}
}

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_di_si = (-BIGBACC_i*d_Voxacc_dV_di_si);
d_T2_dV_g_si = (-BIGBACC_i*d_Voxacc_dV_g_si);
d_T2_dV_g_e = (-BIGBACC_i*d_Voxacc_dV_g_e);
d_T2_dV_e_di = (-BIGBACC_i*d_Voxacc_dV_e_di);
d_T2_dV_e_si = (-BIGBACC_i*d_Voxacc_dV_e_si);
d_T2_dV_g_di = (-BIGBACC_i*d_Voxacc_dV_g_di);
T2 = (AIGBACC_t-(BIGBACC_i*Voxacc));

d_T3_dV_di_si = CIGBACC_i*d_Voxacc_dV_di_si;
d_T3_dV_g_si = CIGBACC_i*d_Voxacc_dV_g_si;
d_T3_dV_g_e = CIGBACC_i*d_Voxacc_dV_g_e;
d_T3_dV_e_di = CIGBACC_i*d_Voxacc_dV_e_di;
d_T3_dV_e_si = CIGBACC_i*d_Voxacc_dV_e_si;
d_T3_dV_g_di = CIGBACC_i*d_Voxacc_dV_g_di;
T3 = (1+(CIGBACC_i*Voxacc));

d_T4_dV_di_si = ((((-7.45669e11)*(model_.TOXG))*T2)*d_T3_dV_di_si+((-7.45669e11)*(model_.TOXG))*d_T2_dV_di_si*T3);
d_T4_dV_e_di = ((((-7.45669e11)*(model_.TOXG))*T2)*d_T3_dV_e_di+((-7.45669e11)*(model_.TOXG))*d_T2_dV_e_di*T3);
d_T4_dV_e_si = ((((-7.45669e11)*(model_.TOXG))*T2)*d_T3_dV_e_si+((-7.45669e11)*(model_.TOXG))*d_T2_dV_e_si*T3);
d_T4_dV_g_si = ((((-7.45669e11)*(model_.TOXG))*T2)*d_T3_dV_g_si+((-7.45669e11)*(model_.TOXG))*d_T2_dV_g_si*T3);
d_T4_dV_g_e = ((((-7.45669e11)*(model_.TOXG))*T2)*d_T3_dV_g_e+((-7.45669e11)*(model_.TOXG))*d_T2_dV_g_e*T3);
d_T4_dV_g_di = ((((-7.45669e11)*(model_.TOXG))*T2)*d_T3_dV_g_di+((-7.45669e11)*(model_.TOXG))*d_T2_dV_g_di*T3);
T4 = ((((-7.45669e11)*(model_.TOXG))*T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_g_si = evaluator_lexp_0.getDerivs(T4,d_T4_dV_g_si);
d_T5_dV_g_e = evaluator_lexp_0.getDerivs(T4,d_T4_dV_g_e);
d_T5_dV_e_di = evaluator_lexp_0.getDerivs(T4,d_T4_dV_e_di);
d_T5_dV_e_si = evaluator_lexp_0.getDerivs(T4,d_T4_dV_e_si);
d_T5_dV_di_si = evaluator_lexp_0.getDerivs(T4,d_T4_dV_di_si);
d_T5_dV_g_di = evaluator_lexp_0.getDerivs(T4,d_T4_dV_g_di);
T5 = evaluator_lexp_0.getValues(T4);
}

d_T6_dV_g_di = d_T6_dV_di_d = d_T6_dV_si_s = d_T6_dV_g_si = d_T6_dV_di_si = d_T6_dV_e_si = d_T6_dV_e_di = d_T6_dV_g_e =  0.0;
T6 = 4.97232e-7;

d_igbacc_dV_si_s = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_si_s+(Weff0*Leff)*d_T6_dV_si_s*Toxratio*vge*Vaux_Igbacc*T5);
d_igbacc_dV_di_d = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_di_d+(Weff0*Leff)*d_T6_dV_di_d*Toxratio*vge*Vaux_Igbacc*T5);
d_igbacc_dV_g_di = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_g_di+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbacc_dV_g_di+(Weff0*Leff)*d_T6_dV_g_di*Toxratio*vge*Vaux_Igbacc)*T5);
d_igbacc_dV_g_e = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_g_e+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbacc_dV_g_e+((((Weff0*Leff)*T6)*Toxratio)*d_vge_dV_g_e+(Weff0*Leff)*d_T6_dV_g_e*Toxratio*vge)*Vaux_Igbacc)*T5);
d_igbacc_dV_e_di = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_e_di+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbacc_dV_e_di+(Weff0*Leff)*d_T6_dV_e_di*Toxratio*vge*Vaux_Igbacc)*T5);
d_igbacc_dV_e_si = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_e_si+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbacc_dV_e_si+(Weff0*Leff)*d_T6_dV_e_si*Toxratio*vge*Vaux_Igbacc)*T5);
d_igbacc_dV_di_si = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_di_si+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbacc_dV_di_si+(Weff0*Leff)*d_T6_dV_di_si*Toxratio*vge*Vaux_Igbacc)*T5);
d_igbacc_dV_g_si = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dV_g_si+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbacc_dV_g_si+(Weff0*Leff)*d_T6_dV_g_si*Toxratio*vge*Vaux_Igbacc)*T5);
igbacc = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5);

d_igbacc_dV_si_s = d_igbacc_dV_si_s*igtemp;
d_igbacc_dV_di_d = d_igbacc_dV_di_d*igtemp;
d_igbacc_dV_g_di = d_igbacc_dV_g_di*igtemp;
d_igbacc_dV_g_e = d_igbacc_dV_g_e*igtemp;
d_igbacc_dV_e_di = d_igbacc_dV_e_di*igtemp;
d_igbacc_dV_e_si = d_igbacc_dV_e_si*igtemp;
d_igbacc_dV_di_si = d_igbacc_dV_di_si*igtemp;
d_igbacc_dV_g_si = d_igbacc_dV_g_si*igtemp;
igbacc = (igbacc*igtemp);
}
if (((model_.IGCMOD)!=0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = (-BIGC_i*d_qia_dV_g_si);
d_T1_dV_g_e = (-BIGC_i*d_qia_dV_g_e);
d_T1_dV_e_di = (-BIGC_i*d_qia_dV_e_di);
d_T1_dV_e_si = (-BIGC_i*d_qia_dV_e_si);
d_T1_dV_di_si = (-BIGC_i*d_qia_dV_di_si);
T1 = (AIGC_t-(BIGC_i*qia));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_g_si = CIGC_i*d_qia_dV_g_si;
d_T2_dV_g_e = CIGC_i*d_qia_dV_g_e;
d_T2_dV_e_di = CIGC_i*d_qia_dV_e_di;
d_T2_dV_e_si = CIGC_i*d_qia_dV_e_si;
d_T2_dV_di_si = CIGC_i*d_qia_dV_di_si;
T2 = (1.0+(CIGC_i*qia));

d_T3_dV_di_si = ((((-Bechvb)*(model_.TOXG))*T1)*d_T2_dV_di_si+((-Bechvb)*(model_.TOXG))*d_T1_dV_di_si*T2);
d_T3_dV_g_si = ((((-Bechvb)*(model_.TOXG))*T1)*d_T2_dV_g_si+((-Bechvb)*(model_.TOXG))*d_T1_dV_g_si*T2);
d_T3_dV_g_e = ((((-Bechvb)*(model_.TOXG))*T1)*d_T2_dV_g_e+((-Bechvb)*(model_.TOXG))*d_T1_dV_g_e*T2);
d_T3_dV_e_di = ((((-Bechvb)*(model_.TOXG))*T1)*d_T2_dV_e_di+((-Bechvb)*(model_.TOXG))*d_T1_dV_e_di*T2);
d_T3_dV_e_si = ((((-Bechvb)*(model_.TOXG))*T1)*d_T2_dV_e_si+((-Bechvb)*(model_.TOXG))*d_T1_dV_e_si*T2);
d_T3_dV_g_di = ((((-Bechvb)*(model_.TOXG))*T1)*d_T2_dV_g_di+((-Bechvb)*(model_.TOXG))*d_T1_dV_g_di*T2);
T3 = ((((-Bechvb)*(model_.TOXG))*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);

d_T4_dV_g_di = qia*evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_di);
d_T4_dV_g_si = (qia*evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_si)+d_qia_dV_g_si*evaluator_lexp_0.getValues(T3));
d_T4_dV_g_e = (qia*evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_e)+d_qia_dV_g_e*evaluator_lexp_0.getValues(T3));
d_T4_dV_e_di = (qia*evaluator_lexp_0.getDerivs(T3,d_T3_dV_e_di)+d_qia_dV_e_di*evaluator_lexp_0.getValues(T3));
d_T4_dV_e_si = (qia*evaluator_lexp_0.getDerivs(T3,d_T3_dV_e_si)+d_qia_dV_e_si*evaluator_lexp_0.getValues(T3));
d_T4_dV_di_si = (qia*evaluator_lexp_0.getDerivs(T3,d_T3_dV_di_si)+d_qia_dV_di_si*evaluator_lexp_0.getValues(T3));
T4 = (qia*evaluator_lexp_0.getValues(T3));
}

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_si_s = d_T5_dV_g_si =  0.0;
d_T5_dV_e_di = 0.5*d_ved_jct_dV_e_di;
d_T5_dV_e_si = 0.5*d_ves_jct_dV_e_si;
d_T5_dV_di_si = 0.5*d_vdsx_dV_di_si;
d_T5_dV_g_e = d_vge_dV_g_e;
T5 = ((vge+(0.5*vdsx))+(0.5*(ves_jct+ved_jct)));

d_igc0_dV_si_s = ((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_si_s*igtemp;
d_igc0_dV_di_d = ((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_di_d*igtemp;
d_igc0_dV_g_si = (((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_g_si+(((Weff0*Leff)*Aechvb)*Toxratio)*d_T4_dV_g_si*T5)*igtemp;
d_igc0_dV_g_e = (((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_g_e+(((Weff0*Leff)*Aechvb)*Toxratio)*d_T4_dV_g_e*T5)*igtemp;
d_igc0_dV_e_di = (((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_e_di+(((Weff0*Leff)*Aechvb)*Toxratio)*d_T4_dV_e_di*T5)*igtemp;
d_igc0_dV_e_si = (((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_e_si+(((Weff0*Leff)*Aechvb)*Toxratio)*d_T4_dV_e_si*T5)*igtemp;
d_igc0_dV_di_si = (((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_di_si+(((Weff0*Leff)*Aechvb)*Toxratio)*d_T4_dV_di_si*T5)*igtemp;
d_igc0_dV_g_di = (((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dV_g_di+(((Weff0*Leff)*Aechvb)*Toxratio)*d_T4_dV_g_di*T5)*igtemp;
igc0 = ((((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*igtemp);
{
double value_sqrt_0 = sqrt(((Vdseff*Vdseff)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdseffx_dV_g_si = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_g_si+d_Vdseff_dV_g_si*Vdseff)));
d_Vdseffx_dV_g_e = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_g_e+d_Vdseff_dV_g_e*Vdseff)));
d_Vdseffx_dV_e_di = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_e_di+d_Vdseff_dV_e_di*Vdseff)));
d_Vdseffx_dV_e_si = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_e_si+d_Vdseff_dV_e_si*Vdseff)));
d_Vdseffx_dV_di_si = (deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dV_di_si+d_Vdseff_dV_di_si*Vdseff)));
Vdseffx = (value_sqrt_0-0.1);
}

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di =  0.0;
d_T1_dV_g_si = PIGCD_i*d_Vdseffx_dV_g_si;
d_T1_dV_g_e = PIGCD_i*d_Vdseffx_dV_g_e;
d_T1_dV_e_di = PIGCD_i*d_Vdseffx_dV_e_di;
d_T1_dV_e_si = PIGCD_i*d_Vdseffx_dV_e_si;
d_T1_dV_di_si = PIGCD_i*d_Vdseffx_dV_di_si;
T1 = (PIGCD_i*Vdseffx);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));

d_T1_exp_dV_di_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_si));
d_T1_exp_dV_g_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_si));
d_T1_exp_dV_g_e = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_e));
d_T1_exp_dV_e_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_di));
d_T1_exp_dV_e_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_si));
d_T1_exp_dV_g_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_di));
T1_exp = evaluator_lexp_0.getValues((-T1));
}

d_T3_dV_di_si = (d_T1_dV_di_si+d_T1_exp_dV_di_si);
d_T3_dV_g_si = (d_T1_dV_g_si+d_T1_exp_dV_g_si);
d_T3_dV_g_e = (d_T1_dV_g_e+d_T1_exp_dV_g_e);
d_T3_dV_e_di = (d_T1_dV_e_di+d_T1_exp_dV_e_di);
d_T3_dV_e_si = (d_T1_dV_e_si+d_T1_exp_dV_e_si);
d_T3_dV_g_di = (d_T1_dV_g_di+d_T1_exp_dV_g_di);
T3 = (((T1+T1_exp)-1.0)+1.0E-4);

d_T4_dV_di_si = (-((T1+1.0)*d_T1_exp_dV_di_si+d_T1_dV_di_si*T1_exp));
d_T4_dV_g_si = (-((T1+1.0)*d_T1_exp_dV_g_si+d_T1_dV_g_si*T1_exp));
d_T4_dV_g_e = (-((T1+1.0)*d_T1_exp_dV_g_e+d_T1_dV_g_e*T1_exp));
d_T4_dV_e_di = (-((T1+1.0)*d_T1_exp_dV_e_di+d_T1_dV_e_di*T1_exp));
d_T4_dV_e_si = (-((T1+1.0)*d_T1_exp_dV_e_si+d_T1_dV_e_si*T1_exp));
d_T4_dV_g_di = (-((T1+1.0)*d_T1_exp_dV_g_di+d_T1_dV_g_di*T1_exp));
T4 = ((1.0-((T1+1.0)*T1_exp))+1.0E-4);

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (T1*d_T1_dV_di_si+d_T1_dV_di_si*T1);
d_T5_dV_g_si = (T1*d_T1_dV_g_si+d_T1_dV_g_si*T1);
d_T5_dV_g_e = (T1*d_T1_dV_g_e+d_T1_dV_g_e*T1);
d_T5_dV_e_di = (T1*d_T1_dV_e_di+d_T1_dV_e_di*T1);
d_T5_dV_e_si = (T1*d_T1_dV_e_si+d_T1_dV_e_si*T1);
d_T5_dV_g_di = (T1*d_T1_dV_g_di+d_T1_dV_g_di*T1);
T5 = ((T1*T1)+2.0E-4);

d_igcd_dV_si_s = ((T5*d_igc0_dV_si_s*T4-(igc0*T4)*d_T5_dV_si_s)/T5/T5);
d_igcd_dV_di_d = ((T5*d_igc0_dV_di_d*T4-(igc0*T4)*d_T5_dV_di_d)/T5/T5);
d_igcd_dV_g_si = ((T5*(igc0*d_T4_dV_g_si+d_igc0_dV_g_si*T4)-(igc0*T4)*d_T5_dV_g_si)/T5/T5);
d_igcd_dV_g_e = ((T5*(igc0*d_T4_dV_g_e+d_igc0_dV_g_e*T4)-(igc0*T4)*d_T5_dV_g_e)/T5/T5);
d_igcd_dV_e_di = ((T5*(igc0*d_T4_dV_e_di+d_igc0_dV_e_di*T4)-(igc0*T4)*d_T5_dV_e_di)/T5/T5);
d_igcd_dV_e_si = ((T5*(igc0*d_T4_dV_e_si+d_igc0_dV_e_si*T4)-(igc0*T4)*d_T5_dV_e_si)/T5/T5);
d_igcd_dV_di_si = ((T5*(igc0*d_T4_dV_di_si+d_igc0_dV_di_si*T4)-(igc0*T4)*d_T5_dV_di_si)/T5/T5);
d_igcd_dV_g_di = ((T5*(igc0*d_T4_dV_g_di+d_igc0_dV_g_di*T4)-(igc0*T4)*d_T5_dV_g_di)/T5/T5);
igcd = ((igc0*T4)/T5);

d_igcs_dV_si_s = ((T5*d_igc0_dV_si_s*T3-(igc0*T3)*d_T5_dV_si_s)/T5/T5);
d_igcs_dV_di_d = ((T5*d_igc0_dV_di_d*T3-(igc0*T3)*d_T5_dV_di_d)/T5/T5);
d_igcs_dV_g_si = ((T5*(igc0*d_T3_dV_g_si+d_igc0_dV_g_si*T3)-(igc0*T3)*d_T5_dV_g_si)/T5/T5);
d_igcs_dV_g_e = ((T5*(igc0*d_T3_dV_g_e+d_igc0_dV_g_e*T3)-(igc0*T3)*d_T5_dV_g_e)/T5/T5);
d_igcs_dV_e_di = ((T5*(igc0*d_T3_dV_e_di+d_igc0_dV_e_di*T3)-(igc0*T3)*d_T5_dV_e_di)/T5/T5);
d_igcs_dV_e_si = ((T5*(igc0*d_T3_dV_e_si+d_igc0_dV_e_si*T3)-(igc0*T3)*d_T5_dV_e_si)/T5/T5);
d_igcs_dV_di_si = ((T5*(igc0*d_T3_dV_di_si+d_igc0_dV_di_si*T3)-(igc0*T3)*d_T5_dV_di_si)/T5/T5);
d_igcs_dV_g_di = ((T5*(igc0*d_T3_dV_g_di+d_igc0_dV_g_di*T3)-(igc0*T3)*d_T5_dV_g_di)/T5/T5);
igcs = ((igc0*T3)/T5);

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_di_si =  0.0;
d_T0_dV_g_si = d_vgs_noswap_dV_g_si;
T0 = vgs_noswap;
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vgs_eff_dV_di_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_di_si+d_T0_dV_di_si*T0)));
d_vgs_eff_dV_g_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_si+d_T0_dV_g_si*T0)));
d_vgs_eff_dV_g_e = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_e+d_T0_dV_g_e*T0)));
d_vgs_eff_dV_e_di = (deriv_sqrt_0_d0*((T0*d_T0_dV_e_di+d_T0_dV_e_di*T0)));
d_vgs_eff_dV_e_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_e_si+d_T0_dV_e_si*T0)));
d_vgs_eff_dV_g_di = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_di+d_T0_dV_g_di*T0)));
vgs_eff = value_sqrt_0;
}

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (-BIGS_i*d_vgs_eff_dV_di_si);
d_T1_dV_e_di = (-BIGS_i*d_vgs_eff_dV_e_di);
d_T1_dV_e_si = (-BIGS_i*d_vgs_eff_dV_e_si);
d_T1_dV_g_si = (-BIGS_i*d_vgs_eff_dV_g_si);
d_T1_dV_g_e = (-BIGS_i*d_vgs_eff_dV_g_e);
d_T1_dV_g_di = (-BIGS_i*d_vgs_eff_dV_g_di);
T1 = (AIGS_t-(BIGS_i*vgs_eff));

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_di_si = CIGS_i*d_vgs_eff_dV_di_si;
d_T2_dV_e_di = CIGS_i*d_vgs_eff_dV_e_di;
d_T2_dV_e_si = CIGS_i*d_vgs_eff_dV_e_si;
d_T2_dV_g_si = CIGS_i*d_vgs_eff_dV_g_si;
d_T2_dV_g_e = CIGS_i*d_vgs_eff_dV_g_e;
d_T2_dV_g_di = CIGS_i*d_vgs_eff_dV_g_di;
T2 = (1.0+(CIGS_i*vgs_eff));

d_T3_dV_di_si = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_di_si+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_di_si*T2);
d_T3_dV_g_si = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_g_si+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_g_si*T2);
d_T3_dV_g_e = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_g_e+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_g_e*T2);
d_T3_dV_e_di = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_e_di+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_e_di*T2);
d_T3_dV_e_si = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_e_si+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_e_si*T2);
d_T3_dV_g_di = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_g_di+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_g_di*T2);
T3 = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);

d_T4_dV_di_si = evaluator_lexp_0.getDerivs(T3,d_T3_dV_di_si);
d_T4_dV_e_di = evaluator_lexp_0.getDerivs(T3,d_T3_dV_e_di);
d_T4_dV_e_si = evaluator_lexp_0.getDerivs(T3,d_T3_dV_e_si);
d_T4_dV_g_si = evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_si);
d_T4_dV_g_e = evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_e);
d_T4_dV_g_di = evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_di);
T4 = evaluator_lexp_0.getValues(T3);
}
if ((sigvds>0))
{

d_igs_dV_di_si = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_di_si+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_di_si*T4);
d_igs_dV_e_di = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_e_di+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_e_di*T4);
d_igs_dV_e_si = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_e_si+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_e_si*T4);
d_igs_dV_g_e = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_g_e+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_g_e*T4);
d_igs_dV_g_di = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_g_di+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_g_di*T4);
d_igs_dV_g_si = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_g_si+(((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_g_si+(igsd_mult*(model_.DLCIGS))*d_vgs_noswap_dV_g_si*vgs_eff)*T4);
igs = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*T4);
}
else
{

d_igd_dV_di_si = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_di_si+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_di_si*T4);
d_igd_dV_e_di = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_e_di+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_e_di*T4);
d_igd_dV_e_si = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_e_si+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_e_si*T4);
d_igd_dV_g_e = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_g_e+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_g_e*T4);
d_igd_dV_g_di = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_g_di+((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_g_di*T4);
d_igd_dV_g_si = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*d_T4_dV_g_si+(((igsd_mult*(model_.DLCIGS))*vgs_noswap)*d_vgs_eff_dV_g_si+(igsd_mult*(model_.DLCIGS))*d_vgs_noswap_dV_g_si*vgs_eff)*T4);
igd = ((((igsd_mult*(model_.DLCIGS))*vgs_noswap)*vgs_eff)*T4);
}

d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_g_di = d_vgd_noswap_dV_g_di;
T0 = vgd_noswap;
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vgd_eff_dV_di_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_di_si+d_T0_dV_di_si*T0)));
d_vgd_eff_dV_g_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_si+d_T0_dV_g_si*T0)));
d_vgd_eff_dV_g_e = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_e+d_T0_dV_g_e*T0)));
d_vgd_eff_dV_e_di = (deriv_sqrt_0_d0*((T0*d_T0_dV_e_di+d_T0_dV_e_di*T0)));
d_vgd_eff_dV_e_si = (deriv_sqrt_0_d0*((T0*d_T0_dV_e_si+d_T0_dV_e_si*T0)));
d_vgd_eff_dV_g_di = (deriv_sqrt_0_d0*((T0*d_T0_dV_g_di+d_T0_dV_g_di*T0)));
vgd_eff = value_sqrt_0;
}

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (-BIGD_i*d_vgd_eff_dV_di_si);
d_T1_dV_e_di = (-BIGD_i*d_vgd_eff_dV_e_di);
d_T1_dV_e_si = (-BIGD_i*d_vgd_eff_dV_e_si);
d_T1_dV_g_si = (-BIGD_i*d_vgd_eff_dV_g_si);
d_T1_dV_g_e = (-BIGD_i*d_vgd_eff_dV_g_e);
d_T1_dV_g_di = (-BIGD_i*d_vgd_eff_dV_g_di);
T1 = (AIGD_t-(BIGD_i*vgd_eff));

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_di_si = CIGD_i*d_vgd_eff_dV_di_si;
d_T2_dV_e_di = CIGD_i*d_vgd_eff_dV_e_di;
d_T2_dV_e_si = CIGD_i*d_vgd_eff_dV_e_si;
d_T2_dV_g_si = CIGD_i*d_vgd_eff_dV_g_si;
d_T2_dV_g_e = CIGD_i*d_vgd_eff_dV_g_e;
d_T2_dV_g_di = CIGD_i*d_vgd_eff_dV_g_di;
T2 = (1.0+(CIGD_i*vgd_eff));

d_T3_dV_di_si = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_di_si+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_di_si*T2);
d_T3_dV_g_si = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_g_si+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_g_si*T2);
d_T3_dV_g_e = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_g_e+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_g_e*T2);
d_T3_dV_e_di = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_e_di+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_e_di*T2);
d_T3_dV_e_si = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_e_si+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_e_si*T2);
d_T3_dV_g_di = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*d_T2_dV_g_di+(((-Bechvb)*(model_.TOXG))*POXEDGE_i)*d_T1_dV_g_di*T2);
T3 = (((((-Bechvb)*(model_.TOXG))*POXEDGE_i)*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);

d_T4_dV_di_si = evaluator_lexp_0.getDerivs(T3,d_T3_dV_di_si);
d_T4_dV_e_di = evaluator_lexp_0.getDerivs(T3,d_T3_dV_e_di);
d_T4_dV_e_si = evaluator_lexp_0.getDerivs(T3,d_T3_dV_e_si);
d_T4_dV_g_si = evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_si);
d_T4_dV_g_e = evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_e);
d_T4_dV_g_di = evaluator_lexp_0.getDerivs(T3,d_T3_dV_g_di);
T4 = evaluator_lexp_0.getValues(T3);
}
if ((sigvds>0))
{

d_igd_dV_di_si = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_di_si+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_di_si*T4);
d_igd_dV_e_di = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_e_di+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_e_di*T4);
d_igd_dV_e_si = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_e_si+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_e_si*T4);
d_igd_dV_g_si = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_g_si+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_g_si*T4);
d_igd_dV_g_e = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_g_e+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_g_e*T4);
d_igd_dV_g_di = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_g_di+(((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_g_di+(igsd_mult*(model_.DLCIGD))*d_vgd_noswap_dV_g_di*vgd_eff)*T4);
igd = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*T4);
}
else
{

d_igs_dV_di_si = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_di_si+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_di_si*T4);
d_igs_dV_e_di = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_e_di+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_e_di*T4);
d_igs_dV_e_si = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_e_si+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_e_si*T4);
d_igs_dV_g_si = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_g_si+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_g_si*T4);
d_igs_dV_g_e = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_g_e+((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_g_e*T4);
d_igs_dV_g_di = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*d_T4_dV_g_di+(((igsd_mult*(model_.DLCIGD))*vgd_noswap)*d_vgd_eff_dV_g_di+(igsd_mult*(model_.DLCIGD))*d_vgd_noswap_dV_g_di*vgd_eff)*T4);
igs = ((((igsd_mult*(model_.DLCIGD))*vgd_noswap)*vgd_eff)*T4);
}
}

d_igisl_dV_g_di = d_igisl_dV_di_d = d_igisl_dV_si_s = d_igisl_dV_g_si = d_igisl_dV_di_si = d_igisl_dV_e_si = d_igisl_dV_e_di = d_igisl_dV_g_e =  0.0;
igisl = 0.0;

d_igidl_dV_g_di = d_igidl_dV_di_d = d_igidl_dV_si_s = d_igidl_dV_g_si = d_igidl_dV_di_si = d_igidl_dV_e_si = d_igidl_dV_e_di = d_igidl_dV_g_e =  0.0;
igidl = 0.0;
if (((model_.GIDLMOD)!=0))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
T0 = (epsratio*(model_.EOT));
if (((AGIDL_i<=0.0)||(BGIDL_t<=0.0)))
{

d_T6_dV_g_di = d_T6_dV_di_d = d_T6_dV_si_s = d_T6_dV_g_si = d_T6_dV_di_si = d_T6_dV_e_si = d_T6_dV_e_di = d_T6_dV_g_e =  0.0;
T6 = 0.0;
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (-(((-vgd_noswap)-EGIDL_i)+vfbsd)*d_T0_dV_di_si/T0/T0);
d_T1_dV_g_si = (-(((-vgd_noswap)-EGIDL_i)+vfbsd)*d_T0_dV_g_si/T0/T0);
d_T1_dV_g_e = (-(((-vgd_noswap)-EGIDL_i)+vfbsd)*d_T0_dV_g_e/T0/T0);
d_T1_dV_e_di = (-(((-vgd_noswap)-EGIDL_i)+vfbsd)*d_T0_dV_e_di/T0/T0);
d_T1_dV_e_si = (-(((-vgd_noswap)-EGIDL_i)+vfbsd)*d_T0_dV_e_si/T0/T0);
d_T1_dV_g_di = ((T0*(-d_vgd_noswap_dV_g_di)-(((-vgd_noswap)-EGIDL_i)+vfbsd)*d_T0_dV_g_di)/T0/T0);
T1 = ((((-vgd_noswap)-EGIDL_i)+vfbsd)/T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-2);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_di_si,0.0);
d_T1_dV_g_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_g_si,0.0);
d_T1_dV_g_e = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_g_e,0.0);
d_T1_dV_e_di = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_e_di,0.0);
d_T1_dV_e_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_e_si,0.0);
d_T1_dV_g_di = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_g_di,0.0);
T1 = evaluator_hypsmooth_0.getValues(T1,1.0E-2);
}

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_di_si = (-BGIDL_t*d_T1_dV_di_si/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_g_si = (-BGIDL_t*d_T1_dV_g_si/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_g_e = (-BGIDL_t*d_T1_dV_g_e/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_e_di = (-BGIDL_t*d_T1_dV_e_di/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_e_si = (-BGIDL_t*d_T1_dV_e_si/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_g_di = (-BGIDL_t*d_T1_dV_g_di/(T1+1.0E-3)/(T1+1.0E-3));
T2 = (BGIDL_t/(T1+1.0E-3));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(T1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PGIDL_i*evaluator_lln_0.getValues(T1)));

d_T3_dV_di_si = evaluator_lexp_1.getDerivs((PGIDL_i*evaluator_lln_0.getValues(T1)),PGIDL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_di_si));
d_T3_dV_g_si = evaluator_lexp_1.getDerivs((PGIDL_i*evaluator_lln_0.getValues(T1)),PGIDL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_g_si));
d_T3_dV_g_e = evaluator_lexp_1.getDerivs((PGIDL_i*evaluator_lln_0.getValues(T1)),PGIDL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_g_e));
d_T3_dV_e_di = evaluator_lexp_1.getDerivs((PGIDL_i*evaluator_lln_0.getValues(T1)),PGIDL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_e_di));
d_T3_dV_e_si = evaluator_lexp_1.getDerivs((PGIDL_i*evaluator_lln_0.getValues(T1)),PGIDL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_e_si));
d_T3_dV_g_di = evaluator_lexp_1.getDerivs((PGIDL_i*evaluator_lln_0.getValues(T1)),PGIDL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_g_di));
T3 = evaluator_lexp_1.getValues((PGIDL_i*evaluator_lln_0.getValues(T1)));
}
if (((model_.BULKMOD)!=0))
{

d_T4_dV_g_di = d_T4_dV_di_si = d_T4_dV_e_si = d_T4_dV_g_e = d_T4_dV_g_si =  0.0;
d_T4_dV_e_di = (((-ved_jct)*ved_jct)*d_ved_jct_dV_e_di+((-ved_jct)*d_ved_jct_dV_e_di+(-d_ved_jct_dV_e_di)*ved_jct)*ved_jct);
T4 = (((-ved_jct)*ved_jct)*ved_jct);
{
double value_fabs_0 = fabs(T4);
double  deriv_fabs_0_d0 = (((T4)>=0)?(+1.0):(-1.0));

d_T4a_dV_g_si = (deriv_fabs_0_d0*(d_T4_dV_g_si));
d_T4a_dV_g_e = (deriv_fabs_0_d0*(d_T4_dV_g_e));
d_T4a_dV_e_di = (deriv_fabs_0_d0*(d_T4_dV_e_di));
d_T4a_dV_e_si = (deriv_fabs_0_d0*(d_T4_dV_e_si));
d_T4a_dV_di_si = (deriv_fabs_0_d0*(d_T4_dV_di_si));
d_T4a_dV_g_di = (deriv_fabs_0_d0*(d_T4_dV_g_di));
T4a = ((CGIDL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T4/T4a),1.0E-6);

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_g_si = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_g_si-T4*d_T4a_dV_g_si)/T4a/T4a),0.0);
d_T5_dV_g_e = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_g_e-T4*d_T4a_dV_g_e)/T4a/T4a),0.0);
d_T5_dV_e_di = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_e_di-T4*d_T4a_dV_e_di)/T4a/T4a),0.0);
d_T5_dV_e_si = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_e_si-T4*d_T4a_dV_e_si)/T4a/T4a),0.0);
d_T5_dV_di_si = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_di_si-T4*d_T4a_dV_di_si)/T4a/T4a),0.0);
d_T5_dV_g_di = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_g_di-T4*d_T4a_dV_g_di)/T4a/T4a),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T4/T4a),1.0E-6)-1.0E-6);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));

d_T6_dV_si_s = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_si_s+((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_si_s))*T5);
d_T6_dV_di_d = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_di_d+((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_d))*T5);
d_T6_dV_di_si = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_di_si+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_si))+(AGIDL_i*Weff0)*d_T3_dV_di_si*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_e_di = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_e_di+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_di))+(AGIDL_i*Weff0)*d_T3_dV_e_di*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_e_si = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_e_si+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_si))+(AGIDL_i*Weff0)*d_T3_dV_e_si*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_g_si = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_g_si+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_si))+(AGIDL_i*Weff0)*d_T3_dV_g_si*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_g_e = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_g_e+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_e))+(AGIDL_i*Weff0)*d_T3_dV_g_e*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_g_di = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_g_di+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_di))+(AGIDL_i*Weff0)*d_T3_dV_g_di*evaluator_lexp_0.getValues((-T2)))*T5);
T6 = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*T5);
}
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));

d_T6_dV_di_d = d_T6_dV_si_s =  0.0;
d_T6_dV_di_si = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_vds_noswap_dV_di_si+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_si))+(AGIDL_i*Weff0)*d_T3_dV_di_si*evaluator_lexp_0.getValues((-T2)))*vds_noswap);
d_T6_dV_e_di = (((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_di))+(AGIDL_i*Weff0)*d_T3_dV_e_di*evaluator_lexp_0.getValues((-T2)))*vds_noswap;
d_T6_dV_e_si = (((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_si))+(AGIDL_i*Weff0)*d_T3_dV_e_si*evaluator_lexp_0.getValues((-T2)))*vds_noswap;
d_T6_dV_g_si = (((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_si))+(AGIDL_i*Weff0)*d_T3_dV_g_si*evaluator_lexp_0.getValues((-T2)))*vds_noswap;
d_T6_dV_g_e = (((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_e))+(AGIDL_i*Weff0)*d_T3_dV_g_e*evaluator_lexp_0.getValues((-T2)))*vds_noswap;
d_T6_dV_g_di = (((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_di))+(AGIDL_i*Weff0)*d_T3_dV_g_di*evaluator_lexp_0.getValues((-T2)))*vds_noswap;
T6 = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*vds_noswap);
}
}
}
if ((sigvds>0.0))
{

d_igidl_dV_g_e = d_T6_dV_g_e;
d_igidl_dV_e_di = d_T6_dV_e_di;
d_igidl_dV_e_si = d_T6_dV_e_si;
d_igidl_dV_di_si = d_T6_dV_di_si;
d_igidl_dV_g_si = d_T6_dV_g_si;
d_igidl_dV_si_s = d_T6_dV_si_s;
d_igidl_dV_di_d = d_T6_dV_di_d;
d_igidl_dV_g_di = d_T6_dV_g_di;
igidl = T6;
}
else
{

d_igisl_dV_g_e = d_T6_dV_g_e;
d_igisl_dV_e_di = d_T6_dV_e_di;
d_igisl_dV_e_si = d_T6_dV_e_si;
d_igisl_dV_di_si = d_T6_dV_di_si;
d_igisl_dV_g_si = d_T6_dV_g_si;
d_igisl_dV_si_s = d_T6_dV_si_s;
d_igisl_dV_di_d = d_T6_dV_di_d;
d_igisl_dV_g_di = d_T6_dV_g_di;
igisl = T6;
}
if (((AGISL_i<=0.0)||(BGISL_t<=0.0)))
{

d_T6_dV_g_di = d_T6_dV_di_d = d_T6_dV_si_s = d_T6_dV_g_si = d_T6_dV_di_si = d_T6_dV_e_si = d_T6_dV_e_di = d_T6_dV_g_e =  0.0;
T6 = 0.0;
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (-(((-vgs_noswap)-EGISL_i)+vfbsd)*d_T0_dV_di_si/T0/T0);
d_T1_dV_g_e = (-(((-vgs_noswap)-EGISL_i)+vfbsd)*d_T0_dV_g_e/T0/T0);
d_T1_dV_e_di = (-(((-vgs_noswap)-EGISL_i)+vfbsd)*d_T0_dV_e_di/T0/T0);
d_T1_dV_e_si = (-(((-vgs_noswap)-EGISL_i)+vfbsd)*d_T0_dV_e_si/T0/T0);
d_T1_dV_g_di = (-(((-vgs_noswap)-EGISL_i)+vfbsd)*d_T0_dV_g_di/T0/T0);
d_T1_dV_g_si = ((T0*(-d_vgs_noswap_dV_g_si)-(((-vgs_noswap)-EGISL_i)+vfbsd)*d_T0_dV_g_si)/T0/T0);
T1 = ((((-vgs_noswap)-EGISL_i)+vfbsd)/T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-2);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_di_si,0.0);
d_T1_dV_g_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_g_si,0.0);
d_T1_dV_g_e = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_g_e,0.0);
d_T1_dV_e_di = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_e_di,0.0);
d_T1_dV_e_si = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_e_si,0.0);
d_T1_dV_g_di = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dV_g_di,0.0);
T1 = evaluator_hypsmooth_0.getValues(T1,1.0E-2);
}

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_di_si = (-BGISL_t*d_T1_dV_di_si/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_g_si = (-BGISL_t*d_T1_dV_g_si/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_g_e = (-BGISL_t*d_T1_dV_g_e/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_e_di = (-BGISL_t*d_T1_dV_e_di/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_e_si = (-BGISL_t*d_T1_dV_e_si/(T1+1.0E-3)/(T1+1.0E-3));
d_T2_dV_g_di = (-BGISL_t*d_T1_dV_g_di/(T1+1.0E-3)/(T1+1.0E-3));
T2 = (BGISL_t/(T1+1.0E-3));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(T1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PGISL_i*evaluator_lln_0.getValues(T1)));

d_T3_dV_di_si = evaluator_lexp_1.getDerivs((PGISL_i*evaluator_lln_0.getValues(T1)),PGISL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_di_si));
d_T3_dV_g_si = evaluator_lexp_1.getDerivs((PGISL_i*evaluator_lln_0.getValues(T1)),PGISL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_g_si));
d_T3_dV_g_e = evaluator_lexp_1.getDerivs((PGISL_i*evaluator_lln_0.getValues(T1)),PGISL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_g_e));
d_T3_dV_e_di = evaluator_lexp_1.getDerivs((PGISL_i*evaluator_lln_0.getValues(T1)),PGISL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_e_di));
d_T3_dV_e_si = evaluator_lexp_1.getDerivs((PGISL_i*evaluator_lln_0.getValues(T1)),PGISL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_e_si));
d_T3_dV_g_di = evaluator_lexp_1.getDerivs((PGISL_i*evaluator_lln_0.getValues(T1)),PGISL_i*evaluator_lln_0.getDerivs(T1,d_T1_dV_g_di));
T3 = evaluator_lexp_1.getValues((PGISL_i*evaluator_lln_0.getValues(T1)));
}
if (((model_.BULKMOD)!=0))
{

d_T4_dV_g_di = d_T4_dV_di_si = d_T4_dV_e_di = d_T4_dV_g_e = d_T4_dV_g_si =  0.0;
d_T4_dV_e_si = (((-ves_jct)*ves_jct)*d_ves_jct_dV_e_si+((-ves_jct)*d_ves_jct_dV_e_si+(-d_ves_jct_dV_e_si)*ves_jct)*ves_jct);
T4 = (((-ves_jct)*ves_jct)*ves_jct);
{
double value_fabs_0 = fabs(T4);
double  deriv_fabs_0_d0 = (((T4)>=0)?(+1.0):(-1.0));

d_T4a_dV_g_si = (deriv_fabs_0_d0*(d_T4_dV_g_si));
d_T4a_dV_g_e = (deriv_fabs_0_d0*(d_T4_dV_g_e));
d_T4a_dV_e_di = (deriv_fabs_0_d0*(d_T4_dV_e_di));
d_T4a_dV_e_si = (deriv_fabs_0_d0*(d_T4_dV_e_si));
d_T4a_dV_di_si = (deriv_fabs_0_d0*(d_T4_dV_di_si));
d_T4a_dV_g_di = (deriv_fabs_0_d0*(d_T4_dV_g_di));
T4a = ((CGISL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T4/T4a),1.0E-6);

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_g_si = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_g_si-T4*d_T4a_dV_g_si)/T4a/T4a),0.0);
d_T5_dV_g_e = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_g_e-T4*d_T4a_dV_g_e)/T4a/T4a),0.0);
d_T5_dV_e_di = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_e_di-T4*d_T4a_dV_e_di)/T4a/T4a),0.0);
d_T5_dV_e_si = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_e_si-T4*d_T4a_dV_e_si)/T4a/T4a),0.0);
d_T5_dV_di_si = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_di_si-T4*d_T4a_dV_di_si)/T4a/T4a),0.0);
d_T5_dV_g_di = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dV_g_di-T4*d_T4a_dV_g_di)/T4a/T4a),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T4/T4a),1.0E-6)-1.0E-6);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));

d_T6_dV_si_s = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_si_s+((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_si_s))*T5);
d_T6_dV_di_d = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_di_d+((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_d))*T5);
d_T6_dV_di_si = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_di_si+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_si))+(AGISL_i*Weff0)*d_T3_dV_di_si*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_e_di = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_e_di+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_di))+(AGISL_i*Weff0)*d_T3_dV_e_di*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_e_si = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_e_si+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_si))+(AGISL_i*Weff0)*d_T3_dV_e_si*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_g_si = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_g_si+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_si))+(AGISL_i*Weff0)*d_T3_dV_g_si*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_g_e = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_g_e+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_e))+(AGISL_i*Weff0)*d_T3_dV_g_e*evaluator_lexp_0.getValues((-T2)))*T5);
d_T6_dV_g_di = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dV_g_di+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_di))+(AGISL_i*Weff0)*d_T3_dV_g_di*evaluator_lexp_0.getValues((-T2)))*T5);
T6 = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*T5);
}
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));

d_T6_dV_di_d = d_T6_dV_si_s =  0.0;
d_T6_dV_di_si = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*(-d_vds_noswap_dV_di_si)+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_di_si))+(AGISL_i*Weff0)*d_T3_dV_di_si*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap));
d_T6_dV_e_di = (((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_di))+(AGISL_i*Weff0)*d_T3_dV_e_di*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap);
d_T6_dV_e_si = (((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_e_si))+(AGISL_i*Weff0)*d_T3_dV_e_si*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap);
d_T6_dV_g_si = (((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_si))+(AGISL_i*Weff0)*d_T3_dV_g_si*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap);
d_T6_dV_g_e = (((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_e))+(AGISL_i*Weff0)*d_T3_dV_g_e*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap);
d_T6_dV_g_di = (((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dV_g_di))+(AGISL_i*Weff0)*d_T3_dV_g_di*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap);
T6 = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap));
}
}
}
if ((sigvds>0.0))
{

d_igisl_dV_g_e = d_T6_dV_g_e;
d_igisl_dV_e_di = d_T6_dV_e_di;
d_igisl_dV_e_si = d_T6_dV_e_si;
d_igisl_dV_di_si = d_T6_dV_di_si;
d_igisl_dV_g_si = d_T6_dV_g_si;
d_igisl_dV_si_s = d_T6_dV_si_s;
d_igisl_dV_di_d = d_T6_dV_di_d;
d_igisl_dV_g_di = d_T6_dV_g_di;
igisl = T6;
}
else
{

d_igidl_dV_g_e = d_T6_dV_g_e;
d_igidl_dV_e_di = d_T6_dV_e_di;
d_igidl_dV_e_si = d_T6_dV_e_si;
d_igidl_dV_di_si = d_T6_dV_di_si;
d_igidl_dV_g_si = d_T6_dV_g_si;
d_igidl_dV_si_s = d_T6_dV_si_s;
d_igidl_dV_di_d = d_T6_dV_di_d;
d_igidl_dV_g_di = d_T6_dV_g_di;
igidl = T6;
}
}
if (((model_.BULKMOD)!=0))
{
if ((Isbs>0.0))
{
if ((ves_jct<VjsmRev))
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (d_ves_jct_dV_e_si/Nvtms);
T0 = (ves_jct/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_si);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_si);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_e);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_di);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_si);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_di);
T1 = (evaluator_lexp_0.getValues(T0)-1.0);
}

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_e_si = SslpRev*d_ves_jct_dV_e_si;
T2 = (IVjsmRev+(SslpRev*(ves_jct-VjsmRev)));

d_Ies_dV_di_si = (T1*d_T2_dV_di_si+d_T1_dV_di_si*T2);
d_Ies_dV_g_si = (T1*d_T2_dV_g_si+d_T1_dV_g_si*T2);
d_Ies_dV_g_e = (T1*d_T2_dV_g_e+d_T1_dV_g_e*T2);
d_Ies_dV_e_di = (T1*d_T2_dV_e_di+d_T1_dV_e_di*T2);
d_Ies_dV_e_si = (T1*d_T2_dV_e_si+d_T1_dV_e_si*T2);
d_Ies_dV_g_di = (T1*d_T2_dV_g_di+d_T1_dV_g_di*T2);
Ies = (T1*T2);
}
else
{
if ((ves_jct<=VjsmFwd))
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (d_ves_jct_dV_e_si/Nvtms);
T0 = (ves_jct/Nvtms);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_si = (d_ves_jct_dV_e_si/Nvtms);
T1 = (((model_.BVS)+ves_jct)/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_di_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_si));
d_T2_dV_g_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_si));
d_T2_dV_g_e = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_e));
d_T2_dV_e_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_di));
d_T2_dV_e_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_si));
d_T2_dV_g_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_di));
T2 = evaluator_lexp_0.getValues((-T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_Ies_dV_di_si = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_si)-(model_.XJBVS)*d_T2_dV_di_si);
d_Ies_dV_g_si = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_si)-(model_.XJBVS)*d_T2_dV_g_si);
d_Ies_dV_g_e = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_e)-(model_.XJBVS)*d_T2_dV_g_e);
d_Ies_dV_e_di = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_di)-(model_.XJBVS)*d_T2_dV_e_di);
d_Ies_dV_e_si = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_si)-(model_.XJBVS)*d_T2_dV_e_si);
d_Ies_dV_g_di = Isbs*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_di)-(model_.XJBVS)*d_T2_dV_g_di);
Ies = (Isbs*(((evaluator_lexp_0.getValues(T0)+XExpBVS)-1.0)-((model_.XJBVS)*T2)));
}
}
else
{

d_Ies_dV_g_di = d_Ies_dV_e_di = d_Ies_dV_g_e = d_Ies_dV_g_si = d_Ies_dV_di_si =  0.0;
d_Ies_dV_e_si = SslpFwd*d_ves_jct_dV_e_si;
Ies = (IVjsmFwd+(SslpFwd*(ves_jct-VjsmFwd)));
}
}
}
else
{

d_Ies_dV_g_di = d_Ies_dV_e_si = d_Ies_dV_e_di = d_Ies_dV_g_e = d_Ies_dV_g_si = d_Ies_dV_di_si =  0.0;
Ies = 0.0;
}
if ((JTSS_t>0.0))
{
if ((((model_.VTSS)-ves_jct)<((model_.VTSS)*1.0e-3)))
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (((-d_ves_jct_dV_e_si)/Vtm0)/NJTS_t);
T0 = (((-ves_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_si*1.0e+3);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_si*1.0e+3);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_e*1.0e+3);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_di*1.0e+3);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_si*1.0e+3);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ies_dV_di_si = (d_Ies_dV_di_si-(ASEJ*JTSS_t)*d_T1_dV_di_si);
d_Ies_dV_g_si = (d_Ies_dV_g_si-(ASEJ*JTSS_t)*d_T1_dV_g_si);
d_Ies_dV_g_e = (d_Ies_dV_g_e-(ASEJ*JTSS_t)*d_T1_dV_g_e);
d_Ies_dV_e_di = (d_Ies_dV_e_di-(ASEJ*JTSS_t)*d_T1_dV_e_di);
d_Ies_dV_e_si = (d_Ies_dV_e_si-(ASEJ*JTSS_t)*d_T1_dV_e_si);
d_Ies_dV_g_di = (d_Ies_dV_g_di-(ASEJ*JTSS_t)*d_T1_dV_g_di);
Ies = (Ies-((ASEJ*JTSS_t)*T1));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (((-d_ves_jct_dV_e_si)/Vtm0)/NJTS_t);
T0 = (((-ves_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)),(d_T0_dV_di_si*(model_.VTSS)/((model_.VTSS)-ves_jct)));
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)),(d_T0_dV_g_si*(model_.VTSS)/((model_.VTSS)-ves_jct)));
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)),(d_T0_dV_g_e*(model_.VTSS)/((model_.VTSS)-ves_jct)));
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)),(d_T0_dV_e_di*(model_.VTSS)/((model_.VTSS)-ves_jct)));
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)),((((model_.VTSS)-ves_jct)*d_T0_dV_e_si*(model_.VTSS)-(T0*(model_.VTSS))*(-d_ves_jct_dV_e_si))/((model_.VTSS)-ves_jct)/((model_.VTSS)-ves_jct)));
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)),(d_T0_dV_g_di*(model_.VTSS)/((model_.VTSS)-ves_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSS))/((model_.VTSS)-ves_jct)))-1.0);
}

d_Ies_dV_di_si = (d_Ies_dV_di_si-(ASEJ*JTSS_t)*d_T1_dV_di_si);
d_Ies_dV_g_si = (d_Ies_dV_g_si-(ASEJ*JTSS_t)*d_T1_dV_g_si);
d_Ies_dV_g_e = (d_Ies_dV_g_e-(ASEJ*JTSS_t)*d_T1_dV_g_e);
d_Ies_dV_e_di = (d_Ies_dV_e_di-(ASEJ*JTSS_t)*d_T1_dV_e_di);
d_Ies_dV_e_si = (d_Ies_dV_e_si-(ASEJ*JTSS_t)*d_T1_dV_e_si);
d_Ies_dV_g_di = (d_Ies_dV_g_di-(ASEJ*JTSS_t)*d_T1_dV_g_di);
Ies = (Ies-((ASEJ*JTSS_t)*T1));
}
}
if ((JTSSWS_t>0.0))
{
if ((((model_.VTSSWS)-ves_jct)<((model_.VTSSWS)*1.0e-3)))
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (((-d_ves_jct_dV_e_si)/Vtm0)/NJTSSW_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_si*1.0e+3);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_si*1.0e+3);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_e*1.0e+3);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_di*1.0e+3);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_si*1.0e+3);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ies_dV_di_si = (d_Ies_dV_di_si-(PSEJ*JTSSWS_t)*d_T1_dV_di_si);
d_Ies_dV_g_si = (d_Ies_dV_g_si-(PSEJ*JTSSWS_t)*d_T1_dV_g_si);
d_Ies_dV_g_e = (d_Ies_dV_g_e-(PSEJ*JTSSWS_t)*d_T1_dV_g_e);
d_Ies_dV_e_di = (d_Ies_dV_e_di-(PSEJ*JTSSWS_t)*d_T1_dV_e_di);
d_Ies_dV_e_si = (d_Ies_dV_e_si-(PSEJ*JTSSWS_t)*d_T1_dV_e_si);
d_Ies_dV_g_di = (d_Ies_dV_g_di-(PSEJ*JTSSWS_t)*d_T1_dV_g_di);
Ies = (Ies-((PSEJ*JTSSWS_t)*T1));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (((-d_ves_jct_dV_e_si)/Vtm0)/NJTSSW_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)),(d_T0_dV_di_si*(model_.VTSSWS)/((model_.VTSSWS)-ves_jct)));
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)),(d_T0_dV_g_si*(model_.VTSSWS)/((model_.VTSSWS)-ves_jct)));
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)),(d_T0_dV_g_e*(model_.VTSSWS)/((model_.VTSSWS)-ves_jct)));
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)),(d_T0_dV_e_di*(model_.VTSSWS)/((model_.VTSSWS)-ves_jct)));
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)),((((model_.VTSSWS)-ves_jct)*d_T0_dV_e_si*(model_.VTSSWS)-(T0*(model_.VTSSWS))*(-d_ves_jct_dV_e_si))/((model_.VTSSWS)-ves_jct)/((model_.VTSSWS)-ves_jct)));
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)),(d_T0_dV_g_di*(model_.VTSSWS)/((model_.VTSSWS)-ves_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWS))/((model_.VTSSWS)-ves_jct)))-1.0);
}

d_Ies_dV_di_si = (d_Ies_dV_di_si-(PSEJ*JTSSWS_t)*d_T1_dV_di_si);
d_Ies_dV_g_si = (d_Ies_dV_g_si-(PSEJ*JTSSWS_t)*d_T1_dV_g_si);
d_Ies_dV_g_e = (d_Ies_dV_g_e-(PSEJ*JTSSWS_t)*d_T1_dV_g_e);
d_Ies_dV_e_di = (d_Ies_dV_e_di-(PSEJ*JTSSWS_t)*d_T1_dV_e_di);
d_Ies_dV_e_si = (d_Ies_dV_e_si-(PSEJ*JTSSWS_t)*d_T1_dV_e_si);
d_Ies_dV_g_di = (d_Ies_dV_g_di-(PSEJ*JTSSWS_t)*d_T1_dV_g_di);
Ies = (Ies-((PSEJ*JTSSWS_t)*T1));
}
}
if ((JTSSWGS_t>0.0))
{
if ((((model_.VTSSWGS)-ves_jct)<((model_.VTSSWGS)*1.0e-3)))
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (((-d_ves_jct_dV_e_si)/Vtm0)/NJTSSWG_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_si*1.0e+3);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_si*1.0e+3);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_e*1.0e+3);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_di*1.0e+3);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_si*1.0e+3);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ies_dV_di_si = (d_Ies_dV_di_si-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_di_si);
d_Ies_dV_g_si = (d_Ies_dV_g_si-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_g_si);
d_Ies_dV_g_e = (d_Ies_dV_g_e-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_g_e);
d_Ies_dV_e_di = (d_Ies_dV_e_di-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_e_di);
d_Ies_dV_e_si = (d_Ies_dV_e_si-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_e_si);
d_Ies_dV_g_di = (d_Ies_dV_g_di-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_g_di);
Ies = (Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_si = (((-d_ves_jct_dV_e_si)/Vtm0)/NJTSSWG_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)),(d_T0_dV_di_si*(model_.VTSSWGS)/((model_.VTSSWGS)-ves_jct)));
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)),(d_T0_dV_g_si*(model_.VTSSWGS)/((model_.VTSSWGS)-ves_jct)));
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)),(d_T0_dV_g_e*(model_.VTSSWGS)/((model_.VTSSWGS)-ves_jct)));
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)),(d_T0_dV_e_di*(model_.VTSSWGS)/((model_.VTSSWGS)-ves_jct)));
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)),((((model_.VTSSWGS)-ves_jct)*d_T0_dV_e_si*(model_.VTSSWGS)-(T0*(model_.VTSSWGS))*(-d_ves_jct_dV_e_si))/((model_.VTSSWGS)-ves_jct)/((model_.VTSSWGS)-ves_jct)));
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)),(d_T0_dV_g_di*(model_.VTSSWGS)/((model_.VTSSWGS)-ves_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWGS))/((model_.VTSSWGS)-ves_jct)))-1.0);
}

d_Ies_dV_di_si = (d_Ies_dV_di_si-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_di_si);
d_Ies_dV_g_si = (d_Ies_dV_g_si-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_g_si);
d_Ies_dV_g_e = (d_Ies_dV_g_e-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_g_e);
d_Ies_dV_e_di = (d_Ies_dV_e_di-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_e_di);
d_Ies_dV_e_si = (d_Ies_dV_e_si-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_e_si);
d_Ies_dV_g_di = (d_Ies_dV_g_di-((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dV_g_di);
Ies = (Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
}
}
if ((Isbd>0.0))
{
if ((ved_jct<VjdmRev))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (d_ved_jct_dV_e_di/Nvtmd);
T0 = (ved_jct/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_si);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_si);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_e);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_di);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_si);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_di);
T1 = (evaluator_lexp_0.getValues(T0)-1.0);
}

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_di_si =  0.0;
d_T2_dV_e_di = DslpRev*d_ved_jct_dV_e_di;
T2 = (IVjdmRev+(DslpRev*(ved_jct-VjdmRev)));

d_Ied_dV_di_si = (T1*d_T2_dV_di_si+d_T1_dV_di_si*T2);
d_Ied_dV_g_si = (T1*d_T2_dV_g_si+d_T1_dV_g_si*T2);
d_Ied_dV_g_e = (T1*d_T2_dV_g_e+d_T1_dV_g_e*T2);
d_Ied_dV_e_di = (T1*d_T2_dV_e_di+d_T1_dV_e_di*T2);
d_Ied_dV_e_si = (T1*d_T2_dV_e_si+d_T1_dV_e_si*T2);
d_Ied_dV_g_di = (T1*d_T2_dV_g_di+d_T1_dV_g_di*T2);
Ied = (T1*T2);
}
else
{
if ((ved_jct<=VjdmFwd))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (d_ved_jct_dV_e_di/Nvtmd);
T0 = (ved_jct/Nvtmd);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_di = (d_ved_jct_dV_e_di/Nvtmd);
T1 = (((model_.BVD)+ved_jct)/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));

d_T2_dV_di_d = d_T2_dV_si_s =  0.0;
d_T2_dV_di_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_di_si));
d_T2_dV_g_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_si));
d_T2_dV_g_e = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_e));
d_T2_dV_e_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_di));
d_T2_dV_e_si = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_e_si));
d_T2_dV_g_di = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dV_g_di));
T2 = evaluator_lexp_0.getValues((-T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);

d_Ied_dV_di_si = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_di_si)-(model_.XJBVD)*d_T2_dV_di_si);
d_Ied_dV_g_si = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_si)-(model_.XJBVD)*d_T2_dV_g_si);
d_Ied_dV_g_e = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_e)-(model_.XJBVD)*d_T2_dV_g_e);
d_Ied_dV_e_di = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_di)-(model_.XJBVD)*d_T2_dV_e_di);
d_Ied_dV_e_si = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_e_si)-(model_.XJBVD)*d_T2_dV_e_si);
d_Ied_dV_g_di = Isbd*(evaluator_lexp_0.getDerivs(T0,d_T0_dV_g_di)-(model_.XJBVD)*d_T2_dV_g_di);
Ied = (Isbd*(((evaluator_lexp_0.getValues(T0)+XExpBVD)-1.0)-((model_.XJBVD)*T2)));
}
}
else
{

d_Ied_dV_g_di = d_Ied_dV_e_si = d_Ied_dV_g_e = d_Ied_dV_g_si = d_Ied_dV_di_si =  0.0;
d_Ied_dV_e_di = DslpFwd*d_ved_jct_dV_e_di;
Ied = (IVjdmFwd+(DslpFwd*(ved_jct-VjdmFwd)));
}
}
}
else
{

d_Ied_dV_g_di = d_Ied_dV_e_si = d_Ied_dV_e_di = d_Ied_dV_g_e = d_Ied_dV_g_si = d_Ied_dV_di_si =  0.0;
Ied = 0.0;
}
if ((JTSD_t>0.0))
{
if ((((model_.VTSD)-ved_jct)<((model_.VTSD)*1.0e-3)))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (((-d_ved_jct_dV_e_di)/Vtm0)/NJTSD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_si*1.0e+3);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_si*1.0e+3);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_e*1.0e+3);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_di*1.0e+3);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_si*1.0e+3);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ied_dV_di_si = (d_Ied_dV_di_si-(ADEJ*JTSD_t)*d_T1_dV_di_si);
d_Ied_dV_g_si = (d_Ied_dV_g_si-(ADEJ*JTSD_t)*d_T1_dV_g_si);
d_Ied_dV_g_e = (d_Ied_dV_g_e-(ADEJ*JTSD_t)*d_T1_dV_g_e);
d_Ied_dV_e_di = (d_Ied_dV_e_di-(ADEJ*JTSD_t)*d_T1_dV_e_di);
d_Ied_dV_e_si = (d_Ied_dV_e_si-(ADEJ*JTSD_t)*d_T1_dV_e_si);
d_Ied_dV_g_di = (d_Ied_dV_g_di-(ADEJ*JTSD_t)*d_T1_dV_g_di);
Ied = (Ied-((ADEJ*JTSD_t)*T1));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (((-d_ved_jct_dV_e_di)/Vtm0)/NJTSD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)),(d_T0_dV_di_si*(model_.VTSD)/((model_.VTSD)-ved_jct)));
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)),(d_T0_dV_g_si*(model_.VTSD)/((model_.VTSD)-ved_jct)));
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)),(d_T0_dV_g_e*(model_.VTSD)/((model_.VTSD)-ved_jct)));
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)),((((model_.VTSD)-ved_jct)*d_T0_dV_e_di*(model_.VTSD)-(T0*(model_.VTSD))*(-d_ved_jct_dV_e_di))/((model_.VTSD)-ved_jct)/((model_.VTSD)-ved_jct)));
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)),(d_T0_dV_e_si*(model_.VTSD)/((model_.VTSD)-ved_jct)));
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)),(d_T0_dV_g_di*(model_.VTSD)/((model_.VTSD)-ved_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSD))/((model_.VTSD)-ved_jct)))-1.0);
}

d_Ied_dV_di_si = (d_Ied_dV_di_si-(ADEJ*JTSD_t)*d_T1_dV_di_si);
d_Ied_dV_g_si = (d_Ied_dV_g_si-(ADEJ*JTSD_t)*d_T1_dV_g_si);
d_Ied_dV_g_e = (d_Ied_dV_g_e-(ADEJ*JTSD_t)*d_T1_dV_g_e);
d_Ied_dV_e_di = (d_Ied_dV_e_di-(ADEJ*JTSD_t)*d_T1_dV_e_di);
d_Ied_dV_e_si = (d_Ied_dV_e_si-(ADEJ*JTSD_t)*d_T1_dV_e_si);
d_Ied_dV_g_di = (d_Ied_dV_g_di-(ADEJ*JTSD_t)*d_T1_dV_g_di);
Ied = (Ied-((ADEJ*JTSD_t)*T1));
}
}
if ((JTSSWD_t>0.0))
{
if ((((model_.VTSSWD)-ved_jct)<((model_.VTSSWD)*1.0e-3)))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (((-d_ved_jct_dV_e_di)/Vtm0)/NJTSSWD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_si*1.0e+3);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_si*1.0e+3);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_e*1.0e+3);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_di*1.0e+3);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_si*1.0e+3);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ied_dV_di_si = (d_Ied_dV_di_si-(PDEJ*JTSSWD_t)*d_T1_dV_di_si);
d_Ied_dV_g_si = (d_Ied_dV_g_si-(PDEJ*JTSSWD_t)*d_T1_dV_g_si);
d_Ied_dV_g_e = (d_Ied_dV_g_e-(PDEJ*JTSSWD_t)*d_T1_dV_g_e);
d_Ied_dV_e_di = (d_Ied_dV_e_di-(PDEJ*JTSSWD_t)*d_T1_dV_e_di);
d_Ied_dV_e_si = (d_Ied_dV_e_si-(PDEJ*JTSSWD_t)*d_T1_dV_e_si);
d_Ied_dV_g_di = (d_Ied_dV_g_di-(PDEJ*JTSSWD_t)*d_T1_dV_g_di);
Ied = (Ied-((PDEJ*JTSSWD_t)*T1));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (((-d_ved_jct_dV_e_di)/Vtm0)/NJTSSWD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)),(d_T0_dV_di_si*(model_.VTSSWD)/((model_.VTSSWD)-ved_jct)));
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)),(d_T0_dV_g_si*(model_.VTSSWD)/((model_.VTSSWD)-ved_jct)));
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)),(d_T0_dV_g_e*(model_.VTSSWD)/((model_.VTSSWD)-ved_jct)));
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)),((((model_.VTSSWD)-ved_jct)*d_T0_dV_e_di*(model_.VTSSWD)-(T0*(model_.VTSSWD))*(-d_ved_jct_dV_e_di))/((model_.VTSSWD)-ved_jct)/((model_.VTSSWD)-ved_jct)));
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)),(d_T0_dV_e_si*(model_.VTSSWD)/((model_.VTSSWD)-ved_jct)));
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)),(d_T0_dV_g_di*(model_.VTSSWD)/((model_.VTSSWD)-ved_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWD))/((model_.VTSSWD)-ved_jct)))-1.0);
}

d_Ied_dV_di_si = (d_Ied_dV_di_si-(PDEJ*JTSSWD_t)*d_T1_dV_di_si);
d_Ied_dV_g_si = (d_Ied_dV_g_si-(PDEJ*JTSSWD_t)*d_T1_dV_g_si);
d_Ied_dV_g_e = (d_Ied_dV_g_e-(PDEJ*JTSSWD_t)*d_T1_dV_g_e);
d_Ied_dV_e_di = (d_Ied_dV_e_di-(PDEJ*JTSSWD_t)*d_T1_dV_e_di);
d_Ied_dV_e_si = (d_Ied_dV_e_si-(PDEJ*JTSSWD_t)*d_T1_dV_e_si);
d_Ied_dV_g_di = (d_Ied_dV_g_di-(PDEJ*JTSSWD_t)*d_T1_dV_g_di);
Ied = (Ied-((PDEJ*JTSSWD_t)*T1));
}
}
if ((JTSSWGD_t>0.0))
{
if ((((model_.VTSSWGD)-ved_jct)<((model_.VTSSWGD)*1.0e-3)))
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (((-d_ved_jct_dV_e_di)/Vtm0)/NJTSSWGD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_di_si*1.0e+3);
d_T1_dV_g_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_si*1.0e+3);
d_T1_dV_g_e = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_e*1.0e+3);
d_T1_dV_e_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_di*1.0e+3);
d_T1_dV_e_si = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_e_si*1.0e+3);
d_T1_dV_g_di = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dV_g_di*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}

d_Ied_dV_di_si = (d_Ied_dV_di_si-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_di_si);
d_Ied_dV_g_si = (d_Ied_dV_g_si-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_g_si);
d_Ied_dV_g_e = (d_Ied_dV_g_e-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_g_e);
d_Ied_dV_e_di = (d_Ied_dV_e_di-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_e_di);
d_Ied_dV_e_si = (d_Ied_dV_e_si-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_e_si);
d_Ied_dV_g_di = (d_Ied_dV_g_di-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_g_di);
Ied = (Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
}
else
{

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_g_e = d_T0_dV_g_si = d_T0_dV_di_si =  0.0;
d_T0_dV_e_di = (((-d_ved_jct_dV_e_di)/Vtm0)/NJTSSWGD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)),(d_T0_dV_di_si*(model_.VTSSWGD)/((model_.VTSSWGD)-ved_jct)));
d_T1_dV_g_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)),(d_T0_dV_g_si*(model_.VTSSWGD)/((model_.VTSSWGD)-ved_jct)));
d_T1_dV_g_e = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)),(d_T0_dV_g_e*(model_.VTSSWGD)/((model_.VTSSWGD)-ved_jct)));
d_T1_dV_e_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)),((((model_.VTSSWGD)-ved_jct)*d_T0_dV_e_di*(model_.VTSSWGD)-(T0*(model_.VTSSWGD))*(-d_ved_jct_dV_e_di))/((model_.VTSSWGD)-ved_jct)/((model_.VTSSWGD)-ved_jct)));
d_T1_dV_e_si = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)),(d_T0_dV_e_si*(model_.VTSSWGD)/((model_.VTSSWGD)-ved_jct)));
d_T1_dV_g_di = evaluator_lexp_0.getDerivs(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)),(d_T0_dV_g_di*(model_.VTSSWGD)/((model_.VTSSWGD)-ved_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*(model_.VTSSWGD))/((model_.VTSSWGD)-ved_jct)))-1.0);
}

d_Ied_dV_di_si = (d_Ied_dV_di_si-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_di_si);
d_Ied_dV_g_si = (d_Ied_dV_g_si-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_g_si);
d_Ied_dV_g_e = (d_Ied_dV_g_e-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_g_e);
d_Ied_dV_e_di = (d_Ied_dV_e_di-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_e_di);
d_Ied_dV_e_si = (d_Ied_dV_e_si-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_e_si);
d_Ied_dV_g_di = (d_Ied_dV_g_di-((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dV_g_di);
Ied = (Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
}
}
{
if ((Czbs>0.0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_si = (d_ves_jct_dV_e_si/PBS_t);
T1 = (ves_jct/PBS_t);
if ((T1<0.9))
{
if (((model_.SJS)>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/(model_.SJS)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/(model_.MJS))*evaluator_lln_0.getValues((1.0/(model_.SJS)))));
vec = (PBS_t*(1.0-evaluator_lexp_1.getValues(((1.0/(model_.MJS))*evaluator_lln_0.getValues((1.0/(model_.SJS)))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBS_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+(model_.MJS)))*evaluator_lln_0.getValues((1.0-(vec/PBS_t)))));
pb2 = ((((PBS_t*(model_.SJS))*(model_.MJS2))/(model_.MJS))/evaluator_lexp_1.getValues(((-(1.0+(model_.MJS)))*evaluator_lln_0.getValues((1.0-(vec/PBS_t))))));
}
if ((ves_jct>vec))
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj1_dV_di_d = d_Qesj1_dV_si_s =  0.0;
d_Qesj1_dV_di_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_g_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_g_e = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_e_di = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_e_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_g_di = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJS)));
Qesj1 = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
}
else
{

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
arg = (1.0-(vec/PBS_t));
if (((model_.MJS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qec_dV_di_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJS)));
d_Qec_dV_g_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJS)));
d_Qec_dV_g_e = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJS)));
d_Qec_dV_e_di = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJS)));
d_Qec_dV_e_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJS)));
d_Qec_dV_g_di = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJS)));
Qec = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));

d_arg_dV_g_di = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
d_arg_dV_e_si = (-(d_ves_jct_dV_e_si/pb2));
arg = (1.0-((ves_jct-vec)/pb2));
if (((model_.MJS2)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJS2))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj1_dV_di_d = d_Qesj1_dV_si_s =  0.0;
d_Qesj1_dV_di_si = (d_Qec_dV_di_si+((((model_.SJS)*pb2)*Czbs)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJS2))));
d_Qesj1_dV_g_si = (d_Qec_dV_g_si+((((model_.SJS)*pb2)*Czbs)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJS2))));
d_Qesj1_dV_g_e = (d_Qec_dV_g_e+((((model_.SJS)*pb2)*Czbs)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJS2))));
d_Qesj1_dV_e_di = (d_Qec_dV_e_di+((((model_.SJS)*pb2)*Czbs)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJS2))));
d_Qesj1_dV_e_si = (d_Qec_dV_e_si+((((model_.SJS)*pb2)*Czbs)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJS2))));
d_Qesj1_dV_g_di = (d_Qec_dV_g_di+((((model_.SJS)*pb2)*Czbs)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJS2))));
Qesj1 = (Qec+(((((model_.SJS)*pb2)*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS2))));
}
}
else
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJS))*evaluator_lln_0.getValues(arg)),(-(model_.MJS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj1_dV_di_d = d_Qesj1_dV_si_s =  0.0;
d_Qesj1_dV_di_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_g_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_g_e = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_e_di = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_e_si = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJS)));
d_Qesj1_dV_g_di = ((PBS_t*Czbs)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJS)));
Qesj1 = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-(model_.MJS)));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJS))*evaluator_lln_0.getValues(0.1)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = evaluator_lexp_1.getValues(((-(model_.MJS))*evaluator_lln_0.getValues(0.1)));
}

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = (1.0/(1.0-(model_.MJS)));

d_T4_dV_di_si = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_di_si+(T2*d_T1_dV_di_si+d_T2_dV_di_si*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_e_di = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_e_di+(T2*d_T1_dV_e_di+d_T2_dV_e_di*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_e_si = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_e_si+(T2*d_T1_dV_e_si+d_T2_dV_e_si*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_g_si = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_g_si+(T2*d_T1_dV_g_si+d_T2_dV_g_si*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_g_e = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_g_e+(T2*d_T1_dV_g_e+d_T2_dV_g_e*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
d_T4_dV_g_di = ((T2*(T1-1.0))*(5.0*(model_.MJS))*d_T1_dV_g_di+(T2*d_T1_dV_g_di+d_T2_dV_g_di*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJS))*(T1-1.0))+(1.0+(model_.MJS))));

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_di_si)+d_T3_dV_di_si*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_e_di = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_e_di)+d_T3_dV_e_di*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_e_si = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_e_si)+d_T3_dV_e_si*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_g_si = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_g_si)+d_T3_dV_g_si*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_g_e = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_g_e)+d_T3_dV_g_e*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
d_T5_dV_g_di = (T3*(-((0.05*(model_.MJS))*(1.0+(model_.MJS)))*d_T2_dV_g_di)+d_T3_dV_g_di*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJS))*(1.0+(model_.MJS)))*T2)));

d_Qesj1_dV_si_s = (PBS_t*Czbs)*d_T5_dV_si_s;
d_Qesj1_dV_di_d = (PBS_t*Czbs)*d_T5_dV_di_d;
d_Qesj1_dV_g_si = (PBS_t*Czbs)*(d_T4_dV_g_si+d_T5_dV_g_si);
d_Qesj1_dV_g_e = (PBS_t*Czbs)*(d_T4_dV_g_e+d_T5_dV_g_e);
d_Qesj1_dV_e_di = (PBS_t*Czbs)*(d_T4_dV_e_di+d_T5_dV_e_di);
d_Qesj1_dV_e_si = (PBS_t*Czbs)*(d_T4_dV_e_si+d_T5_dV_e_si);
d_Qesj1_dV_di_si = (PBS_t*Czbs)*(d_T4_dV_di_si+d_T5_dV_di_si);
d_Qesj1_dV_g_di = (PBS_t*Czbs)*(d_T4_dV_g_di+d_T5_dV_g_di);
Qesj1 = ((PBS_t*Czbs)*(T4+T5));
}
}
else
{

d_Qesj1_dV_di_d = d_Qesj1_dV_si_s = d_Qesj1_dV_g_di = d_Qesj1_dV_e_si = d_Qesj1_dV_e_di = d_Qesj1_dV_g_e = d_Qesj1_dV_g_si = d_Qesj1_dV_di_si =  0.0;
Qesj1 = 0.0;
}
}
{
if ((Czbssw>0.0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_si = (d_ves_jct_dV_e_si/PBSWS_t);
T1 = (ves_jct/PBSWS_t);
if ((T1<0.9))
{
if (((model_.SJSWS)>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/(model_.SJSWS)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/(model_.MJSWS))*evaluator_lln_0.getValues((1.0/(model_.SJSWS)))));
vec = (PBSWS_t*(1.0-evaluator_lexp_1.getValues(((1.0/(model_.MJSWS))*evaluator_lln_0.getValues((1.0/(model_.SJSWS)))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWS_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+(model_.MJSWS)))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t)))));
pb2 = ((((PBSWS_t*(model_.SJSWS))*(model_.MJSWS2))/(model_.MJSWS))/evaluator_lexp_1.getValues(((-(1.0+(model_.MJSWS)))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t))))));
}
if ((ves_jct>vec))
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj2_dV_di_d = d_Qesj2_dV_si_s =  0.0;
d_Qesj2_dV_di_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_g_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_g_e = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_e_di = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_e_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_g_di = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWS)));
Qesj2 = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS)));
}
else
{

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
arg = (1.0-(vec/PBSWS_t));
if (((model_.MJSWS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qec_dV_di_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWS)));
d_Qec_dV_g_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWS)));
d_Qec_dV_g_e = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWS)));
d_Qec_dV_e_di = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWS)));
d_Qec_dV_e_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWS)));
d_Qec_dV_g_di = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWS)));
Qec = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS)));

d_arg_dV_g_di = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
d_arg_dV_e_si = (-(d_ves_jct_dV_e_si/pb2));
arg = (1.0-((ves_jct-vec)/pb2));
if (((model_.MJSWS2)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWS2))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj2_dV_di_d = d_Qesj2_dV_si_s =  0.0;
d_Qesj2_dV_di_si = (d_Qec_dV_di_si+((((model_.SJSWS)*pb2)*Czbssw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWS2))));
d_Qesj2_dV_g_si = (d_Qec_dV_g_si+((((model_.SJSWS)*pb2)*Czbssw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWS2))));
d_Qesj2_dV_g_e = (d_Qec_dV_g_e+((((model_.SJSWS)*pb2)*Czbssw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWS2))));
d_Qesj2_dV_e_di = (d_Qec_dV_e_di+((((model_.SJSWS)*pb2)*Czbssw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWS2))));
d_Qesj2_dV_e_si = (d_Qec_dV_e_si+((((model_.SJSWS)*pb2)*Czbssw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWS2))));
d_Qesj2_dV_g_di = (d_Qec_dV_g_di+((((model_.SJSWS)*pb2)*Czbssw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWS2))));
Qesj2 = (Qec+(((((model_.SJSWS)*pb2)*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS2))));
}
}
else
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj2_dV_di_d = d_Qesj2_dV_si_s =  0.0;
d_Qesj2_dV_di_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_g_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_g_e = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_e_di = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_e_si = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWS)));
d_Qesj2_dV_g_di = ((PBSWS_t*Czbssw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWS)));
Qesj2 = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWS)));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWS))*evaluator_lln_0.getValues(0.1)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = evaluator_lexp_1.getValues(((-(model_.MJSWS))*evaluator_lln_0.getValues(0.1)));
}

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = (1.0/(1.0-(model_.MJSWS)));

d_T4_dV_di_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_di_si+(T2*d_T1_dV_di_si+d_T2_dV_di_si*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_e_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_e_di+(T2*d_T1_dV_e_di+d_T2_dV_e_di*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_e_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_e_si+(T2*d_T1_dV_e_si+d_T2_dV_e_si*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_g_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_g_si+(T2*d_T1_dV_g_si+d_T2_dV_g_si*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_g_e = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_g_e+(T2*d_T1_dV_g_e+d_T2_dV_g_e*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
d_T4_dV_g_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWS))*d_T1_dV_g_di+(T2*d_T1_dV_g_di+d_T2_dV_g_di*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWS))*(T1-1.0))+(1.0+(model_.MJSWS))));

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_di_si)+d_T3_dV_di_si*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_e_di = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_e_di)+d_T3_dV_e_di*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_e_si = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_e_si)+d_T3_dV_e_si*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_g_si = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_g_si)+d_T3_dV_g_si*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_g_e = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_g_e)+d_T3_dV_g_e*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
d_T5_dV_g_di = (T3*(-((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*d_T2_dV_g_di)+d_T3_dV_g_di*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWS))*(1.0+(model_.MJSWS)))*T2)));

d_Qesj2_dV_si_s = (PBSWS_t*Czbssw)*d_T5_dV_si_s;
d_Qesj2_dV_di_d = (PBSWS_t*Czbssw)*d_T5_dV_di_d;
d_Qesj2_dV_g_si = (PBSWS_t*Czbssw)*(d_T4_dV_g_si+d_T5_dV_g_si);
d_Qesj2_dV_g_e = (PBSWS_t*Czbssw)*(d_T4_dV_g_e+d_T5_dV_g_e);
d_Qesj2_dV_e_di = (PBSWS_t*Czbssw)*(d_T4_dV_e_di+d_T5_dV_e_di);
d_Qesj2_dV_e_si = (PBSWS_t*Czbssw)*(d_T4_dV_e_si+d_T5_dV_e_si);
d_Qesj2_dV_di_si = (PBSWS_t*Czbssw)*(d_T4_dV_di_si+d_T5_dV_di_si);
d_Qesj2_dV_g_di = (PBSWS_t*Czbssw)*(d_T4_dV_g_di+d_T5_dV_g_di);
Qesj2 = ((PBSWS_t*Czbssw)*(T4+T5));
}
}
else
{

d_Qesj2_dV_di_d = d_Qesj2_dV_si_s = d_Qesj2_dV_g_di = d_Qesj2_dV_e_si = d_Qesj2_dV_e_di = d_Qesj2_dV_g_e = d_Qesj2_dV_g_si = d_Qesj2_dV_di_si =  0.0;
Qesj2 = 0.0;
}
}
{
if ((Czbsswg>0.0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_si = (d_ves_jct_dV_e_si/PBSWGS_t);
T1 = (ves_jct/PBSWGS_t);
if ((T1<0.9))
{
if (((model_.SJSWGS)>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/(model_.SJSWGS)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/(model_.MJSWGS))*evaluator_lln_0.getValues((1.0/(model_.SJSWGS)))));
vec = (PBSWGS_t*(1.0-evaluator_lexp_1.getValues(((1.0/(model_.MJSWGS))*evaluator_lln_0.getValues((1.0/(model_.SJSWGS)))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWGS_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+(model_.MJSWGS)))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t)))));
pb2 = ((((PBSWGS_t*(model_.SJSWGS))*(model_.MJSWGS2))/(model_.MJSWGS))/evaluator_lexp_1.getValues(((-(1.0+(model_.MJSWGS)))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t))))));
}
if ((ves_jct>vec))
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWGS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj3_dV_di_d = d_Qesj3_dV_si_s =  0.0;
d_Qesj3_dV_di_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_g_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_g_e = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_e_di = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_e_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_g_di = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGS)));
Qesj3 = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS)));
}
else
{

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
arg = (1.0-(vec/PBSWGS_t));
if (((model_.MJSWGS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qec_dV_di_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qec_dV_g_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qec_dV_g_e = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGS)));
d_Qec_dV_e_di = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGS)));
d_Qec_dV_e_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qec_dV_g_di = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGS)));
Qec = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS)));

d_arg_dV_g_di = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
d_arg_dV_e_si = (-(d_ves_jct_dV_e_si/pb2));
arg = (1.0-((ves_jct-vec)/pb2));
if (((model_.MJSWGS2)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGS2))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj3_dV_di_d = d_Qesj3_dV_si_s =  0.0;
d_Qesj3_dV_di_si = (d_Qec_dV_di_si+((((model_.SJSWGS)*pb2)*Czbsswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGS2))));
d_Qesj3_dV_g_si = (d_Qec_dV_g_si+((((model_.SJSWGS)*pb2)*Czbsswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGS2))));
d_Qesj3_dV_g_e = (d_Qec_dV_g_e+((((model_.SJSWGS)*pb2)*Czbsswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGS2))));
d_Qesj3_dV_e_di = (d_Qec_dV_e_di+((((model_.SJSWGS)*pb2)*Czbsswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGS2))));
d_Qesj3_dV_e_si = (d_Qec_dV_e_si+((((model_.SJSWGS)*pb2)*Czbsswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGS2))));
d_Qesj3_dV_g_di = (d_Qec_dV_g_di+((((model_.SJSWGS)*pb2)*Czbsswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGS2))));
Qesj3 = (Qec+(((((model_.SJSWGS)*pb2)*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS2))));
}
}
else
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWGS)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGS))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGS))*evaluator_lln_0.getValues(arg)));
}
}

d_Qesj3_dV_di_d = d_Qesj3_dV_si_s =  0.0;
d_Qesj3_dV_di_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_g_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_g_e = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_e_di = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_e_si = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGS)));
d_Qesj3_dV_g_di = ((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGS)));
Qesj3 = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGS)));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGS))*evaluator_lln_0.getValues(0.1)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = evaluator_lexp_1.getValues(((-(model_.MJSWGS))*evaluator_lln_0.getValues(0.1)));
}

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = (1.0/(1.0-(model_.MJSWGS)));

d_T4_dV_di_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_di_si+(T2*d_T1_dV_di_si+d_T2_dV_di_si*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_e_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_e_di+(T2*d_T1_dV_e_di+d_T2_dV_e_di*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_e_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_e_si+(T2*d_T1_dV_e_si+d_T2_dV_e_si*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_g_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_g_si+(T2*d_T1_dV_g_si+d_T2_dV_g_si*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_g_e = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_g_e+(T2*d_T1_dV_g_e+d_T2_dV_g_e*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
d_T4_dV_g_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWGS))*d_T1_dV_g_di+(T2*d_T1_dV_g_di+d_T2_dV_g_di*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGS))*(T1-1.0))+(1.0+(model_.MJSWGS))));

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_di_si)+d_T3_dV_di_si*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_e_di = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_e_di)+d_T3_dV_e_di*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_e_si = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_e_si)+d_T3_dV_e_si*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_g_si = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_g_si)+d_T3_dV_g_si*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_g_e = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_g_e)+d_T3_dV_g_e*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
d_T5_dV_g_di = (T3*(-((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*d_T2_dV_g_di)+d_T3_dV_g_di*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWGS))*(1.0+(model_.MJSWGS)))*T2)));

d_Qesj3_dV_si_s = (PBSWGS_t*Czbsswg)*d_T5_dV_si_s;
d_Qesj3_dV_di_d = (PBSWGS_t*Czbsswg)*d_T5_dV_di_d;
d_Qesj3_dV_g_si = (PBSWGS_t*Czbsswg)*(d_T4_dV_g_si+d_T5_dV_g_si);
d_Qesj3_dV_g_e = (PBSWGS_t*Czbsswg)*(d_T4_dV_g_e+d_T5_dV_g_e);
d_Qesj3_dV_e_di = (PBSWGS_t*Czbsswg)*(d_T4_dV_e_di+d_T5_dV_e_di);
d_Qesj3_dV_e_si = (PBSWGS_t*Czbsswg)*(d_T4_dV_e_si+d_T5_dV_e_si);
d_Qesj3_dV_di_si = (PBSWGS_t*Czbsswg)*(d_T4_dV_di_si+d_T5_dV_di_si);
d_Qesj3_dV_g_di = (PBSWGS_t*Czbsswg)*(d_T4_dV_g_di+d_T5_dV_g_di);
Qesj3 = ((PBSWGS_t*Czbsswg)*(T4+T5));
}
}
else
{

d_Qesj3_dV_di_d = d_Qesj3_dV_si_s = d_Qesj3_dV_g_di = d_Qesj3_dV_e_si = d_Qesj3_dV_e_di = d_Qesj3_dV_g_e = d_Qesj3_dV_g_si = d_Qesj3_dV_di_si =  0.0;
Qesj3 = 0.0;
}
}

d_Qesj_dV_di_si = ((d_Qesj1_dV_di_si+d_Qesj2_dV_di_si)+d_Qesj3_dV_di_si);
d_Qesj_dV_g_si = ((d_Qesj1_dV_g_si+d_Qesj2_dV_g_si)+d_Qesj3_dV_g_si);
d_Qesj_dV_g_e = ((d_Qesj1_dV_g_e+d_Qesj2_dV_g_e)+d_Qesj3_dV_g_e);
d_Qesj_dV_e_di = ((d_Qesj1_dV_e_di+d_Qesj2_dV_e_di)+d_Qesj3_dV_e_di);
d_Qesj_dV_e_si = ((d_Qesj1_dV_e_si+d_Qesj2_dV_e_si)+d_Qesj3_dV_e_si);
d_Qesj_dV_g_di = ((d_Qesj1_dV_g_di+d_Qesj2_dV_g_di)+d_Qesj3_dV_g_di);
d_Qesj_dV_si_s = ((d_Qesj1_dV_si_s+d_Qesj2_dV_si_s)+d_Qesj3_dV_si_s);
d_Qesj_dV_di_d = ((d_Qesj1_dV_di_d+d_Qesj2_dV_di_d)+d_Qesj3_dV_di_d);
Qesj = ((Qesj1+Qesj2)+Qesj3);
{
if ((Czbd>0.0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_di = (d_ved_jct_dV_e_di/PBD_t);
T1 = (ved_jct/PBD_t);
if ((T1<0.9))
{
if (((model_.SJD)>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/(model_.SJD)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/(model_.MJD))*evaluator_lln_0.getValues((1.0/(model_.SJD)))));
vec = (PBD_t*(1.0-evaluator_lexp_1.getValues(((1.0/(model_.MJD))*evaluator_lln_0.getValues((1.0/(model_.SJD)))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBD_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+(model_.MJD)))*evaluator_lln_0.getValues((1.0-(vec/PBD_t)))));
pb2 = ((((PBD_t*(model_.SJD))*(model_.MJD2))/(model_.MJD))/evaluator_lexp_1.getValues(((-(1.0+(model_.MJD)))*evaluator_lln_0.getValues((1.0-(vec/PBD_t))))));
}
if ((ved_jct>vec))
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj1_dV_di_d = d_Qedj1_dV_si_s =  0.0;
d_Qedj1_dV_di_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_g_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_g_e = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_e_di = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_e_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_g_di = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJD)));
Qedj1 = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
}
else
{

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
arg = (1.0-(vec/PBD_t));
if (((model_.MJD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qec_dV_di_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJD)));
d_Qec_dV_g_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJD)));
d_Qec_dV_g_e = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJD)));
d_Qec_dV_e_di = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJD)));
d_Qec_dV_e_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJD)));
d_Qec_dV_g_di = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJD)));
Qec = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
d_arg_dV_e_di = (-(d_ved_jct_dV_e_di/pb2));
arg = (1.0-((ved_jct-vec)/pb2));
if (((model_.MJD2)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJD2))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj1_dV_di_d = d_Qedj1_dV_si_s =  0.0;
d_Qedj1_dV_di_si = (d_Qec_dV_di_si+((((model_.SJD)*pb2)*Czbd)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJD2))));
d_Qedj1_dV_g_si = (d_Qec_dV_g_si+((((model_.SJD)*pb2)*Czbd)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJD2))));
d_Qedj1_dV_g_e = (d_Qec_dV_g_e+((((model_.SJD)*pb2)*Czbd)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJD2))));
d_Qedj1_dV_e_di = (d_Qec_dV_e_di+((((model_.SJD)*pb2)*Czbd)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJD2))));
d_Qedj1_dV_e_si = (d_Qec_dV_e_si+((((model_.SJD)*pb2)*Czbd)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJD2))));
d_Qedj1_dV_g_di = (d_Qec_dV_g_di+((((model_.SJD)*pb2)*Czbd)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJD2))));
Qedj1 = (Qec+(((((model_.SJD)*pb2)*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD2))));
}
}
else
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJD))*evaluator_lln_0.getValues(arg)),(-(model_.MJD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj1_dV_di_d = d_Qedj1_dV_si_s =  0.0;
d_Qedj1_dV_di_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_g_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_g_e = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_e_di = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_e_si = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJD)));
d_Qedj1_dV_g_di = ((PBD_t*Czbd)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJD)));
Qedj1 = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-(model_.MJD)));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJD))*evaluator_lln_0.getValues(0.1)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = evaluator_lexp_1.getValues(((-(model_.MJD))*evaluator_lln_0.getValues(0.1)));
}

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = (1.0/(1.0-(model_.MJD)));

d_T4_dV_di_si = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_di_si+(T2*d_T1_dV_di_si+d_T2_dV_di_si*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_e_di = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_e_di+(T2*d_T1_dV_e_di+d_T2_dV_e_di*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_e_si = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_e_si+(T2*d_T1_dV_e_si+d_T2_dV_e_si*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_g_si = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_g_si+(T2*d_T1_dV_g_si+d_T2_dV_g_si*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_g_e = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_g_e+(T2*d_T1_dV_g_e+d_T2_dV_g_e*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
d_T4_dV_g_di = ((T2*(T1-1.0))*(5.0*(model_.MJD))*d_T1_dV_g_di+(T2*d_T1_dV_g_di+d_T2_dV_g_di*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJD))*(T1-1.0))+(1.0+(model_.MJD))));

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_di_si)+d_T3_dV_di_si*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_e_di = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_e_di)+d_T3_dV_e_di*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_e_si = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_e_si)+d_T3_dV_e_si*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_g_si = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_g_si)+d_T3_dV_g_si*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_g_e = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_g_e)+d_T3_dV_g_e*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
d_T5_dV_g_di = (T3*(-((0.05*(model_.MJD))*(1.0+(model_.MJD)))*d_T2_dV_g_di)+d_T3_dV_g_di*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJD))*(1.0+(model_.MJD)))*T2)));

d_Qedj1_dV_si_s = (PBD_t*Czbd)*d_T5_dV_si_s;
d_Qedj1_dV_di_d = (PBD_t*Czbd)*d_T5_dV_di_d;
d_Qedj1_dV_g_si = (PBD_t*Czbd)*(d_T4_dV_g_si+d_T5_dV_g_si);
d_Qedj1_dV_g_e = (PBD_t*Czbd)*(d_T4_dV_g_e+d_T5_dV_g_e);
d_Qedj1_dV_e_di = (PBD_t*Czbd)*(d_T4_dV_e_di+d_T5_dV_e_di);
d_Qedj1_dV_e_si = (PBD_t*Czbd)*(d_T4_dV_e_si+d_T5_dV_e_si);
d_Qedj1_dV_di_si = (PBD_t*Czbd)*(d_T4_dV_di_si+d_T5_dV_di_si);
d_Qedj1_dV_g_di = (PBD_t*Czbd)*(d_T4_dV_g_di+d_T5_dV_g_di);
Qedj1 = ((PBD_t*Czbd)*(T4+T5));
}
}
else
{

d_Qedj1_dV_di_d = d_Qedj1_dV_si_s = d_Qedj1_dV_g_di = d_Qedj1_dV_e_si = d_Qedj1_dV_e_di = d_Qedj1_dV_g_e = d_Qedj1_dV_g_si = d_Qedj1_dV_di_si =  0.0;
Qedj1 = 0.0;
}
}
{
if ((Czbdsw>0.0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_di = (d_ved_jct_dV_e_di/PBSWD_t);
T1 = (ved_jct/PBSWD_t);
if ((T1<0.9))
{
if (((model_.SJSWD)>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/(model_.SJSWD)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/(model_.MJSWD))*evaluator_lln_0.getValues((1.0/(model_.SJSWD)))));
vec = (PBSWD_t*(1.0-evaluator_lexp_1.getValues(((1.0/(model_.MJSWD))*evaluator_lln_0.getValues((1.0/(model_.SJSWD)))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWD_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+(model_.MJSWD)))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t)))));
pb2 = ((((PBSWD_t*(model_.SJSWD))*(model_.MJSWD2))/(model_.MJSWD))/evaluator_lexp_1.getValues(((-(1.0+(model_.MJSWD)))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t))))));
}
if ((ved_jct>vec))
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj2_dV_di_d = d_Qedj2_dV_si_s =  0.0;
d_Qedj2_dV_di_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_g_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_g_e = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_e_di = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_e_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_g_di = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWD)));
Qedj2 = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD)));
}
else
{

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
arg = (1.0-(vec/PBSWD_t));
if (((model_.MJSWD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qec_dV_di_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWD)));
d_Qec_dV_g_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWD)));
d_Qec_dV_g_e = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWD)));
d_Qec_dV_e_di = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWD)));
d_Qec_dV_e_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWD)));
d_Qec_dV_g_di = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWD)));
Qec = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD)));

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
d_arg_dV_e_di = (-(d_ved_jct_dV_e_di/pb2));
arg = (1.0-((ved_jct-vec)/pb2));
if (((model_.MJSWD2)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWD2))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj2_dV_di_d = d_Qedj2_dV_si_s =  0.0;
d_Qedj2_dV_di_si = (d_Qec_dV_di_si+((((model_.SJSWD)*pb2)*Czbdsw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWD2))));
d_Qedj2_dV_g_si = (d_Qec_dV_g_si+((((model_.SJSWD)*pb2)*Czbdsw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWD2))));
d_Qedj2_dV_g_e = (d_Qec_dV_g_e+((((model_.SJSWD)*pb2)*Czbdsw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWD2))));
d_Qedj2_dV_e_di = (d_Qec_dV_e_di+((((model_.SJSWD)*pb2)*Czbdsw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWD2))));
d_Qedj2_dV_e_si = (d_Qec_dV_e_si+((((model_.SJSWD)*pb2)*Czbdsw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWD2))));
d_Qedj2_dV_g_di = (d_Qec_dV_g_di+((((model_.SJSWD)*pb2)*Czbdsw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWD2))));
Qedj2 = (Qec+(((((model_.SJSWD)*pb2)*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD2))));
}
}
else
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj2_dV_di_d = d_Qedj2_dV_si_s =  0.0;
d_Qedj2_dV_di_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_g_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_g_e = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_e_di = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_e_si = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWD)));
d_Qedj2_dV_g_di = ((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWD)));
Qedj2 = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWD)));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWD))*evaluator_lln_0.getValues(0.1)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = evaluator_lexp_1.getValues(((-(model_.MJSWD))*evaluator_lln_0.getValues(0.1)));
}

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = (1.0/(1.0-(model_.MJSWD)));

d_T4_dV_di_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_di_si+(T2*d_T1_dV_di_si+d_T2_dV_di_si*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_e_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_e_di+(T2*d_T1_dV_e_di+d_T2_dV_e_di*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_e_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_e_si+(T2*d_T1_dV_e_si+d_T2_dV_e_si*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_g_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_g_si+(T2*d_T1_dV_g_si+d_T2_dV_g_si*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_g_e = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_g_e+(T2*d_T1_dV_g_e+d_T2_dV_g_e*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
d_T4_dV_g_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWD))*d_T1_dV_g_di+(T2*d_T1_dV_g_di+d_T2_dV_g_di*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWD))*(T1-1.0))+(1.0+(model_.MJSWD))));

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_di_si)+d_T3_dV_di_si*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_e_di = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_e_di)+d_T3_dV_e_di*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_e_si = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_e_si)+d_T3_dV_e_si*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_g_si = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_g_si)+d_T3_dV_g_si*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_g_e = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_g_e)+d_T3_dV_g_e*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
d_T5_dV_g_di = (T3*(-((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*d_T2_dV_g_di)+d_T3_dV_g_di*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWD))*(1.0+(model_.MJSWD)))*T2)));

d_Qedj2_dV_si_s = (PBSWD_t*Czbdsw)*d_T5_dV_si_s;
d_Qedj2_dV_di_d = (PBSWD_t*Czbdsw)*d_T5_dV_di_d;
d_Qedj2_dV_g_si = (PBSWD_t*Czbdsw)*(d_T4_dV_g_si+d_T5_dV_g_si);
d_Qedj2_dV_g_e = (PBSWD_t*Czbdsw)*(d_T4_dV_g_e+d_T5_dV_g_e);
d_Qedj2_dV_e_di = (PBSWD_t*Czbdsw)*(d_T4_dV_e_di+d_T5_dV_e_di);
d_Qedj2_dV_e_si = (PBSWD_t*Czbdsw)*(d_T4_dV_e_si+d_T5_dV_e_si);
d_Qedj2_dV_di_si = (PBSWD_t*Czbdsw)*(d_T4_dV_di_si+d_T5_dV_di_si);
d_Qedj2_dV_g_di = (PBSWD_t*Czbdsw)*(d_T4_dV_g_di+d_T5_dV_g_di);
Qedj2 = ((PBSWD_t*Czbdsw)*(T4+T5));
}
}
else
{

d_Qedj2_dV_di_d = d_Qedj2_dV_si_s = d_Qedj2_dV_g_di = d_Qedj2_dV_e_si = d_Qedj2_dV_e_di = d_Qedj2_dV_g_e = d_Qedj2_dV_g_si = d_Qedj2_dV_di_si =  0.0;
Qedj2 = 0.0;
}
}
{
if ((Czbdswg>0.0))
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_g_e = d_T1_dV_g_si = d_T1_dV_di_si =  0.0;
d_T1_dV_e_di = (d_ved_jct_dV_e_di/PBSWGD_t);
T1 = (ved_jct/PBSWGD_t);
if ((T1<0.9))
{
if (((model_.SJSWGD)>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/(model_.SJSWGD)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/(model_.MJSWGD))*evaluator_lln_0.getValues((1.0/(model_.SJSWGD)))));
vec = (PBSWGD_t*(1.0-evaluator_lexp_1.getValues(((1.0/(model_.MJSWGD))*evaluator_lln_0.getValues((1.0/(model_.SJSWGD)))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWGD_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+(model_.MJSWGD)))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t)))));
pb2 = ((((PBSWGD_t*(model_.SJSWGD))*(model_.MJSWGD2))/(model_.MJSWGD))/evaluator_lexp_1.getValues(((-(1.0+(model_.MJSWGD)))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t))))));
}
if ((ved_jct>vec))
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWGD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj3_dV_di_d = d_Qedj3_dV_si_s =  0.0;
d_Qedj3_dV_di_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_g_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_g_e = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_e_di = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_e_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_g_di = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGD)));
Qedj3 = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD)));
}
else
{

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_e_di = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
arg = (1.0-(vec/PBSWGD_t));
if (((model_.MJSWGD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qec_dV_di_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qec_dV_g_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qec_dV_g_e = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGD)));
d_Qec_dV_e_di = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGD)));
d_Qec_dV_e_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qec_dV_g_di = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGD)));
Qec = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD)));

d_arg_dV_g_di = d_arg_dV_e_si = d_arg_dV_g_e = d_arg_dV_g_si = d_arg_dV_di_si =  0.0;
d_arg_dV_e_di = (-(d_ved_jct_dV_e_di/pb2));
arg = (1.0-((ved_jct-vec)/pb2));
if (((model_.MJSWGD2)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD2))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGD2))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj3_dV_di_d = d_Qedj3_dV_si_s =  0.0;
d_Qedj3_dV_di_si = (d_Qec_dV_di_si+((((model_.SJSWGD)*pb2)*Czbdswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGD2))));
d_Qedj3_dV_g_si = (d_Qec_dV_g_si+((((model_.SJSWGD)*pb2)*Czbdswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGD2))));
d_Qedj3_dV_g_e = (d_Qec_dV_g_e+((((model_.SJSWGD)*pb2)*Czbdswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGD2))));
d_Qedj3_dV_e_di = (d_Qec_dV_e_di+((((model_.SJSWGD)*pb2)*Czbdswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGD2))));
d_Qedj3_dV_e_si = (d_Qec_dV_e_si+((((model_.SJSWGD)*pb2)*Czbdswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGD2))));
d_Qedj3_dV_g_di = (d_Qec_dV_g_di+((((model_.SJSWGD)*pb2)*Czbdswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGD2))));
Qedj3 = (Qec+(((((model_.SJSWGD)*pb2)*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD2))));
}
}
else
{

d_arg_dV_di_si = (-d_T1_dV_di_si);
d_arg_dV_g_si = (-d_T1_dV_g_si);
d_arg_dV_g_e = (-d_T1_dV_g_e);
d_arg_dV_e_di = (-d_T1_dV_e_di);
d_arg_dV_e_si = (-d_T1_dV_e_si);
d_arg_dV_g_di = (-d_T1_dV_g_di);
arg = (1.0-T1);
if (((model_.MJSWGD)==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sarg_dV_di_si = (-(deriv_sqrt_0_d0*(d_arg_dV_di_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_si = (-(deriv_sqrt_0_d0*(d_arg_dV_g_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_e = (-(deriv_sqrt_0_d0*(d_arg_dV_g_e))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_di = (-(deriv_sqrt_0_d0*(d_arg_dV_e_di))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_e_si = (-(deriv_sqrt_0_d0*(d_arg_dV_e_si))/value_sqrt_0/value_sqrt_0);
d_sarg_dV_g_di = (-(deriv_sqrt_0_d0*(d_arg_dV_g_di))/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));

d_sarg_dV_di_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_di_si));
d_sarg_dV_g_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_si));
d_sarg_dV_g_e = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_e));
d_sarg_dV_e_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_di));
d_sarg_dV_e_si = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_e_si));
d_sarg_dV_g_di = evaluator_lexp_1.getDerivs(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)),(-(model_.MJSWGD))*evaluator_lln_0.getDerivs(arg,d_arg_dV_g_di));
sarg = evaluator_lexp_1.getValues(((-(model_.MJSWGD))*evaluator_lln_0.getValues(arg)));
}
}

d_Qedj3_dV_di_d = d_Qedj3_dV_si_s =  0.0;
d_Qedj3_dV_di_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_di_si+d_arg_dV_di_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_g_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_si+d_arg_dV_g_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_g_e = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_e+d_arg_dV_g_e*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_e_di = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_e_di+d_arg_dV_e_di*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_e_si = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_e_si+d_arg_dV_e_si*sarg))/(1.0-(model_.MJSWGD)));
d_Qedj3_dV_g_di = ((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dV_g_di+d_arg_dV_g_di*sarg))/(1.0-(model_.MJSWGD)));
Qedj3 = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-(model_.MJSWGD)));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(model_.MJSWGD))*evaluator_lln_0.getValues(0.1)));

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_e = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
T2 = evaluator_lexp_1.getValues(((-(model_.MJSWGD))*evaluator_lln_0.getValues(0.1)));
}

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = (1.0/(1.0-(model_.MJSWGD)));

d_T4_dV_di_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_di_si+(T2*d_T1_dV_di_si+d_T2_dV_di_si*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_e_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_e_di+(T2*d_T1_dV_e_di+d_T2_dV_e_di*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_e_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_e_si+(T2*d_T1_dV_e_si+d_T2_dV_e_si*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_g_si = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_g_si+(T2*d_T1_dV_g_si+d_T2_dV_g_si*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_g_e = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_g_e+(T2*d_T1_dV_g_e+d_T2_dV_g_e*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
d_T4_dV_g_di = ((T2*(T1-1.0))*(5.0*(model_.MJSWGD))*d_T1_dV_g_di+(T2*d_T1_dV_g_di+d_T2_dV_g_di*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));
T4 = ((T2*(T1-1.0))*(((5.0*(model_.MJSWGD))*(T1-1.0))+(1.0+(model_.MJSWGD))));

d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_di_si)+d_T3_dV_di_si*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_e_di = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_e_di)+d_T3_dV_e_di*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_e_si = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_e_si)+d_T3_dV_e_si*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_g_si = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_g_si)+d_T3_dV_g_si*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_g_e = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_g_e)+d_T3_dV_g_e*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
d_T5_dV_g_di = (T3*(-((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*d_T2_dV_g_di)+d_T3_dV_g_di*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));
T5 = (T3*(1.0-(((0.05*(model_.MJSWGD))*(1.0+(model_.MJSWGD)))*T2)));

d_Qedj3_dV_si_s = (PBSWGD_t*Czbdswg)*d_T5_dV_si_s;
d_Qedj3_dV_di_d = (PBSWGD_t*Czbdswg)*d_T5_dV_di_d;
d_Qedj3_dV_g_si = (PBSWGD_t*Czbdswg)*(d_T4_dV_g_si+d_T5_dV_g_si);
d_Qedj3_dV_g_e = (PBSWGD_t*Czbdswg)*(d_T4_dV_g_e+d_T5_dV_g_e);
d_Qedj3_dV_e_di = (PBSWGD_t*Czbdswg)*(d_T4_dV_e_di+d_T5_dV_e_di);
d_Qedj3_dV_e_si = (PBSWGD_t*Czbdswg)*(d_T4_dV_e_si+d_T5_dV_e_si);
d_Qedj3_dV_di_si = (PBSWGD_t*Czbdswg)*(d_T4_dV_di_si+d_T5_dV_di_si);
d_Qedj3_dV_g_di = (PBSWGD_t*Czbdswg)*(d_T4_dV_g_di+d_T5_dV_g_di);
Qedj3 = ((PBSWGD_t*Czbdswg)*(T4+T5));
}
}
else
{

d_Qedj3_dV_di_d = d_Qedj3_dV_si_s = d_Qedj3_dV_g_di = d_Qedj3_dV_e_si = d_Qedj3_dV_e_di = d_Qedj3_dV_g_e = d_Qedj3_dV_g_si = d_Qedj3_dV_di_si =  0.0;
Qedj3 = 0.0;
}
}

d_Qedj_dV_di_si = ((d_Qedj1_dV_di_si+d_Qedj2_dV_di_si)+d_Qedj3_dV_di_si);
d_Qedj_dV_g_si = ((d_Qedj1_dV_g_si+d_Qedj2_dV_g_si)+d_Qedj3_dV_g_si);
d_Qedj_dV_g_e = ((d_Qedj1_dV_g_e+d_Qedj2_dV_g_e)+d_Qedj3_dV_g_e);
d_Qedj_dV_e_di = ((d_Qedj1_dV_e_di+d_Qedj2_dV_e_di)+d_Qedj3_dV_e_di);
d_Qedj_dV_e_si = ((d_Qedj1_dV_e_si+d_Qedj2_dV_e_si)+d_Qedj3_dV_e_si);
d_Qedj_dV_g_di = ((d_Qedj1_dV_g_di+d_Qedj2_dV_g_di)+d_Qedj3_dV_g_di);
d_Qedj_dV_si_s = ((d_Qedj1_dV_si_s+d_Qedj2_dV_si_s)+d_Qedj3_dV_si_s);
d_Qedj_dV_di_d = ((d_Qedj1_dV_di_d+d_Qedj2_dV_di_d)+d_Qedj3_dV_di_d);
Qedj = ((Qedj1+Qedj2)+Qedj3);
}

d_Qes_dV_di_si = d_Qesj_dV_di_si;
d_Qes_dV_g_si = d_Qesj_dV_g_si;
d_Qes_dV_g_e = d_Qesj_dV_g_e;
d_Qes_dV_e_di = d_Qesj_dV_e_di;
d_Qes_dV_e_si = (d_Qesj_dV_e_si+csbox*d_ves_jct_dV_e_si);
d_Qes_dV_g_di = d_Qesj_dV_g_di;
d_Qes_dV_si_s = d_Qesj_dV_si_s;
d_Qes_dV_di_d = d_Qesj_dV_di_d;
Qes = (Qesj+(csbox*ves_jct));

d_Qed_dV_di_si = d_Qedj_dV_di_si;
d_Qed_dV_g_si = d_Qedj_dV_g_si;
d_Qed_dV_g_e = d_Qedj_dV_g_e;
d_Qed_dV_e_di = (d_Qedj_dV_e_di+cdbox*d_ved_jct_dV_e_di);
d_Qed_dV_e_si = d_Qedj_dV_e_si;
d_Qed_dV_g_di = d_Qedj_dV_g_di;
d_Qed_dV_si_s = d_Qedj_dV_si_s;
d_Qed_dV_di_d = d_Qedj_dV_di_d;
Qed = (Qedj+(cdbox*ved_jct));

d_Qeg_dV_g_di = d_Qeg_dV_g_e = d_Qeg_dV_g_si = d_Qeg_dV_e_si = d_Qeg_dV_e_di = d_Qeg_dV_di_si =  0.0;
d_Qeg_dV_e_g = (cgbox*devsign)*d_probeVars[admsProbeID_V_e_g][admsProbeID_V_e_g];
Qeg = ((cgbox*devsign)*(probeVars[admsProbeID_V_e_g]));
if (((model_.BULKMOD)!=0))
{

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di = d_T2_dV_g_si = d_T2_dV_e_si = d_T2_dV_e_di = d_T2_dV_di_si =  0.0;
d_T2_dV_g_e = devsign*d_probeVars[admsProbeID_V_g_e][admsProbeID_V_g_e];
T2 = (devsign*(probeVars[admsProbeID_V_g_e]));

d_T3_dV_di_si = d_T2_dV_di_si;
d_T3_dV_e_di = d_T2_dV_e_di;
d_T3_dV_e_si = d_T2_dV_e_si;
d_T3_dV_g_si = d_T2_dV_g_si;
d_T3_dV_g_e = d_T2_dV_g_e;
d_T3_dV_g_di = d_T2_dV_g_di;
T3 = ((((T2-deltaPhi)+(Eg/2.0))+phib)-(model_.DELVFBACC));

d_T0_dV_di_si = d_T3_dV_di_si;
d_T0_dV_e_di = d_T3_dV_e_di;
d_T0_dV_e_si = d_T3_dV_e_si;
d_T0_dV_g_si = d_T3_dV_g_si;
d_T0_dV_g_e = d_T3_dV_g_e;
d_T0_dV_g_di = d_T3_dV_g_di;
T0 = (T3+0.02);
{
double value_sqrt_0 = sqrt(((T0*T0)+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vge_overlap_dV_di_si = 0.5*(d_T0_dV_di_si+(deriv_sqrt_0_d0*((T0*d_T0_dV_di_si+d_T0_dV_di_si*T0))));
d_vge_overlap_dV_g_si = 0.5*(d_T0_dV_g_si+(deriv_sqrt_0_d0*((T0*d_T0_dV_g_si+d_T0_dV_g_si*T0))));
d_vge_overlap_dV_g_e = 0.5*(d_T0_dV_g_e+(deriv_sqrt_0_d0*((T0*d_T0_dV_g_e+d_T0_dV_g_e*T0))));
d_vge_overlap_dV_e_di = 0.5*(d_T0_dV_e_di+(deriv_sqrt_0_d0*((T0*d_T0_dV_e_di+d_T0_dV_e_di*T0))));
d_vge_overlap_dV_e_si = 0.5*(d_T0_dV_e_si+(deriv_sqrt_0_d0*((T0*d_T0_dV_e_si+d_T0_dV_e_si*T0))));
d_vge_overlap_dV_g_di = 0.5*(d_T0_dV_g_di+(deriv_sqrt_0_d0*((T0*d_T0_dV_g_di+d_T0_dV_g_di*T0))));
vge_overlap = (0.5*(T0+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Qeg_dV_di_si = (d_Qeg_dV_di_si-(NFINtotal*LeffCV)*CGBL_i*((d_T3_dV_di_si-d_vge_overlap_dV_di_si)+(0.5*CKAPPAB_i)*(deriv_sqrt_0_d0*((4.0*d_vge_overlap_dV_di_si/CKAPPAB_i)))));
d_Qeg_dV_e_di = (d_Qeg_dV_e_di-(NFINtotal*LeffCV)*CGBL_i*((d_T3_dV_e_di-d_vge_overlap_dV_e_di)+(0.5*CKAPPAB_i)*(deriv_sqrt_0_d0*((4.0*d_vge_overlap_dV_e_di/CKAPPAB_i)))));
d_Qeg_dV_e_si = (d_Qeg_dV_e_si-(NFINtotal*LeffCV)*CGBL_i*((d_T3_dV_e_si-d_vge_overlap_dV_e_si)+(0.5*CKAPPAB_i)*(deriv_sqrt_0_d0*((4.0*d_vge_overlap_dV_e_si/CKAPPAB_i)))));
d_Qeg_dV_g_si = (d_Qeg_dV_g_si-(NFINtotal*LeffCV)*CGBL_i*((d_T3_dV_g_si-d_vge_overlap_dV_g_si)+(0.5*CKAPPAB_i)*(deriv_sqrt_0_d0*((4.0*d_vge_overlap_dV_g_si/CKAPPAB_i)))));
d_Qeg_dV_g_e = (d_Qeg_dV_g_e-(NFINtotal*LeffCV)*CGBL_i*((d_T3_dV_g_e-d_vge_overlap_dV_g_e)+(0.5*CKAPPAB_i)*(deriv_sqrt_0_d0*((4.0*d_vge_overlap_dV_g_e/CKAPPAB_i)))));
d_Qeg_dV_g_di = (d_Qeg_dV_g_di-(NFINtotal*LeffCV)*CGBL_i*((d_T3_dV_g_di-d_vge_overlap_dV_g_di)+(0.5*CKAPPAB_i)*(deriv_sqrt_0_d0*((4.0*d_vge_overlap_dV_g_di/CKAPPAB_i)))));
Qeg = (Qeg-((NFINtotal*LeffCV)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(value_sqrt_0-1.0))))));
}
}

d_T0_dV_g_di = d_T0_dV_e_si = d_T0_dV_e_di = d_T0_dV_g_e = d_T0_dV_g_si =  0.0;
d_T0_dV_di_si = d_vds_dV_di_si;
T0 = vds;

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (T0*((BIGEN_i*T0)*d_T0_dV_di_si+BIGEN_i*d_T0_dV_di_si*T0)+d_T0_dV_di_si*(AIGEN_i+((BIGEN_i*T0)*T0)));
d_T1_dV_g_si = (T0*((BIGEN_i*T0)*d_T0_dV_g_si+BIGEN_i*d_T0_dV_g_si*T0)+d_T0_dV_g_si*(AIGEN_i+((BIGEN_i*T0)*T0)));
d_T1_dV_g_e = (T0*((BIGEN_i*T0)*d_T0_dV_g_e+BIGEN_i*d_T0_dV_g_e*T0)+d_T0_dV_g_e*(AIGEN_i+((BIGEN_i*T0)*T0)));
d_T1_dV_e_di = (T0*((BIGEN_i*T0)*d_T0_dV_e_di+BIGEN_i*d_T0_dV_e_di*T0)+d_T0_dV_e_di*(AIGEN_i+((BIGEN_i*T0)*T0)));
d_T1_dV_e_si = (T0*((BIGEN_i*T0)*d_T0_dV_e_si+BIGEN_i*d_T0_dV_e_si*T0)+d_T0_dV_e_si*(AIGEN_i+((BIGEN_i*T0)*T0)));
d_T1_dV_g_di = (T0*((BIGEN_i*T0)*d_T0_dV_g_di+BIGEN_i*d_T0_dV_g_di*T0)+d_T0_dV_g_di*(AIGEN_i+((BIGEN_i*T0)*T0)));
T1 = (T0*(AIGEN_i+((BIGEN_i*T0)*T0)));

d_idsgen_dV_di_si = ((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*d_T1_dV_di_si;
d_idsgen_dV_g_si = ((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*d_T1_dV_g_si;
d_idsgen_dV_g_e = ((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*d_T1_dV_g_e;
d_idsgen_dV_e_di = ((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*d_T1_dV_e_di;
d_idsgen_dV_e_si = ((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*d_T1_dV_e_si;
d_idsgen_dV_g_di = ((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*d_T1_dV_g_di;
idsgen = (((((model_.HFIN)*TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1);
IdovVds = (((beta*ids0_ov_dqi)*Moc)/((Dmob*Dvsat)*Dr));

d_T0_dV_g_di =  0.0;
d_T0_dV_di_si = (((ueff*coxeff)*d_Weff_dV_di_si+(ueff*d_coxeff_dV_di_si+d_ueff_dV_di_si*coxeff)*Weff)/Leff);
d_T0_dV_e_di = (((ueff*coxeff)*d_Weff_dV_e_di+(ueff*d_coxeff_dV_e_di+d_ueff_dV_e_di*coxeff)*Weff)/Leff);
d_T0_dV_e_si = (((ueff*coxeff)*d_Weff_dV_e_si+(ueff*d_coxeff_dV_e_si+d_ueff_dV_e_si*coxeff)*Weff)/Leff);
d_T0_dV_g_si = (((ueff*coxeff)*d_Weff_dV_g_si+(ueff*d_coxeff_dV_g_si+d_ueff_dV_g_si*coxeff)*Weff)/Leff);
d_T0_dV_g_e = (((ueff*coxeff)*d_Weff_dV_g_e+(ueff*d_coxeff_dV_g_e+d_ueff_dV_g_e*coxeff)*Weff)/Leff);
T0 = (((ueff*coxeff)*Weff)/Leff);

d_igidl_dV_g_e = NFINtotal*d_igidl_dV_g_e;
d_igidl_dV_e_di = NFINtotal*d_igidl_dV_e_di;
d_igidl_dV_e_si = NFINtotal*d_igidl_dV_e_si;
d_igidl_dV_di_si = NFINtotal*d_igidl_dV_di_si;
d_igidl_dV_g_si = NFINtotal*d_igidl_dV_g_si;
d_igidl_dV_si_s = NFINtotal*d_igidl_dV_si_s;
d_igidl_dV_di_d = NFINtotal*d_igidl_dV_di_d;
d_igidl_dV_g_di = NFINtotal*d_igidl_dV_g_di;
igidl = (NFINtotal*igidl);

d_igisl_dV_g_e = NFINtotal*d_igisl_dV_g_e;
d_igisl_dV_e_di = NFINtotal*d_igisl_dV_e_di;
d_igisl_dV_e_si = NFINtotal*d_igisl_dV_e_si;
d_igisl_dV_di_si = NFINtotal*d_igisl_dV_di_si;
d_igisl_dV_g_si = NFINtotal*d_igisl_dV_g_si;
d_igisl_dV_si_s = NFINtotal*d_igisl_dV_si_s;
d_igisl_dV_di_d = NFINtotal*d_igisl_dV_di_d;
d_igisl_dV_g_di = NFINtotal*d_igisl_dV_g_di;
igisl = (NFINtotal*igisl);

d_igcd_dV_si_s = NFINtotal*d_igcd_dV_si_s;
d_igcd_dV_di_d = NFINtotal*d_igcd_dV_di_d;
d_igcd_dV_g_si = NFINtotal*d_igcd_dV_g_si;
d_igcd_dV_g_e = NFINtotal*d_igcd_dV_g_e;
d_igcd_dV_e_di = NFINtotal*d_igcd_dV_e_di;
d_igcd_dV_e_si = NFINtotal*d_igcd_dV_e_si;
d_igcd_dV_di_si = NFINtotal*d_igcd_dV_di_si;
d_igcd_dV_g_di = NFINtotal*d_igcd_dV_g_di;
igcd = (NFINtotal*igcd);

d_igcs_dV_si_s = NFINtotal*d_igcs_dV_si_s;
d_igcs_dV_di_d = NFINtotal*d_igcs_dV_di_d;
d_igcs_dV_g_si = NFINtotal*d_igcs_dV_g_si;
d_igcs_dV_g_e = NFINtotal*d_igcs_dV_g_e;
d_igcs_dV_e_di = NFINtotal*d_igcs_dV_e_di;
d_igcs_dV_e_si = NFINtotal*d_igcs_dV_e_si;
d_igcs_dV_di_si = NFINtotal*d_igcs_dV_di_si;
d_igcs_dV_g_di = NFINtotal*d_igcs_dV_g_di;
igcs = (NFINtotal*igcs);

d_igs_dV_di_si = NFINtotal*d_igs_dV_di_si;
d_igs_dV_e_di = NFINtotal*d_igs_dV_e_di;
d_igs_dV_e_si = NFINtotal*d_igs_dV_e_si;
d_igs_dV_g_e = NFINtotal*d_igs_dV_g_e;
d_igs_dV_g_di = NFINtotal*d_igs_dV_g_di;
d_igs_dV_g_si = NFINtotal*d_igs_dV_g_si;
igs = (NFINtotal*igs);

d_igd_dV_di_si = NFINtotal*d_igd_dV_di_si;
d_igd_dV_e_di = NFINtotal*d_igd_dV_e_di;
d_igd_dV_e_si = NFINtotal*d_igd_dV_e_si;
d_igd_dV_g_e = NFINtotal*d_igd_dV_g_e;
d_igd_dV_g_di = NFINtotal*d_igd_dV_g_di;
d_igd_dV_g_si = NFINtotal*d_igd_dV_g_si;
igd = (NFINtotal*igd);

d_igbinv_dV_si_s = NFINtotal*d_igbinv_dV_si_s;
d_igbinv_dV_di_d = NFINtotal*d_igbinv_dV_di_d;
d_igbinv_dV_g_di = NFINtotal*d_igbinv_dV_g_di;
d_igbinv_dV_g_e = NFINtotal*d_igbinv_dV_g_e;
d_igbinv_dV_e_di = NFINtotal*d_igbinv_dV_e_di;
d_igbinv_dV_e_si = NFINtotal*d_igbinv_dV_e_si;
d_igbinv_dV_di_si = NFINtotal*d_igbinv_dV_di_si;
d_igbinv_dV_g_si = NFINtotal*d_igbinv_dV_g_si;
igbinv = (NFINtotal*igbinv);

d_igbacc_dV_si_s = NFINtotal*d_igbacc_dV_si_s;
d_igbacc_dV_di_d = NFINtotal*d_igbacc_dV_di_d;
d_igbacc_dV_g_di = NFINtotal*d_igbacc_dV_g_di;
d_igbacc_dV_g_e = NFINtotal*d_igbacc_dV_g_e;
d_igbacc_dV_e_di = NFINtotal*d_igbacc_dV_e_di;
d_igbacc_dV_e_si = NFINtotal*d_igbacc_dV_e_si;
d_igbacc_dV_di_si = NFINtotal*d_igbacc_dV_di_si;
d_igbacc_dV_g_si = NFINtotal*d_igbacc_dV_g_si;
igbacc = (NFINtotal*igbacc);

d_idsgen_dV_di_si = NFINtotal*d_idsgen_dV_di_si;
d_idsgen_dV_g_si = NFINtotal*d_idsgen_dV_g_si;
d_idsgen_dV_g_e = NFINtotal*d_idsgen_dV_g_e;
d_idsgen_dV_e_di = NFINtotal*d_idsgen_dV_e_di;
d_idsgen_dV_e_si = NFINtotal*d_idsgen_dV_e_si;
d_idsgen_dV_g_di = NFINtotal*d_idsgen_dV_g_di;
idsgen = (NFINtotal*idsgen);

d_Iii_dV_di_si = NFINtotal*d_Iii_dV_di_si;
d_Iii_dV_g_si = NFINtotal*d_Iii_dV_g_si;
d_Iii_dV_g_e = NFINtotal*d_Iii_dV_g_e;
d_Iii_dV_e_di = NFINtotal*d_Iii_dV_e_di;
d_Iii_dV_e_si = NFINtotal*d_Iii_dV_e_si;
d_Iii_dV_g_di = NFINtotal*d_Iii_dV_g_di;
Iii = (NFINtotal*Iii);

d_igbs_dV_g_si = d_igbs_dV_di_si = d_igbs_dV_e_si = d_igbs_dV_e_di = d_igbs_dV_g_e = d_igbs_dV_g_di = d_igbs_dV_di_d = d_igbs_dV_si_s =  0.0;
igbs = 0.0;

d_igbd_dV_g_si = d_igbd_dV_di_si = d_igbd_dV_e_si = d_igbd_dV_e_di = d_igbd_dV_g_e = d_igbd_dV_g_di = d_igbd_dV_di_d = d_igbd_dV_si_s =  0.0;
igbd = 0.0;
if (((model_.BULKMOD)==0))
{

d_igbs_dV_si_s = (d_igbinv_dV_si_s+d_igbacc_dV_si_s)*wf;
d_igbs_dV_di_d = (d_igbinv_dV_di_d+d_igbacc_dV_di_d)*wf;
d_igbs_dV_g_di = (d_igbinv_dV_g_di+d_igbacc_dV_g_di)*wf;
d_igbs_dV_g_e = (d_igbinv_dV_g_e+d_igbacc_dV_g_e)*wf;
d_igbs_dV_e_di = (d_igbinv_dV_e_di+d_igbacc_dV_e_di)*wf;
d_igbs_dV_e_si = (d_igbinv_dV_e_si+d_igbacc_dV_e_si)*wf;
d_igbs_dV_di_si = ((igbinv+igbacc)*d_wf_dV_di_si+(d_igbinv_dV_di_si+d_igbacc_dV_di_si)*wf);
d_igbs_dV_g_si = (d_igbinv_dV_g_si+d_igbacc_dV_g_si)*wf;
igbs = ((igbinv+igbacc)*wf);

d_igbd_dV_si_s = (d_igbinv_dV_si_s+d_igbacc_dV_si_s)*wr;
d_igbd_dV_di_d = (d_igbinv_dV_di_d+d_igbacc_dV_di_d)*wr;
d_igbd_dV_g_di = (d_igbinv_dV_g_di+d_igbacc_dV_g_di)*wr;
d_igbd_dV_g_e = (d_igbinv_dV_g_e+d_igbacc_dV_g_e)*wr;
d_igbd_dV_e_di = (d_igbinv_dV_e_di+d_igbacc_dV_e_di)*wr;
d_igbd_dV_e_si = (d_igbinv_dV_e_si+d_igbacc_dV_e_si)*wr;
d_igbd_dV_di_si = ((igbinv+igbacc)*d_wr_dV_di_si+(d_igbinv_dV_di_si+d_igbacc_dV_di_si)*wr);
d_igbd_dV_g_si = (d_igbinv_dV_g_si+d_igbacc_dV_g_si)*wr;
igbd = ((igbinv+igbacc)*wr);
}
Esatnoi = ((2.0*VSAT_t)/ueff);
if (((((model_.NOIA)>0)||((model_.NOIB)>0))||((model_.NOIC)>0)))
{
Leffnoi = (Leff-(2.0*LINTNOI_i));
Leffnoisq = (Leffnoi*Leffnoi);
if (((model_.EM)<=0.0))
{
DelClm = 0.0;
}
else
{

d_T0_dV_g_di =  0.0;
d_T0_dV_g_si = ((d_diffVds_dV_g_si/litl)/Esatnoi);
d_T0_dV_g_e = ((d_diffVds_dV_g_e/litl)/Esatnoi);
d_T0_dV_e_di = ((d_diffVds_dV_e_di/litl)/Esatnoi);
d_T0_dV_e_si = ((d_diffVds_dV_e_si/litl)/Esatnoi);
d_T0_dV_di_si = ((d_diffVds_dV_di_si/litl)/Esatnoi);
T0 = (((diffVds/litl)+(model_.EM))/Esatnoi);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(T0);
DelClm = (litl*evaluator_lln_0.getValues(T0));
}
if ((DelClm<0.0))
{
DelClm = 0.0;
}
}
{
double value_fabs_0 = fabs(ids);
double  deriv_fabs_0_d0 = (((ids)>=0)?(+1.0):(-1.0));

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_g_di = (((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(deriv_fabs_0_d0*(d_ids_dV_g_di))*ueff;
d_T1_dV_di_si = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*d_ueff_dV_di_si+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(deriv_fabs_0_d0*(d_ids_dV_di_si))*ueff);
d_T1_dV_g_si = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*d_ueff_dV_g_si+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(deriv_fabs_0_d0*(d_ids_dV_g_si))*ueff);
d_T1_dV_g_e = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*d_ueff_dV_g_e+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(deriv_fabs_0_d0*(d_ids_dV_g_e))*ueff);
d_T1_dV_e_di = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*d_ueff_dV_e_di+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(deriv_fabs_0_d0*(d_ids_dV_e_di))*ueff);
d_T1_dV_e_si = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*d_ueff_dV_e_si+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(deriv_fabs_0_d0*(d_ids_dV_e_si))*ueff);
T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*ueff);
}

d_T2_dV_di_d = d_T2_dV_si_s = d_T2_dV_g_di =  0.0;
d_T2_dV_di_si = 1.0e10*d_coxeff_dV_di_si*Leffnoisq;
d_T2_dV_g_si = 1.0e10*d_coxeff_dV_g_si*Leffnoisq;
d_T2_dV_g_e = 1.0e10*d_coxeff_dV_g_e*Leffnoisq;
d_T2_dV_e_di = 1.0e10*d_coxeff_dV_e_di*Leffnoisq;
d_T2_dV_e_si = 1.0e10*d_coxeff_dV_e_si*Leffnoisq;
T2 = ((1.0e10*coxeff)*Leffnoisq);
N0 = ((coxeff*qis)/1.60219e-19);
Nl = ((coxeff*qid)/1.60219e-19);
Nstar = ((Vtm/1.60219e-19)*(coxeff+CIT_i));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((N0+Nstar)/(Nl+Nstar)));

d_T3_dV_g_di =  0.0;
d_T3_dV_di_si = 0.0;
d_T3_dV_g_si = 0.0;
d_T3_dV_g_e = 0.0;
d_T3_dV_e_di = 0.0;
d_T3_dV_e_si = 0.0;
T3 = ((model_.NOIA)*evaluator_lln_0.getValues(((N0+Nstar)/(Nl+Nstar))));
}

d_T4_dV_g_di =  0.0;
d_T4_dV_di_si = 0.0;
d_T4_dV_g_si = 0.0;
d_T4_dV_g_e = 0.0;
d_T4_dV_e_di = 0.0;
d_T4_dV_e_si = 0.0;
T4 = ((model_.NOIB)*(N0-Nl));

d_T5_dV_g_di = d_T5_dV_di_d = d_T5_dV_si_s =  0.0;
d_T5_dV_di_si = 0.0;
d_T5_dV_g_si = 0.0;
d_T5_dV_g_e = 0.0;
d_T5_dV_e_di = 0.0;
d_T5_dV_e_si = 0.0;
T5 = ((0.5*(model_.NOIC))*((N0*N0)-(Nl*Nl)));

d_T6_dV_di_d = d_T6_dV_si_s =  0.0;
d_T6_dV_g_di = (((1.60219e-19*Vtm)*ids)*d_ids_dV_g_di+(1.60219e-19*Vtm)*d_ids_dV_g_di*ids);
d_T6_dV_di_si = (((1.60219e-19*Vtm)*ids)*d_ids_dV_di_si+(1.60219e-19*Vtm)*d_ids_dV_di_si*ids);
d_T6_dV_g_si = (((1.60219e-19*Vtm)*ids)*d_ids_dV_g_si+(1.60219e-19*Vtm)*d_ids_dV_g_si*ids);
d_T6_dV_g_e = (((1.60219e-19*Vtm)*ids)*d_ids_dV_g_e+(1.60219e-19*Vtm)*d_ids_dV_g_e*ids);
d_T6_dV_e_di = (((1.60219e-19*Vtm)*ids)*d_ids_dV_e_di+(1.60219e-19*Vtm)*d_ids_dV_e_di*ids);
d_T6_dV_e_si = (((1.60219e-19*Vtm)*ids)*d_ids_dV_e_si+(1.60219e-19*Vtm)*d_ids_dV_e_si*ids);
T6 = (((1.60219e-19*Vtm)*ids)*ids);

d_T7_dV_di_si = (1.0e10*Leffnoisq)*d_Weff_dV_di_si*NFINtotal;
d_T7_dV_g_si = (1.0e10*Leffnoisq)*d_Weff_dV_g_si*NFINtotal;
d_T7_dV_g_e = (1.0e10*Leffnoisq)*d_Weff_dV_g_e*NFINtotal;
d_T7_dV_e_di = (1.0e10*Leffnoisq)*d_Weff_dV_e_di*NFINtotal;
d_T7_dV_e_si = (1.0e10*Leffnoisq)*d_Weff_dV_e_si*NFINtotal;
T7 = (((1.0e10*Leffnoisq)*Weff)*NFINtotal);

d_T8_dV_di_si = 0.0;
d_T8_dV_g_si = 0.0;
d_T8_dV_g_e = 0.0;
d_T8_dV_e_di = 0.0;
d_T8_dV_e_si = 0.0;
T8 = (((model_.NOIA)+((model_.NOIB)*Nl))+(((model_.NOIC)*Nl)*Nl));

d_T9_dV_di_si = 0.0;
d_T9_dV_g_si = 0.0;
d_T9_dV_g_e = 0.0;
d_T9_dV_e_di = 0.0;
d_T9_dV_e_si = 0.0;
T9 = ((Nl+Nstar)*(Nl+Nstar));
Ssi = (((T1/T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
T10 = (((model_.NOIA)*1.60219e-19)*Vtm);
T11 = (((((Weff*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar);
Swi = (((T10/T11)*ids)*ids);

d_T1_dV_si_s = 0.0;
d_T1_dV_di_d = 0.0;
d_T1_dV_g_di = 0.0;
d_T1_dV_di_si = 0.0;
d_T1_dV_g_si = 0.0;
d_T1_dV_g_e = 0.0;
d_T1_dV_e_di = 0.0;
d_T1_dV_e_si = 0.0;
T1 = (Swi+Ssi);
if ((T1>0.0))
{
FNPowerAt1Hz = ((Ssi*Swi)/T1);
}
else
{
FNPowerAt1Hz = 0.0;
}
}
else
{
FNPowerAt1Hz = 0.0;
}

d_T0_dV_g_di = ueff*d_qinv_dV_g_di;
d_T0_dV_di_si = (ueff*d_qinv_dV_di_si+d_ueff_dV_di_si*qinv);
d_T0_dV_e_di = (ueff*d_qinv_dV_e_di+d_ueff_dV_e_di*qinv);
d_T0_dV_e_si = (ueff*d_qinv_dV_e_si+d_ueff_dV_e_si*qinv);
d_T0_dV_g_si = (ueff*d_qinv_dV_g_si+d_ueff_dV_g_si*qinv);
d_T0_dV_g_e = (ueff*d_qinv_dV_g_e+d_ueff_dV_g_e*qinv);
T0 = (ueff*qinv);

d_T1_dV_di_d = d_T1_dV_si_s =  0.0;
d_T1_dV_di_si = (T0*d_Rdsi_dV_di_si+d_T0_dV_di_si*Rdsi);
d_T1_dV_g_si = (T0*d_Rdsi_dV_g_si+d_T0_dV_g_si*Rdsi);
d_T1_dV_g_e = (T0*d_Rdsi_dV_g_e+d_T0_dV_g_e*Rdsi);
d_T1_dV_e_di = (T0*d_Rdsi_dV_e_di+d_T0_dV_e_di*Rdsi);
d_T1_dV_e_si = (T0*d_Rdsi_dV_e_si+d_T0_dV_e_si*Rdsi);
d_T1_dV_g_di = (T0*d_Rdsi_dV_g_di+d_T0_dV_g_di*Rdsi);
T1 = ((T0*Rdsi)+(Leff*Leff));
Gtnoi = ((T0/T1)*NTNOI_i);
sid = (((4*Vtm)*1.60219e-19)*Gtnoi);
gspr = (1/Rsource);
gdpr = (1/Rdrain);
}
if ((!initialized))
{
devsign = 0.0;

d_Rsource_dV_di_d = d_Rsource_dV_g_di = d_Rsource_dV_si_s = d_Rsource_dV_e_si = d_Rsource_dV_e_di = d_Rsource_dV_g_e = d_Rsource_dV_g_si = d_Rsource_dV_di_si =  0.0;
Rsource = 1.0;

d_Rdrain_dV_di_d = d_Rdrain_dV_si_s = d_Rdrain_dV_e_si = d_Rdrain_dV_e_di = d_Rdrain_dV_g_e = d_Rdrain_dV_g_si = d_Rdrain_dV_di_si = d_Rdrain_dV_g_di =  0.0;
Rdrain = 1.0;
UserInfo(*this)  << "uninitialized" << " " <<  std::endl; 
}
if ((sigvds>0.0))
{
// I(di,si) <+ ((devsign*ids))
staticContributions[admsNodeID_di] += (devsign*ids);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] += devsign*d_ids_dV_g_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += devsign*d_ids_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] += devsign*d_ids_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] += devsign*d_ids_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] += devsign*d_ids_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] += devsign*d_ids_dV_e_si;
staticContributions[admsNodeID_si] -= (devsign*ids);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*d_ids_dV_g_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*d_ids_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*d_ids_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*d_ids_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*d_ids_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*d_ids_dV_e_si;
}
else
{
// I(si,di) <+ ((devsign*ids))
staticContributions[admsNodeID_si] += (devsign*ids);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] += devsign*d_ids_dV_g_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] += devsign*d_ids_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] += devsign*d_ids_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] += devsign*d_ids_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] += devsign*d_ids_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] += devsign*d_ids_dV_e_si;
staticContributions[admsNodeID_di] -= (devsign*ids);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*d_ids_dV_g_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*d_ids_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*d_ids_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*d_ids_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*d_ids_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*d_ids_dV_e_si;
}
// I(di,si) <+ ((devsign*ddt(qd)))
dynamicContributions[admsNodeID_di] += (devsign*(qd));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di] += devsign*(d_qd_dV_g_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si] += devsign*(d_qd_dV_g_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e] += devsign*(d_qd_dV_g_e);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] += devsign*(d_qd_dV_e_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] += devsign*(d_qd_dV_e_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] += devsign*(d_qd_dV_di_si);
dynamicContributions[admsNodeID_si] -= (devsign*(qd));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_qd_dV_g_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_qd_dV_g_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_qd_dV_g_e);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_qd_dV_e_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_qd_dV_e_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_qd_dV_di_si);
// I(g,si) <+ ((devsign*ddt(qg)))
dynamicContributions[admsNodeID_g] += (devsign*(qg));
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_qg_dV_g_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_qg_dV_g_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_qg_dV_g_e);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_qg_dV_e_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_qg_dV_e_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_qg_dV_di_si);
dynamicContributions[admsNodeID_si] -= (devsign*(qg));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_qg_dV_g_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_qg_dV_g_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_qg_dV_g_e);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_qg_dV_e_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_qg_dV_e_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_qg_dV_di_si);
if ((sigvds>0))
{
// I(di,si) <+ ((devsign*idsgen))
staticContributions[admsNodeID_di] += (devsign*idsgen);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += devsign*d_idsgen_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] += devsign*d_idsgen_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] += devsign*d_idsgen_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] += devsign*d_idsgen_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] += devsign*d_idsgen_dV_e_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] += devsign*d_idsgen_dV_g_di;
staticContributions[admsNodeID_si] -= (devsign*idsgen);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*d_idsgen_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*d_idsgen_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*d_idsgen_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*d_idsgen_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*d_idsgen_dV_e_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*d_idsgen_dV_g_di;
// I(g,si) <+ ((devsign*(igcs+igs)))
staticContributions[admsNodeID_g] += (devsign*(igcs+igs));
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*d_igcs_dV_si_s;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*d_igcs_dV_di_d;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_igcs_dV_g_si+d_igs_dV_g_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_igcs_dV_g_e+d_igs_dV_g_e);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_igcs_dV_e_di+d_igs_dV_e_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_igcs_dV_e_si+d_igs_dV_e_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_igcs_dV_di_si+d_igs_dV_di_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_igcs_dV_g_di+d_igs_dV_g_di);
staticContributions[admsNodeID_si] -= (devsign*(igcs+igs));
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -= devsign*d_igcs_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -= devsign*d_igcs_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_igcs_dV_g_si+d_igs_dV_g_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_igcs_dV_g_e+d_igs_dV_g_e);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_igcs_dV_e_di+d_igs_dV_e_di);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_igcs_dV_e_si+d_igs_dV_e_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_igcs_dV_di_si+d_igs_dV_di_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_igcs_dV_g_di+d_igs_dV_g_di);
// I(g,di) <+ ((devsign*(igcd+igd)))
staticContributions[admsNodeID_g] += (devsign*(igcd+igd));
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*d_igcd_dV_si_s;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*d_igcd_dV_di_d;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_igcd_dV_g_si+d_igd_dV_g_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_igcd_dV_g_e+d_igd_dV_g_e);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_igcd_dV_e_di+d_igd_dV_e_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_igcd_dV_e_si+d_igd_dV_e_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_igcd_dV_di_si+d_igd_dV_di_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_igcd_dV_g_di+d_igd_dV_g_di);
staticContributions[admsNodeID_di] -= (devsign*(igcd+igd));
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -= devsign*d_igcd_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -= devsign*d_igcd_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*(d_igcd_dV_g_si+d_igd_dV_g_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*(d_igcd_dV_g_e+d_igd_dV_g_e);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*(d_igcd_dV_e_di+d_igd_dV_e_di);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*(d_igcd_dV_e_si+d_igd_dV_e_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*(d_igcd_dV_di_si+d_igd_dV_di_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*(d_igcd_dV_g_di+d_igd_dV_g_di);
if (((model_.BULKMOD)!=0))
{
// I(di,e) <+ ((devsign*(igidl+Iii)))
staticContributions[admsNodeID_di] += (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] += devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] += devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] += devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] += devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] += devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] += devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] += devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
staticContributions[admsNodeID_e] -= (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] -= devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -= devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] -= devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -= devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -= devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -= devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] -= devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] -= devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
// I(si,e) <+ ((devsign*igisl))
staticContributions[admsNodeID_si] += (devsign*igisl);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] += devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] += devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] += devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] += devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] += devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] += devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] += devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] += devsign*d_igisl_dV_g_di;
staticContributions[admsNodeID_e] -= (devsign*igisl);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] -= devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -= devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] -= devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -= devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -= devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -= devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] -= devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] -= devsign*d_igisl_dV_g_di;
// I(g,e) <+ ((devsign*(igbinv+igbacc)))
staticContributions[admsNodeID_g] += (devsign*(igbinv+igbacc));
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*(d_igbinv_dV_si_s+d_igbacc_dV_si_s);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*(d_igbinv_dV_di_d+d_igbacc_dV_di_d);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_igbinv_dV_g_di+d_igbacc_dV_g_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_igbinv_dV_g_e+d_igbacc_dV_g_e);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_igbinv_dV_e_di+d_igbacc_dV_e_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_igbinv_dV_e_si+d_igbacc_dV_e_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_igbinv_dV_di_si+d_igbacc_dV_di_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_igbinv_dV_g_si+d_igbacc_dV_g_si);
staticContributions[admsNodeID_e] -= (devsign*(igbinv+igbacc));
d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -= devsign*(d_igbinv_dV_si_s+d_igbacc_dV_si_s);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] -= devsign*(d_igbinv_dV_di_d+d_igbacc_dV_di_d);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] -= devsign*(d_igbinv_dV_g_di+d_igbacc_dV_g_di);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] -= devsign*(d_igbinv_dV_g_e+d_igbacc_dV_g_e);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -= devsign*(d_igbinv_dV_e_di+d_igbacc_dV_e_di);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] -= devsign*(d_igbinv_dV_e_si+d_igbacc_dV_e_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -= devsign*(d_igbinv_dV_di_si+d_igbacc_dV_di_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -= devsign*(d_igbinv_dV_g_si+d_igbacc_dV_g_si);
}
else
{
// I(di,si) <+ ((devsign*(igidl+Iii)))
staticContributions[admsNodeID_di] += (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] += devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] += devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] += devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] += devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] += devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] += devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] += devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
staticContributions[admsNodeID_si] -= (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -= devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -= devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
// I(si,di) <+ ((devsign*igisl))
staticContributions[admsNodeID_si] += (devsign*igisl);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] += devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] += devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] += devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] += devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] += devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] += devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] += devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] += devsign*d_igisl_dV_g_di;
staticContributions[admsNodeID_di] -= (devsign*igisl);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -= devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -= devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*d_igisl_dV_g_di;
}
}
else
{
// I(si,di) <+ ((devsign*idsgen))
staticContributions[admsNodeID_si] += (devsign*idsgen);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] += devsign*d_idsgen_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] += devsign*d_idsgen_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] += devsign*d_idsgen_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] += devsign*d_idsgen_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] += devsign*d_idsgen_dV_e_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] += devsign*d_idsgen_dV_g_di;
staticContributions[admsNodeID_di] -= (devsign*idsgen);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*d_idsgen_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*d_idsgen_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*d_idsgen_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*d_idsgen_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*d_idsgen_dV_e_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*d_idsgen_dV_g_di;
// I(g,di) <+ ((devsign*(igcs+igs)))
staticContributions[admsNodeID_g] += (devsign*(igcs+igs));
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*d_igcs_dV_si_s;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*d_igcs_dV_di_d;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_igcs_dV_g_si+d_igs_dV_g_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_igcs_dV_g_e+d_igs_dV_g_e);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_igcs_dV_e_di+d_igs_dV_e_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_igcs_dV_e_si+d_igs_dV_e_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_igcs_dV_di_si+d_igs_dV_di_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_igcs_dV_g_di+d_igs_dV_g_di);
staticContributions[admsNodeID_di] -= (devsign*(igcs+igs));
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -= devsign*d_igcs_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -= devsign*d_igcs_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*(d_igcs_dV_g_si+d_igs_dV_g_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*(d_igcs_dV_g_e+d_igs_dV_g_e);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*(d_igcs_dV_e_di+d_igs_dV_e_di);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*(d_igcs_dV_e_si+d_igs_dV_e_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*(d_igcs_dV_di_si+d_igs_dV_di_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*(d_igcs_dV_g_di+d_igs_dV_g_di);
// I(g,si) <+ ((devsign*(igcd+igd)))
staticContributions[admsNodeID_g] += (devsign*(igcd+igd));
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*d_igcd_dV_si_s;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*d_igcd_dV_di_d;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_igcd_dV_g_si+d_igd_dV_g_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_igcd_dV_g_e+d_igd_dV_g_e);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_igcd_dV_e_di+d_igd_dV_e_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_igcd_dV_e_si+d_igd_dV_e_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_igcd_dV_di_si+d_igd_dV_di_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_igcd_dV_g_di+d_igd_dV_g_di);
staticContributions[admsNodeID_si] -= (devsign*(igcd+igd));
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -= devsign*d_igcd_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -= devsign*d_igcd_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_igcd_dV_g_si+d_igd_dV_g_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_igcd_dV_g_e+d_igd_dV_g_e);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_igcd_dV_e_di+d_igd_dV_e_di);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_igcd_dV_e_si+d_igd_dV_e_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_igcd_dV_di_si+d_igd_dV_di_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_igcd_dV_g_di+d_igd_dV_g_di);
if (((model_.BULKMOD)!=0))
{
// I(si,e) <+ ((devsign*(igidl+Iii)))
staticContributions[admsNodeID_si] += (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] += devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] += devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] += devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] += devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] += devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] += devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] += devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] += devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
staticContributions[admsNodeID_e] -= (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] -= devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -= devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] -= devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -= devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -= devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -= devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] -= devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] -= devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
// I(di,e) <+ ((devsign*igisl))
staticContributions[admsNodeID_di] += (devsign*igisl);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] += devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] += devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] += devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] += devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] += devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] += devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] += devsign*d_igisl_dV_g_di;
staticContributions[admsNodeID_e] -= (devsign*igisl);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] -= devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -= devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] -= devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -= devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -= devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -= devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] -= devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] -= devsign*d_igisl_dV_g_di;
// I(g,e) <+ ((devsign*(igbinv+igbacc)))
staticContributions[admsNodeID_g] += (devsign*(igbinv+igbacc));
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*(d_igbinv_dV_si_s+d_igbacc_dV_si_s);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*(d_igbinv_dV_di_d+d_igbacc_dV_di_d);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_igbinv_dV_g_di+d_igbacc_dV_g_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_igbinv_dV_g_e+d_igbacc_dV_g_e);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_igbinv_dV_e_di+d_igbacc_dV_e_di);
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_igbinv_dV_e_si+d_igbacc_dV_e_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_igbinv_dV_di_si+d_igbacc_dV_di_si);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_igbinv_dV_g_si+d_igbacc_dV_g_si);
staticContributions[admsNodeID_e] -= (devsign*(igbinv+igbacc));
d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -= devsign*(d_igbinv_dV_si_s+d_igbacc_dV_si_s);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] -= devsign*(d_igbinv_dV_di_d+d_igbacc_dV_di_d);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] -= devsign*(d_igbinv_dV_g_di+d_igbacc_dV_g_di);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] -= devsign*(d_igbinv_dV_g_e+d_igbacc_dV_g_e);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -= devsign*(d_igbinv_dV_e_di+d_igbacc_dV_e_di);
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] -= devsign*(d_igbinv_dV_e_si+d_igbacc_dV_e_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -= devsign*(d_igbinv_dV_di_si+d_igbacc_dV_di_si);
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -= devsign*(d_igbinv_dV_g_si+d_igbacc_dV_g_si);
}
else
{
// I(si,di) <+ ((devsign*(igidl+Iii)))
staticContributions[admsNodeID_si] += (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] += devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] += devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] += devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] += devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] += devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] += devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] += devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] += devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
staticContributions[admsNodeID_di] -= (devsign*(igidl+Iii));
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*(d_igidl_dV_g_e+d_Iii_dV_g_e);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*(d_igidl_dV_e_di+d_Iii_dV_e_di);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*(d_igidl_dV_e_si+d_Iii_dV_e_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*(d_igidl_dV_di_si+d_Iii_dV_di_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*(d_igidl_dV_g_si+d_Iii_dV_g_si);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -= devsign*d_igidl_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -= devsign*d_igidl_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*(d_igidl_dV_g_di+d_Iii_dV_g_di);
// I(di,si) <+ ((devsign*igisl))
staticContributions[admsNodeID_di] += (devsign*igisl);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] += devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] += devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] += devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] += devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] += devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] += devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] += devsign*d_igisl_dV_g_di;
staticContributions[admsNodeID_si] -= (devsign*igisl);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*d_igisl_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*d_igisl_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*d_igisl_dV_e_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*d_igisl_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*d_igisl_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -= devsign*d_igisl_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -= devsign*d_igisl_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*d_igisl_dV_g_di;
}
}
if (((model_.BULKMOD)==0))
{
// I(g,si) <+ ((devsign*igbs))
staticContributions[admsNodeID_g] += (devsign*igbs);
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*d_igbs_dV_si_s;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*d_igbs_dV_di_d;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*d_igbs_dV_g_di;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*d_igbs_dV_g_e;
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*d_igbs_dV_e_di;
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*d_igbs_dV_e_si;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*d_igbs_dV_di_si;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*d_igbs_dV_g_si;
staticContributions[admsNodeID_si] -= (devsign*igbs);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -= devsign*d_igbs_dV_si_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -= devsign*d_igbs_dV_di_d;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*d_igbs_dV_g_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*d_igbs_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*d_igbs_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*d_igbs_dV_e_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*d_igbs_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*d_igbs_dV_g_si;
// I(g,di) <+ ((devsign*igbd))
staticContributions[admsNodeID_g] += (devsign*igbd);
d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] += devsign*d_igbd_dV_si_s;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] += devsign*d_igbd_dV_di_d;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*d_igbd_dV_g_di;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*d_igbd_dV_g_e;
d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*d_igbd_dV_e_di;
d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*d_igbd_dV_e_si;
d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*d_igbd_dV_di_si;
d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*d_igbd_dV_g_si;
staticContributions[admsNodeID_di] -= (devsign*igbd);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -= devsign*d_igbd_dV_si_s;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -= devsign*d_igbd_dV_di_d;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*d_igbd_dV_g_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*d_igbd_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*d_igbd_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*d_igbd_dV_e_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*d_igbd_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*d_igbd_dV_g_si;
}
if (((model_.BULKMOD)!=0))
{
// I(e,si) <+ ((devsign*Ies))
staticContributions[admsNodeID_e] += (devsign*Ies);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] += devsign*d_Ies_dV_di_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] += devsign*d_Ies_dV_g_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] += devsign*d_Ies_dV_g_e;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] += devsign*d_Ies_dV_e_di;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] += devsign*d_Ies_dV_e_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] += devsign*d_Ies_dV_g_di;
staticContributions[admsNodeID_si] -= (devsign*Ies);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*d_Ies_dV_di_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*d_Ies_dV_g_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*d_Ies_dV_g_e;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*d_Ies_dV_e_di;
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*d_Ies_dV_e_si;
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*d_Ies_dV_g_di;
// I(e,di) <+ ((devsign*Ied))
staticContributions[admsNodeID_e] += (devsign*Ied);
d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] += devsign*d_Ied_dV_di_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] += devsign*d_Ied_dV_g_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] += devsign*d_Ied_dV_g_e;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] += devsign*d_Ied_dV_e_di;
d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] += devsign*d_Ied_dV_e_si;
d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] += devsign*d_Ied_dV_g_di;
staticContributions[admsNodeID_di] -= (devsign*Ied);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*d_Ied_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*d_Ied_dV_g_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*d_Ied_dV_g_e;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*d_Ied_dV_e_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*d_Ied_dV_e_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*d_Ied_dV_g_di;
}
// I(e,si) <+ ((devsign*ddt(Qes)))
dynamicContributions[admsNodeID_e] += (devsign*(Qes));
d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si] += devsign*(d_Qes_dV_di_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si] += devsign*(d_Qes_dV_g_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e] += devsign*(d_Qes_dV_g_e);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] += devsign*(d_Qes_dV_e_di);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] += devsign*(d_Qes_dV_e_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] += devsign*(d_Qes_dV_g_di);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s] += devsign*(d_Qes_dV_si_s);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_d] += devsign*(d_Qes_dV_di_d);
dynamicContributions[admsNodeID_si] -= (devsign*(Qes));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_Qes_dV_di_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_Qes_dV_g_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_Qes_dV_g_e);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_Qes_dV_e_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_Qes_dV_e_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_Qes_dV_g_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] -= devsign*(d_Qes_dV_si_s);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_d] -= devsign*(d_Qes_dV_di_d);
// I(e,di) <+ ((devsign*ddt(Qed)))
dynamicContributions[admsNodeID_e] += (devsign*(Qed));
d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si] += devsign*(d_Qed_dV_di_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si] += devsign*(d_Qed_dV_g_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e] += devsign*(d_Qed_dV_g_e);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] += devsign*(d_Qed_dV_e_di);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] += devsign*(d_Qed_dV_e_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] += devsign*(d_Qed_dV_g_di);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s] += devsign*(d_Qed_dV_si_s);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_d] += devsign*(d_Qed_dV_di_d);
dynamicContributions[admsNodeID_di] -= (devsign*(Qed));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -= devsign*(d_Qed_dV_di_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si] -= devsign*(d_Qed_dV_g_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e] -= devsign*(d_Qed_dV_g_e);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] -= devsign*(d_Qed_dV_e_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] -= devsign*(d_Qed_dV_e_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di] -= devsign*(d_Qed_dV_g_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_s] -= devsign*(d_Qed_dV_si_s);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_d] -= devsign*(d_Qed_dV_di_d);
// I(e,g) <+ ((devsign*ddt(Qeg)))
dynamicContributions[admsNodeID_e] += (devsign*(Qeg));
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_g] += devsign*(d_Qeg_dV_e_g);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si] += devsign*(d_Qeg_dV_di_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] += devsign*(d_Qeg_dV_e_di);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] += devsign*(d_Qeg_dV_e_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si] += devsign*(d_Qeg_dV_g_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e] += devsign*(d_Qeg_dV_g_e);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] += devsign*(d_Qeg_dV_g_di);
dynamicContributions[admsNodeID_g] -= (devsign*(Qeg));
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_g] -= devsign*(d_Qeg_dV_e_g);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] -= devsign*(d_Qeg_dV_di_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] -= devsign*(d_Qeg_dV_e_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] -= devsign*(d_Qeg_dV_e_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] -= devsign*(d_Qeg_dV_g_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] -= devsign*(d_Qeg_dV_g_e);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] -= devsign*(d_Qeg_dV_g_di);
// I(g,si) <+ (ddt(qgs_parasitic))
dynamicContributions[admsNodeID_g] += (qgs_parasitic);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] += (d_qgs_parasitic_dV_di_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] += (d_qgs_parasitic_dV_g_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] += (d_qgs_parasitic_dV_g_e);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] += (d_qgs_parasitic_dV_e_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] += (d_qgs_parasitic_dV_e_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] += (d_qgs_parasitic_dV_g_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_s] += (d_qgs_parasitic_dV_g_s);
dynamicContributions[admsNodeID_si] -= (qgs_parasitic);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -= (d_qgs_parasitic_dV_di_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] -= (d_qgs_parasitic_dV_g_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] -= (d_qgs_parasitic_dV_g_e);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -= (d_qgs_parasitic_dV_e_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -= (d_qgs_parasitic_dV_e_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di] -= (d_qgs_parasitic_dV_g_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_s] -= (d_qgs_parasitic_dV_g_s);
// I(g,di) <+ (ddt(qgd_parasitic))
dynamicContributions[admsNodeID_g] += (qgd_parasitic);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] += (d_qgd_parasitic_dV_di_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] += (d_qgd_parasitic_dV_g_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] += (d_qgd_parasitic_dV_g_e);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] += (d_qgd_parasitic_dV_e_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] += (d_qgd_parasitic_dV_e_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] += (d_qgd_parasitic_dV_g_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_d] += (d_qgd_parasitic_dV_g_d);
dynamicContributions[admsNodeID_di] -= (qgd_parasitic);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -= (d_qgd_parasitic_dV_di_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si] -= (d_qgd_parasitic_dV_g_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e] -= (d_qgd_parasitic_dV_g_e);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] -= (d_qgd_parasitic_dV_e_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] -= (d_qgd_parasitic_dV_e_si);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di] -= (d_qgd_parasitic_dV_g_di);
d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_d] -= (d_qgd_parasitic_dV_g_d);
// I(d,s) <+ (ddt(qds_fr))
dynamicContributions[admsNodeID_d] += (qds_fr);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s] += (d_qds_fr_dV_d_s);
dynamicContributions[admsNodeID_s] -= (qds_fr);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s] -= (d_qds_fr_dV_d_s);
if (((model_.CGEOMOD)==1))
{
// I(g,s) <+ (ddt(qgs_fr))
dynamicContributions[admsNodeID_g] += (qgs_fr);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] += (d_qgs_fr_dV_di_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] += (d_qgs_fr_dV_g_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] += (d_qgs_fr_dV_g_e);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] += (d_qgs_fr_dV_e_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] += (d_qgs_fr_dV_e_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] += (d_qgs_fr_dV_g_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_s] += (d_qgs_fr_dV_g_s);
dynamicContributions[admsNodeID_s] -= (qgs_fr);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si] -= (d_qgs_fr_dV_di_si);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_si] -= (d_qgs_fr_dV_g_si);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_e] -= (d_qgs_fr_dV_g_e);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_di] -= (d_qgs_fr_dV_e_di);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_si] -= (d_qgs_fr_dV_e_si);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_di] -= (d_qgs_fr_dV_g_di);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_s] -= (d_qgs_fr_dV_g_s);
// I(g,d) <+ (ddt(qgd_fr))
dynamicContributions[admsNodeID_g] += (qgd_fr);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] += (d_qgd_fr_dV_di_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] += (d_qgd_fr_dV_g_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] += (d_qgd_fr_dV_g_e);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] += (d_qgd_fr_dV_e_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] += (d_qgd_fr_dV_e_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] += (d_qgd_fr_dV_g_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_d] += (d_qgd_fr_dV_g_d);
dynamicContributions[admsNodeID_d] -= (qgd_fr);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si] -= (d_qgd_fr_dV_di_si);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_si] -= (d_qgd_fr_dV_g_si);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_e] -= (d_qgd_fr_dV_g_e);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_di] -= (d_qgd_fr_dV_e_di);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_si] -= (d_qgd_fr_dV_e_si);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_di] -= (d_qgd_fr_dV_g_di);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_d] -= (d_qgd_fr_dV_g_d);
}
if ((((model_.CAPMOD)!=0)&&((model_.BULKMOD)!=0)))
{
// I(g,si) <+ ((devsign*ddt(qg_acc)))
dynamicContributions[admsNodeID_g] += (devsign*(qg_acc));
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] += devsign*(d_qg_acc_dV_g_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] += devsign*(d_qg_acc_dV_di_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] += devsign*(d_qg_acc_dV_g_si);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] += devsign*(d_qg_acc_dV_g_e);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] += devsign*(d_qg_acc_dV_e_di);
d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] += devsign*(d_qg_acc_dV_e_si);
dynamicContributions[admsNodeID_si] -= (devsign*(qg_acc));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_qg_acc_dV_g_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_qg_acc_dV_di_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_qg_acc_dV_g_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_qg_acc_dV_g_e);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_qg_acc_dV_e_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_qg_acc_dV_e_si);
// I(e,si) <+ ((devsign*ddt(qb_acc)))
dynamicContributions[admsNodeID_e] += (devsign*(qb_acc));
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] += devsign*(d_qb_acc_dV_g_di);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si] += devsign*(d_qb_acc_dV_di_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si] += devsign*(d_qb_acc_dV_g_si);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e] += devsign*(d_qb_acc_dV_g_e);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] += devsign*(d_qb_acc_dV_e_di);
d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] += devsign*(d_qb_acc_dV_e_si);
dynamicContributions[admsNodeID_si] -= (devsign*(qb_acc));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di] -= devsign*(d_qb_acc_dV_g_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -= devsign*(d_qb_acc_dV_di_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] -= devsign*(d_qb_acc_dV_g_si);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] -= devsign*(d_qb_acc_dV_g_e);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -= devsign*(d_qb_acc_dV_e_di);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -= devsign*(d_qb_acc_dV_e_si);
}
// I(d,di) <+ ((V(d,di)/Rdrain))
staticContributions[admsNodeID_d] += ((probeVars[admsProbeID_V_d_di])/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_g_di] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_g_di/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_di_si] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_di_si/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_g_si] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_g_si/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_g_e] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_g_e/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_e_di] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_e_di/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_e_si] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_e_si/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_si_s] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_si_s/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_di_d] += (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_di_d/Rdrain/Rdrain);
d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] += (d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di]/Rdrain);
staticContributions[admsNodeID_di] -= ((probeVars[admsProbeID_V_d_di])/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_g_di/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_di_si/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_g_si/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_g_e/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_e_di/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_e_si/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_si_s/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dV_di_d/Rdrain/Rdrain);
d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] -= (d_probeVars[admsProbeID_V_d_di][admsProbeID_V_d_di]/Rdrain);
// I(s,si) <+ ((V(s,si)/Rsource))
staticContributions[admsNodeID_s] += ((probeVars[admsProbeID_V_s_si])/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_di_si] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_di_si/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_g_si] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_g_si/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_g_e] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_g_e/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_e_di] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_e_di/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_e_si] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_e_si/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_si_s/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_g_di] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_g_di/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_di_d] += (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_di_d/Rsource/Rsource);
d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] += (d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si]/Rsource);
staticContributions[admsNodeID_si] -= ((probeVars[admsProbeID_V_s_si])/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_di_si/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_g_si/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_g_e/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_e_di/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_e_si/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_si_s/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_g_di/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dV_di_d/Rsource/Rsource);
d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] -= (d_probeVars[admsProbeID_V_s_si][admsProbeID_V_s_si]/Rsource);
// I(di,si) <+ (flicker_noise(FNPowerAt1Hz,EF,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[0]= FNPowerAt1Hz;
  noiseContribsExponent[0]= (model_.EF);
}
// I(d,di) <+ (white_noise((((4*Vtm)*1.60219e-19)*gdpr),"thermal"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[1]= (((4*Vtm)*1.60219e-19)*gdpr);
}
// I(s,si) <+ (white_noise((((4*Vtm)*1.60219e-19)*gspr),"thermal"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[2]= (((4*Vtm)*1.60219e-19)*gspr);
}
// I(di,si) <+ (white_noise(sid,"thermal"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[3]= sid;
}
if (((model_.IGCMOD)!=0))
{
if ((sigvds>0))
{
// I(g,si) <+ (white_noise(((2*1.60219e-19)*abs((igcs+igs))),"shot"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs((igcs+igs));
  noiseContribsPower[4]= ((2*1.60219e-19)*value_fabs_0);
}
// I(g,di) <+ (white_noise(((2*1.60219e-19)*abs((igcd+igd))),"shot"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs((igcd+igd));
  noiseContribsPower[5]= ((2*1.60219e-19)*value_fabs_0);
}
}
else
{
// I(g,di) <+ (white_noise(((2*1.60219e-19)*abs((igcs+igs))),"shot"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs((igcs+igs));
  noiseContribsPower[6]= ((2*1.60219e-19)*value_fabs_0);
}
// I(g,si) <+ (white_noise(((2*1.60219e-19)*abs((igcd+igd))),"shot"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs((igcd+igd));
  noiseContribsPower[7]= ((2*1.60219e-19)*value_fabs_0);
}
}
}
if (((model_.IGBMOD)!=0))
{
if (((model_.BULKMOD)!=0))
{
// I(g,e) <+ (white_noise(((2*1.60219e-19)*abs((igbinv+igbacc))),"shot"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs((igbinv+igbacc));
  noiseContribsPower[8]= ((2*1.60219e-19)*value_fabs_0);
}
}
else
{
// I(g,si) <+ (white_noise(((2*1.60219e-19)*abs(igbs)),"shot"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(igbs);
  noiseContribsPower[9]= ((2*1.60219e-19)*value_fabs_0);
}
// I(g,di) <+ (white_noise(((2*1.60219e-19)*abs(igbd)),"shot"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(igbd);
  noiseContribsPower[10]= ((2*1.60219e-19)*value_fabs_0);
}
}
}
WEFF = Weff;
LEFF = Leff;
WEFFCV = WeffCV;
LEFFCV = LeffCV;

d_IDS_dV_g_di = devsign*d_ids_dV_g_di;
d_IDS_dV_di_si = devsign*d_ids_dV_di_si;
d_IDS_dV_g_si = devsign*d_ids_dV_g_si;
d_IDS_dV_g_e = devsign*d_ids_dV_g_e;
d_IDS_dV_e_di = devsign*d_ids_dV_e_di;
d_IDS_dV_e_si = devsign*d_ids_dV_e_si;
IDS = (devsign*ids);
if ((sigvds>0))
{
if (((model_.BULKMOD)!=0))
{
IDEFF = ((((IDS+(devsign*idsgen))-(devsign*(igd+igcd)))+(devsign*(Iii+igidl)))-(devsign*Ied));
ISEFF = (((((-IDS)-(devsign*idsgen))-(devsign*(igs+igcs)))+(devsign*igisl))-(devsign*Ies));
}
else
{
IDEFF = (((IDS+(devsign*idsgen))-(devsign*((igd+igcd)+igbd)))+(devsign*((Iii+igidl)-igisl)));
ISEFF = ((((-IDS)-(devsign*idsgen))-(devsign*((igs+igcs)+igbs)))+(devsign*(igisl-igidl)));
}
}
else
{
if (((model_.BULKMOD)!=0))
{
IDEFF = (((((-IDS)-(devsign*idsgen))-(devsign*(igs+igcs)))+(devsign*igisl))-(devsign*Ied));
ISEFF = ((((IDS+(devsign*idsgen))-(devsign*(igd+igcd)))+(devsign*(Iii+igidl)))-((-devsign)*Ies));
}
else
{
IDEFF = ((((-IDS)-(devsign*idsgen))-(devsign*((igs+igcs)+igbd)))+(devsign*(igisl-igidl)));
ISEFF = (((IDS+(devsign*idsgen))-(devsign*((igd+igcd)+igbs)))+(devsign*((Iii+igidl)-igisl)));
}
}
if (((model_.BULKMOD)==0))
{
IGTOT = (devsign*(((((igs+igd)+igcs)+igcd)+igbs)+igbd));
}
else
{
IGTOT = (devsign*(((((igs+igd)+igcs)+igcd)+igbacc)+igbinv));
}
IDSGEN = ((sigvds*devsign)*idsgen);
III = (devsign*Iii);
if ((sigvds>0))
{
IGIDL = (devsign*igidl);
IGISL = (devsign*igisl);
}
else
{
IGIDL = (devsign*igisl);
IGISL = (devsign*igidl);
}
if (((model_.BULKMOD)!=0))
{
IJSB = ((-devsign)*Ies);
IJDB = ((-devsign)*Ied);
}
else
{
IJSB = 0.0;
IJDB = 0.0;
}
if (((model_.BULKMOD)!=0))
{
ISUB = ((((((-III)-IGIDL)-IGISL)-IJSB)-IJDB)-(devsign*(igbinv+igbacc)));
}
else
{
ISUB = 0.0;
}
BETA = beta;
VDSSAT = Vdsat;
if ((NGATE_i>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((NGATE_i/ni));
VFB = ((-devsign)*(phib+(Vtm*evaluator_lln_0.getValues((NGATE_i/ni)))));
}
}
else
{
VFB = (PHIG_i-(((model_.EASUB)+(0.5*Eg))+(devsign*phib)));
}
if (((model_.GEOMOD)!=3))
{

d_q0_dV_di_si =  0.0;
q0 = ((((5.0*Vtm)*(epssub/TFIN))+(2.0*Qbul))/cox);

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si =  0.0;
d_T1_dV_di_si = Vtm*d_q0_dV_di_si;
T1 = (Vtm*(Vtm+q0));

d_T2_dV_di_si = (cox*cox)*d_T1_dV_di_si;
d_T2_dV_g_si = (cox*cox)*d_T1_dV_g_si;
d_T2_dV_g_e = (cox*cox)*d_T1_dV_g_e;
d_T2_dV_e_di = (cox*cox)*d_T1_dV_e_di;
d_T2_dV_e_si = (cox*cox)*d_T1_dV_e_si;
d_T2_dV_g_di = (cox*cox)*d_T1_dV_g_di;
d_T2_dV_si_s = (cox*cox)*d_T1_dV_si_s;
d_T2_dV_di_d = (cox*cox)*d_T1_dV_di_d;
T2 = ((cox*cox)*T1);

d_T3_dV_g_di = d_T3_dV_g_e = d_T3_dV_g_si = d_T3_dV_e_si = d_T3_dV_e_di = d_T3_dV_di_si =  0.0;
T3 = ((((2.0*1.60219e-19)*ni)*epssub)*Vtm);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((T2/T3));
VTH = (VFB+(devsign*(((((((Vtm*evaluator_lln_0.getValues((T2/T3)))+dvch_qm)+phib)+qbs)+Vtm)+dvth_all)-DELVTRAND)));
}
}
else
{

d_T1_dV_di_d = d_T1_dV_si_s = d_T1_dV_g_di = d_T1_dV_e_si = d_T1_dV_e_di = d_T1_dV_g_e = d_T1_dV_g_si =  0.0;
d_T1_dV_di_si = (-(Vtm*r1)*d_cdop_dV_di_si/cdop/cdop);
T1 = ((Vtm*r1)/cdop);
{
double value_sqrt_0 = sqrt(((T1*T1)+((2.0*T1)*Vtm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
qith = (value_sqrt_0-T1);
}

d_g0_dV_di_si = (-qith*d_q0_dV_di_si/q0/q0);
d_g0_dV_g_si = 0.0;
d_g0_dV_g_e = 0.0;
d_g0_dV_e_di = 0.0;
d_g0_dV_e_si = 0.0;
d_g0_dV_g_di = 0.0;
d_g0_dV_si_s = 0.0;
d_g0_dV_di_d = 0.0;
g0 = (qith/q0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(cdop*g0)));

d_F0_dV_di_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_si)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),(cdop*d_g0_dV_di_si+d_cdop_dV_di_si*g0)))+r1*d_g0_dV_di_si)+((r2*g0)*d_g0_dV_di_si+r2*d_g0_dV_di_si*g0));
d_F0_dV_g_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_si)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),cdop*d_g0_dV_g_si))+r1*d_g0_dV_g_si)+((r2*g0)*d_g0_dV_g_si+r2*d_g0_dV_g_si*g0));
d_F0_dV_g_e = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_e)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),cdop*d_g0_dV_g_e))+r1*d_g0_dV_g_e)+((r2*g0)*d_g0_dV_g_e+r2*d_g0_dV_g_e*g0));
d_F0_dV_e_di = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_di)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),cdop*d_g0_dV_e_di))+r1*d_g0_dV_e_di)+((r2*g0)*d_g0_dV_e_di+r2*d_g0_dV_e_di*g0));
d_F0_dV_e_si = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_e_si)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),cdop*d_g0_dV_e_si))+r1*d_g0_dV_e_si)+((r2*g0)*d_g0_dV_e_si+r2*d_g0_dV_e_si*g0));
d_F0_dV_g_di = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_g_di)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),cdop*d_g0_dV_g_di))+r1*d_g0_dV_g_di)+((r2*g0)*d_g0_dV_g_di+r2*d_g0_dV_g_di*g0));
d_F0_dV_si_s = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_si_s)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),cdop*d_g0_dV_si_s))+r1*d_g0_dV_si_s)+((r2*g0)*d_g0_dV_si_s+r2*d_g0_dV_si_s*g0));
d_F0_dV_di_d = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dV_di_d)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),cdop*d_g0_dV_di_d))+r1*d_g0_dV_di_d)+((r2*g0)*d_g0_dV_di_d+r2*d_g0_dV_di_d*g0));
F0 = ((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues((1.0+(cdop*g0)))))+(r1*g0))+((r2*g0)*g0));
}
VTH = (((((((((2.0*Vtm)*F0)+((vt0*Vtm)/nVtm))+deltaPhi)-(0.5*Eg))-phib)+dvth_all)+dvch_qm)-DELVTRAND);
}
GM = (+d_IDS_dV_g_di+d_IDS_dV_g_si+d_IDS_dV_g_e);
GDS = (-d_IDS_dV_g_di+d_IDS_dV_di_si-d_IDS_dV_e_di);
if (((model_.BULKMOD)!=0))
{
GMBS = (-d_IDS_dV_g_e+d_IDS_dV_e_di+d_IDS_dV_e_si);
}
else
{
GMBS = 0.0;
}

d_QGI_dV_g_di = (devsign*d_qg_dV_g_di+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_g_di:0.0));
d_QGI_dV_g_si = (devsign*d_qg_dV_g_si+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_g_si:0.0));
d_QGI_dV_g_e = (devsign*d_qg_dV_g_e+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_g_e:0.0));
d_QGI_dV_e_di = (devsign*d_qg_dV_e_di+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_e_di:0.0));
d_QGI_dV_e_si = (devsign*d_qg_dV_e_si+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_e_si:0.0));
d_QGI_dV_di_si = (devsign*d_qg_dV_di_si+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_di_si:0.0));
QGI = ((devsign*qg)+(((model_.CAPMOD)==1)?(devsign*qg_acc):0));

d_QDI_dV_g_di = devsign*d_qd_dV_g_di;
d_QDI_dV_g_si = devsign*d_qd_dV_g_si;
d_QDI_dV_g_e = devsign*d_qd_dV_g_e;
d_QDI_dV_e_di = devsign*d_qd_dV_e_di;
d_QDI_dV_e_si = devsign*d_qd_dV_e_si;
d_QDI_dV_di_si = devsign*d_qd_dV_di_si;
QDI = (devsign*qd);

d_QSI_dV_g_di = devsign*d_qs_dV_g_di;
d_QSI_dV_g_si = devsign*d_qs_dV_g_si;
d_QSI_dV_g_e = devsign*d_qs_dV_g_e;
d_QSI_dV_e_di = devsign*d_qs_dV_e_di;
d_QSI_dV_e_si = devsign*d_qs_dV_e_si;
d_QSI_dV_di_si = devsign*d_qs_dV_di_si;
QSI = (devsign*qs);

d_QBI_dV_g_di = devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_g_di:0.0);
d_QBI_dV_di_si = devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_di_si:0.0);
d_QBI_dV_g_si = devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_g_si:0.0);
d_QBI_dV_g_e = devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_g_e:0.0);
d_QBI_dV_e_di = devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_e_di:0.0);
d_QBI_dV_e_si = devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_e_si:0.0);
QBI = (devsign*(qb+(((model_.CAPMOD)==1)?qb_acc:0)));

d_QG_dV_e_g = (((((model_.CGEOMOD)==1)?0.0:0.0)+(((model_.CAPMOD)==1)?0.0:0.0))-devsign*d_Qeg_dV_e_g);
d_QG_dV_g_d = ((d_qgd_parasitic_dV_g_d+(((model_.CGEOMOD)==1)?d_qgd_fr_dV_g_d:0.0))+(((model_.CAPMOD)==1)?0.0:0.0));
d_QG_dV_g_s = ((d_qgs_parasitic_dV_g_s+(((model_.CGEOMOD)==1)?d_qgs_fr_dV_g_s:0.0))+(((model_.CAPMOD)==1)?0.0:0.0));
d_QG_dV_g_di = (((((devsign*d_qg_dV_g_di+d_qgs_parasitic_dV_g_di)+d_qgd_parasitic_dV_g_di)+(((model_.CGEOMOD)==1)?(d_qgs_fr_dV_g_di+d_qgd_fr_dV_g_di):0.0))+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_g_di:0.0))-devsign*d_Qeg_dV_g_di);
d_QG_dV_g_si = (((((devsign*d_qg_dV_g_si+d_qgs_parasitic_dV_g_si)+d_qgd_parasitic_dV_g_si)+(((model_.CGEOMOD)==1)?(d_qgs_fr_dV_g_si+d_qgd_fr_dV_g_si):0.0))+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_g_si:0.0))-devsign*d_Qeg_dV_g_si);
d_QG_dV_g_e = (((((devsign*d_qg_dV_g_e+d_qgs_parasitic_dV_g_e)+d_qgd_parasitic_dV_g_e)+(((model_.CGEOMOD)==1)?(d_qgs_fr_dV_g_e+d_qgd_fr_dV_g_e):0.0))+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_g_e:0.0))-devsign*d_Qeg_dV_g_e);
d_QG_dV_e_di = (((((devsign*d_qg_dV_e_di+d_qgs_parasitic_dV_e_di)+d_qgd_parasitic_dV_e_di)+(((model_.CGEOMOD)==1)?(d_qgs_fr_dV_e_di+d_qgd_fr_dV_e_di):0.0))+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_e_di:0.0))-devsign*d_Qeg_dV_e_di);
d_QG_dV_e_si = (((((devsign*d_qg_dV_e_si+d_qgs_parasitic_dV_e_si)+d_qgd_parasitic_dV_e_si)+(((model_.CGEOMOD)==1)?(d_qgs_fr_dV_e_si+d_qgd_fr_dV_e_si):0.0))+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_e_si:0.0))-devsign*d_Qeg_dV_e_si);
d_QG_dV_di_si = (((((devsign*d_qg_dV_di_si+d_qgs_parasitic_dV_di_si)+d_qgd_parasitic_dV_di_si)+(((model_.CGEOMOD)==1)?(d_qgs_fr_dV_di_si+d_qgd_fr_dV_di_si):0.0))+(((model_.CAPMOD)==1)?devsign*d_qg_acc_dV_di_si:0.0))-devsign*d_Qeg_dV_di_si);
QG = ((((((devsign*qg)+qgs_parasitic)+qgd_parasitic)+(((model_.CGEOMOD)==1)?(qgs_fr+qgd_fr):0))+(((model_.CAPMOD)==1)?(devsign*qg_acc):0))-(devsign*Qeg));

d_QD_dV_si_s = ((-(((model_.CGEOMOD)==1)?0.0:0.0))-devsign*d_Qed_dV_si_s);
d_QD_dV_di_d = ((-(((model_.CGEOMOD)==1)?0.0:0.0))-devsign*d_Qed_dV_di_d);
d_QD_dV_g_d = ((-d_qgd_parasitic_dV_g_d)-(((model_.CGEOMOD)==1)?d_qgd_fr_dV_g_d:0.0));
d_QD_dV_g_di = (((devsign*d_qd_dV_g_di-d_qgd_parasitic_dV_g_di)-(((model_.CGEOMOD)==1)?d_qgd_fr_dV_g_di:0.0))-devsign*d_Qed_dV_g_di);
d_QD_dV_g_si = (((devsign*d_qd_dV_g_si-d_qgd_parasitic_dV_g_si)-(((model_.CGEOMOD)==1)?d_qgd_fr_dV_g_si:0.0))-devsign*d_Qed_dV_g_si);
d_QD_dV_g_e = (((devsign*d_qd_dV_g_e-d_qgd_parasitic_dV_g_e)-(((model_.CGEOMOD)==1)?d_qgd_fr_dV_g_e:0.0))-devsign*d_Qed_dV_g_e);
d_QD_dV_e_di = (((devsign*d_qd_dV_e_di-d_qgd_parasitic_dV_e_di)-(((model_.CGEOMOD)==1)?d_qgd_fr_dV_e_di:0.0))-devsign*d_Qed_dV_e_di);
d_QD_dV_e_si = (((devsign*d_qd_dV_e_si-d_qgd_parasitic_dV_e_si)-(((model_.CGEOMOD)==1)?d_qgd_fr_dV_e_si:0.0))-devsign*d_Qed_dV_e_si);
d_QD_dV_di_si = (((devsign*d_qd_dV_di_si-d_qgd_parasitic_dV_di_si)-(((model_.CGEOMOD)==1)?d_qgd_fr_dV_di_si:0.0))-devsign*d_Qed_dV_di_si);
QD = ((((devsign*qd)-qgd_parasitic)-(((model_.CGEOMOD)==1)?qgd_fr:0))-(devsign*Qed));

d_QS_dV_si_s = ((-(((model_.CGEOMOD)==1)?0.0:0.0))-devsign*d_Qes_dV_si_s);
d_QS_dV_di_d = ((-(((model_.CGEOMOD)==1)?0.0:0.0))-devsign*d_Qes_dV_di_d);
d_QS_dV_g_s = ((-d_qgs_parasitic_dV_g_s)-(((model_.CGEOMOD)==1)?d_qgs_fr_dV_g_s:0.0));
d_QS_dV_g_di = (((devsign*d_qs_dV_g_di-d_qgs_parasitic_dV_g_di)-(((model_.CGEOMOD)==1)?d_qgs_fr_dV_g_di:0.0))-devsign*d_Qes_dV_g_di);
d_QS_dV_g_si = (((devsign*d_qs_dV_g_si-d_qgs_parasitic_dV_g_si)-(((model_.CGEOMOD)==1)?d_qgs_fr_dV_g_si:0.0))-devsign*d_Qes_dV_g_si);
d_QS_dV_g_e = (((devsign*d_qs_dV_g_e-d_qgs_parasitic_dV_g_e)-(((model_.CGEOMOD)==1)?d_qgs_fr_dV_g_e:0.0))-devsign*d_Qes_dV_g_e);
d_QS_dV_e_di = (((devsign*d_qs_dV_e_di-d_qgs_parasitic_dV_e_di)-(((model_.CGEOMOD)==1)?d_qgs_fr_dV_e_di:0.0))-devsign*d_Qes_dV_e_di);
d_QS_dV_e_si = (((devsign*d_qs_dV_e_si-d_qgs_parasitic_dV_e_si)-(((model_.CGEOMOD)==1)?d_qgs_fr_dV_e_si:0.0))-devsign*d_Qes_dV_e_si);
d_QS_dV_di_si = (((devsign*d_qs_dV_di_si-d_qgs_parasitic_dV_di_si)-(((model_.CGEOMOD)==1)?d_qgs_fr_dV_di_si:0.0))-devsign*d_Qes_dV_di_si);
QS = ((((devsign*qs)-qgs_parasitic)-(((model_.CGEOMOD)==1)?qgs_fr:0))-(devsign*Qes));

d_QB_dV_si_s = (devsign*(((model_.CAPMOD)==1)?0.0:0.0)+devsign*(d_Qes_dV_si_s+d_Qed_dV_si_s));
d_QB_dV_di_d = (devsign*(((model_.CAPMOD)==1)?0.0:0.0)+devsign*(d_Qes_dV_di_d+d_Qed_dV_di_d));
d_QB_dV_e_g = (devsign*(((model_.CAPMOD)==1)?0.0:0.0)+devsign*d_Qeg_dV_e_g);
d_QB_dV_g_di = (devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_g_di:0.0)+devsign*((d_Qeg_dV_g_di+d_Qes_dV_g_di)+d_Qed_dV_g_di));
d_QB_dV_di_si = (devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_di_si:0.0)+devsign*((d_Qeg_dV_di_si+d_Qes_dV_di_si)+d_Qed_dV_di_si));
d_QB_dV_g_si = (devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_g_si:0.0)+devsign*((d_Qeg_dV_g_si+d_Qes_dV_g_si)+d_Qed_dV_g_si));
d_QB_dV_g_e = (devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_g_e:0.0)+devsign*((d_Qeg_dV_g_e+d_Qes_dV_g_e)+d_Qed_dV_g_e));
d_QB_dV_e_di = (devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_e_di:0.0)+devsign*((d_Qeg_dV_e_di+d_Qes_dV_e_di)+d_Qed_dV_e_di));
d_QB_dV_e_si = (devsign*(((model_.CAPMOD)==1)?d_qb_acc_dV_e_si:0.0)+devsign*((d_Qeg_dV_e_si+d_Qes_dV_e_si)+d_Qed_dV_e_si));
QB = ((devsign*(qb+(((model_.CAPMOD)==1)?qb_acc:0)))+(devsign*((Qeg+Qes)+Qed)));
CGGI = (+d_QGI_dV_g_di+d_QGI_dV_g_si+d_QGI_dV_g_e);
CGSI = (-(-d_QGI_dV_g_si-d_QGI_dV_e_si-d_QGI_dV_di_si));
CGDI = (-(-d_QGI_dV_g_di-d_QGI_dV_e_di+d_QGI_dV_di_si));
CGEI = (-(-d_QGI_dV_g_e+d_QGI_dV_e_di+d_QGI_dV_e_si));
CSGI = (-(+d_QSI_dV_g_di+d_QSI_dV_g_si+d_QSI_dV_g_e));
CSDI = (-(-d_QSI_dV_g_di-d_QSI_dV_e_di+d_QSI_dV_di_si));
CSSI = (-d_QSI_dV_g_si-d_QSI_dV_e_si-d_QSI_dV_di_si);
CSEI = (-(-d_QSI_dV_g_e+d_QSI_dV_e_di+d_QSI_dV_e_si));
CDGI = (-(+d_QDI_dV_g_di+d_QDI_dV_g_si+d_QDI_dV_g_e));
CDDI = (-d_QDI_dV_g_di-d_QDI_dV_e_di+d_QDI_dV_di_si);
CDSI = (-(-d_QDI_dV_g_si-d_QDI_dV_e_si-d_QDI_dV_di_si));
CDEI = (-(-d_QDI_dV_g_e+d_QDI_dV_e_di+d_QDI_dV_e_si));
CEGI = (-(+d_QBI_dV_g_di+d_QBI_dV_g_si+d_QBI_dV_g_e));
CEDI = (-(-d_QBI_dV_g_di+d_QBI_dV_di_si-d_QBI_dV_e_di));
CESI = (-(-d_QBI_dV_di_si-d_QBI_dV_g_si-d_QBI_dV_e_si));
CEEI = (-d_QBI_dV_g_e+d_QBI_dV_e_di+d_QBI_dV_e_si);
CGG = (-d_QG_dV_e_g+d_QG_dV_g_d+d_QG_dV_g_s+d_QG_dV_g_di+d_QG_dV_g_si+d_QG_dV_g_e);
CGS = (-(-d_QG_dV_g_si-d_QG_dV_e_si-d_QG_dV_di_si));
CGD = (-(-d_QG_dV_g_di-d_QG_dV_e_di+d_QG_dV_di_si));
CGE = (-(+d_QG_dV_e_g-d_QG_dV_g_e+d_QG_dV_e_di+d_QG_dV_e_si));
CSG = (-(+d_QS_dV_g_s+d_QS_dV_g_di+d_QS_dV_g_si+d_QS_dV_g_e));
CSD = (-(+d_QS_dV_di_d-d_QS_dV_g_di-d_QS_dV_e_di+d_QS_dV_di_si));
CSS = (+d_QS_dV_si_s-d_QS_dV_g_si-d_QS_dV_e_si-d_QS_dV_di_si);
CSE = (-(-d_QS_dV_g_e+d_QS_dV_e_di+d_QS_dV_e_si));
CDG = (-(+d_QD_dV_g_d+d_QD_dV_g_di+d_QD_dV_g_si+d_QD_dV_g_e));
CDD = (+d_QD_dV_di_d-d_QD_dV_g_di-d_QD_dV_e_di+d_QD_dV_di_si);
CDS = (-(+d_QD_dV_si_s-d_QD_dV_g_si-d_QD_dV_e_si-d_QD_dV_di_si));
CDE = (-(-d_QD_dV_g_e+d_QD_dV_e_di+d_QD_dV_e_si));
CEG = (-(-d_QB_dV_e_g+d_QB_dV_g_di+d_QB_dV_g_si+d_QB_dV_g_e));
CED = (-(+d_QB_dV_di_d-d_QB_dV_g_di+d_QB_dV_di_si-d_QB_dV_e_di));
CES = (-(+d_QB_dV_si_s-d_QB_dV_di_si-d_QB_dV_g_si-d_QB_dV_e_si));
CEE = (+d_QB_dV_e_g-d_QB_dV_g_e+d_QB_dV_e_di+d_QB_dV_e_si);
CGSEXT = (-(-(d_qgs_parasitic_dV_di_si+(((model_.CGEOMOD)==1)?d_qgs_fr_dV_di_si:0.0))-(d_qgs_parasitic_dV_g_si+(((model_.CGEOMOD)==1)?d_qgs_fr_dV_g_si:0.0))-(d_qgs_parasitic_dV_e_si+(((model_.CGEOMOD)==1)?d_qgs_fr_dV_e_si:0.0))));
CGDEXT = (-(+(d_qgd_parasitic_dV_di_si+(((model_.CGEOMOD)==1)?d_qgd_fr_dV_di_si:0.0))-(d_qgd_parasitic_dV_e_di+(((model_.CGEOMOD)==1)?d_qgd_fr_dV_e_di:0.0))-(d_qgd_parasitic_dV_g_di+(((model_.CGEOMOD)==1)?d_qgd_fr_dV_g_di:0.0))));
CGBOV = ((-devsign)*(+d_Qeg_dV_e_g+d_Qeg_dV_e_di+d_Qeg_dV_e_si-d_Qeg_dV_g_e));
CJST = ((-devsign)*(-d_Qes_dV_di_si-d_Qes_dV_g_si-d_Qes_dV_e_si+d_Qes_dV_si_s));
CJDT = ((-devsign)*(+d_Qed_dV_di_si-d_Qed_dV_e_di-d_Qed_dV_g_di+d_Qed_dV_di_d));
RSGEO = RSourceGeo;
RDGEO = RDrainGeo;
CFGEO = Cfr_geo;


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_si_GND] =  "
         <<probeVars[admsProbeID_V_si_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_GND] =  "
         <<probeVars[admsProbeID_V_e_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_GND] =  "
         <<probeVars[admsProbeID_V_di_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_GND] =  "
         <<probeVars[admsProbeID_V_g_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_si] =  "
         <<probeVars[admsProbeID_V_s_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_di] =  "
         <<probeVars[admsProbeID_V_d_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_g] =  "
         <<probeVars[admsProbeID_V_e_g] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_s] =  "
         <<probeVars[admsProbeID_V_d_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_d] =  "
         <<probeVars[admsProbeID_V_g_d] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_s] =  "
         <<probeVars[admsProbeID_V_g_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_d] =  "
         <<probeVars[admsProbeID_V_di_d] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_s] =  "
         <<probeVars[admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_e] =  "
         <<probeVars[admsProbeID_V_g_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_di] =  "
         <<probeVars[admsProbeID_V_e_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_e_si] =  "
         <<probeVars[admsProbeID_V_e_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_di] =  "
         <<probeVars[admsProbeID_V_g_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_si] =  "
         <<probeVars[admsProbeID_V_di_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_si] =  "
         <<probeVars[admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_d] =  "
         <<staticContributions[admsNodeID_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_g) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_d) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_s) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_d) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_e) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_e_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_d] =  "
         <<dynamicContributions[admsNodeID_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_g) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_d) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_s) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_d) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_e) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_e_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_g] =  "
         <<staticContributions[admsNodeID_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_g) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_d) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_s) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_d) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_e) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_e_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_g] =  "
         <<dynamicContributions[admsNodeID_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_g) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_d) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_s) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_d) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_e) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_e_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
         <<staticContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_g) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_d) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_d) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_e_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
         <<dynamicContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_g) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_d) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_d) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_e_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
         <<staticContributions[admsNodeID_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_g) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_d) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_s) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_di_d) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_di) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_e_si) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_di) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_g_si) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
         <<dynamicContributions[admsNodeID_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_g) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_d) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_s) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_d) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_di) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_e_si) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_di) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_g_si) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_di] =  "
         <<staticContributions[admsNodeID_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_g) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_d) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_s) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_d) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_e) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_e_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_di] =  "
         <<dynamicContributions[admsNodeID_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_g) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_d) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_s) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_d) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_e) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_e_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
         <<staticContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_g) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_d) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_d) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_e_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
         <<dynamicContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_d_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_g) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_d) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_d) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_e_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 6; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
return 11;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
int numSources=getNumNoiseSources();
noiseData.numSources = numSources;
noiseData.resize(numSources);

noiseData.deviceName = getName().getEncodedName();
std::string theNoiseName;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_di_si")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[0]=theNoiseName;
noiseData.li_Pos[0]=li_di;
noiseData.li_Neg[0]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_d_di")+std::string("_")+std::string("thermal");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[1]=theNoiseName;
noiseData.li_Pos[1]=li_d;
noiseData.li_Neg[1]=li_di;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_s_si")+std::string("_")+std::string("thermal");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[2]=theNoiseName;
noiseData.li_Pos[2]=li_s;
noiseData.li_Neg[2]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_di_si")+std::string("_")+std::string("thermal");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[3]=theNoiseName;
noiseData.li_Pos[3]=li_di;
noiseData.li_Neg[3]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_si")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[4]=theNoiseName;
noiseData.li_Pos[4]=li_g;
noiseData.li_Neg[4]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_di")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[5]=theNoiseName;
noiseData.li_Pos[5]=li_g;
noiseData.li_Neg[5]=li_di;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_di")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[6]=theNoiseName;
noiseData.li_Pos[6]=li_g;
noiseData.li_Neg[6]=li_di;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_si")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[7]=theNoiseName;
noiseData.li_Pos[7]=li_g;
noiseData.li_Neg[7]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_e")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[8]=theNoiseName;
noiseData.li_Pos[8]=li_g;
noiseData.li_Neg[8]=li_e;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_si")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[9]=theNoiseName;
noiseData.li_Pos[9]=li_g;
noiseData.li_Neg[9]=li_si;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_g_di")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[10]=theNoiseName;
noiseData.li_Pos[10]=li_g;
noiseData.li_Neg[10]=li_di;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];

      noiseData.noiseDens[0] /= pow(noiseData.freq,noiseContribsExponent[0]);noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
noiseData.noiseDens[1] = noiseContribsPower[1];
noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
noiseData.noiseDens[2] = noiseContribsPower[2];
noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
noiseData.noiseDens[3] = noiseContribsPower[3];
noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
noiseData.noiseDens[4] = noiseContribsPower[4];
noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
noiseData.noiseDens[5] = noiseContribsPower[5];
noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
noiseData.noiseDens[6] = noiseContribsPower[6];
noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
noiseData.noiseDens[7] = noiseContribsPower[7];
noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
noiseData.noiseDens[8] = noiseContribsPower[8];
noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
noiseData.noiseDens[9] = noiseContribsPower[9];
noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
noiseData.noiseDens[10] = noiseContribsPower[10];
noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_di_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_g_di];
  (*f_di_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] +d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_g_di];
  (*f_si_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_g_di];
  (*f_si_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_g_di];
  (*f_di_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_si];
  (*f_si_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_di_si];
  (*f_di_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_g_e];
  (*f_si_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_si][admsProbeID_V_g_e];
  (*f_g_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_g][admsProbeID_V_g_si];
  (*f_g_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_g][admsProbeID_V_di_d];
  (*f_g_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_g][admsProbeID_V_si_s];
  (*f_g_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_g][admsProbeID_V_g_e];
  (*f_g_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_si_s];
  (*f_si_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_s];
  (*f_g_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_di_d];
  (*f_si_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_di_d];
  (*f_di_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_si_s];
  (*f_di_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_d];
  (*f_e_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_e][admsProbeID_V_g_e];
  (*f_e_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_e][admsProbeID_V_g_e];
  (*f_e_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] +d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_e][admsProbeID_V_e_di];
  (*f_e_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_e][admsProbeID_V_e_si];
  (*f_e_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_si_s];
  (*f_e_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_di_d];
  (*f_d_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] -d_staticContributions[admsNodeID_d][admsProbeID_V_di_d];
  (*f_d_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_si_s];
  (*f_s_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_di_d];
  (*f_s_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] -d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  (*f_s_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_s][admsProbeID_V_g_di] -d_staticContributions[admsNodeID_s][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_s][admsProbeID_V_di_si];
  (*f_s_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] +d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_s][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_s][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_s][admsProbeID_V_di_si];
  (*f_s_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_s][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_s][admsProbeID_V_g_si];
  (*f_s_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_s][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_s][admsProbeID_V_g_e];
  (*f_d_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] +d_staticContributions[admsNodeID_d][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_d][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_d][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_d][admsProbeID_V_g_di];
  (*f_d_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_d][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_d][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_d][admsProbeID_V_di_si];
  (*f_d_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_d][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_d][admsProbeID_V_g_di];
  (*f_d_Equ_e_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_d][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_d][admsProbeID_V_g_e];

#else
  //use the offsets instead of pointers
  dFdx[li_di][A_di_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_g_di];
  dFdx[li_di][A_di_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] +d_staticContributions[admsNodeID_di][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_g_di];
  dFdx[li_si][A_si_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_g_di];
  dFdx[li_si][A_si_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_g_di];
  dFdx[li_di][A_di_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_si];
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_di_si];
  dFdx[li_di][A_di_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_g_e];
  dFdx[li_si][A_si_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_si][admsProbeID_V_g_e];
  dFdx[li_g][A_g_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_g][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_g][admsProbeID_V_g_si];
  dFdx[li_g][A_g_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_g][admsProbeID_V_di_d];
  dFdx[li_g][A_g_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_g][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_g][admsProbeID_V_si_s];
  dFdx[li_g][A_g_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_g][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_g][admsProbeID_V_g_e];
  dFdx[li_g][A_g_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_si_s];
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_s_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_s];
  dFdx[li_g][A_g_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_di_d];
  dFdx[li_si][A_si_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_di_d];
  dFdx[li_di][A_di_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_si_s];
  dFdx[li_di][A_di_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_d_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_d];
  dFdx[li_e][A_e_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_e][admsProbeID_V_g_e];
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_e][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_e][admsProbeID_V_g_e];
  dFdx[li_e][A_e_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_e][admsProbeID_V_di_d] +d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_e][admsProbeID_V_e_di];
  dFdx[li_e][A_e_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_e][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_e][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_e][admsProbeID_V_e_si];
  dFdx[li_e][A_e_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_si_s];
  dFdx[li_e][A_e_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_di_d];
  dFdx[li_d][A_d_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] -d_staticContributions[admsNodeID_d][admsProbeID_V_di_d];
  dFdx[li_d][A_d_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_si_s];
  dFdx[li_s][A_s_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_di_d];
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] -d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  dFdx[li_s][A_s_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_s][admsProbeID_V_g_di] -d_staticContributions[admsNodeID_s][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_s][admsProbeID_V_di_si];
  dFdx[li_s][A_s_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_s_si] +d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_s][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_s][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_s][admsProbeID_V_di_si];
  dFdx[li_s][A_s_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_g_di] +d_staticContributions[admsNodeID_s][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_s][admsProbeID_V_g_si];
  dFdx[li_s][A_s_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_s][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_s][admsProbeID_V_g_e];
  dFdx[li_d][A_d_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_d_di] +d_staticContributions[admsNodeID_d][admsProbeID_V_di_d] -d_staticContributions[admsNodeID_d][admsProbeID_V_e_di] +d_staticContributions[admsNodeID_d][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_d][admsProbeID_V_g_di];
  dFdx[li_d][A_d_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_si_s] -d_staticContributions[admsNodeID_d][admsProbeID_V_e_si] -d_staticContributions[admsNodeID_d][admsProbeID_V_g_si] -d_staticContributions[admsNodeID_d][admsProbeID_V_di_si];
  dFdx[li_d][A_d_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_g_e] +d_staticContributions[admsNodeID_d][admsProbeID_V_g_si] +d_staticContributions[admsNodeID_d][admsProbeID_V_g_di];
  dFdx[li_d][A_d_Equ_e_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_e_si] +d_staticContributions[admsNodeID_d][admsProbeID_V_e_di] -d_staticContributions[admsNodeID_d][admsProbeID_V_g_e];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_di_Equ_g_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di];
  (*q_di_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_d] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di];
  (*q_si_Equ_g_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_s] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di];
  (*q_si_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_d] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di];
  (*q_di_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_s] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si];
  (*q_si_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si];
  (*q_di_Equ_e_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e];
  (*q_si_Equ_e_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e];
  (*q_g_Equ_g_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_s] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di];
  (*q_g_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di];
  (*q_g_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si];
  (*q_g_Equ_e_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e];
  (*q_g_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_s];
  (*q_si_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_s] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s];
  (*q_g_Equ_d_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_d];
  (*q_si_Equ_d_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_d];
  (*q_di_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_s];
  (*q_di_Equ_d_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_d] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_d];
  (*q_e_Equ_g_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si];
  (*q_e_Equ_e_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e];
  (*q_e_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_d] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si];
  (*q_e_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si];
  (*q_e_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s];
  (*q_e_Equ_d_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_d];
  (*q_d_Equ_d_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s];
  (*q_d_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s];
  (*q_s_Equ_d_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s];
  (*q_s_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_s] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s];
  (*q_s_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si];
  (*q_s_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_si] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si];
  (*q_s_Equ_g_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_si];
  (*q_s_Equ_e_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_e];
  (*q_d_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_di] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_di] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si];
  (*q_d_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_si] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si];
  (*q_d_Equ_g_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_di] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_si];
  (*q_d_Equ_e_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_e];

#else
  //use the offsets instead of pointers
  dQdx[li_di][A_di_Equ_g_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di];
  dQdx[li_di][A_di_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_d] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_di];
  dQdx[li_si][A_si_Equ_g_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_s] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di];
  dQdx[li_si][A_si_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_d] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_di];
  dQdx[li_di][A_di_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_s] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_si];
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_si];
  dQdx[li_di][A_di_Equ_e_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_e];
  dQdx[li_si][A_si_Equ_e_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_e];
  dQdx[li_g][A_g_Equ_g_NodeOffset] +=  +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_s] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di];
  dQdx[li_g][A_g_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_di];
  dQdx[li_g][A_g_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_si];
  dQdx[li_g][A_g_Equ_e_NodeOffset] +=  +d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_g][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_e];
  dQdx[li_g][A_g_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_s];
  dQdx[li_si][A_si_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_s] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s];
  dQdx[li_g][A_g_Equ_d_NodeOffset] +=  -d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_d];
  dQdx[li_si][A_si_Equ_d_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_d];
  dQdx[li_di][A_di_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_s];
  dQdx[li_di][A_di_Equ_d_NodeOffset] +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_d] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_d];
  dQdx[li_e][A_e_Equ_g_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si];
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_g] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_e];
  dQdx[li_e][A_e_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_d] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_di] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_di] +d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si];
  dQdx[li_e][A_e_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_g_si] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_si];
  dQdx[li_e][A_e_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s];
  dQdx[li_e][A_e_Equ_d_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_di_d];
  dQdx[li_d][A_d_Equ_d_NodeOffset] +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s];
  dQdx[li_d][A_d_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s];
  dQdx[li_s][A_s_Equ_d_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s];
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_s] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s];
  dQdx[li_s][A_s_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si];
  dQdx[li_s][A_s_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_si] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si];
  dQdx[li_s][A_s_Equ_g_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_si];
  dQdx[li_s][A_s_Equ_e_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_e];
  dQdx[li_d][A_d_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_di] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_di] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si];
  dQdx[li_d][A_d_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_si] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_si] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si];
  dQdx[li_d][A_d_Equ_g_NodeOffset] +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_d] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_di] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_e] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_si];
  dQdx[li_d][A_d_Equ_e_NodeOffset] +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_si] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_e_di] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_e];


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:
  if (!given("COVD"))
  {
  COVD = COVS;
  }
  if (!given("LRSD"))
  {
  LRSD = L;
  }

// set internal model type based on model card type
if (getType() == "pmos" || getType() == "PMOS")
    DEVTYPE = 0;
  if (!given("CDSCDR"))
  {
  CDSCDR = CDSCD;
  }
  if (!given("CDSCDRN1"))
  {
  CDSCDRN1 = CDSCDN1;
  }
  if (!given("CDSCDRN2"))
  {
  CDSCDRN2 = CDSCDN2;
  }
  if (!given("DVT1SS"))
  {
  DVT1SS = DVT1;
  }
  if (!given("ETA0R"))
  {
  ETA0R = ETA0;
  }
  if (!given("TETA0R"))
  {
  TETA0R = TETA0;
  }
  if (!given("K1SI"))
  {
  K1SI = K0SI;
  }
  if (!given("K1SI1"))
  {
  K1SI1 = K0SI1;
  }
  if (!given("VSAT1"))
  {
  VSAT1 = VSAT;
  }
  if (!given("VSAT1N1"))
  {
  VSAT1N1 = VSATN1;
  }
  if (!given("VSAT1N2"))
  {
  VSAT1N2 = VSATN2;
  }
  if (!given("VSAT1R"))
  {
  VSAT1R = VSAT1;
  }
  if (!given("VSAT1RN1"))
  {
  VSAT1RN1 = VSAT1N1;
  }
  if (!given("VSAT1RN2"))
  {
  VSAT1RN2 = VSAT1N2;
  }
  if (!given("AVSAT1"))
  {
  AVSAT1 = AVSAT;
  }
  if (!given("BVSAT1"))
  {
  BVSAT1 = BVSAT;
  }
  if (!given("VSATCV"))
  {
  VSATCV = VSAT;
  }
  if (!given("AVSATCV"))
  {
  AVSATCV = AVSAT;
  }
  if (!given("BVSATCV"))
  {
  BVSATCV = BVSAT;
  }
  if (!given("DELTAVSATCV"))
  {
  DELTAVSATCV = DELTAVSAT;
  }
  if (!given("PSATCV"))
  {
  PSATCV = PSAT;
  }
  if (!given("APSATCV"))
  {
  APSATCV = APSAT;
  }
  if (!given("BPSATCV"))
  {
  BPSATCV = BPSAT;
  }
  if (!given("MEXPR"))
  {
  MEXPR = MEXP;
  }
  if (!given("AMEXPR"))
  {
  AMEXPR = AMEXP;
  }
  if (!given("BMEXPR"))
  {
  BMEXPR = BMEXP;
  }
  if (!given("PTWGR"))
  {
  PTWGR = PTWG;
  }
  if (!given("TMEXPR"))
  {
  TMEXPR = TMEXP;
  }
  if (!given("RSDRR"))
  {
  RSDRR = RSDR;
  }
  if (!given("RDDR"))
  {
  RDDR = RSDR;
  }
  if (!given("RDDRR"))
  {
  RDDRR = RDDR;
  }
  if (!given("PRDDR"))
  {
  PRDDR = PRSDR;
  }
  if (!given("PRWGD"))
  {
  PRWGD = PRWGS;
  }
  if (!given("TRDDR"))
  {
  TRDDR = TRSDR;
  }
  if (!given("PDIBL1R"))
  {
  PDIBL1R = PDIBL1;
  }
  if (!given("PCLMCV"))
  {
  PCLMCV = PCLM;
  }
  if (!given("RSHD"))
  {
  RSHD = RSHS;
  }
  if (!given("LSP"))
  {
  LSP = (0.2*(L+XL));
  }
  if (!given("DLCIGD"))
  {
  DLCIGD = DLCIGS;
  }
  if (!given("AIGD"))
  {
  AIGD = AIGS;
  }
  if (!given("AIGD1"))
  {
  AIGD1 = AIGS1;
  }
  if (!given("BIGD"))
  {
  BIGD = BIGS;
  }
  if (!given("CIGD"))
  {
  CIGD = CIGS;
  }
  if (!given("TOXG"))
  {
  TOXG = TOXP;
  }
  if (!given("AGIDL"))
  {
  AGIDL = AGISL;
  }
  if (!given("BGIDL"))
  {
  BGIDL = BGISL;
  }
  if (!given("CGIDL"))
  {
  CGIDL = CGISL;
  }
  if (!given("EGIDL"))
  {
  EGIDL = EGISL;
  }
  if (!given("PGIDL"))
  {
  PGIDL = PGISL;
  }
  if (!given("EOTACC"))
  {
  EOTACC = EOT;
  }
  if (!given("CFD"))
  {
  CFD = CFS;
  }
  if (!given("CGDO"))
  {
  CGDO = CGSO;
  }
  if (!given("CGDL"))
  {
  CGDL = CGSL;
  }
  if (!given("CKAPPAD"))
  {
  CKAPPAD = CKAPPAS;
  }
  if (!given("CJD"))
  {
  CJD = CJS;
  }
  if (!given("CJSWD"))
  {
  CJSWD = CJSWS;
  }
  if (!given("CJSWGD"))
  {
  CJSWGD = CJSWGS;
  }
  if (!given("PBD"))
  {
  PBD = PBS;
  }
  if (!given("PBSWD"))
  {
  PBSWD = PBSWS;
  }
  if (!given("PBSWGS"))
  {
  PBSWGS = PBSWS;
  }
  if (!given("PBSWGD"))
  {
  PBSWGD = PBSWGS;
  }
  if (!given("MJD"))
  {
  MJD = MJS;
  }
  if (!given("MJSWD"))
  {
  MJSWD = MJSWS;
  }
  if (!given("MJSWGS"))
  {
  MJSWGS = MJSWS;
  }
  if (!given("MJSWGD"))
  {
  MJSWGD = MJSWGS;
  }
  if (!given("SJD"))
  {
  SJD = SJS;
  }
  if (!given("SJSWD"))
  {
  SJSWD = SJSWS;
  }
  if (!given("SJSWGD"))
  {
  SJSWGD = SJSWGS;
  }
  if (!given("MJD2"))
  {
  MJD2 = MJS2;
  }
  if (!given("MJSWD2"))
  {
  MJSWD2 = MJSWS2;
  }
  if (!given("MJSWGS2"))
  {
  MJSWGS2 = MJSWS2;
  }
  if (!given("MJSWGD2"))
  {
  MJSWGD2 = MJSWGS2;
  }
  if (!given("JSD"))
  {
  JSD = JSS;
  }
  if (!given("JSWD"))
  {
  JSWD = JSWS;
  }
  if (!given("JSWGD"))
  {
  JSWGD = JSWGS;
  }
  if (!given("NJD"))
  {
  NJD = NJS;
  }
  if (!given("IJTHDFWD"))
  {
  IJTHDFWD = IJTHSFWD;
  }
  if (!given("IJTHDREV"))
  {
  IJTHDREV = IJTHSREV;
  }
  if (!given("BVD"))
  {
  BVD = BVS;
  }
  if (!given("XJBVD"))
  {
  XJBVD = XJBVS;
  }
  if (!given("JTSD"))
  {
  JTSD = JTSS;
  }
  if (!given("JTSSWD"))
  {
  JTSSWD = JTSSWS;
  }
  if (!given("JTSSWGD"))
  {
  JTSSWGD = JTSSWGS;
  }
  if (!given("NJTSD"))
  {
  NJTSD = NJTS;
  }
  if (!given("NJTSSWD"))
  {
  NJTSSWD = NJTSSW;
  }
  if (!given("NJTSSWGD"))
  {
  NJTSSWGD = NJTSSWG;
  }
  if (!given("VTSD"))
  {
  VTSD = VTSS;
  }
  if (!given("VTSSWD"))
  {
  VTSSWD = VTSSWS;
  }
  if (!given("VTSSWGD"))
  {
  VTSSWGD = VTSSWGS;
  }
  if (!given("XTID"))
  {
  XTID = XTIS;
  }
  if (!given("XTSD"))
  {
  XTSD = XTSS;
  }
  if (!given("XTSSWD"))
  {
  XTSSWD = XTSSWS;
  }
  if (!given("XTSSWGD"))
  {
  XTSSWGD = XTSSWGS;
  }
  if (!given("TNJTSD"))
  {
  TNJTSD = TNJTS;
  }
  if (!given("TNJTSSWD"))
  {
  TNJTSSWD = TNJTSSW;
  }
  if (!given("TNJTSSWGD"))
  {
  TNJTSSWGD = TNJTSSWG;
  }
  if (!given("LCDSCDR"))
  {
  LCDSCDR = LCDSCD;
  }
  if (!given("NCDSCDR"))
  {
  NCDSCDR = NCDSCD;
  }
  if (!given("PCDSCDR"))
  {
  PCDSCDR = PCDSCD;
  }
  if (!given("LETA0R"))
  {
  LETA0R = LETA0;
  }
  if (!given("NETA0R"))
  {
  NETA0R = NETA0;
  }
  if (!given("PETA0R"))
  {
  PETA0R = PETA0;
  }
  if (!given("LVSAT1"))
  {
  LVSAT1 = LVSAT;
  }
  if (!given("NVSAT1"))
  {
  NVSAT1 = NVSAT;
  }
  if (!given("PVSAT1"))
  {
  PVSAT1 = PVSAT;
  }
  if (!given("LVSAT1R"))
  {
  LVSAT1R = LVSAT1;
  }
  if (!given("NVSAT1R"))
  {
  NVSAT1R = NVSAT1;
  }
  if (!given("PVSAT1R"))
  {
  PVSAT1R = PVSAT1;
  }
  if (!given("LPTWGR"))
  {
  LPTWGR = LPTWG;
  }
  if (!given("NPTWGR"))
  {
  NPTWGR = NPTWG;
  }
  if (!given("PPTWGR"))
  {
  PPTWGR = PPTWG;
  }
  if (!given("LPDIBL1R"))
  {
  LPDIBL1R = LPDIBL1;
  }
  if (!given("NPDIBL1R"))
  {
  NPDIBL1R = NPDIBL1;
  }
  if (!given("PPDIBL1R"))
  {
  PPDIBL1R = PPDIBL1;
  }
  if (!given("LAIGD"))
  {
  LAIGD = LAIGS;
  }
  if (!given("NAIGD"))
  {
  NAIGD = NAIGS;
  }
  if (!given("PAIGD"))
  {
  PAIGD = PAIGS;
  }
  if (!given("LAIGD1"))
  {
  LAIGD1 = LAIGS1;
  }
  if (!given("NAIGD1"))
  {
  NAIGD1 = NAIGS1;
  }
  if (!given("PAIGD1"))
  {
  PAIGD1 = PAIGS1;
  }
  if (!given("LBIGD"))
  {
  LBIGD = LBIGS;
  }
  if (!given("NBIGD"))
  {
  NBIGD = NBIGS;
  }
  if (!given("PBIGD"))
  {
  PBIGD = PBIGS;
  }
  if (!given("LCIGD"))
  {
  LCIGD = LCIGS;
  }
  if (!given("NCIGD"))
  {
  NCIGD = NCIGS;
  }
  if (!given("PCIGD"))
  {
  PCIGD = PCIGS;
  }
  if (!given("LAGIDL"))
  {
  LAGIDL = LAGISL;
  }
  if (!given("NAGIDL"))
  {
  NAGIDL = NAGISL;
  }
  if (!given("PAGIDL"))
  {
  PAGIDL = PAGISL;
  }
  if (!given("LBGIDL"))
  {
  LBGIDL = LBGISL;
  }
  if (!given("NBGIDL"))
  {
  NBGIDL = NBGISL;
  }
  if (!given("PBGIDL"))
  {
  PBGIDL = PBGISL;
  }
  if (!given("LCGIDL"))
  {
  LCGIDL = LCGISL;
  }
  if (!given("NCGIDL"))
  {
  NCGIDL = NCGISL;
  }
  if (!given("PCGIDL"))
  {
  PCGIDL = PCGISL;
  }
  if (!given("LEGIDL"))
  {
  LEGIDL = LEGISL;
  }
  if (!given("NEGIDL"))
  {
  NEGIDL = NEGISL;
  }
  if (!given("PEGIDL"))
  {
  PEGIDL = PEGISL;
  }
  if (!given("LPGIDL"))
  {
  LPGIDL = LPGISL;
  }
  if (!given("NPGIDL"))
  {
  NPGIDL = NPGISL;
  }
  if (!given("PPGIDL"))
  {
  PPGIDL = PPGISL;
  }
  if (!given("LCFD"))
  {
  LCFD = LCFS;
  }
  if (!given("NCFD"))
  {
  NCFD = NCFS;
  }
  if (!given("PCFD"))
  {
  PCFD = PCFS;
  }
  if (!given("LCOVD"))
  {
  LCOVD = LCOVS;
  }
  if (!given("NCOVD"))
  {
  NCOVD = NCOVS;
  }
  if (!given("PCOVD"))
  {
  PCOVD = PCOVS;
  }
  if (!given("LCGDL"))
  {
  LCGDL = LCGSL;
  }
  if (!given("NCGDL"))
  {
  NCGDL = NCGSL;
  }
  if (!given("PCGDL"))
  {
  PCGDL = PCGSL;
  }
  if (!given("LCKAPPAD"))
  {
  LCKAPPAD = LCKAPPAS;
  }
  if (!given("NCKAPPAD"))
  {
  NCKAPPAD = NCKAPPAS;
  }
  if (!given("PCKAPPAD"))
  {
  PCKAPPAD = PCKAPPAS;
  }



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter L : [ 1*1.0e-9,  (+inf) [
  if ( (!((L >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter L value " << L << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter D : [ 1*1.0e-9,  (+inf) [
  if ( (!((D >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter D value " << D << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter TFIN : [ 1*1.0e-9,  (+inf) [
  if ( (!((TFIN >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter TFIN value " << TFIN << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter FPITCH : [ TFIN,  (+inf) [
  if ( (!((FPITCH >=TFIN))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter FPITCH value " << FPITCH << " out of range [ TFIN,  (+inf) [";
  }

//    Parameter NF : [ 1,  (+inf) [
  if ( (!((NF >=1))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NF value " << NF << " out of range [ 1,  (+inf) [";
  }

//    Parameter NFIN : ] 0,  (+inf) [
  if ( (!((NFIN >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NFIN value " << NFIN << " out of range ] 0,  (+inf) [";
  }

//    Parameter NGCON : [ 1, 2 ]
  if ( (!((NGCON >=1 && NGCON <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NGCON value " << NGCON << " out of range [ 1, 2 ]";
  }

//    Parameter ASEO : [ 0,  (+inf) [
  if ( (!((ASEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ASEO value " << ASEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter ADEO : [ 0,  (+inf) [
  if ( (!((ADEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ADEO value " << ADEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSEO : [ 0,  (+inf) [
  if ( (!((PSEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PSEO value " << PSEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter PDEO : [ 0,  (+inf) [
  if ( (!((PDEO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PDEO value " << PDEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter ASEJ : [ 0,  (+inf) [
  if ( (!((ASEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ASEJ value " << ASEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter ADEJ : [ 0,  (+inf) [
  if ( (!((ADEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ADEJ value " << ADEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSEJ : [ 0,  (+inf) [
  if ( (!((PSEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PSEJ value " << PSEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter PDEJ : [ 0,  (+inf) [
  if ( (!((PDEJ >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PDEJ value " << PDEJ << " out of range [ 0,  (+inf) [";
  }

//    Parameter COVS : [ 0,  (+inf) [
  if ( (!((COVS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter COVS value " << COVS << " out of range [ 0,  (+inf) [";
  }

//    Parameter COVD : [ 0,  (+inf) [
  if ( (!((COVD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter COVD value " << COVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGSP : [ 0,  (+inf) [
  if ( (!((CGSP >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGSP value " << CGSP << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGDP : [ 0,  (+inf) [
  if ( (!((CGDP >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGDP value " << CGDP << " out of range [ 0,  (+inf) [";
  }

//    Parameter CDSP : [ 0,  (+inf) [
  if ( (!((CDSP >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSP value " << CDSP << " out of range [ 0,  (+inf) [";
  }

//    Parameter NRS : [ 0,  (+inf) [
  if ( (!((NRS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NRS value " << NRS << " out of range [ 0,  (+inf) [";
  }

//    Parameter NRD : [ 0,  (+inf) [
  if ( (!((NRD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NRD value " << NRD << " out of range [ 0,  (+inf) [";
  }

//    Parameter LRSD : ] 0,  (+inf) [
  if ( (!((LRSD >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter LRSD value " << LRSD << " out of range ] 0,  (+inf) [";
  }

//    Parameter U0MULT : [ 0,  (+inf) [
  if ( (!((U0MULT >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter U0MULT value " << U0MULT << " out of range [ 0,  (+inf) [";
  }

//    Parameter IDS0MULT : [ 0,  (+inf) [
  if ( (!((IDS0MULT >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter IDS0MULT value " << IDS0MULT << " out of range [ 0,  (+inf) [";
  }

//    Parameter DEVTYPE : [ 0, 1 ]
  if ( (!((DEVTYPE >=0 && DEVTYPE <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter DEVTYPE value " << DEVTYPE << " out of range [ 0, 1 ]";
  }

//    Parameter BULKMOD : [ 0, 1 ]
  if ( (!((BULKMOD >=0 && BULKMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter BULKMOD value " << BULKMOD << " out of range [ 0, 1 ]";
  }

//    Parameter COREMOD : [ 0, 1 ]
  if ( (!((COREMOD >=0 && COREMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter COREMOD value " << COREMOD << " out of range [ 0, 1 ]";
  }

//    Parameter GEOMOD : [ 0, 3 ]
  if ( (!((GEOMOD >=0 && GEOMOD <=3 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter GEOMOD value " << GEOMOD << " out of range [ 0, 3 ]";
  }

//    Parameter CGEO1SW : [ 0, 1 ]
  if ( (!((CGEO1SW >=0 && CGEO1SW <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGEO1SW value " << CGEO1SW << " out of range [ 0, 1 ]";
  }

//    Parameter RDSMOD : [ 0, 1 ]
  if ( (!((RDSMOD >=0 && RDSMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RDSMOD value " << RDSMOD << " out of range [ 0, 1 ]";
  }

//    Parameter ASYMMOD : [ 0, 1 ]
  if ( (!((ASYMMOD >=0 && ASYMMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ASYMMOD value " << ASYMMOD << " out of range [ 0, 1 ]";
  }

//    Parameter IGCMOD : [ 0, 1 ]
  if ( (!((IGCMOD >=0 && IGCMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter IGCMOD value " << IGCMOD << " out of range [ 0, 1 ]";
  }

//    Parameter IGBMOD : [ 0, 1 ]
  if ( (!((IGBMOD >=0 && IGBMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter IGBMOD value " << IGBMOD << " out of range [ 0, 1 ]";
  }

//    Parameter GIDLMOD : [ 0, 1 ]
  if ( (!((GIDLMOD >=0 && GIDLMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter GIDLMOD value " << GIDLMOD << " out of range [ 0, 1 ]";
  }

//    Parameter IIMOD : [ 0, 2 ]
  if ( (!((IIMOD >=0 && IIMOD <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter IIMOD value " << IIMOD << " out of range [ 0, 2 ]";
  }

//    Parameter NQSMOD : [ 0, 2 ]
  if ( (!((NQSMOD >=0 && NQSMOD <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NQSMOD value " << NQSMOD << " out of range [ 0, 2 ]";
  }

//    Parameter SHMOD : [ 0, 1 ]
  if ( (!((SHMOD >=0 && SHMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SHMOD value " << SHMOD << " out of range [ 0, 1 ]";
  }

//    Parameter RGATEMOD : [ 0, 1 ]
  if ( (!((RGATEMOD >=0 && RGATEMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RGATEMOD value " << RGATEMOD << " out of range [ 0, 1 ]";
  }

//    Parameter RGEOMOD : [ 0, 1 ]
  if ( (!((RGEOMOD >=0 && RGEOMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RGEOMOD value " << RGEOMOD << " out of range [ 0, 1 ]";
  }

//    Parameter CGEOMOD : [ 0, 2 ]
  if ( (!((CGEOMOD >=0 && CGEOMOD <=2 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGEOMOD value " << CGEOMOD << " out of range [ 0, 2 ]";
  }

//    Parameter CAPMOD : [ 0, 1 ]
  if ( (!((CAPMOD >=0 && CAPMOD <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CAPMOD value " << CAPMOD << " out of range [ 0, 1 ]";
  }

//    Parameter EOT : [ 0.1*1.0e-9,  (+inf) [
  if ( (!((EOT >=0.1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter EOT value " << EOT << " out of range [ 0.1*1.0e-9,  (+inf) [";
  }

//    Parameter TOXP : [ 0.1*1.0e-9,  (+inf) [
  if ( (!((TOXP >=0.1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter TOXP value " << TOXP << " out of range [ 0.1*1.0e-9,  (+inf) [";
  }

//    Parameter EOTBOX : [ 1*1.0e-9,  (+inf) [
  if ( (!((EOTBOX >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter EOTBOX value " << EOTBOX << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter HFIN : [ 1*1.0e-9,  (+inf) [
  if ( (!((HFIN >=1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter HFIN value " << HFIN << " out of range [ 1*1.0e-9,  (+inf) [";
  }

//    Parameter FECH : [ 0,  (+inf) [
  if ( (!((FECH >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter FECH value " << FECH << " out of range [ 0,  (+inf) [";
  }

//    Parameter FECHCV : [ 0,  (+inf) [
  if ( (!((FECHCV >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter FECHCV value " << FECHCV << " out of range [ 0,  (+inf) [";
  }

//    Parameter NBODY : [ 1e18, 5e24 ]
  if ( (!((NBODY >=1e18 && NBODY <=5e24 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NBODY value " << NBODY << " out of range [ 1e18, 5e24 ]";
  }

//    Parameter NBODYN1 : [ (-0.08),  (+inf) [
  if ( (!((NBODYN1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NBODYN1 value " << NBODYN1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter NBODYN2 : [ 1.0e-5,  (+inf) [
  if ( (!((NBODYN2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NBODYN2 value " << NBODYN2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter NSD : [ 2e25, 1e27 ]
  if ( (!((NSD >=2e25 && NSD <=1e27 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NSD value " << NSD << " out of range [ 2e25, 1e27 ]";
  }

//    Parameter PHIG : [ 0,  (+inf) [
  if ( (!((PHIG >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PHIG value " << PHIG << " out of range [ 0,  (+inf) [";
  }

//    Parameter PHIGN1 : [ (-0.08),  (+inf) [
  if ( (!((PHIGN1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PHIGN1 value " << PHIGN1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter PHIGN2 : [ 1.0e-5,  (+inf) [
  if ( (!((PHIGN2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PHIGN2 value " << PHIGN2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter EPSROX : [ 1,  (+inf) [
  if ( (!((EPSROX >=1))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter EPSROX value " << EPSROX << " out of range [ 1,  (+inf) [";
  }

//    Parameter EPSRSUB : [ 1,  (+inf) [
  if ( (!((EPSRSUB >=1))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter EPSRSUB value " << EPSRSUB << " out of range [ 1,  (+inf) [";
  }

//    Parameter EASUB : [ 0,  (+inf) [
  if ( (!((EASUB >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter EASUB value " << EASUB << " out of range [ 0,  (+inf) [";
  }

//    Parameter CDSCN1 : [ (-0.08),  (+inf) [
  if ( (!((CDSCN1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSCN1 value " << CDSCN1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter CDSCN2 : [ 1.0e-5,  (+inf) [
  if ( (!((CDSCN2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSCN2 value " << CDSCN2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter CDSCDN1 : [ (-0.08),  (+inf) [
  if ( (!((CDSCDN1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSCDN1 value " << CDSCDN1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter CDSCDN2 : [ 1.0e-5,  (+inf) [
  if ( (!((CDSCDN2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSCDN2 value " << CDSCDN2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter CDSCDRN1 : [ (-0.08),  (+inf) [
  if ( (!((CDSCDRN1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSCDRN1 value " << CDSCDRN1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter CDSCDRN2 : [ 1.0e-5,  (+inf) [
  if ( (!((CDSCDRN2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CDSCDRN2 value " << CDSCDRN2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter ETA0N1 : [ (-0.08),  (+inf) [
  if ( (!((ETA0N1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ETA0N1 value " << ETA0N1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter ETA0N2 : [ 1.0e-5,  (+inf) [
  if ( (!((ETA0N2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ETA0N2 value " << ETA0N2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter VSATN1 : [ (-0.08),  (+inf) [
  if ( (!((VSATN1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter VSATN1 value " << VSATN1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter VSATN2 : [ 1.0e-5,  (+inf) [
  if ( (!((VSATN2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter VSATN2 value " << VSATN2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter VSAT1N1 : [ (-0.08),  (+inf) [
  if ( (!((VSAT1N1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter VSAT1N1 value " << VSAT1N1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter VSAT1N2 : [ 1.0e-5,  (+inf) [
  if ( (!((VSAT1N2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter VSAT1N2 value " << VSAT1N2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter VSAT1RN1 : [ (-0.08),  (+inf) [
  if ( (!((VSAT1RN1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter VSAT1RN1 value " << VSAT1RN1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter VSAT1RN2 : [ 1.0e-5,  (+inf) [
  if ( (!((VSAT1RN2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter VSAT1RN2 value " << VSAT1RN2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter U0N1 : [ (-0.08),  (+inf) [
  if ( (!((U0N1 >=(-0.08)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter U0N1 value " << U0N1 << " out of range [ (-0.08),  (+inf) [";
  }

//    Parameter U0N2 : [ 1.0e-5,  (+inf) [
  if ( (!((U0N2 >=1.0e-5))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter U0N2 value " << U0N2 << " out of range [ 1.0e-5,  (+inf) [";
  }

//    Parameter CHARGEWF : [ (-1), 1 ]
  if ( (!((CHARGEWF >=(-1) && CHARGEWF <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CHARGEWF value " << CHARGEWF << " out of range [ (-1), 1 ]";
  }

//    Parameter RSDR : [ 0,  (+inf) [
  if ( (!((RSDR >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RSDR value " << RSDR << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSDRR : [ 0,  (+inf) [
  if ( (!((RSDRR >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RSDRR value " << RSDRR << " out of range [ 0,  (+inf) [";
  }

//    Parameter RDDR : [ 0,  (+inf) [
  if ( (!((RDDR >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RDDR value " << RDDR << " out of range [ 0,  (+inf) [";
  }

//    Parameter RDDRR : [ 0,  (+inf) [
  if ( (!((RDDRR >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RDDRR value " << RDDRR << " out of range [ 0,  (+inf) [";
  }

//    Parameter RGEXT : [ 0,  (+inf) [
  if ( (!((RGEXT >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RGEXT value " << RGEXT << " out of range [ 0,  (+inf) [";
  }

//    Parameter RGFIN : [ 1.0e-3,  (+inf) [
  if ( (!((RGFIN >=1.0e-3))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RGFIN value " << RGFIN << " out of range [ 1.0e-3,  (+inf) [";
  }

//    Parameter RHOC : [ 1.0e-18, 1.0e-9 ]
  if ( (!((RHOC >=1.0e-18 && RHOC <=1.0e-9 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RHOC value " << RHOC << " out of range [ 1.0e-18, 1.0e-9 ]";
  }

//    Parameter RHORSD : ] 0,  (+inf) [
  if ( (!((RHORSD >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RHORSD value " << RHORSD << " out of range ] 0,  (+inf) [";
  }

//    Parameter CRATIO : [ 0, 1 ]
  if ( (!((CRATIO >=0 && CRATIO <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CRATIO value " << CRATIO << " out of range [ 0, 1 ]";
  }

//    Parameter DELTAPRSD : ] (-FPITCH),  (+inf) [
  if ( (!((DELTAPRSD >(-FPITCH)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter DELTAPRSD value " << DELTAPRSD << " out of range ] (-FPITCH),  (+inf) [";
  }

//    Parameter SDTERM : [ 0, 1 ]
  if ( (!((SDTERM >=0 && SDTERM <=1 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SDTERM value " << SDTERM << " out of range [ 0, 1 ]";
  }

//    Parameter LSP : ] 0,  (+inf) [
  if ( (!((LSP >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter LSP value " << LSP << " out of range ] 0,  (+inf) [";
  }

//    Parameter EPSRSP : [ 1,  (+inf) [
  if ( (!((EPSRSP >=1))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter EPSRSP value " << EPSRSP << " out of range [ 1,  (+inf) [";
  }

//    Parameter TGATE : ] 0,  (+inf) [
  if ( (!((TGATE >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter TGATE value " << TGATE << " out of range ] 0,  (+inf) [";
  }

//    Parameter TMASK : [ 0,  (+inf) [
  if ( (!((TMASK >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter TMASK value " << TMASK << " out of range [ 0,  (+inf) [";
  }

//    Parameter ASILIEND : [ 0,  (+inf) [
  if ( (!((ASILIEND >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ASILIEND value " << ASILIEND << " out of range [ 0,  (+inf) [";
  }

//    Parameter ARSDEND : [ 0,  (+inf) [
  if ( (!((ARSDEND >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter ARSDEND value " << ARSDEND << " out of range [ 0,  (+inf) [";
  }

//    Parameter PRSDEND : [ 0,  (+inf) [
  if ( (!((PRSDEND >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter PRSDEND value " << PRSDEND << " out of range [ 0,  (+inf) [";
  }

//    Parameter NSDE : [ 1e25, 1e26 ]
  if ( (!((NSDE >=1e25 && NSDE <=1e26 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NSDE value " << NSDE << " out of range [ 1e25, 1e26 ]";
  }

//    Parameter CGEOE : [ 0,  (+inf) [
  if ( (!((CGEOE >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGEOE value " << CGEOE << " out of range [ 0,  (+inf) [";
  }

//    Parameter TOXREF : ] 0,  (+inf) [
  if ( (!((TOXREF >0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter TOXREF value " << TOXREF << " out of range ] 0,  (+inf) [";
  }

//    Parameter EOTACC : [ 0.1*1.0e-9,  (+inf) [
  if ( (!((EOTACC >=0.1*1.0e-9))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter EOTACC value " << EOTACC << " out of range [ 0.1*1.0e-9,  (+inf) [";
  }

//    Parameter CFS : [ 0,  (+inf) [
  if ( (!((CFS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CFS value " << CFS << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFD : [ 0,  (+inf) [
  if ( (!((CFD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CFD value " << CFD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGSO : [ 0,  (+inf) [
  if ( (!((CGSO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGSO value " << CGSO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGDO : [ 0,  (+inf) [
  if ( (!((CGDO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGDO value " << CGDO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGSL : [ 0,  (+inf) [
  if ( (!((CGSL >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGSL value " << CGSL << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGDL : [ 0,  (+inf) [
  if ( (!((CGDL >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGDL value " << CGDL << " out of range [ 0,  (+inf) [";
  }

//    Parameter CKAPPAS : [ 0.02,  (+inf) [
  if ( (!((CKAPPAS >=0.02))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CKAPPAS value " << CKAPPAS << " out of range [ 0.02,  (+inf) [";
  }

//    Parameter CKAPPAD : [ 0.02,  (+inf) [
  if ( (!((CKAPPAD >=0.02))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CKAPPAD value " << CKAPPAD << " out of range [ 0.02,  (+inf) [";
  }

//    Parameter CGBO : [ 0,  (+inf) [
  if ( (!((CGBO >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGBO value " << CGBO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGBN : [ 0,  (+inf) [
  if ( (!((CGBN >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGBN value " << CGBN << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGBL : [ 0,  (+inf) [
  if ( (!((CGBL >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CGBL value " << CGBL << " out of range [ 0,  (+inf) [";
  }

//    Parameter CKAPPAB : [ 0.02,  (+inf) [
  if ( (!((CKAPPAB >=0.02))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CKAPPAB value " << CKAPPAB << " out of range [ 0.02,  (+inf) [";
  }

//    Parameter CSDESW : [ 0,  (+inf) [
  if ( (!((CSDESW >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CSDESW value " << CSDESW << " out of range [ 0,  (+inf) [";
  }

//    Parameter SJS : [ 0,  (+inf) [
  if ( (!((SJS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SJS value " << SJS << " out of range [ 0,  (+inf) [";
  }

//    Parameter SJD : [ 0,  (+inf) [
  if ( (!((SJD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SJD value " << SJD << " out of range [ 0,  (+inf) [";
  }

//    Parameter SJSWS : [ 0,  (+inf) [
  if ( (!((SJSWS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SJSWS value " << SJSWS << " out of range [ 0,  (+inf) [";
  }

//    Parameter SJSWD : [ 0,  (+inf) [
  if ( (!((SJSWD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SJSWD value " << SJSWD << " out of range [ 0,  (+inf) [";
  }

//    Parameter SJSWGS : [ 0,  (+inf) [
  if ( (!((SJSWGS >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SJSWGS value " << SJSWGS << " out of range [ 0,  (+inf) [";
  }

//    Parameter SJSWGD : [ 0,  (+inf) [
  if ( (!((SJSWGD >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter SJSWGD value " << SJSWGD << " out of range [ 0,  (+inf) [";
  }

//    Parameter NSEG : [ 4, 10 ]
  if ( (!((NSEG >=4 && NSEG <=10 ))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NSEG value " << NSEG << " out of range [ 4, 10 ]";
  }

//    Parameter NTNOI : [ 0,  (+inf) [
  if ( (!((NTNOI >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NTNOI value " << NTNOI << " out of range [ 0,  (+inf) [";
  }

//    Parameter TNOM : [ (-273.15),  (+inf) [
  if ( (!((TNOM >=(-273.15)))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter TNOM value " << TNOM << " out of range [ (-273.15),  (+inf) [";
  }

//    Parameter RTH0 : [ 0,  (+inf) [
  if ( (!((RTH0 >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter RTH0 value " << RTH0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTH0 : [ 0,  (+inf) [
  if ( (!((CTH0 >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter CTH0 value " << CTH0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter WTH0 : [ 0,  (+inf) [
  if ( (!((WTH0 >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter WTH0 value " << WTH0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter LMIN : [ 0,  (+inf) [
  if ( (!((LMIN >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter LMIN value " << LMIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter LMAX : [ 0,  (+inf) [
  if ( (!((LMAX >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter LMAX value " << LMAX << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFINMIN : [ 0,  (+inf) [
  if ( (!((NFINMIN >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NFINMIN value " << NFINMIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFINMAX : [ 0,  (+inf) [
  if ( (!((NFINMAX >=0))) )
  {
    UserWarning(*this) << "ADMSbsimcmg: Parameter NFINMAX value " << NFINMAX << " out of range [ 0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    L(30*1.0e-9),
    D(40*1.0e-9),
    TFIN(15*1.0e-9),
    FPITCH(80*1.0e-9),
    NF(1),
    NFIN(1.0),
    NGCON(1),
    ASEO(0),
    ADEO(0),
    PSEO(0),
    PDEO(0),
    ASEJ(0),
    ADEJ(0),
    PSEJ(0),
    PDEJ(0),
    COVS(0),
    COVD(0.0),
    CGSP(0.0),
    CGDP(0.0),
    CDSP(0.0),
    NRS(0.0),
    NRD(0.0),
    LRSD(0.0),
    XL(0),
    DTEMP(0),
    DELVTRAND(0),
    U0MULT(1),
    IDS0MULT(1),
    DEVTYPE(1),
    BULKMOD(0),
    COREMOD(0),
    GEOMOD(1),
    CGEO1SW(0),
    RDSMOD(0),
    ASYMMOD(0),
    IGCMOD(0),
    IGBMOD(0),
    GIDLMOD(0),
    IIMOD(0),
    NQSMOD(0),
    SHMOD(0),
    RGATEMOD(0),
    RGEOMOD(0),
    CGEOMOD(0),
    CAPMOD(0),
    LINT(0),
    LL(0),
    LLN(1),
    DLC(0),
    DLCACC(0),
    DLBIN(0),
    LLC(0),
    EOT(1.0*1.0e-9),
    TOXP(1.2*1.0e-9),
    EOTBOX(140*1.0e-9),
    HFIN(30*1.0e-9),
    FECH(1),
    DELTAW(0),
    FECHCV(1),
    DELTAWCV(0),
    NBODY(1e22),
    NBODYN1(0),
    NBODYN2(1.0e5),
    NSD(2e26),
    PHIG(4.61),
    PHIGL(0),
    PHIGN1(0),
    PHIGN2(1.0e5),
    EPSROX(3.9),
    EPSRSUB(11.9),
    EASUB(4.05),
    NI0SUB(1.1e16),
    BG0SUB(1.12),
    NC0SUB(2.86e25),
    NGATE(0.0),
    Imin(1.0E-15),
    CIT(0.0),
    CDSC(7e-3),
    CDSCN1(0),
    CDSCN2(1.0e5),
    CDSCD(7e-3),
    CDSCDN1(0),
    CDSCDN2(1.0e5),
    CDSCDR(0.0),
    CDSCDRN1(0.0),
    CDSCDRN2(0.0),
    DVT0(0.0),
    DVT1(0.60),
    DVT1SS(0.0),
    PHIN(0.05),
    ETA0(0.60),
    ETA0N1(0),
    ETA0N2(1.0e5),
    TETA0(0.0),
    ETA0R(0.0),
    TETA0R(0.0),
    DSUB(1.06),
    DVTP0(0),
    DVTP1(0),
    K1RSCE(0.0),
    LPE0(5.0*1.0e-9),
    DVTSHIFT(0),
    K0(0.0),
    K01(0.0),
    K0SI(1.0),
    K0SI1(0.0),
    K1SI(0.0),
    K1SI1(0.0),
    PHIBE(0.7),
    K1(0.0),
    K11(0.0),
    K1SAT(0.0),
    K1SAT1(0.0),
    QMFACTOR(0.0),
    QMTCENIV(0.0),
    QMTCENCV(0.0),
    QMTCENCVA(0.0),
    AQMTCEN(0.0),
    BQMTCEN(12.0e-9),
    ETAQM(0.54),
    QM0(1.00e-3),
    PQM(0.66),
    QM0ACC(1.00e-3),
    PQMACC(0.66),
    VSAT(85000),
    VSATN1(0),
    VSATN2(1.0e5),
    AVSAT(0.0),
    BVSAT(100.0e-9),
    VSAT1(0.0),
    VSAT1N1(0.0),
    VSAT1N2(0.0),
    VSAT1R(0.0),
    VSAT1RN1(0.0),
    VSAT1RN2(0.0),
    AVSAT1(0.0),
    BVSAT1(0.0),
    DELTAVSAT(1.0),
    PSAT(2.0),
    APSAT(0.0),
    BPSAT(1.0),
    KSATIV(1.0),
    VSATCV(0.0),
    AVSATCV(0.0),
    BVSATCV(0.0),
    DELTAVSATCV(0.0),
    PSATCV(0.0),
    APSATCV(0.0),
    BPSATCV(0.0),
    MEXP(4.0),
    AMEXP(0.0),
    BMEXP(1.0),
    MEXPR(0.0),
    AMEXPR(0.0),
    BMEXPR(0.0),
    PTWG(0.0),
    PTWGR(0.0),
    APTWG(0.0),
    BPTWG(100.0e-9),
    AT((-1.56e-3)),
    TMEXP(0.0),
    TMEXPR(0.0),
    PTWGT(0.004),
    U0(0.03),
    U0N1(0),
    U0N2(1.0e5),
    ETAMOB(2.0),
    UP(0),
    LPA(1.0),
    UA(0.3),
    AUA(0.0),
    BUA(100.0e-9),
    UC(0.0),
    EU(2.5),
    AEU(0.0),
    BEU(100.0e-9),
    UD(0.0),
    AUD(0.0),
    BUD(50.0e-9),
    UCS(1.0),
    UTE(0.0),
    UTL((-1.5e-3)),
    EMOBT(0.0),
    UA1(1.032e-3),
    UC1(0.056e-9),
    UD1(0.0),
    UCSTE((-4.775e-3)),
    CHARGEWF(0),
    RDSWMIN(0.0),
    RDSW(100.0),
    ARDSW(0.0),
    BRDSW(100.0e-9),
    RSWMIN(0.0),
    RSW(50.0),
    ARSW(0.0),
    BRSW(100.0e-9),
    RDWMIN(0.0),
    RDW(50.0),
    ARDW(0.0),
    BRDW(100.0e-9),
    RSDR(0.0),
    RSDRR(0.0),
    RDDR(0.0),
    RDDRR(0.0),
    PRSDR(1.0),
    PRDDR(0.0),
    PRWGS(0.0),
    PRWGD(0.0),
    WR(1.0),
    PRT(0.001),
    TRSDR(0.0),
    TRDDR(0.0),
    PDIBL1(1.30),
    PDIBL1R(0.0),
    PDIBL2(2.0e-4),
    DROUT(1.06),
    PVAG(1.0),
    PCLM(0.013),
    APCLM(0.0),
    BPCLM(100.0e-9),
    PCLMG(0.0),
    PCLMCV(0.0),
    A1(0.0),
    A11(0.0),
    A2(0.0),
    A21(0.0),
    RGEXT(0.0),
    RGFIN(1.0e-3),
    RSHS(0.0),
    RSHD(0.0),
    HEPI(10.0*1.0e-9),
    TSILI(10.0*1.0e-9),
    RHOC(1.0e-12),
    RHORSD(1.0),
    CRATIO(0.5),
    DELTAPRSD(0.0),
    SDTERM(0),
    LSP(0.0),
    EPSRSP(3.9),
    TGATE(30.0*1.0e-9),
    TMASK(30.0*1.0e-9),
    ASILIEND(0.0),
    ARSDEND(0.0),
    PRSDEND(0.0),
    NSDE(2e25),
    RGEOA(1.0),
    RGEOB(0.0),
    RGEOC(0.0),
    RGEOD(0.0),
    RGEOE(0.0),
    CGEOA(1.0),
    CGEOB(0.0),
    CGEOC(0.0),
    CGEOD(0.0),
    CGEOE(1.0),
    AIGBINV(1.11e-2),
    AIGBINV1(0),
    BIGBINV(9.49e-4),
    CIGBINV(6.00e-3),
    EIGBINV(1.1),
    NIGBINV(3.0),
    AIGBACC(1.36e-2),
    AIGBACC1(0),
    BIGBACC(1.71e-3),
    CIGBACC(7.5e-2),
    NIGBACC(1.0),
    AIGC(1.36e-2),
    AIGC1(0),
    BIGC(1.71e-3),
    CIGC(0.075),
    PIGCD(1.0),
    DLCIGS(0),
    AIGS(1.36e-2),
    AIGS1(0),
    BIGS(1.71e-3),
    CIGS(0.075),
    DLCIGD(0.0),
    AIGD(0.0),
    AIGD1(0.0),
    BIGD(0.0),
    CIGD(0.0),
    TOXREF(1.2*1.0e-9),
    TOXG(0.0),
    NTOX(1.0),
    POXEDGE(1.0),
    AGISL(6.055*1.0e-12),
    BGISL(0.3e9),
    CGISL(0.5),
    EGISL(0.2),
    PGISL(1.0),
    AGIDL(0.0),
    BGIDL(0.0),
    CGIDL(0.0),
    EGIDL(0.0),
    PGIDL(0.0),
    ALPHA0(0.0),
    ALPHA01(0.0),
    ALPHA1(0.0),
    ALPHA11(0.0),
    BETA0(0.0),
    ALPHAII0(0.0),
    ALPHAII01(0.0),
    ALPHAII1(0.0),
    ALPHAII11(0.0),
    BETAII0(0.0),
    BETAII1(0.0),
    BETAII2(0.1),
    ESATII(1.0e7),
    LII(0.5E-9),
    SII0(0.5),
    SII1(0.1),
    SII2(0.0),
    SIID(0.0),
    EOTACC(0.0),
    DELVFBACC(0.0),
    CFS(2.5e-11),
    CFD(0.0),
    CGSO(0.0),
    CGDO(0.0),
    CGSL(0.0),
    CGDL(0.0),
    CKAPPAS(0.6),
    CKAPPAD(0.0),
    CGBO(0.0),
    CGBN(0.0),
    CGBL(0.0),
    CKAPPAB(0.6),
    CSDESW(0.0),
    CJS(5.0e-4),
    CJD(0.0),
    CJSWS(5.0e-10),
    CJSWD(0.0),
    CJSWGS(0.0),
    CJSWGD(0.0),
    PBS(1.0),
    PBD(0.0),
    PBSWS(1.0),
    PBSWD(0.0),
    PBSWGS(0.0),
    PBSWGD(0.0),
    MJS(0.5),
    MJD(0.0),
    MJSWS(0.33),
    MJSWD(0.0),
    MJSWGS(0.0),
    MJSWGD(0.0),
    SJS(0.0),
    SJD(0.0),
    SJSWS(0.0),
    SJSWD(0.0),
    SJSWGS(0.0),
    SJSWGD(0.0),
    MJS2(0.125),
    MJD2(0.0),
    MJSWS2(0.083),
    MJSWD2(0.0),
    MJSWGS2(0.0),
    MJSWGD2(0.0),
    JSS(1.0e-4),
    JSD(0.0),
    JSWS(0.0),
    JSWD(0.0),
    JSWGS(0.0),
    JSWGD(0.0),
    NJS(1.0),
    NJD(0.0),
    IJTHSFWD(0.1),
    IJTHDFWD(0.0),
    IJTHSREV(0.1),
    IJTHDREV(0.0),
    BVS(10.0),
    BVD(0.0),
    XJBVS(1.0),
    XJBVD(0.0),
    JTSS(0.0),
    JTSD(0.0),
    JTSSWS(0.0),
    JTSSWD(0.0),
    JTSSWGS(0.0),
    JTSSWGD(0.0),
    JTWEFF(0.0),
    NJTS(20.0),
    NJTSD(0.0),
    NJTSSW(20.0),
    NJTSSWD(0.0),
    NJTSSWG(20.0),
    NJTSSWGD(0.0),
    VTSS(10.0),
    VTSD(0.0),
    VTSSWS(10.0),
    VTSSWD(0.0),
    VTSSWGS(10.0),
    VTSSWGD(0.0),
    LINTIGEN(0),
    NTGEN(1.0),
    AIGEN(0),
    BIGEN(0),
    XRCRG1(12.0),
    XRCRG2(1.0),
    NSEG(4),
    EF(1.0),
    EM(4.1e7),
    NOIA(6.250e+39),
    NOIB(3.125e+24),
    NOIC(8.750e+07),
    NTNOI(1.0),
    TNOM(27.0),
    TBGASUB(7.02e-4),
    TBGBSUB(1108.0),
    KT1(0.0),
    KT1L(0.0),
    TSS(0.0),
    IIT((-0.5)),
    TII(0.0),
    TGIDL((-0.003)),
    IGT(2.5),
    TCJ(0.0),
    TCJSW(0.0),
    TCJSWG(0.0),
    TPB(0.0),
    TPBSW(0.0),
    TPBSWG(0.0),
    XTIS(3.0),
    XTID(0.0),
    XTSS(0.02),
    XTSD(0.0),
    XTSSWS(0.02),
    XTSSWD(0.0),
    XTSSWGS(0.02),
    XTSSWGD(0.0),
    TNJTS(0.0),
    TNJTSD(0.0),
    TNJTSSW(0.0),
    TNJTSSWD(0.0),
    TNJTSSWG(0.0),
    TNJTSSWGD(0.0),
    RTH0(0.01),
    CTH0(1.0E-05),
    WTH0(0.0),
    LMIN(0),
    LMAX(100),
    NFINMIN(0),
    NFINMAX(100),
    LNBODY(0),
    NNBODY(0),
    PNBODY(0),
    LPHIG(0),
    NPHIG(0),
    PPHIG(0),
    LNGATE(0),
    NNGATE(0),
    PNGATE(0),
    LCIT(0),
    NCIT(0),
    PCIT(0),
    LCDSC(0),
    NCDSC(0),
    PCDSC(0),
    LCDSCD(0),
    NCDSCD(0),
    PCDSCD(0),
    LCDSCDR(0.0),
    NCDSCDR(0.0),
    PCDSCDR(0.0),
    LDVT0(0),
    NDVT0(0),
    PDVT0(0),
    LDVT1(0),
    NDVT1(0),
    PDVT1(0),
    LDVT1SS(0),
    NDVT1SS(0),
    PDVT1SS(0),
    LPHIN(0),
    NPHIN(0),
    PPHIN(0),
    LETA0(0),
    NETA0(0),
    PETA0(0),
    LETA0R(0.0),
    NETA0R(0.0),
    PETA0R(0.0),
    LDSUB(0),
    NDSUB(0),
    PDSUB(0),
    LK1RSCE(0),
    NK1RSCE(0),
    PK1RSCE(0),
    LLPE0(0),
    NLPE0(0),
    PLPE0(0),
    LDVTSHIFT(0),
    NDVTSHIFT(0),
    PDVTSHIFT(0),
    LPHIBE(0),
    NPHIBE(0),
    PPHIBE(0),
    LK0(0),
    NK0(0),
    PK0(0),
    LK01(0),
    NK01(0),
    PK01(0),
    LK0SI(0),
    NK0SI(0),
    PK0SI(0),
    LK0SI1(0),
    NK0SI1(0),
    PK0SI1(0),
    LK1SI(0),
    NK1SI(0),
    PK1SI(0),
    LK1SI1(0),
    NK1SI1(0),
    PK1SI1(0),
    LK1(0),
    NK1(0),
    PK1(0),
    LK11(0),
    NK11(0),
    PK11(0),
    LK1SAT(0),
    NK1SAT(0),
    PK1SAT(0),
    LK1SAT1(0),
    NK1SAT1(0),
    PK1SAT1(0),
    LDVTB(0),
    NDVTB(0),
    PDVTB(0),
    LLPEB(0),
    NLPEB(0),
    PLPEB(0),
    LQMFACTOR(0.0),
    NQMFACTOR(0.0),
    PQMFACTOR(0.0),
    LQMTCENIV(0.0),
    NQMTCENIV(0.0),
    PQMTCENIV(0.0),
    LQMTCENCV(0.0),
    NQMTCENCV(0.0),
    PQMTCENCV(0.0),
    LQMTCENCVA(0.0),
    NQMTCENCVA(0.0),
    PQMTCENCVA(0.0),
    LVSAT(0),
    NVSAT(0),
    PVSAT(0),
    LVSAT1(0.0),
    NVSAT1(0.0),
    PVSAT1(0.0),
    LVSAT1R(0.0),
    NVSAT1R(0.0),
    PVSAT1R(0.0),
    LPSAT(0),
    NPSAT(0),
    PPSAT(0),
    LDELTAVSAT(0),
    NDELTAVSAT(0),
    PDELTAVSAT(0),
    LKSATIV(0),
    NKSATIV(0),
    PKSATIV(0),
    LVSATCV(0),
    NVSATCV(0),
    PVSATCV(0),
    LPSATCV(0),
    NPSATCV(0),
    PPSATCV(0),
    LDELTAVSATCV(0),
    NDELTAVSATCV(0),
    PDELTAVSATCV(0),
    LMEXP(0),
    NMEXP(0),
    PMEXP(0),
    LMEXPR(0),
    NMEXPR(0),
    PMEXPR(0),
    LPTWG(0.0),
    NPTWG(0.0),
    PPTWG(0.0),
    LPTWGR(0.0),
    NPTWGR(0.0),
    PPTWGR(0.0),
    LU0(0),
    NU0(0),
    PU0(0),
    LETAMOB(0),
    NETAMOB(0),
    PETAMOB(0),
    LUP(0),
    NUP(0),
    PUP(0),
    LUA(0),
    NUA(0),
    PUA(0),
    LUC(0),
    NUC(0),
    PUC(0),
    LEU(0),
    NEU(0),
    PEU(0),
    LUD(0),
    NUD(0),
    PUD(0),
    LUCS(0),
    NUCS(0),
    PUCS(0),
    LPCLM(0),
    NPCLM(0),
    PPCLM(0),
    LPCLMG(0),
    NPCLMG(0),
    PPCLMG(0),
    LPCLMCV(0),
    NPCLMCV(0),
    PPCLMCV(0),
    LA1(0),
    NA1(0),
    PA1(0),
    LA11(0),
    NA11(0),
    PA11(0),
    LA2(0),
    NA2(0),
    PA2(0),
    LA21(0),
    NA21(0),
    PA21(0),
    LRDSW(0),
    NRDSW(0),
    PRDSW(0),
    LRSW(0.0),
    NRSW(0.0),
    PRSW(0.0),
    LRDW(0.0),
    NRDW(0.0),
    PRDW(0.0),
    LPRWGS(0),
    NPRWGS(0),
    PPRWGS(0),
    LPRWGD(0),
    NPRWGD(0),
    PPRWGD(0),
    LWR(0),
    NWR(0),
    PWR(0),
    LPDIBL1(0),
    NPDIBL1(0),
    PPDIBL1(0),
    LPDIBL1R(0.0),
    NPDIBL1R(0.0),
    PPDIBL1R(0.0),
    LPDIBL2(0),
    NPDIBL2(0),
    PPDIBL2(0),
    LDROUT(0),
    NDROUT(0),
    PDROUT(0),
    LPVAG(0),
    NPVAG(0),
    PPVAG(0),
    LAIGBINV(0),
    NAIGBINV(0),
    PAIGBINV(0),
    LAIGBINV1(0),
    NAIGBINV1(0),
    PAIGBINV1(0),
    LBIGBINV(0),
    NBIGBINV(0),
    PBIGBINV(0),
    LCIGBINV(0),
    NCIGBINV(0),
    PCIGBINV(0),
    LEIGBINV(0),
    NEIGBINV(0),
    PEIGBINV(0),
    LNIGBINV(0),
    NNIGBINV(0),
    PNIGBINV(0),
    LAIGBACC(0),
    NAIGBACC(0),
    PAIGBACC(0),
    LAIGBACC1(0),
    NAIGBACC1(0),
    PAIGBACC1(0),
    LBIGBACC(0),
    NBIGBACC(0),
    PBIGBACC(0),
    LCIGBACC(0),
    NCIGBACC(0),
    PCIGBACC(0),
    LNIGBACC(0),
    NNIGBACC(0),
    PNIGBACC(0),
    LAIGC(0),
    NAIGC(0),
    PAIGC(0),
    LAIGC1(0),
    NAIGC1(0),
    PAIGC1(0),
    LBIGC(0),
    NBIGC(0),
    PBIGC(0),
    LCIGC(0),
    NCIGC(0),
    PCIGC(0),
    LPIGCD(0),
    NPIGCD(0),
    PPIGCD(0),
    LAIGS(0),
    NAIGS(0),
    PAIGS(0),
    LAIGS1(0),
    NAIGS1(0),
    PAIGS1(0),
    LBIGS(0),
    NBIGS(0),
    PBIGS(0),
    LCIGS(0),
    NCIGS(0),
    PCIGS(0),
    LAIGD(0.0),
    NAIGD(0.0),
    PAIGD(0.0),
    LAIGD1(0.0),
    NAIGD1(0.0),
    PAIGD1(0.0),
    LBIGD(0.0),
    NBIGD(0.0),
    PBIGD(0.0),
    LCIGD(0.0),
    NCIGD(0.0),
    PCIGD(0.0),
    LNTOX(0),
    NNTOX(0),
    PNTOX(0),
    LPOXEDGE(0),
    NPOXEDGE(0),
    PPOXEDGE(0),
    LAGISL(0),
    NAGISL(0),
    PAGISL(0),
    LBGISL(0),
    NBGISL(0),
    PBGISL(0),
    LCGISL(0),
    NCGISL(0),
    PCGISL(0),
    LEGISL(0),
    NEGISL(0),
    PEGISL(0),
    LPGISL(0),
    NPGISL(0),
    PPGISL(0),
    LAGIDL(0.0),
    NAGIDL(0.0),
    PAGIDL(0.0),
    LBGIDL(0.0),
    NBGIDL(0.0),
    PBGIDL(0.0),
    LCGIDL(0.0),
    NCGIDL(0.0),
    PCGIDL(0.0),
    LEGIDL(0.0),
    NEGIDL(0.0),
    PEGIDL(0.0),
    LPGIDL(0.0),
    NPGIDL(0.0),
    PPGIDL(0.0),
    LALPHA0(0.0),
    NALPHA0(0.0),
    PALPHA0(0.0),
    LALPHA1(0.0),
    NALPHA1(0.0),
    PALPHA1(0.0),
    LALPHAII0(0.0),
    NALPHAII0(0.0),
    PALPHAII0(0.0),
    LALPHAII1(0.0),
    NALPHAII1(0.0),
    PALPHAII1(0.0),
    LBETA0(0.0),
    NBETA0(0.0),
    PBETA0(0.0),
    LBETAII0(0.0),
    NBETAII0(0.0),
    PBETAII0(0.0),
    LBETAII1(0.0),
    NBETAII1(0.0),
    PBETAII1(0.0),
    LBETAII2(0.0),
    NBETAII2(0.0),
    PBETAII2(0.0),
    LESATII(0.0),
    NESATII(0.0),
    PESATII(0.0),
    LLII(0.0),
    NLII(0.0),
    PLII(0.0),
    LSII0(0.0),
    NSII0(0.0),
    PSII0(0.0),
    LSII1(0.0),
    NSII1(0.0),
    PSII1(0.0),
    LSII2(0.0),
    NSII2(0.0),
    PSII2(0.0),
    LSIID(0.0),
    NSIID(0.0),
    PSIID(0.0),
    LCFS(0.0),
    NCFS(0.0),
    PCFS(0.0),
    LCFD(0.0),
    NCFD(0.0),
    PCFD(0.0),
    LCOVS(0.0),
    NCOVS(0.0),
    PCOVS(0.0),
    LCOVD(0.0),
    NCOVD(0.0),
    PCOVD(0.0),
    LCGSL(0.0),
    NCGSL(0.0),
    PCGSL(0.0),
    LCGDL(0.0),
    NCGDL(0.0),
    PCGDL(0.0),
    LCKAPPAS(0.0),
    NCKAPPAS(0.0),
    PCKAPPAS(0.0),
    LCKAPPAD(0.0),
    NCKAPPAD(0.0),
    PCKAPPAD(0.0),
    LCGBL(0.0),
    NCGBL(0.0),
    PCGBL(0.0),
    LCKAPPAB(0.0),
    NCKAPPAB(0.0),
    PCKAPPAB(0.0),
    LNTGEN(0),
    NNTGEN(0),
    PNTGEN(0),
    LAIGEN(0),
    NAIGEN(0),
    PAIGEN(0),
    LBIGEN(0),
    NBIGEN(0),
    PBIGEN(0),
    LXRCRG1(0.0),
    NXRCRG1(0.0),
    PXRCRG1(0.0),
    LXRCRG2(0.0),
    NXRCRG2(0.0),
    PXRCRG2(0.0),
    LINTNOI(0.0),
    LUTE(0.0),
    NUTE(0.0),
    PUTE(0.0),
    LUTL(0.0),
    NUTL(0.0),
    PUTL(0.0),
    LEMOBT(0),
    NEMOBT(0),
    PEMOBT(0),
    LUA1(0.0),
    NUA1(0.0),
    PUA1(0.0),
    LUC1(0.0),
    NUC1(0.0),
    PUC1(0.0),
    LUD1(0.0),
    NUD1(0.0),
    PUD1(0.0),
    LUCSTE(0.0),
    NUCSTE(0.0),
    PUCSTE(0.0),
    LPTWGT(0),
    NPTWGT(0),
    PPTWGT(0),
    LAT(0),
    NAT(0),
    PAT(0),
    LSTTHETASAT(0),
    NSTTHETASAT(0),
    PSTTHETASAT(0),
    LPRT(0),
    NPRT(0),
    PPRT(0),
    LKT1(0),
    NKT1(0),
    PKT1(0),
    LTSS(0),
    NTSS(0),
    PTSS(0),
    LIIT(0),
    NIIT(0),
    PIIT(0),
    LTII(0.0),
    NTII(0.0),
    PTII(0.0),
    LTGIDL(0),
    NTGIDL(0),
    PTGIDL(0),
    LIGT(0),
    NIGT(0),
    PIGT(0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
      os << "L  =  " << (*iter)->L << std::endl;
      os << "D  =  " << (*iter)->D << std::endl;
      os << "TFIN  =  " << (*iter)->TFIN << std::endl;
      os << "FPITCH  =  " << (*iter)->FPITCH << std::endl;
      os << "NFIN  =  " << (*iter)->NFIN << std::endl;
      os << "NGCON  =  " << (*iter)->NGCON << std::endl;
      os << "ASEO  =  " << (*iter)->ASEO << std::endl;
      os << "ADEO  =  " << (*iter)->ADEO << std::endl;
      os << "PSEO  =  " << (*iter)->PSEO << std::endl;
      os << "PDEO  =  " << (*iter)->PDEO << std::endl;
      os << "ASEJ  =  " << (*iter)->ASEJ << std::endl;
      os << "ADEJ  =  " << (*iter)->ADEJ << std::endl;
      os << "PSEJ  =  " << (*iter)->PSEJ << std::endl;
      os << "PDEJ  =  " << (*iter)->PDEJ << std::endl;
      os << "COVS  =  " << (*iter)->COVS << std::endl;
      os << "COVD  =  " << (*iter)->COVD << std::endl;
      os << "CGSP  =  " << (*iter)->CGSP << std::endl;
      os << "CGDP  =  " << (*iter)->CGDP << std::endl;
      os << "CDSP  =  " << (*iter)->CDSP << std::endl;
      os << "NRS  =  " << (*iter)->NRS << std::endl;
      os << "NRD  =  " << (*iter)->NRD << std::endl;
      os << "LRSD  =  " << (*iter)->LRSD << std::endl;
      os << "DELVTRAND  =  " << (*iter)->DELVTRAND << std::endl;
      os << "U0MULT  =  " << (*iter)->U0MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("M") != deviceMap.end() && (levelSet.find(107)!=levelSet.end()))))
{
MOSFET1::registerDevice();
  Config<Traits>::addConfiguration()
    .registerDevice("m", 107)
    .registerModelType("nmos", 107)
    .registerModelType("pmos", 107);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_si_GND,
const int admsProbeID_V_e_GND,
const int admsProbeID_V_di_GND,
const int admsProbeID_V_g_GND,
const int admsProbeID_V_s_si,
const int admsProbeID_V_d_di,
const int admsProbeID_V_e_g,
const int admsProbeID_V_d_s,
const int admsProbeID_V_g_d,
const int admsProbeID_V_g_s,
const int admsProbeID_V_di_d,
const int admsProbeID_V_si_s,
const int admsProbeID_V_g_e,
const int admsProbeID_V_e_di,
const int admsProbeID_V_e_si,
const int admsProbeID_V_g_di,
const int admsProbeID_V_di_si,
const int admsProbeID_V_g_si,
// node constants
const int admsNodeID_d,
const int admsNodeID_g,
const int admsNodeID_s,
const int admsNodeID_e,
const int admsNodeID_di,
const int admsNodeID_si,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double qith=0.0;
double d_qith_dX=0.0;
  double sid=0.0;
double d_sid_dX=0.0;
  double Swi=0.0;
double d_Swi_dX=0.0;
  double T10=0.0;
double d_T10_dX=0.0;
  double Ssi=0.0;
double d_Ssi_dX=0.0;
  double Nstar=0.0;
double d_Nstar_dX=0.0;
  double Nl=0.0;
double d_Nl_dX=0.0;
  double N0=0.0;
double d_N0_dX=0.0;
  double DelClm=0.0;
double d_DelClm_dX=0.0;
  double Leffnoisq=0.0;
double d_Leffnoisq_dX=0.0;
  double Leffnoi=0.0;
double d_Leffnoi_dX=0.0;
  double Esatnoi=0.0;
double d_Esatnoi_dX=0.0;
  double IdovVds=0.0;
double d_IdovVds_dX=0.0;
  double vge_overlap=0.0;
double d_vge_overlap_dX=0.0;
  double Qedj3=0.0;
double d_Qedj3_dX=0.0;
  double Qedj2=0.0;
double d_Qedj2_dX=0.0;
  double Qedj1=0.0;
double d_Qedj1_dX=0.0;
  double Qesj3=0.0;
double d_Qesj3_dX=0.0;
  double Qesj2=0.0;
double d_Qesj2_dX=0.0;
  double vec=0.0;
double d_vec_dX=0.0;
  double pb2=0.0;
double d_pb2_dX=0.0;
  double Qec=0.0;
double d_Qec_dX=0.0;
  double arg=0.0;
double d_arg_dX=0.0;
  double sarg=0.0;
double d_sarg_dX=0.0;
  double Qesj1=0.0;
double d_Qesj1_dX=0.0;
  double T4a=0.0;
double d_T4a_dX=0.0;
  double T1_exp=0.0;
double d_T1_exp_dX=0.0;
  double Vdseffx=0.0;
double d_Vdseffx_dX=0.0;
  double igc0=0.0;
double d_igc0_dX=0.0;
  double Voxacc=0.0;
double d_Voxacc_dX=0.0;
  double Vaux_Igbacc=0.0;
double d_Vaux_Igbacc_dX=0.0;
  double vfbzb=0.0;
double d_vfbzb_dX=0.0;
  double Vaux_Igbinv=0.0;
double d_Vaux_Igbinv_dX=0.0;
  double ALPHAII=0.0;
double d_ALPHAII_dX=0.0;
  double VgsStep=0.0;
double d_VgsStep_dX=0.0;
  double Vdsatii=0.0;
double d_Vdsatii_dX=0.0;
  double Vdiff=0.0;
double d_Vdiff_dX=0.0;
  double Ratio=0.0;
double d_Ratio_dX=0.0;
  double cgsp=0.0;
double d_cgsp_dX=0.0;
  double cgdp=0.0;
double d_cgdp_dX=0.0;
  double vgd_overlap=0.0;
double d_vgd_overlap_dX=0.0;
  double vgs_overlap=0.0;
double d_vgs_overlap_dX=0.0;
  double qgd_ov=0.0;
double d_qgd_ov_dX=0.0;
  double qgs_ov=0.0;
double d_qgs_ov_dX=0.0;
  double qinv=0.0;
double d_qinv_dX=0.0;
  double inv_MclmCV=0.0;
double d_inv_MclmCV_dX=0.0;
  double dqi_idscv=0.0;
double d_dqi_idscv_dX=0.0;
  double beta_cv=0.0;
double d_beta_cv_dX=0.0;
  double idscv=0.0;
double d_idscv_dX=0.0;
  double Tcom=0.0;
double d_Tcom_dX=0.0;
  double vgd_eff=0.0;
double d_vgd_eff_dX=0.0;
  double vgs_eff=0.0;
double d_vgs_eff_dX=0.0;
  double Dr=0.0;
double d_Dr_dX=0.0;
  double Rdsi=0.0;
double d_Rdsi_dX=0.0;
  double ids0_ov_dqi=0.0;
double d_ids0_ov_dqi_dX=0.0;
  double ids0=0.0;
double d_ids0_dX=0.0;
  double MclmCV=0.0;
double d_MclmCV_dX=0.0;
  double DvsatCV=0.0;
double d_DvsatCV_dX=0.0;
  double EsatCVL=0.0;
double d_EsatCVL_dX=0.0;
  double EsatCV=0.0;
double d_EsatCV_dX=0.0;
  double Mob=0.0;
double d_Mob_dX=0.0;
  double Mnud=0.0;
double d_Mnud_dX=0.0;
  double Nsat=0.0;
double d_Nsat_dX=0.0;
  double Dvsat=0.0;
double d_Dvsat_dX=0.0;
  double Esat1L=0.0;
double d_Esat1L_dX=0.0;
  double Esat1=0.0;
double d_Esat1_dX=0.0;
  double Mclm=0.0;
double d_Mclm_dX=0.0;
  double Moc=0.0;
double d_Moc_dX=0.0;
  double VaDIBL=0.0;
double d_VaDIBL_dX=0.0;
  double Vgst2Vtm=0.0;
double d_Vgst2Vtm_dX=0.0;
  double diffVds=0.0;
double d_diffVds_dX=0.0;
  double PVAGfactor=0.0;
double d_PVAGfactor_dX=0.0;
  double DIBLfactor=0.0;
double d_DIBLfactor_dX=0.0;
  double Dmob_cv=0.0;
double d_Dmob_cv_dX=0.0;
  double Eeffm_cv=0.0;
double d_Eeffm_cv_dX=0.0;
  double ueff=0.0;
double d_ueff_dX=0.0;
  double Dmob=0.0;
double d_Dmob_dX=0.0;
  double Eeffm=0.0;
double d_Eeffm_dX=0.0;
  double beta=0.0;
double d_beta_dX=0.0;
  double coxeff=0.0;
double d_coxeff_dX=0.0;
  double qia2=0.0;
double d_qia2_dX=0.0;
  double dqi=0.0;
double d_dqi_dX=0.0;
  double qia=0.0;
double d_qia_dX=0.0;
  double qba=0.0;
double d_qba_dX=0.0;
  double phid=0.0;
double d_phid_dX=0.0;
  double vpolyd=0.0;
double d_vpolyd_dX=0.0;
  double Vdseff=0.0;
double d_Vdseff_dX=0.0;
  double Vdsat=0.0;
double d_Vdsat_dX=0.0;
  double Tc=0.0;
double d_Tc_dX=0.0;
  double Ta=0.0;
double d_Ta_dX=0.0;
  double WVCox=0.0;
double d_WVCox_dX=0.0;
  double T6=0.0;
double d_T6_dX=0.0;
  double EsatL=0.0;
double d_EsatL_dX=0.0;
  double Esat=0.0;
double d_Esat_dX=0.0;
  double Rdss=0.0;
double d_Rdss_dX=0.0;
  double Dmobs=0.0;
double d_Dmobs_dX=0.0;
  double qb0=0.0;
double d_qb0_dX=0.0;
  double Eeffs=0.0;
double d_Eeffs_dX=0.0;
  double phis=0.0;
double d_phis_dX=0.0;
  double TA=0.0;
double d_TA_dX=0.0;
  double T9=0.0;
double d_T9_dX=0.0;
  double T8=0.0;
double d_T8_dX=0.0;
  double T7=0.0;
double d_T7_dX=0.0;
  double T5=0.0;
double d_T5_dX=0.0;
  double T4=0.0;
double d_T4_dX=0.0;
  double secg0=0.0;
double d_secg0_dX=0.0;
  double cosg0=0.0;
double d_cosg0_dX=0.0;
  double guessB=0.0;
double d_guessB_dX=0.0;
  double guessA=0.0;
double d_guessA_dX=0.0;
  double vpolys=0.0;
double d_vpolys_dX=0.0;
  double vch=0.0;
double d_vch_dX=0.0;
  double tang0a=0.0;
double d_tang0a_dX=0.0;
  double g0a=0.0;
double d_g0a_dX=0.0;
  double e3=0.0;
double d_e3_dX=0.0;
  double e2=0.0;
double d_e2_dX=0.0;
  double e1=0.0;
double d_e1_dX=0.0;
  double e0=0.0;
double d_e0_dX=0.0;
  double inv_g0=0.0;
double d_inv_g0_dX=0.0;
  double lncosg0=0.0;
double d_lncosg0_dX=0.0;
  double secg0sq=0.0;
double d_secg0sq_dX=0.0;
  double lng0=0.0;
double d_lng0_dX=0.0;
  double tang0=0.0;
double d_tang0_dX=0.0;
  double g0=0.0;
double d_g0_dX=0.0;
  double z2=0.0;
double d_z2_dX=0.0;
  double z1=0.0;
double d_z1_dX=0.0;
  double expff=0.0;
double d_expff_dX=0.0;
  double F0=0.0;
double d_F0_dX=0.0;
  double inv_g0sq=0.0;
double d_inv_g0sq_dX=0.0;
  double vgsfbeff=0.0;
double d_vgsfbeff_dX=0.0;
  double cdop=0.0;
double d_cdop_dX=0.0;
  double vtdop_acc=0.0;
double d_vtdop_acc_dX=0.0;
  double vtdop=0.0;
double d_vtdop_dX=0.0;
  double dvth_all=0.0;
double d_dvth_all_dX=0.0;
  double dvth_rsce=0.0;
double d_dvth_rsce_dX=0.0;
  double dvth_dibl=0.0;
double d_dvth_dibl_dX=0.0;
  double dvth_vtroll=0.0;
double d_dvth_vtroll_dX=0.0;
  double nVtm=0.0;
double d_nVtm_dX=0.0;
  double cdsc=0.0;
double d_cdsc_dX=0.0;
  double phist=0.0;
double d_phist_dX=0.0;
  double inv_MEXP=0.0;
double d_inv_MEXP_dX=0.0;
  double RDDR_a=0.0;
double d_RDDR_a_dX=0.0;
  double RSDR_a=0.0;
double d_RSDR_a_dX=0.0;
  double VSAT1_a=0.0;
double d_VSAT1_a_dX=0.0;
  double PTWG_a=0.0;
double d_PTWG_a_dX=0.0;
  double MEXP_a=0.0;
double d_MEXP_a_dX=0.0;
  double PDIBL1_a=0.0;
double d_PDIBL1_a_dX=0.0;
  double ETA0_a=0.0;
double d_ETA0_a_dX=0.0;
  double CDSCD_a=0.0;
double d_CDSCD_a_dX=0.0;
  double wr=0.0;
double d_wr_dX=0.0;
  double wf=0.0;
double d_wf_dX=0.0;
  double veseff=0.0;
double d_veseff_dX=0.0;
  double vesmax=0.0;
double d_vesmax_dX=0.0;
  double vesx=0.0;
  double vdsx=0.0;
  double Qedj=0.0;
double d_Qedj_dX=0.0;
  double Qesj=0.0;
double d_Qesj_dX=0.0;
  double etaiv=0.0;
double d_etaiv_dX=0.0;
  double vgsfb=0.0;
double d_vgsfb_dX=0.0;
  double ves=0.0;
  double vgd=0.0;
  double vds=0.0;
  double vgs=0.0;
  double vge=0.0;
  double ved_jct=0.0;
  double ves_jct=0.0;
  double vgd_noswap=0.0;
  double vds_noswap=0.0;
  double vgs_noswap=0.0;
  double TRatio=0.0;
double d_TRatio_dX=0.0;
  double delTemp=0.0;
double d_delTemp_dX=0.0;
  double Vtm=0.0;
double d_Vtm_dX=0.0;
  double Vtm0=0.0;
double d_Vtm0_dX=0.0;
  double Eg=0.0;
double d_Eg_dX=0.0;
  double Eg0=0.0;
double d_Eg0_dX=0.0;
  double ni=0.0;
double d_ni_dX=0.0;
  double Nc=0.0;
double d_Nc_dX=0.0;
  double ThetaSS=0.0;
double d_ThetaSS_dX=0.0;
  double kT=0.0;
double d_kT_dX=0.0;
  double E0=0.0;
double d_E0_dX=0.0;
  double E0prime=0.0;
double d_E0prime_dX=0.0;
  double E1=0.0;
double d_E1_dX=0.0;
  double E1prime=0.0;
double d_E1prime_dX=0.0;
  double gam0=0.0;
double d_gam0_dX=0.0;
  double gam1=0.0;
double d_gam1_dX=0.0;
  double dvch_qm=0.0;
double d_dvch_qm_dX=0.0;
  double ETA0_t=0.0;
double d_ETA0_t_dX=0.0;
  double ETA0R_t=0.0;
double d_ETA0R_t_dX=0.0;
  double U0_t=0.0;
double d_U0_t_dX=0.0;
  double u0=0.0;
double d_u0_dX=0.0;
  double ETAMOB_t=0.0;
double d_ETAMOB_t_dX=0.0;
  double UA_t=0.0;
double d_UA_t_dX=0.0;
  double UC_t=0.0;
double d_UC_t_dX=0.0;
  double UD_t=0.0;
double d_UD_t_dX=0.0;
  double UCS_t=0.0;
double d_UCS_t_dX=0.0;
  double rdstemp=0.0;
double d_rdstemp_dX=0.0;
  double RSDR_t=0.0;
double d_RSDR_t_dX=0.0;
  double RSDRR_t=0.0;
double d_RSDRR_t_dX=0.0;
  double RDDR_t=0.0;
double d_RDDR_t_dX=0.0;
  double RDDRR_t=0.0;
double d_RDDRR_t_dX=0.0;
  double VSAT_t=0.0;
double d_VSAT_t_dX=0.0;
  double VSAT1_t=0.0;
double d_VSAT1_t_dX=0.0;
  double VSAT1R_t=0.0;
double d_VSAT1R_t_dX=0.0;
  double VSATCV_t=0.0;
double d_VSATCV_t_dX=0.0;
  double MEXP_t=0.0;
double d_MEXP_t_dX=0.0;
  double MEXPR_t=0.0;
double d_MEXPR_t_dX=0.0;
  double PTWG_t=0.0;
double d_PTWG_t_dX=0.0;
  double PTWGR_t=0.0;
double d_PTWGR_t_dX=0.0;
  double dvth_temp=0.0;
double d_dvth_temp_dX=0.0;
  double BETA0_t=0.0;
double d_BETA0_t_dX=0.0;
  double SII0_t=0.0;
double d_SII0_t_dX=0.0;
  double K0_t=0.0;
double d_K0_t_dX=0.0;
  double K0SI_t=0.0;
double d_K0SI_t_dX=0.0;
  double K1SI_t=0.0;
double d_K1SI_t_dX=0.0;
  double K1_t=0.0;
double d_K1_t_dX=0.0;
  double K1SAT_t=0.0;
double d_K1SAT_t_dX=0.0;
  double A1_t=0.0;
double d_A1_t_dX=0.0;
  double A2_t=0.0;
double d_A2_t_dX=0.0;
  double AIGBINV_t=0.0;
double d_AIGBINV_t_dX=0.0;
  double AIGBACC_t=0.0;
double d_AIGBACC_t_dX=0.0;
  double AIGC_t=0.0;
double d_AIGC_t_dX=0.0;
  double AIGS_t=0.0;
double d_AIGS_t_dX=0.0;
  double AIGD_t=0.0;
double d_AIGD_t_dX=0.0;
  double BGIDL_t=0.0;
double d_BGIDL_t_dX=0.0;
  double BGISL_t=0.0;
double d_BGISL_t_dX=0.0;
  double ALPHA0_t=0.0;
double d_ALPHA0_t_dX=0.0;
  double ALPHA1_t=0.0;
double d_ALPHA1_t_dX=0.0;
  double ALPHAII0_t=0.0;
double d_ALPHAII0_t_dX=0.0;
  double ALPHAII1_t=0.0;
double d_ALPHAII1_t_dX=0.0;
  double igtemp=0.0;
double d_igtemp_dX=0.0;
  double igsd_mult=0.0;
double d_igsd_mult_dX=0.0;
  double beta0=0.0;
double d_beta0_dX=0.0;
  double vfbsd=0.0;
double d_vfbsd_dX=0.0;
  double phib=0.0;
double d_phib_dX=0.0;
  double vbi=0.0;
double d_vbi_dX=0.0;
  double deltaPhi=0.0;
double d_deltaPhi_dX=0.0;
  double vpoly0=0.0;
double d_vpoly0_dX=0.0;
  double cpoly=0.0;
double d_cpoly_dX=0.0;
  double kpoly=0.0;
double d_kpoly_dX=0.0;
  double g0max=0.0;
  double g0min=0.0;
  double r2=0.0;
double d_r2_dX=0.0;
  double eta_mu=0.0;
double d_eta_mu_dX=0.0;
  double eta_mu_cv=0.0;
  double Tb=0.0;
double d_Tb_dX=0.0;
  double igentemp=0.0;
double d_igentemp_dX=0.0;
  double DevTemp=0.0;
double d_DevTemp_dX=0.0;
  int initialized=0.0;
  double R=0.0;
double d_R_dX=0.0;
  double vgsfbeff_acc=0.0;
double d_vgsfbeff_acc_dX=0.0;
  double vt0=0.0;
double d_vt0_dX=0.0;
  double vt0_acc=0.0;
double d_vt0_acc_dX=0.0;
  double F1=0.0;
double d_F1_dX=0.0;
  double F1_acc=0.0;
double d_F1_acc_dX=0.0;
  double cdop_acc=0.0;
double d_cdop_acc_dX=0.0;
  double qid=0.0;
double d_qid_dX=0.0;
  double qis=0.0;
double d_qis_dX=0.0;
  double tang0d=0.0;
double d_tang0d_dX=0.0;
  double tang0s=0.0;
double d_tang0s_dX=0.0;
  double T11=0.0;
double d_T11_dX=0.0;
  double T12=0.0;
double d_T12_dX=0.0;
  double T13=0.0;
double d_T13_dX=0.0;
  double T14=0.0;
double d_T14_dX=0.0;
  double ids=0.0;
double d_ids_dX=0.0;
  double sigvds=0.0;
  double Iii=0.0;
double d_Iii_dX=0.0;
  double qd=0.0;
double d_qd_dX=0.0;
  double qg=0.0;
double d_qg_dX=0.0;
  double qs=0.0;
double d_qs_dX=0.0;
  double qb=0.0;
double d_qb_dX=0.0;
  double Qbul=0.0;
double d_Qbul_dX=0.0;
  double aab=0.0;
double d_aab_dX=0.0;
  double Weff0=0.0;
double d_Weff0_dX=0.0;
  double WeffCV0=0.0;
double d_WeffCV0_dX=0.0;
  double Weff=0.0;
double d_Weff_dX=0.0;
  double WeffCV=0.0;
double d_WeffCV_dX=0.0;
  double CJS_t=0.0;
double d_CJS_t_dX=0.0;
  double CJSWS_t=0.0;
double d_CJSWS_t_dX=0.0;
  double CJSWGS_t=0.0;
double d_CJSWGS_t_dX=0.0;
  double CJD_t=0.0;
double d_CJD_t_dX=0.0;
  double CJSWD_t=0.0;
double d_CJSWD_t_dX=0.0;
  double CJSWGD_t=0.0;
double d_CJSWGD_t_dX=0.0;
  double PBS_t=0.0;
double d_PBS_t_dX=0.0;
  double PBSWS_t=0.0;
double d_PBSWS_t_dX=0.0;
  double PBSWGS_t=0.0;
double d_PBSWGS_t_dX=0.0;
  double PBD_t=0.0;
double d_PBD_t_dX=0.0;
  double PBSWD_t=0.0;
double d_PBSWD_t_dX=0.0;
  double PBSWGD_t=0.0;
double d_PBSWGD_t_dX=0.0;
  double JSS_t=0.0;
double d_JSS_t_dX=0.0;
  double JSWS_t=0.0;
double d_JSWS_t_dX=0.0;
  double JSWGS_t=0.0;
double d_JSWGS_t_dX=0.0;
  double JSD_t=0.0;
double d_JSD_t_dX=0.0;
  double JSWD_t=0.0;
double d_JSWD_t_dX=0.0;
  double JSWGD_t=0.0;
double d_JSWGD_t_dX=0.0;
  double JTSS_t=0.0;
double d_JTSS_t_dX=0.0;
  double JTSSWS_t=0.0;
double d_JTSSWS_t_dX=0.0;
  double JTSSWGS_t=0.0;
double d_JTSSWGS_t_dX=0.0;
  double JTSD_t=0.0;
double d_JTSD_t_dX=0.0;
  double JTSSWD_t=0.0;
double d_JTSSWD_t_dX=0.0;
  double JTSSWGD_t=0.0;
double d_JTSSWGD_t_dX=0.0;
  double NJTS_t=0.0;
double d_NJTS_t_dX=0.0;
  double NJTSSW_t=0.0;
double d_NJTSSW_t_dX=0.0;
  double NJTSSWG_t=0.0;
double d_NJTSSWG_t_dX=0.0;
  double NJTSD_t=0.0;
double d_NJTSD_t_dX=0.0;
  double NJTSSWD_t=0.0;
double d_NJTSSWD_t_dX=0.0;
  double NJTSSWGD_t=0.0;
double d_NJTSSWGD_t_dX=0.0;
  double Ies=0.0;
double d_Ies_dX=0.0;
  double Ied=0.0;
double d_Ied_dX=0.0;
  double Czbs=0.0;
double d_Czbs_dX=0.0;
  double Czbssw=0.0;
double d_Czbssw_dX=0.0;
  double Czbsswg=0.0;
double d_Czbsswg_dX=0.0;
  double Czbd=0.0;
double d_Czbd_dX=0.0;
  double Czbdsw=0.0;
double d_Czbdsw_dX=0.0;
  double Czbdswg=0.0;
double d_Czbdswg_dX=0.0;
  double Qes=0.0;
double d_Qes_dX=0.0;
  double Qed=0.0;
double d_Qed_dX=0.0;
  double Qeg=0.0;
double d_Qeg_dX=0.0;
  double Isbs=0.0;
double d_Isbs_dX=0.0;
  double Isbd=0.0;
double d_Isbd_dX=0.0;
  double Nvtms=0.0;
double d_Nvtms_dX=0.0;
  double Nvtmd=0.0;
double d_Nvtmd_dX=0.0;
  double SslpRev=0.0;
double d_SslpRev_dX=0.0;
  double IVjsmRev=0.0;
double d_IVjsmRev_dX=0.0;
  double VjsmRev=0.0;
double d_VjsmRev_dX=0.0;
  double SslpFwd=0.0;
double d_SslpFwd_dX=0.0;
  double IVjsmFwd=0.0;
double d_IVjsmFwd_dX=0.0;
  double VjsmFwd=0.0;
double d_VjsmFwd_dX=0.0;
  double DslpRev=0.0;
double d_DslpRev_dX=0.0;
  double IVjdmRev=0.0;
double d_IVjdmRev_dX=0.0;
  double VjdmRev=0.0;
double d_VjdmRev_dX=0.0;
  double DslpFwd=0.0;
double d_DslpFwd_dX=0.0;
  double IVjdmFwd=0.0;
double d_IVjdmFwd_dX=0.0;
  double VjdmFwd=0.0;
double d_VjdmFwd_dX=0.0;
  double XExpBVS=0.0;
double d_XExpBVS_dX=0.0;
  double XExpBVD=0.0;
double d_XExpBVD_dX=0.0;
  double idsgen=0.0;
double d_idsgen_dX=0.0;
  double phibulk=0.0;
double d_phibulk_dX=0.0;
  double phipert=0.0;
  double g0s=0.0;
double d_g0s_dX=0.0;
  double g0d=0.0;
double d_g0d_dX=0.0;
  double r1=0.0;
double d_r1_dX=0.0;
  double q0=0.0;
double d_q0_dX=0.0;
  double F2=0.0;
double d_F2_dX=0.0;
  double Inv_r1pi=0.0;
double d_Inv_r1pi_dX=0.0;
  double Tcen=0.0;
double d_Tcen_dX=0.0;
  double MTcen=0.0;
double d_MTcen_dX=0.0;
  double Rdrain=0.0;
double d_Rdrain_dX=0.0;
  double Rsource=0.0;
double d_Rsource_dX=0.0;
  double Cfr_geo=0.0;
double d_Cfr_geo_dX=0.0;
  double igbinv=0.0;
double d_igbinv_dX=0.0;
  double igbs=0.0;
double d_igbs_dX=0.0;
  double igbd=0.0;
double d_igbd_dX=0.0;
  double igbacc=0.0;
double d_igbacc_dX=0.0;
  double igcs=0.0;
double d_igcs_dX=0.0;
  double igcd=0.0;
double d_igcd_dX=0.0;
  double igidl=0.0;
double d_igidl_dX=0.0;
  double igisl=0.0;
double d_igisl_dX=0.0;
  double igs=0.0;
double d_igs_dX=0.0;
  double igd=0.0;
double d_igd_dX=0.0;
  double cox_acc=0.0;
double d_cox_acc_dX=0.0;
  double r1_acc=0.0;
double d_r1_acc_dX=0.0;
  double Inv_r1pi_acc=0.0;
double d_Inv_r1pi_acc_dX=0.0;
  double CGSO_i=0.0;
double d_CGSO_i_dX=0.0;
  double CGDO_i=0.0;
double d_CGDO_i_dX=0.0;
  double q0_acc=0.0;
double d_q0_acc_dX=0.0;
  double qb_acc=0.0;
double d_qb_acc_dX=0.0;
  double qg_acc=0.0;
double d_qg_acc_dX=0.0;
  double qi_acc=0.0;
double d_qi_acc_dX=0.0;
  double qgs_fr=0.0;
double d_qgs_fr_dX=0.0;
  double qgd_fr=0.0;
double d_qgd_fr_dX=0.0;
  double qds_fr=0.0;
double d_qds_fr_dX=0.0;
  double qgs_parasitic=0.0;
double d_qgs_parasitic_dX=0.0;
  double qgd_parasitic=0.0;
double d_qgd_parasitic_dX=0.0;
  double FNPowerAt1Hz=0.0;
double d_FNPowerAt1Hz_dX=0.0;
  double Gtnoi=0.0;
double d_Gtnoi_dX=0.0;
  double gspr=0.0;
double d_gspr_dX=0.0;
  double gdpr=0.0;
double d_gdpr_dX=0.0;
  int devsign=0.0;
  double epssub=0.0;
double d_epssub_dX=0.0;
  double epssp=0.0;
double d_epssp_dX=0.0;
  double cox=0.0;
double d_cox_dX=0.0;
  double csi=0.0;
double d_csi_dX=0.0;
  double cbox=0.0;
double d_cbox_dX=0.0;
  double epsratio=0.0;
double d_epsratio_dX=0.0;
  double scl=0.0;
double d_scl_dX=0.0;
  double heff=0.0;
double d_heff_dX=0.0;
  double mx=0.0;
  double mxprime=0.0;
  double md=0.0;
  double mdprime=0.0;
  double gprime=0.0;
  double gfactor=0.0;
  double Lg=0.0;
double d_Lg_dX=0.0;
  double deltaL=0.0;
double d_deltaL_dX=0.0;
  double deltaLCV=0.0;
double d_deltaLCV_dX=0.0;
  double Leff=0.0;
double d_Leff_dX=0.0;
  double LeffCV=0.0;
double d_LeffCV_dX=0.0;
  double LeffCV_acc=0.0;
double d_LeffCV_acc_dX=0.0;
  double NFINtotal=0.0;
double d_NFINtotal_dX=0.0;
  double Inv_L=0.0;
double d_Inv_L_dX=0.0;
  double Inv_NFIN=0.0;
double d_Inv_NFIN_dX=0.0;
  double Inv_LNFIN=0.0;
double d_Inv_LNFIN_dX=0.0;
  double NBODY_i=0.0;
double d_NBODY_i_dX=0.0;
  double PHIG_i=0.0;
double d_PHIG_i_dX=0.0;
  double NGATE_i=0.0;
double d_NGATE_i_dX=0.0;
  double CIT_i=0.0;
double d_CIT_i_dX=0.0;
  double CDSC_i=0.0;
double d_CDSC_i_dX=0.0;
  double CDSCD_i=0.0;
double d_CDSCD_i_dX=0.0;
  double DVT0_i=0.0;
double d_DVT0_i_dX=0.0;
  double DVT1_i=0.0;
double d_DVT1_i_dX=0.0;
  double DVT1SS_i=0.0;
double d_DVT1SS_i_dX=0.0;
  double PHIN_i=0.0;
double d_PHIN_i_dX=0.0;
  double ETA0_i=0.0;
double d_ETA0_i_dX=0.0;
  double DSUB_i=0.0;
double d_DSUB_i_dX=0.0;
  double K1RSCE_i=0.0;
double d_K1RSCE_i_dX=0.0;
  double LPE0_i=0.0;
double d_LPE0_i_dX=0.0;
  double DVTSHIFT_i=0.0;
double d_DVTSHIFT_i_dX=0.0;
  double K0_i=0.0;
double d_K0_i_dX=0.0;
  double K01_i=0.0;
double d_K01_i_dX=0.0;
  double K0SI_i=0.0;
double d_K0SI_i_dX=0.0;
  double K0SI1_i=0.0;
double d_K0SI1_i_dX=0.0;
  double K1SI_i=0.0;
double d_K1SI_i_dX=0.0;
  double K1SI1_i=0.0;
double d_K1SI1_i_dX=0.0;
  double PHIBE_i=0.0;
double d_PHIBE_i_dX=0.0;
  double K1_i=0.0;
double d_K1_i_dX=0.0;
  double K11_i=0.0;
double d_K11_i_dX=0.0;
  double K1SAT_i=0.0;
double d_K1SAT_i_dX=0.0;
  double K1SAT1_i=0.0;
double d_K1SAT1_i_dX=0.0;
  double QMFACTOR_i=0.0;
double d_QMFACTOR_i_dX=0.0;
  double QMTCENIV_i=0.0;
double d_QMTCENIV_i_dX=0.0;
  double QMTCENCV_i=0.0;
double d_QMTCENCV_i_dX=0.0;
  double QMTCENCVA_i=0.0;
double d_QMTCENCVA_i_dX=0.0;
  double VSAT_i=0.0;
double d_VSAT_i_dX=0.0;
  double VSAT1_i=0.0;
double d_VSAT1_i_dX=0.0;
  double VSATCV_i=0.0;
double d_VSATCV_i_dX=0.0;
  double DELTAVSAT_i=0.0;
double d_DELTAVSAT_i_dX=0.0;
  double PSAT_i=0.0;
double d_PSAT_i_dX=0.0;
  double DELTAVSATCV_i=0.0;
double d_DELTAVSATCV_i_dX=0.0;
  double PSATCV_i=0.0;
double d_PSATCV_i_dX=0.0;
  double KSATIV_i=0.0;
double d_KSATIV_i_dX=0.0;
  double MEXP_i=0.0;
double d_MEXP_i_dX=0.0;
  double PTWG_i=0.0;
double d_PTWG_i_dX=0.0;
  double U0_i=0.0;
double d_U0_i_dX=0.0;
  double ETAMOB_i=0.0;
double d_ETAMOB_i_dX=0.0;
  double UP_i=0.0;
double d_UP_i_dX=0.0;
  double UA_i=0.0;
double d_UA_i_dX=0.0;
  double UC_i=0.0;
double d_UC_i_dX=0.0;
  double EU_i=0.0;
double d_EU_i_dX=0.0;
  double UD_i=0.0;
double d_UD_i_dX=0.0;
  double UCS_i=0.0;
double d_UCS_i_dX=0.0;
  double PCLM_i=0.0;
double d_PCLM_i_dX=0.0;
  double PCLMG_i=0.0;
double d_PCLMG_i_dX=0.0;
  double PCLMCV_i=0.0;
double d_PCLMCV_i_dX=0.0;
  double A1_i=0.0;
double d_A1_i_dX=0.0;
  double A11_i=0.0;
double d_A11_i_dX=0.0;
  double A2_i=0.0;
double d_A2_i_dX=0.0;
  double A21_i=0.0;
double d_A21_i_dX=0.0;
  double RDSW_i=0.0;
double d_RDSW_i_dX=0.0;
  double RSW_i=0.0;
double d_RSW_i_dX=0.0;
  double RDW_i=0.0;
double d_RDW_i_dX=0.0;
  double PRWGD_i=0.0;
double d_PRWGD_i_dX=0.0;
  double PRWGS_i=0.0;
double d_PRWGS_i_dX=0.0;
  double WR_i=0.0;
double d_WR_i_dX=0.0;
  double PDIBL1_i=0.0;
double d_PDIBL1_i_dX=0.0;
  double PDIBL2_i=0.0;
double d_PDIBL2_i_dX=0.0;
  double DROUT_i=0.0;
double d_DROUT_i_dX=0.0;
  double PVAG_i=0.0;
double d_PVAG_i_dX=0.0;
  double AIGBINV_i=0.0;
double d_AIGBINV_i_dX=0.0;
  double AIGBINV1_i=0.0;
double d_AIGBINV1_i_dX=0.0;
  double BIGBINV_i=0.0;
double d_BIGBINV_i_dX=0.0;
  double CIGBINV_i=0.0;
double d_CIGBINV_i_dX=0.0;
  double EIGBINV_i=0.0;
double d_EIGBINV_i_dX=0.0;
  double NIGBINV_i=0.0;
double d_NIGBINV_i_dX=0.0;
  double AIGBACC_i=0.0;
double d_AIGBACC_i_dX=0.0;
  double AIGBACC1_i=0.0;
double d_AIGBACC1_i_dX=0.0;
  double BIGBACC_i=0.0;
double d_BIGBACC_i_dX=0.0;
  double CIGBACC_i=0.0;
double d_CIGBACC_i_dX=0.0;
  double NIGBACC_i=0.0;
double d_NIGBACC_i_dX=0.0;
  double AIGC_i=0.0;
double d_AIGC_i_dX=0.0;
  double AIGC1_i=0.0;
double d_AIGC1_i_dX=0.0;
  double BIGC_i=0.0;
double d_BIGC_i_dX=0.0;
  double CIGC_i=0.0;
double d_CIGC_i_dX=0.0;
  double PIGCD_i=0.0;
double d_PIGCD_i_dX=0.0;
  double AIGS_i=0.0;
double d_AIGS_i_dX=0.0;
  double AIGS1_i=0.0;
double d_AIGS1_i_dX=0.0;
  double BIGS_i=0.0;
double d_BIGS_i_dX=0.0;
  double CIGS_i=0.0;
double d_CIGS_i_dX=0.0;
  double AIGD_i=0.0;
double d_AIGD_i_dX=0.0;
  double AIGD1_i=0.0;
double d_AIGD1_i_dX=0.0;
  double BIGD_i=0.0;
double d_BIGD_i_dX=0.0;
  double CIGD_i=0.0;
double d_CIGD_i_dX=0.0;
  double NTOX_i=0.0;
double d_NTOX_i_dX=0.0;
  double POXEDGE_i=0.0;
double d_POXEDGE_i_dX=0.0;
  double AGIDL_i=0.0;
double d_AGIDL_i_dX=0.0;
  double BGIDL_i=0.0;
double d_BGIDL_i_dX=0.0;
  double CGIDL_i=0.0;
double d_CGIDL_i_dX=0.0;
  double EGIDL_i=0.0;
double d_EGIDL_i_dX=0.0;
  double PGIDL_i=0.0;
double d_PGIDL_i_dX=0.0;
  double AGISL_i=0.0;
double d_AGISL_i_dX=0.0;
  double BGISL_i=0.0;
double d_BGISL_i_dX=0.0;
  double CGISL_i=0.0;
double d_CGISL_i_dX=0.0;
  double EGISL_i=0.0;
double d_EGISL_i_dX=0.0;
  double PGISL_i=0.0;
double d_PGISL_i_dX=0.0;
  double ALPHA0_i=0.0;
double d_ALPHA0_i_dX=0.0;
  double ALPHA1_i=0.0;
double d_ALPHA1_i_dX=0.0;
  double ALPHAII0_i=0.0;
double d_ALPHAII0_i_dX=0.0;
  double ALPHAII1_i=0.0;
double d_ALPHAII1_i_dX=0.0;
  double BETA0_i=0.0;
double d_BETA0_i_dX=0.0;
  double BETAII0_i=0.0;
double d_BETAII0_i_dX=0.0;
  double BETAII1_i=0.0;
double d_BETAII1_i_dX=0.0;
  double BETAII2_i=0.0;
double d_BETAII2_i_dX=0.0;
  double ESATII_i=0.0;
double d_ESATII_i_dX=0.0;
  double LII_i=0.0;
double d_LII_i_dX=0.0;
  double SII0_i=0.0;
double d_SII0_i_dX=0.0;
  double SII1_i=0.0;
double d_SII1_i_dX=0.0;
  double SII2_i=0.0;
double d_SII2_i_dX=0.0;
  double SIID_i=0.0;
double d_SIID_i_dX=0.0;
  double TII_i=0.0;
double d_TII_i_dX=0.0;
  double CFS_i=0.0;
double d_CFS_i_dX=0.0;
  double CFD_i=0.0;
double d_CFD_i_dX=0.0;
  double COVS_i=0.0;
double d_COVS_i_dX=0.0;
  double COVD_i=0.0;
double d_COVD_i_dX=0.0;
  double CGSL_i=0.0;
double d_CGSL_i_dX=0.0;
  double CGDL_i=0.0;
double d_CGDL_i_dX=0.0;
  double CGBL_i=0.0;
double d_CGBL_i_dX=0.0;
  double CKAPPAS_i=0.0;
double d_CKAPPAS_i_dX=0.0;
  double CKAPPAD_i=0.0;
double d_CKAPPAD_i_dX=0.0;
  double CKAPPAB_i=0.0;
double d_CKAPPAB_i_dX=0.0;
  double NTGEN_i=0.0;
double d_NTGEN_i_dX=0.0;
  double AIGEN_i=0.0;
double d_AIGEN_i_dX=0.0;
  double BIGEN_i=0.0;
double d_BIGEN_i_dX=0.0;
  double CDSCDR_i=0.0;
double d_CDSCDR_i_dX=0.0;
  double ETA0R_i=0.0;
double d_ETA0R_i_dX=0.0;
  double VSAT1R_i=0.0;
double d_VSAT1R_i_dX=0.0;
  double MEXPR_i=0.0;
double d_MEXPR_i_dX=0.0;
  double PTWGR_i=0.0;
double d_PTWGR_i_dX=0.0;
  double PDIBL1R_i=0.0;
double d_PDIBL1R_i_dX=0.0;
  double UTE_i=0.0;
double d_UTE_i_dX=0.0;
  double UTL_i=0.0;
double d_UTL_i_dX=0.0;
  double EMOBT_i=0.0;
double d_EMOBT_i_dX=0.0;
  double UA1_i=0.0;
double d_UA1_i_dX=0.0;
  double UC1_i=0.0;
double d_UC1_i_dX=0.0;
  double UD1_i=0.0;
double d_UD1_i_dX=0.0;
  double UCSTE_i=0.0;
double d_UCSTE_i_dX=0.0;
  double PTWGT_i=0.0;
double d_PTWGT_i_dX=0.0;
  double AT_i=0.0;
double d_AT_i_dX=0.0;
  double PRT_i=0.0;
double d_PRT_i_dX=0.0;
  double KT1_i=0.0;
double d_KT1_i_dX=0.0;
  double TSS_i=0.0;
double d_TSS_i_dX=0.0;
  double IIT_i=0.0;
double d_IIT_i_dX=0.0;
  double TGIDL_i=0.0;
double d_TGIDL_i_dX=0.0;
  double IGT_i=0.0;
double d_IGT_i_dX=0.0;
  double Tcen0=0.0;
double d_Tcen0_dX=0.0;
  double RDSWMIN_i=0.0;
double d_RDSWMIN_i_dX=0.0;
  double RSWMIN_i=0.0;
double d_RSWMIN_i_dX=0.0;
  double RDWMIN_i=0.0;
double d_RDWMIN_i_dX=0.0;
  double LINTIGEN_i=0.0;
double d_LINTIGEN_i_dX=0.0;
  double LINTNOI_i=0.0;
double d_LINTNOI_i_dX=0.0;
  double NTNOI_i=0.0;
double d_NTNOI_i_dX=0.0;
  double Arsd=0.0;
double d_Arsd_dX=0.0;
  double Prsd=0.0;
double d_Prsd_dX=0.0;
  double mu_max=0.0;
double d_mu_max_dX=0.0;
  double mu_rsd=0.0;
double d_mu_rsd_dX=0.0;
  double rhorsd=0.0;
double d_rhorsd_dX=0.0;
  double thetarsp=0.0;
  double afin=0.0;
double d_afin_dX=0.0;
  double T1=0.0;
double d_T1_dX=0.0;
  double Rsp=0.0;
double d_Rsp_dX=0.0;
  double arsd_total=0.0;
double d_arsd_total_dX=0.0;
  double prsd_total=0.0;
double d_prsd_total_dX=0.0;
  double lt=0.0;
double d_lt_dX=0.0;
  double alpha=0.0;
double d_alpha_dX=0.0;
  double T0=0.0;
double d_T0_dX=0.0;
  double eta=0.0;
double d_eta_dX=0.0;
  double T2=0.0;
double d_T2_dX=0.0;
  double T3=0.0;
double d_T3_dX=0.0;
  double RrsdTML=0.0;
double d_RrsdTML_dX=0.0;
  double Rrsdside=0.0;
double d_Rrsdside_dX=0.0;
  double Rrsd=0.0;
double d_Rrsd_dX=0.0;
  double Rdsgeo=0.0;
double d_Rdsgeo_dX=0.0;
  double RSourceGeo=0.0;
double d_RSourceGeo_dX=0.0;
  double RDrainGeo=0.0;
double d_RDrainGeo_dX=0.0;
  double Hg=0.0;
double d_Hg_dX=0.0;
  double Trsd=0.0;
double d_Trsd_dX=0.0;
  double Wg=0.0;
double d_Wg_dX=0.0;
  double Hrsd=0.0;
double d_Hrsd_dX=0.0;
  double Cgg_top=0.0;
double d_Cgg_top_dX=0.0;
  double Cgg_side=0.0;
double d_Cgg_side_dX=0.0;
  double Acorner=0.0;
double d_Acorner_dX=0.0;
  double Ccorner=0.0;
double d_Ccorner_dX=0.0;
  double csbox=0.0;
double d_csbox_dX=0.0;
  double cdbox=0.0;
double d_cdbox_dX=0.0;
  double cgbox=0.0;
double d_cgbox_dX=0.0;
  double EeffFactor=0.0;
double d_EeffFactor_dX=0.0;
  double WeffWRFactor=0.0;
double d_WeffWRFactor_dX=0.0;
  double litl=0.0;
double d_litl_dX=0.0;
  double tmp=0.0;
double d_tmp_dX=0.0;
  double Theta_SCE=0.0;
double d_Theta_SCE_dX=0.0;
  double Theta_SW=0.0;
double d_Theta_SW_dX=0.0;
  double Theta_DIBL=0.0;
double d_Theta_DIBL_dX=0.0;
  double Theta_RSCE=0.0;
double d_Theta_RSCE_dX=0.0;
  double nbody=0.0;
double d_nbody_dX=0.0;
  double qbs=0.0;
double d_qbs_dX=0.0;
  double Aechvb=0.0;
  double Bechvb=0.0;
  double Toxratio=0.0;
double d_Toxratio_dX=0.0;
  double Toxratioedge=0.0;
double d_Toxratioedge_dX=0.0;
  double igsd_mult0=0.0;
double d_igsd_mult0_dX=0.0;
  double Tnom=0.0;
double d_Tnom_dX=0.0;


  // -- code converted from analog/code block
//Begin block CMGBiasIndepCalc
{
initialized = 1;
d_R_dX = 0.0;
R = 0;
d_vgsfbeff_acc_dX = 0.0;
vgsfbeff_acc = 0;
d_vt0_dX = 0.0;
vt0 = 0;
d_vt0_acc_dX = 0.0;
vt0_acc = 0;
d_F1_dX = 0.0;
F1 = 0;
d_F1_acc_dX = 0.0;
F1_acc = 0;
d_cdop_acc_dX = 0.0;
cdop_acc = 0;
d_qid_dX = 0.0;
qid = 0;
d_qis_dX = 0.0;
qis = 0;
d_tang0d_dX = 0.0;
tang0d = 0;
d_tang0s_dX = 0.0;
tang0s = 0;
d_T11_dX = 0.0;
T11 = 0;
d_T12_dX = 0.0;
T12 = 0;
d_T13_dX = 0.0;
T13 = 0;
d_T14_dX = 0.0;
T14 = 0;
d_ids_dX = 0.0;
ids = 0;
sigvds = 0;
d_Iii_dX = 0.0;
Iii = 0;
d_qd_dX = 0.0;
qd = 0;
d_qg_dX = 0.0;
qg = 0;
d_qs_dX = 0.0;
qs = 0;
d_qb_dX = 0.0;
qb = 0;
d_Qbul_dX = 0.0;
Qbul = 0;
d_aab_dX = 0.0;
aab = 0;
d_Weff0_dX = 0.0;
Weff0 = 0;
d_WeffCV0_dX = 0.0;
WeffCV0 = 0;
d_Weff_dX = 0.0;
Weff = 0;
d_WeffCV_dX = 0.0;
WeffCV = 0;
d_CJS_t_dX = 0.0;
CJS_t = 0;
d_CJSWS_t_dX = 0.0;
CJSWS_t = 0;
d_CJSWGS_t_dX = 0.0;
CJSWGS_t = 0;
d_CJD_t_dX = 0.0;
CJD_t = 0;
d_CJSWD_t_dX = 0.0;
CJSWD_t = 0;
d_CJSWGD_t_dX = 0.0;
CJSWGD_t = 0;
d_PBS_t_dX = 0.0;
PBS_t = 0;
d_PBSWS_t_dX = 0.0;
PBSWS_t = 0;
d_PBSWGS_t_dX = 0.0;
PBSWGS_t = 0;
d_PBD_t_dX = 0.0;
PBD_t = 0;
d_PBSWD_t_dX = 0.0;
PBSWD_t = 0;
d_PBSWGD_t_dX = 0.0;
PBSWGD_t = 0;
d_JSS_t_dX = 0.0;
JSS_t = 0;
d_JSWS_t_dX = 0.0;
JSWS_t = 0;
d_JSWGS_t_dX = 0.0;
JSWGS_t = 0;
d_JSD_t_dX = 0.0;
JSD_t = 0;
d_JSWD_t_dX = 0.0;
JSWD_t = 0;
d_JSWGD_t_dX = 0.0;
JSWGD_t = 0;
d_JTSS_t_dX = 0.0;
JTSS_t = 0;
d_JTSSWS_t_dX = 0.0;
JTSSWS_t = 0;
d_JTSSWGS_t_dX = 0.0;
JTSSWGS_t = 0;
d_JTSD_t_dX = 0.0;
JTSD_t = 0;
d_JTSSWD_t_dX = 0.0;
JTSSWD_t = 0;
d_JTSSWGD_t_dX = 0.0;
JTSSWGD_t = 0;
d_NJTS_t_dX = 0.0;
NJTS_t = 0;
d_NJTSSW_t_dX = 0.0;
NJTSSW_t = 0;
d_NJTSSWG_t_dX = 0.0;
NJTSSWG_t = 0;
d_NJTSD_t_dX = 0.0;
NJTSD_t = 0;
d_NJTSSWD_t_dX = 0.0;
NJTSSWD_t = 0;
d_NJTSSWGD_t_dX = 0.0;
NJTSSWGD_t = 0;
d_Ies_dX = 0.0;
Ies = 0;
d_Ied_dX = 0.0;
Ied = 0;
d_Czbs_dX = 0.0;
Czbs = 0;
d_Czbssw_dX = 0.0;
Czbssw = 0;
d_Czbsswg_dX = 0.0;
Czbsswg = 0;
d_Czbd_dX = 0.0;
Czbd = 0;
d_Czbdsw_dX = 0.0;
Czbdsw = 0;
d_Czbdswg_dX = 0.0;
Czbdswg = 0;
d_Qes_dX = 0.0;
Qes = 0;
d_Qed_dX = 0.0;
Qed = 0;
d_Qeg_dX = 0.0;
Qeg = 0;
d_Isbs_dX = 0.0;
Isbs = 0;
d_Isbd_dX = 0.0;
Isbd = 0;
d_Nvtms_dX = 0.0;
Nvtms = 0;
d_Nvtmd_dX = 0.0;
Nvtmd = 0;
d_SslpRev_dX = 0.0;
SslpRev = 0;
d_IVjsmRev_dX = 0.0;
IVjsmRev = 0;
d_VjsmRev_dX = 0.0;
VjsmRev = 0;
d_SslpFwd_dX = 0.0;
SslpFwd = 0;
d_IVjsmFwd_dX = 0.0;
IVjsmFwd = 0;
d_VjsmFwd_dX = 0.0;
VjsmFwd = 0;
d_DslpRev_dX = 0.0;
DslpRev = 0;
d_IVjdmRev_dX = 0.0;
IVjdmRev = 0;
d_VjdmRev_dX = 0.0;
VjdmRev = 0;
d_DslpFwd_dX = 0.0;
DslpFwd = 0;
d_IVjdmFwd_dX = 0.0;
IVjdmFwd = 0;
d_VjdmFwd_dX = 0.0;
VjdmFwd = 0;
d_XExpBVS_dX = 0.0;
XExpBVS = 0;
d_XExpBVD_dX = 0.0;
XExpBVD = 0;
d_idsgen_dX = 0.0;
idsgen = 0;
d_phibulk_dX = 0.0;
phibulk = 0;
phipert = 0;
d_g0s_dX = 0.0;
g0s = 0;
d_g0d_dX = 0.0;
g0d = 0;
d_r1_dX = 0.0;
r1 = 0;
d_q0_dX = 0.0;
q0 = 0;
d_F2_dX = 0.0;
F2 = 0;
d_Inv_r1pi_dX = 0.0;
Inv_r1pi = 0;
d_Tcen_dX = 0.0;
Tcen = 0;
d_MTcen_dX = 0.0;
MTcen = 0;
d_Rdrain_dX = 0.0;
Rdrain = 0;
d_Rsource_dX = 0.0;
Rsource = 0;
d_Cfr_geo_dX = 0.0;
Cfr_geo = 0;
d_igbinv_dX = 0.0;
igbinv = 0;
d_igbs_dX = 0.0;
igbs = 0;
d_igbd_dX = 0.0;
igbd = 0;
d_igbacc_dX = 0.0;
igbacc = 0;
d_igcs_dX = 0.0;
igcs = 0;
d_igcd_dX = 0.0;
igcd = 0;
d_igidl_dX = 0.0;
igidl = 0;
d_igisl_dX = 0.0;
igisl = 0;
d_igs_dX = 0.0;
igs = 0;
d_igd_dX = 0.0;
igd = 0;
d_cox_acc_dX = 0.0;
cox_acc = 0;
d_r1_acc_dX = 0.0;
r1_acc = 0;
d_Inv_r1pi_acc_dX = 0.0;
Inv_r1pi_acc = 0;
d_CGSO_i_dX = 0.0;
CGSO_i = 0;
d_CGDO_i_dX = 0.0;
CGDO_i = 0;
d_q0_acc_dX = 0.0;
q0_acc = 0;
d_qb_acc_dX = 0.0;
qb_acc = 0;
d_qg_acc_dX = 0.0;
qg_acc = 0;
d_qi_acc_dX = 0.0;
qi_acc = 0;
d_qgs_fr_dX = 0.0;
qgs_fr = 0;
d_qgd_fr_dX = 0.0;
qgd_fr = 0;
d_qds_fr_dX = 0.0;
qds_fr = 0;
d_qgs_parasitic_dX = 0.0;
qgs_parasitic = 0;
d_qgd_parasitic_dX = 0.0;
qgd_parasitic = 0;
d_FNPowerAt1Hz_dX = 0.0;
FNPowerAt1Hz = 0;
d_Gtnoi_dX = 0.0;
Gtnoi = 0;
d_gspr_dX = 0.0;
gspr = 0;
d_gdpr_dX = 0.0;
gdpr = 0;
if ( modelStruct.modelPar_GEOMOD == (0))
{
d_Weff0_dX = (2*modelStruct.d_modelPar_HFIN_dX-modelStruct.d_modelPar_DELTAW_dX);
Weff0 = ((2*modelStruct.modelPar_HFIN)-modelStruct.modelPar_DELTAW);
d_WeffCV0_dX = (2*modelStruct.d_modelPar_HFIN_dX-modelStruct.d_modelPar_DELTAWCV_dX);
WeffCV0 = ((2*modelStruct.modelPar_HFIN)-modelStruct.modelPar_DELTAWCV);
}
else
if ( modelStruct.modelPar_GEOMOD == (1))
{
d_Weff0_dX = ((2*modelStruct.d_modelPar_HFIN_dX+(modelStruct.modelPar_FECH*instanceStruct.d_instancePar_TFIN_dX+modelStruct.d_modelPar_FECH_dX*instanceStruct.instancePar_TFIN))-modelStruct.d_modelPar_DELTAW_dX);
Weff0 = (((2*modelStruct.modelPar_HFIN)+(modelStruct.modelPar_FECH*instanceStruct.instancePar_TFIN))-modelStruct.modelPar_DELTAW);
d_WeffCV0_dX = ((2*modelStruct.d_modelPar_HFIN_dX+(modelStruct.modelPar_FECHCV*instanceStruct.d_instancePar_TFIN_dX+modelStruct.d_modelPar_FECHCV_dX*instanceStruct.instancePar_TFIN))-modelStruct.d_modelPar_DELTAWCV_dX);
WeffCV0 = (((2*modelStruct.modelPar_HFIN)+(modelStruct.modelPar_FECHCV*instanceStruct.instancePar_TFIN))-modelStruct.modelPar_DELTAWCV);
}
else
if ( modelStruct.modelPar_GEOMOD == (2))
{
d_Weff0_dX = ((2*modelStruct.d_modelPar_HFIN_dX+((2*modelStruct.modelPar_FECH)*instanceStruct.d_instancePar_TFIN_dX+2*modelStruct.d_modelPar_FECH_dX*instanceStruct.instancePar_TFIN))-modelStruct.d_modelPar_DELTAW_dX);
Weff0 = (((2*modelStruct.modelPar_HFIN)+((2*modelStruct.modelPar_FECH)*instanceStruct.instancePar_TFIN))-modelStruct.modelPar_DELTAW);
d_WeffCV0_dX = ((2*modelStruct.d_modelPar_HFIN_dX+((2*modelStruct.modelPar_FECHCV)*instanceStruct.d_instancePar_TFIN_dX+2*modelStruct.d_modelPar_FECHCV_dX*instanceStruct.instancePar_TFIN))-modelStruct.d_modelPar_DELTAWCV_dX);
WeffCV0 = (((2*modelStruct.modelPar_HFIN)+((2*modelStruct.modelPar_FECHCV)*instanceStruct.instancePar_TFIN))-modelStruct.modelPar_DELTAWCV);
}
else
if ( modelStruct.modelPar_GEOMOD == (3))
{
d_R_dX = (instanceStruct.d_instancePar_D_dX/2.0);
R = (instanceStruct.instancePar_D/2.0);
d_Weff0_dX = (3.14159265358979323846*instanceStruct.d_instancePar_D_dX-modelStruct.d_modelPar_DELTAW_dX);
Weff0 = ((3.14159265358979323846*instanceStruct.instancePar_D)-modelStruct.modelPar_DELTAW);
d_WeffCV0_dX = (3.14159265358979323846*instanceStruct.d_instancePar_D_dX-modelStruct.d_modelPar_DELTAWCV_dX);
WeffCV0 = ((3.14159265358979323846*instanceStruct.instancePar_D)-modelStruct.modelPar_DELTAWCV);
}
else
{
 // no default
}
if ((modelStruct.modelPar_DEVTYPE==1))
{
devsign = 1;
}
else
{
devsign = (-1);
}
d_epssub_dX = modelStruct.d_modelPar_EPSRSUB_dX*8.8542e-12;
epssub = (modelStruct.modelPar_EPSRSUB*8.8542e-12);
d_epssp_dX = modelStruct.d_modelPar_EPSRSP_dX*8.8542e-12;
epssp = (modelStruct.modelPar_EPSRSP*8.8542e-12);
d_cox_dX = (-(3.9*8.8542e-12)*modelStruct.d_modelPar_EOT_dX/modelStruct.modelPar_EOT/modelStruct.modelPar_EOT);
cox = ((3.9*8.8542e-12)/modelStruct.modelPar_EOT);
d_csi_dX = ((instanceStruct.instancePar_TFIN*d_epssub_dX-epssub*instanceStruct.d_instancePar_TFIN_dX)/instanceStruct.instancePar_TFIN/instanceStruct.instancePar_TFIN);
csi = (epssub/instanceStruct.instancePar_TFIN);
d_cbox_dX = (-(3.9*8.8542e-12)*modelStruct.d_modelPar_EOTBOX_dX/modelStruct.modelPar_EOTBOX/modelStruct.modelPar_EOTBOX);
cbox = ((3.9*8.8542e-12)/modelStruct.modelPar_EOTBOX);
d_epsratio_dX = (modelStruct.d_modelPar_EPSRSUB_dX/3.9);
epsratio = (modelStruct.modelPar_EPSRSUB/3.9);
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_cox_acc_dX = (-(3.9*8.8542e-12)*modelStruct.d_modelPar_EOTACC_dX/modelStruct.modelPar_EOTACC/modelStruct.modelPar_EOTACC);
cox_acc = ((3.9*8.8542e-12)/modelStruct.modelPar_EOTACC);
}
{
double value_sqrt_0 = sqrt(((((0.5*epsratio)*instanceStruct.instancePar_TFIN)*modelStruct.modelPar_EOT)*(1.0+(instanceStruct.instancePar_TFIN/((4.0*epsratio)*modelStruct.modelPar_EOT)))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_scl_dX = deriv_sqrt_0_d0*(((((0.5*epsratio)*instanceStruct.instancePar_TFIN)*modelStruct.modelPar_EOT)*((((4.0*epsratio)*modelStruct.modelPar_EOT)*instanceStruct.d_instancePar_TFIN_dX-instanceStruct.instancePar_TFIN*((4.0*epsratio)*modelStruct.d_modelPar_EOT_dX+4.0*d_epsratio_dX*modelStruct.modelPar_EOT))/((4.0*epsratio)*modelStruct.modelPar_EOT)/((4.0*epsratio)*modelStruct.modelPar_EOT))+(((0.5*epsratio)*instanceStruct.instancePar_TFIN)*modelStruct.d_modelPar_EOT_dX+((0.5*epsratio)*instanceStruct.d_instancePar_TFIN_dX+0.5*d_epsratio_dX*instanceStruct.instancePar_TFIN)*modelStruct.modelPar_EOT)*(1.0+(instanceStruct.instancePar_TFIN/((4.0*epsratio)*modelStruct.modelPar_EOT)))));
scl = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt(((modelStruct.modelPar_HFIN*(modelStruct.modelPar_HFIN+((2*epsratio)*modelStruct.modelPar_EOT)))/8.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_heff_dX = deriv_sqrt_0_d0*(((modelStruct.modelPar_HFIN*(modelStruct.d_modelPar_HFIN_dX+((2*epsratio)*modelStruct.d_modelPar_EOT_dX+2*d_epsratio_dX*modelStruct.modelPar_EOT))+modelStruct.d_modelPar_HFIN_dX*(modelStruct.modelPar_HFIN+((2*epsratio)*modelStruct.modelPar_EOT)))/8.0));
heff = value_sqrt_0;
}
if ( modelStruct.modelPar_GEOMOD == (1))
{
{
double value_sqrt_0 = sqrt(((1.0/(scl*scl))+(0.25/(heff*heff))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_scl_dX = (-deriv_sqrt_0_d0*(((-(scl*d_scl_dX+d_scl_dX*scl)/(scl*scl)/(scl*scl))+(-0.25*(heff*d_heff_dX+d_heff_dX*heff)/(heff*heff)/(heff*heff))))/value_sqrt_0/value_sqrt_0);
scl = (1.0/value_sqrt_0);
}
}
else
if ( modelStruct.modelPar_GEOMOD == (2))
{
{
double value_sqrt_0 = sqrt(((1.0/(scl*scl))+(0.25/(heff*heff))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_scl_dX = (-0.5*deriv_sqrt_0_d0*(((-(scl*d_scl_dX+d_scl_dX*scl)/(scl*scl)/(scl*scl))+(-0.25*(heff*d_heff_dX+d_heff_dX*heff)/(heff*heff)/(heff*heff))))/value_sqrt_0/value_sqrt_0);
scl = (0.5/value_sqrt_0);
}
}
else
if ( modelStruct.modelPar_GEOMOD == (3))
{
{
double value_sqrt_0 = sqrt(((((0.5*epsratio)*R)*modelStruct.modelPar_EOT)*(1.0+(R/((2.0*epsratio)*modelStruct.modelPar_EOT)))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_scl_dX = deriv_sqrt_0_d0*(((((0.5*epsratio)*R)*modelStruct.modelPar_EOT)*((((2.0*epsratio)*modelStruct.modelPar_EOT)*d_R_dX-R*((2.0*epsratio)*modelStruct.d_modelPar_EOT_dX+2.0*d_epsratio_dX*modelStruct.modelPar_EOT))/((2.0*epsratio)*modelStruct.modelPar_EOT)/((2.0*epsratio)*modelStruct.modelPar_EOT))+(((0.5*epsratio)*R)*modelStruct.d_modelPar_EOT_dX+((0.5*epsratio)*d_R_dX+0.5*d_epsratio_dX*R)*modelStruct.modelPar_EOT)*(1.0+(R/((2.0*epsratio)*modelStruct.modelPar_EOT)))));
scl = value_sqrt_0;
}
}
else
{
 // no default
}
mx = (0.916*9.11e-31);
mxprime = (0.190*9.11e-31);
md = (0.190*9.11e-31);
mdprime = (0.417*9.11e-31);
gprime = 4.0;
gfactor = 2.0;
d_Lg_dX = (instanceStruct.d_instancePar_L_dX+modelStruct.d_modelPar_XL_dX);
Lg = (instanceStruct.instancePar_L+modelStruct.modelPar_XL);
{
double value_pow_0 = pow(Lg,(-modelStruct.modelPar_LLN));
double  deriv_pow_0_d0 = ((Lg == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_LLN)/Lg));
double  deriv_pow_0_d1 = (Lg == 0.0)?0.0:(log(Lg)*value_pow_0);
d_deltaL_dX = (modelStruct.d_modelPar_LINT_dX+(modelStruct.modelPar_LL*((deriv_pow_0_d0*(d_Lg_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_LLN_dX))))+modelStruct.d_modelPar_LL_dX*value_pow_0));
deltaL = (modelStruct.modelPar_LINT+(modelStruct.modelPar_LL*value_pow_0));
}
{
double value_pow_0 = pow(Lg,(-modelStruct.modelPar_LLN));
double  deriv_pow_0_d0 = ((Lg == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_LLN)/Lg));
double  deriv_pow_0_d1 = (Lg == 0.0)?0.0:(log(Lg)*value_pow_0);
d_deltaLCV_dX = (modelStruct.d_modelPar_DLC_dX+(modelStruct.modelPar_LLC*((deriv_pow_0_d0*(d_Lg_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_LLN_dX))))+modelStruct.d_modelPar_LLC_dX*value_pow_0));
deltaLCV = (modelStruct.modelPar_DLC+(modelStruct.modelPar_LLC*value_pow_0));
}
d_Leff_dX = (d_Lg_dX-2.0*d_deltaL_dX);
Leff = (Lg-(2.0*deltaL));
d_LeffCV_dX = (d_Lg_dX-2.0*d_deltaLCV_dX);
LeffCV = (Lg-(2.0*deltaLCV));
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_LeffCV_acc_dX = (d_LeffCV_dX-modelStruct.d_modelPar_DLCACC_dX);
LeffCV_acc = (LeffCV-modelStruct.modelPar_DLCACC);
}
d_NFINtotal_dX = instanceStruct.d_instancePar_NFIN_dX*modelStruct.modelPar_NF;
NFINtotal = (instanceStruct.instancePar_NFIN*modelStruct.modelPar_NF);
d_Inv_L_dX = (-1.0e-6*(d_Leff_dX+modelStruct.d_modelPar_DLBIN_dX)/(Leff+modelStruct.modelPar_DLBIN)/(Leff+modelStruct.modelPar_DLBIN));
Inv_L = (1.0e-6/(Leff+modelStruct.modelPar_DLBIN));
d_Inv_NFIN_dX = (-instanceStruct.d_instancePar_NFIN_dX/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN);
Inv_NFIN = (1.0/instanceStruct.instancePar_NFIN);
d_Inv_LNFIN_dX = (-1.0e-6*((Leff+modelStruct.modelPar_DLBIN)*instanceStruct.d_instancePar_NFIN_dX+(d_Leff_dX+modelStruct.d_modelPar_DLBIN_dX)*instanceStruct.instancePar_NFIN)/((Leff+modelStruct.modelPar_DLBIN)*instanceStruct.instancePar_NFIN)/((Leff+modelStruct.modelPar_DLBIN)*instanceStruct.instancePar_NFIN));
Inv_LNFIN = (1.0e-6/((Leff+modelStruct.modelPar_DLBIN)*instanceStruct.instancePar_NFIN));
d_NBODY_i_dX = (((modelStruct.d_modelPar_NBODY_dX+(Inv_L*modelStruct.d_modelPar_LNBODY_dX+d_Inv_L_dX*modelStruct.modelPar_LNBODY))+(Inv_NFIN*modelStruct.d_modelPar_NNBODY_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NNBODY))+(Inv_LNFIN*modelStruct.d_modelPar_PNBODY_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PNBODY));
NBODY_i = (((modelStruct.modelPar_NBODY+(Inv_L*modelStruct.modelPar_LNBODY))+(Inv_NFIN*modelStruct.modelPar_NNBODY))+(Inv_LNFIN*modelStruct.modelPar_PNBODY));
d_PHIG_i_dX = (((modelStruct.d_modelPar_PHIG_dX+(Inv_L*modelStruct.d_modelPar_LPHIG_dX+d_Inv_L_dX*modelStruct.modelPar_LPHIG))+(Inv_NFIN*modelStruct.d_modelPar_NPHIG_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPHIG))+(Inv_LNFIN*modelStruct.d_modelPar_PPHIG_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPHIG));
PHIG_i = (((modelStruct.modelPar_PHIG+(Inv_L*modelStruct.modelPar_LPHIG))+(Inv_NFIN*modelStruct.modelPar_NPHIG))+(Inv_LNFIN*modelStruct.modelPar_PPHIG));
d_NGATE_i_dX = (((modelStruct.d_modelPar_NGATE_dX+(Inv_L*modelStruct.d_modelPar_LNGATE_dX+d_Inv_L_dX*modelStruct.modelPar_LNGATE))+(Inv_NFIN*modelStruct.d_modelPar_NNGATE_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NNGATE))+(Inv_LNFIN*modelStruct.d_modelPar_PNGATE_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PNGATE));
NGATE_i = (((modelStruct.modelPar_NGATE+(Inv_L*modelStruct.modelPar_LNGATE))+(Inv_NFIN*modelStruct.modelPar_NNGATE))+(Inv_LNFIN*modelStruct.modelPar_PNGATE));
d_CIT_i_dX = (((modelStruct.d_modelPar_CIT_dX+(Inv_L*modelStruct.d_modelPar_LCIT_dX+d_Inv_L_dX*modelStruct.modelPar_LCIT))+(Inv_NFIN*modelStruct.d_modelPar_NCIT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCIT))+(Inv_LNFIN*modelStruct.d_modelPar_PCIT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCIT));
CIT_i = (((modelStruct.modelPar_CIT+(Inv_L*modelStruct.modelPar_LCIT))+(Inv_NFIN*modelStruct.modelPar_NCIT))+(Inv_LNFIN*modelStruct.modelPar_PCIT));
d_CDSC_i_dX = (((modelStruct.d_modelPar_CDSC_dX+(Inv_L*modelStruct.d_modelPar_LCDSC_dX+d_Inv_L_dX*modelStruct.modelPar_LCDSC))+(Inv_NFIN*modelStruct.d_modelPar_NCDSC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCDSC))+(Inv_LNFIN*modelStruct.d_modelPar_PCDSC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCDSC));
CDSC_i = (((modelStruct.modelPar_CDSC+(Inv_L*modelStruct.modelPar_LCDSC))+(Inv_NFIN*modelStruct.modelPar_NCDSC))+(Inv_LNFIN*modelStruct.modelPar_PCDSC));
d_CDSCD_i_dX = (((modelStruct.d_modelPar_CDSCD_dX+(Inv_L*modelStruct.d_modelPar_LCDSCD_dX+d_Inv_L_dX*modelStruct.modelPar_LCDSCD))+(Inv_NFIN*modelStruct.d_modelPar_NCDSCD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCDSCD))+(Inv_LNFIN*modelStruct.d_modelPar_PCDSCD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCDSCD));
CDSCD_i = (((modelStruct.modelPar_CDSCD+(Inv_L*modelStruct.modelPar_LCDSCD))+(Inv_NFIN*modelStruct.modelPar_NCDSCD))+(Inv_LNFIN*modelStruct.modelPar_PCDSCD));
d_DVT0_i_dX = (((modelStruct.d_modelPar_DVT0_dX+(Inv_L*modelStruct.d_modelPar_LDVT0_dX+d_Inv_L_dX*modelStruct.modelPar_LDVT0))+(Inv_NFIN*modelStruct.d_modelPar_NDVT0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDVT0))+(Inv_LNFIN*modelStruct.d_modelPar_PDVT0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDVT0));
DVT0_i = (((modelStruct.modelPar_DVT0+(Inv_L*modelStruct.modelPar_LDVT0))+(Inv_NFIN*modelStruct.modelPar_NDVT0))+(Inv_LNFIN*modelStruct.modelPar_PDVT0));
d_DVT1_i_dX = (((modelStruct.d_modelPar_DVT1_dX+(Inv_L*modelStruct.d_modelPar_LDVT1_dX+d_Inv_L_dX*modelStruct.modelPar_LDVT1))+(Inv_NFIN*modelStruct.d_modelPar_NDVT1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDVT1))+(Inv_LNFIN*modelStruct.d_modelPar_PDVT1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDVT1));
DVT1_i = (((modelStruct.modelPar_DVT1+(Inv_L*modelStruct.modelPar_LDVT1))+(Inv_NFIN*modelStruct.modelPar_NDVT1))+(Inv_LNFIN*modelStruct.modelPar_PDVT1));
d_DVT1SS_i_dX = (((modelStruct.d_modelPar_DVT1SS_dX+(Inv_L*modelStruct.d_modelPar_LDVT1SS_dX+d_Inv_L_dX*modelStruct.modelPar_LDVT1SS))+(Inv_NFIN*modelStruct.d_modelPar_NDVT1SS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDVT1SS))+(Inv_LNFIN*modelStruct.d_modelPar_PDVT1SS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDVT1SS));
DVT1SS_i = (((modelStruct.modelPar_DVT1SS+(Inv_L*modelStruct.modelPar_LDVT1SS))+(Inv_NFIN*modelStruct.modelPar_NDVT1SS))+(Inv_LNFIN*modelStruct.modelPar_PDVT1SS));
d_PHIN_i_dX = (((modelStruct.d_modelPar_PHIN_dX+(Inv_L*modelStruct.d_modelPar_LPHIN_dX+d_Inv_L_dX*modelStruct.modelPar_LPHIN))+(Inv_NFIN*modelStruct.d_modelPar_NPHIN_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPHIN))+(Inv_LNFIN*modelStruct.d_modelPar_PPHIN_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPHIN));
PHIN_i = (((modelStruct.modelPar_PHIN+(Inv_L*modelStruct.modelPar_LPHIN))+(Inv_NFIN*modelStruct.modelPar_NPHIN))+(Inv_LNFIN*modelStruct.modelPar_PPHIN));
d_ETA0_i_dX = (((modelStruct.d_modelPar_ETA0_dX+(Inv_L*modelStruct.d_modelPar_LETA0_dX+d_Inv_L_dX*modelStruct.modelPar_LETA0))+(Inv_NFIN*modelStruct.d_modelPar_NETA0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NETA0))+(Inv_LNFIN*modelStruct.d_modelPar_PETA0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PETA0));
ETA0_i = (((modelStruct.modelPar_ETA0+(Inv_L*modelStruct.modelPar_LETA0))+(Inv_NFIN*modelStruct.modelPar_NETA0))+(Inv_LNFIN*modelStruct.modelPar_PETA0));
d_DSUB_i_dX = (((modelStruct.d_modelPar_DSUB_dX+(Inv_L*modelStruct.d_modelPar_LDSUB_dX+d_Inv_L_dX*modelStruct.modelPar_LDSUB))+(Inv_NFIN*modelStruct.d_modelPar_NDSUB_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDSUB))+(Inv_LNFIN*modelStruct.d_modelPar_PDSUB_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDSUB));
DSUB_i = (((modelStruct.modelPar_DSUB+(Inv_L*modelStruct.modelPar_LDSUB))+(Inv_NFIN*modelStruct.modelPar_NDSUB))+(Inv_LNFIN*modelStruct.modelPar_PDSUB));
d_K1RSCE_i_dX = (((modelStruct.d_modelPar_K1RSCE_dX+(Inv_L*modelStruct.d_modelPar_LK1RSCE_dX+d_Inv_L_dX*modelStruct.modelPar_LK1RSCE))+(Inv_NFIN*modelStruct.d_modelPar_NK1RSCE_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK1RSCE))+(Inv_LNFIN*modelStruct.d_modelPar_PK1RSCE_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK1RSCE));
K1RSCE_i = (((modelStruct.modelPar_K1RSCE+(Inv_L*modelStruct.modelPar_LK1RSCE))+(Inv_NFIN*modelStruct.modelPar_NK1RSCE))+(Inv_LNFIN*modelStruct.modelPar_PK1RSCE));
d_LPE0_i_dX = (((modelStruct.d_modelPar_LPE0_dX+(Inv_L*modelStruct.d_modelPar_LLPE0_dX+d_Inv_L_dX*modelStruct.modelPar_LLPE0))+(Inv_NFIN*modelStruct.d_modelPar_NLPE0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NLPE0))+(Inv_LNFIN*modelStruct.d_modelPar_PLPE0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PLPE0));
LPE0_i = (((modelStruct.modelPar_LPE0+(Inv_L*modelStruct.modelPar_LLPE0))+(Inv_NFIN*modelStruct.modelPar_NLPE0))+(Inv_LNFIN*modelStruct.modelPar_PLPE0));
d_DVTSHIFT_i_dX = (((modelStruct.d_modelPar_DVTSHIFT_dX+(Inv_L*modelStruct.d_modelPar_LDVTSHIFT_dX+d_Inv_L_dX*modelStruct.modelPar_LDVTSHIFT))+(Inv_NFIN*modelStruct.d_modelPar_NDVTSHIFT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDVTSHIFT))+(Inv_LNFIN*modelStruct.d_modelPar_PDVTSHIFT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDVTSHIFT));
DVTSHIFT_i = (((modelStruct.modelPar_DVTSHIFT+(Inv_L*modelStruct.modelPar_LDVTSHIFT))+(Inv_NFIN*modelStruct.modelPar_NDVTSHIFT))+(Inv_LNFIN*modelStruct.modelPar_PDVTSHIFT));
d_K0_i_dX = (((modelStruct.d_modelPar_K0_dX+(Inv_L*modelStruct.d_modelPar_LK0_dX+d_Inv_L_dX*modelStruct.modelPar_LK0))+(Inv_NFIN*modelStruct.d_modelPar_NK0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK0))+(Inv_LNFIN*modelStruct.d_modelPar_PK0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK0));
K0_i = (((modelStruct.modelPar_K0+(Inv_L*modelStruct.modelPar_LK0))+(Inv_NFIN*modelStruct.modelPar_NK0))+(Inv_LNFIN*modelStruct.modelPar_PK0));
d_K01_i_dX = (((modelStruct.d_modelPar_K01_dX+(Inv_L*modelStruct.d_modelPar_LK01_dX+d_Inv_L_dX*modelStruct.modelPar_LK01))+(Inv_NFIN*modelStruct.d_modelPar_NK01_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK01))+(Inv_LNFIN*modelStruct.d_modelPar_PK01_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK01));
K01_i = (((modelStruct.modelPar_K01+(Inv_L*modelStruct.modelPar_LK01))+(Inv_NFIN*modelStruct.modelPar_NK01))+(Inv_LNFIN*modelStruct.modelPar_PK01));
d_K0SI_i_dX = (((modelStruct.d_modelPar_K0SI_dX+(Inv_L*modelStruct.d_modelPar_LK0SI_dX+d_Inv_L_dX*modelStruct.modelPar_LK0SI))+(Inv_NFIN*modelStruct.d_modelPar_NK0SI_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK0SI))+(Inv_LNFIN*modelStruct.d_modelPar_PK0SI_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK0SI));
K0SI_i = (((modelStruct.modelPar_K0SI+(Inv_L*modelStruct.modelPar_LK0SI))+(Inv_NFIN*modelStruct.modelPar_NK0SI))+(Inv_LNFIN*modelStruct.modelPar_PK0SI));
d_K0SI1_i_dX = (((modelStruct.d_modelPar_K0SI1_dX+(Inv_L*modelStruct.d_modelPar_LK0SI1_dX+d_Inv_L_dX*modelStruct.modelPar_LK0SI1))+(Inv_NFIN*modelStruct.d_modelPar_NK0SI1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK0SI1))+(Inv_LNFIN*modelStruct.d_modelPar_PK0SI1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK0SI1));
K0SI1_i = (((modelStruct.modelPar_K0SI1+(Inv_L*modelStruct.modelPar_LK0SI1))+(Inv_NFIN*modelStruct.modelPar_NK0SI1))+(Inv_LNFIN*modelStruct.modelPar_PK0SI1));
d_K1SI_i_dX = (((modelStruct.d_modelPar_K1SI_dX+(Inv_L*modelStruct.d_modelPar_LK1SI_dX+d_Inv_L_dX*modelStruct.modelPar_LK1SI))+(Inv_NFIN*modelStruct.d_modelPar_NK1SI_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK1SI))+(Inv_LNFIN*modelStruct.d_modelPar_PK1SI_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK1SI));
K1SI_i = (((modelStruct.modelPar_K1SI+(Inv_L*modelStruct.modelPar_LK1SI))+(Inv_NFIN*modelStruct.modelPar_NK1SI))+(Inv_LNFIN*modelStruct.modelPar_PK1SI));
d_K1SI1_i_dX = (((modelStruct.d_modelPar_K1SI1_dX+(Inv_L*modelStruct.d_modelPar_LK1SI1_dX+d_Inv_L_dX*modelStruct.modelPar_LK1SI1))+(Inv_NFIN*modelStruct.d_modelPar_NK1SI1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK1SI1))+(Inv_LNFIN*modelStruct.d_modelPar_PK1SI1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK1SI1));
K1SI1_i = (((modelStruct.modelPar_K1SI1+(Inv_L*modelStruct.modelPar_LK1SI1))+(Inv_NFIN*modelStruct.modelPar_NK1SI1))+(Inv_LNFIN*modelStruct.modelPar_PK1SI1));
if ((modelStruct.modelPar_BULKMOD!=0))
{
d_PHIBE_i_dX = (((modelStruct.d_modelPar_PHIBE_dX+(Inv_L*modelStruct.d_modelPar_LPHIBE_dX+d_Inv_L_dX*modelStruct.modelPar_LPHIBE))+(Inv_NFIN*modelStruct.d_modelPar_NPHIBE_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPHIBE))+(Inv_LNFIN*modelStruct.d_modelPar_PPHIBE_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPHIBE));
PHIBE_i = (((modelStruct.modelPar_PHIBE+(Inv_L*modelStruct.modelPar_LPHIBE))+(Inv_NFIN*modelStruct.modelPar_NPHIBE))+(Inv_LNFIN*modelStruct.modelPar_PPHIBE));
d_K1_i_dX = (((modelStruct.d_modelPar_K1_dX+(Inv_L*modelStruct.d_modelPar_LK1_dX+d_Inv_L_dX*modelStruct.modelPar_LK1))+(Inv_NFIN*modelStruct.d_modelPar_NK1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK1))+(Inv_LNFIN*modelStruct.d_modelPar_PK1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK1));
K1_i = (((modelStruct.modelPar_K1+(Inv_L*modelStruct.modelPar_LK1))+(Inv_NFIN*modelStruct.modelPar_NK1))+(Inv_LNFIN*modelStruct.modelPar_PK1));
d_K11_i_dX = (((modelStruct.d_modelPar_K11_dX+(Inv_L*modelStruct.d_modelPar_LK11_dX+d_Inv_L_dX*modelStruct.modelPar_LK11))+(Inv_NFIN*modelStruct.d_modelPar_NK11_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK11))+(Inv_LNFIN*modelStruct.d_modelPar_PK11_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK11));
K11_i = (((modelStruct.modelPar_K11+(Inv_L*modelStruct.modelPar_LK11))+(Inv_NFIN*modelStruct.modelPar_NK11))+(Inv_LNFIN*modelStruct.modelPar_PK11));
d_K1SAT_i_dX = (((modelStruct.d_modelPar_K1SAT_dX+(Inv_L*modelStruct.d_modelPar_LK1SAT_dX+d_Inv_L_dX*modelStruct.modelPar_LK1SAT))+(Inv_NFIN*modelStruct.d_modelPar_NK1SAT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK1SAT))+(Inv_LNFIN*modelStruct.d_modelPar_PK1SAT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK1SAT));
K1SAT_i = (((modelStruct.modelPar_K1SAT+(Inv_L*modelStruct.modelPar_LK1SAT))+(Inv_NFIN*modelStruct.modelPar_NK1SAT))+(Inv_LNFIN*modelStruct.modelPar_PK1SAT));
d_K1SAT1_i_dX = (((modelStruct.d_modelPar_K1SAT1_dX+(Inv_L*modelStruct.d_modelPar_LK1SAT1_dX+d_Inv_L_dX*modelStruct.modelPar_LK1SAT1))+(Inv_NFIN*modelStruct.d_modelPar_NK1SAT1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NK1SAT1))+(Inv_LNFIN*modelStruct.d_modelPar_PK1SAT1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PK1SAT1));
K1SAT1_i = (((modelStruct.modelPar_K1SAT1+(Inv_L*modelStruct.modelPar_LK1SAT1))+(Inv_NFIN*modelStruct.modelPar_NK1SAT1))+(Inv_LNFIN*modelStruct.modelPar_PK1SAT1));
}
d_QMFACTOR_i_dX = (((modelStruct.d_modelPar_QMFACTOR_dX+(Inv_L*modelStruct.d_modelPar_LQMFACTOR_dX+d_Inv_L_dX*modelStruct.modelPar_LQMFACTOR))+(Inv_NFIN*modelStruct.d_modelPar_NQMFACTOR_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NQMFACTOR))+(Inv_LNFIN*modelStruct.d_modelPar_PQMFACTOR_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PQMFACTOR));
QMFACTOR_i = (((modelStruct.modelPar_QMFACTOR+(Inv_L*modelStruct.modelPar_LQMFACTOR))+(Inv_NFIN*modelStruct.modelPar_NQMFACTOR))+(Inv_LNFIN*modelStruct.modelPar_PQMFACTOR));
d_QMTCENIV_i_dX = (((modelStruct.d_modelPar_QMTCENIV_dX+(Inv_L*modelStruct.d_modelPar_LQMTCENIV_dX+d_Inv_L_dX*modelStruct.modelPar_LQMTCENIV))+(Inv_NFIN*modelStruct.d_modelPar_NQMTCENIV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NQMTCENIV))+(Inv_LNFIN*modelStruct.d_modelPar_PQMTCENIV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PQMTCENIV));
QMTCENIV_i = (((modelStruct.modelPar_QMTCENIV+(Inv_L*modelStruct.modelPar_LQMTCENIV))+(Inv_NFIN*modelStruct.modelPar_NQMTCENIV))+(Inv_LNFIN*modelStruct.modelPar_PQMTCENIV));
d_QMTCENCV_i_dX = (((modelStruct.d_modelPar_QMTCENCV_dX+(Inv_L*modelStruct.d_modelPar_LQMTCENCV_dX+d_Inv_L_dX*modelStruct.modelPar_LQMTCENCV))+(Inv_NFIN*modelStruct.d_modelPar_NQMTCENCV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NQMTCENCV))+(Inv_LNFIN*modelStruct.d_modelPar_PQMTCENCV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PQMTCENCV));
QMTCENCV_i = (((modelStruct.modelPar_QMTCENCV+(Inv_L*modelStruct.modelPar_LQMTCENCV))+(Inv_NFIN*modelStruct.modelPar_NQMTCENCV))+(Inv_LNFIN*modelStruct.modelPar_PQMTCENCV));
d_QMTCENCVA_i_dX = (((modelStruct.d_modelPar_QMTCENCVA_dX+(Inv_L*modelStruct.d_modelPar_LQMTCENCVA_dX+d_Inv_L_dX*modelStruct.modelPar_LQMTCENCVA))+(Inv_NFIN*modelStruct.d_modelPar_NQMTCENCVA_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NQMTCENCVA))+(Inv_LNFIN*modelStruct.d_modelPar_PQMTCENCVA_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PQMTCENCVA));
QMTCENCVA_i = (((modelStruct.modelPar_QMTCENCVA+(Inv_L*modelStruct.modelPar_LQMTCENCVA))+(Inv_NFIN*modelStruct.modelPar_NQMTCENCVA))+(Inv_LNFIN*modelStruct.modelPar_PQMTCENCVA));
d_VSAT_i_dX = (((modelStruct.d_modelPar_VSAT_dX+(Inv_L*modelStruct.d_modelPar_LVSAT_dX+d_Inv_L_dX*modelStruct.modelPar_LVSAT))+(Inv_NFIN*modelStruct.d_modelPar_NVSAT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NVSAT))+(Inv_LNFIN*modelStruct.d_modelPar_PVSAT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PVSAT));
VSAT_i = (((modelStruct.modelPar_VSAT+(Inv_L*modelStruct.modelPar_LVSAT))+(Inv_NFIN*modelStruct.modelPar_NVSAT))+(Inv_LNFIN*modelStruct.modelPar_PVSAT));
d_VSAT1_i_dX = (((modelStruct.d_modelPar_VSAT1_dX+(Inv_L*modelStruct.d_modelPar_LVSAT1_dX+d_Inv_L_dX*modelStruct.modelPar_LVSAT1))+(Inv_NFIN*modelStruct.d_modelPar_NVSAT1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NVSAT1))+(Inv_LNFIN*modelStruct.d_modelPar_PVSAT1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PVSAT1));
VSAT1_i = (((modelStruct.modelPar_VSAT1+(Inv_L*modelStruct.modelPar_LVSAT1))+(Inv_NFIN*modelStruct.modelPar_NVSAT1))+(Inv_LNFIN*modelStruct.modelPar_PVSAT1));
d_VSATCV_i_dX = (((modelStruct.d_modelPar_VSATCV_dX+(Inv_L*modelStruct.d_modelPar_LVSATCV_dX+d_Inv_L_dX*modelStruct.modelPar_LVSATCV))+(Inv_NFIN*modelStruct.d_modelPar_NVSATCV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NVSATCV))+(Inv_LNFIN*modelStruct.d_modelPar_PVSATCV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PVSATCV));
VSATCV_i = (((modelStruct.modelPar_VSATCV+(Inv_L*modelStruct.modelPar_LVSATCV))+(Inv_NFIN*modelStruct.modelPar_NVSATCV))+(Inv_LNFIN*modelStruct.modelPar_PVSATCV));
d_DELTAVSAT_i_dX = (((modelStruct.d_modelPar_DELTAVSAT_dX+(Inv_L*modelStruct.d_modelPar_LDELTAVSAT_dX+d_Inv_L_dX*modelStruct.modelPar_LDELTAVSAT))+(Inv_NFIN*modelStruct.d_modelPar_NDELTAVSAT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDELTAVSAT))+(Inv_LNFIN*modelStruct.d_modelPar_PDELTAVSAT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDELTAVSAT));
DELTAVSAT_i = (((modelStruct.modelPar_DELTAVSAT+(Inv_L*modelStruct.modelPar_LDELTAVSAT))+(Inv_NFIN*modelStruct.modelPar_NDELTAVSAT))+(Inv_LNFIN*modelStruct.modelPar_PDELTAVSAT));
d_PSAT_i_dX = (((modelStruct.d_modelPar_PSAT_dX+(Inv_L*modelStruct.d_modelPar_LPSAT_dX+d_Inv_L_dX*modelStruct.modelPar_LPSAT))+(Inv_NFIN*modelStruct.d_modelPar_NPSAT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPSAT))+(Inv_LNFIN*modelStruct.d_modelPar_PPSAT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPSAT));
PSAT_i = (((modelStruct.modelPar_PSAT+(Inv_L*modelStruct.modelPar_LPSAT))+(Inv_NFIN*modelStruct.modelPar_NPSAT))+(Inv_LNFIN*modelStruct.modelPar_PPSAT));
d_DELTAVSATCV_i_dX = (((modelStruct.d_modelPar_DELTAVSATCV_dX+(Inv_L*modelStruct.d_modelPar_LDELTAVSATCV_dX+d_Inv_L_dX*modelStruct.modelPar_LDELTAVSATCV))+(Inv_NFIN*modelStruct.d_modelPar_NDELTAVSATCV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDELTAVSATCV))+(Inv_LNFIN*modelStruct.d_modelPar_PDELTAVSATCV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDELTAVSATCV));
DELTAVSATCV_i = (((modelStruct.modelPar_DELTAVSATCV+(Inv_L*modelStruct.modelPar_LDELTAVSATCV))+(Inv_NFIN*modelStruct.modelPar_NDELTAVSATCV))+(Inv_LNFIN*modelStruct.modelPar_PDELTAVSATCV));
d_PSATCV_i_dX = (((modelStruct.d_modelPar_PSATCV_dX+(Inv_L*modelStruct.d_modelPar_LPSATCV_dX+d_Inv_L_dX*modelStruct.modelPar_LPSATCV))+(Inv_NFIN*modelStruct.d_modelPar_NPSATCV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPSATCV))+(Inv_LNFIN*modelStruct.d_modelPar_PPSATCV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPSATCV));
PSATCV_i = (((modelStruct.modelPar_PSATCV+(Inv_L*modelStruct.modelPar_LPSATCV))+(Inv_NFIN*modelStruct.modelPar_NPSATCV))+(Inv_LNFIN*modelStruct.modelPar_PPSATCV));
d_KSATIV_i_dX = (((modelStruct.d_modelPar_KSATIV_dX+(Inv_L*modelStruct.d_modelPar_LKSATIV_dX+d_Inv_L_dX*modelStruct.modelPar_LKSATIV))+(Inv_NFIN*modelStruct.d_modelPar_NKSATIV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NKSATIV))+(Inv_LNFIN*modelStruct.d_modelPar_PKSATIV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PKSATIV));
KSATIV_i = (((modelStruct.modelPar_KSATIV+(Inv_L*modelStruct.modelPar_LKSATIV))+(Inv_NFIN*modelStruct.modelPar_NKSATIV))+(Inv_LNFIN*modelStruct.modelPar_PKSATIV));
d_MEXP_i_dX = (((modelStruct.d_modelPar_MEXP_dX+(Inv_L*modelStruct.d_modelPar_LMEXP_dX+d_Inv_L_dX*modelStruct.modelPar_LMEXP))+(Inv_NFIN*modelStruct.d_modelPar_NMEXP_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NMEXP))+(Inv_LNFIN*modelStruct.d_modelPar_PMEXP_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PMEXP));
MEXP_i = (((modelStruct.modelPar_MEXP+(Inv_L*modelStruct.modelPar_LMEXP))+(Inv_NFIN*modelStruct.modelPar_NMEXP))+(Inv_LNFIN*modelStruct.modelPar_PMEXP));
d_PTWG_i_dX = (((modelStruct.d_modelPar_PTWG_dX+(Inv_L*modelStruct.d_modelPar_LPTWG_dX+d_Inv_L_dX*modelStruct.modelPar_LPTWG))+(Inv_NFIN*modelStruct.d_modelPar_NPTWG_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPTWG))+(Inv_LNFIN*modelStruct.d_modelPar_PPTWG_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPTWG));
PTWG_i = (((modelStruct.modelPar_PTWG+(Inv_L*modelStruct.modelPar_LPTWG))+(Inv_NFIN*modelStruct.modelPar_NPTWG))+(Inv_LNFIN*modelStruct.modelPar_PPTWG));
d_U0_i_dX = (((modelStruct.d_modelPar_U0_dX+(Inv_L*modelStruct.d_modelPar_LU0_dX+d_Inv_L_dX*modelStruct.modelPar_LU0))+(Inv_NFIN*modelStruct.d_modelPar_NU0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NU0))+(Inv_LNFIN*modelStruct.d_modelPar_PU0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PU0));
U0_i = (((modelStruct.modelPar_U0+(Inv_L*modelStruct.modelPar_LU0))+(Inv_NFIN*modelStruct.modelPar_NU0))+(Inv_LNFIN*modelStruct.modelPar_PU0));
d_ETAMOB_i_dX = (((modelStruct.d_modelPar_ETAMOB_dX+(Inv_L*modelStruct.d_modelPar_LETAMOB_dX+d_Inv_L_dX*modelStruct.modelPar_LETAMOB))+(Inv_NFIN*modelStruct.d_modelPar_NETAMOB_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NETAMOB))+(Inv_LNFIN*modelStruct.d_modelPar_PETAMOB_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PETAMOB));
ETAMOB_i = (((modelStruct.modelPar_ETAMOB+(Inv_L*modelStruct.modelPar_LETAMOB))+(Inv_NFIN*modelStruct.modelPar_NETAMOB))+(Inv_LNFIN*modelStruct.modelPar_PETAMOB));
d_UP_i_dX = (((modelStruct.d_modelPar_UP_dX+(Inv_L*modelStruct.d_modelPar_LUP_dX+d_Inv_L_dX*modelStruct.modelPar_LUP))+(Inv_NFIN*modelStruct.d_modelPar_NUP_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUP))+(Inv_LNFIN*modelStruct.d_modelPar_PUP_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUP));
UP_i = (((modelStruct.modelPar_UP+(Inv_L*modelStruct.modelPar_LUP))+(Inv_NFIN*modelStruct.modelPar_NUP))+(Inv_LNFIN*modelStruct.modelPar_PUP));
d_UA_i_dX = (((modelStruct.d_modelPar_UA_dX+(Inv_L*modelStruct.d_modelPar_LUA_dX+d_Inv_L_dX*modelStruct.modelPar_LUA))+(Inv_NFIN*modelStruct.d_modelPar_NUA_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUA))+(Inv_LNFIN*modelStruct.d_modelPar_PUA_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUA));
UA_i = (((modelStruct.modelPar_UA+(Inv_L*modelStruct.modelPar_LUA))+(Inv_NFIN*modelStruct.modelPar_NUA))+(Inv_LNFIN*modelStruct.modelPar_PUA));
if ((modelStruct.modelPar_BULKMOD!=0))
{
d_UC_i_dX = (((modelStruct.d_modelPar_UC_dX+(Inv_L*modelStruct.d_modelPar_LUC_dX+d_Inv_L_dX*modelStruct.modelPar_LUC))+(Inv_NFIN*modelStruct.d_modelPar_NUC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUC))+(Inv_LNFIN*modelStruct.d_modelPar_PUC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUC));
UC_i = (((modelStruct.modelPar_UC+(Inv_L*modelStruct.modelPar_LUC))+(Inv_NFIN*modelStruct.modelPar_NUC))+(Inv_LNFIN*modelStruct.modelPar_PUC));
}
d_EU_i_dX = (((modelStruct.d_modelPar_EU_dX+(Inv_L*modelStruct.d_modelPar_LEU_dX+d_Inv_L_dX*modelStruct.modelPar_LEU))+(Inv_NFIN*modelStruct.d_modelPar_NEU_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NEU))+(Inv_LNFIN*modelStruct.d_modelPar_PEU_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PEU));
EU_i = (((modelStruct.modelPar_EU+(Inv_L*modelStruct.modelPar_LEU))+(Inv_NFIN*modelStruct.modelPar_NEU))+(Inv_LNFIN*modelStruct.modelPar_PEU));
d_UD_i_dX = (((modelStruct.d_modelPar_UD_dX+(Inv_L*modelStruct.d_modelPar_LUD_dX+d_Inv_L_dX*modelStruct.modelPar_LUD))+(Inv_NFIN*modelStruct.d_modelPar_NUD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUD))+(Inv_LNFIN*modelStruct.d_modelPar_PUD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUD));
UD_i = (((modelStruct.modelPar_UD+(Inv_L*modelStruct.modelPar_LUD))+(Inv_NFIN*modelStruct.modelPar_NUD))+(Inv_LNFIN*modelStruct.modelPar_PUD));
d_UCS_i_dX = (((modelStruct.d_modelPar_UCS_dX+(Inv_L*modelStruct.d_modelPar_LUCS_dX+d_Inv_L_dX*modelStruct.modelPar_LUCS))+(Inv_NFIN*modelStruct.d_modelPar_NUCS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUCS))+(Inv_LNFIN*modelStruct.d_modelPar_PUCS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUCS));
UCS_i = (((modelStruct.modelPar_UCS+(Inv_L*modelStruct.modelPar_LUCS))+(Inv_NFIN*modelStruct.modelPar_NUCS))+(Inv_LNFIN*modelStruct.modelPar_PUCS));
d_PCLM_i_dX = (((modelStruct.d_modelPar_PCLM_dX+(Inv_L*modelStruct.d_modelPar_LPCLM_dX+d_Inv_L_dX*modelStruct.modelPar_LPCLM))+(Inv_NFIN*modelStruct.d_modelPar_NPCLM_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPCLM))+(Inv_LNFIN*modelStruct.d_modelPar_PPCLM_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPCLM));
PCLM_i = (((modelStruct.modelPar_PCLM+(Inv_L*modelStruct.modelPar_LPCLM))+(Inv_NFIN*modelStruct.modelPar_NPCLM))+(Inv_LNFIN*modelStruct.modelPar_PPCLM));
d_PCLMG_i_dX = (((modelStruct.d_modelPar_PCLMG_dX+(Inv_L*modelStruct.d_modelPar_LPCLMG_dX+d_Inv_L_dX*modelStruct.modelPar_LPCLMG))+(Inv_NFIN*modelStruct.d_modelPar_NPCLMG_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPCLMG))+(Inv_LNFIN*modelStruct.d_modelPar_PPCLMG_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPCLMG));
PCLMG_i = (((modelStruct.modelPar_PCLMG+(Inv_L*modelStruct.modelPar_LPCLMG))+(Inv_NFIN*modelStruct.modelPar_NPCLMG))+(Inv_LNFIN*modelStruct.modelPar_PPCLMG));
d_PCLMCV_i_dX = (((modelStruct.d_modelPar_PCLMCV_dX+(Inv_L*modelStruct.d_modelPar_LPCLMCV_dX+d_Inv_L_dX*modelStruct.modelPar_LPCLMCV))+(Inv_NFIN*modelStruct.d_modelPar_NPCLMCV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPCLMCV))+(Inv_LNFIN*modelStruct.d_modelPar_PPCLMCV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPCLMCV));
PCLMCV_i = (((modelStruct.modelPar_PCLMCV+(Inv_L*modelStruct.modelPar_LPCLMCV))+(Inv_NFIN*modelStruct.modelPar_NPCLMCV))+(Inv_LNFIN*modelStruct.modelPar_PPCLMCV));
d_A1_i_dX = (((modelStruct.d_modelPar_A1_dX+(Inv_L*modelStruct.d_modelPar_LA1_dX+d_Inv_L_dX*modelStruct.modelPar_LA1))+(Inv_NFIN*modelStruct.d_modelPar_NA1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NA1))+(Inv_LNFIN*modelStruct.d_modelPar_PA1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PA1));
A1_i = (((modelStruct.modelPar_A1+(Inv_L*modelStruct.modelPar_LA1))+(Inv_NFIN*modelStruct.modelPar_NA1))+(Inv_LNFIN*modelStruct.modelPar_PA1));
d_A11_i_dX = (((modelStruct.d_modelPar_A11_dX+(Inv_L*modelStruct.d_modelPar_LA11_dX+d_Inv_L_dX*modelStruct.modelPar_LA11))+(Inv_NFIN*modelStruct.d_modelPar_NA11_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NA11))+(Inv_LNFIN*modelStruct.d_modelPar_PA11_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PA11));
A11_i = (((modelStruct.modelPar_A11+(Inv_L*modelStruct.modelPar_LA11))+(Inv_NFIN*modelStruct.modelPar_NA11))+(Inv_LNFIN*modelStruct.modelPar_PA11));
d_A2_i_dX = (((modelStruct.d_modelPar_A2_dX+(Inv_L*modelStruct.d_modelPar_LA2_dX+d_Inv_L_dX*modelStruct.modelPar_LA2))+(Inv_NFIN*modelStruct.d_modelPar_NA2_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NA2))+(Inv_LNFIN*modelStruct.d_modelPar_PA2_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PA2));
A2_i = (((modelStruct.modelPar_A2+(Inv_L*modelStruct.modelPar_LA2))+(Inv_NFIN*modelStruct.modelPar_NA2))+(Inv_LNFIN*modelStruct.modelPar_PA2));
d_A21_i_dX = (((modelStruct.d_modelPar_A21_dX+(Inv_L*modelStruct.d_modelPar_LA21_dX+d_Inv_L_dX*modelStruct.modelPar_LA21))+(Inv_NFIN*modelStruct.d_modelPar_NA21_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NA21))+(Inv_LNFIN*modelStruct.d_modelPar_PA21_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PA21));
A21_i = (((modelStruct.modelPar_A21+(Inv_L*modelStruct.modelPar_LA21))+(Inv_NFIN*modelStruct.modelPar_NA21))+(Inv_LNFIN*modelStruct.modelPar_PA21));
d_RDSW_i_dX = (((modelStruct.d_modelPar_RDSW_dX+(Inv_L*modelStruct.d_modelPar_LRDSW_dX+d_Inv_L_dX*modelStruct.modelPar_LRDSW))+(Inv_NFIN*modelStruct.d_modelPar_NRDSW_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NRDSW))+(Inv_LNFIN*modelStruct.d_modelPar_PRDSW_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PRDSW));
RDSW_i = (((modelStruct.modelPar_RDSW+(Inv_L*modelStruct.modelPar_LRDSW))+(Inv_NFIN*modelStruct.modelPar_NRDSW))+(Inv_LNFIN*modelStruct.modelPar_PRDSW));
d_RSW_i_dX = (((modelStruct.d_modelPar_RSW_dX+(Inv_L*modelStruct.d_modelPar_LRSW_dX+d_Inv_L_dX*modelStruct.modelPar_LRSW))+(Inv_NFIN*modelStruct.d_modelPar_NRSW_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NRSW))+(Inv_LNFIN*modelStruct.d_modelPar_PRSW_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PRSW));
RSW_i = (((modelStruct.modelPar_RSW+(Inv_L*modelStruct.modelPar_LRSW))+(Inv_NFIN*modelStruct.modelPar_NRSW))+(Inv_LNFIN*modelStruct.modelPar_PRSW));
d_RDW_i_dX = (((modelStruct.d_modelPar_RDW_dX+(Inv_L*modelStruct.d_modelPar_LRDW_dX+d_Inv_L_dX*modelStruct.modelPar_LRDW))+(Inv_NFIN*modelStruct.d_modelPar_NRDW_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NRDW))+(Inv_LNFIN*modelStruct.d_modelPar_PRDW_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PRDW));
RDW_i = (((modelStruct.modelPar_RDW+(Inv_L*modelStruct.modelPar_LRDW))+(Inv_NFIN*modelStruct.modelPar_NRDW))+(Inv_LNFIN*modelStruct.modelPar_PRDW));
d_PRWGD_i_dX = (((modelStruct.d_modelPar_PRWGD_dX+(Inv_L*modelStruct.d_modelPar_LPRWGD_dX+d_Inv_L_dX*modelStruct.modelPar_LPRWGD))+(Inv_NFIN*modelStruct.d_modelPar_NPRWGD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPRWGD))+(Inv_LNFIN*modelStruct.d_modelPar_PPRWGD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPRWGD));
PRWGD_i = (((modelStruct.modelPar_PRWGD+(Inv_L*modelStruct.modelPar_LPRWGD))+(Inv_NFIN*modelStruct.modelPar_NPRWGD))+(Inv_LNFIN*modelStruct.modelPar_PPRWGD));
d_PRWGS_i_dX = (((modelStruct.d_modelPar_PRWGS_dX+(Inv_L*modelStruct.d_modelPar_LPRWGS_dX+d_Inv_L_dX*modelStruct.modelPar_LPRWGS))+(Inv_NFIN*modelStruct.d_modelPar_NPRWGS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPRWGS))+(Inv_LNFIN*modelStruct.d_modelPar_PPRWGS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPRWGS));
PRWGS_i = (((modelStruct.modelPar_PRWGS+(Inv_L*modelStruct.modelPar_LPRWGS))+(Inv_NFIN*modelStruct.modelPar_NPRWGS))+(Inv_LNFIN*modelStruct.modelPar_PPRWGS));
d_WR_i_dX = (((modelStruct.d_modelPar_WR_dX+(Inv_L*modelStruct.d_modelPar_LWR_dX+d_Inv_L_dX*modelStruct.modelPar_LWR))+(Inv_NFIN*modelStruct.d_modelPar_NWR_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NWR))+(Inv_LNFIN*modelStruct.d_modelPar_PWR_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PWR));
WR_i = (((modelStruct.modelPar_WR+(Inv_L*modelStruct.modelPar_LWR))+(Inv_NFIN*modelStruct.modelPar_NWR))+(Inv_LNFIN*modelStruct.modelPar_PWR));
d_PDIBL1_i_dX = (((modelStruct.d_modelPar_PDIBL1_dX+(Inv_L*modelStruct.d_modelPar_LPDIBL1_dX+d_Inv_L_dX*modelStruct.modelPar_LPDIBL1))+(Inv_NFIN*modelStruct.d_modelPar_NPDIBL1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPDIBL1))+(Inv_LNFIN*modelStruct.d_modelPar_PPDIBL1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPDIBL1));
PDIBL1_i = (((modelStruct.modelPar_PDIBL1+(Inv_L*modelStruct.modelPar_LPDIBL1))+(Inv_NFIN*modelStruct.modelPar_NPDIBL1))+(Inv_LNFIN*modelStruct.modelPar_PPDIBL1));
d_PDIBL2_i_dX = (((modelStruct.d_modelPar_PDIBL2_dX+(Inv_L*modelStruct.d_modelPar_LPDIBL2_dX+d_Inv_L_dX*modelStruct.modelPar_LPDIBL2))+(Inv_NFIN*modelStruct.d_modelPar_NPDIBL2_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPDIBL2))+(Inv_LNFIN*modelStruct.d_modelPar_PPDIBL2_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPDIBL2));
PDIBL2_i = (((modelStruct.modelPar_PDIBL2+(Inv_L*modelStruct.modelPar_LPDIBL2))+(Inv_NFIN*modelStruct.modelPar_NPDIBL2))+(Inv_LNFIN*modelStruct.modelPar_PPDIBL2));
d_DROUT_i_dX = (((modelStruct.d_modelPar_DROUT_dX+(Inv_L*modelStruct.d_modelPar_LDROUT_dX+d_Inv_L_dX*modelStruct.modelPar_LDROUT))+(Inv_NFIN*modelStruct.d_modelPar_NDROUT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NDROUT))+(Inv_LNFIN*modelStruct.d_modelPar_PDROUT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PDROUT));
DROUT_i = (((modelStruct.modelPar_DROUT+(Inv_L*modelStruct.modelPar_LDROUT))+(Inv_NFIN*modelStruct.modelPar_NDROUT))+(Inv_LNFIN*modelStruct.modelPar_PDROUT));
d_PVAG_i_dX = (((modelStruct.d_modelPar_PVAG_dX+(Inv_L*modelStruct.d_modelPar_LPVAG_dX+d_Inv_L_dX*modelStruct.modelPar_LPVAG))+(Inv_NFIN*modelStruct.d_modelPar_NPVAG_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPVAG))+(Inv_LNFIN*modelStruct.d_modelPar_PPVAG_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPVAG));
PVAG_i = (((modelStruct.modelPar_PVAG+(Inv_L*modelStruct.modelPar_LPVAG))+(Inv_NFIN*modelStruct.modelPar_NPVAG))+(Inv_LNFIN*modelStruct.modelPar_PPVAG));
d_AIGBINV_i_dX = (((modelStruct.d_modelPar_AIGBINV_dX+(Inv_L*modelStruct.d_modelPar_LAIGBINV_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGBINV))+(Inv_NFIN*modelStruct.d_modelPar_NAIGBINV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGBINV))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGBINV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGBINV));
AIGBINV_i = (((modelStruct.modelPar_AIGBINV+(Inv_L*modelStruct.modelPar_LAIGBINV))+(Inv_NFIN*modelStruct.modelPar_NAIGBINV))+(Inv_LNFIN*modelStruct.modelPar_PAIGBINV));
d_AIGBINV1_i_dX = (((modelStruct.d_modelPar_AIGBINV1_dX+(Inv_L*modelStruct.d_modelPar_LAIGBINV1_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGBINV1))+(Inv_NFIN*modelStruct.d_modelPar_NAIGBINV1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGBINV1))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGBINV1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGBINV1));
AIGBINV1_i = (((modelStruct.modelPar_AIGBINV1+(Inv_L*modelStruct.modelPar_LAIGBINV1))+(Inv_NFIN*modelStruct.modelPar_NAIGBINV1))+(Inv_LNFIN*modelStruct.modelPar_PAIGBINV1));
d_BIGBINV_i_dX = (((modelStruct.d_modelPar_BIGBINV_dX+(Inv_L*modelStruct.d_modelPar_LBIGBINV_dX+d_Inv_L_dX*modelStruct.modelPar_LBIGBINV))+(Inv_NFIN*modelStruct.d_modelPar_NBIGBINV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBIGBINV))+(Inv_LNFIN*modelStruct.d_modelPar_PBIGBINV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBIGBINV));
BIGBINV_i = (((modelStruct.modelPar_BIGBINV+(Inv_L*modelStruct.modelPar_LBIGBINV))+(Inv_NFIN*modelStruct.modelPar_NBIGBINV))+(Inv_LNFIN*modelStruct.modelPar_PBIGBINV));
d_CIGBINV_i_dX = (((modelStruct.d_modelPar_CIGBINV_dX+(Inv_L*modelStruct.d_modelPar_LCIGBINV_dX+d_Inv_L_dX*modelStruct.modelPar_LCIGBINV))+(Inv_NFIN*modelStruct.d_modelPar_NCIGBINV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCIGBINV))+(Inv_LNFIN*modelStruct.d_modelPar_PCIGBINV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCIGBINV));
CIGBINV_i = (((modelStruct.modelPar_CIGBINV+(Inv_L*modelStruct.modelPar_LCIGBINV))+(Inv_NFIN*modelStruct.modelPar_NCIGBINV))+(Inv_LNFIN*modelStruct.modelPar_PCIGBINV));
d_EIGBINV_i_dX = (((modelStruct.d_modelPar_EIGBINV_dX+(Inv_L*modelStruct.d_modelPar_LEIGBINV_dX+d_Inv_L_dX*modelStruct.modelPar_LEIGBINV))+(Inv_NFIN*modelStruct.d_modelPar_NEIGBINV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NEIGBINV))+(Inv_LNFIN*modelStruct.d_modelPar_PEIGBINV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PEIGBINV));
EIGBINV_i = (((modelStruct.modelPar_EIGBINV+(Inv_L*modelStruct.modelPar_LEIGBINV))+(Inv_NFIN*modelStruct.modelPar_NEIGBINV))+(Inv_LNFIN*modelStruct.modelPar_PEIGBINV));
d_NIGBINV_i_dX = (((modelStruct.d_modelPar_NIGBINV_dX+(Inv_L*modelStruct.d_modelPar_LNIGBINV_dX+d_Inv_L_dX*modelStruct.modelPar_LNIGBINV))+(Inv_NFIN*modelStruct.d_modelPar_NNIGBINV_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NNIGBINV))+(Inv_LNFIN*modelStruct.d_modelPar_PNIGBINV_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PNIGBINV));
NIGBINV_i = (((modelStruct.modelPar_NIGBINV+(Inv_L*modelStruct.modelPar_LNIGBINV))+(Inv_NFIN*modelStruct.modelPar_NNIGBINV))+(Inv_LNFIN*modelStruct.modelPar_PNIGBINV));
d_AIGBACC_i_dX = (((modelStruct.d_modelPar_AIGBACC_dX+(Inv_L*modelStruct.d_modelPar_LAIGBACC_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGBACC))+(Inv_NFIN*modelStruct.d_modelPar_NAIGBACC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGBACC))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGBACC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGBACC));
AIGBACC_i = (((modelStruct.modelPar_AIGBACC+(Inv_L*modelStruct.modelPar_LAIGBACC))+(Inv_NFIN*modelStruct.modelPar_NAIGBACC))+(Inv_LNFIN*modelStruct.modelPar_PAIGBACC));
d_AIGBACC1_i_dX = (((modelStruct.d_modelPar_AIGBACC1_dX+(Inv_L*modelStruct.d_modelPar_LAIGBACC1_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGBACC1))+(Inv_NFIN*modelStruct.d_modelPar_NAIGBACC1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGBACC1))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGBACC1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGBACC1));
AIGBACC1_i = (((modelStruct.modelPar_AIGBACC1+(Inv_L*modelStruct.modelPar_LAIGBACC1))+(Inv_NFIN*modelStruct.modelPar_NAIGBACC1))+(Inv_LNFIN*modelStruct.modelPar_PAIGBACC1));
d_BIGBACC_i_dX = (((modelStruct.d_modelPar_BIGBACC_dX+(Inv_L*modelStruct.d_modelPar_LBIGBACC_dX+d_Inv_L_dX*modelStruct.modelPar_LBIGBACC))+(Inv_NFIN*modelStruct.d_modelPar_NBIGBACC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBIGBACC))+(Inv_LNFIN*modelStruct.d_modelPar_PBIGBACC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBIGBACC));
BIGBACC_i = (((modelStruct.modelPar_BIGBACC+(Inv_L*modelStruct.modelPar_LBIGBACC))+(Inv_NFIN*modelStruct.modelPar_NBIGBACC))+(Inv_LNFIN*modelStruct.modelPar_PBIGBACC));
d_CIGBACC_i_dX = (((modelStruct.d_modelPar_CIGBACC_dX+(Inv_L*modelStruct.d_modelPar_LCIGBACC_dX+d_Inv_L_dX*modelStruct.modelPar_LCIGBACC))+(Inv_NFIN*modelStruct.d_modelPar_NCIGBACC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCIGBACC))+(Inv_LNFIN*modelStruct.d_modelPar_PCIGBACC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCIGBACC));
CIGBACC_i = (((modelStruct.modelPar_CIGBACC+(Inv_L*modelStruct.modelPar_LCIGBACC))+(Inv_NFIN*modelStruct.modelPar_NCIGBACC))+(Inv_LNFIN*modelStruct.modelPar_PCIGBACC));
d_NIGBACC_i_dX = (((modelStruct.d_modelPar_NIGBACC_dX+(Inv_L*modelStruct.d_modelPar_LNIGBACC_dX+d_Inv_L_dX*modelStruct.modelPar_LNIGBACC))+(Inv_NFIN*modelStruct.d_modelPar_NNIGBACC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NNIGBACC))+(Inv_LNFIN*modelStruct.d_modelPar_PNIGBACC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PNIGBACC));
NIGBACC_i = (((modelStruct.modelPar_NIGBACC+(Inv_L*modelStruct.modelPar_LNIGBACC))+(Inv_NFIN*modelStruct.modelPar_NNIGBACC))+(Inv_LNFIN*modelStruct.modelPar_PNIGBACC));
d_AIGC_i_dX = (((modelStruct.d_modelPar_AIGC_dX+(Inv_L*modelStruct.d_modelPar_LAIGC_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGC))+(Inv_NFIN*modelStruct.d_modelPar_NAIGC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGC))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGC));
AIGC_i = (((modelStruct.modelPar_AIGC+(Inv_L*modelStruct.modelPar_LAIGC))+(Inv_NFIN*modelStruct.modelPar_NAIGC))+(Inv_LNFIN*modelStruct.modelPar_PAIGC));
d_AIGC1_i_dX = (((modelStruct.d_modelPar_AIGC1_dX+(Inv_L*modelStruct.d_modelPar_LAIGC1_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGC1))+(Inv_NFIN*modelStruct.d_modelPar_NAIGC1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGC1))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGC1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGC1));
AIGC1_i = (((modelStruct.modelPar_AIGC1+(Inv_L*modelStruct.modelPar_LAIGC1))+(Inv_NFIN*modelStruct.modelPar_NAIGC1))+(Inv_LNFIN*modelStruct.modelPar_PAIGC1));
d_BIGC_i_dX = (((modelStruct.d_modelPar_BIGC_dX+(Inv_L*modelStruct.d_modelPar_LBIGC_dX+d_Inv_L_dX*modelStruct.modelPar_LBIGC))+(Inv_NFIN*modelStruct.d_modelPar_NBIGC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBIGC))+(Inv_LNFIN*modelStruct.d_modelPar_PBIGC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBIGC));
BIGC_i = (((modelStruct.modelPar_BIGC+(Inv_L*modelStruct.modelPar_LBIGC))+(Inv_NFIN*modelStruct.modelPar_NBIGC))+(Inv_LNFIN*modelStruct.modelPar_PBIGC));
d_CIGC_i_dX = (((modelStruct.d_modelPar_CIGC_dX+(Inv_L*modelStruct.d_modelPar_LCIGC_dX+d_Inv_L_dX*modelStruct.modelPar_LCIGC))+(Inv_NFIN*modelStruct.d_modelPar_NCIGC_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCIGC))+(Inv_LNFIN*modelStruct.d_modelPar_PCIGC_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCIGC));
CIGC_i = (((modelStruct.modelPar_CIGC+(Inv_L*modelStruct.modelPar_LCIGC))+(Inv_NFIN*modelStruct.modelPar_NCIGC))+(Inv_LNFIN*modelStruct.modelPar_PCIGC));
d_PIGCD_i_dX = (((modelStruct.d_modelPar_PIGCD_dX+(Inv_L*modelStruct.d_modelPar_LPIGCD_dX+d_Inv_L_dX*modelStruct.modelPar_LPIGCD))+(Inv_NFIN*modelStruct.d_modelPar_NPIGCD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPIGCD))+(Inv_LNFIN*modelStruct.d_modelPar_PPIGCD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPIGCD));
PIGCD_i = (((modelStruct.modelPar_PIGCD+(Inv_L*modelStruct.modelPar_LPIGCD))+(Inv_NFIN*modelStruct.modelPar_NPIGCD))+(Inv_LNFIN*modelStruct.modelPar_PPIGCD));
d_AIGS_i_dX = (((modelStruct.d_modelPar_AIGS_dX+(Inv_L*modelStruct.d_modelPar_LAIGS_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGS))+(Inv_NFIN*modelStruct.d_modelPar_NAIGS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGS))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGS));
AIGS_i = (((modelStruct.modelPar_AIGS+(Inv_L*modelStruct.modelPar_LAIGS))+(Inv_NFIN*modelStruct.modelPar_NAIGS))+(Inv_LNFIN*modelStruct.modelPar_PAIGS));
d_AIGS1_i_dX = (((modelStruct.d_modelPar_AIGS1_dX+(Inv_L*modelStruct.d_modelPar_LAIGS1_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGS1))+(Inv_NFIN*modelStruct.d_modelPar_NAIGS1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGS1))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGS1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGS1));
AIGS1_i = (((modelStruct.modelPar_AIGS1+(Inv_L*modelStruct.modelPar_LAIGS1))+(Inv_NFIN*modelStruct.modelPar_NAIGS1))+(Inv_LNFIN*modelStruct.modelPar_PAIGS1));
d_BIGS_i_dX = (((modelStruct.d_modelPar_BIGS_dX+(Inv_L*modelStruct.d_modelPar_LBIGS_dX+d_Inv_L_dX*modelStruct.modelPar_LBIGS))+(Inv_NFIN*modelStruct.d_modelPar_NBIGS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBIGS))+(Inv_LNFIN*modelStruct.d_modelPar_PBIGS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBIGS));
BIGS_i = (((modelStruct.modelPar_BIGS+(Inv_L*modelStruct.modelPar_LBIGS))+(Inv_NFIN*modelStruct.modelPar_NBIGS))+(Inv_LNFIN*modelStruct.modelPar_PBIGS));
d_CIGS_i_dX = (((modelStruct.d_modelPar_CIGS_dX+(Inv_L*modelStruct.d_modelPar_LCIGS_dX+d_Inv_L_dX*modelStruct.modelPar_LCIGS))+(Inv_NFIN*modelStruct.d_modelPar_NCIGS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCIGS))+(Inv_LNFIN*modelStruct.d_modelPar_PCIGS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCIGS));
CIGS_i = (((modelStruct.modelPar_CIGS+(Inv_L*modelStruct.modelPar_LCIGS))+(Inv_NFIN*modelStruct.modelPar_NCIGS))+(Inv_LNFIN*modelStruct.modelPar_PCIGS));
d_AIGD_i_dX = (((modelStruct.d_modelPar_AIGD_dX+(Inv_L*modelStruct.d_modelPar_LAIGD_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGD))+(Inv_NFIN*modelStruct.d_modelPar_NAIGD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGD))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGD));
AIGD_i = (((modelStruct.modelPar_AIGD+(Inv_L*modelStruct.modelPar_LAIGD))+(Inv_NFIN*modelStruct.modelPar_NAIGD))+(Inv_LNFIN*modelStruct.modelPar_PAIGD));
d_AIGD1_i_dX = (((modelStruct.d_modelPar_AIGD1_dX+(Inv_L*modelStruct.d_modelPar_LAIGD1_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGD1))+(Inv_NFIN*modelStruct.d_modelPar_NAIGD1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGD1))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGD1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGD1));
AIGD1_i = (((modelStruct.modelPar_AIGD1+(Inv_L*modelStruct.modelPar_LAIGD1))+(Inv_NFIN*modelStruct.modelPar_NAIGD1))+(Inv_LNFIN*modelStruct.modelPar_PAIGD1));
d_BIGD_i_dX = (((modelStruct.d_modelPar_BIGD_dX+(Inv_L*modelStruct.d_modelPar_LBIGD_dX+d_Inv_L_dX*modelStruct.modelPar_LBIGD))+(Inv_NFIN*modelStruct.d_modelPar_NBIGD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBIGD))+(Inv_LNFIN*modelStruct.d_modelPar_PBIGD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBIGD));
BIGD_i = (((modelStruct.modelPar_BIGD+(Inv_L*modelStruct.modelPar_LBIGD))+(Inv_NFIN*modelStruct.modelPar_NBIGD))+(Inv_LNFIN*modelStruct.modelPar_PBIGD));
d_CIGD_i_dX = (((modelStruct.d_modelPar_CIGD_dX+(Inv_L*modelStruct.d_modelPar_LCIGD_dX+d_Inv_L_dX*modelStruct.modelPar_LCIGD))+(Inv_NFIN*modelStruct.d_modelPar_NCIGD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCIGD))+(Inv_LNFIN*modelStruct.d_modelPar_PCIGD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCIGD));
CIGD_i = (((modelStruct.modelPar_CIGD+(Inv_L*modelStruct.modelPar_LCIGD))+(Inv_NFIN*modelStruct.modelPar_NCIGD))+(Inv_LNFIN*modelStruct.modelPar_PCIGD));
d_NTOX_i_dX = (((modelStruct.d_modelPar_NTOX_dX+(Inv_L*modelStruct.d_modelPar_LNTOX_dX+d_Inv_L_dX*modelStruct.modelPar_LNTOX))+(Inv_NFIN*modelStruct.d_modelPar_NNTOX_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NNTOX))+(Inv_LNFIN*modelStruct.d_modelPar_PNTOX_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PNTOX));
NTOX_i = (((modelStruct.modelPar_NTOX+(Inv_L*modelStruct.modelPar_LNTOX))+(Inv_NFIN*modelStruct.modelPar_NNTOX))+(Inv_LNFIN*modelStruct.modelPar_PNTOX));
d_POXEDGE_i_dX = (((modelStruct.d_modelPar_POXEDGE_dX+(Inv_L*modelStruct.d_modelPar_LPOXEDGE_dX+d_Inv_L_dX*modelStruct.modelPar_LPOXEDGE))+(Inv_NFIN*modelStruct.d_modelPar_NPOXEDGE_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPOXEDGE))+(Inv_LNFIN*modelStruct.d_modelPar_PPOXEDGE_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPOXEDGE));
POXEDGE_i = (((modelStruct.modelPar_POXEDGE+(Inv_L*modelStruct.modelPar_LPOXEDGE))+(Inv_NFIN*modelStruct.modelPar_NPOXEDGE))+(Inv_LNFIN*modelStruct.modelPar_PPOXEDGE));
d_AGIDL_i_dX = (((modelStruct.d_modelPar_AGIDL_dX+(Inv_L*modelStruct.d_modelPar_LAGIDL_dX+d_Inv_L_dX*modelStruct.modelPar_LAGIDL))+(Inv_NFIN*modelStruct.d_modelPar_NAGIDL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAGIDL))+(Inv_LNFIN*modelStruct.d_modelPar_PAGIDL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAGIDL));
AGIDL_i = (((modelStruct.modelPar_AGIDL+(Inv_L*modelStruct.modelPar_LAGIDL))+(Inv_NFIN*modelStruct.modelPar_NAGIDL))+(Inv_LNFIN*modelStruct.modelPar_PAGIDL));
d_BGIDL_i_dX = (((modelStruct.d_modelPar_BGIDL_dX+(Inv_L*modelStruct.d_modelPar_LBGIDL_dX+d_Inv_L_dX*modelStruct.modelPar_LBGIDL))+(Inv_NFIN*modelStruct.d_modelPar_NBGIDL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBGIDL))+(Inv_LNFIN*modelStruct.d_modelPar_PBGIDL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBGIDL));
BGIDL_i = (((modelStruct.modelPar_BGIDL+(Inv_L*modelStruct.modelPar_LBGIDL))+(Inv_NFIN*modelStruct.modelPar_NBGIDL))+(Inv_LNFIN*modelStruct.modelPar_PBGIDL));
d_CGIDL_i_dX = (((modelStruct.d_modelPar_CGIDL_dX+(Inv_L*modelStruct.d_modelPar_LCGIDL_dX+d_Inv_L_dX*modelStruct.modelPar_LCGIDL))+(Inv_NFIN*modelStruct.d_modelPar_NCGIDL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCGIDL))+(Inv_LNFIN*modelStruct.d_modelPar_PCGIDL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCGIDL));
CGIDL_i = (((modelStruct.modelPar_CGIDL+(Inv_L*modelStruct.modelPar_LCGIDL))+(Inv_NFIN*modelStruct.modelPar_NCGIDL))+(Inv_LNFIN*modelStruct.modelPar_PCGIDL));
d_EGIDL_i_dX = (((modelStruct.d_modelPar_EGIDL_dX+(Inv_L*modelStruct.d_modelPar_LEGIDL_dX+d_Inv_L_dX*modelStruct.modelPar_LEGIDL))+(Inv_NFIN*modelStruct.d_modelPar_NEGIDL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NEGIDL))+(Inv_LNFIN*modelStruct.d_modelPar_PEGIDL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PEGIDL));
EGIDL_i = (((modelStruct.modelPar_EGIDL+(Inv_L*modelStruct.modelPar_LEGIDL))+(Inv_NFIN*modelStruct.modelPar_NEGIDL))+(Inv_LNFIN*modelStruct.modelPar_PEGIDL));
d_PGIDL_i_dX = (((modelStruct.d_modelPar_PGIDL_dX+(Inv_L*modelStruct.d_modelPar_LPGIDL_dX+d_Inv_L_dX*modelStruct.modelPar_LPGIDL))+(Inv_NFIN*modelStruct.d_modelPar_NPGIDL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPGIDL))+(Inv_LNFIN*modelStruct.d_modelPar_PPGIDL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPGIDL));
PGIDL_i = (((modelStruct.modelPar_PGIDL+(Inv_L*modelStruct.modelPar_LPGIDL))+(Inv_NFIN*modelStruct.modelPar_NPGIDL))+(Inv_LNFIN*modelStruct.modelPar_PPGIDL));
d_AGISL_i_dX = (((modelStruct.d_modelPar_AGISL_dX+(Inv_L*modelStruct.d_modelPar_LAGISL_dX+d_Inv_L_dX*modelStruct.modelPar_LAGISL))+(Inv_NFIN*modelStruct.d_modelPar_NAGISL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAGISL))+(Inv_LNFIN*modelStruct.d_modelPar_PAGISL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAGISL));
AGISL_i = (((modelStruct.modelPar_AGISL+(Inv_L*modelStruct.modelPar_LAGISL))+(Inv_NFIN*modelStruct.modelPar_NAGISL))+(Inv_LNFIN*modelStruct.modelPar_PAGISL));
d_BGISL_i_dX = (((modelStruct.d_modelPar_BGISL_dX+(Inv_L*modelStruct.d_modelPar_LBGISL_dX+d_Inv_L_dX*modelStruct.modelPar_LBGISL))+(Inv_NFIN*modelStruct.d_modelPar_NBGISL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBGISL))+(Inv_LNFIN*modelStruct.d_modelPar_PBGISL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBGISL));
BGISL_i = (((modelStruct.modelPar_BGISL+(Inv_L*modelStruct.modelPar_LBGISL))+(Inv_NFIN*modelStruct.modelPar_NBGISL))+(Inv_LNFIN*modelStruct.modelPar_PBGISL));
d_CGISL_i_dX = (((modelStruct.d_modelPar_CGISL_dX+(Inv_L*modelStruct.d_modelPar_LCGISL_dX+d_Inv_L_dX*modelStruct.modelPar_LCGISL))+(Inv_NFIN*modelStruct.d_modelPar_NCGISL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCGISL))+(Inv_LNFIN*modelStruct.d_modelPar_PCGISL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCGISL));
CGISL_i = (((modelStruct.modelPar_CGISL+(Inv_L*modelStruct.modelPar_LCGISL))+(Inv_NFIN*modelStruct.modelPar_NCGISL))+(Inv_LNFIN*modelStruct.modelPar_PCGISL));
d_EGISL_i_dX = (((modelStruct.d_modelPar_EGISL_dX+(Inv_L*modelStruct.d_modelPar_LEGISL_dX+d_Inv_L_dX*modelStruct.modelPar_LEGISL))+(Inv_NFIN*modelStruct.d_modelPar_NEGISL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NEGISL))+(Inv_LNFIN*modelStruct.d_modelPar_PEGISL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PEGISL));
EGISL_i = (((modelStruct.modelPar_EGISL+(Inv_L*modelStruct.modelPar_LEGISL))+(Inv_NFIN*modelStruct.modelPar_NEGISL))+(Inv_LNFIN*modelStruct.modelPar_PEGISL));
d_PGISL_i_dX = (((modelStruct.d_modelPar_PGISL_dX+(Inv_L*modelStruct.d_modelPar_LPGISL_dX+d_Inv_L_dX*modelStruct.modelPar_LPGISL))+(Inv_NFIN*modelStruct.d_modelPar_NPGISL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPGISL))+(Inv_LNFIN*modelStruct.d_modelPar_PPGISL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPGISL));
PGISL_i = (((modelStruct.modelPar_PGISL+(Inv_L*modelStruct.modelPar_LPGISL))+(Inv_NFIN*modelStruct.modelPar_NPGISL))+(Inv_LNFIN*modelStruct.modelPar_PPGISL));
d_ALPHA0_i_dX = (((modelStruct.d_modelPar_ALPHA0_dX+(Inv_L*modelStruct.d_modelPar_LALPHA0_dX+d_Inv_L_dX*modelStruct.modelPar_LALPHA0))+(Inv_NFIN*modelStruct.d_modelPar_NALPHA0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NALPHA0))+(Inv_LNFIN*modelStruct.d_modelPar_PALPHA0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PALPHA0));
ALPHA0_i = (((modelStruct.modelPar_ALPHA0+(Inv_L*modelStruct.modelPar_LALPHA0))+(Inv_NFIN*modelStruct.modelPar_NALPHA0))+(Inv_LNFIN*modelStruct.modelPar_PALPHA0));
d_ALPHA1_i_dX = (((modelStruct.d_modelPar_ALPHA1_dX+(Inv_L*modelStruct.d_modelPar_LALPHA1_dX+d_Inv_L_dX*modelStruct.modelPar_LALPHA1))+(Inv_NFIN*modelStruct.d_modelPar_NALPHA1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NALPHA1))+(Inv_LNFIN*modelStruct.d_modelPar_PALPHA1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PALPHA1));
ALPHA1_i = (((modelStruct.modelPar_ALPHA1+(Inv_L*modelStruct.modelPar_LALPHA1))+(Inv_NFIN*modelStruct.modelPar_NALPHA1))+(Inv_LNFIN*modelStruct.modelPar_PALPHA1));
d_ALPHAII0_i_dX = (((modelStruct.d_modelPar_ALPHAII0_dX+(Inv_L*modelStruct.d_modelPar_LALPHAII0_dX+d_Inv_L_dX*modelStruct.modelPar_LALPHAII0))+(Inv_NFIN*modelStruct.d_modelPar_NALPHAII0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NALPHAII0))+(Inv_LNFIN*modelStruct.d_modelPar_PALPHAII0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PALPHAII0));
ALPHAII0_i = (((modelStruct.modelPar_ALPHAII0+(Inv_L*modelStruct.modelPar_LALPHAII0))+(Inv_NFIN*modelStruct.modelPar_NALPHAII0))+(Inv_LNFIN*modelStruct.modelPar_PALPHAII0));
d_ALPHAII1_i_dX = (((modelStruct.d_modelPar_ALPHAII1_dX+(Inv_L*modelStruct.d_modelPar_LALPHAII1_dX+d_Inv_L_dX*modelStruct.modelPar_LALPHAII1))+(Inv_NFIN*modelStruct.d_modelPar_NALPHAII1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NALPHAII1))+(Inv_LNFIN*modelStruct.d_modelPar_PALPHAII1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PALPHAII1));
ALPHAII1_i = (((modelStruct.modelPar_ALPHAII1+(Inv_L*modelStruct.modelPar_LALPHAII1))+(Inv_NFIN*modelStruct.modelPar_NALPHAII1))+(Inv_LNFIN*modelStruct.modelPar_PALPHAII1));
d_BETA0_i_dX = (((modelStruct.d_modelPar_BETA0_dX+(Inv_L*modelStruct.d_modelPar_LBETA0_dX+d_Inv_L_dX*modelStruct.modelPar_LBETA0))+(Inv_NFIN*modelStruct.d_modelPar_NBETA0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBETA0))+(Inv_LNFIN*modelStruct.d_modelPar_PBETA0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBETA0));
BETA0_i = (((modelStruct.modelPar_BETA0+(Inv_L*modelStruct.modelPar_LBETA0))+(Inv_NFIN*modelStruct.modelPar_NBETA0))+(Inv_LNFIN*modelStruct.modelPar_PBETA0));
d_BETAII0_i_dX = (((modelStruct.d_modelPar_BETAII0_dX+(Inv_L*modelStruct.d_modelPar_LBETAII0_dX+d_Inv_L_dX*modelStruct.modelPar_LBETAII0))+(Inv_NFIN*modelStruct.d_modelPar_NBETAII0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBETAII0))+(Inv_LNFIN*modelStruct.d_modelPar_PBETAII0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBETAII0));
BETAII0_i = (((modelStruct.modelPar_BETAII0+(Inv_L*modelStruct.modelPar_LBETAII0))+(Inv_NFIN*modelStruct.modelPar_NBETAII0))+(Inv_LNFIN*modelStruct.modelPar_PBETAII0));
d_BETAII1_i_dX = (((modelStruct.d_modelPar_BETAII1_dX+(Inv_L*modelStruct.d_modelPar_LBETAII1_dX+d_Inv_L_dX*modelStruct.modelPar_LBETAII1))+(Inv_NFIN*modelStruct.d_modelPar_NBETAII1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBETAII1))+(Inv_LNFIN*modelStruct.d_modelPar_PBETAII1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBETAII1));
BETAII1_i = (((modelStruct.modelPar_BETAII1+(Inv_L*modelStruct.modelPar_LBETAII1))+(Inv_NFIN*modelStruct.modelPar_NBETAII1))+(Inv_LNFIN*modelStruct.modelPar_PBETAII1));
d_BETAII2_i_dX = (((modelStruct.d_modelPar_BETAII2_dX+(Inv_L*modelStruct.d_modelPar_LBETAII2_dX+d_Inv_L_dX*modelStruct.modelPar_LBETAII2))+(Inv_NFIN*modelStruct.d_modelPar_NBETAII2_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBETAII2))+(Inv_LNFIN*modelStruct.d_modelPar_PBETAII2_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBETAII2));
BETAII2_i = (((modelStruct.modelPar_BETAII2+(Inv_L*modelStruct.modelPar_LBETAII2))+(Inv_NFIN*modelStruct.modelPar_NBETAII2))+(Inv_LNFIN*modelStruct.modelPar_PBETAII2));
d_ESATII_i_dX = (((modelStruct.d_modelPar_ESATII_dX+(Inv_L*modelStruct.d_modelPar_LESATII_dX+d_Inv_L_dX*modelStruct.modelPar_LESATII))+(Inv_NFIN*modelStruct.d_modelPar_NESATII_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NESATII))+(Inv_LNFIN*modelStruct.d_modelPar_PESATII_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PESATII));
ESATII_i = (((modelStruct.modelPar_ESATII+(Inv_L*modelStruct.modelPar_LESATII))+(Inv_NFIN*modelStruct.modelPar_NESATII))+(Inv_LNFIN*modelStruct.modelPar_PESATII));
d_LII_i_dX = (((modelStruct.d_modelPar_LII_dX+(Inv_L*modelStruct.d_modelPar_LLII_dX+d_Inv_L_dX*modelStruct.modelPar_LLII))+(Inv_NFIN*modelStruct.d_modelPar_NLII_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NLII))+(Inv_LNFIN*modelStruct.d_modelPar_PLII_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PLII));
LII_i = (((modelStruct.modelPar_LII+(Inv_L*modelStruct.modelPar_LLII))+(Inv_NFIN*modelStruct.modelPar_NLII))+(Inv_LNFIN*modelStruct.modelPar_PLII));
d_SII0_i_dX = (((modelStruct.d_modelPar_SII0_dX+(Inv_L*modelStruct.d_modelPar_LSII0_dX+d_Inv_L_dX*modelStruct.modelPar_LSII0))+(Inv_NFIN*modelStruct.d_modelPar_NSII0_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NSII0))+(Inv_LNFIN*modelStruct.d_modelPar_PSII0_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PSII0));
SII0_i = (((modelStruct.modelPar_SII0+(Inv_L*modelStruct.modelPar_LSII0))+(Inv_NFIN*modelStruct.modelPar_NSII0))+(Inv_LNFIN*modelStruct.modelPar_PSII0));
d_SII1_i_dX = (((modelStruct.d_modelPar_SII1_dX+(Inv_L*modelStruct.d_modelPar_LSII1_dX+d_Inv_L_dX*modelStruct.modelPar_LSII1))+(Inv_NFIN*modelStruct.d_modelPar_NSII1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NSII1))+(Inv_LNFIN*modelStruct.d_modelPar_PSII1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PSII1));
SII1_i = (((modelStruct.modelPar_SII1+(Inv_L*modelStruct.modelPar_LSII1))+(Inv_NFIN*modelStruct.modelPar_NSII1))+(Inv_LNFIN*modelStruct.modelPar_PSII1));
d_SII2_i_dX = (((modelStruct.d_modelPar_SII2_dX+(Inv_L*modelStruct.d_modelPar_LSII2_dX+d_Inv_L_dX*modelStruct.modelPar_LSII2))+(Inv_NFIN*modelStruct.d_modelPar_NSII2_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NSII2))+(Inv_LNFIN*modelStruct.d_modelPar_PSII2_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PSII2));
SII2_i = (((modelStruct.modelPar_SII2+(Inv_L*modelStruct.modelPar_LSII2))+(Inv_NFIN*modelStruct.modelPar_NSII2))+(Inv_LNFIN*modelStruct.modelPar_PSII2));
d_SIID_i_dX = (((modelStruct.d_modelPar_SIID_dX+(Inv_L*modelStruct.d_modelPar_LSIID_dX+d_Inv_L_dX*modelStruct.modelPar_LSIID))+(Inv_NFIN*modelStruct.d_modelPar_NSIID_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NSIID))+(Inv_LNFIN*modelStruct.d_modelPar_PSIID_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PSIID));
SIID_i = (((modelStruct.modelPar_SIID+(Inv_L*modelStruct.modelPar_LSIID))+(Inv_NFIN*modelStruct.modelPar_NSIID))+(Inv_LNFIN*modelStruct.modelPar_PSIID));
d_TII_i_dX = (((modelStruct.d_modelPar_TII_dX+(Inv_L*modelStruct.d_modelPar_LTII_dX+d_Inv_L_dX*modelStruct.modelPar_LTII))+(Inv_NFIN*modelStruct.d_modelPar_NTII_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NTII))+(Inv_LNFIN*modelStruct.d_modelPar_PTII_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PTII));
TII_i = (((modelStruct.modelPar_TII+(Inv_L*modelStruct.modelPar_LTII))+(Inv_NFIN*modelStruct.modelPar_NTII))+(Inv_LNFIN*modelStruct.modelPar_PTII));
d_CFS_i_dX = (((modelStruct.d_modelPar_CFS_dX+(Inv_L*modelStruct.d_modelPar_LCFS_dX+d_Inv_L_dX*modelStruct.modelPar_LCFS))+(Inv_NFIN*modelStruct.d_modelPar_NCFS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCFS))+(Inv_LNFIN*modelStruct.d_modelPar_PCFS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCFS));
CFS_i = (((modelStruct.modelPar_CFS+(Inv_L*modelStruct.modelPar_LCFS))+(Inv_NFIN*modelStruct.modelPar_NCFS))+(Inv_LNFIN*modelStruct.modelPar_PCFS));
d_CFD_i_dX = (((modelStruct.d_modelPar_CFD_dX+(Inv_L*modelStruct.d_modelPar_LCFD_dX+d_Inv_L_dX*modelStruct.modelPar_LCFD))+(Inv_NFIN*modelStruct.d_modelPar_NCFD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCFD))+(Inv_LNFIN*modelStruct.d_modelPar_PCFD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCFD));
CFD_i = (((modelStruct.modelPar_CFD+(Inv_L*modelStruct.modelPar_LCFD))+(Inv_NFIN*modelStruct.modelPar_NCFD))+(Inv_LNFIN*modelStruct.modelPar_PCFD));
d_COVS_i_dX = (((instanceStruct.d_instancePar_COVS_dX+(Inv_L*modelStruct.d_modelPar_LCOVS_dX+d_Inv_L_dX*modelStruct.modelPar_LCOVS))+(Inv_NFIN*modelStruct.d_modelPar_NCOVS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCOVS))+(Inv_LNFIN*modelStruct.d_modelPar_PCOVS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCOVS));
COVS_i = (((instanceStruct.instancePar_COVS+(Inv_L*modelStruct.modelPar_LCOVS))+(Inv_NFIN*modelStruct.modelPar_NCOVS))+(Inv_LNFIN*modelStruct.modelPar_PCOVS));
d_COVD_i_dX = (((instanceStruct.d_instancePar_COVD_dX+(Inv_L*modelStruct.d_modelPar_LCOVD_dX+d_Inv_L_dX*modelStruct.modelPar_LCOVD))+(Inv_NFIN*modelStruct.d_modelPar_NCOVD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCOVD))+(Inv_LNFIN*modelStruct.d_modelPar_PCOVD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCOVD));
COVD_i = (((instanceStruct.instancePar_COVD+(Inv_L*modelStruct.modelPar_LCOVD))+(Inv_NFIN*modelStruct.modelPar_NCOVD))+(Inv_LNFIN*modelStruct.modelPar_PCOVD));
d_CGSL_i_dX = (((modelStruct.d_modelPar_CGSL_dX+(Inv_L*modelStruct.d_modelPar_LCGSL_dX+d_Inv_L_dX*modelStruct.modelPar_LCGSL))+(Inv_NFIN*modelStruct.d_modelPar_NCGSL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCGSL))+(Inv_LNFIN*modelStruct.d_modelPar_PCGSL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCGSL));
CGSL_i = (((modelStruct.modelPar_CGSL+(Inv_L*modelStruct.modelPar_LCGSL))+(Inv_NFIN*modelStruct.modelPar_NCGSL))+(Inv_LNFIN*modelStruct.modelPar_PCGSL));
d_CGDL_i_dX = (((modelStruct.d_modelPar_CGDL_dX+(Inv_L*modelStruct.d_modelPar_LCGDL_dX+d_Inv_L_dX*modelStruct.modelPar_LCGDL))+(Inv_NFIN*modelStruct.d_modelPar_NCGDL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCGDL))+(Inv_LNFIN*modelStruct.d_modelPar_PCGDL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCGDL));
CGDL_i = (((modelStruct.modelPar_CGDL+(Inv_L*modelStruct.modelPar_LCGDL))+(Inv_NFIN*modelStruct.modelPar_NCGDL))+(Inv_LNFIN*modelStruct.modelPar_PCGDL));
d_CGBL_i_dX = (((modelStruct.d_modelPar_CGBL_dX+(Inv_L*modelStruct.d_modelPar_LCGBL_dX+d_Inv_L_dX*modelStruct.modelPar_LCGBL))+(Inv_NFIN*modelStruct.d_modelPar_NCGBL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCGBL))+(Inv_LNFIN*modelStruct.d_modelPar_PCGBL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCGBL));
CGBL_i = (((modelStruct.modelPar_CGBL+(Inv_L*modelStruct.modelPar_LCGBL))+(Inv_NFIN*modelStruct.modelPar_NCGBL))+(Inv_LNFIN*modelStruct.modelPar_PCGBL));
d_CKAPPAS_i_dX = (((modelStruct.d_modelPar_CKAPPAS_dX+(Inv_L*modelStruct.d_modelPar_LCKAPPAS_dX+d_Inv_L_dX*modelStruct.modelPar_LCKAPPAS))+(Inv_NFIN*modelStruct.d_modelPar_NCKAPPAS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCKAPPAS))+(Inv_LNFIN*modelStruct.d_modelPar_PCKAPPAS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCKAPPAS));
CKAPPAS_i = (((modelStruct.modelPar_CKAPPAS+(Inv_L*modelStruct.modelPar_LCKAPPAS))+(Inv_NFIN*modelStruct.modelPar_NCKAPPAS))+(Inv_LNFIN*modelStruct.modelPar_PCKAPPAS));
d_CKAPPAD_i_dX = (((modelStruct.d_modelPar_CKAPPAD_dX+(Inv_L*modelStruct.d_modelPar_LCKAPPAD_dX+d_Inv_L_dX*modelStruct.modelPar_LCKAPPAD))+(Inv_NFIN*modelStruct.d_modelPar_NCKAPPAD_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCKAPPAD))+(Inv_LNFIN*modelStruct.d_modelPar_PCKAPPAD_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCKAPPAD));
CKAPPAD_i = (((modelStruct.modelPar_CKAPPAD+(Inv_L*modelStruct.modelPar_LCKAPPAD))+(Inv_NFIN*modelStruct.modelPar_NCKAPPAD))+(Inv_LNFIN*modelStruct.modelPar_PCKAPPAD));
d_CKAPPAB_i_dX = (((modelStruct.d_modelPar_CKAPPAB_dX+(Inv_L*modelStruct.d_modelPar_LCKAPPAB_dX+d_Inv_L_dX*modelStruct.modelPar_LCKAPPAB))+(Inv_NFIN*modelStruct.d_modelPar_NCKAPPAB_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCKAPPAB))+(Inv_LNFIN*modelStruct.d_modelPar_PCKAPPAB_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCKAPPAB));
CKAPPAB_i = (((modelStruct.modelPar_CKAPPAB+(Inv_L*modelStruct.modelPar_LCKAPPAB))+(Inv_NFIN*modelStruct.modelPar_NCKAPPAB))+(Inv_LNFIN*modelStruct.modelPar_PCKAPPAB));
d_NTGEN_i_dX = (((modelStruct.d_modelPar_NTGEN_dX+(Inv_L*modelStruct.d_modelPar_LNTGEN_dX+d_Inv_L_dX*modelStruct.modelPar_LNTGEN))+(Inv_NFIN*modelStruct.d_modelPar_NNTGEN_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NNTGEN))+(Inv_LNFIN*modelStruct.d_modelPar_PNTGEN_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PNTGEN));
NTGEN_i = (((modelStruct.modelPar_NTGEN+(Inv_L*modelStruct.modelPar_LNTGEN))+(Inv_NFIN*modelStruct.modelPar_NNTGEN))+(Inv_LNFIN*modelStruct.modelPar_PNTGEN));
d_AIGEN_i_dX = (((modelStruct.d_modelPar_AIGEN_dX+(Inv_L*modelStruct.d_modelPar_LAIGEN_dX+d_Inv_L_dX*modelStruct.modelPar_LAIGEN))+(Inv_NFIN*modelStruct.d_modelPar_NAIGEN_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAIGEN))+(Inv_LNFIN*modelStruct.d_modelPar_PAIGEN_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAIGEN));
AIGEN_i = (((modelStruct.modelPar_AIGEN+(Inv_L*modelStruct.modelPar_LAIGEN))+(Inv_NFIN*modelStruct.modelPar_NAIGEN))+(Inv_LNFIN*modelStruct.modelPar_PAIGEN));
d_BIGEN_i_dX = (((modelStruct.d_modelPar_BIGEN_dX+(Inv_L*modelStruct.d_modelPar_LBIGEN_dX+d_Inv_L_dX*modelStruct.modelPar_LBIGEN))+(Inv_NFIN*modelStruct.d_modelPar_NBIGEN_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NBIGEN))+(Inv_LNFIN*modelStruct.d_modelPar_PBIGEN_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PBIGEN));
BIGEN_i = (((modelStruct.modelPar_BIGEN+(Inv_L*modelStruct.modelPar_LBIGEN))+(Inv_NFIN*modelStruct.modelPar_NBIGEN))+(Inv_LNFIN*modelStruct.modelPar_PBIGEN));
if ((modelStruct.modelPar_ASYMMOD!=0))
{
d_CDSCDR_i_dX = (((modelStruct.d_modelPar_CDSCDR_dX+(Inv_L*modelStruct.d_modelPar_LCDSCDR_dX+d_Inv_L_dX*modelStruct.modelPar_LCDSCDR))+(Inv_NFIN*modelStruct.d_modelPar_NCDSCDR_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NCDSCDR))+(Inv_LNFIN*modelStruct.d_modelPar_PCDSCDR_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PCDSCDR));
CDSCDR_i = (((modelStruct.modelPar_CDSCDR+(Inv_L*modelStruct.modelPar_LCDSCDR))+(Inv_NFIN*modelStruct.modelPar_NCDSCDR))+(Inv_LNFIN*modelStruct.modelPar_PCDSCDR));
d_ETA0R_i_dX = (((modelStruct.d_modelPar_ETA0R_dX+(Inv_L*modelStruct.d_modelPar_LETA0R_dX+d_Inv_L_dX*modelStruct.modelPar_LETA0R))+(Inv_NFIN*modelStruct.d_modelPar_NETA0R_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NETA0R))+(Inv_LNFIN*modelStruct.d_modelPar_PETA0R_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PETA0R));
ETA0R_i = (((modelStruct.modelPar_ETA0R+(Inv_L*modelStruct.modelPar_LETA0R))+(Inv_NFIN*modelStruct.modelPar_NETA0R))+(Inv_LNFIN*modelStruct.modelPar_PETA0R));
d_VSAT1R_i_dX = (((modelStruct.d_modelPar_VSAT1R_dX+(Inv_L*modelStruct.d_modelPar_LVSAT1R_dX+d_Inv_L_dX*modelStruct.modelPar_LVSAT1R))+(Inv_NFIN*modelStruct.d_modelPar_NVSAT1R_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NVSAT1R))+(Inv_LNFIN*modelStruct.d_modelPar_PVSAT1R_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PVSAT1R));
VSAT1R_i = (((modelStruct.modelPar_VSAT1R+(Inv_L*modelStruct.modelPar_LVSAT1R))+(Inv_NFIN*modelStruct.modelPar_NVSAT1R))+(Inv_LNFIN*modelStruct.modelPar_PVSAT1R));
d_MEXPR_i_dX = (((modelStruct.d_modelPar_MEXPR_dX+(Inv_L*modelStruct.d_modelPar_LMEXPR_dX+d_Inv_L_dX*modelStruct.modelPar_LMEXPR))+(Inv_NFIN*modelStruct.d_modelPar_NMEXPR_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NMEXPR))+(Inv_LNFIN*modelStruct.d_modelPar_PMEXPR_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PMEXPR));
MEXPR_i = (((modelStruct.modelPar_MEXPR+(Inv_L*modelStruct.modelPar_LMEXPR))+(Inv_NFIN*modelStruct.modelPar_NMEXPR))+(Inv_LNFIN*modelStruct.modelPar_PMEXPR));
d_PTWGR_i_dX = (((modelStruct.d_modelPar_PTWGR_dX+(Inv_L*modelStruct.d_modelPar_LPTWGR_dX+d_Inv_L_dX*modelStruct.modelPar_LPTWGR))+(Inv_NFIN*modelStruct.d_modelPar_NPTWGR_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPTWGR))+(Inv_LNFIN*modelStruct.d_modelPar_PPTWGR_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPTWGR));
PTWGR_i = (((modelStruct.modelPar_PTWGR+(Inv_L*modelStruct.modelPar_LPTWGR))+(Inv_NFIN*modelStruct.modelPar_NPTWGR))+(Inv_LNFIN*modelStruct.modelPar_PPTWGR));
d_PDIBL1R_i_dX = (((modelStruct.d_modelPar_PDIBL1R_dX+(Inv_L*modelStruct.d_modelPar_LPDIBL1R_dX+d_Inv_L_dX*modelStruct.modelPar_LPDIBL1R))+(Inv_NFIN*modelStruct.d_modelPar_NPDIBL1R_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPDIBL1R))+(Inv_LNFIN*modelStruct.d_modelPar_PPDIBL1R_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPDIBL1R));
PDIBL1R_i = (((modelStruct.modelPar_PDIBL1R+(Inv_L*modelStruct.modelPar_LPDIBL1R))+(Inv_NFIN*modelStruct.modelPar_NPDIBL1R))+(Inv_LNFIN*modelStruct.modelPar_PPDIBL1R));
}
if ((modelStruct.modelPar_NQSMOD==1))
{
UserInfo(theInstance)  << "[bsimcmg] Although the model selector NQSMOD is set to 1, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD1__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
if ((modelStruct.modelPar_NQSMOD==2))
{
UserInfo(theInstance)  << "[bsimcmg] Although the model selector NQSMOD is set to 2, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment `define __NQSMOD2__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
d_UTE_i_dX = (((modelStruct.d_modelPar_UTE_dX+(Inv_L*modelStruct.d_modelPar_LUTE_dX+d_Inv_L_dX*modelStruct.modelPar_LUTE))+(Inv_NFIN*modelStruct.d_modelPar_NUTE_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUTE))+(Inv_LNFIN*modelStruct.d_modelPar_PUTE_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUTE));
UTE_i = (((modelStruct.modelPar_UTE+(Inv_L*modelStruct.modelPar_LUTE))+(Inv_NFIN*modelStruct.modelPar_NUTE))+(Inv_LNFIN*modelStruct.modelPar_PUTE));
d_UTL_i_dX = (((modelStruct.d_modelPar_UTL_dX+(Inv_L*modelStruct.d_modelPar_LUTL_dX+d_Inv_L_dX*modelStruct.modelPar_LUTL))+(Inv_NFIN*modelStruct.d_modelPar_NUTL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUTL))+(Inv_LNFIN*modelStruct.d_modelPar_PUTL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUTL));
UTL_i = (((modelStruct.modelPar_UTL+(Inv_L*modelStruct.modelPar_LUTL))+(Inv_NFIN*modelStruct.modelPar_NUTL))+(Inv_LNFIN*modelStruct.modelPar_PUTL));
d_EMOBT_i_dX = (((modelStruct.d_modelPar_EMOBT_dX+(Inv_L*modelStruct.d_modelPar_LEMOBT_dX+d_Inv_L_dX*modelStruct.modelPar_LEMOBT))+(Inv_NFIN*modelStruct.d_modelPar_NEMOBT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NEMOBT))+(Inv_LNFIN*modelStruct.d_modelPar_PEMOBT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PEMOBT));
EMOBT_i = (((modelStruct.modelPar_EMOBT+(Inv_L*modelStruct.modelPar_LEMOBT))+(Inv_NFIN*modelStruct.modelPar_NEMOBT))+(Inv_LNFIN*modelStruct.modelPar_PEMOBT));
d_UA1_i_dX = (((modelStruct.d_modelPar_UA1_dX+(Inv_L*modelStruct.d_modelPar_LUA1_dX+d_Inv_L_dX*modelStruct.modelPar_LUA1))+(Inv_NFIN*modelStruct.d_modelPar_NUA1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUA1))+(Inv_LNFIN*modelStruct.d_modelPar_PUA1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUA1));
UA1_i = (((modelStruct.modelPar_UA1+(Inv_L*modelStruct.modelPar_LUA1))+(Inv_NFIN*modelStruct.modelPar_NUA1))+(Inv_LNFIN*modelStruct.modelPar_PUA1));
if ((modelStruct.modelPar_BULKMOD!=0))
{
d_UC1_i_dX = (((modelStruct.d_modelPar_UC1_dX+(Inv_L*modelStruct.d_modelPar_LUC1_dX+d_Inv_L_dX*modelStruct.modelPar_LUC1))+(Inv_NFIN*modelStruct.d_modelPar_NUC1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUC1))+(Inv_LNFIN*modelStruct.d_modelPar_PUC1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUC1));
UC1_i = (((modelStruct.modelPar_UC1+(Inv_L*modelStruct.modelPar_LUC1))+(Inv_NFIN*modelStruct.modelPar_NUC1))+(Inv_LNFIN*modelStruct.modelPar_PUC1));
}
d_UD1_i_dX = (((modelStruct.d_modelPar_UD1_dX+(Inv_L*modelStruct.d_modelPar_LUD1_dX+d_Inv_L_dX*modelStruct.modelPar_LUD1))+(Inv_NFIN*modelStruct.d_modelPar_NUD1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUD1))+(Inv_LNFIN*modelStruct.d_modelPar_PUD1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUD1));
UD1_i = (((modelStruct.modelPar_UD1+(Inv_L*modelStruct.modelPar_LUD1))+(Inv_NFIN*modelStruct.modelPar_NUD1))+(Inv_LNFIN*modelStruct.modelPar_PUD1));
d_UCSTE_i_dX = (((modelStruct.d_modelPar_UCSTE_dX+(Inv_L*modelStruct.d_modelPar_LUCSTE_dX+d_Inv_L_dX*modelStruct.modelPar_LUCSTE))+(Inv_NFIN*modelStruct.d_modelPar_NUCSTE_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NUCSTE))+(Inv_LNFIN*modelStruct.d_modelPar_PUCSTE_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PUCSTE));
UCSTE_i = (((modelStruct.modelPar_UCSTE+(Inv_L*modelStruct.modelPar_LUCSTE))+(Inv_NFIN*modelStruct.modelPar_NUCSTE))+(Inv_LNFIN*modelStruct.modelPar_PUCSTE));
d_PTWGT_i_dX = (((modelStruct.d_modelPar_PTWGT_dX+(Inv_L*modelStruct.d_modelPar_LPTWGT_dX+d_Inv_L_dX*modelStruct.modelPar_LPTWGT))+(Inv_NFIN*modelStruct.d_modelPar_NPTWGT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPTWGT))+(Inv_LNFIN*modelStruct.d_modelPar_PPTWGT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPTWGT));
PTWGT_i = (((modelStruct.modelPar_PTWGT+(Inv_L*modelStruct.modelPar_LPTWGT))+(Inv_NFIN*modelStruct.modelPar_NPTWGT))+(Inv_LNFIN*modelStruct.modelPar_PPTWGT));
d_AT_i_dX = (((modelStruct.d_modelPar_AT_dX+(Inv_L*modelStruct.d_modelPar_LAT_dX+d_Inv_L_dX*modelStruct.modelPar_LAT))+(Inv_NFIN*modelStruct.d_modelPar_NAT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NAT))+(Inv_LNFIN*modelStruct.d_modelPar_PAT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PAT));
AT_i = (((modelStruct.modelPar_AT+(Inv_L*modelStruct.modelPar_LAT))+(Inv_NFIN*modelStruct.modelPar_NAT))+(Inv_LNFIN*modelStruct.modelPar_PAT));
d_PRT_i_dX = (((modelStruct.d_modelPar_PRT_dX+(Inv_L*modelStruct.d_modelPar_LPRT_dX+d_Inv_L_dX*modelStruct.modelPar_LPRT))+(Inv_NFIN*modelStruct.d_modelPar_NPRT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NPRT))+(Inv_LNFIN*modelStruct.d_modelPar_PPRT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PPRT));
PRT_i = (((modelStruct.modelPar_PRT+(Inv_L*modelStruct.modelPar_LPRT))+(Inv_NFIN*modelStruct.modelPar_NPRT))+(Inv_LNFIN*modelStruct.modelPar_PPRT));
d_KT1_i_dX = (((modelStruct.d_modelPar_KT1_dX+(Inv_L*modelStruct.d_modelPar_LKT1_dX+d_Inv_L_dX*modelStruct.modelPar_LKT1))+(Inv_NFIN*modelStruct.d_modelPar_NKT1_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NKT1))+(Inv_LNFIN*modelStruct.d_modelPar_PKT1_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PKT1));
KT1_i = (((modelStruct.modelPar_KT1+(Inv_L*modelStruct.modelPar_LKT1))+(Inv_NFIN*modelStruct.modelPar_NKT1))+(Inv_LNFIN*modelStruct.modelPar_PKT1));
d_TSS_i_dX = (((modelStruct.d_modelPar_TSS_dX+(Inv_L*modelStruct.d_modelPar_LTSS_dX+d_Inv_L_dX*modelStruct.modelPar_LTSS))+(Inv_NFIN*modelStruct.d_modelPar_NTSS_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NTSS))+(Inv_LNFIN*modelStruct.d_modelPar_PTSS_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PTSS));
TSS_i = (((modelStruct.modelPar_TSS+(Inv_L*modelStruct.modelPar_LTSS))+(Inv_NFIN*modelStruct.modelPar_NTSS))+(Inv_LNFIN*modelStruct.modelPar_PTSS));
d_IIT_i_dX = (((modelStruct.d_modelPar_IIT_dX+(Inv_L*modelStruct.d_modelPar_LIIT_dX+d_Inv_L_dX*modelStruct.modelPar_LIIT))+(Inv_NFIN*modelStruct.d_modelPar_NIIT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NIIT))+(Inv_LNFIN*modelStruct.d_modelPar_PIIT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PIIT));
IIT_i = (((modelStruct.modelPar_IIT+(Inv_L*modelStruct.modelPar_LIIT))+(Inv_NFIN*modelStruct.modelPar_NIIT))+(Inv_LNFIN*modelStruct.modelPar_PIIT));
d_TGIDL_i_dX = (((modelStruct.d_modelPar_TGIDL_dX+(Inv_L*modelStruct.d_modelPar_LTGIDL_dX+d_Inv_L_dX*modelStruct.modelPar_LTGIDL))+(Inv_NFIN*modelStruct.d_modelPar_NTGIDL_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NTGIDL))+(Inv_LNFIN*modelStruct.d_modelPar_PTGIDL_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PTGIDL));
TGIDL_i = (((modelStruct.modelPar_TGIDL+(Inv_L*modelStruct.modelPar_LTGIDL))+(Inv_NFIN*modelStruct.modelPar_NTGIDL))+(Inv_LNFIN*modelStruct.modelPar_PTGIDL));
d_IGT_i_dX = (((modelStruct.d_modelPar_IGT_dX+(Inv_L*modelStruct.d_modelPar_LIGT_dX+d_Inv_L_dX*modelStruct.modelPar_LIGT))+(Inv_NFIN*modelStruct.d_modelPar_NIGT_dX+d_Inv_NFIN_dX*modelStruct.modelPar_NIGT))+(Inv_LNFIN*modelStruct.d_modelPar_PIGT_dX+d_Inv_LNFIN_dX*modelStruct.modelPar_PIGT));
IGT_i = (((modelStruct.modelPar_IGT+(Inv_L*modelStruct.modelPar_LIGT))+(Inv_NFIN*modelStruct.modelPar_NIGT))+(Inv_LNFIN*modelStruct.modelPar_PIGT));
if ((modelStruct.modelPar_PHIGN1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_PHIGN2)));
d_PHIG_i_dX = (PHIG_i*((modelStruct.modelPar_PHIGN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_PHIGN2)),((modelStruct.modelPar_PHIGN2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_PHIGN2_dX)/modelStruct.modelPar_PHIGN2/modelStruct.modelPar_PHIGN2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_PHIGN1_dX-modelStruct.modelPar_PHIGN1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_PHIGN2))))+d_PHIG_i_dX*(1.0+((modelStruct.modelPar_PHIGN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_PHIGN2))))));
PHIG_i = (PHIG_i*(1.0+((modelStruct.modelPar_PHIGN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_PHIGN2))))));
}
}
if ((modelStruct.modelPar_ETA0N1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_ETA0N2)));
d_ETA0_i_dX = (ETA0_i*((modelStruct.modelPar_ETA0N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_ETA0N2)),((modelStruct.modelPar_ETA0N2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_ETA0N2_dX)/modelStruct.modelPar_ETA0N2/modelStruct.modelPar_ETA0N2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_ETA0N1_dX-modelStruct.modelPar_ETA0N1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_ETA0N2))))+d_ETA0_i_dX*(1.0+((modelStruct.modelPar_ETA0N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_ETA0N2))))));
ETA0_i = (ETA0_i*(1.0+((modelStruct.modelPar_ETA0N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_ETA0N2))))));
}
}
if ((modelStruct.modelPar_CDSCN1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCN2)));
d_CDSC_i_dX = (CDSC_i*((modelStruct.modelPar_CDSCN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCN2)),((modelStruct.modelPar_CDSCN2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_CDSCN2_dX)/modelStruct.modelPar_CDSCN2/modelStruct.modelPar_CDSCN2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_CDSCN1_dX-modelStruct.modelPar_CDSCN1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCN2))))+d_CDSC_i_dX*(1.0+((modelStruct.modelPar_CDSCN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCN2))))));
CDSC_i = (CDSC_i*(1.0+((modelStruct.modelPar_CDSCN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCN2))))));
}
}
if ((modelStruct.modelPar_CDSCDN1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDN2)));
d_CDSCD_i_dX = (CDSCD_i*((modelStruct.modelPar_CDSCDN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDN2)),((modelStruct.modelPar_CDSCDN2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_CDSCDN2_dX)/modelStruct.modelPar_CDSCDN2/modelStruct.modelPar_CDSCDN2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_CDSCDN1_dX-modelStruct.modelPar_CDSCDN1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDN2))))+d_CDSCD_i_dX*(1.0+((modelStruct.modelPar_CDSCDN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDN2))))));
CDSCD_i = (CDSCD_i*(1.0+((modelStruct.modelPar_CDSCDN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDN2))))));
}
}
if ((modelStruct.modelPar_CDSCDRN1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDRN2)));
d_CDSCDR_i_dX = (CDSCDR_i*((modelStruct.modelPar_CDSCDRN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDRN2)),((modelStruct.modelPar_CDSCDRN2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_CDSCDRN2_dX)/modelStruct.modelPar_CDSCDRN2/modelStruct.modelPar_CDSCDRN2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_CDSCDRN1_dX-modelStruct.modelPar_CDSCDRN1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDRN2))))+d_CDSCDR_i_dX*(1.0+((modelStruct.modelPar_CDSCDRN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDRN2))))));
CDSCDR_i = (CDSCDR_i*(1.0+((modelStruct.modelPar_CDSCDRN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_CDSCDRN2))))));
}
}
if ((modelStruct.modelPar_NBODYN1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_NBODYN2)));
d_NBODY_i_dX = (NBODY_i*((modelStruct.modelPar_NBODYN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_NBODYN2)),((modelStruct.modelPar_NBODYN2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_NBODYN2_dX)/modelStruct.modelPar_NBODYN2/modelStruct.modelPar_NBODYN2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_NBODYN1_dX-modelStruct.modelPar_NBODYN1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_NBODYN2))))+d_NBODY_i_dX*(1.0+((modelStruct.modelPar_NBODYN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_NBODYN2))))));
NBODY_i = (NBODY_i*(1.0+((modelStruct.modelPar_NBODYN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_NBODYN2))))));
}
}
if ((modelStruct.modelPar_VSATN1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSATN2)));
d_VSAT_i_dX = (VSAT_i*((modelStruct.modelPar_VSATN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSATN2)),((modelStruct.modelPar_VSATN2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_VSATN2_dX)/modelStruct.modelPar_VSATN2/modelStruct.modelPar_VSATN2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_VSATN1_dX-modelStruct.modelPar_VSATN1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSATN2))))+d_VSAT_i_dX*(1.0+((modelStruct.modelPar_VSATN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSATN2))))));
VSAT_i = (VSAT_i*(1.0+((modelStruct.modelPar_VSATN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSATN2))))));
}
}
if ((modelStruct.modelPar_VSAT1N1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1N2)));
d_VSAT1_i_dX = (VSAT1_i*((modelStruct.modelPar_VSAT1N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1N2)),((modelStruct.modelPar_VSAT1N2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_VSAT1N2_dX)/modelStruct.modelPar_VSAT1N2/modelStruct.modelPar_VSAT1N2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_VSAT1N1_dX-modelStruct.modelPar_VSAT1N1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1N2))))+d_VSAT1_i_dX*(1.0+((modelStruct.modelPar_VSAT1N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1N2))))));
VSAT1_i = (VSAT1_i*(1.0+((modelStruct.modelPar_VSAT1N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1N2))))));
}
}
if ((modelStruct.modelPar_VSAT1RN1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1RN2)));
d_VSAT1R_i_dX = (VSAT1R_i*((modelStruct.modelPar_VSAT1RN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1RN2)),((modelStruct.modelPar_VSAT1RN2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_VSAT1RN2_dX)/modelStruct.modelPar_VSAT1RN2/modelStruct.modelPar_VSAT1RN2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_VSAT1RN1_dX-modelStruct.modelPar_VSAT1RN1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1RN2))))+d_VSAT1R_i_dX*(1.0+((modelStruct.modelPar_VSAT1RN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1RN2))))));
VSAT1R_i = (VSAT1R_i*(1.0+((modelStruct.modelPar_VSAT1RN1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_VSAT1RN2))))));
}
}
if ((modelStruct.modelPar_U0N1!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_U0N2)));
d_U0_i_dX = (U0_i*((modelStruct.modelPar_U0N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getDerivs((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_U0N2)),((modelStruct.modelPar_U0N2*instanceStruct.d_instancePar_NFIN_dX-instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_U0N2_dX)/modelStruct.modelPar_U0N2/modelStruct.modelPar_U0N2))+((instanceStruct.instancePar_NFIN*modelStruct.d_modelPar_U0N1_dX-modelStruct.modelPar_U0N1*instanceStruct.d_instancePar_NFIN_dX)/instanceStruct.instancePar_NFIN/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_U0N2))))+d_U0_i_dX*(1.0+((modelStruct.modelPar_U0N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_U0N2))))));
U0_i = (U0_i*(1.0+((modelStruct.modelPar_U0N1/instanceStruct.instancePar_NFIN)*evaluator_lln_0.getValues((1.0+(instanceStruct.instancePar_NFIN/modelStruct.modelPar_U0N2))))));
}
}
d_PHIG_i_dX = (d_PHIG_i_dX+(modelStruct.modelPar_PHIGL*d_Leff_dX+modelStruct.d_modelPar_PHIGL_dX*Leff));
PHIG_i = (PHIG_i+(modelStruct.modelPar_PHIGL*Leff));
if ((modelStruct.modelPar_LPA>0))
{
{
double value_pow_0 = pow(Leff,(-modelStruct.modelPar_LPA));
double  deriv_pow_0_d0 = ((Leff == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_LPA)/Leff));
double  deriv_pow_0_d1 = (Leff == 0.0)?0.0:(log(Leff)*value_pow_0);
d_U0_i_dX = (U0_i*(-(UP_i*((deriv_pow_0_d0*(d_Leff_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_LPA_dX))))+d_UP_i_dX*value_pow_0))+d_U0_i_dX*(1-(UP_i*value_pow_0)));
U0_i = (U0_i*(1-(UP_i*value_pow_0)));
}
}
else
{
d_U0_i_dX = (U0_i*(-d_UP_i_dX)+d_U0_i_dX*(1-UP_i));
U0_i = (U0_i*(1-UP_i));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BUA));
d_UA_i_dX = (d_UA_i_dX+(modelStruct.modelPar_AUA*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BUA),((modelStruct.modelPar_BUA*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BUA_dX)/modelStruct.modelPar_BUA/modelStruct.modelPar_BUA))+modelStruct.d_modelPar_AUA_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BUA))));
UA_i = (UA_i+(modelStruct.modelPar_AUA*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BUA))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BUD));
d_UD_i_dX = (d_UD_i_dX+(modelStruct.modelPar_AUD*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BUD),((modelStruct.modelPar_BUD*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BUD_dX)/modelStruct.modelPar_BUD/modelStruct.modelPar_BUD))+modelStruct.d_modelPar_AUD_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BUD))));
UD_i = (UD_i+(modelStruct.modelPar_AUD*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BUD))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BEU));
d_EU_i_dX = (d_EU_i_dX+(modelStruct.modelPar_AEU*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BEU),((modelStruct.modelPar_BEU*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BEU_dX)/modelStruct.modelPar_BEU/modelStruct.modelPar_BEU))+modelStruct.d_modelPar_AEU_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BEU))));
EU_i = (EU_i+(modelStruct.modelPar_AEU*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BEU))));
}
if ((modelStruct.modelPar_RDSMOD==1))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BRSW));
d_RSW_i_dX = (d_RSW_i_dX+(modelStruct.modelPar_ARSW*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BRSW),((modelStruct.modelPar_BRSW*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BRSW_dX)/modelStruct.modelPar_BRSW/modelStruct.modelPar_BRSW))+modelStruct.d_modelPar_ARSW_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BRSW))));
RSW_i = (RSW_i+(modelStruct.modelPar_ARSW*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BRSW))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BRDW));
d_RDW_i_dX = (d_RDW_i_dX+(modelStruct.modelPar_ARDW*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BRDW),((modelStruct.modelPar_BRDW*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BRDW_dX)/modelStruct.modelPar_BRDW/modelStruct.modelPar_BRDW))+modelStruct.d_modelPar_ARDW_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BRDW))));
RDW_i = (RDW_i+(modelStruct.modelPar_ARDW*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BRDW))));
}
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BRDSW));
d_RDSW_i_dX = (d_RDSW_i_dX+(modelStruct.modelPar_ARDSW*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BRDSW),((modelStruct.modelPar_BRDSW*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BRDSW_dX)/modelStruct.modelPar_BRDSW/modelStruct.modelPar_BRDSW))+modelStruct.d_modelPar_ARDSW_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BRDSW))));
RDSW_i = (RDSW_i+(modelStruct.modelPar_ARDSW*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BRDSW))));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BPCLM));
d_PCLM_i_dX = (d_PCLM_i_dX+(modelStruct.modelPar_APCLM*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BPCLM),((modelStruct.modelPar_BPCLM*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BPCLM_dX)/modelStruct.modelPar_BPCLM/modelStruct.modelPar_BPCLM))+modelStruct.d_modelPar_APCLM_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPCLM))));
PCLM_i = (PCLM_i+(modelStruct.modelPar_APCLM*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPCLM))));
}
{
double value_pow_0 = pow(Leff,(-modelStruct.modelPar_BMEXP));
double  deriv_pow_0_d0 = ((Leff == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_BMEXP)/Leff));
double  deriv_pow_0_d1 = (Leff == 0.0)?0.0:(log(Leff)*value_pow_0);
d_MEXP_i_dX = (d_MEXP_i_dX+(modelStruct.modelPar_AMEXP*((deriv_pow_0_d0*(d_Leff_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_BMEXP_dX))))+modelStruct.d_modelPar_AMEXP_dX*value_pow_0));
MEXP_i = (MEXP_i+(modelStruct.modelPar_AMEXP*value_pow_0));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
double value_pow_0 = pow(Leff,(-modelStruct.modelPar_BMEXPR));
double  deriv_pow_0_d0 = ((Leff == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_BMEXPR)/Leff));
double  deriv_pow_0_d1 = (Leff == 0.0)?0.0:(log(Leff)*value_pow_0);
d_MEXPR_i_dX = (d_MEXPR_i_dX+(modelStruct.modelPar_AMEXPR*((deriv_pow_0_d0*(d_Leff_dX))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_BMEXPR_dX))))+modelStruct.d_modelPar_AMEXPR_dX*value_pow_0));
MEXPR_i = (MEXPR_i+(modelStruct.modelPar_AMEXPR*value_pow_0));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BPTWG));
d_PTWG_i_dX = (d_PTWG_i_dX+(modelStruct.modelPar_APTWG*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BPTWG),((modelStruct.modelPar_BPTWG*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BPTWG_dX)/modelStruct.modelPar_BPTWG/modelStruct.modelPar_BPTWG))+modelStruct.d_modelPar_APTWG_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPTWG))));
PTWG_i = (PTWG_i+(modelStruct.modelPar_APTWG*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPTWG))));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BPTWG));
d_PTWGR_i_dX = (d_PTWGR_i_dX+(modelStruct.modelPar_APTWG*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BPTWG),((modelStruct.modelPar_BPTWG*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BPTWG_dX)/modelStruct.modelPar_BPTWG/modelStruct.modelPar_BPTWG))+modelStruct.d_modelPar_APTWG_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPTWG))));
PTWGR_i = (PTWGR_i+(modelStruct.modelPar_APTWG*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPTWG))));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BVSAT));
d_VSAT_i_dX = (d_VSAT_i_dX+(modelStruct.modelPar_AVSAT*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BVSAT),((modelStruct.modelPar_BVSAT*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BVSAT_dX)/modelStruct.modelPar_BVSAT/modelStruct.modelPar_BVSAT))+modelStruct.d_modelPar_AVSAT_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BVSAT))));
VSAT_i = (VSAT_i+(modelStruct.modelPar_AVSAT*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BVSAT))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BVSAT1));
d_VSAT1_i_dX = (d_VSAT1_i_dX+(modelStruct.modelPar_AVSAT1*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BVSAT1),((modelStruct.modelPar_BVSAT1*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BVSAT1_dX)/modelStruct.modelPar_BVSAT1/modelStruct.modelPar_BVSAT1))+modelStruct.d_modelPar_AVSAT1_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BVSAT1))));
VSAT1_i = (VSAT1_i+(modelStruct.modelPar_AVSAT1*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BVSAT1))));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BVSAT1));
d_VSAT1R_i_dX = (d_VSAT1R_i_dX+(modelStruct.modelPar_AVSAT1*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BVSAT1),((modelStruct.modelPar_BVSAT1*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BVSAT1_dX)/modelStruct.modelPar_BVSAT1/modelStruct.modelPar_BVSAT1))+modelStruct.d_modelPar_AVSAT1_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BVSAT1))));
VSAT1R_i = (VSAT1R_i+(modelStruct.modelPar_AVSAT1*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BVSAT1))));
}
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BPSAT));
d_PSAT_i_dX = (d_PSAT_i_dX+(modelStruct.modelPar_APSAT*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BPSAT),((modelStruct.modelPar_BPSAT*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BPSAT_dX)/modelStruct.modelPar_BPSAT/modelStruct.modelPar_BPSAT))+modelStruct.d_modelPar_APSAT_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPSAT))));
PSAT_i = (PSAT_i+(modelStruct.modelPar_APSAT*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPSAT))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-Leff)/modelStruct.modelPar_BPSATCV));
d_PSATCV_i_dX = (d_PSATCV_i_dX+(modelStruct.modelPar_APSATCV*evaluator_lexp_0.getDerivs(((-Leff)/modelStruct.modelPar_BPSATCV),((modelStruct.modelPar_BPSATCV*(-d_Leff_dX)-(-Leff)*modelStruct.d_modelPar_BPSATCV_dX)/modelStruct.modelPar_BPSATCV/modelStruct.modelPar_BPSATCV))+modelStruct.d_modelPar_APSATCV_dX*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPSATCV))));
PSATCV_i = (PSATCV_i+(modelStruct.modelPar_APSATCV*evaluator_lexp_0.getValues(((-Leff)/modelStruct.modelPar_BPSATCV))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-LeffCV)/modelStruct.modelPar_BVSATCV));
d_VSATCV_i_dX = (d_VSATCV_i_dX+(modelStruct.modelPar_AVSATCV*evaluator_lexp_0.getDerivs(((-LeffCV)/modelStruct.modelPar_BVSATCV),((modelStruct.modelPar_BVSATCV*(-d_LeffCV_dX)-(-LeffCV)*modelStruct.d_modelPar_BVSATCV_dX)/modelStruct.modelPar_BVSATCV/modelStruct.modelPar_BVSATCV))+modelStruct.d_modelPar_AVSATCV_dX*evaluator_lexp_0.getValues(((-LeffCV)/modelStruct.modelPar_BVSATCV))));
VSATCV_i = (VSATCV_i+(modelStruct.modelPar_AVSATCV*evaluator_lexp_0.getValues(((-LeffCV)/modelStruct.modelPar_BVSATCV))));
}
if ((((QMTCENIV_i>0.0)||(QMTCENCV_i>0.0))||(QMTCENCVA_i>0.0)))
{
if ( modelStruct.modelPar_GEOMOD == (0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-instanceStruct.instancePar_TFIN)/modelStruct.modelPar_BQMTCEN));
d_MTcen_dX = (modelStruct.modelPar_AQMTCEN*evaluator_lexp_0.getDerivs(((-instanceStruct.instancePar_TFIN)/modelStruct.modelPar_BQMTCEN),((modelStruct.modelPar_BQMTCEN*(-instanceStruct.d_instancePar_TFIN_dX)-(-instanceStruct.instancePar_TFIN)*modelStruct.d_modelPar_BQMTCEN_dX)/modelStruct.modelPar_BQMTCEN/modelStruct.modelPar_BQMTCEN))+modelStruct.d_modelPar_AQMTCEN_dX*evaluator_lexp_0.getValues(((-instanceStruct.instancePar_TFIN)/modelStruct.modelPar_BQMTCEN)));
MTcen = (1.0+(modelStruct.modelPar_AQMTCEN*evaluator_lexp_0.getValues(((-instanceStruct.instancePar_TFIN)/modelStruct.modelPar_BQMTCEN))));
}
d_Tcen0_dX = (instanceStruct.instancePar_TFIN*d_MTcen_dX+instanceStruct.d_instancePar_TFIN_dX*MTcen);
Tcen0 = (instanceStruct.instancePar_TFIN*MTcen);
}
else
if ( modelStruct.modelPar_GEOMOD == (1))
{
{
double value_min_0 = std::min(modelStruct.modelPar_HFIN,instanceStruct.instancePar_TFIN);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-value_min_0)/modelStruct.modelPar_BQMTCEN));
double  deriv_min_0_d0 = ((modelStruct.modelPar_HFIN<=instanceStruct.instancePar_TFIN)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelPar_HFIN<=instanceStruct.instancePar_TFIN)?0.0:1.0);
d_MTcen_dX = (modelStruct.modelPar_AQMTCEN*evaluator_lexp_1.getDerivs(((-value_min_0)/modelStruct.modelPar_BQMTCEN),((modelStruct.modelPar_BQMTCEN*(-((deriv_min_0_d0*(modelStruct.d_modelPar_HFIN_dX))+(deriv_min_0_d1*(instanceStruct.d_instancePar_TFIN_dX))))-(-value_min_0)*modelStruct.d_modelPar_BQMTCEN_dX)/modelStruct.modelPar_BQMTCEN/modelStruct.modelPar_BQMTCEN))+modelStruct.d_modelPar_AQMTCEN_dX*evaluator_lexp_1.getValues(((-value_min_0)/modelStruct.modelPar_BQMTCEN)));
MTcen = (1.0+(modelStruct.modelPar_AQMTCEN*evaluator_lexp_1.getValues(((-value_min_0)/modelStruct.modelPar_BQMTCEN))));
}
{
double value_min_0 = std::min(instanceStruct.instancePar_TFIN,modelStruct.modelPar_HFIN);
double  deriv_min_0_d0 = ((instanceStruct.instancePar_TFIN<=modelStruct.modelPar_HFIN)?1.0:0.0);
double  deriv_min_0_d1 = ((instanceStruct.instancePar_TFIN<=modelStruct.modelPar_HFIN)?0.0:1.0);
d_Tcen0_dX = (value_min_0*d_MTcen_dX+((deriv_min_0_d0*(instanceStruct.d_instancePar_TFIN_dX))+(deriv_min_0_d1*(modelStruct.d_modelPar_HFIN_dX)))*MTcen);
Tcen0 = (value_min_0*MTcen);
}
}
else
if ( modelStruct.modelPar_GEOMOD == (2))
{
{
double value_min_0 = std::min(modelStruct.modelPar_HFIN,instanceStruct.instancePar_TFIN);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-value_min_0)/modelStruct.modelPar_BQMTCEN));
double  deriv_min_0_d0 = ((modelStruct.modelPar_HFIN<=instanceStruct.instancePar_TFIN)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelPar_HFIN<=instanceStruct.instancePar_TFIN)?0.0:1.0);
d_MTcen_dX = (modelStruct.modelPar_AQMTCEN*evaluator_lexp_1.getDerivs(((-value_min_0)/modelStruct.modelPar_BQMTCEN),((modelStruct.modelPar_BQMTCEN*(-((deriv_min_0_d0*(modelStruct.d_modelPar_HFIN_dX))+(deriv_min_0_d1*(instanceStruct.d_instancePar_TFIN_dX))))-(-value_min_0)*modelStruct.d_modelPar_BQMTCEN_dX)/modelStruct.modelPar_BQMTCEN/modelStruct.modelPar_BQMTCEN))+modelStruct.d_modelPar_AQMTCEN_dX*evaluator_lexp_1.getValues(((-value_min_0)/modelStruct.modelPar_BQMTCEN)));
MTcen = (1.0+(modelStruct.modelPar_AQMTCEN*evaluator_lexp_1.getValues(((-value_min_0)/modelStruct.modelPar_BQMTCEN))));
}
{
double value_min_0 = std::min(instanceStruct.instancePar_TFIN,modelStruct.modelPar_HFIN);
double  deriv_min_0_d0 = ((instanceStruct.instancePar_TFIN<=modelStruct.modelPar_HFIN)?1.0:0.0);
double  deriv_min_0_d1 = ((instanceStruct.instancePar_TFIN<=modelStruct.modelPar_HFIN)?0.0:1.0);
d_Tcen0_dX = (value_min_0*d_MTcen_dX+((deriv_min_0_d0*(instanceStruct.d_instancePar_TFIN_dX))+(deriv_min_0_d1*(modelStruct.d_modelPar_HFIN_dX)))*MTcen);
Tcen0 = (value_min_0*MTcen);
}
}
else
if ( modelStruct.modelPar_GEOMOD == (3))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-R)/modelStruct.modelPar_BQMTCEN));
d_MTcen_dX = (modelStruct.modelPar_AQMTCEN*evaluator_lexp_0.getDerivs(((-R)/modelStruct.modelPar_BQMTCEN),((modelStruct.modelPar_BQMTCEN*(-d_R_dX)-(-R)*modelStruct.d_modelPar_BQMTCEN_dX)/modelStruct.modelPar_BQMTCEN/modelStruct.modelPar_BQMTCEN))+modelStruct.d_modelPar_AQMTCEN_dX*evaluator_lexp_0.getValues(((-R)/modelStruct.modelPar_BQMTCEN)));
MTcen = (1.0+(modelStruct.modelPar_AQMTCEN*evaluator_lexp_0.getValues(((-R)/modelStruct.modelPar_BQMTCEN))));
}
d_Tcen0_dX = (R*d_MTcen_dX+d_R_dX*MTcen);
Tcen0 = (R*MTcen);
}
else
{
 // no default
}
}
if ((Leff<=0))
{
UserInfo(theInstance)  << "Fatal: Leff = %e is not positive." << " " << Leff << " " <<  std::endl; 
}
else
{
if ((Leff<=1e-9))
{
UserInfo(theInstance)  << "Warning: Leff = %e <= 1.0e-9." << " " << Leff << " " <<  std::endl; 
}
}
if ((LeffCV<=1e-9))
{
UserInfo(theInstance)  << "Warning: LeffCV = %e <= 1.0e-9." << " " << LeffCV << " " <<  std::endl; 
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
if ((LeffCV_acc<=1e-9))
{
UserInfo(theInstance)  << "Warning: LeffCV_acc = %e <= 1.0e-9." << " " << LeffCV_acc << " " <<  std::endl; 
}
}
if ((Weff0<=1e-9))
{
UserInfo(theInstance)  << "Warning: Weff0 = %e <= 1.0e-9." << " " << Weff0 << " " <<  std::endl; 
}
if ((WeffCV0<=1e-9))
{
UserInfo(theInstance)  << "Warning: WeffCV0 = %e <= 1.0e-9." << " " << WeffCV0 << " " <<  std::endl; 
}
if ((NBODY_i<=0))
{
UserInfo(theInstance)  << "Fatal: NBODY_i = %e is not positive." << " " << NBODY_i << " " <<  std::endl; 
}
else
{
if ((NBODY_i<=1e18))
{
UserInfo(theInstance)  << "Warning: NBODY_i = %e m^-3 may be too small." << " " << NBODY_i << " " <<  std::endl; 
}
}
if ((NGATE_i<0))
{
UserInfo(theInstance)  << "Fatal: NGATE_i = %e is negative." << " " << NGATE_i << " " <<  std::endl; 
}
else
{
if (((NGATE_i!=0)&&(NGATE_i<=1e24)))
{
UserInfo(theInstance)  << "Warning: NGATE_i = %e may be too small." << " " << NGATE_i << " " <<  std::endl; 
}
else
{
if ((NGATE_i>1e31))
{
UserInfo(theInstance)  << "Fatal: NGATE_i = %e is too high." << " " << NGATE_i << " " <<  std::endl; 
}
}
}
if ((DVT0_i<0))
{
UserInfo(theInstance)  << "Warning: DVT0_i = %e is negative." << " " << DVT0_i << " " <<  std::endl; 
}
if ((DVT1_i<=0))
{
UserInfo(theInstance)  << "Fatal: DVT1_i = %e is not positive." << " " << DVT1_i << " " <<  std::endl; 
}
if ((DVT1SS_i<=0))
{
UserInfo(theInstance)  << "Fatal: DVT1SS_i = %e is not positive." << " " << DVT1SS_i << " " <<  std::endl; 
}
if ((CDSC_i<0))
{
UserInfo(theInstance)  << "Warning: CDSC_i = %e is negative." << " " << CDSC_i << " " <<  std::endl; 
}
if ((CDSCD_i<0))
{
UserInfo(theInstance)  << "Warning: CDSCD_i = %e is negative." << " " << CDSCD_i << " " <<  std::endl; 
}
if ((DSUB_i<=0))
{
UserInfo(theInstance)  << "Fatal: DSUB_i = %e is not positive." << " " << DSUB_i << " " <<  std::endl; 
}
if ((ETA0_i<0))
{
UserInfo(theInstance)  << "Warning: ETA0_i = %e is negative." << " " << ETA0_i << " " <<  std::endl; 
}
if ((LPE0_i<(-Leff)))
{
UserInfo(theInstance)  << "Warning: LPE0_i = %e is less than -Leff. Clipping LPE0_i to 0" << " " << LPE0_i << " " <<  std::endl; 
d_LPE0_i_dX = 0.0;
LPE0_i = 0;
}
if ((K0SI_i<=0))
{
UserInfo(theInstance)  << "Warning: K0SI_i = %e is not positive, setting it to 0." << " " << K0SI_i << " " <<  std::endl; 
d_K0SI_i_dX = 0.0;
K0SI_i = 0;
}
if ((K1SI_i<=0))
{
UserInfo(theInstance)  << "Warning: K1SI_i = %e is not positive, setting it to 0." << " " << K1SI_i << " " <<  std::endl; 
d_K1SI_i_dX = 0.0;
K1SI_i = 0;
}
if (((PHIBE_i<0.2)&&(modelStruct.modelPar_BULKMOD!=0)))
{
UserInfo(theInstance)  << "Warning: PHIBE_i = %e is less than 0.2, setting it to 0.2." << " " << PHIBE_i << " " <<  std::endl; 
d_PHIBE_i_dX = 0.0;
PHIBE_i = 0.2;
}
if (((PHIBE_i>1.2)&&(modelStruct.modelPar_BULKMOD!=0)))
{
UserInfo(theInstance)  << "Warning: PHIBE_i = %e is larger than 1.2, setting it to 1.2." << " " << PHIBE_i << " " <<  std::endl; 
d_PHIBE_i_dX = 0.0;
PHIBE_i = 1.2;
}
if ((PSAT_i<2.0))
{
UserInfo(theInstance)  << "Warning: PSAT_i = %e is less than 2.0, setting it to 2.0." << " " << PSAT_i << " " <<  std::endl; 
d_PSAT_i_dX = 0.0;
PSAT_i = 2.0;
}
if ((PSATCV_i<2.0))
{
UserInfo(theInstance)  << "Warning: PSATCV_i = %e is less than 2.0, setting it to 2.0." << " " << PSATCV_i << " " <<  std::endl; 
d_PSATCV_i_dX = 0.0;
PSATCV_i = 2.0;
}
if ((U0_i<0))
{
UserInfo(theInstance)  << "Warning: U0_i = %e is negative, setting it to 0." << " " << U0_i << " " <<  std::endl; 
d_U0_i_dX = 0.0;
U0_i = 0;
}
if ((UA_i<0))
{
UserInfo(theInstance)  << "Warning: UA_i = %e is negative, setting it to 0." << " " << UA_i << " " <<  std::endl; 
d_UA_i_dX = 0.0;
UA_i = 0;
}
if ((EU_i<0))
{
UserInfo(theInstance)  << "Warning: EU_i = %e is negative, setting it to 0." << " " << EU_i << " " <<  std::endl; 
d_EU_i_dX = 0.0;
EU_i = 0;
}
if ((UD_i<0))
{
UserInfo(theInstance)  << "Warning: UD_i = %e is negative, setting it to 0." << " " << UD_i << " " <<  std::endl; 
d_UD_i_dX = 0.0;
UD_i = 0;
}
if ((UCS_i<0))
{
UserInfo(theInstance)  << "Warning: UCS_i = %e is negative, setting it to 0." << " " << UCS_i << " " <<  std::endl; 
d_UCS_i_dX = 0.0;
UCS_i = 0;
}
d_RDSWMIN_i_dX = modelStruct.d_modelPar_RDSWMIN_dX;
RDSWMIN_i = modelStruct.modelPar_RDSWMIN;
if ((RDSWMIN_i<0))
{
UserInfo(theInstance)  << "Warning: RDSWMIN = %e is negative.  Set to zero" << " " << RDSWMIN_i << " " <<  std::endl; 
d_RDSWMIN_i_dX = 0.0;
RDSWMIN_i = 0;
}
if ((RDSW_i<0))
{
UserInfo(theInstance)  << "Warning: RDSW_i = %e is negative.  Set to zero" << " " << RDSW_i << " " <<  std::endl; 
d_RDSW_i_dX = 0.0;
RDSW_i = 0;
}
d_RSWMIN_i_dX = modelStruct.d_modelPar_RSWMIN_dX;
RSWMIN_i = modelStruct.modelPar_RSWMIN;
if ((RSWMIN_i<0))
{
UserInfo(theInstance)  << "Warning: RSWMIN = %e is negative.  Set to zero" << " " << RSWMIN_i << " " <<  std::endl; 
d_RSWMIN_i_dX = 0.0;
RSWMIN_i = 0;
}
if ((RSW_i<0))
{
UserInfo(theInstance)  << "Warning: RSW_i = %e is negative.  Set to zero" << " " << RSW_i << " " <<  std::endl; 
d_RSW_i_dX = 0.0;
RSW_i = 0;
}
d_RDWMIN_i_dX = modelStruct.d_modelPar_RDWMIN_dX;
RDWMIN_i = modelStruct.modelPar_RDWMIN;
if ((RDWMIN_i<0))
{
UserInfo(theInstance)  << "Warning: RDWMIN = %e is negative.  Set to zero" << " " << RDWMIN_i << " " <<  std::endl; 
d_RDWMIN_i_dX = 0.0;
RDWMIN_i = 0;
}
if ((RDW_i<0))
{
UserInfo(theInstance)  << "Warning: RDW_i = %e is negative.  Set to zero" << " " << RDW_i << " " <<  std::endl; 
d_RDW_i_dX = 0.0;
RDW_i = 0;
}
if ((PRWGD_i<0))
{
UserInfo(theInstance)  << "Warning: PRWGD_i = %e is negative.  Set to zero" << " " << PRWGD_i << " " <<  std::endl; 
d_PRWGD_i_dX = 0.0;
PRWGD_i = 0;
}
if ((PRWGS_i<0))
{
UserInfo(theInstance)  << "Warning: PRWGS_i = %e is negative.  Set to zero" << " " << PRWGS_i << " " <<  std::endl; 
d_PRWGS_i_dX = 0.0;
PRWGS_i = 0;
}
if ((PCLM_i<0))
{
UserInfo(theInstance)  << "Warning: PCLM_i = %e is negative." << " " << PCLM_i << " " <<  std::endl; 
}
if ((PDIBL1_i<0))
{
UserInfo(theInstance)  << "Warning: PDIBL1_i = %e is negative." << " " << PDIBL1_i << " " <<  std::endl; 
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
if ((PDIBL1R_i<0))
{
UserInfo(theInstance)  << "Warning: PDIBL1R_i = %e is negative." << " " << PDIBL1R_i << " " <<  std::endl; 
}
}
if ((PDIBL2_i<0))
{
UserInfo(theInstance)  << "Fatal: PDIBL2_i = %e is negative." << " " << PDIBL2_i << " " <<  std::endl; 
}
if ((DROUT_i<=0))
{
UserInfo(theInstance)  << "Fatal: DROUT_i = %e is non-positive." << " " << DROUT_i << " " <<  std::endl; 
}
if ((MEXP_i<2.0))
{
UserInfo(theInstance)  << "Warning: MEXP_i = %e < 2.  Setting MEXP_i = 2." << " " << MEXP_i << " " <<  std::endl; 
d_MEXP_i_dX = 0.0;
MEXP_i = 2.0;
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
if ((MEXPR_i<2.0))
{
UserInfo(theInstance)  << "Warning: MEXPR_i = %e < 2.  Setting MEXPR_i = 2." << " " << MEXPR_i << " " <<  std::endl; 
d_MEXPR_i_dX = 0.0;
MEXPR_i = 2.0;
}
}
if ((PTWG_i<0))
{
UserInfo(theInstance)  << "Warning: PTWG_i = %e is negative, setting it to 0." << " " << PTWG_i << " " <<  std::endl; 
d_PTWG_i_dX = 0.0;
PTWG_i = 0;
}
if (((QMTCENIV_i>0)||(QMTCENCV_i>0)))
{
if ((modelStruct.modelPar_QM0<=0))
{
UserInfo(theInstance)  << "Fatal: QM0 = %e is non-positive." << " " << modelStruct.modelPar_QM0 << " " <<  std::endl; 
}
}
if ((((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0))&&(QMTCENCVA_i>0)))
{
if ((modelStruct.modelPar_QM0ACC<=0))
{
UserInfo(theInstance)  << "Fatal: QM0ACC = %e is non-positive." << " " << modelStruct.modelPar_QM0ACC << " " <<  std::endl; 
}
}
if ((CGIDL_i<0.0))
{
UserInfo(theInstance)  << "Warning: CGIDL_i = %e < 0.  Setting CGIDL_i = 0." << " " << CGIDL_i << " " <<  std::endl; 
d_CGIDL_i_dX = 0.0;
CGIDL_i = 0.0;
}
if ((CGISL_i<0.0))
{
UserInfo(theInstance)  << "Warning: CGISL_i = %e < 0.  Setting CGISL_i = 0." << " " << CGISL_i << " " <<  std::endl; 
d_CGISL_i_dX = 0.0;
CGISL_i = 0.0;
}
if ((modelStruct.modelPar_IGBMOD!=0))
{
if ((NIGBINV_i<=0))
{
UserInfo(theInstance)  << "Fatal: NIGBINV_i = %e is non-positive." << " " << NIGBINV_i << " " <<  std::endl; 
}
if ((NIGBACC_i<=0))
{
UserInfo(theInstance)  << "Fatal: NIGBACC_i = %e is non-positive." << " " << NIGBACC_i << " " <<  std::endl; 
}
}
if ((modelStruct.modelPar_IGCMOD!=0))
{
if ((POXEDGE_i<=0))
{
UserInfo(theInstance)  << "Fatal: POXEDGE_i = %e is non-positive." << " " << POXEDGE_i << " " <<  std::endl; 
}
if ((PIGCD_i<=0))
{
UserInfo(theInstance)  << "Fatal: PIGCD_i = %e is non-positive." << " " << PIGCD_i << " " <<  std::endl; 
}
}
if (((modelStruct.modelPar_IGCMOD!=0)||(modelStruct.modelPar_IGBMOD!=0)))
{
if ((modelStruct.modelPar_TOXREF<=0))
{
UserInfo(theInstance)  << "Fatal: TOXREF = %e is non-positive." << " " << modelStruct.modelPar_TOXREF << " " <<  std::endl; 
}
}
if ((modelStruct.modelPar_LINTIGEN>=(Leff/2)))
{
UserInfo(theInstance)  << "Warning: LINTIGEN = %e is too large - Leff for r/g current is negative.  Re-setting LINTIGEN = 0." << " " << modelStruct.modelPar_LINTIGEN << " " <<  std::endl; 
d_LINTIGEN_i_dX = 0.0;
LINTIGEN_i = 0;
}
else
{
d_LINTIGEN_i_dX = modelStruct.d_modelPar_LINTIGEN_dX;
LINTIGEN_i = modelStruct.modelPar_LINTIGEN;
}
if ((NTGEN_i<=0))
{
UserInfo(theInstance)  << "Fatal: NTGEN_i = %e is non-positive." << " " << NTGEN_i << " " <<  std::endl; 
}
if ((modelStruct.modelPar_IIMOD==2))
{
if ((BETAII0_i<0.0))
{
UserInfo(theInstance)  << "Warning:  BETAII0_i = %e is negative." << " " << BETAII0_i << " " <<  std::endl; 
}
if ((BETAII1_i<0.0))
{
UserInfo(theInstance)  << "Warning:  BETAII1_i = %e is negative." << " " << BETAII1_i << " " <<  std::endl; 
}
if ((BETAII2_i<0.0))
{
UserInfo(theInstance)  << "Warning:  BETAII2_i = %e is negative." << " " << BETAII2_i << " " <<  std::endl; 
}
if ((ESATII_i<0.0))
{
UserInfo(theInstance)  << "Warning:  ESATII_i = %e is negative." << " " << ESATII_i << " " <<  std::endl; 
}
if ((LII_i<0.0))
{
UserInfo(theInstance)  << "Warning:  LII_i = %e is negative." << " " << LII_i << " " <<  std::endl; 
}
if ((SII1_i<0.0))
{
UserInfo(theInstance)  << "Warning:  SII1_i = %e is negative." << " " << modelStruct.modelPar_SII1 << " " <<  std::endl; 
}
if ((SII2_i<0.0))
{
UserInfo(theInstance)  << "Warning:  SII2_i = %e is negative." << " " << SII2_i << " " <<  std::endl; 
}
if ((SIID_i<0.0))
{
UserInfo(theInstance)  << "Warning:  SIID_i = %e is negative." << " " << SIID_i << " " <<  std::endl; 
}
}
if ((modelStruct.modelPar_EF<=0))
{
UserInfo(theInstance)  << "Fatal: EF = %e is non-positive." << " " << modelStruct.modelPar_EF << " " <<  std::endl; 
}
else
{
if ((modelStruct.modelPar_EF>2.0))
{
UserInfo(theInstance)  << "Fatal: EF = %e > 2.0." << " " << modelStruct.modelPar_EF << " " <<  std::endl; 
}
}
if ((modelStruct.modelPar_LINTNOI>=(Leff/2)))
{
UserInfo(theInstance)  << "Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0." << " " << modelStruct.modelPar_LINTNOI << " " <<  std::endl; 
d_LINTNOI_i_dX = 0.0;
LINTNOI_i = 0;
}
else
{
d_LINTNOI_i_dX = modelStruct.d_modelPar_LINTNOI_dX;
LINTNOI_i = modelStruct.modelPar_LINTNOI;
}
if ((modelStruct.modelPar_NTNOI<0))
{
UserInfo(theInstance)  << "Warning: NTNOI = %e is negative. Set to zero." << " " << modelStruct.modelPar_NTNOI << " " <<  std::endl; 
d_NTNOI_i_dX = 0.0;
NTNOI_i = 0;
}
else
{
d_NTNOI_i_dX = modelStruct.d_modelPar_NTNOI_dX;
NTNOI_i = modelStruct.modelPar_NTNOI;
}
if ((modelStruct.modelPar_SHMOD!=0))
{
UserInfo(theInstance)  << "[bsimcmg] Although the model selector SHMOD is set to 1, the self heating model is not activated in the Verilog-A code.  Please uncomment `define __SHMOD__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
if ((modelStruct.modelPar_RGATEMOD!=0))
{
UserInfo(theInstance)  << "[bsimcmg] Although the model selector RGATEMOD is set to 1, the gate electrode resistance model is not activated in the Verilog-A code.  Please uncomment `define __RGATEMOD__ in bsimcmg.va to activate it." << " " <<  std::endl; 
}
if ((modelStruct.modelPar_RGEOMOD==0))
{
d_RSourceGeo_dX = (modelStruct.modelPar_RSHS*instanceStruct.d_instancePar_NRS_dX+modelStruct.d_modelPar_RSHS_dX*instanceStruct.instancePar_NRS);
RSourceGeo = (modelStruct.modelPar_RSHS*instanceStruct.instancePar_NRS);
d_RDrainGeo_dX = (modelStruct.modelPar_RSHD*instanceStruct.d_instancePar_NRD_dX+modelStruct.d_modelPar_RSHD_dX*instanceStruct.instancePar_NRD);
RDrainGeo = (modelStruct.modelPar_RSHD*instanceStruct.instancePar_NRD);
}
else
{
if ((modelStruct.modelPar_HEPI>0))
{
d_Arsd_dX = ((instanceStruct.instancePar_FPITCH*modelStruct.d_modelPar_HFIN_dX+instanceStruct.d_instancePar_FPITCH_dX*modelStruct.modelPar_HFIN)+((instanceStruct.instancePar_TFIN+((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*modelStruct.modelPar_CRATIO))*modelStruct.d_modelPar_HEPI_dX+(instanceStruct.d_instancePar_TFIN_dX+((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*modelStruct.d_modelPar_CRATIO_dX+(instanceStruct.d_instancePar_FPITCH_dX-instanceStruct.d_instancePar_TFIN_dX)*modelStruct.modelPar_CRATIO))*modelStruct.modelPar_HEPI));
Arsd = ((instanceStruct.instancePar_FPITCH*modelStruct.modelPar_HFIN)+((instanceStruct.instancePar_TFIN+((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*modelStruct.modelPar_CRATIO))*modelStruct.modelPar_HEPI));
}
else
{
{
double value_max_0 = std::max((modelStruct.modelPar_HFIN+modelStruct.modelPar_HEPI),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = (((modelStruct.modelPar_HFIN+modelStruct.modelPar_HEPI)>=1.0e-9)?1.0:0.0);
d_Arsd_dX = (instanceStruct.instancePar_FPITCH*(deriv_max_0_d0*((modelStruct.d_modelPar_HFIN_dX+modelStruct.d_modelPar_HEPI_dX)))+instanceStruct.d_instancePar_FPITCH_dX*value_max_0);
Arsd = (instanceStruct.instancePar_FPITCH*value_max_0);
}
}
d_Prsd_dX = (instanceStruct.d_instancePar_FPITCH_dX+modelStruct.d_modelPar_DELTAPRSD_dX);
Prsd = (instanceStruct.instancePar_FPITCH+modelStruct.modelPar_DELTAPRSD);
if (modelStruct.modelPar_given_RHORSD)
{
d_rhorsd_dX = modelStruct.d_modelPar_RHORSD_dX;
rhorsd = modelStruct.modelPar_RHORSD;
}
else
{
d_mu_max_dX = 0.0;
mu_max = ((modelStruct.modelPar_DEVTYPE==1)?1417:470.5);
if ((modelStruct.modelPar_DEVTYPE==1))
{
{
double value_pow_0 = pow((modelStruct.modelPar_NSD/9.68e22),0.680);
double value_pow_1 = pow((3.43e26/modelStruct.modelPar_NSD),2);
double  deriv_pow_0_d0 = (((modelStruct.modelPar_NSD/9.68e22) == 0.0)?0.0:(value_pow_0*0.680/(modelStruct.modelPar_NSD/9.68e22)));
double  deriv_pow_1_d0 = (((3.43e26/modelStruct.modelPar_NSD) == 0.0)?0.0:(value_pow_1*2/(3.43e26/modelStruct.modelPar_NSD)));
d_mu_rsd_dX = ((((1+value_pow_0)*d_mu_max_dX-(mu_max-52.2)*(deriv_pow_0_d0*((modelStruct.d_modelPar_NSD_dX/9.68e22))))/(1+value_pow_0)/(1+value_pow_0))-(-43.4*(deriv_pow_1_d0*((-3.43e26*modelStruct.d_modelPar_NSD_dX/modelStruct.modelPar_NSD/modelStruct.modelPar_NSD)))/(1.0+value_pow_1)/(1.0+value_pow_1)))*1.0e-4;
mu_rsd = (((52.2+((mu_max-52.2)/(1+value_pow_0)))-(43.4/(1.0+value_pow_1)))*1.0e-4);
}
}
else
{
{
double value_pow_0 = pow((modelStruct.modelPar_NSD/2.23e22),0.719);
double value_pow_1 = pow((6.10e26/modelStruct.modelPar_NSD),2);
double  deriv_pow_0_d0 = (((modelStruct.modelPar_NSD/2.23e22) == 0.0)?0.0:(value_pow_0*0.719/(modelStruct.modelPar_NSD/2.23e22)));
double  deriv_pow_1_d0 = (((6.10e26/modelStruct.modelPar_NSD) == 0.0)?0.0:(value_pow_1*2/(6.10e26/modelStruct.modelPar_NSD)));
d_mu_rsd_dX = ((((1+value_pow_0)*d_mu_max_dX-(mu_max-44.9)*(deriv_pow_0_d0*((modelStruct.d_modelPar_NSD_dX/2.23e22))))/(1+value_pow_0)/(1+value_pow_0))-(-29.0*(deriv_pow_1_d0*((-6.10e26*modelStruct.d_modelPar_NSD_dX/modelStruct.modelPar_NSD/modelStruct.modelPar_NSD)))/(1.0+value_pow_1)/(1.0+value_pow_1)))*1.0e-4;
mu_rsd = (((44.9+((mu_max-44.9)/(1+value_pow_0)))-(29.0/(1.0+value_pow_1)))*1.0e-4);
}
}
d_rhorsd_dX = (-1*((1.60219e-19*modelStruct.modelPar_NSD)*d_mu_rsd_dX+1.60219e-19*modelStruct.d_modelPar_NSD_dX*mu_rsd)/((1.60219e-19*modelStruct.modelPar_NSD)*mu_rsd)/((1.60219e-19*modelStruct.modelPar_NSD)*mu_rsd));
rhorsd = (1/((1.60219e-19*modelStruct.modelPar_NSD)*mu_rsd));
}
thetarsp = ((55*3.14159265358979323846)/180);
{
double value_min_0 = std::min(modelStruct.modelPar_HEPI,static_cast<double>(0.0));
double value_max_1 = std::max((instanceStruct.instancePar_TFIN*(modelStruct.modelPar_HFIN+value_min_0)),static_cast<double>(1.0e-18));
double value_min_2 = std::min(value_max_1,Arsd);
double  deriv_min_0_d0 = ((modelStruct.modelPar_HEPI<=0.0)?1.0:0.0);
double  deriv_max_1_d0 = (((instanceStruct.instancePar_TFIN*(modelStruct.modelPar_HFIN+value_min_0))>=1.0e-18)?1.0:0.0);
double  deriv_min_2_d0 = ((value_max_1<=Arsd)?1.0:0.0);
double  deriv_min_2_d1 = ((value_max_1<=Arsd)?0.0:1.0);
d_afin_dX = ((deriv_min_2_d0*((deriv_max_1_d0*((instanceStruct.instancePar_TFIN*(modelStruct.d_modelPar_HFIN_dX+(deriv_min_0_d0*(modelStruct.d_modelPar_HEPI_dX)))+instanceStruct.d_instancePar_TFIN_dX*(modelStruct.modelPar_HFIN+value_min_0))))))+(deriv_min_2_d1*(d_Arsd_dX)));
afin = value_min_2;
}
{
double value_tan_0 = tan(thetarsp);
d_T1_dX = 0.0;
T1 = ((thetarsp>=(3.14159265358979323846/2))?0:((thetarsp<=((-3.14159265358979323846)/2))?0:(1.0/value_tan_0)));
}
{
double value_sqrt_0 = sqrt(static_cast<double>(3.14159265358979323846));
double value_sqrt_1 = sqrt(afin);
double value_sqrt_2 = sqrt(Arsd);
double value_sqrt_3 = sqrt((afin/(Arsd*Arsd)));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_sqrt_2_d0 = (0.5/value_sqrt_2);
double  deriv_sqrt_3_d0 = (0.5/value_sqrt_3);
d_Rsp_dX = (((rhorsd*T1)/(value_sqrt_0*instanceStruct.instancePar_NFIN))*(((-deriv_sqrt_1_d0*(d_afin_dX)/value_sqrt_1/value_sqrt_1)-(-2.0*deriv_sqrt_2_d0*(d_Arsd_dX)/value_sqrt_2/value_sqrt_2))+deriv_sqrt_3_d0*((((Arsd*Arsd)*d_afin_dX-afin*(Arsd*d_Arsd_dX+d_Arsd_dX*Arsd))/(Arsd*Arsd)/(Arsd*Arsd))))+(((value_sqrt_0*instanceStruct.instancePar_NFIN)*(rhorsd*d_T1_dX+d_rhorsd_dX*T1)-(rhorsd*T1)*value_sqrt_0*instanceStruct.d_instancePar_NFIN_dX)/(value_sqrt_0*instanceStruct.instancePar_NFIN)/(value_sqrt_0*instanceStruct.instancePar_NFIN))*(((1.0/value_sqrt_1)-(2.0/value_sqrt_2))+value_sqrt_3));
Rsp = (((rhorsd*T1)/(value_sqrt_0*instanceStruct.instancePar_NFIN))*(((1.0/value_sqrt_1)-(2.0/value_sqrt_2))+value_sqrt_3));
}
d_arsd_total_dX = ((Arsd*instanceStruct.d_instancePar_NFIN_dX+d_Arsd_dX*instanceStruct.instancePar_NFIN)+modelStruct.d_modelPar_ARSDEND_dX);
arsd_total = ((Arsd*instanceStruct.instancePar_NFIN)+modelStruct.modelPar_ARSDEND);
d_prsd_total_dX = ((Prsd*instanceStruct.d_instancePar_NFIN_dX+d_Prsd_dX*instanceStruct.instancePar_NFIN)+modelStruct.d_modelPar_PRSDEND_dX);
prsd_total = ((Prsd*instanceStruct.instancePar_NFIN)+modelStruct.modelPar_PRSDEND);
{
double value_sqrt_0 = sqrt(((modelStruct.modelPar_RHOC*arsd_total)/(rhorsd*prsd_total)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_lt_dX = deriv_sqrt_0_d0*((((rhorsd*prsd_total)*(modelStruct.modelPar_RHOC*d_arsd_total_dX+modelStruct.d_modelPar_RHOC_dX*arsd_total)-(modelStruct.modelPar_RHOC*arsd_total)*(rhorsd*d_prsd_total_dX+d_rhorsd_dX*prsd_total))/(rhorsd*prsd_total)/(rhorsd*prsd_total)));
lt = value_sqrt_0;
}
d_alpha_dX = ((lt*instanceStruct.d_instancePar_LRSD_dX-instanceStruct.instancePar_LRSD*d_lt_dX)/lt/lt);
alpha = (instanceStruct.instancePar_LRSD/lt);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((alpha+alpha));
d_T0_dX = evaluator_lexp_0.getDerivs((alpha+alpha),(d_alpha_dX+d_alpha_dX));
T0 = evaluator_lexp_0.getValues((alpha+alpha));
}
if ((modelStruct.modelPar_SDTERM==1))
{
d_eta_dX = ((modelStruct.modelPar_RHOC*(rhorsd*d_lt_dX+d_rhorsd_dX*lt)-(rhorsd*lt)*modelStruct.d_modelPar_RHOC_dX)/modelStruct.modelPar_RHOC/modelStruct.modelPar_RHOC);
eta = ((rhorsd*lt)/modelStruct.modelPar_RHOC);
d_T1_dX = (T0*d_eta_dX+d_T0_dX*(1.0+eta));
T1 = (T0*(1.0+eta));
d_T2_dX = (d_T1_dX-d_eta_dX);
T2 = ((T1+1.0)-eta);
d_T3_dX = (d_T1_dX+d_eta_dX);
T3 = ((T1-1.0)+eta);
}
else
{
d_T2_dX = d_T0_dX;
T2 = (T0+1.0);
d_T3_dX = d_T0_dX;
T3 = (T0-1.0);
}
d_RrsdTML_dX = (((arsd_total*T3)*((rhorsd*lt)*d_T2_dX+(rhorsd*d_lt_dX+d_rhorsd_dX*lt)*T2)-((rhorsd*lt)*T2)*(arsd_total*d_T3_dX+d_arsd_total_dX*T3))/(arsd_total*T3)/(arsd_total*T3));
RrsdTML = (((rhorsd*lt)*T2)/(arsd_total*T3));
if ((modelStruct.modelPar_HEPI<(-1.0e-10)))
{
d_Rrsdside_dX = (((((-modelStruct.modelPar_HEPI)*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_NFIN)*modelStruct.d_modelPar_RHOC_dX-modelStruct.modelPar_RHOC*(((-modelStruct.modelPar_HEPI)*instanceStruct.instancePar_TFIN)*instanceStruct.d_instancePar_NFIN_dX+((-modelStruct.modelPar_HEPI)*instanceStruct.d_instancePar_TFIN_dX+(-modelStruct.d_modelPar_HEPI_dX)*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_NFIN))/(((-modelStruct.modelPar_HEPI)*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_NFIN)/(((-modelStruct.modelPar_HEPI)*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_NFIN));
Rrsdside = (modelStruct.modelPar_RHOC/(((-modelStruct.modelPar_HEPI)*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_NFIN));
d_Rrsd_dX = ((((RrsdTML+Rsp)+Rrsdside)*((RrsdTML+Rsp)*d_Rrsdside_dX+(d_RrsdTML_dX+d_Rsp_dX)*Rrsdside)-((RrsdTML+Rsp)*Rrsdside)*((d_RrsdTML_dX+d_Rsp_dX)+d_Rrsdside_dX))/((RrsdTML+Rsp)+Rrsdside)/((RrsdTML+Rsp)+Rrsdside));
Rrsd = (((RrsdTML+Rsp)*Rrsdside)/((RrsdTML+Rsp)+Rrsdside));
}
else
{
d_Rrsd_dX = (d_RrsdTML_dX+d_Rsp_dX);
Rrsd = (RrsdTML+Rsp);
}
{
double value_max_0 = std::max(((((modelStruct.modelPar_RGEOA+(modelStruct.modelPar_RGEOB*instanceStruct.instancePar_TFIN))+(modelStruct.modelPar_RGEOC*instanceStruct.instancePar_FPITCH))+(modelStruct.modelPar_RGEOD*instanceStruct.instancePar_LRSD))+(modelStruct.modelPar_RGEOE*modelStruct.modelPar_HEPI)),static_cast<double>(0.0));
double  deriv_max_0_d0 = ((((((modelStruct.modelPar_RGEOA+(modelStruct.modelPar_RGEOB*instanceStruct.instancePar_TFIN))+(modelStruct.modelPar_RGEOC*instanceStruct.instancePar_FPITCH))+(modelStruct.modelPar_RGEOD*instanceStruct.instancePar_LRSD))+(modelStruct.modelPar_RGEOE*modelStruct.modelPar_HEPI))>=0.0)?1.0:0.0);
d_Rdsgeo_dX = ((Rrsd/modelStruct.modelPar_NF)*(deriv_max_0_d0*(((((modelStruct.d_modelPar_RGEOA_dX+(modelStruct.modelPar_RGEOB*instanceStruct.d_instancePar_TFIN_dX+modelStruct.d_modelPar_RGEOB_dX*instanceStruct.instancePar_TFIN))+(modelStruct.modelPar_RGEOC*instanceStruct.d_instancePar_FPITCH_dX+modelStruct.d_modelPar_RGEOC_dX*instanceStruct.instancePar_FPITCH))+(modelStruct.modelPar_RGEOD*instanceStruct.d_instancePar_LRSD_dX+modelStruct.d_modelPar_RGEOD_dX*instanceStruct.instancePar_LRSD))+(modelStruct.modelPar_RGEOE*modelStruct.d_modelPar_HEPI_dX+modelStruct.d_modelPar_RGEOE_dX*modelStruct.modelPar_HEPI))))+(d_Rrsd_dX/modelStruct.modelPar_NF)*value_max_0);
Rdsgeo = ((Rrsd/modelStruct.modelPar_NF)*value_max_0);
}
d_RSourceGeo_dX = d_Rdsgeo_dX;
RSourceGeo = Rdsgeo;
d_RDrainGeo_dX = d_Rdsgeo_dX;
RDrainGeo = Rdsgeo;
}
if ((RSourceGeo<=1.0e-3))
{
d_RSourceGeo_dX = 0.0;
RSourceGeo = 1.0e-3;
}
if ((RDrainGeo<=1.0e-3))
{
d_RDrainGeo_dX = 0.0;
RDrainGeo = 1.0e-3;
}
if ((modelStruct.modelPar_RDSMOD!=0))
{
if ((RSWMIN_i<=0))
{
d_RSWMIN_i_dX = 0.0;
RSWMIN_i = 0;
}
if ((RDWMIN_i<=0))
{
d_RDWMIN_i_dX = 0.0;
RDWMIN_i = 0;
}
if ((RSW_i<=0))
{
d_RSW_i_dX = 0.0;
RSW_i = 0;
}
if ((RDW_i<=0))
{
d_RDW_i_dX = 0.0;
RDW_i = 0;
}
}
else
{
if ((RDSWMIN_i<=0))
{
d_RDSWMIN_i_dX = 0.0;
RDSWMIN_i = 0;
}
if ((RDSW_i<=0))
{
d_RDSW_i_dX = 0.0;
RDSW_i = 0;
}
}
if ((modelStruct.modelPar_CGEOMOD!=1))
{
if (modelStruct.modelPar_given_CGSO)
{
d_CGSO_i_dX = modelStruct.d_modelPar_CGSO_dX;
CGSO_i = modelStruct.modelPar_CGSO;
}
else
{
if ((modelStruct.modelPar_given_DLC&&(modelStruct.modelPar_DLC>0)))
{
{
double value_max_0 = std::max(static_cast<double>(0.0),((modelStruct.modelPar_DLC*cox)-CGSL_i));
double  deriv_max_0_d1 = ((0.0>=((modelStruct.modelPar_DLC*cox)-CGSL_i))?0.0:1.0);
d_CGSO_i_dX = (deriv_max_0_d1*(((modelStruct.modelPar_DLC*d_cox_dX+modelStruct.d_modelPar_DLC_dX*cox)-d_CGSL_i_dX)));
CGSO_i = value_max_0;
}
}
else
{
d_CGSO_i_dX = ((0.3*instanceStruct.instancePar_TFIN)*d_cox_dX+0.3*instanceStruct.d_instancePar_TFIN_dX*cox);
CGSO_i = ((0.3*instanceStruct.instancePar_TFIN)*cox);
}
}
if (modelStruct.modelPar_given_CGDO)
{
d_CGDO_i_dX = modelStruct.d_modelPar_CGDO_dX;
CGDO_i = modelStruct.modelPar_CGDO;
}
else
{
if ((modelStruct.modelPar_given_DLC&&(modelStruct.modelPar_DLC>0)))
{
{
double value_max_0 = std::max(static_cast<double>(0.0),((modelStruct.modelPar_DLC*cox)-CGDL_i));
double  deriv_max_0_d1 = ((0.0>=((modelStruct.modelPar_DLC*cox)-CGDL_i))?0.0:1.0);
d_CGDO_i_dX = (deriv_max_0_d1*(((modelStruct.modelPar_DLC*d_cox_dX+modelStruct.d_modelPar_DLC_dX*cox)-d_CGDL_i_dX)));
CGDO_i = value_max_0;
}
}
else
{
d_CGDO_i_dX = ((0.3*instanceStruct.instancePar_TFIN)*d_cox_dX+0.3*instanceStruct.d_instancePar_TFIN_dX*cox);
CGDO_i = ((0.3*instanceStruct.instancePar_TFIN)*cox);
}
}
}
if ((modelStruct.modelPar_CGEOMOD==2))
{
d_Hg_dX = (modelStruct.d_modelPar_TGATE_dX+modelStruct.d_modelPar_TMASK_dX);
Hg = (modelStruct.modelPar_TGATE+modelStruct.modelPar_TMASK);
d_Trsd_dX = 0.5*(instanceStruct.d_instancePar_FPITCH_dX-instanceStruct.d_instancePar_TFIN_dX);
Trsd = (0.5*(instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN));
{
double value_max_0 = std::max((Trsd-modelStruct.modelPar_TOXP),static_cast<double>(0.0));
double  deriv_max_0_d0 = (((Trsd-modelStruct.modelPar_TOXP)>=0.0)?1.0:0.0);
d_Wg_dX = (deriv_max_0_d0*((d_Trsd_dX-modelStruct.d_modelPar_TOXP_dX)));
Wg = value_max_0;
}
{
double value_max_0 = std::max((modelStruct.modelPar_HEPI+modelStruct.modelPar_TSILI),static_cast<double>(0.0));
double  deriv_max_0_d0 = (((modelStruct.modelPar_HEPI+modelStruct.modelPar_TSILI)>=0.0)?1.0:0.0);
d_Hrsd_dX = (deriv_max_0_d0*((modelStruct.d_modelPar_HEPI_dX+modelStruct.d_modelPar_TSILI_dX)));
Hrsd = value_max_0;
}
if ((modelStruct.modelPar_TMASK>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((1.0e-7*modelStruct.modelPar_EPSRSP)/(3.9*modelStruct.modelPar_LSP)));
d_T0_dX = 3.467e-11*evaluator_lln_0.getDerivs(((1.0e-7*modelStruct.modelPar_EPSRSP)/(3.9*modelStruct.modelPar_LSP)),(((3.9*modelStruct.modelPar_LSP)*1.0e-7*modelStruct.d_modelPar_EPSRSP_dX-(1.0e-7*modelStruct.modelPar_EPSRSP)*3.9*modelStruct.d_modelPar_LSP_dX)/(3.9*modelStruct.modelPar_LSP)/(3.9*modelStruct.modelPar_LSP)));
T0 = (3.467e-11*evaluator_lln_0.getValues(((1.0e-7*modelStruct.modelPar_EPSRSP)/(3.9*modelStruct.modelPar_LSP))));
}
d_T1_dX = ((modelStruct.modelPar_LSP*((0.942*Hrsd)*d_epssp_dX+0.942*d_Hrsd_dX*epssp)-((0.942*Hrsd)*epssp)*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP);
T1 = (((0.942*Hrsd)*epssp)/modelStruct.modelPar_LSP);
d_Cgg_top_dX = ((T0+T1)*(instanceStruct.d_instancePar_TFIN_dX+((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*modelStruct.d_modelPar_CRATIO_dX+(instanceStruct.d_instancePar_FPITCH_dX-instanceStruct.d_instancePar_TFIN_dX)*modelStruct.modelPar_CRATIO))+(d_T0_dX+d_T1_dX)*(instanceStruct.instancePar_TFIN+((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*modelStruct.modelPar_CRATIO)));
Cgg_top = ((T0+T1)*(instanceStruct.instancePar_TFIN+((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*modelStruct.modelPar_CRATIO)));
}
else
{
//Begin block cfr_top_trigate
{
//Block-local variables for block cfr_top_trigate
double Hr=0.0;
double d_Hr_dX=0.0;
double Lr=0.0;
double Hgdelta=0.0;
double d_Hgdelta_dX=0.0;
double Lmax=0.0;
double d_Lmax_dX=0.0;
double y=0.0;
double d_y_dX=0.0;
double x=0.0;
double d_x_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_top_trigate
double CcgSat=0.0;
double d_CcgSat_dX=0.0;
double Cnon=0.0;
double TT1=0.0;
double d_TT1_dX=0.0;
double Ccg1=0.0;
double d_Ccg1_dX=0.0;
double r1cf=0.0;
double d_r1cf_dX=0.0;
double Rcf=0.0;
double d_Rcf_dX=0.0;
double Ccg2=0.0;
double d_Ccg2_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_top_trigate
double Ccg=0.0;
double d_Ccg_dX=0.0;
double C1=0.0;
double d_C1_dX=0.0;
double C2=0.0;
double d_C2_dX=0.0;
double C3=0.0;
double d_C3_dX=0.0;
double Cfglog=0.0;
double d_Cfglog_dX=0.0;
double dcf=0.0;
double d_dcf_dX=0.0;
double TT0=0.0;
double d_TT0_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_top_trigate
double TT2=0.0;
double d_TT2_dX=0.0;
double Cfgsat=0.0;
double d_Cfgsat_dX=0.0;
double delta=0.0;
double Cfg=0.0;
double d_Cfg_dX=0.0;
//End of Block-local variables
d_Hr_dX = ((Hrsd*0.2*(d_Hg_dX+modelStruct.d_modelPar_TOXP_dX)-(0.2*(Hg+modelStruct.modelPar_TOXP))*d_Hrsd_dX)/Hrsd/Hrsd);
Hr = (2.3+((0.2*(Hg+modelStruct.modelPar_TOXP))/Hrsd));
Lr = 1.05;
{
double value_fabs_0 = fabs(((Hg+modelStruct.modelPar_TOXP)-Hrsd));
double  deriv_fabs_0_d0 = (((((Hg+modelStruct.modelPar_TOXP)-Hrsd))>=0)?(+1.0):(-1.0));
d_Hgdelta_dX = deriv_fabs_0_d0*(((d_Hg_dX+modelStruct.d_modelPar_TOXP_dX)-d_Hrsd_dX));
Hgdelta = value_fabs_0;
}
d_Lmax_dX = modelStruct.d_modelPar_LSP_dX*Lr;
Lmax = (modelStruct.modelPar_LSP*Lr);
{
double value_min_0 = std::min(Hrsd,(Hg+modelStruct.modelPar_TOXP));
double  deriv_min_0_d0 = ((Hrsd<=(Hg+modelStruct.modelPar_TOXP))?1.0:0.0);
double  deriv_min_0_d1 = ((Hrsd<=(Hg+modelStruct.modelPar_TOXP))?0.0:1.0);
d_y_dX = ((deriv_min_0_d0*(d_Hrsd_dX))+(deriv_min_0_d1*((d_Hg_dX+modelStruct.d_modelPar_TOXP_dX))));
y = value_min_0;
}
d_x_dX = (((Hr+1.0)*modelStruct.d_modelPar_LSP_dX-modelStruct.modelPar_LSP*d_Hr_dX)/(Hr+1.0)/(Hr+1.0));
x = (modelStruct.modelPar_LSP/(Hr+1.0));
Cnon = 1.7e12;
d_CcgSat_dX = ((modelStruct.modelPar_LSP*(epssp*(d_y_dX-d_x_dX)+d_epssp_dX*(y-x))-(epssp*(y-x))*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP);
CcgSat = ((epssp*(y-x))/modelStruct.modelPar_LSP);
d_TT1_dX = Cnon*d_CcgSat_dX;
TT1 = (Cnon*CcgSat);
if ((TT1>80.0))
{
d_Ccg1_dX = d_CcgSat_dX;
Ccg1 = CcgSat;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(TT1);
double value_log_1 = log((1.0+evaluator_lexp_0.getValues(TT1)));
double  deriv_log_1_d0 = (1.0/(1.0+evaluator_lexp_0.getValues(TT1)));
d_Ccg1_dX = (1.0/Cnon)*deriv_log_1_d0*(evaluator_lexp_0.getDerivs(TT1,d_TT1_dX));
Ccg1 = ((1.0/Cnon)*value_log_1);
}
}
{
double value_min_0 = std::min((Hrsd/(Hg+modelStruct.modelPar_TOXP)),((Hg+modelStruct.modelPar_TOXP)/Hrsd));
double  deriv_min_0_d0 = (((Hrsd/(Hg+modelStruct.modelPar_TOXP))<=((Hg+modelStruct.modelPar_TOXP)/Hrsd))?1.0:0.0);
double  deriv_min_0_d1 = (((Hrsd/(Hg+modelStruct.modelPar_TOXP))<=((Hg+modelStruct.modelPar_TOXP)/Hrsd))?0.0:1.0);
d_r1cf_dX = 0.5*((deriv_min_0_d0*((((Hg+modelStruct.modelPar_TOXP)*d_Hrsd_dX-Hrsd*(d_Hg_dX+modelStruct.d_modelPar_TOXP_dX))/(Hg+modelStruct.modelPar_TOXP)/(Hg+modelStruct.modelPar_TOXP))))+(deriv_min_0_d1*(((Hrsd*(d_Hg_dX+modelStruct.d_modelPar_TOXP_dX)-(Hg+modelStruct.modelPar_TOXP)*d_Hrsd_dX)/Hrsd/Hrsd))));
r1cf = (0.5*value_min_0);
}
d_Rcf_dX = (Hgdelta*d_r1cf_dX+d_Hgdelta_dX*r1cf);
Rcf = (Hgdelta*r1cf);
{
double value_log_0 = log(((modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelStruct.modelPar_LSP));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelStruct.modelPar_LSP));
d_Ccg2_dX = (((epssp*2)/3.14159265358979323846)*deriv_log_0_d0*(((modelStruct.modelPar_LSP*(modelStruct.d_modelPar_LSP_dX+(0.5*3.14159265358979323846)*d_Rcf_dX)-(modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP))+(d_epssp_dX*2/3.14159265358979323846)*value_log_0);
Ccg2 = (((epssp*2)/3.14159265358979323846)*value_log_0);
}
d_Ccg_dX = (instanceStruct.instancePar_TFIN*(d_Ccg1_dX+d_Ccg2_dX)+instanceStruct.d_instancePar_TFIN_dX*(Ccg1+Ccg2));
Ccg = (instanceStruct.instancePar_TFIN*(Ccg1+Ccg2));
d_x_dX = ((Hg*d_Lmax_dX-Lmax*d_Hg_dX)/Hg/Hg);
x = (Lmax/Hg);
{
double value_sqrt_0 = sqrt((2.0*(x+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_C1_dX = (-4.0*deriv_sqrt_0_d0*(2.0*d_x_dX)*3.14159265358979323846/(value_sqrt_0*3.14159265358979323846)/(value_sqrt_0*3.14159265358979323846));
C1 = (4.0/(value_sqrt_0*3.14159265358979323846));
}
{
double value_sqrt_0 = sqrt((((modelStruct.modelPar_TOXP*modelStruct.modelPar_TOXP)+((2.0*Hg)*modelStruct.modelPar_TOXP))+((Hg*Hg)*(x+1))));
double value_sqrt_1 = sqrt((x+1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_C2_dX = ((((value_sqrt_0*deriv_sqrt_1_d0*(d_x_dX)+deriv_sqrt_0_d0*((((modelStruct.modelPar_TOXP*modelStruct.d_modelPar_TOXP_dX+modelStruct.d_modelPar_TOXP_dX*modelStruct.modelPar_TOXP)+((2.0*Hg)*modelStruct.d_modelPar_TOXP_dX+2.0*d_Hg_dX*modelStruct.modelPar_TOXP))+((Hg*Hg)*d_x_dX+(Hg*d_Hg_dX+d_Hg_dX*Hg)*(x+1))))*value_sqrt_1)+modelStruct.d_modelPar_TOXP_dX)+(Hg*d_x_dX+d_Hg_dX*x))+d_Hg_dX);
C2 = ((((value_sqrt_0*value_sqrt_1)+modelStruct.modelPar_TOXP)+(Hg*x))+Hg);
}
{
double value_sqrt_0 = sqrt(((x+1)*(x+4)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_C3_dX = ((modelStruct.modelPar_TOXP*deriv_sqrt_0_d0*(((x+1)*d_x_dX+d_x_dX*(x+4)))+modelStruct.d_modelPar_TOXP_dX*value_sqrt_0)+(modelStruct.modelPar_TOXP*d_x_dX+modelStruct.d_modelPar_TOXP_dX*(x+2)));
C3 = ((modelStruct.modelPar_TOXP*value_sqrt_0)+(modelStruct.modelPar_TOXP*(x+2)));
}
{
double value_log_0 = log((C2/C3));
double  deriv_log_0_d0 = (1.0/(C2/C3));
d_Cfglog_dX = (epssp*(C1*deriv_log_0_d0*(((C3*d_C2_dX-C2*d_C3_dX)/C3/C3))+d_C1_dX*value_log_0)+d_epssp_dX*((C1*value_log_0)+12.27));
Cfglog = (epssp*((C1*value_log_0)+12.27));
}
d_dcf_dX = d_Hr_dX*Lr;
dcf = (Hr*Lr);
{
double value_sqrt_0 = sqrt(((dcf*dcf)+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_TT0_dX = deriv_sqrt_0_d0*((dcf*d_dcf_dX+d_dcf_dX*dcf));
TT0 = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((dcf*dcf)+1)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_TT1_dX = (((deriv_sqrt_0_d0*((((dcf*dcf)+1)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)+(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.d_modelPar_TOXP_dX+((2*dcf)*d_Lmax_dX+2*d_dcf_dX*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*d_Lmax_dX+(((dcf*dcf)+1)*d_Lmax_dX+(dcf*d_dcf_dX+d_dcf_dX*dcf)*Lmax)*Lmax))+(dcf*d_dcf_dX+d_dcf_dX*dcf)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP))+((dcf*dcf)*d_Lmax_dX+(dcf*d_dcf_dX+d_dcf_dX*dcf)*Lmax))+d_Lmax_dX);
TT1 = (((value_sqrt_0+(dcf*modelStruct.modelPar_TOXP))+((dcf*dcf)*Lmax))+Lmax);
}
d_TT2_dX = ((TT0+1.0)*(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)+d_TT0_dX*(dcf*modelStruct.modelPar_TOXP));
TT2 = ((TT0+1.0)*(dcf*modelStruct.modelPar_TOXP));
{
double value_sqrt_0 = sqrt(static_cast<double>(2.0));
double value_log_1 = log((TT1/TT2));
double  deriv_log_1_d0 = (1.0/(TT1/TT2));
d_Cfgsat_dX = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)/TT0)*deriv_log_1_d0*(((TT2*d_TT1_dX-TT1*d_TT2_dX)/TT2/TT2))+((TT0*(((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*d_dcf_dX+(2.0*d_epssp_dX*value_sqrt_0/3.14159265358979323846)*0.85*dcf)-(((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)*d_TT0_dX)/TT0/TT0)*value_log_1);
Cfgsat = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)/TT0)*value_log_1);
}
delta = 1.2e-12;
d_TT1_dX = (d_Cfgsat_dX-d_Cfglog_dX);
TT1 = ((Cfgsat-Cfglog)-delta);
{
double value_sqrt_0 = sqrt(((TT1*TT1)+((4*delta)*Cfgsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Cfg_dX = (instanceStruct.instancePar_TFIN*(d_Cfgsat_dX-0.5*(d_TT1_dX+deriv_sqrt_0_d0*(((TT1*d_TT1_dX+d_TT1_dX*TT1)+(4*delta)*d_Cfgsat_dX))))+instanceStruct.d_instancePar_TFIN_dX*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
Cfg = (instanceStruct.instancePar_TFIN*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
}
d_Cgg_top_dX = (d_Ccg_dX+d_Cfg_dX);
Cgg_top = (Ccg+Cfg);
}
// End block cfr_top_trigate
}
if ((modelStruct.modelPar_TMASK>0))
{
//Begin block cfr_side_dblgate
{
//Block-local variables for block cfr_side_dblgate
double Hr=0.0;
double d_Hr_dX=0.0;
double Lr=0.0;
double Hgdelta=0.0;
double d_Hgdelta_dX=0.0;
double Lmax=0.0;
double d_Lmax_dX=0.0;
double y=0.0;
double d_y_dX=0.0;
double x=0.0;
double d_x_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_dblgate
double CcgSat=0.0;
double d_CcgSat_dX=0.0;
double Cnon=0.0;
double TT1=0.0;
double d_TT1_dX=0.0;
double Ccg1=0.0;
double d_Ccg1_dX=0.0;
double r1cf=0.0;
double d_r1cf_dX=0.0;
double Rcf=0.0;
double d_Rcf_dX=0.0;
double Ccg2=0.0;
double d_Ccg2_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_dblgate
double Ccg=0.0;
double d_Ccg_dX=0.0;
double C1=0.0;
double d_C1_dX=0.0;
double C2=0.0;
double d_C2_dX=0.0;
double C3=0.0;
double d_C3_dX=0.0;
double Cfglog=0.0;
double d_Cfglog_dX=0.0;
double dcf=0.0;
double d_dcf_dX=0.0;
double TT0=0.0;
double d_TT0_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_dblgate
double TT2=0.0;
double d_TT2_dX=0.0;
double Cfgsat=0.0;
double d_Cfgsat_dX=0.0;
double delta=0.0;
double Cfg=0.0;
double d_Cfg_dX=0.0;
//End of Block-local variables
d_Hr_dX = ((Trsd*0.2*(d_Wg_dX+modelStruct.d_modelPar_TOXP_dX)-(0.2*(Wg+modelStruct.modelPar_TOXP))*d_Trsd_dX)/Trsd/Trsd);
Hr = (2.3+((0.2*(Wg+modelStruct.modelPar_TOXP))/Trsd));
Lr = 1.05;
{
double value_fabs_0 = fabs(((Wg+modelStruct.modelPar_TOXP)-Trsd));
double  deriv_fabs_0_d0 = (((((Wg+modelStruct.modelPar_TOXP)-Trsd))>=0)?(+1.0):(-1.0));
d_Hgdelta_dX = deriv_fabs_0_d0*(((d_Wg_dX+modelStruct.d_modelPar_TOXP_dX)-d_Trsd_dX));
Hgdelta = value_fabs_0;
}
d_Lmax_dX = modelStruct.d_modelPar_LSP_dX*Lr;
Lmax = (modelStruct.modelPar_LSP*Lr);
{
double value_min_0 = std::min(Trsd,(Wg+modelStruct.modelPar_TOXP));
double  deriv_min_0_d0 = ((Trsd<=(Wg+modelStruct.modelPar_TOXP))?1.0:0.0);
double  deriv_min_0_d1 = ((Trsd<=(Wg+modelStruct.modelPar_TOXP))?0.0:1.0);
d_y_dX = ((deriv_min_0_d0*(d_Trsd_dX))+(deriv_min_0_d1*((d_Wg_dX+modelStruct.d_modelPar_TOXP_dX))));
y = value_min_0;
}
d_x_dX = (((Hr+1.0)*modelStruct.d_modelPar_LSP_dX-modelStruct.modelPar_LSP*d_Hr_dX)/(Hr+1.0)/(Hr+1.0));
x = (modelStruct.modelPar_LSP/(Hr+1.0));
Cnon = 1.7e12;
d_CcgSat_dX = ((modelStruct.modelPar_LSP*(epssp*(d_y_dX-d_x_dX)+d_epssp_dX*(y-x))-(epssp*(y-x))*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP);
CcgSat = ((epssp*(y-x))/modelStruct.modelPar_LSP);
d_TT1_dX = Cnon*d_CcgSat_dX;
TT1 = (Cnon*CcgSat);
if ((TT1>80.0))
{
d_Ccg1_dX = d_CcgSat_dX;
Ccg1 = CcgSat;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(TT1);
double value_log_1 = log((1.0+evaluator_lexp_0.getValues(TT1)));
double  deriv_log_1_d0 = (1.0/(1.0+evaluator_lexp_0.getValues(TT1)));
d_Ccg1_dX = (1.0/Cnon)*deriv_log_1_d0*(evaluator_lexp_0.getDerivs(TT1,d_TT1_dX));
Ccg1 = ((1.0/Cnon)*value_log_1);
}
}
{
double value_min_0 = std::min((Trsd/(Wg+modelStruct.modelPar_TOXP)),((Wg+modelStruct.modelPar_TOXP)/Trsd));
double  deriv_min_0_d0 = (((Trsd/(Wg+modelStruct.modelPar_TOXP))<=((Wg+modelStruct.modelPar_TOXP)/Trsd))?1.0:0.0);
double  deriv_min_0_d1 = (((Trsd/(Wg+modelStruct.modelPar_TOXP))<=((Wg+modelStruct.modelPar_TOXP)/Trsd))?0.0:1.0);
d_r1cf_dX = 0.5*((deriv_min_0_d0*((((Wg+modelStruct.modelPar_TOXP)*d_Trsd_dX-Trsd*(d_Wg_dX+modelStruct.d_modelPar_TOXP_dX))/(Wg+modelStruct.modelPar_TOXP)/(Wg+modelStruct.modelPar_TOXP))))+(deriv_min_0_d1*(((Trsd*(d_Wg_dX+modelStruct.d_modelPar_TOXP_dX)-(Wg+modelStruct.modelPar_TOXP)*d_Trsd_dX)/Trsd/Trsd))));
r1cf = (0.5*value_min_0);
}
d_Rcf_dX = (Hgdelta*d_r1cf_dX+d_Hgdelta_dX*r1cf);
Rcf = (Hgdelta*r1cf);
{
double value_log_0 = log(((modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelStruct.modelPar_LSP));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelStruct.modelPar_LSP));
d_Ccg2_dX = (((epssp*2)/3.14159265358979323846)*deriv_log_0_d0*(((modelStruct.modelPar_LSP*(modelStruct.d_modelPar_LSP_dX+(0.5*3.14159265358979323846)*d_Rcf_dX)-(modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP))+(d_epssp_dX*2/3.14159265358979323846)*value_log_0);
Ccg2 = (((epssp*2)/3.14159265358979323846)*value_log_0);
}
d_Ccg_dX = (modelStruct.modelPar_HFIN*(d_Ccg1_dX+d_Ccg2_dX)+modelStruct.d_modelPar_HFIN_dX*(Ccg1+Ccg2));
Ccg = (modelStruct.modelPar_HFIN*(Ccg1+Ccg2));
d_x_dX = ((Wg*d_Lmax_dX-Lmax*d_Wg_dX)/Wg/Wg);
x = (Lmax/Wg);
{
double value_sqrt_0 = sqrt((2.0*(x+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_C1_dX = (-4.0*deriv_sqrt_0_d0*(2.0*d_x_dX)*3.14159265358979323846/(value_sqrt_0*3.14159265358979323846)/(value_sqrt_0*3.14159265358979323846));
C1 = (4.0/(value_sqrt_0*3.14159265358979323846));
}
{
double value_sqrt_0 = sqrt((((modelStruct.modelPar_TOXP*modelStruct.modelPar_TOXP)+((2.0*Wg)*modelStruct.modelPar_TOXP))+((Wg*Wg)*(x+1))));
double value_sqrt_1 = sqrt((x+1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_C2_dX = ((((value_sqrt_0*deriv_sqrt_1_d0*(d_x_dX)+deriv_sqrt_0_d0*((((modelStruct.modelPar_TOXP*modelStruct.d_modelPar_TOXP_dX+modelStruct.d_modelPar_TOXP_dX*modelStruct.modelPar_TOXP)+((2.0*Wg)*modelStruct.d_modelPar_TOXP_dX+2.0*d_Wg_dX*modelStruct.modelPar_TOXP))+((Wg*Wg)*d_x_dX+(Wg*d_Wg_dX+d_Wg_dX*Wg)*(x+1))))*value_sqrt_1)+modelStruct.d_modelPar_TOXP_dX)+(Wg*d_x_dX+d_Wg_dX*x))+d_Wg_dX);
C2 = ((((value_sqrt_0*value_sqrt_1)+modelStruct.modelPar_TOXP)+(Wg*x))+Wg);
}
{
double value_sqrt_0 = sqrt(((x+1)*(x+4)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_C3_dX = ((modelStruct.modelPar_TOXP*deriv_sqrt_0_d0*(((x+1)*d_x_dX+d_x_dX*(x+4)))+modelStruct.d_modelPar_TOXP_dX*value_sqrt_0)+(modelStruct.modelPar_TOXP*d_x_dX+modelStruct.d_modelPar_TOXP_dX*(x+2)));
C3 = ((modelStruct.modelPar_TOXP*value_sqrt_0)+(modelStruct.modelPar_TOXP*(x+2)));
}
{
double value_log_0 = log((C2/C3));
double  deriv_log_0_d0 = (1.0/(C2/C3));
d_Cfglog_dX = (epssp*(C1*deriv_log_0_d0*(((C3*d_C2_dX-C2*d_C3_dX)/C3/C3))+d_C1_dX*value_log_0)+d_epssp_dX*((C1*value_log_0)+12.27));
Cfglog = (epssp*((C1*value_log_0)+12.27));
}
d_dcf_dX = d_Hr_dX*Lr;
dcf = (Hr*Lr);
{
double value_sqrt_0 = sqrt(((dcf*dcf)+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_TT0_dX = deriv_sqrt_0_d0*((dcf*d_dcf_dX+d_dcf_dX*dcf));
TT0 = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((dcf*dcf)+1)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_TT1_dX = (((deriv_sqrt_0_d0*((((dcf*dcf)+1)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)+(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.d_modelPar_TOXP_dX+((2*dcf)*d_Lmax_dX+2*d_dcf_dX*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*d_Lmax_dX+(((dcf*dcf)+1)*d_Lmax_dX+(dcf*d_dcf_dX+d_dcf_dX*dcf)*Lmax)*Lmax))+(dcf*d_dcf_dX+d_dcf_dX*dcf)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP))+((dcf*dcf)*d_Lmax_dX+(dcf*d_dcf_dX+d_dcf_dX*dcf)*Lmax))+d_Lmax_dX);
TT1 = (((value_sqrt_0+(dcf*modelStruct.modelPar_TOXP))+((dcf*dcf)*Lmax))+Lmax);
}
d_TT2_dX = ((TT0+1.0)*(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)+d_TT0_dX*(dcf*modelStruct.modelPar_TOXP));
TT2 = ((TT0+1.0)*(dcf*modelStruct.modelPar_TOXP));
{
double value_sqrt_0 = sqrt(static_cast<double>(2.0));
double value_log_1 = log((TT1/TT2));
double  deriv_log_1_d0 = (1.0/(TT1/TT2));
d_Cfgsat_dX = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.70)*dcf)/TT0)*deriv_log_1_d0*(((TT2*d_TT1_dX-TT1*d_TT2_dX)/TT2/TT2))+((TT0*(((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.70)*d_dcf_dX+(2.0*d_epssp_dX*value_sqrt_0/3.14159265358979323846)*0.70*dcf)-(((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.70)*dcf)*d_TT0_dX)/TT0/TT0)*value_log_1);
Cfgsat = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.70)*dcf)/TT0)*value_log_1);
}
delta = 1.2e-12;
d_TT1_dX = (d_Cfgsat_dX-d_Cfglog_dX);
TT1 = ((Cfgsat-Cfglog)-delta);
{
double value_sqrt_0 = sqrt(((TT1*TT1)+((4*delta)*Cfgsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Cfg_dX = (modelStruct.modelPar_HFIN*(d_Cfgsat_dX-0.5*(d_TT1_dX+deriv_sqrt_0_d0*(((TT1*d_TT1_dX+d_TT1_dX*TT1)+(4*delta)*d_Cfgsat_dX))))+modelStruct.d_modelPar_HFIN_dX*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
Cfg = (modelStruct.modelPar_HFIN*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
}
d_Cgg_side_dX = (d_Ccg_dX+d_Cfg_dX);
Cgg_side = (Ccg+Cfg);
}
// End block cfr_side_dblgate
}
else
{
//Begin block cfr_side_trigate
{
//Block-local variables for block cfr_side_trigate
double Hr=0.0;
double d_Hr_dX=0.0;
double Lr=0.0;
double Hgdelta=0.0;
double d_Hgdelta_dX=0.0;
double Lmax=0.0;
double d_Lmax_dX=0.0;
double y=0.0;
double d_y_dX=0.0;
double x=0.0;
double d_x_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_trigate
double CcgSat=0.0;
double d_CcgSat_dX=0.0;
double Cnon=0.0;
double TT1=0.0;
double d_TT1_dX=0.0;
double Ccg1=0.0;
double d_Ccg1_dX=0.0;
double r1cf=0.0;
double d_r1cf_dX=0.0;
double Rcf=0.0;
double d_Rcf_dX=0.0;
double Ccg2=0.0;
double d_Ccg2_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_trigate
double Ccg=0.0;
double d_Ccg_dX=0.0;
double C1=0.0;
double d_C1_dX=0.0;
double C2=0.0;
double d_C2_dX=0.0;
double C3=0.0;
double d_C3_dX=0.0;
double Cfglog=0.0;
double d_Cfglog_dX=0.0;
double dcf=0.0;
double d_dcf_dX=0.0;
double TT0=0.0;
double d_TT0_dX=0.0;
//End of Block-local variables
//Block-local variables for block cfr_side_trigate
double TT2=0.0;
double d_TT2_dX=0.0;
double Cfgsat=0.0;
double d_Cfgsat_dX=0.0;
double delta=0.0;
double Cfg=0.0;
double d_Cfg_dX=0.0;
//End of Block-local variables
d_Hr_dX = ((Trsd*0.2*(d_Wg_dX+modelStruct.d_modelPar_TOXP_dX)-(0.2*(Wg+modelStruct.modelPar_TOXP))*d_Trsd_dX)/Trsd/Trsd);
Hr = (2.3+((0.2*(Wg+modelStruct.modelPar_TOXP))/Trsd));
Lr = 1.05;
{
double value_fabs_0 = fabs(((Wg+modelStruct.modelPar_TOXP)-Trsd));
double  deriv_fabs_0_d0 = (((((Wg+modelStruct.modelPar_TOXP)-Trsd))>=0)?(+1.0):(-1.0));
d_Hgdelta_dX = deriv_fabs_0_d0*(((d_Wg_dX+modelStruct.d_modelPar_TOXP_dX)-d_Trsd_dX));
Hgdelta = value_fabs_0;
}
d_Lmax_dX = modelStruct.d_modelPar_LSP_dX*Lr;
Lmax = (modelStruct.modelPar_LSP*Lr);
{
double value_min_0 = std::min(Trsd,(Wg+modelStruct.modelPar_TOXP));
double  deriv_min_0_d0 = ((Trsd<=(Wg+modelStruct.modelPar_TOXP))?1.0:0.0);
double  deriv_min_0_d1 = ((Trsd<=(Wg+modelStruct.modelPar_TOXP))?0.0:1.0);
d_y_dX = ((deriv_min_0_d0*(d_Trsd_dX))+(deriv_min_0_d1*((d_Wg_dX+modelStruct.d_modelPar_TOXP_dX))));
y = value_min_0;
}
d_x_dX = (((Hr+1.0)*modelStruct.d_modelPar_LSP_dX-modelStruct.modelPar_LSP*d_Hr_dX)/(Hr+1.0)/(Hr+1.0));
x = (modelStruct.modelPar_LSP/(Hr+1.0));
Cnon = 1.7e12;
d_CcgSat_dX = ((modelStruct.modelPar_LSP*(epssp*(d_y_dX-d_x_dX)+d_epssp_dX*(y-x))-(epssp*(y-x))*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP);
CcgSat = ((epssp*(y-x))/modelStruct.modelPar_LSP);
d_TT1_dX = Cnon*d_CcgSat_dX;
TT1 = (Cnon*CcgSat);
if ((TT1>80.0))
{
d_Ccg1_dX = d_CcgSat_dX;
Ccg1 = CcgSat;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(TT1);
double value_log_1 = log((1.0+evaluator_lexp_0.getValues(TT1)));
double  deriv_log_1_d0 = (1.0/(1.0+evaluator_lexp_0.getValues(TT1)));
d_Ccg1_dX = (1.0/Cnon)*deriv_log_1_d0*(evaluator_lexp_0.getDerivs(TT1,d_TT1_dX));
Ccg1 = ((1.0/Cnon)*value_log_1);
}
}
{
double value_min_0 = std::min((Trsd/(Wg+modelStruct.modelPar_TOXP)),((Wg+modelStruct.modelPar_TOXP)/Trsd));
double  deriv_min_0_d0 = (((Trsd/(Wg+modelStruct.modelPar_TOXP))<=((Wg+modelStruct.modelPar_TOXP)/Trsd))?1.0:0.0);
double  deriv_min_0_d1 = (((Trsd/(Wg+modelStruct.modelPar_TOXP))<=((Wg+modelStruct.modelPar_TOXP)/Trsd))?0.0:1.0);
d_r1cf_dX = 0.5*((deriv_min_0_d0*((((Wg+modelStruct.modelPar_TOXP)*d_Trsd_dX-Trsd*(d_Wg_dX+modelStruct.d_modelPar_TOXP_dX))/(Wg+modelStruct.modelPar_TOXP)/(Wg+modelStruct.modelPar_TOXP))))+(deriv_min_0_d1*(((Trsd*(d_Wg_dX+modelStruct.d_modelPar_TOXP_dX)-(Wg+modelStruct.modelPar_TOXP)*d_Trsd_dX)/Trsd/Trsd))));
r1cf = (0.5*value_min_0);
}
d_Rcf_dX = (Hgdelta*d_r1cf_dX+d_Hgdelta_dX*r1cf);
Rcf = (Hgdelta*r1cf);
{
double value_log_0 = log(((modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelStruct.modelPar_LSP));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))/modelStruct.modelPar_LSP));
d_Ccg2_dX = (((epssp*2)/3.14159265358979323846)*deriv_log_0_d0*(((modelStruct.modelPar_LSP*(modelStruct.d_modelPar_LSP_dX+(0.5*3.14159265358979323846)*d_Rcf_dX)-(modelStruct.modelPar_LSP+((0.5*3.14159265358979323846)*Rcf))*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP))+(d_epssp_dX*2/3.14159265358979323846)*value_log_0);
Ccg2 = (((epssp*2)/3.14159265358979323846)*value_log_0);
}
d_Ccg_dX = (modelStruct.modelPar_HFIN*(d_Ccg1_dX+d_Ccg2_dX)+modelStruct.d_modelPar_HFIN_dX*(Ccg1+Ccg2));
Ccg = (modelStruct.modelPar_HFIN*(Ccg1+Ccg2));
d_x_dX = ((Wg*d_Lmax_dX-Lmax*d_Wg_dX)/Wg/Wg);
x = (Lmax/Wg);
{
double value_sqrt_0 = sqrt((2.0*(x+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_C1_dX = (-4.0*deriv_sqrt_0_d0*(2.0*d_x_dX)*3.14159265358979323846/(value_sqrt_0*3.14159265358979323846)/(value_sqrt_0*3.14159265358979323846));
C1 = (4.0/(value_sqrt_0*3.14159265358979323846));
}
{
double value_sqrt_0 = sqrt((((modelStruct.modelPar_TOXP*modelStruct.modelPar_TOXP)+((2.0*Wg)*modelStruct.modelPar_TOXP))+((Wg*Wg)*(x+1))));
double value_sqrt_1 = sqrt((x+1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_C2_dX = ((((value_sqrt_0*deriv_sqrt_1_d0*(d_x_dX)+deriv_sqrt_0_d0*((((modelStruct.modelPar_TOXP*modelStruct.d_modelPar_TOXP_dX+modelStruct.d_modelPar_TOXP_dX*modelStruct.modelPar_TOXP)+((2.0*Wg)*modelStruct.d_modelPar_TOXP_dX+2.0*d_Wg_dX*modelStruct.modelPar_TOXP))+((Wg*Wg)*d_x_dX+(Wg*d_Wg_dX+d_Wg_dX*Wg)*(x+1))))*value_sqrt_1)+modelStruct.d_modelPar_TOXP_dX)+(Wg*d_x_dX+d_Wg_dX*x))+d_Wg_dX);
C2 = ((((value_sqrt_0*value_sqrt_1)+modelStruct.modelPar_TOXP)+(Wg*x))+Wg);
}
{
double value_sqrt_0 = sqrt(((x+1)*(x+4)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_C3_dX = ((modelStruct.modelPar_TOXP*deriv_sqrt_0_d0*(((x+1)*d_x_dX+d_x_dX*(x+4)))+modelStruct.d_modelPar_TOXP_dX*value_sqrt_0)+(modelStruct.modelPar_TOXP*d_x_dX+modelStruct.d_modelPar_TOXP_dX*(x+2)));
C3 = ((modelStruct.modelPar_TOXP*value_sqrt_0)+(modelStruct.modelPar_TOXP*(x+2)));
}
{
double value_log_0 = log((C2/C3));
double  deriv_log_0_d0 = (1.0/(C2/C3));
d_Cfglog_dX = (epssp*(C1*deriv_log_0_d0*(((C3*d_C2_dX-C2*d_C3_dX)/C3/C3))+d_C1_dX*value_log_0)+d_epssp_dX*((C1*value_log_0)+12.27));
Cfglog = (epssp*((C1*value_log_0)+12.27));
}
d_dcf_dX = d_Hr_dX*Lr;
dcf = (Hr*Lr);
{
double value_sqrt_0 = sqrt(((dcf*dcf)+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_TT0_dX = deriv_sqrt_0_d0*((dcf*d_dcf_dX+d_dcf_dX*dcf));
TT0 = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((dcf*dcf)+1)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_TT1_dX = (((deriv_sqrt_0_d0*((((dcf*dcf)+1)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)+(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.d_modelPar_TOXP_dX+((2*dcf)*d_Lmax_dX+2*d_dcf_dX*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*d_Lmax_dX+(((dcf*dcf)+1)*d_Lmax_dX+(dcf*d_dcf_dX+d_dcf_dX*dcf)*Lmax)*Lmax))+(dcf*d_dcf_dX+d_dcf_dX*dcf)*((((dcf*modelStruct.modelPar_TOXP)*(dcf*modelStruct.modelPar_TOXP))+(((2*dcf)*Lmax)*modelStruct.modelPar_TOXP))+((((dcf*dcf)+1)*Lmax)*Lmax))))+(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP))+((dcf*dcf)*d_Lmax_dX+(dcf*d_dcf_dX+d_dcf_dX*dcf)*Lmax))+d_Lmax_dX);
TT1 = (((value_sqrt_0+(dcf*modelStruct.modelPar_TOXP))+((dcf*dcf)*Lmax))+Lmax);
}
d_TT2_dX = ((TT0+1.0)*(dcf*modelStruct.d_modelPar_TOXP_dX+d_dcf_dX*modelStruct.modelPar_TOXP)+d_TT0_dX*(dcf*modelStruct.modelPar_TOXP));
TT2 = ((TT0+1.0)*(dcf*modelStruct.modelPar_TOXP));
{
double value_sqrt_0 = sqrt(static_cast<double>(2.0));
double value_log_1 = log((TT1/TT2));
double  deriv_log_1_d0 = (1.0/(TT1/TT2));
d_Cfgsat_dX = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)/TT0)*deriv_log_1_d0*(((TT2*d_TT1_dX-TT1*d_TT2_dX)/TT2/TT2))+((TT0*(((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*d_dcf_dX+(2.0*d_epssp_dX*value_sqrt_0/3.14159265358979323846)*0.85*dcf)-(((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)*d_TT0_dX)/TT0/TT0)*value_log_1);
Cfgsat = (((((((2.0*epssp)*value_sqrt_0)/3.14159265358979323846)*0.85)*dcf)/TT0)*value_log_1);
}
delta = 1.2e-12;
d_TT1_dX = (d_Cfgsat_dX-d_Cfglog_dX);
TT1 = ((Cfgsat-Cfglog)-delta);
{
double value_sqrt_0 = sqrt(((TT1*TT1)+((4*delta)*Cfgsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Cfg_dX = (modelStruct.modelPar_HFIN*(d_Cfgsat_dX-0.5*(d_TT1_dX+deriv_sqrt_0_d0*(((TT1*d_TT1_dX+d_TT1_dX*TT1)+(4*delta)*d_Cfgsat_dX))))+modelStruct.d_modelPar_HFIN_dX*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
Cfg = (modelStruct.modelPar_HFIN*(Cfgsat-(0.5*(TT1+value_sqrt_0))));
}
d_Cgg_side_dX = (d_Ccg_dX+d_Cfg_dX);
Cgg_side = (Ccg+Cfg);
}
// End block cfr_side_trigate
}
if ((modelStruct.modelPar_TMASK>0))
{
d_Acorner_dX = 0.0;
Acorner = 0.0;
}
else
{
if ((modelStruct.modelPar_HEPI>0))
{
d_Acorner_dX = ((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*((modelStruct.modelPar_HEPI*modelStruct.d_modelPar_CRATIO_dX+modelStruct.d_modelPar_HEPI_dX*modelStruct.modelPar_CRATIO)+modelStruct.d_modelPar_TSILI_dX)+(instanceStruct.d_instancePar_FPITCH_dX-instanceStruct.d_instancePar_TFIN_dX)*((modelStruct.modelPar_HEPI*modelStruct.modelPar_CRATIO)+modelStruct.modelPar_TSILI));
Acorner = ((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*((modelStruct.modelPar_HEPI*modelStruct.modelPar_CRATIO)+modelStruct.modelPar_TSILI));
}
else
{
d_Acorner_dX = ((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*d_Hrsd_dX+(instanceStruct.d_instancePar_FPITCH_dX-instanceStruct.d_instancePar_TFIN_dX)*Hrsd);
Acorner = ((instanceStruct.instancePar_FPITCH-instanceStruct.instancePar_TFIN)*Hrsd);
}
}
d_Ccorner_dX = ((modelStruct.modelPar_LSP*((((instanceStruct.instancePar_NFIN*Acorner)+modelStruct.modelPar_ARSDEND)+modelStruct.modelPar_ASILIEND)*d_epssp_dX+(((instanceStruct.instancePar_NFIN*d_Acorner_dX+instanceStruct.d_instancePar_NFIN_dX*Acorner)+modelStruct.d_modelPar_ARSDEND_dX)+modelStruct.d_modelPar_ASILIEND_dX)*epssp)-((((instanceStruct.instancePar_NFIN*Acorner)+modelStruct.modelPar_ARSDEND)+modelStruct.modelPar_ASILIEND)*epssp)*modelStruct.d_modelPar_LSP_dX)/modelStruct.modelPar_LSP/modelStruct.modelPar_LSP);
Ccorner = (((((instanceStruct.instancePar_NFIN*Acorner)+modelStruct.modelPar_ARSDEND)+modelStruct.modelPar_ASILIEND)*epssp)/modelStruct.modelPar_LSP);
d_Cfr_geo_dX = ((d_Ccorner_dX+(Cgg_top*instanceStruct.d_instancePar_NFIN_dX+d_Cgg_top_dX*instanceStruct.instancePar_NFIN))+((modelStruct.modelPar_CGEOE*Cgg_side)*instanceStruct.d_instancePar_NFIN_dX+(modelStruct.modelPar_CGEOE*d_Cgg_side_dX+modelStruct.d_modelPar_CGEOE_dX*Cgg_side)*instanceStruct.instancePar_NFIN)*2.0)*modelStruct.modelPar_NF;
Cfr_geo = (((Ccorner+(Cgg_top*instanceStruct.instancePar_NFIN))+(((modelStruct.modelPar_CGEOE*Cgg_side)*instanceStruct.instancePar_NFIN)*2.0))*modelStruct.modelPar_NF);
{
double value_max_0 = std::max((((modelStruct.modelPar_CGEOA+(modelStruct.modelPar_CGEOB*instanceStruct.instancePar_TFIN))+(modelStruct.modelPar_CGEOC*instanceStruct.instancePar_FPITCH))+(modelStruct.modelPar_CGEOD*instanceStruct.instancePar_LRSD)),static_cast<double>(0.0));
double  deriv_max_0_d0 = (((((modelStruct.modelPar_CGEOA+(modelStruct.modelPar_CGEOB*instanceStruct.instancePar_TFIN))+(modelStruct.modelPar_CGEOC*instanceStruct.instancePar_FPITCH))+(modelStruct.modelPar_CGEOD*instanceStruct.instancePar_LRSD))>=0.0)?1.0:0.0);
d_Cfr_geo_dX = (Cfr_geo*(deriv_max_0_d0*((((modelStruct.d_modelPar_CGEOA_dX+(modelStruct.modelPar_CGEOB*instanceStruct.d_instancePar_TFIN_dX+modelStruct.d_modelPar_CGEOB_dX*instanceStruct.instancePar_TFIN))+(modelStruct.modelPar_CGEOC*instanceStruct.d_instancePar_FPITCH_dX+modelStruct.d_modelPar_CGEOC_dX*instanceStruct.instancePar_FPITCH))+(modelStruct.modelPar_CGEOD*instanceStruct.d_instancePar_LRSD_dX+modelStruct.d_modelPar_CGEOD_dX*instanceStruct.instancePar_LRSD))))+d_Cfr_geo_dX*value_max_0);
Cfr_geo = (Cfr_geo*value_max_0);
}
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(modelStruct.modelPar_HFIN/modelStruct.modelPar_EOTBOX)));
d_T0_dX = (modelStruct.modelPar_CSDESW*evaluator_lln_0.getDerivs((1.0+(modelStruct.modelPar_HFIN/modelStruct.modelPar_EOTBOX)),((modelStruct.modelPar_EOTBOX*modelStruct.d_modelPar_HFIN_dX-modelStruct.modelPar_HFIN*modelStruct.d_modelPar_EOTBOX_dX)/modelStruct.modelPar_EOTBOX/modelStruct.modelPar_EOTBOX))+modelStruct.d_modelPar_CSDESW_dX*evaluator_lln_0.getValues((1.0+(modelStruct.modelPar_HFIN/modelStruct.modelPar_EOTBOX))));
T0 = (modelStruct.modelPar_CSDESW*evaluator_lln_0.getValues((1.0+(modelStruct.modelPar_HFIN/modelStruct.modelPar_EOTBOX))));
}
{
double value_max_0 = std::max(static_cast<double>(0.0),(instanceStruct.instancePar_PSEO-(instanceStruct.instancePar_FPITCH*NFINtotal)));
double  deriv_max_0_d1 = ((0.0>=(instanceStruct.instancePar_PSEO-(instanceStruct.instancePar_FPITCH*NFINtotal)))?0.0:1.0);
d_csbox_dX = ((cbox*instanceStruct.d_instancePar_ASEO_dX+d_cbox_dX*instanceStruct.instancePar_ASEO)+(T0*(deriv_max_0_d1*((instanceStruct.d_instancePar_PSEO_dX-(instanceStruct.instancePar_FPITCH*d_NFINtotal_dX+instanceStruct.d_instancePar_FPITCH_dX*NFINtotal))))+d_T0_dX*value_max_0));
csbox = ((cbox*instanceStruct.instancePar_ASEO)+(T0*value_max_0));
}
{
double value_max_0 = std::max(static_cast<double>(0.0),(instanceStruct.instancePar_PDEO-(instanceStruct.instancePar_FPITCH*NFINtotal)));
double  deriv_max_0_d1 = ((0.0>=(instanceStruct.instancePar_PDEO-(instanceStruct.instancePar_FPITCH*NFINtotal)))?0.0:1.0);
d_cdbox_dX = ((cbox*instanceStruct.d_instancePar_ADEO_dX+d_cbox_dX*instanceStruct.instancePar_ADEO)+(T0*(deriv_max_0_d1*((instanceStruct.d_instancePar_PDEO_dX-(instanceStruct.instancePar_FPITCH*d_NFINtotal_dX+instanceStruct.d_instancePar_FPITCH_dX*NFINtotal))))+d_T0_dX*value_max_0));
cdbox = ((cbox*instanceStruct.instancePar_ADEO)+(T0*value_max_0));
}
d_cgbox_dX = ((((modelStruct.modelPar_CGBO*modelStruct.modelPar_NF)*instanceStruct.instancePar_NGCON)+(modelStruct.modelPar_CGBN*NFINtotal))*d_LeffCV_dX+(modelStruct.d_modelPar_CGBO_dX*modelStruct.modelPar_NF*instanceStruct.instancePar_NGCON+(modelStruct.modelPar_CGBN*d_NFINtotal_dX+modelStruct.d_modelPar_CGBN_dX*NFINtotal))*LeffCV);
cgbox = ((((modelStruct.modelPar_CGBO*modelStruct.modelPar_NF)*instanceStruct.instancePar_NGCON)+(modelStruct.modelPar_CGBN*NFINtotal))*LeffCV);
d_EeffFactor_dX = (-1.0e-8*(epsratio*modelStruct.d_modelPar_EOT_dX+d_epsratio_dX*modelStruct.modelPar_EOT)/(epsratio*modelStruct.modelPar_EOT)/(epsratio*modelStruct.modelPar_EOT));
EeffFactor = (1.0e-8/(epsratio*modelStruct.modelPar_EOT));
{
double value_pow_0 = pow((Weff0*1.0e6),WR_i);
double  deriv_pow_0_d0 = (((Weff0*1.0e6) == 0.0)?0.0:(value_pow_0*WR_i/(Weff0*1.0e6)));
double  deriv_pow_0_d1 = ((Weff0*1.0e6) == 0.0)?0.0:(log((Weff0*1.0e6))*value_pow_0);
d_WeffWRFactor_dX = (-(value_pow_0*d_NFINtotal_dX+((deriv_pow_0_d0*(d_Weff0_dX*1.0e6))+(deriv_pow_0_d1*(d_WR_i_dX)))*NFINtotal)/(value_pow_0*NFINtotal)/(value_pow_0*NFINtotal));
WeffWRFactor = (1.0/(value_pow_0*NFINtotal));
}
{
double value_sqrt_0 = sqrt((((epsratio*modelStruct.modelPar_EOT)*0.5)*instanceStruct.instancePar_TFIN));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_litl_dX = deriv_sqrt_0_d0*((((epsratio*modelStruct.modelPar_EOT)*0.5)*instanceStruct.d_instancePar_TFIN_dX+(epsratio*modelStruct.d_modelPar_EOT_dX+d_epsratio_dX*modelStruct.modelPar_EOT)*0.5*instanceStruct.instancePar_TFIN));
litl = value_sqrt_0;
}
d_tmp_dX = ((scl*(DVT1_i*d_Leff_dX+d_DVT1_i_dX*Leff)-(DVT1_i*Leff)*d_scl_dX)/scl/scl);
tmp = (((DVT1_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);
double  deriv_cosh_0_d0 = (sinh(tmp));
d_Theta_SCE_dX = (-0.5*deriv_cosh_0_d0*(d_tmp_dX)/(value_cosh_0-1.0)/(value_cosh_0-1.0));
Theta_SCE = (0.5/(value_cosh_0-1.0));
}
}
else
{
{
double value_exp_0 = exp((-tmp));
double  deriv_exp_0_d0 = value_exp_0;
d_Theta_SCE_dX = deriv_exp_0_d0*((-d_tmp_dX));
Theta_SCE = value_exp_0;
}
}
d_tmp_dX = ((scl*(DVT1SS_i*d_Leff_dX+d_DVT1SS_i_dX*Leff)-(DVT1SS_i*Leff)*d_scl_dX)/scl/scl);
tmp = (((DVT1SS_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);
double  deriv_cosh_0_d0 = (sinh(tmp));
d_Theta_SW_dX = (-0.5*deriv_cosh_0_d0*(d_tmp_dX)/(value_cosh_0-1.0)/(value_cosh_0-1.0));
Theta_SW = (0.5/(value_cosh_0-1.0));
}
}
else
{
{
double value_exp_0 = exp((-tmp));
double  deriv_exp_0_d0 = value_exp_0;
d_Theta_SW_dX = deriv_exp_0_d0*((-d_tmp_dX));
Theta_SW = value_exp_0;
}
}
d_tmp_dX = ((scl*(DSUB_i*d_Leff_dX+d_DSUB_i_dX*Leff)-(DSUB_i*Leff)*d_scl_dX)/scl/scl);
tmp = (((DSUB_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);
double  deriv_cosh_0_d0 = (sinh(tmp));
d_Theta_DIBL_dX = (-0.5*deriv_cosh_0_d0*(d_tmp_dX)/(value_cosh_0-1.0)/(value_cosh_0-1.0));
Theta_DIBL = (0.5/(value_cosh_0-1.0));
}
}
else
{
{
double value_exp_0 = exp((-tmp));
double  deriv_exp_0_d0 = value_exp_0;
d_Theta_DIBL_dX = deriv_exp_0_d0*((-d_tmp_dX));
Theta_DIBL = value_exp_0;
}
}
{
double value_sqrt_0 = sqrt((1.0+(LPE0_i/Leff)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Theta_RSCE_dX = deriv_sqrt_0_d0*(((Leff*d_LPE0_i_dX-LPE0_i*d_Leff_dX)/Leff/Leff));
Theta_RSCE = (value_sqrt_0-1.0);
}
if (((modelStruct.modelPar_COREMOD!=0)&&(NBODY_i>1e23)))
{
d_nbody_dX = 0.0;
nbody = 1e23;
}
else
{
d_nbody_dX = d_NBODY_i_dX;
nbody = NBODY_i;
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_qbs_dX = (((2*cox)*((1.60219e-19*nbody)*instanceStruct.d_instancePar_TFIN_dX+1.60219e-19*d_nbody_dX*instanceStruct.instancePar_TFIN)-((1.60219e-19*nbody)*instanceStruct.instancePar_TFIN)*2*d_cox_dX)/(2*cox)/(2*cox));
qbs = (((1.60219e-19*nbody)*instanceStruct.instancePar_TFIN)/(2*cox));
}
else
{
d_qbs_dX = (((2*cox)*((1.60219e-19*nbody)*d_R_dX+1.60219e-19*d_nbody_dX*R)-((1.60219e-19*nbody)*R)*2*d_cox_dX)/(2*cox)/(2*cox));
qbs = (((1.60219e-19*nbody)*R)/(2*cox));
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_phibulk_dX = ((((1.60219e-19/(2*epssub))*nbody)*(instanceStruct.instancePar_TFIN/2))*(instanceStruct.d_instancePar_TFIN_dX/2)+(((1.60219e-19/(2*epssub))*nbody)*(instanceStruct.d_instancePar_TFIN_dX/2)+((1.60219e-19/(2*epssub))*d_nbody_dX+(-1.60219e-19*2*d_epssub_dX/(2*epssub)/(2*epssub))*nbody)*(instanceStruct.instancePar_TFIN/2))*(instanceStruct.instancePar_TFIN/2));
phibulk = ((((1.60219e-19/(2*epssub))*nbody)*(instanceStruct.instancePar_TFIN/2))*(instanceStruct.instancePar_TFIN/2));
{
double value_sqrt_0 = sqrt(((((2*1.60219e-19)*nbody)*epssub)*phibulk));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Qbul_dX = ((modelStruct.modelPar_COREMOD!=0)?0.0:deriv_sqrt_0_d0*(((((2*1.60219e-19)*nbody)*epssub)*d_phibulk_dX+(((2*1.60219e-19)*nbody)*d_epssub_dX+(2*1.60219e-19)*d_nbody_dX*epssub)*phibulk)));
Qbul = ((modelStruct.modelPar_COREMOD!=0)?0:value_sqrt_0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((2.0/instanceStruct.instancePar_TFIN));
d_F2_dX = evaluator_lln_0.getDerivs((2.0/instanceStruct.instancePar_TFIN),(-2.0*instanceStruct.d_instancePar_TFIN_dX/instanceStruct.instancePar_TFIN/instanceStruct.instancePar_TFIN));
F2 = evaluator_lln_0.getValues((2.0/instanceStruct.instancePar_TFIN));
}
}
else
{
d_r1_dX = (((R*cox)*2*d_epssub_dX-(2*epssub)*(R*d_cox_dX+d_R_dX*cox))/(R*cox)/(R*cox));
r1 = ((2*epssub)/(R*cox));
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_r1_acc_dX = (((R*cox_acc)*2.0*d_epssub_dX-(2.0*epssub)*(R*d_cox_acc_dX+d_R_dX*cox_acc))/(R*cox_acc)/(R*cox_acc));
r1_acc = ((2.0*epssub)/(R*cox_acc));
}
}
if ((modelStruct.modelPar_DEVTYPE==1))
{
Aechvb = 4.97232e-7;
}
else
{
Aechvb = 3.42537e-7;
}
if ((modelStruct.modelPar_DEVTYPE==1))
{
Bechvb = 7.45669e11;
}
else
{
Bechvb = 1.16645e12;
}
d_T0_dX = (modelStruct.modelPar_TOXG*modelStruct.d_modelPar_TOXG_dX+modelStruct.d_modelPar_TOXG_dX*modelStruct.modelPar_TOXG);
T0 = (modelStruct.modelPar_TOXG*modelStruct.modelPar_TOXG);
d_T1_dX = (modelStruct.modelPar_TOXG*d_POXEDGE_i_dX+modelStruct.d_modelPar_TOXG_dX*POXEDGE_i);
T1 = (modelStruct.modelPar_TOXG*POXEDGE_i);
d_T2_dX = (T1*d_T1_dX+d_T1_dX*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXG));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXG))));
d_Toxratio_dX = ((T0*evaluator_lexp_1.getDerivs((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXG))),(NTOX_i*evaluator_lln_0.getDerivs((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXG),((modelStruct.modelPar_TOXG*modelStruct.d_modelPar_TOXREF_dX-modelStruct.modelPar_TOXREF*modelStruct.d_modelPar_TOXG_dX)/modelStruct.modelPar_TOXG/modelStruct.modelPar_TOXG))+d_NTOX_i_dX*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXG))))-evaluator_lexp_1.getValues((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXG))))*d_T0_dX)/T0/T0);
Toxratio = (evaluator_lexp_1.getValues((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/modelStruct.modelPar_TOXG))))/T0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((modelStruct.modelPar_TOXREF/T1));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/T1))));
d_Toxratioedge_dX = ((T2*evaluator_lexp_1.getDerivs((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/T1))),(NTOX_i*evaluator_lln_0.getDerivs((modelStruct.modelPar_TOXREF/T1),((T1*modelStruct.d_modelPar_TOXREF_dX-modelStruct.modelPar_TOXREF*d_T1_dX)/T1/T1))+d_NTOX_i_dX*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/T1))))-evaluator_lexp_1.getValues((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/T1))))*d_T2_dX)/T2/T2);
Toxratioedge = (evaluator_lexp_1.getValues((NTOX_i*evaluator_lln_0.getValues((modelStruct.modelPar_TOXREF/T1))))/T2);
}
d_igsd_mult0_dX = ((Weff0*Aechvb)*d_Toxratioedge_dX+d_Weff0_dX*Aechvb*Toxratioedge);
igsd_mult0 = ((Weff0*Aechvb)*Toxratioedge);
if ((modelStruct.modelPar_TNOM<(-273.15)))
{
UserInfo(theInstance)  << "Warning: (TNOM=%e) < -`P_CELSIUS0. Set to 27 C." << " " << modelStruct.modelPar_TNOM << " " <<  std::endl; 
d_Tnom_dX = 0.0;
Tnom = 300.15;
}
else
{
d_Tnom_dX = modelStruct.d_modelPar_TNOM_dX;
Tnom = (modelStruct.modelPar_TNOM+273.15);
}
}
// End block CMGBiasIndepCalc
d_DevTemp_dX = modelStruct.d_modelPar_DTEMP_dX;
DevTemp = (admsTemperature+modelStruct.modelPar_DTEMP);
//Begin block CMGTempDepCalc
{
d_TRatio_dX = ((Tnom*d_DevTemp_dX-DevTemp*d_Tnom_dX)/Tnom/Tnom);
TRatio = (DevTemp/Tnom);
d_delTemp_dX = (d_DevTemp_dX-d_Tnom_dX);
delTemp = (DevTemp-Tnom);
d_Vtm_dX = 8.617087e-5*d_DevTemp_dX;
Vtm = (8.617087e-5*DevTemp);
d_Vtm0_dX = 8.617087e-5*d_Tnom_dX;
Vtm0 = (8.617087e-5*Tnom);
d_Eg_dX = (modelStruct.d_modelPar_BG0SUB_dX-(((DevTemp+modelStruct.modelPar_TBGBSUB)*((modelStruct.modelPar_TBGASUB*DevTemp)*d_DevTemp_dX+(modelStruct.modelPar_TBGASUB*d_DevTemp_dX+modelStruct.d_modelPar_TBGASUB_dX*DevTemp)*DevTemp)-((modelStruct.modelPar_TBGASUB*DevTemp)*DevTemp)*(d_DevTemp_dX+modelStruct.d_modelPar_TBGBSUB_dX))/(DevTemp+modelStruct.modelPar_TBGBSUB)/(DevTemp+modelStruct.modelPar_TBGBSUB)));
Eg = (modelStruct.modelPar_BG0SUB-(((modelStruct.modelPar_TBGASUB*DevTemp)*DevTemp)/(DevTemp+modelStruct.modelPar_TBGBSUB)));
d_Eg0_dX = (modelStruct.d_modelPar_BG0SUB_dX-(((Tnom+modelStruct.modelPar_TBGBSUB)*((modelStruct.modelPar_TBGASUB*Tnom)*d_Tnom_dX+(modelStruct.modelPar_TBGASUB*d_Tnom_dX+modelStruct.d_modelPar_TBGASUB_dX*Tnom)*Tnom)-((modelStruct.modelPar_TBGASUB*Tnom)*Tnom)*(d_Tnom_dX+modelStruct.d_modelPar_TBGBSUB_dX))/(Tnom+modelStruct.modelPar_TBGBSUB)/(Tnom+modelStruct.modelPar_TBGBSUB)));
Eg0 = (modelStruct.modelPar_BG0SUB-(((modelStruct.modelPar_TBGASUB*Tnom)*Tnom)/(Tnom+modelStruct.modelPar_TBGBSUB)));
{
double value_sqrt_0 = sqrt((DevTemp/300.15));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T1_dX = ((DevTemp/300.15)*deriv_sqrt_0_d0*((d_DevTemp_dX/300.15))+(d_DevTemp_dX/300.15)*value_sqrt_0);
T1 = ((DevTemp/300.15)*value_sqrt_0);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((modelStruct.modelPar_BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))));
d_ni_dX = ((modelStruct.modelPar_NI0SUB*T1)*evaluator_lexp_0.getDerivs(((modelStruct.modelPar_BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))),((modelStruct.d_modelPar_BG0SUB_dX/((2.0*8.617087e-5)*300.15))-(((2.0*Vtm)*d_Eg_dX-Eg*2.0*d_Vtm_dX)/(2.0*Vtm)/(2.0*Vtm))))+(modelStruct.modelPar_NI0SUB*d_T1_dX+modelStruct.d_modelPar_NI0SUB_dX*T1)*evaluator_lexp_0.getValues(((modelStruct.modelPar_BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm)))));
ni = ((modelStruct.modelPar_NI0SUB*T1)*evaluator_lexp_0.getValues(((modelStruct.modelPar_BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm)))));
}
d_Nc_dX = (modelStruct.modelPar_NC0SUB*d_T1_dX+modelStruct.d_modelPar_NC0SUB_dX*T1);
Nc = (modelStruct.modelPar_NC0SUB*T1);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TSS_i*delTemp))-1.0E-6),1.0E-3);
d_ThetaSS_dX = evaluator_hypsmooth_0.getDerivs(((1.0+(TSS_i*delTemp))-1.0E-6),1.0E-3,(TSS_i*d_delTemp_dX+d_TSS_i_dX*delTemp),0.0);
ThetaSS = evaluator_hypsmooth_0.getValues(((1.0+(TSS_i*delTemp))-1.0E-6),1.0E-3);
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_kT_dX = d_Vtm_dX*1.60219e-19;
kT = (Vtm*1.60219e-19);
d_T0_dX = (-(1.05457e-34*3.14159265358979323846)*instanceStruct.d_instancePar_TFIN_dX/instanceStruct.instancePar_TFIN/instanceStruct.instancePar_TFIN);
T0 = ((1.05457e-34*3.14159265358979323846)/instanceStruct.instancePar_TFIN);
d_E0_dX = ((T0*d_T0_dX+d_T0_dX*T0)/(2.0*mx));
E0 = ((T0*T0)/(2.0*mx));
d_E0prime_dX = ((T0*d_T0_dX+d_T0_dX*T0)/(2.0*mxprime));
E0prime = ((T0*T0)/(2.0*mxprime));
d_E1_dX = 4.0*d_E0_dX;
E1 = (4.0*E0);
d_E1prime_dX = 4.0*d_E0prime_dX;
E1prime = (4.0*E0prime);
d_T1_dX = 0.0;
T1 = ((gprime*mdprime)/(gfactor*md));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((E0-E0prime)/kT));
d_gam0_dX = (T1*evaluator_lexp_0.getDerivs(((E0-E0prime)/kT),((kT*(d_E0_dX-d_E0prime_dX)-(E0-E0prime)*d_kT_dX)/kT/kT))+d_T1_dX*evaluator_lexp_0.getValues(((E0-E0prime)/kT)));
gam0 = (1.0+(T1*evaluator_lexp_0.getValues(((E0-E0prime)/kT))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((E0-E1)/kT));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((E0-E1prime)/kT));
d_gam1_dX = ((d_gam0_dX+evaluator_lexp_0.getDerivs(((E0-E1)/kT),((kT*(d_E0_dX-d_E1_dX)-(E0-E1)*d_kT_dX)/kT/kT)))+(T1*evaluator_lexp_1.getDerivs(((E0-E1prime)/kT),((kT*(d_E0_dX-d_E1prime_dX)-(E0-E1prime)*d_kT_dX)/kT/kT))+d_T1_dX*evaluator_lexp_1.getValues(((E0-E1prime)/kT))));
gam1 = ((gam0+evaluator_lexp_0.getValues(((E0-E1)/kT)))+(T1*evaluator_lexp_1.getValues(((E0-E1prime)/kT))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/instanceStruct.instancePar_TFIN)*gam1));
d_T2_dX = ((-Vtm)*evaluator_lln_0.getDerivs((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/instanceStruct.instancePar_TFIN)*gam1),(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/instanceStruct.instancePar_TFIN)*d_gam1_dX+((instanceStruct.instancePar_TFIN*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*d_kT_dX+(-(gfactor*md)*((3.14159265358979323846*1.05457e-34)*1.05457e-34)*d_Nc_dX/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*instanceStruct.d_instancePar_TFIN_dX)/instanceStruct.instancePar_TFIN/instanceStruct.instancePar_TFIN)*gam1))+(-d_Vtm_dX)*evaluator_lln_0.getValues((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/instanceStruct.instancePar_TFIN)*gam1)));
T2 = ((-Vtm)*evaluator_lln_0.getValues((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/instanceStruct.instancePar_TFIN)*gam1)));
}
d_dvch_qm_dX = (QMFACTOR_i*((d_E0_dX/1.60219e-19)+d_T2_dX)+d_QMFACTOR_i_dX*((E0/1.60219e-19)+T2));
dvch_qm = (QMFACTOR_i*((E0/1.60219e-19)+T2));
}
else
{
d_T0_dX = (-(1.05457e-34*2.4048)*d_R_dX/R/R);
T0 = ((1.05457e-34*2.4048)/R);
d_E0_dX = ((T0*d_T0_dX+d_T0_dX*T0)/(2.0*mx));
E0 = ((T0*T0)/(2.0*mx));
d_dvch_qm_dX = ((QMFACTOR_i*d_E0_dX+d_QMFACTOR_i_dX*E0)/1.60219e-19);
dvch_qm = ((QMFACTOR_i*E0)/1.60219e-19);
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((modelStruct.modelPar_TETA0*delTemp),(-0.9),1e-4);
d_ETA0_t_dX = (ETA0_i*evaluator_hypmax_0.getDerivs((modelStruct.modelPar_TETA0*delTemp),(-0.9),1e-4,(modelStruct.modelPar_TETA0*d_delTemp_dX+modelStruct.d_modelPar_TETA0_dX*delTemp),0.0,0.0)+d_ETA0_i_dX*(1.0+evaluator_hypmax_0.getValues((modelStruct.modelPar_TETA0*delTemp),(-0.9),1e-4)));
ETA0_t = (ETA0_i*(1.0+evaluator_hypmax_0.getValues((modelStruct.modelPar_TETA0*delTemp),(-0.9),1e-4)));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((modelStruct.modelPar_TETA0R*delTemp),(-0.9),1e-4);
d_ETA0R_t_dX = (ETA0R_i*evaluator_hypmax_0.getDerivs((modelStruct.modelPar_TETA0R*delTemp),(-0.9),1e-4,(modelStruct.modelPar_TETA0R*d_delTemp_dX+modelStruct.d_modelPar_TETA0R_dX*delTemp),0.0,0.0)+d_ETA0R_i_dX*(1.0+evaluator_hypmax_0.getValues((modelStruct.modelPar_TETA0R*delTemp),(-0.9),1e-4)));
ETA0R_t = (ETA0R_i*(1.0+evaluator_hypmax_0.getValues((modelStruct.modelPar_TETA0R*delTemp),(-0.9),1e-4)));
}
{
double value_pow_0 = pow(TRatio,UTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UTE_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_T1_dX = (U0_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(d_UTE_i_dX)))+d_U0_i_dX*value_pow_0);
T1 = (U0_i*value_pow_0);
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((UTL_i*delTemp),((-0.9)*T1),1e-4);
d_U0_t_dX = (d_T1_dX+evaluator_hypmax_0.getDerivs((UTL_i*delTemp),((-0.9)*T1),1e-4,(UTL_i*d_delTemp_dX+d_UTL_i_dX*delTemp),(-0.9)*d_T1_dX,0.0));
U0_t = (T1+evaluator_hypmax_0.getValues((UTL_i*delTemp),((-0.9)*T1),1e-4));
}
d_u0_dX = d_U0_t_dX;
u0 = U0_t;
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(EMOBT_i*delTemp))-1.0E-6),1.0E-3);
d_ETAMOB_t_dX = (ETAMOB_i*evaluator_hypsmooth_0.getDerivs(((1.0+(EMOBT_i*delTemp))-1.0E-6),1.0E-3,(EMOBT_i*d_delTemp_dX+d_EMOBT_i_dX*delTemp),0.0)+d_ETAMOB_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(EMOBT_i*delTemp))-1.0E-6),1.0E-3));
ETAMOB_t = (ETAMOB_i*evaluator_hypsmooth_0.getValues(((1.0+(EMOBT_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((UA1_i*delTemp),(-UA_i),1.0e-6);
d_UA_t_dX = (d_UA_i_dX+evaluator_hypmax_0.getDerivs((UA1_i*delTemp),(-UA_i),1.0e-6,(UA1_i*d_delTemp_dX+d_UA1_i_dX*delTemp),(-d_UA_i_dX),0.0));
UA_t = (UA_i+evaluator_hypmax_0.getValues((UA1_i*delTemp),(-UA_i),1.0e-6));
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3);
d_UC_t_dX = (UC_i*evaluator_hypsmooth_0.getDerivs(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3,(UC1_i*d_delTemp_dX+d_UC1_i_dX*delTemp),0.0)+d_UC_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3));
UC_t = (UC_i*evaluator_hypsmooth_0.getValues(((1.0+(UC1_i*delTemp))-1.0E-6),1.0E-3));
}
}
{
double value_pow_0 = pow(TRatio,UD1_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UD1_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_UD_t_dX = (UD_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(d_UD1_i_dX)))+d_UD_i_dX*value_pow_0);
UD_t = (UD_i*value_pow_0);
}
{
double value_pow_0 = pow(TRatio,UCSTE_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*UCSTE_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_UCS_t_dX = (UCS_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(d_UCSTE_i_dX)))+d_UCS_i_dX*value_pow_0);
UCS_t = (UCS_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(PRT_i*delTemp))-1.0E-6),1.0E-3);
d_rdstemp_dX = evaluator_hypsmooth_0.getDerivs(((1.0+(PRT_i*delTemp))-1.0E-6),1.0E-3,(PRT_i*d_delTemp_dX+d_PRT_i_dX*delTemp),0.0);
rdstemp = evaluator_hypsmooth_0.getValues(((1.0+(PRT_i*delTemp))-1.0E-6),1.0E-3);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3);
d_RSDR_t_dX = (modelStruct.modelPar_RSDR*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TRSDR*d_delTemp_dX+modelStruct.d_modelPar_TRSDR_dX*delTemp),0.0)+modelStruct.d_modelPar_RSDR_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3));
RSDR_t = (modelStruct.modelPar_RSDR*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3);
d_RSDRR_t_dX = (modelStruct.modelPar_RSDRR*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TRSDR*d_delTemp_dX+modelStruct.d_modelPar_TRSDR_dX*delTemp),0.0)+modelStruct.d_modelPar_RSDRR_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3));
RSDRR_t = (modelStruct.modelPar_RSDRR*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRSDR*delTemp))-1.0E-6),1.0E-3));
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3);
d_RDDR_t_dX = (modelStruct.modelPar_RDDR*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TRDDR*d_delTemp_dX+modelStruct.d_modelPar_TRDDR_dX*delTemp),0.0)+modelStruct.d_modelPar_RDDR_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3));
RDDR_t = (modelStruct.modelPar_RDDR*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3);
d_RDDRR_t_dX = (modelStruct.modelPar_RDDRR*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TRDDR*d_delTemp_dX+modelStruct.d_modelPar_TRDDR_dX*delTemp),0.0)+modelStruct.d_modelPar_RDDRR_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3));
RDDRR_t = (modelStruct.modelPar_RDDRR*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TRDDR*delTemp))-1.0E-6),1.0E-3));
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
d_VSAT_t_dX = (VSAT_i*evaluator_hypsmooth_0.getDerivs((0.9-(AT_i*delTemp)),1.0E-3,(-(AT_i*d_delTemp_dX+d_AT_i_dX*delTemp)),0.0)+d_VSAT_i_dX*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
VSAT_t = (VSAT_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSAT_t<1000))
{
UserInfo(theInstance)  << "Warning: VSAT(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSAT_t << " " <<  std::endl; 
d_VSAT_t_dX = 0.0;
VSAT_t = 1000;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
d_VSAT1_t_dX = (VSAT1_i*evaluator_hypsmooth_0.getDerivs((0.9-(AT_i*delTemp)),1.0E-3,(-(AT_i*d_delTemp_dX+d_AT_i_dX*delTemp)),0.0)+d_VSAT1_i_dX*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
VSAT1_t = (VSAT1_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSAT1_t<1000))
{
UserInfo(theInstance)  << "Warning: VSAT1(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSAT1_t << " " <<  std::endl; 
d_VSAT1_t_dX = 0.0;
VSAT1_t = 1000;
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
d_VSAT1R_t_dX = (VSAT1R_i*evaluator_hypsmooth_0.getDerivs((0.9-(AT_i*delTemp)),1.0E-3,(-(AT_i*d_delTemp_dX+d_AT_i_dX*delTemp)),0.0)+d_VSAT1R_i_dX*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
VSAT1R_t = (VSAT1R_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSAT1R_t<1000))
{
UserInfo(theInstance)  << "Warning: VSAT1R(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSAT1R_t << " " <<  std::endl; 
d_VSAT1R_t_dX = 0.0;
VSAT1R_t = 1000;
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((0.9-(AT_i*delTemp)),1.0E-3);
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(0.9,1.0E-3);
d_VSATCV_t_dX = (VSATCV_i*evaluator_hypsmooth_0.getDerivs((0.9-(AT_i*delTemp)),1.0E-3,(-(AT_i*d_delTemp_dX+d_AT_i_dX*delTemp)),0.0)+d_VSATCV_i_dX*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
VSATCV_t = (VSATCV_i*((1.0+evaluator_hypsmooth_0.getValues((0.9-(AT_i*delTemp)),1.0E-3))-evaluator_hypsmooth_1.getValues(0.9,1.0E-3)));
}
if ((VSATCV_t<1000))
{
UserInfo(theInstance)  << "Warning: VSATCV(%f) = %e is less than 1K, setting it to 1K." << " " << DevTemp << " " << VSATCV_t << " " <<  std::endl; 
d_VSATCV_t_dX = 0.0;
VSATCV_t = 1000;
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((MEXP_i*(1.0+(modelStruct.modelPar_TMEXP*delTemp)))-2.0),1.0E-3);
d_MEXP_t_dX = evaluator_hypsmooth_0.getDerivs(((MEXP_i*(1.0+(modelStruct.modelPar_TMEXP*delTemp)))-2.0),1.0E-3,(MEXP_i*(modelStruct.modelPar_TMEXP*d_delTemp_dX+modelStruct.d_modelPar_TMEXP_dX*delTemp)+d_MEXP_i_dX*(1.0+(modelStruct.modelPar_TMEXP*delTemp))),0.0);
MEXP_t = (evaluator_hypsmooth_0.getValues(((MEXP_i*(1.0+(modelStruct.modelPar_TMEXP*delTemp)))-2.0),1.0E-3)+2.0);
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((MEXPR_i*(1.0+(modelStruct.modelPar_TMEXPR*delTemp)))-2.0),1.0E-3);
d_MEXPR_t_dX = evaluator_hypsmooth_0.getDerivs(((MEXPR_i*(1.0+(modelStruct.modelPar_TMEXPR*delTemp)))-2.0),1.0E-3,(MEXPR_i*(modelStruct.modelPar_TMEXPR*d_delTemp_dX+modelStruct.d_modelPar_TMEXPR_dX*delTemp)+d_MEXPR_i_dX*(1.0+(modelStruct.modelPar_TMEXPR*delTemp))),0.0);
MEXPR_t = (evaluator_hypsmooth_0.getValues(((MEXPR_i*(1.0+(modelStruct.modelPar_TMEXPR*delTemp)))-2.0),1.0E-3)+2.0);
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3);
d_PTWG_t_dX = (PTWG_i*evaluator_hypsmooth_0.getDerivs(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3,(-(PTWGT_i*d_delTemp_dX+d_PTWGT_i_dX*delTemp)),0.0)+d_PTWG_i_dX*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
PTWG_t = (PTWG_i*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
if ((modelStruct.modelPar_ASYMMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3);
d_PTWGR_t_dX = (PTWGR_i*evaluator_hypsmooth_0.getDerivs(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3,(-(PTWGT_i*d_delTemp_dX+d_PTWGT_i_dX*delTemp)),0.0)+d_PTWGR_i_dX*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
PTWGR_t = (PTWGR_i*evaluator_hypsmooth_0.getValues(((1.0-(PTWGT_i*delTemp))-1.0E-6),1.0E-3));
}
}
d_dvth_temp_dX = ((KT1_i+(modelStruct.modelPar_KT1L/Leff))*d_TRatio_dX+(d_KT1_i_dX+((Leff*modelStruct.d_modelPar_KT1L_dX-modelStruct.modelPar_KT1L*d_Leff_dX)/Leff/Leff))*(TRatio-1.0));
dvth_temp = ((KT1_i+(modelStruct.modelPar_KT1L/Leff))*(TRatio-1.0));
{
double value_pow_0 = pow(TRatio,IIT_i);
double  deriv_pow_0_d0 = ((TRatio == 0.0)?0.0:(value_pow_0*IIT_i/TRatio));
double  deriv_pow_0_d1 = (TRatio == 0.0)?0.0:(log(TRatio)*value_pow_0);
d_BETA0_t_dX = (BETA0_i*((deriv_pow_0_d0*(d_TRatio_dX))+(deriv_pow_0_d1*(d_IIT_i_dX)))+d_BETA0_i_dX*value_pow_0);
BETA0_t = (BETA0_i*value_pow_0);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1+(TII_i*(TRatio-1)))-0.01),1.0E-3);
d_SII0_t_dX = (SII0_i*evaluator_hypsmooth_0.getDerivs(((1+(TII_i*(TRatio-1)))-0.01),1.0E-3,(TII_i*d_TRatio_dX+d_TII_i_dX*(TRatio-1)),0.0)+d_SII0_i_dX*(evaluator_hypsmooth_0.getValues(((1+(TII_i*(TRatio-1)))-0.01),1.0E-3)+0.01));
SII0_t = (SII0_i*(evaluator_hypsmooth_0.getValues(((1+(TII_i*(TRatio-1)))-0.01),1.0E-3)+0.01));
}
d_K0_t_dX = (d_K0_i_dX+(K01_i*d_delTemp_dX+d_K01_i_dX*delTemp));
K0_t = (K0_i+(K01_i*delTemp));
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((K0SI1_i*delTemp),(-K0SI_i),1E-6);
d_K0SI_t_dX = (d_K0SI_i_dX+evaluator_hypmax_0.getDerivs((K0SI1_i*delTemp),(-K0SI_i),1E-6,(K0SI1_i*d_delTemp_dX+d_K0SI1_i_dX*delTemp),(-d_K0SI_i_dX),0.0));
K0SI_t = (K0SI_i+evaluator_hypmax_0.getValues((K0SI1_i*delTemp),(-K0SI_i),1E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((K1SI1_i*delTemp),(-K1SI_i),1E-6);
d_K1SI_t_dX = (d_K1SI_i_dX+evaluator_hypmax_0.getDerivs((K1SI1_i*delTemp),(-K1SI_i),1E-6,(K1SI1_i*d_delTemp_dX+d_K1SI1_i_dX*delTemp),(-d_K1SI_i_dX),0.0));
K1SI_t = (K1SI_i+evaluator_hypmax_0.getValues((K1SI1_i*delTemp),(-K1SI_i),1E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((K11_i*delTemp),(-K1_i),1E-6);
d_K1_t_dX = (d_K1_i_dX+evaluator_hypmax_0.getDerivs((K11_i*delTemp),(-K1_i),1E-6,(K11_i*d_delTemp_dX+d_K11_i_dX*delTemp),(-d_K1_i_dX),0.0));
K1_t = (K1_i+evaluator_hypmax_0.getValues((K11_i*delTemp),(-K1_i),1E-6));
}
d_K1SAT_t_dX = (d_K1SAT_i_dX+(K1SAT1_i*d_delTemp_dX+d_K1SAT1_i_dX*delTemp));
K1SAT_t = (K1SAT_i+(K1SAT1_i*delTemp));
d_A1_t_dX = (d_A1_i_dX+(A11_i*d_delTemp_dX+d_A11_i_dX*delTemp));
A1_t = (A1_i+(A11_i*delTemp));
d_A2_t_dX = (d_A2_i_dX+(A21_i*d_delTemp_dX+d_A21_i_dX*delTemp));
A2_t = (A2_i+(A21_i*delTemp));
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0E-6);
d_AIGBINV_t_dX = (d_AIGBINV_i_dX+evaluator_hypmax_0.getDerivs((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0E-6,(AIGBINV1_i*d_delTemp_dX+d_AIGBINV1_i_dX*delTemp),(-d_AIGBINV_i_dX),0.0));
AIGBINV_t = (AIGBINV_i+evaluator_hypmax_0.getValues((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0E-6);
d_AIGBACC_t_dX = (d_AIGBACC_i_dX+evaluator_hypmax_0.getDerivs((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0E-6,(AIGBACC1_i*d_delTemp_dX+d_AIGBACC1_i_dX*delTemp),(-d_AIGBACC_i_dX),0.0));
AIGBACC_t = (AIGBACC_i+evaluator_hypmax_0.getValues((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGC1_i*delTemp),(-AIGC_i),1.0E-6);
d_AIGC_t_dX = (d_AIGC_i_dX+evaluator_hypmax_0.getDerivs((AIGC1_i*delTemp),(-AIGC_i),1.0E-6,(AIGC1_i*d_delTemp_dX+d_AIGC1_i_dX*delTemp),(-d_AIGC_i_dX),0.0));
AIGC_t = (AIGC_i+evaluator_hypmax_0.getValues((AIGC1_i*delTemp),(-AIGC_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGS1_i*delTemp),(-AIGS_i),1.0E-6);
d_AIGS_t_dX = (d_AIGS_i_dX+evaluator_hypmax_0.getDerivs((AIGS1_i*delTemp),(-AIGS_i),1.0E-6,(AIGS1_i*d_delTemp_dX+d_AIGS1_i_dX*delTemp),(-d_AIGS_i_dX),0.0));
AIGS_t = (AIGS_i+evaluator_hypmax_0.getValues((AIGS1_i*delTemp),(-AIGS_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((AIGD1_i*delTemp),(-AIGD_i),1.0E-6);
d_AIGD_t_dX = (d_AIGD_i_dX+evaluator_hypmax_0.getDerivs((AIGD1_i*delTemp),(-AIGD_i),1.0E-6,(AIGD1_i*d_delTemp_dX+d_AIGD1_i_dX*delTemp),(-d_AIGD_i_dX),0.0));
AIGD_t = (AIGD_i+evaluator_hypmax_0.getValues((AIGD1_i*delTemp),(-AIGD_i),1.0E-6));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3);
d_BGIDL_t_dX = (BGIDL_i*evaluator_hypsmooth_0.getDerivs(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3,(TGIDL_i*d_delTemp_dX+d_TGIDL_i_dX*delTemp),0.0)+d_BGIDL_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
BGIDL_t = (BGIDL_i*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3);
d_BGISL_t_dX = (BGISL_i*evaluator_hypsmooth_0.getDerivs(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3,(TGIDL_i*d_delTemp_dX+d_TGIDL_i_dX*delTemp),0.0)+d_BGISL_i_dX*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
BGISL_t = (BGISL_i*evaluator_hypsmooth_0.getValues(((1.0+(TGIDL_i*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((modelStruct.modelPar_ALPHA01*delTemp),(-ALPHA0_i),1.0E-6);
d_ALPHA0_t_dX = (d_ALPHA0_i_dX+evaluator_hypmax_0.getDerivs((modelStruct.modelPar_ALPHA01*delTemp),(-ALPHA0_i),1.0E-6,(modelStruct.modelPar_ALPHA01*d_delTemp_dX+modelStruct.d_modelPar_ALPHA01_dX*delTemp),(-d_ALPHA0_i_dX),0.0));
ALPHA0_t = (ALPHA0_i+evaluator_hypmax_0.getValues((modelStruct.modelPar_ALPHA01*delTemp),(-ALPHA0_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((modelStruct.modelPar_ALPHA11*delTemp),(-ALPHA1_i),1.0E-6);
d_ALPHA1_t_dX = (d_ALPHA1_i_dX+evaluator_hypmax_0.getDerivs((modelStruct.modelPar_ALPHA11*delTemp),(-ALPHA1_i),1.0E-6,(modelStruct.modelPar_ALPHA11*d_delTemp_dX+modelStruct.d_modelPar_ALPHA11_dX*delTemp),(-d_ALPHA1_i_dX),0.0));
ALPHA1_t = (ALPHA1_i+evaluator_hypmax_0.getValues((modelStruct.modelPar_ALPHA11*delTemp),(-ALPHA1_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((modelStruct.modelPar_ALPHAII01*delTemp),(-ALPHAII0_i),1.0E-6);
d_ALPHAII0_t_dX = (d_ALPHAII0_i_dX+evaluator_hypmax_0.getDerivs((modelStruct.modelPar_ALPHAII01*delTemp),(-ALPHAII0_i),1.0E-6,(modelStruct.modelPar_ALPHAII01*d_delTemp_dX+modelStruct.d_modelPar_ALPHAII01_dX*delTemp),(-d_ALPHAII0_i_dX),0.0));
ALPHAII0_t = (ALPHAII0_i+evaluator_hypmax_0.getValues((modelStruct.modelPar_ALPHAII01*delTemp),(-ALPHAII0_i),1.0E-6));
}
{
AnalogFunctions::hypmaxEvaluator evaluator_hypmax_0((modelStruct.modelPar_ALPHAII11*delTemp),(-ALPHAII1_i),1.0E-6);
d_ALPHAII1_t_dX = (d_ALPHAII1_i_dX+evaluator_hypmax_0.getDerivs((modelStruct.modelPar_ALPHAII11*delTemp),(-ALPHAII1_i),1.0E-6,(modelStruct.modelPar_ALPHAII11*d_delTemp_dX+modelStruct.d_modelPar_ALPHAII11_dX*delTemp),(-d_ALPHAII1_i_dX),0.0));
ALPHAII1_t = (ALPHAII1_i+evaluator_hypmax_0.getValues((modelStruct.modelPar_ALPHAII11*delTemp),(-ALPHAII1_i),1.0E-6));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((IGT_i*evaluator_lln_0.getValues(TRatio)));
d_igtemp_dX = evaluator_lexp_1.getDerivs((IGT_i*evaluator_lln_0.getValues(TRatio)),(IGT_i*evaluator_lln_0.getDerivs(TRatio,d_TRatio_dX)+d_IGT_i_dX*evaluator_lln_0.getValues(TRatio)));
igtemp = evaluator_lexp_1.getValues((IGT_i*evaluator_lln_0.getValues(TRatio)));
}
d_igsd_mult_dX = (igsd_mult0*d_igtemp_dX+d_igsd_mult0_dX*igtemp);
igsd_mult = (igsd_mult0*igtemp);
if ((modelStruct.modelPar_BULKMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3);
d_CJS_t_dX = (modelStruct.modelPar_CJS*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJ*d_delTemp_dX+modelStruct.d_modelPar_TCJ_dX*delTemp),0.0)+modelStruct.d_modelPar_CJS_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
CJS_t = (modelStruct.modelPar_CJS*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3);
d_CJD_t_dX = (modelStruct.modelPar_CJD*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJ*d_delTemp_dX+modelStruct.d_modelPar_TCJ_dX*delTemp),0.0)+modelStruct.d_modelPar_CJD_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
CJD_t = (modelStruct.modelPar_CJD*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJ*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3);
d_CJSWS_t_dX = (modelStruct.modelPar_CJSWS*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSW*d_delTemp_dX+modelStruct.d_modelPar_TCJSW_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWS_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
CJSWS_t = (modelStruct.modelPar_CJSWS*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3);
d_CJSWD_t_dX = (modelStruct.modelPar_CJSWD*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSW*d_delTemp_dX+modelStruct.d_modelPar_TCJSW_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWD_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
CJSWD_t = (modelStruct.modelPar_CJSWD*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSW*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3);
d_CJSWGS_t_dX = (modelStruct.modelPar_CJSWGS*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSWG*d_delTemp_dX+modelStruct.d_modelPar_TCJSWG_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWGS_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
CJSWGS_t = (modelStruct.modelPar_CJSWGS*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3);
d_CJSWGD_t_dX = (modelStruct.modelPar_CJSWGD*evaluator_hypsmooth_0.getDerivs(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3,(modelStruct.modelPar_TCJSWG*d_delTemp_dX+modelStruct.d_modelPar_TCJSWG_dX*delTemp),0.0)+modelStruct.d_modelPar_CJSWGD_dX*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
CJSWGD_t = (modelStruct.modelPar_CJSWGD*evaluator_hypsmooth_0.getValues(((1.0+(modelStruct.modelPar_TCJSWG*delTemp))-1.0E-6),1.0E-3));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBS-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3);
d_PBS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBS-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBS_dX-(modelStruct.modelPar_TPB*d_delTemp_dX+modelStruct.d_modelPar_TPB_dX*delTemp)),0.0);
PBS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBS-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBD-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3);
d_PBD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBD-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBD_dX-(modelStruct.modelPar_TPB*d_delTemp_dX+modelStruct.d_modelPar_TPB_dX*delTemp)),0.0);
PBD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBD-(modelStruct.modelPar_TPB*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWS-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3);
d_PBSWS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWS-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWS_dX-(modelStruct.modelPar_TPBSW*d_delTemp_dX+modelStruct.d_modelPar_TPBSW_dX*delTemp)),0.0);
PBSWS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWS-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWD-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3);
d_PBSWD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWD-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWD_dX-(modelStruct.modelPar_TPBSW*d_delTemp_dX+modelStruct.d_modelPar_TPBSW_dX*delTemp)),0.0);
PBSWD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWD-(modelStruct.modelPar_TPBSW*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWGS-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3);
d_PBSWGS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWGS-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWGS_dX-(modelStruct.modelPar_TPBSWG*d_delTemp_dX+modelStruct.d_modelPar_TPBSWG_dX*delTemp)),0.0);
PBSWGS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWGS-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_PBSWGD-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3);
d_PBSWGD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_PBSWGD-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3,(modelStruct.d_modelPar_PBSWGD_dX-(modelStruct.modelPar_TPBSWG*d_delTemp_dX+modelStruct.d_modelPar_TPBSWG_dX*delTemp)),0.0);
PBSWGD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_PBSWGD-(modelStruct.modelPar_TPBSWG*delTemp))-0.01),1.0E-3)+0.01);
}
d_T0_dX = (((Vtm0*d_Eg0_dX-Eg0*d_Vtm0_dX)/Vtm0/Vtm0)-((Vtm*d_Eg_dX-Eg*d_Vtm_dX)/Vtm/Vtm));
T0 = ((Eg0/Vtm0)-(Eg/Vtm));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(TRatio);
d_T1_dX = evaluator_lln_0.getDerivs(TRatio,d_TRatio_dX);
T1 = evaluator_lln_0.getValues(TRatio);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0+(modelStruct.modelPar_XTIS*T1))/modelStruct.modelPar_NJS));
d_T3_dX = evaluator_lexp_0.getDerivs(((T0+(modelStruct.modelPar_XTIS*T1))/modelStruct.modelPar_NJS),((modelStruct.modelPar_NJS*(d_T0_dX+(modelStruct.modelPar_XTIS*d_T1_dX+modelStruct.d_modelPar_XTIS_dX*T1))-(T0+(modelStruct.modelPar_XTIS*T1))*modelStruct.d_modelPar_NJS_dX)/modelStruct.modelPar_NJS/modelStruct.modelPar_NJS));
T3 = evaluator_lexp_0.getValues(((T0+(modelStruct.modelPar_XTIS*T1))/modelStruct.modelPar_NJS));
}
d_JSS_t_dX = (modelStruct.modelPar_JSS*d_T3_dX+modelStruct.d_modelPar_JSS_dX*T3);
JSS_t = (modelStruct.modelPar_JSS*T3);
d_JSWS_t_dX = (modelStruct.modelPar_JSWS*d_T3_dX+modelStruct.d_modelPar_JSWS_dX*T3);
JSWS_t = (modelStruct.modelPar_JSWS*T3);
d_JSWGS_t_dX = (modelStruct.modelPar_JSWGS*d_T3_dX+modelStruct.d_modelPar_JSWGS_dX*T3);
JSWGS_t = (modelStruct.modelPar_JSWGS*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0+(modelStruct.modelPar_XTID*T1))/modelStruct.modelPar_NJD));
d_T3_dX = evaluator_lexp_0.getDerivs(((T0+(modelStruct.modelPar_XTID*T1))/modelStruct.modelPar_NJD),((modelStruct.modelPar_NJD*(d_T0_dX+(modelStruct.modelPar_XTID*d_T1_dX+modelStruct.d_modelPar_XTID_dX*T1))-(T0+(modelStruct.modelPar_XTID*T1))*modelStruct.d_modelPar_NJD_dX)/modelStruct.modelPar_NJD/modelStruct.modelPar_NJD));
T3 = evaluator_lexp_0.getValues(((T0+(modelStruct.modelPar_XTID*T1))/modelStruct.modelPar_NJD));
}
d_JSD_t_dX = (modelStruct.modelPar_JSD*d_T3_dX+modelStruct.d_modelPar_JSD_dX*T3);
JSD_t = (modelStruct.modelPar_JSD*T3);
d_JSWD_t_dX = (modelStruct.modelPar_JSWD*d_T3_dX+modelStruct.d_modelPar_JSWD_dX*T3);
JSWD_t = (modelStruct.modelPar_JSWD*T3);
d_JSWGD_t_dX = (modelStruct.modelPar_JSWGD*d_T3_dX+modelStruct.d_modelPar_JSWGD_dX*T3);
JSWGD_t = (modelStruct.modelPar_JSWGD*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1))/Vtm));
d_JTSS_t_dX = (modelStruct.modelPar_JTSS*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSS)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSS_dX+d_Eg0_dX*modelStruct.modelPar_XTSS)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSS_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1))/Vtm)));
JTSS_t = (modelStruct.modelPar_JTSS*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSS)*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1))/Vtm));
d_JTSD_t_dX = (modelStruct.modelPar_JTSD*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSD)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSD_dX+d_Eg0_dX*modelStruct.modelPar_XTSD)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSD_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1))/Vtm)));
JTSD_t = (modelStruct.modelPar_JTSD*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSD)*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1))/Vtm));
d_JTSSWS_t_dX = (modelStruct.modelPar_JTSSWS*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWS)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWS_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWS)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSSWS_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1))/Vtm)));
JTSSWS_t = (modelStruct.modelPar_JTSSWS*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWS)*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1))/Vtm));
d_JTSSWD_t_dX = (modelStruct.modelPar_JTSSWD*evaluator_lexp_0.getDerivs((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWD)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWD_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWD)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+modelStruct.d_modelPar_JTSSWD_dX*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1))/Vtm)));
JTSSWD_t = (modelStruct.modelPar_JTSSWD*evaluator_lexp_0.getValues((((Eg0*modelStruct.modelPar_XTSSWD)*(TRatio-1))/Vtm)));
}
{
double value_sqrt_0 = sqrt((modelStruct.modelPar_JTWEFF/Weff0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_JTSSWGS_t_dX = ((modelStruct.modelPar_JTSSWGS*(value_sqrt_0+1.0))*evaluator_lexp_1.getDerivs((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWGS)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWGS_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWGS)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+(modelStruct.modelPar_JTSSWGS*deriv_sqrt_0_d0*(((Weff0*modelStruct.d_modelPar_JTWEFF_dX-modelStruct.modelPar_JTWEFF*d_Weff0_dX)/Weff0/Weff0))+modelStruct.d_modelPar_JTSSWGS_dX*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm)));
JTSSWGS_t = ((modelStruct.modelPar_JTSSWGS*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGS)*(TRatio-1))/Vtm)));
}
{
double value_sqrt_0 = sqrt((modelStruct.modelPar_JTWEFF/Weff0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_JTSSWGD_t_dX = ((modelStruct.modelPar_JTSSWGD*(value_sqrt_0+1.0))*evaluator_lexp_1.getDerivs((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm),((Vtm*((Eg0*modelStruct.modelPar_XTSSWGD)*d_TRatio_dX+(Eg0*modelStruct.d_modelPar_XTSSWGD_dX+d_Eg0_dX*modelStruct.modelPar_XTSSWGD)*(TRatio-1))-((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))*d_Vtm_dX)/Vtm/Vtm))+(modelStruct.modelPar_JTSSWGD*deriv_sqrt_0_d0*(((Weff0*modelStruct.d_modelPar_JTWEFF_dX-modelStruct.modelPar_JTWEFF*d_Weff0_dX)/Weff0/Weff0))+modelStruct.d_modelPar_JTSSWGD_dX*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm)));
JTSSWGD_t = ((modelStruct.modelPar_JTSSWGD*(value_sqrt_0+1.0))*evaluator_lexp_1.getValues((((Eg0*modelStruct.modelPar_XTSSWGD)*(TRatio-1))/Vtm)));
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTS*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTS_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTS*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTS*(modelStruct.modelPar_TNJTS*d_TRatio_dX+modelStruct.d_modelPar_TNJTS_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTS_dX*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0)))),0.0);
NJTS_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTS*(1.0+(modelStruct.modelPar_TNJTS*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSD*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSD*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSD*(modelStruct.modelPar_TNJTSD*d_TRatio_dX+modelStruct.d_modelPar_TNJTSD_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSD_dX*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0)))),0.0);
NJTSD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSD*(1.0+(modelStruct.modelPar_TNJTSD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSW*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSW_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSW*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSW*(modelStruct.modelPar_TNJTSSW*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSW_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSW_dX*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0)))),0.0);
NJTSSW_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSW*(1.0+(modelStruct.modelPar_TNJTSSW*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSWD*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSWD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSWD*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSWD*(modelStruct.modelPar_TNJTSSWD*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSWD_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSWD_dX*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0)))),0.0);
NJTSSWD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSWD*(1.0+(modelStruct.modelPar_TNJTSSWD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSWG*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSWG_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSWG*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSWG*(modelStruct.modelPar_TNJTSSWG*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSWG_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSWG_dX*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0)))),0.0);
NJTSSWG_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSWG*(1.0+(modelStruct.modelPar_TNJTSSWG*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_NJTSSWGD*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0E-3);
d_NJTSSWGD_t_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_NJTSSWGD*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0E-3,(modelStruct.modelPar_NJTSSWGD*(modelStruct.modelPar_TNJTSSWGD*d_TRatio_dX+modelStruct.d_modelPar_TNJTSSWGD_dX*(TRatio-1.0))+modelStruct.d_modelPar_NJTSSWGD_dX*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0)))),0.0);
NJTSSWGD_t = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_NJTSSWGD*(1.0+(modelStruct.modelPar_TNJTSSWGD*(TRatio-1.0))))-0.01),1.0E-3)+0.01);
}
}
d_beta0_dX = ((Leff*((u0*cox)*d_Weff0_dX+(u0*d_cox_dX+d_u0_dX*cox)*Weff0)-((u0*cox)*Weff0)*d_Leff_dX)/Leff/Leff);
beta0 = (((u0*cox)*Weff0)/Leff);
if ((modelStruct.modelPar_NGATE>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((modelStruct.modelPar_NGATE/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((modelStruct.modelPar_NGATE/ni)))),1.0E-4);
AnalogFunctions::llnEvaluator evaluator_lln_2((modelStruct.modelPar_NSD/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_3(((0.5*Eg)-(Vtm*evaluator_lln_2.getValues((modelStruct.modelPar_NSD/ni)))),1.0E-4);
d_vfbsd_dX = devsign*(evaluator_hypsmooth_1.getDerivs(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((modelStruct.modelPar_NGATE/ni)))),1.0E-4,(0.5*d_Eg_dX-(Vtm*evaluator_lln_0.getDerivs((modelStruct.modelPar_NGATE/ni),((ni*modelStruct.d_modelPar_NGATE_dX-modelStruct.modelPar_NGATE*d_ni_dX)/ni/ni))+d_Vtm_dX*evaluator_lln_0.getValues((modelStruct.modelPar_NGATE/ni)))),0.0)-(0.5*d_Eg_dX-devsign*(0.5*d_Eg_dX-evaluator_hypsmooth_3.getDerivs(((0.5*Eg)-(Vtm*evaluator_lln_2.getValues((modelStruct.modelPar_NSD/ni)))),1.0E-4,(0.5*d_Eg_dX-(Vtm*evaluator_lln_2.getDerivs((modelStruct.modelPar_NSD/ni),((ni*modelStruct.d_modelPar_NSD_dX-modelStruct.modelPar_NSD*d_ni_dX)/ni/ni))+d_Vtm_dX*evaluator_lln_2.getValues((modelStruct.modelPar_NSD/ni)))),0.0))));
vfbsd = (devsign*(evaluator_hypsmooth_1.getValues(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((modelStruct.modelPar_NGATE/ni)))),1.0E-4)-((0.5*Eg)-(devsign*((0.5*Eg)-evaluator_hypsmooth_3.getValues(((0.5*Eg)-(Vtm*evaluator_lln_2.getValues((modelStruct.modelPar_NSD/ni)))),1.0E-4))))));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((modelStruct.modelPar_NSD/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((modelStruct.modelPar_NSD/ni)))),1.0E-4);
d_vfbsd_dX = devsign*(d_PHIG_i_dX-((modelStruct.d_modelPar_EASUB_dX+0.5*d_Eg_dX)-devsign*(0.5*d_Eg_dX-evaluator_hypsmooth_1.getDerivs(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((modelStruct.modelPar_NSD/ni)))),1.0E-4,(0.5*d_Eg_dX-(Vtm*evaluator_lln_0.getDerivs((modelStruct.modelPar_NSD/ni),((ni*modelStruct.d_modelPar_NSD_dX-modelStruct.modelPar_NSD*d_ni_dX)/ni/ni))+d_Vtm_dX*evaluator_lln_0.getValues((modelStruct.modelPar_NSD/ni)))),0.0))));
vfbsd = (devsign*(PHIG_i-((modelStruct.modelPar_EASUB+(0.5*Eg))-(devsign*((0.5*Eg)-evaluator_hypsmooth_1.getValues(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((modelStruct.modelPar_NSD/ni)))),1.0E-4))))));
}
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((nbody/ni));
d_phib_dX = (Vtm*evaluator_lln_0.getDerivs((nbody/ni),((ni*d_nbody_dX-nbody*d_ni_dX)/ni/ni))+d_Vtm_dX*evaluator_lln_0.getValues((nbody/ni)));
phib = (Vtm*evaluator_lln_0.getValues((nbody/ni)));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((nbody*modelStruct.modelPar_NSD)/(ni*ni)));
d_vbi_dX = (Vtm*evaluator_lln_0.getDerivs(((nbody*modelStruct.modelPar_NSD)/(ni*ni)),(((ni*ni)*(nbody*modelStruct.d_modelPar_NSD_dX+d_nbody_dX*modelStruct.modelPar_NSD)-(nbody*modelStruct.modelPar_NSD)*(ni*d_ni_dX+d_ni_dX*ni))/(ni*ni)/(ni*ni)))+d_Vtm_dX*evaluator_lln_0.getValues(((nbody*modelStruct.modelPar_NSD)/(ni*ni))));
vbi = (Vtm*evaluator_lln_0.getValues(((nbody*modelStruct.modelPar_NSD)/(ni*ni))));
}
if ((NGATE_i>0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((NGATE_i/ni));
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_1(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((NGATE_i/ni)))),1.0E-4);
d_deltaPhi_dX = evaluator_hypsmooth_1.getDerivs(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((NGATE_i/ni)))),1.0E-4,(0.5*d_Eg_dX-(Vtm*evaluator_lln_0.getDerivs((NGATE_i/ni),((ni*d_NGATE_i_dX-NGATE_i*d_ni_dX)/ni/ni))+d_Vtm_dX*evaluator_lln_0.getValues((NGATE_i/ni)))),0.0);
deltaPhi = evaluator_hypsmooth_1.getValues(((0.5*Eg)-(Vtm*evaluator_lln_0.getValues((NGATE_i/ni)))),1.0E-4);
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_vpoly0_dX = ((((2.0*cox)*cox)*((1.60219e-19*NGATE_i)*d_epssub_dX+1.60219e-19*d_NGATE_i_dX*epssub)-((1.60219e-19*NGATE_i)*epssub)*((2.0*cox)*d_cox_dX+2.0*d_cox_dX*cox))/((2.0*cox)*cox)/((2.0*cox)*cox));
vpoly0 = (((1.60219e-19*NGATE_i)*epssub)/((2.0*cox)*cox));
d_cpoly_dX = (-4.0*d_vpoly0_dX/(4.0*vpoly0)/(4.0*vpoly0));
cpoly = (1.0/(4.0*vpoly0));
}
else
{
d_T0_dX = ((R*(d_R_dX+modelStruct.d_modelPar_EOT_dX)-(R+modelStruct.modelPar_EOT)*d_R_dX)/R/R);
T0 = ((R+modelStruct.modelPar_EOT)/R);
d_vpoly0_dX = ((((2.0*cox)*cox)*((((1.60219e-19*NGATE_i)*epssub)*T0)*d_T0_dX+(((1.60219e-19*NGATE_i)*epssub)*d_T0_dX+((1.60219e-19*NGATE_i)*d_epssub_dX+1.60219e-19*d_NGATE_i_dX*epssub)*T0)*T0)-((((1.60219e-19*NGATE_i)*epssub)*T0)*T0)*((2.0*cox)*d_cox_dX+2.0*d_cox_dX*cox))/((2.0*cox)*cox)/((2.0*cox)*cox));
vpoly0 = (((((1.60219e-19*NGATE_i)*epssub)*T0)*T0)/((2.0*cox)*cox));
d_cpoly_dX = (-4.0*d_vpoly0_dX/(4.0*vpoly0)/(4.0*vpoly0));
cpoly = (1.0/(4.0*vpoly0));
}
d_kpoly_dX = ((2.0*cpoly)*d_qbs_dX+2.0*d_cpoly_dX*qbs);
kpoly = (1.0+((2.0*cpoly)*qbs));
}
else
{
d_deltaPhi_dX = devsign*(d_PHIG_i_dX-(modelStruct.d_modelPar_EASUB_dX+((modelStruct.modelPar_DEVTYPE==1)?0.0:d_Eg_dX)));
deltaPhi = (devsign*(PHIG_i-(modelStruct.modelPar_EASUB+((modelStruct.modelPar_DEVTYPE==1)?0:Eg))));
d_cpoly_dX = 0.0;
cpoly = 0.0;
d_vpoly0_dX = 0.0;
vpoly0 = 0.0;
d_kpoly_dX = 0.0;
kpoly = 0.0;
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_r1_dX = (((cox*instanceStruct.instancePar_TFIN)*2.0*d_epssub_dX-(2.0*epssub)*(cox*instanceStruct.d_instancePar_TFIN_dX+d_cox_dX*instanceStruct.instancePar_TFIN))/(cox*instanceStruct.instancePar_TFIN)/(cox*instanceStruct.instancePar_TFIN));
r1 = ((2.0*epssub)/(cox*instanceStruct.instancePar_TFIN));
g0max = 1.57079;
g0min = 1e-37;
d_Inv_r1pi_dX = (-d_r1_dX*3.14159265358979323846/(r1*3.14159265358979323846)/(r1*3.14159265358979323846));
Inv_r1pi = (1.0/(r1*3.14159265358979323846));
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_r1_acc_dX = (((cox_acc*instanceStruct.instancePar_TFIN)*2.0*d_epssub_dX-(2.0*epssub)*(cox_acc*instanceStruct.d_instancePar_TFIN_dX+d_cox_acc_dX*instanceStruct.instancePar_TFIN))/(cox_acc*instanceStruct.instancePar_TFIN)/(cox_acc*instanceStruct.instancePar_TFIN));
r1_acc = ((2.0*epssub)/(cox_acc*instanceStruct.instancePar_TFIN));
d_Inv_r1pi_acc_dX = (-d_r1_acc_dX*3.14159265358979323846/(r1_acc*3.14159265358979323846)/(r1_acc*3.14159265358979323846));
Inv_r1pi_acc = (1.0/(r1_acc*3.14159265358979323846));
}
}
else
{
g0max = 700;
g0min = 1e-37;
}
if ((NGATE_i>0))
{
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_r2_dX = (((((1.60219e-19*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_TFIN)*NGATE_i)*((4.0*Vtm)*d_epssub_dX+4.0*d_Vtm_dX*epssub)-((4.0*Vtm)*epssub)*(((1.60219e-19*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_TFIN)*d_NGATE_i_dX+((1.60219e-19*instanceStruct.instancePar_TFIN)*instanceStruct.d_instancePar_TFIN_dX+1.60219e-19*instanceStruct.d_instancePar_TFIN_dX*instanceStruct.instancePar_TFIN)*NGATE_i))/(((1.60219e-19*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_TFIN)*NGATE_i)/(((1.60219e-19*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_TFIN)*NGATE_i));
r2 = (((4.0*Vtm)*epssub)/(((1.60219e-19*instanceStruct.instancePar_TFIN)*instanceStruct.instancePar_TFIN)*NGATE_i));
}
else
{
d_r2_dX = ((((2.0*cpoly)*r1)*r1)*d_Vtm_dX+(((2.0*cpoly)*r1)*d_r1_dX+((2.0*cpoly)*d_r1_dX+2.0*d_cpoly_dX*r1)*r1)*Vtm);
r2 = ((((2.0*cpoly)*r1)*r1)*Vtm);
}
}
else
{
d_r2_dX = 0.0;
r2 = 0.0;
}
d_eta_mu_dX = 0.5*d_ETAMOB_t_dX;
eta_mu = (0.5*ETAMOB_t);
eta_mu_cv = 0.5;
if ((modelStruct.modelPar_DEVTYPE!=1))
{
d_eta_mu_dX = (1.0/3.0)*d_ETAMOB_t_dX;
eta_mu = ((1.0/3.0)*ETAMOB_t);
eta_mu_cv = (1.0/3.0);
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
d_Isbs_dX = (((instanceStruct.instancePar_ASEJ*d_JSS_t_dX+instanceStruct.d_instancePar_ASEJ_dX*JSS_t)+(instanceStruct.instancePar_PSEJ*d_JSWS_t_dX+instanceStruct.d_instancePar_PSEJ_dX*JSWS_t))+((Weff0*NFINtotal)*d_JSWGS_t_dX+(Weff0*d_NFINtotal_dX+d_Weff0_dX*NFINtotal)*JSWGS_t));
Isbs = (((instanceStruct.instancePar_ASEJ*JSS_t)+(instanceStruct.instancePar_PSEJ*JSWS_t))+((Weff0*NFINtotal)*JSWGS_t));
if ((Isbs>0.0))
{
d_Nvtms_dX = (Vtm*modelStruct.d_modelPar_NJS_dX+d_Vtm_dX*modelStruct.modelPar_NJS);
Nvtms = (Vtm*modelStruct.modelPar_NJS);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-modelStruct.modelPar_BVS)/Nvtms));
d_XExpBVS_dX = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVS)/Nvtms))*modelStruct.d_modelPar_XJBVS_dX+evaluator_lexp_0.getDerivs(((-modelStruct.modelPar_BVS)/Nvtms),((Nvtms*(-modelStruct.d_modelPar_BVS_dX)-(-modelStruct.modelPar_BVS)*d_Nvtms_dX)/Nvtms/Nvtms))*modelStruct.modelPar_XJBVS);
XExpBVS = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVS)/Nvtms))*modelStruct.modelPar_XJBVS);
}
{
double value_max_0 = std::max((modelStruct.modelPar_IJTHSFWD/Isbs),static_cast<double>(10.0));
double  deriv_max_0_d0 = (((modelStruct.modelPar_IJTHSFWD/Isbs)>=10.0)?1.0:0.0);
d_T2_dX = (deriv_max_0_d0*(((Isbs*modelStruct.d_modelPar_IJTHSFWD_dX-modelStruct.modelPar_IJTHSFWD*d_Isbs_dX)/Isbs/Isbs)));
T2 = value_max_0;
}
d_Tb_dX = (d_T2_dX-d_XExpBVS_dX);
Tb = ((1.0+T2)-XExpBVS);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVS)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_VjsmFwd_dX = (Nvtms*evaluator_lln_1.getDerivs((0.5*(Tb+value_sqrt_0)),0.5*(d_Tb_dX+deriv_sqrt_0_d0*(((Tb*d_Tb_dX+d_Tb_dX*Tb)+4*d_XExpBVS_dX))))+d_Nvtms_dX*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
VjsmFwd = (Nvtms*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjsmFwd/Nvtms));
d_T0_dX = evaluator_lexp_0.getDerivs((VjsmFwd/Nvtms),((Nvtms*d_VjsmFwd_dX-VjsmFwd*d_Nvtms_dX)/Nvtms/Nvtms));
T0 = evaluator_lexp_0.getValues((VjsmFwd/Nvtms));
}
d_IVjsmFwd_dX = (Isbs*((d_T0_dX-((T0*d_XExpBVS_dX-XExpBVS*d_T0_dX)/T0/T0))+d_XExpBVS_dX)+d_Isbs_dX*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
IVjsmFwd = (Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
d_SslpFwd_dX = ((Nvtms*(Isbs*(d_T0_dX+((T0*d_XExpBVS_dX-XExpBVS*d_T0_dX)/T0/T0))+d_Isbs_dX*(T0+(XExpBVS/T0)))-(Isbs*(T0+(XExpBVS/T0)))*d_Nvtms_dX)/Nvtms/Nvtms);
SslpFwd = ((Isbs*(T0+(XExpBVS/T0)))/Nvtms);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_IJTHSREV/Isbs)-10.0),1.0E-3);
d_T2_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_IJTHSREV/Isbs)-10.0),1.0E-3,((Isbs*modelStruct.d_modelPar_IJTHSREV_dX-modelStruct.modelPar_IJTHSREV*d_Isbs_dX)/Isbs/Isbs),0.0);
T2 = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_IJTHSREV/Isbs)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((T2-1.0)/modelStruct.modelPar_XJBVS));
d_VjsmRev_dX = ((-modelStruct.d_modelPar_BVS_dX)-(Nvtms*evaluator_lln_0.getDerivs(((T2-1.0)/modelStruct.modelPar_XJBVS),((modelStruct.modelPar_XJBVS*d_T2_dX-(T2-1.0)*modelStruct.d_modelPar_XJBVS_dX)/modelStruct.modelPar_XJBVS/modelStruct.modelPar_XJBVS))+d_Nvtms_dX*evaluator_lln_0.getValues(((T2-1.0)/modelStruct.modelPar_XJBVS))));
VjsmRev = ((-modelStruct.modelPar_BVS)-(Nvtms*evaluator_lln_0.getValues(((T2-1.0)/modelStruct.modelPar_XJBVS))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms));
d_T1_dX = (modelStruct.modelPar_XJBVS*evaluator_lexp_0.getDerivs(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms),((Nvtms*(-(modelStruct.d_modelPar_BVS_dX+d_VjsmRev_dX))-(-(modelStruct.modelPar_BVS+VjsmRev))*d_Nvtms_dX)/Nvtms/Nvtms))+modelStruct.d_modelPar_XJBVS_dX*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms)));
T1 = (modelStruct.modelPar_XJBVS*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVS+VjsmRev))/Nvtms)));
}
d_IVjsmRev_dX = (Isbs*d_T1_dX+d_Isbs_dX*(1.0+T1));
IVjsmRev = (Isbs*(1.0+T1));
d_SslpRev_dX = ((Nvtms*((-Isbs)*d_T1_dX+(-d_Isbs_dX)*T1)-((-Isbs)*T1)*d_Nvtms_dX)/Nvtms/Nvtms);
SslpRev = (((-Isbs)*T1)/Nvtms);
}
d_Isbd_dX = (((instanceStruct.instancePar_ADEJ*d_JSD_t_dX+instanceStruct.d_instancePar_ADEJ_dX*JSD_t)+(instanceStruct.instancePar_PDEJ*d_JSWD_t_dX+instanceStruct.d_instancePar_PDEJ_dX*JSWD_t))+((Weff0*NFINtotal)*d_JSWGD_t_dX+(Weff0*d_NFINtotal_dX+d_Weff0_dX*NFINtotal)*JSWGD_t));
Isbd = (((instanceStruct.instancePar_ADEJ*JSD_t)+(instanceStruct.instancePar_PDEJ*JSWD_t))+((Weff0*NFINtotal)*JSWGD_t));
if ((Isbd>0.0))
{
d_Nvtmd_dX = (Vtm*modelStruct.d_modelPar_NJD_dX+d_Vtm_dX*modelStruct.modelPar_NJD);
Nvtmd = (Vtm*modelStruct.modelPar_NJD);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-modelStruct.modelPar_BVD)/Nvtmd));
d_XExpBVD_dX = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVD)/Nvtmd))*modelStruct.d_modelPar_XJBVD_dX+evaluator_lexp_0.getDerivs(((-modelStruct.modelPar_BVD)/Nvtmd),((Nvtmd*(-modelStruct.d_modelPar_BVD_dX)-(-modelStruct.modelPar_BVD)*d_Nvtmd_dX)/Nvtmd/Nvtmd))*modelStruct.modelPar_XJBVD);
XExpBVD = (evaluator_lexp_0.getValues(((-modelStruct.modelPar_BVD)/Nvtmd))*modelStruct.modelPar_XJBVD);
}
{
double value_max_0 = std::max((modelStruct.modelPar_IJTHDFWD/Isbd),static_cast<double>(10.0));
double  deriv_max_0_d0 = (((modelStruct.modelPar_IJTHDFWD/Isbd)>=10.0)?1.0:0.0);
d_T2_dX = (deriv_max_0_d0*(((Isbd*modelStruct.d_modelPar_IJTHDFWD_dX-modelStruct.modelPar_IJTHDFWD*d_Isbd_dX)/Isbd/Isbd)));
T2 = value_max_0;
}
d_Tb_dX = (d_T2_dX-d_XExpBVD_dX);
Tb = ((1.0+T2)-XExpBVD);
{
double value_sqrt_0 = sqrt(((Tb*Tb)+(4*XExpBVD)));
AnalogFunctions::llnEvaluator evaluator_lln_1((0.5*(Tb+value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_VjdmFwd_dX = (Nvtmd*evaluator_lln_1.getDerivs((0.5*(Tb+value_sqrt_0)),0.5*(d_Tb_dX+deriv_sqrt_0_d0*(((Tb*d_Tb_dX+d_Tb_dX*Tb)+4*d_XExpBVD_dX))))+d_Nvtmd_dX*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
VjdmFwd = (Nvtmd*evaluator_lln_1.getValues((0.5*(Tb+value_sqrt_0))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((VjdmFwd/Nvtmd));
d_T0_dX = evaluator_lexp_0.getDerivs((VjdmFwd/Nvtmd),((Nvtmd*d_VjdmFwd_dX-VjdmFwd*d_Nvtmd_dX)/Nvtmd/Nvtmd));
T0 = evaluator_lexp_0.getValues((VjdmFwd/Nvtmd));
}
d_IVjdmFwd_dX = (Isbd*((d_T0_dX-((T0*d_XExpBVD_dX-XExpBVD*d_T0_dX)/T0/T0))+d_XExpBVD_dX)+d_Isbd_dX*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
IVjdmFwd = (Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
d_DslpFwd_dX = ((Nvtmd*(Isbd*(d_T0_dX+((T0*d_XExpBVD_dX-XExpBVD*d_T0_dX)/T0/T0))+d_Isbd_dX*(T0+(XExpBVD/T0)))-(Isbd*(T0+(XExpBVD/T0)))*d_Nvtmd_dX)/Nvtmd/Nvtmd);
DslpFwd = ((Isbd*(T0+(XExpBVD/T0)))/Nvtmd);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(((modelStruct.modelPar_IJTHDREV/Isbd)-10.0),1.0E-3);
d_T2_dX = evaluator_hypsmooth_0.getDerivs(((modelStruct.modelPar_IJTHDREV/Isbd)-10.0),1.0E-3,((Isbd*modelStruct.d_modelPar_IJTHDREV_dX-modelStruct.modelPar_IJTHDREV*d_Isbd_dX)/Isbd/Isbd),0.0);
T2 = (evaluator_hypsmooth_0.getValues(((modelStruct.modelPar_IJTHDREV/Isbd)-10.0),1.0E-3)+10.0);
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((T2-1.0)/modelStruct.modelPar_XJBVD));
d_VjdmRev_dX = ((-modelStruct.d_modelPar_BVD_dX)-(Nvtmd*evaluator_lln_0.getDerivs(((T2-1.0)/modelStruct.modelPar_XJBVD),((modelStruct.modelPar_XJBVD*d_T2_dX-(T2-1.0)*modelStruct.d_modelPar_XJBVD_dX)/modelStruct.modelPar_XJBVD/modelStruct.modelPar_XJBVD))+d_Nvtmd_dX*evaluator_lln_0.getValues(((T2-1.0)/modelStruct.modelPar_XJBVD))));
VjdmRev = ((-modelStruct.modelPar_BVD)-(Nvtmd*evaluator_lln_0.getValues(((T2-1.0)/modelStruct.modelPar_XJBVD))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd));
d_T1_dX = (modelStruct.modelPar_XJBVD*evaluator_lexp_0.getDerivs(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd),((Nvtmd*(-(modelStruct.d_modelPar_BVD_dX+d_VjdmRev_dX))-(-(modelStruct.modelPar_BVD+VjdmRev))*d_Nvtmd_dX)/Nvtmd/Nvtmd))+modelStruct.d_modelPar_XJBVD_dX*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd)));
T1 = (modelStruct.modelPar_XJBVD*evaluator_lexp_0.getValues(((-(modelStruct.modelPar_BVD+VjdmRev))/Nvtmd)));
}
d_IVjdmRev_dX = (Isbd*d_T1_dX+d_Isbd_dX*(1.0+T1));
IVjdmRev = (Isbd*(1.0+T1));
d_DslpRev_dX = ((Nvtmd*((-Isbd)*d_T1_dX+(-d_Isbd_dX)*T1)-((-Isbd)*T1)*d_Nvtmd_dX)/Nvtmd/Nvtmd);
DslpRev = (((-Isbd)*T1)/Nvtmd);
}
d_Czbs_dX = (CJS_t*instanceStruct.d_instancePar_ASEJ_dX+d_CJS_t_dX*instanceStruct.instancePar_ASEJ);
Czbs = (CJS_t*instanceStruct.instancePar_ASEJ);
d_Czbssw_dX = (CJSWS_t*instanceStruct.d_instancePar_PSEJ_dX+d_CJSWS_t_dX*instanceStruct.instancePar_PSEJ);
Czbssw = (CJSWS_t*instanceStruct.instancePar_PSEJ);
d_Czbsswg_dX = ((CJSWGS_t*Weff0)*d_NFINtotal_dX+(CJSWGS_t*d_Weff0_dX+d_CJSWGS_t_dX*Weff0)*NFINtotal);
Czbsswg = ((CJSWGS_t*Weff0)*NFINtotal);
d_Czbd_dX = (CJD_t*instanceStruct.d_instancePar_ADEJ_dX+d_CJD_t_dX*instanceStruct.instancePar_ADEJ);
Czbd = (CJD_t*instanceStruct.instancePar_ADEJ);
d_Czbdsw_dX = (CJSWD_t*instanceStruct.d_instancePar_PDEJ_dX+d_CJSWD_t_dX*instanceStruct.instancePar_PDEJ);
Czbdsw = (CJSWD_t*instanceStruct.instancePar_PDEJ);
d_Czbdswg_dX = ((CJSWGD_t*Weff0)*d_NFINtotal_dX+(CJSWGD_t*d_Weff0_dX+d_CJSWGD_t_dX*Weff0)*NFINtotal);
Czbdswg = ((CJSWGD_t*Weff0)*NFINtotal);
}
d_T0_dX = ((Eg/Vtm)*d_TRatio_dX+((Vtm*d_Eg_dX-Eg*d_Vtm_dX)/Vtm/Vtm)*(TRatio-1.0));
T0 = ((Eg/Vtm)*(TRatio-1.0));
d_T1_dX = ((NTGEN_i*d_T0_dX-T0*d_NTGEN_i_dX)/NTGEN_i/NTGEN_i);
T1 = (T0/NTGEN_i);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
d_igentemp_dX = evaluator_lexp_0.getDerivs(T1,d_T1_dX);
igentemp = evaluator_lexp_0.getValues(T1);
}
}
// End block CMGTempDepCalc
if ((!initialized))
{
UserInfo(theInstance)  << "Warning: initial_step is not triggered at the first execution of this code.  As a result, bias-independent variables may not be initialized.  Check your simulator for Verilog-A language compatibility." << " " <<  std::endl; 
}
else
{
vgs_noswap = (devsign*(probeVars[admsProbeID_V_g_si]));
vds_noswap = (devsign*(probeVars[admsProbeID_V_di_si]));
vgd_noswap = (devsign*(probeVars[admsProbeID_V_g_di]));
ves_jct = (devsign*(probeVars[admsProbeID_V_e_si]));
ved_jct = (devsign*(probeVars[admsProbeID_V_e_di]));
vge = (devsign*(probeVars[admsProbeID_V_g_e]));
sigvds = 1.0;
if ((vds_noswap<0.0))
{
sigvds = (-1.0);
vgs = (vgs_noswap-vds_noswap);
vds = ((-1.0)*vds_noswap);
vgd = (vgd_noswap+vds_noswap);
ves = ved_jct;
}
else
{
vgs = vgs_noswap;
vds = vds_noswap;
vgd = vgd_noswap;
ves = ves_jct;
}
d_vgsfb_dX = (-d_deltaPhi_dX);
vgsfb = (vgs-deltaPhi);
d_etaiv_dX = 0.0;
etaiv = 0.0;
d_Qes_dX = 0.0;
Qes = 0.0;
d_Qesj_dX = 0.0;
Qesj = 0.0;
d_Qeg_dX = 0.0;
Qeg = 0.0;
d_Qed_dX = 0.0;
Qed = 0.0;
d_Qedj_dX = 0.0;
Qedj = 0.0;
{
double value_sqrt_0 = sqrt(((vds*vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vdsx = (value_sqrt_0-0.1);
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
vesx = (ves-(0.5*(vds-vdsx)));
d_vesmax_dX = 0.95*d_PHIBE_i_dX;
vesmax = (0.95*PHIBE_i);
d_T2_dX = d_vesmax_dX;
T2 = ((vesmax-vesx)-1.0E-3);
{
double value_sqrt_0 = sqrt(((T2*T2)+(0.004*vesmax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_veseff_dX = (d_vesmax_dX-0.5*(d_T2_dX+deriv_sqrt_0_d0*(((T2*d_T2_dX+d_T2_dX*T2)+0.004*d_vesmax_dX))));
veseff = (vesmax-(0.5*(T2+value_sqrt_0)));
}
}
{
double value_tanh_0 = tanh(((0.6*vds_noswap)/Vtm));
double  deriv_tanh_0_d0 = (1.0/cosh(((0.6*vds_noswap)/Vtm))/cosh(((0.6*vds_noswap)/Vtm)));
d_T0_dX = deriv_tanh_0_d0*((-(0.6*vds_noswap)*d_Vtm_dX/Vtm/Vtm));
T0 = value_tanh_0;
}
d_wf_dX = 0.5*d_T0_dX;
wf = (0.5+(0.5*T0));
d_wr_dX = (-d_wf_dX);
wr = (1.0-wf);
if ((modelStruct.modelPar_ASYMMOD!=0))
{
d_CDSCD_a_dX = ((CDSCDR_i*d_wr_dX+d_CDSCDR_i_dX*wr)+(CDSCD_i*d_wf_dX+d_CDSCD_i_dX*wf));
CDSCD_a = ((CDSCDR_i*wr)+(CDSCD_i*wf));
d_ETA0_a_dX = ((ETA0R_t*d_wr_dX+d_ETA0R_t_dX*wr)+(ETA0_t*d_wf_dX+d_ETA0_t_dX*wf));
ETA0_a = ((ETA0R_t*wr)+(ETA0_t*wf));
d_PDIBL1_a_dX = ((PDIBL1R_i*d_wr_dX+d_PDIBL1R_i_dX*wr)+(PDIBL1_i*d_wf_dX+d_PDIBL1_i_dX*wf));
PDIBL1_a = ((PDIBL1R_i*wr)+(PDIBL1_i*wf));
d_MEXP_a_dX = ((MEXPR_t*d_wr_dX+d_MEXPR_t_dX*wr)+(MEXP_t*d_wf_dX+d_MEXP_t_dX*wf));
MEXP_a = ((MEXPR_t*wr)+(MEXP_t*wf));
d_PTWG_a_dX = ((PTWGR_t*d_wr_dX+d_PTWGR_t_dX*wr)+(PTWG_t*d_wf_dX+d_PTWG_t_dX*wf));
PTWG_a = ((PTWGR_t*wr)+(PTWG_t*wf));
d_VSAT1_a_dX = ((VSAT1R_t*d_wr_dX+d_VSAT1R_t_dX*wr)+(VSAT1_t*d_wf_dX+d_VSAT1_t_dX*wf));
VSAT1_a = ((VSAT1R_t*wr)+(VSAT1_t*wf));
d_RSDR_a_dX = ((RSDRR_t*d_wr_dX+d_RSDRR_t_dX*wr)+(RSDR_t*d_wf_dX+d_RSDR_t_dX*wf));
RSDR_a = ((RSDRR_t*wr)+(RSDR_t*wf));
d_RDDR_a_dX = ((RDDRR_t*d_wr_dX+d_RDDRR_t_dX*wr)+(RDDR_t*d_wf_dX+d_RDDR_t_dX*wf));
RDDR_a = ((RDDRR_t*wr)+(RDDR_t*wf));
}
else
{
d_CDSCD_a_dX = d_CDSCD_i_dX;
CDSCD_a = CDSCD_i;
d_ETA0_a_dX = d_ETA0_t_dX;
ETA0_a = ETA0_t;
d_PDIBL1_a_dX = d_PDIBL1_i_dX;
PDIBL1_a = PDIBL1_i;
d_MEXP_a_dX = d_MEXP_t_dX;
MEXP_a = MEXP_t;
d_PTWG_a_dX = d_PTWG_t_dX;
PTWG_a = PTWG_t;
d_VSAT1_a_dX = d_VSAT1_t_dX;
VSAT1_a = VSAT1_t;
d_RSDR_a_dX = d_RSDR_t_dX;
RSDR_a = RSDR_t;
d_RDDR_a_dX = d_RDDR_t_dX;
RDDR_a = RDDR_t;
}
d_inv_MEXP_dX = (-d_MEXP_a_dX/MEXP_a/MEXP_a);
inv_MEXP = (1.0/MEXP_a);
d_phist_dX = (d_phib_dX+d_PHIN_i_dX);
phist = ((0.4+phib)+PHIN_i);
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_T1_dX = ((((2*csi)+cox)*((2*cox)*d_csi_dX+2*d_cox_dX*csi)-((2*cox)*csi)*(2*d_csi_dX+d_cox_dX))/((2*csi)+cox)/((2*csi)+cox));
T1 = (((2*cox)*csi)/((2*csi)+cox));
}
else
{
d_T1_dX = d_cox_dX;
T1 = cox;
}
d_cdsc_dX = (Theta_SW*(d_CDSC_i_dX+d_CDSCD_a_dX*vdsx)+d_Theta_SW_dX*(CDSC_i+(CDSCD_a*vdsx)));
cdsc = (Theta_SW*(CDSC_i+(CDSCD_a*vdsx)));
d_nVtm_dX = ((Vtm*ThetaSS)*((T1*(((TRatio*d_CIT_i_dX-CIT_i*d_TRatio_dX)/TRatio/TRatio)+d_cdsc_dX)-((CIT_i/TRatio)+cdsc)*d_T1_dX)/T1/T1)+(Vtm*d_ThetaSS_dX+d_Vtm_dX*ThetaSS)*(1.0+(((CIT_i/TRatio)+cdsc)/T1)));
nVtm = ((Vtm*ThetaSS)*(1.0+(((CIT_i/TRatio)+cdsc)/T1)));
d_dvth_vtroll_dX = (((-DVT0_i)*Theta_SCE)*(d_vbi_dX-d_phist_dX)+((-DVT0_i)*d_Theta_SCE_dX+(-d_DVT0_i_dX)*Theta_SCE)*(vbi-phist));
dvth_vtroll = (((-DVT0_i)*Theta_SCE)*(vbi-phist));
{
double value_pow_0 = pow(vdsx,modelStruct.modelPar_DVTP1);
double  deriv_pow_0_d0 = ((vdsx == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_DVTP1/vdsx));
double  deriv_pow_0_d1 = (vdsx == 0.0)?0.0:(log(vdsx)*value_pow_0);
d_dvth_dibl_dX = (((-ETA0_a)*d_Theta_DIBL_dX+(-d_ETA0_a_dX)*Theta_DIBL)*vdsx+(modelStruct.modelPar_DVTP0*(deriv_pow_0_d1*(modelStruct.d_modelPar_DVTP1_dX))+modelStruct.d_modelPar_DVTP0_dX*value_pow_0));
dvth_dibl = ((((-ETA0_a)*Theta_DIBL)*vdsx)+(modelStruct.modelPar_DVTP0*value_pow_0));
}
{
double value_sqrt_0 = sqrt(phist);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dvth_rsce_dX = ((K1RSCE_i*Theta_RSCE)*deriv_sqrt_0_d0*(d_phist_dX)+(K1RSCE_i*d_Theta_RSCE_dX+d_K1RSCE_i_dX*Theta_RSCE)*value_sqrt_0);
dvth_rsce = ((K1RSCE_i*Theta_RSCE)*value_sqrt_0);
}
d_dvth_all_dX = ((((d_dvth_vtroll_dX+d_dvth_dibl_dX)+d_dvth_rsce_dX)+d_dvth_temp_dX)+d_DVTSHIFT_i_dX);
dvth_all = ((((dvth_vtroll+dvth_dibl)+dvth_rsce)+dvth_temp)+DVTSHIFT_i);
d_vgsfb_dX = (d_vgsfb_dX-d_dvth_all_dX);
vgsfb = (vgsfb-dvth_all);
if ((modelStruct.modelPar_GEOMOD!=3))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2*epssub)*nVtm)/(1.60219e-19*Nc)));
d_F1_dX = (0.5*evaluator_lln_0.getDerivs((((2*epssub)*nVtm)/(1.60219e-19*Nc)),(((1.60219e-19*Nc)*((2*epssub)*d_nVtm_dX+2*d_epssub_dX*nVtm)-((2*epssub)*nVtm)*1.60219e-19*d_Nc_dX)/(1.60219e-19*Nc)/(1.60219e-19*Nc)))+d_F2_dX);
F1 = ((0.5*evaluator_lln_0.getValues((((2*epssub)*nVtm)/(1.60219e-19*Nc))))+F2);
}
if ((modelStruct.modelPar_COREMOD!=0))
{
d_vgsfb_dX = (d_vgsfb_dX-((cox*(((0.5*1.60219e-19)*nbody)*instanceStruct.d_instancePar_TFIN_dX+(0.5*1.60219e-19)*d_nbody_dX*instanceStruct.instancePar_TFIN)-(((0.5*1.60219e-19)*nbody)*instanceStruct.instancePar_TFIN)*d_cox_dX)/cox/cox));
vgsfb = (vgsfb-((((0.5*1.60219e-19)*nbody)*instanceStruct.instancePar_TFIN)/cox));
}
else
{
d_q0_dX = ((cox*(((5.0*nVtm)*((instanceStruct.instancePar_TFIN*d_epssub_dX-epssub*instanceStruct.d_instancePar_TFIN_dX)/instanceStruct.instancePar_TFIN/instanceStruct.instancePar_TFIN)+5.0*d_nVtm_dX*(epssub/instanceStruct.instancePar_TFIN))+2.0*d_Qbul_dX)-(((5.0*nVtm)*(epssub/instanceStruct.instancePar_TFIN))+(2.0*Qbul))*d_cox_dX)/cox/cox);
q0 = ((((5.0*nVtm)*(epssub/instanceStruct.instancePar_TFIN))+(2.0*Qbul))/cox);
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2*epssub)*Vtm)/(1.60219e-19*Nc)));
d_F1_acc_dX = (0.5*evaluator_lln_0.getDerivs((((2*epssub)*Vtm)/(1.60219e-19*Nc)),(((1.60219e-19*Nc)*((2*epssub)*d_Vtm_dX+2*d_epssub_dX*Vtm)-((2*epssub)*Vtm)*1.60219e-19*d_Nc_dX)/(1.60219e-19*Nc)/(1.60219e-19*Nc)))+d_F2_dX);
F1_acc = ((0.5*evaluator_lln_0.getValues((((2*epssub)*Vtm)/(1.60219e-19*Nc))))+F2);
}
}
d_cdop_dX = 0.0;
cdop = 1.0;
}
else
{
d_q0_dX = ((2.0*nVtm)*d_r1_dX+2.0*d_nVtm_dX*r1);
q0 = ((2.0*nVtm)*r1);
d_T0_dX = ((cox*((1.60219e-19*nbody)*d_R_dX+1.60219e-19*d_nbody_dX*R)-((1.60219e-19*nbody)*R)*d_cox_dX)/cox/cox);
T0 = (((1.60219e-19*nbody)*R)/cox);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((nVtm/T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-T0)/((2.0*r1)*nVtm)));
AnalogFunctions::llnEvaluator evaluator_lln_2((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))));
d_vtdop_dX = (((-nVtm)*evaluator_lln_0.getDerivs((nVtm/T0),((T0*d_nVtm_dX-nVtm*d_T0_dX)/T0/T0))+(-d_nVtm_dX)*evaluator_lln_0.getValues((nVtm/T0)))-(nVtm*evaluator_lln_2.getDerivs((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))),(-evaluator_lexp_1.getDerivs(((-T0)/((2.0*r1)*nVtm)),((((2.0*r1)*nVtm)*(-d_T0_dX)-(-T0)*((2.0*r1)*d_nVtm_dX+2.0*d_r1_dX*nVtm))/((2.0*r1)*nVtm)/((2.0*r1)*nVtm)))))+d_nVtm_dX*evaluator_lln_2.getValues((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))))));
vtdop = (((-nVtm)*evaluator_lln_0.getValues((nVtm/T0)))-(nVtm*evaluator_lln_2.getValues((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1)*nVtm)))))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-vtdop)/nVtm));
d_cdop_dX = ((2.0*r1)*evaluator_lexp_0.getDerivs(((-vtdop)/nVtm),((nVtm*(-d_vtdop_dX)-(-vtdop)*d_nVtm_dX)/nVtm/nVtm))+2.0*d_r1_dX*evaluator_lexp_0.getValues(((-vtdop)/nVtm)));
cdop = ((2.0*r1)*evaluator_lexp_0.getValues(((-vtdop)/nVtm)));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((0.5*T0)/nVtm));
d_vt0_dX = (((0.5*d_T0_dX+((Vtm*((2.0*phib)*d_nVtm_dX+2.0*d_phib_dX*nVtm)-((2.0*phib)*nVtm)*d_Vtm_dX)/Vtm/Vtm))-(nVtm*evaluator_lln_0.getDerivs(((0.5*T0)/nVtm),((nVtm*0.5*d_T0_dX-(0.5*T0)*d_nVtm_dX)/nVtm/nVtm))+d_nVtm_dX*evaluator_lln_0.getValues(((0.5*T0)/nVtm))))+d_vtdop_dX);
vt0 = ((((0.5*T0)+(((2.0*phib)*nVtm)/Vtm))-(nVtm*evaluator_lln_0.getValues(((0.5*T0)/nVtm))))+vtdop);
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_q0_acc_dX = ((2.0*Vtm)*d_r1_acc_dX+2.0*d_Vtm_dX*r1_acc);
q0_acc = ((2.0*Vtm)*r1_acc);
d_T0_dX = ((cox_acc*((1.60219e-19*ni)*d_R_dX+1.60219e-19*d_ni_dX*R)-((1.60219e-19*ni)*R)*d_cox_acc_dX)/cox_acc/cox_acc);
T0 = (((1.60219e-19*ni)*R)/cox_acc);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((Vtm/T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-T0)/((2.0*r1_acc)*Vtm)));
AnalogFunctions::llnEvaluator evaluator_lln_2((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1_acc)*Vtm)))));
d_vtdop_acc_dX = (((-Vtm)*evaluator_lln_0.getDerivs((Vtm/T0),((T0*d_Vtm_dX-Vtm*d_T0_dX)/T0/T0))+(-d_Vtm_dX)*evaluator_lln_0.getValues((Vtm/T0)))-(Vtm*evaluator_lln_2.getDerivs((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1_acc)*Vtm)))),(-evaluator_lexp_1.getDerivs(((-T0)/((2.0*r1_acc)*Vtm)),((((2.0*r1_acc)*Vtm)*(-d_T0_dX)-(-T0)*((2.0*r1_acc)*d_Vtm_dX+2.0*d_r1_acc_dX*Vtm))/((2.0*r1_acc)*Vtm)/((2.0*r1_acc)*Vtm)))))+d_Vtm_dX*evaluator_lln_2.getValues((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1_acc)*Vtm)))))));
vtdop_acc = (((-Vtm)*evaluator_lln_0.getValues((Vtm/T0)))-(Vtm*evaluator_lln_2.getValues((1-evaluator_lexp_1.getValues(((-T0)/((2.0*r1_acc)*Vtm)))))));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-vtdop_acc)/Vtm));
d_cdop_acc_dX = ((2.0*r1_acc)*evaluator_lexp_0.getDerivs(((-vtdop_acc)/Vtm),((Vtm*(-d_vtdop_acc_dX)-(-vtdop_acc)*d_Vtm_dX)/Vtm/Vtm))+2.0*d_r1_acc_dX*evaluator_lexp_0.getValues(((-vtdop_acc)/Vtm)));
cdop_acc = ((2.0*r1_acc)*evaluator_lexp_0.getValues(((-vtdop_acc)/Vtm)));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((0.5*T0)/Vtm));
d_vt0_acc_dX = ((0.5*d_T0_dX-(Vtm*evaluator_lln_0.getDerivs(((0.5*T0)/Vtm),((Vtm*0.5*d_T0_dX-(0.5*T0)*d_Vtm_dX)/Vtm/Vtm))+d_Vtm_dX*evaluator_lln_0.getValues(((0.5*T0)/Vtm))))+d_vtdop_acc_dX);
vt0_acc = (((0.5*T0)-(Vtm*evaluator_lln_0.getValues(((0.5*T0)/Vtm))))+vtdop_acc);
}
}
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.instancePar_TFIN)));
d_T0_dX = (-(d_dvch_qm_dX+(nVtm*evaluator_lln_0.getDerivs((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.instancePar_TFIN)),((((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.instancePar_TFIN)*((2.0*cox)*modelStruct.d_modelPar_Imin_dX+2.0*d_cox_dX*modelStruct.modelPar_Imin)-((2.0*cox)*modelStruct.modelPar_Imin)*((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.d_instancePar_TFIN_dX+(((beta0*nVtm)*1.60219e-19)*d_Nc_dX+(beta0*d_nVtm_dX+d_beta0_dX*nVtm)*1.60219e-19*Nc)*instanceStruct.instancePar_TFIN))/((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.instancePar_TFIN)/((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.instancePar_TFIN)))+d_nVtm_dX*evaluator_lln_0.getValues((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.instancePar_TFIN))))));
T0 = (-(dvch_qm+(nVtm*evaluator_lln_0.getValues((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*instanceStruct.instancePar_TFIN))))));
}
d_T1_dX = ((d_vgsfb_dX+d_T0_dX)+instanceStruct.d_instancePar_DELVTRAND_dX);
T1 = ((vgsfb+T0)+instanceStruct.instancePar_DELVTRAND);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);
d_vgsfbeff_dX = (evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dX,0.0)-d_T0_dX);
vgsfbeff = (evaluator_hypsmooth_0.getValues(T1,1.0E-4)-T0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*ni)*R)));
d_T0_dX = (-(d_dvch_qm_dX+(nVtm*evaluator_lln_0.getDerivs((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*ni)*R)),((((((beta0*nVtm)*1.60219e-19)*ni)*R)*((2.0*cox)*modelStruct.d_modelPar_Imin_dX+2.0*d_cox_dX*modelStruct.modelPar_Imin)-((2.0*cox)*modelStruct.modelPar_Imin)*((((beta0*nVtm)*1.60219e-19)*ni)*d_R_dX+(((beta0*nVtm)*1.60219e-19)*d_ni_dX+(beta0*d_nVtm_dX+d_beta0_dX*nVtm)*1.60219e-19*ni)*R))/((((beta0*nVtm)*1.60219e-19)*ni)*R)/((((beta0*nVtm)*1.60219e-19)*ni)*R)))+d_nVtm_dX*evaluator_lln_0.getValues((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*ni)*R))))));
T0 = (-(dvch_qm+(nVtm*evaluator_lln_0.getValues((((2.0*cox)*modelStruct.modelPar_Imin)/((((beta0*nVtm)*1.60219e-19)*ni)*R))))));
}
d_T1_dX = ((((d_vgsfb_dX+instanceStruct.d_instancePar_DELVTRAND_dX)+d_T0_dX)+0.5*d_Eg_dX)+((Vtm*(phib*d_nVtm_dX+d_phib_dX*nVtm)-(phib*nVtm)*d_Vtm_dX)/Vtm/Vtm));
T1 = ((((vgsfb+instanceStruct.instancePar_DELVTRAND)+T0)+(0.5*Eg))+((phib*nVtm)/Vtm));
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);
d_vgsfbeff_dX = ((evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dX,0.0)-d_T0_dX)-d_vt0_dX);
vgsfbeff = ((evaluator_hypsmooth_0.getValues(T1,1.0E-4)-T0)-vt0);
}
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_T1_dX = ((d_deltaPhi_dX-0.5*d_Eg_dX)+modelStruct.d_modelPar_DELVFBACC_dX);
T1 = ((((-vge)+deltaPhi)-(0.5*Eg))+modelStruct.modelPar_DELVFBACC);
if ((modelStruct.modelPar_GEOMOD!=3))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);
d_vgsfbeff_acc_dX = (evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dX,0.0)-0.5*d_Eg_dX);
vgsfbeff_acc = (evaluator_hypsmooth_0.getValues(T1,1.0E-4)-(0.5*Eg));
}
}
else
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-4);
d_vgsfbeff_acc_dX = (evaluator_hypsmooth_0.getDerivs(T1,1.0E-4,d_T1_dX,0.0)-d_vt0_acc_dX);
vgsfbeff_acc = (evaluator_hypsmooth_0.getValues(T1,1.0E-4)-vt0_acc);
}
}
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_T14_dX = 2.0*d_nVtm_dX;
T14 = (2.0*nVtm);
if ((modelStruct.modelPar_COREMOD==0))
{
d_aab_dX = (((nVtm*nVtm)*d_phibulk_dX-phibulk*(nVtm*d_nVtm_dX+d_nVtm_dX*nVtm))/(nVtm*nVtm)/(nVtm*nVtm));
aab = (phibulk/(nVtm*nVtm));
d_T0_dX = (phibulk*d_aab_dX+d_phibulk_dX*aab);
T0 = (phibulk*aab);
d_T11_dX = (((nVtm*(r1*d_phibulk_dX+d_r1_dX*phibulk)-(r1*phibulk)*d_nVtm_dX)/nVtm/nVtm)+(r2*d_T0_dX+d_r2_dX*T0));
T11 = (((r1*phibulk)/nVtm)+(r2*T0));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((phibulk/(2.0*nVtm)));
d_T12_dX = evaluator_lexp_0.getDerivs((phibulk/(2.0*nVtm)),(((2.0*nVtm)*d_phibulk_dX-phibulk*2.0*d_nVtm_dX)/(2.0*nVtm)/(2.0*nVtm)));
T12 = evaluator_lexp_0.getValues((phibulk/(2.0*nVtm)));
}
d_T13_dX = (T12*d_T12_dX+d_T12_dX*T12);
T13 = (T12*T12);
}
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_F0_dX = ((((2.0*Vtm)*d_vgsfbeff_acc_dX-vgsfbeff_acc*2.0*d_Vtm_dX)/(2.0*Vtm)/(2.0*Vtm))-d_F1_acc_dX);
F0 = ((vgsfbeff_acc/(2.0*Vtm))-F1_acc);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
d_expff_dX = evaluator_lexp_0.getDerivs(F0,d_F0_dX);
expff = evaluator_lexp_0.getValues(F0);
}
{
double value_atan_0 = atan(expff);
double  deriv_atan_0_d0 = (+1.0/(1+expff*expff));
d_z1_dX = deriv_atan_0_d0*(d_expff_dX);
z1 = value_atan_0;
}
if ((F0>80.0))
{
d_T0_dX = d_F0_dX;
T0 = F0;
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+expff));
d_T0_dX = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dX);
T0 = evaluator_lln_0.getValues((1.0+expff));
}
}
{
double value_atan_0 = atan(((2*T0)*Inv_r1pi_acc));
double  deriv_atan_0_d0 = (+1.0/(1+((2*T0)*Inv_r1pi_acc)*((2*T0)*Inv_r1pi_acc)));
d_z2_dX = deriv_atan_0_d0*(((2*T0)*d_Inv_r1pi_acc_dX+2*d_T0_dX*Inv_r1pi_acc));
z2 = value_atan_0;
}
{
double value_max_0 = std::max(z2,static_cast<double>(1e-15));
double value_min_1 = std::min(z1,value_max_0);
double  deriv_max_0_d0 = ((z2>=1e-15)?1.0:0.0);
double  deriv_min_1_d0 = ((z1<=value_max_0)?1.0:0.0);
double  deriv_min_1_d1 = ((z1<=value_max_0)?0.0:1.0);
d_g0_dX = ((deriv_min_1_d0*(d_z1_dX))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dX)))));
g0 = value_min_1;
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
d_lng0_dX = evaluator_lln_0.getDerivs(g0,d_g0_dX);
lng0 = evaluator_lln_0.getValues(g0);
}
d_secg0sq_dX = (tang0*d_tang0_dX+d_tang0_dX*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);
d_lncosg0_dX = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dX);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (g0*tang0);
d_e0_dX = (((d_lng0_dX-d_lncosg0_dX)+(r1_acc*d_T0_dX+d_r1_acc_dX*T0))-d_F0_dX);
e0 = (((lng0-lncosg0)+(r1_acc*T0))-F0);
d_e1_dX = ((d_inv_g0_dX+((secg0sq*g0)*d_r1_acc_dX+(secg0sq*d_g0_dX+d_secg0sq_dX*g0)*r1_acc))+(tang0*d_r1_acc_dX+d_tang0_dX*(1.0+r1_acc)));
e1 = ((inv_g0+((secg0sq*g0)*r1_acc))+(tang0*(1.0+r1_acc)));
d_e2_dX = ((secg0sq*2.0*(d_r1_acc_dX+(T0*d_r1_acc_dX+d_T0_dX*r1_acc))+d_secg0sq_dX*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0));
e2 = ((secg0sq*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*inv_g0));
d_e3_dX = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dX+((2.0*inv_g0)*d_inv_g0_dX+2.0*d_inv_g0_dX*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*d_r1_acc_dX+(((2.0*g0)*secg0sq)*d_secg0sq_dX+((2.0*g0)*d_secg0sq_dX+2.0*d_g0_dX*secg0sq)*secg0sq)*r1_acc))+(((2.0*secg0sq)*tang0)*(3.0*d_r1_acc_dX+((2.0*r1_acc)*d_T0_dX+2.0*d_r1_acc_dX*T0))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*r1_acc))+(((2.0*secg0sq)*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
d_lng0_dX = evaluator_lln_0.getDerivs(g0,d_g0_dX);
lng0 = evaluator_lln_0.getValues(g0);
}
d_secg0sq_dX = (tang0*d_tang0_dX+d_tang0_dX*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);
d_lncosg0_dX = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dX);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (g0*tang0);
d_e0_dX = (((d_lng0_dX-d_lncosg0_dX)+(r1_acc*d_T0_dX+d_r1_acc_dX*T0))-d_F0_dX);
e0 = (((lng0-lncosg0)+(r1_acc*T0))-F0);
d_e1_dX = ((d_inv_g0_dX+((secg0sq*g0)*d_r1_acc_dX+(secg0sq*d_g0_dX+d_secg0sq_dX*g0)*r1_acc))+(tang0*d_r1_acc_dX+d_tang0_dX*(1.0+r1_acc)));
e1 = ((inv_g0+((secg0sq*g0)*r1_acc))+(tang0*(1.0+r1_acc)));
d_e2_dX = ((secg0sq*2.0*(d_r1_acc_dX+(T0*d_r1_acc_dX+d_T0_dX*r1_acc))+d_secg0sq_dX*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0));
e2 = ((secg0sq*(1.0+(2.0*(r1_acc+(T0*r1_acc)))))-(inv_g0*inv_g0));
d_e3_dX = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dX+((2.0*inv_g0)*d_inv_g0_dX+2.0*d_inv_g0_dX*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*d_r1_acc_dX+(((2.0*g0)*secg0sq)*d_secg0sq_dX+((2.0*g0)*d_secg0sq_dX+2.0*d_g0_dX*secg0sq)*secg0sq)*r1_acc))+(((2.0*secg0sq)*tang0)*(3.0*d_r1_acc_dX+((2.0*r1_acc)*d_T0_dX+2.0*d_r1_acc_dX*T0))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*r1_acc))+(((2.0*secg0sq)*tang0)*((1.0+(3.0*r1_acc))+((2.0*r1_acc)*T0))));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_g0a_dX = d_g0_dX;
g0a = g0;
{
double value_tan_0 = tan(g0a);
double  deriv_tan_0_d0 = (1.0/cos(g0a)/cos(g0a));
d_tang0a_dX = deriv_tan_0_d0*(d_g0a_dX);
tang0a = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0a);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(tang0a*tang0a)));
d_qi_acc_dX = (d_vgsfbeff_acc_dX-((2.0*Vtm)*((evaluator_lln_0.getDerivs(g0a,d_g0a_dX)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0a*tang0a)),(tang0a*d_tang0a_dX+d_tang0a_dX*tang0a)))+d_F1_acc_dX)+2.0*d_Vtm_dX*((evaluator_lln_0.getValues(g0a)+(0.5*evaluator_lln_1.getValues((1.0+(tang0a*tang0a)))))+F1_acc)));
qi_acc = (vgsfbeff_acc-((2.0*Vtm)*((evaluator_lln_0.getValues(g0a)+(0.5*evaluator_lln_1.getValues((1.0+(tang0a*tang0a)))))+F1_acc)));
}
}
else
{
d_F0_dX = (((2.0*Vtm)*d_vgsfbeff_acc_dX-vgsfbeff_acc*2.0*d_Vtm_dX)/(2.0*Vtm)/(2.0*Vtm));
F0 = (vgsfbeff_acc/(2.0*Vtm));
if ((F0>80.0))
{
d_T0_dX = d_F0_dX;
T0 = F0;
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(F0)));
d_T0_dX = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dX));
T0 = evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(F0)));
}
}
if ((F0<(-10)))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((2*F0));
d_g0_dX = evaluator_lexp_0.getDerivs((2*F0),2*d_F0_dX);
g0 = evaluator_lexp_0.getValues((2*F0));
}
}
else
{
if ((F0>10))
{
d_g0_dX = ((r1_acc*d_F0_dX-F0*d_r1_acc_dX)/r1_acc/r1_acc);
g0 = (F0/r1_acc);
}
else
{
{
double value_sqrt_0 = sqrt((0.25+(((r1_acc*r1_acc)*T0)*T0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_g0_dX = (((r1_acc*r1_acc)*deriv_sqrt_0_d0*((((r1_acc*r1_acc)*T0)*d_T0_dX+((r1_acc*r1_acc)*d_T0_dX+(r1_acc*d_r1_acc_dX+d_r1_acc_dX*r1_acc)*T0)*T0))-(value_sqrt_0-0.5)*(r1_acc*d_r1_acc_dX+d_r1_acc_dX*r1_acc))/(r1_acc*r1_acc)/(r1_acc*r1_acc));
g0 = ((value_sqrt_0-0.5)/(r1_acc*r1_acc));
}
}
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
if ((F0<(-50)))
{
d_g0a_dX = d_g0_dX;
g0a = g0;
}
else
{
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_inv_g0sq_dX = (inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0);
inv_g0sq = (inv_g0*inv_g0);
d_T0_dX = (cdop_acc*d_g0_dX+d_cdop_acc_dX*g0);
T0 = (1+(cdop_acc*g0));
d_T1_dX = ((T0*d_cdop_acc_dX-cdop_acc*d_T0_dX)/T0/T0);
T1 = (cdop_acc/T0);
d_T2_dX = (T1*d_T1_dX+d_T1_dX*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);
d_e0_dX = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dX)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dX))+(r1_acc*d_g0_dX+d_r1_acc_dX*g0))-d_F0_dX);
e0 = ((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1_acc*g0))-F0);
}
d_e1_dX = ((0.5*d_inv_g0_dX+0.5*d_T1_dX)+d_r1_acc_dX);
e1 = (((0.5*inv_g0)+(0.5*T1))+r1_acc);
d_e2_dX = ((-0.5)*d_inv_g0sq_dX-0.5*d_T2_dX);
e2 = (((-0.5)*inv_g0sq)-(0.5*T2));
d_e3_dX = ((inv_g0*d_inv_g0sq_dX+d_inv_g0_dX*inv_g0sq)+(T2*d_T1_dX+d_T2_dX*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_inv_g0sq_dX = (inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0);
inv_g0sq = (inv_g0*inv_g0);
d_T0_dX = (cdop_acc*d_g0_dX+d_cdop_acc_dX*g0);
T0 = (1+(cdop_acc*g0));
d_T1_dX = ((T0*d_cdop_acc_dX-cdop_acc*d_T0_dX)/T0/T0);
T1 = (cdop_acc/T0);
d_T2_dX = (T1*d_T1_dX+d_T1_dX*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);
d_e0_dX = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dX)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dX))+(r1_acc*d_g0_dX+d_r1_acc_dX*g0))-d_F0_dX);
e0 = ((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1_acc*g0))-F0);
}
d_e1_dX = ((0.5*d_inv_g0_dX+0.5*d_T1_dX)+d_r1_acc_dX);
e1 = (((0.5*inv_g0)+(0.5*T1))+r1_acc);
d_e2_dX = ((-0.5)*d_inv_g0sq_dX-0.5*d_T2_dX);
e2 = (((-0.5)*inv_g0sq)-(0.5*T2));
d_e3_dX = ((inv_g0*d_inv_g0sq_dX+d_inv_g0_dX*inv_g0sq)+(T2*d_T1_dX+d_T2_dX*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_g0a_dX = d_g0_dX;
g0a = g0;
}
d_qi_acc_dX = (q0_acc*d_g0a_dX+d_q0_acc_dX*g0a);
qi_acc = (q0_acc*g0a);
}
}
d_vch_dX = d_dvch_qm_dX;
vch = dvch_qm;
if ((modelStruct.modelPar_GEOMOD!=3))
{
if ((modelStruct.modelPar_COREMOD!=0))
{
d_F0_dX = ((((2.0*nVtm)*(d_vgsfbeff_dX-d_vch_dX)-(vgsfbeff-vch)*2.0*d_nVtm_dX)/(2.0*nVtm)/(2.0*nVtm))-d_F1_dX);
F0 = (((vgsfbeff-vch)/(2.0*nVtm))-F1);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
d_expff_dX = evaluator_lexp_0.getDerivs(F0,d_F0_dX);
expff = evaluator_lexp_0.getValues(F0);
}
{
double value_atan_0 = atan(expff);
double  deriv_atan_0_d0 = (+1.0/(1+expff*expff));
d_z1_dX = deriv_atan_0_d0*(d_expff_dX);
z1 = value_atan_0;
}
if ((F0>80.0))
{
d_T0_dX = d_F0_dX;
T0 = F0;
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+expff));
d_T0_dX = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dX);
T0 = evaluator_lln_0.getValues((1.0+expff));
}
}
{
double value_atan_0 = atan(((2*T0)*Inv_r1pi));
double  deriv_atan_0_d0 = (+1.0/(1+((2*T0)*Inv_r1pi)*((2*T0)*Inv_r1pi)));
d_z2_dX = deriv_atan_0_d0*(((2*T0)*d_Inv_r1pi_dX+2*d_T0_dX*Inv_r1pi));
z2 = value_atan_0;
}
{
double value_max_0 = std::max(z2,static_cast<double>(1e-15));
double value_min_1 = std::min(z1,value_max_0);
double  deriv_max_0_d0 = ((z2>=1e-15)?1.0:0.0);
double  deriv_min_1_d0 = ((z1<=value_max_0)?1.0:0.0);
double  deriv_min_1_d1 = ((z1<=value_max_0)?0.0:1.0);
d_g0_dX = ((deriv_min_1_d0*(d_z1_dX))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dX)))));
g0 = value_min_1;
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
d_lng0_dX = evaluator_lln_0.getDerivs(g0,d_g0_dX);
lng0 = evaluator_lln_0.getValues(g0);
}
d_secg0sq_dX = (tang0*d_tang0_dX+d_tang0_dX*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);
d_lncosg0_dX = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dX);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (g0*tang0);
d_T1_dX = (T0*d_T0_dX+d_T0_dX*T0);
T1 = (T0*T0);
d_e0_dX = ((((d_lng0_dX-d_lncosg0_dX)+(r1*d_T0_dX+d_r1_dX*T0))+(r2*d_T1_dX+d_r2_dX*T1))-d_F0_dX);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);
d_e1_dX = ((d_inv_g0_dX+((secg0sq*g0)*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+(secg0sq*d_g0_dX+d_secg0sq_dX*g0)*(r1+((2.0*r2)*T0))))+(tang0*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+d_tang0_dX*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));
d_e2_dX = ((secg0sq*2.0*(((d_r1_dX+(((r2*g0)*g0)*d_secg0sq_dX+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0)*secg0sq))+(T0*d_r1_dX+d_T0_dX*r1))+((2.0*r2)*(d_T1_dX+2.0*d_T0_dX)+2.0*d_r2_dX*(T1+(2.0*T0))))+d_secg0sq_dX*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*((2.0*T1)*d_r2_dX+2.0*d_T1_dX*r2)+(inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e3_dX = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dX+((2.0*inv_g0)*d_inv_g0_dX+2.0*d_inv_g0_dX*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(d_r1_dX+((2.0*r2)*4.0*d_T0_dX+2.0*d_r2_dX*(3.0+(4.0*T0))))+(((2.0*g0)*secg0sq)*d_secg0sq_dX+((2.0*g0)*d_secg0sq_dX+2.0*d_g0_dX*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((3.0*d_r1_dX+((2.0*r1)*d_T0_dX+2.0*d_r1_dX*T0))+((2.0*r2)*(3.0*2.0*d_T0_dX+2.0*d_T1_dX)+2.0*d_r2_dX*((3.0*(1+(2.0*T0)))+(2.0*T1))))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
d_lng0_dX = evaluator_lln_0.getDerivs(g0,d_g0_dX);
lng0 = evaluator_lln_0.getValues(g0);
}
d_secg0sq_dX = (tang0*d_tang0_dX+d_tang0_dX*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);
d_lncosg0_dX = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dX);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (g0*tang0);
d_T1_dX = (T0*d_T0_dX+d_T0_dX*T0);
T1 = (T0*T0);
d_e0_dX = ((((d_lng0_dX-d_lncosg0_dX)+(r1*d_T0_dX+d_r1_dX*T0))+(r2*d_T1_dX+d_r2_dX*T1))-d_F0_dX);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);
d_e1_dX = ((d_inv_g0_dX+((secg0sq*g0)*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+(secg0sq*d_g0_dX+d_secg0sq_dX*g0)*(r1+((2.0*r2)*T0))))+(tang0*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+d_tang0_dX*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));
d_e2_dX = ((secg0sq*2.0*(((d_r1_dX+(((r2*g0)*g0)*d_secg0sq_dX+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0)*secg0sq))+(T0*d_r1_dX+d_T0_dX*r1))+((2.0*r2)*(d_T1_dX+2.0*d_T0_dX)+2.0*d_r2_dX*(T1+(2.0*T0))))+d_secg0sq_dX*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*((2.0*T1)*d_r2_dX+2.0*d_T1_dX*r2)+(inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e3_dX = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dX+((2.0*inv_g0)*d_inv_g0_dX+2.0*d_inv_g0_dX*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(d_r1_dX+((2.0*r2)*4.0*d_T0_dX+2.0*d_r2_dX*(3.0+(4.0*T0))))+(((2.0*g0)*secg0sq)*d_secg0sq_dX+((2.0*g0)*d_secg0sq_dX+2.0*d_g0_dX*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((3.0*d_r1_dX+((2.0*r1)*d_T0_dX+2.0*d_r1_dX*T0))+((2.0*r2)*(3.0*2.0*d_T0_dX+2.0*d_T1_dX)+2.0*d_r2_dX*((3.0*(1+(2.0*T0)))+(2.0*T1))))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_g0s_dX = d_g0_dX;
g0s = g0;
{
double value_tan_0 = tan(g0s);
double  deriv_tan_0_d0 = (1.0/cos(g0s)/cos(g0s));
d_tang0s_dX = deriv_tan_0_d0*(d_g0s_dX);
tang0s = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0s);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(tang0s*tang0s)));
d_phis_dX = (d_vch_dX+((2.0*nVtm)*((evaluator_lln_0.getDerivs(g0s,d_g0s_dX)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0s*tang0s)),(tang0s*d_tang0s_dX+d_tang0s_dX*tang0s)))+d_F1_dX)+2.0*d_nVtm_dX*((evaluator_lln_0.getValues(g0s)+(0.5*evaluator_lln_1.getValues((1.0+(tang0s*tang0s)))))+F1)));
phis = (vch+((2.0*nVtm)*((evaluator_lln_0.getValues(g0s)+(0.5*evaluator_lln_1.getValues((1.0+(tang0s*tang0s)))))+F1)));
}
}
else
{
d_F0_dX = (((T14*((d_vgsfbeff_dX-d_phibulk_dX)-d_vch_dX)-((vgsfbeff-phibulk)-vch)*d_T14_dX)/T14/T14)-d_F1_dX);
F0 = ((((vgsfbeff-phibulk)-vch)/T14)-F1);
d_T0_dX = (phibulk*d_aab_dX+d_phibulk_dX*aab);
T0 = (phibulk*aab);
d_T1_dX = ((T14*d_phibulk_dX-phibulk*d_T14_dX)/T14/T14);
T1 = (phibulk/T14);
d_z1_dX = ((((2.0*r1)-1.0)*d_T1_dX+2.0*d_r1_dX*T1)+(r2*d_T0_dX+d_r2_dX*T0));
z1 = ((((2.0*r1)-1.0)*T1)+(r2*T0));
d_guessA_dX = ((2.0*r1)*d_T1_dX+2.0*d_r1_dX*T1);
guessA = ((2.0*r1)*T1);
{
double value_exp_0 = exp((-guessA));
double  deriv_exp_0_d0 = value_exp_0;
d_guessA_dX = (((1.0-value_exp_0)*d_guessA_dX-guessA*(-deriv_exp_0_d0*((-d_guessA_dX))))/(1.0-value_exp_0)/(1.0-value_exp_0));
guessA = (guessA/(1.0-value_exp_0));
}
{
double value_sqrt_0 = sqrt(guessA);
double value_log_1 = log((value_sqrt_0/r1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(value_sqrt_0/r1));
d_z2_dX = (d_z1_dX+deriv_log_1_d0*(((r1*deriv_sqrt_0_d0*(d_guessA_dX)-value_sqrt_0*d_r1_dX)/r1/r1)));
z2 = (z1+value_log_1);
}
if (((F0-z2)>((-0.3)/T14)))
{
if (((F0-z2)<20))
{
{
double value_exp_0 = exp((2.0*(F0-z2)));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_T2_dX = ((0.5/guessA)*deriv_log_1_d0*(deriv_exp_0_d0*(2.0*(d_F0_dX-d_z2_dX)))+(-0.5*d_guessA_dX/guessA/guessA)*value_log_1);
T2 = (((0.5/guessA)*value_log_1)+1.0);
}
}
else
{
d_T2_dX = ((0.5/guessA)*2.0*(d_F0_dX-d_z2_dX)+(-0.5*d_guessA_dX/guessA/guessA)*(2.0*(F0-z2)));
T2 = (((0.5/guessA)*(2.0*(F0-z2)))+1.0);
}
{
double value_pow_0 = pow(T2,2.0);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*2.0/T2));
d_T3_dX = (deriv_pow_0_d0*(d_T2_dX));
T3 = value_pow_0;
}
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_exp_1 = exp((-T1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_exp_1_d0 = value_exp_1;
d_guessB_dX = (((guessA/r1)*value_sqrt_0)*deriv_exp_1_d0*((-d_T1_dX))+((guessA/r1)*deriv_sqrt_0_d0*(d_T3_dX)+((r1*d_guessA_dX-guessA*d_r1_dX)/r1/r1)*value_sqrt_0)*value_exp_1);
guessB = (((guessA/r1)*value_sqrt_0)*value_exp_1);
}
}
else
{
{
double value_exp_0 = exp(((F0-z1)-T1));
double  deriv_exp_0_d0 = value_exp_0;
d_guessB_dX = deriv_exp_0_d0*(((d_F0_dX-d_z1_dX)-d_T1_dX));
guessB = value_exp_0;
}
}
d_g0_dX = d_guessB_dX;
g0 = guessB;
if ((g0>1e-60))
{
d_g0_dX = (-(-d_g0_dX/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
g0 = (1.0/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));
d_cosg0_dX = deriv_cos_0_d0*(d_g0_dX);
cosg0 = value_cos_0;
}
d_secg0_dX = (-d_cosg0_dX/cosg0/cosg0);
secg0 = (1.0/cosg0);
d_secg0sq_dX = (secg0*d_secg0_dX+d_secg0_dX*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T1_dX = (((g0*g0)*(T13*d_secg0sq_dX+d_T13_dX*secg0sq)+(g0*d_g0_dX+d_g0_dX*g0)*((T13*secg0sq)-1.0))+(aab*(d_phibulk_dX-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX)+d_T14_dX*evaluator_lln_0.getValues(cosg0)))+d_aab_dX*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T2_dX = deriv_sqrt_0_d0*(d_T1_dX);
T2 = value_sqrt_0;
}
d_T3_dX = (((-2.0)*d_g0_dX+((aab*T14)*d_tang0_dX+(aab*d_T14_dX+d_aab_dX*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dX+(((2.0*T13)*g0)*d_secg0sq_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));
d_T4_dX = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dX+((((2.0*T13)*g0)*g0)*d_secg0sq_dX+(((2.0*T13)*g0)*d_g0_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dX+(aab*d_T14_dX+d_aab_dX*T14))+(((8.0*T13)*g0)*d_tang0_dX+((8.0*T13)*d_g0_dX+8.0*d_T13_dX*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dX+((((4.0*T13)*g0)*g0)*d_tang0_dX+(((4.0*T13)*g0)*d_g0_dX+((4.0*T13)*d_g0_dX+4.0*d_T13_dX*g0)*g0)*tang0)*tang0))+d_secg0sq_dX*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T5_dX = (((2.0*tang0)*d_T4_dX+2.0*d_tang0_dX*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dX+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dX+(((3.0*T13)*g0)*d_secg0sq_dX+((3.0*T13)*d_g0_dX+3.0*d_T13_dX*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dX)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dX+(((2.0*T13)*secg0sq)*d_T0_dX+((2.0*T13)*d_secg0sq_dX+2.0*d_T13_dX*secg0sq)*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T7_dX = ((((d_lng0_dX-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX))+(r2*d_T1_dX+d_r2_dX*T1))+(r1*d_T2_dX+d_r1_dX*T2))-d_F0_dX);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}
d_T8_dX = ((((-d_g0_dX/g0/g0)+d_tang0_dX)+(r2*d_T3_dX+d_r2_dX*T3))+(((2.0*T2)*(r1*d_T3_dX+d_r1_dX*T3)-(r1*T3)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));
d_T9_dX = (((((-(-1.0)*(g0*d_g0_dX+d_g0_dX*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dX)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dX+(r1*d_T3_dX+d_r1_dX*T3)*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dX+((4*T2)*d_T2_dX+4*d_T2_dX*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*(r1*d_T4_dX+d_r1_dX*T4)-(r1*T4)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T4_dX+d_r2_dX*T4));
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));
d_TA_dX = (((((-2.0*((g0*g0)*d_g0_dX+(g0*d_g0_dX+d_g0_dX*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dX+d_T3_dX*T3)-(T3*T3)*((2.0*T2)*d_T2_dX+2.0*d_T2_dX*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dX)+(((4.0*value_pow_0)*((3.0*r1)*d_T3_dX+3.0*d_r1_dX*T3)-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dX)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*(r1*d_T5_dX+d_r1_dX*T5)-(r1*T5)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T5_dX+d_r2_dX*T5));
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));
d_g0_dX = (d_g0_dX-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dX+d_T7_dX*T9)-(T7*T9)*((2.0*T8)*d_T8_dX+2.0*d_T8_dX*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dX+3.0*d_T9_dX*T9)-(T8*d_TA_dX+d_T8_dX*TA))+(T7*d_T7_dX+d_T7_dX*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dX)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dX-T7*d_T8_dX)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));
d_cosg0_dX = deriv_cos_0_d0*(d_g0_dX);
cosg0 = value_cos_0;
}
d_secg0_dX = (-d_cosg0_dX/cosg0/cosg0);
secg0 = (1.0/cosg0);
d_secg0sq_dX = (secg0*d_secg0_dX+d_secg0_dX*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T1_dX = (((g0*g0)*(T13*d_secg0sq_dX+d_T13_dX*secg0sq)+(g0*d_g0_dX+d_g0_dX*g0)*((T13*secg0sq)-1.0))+(aab*(d_phibulk_dX-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX)+d_T14_dX*evaluator_lln_0.getValues(cosg0)))+d_aab_dX*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T2_dX = deriv_sqrt_0_d0*(d_T1_dX);
T2 = value_sqrt_0;
}
d_T3_dX = (((-2.0)*d_g0_dX+((aab*T14)*d_tang0_dX+(aab*d_T14_dX+d_aab_dX*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dX+(((2.0*T13)*g0)*d_secg0sq_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));
d_T4_dX = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dX+((((2.0*T13)*g0)*g0)*d_secg0sq_dX+(((2.0*T13)*g0)*d_g0_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dX+(aab*d_T14_dX+d_aab_dX*T14))+(((8.0*T13)*g0)*d_tang0_dX+((8.0*T13)*d_g0_dX+8.0*d_T13_dX*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dX+((((4.0*T13)*g0)*g0)*d_tang0_dX+(((4.0*T13)*g0)*d_g0_dX+((4.0*T13)*d_g0_dX+4.0*d_T13_dX*g0)*g0)*tang0)*tang0))+d_secg0sq_dX*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T5_dX = (((2.0*tang0)*d_T4_dX+2.0*d_tang0_dX*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dX+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dX+(((3.0*T13)*g0)*d_secg0sq_dX+((3.0*T13)*d_g0_dX+3.0*d_T13_dX*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dX)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dX+(((2.0*T13)*secg0sq)*d_T0_dX+((2.0*T13)*d_secg0sq_dX+2.0*d_T13_dX*secg0sq)*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T7_dX = ((((d_lng0_dX-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX))+(r2*d_T1_dX+d_r2_dX*T1))+(r1*d_T2_dX+d_r1_dX*T2))-d_F0_dX);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}
d_T8_dX = ((((-d_g0_dX/g0/g0)+d_tang0_dX)+(r2*d_T3_dX+d_r2_dX*T3))+(((2.0*T2)*(r1*d_T3_dX+d_r1_dX*T3)-(r1*T3)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));
d_T9_dX = (((((-(-1.0)*(g0*d_g0_dX+d_g0_dX*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dX)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dX+(r1*d_T3_dX+d_r1_dX*T3)*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dX+((4*T2)*d_T2_dX+4*d_T2_dX*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*(r1*d_T4_dX+d_r1_dX*T4)-(r1*T4)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T4_dX+d_r2_dX*T4));
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));
d_TA_dX = (((((-2.0*((g0*g0)*d_g0_dX+(g0*d_g0_dX+d_g0_dX*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dX+d_T3_dX*T3)-(T3*T3)*((2.0*T2)*d_T2_dX+2.0*d_T2_dX*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dX)+(((4.0*value_pow_0)*((3.0*r1)*d_T3_dX+3.0*d_r1_dX*T3)-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dX)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*(r1*d_T5_dX+d_r1_dX*T5)-(r1*T5)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T5_dX+d_r2_dX*T5));
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));
d_g0_dX = (d_g0_dX-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dX+d_T7_dX*T9)-(T7*T9)*((2.0*T8)*d_T8_dX+2.0*d_T8_dX*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dX+3.0*d_T9_dX*T9)-(T8*d_TA_dX+d_T8_dX*TA))+(T7*d_T7_dX+d_T7_dX*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dX)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dX-T7*d_T8_dX)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
}
else
{
if ((g0>=1e-300))
{
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
}
else
{
if (((F0-z2)>((-0.3)/T14)))
{
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_log_1 = log((1.0/((guessA/r1)*value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(1.0/((guessA/r1)*value_sqrt_0)));
d_lng0_dX = ((-deriv_log_1_d0*((-((guessA/r1)*deriv_sqrt_0_d0*(d_T3_dX)+((r1*d_guessA_dX-guessA*d_r1_dX)/r1/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0))))-d_T1_dX);
lng0 = ((-value_log_1)-T1);
}
}
else
{
d_lng0_dX = ((d_F0_dX-d_z1_dX)-d_T1_dX);
lng0 = ((F0-z1)-T1);
}
}
}
{
double value_cos_0 = cos(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(value_cos_0);
double  deriv_cos_0_d0 = (-sin(g0));
d_phis_dX = ((d_vch_dX+(T14*((d_lng0_dX-evaluator_lln_1.getDerivs(value_cos_0,deriv_cos_0_d0*(d_g0_dX)))+d_F1_dX)+d_T14_dX*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)))+d_phibulk_dX);
phis = ((vch+(T14*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)))+phibulk);
}
}
}
else
{
d_F0_dX = (((2.0*nVtm)*(d_vgsfbeff_dX-d_vch_dX)-(vgsfbeff-vch)*2.0*d_nVtm_dX)/(2.0*nVtm)/(2.0*nVtm));
F0 = ((vgsfbeff-vch)/(2.0*nVtm));
if ((F0<(-10)))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((2.0*F0));
d_g0_dX = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dX);
g0 = evaluator_lexp_0.getValues((2.0*F0));
}
}
else
{
if ((F0>10))
{
d_g0_dX = ((r1*d_F0_dX-F0*d_r1_dX)/r1/r1);
g0 = (F0/r1);
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(F0)));
d_T0_dX = evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dX));
T0 = evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(F0)));
}
{
double value_sqrt_0 = sqrt((0.25+(((r1*r1)*T0)*T0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_g0_dX = (((r1*r1)*deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dX+((r1*r1)*d_T0_dX+(r1*d_r1_dX+d_r1_dX*r1)*T0)*T0))-(value_sqrt_0-0.5)*(r1*d_r1_dX+d_r1_dX*r1))/(r1*r1)/(r1*r1));
g0 = ((value_sqrt_0-0.5)/(r1*r1));
}
}
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
if ((F0<(-50)))
{
d_g0s_dX = d_g0_dX;
g0s = g0;
}
else
{
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_inv_g0sq_dX = (inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0);
inv_g0sq = (inv_g0*inv_g0);
d_T0_dX = (cdop*d_g0_dX+d_cdop_dX*g0);
T0 = (1+(cdop*g0));
d_T1_dX = ((T0*d_cdop_dX-cdop*d_T0_dX)/T0/T0);
T1 = (cdop/T0);
d_T2_dX = (T1*d_T1_dX+d_T1_dX*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);
d_e0_dX = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dX)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dX))+(r1*d_g0_dX+d_r1_dX*g0))+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0))-d_F0_dX);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}
d_e1_dX = (((0.5*d_inv_g0_dX+0.5*d_T1_dX)+d_r1_dX)+((2*r2)*d_g0_dX+2*d_r2_dX*g0));
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));
d_e2_dX = (((-0.5)*d_inv_g0sq_dX-0.5*d_T2_dX)+2*d_r2_dX);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2*r2));
d_e3_dX = ((inv_g0*d_inv_g0sq_dX+d_inv_g0_dX*inv_g0sq)+(T2*d_T1_dX+d_T2_dX*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_inv_g0sq_dX = (inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0);
inv_g0sq = (inv_g0*inv_g0);
d_T0_dX = (cdop*d_g0_dX+d_cdop_dX*g0);
T0 = (1+(cdop*g0));
d_T1_dX = ((T0*d_cdop_dX-cdop*d_T0_dX)/T0/T0);
T1 = (cdop/T0);
d_T2_dX = (T1*d_T1_dX+d_T1_dX*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);
d_e0_dX = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dX)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dX))+(r1*d_g0_dX+d_r1_dX*g0))+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0))-d_F0_dX);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}
d_e1_dX = (((0.5*d_inv_g0_dX+0.5*d_T1_dX)+d_r1_dX)+((2*r2)*d_g0_dX+2*d_r2_dX*g0));
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));
d_e2_dX = (((-0.5)*d_inv_g0sq_dX-0.5*d_T2_dX)+2.0*d_r2_dX);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2.0*r2));
d_e3_dX = ((inv_g0*d_inv_g0sq_dX+d_inv_g0_dX*inv_g0sq)+(T2*d_T1_dX+d_T2_dX*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_g0s_dX = d_g0_dX;
g0s = g0;
}
d_vpolys_dX = ((((2.0*nVtm)*r2)*g0s)*d_g0s_dX+(((2.0*nVtm)*r2)*d_g0s_dX+((2.0*nVtm)*d_r2_dX+2.0*d_nVtm_dX*r2)*g0s)*g0s);
vpolys = ((((2.0*nVtm)*r2)*g0s)*g0s);
d_phis_dX = ((d_vgsfbeff_dX-(((2.0*nVtm)*r1)*d_g0s_dX+((2.0*nVtm)*d_r1_dX+2.0*d_nVtm_dX*r1)*g0s))-d_vpolys_dX);
phis = ((vgsfbeff-(((2.0*nVtm)*r1)*g0s))-vpolys);
d_qis_dX = (q0*d_g0s_dX+d_q0_dX*g0s);
qis = (q0*g0s);
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
if ((NGATE_i>0))
{
{
double value_sqrt_0 = sqrt((1.0+((vgsfbeff-phis)/vpoly0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = deriv_sqrt_0_d0*(((vpoly0*(d_vgsfbeff_dX-d_phis_dX)-(vgsfbeff-phis)*d_vpoly0_dX)/vpoly0/vpoly0));
T0 = (value_sqrt_0-1.0);
}
d_vpolys_dX = ((vpoly0*T0)*d_T0_dX+(vpoly0*d_T0_dX+d_vpoly0_dX*T0)*T0);
vpolys = ((vpoly0*T0)*T0);
}
else
{
d_vpolys_dX = 0.0;
vpolys = 0;
}
d_qis_dX = ((modelStruct.modelPar_COREMOD!=0)?((d_vgsfbeff_dX-d_phis_dX)-d_vpolys_dX):(((d_vgsfbeff_dX-d_phis_dX)-d_qbs_dX)-d_vpolys_dX));
qis = ((modelStruct.modelPar_COREMOD!=0)?((vgsfbeff-phis)-vpolys):(((vgsfbeff-phis)-qbs)-vpolys));
}
d_Eeffs_dX = (EeffFactor*(d_qbs_dX+(eta_mu*d_qis_dX+d_eta_mu_dX*qis))+d_EeffFactor_dX*(qbs+(eta_mu*qis)));
Eeffs = (EeffFactor*(qbs+(eta_mu*qis)));
d_qb0_dX = (-1.0e-2*d_cox_dX/cox/cox);
qb0 = (1.0e-2/cox);
{
double value_fabs_0 = fabs((qis/qb0));
double value_pow_1 = pow((0.5*(1.0+value_fabs_0)),UCS_t);
double  deriv_fabs_0_d0 = ((((qis/qb0))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = (((0.5*(1.0+value_fabs_0)) == 0.0)?0.0:(value_pow_1*UCS_t/(0.5*(1.0+value_fabs_0))));
double  deriv_pow_1_d1 = ((0.5*(1.0+value_fabs_0)) == 0.0)?0.0:(log((0.5*(1.0+value_fabs_0)))*value_pow_1);
d_T2_dX = ((deriv_pow_1_d0*(0.5*deriv_fabs_0_d0*(((qb0*d_qis_dX-qis*d_qb0_dX)/qb0/qb0))))+(deriv_pow_1_d1*(d_UCS_t_dX)));
T2 = value_pow_1;
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
{
double value_fabs_0 = fabs(Eeffs);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffs)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_T3_dX = (((UA_t+(UC_t*veseff))*((deriv_pow_1_d0*(deriv_fabs_0_d0*(d_Eeffs_dX)))+(deriv_pow_1_d1*(d_EU_i_dX)))+(d_UA_t_dX+(UC_t*d_veseff_dX+d_UC_t_dX*veseff))*value_pow_1)+((T2*d_UD_t_dX-UD_t*d_T2_dX)/T2/T2));
T3 = (((UA_t+(UC_t*veseff))*value_pow_1)+(UD_t/T2));
}
}
else
{
{
double value_fabs_0 = fabs(Eeffs);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffs)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_T3_dX = ((UA_t*((deriv_pow_1_d0*(deriv_fabs_0_d0*(d_Eeffs_dX)))+(deriv_pow_1_d1*(d_EU_i_dX)))+d_UA_t_dX*value_pow_1)+((T2*d_UD_t_dX-UD_t*d_T2_dX)/T2/T2));
T3 = ((UA_t*value_pow_1)+(UD_t/T2));
}
}
d_Dmobs_dX = d_T3_dX;
Dmobs = (1.0+T3);
d_Dmobs_dX = ((instanceStruct.instancePar_U0MULT*d_Dmobs_dX-Dmobs*instanceStruct.d_instancePar_U0MULT_dX)/instanceStruct.instancePar_U0MULT/instanceStruct.instancePar_U0MULT);
Dmobs = (Dmobs/instanceStruct.instancePar_U0MULT);
if ((modelStruct.modelPar_RDSMOD!=0))
{
d_Rdss_dX = 0.0;
Rdss = 0.0;
}
else
{
d_T4_dX = (PRWGS_i*d_qis_dX+d_PRWGS_i_dX*qis);
T4 = (1.0+(PRWGS_i*qis));
d_T1_dX = (-d_T4_dX/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = 0.5*(d_T1_dX+deriv_sqrt_0_d0*((T1*d_T1_dX+d_T1_dX*T1)));
T0 = (0.5*(T1+value_sqrt_0));
}
d_Rdss_dX = ((((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*d_rdstemp_dX+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*d_NFINtotal_dX+((RDSWMIN_i+(RDSW_i*T0))*d_WeffWRFactor_dX+(d_RDSWMIN_i_dX+(RDSW_i*d_T0_dX+d_RDSW_i_dX*T0))*WeffWRFactor)*NFINtotal)*rdstemp);
Rdss = ((((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp);
}
d_Esat_dX = (((2*VSAT_t)/u0)*d_Dmobs_dX+((u0*2*d_VSAT_t_dX-(2*VSAT_t)*d_u0_dX)/u0/u0)*Dmobs);
Esat = (((2*VSAT_t)/u0)*Dmobs);
d_EsatL_dX = (Esat*d_Leff_dX+d_Esat_dX*Leff);
EsatL = (Esat*Leff);
d_T6_dX = (KSATIV_i*((d_vgsfbeff_dX-d_phis_dX)+2*d_Vtm_dX)+d_KSATIV_i_dX*((vgsfbeff-phis)+(2*Vtm)));
T6 = (KSATIV_i*((vgsfbeff-phis)+(2*Vtm)));
if ((Rdss==0))
{
d_Vdsat_dX = (((EsatL+T6)*(EsatL*d_T6_dX+d_EsatL_dX*T6)-(EsatL*T6)*(d_EsatL_dX+d_T6_dX))/(EsatL+T6)/(EsatL+T6));
Vdsat = ((EsatL*T6)/(EsatL+T6));
}
else
{
d_WVCox_dX = ((Weff0*VSAT_t)*d_cox_dX+(Weff0*d_VSAT_t_dX+d_Weff0_dX*VSAT_t)*cox);
WVCox = ((Weff0*VSAT_t)*cox);
d_T0_dX = (WVCox*d_Rdss_dX+d_WVCox_dX*Rdss);
T0 = (WVCox*Rdss);
d_Ta_dX = 2*d_T0_dX;
Ta = (2*T0);
d_Tb_dX = ((d_T6_dX+d_EsatL_dX)+((3*T6)*d_T0_dX+3*d_T6_dX*T0));
Tb = ((T6+EsatL)+((3*T6)*T0));
d_Tc_dX = (T6*(d_EsatL_dX+((2*T6)*d_T0_dX+2*d_T6_dX*T0))+d_T6_dX*(EsatL+((2*T6)*T0)));
Tc = (T6*(EsatL+((2*T6)*T0)));
{
double value_sqrt_0 = sqrt(((Tb*Tb)-((2*Ta)*Tc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdsat_dX = ((Ta*(d_Tb_dX-deriv_sqrt_0_d0*(((Tb*d_Tb_dX+d_Tb_dX*Tb)-((2*Ta)*d_Tc_dX+2*d_Ta_dX*Tc))))-(Tb-value_sqrt_0)*d_Ta_dX)/Ta/Ta);
Vdsat = ((Tb-value_sqrt_0)/Ta);
}
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((Vdsat-1.0E-3),1.0E-5);
d_Vdsat_dX = evaluator_hypsmooth_0.getDerivs((Vdsat-1.0E-3),1.0E-5,d_Vdsat_dX,0.0);
Vdsat = (evaluator_hypsmooth_0.getValues((Vdsat-1.0E-3),1.0E-5)+1.0E-3);
}
{
double value_pow_0 = pow((vds/Vdsat),MEXP_a);
double  deriv_pow_0_d0 = (((vds/Vdsat) == 0.0)?0.0:(value_pow_0*MEXP_a/(vds/Vdsat)));
double  deriv_pow_0_d1 = ((vds/Vdsat) == 0.0)?0.0:(log((vds/Vdsat))*value_pow_0);
d_T7_dX = ((deriv_pow_0_d0*((-vds*d_Vdsat_dX/Vdsat/Vdsat)))+(deriv_pow_0_d1*(d_MEXP_a_dX)));
T7 = value_pow_0;
}
{
double value_pow_0 = pow((1.0+T7),inv_MEXP);
double  deriv_pow_0_d0 = (((1.0+T7) == 0.0)?0.0:(value_pow_0*inv_MEXP/(1.0+T7)));
double  deriv_pow_0_d1 = ((1.0+T7) == 0.0)?0.0:(log((1.0+T7))*value_pow_0);
d_T8_dX = ((deriv_pow_0_d0*(d_T7_dX))+(deriv_pow_0_d1*(d_inv_MEXP_dX)));
T8 = value_pow_0;
}
d_Vdseff_dX = (-vds*d_T8_dX/T8/T8);
Vdseff = (vds/T8);
if ((Vdseff>vds))
{
d_Vdseff_dX = 0.0;
Vdseff = vds;
}
d_vch_dX = (d_Vdseff_dX+d_dvch_qm_dX);
vch = (Vdseff+dvch_qm);
if ((modelStruct.modelPar_GEOMOD!=3))
{
if ((modelStruct.modelPar_COREMOD!=0))
{
d_F0_dX = ((((2.0*nVtm)*(d_vgsfbeff_dX-d_vch_dX)-(vgsfbeff-vch)*2.0*d_nVtm_dX)/(2.0*nVtm)/(2.0*nVtm))-d_F1_dX);
F0 = (((vgsfbeff-vch)/(2.0*nVtm))-F1);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
d_expff_dX = evaluator_lexp_0.getDerivs(F0,d_F0_dX);
expff = evaluator_lexp_0.getValues(F0);
}
{
double value_atan_0 = atan(expff);
double  deriv_atan_0_d0 = (+1.0/(1+expff*expff));
d_z1_dX = deriv_atan_0_d0*(d_expff_dX);
z1 = value_atan_0;
}
if ((F0>80.0))
{
d_T0_dX = d_F0_dX;
T0 = F0;
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+expff));
d_T0_dX = evaluator_lln_0.getDerivs((1.0+expff),d_expff_dX);
T0 = evaluator_lln_0.getValues((1.0+expff));
}
}
{
double value_atan_0 = atan(((2*T0)*Inv_r1pi));
double  deriv_atan_0_d0 = (+1.0/(1+((2*T0)*Inv_r1pi)*((2*T0)*Inv_r1pi)));
d_z2_dX = deriv_atan_0_d0*(((2*T0)*d_Inv_r1pi_dX+2*d_T0_dX*Inv_r1pi));
z2 = value_atan_0;
}
{
double value_max_0 = std::max(z2,static_cast<double>(1e-15));
double value_min_1 = std::min(z1,value_max_0);
double  deriv_max_0_d0 = ((z2>=1e-15)?1.0:0.0);
double  deriv_min_1_d0 = ((z1<=value_max_0)?1.0:0.0);
double  deriv_min_1_d1 = ((z1<=value_max_0)?0.0:1.0);
d_g0_dX = ((deriv_min_1_d0*(d_z1_dX))+(deriv_min_1_d1*((deriv_max_0_d0*(d_z2_dX)))));
g0 = value_min_1;
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
d_lng0_dX = evaluator_lln_0.getDerivs(g0,d_g0_dX);
lng0 = evaluator_lln_0.getValues(g0);
}
d_secg0sq_dX = (tang0*d_tang0_dX+d_tang0_dX*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);
d_lncosg0_dX = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dX);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (g0*tang0);
d_T1_dX = (T0*d_T0_dX+d_T0_dX*T0);
T1 = (T0*T0);
d_e0_dX = ((((d_lng0_dX-d_lncosg0_dX)+(r1*d_T0_dX+d_r1_dX*T0))+(r2*d_T1_dX+d_r2_dX*T1))-d_F0_dX);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);
d_e1_dX = ((d_inv_g0_dX+((secg0sq*g0)*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+(secg0sq*d_g0_dX+d_secg0sq_dX*g0)*(r1+((2.0*r2)*T0))))+(tang0*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+d_tang0_dX*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));
d_e2_dX = ((secg0sq*2.0*(((d_r1_dX+(((r2*g0)*g0)*d_secg0sq_dX+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0)*secg0sq))+(T0*d_r1_dX+d_T0_dX*r1))+((2.0*r2)*(d_T1_dX+2.0*d_T0_dX)+2.0*d_r2_dX*(T1+(2.0*T0))))+d_secg0sq_dX*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*((2.0*T1)*d_r2_dX+2.0*d_T1_dX*r2)+(inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e3_dX = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dX+((2.0*inv_g0)*d_inv_g0_dX+2.0*d_inv_g0_dX*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(d_r1_dX+((2.0*r2)*4.0*d_T0_dX+2.0*d_r2_dX*(3.0+(4.0*T0))))+(((2.0*g0)*secg0sq)*d_secg0sq_dX+((2.0*g0)*d_secg0sq_dX+2.0*d_g0_dX*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((3.0*d_r1_dX+((2.0*r1)*d_T0_dX+2.0*d_r1_dX*T0))+((2.0*r2)*(3.0*2.0*d_T0_dX+2.0*d_T1_dX)+2.0*d_r2_dX*((3.0*(1+(2.0*T0)))+(2.0*T1))))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
d_lng0_dX = evaluator_lln_0.getDerivs(g0,d_g0_dX);
lng0 = evaluator_lln_0.getValues(g0);
}
d_secg0sq_dX = (tang0*d_tang0_dX+d_tang0_dX*tang0);
secg0sq = ((tang0*tang0)+1.0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(secg0sq);
d_lncosg0_dX = (-0.5)*evaluator_lln_0.getDerivs(secg0sq,d_secg0sq_dX);
lncosg0 = ((-0.5)*evaluator_lln_0.getValues(secg0sq));
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (g0*tang0);
d_T1_dX = (T0*d_T0_dX+d_T0_dX*T0);
T1 = (T0*T0);
d_e0_dX = ((((d_lng0_dX-d_lncosg0_dX)+(r1*d_T0_dX+d_r1_dX*T0))+(r2*d_T1_dX+d_r2_dX*T1))-d_F0_dX);
e0 = ((((lng0-lncosg0)+(r1*T0))+(r2*T1))-F0);
d_e1_dX = ((d_inv_g0_dX+((secg0sq*g0)*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+(secg0sq*d_g0_dX+d_secg0sq_dX*g0)*(r1+((2.0*r2)*T0))))+(tang0*(d_r1_dX+((2.0*r2)*d_T0_dX+2.0*d_r2_dX*T0))+d_tang0_dX*(1.0+(r1+((2.0*r2)*T0)))));
e1 = ((inv_g0+((secg0sq*g0)*(r1+((2.0*r2)*T0))))+(tang0*(1.0+(r1+((2.0*r2)*T0)))));
d_e2_dX = ((secg0sq*2.0*(((d_r1_dX+(((r2*g0)*g0)*d_secg0sq_dX+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0)*secg0sq))+(T0*d_r1_dX+d_T0_dX*r1))+((2.0*r2)*(d_T1_dX+2.0*d_T0_dX)+2.0*d_r2_dX*(T1+(2.0*T0))))+d_secg0sq_dX*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*((2.0*T1)*d_r2_dX+2.0*d_T1_dX*r2)+(inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0)*(((2.0*T1)*r2)-1.0)));
e2 = ((secg0sq*(1.0+(2.0*(((r1+(((r2*g0)*g0)*secg0sq))+(T0*r1))+((2.0*r2)*(T1+(2.0*T0)))))))+((inv_g0*inv_g0)*(((2.0*T1)*r2)-1.0)));
d_e3_dX = (((((2.0*inv_g0)*inv_g0)*d_inv_g0_dX+((2.0*inv_g0)*d_inv_g0_dX+2.0*d_inv_g0_dX*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(d_r1_dX+((2.0*r2)*4.0*d_T0_dX+2.0*d_r2_dX*(3.0+(4.0*T0))))+(((2.0*g0)*secg0sq)*d_secg0sq_dX+((2.0*g0)*d_secg0sq_dX+2.0*d_g0_dX*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*((3.0*d_r1_dX+((2.0*r1)*d_T0_dX+2.0*d_r1_dX*T0))+((2.0*r2)*(3.0*2.0*d_T0_dX+2.0*d_T1_dX)+2.0*d_r2_dX*((3.0*(1+(2.0*T0)))+(2.0*T1))))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
e3 = (((((2.0*inv_g0)*inv_g0)*inv_g0)+((((2.0*g0)*secg0sq)*secg0sq)*(r1+((2.0*r2)*(3.0+(4.0*T0))))))+(((2.0*secg0sq)*tang0)*(((1.0+(3.0*r1))+((2.0*r1)*T0))+((2.0*r2)*((3.0*(1+(2.0*T0)))+(2.0*T1))))));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_g0d_dX = d_g0_dX;
g0d = g0;
{
double value_tan_0 = tan(g0d);
double  deriv_tan_0_d0 = (1.0/cos(g0d)/cos(g0d));
d_tang0d_dX = deriv_tan_0_d0*(d_g0d_dX);
tang0d = value_tan_0;
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0d);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(tang0d*tang0d)));
d_phid_dX = (d_vch_dX+((2.0*nVtm)*((evaluator_lln_0.getDerivs(g0d,d_g0d_dX)+0.5*evaluator_lln_1.getDerivs((1.0+(tang0d*tang0d)),(tang0d*d_tang0d_dX+d_tang0d_dX*tang0d)))+d_F1_dX)+2.0*d_nVtm_dX*((evaluator_lln_0.getValues(g0d)+(0.5*evaluator_lln_1.getValues((1.0+(tang0d*tang0d)))))+F1)));
phid = (vch+((2.0*nVtm)*((evaluator_lln_0.getValues(g0d)+(0.5*evaluator_lln_1.getValues((1.0+(tang0d*tang0d)))))+F1)));
}
}
else
{
d_F0_dX = (((T14*((d_vgsfbeff_dX-d_phibulk_dX)-d_vch_dX)-((vgsfbeff-phibulk)-vch)*d_T14_dX)/T14/T14)-d_F1_dX);
F0 = ((((vgsfbeff-phibulk)-vch)/T14)-F1);
d_T0_dX = (phibulk*d_aab_dX+d_phibulk_dX*aab);
T0 = (phibulk*aab);
d_T1_dX = ((T14*d_phibulk_dX-phibulk*d_T14_dX)/T14/T14);
T1 = (phibulk/T14);
d_z1_dX = ((((2.0*r1)-1.0)*d_T1_dX+2.0*d_r1_dX*T1)+(r2*d_T0_dX+d_r2_dX*T0));
z1 = ((((2.0*r1)-1.0)*T1)+(r2*T0));
d_guessA_dX = ((2.0*r1)*d_T1_dX+2.0*d_r1_dX*T1);
guessA = ((2.0*r1)*T1);
{
double value_exp_0 = exp((-guessA));
double  deriv_exp_0_d0 = value_exp_0;
d_guessA_dX = (((1.0-value_exp_0)*d_guessA_dX-guessA*(-deriv_exp_0_d0*((-d_guessA_dX))))/(1.0-value_exp_0)/(1.0-value_exp_0));
guessA = (guessA/(1.0-value_exp_0));
}
{
double value_sqrt_0 = sqrt(guessA);
double value_log_1 = log((value_sqrt_0/r1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(value_sqrt_0/r1));
d_z2_dX = (d_z1_dX+deriv_log_1_d0*(((r1*deriv_sqrt_0_d0*(d_guessA_dX)-value_sqrt_0*d_r1_dX)/r1/r1)));
z2 = (z1+value_log_1);
}
if (((F0-z2)>((-0.3)/T14)))
{
if (((F0-z2)<20))
{
{
double value_exp_0 = exp((2.0*(F0-z2)));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_T2_dX = ((0.5/guessA)*deriv_log_1_d0*(deriv_exp_0_d0*(2.0*(d_F0_dX-d_z2_dX)))+(-0.5*d_guessA_dX/guessA/guessA)*value_log_1);
T2 = (((0.5/guessA)*value_log_1)+1.0);
}
}
else
{
d_T2_dX = ((0.5/guessA)*2.0*(d_F0_dX-d_z2_dX)+(-0.5*d_guessA_dX/guessA/guessA)*(2.0*(F0-z2)));
T2 = (((0.5/guessA)*(2.0*(F0-z2)))+1.0);
}
{
double value_pow_0 = pow(T2,2.0);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*2.0/T2));
d_T3_dX = (deriv_pow_0_d0*(d_T2_dX));
T3 = value_pow_0;
}
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_exp_1 = exp((-T1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_exp_1_d0 = value_exp_1;
d_guessB_dX = (((guessA/r1)*value_sqrt_0)*deriv_exp_1_d0*((-d_T1_dX))+((guessA/r1)*deriv_sqrt_0_d0*(d_T3_dX)+((r1*d_guessA_dX-guessA*d_r1_dX)/r1/r1)*value_sqrt_0)*value_exp_1);
guessB = (((guessA/r1)*value_sqrt_0)*value_exp_1);
}
}
else
{
{
double value_exp_0 = exp(((F0-z1)-T1));
double  deriv_exp_0_d0 = value_exp_0;
d_guessB_dX = deriv_exp_0_d0*(((d_F0_dX-d_z1_dX)-d_T1_dX));
guessB = value_exp_0;
}
}
d_g0_dX = d_guessB_dX;
g0 = guessB;
if ((g0>1e-60))
{
d_g0_dX = (-(-d_g0_dX/g0/g0)/((1.0/g0)+(1.0/(0.5*3.14159265358979323846)))/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
g0 = (1.0/((1.0/g0)+(1.0/(0.5*3.14159265358979323846))));
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));
d_cosg0_dX = deriv_cos_0_d0*(d_g0_dX);
cosg0 = value_cos_0;
}
d_secg0_dX = (-d_cosg0_dX/cosg0/cosg0);
secg0 = (1.0/cosg0);
d_secg0sq_dX = (secg0*d_secg0_dX+d_secg0_dX*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T1_dX = (((g0*g0)*(T13*d_secg0sq_dX+d_T13_dX*secg0sq)+(g0*d_g0_dX+d_g0_dX*g0)*((T13*secg0sq)-1.0))+(aab*(d_phibulk_dX-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX)+d_T14_dX*evaluator_lln_0.getValues(cosg0)))+d_aab_dX*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T2_dX = deriv_sqrt_0_d0*(d_T1_dX);
T2 = value_sqrt_0;
}
d_T3_dX = (((-2.0)*d_g0_dX+((aab*T14)*d_tang0_dX+(aab*d_T14_dX+d_aab_dX*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dX+(((2.0*T13)*g0)*d_secg0sq_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));
d_T4_dX = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dX+((((2.0*T13)*g0)*g0)*d_secg0sq_dX+(((2.0*T13)*g0)*d_g0_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dX+(aab*d_T14_dX+d_aab_dX*T14))+(((8.0*T13)*g0)*d_tang0_dX+((8.0*T13)*d_g0_dX+8.0*d_T13_dX*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dX+((((4.0*T13)*g0)*g0)*d_tang0_dX+(((4.0*T13)*g0)*d_g0_dX+((4.0*T13)*d_g0_dX+4.0*d_T13_dX*g0)*g0)*tang0)*tang0))+d_secg0sq_dX*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T5_dX = (((2.0*tang0)*d_T4_dX+2.0*d_tang0_dX*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dX+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dX+(((3.0*T13)*g0)*d_secg0sq_dX+((3.0*T13)*d_g0_dX+3.0*d_T13_dX*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dX)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dX+(((2.0*T13)*secg0sq)*d_T0_dX+((2.0*T13)*d_secg0sq_dX+2.0*d_T13_dX*secg0sq)*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T7_dX = ((((d_lng0_dX-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX))+(r2*d_T1_dX+d_r2_dX*T1))+(r1*d_T2_dX+d_r1_dX*T2))-d_F0_dX);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}
d_T8_dX = ((((-d_g0_dX/g0/g0)+d_tang0_dX)+(r2*d_T3_dX+d_r2_dX*T3))+(((2.0*T2)*(r1*d_T3_dX+d_r1_dX*T3)-(r1*T3)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));
d_T9_dX = (((((-(-1.0)*(g0*d_g0_dX+d_g0_dX*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dX)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dX+(r1*d_T3_dX+d_r1_dX*T3)*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dX+((4*T2)*d_T2_dX+4*d_T2_dX*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*(r1*d_T4_dX+d_r1_dX*T4)-(r1*T4)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T4_dX+d_r2_dX*T4));
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));
d_TA_dX = (((((-2.0*((g0*g0)*d_g0_dX+(g0*d_g0_dX+d_g0_dX*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dX+d_T3_dX*T3)-(T3*T3)*((2.0*T2)*d_T2_dX+2.0*d_T2_dX*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dX)+(((4.0*value_pow_0)*((3.0*r1)*d_T3_dX+3.0*d_r1_dX*T3)-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dX)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*(r1*d_T5_dX+d_r1_dX*T5)-(r1*T5)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T5_dX+d_r2_dX*T5));
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));
d_g0_dX = (d_g0_dX-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dX+d_T7_dX*T9)-(T7*T9)*((2.0*T8)*d_T8_dX+2.0*d_T8_dX*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dX+3.0*d_T9_dX*T9)-(T8*d_TA_dX+d_T8_dX*TA))+(T7*d_T7_dX+d_T7_dX*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dX)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dX-T7*d_T8_dX)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_tan_0 = tan(g0);
double  deriv_tan_0_d0 = (1.0/cos(g0)/cos(g0));
d_tang0_dX = deriv_tan_0_d0*(d_g0_dX);
tang0 = value_tan_0;
}
{
double value_cos_0 = cos(g0);
double  deriv_cos_0_d0 = (-sin(g0));
d_cosg0_dX = deriv_cos_0_d0*(d_g0_dX);
cosg0 = value_cos_0;
}
d_secg0_dX = (-d_cosg0_dX/cosg0/cosg0);
secg0 = (1.0/cosg0);
d_secg0sq_dX = (secg0*d_secg0_dX+d_secg0_dX*secg0);
secg0sq = (secg0*secg0);
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
d_T0_dX = (g0*d_tang0_dX+d_g0_dX*tang0);
T0 = (1.0+(g0*tang0));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T1_dX = (((g0*g0)*(T13*d_secg0sq_dX+d_T13_dX*secg0sq)+(g0*d_g0_dX+d_g0_dX*g0)*((T13*secg0sq)-1.0))+(aab*(d_phibulk_dX-(T14*evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX)+d_T14_dX*evaluator_lln_0.getValues(cosg0)))+d_aab_dX*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
T1 = (((g0*g0)*((T13*secg0sq)-1.0))+(aab*(phibulk-(T14*evaluator_lln_0.getValues(cosg0)))));
}
{
double value_sqrt_0 = sqrt(T1);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T2_dX = deriv_sqrt_0_d0*(d_T1_dX);
T2 = value_sqrt_0;
}
d_T3_dX = (((-2.0)*d_g0_dX+((aab*T14)*d_tang0_dX+(aab*d_T14_dX+d_aab_dX*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*d_T0_dX+(((2.0*T13)*g0)*d_secg0sq_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*secg0sq)*T0));
T3 = ((((-2.0)*g0)+((aab*T14)*tang0))+((((2.0*T13)*g0)*secg0sq)*T0));
d_T4_dX = ((((((2.0*T13)*g0)*g0)*secg0sq)*d_secg0sq_dX+((((2.0*T13)*g0)*g0)*d_secg0sq_dX+(((2.0*T13)*g0)*d_g0_dX+((2.0*T13)*d_g0_dX+2.0*d_T13_dX*g0)*g0)*secg0sq)*secg0sq)+(secg0sq*(((2*d_T13_dX+(aab*d_T14_dX+d_aab_dX*T14))+(((8.0*T13)*g0)*d_tang0_dX+((8.0*T13)*d_g0_dX+8.0*d_T13_dX*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*d_tang0_dX+((((4.0*T13)*g0)*g0)*d_tang0_dX+(((4.0*T13)*g0)*d_g0_dX+((4.0*T13)*d_g0_dX+4.0*d_T13_dX*g0)*g0)*tang0)*tang0))+d_secg0sq_dX*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
T4 = (((-2.0)+(((((2.0*T13)*g0)*g0)*secg0sq)*secg0sq))+(secg0sq*((((2*T13)+(aab*T14))+(((8.0*T13)*g0)*tang0))+(((((4.0*T13)*g0)*g0)*tang0)*tang0))));
d_T5_dX = (((2.0*tang0)*d_T4_dX+2.0*d_tang0_dX*T4)+4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*d_T0_dX+((((3.0*T13)*g0)*secg0sq)*d_secg0sq_dX+(((3.0*T13)*g0)*d_secg0sq_dX+((3.0*T13)*d_g0_dX+3.0*d_T13_dX*g0)*secg0sq)*secg0sq)*T0)+d_tang0_dX)+((((2.0*T13)*secg0sq)*T0)*d_tang0_dX+(((2.0*T13)*secg0sq)*d_T0_dX+((2.0*T13)*d_secg0sq_dX+2.0*d_T13_dX*secg0sq)*T0)*tang0)));
T5 = (((2.0*tang0)*T4)+(4.0*(((((((3.0*T13)*g0)*secg0sq)*secg0sq)*T0)+tang0)+((((2.0*T13)*secg0sq)*T0)*tang0))));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(cosg0);
d_T7_dX = ((((d_lng0_dX-evaluator_lln_0.getDerivs(cosg0,d_cosg0_dX))+(r2*d_T1_dX+d_r2_dX*T1))+(r1*d_T2_dX+d_r1_dX*T2))-d_F0_dX);
T7 = ((((lng0-evaluator_lln_0.getValues(cosg0))+(r2*T1))+(r1*T2))-F0);
}
d_T8_dX = ((((-d_g0_dX/g0/g0)+d_tang0_dX)+(r2*d_T3_dX+d_r2_dX*T3))+(((2.0*T2)*(r1*d_T3_dX+d_r1_dX*T3)-(r1*T3)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)));
T8 = ((((1.0/g0)+tang0)+(r2*T3))+((r1*T3)/(2.0*T2)));
d_T9_dX = (((((-(-1.0)*(g0*d_g0_dX+d_g0_dX*g0)/(g0*g0)/(g0*g0))+d_secg0sq_dX)-(((((4*T2)*T2)*T2)*((r1*T3)*d_T3_dX+(r1*d_T3_dX+d_r1_dX*T3)*T3)-((r1*T3)*T3)*(((4*T2)*T2)*d_T2_dX+((4*T2)*d_T2_dX+4*d_T2_dX*T2)*T2))/(((4*T2)*T2)*T2)/(((4*T2)*T2)*T2)))+(((2.0*T2)*(r1*d_T4_dX+d_r1_dX*T4)-(r1*T4)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T4_dX+d_r2_dX*T4));
T9 = ((((((-1.0)/(g0*g0))+secg0sq)-(((r1*T3)*T3)/(((4*T2)*T2)*T2)))+((r1*T4)/(2.0*T2)))+(r2*T4));
{
double value_pow_0 = pow(T2,3);
double  deriv_pow_0_d0 = ((T2 == 0.0)?0.0:(value_pow_0*3/T2));
d_TA_dX = (((((-2.0*((g0*g0)*d_g0_dX+(g0*d_g0_dX+d_g0_dX*g0)*g0)/((g0*g0)*g0)/((g0*g0)*g0))+((2.0*secg0sq)*d_tang0_dX+2.0*d_secg0sq_dX*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((((2.0*T2)*T2)*(T3*d_T3_dX+d_T3_dX*T3)-(T3*T3)*((2.0*T2)*d_T2_dX+2.0*d_T2_dX*T2))/((2.0*T2)*T2)/((2.0*T2)*T2))-d_T4_dX)+(((4.0*value_pow_0)*((3.0*r1)*d_T3_dX+3.0*d_r1_dX*T3)-((3.0*r1)*T3)*4.0*(deriv_pow_0_d0*(d_T2_dX)))/(4.0*value_pow_0)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+(((2.0*T2)*(r1*d_T5_dX+d_r1_dX*T5)-(r1*T5)*2.0*d_T2_dX)/(2.0*T2)/(2.0*T2)))+(r2*d_T5_dX+d_r2_dX*T5));
TA = (((((2.0/((g0*g0)*g0))+((2.0*secg0sq)*tang0))+((((3.0*r1)*T3)/(4.0*value_pow_0))*(((T3*T3)/((2.0*T2)*T2))-T4)))+((r1*T5)/(2.0*T2)))+(r2*T5));
}
{
double value_pow_0 = pow(T8,4);
double  deriv_pow_0_d0 = ((T8 == 0.0)?0.0:(value_pow_0*4/T8));
d_g0_dX = (d_g0_dX-((T7/T8)*(((((2.0*T8)*T8)*(T7*d_T9_dX+d_T7_dX*T9)-(T7*T9)*((2.0*T8)*d_T8_dX+2.0*d_T8_dX*T8))/((2.0*T8)*T8)/((2.0*T8)*T8))+(((6.0*value_pow_0)*((T7*T7)*(((3.0*T9)*d_T9_dX+3.0*d_T9_dX*T9)-(T8*d_TA_dX+d_T8_dX*TA))+(T7*d_T7_dX+d_T7_dX*T7)*(((3.0*T9)*T9)-(T8*TA)))-((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))*6.0*(deriv_pow_0_d0*(d_T8_dX)))/(6.0*value_pow_0)/(6.0*value_pow_0)))+((T8*d_T7_dX-T7*d_T8_dX)/T8/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
g0 = (g0-((T7/T8)*((1.0+((T7*T9)/((2.0*T8)*T8)))+(((T7*T7)*(((3.0*T9)*T9)-(T8*TA)))/(6.0*value_pow_0)))));
}
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
}
else
{
if ((g0>=1e-300))
{
{
double value_log_0 = log((1.0/g0));
double  deriv_log_0_d0 = (1.0/(1.0/g0));
d_lng0_dX = (-deriv_log_0_d0*((-d_g0_dX/g0/g0)));
lng0 = (-value_log_0);
}
}
else
{
if (((F0-z2)>((-0.3)/T14)))
{
{
double value_sqrt_0 = sqrt((T3-1.0));
double value_log_1 = log((1.0/((guessA/r1)*value_sqrt_0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(1.0/((guessA/r1)*value_sqrt_0)));
d_lng0_dX = ((-deriv_log_1_d0*((-((guessA/r1)*deriv_sqrt_0_d0*(d_T3_dX)+((r1*d_guessA_dX-guessA*d_r1_dX)/r1/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0)/((guessA/r1)*value_sqrt_0))))-d_T1_dX);
lng0 = ((-value_log_1)-T1);
}
}
else
{
d_lng0_dX = ((d_F0_dX-d_z1_dX)-d_T1_dX);
lng0 = ((F0-z1)-T1);
}
}
}
{
double value_cos_0 = cos(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(value_cos_0);
double  deriv_cos_0_d0 = (-sin(g0));
d_phid_dX = ((d_vch_dX+(T14*((d_lng0_dX-evaluator_lln_1.getDerivs(value_cos_0,deriv_cos_0_d0*(d_g0_dX)))+d_F1_dX)+d_T14_dX*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)))+d_phibulk_dX);
phid = ((vch+(T14*((lng0-evaluator_lln_1.getValues(value_cos_0))+F1)))+phibulk);
}
}
}
else
{
d_F0_dX = (((2.0*nVtm)*(d_vgsfbeff_dX-d_vch_dX)-(vgsfbeff-vch)*2.0*d_nVtm_dX)/(2.0*nVtm)/(2.0*nVtm));
F0 = ((vgsfbeff-vch)/(2.0*nVtm));
if ((F0<(-10)))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((2.0*F0));
d_g0_dX = evaluator_lexp_0.getDerivs((2.0*F0),2.0*d_F0_dX);
g0 = evaluator_lexp_0.getValues((2.0*F0));
}
}
else
{
if ((F0>10))
{
d_g0_dX = ((r1*d_F0_dX-F0*d_r1_dX)/r1/r1);
g0 = (F0/r1);
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(F0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+evaluator_lexp_0.getValues(F0)));
d_T0_dX = evaluator_lln_1.getDerivs((1.0+evaluator_lexp_0.getValues(F0)),evaluator_lexp_0.getDerivs(F0,d_F0_dX));
T0 = evaluator_lln_1.getValues((1.0+evaluator_lexp_0.getValues(F0)));
}
{
double value_sqrt_0 = sqrt((0.25+(((r1*r1)*T0)*T0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_g0_dX = (((r1*r1)*deriv_sqrt_0_d0*((((r1*r1)*T0)*d_T0_dX+((r1*r1)*d_T0_dX+(r1*d_r1_dX+d_r1_dX*r1)*T0)*T0))-(value_sqrt_0-0.5)*(r1*d_r1_dX+d_r1_dX*r1))/(r1*r1)/(r1*r1));
g0 = ((value_sqrt_0-0.5)/(r1*r1));
}
}
}
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
if ((F0<(-50)))
{
d_g0d_dX = d_g0_dX;
g0d = g0;
}
else
{
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_inv_g0sq_dX = (inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0);
inv_g0sq = (inv_g0*inv_g0);
d_T0_dX = (cdop*d_g0_dX+d_cdop_dX*g0);
T0 = (1+(cdop*g0));
d_T1_dX = ((T0*d_cdop_dX-cdop*d_T0_dX)/T0/T0);
T1 = (cdop/T0);
d_T2_dX = (T1*d_T1_dX+d_T1_dX*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);
d_e0_dX = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dX)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dX))+(r1*d_g0_dX+d_r1_dX*g0))+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0))-d_F0_dX);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}
d_e1_dX = (((0.5*d_inv_g0_dX+0.5*d_T1_dX)+d_r1_dX)+((2*r2)*d_g0_dX+2*d_r2_dX*g0));
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));
d_e2_dX = (((-0.5)*d_inv_g0sq_dX-0.5*d_T2_dX)+2*d_r2_dX);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2*r2));
d_e3_dX = ((inv_g0*d_inv_g0sq_dX+d_inv_g0_dX*inv_g0sq)+(T2*d_T1_dX+d_T2_dX*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_inv_g0_dX = (-d_g0_dX/g0/g0);
inv_g0 = (1.0/g0);
d_inv_g0sq_dX = (inv_g0*d_inv_g0_dX+d_inv_g0_dX*inv_g0);
inv_g0sq = (inv_g0*inv_g0);
d_T0_dX = (cdop*d_g0_dX+d_cdop_dX*g0);
T0 = (1+(cdop*g0));
d_T1_dX = ((T0*d_cdop_dX-cdop*d_T0_dX)/T0/T0);
T1 = (cdop/T0);
d_T2_dX = (T1*d_T1_dX+d_T1_dX*T1);
T2 = (T1*T1);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1(T0);
d_e0_dX = ((((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dX)+0.5*evaluator_lln_1.getDerivs(T0,d_T0_dX))+(r1*d_g0_dX+d_r1_dX*g0))+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0))-d_F0_dX);
e0 = (((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues(T0)))+(r1*g0))+((r2*g0)*g0))-F0);
}
d_e1_dX = (((0.5*d_inv_g0_dX+0.5*d_T1_dX)+d_r1_dX)+((2*r2)*d_g0_dX+2*d_r2_dX*g0));
e1 = ((((0.5*inv_g0)+(0.5*T1))+r1)+((2*r2)*g0));
d_e2_dX = (((-0.5)*d_inv_g0sq_dX-0.5*d_T2_dX)+2*d_r2_dX);
e2 = ((((-0.5)*inv_g0sq)-(0.5*T2))+(2*r2));
d_e3_dX = ((inv_g0*d_inv_g0sq_dX+d_inv_g0_dX*inv_g0sq)+(T2*d_T1_dX+d_T2_dX*T1));
e3 = ((inv_g0*inv_g0sq)+(T2*T1));
d_g0_dX = (d_g0_dX-((e0/e1)*(((((2.0*e1)*e1)*(e0*d_e2_dX+d_e0_dX*e2)-(e0*e2)*((2.0*e1)*d_e1_dX+2.0*d_e1_dX*e1))/((2.0*e1)*e1)/((2.0*e1)*e1))+((((((6.0*e1)*e1)*e1)*e1)*((e0*e0)*(((3.0*e2)*d_e2_dX+3.0*d_e2_dX*e2)-(e1*d_e3_dX+d_e1_dX*e3))+(e0*d_e0_dX+d_e0_dX*e0)*(((3.0*e2)*e2)-(e1*e3)))-((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))*((((6.0*e1)*e1)*e1)*d_e1_dX+(((6.0*e1)*e1)*d_e1_dX+((6.0*e1)*d_e1_dX+6.0*d_e1_dX*e1)*e1)*e1))/((((6.0*e1)*e1)*e1)*e1)/((((6.0*e1)*e1)*e1)*e1)))+((e1*d_e0_dX-e0*d_e1_dX)/e1/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
g0 = (g0-((e0/e1)*((1.0+((e0*e2)/((2.0*e1)*e1)))+(((e0*e0)*(((3.0*e2)*e2)-(e1*e3)))/((((6.0*e1)*e1)*e1)*e1)))));
if (((g0>g0max)||(g0<g0min)))
{
if ((g0>g0max))
{
d_g0_dX = 0.0;
g0 = g0max;
}
else
{
d_g0_dX = 0.0;
g0 = g0min;
}
}
d_g0d_dX = d_g0_dX;
g0d = g0;
}
d_vpolyd_dX = ((((2*nVtm)*r2)*g0d)*d_g0d_dX+(((2*nVtm)*r2)*d_g0d_dX+((2*nVtm)*d_r2_dX+2*d_nVtm_dX*r2)*g0d)*g0d);
vpolyd = ((((2*nVtm)*r2)*g0d)*g0d);
d_phid_dX = ((d_vgsfbeff_dX-(((2*nVtm)*r1)*d_g0d_dX+((2*nVtm)*d_r1_dX+2*d_nVtm_dX*r1)*g0d))-d_vpolyd_dX);
phid = ((vgsfbeff-(((2*nVtm)*r1)*g0d))-vpolyd);
d_qid_dX = (q0*d_g0d_dX+d_q0_dX*g0d);
qid = (q0*g0d);
}
d_qba_dX = d_qbs_dX;
qba = qbs;
if ((modelStruct.modelPar_GEOMOD!=3))
{
if ((NGATE_i>0))
{
{
double value_sqrt_0 = sqrt((1+((vgsfbeff-phid)/vpoly0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = deriv_sqrt_0_d0*(((vpoly0*(d_vgsfbeff_dX-d_phid_dX)-(vgsfbeff-phid)*d_vpoly0_dX)/vpoly0/vpoly0));
T0 = (value_sqrt_0-1);
}
d_vpolyd_dX = ((vpoly0*T0)*d_T0_dX+(vpoly0*d_T0_dX+d_vpoly0_dX*T0)*T0);
vpolyd = ((vpoly0*T0)*T0);
}
else
{
d_vpolyd_dX = 0.0;
vpolyd = 0;
}
d_qid_dX = ((modelStruct.modelPar_COREMOD!=0)?((d_vgsfbeff_dX-d_phid_dX)-d_vpolyd_dX):(((d_vgsfbeff_dX-d_phid_dX)-d_qbs_dX)-d_vpolyd_dX));
qid = ((modelStruct.modelPar_COREMOD!=0)?((vgsfbeff-phid)-vpolyd):(((vgsfbeff-phid)-qbs)-vpolyd));
}
d_qia_dX = 0.5*(d_qis_dX+d_qid_dX);
qia = (0.5*(qis+qid));
d_dqi_dX = (d_qis_dX-d_qid_dX);
dqi = (qis-qid);
{
double value_pow_0 = pow(Vdseff,2.0);
double  deriv_pow_0_d0 = ((Vdseff == 0.0)?0.0:(value_pow_0*2.0/Vdseff));
d_T0_dX = ((deriv_pow_0_d0*(d_Vdseff_dX))/6.25e-4);
T0 = (value_pow_0/6.25e-4);
}
if ((modelStruct.modelPar_CHARGEWF!=0))
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T0));
d_qia2_dX = (0.5*(d_qis_dX+d_qid_dX)+(((modelStruct.modelPar_CHARGEWF*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*d_dqi_dX+(modelStruct.modelPar_CHARGEWF*(-evaluator_lexp_0.getDerivs((-T0),(-d_T0_dX)))+modelStruct.d_modelPar_CHARGEWF_dX*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5*dqi));
qia2 = ((0.5*(qis+qid))+(((modelStruct.modelPar_CHARGEWF*(1.0-evaluator_lexp_0.getValues((-T0))))*0.5)*dqi));
}
}
else
{
d_qia2_dX = 0.5*(d_qis_dX+d_qid_dX);
qia2 = (0.5*(qis+qid));
}
if (((QMTCENIV_i>0.0)||(QMTCENCV_i>0.0)))
{
d_T4_dX = ((modelStruct.modelPar_QM0*(d_qia_dX+(modelStruct.modelPar_ETAQM*d_qba_dX+modelStruct.d_modelPar_ETAQM_dX*qba))-(qia+(modelStruct.modelPar_ETAQM*qba))*modelStruct.d_modelPar_QM0_dX)/modelStruct.modelPar_QM0/modelStruct.modelPar_QM0);
T4 = ((qia+(modelStruct.modelPar_ETAQM*qba))/modelStruct.modelPar_QM0);
{
double value_pow_0 = pow(T4,modelStruct.modelPar_PQM);
double  deriv_pow_0_d0 = ((T4 == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PQM/T4));
double  deriv_pow_0_d1 = (T4 == 0.0)?0.0:(log(T4)*value_pow_0);
d_T5_dX = ((deriv_pow_0_d0*(d_T4_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PQM_dX)));
T5 = (1.0+value_pow_0);
}
d_Tcen_dX = ((T5*d_Tcen0_dX-Tcen0*d_T5_dX)/T5/T5);
Tcen = (Tcen0/T5);
if ( modelStruct.modelPar_GEOMOD == (0))
{
d_Weff_dX = d_Weff0_dX;
Weff = Weff0;
d_WeffCV_dX = d_WeffCV0_dX;
WeffCV = WeffCV0;
}
else
if ( modelStruct.modelPar_GEOMOD == (1))
{
d_Weff_dX = (d_Weff0_dX-((4.0*QMTCENIV_i)*d_Tcen_dX+4.0*d_QMTCENIV_i_dX*Tcen));
Weff = (Weff0-((4.0*QMTCENIV_i)*Tcen));
d_WeffCV_dX = (d_WeffCV0_dX-((4.0*QMTCENCV_i)*d_Tcen_dX+4.0*d_QMTCENCV_i_dX*Tcen));
WeffCV = (WeffCV0-((4.0*QMTCENCV_i)*Tcen));
}
else
if ( modelStruct.modelPar_GEOMOD == (2))
{
d_Weff_dX = (d_Weff0_dX-((8.0*QMTCENIV_i)*d_Tcen_dX+8.0*d_QMTCENIV_i_dX*Tcen));
Weff = (Weff0-((8.0*QMTCENIV_i)*Tcen));
d_WeffCV_dX = (d_WeffCV0_dX-((8.0*QMTCENCV_i)*d_Tcen_dX+8.0*d_QMTCENCV_i_dX*Tcen));
WeffCV = (WeffCV0-((8.0*QMTCENCV_i)*Tcen));
}
else
if ( modelStruct.modelPar_GEOMOD == (3))
{
d_Weff_dX = (d_Weff0_dX-(((2.0*3.14159265358979323846)*QMTCENIV_i)*d_Tcen_dX+(2.0*3.14159265358979323846)*d_QMTCENIV_i_dX*Tcen));
Weff = (Weff0-(((2.0*3.14159265358979323846)*QMTCENIV_i)*Tcen));
d_WeffCV_dX = (d_WeffCV0_dX-(((2.0*3.14159265358979323846)*QMTCENCV_i)*d_Tcen_dX+(2.0*3.14159265358979323846)*d_QMTCENCV_i_dX*Tcen));
WeffCV = (WeffCV0-(((2.0*3.14159265358979323846)*QMTCENCV_i)*Tcen));
}
else
{
 // no default
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_coxeff_dX = (-(3.9*8.8542e-12)*(((modelStruct.modelPar_EPSROX*modelStruct.d_modelPar_TOXP_dX*3.9-(modelStruct.modelPar_TOXP*3.9)*modelStruct.d_modelPar_EPSROX_dX)/modelStruct.modelPar_EPSROX/modelStruct.modelPar_EPSROX)+((epsratio*(Tcen*d_QMTCENCV_i_dX+d_Tcen_dX*QMTCENCV_i)-(Tcen*QMTCENCV_i)*d_epsratio_dX)/epsratio/epsratio))/(((modelStruct.modelPar_TOXP*3.9)/modelStruct.modelPar_EPSROX)+((Tcen*QMTCENCV_i)/epsratio))/(((modelStruct.modelPar_TOXP*3.9)/modelStruct.modelPar_EPSROX)+((Tcen*QMTCENCV_i)/epsratio)));
coxeff = ((3.9*8.8542e-12)/(((modelStruct.modelPar_TOXP*3.9)/modelStruct.modelPar_EPSROX)+((Tcen*QMTCENCV_i)/epsratio)));
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((R/(R-(Tcen*QMTCENCV_i))));
AnalogFunctions::llnEvaluator evaluator_lln_1((1+(modelStruct.modelPar_TOXP/R)));
d_coxeff_dX = (-(3.9*8.8542e-12)*(R*(((epsratio*evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCV_i))),(((R-(Tcen*QMTCENCV_i))*d_R_dX-R*(d_R_dX-(Tcen*d_QMTCENCV_i_dX+d_Tcen_dX*QMTCENCV_i)))/(R-(Tcen*QMTCENCV_i))/(R-(Tcen*QMTCENCV_i))))-evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))*d_epsratio_dX)/epsratio/epsratio)+((modelStruct.modelPar_EPSROX*evaluator_lln_1.getDerivs((1+(modelStruct.modelPar_TOXP/R)),((R*modelStruct.d_modelPar_TOXP_dX-modelStruct.modelPar_TOXP*d_R_dX)/R/R))*3.9-(evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)*modelStruct.d_modelPar_EPSROX_dX)/modelStruct.modelPar_EPSROX/modelStruct.modelPar_EPSROX))+d_R_dX*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX)))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX)))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX))));
coxeff = ((3.9*8.8542e-12)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCV_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX))));
}
}
}
else
{
d_Weff_dX = d_Weff0_dX;
Weff = Weff0;
d_WeffCV_dX = d_WeffCV0_dX;
WeffCV = WeffCV0;
d_coxeff_dX = d_cox_dX;
coxeff = cox;
}
if ((((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0))&&(QMTCENCVA_i!=0)))
{
{
double value_pow_0 = pow((qi_acc/modelStruct.modelPar_QM0ACC),modelStruct.modelPar_PQMACC);
double  deriv_pow_0_d0 = (((qi_acc/modelStruct.modelPar_QM0ACC) == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PQMACC/(qi_acc/modelStruct.modelPar_QM0ACC)));
double  deriv_pow_0_d1 = ((qi_acc/modelStruct.modelPar_QM0ACC) == 0.0)?0.0:(log((qi_acc/modelStruct.modelPar_QM0ACC))*value_pow_0);
d_T6_dX = ((deriv_pow_0_d0*(((modelStruct.modelPar_QM0ACC*d_qi_acc_dX-qi_acc*modelStruct.d_modelPar_QM0ACC_dX)/modelStruct.modelPar_QM0ACC/modelStruct.modelPar_QM0ACC)))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PQMACC_dX)));
T6 = (1.0+value_pow_0);
}
d_Tcen_dX = ((T6*d_Tcen0_dX-Tcen0*d_T6_dX)/T6/T6);
Tcen = (Tcen0/T6);
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_cox_acc_dX = (-(3.9*8.8542e-12)*(((modelStruct.modelPar_EPSROX*modelStruct.d_modelPar_TOXP_dX*3.9-(modelStruct.modelPar_TOXP*3.9)*modelStruct.d_modelPar_EPSROX_dX)/modelStruct.modelPar_EPSROX/modelStruct.modelPar_EPSROX)+((epsratio*(Tcen*d_QMTCENCVA_i_dX+d_Tcen_dX*QMTCENCVA_i)-(Tcen*QMTCENCVA_i)*d_epsratio_dX)/epsratio/epsratio))/(((modelStruct.modelPar_TOXP*3.9)/modelStruct.modelPar_EPSROX)+((Tcen*QMTCENCVA_i)/epsratio))/(((modelStruct.modelPar_TOXP*3.9)/modelStruct.modelPar_EPSROX)+((Tcen*QMTCENCVA_i)/epsratio)));
cox_acc = ((3.9*8.8542e-12)/(((modelStruct.modelPar_TOXP*3.9)/modelStruct.modelPar_EPSROX)+((Tcen*QMTCENCVA_i)/epsratio)));
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((R/(R-(Tcen*QMTCENCVA_i))));
AnalogFunctions::llnEvaluator evaluator_lln_1((1+(modelStruct.modelPar_TOXP/R)));
d_cox_acc_dX = (-(3.9*8.8542e-12)*(R*(((epsratio*evaluator_lln_0.getDerivs((R/(R-(Tcen*QMTCENCVA_i))),(((R-(Tcen*QMTCENCVA_i))*d_R_dX-R*(d_R_dX-(Tcen*d_QMTCENCVA_i_dX+d_Tcen_dX*QMTCENCVA_i)))/(R-(Tcen*QMTCENCVA_i))/(R-(Tcen*QMTCENCVA_i))))-evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))*d_epsratio_dX)/epsratio/epsratio)+((modelStruct.modelPar_EPSROX*evaluator_lln_1.getDerivs((1+(modelStruct.modelPar_TOXP/R)),((R*modelStruct.d_modelPar_TOXP_dX-modelStruct.modelPar_TOXP*d_R_dX)/R/R))*3.9-(evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)*modelStruct.d_modelPar_EPSROX_dX)/modelStruct.modelPar_EPSROX/modelStruct.modelPar_EPSROX))+d_R_dX*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX)))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX)))/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX))));
cox_acc = ((3.9*8.8542e-12)/(R*((evaluator_lln_0.getValues((R/(R-(Tcen*QMTCENCVA_i))))/epsratio)+((evaluator_lln_1.getValues((1+(modelStruct.modelPar_TOXP/R)))*3.9)/modelStruct.modelPar_EPSROX))));
}
}
}
d_beta_dX = ((Leff*((u0*cox)*d_Weff_dX+(u0*d_cox_dX+d_u0_dX*cox)*Weff)-((u0*cox)*Weff)*d_Leff_dX)/Leff/Leff);
beta = (((u0*cox)*Weff)/Leff);
d_Eeffm_dX = (EeffFactor*(d_qba_dX+(eta_mu*d_qia2_dX+d_eta_mu_dX*qia2))+d_EeffFactor_dX*(qba+(eta_mu*qia2)));
Eeffm = (EeffFactor*(qba+(eta_mu*qia2)));
{
double value_fabs_0 = fabs((qia2/qb0));
double value_pow_1 = pow((0.5*(1.0+value_fabs_0)),UCS_t);
double  deriv_fabs_0_d0 = ((((qia2/qb0))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = (((0.5*(1.0+value_fabs_0)) == 0.0)?0.0:(value_pow_1*UCS_t/(0.5*(1.0+value_fabs_0))));
double  deriv_pow_1_d1 = ((0.5*(1.0+value_fabs_0)) == 0.0)?0.0:(log((0.5*(1.0+value_fabs_0)))*value_pow_1);
d_T2_dX = ((deriv_pow_1_d0*(0.5*deriv_fabs_0_d0*(((qb0*d_qia2_dX-qia2*d_qb0_dX)/qb0/qb0))))+(deriv_pow_1_d1*(d_UCS_t_dX)));
T2 = value_pow_1;
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
{
double value_fabs_0 = fabs(Eeffm);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffm)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_T3_dX = (((UA_t+(UC_t*veseff))*((deriv_pow_1_d0*(deriv_fabs_0_d0*(d_Eeffm_dX)))+(deriv_pow_1_d1*(d_EU_i_dX)))+(d_UA_t_dX+(UC_t*d_veseff_dX+d_UC_t_dX*veseff))*value_pow_1)+((T2*d_UD_t_dX-UD_t*d_T2_dX)/T2/T2));
T3 = (((UA_t+(UC_t*veseff))*value_pow_1)+(UD_t/T2));
}
}
else
{
{
double value_fabs_0 = fabs(Eeffm);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffm)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_T3_dX = ((UA_t*((deriv_pow_1_d0*(deriv_fabs_0_d0*(d_Eeffm_dX)))+(deriv_pow_1_d1*(d_EU_i_dX)))+d_UA_t_dX*value_pow_1)+((T2*d_UD_t_dX-UD_t*d_T2_dX)/T2/T2));
T3 = ((UA_t*value_pow_1)+(UD_t/T2));
}
}
d_Dmob_dX = d_T3_dX;
Dmob = (1.0+T3);
d_Dmob_dX = ((instanceStruct.instancePar_U0MULT*d_Dmob_dX-Dmob*instanceStruct.d_instancePar_U0MULT_dX)/instanceStruct.instancePar_U0MULT/instanceStruct.instancePar_U0MULT);
Dmob = (Dmob/instanceStruct.instancePar_U0MULT);
d_ueff_dX = ((Dmob*d_u0_dX-u0*d_Dmob_dX)/Dmob/Dmob);
ueff = (u0/Dmob);
d_Eeffm_cv_dX = (EeffFactor*(d_qba_dX+eta_mu_cv*d_qia2_dX)+d_EeffFactor_dX*(qba+(eta_mu_cv*qia2)));
Eeffm_cv = (EeffFactor*(qba+(eta_mu_cv*qia2)));
{
double value_fabs_0 = fabs(Eeffm_cv);
double value_pow_1 = pow(value_fabs_0,EU_i);
double  deriv_fabs_0_d0 = (((Eeffm_cv)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*EU_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_T3_dX = ((UA_t*((deriv_pow_1_d0*(deriv_fabs_0_d0*(d_Eeffm_cv_dX)))+(deriv_pow_1_d1*(d_EU_i_dX)))+d_UA_t_dX*value_pow_1)+((T2*d_UD_t_dX-UD_t*d_T2_dX)/T2/T2));
T3 = ((UA_t*value_pow_1)+(UD_t/T2));
}
d_Dmob_cv_dX = d_T3_dX;
Dmob_cv = (1.0+T3);
d_Dmob_cv_dX = ((instanceStruct.instancePar_U0MULT*d_Dmob_cv_dX-Dmob_cv*instanceStruct.d_instancePar_U0MULT_dX)/instanceStruct.instancePar_U0MULT/instanceStruct.instancePar_U0MULT);
Dmob_cv = (Dmob_cv/instanceStruct.instancePar_U0MULT);
d_tmp_dX = ((scl*(DROUT_i*d_Leff_dX+d_DROUT_i_dX*Leff)-(DROUT_i*Leff)*d_scl_dX)/scl/scl);
tmp = (((DROUT_i*Leff)/scl)+1.0e-6);
if ((tmp<40.0))
{
{
double value_cosh_0 = cosh(tmp);
double  deriv_cosh_0_d0 = (sinh(tmp));
d_DIBLfactor_dX = ((((value_cosh_0-1.0)*0.5*d_PDIBL1_a_dX-(0.5*PDIBL1_a)*deriv_cosh_0_d0*(d_tmp_dX))/(value_cosh_0-1.0)/(value_cosh_0-1.0))+d_PDIBL2_i_dX);
DIBLfactor = (((0.5*PDIBL1_a)/(value_cosh_0-1.0))+PDIBL2_i);
}
}
else
{
{
double value_exp_0 = exp((-tmp));
double  deriv_exp_0_d0 = value_exp_0;
d_DIBLfactor_dX = ((PDIBL1_a*deriv_exp_0_d0*((-d_tmp_dX))+d_PDIBL1_a_dX*value_exp_0)+d_PDIBL2_i_dX);
DIBLfactor = ((PDIBL1_a*value_exp_0)+PDIBL2_i);
}
}
if ((PVAG_i>0))
{
d_PVAGfactor_dX = ((EsatL*(PVAG_i*d_qia_dX+d_PVAG_i_dX*qia)-(PVAG_i*qia)*d_EsatL_dX)/EsatL/EsatL);
PVAGfactor = (1.0+((PVAG_i*qia)/EsatL));
}
else
{
d_PVAGfactor_dX = (-(-((EsatL*(PVAG_i*d_qia_dX+d_PVAG_i_dX*qia)-(PVAG_i*qia)*d_EsatL_dX)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
PVAGfactor = (1.0/(1.0-((PVAG_i*qia)/EsatL)));
}
if ((Vdseff>vds))
{
d_Vdseff_dX = 0.0;
Vdseff = vds;
}
d_diffVds_dX = (-d_Vdseff_dX);
diffVds = (vds-Vdseff);
d_Vgst2Vtm_dX = (d_qia_dX+2.0*d_Vtm_dX);
Vgst2Vtm = (qia+(2.0*Vtm));
if ((DIBLfactor>0))
{
d_T1_dX = d_Vgst2Vtm_dX;
T1 = Vgst2Vtm;
d_T3_dX = (((Vdsat+T1)*d_T1_dX-T1*(d_Vdsat_dX+d_T1_dX))/(Vdsat+T1)/(Vdsat+T1));
T3 = (T1/(Vdsat+T1));
d_VaDIBL_dX = (((T1/DIBLfactor)*T3)*d_PVAGfactor_dX+((T1/DIBLfactor)*d_T3_dX+((DIBLfactor*d_T1_dX-T1*d_DIBLfactor_dX)/DIBLfactor/DIBLfactor)*T3)*PVAGfactor);
VaDIBL = (((T1/DIBLfactor)*T3)*PVAGfactor);
d_Moc_dX = ((VaDIBL*d_diffVds_dX-diffVds*d_VaDIBL_dX)/VaDIBL/VaDIBL);
Moc = (1.0+(diffVds/VaDIBL));
}
else
{
d_Moc_dX = 0.0;
Moc = 1.0;
}
if ((PCLM_i>0))
{
if ((PCLMG_i<0.0))
{
d_T1_dX = (-((-d_PCLM_i_dX/PCLM_i/PCLM_i)-(PCLMG_i*d_qia_dX+d_PCLMG_i_dX*qia))/((1.0/PCLM_i)-(PCLMG_i*qia))/((1.0/PCLM_i)-(PCLMG_i*qia)));
T1 = (1.0/((1.0/PCLM_i)-(PCLMG_i*qia)));
}
else
{
d_T1_dX = (d_PCLM_i_dX+(PCLMG_i*d_qia_dX+d_PCLMG_i_dX*qia));
T1 = (PCLM_i+(PCLMG_i*qia));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))));
d_Mclm_dX = (T1*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((Vdsat+EsatL)*((T1*(-d_Vdseff_dX)-(vds-Vdseff)*d_T1_dX)/T1/T1)-((vds-Vdseff)/T1)*(d_Vdsat_dX+d_EsatL_dX))/(Vdsat+EsatL)/(Vdsat+EsatL)))+d_T1_dX*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))));
Mclm = (1.0+(T1*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))));
}
}
else
{
d_Mclm_dX = 0.0;
Mclm = 1.0;
}
d_Moc_dX = (Moc*d_Mclm_dX+d_Moc_dX*Mclm);
Moc = (Moc*Mclm);
d_Esat1_dX = ((ueff*2.0*d_VSAT1_a_dX-(2.0*VSAT1_a)*d_ueff_dX)/ueff/ueff);
Esat1 = ((2.0*VSAT1_a)/ueff);
d_Esat1L_dX = (Esat1*d_Leff_dX+d_Esat1_dX*Leff);
Esat1L = (Esat1*Leff);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((dqi/Esat1L));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))));
d_T0_dX = evaluator_lexp_1.getDerivs((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))),(PSAT_i*evaluator_lln_0.getDerivs((dqi/Esat1L),((Esat1L*d_dqi_dX-dqi*d_Esat1L_dX)/Esat1L/Esat1L))+d_PSAT_i_dX*evaluator_lln_0.getValues((dqi/Esat1L))));
T0 = evaluator_lexp_1.getValues((PSAT_i*evaluator_lln_0.getValues((dqi/Esat1L))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(DELTAVSAT_i);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSAT_i)*evaluator_lln_0.getValues(DELTAVSAT_i)));
d_Ta_dX = evaluator_lexp_1.getDerivs(((1.0/PSAT_i)*evaluator_lln_0.getValues(DELTAVSAT_i)),((1.0/PSAT_i)*evaluator_lln_0.getDerivs(DELTAVSAT_i,d_DELTAVSAT_i_dX)+(-d_PSAT_i_dX/PSAT_i/PSAT_i)*evaluator_lln_0.getValues(DELTAVSAT_i)));
Ta = (1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues(DELTAVSAT_i))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((DELTAVSAT_i+T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))));
d_Dvsat_dX = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))),((1.0/PSAT_i)*evaluator_lln_0.getDerivs((DELTAVSAT_i+T0),(d_DELTAVSAT_i_dX+d_T0_dX))+(-d_PSAT_i_dX/PSAT_i/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0))))-(1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))*d_Ta_dX)/Ta/Ta);
Dvsat = ((1.0+evaluator_lexp_1.getValues(((1.0/PSAT_i)*evaluator_lln_0.getValues((DELTAVSAT_i+T0)))))/Ta);
}
d_Dvsat_dX = (d_Dvsat_dX+((((0.5*PTWG_a)*qia)*dqi)*d_dqi_dX+(((0.5*PTWG_a)*qia)*d_dqi_dX+((0.5*PTWG_a)*d_qia_dX+0.5*d_PTWG_a_dX*qia)*dqi)*dqi));
Dvsat = (Dvsat+((((0.5*PTWG_a)*qia)*dqi)*dqi));
d_T0_dX = (d_A1_t_dX+(((qia+(2.0*nVtm))*d_A2_t_dX-A2_t*(d_qia_dX+2.0*d_nVtm_dX))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
T0 = (A1_t+(A2_t/(qia+(2.0*nVtm))));
d_T1_dX = ((T0*dqi)*d_dqi_dX+(T0*d_dqi_dX+d_T0_dX*dqi)*dqi);
T1 = ((T0*dqi)*dqi);
d_T2_dX = d_T1_dX;
T2 = ((T1+1.0)-0.001);
{
double value_sqrt_0 = sqrt(((T2*T2)+0.004));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = 0.5*(d_T2_dX+deriv_sqrt_0_d0*((T2*d_T2_dX+d_T2_dX*T2)));
T3 = ((-1.0)+(0.5*(T2+value_sqrt_0)));
}
{
double value_sqrt_0 = sqrt((1.0+T3));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Nsat_dX = 0.5*deriv_sqrt_0_d0*(d_T3_dX);
Nsat = (0.5*(1.0+value_sqrt_0));
}
d_Dvsat_dX = (Dvsat*d_Nsat_dX+d_Dvsat_dX*Nsat);
Dvsat = (Dvsat*Nsat);
if ((K0_t!=0))
{
d_T1_dX = ((((K0SI_t*qia)+(2.0*nVtm))*d_K0_t_dX-K0_t*((K0SI_t*d_qia_dX+d_K0SI_t_dX*qia)+2.0*d_nVtm_dX))/((K0SI_t*qia)+(2.0*nVtm))/((K0SI_t*qia)+(2.0*nVtm)));
T1 = (K0_t/((K0SI_t*qia)+(2.0*nVtm)));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));
d_Mnud_dX = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dX));
Mnud = evaluator_lexp_0.getValues((-T1));
}
}
else
{
d_Mnud_dX = 0.0;
Mnud = 1.0;
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((K1_t+(K1SAT_t*vdsx)),1.0E-6);
d_T0_dX = evaluator_hypsmooth_0.getDerivs((K1_t+(K1SAT_t*vdsx)),1.0E-6,(d_K1_t_dX+d_K1SAT_t_dX*vdsx),0.0);
T0 = evaluator_hypsmooth_0.getValues((K1_t+(K1SAT_t*vdsx)),1.0E-6);
}
d_T1_dX = ((((K1SI_t*qia)+(2.0*nVtm))*d_T0_dX-T0*((K1SI_t*d_qia_dX+d_K1SI_t_dX*qia)+2.0*d_nVtm_dX))/((K1SI_t*qia)+(2.0*nVtm))/((K1SI_t*qia)+(2.0*nVtm)));
T1 = (T0/((K1SI_t*qia)+(2.0*nVtm)));
{
double value_sqrt_0 = sqrt((PHIBE_i-veseff));
double value_sqrt_1 = sqrt(PHIBE_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_T3_dX = (deriv_sqrt_0_d0*((d_PHIBE_i_dX-d_veseff_dX))-deriv_sqrt_1_d0*(d_PHIBE_i_dX));
T3 = (value_sqrt_0-value_sqrt_1);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((-T1)*T3));
d_Mob_dX = evaluator_lexp_0.getDerivs(((-T1)*T3),((-T1)*d_T3_dX+(-d_T1_dX)*T3));
Mob = evaluator_lexp_0.getValues(((-T1)*T3));
}
}
else
{
d_Mob_dX = 0.0;
Mob = 1.0;
}
d_EsatCV_dX = ((u0*((2.0*VSATCV_t)*d_Dmob_cv_dX+2.0*d_VSATCV_t_dX*Dmob_cv)-((2.0*VSATCV_t)*Dmob_cv)*d_u0_dX)/u0/u0);
EsatCV = (((2.0*VSATCV_t)*Dmob_cv)/u0);
d_EsatCVL_dX = (EsatCV*d_LeffCV_dX+d_EsatCV_dX*LeffCV);
EsatCVL = (EsatCV*LeffCV);
{
AnalogFunctions::llnEvaluator evaluator_lln_0((dqi/EsatCVL));
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))));
d_T0_dX = evaluator_lexp_1.getDerivs((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))),(PSATCV_i*evaluator_lln_0.getDerivs((dqi/EsatCVL),((EsatCVL*d_dqi_dX-dqi*d_EsatCVL_dX)/EsatCVL/EsatCVL))+d_PSATCV_i_dX*evaluator_lln_0.getValues((dqi/EsatCVL))));
T0 = evaluator_lexp_1.getValues((PSATCV_i*evaluator_lln_0.getValues((dqi/EsatCVL))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0(DELTAVSATCV_i);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSATCV_i)*evaluator_lln_0.getValues(DELTAVSATCV_i)));
d_Ta_dX = evaluator_lexp_1.getDerivs(((1.0/PSATCV_i)*evaluator_lln_0.getValues(DELTAVSATCV_i)),((1.0/PSATCV_i)*evaluator_lln_0.getDerivs(DELTAVSATCV_i,d_DELTAVSATCV_i_dX)+(-d_PSATCV_i_dX/PSATCV_i/PSATCV_i)*evaluator_lln_0.getValues(DELTAVSATCV_i)));
Ta = (1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues(DELTAVSATCV_i))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((DELTAVSATCV_i+T0));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))));
d_DvsatCV_dX = ((Ta*evaluator_lexp_1.getDerivs(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*evaluator_lln_0.getDerivs((DELTAVSATCV_i+T0),(d_DELTAVSATCV_i_dX+d_T0_dX))+(-d_PSATCV_i_dX/PSATCV_i/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0))))-(1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))*d_Ta_dX)/Ta/Ta);
DvsatCV = ((1.0+evaluator_lexp_1.getValues(((1.0/PSATCV_i)*evaluator_lln_0.getValues((DELTAVSATCV_i+T0)))))/Ta);
}
if ((PCLMCV_i!=0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))));
d_MclmCV_dX = (PCLMCV_i*evaluator_lln_0.getDerivs((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(((Vdsat+EsatCVL)*((PCLMCV_i*(-d_Vdseff_dX)-(vds-Vdseff)*d_PCLMCV_i_dX)/PCLMCV_i/PCLMCV_i)-((vds-Vdseff)/PCLMCV_i)*(d_Vdsat_dX+d_EsatCVL_dX))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+d_PCLMCV_i_dX*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL)))));
MclmCV = (1.0+(PCLMCV_i*evaluator_lln_0.getValues((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))));
}
}
else
{
d_MclmCV_dX = 0.0;
MclmCV = 1.0;
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_qb_dX = (((((-1.60219e-19)*nbody)*modelStruct.modelPar_HFIN)*instanceStruct.instancePar_TFIN)*d_LeffCV_dX+((((-1.60219e-19)*nbody)*modelStruct.modelPar_HFIN)*instanceStruct.d_instancePar_TFIN_dX+(((-1.60219e-19)*nbody)*modelStruct.d_modelPar_HFIN_dX+(-1.60219e-19)*d_nbody_dX*modelStruct.modelPar_HFIN)*instanceStruct.instancePar_TFIN)*LeffCV);
qb = (((((-1.60219e-19)*nbody)*modelStruct.modelPar_HFIN)*instanceStruct.instancePar_TFIN)*LeffCV);
}
else
{
d_qb_dX = ((((((-1.60219e-19)*nbody)*3.14159265358979323846)*R)*R)*d_LeffCV_dX+(((((-1.60219e-19)*nbody)*3.14159265358979323846)*R)*d_R_dX+((((-1.60219e-19)*nbody)*3.14159265358979323846)*d_R_dX+(-1.60219e-19)*d_nbody_dX*3.14159265358979323846*R)*R)*LeffCV);
qb = ((((((-1.60219e-19)*nbody)*3.14159265358979323846)*R)*R)*LeffCV);
}
if (((modelStruct.modelPar_GEOMOD!=3)&&(modelStruct.modelPar_COREMOD!=0)))
{
d_T0_dX = ((cox*2.0*d_csi_dX-(2.0*csi)*d_cox_dX)/cox/cox);
T0 = ((2.0*csi)/cox);
d_T1_dX = (g0s*d_tang0s_dX+d_g0s_dX*tang0s);
T1 = (g0s*tang0s);
d_T2_dX = (g0d*d_tang0d_dX+d_g0d_dX*tang0d);
T2 = (g0d*tang0d);
if ((NGATE_i>0.0))
{
d_T3_dX = ((((4.0*r2)*(((T1*d_T1_dX+d_T1_dX*T1)+(T1*d_T2_dX+d_T1_dX*T2))+(T2*d_T2_dX+d_T2_dX*T2))+4.0*d_r2_dX*(((T1*T1)+(T1*T2))+(T2*T2)))/3.0)+(T0*(d_T1_dX+d_T2_dX)+d_T0_dX*(T1+T2)));
T3 = ((((4.0*r2)*(((T1*T1)+(T1*T2))+(T2*T2)))/3.0)+(T0*(T1+T2)));
}
else
{
d_T3_dX = (T0*(d_T1_dX+d_T2_dX)+d_T0_dX*(T1+T2));
T3 = (T0*(T1+T2));
}
d_T6_dX = ((g0s*d_g0s_dX+d_g0s_dX*g0s)-(g0d*d_g0d_dX+d_g0d_dX*g0d));
T6 = ((g0s*g0s)-(g0d*g0d));
d_ids0_dX = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(d_T1_dX-d_T2_dX)+d_T3_dX*(T1-T2))-d_T6_dX)+(((2.0*T0)*nVtm)*d_nVtm_dX+((2.0*T0)*d_nVtm_dX+2.0*d_T0_dX*nVtm)*nVtm)*(((T3+2.0)*(T1-T2))-T6));
ids0 = ((((2.0*T0)*nVtm)*nVtm)*(((T3+2.0)*(T1-T2))-T6));
d_ids0_ov_dqi_dX = ((0.5*nVtm)*d_T3_dX+0.5*d_nVtm_dX*(T3+1.0));
ids0_ov_dqi = ((0.5*nVtm)*(T3+1.0));
if ((modelStruct.modelPar_RDSMOD!=0))
{
d_Rdsi_dX = 0.0;
Rdsi = 0.0;
d_Dr_dX = 0.0;
Dr = 1.0;
d_T2_dX = (-d_vfbsd_dX);
T2 = (vgs_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = deriv_sqrt_0_d0*((T2*d_T2_dX+d_T2_dX*T2));
T3 = value_sqrt_0;
}
d_vgs_eff_dX = 0.5*(d_T2_dX+d_T3_dX);
vgs_eff = (0.5*(T2+T3));
d_T4_dX = (PRWGS_i*d_vgs_eff_dX+d_PRWGS_i_dX*vgs_eff);
T4 = (1.0+(PRWGS_i*vgs_eff));
d_T1_dX = (-d_T4_dX/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = 0.5*(d_T1_dX+deriv_sqrt_0_d0*((T1*d_T1_dX+d_T1_dX*T1)));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))));
d_T5_dX = (RSW_i*(RSDR_a*evaluator_lexp_1.getDerivs(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))),0.5*modelStruct.d_modelPar_PRSDR_dX*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))+d_RSDR_a_dX*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))+d_RSW_i_dX*(1.0+(RSDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
T5 = (RSW_i*(1.0+(RSDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
}
d_Rsource_dX = (rdstemp*(d_RSourceGeo_dX+((RSWMIN_i+(T5*T0))*d_WeffWRFactor_dX+(d_RSWMIN_i_dX+(T5*d_T0_dX+d_T5_dX*T0))*WeffWRFactor))+d_rdstemp_dX*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));
Rsource = (rdstemp*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));
d_T2_dX = (-d_vfbsd_dX);
T2 = (vgd_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = deriv_sqrt_0_d0*((T2*d_T2_dX+d_T2_dX*T2));
T3 = value_sqrt_0;
}
d_vgd_eff_dX = 0.5*(d_T2_dX+d_T3_dX);
vgd_eff = (0.5*(T2+T3));
d_T4_dX = (PRWGD_i*d_vgd_eff_dX+d_PRWGD_i_dX*vgd_eff);
T4 = (1.0+(PRWGD_i*vgd_eff));
d_T1_dX = (-d_T4_dX/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = 0.5*(d_T1_dX+deriv_sqrt_0_d0*((T1*d_T1_dX+d_T1_dX*T1)));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))));
d_T5_dX = (RDW_i*(RDDR_a*evaluator_lexp_1.getDerivs(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))),0.5*modelStruct.d_modelPar_PRDDR_dX*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))+d_RDDR_a_dX*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))+d_RDW_i_dX*(1.0+(RDDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
T5 = (RDW_i*(1.0+(RDDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
}
d_Rdrain_dX = (rdstemp*(d_RDrainGeo_dX+((RDWMIN_i+(T5*T0))*d_WeffWRFactor_dX+(d_RDWMIN_i_dX+(T5*d_T0_dX+d_T5_dX*T0))*WeffWRFactor))+d_rdstemp_dX*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
Rdrain = (rdstemp*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
}
else
{
d_Rsource_dX = d_RSourceGeo_dX;
Rsource = RSourceGeo;
d_Rdrain_dX = d_RDrainGeo_dX;
Rdrain = RDrainGeo;
d_T4_dX = (PRWGS_i*d_qia_dX+d_PRWGS_i_dX*qia);
T4 = (1.0+(PRWGS_i*qia));
d_T1_dX = (-d_T4_dX/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = 0.5*(d_T1_dX+deriv_sqrt_0_d0*((T1*d_T1_dX+d_T1_dX*T1)));
T0 = (0.5*(T1+value_sqrt_0));
}
d_Rdsi_dX = ((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*d_WeffWRFactor_dX+(rdstemp*(d_RDSWMIN_i_dX+(RDSW_i*d_T0_dX+d_RDSW_i_dX*T0))+d_rdstemp_dX*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);
Rdsi = ((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);
d_Dr_dX = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dX+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dX+(NFINtotal*d_beta_dX+d_NFINtotal_dX*beta)*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dX+d_Dmob_dX*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
Dr = (1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
}
d_ids_dX = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dX+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dX+(((NFINtotal*beta)*ids0)*d_Moc_dX+((NFINtotal*beta)*d_ids0_dX+(NFINtotal*d_beta_dX+d_NFINtotal_dX*beta)*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dX+(Dmob*d_Dvsat_dX+d_Dmob_dX*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
ids = ((((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)/((Dmob*Dvsat)*Dr));
d_ids_dX = (ids*modelStruct.d_modelPar_IDS0MULT_dX+d_ids_dX*modelStruct.modelPar_IDS0MULT);
ids = (ids*modelStruct.modelPar_IDS0MULT);
if ((NGATE_i>0.0))
{
d_Tcom_dX = (((qis*d_qis_dX+d_qis_dX*qis)+(qis*d_qid_dX+d_qis_dX*qid))+(qid*d_qid_dX+d_qid_dX*qid));
Tcom = (((qis*qis)+(qis*qid))+(qid*qid));
}
else
{
d_Tcom_dX = 0.0;
Tcom = 0.0;
}
if ((NGATE_i>0))
{
d_idscv_dX = (((((2.0*cpoly)*d_Tcom_dX+2.0*d_cpoly_dX*Tcom)/3.0)+(kpoly*d_qia_dX+d_kpoly_dX*qia))+((2.0-etaiv)*d_nVtm_dX+(-d_etaiv_dX)*nVtm));
idscv = (((((2.0*cpoly)*Tcom)/3.0)+(kpoly*qia))+((2.0-etaiv)*nVtm));
}
else
{
d_idscv_dX = (d_qia_dX+((2.0-etaiv)*d_nVtm_dX+(-d_etaiv_dX)*nVtm));
idscv = (qia+((2.0-etaiv)*nVtm));
}
d_idscv_dX = ((DvsatCV*d_idscv_dX-idscv*d_DvsatCV_dX)/DvsatCV/DvsatCV);
idscv = (idscv/DvsatCV);
d_beta_cv_dX = ((LeffCV*((u0*coxeff)*d_WeffCV_dX+(u0*d_coxeff_dX+d_u0_dX*coxeff)*WeffCV)-((u0*coxeff)*WeffCV)*d_LeffCV_dX)/LeffCV/LeffCV);
beta_cv = (((u0*coxeff)*WeffCV)/LeffCV);
d_dqi_idscv_dX = ((idscv*d_dqi_dX-dqi*d_idscv_dX)/idscv/idscv);
dqi_idscv = (dqi/idscv);
if ((NGATE_i>0))
{
d_T1_dX = (d_kpoly_dX+((4.0*cpoly)*d_qia_dX+4.0*d_cpoly_dX*qia));
T1 = (kpoly+((4.0*cpoly)*qia));
}
else
{
d_T1_dX = 0.0;
T1 = 1.0;
}
d_qg_dX = (d_qia_dX+(((T1*dqi)*d_dqi_idscv_dX+(T1*d_dqi_dX+d_T1_dX*dqi)*dqi_idscv)/12.0));
qg = (qia+(((T1*dqi)*dqi_idscv)/12.0));
if ((NGATE_i>0))
{
d_T1_dX = (15.0*d_kpoly_dX+(cpoly*(32.0*d_qid_dX+28.0*d_qis_dX)+d_cpoly_dX*((32.0*qid)+(28.0*qis))));
T1 = ((15.0*kpoly)+(cpoly*((32.0*qid)+(28.0*qis))));
d_T2_dX = ((((63.0*kpoly)*d_kpoly_dX+63.0*d_kpoly_dX*kpoly)+(((126.0*cpoly)*kpoly)*d_qia_dX+((126.0*cpoly)*d_kpoly_dX+126.0*d_cpoly_dX*kpoly)*qia))+((cpoly*cpoly)*(256.0*d_Tcom_dX+((240.0*qis)*d_qid_dX+240.0*d_qis_dX*qid))+(cpoly*d_cpoly_dX+d_cpoly_dX*cpoly)*((256.0*Tcom)+((240.0*qis)*qid))));
T2 = ((((63.0*kpoly)*kpoly)+(((126.0*cpoly)*kpoly)*qia))+((cpoly*cpoly)*((256.0*Tcom)+((240.0*qis)*qid))));
}
else
{
d_T1_dX = 0.0;
T1 = 15.0;
d_T2_dX = 0.0;
T2 = 63.0;
}
d_qd_dX = (0.5*d_qia_dX-((dqi*((-((T1*d_dqi_idscv_dX+d_T1_dX*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dX+(T2*d_dqi_idscv_dX+d_T2_dX*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dX*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
qd = ((0.5*qia)-((dqi*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_inv_MclmCV_dX = (-d_MclmCV_dX/MclmCV/MclmCV);
inv_MclmCV = (1.0/MclmCV);
d_qg_dX = ((inv_MclmCV*d_qg_dX+d_inv_MclmCV_dX*qg)+((MclmCV-1.0)*d_qid_dX+d_MclmCV_dX*qid));
qg = ((inv_MclmCV*qg)+((MclmCV-1.0)*qid));
d_qd_dX = (((inv_MclmCV*inv_MclmCV)*d_qd_dX+(inv_MclmCV*d_inv_MclmCV_dX+d_inv_MclmCV_dX*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dX+0.5*(d_MclmCV_dX-d_inv_MclmCV_dX)*qid));
qd = (((inv_MclmCV*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*qid));
d_T1_dX = ((WeffCV*LeffCV)*d_coxeff_dX+(WeffCV*d_LeffCV_dX+d_WeffCV_dX*LeffCV)*coxeff);
T1 = ((WeffCV*LeffCV)*coxeff);
d_qinv_dX = ((NFINtotal*qg)*d_T1_dX+(NFINtotal*d_qg_dX+d_NFINtotal_dX*qg)*T1);
qinv = ((NFINtotal*qg)*T1);
d_qd_dX = ((NFINtotal*qd)*d_T1_dX+(NFINtotal*d_qd_dX+d_NFINtotal_dX*qd)*T1);
qd = ((NFINtotal*qd)*T1);
d_qg_dX = (d_qinv_dX-(NFINtotal*d_qb_dX+d_NFINtotal_dX*qb));
qg = (qinv-(NFINtotal*qb));
d_qd_dX = (-d_qd_dX);
qd = (-qd);
d_qb_dX = ((+NFINtotal)*d_qb_dX+(+d_NFINtotal_dX)*qb);
qb = ((+NFINtotal)*qb);
d_qs_dX = (((-d_qg_dX)-d_qd_dX)-d_qb_dX);
qs = (((-qg)-qd)-qb);
if ((sigvds<0))
{
d_T1_dX = d_qd_dX;
T1 = qd;
d_qd_dX = d_qs_dX;
qd = qs;
d_qs_dX = d_T1_dX;
qs = T1;
}
}
else
{
if ((modelStruct.modelPar_NQSMOD==3))
{
UserInfo(theInstance)  << "[bsimcmg] Although the model selector NQSMOD is set to 3, the NQS charge segmentation model is not activated in the Verilog-A code.  Please uncomment `define __NQSMOD3__ in bsimcmg.va to activate it. Quasi-static calculations being performed instead" << " " <<  std::endl; 
}
if ((NGATE_i>0.0))
{
d_Tcom_dX = (((qis*d_qis_dX+d_qis_dX*qis)+(qis*d_qid_dX+d_qis_dX*qid))+(qid*d_qid_dX+d_qid_dX*qid));
Tcom = (((qis*qis)+(qis*qid))+(qid*qid));
}
else
{
d_Tcom_dX = 0.0;
Tcom = 0.0;
}
if ((NGATE_i>0))
{
d_T0_dX = (((2.0*cpoly)*d_Tcom_dX+2.0*d_cpoly_dX*Tcom)/3);
T0 = (((2.0*cpoly)*Tcom)/3);
d_T1_dX = (kpoly*d_qia_dX+d_kpoly_dX*qia);
T1 = (kpoly*qia);
}
else
{
d_T0_dX = 0.0;
T0 = 0;
d_T1_dX = d_qia_dX;
T1 = qia;
}
d_etaiv_dX = (((q0+(cdop*qia))*d_q0_dX-q0*(d_q0_dX+(cdop*d_qia_dX+d_cdop_dX*qia)))/(q0+(cdop*qia))/(q0+(cdop*qia)));
etaiv = (q0/(q0+(cdop*qia)));
d_T2_dX = ((2.0-etaiv)*d_nVtm_dX+(-d_etaiv_dX)*nVtm);
T2 = ((2.0-etaiv)*nVtm);
d_ids0_ov_dqi_dX = ((d_T0_dX+d_T1_dX)+d_T2_dX);
ids0_ov_dqi = ((T0+T1)+T2);
d_ids0_dX = (ids0_ov_dqi*d_dqi_dX+d_ids0_ov_dqi_dX*dqi);
ids0 = (ids0_ov_dqi*dqi);
if ((modelStruct.modelPar_RDSMOD!=0))
{
d_Rdsi_dX = 0.0;
Rdsi = 0.0;
d_Dr_dX = 0.0;
Dr = 1.0;
d_T2_dX = (-d_vfbsd_dX);
T2 = (vgs_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = deriv_sqrt_0_d0*((T2*d_T2_dX+d_T2_dX*T2));
T3 = value_sqrt_0;
}
d_vgs_eff_dX = 0.5*(d_T2_dX+d_T3_dX);
vgs_eff = (0.5*(T2+T3));
d_T4_dX = (PRWGS_i*d_vgs_eff_dX+d_PRWGS_i_dX*vgs_eff);
T4 = (1.0+(PRWGS_i*vgs_eff));
d_T1_dX = (-d_T4_dX/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = 0.5*(d_T1_dX+deriv_sqrt_0_d0*((T1*d_T1_dX+d_T1_dX*T1)));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))));
d_T5_dX = (RSW_i*(RSDR_a*evaluator_lexp_1.getDerivs(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6))),0.5*modelStruct.d_modelPar_PRSDR_dX*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))+d_RSDR_a_dX*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))+d_RSW_i_dX*(1.0+(RSDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
T5 = (RSW_i*(1.0+(RSDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRSDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_si_s])*(probeVars[admsProbeID_V_si_s]))+1.0E-6)))))));
}
d_Rsource_dX = (rdstemp*(d_RSourceGeo_dX+((RSWMIN_i+(T5*T0))*d_WeffWRFactor_dX+(d_RSWMIN_i_dX+(T5*d_T0_dX+d_T5_dX*T0))*WeffWRFactor))+d_rdstemp_dX*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));
Rsource = (rdstemp*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));
d_T2_dX = (-d_vfbsd_dX);
T2 = (vgd_noswap-vfbsd);
{
double value_sqrt_0 = sqrt(((T2*T2)+1.0e-1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T3_dX = deriv_sqrt_0_d0*((T2*d_T2_dX+d_T2_dX*T2));
T3 = value_sqrt_0;
}
d_vgd_eff_dX = 0.5*(d_T2_dX+d_T3_dX);
vgd_eff = (0.5*(T2+T3));
d_T4_dX = (PRWGD_i*d_vgd_eff_dX+d_PRWGD_i_dX*vgd_eff);
T4 = (1.0+(PRWGD_i*vgd_eff));
d_T1_dX = (-d_T4_dX/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = 0.5*(d_T1_dX+deriv_sqrt_0_d0*((T1*d_T1_dX+d_T1_dX*T1)));
T0 = (0.5*(T1+value_sqrt_0));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))));
d_T5_dX = (RDW_i*(RDDR_a*evaluator_lexp_1.getDerivs(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6))),0.5*modelStruct.d_modelPar_PRDDR_dX*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))+d_RDDR_a_dX*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))+d_RDW_i_dX*(1.0+(RDDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
T5 = (RDW_i*(1.0+(RDDR_a*evaluator_lexp_1.getValues(((0.5*modelStruct.modelPar_PRDDR)*evaluator_lln_0.getValues((((probeVars[admsProbeID_V_di_d])*(probeVars[admsProbeID_V_di_d]))+1.0E-6)))))));
}
d_Rdrain_dX = (rdstemp*(d_RDrainGeo_dX+((RDWMIN_i+(T5*T0))*d_WeffWRFactor_dX+(d_RDWMIN_i_dX+(T5*d_T0_dX+d_T5_dX*T0))*WeffWRFactor))+d_rdstemp_dX*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
Rdrain = (rdstemp*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
}
else
{
d_Rsource_dX = d_RSourceGeo_dX;
Rsource = RSourceGeo;
d_Rdrain_dX = d_RDrainGeo_dX;
Rdrain = RDrainGeo;
d_T4_dX = (PRWGS_i*d_qia_dX+d_PRWGS_i_dX*qia);
T4 = (1.0+(PRWGS_i*qia));
d_T1_dX = (-d_T4_dX/T4/T4);
T1 = (1.0/T4);
{
double value_sqrt_0 = sqrt(((T1*T1)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T0_dX = 0.5*(d_T1_dX+deriv_sqrt_0_d0*((T1*d_T1_dX+d_T1_dX*T1)));
T0 = (0.5*(T1+value_sqrt_0));
}
d_Rdsi_dX = ((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*d_WeffWRFactor_dX+(rdstemp*(d_RDSWMIN_i_dX+(RDSW_i*d_T0_dX+d_RDSW_i_dX*T0))+d_rdstemp_dX*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);
Rdsi = ((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);
d_Dr_dX = ((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*d_Rdsi_dX+(((Dmob*Dvsat)*((NFINtotal*beta)*d_ids0_ov_dqi_dX+(NFINtotal*d_beta_dX+d_NFINtotal_dX*beta)*ids0_ov_dqi)-((NFINtotal*beta)*ids0_ov_dqi)*(Dmob*d_Dvsat_dX+d_Dmob_dX*Dvsat))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi);
Dr = (1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
}
d_ids_dX = ((((Dmob*Dvsat)*Dr)*(((((NFINtotal*beta)*ids0)*Moc)*Mob)*d_Mnud_dX+((((NFINtotal*beta)*ids0)*Moc)*d_Mob_dX+(((NFINtotal*beta)*ids0)*d_Moc_dX+((NFINtotal*beta)*d_ids0_dX+(NFINtotal*d_beta_dX+d_NFINtotal_dX*beta)*ids0)*Moc)*Mob)*Mnud)-(((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)*((Dmob*Dvsat)*d_Dr_dX+(Dmob*d_Dvsat_dX+d_Dmob_dX*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
ids = ((((((NFINtotal*beta)*ids0)*Moc)*Mob)*Mnud)/((Dmob*Dvsat)*Dr));
d_ids_dX = (ids*modelStruct.d_modelPar_IDS0MULT_dX+d_ids_dX*modelStruct.modelPar_IDS0MULT);
ids = (ids*modelStruct.modelPar_IDS0MULT);
if ((NGATE_i>0))
{
d_idscv_dX = (((((2.0*cpoly)*d_Tcom_dX+2.0*d_cpoly_dX*Tcom)/3.0)+(kpoly*d_qia_dX+d_kpoly_dX*qia))+((2.0-etaiv)*d_nVtm_dX+(-d_etaiv_dX)*nVtm));
idscv = (((((2.0*cpoly)*Tcom)/3.0)+(kpoly*qia))+((2.0-etaiv)*nVtm));
}
else
{
d_idscv_dX = (d_qia_dX+((2.0-etaiv)*d_nVtm_dX+(-d_etaiv_dX)*nVtm));
idscv = (qia+((2.0-etaiv)*nVtm));
}
d_idscv_dX = ((DvsatCV*d_idscv_dX-idscv*d_DvsatCV_dX)/DvsatCV/DvsatCV);
idscv = (idscv/DvsatCV);
d_beta_cv_dX = ((LeffCV*((u0*coxeff)*d_WeffCV_dX+(u0*d_coxeff_dX+d_u0_dX*coxeff)*WeffCV)-((u0*coxeff)*WeffCV)*d_LeffCV_dX)/LeffCV/LeffCV);
beta_cv = (((u0*coxeff)*WeffCV)/LeffCV);
d_dqi_idscv_dX = ((idscv*d_dqi_dX-dqi*d_idscv_dX)/idscv/idscv);
dqi_idscv = (dqi/idscv);
if ((NGATE_i>0))
{
d_T1_dX = (d_kpoly_dX+((4.0*cpoly)*d_qia_dX+4.0*d_cpoly_dX*qia));
T1 = (kpoly+((4.0*cpoly)*qia));
}
else
{
d_T1_dX = 0.0;
T1 = 1.0;
}
d_qg_dX = (d_qia_dX+(((T1*dqi)*d_dqi_idscv_dX+(T1*d_dqi_dX+d_T1_dX*dqi)*dqi_idscv)/12.0));
qg = (qia+(((T1*dqi)*dqi_idscv)/12.0));
if ((NGATE_i>0))
{
d_T1_dX = (15.0*d_kpoly_dX+(cpoly*(32.0*d_qid_dX+28.0*d_qis_dX)+d_cpoly_dX*((32.0*qid)+(28.0*qis))));
T1 = ((15.0*kpoly)+(cpoly*((32.0*qid)+(28.0*qis))));
d_T2_dX = ((((63.0*kpoly)*d_kpoly_dX+63.0*d_kpoly_dX*kpoly)+(((126.0*cpoly)*kpoly)*d_qia_dX+((126.0*cpoly)*d_kpoly_dX+126.0*d_cpoly_dX*kpoly)*qia))+((cpoly*cpoly)*(256.0*d_Tcom_dX+((240.0*qis)*d_qid_dX+240.0*d_qis_dX*qid))+(cpoly*d_cpoly_dX+d_cpoly_dX*cpoly)*((256.0*Tcom)+((240.0*qis)*qid))));
T2 = ((((63.0*kpoly)*kpoly)+(((126.0*cpoly)*kpoly)*qia))+((cpoly*cpoly)*((256.0*Tcom)+((240.0*qis)*qid))));
}
else
{
d_T1_dX = 0.0;
T1 = 15.0;
d_T2_dX = 0.0;
T2 = 63.0;
}
d_qd_dX = (0.5*d_qia_dX-((dqi*((-((T1*d_dqi_idscv_dX+d_T1_dX*dqi_idscv)/30.0))-(((T2*dqi_idscv)*d_dqi_idscv_dX+(T2*d_dqi_idscv_dX+d_T2_dX*dqi_idscv)*dqi_idscv)/1260.0))+d_dqi_dX*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
qd = ((0.5*qia)-((dqi*((1.0-((T1*dqi_idscv)/30.0))-(((T2*dqi_idscv)*dqi_idscv)/1260.0)))/12.0));
d_inv_MclmCV_dX = (-d_MclmCV_dX/MclmCV/MclmCV);
inv_MclmCV = (1.0/MclmCV);
d_qg_dX = ((inv_MclmCV*d_qg_dX+d_inv_MclmCV_dX*qg)+((MclmCV-1.0)*d_qid_dX+d_MclmCV_dX*qid));
qg = ((inv_MclmCV*qg)+((MclmCV-1.0)*qid));
d_qd_dX = (((inv_MclmCV*inv_MclmCV)*d_qd_dX+(inv_MclmCV*d_inv_MclmCV_dX+d_inv_MclmCV_dX*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*d_qid_dX+0.5*(d_MclmCV_dX-d_inv_MclmCV_dX)*qid));
qd = (((inv_MclmCV*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*qid));
d_T1_dX = ((WeffCV*LeffCV)*d_coxeff_dX+(WeffCV*d_LeffCV_dX+d_WeffCV_dX*LeffCV)*coxeff);
T1 = ((WeffCV*LeffCV)*coxeff);
d_qinv_dX = ((NFINtotal*qg)*d_T1_dX+(NFINtotal*d_qg_dX+d_NFINtotal_dX*qg)*T1);
qinv = ((NFINtotal*qg)*T1);
d_qd_dX = ((NFINtotal*qd)*d_T1_dX+(NFINtotal*d_qd_dX+d_NFINtotal_dX*qd)*T1);
qd = ((NFINtotal*qd)*T1);
d_qg_dX = (d_qinv_dX-(NFINtotal*d_qb_dX+d_NFINtotal_dX*qb));
qg = (qinv-(NFINtotal*qb));
d_qd_dX = (-d_qd_dX);
qd = (-qd);
d_qb_dX = ((+NFINtotal)*d_qb_dX+(+d_NFINtotal_dX)*qb);
qb = ((+NFINtotal)*qb);
d_qs_dX = (((-d_qg_dX)-d_qd_dX)-d_qb_dX);
qs = (((-qg)-qd)-qb);
if ((sigvds<0))
{
d_T1_dX = d_qd_dX;
T1 = qd;
d_qd_dX = d_qs_dX;
qd = qs;
d_qs_dX = d_T1_dX;
qs = T1;
}
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_T1_dX = (((NFINtotal*WeffCV0)*LeffCV_acc)*d_cox_acc_dX+((NFINtotal*WeffCV0)*d_LeffCV_acc_dX+(NFINtotal*d_WeffCV0_dX+d_NFINtotal_dX*WeffCV0)*LeffCV_acc)*cox_acc);
T1 = (((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc);
d_qg_acc_dX = ((-qi_acc)*d_T1_dX+(-d_qi_acc_dX)*T1);
qg_acc = ((-qi_acc)*T1);
d_qb_acc_dX = ((+qi_acc)*d_T1_dX+(+d_qi_acc_dX)*T1);
qb_acc = ((+qi_acc)*T1);
}
d_qgs_ov_dX = 0.0;
qgs_ov = 0.0;
d_qgd_ov_dX = 0.0;
qgd_ov = 0.0;
if ((modelStruct.modelPar_CGEOMOD!=1))
{
d_T1_dX = (NFINtotal*d_WeffCV_dX+d_NFINtotal_dX*WeffCV)*devsign;
T1 = ((NFINtotal*WeffCV)*devsign);
d_T2_dX = 0.0;
T2 = (devsign*(probeVars[admsProbeID_V_g_si]));
d_T0_dX = (d_T2_dX-d_vfbsd_dX);
T0 = ((T2-vfbsd)+0.02);
{
double value_sqrt_0 = sqrt(((T0*T0)+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vgs_overlap_dX = 0.5*(d_T0_dX-deriv_sqrt_0_d0*((T0*d_T0_dX+d_T0_dX*T0)));
vgs_overlap = (0.5*(T0-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qgs_ov_dX = (T1*((CGSL_i*(((d_T2_dX-d_vfbsd_dX)-d_vgs_overlap_dX)-((0.5*CKAPPAS_i)*deriv_sqrt_0_d0*((-((CKAPPAS_i*4.0*d_vgs_overlap_dX-(4.0*vgs_overlap)*d_CKAPPAS_i_dX)/CKAPPAS_i/CKAPPAS_i)))+0.5*d_CKAPPAS_i_dX*(value_sqrt_0-1.0)))+d_CGSL_i_dX*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*d_T2_dX+d_CGSO_i_dX*T2))+d_T1_dX*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
qgs_ov = (T1*((CGSL_i*(((T2-vfbsd)-vgs_overlap)-((0.5*CKAPPAS_i)*(value_sqrt_0-1.0))))+(CGSO_i*T2)));
}
d_T2_dX = 0.0;
T2 = (devsign*(probeVars[admsProbeID_V_g_di]));
d_T0_dX = (d_T2_dX-d_vfbsd_dX);
T0 = ((T2-vfbsd)+0.02);
{
double value_sqrt_0 = sqrt(((T0*T0)+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vgd_overlap_dX = 0.5*(d_T0_dX-deriv_sqrt_0_d0*((T0*d_T0_dX+d_T0_dX*T0)));
vgd_overlap = (0.5*(T0-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qgd_ov_dX = (T1*((CGDL_i*(((d_T2_dX-d_vfbsd_dX)-d_vgd_overlap_dX)-((0.5*CKAPPAD_i)*deriv_sqrt_0_d0*((-((CKAPPAD_i*4.0*d_vgd_overlap_dX-(4.0*vgd_overlap)*d_CKAPPAD_i_dX)/CKAPPAD_i/CKAPPAD_i)))+0.5*d_CKAPPAD_i_dX*(value_sqrt_0-1.0)))+d_CGDL_i_dX*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*d_T2_dX+d_CGDO_i_dX*T2))+d_T1_dX*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
qgd_ov = (T1*((CGDL_i*(((T2-vfbsd)-vgd_overlap)-((0.5*CKAPPAD_i)*(value_sqrt_0-1.0))))+(CGDO_i*T2)));
}
}
if ((modelStruct.modelPar_CGEOMOD==0))
{
d_T1_dX = (NFINtotal*d_WeffCV0_dX+d_NFINtotal_dX*WeffCV0);
T1 = (NFINtotal*WeffCV0);
d_qgs_fr_dX = (T1*d_CFS_i_dX+d_T1_dX*CFS_i)*(probeVars[admsProbeID_V_g_si]);
qgs_fr = ((T1*CFS_i)*(probeVars[admsProbeID_V_g_si]));
d_qgd_fr_dX = (T1*d_CFD_i_dX+d_T1_dX*CFD_i)*(probeVars[admsProbeID_V_g_di]);
qgd_fr = ((T1*CFD_i)*(probeVars[admsProbeID_V_g_di]));
d_qgs_parasitic_dX = (d_qgs_ov_dX+d_qgs_fr_dX);
qgs_parasitic = (qgs_ov+qgs_fr);
d_qgd_parasitic_dX = (d_qgd_ov_dX+d_qgd_fr_dX);
qgd_parasitic = (qgd_ov+qgd_fr);
}
else
{
if ((modelStruct.modelPar_CGEOMOD==1))
{
if ((modelStruct.modelPar_CGEO1SW==1))
{
d_T0_dX = (NFINtotal*d_WeffCV0_dX+d_NFINtotal_dX*WeffCV0);
T0 = (NFINtotal*WeffCV0);
d_COVS_i_dX = (T0*d_COVS_i_dX+d_T0_dX*COVS_i);
COVS_i = (T0*COVS_i);
d_COVD_i_dX = (T0*d_COVD_i_dX+d_T0_dX*COVD_i);
COVD_i = (T0*COVD_i);
d_cgsp_dX = (T0*instanceStruct.d_instancePar_CGSP_dX+d_T0_dX*instanceStruct.instancePar_CGSP);
cgsp = (T0*instanceStruct.instancePar_CGSP);
d_cgdp_dX = (T0*instanceStruct.d_instancePar_CGDP_dX+d_T0_dX*instanceStruct.instancePar_CGDP);
cgdp = (T0*instanceStruct.instancePar_CGDP);
}
else
{
d_cgsp_dX = instanceStruct.d_instancePar_CGSP_dX;
cgsp = instanceStruct.instancePar_CGSP;
d_cgdp_dX = instanceStruct.d_instancePar_CGDP_dX;
cgdp = instanceStruct.instancePar_CGDP;
}
d_qgs_ov_dX = d_COVS_i_dX*(probeVars[admsProbeID_V_g_si]);
qgs_ov = (COVS_i*(probeVars[admsProbeID_V_g_si]));
d_qgd_ov_dX = d_COVD_i_dX*(probeVars[admsProbeID_V_g_di]);
qgd_ov = (COVD_i*(probeVars[admsProbeID_V_g_di]));
d_qgs_parasitic_dX = d_qgs_ov_dX;
qgs_parasitic = qgs_ov;
d_qgd_parasitic_dX = d_qgd_ov_dX;
qgd_parasitic = qgd_ov;
d_qgs_fr_dX = d_cgsp_dX*(probeVars[admsProbeID_V_g_s]);
qgs_fr = (cgsp*(probeVars[admsProbeID_V_g_s]));
d_qgd_fr_dX = d_cgdp_dX*(probeVars[admsProbeID_V_g_d]);
qgd_fr = (cgdp*(probeVars[admsProbeID_V_g_d]));
}
else
{
d_qgs_fr_dX = d_Cfr_geo_dX*(probeVars[admsProbeID_V_g_si]);
qgs_fr = (Cfr_geo*(probeVars[admsProbeID_V_g_si]));
d_qgd_fr_dX = d_Cfr_geo_dX*(probeVars[admsProbeID_V_g_di]);
qgd_fr = (Cfr_geo*(probeVars[admsProbeID_V_g_di]));
d_qgs_parasitic_dX = (d_qgs_ov_dX+d_qgs_fr_dX);
qgs_parasitic = (qgs_ov+qgs_fr);
d_qgd_parasitic_dX = (d_qgd_ov_dX+d_qgd_fr_dX);
qgd_parasitic = (qgd_ov+qgd_fr);
}
}
d_qds_fr_dX = instanceStruct.d_instancePar_CDSP_dX*(probeVars[admsProbeID_V_d_s]);
qds_fr = (instanceStruct.instancePar_CDSP*(probeVars[admsProbeID_V_d_s]));
d_Iii_dX = 0.0;
Iii = 0;
if ((modelStruct.modelPar_IIMOD==1))
{
d_T0_dX = ((Leff*(d_ALPHA0_t_dX+(ALPHA1_t*d_Leff_dX+d_ALPHA1_t_dX*Leff))-(ALPHA0_t+(ALPHA1_t*Leff))*d_Leff_dX)/Leff/Leff);
T0 = ((ALPHA0_t+(ALPHA1_t*Leff))/Leff);
if (((T0<=0.0)||(BETA0_t<=0.0)))
{
d_Iii_dX = 0.0;
Iii = 0.0;
}
else
{
d_T1_dX = (((diffVds+1.0e-30)*(-d_BETA0_t_dX)-(-BETA0_t)*d_diffVds_dX)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
T1 = ((-BETA0_t)/(diffVds+1.0e-30));
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
d_Iii_dX = (((T0*diffVds)*ids)*evaluator_lexp_0.getDerivs(T1,d_T1_dX)+((T0*diffVds)*d_ids_dX+(T0*d_diffVds_dX+d_T0_dX*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
Iii = (((T0*diffVds)*ids)*evaluator_lexp_0.getValues(T1));
}
}
}
else
{
if ((modelStruct.modelPar_IIMOD==2))
{
d_ALPHAII_dX = ((Leff*(d_ALPHAII0_t_dX+(ALPHAII1_t*d_Leff_dX+d_ALPHAII1_t_dX*Leff))-(ALPHAII0_t+(ALPHAII1_t*Leff))*d_Leff_dX)/Leff/Leff);
ALPHAII = ((ALPHAII0_t+(ALPHAII1_t*Leff))/Leff);
if ((ALPHAII<=0.0))
{
d_Iii_dX = 0.0;
Iii = 0.0;
}
else
{
d_T0_dX = (ESATII_i*d_Leff_dX+d_ESATII_i_dX*Leff);
T0 = (ESATII_i*Leff);
d_T1_dX = (((1.0+T0)*(SII0_t*d_T0_dX+d_SII0_t_dX*T0)-(SII0_t*T0)*d_T0_dX)/(1.0+T0)/(1.0+T0));
T1 = ((SII0_t*T0)/(1.0+T0));
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((SII1_i*vgsfbeff),1.0e-3);
d_T0_dX = (-evaluator_hypsmooth_0.getDerivs((SII1_i*vgsfbeff),1.0e-3,(SII1_i*d_vgsfbeff_dX+d_SII1_i_dX*vgsfbeff),0.0)/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3))/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3)));
T0 = (1.0/(1.0+evaluator_hypsmooth_0.getValues((SII1_i*vgsfbeff),1.0e-3)));
}
d_T3_dX = (d_T0_dX+d_SII2_i_dX);
T3 = (T0+SII2_i);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((vgsfbeff*T3),1.0e-3);
d_T2_dX = evaluator_hypsmooth_0.getDerivs((vgsfbeff*T3),1.0e-3,(vgsfbeff*d_T3_dX+d_vgsfbeff_dX*T3),0.0);
T2 = evaluator_hypsmooth_0.getValues((vgsfbeff*T3),1.0e-3);
}
d_T3_dX = (-d_SIID_i_dX*vds/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
T3 = (1.0/(1.0+(SIID_i*vds)));
d_VgsStep_dX = ((T1*T2)*d_T3_dX+(T1*d_T2_dX+d_T1_dX*T2)*T3);
VgsStep = ((T1*T2)*T3);
d_Vdsatii_dX = (VgsStep*(-((Leff*d_LII_i_dX-LII_i*d_Leff_dX)/Leff/Leff))+d_VgsStep_dX*(1.0-(LII_i/Leff)));
Vdsatii = (VgsStep*(1.0-(LII_i/Leff)));
d_Vdiff_dX = (-d_Vdsatii_dX);
Vdiff = (vds-Vdsatii);
d_T0_dX = ((d_BETAII2_i_dX+(BETAII1_i*d_Vdiff_dX+d_BETAII1_i_dX*Vdiff))+((BETAII0_i*Vdiff)*d_Vdiff_dX+(BETAII0_i*d_Vdiff_dX+d_BETAII0_i_dX*Vdiff)*Vdiff));
T0 = ((BETAII2_i+(BETAII1_i*Vdiff))+((BETAII0_i*Vdiff)*Vdiff));
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0E-10));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_T1_dX = deriv_sqrt_0_d0*((T0*d_T0_dX+d_T0_dX*T0));
T1 = value_sqrt_0;
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((Vdiff/T1));
d_T2_dX = (-(ALPHAII*evaluator_lexp_0.getDerivs((Vdiff/T1),((T1*d_Vdiff_dX-Vdiff*d_T1_dX)/T1/T1))+d_ALPHAII_dX*evaluator_lexp_0.getValues((Vdiff/T1))));
T2 = ((10.0-(ALPHAII*evaluator_lexp_0.getValues((Vdiff/T1))))-0.01);
}
{
double value_sqrt_0 = sqrt(((T2*T2)+((4.0*10.0)*0.01)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Ratio_dX = (-0.5*(d_T2_dX+deriv_sqrt_0_d0*((T2*d_T2_dX+d_T2_dX*T2))));
Ratio = (10.0-(0.5*(T2+value_sqrt_0)));
}
d_Iii_dX = (Ratio*d_ids_dX+d_Ratio_dX*ids);
Iii = (Ratio*ids);
}
}
}
d_igbinv_dX = 0.0;
igbinv = 0.0;
d_igbacc_dX = 0.0;
igbacc = 0.0;
d_igcs_dX = 0.0;
igcs = 0.0;
d_igcd_dX = 0.0;
igcd = 0.0;
d_igs_dX = 0.0;
igs = 0.0;
d_igd_dX = 0.0;
igd = 0.0;
if ((modelStruct.modelPar_IGBMOD!=0))
{
d_T1_dX = ((Vtm*((NIGBINV_i*(d_qia_dX-d_EIGBINV_i_dX)-(qia-EIGBINV_i)*d_NIGBINV_i_dX)/NIGBINV_i/NIGBINV_i)-((qia-EIGBINV_i)/NIGBINV_i)*d_Vtm_dX)/Vtm/Vtm);
T1 = (((qia-EIGBINV_i)/NIGBINV_i)/Vtm);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(T1)));
d_Vaux_Igbinv_dX = ((NIGBINV_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dX))+(NIGBINV_i*d_Vtm_dX+d_NIGBINV_i_dX*Vtm)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(T1))));
Vaux_Igbinv = ((NIGBINV_i*Vtm)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(T1))));
}
d_T2_dX = (d_AIGBINV_t_dX-(BIGBINV_i*d_qia_dX+d_BIGBINV_i_dX*qia));
T2 = (AIGBINV_t-(BIGBINV_i*qia));
d_T3_dX = (CIGBINV_i*d_qia_dX+d_CIGBINV_i_dX*qia);
T3 = (1+(CIGBINV_i*qia));
d_T4_dX = ((((-9.82222e11)*modelStruct.modelPar_TOXG)*T2)*d_T3_dX+(((-9.82222e11)*modelStruct.modelPar_TOXG)*d_T2_dX+(-9.82222e11)*modelStruct.d_modelPar_TOXG_dX*T2)*T3);
T4 = ((((-9.82222e11)*modelStruct.modelPar_TOXG)*T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);
d_T5_dX = evaluator_lexp_0.getDerivs(T4,d_T4_dX);
T5 = evaluator_lexp_0.getValues(T4);
}
d_T6_dX = 0.0;
T6 = 3.75956e-7;
d_igbinv_dX = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*d_T5_dX+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbinv_dX+(((Weff0*Leff)*T6)*d_Toxratio_dX+((Weff0*Leff)*d_T6_dX+(Weff0*d_Leff_dX+d_Weff0_dX*Leff)*T6)*Toxratio)*vge*Vaux_Igbinv)*T5);
igbinv = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5);
d_igbinv_dX = (igbinv*d_igtemp_dX+d_igbinv_dX*igtemp);
igbinv = (igbinv*igtemp);
d_vfbzb_dX = ((d_deltaPhi_dX-(d_Eg_dX/2.0))-d_phib_dX);
vfbzb = ((deltaPhi-(Eg/2.0))-phib);
d_T0_dX = d_vfbzb_dX;
T0 = (vfbzb-vge);
d_T1_dX = ((Vtm*((NIGBACC_i*d_T0_dX-T0*d_NIGBACC_i_dX)/NIGBACC_i/NIGBACC_i)-(T0/NIGBACC_i)*d_Vtm_dX)/Vtm/Vtm);
T1 = ((T0/NIGBACC_i)/Vtm);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T1);
AnalogFunctions::llnEvaluator evaluator_lln_1((1+evaluator_lexp_0.getValues(T1)));
d_Vaux_Igbacc_dX = ((NIGBACC_i*Vtm)*evaluator_lln_1.getDerivs((1+evaluator_lexp_0.getValues(T1)),evaluator_lexp_0.getDerivs(T1,d_T1_dX))+(NIGBACC_i*d_Vtm_dX+d_NIGBACC_i_dX*Vtm)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(T1))));
Vaux_Igbacc = ((NIGBACC_i*Vtm)*evaluator_lln_1.getValues((1+evaluator_lexp_0.getValues(T1))));
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
d_Voxacc_dX = d_qi_acc_dX;
Voxacc = qi_acc;
}
else
{
if ((vfbzb<=0))
{
{
double value_sqrt_0 = sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Voxacc_dX = 0.5*(d_T0_dX+deriv_sqrt_0_d0*((((T0-0.02)*d_T0_dX+d_T0_dX*(T0-0.02))-0.08*d_vfbzb_dX)));
Voxacc = (0.5*((T0-0.02)+value_sqrt_0));
}
}
else
{
{
double value_sqrt_0 = sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Voxacc_dX = 0.5*(d_T0_dX+deriv_sqrt_0_d0*((((T0-0.02)*d_T0_dX+d_T0_dX*(T0-0.02))+0.08*d_vfbzb_dX)));
Voxacc = (0.5*((T0-0.02)+value_sqrt_0));
}
}
}
d_T2_dX = (d_AIGBACC_t_dX-(BIGBACC_i*d_Voxacc_dX+d_BIGBACC_i_dX*Voxacc));
T2 = (AIGBACC_t-(BIGBACC_i*Voxacc));
d_T3_dX = (CIGBACC_i*d_Voxacc_dX+d_CIGBACC_i_dX*Voxacc);
T3 = (1+(CIGBACC_i*Voxacc));
d_T4_dX = ((((-7.45669e11)*modelStruct.modelPar_TOXG)*T2)*d_T3_dX+(((-7.45669e11)*modelStruct.modelPar_TOXG)*d_T2_dX+(-7.45669e11)*modelStruct.d_modelPar_TOXG_dX*T2)*T3);
T4 = ((((-7.45669e11)*modelStruct.modelPar_TOXG)*T2)*T3);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T4);
d_T5_dX = evaluator_lexp_0.getDerivs(T4,d_T4_dX);
T5 = evaluator_lexp_0.getValues(T4);
}
d_T6_dX = 0.0;
T6 = 4.97232e-7;
d_igbacc_dX = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*d_T5_dX+(((((Weff0*Leff)*T6)*Toxratio)*vge)*d_Vaux_Igbacc_dX+(((Weff0*Leff)*T6)*d_Toxratio_dX+((Weff0*Leff)*d_T6_dX+(Weff0*d_Leff_dX+d_Weff0_dX*Leff)*T6)*Toxratio)*vge*Vaux_Igbacc)*T5);
igbacc = ((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5);
d_igbacc_dX = (igbacc*d_igtemp_dX+d_igbacc_dX*igtemp);
igbacc = (igbacc*igtemp);
}
if ((modelStruct.modelPar_IGCMOD!=0))
{
d_T1_dX = (d_AIGC_t_dX-(BIGC_i*d_qia_dX+d_BIGC_i_dX*qia));
T1 = (AIGC_t-(BIGC_i*qia));
d_T2_dX = (CIGC_i*d_qia_dX+d_CIGC_i_dX*qia);
T2 = (1.0+(CIGC_i*qia));
d_T3_dX = ((((-Bechvb)*modelStruct.modelPar_TOXG)*T1)*d_T2_dX+(((-Bechvb)*modelStruct.modelPar_TOXG)*d_T1_dX+(-Bechvb)*modelStruct.d_modelPar_TOXG_dX*T1)*T2);
T3 = ((((-Bechvb)*modelStruct.modelPar_TOXG)*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);
d_T4_dX = (qia*evaluator_lexp_0.getDerivs(T3,d_T3_dX)+d_qia_dX*evaluator_lexp_0.getValues(T3));
T4 = (qia*evaluator_lexp_0.getValues(T3));
}
d_T5_dX = 0.0;
T5 = ((vge+(0.5*vdsx))+(0.5*(ves_jct+ved_jct)));
d_igc0_dX = ((((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*d_igtemp_dX+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*d_T5_dX+((((Weff0*Leff)*Aechvb)*Toxratio)*d_T4_dX+(((Weff0*Leff)*Aechvb)*d_Toxratio_dX+(Weff0*d_Leff_dX+d_Weff0_dX*Leff)*Aechvb*Toxratio)*T4)*T5)*igtemp);
igc0 = ((((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*igtemp);
{
double value_sqrt_0 = sqrt(((Vdseff*Vdseff)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdseffx_dX = deriv_sqrt_0_d0*((Vdseff*d_Vdseff_dX+d_Vdseff_dX*Vdseff));
Vdseffx = (value_sqrt_0-0.1);
}
d_T1_dX = (PIGCD_i*d_Vdseffx_dX+d_PIGCD_i_dX*Vdseffx);
T1 = (PIGCD_i*Vdseffx);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));
d_T1_exp_dX = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dX));
T1_exp = evaluator_lexp_0.getValues((-T1));
}
d_T3_dX = (d_T1_dX+d_T1_exp_dX);
T3 = (((T1+T1_exp)-1.0)+1.0E-4);
d_T4_dX = (-((T1+1.0)*d_T1_exp_dX+d_T1_dX*T1_exp));
T4 = ((1.0-((T1+1.0)*T1_exp))+1.0E-4);
d_T5_dX = (T1*d_T1_dX+d_T1_dX*T1);
T5 = ((T1*T1)+2.0E-4);
d_igcd_dX = ((T5*(igc0*d_T4_dX+d_igc0_dX*T4)-(igc0*T4)*d_T5_dX)/T5/T5);
igcd = ((igc0*T4)/T5);
d_igcs_dX = ((T5*(igc0*d_T3_dX+d_igc0_dX*T3)-(igc0*T3)*d_T5_dX)/T5/T5);
igcs = ((igc0*T3)/T5);
d_T0_dX = 0.0;
T0 = vgs_noswap;
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vgs_eff_dX = deriv_sqrt_0_d0*((T0*d_T0_dX+d_T0_dX*T0));
vgs_eff = value_sqrt_0;
}
d_T1_dX = (d_AIGS_t_dX-(BIGS_i*d_vgs_eff_dX+d_BIGS_i_dX*vgs_eff));
T1 = (AIGS_t-(BIGS_i*vgs_eff));
d_T2_dX = (CIGS_i*d_vgs_eff_dX+d_CIGS_i_dX*vgs_eff);
T2 = (1.0+(CIGS_i*vgs_eff));
d_T3_dX = (((((-Bechvb)*modelStruct.modelPar_TOXG)*POXEDGE_i)*T1)*d_T2_dX+((((-Bechvb)*modelStruct.modelPar_TOXG)*POXEDGE_i)*d_T1_dX+(((-Bechvb)*modelStruct.modelPar_TOXG)*d_POXEDGE_i_dX+(-Bechvb)*modelStruct.d_modelPar_TOXG_dX*POXEDGE_i)*T1)*T2);
T3 = (((((-Bechvb)*modelStruct.modelPar_TOXG)*POXEDGE_i)*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);
d_T4_dX = evaluator_lexp_0.getDerivs(T3,d_T3_dX);
T4 = evaluator_lexp_0.getValues(T3);
}
if ((sigvds>0))
{
d_igs_dX = ((((igsd_mult*modelStruct.modelPar_DLCIGS)*vgs_noswap)*vgs_eff)*d_T4_dX+(((igsd_mult*modelStruct.modelPar_DLCIGS)*vgs_noswap)*d_vgs_eff_dX+(igsd_mult*modelStruct.d_modelPar_DLCIGS_dX+d_igsd_mult_dX*modelStruct.modelPar_DLCIGS)*vgs_noswap*vgs_eff)*T4);
igs = ((((igsd_mult*modelStruct.modelPar_DLCIGS)*vgs_noswap)*vgs_eff)*T4);
}
else
{
d_igd_dX = ((((igsd_mult*modelStruct.modelPar_DLCIGS)*vgs_noswap)*vgs_eff)*d_T4_dX+(((igsd_mult*modelStruct.modelPar_DLCIGS)*vgs_noswap)*d_vgs_eff_dX+(igsd_mult*modelStruct.d_modelPar_DLCIGS_dX+d_igsd_mult_dX*modelStruct.modelPar_DLCIGS)*vgs_noswap*vgs_eff)*T4);
igd = ((((igsd_mult*modelStruct.modelPar_DLCIGS)*vgs_noswap)*vgs_eff)*T4);
}
d_T0_dX = 0.0;
T0 = vgd_noswap;
{
double value_sqrt_0 = sqrt(((T0*T0)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vgd_eff_dX = deriv_sqrt_0_d0*((T0*d_T0_dX+d_T0_dX*T0));
vgd_eff = value_sqrt_0;
}
d_T1_dX = (d_AIGD_t_dX-(BIGD_i*d_vgd_eff_dX+d_BIGD_i_dX*vgd_eff));
T1 = (AIGD_t-(BIGD_i*vgd_eff));
d_T2_dX = (CIGD_i*d_vgd_eff_dX+d_CIGD_i_dX*vgd_eff);
T2 = (1.0+(CIGD_i*vgd_eff));
d_T3_dX = (((((-Bechvb)*modelStruct.modelPar_TOXG)*POXEDGE_i)*T1)*d_T2_dX+((((-Bechvb)*modelStruct.modelPar_TOXG)*POXEDGE_i)*d_T1_dX+(((-Bechvb)*modelStruct.modelPar_TOXG)*d_POXEDGE_i_dX+(-Bechvb)*modelStruct.d_modelPar_TOXG_dX*POXEDGE_i)*T1)*T2);
T3 = (((((-Bechvb)*modelStruct.modelPar_TOXG)*POXEDGE_i)*T1)*T2);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T3);
d_T4_dX = evaluator_lexp_0.getDerivs(T3,d_T3_dX);
T4 = evaluator_lexp_0.getValues(T3);
}
if ((sigvds>0))
{
d_igd_dX = ((((igsd_mult*modelStruct.modelPar_DLCIGD)*vgd_noswap)*vgd_eff)*d_T4_dX+(((igsd_mult*modelStruct.modelPar_DLCIGD)*vgd_noswap)*d_vgd_eff_dX+(igsd_mult*modelStruct.d_modelPar_DLCIGD_dX+d_igsd_mult_dX*modelStruct.modelPar_DLCIGD)*vgd_noswap*vgd_eff)*T4);
igd = ((((igsd_mult*modelStruct.modelPar_DLCIGD)*vgd_noswap)*vgd_eff)*T4);
}
else
{
d_igs_dX = ((((igsd_mult*modelStruct.modelPar_DLCIGD)*vgd_noswap)*vgd_eff)*d_T4_dX+(((igsd_mult*modelStruct.modelPar_DLCIGD)*vgd_noswap)*d_vgd_eff_dX+(igsd_mult*modelStruct.d_modelPar_DLCIGD_dX+d_igsd_mult_dX*modelStruct.modelPar_DLCIGD)*vgd_noswap*vgd_eff)*T4);
igs = ((((igsd_mult*modelStruct.modelPar_DLCIGD)*vgd_noswap)*vgd_eff)*T4);
}
}
d_igisl_dX = 0.0;
igisl = 0.0;
d_igidl_dX = 0.0;
igidl = 0.0;
if ((modelStruct.modelPar_GIDLMOD!=0))
{
d_T0_dX = (epsratio*modelStruct.d_modelPar_EOT_dX+d_epsratio_dX*modelStruct.modelPar_EOT);
T0 = (epsratio*modelStruct.modelPar_EOT);
if (((AGIDL_i<=0.0)||(BGIDL_t<=0.0)))
{
d_T6_dX = 0.0;
T6 = 0.0;
}
else
{
d_T1_dX = ((T0*((-d_EGIDL_i_dX)+d_vfbsd_dX)-(((-vgd_noswap)-EGIDL_i)+vfbsd)*d_T0_dX)/T0/T0);
T1 = ((((-vgd_noswap)-EGIDL_i)+vfbsd)/T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-2);
d_T1_dX = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dX,0.0);
T1 = evaluator_hypsmooth_0.getValues(T1,1.0E-2);
}
d_T2_dX = (((T1+1.0E-3)*d_BGIDL_t_dX-BGIDL_t*d_T1_dX)/(T1+1.0E-3)/(T1+1.0E-3));
T2 = (BGIDL_t/(T1+1.0E-3));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(T1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PGIDL_i*evaluator_lln_0.getValues(T1)));
d_T3_dX = evaluator_lexp_1.getDerivs((PGIDL_i*evaluator_lln_0.getValues(T1)),(PGIDL_i*evaluator_lln_0.getDerivs(T1,d_T1_dX)+d_PGIDL_i_dX*evaluator_lln_0.getValues(T1)));
T3 = evaluator_lexp_1.getValues((PGIDL_i*evaluator_lln_0.getValues(T1)));
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
d_T4_dX = 0.0;
T4 = (((-ved_jct)*ved_jct)*ved_jct);
{
double value_fabs_0 = fabs(T4);
double  deriv_fabs_0_d0 = (((T4)>=0)?(+1.0):(-1.0));
d_T4a_dX = (d_CGIDL_i_dX+deriv_fabs_0_d0*(d_T4_dX));
T4a = ((CGIDL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T4/T4a),1.0E-6);
d_T5_dX = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dX-T4*d_T4a_dX)/T4a/T4a),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T4/T4a),1.0E-6)-1.0E-6);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));
d_T6_dX = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dX+(((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dX))+((AGIDL_i*Weff0)*d_T3_dX+(AGIDL_i*d_Weff0_dX+d_AGIDL_i_dX*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*T5);
T6 = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*T5);
}
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));
d_T6_dX = (((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dX))+((AGIDL_i*Weff0)*d_T3_dX+(AGIDL_i*d_Weff0_dX+d_AGIDL_i_dX*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*vds_noswap;
T6 = ((((AGIDL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*vds_noswap);
}
}
}
if ((sigvds>0.0))
{
d_igidl_dX = d_T6_dX;
igidl = T6;
}
else
{
d_igisl_dX = d_T6_dX;
igisl = T6;
}
if (((AGISL_i<=0.0)||(BGISL_t<=0.0)))
{
d_T6_dX = 0.0;
T6 = 0.0;
}
else
{
d_T1_dX = ((T0*((-d_EGISL_i_dX)+d_vfbsd_dX)-(((-vgs_noswap)-EGISL_i)+vfbsd)*d_T0_dX)/T0/T0);
T1 = ((((-vgs_noswap)-EGISL_i)+vfbsd)/T0);
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0(T1,1.0E-2);
d_T1_dX = evaluator_hypsmooth_0.getDerivs(T1,1.0E-2,d_T1_dX,0.0);
T1 = evaluator_hypsmooth_0.getValues(T1,1.0E-2);
}
d_T2_dX = (((T1+1.0E-3)*d_BGISL_t_dX-BGISL_t*d_T1_dX)/(T1+1.0E-3)/(T1+1.0E-3));
T2 = (BGISL_t/(T1+1.0E-3));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(T1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1((PGISL_i*evaluator_lln_0.getValues(T1)));
d_T3_dX = evaluator_lexp_1.getDerivs((PGISL_i*evaluator_lln_0.getValues(T1)),(PGISL_i*evaluator_lln_0.getDerivs(T1,d_T1_dX)+d_PGISL_i_dX*evaluator_lln_0.getValues(T1)));
T3 = evaluator_lexp_1.getValues((PGISL_i*evaluator_lln_0.getValues(T1)));
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
d_T4_dX = 0.0;
T4 = (((-ves_jct)*ves_jct)*ves_jct);
{
double value_fabs_0 = fabs(T4);
double  deriv_fabs_0_d0 = (((T4)>=0)?(+1.0):(-1.0));
d_T4a_dX = (d_CGISL_i_dX+deriv_fabs_0_d0*(d_T4_dX));
T4a = ((CGISL_i+value_fabs_0)+1.0E-9);
}
{
AnalogFunctions::hypsmoothEvaluator evaluator_hypsmooth_0((T4/T4a),1.0E-6);
d_T5_dX = evaluator_hypsmooth_0.getDerivs((T4/T4a),1.0E-6,((T4a*d_T4_dX-T4*d_T4a_dX)/T4a/T4a),0.0);
T5 = (evaluator_hypsmooth_0.getValues((T4/T4a),1.0E-6)-1.0E-6);
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));
d_T6_dX = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*d_T5_dX+(((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dX))+((AGISL_i*Weff0)*d_T3_dX+(AGISL_i*d_Weff0_dX+d_AGISL_i_dX*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*T5);
T6 = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*T5);
}
}
else
{
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T2));
d_T6_dX = (((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getDerivs((-T2),(-d_T2_dX))+((AGISL_i*Weff0)*d_T3_dX+(AGISL_i*d_Weff0_dX+d_AGISL_i_dX*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap);
T6 = ((((AGISL_i*Weff0)*T3)*evaluator_lexp_0.getValues((-T2)))*(-vds_noswap));
}
}
}
if ((sigvds>0.0))
{
d_igisl_dX = d_T6_dX;
igisl = T6;
}
else
{
d_igidl_dX = d_T6_dX;
igidl = T6;
}
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
if ((Isbs>0.0))
{
if ((ves_jct<VjsmRev))
{
d_T0_dX = (-ves_jct*d_Nvtms_dX/Nvtms/Nvtms);
T0 = (ves_jct/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);
d_T1_dX = evaluator_lexp_0.getDerivs(T0,d_T0_dX);
T1 = (evaluator_lexp_0.getValues(T0)-1.0);
}
d_T2_dX = (d_IVjsmRev_dX+(SslpRev*(-d_VjsmRev_dX)+d_SslpRev_dX*(ves_jct-VjsmRev)));
T2 = (IVjsmRev+(SslpRev*(ves_jct-VjsmRev)));
d_Ies_dX = (T1*d_T2_dX+d_T1_dX*T2);
Ies = (T1*T2);
}
else
{
if ((ves_jct<=VjsmFwd))
{
d_T0_dX = (-ves_jct*d_Nvtms_dX/Nvtms/Nvtms);
T0 = (ves_jct/Nvtms);
d_T1_dX = ((Nvtms*modelStruct.d_modelPar_BVS_dX-(modelStruct.modelPar_BVS+ves_jct)*d_Nvtms_dX)/Nvtms/Nvtms);
T1 = ((modelStruct.modelPar_BVS+ves_jct)/Nvtms);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));
d_T2_dX = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dX));
T2 = evaluator_lexp_0.getValues((-T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);
d_Ies_dX = (Isbs*((evaluator_lexp_0.getDerivs(T0,d_T0_dX)+d_XExpBVS_dX)-(modelStruct.modelPar_XJBVS*d_T2_dX+modelStruct.d_modelPar_XJBVS_dX*T2))+d_Isbs_dX*(((evaluator_lexp_0.getValues(T0)+XExpBVS)-1.0)-(modelStruct.modelPar_XJBVS*T2)));
Ies = (Isbs*(((evaluator_lexp_0.getValues(T0)+XExpBVS)-1.0)-(modelStruct.modelPar_XJBVS*T2)));
}
}
else
{
d_Ies_dX = (d_IVjsmFwd_dX+(SslpFwd*(-d_VjsmFwd_dX)+d_SslpFwd_dX*(ves_jct-VjsmFwd)));
Ies = (IVjsmFwd+(SslpFwd*(ves_jct-VjsmFwd)));
}
}
}
else
{
d_Ies_dX = 0.0;
Ies = 0.0;
}
if ((JTSS_t>0.0))
{
if (((modelStruct.modelPar_VTSS-ves_jct)<(modelStruct.modelPar_VTSS*1.0e-3)))
{
d_T0_dX = ((NJTS_t*(-(-ves_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ves_jct)/Vtm0)*d_NJTS_t_dX)/NJTS_t/NJTS_t);
T0 = (((-ves_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));
d_T1_dX = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dX*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}
d_Ies_dX = (d_Ies_dX-((instanceStruct.instancePar_ASEJ*JTSS_t)*d_T1_dX+(instanceStruct.instancePar_ASEJ*d_JTSS_t_dX+instanceStruct.d_instancePar_ASEJ_dX*JTSS_t)*T1));
Ies = (Ies-((instanceStruct.instancePar_ASEJ*JTSS_t)*T1));
}
else
{
d_T0_dX = ((NJTS_t*(-(-ves_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ves_jct)/Vtm0)*d_NJTS_t_dX)/NJTS_t/NJTS_t);
T0 = (((-ves_jct)/Vtm0)/NJTS_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*modelStruct.modelPar_VTSS)/(modelStruct.modelPar_VTSS-ves_jct)));
d_T1_dX = evaluator_lexp_0.getDerivs(((T0*modelStruct.modelPar_VTSS)/(modelStruct.modelPar_VTSS-ves_jct)),(((modelStruct.modelPar_VTSS-ves_jct)*(T0*modelStruct.d_modelPar_VTSS_dX+d_T0_dX*modelStruct.modelPar_VTSS)-(T0*modelStruct.modelPar_VTSS)*modelStruct.d_modelPar_VTSS_dX)/(modelStruct.modelPar_VTSS-ves_jct)/(modelStruct.modelPar_VTSS-ves_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*modelStruct.modelPar_VTSS)/(modelStruct.modelPar_VTSS-ves_jct)))-1.0);
}
d_Ies_dX = (d_Ies_dX-((instanceStruct.instancePar_ASEJ*JTSS_t)*d_T1_dX+(instanceStruct.instancePar_ASEJ*d_JTSS_t_dX+instanceStruct.d_instancePar_ASEJ_dX*JTSS_t)*T1));
Ies = (Ies-((instanceStruct.instancePar_ASEJ*JTSS_t)*T1));
}
}
if ((JTSSWS_t>0.0))
{
if (((modelStruct.modelPar_VTSSWS-ves_jct)<(modelStruct.modelPar_VTSSWS*1.0e-3)))
{
d_T0_dX = ((NJTSSW_t*(-(-ves_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ves_jct)/Vtm0)*d_NJTSSW_t_dX)/NJTSSW_t/NJTSSW_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));
d_T1_dX = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dX*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}
d_Ies_dX = (d_Ies_dX-((instanceStruct.instancePar_PSEJ*JTSSWS_t)*d_T1_dX+(instanceStruct.instancePar_PSEJ*d_JTSSWS_t_dX+instanceStruct.d_instancePar_PSEJ_dX*JTSSWS_t)*T1));
Ies = (Ies-((instanceStruct.instancePar_PSEJ*JTSSWS_t)*T1));
}
else
{
d_T0_dX = ((NJTSSW_t*(-(-ves_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ves_jct)/Vtm0)*d_NJTSSW_t_dX)/NJTSSW_t/NJTSSW_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSW_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*modelStruct.modelPar_VTSSWS)/(modelStruct.modelPar_VTSSWS-ves_jct)));
d_T1_dX = evaluator_lexp_0.getDerivs(((T0*modelStruct.modelPar_VTSSWS)/(modelStruct.modelPar_VTSSWS-ves_jct)),(((modelStruct.modelPar_VTSSWS-ves_jct)*(T0*modelStruct.d_modelPar_VTSSWS_dX+d_T0_dX*modelStruct.modelPar_VTSSWS)-(T0*modelStruct.modelPar_VTSSWS)*modelStruct.d_modelPar_VTSSWS_dX)/(modelStruct.modelPar_VTSSWS-ves_jct)/(modelStruct.modelPar_VTSSWS-ves_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*modelStruct.modelPar_VTSSWS)/(modelStruct.modelPar_VTSSWS-ves_jct)))-1.0);
}
d_Ies_dX = (d_Ies_dX-((instanceStruct.instancePar_PSEJ*JTSSWS_t)*d_T1_dX+(instanceStruct.instancePar_PSEJ*d_JTSSWS_t_dX+instanceStruct.d_instancePar_PSEJ_dX*JTSSWS_t)*T1));
Ies = (Ies-((instanceStruct.instancePar_PSEJ*JTSSWS_t)*T1));
}
}
if ((JTSSWGS_t>0.0))
{
if (((modelStruct.modelPar_VTSSWGS-ves_jct)<(modelStruct.modelPar_VTSSWGS*1.0e-3)))
{
d_T0_dX = ((NJTSSWG_t*(-(-ves_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ves_jct)/Vtm0)*d_NJTSSWG_t_dX)/NJTSSWG_t/NJTSSWG_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));
d_T1_dX = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dX*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}
d_Ies_dX = (d_Ies_dX-(((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dX+((Weff0*NFINtotal)*d_JTSSWGS_t_dX+(Weff0*d_NFINtotal_dX+d_Weff0_dX*NFINtotal)*JTSSWGS_t)*T1));
Ies = (Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
}
else
{
d_T0_dX = ((NJTSSWG_t*(-(-ves_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ves_jct)/Vtm0)*d_NJTSSWG_t_dX)/NJTSSWG_t/NJTSSWG_t);
T0 = (((-ves_jct)/Vtm0)/NJTSSWG_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*modelStruct.modelPar_VTSSWGS)/(modelStruct.modelPar_VTSSWGS-ves_jct)));
d_T1_dX = evaluator_lexp_0.getDerivs(((T0*modelStruct.modelPar_VTSSWGS)/(modelStruct.modelPar_VTSSWGS-ves_jct)),(((modelStruct.modelPar_VTSSWGS-ves_jct)*(T0*modelStruct.d_modelPar_VTSSWGS_dX+d_T0_dX*modelStruct.modelPar_VTSSWGS)-(T0*modelStruct.modelPar_VTSSWGS)*modelStruct.d_modelPar_VTSSWGS_dX)/(modelStruct.modelPar_VTSSWGS-ves_jct)/(modelStruct.modelPar_VTSSWGS-ves_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*modelStruct.modelPar_VTSSWGS)/(modelStruct.modelPar_VTSSWGS-ves_jct)))-1.0);
}
d_Ies_dX = (d_Ies_dX-(((Weff0*NFINtotal)*JTSSWGS_t)*d_T1_dX+((Weff0*NFINtotal)*d_JTSSWGS_t_dX+(Weff0*d_NFINtotal_dX+d_Weff0_dX*NFINtotal)*JTSSWGS_t)*T1));
Ies = (Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
}
}
if ((Isbd>0.0))
{
if ((ved_jct<VjdmRev))
{
d_T0_dX = (-ved_jct*d_Nvtmd_dX/Nvtmd/Nvtmd);
T0 = (ved_jct/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);
d_T1_dX = evaluator_lexp_0.getDerivs(T0,d_T0_dX);
T1 = (evaluator_lexp_0.getValues(T0)-1.0);
}
d_T2_dX = (d_IVjdmRev_dX+(DslpRev*(-d_VjdmRev_dX)+d_DslpRev_dX*(ved_jct-VjdmRev)));
T2 = (IVjdmRev+(DslpRev*(ved_jct-VjdmRev)));
d_Ied_dX = (T1*d_T2_dX+d_T1_dX*T2);
Ied = (T1*T2);
}
else
{
if ((ved_jct<=VjdmFwd))
{
d_T0_dX = (-ved_jct*d_Nvtmd_dX/Nvtmd/Nvtmd);
T0 = (ved_jct/Nvtmd);
d_T1_dX = ((Nvtmd*modelStruct.d_modelPar_BVD_dX-(modelStruct.modelPar_BVD+ved_jct)*d_Nvtmd_dX)/Nvtmd/Nvtmd);
T1 = ((modelStruct.modelPar_BVD+ved_jct)/Nvtmd);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((-T1));
d_T2_dX = evaluator_lexp_0.getDerivs((-T1),(-d_T1_dX));
T2 = evaluator_lexp_0.getValues((-T1));
}
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(T0);
d_Ied_dX = (Isbd*((evaluator_lexp_0.getDerivs(T0,d_T0_dX)+d_XExpBVD_dX)-(modelStruct.modelPar_XJBVD*d_T2_dX+modelStruct.d_modelPar_XJBVD_dX*T2))+d_Isbd_dX*(((evaluator_lexp_0.getValues(T0)+XExpBVD)-1.0)-(modelStruct.modelPar_XJBVD*T2)));
Ied = (Isbd*(((evaluator_lexp_0.getValues(T0)+XExpBVD)-1.0)-(modelStruct.modelPar_XJBVD*T2)));
}
}
else
{
d_Ied_dX = (d_IVjdmFwd_dX+(DslpFwd*(-d_VjdmFwd_dX)+d_DslpFwd_dX*(ved_jct-VjdmFwd)));
Ied = (IVjdmFwd+(DslpFwd*(ved_jct-VjdmFwd)));
}
}
}
else
{
d_Ied_dX = 0.0;
Ied = 0.0;
}
if ((JTSD_t>0.0))
{
if (((modelStruct.modelPar_VTSD-ved_jct)<(modelStruct.modelPar_VTSD*1.0e-3)))
{
d_T0_dX = ((NJTSD_t*(-(-ved_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ved_jct)/Vtm0)*d_NJTSD_t_dX)/NJTSD_t/NJTSD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));
d_T1_dX = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dX*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}
d_Ied_dX = (d_Ied_dX-((instanceStruct.instancePar_ADEJ*JTSD_t)*d_T1_dX+(instanceStruct.instancePar_ADEJ*d_JTSD_t_dX+instanceStruct.d_instancePar_ADEJ_dX*JTSD_t)*T1));
Ied = (Ied-((instanceStruct.instancePar_ADEJ*JTSD_t)*T1));
}
else
{
d_T0_dX = ((NJTSD_t*(-(-ved_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ved_jct)/Vtm0)*d_NJTSD_t_dX)/NJTSD_t/NJTSD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*modelStruct.modelPar_VTSD)/(modelStruct.modelPar_VTSD-ved_jct)));
d_T1_dX = evaluator_lexp_0.getDerivs(((T0*modelStruct.modelPar_VTSD)/(modelStruct.modelPar_VTSD-ved_jct)),(((modelStruct.modelPar_VTSD-ved_jct)*(T0*modelStruct.d_modelPar_VTSD_dX+d_T0_dX*modelStruct.modelPar_VTSD)-(T0*modelStruct.modelPar_VTSD)*modelStruct.d_modelPar_VTSD_dX)/(modelStruct.modelPar_VTSD-ved_jct)/(modelStruct.modelPar_VTSD-ved_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*modelStruct.modelPar_VTSD)/(modelStruct.modelPar_VTSD-ved_jct)))-1.0);
}
d_Ied_dX = (d_Ied_dX-((instanceStruct.instancePar_ADEJ*JTSD_t)*d_T1_dX+(instanceStruct.instancePar_ADEJ*d_JTSD_t_dX+instanceStruct.d_instancePar_ADEJ_dX*JTSD_t)*T1));
Ied = (Ied-((instanceStruct.instancePar_ADEJ*JTSD_t)*T1));
}
}
if ((JTSSWD_t>0.0))
{
if (((modelStruct.modelPar_VTSSWD-ved_jct)<(modelStruct.modelPar_VTSSWD*1.0e-3)))
{
d_T0_dX = ((NJTSSWD_t*(-(-ved_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ved_jct)/Vtm0)*d_NJTSSWD_t_dX)/NJTSSWD_t/NJTSSWD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));
d_T1_dX = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dX*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}
d_Ied_dX = (d_Ied_dX-((instanceStruct.instancePar_PDEJ*JTSSWD_t)*d_T1_dX+(instanceStruct.instancePar_PDEJ*d_JTSSWD_t_dX+instanceStruct.d_instancePar_PDEJ_dX*JTSSWD_t)*T1));
Ied = (Ied-((instanceStruct.instancePar_PDEJ*JTSSWD_t)*T1));
}
else
{
d_T0_dX = ((NJTSSWD_t*(-(-ved_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ved_jct)/Vtm0)*d_NJTSSWD_t_dX)/NJTSSWD_t/NJTSSWD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*modelStruct.modelPar_VTSSWD)/(modelStruct.modelPar_VTSSWD-ved_jct)));
d_T1_dX = evaluator_lexp_0.getDerivs(((T0*modelStruct.modelPar_VTSSWD)/(modelStruct.modelPar_VTSSWD-ved_jct)),(((modelStruct.modelPar_VTSSWD-ved_jct)*(T0*modelStruct.d_modelPar_VTSSWD_dX+d_T0_dX*modelStruct.modelPar_VTSSWD)-(T0*modelStruct.modelPar_VTSSWD)*modelStruct.d_modelPar_VTSSWD_dX)/(modelStruct.modelPar_VTSSWD-ved_jct)/(modelStruct.modelPar_VTSSWD-ved_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*modelStruct.modelPar_VTSSWD)/(modelStruct.modelPar_VTSSWD-ved_jct)))-1.0);
}
d_Ied_dX = (d_Ied_dX-((instanceStruct.instancePar_PDEJ*JTSSWD_t)*d_T1_dX+(instanceStruct.instancePar_PDEJ*d_JTSSWD_t_dX+instanceStruct.d_instancePar_PDEJ_dX*JTSSWD_t)*T1));
Ied = (Ied-((instanceStruct.instancePar_PDEJ*JTSSWD_t)*T1));
}
}
if ((JTSSWGD_t>0.0))
{
if (((modelStruct.modelPar_VTSSWGD-ved_jct)<(modelStruct.modelPar_VTSSWGD*1.0e-3)))
{
d_T0_dX = ((NJTSSWGD_t*(-(-ved_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ved_jct)/Vtm0)*d_NJTSSWGD_t_dX)/NJTSSWGD_t/NJTSSWGD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0((T0*1.0e+3));
d_T1_dX = evaluator_lexp_0.getDerivs((T0*1.0e+3),d_T0_dX*1.0e+3);
T1 = (evaluator_lexp_0.getValues((T0*1.0e+3))-1.0);
}
d_Ied_dX = (d_Ied_dX-(((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dX+((Weff0*NFINtotal)*d_JTSSWGD_t_dX+(Weff0*d_NFINtotal_dX+d_Weff0_dX*NFINtotal)*JTSSWGD_t)*T1));
Ied = (Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
}
else
{
d_T0_dX = ((NJTSSWGD_t*(-(-ved_jct)*d_Vtm0_dX/Vtm0/Vtm0)-((-ved_jct)/Vtm0)*d_NJTSSWGD_t_dX)/NJTSSWGD_t/NJTSSWGD_t);
T0 = (((-ved_jct)/Vtm0)/NJTSSWGD_t);
{
AnalogFunctions::lexpEvaluator evaluator_lexp_0(((T0*modelStruct.modelPar_VTSSWGD)/(modelStruct.modelPar_VTSSWGD-ved_jct)));
d_T1_dX = evaluator_lexp_0.getDerivs(((T0*modelStruct.modelPar_VTSSWGD)/(modelStruct.modelPar_VTSSWGD-ved_jct)),(((modelStruct.modelPar_VTSSWGD-ved_jct)*(T0*modelStruct.d_modelPar_VTSSWGD_dX+d_T0_dX*modelStruct.modelPar_VTSSWGD)-(T0*modelStruct.modelPar_VTSSWGD)*modelStruct.d_modelPar_VTSSWGD_dX)/(modelStruct.modelPar_VTSSWGD-ved_jct)/(modelStruct.modelPar_VTSSWGD-ved_jct)));
T1 = (evaluator_lexp_0.getValues(((T0*modelStruct.modelPar_VTSSWGD)/(modelStruct.modelPar_VTSSWGD-ved_jct)))-1.0);
}
d_Ied_dX = (d_Ied_dX-(((Weff0*NFINtotal)*JTSSWGD_t)*d_T1_dX+((Weff0*NFINtotal)*d_JTSSWGD_t_dX+(Weff0*d_NFINtotal_dX+d_Weff0_dX*NFINtotal)*JTSSWGD_t)*T1));
Ied = (Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
}
}
{
if ((Czbs>0.0))
{
d_T1_dX = (-ves_jct*d_PBS_t_dX/PBS_t/PBS_t);
T1 = (ves_jct/PBS_t);
if ((T1<0.9))
{
if ((modelStruct.modelPar_SJS>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/modelStruct.modelPar_SJS));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/modelStruct.modelPar_MJS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJS))));
d_vec_dX = (PBS_t*(-evaluator_lexp_1.getDerivs(((1.0/modelStruct.modelPar_MJS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJS))),((1.0/modelStruct.modelPar_MJS)*evaluator_lln_0.getDerivs((1.0/modelStruct.modelPar_SJS),(-modelStruct.d_modelPar_SJS_dX/modelStruct.modelPar_SJS/modelStruct.modelPar_SJS))+(-modelStruct.d_modelPar_MJS_dX/modelStruct.modelPar_MJS/modelStruct.modelPar_MJS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJS)))))+d_PBS_t_dX*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJS))))));
vec = (PBS_t*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJS))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBS_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+modelStruct.modelPar_MJS))*evaluator_lln_0.getValues((1.0-(vec/PBS_t)))));
d_pb2_dX = ((evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJS))*evaluator_lln_0.getValues((1.0-(vec/PBS_t)))))*((modelStruct.modelPar_MJS*((PBS_t*modelStruct.modelPar_SJS)*modelStruct.d_modelPar_MJS2_dX+(PBS_t*modelStruct.d_modelPar_SJS_dX+d_PBS_t_dX*modelStruct.modelPar_SJS)*modelStruct.modelPar_MJS2)-((PBS_t*modelStruct.modelPar_SJS)*modelStruct.modelPar_MJS2)*modelStruct.d_modelPar_MJS_dX)/modelStruct.modelPar_MJS/modelStruct.modelPar_MJS)-(((PBS_t*modelStruct.modelPar_SJS)*modelStruct.modelPar_MJS2)/modelStruct.modelPar_MJS)*evaluator_lexp_1.getDerivs(((-(1.0+modelStruct.modelPar_MJS))*evaluator_lln_0.getValues((1.0-(vec/PBS_t)))),((-(1.0+modelStruct.modelPar_MJS))*evaluator_lln_0.getDerivs((1.0-(vec/PBS_t)),(-((PBS_t*d_vec_dX-vec*d_PBS_t_dX)/PBS_t/PBS_t)))+(-modelStruct.d_modelPar_MJS_dX)*evaluator_lln_0.getValues((1.0-(vec/PBS_t))))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJS))*evaluator_lln_0.getValues((1.0-(vec/PBS_t)))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJS))*evaluator_lln_0.getValues((1.0-(vec/PBS_t))))));
pb2 = ((((PBS_t*modelStruct.modelPar_SJS)*modelStruct.modelPar_MJS2)/modelStruct.modelPar_MJS)/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJS))*evaluator_lln_0.getValues((1.0-(vec/PBS_t))))));
}
if ((ves_jct>vec))
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj1_dX = (((1.0-modelStruct.modelPar_MJS)*((PBS_t*Czbs)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBS_t*d_Czbs_dX+d_PBS_t_dX*Czbs)*(1.0-(arg*sarg)))-((PBS_t*Czbs)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJS_dX))/(1.0-modelStruct.modelPar_MJS)/(1.0-modelStruct.modelPar_MJS));
Qesj1 = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJS));
}
else
{
d_arg_dX = (-((PBS_t*d_vec_dX-vec*d_PBS_t_dX)/PBS_t/PBS_t));
arg = (1.0-(vec/PBS_t));
if ((modelStruct.modelPar_MJS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qec_dX = (((1.0-modelStruct.modelPar_MJS)*((PBS_t*Czbs)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBS_t*d_Czbs_dX+d_PBS_t_dX*Czbs)*(1.0-(arg*sarg)))-((PBS_t*Czbs)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJS_dX))/(1.0-modelStruct.modelPar_MJS)/(1.0-modelStruct.modelPar_MJS));
Qec = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJS));
d_arg_dX = (-((pb2*(-d_vec_dX)-(ves_jct-vec)*d_pb2_dX)/pb2/pb2));
arg = (1.0-((ves_jct-vec)/pb2));
if ((modelStruct.modelPar_MJS2==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJS2)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJS2)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJS2)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJS2_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJS2)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj1_dX = (d_Qec_dX+(((1.0-modelStruct.modelPar_MJS2)*(((modelStruct.modelPar_SJS*pb2)*Czbs)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+((modelStruct.modelPar_SJS*pb2)*d_Czbs_dX+(modelStruct.modelPar_SJS*d_pb2_dX+modelStruct.d_modelPar_SJS_dX*pb2)*Czbs)*(1.0-(arg*sarg)))-(((modelStruct.modelPar_SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJS2_dX))/(1.0-modelStruct.modelPar_MJS2)/(1.0-modelStruct.modelPar_MJS2)));
Qesj1 = (Qec+((((modelStruct.modelPar_SJS*pb2)*Czbs)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJS2)));
}
}
else
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj1_dX = (((1.0-modelStruct.modelPar_MJS)*((PBS_t*Czbs)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBS_t*d_Czbs_dX+d_PBS_t_dX*Czbs)*(1.0-(arg*sarg)))-((PBS_t*Czbs)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJS_dX))/(1.0-modelStruct.modelPar_MJS)/(1.0-modelStruct.modelPar_MJS));
Qesj1 = (((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJS));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(0.1)));
d_T2_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(0.1)),(-modelStruct.d_modelPar_MJS_dX)*evaluator_lln_0.getValues(0.1));
T2 = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJS)*evaluator_lln_0.getValues(0.1)));
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJS_dX)/(1.0-modelStruct.modelPar_MJS)/(1.0-modelStruct.modelPar_MJS));
T3 = (1.0/(1.0-modelStruct.modelPar_MJS));
d_T4_dX = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJS)*d_T1_dX+5.0*modelStruct.d_modelPar_MJS_dX*(T1-1.0))+modelStruct.d_modelPar_MJS_dX)+(T2*d_T1_dX+d_T2_dX*(T1-1.0))*(((5.0*modelStruct.modelPar_MJS)*(T1-1.0))+(1.0+modelStruct.modelPar_MJS)));
T4 = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJS)*(T1-1.0))+(1.0+modelStruct.modelPar_MJS)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJS)*(1.0+modelStruct.modelPar_MJS))*d_T2_dX+((0.05*modelStruct.modelPar_MJS)*modelStruct.d_modelPar_MJS_dX+0.05*modelStruct.d_modelPar_MJS_dX*(1.0+modelStruct.modelPar_MJS))*T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJS)*(1.0+modelStruct.modelPar_MJS))*T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJS)*(1.0+modelStruct.modelPar_MJS))*T2)));
d_Qesj1_dX = ((PBS_t*Czbs)*(d_T4_dX+d_T5_dX)+(PBS_t*d_Czbs_dX+d_PBS_t_dX*Czbs)*(T4+T5));
Qesj1 = ((PBS_t*Czbs)*(T4+T5));
}
}
else
{
d_Qesj1_dX = 0.0;
Qesj1 = 0.0;
}
}
{
if ((Czbssw>0.0))
{
d_T1_dX = (-ves_jct*d_PBSWS_t_dX/PBSWS_t/PBSWS_t);
T1 = (ves_jct/PBSWS_t);
if ((T1<0.9))
{
if ((modelStruct.modelPar_SJSWS>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/modelStruct.modelPar_SJSWS));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWS))));
d_vec_dX = (PBSWS_t*(-evaluator_lexp_1.getDerivs(((1.0/modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWS))),((1.0/modelStruct.modelPar_MJSWS)*evaluator_lln_0.getDerivs((1.0/modelStruct.modelPar_SJSWS),(-modelStruct.d_modelPar_SJSWS_dX/modelStruct.modelPar_SJSWS/modelStruct.modelPar_SJSWS))+(-modelStruct.d_modelPar_MJSWS_dX/modelStruct.modelPar_MJSWS/modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWS)))))+d_PBSWS_t_dX*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWS))))));
vec = (PBSWS_t*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWS))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWS_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+modelStruct.modelPar_MJSWS))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t)))));
d_pb2_dX = ((evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWS))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t)))))*((modelStruct.modelPar_MJSWS*((PBSWS_t*modelStruct.modelPar_SJSWS)*modelStruct.d_modelPar_MJSWS2_dX+(PBSWS_t*modelStruct.d_modelPar_SJSWS_dX+d_PBSWS_t_dX*modelStruct.modelPar_SJSWS)*modelStruct.modelPar_MJSWS2)-((PBSWS_t*modelStruct.modelPar_SJSWS)*modelStruct.modelPar_MJSWS2)*modelStruct.d_modelPar_MJSWS_dX)/modelStruct.modelPar_MJSWS/modelStruct.modelPar_MJSWS)-(((PBSWS_t*modelStruct.modelPar_SJSWS)*modelStruct.modelPar_MJSWS2)/modelStruct.modelPar_MJSWS)*evaluator_lexp_1.getDerivs(((-(1.0+modelStruct.modelPar_MJSWS))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t)))),((-(1.0+modelStruct.modelPar_MJSWS))*evaluator_lln_0.getDerivs((1.0-(vec/PBSWS_t)),(-((PBSWS_t*d_vec_dX-vec*d_PBSWS_t_dX)/PBSWS_t/PBSWS_t)))+(-modelStruct.d_modelPar_MJSWS_dX)*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t))))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWS))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t)))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWS))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t))))));
pb2 = ((((PBSWS_t*modelStruct.modelPar_SJSWS)*modelStruct.modelPar_MJSWS2)/modelStruct.modelPar_MJSWS)/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWS))*evaluator_lln_0.getValues((1.0-(vec/PBSWS_t))))));
}
if ((ves_jct>vec))
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj2_dX = (((1.0-modelStruct.modelPar_MJSWS)*((PBSWS_t*Czbssw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWS_t*d_Czbssw_dX+d_PBSWS_t_dX*Czbssw)*(1.0-(arg*sarg)))-((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWS_dX))/(1.0-modelStruct.modelPar_MJSWS)/(1.0-modelStruct.modelPar_MJSWS));
Qesj2 = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWS));
}
else
{
d_arg_dX = (-((PBSWS_t*d_vec_dX-vec*d_PBSWS_t_dX)/PBSWS_t/PBSWS_t));
arg = (1.0-(vec/PBSWS_t));
if ((modelStruct.modelPar_MJSWS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qec_dX = (((1.0-modelStruct.modelPar_MJSWS)*((PBSWS_t*Czbssw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWS_t*d_Czbssw_dX+d_PBSWS_t_dX*Czbssw)*(1.0-(arg*sarg)))-((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWS_dX))/(1.0-modelStruct.modelPar_MJSWS)/(1.0-modelStruct.modelPar_MJSWS));
Qec = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWS));
d_arg_dX = (-((pb2*(-d_vec_dX)-(ves_jct-vec)*d_pb2_dX)/pb2/pb2));
arg = (1.0-((ves_jct-vec)/pb2));
if ((modelStruct.modelPar_MJSWS2==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWS2)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWS2)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWS2)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWS2_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWS2)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj2_dX = (d_Qec_dX+(((1.0-modelStruct.modelPar_MJSWS2)*(((modelStruct.modelPar_SJSWS*pb2)*Czbssw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+((modelStruct.modelPar_SJSWS*pb2)*d_Czbssw_dX+(modelStruct.modelPar_SJSWS*d_pb2_dX+modelStruct.d_modelPar_SJSWS_dX*pb2)*Czbssw)*(1.0-(arg*sarg)))-(((modelStruct.modelPar_SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWS2_dX))/(1.0-modelStruct.modelPar_MJSWS2)/(1.0-modelStruct.modelPar_MJSWS2)));
Qesj2 = (Qec+((((modelStruct.modelPar_SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWS2)));
}
}
else
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj2_dX = (((1.0-modelStruct.modelPar_MJSWS)*((PBSWS_t*Czbssw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWS_t*d_Czbssw_dX+d_PBSWS_t_dX*Czbssw)*(1.0-(arg*sarg)))-((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWS_dX))/(1.0-modelStruct.modelPar_MJSWS)/(1.0-modelStruct.modelPar_MJSWS));
Qesj2 = (((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWS));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(0.1)));
d_T2_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(0.1)),(-modelStruct.d_modelPar_MJSWS_dX)*evaluator_lln_0.getValues(0.1));
T2 = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWS)*evaluator_lln_0.getValues(0.1)));
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWS_dX)/(1.0-modelStruct.modelPar_MJSWS)/(1.0-modelStruct.modelPar_MJSWS));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWS));
d_T4_dX = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWS)*d_T1_dX+5.0*modelStruct.d_modelPar_MJSWS_dX*(T1-1.0))+modelStruct.d_modelPar_MJSWS_dX)+(T2*d_T1_dX+d_T2_dX*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWS)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWS)));
T4 = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWS)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWS)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWS)*(1.0+modelStruct.modelPar_MJSWS))*d_T2_dX+((0.05*modelStruct.modelPar_MJSWS)*modelStruct.d_modelPar_MJSWS_dX+0.05*modelStruct.d_modelPar_MJSWS_dX*(1.0+modelStruct.modelPar_MJSWS))*T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWS)*(1.0+modelStruct.modelPar_MJSWS))*T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWS)*(1.0+modelStruct.modelPar_MJSWS))*T2)));
d_Qesj2_dX = ((PBSWS_t*Czbssw)*(d_T4_dX+d_T5_dX)+(PBSWS_t*d_Czbssw_dX+d_PBSWS_t_dX*Czbssw)*(T4+T5));
Qesj2 = ((PBSWS_t*Czbssw)*(T4+T5));
}
}
else
{
d_Qesj2_dX = 0.0;
Qesj2 = 0.0;
}
}
{
if ((Czbsswg>0.0))
{
d_T1_dX = (-ves_jct*d_PBSWGS_t_dX/PBSWGS_t/PBSWGS_t);
T1 = (ves_jct/PBSWGS_t);
if ((T1<0.9))
{
if ((modelStruct.modelPar_SJSWGS>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/modelStruct.modelPar_SJSWGS));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGS))));
d_vec_dX = (PBSWGS_t*(-evaluator_lexp_1.getDerivs(((1.0/modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGS))),((1.0/modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getDerivs((1.0/modelStruct.modelPar_SJSWGS),(-modelStruct.d_modelPar_SJSWGS_dX/modelStruct.modelPar_SJSWGS/modelStruct.modelPar_SJSWGS))+(-modelStruct.d_modelPar_MJSWGS_dX/modelStruct.modelPar_MJSWGS/modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGS)))))+d_PBSWGS_t_dX*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGS))))));
vec = (PBSWGS_t*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGS))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWGS_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+modelStruct.modelPar_MJSWGS))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t)))));
d_pb2_dX = ((evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGS))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t)))))*((modelStruct.modelPar_MJSWGS*((PBSWGS_t*modelStruct.modelPar_SJSWGS)*modelStruct.d_modelPar_MJSWGS2_dX+(PBSWGS_t*modelStruct.d_modelPar_SJSWGS_dX+d_PBSWGS_t_dX*modelStruct.modelPar_SJSWGS)*modelStruct.modelPar_MJSWGS2)-((PBSWGS_t*modelStruct.modelPar_SJSWGS)*modelStruct.modelPar_MJSWGS2)*modelStruct.d_modelPar_MJSWGS_dX)/modelStruct.modelPar_MJSWGS/modelStruct.modelPar_MJSWGS)-(((PBSWGS_t*modelStruct.modelPar_SJSWGS)*modelStruct.modelPar_MJSWGS2)/modelStruct.modelPar_MJSWGS)*evaluator_lexp_1.getDerivs(((-(1.0+modelStruct.modelPar_MJSWGS))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t)))),((-(1.0+modelStruct.modelPar_MJSWGS))*evaluator_lln_0.getDerivs((1.0-(vec/PBSWGS_t)),(-((PBSWGS_t*d_vec_dX-vec*d_PBSWGS_t_dX)/PBSWGS_t/PBSWGS_t)))+(-modelStruct.d_modelPar_MJSWGS_dX)*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t))))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGS))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t)))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGS))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t))))));
pb2 = ((((PBSWGS_t*modelStruct.modelPar_SJSWGS)*modelStruct.modelPar_MJSWGS2)/modelStruct.modelPar_MJSWGS)/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGS))*evaluator_lln_0.getValues((1.0-(vec/PBSWGS_t))))));
}
if ((ves_jct>vec))
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWGS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj3_dX = (((1.0-modelStruct.modelPar_MJSWGS)*((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGS_t*d_Czbsswg_dX+d_PBSWGS_t_dX*Czbsswg)*(1.0-(arg*sarg)))-((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGS_dX))/(1.0-modelStruct.modelPar_MJSWGS)/(1.0-modelStruct.modelPar_MJSWGS));
Qesj3 = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGS));
}
else
{
d_arg_dX = (-((PBSWGS_t*d_vec_dX-vec*d_PBSWGS_t_dX)/PBSWGS_t/PBSWGS_t));
arg = (1.0-(vec/PBSWGS_t));
if ((modelStruct.modelPar_MJSWGS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qec_dX = (((1.0-modelStruct.modelPar_MJSWGS)*((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGS_t*d_Czbsswg_dX+d_PBSWGS_t_dX*Czbsswg)*(1.0-(arg*sarg)))-((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGS_dX))/(1.0-modelStruct.modelPar_MJSWGS)/(1.0-modelStruct.modelPar_MJSWGS));
Qec = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGS));
d_arg_dX = (-((pb2*(-d_vec_dX)-(ves_jct-vec)*d_pb2_dX)/pb2/pb2));
arg = (1.0-((ves_jct-vec)/pb2));
if ((modelStruct.modelPar_MJSWGS2==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGS2)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGS2)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGS2)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGS2_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGS2)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj3_dX = (d_Qec_dX+(((1.0-modelStruct.modelPar_MJSWGS2)*(((modelStruct.modelPar_SJSWGS*pb2)*Czbsswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+((modelStruct.modelPar_SJSWGS*pb2)*d_Czbsswg_dX+(modelStruct.modelPar_SJSWGS*d_pb2_dX+modelStruct.d_modelPar_SJSWGS_dX*pb2)*Czbsswg)*(1.0-(arg*sarg)))-(((modelStruct.modelPar_SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGS2_dX))/(1.0-modelStruct.modelPar_MJSWGS2)/(1.0-modelStruct.modelPar_MJSWGS2)));
Qesj3 = (Qec+((((modelStruct.modelPar_SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGS2)));
}
}
else
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWGS==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGS_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(arg)));
}
}
d_Qesj3_dX = (((1.0-modelStruct.modelPar_MJSWGS)*((PBSWGS_t*Czbsswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGS_t*d_Czbsswg_dX+d_PBSWGS_t_dX*Czbsswg)*(1.0-(arg*sarg)))-((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGS_dX))/(1.0-modelStruct.modelPar_MJSWGS)/(1.0-modelStruct.modelPar_MJSWGS));
Qesj3 = (((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGS));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(0.1)));
d_T2_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(0.1)),(-modelStruct.d_modelPar_MJSWGS_dX)*evaluator_lln_0.getValues(0.1));
T2 = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGS)*evaluator_lln_0.getValues(0.1)));
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWGS_dX)/(1.0-modelStruct.modelPar_MJSWGS)/(1.0-modelStruct.modelPar_MJSWGS));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWGS));
d_T4_dX = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGS)*d_T1_dX+5.0*modelStruct.d_modelPar_MJSWGS_dX*(T1-1.0))+modelStruct.d_modelPar_MJSWGS_dX)+(T2*d_T1_dX+d_T2_dX*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGS)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWGS)));
T4 = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGS)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWGS)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWGS)*(1.0+modelStruct.modelPar_MJSWGS))*d_T2_dX+((0.05*modelStruct.modelPar_MJSWGS)*modelStruct.d_modelPar_MJSWGS_dX+0.05*modelStruct.d_modelPar_MJSWGS_dX*(1.0+modelStruct.modelPar_MJSWGS))*T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWGS)*(1.0+modelStruct.modelPar_MJSWGS))*T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWGS)*(1.0+modelStruct.modelPar_MJSWGS))*T2)));
d_Qesj3_dX = ((PBSWGS_t*Czbsswg)*(d_T4_dX+d_T5_dX)+(PBSWGS_t*d_Czbsswg_dX+d_PBSWGS_t_dX*Czbsswg)*(T4+T5));
Qesj3 = ((PBSWGS_t*Czbsswg)*(T4+T5));
}
}
else
{
d_Qesj3_dX = 0.0;
Qesj3 = 0.0;
}
}
d_Qesj_dX = ((d_Qesj1_dX+d_Qesj2_dX)+d_Qesj3_dX);
Qesj = ((Qesj1+Qesj2)+Qesj3);
{
if ((Czbd>0.0))
{
d_T1_dX = (-ved_jct*d_PBD_t_dX/PBD_t/PBD_t);
T1 = (ved_jct/PBD_t);
if ((T1<0.9))
{
if ((modelStruct.modelPar_SJD>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/modelStruct.modelPar_SJD));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/modelStruct.modelPar_MJD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJD))));
d_vec_dX = (PBD_t*(-evaluator_lexp_1.getDerivs(((1.0/modelStruct.modelPar_MJD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJD))),((1.0/modelStruct.modelPar_MJD)*evaluator_lln_0.getDerivs((1.0/modelStruct.modelPar_SJD),(-modelStruct.d_modelPar_SJD_dX/modelStruct.modelPar_SJD/modelStruct.modelPar_SJD))+(-modelStruct.d_modelPar_MJD_dX/modelStruct.modelPar_MJD/modelStruct.modelPar_MJD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJD)))))+d_PBD_t_dX*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJD))))));
vec = (PBD_t*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJD))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBD_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+modelStruct.modelPar_MJD))*evaluator_lln_0.getValues((1.0-(vec/PBD_t)))));
d_pb2_dX = ((evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJD))*evaluator_lln_0.getValues((1.0-(vec/PBD_t)))))*((modelStruct.modelPar_MJD*((PBD_t*modelStruct.modelPar_SJD)*modelStruct.d_modelPar_MJD2_dX+(PBD_t*modelStruct.d_modelPar_SJD_dX+d_PBD_t_dX*modelStruct.modelPar_SJD)*modelStruct.modelPar_MJD2)-((PBD_t*modelStruct.modelPar_SJD)*modelStruct.modelPar_MJD2)*modelStruct.d_modelPar_MJD_dX)/modelStruct.modelPar_MJD/modelStruct.modelPar_MJD)-(((PBD_t*modelStruct.modelPar_SJD)*modelStruct.modelPar_MJD2)/modelStruct.modelPar_MJD)*evaluator_lexp_1.getDerivs(((-(1.0+modelStruct.modelPar_MJD))*evaluator_lln_0.getValues((1.0-(vec/PBD_t)))),((-(1.0+modelStruct.modelPar_MJD))*evaluator_lln_0.getDerivs((1.0-(vec/PBD_t)),(-((PBD_t*d_vec_dX-vec*d_PBD_t_dX)/PBD_t/PBD_t)))+(-modelStruct.d_modelPar_MJD_dX)*evaluator_lln_0.getValues((1.0-(vec/PBD_t))))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJD))*evaluator_lln_0.getValues((1.0-(vec/PBD_t)))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJD))*evaluator_lln_0.getValues((1.0-(vec/PBD_t))))));
pb2 = ((((PBD_t*modelStruct.modelPar_SJD)*modelStruct.modelPar_MJD2)/modelStruct.modelPar_MJD)/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJD))*evaluator_lln_0.getValues((1.0-(vec/PBD_t))))));
}
if ((ved_jct>vec))
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj1_dX = (((1.0-modelStruct.modelPar_MJD)*((PBD_t*Czbd)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBD_t*d_Czbd_dX+d_PBD_t_dX*Czbd)*(1.0-(arg*sarg)))-((PBD_t*Czbd)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJD_dX))/(1.0-modelStruct.modelPar_MJD)/(1.0-modelStruct.modelPar_MJD));
Qedj1 = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJD));
}
else
{
d_arg_dX = (-((PBD_t*d_vec_dX-vec*d_PBD_t_dX)/PBD_t/PBD_t));
arg = (1.0-(vec/PBD_t));
if ((modelStruct.modelPar_MJD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qec_dX = (((1.0-modelStruct.modelPar_MJD)*((PBD_t*Czbd)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBD_t*d_Czbd_dX+d_PBD_t_dX*Czbd)*(1.0-(arg*sarg)))-((PBD_t*Czbd)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJD_dX))/(1.0-modelStruct.modelPar_MJD)/(1.0-modelStruct.modelPar_MJD));
Qec = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJD));
d_arg_dX = (-((pb2*(-d_vec_dX)-(ved_jct-vec)*d_pb2_dX)/pb2/pb2));
arg = (1.0-((ved_jct-vec)/pb2));
if ((modelStruct.modelPar_MJD2==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJD2)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJD2)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJD2)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJD2_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJD2)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj1_dX = (d_Qec_dX+(((1.0-modelStruct.modelPar_MJD2)*(((modelStruct.modelPar_SJD*pb2)*Czbd)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+((modelStruct.modelPar_SJD*pb2)*d_Czbd_dX+(modelStruct.modelPar_SJD*d_pb2_dX+modelStruct.d_modelPar_SJD_dX*pb2)*Czbd)*(1.0-(arg*sarg)))-(((modelStruct.modelPar_SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJD2_dX))/(1.0-modelStruct.modelPar_MJD2)/(1.0-modelStruct.modelPar_MJD2)));
Qedj1 = (Qec+((((modelStruct.modelPar_SJD*pb2)*Czbd)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJD2)));
}
}
else
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj1_dX = (((1.0-modelStruct.modelPar_MJD)*((PBD_t*Czbd)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBD_t*d_Czbd_dX+d_PBD_t_dX*Czbd)*(1.0-(arg*sarg)))-((PBD_t*Czbd)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJD_dX))/(1.0-modelStruct.modelPar_MJD)/(1.0-modelStruct.modelPar_MJD));
Qedj1 = (((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJD));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(0.1)));
d_T2_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(0.1)),(-modelStruct.d_modelPar_MJD_dX)*evaluator_lln_0.getValues(0.1));
T2 = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJD)*evaluator_lln_0.getValues(0.1)));
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJD_dX)/(1.0-modelStruct.modelPar_MJD)/(1.0-modelStruct.modelPar_MJD));
T3 = (1.0/(1.0-modelStruct.modelPar_MJD));
d_T4_dX = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJD)*d_T1_dX+5.0*modelStruct.d_modelPar_MJD_dX*(T1-1.0))+modelStruct.d_modelPar_MJD_dX)+(T2*d_T1_dX+d_T2_dX*(T1-1.0))*(((5.0*modelStruct.modelPar_MJD)*(T1-1.0))+(1.0+modelStruct.modelPar_MJD)));
T4 = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJD)*(T1-1.0))+(1.0+modelStruct.modelPar_MJD)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJD)*(1.0+modelStruct.modelPar_MJD))*d_T2_dX+((0.05*modelStruct.modelPar_MJD)*modelStruct.d_modelPar_MJD_dX+0.05*modelStruct.d_modelPar_MJD_dX*(1.0+modelStruct.modelPar_MJD))*T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJD)*(1.0+modelStruct.modelPar_MJD))*T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJD)*(1.0+modelStruct.modelPar_MJD))*T2)));
d_Qedj1_dX = ((PBD_t*Czbd)*(d_T4_dX+d_T5_dX)+(PBD_t*d_Czbd_dX+d_PBD_t_dX*Czbd)*(T4+T5));
Qedj1 = ((PBD_t*Czbd)*(T4+T5));
}
}
else
{
d_Qedj1_dX = 0.0;
Qedj1 = 0.0;
}
}
{
if ((Czbdsw>0.0))
{
d_T1_dX = (-ved_jct*d_PBSWD_t_dX/PBSWD_t/PBSWD_t);
T1 = (ved_jct/PBSWD_t);
if ((T1<0.9))
{
if ((modelStruct.modelPar_SJSWD>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/modelStruct.modelPar_SJSWD));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWD))));
d_vec_dX = (PBSWD_t*(-evaluator_lexp_1.getDerivs(((1.0/modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWD))),((1.0/modelStruct.modelPar_MJSWD)*evaluator_lln_0.getDerivs((1.0/modelStruct.modelPar_SJSWD),(-modelStruct.d_modelPar_SJSWD_dX/modelStruct.modelPar_SJSWD/modelStruct.modelPar_SJSWD))+(-modelStruct.d_modelPar_MJSWD_dX/modelStruct.modelPar_MJSWD/modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWD)))))+d_PBSWD_t_dX*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWD))))));
vec = (PBSWD_t*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWD))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWD_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+modelStruct.modelPar_MJSWD))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t)))));
d_pb2_dX = ((evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWD))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t)))))*((modelStruct.modelPar_MJSWD*((PBSWD_t*modelStruct.modelPar_SJSWD)*modelStruct.d_modelPar_MJSWD2_dX+(PBSWD_t*modelStruct.d_modelPar_SJSWD_dX+d_PBSWD_t_dX*modelStruct.modelPar_SJSWD)*modelStruct.modelPar_MJSWD2)-((PBSWD_t*modelStruct.modelPar_SJSWD)*modelStruct.modelPar_MJSWD2)*modelStruct.d_modelPar_MJSWD_dX)/modelStruct.modelPar_MJSWD/modelStruct.modelPar_MJSWD)-(((PBSWD_t*modelStruct.modelPar_SJSWD)*modelStruct.modelPar_MJSWD2)/modelStruct.modelPar_MJSWD)*evaluator_lexp_1.getDerivs(((-(1.0+modelStruct.modelPar_MJSWD))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t)))),((-(1.0+modelStruct.modelPar_MJSWD))*evaluator_lln_0.getDerivs((1.0-(vec/PBSWD_t)),(-((PBSWD_t*d_vec_dX-vec*d_PBSWD_t_dX)/PBSWD_t/PBSWD_t)))+(-modelStruct.d_modelPar_MJSWD_dX)*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t))))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWD))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t)))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWD))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t))))));
pb2 = ((((PBSWD_t*modelStruct.modelPar_SJSWD)*modelStruct.modelPar_MJSWD2)/modelStruct.modelPar_MJSWD)/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWD))*evaluator_lln_0.getValues((1.0-(vec/PBSWD_t))))));
}
if ((ved_jct>vec))
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj2_dX = (((1.0-modelStruct.modelPar_MJSWD)*((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWD_t*d_Czbdsw_dX+d_PBSWD_t_dX*Czbdsw)*(1.0-(arg*sarg)))-((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWD_dX))/(1.0-modelStruct.modelPar_MJSWD)/(1.0-modelStruct.modelPar_MJSWD));
Qedj2 = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWD));
}
else
{
d_arg_dX = (-((PBSWD_t*d_vec_dX-vec*d_PBSWD_t_dX)/PBSWD_t/PBSWD_t));
arg = (1.0-(vec/PBSWD_t));
if ((modelStruct.modelPar_MJSWD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qec_dX = (((1.0-modelStruct.modelPar_MJSWD)*((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWD_t*d_Czbdsw_dX+d_PBSWD_t_dX*Czbdsw)*(1.0-(arg*sarg)))-((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWD_dX))/(1.0-modelStruct.modelPar_MJSWD)/(1.0-modelStruct.modelPar_MJSWD));
Qec = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWD));
d_arg_dX = (-((pb2*(-d_vec_dX)-(ved_jct-vec)*d_pb2_dX)/pb2/pb2));
arg = (1.0-((ved_jct-vec)/pb2));
if ((modelStruct.modelPar_MJSWD2==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWD2)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWD2)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWD2)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWD2_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWD2)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj2_dX = (d_Qec_dX+(((1.0-modelStruct.modelPar_MJSWD2)*(((modelStruct.modelPar_SJSWD*pb2)*Czbdsw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+((modelStruct.modelPar_SJSWD*pb2)*d_Czbdsw_dX+(modelStruct.modelPar_SJSWD*d_pb2_dX+modelStruct.d_modelPar_SJSWD_dX*pb2)*Czbdsw)*(1.0-(arg*sarg)))-(((modelStruct.modelPar_SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWD2_dX))/(1.0-modelStruct.modelPar_MJSWD2)/(1.0-modelStruct.modelPar_MJSWD2)));
Qedj2 = (Qec+((((modelStruct.modelPar_SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWD2)));
}
}
else
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj2_dX = (((1.0-modelStruct.modelPar_MJSWD)*((PBSWD_t*Czbdsw)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWD_t*d_Czbdsw_dX+d_PBSWD_t_dX*Czbdsw)*(1.0-(arg*sarg)))-((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWD_dX))/(1.0-modelStruct.modelPar_MJSWD)/(1.0-modelStruct.modelPar_MJSWD));
Qedj2 = (((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWD));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(0.1)));
d_T2_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(0.1)),(-modelStruct.d_modelPar_MJSWD_dX)*evaluator_lln_0.getValues(0.1));
T2 = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWD)*evaluator_lln_0.getValues(0.1)));
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWD_dX)/(1.0-modelStruct.modelPar_MJSWD)/(1.0-modelStruct.modelPar_MJSWD));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWD));
d_T4_dX = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWD)*d_T1_dX+5.0*modelStruct.d_modelPar_MJSWD_dX*(T1-1.0))+modelStruct.d_modelPar_MJSWD_dX)+(T2*d_T1_dX+d_T2_dX*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWD)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWD)));
T4 = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWD)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWD)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWD)*(1.0+modelStruct.modelPar_MJSWD))*d_T2_dX+((0.05*modelStruct.modelPar_MJSWD)*modelStruct.d_modelPar_MJSWD_dX+0.05*modelStruct.d_modelPar_MJSWD_dX*(1.0+modelStruct.modelPar_MJSWD))*T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWD)*(1.0+modelStruct.modelPar_MJSWD))*T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWD)*(1.0+modelStruct.modelPar_MJSWD))*T2)));
d_Qedj2_dX = ((PBSWD_t*Czbdsw)*(d_T4_dX+d_T5_dX)+(PBSWD_t*d_Czbdsw_dX+d_PBSWD_t_dX*Czbdsw)*(T4+T5));
Qedj2 = ((PBSWD_t*Czbdsw)*(T4+T5));
}
}
else
{
d_Qedj2_dX = 0.0;
Qedj2 = 0.0;
}
}
{
if ((Czbdswg>0.0))
{
d_T1_dX = (-ved_jct*d_PBSWGD_t_dX/PBSWGD_t/PBSWGD_t);
T1 = (ved_jct/PBSWGD_t);
if ((T1<0.9))
{
if ((modelStruct.modelPar_SJSWGD>0.0))
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0/modelStruct.modelPar_SJSWGD));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((1.0/modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGD))));
d_vec_dX = (PBSWGD_t*(-evaluator_lexp_1.getDerivs(((1.0/modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGD))),((1.0/modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getDerivs((1.0/modelStruct.modelPar_SJSWGD),(-modelStruct.d_modelPar_SJSWGD_dX/modelStruct.modelPar_SJSWGD/modelStruct.modelPar_SJSWGD))+(-modelStruct.d_modelPar_MJSWGD_dX/modelStruct.modelPar_MJSWGD/modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGD)))))+d_PBSWGD_t_dX*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGD))))));
vec = (PBSWGD_t*(1.0-evaluator_lexp_1.getValues(((1.0/modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues((1.0/modelStruct.modelPar_SJSWGD))))));
}
{
AnalogFunctions::llnEvaluator evaluator_lln_0((1.0-(vec/PBSWGD_t)));
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-(1.0+modelStruct.modelPar_MJSWGD))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t)))));
d_pb2_dX = ((evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGD))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t)))))*((modelStruct.modelPar_MJSWGD*((PBSWGD_t*modelStruct.modelPar_SJSWGD)*modelStruct.d_modelPar_MJSWGD2_dX+(PBSWGD_t*modelStruct.d_modelPar_SJSWGD_dX+d_PBSWGD_t_dX*modelStruct.modelPar_SJSWGD)*modelStruct.modelPar_MJSWGD2)-((PBSWGD_t*modelStruct.modelPar_SJSWGD)*modelStruct.modelPar_MJSWGD2)*modelStruct.d_modelPar_MJSWGD_dX)/modelStruct.modelPar_MJSWGD/modelStruct.modelPar_MJSWGD)-(((PBSWGD_t*modelStruct.modelPar_SJSWGD)*modelStruct.modelPar_MJSWGD2)/modelStruct.modelPar_MJSWGD)*evaluator_lexp_1.getDerivs(((-(1.0+modelStruct.modelPar_MJSWGD))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t)))),((-(1.0+modelStruct.modelPar_MJSWGD))*evaluator_lln_0.getDerivs((1.0-(vec/PBSWGD_t)),(-((PBSWGD_t*d_vec_dX-vec*d_PBSWGD_t_dX)/PBSWGD_t/PBSWGD_t)))+(-modelStruct.d_modelPar_MJSWGD_dX)*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t))))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGD))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t)))))/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGD))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t))))));
pb2 = ((((PBSWGD_t*modelStruct.modelPar_SJSWGD)*modelStruct.modelPar_MJSWGD2)/modelStruct.modelPar_MJSWGD)/evaluator_lexp_1.getValues(((-(1.0+modelStruct.modelPar_MJSWGD))*evaluator_lln_0.getValues((1.0-(vec/PBSWGD_t))))));
}
if ((ved_jct>vec))
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWGD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj3_dX = (((1.0-modelStruct.modelPar_MJSWGD)*((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGD_t*d_Czbdswg_dX+d_PBSWGD_t_dX*Czbdswg)*(1.0-(arg*sarg)))-((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGD_dX))/(1.0-modelStruct.modelPar_MJSWGD)/(1.0-modelStruct.modelPar_MJSWGD));
Qedj3 = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGD));
}
else
{
d_arg_dX = (-((PBSWGD_t*d_vec_dX-vec*d_PBSWGD_t_dX)/PBSWGD_t/PBSWGD_t));
arg = (1.0-(vec/PBSWGD_t));
if ((modelStruct.modelPar_MJSWGD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qec_dX = (((1.0-modelStruct.modelPar_MJSWGD)*((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGD_t*d_Czbdswg_dX+d_PBSWGD_t_dX*Czbdswg)*(1.0-(arg*sarg)))-((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGD_dX))/(1.0-modelStruct.modelPar_MJSWGD)/(1.0-modelStruct.modelPar_MJSWGD));
Qec = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGD));
d_arg_dX = (-((pb2*(-d_vec_dX)-(ved_jct-vec)*d_pb2_dX)/pb2/pb2));
arg = (1.0-((ved_jct-vec)/pb2));
if ((modelStruct.modelPar_MJSWGD2==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGD2)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGD2)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGD2)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGD2_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGD2)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj3_dX = (d_Qec_dX+(((1.0-modelStruct.modelPar_MJSWGD2)*(((modelStruct.modelPar_SJSWGD*pb2)*Czbdswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+((modelStruct.modelPar_SJSWGD*pb2)*d_Czbdswg_dX+(modelStruct.modelPar_SJSWGD*d_pb2_dX+modelStruct.d_modelPar_SJSWGD_dX*pb2)*Czbdswg)*(1.0-(arg*sarg)))-(((modelStruct.modelPar_SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGD2_dX))/(1.0-modelStruct.modelPar_MJSWGD2)/(1.0-modelStruct.modelPar_MJSWGD2)));
Qedj3 = (Qec+((((modelStruct.modelPar_SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGD2)));
}
}
else
{
d_arg_dX = (-d_T1_dX);
arg = (1.0-T1);
if ((modelStruct.modelPar_MJSWGD==0.5))
{
{
double value_sqrt_0 = sqrt(arg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sarg_dX = (-deriv_sqrt_0_d0*(d_arg_dX)/value_sqrt_0/value_sqrt_0);
sarg = (1.0/value_sqrt_0);
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(arg);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
d_sarg_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)),((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getDerivs(arg,d_arg_dX)+(-modelStruct.d_modelPar_MJSWGD_dX)*evaluator_lln_0.getValues(arg)));
sarg = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(arg)));
}
}
d_Qedj3_dX = (((1.0-modelStruct.modelPar_MJSWGD)*((PBSWGD_t*Czbdswg)*(-(arg*d_sarg_dX+d_arg_dX*sarg))+(PBSWGD_t*d_Czbdswg_dX+d_PBSWGD_t_dX*Czbdswg)*(1.0-(arg*sarg)))-((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(-modelStruct.d_modelPar_MJSWGD_dX))/(1.0-modelStruct.modelPar_MJSWGD)/(1.0-modelStruct.modelPar_MJSWGD));
Qedj3 = (((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-modelStruct.modelPar_MJSWGD));
}
}
else
{
{
AnalogFunctions::llnEvaluator evaluator_lln_0(0.1);
AnalogFunctions::lexpEvaluator evaluator_lexp_1(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(0.1)));
d_T2_dX = evaluator_lexp_1.getDerivs(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(0.1)),(-modelStruct.d_modelPar_MJSWGD_dX)*evaluator_lln_0.getValues(0.1));
T2 = evaluator_lexp_1.getValues(((-modelStruct.modelPar_MJSWGD)*evaluator_lln_0.getValues(0.1)));
}
d_T3_dX = (-(-modelStruct.d_modelPar_MJSWGD_dX)/(1.0-modelStruct.modelPar_MJSWGD)/(1.0-modelStruct.modelPar_MJSWGD));
T3 = (1.0/(1.0-modelStruct.modelPar_MJSWGD));
d_T4_dX = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGD)*d_T1_dX+5.0*modelStruct.d_modelPar_MJSWGD_dX*(T1-1.0))+modelStruct.d_modelPar_MJSWGD_dX)+(T2*d_T1_dX+d_T2_dX*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGD)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWGD)));
T4 = ((T2*(T1-1.0))*(((5.0*modelStruct.modelPar_MJSWGD)*(T1-1.0))+(1.0+modelStruct.modelPar_MJSWGD)));
d_T5_dX = (T3*(-(((0.05*modelStruct.modelPar_MJSWGD)*(1.0+modelStruct.modelPar_MJSWGD))*d_T2_dX+((0.05*modelStruct.modelPar_MJSWGD)*modelStruct.d_modelPar_MJSWGD_dX+0.05*modelStruct.d_modelPar_MJSWGD_dX*(1.0+modelStruct.modelPar_MJSWGD))*T2))+d_T3_dX*(1.0-(((0.05*modelStruct.modelPar_MJSWGD)*(1.0+modelStruct.modelPar_MJSWGD))*T2)));
T5 = (T3*(1.0-(((0.05*modelStruct.modelPar_MJSWGD)*(1.0+modelStruct.modelPar_MJSWGD))*T2)));
d_Qedj3_dX = ((PBSWGD_t*Czbdswg)*(d_T4_dX+d_T5_dX)+(PBSWGD_t*d_Czbdswg_dX+d_PBSWGD_t_dX*Czbdswg)*(T4+T5));
Qedj3 = ((PBSWGD_t*Czbdswg)*(T4+T5));
}
}
else
{
d_Qedj3_dX = 0.0;
Qedj3 = 0.0;
}
}
d_Qedj_dX = ((d_Qedj1_dX+d_Qedj2_dX)+d_Qedj3_dX);
Qedj = ((Qedj1+Qedj2)+Qedj3);
}
d_Qes_dX = (d_Qesj_dX+d_csbox_dX*ves_jct);
Qes = (Qesj+(csbox*ves_jct));
d_Qed_dX = (d_Qedj_dX+d_cdbox_dX*ved_jct);
Qed = (Qedj+(cdbox*ved_jct));
d_Qeg_dX = d_cgbox_dX*devsign*(probeVars[admsProbeID_V_e_g]);
Qeg = ((cgbox*devsign)*(probeVars[admsProbeID_V_e_g]));
if ((modelStruct.modelPar_BULKMOD!=0))
{
d_T2_dX = 0.0;
T2 = (devsign*(probeVars[admsProbeID_V_g_e]));
d_T3_dX = ((((d_T2_dX-d_deltaPhi_dX)+(d_Eg_dX/2.0))+d_phib_dX)-modelStruct.d_modelPar_DELVFBACC_dX);
T3 = ((((T2-deltaPhi)+(Eg/2.0))+phib)-modelStruct.modelPar_DELVFBACC);
d_T0_dX = d_T3_dX;
T0 = (T3+0.02);
{
double value_sqrt_0 = sqrt(((T0*T0)+(4.0*0.02)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vge_overlap_dX = 0.5*(d_T0_dX+deriv_sqrt_0_d0*((T0*d_T0_dX+d_T0_dX*T0)));
vge_overlap = (0.5*(T0+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Qeg_dX = (d_Qeg_dX-((NFINtotal*LeffCV)*(CGBL_i*((d_T3_dX-d_vge_overlap_dX)+((0.5*CKAPPAB_i)*deriv_sqrt_0_d0*(((CKAPPAB_i*4.0*d_vge_overlap_dX-(4.0*vge_overlap)*d_CKAPPAB_i_dX)/CKAPPAB_i/CKAPPAB_i))+0.5*d_CKAPPAB_i_dX*(value_sqrt_0-1.0)))+d_CGBL_i_dX*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(value_sqrt_0-1.0))))+(NFINtotal*d_LeffCV_dX+d_NFINtotal_dX*LeffCV)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(value_sqrt_0-1.0))))));
Qeg = (Qeg-((NFINtotal*LeffCV)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(value_sqrt_0-1.0))))));
}
}
d_T0_dX = 0.0;
T0 = vds;
d_T1_dX = (T0*(d_AIGEN_i_dX+((BIGEN_i*T0)*d_T0_dX+(BIGEN_i*d_T0_dX+d_BIGEN_i_dX*T0)*T0))+d_T0_dX*(AIGEN_i+((BIGEN_i*T0)*T0)));
T1 = (T0*(AIGEN_i+((BIGEN_i*T0)*T0)));
d_idsgen_dX = ((((modelStruct.modelPar_HFIN*instanceStruct.instancePar_TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*d_T1_dX+(((modelStruct.modelPar_HFIN*instanceStruct.instancePar_TFIN)*(Leff-(2.0*LINTIGEN_i)))*d_igentemp_dX+((modelStruct.modelPar_HFIN*instanceStruct.instancePar_TFIN)*(d_Leff_dX-2.0*d_LINTIGEN_i_dX)+(modelStruct.modelPar_HFIN*instanceStruct.d_instancePar_TFIN_dX+modelStruct.d_modelPar_HFIN_dX*instanceStruct.instancePar_TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1);
idsgen = ((((modelStruct.modelPar_HFIN*instanceStruct.instancePar_TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1);
d_IdovVds_dX = ((((Dmob*Dvsat)*Dr)*((beta*ids0_ov_dqi)*d_Moc_dX+(beta*d_ids0_ov_dqi_dX+d_beta_dX*ids0_ov_dqi)*Moc)-((beta*ids0_ov_dqi)*Moc)*((Dmob*Dvsat)*d_Dr_dX+(Dmob*d_Dvsat_dX+d_Dmob_dX*Dvsat)*Dr))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
IdovVds = (((beta*ids0_ov_dqi)*Moc)/((Dmob*Dvsat)*Dr));
d_T0_dX = ((Leff*((ueff*coxeff)*d_Weff_dX+(ueff*d_coxeff_dX+d_ueff_dX*coxeff)*Weff)-((ueff*coxeff)*Weff)*d_Leff_dX)/Leff/Leff);
T0 = (((ueff*coxeff)*Weff)/Leff);
d_igidl_dX = (NFINtotal*d_igidl_dX+d_NFINtotal_dX*igidl);
igidl = (NFINtotal*igidl);
d_igisl_dX = (NFINtotal*d_igisl_dX+d_NFINtotal_dX*igisl);
igisl = (NFINtotal*igisl);
d_igcd_dX = (NFINtotal*d_igcd_dX+d_NFINtotal_dX*igcd);
igcd = (NFINtotal*igcd);
d_igcs_dX = (NFINtotal*d_igcs_dX+d_NFINtotal_dX*igcs);
igcs = (NFINtotal*igcs);
d_igs_dX = (NFINtotal*d_igs_dX+d_NFINtotal_dX*igs);
igs = (NFINtotal*igs);
d_igd_dX = (NFINtotal*d_igd_dX+d_NFINtotal_dX*igd);
igd = (NFINtotal*igd);
d_igbinv_dX = (NFINtotal*d_igbinv_dX+d_NFINtotal_dX*igbinv);
igbinv = (NFINtotal*igbinv);
d_igbacc_dX = (NFINtotal*d_igbacc_dX+d_NFINtotal_dX*igbacc);
igbacc = (NFINtotal*igbacc);
d_idsgen_dX = (NFINtotal*d_idsgen_dX+d_NFINtotal_dX*idsgen);
idsgen = (NFINtotal*idsgen);
d_Iii_dX = (NFINtotal*d_Iii_dX+d_NFINtotal_dX*Iii);
Iii = (NFINtotal*Iii);
d_igbs_dX = 0.0;
igbs = 0.0;
d_igbd_dX = 0.0;
igbd = 0.0;
if ((modelStruct.modelPar_BULKMOD==0))
{
d_igbs_dX = ((igbinv+igbacc)*d_wf_dX+(d_igbinv_dX+d_igbacc_dX)*wf);
igbs = ((igbinv+igbacc)*wf);
d_igbd_dX = ((igbinv+igbacc)*d_wr_dX+(d_igbinv_dX+d_igbacc_dX)*wr);
igbd = ((igbinv+igbacc)*wr);
}
d_Esatnoi_dX = ((ueff*2.0*d_VSAT_t_dX-(2.0*VSAT_t)*d_ueff_dX)/ueff/ueff);
Esatnoi = ((2.0*VSAT_t)/ueff);
if ((((modelStruct.modelPar_NOIA>0)||(modelStruct.modelPar_NOIB>0))||(modelStruct.modelPar_NOIC>0)))
{
d_Leffnoi_dX = (d_Leff_dX-2.0*d_LINTNOI_i_dX);
Leffnoi = (Leff-(2.0*LINTNOI_i));
d_Leffnoisq_dX = (Leffnoi*d_Leffnoi_dX+d_Leffnoi_dX*Leffnoi);
Leffnoisq = (Leffnoi*Leffnoi);
if ((modelStruct.modelPar_EM<=0.0))
{
d_DelClm_dX = 0.0;
DelClm = 0.0;
}
else
{
d_T0_dX = ((Esatnoi*(((litl*d_diffVds_dX-diffVds*d_litl_dX)/litl/litl)+modelStruct.d_modelPar_EM_dX)-((diffVds/litl)+modelStruct.modelPar_EM)*d_Esatnoi_dX)/Esatnoi/Esatnoi);
T0 = (((diffVds/litl)+modelStruct.modelPar_EM)/Esatnoi);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(T0);
d_DelClm_dX = (litl*evaluator_lln_0.getDerivs(T0,d_T0_dX)+d_litl_dX*evaluator_lln_0.getValues(T0));
DelClm = (litl*evaluator_lln_0.getValues(T0));
}
if ((DelClm<0.0))
{
d_DelClm_dX = 0.0;
DelClm = 0.0;
}
}
{
double value_fabs_0 = fabs(ids);
double  deriv_fabs_0_d0 = (((ids)>=0)?(+1.0):(-1.0));
d_T1_dX = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*d_ueff_dX+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*deriv_fabs_0_d0*(d_ids_dX)+((1.60219e-19*1.60219e-19)*1.60219e-19)*d_Vtm_dX*value_fabs_0)*ueff);
T1 = (((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*value_fabs_0)*ueff);
}
d_T2_dX = ((1.0e10*coxeff)*d_Leffnoisq_dX+1.0e10*d_coxeff_dX*Leffnoisq);
T2 = ((1.0e10*coxeff)*Leffnoisq);
d_N0_dX = ((coxeff*d_qis_dX+d_coxeff_dX*qis)/1.60219e-19);
N0 = ((coxeff*qis)/1.60219e-19);
d_Nl_dX = ((coxeff*d_qid_dX+d_coxeff_dX*qid)/1.60219e-19);
Nl = ((coxeff*qid)/1.60219e-19);
d_Nstar_dX = ((Vtm/1.60219e-19)*(d_coxeff_dX+d_CIT_i_dX)+(d_Vtm_dX/1.60219e-19)*(coxeff+CIT_i));
Nstar = ((Vtm/1.60219e-19)*(coxeff+CIT_i));
{
AnalogFunctions::llnEvaluator evaluator_lln_0(((N0+Nstar)/(Nl+Nstar)));
d_T3_dX = (modelStruct.modelPar_NOIA*evaluator_lln_0.getDerivs(((N0+Nstar)/(Nl+Nstar)),(((Nl+Nstar)*(d_N0_dX+d_Nstar_dX)-(N0+Nstar)*(d_Nl_dX+d_Nstar_dX))/(Nl+Nstar)/(Nl+Nstar)))+modelStruct.d_modelPar_NOIA_dX*evaluator_lln_0.getValues(((N0+Nstar)/(Nl+Nstar))));
T3 = (modelStruct.modelPar_NOIA*evaluator_lln_0.getValues(((N0+Nstar)/(Nl+Nstar))));
}
d_T4_dX = (modelStruct.modelPar_NOIB*(d_N0_dX-d_Nl_dX)+modelStruct.d_modelPar_NOIB_dX*(N0-Nl));
T4 = (modelStruct.modelPar_NOIB*(N0-Nl));
d_T5_dX = ((0.5*modelStruct.modelPar_NOIC)*((N0*d_N0_dX+d_N0_dX*N0)-(Nl*d_Nl_dX+d_Nl_dX*Nl))+0.5*modelStruct.d_modelPar_NOIC_dX*((N0*N0)-(Nl*Nl)));
T5 = ((0.5*modelStruct.modelPar_NOIC)*((N0*N0)-(Nl*Nl)));
d_T6_dX = (((1.60219e-19*Vtm)*ids)*d_ids_dX+((1.60219e-19*Vtm)*d_ids_dX+1.60219e-19*d_Vtm_dX*ids)*ids);
T6 = (((1.60219e-19*Vtm)*ids)*ids);
d_T7_dX = (((1.0e10*Leffnoisq)*Weff)*d_NFINtotal_dX+((1.0e10*Leffnoisq)*d_Weff_dX+1.0e10*d_Leffnoisq_dX*Weff)*NFINtotal);
T7 = (((1.0e10*Leffnoisq)*Weff)*NFINtotal);
d_T8_dX = ((modelStruct.d_modelPar_NOIA_dX+(modelStruct.modelPar_NOIB*d_Nl_dX+modelStruct.d_modelPar_NOIB_dX*Nl))+((modelStruct.modelPar_NOIC*Nl)*d_Nl_dX+(modelStruct.modelPar_NOIC*d_Nl_dX+modelStruct.d_modelPar_NOIC_dX*Nl)*Nl));
T8 = ((modelStruct.modelPar_NOIA+(modelStruct.modelPar_NOIB*Nl))+((modelStruct.modelPar_NOIC*Nl)*Nl));
d_T9_dX = ((Nl+Nstar)*(d_Nl_dX+d_Nstar_dX)+(d_Nl_dX+d_Nstar_dX)*(Nl+Nstar));
T9 = ((Nl+Nstar)*(Nl+Nstar));
d_Ssi_dX = (((T1/T2)*((d_T3_dX+d_T4_dX)+d_T5_dX)+((T2*d_T1_dX-T1*d_T2_dX)/T2/T2)*((T3+T4)+T5))+((T9*(((T6/T7)*DelClm)*d_T8_dX+((T6/T7)*d_DelClm_dX+((T7*d_T6_dX-T6*d_T7_dX)/T7/T7)*DelClm)*T8)-(((T6/T7)*DelClm)*T8)*d_T9_dX)/T9/T9));
Ssi = (((T1/T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
d_T10_dX = ((modelStruct.modelPar_NOIA*1.60219e-19)*d_Vtm_dX+modelStruct.d_modelPar_NOIA_dX*1.60219e-19*Vtm);
T10 = ((modelStruct.modelPar_NOIA*1.60219e-19)*Vtm);
d_T11_dX = (((((Weff*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*d_Nstar_dX+((((Weff*NFINtotal)*Leffnoi)*1.0e10)*d_Nstar_dX+((Weff*NFINtotal)*d_Leffnoi_dX+(Weff*d_NFINtotal_dX+d_Weff_dX*NFINtotal)*Leffnoi)*1.0e10*Nstar)*Nstar);
T11 = (((((Weff*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar);
d_Swi_dX = (((T10/T11)*ids)*d_ids_dX+((T10/T11)*d_ids_dX+((T11*d_T10_dX-T10*d_T11_dX)/T11/T11)*ids)*ids);
Swi = (((T10/T11)*ids)*ids);
d_T1_dX = (d_Swi_dX+d_Ssi_dX);
T1 = (Swi+Ssi);
if ((T1>0.0))
{
d_FNPowerAt1Hz_dX = ((T1*(Ssi*d_Swi_dX+d_Ssi_dX*Swi)-(Ssi*Swi)*d_T1_dX)/T1/T1);
FNPowerAt1Hz = ((Ssi*Swi)/T1);
}
else
{
d_FNPowerAt1Hz_dX = 0.0;
FNPowerAt1Hz = 0.0;
}
}
else
{
d_FNPowerAt1Hz_dX = 0.0;
FNPowerAt1Hz = 0.0;
}
d_T0_dX = (ueff*d_qinv_dX+d_ueff_dX*qinv);
T0 = (ueff*qinv);
d_T1_dX = ((T0*d_Rdsi_dX+d_T0_dX*Rdsi)+(Leff*d_Leff_dX+d_Leff_dX*Leff));
T1 = ((T0*Rdsi)+(Leff*Leff));
d_Gtnoi_dX = ((T0/T1)*d_NTNOI_i_dX+((T1*d_T0_dX-T0*d_T1_dX)/T1/T1)*NTNOI_i);
Gtnoi = ((T0/T1)*NTNOI_i);
d_sid_dX = (((4*Vtm)*1.60219e-19)*d_Gtnoi_dX+4*d_Vtm_dX*1.60219e-19*Gtnoi);
sid = (((4*Vtm)*1.60219e-19)*Gtnoi);
d_gspr_dX = (-1*d_Rsource_dX/Rsource/Rsource);
gspr = (1/Rsource);
d_gdpr_dX = (-1*d_Rdrain_dX/Rdrain/Rdrain);
gdpr = (1/Rdrain);
}
if ((!initialized))
{
devsign = 0.0;
d_Rsource_dX = 0.0;
Rsource = 1.0;
d_Rdrain_dX = 0.0;
Rdrain = 1.0;
UserInfo(theInstance)  << "uninitialized" << " " <<  std::endl; 
}
if ((sigvds>0.0))
{
// I(di,si) <+ ((devsign*ids))
d_staticContributions_dX[admsNodeID_di]+= devsign*d_ids_dX;
d_staticContributions_dX[(admsNodeID_si)]-= devsign*d_ids_dX;
}
else
{
// I(si,di) <+ ((devsign*ids))
d_staticContributions_dX[admsNodeID_si]+= devsign*d_ids_dX;
d_staticContributions_dX[(admsNodeID_di)]-= devsign*d_ids_dX;
}
// I(di,si) <+ ((devsign*ddt(qd)))
d_dynamicContributions_dX[admsNodeID_di]+= devsign*(d_qd_dX);
d_dynamicContributions_dX[(admsNodeID_si)]-= devsign*(d_qd_dX);
// I(g,si) <+ ((devsign*ddt(qg)))
d_dynamicContributions_dX[admsNodeID_g]+= devsign*(d_qg_dX);
d_dynamicContributions_dX[(admsNodeID_si)]-= devsign*(d_qg_dX);
if ((sigvds>0))
{
// I(di,si) <+ ((devsign*idsgen))
d_staticContributions_dX[admsNodeID_di]+= devsign*d_idsgen_dX;
d_staticContributions_dX[(admsNodeID_si)]-= devsign*d_idsgen_dX;
// I(g,si) <+ ((devsign*(igcs+igs)))
d_staticContributions_dX[admsNodeID_g]+= devsign*(d_igcs_dX+d_igs_dX);
d_staticContributions_dX[(admsNodeID_si)]-= devsign*(d_igcs_dX+d_igs_dX);
// I(g,di) <+ ((devsign*(igcd+igd)))
d_staticContributions_dX[admsNodeID_g]+= devsign*(d_igcd_dX+d_igd_dX);
d_staticContributions_dX[(admsNodeID_di)]-= devsign*(d_igcd_dX+d_igd_dX);
if ((modelStruct.modelPar_BULKMOD!=0))
{
// I(di,e) <+ ((devsign*(igidl+Iii)))
d_staticContributions_dX[admsNodeID_di]+= devsign*(d_igidl_dX+d_Iii_dX);
d_staticContributions_dX[(admsNodeID_e)]-= devsign*(d_igidl_dX+d_Iii_dX);
// I(si,e) <+ ((devsign*igisl))
d_staticContributions_dX[admsNodeID_si]+= devsign*d_igisl_dX;
d_staticContributions_dX[(admsNodeID_e)]-= devsign*d_igisl_dX;
// I(g,e) <+ ((devsign*(igbinv+igbacc)))
d_staticContributions_dX[admsNodeID_g]+= devsign*(d_igbinv_dX+d_igbacc_dX);
d_staticContributions_dX[(admsNodeID_e)]-= devsign*(d_igbinv_dX+d_igbacc_dX);
}
else
{
// I(di,si) <+ ((devsign*(igidl+Iii)))
d_staticContributions_dX[admsNodeID_di]+= devsign*(d_igidl_dX+d_Iii_dX);
d_staticContributions_dX[(admsNodeID_si)]-= devsign*(d_igidl_dX+d_Iii_dX);
// I(si,di) <+ ((devsign*igisl))
d_staticContributions_dX[admsNodeID_si]+= devsign*d_igisl_dX;
d_staticContributions_dX[(admsNodeID_di)]-= devsign*d_igisl_dX;
}
}
else
{
// I(si,di) <+ ((devsign*idsgen))
d_staticContributions_dX[admsNodeID_si]+= devsign*d_idsgen_dX;
d_staticContributions_dX[(admsNodeID_di)]-= devsign*d_idsgen_dX;
// I(g,di) <+ ((devsign*(igcs+igs)))
d_staticContributions_dX[admsNodeID_g]+= devsign*(d_igcs_dX+d_igs_dX);
d_staticContributions_dX[(admsNodeID_di)]-= devsign*(d_igcs_dX+d_igs_dX);
// I(g,si) <+ ((devsign*(igcd+igd)))
d_staticContributions_dX[admsNodeID_g]+= devsign*(d_igcd_dX+d_igd_dX);
d_staticContributions_dX[(admsNodeID_si)]-= devsign*(d_igcd_dX+d_igd_dX);
if ((modelStruct.modelPar_BULKMOD!=0))
{
// I(si,e) <+ ((devsign*(igidl+Iii)))
d_staticContributions_dX[admsNodeID_si]+= devsign*(d_igidl_dX+d_Iii_dX);
d_staticContributions_dX[(admsNodeID_e)]-= devsign*(d_igidl_dX+d_Iii_dX);
// I(di,e) <+ ((devsign*igisl))
d_staticContributions_dX[admsNodeID_di]+= devsign*d_igisl_dX;
d_staticContributions_dX[(admsNodeID_e)]-= devsign*d_igisl_dX;
// I(g,e) <+ ((devsign*(igbinv+igbacc)))
d_staticContributions_dX[admsNodeID_g]+= devsign*(d_igbinv_dX+d_igbacc_dX);
d_staticContributions_dX[(admsNodeID_e)]-= devsign*(d_igbinv_dX+d_igbacc_dX);
}
else
{
// I(si,di) <+ ((devsign*(igidl+Iii)))
d_staticContributions_dX[admsNodeID_si]+= devsign*(d_igidl_dX+d_Iii_dX);
d_staticContributions_dX[(admsNodeID_di)]-= devsign*(d_igidl_dX+d_Iii_dX);
// I(di,si) <+ ((devsign*igisl))
d_staticContributions_dX[admsNodeID_di]+= devsign*d_igisl_dX;
d_staticContributions_dX[(admsNodeID_si)]-= devsign*d_igisl_dX;
}
}
if ((modelStruct.modelPar_BULKMOD==0))
{
// I(g,si) <+ ((devsign*igbs))
d_staticContributions_dX[admsNodeID_g]+= devsign*d_igbs_dX;
d_staticContributions_dX[(admsNodeID_si)]-= devsign*d_igbs_dX;
// I(g,di) <+ ((devsign*igbd))
d_staticContributions_dX[admsNodeID_g]+= devsign*d_igbd_dX;
d_staticContributions_dX[(admsNodeID_di)]-= devsign*d_igbd_dX;
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
// I(e,si) <+ ((devsign*Ies))
d_staticContributions_dX[admsNodeID_e]+= devsign*d_Ies_dX;
d_staticContributions_dX[(admsNodeID_si)]-= devsign*d_Ies_dX;
// I(e,di) <+ ((devsign*Ied))
d_staticContributions_dX[admsNodeID_e]+= devsign*d_Ied_dX;
d_staticContributions_dX[(admsNodeID_di)]-= devsign*d_Ied_dX;
}
// I(e,si) <+ ((devsign*ddt(Qes)))
d_dynamicContributions_dX[admsNodeID_e]+= devsign*(d_Qes_dX);
d_dynamicContributions_dX[(admsNodeID_si)]-= devsign*(d_Qes_dX);
// I(e,di) <+ ((devsign*ddt(Qed)))
d_dynamicContributions_dX[admsNodeID_e]+= devsign*(d_Qed_dX);
d_dynamicContributions_dX[(admsNodeID_di)]-= devsign*(d_Qed_dX);
// I(e,g) <+ ((devsign*ddt(Qeg)))
d_dynamicContributions_dX[admsNodeID_e]+= devsign*(d_Qeg_dX);
d_dynamicContributions_dX[(admsNodeID_g)]-= devsign*(d_Qeg_dX);
// I(g,si) <+ (ddt(qgs_parasitic))
d_dynamicContributions_dX[admsNodeID_g]+= (d_qgs_parasitic_dX);
d_dynamicContributions_dX[(admsNodeID_si)]-= (d_qgs_parasitic_dX);
// I(g,di) <+ (ddt(qgd_parasitic))
d_dynamicContributions_dX[admsNodeID_g]+= (d_qgd_parasitic_dX);
d_dynamicContributions_dX[(admsNodeID_di)]-= (d_qgd_parasitic_dX);
// I(d,s) <+ (ddt(qds_fr))
d_dynamicContributions_dX[admsNodeID_d]+= (d_qds_fr_dX);
d_dynamicContributions_dX[(admsNodeID_s)]-= (d_qds_fr_dX);
if ((modelStruct.modelPar_CGEOMOD==1))
{
// I(g,s) <+ (ddt(qgs_fr))
d_dynamicContributions_dX[admsNodeID_g]+= (d_qgs_fr_dX);
d_dynamicContributions_dX[(admsNodeID_s)]-= (d_qgs_fr_dX);
// I(g,d) <+ (ddt(qgd_fr))
d_dynamicContributions_dX[admsNodeID_g]+= (d_qgd_fr_dX);
d_dynamicContributions_dX[(admsNodeID_d)]-= (d_qgd_fr_dX);
}
if (((modelStruct.modelPar_CAPMOD!=0)&&(modelStruct.modelPar_BULKMOD!=0)))
{
// I(g,si) <+ ((devsign*ddt(qg_acc)))
d_dynamicContributions_dX[admsNodeID_g]+= devsign*(d_qg_acc_dX);
d_dynamicContributions_dX[(admsNodeID_si)]-= devsign*(d_qg_acc_dX);
// I(e,si) <+ ((devsign*ddt(qb_acc)))
d_dynamicContributions_dX[admsNodeID_e]+= devsign*(d_qb_acc_dX);
d_dynamicContributions_dX[(admsNodeID_si)]-= devsign*(d_qb_acc_dX);
}
// I(d,di) <+ ((V(d,di)/Rdrain))
d_staticContributions_dX[admsNodeID_d]+= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dX/Rdrain/Rdrain);
d_staticContributions_dX[(admsNodeID_di)]-= (-(probeVars[admsProbeID_V_d_di])*d_Rdrain_dX/Rdrain/Rdrain);
// I(s,si) <+ ((V(s,si)/Rsource))
d_staticContributions_dX[admsNodeID_s]+= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dX/Rsource/Rsource);
d_staticContributions_dX[(admsNodeID_si)]-= (-(probeVars[admsProbeID_V_s_si])*d_Rsource_dX/Rsource/Rsource);
// I(di,si) <+ (flicker_noise(FNPowerAt1Hz,EF,"flicker"))
// I(d,di) <+ (white_noise((((4*Vtm)*1.60219e-19)*gdpr),"thermal"))
// I(s,si) <+ (white_noise((((4*Vtm)*1.60219e-19)*gspr),"thermal"))
// I(di,si) <+ (white_noise(sid,"thermal"))
if ((modelStruct.modelPar_IGCMOD!=0))
{
if ((sigvds>0))
{
// I(g,si) <+ (white_noise(((2*1.60219e-19)*abs((igcs+igs))),"shot"))
// I(g,di) <+ (white_noise(((2*1.60219e-19)*abs((igcd+igd))),"shot"))
}
else
{
// I(g,di) <+ (white_noise(((2*1.60219e-19)*abs((igcs+igs))),"shot"))
// I(g,si) <+ (white_noise(((2*1.60219e-19)*abs((igcd+igd))),"shot"))
}
}
if ((modelStruct.modelPar_IGBMOD!=0))
{
if ((modelStruct.modelPar_BULKMOD!=0))
{
// I(g,e) <+ (white_noise(((2*1.60219e-19)*abs((igbinv+igbacc))),"shot"))
}
else
{
// I(g,si) <+ (white_noise(((2*1.60219e-19)*abs(igbs)),"shot"))
// I(g,di) <+ (white_noise(((2*1.60219e-19)*abs(igbd)),"shot"))
}
}
if ((sigvds>0))
{
if ((modelStruct.modelPar_BULKMOD!=0))
{
}
else
{
}
}
else
{
if ((modelStruct.modelPar_BULKMOD!=0))
{
}
else
{
}
}
if ((modelStruct.modelPar_BULKMOD==0))
{
}
else
{
}
if ((sigvds>0))
{
}
else
{
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
}
else
{
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
}
else
{
}
if ((NGATE_i>0))
{
}
else
{
}
if ((modelStruct.modelPar_GEOMOD!=3))
{
d_q0_dX = ((cox*(((5.0*Vtm)*((instanceStruct.instancePar_TFIN*d_epssub_dX-epssub*instanceStruct.d_instancePar_TFIN_dX)/instanceStruct.instancePar_TFIN/instanceStruct.instancePar_TFIN)+5.0*d_Vtm_dX*(epssub/instanceStruct.instancePar_TFIN))+2.0*d_Qbul_dX)-(((5.0*Vtm)*(epssub/instanceStruct.instancePar_TFIN))+(2.0*Qbul))*d_cox_dX)/cox/cox);
q0 = ((((5.0*Vtm)*(epssub/instanceStruct.instancePar_TFIN))+(2.0*Qbul))/cox);
d_T1_dX = (Vtm*(d_Vtm_dX+d_q0_dX)+d_Vtm_dX*(Vtm+q0));
T1 = (Vtm*(Vtm+q0));
d_T2_dX = ((cox*cox)*d_T1_dX+(cox*d_cox_dX+d_cox_dX*cox)*T1);
T2 = ((cox*cox)*T1);
d_T3_dX = ((((2.0*1.60219e-19)*ni)*epssub)*d_Vtm_dX+(((2.0*1.60219e-19)*ni)*d_epssub_dX+(2.0*1.60219e-19)*d_ni_dX*epssub)*Vtm);
T3 = ((((2.0*1.60219e-19)*ni)*epssub)*Vtm);
}
else
{
d_T1_dX = ((cdop*(Vtm*d_r1_dX+d_Vtm_dX*r1)-(Vtm*r1)*d_cdop_dX)/cdop/cdop);
T1 = ((Vtm*r1)/cdop);
{
double value_sqrt_0 = sqrt(((T1*T1)+((2.0*T1)*Vtm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qith_dX = (deriv_sqrt_0_d0*(((T1*d_T1_dX+d_T1_dX*T1)+((2.0*T1)*d_Vtm_dX+2.0*d_T1_dX*Vtm)))-d_T1_dX);
qith = (value_sqrt_0-T1);
}
d_g0_dX = ((q0*d_qith_dX-qith*d_q0_dX)/q0/q0);
g0 = (qith/q0);
{
AnalogFunctions::llnEvaluator evaluator_lln_0(g0);
AnalogFunctions::llnEvaluator evaluator_lln_1((1.0+(cdop*g0)));
d_F0_dX = (((0.5*evaluator_lln_0.getDerivs(g0,d_g0_dX)+0.5*evaluator_lln_1.getDerivs((1.0+(cdop*g0)),(cdop*d_g0_dX+d_cdop_dX*g0)))+(r1*d_g0_dX+d_r1_dX*g0))+((r2*g0)*d_g0_dX+(r2*d_g0_dX+d_r2_dX*g0)*g0));
F0 = ((((0.5*evaluator_lln_0.getValues(g0))+(0.5*evaluator_lln_1.getValues((1.0+(cdop*g0)))))+(r1*g0))+((r2*g0)*g0));
}
}
if ((modelStruct.modelPar_BULKMOD!=0))
{
}
else
{
}
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(6+0);
dqdp.resize(6+0);
Findices.resize(6+0);
Qindices.resize(6+0);

std::vector <double> probeVars(18);
std::vector <double> d_staticContributions_dX(6+0);
std::vector <double> d_dynamicContributions_dX(6+0);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 6+0 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_L=mod.L;
modelStruct.d_modelPar_L_dX=0.0;
modelStruct.modelPar_given_L=mod.given("L");
modelStruct.modelPar_D=mod.D;
modelStruct.d_modelPar_D_dX=0.0;
modelStruct.modelPar_given_D=mod.given("D");
modelStruct.modelPar_TFIN=mod.TFIN;
modelStruct.d_modelPar_TFIN_dX=0.0;
modelStruct.modelPar_given_TFIN=mod.given("TFIN");
modelStruct.modelPar_FPITCH=mod.FPITCH;
modelStruct.d_modelPar_FPITCH_dX=0.0;
modelStruct.modelPar_given_FPITCH=mod.given("FPITCH");
modelStruct.modelPar_NFIN=mod.NFIN;
modelStruct.d_modelPar_NFIN_dX=0.0;
modelStruct.modelPar_given_NFIN=mod.given("NFIN");
modelStruct.modelPar_ASEO=mod.ASEO;
modelStruct.d_modelPar_ASEO_dX=0.0;
modelStruct.modelPar_given_ASEO=mod.given("ASEO");
modelStruct.modelPar_ADEO=mod.ADEO;
modelStruct.d_modelPar_ADEO_dX=0.0;
modelStruct.modelPar_given_ADEO=mod.given("ADEO");
modelStruct.modelPar_PSEO=mod.PSEO;
modelStruct.d_modelPar_PSEO_dX=0.0;
modelStruct.modelPar_given_PSEO=mod.given("PSEO");
modelStruct.modelPar_PDEO=mod.PDEO;
modelStruct.d_modelPar_PDEO_dX=0.0;
modelStruct.modelPar_given_PDEO=mod.given("PDEO");
modelStruct.modelPar_ASEJ=mod.ASEJ;
modelStruct.d_modelPar_ASEJ_dX=0.0;
modelStruct.modelPar_given_ASEJ=mod.given("ASEJ");
modelStruct.modelPar_ADEJ=mod.ADEJ;
modelStruct.d_modelPar_ADEJ_dX=0.0;
modelStruct.modelPar_given_ADEJ=mod.given("ADEJ");
modelStruct.modelPar_PSEJ=mod.PSEJ;
modelStruct.d_modelPar_PSEJ_dX=0.0;
modelStruct.modelPar_given_PSEJ=mod.given("PSEJ");
modelStruct.modelPar_PDEJ=mod.PDEJ;
modelStruct.d_modelPar_PDEJ_dX=0.0;
modelStruct.modelPar_given_PDEJ=mod.given("PDEJ");
modelStruct.modelPar_COVS=mod.COVS;
modelStruct.d_modelPar_COVS_dX=0.0;
modelStruct.modelPar_given_COVS=mod.given("COVS");
modelStruct.modelPar_COVD=mod.COVD;
modelStruct.d_modelPar_COVD_dX=0.0;
modelStruct.modelPar_given_COVD=mod.given("COVD");
modelStruct.modelPar_CGSP=mod.CGSP;
modelStruct.d_modelPar_CGSP_dX=0.0;
modelStruct.modelPar_given_CGSP=mod.given("CGSP");
modelStruct.modelPar_CGDP=mod.CGDP;
modelStruct.d_modelPar_CGDP_dX=0.0;
modelStruct.modelPar_given_CGDP=mod.given("CGDP");
modelStruct.modelPar_CDSP=mod.CDSP;
modelStruct.d_modelPar_CDSP_dX=0.0;
modelStruct.modelPar_given_CDSP=mod.given("CDSP");
modelStruct.modelPar_NRS=mod.NRS;
modelStruct.d_modelPar_NRS_dX=0.0;
modelStruct.modelPar_given_NRS=mod.given("NRS");
modelStruct.modelPar_NRD=mod.NRD;
modelStruct.d_modelPar_NRD_dX=0.0;
modelStruct.modelPar_given_NRD=mod.given("NRD");
modelStruct.modelPar_LRSD=mod.LRSD;
modelStruct.d_modelPar_LRSD_dX=0.0;
modelStruct.modelPar_given_LRSD=mod.given("LRSD");
modelStruct.modelPar_XL=mod.XL;
modelStruct.d_modelPar_XL_dX=0.0;
modelStruct.modelPar_given_XL=mod.given("XL");
modelStruct.modelPar_DTEMP=mod.DTEMP;
modelStruct.d_modelPar_DTEMP_dX=0.0;
modelStruct.modelPar_given_DTEMP=mod.given("DTEMP");
modelStruct.modelPar_DELVTRAND=mod.DELVTRAND;
modelStruct.d_modelPar_DELVTRAND_dX=0.0;
modelStruct.modelPar_given_DELVTRAND=mod.given("DELVTRAND");
modelStruct.modelPar_U0MULT=mod.U0MULT;
modelStruct.d_modelPar_U0MULT_dX=0.0;
modelStruct.modelPar_given_U0MULT=mod.given("U0MULT");
modelStruct.modelPar_IDS0MULT=mod.IDS0MULT;
modelStruct.d_modelPar_IDS0MULT_dX=0.0;
modelStruct.modelPar_given_IDS0MULT=mod.given("IDS0MULT");
modelStruct.modelPar_LINT=mod.LINT;
modelStruct.d_modelPar_LINT_dX=0.0;
modelStruct.modelPar_given_LINT=mod.given("LINT");
modelStruct.modelPar_LL=mod.LL;
modelStruct.d_modelPar_LL_dX=0.0;
modelStruct.modelPar_given_LL=mod.given("LL");
modelStruct.modelPar_LLN=mod.LLN;
modelStruct.d_modelPar_LLN_dX=0.0;
modelStruct.modelPar_given_LLN=mod.given("LLN");
modelStruct.modelPar_DLC=mod.DLC;
modelStruct.d_modelPar_DLC_dX=0.0;
modelStruct.modelPar_given_DLC=mod.given("DLC");
modelStruct.modelPar_DLCACC=mod.DLCACC;
modelStruct.d_modelPar_DLCACC_dX=0.0;
modelStruct.modelPar_given_DLCACC=mod.given("DLCACC");
modelStruct.modelPar_DLBIN=mod.DLBIN;
modelStruct.d_modelPar_DLBIN_dX=0.0;
modelStruct.modelPar_given_DLBIN=mod.given("DLBIN");
modelStruct.modelPar_LLC=mod.LLC;
modelStruct.d_modelPar_LLC_dX=0.0;
modelStruct.modelPar_given_LLC=mod.given("LLC");
modelStruct.modelPar_EOT=mod.EOT;
modelStruct.d_modelPar_EOT_dX=0.0;
modelStruct.modelPar_given_EOT=mod.given("EOT");
modelStruct.modelPar_TOXP=mod.TOXP;
modelStruct.d_modelPar_TOXP_dX=0.0;
modelStruct.modelPar_given_TOXP=mod.given("TOXP");
modelStruct.modelPar_EOTBOX=mod.EOTBOX;
modelStruct.d_modelPar_EOTBOX_dX=0.0;
modelStruct.modelPar_given_EOTBOX=mod.given("EOTBOX");
modelStruct.modelPar_HFIN=mod.HFIN;
modelStruct.d_modelPar_HFIN_dX=0.0;
modelStruct.modelPar_given_HFIN=mod.given("HFIN");
modelStruct.modelPar_FECH=mod.FECH;
modelStruct.d_modelPar_FECH_dX=0.0;
modelStruct.modelPar_given_FECH=mod.given("FECH");
modelStruct.modelPar_DELTAW=mod.DELTAW;
modelStruct.d_modelPar_DELTAW_dX=0.0;
modelStruct.modelPar_given_DELTAW=mod.given("DELTAW");
modelStruct.modelPar_FECHCV=mod.FECHCV;
modelStruct.d_modelPar_FECHCV_dX=0.0;
modelStruct.modelPar_given_FECHCV=mod.given("FECHCV");
modelStruct.modelPar_DELTAWCV=mod.DELTAWCV;
modelStruct.d_modelPar_DELTAWCV_dX=0.0;
modelStruct.modelPar_given_DELTAWCV=mod.given("DELTAWCV");
modelStruct.modelPar_NBODY=mod.NBODY;
modelStruct.d_modelPar_NBODY_dX=0.0;
modelStruct.modelPar_given_NBODY=mod.given("NBODY");
modelStruct.modelPar_NBODYN1=mod.NBODYN1;
modelStruct.d_modelPar_NBODYN1_dX=0.0;
modelStruct.modelPar_given_NBODYN1=mod.given("NBODYN1");
modelStruct.modelPar_NBODYN2=mod.NBODYN2;
modelStruct.d_modelPar_NBODYN2_dX=0.0;
modelStruct.modelPar_given_NBODYN2=mod.given("NBODYN2");
modelStruct.modelPar_NSD=mod.NSD;
modelStruct.d_modelPar_NSD_dX=0.0;
modelStruct.modelPar_given_NSD=mod.given("NSD");
modelStruct.modelPar_PHIG=mod.PHIG;
modelStruct.d_modelPar_PHIG_dX=0.0;
modelStruct.modelPar_given_PHIG=mod.given("PHIG");
modelStruct.modelPar_PHIGL=mod.PHIGL;
modelStruct.d_modelPar_PHIGL_dX=0.0;
modelStruct.modelPar_given_PHIGL=mod.given("PHIGL");
modelStruct.modelPar_PHIGN1=mod.PHIGN1;
modelStruct.d_modelPar_PHIGN1_dX=0.0;
modelStruct.modelPar_given_PHIGN1=mod.given("PHIGN1");
modelStruct.modelPar_PHIGN2=mod.PHIGN2;
modelStruct.d_modelPar_PHIGN2_dX=0.0;
modelStruct.modelPar_given_PHIGN2=mod.given("PHIGN2");
modelStruct.modelPar_EPSROX=mod.EPSROX;
modelStruct.d_modelPar_EPSROX_dX=0.0;
modelStruct.modelPar_given_EPSROX=mod.given("EPSROX");
modelStruct.modelPar_EPSRSUB=mod.EPSRSUB;
modelStruct.d_modelPar_EPSRSUB_dX=0.0;
modelStruct.modelPar_given_EPSRSUB=mod.given("EPSRSUB");
modelStruct.modelPar_EASUB=mod.EASUB;
modelStruct.d_modelPar_EASUB_dX=0.0;
modelStruct.modelPar_given_EASUB=mod.given("EASUB");
modelStruct.modelPar_NI0SUB=mod.NI0SUB;
modelStruct.d_modelPar_NI0SUB_dX=0.0;
modelStruct.modelPar_given_NI0SUB=mod.given("NI0SUB");
modelStruct.modelPar_BG0SUB=mod.BG0SUB;
modelStruct.d_modelPar_BG0SUB_dX=0.0;
modelStruct.modelPar_given_BG0SUB=mod.given("BG0SUB");
modelStruct.modelPar_NC0SUB=mod.NC0SUB;
modelStruct.d_modelPar_NC0SUB_dX=0.0;
modelStruct.modelPar_given_NC0SUB=mod.given("NC0SUB");
modelStruct.modelPar_NGATE=mod.NGATE;
modelStruct.d_modelPar_NGATE_dX=0.0;
modelStruct.modelPar_given_NGATE=mod.given("NGATE");
modelStruct.modelPar_Imin=mod.Imin;
modelStruct.d_modelPar_Imin_dX=0.0;
modelStruct.modelPar_given_Imin=mod.given("Imin");
modelStruct.modelPar_CIT=mod.CIT;
modelStruct.d_modelPar_CIT_dX=0.0;
modelStruct.modelPar_given_CIT=mod.given("CIT");
modelStruct.modelPar_CDSC=mod.CDSC;
modelStruct.d_modelPar_CDSC_dX=0.0;
modelStruct.modelPar_given_CDSC=mod.given("CDSC");
modelStruct.modelPar_CDSCN1=mod.CDSCN1;
modelStruct.d_modelPar_CDSCN1_dX=0.0;
modelStruct.modelPar_given_CDSCN1=mod.given("CDSCN1");
modelStruct.modelPar_CDSCN2=mod.CDSCN2;
modelStruct.d_modelPar_CDSCN2_dX=0.0;
modelStruct.modelPar_given_CDSCN2=mod.given("CDSCN2");
modelStruct.modelPar_CDSCD=mod.CDSCD;
modelStruct.d_modelPar_CDSCD_dX=0.0;
modelStruct.modelPar_given_CDSCD=mod.given("CDSCD");
modelStruct.modelPar_CDSCDN1=mod.CDSCDN1;
modelStruct.d_modelPar_CDSCDN1_dX=0.0;
modelStruct.modelPar_given_CDSCDN1=mod.given("CDSCDN1");
modelStruct.modelPar_CDSCDN2=mod.CDSCDN2;
modelStruct.d_modelPar_CDSCDN2_dX=0.0;
modelStruct.modelPar_given_CDSCDN2=mod.given("CDSCDN2");
modelStruct.modelPar_CDSCDR=mod.CDSCDR;
modelStruct.d_modelPar_CDSCDR_dX=0.0;
modelStruct.modelPar_given_CDSCDR=mod.given("CDSCDR");
modelStruct.modelPar_CDSCDRN1=mod.CDSCDRN1;
modelStruct.d_modelPar_CDSCDRN1_dX=0.0;
modelStruct.modelPar_given_CDSCDRN1=mod.given("CDSCDRN1");
modelStruct.modelPar_CDSCDRN2=mod.CDSCDRN2;
modelStruct.d_modelPar_CDSCDRN2_dX=0.0;
modelStruct.modelPar_given_CDSCDRN2=mod.given("CDSCDRN2");
modelStruct.modelPar_DVT0=mod.DVT0;
modelStruct.d_modelPar_DVT0_dX=0.0;
modelStruct.modelPar_given_DVT0=mod.given("DVT0");
modelStruct.modelPar_DVT1=mod.DVT1;
modelStruct.d_modelPar_DVT1_dX=0.0;
modelStruct.modelPar_given_DVT1=mod.given("DVT1");
modelStruct.modelPar_DVT1SS=mod.DVT1SS;
modelStruct.d_modelPar_DVT1SS_dX=0.0;
modelStruct.modelPar_given_DVT1SS=mod.given("DVT1SS");
modelStruct.modelPar_PHIN=mod.PHIN;
modelStruct.d_modelPar_PHIN_dX=0.0;
modelStruct.modelPar_given_PHIN=mod.given("PHIN");
modelStruct.modelPar_ETA0=mod.ETA0;
modelStruct.d_modelPar_ETA0_dX=0.0;
modelStruct.modelPar_given_ETA0=mod.given("ETA0");
modelStruct.modelPar_ETA0N1=mod.ETA0N1;
modelStruct.d_modelPar_ETA0N1_dX=0.0;
modelStruct.modelPar_given_ETA0N1=mod.given("ETA0N1");
modelStruct.modelPar_ETA0N2=mod.ETA0N2;
modelStruct.d_modelPar_ETA0N2_dX=0.0;
modelStruct.modelPar_given_ETA0N2=mod.given("ETA0N2");
modelStruct.modelPar_TETA0=mod.TETA0;
modelStruct.d_modelPar_TETA0_dX=0.0;
modelStruct.modelPar_given_TETA0=mod.given("TETA0");
modelStruct.modelPar_ETA0R=mod.ETA0R;
modelStruct.d_modelPar_ETA0R_dX=0.0;
modelStruct.modelPar_given_ETA0R=mod.given("ETA0R");
modelStruct.modelPar_TETA0R=mod.TETA0R;
modelStruct.d_modelPar_TETA0R_dX=0.0;
modelStruct.modelPar_given_TETA0R=mod.given("TETA0R");
modelStruct.modelPar_DSUB=mod.DSUB;
modelStruct.d_modelPar_DSUB_dX=0.0;
modelStruct.modelPar_given_DSUB=mod.given("DSUB");
modelStruct.modelPar_DVTP0=mod.DVTP0;
modelStruct.d_modelPar_DVTP0_dX=0.0;
modelStruct.modelPar_given_DVTP0=mod.given("DVTP0");
modelStruct.modelPar_DVTP1=mod.DVTP1;
modelStruct.d_modelPar_DVTP1_dX=0.0;
modelStruct.modelPar_given_DVTP1=mod.given("DVTP1");
modelStruct.modelPar_K1RSCE=mod.K1RSCE;
modelStruct.d_modelPar_K1RSCE_dX=0.0;
modelStruct.modelPar_given_K1RSCE=mod.given("K1RSCE");
modelStruct.modelPar_LPE0=mod.LPE0;
modelStruct.d_modelPar_LPE0_dX=0.0;
modelStruct.modelPar_given_LPE0=mod.given("LPE0");
modelStruct.modelPar_DVTSHIFT=mod.DVTSHIFT;
modelStruct.d_modelPar_DVTSHIFT_dX=0.0;
modelStruct.modelPar_given_DVTSHIFT=mod.given("DVTSHIFT");
modelStruct.modelPar_K0=mod.K0;
modelStruct.d_modelPar_K0_dX=0.0;
modelStruct.modelPar_given_K0=mod.given("K0");
modelStruct.modelPar_K01=mod.K01;
modelStruct.d_modelPar_K01_dX=0.0;
modelStruct.modelPar_given_K01=mod.given("K01");
modelStruct.modelPar_K0SI=mod.K0SI;
modelStruct.d_modelPar_K0SI_dX=0.0;
modelStruct.modelPar_given_K0SI=mod.given("K0SI");
modelStruct.modelPar_K0SI1=mod.K0SI1;
modelStruct.d_modelPar_K0SI1_dX=0.0;
modelStruct.modelPar_given_K0SI1=mod.given("K0SI1");
modelStruct.modelPar_K1SI=mod.K1SI;
modelStruct.d_modelPar_K1SI_dX=0.0;
modelStruct.modelPar_given_K1SI=mod.given("K1SI");
modelStruct.modelPar_K1SI1=mod.K1SI1;
modelStruct.d_modelPar_K1SI1_dX=0.0;
modelStruct.modelPar_given_K1SI1=mod.given("K1SI1");
modelStruct.modelPar_PHIBE=mod.PHIBE;
modelStruct.d_modelPar_PHIBE_dX=0.0;
modelStruct.modelPar_given_PHIBE=mod.given("PHIBE");
modelStruct.modelPar_K1=mod.K1;
modelStruct.d_modelPar_K1_dX=0.0;
modelStruct.modelPar_given_K1=mod.given("K1");
modelStruct.modelPar_K11=mod.K11;
modelStruct.d_modelPar_K11_dX=0.0;
modelStruct.modelPar_given_K11=mod.given("K11");
modelStruct.modelPar_K1SAT=mod.K1SAT;
modelStruct.d_modelPar_K1SAT_dX=0.0;
modelStruct.modelPar_given_K1SAT=mod.given("K1SAT");
modelStruct.modelPar_K1SAT1=mod.K1SAT1;
modelStruct.d_modelPar_K1SAT1_dX=0.0;
modelStruct.modelPar_given_K1SAT1=mod.given("K1SAT1");
modelStruct.modelPar_QMFACTOR=mod.QMFACTOR;
modelStruct.d_modelPar_QMFACTOR_dX=0.0;
modelStruct.modelPar_given_QMFACTOR=mod.given("QMFACTOR");
modelStruct.modelPar_QMTCENIV=mod.QMTCENIV;
modelStruct.d_modelPar_QMTCENIV_dX=0.0;
modelStruct.modelPar_given_QMTCENIV=mod.given("QMTCENIV");
modelStruct.modelPar_QMTCENCV=mod.QMTCENCV;
modelStruct.d_modelPar_QMTCENCV_dX=0.0;
modelStruct.modelPar_given_QMTCENCV=mod.given("QMTCENCV");
modelStruct.modelPar_QMTCENCVA=mod.QMTCENCVA;
modelStruct.d_modelPar_QMTCENCVA_dX=0.0;
modelStruct.modelPar_given_QMTCENCVA=mod.given("QMTCENCVA");
modelStruct.modelPar_AQMTCEN=mod.AQMTCEN;
modelStruct.d_modelPar_AQMTCEN_dX=0.0;
modelStruct.modelPar_given_AQMTCEN=mod.given("AQMTCEN");
modelStruct.modelPar_BQMTCEN=mod.BQMTCEN;
modelStruct.d_modelPar_BQMTCEN_dX=0.0;
modelStruct.modelPar_given_BQMTCEN=mod.given("BQMTCEN");
modelStruct.modelPar_ETAQM=mod.ETAQM;
modelStruct.d_modelPar_ETAQM_dX=0.0;
modelStruct.modelPar_given_ETAQM=mod.given("ETAQM");
modelStruct.modelPar_QM0=mod.QM0;
modelStruct.d_modelPar_QM0_dX=0.0;
modelStruct.modelPar_given_QM0=mod.given("QM0");
modelStruct.modelPar_PQM=mod.PQM;
modelStruct.d_modelPar_PQM_dX=0.0;
modelStruct.modelPar_given_PQM=mod.given("PQM");
modelStruct.modelPar_QM0ACC=mod.QM0ACC;
modelStruct.d_modelPar_QM0ACC_dX=0.0;
modelStruct.modelPar_given_QM0ACC=mod.given("QM0ACC");
modelStruct.modelPar_PQMACC=mod.PQMACC;
modelStruct.d_modelPar_PQMACC_dX=0.0;
modelStruct.modelPar_given_PQMACC=mod.given("PQMACC");
modelStruct.modelPar_VSAT=mod.VSAT;
modelStruct.d_modelPar_VSAT_dX=0.0;
modelStruct.modelPar_given_VSAT=mod.given("VSAT");
modelStruct.modelPar_VSATN1=mod.VSATN1;
modelStruct.d_modelPar_VSATN1_dX=0.0;
modelStruct.modelPar_given_VSATN1=mod.given("VSATN1");
modelStruct.modelPar_VSATN2=mod.VSATN2;
modelStruct.d_modelPar_VSATN2_dX=0.0;
modelStruct.modelPar_given_VSATN2=mod.given("VSATN2");
modelStruct.modelPar_AVSAT=mod.AVSAT;
modelStruct.d_modelPar_AVSAT_dX=0.0;
modelStruct.modelPar_given_AVSAT=mod.given("AVSAT");
modelStruct.modelPar_BVSAT=mod.BVSAT;
modelStruct.d_modelPar_BVSAT_dX=0.0;
modelStruct.modelPar_given_BVSAT=mod.given("BVSAT");
modelStruct.modelPar_VSAT1=mod.VSAT1;
modelStruct.d_modelPar_VSAT1_dX=0.0;
modelStruct.modelPar_given_VSAT1=mod.given("VSAT1");
modelStruct.modelPar_VSAT1N1=mod.VSAT1N1;
modelStruct.d_modelPar_VSAT1N1_dX=0.0;
modelStruct.modelPar_given_VSAT1N1=mod.given("VSAT1N1");
modelStruct.modelPar_VSAT1N2=mod.VSAT1N2;
modelStruct.d_modelPar_VSAT1N2_dX=0.0;
modelStruct.modelPar_given_VSAT1N2=mod.given("VSAT1N2");
modelStruct.modelPar_VSAT1R=mod.VSAT1R;
modelStruct.d_modelPar_VSAT1R_dX=0.0;
modelStruct.modelPar_given_VSAT1R=mod.given("VSAT1R");
modelStruct.modelPar_VSAT1RN1=mod.VSAT1RN1;
modelStruct.d_modelPar_VSAT1RN1_dX=0.0;
modelStruct.modelPar_given_VSAT1RN1=mod.given("VSAT1RN1");
modelStruct.modelPar_VSAT1RN2=mod.VSAT1RN2;
modelStruct.d_modelPar_VSAT1RN2_dX=0.0;
modelStruct.modelPar_given_VSAT1RN2=mod.given("VSAT1RN2");
modelStruct.modelPar_AVSAT1=mod.AVSAT1;
modelStruct.d_modelPar_AVSAT1_dX=0.0;
modelStruct.modelPar_given_AVSAT1=mod.given("AVSAT1");
modelStruct.modelPar_BVSAT1=mod.BVSAT1;
modelStruct.d_modelPar_BVSAT1_dX=0.0;
modelStruct.modelPar_given_BVSAT1=mod.given("BVSAT1");
modelStruct.modelPar_DELTAVSAT=mod.DELTAVSAT;
modelStruct.d_modelPar_DELTAVSAT_dX=0.0;
modelStruct.modelPar_given_DELTAVSAT=mod.given("DELTAVSAT");
modelStruct.modelPar_PSAT=mod.PSAT;
modelStruct.d_modelPar_PSAT_dX=0.0;
modelStruct.modelPar_given_PSAT=mod.given("PSAT");
modelStruct.modelPar_APSAT=mod.APSAT;
modelStruct.d_modelPar_APSAT_dX=0.0;
modelStruct.modelPar_given_APSAT=mod.given("APSAT");
modelStruct.modelPar_BPSAT=mod.BPSAT;
modelStruct.d_modelPar_BPSAT_dX=0.0;
modelStruct.modelPar_given_BPSAT=mod.given("BPSAT");
modelStruct.modelPar_KSATIV=mod.KSATIV;
modelStruct.d_modelPar_KSATIV_dX=0.0;
modelStruct.modelPar_given_KSATIV=mod.given("KSATIV");
modelStruct.modelPar_VSATCV=mod.VSATCV;
modelStruct.d_modelPar_VSATCV_dX=0.0;
modelStruct.modelPar_given_VSATCV=mod.given("VSATCV");
modelStruct.modelPar_AVSATCV=mod.AVSATCV;
modelStruct.d_modelPar_AVSATCV_dX=0.0;
modelStruct.modelPar_given_AVSATCV=mod.given("AVSATCV");
modelStruct.modelPar_BVSATCV=mod.BVSATCV;
modelStruct.d_modelPar_BVSATCV_dX=0.0;
modelStruct.modelPar_given_BVSATCV=mod.given("BVSATCV");
modelStruct.modelPar_DELTAVSATCV=mod.DELTAVSATCV;
modelStruct.d_modelPar_DELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_DELTAVSATCV=mod.given("DELTAVSATCV");
modelStruct.modelPar_PSATCV=mod.PSATCV;
modelStruct.d_modelPar_PSATCV_dX=0.0;
modelStruct.modelPar_given_PSATCV=mod.given("PSATCV");
modelStruct.modelPar_APSATCV=mod.APSATCV;
modelStruct.d_modelPar_APSATCV_dX=0.0;
modelStruct.modelPar_given_APSATCV=mod.given("APSATCV");
modelStruct.modelPar_BPSATCV=mod.BPSATCV;
modelStruct.d_modelPar_BPSATCV_dX=0.0;
modelStruct.modelPar_given_BPSATCV=mod.given("BPSATCV");
modelStruct.modelPar_MEXP=mod.MEXP;
modelStruct.d_modelPar_MEXP_dX=0.0;
modelStruct.modelPar_given_MEXP=mod.given("MEXP");
modelStruct.modelPar_AMEXP=mod.AMEXP;
modelStruct.d_modelPar_AMEXP_dX=0.0;
modelStruct.modelPar_given_AMEXP=mod.given("AMEXP");
modelStruct.modelPar_BMEXP=mod.BMEXP;
modelStruct.d_modelPar_BMEXP_dX=0.0;
modelStruct.modelPar_given_BMEXP=mod.given("BMEXP");
modelStruct.modelPar_MEXPR=mod.MEXPR;
modelStruct.d_modelPar_MEXPR_dX=0.0;
modelStruct.modelPar_given_MEXPR=mod.given("MEXPR");
modelStruct.modelPar_AMEXPR=mod.AMEXPR;
modelStruct.d_modelPar_AMEXPR_dX=0.0;
modelStruct.modelPar_given_AMEXPR=mod.given("AMEXPR");
modelStruct.modelPar_BMEXPR=mod.BMEXPR;
modelStruct.d_modelPar_BMEXPR_dX=0.0;
modelStruct.modelPar_given_BMEXPR=mod.given("BMEXPR");
modelStruct.modelPar_PTWG=mod.PTWG;
modelStruct.d_modelPar_PTWG_dX=0.0;
modelStruct.modelPar_given_PTWG=mod.given("PTWG");
modelStruct.modelPar_PTWGR=mod.PTWGR;
modelStruct.d_modelPar_PTWGR_dX=0.0;
modelStruct.modelPar_given_PTWGR=mod.given("PTWGR");
modelStruct.modelPar_APTWG=mod.APTWG;
modelStruct.d_modelPar_APTWG_dX=0.0;
modelStruct.modelPar_given_APTWG=mod.given("APTWG");
modelStruct.modelPar_BPTWG=mod.BPTWG;
modelStruct.d_modelPar_BPTWG_dX=0.0;
modelStruct.modelPar_given_BPTWG=mod.given("BPTWG");
modelStruct.modelPar_AT=mod.AT;
modelStruct.d_modelPar_AT_dX=0.0;
modelStruct.modelPar_given_AT=mod.given("AT");
modelStruct.modelPar_TMEXP=mod.TMEXP;
modelStruct.d_modelPar_TMEXP_dX=0.0;
modelStruct.modelPar_given_TMEXP=mod.given("TMEXP");
modelStruct.modelPar_TMEXPR=mod.TMEXPR;
modelStruct.d_modelPar_TMEXPR_dX=0.0;
modelStruct.modelPar_given_TMEXPR=mod.given("TMEXPR");
modelStruct.modelPar_PTWGT=mod.PTWGT;
modelStruct.d_modelPar_PTWGT_dX=0.0;
modelStruct.modelPar_given_PTWGT=mod.given("PTWGT");
modelStruct.modelPar_U0=mod.U0;
modelStruct.d_modelPar_U0_dX=0.0;
modelStruct.modelPar_given_U0=mod.given("U0");
modelStruct.modelPar_U0N1=mod.U0N1;
modelStruct.d_modelPar_U0N1_dX=0.0;
modelStruct.modelPar_given_U0N1=mod.given("U0N1");
modelStruct.modelPar_U0N2=mod.U0N2;
modelStruct.d_modelPar_U0N2_dX=0.0;
modelStruct.modelPar_given_U0N2=mod.given("U0N2");
modelStruct.modelPar_ETAMOB=mod.ETAMOB;
modelStruct.d_modelPar_ETAMOB_dX=0.0;
modelStruct.modelPar_given_ETAMOB=mod.given("ETAMOB");
modelStruct.modelPar_UP=mod.UP;
modelStruct.d_modelPar_UP_dX=0.0;
modelStruct.modelPar_given_UP=mod.given("UP");
modelStruct.modelPar_LPA=mod.LPA;
modelStruct.d_modelPar_LPA_dX=0.0;
modelStruct.modelPar_given_LPA=mod.given("LPA");
modelStruct.modelPar_UA=mod.UA;
modelStruct.d_modelPar_UA_dX=0.0;
modelStruct.modelPar_given_UA=mod.given("UA");
modelStruct.modelPar_AUA=mod.AUA;
modelStruct.d_modelPar_AUA_dX=0.0;
modelStruct.modelPar_given_AUA=mod.given("AUA");
modelStruct.modelPar_BUA=mod.BUA;
modelStruct.d_modelPar_BUA_dX=0.0;
modelStruct.modelPar_given_BUA=mod.given("BUA");
modelStruct.modelPar_UC=mod.UC;
modelStruct.d_modelPar_UC_dX=0.0;
modelStruct.modelPar_given_UC=mod.given("UC");
modelStruct.modelPar_EU=mod.EU;
modelStruct.d_modelPar_EU_dX=0.0;
modelStruct.modelPar_given_EU=mod.given("EU");
modelStruct.modelPar_AEU=mod.AEU;
modelStruct.d_modelPar_AEU_dX=0.0;
modelStruct.modelPar_given_AEU=mod.given("AEU");
modelStruct.modelPar_BEU=mod.BEU;
modelStruct.d_modelPar_BEU_dX=0.0;
modelStruct.modelPar_given_BEU=mod.given("BEU");
modelStruct.modelPar_UD=mod.UD;
modelStruct.d_modelPar_UD_dX=0.0;
modelStruct.modelPar_given_UD=mod.given("UD");
modelStruct.modelPar_AUD=mod.AUD;
modelStruct.d_modelPar_AUD_dX=0.0;
modelStruct.modelPar_given_AUD=mod.given("AUD");
modelStruct.modelPar_BUD=mod.BUD;
modelStruct.d_modelPar_BUD_dX=0.0;
modelStruct.modelPar_given_BUD=mod.given("BUD");
modelStruct.modelPar_UCS=mod.UCS;
modelStruct.d_modelPar_UCS_dX=0.0;
modelStruct.modelPar_given_UCS=mod.given("UCS");
modelStruct.modelPar_UTE=mod.UTE;
modelStruct.d_modelPar_UTE_dX=0.0;
modelStruct.modelPar_given_UTE=mod.given("UTE");
modelStruct.modelPar_UTL=mod.UTL;
modelStruct.d_modelPar_UTL_dX=0.0;
modelStruct.modelPar_given_UTL=mod.given("UTL");
modelStruct.modelPar_EMOBT=mod.EMOBT;
modelStruct.d_modelPar_EMOBT_dX=0.0;
modelStruct.modelPar_given_EMOBT=mod.given("EMOBT");
modelStruct.modelPar_UA1=mod.UA1;
modelStruct.d_modelPar_UA1_dX=0.0;
modelStruct.modelPar_given_UA1=mod.given("UA1");
modelStruct.modelPar_UC1=mod.UC1;
modelStruct.d_modelPar_UC1_dX=0.0;
modelStruct.modelPar_given_UC1=mod.given("UC1");
modelStruct.modelPar_UD1=mod.UD1;
modelStruct.d_modelPar_UD1_dX=0.0;
modelStruct.modelPar_given_UD1=mod.given("UD1");
modelStruct.modelPar_UCSTE=mod.UCSTE;
modelStruct.d_modelPar_UCSTE_dX=0.0;
modelStruct.modelPar_given_UCSTE=mod.given("UCSTE");
modelStruct.modelPar_CHARGEWF=mod.CHARGEWF;
modelStruct.d_modelPar_CHARGEWF_dX=0.0;
modelStruct.modelPar_given_CHARGEWF=mod.given("CHARGEWF");
modelStruct.modelPar_RDSWMIN=mod.RDSWMIN;
modelStruct.d_modelPar_RDSWMIN_dX=0.0;
modelStruct.modelPar_given_RDSWMIN=mod.given("RDSWMIN");
modelStruct.modelPar_RDSW=mod.RDSW;
modelStruct.d_modelPar_RDSW_dX=0.0;
modelStruct.modelPar_given_RDSW=mod.given("RDSW");
modelStruct.modelPar_ARDSW=mod.ARDSW;
modelStruct.d_modelPar_ARDSW_dX=0.0;
modelStruct.modelPar_given_ARDSW=mod.given("ARDSW");
modelStruct.modelPar_BRDSW=mod.BRDSW;
modelStruct.d_modelPar_BRDSW_dX=0.0;
modelStruct.modelPar_given_BRDSW=mod.given("BRDSW");
modelStruct.modelPar_RSWMIN=mod.RSWMIN;
modelStruct.d_modelPar_RSWMIN_dX=0.0;
modelStruct.modelPar_given_RSWMIN=mod.given("RSWMIN");
modelStruct.modelPar_RSW=mod.RSW;
modelStruct.d_modelPar_RSW_dX=0.0;
modelStruct.modelPar_given_RSW=mod.given("RSW");
modelStruct.modelPar_ARSW=mod.ARSW;
modelStruct.d_modelPar_ARSW_dX=0.0;
modelStruct.modelPar_given_ARSW=mod.given("ARSW");
modelStruct.modelPar_BRSW=mod.BRSW;
modelStruct.d_modelPar_BRSW_dX=0.0;
modelStruct.modelPar_given_BRSW=mod.given("BRSW");
modelStruct.modelPar_RDWMIN=mod.RDWMIN;
modelStruct.d_modelPar_RDWMIN_dX=0.0;
modelStruct.modelPar_given_RDWMIN=mod.given("RDWMIN");
modelStruct.modelPar_RDW=mod.RDW;
modelStruct.d_modelPar_RDW_dX=0.0;
modelStruct.modelPar_given_RDW=mod.given("RDW");
modelStruct.modelPar_ARDW=mod.ARDW;
modelStruct.d_modelPar_ARDW_dX=0.0;
modelStruct.modelPar_given_ARDW=mod.given("ARDW");
modelStruct.modelPar_BRDW=mod.BRDW;
modelStruct.d_modelPar_BRDW_dX=0.0;
modelStruct.modelPar_given_BRDW=mod.given("BRDW");
modelStruct.modelPar_RSDR=mod.RSDR;
modelStruct.d_modelPar_RSDR_dX=0.0;
modelStruct.modelPar_given_RSDR=mod.given("RSDR");
modelStruct.modelPar_RSDRR=mod.RSDRR;
modelStruct.d_modelPar_RSDRR_dX=0.0;
modelStruct.modelPar_given_RSDRR=mod.given("RSDRR");
modelStruct.modelPar_RDDR=mod.RDDR;
modelStruct.d_modelPar_RDDR_dX=0.0;
modelStruct.modelPar_given_RDDR=mod.given("RDDR");
modelStruct.modelPar_RDDRR=mod.RDDRR;
modelStruct.d_modelPar_RDDRR_dX=0.0;
modelStruct.modelPar_given_RDDRR=mod.given("RDDRR");
modelStruct.modelPar_PRSDR=mod.PRSDR;
modelStruct.d_modelPar_PRSDR_dX=0.0;
modelStruct.modelPar_given_PRSDR=mod.given("PRSDR");
modelStruct.modelPar_PRDDR=mod.PRDDR;
modelStruct.d_modelPar_PRDDR_dX=0.0;
modelStruct.modelPar_given_PRDDR=mod.given("PRDDR");
modelStruct.modelPar_PRWGS=mod.PRWGS;
modelStruct.d_modelPar_PRWGS_dX=0.0;
modelStruct.modelPar_given_PRWGS=mod.given("PRWGS");
modelStruct.modelPar_PRWGD=mod.PRWGD;
modelStruct.d_modelPar_PRWGD_dX=0.0;
modelStruct.modelPar_given_PRWGD=mod.given("PRWGD");
modelStruct.modelPar_WR=mod.WR;
modelStruct.d_modelPar_WR_dX=0.0;
modelStruct.modelPar_given_WR=mod.given("WR");
modelStruct.modelPar_PRT=mod.PRT;
modelStruct.d_modelPar_PRT_dX=0.0;
modelStruct.modelPar_given_PRT=mod.given("PRT");
modelStruct.modelPar_TRSDR=mod.TRSDR;
modelStruct.d_modelPar_TRSDR_dX=0.0;
modelStruct.modelPar_given_TRSDR=mod.given("TRSDR");
modelStruct.modelPar_TRDDR=mod.TRDDR;
modelStruct.d_modelPar_TRDDR_dX=0.0;
modelStruct.modelPar_given_TRDDR=mod.given("TRDDR");
modelStruct.modelPar_PDIBL1=mod.PDIBL1;
modelStruct.d_modelPar_PDIBL1_dX=0.0;
modelStruct.modelPar_given_PDIBL1=mod.given("PDIBL1");
modelStruct.modelPar_PDIBL1R=mod.PDIBL1R;
modelStruct.d_modelPar_PDIBL1R_dX=0.0;
modelStruct.modelPar_given_PDIBL1R=mod.given("PDIBL1R");
modelStruct.modelPar_PDIBL2=mod.PDIBL2;
modelStruct.d_modelPar_PDIBL2_dX=0.0;
modelStruct.modelPar_given_PDIBL2=mod.given("PDIBL2");
modelStruct.modelPar_DROUT=mod.DROUT;
modelStruct.d_modelPar_DROUT_dX=0.0;
modelStruct.modelPar_given_DROUT=mod.given("DROUT");
modelStruct.modelPar_PVAG=mod.PVAG;
modelStruct.d_modelPar_PVAG_dX=0.0;
modelStruct.modelPar_given_PVAG=mod.given("PVAG");
modelStruct.modelPar_PCLM=mod.PCLM;
modelStruct.d_modelPar_PCLM_dX=0.0;
modelStruct.modelPar_given_PCLM=mod.given("PCLM");
modelStruct.modelPar_APCLM=mod.APCLM;
modelStruct.d_modelPar_APCLM_dX=0.0;
modelStruct.modelPar_given_APCLM=mod.given("APCLM");
modelStruct.modelPar_BPCLM=mod.BPCLM;
modelStruct.d_modelPar_BPCLM_dX=0.0;
modelStruct.modelPar_given_BPCLM=mod.given("BPCLM");
modelStruct.modelPar_PCLMG=mod.PCLMG;
modelStruct.d_modelPar_PCLMG_dX=0.0;
modelStruct.modelPar_given_PCLMG=mod.given("PCLMG");
modelStruct.modelPar_PCLMCV=mod.PCLMCV;
modelStruct.d_modelPar_PCLMCV_dX=0.0;
modelStruct.modelPar_given_PCLMCV=mod.given("PCLMCV");
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modelStruct.modelPar_A11=mod.A11;
modelStruct.d_modelPar_A11_dX=0.0;
modelStruct.modelPar_given_A11=mod.given("A11");
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modelStruct.modelPar_A21=mod.A21;
modelStruct.d_modelPar_A21_dX=0.0;
modelStruct.modelPar_given_A21=mod.given("A21");
modelStruct.modelPar_RGEXT=mod.RGEXT;
modelStruct.d_modelPar_RGEXT_dX=0.0;
modelStruct.modelPar_given_RGEXT=mod.given("RGEXT");
modelStruct.modelPar_RGFIN=mod.RGFIN;
modelStruct.d_modelPar_RGFIN_dX=0.0;
modelStruct.modelPar_given_RGFIN=mod.given("RGFIN");
modelStruct.modelPar_RSHS=mod.RSHS;
modelStruct.d_modelPar_RSHS_dX=0.0;
modelStruct.modelPar_given_RSHS=mod.given("RSHS");
modelStruct.modelPar_RSHD=mod.RSHD;
modelStruct.d_modelPar_RSHD_dX=0.0;
modelStruct.modelPar_given_RSHD=mod.given("RSHD");
modelStruct.modelPar_HEPI=mod.HEPI;
modelStruct.d_modelPar_HEPI_dX=0.0;
modelStruct.modelPar_given_HEPI=mod.given("HEPI");
modelStruct.modelPar_TSILI=mod.TSILI;
modelStruct.d_modelPar_TSILI_dX=0.0;
modelStruct.modelPar_given_TSILI=mod.given("TSILI");
modelStruct.modelPar_RHOC=mod.RHOC;
modelStruct.d_modelPar_RHOC_dX=0.0;
modelStruct.modelPar_given_RHOC=mod.given("RHOC");
modelStruct.modelPar_RHORSD=mod.RHORSD;
modelStruct.d_modelPar_RHORSD_dX=0.0;
modelStruct.modelPar_given_RHORSD=mod.given("RHORSD");
modelStruct.modelPar_CRATIO=mod.CRATIO;
modelStruct.d_modelPar_CRATIO_dX=0.0;
modelStruct.modelPar_given_CRATIO=mod.given("CRATIO");
modelStruct.modelPar_DELTAPRSD=mod.DELTAPRSD;
modelStruct.d_modelPar_DELTAPRSD_dX=0.0;
modelStruct.modelPar_given_DELTAPRSD=mod.given("DELTAPRSD");
modelStruct.modelPar_LSP=mod.LSP;
modelStruct.d_modelPar_LSP_dX=0.0;
modelStruct.modelPar_given_LSP=mod.given("LSP");
modelStruct.modelPar_EPSRSP=mod.EPSRSP;
modelStruct.d_modelPar_EPSRSP_dX=0.0;
modelStruct.modelPar_given_EPSRSP=mod.given("EPSRSP");
modelStruct.modelPar_TGATE=mod.TGATE;
modelStruct.d_modelPar_TGATE_dX=0.0;
modelStruct.modelPar_given_TGATE=mod.given("TGATE");
modelStruct.modelPar_TMASK=mod.TMASK;
modelStruct.d_modelPar_TMASK_dX=0.0;
modelStruct.modelPar_given_TMASK=mod.given("TMASK");
modelStruct.modelPar_ASILIEND=mod.ASILIEND;
modelStruct.d_modelPar_ASILIEND_dX=0.0;
modelStruct.modelPar_given_ASILIEND=mod.given("ASILIEND");
modelStruct.modelPar_ARSDEND=mod.ARSDEND;
modelStruct.d_modelPar_ARSDEND_dX=0.0;
modelStruct.modelPar_given_ARSDEND=mod.given("ARSDEND");
modelStruct.modelPar_PRSDEND=mod.PRSDEND;
modelStruct.d_modelPar_PRSDEND_dX=0.0;
modelStruct.modelPar_given_PRSDEND=mod.given("PRSDEND");
modelStruct.modelPar_NSDE=mod.NSDE;
modelStruct.d_modelPar_NSDE_dX=0.0;
modelStruct.modelPar_given_NSDE=mod.given("NSDE");
modelStruct.modelPar_RGEOA=mod.RGEOA;
modelStruct.d_modelPar_RGEOA_dX=0.0;
modelStruct.modelPar_given_RGEOA=mod.given("RGEOA");
modelStruct.modelPar_RGEOB=mod.RGEOB;
modelStruct.d_modelPar_RGEOB_dX=0.0;
modelStruct.modelPar_given_RGEOB=mod.given("RGEOB");
modelStruct.modelPar_RGEOC=mod.RGEOC;
modelStruct.d_modelPar_RGEOC_dX=0.0;
modelStruct.modelPar_given_RGEOC=mod.given("RGEOC");
modelStruct.modelPar_RGEOD=mod.RGEOD;
modelStruct.d_modelPar_RGEOD_dX=0.0;
modelStruct.modelPar_given_RGEOD=mod.given("RGEOD");
modelStruct.modelPar_RGEOE=mod.RGEOE;
modelStruct.d_modelPar_RGEOE_dX=0.0;
modelStruct.modelPar_given_RGEOE=mod.given("RGEOE");
modelStruct.modelPar_CGEOA=mod.CGEOA;
modelStruct.d_modelPar_CGEOA_dX=0.0;
modelStruct.modelPar_given_CGEOA=mod.given("CGEOA");
modelStruct.modelPar_CGEOB=mod.CGEOB;
modelStruct.d_modelPar_CGEOB_dX=0.0;
modelStruct.modelPar_given_CGEOB=mod.given("CGEOB");
modelStruct.modelPar_CGEOC=mod.CGEOC;
modelStruct.d_modelPar_CGEOC_dX=0.0;
modelStruct.modelPar_given_CGEOC=mod.given("CGEOC");
modelStruct.modelPar_CGEOD=mod.CGEOD;
modelStruct.d_modelPar_CGEOD_dX=0.0;
modelStruct.modelPar_given_CGEOD=mod.given("CGEOD");
modelStruct.modelPar_CGEOE=mod.CGEOE;
modelStruct.d_modelPar_CGEOE_dX=0.0;
modelStruct.modelPar_given_CGEOE=mod.given("CGEOE");
modelStruct.modelPar_AIGBINV=mod.AIGBINV;
modelStruct.d_modelPar_AIGBINV_dX=0.0;
modelStruct.modelPar_given_AIGBINV=mod.given("AIGBINV");
modelStruct.modelPar_AIGBINV1=mod.AIGBINV1;
modelStruct.d_modelPar_AIGBINV1_dX=0.0;
modelStruct.modelPar_given_AIGBINV1=mod.given("AIGBINV1");
modelStruct.modelPar_BIGBINV=mod.BIGBINV;
modelStruct.d_modelPar_BIGBINV_dX=0.0;
modelStruct.modelPar_given_BIGBINV=mod.given("BIGBINV");
modelStruct.modelPar_CIGBINV=mod.CIGBINV;
modelStruct.d_modelPar_CIGBINV_dX=0.0;
modelStruct.modelPar_given_CIGBINV=mod.given("CIGBINV");
modelStruct.modelPar_EIGBINV=mod.EIGBINV;
modelStruct.d_modelPar_EIGBINV_dX=0.0;
modelStruct.modelPar_given_EIGBINV=mod.given("EIGBINV");
modelStruct.modelPar_NIGBINV=mod.NIGBINV;
modelStruct.d_modelPar_NIGBINV_dX=0.0;
modelStruct.modelPar_given_NIGBINV=mod.given("NIGBINV");
modelStruct.modelPar_AIGBACC=mod.AIGBACC;
modelStruct.d_modelPar_AIGBACC_dX=0.0;
modelStruct.modelPar_given_AIGBACC=mod.given("AIGBACC");
modelStruct.modelPar_AIGBACC1=mod.AIGBACC1;
modelStruct.d_modelPar_AIGBACC1_dX=0.0;
modelStruct.modelPar_given_AIGBACC1=mod.given("AIGBACC1");
modelStruct.modelPar_BIGBACC=mod.BIGBACC;
modelStruct.d_modelPar_BIGBACC_dX=0.0;
modelStruct.modelPar_given_BIGBACC=mod.given("BIGBACC");
modelStruct.modelPar_CIGBACC=mod.CIGBACC;
modelStruct.d_modelPar_CIGBACC_dX=0.0;
modelStruct.modelPar_given_CIGBACC=mod.given("CIGBACC");
modelStruct.modelPar_NIGBACC=mod.NIGBACC;
modelStruct.d_modelPar_NIGBACC_dX=0.0;
modelStruct.modelPar_given_NIGBACC=mod.given("NIGBACC");
modelStruct.modelPar_AIGC=mod.AIGC;
modelStruct.d_modelPar_AIGC_dX=0.0;
modelStruct.modelPar_given_AIGC=mod.given("AIGC");
modelStruct.modelPar_AIGC1=mod.AIGC1;
modelStruct.d_modelPar_AIGC1_dX=0.0;
modelStruct.modelPar_given_AIGC1=mod.given("AIGC1");
modelStruct.modelPar_BIGC=mod.BIGC;
modelStruct.d_modelPar_BIGC_dX=0.0;
modelStruct.modelPar_given_BIGC=mod.given("BIGC");
modelStruct.modelPar_CIGC=mod.CIGC;
modelStruct.d_modelPar_CIGC_dX=0.0;
modelStruct.modelPar_given_CIGC=mod.given("CIGC");
modelStruct.modelPar_PIGCD=mod.PIGCD;
modelStruct.d_modelPar_PIGCD_dX=0.0;
modelStruct.modelPar_given_PIGCD=mod.given("PIGCD");
modelStruct.modelPar_DLCIGS=mod.DLCIGS;
modelStruct.d_modelPar_DLCIGS_dX=0.0;
modelStruct.modelPar_given_DLCIGS=mod.given("DLCIGS");
modelStruct.modelPar_AIGS=mod.AIGS;
modelStruct.d_modelPar_AIGS_dX=0.0;
modelStruct.modelPar_given_AIGS=mod.given("AIGS");
modelStruct.modelPar_AIGS1=mod.AIGS1;
modelStruct.d_modelPar_AIGS1_dX=0.0;
modelStruct.modelPar_given_AIGS1=mod.given("AIGS1");
modelStruct.modelPar_BIGS=mod.BIGS;
modelStruct.d_modelPar_BIGS_dX=0.0;
modelStruct.modelPar_given_BIGS=mod.given("BIGS");
modelStruct.modelPar_CIGS=mod.CIGS;
modelStruct.d_modelPar_CIGS_dX=0.0;
modelStruct.modelPar_given_CIGS=mod.given("CIGS");
modelStruct.modelPar_DLCIGD=mod.DLCIGD;
modelStruct.d_modelPar_DLCIGD_dX=0.0;
modelStruct.modelPar_given_DLCIGD=mod.given("DLCIGD");
modelStruct.modelPar_AIGD=mod.AIGD;
modelStruct.d_modelPar_AIGD_dX=0.0;
modelStruct.modelPar_given_AIGD=mod.given("AIGD");
modelStruct.modelPar_AIGD1=mod.AIGD1;
modelStruct.d_modelPar_AIGD1_dX=0.0;
modelStruct.modelPar_given_AIGD1=mod.given("AIGD1");
modelStruct.modelPar_BIGD=mod.BIGD;
modelStruct.d_modelPar_BIGD_dX=0.0;
modelStruct.modelPar_given_BIGD=mod.given("BIGD");
modelStruct.modelPar_CIGD=mod.CIGD;
modelStruct.d_modelPar_CIGD_dX=0.0;
modelStruct.modelPar_given_CIGD=mod.given("CIGD");
modelStruct.modelPar_TOXREF=mod.TOXREF;
modelStruct.d_modelPar_TOXREF_dX=0.0;
modelStruct.modelPar_given_TOXREF=mod.given("TOXREF");
modelStruct.modelPar_TOXG=mod.TOXG;
modelStruct.d_modelPar_TOXG_dX=0.0;
modelStruct.modelPar_given_TOXG=mod.given("TOXG");
modelStruct.modelPar_NTOX=mod.NTOX;
modelStruct.d_modelPar_NTOX_dX=0.0;
modelStruct.modelPar_given_NTOX=mod.given("NTOX");
modelStruct.modelPar_POXEDGE=mod.POXEDGE;
modelStruct.d_modelPar_POXEDGE_dX=0.0;
modelStruct.modelPar_given_POXEDGE=mod.given("POXEDGE");
modelStruct.modelPar_AGISL=mod.AGISL;
modelStruct.d_modelPar_AGISL_dX=0.0;
modelStruct.modelPar_given_AGISL=mod.given("AGISL");
modelStruct.modelPar_BGISL=mod.BGISL;
modelStruct.d_modelPar_BGISL_dX=0.0;
modelStruct.modelPar_given_BGISL=mod.given("BGISL");
modelStruct.modelPar_CGISL=mod.CGISL;
modelStruct.d_modelPar_CGISL_dX=0.0;
modelStruct.modelPar_given_CGISL=mod.given("CGISL");
modelStruct.modelPar_EGISL=mod.EGISL;
modelStruct.d_modelPar_EGISL_dX=0.0;
modelStruct.modelPar_given_EGISL=mod.given("EGISL");
modelStruct.modelPar_PGISL=mod.PGISL;
modelStruct.d_modelPar_PGISL_dX=0.0;
modelStruct.modelPar_given_PGISL=mod.given("PGISL");
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modelStruct.modelPar_EGIDL=mod.EGIDL;
modelStruct.d_modelPar_EGIDL_dX=0.0;
modelStruct.modelPar_given_EGIDL=mod.given("EGIDL");
modelStruct.modelPar_PGIDL=mod.PGIDL;
modelStruct.d_modelPar_PGIDL_dX=0.0;
modelStruct.modelPar_given_PGIDL=mod.given("PGIDL");
modelStruct.modelPar_ALPHA0=mod.ALPHA0;
modelStruct.d_modelPar_ALPHA0_dX=0.0;
modelStruct.modelPar_given_ALPHA0=mod.given("ALPHA0");
modelStruct.modelPar_ALPHA01=mod.ALPHA01;
modelStruct.d_modelPar_ALPHA01_dX=0.0;
modelStruct.modelPar_given_ALPHA01=mod.given("ALPHA01");
modelStruct.modelPar_ALPHA1=mod.ALPHA1;
modelStruct.d_modelPar_ALPHA1_dX=0.0;
modelStruct.modelPar_given_ALPHA1=mod.given("ALPHA1");
modelStruct.modelPar_ALPHA11=mod.ALPHA11;
modelStruct.d_modelPar_ALPHA11_dX=0.0;
modelStruct.modelPar_given_ALPHA11=mod.given("ALPHA11");
modelStruct.modelPar_BETA0=mod.BETA0;
modelStruct.d_modelPar_BETA0_dX=0.0;
modelStruct.modelPar_given_BETA0=mod.given("BETA0");
modelStruct.modelPar_ALPHAII0=mod.ALPHAII0;
modelStruct.d_modelPar_ALPHAII0_dX=0.0;
modelStruct.modelPar_given_ALPHAII0=mod.given("ALPHAII0");
modelStruct.modelPar_ALPHAII01=mod.ALPHAII01;
modelStruct.d_modelPar_ALPHAII01_dX=0.0;
modelStruct.modelPar_given_ALPHAII01=mod.given("ALPHAII01");
modelStruct.modelPar_ALPHAII1=mod.ALPHAII1;
modelStruct.d_modelPar_ALPHAII1_dX=0.0;
modelStruct.modelPar_given_ALPHAII1=mod.given("ALPHAII1");
modelStruct.modelPar_ALPHAII11=mod.ALPHAII11;
modelStruct.d_modelPar_ALPHAII11_dX=0.0;
modelStruct.modelPar_given_ALPHAII11=mod.given("ALPHAII11");
modelStruct.modelPar_BETAII0=mod.BETAII0;
modelStruct.d_modelPar_BETAII0_dX=0.0;
modelStruct.modelPar_given_BETAII0=mod.given("BETAII0");
modelStruct.modelPar_BETAII1=mod.BETAII1;
modelStruct.d_modelPar_BETAII1_dX=0.0;
modelStruct.modelPar_given_BETAII1=mod.given("BETAII1");
modelStruct.modelPar_BETAII2=mod.BETAII2;
modelStruct.d_modelPar_BETAII2_dX=0.0;
modelStruct.modelPar_given_BETAII2=mod.given("BETAII2");
modelStruct.modelPar_ESATII=mod.ESATII;
modelStruct.d_modelPar_ESATII_dX=0.0;
modelStruct.modelPar_given_ESATII=mod.given("ESATII");
modelStruct.modelPar_LII=mod.LII;
modelStruct.d_modelPar_LII_dX=0.0;
modelStruct.modelPar_given_LII=mod.given("LII");
modelStruct.modelPar_SII0=mod.SII0;
modelStruct.d_modelPar_SII0_dX=0.0;
modelStruct.modelPar_given_SII0=mod.given("SII0");
modelStruct.modelPar_SII1=mod.SII1;
modelStruct.d_modelPar_SII1_dX=0.0;
modelStruct.modelPar_given_SII1=mod.given("SII1");
modelStruct.modelPar_SII2=mod.SII2;
modelStruct.d_modelPar_SII2_dX=0.0;
modelStruct.modelPar_given_SII2=mod.given("SII2");
modelStruct.modelPar_SIID=mod.SIID;
modelStruct.d_modelPar_SIID_dX=0.0;
modelStruct.modelPar_given_SIID=mod.given("SIID");
modelStruct.modelPar_EOTACC=mod.EOTACC;
modelStruct.d_modelPar_EOTACC_dX=0.0;
modelStruct.modelPar_given_EOTACC=mod.given("EOTACC");
modelStruct.modelPar_DELVFBACC=mod.DELVFBACC;
modelStruct.d_modelPar_DELVFBACC_dX=0.0;
modelStruct.modelPar_given_DELVFBACC=mod.given("DELVFBACC");
modelStruct.modelPar_CFS=mod.CFS;
modelStruct.d_modelPar_CFS_dX=0.0;
modelStruct.modelPar_given_CFS=mod.given("CFS");
modelStruct.modelPar_CFD=mod.CFD;
modelStruct.d_modelPar_CFD_dX=0.0;
modelStruct.modelPar_given_CFD=mod.given("CFD");
modelStruct.modelPar_CGSO=mod.CGSO;
modelStruct.d_modelPar_CGSO_dX=0.0;
modelStruct.modelPar_given_CGSO=mod.given("CGSO");
modelStruct.modelPar_CGDO=mod.CGDO;
modelStruct.d_modelPar_CGDO_dX=0.0;
modelStruct.modelPar_given_CGDO=mod.given("CGDO");
modelStruct.modelPar_CGSL=mod.CGSL;
modelStruct.d_modelPar_CGSL_dX=0.0;
modelStruct.modelPar_given_CGSL=mod.given("CGSL");
modelStruct.modelPar_CGDL=mod.CGDL;
modelStruct.d_modelPar_CGDL_dX=0.0;
modelStruct.modelPar_given_CGDL=mod.given("CGDL");
modelStruct.modelPar_CKAPPAS=mod.CKAPPAS;
modelStruct.d_modelPar_CKAPPAS_dX=0.0;
modelStruct.modelPar_given_CKAPPAS=mod.given("CKAPPAS");
modelStruct.modelPar_CKAPPAD=mod.CKAPPAD;
modelStruct.d_modelPar_CKAPPAD_dX=0.0;
modelStruct.modelPar_given_CKAPPAD=mod.given("CKAPPAD");
modelStruct.modelPar_CGBO=mod.CGBO;
modelStruct.d_modelPar_CGBO_dX=0.0;
modelStruct.modelPar_given_CGBO=mod.given("CGBO");
modelStruct.modelPar_CGBN=mod.CGBN;
modelStruct.d_modelPar_CGBN_dX=0.0;
modelStruct.modelPar_given_CGBN=mod.given("CGBN");
modelStruct.modelPar_CGBL=mod.CGBL;
modelStruct.d_modelPar_CGBL_dX=0.0;
modelStruct.modelPar_given_CGBL=mod.given("CGBL");
modelStruct.modelPar_CKAPPAB=mod.CKAPPAB;
modelStruct.d_modelPar_CKAPPAB_dX=0.0;
modelStruct.modelPar_given_CKAPPAB=mod.given("CKAPPAB");
modelStruct.modelPar_CSDESW=mod.CSDESW;
modelStruct.d_modelPar_CSDESW_dX=0.0;
modelStruct.modelPar_given_CSDESW=mod.given("CSDESW");
modelStruct.modelPar_CJS=mod.CJS;
modelStruct.d_modelPar_CJS_dX=0.0;
modelStruct.modelPar_given_CJS=mod.given("CJS");
modelStruct.modelPar_CJD=mod.CJD;
modelStruct.d_modelPar_CJD_dX=0.0;
modelStruct.modelPar_given_CJD=mod.given("CJD");
modelStruct.modelPar_CJSWS=mod.CJSWS;
modelStruct.d_modelPar_CJSWS_dX=0.0;
modelStruct.modelPar_given_CJSWS=mod.given("CJSWS");
modelStruct.modelPar_CJSWD=mod.CJSWD;
modelStruct.d_modelPar_CJSWD_dX=0.0;
modelStruct.modelPar_given_CJSWD=mod.given("CJSWD");
modelStruct.modelPar_CJSWGS=mod.CJSWGS;
modelStruct.d_modelPar_CJSWGS_dX=0.0;
modelStruct.modelPar_given_CJSWGS=mod.given("CJSWGS");
modelStruct.modelPar_CJSWGD=mod.CJSWGD;
modelStruct.d_modelPar_CJSWGD_dX=0.0;
modelStruct.modelPar_given_CJSWGD=mod.given("CJSWGD");
modelStruct.modelPar_PBS=mod.PBS;
modelStruct.d_modelPar_PBS_dX=0.0;
modelStruct.modelPar_given_PBS=mod.given("PBS");
modelStruct.modelPar_PBD=mod.PBD;
modelStruct.d_modelPar_PBD_dX=0.0;
modelStruct.modelPar_given_PBD=mod.given("PBD");
modelStruct.modelPar_PBSWS=mod.PBSWS;
modelStruct.d_modelPar_PBSWS_dX=0.0;
modelStruct.modelPar_given_PBSWS=mod.given("PBSWS");
modelStruct.modelPar_PBSWD=mod.PBSWD;
modelStruct.d_modelPar_PBSWD_dX=0.0;
modelStruct.modelPar_given_PBSWD=mod.given("PBSWD");
modelStruct.modelPar_PBSWGS=mod.PBSWGS;
modelStruct.d_modelPar_PBSWGS_dX=0.0;
modelStruct.modelPar_given_PBSWGS=mod.given("PBSWGS");
modelStruct.modelPar_PBSWGD=mod.PBSWGD;
modelStruct.d_modelPar_PBSWGD_dX=0.0;
modelStruct.modelPar_given_PBSWGD=mod.given("PBSWGD");
modelStruct.modelPar_MJS=mod.MJS;
modelStruct.d_modelPar_MJS_dX=0.0;
modelStruct.modelPar_given_MJS=mod.given("MJS");
modelStruct.modelPar_MJD=mod.MJD;
modelStruct.d_modelPar_MJD_dX=0.0;
modelStruct.modelPar_given_MJD=mod.given("MJD");
modelStruct.modelPar_MJSWS=mod.MJSWS;
modelStruct.d_modelPar_MJSWS_dX=0.0;
modelStruct.modelPar_given_MJSWS=mod.given("MJSWS");
modelStruct.modelPar_MJSWD=mod.MJSWD;
modelStruct.d_modelPar_MJSWD_dX=0.0;
modelStruct.modelPar_given_MJSWD=mod.given("MJSWD");
modelStruct.modelPar_MJSWGS=mod.MJSWGS;
modelStruct.d_modelPar_MJSWGS_dX=0.0;
modelStruct.modelPar_given_MJSWGS=mod.given("MJSWGS");
modelStruct.modelPar_MJSWGD=mod.MJSWGD;
modelStruct.d_modelPar_MJSWGD_dX=0.0;
modelStruct.modelPar_given_MJSWGD=mod.given("MJSWGD");
modelStruct.modelPar_SJS=mod.SJS;
modelStruct.d_modelPar_SJS_dX=0.0;
modelStruct.modelPar_given_SJS=mod.given("SJS");
modelStruct.modelPar_SJD=mod.SJD;
modelStruct.d_modelPar_SJD_dX=0.0;
modelStruct.modelPar_given_SJD=mod.given("SJD");
modelStruct.modelPar_SJSWS=mod.SJSWS;
modelStruct.d_modelPar_SJSWS_dX=0.0;
modelStruct.modelPar_given_SJSWS=mod.given("SJSWS");
modelStruct.modelPar_SJSWD=mod.SJSWD;
modelStruct.d_modelPar_SJSWD_dX=0.0;
modelStruct.modelPar_given_SJSWD=mod.given("SJSWD");
modelStruct.modelPar_SJSWGS=mod.SJSWGS;
modelStruct.d_modelPar_SJSWGS_dX=0.0;
modelStruct.modelPar_given_SJSWGS=mod.given("SJSWGS");
modelStruct.modelPar_SJSWGD=mod.SJSWGD;
modelStruct.d_modelPar_SJSWGD_dX=0.0;
modelStruct.modelPar_given_SJSWGD=mod.given("SJSWGD");
modelStruct.modelPar_MJS2=mod.MJS2;
modelStruct.d_modelPar_MJS2_dX=0.0;
modelStruct.modelPar_given_MJS2=mod.given("MJS2");
modelStruct.modelPar_MJD2=mod.MJD2;
modelStruct.d_modelPar_MJD2_dX=0.0;
modelStruct.modelPar_given_MJD2=mod.given("MJD2");
modelStruct.modelPar_MJSWS2=mod.MJSWS2;
modelStruct.d_modelPar_MJSWS2_dX=0.0;
modelStruct.modelPar_given_MJSWS2=mod.given("MJSWS2");
modelStruct.modelPar_MJSWD2=mod.MJSWD2;
modelStruct.d_modelPar_MJSWD2_dX=0.0;
modelStruct.modelPar_given_MJSWD2=mod.given("MJSWD2");
modelStruct.modelPar_MJSWGS2=mod.MJSWGS2;
modelStruct.d_modelPar_MJSWGS2_dX=0.0;
modelStruct.modelPar_given_MJSWGS2=mod.given("MJSWGS2");
modelStruct.modelPar_MJSWGD2=mod.MJSWGD2;
modelStruct.d_modelPar_MJSWGD2_dX=0.0;
modelStruct.modelPar_given_MJSWGD2=mod.given("MJSWGD2");
modelStruct.modelPar_JSS=mod.JSS;
modelStruct.d_modelPar_JSS_dX=0.0;
modelStruct.modelPar_given_JSS=mod.given("JSS");
modelStruct.modelPar_JSD=mod.JSD;
modelStruct.d_modelPar_JSD_dX=0.0;
modelStruct.modelPar_given_JSD=mod.given("JSD");
modelStruct.modelPar_JSWS=mod.JSWS;
modelStruct.d_modelPar_JSWS_dX=0.0;
modelStruct.modelPar_given_JSWS=mod.given("JSWS");
modelStruct.modelPar_JSWD=mod.JSWD;
modelStruct.d_modelPar_JSWD_dX=0.0;
modelStruct.modelPar_given_JSWD=mod.given("JSWD");
modelStruct.modelPar_JSWGS=mod.JSWGS;
modelStruct.d_modelPar_JSWGS_dX=0.0;
modelStruct.modelPar_given_JSWGS=mod.given("JSWGS");
modelStruct.modelPar_JSWGD=mod.JSWGD;
modelStruct.d_modelPar_JSWGD_dX=0.0;
modelStruct.modelPar_given_JSWGD=mod.given("JSWGD");
modelStruct.modelPar_NJS=mod.NJS;
modelStruct.d_modelPar_NJS_dX=0.0;
modelStruct.modelPar_given_NJS=mod.given("NJS");
modelStruct.modelPar_NJD=mod.NJD;
modelStruct.d_modelPar_NJD_dX=0.0;
modelStruct.modelPar_given_NJD=mod.given("NJD");
modelStruct.modelPar_IJTHSFWD=mod.IJTHSFWD;
modelStruct.d_modelPar_IJTHSFWD_dX=0.0;
modelStruct.modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
modelStruct.modelPar_IJTHDFWD=mod.IJTHDFWD;
modelStruct.d_modelPar_IJTHDFWD_dX=0.0;
modelStruct.modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
modelStruct.modelPar_IJTHSREV=mod.IJTHSREV;
modelStruct.d_modelPar_IJTHSREV_dX=0.0;
modelStruct.modelPar_given_IJTHSREV=mod.given("IJTHSREV");
modelStruct.modelPar_IJTHDREV=mod.IJTHDREV;
modelStruct.d_modelPar_IJTHDREV_dX=0.0;
modelStruct.modelPar_given_IJTHDREV=mod.given("IJTHDREV");
modelStruct.modelPar_BVS=mod.BVS;
modelStruct.d_modelPar_BVS_dX=0.0;
modelStruct.modelPar_given_BVS=mod.given("BVS");
modelStruct.modelPar_BVD=mod.BVD;
modelStruct.d_modelPar_BVD_dX=0.0;
modelStruct.modelPar_given_BVD=mod.given("BVD");
modelStruct.modelPar_XJBVS=mod.XJBVS;
modelStruct.d_modelPar_XJBVS_dX=0.0;
modelStruct.modelPar_given_XJBVS=mod.given("XJBVS");
modelStruct.modelPar_XJBVD=mod.XJBVD;
modelStruct.d_modelPar_XJBVD_dX=0.0;
modelStruct.modelPar_given_XJBVD=mod.given("XJBVD");
modelStruct.modelPar_JTSS=mod.JTSS;
modelStruct.d_modelPar_JTSS_dX=0.0;
modelStruct.modelPar_given_JTSS=mod.given("JTSS");
modelStruct.modelPar_JTSD=mod.JTSD;
modelStruct.d_modelPar_JTSD_dX=0.0;
modelStruct.modelPar_given_JTSD=mod.given("JTSD");
modelStruct.modelPar_JTSSWS=mod.JTSSWS;
modelStruct.d_modelPar_JTSSWS_dX=0.0;
modelStruct.modelPar_given_JTSSWS=mod.given("JTSSWS");
modelStruct.modelPar_JTSSWD=mod.JTSSWD;
modelStruct.d_modelPar_JTSSWD_dX=0.0;
modelStruct.modelPar_given_JTSSWD=mod.given("JTSSWD");
modelStruct.modelPar_JTSSWGS=mod.JTSSWGS;
modelStruct.d_modelPar_JTSSWGS_dX=0.0;
modelStruct.modelPar_given_JTSSWGS=mod.given("JTSSWGS");
modelStruct.modelPar_JTSSWGD=mod.JTSSWGD;
modelStruct.d_modelPar_JTSSWGD_dX=0.0;
modelStruct.modelPar_given_JTSSWGD=mod.given("JTSSWGD");
modelStruct.modelPar_JTWEFF=mod.JTWEFF;
modelStruct.d_modelPar_JTWEFF_dX=0.0;
modelStruct.modelPar_given_JTWEFF=mod.given("JTWEFF");
modelStruct.modelPar_NJTS=mod.NJTS;
modelStruct.d_modelPar_NJTS_dX=0.0;
modelStruct.modelPar_given_NJTS=mod.given("NJTS");
modelStruct.modelPar_NJTSD=mod.NJTSD;
modelStruct.d_modelPar_NJTSD_dX=0.0;
modelStruct.modelPar_given_NJTSD=mod.given("NJTSD");
modelStruct.modelPar_NJTSSW=mod.NJTSSW;
modelStruct.d_modelPar_NJTSSW_dX=0.0;
modelStruct.modelPar_given_NJTSSW=mod.given("NJTSSW");
modelStruct.modelPar_NJTSSWD=mod.NJTSSWD;
modelStruct.d_modelPar_NJTSSWD_dX=0.0;
modelStruct.modelPar_given_NJTSSWD=mod.given("NJTSSWD");
modelStruct.modelPar_NJTSSWG=mod.NJTSSWG;
modelStruct.d_modelPar_NJTSSWG_dX=0.0;
modelStruct.modelPar_given_NJTSSWG=mod.given("NJTSSWG");
modelStruct.modelPar_NJTSSWGD=mod.NJTSSWGD;
modelStruct.d_modelPar_NJTSSWGD_dX=0.0;
modelStruct.modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
modelStruct.modelPar_VTSS=mod.VTSS;
modelStruct.d_modelPar_VTSS_dX=0.0;
modelStruct.modelPar_given_VTSS=mod.given("VTSS");
modelStruct.modelPar_VTSD=mod.VTSD;
modelStruct.d_modelPar_VTSD_dX=0.0;
modelStruct.modelPar_given_VTSD=mod.given("VTSD");
modelStruct.modelPar_VTSSWS=mod.VTSSWS;
modelStruct.d_modelPar_VTSSWS_dX=0.0;
modelStruct.modelPar_given_VTSSWS=mod.given("VTSSWS");
modelStruct.modelPar_VTSSWD=mod.VTSSWD;
modelStruct.d_modelPar_VTSSWD_dX=0.0;
modelStruct.modelPar_given_VTSSWD=mod.given("VTSSWD");
modelStruct.modelPar_VTSSWGS=mod.VTSSWGS;
modelStruct.d_modelPar_VTSSWGS_dX=0.0;
modelStruct.modelPar_given_VTSSWGS=mod.given("VTSSWGS");
modelStruct.modelPar_VTSSWGD=mod.VTSSWGD;
modelStruct.d_modelPar_VTSSWGD_dX=0.0;
modelStruct.modelPar_given_VTSSWGD=mod.given("VTSSWGD");
modelStruct.modelPar_LINTIGEN=mod.LINTIGEN;
modelStruct.d_modelPar_LINTIGEN_dX=0.0;
modelStruct.modelPar_given_LINTIGEN=mod.given("LINTIGEN");
modelStruct.modelPar_NTGEN=mod.NTGEN;
modelStruct.d_modelPar_NTGEN_dX=0.0;
modelStruct.modelPar_given_NTGEN=mod.given("NTGEN");
modelStruct.modelPar_AIGEN=mod.AIGEN;
modelStruct.d_modelPar_AIGEN_dX=0.0;
modelStruct.modelPar_given_AIGEN=mod.given("AIGEN");
modelStruct.modelPar_BIGEN=mod.BIGEN;
modelStruct.d_modelPar_BIGEN_dX=0.0;
modelStruct.modelPar_given_BIGEN=mod.given("BIGEN");
modelStruct.modelPar_XRCRG1=mod.XRCRG1;
modelStruct.d_modelPar_XRCRG1_dX=0.0;
modelStruct.modelPar_given_XRCRG1=mod.given("XRCRG1");
modelStruct.modelPar_XRCRG2=mod.XRCRG2;
modelStruct.d_modelPar_XRCRG2_dX=0.0;
modelStruct.modelPar_given_XRCRG2=mod.given("XRCRG2");
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modelStruct.modelPar_EM=mod.EM;
modelStruct.d_modelPar_EM_dX=0.0;
modelStruct.modelPar_given_EM=mod.given("EM");
modelStruct.modelPar_NOIA=mod.NOIA;
modelStruct.d_modelPar_NOIA_dX=0.0;
modelStruct.modelPar_given_NOIA=mod.given("NOIA");
modelStruct.modelPar_NOIB=mod.NOIB;
modelStruct.d_modelPar_NOIB_dX=0.0;
modelStruct.modelPar_given_NOIB=mod.given("NOIB");
modelStruct.modelPar_NOIC=mod.NOIC;
modelStruct.d_modelPar_NOIC_dX=0.0;
modelStruct.modelPar_given_NOIC=mod.given("NOIC");
modelStruct.modelPar_NTNOI=mod.NTNOI;
modelStruct.d_modelPar_NTNOI_dX=0.0;
modelStruct.modelPar_given_NTNOI=mod.given("NTNOI");
modelStruct.modelPar_TNOM=mod.TNOM;
modelStruct.d_modelPar_TNOM_dX=0.0;
modelStruct.modelPar_given_TNOM=mod.given("TNOM");
modelStruct.modelPar_TBGASUB=mod.TBGASUB;
modelStruct.d_modelPar_TBGASUB_dX=0.0;
modelStruct.modelPar_given_TBGASUB=mod.given("TBGASUB");
modelStruct.modelPar_TBGBSUB=mod.TBGBSUB;
modelStruct.d_modelPar_TBGBSUB_dX=0.0;
modelStruct.modelPar_given_TBGBSUB=mod.given("TBGBSUB");
modelStruct.modelPar_KT1=mod.KT1;
modelStruct.d_modelPar_KT1_dX=0.0;
modelStruct.modelPar_given_KT1=mod.given("KT1");
modelStruct.modelPar_KT1L=mod.KT1L;
modelStruct.d_modelPar_KT1L_dX=0.0;
modelStruct.modelPar_given_KT1L=mod.given("KT1L");
modelStruct.modelPar_TSS=mod.TSS;
modelStruct.d_modelPar_TSS_dX=0.0;
modelStruct.modelPar_given_TSS=mod.given("TSS");
modelStruct.modelPar_IIT=mod.IIT;
modelStruct.d_modelPar_IIT_dX=0.0;
modelStruct.modelPar_given_IIT=mod.given("IIT");
modelStruct.modelPar_TII=mod.TII;
modelStruct.d_modelPar_TII_dX=0.0;
modelStruct.modelPar_given_TII=mod.given("TII");
modelStruct.modelPar_TGIDL=mod.TGIDL;
modelStruct.d_modelPar_TGIDL_dX=0.0;
modelStruct.modelPar_given_TGIDL=mod.given("TGIDL");
modelStruct.modelPar_IGT=mod.IGT;
modelStruct.d_modelPar_IGT_dX=0.0;
modelStruct.modelPar_given_IGT=mod.given("IGT");
modelStruct.modelPar_TCJ=mod.TCJ;
modelStruct.d_modelPar_TCJ_dX=0.0;
modelStruct.modelPar_given_TCJ=mod.given("TCJ");
modelStruct.modelPar_TCJSW=mod.TCJSW;
modelStruct.d_modelPar_TCJSW_dX=0.0;
modelStruct.modelPar_given_TCJSW=mod.given("TCJSW");
modelStruct.modelPar_TCJSWG=mod.TCJSWG;
modelStruct.d_modelPar_TCJSWG_dX=0.0;
modelStruct.modelPar_given_TCJSWG=mod.given("TCJSWG");
modelStruct.modelPar_TPB=mod.TPB;
modelStruct.d_modelPar_TPB_dX=0.0;
modelStruct.modelPar_given_TPB=mod.given("TPB");
modelStruct.modelPar_TPBSW=mod.TPBSW;
modelStruct.d_modelPar_TPBSW_dX=0.0;
modelStruct.modelPar_given_TPBSW=mod.given("TPBSW");
modelStruct.modelPar_TPBSWG=mod.TPBSWG;
modelStruct.d_modelPar_TPBSWG_dX=0.0;
modelStruct.modelPar_given_TPBSWG=mod.given("TPBSWG");
modelStruct.modelPar_XTIS=mod.XTIS;
modelStruct.d_modelPar_XTIS_dX=0.0;
modelStruct.modelPar_given_XTIS=mod.given("XTIS");
modelStruct.modelPar_XTID=mod.XTID;
modelStruct.d_modelPar_XTID_dX=0.0;
modelStruct.modelPar_given_XTID=mod.given("XTID");
modelStruct.modelPar_XTSS=mod.XTSS;
modelStruct.d_modelPar_XTSS_dX=0.0;
modelStruct.modelPar_given_XTSS=mod.given("XTSS");
modelStruct.modelPar_XTSD=mod.XTSD;
modelStruct.d_modelPar_XTSD_dX=0.0;
modelStruct.modelPar_given_XTSD=mod.given("XTSD");
modelStruct.modelPar_XTSSWS=mod.XTSSWS;
modelStruct.d_modelPar_XTSSWS_dX=0.0;
modelStruct.modelPar_given_XTSSWS=mod.given("XTSSWS");
modelStruct.modelPar_XTSSWD=mod.XTSSWD;
modelStruct.d_modelPar_XTSSWD_dX=0.0;
modelStruct.modelPar_given_XTSSWD=mod.given("XTSSWD");
modelStruct.modelPar_XTSSWGS=mod.XTSSWGS;
modelStruct.d_modelPar_XTSSWGS_dX=0.0;
modelStruct.modelPar_given_XTSSWGS=mod.given("XTSSWGS");
modelStruct.modelPar_XTSSWGD=mod.XTSSWGD;
modelStruct.d_modelPar_XTSSWGD_dX=0.0;
modelStruct.modelPar_given_XTSSWGD=mod.given("XTSSWGD");
modelStruct.modelPar_TNJTS=mod.TNJTS;
modelStruct.d_modelPar_TNJTS_dX=0.0;
modelStruct.modelPar_given_TNJTS=mod.given("TNJTS");
modelStruct.modelPar_TNJTSD=mod.TNJTSD;
modelStruct.d_modelPar_TNJTSD_dX=0.0;
modelStruct.modelPar_given_TNJTSD=mod.given("TNJTSD");
modelStruct.modelPar_TNJTSSW=mod.TNJTSSW;
modelStruct.d_modelPar_TNJTSSW_dX=0.0;
modelStruct.modelPar_given_TNJTSSW=mod.given("TNJTSSW");
modelStruct.modelPar_TNJTSSWD=mod.TNJTSSWD;
modelStruct.d_modelPar_TNJTSSWD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
modelStruct.modelPar_TNJTSSWG=mod.TNJTSSWG;
modelStruct.d_modelPar_TNJTSSWG_dX=0.0;
modelStruct.modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
modelStruct.modelPar_TNJTSSWGD=mod.TNJTSSWGD;
modelStruct.d_modelPar_TNJTSSWGD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
modelStruct.modelPar_RTH0=mod.RTH0;
modelStruct.d_modelPar_RTH0_dX=0.0;
modelStruct.modelPar_given_RTH0=mod.given("RTH0");
modelStruct.modelPar_CTH0=mod.CTH0;
modelStruct.d_modelPar_CTH0_dX=0.0;
modelStruct.modelPar_given_CTH0=mod.given("CTH0");
modelStruct.modelPar_WTH0=mod.WTH0;
modelStruct.d_modelPar_WTH0_dX=0.0;
modelStruct.modelPar_given_WTH0=mod.given("WTH0");
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modelStruct.modelPar_NFINMIN=mod.NFINMIN;
modelStruct.d_modelPar_NFINMIN_dX=0.0;
modelStruct.modelPar_given_NFINMIN=mod.given("NFINMIN");
modelStruct.modelPar_NFINMAX=mod.NFINMAX;
modelStruct.d_modelPar_NFINMAX_dX=0.0;
modelStruct.modelPar_given_NFINMAX=mod.given("NFINMAX");
modelStruct.modelPar_LNBODY=mod.LNBODY;
modelStruct.d_modelPar_LNBODY_dX=0.0;
modelStruct.modelPar_given_LNBODY=mod.given("LNBODY");
modelStruct.modelPar_NNBODY=mod.NNBODY;
modelStruct.d_modelPar_NNBODY_dX=0.0;
modelStruct.modelPar_given_NNBODY=mod.given("NNBODY");
modelStruct.modelPar_PNBODY=mod.PNBODY;
modelStruct.d_modelPar_PNBODY_dX=0.0;
modelStruct.modelPar_given_PNBODY=mod.given("PNBODY");
modelStruct.modelPar_LPHIG=mod.LPHIG;
modelStruct.d_modelPar_LPHIG_dX=0.0;
modelStruct.modelPar_given_LPHIG=mod.given("LPHIG");
modelStruct.modelPar_NPHIG=mod.NPHIG;
modelStruct.d_modelPar_NPHIG_dX=0.0;
modelStruct.modelPar_given_NPHIG=mod.given("NPHIG");
modelStruct.modelPar_PPHIG=mod.PPHIG;
modelStruct.d_modelPar_PPHIG_dX=0.0;
modelStruct.modelPar_given_PPHIG=mod.given("PPHIG");
modelStruct.modelPar_LNGATE=mod.LNGATE;
modelStruct.d_modelPar_LNGATE_dX=0.0;
modelStruct.modelPar_given_LNGATE=mod.given("LNGATE");
modelStruct.modelPar_NNGATE=mod.NNGATE;
modelStruct.d_modelPar_NNGATE_dX=0.0;
modelStruct.modelPar_given_NNGATE=mod.given("NNGATE");
modelStruct.modelPar_PNGATE=mod.PNGATE;
modelStruct.d_modelPar_PNGATE_dX=0.0;
modelStruct.modelPar_given_PNGATE=mod.given("PNGATE");
modelStruct.modelPar_LCIT=mod.LCIT;
modelStruct.d_modelPar_LCIT_dX=0.0;
modelStruct.modelPar_given_LCIT=mod.given("LCIT");
modelStruct.modelPar_NCIT=mod.NCIT;
modelStruct.d_modelPar_NCIT_dX=0.0;
modelStruct.modelPar_given_NCIT=mod.given("NCIT");
modelStruct.modelPar_PCIT=mod.PCIT;
modelStruct.d_modelPar_PCIT_dX=0.0;
modelStruct.modelPar_given_PCIT=mod.given("PCIT");
modelStruct.modelPar_LCDSC=mod.LCDSC;
modelStruct.d_modelPar_LCDSC_dX=0.0;
modelStruct.modelPar_given_LCDSC=mod.given("LCDSC");
modelStruct.modelPar_NCDSC=mod.NCDSC;
modelStruct.d_modelPar_NCDSC_dX=0.0;
modelStruct.modelPar_given_NCDSC=mod.given("NCDSC");
modelStruct.modelPar_PCDSC=mod.PCDSC;
modelStruct.d_modelPar_PCDSC_dX=0.0;
modelStruct.modelPar_given_PCDSC=mod.given("PCDSC");
modelStruct.modelPar_LCDSCD=mod.LCDSCD;
modelStruct.d_modelPar_LCDSCD_dX=0.0;
modelStruct.modelPar_given_LCDSCD=mod.given("LCDSCD");
modelStruct.modelPar_NCDSCD=mod.NCDSCD;
modelStruct.d_modelPar_NCDSCD_dX=0.0;
modelStruct.modelPar_given_NCDSCD=mod.given("NCDSCD");
modelStruct.modelPar_PCDSCD=mod.PCDSCD;
modelStruct.d_modelPar_PCDSCD_dX=0.0;
modelStruct.modelPar_given_PCDSCD=mod.given("PCDSCD");
modelStruct.modelPar_LCDSCDR=mod.LCDSCDR;
modelStruct.d_modelPar_LCDSCDR_dX=0.0;
modelStruct.modelPar_given_LCDSCDR=mod.given("LCDSCDR");
modelStruct.modelPar_NCDSCDR=mod.NCDSCDR;
modelStruct.d_modelPar_NCDSCDR_dX=0.0;
modelStruct.modelPar_given_NCDSCDR=mod.given("NCDSCDR");
modelStruct.modelPar_PCDSCDR=mod.PCDSCDR;
modelStruct.d_modelPar_PCDSCDR_dX=0.0;
modelStruct.modelPar_given_PCDSCDR=mod.given("PCDSCDR");
modelStruct.modelPar_LDVT0=mod.LDVT0;
modelStruct.d_modelPar_LDVT0_dX=0.0;
modelStruct.modelPar_given_LDVT0=mod.given("LDVT0");
modelStruct.modelPar_NDVT0=mod.NDVT0;
modelStruct.d_modelPar_NDVT0_dX=0.0;
modelStruct.modelPar_given_NDVT0=mod.given("NDVT0");
modelStruct.modelPar_PDVT0=mod.PDVT0;
modelStruct.d_modelPar_PDVT0_dX=0.0;
modelStruct.modelPar_given_PDVT0=mod.given("PDVT0");
modelStruct.modelPar_LDVT1=mod.LDVT1;
modelStruct.d_modelPar_LDVT1_dX=0.0;
modelStruct.modelPar_given_LDVT1=mod.given("LDVT1");
modelStruct.modelPar_NDVT1=mod.NDVT1;
modelStruct.d_modelPar_NDVT1_dX=0.0;
modelStruct.modelPar_given_NDVT1=mod.given("NDVT1");
modelStruct.modelPar_PDVT1=mod.PDVT1;
modelStruct.d_modelPar_PDVT1_dX=0.0;
modelStruct.modelPar_given_PDVT1=mod.given("PDVT1");
modelStruct.modelPar_LDVT1SS=mod.LDVT1SS;
modelStruct.d_modelPar_LDVT1SS_dX=0.0;
modelStruct.modelPar_given_LDVT1SS=mod.given("LDVT1SS");
modelStruct.modelPar_NDVT1SS=mod.NDVT1SS;
modelStruct.d_modelPar_NDVT1SS_dX=0.0;
modelStruct.modelPar_given_NDVT1SS=mod.given("NDVT1SS");
modelStruct.modelPar_PDVT1SS=mod.PDVT1SS;
modelStruct.d_modelPar_PDVT1SS_dX=0.0;
modelStruct.modelPar_given_PDVT1SS=mod.given("PDVT1SS");
modelStruct.modelPar_LPHIN=mod.LPHIN;
modelStruct.d_modelPar_LPHIN_dX=0.0;
modelStruct.modelPar_given_LPHIN=mod.given("LPHIN");
modelStruct.modelPar_NPHIN=mod.NPHIN;
modelStruct.d_modelPar_NPHIN_dX=0.0;
modelStruct.modelPar_given_NPHIN=mod.given("NPHIN");
modelStruct.modelPar_PPHIN=mod.PPHIN;
modelStruct.d_modelPar_PPHIN_dX=0.0;
modelStruct.modelPar_given_PPHIN=mod.given("PPHIN");
modelStruct.modelPar_LETA0=mod.LETA0;
modelStruct.d_modelPar_LETA0_dX=0.0;
modelStruct.modelPar_given_LETA0=mod.given("LETA0");
modelStruct.modelPar_NETA0=mod.NETA0;
modelStruct.d_modelPar_NETA0_dX=0.0;
modelStruct.modelPar_given_NETA0=mod.given("NETA0");
modelStruct.modelPar_PETA0=mod.PETA0;
modelStruct.d_modelPar_PETA0_dX=0.0;
modelStruct.modelPar_given_PETA0=mod.given("PETA0");
modelStruct.modelPar_LETA0R=mod.LETA0R;
modelStruct.d_modelPar_LETA0R_dX=0.0;
modelStruct.modelPar_given_LETA0R=mod.given("LETA0R");
modelStruct.modelPar_NETA0R=mod.NETA0R;
modelStruct.d_modelPar_NETA0R_dX=0.0;
modelStruct.modelPar_given_NETA0R=mod.given("NETA0R");
modelStruct.modelPar_PETA0R=mod.PETA0R;
modelStruct.d_modelPar_PETA0R_dX=0.0;
modelStruct.modelPar_given_PETA0R=mod.given("PETA0R");
modelStruct.modelPar_LDSUB=mod.LDSUB;
modelStruct.d_modelPar_LDSUB_dX=0.0;
modelStruct.modelPar_given_LDSUB=mod.given("LDSUB");
modelStruct.modelPar_NDSUB=mod.NDSUB;
modelStruct.d_modelPar_NDSUB_dX=0.0;
modelStruct.modelPar_given_NDSUB=mod.given("NDSUB");
modelStruct.modelPar_PDSUB=mod.PDSUB;
modelStruct.d_modelPar_PDSUB_dX=0.0;
modelStruct.modelPar_given_PDSUB=mod.given("PDSUB");
modelStruct.modelPar_LK1RSCE=mod.LK1RSCE;
modelStruct.d_modelPar_LK1RSCE_dX=0.0;
modelStruct.modelPar_given_LK1RSCE=mod.given("LK1RSCE");
modelStruct.modelPar_NK1RSCE=mod.NK1RSCE;
modelStruct.d_modelPar_NK1RSCE_dX=0.0;
modelStruct.modelPar_given_NK1RSCE=mod.given("NK1RSCE");
modelStruct.modelPar_PK1RSCE=mod.PK1RSCE;
modelStruct.d_modelPar_PK1RSCE_dX=0.0;
modelStruct.modelPar_given_PK1RSCE=mod.given("PK1RSCE");
modelStruct.modelPar_LLPE0=mod.LLPE0;
modelStruct.d_modelPar_LLPE0_dX=0.0;
modelStruct.modelPar_given_LLPE0=mod.given("LLPE0");
modelStruct.modelPar_NLPE0=mod.NLPE0;
modelStruct.d_modelPar_NLPE0_dX=0.0;
modelStruct.modelPar_given_NLPE0=mod.given("NLPE0");
modelStruct.modelPar_PLPE0=mod.PLPE0;
modelStruct.d_modelPar_PLPE0_dX=0.0;
modelStruct.modelPar_given_PLPE0=mod.given("PLPE0");
modelStruct.modelPar_LDVTSHIFT=mod.LDVTSHIFT;
modelStruct.d_modelPar_LDVTSHIFT_dX=0.0;
modelStruct.modelPar_given_LDVTSHIFT=mod.given("LDVTSHIFT");
modelStruct.modelPar_NDVTSHIFT=mod.NDVTSHIFT;
modelStruct.d_modelPar_NDVTSHIFT_dX=0.0;
modelStruct.modelPar_given_NDVTSHIFT=mod.given("NDVTSHIFT");
modelStruct.modelPar_PDVTSHIFT=mod.PDVTSHIFT;
modelStruct.d_modelPar_PDVTSHIFT_dX=0.0;
modelStruct.modelPar_given_PDVTSHIFT=mod.given("PDVTSHIFT");
modelStruct.modelPar_LPHIBE=mod.LPHIBE;
modelStruct.d_modelPar_LPHIBE_dX=0.0;
modelStruct.modelPar_given_LPHIBE=mod.given("LPHIBE");
modelStruct.modelPar_NPHIBE=mod.NPHIBE;
modelStruct.d_modelPar_NPHIBE_dX=0.0;
modelStruct.modelPar_given_NPHIBE=mod.given("NPHIBE");
modelStruct.modelPar_PPHIBE=mod.PPHIBE;
modelStruct.d_modelPar_PPHIBE_dX=0.0;
modelStruct.modelPar_given_PPHIBE=mod.given("PPHIBE");
modelStruct.modelPar_LK0=mod.LK0;
modelStruct.d_modelPar_LK0_dX=0.0;
modelStruct.modelPar_given_LK0=mod.given("LK0");
modelStruct.modelPar_NK0=mod.NK0;
modelStruct.d_modelPar_NK0_dX=0.0;
modelStruct.modelPar_given_NK0=mod.given("NK0");
modelStruct.modelPar_PK0=mod.PK0;
modelStruct.d_modelPar_PK0_dX=0.0;
modelStruct.modelPar_given_PK0=mod.given("PK0");
modelStruct.modelPar_LK01=mod.LK01;
modelStruct.d_modelPar_LK01_dX=0.0;
modelStruct.modelPar_given_LK01=mod.given("LK01");
modelStruct.modelPar_NK01=mod.NK01;
modelStruct.d_modelPar_NK01_dX=0.0;
modelStruct.modelPar_given_NK01=mod.given("NK01");
modelStruct.modelPar_PK01=mod.PK01;
modelStruct.d_modelPar_PK01_dX=0.0;
modelStruct.modelPar_given_PK01=mod.given("PK01");
modelStruct.modelPar_LK0SI=mod.LK0SI;
modelStruct.d_modelPar_LK0SI_dX=0.0;
modelStruct.modelPar_given_LK0SI=mod.given("LK0SI");
modelStruct.modelPar_NK0SI=mod.NK0SI;
modelStruct.d_modelPar_NK0SI_dX=0.0;
modelStruct.modelPar_given_NK0SI=mod.given("NK0SI");
modelStruct.modelPar_PK0SI=mod.PK0SI;
modelStruct.d_modelPar_PK0SI_dX=0.0;
modelStruct.modelPar_given_PK0SI=mod.given("PK0SI");
modelStruct.modelPar_LK0SI1=mod.LK0SI1;
modelStruct.d_modelPar_LK0SI1_dX=0.0;
modelStruct.modelPar_given_LK0SI1=mod.given("LK0SI1");
modelStruct.modelPar_NK0SI1=mod.NK0SI1;
modelStruct.d_modelPar_NK0SI1_dX=0.0;
modelStruct.modelPar_given_NK0SI1=mod.given("NK0SI1");
modelStruct.modelPar_PK0SI1=mod.PK0SI1;
modelStruct.d_modelPar_PK0SI1_dX=0.0;
modelStruct.modelPar_given_PK0SI1=mod.given("PK0SI1");
modelStruct.modelPar_LK1SI=mod.LK1SI;
modelStruct.d_modelPar_LK1SI_dX=0.0;
modelStruct.modelPar_given_LK1SI=mod.given("LK1SI");
modelStruct.modelPar_NK1SI=mod.NK1SI;
modelStruct.d_modelPar_NK1SI_dX=0.0;
modelStruct.modelPar_given_NK1SI=mod.given("NK1SI");
modelStruct.modelPar_PK1SI=mod.PK1SI;
modelStruct.d_modelPar_PK1SI_dX=0.0;
modelStruct.modelPar_given_PK1SI=mod.given("PK1SI");
modelStruct.modelPar_LK1SI1=mod.LK1SI1;
modelStruct.d_modelPar_LK1SI1_dX=0.0;
modelStruct.modelPar_given_LK1SI1=mod.given("LK1SI1");
modelStruct.modelPar_NK1SI1=mod.NK1SI1;
modelStruct.d_modelPar_NK1SI1_dX=0.0;
modelStruct.modelPar_given_NK1SI1=mod.given("NK1SI1");
modelStruct.modelPar_PK1SI1=mod.PK1SI1;
modelStruct.d_modelPar_PK1SI1_dX=0.0;
modelStruct.modelPar_given_PK1SI1=mod.given("PK1SI1");
modelStruct.modelPar_LK1=mod.LK1;
modelStruct.d_modelPar_LK1_dX=0.0;
modelStruct.modelPar_given_LK1=mod.given("LK1");
modelStruct.modelPar_NK1=mod.NK1;
modelStruct.d_modelPar_NK1_dX=0.0;
modelStruct.modelPar_given_NK1=mod.given("NK1");
modelStruct.modelPar_PK1=mod.PK1;
modelStruct.d_modelPar_PK1_dX=0.0;
modelStruct.modelPar_given_PK1=mod.given("PK1");
modelStruct.modelPar_LK11=mod.LK11;
modelStruct.d_modelPar_LK11_dX=0.0;
modelStruct.modelPar_given_LK11=mod.given("LK11");
modelStruct.modelPar_NK11=mod.NK11;
modelStruct.d_modelPar_NK11_dX=0.0;
modelStruct.modelPar_given_NK11=mod.given("NK11");
modelStruct.modelPar_PK11=mod.PK11;
modelStruct.d_modelPar_PK11_dX=0.0;
modelStruct.modelPar_given_PK11=mod.given("PK11");
modelStruct.modelPar_LK1SAT=mod.LK1SAT;
modelStruct.d_modelPar_LK1SAT_dX=0.0;
modelStruct.modelPar_given_LK1SAT=mod.given("LK1SAT");
modelStruct.modelPar_NK1SAT=mod.NK1SAT;
modelStruct.d_modelPar_NK1SAT_dX=0.0;
modelStruct.modelPar_given_NK1SAT=mod.given("NK1SAT");
modelStruct.modelPar_PK1SAT=mod.PK1SAT;
modelStruct.d_modelPar_PK1SAT_dX=0.0;
modelStruct.modelPar_given_PK1SAT=mod.given("PK1SAT");
modelStruct.modelPar_LK1SAT1=mod.LK1SAT1;
modelStruct.d_modelPar_LK1SAT1_dX=0.0;
modelStruct.modelPar_given_LK1SAT1=mod.given("LK1SAT1");
modelStruct.modelPar_NK1SAT1=mod.NK1SAT1;
modelStruct.d_modelPar_NK1SAT1_dX=0.0;
modelStruct.modelPar_given_NK1SAT1=mod.given("NK1SAT1");
modelStruct.modelPar_PK1SAT1=mod.PK1SAT1;
modelStruct.d_modelPar_PK1SAT1_dX=0.0;
modelStruct.modelPar_given_PK1SAT1=mod.given("PK1SAT1");
modelStruct.modelPar_LDVTB=mod.LDVTB;
modelStruct.d_modelPar_LDVTB_dX=0.0;
modelStruct.modelPar_given_LDVTB=mod.given("LDVTB");
modelStruct.modelPar_NDVTB=mod.NDVTB;
modelStruct.d_modelPar_NDVTB_dX=0.0;
modelStruct.modelPar_given_NDVTB=mod.given("NDVTB");
modelStruct.modelPar_PDVTB=mod.PDVTB;
modelStruct.d_modelPar_PDVTB_dX=0.0;
modelStruct.modelPar_given_PDVTB=mod.given("PDVTB");
modelStruct.modelPar_LLPEB=mod.LLPEB;
modelStruct.d_modelPar_LLPEB_dX=0.0;
modelStruct.modelPar_given_LLPEB=mod.given("LLPEB");
modelStruct.modelPar_NLPEB=mod.NLPEB;
modelStruct.d_modelPar_NLPEB_dX=0.0;
modelStruct.modelPar_given_NLPEB=mod.given("NLPEB");
modelStruct.modelPar_PLPEB=mod.PLPEB;
modelStruct.d_modelPar_PLPEB_dX=0.0;
modelStruct.modelPar_given_PLPEB=mod.given("PLPEB");
modelStruct.modelPar_LQMFACTOR=mod.LQMFACTOR;
modelStruct.d_modelPar_LQMFACTOR_dX=0.0;
modelStruct.modelPar_given_LQMFACTOR=mod.given("LQMFACTOR");
modelStruct.modelPar_NQMFACTOR=mod.NQMFACTOR;
modelStruct.d_modelPar_NQMFACTOR_dX=0.0;
modelStruct.modelPar_given_NQMFACTOR=mod.given("NQMFACTOR");
modelStruct.modelPar_PQMFACTOR=mod.PQMFACTOR;
modelStruct.d_modelPar_PQMFACTOR_dX=0.0;
modelStruct.modelPar_given_PQMFACTOR=mod.given("PQMFACTOR");
modelStruct.modelPar_LQMTCENIV=mod.LQMTCENIV;
modelStruct.d_modelPar_LQMTCENIV_dX=0.0;
modelStruct.modelPar_given_LQMTCENIV=mod.given("LQMTCENIV");
modelStruct.modelPar_NQMTCENIV=mod.NQMTCENIV;
modelStruct.d_modelPar_NQMTCENIV_dX=0.0;
modelStruct.modelPar_given_NQMTCENIV=mod.given("NQMTCENIV");
modelStruct.modelPar_PQMTCENIV=mod.PQMTCENIV;
modelStruct.d_modelPar_PQMTCENIV_dX=0.0;
modelStruct.modelPar_given_PQMTCENIV=mod.given("PQMTCENIV");
modelStruct.modelPar_LQMTCENCV=mod.LQMTCENCV;
modelStruct.d_modelPar_LQMTCENCV_dX=0.0;
modelStruct.modelPar_given_LQMTCENCV=mod.given("LQMTCENCV");
modelStruct.modelPar_NQMTCENCV=mod.NQMTCENCV;
modelStruct.d_modelPar_NQMTCENCV_dX=0.0;
modelStruct.modelPar_given_NQMTCENCV=mod.given("NQMTCENCV");
modelStruct.modelPar_PQMTCENCV=mod.PQMTCENCV;
modelStruct.d_modelPar_PQMTCENCV_dX=0.0;
modelStruct.modelPar_given_PQMTCENCV=mod.given("PQMTCENCV");
modelStruct.modelPar_LQMTCENCVA=mod.LQMTCENCVA;
modelStruct.d_modelPar_LQMTCENCVA_dX=0.0;
modelStruct.modelPar_given_LQMTCENCVA=mod.given("LQMTCENCVA");
modelStruct.modelPar_NQMTCENCVA=mod.NQMTCENCVA;
modelStruct.d_modelPar_NQMTCENCVA_dX=0.0;
modelStruct.modelPar_given_NQMTCENCVA=mod.given("NQMTCENCVA");
modelStruct.modelPar_PQMTCENCVA=mod.PQMTCENCVA;
modelStruct.d_modelPar_PQMTCENCVA_dX=0.0;
modelStruct.modelPar_given_PQMTCENCVA=mod.given("PQMTCENCVA");
modelStruct.modelPar_LVSAT=mod.LVSAT;
modelStruct.d_modelPar_LVSAT_dX=0.0;
modelStruct.modelPar_given_LVSAT=mod.given("LVSAT");
modelStruct.modelPar_NVSAT=mod.NVSAT;
modelStruct.d_modelPar_NVSAT_dX=0.0;
modelStruct.modelPar_given_NVSAT=mod.given("NVSAT");
modelStruct.modelPar_PVSAT=mod.PVSAT;
modelStruct.d_modelPar_PVSAT_dX=0.0;
modelStruct.modelPar_given_PVSAT=mod.given("PVSAT");
modelStruct.modelPar_LVSAT1=mod.LVSAT1;
modelStruct.d_modelPar_LVSAT1_dX=0.0;
modelStruct.modelPar_given_LVSAT1=mod.given("LVSAT1");
modelStruct.modelPar_NVSAT1=mod.NVSAT1;
modelStruct.d_modelPar_NVSAT1_dX=0.0;
modelStruct.modelPar_given_NVSAT1=mod.given("NVSAT1");
modelStruct.modelPar_PVSAT1=mod.PVSAT1;
modelStruct.d_modelPar_PVSAT1_dX=0.0;
modelStruct.modelPar_given_PVSAT1=mod.given("PVSAT1");
modelStruct.modelPar_LVSAT1R=mod.LVSAT1R;
modelStruct.d_modelPar_LVSAT1R_dX=0.0;
modelStruct.modelPar_given_LVSAT1R=mod.given("LVSAT1R");
modelStruct.modelPar_NVSAT1R=mod.NVSAT1R;
modelStruct.d_modelPar_NVSAT1R_dX=0.0;
modelStruct.modelPar_given_NVSAT1R=mod.given("NVSAT1R");
modelStruct.modelPar_PVSAT1R=mod.PVSAT1R;
modelStruct.d_modelPar_PVSAT1R_dX=0.0;
modelStruct.modelPar_given_PVSAT1R=mod.given("PVSAT1R");
modelStruct.modelPar_LPSAT=mod.LPSAT;
modelStruct.d_modelPar_LPSAT_dX=0.0;
modelStruct.modelPar_given_LPSAT=mod.given("LPSAT");
modelStruct.modelPar_NPSAT=mod.NPSAT;
modelStruct.d_modelPar_NPSAT_dX=0.0;
modelStruct.modelPar_given_NPSAT=mod.given("NPSAT");
modelStruct.modelPar_PPSAT=mod.PPSAT;
modelStruct.d_modelPar_PPSAT_dX=0.0;
modelStruct.modelPar_given_PPSAT=mod.given("PPSAT");
modelStruct.modelPar_LDELTAVSAT=mod.LDELTAVSAT;
modelStruct.d_modelPar_LDELTAVSAT_dX=0.0;
modelStruct.modelPar_given_LDELTAVSAT=mod.given("LDELTAVSAT");
modelStruct.modelPar_NDELTAVSAT=mod.NDELTAVSAT;
modelStruct.d_modelPar_NDELTAVSAT_dX=0.0;
modelStruct.modelPar_given_NDELTAVSAT=mod.given("NDELTAVSAT");
modelStruct.modelPar_PDELTAVSAT=mod.PDELTAVSAT;
modelStruct.d_modelPar_PDELTAVSAT_dX=0.0;
modelStruct.modelPar_given_PDELTAVSAT=mod.given("PDELTAVSAT");
modelStruct.modelPar_LKSATIV=mod.LKSATIV;
modelStruct.d_modelPar_LKSATIV_dX=0.0;
modelStruct.modelPar_given_LKSATIV=mod.given("LKSATIV");
modelStruct.modelPar_NKSATIV=mod.NKSATIV;
modelStruct.d_modelPar_NKSATIV_dX=0.0;
modelStruct.modelPar_given_NKSATIV=mod.given("NKSATIV");
modelStruct.modelPar_PKSATIV=mod.PKSATIV;
modelStruct.d_modelPar_PKSATIV_dX=0.0;
modelStruct.modelPar_given_PKSATIV=mod.given("PKSATIV");
modelStruct.modelPar_LVSATCV=mod.LVSATCV;
modelStruct.d_modelPar_LVSATCV_dX=0.0;
modelStruct.modelPar_given_LVSATCV=mod.given("LVSATCV");
modelStruct.modelPar_NVSATCV=mod.NVSATCV;
modelStruct.d_modelPar_NVSATCV_dX=0.0;
modelStruct.modelPar_given_NVSATCV=mod.given("NVSATCV");
modelStruct.modelPar_PVSATCV=mod.PVSATCV;
modelStruct.d_modelPar_PVSATCV_dX=0.0;
modelStruct.modelPar_given_PVSATCV=mod.given("PVSATCV");
modelStruct.modelPar_LPSATCV=mod.LPSATCV;
modelStruct.d_modelPar_LPSATCV_dX=0.0;
modelStruct.modelPar_given_LPSATCV=mod.given("LPSATCV");
modelStruct.modelPar_NPSATCV=mod.NPSATCV;
modelStruct.d_modelPar_NPSATCV_dX=0.0;
modelStruct.modelPar_given_NPSATCV=mod.given("NPSATCV");
modelStruct.modelPar_PPSATCV=mod.PPSATCV;
modelStruct.d_modelPar_PPSATCV_dX=0.0;
modelStruct.modelPar_given_PPSATCV=mod.given("PPSATCV");
modelStruct.modelPar_LDELTAVSATCV=mod.LDELTAVSATCV;
modelStruct.d_modelPar_LDELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_LDELTAVSATCV=mod.given("LDELTAVSATCV");
modelStruct.modelPar_NDELTAVSATCV=mod.NDELTAVSATCV;
modelStruct.d_modelPar_NDELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_NDELTAVSATCV=mod.given("NDELTAVSATCV");
modelStruct.modelPar_PDELTAVSATCV=mod.PDELTAVSATCV;
modelStruct.d_modelPar_PDELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_PDELTAVSATCV=mod.given("PDELTAVSATCV");
modelStruct.modelPar_LMEXP=mod.LMEXP;
modelStruct.d_modelPar_LMEXP_dX=0.0;
modelStruct.modelPar_given_LMEXP=mod.given("LMEXP");
modelStruct.modelPar_NMEXP=mod.NMEXP;
modelStruct.d_modelPar_NMEXP_dX=0.0;
modelStruct.modelPar_given_NMEXP=mod.given("NMEXP");
modelStruct.modelPar_PMEXP=mod.PMEXP;
modelStruct.d_modelPar_PMEXP_dX=0.0;
modelStruct.modelPar_given_PMEXP=mod.given("PMEXP");
modelStruct.modelPar_LMEXPR=mod.LMEXPR;
modelStruct.d_modelPar_LMEXPR_dX=0.0;
modelStruct.modelPar_given_LMEXPR=mod.given("LMEXPR");
modelStruct.modelPar_NMEXPR=mod.NMEXPR;
modelStruct.d_modelPar_NMEXPR_dX=0.0;
modelStruct.modelPar_given_NMEXPR=mod.given("NMEXPR");
modelStruct.modelPar_PMEXPR=mod.PMEXPR;
modelStruct.d_modelPar_PMEXPR_dX=0.0;
modelStruct.modelPar_given_PMEXPR=mod.given("PMEXPR");
modelStruct.modelPar_LPTWG=mod.LPTWG;
modelStruct.d_modelPar_LPTWG_dX=0.0;
modelStruct.modelPar_given_LPTWG=mod.given("LPTWG");
modelStruct.modelPar_NPTWG=mod.NPTWG;
modelStruct.d_modelPar_NPTWG_dX=0.0;
modelStruct.modelPar_given_NPTWG=mod.given("NPTWG");
modelStruct.modelPar_PPTWG=mod.PPTWG;
modelStruct.d_modelPar_PPTWG_dX=0.0;
modelStruct.modelPar_given_PPTWG=mod.given("PPTWG");
modelStruct.modelPar_LPTWGR=mod.LPTWGR;
modelStruct.d_modelPar_LPTWGR_dX=0.0;
modelStruct.modelPar_given_LPTWGR=mod.given("LPTWGR");
modelStruct.modelPar_NPTWGR=mod.NPTWGR;
modelStruct.d_modelPar_NPTWGR_dX=0.0;
modelStruct.modelPar_given_NPTWGR=mod.given("NPTWGR");
modelStruct.modelPar_PPTWGR=mod.PPTWGR;
modelStruct.d_modelPar_PPTWGR_dX=0.0;
modelStruct.modelPar_given_PPTWGR=mod.given("PPTWGR");
modelStruct.modelPar_LU0=mod.LU0;
modelStruct.d_modelPar_LU0_dX=0.0;
modelStruct.modelPar_given_LU0=mod.given("LU0");
modelStruct.modelPar_NU0=mod.NU0;
modelStruct.d_modelPar_NU0_dX=0.0;
modelStruct.modelPar_given_NU0=mod.given("NU0");
modelStruct.modelPar_PU0=mod.PU0;
modelStruct.d_modelPar_PU0_dX=0.0;
modelStruct.modelPar_given_PU0=mod.given("PU0");
modelStruct.modelPar_LETAMOB=mod.LETAMOB;
modelStruct.d_modelPar_LETAMOB_dX=0.0;
modelStruct.modelPar_given_LETAMOB=mod.given("LETAMOB");
modelStruct.modelPar_NETAMOB=mod.NETAMOB;
modelStruct.d_modelPar_NETAMOB_dX=0.0;
modelStruct.modelPar_given_NETAMOB=mod.given("NETAMOB");
modelStruct.modelPar_PETAMOB=mod.PETAMOB;
modelStruct.d_modelPar_PETAMOB_dX=0.0;
modelStruct.modelPar_given_PETAMOB=mod.given("PETAMOB");
modelStruct.modelPar_LUP=mod.LUP;
modelStruct.d_modelPar_LUP_dX=0.0;
modelStruct.modelPar_given_LUP=mod.given("LUP");
modelStruct.modelPar_NUP=mod.NUP;
modelStruct.d_modelPar_NUP_dX=0.0;
modelStruct.modelPar_given_NUP=mod.given("NUP");
modelStruct.modelPar_PUP=mod.PUP;
modelStruct.d_modelPar_PUP_dX=0.0;
modelStruct.modelPar_given_PUP=mod.given("PUP");
modelStruct.modelPar_LUA=mod.LUA;
modelStruct.d_modelPar_LUA_dX=0.0;
modelStruct.modelPar_given_LUA=mod.given("LUA");
modelStruct.modelPar_NUA=mod.NUA;
modelStruct.d_modelPar_NUA_dX=0.0;
modelStruct.modelPar_given_NUA=mod.given("NUA");
modelStruct.modelPar_PUA=mod.PUA;
modelStruct.d_modelPar_PUA_dX=0.0;
modelStruct.modelPar_given_PUA=mod.given("PUA");
modelStruct.modelPar_LUC=mod.LUC;
modelStruct.d_modelPar_LUC_dX=0.0;
modelStruct.modelPar_given_LUC=mod.given("LUC");
modelStruct.modelPar_NUC=mod.NUC;
modelStruct.d_modelPar_NUC_dX=0.0;
modelStruct.modelPar_given_NUC=mod.given("NUC");
modelStruct.modelPar_PUC=mod.PUC;
modelStruct.d_modelPar_PUC_dX=0.0;
modelStruct.modelPar_given_PUC=mod.given("PUC");
modelStruct.modelPar_LEU=mod.LEU;
modelStruct.d_modelPar_LEU_dX=0.0;
modelStruct.modelPar_given_LEU=mod.given("LEU");
modelStruct.modelPar_NEU=mod.NEU;
modelStruct.d_modelPar_NEU_dX=0.0;
modelStruct.modelPar_given_NEU=mod.given("NEU");
modelStruct.modelPar_PEU=mod.PEU;
modelStruct.d_modelPar_PEU_dX=0.0;
modelStruct.modelPar_given_PEU=mod.given("PEU");
modelStruct.modelPar_LUD=mod.LUD;
modelStruct.d_modelPar_LUD_dX=0.0;
modelStruct.modelPar_given_LUD=mod.given("LUD");
modelStruct.modelPar_NUD=mod.NUD;
modelStruct.d_modelPar_NUD_dX=0.0;
modelStruct.modelPar_given_NUD=mod.given("NUD");
modelStruct.modelPar_PUD=mod.PUD;
modelStruct.d_modelPar_PUD_dX=0.0;
modelStruct.modelPar_given_PUD=mod.given("PUD");
modelStruct.modelPar_LUCS=mod.LUCS;
modelStruct.d_modelPar_LUCS_dX=0.0;
modelStruct.modelPar_given_LUCS=mod.given("LUCS");
modelStruct.modelPar_NUCS=mod.NUCS;
modelStruct.d_modelPar_NUCS_dX=0.0;
modelStruct.modelPar_given_NUCS=mod.given("NUCS");
modelStruct.modelPar_PUCS=mod.PUCS;
modelStruct.d_modelPar_PUCS_dX=0.0;
modelStruct.modelPar_given_PUCS=mod.given("PUCS");
modelStruct.modelPar_LPCLM=mod.LPCLM;
modelStruct.d_modelPar_LPCLM_dX=0.0;
modelStruct.modelPar_given_LPCLM=mod.given("LPCLM");
modelStruct.modelPar_NPCLM=mod.NPCLM;
modelStruct.d_modelPar_NPCLM_dX=0.0;
modelStruct.modelPar_given_NPCLM=mod.given("NPCLM");
modelStruct.modelPar_PPCLM=mod.PPCLM;
modelStruct.d_modelPar_PPCLM_dX=0.0;
modelStruct.modelPar_given_PPCLM=mod.given("PPCLM");
modelStruct.modelPar_LPCLMG=mod.LPCLMG;
modelStruct.d_modelPar_LPCLMG_dX=0.0;
modelStruct.modelPar_given_LPCLMG=mod.given("LPCLMG");
modelStruct.modelPar_NPCLMG=mod.NPCLMG;
modelStruct.d_modelPar_NPCLMG_dX=0.0;
modelStruct.modelPar_given_NPCLMG=mod.given("NPCLMG");
modelStruct.modelPar_PPCLMG=mod.PPCLMG;
modelStruct.d_modelPar_PPCLMG_dX=0.0;
modelStruct.modelPar_given_PPCLMG=mod.given("PPCLMG");
modelStruct.modelPar_LPCLMCV=mod.LPCLMCV;
modelStruct.d_modelPar_LPCLMCV_dX=0.0;
modelStruct.modelPar_given_LPCLMCV=mod.given("LPCLMCV");
modelStruct.modelPar_NPCLMCV=mod.NPCLMCV;
modelStruct.d_modelPar_NPCLMCV_dX=0.0;
modelStruct.modelPar_given_NPCLMCV=mod.given("NPCLMCV");
modelStruct.modelPar_PPCLMCV=mod.PPCLMCV;
modelStruct.d_modelPar_PPCLMCV_dX=0.0;
modelStruct.modelPar_given_PPCLMCV=mod.given("PPCLMCV");
modelStruct.modelPar_LA1=mod.LA1;
modelStruct.d_modelPar_LA1_dX=0.0;
modelStruct.modelPar_given_LA1=mod.given("LA1");
modelStruct.modelPar_NA1=mod.NA1;
modelStruct.d_modelPar_NA1_dX=0.0;
modelStruct.modelPar_given_NA1=mod.given("NA1");
modelStruct.modelPar_PA1=mod.PA1;
modelStruct.d_modelPar_PA1_dX=0.0;
modelStruct.modelPar_given_PA1=mod.given("PA1");
modelStruct.modelPar_LA11=mod.LA11;
modelStruct.d_modelPar_LA11_dX=0.0;
modelStruct.modelPar_given_LA11=mod.given("LA11");
modelStruct.modelPar_NA11=mod.NA11;
modelStruct.d_modelPar_NA11_dX=0.0;
modelStruct.modelPar_given_NA11=mod.given("NA11");
modelStruct.modelPar_PA11=mod.PA11;
modelStruct.d_modelPar_PA11_dX=0.0;
modelStruct.modelPar_given_PA11=mod.given("PA11");
modelStruct.modelPar_LA2=mod.LA2;
modelStruct.d_modelPar_LA2_dX=0.0;
modelStruct.modelPar_given_LA2=mod.given("LA2");
modelStruct.modelPar_NA2=mod.NA2;
modelStruct.d_modelPar_NA2_dX=0.0;
modelStruct.modelPar_given_NA2=mod.given("NA2");
modelStruct.modelPar_PA2=mod.PA2;
modelStruct.d_modelPar_PA2_dX=0.0;
modelStruct.modelPar_given_PA2=mod.given("PA2");
modelStruct.modelPar_LA21=mod.LA21;
modelStruct.d_modelPar_LA21_dX=0.0;
modelStruct.modelPar_given_LA21=mod.given("LA21");
modelStruct.modelPar_NA21=mod.NA21;
modelStruct.d_modelPar_NA21_dX=0.0;
modelStruct.modelPar_given_NA21=mod.given("NA21");
modelStruct.modelPar_PA21=mod.PA21;
modelStruct.d_modelPar_PA21_dX=0.0;
modelStruct.modelPar_given_PA21=mod.given("PA21");
modelStruct.modelPar_LRDSW=mod.LRDSW;
modelStruct.d_modelPar_LRDSW_dX=0.0;
modelStruct.modelPar_given_LRDSW=mod.given("LRDSW");
modelStruct.modelPar_NRDSW=mod.NRDSW;
modelStruct.d_modelPar_NRDSW_dX=0.0;
modelStruct.modelPar_given_NRDSW=mod.given("NRDSW");
modelStruct.modelPar_PRDSW=mod.PRDSW;
modelStruct.d_modelPar_PRDSW_dX=0.0;
modelStruct.modelPar_given_PRDSW=mod.given("PRDSW");
modelStruct.modelPar_LRSW=mod.LRSW;
modelStruct.d_modelPar_LRSW_dX=0.0;
modelStruct.modelPar_given_LRSW=mod.given("LRSW");
modelStruct.modelPar_NRSW=mod.NRSW;
modelStruct.d_modelPar_NRSW_dX=0.0;
modelStruct.modelPar_given_NRSW=mod.given("NRSW");
modelStruct.modelPar_PRSW=mod.PRSW;
modelStruct.d_modelPar_PRSW_dX=0.0;
modelStruct.modelPar_given_PRSW=mod.given("PRSW");
modelStruct.modelPar_LRDW=mod.LRDW;
modelStruct.d_modelPar_LRDW_dX=0.0;
modelStruct.modelPar_given_LRDW=mod.given("LRDW");
modelStruct.modelPar_NRDW=mod.NRDW;
modelStruct.d_modelPar_NRDW_dX=0.0;
modelStruct.modelPar_given_NRDW=mod.given("NRDW");
modelStruct.modelPar_PRDW=mod.PRDW;
modelStruct.d_modelPar_PRDW_dX=0.0;
modelStruct.modelPar_given_PRDW=mod.given("PRDW");
modelStruct.modelPar_LPRWGS=mod.LPRWGS;
modelStruct.d_modelPar_LPRWGS_dX=0.0;
modelStruct.modelPar_given_LPRWGS=mod.given("LPRWGS");
modelStruct.modelPar_NPRWGS=mod.NPRWGS;
modelStruct.d_modelPar_NPRWGS_dX=0.0;
modelStruct.modelPar_given_NPRWGS=mod.given("NPRWGS");
modelStruct.modelPar_PPRWGS=mod.PPRWGS;
modelStruct.d_modelPar_PPRWGS_dX=0.0;
modelStruct.modelPar_given_PPRWGS=mod.given("PPRWGS");
modelStruct.modelPar_LPRWGD=mod.LPRWGD;
modelStruct.d_modelPar_LPRWGD_dX=0.0;
modelStruct.modelPar_given_LPRWGD=mod.given("LPRWGD");
modelStruct.modelPar_NPRWGD=mod.NPRWGD;
modelStruct.d_modelPar_NPRWGD_dX=0.0;
modelStruct.modelPar_given_NPRWGD=mod.given("NPRWGD");
modelStruct.modelPar_PPRWGD=mod.PPRWGD;
modelStruct.d_modelPar_PPRWGD_dX=0.0;
modelStruct.modelPar_given_PPRWGD=mod.given("PPRWGD");
modelStruct.modelPar_LWR=mod.LWR;
modelStruct.d_modelPar_LWR_dX=0.0;
modelStruct.modelPar_given_LWR=mod.given("LWR");
modelStruct.modelPar_NWR=mod.NWR;
modelStruct.d_modelPar_NWR_dX=0.0;
modelStruct.modelPar_given_NWR=mod.given("NWR");
modelStruct.modelPar_PWR=mod.PWR;
modelStruct.d_modelPar_PWR_dX=0.0;
modelStruct.modelPar_given_PWR=mod.given("PWR");
modelStruct.modelPar_LPDIBL1=mod.LPDIBL1;
modelStruct.d_modelPar_LPDIBL1_dX=0.0;
modelStruct.modelPar_given_LPDIBL1=mod.given("LPDIBL1");
modelStruct.modelPar_NPDIBL1=mod.NPDIBL1;
modelStruct.d_modelPar_NPDIBL1_dX=0.0;
modelStruct.modelPar_given_NPDIBL1=mod.given("NPDIBL1");
modelStruct.modelPar_PPDIBL1=mod.PPDIBL1;
modelStruct.d_modelPar_PPDIBL1_dX=0.0;
modelStruct.modelPar_given_PPDIBL1=mod.given("PPDIBL1");
modelStruct.modelPar_LPDIBL1R=mod.LPDIBL1R;
modelStruct.d_modelPar_LPDIBL1R_dX=0.0;
modelStruct.modelPar_given_LPDIBL1R=mod.given("LPDIBL1R");
modelStruct.modelPar_NPDIBL1R=mod.NPDIBL1R;
modelStruct.d_modelPar_NPDIBL1R_dX=0.0;
modelStruct.modelPar_given_NPDIBL1R=mod.given("NPDIBL1R");
modelStruct.modelPar_PPDIBL1R=mod.PPDIBL1R;
modelStruct.d_modelPar_PPDIBL1R_dX=0.0;
modelStruct.modelPar_given_PPDIBL1R=mod.given("PPDIBL1R");
modelStruct.modelPar_LPDIBL2=mod.LPDIBL2;
modelStruct.d_modelPar_LPDIBL2_dX=0.0;
modelStruct.modelPar_given_LPDIBL2=mod.given("LPDIBL2");
modelStruct.modelPar_NPDIBL2=mod.NPDIBL2;
modelStruct.d_modelPar_NPDIBL2_dX=0.0;
modelStruct.modelPar_given_NPDIBL2=mod.given("NPDIBL2");
modelStruct.modelPar_PPDIBL2=mod.PPDIBL2;
modelStruct.d_modelPar_PPDIBL2_dX=0.0;
modelStruct.modelPar_given_PPDIBL2=mod.given("PPDIBL2");
modelStruct.modelPar_LDROUT=mod.LDROUT;
modelStruct.d_modelPar_LDROUT_dX=0.0;
modelStruct.modelPar_given_LDROUT=mod.given("LDROUT");
modelStruct.modelPar_NDROUT=mod.NDROUT;
modelStruct.d_modelPar_NDROUT_dX=0.0;
modelStruct.modelPar_given_NDROUT=mod.given("NDROUT");
modelStruct.modelPar_PDROUT=mod.PDROUT;
modelStruct.d_modelPar_PDROUT_dX=0.0;
modelStruct.modelPar_given_PDROUT=mod.given("PDROUT");
modelStruct.modelPar_LPVAG=mod.LPVAG;
modelStruct.d_modelPar_LPVAG_dX=0.0;
modelStruct.modelPar_given_LPVAG=mod.given("LPVAG");
modelStruct.modelPar_NPVAG=mod.NPVAG;
modelStruct.d_modelPar_NPVAG_dX=0.0;
modelStruct.modelPar_given_NPVAG=mod.given("NPVAG");
modelStruct.modelPar_PPVAG=mod.PPVAG;
modelStruct.d_modelPar_PPVAG_dX=0.0;
modelStruct.modelPar_given_PPVAG=mod.given("PPVAG");
modelStruct.modelPar_LAIGBINV=mod.LAIGBINV;
modelStruct.d_modelPar_LAIGBINV_dX=0.0;
modelStruct.modelPar_given_LAIGBINV=mod.given("LAIGBINV");
modelStruct.modelPar_NAIGBINV=mod.NAIGBINV;
modelStruct.d_modelPar_NAIGBINV_dX=0.0;
modelStruct.modelPar_given_NAIGBINV=mod.given("NAIGBINV");
modelStruct.modelPar_PAIGBINV=mod.PAIGBINV;
modelStruct.d_modelPar_PAIGBINV_dX=0.0;
modelStruct.modelPar_given_PAIGBINV=mod.given("PAIGBINV");
modelStruct.modelPar_LAIGBINV1=mod.LAIGBINV1;
modelStruct.d_modelPar_LAIGBINV1_dX=0.0;
modelStruct.modelPar_given_LAIGBINV1=mod.given("LAIGBINV1");
modelStruct.modelPar_NAIGBINV1=mod.NAIGBINV1;
modelStruct.d_modelPar_NAIGBINV1_dX=0.0;
modelStruct.modelPar_given_NAIGBINV1=mod.given("NAIGBINV1");
modelStruct.modelPar_PAIGBINV1=mod.PAIGBINV1;
modelStruct.d_modelPar_PAIGBINV1_dX=0.0;
modelStruct.modelPar_given_PAIGBINV1=mod.given("PAIGBINV1");
modelStruct.modelPar_LBIGBINV=mod.LBIGBINV;
modelStruct.d_modelPar_LBIGBINV_dX=0.0;
modelStruct.modelPar_given_LBIGBINV=mod.given("LBIGBINV");
modelStruct.modelPar_NBIGBINV=mod.NBIGBINV;
modelStruct.d_modelPar_NBIGBINV_dX=0.0;
modelStruct.modelPar_given_NBIGBINV=mod.given("NBIGBINV");
modelStruct.modelPar_PBIGBINV=mod.PBIGBINV;
modelStruct.d_modelPar_PBIGBINV_dX=0.0;
modelStruct.modelPar_given_PBIGBINV=mod.given("PBIGBINV");
modelStruct.modelPar_LCIGBINV=mod.LCIGBINV;
modelStruct.d_modelPar_LCIGBINV_dX=0.0;
modelStruct.modelPar_given_LCIGBINV=mod.given("LCIGBINV");
modelStruct.modelPar_NCIGBINV=mod.NCIGBINV;
modelStruct.d_modelPar_NCIGBINV_dX=0.0;
modelStruct.modelPar_given_NCIGBINV=mod.given("NCIGBINV");
modelStruct.modelPar_PCIGBINV=mod.PCIGBINV;
modelStruct.d_modelPar_PCIGBINV_dX=0.0;
modelStruct.modelPar_given_PCIGBINV=mod.given("PCIGBINV");
modelStruct.modelPar_LEIGBINV=mod.LEIGBINV;
modelStruct.d_modelPar_LEIGBINV_dX=0.0;
modelStruct.modelPar_given_LEIGBINV=mod.given("LEIGBINV");
modelStruct.modelPar_NEIGBINV=mod.NEIGBINV;
modelStruct.d_modelPar_NEIGBINV_dX=0.0;
modelStruct.modelPar_given_NEIGBINV=mod.given("NEIGBINV");
modelStruct.modelPar_PEIGBINV=mod.PEIGBINV;
modelStruct.d_modelPar_PEIGBINV_dX=0.0;
modelStruct.modelPar_given_PEIGBINV=mod.given("PEIGBINV");
modelStruct.modelPar_LNIGBINV=mod.LNIGBINV;
modelStruct.d_modelPar_LNIGBINV_dX=0.0;
modelStruct.modelPar_given_LNIGBINV=mod.given("LNIGBINV");
modelStruct.modelPar_NNIGBINV=mod.NNIGBINV;
modelStruct.d_modelPar_NNIGBINV_dX=0.0;
modelStruct.modelPar_given_NNIGBINV=mod.given("NNIGBINV");
modelStruct.modelPar_PNIGBINV=mod.PNIGBINV;
modelStruct.d_modelPar_PNIGBINV_dX=0.0;
modelStruct.modelPar_given_PNIGBINV=mod.given("PNIGBINV");
modelStruct.modelPar_LAIGBACC=mod.LAIGBACC;
modelStruct.d_modelPar_LAIGBACC_dX=0.0;
modelStruct.modelPar_given_LAIGBACC=mod.given("LAIGBACC");
modelStruct.modelPar_NAIGBACC=mod.NAIGBACC;
modelStruct.d_modelPar_NAIGBACC_dX=0.0;
modelStruct.modelPar_given_NAIGBACC=mod.given("NAIGBACC");
modelStruct.modelPar_PAIGBACC=mod.PAIGBACC;
modelStruct.d_modelPar_PAIGBACC_dX=0.0;
modelStruct.modelPar_given_PAIGBACC=mod.given("PAIGBACC");
modelStruct.modelPar_LAIGBACC1=mod.LAIGBACC1;
modelStruct.d_modelPar_LAIGBACC1_dX=0.0;
modelStruct.modelPar_given_LAIGBACC1=mod.given("LAIGBACC1");
modelStruct.modelPar_NAIGBACC1=mod.NAIGBACC1;
modelStruct.d_modelPar_NAIGBACC1_dX=0.0;
modelStruct.modelPar_given_NAIGBACC1=mod.given("NAIGBACC1");
modelStruct.modelPar_PAIGBACC1=mod.PAIGBACC1;
modelStruct.d_modelPar_PAIGBACC1_dX=0.0;
modelStruct.modelPar_given_PAIGBACC1=mod.given("PAIGBACC1");
modelStruct.modelPar_LBIGBACC=mod.LBIGBACC;
modelStruct.d_modelPar_LBIGBACC_dX=0.0;
modelStruct.modelPar_given_LBIGBACC=mod.given("LBIGBACC");
modelStruct.modelPar_NBIGBACC=mod.NBIGBACC;
modelStruct.d_modelPar_NBIGBACC_dX=0.0;
modelStruct.modelPar_given_NBIGBACC=mod.given("NBIGBACC");
modelStruct.modelPar_PBIGBACC=mod.PBIGBACC;
modelStruct.d_modelPar_PBIGBACC_dX=0.0;
modelStruct.modelPar_given_PBIGBACC=mod.given("PBIGBACC");
modelStruct.modelPar_LCIGBACC=mod.LCIGBACC;
modelStruct.d_modelPar_LCIGBACC_dX=0.0;
modelStruct.modelPar_given_LCIGBACC=mod.given("LCIGBACC");
modelStruct.modelPar_NCIGBACC=mod.NCIGBACC;
modelStruct.d_modelPar_NCIGBACC_dX=0.0;
modelStruct.modelPar_given_NCIGBACC=mod.given("NCIGBACC");
modelStruct.modelPar_PCIGBACC=mod.PCIGBACC;
modelStruct.d_modelPar_PCIGBACC_dX=0.0;
modelStruct.modelPar_given_PCIGBACC=mod.given("PCIGBACC");
modelStruct.modelPar_LNIGBACC=mod.LNIGBACC;
modelStruct.d_modelPar_LNIGBACC_dX=0.0;
modelStruct.modelPar_given_LNIGBACC=mod.given("LNIGBACC");
modelStruct.modelPar_NNIGBACC=mod.NNIGBACC;
modelStruct.d_modelPar_NNIGBACC_dX=0.0;
modelStruct.modelPar_given_NNIGBACC=mod.given("NNIGBACC");
modelStruct.modelPar_PNIGBACC=mod.PNIGBACC;
modelStruct.d_modelPar_PNIGBACC_dX=0.0;
modelStruct.modelPar_given_PNIGBACC=mod.given("PNIGBACC");
modelStruct.modelPar_LAIGC=mod.LAIGC;
modelStruct.d_modelPar_LAIGC_dX=0.0;
modelStruct.modelPar_given_LAIGC=mod.given("LAIGC");
modelStruct.modelPar_NAIGC=mod.NAIGC;
modelStruct.d_modelPar_NAIGC_dX=0.0;
modelStruct.modelPar_given_NAIGC=mod.given("NAIGC");
modelStruct.modelPar_PAIGC=mod.PAIGC;
modelStruct.d_modelPar_PAIGC_dX=0.0;
modelStruct.modelPar_given_PAIGC=mod.given("PAIGC");
modelStruct.modelPar_LAIGC1=mod.LAIGC1;
modelStruct.d_modelPar_LAIGC1_dX=0.0;
modelStruct.modelPar_given_LAIGC1=mod.given("LAIGC1");
modelStruct.modelPar_NAIGC1=mod.NAIGC1;
modelStruct.d_modelPar_NAIGC1_dX=0.0;
modelStruct.modelPar_given_NAIGC1=mod.given("NAIGC1");
modelStruct.modelPar_PAIGC1=mod.PAIGC1;
modelStruct.d_modelPar_PAIGC1_dX=0.0;
modelStruct.modelPar_given_PAIGC1=mod.given("PAIGC1");
modelStruct.modelPar_LBIGC=mod.LBIGC;
modelStruct.d_modelPar_LBIGC_dX=0.0;
modelStruct.modelPar_given_LBIGC=mod.given("LBIGC");
modelStruct.modelPar_NBIGC=mod.NBIGC;
modelStruct.d_modelPar_NBIGC_dX=0.0;
modelStruct.modelPar_given_NBIGC=mod.given("NBIGC");
modelStruct.modelPar_PBIGC=mod.PBIGC;
modelStruct.d_modelPar_PBIGC_dX=0.0;
modelStruct.modelPar_given_PBIGC=mod.given("PBIGC");
modelStruct.modelPar_LCIGC=mod.LCIGC;
modelStruct.d_modelPar_LCIGC_dX=0.0;
modelStruct.modelPar_given_LCIGC=mod.given("LCIGC");
modelStruct.modelPar_NCIGC=mod.NCIGC;
modelStruct.d_modelPar_NCIGC_dX=0.0;
modelStruct.modelPar_given_NCIGC=mod.given("NCIGC");
modelStruct.modelPar_PCIGC=mod.PCIGC;
modelStruct.d_modelPar_PCIGC_dX=0.0;
modelStruct.modelPar_given_PCIGC=mod.given("PCIGC");
modelStruct.modelPar_LPIGCD=mod.LPIGCD;
modelStruct.d_modelPar_LPIGCD_dX=0.0;
modelStruct.modelPar_given_LPIGCD=mod.given("LPIGCD");
modelStruct.modelPar_NPIGCD=mod.NPIGCD;
modelStruct.d_modelPar_NPIGCD_dX=0.0;
modelStruct.modelPar_given_NPIGCD=mod.given("NPIGCD");
modelStruct.modelPar_PPIGCD=mod.PPIGCD;
modelStruct.d_modelPar_PPIGCD_dX=0.0;
modelStruct.modelPar_given_PPIGCD=mod.given("PPIGCD");
modelStruct.modelPar_LAIGS=mod.LAIGS;
modelStruct.d_modelPar_LAIGS_dX=0.0;
modelStruct.modelPar_given_LAIGS=mod.given("LAIGS");
modelStruct.modelPar_NAIGS=mod.NAIGS;
modelStruct.d_modelPar_NAIGS_dX=0.0;
modelStruct.modelPar_given_NAIGS=mod.given("NAIGS");
modelStruct.modelPar_PAIGS=mod.PAIGS;
modelStruct.d_modelPar_PAIGS_dX=0.0;
modelStruct.modelPar_given_PAIGS=mod.given("PAIGS");
modelStruct.modelPar_LAIGS1=mod.LAIGS1;
modelStruct.d_modelPar_LAIGS1_dX=0.0;
modelStruct.modelPar_given_LAIGS1=mod.given("LAIGS1");
modelStruct.modelPar_NAIGS1=mod.NAIGS1;
modelStruct.d_modelPar_NAIGS1_dX=0.0;
modelStruct.modelPar_given_NAIGS1=mod.given("NAIGS1");
modelStruct.modelPar_PAIGS1=mod.PAIGS1;
modelStruct.d_modelPar_PAIGS1_dX=0.0;
modelStruct.modelPar_given_PAIGS1=mod.given("PAIGS1");
modelStruct.modelPar_LBIGS=mod.LBIGS;
modelStruct.d_modelPar_LBIGS_dX=0.0;
modelStruct.modelPar_given_LBIGS=mod.given("LBIGS");
modelStruct.modelPar_NBIGS=mod.NBIGS;
modelStruct.d_modelPar_NBIGS_dX=0.0;
modelStruct.modelPar_given_NBIGS=mod.given("NBIGS");
modelStruct.modelPar_PBIGS=mod.PBIGS;
modelStruct.d_modelPar_PBIGS_dX=0.0;
modelStruct.modelPar_given_PBIGS=mod.given("PBIGS");
modelStruct.modelPar_LCIGS=mod.LCIGS;
modelStruct.d_modelPar_LCIGS_dX=0.0;
modelStruct.modelPar_given_LCIGS=mod.given("LCIGS");
modelStruct.modelPar_NCIGS=mod.NCIGS;
modelStruct.d_modelPar_NCIGS_dX=0.0;
modelStruct.modelPar_given_NCIGS=mod.given("NCIGS");
modelStruct.modelPar_PCIGS=mod.PCIGS;
modelStruct.d_modelPar_PCIGS_dX=0.0;
modelStruct.modelPar_given_PCIGS=mod.given("PCIGS");
modelStruct.modelPar_LAIGD=mod.LAIGD;
modelStruct.d_modelPar_LAIGD_dX=0.0;
modelStruct.modelPar_given_LAIGD=mod.given("LAIGD");
modelStruct.modelPar_NAIGD=mod.NAIGD;
modelStruct.d_modelPar_NAIGD_dX=0.0;
modelStruct.modelPar_given_NAIGD=mod.given("NAIGD");
modelStruct.modelPar_PAIGD=mod.PAIGD;
modelStruct.d_modelPar_PAIGD_dX=0.0;
modelStruct.modelPar_given_PAIGD=mod.given("PAIGD");
modelStruct.modelPar_LAIGD1=mod.LAIGD1;
modelStruct.d_modelPar_LAIGD1_dX=0.0;
modelStruct.modelPar_given_LAIGD1=mod.given("LAIGD1");
modelStruct.modelPar_NAIGD1=mod.NAIGD1;
modelStruct.d_modelPar_NAIGD1_dX=0.0;
modelStruct.modelPar_given_NAIGD1=mod.given("NAIGD1");
modelStruct.modelPar_PAIGD1=mod.PAIGD1;
modelStruct.d_modelPar_PAIGD1_dX=0.0;
modelStruct.modelPar_given_PAIGD1=mod.given("PAIGD1");
modelStruct.modelPar_LBIGD=mod.LBIGD;
modelStruct.d_modelPar_LBIGD_dX=0.0;
modelStruct.modelPar_given_LBIGD=mod.given("LBIGD");
modelStruct.modelPar_NBIGD=mod.NBIGD;
modelStruct.d_modelPar_NBIGD_dX=0.0;
modelStruct.modelPar_given_NBIGD=mod.given("NBIGD");
modelStruct.modelPar_PBIGD=mod.PBIGD;
modelStruct.d_modelPar_PBIGD_dX=0.0;
modelStruct.modelPar_given_PBIGD=mod.given("PBIGD");
modelStruct.modelPar_LCIGD=mod.LCIGD;
modelStruct.d_modelPar_LCIGD_dX=0.0;
modelStruct.modelPar_given_LCIGD=mod.given("LCIGD");
modelStruct.modelPar_NCIGD=mod.NCIGD;
modelStruct.d_modelPar_NCIGD_dX=0.0;
modelStruct.modelPar_given_NCIGD=mod.given("NCIGD");
modelStruct.modelPar_PCIGD=mod.PCIGD;
modelStruct.d_modelPar_PCIGD_dX=0.0;
modelStruct.modelPar_given_PCIGD=mod.given("PCIGD");
modelStruct.modelPar_LNTOX=mod.LNTOX;
modelStruct.d_modelPar_LNTOX_dX=0.0;
modelStruct.modelPar_given_LNTOX=mod.given("LNTOX");
modelStruct.modelPar_NNTOX=mod.NNTOX;
modelStruct.d_modelPar_NNTOX_dX=0.0;
modelStruct.modelPar_given_NNTOX=mod.given("NNTOX");
modelStruct.modelPar_PNTOX=mod.PNTOX;
modelStruct.d_modelPar_PNTOX_dX=0.0;
modelStruct.modelPar_given_PNTOX=mod.given("PNTOX");
modelStruct.modelPar_LPOXEDGE=mod.LPOXEDGE;
modelStruct.d_modelPar_LPOXEDGE_dX=0.0;
modelStruct.modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
modelStruct.modelPar_NPOXEDGE=mod.NPOXEDGE;
modelStruct.d_modelPar_NPOXEDGE_dX=0.0;
modelStruct.modelPar_given_NPOXEDGE=mod.given("NPOXEDGE");
modelStruct.modelPar_PPOXEDGE=mod.PPOXEDGE;
modelStruct.d_modelPar_PPOXEDGE_dX=0.0;
modelStruct.modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
modelStruct.modelPar_LAGISL=mod.LAGISL;
modelStruct.d_modelPar_LAGISL_dX=0.0;
modelStruct.modelPar_given_LAGISL=mod.given("LAGISL");
modelStruct.modelPar_NAGISL=mod.NAGISL;
modelStruct.d_modelPar_NAGISL_dX=0.0;
modelStruct.modelPar_given_NAGISL=mod.given("NAGISL");
modelStruct.modelPar_PAGISL=mod.PAGISL;
modelStruct.d_modelPar_PAGISL_dX=0.0;
modelStruct.modelPar_given_PAGISL=mod.given("PAGISL");
modelStruct.modelPar_LBGISL=mod.LBGISL;
modelStruct.d_modelPar_LBGISL_dX=0.0;
modelStruct.modelPar_given_LBGISL=mod.given("LBGISL");
modelStruct.modelPar_NBGISL=mod.NBGISL;
modelStruct.d_modelPar_NBGISL_dX=0.0;
modelStruct.modelPar_given_NBGISL=mod.given("NBGISL");
modelStruct.modelPar_PBGISL=mod.PBGISL;
modelStruct.d_modelPar_PBGISL_dX=0.0;
modelStruct.modelPar_given_PBGISL=mod.given("PBGISL");
modelStruct.modelPar_LCGISL=mod.LCGISL;
modelStruct.d_modelPar_LCGISL_dX=0.0;
modelStruct.modelPar_given_LCGISL=mod.given("LCGISL");
modelStruct.modelPar_NCGISL=mod.NCGISL;
modelStruct.d_modelPar_NCGISL_dX=0.0;
modelStruct.modelPar_given_NCGISL=mod.given("NCGISL");
modelStruct.modelPar_PCGISL=mod.PCGISL;
modelStruct.d_modelPar_PCGISL_dX=0.0;
modelStruct.modelPar_given_PCGISL=mod.given("PCGISL");
modelStruct.modelPar_LEGISL=mod.LEGISL;
modelStruct.d_modelPar_LEGISL_dX=0.0;
modelStruct.modelPar_given_LEGISL=mod.given("LEGISL");
modelStruct.modelPar_NEGISL=mod.NEGISL;
modelStruct.d_modelPar_NEGISL_dX=0.0;
modelStruct.modelPar_given_NEGISL=mod.given("NEGISL");
modelStruct.modelPar_PEGISL=mod.PEGISL;
modelStruct.d_modelPar_PEGISL_dX=0.0;
modelStruct.modelPar_given_PEGISL=mod.given("PEGISL");
modelStruct.modelPar_LPGISL=mod.LPGISL;
modelStruct.d_modelPar_LPGISL_dX=0.0;
modelStruct.modelPar_given_LPGISL=mod.given("LPGISL");
modelStruct.modelPar_NPGISL=mod.NPGISL;
modelStruct.d_modelPar_NPGISL_dX=0.0;
modelStruct.modelPar_given_NPGISL=mod.given("NPGISL");
modelStruct.modelPar_PPGISL=mod.PPGISL;
modelStruct.d_modelPar_PPGISL_dX=0.0;
modelStruct.modelPar_given_PPGISL=mod.given("PPGISL");
modelStruct.modelPar_LAGIDL=mod.LAGIDL;
modelStruct.d_modelPar_LAGIDL_dX=0.0;
modelStruct.modelPar_given_LAGIDL=mod.given("LAGIDL");
modelStruct.modelPar_NAGIDL=mod.NAGIDL;
modelStruct.d_modelPar_NAGIDL_dX=0.0;
modelStruct.modelPar_given_NAGIDL=mod.given("NAGIDL");
modelStruct.modelPar_PAGIDL=mod.PAGIDL;
modelStruct.d_modelPar_PAGIDL_dX=0.0;
modelStruct.modelPar_given_PAGIDL=mod.given("PAGIDL");
modelStruct.modelPar_LBGIDL=mod.LBGIDL;
modelStruct.d_modelPar_LBGIDL_dX=0.0;
modelStruct.modelPar_given_LBGIDL=mod.given("LBGIDL");
modelStruct.modelPar_NBGIDL=mod.NBGIDL;
modelStruct.d_modelPar_NBGIDL_dX=0.0;
modelStruct.modelPar_given_NBGIDL=mod.given("NBGIDL");
modelStruct.modelPar_PBGIDL=mod.PBGIDL;
modelStruct.d_modelPar_PBGIDL_dX=0.0;
modelStruct.modelPar_given_PBGIDL=mod.given("PBGIDL");
modelStruct.modelPar_LCGIDL=mod.LCGIDL;
modelStruct.d_modelPar_LCGIDL_dX=0.0;
modelStruct.modelPar_given_LCGIDL=mod.given("LCGIDL");
modelStruct.modelPar_NCGIDL=mod.NCGIDL;
modelStruct.d_modelPar_NCGIDL_dX=0.0;
modelStruct.modelPar_given_NCGIDL=mod.given("NCGIDL");
modelStruct.modelPar_PCGIDL=mod.PCGIDL;
modelStruct.d_modelPar_PCGIDL_dX=0.0;
modelStruct.modelPar_given_PCGIDL=mod.given("PCGIDL");
modelStruct.modelPar_LEGIDL=mod.LEGIDL;
modelStruct.d_modelPar_LEGIDL_dX=0.0;
modelStruct.modelPar_given_LEGIDL=mod.given("LEGIDL");
modelStruct.modelPar_NEGIDL=mod.NEGIDL;
modelStruct.d_modelPar_NEGIDL_dX=0.0;
modelStruct.modelPar_given_NEGIDL=mod.given("NEGIDL");
modelStruct.modelPar_PEGIDL=mod.PEGIDL;
modelStruct.d_modelPar_PEGIDL_dX=0.0;
modelStruct.modelPar_given_PEGIDL=mod.given("PEGIDL");
modelStruct.modelPar_LPGIDL=mod.LPGIDL;
modelStruct.d_modelPar_LPGIDL_dX=0.0;
modelStruct.modelPar_given_LPGIDL=mod.given("LPGIDL");
modelStruct.modelPar_NPGIDL=mod.NPGIDL;
modelStruct.d_modelPar_NPGIDL_dX=0.0;
modelStruct.modelPar_given_NPGIDL=mod.given("NPGIDL");
modelStruct.modelPar_PPGIDL=mod.PPGIDL;
modelStruct.d_modelPar_PPGIDL_dX=0.0;
modelStruct.modelPar_given_PPGIDL=mod.given("PPGIDL");
modelStruct.modelPar_LALPHA0=mod.LALPHA0;
modelStruct.d_modelPar_LALPHA0_dX=0.0;
modelStruct.modelPar_given_LALPHA0=mod.given("LALPHA0");
modelStruct.modelPar_NALPHA0=mod.NALPHA0;
modelStruct.d_modelPar_NALPHA0_dX=0.0;
modelStruct.modelPar_given_NALPHA0=mod.given("NALPHA0");
modelStruct.modelPar_PALPHA0=mod.PALPHA0;
modelStruct.d_modelPar_PALPHA0_dX=0.0;
modelStruct.modelPar_given_PALPHA0=mod.given("PALPHA0");
modelStruct.modelPar_LALPHA1=mod.LALPHA1;
modelStruct.d_modelPar_LALPHA1_dX=0.0;
modelStruct.modelPar_given_LALPHA1=mod.given("LALPHA1");
modelStruct.modelPar_NALPHA1=mod.NALPHA1;
modelStruct.d_modelPar_NALPHA1_dX=0.0;
modelStruct.modelPar_given_NALPHA1=mod.given("NALPHA1");
modelStruct.modelPar_PALPHA1=mod.PALPHA1;
modelStruct.d_modelPar_PALPHA1_dX=0.0;
modelStruct.modelPar_given_PALPHA1=mod.given("PALPHA1");
modelStruct.modelPar_LALPHAII0=mod.LALPHAII0;
modelStruct.d_modelPar_LALPHAII0_dX=0.0;
modelStruct.modelPar_given_LALPHAII0=mod.given("LALPHAII0");
modelStruct.modelPar_NALPHAII0=mod.NALPHAII0;
modelStruct.d_modelPar_NALPHAII0_dX=0.0;
modelStruct.modelPar_given_NALPHAII0=mod.given("NALPHAII0");
modelStruct.modelPar_PALPHAII0=mod.PALPHAII0;
modelStruct.d_modelPar_PALPHAII0_dX=0.0;
modelStruct.modelPar_given_PALPHAII0=mod.given("PALPHAII0");
modelStruct.modelPar_LALPHAII1=mod.LALPHAII1;
modelStruct.d_modelPar_LALPHAII1_dX=0.0;
modelStruct.modelPar_given_LALPHAII1=mod.given("LALPHAII1");
modelStruct.modelPar_NALPHAII1=mod.NALPHAII1;
modelStruct.d_modelPar_NALPHAII1_dX=0.0;
modelStruct.modelPar_given_NALPHAII1=mod.given("NALPHAII1");
modelStruct.modelPar_PALPHAII1=mod.PALPHAII1;
modelStruct.d_modelPar_PALPHAII1_dX=0.0;
modelStruct.modelPar_given_PALPHAII1=mod.given("PALPHAII1");
modelStruct.modelPar_LBETA0=mod.LBETA0;
modelStruct.d_modelPar_LBETA0_dX=0.0;
modelStruct.modelPar_given_LBETA0=mod.given("LBETA0");
modelStruct.modelPar_NBETA0=mod.NBETA0;
modelStruct.d_modelPar_NBETA0_dX=0.0;
modelStruct.modelPar_given_NBETA0=mod.given("NBETA0");
modelStruct.modelPar_PBETA0=mod.PBETA0;
modelStruct.d_modelPar_PBETA0_dX=0.0;
modelStruct.modelPar_given_PBETA0=mod.given("PBETA0");
modelStruct.modelPar_LBETAII0=mod.LBETAII0;
modelStruct.d_modelPar_LBETAII0_dX=0.0;
modelStruct.modelPar_given_LBETAII0=mod.given("LBETAII0");
modelStruct.modelPar_NBETAII0=mod.NBETAII0;
modelStruct.d_modelPar_NBETAII0_dX=0.0;
modelStruct.modelPar_given_NBETAII0=mod.given("NBETAII0");
modelStruct.modelPar_PBETAII0=mod.PBETAII0;
modelStruct.d_modelPar_PBETAII0_dX=0.0;
modelStruct.modelPar_given_PBETAII0=mod.given("PBETAII0");
modelStruct.modelPar_LBETAII1=mod.LBETAII1;
modelStruct.d_modelPar_LBETAII1_dX=0.0;
modelStruct.modelPar_given_LBETAII1=mod.given("LBETAII1");
modelStruct.modelPar_NBETAII1=mod.NBETAII1;
modelStruct.d_modelPar_NBETAII1_dX=0.0;
modelStruct.modelPar_given_NBETAII1=mod.given("NBETAII1");
modelStruct.modelPar_PBETAII1=mod.PBETAII1;
modelStruct.d_modelPar_PBETAII1_dX=0.0;
modelStruct.modelPar_given_PBETAII1=mod.given("PBETAII1");
modelStruct.modelPar_LBETAII2=mod.LBETAII2;
modelStruct.d_modelPar_LBETAII2_dX=0.0;
modelStruct.modelPar_given_LBETAII2=mod.given("LBETAII2");
modelStruct.modelPar_NBETAII2=mod.NBETAII2;
modelStruct.d_modelPar_NBETAII2_dX=0.0;
modelStruct.modelPar_given_NBETAII2=mod.given("NBETAII2");
modelStruct.modelPar_PBETAII2=mod.PBETAII2;
modelStruct.d_modelPar_PBETAII2_dX=0.0;
modelStruct.modelPar_given_PBETAII2=mod.given("PBETAII2");
modelStruct.modelPar_LESATII=mod.LESATII;
modelStruct.d_modelPar_LESATII_dX=0.0;
modelStruct.modelPar_given_LESATII=mod.given("LESATII");
modelStruct.modelPar_NESATII=mod.NESATII;
modelStruct.d_modelPar_NESATII_dX=0.0;
modelStruct.modelPar_given_NESATII=mod.given("NESATII");
modelStruct.modelPar_PESATII=mod.PESATII;
modelStruct.d_modelPar_PESATII_dX=0.0;
modelStruct.modelPar_given_PESATII=mod.given("PESATII");
modelStruct.modelPar_LLII=mod.LLII;
modelStruct.d_modelPar_LLII_dX=0.0;
modelStruct.modelPar_given_LLII=mod.given("LLII");
modelStruct.modelPar_NLII=mod.NLII;
modelStruct.d_modelPar_NLII_dX=0.0;
modelStruct.modelPar_given_NLII=mod.given("NLII");
modelStruct.modelPar_PLII=mod.PLII;
modelStruct.d_modelPar_PLII_dX=0.0;
modelStruct.modelPar_given_PLII=mod.given("PLII");
modelStruct.modelPar_LSII0=mod.LSII0;
modelStruct.d_modelPar_LSII0_dX=0.0;
modelStruct.modelPar_given_LSII0=mod.given("LSII0");
modelStruct.modelPar_NSII0=mod.NSII0;
modelStruct.d_modelPar_NSII0_dX=0.0;
modelStruct.modelPar_given_NSII0=mod.given("NSII0");
modelStruct.modelPar_PSII0=mod.PSII0;
modelStruct.d_modelPar_PSII0_dX=0.0;
modelStruct.modelPar_given_PSII0=mod.given("PSII0");
modelStruct.modelPar_LSII1=mod.LSII1;
modelStruct.d_modelPar_LSII1_dX=0.0;
modelStruct.modelPar_given_LSII1=mod.given("LSII1");
modelStruct.modelPar_NSII1=mod.NSII1;
modelStruct.d_modelPar_NSII1_dX=0.0;
modelStruct.modelPar_given_NSII1=mod.given("NSII1");
modelStruct.modelPar_PSII1=mod.PSII1;
modelStruct.d_modelPar_PSII1_dX=0.0;
modelStruct.modelPar_given_PSII1=mod.given("PSII1");
modelStruct.modelPar_LSII2=mod.LSII2;
modelStruct.d_modelPar_LSII2_dX=0.0;
modelStruct.modelPar_given_LSII2=mod.given("LSII2");
modelStruct.modelPar_NSII2=mod.NSII2;
modelStruct.d_modelPar_NSII2_dX=0.0;
modelStruct.modelPar_given_NSII2=mod.given("NSII2");
modelStruct.modelPar_PSII2=mod.PSII2;
modelStruct.d_modelPar_PSII2_dX=0.0;
modelStruct.modelPar_given_PSII2=mod.given("PSII2");
modelStruct.modelPar_LSIID=mod.LSIID;
modelStruct.d_modelPar_LSIID_dX=0.0;
modelStruct.modelPar_given_LSIID=mod.given("LSIID");
modelStruct.modelPar_NSIID=mod.NSIID;
modelStruct.d_modelPar_NSIID_dX=0.0;
modelStruct.modelPar_given_NSIID=mod.given("NSIID");
modelStruct.modelPar_PSIID=mod.PSIID;
modelStruct.d_modelPar_PSIID_dX=0.0;
modelStruct.modelPar_given_PSIID=mod.given("PSIID");
modelStruct.modelPar_LCFS=mod.LCFS;
modelStruct.d_modelPar_LCFS_dX=0.0;
modelStruct.modelPar_given_LCFS=mod.given("LCFS");
modelStruct.modelPar_NCFS=mod.NCFS;
modelStruct.d_modelPar_NCFS_dX=0.0;
modelStruct.modelPar_given_NCFS=mod.given("NCFS");
modelStruct.modelPar_PCFS=mod.PCFS;
modelStruct.d_modelPar_PCFS_dX=0.0;
modelStruct.modelPar_given_PCFS=mod.given("PCFS");
modelStruct.modelPar_LCFD=mod.LCFD;
modelStruct.d_modelPar_LCFD_dX=0.0;
modelStruct.modelPar_given_LCFD=mod.given("LCFD");
modelStruct.modelPar_NCFD=mod.NCFD;
modelStruct.d_modelPar_NCFD_dX=0.0;
modelStruct.modelPar_given_NCFD=mod.given("NCFD");
modelStruct.modelPar_PCFD=mod.PCFD;
modelStruct.d_modelPar_PCFD_dX=0.0;
modelStruct.modelPar_given_PCFD=mod.given("PCFD");
modelStruct.modelPar_LCOVS=mod.LCOVS;
modelStruct.d_modelPar_LCOVS_dX=0.0;
modelStruct.modelPar_given_LCOVS=mod.given("LCOVS");
modelStruct.modelPar_NCOVS=mod.NCOVS;
modelStruct.d_modelPar_NCOVS_dX=0.0;
modelStruct.modelPar_given_NCOVS=mod.given("NCOVS");
modelStruct.modelPar_PCOVS=mod.PCOVS;
modelStruct.d_modelPar_PCOVS_dX=0.0;
modelStruct.modelPar_given_PCOVS=mod.given("PCOVS");
modelStruct.modelPar_LCOVD=mod.LCOVD;
modelStruct.d_modelPar_LCOVD_dX=0.0;
modelStruct.modelPar_given_LCOVD=mod.given("LCOVD");
modelStruct.modelPar_NCOVD=mod.NCOVD;
modelStruct.d_modelPar_NCOVD_dX=0.0;
modelStruct.modelPar_given_NCOVD=mod.given("NCOVD");
modelStruct.modelPar_PCOVD=mod.PCOVD;
modelStruct.d_modelPar_PCOVD_dX=0.0;
modelStruct.modelPar_given_PCOVD=mod.given("PCOVD");
modelStruct.modelPar_LCGSL=mod.LCGSL;
modelStruct.d_modelPar_LCGSL_dX=0.0;
modelStruct.modelPar_given_LCGSL=mod.given("LCGSL");
modelStruct.modelPar_NCGSL=mod.NCGSL;
modelStruct.d_modelPar_NCGSL_dX=0.0;
modelStruct.modelPar_given_NCGSL=mod.given("NCGSL");
modelStruct.modelPar_PCGSL=mod.PCGSL;
modelStruct.d_modelPar_PCGSL_dX=0.0;
modelStruct.modelPar_given_PCGSL=mod.given("PCGSL");
modelStruct.modelPar_LCGDL=mod.LCGDL;
modelStruct.d_modelPar_LCGDL_dX=0.0;
modelStruct.modelPar_given_LCGDL=mod.given("LCGDL");
modelStruct.modelPar_NCGDL=mod.NCGDL;
modelStruct.d_modelPar_NCGDL_dX=0.0;
modelStruct.modelPar_given_NCGDL=mod.given("NCGDL");
modelStruct.modelPar_PCGDL=mod.PCGDL;
modelStruct.d_modelPar_PCGDL_dX=0.0;
modelStruct.modelPar_given_PCGDL=mod.given("PCGDL");
modelStruct.modelPar_LCKAPPAS=mod.LCKAPPAS;
modelStruct.d_modelPar_LCKAPPAS_dX=0.0;
modelStruct.modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
modelStruct.modelPar_NCKAPPAS=mod.NCKAPPAS;
modelStruct.d_modelPar_NCKAPPAS_dX=0.0;
modelStruct.modelPar_given_NCKAPPAS=mod.given("NCKAPPAS");
modelStruct.modelPar_PCKAPPAS=mod.PCKAPPAS;
modelStruct.d_modelPar_PCKAPPAS_dX=0.0;
modelStruct.modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
modelStruct.modelPar_LCKAPPAD=mod.LCKAPPAD;
modelStruct.d_modelPar_LCKAPPAD_dX=0.0;
modelStruct.modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
modelStruct.modelPar_NCKAPPAD=mod.NCKAPPAD;
modelStruct.d_modelPar_NCKAPPAD_dX=0.0;
modelStruct.modelPar_given_NCKAPPAD=mod.given("NCKAPPAD");
modelStruct.modelPar_PCKAPPAD=mod.PCKAPPAD;
modelStruct.d_modelPar_PCKAPPAD_dX=0.0;
modelStruct.modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
modelStruct.modelPar_LCGBL=mod.LCGBL;
modelStruct.d_modelPar_LCGBL_dX=0.0;
modelStruct.modelPar_given_LCGBL=mod.given("LCGBL");
modelStruct.modelPar_NCGBL=mod.NCGBL;
modelStruct.d_modelPar_NCGBL_dX=0.0;
modelStruct.modelPar_given_NCGBL=mod.given("NCGBL");
modelStruct.modelPar_PCGBL=mod.PCGBL;
modelStruct.d_modelPar_PCGBL_dX=0.0;
modelStruct.modelPar_given_PCGBL=mod.given("PCGBL");
modelStruct.modelPar_LCKAPPAB=mod.LCKAPPAB;
modelStruct.d_modelPar_LCKAPPAB_dX=0.0;
modelStruct.modelPar_given_LCKAPPAB=mod.given("LCKAPPAB");
modelStruct.modelPar_NCKAPPAB=mod.NCKAPPAB;
modelStruct.d_modelPar_NCKAPPAB_dX=0.0;
modelStruct.modelPar_given_NCKAPPAB=mod.given("NCKAPPAB");
modelStruct.modelPar_PCKAPPAB=mod.PCKAPPAB;
modelStruct.d_modelPar_PCKAPPAB_dX=0.0;
modelStruct.modelPar_given_PCKAPPAB=mod.given("PCKAPPAB");
modelStruct.modelPar_LNTGEN=mod.LNTGEN;
modelStruct.d_modelPar_LNTGEN_dX=0.0;
modelStruct.modelPar_given_LNTGEN=mod.given("LNTGEN");
modelStruct.modelPar_NNTGEN=mod.NNTGEN;
modelStruct.d_modelPar_NNTGEN_dX=0.0;
modelStruct.modelPar_given_NNTGEN=mod.given("NNTGEN");
modelStruct.modelPar_PNTGEN=mod.PNTGEN;
modelStruct.d_modelPar_PNTGEN_dX=0.0;
modelStruct.modelPar_given_PNTGEN=mod.given("PNTGEN");
modelStruct.modelPar_LAIGEN=mod.LAIGEN;
modelStruct.d_modelPar_LAIGEN_dX=0.0;
modelStruct.modelPar_given_LAIGEN=mod.given("LAIGEN");
modelStruct.modelPar_NAIGEN=mod.NAIGEN;
modelStruct.d_modelPar_NAIGEN_dX=0.0;
modelStruct.modelPar_given_NAIGEN=mod.given("NAIGEN");
modelStruct.modelPar_PAIGEN=mod.PAIGEN;
modelStruct.d_modelPar_PAIGEN_dX=0.0;
modelStruct.modelPar_given_PAIGEN=mod.given("PAIGEN");
modelStruct.modelPar_LBIGEN=mod.LBIGEN;
modelStruct.d_modelPar_LBIGEN_dX=0.0;
modelStruct.modelPar_given_LBIGEN=mod.given("LBIGEN");
modelStruct.modelPar_NBIGEN=mod.NBIGEN;
modelStruct.d_modelPar_NBIGEN_dX=0.0;
modelStruct.modelPar_given_NBIGEN=mod.given("NBIGEN");
modelStruct.modelPar_PBIGEN=mod.PBIGEN;
modelStruct.d_modelPar_PBIGEN_dX=0.0;
modelStruct.modelPar_given_PBIGEN=mod.given("PBIGEN");
modelStruct.modelPar_LXRCRG1=mod.LXRCRG1;
modelStruct.d_modelPar_LXRCRG1_dX=0.0;
modelStruct.modelPar_given_LXRCRG1=mod.given("LXRCRG1");
modelStruct.modelPar_NXRCRG1=mod.NXRCRG1;
modelStruct.d_modelPar_NXRCRG1_dX=0.0;
modelStruct.modelPar_given_NXRCRG1=mod.given("NXRCRG1");
modelStruct.modelPar_PXRCRG1=mod.PXRCRG1;
modelStruct.d_modelPar_PXRCRG1_dX=0.0;
modelStruct.modelPar_given_PXRCRG1=mod.given("PXRCRG1");
modelStruct.modelPar_LXRCRG2=mod.LXRCRG2;
modelStruct.d_modelPar_LXRCRG2_dX=0.0;
modelStruct.modelPar_given_LXRCRG2=mod.given("LXRCRG2");
modelStruct.modelPar_NXRCRG2=mod.NXRCRG2;
modelStruct.d_modelPar_NXRCRG2_dX=0.0;
modelStruct.modelPar_given_NXRCRG2=mod.given("NXRCRG2");
modelStruct.modelPar_PXRCRG2=mod.PXRCRG2;
modelStruct.d_modelPar_PXRCRG2_dX=0.0;
modelStruct.modelPar_given_PXRCRG2=mod.given("PXRCRG2");
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modelStruct.modelPar_LUTE=mod.LUTE;
modelStruct.d_modelPar_LUTE_dX=0.0;
modelStruct.modelPar_given_LUTE=mod.given("LUTE");
modelStruct.modelPar_NUTE=mod.NUTE;
modelStruct.d_modelPar_NUTE_dX=0.0;
modelStruct.modelPar_given_NUTE=mod.given("NUTE");
modelStruct.modelPar_PUTE=mod.PUTE;
modelStruct.d_modelPar_PUTE_dX=0.0;
modelStruct.modelPar_given_PUTE=mod.given("PUTE");
modelStruct.modelPar_LUTL=mod.LUTL;
modelStruct.d_modelPar_LUTL_dX=0.0;
modelStruct.modelPar_given_LUTL=mod.given("LUTL");
modelStruct.modelPar_NUTL=mod.NUTL;
modelStruct.d_modelPar_NUTL_dX=0.0;
modelStruct.modelPar_given_NUTL=mod.given("NUTL");
modelStruct.modelPar_PUTL=mod.PUTL;
modelStruct.d_modelPar_PUTL_dX=0.0;
modelStruct.modelPar_given_PUTL=mod.given("PUTL");
modelStruct.modelPar_LEMOBT=mod.LEMOBT;
modelStruct.d_modelPar_LEMOBT_dX=0.0;
modelStruct.modelPar_given_LEMOBT=mod.given("LEMOBT");
modelStruct.modelPar_NEMOBT=mod.NEMOBT;
modelStruct.d_modelPar_NEMOBT_dX=0.0;
modelStruct.modelPar_given_NEMOBT=mod.given("NEMOBT");
modelStruct.modelPar_PEMOBT=mod.PEMOBT;
modelStruct.d_modelPar_PEMOBT_dX=0.0;
modelStruct.modelPar_given_PEMOBT=mod.given("PEMOBT");
modelStruct.modelPar_LUA1=mod.LUA1;
modelStruct.d_modelPar_LUA1_dX=0.0;
modelStruct.modelPar_given_LUA1=mod.given("LUA1");
modelStruct.modelPar_NUA1=mod.NUA1;
modelStruct.d_modelPar_NUA1_dX=0.0;
modelStruct.modelPar_given_NUA1=mod.given("NUA1");
modelStruct.modelPar_PUA1=mod.PUA1;
modelStruct.d_modelPar_PUA1_dX=0.0;
modelStruct.modelPar_given_PUA1=mod.given("PUA1");
modelStruct.modelPar_LUC1=mod.LUC1;
modelStruct.d_modelPar_LUC1_dX=0.0;
modelStruct.modelPar_given_LUC1=mod.given("LUC1");
modelStruct.modelPar_NUC1=mod.NUC1;
modelStruct.d_modelPar_NUC1_dX=0.0;
modelStruct.modelPar_given_NUC1=mod.given("NUC1");
modelStruct.modelPar_PUC1=mod.PUC1;
modelStruct.d_modelPar_PUC1_dX=0.0;
modelStruct.modelPar_given_PUC1=mod.given("PUC1");
modelStruct.modelPar_LUD1=mod.LUD1;
modelStruct.d_modelPar_LUD1_dX=0.0;
modelStruct.modelPar_given_LUD1=mod.given("LUD1");
modelStruct.modelPar_NUD1=mod.NUD1;
modelStruct.d_modelPar_NUD1_dX=0.0;
modelStruct.modelPar_given_NUD1=mod.given("NUD1");
modelStruct.modelPar_PUD1=mod.PUD1;
modelStruct.d_modelPar_PUD1_dX=0.0;
modelStruct.modelPar_given_PUD1=mod.given("PUD1");
modelStruct.modelPar_LUCSTE=mod.LUCSTE;
modelStruct.d_modelPar_LUCSTE_dX=0.0;
modelStruct.modelPar_given_LUCSTE=mod.given("LUCSTE");
modelStruct.modelPar_NUCSTE=mod.NUCSTE;
modelStruct.d_modelPar_NUCSTE_dX=0.0;
modelStruct.modelPar_given_NUCSTE=mod.given("NUCSTE");
modelStruct.modelPar_PUCSTE=mod.PUCSTE;
modelStruct.d_modelPar_PUCSTE_dX=0.0;
modelStruct.modelPar_given_PUCSTE=mod.given("PUCSTE");
modelStruct.modelPar_LPTWGT=mod.LPTWGT;
modelStruct.d_modelPar_LPTWGT_dX=0.0;
modelStruct.modelPar_given_LPTWGT=mod.given("LPTWGT");
modelStruct.modelPar_NPTWGT=mod.NPTWGT;
modelStruct.d_modelPar_NPTWGT_dX=0.0;
modelStruct.modelPar_given_NPTWGT=mod.given("NPTWGT");
modelStruct.modelPar_PPTWGT=mod.PPTWGT;
modelStruct.d_modelPar_PPTWGT_dX=0.0;
modelStruct.modelPar_given_PPTWGT=mod.given("PPTWGT");
modelStruct.modelPar_LAT=mod.LAT;
modelStruct.d_modelPar_LAT_dX=0.0;
modelStruct.modelPar_given_LAT=mod.given("LAT");
modelStruct.modelPar_NAT=mod.NAT;
modelStruct.d_modelPar_NAT_dX=0.0;
modelStruct.modelPar_given_NAT=mod.given("NAT");
modelStruct.modelPar_PAT=mod.PAT;
modelStruct.d_modelPar_PAT_dX=0.0;
modelStruct.modelPar_given_PAT=mod.given("PAT");
modelStruct.modelPar_LSTTHETASAT=mod.LSTTHETASAT;
modelStruct.d_modelPar_LSTTHETASAT_dX=0.0;
modelStruct.modelPar_given_LSTTHETASAT=mod.given("LSTTHETASAT");
modelStruct.modelPar_NSTTHETASAT=mod.NSTTHETASAT;
modelStruct.d_modelPar_NSTTHETASAT_dX=0.0;
modelStruct.modelPar_given_NSTTHETASAT=mod.given("NSTTHETASAT");
modelStruct.modelPar_PSTTHETASAT=mod.PSTTHETASAT;
modelStruct.d_modelPar_PSTTHETASAT_dX=0.0;
modelStruct.modelPar_given_PSTTHETASAT=mod.given("PSTTHETASAT");
modelStruct.modelPar_LPRT=mod.LPRT;
modelStruct.d_modelPar_LPRT_dX=0.0;
modelStruct.modelPar_given_LPRT=mod.given("LPRT");
modelStruct.modelPar_NPRT=mod.NPRT;
modelStruct.d_modelPar_NPRT_dX=0.0;
modelStruct.modelPar_given_NPRT=mod.given("NPRT");
modelStruct.modelPar_PPRT=mod.PPRT;
modelStruct.d_modelPar_PPRT_dX=0.0;
modelStruct.modelPar_given_PPRT=mod.given("PPRT");
modelStruct.modelPar_LKT1=mod.LKT1;
modelStruct.d_modelPar_LKT1_dX=0.0;
modelStruct.modelPar_given_LKT1=mod.given("LKT1");
modelStruct.modelPar_NKT1=mod.NKT1;
modelStruct.d_modelPar_NKT1_dX=0.0;
modelStruct.modelPar_given_NKT1=mod.given("NKT1");
modelStruct.modelPar_PKT1=mod.PKT1;
modelStruct.d_modelPar_PKT1_dX=0.0;
modelStruct.modelPar_given_PKT1=mod.given("PKT1");
modelStruct.modelPar_LTSS=mod.LTSS;
modelStruct.d_modelPar_LTSS_dX=0.0;
modelStruct.modelPar_given_LTSS=mod.given("LTSS");
modelStruct.modelPar_NTSS=mod.NTSS;
modelStruct.d_modelPar_NTSS_dX=0.0;
modelStruct.modelPar_given_NTSS=mod.given("NTSS");
modelStruct.modelPar_PTSS=mod.PTSS;
modelStruct.d_modelPar_PTSS_dX=0.0;
modelStruct.modelPar_given_PTSS=mod.given("PTSS");
modelStruct.modelPar_LIIT=mod.LIIT;
modelStruct.d_modelPar_LIIT_dX=0.0;
modelStruct.modelPar_given_LIIT=mod.given("LIIT");
modelStruct.modelPar_NIIT=mod.NIIT;
modelStruct.d_modelPar_NIIT_dX=0.0;
modelStruct.modelPar_given_NIIT=mod.given("NIIT");
modelStruct.modelPar_PIIT=mod.PIIT;
modelStruct.d_modelPar_PIIT_dX=0.0;
modelStruct.modelPar_given_PIIT=mod.given("PIIT");
modelStruct.modelPar_LTII=mod.LTII;
modelStruct.d_modelPar_LTII_dX=0.0;
modelStruct.modelPar_given_LTII=mod.given("LTII");
modelStruct.modelPar_NTII=mod.NTII;
modelStruct.d_modelPar_NTII_dX=0.0;
modelStruct.modelPar_given_NTII=mod.given("NTII");
modelStruct.modelPar_PTII=mod.PTII;
modelStruct.d_modelPar_PTII_dX=0.0;
modelStruct.modelPar_given_PTII=mod.given("PTII");
modelStruct.modelPar_LTGIDL=mod.LTGIDL;
modelStruct.d_modelPar_LTGIDL_dX=0.0;
modelStruct.modelPar_given_LTGIDL=mod.given("LTGIDL");
modelStruct.modelPar_NTGIDL=mod.NTGIDL;
modelStruct.d_modelPar_NTGIDL_dX=0.0;
modelStruct.modelPar_given_NTGIDL=mod.given("NTGIDL");
modelStruct.modelPar_PTGIDL=mod.PTGIDL;
modelStruct.d_modelPar_PTGIDL_dX=0.0;
modelStruct.modelPar_given_PTGIDL=mod.given("PTGIDL");
modelStruct.modelPar_LIGT=mod.LIGT;
modelStruct.d_modelPar_LIGT_dX=0.0;
modelStruct.modelPar_given_LIGT=mod.given("LIGT");
modelStruct.modelPar_NIGT=mod.NIGT;
modelStruct.d_modelPar_NIGT_dX=0.0;
modelStruct.modelPar_given_NIGT=mod.given("NIGT");
modelStruct.modelPar_PIGT=mod.PIGT;
modelStruct.d_modelPar_PIGT_dX=0.0;
modelStruct.modelPar_given_PIGT=mod.given("PIGT");


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_NF=mod.NF;
modelStruct.modelPar_given_NF=mod.given("NF");
modelStruct.modelPar_NGCON=mod.NGCON;
modelStruct.modelPar_given_NGCON=mod.given("NGCON");
modelStruct.modelPar_DEVTYPE=mod.DEVTYPE;
modelStruct.modelPar_given_DEVTYPE=mod.given("DEVTYPE");
modelStruct.modelPar_BULKMOD=mod.BULKMOD;
modelStruct.modelPar_given_BULKMOD=mod.given("BULKMOD");
modelStruct.modelPar_COREMOD=mod.COREMOD;
modelStruct.modelPar_given_COREMOD=mod.given("COREMOD");
modelStruct.modelPar_GEOMOD=mod.GEOMOD;
modelStruct.modelPar_given_GEOMOD=mod.given("GEOMOD");
modelStruct.modelPar_CGEO1SW=mod.CGEO1SW;
modelStruct.modelPar_given_CGEO1SW=mod.given("CGEO1SW");
modelStruct.modelPar_RDSMOD=mod.RDSMOD;
modelStruct.modelPar_given_RDSMOD=mod.given("RDSMOD");
modelStruct.modelPar_ASYMMOD=mod.ASYMMOD;
modelStruct.modelPar_given_ASYMMOD=mod.given("ASYMMOD");
modelStruct.modelPar_IGCMOD=mod.IGCMOD;
modelStruct.modelPar_given_IGCMOD=mod.given("IGCMOD");
modelStruct.modelPar_IGBMOD=mod.IGBMOD;
modelStruct.modelPar_given_IGBMOD=mod.given("IGBMOD");
modelStruct.modelPar_GIDLMOD=mod.GIDLMOD;
modelStruct.modelPar_given_GIDLMOD=mod.given("GIDLMOD");
modelStruct.modelPar_IIMOD=mod.IIMOD;
modelStruct.modelPar_given_IIMOD=mod.given("IIMOD");
modelStruct.modelPar_NQSMOD=mod.NQSMOD;
modelStruct.modelPar_given_NQSMOD=mod.given("NQSMOD");
modelStruct.modelPar_SHMOD=mod.SHMOD;
modelStruct.modelPar_given_SHMOD=mod.given("SHMOD");
modelStruct.modelPar_RGATEMOD=mod.RGATEMOD;
modelStruct.modelPar_given_RGATEMOD=mod.given("RGATEMOD");
modelStruct.modelPar_RGEOMOD=mod.RGEOMOD;
modelStruct.modelPar_given_RGEOMOD=mod.given("RGEOMOD");
modelStruct.modelPar_CGEOMOD=mod.CGEOMOD;
modelStruct.modelPar_given_CGEOMOD=mod.given("CGEOMOD");
modelStruct.modelPar_CAPMOD=mod.CAPMOD;
modelStruct.modelPar_given_CAPMOD=mod.given("CAPMOD");
modelStruct.modelPar_SDTERM=mod.SDTERM;
modelStruct.modelPar_given_SDTERM=mod.given("SDTERM");
modelStruct.modelPar_NSEG=mod.NSEG;
modelStruct.modelPar_given_NSEG=mod.given("NSEG");



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
inParamMap["L"] = &(instanceStruct.d_instancePar_L_dX);
instanceStruct.instancePar_D=in.D;
instanceStruct.d_instancePar_D_dX=0.0;
instanceStruct.instancePar_given_D=in.given("D");
inParamMap["D"] = &(instanceStruct.d_instancePar_D_dX);
instanceStruct.instancePar_TFIN=in.TFIN;
instanceStruct.d_instancePar_TFIN_dX=0.0;
instanceStruct.instancePar_given_TFIN=in.given("TFIN");
inParamMap["TFIN"] = &(instanceStruct.d_instancePar_TFIN_dX);
instanceStruct.instancePar_FPITCH=in.FPITCH;
instanceStruct.d_instancePar_FPITCH_dX=0.0;
instanceStruct.instancePar_given_FPITCH=in.given("FPITCH");
inParamMap["FPITCH"] = &(instanceStruct.d_instancePar_FPITCH_dX);
instanceStruct.instancePar_NFIN=in.NFIN;
instanceStruct.d_instancePar_NFIN_dX=0.0;
instanceStruct.instancePar_given_NFIN=in.given("NFIN");
inParamMap["NFIN"] = &(instanceStruct.d_instancePar_NFIN_dX);
instanceStruct.instancePar_ASEO=in.ASEO;
instanceStruct.d_instancePar_ASEO_dX=0.0;
instanceStruct.instancePar_given_ASEO=in.given("ASEO");
inParamMap["ASEO"] = &(instanceStruct.d_instancePar_ASEO_dX);
instanceStruct.instancePar_ADEO=in.ADEO;
instanceStruct.d_instancePar_ADEO_dX=0.0;
instanceStruct.instancePar_given_ADEO=in.given("ADEO");
inParamMap["ADEO"] = &(instanceStruct.d_instancePar_ADEO_dX);
instanceStruct.instancePar_PSEO=in.PSEO;
instanceStruct.d_instancePar_PSEO_dX=0.0;
instanceStruct.instancePar_given_PSEO=in.given("PSEO");
inParamMap["PSEO"] = &(instanceStruct.d_instancePar_PSEO_dX);
instanceStruct.instancePar_PDEO=in.PDEO;
instanceStruct.d_instancePar_PDEO_dX=0.0;
instanceStruct.instancePar_given_PDEO=in.given("PDEO");
inParamMap["PDEO"] = &(instanceStruct.d_instancePar_PDEO_dX);
instanceStruct.instancePar_ASEJ=in.ASEJ;
instanceStruct.d_instancePar_ASEJ_dX=0.0;
instanceStruct.instancePar_given_ASEJ=in.given("ASEJ");
inParamMap["ASEJ"] = &(instanceStruct.d_instancePar_ASEJ_dX);
instanceStruct.instancePar_ADEJ=in.ADEJ;
instanceStruct.d_instancePar_ADEJ_dX=0.0;
instanceStruct.instancePar_given_ADEJ=in.given("ADEJ");
inParamMap["ADEJ"] = &(instanceStruct.d_instancePar_ADEJ_dX);
instanceStruct.instancePar_PSEJ=in.PSEJ;
instanceStruct.d_instancePar_PSEJ_dX=0.0;
instanceStruct.instancePar_given_PSEJ=in.given("PSEJ");
inParamMap["PSEJ"] = &(instanceStruct.d_instancePar_PSEJ_dX);
instanceStruct.instancePar_PDEJ=in.PDEJ;
instanceStruct.d_instancePar_PDEJ_dX=0.0;
instanceStruct.instancePar_given_PDEJ=in.given("PDEJ");
inParamMap["PDEJ"] = &(instanceStruct.d_instancePar_PDEJ_dX);
instanceStruct.instancePar_COVS=in.COVS;
instanceStruct.d_instancePar_COVS_dX=0.0;
instanceStruct.instancePar_given_COVS=in.given("COVS");
inParamMap["COVS"] = &(instanceStruct.d_instancePar_COVS_dX);
instanceStruct.instancePar_COVD=in.COVD;
instanceStruct.d_instancePar_COVD_dX=0.0;
instanceStruct.instancePar_given_COVD=in.given("COVD");
inParamMap["COVD"] = &(instanceStruct.d_instancePar_COVD_dX);
instanceStruct.instancePar_CGSP=in.CGSP;
instanceStruct.d_instancePar_CGSP_dX=0.0;
instanceStruct.instancePar_given_CGSP=in.given("CGSP");
inParamMap["CGSP"] = &(instanceStruct.d_instancePar_CGSP_dX);
instanceStruct.instancePar_CGDP=in.CGDP;
instanceStruct.d_instancePar_CGDP_dX=0.0;
instanceStruct.instancePar_given_CGDP=in.given("CGDP");
inParamMap["CGDP"] = &(instanceStruct.d_instancePar_CGDP_dX);
instanceStruct.instancePar_CDSP=in.CDSP;
instanceStruct.d_instancePar_CDSP_dX=0.0;
instanceStruct.instancePar_given_CDSP=in.given("CDSP");
inParamMap["CDSP"] = &(instanceStruct.d_instancePar_CDSP_dX);
instanceStruct.instancePar_NRS=in.NRS;
instanceStruct.d_instancePar_NRS_dX=0.0;
instanceStruct.instancePar_given_NRS=in.given("NRS");
inParamMap["NRS"] = &(instanceStruct.d_instancePar_NRS_dX);
instanceStruct.instancePar_NRD=in.NRD;
instanceStruct.d_instancePar_NRD_dX=0.0;
instanceStruct.instancePar_given_NRD=in.given("NRD");
inParamMap["NRD"] = &(instanceStruct.d_instancePar_NRD_dX);
instanceStruct.instancePar_LRSD=in.LRSD;
instanceStruct.d_instancePar_LRSD_dX=0.0;
instanceStruct.instancePar_given_LRSD=in.given("LRSD");
inParamMap["LRSD"] = &(instanceStruct.d_instancePar_LRSD_dX);
instanceStruct.instancePar_DELVTRAND=in.DELVTRAND;
instanceStruct.d_instancePar_DELVTRAND_dX=0.0;
instanceStruct.instancePar_given_DELVTRAND=in.given("DELVTRAND");
inParamMap["DELVTRAND"] = &(instanceStruct.d_instancePar_DELVTRAND_dX);
instanceStruct.instancePar_U0MULT=in.U0MULT;
instanceStruct.d_instancePar_U0MULT_dX=0.0;
instanceStruct.instancePar_given_U0MULT=in.given("U0MULT");
inParamMap["U0MULT"] = &(instanceStruct.d_instancePar_U0MULT_dX);


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals


//non-reals


//make local copies of all model vars
//reals


// non-reals



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_e_GND] = (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_di_GND] = (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_g_GND] = (*solVectorPtr)[in.li_g];
probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_e_g] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_g];
probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_g_d] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_g_s] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_di_d] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_g_e] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_e_di] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_e_si] = (*solVectorPtr)[in.li_e]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_g_di] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_g_si] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_si];




// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_si_GND,
in.admsProbeID_V_e_GND,
in.admsProbeID_V_di_GND,
in.admsProbeID_V_g_GND,
in.admsProbeID_V_s_si,
in.admsProbeID_V_d_di,
in.admsProbeID_V_e_g,
in.admsProbeID_V_d_s,
in.admsProbeID_V_g_d,
in.admsProbeID_V_g_s,
in.admsProbeID_V_di_d,
in.admsProbeID_V_si_s,
in.admsProbeID_V_g_e,
in.admsProbeID_V_e_di,
in.admsProbeID_V_e_si,
in.admsProbeID_V_g_di,
in.admsProbeID_V_di_si,
in.admsProbeID_V_g_si,

// node constants
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_e,
in.admsNodeID_di,
in.admsNodeID_si,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d] += d_staticContributions_dX[in.admsNodeID_d];
    dqdp[in.admsNodeID_d] += d_dynamicContributions_dX[in.admsNodeID_d];
    Findices[in.admsNodeID_d] = in.li_d;
    Qindices[in.admsNodeID_d] = in.li_d;
    dfdp[in.admsNodeID_g] += d_staticContributions_dX[in.admsNodeID_g];
    dqdp[in.admsNodeID_g] += d_dynamicContributions_dX[in.admsNodeID_g];
    Findices[in.admsNodeID_g] = in.li_g;
    Qindices[in.admsNodeID_g] = in.li_g;
    dfdp[in.admsNodeID_s] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s] = in.li_s;
    Qindices[in.admsNodeID_s] = in.li_s;
    dfdp[in.admsNodeID_e] += d_staticContributions_dX[in.admsNodeID_e];
    dqdp[in.admsNodeID_e] += d_dynamicContributions_dX[in.admsNodeID_e];
    Findices[in.admsNodeID_e] = in.li_e;
    Qindices[in.admsNodeID_e] = in.li_e;
    dfdp[in.admsNodeID_di] += d_staticContributions_dX[in.admsNodeID_di];
    dqdp[in.admsNodeID_di] += d_dynamicContributions_dX[in.admsNodeID_di];
    Findices[in.admsNodeID_di] = in.li_di;
    Qindices[in.admsNodeID_di] = in.li_di;
    dfdp[in.admsNodeID_si] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si] = in.li_si;
    Qindices[in.admsNodeID_si] = in.li_si;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((6+0)*sizeInstance);
dqdp.resize((6+0)*sizeInstance);
Findices.resize((6+0)*sizeInstance);
Qindices.resize((6+0)*sizeInstance);

std::vector <double> probeVars(18);
std::vector <double> d_staticContributions_dX(6+0);
std::vector <double> d_dynamicContributions_dX(6+0);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_L=mod.L;
modelStruct.d_modelPar_L_dX=0.0;
modelStruct.modelPar_given_L=mod.given("L");
modParamMap["L"] = &(modelStruct.d_modelPar_L_dX);
modelStruct.modelPar_D=mod.D;
modelStruct.d_modelPar_D_dX=0.0;
modelStruct.modelPar_given_D=mod.given("D");
modParamMap["D"] = &(modelStruct.d_modelPar_D_dX);
modelStruct.modelPar_TFIN=mod.TFIN;
modelStruct.d_modelPar_TFIN_dX=0.0;
modelStruct.modelPar_given_TFIN=mod.given("TFIN");
modParamMap["TFIN"] = &(modelStruct.d_modelPar_TFIN_dX);
modelStruct.modelPar_FPITCH=mod.FPITCH;
modelStruct.d_modelPar_FPITCH_dX=0.0;
modelStruct.modelPar_given_FPITCH=mod.given("FPITCH");
modParamMap["FPITCH"] = &(modelStruct.d_modelPar_FPITCH_dX);
modelStruct.modelPar_NFIN=mod.NFIN;
modelStruct.d_modelPar_NFIN_dX=0.0;
modelStruct.modelPar_given_NFIN=mod.given("NFIN");
modParamMap["NFIN"] = &(modelStruct.d_modelPar_NFIN_dX);
modelStruct.modelPar_ASEO=mod.ASEO;
modelStruct.d_modelPar_ASEO_dX=0.0;
modelStruct.modelPar_given_ASEO=mod.given("ASEO");
modParamMap["ASEO"] = &(modelStruct.d_modelPar_ASEO_dX);
modelStruct.modelPar_ADEO=mod.ADEO;
modelStruct.d_modelPar_ADEO_dX=0.0;
modelStruct.modelPar_given_ADEO=mod.given("ADEO");
modParamMap["ADEO"] = &(modelStruct.d_modelPar_ADEO_dX);
modelStruct.modelPar_PSEO=mod.PSEO;
modelStruct.d_modelPar_PSEO_dX=0.0;
modelStruct.modelPar_given_PSEO=mod.given("PSEO");
modParamMap["PSEO"] = &(modelStruct.d_modelPar_PSEO_dX);
modelStruct.modelPar_PDEO=mod.PDEO;
modelStruct.d_modelPar_PDEO_dX=0.0;
modelStruct.modelPar_given_PDEO=mod.given("PDEO");
modParamMap["PDEO"] = &(modelStruct.d_modelPar_PDEO_dX);
modelStruct.modelPar_ASEJ=mod.ASEJ;
modelStruct.d_modelPar_ASEJ_dX=0.0;
modelStruct.modelPar_given_ASEJ=mod.given("ASEJ");
modParamMap["ASEJ"] = &(modelStruct.d_modelPar_ASEJ_dX);
modelStruct.modelPar_ADEJ=mod.ADEJ;
modelStruct.d_modelPar_ADEJ_dX=0.0;
modelStruct.modelPar_given_ADEJ=mod.given("ADEJ");
modParamMap["ADEJ"] = &(modelStruct.d_modelPar_ADEJ_dX);
modelStruct.modelPar_PSEJ=mod.PSEJ;
modelStruct.d_modelPar_PSEJ_dX=0.0;
modelStruct.modelPar_given_PSEJ=mod.given("PSEJ");
modParamMap["PSEJ"] = &(modelStruct.d_modelPar_PSEJ_dX);
modelStruct.modelPar_PDEJ=mod.PDEJ;
modelStruct.d_modelPar_PDEJ_dX=0.0;
modelStruct.modelPar_given_PDEJ=mod.given("PDEJ");
modParamMap["PDEJ"] = &(modelStruct.d_modelPar_PDEJ_dX);
modelStruct.modelPar_COVS=mod.COVS;
modelStruct.d_modelPar_COVS_dX=0.0;
modelStruct.modelPar_given_COVS=mod.given("COVS");
modParamMap["COVS"] = &(modelStruct.d_modelPar_COVS_dX);
modelStruct.modelPar_COVD=mod.COVD;
modelStruct.d_modelPar_COVD_dX=0.0;
modelStruct.modelPar_given_COVD=mod.given("COVD");
modParamMap["COVD"] = &(modelStruct.d_modelPar_COVD_dX);
modelStruct.modelPar_CGSP=mod.CGSP;
modelStruct.d_modelPar_CGSP_dX=0.0;
modelStruct.modelPar_given_CGSP=mod.given("CGSP");
modParamMap["CGSP"] = &(modelStruct.d_modelPar_CGSP_dX);
modelStruct.modelPar_CGDP=mod.CGDP;
modelStruct.d_modelPar_CGDP_dX=0.0;
modelStruct.modelPar_given_CGDP=mod.given("CGDP");
modParamMap["CGDP"] = &(modelStruct.d_modelPar_CGDP_dX);
modelStruct.modelPar_CDSP=mod.CDSP;
modelStruct.d_modelPar_CDSP_dX=0.0;
modelStruct.modelPar_given_CDSP=mod.given("CDSP");
modParamMap["CDSP"] = &(modelStruct.d_modelPar_CDSP_dX);
modelStruct.modelPar_NRS=mod.NRS;
modelStruct.d_modelPar_NRS_dX=0.0;
modelStruct.modelPar_given_NRS=mod.given("NRS");
modParamMap["NRS"] = &(modelStruct.d_modelPar_NRS_dX);
modelStruct.modelPar_NRD=mod.NRD;
modelStruct.d_modelPar_NRD_dX=0.0;
modelStruct.modelPar_given_NRD=mod.given("NRD");
modParamMap["NRD"] = &(modelStruct.d_modelPar_NRD_dX);
modelStruct.modelPar_LRSD=mod.LRSD;
modelStruct.d_modelPar_LRSD_dX=0.0;
modelStruct.modelPar_given_LRSD=mod.given("LRSD");
modParamMap["LRSD"] = &(modelStruct.d_modelPar_LRSD_dX);
modelStruct.modelPar_XL=mod.XL;
modelStruct.d_modelPar_XL_dX=0.0;
modelStruct.modelPar_given_XL=mod.given("XL");
modParamMap["XL"] = &(modelStruct.d_modelPar_XL_dX);
modelStruct.modelPar_DTEMP=mod.DTEMP;
modelStruct.d_modelPar_DTEMP_dX=0.0;
modelStruct.modelPar_given_DTEMP=mod.given("DTEMP");
modParamMap["DTEMP"] = &(modelStruct.d_modelPar_DTEMP_dX);
modelStruct.modelPar_DELVTRAND=mod.DELVTRAND;
modelStruct.d_modelPar_DELVTRAND_dX=0.0;
modelStruct.modelPar_given_DELVTRAND=mod.given("DELVTRAND");
modParamMap["DELVTRAND"] = &(modelStruct.d_modelPar_DELVTRAND_dX);
modelStruct.modelPar_U0MULT=mod.U0MULT;
modelStruct.d_modelPar_U0MULT_dX=0.0;
modelStruct.modelPar_given_U0MULT=mod.given("U0MULT");
modParamMap["U0MULT"] = &(modelStruct.d_modelPar_U0MULT_dX);
modelStruct.modelPar_IDS0MULT=mod.IDS0MULT;
modelStruct.d_modelPar_IDS0MULT_dX=0.0;
modelStruct.modelPar_given_IDS0MULT=mod.given("IDS0MULT");
modParamMap["IDS0MULT"] = &(modelStruct.d_modelPar_IDS0MULT_dX);
modelStruct.modelPar_LINT=mod.LINT;
modelStruct.d_modelPar_LINT_dX=0.0;
modelStruct.modelPar_given_LINT=mod.given("LINT");
modParamMap["LINT"] = &(modelStruct.d_modelPar_LINT_dX);
modelStruct.modelPar_LL=mod.LL;
modelStruct.d_modelPar_LL_dX=0.0;
modelStruct.modelPar_given_LL=mod.given("LL");
modParamMap["LL"] = &(modelStruct.d_modelPar_LL_dX);
modelStruct.modelPar_LLN=mod.LLN;
modelStruct.d_modelPar_LLN_dX=0.0;
modelStruct.modelPar_given_LLN=mod.given("LLN");
modParamMap["LLN"] = &(modelStruct.d_modelPar_LLN_dX);
modelStruct.modelPar_DLC=mod.DLC;
modelStruct.d_modelPar_DLC_dX=0.0;
modelStruct.modelPar_given_DLC=mod.given("DLC");
modParamMap["DLC"] = &(modelStruct.d_modelPar_DLC_dX);
modelStruct.modelPar_DLCACC=mod.DLCACC;
modelStruct.d_modelPar_DLCACC_dX=0.0;
modelStruct.modelPar_given_DLCACC=mod.given("DLCACC");
modParamMap["DLCACC"] = &(modelStruct.d_modelPar_DLCACC_dX);
modelStruct.modelPar_DLBIN=mod.DLBIN;
modelStruct.d_modelPar_DLBIN_dX=0.0;
modelStruct.modelPar_given_DLBIN=mod.given("DLBIN");
modParamMap["DLBIN"] = &(modelStruct.d_modelPar_DLBIN_dX);
modelStruct.modelPar_LLC=mod.LLC;
modelStruct.d_modelPar_LLC_dX=0.0;
modelStruct.modelPar_given_LLC=mod.given("LLC");
modParamMap["LLC"] = &(modelStruct.d_modelPar_LLC_dX);
modelStruct.modelPar_EOT=mod.EOT;
modelStruct.d_modelPar_EOT_dX=0.0;
modelStruct.modelPar_given_EOT=mod.given("EOT");
modParamMap["EOT"] = &(modelStruct.d_modelPar_EOT_dX);
modelStruct.modelPar_TOXP=mod.TOXP;
modelStruct.d_modelPar_TOXP_dX=0.0;
modelStruct.modelPar_given_TOXP=mod.given("TOXP");
modParamMap["TOXP"] = &(modelStruct.d_modelPar_TOXP_dX);
modelStruct.modelPar_EOTBOX=mod.EOTBOX;
modelStruct.d_modelPar_EOTBOX_dX=0.0;
modelStruct.modelPar_given_EOTBOX=mod.given("EOTBOX");
modParamMap["EOTBOX"] = &(modelStruct.d_modelPar_EOTBOX_dX);
modelStruct.modelPar_HFIN=mod.HFIN;
modelStruct.d_modelPar_HFIN_dX=0.0;
modelStruct.modelPar_given_HFIN=mod.given("HFIN");
modParamMap["HFIN"] = &(modelStruct.d_modelPar_HFIN_dX);
modelStruct.modelPar_FECH=mod.FECH;
modelStruct.d_modelPar_FECH_dX=0.0;
modelStruct.modelPar_given_FECH=mod.given("FECH");
modParamMap["FECH"] = &(modelStruct.d_modelPar_FECH_dX);
modelStruct.modelPar_DELTAW=mod.DELTAW;
modelStruct.d_modelPar_DELTAW_dX=0.0;
modelStruct.modelPar_given_DELTAW=mod.given("DELTAW");
modParamMap["DELTAW"] = &(modelStruct.d_modelPar_DELTAW_dX);
modelStruct.modelPar_FECHCV=mod.FECHCV;
modelStruct.d_modelPar_FECHCV_dX=0.0;
modelStruct.modelPar_given_FECHCV=mod.given("FECHCV");
modParamMap["FECHCV"] = &(modelStruct.d_modelPar_FECHCV_dX);
modelStruct.modelPar_DELTAWCV=mod.DELTAWCV;
modelStruct.d_modelPar_DELTAWCV_dX=0.0;
modelStruct.modelPar_given_DELTAWCV=mod.given("DELTAWCV");
modParamMap["DELTAWCV"] = &(modelStruct.d_modelPar_DELTAWCV_dX);
modelStruct.modelPar_NBODY=mod.NBODY;
modelStruct.d_modelPar_NBODY_dX=0.0;
modelStruct.modelPar_given_NBODY=mod.given("NBODY");
modParamMap["NBODY"] = &(modelStruct.d_modelPar_NBODY_dX);
modelStruct.modelPar_NBODYN1=mod.NBODYN1;
modelStruct.d_modelPar_NBODYN1_dX=0.0;
modelStruct.modelPar_given_NBODYN1=mod.given("NBODYN1");
modParamMap["NBODYN1"] = &(modelStruct.d_modelPar_NBODYN1_dX);
modelStruct.modelPar_NBODYN2=mod.NBODYN2;
modelStruct.d_modelPar_NBODYN2_dX=0.0;
modelStruct.modelPar_given_NBODYN2=mod.given("NBODYN2");
modParamMap["NBODYN2"] = &(modelStruct.d_modelPar_NBODYN2_dX);
modelStruct.modelPar_NSD=mod.NSD;
modelStruct.d_modelPar_NSD_dX=0.0;
modelStruct.modelPar_given_NSD=mod.given("NSD");
modParamMap["NSD"] = &(modelStruct.d_modelPar_NSD_dX);
modelStruct.modelPar_PHIG=mod.PHIG;
modelStruct.d_modelPar_PHIG_dX=0.0;
modelStruct.modelPar_given_PHIG=mod.given("PHIG");
modParamMap["PHIG"] = &(modelStruct.d_modelPar_PHIG_dX);
modelStruct.modelPar_PHIGL=mod.PHIGL;
modelStruct.d_modelPar_PHIGL_dX=0.0;
modelStruct.modelPar_given_PHIGL=mod.given("PHIGL");
modParamMap["PHIGL"] = &(modelStruct.d_modelPar_PHIGL_dX);
modelStruct.modelPar_PHIGN1=mod.PHIGN1;
modelStruct.d_modelPar_PHIGN1_dX=0.0;
modelStruct.modelPar_given_PHIGN1=mod.given("PHIGN1");
modParamMap["PHIGN1"] = &(modelStruct.d_modelPar_PHIGN1_dX);
modelStruct.modelPar_PHIGN2=mod.PHIGN2;
modelStruct.d_modelPar_PHIGN2_dX=0.0;
modelStruct.modelPar_given_PHIGN2=mod.given("PHIGN2");
modParamMap["PHIGN2"] = &(modelStruct.d_modelPar_PHIGN2_dX);
modelStruct.modelPar_EPSROX=mod.EPSROX;
modelStruct.d_modelPar_EPSROX_dX=0.0;
modelStruct.modelPar_given_EPSROX=mod.given("EPSROX");
modParamMap["EPSROX"] = &(modelStruct.d_modelPar_EPSROX_dX);
modelStruct.modelPar_EPSRSUB=mod.EPSRSUB;
modelStruct.d_modelPar_EPSRSUB_dX=0.0;
modelStruct.modelPar_given_EPSRSUB=mod.given("EPSRSUB");
modParamMap["EPSRSUB"] = &(modelStruct.d_modelPar_EPSRSUB_dX);
modelStruct.modelPar_EASUB=mod.EASUB;
modelStruct.d_modelPar_EASUB_dX=0.0;
modelStruct.modelPar_given_EASUB=mod.given("EASUB");
modParamMap["EASUB"] = &(modelStruct.d_modelPar_EASUB_dX);
modelStruct.modelPar_NI0SUB=mod.NI0SUB;
modelStruct.d_modelPar_NI0SUB_dX=0.0;
modelStruct.modelPar_given_NI0SUB=mod.given("NI0SUB");
modParamMap["NI0SUB"] = &(modelStruct.d_modelPar_NI0SUB_dX);
modelStruct.modelPar_BG0SUB=mod.BG0SUB;
modelStruct.d_modelPar_BG0SUB_dX=0.0;
modelStruct.modelPar_given_BG0SUB=mod.given("BG0SUB");
modParamMap["BG0SUB"] = &(modelStruct.d_modelPar_BG0SUB_dX);
modelStruct.modelPar_NC0SUB=mod.NC0SUB;
modelStruct.d_modelPar_NC0SUB_dX=0.0;
modelStruct.modelPar_given_NC0SUB=mod.given("NC0SUB");
modParamMap["NC0SUB"] = &(modelStruct.d_modelPar_NC0SUB_dX);
modelStruct.modelPar_NGATE=mod.NGATE;
modelStruct.d_modelPar_NGATE_dX=0.0;
modelStruct.modelPar_given_NGATE=mod.given("NGATE");
modParamMap["NGATE"] = &(modelStruct.d_modelPar_NGATE_dX);
modelStruct.modelPar_Imin=mod.Imin;
modelStruct.d_modelPar_Imin_dX=0.0;
modelStruct.modelPar_given_Imin=mod.given("Imin");
modParamMap["Imin"] = &(modelStruct.d_modelPar_Imin_dX);
modelStruct.modelPar_CIT=mod.CIT;
modelStruct.d_modelPar_CIT_dX=0.0;
modelStruct.modelPar_given_CIT=mod.given("CIT");
modParamMap["CIT"] = &(modelStruct.d_modelPar_CIT_dX);
modelStruct.modelPar_CDSC=mod.CDSC;
modelStruct.d_modelPar_CDSC_dX=0.0;
modelStruct.modelPar_given_CDSC=mod.given("CDSC");
modParamMap["CDSC"] = &(modelStruct.d_modelPar_CDSC_dX);
modelStruct.modelPar_CDSCN1=mod.CDSCN1;
modelStruct.d_modelPar_CDSCN1_dX=0.0;
modelStruct.modelPar_given_CDSCN1=mod.given("CDSCN1");
modParamMap["CDSCN1"] = &(modelStruct.d_modelPar_CDSCN1_dX);
modelStruct.modelPar_CDSCN2=mod.CDSCN2;
modelStruct.d_modelPar_CDSCN2_dX=0.0;
modelStruct.modelPar_given_CDSCN2=mod.given("CDSCN2");
modParamMap["CDSCN2"] = &(modelStruct.d_modelPar_CDSCN2_dX);
modelStruct.modelPar_CDSCD=mod.CDSCD;
modelStruct.d_modelPar_CDSCD_dX=0.0;
modelStruct.modelPar_given_CDSCD=mod.given("CDSCD");
modParamMap["CDSCD"] = &(modelStruct.d_modelPar_CDSCD_dX);
modelStruct.modelPar_CDSCDN1=mod.CDSCDN1;
modelStruct.d_modelPar_CDSCDN1_dX=0.0;
modelStruct.modelPar_given_CDSCDN1=mod.given("CDSCDN1");
modParamMap["CDSCDN1"] = &(modelStruct.d_modelPar_CDSCDN1_dX);
modelStruct.modelPar_CDSCDN2=mod.CDSCDN2;
modelStruct.d_modelPar_CDSCDN2_dX=0.0;
modelStruct.modelPar_given_CDSCDN2=mod.given("CDSCDN2");
modParamMap["CDSCDN2"] = &(modelStruct.d_modelPar_CDSCDN2_dX);
modelStruct.modelPar_CDSCDR=mod.CDSCDR;
modelStruct.d_modelPar_CDSCDR_dX=0.0;
modelStruct.modelPar_given_CDSCDR=mod.given("CDSCDR");
modParamMap["CDSCDR"] = &(modelStruct.d_modelPar_CDSCDR_dX);
modelStruct.modelPar_CDSCDRN1=mod.CDSCDRN1;
modelStruct.d_modelPar_CDSCDRN1_dX=0.0;
modelStruct.modelPar_given_CDSCDRN1=mod.given("CDSCDRN1");
modParamMap["CDSCDRN1"] = &(modelStruct.d_modelPar_CDSCDRN1_dX);
modelStruct.modelPar_CDSCDRN2=mod.CDSCDRN2;
modelStruct.d_modelPar_CDSCDRN2_dX=0.0;
modelStruct.modelPar_given_CDSCDRN2=mod.given("CDSCDRN2");
modParamMap["CDSCDRN2"] = &(modelStruct.d_modelPar_CDSCDRN2_dX);
modelStruct.modelPar_DVT0=mod.DVT0;
modelStruct.d_modelPar_DVT0_dX=0.0;
modelStruct.modelPar_given_DVT0=mod.given("DVT0");
modParamMap["DVT0"] = &(modelStruct.d_modelPar_DVT0_dX);
modelStruct.modelPar_DVT1=mod.DVT1;
modelStruct.d_modelPar_DVT1_dX=0.0;
modelStruct.modelPar_given_DVT1=mod.given("DVT1");
modParamMap["DVT1"] = &(modelStruct.d_modelPar_DVT1_dX);
modelStruct.modelPar_DVT1SS=mod.DVT1SS;
modelStruct.d_modelPar_DVT1SS_dX=0.0;
modelStruct.modelPar_given_DVT1SS=mod.given("DVT1SS");
modParamMap["DVT1SS"] = &(modelStruct.d_modelPar_DVT1SS_dX);
modelStruct.modelPar_PHIN=mod.PHIN;
modelStruct.d_modelPar_PHIN_dX=0.0;
modelStruct.modelPar_given_PHIN=mod.given("PHIN");
modParamMap["PHIN"] = &(modelStruct.d_modelPar_PHIN_dX);
modelStruct.modelPar_ETA0=mod.ETA0;
modelStruct.d_modelPar_ETA0_dX=0.0;
modelStruct.modelPar_given_ETA0=mod.given("ETA0");
modParamMap["ETA0"] = &(modelStruct.d_modelPar_ETA0_dX);
modelStruct.modelPar_ETA0N1=mod.ETA0N1;
modelStruct.d_modelPar_ETA0N1_dX=0.0;
modelStruct.modelPar_given_ETA0N1=mod.given("ETA0N1");
modParamMap["ETA0N1"] = &(modelStruct.d_modelPar_ETA0N1_dX);
modelStruct.modelPar_ETA0N2=mod.ETA0N2;
modelStruct.d_modelPar_ETA0N2_dX=0.0;
modelStruct.modelPar_given_ETA0N2=mod.given("ETA0N2");
modParamMap["ETA0N2"] = &(modelStruct.d_modelPar_ETA0N2_dX);
modelStruct.modelPar_TETA0=mod.TETA0;
modelStruct.d_modelPar_TETA0_dX=0.0;
modelStruct.modelPar_given_TETA0=mod.given("TETA0");
modParamMap["TETA0"] = &(modelStruct.d_modelPar_TETA0_dX);
modelStruct.modelPar_ETA0R=mod.ETA0R;
modelStruct.d_modelPar_ETA0R_dX=0.0;
modelStruct.modelPar_given_ETA0R=mod.given("ETA0R");
modParamMap["ETA0R"] = &(modelStruct.d_modelPar_ETA0R_dX);
modelStruct.modelPar_TETA0R=mod.TETA0R;
modelStruct.d_modelPar_TETA0R_dX=0.0;
modelStruct.modelPar_given_TETA0R=mod.given("TETA0R");
modParamMap["TETA0R"] = &(modelStruct.d_modelPar_TETA0R_dX);
modelStruct.modelPar_DSUB=mod.DSUB;
modelStruct.d_modelPar_DSUB_dX=0.0;
modelStruct.modelPar_given_DSUB=mod.given("DSUB");
modParamMap["DSUB"] = &(modelStruct.d_modelPar_DSUB_dX);
modelStruct.modelPar_DVTP0=mod.DVTP0;
modelStruct.d_modelPar_DVTP0_dX=0.0;
modelStruct.modelPar_given_DVTP0=mod.given("DVTP0");
modParamMap["DVTP0"] = &(modelStruct.d_modelPar_DVTP0_dX);
modelStruct.modelPar_DVTP1=mod.DVTP1;
modelStruct.d_modelPar_DVTP1_dX=0.0;
modelStruct.modelPar_given_DVTP1=mod.given("DVTP1");
modParamMap["DVTP1"] = &(modelStruct.d_modelPar_DVTP1_dX);
modelStruct.modelPar_K1RSCE=mod.K1RSCE;
modelStruct.d_modelPar_K1RSCE_dX=0.0;
modelStruct.modelPar_given_K1RSCE=mod.given("K1RSCE");
modParamMap["K1RSCE"] = &(modelStruct.d_modelPar_K1RSCE_dX);
modelStruct.modelPar_LPE0=mod.LPE0;
modelStruct.d_modelPar_LPE0_dX=0.0;
modelStruct.modelPar_given_LPE0=mod.given("LPE0");
modParamMap["LPE0"] = &(modelStruct.d_modelPar_LPE0_dX);
modelStruct.modelPar_DVTSHIFT=mod.DVTSHIFT;
modelStruct.d_modelPar_DVTSHIFT_dX=0.0;
modelStruct.modelPar_given_DVTSHIFT=mod.given("DVTSHIFT");
modParamMap["DVTSHIFT"] = &(modelStruct.d_modelPar_DVTSHIFT_dX);
modelStruct.modelPar_K0=mod.K0;
modelStruct.d_modelPar_K0_dX=0.0;
modelStruct.modelPar_given_K0=mod.given("K0");
modParamMap["K0"] = &(modelStruct.d_modelPar_K0_dX);
modelStruct.modelPar_K01=mod.K01;
modelStruct.d_modelPar_K01_dX=0.0;
modelStruct.modelPar_given_K01=mod.given("K01");
modParamMap["K01"] = &(modelStruct.d_modelPar_K01_dX);
modelStruct.modelPar_K0SI=mod.K0SI;
modelStruct.d_modelPar_K0SI_dX=0.0;
modelStruct.modelPar_given_K0SI=mod.given("K0SI");
modParamMap["K0SI"] = &(modelStruct.d_modelPar_K0SI_dX);
modelStruct.modelPar_K0SI1=mod.K0SI1;
modelStruct.d_modelPar_K0SI1_dX=0.0;
modelStruct.modelPar_given_K0SI1=mod.given("K0SI1");
modParamMap["K0SI1"] = &(modelStruct.d_modelPar_K0SI1_dX);
modelStruct.modelPar_K1SI=mod.K1SI;
modelStruct.d_modelPar_K1SI_dX=0.0;
modelStruct.modelPar_given_K1SI=mod.given("K1SI");
modParamMap["K1SI"] = &(modelStruct.d_modelPar_K1SI_dX);
modelStruct.modelPar_K1SI1=mod.K1SI1;
modelStruct.d_modelPar_K1SI1_dX=0.0;
modelStruct.modelPar_given_K1SI1=mod.given("K1SI1");
modParamMap["K1SI1"] = &(modelStruct.d_modelPar_K1SI1_dX);
modelStruct.modelPar_PHIBE=mod.PHIBE;
modelStruct.d_modelPar_PHIBE_dX=0.0;
modelStruct.modelPar_given_PHIBE=mod.given("PHIBE");
modParamMap["PHIBE"] = &(modelStruct.d_modelPar_PHIBE_dX);
modelStruct.modelPar_K1=mod.K1;
modelStruct.d_modelPar_K1_dX=0.0;
modelStruct.modelPar_given_K1=mod.given("K1");
modParamMap["K1"] = &(modelStruct.d_modelPar_K1_dX);
modelStruct.modelPar_K11=mod.K11;
modelStruct.d_modelPar_K11_dX=0.0;
modelStruct.modelPar_given_K11=mod.given("K11");
modParamMap["K11"] = &(modelStruct.d_modelPar_K11_dX);
modelStruct.modelPar_K1SAT=mod.K1SAT;
modelStruct.d_modelPar_K1SAT_dX=0.0;
modelStruct.modelPar_given_K1SAT=mod.given("K1SAT");
modParamMap["K1SAT"] = &(modelStruct.d_modelPar_K1SAT_dX);
modelStruct.modelPar_K1SAT1=mod.K1SAT1;
modelStruct.d_modelPar_K1SAT1_dX=0.0;
modelStruct.modelPar_given_K1SAT1=mod.given("K1SAT1");
modParamMap["K1SAT1"] = &(modelStruct.d_modelPar_K1SAT1_dX);
modelStruct.modelPar_QMFACTOR=mod.QMFACTOR;
modelStruct.d_modelPar_QMFACTOR_dX=0.0;
modelStruct.modelPar_given_QMFACTOR=mod.given("QMFACTOR");
modParamMap["QMFACTOR"] = &(modelStruct.d_modelPar_QMFACTOR_dX);
modelStruct.modelPar_QMTCENIV=mod.QMTCENIV;
modelStruct.d_modelPar_QMTCENIV_dX=0.0;
modelStruct.modelPar_given_QMTCENIV=mod.given("QMTCENIV");
modParamMap["QMTCENIV"] = &(modelStruct.d_modelPar_QMTCENIV_dX);
modelStruct.modelPar_QMTCENCV=mod.QMTCENCV;
modelStruct.d_modelPar_QMTCENCV_dX=0.0;
modelStruct.modelPar_given_QMTCENCV=mod.given("QMTCENCV");
modParamMap["QMTCENCV"] = &(modelStruct.d_modelPar_QMTCENCV_dX);
modelStruct.modelPar_QMTCENCVA=mod.QMTCENCVA;
modelStruct.d_modelPar_QMTCENCVA_dX=0.0;
modelStruct.modelPar_given_QMTCENCVA=mod.given("QMTCENCVA");
modParamMap["QMTCENCVA"] = &(modelStruct.d_modelPar_QMTCENCVA_dX);
modelStruct.modelPar_AQMTCEN=mod.AQMTCEN;
modelStruct.d_modelPar_AQMTCEN_dX=0.0;
modelStruct.modelPar_given_AQMTCEN=mod.given("AQMTCEN");
modParamMap["AQMTCEN"] = &(modelStruct.d_modelPar_AQMTCEN_dX);
modelStruct.modelPar_BQMTCEN=mod.BQMTCEN;
modelStruct.d_modelPar_BQMTCEN_dX=0.0;
modelStruct.modelPar_given_BQMTCEN=mod.given("BQMTCEN");
modParamMap["BQMTCEN"] = &(modelStruct.d_modelPar_BQMTCEN_dX);
modelStruct.modelPar_ETAQM=mod.ETAQM;
modelStruct.d_modelPar_ETAQM_dX=0.0;
modelStruct.modelPar_given_ETAQM=mod.given("ETAQM");
modParamMap["ETAQM"] = &(modelStruct.d_modelPar_ETAQM_dX);
modelStruct.modelPar_QM0=mod.QM0;
modelStruct.d_modelPar_QM0_dX=0.0;
modelStruct.modelPar_given_QM0=mod.given("QM0");
modParamMap["QM0"] = &(modelStruct.d_modelPar_QM0_dX);
modelStruct.modelPar_PQM=mod.PQM;
modelStruct.d_modelPar_PQM_dX=0.0;
modelStruct.modelPar_given_PQM=mod.given("PQM");
modParamMap["PQM"] = &(modelStruct.d_modelPar_PQM_dX);
modelStruct.modelPar_QM0ACC=mod.QM0ACC;
modelStruct.d_modelPar_QM0ACC_dX=0.0;
modelStruct.modelPar_given_QM0ACC=mod.given("QM0ACC");
modParamMap["QM0ACC"] = &(modelStruct.d_modelPar_QM0ACC_dX);
modelStruct.modelPar_PQMACC=mod.PQMACC;
modelStruct.d_modelPar_PQMACC_dX=0.0;
modelStruct.modelPar_given_PQMACC=mod.given("PQMACC");
modParamMap["PQMACC"] = &(modelStruct.d_modelPar_PQMACC_dX);
modelStruct.modelPar_VSAT=mod.VSAT;
modelStruct.d_modelPar_VSAT_dX=0.0;
modelStruct.modelPar_given_VSAT=mod.given("VSAT");
modParamMap["VSAT"] = &(modelStruct.d_modelPar_VSAT_dX);
modelStruct.modelPar_VSATN1=mod.VSATN1;
modelStruct.d_modelPar_VSATN1_dX=0.0;
modelStruct.modelPar_given_VSATN1=mod.given("VSATN1");
modParamMap["VSATN1"] = &(modelStruct.d_modelPar_VSATN1_dX);
modelStruct.modelPar_VSATN2=mod.VSATN2;
modelStruct.d_modelPar_VSATN2_dX=0.0;
modelStruct.modelPar_given_VSATN2=mod.given("VSATN2");
modParamMap["VSATN2"] = &(modelStruct.d_modelPar_VSATN2_dX);
modelStruct.modelPar_AVSAT=mod.AVSAT;
modelStruct.d_modelPar_AVSAT_dX=0.0;
modelStruct.modelPar_given_AVSAT=mod.given("AVSAT");
modParamMap["AVSAT"] = &(modelStruct.d_modelPar_AVSAT_dX);
modelStruct.modelPar_BVSAT=mod.BVSAT;
modelStruct.d_modelPar_BVSAT_dX=0.0;
modelStruct.modelPar_given_BVSAT=mod.given("BVSAT");
modParamMap["BVSAT"] = &(modelStruct.d_modelPar_BVSAT_dX);
modelStruct.modelPar_VSAT1=mod.VSAT1;
modelStruct.d_modelPar_VSAT1_dX=0.0;
modelStruct.modelPar_given_VSAT1=mod.given("VSAT1");
modParamMap["VSAT1"] = &(modelStruct.d_modelPar_VSAT1_dX);
modelStruct.modelPar_VSAT1N1=mod.VSAT1N1;
modelStruct.d_modelPar_VSAT1N1_dX=0.0;
modelStruct.modelPar_given_VSAT1N1=mod.given("VSAT1N1");
modParamMap["VSAT1N1"] = &(modelStruct.d_modelPar_VSAT1N1_dX);
modelStruct.modelPar_VSAT1N2=mod.VSAT1N2;
modelStruct.d_modelPar_VSAT1N2_dX=0.0;
modelStruct.modelPar_given_VSAT1N2=mod.given("VSAT1N2");
modParamMap["VSAT1N2"] = &(modelStruct.d_modelPar_VSAT1N2_dX);
modelStruct.modelPar_VSAT1R=mod.VSAT1R;
modelStruct.d_modelPar_VSAT1R_dX=0.0;
modelStruct.modelPar_given_VSAT1R=mod.given("VSAT1R");
modParamMap["VSAT1R"] = &(modelStruct.d_modelPar_VSAT1R_dX);
modelStruct.modelPar_VSAT1RN1=mod.VSAT1RN1;
modelStruct.d_modelPar_VSAT1RN1_dX=0.0;
modelStruct.modelPar_given_VSAT1RN1=mod.given("VSAT1RN1");
modParamMap["VSAT1RN1"] = &(modelStruct.d_modelPar_VSAT1RN1_dX);
modelStruct.modelPar_VSAT1RN2=mod.VSAT1RN2;
modelStruct.d_modelPar_VSAT1RN2_dX=0.0;
modelStruct.modelPar_given_VSAT1RN2=mod.given("VSAT1RN2");
modParamMap["VSAT1RN2"] = &(modelStruct.d_modelPar_VSAT1RN2_dX);
modelStruct.modelPar_AVSAT1=mod.AVSAT1;
modelStruct.d_modelPar_AVSAT1_dX=0.0;
modelStruct.modelPar_given_AVSAT1=mod.given("AVSAT1");
modParamMap["AVSAT1"] = &(modelStruct.d_modelPar_AVSAT1_dX);
modelStruct.modelPar_BVSAT1=mod.BVSAT1;
modelStruct.d_modelPar_BVSAT1_dX=0.0;
modelStruct.modelPar_given_BVSAT1=mod.given("BVSAT1");
modParamMap["BVSAT1"] = &(modelStruct.d_modelPar_BVSAT1_dX);
modelStruct.modelPar_DELTAVSAT=mod.DELTAVSAT;
modelStruct.d_modelPar_DELTAVSAT_dX=0.0;
modelStruct.modelPar_given_DELTAVSAT=mod.given("DELTAVSAT");
modParamMap["DELTAVSAT"] = &(modelStruct.d_modelPar_DELTAVSAT_dX);
modelStruct.modelPar_PSAT=mod.PSAT;
modelStruct.d_modelPar_PSAT_dX=0.0;
modelStruct.modelPar_given_PSAT=mod.given("PSAT");
modParamMap["PSAT"] = &(modelStruct.d_modelPar_PSAT_dX);
modelStruct.modelPar_APSAT=mod.APSAT;
modelStruct.d_modelPar_APSAT_dX=0.0;
modelStruct.modelPar_given_APSAT=mod.given("APSAT");
modParamMap["APSAT"] = &(modelStruct.d_modelPar_APSAT_dX);
modelStruct.modelPar_BPSAT=mod.BPSAT;
modelStruct.d_modelPar_BPSAT_dX=0.0;
modelStruct.modelPar_given_BPSAT=mod.given("BPSAT");
modParamMap["BPSAT"] = &(modelStruct.d_modelPar_BPSAT_dX);
modelStruct.modelPar_KSATIV=mod.KSATIV;
modelStruct.d_modelPar_KSATIV_dX=0.0;
modelStruct.modelPar_given_KSATIV=mod.given("KSATIV");
modParamMap["KSATIV"] = &(modelStruct.d_modelPar_KSATIV_dX);
modelStruct.modelPar_VSATCV=mod.VSATCV;
modelStruct.d_modelPar_VSATCV_dX=0.0;
modelStruct.modelPar_given_VSATCV=mod.given("VSATCV");
modParamMap["VSATCV"] = &(modelStruct.d_modelPar_VSATCV_dX);
modelStruct.modelPar_AVSATCV=mod.AVSATCV;
modelStruct.d_modelPar_AVSATCV_dX=0.0;
modelStruct.modelPar_given_AVSATCV=mod.given("AVSATCV");
modParamMap["AVSATCV"] = &(modelStruct.d_modelPar_AVSATCV_dX);
modelStruct.modelPar_BVSATCV=mod.BVSATCV;
modelStruct.d_modelPar_BVSATCV_dX=0.0;
modelStruct.modelPar_given_BVSATCV=mod.given("BVSATCV");
modParamMap["BVSATCV"] = &(modelStruct.d_modelPar_BVSATCV_dX);
modelStruct.modelPar_DELTAVSATCV=mod.DELTAVSATCV;
modelStruct.d_modelPar_DELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_DELTAVSATCV=mod.given("DELTAVSATCV");
modParamMap["DELTAVSATCV"] = &(modelStruct.d_modelPar_DELTAVSATCV_dX);
modelStruct.modelPar_PSATCV=mod.PSATCV;
modelStruct.d_modelPar_PSATCV_dX=0.0;
modelStruct.modelPar_given_PSATCV=mod.given("PSATCV");
modParamMap["PSATCV"] = &(modelStruct.d_modelPar_PSATCV_dX);
modelStruct.modelPar_APSATCV=mod.APSATCV;
modelStruct.d_modelPar_APSATCV_dX=0.0;
modelStruct.modelPar_given_APSATCV=mod.given("APSATCV");
modParamMap["APSATCV"] = &(modelStruct.d_modelPar_APSATCV_dX);
modelStruct.modelPar_BPSATCV=mod.BPSATCV;
modelStruct.d_modelPar_BPSATCV_dX=0.0;
modelStruct.modelPar_given_BPSATCV=mod.given("BPSATCV");
modParamMap["BPSATCV"] = &(modelStruct.d_modelPar_BPSATCV_dX);
modelStruct.modelPar_MEXP=mod.MEXP;
modelStruct.d_modelPar_MEXP_dX=0.0;
modelStruct.modelPar_given_MEXP=mod.given("MEXP");
modParamMap["MEXP"] = &(modelStruct.d_modelPar_MEXP_dX);
modelStruct.modelPar_AMEXP=mod.AMEXP;
modelStruct.d_modelPar_AMEXP_dX=0.0;
modelStruct.modelPar_given_AMEXP=mod.given("AMEXP");
modParamMap["AMEXP"] = &(modelStruct.d_modelPar_AMEXP_dX);
modelStruct.modelPar_BMEXP=mod.BMEXP;
modelStruct.d_modelPar_BMEXP_dX=0.0;
modelStruct.modelPar_given_BMEXP=mod.given("BMEXP");
modParamMap["BMEXP"] = &(modelStruct.d_modelPar_BMEXP_dX);
modelStruct.modelPar_MEXPR=mod.MEXPR;
modelStruct.d_modelPar_MEXPR_dX=0.0;
modelStruct.modelPar_given_MEXPR=mod.given("MEXPR");
modParamMap["MEXPR"] = &(modelStruct.d_modelPar_MEXPR_dX);
modelStruct.modelPar_AMEXPR=mod.AMEXPR;
modelStruct.d_modelPar_AMEXPR_dX=0.0;
modelStruct.modelPar_given_AMEXPR=mod.given("AMEXPR");
modParamMap["AMEXPR"] = &(modelStruct.d_modelPar_AMEXPR_dX);
modelStruct.modelPar_BMEXPR=mod.BMEXPR;
modelStruct.d_modelPar_BMEXPR_dX=0.0;
modelStruct.modelPar_given_BMEXPR=mod.given("BMEXPR");
modParamMap["BMEXPR"] = &(modelStruct.d_modelPar_BMEXPR_dX);
modelStruct.modelPar_PTWG=mod.PTWG;
modelStruct.d_modelPar_PTWG_dX=0.0;
modelStruct.modelPar_given_PTWG=mod.given("PTWG");
modParamMap["PTWG"] = &(modelStruct.d_modelPar_PTWG_dX);
modelStruct.modelPar_PTWGR=mod.PTWGR;
modelStruct.d_modelPar_PTWGR_dX=0.0;
modelStruct.modelPar_given_PTWGR=mod.given("PTWGR");
modParamMap["PTWGR"] = &(modelStruct.d_modelPar_PTWGR_dX);
modelStruct.modelPar_APTWG=mod.APTWG;
modelStruct.d_modelPar_APTWG_dX=0.0;
modelStruct.modelPar_given_APTWG=mod.given("APTWG");
modParamMap["APTWG"] = &(modelStruct.d_modelPar_APTWG_dX);
modelStruct.modelPar_BPTWG=mod.BPTWG;
modelStruct.d_modelPar_BPTWG_dX=0.0;
modelStruct.modelPar_given_BPTWG=mod.given("BPTWG");
modParamMap["BPTWG"] = &(modelStruct.d_modelPar_BPTWG_dX);
modelStruct.modelPar_AT=mod.AT;
modelStruct.d_modelPar_AT_dX=0.0;
modelStruct.modelPar_given_AT=mod.given("AT");
modParamMap["AT"] = &(modelStruct.d_modelPar_AT_dX);
modelStruct.modelPar_TMEXP=mod.TMEXP;
modelStruct.d_modelPar_TMEXP_dX=0.0;
modelStruct.modelPar_given_TMEXP=mod.given("TMEXP");
modParamMap["TMEXP"] = &(modelStruct.d_modelPar_TMEXP_dX);
modelStruct.modelPar_TMEXPR=mod.TMEXPR;
modelStruct.d_modelPar_TMEXPR_dX=0.0;
modelStruct.modelPar_given_TMEXPR=mod.given("TMEXPR");
modParamMap["TMEXPR"] = &(modelStruct.d_modelPar_TMEXPR_dX);
modelStruct.modelPar_PTWGT=mod.PTWGT;
modelStruct.d_modelPar_PTWGT_dX=0.0;
modelStruct.modelPar_given_PTWGT=mod.given("PTWGT");
modParamMap["PTWGT"] = &(modelStruct.d_modelPar_PTWGT_dX);
modelStruct.modelPar_U0=mod.U0;
modelStruct.d_modelPar_U0_dX=0.0;
modelStruct.modelPar_given_U0=mod.given("U0");
modParamMap["U0"] = &(modelStruct.d_modelPar_U0_dX);
modelStruct.modelPar_U0N1=mod.U0N1;
modelStruct.d_modelPar_U0N1_dX=0.0;
modelStruct.modelPar_given_U0N1=mod.given("U0N1");
modParamMap["U0N1"] = &(modelStruct.d_modelPar_U0N1_dX);
modelStruct.modelPar_U0N2=mod.U0N2;
modelStruct.d_modelPar_U0N2_dX=0.0;
modelStruct.modelPar_given_U0N2=mod.given("U0N2");
modParamMap["U0N2"] = &(modelStruct.d_modelPar_U0N2_dX);
modelStruct.modelPar_ETAMOB=mod.ETAMOB;
modelStruct.d_modelPar_ETAMOB_dX=0.0;
modelStruct.modelPar_given_ETAMOB=mod.given("ETAMOB");
modParamMap["ETAMOB"] = &(modelStruct.d_modelPar_ETAMOB_dX);
modelStruct.modelPar_UP=mod.UP;
modelStruct.d_modelPar_UP_dX=0.0;
modelStruct.modelPar_given_UP=mod.given("UP");
modParamMap["UP"] = &(modelStruct.d_modelPar_UP_dX);
modelStruct.modelPar_LPA=mod.LPA;
modelStruct.d_modelPar_LPA_dX=0.0;
modelStruct.modelPar_given_LPA=mod.given("LPA");
modParamMap["LPA"] = &(modelStruct.d_modelPar_LPA_dX);
modelStruct.modelPar_UA=mod.UA;
modelStruct.d_modelPar_UA_dX=0.0;
modelStruct.modelPar_given_UA=mod.given("UA");
modParamMap["UA"] = &(modelStruct.d_modelPar_UA_dX);
modelStruct.modelPar_AUA=mod.AUA;
modelStruct.d_modelPar_AUA_dX=0.0;
modelStruct.modelPar_given_AUA=mod.given("AUA");
modParamMap["AUA"] = &(modelStruct.d_modelPar_AUA_dX);
modelStruct.modelPar_BUA=mod.BUA;
modelStruct.d_modelPar_BUA_dX=0.0;
modelStruct.modelPar_given_BUA=mod.given("BUA");
modParamMap["BUA"] = &(modelStruct.d_modelPar_BUA_dX);
modelStruct.modelPar_UC=mod.UC;
modelStruct.d_modelPar_UC_dX=0.0;
modelStruct.modelPar_given_UC=mod.given("UC");
modParamMap["UC"] = &(modelStruct.d_modelPar_UC_dX);
modelStruct.modelPar_EU=mod.EU;
modelStruct.d_modelPar_EU_dX=0.0;
modelStruct.modelPar_given_EU=mod.given("EU");
modParamMap["EU"] = &(modelStruct.d_modelPar_EU_dX);
modelStruct.modelPar_AEU=mod.AEU;
modelStruct.d_modelPar_AEU_dX=0.0;
modelStruct.modelPar_given_AEU=mod.given("AEU");
modParamMap["AEU"] = &(modelStruct.d_modelPar_AEU_dX);
modelStruct.modelPar_BEU=mod.BEU;
modelStruct.d_modelPar_BEU_dX=0.0;
modelStruct.modelPar_given_BEU=mod.given("BEU");
modParamMap["BEU"] = &(modelStruct.d_modelPar_BEU_dX);
modelStruct.modelPar_UD=mod.UD;
modelStruct.d_modelPar_UD_dX=0.0;
modelStruct.modelPar_given_UD=mod.given("UD");
modParamMap["UD"] = &(modelStruct.d_modelPar_UD_dX);
modelStruct.modelPar_AUD=mod.AUD;
modelStruct.d_modelPar_AUD_dX=0.0;
modelStruct.modelPar_given_AUD=mod.given("AUD");
modParamMap["AUD"] = &(modelStruct.d_modelPar_AUD_dX);
modelStruct.modelPar_BUD=mod.BUD;
modelStruct.d_modelPar_BUD_dX=0.0;
modelStruct.modelPar_given_BUD=mod.given("BUD");
modParamMap["BUD"] = &(modelStruct.d_modelPar_BUD_dX);
modelStruct.modelPar_UCS=mod.UCS;
modelStruct.d_modelPar_UCS_dX=0.0;
modelStruct.modelPar_given_UCS=mod.given("UCS");
modParamMap["UCS"] = &(modelStruct.d_modelPar_UCS_dX);
modelStruct.modelPar_UTE=mod.UTE;
modelStruct.d_modelPar_UTE_dX=0.0;
modelStruct.modelPar_given_UTE=mod.given("UTE");
modParamMap["UTE"] = &(modelStruct.d_modelPar_UTE_dX);
modelStruct.modelPar_UTL=mod.UTL;
modelStruct.d_modelPar_UTL_dX=0.0;
modelStruct.modelPar_given_UTL=mod.given("UTL");
modParamMap["UTL"] = &(modelStruct.d_modelPar_UTL_dX);
modelStruct.modelPar_EMOBT=mod.EMOBT;
modelStruct.d_modelPar_EMOBT_dX=0.0;
modelStruct.modelPar_given_EMOBT=mod.given("EMOBT");
modParamMap["EMOBT"] = &(modelStruct.d_modelPar_EMOBT_dX);
modelStruct.modelPar_UA1=mod.UA1;
modelStruct.d_modelPar_UA1_dX=0.0;
modelStruct.modelPar_given_UA1=mod.given("UA1");
modParamMap["UA1"] = &(modelStruct.d_modelPar_UA1_dX);
modelStruct.modelPar_UC1=mod.UC1;
modelStruct.d_modelPar_UC1_dX=0.0;
modelStruct.modelPar_given_UC1=mod.given("UC1");
modParamMap["UC1"] = &(modelStruct.d_modelPar_UC1_dX);
modelStruct.modelPar_UD1=mod.UD1;
modelStruct.d_modelPar_UD1_dX=0.0;
modelStruct.modelPar_given_UD1=mod.given("UD1");
modParamMap["UD1"] = &(modelStruct.d_modelPar_UD1_dX);
modelStruct.modelPar_UCSTE=mod.UCSTE;
modelStruct.d_modelPar_UCSTE_dX=0.0;
modelStruct.modelPar_given_UCSTE=mod.given("UCSTE");
modParamMap["UCSTE"] = &(modelStruct.d_modelPar_UCSTE_dX);
modelStruct.modelPar_CHARGEWF=mod.CHARGEWF;
modelStruct.d_modelPar_CHARGEWF_dX=0.0;
modelStruct.modelPar_given_CHARGEWF=mod.given("CHARGEWF");
modParamMap["CHARGEWF"] = &(modelStruct.d_modelPar_CHARGEWF_dX);
modelStruct.modelPar_RDSWMIN=mod.RDSWMIN;
modelStruct.d_modelPar_RDSWMIN_dX=0.0;
modelStruct.modelPar_given_RDSWMIN=mod.given("RDSWMIN");
modParamMap["RDSWMIN"] = &(modelStruct.d_modelPar_RDSWMIN_dX);
modelStruct.modelPar_RDSW=mod.RDSW;
modelStruct.d_modelPar_RDSW_dX=0.0;
modelStruct.modelPar_given_RDSW=mod.given("RDSW");
modParamMap["RDSW"] = &(modelStruct.d_modelPar_RDSW_dX);
modelStruct.modelPar_ARDSW=mod.ARDSW;
modelStruct.d_modelPar_ARDSW_dX=0.0;
modelStruct.modelPar_given_ARDSW=mod.given("ARDSW");
modParamMap["ARDSW"] = &(modelStruct.d_modelPar_ARDSW_dX);
modelStruct.modelPar_BRDSW=mod.BRDSW;
modelStruct.d_modelPar_BRDSW_dX=0.0;
modelStruct.modelPar_given_BRDSW=mod.given("BRDSW");
modParamMap["BRDSW"] = &(modelStruct.d_modelPar_BRDSW_dX);
modelStruct.modelPar_RSWMIN=mod.RSWMIN;
modelStruct.d_modelPar_RSWMIN_dX=0.0;
modelStruct.modelPar_given_RSWMIN=mod.given("RSWMIN");
modParamMap["RSWMIN"] = &(modelStruct.d_modelPar_RSWMIN_dX);
modelStruct.modelPar_RSW=mod.RSW;
modelStruct.d_modelPar_RSW_dX=0.0;
modelStruct.modelPar_given_RSW=mod.given("RSW");
modParamMap["RSW"] = &(modelStruct.d_modelPar_RSW_dX);
modelStruct.modelPar_ARSW=mod.ARSW;
modelStruct.d_modelPar_ARSW_dX=0.0;
modelStruct.modelPar_given_ARSW=mod.given("ARSW");
modParamMap["ARSW"] = &(modelStruct.d_modelPar_ARSW_dX);
modelStruct.modelPar_BRSW=mod.BRSW;
modelStruct.d_modelPar_BRSW_dX=0.0;
modelStruct.modelPar_given_BRSW=mod.given("BRSW");
modParamMap["BRSW"] = &(modelStruct.d_modelPar_BRSW_dX);
modelStruct.modelPar_RDWMIN=mod.RDWMIN;
modelStruct.d_modelPar_RDWMIN_dX=0.0;
modelStruct.modelPar_given_RDWMIN=mod.given("RDWMIN");
modParamMap["RDWMIN"] = &(modelStruct.d_modelPar_RDWMIN_dX);
modelStruct.modelPar_RDW=mod.RDW;
modelStruct.d_modelPar_RDW_dX=0.0;
modelStruct.modelPar_given_RDW=mod.given("RDW");
modParamMap["RDW"] = &(modelStruct.d_modelPar_RDW_dX);
modelStruct.modelPar_ARDW=mod.ARDW;
modelStruct.d_modelPar_ARDW_dX=0.0;
modelStruct.modelPar_given_ARDW=mod.given("ARDW");
modParamMap["ARDW"] = &(modelStruct.d_modelPar_ARDW_dX);
modelStruct.modelPar_BRDW=mod.BRDW;
modelStruct.d_modelPar_BRDW_dX=0.0;
modelStruct.modelPar_given_BRDW=mod.given("BRDW");
modParamMap["BRDW"] = &(modelStruct.d_modelPar_BRDW_dX);
modelStruct.modelPar_RSDR=mod.RSDR;
modelStruct.d_modelPar_RSDR_dX=0.0;
modelStruct.modelPar_given_RSDR=mod.given("RSDR");
modParamMap["RSDR"] = &(modelStruct.d_modelPar_RSDR_dX);
modelStruct.modelPar_RSDRR=mod.RSDRR;
modelStruct.d_modelPar_RSDRR_dX=0.0;
modelStruct.modelPar_given_RSDRR=mod.given("RSDRR");
modParamMap["RSDRR"] = &(modelStruct.d_modelPar_RSDRR_dX);
modelStruct.modelPar_RDDR=mod.RDDR;
modelStruct.d_modelPar_RDDR_dX=0.0;
modelStruct.modelPar_given_RDDR=mod.given("RDDR");
modParamMap["RDDR"] = &(modelStruct.d_modelPar_RDDR_dX);
modelStruct.modelPar_RDDRR=mod.RDDRR;
modelStruct.d_modelPar_RDDRR_dX=0.0;
modelStruct.modelPar_given_RDDRR=mod.given("RDDRR");
modParamMap["RDDRR"] = &(modelStruct.d_modelPar_RDDRR_dX);
modelStruct.modelPar_PRSDR=mod.PRSDR;
modelStruct.d_modelPar_PRSDR_dX=0.0;
modelStruct.modelPar_given_PRSDR=mod.given("PRSDR");
modParamMap["PRSDR"] = &(modelStruct.d_modelPar_PRSDR_dX);
modelStruct.modelPar_PRDDR=mod.PRDDR;
modelStruct.d_modelPar_PRDDR_dX=0.0;
modelStruct.modelPar_given_PRDDR=mod.given("PRDDR");
modParamMap["PRDDR"] = &(modelStruct.d_modelPar_PRDDR_dX);
modelStruct.modelPar_PRWGS=mod.PRWGS;
modelStruct.d_modelPar_PRWGS_dX=0.0;
modelStruct.modelPar_given_PRWGS=mod.given("PRWGS");
modParamMap["PRWGS"] = &(modelStruct.d_modelPar_PRWGS_dX);
modelStruct.modelPar_PRWGD=mod.PRWGD;
modelStruct.d_modelPar_PRWGD_dX=0.0;
modelStruct.modelPar_given_PRWGD=mod.given("PRWGD");
modParamMap["PRWGD"] = &(modelStruct.d_modelPar_PRWGD_dX);
modelStruct.modelPar_WR=mod.WR;
modelStruct.d_modelPar_WR_dX=0.0;
modelStruct.modelPar_given_WR=mod.given("WR");
modParamMap["WR"] = &(modelStruct.d_modelPar_WR_dX);
modelStruct.modelPar_PRT=mod.PRT;
modelStruct.d_modelPar_PRT_dX=0.0;
modelStruct.modelPar_given_PRT=mod.given("PRT");
modParamMap["PRT"] = &(modelStruct.d_modelPar_PRT_dX);
modelStruct.modelPar_TRSDR=mod.TRSDR;
modelStruct.d_modelPar_TRSDR_dX=0.0;
modelStruct.modelPar_given_TRSDR=mod.given("TRSDR");
modParamMap["TRSDR"] = &(modelStruct.d_modelPar_TRSDR_dX);
modelStruct.modelPar_TRDDR=mod.TRDDR;
modelStruct.d_modelPar_TRDDR_dX=0.0;
modelStruct.modelPar_given_TRDDR=mod.given("TRDDR");
modParamMap["TRDDR"] = &(modelStruct.d_modelPar_TRDDR_dX);
modelStruct.modelPar_PDIBL1=mod.PDIBL1;
modelStruct.d_modelPar_PDIBL1_dX=0.0;
modelStruct.modelPar_given_PDIBL1=mod.given("PDIBL1");
modParamMap["PDIBL1"] = &(modelStruct.d_modelPar_PDIBL1_dX);
modelStruct.modelPar_PDIBL1R=mod.PDIBL1R;
modelStruct.d_modelPar_PDIBL1R_dX=0.0;
modelStruct.modelPar_given_PDIBL1R=mod.given("PDIBL1R");
modParamMap["PDIBL1R"] = &(modelStruct.d_modelPar_PDIBL1R_dX);
modelStruct.modelPar_PDIBL2=mod.PDIBL2;
modelStruct.d_modelPar_PDIBL2_dX=0.0;
modelStruct.modelPar_given_PDIBL2=mod.given("PDIBL2");
modParamMap["PDIBL2"] = &(modelStruct.d_modelPar_PDIBL2_dX);
modelStruct.modelPar_DROUT=mod.DROUT;
modelStruct.d_modelPar_DROUT_dX=0.0;
modelStruct.modelPar_given_DROUT=mod.given("DROUT");
modParamMap["DROUT"] = &(modelStruct.d_modelPar_DROUT_dX);
modelStruct.modelPar_PVAG=mod.PVAG;
modelStruct.d_modelPar_PVAG_dX=0.0;
modelStruct.modelPar_given_PVAG=mod.given("PVAG");
modParamMap["PVAG"] = &(modelStruct.d_modelPar_PVAG_dX);
modelStruct.modelPar_PCLM=mod.PCLM;
modelStruct.d_modelPar_PCLM_dX=0.0;
modelStruct.modelPar_given_PCLM=mod.given("PCLM");
modParamMap["PCLM"] = &(modelStruct.d_modelPar_PCLM_dX);
modelStruct.modelPar_APCLM=mod.APCLM;
modelStruct.d_modelPar_APCLM_dX=0.0;
modelStruct.modelPar_given_APCLM=mod.given("APCLM");
modParamMap["APCLM"] = &(modelStruct.d_modelPar_APCLM_dX);
modelStruct.modelPar_BPCLM=mod.BPCLM;
modelStruct.d_modelPar_BPCLM_dX=0.0;
modelStruct.modelPar_given_BPCLM=mod.given("BPCLM");
modParamMap["BPCLM"] = &(modelStruct.d_modelPar_BPCLM_dX);
modelStruct.modelPar_PCLMG=mod.PCLMG;
modelStruct.d_modelPar_PCLMG_dX=0.0;
modelStruct.modelPar_given_PCLMG=mod.given("PCLMG");
modParamMap["PCLMG"] = &(modelStruct.d_modelPar_PCLMG_dX);
modelStruct.modelPar_PCLMCV=mod.PCLMCV;
modelStruct.d_modelPar_PCLMCV_dX=0.0;
modelStruct.modelPar_given_PCLMCV=mod.given("PCLMCV");
modParamMap["PCLMCV"] = &(modelStruct.d_modelPar_PCLMCV_dX);
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modParamMap["A1"] = &(modelStruct.d_modelPar_A1_dX);
modelStruct.modelPar_A11=mod.A11;
modelStruct.d_modelPar_A11_dX=0.0;
modelStruct.modelPar_given_A11=mod.given("A11");
modParamMap["A11"] = &(modelStruct.d_modelPar_A11_dX);
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modParamMap["A2"] = &(modelStruct.d_modelPar_A2_dX);
modelStruct.modelPar_A21=mod.A21;
modelStruct.d_modelPar_A21_dX=0.0;
modelStruct.modelPar_given_A21=mod.given("A21");
modParamMap["A21"] = &(modelStruct.d_modelPar_A21_dX);
modelStruct.modelPar_RGEXT=mod.RGEXT;
modelStruct.d_modelPar_RGEXT_dX=0.0;
modelStruct.modelPar_given_RGEXT=mod.given("RGEXT");
modParamMap["RGEXT"] = &(modelStruct.d_modelPar_RGEXT_dX);
modelStruct.modelPar_RGFIN=mod.RGFIN;
modelStruct.d_modelPar_RGFIN_dX=0.0;
modelStruct.modelPar_given_RGFIN=mod.given("RGFIN");
modParamMap["RGFIN"] = &(modelStruct.d_modelPar_RGFIN_dX);
modelStruct.modelPar_RSHS=mod.RSHS;
modelStruct.d_modelPar_RSHS_dX=0.0;
modelStruct.modelPar_given_RSHS=mod.given("RSHS");
modParamMap["RSHS"] = &(modelStruct.d_modelPar_RSHS_dX);
modelStruct.modelPar_RSHD=mod.RSHD;
modelStruct.d_modelPar_RSHD_dX=0.0;
modelStruct.modelPar_given_RSHD=mod.given("RSHD");
modParamMap["RSHD"] = &(modelStruct.d_modelPar_RSHD_dX);
modelStruct.modelPar_HEPI=mod.HEPI;
modelStruct.d_modelPar_HEPI_dX=0.0;
modelStruct.modelPar_given_HEPI=mod.given("HEPI");
modParamMap["HEPI"] = &(modelStruct.d_modelPar_HEPI_dX);
modelStruct.modelPar_TSILI=mod.TSILI;
modelStruct.d_modelPar_TSILI_dX=0.0;
modelStruct.modelPar_given_TSILI=mod.given("TSILI");
modParamMap["TSILI"] = &(modelStruct.d_modelPar_TSILI_dX);
modelStruct.modelPar_RHOC=mod.RHOC;
modelStruct.d_modelPar_RHOC_dX=0.0;
modelStruct.modelPar_given_RHOC=mod.given("RHOC");
modParamMap["RHOC"] = &(modelStruct.d_modelPar_RHOC_dX);
modelStruct.modelPar_RHORSD=mod.RHORSD;
modelStruct.d_modelPar_RHORSD_dX=0.0;
modelStruct.modelPar_given_RHORSD=mod.given("RHORSD");
modParamMap["RHORSD"] = &(modelStruct.d_modelPar_RHORSD_dX);
modelStruct.modelPar_CRATIO=mod.CRATIO;
modelStruct.d_modelPar_CRATIO_dX=0.0;
modelStruct.modelPar_given_CRATIO=mod.given("CRATIO");
modParamMap["CRATIO"] = &(modelStruct.d_modelPar_CRATIO_dX);
modelStruct.modelPar_DELTAPRSD=mod.DELTAPRSD;
modelStruct.d_modelPar_DELTAPRSD_dX=0.0;
modelStruct.modelPar_given_DELTAPRSD=mod.given("DELTAPRSD");
modParamMap["DELTAPRSD"] = &(modelStruct.d_modelPar_DELTAPRSD_dX);
modelStruct.modelPar_LSP=mod.LSP;
modelStruct.d_modelPar_LSP_dX=0.0;
modelStruct.modelPar_given_LSP=mod.given("LSP");
modParamMap["LSP"] = &(modelStruct.d_modelPar_LSP_dX);
modelStruct.modelPar_EPSRSP=mod.EPSRSP;
modelStruct.d_modelPar_EPSRSP_dX=0.0;
modelStruct.modelPar_given_EPSRSP=mod.given("EPSRSP");
modParamMap["EPSRSP"] = &(modelStruct.d_modelPar_EPSRSP_dX);
modelStruct.modelPar_TGATE=mod.TGATE;
modelStruct.d_modelPar_TGATE_dX=0.0;
modelStruct.modelPar_given_TGATE=mod.given("TGATE");
modParamMap["TGATE"] = &(modelStruct.d_modelPar_TGATE_dX);
modelStruct.modelPar_TMASK=mod.TMASK;
modelStruct.d_modelPar_TMASK_dX=0.0;
modelStruct.modelPar_given_TMASK=mod.given("TMASK");
modParamMap["TMASK"] = &(modelStruct.d_modelPar_TMASK_dX);
modelStruct.modelPar_ASILIEND=mod.ASILIEND;
modelStruct.d_modelPar_ASILIEND_dX=0.0;
modelStruct.modelPar_given_ASILIEND=mod.given("ASILIEND");
modParamMap["ASILIEND"] = &(modelStruct.d_modelPar_ASILIEND_dX);
modelStruct.modelPar_ARSDEND=mod.ARSDEND;
modelStruct.d_modelPar_ARSDEND_dX=0.0;
modelStruct.modelPar_given_ARSDEND=mod.given("ARSDEND");
modParamMap["ARSDEND"] = &(modelStruct.d_modelPar_ARSDEND_dX);
modelStruct.modelPar_PRSDEND=mod.PRSDEND;
modelStruct.d_modelPar_PRSDEND_dX=0.0;
modelStruct.modelPar_given_PRSDEND=mod.given("PRSDEND");
modParamMap["PRSDEND"] = &(modelStruct.d_modelPar_PRSDEND_dX);
modelStruct.modelPar_NSDE=mod.NSDE;
modelStruct.d_modelPar_NSDE_dX=0.0;
modelStruct.modelPar_given_NSDE=mod.given("NSDE");
modParamMap["NSDE"] = &(modelStruct.d_modelPar_NSDE_dX);
modelStruct.modelPar_RGEOA=mod.RGEOA;
modelStruct.d_modelPar_RGEOA_dX=0.0;
modelStruct.modelPar_given_RGEOA=mod.given("RGEOA");
modParamMap["RGEOA"] = &(modelStruct.d_modelPar_RGEOA_dX);
modelStruct.modelPar_RGEOB=mod.RGEOB;
modelStruct.d_modelPar_RGEOB_dX=0.0;
modelStruct.modelPar_given_RGEOB=mod.given("RGEOB");
modParamMap["RGEOB"] = &(modelStruct.d_modelPar_RGEOB_dX);
modelStruct.modelPar_RGEOC=mod.RGEOC;
modelStruct.d_modelPar_RGEOC_dX=0.0;
modelStruct.modelPar_given_RGEOC=mod.given("RGEOC");
modParamMap["RGEOC"] = &(modelStruct.d_modelPar_RGEOC_dX);
modelStruct.modelPar_RGEOD=mod.RGEOD;
modelStruct.d_modelPar_RGEOD_dX=0.0;
modelStruct.modelPar_given_RGEOD=mod.given("RGEOD");
modParamMap["RGEOD"] = &(modelStruct.d_modelPar_RGEOD_dX);
modelStruct.modelPar_RGEOE=mod.RGEOE;
modelStruct.d_modelPar_RGEOE_dX=0.0;
modelStruct.modelPar_given_RGEOE=mod.given("RGEOE");
modParamMap["RGEOE"] = &(modelStruct.d_modelPar_RGEOE_dX);
modelStruct.modelPar_CGEOA=mod.CGEOA;
modelStruct.d_modelPar_CGEOA_dX=0.0;
modelStruct.modelPar_given_CGEOA=mod.given("CGEOA");
modParamMap["CGEOA"] = &(modelStruct.d_modelPar_CGEOA_dX);
modelStruct.modelPar_CGEOB=mod.CGEOB;
modelStruct.d_modelPar_CGEOB_dX=0.0;
modelStruct.modelPar_given_CGEOB=mod.given("CGEOB");
modParamMap["CGEOB"] = &(modelStruct.d_modelPar_CGEOB_dX);
modelStruct.modelPar_CGEOC=mod.CGEOC;
modelStruct.d_modelPar_CGEOC_dX=0.0;
modelStruct.modelPar_given_CGEOC=mod.given("CGEOC");
modParamMap["CGEOC"] = &(modelStruct.d_modelPar_CGEOC_dX);
modelStruct.modelPar_CGEOD=mod.CGEOD;
modelStruct.d_modelPar_CGEOD_dX=0.0;
modelStruct.modelPar_given_CGEOD=mod.given("CGEOD");
modParamMap["CGEOD"] = &(modelStruct.d_modelPar_CGEOD_dX);
modelStruct.modelPar_CGEOE=mod.CGEOE;
modelStruct.d_modelPar_CGEOE_dX=0.0;
modelStruct.modelPar_given_CGEOE=mod.given("CGEOE");
modParamMap["CGEOE"] = &(modelStruct.d_modelPar_CGEOE_dX);
modelStruct.modelPar_AIGBINV=mod.AIGBINV;
modelStruct.d_modelPar_AIGBINV_dX=0.0;
modelStruct.modelPar_given_AIGBINV=mod.given("AIGBINV");
modParamMap["AIGBINV"] = &(modelStruct.d_modelPar_AIGBINV_dX);
modelStruct.modelPar_AIGBINV1=mod.AIGBINV1;
modelStruct.d_modelPar_AIGBINV1_dX=0.0;
modelStruct.modelPar_given_AIGBINV1=mod.given("AIGBINV1");
modParamMap["AIGBINV1"] = &(modelStruct.d_modelPar_AIGBINV1_dX);
modelStruct.modelPar_BIGBINV=mod.BIGBINV;
modelStruct.d_modelPar_BIGBINV_dX=0.0;
modelStruct.modelPar_given_BIGBINV=mod.given("BIGBINV");
modParamMap["BIGBINV"] = &(modelStruct.d_modelPar_BIGBINV_dX);
modelStruct.modelPar_CIGBINV=mod.CIGBINV;
modelStruct.d_modelPar_CIGBINV_dX=0.0;
modelStruct.modelPar_given_CIGBINV=mod.given("CIGBINV");
modParamMap["CIGBINV"] = &(modelStruct.d_modelPar_CIGBINV_dX);
modelStruct.modelPar_EIGBINV=mod.EIGBINV;
modelStruct.d_modelPar_EIGBINV_dX=0.0;
modelStruct.modelPar_given_EIGBINV=mod.given("EIGBINV");
modParamMap["EIGBINV"] = &(modelStruct.d_modelPar_EIGBINV_dX);
modelStruct.modelPar_NIGBINV=mod.NIGBINV;
modelStruct.d_modelPar_NIGBINV_dX=0.0;
modelStruct.modelPar_given_NIGBINV=mod.given("NIGBINV");
modParamMap["NIGBINV"] = &(modelStruct.d_modelPar_NIGBINV_dX);
modelStruct.modelPar_AIGBACC=mod.AIGBACC;
modelStruct.d_modelPar_AIGBACC_dX=0.0;
modelStruct.modelPar_given_AIGBACC=mod.given("AIGBACC");
modParamMap["AIGBACC"] = &(modelStruct.d_modelPar_AIGBACC_dX);
modelStruct.modelPar_AIGBACC1=mod.AIGBACC1;
modelStruct.d_modelPar_AIGBACC1_dX=0.0;
modelStruct.modelPar_given_AIGBACC1=mod.given("AIGBACC1");
modParamMap["AIGBACC1"] = &(modelStruct.d_modelPar_AIGBACC1_dX);
modelStruct.modelPar_BIGBACC=mod.BIGBACC;
modelStruct.d_modelPar_BIGBACC_dX=0.0;
modelStruct.modelPar_given_BIGBACC=mod.given("BIGBACC");
modParamMap["BIGBACC"] = &(modelStruct.d_modelPar_BIGBACC_dX);
modelStruct.modelPar_CIGBACC=mod.CIGBACC;
modelStruct.d_modelPar_CIGBACC_dX=0.0;
modelStruct.modelPar_given_CIGBACC=mod.given("CIGBACC");
modParamMap["CIGBACC"] = &(modelStruct.d_modelPar_CIGBACC_dX);
modelStruct.modelPar_NIGBACC=mod.NIGBACC;
modelStruct.d_modelPar_NIGBACC_dX=0.0;
modelStruct.modelPar_given_NIGBACC=mod.given("NIGBACC");
modParamMap["NIGBACC"] = &(modelStruct.d_modelPar_NIGBACC_dX);
modelStruct.modelPar_AIGC=mod.AIGC;
modelStruct.d_modelPar_AIGC_dX=0.0;
modelStruct.modelPar_given_AIGC=mod.given("AIGC");
modParamMap["AIGC"] = &(modelStruct.d_modelPar_AIGC_dX);
modelStruct.modelPar_AIGC1=mod.AIGC1;
modelStruct.d_modelPar_AIGC1_dX=0.0;
modelStruct.modelPar_given_AIGC1=mod.given("AIGC1");
modParamMap["AIGC1"] = &(modelStruct.d_modelPar_AIGC1_dX);
modelStruct.modelPar_BIGC=mod.BIGC;
modelStruct.d_modelPar_BIGC_dX=0.0;
modelStruct.modelPar_given_BIGC=mod.given("BIGC");
modParamMap["BIGC"] = &(modelStruct.d_modelPar_BIGC_dX);
modelStruct.modelPar_CIGC=mod.CIGC;
modelStruct.d_modelPar_CIGC_dX=0.0;
modelStruct.modelPar_given_CIGC=mod.given("CIGC");
modParamMap["CIGC"] = &(modelStruct.d_modelPar_CIGC_dX);
modelStruct.modelPar_PIGCD=mod.PIGCD;
modelStruct.d_modelPar_PIGCD_dX=0.0;
modelStruct.modelPar_given_PIGCD=mod.given("PIGCD");
modParamMap["PIGCD"] = &(modelStruct.d_modelPar_PIGCD_dX);
modelStruct.modelPar_DLCIGS=mod.DLCIGS;
modelStruct.d_modelPar_DLCIGS_dX=0.0;
modelStruct.modelPar_given_DLCIGS=mod.given("DLCIGS");
modParamMap["DLCIGS"] = &(modelStruct.d_modelPar_DLCIGS_dX);
modelStruct.modelPar_AIGS=mod.AIGS;
modelStruct.d_modelPar_AIGS_dX=0.0;
modelStruct.modelPar_given_AIGS=mod.given("AIGS");
modParamMap["AIGS"] = &(modelStruct.d_modelPar_AIGS_dX);
modelStruct.modelPar_AIGS1=mod.AIGS1;
modelStruct.d_modelPar_AIGS1_dX=0.0;
modelStruct.modelPar_given_AIGS1=mod.given("AIGS1");
modParamMap["AIGS1"] = &(modelStruct.d_modelPar_AIGS1_dX);
modelStruct.modelPar_BIGS=mod.BIGS;
modelStruct.d_modelPar_BIGS_dX=0.0;
modelStruct.modelPar_given_BIGS=mod.given("BIGS");
modParamMap["BIGS"] = &(modelStruct.d_modelPar_BIGS_dX);
modelStruct.modelPar_CIGS=mod.CIGS;
modelStruct.d_modelPar_CIGS_dX=0.0;
modelStruct.modelPar_given_CIGS=mod.given("CIGS");
modParamMap["CIGS"] = &(modelStruct.d_modelPar_CIGS_dX);
modelStruct.modelPar_DLCIGD=mod.DLCIGD;
modelStruct.d_modelPar_DLCIGD_dX=0.0;
modelStruct.modelPar_given_DLCIGD=mod.given("DLCIGD");
modParamMap["DLCIGD"] = &(modelStruct.d_modelPar_DLCIGD_dX);
modelStruct.modelPar_AIGD=mod.AIGD;
modelStruct.d_modelPar_AIGD_dX=0.0;
modelStruct.modelPar_given_AIGD=mod.given("AIGD");
modParamMap["AIGD"] = &(modelStruct.d_modelPar_AIGD_dX);
modelStruct.modelPar_AIGD1=mod.AIGD1;
modelStruct.d_modelPar_AIGD1_dX=0.0;
modelStruct.modelPar_given_AIGD1=mod.given("AIGD1");
modParamMap["AIGD1"] = &(modelStruct.d_modelPar_AIGD1_dX);
modelStruct.modelPar_BIGD=mod.BIGD;
modelStruct.d_modelPar_BIGD_dX=0.0;
modelStruct.modelPar_given_BIGD=mod.given("BIGD");
modParamMap["BIGD"] = &(modelStruct.d_modelPar_BIGD_dX);
modelStruct.modelPar_CIGD=mod.CIGD;
modelStruct.d_modelPar_CIGD_dX=0.0;
modelStruct.modelPar_given_CIGD=mod.given("CIGD");
modParamMap["CIGD"] = &(modelStruct.d_modelPar_CIGD_dX);
modelStruct.modelPar_TOXREF=mod.TOXREF;
modelStruct.d_modelPar_TOXREF_dX=0.0;
modelStruct.modelPar_given_TOXREF=mod.given("TOXREF");
modParamMap["TOXREF"] = &(modelStruct.d_modelPar_TOXREF_dX);
modelStruct.modelPar_TOXG=mod.TOXG;
modelStruct.d_modelPar_TOXG_dX=0.0;
modelStruct.modelPar_given_TOXG=mod.given("TOXG");
modParamMap["TOXG"] = &(modelStruct.d_modelPar_TOXG_dX);
modelStruct.modelPar_NTOX=mod.NTOX;
modelStruct.d_modelPar_NTOX_dX=0.0;
modelStruct.modelPar_given_NTOX=mod.given("NTOX");
modParamMap["NTOX"] = &(modelStruct.d_modelPar_NTOX_dX);
modelStruct.modelPar_POXEDGE=mod.POXEDGE;
modelStruct.d_modelPar_POXEDGE_dX=0.0;
modelStruct.modelPar_given_POXEDGE=mod.given("POXEDGE");
modParamMap["POXEDGE"] = &(modelStruct.d_modelPar_POXEDGE_dX);
modelStruct.modelPar_AGISL=mod.AGISL;
modelStruct.d_modelPar_AGISL_dX=0.0;
modelStruct.modelPar_given_AGISL=mod.given("AGISL");
modParamMap["AGISL"] = &(modelStruct.d_modelPar_AGISL_dX);
modelStruct.modelPar_BGISL=mod.BGISL;
modelStruct.d_modelPar_BGISL_dX=0.0;
modelStruct.modelPar_given_BGISL=mod.given("BGISL");
modParamMap["BGISL"] = &(modelStruct.d_modelPar_BGISL_dX);
modelStruct.modelPar_CGISL=mod.CGISL;
modelStruct.d_modelPar_CGISL_dX=0.0;
modelStruct.modelPar_given_CGISL=mod.given("CGISL");
modParamMap["CGISL"] = &(modelStruct.d_modelPar_CGISL_dX);
modelStruct.modelPar_EGISL=mod.EGISL;
modelStruct.d_modelPar_EGISL_dX=0.0;
modelStruct.modelPar_given_EGISL=mod.given("EGISL");
modParamMap["EGISL"] = &(modelStruct.d_modelPar_EGISL_dX);
modelStruct.modelPar_PGISL=mod.PGISL;
modelStruct.d_modelPar_PGISL_dX=0.0;
modelStruct.modelPar_given_PGISL=mod.given("PGISL");
modParamMap["PGISL"] = &(modelStruct.d_modelPar_PGISL_dX);
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modParamMap["AGIDL"] = &(modelStruct.d_modelPar_AGIDL_dX);
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modParamMap["BGIDL"] = &(modelStruct.d_modelPar_BGIDL_dX);
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modParamMap["CGIDL"] = &(modelStruct.d_modelPar_CGIDL_dX);
modelStruct.modelPar_EGIDL=mod.EGIDL;
modelStruct.d_modelPar_EGIDL_dX=0.0;
modelStruct.modelPar_given_EGIDL=mod.given("EGIDL");
modParamMap["EGIDL"] = &(modelStruct.d_modelPar_EGIDL_dX);
modelStruct.modelPar_PGIDL=mod.PGIDL;
modelStruct.d_modelPar_PGIDL_dX=0.0;
modelStruct.modelPar_given_PGIDL=mod.given("PGIDL");
modParamMap["PGIDL"] = &(modelStruct.d_modelPar_PGIDL_dX);
modelStruct.modelPar_ALPHA0=mod.ALPHA0;
modelStruct.d_modelPar_ALPHA0_dX=0.0;
modelStruct.modelPar_given_ALPHA0=mod.given("ALPHA0");
modParamMap["ALPHA0"] = &(modelStruct.d_modelPar_ALPHA0_dX);
modelStruct.modelPar_ALPHA01=mod.ALPHA01;
modelStruct.d_modelPar_ALPHA01_dX=0.0;
modelStruct.modelPar_given_ALPHA01=mod.given("ALPHA01");
modParamMap["ALPHA01"] = &(modelStruct.d_modelPar_ALPHA01_dX);
modelStruct.modelPar_ALPHA1=mod.ALPHA1;
modelStruct.d_modelPar_ALPHA1_dX=0.0;
modelStruct.modelPar_given_ALPHA1=mod.given("ALPHA1");
modParamMap["ALPHA1"] = &(modelStruct.d_modelPar_ALPHA1_dX);
modelStruct.modelPar_ALPHA11=mod.ALPHA11;
modelStruct.d_modelPar_ALPHA11_dX=0.0;
modelStruct.modelPar_given_ALPHA11=mod.given("ALPHA11");
modParamMap["ALPHA11"] = &(modelStruct.d_modelPar_ALPHA11_dX);
modelStruct.modelPar_BETA0=mod.BETA0;
modelStruct.d_modelPar_BETA0_dX=0.0;
modelStruct.modelPar_given_BETA0=mod.given("BETA0");
modParamMap["BETA0"] = &(modelStruct.d_modelPar_BETA0_dX);
modelStruct.modelPar_ALPHAII0=mod.ALPHAII0;
modelStruct.d_modelPar_ALPHAII0_dX=0.0;
modelStruct.modelPar_given_ALPHAII0=mod.given("ALPHAII0");
modParamMap["ALPHAII0"] = &(modelStruct.d_modelPar_ALPHAII0_dX);
modelStruct.modelPar_ALPHAII01=mod.ALPHAII01;
modelStruct.d_modelPar_ALPHAII01_dX=0.0;
modelStruct.modelPar_given_ALPHAII01=mod.given("ALPHAII01");
modParamMap["ALPHAII01"] = &(modelStruct.d_modelPar_ALPHAII01_dX);
modelStruct.modelPar_ALPHAII1=mod.ALPHAII1;
modelStruct.d_modelPar_ALPHAII1_dX=0.0;
modelStruct.modelPar_given_ALPHAII1=mod.given("ALPHAII1");
modParamMap["ALPHAII1"] = &(modelStruct.d_modelPar_ALPHAII1_dX);
modelStruct.modelPar_ALPHAII11=mod.ALPHAII11;
modelStruct.d_modelPar_ALPHAII11_dX=0.0;
modelStruct.modelPar_given_ALPHAII11=mod.given("ALPHAII11");
modParamMap["ALPHAII11"] = &(modelStruct.d_modelPar_ALPHAII11_dX);
modelStruct.modelPar_BETAII0=mod.BETAII0;
modelStruct.d_modelPar_BETAII0_dX=0.0;
modelStruct.modelPar_given_BETAII0=mod.given("BETAII0");
modParamMap["BETAII0"] = &(modelStruct.d_modelPar_BETAII0_dX);
modelStruct.modelPar_BETAII1=mod.BETAII1;
modelStruct.d_modelPar_BETAII1_dX=0.0;
modelStruct.modelPar_given_BETAII1=mod.given("BETAII1");
modParamMap["BETAII1"] = &(modelStruct.d_modelPar_BETAII1_dX);
modelStruct.modelPar_BETAII2=mod.BETAII2;
modelStruct.d_modelPar_BETAII2_dX=0.0;
modelStruct.modelPar_given_BETAII2=mod.given("BETAII2");
modParamMap["BETAII2"] = &(modelStruct.d_modelPar_BETAII2_dX);
modelStruct.modelPar_ESATII=mod.ESATII;
modelStruct.d_modelPar_ESATII_dX=0.0;
modelStruct.modelPar_given_ESATII=mod.given("ESATII");
modParamMap["ESATII"] = &(modelStruct.d_modelPar_ESATII_dX);
modelStruct.modelPar_LII=mod.LII;
modelStruct.d_modelPar_LII_dX=0.0;
modelStruct.modelPar_given_LII=mod.given("LII");
modParamMap["LII"] = &(modelStruct.d_modelPar_LII_dX);
modelStruct.modelPar_SII0=mod.SII0;
modelStruct.d_modelPar_SII0_dX=0.0;
modelStruct.modelPar_given_SII0=mod.given("SII0");
modParamMap["SII0"] = &(modelStruct.d_modelPar_SII0_dX);
modelStruct.modelPar_SII1=mod.SII1;
modelStruct.d_modelPar_SII1_dX=0.0;
modelStruct.modelPar_given_SII1=mod.given("SII1");
modParamMap["SII1"] = &(modelStruct.d_modelPar_SII1_dX);
modelStruct.modelPar_SII2=mod.SII2;
modelStruct.d_modelPar_SII2_dX=0.0;
modelStruct.modelPar_given_SII2=mod.given("SII2");
modParamMap["SII2"] = &(modelStruct.d_modelPar_SII2_dX);
modelStruct.modelPar_SIID=mod.SIID;
modelStruct.d_modelPar_SIID_dX=0.0;
modelStruct.modelPar_given_SIID=mod.given("SIID");
modParamMap["SIID"] = &(modelStruct.d_modelPar_SIID_dX);
modelStruct.modelPar_EOTACC=mod.EOTACC;
modelStruct.d_modelPar_EOTACC_dX=0.0;
modelStruct.modelPar_given_EOTACC=mod.given("EOTACC");
modParamMap["EOTACC"] = &(modelStruct.d_modelPar_EOTACC_dX);
modelStruct.modelPar_DELVFBACC=mod.DELVFBACC;
modelStruct.d_modelPar_DELVFBACC_dX=0.0;
modelStruct.modelPar_given_DELVFBACC=mod.given("DELVFBACC");
modParamMap["DELVFBACC"] = &(modelStruct.d_modelPar_DELVFBACC_dX);
modelStruct.modelPar_CFS=mod.CFS;
modelStruct.d_modelPar_CFS_dX=0.0;
modelStruct.modelPar_given_CFS=mod.given("CFS");
modParamMap["CFS"] = &(modelStruct.d_modelPar_CFS_dX);
modelStruct.modelPar_CFD=mod.CFD;
modelStruct.d_modelPar_CFD_dX=0.0;
modelStruct.modelPar_given_CFD=mod.given("CFD");
modParamMap["CFD"] = &(modelStruct.d_modelPar_CFD_dX);
modelStruct.modelPar_CGSO=mod.CGSO;
modelStruct.d_modelPar_CGSO_dX=0.0;
modelStruct.modelPar_given_CGSO=mod.given("CGSO");
modParamMap["CGSO"] = &(modelStruct.d_modelPar_CGSO_dX);
modelStruct.modelPar_CGDO=mod.CGDO;
modelStruct.d_modelPar_CGDO_dX=0.0;
modelStruct.modelPar_given_CGDO=mod.given("CGDO");
modParamMap["CGDO"] = &(modelStruct.d_modelPar_CGDO_dX);
modelStruct.modelPar_CGSL=mod.CGSL;
modelStruct.d_modelPar_CGSL_dX=0.0;
modelStruct.modelPar_given_CGSL=mod.given("CGSL");
modParamMap["CGSL"] = &(modelStruct.d_modelPar_CGSL_dX);
modelStruct.modelPar_CGDL=mod.CGDL;
modelStruct.d_modelPar_CGDL_dX=0.0;
modelStruct.modelPar_given_CGDL=mod.given("CGDL");
modParamMap["CGDL"] = &(modelStruct.d_modelPar_CGDL_dX);
modelStruct.modelPar_CKAPPAS=mod.CKAPPAS;
modelStruct.d_modelPar_CKAPPAS_dX=0.0;
modelStruct.modelPar_given_CKAPPAS=mod.given("CKAPPAS");
modParamMap["CKAPPAS"] = &(modelStruct.d_modelPar_CKAPPAS_dX);
modelStruct.modelPar_CKAPPAD=mod.CKAPPAD;
modelStruct.d_modelPar_CKAPPAD_dX=0.0;
modelStruct.modelPar_given_CKAPPAD=mod.given("CKAPPAD");
modParamMap["CKAPPAD"] = &(modelStruct.d_modelPar_CKAPPAD_dX);
modelStruct.modelPar_CGBO=mod.CGBO;
modelStruct.d_modelPar_CGBO_dX=0.0;
modelStruct.modelPar_given_CGBO=mod.given("CGBO");
modParamMap["CGBO"] = &(modelStruct.d_modelPar_CGBO_dX);
modelStruct.modelPar_CGBN=mod.CGBN;
modelStruct.d_modelPar_CGBN_dX=0.0;
modelStruct.modelPar_given_CGBN=mod.given("CGBN");
modParamMap["CGBN"] = &(modelStruct.d_modelPar_CGBN_dX);
modelStruct.modelPar_CGBL=mod.CGBL;
modelStruct.d_modelPar_CGBL_dX=0.0;
modelStruct.modelPar_given_CGBL=mod.given("CGBL");
modParamMap["CGBL"] = &(modelStruct.d_modelPar_CGBL_dX);
modelStruct.modelPar_CKAPPAB=mod.CKAPPAB;
modelStruct.d_modelPar_CKAPPAB_dX=0.0;
modelStruct.modelPar_given_CKAPPAB=mod.given("CKAPPAB");
modParamMap["CKAPPAB"] = &(modelStruct.d_modelPar_CKAPPAB_dX);
modelStruct.modelPar_CSDESW=mod.CSDESW;
modelStruct.d_modelPar_CSDESW_dX=0.0;
modelStruct.modelPar_given_CSDESW=mod.given("CSDESW");
modParamMap["CSDESW"] = &(modelStruct.d_modelPar_CSDESW_dX);
modelStruct.modelPar_CJS=mod.CJS;
modelStruct.d_modelPar_CJS_dX=0.0;
modelStruct.modelPar_given_CJS=mod.given("CJS");
modParamMap["CJS"] = &(modelStruct.d_modelPar_CJS_dX);
modelStruct.modelPar_CJD=mod.CJD;
modelStruct.d_modelPar_CJD_dX=0.0;
modelStruct.modelPar_given_CJD=mod.given("CJD");
modParamMap["CJD"] = &(modelStruct.d_modelPar_CJD_dX);
modelStruct.modelPar_CJSWS=mod.CJSWS;
modelStruct.d_modelPar_CJSWS_dX=0.0;
modelStruct.modelPar_given_CJSWS=mod.given("CJSWS");
modParamMap["CJSWS"] = &(modelStruct.d_modelPar_CJSWS_dX);
modelStruct.modelPar_CJSWD=mod.CJSWD;
modelStruct.d_modelPar_CJSWD_dX=0.0;
modelStruct.modelPar_given_CJSWD=mod.given("CJSWD");
modParamMap["CJSWD"] = &(modelStruct.d_modelPar_CJSWD_dX);
modelStruct.modelPar_CJSWGS=mod.CJSWGS;
modelStruct.d_modelPar_CJSWGS_dX=0.0;
modelStruct.modelPar_given_CJSWGS=mod.given("CJSWGS");
modParamMap["CJSWGS"] = &(modelStruct.d_modelPar_CJSWGS_dX);
modelStruct.modelPar_CJSWGD=mod.CJSWGD;
modelStruct.d_modelPar_CJSWGD_dX=0.0;
modelStruct.modelPar_given_CJSWGD=mod.given("CJSWGD");
modParamMap["CJSWGD"] = &(modelStruct.d_modelPar_CJSWGD_dX);
modelStruct.modelPar_PBS=mod.PBS;
modelStruct.d_modelPar_PBS_dX=0.0;
modelStruct.modelPar_given_PBS=mod.given("PBS");
modParamMap["PBS"] = &(modelStruct.d_modelPar_PBS_dX);
modelStruct.modelPar_PBD=mod.PBD;
modelStruct.d_modelPar_PBD_dX=0.0;
modelStruct.modelPar_given_PBD=mod.given("PBD");
modParamMap["PBD"] = &(modelStruct.d_modelPar_PBD_dX);
modelStruct.modelPar_PBSWS=mod.PBSWS;
modelStruct.d_modelPar_PBSWS_dX=0.0;
modelStruct.modelPar_given_PBSWS=mod.given("PBSWS");
modParamMap["PBSWS"] = &(modelStruct.d_modelPar_PBSWS_dX);
modelStruct.modelPar_PBSWD=mod.PBSWD;
modelStruct.d_modelPar_PBSWD_dX=0.0;
modelStruct.modelPar_given_PBSWD=mod.given("PBSWD");
modParamMap["PBSWD"] = &(modelStruct.d_modelPar_PBSWD_dX);
modelStruct.modelPar_PBSWGS=mod.PBSWGS;
modelStruct.d_modelPar_PBSWGS_dX=0.0;
modelStruct.modelPar_given_PBSWGS=mod.given("PBSWGS");
modParamMap["PBSWGS"] = &(modelStruct.d_modelPar_PBSWGS_dX);
modelStruct.modelPar_PBSWGD=mod.PBSWGD;
modelStruct.d_modelPar_PBSWGD_dX=0.0;
modelStruct.modelPar_given_PBSWGD=mod.given("PBSWGD");
modParamMap["PBSWGD"] = &(modelStruct.d_modelPar_PBSWGD_dX);
modelStruct.modelPar_MJS=mod.MJS;
modelStruct.d_modelPar_MJS_dX=0.0;
modelStruct.modelPar_given_MJS=mod.given("MJS");
modParamMap["MJS"] = &(modelStruct.d_modelPar_MJS_dX);
modelStruct.modelPar_MJD=mod.MJD;
modelStruct.d_modelPar_MJD_dX=0.0;
modelStruct.modelPar_given_MJD=mod.given("MJD");
modParamMap["MJD"] = &(modelStruct.d_modelPar_MJD_dX);
modelStruct.modelPar_MJSWS=mod.MJSWS;
modelStruct.d_modelPar_MJSWS_dX=0.0;
modelStruct.modelPar_given_MJSWS=mod.given("MJSWS");
modParamMap["MJSWS"] = &(modelStruct.d_modelPar_MJSWS_dX);
modelStruct.modelPar_MJSWD=mod.MJSWD;
modelStruct.d_modelPar_MJSWD_dX=0.0;
modelStruct.modelPar_given_MJSWD=mod.given("MJSWD");
modParamMap["MJSWD"] = &(modelStruct.d_modelPar_MJSWD_dX);
modelStruct.modelPar_MJSWGS=mod.MJSWGS;
modelStruct.d_modelPar_MJSWGS_dX=0.0;
modelStruct.modelPar_given_MJSWGS=mod.given("MJSWGS");
modParamMap["MJSWGS"] = &(modelStruct.d_modelPar_MJSWGS_dX);
modelStruct.modelPar_MJSWGD=mod.MJSWGD;
modelStruct.d_modelPar_MJSWGD_dX=0.0;
modelStruct.modelPar_given_MJSWGD=mod.given("MJSWGD");
modParamMap["MJSWGD"] = &(modelStruct.d_modelPar_MJSWGD_dX);
modelStruct.modelPar_SJS=mod.SJS;
modelStruct.d_modelPar_SJS_dX=0.0;
modelStruct.modelPar_given_SJS=mod.given("SJS");
modParamMap["SJS"] = &(modelStruct.d_modelPar_SJS_dX);
modelStruct.modelPar_SJD=mod.SJD;
modelStruct.d_modelPar_SJD_dX=0.0;
modelStruct.modelPar_given_SJD=mod.given("SJD");
modParamMap["SJD"] = &(modelStruct.d_modelPar_SJD_dX);
modelStruct.modelPar_SJSWS=mod.SJSWS;
modelStruct.d_modelPar_SJSWS_dX=0.0;
modelStruct.modelPar_given_SJSWS=mod.given("SJSWS");
modParamMap["SJSWS"] = &(modelStruct.d_modelPar_SJSWS_dX);
modelStruct.modelPar_SJSWD=mod.SJSWD;
modelStruct.d_modelPar_SJSWD_dX=0.0;
modelStruct.modelPar_given_SJSWD=mod.given("SJSWD");
modParamMap["SJSWD"] = &(modelStruct.d_modelPar_SJSWD_dX);
modelStruct.modelPar_SJSWGS=mod.SJSWGS;
modelStruct.d_modelPar_SJSWGS_dX=0.0;
modelStruct.modelPar_given_SJSWGS=mod.given("SJSWGS");
modParamMap["SJSWGS"] = &(modelStruct.d_modelPar_SJSWGS_dX);
modelStruct.modelPar_SJSWGD=mod.SJSWGD;
modelStruct.d_modelPar_SJSWGD_dX=0.0;
modelStruct.modelPar_given_SJSWGD=mod.given("SJSWGD");
modParamMap["SJSWGD"] = &(modelStruct.d_modelPar_SJSWGD_dX);
modelStruct.modelPar_MJS2=mod.MJS2;
modelStruct.d_modelPar_MJS2_dX=0.0;
modelStruct.modelPar_given_MJS2=mod.given("MJS2");
modParamMap["MJS2"] = &(modelStruct.d_modelPar_MJS2_dX);
modelStruct.modelPar_MJD2=mod.MJD2;
modelStruct.d_modelPar_MJD2_dX=0.0;
modelStruct.modelPar_given_MJD2=mod.given("MJD2");
modParamMap["MJD2"] = &(modelStruct.d_modelPar_MJD2_dX);
modelStruct.modelPar_MJSWS2=mod.MJSWS2;
modelStruct.d_modelPar_MJSWS2_dX=0.0;
modelStruct.modelPar_given_MJSWS2=mod.given("MJSWS2");
modParamMap["MJSWS2"] = &(modelStruct.d_modelPar_MJSWS2_dX);
modelStruct.modelPar_MJSWD2=mod.MJSWD2;
modelStruct.d_modelPar_MJSWD2_dX=0.0;
modelStruct.modelPar_given_MJSWD2=mod.given("MJSWD2");
modParamMap["MJSWD2"] = &(modelStruct.d_modelPar_MJSWD2_dX);
modelStruct.modelPar_MJSWGS2=mod.MJSWGS2;
modelStruct.d_modelPar_MJSWGS2_dX=0.0;
modelStruct.modelPar_given_MJSWGS2=mod.given("MJSWGS2");
modParamMap["MJSWGS2"] = &(modelStruct.d_modelPar_MJSWGS2_dX);
modelStruct.modelPar_MJSWGD2=mod.MJSWGD2;
modelStruct.d_modelPar_MJSWGD2_dX=0.0;
modelStruct.modelPar_given_MJSWGD2=mod.given("MJSWGD2");
modParamMap["MJSWGD2"] = &(modelStruct.d_modelPar_MJSWGD2_dX);
modelStruct.modelPar_JSS=mod.JSS;
modelStruct.d_modelPar_JSS_dX=0.0;
modelStruct.modelPar_given_JSS=mod.given("JSS");
modParamMap["JSS"] = &(modelStruct.d_modelPar_JSS_dX);
modelStruct.modelPar_JSD=mod.JSD;
modelStruct.d_modelPar_JSD_dX=0.0;
modelStruct.modelPar_given_JSD=mod.given("JSD");
modParamMap["JSD"] = &(modelStruct.d_modelPar_JSD_dX);
modelStruct.modelPar_JSWS=mod.JSWS;
modelStruct.d_modelPar_JSWS_dX=0.0;
modelStruct.modelPar_given_JSWS=mod.given("JSWS");
modParamMap["JSWS"] = &(modelStruct.d_modelPar_JSWS_dX);
modelStruct.modelPar_JSWD=mod.JSWD;
modelStruct.d_modelPar_JSWD_dX=0.0;
modelStruct.modelPar_given_JSWD=mod.given("JSWD");
modParamMap["JSWD"] = &(modelStruct.d_modelPar_JSWD_dX);
modelStruct.modelPar_JSWGS=mod.JSWGS;
modelStruct.d_modelPar_JSWGS_dX=0.0;
modelStruct.modelPar_given_JSWGS=mod.given("JSWGS");
modParamMap["JSWGS"] = &(modelStruct.d_modelPar_JSWGS_dX);
modelStruct.modelPar_JSWGD=mod.JSWGD;
modelStruct.d_modelPar_JSWGD_dX=0.0;
modelStruct.modelPar_given_JSWGD=mod.given("JSWGD");
modParamMap["JSWGD"] = &(modelStruct.d_modelPar_JSWGD_dX);
modelStruct.modelPar_NJS=mod.NJS;
modelStruct.d_modelPar_NJS_dX=0.0;
modelStruct.modelPar_given_NJS=mod.given("NJS");
modParamMap["NJS"] = &(modelStruct.d_modelPar_NJS_dX);
modelStruct.modelPar_NJD=mod.NJD;
modelStruct.d_modelPar_NJD_dX=0.0;
modelStruct.modelPar_given_NJD=mod.given("NJD");
modParamMap["NJD"] = &(modelStruct.d_modelPar_NJD_dX);
modelStruct.modelPar_IJTHSFWD=mod.IJTHSFWD;
modelStruct.d_modelPar_IJTHSFWD_dX=0.0;
modelStruct.modelPar_given_IJTHSFWD=mod.given("IJTHSFWD");
modParamMap["IJTHSFWD"] = &(modelStruct.d_modelPar_IJTHSFWD_dX);
modelStruct.modelPar_IJTHDFWD=mod.IJTHDFWD;
modelStruct.d_modelPar_IJTHDFWD_dX=0.0;
modelStruct.modelPar_given_IJTHDFWD=mod.given("IJTHDFWD");
modParamMap["IJTHDFWD"] = &(modelStruct.d_modelPar_IJTHDFWD_dX);
modelStruct.modelPar_IJTHSREV=mod.IJTHSREV;
modelStruct.d_modelPar_IJTHSREV_dX=0.0;
modelStruct.modelPar_given_IJTHSREV=mod.given("IJTHSREV");
modParamMap["IJTHSREV"] = &(modelStruct.d_modelPar_IJTHSREV_dX);
modelStruct.modelPar_IJTHDREV=mod.IJTHDREV;
modelStruct.d_modelPar_IJTHDREV_dX=0.0;
modelStruct.modelPar_given_IJTHDREV=mod.given("IJTHDREV");
modParamMap["IJTHDREV"] = &(modelStruct.d_modelPar_IJTHDREV_dX);
modelStruct.modelPar_BVS=mod.BVS;
modelStruct.d_modelPar_BVS_dX=0.0;
modelStruct.modelPar_given_BVS=mod.given("BVS");
modParamMap["BVS"] = &(modelStruct.d_modelPar_BVS_dX);
modelStruct.modelPar_BVD=mod.BVD;
modelStruct.d_modelPar_BVD_dX=0.0;
modelStruct.modelPar_given_BVD=mod.given("BVD");
modParamMap["BVD"] = &(modelStruct.d_modelPar_BVD_dX);
modelStruct.modelPar_XJBVS=mod.XJBVS;
modelStruct.d_modelPar_XJBVS_dX=0.0;
modelStruct.modelPar_given_XJBVS=mod.given("XJBVS");
modParamMap["XJBVS"] = &(modelStruct.d_modelPar_XJBVS_dX);
modelStruct.modelPar_XJBVD=mod.XJBVD;
modelStruct.d_modelPar_XJBVD_dX=0.0;
modelStruct.modelPar_given_XJBVD=mod.given("XJBVD");
modParamMap["XJBVD"] = &(modelStruct.d_modelPar_XJBVD_dX);
modelStruct.modelPar_JTSS=mod.JTSS;
modelStruct.d_modelPar_JTSS_dX=0.0;
modelStruct.modelPar_given_JTSS=mod.given("JTSS");
modParamMap["JTSS"] = &(modelStruct.d_modelPar_JTSS_dX);
modelStruct.modelPar_JTSD=mod.JTSD;
modelStruct.d_modelPar_JTSD_dX=0.0;
modelStruct.modelPar_given_JTSD=mod.given("JTSD");
modParamMap["JTSD"] = &(modelStruct.d_modelPar_JTSD_dX);
modelStruct.modelPar_JTSSWS=mod.JTSSWS;
modelStruct.d_modelPar_JTSSWS_dX=0.0;
modelStruct.modelPar_given_JTSSWS=mod.given("JTSSWS");
modParamMap["JTSSWS"] = &(modelStruct.d_modelPar_JTSSWS_dX);
modelStruct.modelPar_JTSSWD=mod.JTSSWD;
modelStruct.d_modelPar_JTSSWD_dX=0.0;
modelStruct.modelPar_given_JTSSWD=mod.given("JTSSWD");
modParamMap["JTSSWD"] = &(modelStruct.d_modelPar_JTSSWD_dX);
modelStruct.modelPar_JTSSWGS=mod.JTSSWGS;
modelStruct.d_modelPar_JTSSWGS_dX=0.0;
modelStruct.modelPar_given_JTSSWGS=mod.given("JTSSWGS");
modParamMap["JTSSWGS"] = &(modelStruct.d_modelPar_JTSSWGS_dX);
modelStruct.modelPar_JTSSWGD=mod.JTSSWGD;
modelStruct.d_modelPar_JTSSWGD_dX=0.0;
modelStruct.modelPar_given_JTSSWGD=mod.given("JTSSWGD");
modParamMap["JTSSWGD"] = &(modelStruct.d_modelPar_JTSSWGD_dX);
modelStruct.modelPar_JTWEFF=mod.JTWEFF;
modelStruct.d_modelPar_JTWEFF_dX=0.0;
modelStruct.modelPar_given_JTWEFF=mod.given("JTWEFF");
modParamMap["JTWEFF"] = &(modelStruct.d_modelPar_JTWEFF_dX);
modelStruct.modelPar_NJTS=mod.NJTS;
modelStruct.d_modelPar_NJTS_dX=0.0;
modelStruct.modelPar_given_NJTS=mod.given("NJTS");
modParamMap["NJTS"] = &(modelStruct.d_modelPar_NJTS_dX);
modelStruct.modelPar_NJTSD=mod.NJTSD;
modelStruct.d_modelPar_NJTSD_dX=0.0;
modelStruct.modelPar_given_NJTSD=mod.given("NJTSD");
modParamMap["NJTSD"] = &(modelStruct.d_modelPar_NJTSD_dX);
modelStruct.modelPar_NJTSSW=mod.NJTSSW;
modelStruct.d_modelPar_NJTSSW_dX=0.0;
modelStruct.modelPar_given_NJTSSW=mod.given("NJTSSW");
modParamMap["NJTSSW"] = &(modelStruct.d_modelPar_NJTSSW_dX);
modelStruct.modelPar_NJTSSWD=mod.NJTSSWD;
modelStruct.d_modelPar_NJTSSWD_dX=0.0;
modelStruct.modelPar_given_NJTSSWD=mod.given("NJTSSWD");
modParamMap["NJTSSWD"] = &(modelStruct.d_modelPar_NJTSSWD_dX);
modelStruct.modelPar_NJTSSWG=mod.NJTSSWG;
modelStruct.d_modelPar_NJTSSWG_dX=0.0;
modelStruct.modelPar_given_NJTSSWG=mod.given("NJTSSWG");
modParamMap["NJTSSWG"] = &(modelStruct.d_modelPar_NJTSSWG_dX);
modelStruct.modelPar_NJTSSWGD=mod.NJTSSWGD;
modelStruct.d_modelPar_NJTSSWGD_dX=0.0;
modelStruct.modelPar_given_NJTSSWGD=mod.given("NJTSSWGD");
modParamMap["NJTSSWGD"] = &(modelStruct.d_modelPar_NJTSSWGD_dX);
modelStruct.modelPar_VTSS=mod.VTSS;
modelStruct.d_modelPar_VTSS_dX=0.0;
modelStruct.modelPar_given_VTSS=mod.given("VTSS");
modParamMap["VTSS"] = &(modelStruct.d_modelPar_VTSS_dX);
modelStruct.modelPar_VTSD=mod.VTSD;
modelStruct.d_modelPar_VTSD_dX=0.0;
modelStruct.modelPar_given_VTSD=mod.given("VTSD");
modParamMap["VTSD"] = &(modelStruct.d_modelPar_VTSD_dX);
modelStruct.modelPar_VTSSWS=mod.VTSSWS;
modelStruct.d_modelPar_VTSSWS_dX=0.0;
modelStruct.modelPar_given_VTSSWS=mod.given("VTSSWS");
modParamMap["VTSSWS"] = &(modelStruct.d_modelPar_VTSSWS_dX);
modelStruct.modelPar_VTSSWD=mod.VTSSWD;
modelStruct.d_modelPar_VTSSWD_dX=0.0;
modelStruct.modelPar_given_VTSSWD=mod.given("VTSSWD");
modParamMap["VTSSWD"] = &(modelStruct.d_modelPar_VTSSWD_dX);
modelStruct.modelPar_VTSSWGS=mod.VTSSWGS;
modelStruct.d_modelPar_VTSSWGS_dX=0.0;
modelStruct.modelPar_given_VTSSWGS=mod.given("VTSSWGS");
modParamMap["VTSSWGS"] = &(modelStruct.d_modelPar_VTSSWGS_dX);
modelStruct.modelPar_VTSSWGD=mod.VTSSWGD;
modelStruct.d_modelPar_VTSSWGD_dX=0.0;
modelStruct.modelPar_given_VTSSWGD=mod.given("VTSSWGD");
modParamMap["VTSSWGD"] = &(modelStruct.d_modelPar_VTSSWGD_dX);
modelStruct.modelPar_LINTIGEN=mod.LINTIGEN;
modelStruct.d_modelPar_LINTIGEN_dX=0.0;
modelStruct.modelPar_given_LINTIGEN=mod.given("LINTIGEN");
modParamMap["LINTIGEN"] = &(modelStruct.d_modelPar_LINTIGEN_dX);
modelStruct.modelPar_NTGEN=mod.NTGEN;
modelStruct.d_modelPar_NTGEN_dX=0.0;
modelStruct.modelPar_given_NTGEN=mod.given("NTGEN");
modParamMap["NTGEN"] = &(modelStruct.d_modelPar_NTGEN_dX);
modelStruct.modelPar_AIGEN=mod.AIGEN;
modelStruct.d_modelPar_AIGEN_dX=0.0;
modelStruct.modelPar_given_AIGEN=mod.given("AIGEN");
modParamMap["AIGEN"] = &(modelStruct.d_modelPar_AIGEN_dX);
modelStruct.modelPar_BIGEN=mod.BIGEN;
modelStruct.d_modelPar_BIGEN_dX=0.0;
modelStruct.modelPar_given_BIGEN=mod.given("BIGEN");
modParamMap["BIGEN"] = &(modelStruct.d_modelPar_BIGEN_dX);
modelStruct.modelPar_XRCRG1=mod.XRCRG1;
modelStruct.d_modelPar_XRCRG1_dX=0.0;
modelStruct.modelPar_given_XRCRG1=mod.given("XRCRG1");
modParamMap["XRCRG1"] = &(modelStruct.d_modelPar_XRCRG1_dX);
modelStruct.modelPar_XRCRG2=mod.XRCRG2;
modelStruct.d_modelPar_XRCRG2_dX=0.0;
modelStruct.modelPar_given_XRCRG2=mod.given("XRCRG2");
modParamMap["XRCRG2"] = &(modelStruct.d_modelPar_XRCRG2_dX);
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modParamMap["EF"] = &(modelStruct.d_modelPar_EF_dX);
modelStruct.modelPar_EM=mod.EM;
modelStruct.d_modelPar_EM_dX=0.0;
modelStruct.modelPar_given_EM=mod.given("EM");
modParamMap["EM"] = &(modelStruct.d_modelPar_EM_dX);
modelStruct.modelPar_NOIA=mod.NOIA;
modelStruct.d_modelPar_NOIA_dX=0.0;
modelStruct.modelPar_given_NOIA=mod.given("NOIA");
modParamMap["NOIA"] = &(modelStruct.d_modelPar_NOIA_dX);
modelStruct.modelPar_NOIB=mod.NOIB;
modelStruct.d_modelPar_NOIB_dX=0.0;
modelStruct.modelPar_given_NOIB=mod.given("NOIB");
modParamMap["NOIB"] = &(modelStruct.d_modelPar_NOIB_dX);
modelStruct.modelPar_NOIC=mod.NOIC;
modelStruct.d_modelPar_NOIC_dX=0.0;
modelStruct.modelPar_given_NOIC=mod.given("NOIC");
modParamMap["NOIC"] = &(modelStruct.d_modelPar_NOIC_dX);
modelStruct.modelPar_NTNOI=mod.NTNOI;
modelStruct.d_modelPar_NTNOI_dX=0.0;
modelStruct.modelPar_given_NTNOI=mod.given("NTNOI");
modParamMap["NTNOI"] = &(modelStruct.d_modelPar_NTNOI_dX);
modelStruct.modelPar_TNOM=mod.TNOM;
modelStruct.d_modelPar_TNOM_dX=0.0;
modelStruct.modelPar_given_TNOM=mod.given("TNOM");
modParamMap["TNOM"] = &(modelStruct.d_modelPar_TNOM_dX);
modelStruct.modelPar_TBGASUB=mod.TBGASUB;
modelStruct.d_modelPar_TBGASUB_dX=0.0;
modelStruct.modelPar_given_TBGASUB=mod.given("TBGASUB");
modParamMap["TBGASUB"] = &(modelStruct.d_modelPar_TBGASUB_dX);
modelStruct.modelPar_TBGBSUB=mod.TBGBSUB;
modelStruct.d_modelPar_TBGBSUB_dX=0.0;
modelStruct.modelPar_given_TBGBSUB=mod.given("TBGBSUB");
modParamMap["TBGBSUB"] = &(modelStruct.d_modelPar_TBGBSUB_dX);
modelStruct.modelPar_KT1=mod.KT1;
modelStruct.d_modelPar_KT1_dX=0.0;
modelStruct.modelPar_given_KT1=mod.given("KT1");
modParamMap["KT1"] = &(modelStruct.d_modelPar_KT1_dX);
modelStruct.modelPar_KT1L=mod.KT1L;
modelStruct.d_modelPar_KT1L_dX=0.0;
modelStruct.modelPar_given_KT1L=mod.given("KT1L");
modParamMap["KT1L"] = &(modelStruct.d_modelPar_KT1L_dX);
modelStruct.modelPar_TSS=mod.TSS;
modelStruct.d_modelPar_TSS_dX=0.0;
modelStruct.modelPar_given_TSS=mod.given("TSS");
modParamMap["TSS"] = &(modelStruct.d_modelPar_TSS_dX);
modelStruct.modelPar_IIT=mod.IIT;
modelStruct.d_modelPar_IIT_dX=0.0;
modelStruct.modelPar_given_IIT=mod.given("IIT");
modParamMap["IIT"] = &(modelStruct.d_modelPar_IIT_dX);
modelStruct.modelPar_TII=mod.TII;
modelStruct.d_modelPar_TII_dX=0.0;
modelStruct.modelPar_given_TII=mod.given("TII");
modParamMap["TII"] = &(modelStruct.d_modelPar_TII_dX);
modelStruct.modelPar_TGIDL=mod.TGIDL;
modelStruct.d_modelPar_TGIDL_dX=0.0;
modelStruct.modelPar_given_TGIDL=mod.given("TGIDL");
modParamMap["TGIDL"] = &(modelStruct.d_modelPar_TGIDL_dX);
modelStruct.modelPar_IGT=mod.IGT;
modelStruct.d_modelPar_IGT_dX=0.0;
modelStruct.modelPar_given_IGT=mod.given("IGT");
modParamMap["IGT"] = &(modelStruct.d_modelPar_IGT_dX);
modelStruct.modelPar_TCJ=mod.TCJ;
modelStruct.d_modelPar_TCJ_dX=0.0;
modelStruct.modelPar_given_TCJ=mod.given("TCJ");
modParamMap["TCJ"] = &(modelStruct.d_modelPar_TCJ_dX);
modelStruct.modelPar_TCJSW=mod.TCJSW;
modelStruct.d_modelPar_TCJSW_dX=0.0;
modelStruct.modelPar_given_TCJSW=mod.given("TCJSW");
modParamMap["TCJSW"] = &(modelStruct.d_modelPar_TCJSW_dX);
modelStruct.modelPar_TCJSWG=mod.TCJSWG;
modelStruct.d_modelPar_TCJSWG_dX=0.0;
modelStruct.modelPar_given_TCJSWG=mod.given("TCJSWG");
modParamMap["TCJSWG"] = &(modelStruct.d_modelPar_TCJSWG_dX);
modelStruct.modelPar_TPB=mod.TPB;
modelStruct.d_modelPar_TPB_dX=0.0;
modelStruct.modelPar_given_TPB=mod.given("TPB");
modParamMap["TPB"] = &(modelStruct.d_modelPar_TPB_dX);
modelStruct.modelPar_TPBSW=mod.TPBSW;
modelStruct.d_modelPar_TPBSW_dX=0.0;
modelStruct.modelPar_given_TPBSW=mod.given("TPBSW");
modParamMap["TPBSW"] = &(modelStruct.d_modelPar_TPBSW_dX);
modelStruct.modelPar_TPBSWG=mod.TPBSWG;
modelStruct.d_modelPar_TPBSWG_dX=0.0;
modelStruct.modelPar_given_TPBSWG=mod.given("TPBSWG");
modParamMap["TPBSWG"] = &(modelStruct.d_modelPar_TPBSWG_dX);
modelStruct.modelPar_XTIS=mod.XTIS;
modelStruct.d_modelPar_XTIS_dX=0.0;
modelStruct.modelPar_given_XTIS=mod.given("XTIS");
modParamMap["XTIS"] = &(modelStruct.d_modelPar_XTIS_dX);
modelStruct.modelPar_XTID=mod.XTID;
modelStruct.d_modelPar_XTID_dX=0.0;
modelStruct.modelPar_given_XTID=mod.given("XTID");
modParamMap["XTID"] = &(modelStruct.d_modelPar_XTID_dX);
modelStruct.modelPar_XTSS=mod.XTSS;
modelStruct.d_modelPar_XTSS_dX=0.0;
modelStruct.modelPar_given_XTSS=mod.given("XTSS");
modParamMap["XTSS"] = &(modelStruct.d_modelPar_XTSS_dX);
modelStruct.modelPar_XTSD=mod.XTSD;
modelStruct.d_modelPar_XTSD_dX=0.0;
modelStruct.modelPar_given_XTSD=mod.given("XTSD");
modParamMap["XTSD"] = &(modelStruct.d_modelPar_XTSD_dX);
modelStruct.modelPar_XTSSWS=mod.XTSSWS;
modelStruct.d_modelPar_XTSSWS_dX=0.0;
modelStruct.modelPar_given_XTSSWS=mod.given("XTSSWS");
modParamMap["XTSSWS"] = &(modelStruct.d_modelPar_XTSSWS_dX);
modelStruct.modelPar_XTSSWD=mod.XTSSWD;
modelStruct.d_modelPar_XTSSWD_dX=0.0;
modelStruct.modelPar_given_XTSSWD=mod.given("XTSSWD");
modParamMap["XTSSWD"] = &(modelStruct.d_modelPar_XTSSWD_dX);
modelStruct.modelPar_XTSSWGS=mod.XTSSWGS;
modelStruct.d_modelPar_XTSSWGS_dX=0.0;
modelStruct.modelPar_given_XTSSWGS=mod.given("XTSSWGS");
modParamMap["XTSSWGS"] = &(modelStruct.d_modelPar_XTSSWGS_dX);
modelStruct.modelPar_XTSSWGD=mod.XTSSWGD;
modelStruct.d_modelPar_XTSSWGD_dX=0.0;
modelStruct.modelPar_given_XTSSWGD=mod.given("XTSSWGD");
modParamMap["XTSSWGD"] = &(modelStruct.d_modelPar_XTSSWGD_dX);
modelStruct.modelPar_TNJTS=mod.TNJTS;
modelStruct.d_modelPar_TNJTS_dX=0.0;
modelStruct.modelPar_given_TNJTS=mod.given("TNJTS");
modParamMap["TNJTS"] = &(modelStruct.d_modelPar_TNJTS_dX);
modelStruct.modelPar_TNJTSD=mod.TNJTSD;
modelStruct.d_modelPar_TNJTSD_dX=0.0;
modelStruct.modelPar_given_TNJTSD=mod.given("TNJTSD");
modParamMap["TNJTSD"] = &(modelStruct.d_modelPar_TNJTSD_dX);
modelStruct.modelPar_TNJTSSW=mod.TNJTSSW;
modelStruct.d_modelPar_TNJTSSW_dX=0.0;
modelStruct.modelPar_given_TNJTSSW=mod.given("TNJTSSW");
modParamMap["TNJTSSW"] = &(modelStruct.d_modelPar_TNJTSSW_dX);
modelStruct.modelPar_TNJTSSWD=mod.TNJTSSWD;
modelStruct.d_modelPar_TNJTSSWD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWD=mod.given("TNJTSSWD");
modParamMap["TNJTSSWD"] = &(modelStruct.d_modelPar_TNJTSSWD_dX);
modelStruct.modelPar_TNJTSSWG=mod.TNJTSSWG;
modelStruct.d_modelPar_TNJTSSWG_dX=0.0;
modelStruct.modelPar_given_TNJTSSWG=mod.given("TNJTSSWG");
modParamMap["TNJTSSWG"] = &(modelStruct.d_modelPar_TNJTSSWG_dX);
modelStruct.modelPar_TNJTSSWGD=mod.TNJTSSWGD;
modelStruct.d_modelPar_TNJTSSWGD_dX=0.0;
modelStruct.modelPar_given_TNJTSSWGD=mod.given("TNJTSSWGD");
modParamMap["TNJTSSWGD"] = &(modelStruct.d_modelPar_TNJTSSWGD_dX);
modelStruct.modelPar_RTH0=mod.RTH0;
modelStruct.d_modelPar_RTH0_dX=0.0;
modelStruct.modelPar_given_RTH0=mod.given("RTH0");
modParamMap["RTH0"] = &(modelStruct.d_modelPar_RTH0_dX);
modelStruct.modelPar_CTH0=mod.CTH0;
modelStruct.d_modelPar_CTH0_dX=0.0;
modelStruct.modelPar_given_CTH0=mod.given("CTH0");
modParamMap["CTH0"] = &(modelStruct.d_modelPar_CTH0_dX);
modelStruct.modelPar_WTH0=mod.WTH0;
modelStruct.d_modelPar_WTH0_dX=0.0;
modelStruct.modelPar_given_WTH0=mod.given("WTH0");
modParamMap["WTH0"] = &(modelStruct.d_modelPar_WTH0_dX);
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modParamMap["LMIN"] = &(modelStruct.d_modelPar_LMIN_dX);
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modParamMap["LMAX"] = &(modelStruct.d_modelPar_LMAX_dX);
modelStruct.modelPar_NFINMIN=mod.NFINMIN;
modelStruct.d_modelPar_NFINMIN_dX=0.0;
modelStruct.modelPar_given_NFINMIN=mod.given("NFINMIN");
modParamMap["NFINMIN"] = &(modelStruct.d_modelPar_NFINMIN_dX);
modelStruct.modelPar_NFINMAX=mod.NFINMAX;
modelStruct.d_modelPar_NFINMAX_dX=0.0;
modelStruct.modelPar_given_NFINMAX=mod.given("NFINMAX");
modParamMap["NFINMAX"] = &(modelStruct.d_modelPar_NFINMAX_dX);
modelStruct.modelPar_LNBODY=mod.LNBODY;
modelStruct.d_modelPar_LNBODY_dX=0.0;
modelStruct.modelPar_given_LNBODY=mod.given("LNBODY");
modParamMap["LNBODY"] = &(modelStruct.d_modelPar_LNBODY_dX);
modelStruct.modelPar_NNBODY=mod.NNBODY;
modelStruct.d_modelPar_NNBODY_dX=0.0;
modelStruct.modelPar_given_NNBODY=mod.given("NNBODY");
modParamMap["NNBODY"] = &(modelStruct.d_modelPar_NNBODY_dX);
modelStruct.modelPar_PNBODY=mod.PNBODY;
modelStruct.d_modelPar_PNBODY_dX=0.0;
modelStruct.modelPar_given_PNBODY=mod.given("PNBODY");
modParamMap["PNBODY"] = &(modelStruct.d_modelPar_PNBODY_dX);
modelStruct.modelPar_LPHIG=mod.LPHIG;
modelStruct.d_modelPar_LPHIG_dX=0.0;
modelStruct.modelPar_given_LPHIG=mod.given("LPHIG");
modParamMap["LPHIG"] = &(modelStruct.d_modelPar_LPHIG_dX);
modelStruct.modelPar_NPHIG=mod.NPHIG;
modelStruct.d_modelPar_NPHIG_dX=0.0;
modelStruct.modelPar_given_NPHIG=mod.given("NPHIG");
modParamMap["NPHIG"] = &(modelStruct.d_modelPar_NPHIG_dX);
modelStruct.modelPar_PPHIG=mod.PPHIG;
modelStruct.d_modelPar_PPHIG_dX=0.0;
modelStruct.modelPar_given_PPHIG=mod.given("PPHIG");
modParamMap["PPHIG"] = &(modelStruct.d_modelPar_PPHIG_dX);
modelStruct.modelPar_LNGATE=mod.LNGATE;
modelStruct.d_modelPar_LNGATE_dX=0.0;
modelStruct.modelPar_given_LNGATE=mod.given("LNGATE");
modParamMap["LNGATE"] = &(modelStruct.d_modelPar_LNGATE_dX);
modelStruct.modelPar_NNGATE=mod.NNGATE;
modelStruct.d_modelPar_NNGATE_dX=0.0;
modelStruct.modelPar_given_NNGATE=mod.given("NNGATE");
modParamMap["NNGATE"] = &(modelStruct.d_modelPar_NNGATE_dX);
modelStruct.modelPar_PNGATE=mod.PNGATE;
modelStruct.d_modelPar_PNGATE_dX=0.0;
modelStruct.modelPar_given_PNGATE=mod.given("PNGATE");
modParamMap["PNGATE"] = &(modelStruct.d_modelPar_PNGATE_dX);
modelStruct.modelPar_LCIT=mod.LCIT;
modelStruct.d_modelPar_LCIT_dX=0.0;
modelStruct.modelPar_given_LCIT=mod.given("LCIT");
modParamMap["LCIT"] = &(modelStruct.d_modelPar_LCIT_dX);
modelStruct.modelPar_NCIT=mod.NCIT;
modelStruct.d_modelPar_NCIT_dX=0.0;
modelStruct.modelPar_given_NCIT=mod.given("NCIT");
modParamMap["NCIT"] = &(modelStruct.d_modelPar_NCIT_dX);
modelStruct.modelPar_PCIT=mod.PCIT;
modelStruct.d_modelPar_PCIT_dX=0.0;
modelStruct.modelPar_given_PCIT=mod.given("PCIT");
modParamMap["PCIT"] = &(modelStruct.d_modelPar_PCIT_dX);
modelStruct.modelPar_LCDSC=mod.LCDSC;
modelStruct.d_modelPar_LCDSC_dX=0.0;
modelStruct.modelPar_given_LCDSC=mod.given("LCDSC");
modParamMap["LCDSC"] = &(modelStruct.d_modelPar_LCDSC_dX);
modelStruct.modelPar_NCDSC=mod.NCDSC;
modelStruct.d_modelPar_NCDSC_dX=0.0;
modelStruct.modelPar_given_NCDSC=mod.given("NCDSC");
modParamMap["NCDSC"] = &(modelStruct.d_modelPar_NCDSC_dX);
modelStruct.modelPar_PCDSC=mod.PCDSC;
modelStruct.d_modelPar_PCDSC_dX=0.0;
modelStruct.modelPar_given_PCDSC=mod.given("PCDSC");
modParamMap["PCDSC"] = &(modelStruct.d_modelPar_PCDSC_dX);
modelStruct.modelPar_LCDSCD=mod.LCDSCD;
modelStruct.d_modelPar_LCDSCD_dX=0.0;
modelStruct.modelPar_given_LCDSCD=mod.given("LCDSCD");
modParamMap["LCDSCD"] = &(modelStruct.d_modelPar_LCDSCD_dX);
modelStruct.modelPar_NCDSCD=mod.NCDSCD;
modelStruct.d_modelPar_NCDSCD_dX=0.0;
modelStruct.modelPar_given_NCDSCD=mod.given("NCDSCD");
modParamMap["NCDSCD"] = &(modelStruct.d_modelPar_NCDSCD_dX);
modelStruct.modelPar_PCDSCD=mod.PCDSCD;
modelStruct.d_modelPar_PCDSCD_dX=0.0;
modelStruct.modelPar_given_PCDSCD=mod.given("PCDSCD");
modParamMap["PCDSCD"] = &(modelStruct.d_modelPar_PCDSCD_dX);
modelStruct.modelPar_LCDSCDR=mod.LCDSCDR;
modelStruct.d_modelPar_LCDSCDR_dX=0.0;
modelStruct.modelPar_given_LCDSCDR=mod.given("LCDSCDR");
modParamMap["LCDSCDR"] = &(modelStruct.d_modelPar_LCDSCDR_dX);
modelStruct.modelPar_NCDSCDR=mod.NCDSCDR;
modelStruct.d_modelPar_NCDSCDR_dX=0.0;
modelStruct.modelPar_given_NCDSCDR=mod.given("NCDSCDR");
modParamMap["NCDSCDR"] = &(modelStruct.d_modelPar_NCDSCDR_dX);
modelStruct.modelPar_PCDSCDR=mod.PCDSCDR;
modelStruct.d_modelPar_PCDSCDR_dX=0.0;
modelStruct.modelPar_given_PCDSCDR=mod.given("PCDSCDR");
modParamMap["PCDSCDR"] = &(modelStruct.d_modelPar_PCDSCDR_dX);
modelStruct.modelPar_LDVT0=mod.LDVT0;
modelStruct.d_modelPar_LDVT0_dX=0.0;
modelStruct.modelPar_given_LDVT0=mod.given("LDVT0");
modParamMap["LDVT0"] = &(modelStruct.d_modelPar_LDVT0_dX);
modelStruct.modelPar_NDVT0=mod.NDVT0;
modelStruct.d_modelPar_NDVT0_dX=0.0;
modelStruct.modelPar_given_NDVT0=mod.given("NDVT0");
modParamMap["NDVT0"] = &(modelStruct.d_modelPar_NDVT0_dX);
modelStruct.modelPar_PDVT0=mod.PDVT0;
modelStruct.d_modelPar_PDVT0_dX=0.0;
modelStruct.modelPar_given_PDVT0=mod.given("PDVT0");
modParamMap["PDVT0"] = &(modelStruct.d_modelPar_PDVT0_dX);
modelStruct.modelPar_LDVT1=mod.LDVT1;
modelStruct.d_modelPar_LDVT1_dX=0.0;
modelStruct.modelPar_given_LDVT1=mod.given("LDVT1");
modParamMap["LDVT1"] = &(modelStruct.d_modelPar_LDVT1_dX);
modelStruct.modelPar_NDVT1=mod.NDVT1;
modelStruct.d_modelPar_NDVT1_dX=0.0;
modelStruct.modelPar_given_NDVT1=mod.given("NDVT1");
modParamMap["NDVT1"] = &(modelStruct.d_modelPar_NDVT1_dX);
modelStruct.modelPar_PDVT1=mod.PDVT1;
modelStruct.d_modelPar_PDVT1_dX=0.0;
modelStruct.modelPar_given_PDVT1=mod.given("PDVT1");
modParamMap["PDVT1"] = &(modelStruct.d_modelPar_PDVT1_dX);
modelStruct.modelPar_LDVT1SS=mod.LDVT1SS;
modelStruct.d_modelPar_LDVT1SS_dX=0.0;
modelStruct.modelPar_given_LDVT1SS=mod.given("LDVT1SS");
modParamMap["LDVT1SS"] = &(modelStruct.d_modelPar_LDVT1SS_dX);
modelStruct.modelPar_NDVT1SS=mod.NDVT1SS;
modelStruct.d_modelPar_NDVT1SS_dX=0.0;
modelStruct.modelPar_given_NDVT1SS=mod.given("NDVT1SS");
modParamMap["NDVT1SS"] = &(modelStruct.d_modelPar_NDVT1SS_dX);
modelStruct.modelPar_PDVT1SS=mod.PDVT1SS;
modelStruct.d_modelPar_PDVT1SS_dX=0.0;
modelStruct.modelPar_given_PDVT1SS=mod.given("PDVT1SS");
modParamMap["PDVT1SS"] = &(modelStruct.d_modelPar_PDVT1SS_dX);
modelStruct.modelPar_LPHIN=mod.LPHIN;
modelStruct.d_modelPar_LPHIN_dX=0.0;
modelStruct.modelPar_given_LPHIN=mod.given("LPHIN");
modParamMap["LPHIN"] = &(modelStruct.d_modelPar_LPHIN_dX);
modelStruct.modelPar_NPHIN=mod.NPHIN;
modelStruct.d_modelPar_NPHIN_dX=0.0;
modelStruct.modelPar_given_NPHIN=mod.given("NPHIN");
modParamMap["NPHIN"] = &(modelStruct.d_modelPar_NPHIN_dX);
modelStruct.modelPar_PPHIN=mod.PPHIN;
modelStruct.d_modelPar_PPHIN_dX=0.0;
modelStruct.modelPar_given_PPHIN=mod.given("PPHIN");
modParamMap["PPHIN"] = &(modelStruct.d_modelPar_PPHIN_dX);
modelStruct.modelPar_LETA0=mod.LETA0;
modelStruct.d_modelPar_LETA0_dX=0.0;
modelStruct.modelPar_given_LETA0=mod.given("LETA0");
modParamMap["LETA0"] = &(modelStruct.d_modelPar_LETA0_dX);
modelStruct.modelPar_NETA0=mod.NETA0;
modelStruct.d_modelPar_NETA0_dX=0.0;
modelStruct.modelPar_given_NETA0=mod.given("NETA0");
modParamMap["NETA0"] = &(modelStruct.d_modelPar_NETA0_dX);
modelStruct.modelPar_PETA0=mod.PETA0;
modelStruct.d_modelPar_PETA0_dX=0.0;
modelStruct.modelPar_given_PETA0=mod.given("PETA0");
modParamMap["PETA0"] = &(modelStruct.d_modelPar_PETA0_dX);
modelStruct.modelPar_LETA0R=mod.LETA0R;
modelStruct.d_modelPar_LETA0R_dX=0.0;
modelStruct.modelPar_given_LETA0R=mod.given("LETA0R");
modParamMap["LETA0R"] = &(modelStruct.d_modelPar_LETA0R_dX);
modelStruct.modelPar_NETA0R=mod.NETA0R;
modelStruct.d_modelPar_NETA0R_dX=0.0;
modelStruct.modelPar_given_NETA0R=mod.given("NETA0R");
modParamMap["NETA0R"] = &(modelStruct.d_modelPar_NETA0R_dX);
modelStruct.modelPar_PETA0R=mod.PETA0R;
modelStruct.d_modelPar_PETA0R_dX=0.0;
modelStruct.modelPar_given_PETA0R=mod.given("PETA0R");
modParamMap["PETA0R"] = &(modelStruct.d_modelPar_PETA0R_dX);
modelStruct.modelPar_LDSUB=mod.LDSUB;
modelStruct.d_modelPar_LDSUB_dX=0.0;
modelStruct.modelPar_given_LDSUB=mod.given("LDSUB");
modParamMap["LDSUB"] = &(modelStruct.d_modelPar_LDSUB_dX);
modelStruct.modelPar_NDSUB=mod.NDSUB;
modelStruct.d_modelPar_NDSUB_dX=0.0;
modelStruct.modelPar_given_NDSUB=mod.given("NDSUB");
modParamMap["NDSUB"] = &(modelStruct.d_modelPar_NDSUB_dX);
modelStruct.modelPar_PDSUB=mod.PDSUB;
modelStruct.d_modelPar_PDSUB_dX=0.0;
modelStruct.modelPar_given_PDSUB=mod.given("PDSUB");
modParamMap["PDSUB"] = &(modelStruct.d_modelPar_PDSUB_dX);
modelStruct.modelPar_LK1RSCE=mod.LK1RSCE;
modelStruct.d_modelPar_LK1RSCE_dX=0.0;
modelStruct.modelPar_given_LK1RSCE=mod.given("LK1RSCE");
modParamMap["LK1RSCE"] = &(modelStruct.d_modelPar_LK1RSCE_dX);
modelStruct.modelPar_NK1RSCE=mod.NK1RSCE;
modelStruct.d_modelPar_NK1RSCE_dX=0.0;
modelStruct.modelPar_given_NK1RSCE=mod.given("NK1RSCE");
modParamMap["NK1RSCE"] = &(modelStruct.d_modelPar_NK1RSCE_dX);
modelStruct.modelPar_PK1RSCE=mod.PK1RSCE;
modelStruct.d_modelPar_PK1RSCE_dX=0.0;
modelStruct.modelPar_given_PK1RSCE=mod.given("PK1RSCE");
modParamMap["PK1RSCE"] = &(modelStruct.d_modelPar_PK1RSCE_dX);
modelStruct.modelPar_LLPE0=mod.LLPE0;
modelStruct.d_modelPar_LLPE0_dX=0.0;
modelStruct.modelPar_given_LLPE0=mod.given("LLPE0");
modParamMap["LLPE0"] = &(modelStruct.d_modelPar_LLPE0_dX);
modelStruct.modelPar_NLPE0=mod.NLPE0;
modelStruct.d_modelPar_NLPE0_dX=0.0;
modelStruct.modelPar_given_NLPE0=mod.given("NLPE0");
modParamMap["NLPE0"] = &(modelStruct.d_modelPar_NLPE0_dX);
modelStruct.modelPar_PLPE0=mod.PLPE0;
modelStruct.d_modelPar_PLPE0_dX=0.0;
modelStruct.modelPar_given_PLPE0=mod.given("PLPE0");
modParamMap["PLPE0"] = &(modelStruct.d_modelPar_PLPE0_dX);
modelStruct.modelPar_LDVTSHIFT=mod.LDVTSHIFT;
modelStruct.d_modelPar_LDVTSHIFT_dX=0.0;
modelStruct.modelPar_given_LDVTSHIFT=mod.given("LDVTSHIFT");
modParamMap["LDVTSHIFT"] = &(modelStruct.d_modelPar_LDVTSHIFT_dX);
modelStruct.modelPar_NDVTSHIFT=mod.NDVTSHIFT;
modelStruct.d_modelPar_NDVTSHIFT_dX=0.0;
modelStruct.modelPar_given_NDVTSHIFT=mod.given("NDVTSHIFT");
modParamMap["NDVTSHIFT"] = &(modelStruct.d_modelPar_NDVTSHIFT_dX);
modelStruct.modelPar_PDVTSHIFT=mod.PDVTSHIFT;
modelStruct.d_modelPar_PDVTSHIFT_dX=0.0;
modelStruct.modelPar_given_PDVTSHIFT=mod.given("PDVTSHIFT");
modParamMap["PDVTSHIFT"] = &(modelStruct.d_modelPar_PDVTSHIFT_dX);
modelStruct.modelPar_LPHIBE=mod.LPHIBE;
modelStruct.d_modelPar_LPHIBE_dX=0.0;
modelStruct.modelPar_given_LPHIBE=mod.given("LPHIBE");
modParamMap["LPHIBE"] = &(modelStruct.d_modelPar_LPHIBE_dX);
modelStruct.modelPar_NPHIBE=mod.NPHIBE;
modelStruct.d_modelPar_NPHIBE_dX=0.0;
modelStruct.modelPar_given_NPHIBE=mod.given("NPHIBE");
modParamMap["NPHIBE"] = &(modelStruct.d_modelPar_NPHIBE_dX);
modelStruct.modelPar_PPHIBE=mod.PPHIBE;
modelStruct.d_modelPar_PPHIBE_dX=0.0;
modelStruct.modelPar_given_PPHIBE=mod.given("PPHIBE");
modParamMap["PPHIBE"] = &(modelStruct.d_modelPar_PPHIBE_dX);
modelStruct.modelPar_LK0=mod.LK0;
modelStruct.d_modelPar_LK0_dX=0.0;
modelStruct.modelPar_given_LK0=mod.given("LK0");
modParamMap["LK0"] = &(modelStruct.d_modelPar_LK0_dX);
modelStruct.modelPar_NK0=mod.NK0;
modelStruct.d_modelPar_NK0_dX=0.0;
modelStruct.modelPar_given_NK0=mod.given("NK0");
modParamMap["NK0"] = &(modelStruct.d_modelPar_NK0_dX);
modelStruct.modelPar_PK0=mod.PK0;
modelStruct.d_modelPar_PK0_dX=0.0;
modelStruct.modelPar_given_PK0=mod.given("PK0");
modParamMap["PK0"] = &(modelStruct.d_modelPar_PK0_dX);
modelStruct.modelPar_LK01=mod.LK01;
modelStruct.d_modelPar_LK01_dX=0.0;
modelStruct.modelPar_given_LK01=mod.given("LK01");
modParamMap["LK01"] = &(modelStruct.d_modelPar_LK01_dX);
modelStruct.modelPar_NK01=mod.NK01;
modelStruct.d_modelPar_NK01_dX=0.0;
modelStruct.modelPar_given_NK01=mod.given("NK01");
modParamMap["NK01"] = &(modelStruct.d_modelPar_NK01_dX);
modelStruct.modelPar_PK01=mod.PK01;
modelStruct.d_modelPar_PK01_dX=0.0;
modelStruct.modelPar_given_PK01=mod.given("PK01");
modParamMap["PK01"] = &(modelStruct.d_modelPar_PK01_dX);
modelStruct.modelPar_LK0SI=mod.LK0SI;
modelStruct.d_modelPar_LK0SI_dX=0.0;
modelStruct.modelPar_given_LK0SI=mod.given("LK0SI");
modParamMap["LK0SI"] = &(modelStruct.d_modelPar_LK0SI_dX);
modelStruct.modelPar_NK0SI=mod.NK0SI;
modelStruct.d_modelPar_NK0SI_dX=0.0;
modelStruct.modelPar_given_NK0SI=mod.given("NK0SI");
modParamMap["NK0SI"] = &(modelStruct.d_modelPar_NK0SI_dX);
modelStruct.modelPar_PK0SI=mod.PK0SI;
modelStruct.d_modelPar_PK0SI_dX=0.0;
modelStruct.modelPar_given_PK0SI=mod.given("PK0SI");
modParamMap["PK0SI"] = &(modelStruct.d_modelPar_PK0SI_dX);
modelStruct.modelPar_LK0SI1=mod.LK0SI1;
modelStruct.d_modelPar_LK0SI1_dX=0.0;
modelStruct.modelPar_given_LK0SI1=mod.given("LK0SI1");
modParamMap["LK0SI1"] = &(modelStruct.d_modelPar_LK0SI1_dX);
modelStruct.modelPar_NK0SI1=mod.NK0SI1;
modelStruct.d_modelPar_NK0SI1_dX=0.0;
modelStruct.modelPar_given_NK0SI1=mod.given("NK0SI1");
modParamMap["NK0SI1"] = &(modelStruct.d_modelPar_NK0SI1_dX);
modelStruct.modelPar_PK0SI1=mod.PK0SI1;
modelStruct.d_modelPar_PK0SI1_dX=0.0;
modelStruct.modelPar_given_PK0SI1=mod.given("PK0SI1");
modParamMap["PK0SI1"] = &(modelStruct.d_modelPar_PK0SI1_dX);
modelStruct.modelPar_LK1SI=mod.LK1SI;
modelStruct.d_modelPar_LK1SI_dX=0.0;
modelStruct.modelPar_given_LK1SI=mod.given("LK1SI");
modParamMap["LK1SI"] = &(modelStruct.d_modelPar_LK1SI_dX);
modelStruct.modelPar_NK1SI=mod.NK1SI;
modelStruct.d_modelPar_NK1SI_dX=0.0;
modelStruct.modelPar_given_NK1SI=mod.given("NK1SI");
modParamMap["NK1SI"] = &(modelStruct.d_modelPar_NK1SI_dX);
modelStruct.modelPar_PK1SI=mod.PK1SI;
modelStruct.d_modelPar_PK1SI_dX=0.0;
modelStruct.modelPar_given_PK1SI=mod.given("PK1SI");
modParamMap["PK1SI"] = &(modelStruct.d_modelPar_PK1SI_dX);
modelStruct.modelPar_LK1SI1=mod.LK1SI1;
modelStruct.d_modelPar_LK1SI1_dX=0.0;
modelStruct.modelPar_given_LK1SI1=mod.given("LK1SI1");
modParamMap["LK1SI1"] = &(modelStruct.d_modelPar_LK1SI1_dX);
modelStruct.modelPar_NK1SI1=mod.NK1SI1;
modelStruct.d_modelPar_NK1SI1_dX=0.0;
modelStruct.modelPar_given_NK1SI1=mod.given("NK1SI1");
modParamMap["NK1SI1"] = &(modelStruct.d_modelPar_NK1SI1_dX);
modelStruct.modelPar_PK1SI1=mod.PK1SI1;
modelStruct.d_modelPar_PK1SI1_dX=0.0;
modelStruct.modelPar_given_PK1SI1=mod.given("PK1SI1");
modParamMap["PK1SI1"] = &(modelStruct.d_modelPar_PK1SI1_dX);
modelStruct.modelPar_LK1=mod.LK1;
modelStruct.d_modelPar_LK1_dX=0.0;
modelStruct.modelPar_given_LK1=mod.given("LK1");
modParamMap["LK1"] = &(modelStruct.d_modelPar_LK1_dX);
modelStruct.modelPar_NK1=mod.NK1;
modelStruct.d_modelPar_NK1_dX=0.0;
modelStruct.modelPar_given_NK1=mod.given("NK1");
modParamMap["NK1"] = &(modelStruct.d_modelPar_NK1_dX);
modelStruct.modelPar_PK1=mod.PK1;
modelStruct.d_modelPar_PK1_dX=0.0;
modelStruct.modelPar_given_PK1=mod.given("PK1");
modParamMap["PK1"] = &(modelStruct.d_modelPar_PK1_dX);
modelStruct.modelPar_LK11=mod.LK11;
modelStruct.d_modelPar_LK11_dX=0.0;
modelStruct.modelPar_given_LK11=mod.given("LK11");
modParamMap["LK11"] = &(modelStruct.d_modelPar_LK11_dX);
modelStruct.modelPar_NK11=mod.NK11;
modelStruct.d_modelPar_NK11_dX=0.0;
modelStruct.modelPar_given_NK11=mod.given("NK11");
modParamMap["NK11"] = &(modelStruct.d_modelPar_NK11_dX);
modelStruct.modelPar_PK11=mod.PK11;
modelStruct.d_modelPar_PK11_dX=0.0;
modelStruct.modelPar_given_PK11=mod.given("PK11");
modParamMap["PK11"] = &(modelStruct.d_modelPar_PK11_dX);
modelStruct.modelPar_LK1SAT=mod.LK1SAT;
modelStruct.d_modelPar_LK1SAT_dX=0.0;
modelStruct.modelPar_given_LK1SAT=mod.given("LK1SAT");
modParamMap["LK1SAT"] = &(modelStruct.d_modelPar_LK1SAT_dX);
modelStruct.modelPar_NK1SAT=mod.NK1SAT;
modelStruct.d_modelPar_NK1SAT_dX=0.0;
modelStruct.modelPar_given_NK1SAT=mod.given("NK1SAT");
modParamMap["NK1SAT"] = &(modelStruct.d_modelPar_NK1SAT_dX);
modelStruct.modelPar_PK1SAT=mod.PK1SAT;
modelStruct.d_modelPar_PK1SAT_dX=0.0;
modelStruct.modelPar_given_PK1SAT=mod.given("PK1SAT");
modParamMap["PK1SAT"] = &(modelStruct.d_modelPar_PK1SAT_dX);
modelStruct.modelPar_LK1SAT1=mod.LK1SAT1;
modelStruct.d_modelPar_LK1SAT1_dX=0.0;
modelStruct.modelPar_given_LK1SAT1=mod.given("LK1SAT1");
modParamMap["LK1SAT1"] = &(modelStruct.d_modelPar_LK1SAT1_dX);
modelStruct.modelPar_NK1SAT1=mod.NK1SAT1;
modelStruct.d_modelPar_NK1SAT1_dX=0.0;
modelStruct.modelPar_given_NK1SAT1=mod.given("NK1SAT1");
modParamMap["NK1SAT1"] = &(modelStruct.d_modelPar_NK1SAT1_dX);
modelStruct.modelPar_PK1SAT1=mod.PK1SAT1;
modelStruct.d_modelPar_PK1SAT1_dX=0.0;
modelStruct.modelPar_given_PK1SAT1=mod.given("PK1SAT1");
modParamMap["PK1SAT1"] = &(modelStruct.d_modelPar_PK1SAT1_dX);
modelStruct.modelPar_LDVTB=mod.LDVTB;
modelStruct.d_modelPar_LDVTB_dX=0.0;
modelStruct.modelPar_given_LDVTB=mod.given("LDVTB");
modParamMap["LDVTB"] = &(modelStruct.d_modelPar_LDVTB_dX);
modelStruct.modelPar_NDVTB=mod.NDVTB;
modelStruct.d_modelPar_NDVTB_dX=0.0;
modelStruct.modelPar_given_NDVTB=mod.given("NDVTB");
modParamMap["NDVTB"] = &(modelStruct.d_modelPar_NDVTB_dX);
modelStruct.modelPar_PDVTB=mod.PDVTB;
modelStruct.d_modelPar_PDVTB_dX=0.0;
modelStruct.modelPar_given_PDVTB=mod.given("PDVTB");
modParamMap["PDVTB"] = &(modelStruct.d_modelPar_PDVTB_dX);
modelStruct.modelPar_LLPEB=mod.LLPEB;
modelStruct.d_modelPar_LLPEB_dX=0.0;
modelStruct.modelPar_given_LLPEB=mod.given("LLPEB");
modParamMap["LLPEB"] = &(modelStruct.d_modelPar_LLPEB_dX);
modelStruct.modelPar_NLPEB=mod.NLPEB;
modelStruct.d_modelPar_NLPEB_dX=0.0;
modelStruct.modelPar_given_NLPEB=mod.given("NLPEB");
modParamMap["NLPEB"] = &(modelStruct.d_modelPar_NLPEB_dX);
modelStruct.modelPar_PLPEB=mod.PLPEB;
modelStruct.d_modelPar_PLPEB_dX=0.0;
modelStruct.modelPar_given_PLPEB=mod.given("PLPEB");
modParamMap["PLPEB"] = &(modelStruct.d_modelPar_PLPEB_dX);
modelStruct.modelPar_LQMFACTOR=mod.LQMFACTOR;
modelStruct.d_modelPar_LQMFACTOR_dX=0.0;
modelStruct.modelPar_given_LQMFACTOR=mod.given("LQMFACTOR");
modParamMap["LQMFACTOR"] = &(modelStruct.d_modelPar_LQMFACTOR_dX);
modelStruct.modelPar_NQMFACTOR=mod.NQMFACTOR;
modelStruct.d_modelPar_NQMFACTOR_dX=0.0;
modelStruct.modelPar_given_NQMFACTOR=mod.given("NQMFACTOR");
modParamMap["NQMFACTOR"] = &(modelStruct.d_modelPar_NQMFACTOR_dX);
modelStruct.modelPar_PQMFACTOR=mod.PQMFACTOR;
modelStruct.d_modelPar_PQMFACTOR_dX=0.0;
modelStruct.modelPar_given_PQMFACTOR=mod.given("PQMFACTOR");
modParamMap["PQMFACTOR"] = &(modelStruct.d_modelPar_PQMFACTOR_dX);
modelStruct.modelPar_LQMTCENIV=mod.LQMTCENIV;
modelStruct.d_modelPar_LQMTCENIV_dX=0.0;
modelStruct.modelPar_given_LQMTCENIV=mod.given("LQMTCENIV");
modParamMap["LQMTCENIV"] = &(modelStruct.d_modelPar_LQMTCENIV_dX);
modelStruct.modelPar_NQMTCENIV=mod.NQMTCENIV;
modelStruct.d_modelPar_NQMTCENIV_dX=0.0;
modelStruct.modelPar_given_NQMTCENIV=mod.given("NQMTCENIV");
modParamMap["NQMTCENIV"] = &(modelStruct.d_modelPar_NQMTCENIV_dX);
modelStruct.modelPar_PQMTCENIV=mod.PQMTCENIV;
modelStruct.d_modelPar_PQMTCENIV_dX=0.0;
modelStruct.modelPar_given_PQMTCENIV=mod.given("PQMTCENIV");
modParamMap["PQMTCENIV"] = &(modelStruct.d_modelPar_PQMTCENIV_dX);
modelStruct.modelPar_LQMTCENCV=mod.LQMTCENCV;
modelStruct.d_modelPar_LQMTCENCV_dX=0.0;
modelStruct.modelPar_given_LQMTCENCV=mod.given("LQMTCENCV");
modParamMap["LQMTCENCV"] = &(modelStruct.d_modelPar_LQMTCENCV_dX);
modelStruct.modelPar_NQMTCENCV=mod.NQMTCENCV;
modelStruct.d_modelPar_NQMTCENCV_dX=0.0;
modelStruct.modelPar_given_NQMTCENCV=mod.given("NQMTCENCV");
modParamMap["NQMTCENCV"] = &(modelStruct.d_modelPar_NQMTCENCV_dX);
modelStruct.modelPar_PQMTCENCV=mod.PQMTCENCV;
modelStruct.d_modelPar_PQMTCENCV_dX=0.0;
modelStruct.modelPar_given_PQMTCENCV=mod.given("PQMTCENCV");
modParamMap["PQMTCENCV"] = &(modelStruct.d_modelPar_PQMTCENCV_dX);
modelStruct.modelPar_LQMTCENCVA=mod.LQMTCENCVA;
modelStruct.d_modelPar_LQMTCENCVA_dX=0.0;
modelStruct.modelPar_given_LQMTCENCVA=mod.given("LQMTCENCVA");
modParamMap["LQMTCENCVA"] = &(modelStruct.d_modelPar_LQMTCENCVA_dX);
modelStruct.modelPar_NQMTCENCVA=mod.NQMTCENCVA;
modelStruct.d_modelPar_NQMTCENCVA_dX=0.0;
modelStruct.modelPar_given_NQMTCENCVA=mod.given("NQMTCENCVA");
modParamMap["NQMTCENCVA"] = &(modelStruct.d_modelPar_NQMTCENCVA_dX);
modelStruct.modelPar_PQMTCENCVA=mod.PQMTCENCVA;
modelStruct.d_modelPar_PQMTCENCVA_dX=0.0;
modelStruct.modelPar_given_PQMTCENCVA=mod.given("PQMTCENCVA");
modParamMap["PQMTCENCVA"] = &(modelStruct.d_modelPar_PQMTCENCVA_dX);
modelStruct.modelPar_LVSAT=mod.LVSAT;
modelStruct.d_modelPar_LVSAT_dX=0.0;
modelStruct.modelPar_given_LVSAT=mod.given("LVSAT");
modParamMap["LVSAT"] = &(modelStruct.d_modelPar_LVSAT_dX);
modelStruct.modelPar_NVSAT=mod.NVSAT;
modelStruct.d_modelPar_NVSAT_dX=0.0;
modelStruct.modelPar_given_NVSAT=mod.given("NVSAT");
modParamMap["NVSAT"] = &(modelStruct.d_modelPar_NVSAT_dX);
modelStruct.modelPar_PVSAT=mod.PVSAT;
modelStruct.d_modelPar_PVSAT_dX=0.0;
modelStruct.modelPar_given_PVSAT=mod.given("PVSAT");
modParamMap["PVSAT"] = &(modelStruct.d_modelPar_PVSAT_dX);
modelStruct.modelPar_LVSAT1=mod.LVSAT1;
modelStruct.d_modelPar_LVSAT1_dX=0.0;
modelStruct.modelPar_given_LVSAT1=mod.given("LVSAT1");
modParamMap["LVSAT1"] = &(modelStruct.d_modelPar_LVSAT1_dX);
modelStruct.modelPar_NVSAT1=mod.NVSAT1;
modelStruct.d_modelPar_NVSAT1_dX=0.0;
modelStruct.modelPar_given_NVSAT1=mod.given("NVSAT1");
modParamMap["NVSAT1"] = &(modelStruct.d_modelPar_NVSAT1_dX);
modelStruct.modelPar_PVSAT1=mod.PVSAT1;
modelStruct.d_modelPar_PVSAT1_dX=0.0;
modelStruct.modelPar_given_PVSAT1=mod.given("PVSAT1");
modParamMap["PVSAT1"] = &(modelStruct.d_modelPar_PVSAT1_dX);
modelStruct.modelPar_LVSAT1R=mod.LVSAT1R;
modelStruct.d_modelPar_LVSAT1R_dX=0.0;
modelStruct.modelPar_given_LVSAT1R=mod.given("LVSAT1R");
modParamMap["LVSAT1R"] = &(modelStruct.d_modelPar_LVSAT1R_dX);
modelStruct.modelPar_NVSAT1R=mod.NVSAT1R;
modelStruct.d_modelPar_NVSAT1R_dX=0.0;
modelStruct.modelPar_given_NVSAT1R=mod.given("NVSAT1R");
modParamMap["NVSAT1R"] = &(modelStruct.d_modelPar_NVSAT1R_dX);
modelStruct.modelPar_PVSAT1R=mod.PVSAT1R;
modelStruct.d_modelPar_PVSAT1R_dX=0.0;
modelStruct.modelPar_given_PVSAT1R=mod.given("PVSAT1R");
modParamMap["PVSAT1R"] = &(modelStruct.d_modelPar_PVSAT1R_dX);
modelStruct.modelPar_LPSAT=mod.LPSAT;
modelStruct.d_modelPar_LPSAT_dX=0.0;
modelStruct.modelPar_given_LPSAT=mod.given("LPSAT");
modParamMap["LPSAT"] = &(modelStruct.d_modelPar_LPSAT_dX);
modelStruct.modelPar_NPSAT=mod.NPSAT;
modelStruct.d_modelPar_NPSAT_dX=0.0;
modelStruct.modelPar_given_NPSAT=mod.given("NPSAT");
modParamMap["NPSAT"] = &(modelStruct.d_modelPar_NPSAT_dX);
modelStruct.modelPar_PPSAT=mod.PPSAT;
modelStruct.d_modelPar_PPSAT_dX=0.0;
modelStruct.modelPar_given_PPSAT=mod.given("PPSAT");
modParamMap["PPSAT"] = &(modelStruct.d_modelPar_PPSAT_dX);
modelStruct.modelPar_LDELTAVSAT=mod.LDELTAVSAT;
modelStruct.d_modelPar_LDELTAVSAT_dX=0.0;
modelStruct.modelPar_given_LDELTAVSAT=mod.given("LDELTAVSAT");
modParamMap["LDELTAVSAT"] = &(modelStruct.d_modelPar_LDELTAVSAT_dX);
modelStruct.modelPar_NDELTAVSAT=mod.NDELTAVSAT;
modelStruct.d_modelPar_NDELTAVSAT_dX=0.0;
modelStruct.modelPar_given_NDELTAVSAT=mod.given("NDELTAVSAT");
modParamMap["NDELTAVSAT"] = &(modelStruct.d_modelPar_NDELTAVSAT_dX);
modelStruct.modelPar_PDELTAVSAT=mod.PDELTAVSAT;
modelStruct.d_modelPar_PDELTAVSAT_dX=0.0;
modelStruct.modelPar_given_PDELTAVSAT=mod.given("PDELTAVSAT");
modParamMap["PDELTAVSAT"] = &(modelStruct.d_modelPar_PDELTAVSAT_dX);
modelStruct.modelPar_LKSATIV=mod.LKSATIV;
modelStruct.d_modelPar_LKSATIV_dX=0.0;
modelStruct.modelPar_given_LKSATIV=mod.given("LKSATIV");
modParamMap["LKSATIV"] = &(modelStruct.d_modelPar_LKSATIV_dX);
modelStruct.modelPar_NKSATIV=mod.NKSATIV;
modelStruct.d_modelPar_NKSATIV_dX=0.0;
modelStruct.modelPar_given_NKSATIV=mod.given("NKSATIV");
modParamMap["NKSATIV"] = &(modelStruct.d_modelPar_NKSATIV_dX);
modelStruct.modelPar_PKSATIV=mod.PKSATIV;
modelStruct.d_modelPar_PKSATIV_dX=0.0;
modelStruct.modelPar_given_PKSATIV=mod.given("PKSATIV");
modParamMap["PKSATIV"] = &(modelStruct.d_modelPar_PKSATIV_dX);
modelStruct.modelPar_LVSATCV=mod.LVSATCV;
modelStruct.d_modelPar_LVSATCV_dX=0.0;
modelStruct.modelPar_given_LVSATCV=mod.given("LVSATCV");
modParamMap["LVSATCV"] = &(modelStruct.d_modelPar_LVSATCV_dX);
modelStruct.modelPar_NVSATCV=mod.NVSATCV;
modelStruct.d_modelPar_NVSATCV_dX=0.0;
modelStruct.modelPar_given_NVSATCV=mod.given("NVSATCV");
modParamMap["NVSATCV"] = &(modelStruct.d_modelPar_NVSATCV_dX);
modelStruct.modelPar_PVSATCV=mod.PVSATCV;
modelStruct.d_modelPar_PVSATCV_dX=0.0;
modelStruct.modelPar_given_PVSATCV=mod.given("PVSATCV");
modParamMap["PVSATCV"] = &(modelStruct.d_modelPar_PVSATCV_dX);
modelStruct.modelPar_LPSATCV=mod.LPSATCV;
modelStruct.d_modelPar_LPSATCV_dX=0.0;
modelStruct.modelPar_given_LPSATCV=mod.given("LPSATCV");
modParamMap["LPSATCV"] = &(modelStruct.d_modelPar_LPSATCV_dX);
modelStruct.modelPar_NPSATCV=mod.NPSATCV;
modelStruct.d_modelPar_NPSATCV_dX=0.0;
modelStruct.modelPar_given_NPSATCV=mod.given("NPSATCV");
modParamMap["NPSATCV"] = &(modelStruct.d_modelPar_NPSATCV_dX);
modelStruct.modelPar_PPSATCV=mod.PPSATCV;
modelStruct.d_modelPar_PPSATCV_dX=0.0;
modelStruct.modelPar_given_PPSATCV=mod.given("PPSATCV");
modParamMap["PPSATCV"] = &(modelStruct.d_modelPar_PPSATCV_dX);
modelStruct.modelPar_LDELTAVSATCV=mod.LDELTAVSATCV;
modelStruct.d_modelPar_LDELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_LDELTAVSATCV=mod.given("LDELTAVSATCV");
modParamMap["LDELTAVSATCV"] = &(modelStruct.d_modelPar_LDELTAVSATCV_dX);
modelStruct.modelPar_NDELTAVSATCV=mod.NDELTAVSATCV;
modelStruct.d_modelPar_NDELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_NDELTAVSATCV=mod.given("NDELTAVSATCV");
modParamMap["NDELTAVSATCV"] = &(modelStruct.d_modelPar_NDELTAVSATCV_dX);
modelStruct.modelPar_PDELTAVSATCV=mod.PDELTAVSATCV;
modelStruct.d_modelPar_PDELTAVSATCV_dX=0.0;
modelStruct.modelPar_given_PDELTAVSATCV=mod.given("PDELTAVSATCV");
modParamMap["PDELTAVSATCV"] = &(modelStruct.d_modelPar_PDELTAVSATCV_dX);
modelStruct.modelPar_LMEXP=mod.LMEXP;
modelStruct.d_modelPar_LMEXP_dX=0.0;
modelStruct.modelPar_given_LMEXP=mod.given("LMEXP");
modParamMap["LMEXP"] = &(modelStruct.d_modelPar_LMEXP_dX);
modelStruct.modelPar_NMEXP=mod.NMEXP;
modelStruct.d_modelPar_NMEXP_dX=0.0;
modelStruct.modelPar_given_NMEXP=mod.given("NMEXP");
modParamMap["NMEXP"] = &(modelStruct.d_modelPar_NMEXP_dX);
modelStruct.modelPar_PMEXP=mod.PMEXP;
modelStruct.d_modelPar_PMEXP_dX=0.0;
modelStruct.modelPar_given_PMEXP=mod.given("PMEXP");
modParamMap["PMEXP"] = &(modelStruct.d_modelPar_PMEXP_dX);
modelStruct.modelPar_LMEXPR=mod.LMEXPR;
modelStruct.d_modelPar_LMEXPR_dX=0.0;
modelStruct.modelPar_given_LMEXPR=mod.given("LMEXPR");
modParamMap["LMEXPR"] = &(modelStruct.d_modelPar_LMEXPR_dX);
modelStruct.modelPar_NMEXPR=mod.NMEXPR;
modelStruct.d_modelPar_NMEXPR_dX=0.0;
modelStruct.modelPar_given_NMEXPR=mod.given("NMEXPR");
modParamMap["NMEXPR"] = &(modelStruct.d_modelPar_NMEXPR_dX);
modelStruct.modelPar_PMEXPR=mod.PMEXPR;
modelStruct.d_modelPar_PMEXPR_dX=0.0;
modelStruct.modelPar_given_PMEXPR=mod.given("PMEXPR");
modParamMap["PMEXPR"] = &(modelStruct.d_modelPar_PMEXPR_dX);
modelStruct.modelPar_LPTWG=mod.LPTWG;
modelStruct.d_modelPar_LPTWG_dX=0.0;
modelStruct.modelPar_given_LPTWG=mod.given("LPTWG");
modParamMap["LPTWG"] = &(modelStruct.d_modelPar_LPTWG_dX);
modelStruct.modelPar_NPTWG=mod.NPTWG;
modelStruct.d_modelPar_NPTWG_dX=0.0;
modelStruct.modelPar_given_NPTWG=mod.given("NPTWG");
modParamMap["NPTWG"] = &(modelStruct.d_modelPar_NPTWG_dX);
modelStruct.modelPar_PPTWG=mod.PPTWG;
modelStruct.d_modelPar_PPTWG_dX=0.0;
modelStruct.modelPar_given_PPTWG=mod.given("PPTWG");
modParamMap["PPTWG"] = &(modelStruct.d_modelPar_PPTWG_dX);
modelStruct.modelPar_LPTWGR=mod.LPTWGR;
modelStruct.d_modelPar_LPTWGR_dX=0.0;
modelStruct.modelPar_given_LPTWGR=mod.given("LPTWGR");
modParamMap["LPTWGR"] = &(modelStruct.d_modelPar_LPTWGR_dX);
modelStruct.modelPar_NPTWGR=mod.NPTWGR;
modelStruct.d_modelPar_NPTWGR_dX=0.0;
modelStruct.modelPar_given_NPTWGR=mod.given("NPTWGR");
modParamMap["NPTWGR"] = &(modelStruct.d_modelPar_NPTWGR_dX);
modelStruct.modelPar_PPTWGR=mod.PPTWGR;
modelStruct.d_modelPar_PPTWGR_dX=0.0;
modelStruct.modelPar_given_PPTWGR=mod.given("PPTWGR");
modParamMap["PPTWGR"] = &(modelStruct.d_modelPar_PPTWGR_dX);
modelStruct.modelPar_LU0=mod.LU0;
modelStruct.d_modelPar_LU0_dX=0.0;
modelStruct.modelPar_given_LU0=mod.given("LU0");
modParamMap["LU0"] = &(modelStruct.d_modelPar_LU0_dX);
modelStruct.modelPar_NU0=mod.NU0;
modelStruct.d_modelPar_NU0_dX=0.0;
modelStruct.modelPar_given_NU0=mod.given("NU0");
modParamMap["NU0"] = &(modelStruct.d_modelPar_NU0_dX);
modelStruct.modelPar_PU0=mod.PU0;
modelStruct.d_modelPar_PU0_dX=0.0;
modelStruct.modelPar_given_PU0=mod.given("PU0");
modParamMap["PU0"] = &(modelStruct.d_modelPar_PU0_dX);
modelStruct.modelPar_LETAMOB=mod.LETAMOB;
modelStruct.d_modelPar_LETAMOB_dX=0.0;
modelStruct.modelPar_given_LETAMOB=mod.given("LETAMOB");
modParamMap["LETAMOB"] = &(modelStruct.d_modelPar_LETAMOB_dX);
modelStruct.modelPar_NETAMOB=mod.NETAMOB;
modelStruct.d_modelPar_NETAMOB_dX=0.0;
modelStruct.modelPar_given_NETAMOB=mod.given("NETAMOB");
modParamMap["NETAMOB"] = &(modelStruct.d_modelPar_NETAMOB_dX);
modelStruct.modelPar_PETAMOB=mod.PETAMOB;
modelStruct.d_modelPar_PETAMOB_dX=0.0;
modelStruct.modelPar_given_PETAMOB=mod.given("PETAMOB");
modParamMap["PETAMOB"] = &(modelStruct.d_modelPar_PETAMOB_dX);
modelStruct.modelPar_LUP=mod.LUP;
modelStruct.d_modelPar_LUP_dX=0.0;
modelStruct.modelPar_given_LUP=mod.given("LUP");
modParamMap["LUP"] = &(modelStruct.d_modelPar_LUP_dX);
modelStruct.modelPar_NUP=mod.NUP;
modelStruct.d_modelPar_NUP_dX=0.0;
modelStruct.modelPar_given_NUP=mod.given("NUP");
modParamMap["NUP"] = &(modelStruct.d_modelPar_NUP_dX);
modelStruct.modelPar_PUP=mod.PUP;
modelStruct.d_modelPar_PUP_dX=0.0;
modelStruct.modelPar_given_PUP=mod.given("PUP");
modParamMap["PUP"] = &(modelStruct.d_modelPar_PUP_dX);
modelStruct.modelPar_LUA=mod.LUA;
modelStruct.d_modelPar_LUA_dX=0.0;
modelStruct.modelPar_given_LUA=mod.given("LUA");
modParamMap["LUA"] = &(modelStruct.d_modelPar_LUA_dX);
modelStruct.modelPar_NUA=mod.NUA;
modelStruct.d_modelPar_NUA_dX=0.0;
modelStruct.modelPar_given_NUA=mod.given("NUA");
modParamMap["NUA"] = &(modelStruct.d_modelPar_NUA_dX);
modelStruct.modelPar_PUA=mod.PUA;
modelStruct.d_modelPar_PUA_dX=0.0;
modelStruct.modelPar_given_PUA=mod.given("PUA");
modParamMap["PUA"] = &(modelStruct.d_modelPar_PUA_dX);
modelStruct.modelPar_LUC=mod.LUC;
modelStruct.d_modelPar_LUC_dX=0.0;
modelStruct.modelPar_given_LUC=mod.given("LUC");
modParamMap["LUC"] = &(modelStruct.d_modelPar_LUC_dX);
modelStruct.modelPar_NUC=mod.NUC;
modelStruct.d_modelPar_NUC_dX=0.0;
modelStruct.modelPar_given_NUC=mod.given("NUC");
modParamMap["NUC"] = &(modelStruct.d_modelPar_NUC_dX);
modelStruct.modelPar_PUC=mod.PUC;
modelStruct.d_modelPar_PUC_dX=0.0;
modelStruct.modelPar_given_PUC=mod.given("PUC");
modParamMap["PUC"] = &(modelStruct.d_modelPar_PUC_dX);
modelStruct.modelPar_LEU=mod.LEU;
modelStruct.d_modelPar_LEU_dX=0.0;
modelStruct.modelPar_given_LEU=mod.given("LEU");
modParamMap["LEU"] = &(modelStruct.d_modelPar_LEU_dX);
modelStruct.modelPar_NEU=mod.NEU;
modelStruct.d_modelPar_NEU_dX=0.0;
modelStruct.modelPar_given_NEU=mod.given("NEU");
modParamMap["NEU"] = &(modelStruct.d_modelPar_NEU_dX);
modelStruct.modelPar_PEU=mod.PEU;
modelStruct.d_modelPar_PEU_dX=0.0;
modelStruct.modelPar_given_PEU=mod.given("PEU");
modParamMap["PEU"] = &(modelStruct.d_modelPar_PEU_dX);
modelStruct.modelPar_LUD=mod.LUD;
modelStruct.d_modelPar_LUD_dX=0.0;
modelStruct.modelPar_given_LUD=mod.given("LUD");
modParamMap["LUD"] = &(modelStruct.d_modelPar_LUD_dX);
modelStruct.modelPar_NUD=mod.NUD;
modelStruct.d_modelPar_NUD_dX=0.0;
modelStruct.modelPar_given_NUD=mod.given("NUD");
modParamMap["NUD"] = &(modelStruct.d_modelPar_NUD_dX);
modelStruct.modelPar_PUD=mod.PUD;
modelStruct.d_modelPar_PUD_dX=0.0;
modelStruct.modelPar_given_PUD=mod.given("PUD");
modParamMap["PUD"] = &(modelStruct.d_modelPar_PUD_dX);
modelStruct.modelPar_LUCS=mod.LUCS;
modelStruct.d_modelPar_LUCS_dX=0.0;
modelStruct.modelPar_given_LUCS=mod.given("LUCS");
modParamMap["LUCS"] = &(modelStruct.d_modelPar_LUCS_dX);
modelStruct.modelPar_NUCS=mod.NUCS;
modelStruct.d_modelPar_NUCS_dX=0.0;
modelStruct.modelPar_given_NUCS=mod.given("NUCS");
modParamMap["NUCS"] = &(modelStruct.d_modelPar_NUCS_dX);
modelStruct.modelPar_PUCS=mod.PUCS;
modelStruct.d_modelPar_PUCS_dX=0.0;
modelStruct.modelPar_given_PUCS=mod.given("PUCS");
modParamMap["PUCS"] = &(modelStruct.d_modelPar_PUCS_dX);
modelStruct.modelPar_LPCLM=mod.LPCLM;
modelStruct.d_modelPar_LPCLM_dX=0.0;
modelStruct.modelPar_given_LPCLM=mod.given("LPCLM");
modParamMap["LPCLM"] = &(modelStruct.d_modelPar_LPCLM_dX);
modelStruct.modelPar_NPCLM=mod.NPCLM;
modelStruct.d_modelPar_NPCLM_dX=0.0;
modelStruct.modelPar_given_NPCLM=mod.given("NPCLM");
modParamMap["NPCLM"] = &(modelStruct.d_modelPar_NPCLM_dX);
modelStruct.modelPar_PPCLM=mod.PPCLM;
modelStruct.d_modelPar_PPCLM_dX=0.0;
modelStruct.modelPar_given_PPCLM=mod.given("PPCLM");
modParamMap["PPCLM"] = &(modelStruct.d_modelPar_PPCLM_dX);
modelStruct.modelPar_LPCLMG=mod.LPCLMG;
modelStruct.d_modelPar_LPCLMG_dX=0.0;
modelStruct.modelPar_given_LPCLMG=mod.given("LPCLMG");
modParamMap["LPCLMG"] = &(modelStruct.d_modelPar_LPCLMG_dX);
modelStruct.modelPar_NPCLMG=mod.NPCLMG;
modelStruct.d_modelPar_NPCLMG_dX=0.0;
modelStruct.modelPar_given_NPCLMG=mod.given("NPCLMG");
modParamMap["NPCLMG"] = &(modelStruct.d_modelPar_NPCLMG_dX);
modelStruct.modelPar_PPCLMG=mod.PPCLMG;
modelStruct.d_modelPar_PPCLMG_dX=0.0;
modelStruct.modelPar_given_PPCLMG=mod.given("PPCLMG");
modParamMap["PPCLMG"] = &(modelStruct.d_modelPar_PPCLMG_dX);
modelStruct.modelPar_LPCLMCV=mod.LPCLMCV;
modelStruct.d_modelPar_LPCLMCV_dX=0.0;
modelStruct.modelPar_given_LPCLMCV=mod.given("LPCLMCV");
modParamMap["LPCLMCV"] = &(modelStruct.d_modelPar_LPCLMCV_dX);
modelStruct.modelPar_NPCLMCV=mod.NPCLMCV;
modelStruct.d_modelPar_NPCLMCV_dX=0.0;
modelStruct.modelPar_given_NPCLMCV=mod.given("NPCLMCV");
modParamMap["NPCLMCV"] = &(modelStruct.d_modelPar_NPCLMCV_dX);
modelStruct.modelPar_PPCLMCV=mod.PPCLMCV;
modelStruct.d_modelPar_PPCLMCV_dX=0.0;
modelStruct.modelPar_given_PPCLMCV=mod.given("PPCLMCV");
modParamMap["PPCLMCV"] = &(modelStruct.d_modelPar_PPCLMCV_dX);
modelStruct.modelPar_LA1=mod.LA1;
modelStruct.d_modelPar_LA1_dX=0.0;
modelStruct.modelPar_given_LA1=mod.given("LA1");
modParamMap["LA1"] = &(modelStruct.d_modelPar_LA1_dX);
modelStruct.modelPar_NA1=mod.NA1;
modelStruct.d_modelPar_NA1_dX=0.0;
modelStruct.modelPar_given_NA1=mod.given("NA1");
modParamMap["NA1"] = &(modelStruct.d_modelPar_NA1_dX);
modelStruct.modelPar_PA1=mod.PA1;
modelStruct.d_modelPar_PA1_dX=0.0;
modelStruct.modelPar_given_PA1=mod.given("PA1");
modParamMap["PA1"] = &(modelStruct.d_modelPar_PA1_dX);
modelStruct.modelPar_LA11=mod.LA11;
modelStruct.d_modelPar_LA11_dX=0.0;
modelStruct.modelPar_given_LA11=mod.given("LA11");
modParamMap["LA11"] = &(modelStruct.d_modelPar_LA11_dX);
modelStruct.modelPar_NA11=mod.NA11;
modelStruct.d_modelPar_NA11_dX=0.0;
modelStruct.modelPar_given_NA11=mod.given("NA11");
modParamMap["NA11"] = &(modelStruct.d_modelPar_NA11_dX);
modelStruct.modelPar_PA11=mod.PA11;
modelStruct.d_modelPar_PA11_dX=0.0;
modelStruct.modelPar_given_PA11=mod.given("PA11");
modParamMap["PA11"] = &(modelStruct.d_modelPar_PA11_dX);
modelStruct.modelPar_LA2=mod.LA2;
modelStruct.d_modelPar_LA2_dX=0.0;
modelStruct.modelPar_given_LA2=mod.given("LA2");
modParamMap["LA2"] = &(modelStruct.d_modelPar_LA2_dX);
modelStruct.modelPar_NA2=mod.NA2;
modelStruct.d_modelPar_NA2_dX=0.0;
modelStruct.modelPar_given_NA2=mod.given("NA2");
modParamMap["NA2"] = &(modelStruct.d_modelPar_NA2_dX);
modelStruct.modelPar_PA2=mod.PA2;
modelStruct.d_modelPar_PA2_dX=0.0;
modelStruct.modelPar_given_PA2=mod.given("PA2");
modParamMap["PA2"] = &(modelStruct.d_modelPar_PA2_dX);
modelStruct.modelPar_LA21=mod.LA21;
modelStruct.d_modelPar_LA21_dX=0.0;
modelStruct.modelPar_given_LA21=mod.given("LA21");
modParamMap["LA21"] = &(modelStruct.d_modelPar_LA21_dX);
modelStruct.modelPar_NA21=mod.NA21;
modelStruct.d_modelPar_NA21_dX=0.0;
modelStruct.modelPar_given_NA21=mod.given("NA21");
modParamMap["NA21"] = &(modelStruct.d_modelPar_NA21_dX);
modelStruct.modelPar_PA21=mod.PA21;
modelStruct.d_modelPar_PA21_dX=0.0;
modelStruct.modelPar_given_PA21=mod.given("PA21");
modParamMap["PA21"] = &(modelStruct.d_modelPar_PA21_dX);
modelStruct.modelPar_LRDSW=mod.LRDSW;
modelStruct.d_modelPar_LRDSW_dX=0.0;
modelStruct.modelPar_given_LRDSW=mod.given("LRDSW");
modParamMap["LRDSW"] = &(modelStruct.d_modelPar_LRDSW_dX);
modelStruct.modelPar_NRDSW=mod.NRDSW;
modelStruct.d_modelPar_NRDSW_dX=0.0;
modelStruct.modelPar_given_NRDSW=mod.given("NRDSW");
modParamMap["NRDSW"] = &(modelStruct.d_modelPar_NRDSW_dX);
modelStruct.modelPar_PRDSW=mod.PRDSW;
modelStruct.d_modelPar_PRDSW_dX=0.0;
modelStruct.modelPar_given_PRDSW=mod.given("PRDSW");
modParamMap["PRDSW"] = &(modelStruct.d_modelPar_PRDSW_dX);
modelStruct.modelPar_LRSW=mod.LRSW;
modelStruct.d_modelPar_LRSW_dX=0.0;
modelStruct.modelPar_given_LRSW=mod.given("LRSW");
modParamMap["LRSW"] = &(modelStruct.d_modelPar_LRSW_dX);
modelStruct.modelPar_NRSW=mod.NRSW;
modelStruct.d_modelPar_NRSW_dX=0.0;
modelStruct.modelPar_given_NRSW=mod.given("NRSW");
modParamMap["NRSW"] = &(modelStruct.d_modelPar_NRSW_dX);
modelStruct.modelPar_PRSW=mod.PRSW;
modelStruct.d_modelPar_PRSW_dX=0.0;
modelStruct.modelPar_given_PRSW=mod.given("PRSW");
modParamMap["PRSW"] = &(modelStruct.d_modelPar_PRSW_dX);
modelStruct.modelPar_LRDW=mod.LRDW;
modelStruct.d_modelPar_LRDW_dX=0.0;
modelStruct.modelPar_given_LRDW=mod.given("LRDW");
modParamMap["LRDW"] = &(modelStruct.d_modelPar_LRDW_dX);
modelStruct.modelPar_NRDW=mod.NRDW;
modelStruct.d_modelPar_NRDW_dX=0.0;
modelStruct.modelPar_given_NRDW=mod.given("NRDW");
modParamMap["NRDW"] = &(modelStruct.d_modelPar_NRDW_dX);
modelStruct.modelPar_PRDW=mod.PRDW;
modelStruct.d_modelPar_PRDW_dX=0.0;
modelStruct.modelPar_given_PRDW=mod.given("PRDW");
modParamMap["PRDW"] = &(modelStruct.d_modelPar_PRDW_dX);
modelStruct.modelPar_LPRWGS=mod.LPRWGS;
modelStruct.d_modelPar_LPRWGS_dX=0.0;
modelStruct.modelPar_given_LPRWGS=mod.given("LPRWGS");
modParamMap["LPRWGS"] = &(modelStruct.d_modelPar_LPRWGS_dX);
modelStruct.modelPar_NPRWGS=mod.NPRWGS;
modelStruct.d_modelPar_NPRWGS_dX=0.0;
modelStruct.modelPar_given_NPRWGS=mod.given("NPRWGS");
modParamMap["NPRWGS"] = &(modelStruct.d_modelPar_NPRWGS_dX);
modelStruct.modelPar_PPRWGS=mod.PPRWGS;
modelStruct.d_modelPar_PPRWGS_dX=0.0;
modelStruct.modelPar_given_PPRWGS=mod.given("PPRWGS");
modParamMap["PPRWGS"] = &(modelStruct.d_modelPar_PPRWGS_dX);
modelStruct.modelPar_LPRWGD=mod.LPRWGD;
modelStruct.d_modelPar_LPRWGD_dX=0.0;
modelStruct.modelPar_given_LPRWGD=mod.given("LPRWGD");
modParamMap["LPRWGD"] = &(modelStruct.d_modelPar_LPRWGD_dX);
modelStruct.modelPar_NPRWGD=mod.NPRWGD;
modelStruct.d_modelPar_NPRWGD_dX=0.0;
modelStruct.modelPar_given_NPRWGD=mod.given("NPRWGD");
modParamMap["NPRWGD"] = &(modelStruct.d_modelPar_NPRWGD_dX);
modelStruct.modelPar_PPRWGD=mod.PPRWGD;
modelStruct.d_modelPar_PPRWGD_dX=0.0;
modelStruct.modelPar_given_PPRWGD=mod.given("PPRWGD");
modParamMap["PPRWGD"] = &(modelStruct.d_modelPar_PPRWGD_dX);
modelStruct.modelPar_LWR=mod.LWR;
modelStruct.d_modelPar_LWR_dX=0.0;
modelStruct.modelPar_given_LWR=mod.given("LWR");
modParamMap["LWR"] = &(modelStruct.d_modelPar_LWR_dX);
modelStruct.modelPar_NWR=mod.NWR;
modelStruct.d_modelPar_NWR_dX=0.0;
modelStruct.modelPar_given_NWR=mod.given("NWR");
modParamMap["NWR"] = &(modelStruct.d_modelPar_NWR_dX);
modelStruct.modelPar_PWR=mod.PWR;
modelStruct.d_modelPar_PWR_dX=0.0;
modelStruct.modelPar_given_PWR=mod.given("PWR");
modParamMap["PWR"] = &(modelStruct.d_modelPar_PWR_dX);
modelStruct.modelPar_LPDIBL1=mod.LPDIBL1;
modelStruct.d_modelPar_LPDIBL1_dX=0.0;
modelStruct.modelPar_given_LPDIBL1=mod.given("LPDIBL1");
modParamMap["LPDIBL1"] = &(modelStruct.d_modelPar_LPDIBL1_dX);
modelStruct.modelPar_NPDIBL1=mod.NPDIBL1;
modelStruct.d_modelPar_NPDIBL1_dX=0.0;
modelStruct.modelPar_given_NPDIBL1=mod.given("NPDIBL1");
modParamMap["NPDIBL1"] = &(modelStruct.d_modelPar_NPDIBL1_dX);
modelStruct.modelPar_PPDIBL1=mod.PPDIBL1;
modelStruct.d_modelPar_PPDIBL1_dX=0.0;
modelStruct.modelPar_given_PPDIBL1=mod.given("PPDIBL1");
modParamMap["PPDIBL1"] = &(modelStruct.d_modelPar_PPDIBL1_dX);
modelStruct.modelPar_LPDIBL1R=mod.LPDIBL1R;
modelStruct.d_modelPar_LPDIBL1R_dX=0.0;
modelStruct.modelPar_given_LPDIBL1R=mod.given("LPDIBL1R");
modParamMap["LPDIBL1R"] = &(modelStruct.d_modelPar_LPDIBL1R_dX);
modelStruct.modelPar_NPDIBL1R=mod.NPDIBL1R;
modelStruct.d_modelPar_NPDIBL1R_dX=0.0;
modelStruct.modelPar_given_NPDIBL1R=mod.given("NPDIBL1R");
modParamMap["NPDIBL1R"] = &(modelStruct.d_modelPar_NPDIBL1R_dX);
modelStruct.modelPar_PPDIBL1R=mod.PPDIBL1R;
modelStruct.d_modelPar_PPDIBL1R_dX=0.0;
modelStruct.modelPar_given_PPDIBL1R=mod.given("PPDIBL1R");
modParamMap["PPDIBL1R"] = &(modelStruct.d_modelPar_PPDIBL1R_dX);
modelStruct.modelPar_LPDIBL2=mod.LPDIBL2;
modelStruct.d_modelPar_LPDIBL2_dX=0.0;
modelStruct.modelPar_given_LPDIBL2=mod.given("LPDIBL2");
modParamMap["LPDIBL2"] = &(modelStruct.d_modelPar_LPDIBL2_dX);
modelStruct.modelPar_NPDIBL2=mod.NPDIBL2;
modelStruct.d_modelPar_NPDIBL2_dX=0.0;
modelStruct.modelPar_given_NPDIBL2=mod.given("NPDIBL2");
modParamMap["NPDIBL2"] = &(modelStruct.d_modelPar_NPDIBL2_dX);
modelStruct.modelPar_PPDIBL2=mod.PPDIBL2;
modelStruct.d_modelPar_PPDIBL2_dX=0.0;
modelStruct.modelPar_given_PPDIBL2=mod.given("PPDIBL2");
modParamMap["PPDIBL2"] = &(modelStruct.d_modelPar_PPDIBL2_dX);
modelStruct.modelPar_LDROUT=mod.LDROUT;
modelStruct.d_modelPar_LDROUT_dX=0.0;
modelStruct.modelPar_given_LDROUT=mod.given("LDROUT");
modParamMap["LDROUT"] = &(modelStruct.d_modelPar_LDROUT_dX);
modelStruct.modelPar_NDROUT=mod.NDROUT;
modelStruct.d_modelPar_NDROUT_dX=0.0;
modelStruct.modelPar_given_NDROUT=mod.given("NDROUT");
modParamMap["NDROUT"] = &(modelStruct.d_modelPar_NDROUT_dX);
modelStruct.modelPar_PDROUT=mod.PDROUT;
modelStruct.d_modelPar_PDROUT_dX=0.0;
modelStruct.modelPar_given_PDROUT=mod.given("PDROUT");
modParamMap["PDROUT"] = &(modelStruct.d_modelPar_PDROUT_dX);
modelStruct.modelPar_LPVAG=mod.LPVAG;
modelStruct.d_modelPar_LPVAG_dX=0.0;
modelStruct.modelPar_given_LPVAG=mod.given("LPVAG");
modParamMap["LPVAG"] = &(modelStruct.d_modelPar_LPVAG_dX);
modelStruct.modelPar_NPVAG=mod.NPVAG;
modelStruct.d_modelPar_NPVAG_dX=0.0;
modelStruct.modelPar_given_NPVAG=mod.given("NPVAG");
modParamMap["NPVAG"] = &(modelStruct.d_modelPar_NPVAG_dX);
modelStruct.modelPar_PPVAG=mod.PPVAG;
modelStruct.d_modelPar_PPVAG_dX=0.0;
modelStruct.modelPar_given_PPVAG=mod.given("PPVAG");
modParamMap["PPVAG"] = &(modelStruct.d_modelPar_PPVAG_dX);
modelStruct.modelPar_LAIGBINV=mod.LAIGBINV;
modelStruct.d_modelPar_LAIGBINV_dX=0.0;
modelStruct.modelPar_given_LAIGBINV=mod.given("LAIGBINV");
modParamMap["LAIGBINV"] = &(modelStruct.d_modelPar_LAIGBINV_dX);
modelStruct.modelPar_NAIGBINV=mod.NAIGBINV;
modelStruct.d_modelPar_NAIGBINV_dX=0.0;
modelStruct.modelPar_given_NAIGBINV=mod.given("NAIGBINV");
modParamMap["NAIGBINV"] = &(modelStruct.d_modelPar_NAIGBINV_dX);
modelStruct.modelPar_PAIGBINV=mod.PAIGBINV;
modelStruct.d_modelPar_PAIGBINV_dX=0.0;
modelStruct.modelPar_given_PAIGBINV=mod.given("PAIGBINV");
modParamMap["PAIGBINV"] = &(modelStruct.d_modelPar_PAIGBINV_dX);
modelStruct.modelPar_LAIGBINV1=mod.LAIGBINV1;
modelStruct.d_modelPar_LAIGBINV1_dX=0.0;
modelStruct.modelPar_given_LAIGBINV1=mod.given("LAIGBINV1");
modParamMap["LAIGBINV1"] = &(modelStruct.d_modelPar_LAIGBINV1_dX);
modelStruct.modelPar_NAIGBINV1=mod.NAIGBINV1;
modelStruct.d_modelPar_NAIGBINV1_dX=0.0;
modelStruct.modelPar_given_NAIGBINV1=mod.given("NAIGBINV1");
modParamMap["NAIGBINV1"] = &(modelStruct.d_modelPar_NAIGBINV1_dX);
modelStruct.modelPar_PAIGBINV1=mod.PAIGBINV1;
modelStruct.d_modelPar_PAIGBINV1_dX=0.0;
modelStruct.modelPar_given_PAIGBINV1=mod.given("PAIGBINV1");
modParamMap["PAIGBINV1"] = &(modelStruct.d_modelPar_PAIGBINV1_dX);
modelStruct.modelPar_LBIGBINV=mod.LBIGBINV;
modelStruct.d_modelPar_LBIGBINV_dX=0.0;
modelStruct.modelPar_given_LBIGBINV=mod.given("LBIGBINV");
modParamMap["LBIGBINV"] = &(modelStruct.d_modelPar_LBIGBINV_dX);
modelStruct.modelPar_NBIGBINV=mod.NBIGBINV;
modelStruct.d_modelPar_NBIGBINV_dX=0.0;
modelStruct.modelPar_given_NBIGBINV=mod.given("NBIGBINV");
modParamMap["NBIGBINV"] = &(modelStruct.d_modelPar_NBIGBINV_dX);
modelStruct.modelPar_PBIGBINV=mod.PBIGBINV;
modelStruct.d_modelPar_PBIGBINV_dX=0.0;
modelStruct.modelPar_given_PBIGBINV=mod.given("PBIGBINV");
modParamMap["PBIGBINV"] = &(modelStruct.d_modelPar_PBIGBINV_dX);
modelStruct.modelPar_LCIGBINV=mod.LCIGBINV;
modelStruct.d_modelPar_LCIGBINV_dX=0.0;
modelStruct.modelPar_given_LCIGBINV=mod.given("LCIGBINV");
modParamMap["LCIGBINV"] = &(modelStruct.d_modelPar_LCIGBINV_dX);
modelStruct.modelPar_NCIGBINV=mod.NCIGBINV;
modelStruct.d_modelPar_NCIGBINV_dX=0.0;
modelStruct.modelPar_given_NCIGBINV=mod.given("NCIGBINV");
modParamMap["NCIGBINV"] = &(modelStruct.d_modelPar_NCIGBINV_dX);
modelStruct.modelPar_PCIGBINV=mod.PCIGBINV;
modelStruct.d_modelPar_PCIGBINV_dX=0.0;
modelStruct.modelPar_given_PCIGBINV=mod.given("PCIGBINV");
modParamMap["PCIGBINV"] = &(modelStruct.d_modelPar_PCIGBINV_dX);
modelStruct.modelPar_LEIGBINV=mod.LEIGBINV;
modelStruct.d_modelPar_LEIGBINV_dX=0.0;
modelStruct.modelPar_given_LEIGBINV=mod.given("LEIGBINV");
modParamMap["LEIGBINV"] = &(modelStruct.d_modelPar_LEIGBINV_dX);
modelStruct.modelPar_NEIGBINV=mod.NEIGBINV;
modelStruct.d_modelPar_NEIGBINV_dX=0.0;
modelStruct.modelPar_given_NEIGBINV=mod.given("NEIGBINV");
modParamMap["NEIGBINV"] = &(modelStruct.d_modelPar_NEIGBINV_dX);
modelStruct.modelPar_PEIGBINV=mod.PEIGBINV;
modelStruct.d_modelPar_PEIGBINV_dX=0.0;
modelStruct.modelPar_given_PEIGBINV=mod.given("PEIGBINV");
modParamMap["PEIGBINV"] = &(modelStruct.d_modelPar_PEIGBINV_dX);
modelStruct.modelPar_LNIGBINV=mod.LNIGBINV;
modelStruct.d_modelPar_LNIGBINV_dX=0.0;
modelStruct.modelPar_given_LNIGBINV=mod.given("LNIGBINV");
modParamMap["LNIGBINV"] = &(modelStruct.d_modelPar_LNIGBINV_dX);
modelStruct.modelPar_NNIGBINV=mod.NNIGBINV;
modelStruct.d_modelPar_NNIGBINV_dX=0.0;
modelStruct.modelPar_given_NNIGBINV=mod.given("NNIGBINV");
modParamMap["NNIGBINV"] = &(modelStruct.d_modelPar_NNIGBINV_dX);
modelStruct.modelPar_PNIGBINV=mod.PNIGBINV;
modelStruct.d_modelPar_PNIGBINV_dX=0.0;
modelStruct.modelPar_given_PNIGBINV=mod.given("PNIGBINV");
modParamMap["PNIGBINV"] = &(modelStruct.d_modelPar_PNIGBINV_dX);
modelStruct.modelPar_LAIGBACC=mod.LAIGBACC;
modelStruct.d_modelPar_LAIGBACC_dX=0.0;
modelStruct.modelPar_given_LAIGBACC=mod.given("LAIGBACC");
modParamMap["LAIGBACC"] = &(modelStruct.d_modelPar_LAIGBACC_dX);
modelStruct.modelPar_NAIGBACC=mod.NAIGBACC;
modelStruct.d_modelPar_NAIGBACC_dX=0.0;
modelStruct.modelPar_given_NAIGBACC=mod.given("NAIGBACC");
modParamMap["NAIGBACC"] = &(modelStruct.d_modelPar_NAIGBACC_dX);
modelStruct.modelPar_PAIGBACC=mod.PAIGBACC;
modelStruct.d_modelPar_PAIGBACC_dX=0.0;
modelStruct.modelPar_given_PAIGBACC=mod.given("PAIGBACC");
modParamMap["PAIGBACC"] = &(modelStruct.d_modelPar_PAIGBACC_dX);
modelStruct.modelPar_LAIGBACC1=mod.LAIGBACC1;
modelStruct.d_modelPar_LAIGBACC1_dX=0.0;
modelStruct.modelPar_given_LAIGBACC1=mod.given("LAIGBACC1");
modParamMap["LAIGBACC1"] = &(modelStruct.d_modelPar_LAIGBACC1_dX);
modelStruct.modelPar_NAIGBACC1=mod.NAIGBACC1;
modelStruct.d_modelPar_NAIGBACC1_dX=0.0;
modelStruct.modelPar_given_NAIGBACC1=mod.given("NAIGBACC1");
modParamMap["NAIGBACC1"] = &(modelStruct.d_modelPar_NAIGBACC1_dX);
modelStruct.modelPar_PAIGBACC1=mod.PAIGBACC1;
modelStruct.d_modelPar_PAIGBACC1_dX=0.0;
modelStruct.modelPar_given_PAIGBACC1=mod.given("PAIGBACC1");
modParamMap["PAIGBACC1"] = &(modelStruct.d_modelPar_PAIGBACC1_dX);
modelStruct.modelPar_LBIGBACC=mod.LBIGBACC;
modelStruct.d_modelPar_LBIGBACC_dX=0.0;
modelStruct.modelPar_given_LBIGBACC=mod.given("LBIGBACC");
modParamMap["LBIGBACC"] = &(modelStruct.d_modelPar_LBIGBACC_dX);
modelStruct.modelPar_NBIGBACC=mod.NBIGBACC;
modelStruct.d_modelPar_NBIGBACC_dX=0.0;
modelStruct.modelPar_given_NBIGBACC=mod.given("NBIGBACC");
modParamMap["NBIGBACC"] = &(modelStruct.d_modelPar_NBIGBACC_dX);
modelStruct.modelPar_PBIGBACC=mod.PBIGBACC;
modelStruct.d_modelPar_PBIGBACC_dX=0.0;
modelStruct.modelPar_given_PBIGBACC=mod.given("PBIGBACC");
modParamMap["PBIGBACC"] = &(modelStruct.d_modelPar_PBIGBACC_dX);
modelStruct.modelPar_LCIGBACC=mod.LCIGBACC;
modelStruct.d_modelPar_LCIGBACC_dX=0.0;
modelStruct.modelPar_given_LCIGBACC=mod.given("LCIGBACC");
modParamMap["LCIGBACC"] = &(modelStruct.d_modelPar_LCIGBACC_dX);
modelStruct.modelPar_NCIGBACC=mod.NCIGBACC;
modelStruct.d_modelPar_NCIGBACC_dX=0.0;
modelStruct.modelPar_given_NCIGBACC=mod.given("NCIGBACC");
modParamMap["NCIGBACC"] = &(modelStruct.d_modelPar_NCIGBACC_dX);
modelStruct.modelPar_PCIGBACC=mod.PCIGBACC;
modelStruct.d_modelPar_PCIGBACC_dX=0.0;
modelStruct.modelPar_given_PCIGBACC=mod.given("PCIGBACC");
modParamMap["PCIGBACC"] = &(modelStruct.d_modelPar_PCIGBACC_dX);
modelStruct.modelPar_LNIGBACC=mod.LNIGBACC;
modelStruct.d_modelPar_LNIGBACC_dX=0.0;
modelStruct.modelPar_given_LNIGBACC=mod.given("LNIGBACC");
modParamMap["LNIGBACC"] = &(modelStruct.d_modelPar_LNIGBACC_dX);
modelStruct.modelPar_NNIGBACC=mod.NNIGBACC;
modelStruct.d_modelPar_NNIGBACC_dX=0.0;
modelStruct.modelPar_given_NNIGBACC=mod.given("NNIGBACC");
modParamMap["NNIGBACC"] = &(modelStruct.d_modelPar_NNIGBACC_dX);
modelStruct.modelPar_PNIGBACC=mod.PNIGBACC;
modelStruct.d_modelPar_PNIGBACC_dX=0.0;
modelStruct.modelPar_given_PNIGBACC=mod.given("PNIGBACC");
modParamMap["PNIGBACC"] = &(modelStruct.d_modelPar_PNIGBACC_dX);
modelStruct.modelPar_LAIGC=mod.LAIGC;
modelStruct.d_modelPar_LAIGC_dX=0.0;
modelStruct.modelPar_given_LAIGC=mod.given("LAIGC");
modParamMap["LAIGC"] = &(modelStruct.d_modelPar_LAIGC_dX);
modelStruct.modelPar_NAIGC=mod.NAIGC;
modelStruct.d_modelPar_NAIGC_dX=0.0;
modelStruct.modelPar_given_NAIGC=mod.given("NAIGC");
modParamMap["NAIGC"] = &(modelStruct.d_modelPar_NAIGC_dX);
modelStruct.modelPar_PAIGC=mod.PAIGC;
modelStruct.d_modelPar_PAIGC_dX=0.0;
modelStruct.modelPar_given_PAIGC=mod.given("PAIGC");
modParamMap["PAIGC"] = &(modelStruct.d_modelPar_PAIGC_dX);
modelStruct.modelPar_LAIGC1=mod.LAIGC1;
modelStruct.d_modelPar_LAIGC1_dX=0.0;
modelStruct.modelPar_given_LAIGC1=mod.given("LAIGC1");
modParamMap["LAIGC1"] = &(modelStruct.d_modelPar_LAIGC1_dX);
modelStruct.modelPar_NAIGC1=mod.NAIGC1;
modelStruct.d_modelPar_NAIGC1_dX=0.0;
modelStruct.modelPar_given_NAIGC1=mod.given("NAIGC1");
modParamMap["NAIGC1"] = &(modelStruct.d_modelPar_NAIGC1_dX);
modelStruct.modelPar_PAIGC1=mod.PAIGC1;
modelStruct.d_modelPar_PAIGC1_dX=0.0;
modelStruct.modelPar_given_PAIGC1=mod.given("PAIGC1");
modParamMap["PAIGC1"] = &(modelStruct.d_modelPar_PAIGC1_dX);
modelStruct.modelPar_LBIGC=mod.LBIGC;
modelStruct.d_modelPar_LBIGC_dX=0.0;
modelStruct.modelPar_given_LBIGC=mod.given("LBIGC");
modParamMap["LBIGC"] = &(modelStruct.d_modelPar_LBIGC_dX);
modelStruct.modelPar_NBIGC=mod.NBIGC;
modelStruct.d_modelPar_NBIGC_dX=0.0;
modelStruct.modelPar_given_NBIGC=mod.given("NBIGC");
modParamMap["NBIGC"] = &(modelStruct.d_modelPar_NBIGC_dX);
modelStruct.modelPar_PBIGC=mod.PBIGC;
modelStruct.d_modelPar_PBIGC_dX=0.0;
modelStruct.modelPar_given_PBIGC=mod.given("PBIGC");
modParamMap["PBIGC"] = &(modelStruct.d_modelPar_PBIGC_dX);
modelStruct.modelPar_LCIGC=mod.LCIGC;
modelStruct.d_modelPar_LCIGC_dX=0.0;
modelStruct.modelPar_given_LCIGC=mod.given("LCIGC");
modParamMap["LCIGC"] = &(modelStruct.d_modelPar_LCIGC_dX);
modelStruct.modelPar_NCIGC=mod.NCIGC;
modelStruct.d_modelPar_NCIGC_dX=0.0;
modelStruct.modelPar_given_NCIGC=mod.given("NCIGC");
modParamMap["NCIGC"] = &(modelStruct.d_modelPar_NCIGC_dX);
modelStruct.modelPar_PCIGC=mod.PCIGC;
modelStruct.d_modelPar_PCIGC_dX=0.0;
modelStruct.modelPar_given_PCIGC=mod.given("PCIGC");
modParamMap["PCIGC"] = &(modelStruct.d_modelPar_PCIGC_dX);
modelStruct.modelPar_LPIGCD=mod.LPIGCD;
modelStruct.d_modelPar_LPIGCD_dX=0.0;
modelStruct.modelPar_given_LPIGCD=mod.given("LPIGCD");
modParamMap["LPIGCD"] = &(modelStruct.d_modelPar_LPIGCD_dX);
modelStruct.modelPar_NPIGCD=mod.NPIGCD;
modelStruct.d_modelPar_NPIGCD_dX=0.0;
modelStruct.modelPar_given_NPIGCD=mod.given("NPIGCD");
modParamMap["NPIGCD"] = &(modelStruct.d_modelPar_NPIGCD_dX);
modelStruct.modelPar_PPIGCD=mod.PPIGCD;
modelStruct.d_modelPar_PPIGCD_dX=0.0;
modelStruct.modelPar_given_PPIGCD=mod.given("PPIGCD");
modParamMap["PPIGCD"] = &(modelStruct.d_modelPar_PPIGCD_dX);
modelStruct.modelPar_LAIGS=mod.LAIGS;
modelStruct.d_modelPar_LAIGS_dX=0.0;
modelStruct.modelPar_given_LAIGS=mod.given("LAIGS");
modParamMap["LAIGS"] = &(modelStruct.d_modelPar_LAIGS_dX);
modelStruct.modelPar_NAIGS=mod.NAIGS;
modelStruct.d_modelPar_NAIGS_dX=0.0;
modelStruct.modelPar_given_NAIGS=mod.given("NAIGS");
modParamMap["NAIGS"] = &(modelStruct.d_modelPar_NAIGS_dX);
modelStruct.modelPar_PAIGS=mod.PAIGS;
modelStruct.d_modelPar_PAIGS_dX=0.0;
modelStruct.modelPar_given_PAIGS=mod.given("PAIGS");
modParamMap["PAIGS"] = &(modelStruct.d_modelPar_PAIGS_dX);
modelStruct.modelPar_LAIGS1=mod.LAIGS1;
modelStruct.d_modelPar_LAIGS1_dX=0.0;
modelStruct.modelPar_given_LAIGS1=mod.given("LAIGS1");
modParamMap["LAIGS1"] = &(modelStruct.d_modelPar_LAIGS1_dX);
modelStruct.modelPar_NAIGS1=mod.NAIGS1;
modelStruct.d_modelPar_NAIGS1_dX=0.0;
modelStruct.modelPar_given_NAIGS1=mod.given("NAIGS1");
modParamMap["NAIGS1"] = &(modelStruct.d_modelPar_NAIGS1_dX);
modelStruct.modelPar_PAIGS1=mod.PAIGS1;
modelStruct.d_modelPar_PAIGS1_dX=0.0;
modelStruct.modelPar_given_PAIGS1=mod.given("PAIGS1");
modParamMap["PAIGS1"] = &(modelStruct.d_modelPar_PAIGS1_dX);
modelStruct.modelPar_LBIGS=mod.LBIGS;
modelStruct.d_modelPar_LBIGS_dX=0.0;
modelStruct.modelPar_given_LBIGS=mod.given("LBIGS");
modParamMap["LBIGS"] = &(modelStruct.d_modelPar_LBIGS_dX);
modelStruct.modelPar_NBIGS=mod.NBIGS;
modelStruct.d_modelPar_NBIGS_dX=0.0;
modelStruct.modelPar_given_NBIGS=mod.given("NBIGS");
modParamMap["NBIGS"] = &(modelStruct.d_modelPar_NBIGS_dX);
modelStruct.modelPar_PBIGS=mod.PBIGS;
modelStruct.d_modelPar_PBIGS_dX=0.0;
modelStruct.modelPar_given_PBIGS=mod.given("PBIGS");
modParamMap["PBIGS"] = &(modelStruct.d_modelPar_PBIGS_dX);
modelStruct.modelPar_LCIGS=mod.LCIGS;
modelStruct.d_modelPar_LCIGS_dX=0.0;
modelStruct.modelPar_given_LCIGS=mod.given("LCIGS");
modParamMap["LCIGS"] = &(modelStruct.d_modelPar_LCIGS_dX);
modelStruct.modelPar_NCIGS=mod.NCIGS;
modelStruct.d_modelPar_NCIGS_dX=0.0;
modelStruct.modelPar_given_NCIGS=mod.given("NCIGS");
modParamMap["NCIGS"] = &(modelStruct.d_modelPar_NCIGS_dX);
modelStruct.modelPar_PCIGS=mod.PCIGS;
modelStruct.d_modelPar_PCIGS_dX=0.0;
modelStruct.modelPar_given_PCIGS=mod.given("PCIGS");
modParamMap["PCIGS"] = &(modelStruct.d_modelPar_PCIGS_dX);
modelStruct.modelPar_LAIGD=mod.LAIGD;
modelStruct.d_modelPar_LAIGD_dX=0.0;
modelStruct.modelPar_given_LAIGD=mod.given("LAIGD");
modParamMap["LAIGD"] = &(modelStruct.d_modelPar_LAIGD_dX);
modelStruct.modelPar_NAIGD=mod.NAIGD;
modelStruct.d_modelPar_NAIGD_dX=0.0;
modelStruct.modelPar_given_NAIGD=mod.given("NAIGD");
modParamMap["NAIGD"] = &(modelStruct.d_modelPar_NAIGD_dX);
modelStruct.modelPar_PAIGD=mod.PAIGD;
modelStruct.d_modelPar_PAIGD_dX=0.0;
modelStruct.modelPar_given_PAIGD=mod.given("PAIGD");
modParamMap["PAIGD"] = &(modelStruct.d_modelPar_PAIGD_dX);
modelStruct.modelPar_LAIGD1=mod.LAIGD1;
modelStruct.d_modelPar_LAIGD1_dX=0.0;
modelStruct.modelPar_given_LAIGD1=mod.given("LAIGD1");
modParamMap["LAIGD1"] = &(modelStruct.d_modelPar_LAIGD1_dX);
modelStruct.modelPar_NAIGD1=mod.NAIGD1;
modelStruct.d_modelPar_NAIGD1_dX=0.0;
modelStruct.modelPar_given_NAIGD1=mod.given("NAIGD1");
modParamMap["NAIGD1"] = &(modelStruct.d_modelPar_NAIGD1_dX);
modelStruct.modelPar_PAIGD1=mod.PAIGD1;
modelStruct.d_modelPar_PAIGD1_dX=0.0;
modelStruct.modelPar_given_PAIGD1=mod.given("PAIGD1");
modParamMap["PAIGD1"] = &(modelStruct.d_modelPar_PAIGD1_dX);
modelStruct.modelPar_LBIGD=mod.LBIGD;
modelStruct.d_modelPar_LBIGD_dX=0.0;
modelStruct.modelPar_given_LBIGD=mod.given("LBIGD");
modParamMap["LBIGD"] = &(modelStruct.d_modelPar_LBIGD_dX);
modelStruct.modelPar_NBIGD=mod.NBIGD;
modelStruct.d_modelPar_NBIGD_dX=0.0;
modelStruct.modelPar_given_NBIGD=mod.given("NBIGD");
modParamMap["NBIGD"] = &(modelStruct.d_modelPar_NBIGD_dX);
modelStruct.modelPar_PBIGD=mod.PBIGD;
modelStruct.d_modelPar_PBIGD_dX=0.0;
modelStruct.modelPar_given_PBIGD=mod.given("PBIGD");
modParamMap["PBIGD"] = &(modelStruct.d_modelPar_PBIGD_dX);
modelStruct.modelPar_LCIGD=mod.LCIGD;
modelStruct.d_modelPar_LCIGD_dX=0.0;
modelStruct.modelPar_given_LCIGD=mod.given("LCIGD");
modParamMap["LCIGD"] = &(modelStruct.d_modelPar_LCIGD_dX);
modelStruct.modelPar_NCIGD=mod.NCIGD;
modelStruct.d_modelPar_NCIGD_dX=0.0;
modelStruct.modelPar_given_NCIGD=mod.given("NCIGD");
modParamMap["NCIGD"] = &(modelStruct.d_modelPar_NCIGD_dX);
modelStruct.modelPar_PCIGD=mod.PCIGD;
modelStruct.d_modelPar_PCIGD_dX=0.0;
modelStruct.modelPar_given_PCIGD=mod.given("PCIGD");
modParamMap["PCIGD"] = &(modelStruct.d_modelPar_PCIGD_dX);
modelStruct.modelPar_LNTOX=mod.LNTOX;
modelStruct.d_modelPar_LNTOX_dX=0.0;
modelStruct.modelPar_given_LNTOX=mod.given("LNTOX");
modParamMap["LNTOX"] = &(modelStruct.d_modelPar_LNTOX_dX);
modelStruct.modelPar_NNTOX=mod.NNTOX;
modelStruct.d_modelPar_NNTOX_dX=0.0;
modelStruct.modelPar_given_NNTOX=mod.given("NNTOX");
modParamMap["NNTOX"] = &(modelStruct.d_modelPar_NNTOX_dX);
modelStruct.modelPar_PNTOX=mod.PNTOX;
modelStruct.d_modelPar_PNTOX_dX=0.0;
modelStruct.modelPar_given_PNTOX=mod.given("PNTOX");
modParamMap["PNTOX"] = &(modelStruct.d_modelPar_PNTOX_dX);
modelStruct.modelPar_LPOXEDGE=mod.LPOXEDGE;
modelStruct.d_modelPar_LPOXEDGE_dX=0.0;
modelStruct.modelPar_given_LPOXEDGE=mod.given("LPOXEDGE");
modParamMap["LPOXEDGE"] = &(modelStruct.d_modelPar_LPOXEDGE_dX);
modelStruct.modelPar_NPOXEDGE=mod.NPOXEDGE;
modelStruct.d_modelPar_NPOXEDGE_dX=0.0;
modelStruct.modelPar_given_NPOXEDGE=mod.given("NPOXEDGE");
modParamMap["NPOXEDGE"] = &(modelStruct.d_modelPar_NPOXEDGE_dX);
modelStruct.modelPar_PPOXEDGE=mod.PPOXEDGE;
modelStruct.d_modelPar_PPOXEDGE_dX=0.0;
modelStruct.modelPar_given_PPOXEDGE=mod.given("PPOXEDGE");
modParamMap["PPOXEDGE"] = &(modelStruct.d_modelPar_PPOXEDGE_dX);
modelStruct.modelPar_LAGISL=mod.LAGISL;
modelStruct.d_modelPar_LAGISL_dX=0.0;
modelStruct.modelPar_given_LAGISL=mod.given("LAGISL");
modParamMap["LAGISL"] = &(modelStruct.d_modelPar_LAGISL_dX);
modelStruct.modelPar_NAGISL=mod.NAGISL;
modelStruct.d_modelPar_NAGISL_dX=0.0;
modelStruct.modelPar_given_NAGISL=mod.given("NAGISL");
modParamMap["NAGISL"] = &(modelStruct.d_modelPar_NAGISL_dX);
modelStruct.modelPar_PAGISL=mod.PAGISL;
modelStruct.d_modelPar_PAGISL_dX=0.0;
modelStruct.modelPar_given_PAGISL=mod.given("PAGISL");
modParamMap["PAGISL"] = &(modelStruct.d_modelPar_PAGISL_dX);
modelStruct.modelPar_LBGISL=mod.LBGISL;
modelStruct.d_modelPar_LBGISL_dX=0.0;
modelStruct.modelPar_given_LBGISL=mod.given("LBGISL");
modParamMap["LBGISL"] = &(modelStruct.d_modelPar_LBGISL_dX);
modelStruct.modelPar_NBGISL=mod.NBGISL;
modelStruct.d_modelPar_NBGISL_dX=0.0;
modelStruct.modelPar_given_NBGISL=mod.given("NBGISL");
modParamMap["NBGISL"] = &(modelStruct.d_modelPar_NBGISL_dX);
modelStruct.modelPar_PBGISL=mod.PBGISL;
modelStruct.d_modelPar_PBGISL_dX=0.0;
modelStruct.modelPar_given_PBGISL=mod.given("PBGISL");
modParamMap["PBGISL"] = &(modelStruct.d_modelPar_PBGISL_dX);
modelStruct.modelPar_LCGISL=mod.LCGISL;
modelStruct.d_modelPar_LCGISL_dX=0.0;
modelStruct.modelPar_given_LCGISL=mod.given("LCGISL");
modParamMap["LCGISL"] = &(modelStruct.d_modelPar_LCGISL_dX);
modelStruct.modelPar_NCGISL=mod.NCGISL;
modelStruct.d_modelPar_NCGISL_dX=0.0;
modelStruct.modelPar_given_NCGISL=mod.given("NCGISL");
modParamMap["NCGISL"] = &(modelStruct.d_modelPar_NCGISL_dX);
modelStruct.modelPar_PCGISL=mod.PCGISL;
modelStruct.d_modelPar_PCGISL_dX=0.0;
modelStruct.modelPar_given_PCGISL=mod.given("PCGISL");
modParamMap["PCGISL"] = &(modelStruct.d_modelPar_PCGISL_dX);
modelStruct.modelPar_LEGISL=mod.LEGISL;
modelStruct.d_modelPar_LEGISL_dX=0.0;
modelStruct.modelPar_given_LEGISL=mod.given("LEGISL");
modParamMap["LEGISL"] = &(modelStruct.d_modelPar_LEGISL_dX);
modelStruct.modelPar_NEGISL=mod.NEGISL;
modelStruct.d_modelPar_NEGISL_dX=0.0;
modelStruct.modelPar_given_NEGISL=mod.given("NEGISL");
modParamMap["NEGISL"] = &(modelStruct.d_modelPar_NEGISL_dX);
modelStruct.modelPar_PEGISL=mod.PEGISL;
modelStruct.d_modelPar_PEGISL_dX=0.0;
modelStruct.modelPar_given_PEGISL=mod.given("PEGISL");
modParamMap["PEGISL"] = &(modelStruct.d_modelPar_PEGISL_dX);
modelStruct.modelPar_LPGISL=mod.LPGISL;
modelStruct.d_modelPar_LPGISL_dX=0.0;
modelStruct.modelPar_given_LPGISL=mod.given("LPGISL");
modParamMap["LPGISL"] = &(modelStruct.d_modelPar_LPGISL_dX);
modelStruct.modelPar_NPGISL=mod.NPGISL;
modelStruct.d_modelPar_NPGISL_dX=0.0;
modelStruct.modelPar_given_NPGISL=mod.given("NPGISL");
modParamMap["NPGISL"] = &(modelStruct.d_modelPar_NPGISL_dX);
modelStruct.modelPar_PPGISL=mod.PPGISL;
modelStruct.d_modelPar_PPGISL_dX=0.0;
modelStruct.modelPar_given_PPGISL=mod.given("PPGISL");
modParamMap["PPGISL"] = &(modelStruct.d_modelPar_PPGISL_dX);
modelStruct.modelPar_LAGIDL=mod.LAGIDL;
modelStruct.d_modelPar_LAGIDL_dX=0.0;
modelStruct.modelPar_given_LAGIDL=mod.given("LAGIDL");
modParamMap["LAGIDL"] = &(modelStruct.d_modelPar_LAGIDL_dX);
modelStruct.modelPar_NAGIDL=mod.NAGIDL;
modelStruct.d_modelPar_NAGIDL_dX=0.0;
modelStruct.modelPar_given_NAGIDL=mod.given("NAGIDL");
modParamMap["NAGIDL"] = &(modelStruct.d_modelPar_NAGIDL_dX);
modelStruct.modelPar_PAGIDL=mod.PAGIDL;
modelStruct.d_modelPar_PAGIDL_dX=0.0;
modelStruct.modelPar_given_PAGIDL=mod.given("PAGIDL");
modParamMap["PAGIDL"] = &(modelStruct.d_modelPar_PAGIDL_dX);
modelStruct.modelPar_LBGIDL=mod.LBGIDL;
modelStruct.d_modelPar_LBGIDL_dX=0.0;
modelStruct.modelPar_given_LBGIDL=mod.given("LBGIDL");
modParamMap["LBGIDL"] = &(modelStruct.d_modelPar_LBGIDL_dX);
modelStruct.modelPar_NBGIDL=mod.NBGIDL;
modelStruct.d_modelPar_NBGIDL_dX=0.0;
modelStruct.modelPar_given_NBGIDL=mod.given("NBGIDL");
modParamMap["NBGIDL"] = &(modelStruct.d_modelPar_NBGIDL_dX);
modelStruct.modelPar_PBGIDL=mod.PBGIDL;
modelStruct.d_modelPar_PBGIDL_dX=0.0;
modelStruct.modelPar_given_PBGIDL=mod.given("PBGIDL");
modParamMap["PBGIDL"] = &(modelStruct.d_modelPar_PBGIDL_dX);
modelStruct.modelPar_LCGIDL=mod.LCGIDL;
modelStruct.d_modelPar_LCGIDL_dX=0.0;
modelStruct.modelPar_given_LCGIDL=mod.given("LCGIDL");
modParamMap["LCGIDL"] = &(modelStruct.d_modelPar_LCGIDL_dX);
modelStruct.modelPar_NCGIDL=mod.NCGIDL;
modelStruct.d_modelPar_NCGIDL_dX=0.0;
modelStruct.modelPar_given_NCGIDL=mod.given("NCGIDL");
modParamMap["NCGIDL"] = &(modelStruct.d_modelPar_NCGIDL_dX);
modelStruct.modelPar_PCGIDL=mod.PCGIDL;
modelStruct.d_modelPar_PCGIDL_dX=0.0;
modelStruct.modelPar_given_PCGIDL=mod.given("PCGIDL");
modParamMap["PCGIDL"] = &(modelStruct.d_modelPar_PCGIDL_dX);
modelStruct.modelPar_LEGIDL=mod.LEGIDL;
modelStruct.d_modelPar_LEGIDL_dX=0.0;
modelStruct.modelPar_given_LEGIDL=mod.given("LEGIDL");
modParamMap["LEGIDL"] = &(modelStruct.d_modelPar_LEGIDL_dX);
modelStruct.modelPar_NEGIDL=mod.NEGIDL;
modelStruct.d_modelPar_NEGIDL_dX=0.0;
modelStruct.modelPar_given_NEGIDL=mod.given("NEGIDL");
modParamMap["NEGIDL"] = &(modelStruct.d_modelPar_NEGIDL_dX);
modelStruct.modelPar_PEGIDL=mod.PEGIDL;
modelStruct.d_modelPar_PEGIDL_dX=0.0;
modelStruct.modelPar_given_PEGIDL=mod.given("PEGIDL");
modParamMap["PEGIDL"] = &(modelStruct.d_modelPar_PEGIDL_dX);
modelStruct.modelPar_LPGIDL=mod.LPGIDL;
modelStruct.d_modelPar_LPGIDL_dX=0.0;
modelStruct.modelPar_given_LPGIDL=mod.given("LPGIDL");
modParamMap["LPGIDL"] = &(modelStruct.d_modelPar_LPGIDL_dX);
modelStruct.modelPar_NPGIDL=mod.NPGIDL;
modelStruct.d_modelPar_NPGIDL_dX=0.0;
modelStruct.modelPar_given_NPGIDL=mod.given("NPGIDL");
modParamMap["NPGIDL"] = &(modelStruct.d_modelPar_NPGIDL_dX);
modelStruct.modelPar_PPGIDL=mod.PPGIDL;
modelStruct.d_modelPar_PPGIDL_dX=0.0;
modelStruct.modelPar_given_PPGIDL=mod.given("PPGIDL");
modParamMap["PPGIDL"] = &(modelStruct.d_modelPar_PPGIDL_dX);
modelStruct.modelPar_LALPHA0=mod.LALPHA0;
modelStruct.d_modelPar_LALPHA0_dX=0.0;
modelStruct.modelPar_given_LALPHA0=mod.given("LALPHA0");
modParamMap["LALPHA0"] = &(modelStruct.d_modelPar_LALPHA0_dX);
modelStruct.modelPar_NALPHA0=mod.NALPHA0;
modelStruct.d_modelPar_NALPHA0_dX=0.0;
modelStruct.modelPar_given_NALPHA0=mod.given("NALPHA0");
modParamMap["NALPHA0"] = &(modelStruct.d_modelPar_NALPHA0_dX);
modelStruct.modelPar_PALPHA0=mod.PALPHA0;
modelStruct.d_modelPar_PALPHA0_dX=0.0;
modelStruct.modelPar_given_PALPHA0=mod.given("PALPHA0");
modParamMap["PALPHA0"] = &(modelStruct.d_modelPar_PALPHA0_dX);
modelStruct.modelPar_LALPHA1=mod.LALPHA1;
modelStruct.d_modelPar_LALPHA1_dX=0.0;
modelStruct.modelPar_given_LALPHA1=mod.given("LALPHA1");
modParamMap["LALPHA1"] = &(modelStruct.d_modelPar_LALPHA1_dX);
modelStruct.modelPar_NALPHA1=mod.NALPHA1;
modelStruct.d_modelPar_NALPHA1_dX=0.0;
modelStruct.modelPar_given_NALPHA1=mod.given("NALPHA1");
modParamMap["NALPHA1"] = &(modelStruct.d_modelPar_NALPHA1_dX);
modelStruct.modelPar_PALPHA1=mod.PALPHA1;
modelStruct.d_modelPar_PALPHA1_dX=0.0;
modelStruct.modelPar_given_PALPHA1=mod.given("PALPHA1");
modParamMap["PALPHA1"] = &(modelStruct.d_modelPar_PALPHA1_dX);
modelStruct.modelPar_LALPHAII0=mod.LALPHAII0;
modelStruct.d_modelPar_LALPHAII0_dX=0.0;
modelStruct.modelPar_given_LALPHAII0=mod.given("LALPHAII0");
modParamMap["LALPHAII0"] = &(modelStruct.d_modelPar_LALPHAII0_dX);
modelStruct.modelPar_NALPHAII0=mod.NALPHAII0;
modelStruct.d_modelPar_NALPHAII0_dX=0.0;
modelStruct.modelPar_given_NALPHAII0=mod.given("NALPHAII0");
modParamMap["NALPHAII0"] = &(modelStruct.d_modelPar_NALPHAII0_dX);
modelStruct.modelPar_PALPHAII0=mod.PALPHAII0;
modelStruct.d_modelPar_PALPHAII0_dX=0.0;
modelStruct.modelPar_given_PALPHAII0=mod.given("PALPHAII0");
modParamMap["PALPHAII0"] = &(modelStruct.d_modelPar_PALPHAII0_dX);
modelStruct.modelPar_LALPHAII1=mod.LALPHAII1;
modelStruct.d_modelPar_LALPHAII1_dX=0.0;
modelStruct.modelPar_given_LALPHAII1=mod.given("LALPHAII1");
modParamMap["LALPHAII1"] = &(modelStruct.d_modelPar_LALPHAII1_dX);
modelStruct.modelPar_NALPHAII1=mod.NALPHAII1;
modelStruct.d_modelPar_NALPHAII1_dX=0.0;
modelStruct.modelPar_given_NALPHAII1=mod.given("NALPHAII1");
modParamMap["NALPHAII1"] = &(modelStruct.d_modelPar_NALPHAII1_dX);
modelStruct.modelPar_PALPHAII1=mod.PALPHAII1;
modelStruct.d_modelPar_PALPHAII1_dX=0.0;
modelStruct.modelPar_given_PALPHAII1=mod.given("PALPHAII1");
modParamMap["PALPHAII1"] = &(modelStruct.d_modelPar_PALPHAII1_dX);
modelStruct.modelPar_LBETA0=mod.LBETA0;
modelStruct.d_modelPar_LBETA0_dX=0.0;
modelStruct.modelPar_given_LBETA0=mod.given("LBETA0");
modParamMap["LBETA0"] = &(modelStruct.d_modelPar_LBETA0_dX);
modelStruct.modelPar_NBETA0=mod.NBETA0;
modelStruct.d_modelPar_NBETA0_dX=0.0;
modelStruct.modelPar_given_NBETA0=mod.given("NBETA0");
modParamMap["NBETA0"] = &(modelStruct.d_modelPar_NBETA0_dX);
modelStruct.modelPar_PBETA0=mod.PBETA0;
modelStruct.d_modelPar_PBETA0_dX=0.0;
modelStruct.modelPar_given_PBETA0=mod.given("PBETA0");
modParamMap["PBETA0"] = &(modelStruct.d_modelPar_PBETA0_dX);
modelStruct.modelPar_LBETAII0=mod.LBETAII0;
modelStruct.d_modelPar_LBETAII0_dX=0.0;
modelStruct.modelPar_given_LBETAII0=mod.given("LBETAII0");
modParamMap["LBETAII0"] = &(modelStruct.d_modelPar_LBETAII0_dX);
modelStruct.modelPar_NBETAII0=mod.NBETAII0;
modelStruct.d_modelPar_NBETAII0_dX=0.0;
modelStruct.modelPar_given_NBETAII0=mod.given("NBETAII0");
modParamMap["NBETAII0"] = &(modelStruct.d_modelPar_NBETAII0_dX);
modelStruct.modelPar_PBETAII0=mod.PBETAII0;
modelStruct.d_modelPar_PBETAII0_dX=0.0;
modelStruct.modelPar_given_PBETAII0=mod.given("PBETAII0");
modParamMap["PBETAII0"] = &(modelStruct.d_modelPar_PBETAII0_dX);
modelStruct.modelPar_LBETAII1=mod.LBETAII1;
modelStruct.d_modelPar_LBETAII1_dX=0.0;
modelStruct.modelPar_given_LBETAII1=mod.given("LBETAII1");
modParamMap["LBETAII1"] = &(modelStruct.d_modelPar_LBETAII1_dX);
modelStruct.modelPar_NBETAII1=mod.NBETAII1;
modelStruct.d_modelPar_NBETAII1_dX=0.0;
modelStruct.modelPar_given_NBETAII1=mod.given("NBETAII1");
modParamMap["NBETAII1"] = &(modelStruct.d_modelPar_NBETAII1_dX);
modelStruct.modelPar_PBETAII1=mod.PBETAII1;
modelStruct.d_modelPar_PBETAII1_dX=0.0;
modelStruct.modelPar_given_PBETAII1=mod.given("PBETAII1");
modParamMap["PBETAII1"] = &(modelStruct.d_modelPar_PBETAII1_dX);
modelStruct.modelPar_LBETAII2=mod.LBETAII2;
modelStruct.d_modelPar_LBETAII2_dX=0.0;
modelStruct.modelPar_given_LBETAII2=mod.given("LBETAII2");
modParamMap["LBETAII2"] = &(modelStruct.d_modelPar_LBETAII2_dX);
modelStruct.modelPar_NBETAII2=mod.NBETAII2;
modelStruct.d_modelPar_NBETAII2_dX=0.0;
modelStruct.modelPar_given_NBETAII2=mod.given("NBETAII2");
modParamMap["NBETAII2"] = &(modelStruct.d_modelPar_NBETAII2_dX);
modelStruct.modelPar_PBETAII2=mod.PBETAII2;
modelStruct.d_modelPar_PBETAII2_dX=0.0;
modelStruct.modelPar_given_PBETAII2=mod.given("PBETAII2");
modParamMap["PBETAII2"] = &(modelStruct.d_modelPar_PBETAII2_dX);
modelStruct.modelPar_LESATII=mod.LESATII;
modelStruct.d_modelPar_LESATII_dX=0.0;
modelStruct.modelPar_given_LESATII=mod.given("LESATII");
modParamMap["LESATII"] = &(modelStruct.d_modelPar_LESATII_dX);
modelStruct.modelPar_NESATII=mod.NESATII;
modelStruct.d_modelPar_NESATII_dX=0.0;
modelStruct.modelPar_given_NESATII=mod.given("NESATII");
modParamMap["NESATII"] = &(modelStruct.d_modelPar_NESATII_dX);
modelStruct.modelPar_PESATII=mod.PESATII;
modelStruct.d_modelPar_PESATII_dX=0.0;
modelStruct.modelPar_given_PESATII=mod.given("PESATII");
modParamMap["PESATII"] = &(modelStruct.d_modelPar_PESATII_dX);
modelStruct.modelPar_LLII=mod.LLII;
modelStruct.d_modelPar_LLII_dX=0.0;
modelStruct.modelPar_given_LLII=mod.given("LLII");
modParamMap["LLII"] = &(modelStruct.d_modelPar_LLII_dX);
modelStruct.modelPar_NLII=mod.NLII;
modelStruct.d_modelPar_NLII_dX=0.0;
modelStruct.modelPar_given_NLII=mod.given("NLII");
modParamMap["NLII"] = &(modelStruct.d_modelPar_NLII_dX);
modelStruct.modelPar_PLII=mod.PLII;
modelStruct.d_modelPar_PLII_dX=0.0;
modelStruct.modelPar_given_PLII=mod.given("PLII");
modParamMap["PLII"] = &(modelStruct.d_modelPar_PLII_dX);
modelStruct.modelPar_LSII0=mod.LSII0;
modelStruct.d_modelPar_LSII0_dX=0.0;
modelStruct.modelPar_given_LSII0=mod.given("LSII0");
modParamMap["LSII0"] = &(modelStruct.d_modelPar_LSII0_dX);
modelStruct.modelPar_NSII0=mod.NSII0;
modelStruct.d_modelPar_NSII0_dX=0.0;
modelStruct.modelPar_given_NSII0=mod.given("NSII0");
modParamMap["NSII0"] = &(modelStruct.d_modelPar_NSII0_dX);
modelStruct.modelPar_PSII0=mod.PSII0;
modelStruct.d_modelPar_PSII0_dX=0.0;
modelStruct.modelPar_given_PSII0=mod.given("PSII0");
modParamMap["PSII0"] = &(modelStruct.d_modelPar_PSII0_dX);
modelStruct.modelPar_LSII1=mod.LSII1;
modelStruct.d_modelPar_LSII1_dX=0.0;
modelStruct.modelPar_given_LSII1=mod.given("LSII1");
modParamMap["LSII1"] = &(modelStruct.d_modelPar_LSII1_dX);
modelStruct.modelPar_NSII1=mod.NSII1;
modelStruct.d_modelPar_NSII1_dX=0.0;
modelStruct.modelPar_given_NSII1=mod.given("NSII1");
modParamMap["NSII1"] = &(modelStruct.d_modelPar_NSII1_dX);
modelStruct.modelPar_PSII1=mod.PSII1;
modelStruct.d_modelPar_PSII1_dX=0.0;
modelStruct.modelPar_given_PSII1=mod.given("PSII1");
modParamMap["PSII1"] = &(modelStruct.d_modelPar_PSII1_dX);
modelStruct.modelPar_LSII2=mod.LSII2;
modelStruct.d_modelPar_LSII2_dX=0.0;
modelStruct.modelPar_given_LSII2=mod.given("LSII2");
modParamMap["LSII2"] = &(modelStruct.d_modelPar_LSII2_dX);
modelStruct.modelPar_NSII2=mod.NSII2;
modelStruct.d_modelPar_NSII2_dX=0.0;
modelStruct.modelPar_given_NSII2=mod.given("NSII2");
modParamMap["NSII2"] = &(modelStruct.d_modelPar_NSII2_dX);
modelStruct.modelPar_PSII2=mod.PSII2;
modelStruct.d_modelPar_PSII2_dX=0.0;
modelStruct.modelPar_given_PSII2=mod.given("PSII2");
modParamMap["PSII2"] = &(modelStruct.d_modelPar_PSII2_dX);
modelStruct.modelPar_LSIID=mod.LSIID;
modelStruct.d_modelPar_LSIID_dX=0.0;
modelStruct.modelPar_given_LSIID=mod.given("LSIID");
modParamMap["LSIID"] = &(modelStruct.d_modelPar_LSIID_dX);
modelStruct.modelPar_NSIID=mod.NSIID;
modelStruct.d_modelPar_NSIID_dX=0.0;
modelStruct.modelPar_given_NSIID=mod.given("NSIID");
modParamMap["NSIID"] = &(modelStruct.d_modelPar_NSIID_dX);
modelStruct.modelPar_PSIID=mod.PSIID;
modelStruct.d_modelPar_PSIID_dX=0.0;
modelStruct.modelPar_given_PSIID=mod.given("PSIID");
modParamMap["PSIID"] = &(modelStruct.d_modelPar_PSIID_dX);
modelStruct.modelPar_LCFS=mod.LCFS;
modelStruct.d_modelPar_LCFS_dX=0.0;
modelStruct.modelPar_given_LCFS=mod.given("LCFS");
modParamMap["LCFS"] = &(modelStruct.d_modelPar_LCFS_dX);
modelStruct.modelPar_NCFS=mod.NCFS;
modelStruct.d_modelPar_NCFS_dX=0.0;
modelStruct.modelPar_given_NCFS=mod.given("NCFS");
modParamMap["NCFS"] = &(modelStruct.d_modelPar_NCFS_dX);
modelStruct.modelPar_PCFS=mod.PCFS;
modelStruct.d_modelPar_PCFS_dX=0.0;
modelStruct.modelPar_given_PCFS=mod.given("PCFS");
modParamMap["PCFS"] = &(modelStruct.d_modelPar_PCFS_dX);
modelStruct.modelPar_LCFD=mod.LCFD;
modelStruct.d_modelPar_LCFD_dX=0.0;
modelStruct.modelPar_given_LCFD=mod.given("LCFD");
modParamMap["LCFD"] = &(modelStruct.d_modelPar_LCFD_dX);
modelStruct.modelPar_NCFD=mod.NCFD;
modelStruct.d_modelPar_NCFD_dX=0.0;
modelStruct.modelPar_given_NCFD=mod.given("NCFD");
modParamMap["NCFD"] = &(modelStruct.d_modelPar_NCFD_dX);
modelStruct.modelPar_PCFD=mod.PCFD;
modelStruct.d_modelPar_PCFD_dX=0.0;
modelStruct.modelPar_given_PCFD=mod.given("PCFD");
modParamMap["PCFD"] = &(modelStruct.d_modelPar_PCFD_dX);
modelStruct.modelPar_LCOVS=mod.LCOVS;
modelStruct.d_modelPar_LCOVS_dX=0.0;
modelStruct.modelPar_given_LCOVS=mod.given("LCOVS");
modParamMap["LCOVS"] = &(modelStruct.d_modelPar_LCOVS_dX);
modelStruct.modelPar_NCOVS=mod.NCOVS;
modelStruct.d_modelPar_NCOVS_dX=0.0;
modelStruct.modelPar_given_NCOVS=mod.given("NCOVS");
modParamMap["NCOVS"] = &(modelStruct.d_modelPar_NCOVS_dX);
modelStruct.modelPar_PCOVS=mod.PCOVS;
modelStruct.d_modelPar_PCOVS_dX=0.0;
modelStruct.modelPar_given_PCOVS=mod.given("PCOVS");
modParamMap["PCOVS"] = &(modelStruct.d_modelPar_PCOVS_dX);
modelStruct.modelPar_LCOVD=mod.LCOVD;
modelStruct.d_modelPar_LCOVD_dX=0.0;
modelStruct.modelPar_given_LCOVD=mod.given("LCOVD");
modParamMap["LCOVD"] = &(modelStruct.d_modelPar_LCOVD_dX);
modelStruct.modelPar_NCOVD=mod.NCOVD;
modelStruct.d_modelPar_NCOVD_dX=0.0;
modelStruct.modelPar_given_NCOVD=mod.given("NCOVD");
modParamMap["NCOVD"] = &(modelStruct.d_modelPar_NCOVD_dX);
modelStruct.modelPar_PCOVD=mod.PCOVD;
modelStruct.d_modelPar_PCOVD_dX=0.0;
modelStruct.modelPar_given_PCOVD=mod.given("PCOVD");
modParamMap["PCOVD"] = &(modelStruct.d_modelPar_PCOVD_dX);
modelStruct.modelPar_LCGSL=mod.LCGSL;
modelStruct.d_modelPar_LCGSL_dX=0.0;
modelStruct.modelPar_given_LCGSL=mod.given("LCGSL");
modParamMap["LCGSL"] = &(modelStruct.d_modelPar_LCGSL_dX);
modelStruct.modelPar_NCGSL=mod.NCGSL;
modelStruct.d_modelPar_NCGSL_dX=0.0;
modelStruct.modelPar_given_NCGSL=mod.given("NCGSL");
modParamMap["NCGSL"] = &(modelStruct.d_modelPar_NCGSL_dX);
modelStruct.modelPar_PCGSL=mod.PCGSL;
modelStruct.d_modelPar_PCGSL_dX=0.0;
modelStruct.modelPar_given_PCGSL=mod.given("PCGSL");
modParamMap["PCGSL"] = &(modelStruct.d_modelPar_PCGSL_dX);
modelStruct.modelPar_LCGDL=mod.LCGDL;
modelStruct.d_modelPar_LCGDL_dX=0.0;
modelStruct.modelPar_given_LCGDL=mod.given("LCGDL");
modParamMap["LCGDL"] = &(modelStruct.d_modelPar_LCGDL_dX);
modelStruct.modelPar_NCGDL=mod.NCGDL;
modelStruct.d_modelPar_NCGDL_dX=0.0;
modelStruct.modelPar_given_NCGDL=mod.given("NCGDL");
modParamMap["NCGDL"] = &(modelStruct.d_modelPar_NCGDL_dX);
modelStruct.modelPar_PCGDL=mod.PCGDL;
modelStruct.d_modelPar_PCGDL_dX=0.0;
modelStruct.modelPar_given_PCGDL=mod.given("PCGDL");
modParamMap["PCGDL"] = &(modelStruct.d_modelPar_PCGDL_dX);
modelStruct.modelPar_LCKAPPAS=mod.LCKAPPAS;
modelStruct.d_modelPar_LCKAPPAS_dX=0.0;
modelStruct.modelPar_given_LCKAPPAS=mod.given("LCKAPPAS");
modParamMap["LCKAPPAS"] = &(modelStruct.d_modelPar_LCKAPPAS_dX);
modelStruct.modelPar_NCKAPPAS=mod.NCKAPPAS;
modelStruct.d_modelPar_NCKAPPAS_dX=0.0;
modelStruct.modelPar_given_NCKAPPAS=mod.given("NCKAPPAS");
modParamMap["NCKAPPAS"] = &(modelStruct.d_modelPar_NCKAPPAS_dX);
modelStruct.modelPar_PCKAPPAS=mod.PCKAPPAS;
modelStruct.d_modelPar_PCKAPPAS_dX=0.0;
modelStruct.modelPar_given_PCKAPPAS=mod.given("PCKAPPAS");
modParamMap["PCKAPPAS"] = &(modelStruct.d_modelPar_PCKAPPAS_dX);
modelStruct.modelPar_LCKAPPAD=mod.LCKAPPAD;
modelStruct.d_modelPar_LCKAPPAD_dX=0.0;
modelStruct.modelPar_given_LCKAPPAD=mod.given("LCKAPPAD");
modParamMap["LCKAPPAD"] = &(modelStruct.d_modelPar_LCKAPPAD_dX);
modelStruct.modelPar_NCKAPPAD=mod.NCKAPPAD;
modelStruct.d_modelPar_NCKAPPAD_dX=0.0;
modelStruct.modelPar_given_NCKAPPAD=mod.given("NCKAPPAD");
modParamMap["NCKAPPAD"] = &(modelStruct.d_modelPar_NCKAPPAD_dX);
modelStruct.modelPar_PCKAPPAD=mod.PCKAPPAD;
modelStruct.d_modelPar_PCKAPPAD_dX=0.0;
modelStruct.modelPar_given_PCKAPPAD=mod.given("PCKAPPAD");
modParamMap["PCKAPPAD"] = &(modelStruct.d_modelPar_PCKAPPAD_dX);
modelStruct.modelPar_LCGBL=mod.LCGBL;
modelStruct.d_modelPar_LCGBL_dX=0.0;
modelStruct.modelPar_given_LCGBL=mod.given("LCGBL");
modParamMap["LCGBL"] = &(modelStruct.d_modelPar_LCGBL_dX);
modelStruct.modelPar_NCGBL=mod.NCGBL;
modelStruct.d_modelPar_NCGBL_dX=0.0;
modelStruct.modelPar_given_NCGBL=mod.given("NCGBL");
modParamMap["NCGBL"] = &(modelStruct.d_modelPar_NCGBL_dX);
modelStruct.modelPar_PCGBL=mod.PCGBL;
modelStruct.d_modelPar_PCGBL_dX=0.0;
modelStruct.modelPar_given_PCGBL=mod.given("PCGBL");
modParamMap["PCGBL"] = &(modelStruct.d_modelPar_PCGBL_dX);
modelStruct.modelPar_LCKAPPAB=mod.LCKAPPAB;
modelStruct.d_modelPar_LCKAPPAB_dX=0.0;
modelStruct.modelPar_given_LCKAPPAB=mod.given("LCKAPPAB");
modParamMap["LCKAPPAB"] = &(modelStruct.d_modelPar_LCKAPPAB_dX);
modelStruct.modelPar_NCKAPPAB=mod.NCKAPPAB;
modelStruct.d_modelPar_NCKAPPAB_dX=0.0;
modelStruct.modelPar_given_NCKAPPAB=mod.given("NCKAPPAB");
modParamMap["NCKAPPAB"] = &(modelStruct.d_modelPar_NCKAPPAB_dX);
modelStruct.modelPar_PCKAPPAB=mod.PCKAPPAB;
modelStruct.d_modelPar_PCKAPPAB_dX=0.0;
modelStruct.modelPar_given_PCKAPPAB=mod.given("PCKAPPAB");
modParamMap["PCKAPPAB"] = &(modelStruct.d_modelPar_PCKAPPAB_dX);
modelStruct.modelPar_LNTGEN=mod.LNTGEN;
modelStruct.d_modelPar_LNTGEN_dX=0.0;
modelStruct.modelPar_given_LNTGEN=mod.given("LNTGEN");
modParamMap["LNTGEN"] = &(modelStruct.d_modelPar_LNTGEN_dX);
modelStruct.modelPar_NNTGEN=mod.NNTGEN;
modelStruct.d_modelPar_NNTGEN_dX=0.0;
modelStruct.modelPar_given_NNTGEN=mod.given("NNTGEN");
modParamMap["NNTGEN"] = &(modelStruct.d_modelPar_NNTGEN_dX);
modelStruct.modelPar_PNTGEN=mod.PNTGEN;
modelStruct.d_modelPar_PNTGEN_dX=0.0;
modelStruct.modelPar_given_PNTGEN=mod.given("PNTGEN");
modParamMap["PNTGEN"] = &(modelStruct.d_modelPar_PNTGEN_dX);
modelStruct.modelPar_LAIGEN=mod.LAIGEN;
modelStruct.d_modelPar_LAIGEN_dX=0.0;
modelStruct.modelPar_given_LAIGEN=mod.given("LAIGEN");
modParamMap["LAIGEN"] = &(modelStruct.d_modelPar_LAIGEN_dX);
modelStruct.modelPar_NAIGEN=mod.NAIGEN;
modelStruct.d_modelPar_NAIGEN_dX=0.0;
modelStruct.modelPar_given_NAIGEN=mod.given("NAIGEN");
modParamMap["NAIGEN"] = &(modelStruct.d_modelPar_NAIGEN_dX);
modelStruct.modelPar_PAIGEN=mod.PAIGEN;
modelStruct.d_modelPar_PAIGEN_dX=0.0;
modelStruct.modelPar_given_PAIGEN=mod.given("PAIGEN");
modParamMap["PAIGEN"] = &(modelStruct.d_modelPar_PAIGEN_dX);
modelStruct.modelPar_LBIGEN=mod.LBIGEN;
modelStruct.d_modelPar_LBIGEN_dX=0.0;
modelStruct.modelPar_given_LBIGEN=mod.given("LBIGEN");
modParamMap["LBIGEN"] = &(modelStruct.d_modelPar_LBIGEN_dX);
modelStruct.modelPar_NBIGEN=mod.NBIGEN;
modelStruct.d_modelPar_NBIGEN_dX=0.0;
modelStruct.modelPar_given_NBIGEN=mod.given("NBIGEN");
modParamMap["NBIGEN"] = &(modelStruct.d_modelPar_NBIGEN_dX);
modelStruct.modelPar_PBIGEN=mod.PBIGEN;
modelStruct.d_modelPar_PBIGEN_dX=0.0;
modelStruct.modelPar_given_PBIGEN=mod.given("PBIGEN");
modParamMap["PBIGEN"] = &(modelStruct.d_modelPar_PBIGEN_dX);
modelStruct.modelPar_LXRCRG1=mod.LXRCRG1;
modelStruct.d_modelPar_LXRCRG1_dX=0.0;
modelStruct.modelPar_given_LXRCRG1=mod.given("LXRCRG1");
modParamMap["LXRCRG1"] = &(modelStruct.d_modelPar_LXRCRG1_dX);
modelStruct.modelPar_NXRCRG1=mod.NXRCRG1;
modelStruct.d_modelPar_NXRCRG1_dX=0.0;
modelStruct.modelPar_given_NXRCRG1=mod.given("NXRCRG1");
modParamMap["NXRCRG1"] = &(modelStruct.d_modelPar_NXRCRG1_dX);
modelStruct.modelPar_PXRCRG1=mod.PXRCRG1;
modelStruct.d_modelPar_PXRCRG1_dX=0.0;
modelStruct.modelPar_given_PXRCRG1=mod.given("PXRCRG1");
modParamMap["PXRCRG1"] = &(modelStruct.d_modelPar_PXRCRG1_dX);
modelStruct.modelPar_LXRCRG2=mod.LXRCRG2;
modelStruct.d_modelPar_LXRCRG2_dX=0.0;
modelStruct.modelPar_given_LXRCRG2=mod.given("LXRCRG2");
modParamMap["LXRCRG2"] = &(modelStruct.d_modelPar_LXRCRG2_dX);
modelStruct.modelPar_NXRCRG2=mod.NXRCRG2;
modelStruct.d_modelPar_NXRCRG2_dX=0.0;
modelStruct.modelPar_given_NXRCRG2=mod.given("NXRCRG2");
modParamMap["NXRCRG2"] = &(modelStruct.d_modelPar_NXRCRG2_dX);
modelStruct.modelPar_PXRCRG2=mod.PXRCRG2;
modelStruct.d_modelPar_PXRCRG2_dX=0.0;
modelStruct.modelPar_given_PXRCRG2=mod.given("PXRCRG2");
modParamMap["PXRCRG2"] = &(modelStruct.d_modelPar_PXRCRG2_dX);
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modParamMap["LINTNOI"] = &(modelStruct.d_modelPar_LINTNOI_dX);
modelStruct.modelPar_LUTE=mod.LUTE;
modelStruct.d_modelPar_LUTE_dX=0.0;
modelStruct.modelPar_given_LUTE=mod.given("LUTE");
modParamMap["LUTE"] = &(modelStruct.d_modelPar_LUTE_dX);
modelStruct.modelPar_NUTE=mod.NUTE;
modelStruct.d_modelPar_NUTE_dX=0.0;
modelStruct.modelPar_given_NUTE=mod.given("NUTE");
modParamMap["NUTE"] = &(modelStruct.d_modelPar_NUTE_dX);
modelStruct.modelPar_PUTE=mod.PUTE;
modelStruct.d_modelPar_PUTE_dX=0.0;
modelStruct.modelPar_given_PUTE=mod.given("PUTE");
modParamMap["PUTE"] = &(modelStruct.d_modelPar_PUTE_dX);
modelStruct.modelPar_LUTL=mod.LUTL;
modelStruct.d_modelPar_LUTL_dX=0.0;
modelStruct.modelPar_given_LUTL=mod.given("LUTL");
modParamMap["LUTL"] = &(modelStruct.d_modelPar_LUTL_dX);
modelStruct.modelPar_NUTL=mod.NUTL;
modelStruct.d_modelPar_NUTL_dX=0.0;
modelStruct.modelPar_given_NUTL=mod.given("NUTL");
modParamMap["NUTL"] = &(modelStruct.d_modelPar_NUTL_dX);
modelStruct.modelPar_PUTL=mod.PUTL;
modelStruct.d_modelPar_PUTL_dX=0.0;
modelStruct.modelPar_given_PUTL=mod.given("PUTL");
modParamMap["PUTL"] = &(modelStruct.d_modelPar_PUTL_dX);
modelStruct.modelPar_LEMOBT=mod.LEMOBT;
modelStruct.d_modelPar_LEMOBT_dX=0.0;
modelStruct.modelPar_given_LEMOBT=mod.given("LEMOBT");
modParamMap["LEMOBT"] = &(modelStruct.d_modelPar_LEMOBT_dX);
modelStruct.modelPar_NEMOBT=mod.NEMOBT;
modelStruct.d_modelPar_NEMOBT_dX=0.0;
modelStruct.modelPar_given_NEMOBT=mod.given("NEMOBT");
modParamMap["NEMOBT"] = &(modelStruct.d_modelPar_NEMOBT_dX);
modelStruct.modelPar_PEMOBT=mod.PEMOBT;
modelStruct.d_modelPar_PEMOBT_dX=0.0;
modelStruct.modelPar_given_PEMOBT=mod.given("PEMOBT");
modParamMap["PEMOBT"] = &(modelStruct.d_modelPar_PEMOBT_dX);
modelStruct.modelPar_LUA1=mod.LUA1;
modelStruct.d_modelPar_LUA1_dX=0.0;
modelStruct.modelPar_given_LUA1=mod.given("LUA1");
modParamMap["LUA1"] = &(modelStruct.d_modelPar_LUA1_dX);
modelStruct.modelPar_NUA1=mod.NUA1;
modelStruct.d_modelPar_NUA1_dX=0.0;
modelStruct.modelPar_given_NUA1=mod.given("NUA1");
modParamMap["NUA1"] = &(modelStruct.d_modelPar_NUA1_dX);
modelStruct.modelPar_PUA1=mod.PUA1;
modelStruct.d_modelPar_PUA1_dX=0.0;
modelStruct.modelPar_given_PUA1=mod.given("PUA1");
modParamMap["PUA1"] = &(modelStruct.d_modelPar_PUA1_dX);
modelStruct.modelPar_LUC1=mod.LUC1;
modelStruct.d_modelPar_LUC1_dX=0.0;
modelStruct.modelPar_given_LUC1=mod.given("LUC1");
modParamMap["LUC1"] = &(modelStruct.d_modelPar_LUC1_dX);
modelStruct.modelPar_NUC1=mod.NUC1;
modelStruct.d_modelPar_NUC1_dX=0.0;
modelStruct.modelPar_given_NUC1=mod.given("NUC1");
modParamMap["NUC1"] = &(modelStruct.d_modelPar_NUC1_dX);
modelStruct.modelPar_PUC1=mod.PUC1;
modelStruct.d_modelPar_PUC1_dX=0.0;
modelStruct.modelPar_given_PUC1=mod.given("PUC1");
modParamMap["PUC1"] = &(modelStruct.d_modelPar_PUC1_dX);
modelStruct.modelPar_LUD1=mod.LUD1;
modelStruct.d_modelPar_LUD1_dX=0.0;
modelStruct.modelPar_given_LUD1=mod.given("LUD1");
modParamMap["LUD1"] = &(modelStruct.d_modelPar_LUD1_dX);
modelStruct.modelPar_NUD1=mod.NUD1;
modelStruct.d_modelPar_NUD1_dX=0.0;
modelStruct.modelPar_given_NUD1=mod.given("NUD1");
modParamMap["NUD1"] = &(modelStruct.d_modelPar_NUD1_dX);
modelStruct.modelPar_PUD1=mod.PUD1;
modelStruct.d_modelPar_PUD1_dX=0.0;
modelStruct.modelPar_given_PUD1=mod.given("PUD1");
modParamMap["PUD1"] = &(modelStruct.d_modelPar_PUD1_dX);
modelStruct.modelPar_LUCSTE=mod.LUCSTE;
modelStruct.d_modelPar_LUCSTE_dX=0.0;
modelStruct.modelPar_given_LUCSTE=mod.given("LUCSTE");
modParamMap["LUCSTE"] = &(modelStruct.d_modelPar_LUCSTE_dX);
modelStruct.modelPar_NUCSTE=mod.NUCSTE;
modelStruct.d_modelPar_NUCSTE_dX=0.0;
modelStruct.modelPar_given_NUCSTE=mod.given("NUCSTE");
modParamMap["NUCSTE"] = &(modelStruct.d_modelPar_NUCSTE_dX);
modelStruct.modelPar_PUCSTE=mod.PUCSTE;
modelStruct.d_modelPar_PUCSTE_dX=0.0;
modelStruct.modelPar_given_PUCSTE=mod.given("PUCSTE");
modParamMap["PUCSTE"] = &(modelStruct.d_modelPar_PUCSTE_dX);
modelStruct.modelPar_LPTWGT=mod.LPTWGT;
modelStruct.d_modelPar_LPTWGT_dX=0.0;
modelStruct.modelPar_given_LPTWGT=mod.given("LPTWGT");
modParamMap["LPTWGT"] = &(modelStruct.d_modelPar_LPTWGT_dX);
modelStruct.modelPar_NPTWGT=mod.NPTWGT;
modelStruct.d_modelPar_NPTWGT_dX=0.0;
modelStruct.modelPar_given_NPTWGT=mod.given("NPTWGT");
modParamMap["NPTWGT"] = &(modelStruct.d_modelPar_NPTWGT_dX);
modelStruct.modelPar_PPTWGT=mod.PPTWGT;
modelStruct.d_modelPar_PPTWGT_dX=0.0;
modelStruct.modelPar_given_PPTWGT=mod.given("PPTWGT");
modParamMap["PPTWGT"] = &(modelStruct.d_modelPar_PPTWGT_dX);
modelStruct.modelPar_LAT=mod.LAT;
modelStruct.d_modelPar_LAT_dX=0.0;
modelStruct.modelPar_given_LAT=mod.given("LAT");
modParamMap["LAT"] = &(modelStruct.d_modelPar_LAT_dX);
modelStruct.modelPar_NAT=mod.NAT;
modelStruct.d_modelPar_NAT_dX=0.0;
modelStruct.modelPar_given_NAT=mod.given("NAT");
modParamMap["NAT"] = &(modelStruct.d_modelPar_NAT_dX);
modelStruct.modelPar_PAT=mod.PAT;
modelStruct.d_modelPar_PAT_dX=0.0;
modelStruct.modelPar_given_PAT=mod.given("PAT");
modParamMap["PAT"] = &(modelStruct.d_modelPar_PAT_dX);
modelStruct.modelPar_LSTTHETASAT=mod.LSTTHETASAT;
modelStruct.d_modelPar_LSTTHETASAT_dX=0.0;
modelStruct.modelPar_given_LSTTHETASAT=mod.given("LSTTHETASAT");
modParamMap["LSTTHETASAT"] = &(modelStruct.d_modelPar_LSTTHETASAT_dX);
modelStruct.modelPar_NSTTHETASAT=mod.NSTTHETASAT;
modelStruct.d_modelPar_NSTTHETASAT_dX=0.0;
modelStruct.modelPar_given_NSTTHETASAT=mod.given("NSTTHETASAT");
modParamMap["NSTTHETASAT"] = &(modelStruct.d_modelPar_NSTTHETASAT_dX);
modelStruct.modelPar_PSTTHETASAT=mod.PSTTHETASAT;
modelStruct.d_modelPar_PSTTHETASAT_dX=0.0;
modelStruct.modelPar_given_PSTTHETASAT=mod.given("PSTTHETASAT");
modParamMap["PSTTHETASAT"] = &(modelStruct.d_modelPar_PSTTHETASAT_dX);
modelStruct.modelPar_LPRT=mod.LPRT;
modelStruct.d_modelPar_LPRT_dX=0.0;
modelStruct.modelPar_given_LPRT=mod.given("LPRT");
modParamMap["LPRT"] = &(modelStruct.d_modelPar_LPRT_dX);
modelStruct.modelPar_NPRT=mod.NPRT;
modelStruct.d_modelPar_NPRT_dX=0.0;
modelStruct.modelPar_given_NPRT=mod.given("NPRT");
modParamMap["NPRT"] = &(modelStruct.d_modelPar_NPRT_dX);
modelStruct.modelPar_PPRT=mod.PPRT;
modelStruct.d_modelPar_PPRT_dX=0.0;
modelStruct.modelPar_given_PPRT=mod.given("PPRT");
modParamMap["PPRT"] = &(modelStruct.d_modelPar_PPRT_dX);
modelStruct.modelPar_LKT1=mod.LKT1;
modelStruct.d_modelPar_LKT1_dX=0.0;
modelStruct.modelPar_given_LKT1=mod.given("LKT1");
modParamMap["LKT1"] = &(modelStruct.d_modelPar_LKT1_dX);
modelStruct.modelPar_NKT1=mod.NKT1;
modelStruct.d_modelPar_NKT1_dX=0.0;
modelStruct.modelPar_given_NKT1=mod.given("NKT1");
modParamMap["NKT1"] = &(modelStruct.d_modelPar_NKT1_dX);
modelStruct.modelPar_PKT1=mod.PKT1;
modelStruct.d_modelPar_PKT1_dX=0.0;
modelStruct.modelPar_given_PKT1=mod.given("PKT1");
modParamMap["PKT1"] = &(modelStruct.d_modelPar_PKT1_dX);
modelStruct.modelPar_LTSS=mod.LTSS;
modelStruct.d_modelPar_LTSS_dX=0.0;
modelStruct.modelPar_given_LTSS=mod.given("LTSS");
modParamMap["LTSS"] = &(modelStruct.d_modelPar_LTSS_dX);
modelStruct.modelPar_NTSS=mod.NTSS;
modelStruct.d_modelPar_NTSS_dX=0.0;
modelStruct.modelPar_given_NTSS=mod.given("NTSS");
modParamMap["NTSS"] = &(modelStruct.d_modelPar_NTSS_dX);
modelStruct.modelPar_PTSS=mod.PTSS;
modelStruct.d_modelPar_PTSS_dX=0.0;
modelStruct.modelPar_given_PTSS=mod.given("PTSS");
modParamMap["PTSS"] = &(modelStruct.d_modelPar_PTSS_dX);
modelStruct.modelPar_LIIT=mod.LIIT;
modelStruct.d_modelPar_LIIT_dX=0.0;
modelStruct.modelPar_given_LIIT=mod.given("LIIT");
modParamMap["LIIT"] = &(modelStruct.d_modelPar_LIIT_dX);
modelStruct.modelPar_NIIT=mod.NIIT;
modelStruct.d_modelPar_NIIT_dX=0.0;
modelStruct.modelPar_given_NIIT=mod.given("NIIT");
modParamMap["NIIT"] = &(modelStruct.d_modelPar_NIIT_dX);
modelStruct.modelPar_PIIT=mod.PIIT;
modelStruct.d_modelPar_PIIT_dX=0.0;
modelStruct.modelPar_given_PIIT=mod.given("PIIT");
modParamMap["PIIT"] = &(modelStruct.d_modelPar_PIIT_dX);
modelStruct.modelPar_LTII=mod.LTII;
modelStruct.d_modelPar_LTII_dX=0.0;
modelStruct.modelPar_given_LTII=mod.given("LTII");
modParamMap["LTII"] = &(modelStruct.d_modelPar_LTII_dX);
modelStruct.modelPar_NTII=mod.NTII;
modelStruct.d_modelPar_NTII_dX=0.0;
modelStruct.modelPar_given_NTII=mod.given("NTII");
modParamMap["NTII"] = &(modelStruct.d_modelPar_NTII_dX);
modelStruct.modelPar_PTII=mod.PTII;
modelStruct.d_modelPar_PTII_dX=0.0;
modelStruct.modelPar_given_PTII=mod.given("PTII");
modParamMap["PTII"] = &(modelStruct.d_modelPar_PTII_dX);
modelStruct.modelPar_LTGIDL=mod.LTGIDL;
modelStruct.d_modelPar_LTGIDL_dX=0.0;
modelStruct.modelPar_given_LTGIDL=mod.given("LTGIDL");
modParamMap["LTGIDL"] = &(modelStruct.d_modelPar_LTGIDL_dX);
modelStruct.modelPar_NTGIDL=mod.NTGIDL;
modelStruct.d_modelPar_NTGIDL_dX=0.0;
modelStruct.modelPar_given_NTGIDL=mod.given("NTGIDL");
modParamMap["NTGIDL"] = &(modelStruct.d_modelPar_NTGIDL_dX);
modelStruct.modelPar_PTGIDL=mod.PTGIDL;
modelStruct.d_modelPar_PTGIDL_dX=0.0;
modelStruct.modelPar_given_PTGIDL=mod.given("PTGIDL");
modParamMap["PTGIDL"] = &(modelStruct.d_modelPar_PTGIDL_dX);
modelStruct.modelPar_LIGT=mod.LIGT;
modelStruct.d_modelPar_LIGT_dX=0.0;
modelStruct.modelPar_given_LIGT=mod.given("LIGT");
modParamMap["LIGT"] = &(modelStruct.d_modelPar_LIGT_dX);
modelStruct.modelPar_NIGT=mod.NIGT;
modelStruct.d_modelPar_NIGT_dX=0.0;
modelStruct.modelPar_given_NIGT=mod.given("NIGT");
modParamMap["NIGT"] = &(modelStruct.d_modelPar_NIGT_dX);
modelStruct.modelPar_PIGT=mod.PIGT;
modelStruct.d_modelPar_PIGT_dX=0.0;
modelStruct.modelPar_given_PIGT=mod.given("PIGT");
modParamMap["PIGT"] = &(modelStruct.d_modelPar_PIGT_dX);


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_NF=mod.NF;
modelStruct.modelPar_given_NF=mod.given("NF");
modelStruct.modelPar_NGCON=mod.NGCON;
modelStruct.modelPar_given_NGCON=mod.given("NGCON");
modelStruct.modelPar_DEVTYPE=mod.DEVTYPE;
modelStruct.modelPar_given_DEVTYPE=mod.given("DEVTYPE");
modelStruct.modelPar_BULKMOD=mod.BULKMOD;
modelStruct.modelPar_given_BULKMOD=mod.given("BULKMOD");
modelStruct.modelPar_COREMOD=mod.COREMOD;
modelStruct.modelPar_given_COREMOD=mod.given("COREMOD");
modelStruct.modelPar_GEOMOD=mod.GEOMOD;
modelStruct.modelPar_given_GEOMOD=mod.given("GEOMOD");
modelStruct.modelPar_CGEO1SW=mod.CGEO1SW;
modelStruct.modelPar_given_CGEO1SW=mod.given("CGEO1SW");
modelStruct.modelPar_RDSMOD=mod.RDSMOD;
modelStruct.modelPar_given_RDSMOD=mod.given("RDSMOD");
modelStruct.modelPar_ASYMMOD=mod.ASYMMOD;
modelStruct.modelPar_given_ASYMMOD=mod.given("ASYMMOD");
modelStruct.modelPar_IGCMOD=mod.IGCMOD;
modelStruct.modelPar_given_IGCMOD=mod.given("IGCMOD");
modelStruct.modelPar_IGBMOD=mod.IGBMOD;
modelStruct.modelPar_given_IGBMOD=mod.given("IGBMOD");
modelStruct.modelPar_GIDLMOD=mod.GIDLMOD;
modelStruct.modelPar_given_GIDLMOD=mod.given("GIDLMOD");
modelStruct.modelPar_IIMOD=mod.IIMOD;
modelStruct.modelPar_given_IIMOD=mod.given("IIMOD");
modelStruct.modelPar_NQSMOD=mod.NQSMOD;
modelStruct.modelPar_given_NQSMOD=mod.given("NQSMOD");
modelStruct.modelPar_SHMOD=mod.SHMOD;
modelStruct.modelPar_given_SHMOD=mod.given("SHMOD");
modelStruct.modelPar_RGATEMOD=mod.RGATEMOD;
modelStruct.modelPar_given_RGATEMOD=mod.given("RGATEMOD");
modelStruct.modelPar_RGEOMOD=mod.RGEOMOD;
modelStruct.modelPar_given_RGEOMOD=mod.given("RGEOMOD");
modelStruct.modelPar_CGEOMOD=mod.CGEOMOD;
modelStruct.modelPar_given_CGEOMOD=mod.given("CGEOMOD");
modelStruct.modelPar_CAPMOD=mod.CAPMOD;
modelStruct.modelPar_given_CAPMOD=mod.given("CAPMOD");
modelStruct.modelPar_SDTERM=mod.SDTERM;
modelStruct.modelPar_given_SDTERM=mod.given("SDTERM");
modelStruct.modelPar_NSEG=mod.NSEG;
modelStruct.modelPar_given_NSEG=mod.given("NSEG");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals


// non-reals



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 6+0 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
instanceStruct.instancePar_D=in.D;
instanceStruct.d_instancePar_D_dX=0.0;
instanceStruct.instancePar_given_D=in.given("D");
instanceStruct.instancePar_TFIN=in.TFIN;
instanceStruct.d_instancePar_TFIN_dX=0.0;
instanceStruct.instancePar_given_TFIN=in.given("TFIN");
instanceStruct.instancePar_FPITCH=in.FPITCH;
instanceStruct.d_instancePar_FPITCH_dX=0.0;
instanceStruct.instancePar_given_FPITCH=in.given("FPITCH");
instanceStruct.instancePar_NFIN=in.NFIN;
instanceStruct.d_instancePar_NFIN_dX=0.0;
instanceStruct.instancePar_given_NFIN=in.given("NFIN");
instanceStruct.instancePar_ASEO=in.ASEO;
instanceStruct.d_instancePar_ASEO_dX=0.0;
instanceStruct.instancePar_given_ASEO=in.given("ASEO");
instanceStruct.instancePar_ADEO=in.ADEO;
instanceStruct.d_instancePar_ADEO_dX=0.0;
instanceStruct.instancePar_given_ADEO=in.given("ADEO");
instanceStruct.instancePar_PSEO=in.PSEO;
instanceStruct.d_instancePar_PSEO_dX=0.0;
instanceStruct.instancePar_given_PSEO=in.given("PSEO");
instanceStruct.instancePar_PDEO=in.PDEO;
instanceStruct.d_instancePar_PDEO_dX=0.0;
instanceStruct.instancePar_given_PDEO=in.given("PDEO");
instanceStruct.instancePar_ASEJ=in.ASEJ;
instanceStruct.d_instancePar_ASEJ_dX=0.0;
instanceStruct.instancePar_given_ASEJ=in.given("ASEJ");
instanceStruct.instancePar_ADEJ=in.ADEJ;
instanceStruct.d_instancePar_ADEJ_dX=0.0;
instanceStruct.instancePar_given_ADEJ=in.given("ADEJ");
instanceStruct.instancePar_PSEJ=in.PSEJ;
instanceStruct.d_instancePar_PSEJ_dX=0.0;
instanceStruct.instancePar_given_PSEJ=in.given("PSEJ");
instanceStruct.instancePar_PDEJ=in.PDEJ;
instanceStruct.d_instancePar_PDEJ_dX=0.0;
instanceStruct.instancePar_given_PDEJ=in.given("PDEJ");
instanceStruct.instancePar_COVS=in.COVS;
instanceStruct.d_instancePar_COVS_dX=0.0;
instanceStruct.instancePar_given_COVS=in.given("COVS");
instanceStruct.instancePar_COVD=in.COVD;
instanceStruct.d_instancePar_COVD_dX=0.0;
instanceStruct.instancePar_given_COVD=in.given("COVD");
instanceStruct.instancePar_CGSP=in.CGSP;
instanceStruct.d_instancePar_CGSP_dX=0.0;
instanceStruct.instancePar_given_CGSP=in.given("CGSP");
instanceStruct.instancePar_CGDP=in.CGDP;
instanceStruct.d_instancePar_CGDP_dX=0.0;
instanceStruct.instancePar_given_CGDP=in.given("CGDP");
instanceStruct.instancePar_CDSP=in.CDSP;
instanceStruct.d_instancePar_CDSP_dX=0.0;
instanceStruct.instancePar_given_CDSP=in.given("CDSP");
instanceStruct.instancePar_NRS=in.NRS;
instanceStruct.d_instancePar_NRS_dX=0.0;
instanceStruct.instancePar_given_NRS=in.given("NRS");
instanceStruct.instancePar_NRD=in.NRD;
instanceStruct.d_instancePar_NRD_dX=0.0;
instanceStruct.instancePar_given_NRD=in.given("NRD");
instanceStruct.instancePar_LRSD=in.LRSD;
instanceStruct.d_instancePar_LRSD_dX=0.0;
instanceStruct.instancePar_given_LRSD=in.given("LRSD");
instanceStruct.instancePar_DELVTRAND=in.DELVTRAND;
instanceStruct.d_instancePar_DELVTRAND_dX=0.0;
instanceStruct.instancePar_given_DELVTRAND=in.given("DELVTRAND");
instanceStruct.instancePar_U0MULT=in.U0MULT;
instanceStruct.d_instancePar_U0MULT_dX=0.0;
instanceStruct.instancePar_given_U0MULT=in.given("U0MULT");


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.
   if (!(in.given("L")))
   {
      instanceStruct.instancePar_L = modelStruct.modelPar_L;
      instanceStruct.d_instancePar_L_dX = modelStruct.d_modelPar_L_dX;
   }
   if (!(in.given("D")))
   {
      instanceStruct.instancePar_D = modelStruct.modelPar_D;
      instanceStruct.d_instancePar_D_dX = modelStruct.d_modelPar_D_dX;
   }
   if (!(in.given("TFIN")))
   {
      instanceStruct.instancePar_TFIN = modelStruct.modelPar_TFIN;
      instanceStruct.d_instancePar_TFIN_dX = modelStruct.d_modelPar_TFIN_dX;
   }
   if (!(in.given("FPITCH")))
   {
      instanceStruct.instancePar_FPITCH = modelStruct.modelPar_FPITCH;
      instanceStruct.d_instancePar_FPITCH_dX = modelStruct.d_modelPar_FPITCH_dX;
   }
   if (!(in.given("NFIN")))
   {
      instanceStruct.instancePar_NFIN = modelStruct.modelPar_NFIN;
      instanceStruct.d_instancePar_NFIN_dX = modelStruct.d_modelPar_NFIN_dX;
   }
   if (!(in.given("NGCON")))
   {
      instanceStruct.instancePar_NGCON = modelStruct.modelPar_NGCON;
   }
   if (!(in.given("ASEO")))
   {
      instanceStruct.instancePar_ASEO = modelStruct.modelPar_ASEO;
      instanceStruct.d_instancePar_ASEO_dX = modelStruct.d_modelPar_ASEO_dX;
   }
   if (!(in.given("ADEO")))
   {
      instanceStruct.instancePar_ADEO = modelStruct.modelPar_ADEO;
      instanceStruct.d_instancePar_ADEO_dX = modelStruct.d_modelPar_ADEO_dX;
   }
   if (!(in.given("PSEO")))
   {
      instanceStruct.instancePar_PSEO = modelStruct.modelPar_PSEO;
      instanceStruct.d_instancePar_PSEO_dX = modelStruct.d_modelPar_PSEO_dX;
   }
   if (!(in.given("PDEO")))
   {
      instanceStruct.instancePar_PDEO = modelStruct.modelPar_PDEO;
      instanceStruct.d_instancePar_PDEO_dX = modelStruct.d_modelPar_PDEO_dX;
   }
   if (!(in.given("ASEJ")))
   {
      instanceStruct.instancePar_ASEJ = modelStruct.modelPar_ASEJ;
      instanceStruct.d_instancePar_ASEJ_dX = modelStruct.d_modelPar_ASEJ_dX;
   }
   if (!(in.given("ADEJ")))
   {
      instanceStruct.instancePar_ADEJ = modelStruct.modelPar_ADEJ;
      instanceStruct.d_instancePar_ADEJ_dX = modelStruct.d_modelPar_ADEJ_dX;
   }
   if (!(in.given("PSEJ")))
   {
      instanceStruct.instancePar_PSEJ = modelStruct.modelPar_PSEJ;
      instanceStruct.d_instancePar_PSEJ_dX = modelStruct.d_modelPar_PSEJ_dX;
   }
   if (!(in.given("PDEJ")))
   {
      instanceStruct.instancePar_PDEJ = modelStruct.modelPar_PDEJ;
      instanceStruct.d_instancePar_PDEJ_dX = modelStruct.d_modelPar_PDEJ_dX;
   }
   if (!(in.given("COVS")))
   {
      instanceStruct.instancePar_COVS = modelStruct.modelPar_COVS;
      instanceStruct.d_instancePar_COVS_dX = modelStruct.d_modelPar_COVS_dX;
   }
   if (!(in.given("COVD")))
   {
      instanceStruct.instancePar_COVD = modelStruct.modelPar_COVD;
      instanceStruct.d_instancePar_COVD_dX = modelStruct.d_modelPar_COVD_dX;
   }
   if (!(in.given("CGSP")))
   {
      instanceStruct.instancePar_CGSP = modelStruct.modelPar_CGSP;
      instanceStruct.d_instancePar_CGSP_dX = modelStruct.d_modelPar_CGSP_dX;
   }
   if (!(in.given("CGDP")))
   {
      instanceStruct.instancePar_CGDP = modelStruct.modelPar_CGDP;
      instanceStruct.d_instancePar_CGDP_dX = modelStruct.d_modelPar_CGDP_dX;
   }
   if (!(in.given("CDSP")))
   {
      instanceStruct.instancePar_CDSP = modelStruct.modelPar_CDSP;
      instanceStruct.d_instancePar_CDSP_dX = modelStruct.d_modelPar_CDSP_dX;
   }
   if (!(in.given("NRS")))
   {
      instanceStruct.instancePar_NRS = modelStruct.modelPar_NRS;
      instanceStruct.d_instancePar_NRS_dX = modelStruct.d_modelPar_NRS_dX;
   }
   if (!(in.given("NRD")))
   {
      instanceStruct.instancePar_NRD = modelStruct.modelPar_NRD;
      instanceStruct.d_instancePar_NRD_dX = modelStruct.d_modelPar_NRD_dX;
   }
   if (!(in.given("LRSD")))
   {
      instanceStruct.instancePar_LRSD = modelStruct.modelPar_LRSD;
      instanceStruct.d_instancePar_LRSD_dX = modelStruct.d_modelPar_LRSD_dX;
   }
   if (!(in.given("DELVTRAND")))
   {
      instanceStruct.instancePar_DELVTRAND = modelStruct.modelPar_DELVTRAND;
      instanceStruct.d_instancePar_DELVTRAND_dX = modelStruct.d_modelPar_DELVTRAND_dX;
   }
   if (!(in.given("U0MULT")))
   {
      instanceStruct.instancePar_U0MULT = modelStruct.modelPar_U0MULT;
      instanceStruct.d_instancePar_U0MULT_dX = modelStruct.d_modelPar_U0MULT_dX;
   }


  //make local copies of all instance vars
  //reals


  //non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_e_GND] = (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_di_GND] = (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_g_GND] = (*solVectorPtr)[in.li_g];
probeVars[in.admsProbeID_V_s_si] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_d_di] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_e_g] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_g];
probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_g_d] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_g_s] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_di_d] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_g_e] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_e_di] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_e_si] = (*solVectorPtr)[in.li_e] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_g_di] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_g_si] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_si];




// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_si_GND,
in.admsProbeID_V_e_GND,
in.admsProbeID_V_di_GND,
in.admsProbeID_V_g_GND,
in.admsProbeID_V_s_si,
in.admsProbeID_V_d_di,
in.admsProbeID_V_e_g,
in.admsProbeID_V_d_s,
in.admsProbeID_V_g_d,
in.admsProbeID_V_g_s,
in.admsProbeID_V_di_d,
in.admsProbeID_V_si_s,
in.admsProbeID_V_g_e,
in.admsProbeID_V_e_di,
in.admsProbeID_V_e_si,
in.admsProbeID_V_g_di,
in.admsProbeID_V_di_si,
in.admsProbeID_V_g_si,

// node constants
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_e,
in.admsNodeID_di,
in.admsNodeID_si,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_d];
    dqdp[in.admsNodeID_d+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_d];
    Findices[in.admsNodeID_d+inst*(6+0)] = in.li_d;
    Qindices[in.admsNodeID_d+inst*(6+0)] = in.li_d;
    dfdp[in.admsNodeID_g+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_g];
    dqdp[in.admsNodeID_g+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_g];
    Findices[in.admsNodeID_g+inst*(6+0)] = in.li_g;
    Qindices[in.admsNodeID_g+inst*(6+0)] = in.li_g;
    dfdp[in.admsNodeID_s+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s+inst*(6+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(6+0)] = in.li_s;
    dfdp[in.admsNodeID_e+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_e];
    dqdp[in.admsNodeID_e+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_e];
    Findices[in.admsNodeID_e+inst*(6+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(6+0)] = in.li_e;
    dfdp[in.admsNodeID_di+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_di];
    dqdp[in.admsNodeID_di+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_di];
    Findices[in.admsNodeID_di+inst*(6+0)] = in.li_di;
    Qindices[in.admsNodeID_di+inst*(6+0)] = in.li_di;
    dfdp[in.admsNodeID_si+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si+inst*(6+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(6+0)] = in.li_si;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSbsimcmg
} // namespace Device
} // namespace Xyce
