
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file hicumL2V2p4p0.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:28
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMShicumL2va.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

  #include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMShicumL2va {


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_c;
    const int Instance::admsNodeID_b;
    const int Instance::admsNodeID_e;
    const int Instance::admsNodeID_s;
    const int Instance::admsNodeID_tnode;
    const int Instance::admsNodeID_ci;
    const int Instance::admsNodeID_ei;
    const int Instance::admsNodeID_bp;
    const int Instance::admsNodeID_bi;
    const int Instance::admsNodeID_si;
    const int Instance::admsNodeID_xf1;
    const int Instance::admsNodeID_xf2;
    const int Instance::admsNodeID_xf;
    const int Instance::admsNodeID_n1;
    const int Instance::admsNodeID_n2;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMShicumL2va::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMShicumL2va::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");


}

void Traits::loadModelParameters(ParametricData<ADMShicumL2va::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMShicumL2va::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("C10", static_cast<double>(2.0E-30), &ADMShicumL2va::Model::c10)
    .setDescription("GICCR constant")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QP0", static_cast<double>(2.0E-14), &ADMShicumL2va::Model::qp0)
    .setDescription("Zero-bias hole charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ICH", static_cast<double>(0.0), &ADMShicumL2va::Model::ich)
    .setDescription("High-current correction for 2D and 3D effects")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("HF0", static_cast<double>(1.0), &ADMShicumL2va::Model::hf0)
    .setDescription("Weight factor for the low current minority charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("HFE", static_cast<double>(1.0), &ADMShicumL2va::Model::hfe)
    .setDescription("Emitter minority charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("HFC", static_cast<double>(1.0), &ADMShicumL2va::Model::hfc)
    .setDescription("Collector minority charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("HJEI", static_cast<double>(1.0), &ADMShicumL2va::Model::hjei)
    .setDescription("B-E depletion charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AHJEI", static_cast<double>(0.0), &ADMShicumL2va::Model::ahjei)
    .setDescription("Parameter describing the slope of hjEi(VBE)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RHJEI", static_cast<double>(1.0), &ADMShicumL2va::Model::rhjei)
    .setDescription("Smoothing parameter for hjEi(VBE) at high voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("HJCI", static_cast<double>(1.0), &ADMShicumL2va::Model::hjci)
    .setDescription("B-C depletion charge weighting factor in HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IBEIS", static_cast<double>(1.0E-18), &ADMShicumL2va::Model::ibeis)
    .setDescription("Internal B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MBEI", static_cast<double>(1.0), &ADMShicumL2va::Model::mbei)
    .setDescription("Internal B-E current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IREIS", static_cast<double>(0.0), &ADMShicumL2va::Model::ireis)
    .setDescription("Internal B-E recombination saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MREI", static_cast<double>(2.0), &ADMShicumL2va::Model::mrei)
    .setDescription("Internal B-E recombination current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IBEPS", static_cast<double>(0.0), &ADMShicumL2va::Model::ibeps)
    .setDescription("Peripheral B-E saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MBEP", static_cast<double>(1.0), &ADMShicumL2va::Model::mbep)
    .setDescription("Peripheral B-E current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IREPS", static_cast<double>(0.0), &ADMShicumL2va::Model::ireps)
    .setDescription("Peripheral B-E recombination saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MREP", static_cast<double>(2.0), &ADMShicumL2va::Model::mrep)
    .setDescription("Peripheral B-E recombination current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MCF", static_cast<double>(1.0), &ADMShicumL2va::Model::mcf)
    .setDescription("Non-ideality factor for III-V HBTs")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBHREC", static_cast<double>(0.0), &ADMShicumL2va::Model::tbhrec)
    .setDescription("Base current recombination time constant at B-C barrier for high forward injection")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IBCIS", static_cast<double>(1.0E-16), &ADMShicumL2va::Model::ibcis)
    .setDescription("Internal B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MBCI", static_cast<double>(1.0), &ADMShicumL2va::Model::mbci)
    .setDescription("Internal B-C current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IBCXS", static_cast<double>(0.0), &ADMShicumL2va::Model::ibcxs)
    .setDescription("External B-C saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MBCX", static_cast<double>(1.0), &ADMShicumL2va::Model::mbcx)
    .setDescription("External B-C current ideality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IBETS", static_cast<double>(0.0), &ADMShicumL2va::Model::ibets)
    .setDescription("B-E tunneling saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ABET", static_cast<double>(40), &ADMShicumL2va::Model::abet)
    .setDescription("Exponent factor for tunneling current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TUNODE", static_cast<int>(1), &ADMShicumL2va::Model::tunode)
    .setDescription("Specifies the base node connection for the tunneling current");
  p.addPar("FAVL", static_cast<double>(0.0), &ADMShicumL2va::Model::favl)
    .setDescription("Avalanche current factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QAVL", static_cast<double>(0.0), &ADMShicumL2va::Model::qavl)
    .setDescription("Exponent factor for avalanche current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KAVL", static_cast<double>(0.0), &ADMShicumL2va::Model::kavl)
    .setDescription("Flag/factor for turning strong avalanche on")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALFAV", static_cast<double>(0.0), &ADMShicumL2va::Model::alfav)
    .setDescription("Relative TC for FAVL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALQAV", static_cast<double>(0.0), &ADMShicumL2va::Model::alqav)
    .setDescription("Relative TC for QAVL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALKAV", static_cast<double>(0.0), &ADMShicumL2va::Model::alkav)
    .setDescription("Relative TC for KAVL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBI0", static_cast<double>(0.0), &ADMShicumL2va::Model::rbi0)
    .setDescription("Zero bias internal base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBX", static_cast<double>(0.0), &ADMShicumL2va::Model::rbx)
    .setDescription("External base series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FGEO", static_cast<double>(0.6557), &ADMShicumL2va::Model::fgeo)
    .setDescription("Factor for geometry dependence of emitter current crowding")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FDQR0", static_cast<double>(0.0), &ADMShicumL2va::Model::fdqr0)
    .setDescription("Correction factor for modulation by B-E and B-C space charge layer")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FCRBI", static_cast<double>(0.0), &ADMShicumL2va::Model::fcrbi)
    .setDescription("Ratio of HF shunt to total internal capacitance (lateral NQS effect)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FQI", static_cast<double>(1.0), &ADMShicumL2va::Model::fqi)
    .setDescription("Ration of internal to total minority charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RE", static_cast<double>(0.0), &ADMShicumL2va::Model::re)
    .setDescription("Emitter series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RCX", static_cast<double>(0.0), &ADMShicumL2va::Model::rcx)
    .setDescription("External collector series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ITSS", static_cast<double>(0.0), &ADMShicumL2va::Model::itss)
    .setDescription("Substrate transistor transfer saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MSF", static_cast<double>(1.0), &ADMShicumL2va::Model::msf)
    .setDescription("Forward ideality factor of substrate transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ISCS", static_cast<double>(0.0), &ADMShicumL2va::Model::iscs)
    .setDescription("C-S diode saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MSC", static_cast<double>(1.0), &ADMShicumL2va::Model::msc)
    .setDescription("Ideality factor of C-S diode current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TSF", static_cast<double>(0.0), &ADMShicumL2va::Model::tsf)
    .setDescription("Transit time for forward operation of substrate transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSU", static_cast<double>(0.0), &ADMShicumL2va::Model::rsu)
    .setDescription("Substrate series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSU", static_cast<double>(0.0), &ADMShicumL2va::Model::csu)
    .setDescription("Substrate shunt capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJEI0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjei0)
    .setDescription("Internal B-E zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VDEI", static_cast<double>(0.9), &ADMShicumL2va::Model::vdei)
    .setDescription("Internal B-E built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZEI", static_cast<double>(0.5), &ADMShicumL2va::Model::zei)
    .setDescription("Internal B-E grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AJEI", static_cast<double>(2.5), &ADMShicumL2va::Model::ajei)
    .setDescription("Ratio of maximum to zero-bias value of internal B-E capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJEP0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjep0)
    .setDescription("Peripheral B-E zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VDEP", static_cast<double>(0.9), &ADMShicumL2va::Model::vdep)
    .setDescription("Peripheral B-E built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZEP", static_cast<double>(0.5), &ADMShicumL2va::Model::zep)
    .setDescription("Peripheral B-E grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AJEP", static_cast<double>(2.5), &ADMShicumL2va::Model::ajep)
    .setDescription("Ratio of maximum to zero-bias value of peripheral B-E capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJCI0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjci0)
    .setDescription("Internal B-C zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VDCI", static_cast<double>(0.7), &ADMShicumL2va::Model::vdci)
    .setDescription("Internal B-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZCI", static_cast<double>(0.4), &ADMShicumL2va::Model::zci)
    .setDescription("Internal B-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPTCI", static_cast<double>(100), &ADMShicumL2va::Model::vptci)
    .setDescription("Internal B-C punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJCX0", static_cast<double>(1.0E-20), &ADMShicumL2va::Model::cjcx0)
    .setDescription("External B-C zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VDCX", static_cast<double>(0.7), &ADMShicumL2va::Model::vdcx)
    .setDescription("External B-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZCX", static_cast<double>(0.4), &ADMShicumL2va::Model::zcx)
    .setDescription("External B-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPTCX", static_cast<double>(100), &ADMShicumL2va::Model::vptcx)
    .setDescription("External B-C punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBCPAR", static_cast<double>(0.0), &ADMShicumL2va::Model::fbcpar)
    .setDescription("Partitioning factor of parasitic B-C cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBEPAR", static_cast<double>(1.0), &ADMShicumL2va::Model::fbepar)
    .setDescription("Partitioning factor of parasitic B-E cap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJS0", static_cast<double>(0.0), &ADMShicumL2va::Model::cjs0)
    .setDescription("C-S zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VDS", static_cast<double>(0.6), &ADMShicumL2va::Model::vds)
    .setDescription("C-S built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZS", static_cast<double>(0.5), &ADMShicumL2va::Model::zs)
    .setDescription("C-S grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPTS", static_cast<double>(100), &ADMShicumL2va::Model::vpts)
    .setDescription("C-S punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSCP0", static_cast<double>(0.0), &ADMShicumL2va::Model::cscp0)
    .setDescription("Perimeter S-C zero-bias depletion capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VDSP", static_cast<double>(0.6), &ADMShicumL2va::Model::vdsp)
    .setDescription("Perimeter S-C built-in potential")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZSP", static_cast<double>(0.5), &ADMShicumL2va::Model::zsp)
    .setDescription("Perimeter S-C grading coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPTSP", static_cast<double>(100), &ADMShicumL2va::Model::vptsp)
    .setDescription("Perimeter S-C punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("T0", static_cast<double>(0.0), &ADMShicumL2va::Model::t0)
    .setDescription("Low current forward transit time at VBC=0V")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DT0H", static_cast<double>(0.0), &ADMShicumL2va::Model::dt0h)
    .setDescription("Time constant for base and B-C space charge layer width modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBVL", static_cast<double>(0.0), &ADMShicumL2va::Model::tbvl)
    .setDescription("Time constant for modeling carrier jam at low VCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TEF0", static_cast<double>(0.0), &ADMShicumL2va::Model::tef0)
    .setDescription("Neutral emitter storage time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GTFE", static_cast<double>(1.0), &ADMShicumL2va::Model::gtfe)
    .setDescription("Exponent factor for current dependence of neutral emitter storage time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THCS", static_cast<double>(0.0), &ADMShicumL2va::Model::thcs)
    .setDescription("Saturation time constant at high current densities")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AHC", static_cast<double>(0.1), &ADMShicumL2va::Model::ahc)
    .setDescription("Smoothing factor for current dependence of base and collector transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FTHC", static_cast<double>(0.0), &ADMShicumL2va::Model::fthc)
    .setDescription("Partitioning factor for base and collector portion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RCI0", static_cast<double>(150), &ADMShicumL2va::Model::rci0)
    .setDescription("Internal collector resistance at low electric field")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VLIM", static_cast<double>(0.5), &ADMShicumL2va::Model::vlim)
    .setDescription("Voltage separating ohmic and saturation velocity regime")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VCES", static_cast<double>(0.1), &ADMShicumL2va::Model::vces)
    .setDescription("Internal C-E saturation voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPT", static_cast<double>(100.0), &ADMShicumL2va::Model::vpt)
    .setDescription("Collector punch-through voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AICK", static_cast<double>(1e-3), &ADMShicumL2va::Model::aick)
    .setDescription("Smoothing term for ICK")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELCK", static_cast<double>(2.0), &ADMShicumL2va::Model::delck)
    .setDescription("Fitting factor for critical current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TR", static_cast<double>(0.0), &ADMShicumL2va::Model::tr)
    .setDescription("Storage time for inverse operation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VCBAR", static_cast<double>(0.0), &ADMShicumL2va::Model::vcbar)
    .setDescription("Barrier voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ICBAR", static_cast<double>(0.0), &ADMShicumL2va::Model::icbar)
    .setDescription("Normalization parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ACBAR", static_cast<double>(0.01), &ADMShicumL2va::Model::acbar)
    .setDescription("Smoothing parameter for barrier voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBEPAR", static_cast<double>(0.0), &ADMShicumL2va::Model::cbepar)
    .setDescription("Total parasitic B-E capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBCPAR", static_cast<double>(0.0), &ADMShicumL2va::Model::cbcpar)
    .setDescription("Total parasitic B-C capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALQF", static_cast<double>(0.167), &ADMShicumL2va::Model::alqf)
    .setDescription("Factor for additional delay time of minority charge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALIT", static_cast<double>(0.333), &ADMShicumL2va::Model::alit)
    .setDescription("Factor for additional delay time of transfer current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLNQS", static_cast<int>(0), &ADMShicumL2va::Model::flnqs)
    .setDescription("Flag for turning on and off of vertical NQS effect");
  p.addPar("KF", static_cast<double>(0.0), &ADMShicumL2va::Model::kf)
    .setDescription("Flicker noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AF", static_cast<double>(2.0), &ADMShicumL2va::Model::af)
    .setDescription("Flicker noise exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFBE", static_cast<int>((-1)), &ADMShicumL2va::Model::cfbe)
    .setDescription("Flag for determining where to tag the flicker noise source");
  p.addPar("FLCONO", static_cast<int>(0), &ADMShicumL2va::Model::flcono)
    .setDescription("Flag for turning on and off of correlated noise implementation");
  p.addPar("KFRE", static_cast<double>(0.0), &ADMShicumL2va::Model::kfre)
    .setDescription("Emitter resistance flicker noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AFRE", static_cast<double>(2.0), &ADMShicumL2va::Model::afre)
    .setDescription("Emitter resistance flicker noise exponent factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LATB", static_cast<double>(0.0), &ADMShicumL2va::Model::latb)
    .setDescription("Scaling factor for collector minority charge in direction of emitter width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LATL", static_cast<double>(0.0), &ADMShicumL2va::Model::latl)
    .setDescription("Scaling factor for collector minority charge in direction of emitter length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGB", static_cast<double>(1.17), &ADMShicumL2va::Model::vgb)
    .setDescription("Bandgap voltage extrapolated to 0 K")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALT0", static_cast<double>(0.0), &ADMShicumL2va::Model::alt0)
    .setDescription("First order relative TC of parameter T0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KT0", static_cast<double>(0.0), &ADMShicumL2va::Model::kt0)
    .setDescription("Second order relative TC of parameter T0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETACI", static_cast<double>(0.0), &ADMShicumL2va::Model::zetaci)
    .setDescription("Temperature exponent for RCI0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALVS", static_cast<double>(0.0), &ADMShicumL2va::Model::alvs)
    .setDescription("Relative TC of saturation drift velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALCES", static_cast<double>(0.0), &ADMShicumL2va::Model::alces)
    .setDescription("Relative TC of VCES")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETARBI", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarbi)
    .setDescription("Temperature exponent of internal base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETARBX", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarbx)
    .setDescription("Temperature exponent of external base resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETARCX", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarcx)
    .setDescription("Temperature exponent of external collector resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETARE", static_cast<double>(0.0), &ADMShicumL2va::Model::zetare)
    .setDescription("Temperature exponent of emitter resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETACX", static_cast<double>(1.0), &ADMShicumL2va::Model::zetacx)
    .setDescription("Temperature exponent of mobility in substrate transistor transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGE", static_cast<double>(1.17), &ADMShicumL2va::Model::vge)
    .setDescription("Effective emitter bandgap voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGC", static_cast<double>(1.17), &ADMShicumL2va::Model::vgc)
    .setDescription("Effective collector bandgap voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGS", static_cast<double>(1.17), &ADMShicumL2va::Model::vgs)
    .setDescription("Effective substrate bandgap voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("F1VG", static_cast<double>((-1.02377e-4)), &ADMShicumL2va::Model::f1vg)
    .setDescription("Coefficient K1 in T-dependent band-gap equation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("F2VG", static_cast<double>(4.3215e-4), &ADMShicumL2va::Model::f2vg)
    .setDescription("Coefficient K2 in T-dependent band-gap equation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETACT", static_cast<double>(3.0), &ADMShicumL2va::Model::zetact)
    .setDescription("Exponent coefficient in transfer current temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETABET", static_cast<double>(3.5), &ADMShicumL2va::Model::zetabet)
    .setDescription("Exponent coefficient in B-E junction current temperature dependence")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALB", static_cast<double>(0.0), &ADMShicumL2va::Model::alb)
    .setDescription("Relative TC of forward current gain for V2.1 model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVGBE", static_cast<double>(0), &ADMShicumL2va::Model::dvgbe)
    .setDescription("Bandgap difference between B and B-E junction used for hjEi0 and hf0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETAHJEI", static_cast<double>(1), &ADMShicumL2va::Model::zetahjei)
    .setDescription("Temperature coefficient for ahjEi")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETAVGBE", static_cast<double>(1), &ADMShicumL2va::Model::zetavgbe)
    .setDescription("Temperature coefficient for hjEi0")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLSH", static_cast<int>(0), &ADMShicumL2va::Model::flsh)
    .setDescription("Flag for turning on and off self-heating effect");
  p.addPar("RTH", static_cast<double>(0.0), &ADMShicumL2va::Model::rth)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ZETARTH", static_cast<double>(0.0), &ADMShicumL2va::Model::zetarth)
    .setDescription("Temperature coefficient for Rth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALRTH", static_cast<double>(0.0), &ADMShicumL2va::Model::alrth)
    .setDescription("First order relative TC of parameter Rth")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTH", static_cast<double>(0.0), &ADMShicumL2va::Model::cth)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLCOMP", static_cast<double>(0.0), &ADMShicumL2va::Model::flcomp)
    .setDescription("Flag for compatibility with v2.1 model (0=v2.1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMShicumL2va::Model::tnom)
    .setDescription("Temperature at which parameters are specified")
   .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DT", static_cast<double>(0.0), &ADMShicumL2va::Model::dt)
    .setDescription("Temperature change w.r.t. chip temperature for particular transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TYPE", static_cast<int>(1), &ADMShicumL2va::Model::type)
    .setDescription("For transistor type NPN(+1) or PNP (-1)");

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double C_1=0.0;
  double vge_t0=0.0;
  double vgb_t0=0.0;
  double k20=0.0;
  double k10=0.0;
//Begin block initial_instance
{
Tnom = ((model_.tnom)+273.15);
Tamb = admsTemperature;
vt0 = ((1.3806503e-23*Tnom)/1.6021766208e-19);
{
double value_log_0 = log(Tnom);
k10 = (((model_.f1vg)*Tnom)*value_log_0);
}
k20 = ((model_.f2vg)*Tnom);
avs = ((model_.alvs)*Tnom);
vgb_t0 = (((model_.vgb)+k10)+k20);
vge_t0 = (((model_.vge)+k10)+k20);
vgbe_t0 = ((vgb_t0+vge_t0)/2);
vgbe0 = (((model_.vgb)+(model_.vge))/2);
vgbc0 = (((model_.vgb)+(model_.vgc))/2);
vgsc0 = (((model_.vgs)+(model_.vgc))/2);
mg = (3-((1.6021766208e-19*(model_.f1vg))/1.3806503e-23));
zetabci = ((mg+1)-(model_.zetaci));
zetabcxt = ((mg+1)-(model_.zetacx));
zetasct = (mg-1.5);
C_1 = ((1.0-(model_.fbcpar))*((model_.cjcx0)+(model_.cbcpar)));
if ((C_1>=(model_.cbcpar)))
{
cbcpar1 = (model_.cbcpar);
cbcpar2 = 0.0;
cjcx01 = (C_1-(model_.cbcpar));
cjcx02 = ((model_.cjcx0)-cjcx01);
}
else
{
cbcpar1 = C_1;
cbcpar2 = ((model_.cbcpar)-cbcpar1);
cjcx01 = 0.0;
cjcx02 = (model_.cjcx0);
}
cbepar2 = ((model_.fbepar)*(model_.cbepar));
cbepar1 = ((model_.cbepar)-cbepar2);
if (((model_.ich)!=0.0))
{
Oich = (1.0/(model_.ich));
}
else
{
Oich = 0.0;
}
if (((model_.tbhrec)!=0.0))
{
Otbhrec = (1.0/(model_.tbhrec));
}
else
{
Otbhrec = 0.0;
}
if ((((model_.favl)>0.0)&&((model_.cjci0)>0.0)))
{
use_aval = 1;
}
else
{
use_aval = 0;

d_iavl_dV_tnode_GND = d_iavl_dV_bi_ei = d_iavl_dV_bi_ci =  0.0;
iavl = 0.0;
}
if ((((model_.flsh)==0)||((model_.rth)<0.001)))
//Begin block Thermal_updat_without_self_heating
{

d_Tdev_dV_tnode_GND =  0.0;
Tdev = (Tamb+(model_.dt));
if ((Tdev<((-100.0)+273.15)))
{

d_Tdev_dV_tnode_GND =  0.0;
Tdev = ((-100.0)+273.15);
}
else
{
if ((Tdev>(326.85+273.15)))
{

d_Tdev_dV_tnode_GND =  0.0;
Tdev = (326.85+273.15);
}
}

d_VT_dV_tnode_GND =  0.0;
VT = ((1.3806503e-23*Tdev)/1.6021766208e-19);

d_dT_dV_tnode_GND =  0.0;
dT = (Tdev-Tnom);

d_qtt0_dV_tnode_GND =  0.0;
qtt0 = (Tdev/Tnom);
{
double value_log_0 = log(qtt0);

d_ln_qtt0_dV_tnode_GND =  0.0;
ln_qtt0 = value_log_0;
}
{
double value_log_0 = log(Tdev);

d_k1_dV_tnode_GND =  0.0;
k1 = (((model_.f1vg)*Tdev)*value_log_0);
}

d_k2_dV_tnode_GND =  0.0;
k2 = ((model_.f2vg)*Tdev);

d_vgb_t_dV_tnode_GND =  0.0;
vgb_t = (((model_.vgb)+k1)+k2);

d_vge_t_dV_tnode_GND =  0.0;
vge_t = (((model_.vge)+k1)+k2);

d_vgbe_t_dV_tnode_GND =  0.0;
vgbe_t = ((vgb_t+vge_t)/2);
if (((model_.cjei0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdei)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdei))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND =  0.0;
vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND =  0.0;
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdei_t_dV_tnode_GND =  0.0;
vdei_t = vdt;
{
double value_log_0 = log(((model_.vdei)/vdei_t));
double value_exp_1 = exp(((model_.zei)*value_log_0));

d_cjei0_t_dV_tnode_GND =  0.0;
cjei0_t = ((model_.cjei0)*value_exp_1);
}
if ((1==1))
{

d_ajei_t_dV_tnode_GND =  0.0;
ajei_t = (((model_.ajei)*vdei_t)/(model_.vdei));
}
else
{

d_ajei_t_dV_tnode_GND =  0.0;
ajei_t = (model_.ajei);
}
}
else
{

d_cjei0_t_dV_tnode_GND =  0.0;
cjei0_t = (model_.cjei0);

d_vdei_t_dV_tnode_GND =  0.0;
vdei_t = (model_.vdei);

d_ajei_t_dV_tnode_GND =  0.0;
ajei_t = (model_.ajei);
}
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{

d_V_gT_dV_tnode_GND =  0.0;
V_gT = (((3.0*VT)*ln_qtt0)+((model_.vgb)*(qtt0-1.0)));

d_r_VgVT_dV_tnode_GND =  0.0;
r_VgVT = (V_gT/VT);

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = ((((model_.mcf)*r_VgVT)/(model_.mbei))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);

d_ibeis_t_dV_tnode_GND =  0.0;
ibeis_t = ((model_.ibeis)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = ((((model_.mcf)*r_VgVT)/(model_.mrei))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);

d_ireis_t_dV_tnode_GND =  0.0;
ireis_t = ((model_.ireis)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = ((((model_.mcf)*r_VgVT)/(model_.mbep))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);

d_ibeps_t_dV_tnode_GND =  0.0;
ibeps_t = ((model_.ibeps)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = ((((model_.mcf)*r_VgVT)/(model_.mrep))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);

d_ireps_t_dV_tnode_GND =  0.0;
ireps_t = ((model_.ireps)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = (r_VgVT/(model_.mbci));
{
double value_exp_0 = exp(a);

d_ibcis_t_dV_tnode_GND =  0.0;
ibcis_t = ((model_.ibcis)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = (r_VgVT/(model_.mbcx));
{
double value_exp_0 = exp(a);

d_ibcxs_t_dV_tnode_GND =  0.0;
ibcxs_t = ((model_.ibcxs)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = (r_VgVT/(model_.msf));
{
double value_exp_0 = exp(a);

d_itss_t_dV_tnode_GND =  0.0;
itss_t = ((model_.itss)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = (r_VgVT/(model_.msc));
{
double value_exp_0 = exp(a);

d_iscs_t_dV_tnode_GND =  0.0;
iscs_t = ((model_.iscs)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = (vdei_t/(model_.vdei));

d_qp0_t_dV_tnode_GND =  0.0;
qp0_t = ((model_.qp0)*(1.0+((0.5*(model_.zei))*(1.0-a))));
{
double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = (((model_.vlim)*(1.0-((model_.alvs)*dT)))*value_exp_0);
}

d_k_dV_tnode_GND =  0.0;
k = ((a-VT)/VT);
if ((k<11.0))
{
{
double value_exp_0 = exp(k);
double value_log_1 = log((1.0+value_exp_0));

d_vlim_t_dV_tnode_GND =  0.0;
vlim_t = (VT+(VT*value_log_1));
}
}
else
{

d_vlim_t_dV_tnode_GND =  0.0;
vlim_t = a;
}

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = (1.0+((model_.alb)*dT));
{
double value_sqrt_0 = sqrt(((a*a)+0.01));

d_k_dV_tnode_GND =  0.0;
k = (0.5*(a+value_sqrt_0));
}

d_tef0_t_dV_tnode_GND =  0.0;
tef0_t = (((model_.tef0)*qtt0)/k);
}
else
{
{
double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));

d_ibeis_t_dV_tnode_GND =  0.0;
ibeis_t = ((model_.ibeis)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{
{
double value_exp_0 = exp((((mg/(model_.mrei))*ln_qtt0)+((vgbe0/((model_.mrei)*VT))*(qtt0-1))));

d_ireis_t_dV_tnode_GND =  0.0;
ireis_t = ((model_.ireis)*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));

d_ireis_t_dV_tnode_GND =  0.0;
ireis_t = ((model_.ireis)*value_exp_0);
}
}
{
double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));

d_ibeps_t_dV_tnode_GND =  0.0;
ibeps_t = ((model_.ibeps)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{
{
double value_exp_0 = exp((((mg/(model_.mrep))*ln_qtt0)+((vgbe0/((model_.mrep)*VT))*(qtt0-1))));

d_ireps_t_dV_tnode_GND =  0.0;
ireps_t = ((model_.ireps)*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));

d_ireps_t_dV_tnode_GND =  0.0;
ireps_t = ((model_.ireps)*value_exp_0);
}
}
{
double value_exp_0 = exp(((zetabci*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));

d_ibcis_t_dV_tnode_GND =  0.0;
ibcis_t = ((model_.ibcis)*value_exp_0);
}
{
double value_exp_0 = exp(((zetabcxt*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));

d_ibcxs_t_dV_tnode_GND =  0.0;
ibcxs_t = ((model_.ibcxs)*value_exp_0);
}
{
double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));

d_itss_t_dV_tnode_GND =  0.0;
itss_t = ((model_.itss)*value_exp_0);
}
{
double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgs)/VT)*(qtt0-1))));

d_iscs_t_dV_tnode_GND =  0.0;
iscs_t = ((model_.iscs)*value_exp_0);
}
{
double value_log_0 = log((vdei_t/(model_.vdei)));
double value_exp_1 = exp(((model_.zei)*value_log_0));

d_a_dV_bi_ei = d_a_dV_bi_ci = d_a_dV_tnode_GND =  0.0;
a = value_exp_1;
}

d_qp0_t_dV_tnode_GND =  0.0;
qp0_t = ((model_.qp0)*(2.0-a));
{
double value_exp_0 = exp((((model_.zetaci)-avs)*ln_qtt0));

d_vlim_t_dV_tnode_GND =  0.0;
vlim_t = ((model_.vlim)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{

d_tef0_t_dV_tnode_GND =  0.0;
tef0_t = (model_.tef0);
}
else
{
zetatef = (((model_.zetabet)-(model_.zetact))-0.5);
dvg0 = ((model_.vgb)-(model_.vge));
{
double value_exp_0 = exp(((zetatef*ln_qtt0)-((dvg0/VT)*(qtt0-1))));

d_tef0_t_dV_tnode_GND =  0.0;
tef0_t = ((model_.tef0)*value_exp_0);
}
}
}
{
double value_exp_0 = exp((((model_.zetact)*ln_qtt0)+(((model_.vgb)/VT)*(qtt0-1))));

d_c10_t_dV_tnode_GND =  0.0;
c10_t = ((model_.c10)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));

d_rci0_t_dV_tnode_GND =  0.0;
rci0_t = ((model_.rci0)*value_exp_0);
}

d_vces_t_dV_tnode_GND =  0.0;
vces_t = ((model_.vces)*(1+((model_.alces)*dT)));
if (((model_.cjci0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdci)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdci))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND =  0.0;
vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND =  0.0;
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdci_t_dV_tnode_GND =  0.0;
vdci_t = vdt;
{
double value_log_0 = log(((model_.vdci)/vdci_t));
double value_exp_1 = exp(((model_.zci)*value_log_0));

d_cjci0_t_dV_tnode_GND =  0.0;
cjci0_t = ((model_.cjci0)*value_exp_1);
}
if ((0==1))
{

d_vptci_t_dV_tnode_GND =  0.0;
vptci_t = (((model_.vptci)*vdci_t)/(model_.vdci));
}
else
{

d_vptci_t_dV_tnode_GND =  0.0;
vptci_t = (model_.vptci);
}
}
else
{

d_cjci0_t_dV_tnode_GND =  0.0;
cjci0_t = (model_.cjci0);

d_vdci_t_dV_tnode_GND =  0.0;
vdci_t = (model_.vdci);

d_vptci_t_dV_tnode_GND =  0.0;
vptci_t = (model_.vptci);
}

d_t0_t_dV_tnode_GND =  0.0;
t0_t = ((model_.t0)*((1+((model_.alt0)*dT))+(((model_.kt0)*dT)*dT)));
{
double value_exp_0 = exp((((model_.zetaci)-1)*ln_qtt0));

d_thcs_t_dV_tnode_GND =  0.0;
thcs_t = ((model_.thcs)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.alfav)*dT));

d_favl_t_dV_tnode_GND =  0.0;
favl_t = ((model_.favl)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.alqav)*dT));

d_qavl_t_dV_tnode_GND =  0.0;
qavl_t = ((model_.qavl)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.alkav)*dT));

d_kavl_t_dV_tnode_GND =  0.0;
kavl_t = ((model_.kavl)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetarbi)*ln_qtt0));

d_rbi0_t_dV_tnode_GND =  0.0;
rbi0_t = ((model_.rbi0)*value_exp_0);
}
if (((model_.cjep0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdep)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdep))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND =  0.0;
vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND =  0.0;
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdep_t_dV_tnode_GND =  0.0;
vdep_t = vdt;
{
double value_log_0 = log(((model_.vdep)/vdep_t));
double value_exp_1 = exp(((model_.zep)*value_log_0));

d_cjep0_t_dV_tnode_GND =  0.0;
cjep0_t = ((model_.cjep0)*value_exp_1);
}
if ((1==1))
{

d_ajep_t_dV_tnode_GND =  0.0;
ajep_t = (((model_.ajep)*vdep_t)/(model_.vdep));
}
else
{

d_ajep_t_dV_tnode_GND =  0.0;
ajep_t = (model_.ajep);
}
}
else
{

d_cjep0_t_dV_tnode_GND =  0.0;
cjep0_t = (model_.cjep0);

d_vdep_t_dV_tnode_GND =  0.0;
vdep_t = (model_.vdep);

d_ajep_t_dV_tnode_GND =  0.0;
ajep_t = (model_.ajep);
}
if (((model_.ibets)>0))
//Begin block HICTUN_T
{
//Block-local variables for block HICTUN_T
double a_eg=0.0;
double ab=0.0;
double aa=0.0;
//End of Block-local variables
ab = 1.0;
aa = 1.0;
a_eg = (vgbe_t0/vgbe_t);
if (((((model_.tunode)==1)&&((model_.cjep0)>0.0))&&((model_.vdep)>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
ab = (((((cjep0_t/(model_.cjep0))*value_sqrt_0)*vdep_t)*vdep_t)/((model_.vdep)*(model_.vdep)));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
aa = ((((model_.vdep)/vdep_t)*((model_.cjep0)/cjep0_t))*value_pow_0);
}
}
else
{
if (((((model_.tunode)==0)&&((model_.cjei0)>0.0))&&((model_.vdei)>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
ab = (((((cjei0_t/(model_.cjei0))*value_sqrt_0)*vdei_t)*vdei_t)/((model_.vdei)*(model_.vdei)));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
aa = ((((model_.vdei)/vdei_t)*((model_.cjei0)/cjei0_t))*value_pow_0);
}
}
}

d_ibets_t_dV_tnode_GND =  0.0;
ibets_t = ((model_.ibets)*ab);

d_abet_t_dV_tnode_GND =  0.0;
abet_t = ((model_.abet)*aa);
}
// End block HICTUN_T
else
{

d_ibets_t_dV_tnode_GND =  0.0;
ibets_t = 0;

d_abet_t_dV_tnode_GND =  0.0;
abet_t = 1;
}
if ((1.0>0.0))
{
{
double value_exp_0 = exp((((model_.vdcx)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdcx))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND =  0.0;
vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND =  0.0;
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdcx_t_dV_tnode_GND =  0.0;
vdcx_t = vdt;
{
double value_log_0 = log(((model_.vdcx)/vdcx_t));
double value_exp_1 = exp(((model_.zcx)*value_log_0));

d_cratio_t_dV_tnode_GND =  0.0;
cratio_t = (1.0*value_exp_1);
}
if ((0==1))
{

d_vptcx_t_dV_tnode_GND =  0.0;
vptcx_t = (((model_.vptcx)*vdcx_t)/(model_.vdcx));
}
else
{

d_vptcx_t_dV_tnode_GND =  0.0;
vptcx_t = (model_.vptcx);
}
}
else
{

d_cratio_t_dV_tnode_GND =  0.0;
cratio_t = 1.0;

d_vdcx_t_dV_tnode_GND =  0.0;
vdcx_t = (model_.vdcx);

d_vptcx_t_dV_tnode_GND =  0.0;
vptcx_t = (model_.vptcx);
}

d_cjcx01_t_dV_tnode_GND =  0.0;
cjcx01_t = (cratio_t*cjcx01);

d_cjcx02_t_dV_tnode_GND =  0.0;
cjcx02_t = (cratio_t*cjcx02);
{
double value_exp_0 = exp(((model_.zetarcx)*ln_qtt0));

d_rcx_t_dV_tnode_GND =  0.0;
rcx_t = ((model_.rcx)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetarbx)*ln_qtt0));

d_rbx_t_dV_tnode_GND =  0.0;
rbx_t = ((model_.rbx)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetare)*ln_qtt0));

d_re_t_dV_tnode_GND =  0.0;
re_t = ((model_.re)*value_exp_0);
}
{
double value_exp_0 = exp((((model_.zetacx)-1.0)*ln_qtt0));

d_tsf_t_dV_tnode_GND =  0.0;
tsf_t = ((model_.tsf)*value_exp_0);
}
if (((model_.cjs0)>0.0))
{
{
double value_exp_0 = exp((((model_.vds)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vds))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND =  0.0;
vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND =  0.0;
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vds_t_dV_tnode_GND =  0.0;
vds_t = vdt;
{
double value_log_0 = log(((model_.vds)/vds_t));
double value_exp_1 = exp(((model_.zs)*value_log_0));

d_cjs0_t_dV_tnode_GND =  0.0;
cjs0_t = ((model_.cjs0)*value_exp_1);
}
if ((0==1))
{

d_vpts_t_dV_tnode_GND =  0.0;
vpts_t = (((model_.vpts)*vds_t)/(model_.vds));
}
else
{

d_vpts_t_dV_tnode_GND =  0.0;
vpts_t = (model_.vpts);
}
}
else
{

d_cjs0_t_dV_tnode_GND =  0.0;
cjs0_t = (model_.cjs0);

d_vds_t_dV_tnode_GND =  0.0;
vds_t = (model_.vds);

d_vpts_t_dV_tnode_GND =  0.0;
vpts_t = (model_.vpts);
}
if (((model_.vdsp)>0))
{
if (((model_.cscp0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdsp)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdsp))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND =  0.0;
vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND =  0.0;
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdsp_t_dV_tnode_GND =  0.0;
vdsp_t = vdt;
{
double value_log_0 = log(((model_.vdsp)/vdsp_t));
double value_exp_1 = exp(((model_.zsp)*value_log_0));

d_cscp0_t_dV_tnode_GND =  0.0;
cscp0_t = ((model_.cscp0)*value_exp_1);
}
if ((0==1))
{

d_vptsp_t_dV_tnode_GND =  0.0;
vptsp_t = (((model_.vptsp)*vdsp_t)/(model_.vdsp));
}
else
{

d_vptsp_t_dV_tnode_GND =  0.0;
vptsp_t = (model_.vptsp);
}
}
else
{

d_cscp0_t_dV_tnode_GND =  0.0;
cscp0_t = (model_.cscp0);

d_vdsp_t_dV_tnode_GND =  0.0;
vdsp_t = (model_.vdsp);

d_vptsp_t_dV_tnode_GND =  0.0;
vptsp_t = (model_.vptsp);
}
}
else
{

d_cscp0_t_dV_tnode_GND =  0.0;
cscp0_t = (model_.cscp0);

d_vdsp_t_dV_tnode_GND =  0.0;
vdsp_t = (model_.vdsp);

d_vptsp_t_dV_tnode_GND =  0.0;
vptsp_t = (model_.vptsp);
}
{
double value_exp_0 = exp(((model_.zetahjei)*ln_qtt0));

d_ahjei_t_dV_tnode_GND =  0.0;
ahjei_t = ((model_.ahjei)*value_exp_0);
}
{
double value_log_0 = log(qtt0);
double value_exp_1 = exp(((model_.zetavgbe)*value_log_0));
double value_exp_2 = exp((((model_.dvgbe)/VT)*(value_exp_1-1)));

d_hjei0_t_dV_tnode_GND =  0.0;
hjei0_t = ((model_.hjei)*value_exp_2);
}
{
double value_exp_0 = exp((((model_.dvgbe)/VT)*(qtt0-1)));

d_hf0_t_dV_tnode_GND =  0.0;
hf0_t = ((model_.hf0)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{
{
double value_exp_0 = exp(((((model_.vgb)-(model_.vge))/VT)*(qtt0-1)));

d_hfe_t_dV_tnode_GND =  0.0;
hfe_t = ((model_.hfe)*value_exp_0);
}
{
double value_exp_0 = exp(((((model_.vgb)-(model_.vgc))/VT)*(qtt0-1)));

d_hfc_t_dV_tnode_GND =  0.0;
hfc_t = ((model_.hfc)*value_exp_0);
}
}
else
{

d_hfe_t_dV_tnode_GND =  0.0;
hfe_t = (model_.hfe);

d_hfc_t_dV_tnode_GND =  0.0;
hfc_t = (model_.hfc);
}
{
double value_exp_0 = exp(((model_.zetarth)*ln_qtt0));

d_rth_t_dV_tnode_GND =  0.0;
rth_t = (((model_.rth)*value_exp_0)*(1+((model_.alrth)*dT)));
}
}
// End block Thermal_updat_without_self_heating
}
// End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    VT(0.0),
d_VT_dV_tnode_GND(0.0),
    Tdev(0.0),
d_Tdev_dV_tnode_GND(0.0),
    qtt0(0.0),
d_qtt0_dV_tnode_GND(0.0),
    ln_qtt0(0.0),
d_ln_qtt0_dV_tnode_GND(0.0),
    r_VgVT(0.0),
d_r_VgVT_dV_tnode_GND(0.0),
    V_gT(0.0),
d_V_gT_dV_tnode_GND(0.0),
    dT(0.0),
d_dT_dV_tnode_GND(0.0),
    k(0.0),
d_k_dV_tnode_GND(0.0),
    ireis_t(0.0),
d_ireis_t_dV_tnode_GND(0.0),
    ibeis_t(0.0),
d_ibeis_t_dV_tnode_GND(0.0),
    ibcxs_t(0.0),
d_ibcxs_t_dV_tnode_GND(0.0),
    ibcis_t(0.0),
d_ibcis_t_dV_tnode_GND(0.0),
    iscs_t(0.0),
d_iscs_t_dV_tnode_GND(0.0),
    cjci0_t(0.0),
d_cjci0_t_dV_tnode_GND(0.0),
    cjs0_t(0.0),
d_cjs0_t_dV_tnode_GND(0.0),
    cscp0_t(0.0),
d_cscp0_t_dV_tnode_GND(0.0),
    rci0_t(0.0),
d_rci0_t_dV_tnode_GND(0.0),
    vlim_t(0.0),
d_vlim_t_dV_tnode_GND(0.0),
    vces_t(0.0),
d_vces_t_dV_tnode_GND(0.0),
    thcs_t(0.0),
d_thcs_t_dV_tnode_GND(0.0),
    tef0_t(0.0),
d_tef0_t_dV_tnode_GND(0.0),
    rbi0_t(0.0),
d_rbi0_t_dV_tnode_GND(0.0),
    t0_t(0.0),
d_t0_t_dV_tnode_GND(0.0),
    vdei_t(0.0),
d_vdei_t_dV_tnode_GND(0.0),
    vdci_t(0.0),
d_vdci_t_dV_tnode_GND(0.0),
    vpts_t(0.0),
d_vpts_t_dV_tnode_GND(0.0),
    vptsp_t(0.0),
d_vptsp_t_dV_tnode_GND(0.0),
    itss_t(0.0),
d_itss_t_dV_tnode_GND(0.0),
    tsf_t(0.0),
d_tsf_t_dV_tnode_GND(0.0),
    c10_t(0.0),
d_c10_t_dV_tnode_GND(0.0),
    cjei0_t(0.0),
d_cjei0_t_dV_tnode_GND(0.0),
    qp0_t(0.0),
d_qp0_t_dV_tnode_GND(0.0),
    vdcx_t(0.0),
d_vdcx_t_dV_tnode_GND(0.0),
    vptcx_t(0.0),
d_vptcx_t_dV_tnode_GND(0.0),
    cjcx01_t(0.0),
d_cjcx01_t_dV_tnode_GND(0.0),
    cjcx02_t(0.0),
d_cjcx02_t_dV_tnode_GND(0.0),
    cratio_t(0.0),
d_cratio_t_dV_tnode_GND(0.0),
    ibeps_t(0.0),
d_ibeps_t_dV_tnode_GND(0.0),
    ireps_t(0.0),
d_ireps_t_dV_tnode_GND(0.0),
    cjep0_t(0.0),
d_cjep0_t_dV_tnode_GND(0.0),
    ajei_t(0.0),
d_ajei_t_dV_tnode_GND(0.0),
    qavl_t(0.0),
d_qavl_t_dV_tnode_GND(0.0),
    favl_t(0.0),
d_favl_t_dV_tnode_GND(0.0),
    kavl_t(0.0),
d_kavl_t_dV_tnode_GND(0.0),
    ibets_t(0.0),
d_ibets_t_dV_tnode_GND(0.0),
    abet_t(0.0),
d_abet_t_dV_tnode_GND(0.0),
    vptci_t(0.0),
d_vptci_t_dV_tnode_GND(0.0),
    vdep_t(0.0),
d_vdep_t_dV_tnode_GND(0.0),
    ajep_t(0.0),
d_ajep_t_dV_tnode_GND(0.0),
    zetatef(0.0),
    k1(0.0),
d_k1_dV_tnode_GND(0.0),
    k2(0.0),
d_k2_dV_tnode_GND(0.0),
    dvg0(0.0),
    vge_t(0.0),
d_vge_t_dV_tnode_GND(0.0),
    vgb_t(0.0),
d_vgb_t_dV_tnode_GND(0.0),
    vgbe_t(0.0),
d_vgbe_t_dV_tnode_GND(0.0),
    vds_t(0.0),
d_vds_t_dV_tnode_GND(0.0),
    vdsp_t(0.0),
d_vdsp_t_dV_tnode_GND(0.0),
    vt0(0.0),
    Tnom(0.0),
    Tamb(0.0),
    a(0.0),
d_a_dV_bi_ei(0.0),
d_a_dV_bi_ci(0.0),
d_a_dV_tnode_GND(0.0),
    avs(0.0),
    zetabci(0.0),
    zetabcxt(0.0),
    zetasct(0.0),
    vgbe0(0.0),
    mg(0.0),
    vgbe_t0(0.0),
    vgbc0(0.0),
    vgsc0(0.0),
    cbcpar1(0.0),
    cbcpar2(0.0),
    cbepar2(0.0),
    cbepar1(0.0),
    Oich(0.0),
    Otbhrec(0.0),
    it(0.0),
d_it_dV_tnode_GND(0.0),
d_it_dV_bi_ei(0.0),
d_it_dV_bi_ci(0.0),
    ibei(0.0),
d_ibei_dV_tnode_GND(0.0),
d_ibei_dV_bi_ei(0.0),
    ibci(0.0),
d_ibci_dV_tnode_GND(0.0),
d_ibci_dV_bi_ci(0.0),
d_ibci_dV_bi_ei(0.0),
    ibep(0.0),
d_ibep_dV_tnode_GND(0.0),
d_ibep_dV_bp_ei(0.0),
d_ibep_dV_bi_ci(0.0),
d_ibep_dV_bi_ei(0.0),
    iavl(0.0),
d_iavl_dV_tnode_GND(0.0),
d_iavl_dV_bi_ei(0.0),
d_iavl_dV_bi_ci(0.0),
    ijbcx(0.0),
d_ijbcx_dV_tnode_GND(0.0),
d_ijbcx_dV_bp_ci(0.0),
d_ijbcx_dV_bp_ei(0.0),
d_ijbcx_dV_bi_ci(0.0),
d_ijbcx_dV_bi_ei(0.0),
    ijsc(0.0),
d_ijsc_dV_tnode_GND(0.0),
d_ijsc_dV_si_ci(0.0),
d_ijsc_dV_bp_ci(0.0),
d_ijsc_dV_bp_ei(0.0),
d_ijsc_dV_bi_ci(0.0),
d_ijsc_dV_bi_ei(0.0),
    rth_t(0.0),
d_rth_t_dV_tnode_GND(0.0),
    vdj0(0.0),
    vdjt(0.0),
d_vdjt_dV_tnode_GND(0.0),
    vdt(0.0),
d_vdt_dV_tnode_GND(0.0),
    Tf(0.0),
d_Tf_dV_bi_ei(0.0),
d_Tf_dV_tnode_GND(0.0),
d_Tf_dV_bi_ci(0.0),
    cjcx01(0.0),
    cjcx02(0.0),
    betadc(0.0),
d_betadc_dV_tnode_GND(0.0),
d_betadc_dV_bi_ei(0.0),
d_betadc_dV_bi_ci(0.0),
    hjei0_t(0.0),
d_hjei0_t_dV_tnode_GND(0.0),
    ahjei_t(0.0),
d_ahjei_t_dV_tnode_GND(0.0),
    hf0_t(0.0),
d_hf0_t_dV_tnode_GND(0.0),
    hfe_t(0.0),
d_hfe_t_dV_tnode_GND(0.0),
    hfc_t(0.0),
d_hfc_t_dV_tnode_GND(0.0),
    use_aval(0),
    rbx_t(0.0),
d_rbx_t_dV_tnode_GND(0.0),
    rcx_t(0.0),
d_rcx_t_dV_tnode_GND(0.0),
    re_t(0.0),
d_re_t_dV_tnode_GND(0.0),
    rbi(0.0),
d_rbi_dV_tnode_GND(0.0),
d_rbi_dV_bi_ei(0.0),
d_rbi_dV_bi_ci(0.0),
    rb(0.0),
    IAVL(0.0),
    VBE(0.0),
    VBC(0.0),
    VCE(0.0),
    VSC(0.0),
    GMi(0.0),
    GMS(0.0),
    RPIi(0.0),
    RPIx(0.0),
    RMUi(0.0),
    RMUx(0.0),
    ROi(0.0),
    CPIi(0.0),
    CPIx(0.0),
    CMUi(0.0),
    CMUx(0.0),
    CCS(0.0),
    BETAAC(0.0),
    CRBI(0.0),
    TF(0.0),
    FT(0.0),
    TK(0.0),
    DTSH(0.0),
    li_c(-1),
    li_b(-1),
    li_e(-1),
    li_s(-1),
    li_tnode(-1),
    li_ci(-1),
    li_ei(-1),
    li_bp(-1),
    li_bi(-1),
    li_si(-1),
    li_xf1(-1),
    li_xf2(-1),
    li_xf(-1),
    li_n1(-1),
    li_n2(-1),
    li_branch_ic(-1),
    li_branch_ib(-1),
    li_branch_ie(-1),
    li_branch_is(-1),
    li_branch_itnode(-1),
    f_bi_Equ_bi_Node_Ptr(0),
    f_bi_Equ_ei_Node_Ptr(0),
    f_ei_Equ_bi_Node_Ptr(0),
    f_ei_Equ_ei_Node_Ptr(0),
    f_bi_Equ_ci_Node_Ptr(0),
    f_ci_Equ_bi_Node_Ptr(0),
    f_ci_Equ_ci_Node_Ptr(0),
    f_ci_Equ_ei_Node_Ptr(0),
    f_ei_Equ_ci_Node_Ptr(0),
    f_b_Equ_bi_Node_Ptr(0),
    f_b_Equ_ci_Node_Ptr(0),
    f_b_Equ_tnode_Node_Ptr(0),
    f_ci_Equ_tnode_Node_Ptr(0),
    f_b_Equ_bp_Node_Ptr(0),
    f_ci_Equ_bp_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_ci_Equ_b_Node_Ptr(0),
    f_b_Equ_ei_Node_Ptr(0),
    f_bp_Equ_bp_Node_Ptr(0),
    f_bp_Equ_ci_Node_Ptr(0),
    f_bp_Equ_tnode_Node_Ptr(0),
    f_bp_Equ_b_Node_Ptr(0),
    f_bp_Equ_bi_Node_Ptr(0),
    f_bp_Equ_ei_Node_Ptr(0),
    f_bi_Equ_tnode_Node_Ptr(0),
    f_bi_Equ_bp_Node_Ptr(0),
    f_ei_Equ_tnode_Node_Ptr(0),
    f_ei_Equ_bp_Node_Ptr(0),
    f_bi_Equ_xf_Node_Ptr(0),
    f_ei_Equ_xf_Node_Ptr(0),
    f_bp_Equ_si_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_si_Equ_ci_Node_Ptr(0),
    f_si_Equ_bp_Node_Ptr(0),
    f_si_Equ_tnode_Node_Ptr(0),
    f_b_Equ_e_Node_Ptr(0),
    f_e_Equ_b_Node_Ptr(0),
    f_e_Equ_e_Node_Ptr(0),
    f_bp_Equ_e_Node_Ptr(0),
    f_e_Equ_bp_Node_Ptr(0),
    f_si_Equ_bi_Node_Ptr(0),
    f_si_Equ_ei_Node_Ptr(0),
    f_ci_Equ_si_Node_Ptr(0),
    f_si_Equ_b_Node_Ptr(0),
    f_s_Equ_bi_Node_Ptr(0),
    f_s_Equ_ci_Node_Ptr(0),
    f_c_Equ_bi_Node_Ptr(0),
    f_c_Equ_ci_Node_Ptr(0),
    f_s_Equ_tnode_Node_Ptr(0),
    f_c_Equ_tnode_Node_Ptr(0),
    f_s_Equ_bp_Node_Ptr(0),
    f_c_Equ_bp_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_c_Equ_b_Node_Ptr(0),
    f_s_Equ_si_Node_Ptr(0),
    f_c_Equ_si_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_s_Equ_c_Node_Ptr(0),
    f_c_Equ_s_Node_Ptr(0),
    f_c_Equ_c_Node_Ptr(0),
    f_s_Equ_ei_Node_Ptr(0),
    f_c_Equ_ei_Node_Ptr(0),
    f_ci_Equ_xf2_Node_Ptr(0),
    f_ei_Equ_xf2_Node_Ptr(0),
    f_ci_Equ_c_Node_Ptr(0),
    f_e_Equ_tnode_Node_Ptr(0),
    f_ei_Equ_e_Node_Ptr(0),
    f_e_Equ_ei_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_tnode_Equ_tnode_Node_Ptr(0),
    f_tnode_Equ_bi_Node_Ptr(0),
    f_tnode_Equ_ci_Node_Ptr(0),
    f_tnode_Equ_ei_Node_Ptr(0),
    f_tnode_Equ_si_Node_Ptr(0),
    f_tnode_Equ_bp_Node_Ptr(0),
    f_tnode_Equ_e_Node_Ptr(0),
    f_tnode_Equ_c_Node_Ptr(0),
    f_tnode_Equ_b_Node_Ptr(0),
    f_xf1_Equ_bi_Node_Ptr(0),
    f_xf1_Equ_ci_Node_Ptr(0),
    f_xf1_Equ_ei_Node_Ptr(0),
    f_xf1_Equ_tnode_Node_Ptr(0),
    f_xf1_Equ_xf2_Node_Ptr(0),
    f_xf1_Equ_xf1_Node_Ptr(0),
    f_xf2_Equ_bi_Node_Ptr(0),
    f_xf2_Equ_ci_Node_Ptr(0),
    f_xf2_Equ_tnode_Node_Ptr(0),
    f_xf2_Equ_ei_Node_Ptr(0),
    f_xf2_Equ_xf1_Node_Ptr(0),
    f_xf2_Equ_xf2_Node_Ptr(0),
    f_xf_Equ_bi_Node_Ptr(0),
    f_xf_Equ_ei_Node_Ptr(0),
    f_xf_Equ_ci_Node_Ptr(0),
    f_xf_Equ_tnode_Node_Ptr(0),
    f_xf_Equ_xf_Node_Ptr(0),
    f_e_Equ_bi_Node_Ptr(0),
    f_e_Equ_ci_Node_Ptr(0),
    f_n1_Equ_bi_Node_Ptr(0),
    f_n1_Equ_ei_Node_Ptr(0),
    f_n1_Equ_tnode_Node_Ptr(0),
    f_n1_Equ_n1_Node_Ptr(0),
    f_bi_Equ_n1_Node_Ptr(0),
    f_ei_Equ_n1_Node_Ptr(0),
    f_bi_Equ_n2_Node_Ptr(0),
    f_ei_Equ_n2_Node_Ptr(0),
    f_n2_Equ_bi_Node_Ptr(0),
    f_n2_Equ_ci_Node_Ptr(0),
    f_n2_Equ_ei_Node_Ptr(0),
    f_n2_Equ_tnode_Node_Ptr(0),
    f_n2_Equ_n2_Node_Ptr(0),
    f_ci_Equ_n2_Node_Ptr(0),
    q_bi_Equ_bi_Node_Ptr(0),
    q_bi_Equ_ei_Node_Ptr(0),
    q_ei_Equ_bi_Node_Ptr(0),
    q_ei_Equ_ei_Node_Ptr(0),
    q_bi_Equ_ci_Node_Ptr(0),
    q_ci_Equ_bi_Node_Ptr(0),
    q_ci_Equ_ci_Node_Ptr(0),
    q_ci_Equ_ei_Node_Ptr(0),
    q_ei_Equ_ci_Node_Ptr(0),
    q_b_Equ_bi_Node_Ptr(0),
    q_b_Equ_ci_Node_Ptr(0),
    q_b_Equ_tnode_Node_Ptr(0),
    q_ci_Equ_tnode_Node_Ptr(0),
    q_b_Equ_bp_Node_Ptr(0),
    q_ci_Equ_bp_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_ci_Equ_b_Node_Ptr(0),
    q_b_Equ_ei_Node_Ptr(0),
    q_bp_Equ_bp_Node_Ptr(0),
    q_bp_Equ_ci_Node_Ptr(0),
    q_bp_Equ_tnode_Node_Ptr(0),
    q_bp_Equ_b_Node_Ptr(0),
    q_bp_Equ_bi_Node_Ptr(0),
    q_bp_Equ_ei_Node_Ptr(0),
    q_bi_Equ_tnode_Node_Ptr(0),
    q_bi_Equ_bp_Node_Ptr(0),
    q_ei_Equ_tnode_Node_Ptr(0),
    q_ei_Equ_bp_Node_Ptr(0),
    q_bi_Equ_xf_Node_Ptr(0),
    q_ei_Equ_xf_Node_Ptr(0),
    q_bp_Equ_si_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_si_Equ_ci_Node_Ptr(0),
    q_si_Equ_bp_Node_Ptr(0),
    q_si_Equ_tnode_Node_Ptr(0),
    q_b_Equ_e_Node_Ptr(0),
    q_e_Equ_b_Node_Ptr(0),
    q_e_Equ_e_Node_Ptr(0),
    q_bp_Equ_e_Node_Ptr(0),
    q_e_Equ_bp_Node_Ptr(0),
    q_si_Equ_bi_Node_Ptr(0),
    q_si_Equ_ei_Node_Ptr(0),
    q_ci_Equ_si_Node_Ptr(0),
    q_si_Equ_b_Node_Ptr(0),
    q_s_Equ_bi_Node_Ptr(0),
    q_s_Equ_ci_Node_Ptr(0),
    q_c_Equ_bi_Node_Ptr(0),
    q_c_Equ_ci_Node_Ptr(0),
    q_s_Equ_tnode_Node_Ptr(0),
    q_c_Equ_tnode_Node_Ptr(0),
    q_s_Equ_bp_Node_Ptr(0),
    q_c_Equ_bp_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_c_Equ_b_Node_Ptr(0),
    q_s_Equ_si_Node_Ptr(0),
    q_c_Equ_si_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_s_Equ_c_Node_Ptr(0),
    q_c_Equ_s_Node_Ptr(0),
    q_c_Equ_c_Node_Ptr(0),
    q_s_Equ_ei_Node_Ptr(0),
    q_c_Equ_ei_Node_Ptr(0),
    q_ci_Equ_xf2_Node_Ptr(0),
    q_ei_Equ_xf2_Node_Ptr(0),
    q_ci_Equ_c_Node_Ptr(0),
    q_e_Equ_tnode_Node_Ptr(0),
    q_ei_Equ_e_Node_Ptr(0),
    q_e_Equ_ei_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_tnode_Equ_tnode_Node_Ptr(0),
    q_tnode_Equ_bi_Node_Ptr(0),
    q_tnode_Equ_ci_Node_Ptr(0),
    q_tnode_Equ_ei_Node_Ptr(0),
    q_tnode_Equ_si_Node_Ptr(0),
    q_tnode_Equ_bp_Node_Ptr(0),
    q_tnode_Equ_e_Node_Ptr(0),
    q_tnode_Equ_c_Node_Ptr(0),
    q_tnode_Equ_b_Node_Ptr(0),
    q_xf1_Equ_bi_Node_Ptr(0),
    q_xf1_Equ_ci_Node_Ptr(0),
    q_xf1_Equ_ei_Node_Ptr(0),
    q_xf1_Equ_tnode_Node_Ptr(0),
    q_xf1_Equ_xf2_Node_Ptr(0),
    q_xf1_Equ_xf1_Node_Ptr(0),
    q_xf2_Equ_bi_Node_Ptr(0),
    q_xf2_Equ_ci_Node_Ptr(0),
    q_xf2_Equ_tnode_Node_Ptr(0),
    q_xf2_Equ_ei_Node_Ptr(0),
    q_xf2_Equ_xf1_Node_Ptr(0),
    q_xf2_Equ_xf2_Node_Ptr(0),
    q_xf_Equ_bi_Node_Ptr(0),
    q_xf_Equ_ei_Node_Ptr(0),
    q_xf_Equ_ci_Node_Ptr(0),
    q_xf_Equ_tnode_Node_Ptr(0),
    q_xf_Equ_xf_Node_Ptr(0),
    q_e_Equ_bi_Node_Ptr(0),
    q_e_Equ_ci_Node_Ptr(0),
    q_n1_Equ_bi_Node_Ptr(0),
    q_n1_Equ_ei_Node_Ptr(0),
    q_n1_Equ_tnode_Node_Ptr(0),
    q_n1_Equ_n1_Node_Ptr(0),
    q_bi_Equ_n1_Node_Ptr(0),
    q_ei_Equ_n1_Node_Ptr(0),
    q_bi_Equ_n2_Node_Ptr(0),
    q_ei_Equ_n2_Node_Ptr(0),
    q_n2_Equ_bi_Node_Ptr(0),
    q_n2_Equ_ci_Node_Ptr(0),
    q_n2_Equ_ei_Node_Ptr(0),
    q_n2_Equ_tnode_Node_Ptr(0),
    q_n2_Equ_n2_Node_Ptr(0),
    q_ci_Equ_n2_Node_Ptr(0),
    A_bi_Equ_bi_NodeOffset(-1),
    A_bi_Equ_ei_NodeOffset(-1),
    A_ei_Equ_bi_NodeOffset(-1),
    A_ei_Equ_ei_NodeOffset(-1),
    A_bi_Equ_ci_NodeOffset(-1),
    A_ci_Equ_bi_NodeOffset(-1),
    A_ci_Equ_ci_NodeOffset(-1),
    A_ci_Equ_ei_NodeOffset(-1),
    A_ei_Equ_ci_NodeOffset(-1),
    A_b_Equ_bi_NodeOffset(-1),
    A_b_Equ_ci_NodeOffset(-1),
    A_b_Equ_tnode_NodeOffset(-1),
    A_ci_Equ_tnode_NodeOffset(-1),
    A_b_Equ_bp_NodeOffset(-1),
    A_ci_Equ_bp_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_ci_Equ_b_NodeOffset(-1),
    A_b_Equ_ei_NodeOffset(-1),
    A_bp_Equ_bp_NodeOffset(-1),
    A_bp_Equ_ci_NodeOffset(-1),
    A_bp_Equ_tnode_NodeOffset(-1),
    A_bp_Equ_b_NodeOffset(-1),
    A_bp_Equ_bi_NodeOffset(-1),
    A_bp_Equ_ei_NodeOffset(-1),
    A_bi_Equ_tnode_NodeOffset(-1),
    A_bi_Equ_bp_NodeOffset(-1),
    A_ei_Equ_tnode_NodeOffset(-1),
    A_ei_Equ_bp_NodeOffset(-1),
    A_bi_Equ_xf_NodeOffset(-1),
    A_ei_Equ_xf_NodeOffset(-1),
    A_bp_Equ_si_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_si_Equ_ci_NodeOffset(-1),
    A_si_Equ_bp_NodeOffset(-1),
    A_si_Equ_tnode_NodeOffset(-1),
    A_b_Equ_e_NodeOffset(-1),
    A_e_Equ_b_NodeOffset(-1),
    A_e_Equ_e_NodeOffset(-1),
    A_bp_Equ_e_NodeOffset(-1),
    A_e_Equ_bp_NodeOffset(-1),
    A_si_Equ_bi_NodeOffset(-1),
    A_si_Equ_ei_NodeOffset(-1),
    A_ci_Equ_si_NodeOffset(-1),
    A_si_Equ_b_NodeOffset(-1),
    A_s_Equ_bi_NodeOffset(-1),
    A_s_Equ_ci_NodeOffset(-1),
    A_c_Equ_bi_NodeOffset(-1),
    A_c_Equ_ci_NodeOffset(-1),
    A_s_Equ_tnode_NodeOffset(-1),
    A_c_Equ_tnode_NodeOffset(-1),
    A_s_Equ_bp_NodeOffset(-1),
    A_c_Equ_bp_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_c_Equ_b_NodeOffset(-1),
    A_s_Equ_si_NodeOffset(-1),
    A_c_Equ_si_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_s_Equ_c_NodeOffset(-1),
    A_c_Equ_s_NodeOffset(-1),
    A_c_Equ_c_NodeOffset(-1),
    A_s_Equ_ei_NodeOffset(-1),
    A_c_Equ_ei_NodeOffset(-1),
    A_ci_Equ_xf2_NodeOffset(-1),
    A_ei_Equ_xf2_NodeOffset(-1),
    A_ci_Equ_c_NodeOffset(-1),
    A_e_Equ_tnode_NodeOffset(-1),
    A_ei_Equ_e_NodeOffset(-1),
    A_e_Equ_ei_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_tnode_Equ_tnode_NodeOffset(-1),
    A_tnode_Equ_bi_NodeOffset(-1),
    A_tnode_Equ_ci_NodeOffset(-1),
    A_tnode_Equ_ei_NodeOffset(-1),
    A_tnode_Equ_si_NodeOffset(-1),
    A_tnode_Equ_bp_NodeOffset(-1),
    A_tnode_Equ_e_NodeOffset(-1),
    A_tnode_Equ_c_NodeOffset(-1),
    A_tnode_Equ_b_NodeOffset(-1),
    A_xf1_Equ_bi_NodeOffset(-1),
    A_xf1_Equ_ci_NodeOffset(-1),
    A_xf1_Equ_ei_NodeOffset(-1),
    A_xf1_Equ_tnode_NodeOffset(-1),
    A_xf1_Equ_xf2_NodeOffset(-1),
    A_xf1_Equ_xf1_NodeOffset(-1),
    A_xf2_Equ_bi_NodeOffset(-1),
    A_xf2_Equ_ci_NodeOffset(-1),
    A_xf2_Equ_tnode_NodeOffset(-1),
    A_xf2_Equ_ei_NodeOffset(-1),
    A_xf2_Equ_xf1_NodeOffset(-1),
    A_xf2_Equ_xf2_NodeOffset(-1),
    A_xf_Equ_bi_NodeOffset(-1),
    A_xf_Equ_ei_NodeOffset(-1),
    A_xf_Equ_ci_NodeOffset(-1),
    A_xf_Equ_tnode_NodeOffset(-1),
    A_xf_Equ_xf_NodeOffset(-1),
    A_e_Equ_bi_NodeOffset(-1),
    A_e_Equ_ci_NodeOffset(-1),
    A_n1_Equ_bi_NodeOffset(-1),
    A_n1_Equ_ei_NodeOffset(-1),
    A_n1_Equ_tnode_NodeOffset(-1),
    A_n1_Equ_n1_NodeOffset(-1),
    A_bi_Equ_n1_NodeOffset(-1),
    A_ei_Equ_n1_NodeOffset(-1),
    A_bi_Equ_n2_NodeOffset(-1),
    A_ei_Equ_n2_NodeOffset(-1),
    A_n2_Equ_bi_NodeOffset(-1),
    A_n2_Equ_ci_NodeOffset(-1),
    A_n2_Equ_ei_NodeOffset(-1),
    A_n2_Equ_tnode_NodeOffset(-1),
    A_n2_Equ_n2_NodeOffset(-1),
    A_ci_Equ_n2_NodeOffset(-1),
    li_store_rcx_t(-1),
    li_store_re_t(-1),
    li_store_rbi(-1),
    li_store_rb(-1),
    li_store_IAVL(-1),
    li_store_VBE(-1),
    li_store_VBC(-1),
    li_store_VCE(-1),
    li_store_VSC(-1),
    li_store_GMi(-1),
    li_store_GMS(-1),
    li_store_RPIi(-1),
    li_store_RPIx(-1),
    li_store_RMUi(-1),
    li_store_RMUx(-1),
    li_store_ROi(-1),
    li_store_CPIi(-1),
    li_store_CPIx(-1),
    li_store_CMUi(-1),
    li_store_CMUx(-1),
    li_store_CCS(-1),
    li_store_BETAAC(-1),
    li_store_CRBI(-1),
    li_store_TF(-1),
    li_store_FT(-1),
    li_store_TK(-1),
    li_store_DTSH(-1),
    collapseNode_ci(false),
    collapseNode_ei(false),
    collapseNode_bp(false),
    collapseNode_bi(false),
    collapseNode_si(false),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 10 + 0;
    numExtVars = 5;

  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+27);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 5;

  leadCurrentF.resize(5);
  leadCurrentQ.resize(5);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_c));
    jacobianElements.push_back(IntPair(admsNodeID_c,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_e,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_c));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_c));
    jacobianElements.push_back(IntPair(admsNodeID_tnode,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_xf2));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_c));
    jacobianElements.push_back(IntPair(admsNodeID_ci,admsNodeID_n2));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_xf));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_xf2));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_n1));
    jacobianElements.push_back(IntPair(admsNodeID_ei,admsNodeID_n2));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_bp,admsNodeID_e));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_xf));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_n1));
    jacobianElements.push_back(IntPair(admsNodeID_bi,admsNodeID_n2));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bp));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf2));
    jacobianElements.push_back(IntPair(admsNodeID_xf1,admsNodeID_xf1));
    jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf1));
    jacobianElements.push_back(IntPair(admsNodeID_xf2,admsNodeID_xf2));
    jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_xf,admsNodeID_xf));
    jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_n1,admsNodeID_n1));
    jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_bi));
    jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_ci));
    jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_ei));
    jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_tnode));
    jacobianElements.push_back(IntPair(admsNodeID_n2,admsNodeID_n2));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_ci)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_ci,admsNodeID_c));
  }
  if (collapseNode_ei)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_ei,admsNodeID_e));
  }
  if (collapseNode_bp)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_bp,admsNodeID_b));
  }
  if (collapseNode_bi)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_bi,admsNodeID_bp));
  }
  if (collapseNode_si)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_si,admsNodeID_s));
  }

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 15+0;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
collapseNode_ci = false;
collapseNode_ei = false;
collapseNode_bp = false;
collapseNode_bi = false;
collapseNode_si = false;
// begin block named Load_sources

if (!(((model_.rbx)>=0.001)))
{

collapseNode_bp = true;

}

if (!(((model_.rbi0)>=0.001)))
{

collapseNode_bi = true;

}

if (!(((model_.rcx)>=0.001)))
{

collapseNode_ci = true;

}

if (!(((model_.re)>=0.001)))
{

collapseNode_ei = true;

}

if (!(((model_.rsu)>=0.001)))
{

collapseNode_si = true;

}

// end block  named Load_sources


  if (collapseNode_ci)
  {
    numIntVars--;
  }
  if (collapseNode_ei)
  {
    numIntVars--;
  }
  if (collapseNode_bp)
  {
    numIntVars--;
  }
  if (collapseNode_bi)
  {
    numIntVars--;
  }
  if (collapseNode_si)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMShicumL2va::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_c = localLIDVec[nodeMap[admsNodeID_c]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_e = localLIDVec[nodeMap[admsNodeID_e]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_tnode = localLIDVec[nodeMap[admsNodeID_tnode]];
  li_ci = localLIDVec[nodeMap[admsNodeID_ci]];
  li_ei = localLIDVec[nodeMap[admsNodeID_ei]];
  li_bp = localLIDVec[nodeMap[admsNodeID_bp]];
  li_bi = localLIDVec[nodeMap[admsNodeID_bi]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_xf1 = localLIDVec[nodeMap[admsNodeID_xf1]];
  li_xf2 = localLIDVec[nodeMap[admsNodeID_xf2]];
  li_xf = localLIDVec[nodeMap[admsNodeID_xf]];
  li_n1 = localLIDVec[nodeMap[admsNodeID_n1]];
  li_n2 = localLIDVec[nodeMap[admsNodeID_n2]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_c = " << li_c << std::endl;
      Xyce::dout() << "\nli_b = " << li_b << std::endl;
      Xyce::dout() << "\nli_e = " << li_e << std::endl;
      Xyce::dout() << "\nli_s = " << li_s << std::endl;
      Xyce::dout() << "\nli_tnode = " << li_tnode << std::endl;
      Xyce::dout() << "\nli_ci = " << li_ci << std::endl;
      Xyce::dout() << "\nli_ei = " << li_ei << std::endl;
      Xyce::dout() << "\nli_bp = " << li_bp << std::endl;
      Xyce::dout() << "\nli_bi = " << li_bi << std::endl;
      Xyce::dout() << "\nli_si = " << li_si << std::endl;
      Xyce::dout() << "\nli_xf1 = " << li_xf1 << std::endl;
      Xyce::dout() << "\nli_xf2 = " << li_xf2 << std::endl;
      Xyce::dout() << "\nli_xf = " << li_xf << std::endl;
      Xyce::dout() << "\nli_n1 = " << li_n1 << std::endl;
      Xyce::dout() << "\nli_n2 = " << li_n2 << std::endl;

    Xyce::dout() << "\nEnd of ADMShicumL2va::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    if (!collapseNode_ci)
    {
    addInternalNode(symbol_table, li_ci, getName(), "ci");
    }
    if (!collapseNode_ei)
    {
    addInternalNode(symbol_table, li_ei, getName(), "ei");
    }
    if (!collapseNode_bp)
    {
    addInternalNode(symbol_table, li_bp, getName(), "bp");
    }
    if (!collapseNode_bi)
    {
    addInternalNode(symbol_table, li_bi, getName(), "bi");
    }
    if (!collapseNode_si)
    {
    addInternalNode(symbol_table, li_si, getName(), "si");
    }
    addInternalNode(symbol_table, li_xf1, getName(), "xf1");
    addInternalNode(symbol_table, li_xf2, getName(), "xf2");
    addInternalNode(symbol_table, li_xf, getName(), "xf");
    addInternalNode(symbol_table, li_n1, getName(), "n1");
    addInternalNode(symbol_table, li_n2, getName(), "n2");
    addStoreNode(symbol_table, li_store_rcx_t, getName().getEncodedName() + ":rcx_t");
    addStoreNode(symbol_table, li_store_re_t, getName().getEncodedName() + ":re_t");
    addStoreNode(symbol_table, li_store_rbi, getName().getEncodedName() + ":rbi");
    addStoreNode(symbol_table, li_store_rb, getName().getEncodedName() + ":rb");
    addStoreNode(symbol_table, li_store_IAVL, getName().getEncodedName() + ":IAVL");
    addStoreNode(symbol_table, li_store_VBE, getName().getEncodedName() + ":VBE");
    addStoreNode(symbol_table, li_store_VBC, getName().getEncodedName() + ":VBC");
    addStoreNode(symbol_table, li_store_VCE, getName().getEncodedName() + ":VCE");
    addStoreNode(symbol_table, li_store_VSC, getName().getEncodedName() + ":VSC");
    addStoreNode(symbol_table, li_store_GMi, getName().getEncodedName() + ":GMi");
    addStoreNode(symbol_table, li_store_GMS, getName().getEncodedName() + ":GMS");
    addStoreNode(symbol_table, li_store_RPIi, getName().getEncodedName() + ":RPIi");
    addStoreNode(symbol_table, li_store_RPIx, getName().getEncodedName() + ":RPIx");
    addStoreNode(symbol_table, li_store_RMUi, getName().getEncodedName() + ":RMUi");
    addStoreNode(symbol_table, li_store_RMUx, getName().getEncodedName() + ":RMUx");
    addStoreNode(symbol_table, li_store_ROi, getName().getEncodedName() + ":ROi");
    addStoreNode(symbol_table, li_store_CPIi, getName().getEncodedName() + ":CPIi");
    addStoreNode(symbol_table, li_store_CPIx, getName().getEncodedName() + ":CPIx");
    addStoreNode(symbol_table, li_store_CMUi, getName().getEncodedName() + ":CMUi");
    addStoreNode(symbol_table, li_store_CMUx, getName().getEncodedName() + ":CMUx");
    addStoreNode(symbol_table, li_store_CCS, getName().getEncodedName() + ":CCS");
    addStoreNode(symbol_table, li_store_BETAAC, getName().getEncodedName() + ":BETAAC");
    addStoreNode(symbol_table, li_store_CRBI, getName().getEncodedName() + ":CRBI");
    addStoreNode(symbol_table, li_store_TF, getName().getEncodedName() + ":TF");
    addStoreNode(symbol_table, li_store_FT, getName().getEncodedName() + ":FT");
    addStoreNode(symbol_table, li_store_TK, getName().getEncodedName() + ":TK");
    addStoreNode(symbol_table, li_store_DTSH, getName().getEncodedName() + ":DTSH");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_ic, getName(), "BRANCH_DC");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");
    addBranchDataNode( symbol_table, li_branch_ie, getName(), "BRANCH_DE");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_D4");
    addBranchDataNode( symbol_table, li_branch_itnode, getName(), "BRANCH_D5");


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_rcx_t= stoLIDVec[i++];
      li_store_re_t= stoLIDVec[i++];
      li_store_rbi= stoLIDVec[i++];
      li_store_rb= stoLIDVec[i++];
      li_store_IAVL= stoLIDVec[i++];
      li_store_VBE= stoLIDVec[i++];
      li_store_VBC= stoLIDVec[i++];
      li_store_VCE= stoLIDVec[i++];
      li_store_VSC= stoLIDVec[i++];
      li_store_GMi= stoLIDVec[i++];
      li_store_GMS= stoLIDVec[i++];
      li_store_RPIi= stoLIDVec[i++];
      li_store_RPIx= stoLIDVec[i++];
      li_store_RMUi= stoLIDVec[i++];
      li_store_RMUx= stoLIDVec[i++];
      li_store_ROi= stoLIDVec[i++];
      li_store_CPIi= stoLIDVec[i++];
      li_store_CPIx= stoLIDVec[i++];
      li_store_CMUi= stoLIDVec[i++];
      li_store_CMUx= stoLIDVec[i++];
      li_store_CCS= stoLIDVec[i++];
      li_store_BETAAC= stoLIDVec[i++];
      li_store_CRBI= stoLIDVec[i++];
      li_store_TF= stoLIDVec[i++];
      li_store_FT= stoLIDVec[i++];
      li_store_TK= stoLIDVec[i++];
      li_store_DTSH= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_ic = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];
    li_branch_ie = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_itnode = branchLIDVecRef[i++];

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_bi)];
    A_c_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_ci)];
    A_c_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_tnode)];
    A_c_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_bp)];
    A_c_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_b)];
    A_c_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_si)];
    A_c_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_s)];
    A_c_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_c)];
    A_c_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_c,admsNodeID_ei)];
    A_c_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bi)];
    A_b_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_ci)];
    A_b_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_tnode)];
    A_b_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_bp)];
    A_b_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
    A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_ei)];
    A_b_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_e)];
    A_b_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_b)];
    A_e_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_e)];
    A_e_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_bp)];
    A_e_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_tnode)];
    A_e_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ei)];
    A_e_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_bi)];
    A_e_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_e,admsNodeID_ci)];
    A_e_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_bi)];
    A_s_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_ci)];
    A_s_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_tnode)];
    A_s_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_bp)];
    A_s_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
    A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_si)];
    A_s_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
    A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_c)];
    A_s_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_ei)];
    A_s_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_tnode)];
    A_tnode_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_bi)];
    A_tnode_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_ci)];
    A_tnode_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_ei)];
    A_tnode_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_si)];
    A_tnode_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_bp)];
    A_tnode_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_e)];
    A_tnode_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_c)];
    A_tnode_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tnode,admsNodeID_b)];
    A_tnode_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bi)];
    A_ci_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ci)];
    A_ci_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_ei)];
    A_ci_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_tnode)];
    A_ci_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_bp)];
    A_ci_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_b)];
    A_ci_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_si)];
    A_ci_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_xf2)];
    A_ci_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_c)];
    A_ci_Equ_c_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ci,admsNodeID_n2)];
    A_ci_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bi)];
    A_ei_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ei)];
    A_ei_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_ci)];
    A_ei_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_tnode)];
    A_ei_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_bp)];
    A_ei_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_xf)];
    A_ei_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_xf2)];
    A_ei_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_e)];
    A_ei_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_n1)];
    A_ei_Equ_n1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_ei,admsNodeID_n2)];
    A_ei_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bp)];
    A_bp_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_ci)];
    A_bp_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_tnode)];
    A_bp_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_b)];
    A_bp_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_bi)];
    A_bp_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_ei)];
    A_bp_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_si)];
    A_bp_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bp,admsNodeID_e)];
    A_bp_Equ_e_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bi)];
    A_bi_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ei)];
    A_bi_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_ci)];
    A_bi_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_tnode)];
    A_bi_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_bp)];
    A_bi_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_xf)];
    A_bi_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_n1)];
    A_bi_Equ_n1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_bi,admsNodeID_n2)];
    A_bi_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
    A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_ci)];
    A_si_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bp)];
    A_si_Equ_bp_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_tnode)];
    A_si_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_bi)];
    A_si_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_ei)];
    A_si_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_b)];
    A_si_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
    A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_bi)];
    A_xf1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ci)];
    A_xf1_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_ei)];
    A_xf1_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_tnode)];
    A_xf1_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf2)];
    A_xf1_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf1,admsNodeID_xf1)];
    A_xf1_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_bi)];
    A_xf2_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_ci)];
    A_xf2_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_tnode)];
    A_xf2_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_ei)];
    A_xf2_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf1)];
    A_xf2_Equ_xf1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf2,admsNodeID_xf2)];
    A_xf2_Equ_xf2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_bi)];
    A_xf_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_ei)];
    A_xf_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_ci)];
    A_xf_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_tnode)];
    A_xf_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xf,admsNodeID_xf)];
    A_xf_Equ_xf_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_bi)];
    A_n1_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_ei)];
    A_n1_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_tnode)];
    A_n1_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n1,admsNodeID_n1)];
    A_n1_Equ_n1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_bi)];
    A_n2_Equ_bi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_ci)];
    A_n2_Equ_ci_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_ei)];
    A_n2_Equ_ei_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_tnode)];
    A_n2_Equ_tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_n2,admsNodeID_n2)];
    A_n2_Equ_n2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
    f_c_Equ_bi_Node_Ptr = &(dFdx[li_c][A_c_Equ_bi_NodeOffset]);
    q_c_Equ_bi_Node_Ptr = &(dQdx[li_c][A_c_Equ_bi_NodeOffset]);
    f_c_Equ_ci_Node_Ptr = &(dFdx[li_c][A_c_Equ_ci_NodeOffset]);
    q_c_Equ_ci_Node_Ptr = &(dQdx[li_c][A_c_Equ_ci_NodeOffset]);
    f_c_Equ_tnode_Node_Ptr = &(dFdx[li_c][A_c_Equ_tnode_NodeOffset]);
    q_c_Equ_tnode_Node_Ptr = &(dQdx[li_c][A_c_Equ_tnode_NodeOffset]);
    f_c_Equ_bp_Node_Ptr = &(dFdx[li_c][A_c_Equ_bp_NodeOffset]);
    q_c_Equ_bp_Node_Ptr = &(dQdx[li_c][A_c_Equ_bp_NodeOffset]);
    f_c_Equ_b_Node_Ptr = &(dFdx[li_c][A_c_Equ_b_NodeOffset]);
    q_c_Equ_b_Node_Ptr = &(dQdx[li_c][A_c_Equ_b_NodeOffset]);
    f_c_Equ_si_Node_Ptr = &(dFdx[li_c][A_c_Equ_si_NodeOffset]);
    q_c_Equ_si_Node_Ptr = &(dQdx[li_c][A_c_Equ_si_NodeOffset]);
    f_c_Equ_s_Node_Ptr = &(dFdx[li_c][A_c_Equ_s_NodeOffset]);
    q_c_Equ_s_Node_Ptr = &(dQdx[li_c][A_c_Equ_s_NodeOffset]);
    f_c_Equ_c_Node_Ptr = &(dFdx[li_c][A_c_Equ_c_NodeOffset]);
    q_c_Equ_c_Node_Ptr = &(dQdx[li_c][A_c_Equ_c_NodeOffset]);
    f_c_Equ_ei_Node_Ptr = &(dFdx[li_c][A_c_Equ_ei_NodeOffset]);
    q_c_Equ_ei_Node_Ptr = &(dQdx[li_c][A_c_Equ_ei_NodeOffset]);
    f_b_Equ_bi_Node_Ptr = &(dFdx[li_b][A_b_Equ_bi_NodeOffset]);
    q_b_Equ_bi_Node_Ptr = &(dQdx[li_b][A_b_Equ_bi_NodeOffset]);
    f_b_Equ_ci_Node_Ptr = &(dFdx[li_b][A_b_Equ_ci_NodeOffset]);
    q_b_Equ_ci_Node_Ptr = &(dQdx[li_b][A_b_Equ_ci_NodeOffset]);
    f_b_Equ_tnode_Node_Ptr = &(dFdx[li_b][A_b_Equ_tnode_NodeOffset]);
    q_b_Equ_tnode_Node_Ptr = &(dQdx[li_b][A_b_Equ_tnode_NodeOffset]);
    f_b_Equ_bp_Node_Ptr = &(dFdx[li_b][A_b_Equ_bp_NodeOffset]);
    q_b_Equ_bp_Node_Ptr = &(dQdx[li_b][A_b_Equ_bp_NodeOffset]);
    f_b_Equ_b_Node_Ptr = &(dFdx[li_b][A_b_Equ_b_NodeOffset]);
    q_b_Equ_b_Node_Ptr = &(dQdx[li_b][A_b_Equ_b_NodeOffset]);
    f_b_Equ_ei_Node_Ptr = &(dFdx[li_b][A_b_Equ_ei_NodeOffset]);
    q_b_Equ_ei_Node_Ptr = &(dQdx[li_b][A_b_Equ_ei_NodeOffset]);
    f_b_Equ_e_Node_Ptr = &(dFdx[li_b][A_b_Equ_e_NodeOffset]);
    q_b_Equ_e_Node_Ptr = &(dQdx[li_b][A_b_Equ_e_NodeOffset]);
    f_e_Equ_b_Node_Ptr = &(dFdx[li_e][A_e_Equ_b_NodeOffset]);
    q_e_Equ_b_Node_Ptr = &(dQdx[li_e][A_e_Equ_b_NodeOffset]);
    f_e_Equ_e_Node_Ptr = &(dFdx[li_e][A_e_Equ_e_NodeOffset]);
    q_e_Equ_e_Node_Ptr = &(dQdx[li_e][A_e_Equ_e_NodeOffset]);
    f_e_Equ_bp_Node_Ptr = &(dFdx[li_e][A_e_Equ_bp_NodeOffset]);
    q_e_Equ_bp_Node_Ptr = &(dQdx[li_e][A_e_Equ_bp_NodeOffset]);
    f_e_Equ_tnode_Node_Ptr = &(dFdx[li_e][A_e_Equ_tnode_NodeOffset]);
    q_e_Equ_tnode_Node_Ptr = &(dQdx[li_e][A_e_Equ_tnode_NodeOffset]);
    f_e_Equ_ei_Node_Ptr = &(dFdx[li_e][A_e_Equ_ei_NodeOffset]);
    q_e_Equ_ei_Node_Ptr = &(dQdx[li_e][A_e_Equ_ei_NodeOffset]);
    f_e_Equ_bi_Node_Ptr = &(dFdx[li_e][A_e_Equ_bi_NodeOffset]);
    q_e_Equ_bi_Node_Ptr = &(dQdx[li_e][A_e_Equ_bi_NodeOffset]);
    f_e_Equ_ci_Node_Ptr = &(dFdx[li_e][A_e_Equ_ci_NodeOffset]);
    q_e_Equ_ci_Node_Ptr = &(dQdx[li_e][A_e_Equ_ci_NodeOffset]);
    f_s_Equ_bi_Node_Ptr = &(dFdx[li_s][A_s_Equ_bi_NodeOffset]);
    q_s_Equ_bi_Node_Ptr = &(dQdx[li_s][A_s_Equ_bi_NodeOffset]);
    f_s_Equ_ci_Node_Ptr = &(dFdx[li_s][A_s_Equ_ci_NodeOffset]);
    q_s_Equ_ci_Node_Ptr = &(dQdx[li_s][A_s_Equ_ci_NodeOffset]);
    f_s_Equ_tnode_Node_Ptr = &(dFdx[li_s][A_s_Equ_tnode_NodeOffset]);
    q_s_Equ_tnode_Node_Ptr = &(dQdx[li_s][A_s_Equ_tnode_NodeOffset]);
    f_s_Equ_bp_Node_Ptr = &(dFdx[li_s][A_s_Equ_bp_NodeOffset]);
    q_s_Equ_bp_Node_Ptr = &(dQdx[li_s][A_s_Equ_bp_NodeOffset]);
    f_s_Equ_b_Node_Ptr = &(dFdx[li_s][A_s_Equ_b_NodeOffset]);
    q_s_Equ_b_Node_Ptr = &(dQdx[li_s][A_s_Equ_b_NodeOffset]);
    f_s_Equ_si_Node_Ptr = &(dFdx[li_s][A_s_Equ_si_NodeOffset]);
    q_s_Equ_si_Node_Ptr = &(dQdx[li_s][A_s_Equ_si_NodeOffset]);
    f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
    q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
    f_s_Equ_c_Node_Ptr = &(dFdx[li_s][A_s_Equ_c_NodeOffset]);
    q_s_Equ_c_Node_Ptr = &(dQdx[li_s][A_s_Equ_c_NodeOffset]);
    f_s_Equ_ei_Node_Ptr = &(dFdx[li_s][A_s_Equ_ei_NodeOffset]);
    q_s_Equ_ei_Node_Ptr = &(dQdx[li_s][A_s_Equ_ei_NodeOffset]);
    f_tnode_Equ_tnode_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_tnode_NodeOffset]);
    q_tnode_Equ_tnode_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_tnode_NodeOffset]);
    f_tnode_Equ_bi_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_bi_NodeOffset]);
    q_tnode_Equ_bi_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_bi_NodeOffset]);
    f_tnode_Equ_ci_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_ci_NodeOffset]);
    q_tnode_Equ_ci_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_ci_NodeOffset]);
    f_tnode_Equ_ei_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_ei_NodeOffset]);
    q_tnode_Equ_ei_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_ei_NodeOffset]);
    f_tnode_Equ_si_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_si_NodeOffset]);
    q_tnode_Equ_si_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_si_NodeOffset]);
    f_tnode_Equ_bp_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_bp_NodeOffset]);
    q_tnode_Equ_bp_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_bp_NodeOffset]);
    f_tnode_Equ_e_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_e_NodeOffset]);
    q_tnode_Equ_e_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_e_NodeOffset]);
    f_tnode_Equ_c_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_c_NodeOffset]);
    q_tnode_Equ_c_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_c_NodeOffset]);
    f_tnode_Equ_b_Node_Ptr = &(dFdx[li_tnode][A_tnode_Equ_b_NodeOffset]);
    q_tnode_Equ_b_Node_Ptr = &(dQdx[li_tnode][A_tnode_Equ_b_NodeOffset]);
    f_ci_Equ_bi_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_bi_NodeOffset]);
    q_ci_Equ_bi_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_bi_NodeOffset]);
    f_ci_Equ_ci_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_ci_NodeOffset]);
    q_ci_Equ_ci_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_ci_NodeOffset]);
    f_ci_Equ_ei_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_ei_NodeOffset]);
    q_ci_Equ_ei_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_ei_NodeOffset]);
    f_ci_Equ_tnode_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_tnode_NodeOffset]);
    q_ci_Equ_tnode_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_tnode_NodeOffset]);
    f_ci_Equ_bp_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_bp_NodeOffset]);
    q_ci_Equ_bp_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_bp_NodeOffset]);
    f_ci_Equ_b_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_b_NodeOffset]);
    q_ci_Equ_b_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_b_NodeOffset]);
    f_ci_Equ_si_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_si_NodeOffset]);
    q_ci_Equ_si_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_si_NodeOffset]);
    f_ci_Equ_xf2_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_xf2_NodeOffset]);
    q_ci_Equ_xf2_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_xf2_NodeOffset]);
    f_ci_Equ_c_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_c_NodeOffset]);
    q_ci_Equ_c_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_c_NodeOffset]);
    f_ci_Equ_n2_Node_Ptr = &(dFdx[li_ci][A_ci_Equ_n2_NodeOffset]);
    q_ci_Equ_n2_Node_Ptr = &(dQdx[li_ci][A_ci_Equ_n2_NodeOffset]);
    f_ei_Equ_bi_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_bi_NodeOffset]);
    q_ei_Equ_bi_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_bi_NodeOffset]);
    f_ei_Equ_ei_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_ei_NodeOffset]);
    q_ei_Equ_ei_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_ei_NodeOffset]);
    f_ei_Equ_ci_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_ci_NodeOffset]);
    q_ei_Equ_ci_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_ci_NodeOffset]);
    f_ei_Equ_tnode_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_tnode_NodeOffset]);
    q_ei_Equ_tnode_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_tnode_NodeOffset]);
    f_ei_Equ_bp_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_bp_NodeOffset]);
    q_ei_Equ_bp_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_bp_NodeOffset]);
    f_ei_Equ_xf_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_xf_NodeOffset]);
    q_ei_Equ_xf_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_xf_NodeOffset]);
    f_ei_Equ_xf2_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_xf2_NodeOffset]);
    q_ei_Equ_xf2_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_xf2_NodeOffset]);
    f_ei_Equ_e_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_e_NodeOffset]);
    q_ei_Equ_e_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_e_NodeOffset]);
    f_ei_Equ_n1_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_n1_NodeOffset]);
    q_ei_Equ_n1_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_n1_NodeOffset]);
    f_ei_Equ_n2_Node_Ptr = &(dFdx[li_ei][A_ei_Equ_n2_NodeOffset]);
    q_ei_Equ_n2_Node_Ptr = &(dQdx[li_ei][A_ei_Equ_n2_NodeOffset]);
    f_bp_Equ_bp_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_bp_NodeOffset]);
    q_bp_Equ_bp_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_bp_NodeOffset]);
    f_bp_Equ_ci_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_ci_NodeOffset]);
    q_bp_Equ_ci_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_ci_NodeOffset]);
    f_bp_Equ_tnode_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_tnode_NodeOffset]);
    q_bp_Equ_tnode_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_tnode_NodeOffset]);
    f_bp_Equ_b_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_b_NodeOffset]);
    q_bp_Equ_b_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_b_NodeOffset]);
    f_bp_Equ_bi_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_bi_NodeOffset]);
    q_bp_Equ_bi_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_bi_NodeOffset]);
    f_bp_Equ_ei_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_ei_NodeOffset]);
    q_bp_Equ_ei_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_ei_NodeOffset]);
    f_bp_Equ_si_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_si_NodeOffset]);
    q_bp_Equ_si_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_si_NodeOffset]);
    f_bp_Equ_e_Node_Ptr = &(dFdx[li_bp][A_bp_Equ_e_NodeOffset]);
    q_bp_Equ_e_Node_Ptr = &(dQdx[li_bp][A_bp_Equ_e_NodeOffset]);
    f_bi_Equ_bi_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_bi_NodeOffset]);
    q_bi_Equ_bi_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_bi_NodeOffset]);
    f_bi_Equ_ei_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_ei_NodeOffset]);
    q_bi_Equ_ei_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_ei_NodeOffset]);
    f_bi_Equ_ci_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_ci_NodeOffset]);
    q_bi_Equ_ci_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_ci_NodeOffset]);
    f_bi_Equ_tnode_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_tnode_NodeOffset]);
    q_bi_Equ_tnode_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_tnode_NodeOffset]);
    f_bi_Equ_bp_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_bp_NodeOffset]);
    q_bi_Equ_bp_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_bp_NodeOffset]);
    f_bi_Equ_xf_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_xf_NodeOffset]);
    q_bi_Equ_xf_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_xf_NodeOffset]);
    f_bi_Equ_n1_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_n1_NodeOffset]);
    q_bi_Equ_n1_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_n1_NodeOffset]);
    f_bi_Equ_n2_Node_Ptr = &(dFdx[li_bi][A_bi_Equ_n2_NodeOffset]);
    q_bi_Equ_n2_Node_Ptr = &(dQdx[li_bi][A_bi_Equ_n2_NodeOffset]);
    f_si_Equ_si_Node_Ptr = &(dFdx[li_si][A_si_Equ_si_NodeOffset]);
    q_si_Equ_si_Node_Ptr = &(dQdx[li_si][A_si_Equ_si_NodeOffset]);
    f_si_Equ_ci_Node_Ptr = &(dFdx[li_si][A_si_Equ_ci_NodeOffset]);
    q_si_Equ_ci_Node_Ptr = &(dQdx[li_si][A_si_Equ_ci_NodeOffset]);
    f_si_Equ_bp_Node_Ptr = &(dFdx[li_si][A_si_Equ_bp_NodeOffset]);
    q_si_Equ_bp_Node_Ptr = &(dQdx[li_si][A_si_Equ_bp_NodeOffset]);
    f_si_Equ_tnode_Node_Ptr = &(dFdx[li_si][A_si_Equ_tnode_NodeOffset]);
    q_si_Equ_tnode_Node_Ptr = &(dQdx[li_si][A_si_Equ_tnode_NodeOffset]);
    f_si_Equ_bi_Node_Ptr = &(dFdx[li_si][A_si_Equ_bi_NodeOffset]);
    q_si_Equ_bi_Node_Ptr = &(dQdx[li_si][A_si_Equ_bi_NodeOffset]);
    f_si_Equ_ei_Node_Ptr = &(dFdx[li_si][A_si_Equ_ei_NodeOffset]);
    q_si_Equ_ei_Node_Ptr = &(dQdx[li_si][A_si_Equ_ei_NodeOffset]);
    f_si_Equ_b_Node_Ptr = &(dFdx[li_si][A_si_Equ_b_NodeOffset]);
    q_si_Equ_b_Node_Ptr = &(dQdx[li_si][A_si_Equ_b_NodeOffset]);
    f_si_Equ_s_Node_Ptr = &(dFdx[li_si][A_si_Equ_s_NodeOffset]);
    q_si_Equ_s_Node_Ptr = &(dQdx[li_si][A_si_Equ_s_NodeOffset]);
    f_xf1_Equ_bi_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_bi_NodeOffset]);
    q_xf1_Equ_bi_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_bi_NodeOffset]);
    f_xf1_Equ_ci_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_ci_NodeOffset]);
    q_xf1_Equ_ci_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_ci_NodeOffset]);
    f_xf1_Equ_ei_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_ei_NodeOffset]);
    q_xf1_Equ_ei_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_ei_NodeOffset]);
    f_xf1_Equ_tnode_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_tnode_NodeOffset]);
    q_xf1_Equ_tnode_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_tnode_NodeOffset]);
    f_xf1_Equ_xf2_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_xf2_NodeOffset]);
    q_xf1_Equ_xf2_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_xf2_NodeOffset]);
    f_xf1_Equ_xf1_Node_Ptr = &(dFdx[li_xf1][A_xf1_Equ_xf1_NodeOffset]);
    q_xf1_Equ_xf1_Node_Ptr = &(dQdx[li_xf1][A_xf1_Equ_xf1_NodeOffset]);
    f_xf2_Equ_bi_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_bi_NodeOffset]);
    q_xf2_Equ_bi_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_bi_NodeOffset]);
    f_xf2_Equ_ci_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_ci_NodeOffset]);
    q_xf2_Equ_ci_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_ci_NodeOffset]);
    f_xf2_Equ_tnode_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_tnode_NodeOffset]);
    q_xf2_Equ_tnode_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_tnode_NodeOffset]);
    f_xf2_Equ_ei_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_ei_NodeOffset]);
    q_xf2_Equ_ei_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_ei_NodeOffset]);
    f_xf2_Equ_xf1_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_xf1_NodeOffset]);
    q_xf2_Equ_xf1_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_xf1_NodeOffset]);
    f_xf2_Equ_xf2_Node_Ptr = &(dFdx[li_xf2][A_xf2_Equ_xf2_NodeOffset]);
    q_xf2_Equ_xf2_Node_Ptr = &(dQdx[li_xf2][A_xf2_Equ_xf2_NodeOffset]);
    f_xf_Equ_bi_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_bi_NodeOffset]);
    q_xf_Equ_bi_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_bi_NodeOffset]);
    f_xf_Equ_ei_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_ei_NodeOffset]);
    q_xf_Equ_ei_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_ei_NodeOffset]);
    f_xf_Equ_ci_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_ci_NodeOffset]);
    q_xf_Equ_ci_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_ci_NodeOffset]);
    f_xf_Equ_tnode_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_tnode_NodeOffset]);
    q_xf_Equ_tnode_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_tnode_NodeOffset]);
    f_xf_Equ_xf_Node_Ptr = &(dFdx[li_xf][A_xf_Equ_xf_NodeOffset]);
    q_xf_Equ_xf_Node_Ptr = &(dQdx[li_xf][A_xf_Equ_xf_NodeOffset]);
    f_n1_Equ_bi_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_bi_NodeOffset]);
    q_n1_Equ_bi_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_bi_NodeOffset]);
    f_n1_Equ_ei_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_ei_NodeOffset]);
    q_n1_Equ_ei_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_ei_NodeOffset]);
    f_n1_Equ_tnode_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_tnode_NodeOffset]);
    q_n1_Equ_tnode_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_tnode_NodeOffset]);
    f_n1_Equ_n1_Node_Ptr = &(dFdx[li_n1][A_n1_Equ_n1_NodeOffset]);
    q_n1_Equ_n1_Node_Ptr = &(dQdx[li_n1][A_n1_Equ_n1_NodeOffset]);
    f_n2_Equ_bi_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_bi_NodeOffset]);
    q_n2_Equ_bi_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_bi_NodeOffset]);
    f_n2_Equ_ci_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_ci_NodeOffset]);
    q_n2_Equ_ci_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_ci_NodeOffset]);
    f_n2_Equ_ei_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_ei_NodeOffset]);
    q_n2_Equ_ei_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_ei_NodeOffset]);
    f_n2_Equ_tnode_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_tnode_NodeOffset]);
    q_n2_Equ_tnode_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_tnode_NodeOffset]);
    f_n2_Equ_n2_Node_Ptr = &(dFdx[li_n2][A_n2_Equ_n2_NodeOffset]);
    q_n2_Equ_n2_Node_Ptr = &(dQdx[li_n2][A_n2_Equ_n2_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_c] += staticContributions[admsNodeID_c];
(*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b];
(*extData.daeFVectorPtr)[li_e] += staticContributions[admsNodeID_e];
(*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s];
(*extData.daeFVectorPtr)[li_tnode] += staticContributions[admsNodeID_tnode];
(*extData.daeFVectorPtr)[li_ci] += staticContributions[admsNodeID_ci];
(*extData.daeFVectorPtr)[li_ei] += staticContributions[admsNodeID_ei];
(*extData.daeFVectorPtr)[li_bp] += staticContributions[admsNodeID_bp];
(*extData.daeFVectorPtr)[li_bi] += staticContributions[admsNodeID_bi];
(*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si];
(*extData.daeFVectorPtr)[li_xf1] += staticContributions[admsNodeID_xf1];
(*extData.daeFVectorPtr)[li_xf2] += staticContributions[admsNodeID_xf2];
(*extData.daeFVectorPtr)[li_xf] += staticContributions[admsNodeID_xf];
(*extData.daeFVectorPtr)[li_n1] += staticContributions[admsNodeID_n1];
(*extData.daeFVectorPtr)[li_n2] += staticContributions[admsNodeID_n2];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_ic] = leadCurrentF[admsNodeID_c];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];
    leadF[li_branch_ie] = leadCurrentF[admsNodeID_e];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_itnode] = leadCurrentF[admsNodeID_tnode];



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_ic] = solVec[li_c] - solVec[li_e];
        junctionV[li_branch_ib] = solVec[li_b] - solVec[li_e];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_c] += dynamicContributions[admsNodeID_c];
(*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b];
(*extData.daeQVectorPtr)[li_e] += dynamicContributions[admsNodeID_e];
(*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s];
(*extData.daeQVectorPtr)[li_tnode] += dynamicContributions[admsNodeID_tnode];
(*extData.daeQVectorPtr)[li_ci] += dynamicContributions[admsNodeID_ci];
(*extData.daeQVectorPtr)[li_ei] += dynamicContributions[admsNodeID_ei];
(*extData.daeQVectorPtr)[li_bp] += dynamicContributions[admsNodeID_bp];
(*extData.daeQVectorPtr)[li_bi] += dynamicContributions[admsNodeID_bi];
(*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si];
(*extData.daeQVectorPtr)[li_xf1] += dynamicContributions[admsNodeID_xf1];
(*extData.daeQVectorPtr)[li_xf2] += dynamicContributions[admsNodeID_xf2];
(*extData.daeQVectorPtr)[li_xf] += dynamicContributions[admsNodeID_xf];
(*extData.daeQVectorPtr)[li_n1] += dynamicContributions[admsNodeID_n1];
(*extData.daeQVectorPtr)[li_n2] += dynamicContributions[admsNodeID_n2];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_ic] = leadCurrentQ[admsNodeID_c];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];
    leadQ[li_branch_ie] = leadCurrentQ[admsNodeID_e];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_itnode] = leadCurrentQ[admsNodeID_tnode];


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_rcx_t] = rcx_t;
  stoVec[li_store_re_t] = re_t;
  stoVec[li_store_rbi] = rbi;
  stoVec[li_store_rb] = rb;
  stoVec[li_store_IAVL] = IAVL;
  stoVec[li_store_VBE] = VBE;
  stoVec[li_store_VBC] = VBC;
  stoVec[li_store_VCE] = VCE;
  stoVec[li_store_VSC] = VSC;
  stoVec[li_store_GMi] = GMi;
  stoVec[li_store_GMS] = GMS;
  stoVec[li_store_RPIi] = RPIi;
  stoVec[li_store_RPIx] = RPIx;
  stoVec[li_store_RMUi] = RMUi;
  stoVec[li_store_RMUx] = RMUx;
  stoVec[li_store_ROi] = ROi;
  stoVec[li_store_CPIi] = CPIi;
  stoVec[li_store_CPIx] = CPIx;
  stoVec[li_store_CMUi] = CMUi;
  stoVec[li_store_CMUx] = CMUx;
  stoVec[li_store_CCS] = CCS;
  stoVec[li_store_BETAAC] = BETAAC;
  stoVec[li_store_CRBI] = CRBI;
  stoVec[li_store_TF] = TF;
  stoVec[li_store_FT] = FT;
  stoVec[li_store_TK] = TK;
  stoVec[li_store_DTSH] = DTSH;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one hicumL2va instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMShicumL2va::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double fourkt=0.0;
  double flicker_Pwr=0.0;
  double i_re=0.0;
  double twoq=0.0;
  double n_w=0.0;
  double n_1=0.0;
     double d_n_1_dV_bi_ei=0.0;
     double d_n_1_dV_tnode_GND=0.0;
     double d_n_1_dV_bi_ci=0.0;
  double sqrt_n2=0.0;
     double d_sqrt_n2_dV_tnode_GND=0.0;
     double d_sqrt_n2_dV_bi_ei=0.0;
     double d_sqrt_n2_dV_bi_ci=0.0;
  double n_2=0.0;
     double d_n_2_dV_bi_ei=0.0;
     double d_n_2_dV_tnode_GND=0.0;
     double d_n_2_dV_bi_ci=0.0;
  double DIOY=0.0;
     double d_DIOY_dV_si_ci=0.0;
     double d_DIOY_dV_bp_ci=0.0;
     double d_DIOY_dV_bp_ei=0.0;
     double d_DIOY_dV_bi_ci=0.0;
     double d_DIOY_dV_bi_ei=0.0;
     double d_DIOY_dV_tnode_GND=0.0;
  double le=0.0;
     double d_le_dV_si_ci=0.0;
     double d_le_dV_bp_ci=0.0;
     double d_le_dV_bp_ei=0.0;
     double d_le_dV_bi_ci=0.0;
     double d_le_dV_bi_ei=0.0;
     double d_le_dV_tnode_GND=0.0;
  double irei=0.0;
     double d_irei_dV_tnode_GND=0.0;
     double d_irei_dV_bi_ei=0.0;
  double Orci0_t=0.0;
     double d_Orci0_t_dV_tnode_GND=0.0;
  double Tr=0.0;
  double VT_f=0.0;
     double d_VT_f_dV_tnode_GND=0.0;
  double i_0f=0.0;
     double d_i_0f_dV_tnode_GND=0.0;
     double d_i_0f_dV_bi_ei=0.0;
  double i_0r=0.0;
     double d_i_0r_dV_tnode_GND=0.0;
     double d_i_0r_dV_bi_ci=0.0;
  double DFV_f=0.0;
     double d_DFV_f_dV_tnode_GND=0.0;
  double DFv_e=0.0;
     double d_DFv_e_dV_s_c=0.0;
     double d_DFv_e_dV_si_ci=0.0;
     double d_DFv_e_dV_b_ci=0.0;
     double d_DFv_e_dV_bp_ci=0.0;
     double d_DFv_e_dV_bp_ei=0.0;
     double d_DFv_e_dV_bi_ci=0.0;
     double d_DFv_e_dV_tnode_GND=0.0;
     double d_DFv_e_dV_bi_ei=0.0;
  double DFs_q=0.0;
     double d_DFs_q_dV_s_c=0.0;
     double d_DFs_q_dV_si_ci=0.0;
     double d_DFs_q_dV_b_ci=0.0;
     double d_DFs_q_dV_bp_ci=0.0;
     double d_DFs_q_dV_bp_ei=0.0;
     double d_DFs_q_dV_bi_ci=0.0;
     double d_DFs_q_dV_tnode_GND=0.0;
     double d_DFs_q_dV_bi_ei=0.0;
  double DFs_q2=0.0;
     double d_DFs_q2_dV_s_c=0.0;
     double d_DFs_q2_dV_si_ci=0.0;
     double d_DFs_q2_dV_b_ci=0.0;
     double d_DFs_q2_dV_bp_ci=0.0;
     double d_DFs_q2_dV_bp_ei=0.0;
     double d_DFs_q2_dV_bi_ci=0.0;
     double d_DFs_q2_dV_tnode_GND=0.0;
     double d_DFs_q2_dV_bi_ei=0.0;
  double DFv_j=0.0;
     double d_DFv_j_dV_s_c=0.0;
     double d_DFv_j_dV_si_ci=0.0;
     double d_DFv_j_dV_b_ci=0.0;
     double d_DFv_j_dV_bp_ci=0.0;
     double d_DFv_j_dV_bp_ei=0.0;
     double d_DFv_j_dV_bi_ci=0.0;
     double d_DFv_j_dV_tnode_GND=0.0;
     double d_DFv_j_dV_bi_ei=0.0;
  double DFdvj_dv=0.0;
     double d_DFdvj_dv_dV_s_c=0.0;
     double d_DFdvj_dv_dV_si_ci=0.0;
     double d_DFdvj_dv_dV_b_ci=0.0;
     double d_DFdvj_dv_dV_bp_ci=0.0;
     double d_DFdvj_dv_dV_bp_ei=0.0;
     double d_DFdvj_dv_dV_bi_ci=0.0;
     double d_DFdvj_dv_dV_tnode_GND=0.0;
     double d_DFdvj_dv_dV_bi_ei=0.0;
  double DFb=0.0;
     double d_DFb_dV_s_c=0.0;
     double d_DFb_dV_si_ci=0.0;
     double d_DFb_dV_b_ci=0.0;
     double d_DFb_dV_bp_ci=0.0;
     double d_DFb_dV_bp_ei=0.0;
     double d_DFb_dV_bi_ci=0.0;
     double d_DFb_dV_tnode_GND=0.0;
     double d_DFb_dV_bi_ei=0.0;
  double DFC_j1=0.0;
     double d_DFC_j1_dV_s_c=0.0;
     double d_DFC_j1_dV_si_ci=0.0;
     double d_DFC_j1_dV_b_ci=0.0;
     double d_DFC_j1_dV_bp_ci=0.0;
     double d_DFC_j1_dV_bp_ei=0.0;
     double d_DFC_j1_dV_bi_ci=0.0;
     double d_DFC_j1_dV_tnode_GND=0.0;
     double d_DFC_j1_dV_bi_ei=0.0;
  double Cjei=0.0;
     double d_Cjei_dV_tnode_GND=0.0;
     double d_Cjei_dV_bi_ei=0.0;
  double DFQ_j=0.0;
     double d_DFQ_j_dV_s_c=0.0;
     double d_DFQ_j_dV_si_ci=0.0;
     double d_DFQ_j_dV_b_ci=0.0;
     double d_DFQ_j_dV_bp_ci=0.0;
     double d_DFQ_j_dV_bp_ei=0.0;
     double d_DFQ_j_dV_bi_ci=0.0;
     double d_DFQ_j_dV_tnode_GND=0.0;
     double d_DFQ_j_dV_bi_ei=0.0;
  double Qjei=0.0;
     double d_Qjei_dV_tnode_GND=0.0;
     double d_Qjei_dV_bi_ei=0.0;
  double vj=0.0;
     double d_vj_dV_tnode_GND=0.0;
     double d_vj_dV_bi_ei=0.0;
  double vj_z=0.0;
     double d_vj_z_dV_tnode_GND=0.0;
     double d_vj_z_dV_bi_ei=0.0;
  double hjei_vbe=0.0;
     double d_hjei_vbe_dV_tnode_GND=0.0;
     double d_hjei_vbe_dV_bi_ei=0.0;
  double Dz_r=0.0;
  double Dv_p=0.0;
     double d_Dv_p_dV_tnode_GND=0.0;
  double DV_f=0.0;
     double d_DV_f_dV_tnode_GND=0.0;
  double DC_max=0.0;
     double d_DC_max_dV_tnode_GND=0.0;
  double DC_c=0.0;
     double d_DC_c_dV_tnode_GND=0.0;
  double Dv_e=0.0;
     double d_Dv_e_dV_s_c=0.0;
     double d_Dv_e_dV_si_ci=0.0;
     double d_Dv_e_dV_b_ci=0.0;
     double d_Dv_e_dV_bp_ci=0.0;
     double d_Dv_e_dV_tnode_GND=0.0;
     double d_Dv_e_dV_bi_ci=0.0;
  double De=0.0;
     double d_De_dV_s_c=0.0;
     double d_De_dV_si_ci=0.0;
     double d_De_dV_b_ci=0.0;
     double d_De_dV_bp_ci=0.0;
     double d_De_dV_tnode_GND=0.0;
     double d_De_dV_bi_ci=0.0;
  double De_1=0.0;
     double d_De_1_dV_s_c=0.0;
     double d_De_1_dV_si_ci=0.0;
     double d_De_1_dV_b_ci=0.0;
     double d_De_1_dV_bp_ci=0.0;
     double d_De_1_dV_tnode_GND=0.0;
     double d_De_1_dV_bi_ci=0.0;
  double Dv_j1=0.0;
     double d_Dv_j1_dV_s_c=0.0;
     double d_Dv_j1_dV_si_ci=0.0;
     double d_Dv_j1_dV_b_ci=0.0;
     double d_Dv_j1_dV_bp_ci=0.0;
     double d_Dv_j1_dV_tnode_GND=0.0;
     double d_Dv_j1_dV_bi_ci=0.0;
  double Da=0.0;
     double d_Da_dV_tnode_GND=0.0;
  double Dv_r=0.0;
     double d_Dv_r_dV_s_c=0.0;
     double d_Dv_r_dV_si_ci=0.0;
     double d_Dv_r_dV_b_ci=0.0;
     double d_Dv_r_dV_bp_ci=0.0;
     double d_Dv_r_dV_tnode_GND=0.0;
     double d_Dv_r_dV_bi_ci=0.0;
  double De_2=0.0;
     double d_De_2_dV_s_c=0.0;
     double d_De_2_dV_si_ci=0.0;
     double d_De_2_dV_b_ci=0.0;
     double d_De_2_dV_bp_ci=0.0;
     double d_De_2_dV_tnode_GND=0.0;
     double d_De_2_dV_bi_ci=0.0;
  double Dv_j2=0.0;
     double d_Dv_j2_dV_s_c=0.0;
     double d_Dv_j2_dV_si_ci=0.0;
     double d_Dv_j2_dV_b_ci=0.0;
     double d_Dv_j2_dV_bp_ci=0.0;
     double d_Dv_j2_dV_tnode_GND=0.0;
     double d_Dv_j2_dV_bi_ci=0.0;
  double Dv_j4=0.0;
     double d_Dv_j4_dV_s_c=0.0;
     double d_Dv_j4_dV_si_ci=0.0;
     double d_Dv_j4_dV_b_ci=0.0;
     double d_Dv_j4_dV_bp_ci=0.0;
     double d_Dv_j4_dV_bi_ci=0.0;
     double d_Dv_j4_dV_tnode_GND=0.0;
  double DCln1=0.0;
     double d_DCln1_dV_s_c=0.0;
     double d_DCln1_dV_si_ci=0.0;
     double d_DCln1_dV_b_ci=0.0;
     double d_DCln1_dV_bp_ci=0.0;
     double d_DCln1_dV_tnode_GND=0.0;
     double d_DCln1_dV_bi_ci=0.0;
  double DCln2=0.0;
     double d_DCln2_dV_s_c=0.0;
     double d_DCln2_dV_si_ci=0.0;
     double d_DCln2_dV_b_ci=0.0;
     double d_DCln2_dV_bp_ci=0.0;
     double d_DCln2_dV_tnode_GND=0.0;
     double d_DCln2_dV_bi_ci=0.0;
  double Dz1=0.0;
  double Dzr1=0.0;
  double DC_j1=0.0;
     double d_DC_j1_dV_s_c=0.0;
     double d_DC_j1_dV_si_ci=0.0;
     double d_DC_j1_dV_b_ci=0.0;
     double d_DC_j1_dV_bp_ci=0.0;
     double d_DC_j1_dV_tnode_GND=0.0;
     double d_DC_j1_dV_bi_ci=0.0;
  double DC_j2=0.0;
     double d_DC_j2_dV_s_c=0.0;
     double d_DC_j2_dV_si_ci=0.0;
     double d_DC_j2_dV_b_ci=0.0;
     double d_DC_j2_dV_bp_ci=0.0;
     double d_DC_j2_dV_tnode_GND=0.0;
     double d_DC_j2_dV_bi_ci=0.0;
  double DC_j3=0.0;
     double d_DC_j3_dV_s_c=0.0;
     double d_DC_j3_dV_si_ci=0.0;
     double d_DC_j3_dV_b_ci=0.0;
     double d_DC_j3_dV_bp_ci=0.0;
     double d_DC_j3_dV_tnode_GND=0.0;
     double d_DC_j3_dV_bi_ci=0.0;
  double Cjci=0.0;
     double d_Cjci_dV_bi_ei=0.0;
     double d_Cjci_dV_tnode_GND=0.0;
     double d_Cjci_dV_bi_ci=0.0;
  double DQ_j1=0.0;
     double d_DQ_j1_dV_s_c=0.0;
     double d_DQ_j1_dV_si_ci=0.0;
     double d_DQ_j1_dV_b_ci=0.0;
     double d_DQ_j1_dV_bp_ci=0.0;
     double d_DQ_j1_dV_tnode_GND=0.0;
     double d_DQ_j1_dV_bi_ci=0.0;
  double DQ_j2=0.0;
     double d_DQ_j2_dV_s_c=0.0;
     double d_DQ_j2_dV_si_ci=0.0;
     double d_DQ_j2_dV_b_ci=0.0;
     double d_DQ_j2_dV_bp_ci=0.0;
     double d_DQ_j2_dV_tnode_GND=0.0;
     double d_DQ_j2_dV_bi_ci=0.0;
  double DQ_j3=0.0;
     double d_DQ_j3_dV_s_c=0.0;
     double d_DQ_j3_dV_si_ci=0.0;
     double d_DQ_j3_dV_b_ci=0.0;
     double d_DQ_j3_dV_bp_ci=0.0;
     double d_DQ_j3_dV_tnode_GND=0.0;
     double d_DQ_j3_dV_bi_ci=0.0;
  double Qjci=0.0;
     double d_Qjci_dV_bi_ei=0.0;
     double d_Qjci_dV_tnode_GND=0.0;
     double d_Qjci_dV_bi_ci=0.0;
  double a_bpt=0.0;
  double Q_0=0.0;
     double d_Q_0_dV_tnode_GND=0.0;
     double d_Q_0_dV_bi_ei=0.0;
     double d_Q_0_dV_bi_ci=0.0;
  double Q_bpt=0.0;
     double d_Q_bpt_dV_tnode_GND=0.0;
  double b_q=0.0;
     double d_b_q_dV_tnode_GND=0.0;
     double d_b_q_dV_bi_ei=0.0;
     double d_b_q_dV_bi_ci=0.0;
  double Cjcit=0.0;
     double d_Cjcit_dV_tnode_GND=0.0;
     double d_Cjcit_dV_bi_ci=0.0;
  double cc=0.0;
     double d_cc_dV_tnode_GND=0.0;
     double d_cc_dV_bi_ci=0.0;
  double T_f0=0.0;
     double d_T_f0_dV_tnode_GND=0.0;
     double d_T_f0_dV_bi_ci=0.0;
  double vc=0.0;
     double d_vc_dV_bi_ei=0.0;
     double d_vc_dV_bi_ci=0.0;
     double d_vc_dV_tnode_GND=0.0;
  double ick=0.0;
     double d_ick_dV_bi_ei=0.0;
     double d_ick_dV_bi_ci=0.0;
     double d_ick_dV_tnode_GND=0.0;
  double ICKa=0.0;
     double d_ICKa_dV_bi_ei=0.0;
     double d_ICKa_dV_bi_ci=0.0;
     double d_ICKa_dV_tnode_GND=0.0;
  double ick2=0.0;
     double d_ick2_dV_bi_ei=0.0;
     double d_ick2_dV_bi_ci=0.0;
     double d_ick2_dV_tnode_GND=0.0;
  double ick1=0.0;
     double d_ick1_dV_bi_ei=0.0;
     double d_ick1_dV_bi_ci=0.0;
     double d_ick1_dV_tnode_GND=0.0;
  double Odelck=0.0;
  double a11=0.0;
     double d_a11_dV_bi_ei=0.0;
     double d_a11_dV_bi_ci=0.0;
     double d_a11_dV_tnode_GND=0.0;
  double a1=0.0;
     double d_a1_dV_bi_ei=0.0;
     double d_a1_dV_bi_ci=0.0;
     double d_a1_dV_tnode_GND=0.0;
  double vceff=0.0;
     double d_vceff_dV_bi_ei=0.0;
     double d_vceff_dV_bi_ci=0.0;
     double d_vceff_dV_tnode_GND=0.0;
  double d1=0.0;
     double d_d1_dV_bi_ei=0.0;
     double d_d1_dV_bi_ci=0.0;
     double d_d1_dV_tnode_GND=0.0;
  double Ovpt=0.0;
  double Q_p=0.0;
     double d_Q_p_dV_tnode_GND=0.0;
     double d_Q_p_dV_bi_ei=0.0;
     double d_Q_p_dV_bi_ci=0.0;
  double A=0.0;
     double d_A_dV_tnode_GND=0.0;
     double d_A_dV_bi_ei=0.0;
     double d_A_dV_bi_ci=0.0;
  double I_Tf1=0.0;
     double d_I_Tf1_dV_tnode_GND=0.0;
     double d_I_Tf1_dV_bi_ei=0.0;
     double d_I_Tf1_dV_bi_ci=0.0;
  double a_h=0.0;
     double d_a_h_dV_tnode_GND=0.0;
     double d_a_h_dV_bi_ei=0.0;
     double d_a_h_dV_bi_ci=0.0;
  double itf=0.0;
     double d_itf_dV_tnode_GND=0.0;
     double d_itf_dV_bi_ei=0.0;
     double d_itf_dV_bi_ci=0.0;
  double itr=0.0;
     double d_itr_dV_tnode_GND=0.0;
     double d_itr_dV_bi_ci=0.0;
     double d_itr_dV_bi_ei=0.0;
  double Q_bf=0.0;
     double d_Q_bf_dV_tnode_GND=0.0;
     double d_Q_bf_dV_bi_ei=0.0;
     double d_Q_bf_dV_bi_ci=0.0;
  double Qf=0.0;
     double d_Qf_dV_tnode_GND=0.0;
     double d_Qf_dV_bi_ci=0.0;
     double d_Qf_dV_bi_ei=0.0;
  double FFitf_ick=0.0;
     double d_FFitf_ick_dV_tnode_GND=0.0;
     double d_FFitf_ick_dV_bi_ei=0.0;
     double d_FFitf_ick_dV_bi_ci=0.0;
  double FFdTef=0.0;
     double d_FFdTef_dV_tnode_GND=0.0;
     double d_FFdTef_dV_bi_ei=0.0;
     double d_FFdTef_dV_bi_ci=0.0;
  double FFdQef=0.0;
     double d_FFdQef_dV_tnode_GND=0.0;
     double d_FFdQef_dV_bi_ei=0.0;
     double d_FFdQef_dV_bi_ci=0.0;
  double FFib=0.0;
     double d_FFib_dV_tnode_GND=0.0;
     double d_FFib_dV_bi_ei=0.0;
     double d_FFib_dV_bi_ci=0.0;
  double FFfcbar=0.0;
     double d_FFfcbar_dV_tnode_GND=0.0;
     double d_FFfcbar_dV_bi_ei=0.0;
     double d_FFfcbar_dV_bi_ci=0.0;
  double FFdib_ditf=0.0;
     double d_FFdib_ditf_dV_tnode_GND=0.0;
     double d_FFdib_ditf_dV_bi_ei=0.0;
     double d_FFdib_ditf_dV_bi_ci=0.0;
  double FFdVc=0.0;
     double d_FFdVc_dV_tnode_GND=0.0;
     double d_FFdVc_dV_bi_ei=0.0;
     double d_FFdVc_dV_bi_ci=0.0;
  double FFdVc_ditf=0.0;
     double d_FFdVc_ditf_dV_tnode_GND=0.0;
     double d_FFdVc_ditf_dV_bi_ei=0.0;
     double d_FFdVc_ditf_dV_bi_ci=0.0;
  double FFdQbfb=0.0;
     double d_FFdQbfb_dV_tnode_GND=0.0;
     double d_FFdQbfb_dV_bi_ei=0.0;
     double d_FFdQbfb_dV_bi_ci=0.0;
  double FFdTbfb=0.0;
     double d_FFdTbfb_dV_tnode_GND=0.0;
     double d_FFdTbfb_dV_bi_ei=0.0;
     double d_FFdTbfb_dV_bi_ci=0.0;
  double FFic=0.0;
     double d_FFic_dV_tnode_GND=0.0;
     double d_FFic_dV_bi_ei=0.0;
     double d_FFic_dV_bi_ci=0.0;
  double FFw=0.0;
     double d_FFw_dV_tnode_GND=0.0;
     double d_FFw_dV_bi_ei=0.0;
     double d_FFw_dV_bi_ci=0.0;
  double FFdQfhc=0.0;
     double d_FFdQfhc_dV_tnode_GND=0.0;
     double d_FFdQfhc_dV_bi_ei=0.0;
     double d_FFdQfhc_dV_bi_ci=0.0;
  double FFdTfhc=0.0;
     double d_FFdTfhc_dV_tnode_GND=0.0;
     double d_FFdTfhc_dV_bi_ei=0.0;
     double d_FFdTfhc_dV_bi_ci=0.0;
  double FCa=0.0;
     double d_FCa_dV_bi_ei=0.0;
     double d_FCa_dV_bi_ci=0.0;
     double d_FCa_dV_tnode_GND=0.0;
  double FCrt=0.0;
     double d_FCrt_dV_bi_ei=0.0;
     double d_FCrt_dV_bi_ci=0.0;
     double d_FCrt_dV_tnode_GND=0.0;
  double FCa_ck=0.0;
     double d_FCa_ck_dV_bi_ei=0.0;
     double d_FCa_ck_dV_bi_ci=0.0;
     double d_FCa_ck_dV_tnode_GND=0.0;
  double FCdaick_ditf=0.0;
     double d_FCdaick_ditf_dV_bi_ei=0.0;
     double d_FCdaick_ditf_dV_bi_ci=0.0;
     double d_FCdaick_ditf_dV_tnode_GND=0.0;
  double FCz_1=0.0;
     double d_FCz_1_dV_bi_ei=0.0;
     double d_FCz_1_dV_bi_ci=0.0;
     double d_FCz_1_dV_tnode_GND=0.0;
  double FCd_f=0.0;
     double d_FCd_f_dV_bi_ei=0.0;
     double d_FCd_f_dV_bi_ci=0.0;
     double d_FCd_f_dV_tnode_GND=0.0;
  double FCz=0.0;
     double d_FCz_dV_bi_ei=0.0;
     double d_FCz_dV_bi_ci=0.0;
     double d_FCz_dV_tnode_GND=0.0;
  double FCxl=0.0;
  double FCxb=0.0;
  double FCf1=0.0;
     double d_FCf1_dV_bi_ei=0.0;
     double d_FCf1_dV_bi_ci=0.0;
     double d_FCf1_dV_tnode_GND=0.0;
  double FCln=0.0;
  double FCa1=0.0;
     double d_FCa1_dV_bi_ei=0.0;
     double d_FCa1_dV_bi_ci=0.0;
     double d_FCa1_dV_tnode_GND=0.0;
  double FCd_a=0.0;
     double d_FCd_a_dV_bi_ei=0.0;
     double d_FCd_a_dV_bi_ci=0.0;
     double d_FCd_a_dV_tnode_GND=0.0;
  double FCw=0.0;
     double d_FCw_dV_bi_ei=0.0;
     double d_FCw_dV_bi_ci=0.0;
     double d_FCw_dV_tnode_GND=0.0;
  double FCdw_daick=0.0;
     double d_FCdw_daick_dV_bi_ei=0.0;
     double d_FCdw_daick_dV_bi_ci=0.0;
     double d_FCdw_daick_dV_tnode_GND=0.0;
  double FCda1_dw=0.0;
     double d_FCda1_dw_dV_bi_ei=0.0;
     double d_FCda1_dw_dV_bi_ci=0.0;
     double d_FCda1_dw_dV_tnode_GND=0.0;
  double FCf_CT=0.0;
     double d_FCf_CT_dV_bi_ei=0.0;
     double d_FCf_CT_dV_bi_ci=0.0;
     double d_FCf_CT_dV_tnode_GND=0.0;
  double FCw2=0.0;
     double d_FCw2_dV_bi_ei=0.0;
     double d_FCw2_dV_bi_ci=0.0;
     double d_FCw2_dV_tnode_GND=0.0;
  double FCdf1_dw=0.0;
     double d_FCdf1_dw_dV_bi_ei=0.0;
     double d_FCdf1_dw_dV_bi_ci=0.0;
     double d_FCdf1_dw_dV_tnode_GND=0.0;
  double z=0.0;
     double d_z_dV_bi_ei=0.0;
     double d_z_dV_bi_ci=0.0;
     double d_z_dV_tnode_GND=0.0;
  double lnzb=0.0;
     double d_lnzb_dV_bi_ei=0.0;
     double d_lnzb_dV_bi_ci=0.0;
     double d_lnzb_dV_tnode_GND=0.0;
  double x=0.0;
     double d_x_dV_bi_ei=0.0;
     double d_x_dV_bi_ci=0.0;
     double d_x_dV_tnode_GND=0.0;
  double a2=0.0;
     double d_a2_dV_bi_ei=0.0;
     double d_a2_dV_bi_ci=0.0;
     double d_a2_dV_tnode_GND=0.0;
  double a3=0.0;
     double d_a3_dV_bi_ei=0.0;
     double d_a3_dV_bi_ci=0.0;
     double d_a3_dV_tnode_GND=0.0;
  double r=0.0;
  double FCf2=0.0;
     double d_FCf2_dV_bi_ei=0.0;
     double d_FCf2_dV_bi_ci=0.0;
     double d_FCf2_dV_tnode_GND=0.0;
  double FCdf2_dw=0.0;
     double d_FCdf2_dw_dV_bi_ei=0.0;
     double d_FCdf2_dw_dV_bi_ci=0.0;
     double d_FCdf2_dw_dV_tnode_GND=0.0;
  double FCf3=0.0;
     double d_FCf3_dV_bi_ei=0.0;
     double d_FCf3_dV_bi_ci=0.0;
     double d_FCf3_dV_tnode_GND=0.0;
  double FCdf3_dw=0.0;
     double d_FCdf3_dw_dV_bi_ei=0.0;
     double d_FCdf3_dw_dV_bi_ci=0.0;
     double d_FCdf3_dw_dV_tnode_GND=0.0;
  double FCf_ci=0.0;
     double d_FCf_ci_dV_bi_ei=0.0;
     double d_FCf_ci_dV_bi_ci=0.0;
     double d_FCf_ci_dV_tnode_GND=0.0;
  double FCdfc_dw=0.0;
     double d_FCdfc_dw_dV_bi_ei=0.0;
     double d_FCdfc_dw_dV_bi_ci=0.0;
     double d_FCdfc_dw_dV_tnode_GND=0.0;
  double FCdw_ditf=0.0;
     double d_FCdw_ditf_dV_bi_ei=0.0;
     double d_FCdw_ditf_dV_bi_ci=0.0;
     double d_FCdw_ditf_dV_tnode_GND=0.0;
  double FCdfc_ditf=0.0;
     double d_FCdfc_ditf_dV_bi_ei=0.0;
     double d_FCdfc_ditf_dV_bi_ci=0.0;
     double d_FCdfc_ditf_dV_tnode_GND=0.0;
  double lnz=0.0;
     double d_lnz_dV_bi_ei=0.0;
     double d_lnz_dV_bi_ci=0.0;
     double d_lnz_dV_tnode_GND=0.0;
  double FCdfCT_dw=0.0;
     double d_FCdfCT_dw_dV_bi_ei=0.0;
     double d_FCdfCT_dw_dV_bi_ci=0.0;
     double d_FCdfCT_dw_dV_tnode_GND=0.0;
  double FCdfCT_ditf=0.0;
     double d_FCdfCT_ditf_dV_bi_ei=0.0;
     double d_FCdfCT_ditf_dV_bi_ci=0.0;
     double d_FCdfCT_ditf_dV_tnode_GND=0.0;
  double FFdQcfc=0.0;
     double d_FFdQcfc_dV_tnode_GND=0.0;
     double d_FFdQcfc_dV_bi_ei=0.0;
     double d_FFdQcfc_dV_bi_ci=0.0;
  double FFdTcfc=0.0;
     double d_FFdTcfc_dV_tnode_GND=0.0;
     double d_FFdTcfc_dV_bi_ei=0.0;
     double d_FFdTcfc_dV_bi_ci=0.0;
  double FFdQcfcT=0.0;
     double d_FFdQcfcT_dV_tnode_GND=0.0;
     double d_FFdQcfcT_dV_bi_ei=0.0;
     double d_FFdQcfcT_dV_bi_ci=0.0;
  double FFdTcfcT=0.0;
     double d_FFdTcfcT_dV_tnode_GND=0.0;
     double d_FFdTcfcT_dV_bi_ei=0.0;
     double d_FFdTcfcT_dV_bi_ci=0.0;
  double FFdQbfc=0.0;
     double d_FFdQbfc_dV_tnode_GND=0.0;
     double d_FFdQbfc_dV_bi_ei=0.0;
     double d_FFdQbfc_dV_bi_ci=0.0;
  double FFdTbfc=0.0;
     double d_FFdTbfc_dV_tnode_GND=0.0;
     double d_FFdTbfc_dV_bi_ei=0.0;
     double d_FFdTbfc_dV_bi_ci=0.0;
  double Q_fT=0.0;
     double d_Q_fT_dV_tnode_GND=0.0;
     double d_Q_fT_dV_bi_ci=0.0;
     double d_Q_fT_dV_bi_ei=0.0;
  double T_fT=0.0;
     double d_T_fT_dV_bi_ei=0.0;
     double d_T_fT_dV_tnode_GND=0.0;
     double d_T_fT_dV_bi_ci=0.0;
  double Qr=0.0;
     double d_Qr_dV_tnode_GND=0.0;
     double d_Qr_dV_bi_ci=0.0;
     double d_Qr_dV_bi_ei=0.0;
  int l_it=0.0;
  double Q_pT=0.0;
     double d_Q_pT_dV_tnode_GND=0.0;
     double d_Q_pT_dV_bi_ei=0.0;
     double d_Q_pT_dV_bi_ci=0.0;
  double d_Q=0.0;
     double d_d_Q_dV_tnode_GND=0.0;
     double d_d_Q_dV_bi_ei=0.0;
     double d_d_Q_dV_bi_ci=0.0;
  double d_Q0=0.0;
  double Qdei=0.0;
     double d_Qdei_dV_tnode_GND=0.0;
     double d_Qdei_dV_bi_ci=0.0;
     double d_Qdei_dV_bi_ei=0.0;
  double Qdci=0.0;
     double d_Qdci_dV_tnode_GND=0.0;
     double d_Qdci_dV_bi_ci=0.0;
     double d_Qdci_dV_bi_ei=0.0;
  double Cdei=0.0;
     double d_Cdei_dV_tnode_GND=0.0;
     double d_Cdei_dV_bi_ci=0.0;
     double d_Cdei_dV_bi_ei=0.0;
  double Cdci=0.0;
     double d_Cdci_dV_tnode_GND=0.0;
     double d_Cdci_dV_bi_ci=0.0;
     double d_Cdci_dV_bi_ei=0.0;
  double Crbi=0.0;
     double d_Crbi_dV_tnode_GND=0.0;
     double d_Crbi_dV_bi_ei=0.0;
     double d_Crbi_dV_bi_ci=0.0;
  double qrbi=0.0;
     double d_qrbi_dV_tnode_GND=0.0;
     double d_qrbi_dV_bi_ei=0.0;
     double d_qrbi_dV_bi_ci=0.0;
     double d_qrbi_dV_bp_bi=0.0;
  double ibh_rec=0.0;
     double d_ibh_rec_dV_tnode_GND=0.0;
     double d_ibh_rec_dV_bi_ei=0.0;
     double d_ibh_rec_dV_bi_ci=0.0;
  double irep=0.0;
     double d_irep_dV_tnode_GND=0.0;
     double d_irep_dV_bp_ei=0.0;
     double d_irep_dV_bi_ci=0.0;
     double d_irep_dV_bi_ei=0.0;
  double Cjep=0.0;
     double d_Cjep_dV_bp_ei=0.0;
     double d_Cjep_dV_bi_ci=0.0;
     double d_Cjep_dV_tnode_GND=0.0;
     double d_Cjep_dV_bi_ei=0.0;
  double Qjep=0.0;
     double d_Qjep_dV_bp_ei=0.0;
     double d_Qjep_dV_bi_ci=0.0;
     double d_Qjep_dV_tnode_GND=0.0;
     double d_Qjep_dV_bi_ei=0.0;
  double ibet=0.0;
     double d_ibet_dV_bp_ei=0.0;
     double d_ibet_dV_tnode_GND=0.0;
     double d_ibet_dV_bi_ci=0.0;
     double d_ibet_dV_bi_ei=0.0;
  double CjCx_ii=0.0;
  double qjcx0_t_ii=0.0;
     double d_qjcx0_t_ii_dV_bp_ei=0.0;
     double d_qjcx0_t_ii_dV_bi_ei=0.0;
     double d_qjcx0_t_ii_dV_bp_ci=0.0;
     double d_qjcx0_t_ii_dV_tnode_GND=0.0;
     double d_qjcx0_t_ii_dV_bi_ci=0.0;
  double CjCx_i=0.0;
  double qjcx0_t_i=0.0;
     double d_qjcx0_t_i_dV_bp_ei=0.0;
     double d_qjcx0_t_i_dV_bi_ei=0.0;
     double d_qjcx0_t_i_dV_b_ci=0.0;
     double d_qjcx0_t_i_dV_bp_ci=0.0;
     double d_qjcx0_t_i_dV_tnode_GND=0.0;
     double d_qjcx0_t_i_dV_bi_ci=0.0;
  double Cjs=0.0;
  double Qjs=0.0;
     double d_Qjs_dV_bp_ei=0.0;
     double d_Qjs_dV_bi_ei=0.0;
     double d_Qjs_dV_si_ci=0.0;
     double d_Qjs_dV_b_ci=0.0;
     double d_Qjs_dV_bp_ci=0.0;
     double d_Qjs_dV_tnode_GND=0.0;
     double d_Qjs_dV_bi_ci=0.0;
  double Cscp=0.0;
  double Qscp=0.0;
     double d_Qscp_dV_bp_ei=0.0;
     double d_Qscp_dV_bi_ei=0.0;
     double d_Qscp_dV_s_c=0.0;
     double d_Qscp_dV_si_ci=0.0;
     double d_Qscp_dV_b_ci=0.0;
     double d_Qscp_dV_bp_ci=0.0;
     double d_Qscp_dV_tnode_GND=0.0;
     double d_Qscp_dV_bi_ci=0.0;
  double HSUM=0.0;
     double d_HSUM_dV_tnode_GND=0.0;
  double HSa=0.0;
     double d_HSa_dV_bp_ci=0.0;
     double d_HSa_dV_tnode_GND=0.0;
  double HSb=0.0;
     double d_HSb_dV_si_ci=0.0;
     double d_HSb_dV_tnode_GND=0.0;
  double HSI_Tsu=0.0;
     double d_HSI_Tsu_dV_tnode_GND=0.0;
     double d_HSI_Tsu_dV_bp_ci=0.0;
     double d_HSI_Tsu_dV_si_ci=0.0;
  double Qdsu=0.0;
     double d_Qdsu_dV_tnode_GND=0.0;
     double d_Qdsu_dV_bp_ci=0.0;
  double pterm=0.0;
     double d_pterm_dV_b_bp=0.0;
     double d_pterm_dV_ci_c=0.0;
     double d_pterm_dV_ei_e=0.0;
     double d_pterm_dV_bp_bi=0.0;
     double d_pterm_dV_bp_ei=0.0;
     double d_pterm_dV_bp_ci=0.0;
     double d_pterm_dV_si_ci=0.0;
     double d_pterm_dV_bi_ei=0.0;
     double d_pterm_dV_bi_ci=0.0;
     double d_pterm_dV_tnode_GND=0.0;
  double Itxf=0.0;
     double d_Itxf_dV_xf2_GND=0.0;
     double d_Itxf_dV_tnode_GND=0.0;
     double d_Itxf_dV_bi_ei=0.0;
     double d_Itxf_dV_bi_ci=0.0;
  double Qdeix=0.0;
     double d_Qdeix_dV_xf_GND=0.0;
     double d_Qdeix_dV_tnode_GND=0.0;
     double d_Qdeix_dV_bi_ci=0.0;
     double d_Qdeix_dV_bi_ei=0.0;
  double Vxf1=0.0;
     double d_Vxf1_dV_xf1_GND=0.0;
  double Vxf2=0.0;
     double d_Vxf2_dV_xf2_GND=0.0;
  double Ixf1=0.0;
     double d_Ixf1_dV_xf1_GND=0.0;
     double d_Ixf1_dV_xf2_GND=0.0;
     double d_Ixf1_dV_tnode_GND=0.0;
     double d_Ixf1_dV_bi_ei=0.0;
     double d_Ixf1_dV_bi_ci=0.0;
  double Ixf2=0.0;
     double d_Ixf2_dV_xf2_GND=0.0;
     double d_Ixf2_dV_xf1_GND=0.0;
     double d_Ixf2_dV_bi_ei=0.0;
     double d_Ixf2_dV_tnode_GND=0.0;
     double d_Ixf2_dV_bi_ci=0.0;
  double Qxf1=0.0;
     double d_Qxf1_dV_xf1_GND=0.0;
  double Qxf2=0.0;
     double d_Qxf2_dV_xf2_GND=0.0;
  double Vxf=0.0;
     double d_Vxf_dV_xf_GND=0.0;
  double fact=0.0;
     double d_fact_dV_bi_ei=0.0;
     double d_fact_dV_tnode_GND=0.0;
     double d_fact_dV_bi_ci=0.0;
  double Ixf=0.0;
     double d_Ixf_dV_xf_GND=0.0;
     double d_Ixf_dV_tnode_GND=0.0;
     double d_Ixf_dV_bi_ci=0.0;
     double d_Ixf_dV_bi_ei=0.0;
  double Qxf=0.0;
     double d_Qxf_dV_xf_GND=0.0;
  double Vsc=0.0;
     double d_Vsc_dV_s_c=0.0;
  double Vsici=0.0;
     double d_Vsici_dV_si_ci=0.0;
  double Vbci=0.0;
     double d_Vbci_dV_b_ci=0.0;
  double Vbpci=0.0;
     double d_Vbpci_dV_bp_ci=0.0;
  double Vbpei=0.0;
     double d_Vbpei_dV_bp_ei=0.0;
  double Vciei=0.0;
     double d_Vciei_dV_bi_ei=0.0;
     double d_Vciei_dV_bi_ci=0.0;
  double Vbici=0.0;
     double d_Vbici_dV_bi_ci=0.0;
  double Vbiei=0.0;
     double d_Vbiei_dV_bi_ei=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (27))
  {
    probeVars.resize(27);
    d_probeVars.resize(27);
    for (int i=0;i<27;i++)
    {
      d_probeVars[i].resize(27);
      for (int j=0;j<27;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(15+0);
    d_staticContributions.resize(15+0);
    for (int i=0;i<15+0;i++)
      d_staticContributions[i].resize(27);
    dynamicContributions.resize(15+0);
    d_dynamicContributions.resize(15+0);
    for (int i=0;i<15+0;i++)
      d_dynamicContributions[i].resize(27);
  }

    noiseContribsPower.resize(17);
    noiseContribsExponent.resize(17);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 15+0 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<27;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<27;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_ei_GND] = (*solVectorPtr)[li_ei];
d_probeVars[admsProbeID_V_ei_GND][admsProbeID_V_ei_GND] = 1.0;
probeVars[admsProbeID_V_bp_GND] = (*solVectorPtr)[li_bp];
d_probeVars[admsProbeID_V_bp_GND][admsProbeID_V_bp_GND] = 1.0;
probeVars[admsProbeID_V_ci_GND] = (*solVectorPtr)[li_ci];
d_probeVars[admsProbeID_V_ci_GND][admsProbeID_V_ci_GND] = 1.0;
probeVars[admsProbeID_V_bi_GND] = (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_bi_GND][admsProbeID_V_bi_GND] = 1.0;
probeVars[admsProbeID_V_c_e] = (*solVectorPtr)[li_c] - (*solVectorPtr)[li_e];
d_probeVars[admsProbeID_V_c_e][admsProbeID_V_c_e] = 1.0;
probeVars[admsProbeID_V_b_c] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_c];
d_probeVars[admsProbeID_V_b_c][admsProbeID_V_b_c] = 1.0;
probeVars[admsProbeID_V_n2_GND] = (*solVectorPtr)[li_n2];
d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND] = 1.0;
probeVars[admsProbeID_V_n1_GND] = (*solVectorPtr)[li_n1];
d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND] = 1.0;
probeVars[admsProbeID_V_si_s] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s] = 1.0;
probeVars[admsProbeID_V_bp_e] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_e];
d_probeVars[admsProbeID_V_bp_e][admsProbeID_V_bp_e] = 1.0;
probeVars[admsProbeID_V_b_e] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_e];
d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e] = 1.0;
probeVars[admsProbeID_V_ci_ei] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_ei];
d_probeVars[admsProbeID_V_ci_ei][admsProbeID_V_ci_ei] = 1.0;
probeVars[admsProbeID_V_xf_GND] = (*solVectorPtr)[li_xf];
d_probeVars[admsProbeID_V_xf_GND][admsProbeID_V_xf_GND] = 1.0;
probeVars[admsProbeID_V_xf2_GND] = (*solVectorPtr)[li_xf2];
d_probeVars[admsProbeID_V_xf2_GND][admsProbeID_V_xf2_GND] = 1.0;
probeVars[admsProbeID_V_xf1_GND] = (*solVectorPtr)[li_xf1];
d_probeVars[admsProbeID_V_xf1_GND][admsProbeID_V_xf1_GND] = 1.0;
probeVars[admsProbeID_V_b_bp] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_bp];
d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp] = 1.0;
probeVars[admsProbeID_V_ci_c] = (*solVectorPtr)[li_ci] - (*solVectorPtr)[li_c];
d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c] = 1.0;
probeVars[admsProbeID_V_ei_e] = (*solVectorPtr)[li_ei] - (*solVectorPtr)[li_e];
d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e] = 1.0;
probeVars[admsProbeID_V_bp_bi] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_bi];
d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi] = 1.0;
probeVars[admsProbeID_V_tnode_GND] = (*solVectorPtr)[li_tnode];
d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND] = 1.0;
probeVars[admsProbeID_V_s_c] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_c];
d_probeVars[admsProbeID_V_s_c][admsProbeID_V_s_c] = 1.0;
probeVars[admsProbeID_V_si_ci] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_ci];
d_probeVars[admsProbeID_V_si_ci][admsProbeID_V_si_ci] = 1.0;
probeVars[admsProbeID_V_b_ci] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_ci];
d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci] = 1.0;
probeVars[admsProbeID_V_bp_ci] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_ci];
d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci] = 1.0;
probeVars[admsProbeID_V_bp_ei] = (*solVectorPtr)[li_bp] - (*solVectorPtr)[li_ei];
d_probeVars[admsProbeID_V_bp_ei][admsProbeID_V_bp_ei] = 1.0;
probeVars[admsProbeID_V_bi_ci] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ci];
d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci] = 1.0;
probeVars[admsProbeID_V_bi_ei] = (*solVectorPtr)[li_bi] - (*solVectorPtr)[li_ei];
d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei] = 1.0;
// -- code converted from analog/code block

d_Vbiei_dV_bi_ei = (model_.type)*d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei];
Vbiei = ((model_.type)*(probeVars[admsProbeID_V_bi_ei]));

d_Vbici_dV_bi_ci = (model_.type)*d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci];
Vbici = ((model_.type)*(probeVars[admsProbeID_V_bi_ci]));

d_Vciei_dV_bi_ci = (-d_Vbici_dV_bi_ci);
d_Vciei_dV_bi_ei = d_Vbiei_dV_bi_ei;
Vciei = (Vbiei-Vbici);

d_Vbpei_dV_bp_ei = (model_.type)*d_probeVars[admsProbeID_V_bp_ei][admsProbeID_V_bp_ei];
Vbpei = ((model_.type)*(probeVars[admsProbeID_V_bp_ei]));

d_Vbpci_dV_bp_ci = (model_.type)*d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci];
Vbpci = ((model_.type)*(probeVars[admsProbeID_V_bp_ci]));

d_Vbci_dV_b_ci = (model_.type)*d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci];
Vbci = ((model_.type)*(probeVars[admsProbeID_V_b_ci]));

d_Vsici_dV_si_ci = (model_.type)*d_probeVars[admsProbeID_V_si_ci][admsProbeID_V_si_ci];
Vsici = ((model_.type)*(probeVars[admsProbeID_V_si_ci]));

d_Vsc_dV_s_c = (model_.type)*d_probeVars[admsProbeID_V_s_c][admsProbeID_V_s_c];
Vsc = ((model_.type)*(probeVars[admsProbeID_V_s_c]));
if ((((model_.flsh)!=0)&&((model_.rth)>=0.001)))
//Begin block Thermal_update_with_self_heating
{

d_Tdev_dV_tnode_GND = d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND];
Tdev = ((Tamb+(model_.dt))+(probeVars[admsProbeID_V_tnode_GND]));
if ((Tdev<((-100.0)+273.15)))
{

d_Tdev_dV_tnode_GND =  0.0;
Tdev = ((-100.0)+273.15);
}
else
{
if ((Tdev>(326.85+273.15)))
{

d_Tdev_dV_tnode_GND =  0.0;
Tdev = (326.85+273.15);
}
}

d_VT_dV_tnode_GND = (1.3806503e-23*d_Tdev_dV_tnode_GND/1.6021766208e-19);
VT = ((1.3806503e-23*Tdev)/1.6021766208e-19);

d_dT_dV_tnode_GND = d_Tdev_dV_tnode_GND;
dT = (Tdev-Tnom);

d_qtt0_dV_tnode_GND = (d_Tdev_dV_tnode_GND/Tnom);
qtt0 = (Tdev/Tnom);
{
double value_log_0 = log(qtt0);
double  deriv_log_0_d0 = (1.0/qtt0);

d_ln_qtt0_dV_tnode_GND = (deriv_log_0_d0*(d_qtt0_dV_tnode_GND));
ln_qtt0 = value_log_0;
}
{
double value_log_0 = log(Tdev);
double  deriv_log_0_d0 = (1.0/Tdev);

d_k1_dV_tnode_GND = (((model_.f1vg)*Tdev)*(deriv_log_0_d0*(d_Tdev_dV_tnode_GND))+(model_.f1vg)*d_Tdev_dV_tnode_GND*value_log_0);
k1 = (((model_.f1vg)*Tdev)*value_log_0);
}

d_k2_dV_tnode_GND = (model_.f2vg)*d_Tdev_dV_tnode_GND;
k2 = ((model_.f2vg)*Tdev);

d_vgb_t_dV_tnode_GND = (d_k1_dV_tnode_GND+d_k2_dV_tnode_GND);
vgb_t = (((model_.vgb)+k1)+k2);

d_vge_t_dV_tnode_GND = (d_k1_dV_tnode_GND+d_k2_dV_tnode_GND);
vge_t = (((model_.vge)+k1)+k2);

d_vgbe_t_dV_tnode_GND = ((d_vgb_t_dV_tnode_GND+d_vge_t_dV_tnode_GND)/2);
vgbe_t = ((vgb_t+vge_t)/2);
if (((model_.cjei0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdei)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdei))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND = ((vdj0*d_qtt0_dV_tnode_GND+vgbe0*(-d_qtt0_dV_tnode_GND))-((mg*VT)*d_ln_qtt0_dV_tnode_GND+mg*d_VT_dV_tnode_GND*ln_qtt0));
vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+((2*VT)*(deriv_log_2_d0*(0.5*(deriv_sqrt_1_d0*(4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT)))))))+2*d_VT_dV_tnode_GND*value_log_2));
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdei_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
vdei_t = vdt;
{
double value_log_0 = log(((model_.vdei)/vdei_t));
double value_exp_1 = exp(((model_.zei)*value_log_0));
double  deriv_log_0_d0 = (1.0/((model_.vdei)/vdei_t));
double  deriv_exp_1_d0 = value_exp_1;

d_cjei0_t_dV_tnode_GND = (model_.cjei0)*(deriv_exp_1_d0*((model_.zei)*(deriv_log_0_d0*((-(model_.vdei)*d_vdei_t_dV_tnode_GND/vdei_t/vdei_t)))));
cjei0_t = ((model_.cjei0)*value_exp_1);
}
if ((1==1))
{

d_ajei_t_dV_tnode_GND = ((model_.ajei)*d_vdei_t_dV_tnode_GND/(model_.vdei));
ajei_t = (((model_.ajei)*vdei_t)/(model_.vdei));
}
else
{

d_ajei_t_dV_tnode_GND =  0.0;
ajei_t = (model_.ajei);
}
}
else
{

d_cjei0_t_dV_tnode_GND =  0.0;
cjei0_t = (model_.cjei0);

d_vdei_t_dV_tnode_GND =  0.0;
vdei_t = (model_.vdei);

d_ajei_t_dV_tnode_GND =  0.0;
ajei_t = (model_.ajei);
}
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{

d_V_gT_dV_tnode_GND = (((3.0*VT)*d_ln_qtt0_dV_tnode_GND+3.0*d_VT_dV_tnode_GND*ln_qtt0)+(model_.vgb)*d_qtt0_dV_tnode_GND);
V_gT = (((3.0*VT)*ln_qtt0)+((model_.vgb)*(qtt0-1.0)));

d_r_VgVT_dV_tnode_GND = ((VT*d_V_gT_dV_tnode_GND-V_gT*d_VT_dV_tnode_GND)/VT/VT);
r_VgVT = (V_gT/VT);

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (((model_.mcf)*d_r_VgVT_dV_tnode_GND/(model_.mbei))-(model_.alb)*d_dT_dV_tnode_GND);
a = ((((model_.mcf)*r_VgVT)/(model_.mbei))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_ibeis_t_dV_tnode_GND = (model_.ibeis)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
ibeis_t = ((model_.ibeis)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (((model_.mcf)*d_r_VgVT_dV_tnode_GND/(model_.mrei))-(model_.alb)*d_dT_dV_tnode_GND);
a = ((((model_.mcf)*r_VgVT)/(model_.mrei))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_ireis_t_dV_tnode_GND = (model_.ireis)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
ireis_t = ((model_.ireis)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (((model_.mcf)*d_r_VgVT_dV_tnode_GND/(model_.mbep))-(model_.alb)*d_dT_dV_tnode_GND);
a = ((((model_.mcf)*r_VgVT)/(model_.mbep))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_ibeps_t_dV_tnode_GND = (model_.ibeps)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
ibeps_t = ((model_.ibeps)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (((model_.mcf)*d_r_VgVT_dV_tnode_GND/(model_.mrep))-(model_.alb)*d_dT_dV_tnode_GND);
a = ((((model_.mcf)*r_VgVT)/(model_.mrep))-((model_.alb)*dT));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_ireps_t_dV_tnode_GND = (model_.ireps)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
ireps_t = ((model_.ireps)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.mbci));
a = (r_VgVT/(model_.mbci));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_ibcis_t_dV_tnode_GND = (model_.ibcis)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
ibcis_t = ((model_.ibcis)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.mbcx));
a = (r_VgVT/(model_.mbcx));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_ibcxs_t_dV_tnode_GND = (model_.ibcxs)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
ibcxs_t = ((model_.ibcxs)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.msf));
a = (r_VgVT/(model_.msf));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_itss_t_dV_tnode_GND = (model_.itss)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
itss_t = ((model_.itss)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (d_r_VgVT_dV_tnode_GND/(model_.msc));
a = (r_VgVT/(model_.msc));
{
double value_exp_0 = exp(a);
double  deriv_exp_0_d0 = value_exp_0;

d_iscs_t_dV_tnode_GND = (model_.iscs)*(deriv_exp_0_d0*(d_a_dV_tnode_GND));
iscs_t = ((model_.iscs)*value_exp_0);
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (d_vdei_t_dV_tnode_GND/(model_.vdei));
a = (vdei_t/(model_.vdei));

d_qp0_t_dV_tnode_GND = (model_.qp0)*(0.5*(model_.zei))*(-d_a_dV_tnode_GND);
qp0_t = ((model_.qp0)*(1.0+((0.5*(model_.zei))*(1.0-a))));
{
double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (((model_.vlim)*(1.0-((model_.alvs)*dT)))*(deriv_exp_0_d0*((model_.zetaci)*d_ln_qtt0_dV_tnode_GND))+(model_.vlim)*(-(model_.alvs)*d_dT_dV_tnode_GND)*value_exp_0);
a = (((model_.vlim)*(1.0-((model_.alvs)*dT)))*value_exp_0);
}

d_k_dV_tnode_GND = ((VT*(d_a_dV_tnode_GND-d_VT_dV_tnode_GND)-(a-VT)*d_VT_dV_tnode_GND)/VT/VT);
k = ((a-VT)/VT);
if ((k<11.0))
{
{
double value_exp_0 = exp(k);
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_vlim_t_dV_tnode_GND = (d_VT_dV_tnode_GND+(VT*(deriv_log_1_d0*((deriv_exp_0_d0*(d_k_dV_tnode_GND))))+d_VT_dV_tnode_GND*value_log_1));
vlim_t = (VT+(VT*value_log_1));
}
}
else
{

d_vlim_t_dV_tnode_GND = d_a_dV_tnode_GND;
vlim_t = a;
}

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (model_.alb)*d_dT_dV_tnode_GND;
a = (1.0+((model_.alb)*dT));
{
double value_sqrt_0 = sqrt(((a*a)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_k_dV_tnode_GND = 0.5*(d_a_dV_tnode_GND+(deriv_sqrt_0_d0*((a*d_a_dV_tnode_GND+d_a_dV_tnode_GND*a))));
k = (0.5*(a+value_sqrt_0));
}

d_tef0_t_dV_tnode_GND = ((k*(model_.tef0)*d_qtt0_dV_tnode_GND-((model_.tef0)*qtt0)*d_k_dV_tnode_GND)/k/k);
tef0_t = (((model_.tef0)*qtt0)/k);
}
else
{
{
double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ibeis_t_dV_tnode_GND = (model_.ibeis)*(deriv_exp_0_d0*(((model_.zetabet)*d_ln_qtt0_dV_tnode_GND+(((model_.vge)/VT)*d_qtt0_dV_tnode_GND+(-(model_.vge)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
ibeis_t = ((model_.ibeis)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{
{
double value_exp_0 = exp((((mg/(model_.mrei))*ln_qtt0)+((vgbe0/((model_.mrei)*VT))*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ireis_t_dV_tnode_GND = (model_.ireis)*(deriv_exp_0_d0*(((mg/(model_.mrei))*d_ln_qtt0_dV_tnode_GND+((vgbe0/((model_.mrei)*VT))*d_qtt0_dV_tnode_GND+(-vgbe0*(model_.mrei)*d_VT_dV_tnode_GND/((model_.mrei)*VT)/((model_.mrei)*VT))*(qtt0-1)))));
ireis_t = ((model_.ireis)*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ireis_t_dV_tnode_GND = (model_.ireis)*(deriv_exp_0_d0*(((0.5*mg)*d_ln_qtt0_dV_tnode_GND+(((0.5*vgbe0)/VT)*d_qtt0_dV_tnode_GND+(-(0.5*vgbe0)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
ireis_t = ((model_.ireis)*value_exp_0);
}
}
{
double value_exp_0 = exp((((model_.zetabet)*ln_qtt0)+(((model_.vge)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ibeps_t_dV_tnode_GND = (model_.ibeps)*(deriv_exp_0_d0*(((model_.zetabet)*d_ln_qtt0_dV_tnode_GND+(((model_.vge)/VT)*d_qtt0_dV_tnode_GND+(-(model_.vge)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
ibeps_t = ((model_.ibeps)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{
{
double value_exp_0 = exp((((mg/(model_.mrep))*ln_qtt0)+((vgbe0/((model_.mrep)*VT))*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ireps_t_dV_tnode_GND = (model_.ireps)*(deriv_exp_0_d0*(((mg/(model_.mrep))*d_ln_qtt0_dV_tnode_GND+((vgbe0/((model_.mrep)*VT))*d_qtt0_dV_tnode_GND+(-vgbe0*(model_.mrep)*d_VT_dV_tnode_GND/((model_.mrep)*VT)/((model_.mrep)*VT))*(qtt0-1)))));
ireps_t = ((model_.ireps)*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*mg)*ln_qtt0)+(((0.5*vgbe0)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ireps_t_dV_tnode_GND = (model_.ireps)*(deriv_exp_0_d0*(((0.5*mg)*d_ln_qtt0_dV_tnode_GND+(((0.5*vgbe0)/VT)*d_qtt0_dV_tnode_GND+(-(0.5*vgbe0)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
ireps_t = ((model_.ireps)*value_exp_0);
}
}
{
double value_exp_0 = exp(((zetabci*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ibcis_t_dV_tnode_GND = (model_.ibcis)*(deriv_exp_0_d0*((zetabci*d_ln_qtt0_dV_tnode_GND+(((model_.vgc)/VT)*d_qtt0_dV_tnode_GND+(-(model_.vgc)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
ibcis_t = ((model_.ibcis)*value_exp_0);
}
{
double value_exp_0 = exp(((zetabcxt*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_ibcxs_t_dV_tnode_GND = (model_.ibcxs)*(deriv_exp_0_d0*((zetabcxt*d_ln_qtt0_dV_tnode_GND+(((model_.vgc)/VT)*d_qtt0_dV_tnode_GND+(-(model_.vgc)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
ibcxs_t = ((model_.ibcxs)*value_exp_0);
}
{
double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgc)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_itss_t_dV_tnode_GND = (model_.itss)*(deriv_exp_0_d0*((zetasct*d_ln_qtt0_dV_tnode_GND+(((model_.vgc)/VT)*d_qtt0_dV_tnode_GND+(-(model_.vgc)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
itss_t = ((model_.itss)*value_exp_0);
}
{
double value_exp_0 = exp(((zetasct*ln_qtt0)+(((model_.vgs)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_iscs_t_dV_tnode_GND = (model_.iscs)*(deriv_exp_0_d0*((zetasct*d_ln_qtt0_dV_tnode_GND+(((model_.vgs)/VT)*d_qtt0_dV_tnode_GND+(-(model_.vgs)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
iscs_t = ((model_.iscs)*value_exp_0);
}
{
double value_log_0 = log((vdei_t/(model_.vdei)));
double value_exp_1 = exp(((model_.zei)*value_log_0));
double  deriv_log_0_d0 = (1.0/(vdei_t/(model_.vdei)));
double  deriv_exp_1_d0 = value_exp_1;

d_a_dV_bi_ei = d_a_dV_bi_ci =  0.0;
d_a_dV_tnode_GND = (deriv_exp_1_d0*((model_.zei)*(deriv_log_0_d0*((d_vdei_t_dV_tnode_GND/(model_.vdei))))));
a = value_exp_1;
}

d_qp0_t_dV_tnode_GND = (model_.qp0)*(-d_a_dV_tnode_GND);
qp0_t = ((model_.qp0)*(2.0-a));
{
double value_exp_0 = exp((((model_.zetaci)-avs)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_vlim_t_dV_tnode_GND = (model_.vlim)*(deriv_exp_0_d0*(((model_.zetaci)-avs)*d_ln_qtt0_dV_tnode_GND));
vlim_t = ((model_.vlim)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{

d_tef0_t_dV_tnode_GND =  0.0;
tef0_t = (model_.tef0);
}
else
{
zetatef = (((model_.zetabet)-(model_.zetact))-0.5);
dvg0 = ((model_.vgb)-(model_.vge));
{
double value_exp_0 = exp(((zetatef*ln_qtt0)-((dvg0/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_tef0_t_dV_tnode_GND = (model_.tef0)*(deriv_exp_0_d0*((zetatef*d_ln_qtt0_dV_tnode_GND-((dvg0/VT)*d_qtt0_dV_tnode_GND+(-dvg0*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
tef0_t = ((model_.tef0)*value_exp_0);
}
}
}
{
double value_exp_0 = exp((((model_.zetact)*ln_qtt0)+(((model_.vgb)/VT)*(qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;

d_c10_t_dV_tnode_GND = (model_.c10)*(deriv_exp_0_d0*(((model_.zetact)*d_ln_qtt0_dV_tnode_GND+(((model_.vgb)/VT)*d_qtt0_dV_tnode_GND+(-(model_.vgb)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1)))));
c10_t = ((model_.c10)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetaci)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_rci0_t_dV_tnode_GND = (model_.rci0)*(deriv_exp_0_d0*((model_.zetaci)*d_ln_qtt0_dV_tnode_GND));
rci0_t = ((model_.rci0)*value_exp_0);
}

d_vces_t_dV_tnode_GND = (model_.vces)*(model_.alces)*d_dT_dV_tnode_GND;
vces_t = ((model_.vces)*(1+((model_.alces)*dT)));
if (((model_.cjci0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdci)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdci))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND = ((vdj0*d_qtt0_dV_tnode_GND+vgbc0*(-d_qtt0_dV_tnode_GND))-((mg*VT)*d_ln_qtt0_dV_tnode_GND+mg*d_VT_dV_tnode_GND*ln_qtt0));
vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+((2*VT)*(deriv_log_2_d0*(0.5*(deriv_sqrt_1_d0*(4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT)))))))+2*d_VT_dV_tnode_GND*value_log_2));
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdci_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
vdci_t = vdt;
{
double value_log_0 = log(((model_.vdci)/vdci_t));
double value_exp_1 = exp(((model_.zci)*value_log_0));
double  deriv_log_0_d0 = (1.0/((model_.vdci)/vdci_t));
double  deriv_exp_1_d0 = value_exp_1;

d_cjci0_t_dV_tnode_GND = (model_.cjci0)*(deriv_exp_1_d0*((model_.zci)*(deriv_log_0_d0*((-(model_.vdci)*d_vdci_t_dV_tnode_GND/vdci_t/vdci_t)))));
cjci0_t = ((model_.cjci0)*value_exp_1);
}
if ((0==1))
{

d_vptci_t_dV_tnode_GND = ((model_.vptci)*d_vdci_t_dV_tnode_GND/(model_.vdci));
vptci_t = (((model_.vptci)*vdci_t)/(model_.vdci));
}
else
{

d_vptci_t_dV_tnode_GND =  0.0;
vptci_t = (model_.vptci);
}
}
else
{

d_cjci0_t_dV_tnode_GND =  0.0;
cjci0_t = (model_.cjci0);

d_vdci_t_dV_tnode_GND =  0.0;
vdci_t = (model_.vdci);

d_vptci_t_dV_tnode_GND =  0.0;
vptci_t = (model_.vptci);
}

d_t0_t_dV_tnode_GND = (model_.t0)*((model_.alt0)*d_dT_dV_tnode_GND+(((model_.kt0)*dT)*d_dT_dV_tnode_GND+(model_.kt0)*d_dT_dV_tnode_GND*dT));
t0_t = ((model_.t0)*((1+((model_.alt0)*dT))+(((model_.kt0)*dT)*dT)));
{
double value_exp_0 = exp((((model_.zetaci)-1)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_thcs_t_dV_tnode_GND = (model_.thcs)*(deriv_exp_0_d0*(((model_.zetaci)-1)*d_ln_qtt0_dV_tnode_GND));
thcs_t = ((model_.thcs)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.alfav)*dT));
double  deriv_exp_0_d0 = value_exp_0;

d_favl_t_dV_tnode_GND = (model_.favl)*(deriv_exp_0_d0*((model_.alfav)*d_dT_dV_tnode_GND));
favl_t = ((model_.favl)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.alqav)*dT));
double  deriv_exp_0_d0 = value_exp_0;

d_qavl_t_dV_tnode_GND = (model_.qavl)*(deriv_exp_0_d0*((model_.alqav)*d_dT_dV_tnode_GND));
qavl_t = ((model_.qavl)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.alkav)*dT));
double  deriv_exp_0_d0 = value_exp_0;

d_kavl_t_dV_tnode_GND = (model_.kavl)*(deriv_exp_0_d0*((model_.alkav)*d_dT_dV_tnode_GND));
kavl_t = ((model_.kavl)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetarbi)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_rbi0_t_dV_tnode_GND = (model_.rbi0)*(deriv_exp_0_d0*((model_.zetarbi)*d_ln_qtt0_dV_tnode_GND));
rbi0_t = ((model_.rbi0)*value_exp_0);
}
if (((model_.cjep0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdep)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdep))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND = ((vdj0*d_qtt0_dV_tnode_GND+vgbe0*(-d_qtt0_dV_tnode_GND))-((mg*VT)*d_ln_qtt0_dV_tnode_GND+mg*d_VT_dV_tnode_GND*ln_qtt0));
vdjt = (((vdj0*qtt0)+(vgbe0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+((2*VT)*(deriv_log_2_d0*(0.5*(deriv_sqrt_1_d0*(4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT)))))))+2*d_VT_dV_tnode_GND*value_log_2));
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdep_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
vdep_t = vdt;
{
double value_log_0 = log(((model_.vdep)/vdep_t));
double value_exp_1 = exp(((model_.zep)*value_log_0));
double  deriv_log_0_d0 = (1.0/((model_.vdep)/vdep_t));
double  deriv_exp_1_d0 = value_exp_1;

d_cjep0_t_dV_tnode_GND = (model_.cjep0)*(deriv_exp_1_d0*((model_.zep)*(deriv_log_0_d0*((-(model_.vdep)*d_vdep_t_dV_tnode_GND/vdep_t/vdep_t)))));
cjep0_t = ((model_.cjep0)*value_exp_1);
}
if ((1==1))
{

d_ajep_t_dV_tnode_GND = ((model_.ajep)*d_vdep_t_dV_tnode_GND/(model_.vdep));
ajep_t = (((model_.ajep)*vdep_t)/(model_.vdep));
}
else
{

d_ajep_t_dV_tnode_GND =  0.0;
ajep_t = (model_.ajep);
}
}
else
{

d_cjep0_t_dV_tnode_GND =  0.0;
cjep0_t = (model_.cjep0);

d_vdep_t_dV_tnode_GND =  0.0;
vdep_t = (model_.vdep);

d_ajep_t_dV_tnode_GND =  0.0;
ajep_t = (model_.ajep);
}
if ((((model_.ibets)>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
//Begin block HICTUN_T
{
//Block-local variables for block HICTUN_T
double a_eg=0.0;
     double d_a_eg_dV_tnode_GND=0.0;
double ab=0.0;
     double d_ab_dV_tnode_GND=0.0;
double aa=0.0;
     double d_aa_dV_tnode_GND=0.0;
//End of Block-local variables

d_ab_dV_tnode_GND =  0.0;
ab = 1.0;

d_aa_dV_tnode_GND =  0.0;
aa = 1.0;

d_a_eg_dV_tnode_GND = (-vgbe_t0*d_vgbe_t_dV_tnode_GND/vgbe_t/vgbe_t);
a_eg = (vgbe_t0/vgbe_t);
if (((((model_.tunode)==1)&&((model_.cjep0)>0.0))&&((model_.vdep)>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ab_dV_tnode_GND = (((((cjep0_t/(model_.cjep0))*value_sqrt_0)*vdep_t)*d_vdep_t_dV_tnode_GND+(((cjep0_t/(model_.cjep0))*value_sqrt_0)*d_vdep_t_dV_tnode_GND+((cjep0_t/(model_.cjep0))*(deriv_sqrt_0_d0*(d_a_eg_dV_tnode_GND))+(d_cjep0_t_dV_tnode_GND/(model_.cjep0))*value_sqrt_0)*vdep_t)*vdep_t)/((model_.vdep)*(model_.vdep)));
ab = (((((cjep0_t/(model_.cjep0))*value_sqrt_0)*vdep_t)*vdep_t)/((model_.vdep)*(model_.vdep)));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));

d_aa_dV_tnode_GND = ((((model_.vdep)/vdep_t)*((model_.cjep0)/cjep0_t))*(deriv_pow_0_d0*(d_a_eg_dV_tnode_GND))+(((model_.vdep)/vdep_t)*(-(model_.cjep0)*d_cjep0_t_dV_tnode_GND/cjep0_t/cjep0_t)+(-(model_.vdep)*d_vdep_t_dV_tnode_GND/vdep_t/vdep_t)*((model_.cjep0)/cjep0_t))*value_pow_0);
aa = ((((model_.vdep)/vdep_t)*((model_.cjep0)/cjep0_t))*value_pow_0);
}
}
else
{
if (((((model_.tunode)==0)&&((model_.cjei0)>0.0))&&((model_.vdei)>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ab_dV_tnode_GND = (((((cjei0_t/(model_.cjei0))*value_sqrt_0)*vdei_t)*d_vdei_t_dV_tnode_GND+(((cjei0_t/(model_.cjei0))*value_sqrt_0)*d_vdei_t_dV_tnode_GND+((cjei0_t/(model_.cjei0))*(deriv_sqrt_0_d0*(d_a_eg_dV_tnode_GND))+(d_cjei0_t_dV_tnode_GND/(model_.cjei0))*value_sqrt_0)*vdei_t)*vdei_t)/((model_.vdei)*(model_.vdei)));
ab = (((((cjei0_t/(model_.cjei0))*value_sqrt_0)*vdei_t)*vdei_t)/((model_.vdei)*(model_.vdei)));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));

d_aa_dV_tnode_GND = ((((model_.vdei)/vdei_t)*((model_.cjei0)/cjei0_t))*(deriv_pow_0_d0*(d_a_eg_dV_tnode_GND))+(((model_.vdei)/vdei_t)*(-(model_.cjei0)*d_cjei0_t_dV_tnode_GND/cjei0_t/cjei0_t)+(-(model_.vdei)*d_vdei_t_dV_tnode_GND/vdei_t/vdei_t)*((model_.cjei0)/cjei0_t))*value_pow_0);
aa = ((((model_.vdei)/vdei_t)*((model_.cjei0)/cjei0_t))*value_pow_0);
}
}
}

d_ibets_t_dV_tnode_GND = (model_.ibets)*d_ab_dV_tnode_GND;
ibets_t = ((model_.ibets)*ab);

d_abet_t_dV_tnode_GND = (model_.abet)*d_aa_dV_tnode_GND;
abet_t = ((model_.abet)*aa);
}
// End block HICTUN_T
else
{

d_ibets_t_dV_tnode_GND =  0.0;
ibets_t = 0;

d_abet_t_dV_tnode_GND =  0.0;
abet_t = 1;
}
if ((1.0>0.0))
{
{
double value_exp_0 = exp((((model_.vdcx)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdcx))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND = ((vdj0*d_qtt0_dV_tnode_GND+vgbc0*(-d_qtt0_dV_tnode_GND))-((mg*VT)*d_ln_qtt0_dV_tnode_GND+mg*d_VT_dV_tnode_GND*ln_qtt0));
vdjt = (((vdj0*qtt0)+(vgbc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+((2*VT)*(deriv_log_2_d0*(0.5*(deriv_sqrt_1_d0*(4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT)))))))+2*d_VT_dV_tnode_GND*value_log_2));
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdcx_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
vdcx_t = vdt;
{
double value_log_0 = log(((model_.vdcx)/vdcx_t));
double value_exp_1 = exp(((model_.zcx)*value_log_0));
double  deriv_log_0_d0 = (1.0/((model_.vdcx)/vdcx_t));
double  deriv_exp_1_d0 = value_exp_1;

d_cratio_t_dV_tnode_GND = 1.0*(deriv_exp_1_d0*((model_.zcx)*(deriv_log_0_d0*((-(model_.vdcx)*d_vdcx_t_dV_tnode_GND/vdcx_t/vdcx_t)))));
cratio_t = (1.0*value_exp_1);
}
if ((0==1))
{

d_vptcx_t_dV_tnode_GND = ((model_.vptcx)*d_vdcx_t_dV_tnode_GND/(model_.vdcx));
vptcx_t = (((model_.vptcx)*vdcx_t)/(model_.vdcx));
}
else
{

d_vptcx_t_dV_tnode_GND =  0.0;
vptcx_t = (model_.vptcx);
}
}
else
{

d_cratio_t_dV_tnode_GND =  0.0;
cratio_t = 1.0;

d_vdcx_t_dV_tnode_GND =  0.0;
vdcx_t = (model_.vdcx);

d_vptcx_t_dV_tnode_GND =  0.0;
vptcx_t = (model_.vptcx);
}

d_cjcx01_t_dV_tnode_GND = d_cratio_t_dV_tnode_GND*cjcx01;
cjcx01_t = (cratio_t*cjcx01);

d_cjcx02_t_dV_tnode_GND = d_cratio_t_dV_tnode_GND*cjcx02;
cjcx02_t = (cratio_t*cjcx02);
{
double value_exp_0 = exp(((model_.zetarcx)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_rcx_t_dV_tnode_GND = (model_.rcx)*(deriv_exp_0_d0*((model_.zetarcx)*d_ln_qtt0_dV_tnode_GND));
rcx_t = ((model_.rcx)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetarbx)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_rbx_t_dV_tnode_GND = (model_.rbx)*(deriv_exp_0_d0*((model_.zetarbx)*d_ln_qtt0_dV_tnode_GND));
rbx_t = ((model_.rbx)*value_exp_0);
}
{
double value_exp_0 = exp(((model_.zetare)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_re_t_dV_tnode_GND = (model_.re)*(deriv_exp_0_d0*((model_.zetare)*d_ln_qtt0_dV_tnode_GND));
re_t = ((model_.re)*value_exp_0);
}
{
double value_exp_0 = exp((((model_.zetacx)-1.0)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_tsf_t_dV_tnode_GND = (model_.tsf)*(deriv_exp_0_d0*(((model_.zetacx)-1.0)*d_ln_qtt0_dV_tnode_GND));
tsf_t = ((model_.tsf)*value_exp_0);
}
if (((model_.cjs0)>0.0))
{
{
double value_exp_0 = exp((((model_.vds)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vds))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND = ((vdj0*d_qtt0_dV_tnode_GND+vgsc0*(-d_qtt0_dV_tnode_GND))-((mg*VT)*d_ln_qtt0_dV_tnode_GND+mg*d_VT_dV_tnode_GND*ln_qtt0));
vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+((2*VT)*(deriv_log_2_d0*(0.5*(deriv_sqrt_1_d0*(4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT)))))))+2*d_VT_dV_tnode_GND*value_log_2));
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vds_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
vds_t = vdt;
{
double value_log_0 = log(((model_.vds)/vds_t));
double value_exp_1 = exp(((model_.zs)*value_log_0));
double  deriv_log_0_d0 = (1.0/((model_.vds)/vds_t));
double  deriv_exp_1_d0 = value_exp_1;

d_cjs0_t_dV_tnode_GND = (model_.cjs0)*(deriv_exp_1_d0*((model_.zs)*(deriv_log_0_d0*((-(model_.vds)*d_vds_t_dV_tnode_GND/vds_t/vds_t)))));
cjs0_t = ((model_.cjs0)*value_exp_1);
}
if ((0==1))
{

d_vpts_t_dV_tnode_GND = ((model_.vpts)*d_vds_t_dV_tnode_GND/(model_.vds));
vpts_t = (((model_.vpts)*vds_t)/(model_.vds));
}
else
{

d_vpts_t_dV_tnode_GND =  0.0;
vpts_t = (model_.vpts);
}
}
else
{

d_cjs0_t_dV_tnode_GND =  0.0;
cjs0_t = (model_.cjs0);

d_vds_t_dV_tnode_GND =  0.0;
vds_t = (model_.vds);

d_vpts_t_dV_tnode_GND =  0.0;
vpts_t = (model_.vpts);
}
if (((model_.vdsp)>0))
{
if (((model_.cscp0)>0.0))
{
{
double value_exp_0 = exp((((model_.vdsp)*0.5)/vt0));
double value_exp_1 = exp((((-0.5)*(model_.vdsp))/vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
vdj0 = ((2*vt0)*value_log_2);
}

d_vdjt_dV_tnode_GND = ((vdj0*d_qtt0_dV_tnode_GND+vgsc0*(-d_qtt0_dV_tnode_GND))-((mg*VT)*d_ln_qtt0_dV_tnode_GND+mg*d_VT_dV_tnode_GND*ln_qtt0));
vdjt = (((vdj0*qtt0)+(vgsc0*(1-qtt0)))-((mg*VT)*ln_qtt0));
{
double value_exp_0 = exp(((-vdjt)/VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));

d_vdt_dV_tnode_GND = (d_vdjt_dV_tnode_GND+((2*VT)*(deriv_log_2_d0*(0.5*(deriv_sqrt_1_d0*(4*(deriv_exp_0_d0*(((VT*(-d_vdjt_dV_tnode_GND)-(-vdjt)*d_VT_dV_tnode_GND)/VT/VT)))))))+2*d_VT_dV_tnode_GND*value_log_2));
vdt = (vdjt+((2*VT)*value_log_2));
}

d_vdsp_t_dV_tnode_GND = d_vdt_dV_tnode_GND;
vdsp_t = vdt;
{
double value_log_0 = log(((model_.vdsp)/vdsp_t));
double value_exp_1 = exp(((model_.zsp)*value_log_0));
double  deriv_log_0_d0 = (1.0/((model_.vdsp)/vdsp_t));
double  deriv_exp_1_d0 = value_exp_1;

d_cscp0_t_dV_tnode_GND = (model_.cscp0)*(deriv_exp_1_d0*((model_.zsp)*(deriv_log_0_d0*((-(model_.vdsp)*d_vdsp_t_dV_tnode_GND/vdsp_t/vdsp_t)))));
cscp0_t = ((model_.cscp0)*value_exp_1);
}
if ((0==1))
{

d_vptsp_t_dV_tnode_GND = ((model_.vptsp)*d_vdsp_t_dV_tnode_GND/(model_.vdsp));
vptsp_t = (((model_.vptsp)*vdsp_t)/(model_.vdsp));
}
else
{

d_vptsp_t_dV_tnode_GND =  0.0;
vptsp_t = (model_.vptsp);
}
}
else
{

d_cscp0_t_dV_tnode_GND =  0.0;
cscp0_t = (model_.cscp0);

d_vdsp_t_dV_tnode_GND =  0.0;
vdsp_t = (model_.vdsp);

d_vptsp_t_dV_tnode_GND =  0.0;
vptsp_t = (model_.vptsp);
}
}
else
{

d_cscp0_t_dV_tnode_GND =  0.0;
cscp0_t = (model_.cscp0);

d_vdsp_t_dV_tnode_GND =  0.0;
vdsp_t = (model_.vdsp);

d_vptsp_t_dV_tnode_GND =  0.0;
vptsp_t = (model_.vptsp);
}
{
double value_exp_0 = exp(((model_.zetahjei)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_ahjei_t_dV_tnode_GND = (model_.ahjei)*(deriv_exp_0_d0*((model_.zetahjei)*d_ln_qtt0_dV_tnode_GND));
ahjei_t = ((model_.ahjei)*value_exp_0);
}
{
double value_log_0 = log(qtt0);
double value_exp_1 = exp(((model_.zetavgbe)*value_log_0));
double value_exp_2 = exp((((model_.dvgbe)/VT)*(value_exp_1-1)));
double  deriv_log_0_d0 = (1.0/qtt0);
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_exp_2_d0 = value_exp_2;

d_hjei0_t_dV_tnode_GND = (model_.hjei)*(deriv_exp_2_d0*((((model_.dvgbe)/VT)*(deriv_exp_1_d0*((model_.zetavgbe)*(deriv_log_0_d0*(d_qtt0_dV_tnode_GND))))+(-(model_.dvgbe)*d_VT_dV_tnode_GND/VT/VT)*(value_exp_1-1))));
hjei0_t = ((model_.hjei)*value_exp_2);
}
{
double value_exp_0 = exp((((model_.dvgbe)/VT)*(qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;

d_hf0_t_dV_tnode_GND = (model_.hf0)*(deriv_exp_0_d0*((((model_.dvgbe)/VT)*d_qtt0_dV_tnode_GND+(-(model_.dvgbe)*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1))));
hf0_t = ((model_.hf0)*value_exp_0);
}
if (((model_.flcomp)>=2.3))
{
{
double value_exp_0 = exp(((((model_.vgb)-(model_.vge))/VT)*(qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;

d_hfe_t_dV_tnode_GND = (model_.hfe)*(deriv_exp_0_d0*(((((model_.vgb)-(model_.vge))/VT)*d_qtt0_dV_tnode_GND+(-((model_.vgb)-(model_.vge))*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1))));
hfe_t = ((model_.hfe)*value_exp_0);
}
{
double value_exp_0 = exp(((((model_.vgb)-(model_.vgc))/VT)*(qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;

d_hfc_t_dV_tnode_GND = (model_.hfc)*(deriv_exp_0_d0*(((((model_.vgb)-(model_.vgc))/VT)*d_qtt0_dV_tnode_GND+(-((model_.vgb)-(model_.vgc))*d_VT_dV_tnode_GND/VT/VT)*(qtt0-1))));
hfc_t = ((model_.hfc)*value_exp_0);
}
}
else
{

d_hfe_t_dV_tnode_GND =  0.0;
hfe_t = (model_.hfe);

d_hfc_t_dV_tnode_GND =  0.0;
hfc_t = (model_.hfc);
}
{
double value_exp_0 = exp(((model_.zetarth)*ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;

d_rth_t_dV_tnode_GND = (((model_.rth)*value_exp_0)*(model_.alrth)*d_dT_dV_tnode_GND+(model_.rth)*(deriv_exp_0_d0*((model_.zetarth)*d_ln_qtt0_dV_tnode_GND))*(1+((model_.alrth)*dT)));
rth_t = (((model_.rth)*value_exp_0)*(1+((model_.alrth)*dT)));
}
}
// End block Thermal_update_with_self_heating
//Begin block Model_evaluation
{

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci =  0.0;
d_DIOY_dV_tnode_GND = (-Vbiei*(model_.mbei)*d_VT_dV_tnode_GND/((model_.mbei)*VT)/((model_.mbei)*VT));
d_DIOY_dV_bi_ei = (d_Vbiei_dV_bi_ei/((model_.mbei)*VT));
DIOY = (Vbiei/((model_.mbei)*VT));
if (((model_.ibeis)>0.0))
{
if ((DIOY>80.0))
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
le = (1+(DIOY-80.0));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
DIOY = 80.0;
}
else
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
d_le_dV_tnode_GND = (le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND))+d_le_dV_tnode_GND*value_limexp_0);
d_le_dV_bi_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei))+d_le_dV_bi_ei*value_limexp_0);
le = (le*value_limexp_0);
}

d_ibei_dV_bi_ei = ibeis_t*d_le_dV_bi_ei;
d_ibei_dV_tnode_GND = (ibeis_t*d_le_dV_tnode_GND+d_ibeis_t_dV_tnode_GND*(le-1.0));
ibei = (ibeis_t*(le-1.0));
if ((DIOY<=(-14.0)))
{

d_ibei_dV_bi_ei =  0.0;
d_ibei_dV_tnode_GND = (-d_ibeis_t_dV_tnode_GND);
ibei = (-ibeis_t);
}
}
else
{

d_ibei_dV_tnode_GND = d_ibei_dV_bi_ei =  0.0;
ibei = 0.0;
}

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci =  0.0;
d_DIOY_dV_tnode_GND = (-Vbiei*(model_.mrei)*d_VT_dV_tnode_GND/((model_.mrei)*VT)/((model_.mrei)*VT));
d_DIOY_dV_bi_ei = (d_Vbiei_dV_bi_ei/((model_.mrei)*VT));
DIOY = (Vbiei/((model_.mrei)*VT));
if (((model_.ireis)>0.0))
{
if ((DIOY>80.0))
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
le = (1+(DIOY-80.0));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
DIOY = 80.0;
}
else
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci =  0.0;
d_le_dV_tnode_GND = (le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND))+d_le_dV_tnode_GND*value_limexp_0);
d_le_dV_bi_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei))+d_le_dV_bi_ei*value_limexp_0);
le = (le*value_limexp_0);
}

d_irei_dV_bi_ei = ireis_t*d_le_dV_bi_ei;
d_irei_dV_tnode_GND = (ireis_t*d_le_dV_tnode_GND+d_ireis_t_dV_tnode_GND*(le-1.0));
irei = (ireis_t*(le-1.0));
if ((DIOY<=(-14.0)))
{

d_irei_dV_bi_ei =  0.0;
d_irei_dV_tnode_GND = (-d_ireis_t_dV_tnode_GND);
irei = (-ireis_t);
}
}
else
{

d_irei_dV_tnode_GND = d_irei_dV_bi_ei =  0.0;
irei = 0.0;
}

d_Orci0_t_dV_tnode_GND = (-d_rci0_t_dV_tnode_GND/rci0_t/rci0_t);
Orci0_t = (1.0/rci0_t);
Tr = (model_.tr);

d_VT_f_dV_tnode_GND = (model_.mcf)*d_VT_dV_tnode_GND;
VT_f = ((model_.mcf)*VT);
{
double value_limexp_0 = limexp((Vbiei/VT_f));
double  deriv_limexp_0_d0 = ((((Vbiei/VT_f))<80)?(value_limexp_0):exp(80.0));

d_i_0f_dV_bi_ei = c10_t*(deriv_limexp_0_d0*((d_Vbiei_dV_bi_ei/VT_f)));
d_i_0f_dV_tnode_GND = (c10_t*(deriv_limexp_0_d0*((-Vbiei*d_VT_f_dV_tnode_GND/VT_f/VT_f)))+d_c10_t_dV_tnode_GND*value_limexp_0);
i_0f = (c10_t*value_limexp_0);
}
{
double value_limexp_0 = limexp((Vbici/VT));
double  deriv_limexp_0_d0 = ((((Vbici/VT))<80)?(value_limexp_0):exp(80.0));

d_i_0r_dV_bi_ci = c10_t*(deriv_limexp_0_d0*((d_Vbici_dV_bi_ci/VT)));
d_i_0r_dV_tnode_GND = (c10_t*(deriv_limexp_0_d0*((-Vbici*d_VT_dV_tnode_GND/VT/VT)))+d_c10_t_dV_tnode_GND*value_limexp_0);
i_0r = (c10_t*value_limexp_0);
}
if ((cjei0_t>0.0))
{
{
double value_log_0 = log(ajei_t);
double value_exp_1 = exp(((-value_log_0)/(model_.zei)));
double  deriv_log_0_d0 = (1.0/ajei_t);
double  deriv_exp_1_d0 = value_exp_1;

d_DFV_f_dV_tnode_GND = (vdei_t*(-(deriv_exp_1_d0*(((-(deriv_log_0_d0*(d_ajei_t_dV_tnode_GND)))/(model_.zei)))))+d_vdei_t_dV_tnode_GND*(1.0-value_exp_1));
DFV_f = (vdei_t*(1.0-value_exp_1));
}

d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci =  0.0;
d_DFv_e_dV_bi_ei = ((-d_Vbiei_dV_bi_ei)/VT);
d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbiei)*d_VT_dV_tnode_GND)/VT/VT);
DFv_e = ((DFV_f-Vbiei)/VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci = d_DFs_q_dV_bp_ci = d_DFs_q_dV_bp_ei = d_DFs_q_dV_bi_ci =  0.0;
d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ei+d_DFv_e_dV_bi_ei*DFv_e)));
d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_tnode_GND+d_DFv_e_dV_tnode_GND*DFv_e)));
DFs_q = value_sqrt_0;
}

d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci = d_DFs_q2_dV_bp_ci = d_DFs_q2_dV_bp_ei = d_DFs_q2_dV_bi_ci =  0.0;
d_DFs_q2_dV_bi_ei = (d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5;
d_DFs_q2_dV_tnode_GND = (d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);

d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci = d_DFv_j_dV_bp_ci = d_DFv_j_dV_bp_ei = d_DFv_j_dV_bi_ci =  0.0;
d_DFv_j_dV_bi_ei = (-VT*d_DFs_q2_dV_bi_ei);
d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-(VT*d_DFs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*DFs_q2));
DFv_j = (DFV_f-(VT*DFs_q2));

d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci = d_DFdvj_dv_dV_bp_ci = d_DFdvj_dv_dV_bp_ei = d_DFdvj_dv_dV_bi_ci =  0.0;
d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/vdei_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdei_t)));

d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci = d_DFb_dV_bp_ci = d_DFb_dV_bp_ei = d_DFb_dV_bi_ci =  0.0;
d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdei_t))));
d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdei_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdei_t_dV_tnode_GND)/vdei_t/vdei_t))));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-(model_.zei))*DFb));
double  deriv_exp_0_d0 = value_exp_0;

d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci = d_DFC_j1_dV_bp_ci = d_DFC_j1_dV_bp_ei = d_DFC_j1_dV_bi_ci =  0.0;
d_DFC_j1_dV_bi_ei = ((cjei0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei+cjei0_t*(deriv_exp_0_d0*((-(model_.zei))*d_DFb_dV_bi_ei))*DFdvj_dv);
d_DFC_j1_dV_tnode_GND = ((cjei0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND+(cjei0_t*(deriv_exp_0_d0*((-(model_.zei))*d_DFb_dV_tnode_GND))+d_cjei0_t_dV_tnode_GND*value_exp_0)*DFdvj_dv);
DFC_j1 = ((cjei0_t*value_exp_0)*DFdvj_dv);
}

d_Cjei_dV_bi_ei = (d_DFC_j1_dV_bi_ei+(ajei_t*cjei0_t)*(-d_DFdvj_dv_dV_bi_ei));
d_Cjei_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+((ajei_t*cjei0_t)*(-d_DFdvj_dv_dV_tnode_GND)+(ajei_t*d_cjei0_t_dV_tnode_GND+d_ajei_t_dV_tnode_GND*cjei0_t)*(1.0-DFdvj_dv)));
Cjei = (DFC_j1+((ajei_t*cjei0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-(model_.zei))));
double  deriv_exp_0_d0 = value_exp_0;

d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci = d_DFQ_j_dV_bp_ci = d_DFQ_j_dV_bp_ei = d_DFQ_j_dV_bi_ci =  0.0;
d_DFQ_j_dV_bi_ei = ((cjei0_t*vdei_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ei*(1.0-(model_.zei)))))/(1.0-(model_.zei)));
d_DFQ_j_dV_tnode_GND = (((cjei0_t*vdei_t)*(-(deriv_exp_0_d0*(d_DFb_dV_tnode_GND*(1.0-(model_.zei)))))+(cjei0_t*d_vdei_t_dV_tnode_GND+d_cjei0_t_dV_tnode_GND*vdei_t)*(1.0-value_exp_0))/(1.0-(model_.zei)));
DFQ_j = (((cjei0_t*vdei_t)*(1.0-value_exp_0))/(1.0-(model_.zei)));
}

d_Qjei_dV_bi_ei = (d_DFQ_j_dV_bi_ei+(ajei_t*cjei0_t)*(d_Vbiei_dV_bi_ei-d_DFv_j_dV_bi_ei));
d_Qjei_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+((ajei_t*cjei0_t)*(-d_DFv_j_dV_tnode_GND)+(ajei_t*d_cjei0_t_dV_tnode_GND+d_ajei_t_dV_tnode_GND*cjei0_t)*(Vbiei-DFv_j)));
Qjei = (DFQ_j+((ajei_t*cjei0_t)*(Vbiei-DFv_j)));
}
else
{

d_Cjei_dV_tnode_GND = d_Cjei_dV_bi_ei =  0.0;
Cjei = 0.0;

d_Qjei_dV_tnode_GND = d_Qjei_dV_bi_ei =  0.0;
Qjei = 0.0;
}
if (((model_.ahjei)==0.0))
{

d_hjei_vbe_dV_tnode_GND = d_hjei_vbe_dV_bi_ei =  0.0;
hjei_vbe = (model_.hjei);
}
else
{

d_vj_dV_bi_ei = ((-d_Vbiei_dV_bi_ei)/((model_.rhjei)*VT));
d_vj_dV_tnode_GND = ((((model_.rhjei)*VT)*d_vdei_t_dV_tnode_GND-(vdei_t-Vbiei)*(model_.rhjei)*d_VT_dV_tnode_GND)/((model_.rhjei)*VT)/((model_.rhjei)*VT));
vj = ((vdei_t-Vbiei)/((model_.rhjei)*VT));
{
double value_sqrt_0 = sqrt(((vj*vj)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vj_dV_bi_ei = (-((model_.rhjei)*VT)*(d_vj_dV_bi_ei+(deriv_sqrt_0_d0*((vj*d_vj_dV_bi_ei+d_vj_dV_bi_ei*vj))))*0.5);
d_vj_dV_tnode_GND = (d_vdei_t_dV_tnode_GND-(((model_.rhjei)*VT)*(d_vj_dV_tnode_GND+(deriv_sqrt_0_d0*((vj*d_vj_dV_tnode_GND+d_vj_dV_tnode_GND*vj))))+(model_.rhjei)*d_VT_dV_tnode_GND*(vj+value_sqrt_0))*0.5);
vj = (vdei_t-((((model_.rhjei)*VT)*(vj+value_sqrt_0))*0.5));
}

d_vj_dV_bi_ei = (d_vj_dV_bi_ei/VT);
d_vj_dV_tnode_GND = ((VT*(d_vj_dV_tnode_GND-d_VT_dV_tnode_GND)-(vj-VT)*d_VT_dV_tnode_GND)/VT/VT);
vj = ((vj-VT)/VT);
{
double value_sqrt_0 = sqrt(((vj*vj)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vj_dV_bi_ei = VT*(d_vj_dV_bi_ei+(deriv_sqrt_0_d0*((vj*d_vj_dV_bi_ei+d_vj_dV_bi_ei*vj))))*0.5;
d_vj_dV_tnode_GND = (VT*(d_vj_dV_tnode_GND+(deriv_sqrt_0_d0*((vj*d_vj_dV_tnode_GND+d_vj_dV_tnode_GND*vj))))*0.5+d_VT_dV_tnode_GND*(1.0+((vj+value_sqrt_0)*0.5)));
vj = (VT*(1.0+((vj+value_sqrt_0)*0.5)));
}
{
double value_log_0 = log((1.0-(vj/vdei_t)));
double value_exp_1 = exp(((model_.zei)*value_log_0));
double  deriv_log_0_d0 = (1.0/(1.0-(vj/vdei_t)));
double  deriv_exp_1_d0 = value_exp_1;

d_vj_z_dV_bi_ei = (-(deriv_exp_1_d0*((model_.zei)*(deriv_log_0_d0*((-(d_vj_dV_bi_ei/vdei_t)))))))*ahjei_t;
d_vj_z_dV_tnode_GND = ((1.0-value_exp_1)*d_ahjei_t_dV_tnode_GND+(-(deriv_exp_1_d0*((model_.zei)*(deriv_log_0_d0*((-((vdei_t*d_vj_dV_tnode_GND-vj*d_vdei_t_dV_tnode_GND)/vdei_t/vdei_t)))))))*ahjei_t);
vj_z = ((1.0-value_exp_1)*ahjei_t);
}
{
double value_exp_0 = exp(vj_z);
double  deriv_exp_0_d0 = value_exp_0;

d_hjei_vbe_dV_bi_ei = ((vj_z*hjei0_t*(deriv_exp_0_d0*(d_vj_z_dV_bi_ei))-(hjei0_t*(value_exp_0-1.0))*d_vj_z_dV_bi_ei)/vj_z/vj_z);
d_hjei_vbe_dV_tnode_GND = ((vj_z*(hjei0_t*(deriv_exp_0_d0*(d_vj_z_dV_tnode_GND))+d_hjei0_t_dV_tnode_GND*(value_exp_0-1.0))-(hjei0_t*(value_exp_0-1.0))*d_vj_z_dV_tnode_GND)/vj_z/vj_z);
hjei_vbe = ((hjei0_t*(value_exp_0-1.0))/vj_z);
}
}
if ((vptci_t<1.0e2))
{
if ((cjci0_t>0.0))
{
Dz_r = ((model_.zci)/4.0);

d_Dv_p_dV_tnode_GND = (d_vptci_t_dV_tnode_GND-d_vdci_t_dV_tnode_GND);
Dv_p = (vptci_t-vdci_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zci)));

d_DV_f_dV_tnode_GND = d_vdci_t_dV_tnode_GND*(1.0-value_exp_1);
DV_f = (vdci_t*(1.0-value_exp_1));
}

d_DC_max_dV_tnode_GND = 2.4*d_cjci0_t_dV_tnode_GND;
DC_max = (2.4*cjci0_t);
{
double value_log_0 = log((vptci_t/vdci_t));
double value_exp_1 = exp(((Dz_r-(model_.zci))*value_log_0));
double  deriv_log_0_d0 = (1.0/(vptci_t/vdci_t));
double  deriv_exp_1_d0 = value_exp_1;

d_DC_c_dV_tnode_GND = (cjci0_t*(deriv_exp_1_d0*((Dz_r-(model_.zci))*(deriv_log_0_d0*(((vdci_t*d_vptci_t_dV_tnode_GND-vptci_t*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t)))))+d_cjci0_t_dV_tnode_GND*value_exp_1);
DC_c = (cjci0_t*value_exp_1);
}

d_Dv_e_dV_s_c = d_Dv_e_dV_si_ci = d_Dv_e_dV_b_ci = d_Dv_e_dV_bp_ci =  0.0;
d_Dv_e_dV_bi_ci = ((-d_Vbici_dV_bi_ci)/VT);
d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vbici)*d_VT_dV_tnode_GND)/VT/VT);
Dv_e = ((DV_f-Vbici)/VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci = d_De_dV_bp_ci =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
De = value_exp_0;
}

d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci =  0.0;
d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));

d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci =  0.0;
d_Dv_j1_dV_bi_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bi_ci)));
d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-(VT*(deriv_log_0_d0*(d_De_dV_tnode_GND))+d_VT_dV_tnode_GND*value_log_0));
Dv_j1 = (DV_f-(VT*value_log_0));
}
}
else
{

d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
De_1 = 1.0;

d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND =  0.0;
d_Dv_j1_dV_bi_ci = d_Vbici_dV_bi_ci;
Dv_j1 = Vbici;
}

d_Da_dV_tnode_GND = (0.1*d_Dv_p_dV_tnode_GND+4.0*d_VT_dV_tnode_GND);
Da = ((0.1*Dv_p)+(4.0*VT));

d_Dv_r_dV_s_c = d_Dv_r_dV_si_ci = d_Dv_r_dV_b_ci = d_Dv_r_dV_bp_ci =  0.0;
d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci = d_De_dV_bp_ci =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
De = value_exp_0;
}

d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci =  0.0;
d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;

d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci = d_Dv_j2_dV_bp_ci =  0.0;
d_Dv_j2_dV_bi_ci = Da*(deriv_log_0_d0*(d_De_dV_bi_ci));
d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+(Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da))))+d_Da_dV_tnode_GND*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{

d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
De_2 = 1.0;

d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci = d_Dv_j2_dV_bp_ci =  0.0;
d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
Dv_j2 = Dv_j1;
}

d_Dv_j4_dV_s_c = d_Dv_j4_dV_si_ci = d_Dv_j4_dV_b_ci = d_Dv_j4_dV_bp_ci =  0.0;
d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
d_Dv_j4_dV_bi_ci = (d_Vbici_dV_bi_ci-d_Dv_j1_dV_bi_ci);
Dv_j4 = (Vbici-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/vdci_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdci_t)));

d_DCln1_dV_s_c = d_DCln1_dV_si_ci = d_DCln1_dV_b_ci = d_DCln1_dV_bp_ci =  0.0;
d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdci_t))));
d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdci_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/vdci_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdci_t)));

d_DCln2_dV_s_c = d_DCln2_dV_si_ci = d_DCln2_dV_b_ci = d_DCln2_dV_bp_ci =  0.0;
d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdci_t))));
d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdci_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))));
DCln2 = value_log_0;
}
Dz1 = (1.0-(model_.zci));
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-(model_.zci))));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j1_dV_s_c = d_DC_j1_dV_si_ci = d_DC_j1_dV_b_ci = d_DC_j1_dV_bp_ci =  0.0;
d_DC_j1_dV_bi_ci = (((cjci0_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci+((cjci0_t*value_exp_0)*d_De_1_dV_bi_ci+cjci0_t*(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*(-(model_.zci))))*De_1)*De_2);
d_DC_j1_dV_tnode_GND = (((cjci0_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND+((cjci0_t*value_exp_0)*d_De_1_dV_tnode_GND+(cjci0_t*(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*(-(model_.zci))))+d_cjci0_t_dV_tnode_GND*value_exp_0)*De_1)*De_2);
DC_j1 = (((cjci0_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j2_dV_s_c = d_DC_j2_dV_si_ci = d_DC_j2_dV_b_ci = d_DC_j2_dV_bp_ci =  0.0;
d_DC_j2_dV_bi_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_tnode_GND = ((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND)+(DC_c*(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*(-Dz_r)))+d_DC_c_dV_tnode_GND*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}

d_DC_j3_dV_s_c = d_DC_j3_dV_si_ci = d_DC_j3_dV_b_ci = d_DC_j3_dV_bp_ci =  0.0;
d_DC_j3_dV_bi_ci = DC_max*(-d_De_1_dV_bi_ci);
d_DC_j3_dV_tnode_GND = (DC_max*(-d_De_1_dV_tnode_GND)+d_DC_max_dV_tnode_GND*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));

d_Cjci_dV_bi_ei =  0.0;
d_Cjci_dV_bi_ci = ((d_DC_j1_dV_bi_ci+d_DC_j2_dV_bi_ci)+d_DC_j3_dV_bi_ci);
d_Cjci_dV_tnode_GND = ((d_DC_j1_dV_tnode_GND+d_DC_j2_dV_tnode_GND)+d_DC_j3_dV_tnode_GND);
Cjci = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j1_dV_s_c = d_DQ_j1_dV_si_ci = d_DQ_j1_dV_b_ci = d_DQ_j1_dV_bp_ci =  0.0;
d_DQ_j1_dV_bi_ci = (cjci0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dz1)))/Dz1);
d_DQ_j1_dV_tnode_GND = ((cjci0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dz1)))+d_cjci0_t_dV_tnode_GND*(1.0-value_exp_0))/Dz1);
DQ_j1 = ((cjci0_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j2_dV_s_c = d_DQ_j2_dV_si_ci = d_DQ_j2_dV_b_ci = d_DQ_j2_dV_bp_ci =  0.0;
d_DQ_j2_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j3_dV_s_c = d_DQ_j3_dV_si_ci = d_DQ_j3_dV_b_ci = d_DQ_j3_dV_bp_ci =  0.0;
d_DQ_j3_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}

d_Qjci_dV_bi_ei =  0.0;
d_Qjci_dV_bi_ci = (((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdci_t+DC_max*d_Dv_j4_dV_bi_ci);
d_Qjci_dV_tnode_GND = ((((DQ_j1+DQ_j2)-DQ_j3)*d_vdci_t_dV_tnode_GND+((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdci_t)+(DC_max*d_Dv_j4_dV_tnode_GND+d_DC_max_dV_tnode_GND*Dv_j4));
Qjci = ((((DQ_j1+DQ_j2)-DQ_j3)*vdci_t)+(DC_max*Dv_j4));
}
else
{

d_Cjci_dV_bi_ei = d_Cjci_dV_tnode_GND = d_Cjci_dV_bi_ci =  0.0;
Cjci = 0.0;

d_Qjci_dV_bi_ei = d_Qjci_dV_tnode_GND = d_Qjci_dV_bi_ci =  0.0;
Qjci = 0.0;
}
}
else
{
if ((cjci0_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zci)));

d_DFV_f_dV_tnode_GND = d_vdci_t_dV_tnode_GND*(1.0-value_exp_1);
DFV_f = (vdci_t*(1.0-value_exp_1));
}

d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ei =  0.0;
d_DFv_e_dV_bi_ci = ((-d_Vbici_dV_bi_ci)/VT);
d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbici)*d_VT_dV_tnode_GND)/VT/VT);
DFv_e = ((DFV_f-Vbici)/VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci = d_DFs_q_dV_bp_ci = d_DFs_q_dV_bp_ei =  0.0;
d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ei+d_DFv_e_dV_bi_ei*DFv_e)));
d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_tnode_GND+d_DFv_e_dV_tnode_GND*DFv_e)));
d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ci+d_DFv_e_dV_bi_ci*DFv_e)));
DFs_q = value_sqrt_0;
}

d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci = d_DFs_q2_dV_bp_ci = d_DFs_q2_dV_bp_ei =  0.0;
d_DFs_q2_dV_bi_ei = (d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5;
d_DFs_q2_dV_tnode_GND = (d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5;
d_DFs_q2_dV_bi_ci = (d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);

d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci = d_DFv_j_dV_bp_ci = d_DFv_j_dV_bp_ei =  0.0;
d_DFv_j_dV_bi_ei = (-VT*d_DFs_q2_dV_bi_ei);
d_DFv_j_dV_bi_ci = (-VT*d_DFs_q2_dV_bi_ci);
d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-(VT*d_DFs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*DFs_q2));
DFv_j = (DFV_f-(VT*DFs_q2));

d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci = d_DFdvj_dv_dV_bp_ci = d_DFdvj_dv_dV_bp_ei =  0.0;
d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/vdci_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdci_t)));

d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci = d_DFb_dV_bp_ci = d_DFb_dV_bp_ei =  0.0;
d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdci_t))));
d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdci_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))));
d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdci_t))));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-(model_.zci))*DFb));
double  deriv_exp_0_d0 = value_exp_0;

d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci = d_DFC_j1_dV_bp_ci = d_DFC_j1_dV_bp_ei =  0.0;
d_DFC_j1_dV_bi_ei = ((cjci0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei+cjci0_t*(deriv_exp_0_d0*((-(model_.zci))*d_DFb_dV_bi_ei))*DFdvj_dv);
d_DFC_j1_dV_bi_ci = ((cjci0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci+cjci0_t*(deriv_exp_0_d0*((-(model_.zci))*d_DFb_dV_bi_ci))*DFdvj_dv);
d_DFC_j1_dV_tnode_GND = ((cjci0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND+(cjci0_t*(deriv_exp_0_d0*((-(model_.zci))*d_DFb_dV_tnode_GND))+d_cjci0_t_dV_tnode_GND*value_exp_0)*DFdvj_dv);
DFC_j1 = ((cjci0_t*value_exp_0)*DFdvj_dv);
}

d_Cjci_dV_bi_ei = (d_DFC_j1_dV_bi_ei+(2.4*cjci0_t)*(-d_DFdvj_dv_dV_bi_ei));
d_Cjci_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+((2.4*cjci0_t)*(-d_DFdvj_dv_dV_tnode_GND)+2.4*d_cjci0_t_dV_tnode_GND*(1.0-DFdvj_dv)));
d_Cjci_dV_bi_ci = (d_DFC_j1_dV_bi_ci+(2.4*cjci0_t)*(-d_DFdvj_dv_dV_bi_ci));
Cjci = (DFC_j1+((2.4*cjci0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-(model_.zci))));
double  deriv_exp_0_d0 = value_exp_0;

d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci = d_DFQ_j_dV_bp_ci = d_DFQ_j_dV_bp_ei =  0.0;
d_DFQ_j_dV_bi_ei = ((cjci0_t*vdci_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ei*(1.0-(model_.zci)))))/(1.0-(model_.zci)));
d_DFQ_j_dV_bi_ci = ((cjci0_t*vdci_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ci*(1.0-(model_.zci)))))/(1.0-(model_.zci)));
d_DFQ_j_dV_tnode_GND = (((cjci0_t*vdci_t)*(-(deriv_exp_0_d0*(d_DFb_dV_tnode_GND*(1.0-(model_.zci)))))+(cjci0_t*d_vdci_t_dV_tnode_GND+d_cjci0_t_dV_tnode_GND*vdci_t)*(1.0-value_exp_0))/(1.0-(model_.zci)));
DFQ_j = (((cjci0_t*vdci_t)*(1.0-value_exp_0))/(1.0-(model_.zci)));
}

d_Qjci_dV_bi_ei = (d_DFQ_j_dV_bi_ei+(2.4*cjci0_t)*(-d_DFv_j_dV_bi_ei));
d_Qjci_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+((2.4*cjci0_t)*(-d_DFv_j_dV_tnode_GND)+2.4*d_cjci0_t_dV_tnode_GND*(Vbici-DFv_j)));
d_Qjci_dV_bi_ci = (d_DFQ_j_dV_bi_ci+(2.4*cjci0_t)*(d_Vbici_dV_bi_ci-d_DFv_j_dV_bi_ci));
Qjci = (DFQ_j+((2.4*cjci0_t)*(Vbici-DFv_j)));
}
else
{

d_Cjci_dV_bi_ei = d_Cjci_dV_tnode_GND = d_Cjci_dV_bi_ci =  0.0;
Cjci = 0.0;

d_Qjci_dV_bi_ei = d_Qjci_dV_tnode_GND = d_Qjci_dV_bi_ci =  0.0;
Qjci = 0.0;
}
}
a_bpt = 0.05;

d_Q_0_dV_bi_ci = (model_.hjci)*d_Qjci_dV_bi_ci;
d_Q_0_dV_bi_ei = ((hjei_vbe*d_Qjei_dV_bi_ei+d_hjei_vbe_dV_bi_ei*Qjei)+(model_.hjci)*d_Qjci_dV_bi_ei);
d_Q_0_dV_tnode_GND = ((d_qp0_t_dV_tnode_GND+(hjei_vbe*d_Qjei_dV_tnode_GND+d_hjei_vbe_dV_tnode_GND*Qjei))+(model_.hjci)*d_Qjci_dV_tnode_GND);
Q_0 = ((qp0_t+(hjei_vbe*Qjei))+((model_.hjci)*Qjci));

d_Q_bpt_dV_tnode_GND = a_bpt*d_qp0_t_dV_tnode_GND;
Q_bpt = (a_bpt*qp0_t);

d_b_q_dV_bi_ci = (d_Q_0_dV_bi_ci/Q_bpt);
d_b_q_dV_bi_ei = (d_Q_0_dV_bi_ei/Q_bpt);
d_b_q_dV_tnode_GND = ((Q_bpt*d_Q_0_dV_tnode_GND-Q_0*d_Q_bpt_dV_tnode_GND)/Q_bpt/Q_bpt);
b_q = ((Q_0/Q_bpt)-1);
{
double value_sqrt_0 = sqrt(((b_q*b_q)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_0_dV_bi_ci = Q_bpt*((d_b_q_dV_bi_ci+(deriv_sqrt_0_d0*((b_q*d_b_q_dV_bi_ci+d_b_q_dV_bi_ci*b_q))))/2);
d_Q_0_dV_bi_ei = Q_bpt*((d_b_q_dV_bi_ei+(deriv_sqrt_0_d0*((b_q*d_b_q_dV_bi_ei+d_b_q_dV_bi_ei*b_q))))/2);
d_Q_0_dV_tnode_GND = (Q_bpt*((d_b_q_dV_tnode_GND+(deriv_sqrt_0_d0*((b_q*d_b_q_dV_tnode_GND+d_b_q_dV_tnode_GND*b_q))))/2)+d_Q_bpt_dV_tnode_GND*(1+((b_q+value_sqrt_0)/2)));
Q_0 = (Q_bpt*(1+((b_q+value_sqrt_0)/2)));
}
if ((cjci0_t>0.0))
//Begin block CJMODF
{
//Block-local variables for block CJMODF
double cV_f=0.0;
     double d_cV_f_dV_tnode_GND=0.0;
double cv_e=0.0;
     double d_cv_e_dV_tnode_GND=0.0;
     double d_cv_e_dV_bi_ci=0.0;
double cs_q=0.0;
     double d_cs_q_dV_tnode_GND=0.0;
     double d_cs_q_dV_bi_ci=0.0;
double cs_q2=0.0;
     double d_cs_q2_dV_tnode_GND=0.0;
     double d_cs_q2_dV_bi_ci=0.0;
double cv_j=0.0;
     double d_cv_j_dV_tnode_GND=0.0;
     double d_cv_j_dV_bi_ci=0.0;
double cdvj_dv=0.0;
     double d_cdvj_dv_dV_tnode_GND=0.0;
     double d_cdvj_dv_dV_bi_ci=0.0;
//End of Block-local variables
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zci)));

d_cV_f_dV_tnode_GND = d_vdci_t_dV_tnode_GND*(1.0-value_exp_1);
cV_f = (vdci_t*(1.0-value_exp_1));
}

d_cv_e_dV_bi_ci = ((-d_Vbici_dV_bi_ci)/VT);
d_cv_e_dV_tnode_GND = ((VT*d_cV_f_dV_tnode_GND-(cV_f-Vbici)*d_VT_dV_tnode_GND)/VT/VT);
cv_e = ((cV_f-Vbici)/VT);
{
double value_sqrt_0 = sqrt(((cv_e*cv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_cs_q_dV_bi_ci = (deriv_sqrt_0_d0*((cv_e*d_cv_e_dV_bi_ci+d_cv_e_dV_bi_ci*cv_e)));
d_cs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((cv_e*d_cv_e_dV_tnode_GND+d_cv_e_dV_tnode_GND*cv_e)));
cs_q = value_sqrt_0;
}

d_cs_q2_dV_bi_ci = (d_cv_e_dV_bi_ci+d_cs_q_dV_bi_ci)*0.5;
d_cs_q2_dV_tnode_GND = (d_cv_e_dV_tnode_GND+d_cs_q_dV_tnode_GND)*0.5;
cs_q2 = ((cv_e+cs_q)*0.5);

d_cv_j_dV_bi_ci = (-VT*d_cs_q2_dV_bi_ci);
d_cv_j_dV_tnode_GND = (d_cV_f_dV_tnode_GND-(VT*d_cs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*cs_q2));
cv_j = (cV_f-(VT*cs_q2));

d_cdvj_dv_dV_bi_ci = ((cs_q*d_cs_q2_dV_bi_ci-cs_q2*d_cs_q_dV_bi_ci)/cs_q/cs_q);
d_cdvj_dv_dV_tnode_GND = ((cs_q*d_cs_q2_dV_tnode_GND-cs_q2*d_cs_q_dV_tnode_GND)/cs_q/cs_q);
cdvj_dv = (cs_q2/cs_q);
{
double value_log_0 = log((1.0-(cv_j/vdci_t)));
double value_exp_1 = exp(((-(model_.zci))*value_log_0));
double  deriv_log_0_d0 = (1.0/(1.0-(cv_j/vdci_t)));
double  deriv_exp_1_d0 = value_exp_1;

d_Cjcit_dV_bi_ci = (((cjci0_t*value_exp_1)*d_cdvj_dv_dV_bi_ci+cjci0_t*(deriv_exp_1_d0*((-(model_.zci))*(deriv_log_0_d0*((-(d_cv_j_dV_bi_ci/vdci_t))))))*cdvj_dv)+(2.4*cjci0_t)*(-d_cdvj_dv_dV_bi_ci));
d_Cjcit_dV_tnode_GND = (((cjci0_t*value_exp_1)*d_cdvj_dv_dV_tnode_GND+(cjci0_t*(deriv_exp_1_d0*((-(model_.zci))*(deriv_log_0_d0*((-((vdci_t*d_cv_j_dV_tnode_GND-cv_j*d_vdci_t_dV_tnode_GND)/vdci_t/vdci_t))))))+d_cjci0_t_dV_tnode_GND*value_exp_1)*cdvj_dv)+((2.4*cjci0_t)*(-d_cdvj_dv_dV_tnode_GND)+2.4*d_cjci0_t_dV_tnode_GND*(1.0-cdvj_dv)));
Cjcit = (((cjci0_t*value_exp_1)*cdvj_dv)+((2.4*cjci0_t)*(1.0-cdvj_dv)));
}
}
// End block CJMODF
else
{

d_Cjcit_dV_tnode_GND = d_Cjcit_dV_bi_ci =  0.0;
Cjcit = 0.0;
}
if ((Cjcit>0.0))
{

d_cc_dV_bi_ci = (-cjci0_t*d_Cjcit_dV_bi_ci/Cjcit/Cjcit);
d_cc_dV_tnode_GND = ((Cjcit*d_cjci0_t_dV_tnode_GND-cjci0_t*d_Cjcit_dV_tnode_GND)/Cjcit/Cjcit);
cc = (cjci0_t/Cjcit);
}
else
{

d_cc_dV_tnode_GND = d_cc_dV_bi_ci =  0.0;
cc = 1.0;
}

d_T_f0_dV_bi_ci = ((model_.dt0h)*d_cc_dV_bi_ci+(model_.tbvl)*(-1*d_cc_dV_bi_ci/cc/cc));
d_T_f0_dV_tnode_GND = ((d_t0_t_dV_tnode_GND+(model_.dt0h)*d_cc_dV_tnode_GND)+(model_.tbvl)*(-1*d_cc_dV_tnode_GND/cc/cc));
T_f0 = ((t0_t+((model_.dt0h)*(cc-1.0)))+((model_.tbvl)*((1/cc)-1.0)));

d_vc_dV_tnode_GND = (-d_vces_t_dV_tnode_GND);
d_vc_dV_bi_ci = d_Vciei_dV_bi_ci;
d_vc_dV_bi_ei = d_Vciei_dV_bi_ei;
vc = (Vciei-vces_t);
//Begin block HICICK
{
Ovpt = (1.0/(model_.vpt));

d_a_dV_tnode_GND = ((VT*d_vc_dV_tnode_GND-vc*d_VT_dV_tnode_GND)/VT/VT);
d_a_dV_bi_ci = (d_vc_dV_bi_ci/VT);
d_a_dV_bi_ei = (d_vc_dV_bi_ei/VT);
a = (vc/VT);

d_d1_dV_tnode_GND = d_a_dV_tnode_GND;
d_d1_dV_bi_ci = d_a_dV_bi_ci;
d_d1_dV_bi_ei = d_a_dV_bi_ei;
d1 = (a-1);
{
double value_sqrt_0 = sqrt(((d1*d1)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vceff_dV_tnode_GND = ((1.0+((d1+value_sqrt_0)/2))*d_VT_dV_tnode_GND+((d_d1_dV_tnode_GND+(deriv_sqrt_0_d0*((d1*d_d1_dV_tnode_GND+d_d1_dV_tnode_GND*d1))))/2)*VT);
d_vceff_dV_bi_ci = ((d_d1_dV_bi_ci+(deriv_sqrt_0_d0*((d1*d_d1_dV_bi_ci+d_d1_dV_bi_ci*d1))))/2)*VT;
d_vceff_dV_bi_ei = ((d_d1_dV_bi_ei+(deriv_sqrt_0_d0*((d1*d_d1_dV_bi_ei+d_d1_dV_bi_ei*d1))))/2)*VT;
vceff = ((1.0+((d1+value_sqrt_0)/2))*VT);
}

d_a1_dV_tnode_GND = ((vlim_t*d_vceff_dV_tnode_GND-vceff*d_vlim_t_dV_tnode_GND)/vlim_t/vlim_t);
d_a1_dV_bi_ci = (d_vceff_dV_bi_ci/vlim_t);
d_a1_dV_bi_ei = (d_vceff_dV_bi_ei/vlim_t);
a1 = (vceff/vlim_t);

d_a11_dV_tnode_GND = (vceff*d_Orci0_t_dV_tnode_GND+d_vceff_dV_tnode_GND*Orci0_t);
d_a11_dV_bi_ci = d_vceff_dV_bi_ci*Orci0_t;
d_a11_dV_bi_ei = d_vceff_dV_bi_ei*Orci0_t;
a11 = (vceff*Orci0_t);
Odelck = (1/(model_.delck));
{
double value_log_0 = log(a1);
double value_exp_1 = exp(((model_.delck)*value_log_0));
double value_log_2 = log((1+value_exp_1));
double value_exp_3 = exp((Odelck*value_log_2));
double  deriv_log_0_d0 = (1.0/a1);
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(1+value_exp_1));
double  deriv_exp_3_d0 = value_exp_3;

d_ick1_dV_tnode_GND = (deriv_exp_3_d0*(Odelck*(deriv_log_2_d0*((deriv_exp_1_d0*((model_.delck)*(deriv_log_0_d0*(d_a1_dV_tnode_GND))))))));
d_ick1_dV_bi_ci = (deriv_exp_3_d0*(Odelck*(deriv_log_2_d0*((deriv_exp_1_d0*((model_.delck)*(deriv_log_0_d0*(d_a1_dV_bi_ci))))))));
d_ick1_dV_bi_ei = (deriv_exp_3_d0*(Odelck*(deriv_log_2_d0*((deriv_exp_1_d0*((model_.delck)*(deriv_log_0_d0*(d_a1_dV_bi_ei))))))));
ick1 = value_exp_3;
}

d_ick2_dV_tnode_GND = ((ick1*d_a11_dV_tnode_GND-a11*d_ick1_dV_tnode_GND)/ick1/ick1);
d_ick2_dV_bi_ci = ((ick1*d_a11_dV_bi_ci-a11*d_ick1_dV_bi_ci)/ick1/ick1);
d_ick2_dV_bi_ei = ((ick1*d_a11_dV_bi_ei-a11*d_ick1_dV_bi_ei)/ick1/ick1);
ick2 = (a11/ick1);

d_ICKa_dV_tnode_GND = (d_vceff_dV_tnode_GND-d_vlim_t_dV_tnode_GND)*Ovpt;
d_ICKa_dV_bi_ci = d_vceff_dV_bi_ci*Ovpt;
d_ICKa_dV_bi_ei = d_vceff_dV_bi_ei*Ovpt;
ICKa = ((vceff-vlim_t)*Ovpt);
{
double value_sqrt_0 = sqrt(((ICKa*ICKa)+(model_.aick)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ick_dV_tnode_GND = (ick2*0.5*(d_ICKa_dV_tnode_GND+(deriv_sqrt_0_d0*((ICKa*d_ICKa_dV_tnode_GND+d_ICKa_dV_tnode_GND*ICKa))))+d_ick2_dV_tnode_GND*(1.0+(0.5*(ICKa+value_sqrt_0))));
d_ick_dV_bi_ci = (ick2*0.5*(d_ICKa_dV_bi_ci+(deriv_sqrt_0_d0*((ICKa*d_ICKa_dV_bi_ci+d_ICKa_dV_bi_ci*ICKa))))+d_ick2_dV_bi_ci*(1.0+(0.5*(ICKa+value_sqrt_0))));
d_ick_dV_bi_ei = (ick2*0.5*(d_ICKa_dV_bi_ei+(deriv_sqrt_0_d0*((ICKa*d_ICKa_dV_bi_ei+d_ICKa_dV_bi_ei*ICKa))))+d_ick2_dV_bi_ei*(1.0+(0.5*(ICKa+value_sqrt_0))));
ick = (ick2*(1.0+(0.5*(ICKa+value_sqrt_0))));
}
}
// End block HICICK

d_Q_p_dV_bi_ci = d_Q_0_dV_bi_ci;
d_Q_p_dV_bi_ei = d_Q_0_dV_bi_ei;
d_Q_p_dV_tnode_GND = d_Q_0_dV_tnode_GND;
Q_p = Q_0;
if (((T_f0>0.0)||(Tr>0.0)))
{

d_A_dV_bi_ci = 0.5*d_Q_0_dV_bi_ci;
d_A_dV_bi_ei = 0.5*d_Q_0_dV_bi_ei;
d_A_dV_tnode_GND = 0.5*d_Q_0_dV_tnode_GND;
A = (0.5*Q_0);
{
double value_sqrt_0 = sqrt((((A*A)+(T_f0*i_0f))+(Tr*i_0r)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_p_dV_bi_ci = (d_A_dV_bi_ci+(deriv_sqrt_0_d0*((((A*d_A_dV_bi_ci+d_A_dV_bi_ci*A)+d_T_f0_dV_bi_ci*i_0f)+Tr*d_i_0r_dV_bi_ci))));
d_Q_p_dV_bi_ei = (d_A_dV_bi_ei+(deriv_sqrt_0_d0*(((A*d_A_dV_bi_ei+d_A_dV_bi_ei*A)+T_f0*d_i_0f_dV_bi_ei))));
d_Q_p_dV_tnode_GND = (d_A_dV_tnode_GND+(deriv_sqrt_0_d0*((((A*d_A_dV_tnode_GND+d_A_dV_tnode_GND*A)+(T_f0*d_i_0f_dV_tnode_GND+d_T_f0_dV_tnode_GND*i_0f))+Tr*d_i_0r_dV_tnode_GND))));
Q_p = (A+value_sqrt_0);
}
}

d_I_Tf1_dV_bi_ci = (-i_0f*d_Q_p_dV_bi_ci/Q_p/Q_p);
d_I_Tf1_dV_bi_ei = ((Q_p*d_i_0f_dV_bi_ei-i_0f*d_Q_p_dV_bi_ei)/Q_p/Q_p);
d_I_Tf1_dV_tnode_GND = ((Q_p*d_i_0f_dV_tnode_GND-i_0f*d_Q_p_dV_tnode_GND)/Q_p/Q_p);
I_Tf1 = (i_0f/Q_p);

d_a_h_dV_bi_ci = Oich*d_I_Tf1_dV_bi_ci;
d_a_h_dV_bi_ei = Oich*d_I_Tf1_dV_bi_ei;
d_a_h_dV_tnode_GND = Oich*d_I_Tf1_dV_tnode_GND;
a_h = (Oich*I_Tf1);

d_itf_dV_bi_ci = (I_Tf1*d_a_h_dV_bi_ci+d_I_Tf1_dV_bi_ci*(1.0+a_h));
d_itf_dV_bi_ei = (I_Tf1*d_a_h_dV_bi_ei+d_I_Tf1_dV_bi_ei*(1.0+a_h));
d_itf_dV_tnode_GND = (I_Tf1*d_a_h_dV_tnode_GND+d_I_Tf1_dV_tnode_GND*(1.0+a_h));
itf = (I_Tf1*(1.0+a_h));

d_itr_dV_bi_ei = (-i_0r*d_Q_p_dV_bi_ei/Q_p/Q_p);
d_itr_dV_bi_ci = ((Q_p*d_i_0r_dV_bi_ci-i_0r*d_Q_p_dV_bi_ci)/Q_p/Q_p);
d_itr_dV_tnode_GND = ((Q_p*d_i_0r_dV_tnode_GND-i_0r*d_Q_p_dV_tnode_GND)/Q_p/Q_p);
itr = (i_0r/Q_p);

d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
Q_bf = 0.0;

d_Tf_dV_bi_ei =  0.0;
d_Tf_dV_bi_ci = d_T_f0_dV_bi_ci;
d_Tf_dV_tnode_GND = d_T_f0_dV_tnode_GND;
Tf = T_f0;

d_Qf_dV_bi_ei = T_f0*d_itf_dV_bi_ei;
d_Qf_dV_bi_ci = (T_f0*d_itf_dV_bi_ci+d_T_f0_dV_bi_ci*itf);
d_Qf_dV_tnode_GND = (T_f0*d_itf_dV_tnode_GND+d_T_f0_dV_tnode_GND*itf);
Qf = (T_f0*itf);
if ((itf<(1.0e-6*ick)))
{

d_Q_fT_dV_bi_ei = d_Qf_dV_bi_ei;
d_Q_fT_dV_bi_ci = d_Qf_dV_bi_ci;
d_Q_fT_dV_tnode_GND = d_Qf_dV_tnode_GND;
Q_fT = Qf;

d_T_fT_dV_bi_ei =  0.0;
d_T_fT_dV_bi_ci = d_Tf_dV_bi_ci;
d_T_fT_dV_tnode_GND = d_Tf_dV_tnode_GND;
T_fT = Tf;

d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
Q_bf = 0;
}
else
{

d_FFitf_ick_dV_bi_ci = ((ick*d_itf_dV_bi_ci-itf*d_ick_dV_bi_ci)/ick/ick);
d_FFitf_ick_dV_bi_ei = ((ick*d_itf_dV_bi_ei-itf*d_ick_dV_bi_ei)/ick/ick);
d_FFitf_ick_dV_tnode_GND = ((ick*d_itf_dV_tnode_GND-itf*d_ick_dV_tnode_GND)/ick/ick);
FFitf_ick = (itf/ick);
{
double value_log_0 = log(FFitf_ick);
double value_exp_1 = exp(((model_.gtfe)*value_log_0));
double  deriv_log_0_d0 = (1.0/FFitf_ick);
double  deriv_exp_1_d0 = value_exp_1;

d_FFdTef_dV_bi_ci = tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ci))));
d_FFdTef_dV_bi_ei = tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ei))));
d_FFdTef_dV_tnode_GND = (tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_tnode_GND))))+d_tef0_t_dV_tnode_GND*value_exp_1);
FFdTef = (tef0_t*value_exp_1);
}

d_FFdQef_dV_bi_ci = ((FFdTef*d_itf_dV_bi_ci+d_FFdTef_dV_bi_ci*itf)/(1+(model_.gtfe)));
d_FFdQef_dV_bi_ei = ((FFdTef*d_itf_dV_bi_ei+d_FFdTef_dV_bi_ei*itf)/(1+(model_.gtfe)));
d_FFdQef_dV_tnode_GND = ((FFdTef*d_itf_dV_tnode_GND+d_FFdTef_dV_tnode_GND*itf)/(1+(model_.gtfe)));
FFdQef = ((FFdTef*itf)/(1+(model_.gtfe)));
if (((model_.icbar)<(0.05*((model_.vlim)/(model_.rci0)))))
{

d_FFdVc_dV_tnode_GND = d_FFdVc_dV_bi_ei = d_FFdVc_dV_bi_ci =  0.0;
FFdVc = 0;

d_FFdVc_ditf_dV_tnode_GND = d_FFdVc_ditf_dV_bi_ei = d_FFdVc_ditf_dV_bi_ci =  0.0;
FFdVc_ditf = 0;
}
else
{

d_FFib_dV_bi_ci = ((d_itf_dV_bi_ci-d_ick_dV_bi_ci)/(model_.icbar));
d_FFib_dV_bi_ei = ((d_itf_dV_bi_ei-d_ick_dV_bi_ei)/(model_.icbar));
d_FFib_dV_tnode_GND = ((d_itf_dV_tnode_GND-d_ick_dV_tnode_GND)/(model_.icbar));
FFib = ((itf-ick)/(model_.icbar));
if ((FFib<(-1.0e10)))
{

d_FFib_dV_tnode_GND = d_FFib_dV_bi_ei = d_FFib_dV_bi_ci =  0.0;
FFib = (-1.0e10);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFfcbar_dV_bi_ci = ((d_FFib_dV_bi_ci+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ci+d_FFib_dV_bi_ci*FFib))))/2.0);
d_FFfcbar_dV_bi_ei = ((d_FFib_dV_bi_ei+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ei+d_FFib_dV_bi_ei*FFib))))/2.0);
d_FFfcbar_dV_tnode_GND = ((d_FFib_dV_tnode_GND+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_tnode_GND+d_FFib_dV_tnode_GND*FFib))))/2.0);
FFfcbar = ((FFib+value_sqrt_0)/2.0);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFdib_ditf_dV_bi_ci = (((value_sqrt_0*d_FFfcbar_dV_bi_ci-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ci+d_FFib_dV_bi_ci*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
d_FFdib_ditf_dV_bi_ei = (((value_sqrt_0*d_FFfcbar_dV_bi_ei-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ei+d_FFib_dV_bi_ei*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
d_FFdib_ditf_dV_tnode_GND = (((value_sqrt_0*d_FFfcbar_dV_tnode_GND-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_tnode_GND+d_FFib_dV_tnode_GND*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
FFdib_ditf = ((FFfcbar/value_sqrt_0)/(model_.icbar));
}
{
double value_exp_0 = exp(((-1.0)/FFfcbar));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdVc_dV_bi_ci = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ci/FFfcbar/FFfcbar)));
d_FFdVc_dV_bi_ei = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ei/FFfcbar/FFfcbar)));
d_FFdVc_dV_tnode_GND = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_tnode_GND/FFfcbar/FFfcbar)));
FFdVc = ((model_.vcbar)*value_exp_0);
}

d_FFdVc_ditf_dV_bi_ci = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ci+(((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ci-FFdVc*(FFfcbar*d_FFfcbar_dV_bi_ci+d_FFfcbar_dV_bi_ci*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
d_FFdVc_ditf_dV_bi_ei = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ei+(((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ei-FFdVc*(FFfcbar*d_FFfcbar_dV_bi_ei+d_FFfcbar_dV_bi_ei*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
d_FFdVc_ditf_dV_tnode_GND = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_tnode_GND+(((FFfcbar*FFfcbar)*d_FFdVc_dV_tnode_GND-FFdVc*(FFfcbar*d_FFfcbar_dV_tnode_GND+d_FFfcbar_dV_tnode_GND*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
}
{
double value_exp_0 = exp((FFdVc/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQbfb_dV_bi_ci = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci*(value_exp_0-1));
d_FFdQbfb_dV_bi_ei = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei*(value_exp_0-1));
d_FFdQbfb_dV_tnode_GND = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT)))+(((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND+(1-(model_.fthc))*d_thcs_t_dV_tnode_GND*itf)*(value_exp_0-1));
FFdQbfb = ((((1-(model_.fthc))*thcs_t)*itf)*(value_exp_0-1));
}
{
double value_exp_0 = exp((FFdVc/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTbfb_dV_bi_ci = (((itf*d_FFdQbfb_dV_bi_ci-FFdQbfb*d_itf_dV_bi_ci)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ci+(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci*value_exp_0)/VT)*FFdVc_ditf));
d_FFdTbfb_dV_bi_ei = (((itf*d_FFdQbfb_dV_bi_ei-FFdQbfb*d_itf_dV_bi_ei)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ei+(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei*value_exp_0)/VT)*FFdVc_ditf));
d_FFdTbfb_dV_tnode_GND = (((itf*d_FFdQbfb_dV_tnode_GND-FFdQbfb*d_itf_dV_tnode_GND)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT)))+(((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND+(1-(model_.fthc))*d_thcs_t_dV_tnode_GND*itf)*value_exp_0)-((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTbfb = ((FFdQbfb/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*FFdVc_ditf));
}

d_FFic_dV_bi_ci = (-(-d_FFitf_ick_dV_bi_ci/FFitf_ick/FFitf_ick));
d_FFic_dV_bi_ei = (-(-d_FFitf_ick_dV_bi_ei/FFitf_ick/FFitf_ick));
d_FFic_dV_tnode_GND = (-(-d_FFitf_ick_dV_tnode_GND/FFitf_ick/FFitf_ick));
FFic = (1-(1.0/FFitf_ick));
{
double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
double value_sqrt_1 = sqrt((1+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFw_dV_bi_ci = ((d_FFic_dV_bi_ci+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ci+d_FFic_dV_bi_ci*FFic))))/(1+value_sqrt_1));
d_FFw_dV_bi_ei = ((d_FFic_dV_bi_ei+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ei+d_FFic_dV_bi_ei*FFic))))/(1+value_sqrt_1));
d_FFw_dV_tnode_GND = ((d_FFic_dV_tnode_GND+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_tnode_GND+d_FFic_dV_tnode_GND*FFic))))/(1+value_sqrt_1));
FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQfhc_dV_bi_ci = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_bi_ci+((thcs_t*itf)*d_FFw_dV_bi_ci+thcs_t*d_itf_dV_bi_ci*FFw)*FFw)*value_exp_0);
d_FFdQfhc_dV_bi_ei = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_bi_ei+((thcs_t*itf)*d_FFw_dV_bi_ei+thcs_t*d_itf_dV_bi_ei*FFw)*FFw)*value_exp_0);
d_FFdQfhc_dV_tnode_GND = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_tnode_GND+((thcs_t*itf)*d_FFw_dV_tnode_GND+(thcs_t*d_itf_dV_tnode_GND+d_thcs_t_dV_tnode_GND*itf)*FFw)*FFw)*value_exp_0);
FFdQfhc = ((((thcs_t*itf)*FFw)*FFw)*value_exp_0);
}
{
double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFdTfhc_dV_bi_ci = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ci+d_FFic_dV_bi_ci*FFic)))+d_FFitf_ick_dV_bi_ci*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_bi_ci/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+(1.0/VT)*d_FFdVc_ditf_dV_bi_ci)+d_FFdQfhc_dV_bi_ci*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
d_FFdTfhc_dV_bi_ei = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ei+d_FFic_dV_bi_ei*FFic)))+d_FFitf_ick_dV_bi_ei*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_bi_ei/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+(1.0/VT)*d_FFdVc_ditf_dV_bi_ei)+d_FFdQfhc_dV_bi_ei*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
d_FFdTfhc_dV_tnode_GND = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_tnode_GND+d_FFic_dV_tnode_GND*FFic)))+d_FFitf_ick_dV_tnode_GND*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_tnode_GND/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*d_FFdVc_ditf_dV_tnode_GND+(-d_VT_dV_tnode_GND/VT/VT)*FFdVc_ditf))+d_FFdQfhc_dV_tnode_GND*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
}
if ((((model_.latb)<=0.0)&&((model_.latl)<=0.0)))
{

d_FFdQcfc_dV_bi_ci = (model_.fthc)*d_FFdQfhc_dV_bi_ci;
d_FFdQcfc_dV_bi_ei = (model_.fthc)*d_FFdQfhc_dV_bi_ei;
d_FFdQcfc_dV_tnode_GND = (model_.fthc)*d_FFdQfhc_dV_tnode_GND;
FFdQcfc = ((model_.fthc)*FFdQfhc);

d_FFdTcfc_dV_bi_ci = (model_.fthc)*d_FFdTfhc_dV_bi_ci;
d_FFdTcfc_dV_bi_ei = (model_.fthc)*d_FFdTfhc_dV_bi_ei;
d_FFdTcfc_dV_tnode_GND = (model_.fthc)*d_FFdTfhc_dV_tnode_GND;
FFdTcfc = ((model_.fthc)*FFdTfhc);

d_FFdQcfcT_dV_bi_ci = d_FFdQcfc_dV_bi_ci;
d_FFdQcfcT_dV_bi_ei = d_FFdQcfc_dV_bi_ei;
d_FFdQcfcT_dV_tnode_GND = d_FFdQcfc_dV_tnode_GND;
FFdQcfcT = FFdQcfc;

d_FFdTcfcT_dV_bi_ci = d_FFdTcfc_dV_bi_ci;
d_FFdTcfcT_dV_bi_ei = d_FFdTcfc_dV_bi_ei;
d_FFdTcfcT_dV_tnode_GND = d_FFdTcfc_dV_tnode_GND;
FFdTcfcT = FFdTcfc;
}
else
{

d_FFdQcfc_dV_bi_ci = ((model_.fthc)*thcs_t)*d_itf_dV_bi_ci;
d_FFdQcfc_dV_bi_ei = ((model_.fthc)*thcs_t)*d_itf_dV_bi_ei;
d_FFdQcfc_dV_tnode_GND = (((model_.fthc)*thcs_t)*d_itf_dV_tnode_GND+(model_.fthc)*d_thcs_t_dV_tnode_GND*itf);
FFdQcfc = (((model_.fthc)*thcs_t)*itf);

d_FCa_dV_tnode_GND = (-((itf*d_ick_dV_tnode_GND-ick*d_itf_dV_tnode_GND)/itf/itf));
d_FCa_dV_bi_ci = (-((itf*d_ick_dV_bi_ci-ick*d_itf_dV_bi_ci)/itf/itf));
d_FCa_dV_bi_ei = (-((itf*d_ick_dV_bi_ei-ick*d_itf_dV_bi_ei)/itf/itf));
FCa = (1.0-(ick/itf));
{
double value_sqrt_0 = sqrt(((FCa*FCa)+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FCrt_dV_tnode_GND = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_tnode_GND+d_FCa_dV_tnode_GND*FCa)));
d_FCrt_dV_bi_ci = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_bi_ci+d_FCa_dV_bi_ci*FCa)));
d_FCrt_dV_bi_ei = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_bi_ei+d_FCa_dV_bi_ei*FCa)));
FCrt = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((1.0+(model_.ahc)));

d_FCa_ck_dV_tnode_GND = (-((d_FCa_dV_tnode_GND+d_FCrt_dV_tnode_GND)/(1.0+value_sqrt_0)));
d_FCa_ck_dV_bi_ci = (-((d_FCa_dV_bi_ci+d_FCrt_dV_bi_ci)/(1.0+value_sqrt_0)));
d_FCa_ck_dV_bi_ei = (-((d_FCa_dV_bi_ei+d_FCrt_dV_bi_ei)/(1.0+value_sqrt_0)));
FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
}

d_FCdaick_ditf_dV_tnode_GND = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_tnode_GND)+d_FCa_ck_dV_tnode_GND*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_tnode_GND+d_FCrt_dV_tnode_GND*itf))/(FCrt*itf)/(FCrt*itf));
d_FCdaick_ditf_dV_bi_ci = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_bi_ci)+d_FCa_ck_dV_bi_ci*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_bi_ci+d_FCrt_dV_bi_ci*itf))/(FCrt*itf)/(FCrt*itf));
d_FCdaick_ditf_dV_bi_ei = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_bi_ei)+d_FCa_ck_dV_bi_ei*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_bi_ei+d_FCrt_dV_bi_ei*itf))/(FCrt*itf)/(FCrt*itf));
FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
if (((model_.latb)>(model_.latl)))
{

d_FCz_dV_bi_ei = d_FCz_dV_bi_ci = d_FCz_dV_tnode_GND =  0.0;
FCz = ((model_.latb)-(model_.latl));
FCxl = (1.0+(model_.latl));
FCxb = (1.0+(model_.latb));
if (((model_.latb)>0.01))
{
{
double value_log_0 = log((FCxb/FCxl));
FCln = value_log_0;
}
{
double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
double  deriv_exp_0_d0 = value_exp_0;

d_FCa1_dV_tnode_GND = (deriv_exp_0_d0*(d_FCa_ck_dV_tnode_GND*FCln));
d_FCa1_dV_bi_ci = (deriv_exp_0_d0*(d_FCa_ck_dV_bi_ci*FCln));
d_FCa1_dV_bi_ei = (deriv_exp_0_d0*(d_FCa_ck_dV_bi_ei*FCln));
FCa1 = value_exp_0;
}

d_FCd_a_dV_tnode_GND = (-(-d_FCa1_dV_tnode_GND*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
d_FCd_a_dV_bi_ci = (-(-d_FCa1_dV_bi_ci*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
d_FCd_a_dV_bi_ei = (-(-d_FCa1_dV_bi_ei*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
FCd_a = (1.0/((model_.latl)-(FCa1*(model_.latb))));

d_FCw_dV_tnode_GND = ((FCa1-1.0)*d_FCd_a_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCd_a);
d_FCw_dV_bi_ci = ((FCa1-1.0)*d_FCd_a_dV_bi_ci+d_FCa1_dV_bi_ci*FCd_a);
d_FCw_dV_bi_ei = ((FCa1-1.0)*d_FCd_a_dV_bi_ei+d_FCa1_dV_bi_ei*FCd_a);
FCw = ((FCa1-1.0)*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_tnode_GND+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_tnode_GND+((-FCz)*d_FCa1_dV_tnode_GND+(-d_FCz_dV_tnode_GND)*FCa1)*FCln*FCd_a)*FCd_a);
d_FCdw_daick_dV_bi_ci = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ci+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ci+((-FCz)*d_FCa1_dV_bi_ci+(-d_FCz_dV_bi_ci)*FCa1)*FCln*FCd_a)*FCd_a);
d_FCdw_daick_dV_bi_ei = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ei+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ei+((-FCz)*d_FCa1_dV_bi_ei+(-d_FCz_dV_bi_ei)*FCa1)*FCln*FCd_a)*FCd_a);
FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
{
double value_log_0 = log(((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));
double  deriv_log_0_d0 = (1.0/((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));

d_FCa1_dV_tnode_GND = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_tnode_GND-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_tnode_GND)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
d_FCa1_dV_bi_ci = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_bi_ci-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_bi_ci)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
d_FCa1_dV_bi_ei = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_bi_ei-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_bi_ei)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
FCa1 = value_log_0;
}

d_FCda1_dw_dV_tnode_GND = ((-(model_.latb)*(model_.latb)*d_FCw_dV_tnode_GND/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_tnode_GND/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
d_FCda1_dw_dV_bi_ci = ((-(model_.latb)*(model_.latb)*d_FCw_dV_bi_ci/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_bi_ci/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
d_FCda1_dw_dV_bi_ei = ((-(model_.latb)*(model_.latb)*d_FCw_dV_bi_ei/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_bi_ei/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
FCda1_dw = (((model_.latb)/(1.0+((model_.latb)*FCw)))-((model_.latl)/(1.0+((model_.latl)*FCw))));
}
else
{

d_FCf1_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND);
d_FCf1_dV_bi_ci = (-d_FCa_ck_dV_bi_ci);
d_FCf1_dV_bi_ei = (-d_FCa_ck_dV_bi_ei);
FCf1 = (1.0-FCa_ck);

d_FCd_a_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ci = (-d_FCa_ck_dV_bi_ci*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ei = (-d_FCa_ck_dV_bi_ei*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

d_FCw_dV_tnode_GND = (FCf1*d_FCd_a_dV_tnode_GND+d_FCf1_dV_tnode_GND*FCd_a);
d_FCw_dV_bi_ci = (FCf1*d_FCd_a_dV_bi_ci+d_FCf1_dV_bi_ci*FCd_a);
d_FCw_dV_bi_ei = (FCf1*d_FCd_a_dV_bi_ei+d_FCf1_dV_bi_ei*FCd_a);
FCw = (FCf1*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_tnode_GND+(((-1.0)*FCd_a)*d_FCd_a_dV_tnode_GND+(-1.0)*d_FCd_a_dV_tnode_GND*FCd_a)*FCxb*FCd_a);
d_FCdw_daick_dV_bi_ci = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ci+(((-1.0)*FCd_a)*d_FCd_a_dV_bi_ci+(-1.0)*d_FCd_a_dV_bi_ci*FCd_a)*FCxb*FCd_a);
d_FCdw_daick_dV_bi_ei = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ei+(((-1.0)*FCd_a)*d_FCd_a_dV_bi_ei+(-1.0)*d_FCd_a_dV_bi_ei*FCd_a)*FCxb*FCd_a);
FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);

d_FCa1_dV_tnode_GND = (FCz*d_FCw_dV_tnode_GND+d_FCz_dV_tnode_GND*FCw);
d_FCa1_dV_bi_ci = (FCz*d_FCw_dV_bi_ci+d_FCz_dV_bi_ci*FCw);
d_FCa1_dV_bi_ei = (FCz*d_FCw_dV_bi_ei+d_FCz_dV_bi_ei*FCw);
FCa1 = (FCz*FCw);

d_FCda1_dw_dV_bi_ei = d_FCda1_dw_dV_bi_ci = d_FCda1_dw_dV_tnode_GND =  0.0;
FCda1_dw = FCz;
}

d_FCf_CT_dV_bi_ei = d_FCf_CT_dV_bi_ci = d_FCf_CT_dV_tnode_GND =  0.0;
FCf_CT = (2.0/FCz);

d_FCw2_dV_tnode_GND = (FCw*d_FCw_dV_tnode_GND+d_FCw_dV_tnode_GND*FCw);
d_FCw2_dV_bi_ci = (FCw*d_FCw_dV_bi_ci+d_FCw_dV_bi_ci*FCw);
d_FCw2_dV_bi_ei = (FCw*d_FCw_dV_bi_ei+d_FCw_dV_bi_ei*FCw);
FCw2 = (FCw*FCw);

d_FCf1_dV_tnode_GND = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_tnode_GND+((model_.latb)*(model_.latl))*d_FCw_dV_tnode_GND*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_tnode_GND/2.0))+d_FCw_dV_tnode_GND);
d_FCf1_dV_bi_ci = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ci+((model_.latb)*(model_.latl))*d_FCw_dV_bi_ci*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ci/2.0))+d_FCw_dV_bi_ci);
d_FCf1_dV_bi_ei = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ei+((model_.latb)*(model_.latl))*d_FCw_dV_bi_ei*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ei/2.0))+d_FCw_dV_bi_ei);
FCf1 = (((((((model_.latb)*(model_.latl))*FCw)*FCw2)/3.0)+((((model_.latb)+(model_.latl))*FCw2)/2.0))+FCw);

d_FCdf1_dw_dV_tnode_GND = (((model_.latb)*(model_.latl))*d_FCw2_dV_tnode_GND+((model_.latb)+(model_.latl))*d_FCw_dV_tnode_GND);
d_FCdf1_dw_dV_bi_ci = (((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ci+((model_.latb)+(model_.latl))*d_FCw_dV_bi_ci);
d_FCdf1_dw_dV_bi_ei = (((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ei+((model_.latb)+(model_.latl))*d_FCw_dV_bi_ei);
FCdf1_dw = (((((model_.latb)*(model_.latl))*FCw2)+(((model_.latb)+(model_.latl))*FCw))+1.0);

d_z_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_z_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_z_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
z = ((model_.latb)*FCw);
{
double value_log_0 = log((1+((model_.latb)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

d_lnzb_dV_tnode_GND = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_tnode_GND));
d_lnzb_dV_bi_ci = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ci));
d_lnzb_dV_bi_ei = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ei));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{

d_x_dV_tnode_GND = d_z_dV_tnode_GND;
d_x_dV_bi_ci = d_z_dV_bi_ci;
d_x_dV_bi_ei = d_z_dV_bi_ei;
x = (1.0+z);

d_a_dV_tnode_GND = (x*d_x_dV_tnode_GND+d_x_dV_tnode_GND*x);
d_a_dV_bi_ci = (x*d_x_dV_bi_ci+d_x_dV_bi_ci*x);
d_a_dV_bi_ei = (x*d_x_dV_bi_ei+d_x_dV_bi_ei*x);
a = (x*x);

d_a2_dV_tnode_GND = 0.250*(a*2.0*d_lnzb_dV_tnode_GND+d_a_dV_tnode_GND*((2.0*lnzb)-1.0));
d_a2_dV_bi_ci = 0.250*(a*2.0*d_lnzb_dV_bi_ci+d_a_dV_bi_ci*((2.0*lnzb)-1.0));
d_a2_dV_bi_ei = 0.250*(a*2.0*d_lnzb_dV_bi_ei+d_a_dV_bi_ei*((2.0*lnzb)-1.0));
a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

d_a3_dV_tnode_GND = (((a*x)*3.0*d_lnzb_dV_tnode_GND+(a*d_x_dV_tnode_GND+d_a_dV_tnode_GND*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ci = (((a*x)*3.0*d_lnzb_dV_bi_ci+(a*d_x_dV_bi_ci+d_a_dV_bi_ci*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ei = (((a*x)*3.0*d_lnzb_dV_bi_ei+(a*d_x_dV_bi_ei+d_a_dV_bi_ei*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
r = ((model_.latl)/(model_.latb));

d_FCf2_dV_tnode_GND = (((1.0-r)*d_a2_dV_tnode_GND+r*d_a3_dV_tnode_GND)/(model_.latb));
d_FCf2_dV_bi_ci = (((1.0-r)*d_a2_dV_bi_ci+r*d_a3_dV_bi_ci)/(model_.latb));
d_FCf2_dV_bi_ei = (((1.0-r)*d_a2_dV_bi_ei+r*d_a3_dV_bi_ei)/(model_.latb));
FCf2 = ((((1.0-r)*a2)+(r*a3))/(model_.latb));

d_FCdf2_dw_dV_tnode_GND = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND+((1.0-r)*d_x_dV_tnode_GND+r*d_a_dV_tnode_GND)*lnzb);
d_FCdf2_dw_dV_bi_ci = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci+((1.0-r)*d_x_dV_bi_ci+r*d_a_dV_bi_ci)*lnzb);
d_FCdf2_dw_dV_bi_ei = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei+((1.0-r)*d_x_dV_bi_ei+r*d_a_dV_bi_ei)*lnzb);
FCdf2_dw = ((((1.0-r)*x)+(r*a))*lnzb);
}
else
{

d_a_dV_tnode_GND = (z*d_z_dV_tnode_GND+d_z_dV_tnode_GND*z);
d_a_dV_bi_ci = (z*d_z_dV_bi_ci+d_z_dV_bi_ci*z);
d_a_dV_bi_ei = (z*d_z_dV_bi_ei+d_z_dV_bi_ei*z);
a = (z*z);

d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-0.25*d_a_dV_tnode_GND)+((0.10*z)*d_a_dV_tnode_GND+0.10*d_z_dV_tnode_GND*a));
d_a2_dV_bi_ci = ((d_z_dV_bi_ci-0.25*d_a_dV_bi_ci)+((0.10*z)*d_a_dV_bi_ci+0.10*d_z_dV_bi_ci*a));
d_a2_dV_bi_ei = ((d_z_dV_bi_ei-0.25*d_a_dV_bi_ei)+((0.10*z)*d_a_dV_bi_ei+0.10*d_z_dV_bi_ei*a));
a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

d_a3_dV_tnode_GND = ((2.0*d_z_dV_tnode_GND+0.75*d_a_dV_tnode_GND)-((0.20*a)*d_z_dV_tnode_GND+0.20*d_a_dV_tnode_GND*z));
d_a3_dV_bi_ci = ((2.0*d_z_dV_bi_ci+0.75*d_a_dV_bi_ci)-((0.20*a)*d_z_dV_bi_ci+0.20*d_a_dV_bi_ci*z));
d_a3_dV_bi_ei = ((2.0*d_z_dV_bi_ei+0.75*d_a_dV_bi_ei)-((0.20*a)*d_z_dV_bi_ei+0.20*d_a_dV_bi_ei*z));
a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

d_FCf2_dV_tnode_GND = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_tnode_GND+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_tnode_GND+((model_.latb)*d_a2_dV_tnode_GND+(model_.latl)*d_a3_dV_tnode_GND)*FCw)*FCw)/6.0);
d_FCf2_dV_bi_ci = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ci+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ci+((model_.latb)*d_a2_dV_bi_ci+(model_.latl)*d_a3_dV_bi_ci)*FCw)*FCw)/6.0);
d_FCf2_dV_bi_ei = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ei+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ei+((model_.latb)*d_a2_dV_bi_ei+(model_.latl)*d_a3_dV_bi_ei)*FCw)*FCw)/6.0);
FCf2 = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*FCw)/6.0);

d_FCdf2_dw_dV_tnode_GND = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_tnode_GND+((1+((model_.latl)*FCw))*d_z_dV_tnode_GND+(model_.latl)*d_FCw_dV_tnode_GND*(1+z))*lnzb);
d_FCdf2_dw_dV_bi_ci = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ci+((1+((model_.latl)*FCw))*d_z_dV_bi_ci+(model_.latl)*d_FCw_dV_bi_ci*(1+z))*lnzb);
d_FCdf2_dw_dV_bi_ei = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ei+((1+((model_.latl)*FCw))*d_z_dV_bi_ei+(model_.latl)*d_FCw_dV_bi_ei*(1+z))*lnzb);
FCdf2_dw = (((1+((model_.latl)*FCw))*(1+z))*lnzb);
}

d_z_dV_tnode_GND = (model_.latl)*d_FCw_dV_tnode_GND;
d_z_dV_bi_ci = (model_.latl)*d_FCw_dV_bi_ci;
d_z_dV_bi_ei = (model_.latl)*d_FCw_dV_bi_ei;
z = ((model_.latl)*FCw);
{
double value_log_0 = log((1+((model_.latl)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

d_lnzb_dV_tnode_GND = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_tnode_GND));
d_lnzb_dV_bi_ci = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ci));
d_lnzb_dV_bi_ei = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ei));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{

d_x_dV_tnode_GND = d_z_dV_tnode_GND;
d_x_dV_bi_ci = d_z_dV_bi_ci;
d_x_dV_bi_ei = d_z_dV_bi_ei;
x = (1.0+z);

d_a_dV_tnode_GND = (x*d_x_dV_tnode_GND+d_x_dV_tnode_GND*x);
d_a_dV_bi_ci = (x*d_x_dV_bi_ci+d_x_dV_bi_ci*x);
d_a_dV_bi_ei = (x*d_x_dV_bi_ei+d_x_dV_bi_ei*x);
a = (x*x);

d_a2_dV_tnode_GND = 0.250*(a*2.0*d_lnzb_dV_tnode_GND+d_a_dV_tnode_GND*((2.0*lnzb)-1.0));
d_a2_dV_bi_ci = 0.250*(a*2.0*d_lnzb_dV_bi_ci+d_a_dV_bi_ci*((2.0*lnzb)-1.0));
d_a2_dV_bi_ei = 0.250*(a*2.0*d_lnzb_dV_bi_ei+d_a_dV_bi_ei*((2.0*lnzb)-1.0));
a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

d_a3_dV_tnode_GND = (((a*x)*3.0*d_lnzb_dV_tnode_GND+(a*d_x_dV_tnode_GND+d_a_dV_tnode_GND*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ci = (((a*x)*3.0*d_lnzb_dV_bi_ci+(a*d_x_dV_bi_ci+d_a_dV_bi_ci*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ei = (((a*x)*3.0*d_lnzb_dV_bi_ei+(a*d_x_dV_bi_ei+d_a_dV_bi_ei*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
r = ((model_.latb)/(model_.latl));

d_FCf3_dV_tnode_GND = (((1.0-r)*d_a2_dV_tnode_GND+r*d_a3_dV_tnode_GND)/(model_.latl));
d_FCf3_dV_bi_ci = (((1.0-r)*d_a2_dV_bi_ci+r*d_a3_dV_bi_ci)/(model_.latl));
d_FCf3_dV_bi_ei = (((1.0-r)*d_a2_dV_bi_ei+r*d_a3_dV_bi_ei)/(model_.latl));
FCf3 = ((((1.0-r)*a2)+(r*a3))/(model_.latl));

d_FCdf3_dw_dV_tnode_GND = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND+((1.0-r)*d_x_dV_tnode_GND+r*d_a_dV_tnode_GND)*lnzb);
d_FCdf3_dw_dV_bi_ci = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci+((1.0-r)*d_x_dV_bi_ci+r*d_a_dV_bi_ci)*lnzb);
d_FCdf3_dw_dV_bi_ei = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei+((1.0-r)*d_x_dV_bi_ei+r*d_a_dV_bi_ei)*lnzb);
FCdf3_dw = ((((1.0-r)*x)+(r*a))*lnzb);
}
else
{

d_a_dV_tnode_GND = (z*d_z_dV_tnode_GND+d_z_dV_tnode_GND*z);
d_a_dV_bi_ci = (z*d_z_dV_bi_ci+d_z_dV_bi_ci*z);
d_a_dV_bi_ei = (z*d_z_dV_bi_ei+d_z_dV_bi_ei*z);
a = (z*z);

d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-0.25*d_a_dV_tnode_GND)+((0.10*z)*d_a_dV_tnode_GND+0.10*d_z_dV_tnode_GND*a));
d_a2_dV_bi_ci = ((d_z_dV_bi_ci-0.25*d_a_dV_bi_ci)+((0.10*z)*d_a_dV_bi_ci+0.10*d_z_dV_bi_ci*a));
d_a2_dV_bi_ei = ((d_z_dV_bi_ei-0.25*d_a_dV_bi_ei)+((0.10*z)*d_a_dV_bi_ei+0.10*d_z_dV_bi_ei*a));
a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

d_a3_dV_tnode_GND = ((2.0*d_z_dV_tnode_GND+0.75*d_a_dV_tnode_GND)-((0.20*a)*d_z_dV_tnode_GND+0.20*d_a_dV_tnode_GND*z));
d_a3_dV_bi_ci = ((2.0*d_z_dV_bi_ci+0.75*d_a_dV_bi_ci)-((0.20*a)*d_z_dV_bi_ci+0.20*d_a_dV_bi_ci*z));
d_a3_dV_bi_ei = ((2.0*d_z_dV_bi_ei+0.75*d_a_dV_bi_ei)-((0.20*a)*d_z_dV_bi_ei+0.20*d_a_dV_bi_ei*z));
a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

d_FCf3_dV_tnode_GND = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_tnode_GND+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_tnode_GND+((model_.latl)*d_a2_dV_tnode_GND+(model_.latb)*d_a3_dV_tnode_GND)*FCw)*FCw)/6.0);
d_FCf3_dV_bi_ci = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ci+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ci+((model_.latl)*d_a2_dV_bi_ci+(model_.latb)*d_a3_dV_bi_ci)*FCw)*FCw)/6.0);
d_FCf3_dV_bi_ei = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ei+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ei+((model_.latl)*d_a2_dV_bi_ei+(model_.latb)*d_a3_dV_bi_ei)*FCw)*FCw)/6.0);
FCf3 = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*FCw)/6.0);

d_FCdf3_dw_dV_tnode_GND = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_tnode_GND+((1+((model_.latb)*FCw))*d_z_dV_tnode_GND+(model_.latb)*d_FCw_dV_tnode_GND*(1+z))*lnzb);
d_FCdf3_dw_dV_bi_ci = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ci+((1+((model_.latb)*FCw))*d_z_dV_bi_ci+(model_.latb)*d_FCw_dV_bi_ci*(1+z))*lnzb);
d_FCdf3_dw_dV_bi_ei = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ei+((1+((model_.latb)*FCw))*d_z_dV_bi_ei+(model_.latb)*d_FCw_dV_bi_ei*(1+z))*lnzb);
FCdf3_dw = (((1+((model_.latb)*FCw))*(1+z))*lnzb);
}

d_FCf_ci_dV_tnode_GND = (FCf_CT*(((FCa1*d_FCf1_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCf1)-d_FCf2_dV_tnode_GND)+d_FCf3_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCf_ci_dV_bi_ci = (FCf_CT*(((FCa1*d_FCf1_dV_bi_ci+d_FCa1_dV_bi_ci*FCf1)-d_FCf2_dV_bi_ci)+d_FCf3_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCf_ci_dV_bi_ei = (FCf_CT*(((FCa1*d_FCf1_dV_bi_ei+d_FCa1_dV_bi_ei*FCf1)-d_FCf2_dV_bi_ei)+d_FCf3_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(((FCa1*FCf1)-FCf2)+FCf3));
FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));

d_FCdfc_dw_dV_tnode_GND = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_tnode_GND+d_FCda1_dw_dV_tnode_GND*FCf1))-d_FCdf2_dw_dV_tnode_GND)+d_FCdf3_dw_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdfc_dw_dV_bi_ci = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_bi_ci+d_FCa1_dV_bi_ci*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_bi_ci+d_FCda1_dw_dV_bi_ci*FCf1))-d_FCdf2_dw_dV_bi_ci)+d_FCdf3_dw_dV_bi_ci)+d_FCf_CT_dV_bi_ci*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdfc_dw_dV_bi_ei = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_bi_ei+d_FCa1_dV_bi_ei*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_bi_ei+d_FCda1_dw_dV_bi_ei*FCf1))-d_FCdf2_dw_dV_bi_ei)+d_FCdf3_dw_dV_bi_ei)+d_FCf_CT_dV_bi_ei*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));

d_FCdw_ditf_dV_tnode_GND = (FCdw_daick*d_FCdaick_ditf_dV_tnode_GND+d_FCdw_daick_dV_tnode_GND*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ci = (FCdw_daick*d_FCdaick_ditf_dV_bi_ci+d_FCdw_daick_dV_bi_ci*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ei = (FCdw_daick*d_FCdaick_ditf_dV_bi_ei+d_FCdw_daick_dV_bi_ei*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);

d_FCdfc_ditf_dV_tnode_GND = (FCdfc_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfc_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ci = (FCdfc_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfc_dw_dV_bi_ci*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ei = (FCdfc_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfc_dw_dV_bi_ei*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{

d_a_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_a_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_a_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
a = ((model_.latb)*FCw);
{
double value_log_0 = log((1+((model_.latb)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

d_lnz_dV_tnode_GND = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_tnode_GND));
d_lnz_dV_bi_ci = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ci));
d_lnz_dV_bi_ei = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ei));
lnz = value_log_0;
}
if ((a>1.0e-6))
{

d_FCf2_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latb));
d_FCf2_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latb));
d_FCf2_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latb));
FCf2 = ((a-lnz)/(model_.latb));

d_FCdf2_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
d_FCdf2_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
d_FCdf2_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
FCdf2_dw = (a/(1.0+a));
}
else
{

d_FCf2_dV_tnode_GND = ((0.5*a)*d_FCw_dV_tnode_GND+0.5*d_a_dV_tnode_GND*FCw);
d_FCf2_dV_bi_ci = ((0.5*a)*d_FCw_dV_bi_ci+0.5*d_a_dV_bi_ci*FCw);
d_FCf2_dV_bi_ei = ((0.5*a)*d_FCw_dV_bi_ei+0.5*d_a_dV_bi_ei*FCw);
FCf2 = ((0.5*a)*FCw);

d_FCdf2_dw_dV_tnode_GND = d_a_dV_tnode_GND;
d_FCdf2_dw_dV_bi_ci = d_a_dV_bi_ci;
d_FCdf2_dw_dV_bi_ei = d_a_dV_bi_ei;
FCdf2_dw = a;
}

d_a_dV_tnode_GND = (model_.latl)*d_FCw_dV_tnode_GND;
d_a_dV_bi_ci = (model_.latl)*d_FCw_dV_bi_ci;
d_a_dV_bi_ei = (model_.latl)*d_FCw_dV_bi_ei;
a = ((model_.latl)*FCw);
{
double value_log_0 = log((1+((model_.latl)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

d_lnz_dV_tnode_GND = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_tnode_GND));
d_lnz_dV_bi_ci = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ci));
d_lnz_dV_bi_ei = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ei));
lnz = value_log_0;
}
if ((a>1.0e-6))
{

d_FCf3_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latl));
d_FCf3_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latl));
d_FCf3_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latl));
FCf3 = ((a-lnz)/(model_.latl));

d_FCdf3_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
d_FCdf3_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
d_FCdf3_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
FCdf3_dw = (a/(1.0+a));
}
else
{

d_FCf3_dV_tnode_GND = ((0.5*a)*d_FCw_dV_tnode_GND+0.5*d_a_dV_tnode_GND*FCw);
d_FCf3_dV_bi_ci = ((0.5*a)*d_FCw_dV_bi_ci+0.5*d_a_dV_bi_ci*FCw);
d_FCf3_dV_bi_ei = ((0.5*a)*d_FCw_dV_bi_ei+0.5*d_a_dV_bi_ei*FCw);
FCf3 = ((0.5*a)*FCw);

d_FCdf3_dw_dV_tnode_GND = d_a_dV_tnode_GND;
d_FCdf3_dw_dV_bi_ci = d_a_dV_bi_ci;
d_FCdf3_dw_dV_bi_ei = d_a_dV_bi_ei;
FCdf3_dw = a;
}

d_FCf_CT_dV_tnode_GND = (FCf_CT*(d_FCf2_dV_tnode_GND-d_FCf3_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(FCf2-FCf3));
d_FCf_CT_dV_bi_ci = (FCf_CT*(d_FCf2_dV_bi_ci-d_FCf3_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(FCf2-FCf3));
d_FCf_CT_dV_bi_ei = (FCf_CT*(d_FCf2_dV_bi_ei-d_FCf3_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(FCf2-FCf3));
FCf_CT = (FCf_CT*(FCf2-FCf3));

d_FCdfCT_dw_dV_tnode_GND = (FCf_CT*(d_FCdf2_dw_dV_tnode_GND-d_FCdf3_dw_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_dw_dV_bi_ci = (FCf_CT*(d_FCdf2_dw_dV_bi_ci-d_FCdf3_dw_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_dw_dV_bi_ei = (FCf_CT*(d_FCdf2_dw_dV_bi_ei-d_FCdf3_dw_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(FCdf2_dw-FCdf3_dw));
FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));

d_FCdfCT_ditf_dV_tnode_GND = (FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ci = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfCT_dw_dV_bi_ci*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ei = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfCT_dw_dV_bi_ei*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{

d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
FCf_CT = FCf_ci;

d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
FCdfCT_ditf = FCdfc_ditf;
}
}
else
{
if (((model_.latb)>0.01))
{

d_FCd_a_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ci = (-d_FCa_ck_dV_bi_ci*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ei = (-d_FCa_ck_dV_bi_ei*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

d_FCw_dV_tnode_GND = ((1.0-FCa_ck)*d_FCd_a_dV_tnode_GND+(-d_FCa_ck_dV_tnode_GND)*FCd_a);
d_FCw_dV_bi_ci = ((1.0-FCa_ck)*d_FCd_a_dV_bi_ci+(-d_FCa_ck_dV_bi_ci)*FCd_a);
d_FCw_dV_bi_ei = ((1.0-FCa_ck)*d_FCd_a_dV_bi_ei+(-d_FCa_ck_dV_bi_ei)*FCd_a);
FCw = ((1.0-FCa_ck)*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_tnode_GND+(-(1.0+(model_.latb)))*d_FCd_a_dV_tnode_GND*FCd_a);
d_FCdw_daick_dV_bi_ci = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ci+(-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ci*FCd_a);
d_FCdw_daick_dV_bi_ei = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ei+(-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ei*FCd_a);
FCdw_daick = (((-(1.0+(model_.latb)))*FCd_a)*FCd_a);
}
else
{

d_FCw_dV_tnode_GND = ((-d_FCa_ck_dV_tnode_GND)-d_FCa_ck_dV_tnode_GND*(model_.latb));
d_FCw_dV_bi_ci = ((-d_FCa_ck_dV_bi_ci)-d_FCa_ck_dV_bi_ci*(model_.latb));
d_FCw_dV_bi_ei = ((-d_FCa_ck_dV_bi_ei)-d_FCa_ck_dV_bi_ei*(model_.latb));
FCw = ((1.0-FCa_ck)-(FCa_ck*(model_.latb)));

d_FCdw_daick_dV_bi_ei = d_FCdw_daick_dV_bi_ci = d_FCdw_daick_dV_tnode_GND =  0.0;
FCdw_daick = (-(1.0+(model_.latb)));
}

d_FCw2_dV_tnode_GND = (FCw*d_FCw_dV_tnode_GND+d_FCw_dV_tnode_GND*FCw);
d_FCw2_dV_bi_ci = (FCw*d_FCw_dV_bi_ci+d_FCw_dV_bi_ci*FCw);
d_FCw2_dV_bi_ei = (FCw*d_FCw_dV_bi_ei+d_FCw_dV_bi_ei*FCw);
FCw2 = (FCw*FCw);

d_FCz_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_FCz_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_FCz_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
FCz = ((model_.latb)*FCw);

d_FCz_1_dV_tnode_GND = d_FCz_dV_tnode_GND;
d_FCz_1_dV_bi_ci = d_FCz_dV_bi_ci;
d_FCz_1_dV_bi_ei = d_FCz_dV_bi_ei;
FCz_1 = (1.0+FCz);

d_FCd_f_dV_tnode_GND = (-d_FCz_1_dV_tnode_GND/FCz_1/FCz_1);
d_FCd_f_dV_bi_ci = (-d_FCz_1_dV_bi_ci/FCz_1/FCz_1);
d_FCd_f_dV_bi_ei = (-d_FCz_1_dV_bi_ei/FCz_1/FCz_1);
FCd_f = (1.0/FCz_1);

d_FCf_ci_dV_tnode_GND = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_tnode_GND+(FCw2*(d_FCz_dV_tnode_GND/3.0)+d_FCw2_dV_tnode_GND*(1.0+(FCz/3.0)))*FCd_f);
d_FCf_ci_dV_bi_ci = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ci+(FCw2*(d_FCz_dV_bi_ci/3.0)+d_FCw2_dV_bi_ci*(1.0+(FCz/3.0)))*FCd_f);
d_FCf_ci_dV_bi_ei = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ei+(FCw2*(d_FCz_dV_bi_ei/3.0)+d_FCw2_dV_bi_ei*(1.0+(FCz/3.0)))*FCd_f);
FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);

d_FCdfc_dw_dV_tnode_GND = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND+((2.0*FCw)*(d_FCz_1_dV_tnode_GND+((FCz*d_FCz_dV_tnode_GND+d_FCz_dV_tnode_GND*FCz)/3.0))+2.0*d_FCw_dV_tnode_GND*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfc_dw_dV_bi_ci = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci+((2.0*FCw)*(d_FCz_1_dV_bi_ci+((FCz*d_FCz_dV_bi_ci+d_FCz_dV_bi_ci*FCz)/3.0))+2.0*d_FCw_dV_bi_ci*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfc_dw_dV_bi_ei = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei+((2.0*FCw)*(d_FCz_1_dV_bi_ei+((FCz*d_FCz_dV_bi_ei+d_FCz_dV_bi_ei*FCz)/3.0))+2.0*d_FCw_dV_bi_ei*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);

d_FCdw_ditf_dV_tnode_GND = (FCdw_daick*d_FCdaick_ditf_dV_tnode_GND+d_FCdw_daick_dV_tnode_GND*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ci = (FCdw_daick*d_FCdaick_ditf_dV_bi_ci+d_FCdw_daick_dV_bi_ci*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ei = (FCdw_daick*d_FCdaick_ditf_dV_bi_ei+d_FCdw_daick_dV_bi_ei*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);

d_FCdfc_ditf_dV_tnode_GND = (FCdfc_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfc_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ci = (FCdfc_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfc_dw_dV_bi_ci*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ei = (FCdfc_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfc_dw_dV_bi_ei*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{
if ((FCz>0.001))
{
{
double value_log_0 = log(FCz_1);
double  deriv_log_0_d0 = (1.0/FCz_1);

d_FCf_CT_dV_tnode_GND = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_tnode_GND))+d_FCz_1_dV_tnode_GND*value_log_0)-d_FCz_dV_tnode_GND)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_tnode_GND)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
d_FCf_CT_dV_bi_ci = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ci))+d_FCz_1_dV_bi_ci*value_log_0)-d_FCz_dV_bi_ci)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ci)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
d_FCf_CT_dV_bi_ei = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ei))+d_FCz_1_dV_bi_ei*value_log_0)-d_FCz_dV_bi_ei)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ei)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/(((model_.latb)*(model_.latb))*FCz_1));
}

d_FCdfCT_dw_dV_tnode_GND = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_tnode_GND+((2.0*FCw)*d_FCd_f_dV_tnode_GND+2.0*d_FCw_dV_tnode_GND*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ci = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ci+((2.0*FCw)*d_FCd_f_dV_bi_ci+2.0*d_FCw_dV_bi_ci*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ei = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ei+((2.0*FCw)*d_FCd_f_dV_bi_ei+2.0*d_FCw_dV_bi_ei*FCd_f)*FCd_f);
FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
}
else
{

d_FCf_CT_dV_tnode_GND = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_tnode_GND+(FCw2*(-(d_FCz_dV_tnode_GND/3.0))+d_FCw2_dV_tnode_GND*(1.0-(FCz/3.0)))*FCd_f);
d_FCf_CT_dV_bi_ci = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ci+(FCw2*(-(d_FCz_dV_bi_ci/3.0))+d_FCw2_dV_bi_ci*(1.0-(FCz/3.0)))*FCd_f);
d_FCf_CT_dV_bi_ei = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ei+(FCw2*(-(d_FCz_dV_bi_ei/3.0))+d_FCw2_dV_bi_ei*(1.0-(FCz/3.0)))*FCd_f);
FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);

d_FCdfCT_dw_dV_tnode_GND = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND+((2.0*FCw)*(-((FCz*d_FCz_dV_tnode_GND+d_FCz_dV_tnode_GND*FCz)/3.0))+2.0*d_FCw_dV_tnode_GND*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ci = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci+((2.0*FCw)*(-((FCz*d_FCz_dV_bi_ci+d_FCz_dV_bi_ci*FCz)/3.0))+2.0*d_FCw_dV_bi_ci*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ei = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei+((2.0*FCw)*(-((FCz*d_FCz_dV_bi_ei+d_FCz_dV_bi_ei*FCz)/3.0))+2.0*d_FCw_dV_bi_ei*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
}

d_FCdfCT_ditf_dV_tnode_GND = (FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ci = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfCT_dw_dV_bi_ci*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ei = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfCT_dw_dV_bi_ei*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{

d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
FCf_CT = FCf_ci;

d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
FCdfCT_ditf = FCdfc_ditf;
}
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQcfcT_dV_bi_ci = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(FFdQcfc*d_FCf_CT_dV_bi_ci+d_FFdQcfc_dV_bi_ci*FCf_CT)*value_exp_0);
d_FFdQcfcT_dV_bi_ei = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(FFdQcfc*d_FCf_CT_dV_bi_ei+d_FFdQcfc_dV_bi_ei*FCf_CT)*value_exp_0);
d_FFdQcfcT_dV_tnode_GND = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(FFdQcfc*d_FCf_CT_dV_tnode_GND+d_FFdQcfc_dV_tnode_GND*FCf_CT)*value_exp_0);
FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQcfc_dV_bi_ci = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(FFdQcfc*d_FCf_ci_dV_bi_ci+d_FFdQcfc_dV_bi_ci*FCf_ci)*value_exp_0);
d_FFdQcfc_dV_bi_ei = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(FFdQcfc*d_FCf_ci_dV_bi_ei+d_FFdQcfc_dV_bi_ei*FCf_ci)*value_exp_0);
d_FFdQcfc_dV_tnode_GND = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(FFdQcfc*d_FCf_ci_dV_tnode_GND+d_FFdQcfc_dV_tnode_GND*FCf_ci)*value_exp_0);
FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTcfc_dV_bi_ci = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ci+(itf*d_FCdfc_ditf_dV_bi_ci+d_itf_dV_bi_ci*FCdfc_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ci+(d_FFdQcfc_dV_bi_ci/VT)*FFdVc_ditf));
d_FFdTcfc_dV_bi_ei = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ei+(itf*d_FCdfc_ditf_dV_bi_ei+d_itf_dV_bi_ei*FCdfc_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ei+(d_FFdQcfc_dV_bi_ei/VT)*FFdVc_ditf));
d_FFdTcfc_dV_tnode_GND = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_tnode_GND+(itf*d_FCdfc_ditf_dV_tnode_GND+d_itf_dV_tnode_GND*FCdfc_ditf))+(((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(model_.fthc)*d_thcs_t_dV_tnode_GND*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*d_FFdQcfc_dV_tnode_GND-FFdQcfc*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTcfc = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*FFdVc_ditf));
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTcfcT_dV_bi_ci = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ci+(itf*d_FCdfCT_ditf_dV_bi_ci+d_itf_dV_bi_ci*FCdfCT_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ci+(d_FFdQcfcT_dV_bi_ci/VT)*FFdVc_ditf));
d_FFdTcfcT_dV_bi_ei = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ei+(itf*d_FCdfCT_ditf_dV_bi_ei+d_itf_dV_bi_ei*FCdfCT_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ei+(d_FFdQcfcT_dV_bi_ei/VT)*FFdVc_ditf));
d_FFdTcfcT_dV_tnode_GND = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_tnode_GND+(itf*d_FCdfCT_ditf_dV_tnode_GND+d_itf_dV_tnode_GND*FCdfCT_ditf))+(((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(model_.fthc)*d_thcs_t_dV_tnode_GND*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*d_FFdQcfcT_dV_tnode_GND-FFdQcfcT*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTcfcT = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*FFdVc_ditf));
}
}

d_FFdQbfc_dV_bi_ci = (1-(model_.fthc))*d_FFdQfhc_dV_bi_ci;
d_FFdQbfc_dV_bi_ei = (1-(model_.fthc))*d_FFdQfhc_dV_bi_ei;
d_FFdQbfc_dV_tnode_GND = (1-(model_.fthc))*d_FFdQfhc_dV_tnode_GND;
FFdQbfc = ((1-(model_.fthc))*FFdQfhc);

d_FFdTbfc_dV_bi_ci = (1-(model_.fthc))*d_FFdTfhc_dV_bi_ci;
d_FFdTbfc_dV_bi_ei = (1-(model_.fthc))*d_FFdTfhc_dV_bi_ei;
d_FFdTbfc_dV_tnode_GND = (1-(model_.fthc))*d_FFdTfhc_dV_tnode_GND;
FFdTbfc = ((1-(model_.fthc))*FFdTfhc);

d_Q_fT_dV_bi_ei = ((((hf0_t*d_Qf_dV_bi_ei+d_FFdQbfb_dV_bi_ei)+d_FFdQbfc_dV_bi_ei)+hfe_t*d_FFdQef_dV_bi_ei)+hfc_t*d_FFdQcfcT_dV_bi_ei);
d_Q_fT_dV_bi_ci = ((((hf0_t*d_Qf_dV_bi_ci+d_FFdQbfb_dV_bi_ci)+d_FFdQbfc_dV_bi_ci)+hfe_t*d_FFdQef_dV_bi_ci)+hfc_t*d_FFdQcfcT_dV_bi_ci);
d_Q_fT_dV_tnode_GND = (((((hf0_t*d_Qf_dV_tnode_GND+d_hf0_t_dV_tnode_GND*Qf)+d_FFdQbfb_dV_tnode_GND)+d_FFdQbfc_dV_tnode_GND)+(hfe_t*d_FFdQef_dV_tnode_GND+d_hfe_t_dV_tnode_GND*FFdQef))+(hfc_t*d_FFdQcfcT_dV_tnode_GND+d_hfc_t_dV_tnode_GND*FFdQcfcT));
Q_fT = (((((hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(hfe_t*FFdQef))+(hfc_t*FFdQcfcT));

d_T_fT_dV_bi_ei = ((((hf0_t*d_Tf_dV_bi_ei+d_FFdTbfb_dV_bi_ei)+d_FFdTbfc_dV_bi_ei)+hfe_t*d_FFdTef_dV_bi_ei)+hfc_t*d_FFdTcfcT_dV_bi_ei);
d_T_fT_dV_bi_ci = ((((hf0_t*d_Tf_dV_bi_ci+d_FFdTbfb_dV_bi_ci)+d_FFdTbfc_dV_bi_ci)+hfe_t*d_FFdTef_dV_bi_ci)+hfc_t*d_FFdTcfcT_dV_bi_ci);
d_T_fT_dV_tnode_GND = (((((hf0_t*d_Tf_dV_tnode_GND+d_hf0_t_dV_tnode_GND*Tf)+d_FFdTbfb_dV_tnode_GND)+d_FFdTbfc_dV_tnode_GND)+(hfe_t*d_FFdTef_dV_tnode_GND+d_hfe_t_dV_tnode_GND*FFdTef))+(hfc_t*d_FFdTcfcT_dV_tnode_GND+d_hfc_t_dV_tnode_GND*FFdTcfcT));
T_fT = (((((hf0_t*Tf)+FFdTbfb)+FFdTbfc)+(hfe_t*FFdTef))+(hfc_t*FFdTcfcT));

d_Qf_dV_bi_ei = (((d_Qf_dV_bi_ei+(d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei))+d_FFdQef_dV_bi_ei)+d_FFdQcfc_dV_bi_ei);
d_Qf_dV_bi_ci = (((d_Qf_dV_bi_ci+(d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci))+d_FFdQef_dV_bi_ci)+d_FFdQcfc_dV_bi_ci);
d_Qf_dV_tnode_GND = (((d_Qf_dV_tnode_GND+(d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND))+d_FFdQef_dV_tnode_GND)+d_FFdQcfc_dV_tnode_GND);
Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);

d_Tf_dV_bi_ei = (((d_Tf_dV_bi_ei+(d_FFdTbfb_dV_bi_ei+d_FFdTbfc_dV_bi_ei))+d_FFdTef_dV_bi_ei)+d_FFdTcfc_dV_bi_ei);
d_Tf_dV_bi_ci = (((d_Tf_dV_bi_ci+(d_FFdTbfb_dV_bi_ci+d_FFdTbfc_dV_bi_ci))+d_FFdTef_dV_bi_ci)+d_FFdTcfc_dV_bi_ci);
d_Tf_dV_tnode_GND = (((d_Tf_dV_tnode_GND+(d_FFdTbfb_dV_tnode_GND+d_FFdTbfc_dV_tnode_GND))+d_FFdTef_dV_tnode_GND)+d_FFdTcfc_dV_tnode_GND);
Tf = (((Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);

d_Q_bf_dV_bi_ci = (d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci);
d_Q_bf_dV_bi_ei = (d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei);
d_Q_bf_dV_tnode_GND = (d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND);
Q_bf = (FFdQbfb+FFdQbfc);
}

d_Qr_dV_bi_ei = Tr*d_itr_dV_bi_ei;
d_Qr_dV_bi_ci = Tr*d_itr_dV_bi_ci;
d_Qr_dV_tnode_GND = Tr*d_itr_dV_tnode_GND;
Qr = (Tr*itr);
l_it = 0;
if (((Qf>(1.0e-5*Q_p))||(a_h>1.0e-5)))
{
{
double value_sqrt_0 = sqrt(((T_f0*itf)*Q_fT));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Qf_dV_bi_ei = (deriv_sqrt_0_d0*(((T_f0*itf)*d_Q_fT_dV_bi_ei+T_f0*d_itf_dV_bi_ei*Q_fT)));
d_Qf_dV_bi_ci = (deriv_sqrt_0_d0*(((T_f0*itf)*d_Q_fT_dV_bi_ci+(T_f0*d_itf_dV_bi_ci+d_T_f0_dV_bi_ci*itf)*Q_fT)));
d_Qf_dV_tnode_GND = (deriv_sqrt_0_d0*(((T_f0*itf)*d_Q_fT_dV_tnode_GND+(T_f0*d_itf_dV_tnode_GND+d_T_f0_dV_tnode_GND*itf)*Q_fT)));
Qf = value_sqrt_0;
}

d_Q_pT_dV_bi_ci = ((d_Q_0_dV_bi_ci+d_Qf_dV_bi_ci)+d_Qr_dV_bi_ci);
d_Q_pT_dV_bi_ei = ((d_Q_0_dV_bi_ei+d_Qf_dV_bi_ei)+d_Qr_dV_bi_ei);
d_Q_pT_dV_tnode_GND = ((d_Q_0_dV_tnode_GND+d_Qf_dV_tnode_GND)+d_Qr_dV_tnode_GND);
Q_pT = ((Q_0+Qf)+Qr);

d_d_Q_dV_bi_ci = d_Q_pT_dV_bi_ci;
d_d_Q_dV_bi_ei = d_Q_pT_dV_bi_ei;
d_d_Q_dV_tnode_GND = d_Q_pT_dV_tnode_GND;
d_Q = Q_pT;
while (((fabs(d_Q)>=(1.0e-5*fabs(Q_pT)))&&(l_it<=100)))
{
d_Q0 = d_Q;

d_I_Tf1_dV_bi_ci = (-i_0f*d_Q_pT_dV_bi_ci/Q_pT/Q_pT);
d_I_Tf1_dV_bi_ei = ((Q_pT*d_i_0f_dV_bi_ei-i_0f*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
d_I_Tf1_dV_tnode_GND = ((Q_pT*d_i_0f_dV_tnode_GND-i_0f*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
I_Tf1 = (i_0f/Q_pT);

d_a_h_dV_bi_ci = Oich*d_I_Tf1_dV_bi_ci;
d_a_h_dV_bi_ei = Oich*d_I_Tf1_dV_bi_ei;
d_a_h_dV_tnode_GND = Oich*d_I_Tf1_dV_tnode_GND;
a_h = (Oich*I_Tf1);

d_itf_dV_bi_ci = (I_Tf1*d_a_h_dV_bi_ci+d_I_Tf1_dV_bi_ci*(1.0+a_h));
d_itf_dV_bi_ei = (I_Tf1*d_a_h_dV_bi_ei+d_I_Tf1_dV_bi_ei*(1.0+a_h));
d_itf_dV_tnode_GND = (I_Tf1*d_a_h_dV_tnode_GND+d_I_Tf1_dV_tnode_GND*(1.0+a_h));
itf = (I_Tf1*(1.0+a_h));

d_itr_dV_bi_ei = (-i_0r*d_Q_pT_dV_bi_ei/Q_pT/Q_pT);
d_itr_dV_bi_ci = ((Q_pT*d_i_0r_dV_bi_ci-i_0r*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
d_itr_dV_tnode_GND = ((Q_pT*d_i_0r_dV_tnode_GND-i_0r*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
itr = (i_0r/Q_pT);

d_Tf_dV_bi_ei =  0.0;
d_Tf_dV_bi_ci = d_T_f0_dV_bi_ci;
d_Tf_dV_tnode_GND = d_T_f0_dV_tnode_GND;
Tf = T_f0;

d_Qf_dV_bi_ei = T_f0*d_itf_dV_bi_ei;
d_Qf_dV_bi_ci = (T_f0*d_itf_dV_bi_ci+d_T_f0_dV_bi_ci*itf);
d_Qf_dV_tnode_GND = (T_f0*d_itf_dV_tnode_GND+d_T_f0_dV_tnode_GND*itf);
Qf = (T_f0*itf);
if ((itf<(1.0e-6*ick)))
{

d_Q_fT_dV_bi_ei = d_Qf_dV_bi_ei;
d_Q_fT_dV_bi_ci = d_Qf_dV_bi_ci;
d_Q_fT_dV_tnode_GND = d_Qf_dV_tnode_GND;
Q_fT = Qf;

d_T_fT_dV_bi_ci = d_Tf_dV_bi_ci;
d_T_fT_dV_tnode_GND = d_Tf_dV_tnode_GND;
d_T_fT_dV_bi_ei = d_Tf_dV_bi_ei;
T_fT = Tf;

d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
Q_bf = 0;
}
else
{

d_FFitf_ick_dV_bi_ci = ((ick*d_itf_dV_bi_ci-itf*d_ick_dV_bi_ci)/ick/ick);
d_FFitf_ick_dV_bi_ei = ((ick*d_itf_dV_bi_ei-itf*d_ick_dV_bi_ei)/ick/ick);
d_FFitf_ick_dV_tnode_GND = ((ick*d_itf_dV_tnode_GND-itf*d_ick_dV_tnode_GND)/ick/ick);
FFitf_ick = (itf/ick);
{
double value_log_0 = log(FFitf_ick);
double value_exp_1 = exp(((model_.gtfe)*value_log_0));
double  deriv_log_0_d0 = (1.0/FFitf_ick);
double  deriv_exp_1_d0 = value_exp_1;

d_FFdTef_dV_bi_ci = tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ci))));
d_FFdTef_dV_bi_ei = tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ei))));
d_FFdTef_dV_tnode_GND = (tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_tnode_GND))))+d_tef0_t_dV_tnode_GND*value_exp_1);
FFdTef = (tef0_t*value_exp_1);
}

d_FFdQef_dV_bi_ci = ((FFdTef*d_itf_dV_bi_ci+d_FFdTef_dV_bi_ci*itf)/(1+(model_.gtfe)));
d_FFdQef_dV_bi_ei = ((FFdTef*d_itf_dV_bi_ei+d_FFdTef_dV_bi_ei*itf)/(1+(model_.gtfe)));
d_FFdQef_dV_tnode_GND = ((FFdTef*d_itf_dV_tnode_GND+d_FFdTef_dV_tnode_GND*itf)/(1+(model_.gtfe)));
FFdQef = ((FFdTef*itf)/(1+(model_.gtfe)));
if (((model_.icbar)<(0.05*((model_.vlim)/(model_.rci0)))))
{

d_FFdVc_dV_tnode_GND = d_FFdVc_dV_bi_ei = d_FFdVc_dV_bi_ci =  0.0;
FFdVc = 0;

d_FFdVc_ditf_dV_tnode_GND = d_FFdVc_ditf_dV_bi_ei = d_FFdVc_ditf_dV_bi_ci =  0.0;
FFdVc_ditf = 0;
}
else
{

d_FFib_dV_bi_ci = ((d_itf_dV_bi_ci-d_ick_dV_bi_ci)/(model_.icbar));
d_FFib_dV_bi_ei = ((d_itf_dV_bi_ei-d_ick_dV_bi_ei)/(model_.icbar));
d_FFib_dV_tnode_GND = ((d_itf_dV_tnode_GND-d_ick_dV_tnode_GND)/(model_.icbar));
FFib = ((itf-ick)/(model_.icbar));
if ((FFib<(-1.0e10)))
{

d_FFib_dV_tnode_GND = d_FFib_dV_bi_ei = d_FFib_dV_bi_ci =  0.0;
FFib = (-1.0e10);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFfcbar_dV_bi_ci = ((d_FFib_dV_bi_ci+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ci+d_FFib_dV_bi_ci*FFib))))/2.0);
d_FFfcbar_dV_bi_ei = ((d_FFib_dV_bi_ei+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ei+d_FFib_dV_bi_ei*FFib))))/2.0);
d_FFfcbar_dV_tnode_GND = ((d_FFib_dV_tnode_GND+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_tnode_GND+d_FFib_dV_tnode_GND*FFib))))/2.0);
FFfcbar = ((FFib+value_sqrt_0)/2.0);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFdib_ditf_dV_bi_ci = (((value_sqrt_0*d_FFfcbar_dV_bi_ci-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ci+d_FFib_dV_bi_ci*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
d_FFdib_ditf_dV_bi_ei = (((value_sqrt_0*d_FFfcbar_dV_bi_ei-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ei+d_FFib_dV_bi_ei*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
d_FFdib_ditf_dV_tnode_GND = (((value_sqrt_0*d_FFfcbar_dV_tnode_GND-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_tnode_GND+d_FFib_dV_tnode_GND*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
FFdib_ditf = ((FFfcbar/value_sqrt_0)/(model_.icbar));
}
{
double value_exp_0 = exp(((-1.0)/FFfcbar));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdVc_dV_bi_ci = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ci/FFfcbar/FFfcbar)));
d_FFdVc_dV_bi_ei = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ei/FFfcbar/FFfcbar)));
d_FFdVc_dV_tnode_GND = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_tnode_GND/FFfcbar/FFfcbar)));
FFdVc = ((model_.vcbar)*value_exp_0);
}

d_FFdVc_ditf_dV_bi_ci = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ci+(((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ci-FFdVc*(FFfcbar*d_FFfcbar_dV_bi_ci+d_FFfcbar_dV_bi_ci*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
d_FFdVc_ditf_dV_bi_ei = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ei+(((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ei-FFdVc*(FFfcbar*d_FFfcbar_dV_bi_ei+d_FFfcbar_dV_bi_ei*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
d_FFdVc_ditf_dV_tnode_GND = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_tnode_GND+(((FFfcbar*FFfcbar)*d_FFdVc_dV_tnode_GND-FFdVc*(FFfcbar*d_FFfcbar_dV_tnode_GND+d_FFfcbar_dV_tnode_GND*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
}
{
double value_exp_0 = exp((FFdVc/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQbfb_dV_bi_ci = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci*(value_exp_0-1));
d_FFdQbfb_dV_bi_ei = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei*(value_exp_0-1));
d_FFdQbfb_dV_tnode_GND = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT)))+(((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND+(1-(model_.fthc))*d_thcs_t_dV_tnode_GND*itf)*(value_exp_0-1));
FFdQbfb = ((((1-(model_.fthc))*thcs_t)*itf)*(value_exp_0-1));
}
{
double value_exp_0 = exp((FFdVc/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTbfb_dV_bi_ci = (((itf*d_FFdQbfb_dV_bi_ci-FFdQbfb*d_itf_dV_bi_ci)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ci+(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci*value_exp_0)/VT)*FFdVc_ditf));
d_FFdTbfb_dV_bi_ei = (((itf*d_FFdQbfb_dV_bi_ei-FFdQbfb*d_itf_dV_bi_ei)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ei+(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei*value_exp_0)/VT)*FFdVc_ditf));
d_FFdTbfb_dV_tnode_GND = (((itf*d_FFdQbfb_dV_tnode_GND-FFdQbfb*d_itf_dV_tnode_GND)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT)))+(((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND+(1-(model_.fthc))*d_thcs_t_dV_tnode_GND*itf)*value_exp_0)-((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTbfb = ((FFdQbfb/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*FFdVc_ditf));
}

d_FFic_dV_bi_ci = (-(-d_FFitf_ick_dV_bi_ci/FFitf_ick/FFitf_ick));
d_FFic_dV_bi_ei = (-(-d_FFitf_ick_dV_bi_ei/FFitf_ick/FFitf_ick));
d_FFic_dV_tnode_GND = (-(-d_FFitf_ick_dV_tnode_GND/FFitf_ick/FFitf_ick));
FFic = (1-(1.0/FFitf_ick));
{
double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
double value_sqrt_1 = sqrt((1+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFw_dV_bi_ci = ((d_FFic_dV_bi_ci+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ci+d_FFic_dV_bi_ci*FFic))))/(1+value_sqrt_1));
d_FFw_dV_bi_ei = ((d_FFic_dV_bi_ei+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ei+d_FFic_dV_bi_ei*FFic))))/(1+value_sqrt_1));
d_FFw_dV_tnode_GND = ((d_FFic_dV_tnode_GND+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_tnode_GND+d_FFic_dV_tnode_GND*FFic))))/(1+value_sqrt_1));
FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQfhc_dV_bi_ci = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_bi_ci+((thcs_t*itf)*d_FFw_dV_bi_ci+thcs_t*d_itf_dV_bi_ci*FFw)*FFw)*value_exp_0);
d_FFdQfhc_dV_bi_ei = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_bi_ei+((thcs_t*itf)*d_FFw_dV_bi_ei+thcs_t*d_itf_dV_bi_ei*FFw)*FFw)*value_exp_0);
d_FFdQfhc_dV_tnode_GND = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_tnode_GND+((thcs_t*itf)*d_FFw_dV_tnode_GND+(thcs_t*d_itf_dV_tnode_GND+d_thcs_t_dV_tnode_GND*itf)*FFw)*FFw)*value_exp_0);
FFdQfhc = ((((thcs_t*itf)*FFw)*FFw)*value_exp_0);
}
{
double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFdTfhc_dV_bi_ci = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ci+d_FFic_dV_bi_ci*FFic)))+d_FFitf_ick_dV_bi_ci*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_bi_ci/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+(1.0/VT)*d_FFdVc_ditf_dV_bi_ci)+d_FFdQfhc_dV_bi_ci*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
d_FFdTfhc_dV_bi_ei = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ei+d_FFic_dV_bi_ei*FFic)))+d_FFitf_ick_dV_bi_ei*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_bi_ei/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+(1.0/VT)*d_FFdVc_ditf_dV_bi_ei)+d_FFdQfhc_dV_bi_ei*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
d_FFdTfhc_dV_tnode_GND = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_tnode_GND+d_FFic_dV_tnode_GND*FFic)))+d_FFitf_ick_dV_tnode_GND*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_tnode_GND/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*d_FFdVc_ditf_dV_tnode_GND+(-d_VT_dV_tnode_GND/VT/VT)*FFdVc_ditf))+d_FFdQfhc_dV_tnode_GND*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
}
if ((((model_.latb)<=0.0)&&((model_.latl)<=0.0)))
{

d_FFdQcfc_dV_bi_ci = (model_.fthc)*d_FFdQfhc_dV_bi_ci;
d_FFdQcfc_dV_bi_ei = (model_.fthc)*d_FFdQfhc_dV_bi_ei;
d_FFdQcfc_dV_tnode_GND = (model_.fthc)*d_FFdQfhc_dV_tnode_GND;
FFdQcfc = ((model_.fthc)*FFdQfhc);

d_FFdTcfc_dV_bi_ci = (model_.fthc)*d_FFdTfhc_dV_bi_ci;
d_FFdTcfc_dV_bi_ei = (model_.fthc)*d_FFdTfhc_dV_bi_ei;
d_FFdTcfc_dV_tnode_GND = (model_.fthc)*d_FFdTfhc_dV_tnode_GND;
FFdTcfc = ((model_.fthc)*FFdTfhc);

d_FFdQcfcT_dV_bi_ci = d_FFdQcfc_dV_bi_ci;
d_FFdQcfcT_dV_bi_ei = d_FFdQcfc_dV_bi_ei;
d_FFdQcfcT_dV_tnode_GND = d_FFdQcfc_dV_tnode_GND;
FFdQcfcT = FFdQcfc;

d_FFdTcfcT_dV_bi_ci = d_FFdTcfc_dV_bi_ci;
d_FFdTcfcT_dV_bi_ei = d_FFdTcfc_dV_bi_ei;
d_FFdTcfcT_dV_tnode_GND = d_FFdTcfc_dV_tnode_GND;
FFdTcfcT = FFdTcfc;
}
else
{

d_FFdQcfc_dV_bi_ci = ((model_.fthc)*thcs_t)*d_itf_dV_bi_ci;
d_FFdQcfc_dV_bi_ei = ((model_.fthc)*thcs_t)*d_itf_dV_bi_ei;
d_FFdQcfc_dV_tnode_GND = (((model_.fthc)*thcs_t)*d_itf_dV_tnode_GND+(model_.fthc)*d_thcs_t_dV_tnode_GND*itf);
FFdQcfc = (((model_.fthc)*thcs_t)*itf);

d_FCa_dV_tnode_GND = (-((itf*d_ick_dV_tnode_GND-ick*d_itf_dV_tnode_GND)/itf/itf));
d_FCa_dV_bi_ci = (-((itf*d_ick_dV_bi_ci-ick*d_itf_dV_bi_ci)/itf/itf));
d_FCa_dV_bi_ei = (-((itf*d_ick_dV_bi_ei-ick*d_itf_dV_bi_ei)/itf/itf));
FCa = (1.0-(ick/itf));
{
double value_sqrt_0 = sqrt(((FCa*FCa)+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FCrt_dV_tnode_GND = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_tnode_GND+d_FCa_dV_tnode_GND*FCa)));
d_FCrt_dV_bi_ci = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_bi_ci+d_FCa_dV_bi_ci*FCa)));
d_FCrt_dV_bi_ei = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_bi_ei+d_FCa_dV_bi_ei*FCa)));
FCrt = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((1.0+(model_.ahc)));

d_FCa_ck_dV_tnode_GND = (-((d_FCa_dV_tnode_GND+d_FCrt_dV_tnode_GND)/(1.0+value_sqrt_0)));
d_FCa_ck_dV_bi_ci = (-((d_FCa_dV_bi_ci+d_FCrt_dV_bi_ci)/(1.0+value_sqrt_0)));
d_FCa_ck_dV_bi_ei = (-((d_FCa_dV_bi_ei+d_FCrt_dV_bi_ei)/(1.0+value_sqrt_0)));
FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
}

d_FCdaick_ditf_dV_tnode_GND = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_tnode_GND)+d_FCa_ck_dV_tnode_GND*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_tnode_GND+d_FCrt_dV_tnode_GND*itf))/(FCrt*itf)/(FCrt*itf));
d_FCdaick_ditf_dV_bi_ci = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_bi_ci)+d_FCa_ck_dV_bi_ci*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_bi_ci+d_FCrt_dV_bi_ci*itf))/(FCrt*itf)/(FCrt*itf));
d_FCdaick_ditf_dV_bi_ei = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_bi_ei)+d_FCa_ck_dV_bi_ei*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_bi_ei+d_FCrt_dV_bi_ei*itf))/(FCrt*itf)/(FCrt*itf));
FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
if (((model_.latb)>(model_.latl)))
{

d_FCz_dV_bi_ei = d_FCz_dV_bi_ci = d_FCz_dV_tnode_GND =  0.0;
FCz = ((model_.latb)-(model_.latl));
FCxl = (1.0+(model_.latl));
FCxb = (1.0+(model_.latb));
if (((model_.latb)>0.01))
{
{
double value_log_0 = log((FCxb/FCxl));
FCln = value_log_0;
}
{
double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
double  deriv_exp_0_d0 = value_exp_0;

d_FCa1_dV_tnode_GND = (deriv_exp_0_d0*(d_FCa_ck_dV_tnode_GND*FCln));
d_FCa1_dV_bi_ci = (deriv_exp_0_d0*(d_FCa_ck_dV_bi_ci*FCln));
d_FCa1_dV_bi_ei = (deriv_exp_0_d0*(d_FCa_ck_dV_bi_ei*FCln));
FCa1 = value_exp_0;
}

d_FCd_a_dV_tnode_GND = (-(-d_FCa1_dV_tnode_GND*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
d_FCd_a_dV_bi_ci = (-(-d_FCa1_dV_bi_ci*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
d_FCd_a_dV_bi_ei = (-(-d_FCa1_dV_bi_ei*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
FCd_a = (1.0/((model_.latl)-(FCa1*(model_.latb))));

d_FCw_dV_tnode_GND = ((FCa1-1.0)*d_FCd_a_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCd_a);
d_FCw_dV_bi_ci = ((FCa1-1.0)*d_FCd_a_dV_bi_ci+d_FCa1_dV_bi_ci*FCd_a);
d_FCw_dV_bi_ei = ((FCa1-1.0)*d_FCd_a_dV_bi_ei+d_FCa1_dV_bi_ei*FCd_a);
FCw = ((FCa1-1.0)*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_tnode_GND+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_tnode_GND+((-FCz)*d_FCa1_dV_tnode_GND+(-d_FCz_dV_tnode_GND)*FCa1)*FCln*FCd_a)*FCd_a);
d_FCdw_daick_dV_bi_ci = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ci+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ci+((-FCz)*d_FCa1_dV_bi_ci+(-d_FCz_dV_bi_ci)*FCa1)*FCln*FCd_a)*FCd_a);
d_FCdw_daick_dV_bi_ei = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ei+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ei+((-FCz)*d_FCa1_dV_bi_ei+(-d_FCz_dV_bi_ei)*FCa1)*FCln*FCd_a)*FCd_a);
FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
{
double value_log_0 = log(((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));
double  deriv_log_0_d0 = (1.0/((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));

d_FCa1_dV_tnode_GND = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_tnode_GND-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_tnode_GND)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
d_FCa1_dV_bi_ci = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_bi_ci-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_bi_ci)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
d_FCa1_dV_bi_ei = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_bi_ei-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_bi_ei)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
FCa1 = value_log_0;
}

d_FCda1_dw_dV_tnode_GND = ((-(model_.latb)*(model_.latb)*d_FCw_dV_tnode_GND/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_tnode_GND/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
d_FCda1_dw_dV_bi_ci = ((-(model_.latb)*(model_.latb)*d_FCw_dV_bi_ci/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_bi_ci/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
d_FCda1_dw_dV_bi_ei = ((-(model_.latb)*(model_.latb)*d_FCw_dV_bi_ei/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_bi_ei/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
FCda1_dw = (((model_.latb)/(1.0+((model_.latb)*FCw)))-((model_.latl)/(1.0+((model_.latl)*FCw))));
}
else
{

d_FCf1_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND);
d_FCf1_dV_bi_ci = (-d_FCa_ck_dV_bi_ci);
d_FCf1_dV_bi_ei = (-d_FCa_ck_dV_bi_ei);
FCf1 = (1.0-FCa_ck);

d_FCd_a_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ci = (-d_FCa_ck_dV_bi_ci*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ei = (-d_FCa_ck_dV_bi_ei*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

d_FCw_dV_tnode_GND = (FCf1*d_FCd_a_dV_tnode_GND+d_FCf1_dV_tnode_GND*FCd_a);
d_FCw_dV_bi_ci = (FCf1*d_FCd_a_dV_bi_ci+d_FCf1_dV_bi_ci*FCd_a);
d_FCw_dV_bi_ei = (FCf1*d_FCd_a_dV_bi_ei+d_FCf1_dV_bi_ei*FCd_a);
FCw = (FCf1*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_tnode_GND+(((-1.0)*FCd_a)*d_FCd_a_dV_tnode_GND+(-1.0)*d_FCd_a_dV_tnode_GND*FCd_a)*FCxb*FCd_a);
d_FCdw_daick_dV_bi_ci = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ci+(((-1.0)*FCd_a)*d_FCd_a_dV_bi_ci+(-1.0)*d_FCd_a_dV_bi_ci*FCd_a)*FCxb*FCd_a);
d_FCdw_daick_dV_bi_ei = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ei+(((-1.0)*FCd_a)*d_FCd_a_dV_bi_ei+(-1.0)*d_FCd_a_dV_bi_ei*FCd_a)*FCxb*FCd_a);
FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);

d_FCa1_dV_tnode_GND = (FCz*d_FCw_dV_tnode_GND+d_FCz_dV_tnode_GND*FCw);
d_FCa1_dV_bi_ci = (FCz*d_FCw_dV_bi_ci+d_FCz_dV_bi_ci*FCw);
d_FCa1_dV_bi_ei = (FCz*d_FCw_dV_bi_ei+d_FCz_dV_bi_ei*FCw);
FCa1 = (FCz*FCw);

d_FCda1_dw_dV_tnode_GND = d_FCz_dV_tnode_GND;
d_FCda1_dw_dV_bi_ci = d_FCz_dV_bi_ci;
d_FCda1_dw_dV_bi_ei = d_FCz_dV_bi_ei;
FCda1_dw = FCz;
}

d_FCf_CT_dV_tnode_GND = (-2.0*d_FCz_dV_tnode_GND/FCz/FCz);
d_FCf_CT_dV_bi_ci = (-2.0*d_FCz_dV_bi_ci/FCz/FCz);
d_FCf_CT_dV_bi_ei = (-2.0*d_FCz_dV_bi_ei/FCz/FCz);
FCf_CT = (2.0/FCz);

d_FCw2_dV_tnode_GND = (FCw*d_FCw_dV_tnode_GND+d_FCw_dV_tnode_GND*FCw);
d_FCw2_dV_bi_ci = (FCw*d_FCw_dV_bi_ci+d_FCw_dV_bi_ci*FCw);
d_FCw2_dV_bi_ei = (FCw*d_FCw_dV_bi_ei+d_FCw_dV_bi_ei*FCw);
FCw2 = (FCw*FCw);

d_FCf1_dV_tnode_GND = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_tnode_GND+((model_.latb)*(model_.latl))*d_FCw_dV_tnode_GND*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_tnode_GND/2.0))+d_FCw_dV_tnode_GND);
d_FCf1_dV_bi_ci = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ci+((model_.latb)*(model_.latl))*d_FCw_dV_bi_ci*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ci/2.0))+d_FCw_dV_bi_ci);
d_FCf1_dV_bi_ei = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ei+((model_.latb)*(model_.latl))*d_FCw_dV_bi_ei*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ei/2.0))+d_FCw_dV_bi_ei);
FCf1 = (((((((model_.latb)*(model_.latl))*FCw)*FCw2)/3.0)+((((model_.latb)+(model_.latl))*FCw2)/2.0))+FCw);

d_FCdf1_dw_dV_tnode_GND = (((model_.latb)*(model_.latl))*d_FCw2_dV_tnode_GND+((model_.latb)+(model_.latl))*d_FCw_dV_tnode_GND);
d_FCdf1_dw_dV_bi_ci = (((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ci+((model_.latb)+(model_.latl))*d_FCw_dV_bi_ci);
d_FCdf1_dw_dV_bi_ei = (((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ei+((model_.latb)+(model_.latl))*d_FCw_dV_bi_ei);
FCdf1_dw = (((((model_.latb)*(model_.latl))*FCw2)+(((model_.latb)+(model_.latl))*FCw))+1.0);

d_z_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_z_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_z_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
z = ((model_.latb)*FCw);
{
double value_log_0 = log((1+((model_.latb)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

d_lnzb_dV_tnode_GND = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_tnode_GND));
d_lnzb_dV_bi_ci = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ci));
d_lnzb_dV_bi_ei = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ei));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{

d_x_dV_tnode_GND = d_z_dV_tnode_GND;
d_x_dV_bi_ci = d_z_dV_bi_ci;
d_x_dV_bi_ei = d_z_dV_bi_ei;
x = (1.0+z);

d_a_dV_tnode_GND = (x*d_x_dV_tnode_GND+d_x_dV_tnode_GND*x);
d_a_dV_bi_ci = (x*d_x_dV_bi_ci+d_x_dV_bi_ci*x);
d_a_dV_bi_ei = (x*d_x_dV_bi_ei+d_x_dV_bi_ei*x);
a = (x*x);

d_a2_dV_tnode_GND = 0.250*(a*2.0*d_lnzb_dV_tnode_GND+d_a_dV_tnode_GND*((2.0*lnzb)-1.0));
d_a2_dV_bi_ci = 0.250*(a*2.0*d_lnzb_dV_bi_ci+d_a_dV_bi_ci*((2.0*lnzb)-1.0));
d_a2_dV_bi_ei = 0.250*(a*2.0*d_lnzb_dV_bi_ei+d_a_dV_bi_ei*((2.0*lnzb)-1.0));
a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

d_a3_dV_tnode_GND = (((a*x)*3.0*d_lnzb_dV_tnode_GND+(a*d_x_dV_tnode_GND+d_a_dV_tnode_GND*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ci = (((a*x)*3.0*d_lnzb_dV_bi_ci+(a*d_x_dV_bi_ci+d_a_dV_bi_ci*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ei = (((a*x)*3.0*d_lnzb_dV_bi_ei+(a*d_x_dV_bi_ei+d_a_dV_bi_ei*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
r = ((model_.latl)/(model_.latb));

d_FCf2_dV_tnode_GND = (((1.0-r)*d_a2_dV_tnode_GND+r*d_a3_dV_tnode_GND)/(model_.latb));
d_FCf2_dV_bi_ci = (((1.0-r)*d_a2_dV_bi_ci+r*d_a3_dV_bi_ci)/(model_.latb));
d_FCf2_dV_bi_ei = (((1.0-r)*d_a2_dV_bi_ei+r*d_a3_dV_bi_ei)/(model_.latb));
FCf2 = ((((1.0-r)*a2)+(r*a3))/(model_.latb));

d_FCdf2_dw_dV_tnode_GND = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND+((1.0-r)*d_x_dV_tnode_GND+r*d_a_dV_tnode_GND)*lnzb);
d_FCdf2_dw_dV_bi_ci = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci+((1.0-r)*d_x_dV_bi_ci+r*d_a_dV_bi_ci)*lnzb);
d_FCdf2_dw_dV_bi_ei = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei+((1.0-r)*d_x_dV_bi_ei+r*d_a_dV_bi_ei)*lnzb);
FCdf2_dw = ((((1.0-r)*x)+(r*a))*lnzb);
}
else
{

d_a_dV_tnode_GND = (z*d_z_dV_tnode_GND+d_z_dV_tnode_GND*z);
d_a_dV_bi_ci = (z*d_z_dV_bi_ci+d_z_dV_bi_ci*z);
d_a_dV_bi_ei = (z*d_z_dV_bi_ei+d_z_dV_bi_ei*z);
a = (z*z);

d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-0.25*d_a_dV_tnode_GND)+((0.10*z)*d_a_dV_tnode_GND+0.10*d_z_dV_tnode_GND*a));
d_a2_dV_bi_ci = ((d_z_dV_bi_ci-0.25*d_a_dV_bi_ci)+((0.10*z)*d_a_dV_bi_ci+0.10*d_z_dV_bi_ci*a));
d_a2_dV_bi_ei = ((d_z_dV_bi_ei-0.25*d_a_dV_bi_ei)+((0.10*z)*d_a_dV_bi_ei+0.10*d_z_dV_bi_ei*a));
a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

d_a3_dV_tnode_GND = ((2.0*d_z_dV_tnode_GND+0.75*d_a_dV_tnode_GND)-((0.20*a)*d_z_dV_tnode_GND+0.20*d_a_dV_tnode_GND*z));
d_a3_dV_bi_ci = ((2.0*d_z_dV_bi_ci+0.75*d_a_dV_bi_ci)-((0.20*a)*d_z_dV_bi_ci+0.20*d_a_dV_bi_ci*z));
d_a3_dV_bi_ei = ((2.0*d_z_dV_bi_ei+0.75*d_a_dV_bi_ei)-((0.20*a)*d_z_dV_bi_ei+0.20*d_a_dV_bi_ei*z));
a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

d_FCf2_dV_tnode_GND = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_tnode_GND+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_tnode_GND+((model_.latb)*d_a2_dV_tnode_GND+(model_.latl)*d_a3_dV_tnode_GND)*FCw)*FCw)/6.0);
d_FCf2_dV_bi_ci = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ci+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ci+((model_.latb)*d_a2_dV_bi_ci+(model_.latl)*d_a3_dV_bi_ci)*FCw)*FCw)/6.0);
d_FCf2_dV_bi_ei = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ei+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ei+((model_.latb)*d_a2_dV_bi_ei+(model_.latl)*d_a3_dV_bi_ei)*FCw)*FCw)/6.0);
FCf2 = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*FCw)/6.0);

d_FCdf2_dw_dV_tnode_GND = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_tnode_GND+((1+((model_.latl)*FCw))*d_z_dV_tnode_GND+(model_.latl)*d_FCw_dV_tnode_GND*(1+z))*lnzb);
d_FCdf2_dw_dV_bi_ci = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ci+((1+((model_.latl)*FCw))*d_z_dV_bi_ci+(model_.latl)*d_FCw_dV_bi_ci*(1+z))*lnzb);
d_FCdf2_dw_dV_bi_ei = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ei+((1+((model_.latl)*FCw))*d_z_dV_bi_ei+(model_.latl)*d_FCw_dV_bi_ei*(1+z))*lnzb);
FCdf2_dw = (((1+((model_.latl)*FCw))*(1+z))*lnzb);
}

d_z_dV_tnode_GND = (model_.latl)*d_FCw_dV_tnode_GND;
d_z_dV_bi_ci = (model_.latl)*d_FCw_dV_bi_ci;
d_z_dV_bi_ei = (model_.latl)*d_FCw_dV_bi_ei;
z = ((model_.latl)*FCw);
{
double value_log_0 = log((1+((model_.latl)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

d_lnzb_dV_tnode_GND = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_tnode_GND));
d_lnzb_dV_bi_ci = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ci));
d_lnzb_dV_bi_ei = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ei));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{

d_x_dV_tnode_GND = d_z_dV_tnode_GND;
d_x_dV_bi_ci = d_z_dV_bi_ci;
d_x_dV_bi_ei = d_z_dV_bi_ei;
x = (1.0+z);

d_a_dV_tnode_GND = (x*d_x_dV_tnode_GND+d_x_dV_tnode_GND*x);
d_a_dV_bi_ci = (x*d_x_dV_bi_ci+d_x_dV_bi_ci*x);
d_a_dV_bi_ei = (x*d_x_dV_bi_ei+d_x_dV_bi_ei*x);
a = (x*x);

d_a2_dV_tnode_GND = 0.250*(a*2.0*d_lnzb_dV_tnode_GND+d_a_dV_tnode_GND*((2.0*lnzb)-1.0));
d_a2_dV_bi_ci = 0.250*(a*2.0*d_lnzb_dV_bi_ci+d_a_dV_bi_ci*((2.0*lnzb)-1.0));
d_a2_dV_bi_ei = 0.250*(a*2.0*d_lnzb_dV_bi_ei+d_a_dV_bi_ei*((2.0*lnzb)-1.0));
a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

d_a3_dV_tnode_GND = (((a*x)*3.0*d_lnzb_dV_tnode_GND+(a*d_x_dV_tnode_GND+d_a_dV_tnode_GND*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ci = (((a*x)*3.0*d_lnzb_dV_bi_ci+(a*d_x_dV_bi_ci+d_a_dV_bi_ci*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ei = (((a*x)*3.0*d_lnzb_dV_bi_ei+(a*d_x_dV_bi_ei+d_a_dV_bi_ei*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
r = ((model_.latb)/(model_.latl));

d_FCf3_dV_tnode_GND = (((1.0-r)*d_a2_dV_tnode_GND+r*d_a3_dV_tnode_GND)/(model_.latl));
d_FCf3_dV_bi_ci = (((1.0-r)*d_a2_dV_bi_ci+r*d_a3_dV_bi_ci)/(model_.latl));
d_FCf3_dV_bi_ei = (((1.0-r)*d_a2_dV_bi_ei+r*d_a3_dV_bi_ei)/(model_.latl));
FCf3 = ((((1.0-r)*a2)+(r*a3))/(model_.latl));

d_FCdf3_dw_dV_tnode_GND = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND+((1.0-r)*d_x_dV_tnode_GND+r*d_a_dV_tnode_GND)*lnzb);
d_FCdf3_dw_dV_bi_ci = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci+((1.0-r)*d_x_dV_bi_ci+r*d_a_dV_bi_ci)*lnzb);
d_FCdf3_dw_dV_bi_ei = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei+((1.0-r)*d_x_dV_bi_ei+r*d_a_dV_bi_ei)*lnzb);
FCdf3_dw = ((((1.0-r)*x)+(r*a))*lnzb);
}
else
{

d_a_dV_tnode_GND = (z*d_z_dV_tnode_GND+d_z_dV_tnode_GND*z);
d_a_dV_bi_ci = (z*d_z_dV_bi_ci+d_z_dV_bi_ci*z);
d_a_dV_bi_ei = (z*d_z_dV_bi_ei+d_z_dV_bi_ei*z);
a = (z*z);

d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-0.25*d_a_dV_tnode_GND)+((0.10*z)*d_a_dV_tnode_GND+0.10*d_z_dV_tnode_GND*a));
d_a2_dV_bi_ci = ((d_z_dV_bi_ci-0.25*d_a_dV_bi_ci)+((0.10*z)*d_a_dV_bi_ci+0.10*d_z_dV_bi_ci*a));
d_a2_dV_bi_ei = ((d_z_dV_bi_ei-0.25*d_a_dV_bi_ei)+((0.10*z)*d_a_dV_bi_ei+0.10*d_z_dV_bi_ei*a));
a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

d_a3_dV_tnode_GND = ((2.0*d_z_dV_tnode_GND+0.75*d_a_dV_tnode_GND)-((0.20*a)*d_z_dV_tnode_GND+0.20*d_a_dV_tnode_GND*z));
d_a3_dV_bi_ci = ((2.0*d_z_dV_bi_ci+0.75*d_a_dV_bi_ci)-((0.20*a)*d_z_dV_bi_ci+0.20*d_a_dV_bi_ci*z));
d_a3_dV_bi_ei = ((2.0*d_z_dV_bi_ei+0.75*d_a_dV_bi_ei)-((0.20*a)*d_z_dV_bi_ei+0.20*d_a_dV_bi_ei*z));
a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

d_FCf3_dV_tnode_GND = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_tnode_GND+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_tnode_GND+((model_.latl)*d_a2_dV_tnode_GND+(model_.latb)*d_a3_dV_tnode_GND)*FCw)*FCw)/6.0);
d_FCf3_dV_bi_ci = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ci+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ci+((model_.latl)*d_a2_dV_bi_ci+(model_.latb)*d_a3_dV_bi_ci)*FCw)*FCw)/6.0);
d_FCf3_dV_bi_ei = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ei+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ei+((model_.latl)*d_a2_dV_bi_ei+(model_.latb)*d_a3_dV_bi_ei)*FCw)*FCw)/6.0);
FCf3 = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*FCw)/6.0);

d_FCdf3_dw_dV_tnode_GND = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_tnode_GND+((1+((model_.latb)*FCw))*d_z_dV_tnode_GND+(model_.latb)*d_FCw_dV_tnode_GND*(1+z))*lnzb);
d_FCdf3_dw_dV_bi_ci = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ci+((1+((model_.latb)*FCw))*d_z_dV_bi_ci+(model_.latb)*d_FCw_dV_bi_ci*(1+z))*lnzb);
d_FCdf3_dw_dV_bi_ei = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ei+((1+((model_.latb)*FCw))*d_z_dV_bi_ei+(model_.latb)*d_FCw_dV_bi_ei*(1+z))*lnzb);
FCdf3_dw = (((1+((model_.latb)*FCw))*(1+z))*lnzb);
}

d_FCf_ci_dV_tnode_GND = (FCf_CT*(((FCa1*d_FCf1_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCf1)-d_FCf2_dV_tnode_GND)+d_FCf3_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCf_ci_dV_bi_ci = (FCf_CT*(((FCa1*d_FCf1_dV_bi_ci+d_FCa1_dV_bi_ci*FCf1)-d_FCf2_dV_bi_ci)+d_FCf3_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCf_ci_dV_bi_ei = (FCf_CT*(((FCa1*d_FCf1_dV_bi_ei+d_FCa1_dV_bi_ei*FCf1)-d_FCf2_dV_bi_ei)+d_FCf3_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(((FCa1*FCf1)-FCf2)+FCf3));
FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));

d_FCdfc_dw_dV_tnode_GND = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_tnode_GND+d_FCda1_dw_dV_tnode_GND*FCf1))-d_FCdf2_dw_dV_tnode_GND)+d_FCdf3_dw_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdfc_dw_dV_bi_ci = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_bi_ci+d_FCa1_dV_bi_ci*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_bi_ci+d_FCda1_dw_dV_bi_ci*FCf1))-d_FCdf2_dw_dV_bi_ci)+d_FCdf3_dw_dV_bi_ci)+d_FCf_CT_dV_bi_ci*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdfc_dw_dV_bi_ei = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_bi_ei+d_FCa1_dV_bi_ei*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_bi_ei+d_FCda1_dw_dV_bi_ei*FCf1))-d_FCdf2_dw_dV_bi_ei)+d_FCdf3_dw_dV_bi_ei)+d_FCf_CT_dV_bi_ei*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));

d_FCdw_ditf_dV_tnode_GND = (FCdw_daick*d_FCdaick_ditf_dV_tnode_GND+d_FCdw_daick_dV_tnode_GND*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ci = (FCdw_daick*d_FCdaick_ditf_dV_bi_ci+d_FCdw_daick_dV_bi_ci*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ei = (FCdw_daick*d_FCdaick_ditf_dV_bi_ei+d_FCdw_daick_dV_bi_ei*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);

d_FCdfc_ditf_dV_tnode_GND = (FCdfc_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfc_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ci = (FCdfc_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfc_dw_dV_bi_ci*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ei = (FCdfc_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfc_dw_dV_bi_ei*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{

d_a_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_a_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_a_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
a = ((model_.latb)*FCw);
{
double value_log_0 = log((1+((model_.latb)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

d_lnz_dV_tnode_GND = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_tnode_GND));
d_lnz_dV_bi_ci = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ci));
d_lnz_dV_bi_ei = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ei));
lnz = value_log_0;
}
if ((a>1.0e-6))
{

d_FCf2_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latb));
d_FCf2_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latb));
d_FCf2_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latb));
FCf2 = ((a-lnz)/(model_.latb));

d_FCdf2_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
d_FCdf2_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
d_FCdf2_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
FCdf2_dw = (a/(1.0+a));
}
else
{

d_FCf2_dV_tnode_GND = ((0.5*a)*d_FCw_dV_tnode_GND+0.5*d_a_dV_tnode_GND*FCw);
d_FCf2_dV_bi_ci = ((0.5*a)*d_FCw_dV_bi_ci+0.5*d_a_dV_bi_ci*FCw);
d_FCf2_dV_bi_ei = ((0.5*a)*d_FCw_dV_bi_ei+0.5*d_a_dV_bi_ei*FCw);
FCf2 = ((0.5*a)*FCw);

d_FCdf2_dw_dV_tnode_GND = d_a_dV_tnode_GND;
d_FCdf2_dw_dV_bi_ci = d_a_dV_bi_ci;
d_FCdf2_dw_dV_bi_ei = d_a_dV_bi_ei;
FCdf2_dw = a;
}

d_a_dV_tnode_GND = (model_.latl)*d_FCw_dV_tnode_GND;
d_a_dV_bi_ci = (model_.latl)*d_FCw_dV_bi_ci;
d_a_dV_bi_ei = (model_.latl)*d_FCw_dV_bi_ei;
a = ((model_.latl)*FCw);
{
double value_log_0 = log((1+((model_.latl)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

d_lnz_dV_tnode_GND = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_tnode_GND));
d_lnz_dV_bi_ci = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ci));
d_lnz_dV_bi_ei = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ei));
lnz = value_log_0;
}
if ((a>1.0e-6))
{

d_FCf3_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latl));
d_FCf3_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latl));
d_FCf3_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latl));
FCf3 = ((a-lnz)/(model_.latl));

d_FCdf3_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
d_FCdf3_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
d_FCdf3_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
FCdf3_dw = (a/(1.0+a));
}
else
{

d_FCf3_dV_tnode_GND = ((0.5*a)*d_FCw_dV_tnode_GND+0.5*d_a_dV_tnode_GND*FCw);
d_FCf3_dV_bi_ci = ((0.5*a)*d_FCw_dV_bi_ci+0.5*d_a_dV_bi_ci*FCw);
d_FCf3_dV_bi_ei = ((0.5*a)*d_FCw_dV_bi_ei+0.5*d_a_dV_bi_ei*FCw);
FCf3 = ((0.5*a)*FCw);

d_FCdf3_dw_dV_tnode_GND = d_a_dV_tnode_GND;
d_FCdf3_dw_dV_bi_ci = d_a_dV_bi_ci;
d_FCdf3_dw_dV_bi_ei = d_a_dV_bi_ei;
FCdf3_dw = a;
}

d_FCf_CT_dV_tnode_GND = (FCf_CT*(d_FCf2_dV_tnode_GND-d_FCf3_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(FCf2-FCf3));
d_FCf_CT_dV_bi_ci = (FCf_CT*(d_FCf2_dV_bi_ci-d_FCf3_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(FCf2-FCf3));
d_FCf_CT_dV_bi_ei = (FCf_CT*(d_FCf2_dV_bi_ei-d_FCf3_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(FCf2-FCf3));
FCf_CT = (FCf_CT*(FCf2-FCf3));

d_FCdfCT_dw_dV_tnode_GND = (FCf_CT*(d_FCdf2_dw_dV_tnode_GND-d_FCdf3_dw_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_dw_dV_bi_ci = (FCf_CT*(d_FCdf2_dw_dV_bi_ci-d_FCdf3_dw_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_dw_dV_bi_ei = (FCf_CT*(d_FCdf2_dw_dV_bi_ei-d_FCdf3_dw_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(FCdf2_dw-FCdf3_dw));
FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));

d_FCdfCT_ditf_dV_tnode_GND = (FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ci = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfCT_dw_dV_bi_ci*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ei = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfCT_dw_dV_bi_ei*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{

d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
FCf_CT = FCf_ci;

d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
FCdfCT_ditf = FCdfc_ditf;
}
}
else
{
if (((model_.latb)>0.01))
{

d_FCd_a_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ci = (-d_FCa_ck_dV_bi_ci*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ei = (-d_FCa_ck_dV_bi_ei*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

d_FCw_dV_tnode_GND = ((1.0-FCa_ck)*d_FCd_a_dV_tnode_GND+(-d_FCa_ck_dV_tnode_GND)*FCd_a);
d_FCw_dV_bi_ci = ((1.0-FCa_ck)*d_FCd_a_dV_bi_ci+(-d_FCa_ck_dV_bi_ci)*FCd_a);
d_FCw_dV_bi_ei = ((1.0-FCa_ck)*d_FCd_a_dV_bi_ei+(-d_FCa_ck_dV_bi_ei)*FCd_a);
FCw = ((1.0-FCa_ck)*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_tnode_GND+(-(1.0+(model_.latb)))*d_FCd_a_dV_tnode_GND*FCd_a);
d_FCdw_daick_dV_bi_ci = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ci+(-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ci*FCd_a);
d_FCdw_daick_dV_bi_ei = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ei+(-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ei*FCd_a);
FCdw_daick = (((-(1.0+(model_.latb)))*FCd_a)*FCd_a);
}
else
{

d_FCw_dV_tnode_GND = ((-d_FCa_ck_dV_tnode_GND)-d_FCa_ck_dV_tnode_GND*(model_.latb));
d_FCw_dV_bi_ci = ((-d_FCa_ck_dV_bi_ci)-d_FCa_ck_dV_bi_ci*(model_.latb));
d_FCw_dV_bi_ei = ((-d_FCa_ck_dV_bi_ei)-d_FCa_ck_dV_bi_ei*(model_.latb));
FCw = ((1.0-FCa_ck)-(FCa_ck*(model_.latb)));

d_FCdw_daick_dV_bi_ei = d_FCdw_daick_dV_bi_ci = d_FCdw_daick_dV_tnode_GND =  0.0;
FCdw_daick = (-(1.0+(model_.latb)));
}

d_FCw2_dV_tnode_GND = (FCw*d_FCw_dV_tnode_GND+d_FCw_dV_tnode_GND*FCw);
d_FCw2_dV_bi_ci = (FCw*d_FCw_dV_bi_ci+d_FCw_dV_bi_ci*FCw);
d_FCw2_dV_bi_ei = (FCw*d_FCw_dV_bi_ei+d_FCw_dV_bi_ei*FCw);
FCw2 = (FCw*FCw);

d_FCz_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_FCz_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_FCz_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
FCz = ((model_.latb)*FCw);

d_FCz_1_dV_tnode_GND = d_FCz_dV_tnode_GND;
d_FCz_1_dV_bi_ci = d_FCz_dV_bi_ci;
d_FCz_1_dV_bi_ei = d_FCz_dV_bi_ei;
FCz_1 = (1.0+FCz);

d_FCd_f_dV_tnode_GND = (-d_FCz_1_dV_tnode_GND/FCz_1/FCz_1);
d_FCd_f_dV_bi_ci = (-d_FCz_1_dV_bi_ci/FCz_1/FCz_1);
d_FCd_f_dV_bi_ei = (-d_FCz_1_dV_bi_ei/FCz_1/FCz_1);
FCd_f = (1.0/FCz_1);

d_FCf_ci_dV_tnode_GND = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_tnode_GND+(FCw2*(d_FCz_dV_tnode_GND/3.0)+d_FCw2_dV_tnode_GND*(1.0+(FCz/3.0)))*FCd_f);
d_FCf_ci_dV_bi_ci = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ci+(FCw2*(d_FCz_dV_bi_ci/3.0)+d_FCw2_dV_bi_ci*(1.0+(FCz/3.0)))*FCd_f);
d_FCf_ci_dV_bi_ei = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ei+(FCw2*(d_FCz_dV_bi_ei/3.0)+d_FCw2_dV_bi_ei*(1.0+(FCz/3.0)))*FCd_f);
FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);

d_FCdfc_dw_dV_tnode_GND = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND+((2.0*FCw)*(d_FCz_1_dV_tnode_GND+((FCz*d_FCz_dV_tnode_GND+d_FCz_dV_tnode_GND*FCz)/3.0))+2.0*d_FCw_dV_tnode_GND*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfc_dw_dV_bi_ci = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci+((2.0*FCw)*(d_FCz_1_dV_bi_ci+((FCz*d_FCz_dV_bi_ci+d_FCz_dV_bi_ci*FCz)/3.0))+2.0*d_FCw_dV_bi_ci*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfc_dw_dV_bi_ei = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei+((2.0*FCw)*(d_FCz_1_dV_bi_ei+((FCz*d_FCz_dV_bi_ei+d_FCz_dV_bi_ei*FCz)/3.0))+2.0*d_FCw_dV_bi_ei*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);

d_FCdw_ditf_dV_tnode_GND = (FCdw_daick*d_FCdaick_ditf_dV_tnode_GND+d_FCdw_daick_dV_tnode_GND*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ci = (FCdw_daick*d_FCdaick_ditf_dV_bi_ci+d_FCdw_daick_dV_bi_ci*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ei = (FCdw_daick*d_FCdaick_ditf_dV_bi_ei+d_FCdw_daick_dV_bi_ei*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);

d_FCdfc_ditf_dV_tnode_GND = (FCdfc_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfc_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ci = (FCdfc_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfc_dw_dV_bi_ci*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ei = (FCdfc_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfc_dw_dV_bi_ei*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{
if ((FCz>0.001))
{
{
double value_log_0 = log(FCz_1);
double  deriv_log_0_d0 = (1.0/FCz_1);

d_FCf_CT_dV_tnode_GND = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_tnode_GND))+d_FCz_1_dV_tnode_GND*value_log_0)-d_FCz_dV_tnode_GND)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_tnode_GND)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
d_FCf_CT_dV_bi_ci = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ci))+d_FCz_1_dV_bi_ci*value_log_0)-d_FCz_dV_bi_ci)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ci)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
d_FCf_CT_dV_bi_ei = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ei))+d_FCz_1_dV_bi_ei*value_log_0)-d_FCz_dV_bi_ei)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ei)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/(((model_.latb)*(model_.latb))*FCz_1));
}

d_FCdfCT_dw_dV_tnode_GND = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_tnode_GND+((2.0*FCw)*d_FCd_f_dV_tnode_GND+2.0*d_FCw_dV_tnode_GND*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ci = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ci+((2.0*FCw)*d_FCd_f_dV_bi_ci+2.0*d_FCw_dV_bi_ci*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ei = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ei+((2.0*FCw)*d_FCd_f_dV_bi_ei+2.0*d_FCw_dV_bi_ei*FCd_f)*FCd_f);
FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
}
else
{

d_FCf_CT_dV_tnode_GND = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_tnode_GND+(FCw2*(-(d_FCz_dV_tnode_GND/3.0))+d_FCw2_dV_tnode_GND*(1.0-(FCz/3.0)))*FCd_f);
d_FCf_CT_dV_bi_ci = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ci+(FCw2*(-(d_FCz_dV_bi_ci/3.0))+d_FCw2_dV_bi_ci*(1.0-(FCz/3.0)))*FCd_f);
d_FCf_CT_dV_bi_ei = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ei+(FCw2*(-(d_FCz_dV_bi_ei/3.0))+d_FCw2_dV_bi_ei*(1.0-(FCz/3.0)))*FCd_f);
FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);

d_FCdfCT_dw_dV_tnode_GND = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND+((2.0*FCw)*(-((FCz*d_FCz_dV_tnode_GND+d_FCz_dV_tnode_GND*FCz)/3.0))+2.0*d_FCw_dV_tnode_GND*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ci = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci+((2.0*FCw)*(-((FCz*d_FCz_dV_bi_ci+d_FCz_dV_bi_ci*FCz)/3.0))+2.0*d_FCw_dV_bi_ci*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ei = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei+((2.0*FCw)*(-((FCz*d_FCz_dV_bi_ei+d_FCz_dV_bi_ei*FCz)/3.0))+2.0*d_FCw_dV_bi_ei*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
}

d_FCdfCT_ditf_dV_tnode_GND = (FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ci = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfCT_dw_dV_bi_ci*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ei = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfCT_dw_dV_bi_ei*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{

d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
FCf_CT = FCf_ci;

d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
FCdfCT_ditf = FCdfc_ditf;
}
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQcfcT_dV_bi_ci = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(FFdQcfc*d_FCf_CT_dV_bi_ci+d_FFdQcfc_dV_bi_ci*FCf_CT)*value_exp_0);
d_FFdQcfcT_dV_bi_ei = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(FFdQcfc*d_FCf_CT_dV_bi_ei+d_FFdQcfc_dV_bi_ei*FCf_CT)*value_exp_0);
d_FFdQcfcT_dV_tnode_GND = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(FFdQcfc*d_FCf_CT_dV_tnode_GND+d_FFdQcfc_dV_tnode_GND*FCf_CT)*value_exp_0);
FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQcfc_dV_bi_ci = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(FFdQcfc*d_FCf_ci_dV_bi_ci+d_FFdQcfc_dV_bi_ci*FCf_ci)*value_exp_0);
d_FFdQcfc_dV_bi_ei = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(FFdQcfc*d_FCf_ci_dV_bi_ei+d_FFdQcfc_dV_bi_ei*FCf_ci)*value_exp_0);
d_FFdQcfc_dV_tnode_GND = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(FFdQcfc*d_FCf_ci_dV_tnode_GND+d_FFdQcfc_dV_tnode_GND*FCf_ci)*value_exp_0);
FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTcfc_dV_bi_ci = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ci+(itf*d_FCdfc_ditf_dV_bi_ci+d_itf_dV_bi_ci*FCdfc_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ci+(d_FFdQcfc_dV_bi_ci/VT)*FFdVc_ditf));
d_FFdTcfc_dV_bi_ei = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ei+(itf*d_FCdfc_ditf_dV_bi_ei+d_itf_dV_bi_ei*FCdfc_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ei+(d_FFdQcfc_dV_bi_ei/VT)*FFdVc_ditf));
d_FFdTcfc_dV_tnode_GND = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_tnode_GND+(itf*d_FCdfc_ditf_dV_tnode_GND+d_itf_dV_tnode_GND*FCdfc_ditf))+(((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(model_.fthc)*d_thcs_t_dV_tnode_GND*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*d_FFdQcfc_dV_tnode_GND-FFdQcfc*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTcfc = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*FFdVc_ditf));
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTcfcT_dV_bi_ci = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ci+(itf*d_FCdfCT_ditf_dV_bi_ci+d_itf_dV_bi_ci*FCdfCT_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ci+(d_FFdQcfcT_dV_bi_ci/VT)*FFdVc_ditf));
d_FFdTcfcT_dV_bi_ei = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ei+(itf*d_FCdfCT_ditf_dV_bi_ei+d_itf_dV_bi_ei*FCdfCT_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ei+(d_FFdQcfcT_dV_bi_ei/VT)*FFdVc_ditf));
d_FFdTcfcT_dV_tnode_GND = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_tnode_GND+(itf*d_FCdfCT_ditf_dV_tnode_GND+d_itf_dV_tnode_GND*FCdfCT_ditf))+(((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(model_.fthc)*d_thcs_t_dV_tnode_GND*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*d_FFdQcfcT_dV_tnode_GND-FFdQcfcT*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTcfcT = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*FFdVc_ditf));
}
}

d_FFdQbfc_dV_bi_ci = (1-(model_.fthc))*d_FFdQfhc_dV_bi_ci;
d_FFdQbfc_dV_bi_ei = (1-(model_.fthc))*d_FFdQfhc_dV_bi_ei;
d_FFdQbfc_dV_tnode_GND = (1-(model_.fthc))*d_FFdQfhc_dV_tnode_GND;
FFdQbfc = ((1-(model_.fthc))*FFdQfhc);

d_FFdTbfc_dV_bi_ci = (1-(model_.fthc))*d_FFdTfhc_dV_bi_ci;
d_FFdTbfc_dV_bi_ei = (1-(model_.fthc))*d_FFdTfhc_dV_bi_ei;
d_FFdTbfc_dV_tnode_GND = (1-(model_.fthc))*d_FFdTfhc_dV_tnode_GND;
FFdTbfc = ((1-(model_.fthc))*FFdTfhc);

d_Q_fT_dV_bi_ei = ((((hf0_t*d_Qf_dV_bi_ei+d_FFdQbfb_dV_bi_ei)+d_FFdQbfc_dV_bi_ei)+hfe_t*d_FFdQef_dV_bi_ei)+hfc_t*d_FFdQcfcT_dV_bi_ei);
d_Q_fT_dV_bi_ci = ((((hf0_t*d_Qf_dV_bi_ci+d_FFdQbfb_dV_bi_ci)+d_FFdQbfc_dV_bi_ci)+hfe_t*d_FFdQef_dV_bi_ci)+hfc_t*d_FFdQcfcT_dV_bi_ci);
d_Q_fT_dV_tnode_GND = (((((hf0_t*d_Qf_dV_tnode_GND+d_hf0_t_dV_tnode_GND*Qf)+d_FFdQbfb_dV_tnode_GND)+d_FFdQbfc_dV_tnode_GND)+(hfe_t*d_FFdQef_dV_tnode_GND+d_hfe_t_dV_tnode_GND*FFdQef))+(hfc_t*d_FFdQcfcT_dV_tnode_GND+d_hfc_t_dV_tnode_GND*FFdQcfcT));
Q_fT = (((((hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(hfe_t*FFdQef))+(hfc_t*FFdQcfcT));

d_T_fT_dV_bi_ci = ((((hf0_t*d_Tf_dV_bi_ci+d_FFdTbfb_dV_bi_ci)+d_FFdTbfc_dV_bi_ci)+hfe_t*d_FFdTef_dV_bi_ci)+hfc_t*d_FFdTcfcT_dV_bi_ci);
d_T_fT_dV_bi_ei = ((((hf0_t*d_Tf_dV_bi_ei+d_FFdTbfb_dV_bi_ei)+d_FFdTbfc_dV_bi_ei)+hfe_t*d_FFdTef_dV_bi_ei)+hfc_t*d_FFdTcfcT_dV_bi_ei);
d_T_fT_dV_tnode_GND = (((((hf0_t*d_Tf_dV_tnode_GND+d_hf0_t_dV_tnode_GND*Tf)+d_FFdTbfb_dV_tnode_GND)+d_FFdTbfc_dV_tnode_GND)+(hfe_t*d_FFdTef_dV_tnode_GND+d_hfe_t_dV_tnode_GND*FFdTef))+(hfc_t*d_FFdTcfcT_dV_tnode_GND+d_hfc_t_dV_tnode_GND*FFdTcfcT));
T_fT = (((((hf0_t*Tf)+FFdTbfb)+FFdTbfc)+(hfe_t*FFdTef))+(hfc_t*FFdTcfcT));

d_Qf_dV_bi_ei = (((d_Qf_dV_bi_ei+(d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei))+d_FFdQef_dV_bi_ei)+d_FFdQcfc_dV_bi_ei);
d_Qf_dV_bi_ci = (((d_Qf_dV_bi_ci+(d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci))+d_FFdQef_dV_bi_ci)+d_FFdQcfc_dV_bi_ci);
d_Qf_dV_tnode_GND = (((d_Qf_dV_tnode_GND+(d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND))+d_FFdQef_dV_tnode_GND)+d_FFdQcfc_dV_tnode_GND);
Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);

d_Tf_dV_bi_ci = (((d_Tf_dV_bi_ci+(d_FFdTbfb_dV_bi_ci+d_FFdTbfc_dV_bi_ci))+d_FFdTef_dV_bi_ci)+d_FFdTcfc_dV_bi_ci);
d_Tf_dV_tnode_GND = (((d_Tf_dV_tnode_GND+(d_FFdTbfb_dV_tnode_GND+d_FFdTbfc_dV_tnode_GND))+d_FFdTef_dV_tnode_GND)+d_FFdTcfc_dV_tnode_GND);
d_Tf_dV_bi_ei = (((d_Tf_dV_bi_ei+(d_FFdTbfb_dV_bi_ei+d_FFdTbfc_dV_bi_ei))+d_FFdTef_dV_bi_ei)+d_FFdTcfc_dV_bi_ei);
Tf = (((Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);

d_Q_bf_dV_bi_ci = (d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci);
d_Q_bf_dV_bi_ei = (d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei);
d_Q_bf_dV_tnode_GND = (d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND);
Q_bf = (FFdQbfb+FFdQbfc);
}

d_Qr_dV_bi_ei = Tr*d_itr_dV_bi_ei;
d_Qr_dV_bi_ci = Tr*d_itr_dV_bi_ci;
d_Qr_dV_tnode_GND = Tr*d_itr_dV_tnode_GND;
Qr = (Tr*itr);
if ((Oich==0.0))
{

d_a_dV_bi_ci = ((Q_pT*((T_fT*d_itf_dV_bi_ci+d_T_fT_dV_bi_ci*itf)+d_Qr_dV_bi_ci)-((T_fT*itf)+Qr)*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
d_a_dV_tnode_GND = ((Q_pT*((T_fT*d_itf_dV_tnode_GND+d_T_fT_dV_tnode_GND*itf)+d_Qr_dV_tnode_GND)-((T_fT*itf)+Qr)*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
d_a_dV_bi_ei = ((Q_pT*((T_fT*d_itf_dV_bi_ei+d_T_fT_dV_bi_ei*itf)+d_Qr_dV_bi_ei)-((T_fT*itf)+Qr)*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
a = (1.0+(((T_fT*itf)+Qr)/Q_pT));
}
else
{

d_a_dV_bi_ci = ((Q_pT*(((T_fT*I_Tf1)*2.0*d_a_h_dV_bi_ci+(T_fT*d_I_Tf1_dV_bi_ci+d_T_fT_dV_bi_ci*I_Tf1)*(1.0+(2.0*a_h)))+d_Qr_dV_bi_ci)-(((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
d_a_dV_tnode_GND = ((Q_pT*(((T_fT*I_Tf1)*2.0*d_a_h_dV_tnode_GND+(T_fT*d_I_Tf1_dV_tnode_GND+d_T_fT_dV_tnode_GND*I_Tf1)*(1.0+(2.0*a_h)))+d_Qr_dV_tnode_GND)-(((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
d_a_dV_bi_ei = ((Q_pT*(((T_fT*I_Tf1)*2.0*d_a_h_dV_bi_ei+(T_fT*d_I_Tf1_dV_bi_ei+d_T_fT_dV_bi_ei*I_Tf1)*(1.0+(2.0*a_h)))+d_Qr_dV_bi_ei)-(((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
a = (1.0+((((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)/Q_pT));
}

d_d_Q_dV_bi_ci = ((a*(-(d_Q_pT_dV_bi_ci-((d_Q_0_dV_bi_ci+d_Q_fT_dV_bi_ci)+d_Qr_dV_bi_ci)))-(-(Q_pT-((Q_0+Q_fT)+Qr)))*d_a_dV_bi_ci)/a/a);
d_d_Q_dV_bi_ei = ((a*(-(d_Q_pT_dV_bi_ei-((d_Q_0_dV_bi_ei+d_Q_fT_dV_bi_ei)+d_Qr_dV_bi_ei)))-(-(Q_pT-((Q_0+Q_fT)+Qr)))*d_a_dV_bi_ei)/a/a);
d_d_Q_dV_tnode_GND = ((a*(-(d_Q_pT_dV_tnode_GND-((d_Q_0_dV_tnode_GND+d_Q_fT_dV_tnode_GND)+d_Qr_dV_tnode_GND)))-(-(Q_pT-((Q_0+Q_fT)+Qr)))*d_a_dV_tnode_GND)/a/a);
d_Q = ((-(Q_pT-((Q_0+Q_fT)+Qr)))/a);
{
double value_fabs_0 = fabs((0.3*Q_pT));
double  deriv_fabs_0_d0 = ((((0.3*Q_pT))>=0)?(+1.0):(-1.0));

d_a_dV_bi_ci = (deriv_fabs_0_d0*(0.3*d_Q_pT_dV_bi_ci));
d_a_dV_bi_ei = (deriv_fabs_0_d0*(0.3*d_Q_pT_dV_bi_ei));
d_a_dV_tnode_GND = (deriv_fabs_0_d0*(0.3*d_Q_pT_dV_tnode_GND));
a = value_fabs_0;
}
if ((fabs(d_Q)>a))
{
if ((d_Q>=0))
{

d_d_Q_dV_tnode_GND = d_a_dV_tnode_GND;
d_d_Q_dV_bi_ci = d_a_dV_bi_ci;
d_d_Q_dV_bi_ei = d_a_dV_bi_ei;
d_Q = a;
}
else
{

d_d_Q_dV_tnode_GND = (-d_a_dV_tnode_GND);
d_d_Q_dV_bi_ci = (-d_a_dV_bi_ci);
d_d_Q_dV_bi_ei = (-d_a_dV_bi_ei);
d_Q = (-a);
}
}

d_Q_pT_dV_bi_ci = (d_Q_pT_dV_bi_ci+d_d_Q_dV_bi_ci);
d_Q_pT_dV_bi_ei = (d_Q_pT_dV_bi_ei+d_d_Q_dV_bi_ei);
d_Q_pT_dV_tnode_GND = (d_Q_pT_dV_tnode_GND+d_d_Q_dV_tnode_GND);
Q_pT = (Q_pT+d_Q);
l_it = (l_it+1);
}

d_I_Tf1_dV_bi_ci = (-i_0f*d_Q_pT_dV_bi_ci/Q_pT/Q_pT);
d_I_Tf1_dV_bi_ei = ((Q_pT*d_i_0f_dV_bi_ei-i_0f*d_Q_pT_dV_bi_ei)/Q_pT/Q_pT);
d_I_Tf1_dV_tnode_GND = ((Q_pT*d_i_0f_dV_tnode_GND-i_0f*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
I_Tf1 = (i_0f/Q_pT);

d_a_h_dV_bi_ci = Oich*d_I_Tf1_dV_bi_ci;
d_a_h_dV_bi_ei = Oich*d_I_Tf1_dV_bi_ei;
d_a_h_dV_tnode_GND = Oich*d_I_Tf1_dV_tnode_GND;
a_h = (Oich*I_Tf1);

d_itf_dV_bi_ci = (I_Tf1*d_a_h_dV_bi_ci+d_I_Tf1_dV_bi_ci*(1.0+a_h));
d_itf_dV_bi_ei = (I_Tf1*d_a_h_dV_bi_ei+d_I_Tf1_dV_bi_ei*(1.0+a_h));
d_itf_dV_tnode_GND = (I_Tf1*d_a_h_dV_tnode_GND+d_I_Tf1_dV_tnode_GND*(1.0+a_h));
itf = (I_Tf1*(1.0+a_h));

d_itr_dV_bi_ei = (-i_0r*d_Q_pT_dV_bi_ei/Q_pT/Q_pT);
d_itr_dV_bi_ci = ((Q_pT*d_i_0r_dV_bi_ci-i_0r*d_Q_pT_dV_bi_ci)/Q_pT/Q_pT);
d_itr_dV_tnode_GND = ((Q_pT*d_i_0r_dV_tnode_GND-i_0r*d_Q_pT_dV_tnode_GND)/Q_pT/Q_pT);
itr = (i_0r/Q_pT);

d_Tf_dV_bi_ei =  0.0;
d_Tf_dV_bi_ci = d_T_f0_dV_bi_ci;
d_Tf_dV_tnode_GND = d_T_f0_dV_tnode_GND;
Tf = T_f0;

d_Qf_dV_bi_ei = T_f0*d_itf_dV_bi_ei;
d_Qf_dV_bi_ci = (T_f0*d_itf_dV_bi_ci+d_T_f0_dV_bi_ci*itf);
d_Qf_dV_tnode_GND = (T_f0*d_itf_dV_tnode_GND+d_T_f0_dV_tnode_GND*itf);
Qf = (T_f0*itf);
if ((itf<(1.0e-6*ick)))
{

d_Q_fT_dV_bi_ei = d_Qf_dV_bi_ei;
d_Q_fT_dV_bi_ci = d_Qf_dV_bi_ci;
d_Q_fT_dV_tnode_GND = d_Qf_dV_tnode_GND;
Q_fT = Qf;

d_T_fT_dV_bi_ci = d_Tf_dV_bi_ci;
d_T_fT_dV_tnode_GND = d_Tf_dV_tnode_GND;
d_T_fT_dV_bi_ei = d_Tf_dV_bi_ei;
T_fT = Tf;

d_Q_bf_dV_tnode_GND = d_Q_bf_dV_bi_ei = d_Q_bf_dV_bi_ci =  0.0;
Q_bf = 0;
}
else
{

d_FFitf_ick_dV_bi_ci = ((ick*d_itf_dV_bi_ci-itf*d_ick_dV_bi_ci)/ick/ick);
d_FFitf_ick_dV_bi_ei = ((ick*d_itf_dV_bi_ei-itf*d_ick_dV_bi_ei)/ick/ick);
d_FFitf_ick_dV_tnode_GND = ((ick*d_itf_dV_tnode_GND-itf*d_ick_dV_tnode_GND)/ick/ick);
FFitf_ick = (itf/ick);
{
double value_log_0 = log(FFitf_ick);
double value_exp_1 = exp(((model_.gtfe)*value_log_0));
double  deriv_log_0_d0 = (1.0/FFitf_ick);
double  deriv_exp_1_d0 = value_exp_1;

d_FFdTef_dV_bi_ci = tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ci))));
d_FFdTef_dV_bi_ei = tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_bi_ei))));
d_FFdTef_dV_tnode_GND = (tef0_t*(deriv_exp_1_d0*((model_.gtfe)*(deriv_log_0_d0*(d_FFitf_ick_dV_tnode_GND))))+d_tef0_t_dV_tnode_GND*value_exp_1);
FFdTef = (tef0_t*value_exp_1);
}

d_FFdQef_dV_bi_ci = ((FFdTef*d_itf_dV_bi_ci+d_FFdTef_dV_bi_ci*itf)/(1+(model_.gtfe)));
d_FFdQef_dV_bi_ei = ((FFdTef*d_itf_dV_bi_ei+d_FFdTef_dV_bi_ei*itf)/(1+(model_.gtfe)));
d_FFdQef_dV_tnode_GND = ((FFdTef*d_itf_dV_tnode_GND+d_FFdTef_dV_tnode_GND*itf)/(1+(model_.gtfe)));
FFdQef = ((FFdTef*itf)/(1+(model_.gtfe)));
if (((model_.icbar)<(0.05*((model_.vlim)/(model_.rci0)))))
{

d_FFdVc_dV_tnode_GND = d_FFdVc_dV_bi_ei = d_FFdVc_dV_bi_ci =  0.0;
FFdVc = 0;

d_FFdVc_ditf_dV_tnode_GND = d_FFdVc_ditf_dV_bi_ei = d_FFdVc_ditf_dV_bi_ci =  0.0;
FFdVc_ditf = 0;
}
else
{

d_FFib_dV_bi_ci = ((d_itf_dV_bi_ci-d_ick_dV_bi_ci)/(model_.icbar));
d_FFib_dV_bi_ei = ((d_itf_dV_bi_ei-d_ick_dV_bi_ei)/(model_.icbar));
d_FFib_dV_tnode_GND = ((d_itf_dV_tnode_GND-d_ick_dV_tnode_GND)/(model_.icbar));
FFib = ((itf-ick)/(model_.icbar));
if ((FFib<(-1.0e10)))
{

d_FFib_dV_tnode_GND = d_FFib_dV_bi_ei = d_FFib_dV_bi_ci =  0.0;
FFib = (-1.0e10);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFfcbar_dV_bi_ci = ((d_FFib_dV_bi_ci+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ci+d_FFib_dV_bi_ci*FFib))))/2.0);
d_FFfcbar_dV_bi_ei = ((d_FFib_dV_bi_ei+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ei+d_FFib_dV_bi_ei*FFib))))/2.0);
d_FFfcbar_dV_tnode_GND = ((d_FFib_dV_tnode_GND+(deriv_sqrt_0_d0*((FFib*d_FFib_dV_tnode_GND+d_FFib_dV_tnode_GND*FFib))))/2.0);
FFfcbar = ((FFib+value_sqrt_0)/2.0);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+(model_.acbar)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFdib_ditf_dV_bi_ci = (((value_sqrt_0*d_FFfcbar_dV_bi_ci-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ci+d_FFib_dV_bi_ci*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
d_FFdib_ditf_dV_bi_ei = (((value_sqrt_0*d_FFfcbar_dV_bi_ei-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_bi_ei+d_FFib_dV_bi_ei*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
d_FFdib_ditf_dV_tnode_GND = (((value_sqrt_0*d_FFfcbar_dV_tnode_GND-FFfcbar*(deriv_sqrt_0_d0*((FFib*d_FFib_dV_tnode_GND+d_FFib_dV_tnode_GND*FFib))))/value_sqrt_0/value_sqrt_0)/(model_.icbar));
FFdib_ditf = ((FFfcbar/value_sqrt_0)/(model_.icbar));
}
{
double value_exp_0 = exp(((-1.0)/FFfcbar));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdVc_dV_bi_ci = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ci/FFfcbar/FFfcbar)));
d_FFdVc_dV_bi_ei = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_bi_ei/FFfcbar/FFfcbar)));
d_FFdVc_dV_tnode_GND = (model_.vcbar)*(deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dV_tnode_GND/FFfcbar/FFfcbar)));
FFdVc = ((model_.vcbar)*value_exp_0);
}

d_FFdVc_ditf_dV_bi_ci = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ci+(((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ci-FFdVc*(FFfcbar*d_FFfcbar_dV_bi_ci+d_FFfcbar_dV_bi_ci*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
d_FFdVc_ditf_dV_bi_ei = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_bi_ei+(((FFfcbar*FFfcbar)*d_FFdVc_dV_bi_ei-FFdVc*(FFfcbar*d_FFfcbar_dV_bi_ei+d_FFfcbar_dV_bi_ei*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
d_FFdVc_ditf_dV_tnode_GND = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dV_tnode_GND+(((FFfcbar*FFfcbar)*d_FFdVc_dV_tnode_GND-FFdVc*(FFfcbar*d_FFfcbar_dV_tnode_GND+d_FFfcbar_dV_tnode_GND*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
}
{
double value_exp_0 = exp((FFdVc/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQbfb_dV_bi_ci = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci*(value_exp_0-1));
d_FFdQbfb_dV_bi_ei = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei*(value_exp_0-1));
d_FFdQbfb_dV_tnode_GND = ((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT)))+(((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND+(1-(model_.fthc))*d_thcs_t_dV_tnode_GND*itf)*(value_exp_0-1));
FFdQbfb = ((((1-(model_.fthc))*thcs_t)*itf)*(value_exp_0-1));
}
{
double value_exp_0 = exp((FFdVc/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTbfb_dV_bi_ci = (((itf*d_FFdQbfb_dV_bi_ci-FFdQbfb*d_itf_dV_bi_ci)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ci+(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ci*value_exp_0)/VT)*FFdVc_ditf));
d_FFdTbfb_dV_bi_ei = (((itf*d_FFdQbfb_dV_bi_ei-FFdQbfb*d_itf_dV_bi_ei)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_bi_ei+(((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+((1-(model_.fthc))*thcs_t)*d_itf_dV_bi_ei*value_exp_0)/VT)*FFdVc_ditf));
d_FFdTbfb_dV_tnode_GND = (((itf*d_FFdQbfb_dV_tnode_GND-FFdQbfb*d_itf_dV_tnode_GND)/itf/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*((((1-(model_.fthc))*thcs_t)*itf)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-FFdVc*d_VT_dV_tnode_GND)/VT/VT)))+(((1-(model_.fthc))*thcs_t)*d_itf_dV_tnode_GND+(1-(model_.fthc))*d_thcs_t_dV_tnode_GND*itf)*value_exp_0)-((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTbfb = ((FFdQbfb/itf)+((((((1-(model_.fthc))*thcs_t)*itf)*value_exp_0)/VT)*FFdVc_ditf));
}

d_FFic_dV_bi_ci = (-(-d_FFitf_ick_dV_bi_ci/FFitf_ick/FFitf_ick));
d_FFic_dV_bi_ei = (-(-d_FFitf_ick_dV_bi_ei/FFitf_ick/FFitf_ick));
d_FFic_dV_tnode_GND = (-(-d_FFitf_ick_dV_tnode_GND/FFitf_ick/FFitf_ick));
FFic = (1-(1.0/FFitf_ick));
{
double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
double value_sqrt_1 = sqrt((1+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFw_dV_bi_ci = ((d_FFic_dV_bi_ci+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ci+d_FFic_dV_bi_ci*FFic))))/(1+value_sqrt_1));
d_FFw_dV_bi_ei = ((d_FFic_dV_bi_ei+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ei+d_FFic_dV_bi_ei*FFic))))/(1+value_sqrt_1));
d_FFw_dV_tnode_GND = ((d_FFic_dV_tnode_GND+(deriv_sqrt_0_d0*((FFic*d_FFic_dV_tnode_GND+d_FFic_dV_tnode_GND*FFic))))/(1+value_sqrt_1));
FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQfhc_dV_bi_ci = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_bi_ci+((thcs_t*itf)*d_FFw_dV_bi_ci+thcs_t*d_itf_dV_bi_ci*FFw)*FFw)*value_exp_0);
d_FFdQfhc_dV_bi_ei = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_bi_ei+((thcs_t*itf)*d_FFw_dV_bi_ei+thcs_t*d_itf_dV_bi_ei*FFw)*FFw)*value_exp_0);
d_FFdQfhc_dV_tnode_GND = ((((thcs_t*itf)*FFw)*FFw)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(((thcs_t*itf)*FFw)*d_FFw_dV_tnode_GND+((thcs_t*itf)*d_FFw_dV_tnode_GND+(thcs_t*d_itf_dV_tnode_GND+d_thcs_t_dV_tnode_GND*itf)*FFw)*FFw)*value_exp_0);
FFdQfhc = ((((thcs_t*itf)*FFw)*FFw)*value_exp_0);
}
{
double value_sqrt_0 = sqrt(((FFic*FFic)+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FFdTfhc_dV_bi_ci = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ci+d_FFic_dV_bi_ci*FFic)))+d_FFitf_ick_dV_bi_ci*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_bi_ci/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+(1.0/VT)*d_FFdVc_ditf_dV_bi_ci)+d_FFdQfhc_dV_bi_ci*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
d_FFdTfhc_dV_bi_ei = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_bi_ei+d_FFic_dV_bi_ei*FFic)))+d_FFitf_ick_dV_bi_ei*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_bi_ei/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+(1.0/VT)*d_FFdVc_ditf_dV_bi_ei)+d_FFdQfhc_dV_bi_ei*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
d_FFdTfhc_dV_tnode_GND = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*(deriv_sqrt_0_d0*((FFic*d_FFic_dV_tnode_GND+d_FFic_dV_tnode_GND*FFic)))+d_FFitf_ick_dV_tnode_GND*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dV_tnode_GND/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*d_FFdVc_ditf_dV_tnode_GND+(-d_VT_dV_tnode_GND/VT/VT)*FFdVc_ditf))+d_FFdQfhc_dV_tnode_GND*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/VT)*FFdVc_ditf)));
}
if ((((model_.latb)<=0.0)&&((model_.latl)<=0.0)))
{

d_FFdQcfc_dV_bi_ci = (model_.fthc)*d_FFdQfhc_dV_bi_ci;
d_FFdQcfc_dV_bi_ei = (model_.fthc)*d_FFdQfhc_dV_bi_ei;
d_FFdQcfc_dV_tnode_GND = (model_.fthc)*d_FFdQfhc_dV_tnode_GND;
FFdQcfc = ((model_.fthc)*FFdQfhc);

d_FFdTcfc_dV_bi_ci = (model_.fthc)*d_FFdTfhc_dV_bi_ci;
d_FFdTcfc_dV_bi_ei = (model_.fthc)*d_FFdTfhc_dV_bi_ei;
d_FFdTcfc_dV_tnode_GND = (model_.fthc)*d_FFdTfhc_dV_tnode_GND;
FFdTcfc = ((model_.fthc)*FFdTfhc);

d_FFdQcfcT_dV_bi_ci = d_FFdQcfc_dV_bi_ci;
d_FFdQcfcT_dV_bi_ei = d_FFdQcfc_dV_bi_ei;
d_FFdQcfcT_dV_tnode_GND = d_FFdQcfc_dV_tnode_GND;
FFdQcfcT = FFdQcfc;

d_FFdTcfcT_dV_bi_ci = d_FFdTcfc_dV_bi_ci;
d_FFdTcfcT_dV_bi_ei = d_FFdTcfc_dV_bi_ei;
d_FFdTcfcT_dV_tnode_GND = d_FFdTcfc_dV_tnode_GND;
FFdTcfcT = FFdTcfc;
}
else
{

d_FFdQcfc_dV_bi_ci = ((model_.fthc)*thcs_t)*d_itf_dV_bi_ci;
d_FFdQcfc_dV_bi_ei = ((model_.fthc)*thcs_t)*d_itf_dV_bi_ei;
d_FFdQcfc_dV_tnode_GND = (((model_.fthc)*thcs_t)*d_itf_dV_tnode_GND+(model_.fthc)*d_thcs_t_dV_tnode_GND*itf);
FFdQcfc = (((model_.fthc)*thcs_t)*itf);

d_FCa_dV_tnode_GND = (-((itf*d_ick_dV_tnode_GND-ick*d_itf_dV_tnode_GND)/itf/itf));
d_FCa_dV_bi_ci = (-((itf*d_ick_dV_bi_ci-ick*d_itf_dV_bi_ci)/itf/itf));
d_FCa_dV_bi_ei = (-((itf*d_ick_dV_bi_ei-ick*d_itf_dV_bi_ei)/itf/itf));
FCa = (1.0-(ick/itf));
{
double value_sqrt_0 = sqrt(((FCa*FCa)+(model_.ahc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_FCrt_dV_tnode_GND = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_tnode_GND+d_FCa_dV_tnode_GND*FCa)));
d_FCrt_dV_bi_ci = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_bi_ci+d_FCa_dV_bi_ci*FCa)));
d_FCrt_dV_bi_ei = (deriv_sqrt_0_d0*((FCa*d_FCa_dV_bi_ei+d_FCa_dV_bi_ei*FCa)));
FCrt = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((1.0+(model_.ahc)));

d_FCa_ck_dV_tnode_GND = (-((d_FCa_dV_tnode_GND+d_FCrt_dV_tnode_GND)/(1.0+value_sqrt_0)));
d_FCa_ck_dV_bi_ci = (-((d_FCa_dV_bi_ci+d_FCrt_dV_bi_ci)/(1.0+value_sqrt_0)));
d_FCa_ck_dV_bi_ei = (-((d_FCa_dV_bi_ei+d_FCrt_dV_bi_ei)/(1.0+value_sqrt_0)));
FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
}

d_FCdaick_ditf_dV_tnode_GND = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_tnode_GND)+d_FCa_ck_dV_tnode_GND*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_tnode_GND+d_FCrt_dV_tnode_GND*itf))/(FCrt*itf)/(FCrt*itf));
d_FCdaick_ditf_dV_bi_ci = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_bi_ci)+d_FCa_ck_dV_bi_ci*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_bi_ci+d_FCrt_dV_bi_ci*itf))/(FCrt*itf)/(FCrt*itf));
d_FCdaick_ditf_dV_bi_ei = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dV_bi_ei)+d_FCa_ck_dV_bi_ei*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dV_bi_ei+d_FCrt_dV_bi_ei*itf))/(FCrt*itf)/(FCrt*itf));
FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
if (((model_.latb)>(model_.latl)))
{

d_FCz_dV_bi_ei = d_FCz_dV_bi_ci = d_FCz_dV_tnode_GND =  0.0;
FCz = ((model_.latb)-(model_.latl));
FCxl = (1.0+(model_.latl));
FCxb = (1.0+(model_.latb));
if (((model_.latb)>0.01))
{
{
double value_log_0 = log((FCxb/FCxl));
FCln = value_log_0;
}
{
double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
double  deriv_exp_0_d0 = value_exp_0;

d_FCa1_dV_tnode_GND = (deriv_exp_0_d0*(d_FCa_ck_dV_tnode_GND*FCln));
d_FCa1_dV_bi_ci = (deriv_exp_0_d0*(d_FCa_ck_dV_bi_ci*FCln));
d_FCa1_dV_bi_ei = (deriv_exp_0_d0*(d_FCa_ck_dV_bi_ei*FCln));
FCa1 = value_exp_0;
}

d_FCd_a_dV_tnode_GND = (-(-d_FCa1_dV_tnode_GND*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
d_FCd_a_dV_bi_ci = (-(-d_FCa1_dV_bi_ci*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
d_FCd_a_dV_bi_ei = (-(-d_FCa1_dV_bi_ei*(model_.latb))/((model_.latl)-(FCa1*(model_.latb)))/((model_.latl)-(FCa1*(model_.latb))));
FCd_a = (1.0/((model_.latl)-(FCa1*(model_.latb))));

d_FCw_dV_tnode_GND = ((FCa1-1.0)*d_FCd_a_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCd_a);
d_FCw_dV_bi_ci = ((FCa1-1.0)*d_FCd_a_dV_bi_ci+d_FCa1_dV_bi_ci*FCd_a);
d_FCw_dV_bi_ei = ((FCa1-1.0)*d_FCd_a_dV_bi_ei+d_FCa1_dV_bi_ei*FCd_a);
FCw = ((FCa1-1.0)*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_tnode_GND+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_tnode_GND+((-FCz)*d_FCa1_dV_tnode_GND+(-d_FCz_dV_tnode_GND)*FCa1)*FCln*FCd_a)*FCd_a);
d_FCdw_daick_dV_bi_ci = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ci+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ci+((-FCz)*d_FCa1_dV_bi_ci+(-d_FCz_dV_bi_ci)*FCa1)*FCln*FCd_a)*FCd_a);
d_FCdw_daick_dV_bi_ei = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dV_bi_ei+((((-FCz)*FCa1)*FCln)*d_FCd_a_dV_bi_ei+((-FCz)*d_FCa1_dV_bi_ei+(-d_FCz_dV_bi_ei)*FCa1)*FCln*FCd_a)*FCd_a);
FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
{
double value_log_0 = log(((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));
double  deriv_log_0_d0 = (1.0/((1.0+((model_.latb)*FCw))/(1.0+((model_.latl)*FCw))));

d_FCa1_dV_tnode_GND = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_tnode_GND-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_tnode_GND)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
d_FCa1_dV_bi_ci = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_bi_ci-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_bi_ci)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
d_FCa1_dV_bi_ei = (deriv_log_0_d0*((((1.0+((model_.latl)*FCw))*(model_.latb)*d_FCw_dV_bi_ei-(1.0+((model_.latb)*FCw))*(model_.latl)*d_FCw_dV_bi_ei)/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw)))));
FCa1 = value_log_0;
}

d_FCda1_dw_dV_tnode_GND = ((-(model_.latb)*(model_.latb)*d_FCw_dV_tnode_GND/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_tnode_GND/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
d_FCda1_dw_dV_bi_ci = ((-(model_.latb)*(model_.latb)*d_FCw_dV_bi_ci/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_bi_ci/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
d_FCda1_dw_dV_bi_ei = ((-(model_.latb)*(model_.latb)*d_FCw_dV_bi_ei/(1.0+((model_.latb)*FCw))/(1.0+((model_.latb)*FCw)))-(-(model_.latl)*(model_.latl)*d_FCw_dV_bi_ei/(1.0+((model_.latl)*FCw))/(1.0+((model_.latl)*FCw))));
FCda1_dw = (((model_.latb)/(1.0+((model_.latb)*FCw)))-((model_.latl)/(1.0+((model_.latl)*FCw))));
}
else
{

d_FCf1_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND);
d_FCf1_dV_bi_ci = (-d_FCa_ck_dV_bi_ci);
d_FCf1_dV_bi_ei = (-d_FCa_ck_dV_bi_ei);
FCf1 = (1.0-FCa_ck);

d_FCd_a_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ci = (-d_FCa_ck_dV_bi_ci*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ei = (-d_FCa_ck_dV_bi_ei*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

d_FCw_dV_tnode_GND = (FCf1*d_FCd_a_dV_tnode_GND+d_FCf1_dV_tnode_GND*FCd_a);
d_FCw_dV_bi_ci = (FCf1*d_FCd_a_dV_bi_ci+d_FCf1_dV_bi_ci*FCd_a);
d_FCw_dV_bi_ei = (FCf1*d_FCd_a_dV_bi_ei+d_FCf1_dV_bi_ei*FCd_a);
FCw = (FCf1*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_tnode_GND+(((-1.0)*FCd_a)*d_FCd_a_dV_tnode_GND+(-1.0)*d_FCd_a_dV_tnode_GND*FCd_a)*FCxb*FCd_a);
d_FCdw_daick_dV_bi_ci = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ci+(((-1.0)*FCd_a)*d_FCd_a_dV_bi_ci+(-1.0)*d_FCd_a_dV_bi_ci*FCd_a)*FCxb*FCd_a);
d_FCdw_daick_dV_bi_ei = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dV_bi_ei+(((-1.0)*FCd_a)*d_FCd_a_dV_bi_ei+(-1.0)*d_FCd_a_dV_bi_ei*FCd_a)*FCxb*FCd_a);
FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);

d_FCa1_dV_tnode_GND = (FCz*d_FCw_dV_tnode_GND+d_FCz_dV_tnode_GND*FCw);
d_FCa1_dV_bi_ci = (FCz*d_FCw_dV_bi_ci+d_FCz_dV_bi_ci*FCw);
d_FCa1_dV_bi_ei = (FCz*d_FCw_dV_bi_ei+d_FCz_dV_bi_ei*FCw);
FCa1 = (FCz*FCw);

d_FCda1_dw_dV_tnode_GND = d_FCz_dV_tnode_GND;
d_FCda1_dw_dV_bi_ci = d_FCz_dV_bi_ci;
d_FCda1_dw_dV_bi_ei = d_FCz_dV_bi_ei;
FCda1_dw = FCz;
}

d_FCf_CT_dV_tnode_GND = (-2.0*d_FCz_dV_tnode_GND/FCz/FCz);
d_FCf_CT_dV_bi_ci = (-2.0*d_FCz_dV_bi_ci/FCz/FCz);
d_FCf_CT_dV_bi_ei = (-2.0*d_FCz_dV_bi_ei/FCz/FCz);
FCf_CT = (2.0/FCz);

d_FCw2_dV_tnode_GND = (FCw*d_FCw_dV_tnode_GND+d_FCw_dV_tnode_GND*FCw);
d_FCw2_dV_bi_ci = (FCw*d_FCw_dV_bi_ci+d_FCw_dV_bi_ci*FCw);
d_FCw2_dV_bi_ei = (FCw*d_FCw_dV_bi_ei+d_FCw_dV_bi_ei*FCw);
FCw2 = (FCw*FCw);

d_FCf1_dV_tnode_GND = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_tnode_GND+((model_.latb)*(model_.latl))*d_FCw_dV_tnode_GND*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_tnode_GND/2.0))+d_FCw_dV_tnode_GND);
d_FCf1_dV_bi_ci = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ci+((model_.latb)*(model_.latl))*d_FCw_dV_bi_ci*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ci/2.0))+d_FCw_dV_bi_ci);
d_FCf1_dV_bi_ei = (((((((model_.latb)*(model_.latl))*FCw)*d_FCw2_dV_bi_ei+((model_.latb)*(model_.latl))*d_FCw_dV_bi_ei*FCw2)/3.0)+(((model_.latb)+(model_.latl))*d_FCw2_dV_bi_ei/2.0))+d_FCw_dV_bi_ei);
FCf1 = (((((((model_.latb)*(model_.latl))*FCw)*FCw2)/3.0)+((((model_.latb)+(model_.latl))*FCw2)/2.0))+FCw);

d_FCdf1_dw_dV_tnode_GND = (((model_.latb)*(model_.latl))*d_FCw2_dV_tnode_GND+((model_.latb)+(model_.latl))*d_FCw_dV_tnode_GND);
d_FCdf1_dw_dV_bi_ci = (((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ci+((model_.latb)+(model_.latl))*d_FCw_dV_bi_ci);
d_FCdf1_dw_dV_bi_ei = (((model_.latb)*(model_.latl))*d_FCw2_dV_bi_ei+((model_.latb)+(model_.latl))*d_FCw_dV_bi_ei);
FCdf1_dw = (((((model_.latb)*(model_.latl))*FCw2)+(((model_.latb)+(model_.latl))*FCw))+1.0);

d_z_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_z_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_z_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
z = ((model_.latb)*FCw);
{
double value_log_0 = log((1+((model_.latb)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

d_lnzb_dV_tnode_GND = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_tnode_GND));
d_lnzb_dV_bi_ci = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ci));
d_lnzb_dV_bi_ei = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ei));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{

d_x_dV_tnode_GND = d_z_dV_tnode_GND;
d_x_dV_bi_ci = d_z_dV_bi_ci;
d_x_dV_bi_ei = d_z_dV_bi_ei;
x = (1.0+z);

d_a_dV_tnode_GND = (x*d_x_dV_tnode_GND+d_x_dV_tnode_GND*x);
d_a_dV_bi_ci = (x*d_x_dV_bi_ci+d_x_dV_bi_ci*x);
d_a_dV_bi_ei = (x*d_x_dV_bi_ei+d_x_dV_bi_ei*x);
a = (x*x);

d_a2_dV_tnode_GND = 0.250*(a*2.0*d_lnzb_dV_tnode_GND+d_a_dV_tnode_GND*((2.0*lnzb)-1.0));
d_a2_dV_bi_ci = 0.250*(a*2.0*d_lnzb_dV_bi_ci+d_a_dV_bi_ci*((2.0*lnzb)-1.0));
d_a2_dV_bi_ei = 0.250*(a*2.0*d_lnzb_dV_bi_ei+d_a_dV_bi_ei*((2.0*lnzb)-1.0));
a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

d_a3_dV_tnode_GND = (((a*x)*3.0*d_lnzb_dV_tnode_GND+(a*d_x_dV_tnode_GND+d_a_dV_tnode_GND*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ci = (((a*x)*3.0*d_lnzb_dV_bi_ci+(a*d_x_dV_bi_ci+d_a_dV_bi_ci*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ei = (((a*x)*3.0*d_lnzb_dV_bi_ei+(a*d_x_dV_bi_ei+d_a_dV_bi_ei*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
r = ((model_.latl)/(model_.latb));

d_FCf2_dV_tnode_GND = (((1.0-r)*d_a2_dV_tnode_GND+r*d_a3_dV_tnode_GND)/(model_.latb));
d_FCf2_dV_bi_ci = (((1.0-r)*d_a2_dV_bi_ci+r*d_a3_dV_bi_ci)/(model_.latb));
d_FCf2_dV_bi_ei = (((1.0-r)*d_a2_dV_bi_ei+r*d_a3_dV_bi_ei)/(model_.latb));
FCf2 = ((((1.0-r)*a2)+(r*a3))/(model_.latb));

d_FCdf2_dw_dV_tnode_GND = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND+((1.0-r)*d_x_dV_tnode_GND+r*d_a_dV_tnode_GND)*lnzb);
d_FCdf2_dw_dV_bi_ci = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci+((1.0-r)*d_x_dV_bi_ci+r*d_a_dV_bi_ci)*lnzb);
d_FCdf2_dw_dV_bi_ei = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei+((1.0-r)*d_x_dV_bi_ei+r*d_a_dV_bi_ei)*lnzb);
FCdf2_dw = ((((1.0-r)*x)+(r*a))*lnzb);
}
else
{

d_a_dV_tnode_GND = (z*d_z_dV_tnode_GND+d_z_dV_tnode_GND*z);
d_a_dV_bi_ci = (z*d_z_dV_bi_ci+d_z_dV_bi_ci*z);
d_a_dV_bi_ei = (z*d_z_dV_bi_ei+d_z_dV_bi_ei*z);
a = (z*z);

d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-0.25*d_a_dV_tnode_GND)+((0.10*z)*d_a_dV_tnode_GND+0.10*d_z_dV_tnode_GND*a));
d_a2_dV_bi_ci = ((d_z_dV_bi_ci-0.25*d_a_dV_bi_ci)+((0.10*z)*d_a_dV_bi_ci+0.10*d_z_dV_bi_ci*a));
d_a2_dV_bi_ei = ((d_z_dV_bi_ei-0.25*d_a_dV_bi_ei)+((0.10*z)*d_a_dV_bi_ei+0.10*d_z_dV_bi_ei*a));
a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

d_a3_dV_tnode_GND = ((2.0*d_z_dV_tnode_GND+0.75*d_a_dV_tnode_GND)-((0.20*a)*d_z_dV_tnode_GND+0.20*d_a_dV_tnode_GND*z));
d_a3_dV_bi_ci = ((2.0*d_z_dV_bi_ci+0.75*d_a_dV_bi_ci)-((0.20*a)*d_z_dV_bi_ci+0.20*d_a_dV_bi_ci*z));
d_a3_dV_bi_ei = ((2.0*d_z_dV_bi_ei+0.75*d_a_dV_bi_ei)-((0.20*a)*d_z_dV_bi_ei+0.20*d_a_dV_bi_ei*z));
a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

d_FCf2_dV_tnode_GND = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_tnode_GND+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_tnode_GND+((model_.latb)*d_a2_dV_tnode_GND+(model_.latl)*d_a3_dV_tnode_GND)*FCw)*FCw)/6.0);
d_FCf2_dV_bi_ci = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ci+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ci+((model_.latb)*d_a2_dV_bi_ci+(model_.latl)*d_a3_dV_bi_ci)*FCw)*FCw)/6.0);
d_FCf2_dV_bi_ei = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*d_FCw_dV_bi_ei+((((model_.latb)*a2)+((model_.latl)*a3))*d_FCw_dV_bi_ei+((model_.latb)*d_a2_dV_bi_ei+(model_.latl)*d_a3_dV_bi_ei)*FCw)*FCw)/6.0);
FCf2 = ((((((model_.latb)*a2)+((model_.latl)*a3))*FCw)*FCw)/6.0);

d_FCdf2_dw_dV_tnode_GND = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_tnode_GND+((1+((model_.latl)*FCw))*d_z_dV_tnode_GND+(model_.latl)*d_FCw_dV_tnode_GND*(1+z))*lnzb);
d_FCdf2_dw_dV_bi_ci = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ci+((1+((model_.latl)*FCw))*d_z_dV_bi_ci+(model_.latl)*d_FCw_dV_bi_ci*(1+z))*lnzb);
d_FCdf2_dw_dV_bi_ei = (((1+((model_.latl)*FCw))*(1+z))*d_lnzb_dV_bi_ei+((1+((model_.latl)*FCw))*d_z_dV_bi_ei+(model_.latl)*d_FCw_dV_bi_ei*(1+z))*lnzb);
FCdf2_dw = (((1+((model_.latl)*FCw))*(1+z))*lnzb);
}

d_z_dV_tnode_GND = (model_.latl)*d_FCw_dV_tnode_GND;
d_z_dV_bi_ci = (model_.latl)*d_FCw_dV_bi_ci;
d_z_dV_bi_ei = (model_.latl)*d_FCw_dV_bi_ei;
z = ((model_.latl)*FCw);
{
double value_log_0 = log((1+((model_.latl)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

d_lnzb_dV_tnode_GND = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_tnode_GND));
d_lnzb_dV_bi_ci = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ci));
d_lnzb_dV_bi_ei = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ei));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{

d_x_dV_tnode_GND = d_z_dV_tnode_GND;
d_x_dV_bi_ci = d_z_dV_bi_ci;
d_x_dV_bi_ei = d_z_dV_bi_ei;
x = (1.0+z);

d_a_dV_tnode_GND = (x*d_x_dV_tnode_GND+d_x_dV_tnode_GND*x);
d_a_dV_bi_ci = (x*d_x_dV_bi_ci+d_x_dV_bi_ci*x);
d_a_dV_bi_ei = (x*d_x_dV_bi_ei+d_x_dV_bi_ei*x);
a = (x*x);

d_a2_dV_tnode_GND = 0.250*(a*2.0*d_lnzb_dV_tnode_GND+d_a_dV_tnode_GND*((2.0*lnzb)-1.0));
d_a2_dV_bi_ci = 0.250*(a*2.0*d_lnzb_dV_bi_ci+d_a_dV_bi_ci*((2.0*lnzb)-1.0));
d_a2_dV_bi_ei = 0.250*(a*2.0*d_lnzb_dV_bi_ei+d_a_dV_bi_ei*((2.0*lnzb)-1.0));
a2 = (0.250*((a*((2.0*lnzb)-1.0))+1.0));

d_a3_dV_tnode_GND = (((a*x)*3.0*d_lnzb_dV_tnode_GND+(a*d_x_dV_tnode_GND+d_a_dV_tnode_GND*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ci = (((a*x)*3.0*d_lnzb_dV_bi_ci+(a*d_x_dV_bi_ci+d_a_dV_bi_ci*x)*((3.0*lnzb)-1.0))/9.0);
d_a3_dV_bi_ei = (((a*x)*3.0*d_lnzb_dV_bi_ei+(a*d_x_dV_bi_ei+d_a_dV_bi_ei*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
r = ((model_.latb)/(model_.latl));

d_FCf3_dV_tnode_GND = (((1.0-r)*d_a2_dV_tnode_GND+r*d_a3_dV_tnode_GND)/(model_.latl));
d_FCf3_dV_bi_ci = (((1.0-r)*d_a2_dV_bi_ci+r*d_a3_dV_bi_ci)/(model_.latl));
d_FCf3_dV_bi_ei = (((1.0-r)*d_a2_dV_bi_ei+r*d_a3_dV_bi_ei)/(model_.latl));
FCf3 = ((((1.0-r)*a2)+(r*a3))/(model_.latl));

d_FCdf3_dw_dV_tnode_GND = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_tnode_GND+((1.0-r)*d_x_dV_tnode_GND+r*d_a_dV_tnode_GND)*lnzb);
d_FCdf3_dw_dV_bi_ci = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ci+((1.0-r)*d_x_dV_bi_ci+r*d_a_dV_bi_ci)*lnzb);
d_FCdf3_dw_dV_bi_ei = ((((1.0-r)*x)+(r*a))*d_lnzb_dV_bi_ei+((1.0-r)*d_x_dV_bi_ei+r*d_a_dV_bi_ei)*lnzb);
FCdf3_dw = ((((1.0-r)*x)+(r*a))*lnzb);
}
else
{

d_a_dV_tnode_GND = (z*d_z_dV_tnode_GND+d_z_dV_tnode_GND*z);
d_a_dV_bi_ci = (z*d_z_dV_bi_ci+d_z_dV_bi_ci*z);
d_a_dV_bi_ei = (z*d_z_dV_bi_ei+d_z_dV_bi_ei*z);
a = (z*z);

d_a2_dV_tnode_GND = ((d_z_dV_tnode_GND-0.25*d_a_dV_tnode_GND)+((0.10*z)*d_a_dV_tnode_GND+0.10*d_z_dV_tnode_GND*a));
d_a2_dV_bi_ci = ((d_z_dV_bi_ci-0.25*d_a_dV_bi_ci)+((0.10*z)*d_a_dV_bi_ci+0.10*d_z_dV_bi_ci*a));
d_a2_dV_bi_ei = ((d_z_dV_bi_ei-0.25*d_a_dV_bi_ei)+((0.10*z)*d_a_dV_bi_ei+0.10*d_z_dV_bi_ei*a));
a2 = (((3.0+z)-(0.25*a))+((0.10*z)*a));

d_a3_dV_tnode_GND = ((2.0*d_z_dV_tnode_GND+0.75*d_a_dV_tnode_GND)-((0.20*a)*d_z_dV_tnode_GND+0.20*d_a_dV_tnode_GND*z));
d_a3_dV_bi_ci = ((2.0*d_z_dV_bi_ci+0.75*d_a_dV_bi_ci)-((0.20*a)*d_z_dV_bi_ci+0.20*d_a_dV_bi_ci*z));
d_a3_dV_bi_ei = ((2.0*d_z_dV_bi_ei+0.75*d_a_dV_bi_ei)-((0.20*a)*d_z_dV_bi_ei+0.20*d_a_dV_bi_ei*z));
a3 = (((2.0*z)+(0.75*a))-((0.20*a)*z));

d_FCf3_dV_tnode_GND = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_tnode_GND+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_tnode_GND+((model_.latl)*d_a2_dV_tnode_GND+(model_.latb)*d_a3_dV_tnode_GND)*FCw)*FCw)/6.0);
d_FCf3_dV_bi_ci = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ci+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ci+((model_.latl)*d_a2_dV_bi_ci+(model_.latb)*d_a3_dV_bi_ci)*FCw)*FCw)/6.0);
d_FCf3_dV_bi_ei = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*d_FCw_dV_bi_ei+((((model_.latl)*a2)+((model_.latb)*a3))*d_FCw_dV_bi_ei+((model_.latl)*d_a2_dV_bi_ei+(model_.latb)*d_a3_dV_bi_ei)*FCw)*FCw)/6.0);
FCf3 = ((((((model_.latl)*a2)+((model_.latb)*a3))*FCw)*FCw)/6.0);

d_FCdf3_dw_dV_tnode_GND = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_tnode_GND+((1+((model_.latb)*FCw))*d_z_dV_tnode_GND+(model_.latb)*d_FCw_dV_tnode_GND*(1+z))*lnzb);
d_FCdf3_dw_dV_bi_ci = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ci+((1+((model_.latb)*FCw))*d_z_dV_bi_ci+(model_.latb)*d_FCw_dV_bi_ci*(1+z))*lnzb);
d_FCdf3_dw_dV_bi_ei = (((1+((model_.latb)*FCw))*(1+z))*d_lnzb_dV_bi_ei+((1+((model_.latb)*FCw))*d_z_dV_bi_ei+(model_.latb)*d_FCw_dV_bi_ei*(1+z))*lnzb);
FCdf3_dw = (((1+((model_.latb)*FCw))*(1+z))*lnzb);
}

d_FCf_ci_dV_tnode_GND = (FCf_CT*(((FCa1*d_FCf1_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCf1)-d_FCf2_dV_tnode_GND)+d_FCf3_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCf_ci_dV_bi_ci = (FCf_CT*(((FCa1*d_FCf1_dV_bi_ci+d_FCa1_dV_bi_ci*FCf1)-d_FCf2_dV_bi_ci)+d_FCf3_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCf_ci_dV_bi_ei = (FCf_CT*(((FCa1*d_FCf1_dV_bi_ei+d_FCa1_dV_bi_ei*FCf1)-d_FCf2_dV_bi_ei)+d_FCf3_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(((FCa1*FCf1)-FCf2)+FCf3));
FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));

d_FCdfc_dw_dV_tnode_GND = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_tnode_GND+d_FCa1_dV_tnode_GND*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_tnode_GND+d_FCda1_dw_dV_tnode_GND*FCf1))-d_FCdf2_dw_dV_tnode_GND)+d_FCdf3_dw_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdfc_dw_dV_bi_ci = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_bi_ci+d_FCa1_dV_bi_ci*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_bi_ci+d_FCda1_dw_dV_bi_ci*FCf1))-d_FCdf2_dw_dV_bi_ci)+d_FCdf3_dw_dV_bi_ci)+d_FCf_CT_dV_bi_ci*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdfc_dw_dV_bi_ei = (FCf_CT*((((FCa1*d_FCdf1_dw_dV_bi_ei+d_FCa1_dV_bi_ei*FCdf1_dw)+(FCda1_dw*d_FCf1_dV_bi_ei+d_FCda1_dw_dV_bi_ei*FCf1))-d_FCdf2_dw_dV_bi_ei)+d_FCdf3_dw_dV_bi_ei)+d_FCf_CT_dV_bi_ei*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));

d_FCdw_ditf_dV_tnode_GND = (FCdw_daick*d_FCdaick_ditf_dV_tnode_GND+d_FCdw_daick_dV_tnode_GND*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ci = (FCdw_daick*d_FCdaick_ditf_dV_bi_ci+d_FCdw_daick_dV_bi_ci*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ei = (FCdw_daick*d_FCdaick_ditf_dV_bi_ei+d_FCdw_daick_dV_bi_ei*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);

d_FCdfc_ditf_dV_tnode_GND = (FCdfc_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfc_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ci = (FCdfc_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfc_dw_dV_bi_ci*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ei = (FCdfc_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfc_dw_dV_bi_ei*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{

d_a_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_a_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_a_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
a = ((model_.latb)*FCw);
{
double value_log_0 = log((1+((model_.latb)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latb)*FCw)));

d_lnz_dV_tnode_GND = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_tnode_GND));
d_lnz_dV_bi_ci = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ci));
d_lnz_dV_bi_ei = (deriv_log_0_d0*((model_.latb)*d_FCw_dV_bi_ei));
lnz = value_log_0;
}
if ((a>1.0e-6))
{

d_FCf2_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latb));
d_FCf2_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latb));
d_FCf2_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latb));
FCf2 = ((a-lnz)/(model_.latb));

d_FCdf2_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
d_FCdf2_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
d_FCdf2_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
FCdf2_dw = (a/(1.0+a));
}
else
{

d_FCf2_dV_tnode_GND = ((0.5*a)*d_FCw_dV_tnode_GND+0.5*d_a_dV_tnode_GND*FCw);
d_FCf2_dV_bi_ci = ((0.5*a)*d_FCw_dV_bi_ci+0.5*d_a_dV_bi_ci*FCw);
d_FCf2_dV_bi_ei = ((0.5*a)*d_FCw_dV_bi_ei+0.5*d_a_dV_bi_ei*FCw);
FCf2 = ((0.5*a)*FCw);

d_FCdf2_dw_dV_tnode_GND = d_a_dV_tnode_GND;
d_FCdf2_dw_dV_bi_ci = d_a_dV_bi_ci;
d_FCdf2_dw_dV_bi_ei = d_a_dV_bi_ei;
FCdf2_dw = a;
}

d_a_dV_tnode_GND = (model_.latl)*d_FCw_dV_tnode_GND;
d_a_dV_bi_ci = (model_.latl)*d_FCw_dV_bi_ci;
d_a_dV_bi_ei = (model_.latl)*d_FCw_dV_bi_ei;
a = ((model_.latl)*FCw);
{
double value_log_0 = log((1+((model_.latl)*FCw)));
double  deriv_log_0_d0 = (1.0/(1+((model_.latl)*FCw)));

d_lnz_dV_tnode_GND = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_tnode_GND));
d_lnz_dV_bi_ci = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ci));
d_lnz_dV_bi_ei = (deriv_log_0_d0*((model_.latl)*d_FCw_dV_bi_ei));
lnz = value_log_0;
}
if ((a>1.0e-6))
{

d_FCf3_dV_tnode_GND = ((d_a_dV_tnode_GND-d_lnz_dV_tnode_GND)/(model_.latl));
d_FCf3_dV_bi_ci = ((d_a_dV_bi_ci-d_lnz_dV_bi_ci)/(model_.latl));
d_FCf3_dV_bi_ei = ((d_a_dV_bi_ei-d_lnz_dV_bi_ei)/(model_.latl));
FCf3 = ((a-lnz)/(model_.latl));

d_FCdf3_dw_dV_tnode_GND = (((1.0+a)*d_a_dV_tnode_GND-a*d_a_dV_tnode_GND)/(1.0+a)/(1.0+a));
d_FCdf3_dw_dV_bi_ci = (((1.0+a)*d_a_dV_bi_ci-a*d_a_dV_bi_ci)/(1.0+a)/(1.0+a));
d_FCdf3_dw_dV_bi_ei = (((1.0+a)*d_a_dV_bi_ei-a*d_a_dV_bi_ei)/(1.0+a)/(1.0+a));
FCdf3_dw = (a/(1.0+a));
}
else
{

d_FCf3_dV_tnode_GND = ((0.5*a)*d_FCw_dV_tnode_GND+0.5*d_a_dV_tnode_GND*FCw);
d_FCf3_dV_bi_ci = ((0.5*a)*d_FCw_dV_bi_ci+0.5*d_a_dV_bi_ci*FCw);
d_FCf3_dV_bi_ei = ((0.5*a)*d_FCw_dV_bi_ei+0.5*d_a_dV_bi_ei*FCw);
FCf3 = ((0.5*a)*FCw);

d_FCdf3_dw_dV_tnode_GND = d_a_dV_tnode_GND;
d_FCdf3_dw_dV_bi_ci = d_a_dV_bi_ci;
d_FCdf3_dw_dV_bi_ei = d_a_dV_bi_ei;
FCdf3_dw = a;
}

d_FCf_CT_dV_tnode_GND = (FCf_CT*(d_FCf2_dV_tnode_GND-d_FCf3_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(FCf2-FCf3));
d_FCf_CT_dV_bi_ci = (FCf_CT*(d_FCf2_dV_bi_ci-d_FCf3_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(FCf2-FCf3));
d_FCf_CT_dV_bi_ei = (FCf_CT*(d_FCf2_dV_bi_ei-d_FCf3_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(FCf2-FCf3));
FCf_CT = (FCf_CT*(FCf2-FCf3));

d_FCdfCT_dw_dV_tnode_GND = (FCf_CT*(d_FCdf2_dw_dV_tnode_GND-d_FCdf3_dw_dV_tnode_GND)+d_FCf_CT_dV_tnode_GND*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_dw_dV_bi_ci = (FCf_CT*(d_FCdf2_dw_dV_bi_ci-d_FCdf3_dw_dV_bi_ci)+d_FCf_CT_dV_bi_ci*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_dw_dV_bi_ei = (FCf_CT*(d_FCdf2_dw_dV_bi_ei-d_FCdf3_dw_dV_bi_ei)+d_FCf_CT_dV_bi_ei*(FCdf2_dw-FCdf3_dw));
FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));

d_FCdfCT_ditf_dV_tnode_GND = (FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ci = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfCT_dw_dV_bi_ci*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ei = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfCT_dw_dV_bi_ei*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{

d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
FCf_CT = FCf_ci;

d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
FCdfCT_ditf = FCdfc_ditf;
}
}
else
{
if (((model_.latb)>0.01))
{

d_FCd_a_dV_tnode_GND = (-d_FCa_ck_dV_tnode_GND*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ci = (-d_FCa_ck_dV_bi_ci*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
d_FCd_a_dV_bi_ei = (-d_FCa_ck_dV_bi_ei*(model_.latb)/(1.0+(FCa_ck*(model_.latb)))/(1.0+(FCa_ck*(model_.latb))));
FCd_a = (1.0/(1.0+(FCa_ck*(model_.latb))));

d_FCw_dV_tnode_GND = ((1.0-FCa_ck)*d_FCd_a_dV_tnode_GND+(-d_FCa_ck_dV_tnode_GND)*FCd_a);
d_FCw_dV_bi_ci = ((1.0-FCa_ck)*d_FCd_a_dV_bi_ci+(-d_FCa_ck_dV_bi_ci)*FCd_a);
d_FCw_dV_bi_ei = ((1.0-FCa_ck)*d_FCd_a_dV_bi_ei+(-d_FCa_ck_dV_bi_ei)*FCd_a);
FCw = ((1.0-FCa_ck)*FCd_a);

d_FCdw_daick_dV_tnode_GND = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_tnode_GND+(-(1.0+(model_.latb)))*d_FCd_a_dV_tnode_GND*FCd_a);
d_FCdw_daick_dV_bi_ci = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ci+(-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ci*FCd_a);
d_FCdw_daick_dV_bi_ei = (((-(1.0+(model_.latb)))*FCd_a)*d_FCd_a_dV_bi_ei+(-(1.0+(model_.latb)))*d_FCd_a_dV_bi_ei*FCd_a);
FCdw_daick = (((-(1.0+(model_.latb)))*FCd_a)*FCd_a);
}
else
{

d_FCw_dV_tnode_GND = ((-d_FCa_ck_dV_tnode_GND)-d_FCa_ck_dV_tnode_GND*(model_.latb));
d_FCw_dV_bi_ci = ((-d_FCa_ck_dV_bi_ci)-d_FCa_ck_dV_bi_ci*(model_.latb));
d_FCw_dV_bi_ei = ((-d_FCa_ck_dV_bi_ei)-d_FCa_ck_dV_bi_ei*(model_.latb));
FCw = ((1.0-FCa_ck)-(FCa_ck*(model_.latb)));

d_FCdw_daick_dV_bi_ei = d_FCdw_daick_dV_bi_ci = d_FCdw_daick_dV_tnode_GND =  0.0;
FCdw_daick = (-(1.0+(model_.latb)));
}

d_FCw2_dV_tnode_GND = (FCw*d_FCw_dV_tnode_GND+d_FCw_dV_tnode_GND*FCw);
d_FCw2_dV_bi_ci = (FCw*d_FCw_dV_bi_ci+d_FCw_dV_bi_ci*FCw);
d_FCw2_dV_bi_ei = (FCw*d_FCw_dV_bi_ei+d_FCw_dV_bi_ei*FCw);
FCw2 = (FCw*FCw);

d_FCz_dV_tnode_GND = (model_.latb)*d_FCw_dV_tnode_GND;
d_FCz_dV_bi_ci = (model_.latb)*d_FCw_dV_bi_ci;
d_FCz_dV_bi_ei = (model_.latb)*d_FCw_dV_bi_ei;
FCz = ((model_.latb)*FCw);

d_FCz_1_dV_tnode_GND = d_FCz_dV_tnode_GND;
d_FCz_1_dV_bi_ci = d_FCz_dV_bi_ci;
d_FCz_1_dV_bi_ei = d_FCz_dV_bi_ei;
FCz_1 = (1.0+FCz);

d_FCd_f_dV_tnode_GND = (-d_FCz_1_dV_tnode_GND/FCz_1/FCz_1);
d_FCd_f_dV_bi_ci = (-d_FCz_1_dV_bi_ci/FCz_1/FCz_1);
d_FCd_f_dV_bi_ei = (-d_FCz_1_dV_bi_ei/FCz_1/FCz_1);
FCd_f = (1.0/FCz_1);

d_FCf_ci_dV_tnode_GND = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_tnode_GND+(FCw2*(d_FCz_dV_tnode_GND/3.0)+d_FCw2_dV_tnode_GND*(1.0+(FCz/3.0)))*FCd_f);
d_FCf_ci_dV_bi_ci = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ci+(FCw2*(d_FCz_dV_bi_ci/3.0)+d_FCw2_dV_bi_ci*(1.0+(FCz/3.0)))*FCd_f);
d_FCf_ci_dV_bi_ei = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dV_bi_ei+(FCw2*(d_FCz_dV_bi_ei/3.0)+d_FCw2_dV_bi_ei*(1.0+(FCz/3.0)))*FCd_f);
FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);

d_FCdfc_dw_dV_tnode_GND = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND+((2.0*FCw)*(d_FCz_1_dV_tnode_GND+((FCz*d_FCz_dV_tnode_GND+d_FCz_dV_tnode_GND*FCz)/3.0))+2.0*d_FCw_dV_tnode_GND*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfc_dw_dV_bi_ci = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci+((2.0*FCw)*(d_FCz_1_dV_bi_ci+((FCz*d_FCz_dV_bi_ci+d_FCz_dV_bi_ci*FCz)/3.0))+2.0*d_FCw_dV_bi_ci*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfc_dw_dV_bi_ei = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei+((2.0*FCw)*(d_FCz_1_dV_bi_ei+((FCz*d_FCz_dV_bi_ei+d_FCz_dV_bi_ei*FCz)/3.0))+2.0*d_FCw_dV_bi_ei*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);

d_FCdw_ditf_dV_tnode_GND = (FCdw_daick*d_FCdaick_ditf_dV_tnode_GND+d_FCdw_daick_dV_tnode_GND*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ci = (FCdw_daick*d_FCdaick_ditf_dV_bi_ci+d_FCdw_daick_dV_bi_ci*FCdaick_ditf);
d_FCdw_ditf_dV_bi_ei = (FCdw_daick*d_FCdaick_ditf_dV_bi_ei+d_FCdw_daick_dV_bi_ei*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);

d_FCdfc_ditf_dV_tnode_GND = (FCdfc_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfc_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ci = (FCdfc_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfc_dw_dV_bi_ci*FCdw_ditf);
d_FCdfc_ditf_dV_bi_ei = (FCdfc_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfc_dw_dV_bi_ei*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if ((((model_.flcomp)==0.0)||((model_.flcomp)==2.1)))
{
if ((FCz>0.001))
{
{
double value_log_0 = log(FCz_1);
double  deriv_log_0_d0 = (1.0/FCz_1);

d_FCf_CT_dV_tnode_GND = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_tnode_GND))+d_FCz_1_dV_tnode_GND*value_log_0)-d_FCz_dV_tnode_GND)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_tnode_GND)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
d_FCf_CT_dV_bi_ci = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ci))+d_FCz_1_dV_bi_ci*value_log_0)-d_FCz_dV_bi_ci)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ci)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
d_FCf_CT_dV_bi_ei = (((((model_.latb)*(model_.latb))*FCz_1)*2.0*((FCz_1*(deriv_log_0_d0*(d_FCz_1_dV_bi_ei))+d_FCz_1_dV_bi_ei*value_log_0)-d_FCz_dV_bi_ei)-(2.0*((FCz_1*value_log_0)-FCz))*((model_.latb)*(model_.latb))*d_FCz_1_dV_bi_ei)/(((model_.latb)*(model_.latb))*FCz_1)/(((model_.latb)*(model_.latb))*FCz_1));
FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/(((model_.latb)*(model_.latb))*FCz_1));
}

d_FCdfCT_dw_dV_tnode_GND = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_tnode_GND+((2.0*FCw)*d_FCd_f_dV_tnode_GND+2.0*d_FCw_dV_tnode_GND*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ci = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ci+((2.0*FCw)*d_FCd_f_dV_bi_ci+2.0*d_FCw_dV_bi_ci*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ei = (((2.0*FCw)*FCd_f)*d_FCd_f_dV_bi_ei+((2.0*FCw)*d_FCd_f_dV_bi_ei+2.0*d_FCw_dV_bi_ei*FCd_f)*FCd_f);
FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
}
else
{

d_FCf_CT_dV_tnode_GND = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_tnode_GND+(FCw2*(-(d_FCz_dV_tnode_GND/3.0))+d_FCw2_dV_tnode_GND*(1.0-(FCz/3.0)))*FCd_f);
d_FCf_CT_dV_bi_ci = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ci+(FCw2*(-(d_FCz_dV_bi_ci/3.0))+d_FCw2_dV_bi_ci*(1.0-(FCz/3.0)))*FCd_f);
d_FCf_CT_dV_bi_ei = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dV_bi_ei+(FCw2*(-(d_FCz_dV_bi_ei/3.0))+d_FCw2_dV_bi_ei*(1.0-(FCz/3.0)))*FCd_f);
FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);

d_FCdfCT_dw_dV_tnode_GND = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_tnode_GND+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_tnode_GND+((2.0*FCw)*(-((FCz*d_FCz_dV_tnode_GND+d_FCz_dV_tnode_GND*FCz)/3.0))+2.0*d_FCw_dV_tnode_GND*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ci = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ci+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ci+((2.0*FCw)*(-((FCz*d_FCz_dV_bi_ci+d_FCz_dV_bi_ci*FCz)/3.0))+2.0*d_FCw_dV_bi_ci*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdfCT_dw_dV_bi_ei = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dV_bi_ei+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dV_bi_ei+((2.0*FCw)*(-((FCz*d_FCz_dV_bi_ei+d_FCz_dV_bi_ei*FCz)/3.0))+2.0*d_FCw_dV_bi_ei*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
}

d_FCdfCT_ditf_dV_tnode_GND = (FCdfCT_dw*d_FCdw_ditf_dV_tnode_GND+d_FCdfCT_dw_dV_tnode_GND*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ci = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ci+d_FCdfCT_dw_dV_bi_ci*FCdw_ditf);
d_FCdfCT_ditf_dV_bi_ei = (FCdfCT_dw*d_FCdw_ditf_dV_bi_ei+d_FCdfCT_dw_dV_bi_ei*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{

d_FCf_CT_dV_tnode_GND = d_FCf_ci_dV_tnode_GND;
d_FCf_CT_dV_bi_ci = d_FCf_ci_dV_bi_ci;
d_FCf_CT_dV_bi_ei = d_FCf_ci_dV_bi_ei;
FCf_CT = FCf_ci;

d_FCdfCT_ditf_dV_tnode_GND = d_FCdfc_ditf_dV_tnode_GND;
d_FCdfCT_ditf_dV_bi_ci = d_FCdfc_ditf_dV_bi_ci;
d_FCdfCT_ditf_dV_bi_ei = d_FCdfc_ditf_dV_bi_ei;
FCdfCT_ditf = FCdfc_ditf;
}
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQcfcT_dV_bi_ci = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(FFdQcfc*d_FCf_CT_dV_bi_ci+d_FFdQcfc_dV_bi_ci*FCf_CT)*value_exp_0);
d_FFdQcfcT_dV_bi_ei = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(FFdQcfc*d_FCf_CT_dV_bi_ei+d_FFdQcfc_dV_bi_ei*FCf_CT)*value_exp_0);
d_FFdQcfcT_dV_tnode_GND = ((FFdQcfc*FCf_CT)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(FFdQcfc*d_FCf_CT_dV_tnode_GND+d_FFdQcfc_dV_tnode_GND*FCf_CT)*value_exp_0);
FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdQcfc_dV_bi_ci = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))+(FFdQcfc*d_FCf_ci_dV_bi_ci+d_FFdQcfc_dV_bi_ci*FCf_ci)*value_exp_0);
d_FFdQcfc_dV_bi_ei = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))+(FFdQcfc*d_FCf_ci_dV_bi_ei+d_FFdQcfc_dV_bi_ei*FCf_ci)*value_exp_0);
d_FFdQcfc_dV_tnode_GND = ((FFdQcfc*FCf_ci)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(FFdQcfc*d_FCf_ci_dV_tnode_GND+d_FFdQcfc_dV_tnode_GND*FCf_ci)*value_exp_0);
FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTcfc_dV_bi_ci = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ci+(itf*d_FCdfc_ditf_dV_bi_ci+d_itf_dV_bi_ci*FCdfc_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ci+(d_FFdQcfc_dV_bi_ci/VT)*FFdVc_ditf));
d_FFdTcfc_dV_bi_ei = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_bi_ei+(itf*d_FCdfc_ditf_dV_bi_ei+d_itf_dV_bi_ei*FCdfc_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_bi_ei+(d_FFdQcfc_dV_bi_ei/VT)*FFdVc_ditf));
d_FFdTcfc_dV_tnode_GND = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_ci_dV_tnode_GND+(itf*d_FCdfc_ditf_dV_tnode_GND+d_itf_dV_tnode_GND*FCdfc_ditf))+(((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(model_.fthc)*d_thcs_t_dV_tnode_GND*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*d_FFdQcfc_dV_tnode_GND-FFdQcfc*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTcfc = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/VT)*FFdVc_ditf));
}
{
double value_exp_0 = exp(((FFdVc-(model_.vcbar))/VT));
double  deriv_exp_0_d0 = value_exp_0;

d_FFdTcfcT_dV_bi_ci = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ci+(itf*d_FCdfCT_ditf_dV_bi_ci+d_itf_dV_bi_ci*FCdfCT_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ci/VT)))*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ci+(d_FFdQcfcT_dV_bi_ci/VT)*FFdVc_ditf));
d_FFdTcfcT_dV_bi_ei = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_bi_ei+(itf*d_FCdfCT_ditf_dV_bi_ei+d_itf_dV_bi_ei*FCdfCT_ditf))+((model_.fthc)*thcs_t)*(deriv_exp_0_d0*((d_FFdVc_dV_bi_ei/VT)))*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_bi_ei+(d_FFdQcfcT_dV_bi_ei/VT)*FFdVc_ditf));
d_FFdTcfcT_dV_tnode_GND = (((((model_.fthc)*thcs_t)*value_exp_0)*(d_FCf_CT_dV_tnode_GND+(itf*d_FCdfCT_ditf_dV_tnode_GND+d_itf_dV_tnode_GND*FCdfCT_ditf))+(((model_.fthc)*thcs_t)*(deriv_exp_0_d0*(((VT*d_FFdVc_dV_tnode_GND-(FFdVc-(model_.vcbar))*d_VT_dV_tnode_GND)/VT/VT)))+(model_.fthc)*d_thcs_t_dV_tnode_GND*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*d_FFdVc_ditf_dV_tnode_GND+((VT*d_FFdQcfcT_dV_tnode_GND-FFdQcfcT*d_VT_dV_tnode_GND)/VT/VT)*FFdVc_ditf));
FFdTcfcT = (((((model_.fthc)*thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/VT)*FFdVc_ditf));
}
}

d_FFdQbfc_dV_bi_ci = (1-(model_.fthc))*d_FFdQfhc_dV_bi_ci;
d_FFdQbfc_dV_bi_ei = (1-(model_.fthc))*d_FFdQfhc_dV_bi_ei;
d_FFdQbfc_dV_tnode_GND = (1-(model_.fthc))*d_FFdQfhc_dV_tnode_GND;
FFdQbfc = ((1-(model_.fthc))*FFdQfhc);

d_FFdTbfc_dV_bi_ci = (1-(model_.fthc))*d_FFdTfhc_dV_bi_ci;
d_FFdTbfc_dV_bi_ei = (1-(model_.fthc))*d_FFdTfhc_dV_bi_ei;
d_FFdTbfc_dV_tnode_GND = (1-(model_.fthc))*d_FFdTfhc_dV_tnode_GND;
FFdTbfc = ((1-(model_.fthc))*FFdTfhc);

d_Q_fT_dV_bi_ei = ((((hf0_t*d_Qf_dV_bi_ei+d_FFdQbfb_dV_bi_ei)+d_FFdQbfc_dV_bi_ei)+hfe_t*d_FFdQef_dV_bi_ei)+hfc_t*d_FFdQcfcT_dV_bi_ei);
d_Q_fT_dV_bi_ci = ((((hf0_t*d_Qf_dV_bi_ci+d_FFdQbfb_dV_bi_ci)+d_FFdQbfc_dV_bi_ci)+hfe_t*d_FFdQef_dV_bi_ci)+hfc_t*d_FFdQcfcT_dV_bi_ci);
d_Q_fT_dV_tnode_GND = (((((hf0_t*d_Qf_dV_tnode_GND+d_hf0_t_dV_tnode_GND*Qf)+d_FFdQbfb_dV_tnode_GND)+d_FFdQbfc_dV_tnode_GND)+(hfe_t*d_FFdQef_dV_tnode_GND+d_hfe_t_dV_tnode_GND*FFdQef))+(hfc_t*d_FFdQcfcT_dV_tnode_GND+d_hfc_t_dV_tnode_GND*FFdQcfcT));
Q_fT = (((((hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(hfe_t*FFdQef))+(hfc_t*FFdQcfcT));

d_T_fT_dV_bi_ci = ((((hf0_t*d_Tf_dV_bi_ci+d_FFdTbfb_dV_bi_ci)+d_FFdTbfc_dV_bi_ci)+hfe_t*d_FFdTef_dV_bi_ci)+hfc_t*d_FFdTcfcT_dV_bi_ci);
d_T_fT_dV_bi_ei = ((((hf0_t*d_Tf_dV_bi_ei+d_FFdTbfb_dV_bi_ei)+d_FFdTbfc_dV_bi_ei)+hfe_t*d_FFdTef_dV_bi_ei)+hfc_t*d_FFdTcfcT_dV_bi_ei);
d_T_fT_dV_tnode_GND = (((((hf0_t*d_Tf_dV_tnode_GND+d_hf0_t_dV_tnode_GND*Tf)+d_FFdTbfb_dV_tnode_GND)+d_FFdTbfc_dV_tnode_GND)+(hfe_t*d_FFdTef_dV_tnode_GND+d_hfe_t_dV_tnode_GND*FFdTef))+(hfc_t*d_FFdTcfcT_dV_tnode_GND+d_hfc_t_dV_tnode_GND*FFdTcfcT));
T_fT = (((((hf0_t*Tf)+FFdTbfb)+FFdTbfc)+(hfe_t*FFdTef))+(hfc_t*FFdTcfcT));

d_Qf_dV_bi_ei = (((d_Qf_dV_bi_ei+(d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei))+d_FFdQef_dV_bi_ei)+d_FFdQcfc_dV_bi_ei);
d_Qf_dV_bi_ci = (((d_Qf_dV_bi_ci+(d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci))+d_FFdQef_dV_bi_ci)+d_FFdQcfc_dV_bi_ci);
d_Qf_dV_tnode_GND = (((d_Qf_dV_tnode_GND+(d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND))+d_FFdQef_dV_tnode_GND)+d_FFdQcfc_dV_tnode_GND);
Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);

d_Tf_dV_bi_ci = (((d_Tf_dV_bi_ci+(d_FFdTbfb_dV_bi_ci+d_FFdTbfc_dV_bi_ci))+d_FFdTef_dV_bi_ci)+d_FFdTcfc_dV_bi_ci);
d_Tf_dV_tnode_GND = (((d_Tf_dV_tnode_GND+(d_FFdTbfb_dV_tnode_GND+d_FFdTbfc_dV_tnode_GND))+d_FFdTef_dV_tnode_GND)+d_FFdTcfc_dV_tnode_GND);
d_Tf_dV_bi_ei = (((d_Tf_dV_bi_ei+(d_FFdTbfb_dV_bi_ei+d_FFdTbfc_dV_bi_ei))+d_FFdTef_dV_bi_ei)+d_FFdTcfc_dV_bi_ei);
Tf = (((Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);

d_Q_bf_dV_bi_ci = (d_FFdQbfb_dV_bi_ci+d_FFdQbfc_dV_bi_ci);
d_Q_bf_dV_bi_ei = (d_FFdQbfb_dV_bi_ei+d_FFdQbfc_dV_bi_ei);
d_Q_bf_dV_tnode_GND = (d_FFdQbfb_dV_tnode_GND+d_FFdQbfc_dV_tnode_GND);
Q_bf = (FFdQbfb+FFdQbfc);
}

d_Qr_dV_bi_ei = Tr*d_itr_dV_bi_ei;
d_Qr_dV_bi_ci = Tr*d_itr_dV_bi_ci;
d_Qr_dV_tnode_GND = Tr*d_itr_dV_tnode_GND;
Qr = (Tr*itr);
}

d_it_dV_bi_ci = (d_itf_dV_bi_ci-d_itr_dV_bi_ci);
d_it_dV_bi_ei = (d_itf_dV_bi_ei-d_itr_dV_bi_ei);
d_it_dV_tnode_GND = (d_itf_dV_tnode_GND-d_itr_dV_tnode_GND);
it = (itf-itr);

d_Qdei_dV_bi_ei = d_Qf_dV_bi_ei;
d_Qdei_dV_bi_ci = d_Qf_dV_bi_ci;
d_Qdei_dV_tnode_GND = d_Qf_dV_tnode_GND;
Qdei = Qf;

d_Qdci_dV_bi_ei = d_Qr_dV_bi_ei;
d_Qdci_dV_bi_ci = d_Qr_dV_bi_ci;
d_Qdci_dV_tnode_GND = d_Qr_dV_tnode_GND;
Qdci = Qr;

d_Cdei_dV_bi_ei = (T_f0*d_itf_dV_bi_ei/VT);
d_Cdei_dV_bi_ci = ((T_f0*d_itf_dV_bi_ci+d_T_f0_dV_bi_ci*itf)/VT);
d_Cdei_dV_tnode_GND = ((VT*(T_f0*d_itf_dV_tnode_GND+d_T_f0_dV_tnode_GND*itf)-(T_f0*itf)*d_VT_dV_tnode_GND)/VT/VT);
Cdei = ((T_f0*itf)/VT);

d_Cdci_dV_bi_ei = ((model_.tr)*d_itr_dV_bi_ei/VT);
d_Cdci_dV_bi_ci = ((model_.tr)*d_itr_dV_bi_ci/VT);
d_Cdci_dV_tnode_GND = ((VT*(model_.tr)*d_itr_dV_tnode_GND-((model_.tr)*itr)*d_VT_dV_tnode_GND)/VT/VT);
Cdci = (((model_.tr)*itr)/VT);

d_Crbi_dV_bi_ci = (model_.fcrbi)*((d_Cjci_dV_bi_ci+d_Cdei_dV_bi_ci)+d_Cdci_dV_bi_ci);
d_Crbi_dV_bi_ei = (model_.fcrbi)*(((d_Cjei_dV_bi_ei+d_Cjci_dV_bi_ei)+d_Cdei_dV_bi_ei)+d_Cdci_dV_bi_ei);
d_Crbi_dV_tnode_GND = (model_.fcrbi)*(((d_Cjei_dV_tnode_GND+d_Cjci_dV_tnode_GND)+d_Cdei_dV_tnode_GND)+d_Cdci_dV_tnode_GND);
Crbi = ((model_.fcrbi)*(((Cjei+Cjci)+Cdei)+Cdci));

d_qrbi_dV_bp_bi = Crbi*d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi];
d_qrbi_dV_bi_ci = d_Crbi_dV_bi_ci*(probeVars[admsProbeID_V_bp_bi]);
d_qrbi_dV_bi_ei = d_Crbi_dV_bi_ei*(probeVars[admsProbeID_V_bp_bi]);
d_qrbi_dV_tnode_GND = d_Crbi_dV_tnode_GND*(probeVars[admsProbeID_V_bp_bi]);
qrbi = (Crbi*(probeVars[admsProbeID_V_bp_bi]));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ei =  0.0;
d_DIOY_dV_tnode_GND = (-Vbici*(model_.mbci)*d_VT_dV_tnode_GND/((model_.mbci)*VT)/((model_.mbci)*VT));
d_DIOY_dV_bi_ci = (d_Vbici_dV_bi_ci/((model_.mbci)*VT));
DIOY = (Vbici/((model_.mbci)*VT));
if (((model_.ibcis)>0.0))
{
if ((DIOY>80.0))
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei =  0.0;
d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
le = (1+(DIOY-80.0));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
DIOY = 80.0;
}
else
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei =  0.0;
d_le_dV_tnode_GND = (le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND))+d_le_dV_tnode_GND*value_limexp_0);
d_le_dV_bi_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei))+d_le_dV_bi_ei*value_limexp_0);
d_le_dV_bi_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci))+d_le_dV_bi_ci*value_limexp_0);
le = (le*value_limexp_0);
}

d_ibci_dV_bi_ei = ibcis_t*d_le_dV_bi_ei;
d_ibci_dV_bi_ci = ibcis_t*d_le_dV_bi_ci;
d_ibci_dV_tnode_GND = (ibcis_t*d_le_dV_tnode_GND+d_ibcis_t_dV_tnode_GND*(le-1.0));
ibci = (ibcis_t*(le-1.0));
if ((DIOY<=(-14.0)))
{

d_ibci_dV_bi_ci = d_ibci_dV_bi_ei =  0.0;
d_ibci_dV_tnode_GND = (-d_ibcis_t_dV_tnode_GND);
ibci = (-ibcis_t);
}
}
else
{

d_ibci_dV_tnode_GND = d_ibci_dV_bi_ci = d_ibci_dV_bi_ei =  0.0;
ibci = 0.0;
}
if ((use_aval==1))
//Begin block HICAVL
{
//Block-local variables for block HICAVL
double v_bord=0.0;
     double d_v_bord_dV_tnode_GND=0.0;
     double d_v_bord_dV_bi_ci=0.0;
double v_q=0.0;
     double d_v_q_dV_tnode_GND=0.0;
     double d_v_q_dV_bi_ei=0.0;
     double d_v_q_dV_bi_ci=0.0;
double U0=0.0;
     double d_U0_dV_tnode_GND=0.0;
double av=0.0;
     double d_av_dV_tnode_GND=0.0;
     double d_av_dV_bi_ei=0.0;
     double d_av_dV_bi_ci=0.0;
double avl=0.0;
     double d_avl_dV_tnode_GND=0.0;
     double d_avl_dV_bi_ei=0.0;
     double d_avl_dV_bi_ci=0.0;
//End of Block-local variables

d_v_bord_dV_bi_ci = (-d_Vbici_dV_bi_ci);
d_v_bord_dV_tnode_GND = d_vdci_t_dV_tnode_GND;
v_bord = (vdci_t-Vbici);
if ((v_bord>0))
{

d_v_q_dV_bi_ci = (-qavl_t*d_Cjci_dV_bi_ci/Cjci/Cjci);
d_v_q_dV_bi_ei = (-qavl_t*d_Cjci_dV_bi_ei/Cjci/Cjci);
d_v_q_dV_tnode_GND = ((Cjci*d_qavl_t_dV_tnode_GND-qavl_t*d_Cjci_dV_tnode_GND)/Cjci/Cjci);
v_q = (qavl_t/Cjci);

d_U0_dV_tnode_GND = ((cjci0_t*d_qavl_t_dV_tnode_GND-qavl_t*d_cjci0_t_dV_tnode_GND)/cjci0_t/cjci0_t);
U0 = (qavl_t/cjci0_t);
if ((v_bord>U0))
{
{
double value_exp_0 = exp(((-v_q)/U0));
double  deriv_exp_0_d0 = value_exp_0;

d_av_dV_bi_ci = favl_t*(deriv_exp_0_d0*(((-d_v_q_dV_bi_ci)/U0)));
d_av_dV_bi_ei = favl_t*(deriv_exp_0_d0*(((-d_v_q_dV_bi_ei)/U0)));
d_av_dV_tnode_GND = (favl_t*(deriv_exp_0_d0*(((U0*(-d_v_q_dV_tnode_GND)-(-v_q)*d_U0_dV_tnode_GND)/U0/U0)))+d_favl_t_dV_tnode_GND*value_exp_0);
av = (favl_t*value_exp_0);
}

d_avl_dV_bi_ci = (av*((1.0+(v_q/U0))*d_v_bord_dV_bi_ci+(d_v_q_dV_bi_ci/U0)*(v_bord-U0))+d_av_dV_bi_ci*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
d_avl_dV_bi_ei = (av*(d_v_q_dV_bi_ei/U0)*(v_bord-U0)+d_av_dV_bi_ei*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
d_avl_dV_tnode_GND = (av*(d_U0_dV_tnode_GND+((1.0+(v_q/U0))*(d_v_bord_dV_tnode_GND-d_U0_dV_tnode_GND)+((U0*d_v_q_dV_tnode_GND-v_q*d_U0_dV_tnode_GND)/U0/U0)*(v_bord-U0)))+d_av_dV_tnode_GND*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
avl = (av*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
}
else
{
{
double value_exp_0 = exp(((-v_q)/v_bord));
double  deriv_exp_0_d0 = value_exp_0;

d_avl_dV_bi_ei = (favl_t*v_bord)*(deriv_exp_0_d0*(((-d_v_q_dV_bi_ei)/v_bord)));
d_avl_dV_bi_ci = ((favl_t*v_bord)*(deriv_exp_0_d0*(((v_bord*(-d_v_q_dV_bi_ci)-(-v_q)*d_v_bord_dV_bi_ci)/v_bord/v_bord)))+favl_t*d_v_bord_dV_bi_ci*value_exp_0);
d_avl_dV_tnode_GND = ((favl_t*v_bord)*(deriv_exp_0_d0*(((v_bord*(-d_v_q_dV_tnode_GND)-(-v_q)*d_v_bord_dV_tnode_GND)/v_bord/v_bord)))+(favl_t*d_v_bord_dV_tnode_GND+d_favl_t_dV_tnode_GND*v_bord)*value_exp_0);
avl = ((favl_t*v_bord)*value_exp_0);
}
}
if (((model_.kavl)>0))
//Begin block HICAVLHIGH
{
//Block-local variables for block HICAVLHIGH
double denom=0.0;
     double d_denom_dV_tnode_GND=0.0;
     double d_denom_dV_bi_ei=0.0;
     double d_denom_dV_bi_ci=0.0;
double sq_smooth=0.0;
     double d_sq_smooth_dV_tnode_GND=0.0;
     double d_sq_smooth_dV_bi_ei=0.0;
     double d_sq_smooth_dV_bi_ci=0.0;
double hl=0.0;
     double d_hl_dV_tnode_GND=0.0;
     double d_hl_dV_bi_ei=0.0;
     double d_hl_dV_bi_ci=0.0;
//End of Block-local variables

d_denom_dV_bi_ci = (-kavl_t*d_avl_dV_bi_ci);
d_denom_dV_bi_ei = (-kavl_t*d_avl_dV_bi_ei);
d_denom_dV_tnode_GND = (-(kavl_t*d_avl_dV_tnode_GND+d_kavl_t_dV_tnode_GND*avl));
denom = (1-(kavl_t*avl));
{
double value_sqrt_0 = sqrt(((denom*denom)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sq_smooth_dV_bi_ci = (deriv_sqrt_0_d0*((denom*d_denom_dV_bi_ci+d_denom_dV_bi_ci*denom)));
d_sq_smooth_dV_bi_ei = (deriv_sqrt_0_d0*((denom*d_denom_dV_bi_ei+d_denom_dV_bi_ei*denom)));
d_sq_smooth_dV_tnode_GND = (deriv_sqrt_0_d0*((denom*d_denom_dV_tnode_GND+d_denom_dV_tnode_GND*denom)));
sq_smooth = value_sqrt_0;
}

d_hl_dV_bi_ci = 0.5*(d_denom_dV_bi_ci+d_sq_smooth_dV_bi_ci);
d_hl_dV_bi_ei = 0.5*(d_denom_dV_bi_ei+d_sq_smooth_dV_bi_ei);
d_hl_dV_tnode_GND = 0.5*(d_denom_dV_tnode_GND+d_sq_smooth_dV_tnode_GND);
hl = (0.5*(denom+sq_smooth));

d_iavl_dV_bi_ci = ((hl*(itf*d_avl_dV_bi_ci+d_itf_dV_bi_ci*avl)-(itf*avl)*d_hl_dV_bi_ci)/hl/hl);
d_iavl_dV_bi_ei = ((hl*(itf*d_avl_dV_bi_ei+d_itf_dV_bi_ei*avl)-(itf*avl)*d_hl_dV_bi_ei)/hl/hl);
d_iavl_dV_tnode_GND = ((hl*(itf*d_avl_dV_tnode_GND+d_itf_dV_tnode_GND*avl)-(itf*avl)*d_hl_dV_tnode_GND)/hl/hl);
iavl = ((itf*avl)/hl);
}
// End block HICAVLHIGH
else
{

d_iavl_dV_bi_ci = (itf*d_avl_dV_bi_ci+d_itf_dV_bi_ci*avl);
d_iavl_dV_bi_ei = (itf*d_avl_dV_bi_ei+d_itf_dV_bi_ei*avl);
d_iavl_dV_tnode_GND = (itf*d_avl_dV_tnode_GND+d_itf_dV_tnode_GND*avl);
iavl = (itf*avl);
}
}
else
{

d_iavl_dV_tnode_GND = d_iavl_dV_bi_ei = d_iavl_dV_bi_ci =  0.0;
iavl = 0.0;
}
}
// End block HICAVL

d_ibh_rec_dV_bi_ci = d_Q_bf_dV_bi_ci*Otbhrec;
d_ibh_rec_dV_bi_ei = d_Q_bf_dV_bi_ei*Otbhrec;
d_ibh_rec_dV_tnode_GND = d_Q_bf_dV_tnode_GND*Otbhrec;
ibh_rec = (Q_bf*Otbhrec);
if ((rbi0_t>0.0))
//Begin block HICRBI
{
//Block-local variables for block HICRBI
double Qz_nom=0.0;
     double d_Qz_nom_dV_tnode_GND=0.0;
     double d_Qz_nom_dV_bi_ei=0.0;
     double d_Qz_nom_dV_bi_ci=0.0;
double f_QR=0.0;
     double d_f_QR_dV_tnode_GND=0.0;
double ETA=0.0;
     double d_ETA_dV_tnode_GND=0.0;
     double d_ETA_dV_bi_ei=0.0;
     double d_ETA_dV_bi_ci=0.0;
double Qz0=0.0;
     double d_Qz0_dV_tnode_GND=0.0;
     double d_Qz0_dV_bi_ei=0.0;
     double d_Qz0_dV_bi_ci=0.0;
double fQz=0.0;
     double d_fQz_dV_tnode_GND=0.0;
     double d_fQz_dV_bi_ei=0.0;
     double d_fQz_dV_bi_ci=0.0;
//End of Block-local variables

d_f_QR_dV_tnode_GND = (1+(model_.fdqr0))*d_qp0_t_dV_tnode_GND;
f_QR = ((1+(model_.fdqr0))*qp0_t);

d_Qz0_dV_bi_ci = (d_Qjci_dV_bi_ci+d_Qf_dV_bi_ci);
d_Qz0_dV_bi_ei = ((d_Qjei_dV_bi_ei+d_Qjci_dV_bi_ei)+d_Qf_dV_bi_ei);
d_Qz0_dV_tnode_GND = ((d_Qjei_dV_tnode_GND+d_Qjci_dV_tnode_GND)+d_Qf_dV_tnode_GND);
Qz0 = ((Qjei+Qjci)+Qf);

d_Qz_nom_dV_bi_ci = (d_Qz0_dV_bi_ci/f_QR);
d_Qz_nom_dV_bi_ei = (d_Qz0_dV_bi_ei/f_QR);
d_Qz_nom_dV_tnode_GND = ((f_QR*d_Qz0_dV_tnode_GND-Qz0*d_f_QR_dV_tnode_GND)/f_QR/f_QR);
Qz_nom = (1+(Qz0/f_QR));
{
double value_sqrt_0 = sqrt(((Qz_nom*Qz_nom)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_fQz_dV_bi_ci = 0.5*(d_Qz_nom_dV_bi_ci+(deriv_sqrt_0_d0*((Qz_nom*d_Qz_nom_dV_bi_ci+d_Qz_nom_dV_bi_ci*Qz_nom))));
d_fQz_dV_bi_ei = 0.5*(d_Qz_nom_dV_bi_ei+(deriv_sqrt_0_d0*((Qz_nom*d_Qz_nom_dV_bi_ei+d_Qz_nom_dV_bi_ei*Qz_nom))));
d_fQz_dV_tnode_GND = 0.5*(d_Qz_nom_dV_tnode_GND+(deriv_sqrt_0_d0*((Qz_nom*d_Qz_nom_dV_tnode_GND+d_Qz_nom_dV_tnode_GND*Qz_nom))));
fQz = (0.5*(Qz_nom+value_sqrt_0));
}

d_rbi_dV_bi_ci = (-rbi0_t*d_fQz_dV_bi_ci/fQz/fQz);
d_rbi_dV_bi_ei = (-rbi0_t*d_fQz_dV_bi_ei/fQz/fQz);
d_rbi_dV_tnode_GND = ((fQz*d_rbi0_t_dV_tnode_GND-rbi0_t*d_fQz_dV_tnode_GND)/fQz/fQz);
rbi = (rbi0_t/fQz);
if ((ibei>0.0))
{

d_ETA_dV_bi_ci = (d_rbi_dV_bi_ci*ibei*(model_.fgeo)/VT);
d_ETA_dV_bi_ei = ((rbi*d_ibei_dV_bi_ei+d_rbi_dV_bi_ei*ibei)*(model_.fgeo)/VT);
d_ETA_dV_tnode_GND = ((VT*(rbi*d_ibei_dV_tnode_GND+d_rbi_dV_tnode_GND*ibei)*(model_.fgeo)-((rbi*ibei)*(model_.fgeo))*d_VT_dV_tnode_GND)/VT/VT);
ETA = (((rbi*ibei)*(model_.fgeo))/VT);
if ((ETA<1.0e-6))
{

d_rbi_dV_bi_ci = (rbi*(-0.5*d_ETA_dV_bi_ci)+d_rbi_dV_bi_ci*(1.0-(0.5*ETA)));
d_rbi_dV_bi_ei = (rbi*(-0.5*d_ETA_dV_bi_ei)+d_rbi_dV_bi_ei*(1.0-(0.5*ETA)));
d_rbi_dV_tnode_GND = (rbi*(-0.5*d_ETA_dV_tnode_GND)+d_rbi_dV_tnode_GND*(1.0-(0.5*ETA)));
rbi = (rbi*(1.0-(0.5*ETA)));
}
else
{
{
double value_log_0 = log((1.0+ETA));
double  deriv_log_0_d0 = (1.0/(1.0+ETA));

d_rbi_dV_bi_ci = ((ETA*(rbi*(deriv_log_0_d0*(d_ETA_dV_bi_ci))+d_rbi_dV_bi_ci*value_log_0)-(rbi*value_log_0)*d_ETA_dV_bi_ci)/ETA/ETA);
d_rbi_dV_bi_ei = ((ETA*(rbi*(deriv_log_0_d0*(d_ETA_dV_bi_ei))+d_rbi_dV_bi_ei*value_log_0)-(rbi*value_log_0)*d_ETA_dV_bi_ei)/ETA/ETA);
d_rbi_dV_tnode_GND = ((ETA*(rbi*(deriv_log_0_d0*(d_ETA_dV_tnode_GND))+d_rbi_dV_tnode_GND*value_log_0)-(rbi*value_log_0)*d_ETA_dV_tnode_GND)/ETA/ETA);
rbi = ((rbi*value_log_0)/ETA);
}
}
}
if ((Qf>0.0))
{

d_rbi_dV_bi_ci = (((Qjei+Qf)*(rbi*d_Qf_dV_bi_ci*(model_.fqi)+d_rbi_dV_bi_ci*(Qjei+(Qf*(model_.fqi))))-(rbi*(Qjei+(Qf*(model_.fqi))))*d_Qf_dV_bi_ci)/(Qjei+Qf)/(Qjei+Qf));
d_rbi_dV_bi_ei = (((Qjei+Qf)*(rbi*(d_Qjei_dV_bi_ei+d_Qf_dV_bi_ei*(model_.fqi))+d_rbi_dV_bi_ei*(Qjei+(Qf*(model_.fqi))))-(rbi*(Qjei+(Qf*(model_.fqi))))*(d_Qjei_dV_bi_ei+d_Qf_dV_bi_ei))/(Qjei+Qf)/(Qjei+Qf));
d_rbi_dV_tnode_GND = (((Qjei+Qf)*(rbi*(d_Qjei_dV_tnode_GND+d_Qf_dV_tnode_GND*(model_.fqi))+d_rbi_dV_tnode_GND*(Qjei+(Qf*(model_.fqi))))-(rbi*(Qjei+(Qf*(model_.fqi))))*(d_Qjei_dV_tnode_GND+d_Qf_dV_tnode_GND))/(Qjei+Qf)/(Qjei+Qf));
rbi = ((rbi*(Qjei+(Qf*(model_.fqi))))/(Qjei+Qf));
}
}
// End block HICRBI
else
{

d_rbi_dV_tnode_GND = d_rbi_dV_bi_ei = d_rbi_dV_bi_ci =  0.0;
rbi = 0.0;
}

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
d_DIOY_dV_tnode_GND = (-Vbpei*(model_.mbep)*d_VT_dV_tnode_GND/((model_.mbep)*VT)/((model_.mbep)*VT));
d_DIOY_dV_bp_ei = (d_Vbpei_dV_bp_ei/((model_.mbep)*VT));
DIOY = (Vbpei/((model_.mbep)*VT));
if (((model_.ibeps)>0.0))
{
if ((DIOY>80.0))
{

d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
le = (1+(DIOY-80.0));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
DIOY = 80.0;
}
else
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
d_le_dV_tnode_GND = (le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND))+d_le_dV_tnode_GND*value_limexp_0);
d_le_dV_bi_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei))+d_le_dV_bi_ei*value_limexp_0);
d_le_dV_bi_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci))+d_le_dV_bi_ci*value_limexp_0);
d_le_dV_bp_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei))+d_le_dV_bp_ei*value_limexp_0);
le = (le*value_limexp_0);
}

d_ibep_dV_bi_ei = ibeps_t*d_le_dV_bi_ei;
d_ibep_dV_bi_ci = ibeps_t*d_le_dV_bi_ci;
d_ibep_dV_bp_ei = ibeps_t*d_le_dV_bp_ei;
d_ibep_dV_tnode_GND = (ibeps_t*d_le_dV_tnode_GND+d_ibeps_t_dV_tnode_GND*(le-1.0));
ibep = (ibeps_t*(le-1.0));
if ((DIOY<=(-14.0)))
{

d_ibep_dV_bp_ei = d_ibep_dV_bi_ci = d_ibep_dV_bi_ei =  0.0;
d_ibep_dV_tnode_GND = (-d_ibeps_t_dV_tnode_GND);
ibep = (-ibeps_t);
}
}
else
{

d_ibep_dV_tnode_GND = d_ibep_dV_bp_ei = d_ibep_dV_bi_ci = d_ibep_dV_bi_ei =  0.0;
ibep = 0.0;
}

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
d_DIOY_dV_tnode_GND = (-Vbpei*(model_.mrep)*d_VT_dV_tnode_GND/((model_.mrep)*VT)/((model_.mrep)*VT));
d_DIOY_dV_bp_ei = (d_Vbpei_dV_bp_ei/((model_.mrep)*VT));
DIOY = (Vbpei/((model_.mrep)*VT));
if (((model_.ireps)>0.0))
{
if ((DIOY>80.0))
{

d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
le = (1+(DIOY-80.0));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
DIOY = 80.0;
}
else
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

d_le_dV_si_ci = d_le_dV_bp_ci =  0.0;
d_le_dV_tnode_GND = (le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND))+d_le_dV_tnode_GND*value_limexp_0);
d_le_dV_bi_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei))+d_le_dV_bi_ei*value_limexp_0);
d_le_dV_bi_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci))+d_le_dV_bi_ci*value_limexp_0);
d_le_dV_bp_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei))+d_le_dV_bp_ei*value_limexp_0);
le = (le*value_limexp_0);
}

d_irep_dV_bi_ei = ireps_t*d_le_dV_bi_ei;
d_irep_dV_bi_ci = ireps_t*d_le_dV_bi_ci;
d_irep_dV_bp_ei = ireps_t*d_le_dV_bp_ei;
d_irep_dV_tnode_GND = (ireps_t*d_le_dV_tnode_GND+d_ireps_t_dV_tnode_GND*(le-1.0));
irep = (ireps_t*(le-1.0));
if ((DIOY<=(-14.0)))
{

d_irep_dV_bp_ei = d_irep_dV_bi_ci = d_irep_dV_bi_ei =  0.0;
d_irep_dV_tnode_GND = (-d_ireps_t_dV_tnode_GND);
irep = (-ireps_t);
}
}
else
{

d_irep_dV_tnode_GND = d_irep_dV_bp_ei = d_irep_dV_bi_ci = d_irep_dV_bi_ei =  0.0;
irep = 0.0;
}
if ((cjep0_t>0.0))
{
{
double value_log_0 = log(ajep_t);
double value_exp_1 = exp(((-value_log_0)/(model_.zep)));
double  deriv_log_0_d0 = (1.0/ajep_t);
double  deriv_exp_1_d0 = value_exp_1;

d_DFV_f_dV_tnode_GND = (vdep_t*(-(deriv_exp_1_d0*(((-(deriv_log_0_d0*(d_ajep_t_dV_tnode_GND)))/(model_.zep)))))+d_vdep_t_dV_tnode_GND*(1.0-value_exp_1));
DFV_f = (vdep_t*(1.0-value_exp_1));
}

d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
d_DFv_e_dV_bp_ei = ((-d_Vbpei_dV_bp_ei)/VT);
d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbpei)*d_VT_dV_tnode_GND)/VT/VT);
DFv_e = ((DFV_f-Vbpei)/VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci = d_DFs_q_dV_bp_ci =  0.0;
d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ei+d_DFv_e_dV_bi_ei*DFv_e)));
d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_tnode_GND+d_DFv_e_dV_tnode_GND*DFv_e)));
d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ci+d_DFv_e_dV_bi_ci*DFv_e)));
d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ei+d_DFv_e_dV_bp_ei*DFv_e)));
DFs_q = value_sqrt_0;
}

d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci = d_DFs_q2_dV_bp_ci =  0.0;
d_DFs_q2_dV_bi_ei = (d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5;
d_DFs_q2_dV_tnode_GND = (d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5;
d_DFs_q2_dV_bi_ci = (d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5;
d_DFs_q2_dV_bp_ei = (d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);

d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci = d_DFv_j_dV_bp_ci =  0.0;
d_DFv_j_dV_bi_ei = (-VT*d_DFs_q2_dV_bi_ei);
d_DFv_j_dV_bi_ci = (-VT*d_DFs_q2_dV_bi_ci);
d_DFv_j_dV_bp_ei = (-VT*d_DFs_q2_dV_bp_ei);
d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-(VT*d_DFs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*DFs_q2));
DFv_j = (DFV_f-(VT*DFs_q2));

d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci = d_DFdvj_dv_dV_bp_ci =  0.0;
d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/vdep_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdep_t)));

d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci = d_DFb_dV_bp_ci =  0.0;
d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdep_t))));
d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdep_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdep_t_dV_tnode_GND)/vdep_t/vdep_t))));
d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdep_t))));
d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdep_t))));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-(model_.zep))*DFb));
double  deriv_exp_0_d0 = value_exp_0;

d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci = d_DFC_j1_dV_bp_ci =  0.0;
d_DFC_j1_dV_bi_ei = ((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei+cjep0_t*(deriv_exp_0_d0*((-(model_.zep))*d_DFb_dV_bi_ei))*DFdvj_dv);
d_DFC_j1_dV_bi_ci = ((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci+cjep0_t*(deriv_exp_0_d0*((-(model_.zep))*d_DFb_dV_bi_ci))*DFdvj_dv);
d_DFC_j1_dV_bp_ei = ((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei+cjep0_t*(deriv_exp_0_d0*((-(model_.zep))*d_DFb_dV_bp_ei))*DFdvj_dv);
d_DFC_j1_dV_tnode_GND = ((cjep0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND+(cjep0_t*(deriv_exp_0_d0*((-(model_.zep))*d_DFb_dV_tnode_GND))+d_cjep0_t_dV_tnode_GND*value_exp_0)*DFdvj_dv);
DFC_j1 = ((cjep0_t*value_exp_0)*DFdvj_dv);
}

d_Cjep_dV_bi_ei = (d_DFC_j1_dV_bi_ei+(ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_bi_ei));
d_Cjep_dV_tnode_GND = (d_DFC_j1_dV_tnode_GND+((ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_tnode_GND)+(ajep_t*d_cjep0_t_dV_tnode_GND+d_ajep_t_dV_tnode_GND*cjep0_t)*(1.0-DFdvj_dv)));
d_Cjep_dV_bi_ci = (d_DFC_j1_dV_bi_ci+(ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_bi_ci));
d_Cjep_dV_bp_ei = (d_DFC_j1_dV_bp_ei+(ajep_t*cjep0_t)*(-d_DFdvj_dv_dV_bp_ei));
Cjep = (DFC_j1+((ajep_t*cjep0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-(model_.zep))));
double  deriv_exp_0_d0 = value_exp_0;

d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci = d_DFQ_j_dV_bp_ci =  0.0;
d_DFQ_j_dV_bi_ei = ((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ei*(1.0-(model_.zep)))))/(1.0-(model_.zep)));
d_DFQ_j_dV_bi_ci = ((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ci*(1.0-(model_.zep)))))/(1.0-(model_.zep)));
d_DFQ_j_dV_bp_ei = ((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ei*(1.0-(model_.zep)))))/(1.0-(model_.zep)));
d_DFQ_j_dV_tnode_GND = (((cjep0_t*vdep_t)*(-(deriv_exp_0_d0*(d_DFb_dV_tnode_GND*(1.0-(model_.zep)))))+(cjep0_t*d_vdep_t_dV_tnode_GND+d_cjep0_t_dV_tnode_GND*vdep_t)*(1.0-value_exp_0))/(1.0-(model_.zep)));
DFQ_j = (((cjep0_t*vdep_t)*(1.0-value_exp_0))/(1.0-(model_.zep)));
}

d_Qjep_dV_bi_ei = (d_DFQ_j_dV_bi_ei+(ajep_t*cjep0_t)*(-d_DFv_j_dV_bi_ei));
d_Qjep_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+((ajep_t*cjep0_t)*(-d_DFv_j_dV_tnode_GND)+(ajep_t*d_cjep0_t_dV_tnode_GND+d_ajep_t_dV_tnode_GND*cjep0_t)*(Vbpei-DFv_j)));
d_Qjep_dV_bi_ci = (d_DFQ_j_dV_bi_ci+(ajep_t*cjep0_t)*(-d_DFv_j_dV_bi_ci));
d_Qjep_dV_bp_ei = (d_DFQ_j_dV_bp_ei+(ajep_t*cjep0_t)*(d_Vbpei_dV_bp_ei-d_DFv_j_dV_bp_ei));
Qjep = (DFQ_j+((ajep_t*cjep0_t)*(Vbpei-DFv_j)));
}
else
{

d_Cjep_dV_bp_ei = d_Cjep_dV_bi_ci = d_Cjep_dV_tnode_GND = d_Cjep_dV_bi_ei =  0.0;
Cjep = 0.0;

d_Qjep_dV_bp_ei = d_Qjep_dV_bi_ci = d_Qjep_dV_tnode_GND = d_Qjep_dV_bi_ei =  0.0;
Qjep = 0.0;
}
if ((((model_.ibets)>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
//Begin block HICTUN
{
//Block-local variables for block HICTUN
double pocce=0.0;
     double d_pocce_dV_bp_ei=0.0;
     double d_pocce_dV_bi_ci=0.0;
     double d_pocce_dV_tnode_GND=0.0;
     double d_pocce_dV_bi_ei=0.0;
double czz=0.0;
     double d_czz_dV_bp_ei=0.0;
     double d_czz_dV_tnode_GND=0.0;
     double d_czz_dV_bi_ci=0.0;
     double d_czz_dV_bi_ei=0.0;
//End of Block-local variables
if (((((model_.tunode)==1)&&(cjep0_t>0.0))&&(vdep_t>0.0)))
{
{
double value_log_0 = log((Cjep/cjep0_t));
double value_exp_1 = exp(((1-(1/(model_.zep)))*value_log_0));
double  deriv_log_0_d0 = (1.0/(Cjep/cjep0_t));
double  deriv_exp_1_d0 = value_exp_1;

d_pocce_dV_bi_ei = (deriv_exp_1_d0*((1-(1/(model_.zep)))*(deriv_log_0_d0*((d_Cjep_dV_bi_ei/cjep0_t)))));
d_pocce_dV_tnode_GND = (deriv_exp_1_d0*((1-(1/(model_.zep)))*(deriv_log_0_d0*(((cjep0_t*d_Cjep_dV_tnode_GND-Cjep*d_cjep0_t_dV_tnode_GND)/cjep0_t/cjep0_t)))));
d_pocce_dV_bi_ci = (deriv_exp_1_d0*((1-(1/(model_.zep)))*(deriv_log_0_d0*((d_Cjep_dV_bi_ci/cjep0_t)))));
d_pocce_dV_bp_ei = (deriv_exp_1_d0*((1-(1/(model_.zep)))*(deriv_log_0_d0*((d_Cjep_dV_bp_ei/cjep0_t)))));
pocce = value_exp_1;
}

d_czz_dV_bi_ei = ((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_bi_ei;
d_czz_dV_bi_ci = ((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_bi_ci;
d_czz_dV_tnode_GND = (((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_tnode_GND+((-(Vbpei/vdep_t))*d_ibets_t_dV_tnode_GND+(-(-Vbpei*d_vdep_t_dV_tnode_GND/vdep_t/vdep_t))*ibets_t)*pocce);
d_czz_dV_bp_ei = (((-(Vbpei/vdep_t))*ibets_t)*d_pocce_dV_bp_ei+(-(d_Vbpei_dV_bp_ei/vdep_t))*ibets_t*pocce);
czz = (((-(Vbpei/vdep_t))*ibets_t)*pocce);
{
double value_exp_0 = exp(((-abet_t)/pocce));
double  deriv_exp_0_d0 = value_exp_0;

d_ibet_dV_bi_ei = (czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ei/pocce/pocce)))+d_czz_dV_bi_ei*value_exp_0);
d_ibet_dV_bi_ci = (czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ci/pocce/pocce)))+d_czz_dV_bi_ci*value_exp_0);
d_ibet_dV_tnode_GND = (czz*(deriv_exp_0_d0*(((pocce*(-d_abet_t_dV_tnode_GND)-(-abet_t)*d_pocce_dV_tnode_GND)/pocce/pocce)))+d_czz_dV_tnode_GND*value_exp_0);
d_ibet_dV_bp_ei = (czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bp_ei/pocce/pocce)))+d_czz_dV_bp_ei*value_exp_0);
ibet = (czz*value_exp_0);
}
}
else
{
if (((((model_.tunode)==0)&&(cjei0_t>0.0))&&(vdei_t>0.0)))
{
{
double value_log_0 = log((Cjei/cjei0_t));
double value_exp_1 = exp(((1-(1/(model_.zei)))*value_log_0));
double  deriv_log_0_d0 = (1.0/(Cjei/cjei0_t));
double  deriv_exp_1_d0 = value_exp_1;

d_pocce_dV_bp_ei = d_pocce_dV_bi_ci =  0.0;
d_pocce_dV_bi_ei = (deriv_exp_1_d0*((1-(1/(model_.zei)))*(deriv_log_0_d0*((d_Cjei_dV_bi_ei/cjei0_t)))));
d_pocce_dV_tnode_GND = (deriv_exp_1_d0*((1-(1/(model_.zei)))*(deriv_log_0_d0*(((cjei0_t*d_Cjei_dV_tnode_GND-Cjei*d_cjei0_t_dV_tnode_GND)/cjei0_t/cjei0_t)))));
pocce = value_exp_1;
}

d_czz_dV_bi_ci = ((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_bi_ci;
d_czz_dV_bp_ei = ((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_bp_ei;
d_czz_dV_tnode_GND = (((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_tnode_GND+((-(Vbiei/vdei_t))*d_ibets_t_dV_tnode_GND+(-(-Vbiei*d_vdei_t_dV_tnode_GND/vdei_t/vdei_t))*ibets_t)*pocce);
d_czz_dV_bi_ei = (((-(Vbiei/vdei_t))*ibets_t)*d_pocce_dV_bi_ei+(-(d_Vbiei_dV_bi_ei/vdei_t))*ibets_t*pocce);
czz = (((-(Vbiei/vdei_t))*ibets_t)*pocce);
{
double value_exp_0 = exp(((-abet_t)/pocce));
double  deriv_exp_0_d0 = value_exp_0;

d_ibet_dV_bi_ei = (czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ei/pocce/pocce)))+d_czz_dV_bi_ei*value_exp_0);
d_ibet_dV_bi_ci = (czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bi_ci/pocce/pocce)))+d_czz_dV_bi_ci*value_exp_0);
d_ibet_dV_tnode_GND = (czz*(deriv_exp_0_d0*(((pocce*(-d_abet_t_dV_tnode_GND)-(-abet_t)*d_pocce_dV_tnode_GND)/pocce/pocce)))+d_czz_dV_tnode_GND*value_exp_0);
d_ibet_dV_bp_ei = (czz*(deriv_exp_0_d0*((-(-abet_t)*d_pocce_dV_bp_ei/pocce/pocce)))+d_czz_dV_bp_ei*value_exp_0);
ibet = (czz*value_exp_0);
}
}
else
{

d_ibet_dV_bp_ei = d_ibet_dV_tnode_GND = d_ibet_dV_bi_ci = d_ibet_dV_bi_ei =  0.0;
ibet = 0.0;
}
}
}
// End block HICTUN
else
{

d_ibet_dV_bp_ei = d_ibet_dV_tnode_GND = d_ibet_dV_bi_ci = d_ibet_dV_bi_ei =  0.0;
ibet = 0.0;
}
if ((vptcx_t<1.0e2))
{
if ((cjcx02_t>0.0))
{
Dz_r = ((model_.zcx)/4.0);

d_Dv_p_dV_tnode_GND = (d_vptcx_t_dV_tnode_GND-d_vdcx_t_dV_tnode_GND);
Dv_p = (vptcx_t-vdcx_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

d_DV_f_dV_tnode_GND = d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1);
DV_f = (vdcx_t*(1.0-value_exp_1));
}

d_DC_max_dV_tnode_GND = 2.4*d_cjcx02_t_dV_tnode_GND;
DC_max = (2.4*cjcx02_t);
{
double value_log_0 = log((vptcx_t/vdcx_t));
double value_exp_1 = exp(((Dz_r-(model_.zcx))*value_log_0));
double  deriv_log_0_d0 = (1.0/(vptcx_t/vdcx_t));
double  deriv_exp_1_d0 = value_exp_1;

d_DC_c_dV_tnode_GND = (cjcx02_t*(deriv_exp_1_d0*((Dz_r-(model_.zcx))*(deriv_log_0_d0*(((vdcx_t*d_vptcx_t_dV_tnode_GND-vptcx_t*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t)))))+d_cjcx02_t_dV_tnode_GND*value_exp_1);
DC_c = (cjcx02_t*value_exp_1);
}

d_Dv_e_dV_s_c = d_Dv_e_dV_si_ci = d_Dv_e_dV_b_ci = d_Dv_e_dV_bi_ci =  0.0;
d_Dv_e_dV_bp_ci = ((-d_Vbpci_dV_bp_ci)/VT);
d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vbpci)*d_VT_dV_tnode_GND)/VT/VT);
Dv_e = ((DV_f-Vbpci)/VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
De = value_exp_0;
}

d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci =  0.0;
d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));

d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci =  0.0;
d_Dv_j1_dV_bi_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bi_ci)));
d_Dv_j1_dV_bp_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bp_ci)));
d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-(VT*(deriv_log_0_d0*(d_De_dV_tnode_GND))+d_VT_dV_tnode_GND*value_log_0));
Dv_j1 = (DV_f-(VT*value_log_0));
}
}
else
{

d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
De_1 = 1.0;

d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
d_Dv_j1_dV_bp_ci = d_Vbpci_dV_bp_ci;
Dv_j1 = Vbpci;
}

d_Da_dV_tnode_GND = (0.1*d_Dv_p_dV_tnode_GND+4.0*d_VT_dV_tnode_GND);
Da = ((0.1*Dv_p)+(4.0*VT));

d_Dv_r_dV_s_c = d_Dv_r_dV_si_ci = d_Dv_r_dV_b_ci =  0.0;
d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c = d_De_dV_si_ci = d_De_dV_b_ci =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
De = value_exp_0;
}

d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci =  0.0;
d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;

d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci =  0.0;
d_Dv_j2_dV_bi_ci = Da*(deriv_log_0_d0*(d_De_dV_bi_ci));
d_Dv_j2_dV_bp_ci = Da*(deriv_log_0_d0*(d_De_dV_bp_ci));
d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+(Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da))))+d_Da_dV_tnode_GND*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{

d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
De_2 = 1.0;

d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci = d_Dv_j2_dV_b_ci =  0.0;
d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
Dv_j2 = Dv_j1;
}

d_Dv_j4_dV_s_c = d_Dv_j4_dV_si_ci = d_Dv_j4_dV_b_ci =  0.0;
d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
d_Dv_j4_dV_bp_ci = (d_Vbpci_dV_bp_ci-d_Dv_j1_dV_bp_ci);
Dv_j4 = (Vbpci-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdcx_t)));

d_DCln1_dV_s_c = d_DCln1_dV_si_ci = d_DCln1_dV_b_ci =  0.0;
d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdcx_t))));
d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vdcx_t))));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdcx_t)));

d_DCln2_dV_s_c = d_DCln2_dV_si_ci = d_DCln2_dV_b_ci =  0.0;
d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdcx_t))));
d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vdcx_t))));
DCln2 = value_log_0;
}
Dz1 = (1.0-(model_.zcx));
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-(model_.zcx))));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j1_dV_s_c = d_DC_j1_dV_si_ci = d_DC_j1_dV_b_ci =  0.0;
d_DC_j1_dV_bi_ci = (((cjcx02_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci+((cjcx02_t*value_exp_0)*d_De_1_dV_bi_ci+cjcx02_t*(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*(-(model_.zcx))))*De_1)*De_2);
d_DC_j1_dV_bp_ci = (((cjcx02_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci+((cjcx02_t*value_exp_0)*d_De_1_dV_bp_ci+cjcx02_t*(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*(-(model_.zcx))))*De_1)*De_2);
d_DC_j1_dV_tnode_GND = (((cjcx02_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND+((cjcx02_t*value_exp_0)*d_De_1_dV_tnode_GND+(cjcx02_t*(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*(-(model_.zcx))))+d_cjcx02_t_dV_tnode_GND*value_exp_0)*De_1)*De_2);
DC_j1 = (((cjcx02_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j2_dV_s_c = d_DC_j2_dV_si_ci = d_DC_j2_dV_b_ci =  0.0;
d_DC_j2_dV_bi_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_bp_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_tnode_GND = ((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND)+(DC_c*(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*(-Dz_r)))+d_DC_c_dV_tnode_GND*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}

d_DC_j3_dV_s_c = d_DC_j3_dV_si_ci = d_DC_j3_dV_b_ci =  0.0;
d_DC_j3_dV_bi_ci = DC_max*(-d_De_1_dV_bi_ci);
d_DC_j3_dV_bp_ci = DC_max*(-d_De_1_dV_bp_ci);
d_DC_j3_dV_tnode_GND = (DC_max*(-d_De_1_dV_tnode_GND)+d_DC_max_dV_tnode_GND*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
CjCx_ii = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j1_dV_s_c = d_DQ_j1_dV_si_ci = d_DQ_j1_dV_b_ci =  0.0;
d_DQ_j1_dV_bi_ci = (cjcx02_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dz1)))/Dz1);
d_DQ_j1_dV_bp_ci = (cjcx02_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dz1)))/Dz1);
d_DQ_j1_dV_tnode_GND = ((cjcx02_t*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dz1)))+d_cjcx02_t_dV_tnode_GND*(1.0-value_exp_0))/Dz1);
DQ_j1 = ((cjcx02_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j2_dV_s_c = d_DQ_j2_dV_si_ci = d_DQ_j2_dV_b_ci =  0.0;
d_DQ_j2_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j3_dV_s_c = d_DQ_j3_dV_si_ci = d_DQ_j3_dV_b_ci =  0.0;
d_DQ_j3_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}

d_qjcx0_t_ii_dV_bp_ei = d_qjcx0_t_ii_dV_bi_ei =  0.0;
d_qjcx0_t_ii_dV_bi_ci = (((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdcx_t+DC_max*d_Dv_j4_dV_bi_ci);
d_qjcx0_t_ii_dV_tnode_GND = ((((DQ_j1+DQ_j2)-DQ_j3)*d_vdcx_t_dV_tnode_GND+((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdcx_t)+(DC_max*d_Dv_j4_dV_tnode_GND+d_DC_max_dV_tnode_GND*Dv_j4));
d_qjcx0_t_ii_dV_bp_ci = (((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vdcx_t+DC_max*d_Dv_j4_dV_bp_ci);
qjcx0_t_ii = ((((DQ_j1+DQ_j2)-DQ_j3)*vdcx_t)+(DC_max*Dv_j4));
}
else
{
CjCx_ii = 0.0;

d_qjcx0_t_ii_dV_bp_ei = d_qjcx0_t_ii_dV_bi_ei = d_qjcx0_t_ii_dV_bp_ci = d_qjcx0_t_ii_dV_tnode_GND = d_qjcx0_t_ii_dV_bi_ci =  0.0;
qjcx0_t_ii = 0.0;
}
}
else
{
if ((cjcx02_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

d_DFV_f_dV_tnode_GND = d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1);
DFV_f = (vdcx_t*(1.0-value_exp_1));
}

d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
d_DFv_e_dV_bp_ci = ((-d_Vbpci_dV_bp_ci)/VT);
d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbpci)*d_VT_dV_tnode_GND)/VT/VT);
DFv_e = ((DFV_f-Vbpci)/VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci = d_DFs_q_dV_b_ci =  0.0;
d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ei+d_DFv_e_dV_bi_ei*DFv_e)));
d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_tnode_GND+d_DFv_e_dV_tnode_GND*DFv_e)));
d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ci+d_DFv_e_dV_bi_ci*DFv_e)));
d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ei+d_DFv_e_dV_bp_ei*DFv_e)));
d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ci+d_DFv_e_dV_bp_ci*DFv_e)));
DFs_q = value_sqrt_0;
}

d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci = d_DFs_q2_dV_b_ci =  0.0;
d_DFs_q2_dV_bi_ei = (d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5;
d_DFs_q2_dV_tnode_GND = (d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5;
d_DFs_q2_dV_bi_ci = (d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5;
d_DFs_q2_dV_bp_ei = (d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5;
d_DFs_q2_dV_bp_ci = (d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);

d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci = d_DFv_j_dV_b_ci =  0.0;
d_DFv_j_dV_bi_ei = (-VT*d_DFs_q2_dV_bi_ei);
d_DFv_j_dV_bi_ci = (-VT*d_DFs_q2_dV_bi_ci);
d_DFv_j_dV_bp_ei = (-VT*d_DFs_q2_dV_bp_ei);
d_DFv_j_dV_bp_ci = (-VT*d_DFs_q2_dV_bp_ci);
d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-(VT*d_DFs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*DFs_q2));
DFv_j = (DFV_f-(VT*DFs_q2));

d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci = d_DFdvj_dv_dV_b_ci =  0.0;
d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdcx_t)));

d_DFb_dV_s_c = d_DFb_dV_si_ci = d_DFb_dV_b_ci =  0.0;
d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdcx_t))));
d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdcx_t))));
d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdcx_t))));
d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vdcx_t))));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-(model_.zcx))*DFb));
double  deriv_exp_0_d0 = value_exp_0;

d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci = d_DFC_j1_dV_b_ci =  0.0;
d_DFC_j1_dV_bi_ei = ((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei+cjcx02_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bi_ei))*DFdvj_dv);
d_DFC_j1_dV_bi_ci = ((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci+cjcx02_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bi_ci))*DFdvj_dv);
d_DFC_j1_dV_bp_ei = ((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei+cjcx02_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bp_ei))*DFdvj_dv);
d_DFC_j1_dV_bp_ci = ((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci+cjcx02_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bp_ci))*DFdvj_dv);
d_DFC_j1_dV_tnode_GND = ((cjcx02_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND+(cjcx02_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_tnode_GND))+d_cjcx02_t_dV_tnode_GND*value_exp_0)*DFdvj_dv);
DFC_j1 = ((cjcx02_t*value_exp_0)*DFdvj_dv);
}
CjCx_ii = (DFC_j1+((2.4*cjcx02_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-(model_.zcx))));
double  deriv_exp_0_d0 = value_exp_0;

d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci = d_DFQ_j_dV_b_ci =  0.0;
d_DFQ_j_dV_bi_ei = ((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ei*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_bi_ci = ((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ci*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_bp_ei = ((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ei*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_bp_ci = ((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ci*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_tnode_GND = (((cjcx02_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_tnode_GND*(1.0-(model_.zcx)))))+(cjcx02_t*d_vdcx_t_dV_tnode_GND+d_cjcx02_t_dV_tnode_GND*vdcx_t)*(1.0-value_exp_0))/(1.0-(model_.zcx)));
DFQ_j = (((cjcx02_t*vdcx_t)*(1.0-value_exp_0))/(1.0-(model_.zcx)));
}

d_qjcx0_t_ii_dV_bi_ei = (d_DFQ_j_dV_bi_ei+(2.4*cjcx02_t)*(-d_DFv_j_dV_bi_ei));
d_qjcx0_t_ii_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+((2.4*cjcx02_t)*(-d_DFv_j_dV_tnode_GND)+2.4*d_cjcx02_t_dV_tnode_GND*(Vbpci-DFv_j)));
d_qjcx0_t_ii_dV_bi_ci = (d_DFQ_j_dV_bi_ci+(2.4*cjcx02_t)*(-d_DFv_j_dV_bi_ci));
d_qjcx0_t_ii_dV_bp_ei = (d_DFQ_j_dV_bp_ei+(2.4*cjcx02_t)*(-d_DFv_j_dV_bp_ei));
d_qjcx0_t_ii_dV_bp_ci = (d_DFQ_j_dV_bp_ci+(2.4*cjcx02_t)*(d_Vbpci_dV_bp_ci-d_DFv_j_dV_bp_ci));
qjcx0_t_ii = (DFQ_j+((2.4*cjcx02_t)*(Vbpci-DFv_j)));
}
else
{
CjCx_ii = 0.0;

d_qjcx0_t_ii_dV_bp_ei = d_qjcx0_t_ii_dV_bi_ei = d_qjcx0_t_ii_dV_bp_ci = d_qjcx0_t_ii_dV_tnode_GND = d_qjcx0_t_ii_dV_bi_ci =  0.0;
qjcx0_t_ii = 0.0;
}
}

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
d_DIOY_dV_tnode_GND = (-Vbpci*(model_.mbcx)*d_VT_dV_tnode_GND/((model_.mbcx)*VT)/((model_.mbcx)*VT));
d_DIOY_dV_bp_ci = (d_Vbpci_dV_bp_ci/((model_.mbcx)*VT));
DIOY = (Vbpci/((model_.mbcx)*VT));
if (((model_.ibcxs)>0.0))
{
if ((DIOY>80.0))
{

d_le_dV_si_ci =  0.0;
d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
d_le_dV_bp_ci = d_DIOY_dV_bp_ci;
le = (1+(DIOY-80.0));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
DIOY = 80.0;
}
else
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

d_le_dV_si_ci =  0.0;
d_le_dV_tnode_GND = (le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND))+d_le_dV_tnode_GND*value_limexp_0);
d_le_dV_bi_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei))+d_le_dV_bi_ei*value_limexp_0);
d_le_dV_bi_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci))+d_le_dV_bi_ci*value_limexp_0);
d_le_dV_bp_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei))+d_le_dV_bp_ei*value_limexp_0);
d_le_dV_bp_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ci))+d_le_dV_bp_ci*value_limexp_0);
le = (le*value_limexp_0);
}

d_ijbcx_dV_bi_ei = ibcxs_t*d_le_dV_bi_ei;
d_ijbcx_dV_bi_ci = ibcxs_t*d_le_dV_bi_ci;
d_ijbcx_dV_bp_ei = ibcxs_t*d_le_dV_bp_ei;
d_ijbcx_dV_bp_ci = ibcxs_t*d_le_dV_bp_ci;
d_ijbcx_dV_tnode_GND = (ibcxs_t*d_le_dV_tnode_GND+d_ibcxs_t_dV_tnode_GND*(le-1.0));
ijbcx = (ibcxs_t*(le-1.0));
if ((DIOY<=(-14.0)))
{

d_ijbcx_dV_bp_ci = d_ijbcx_dV_bp_ei = d_ijbcx_dV_bi_ci = d_ijbcx_dV_bi_ei =  0.0;
d_ijbcx_dV_tnode_GND = (-d_ibcxs_t_dV_tnode_GND);
ijbcx = (-ibcxs_t);
}
}
else
{

d_ijbcx_dV_tnode_GND = d_ijbcx_dV_bp_ci = d_ijbcx_dV_bp_ei = d_ijbcx_dV_bi_ci = d_ijbcx_dV_bi_ei =  0.0;
ijbcx = 0.0;
}
if ((vptcx_t<1.0e2))
{
if ((cjcx01_t>0.0))
{
Dz_r = ((model_.zcx)/4.0);

d_Dv_p_dV_tnode_GND = (d_vptcx_t_dV_tnode_GND-d_vdcx_t_dV_tnode_GND);
Dv_p = (vptcx_t-vdcx_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

d_DV_f_dV_tnode_GND = d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1);
DV_f = (vdcx_t*(1.0-value_exp_1));
}

d_DC_max_dV_tnode_GND = 2.4*d_cjcx01_t_dV_tnode_GND;
DC_max = (2.4*cjcx01_t);
{
double value_log_0 = log((vptcx_t/vdcx_t));
double value_exp_1 = exp(((Dz_r-(model_.zcx))*value_log_0));
double  deriv_log_0_d0 = (1.0/(vptcx_t/vdcx_t));
double  deriv_exp_1_d0 = value_exp_1;

d_DC_c_dV_tnode_GND = (cjcx01_t*(deriv_exp_1_d0*((Dz_r-(model_.zcx))*(deriv_log_0_d0*(((vdcx_t*d_vptcx_t_dV_tnode_GND-vptcx_t*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t)))))+d_cjcx01_t_dV_tnode_GND*value_exp_1);
DC_c = (cjcx01_t*value_exp_1);
}

d_Dv_e_dV_s_c = d_Dv_e_dV_si_ci = d_Dv_e_dV_bp_ci = d_Dv_e_dV_bi_ci =  0.0;
d_Dv_e_dV_b_ci = ((-d_Vbci_dV_b_ci)/VT);
d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vbci)*d_VT_dV_tnode_GND)/VT/VT);
Dv_e = ((DV_f-Vbci)/VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c = d_De_dV_si_ci =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_e_dV_b_ci));
De = value_exp_0;
}

d_De_1_dV_s_c = d_De_1_dV_si_ci =  0.0;
d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));

d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci =  0.0;
d_Dv_j1_dV_bi_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bi_ci)));
d_Dv_j1_dV_bp_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bp_ci)));
d_Dv_j1_dV_b_ci = (-VT*(deriv_log_0_d0*(d_De_dV_b_ci)));
d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-(VT*(deriv_log_0_d0*(d_De_dV_tnode_GND))+d_VT_dV_tnode_GND*value_log_0));
Dv_j1 = (DV_f-(VT*value_log_0));
}
}
else
{

d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
De_1 = 1.0;

d_Dv_j1_dV_s_c = d_Dv_j1_dV_si_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
d_Dv_j1_dV_b_ci = d_Vbci_dV_b_ci;
Dv_j1 = Vbci;
}

d_Da_dV_tnode_GND = (0.1*d_Dv_p_dV_tnode_GND+4.0*d_VT_dV_tnode_GND);
Da = ((0.1*Dv_p)+(4.0*VT));

d_Dv_r_dV_s_c = d_Dv_r_dV_si_ci =  0.0;
d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
d_Dv_r_dV_b_ci = (d_Dv_j1_dV_b_ci/Da);
d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c = d_De_dV_si_ci =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_r_dV_b_ci));
De = value_exp_0;
}

d_De_2_dV_s_c = d_De_2_dV_si_ci =  0.0;
d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;

d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci =  0.0;
d_Dv_j2_dV_bi_ci = Da*(deriv_log_0_d0*(d_De_dV_bi_ci));
d_Dv_j2_dV_bp_ci = Da*(deriv_log_0_d0*(d_De_dV_bp_ci));
d_Dv_j2_dV_b_ci = Da*(deriv_log_0_d0*(d_De_dV_b_ci));
d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+(Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da))))+d_Da_dV_tnode_GND*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{

d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
De_2 = 1.0;

d_Dv_j2_dV_s_c = d_Dv_j2_dV_si_ci =  0.0;
d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
d_Dv_j2_dV_b_ci = d_Dv_j1_dV_b_ci;
Dv_j2 = Dv_j1;
}

d_Dv_j4_dV_s_c = d_Dv_j4_dV_si_ci =  0.0;
d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
d_Dv_j4_dV_bp_ci = (-d_Dv_j1_dV_bp_ci);
d_Dv_j4_dV_b_ci = (d_Vbci_dV_b_ci-d_Dv_j1_dV_b_ci);
Dv_j4 = (Vbci-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdcx_t)));

d_DCln1_dV_s_c = d_DCln1_dV_si_ci =  0.0;
d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdcx_t))));
d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vdcx_t))));
d_DCln1_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_b_ci/vdcx_t))));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdcx_t)));

d_DCln2_dV_s_c = d_DCln2_dV_si_ci =  0.0;
d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdcx_t))));
d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vdcx_t))));
d_DCln2_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_b_ci/vdcx_t))));
DCln2 = value_log_0;
}
Dz1 = (1.0-(model_.zcx));
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-(model_.zcx))));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j1_dV_s_c = d_DC_j1_dV_si_ci =  0.0;
d_DC_j1_dV_bi_ci = (((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci+((cjcx01_t*value_exp_0)*d_De_1_dV_bi_ci+cjcx01_t*(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*(-(model_.zcx))))*De_1)*De_2);
d_DC_j1_dV_bp_ci = (((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci+((cjcx01_t*value_exp_0)*d_De_1_dV_bp_ci+cjcx01_t*(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*(-(model_.zcx))))*De_1)*De_2);
d_DC_j1_dV_b_ci = (((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_b_ci+((cjcx01_t*value_exp_0)*d_De_1_dV_b_ci+cjcx01_t*(deriv_exp_0_d0*(d_DCln2_dV_b_ci*(-(model_.zcx))))*De_1)*De_2);
d_DC_j1_dV_tnode_GND = (((cjcx01_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND+((cjcx01_t*value_exp_0)*d_De_1_dV_tnode_GND+(cjcx01_t*(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*(-(model_.zcx))))+d_cjcx01_t_dV_tnode_GND*value_exp_0)*De_1)*De_2);
DC_j1 = (((cjcx01_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j2_dV_s_c = d_DC_j2_dV_si_ci =  0.0;
d_DC_j2_dV_bi_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_bp_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_b_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_b_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_b_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_tnode_GND = ((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND)+(DC_c*(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*(-Dz_r)))+d_DC_c_dV_tnode_GND*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}

d_DC_j3_dV_s_c = d_DC_j3_dV_si_ci =  0.0;
d_DC_j3_dV_bi_ci = DC_max*(-d_De_1_dV_bi_ci);
d_DC_j3_dV_bp_ci = DC_max*(-d_De_1_dV_bp_ci);
d_DC_j3_dV_b_ci = DC_max*(-d_De_1_dV_b_ci);
d_DC_j3_dV_tnode_GND = (DC_max*(-d_De_1_dV_tnode_GND)+d_DC_max_dV_tnode_GND*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
CjCx_i = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j1_dV_s_c = d_DQ_j1_dV_si_ci =  0.0;
d_DQ_j1_dV_bi_ci = (cjcx01_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dz1)))/Dz1);
d_DQ_j1_dV_bp_ci = (cjcx01_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dz1)))/Dz1);
d_DQ_j1_dV_b_ci = (cjcx01_t*(-(deriv_exp_0_d0*(d_DCln2_dV_b_ci*Dz1)))/Dz1);
d_DQ_j1_dV_tnode_GND = ((cjcx01_t*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dz1)))+d_cjcx01_t_dV_tnode_GND*(1.0-value_exp_0))/Dz1);
DQ_j1 = ((cjcx01_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j2_dV_s_c = d_DQ_j2_dV_si_ci =  0.0;
d_DQ_j2_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_b_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_b_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j3_dV_s_c = d_DQ_j3_dV_si_ci =  0.0;
d_DQ_j3_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_b_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_b_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}

d_qjcx0_t_i_dV_bp_ei = d_qjcx0_t_i_dV_bi_ei =  0.0;
d_qjcx0_t_i_dV_bi_ci = (((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdcx_t+DC_max*d_Dv_j4_dV_bi_ci);
d_qjcx0_t_i_dV_tnode_GND = ((((DQ_j1+DQ_j2)-DQ_j3)*d_vdcx_t_dV_tnode_GND+((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdcx_t)+(DC_max*d_Dv_j4_dV_tnode_GND+d_DC_max_dV_tnode_GND*Dv_j4));
d_qjcx0_t_i_dV_bp_ci = (((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vdcx_t+DC_max*d_Dv_j4_dV_bp_ci);
d_qjcx0_t_i_dV_b_ci = (((d_DQ_j1_dV_b_ci+d_DQ_j2_dV_b_ci)-d_DQ_j3_dV_b_ci)*vdcx_t+DC_max*d_Dv_j4_dV_b_ci);
qjcx0_t_i = ((((DQ_j1+DQ_j2)-DQ_j3)*vdcx_t)+(DC_max*Dv_j4));
}
else
{
CjCx_i = 0.0;

d_qjcx0_t_i_dV_bp_ei = d_qjcx0_t_i_dV_bi_ei = d_qjcx0_t_i_dV_b_ci = d_qjcx0_t_i_dV_bp_ci = d_qjcx0_t_i_dV_tnode_GND = d_qjcx0_t_i_dV_bi_ci =  0.0;
qjcx0_t_i = 0.0;
}
}
else
{
if ((cjcx01_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zcx)));

d_DFV_f_dV_tnode_GND = d_vdcx_t_dV_tnode_GND*(1.0-value_exp_1);
DFV_f = (vdcx_t*(1.0-value_exp_1));
}

d_DFv_e_dV_s_c = d_DFv_e_dV_si_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
d_DFv_e_dV_b_ci = ((-d_Vbci_dV_b_ci)/VT);
d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vbci)*d_VT_dV_tnode_GND)/VT/VT);
DFv_e = ((DFV_f-Vbci)/VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_DFs_q_dV_s_c = d_DFs_q_dV_si_ci =  0.0;
d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ei+d_DFv_e_dV_bi_ei*DFv_e)));
d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_tnode_GND+d_DFv_e_dV_tnode_GND*DFv_e)));
d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ci+d_DFv_e_dV_bi_ci*DFv_e)));
d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ei+d_DFv_e_dV_bp_ei*DFv_e)));
d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ci+d_DFv_e_dV_bp_ci*DFv_e)));
d_DFs_q_dV_b_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_b_ci+d_DFv_e_dV_b_ci*DFv_e)));
DFs_q = value_sqrt_0;
}

d_DFs_q2_dV_s_c = d_DFs_q2_dV_si_ci =  0.0;
d_DFs_q2_dV_bi_ei = (d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5;
d_DFs_q2_dV_tnode_GND = (d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5;
d_DFs_q2_dV_bi_ci = (d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5;
d_DFs_q2_dV_bp_ei = (d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5;
d_DFs_q2_dV_bp_ci = (d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5;
d_DFs_q2_dV_b_ci = (d_DFv_e_dV_b_ci+d_DFs_q_dV_b_ci)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);

d_DFv_j_dV_s_c = d_DFv_j_dV_si_ci =  0.0;
d_DFv_j_dV_bi_ei = (-VT*d_DFs_q2_dV_bi_ei);
d_DFv_j_dV_bi_ci = (-VT*d_DFs_q2_dV_bi_ci);
d_DFv_j_dV_bp_ei = (-VT*d_DFs_q2_dV_bp_ei);
d_DFv_j_dV_bp_ci = (-VT*d_DFs_q2_dV_bp_ci);
d_DFv_j_dV_b_ci = (-VT*d_DFs_q2_dV_b_ci);
d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-(VT*d_DFs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*DFs_q2));
DFv_j = (DFV_f-(VT*DFs_q2));

d_DFdvj_dv_dV_s_c = d_DFdvj_dv_dV_si_ci =  0.0;
d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_b_ci = ((DFs_q*d_DFs_q2_dV_b_ci-DFs_q2*d_DFs_q_dV_b_ci)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdcx_t)));

d_DFb_dV_s_c = d_DFb_dV_si_ci =  0.0;
d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdcx_t))));
d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdcx_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdcx_t_dV_tnode_GND)/vdcx_t/vdcx_t))));
d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdcx_t))));
d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdcx_t))));
d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vdcx_t))));
d_DFb_dV_b_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_b_ci/vdcx_t))));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-(model_.zcx))*DFb));
double  deriv_exp_0_d0 = value_exp_0;

d_DFC_j1_dV_s_c = d_DFC_j1_dV_si_ci =  0.0;
d_DFC_j1_dV_bi_ei = ((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei+cjcx01_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bi_ei))*DFdvj_dv);
d_DFC_j1_dV_bi_ci = ((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci+cjcx01_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bi_ci))*DFdvj_dv);
d_DFC_j1_dV_bp_ei = ((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei+cjcx01_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bp_ei))*DFdvj_dv);
d_DFC_j1_dV_bp_ci = ((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci+cjcx01_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_bp_ci))*DFdvj_dv);
d_DFC_j1_dV_b_ci = ((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_b_ci+cjcx01_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_b_ci))*DFdvj_dv);
d_DFC_j1_dV_tnode_GND = ((cjcx01_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND+(cjcx01_t*(deriv_exp_0_d0*((-(model_.zcx))*d_DFb_dV_tnode_GND))+d_cjcx01_t_dV_tnode_GND*value_exp_0)*DFdvj_dv);
DFC_j1 = ((cjcx01_t*value_exp_0)*DFdvj_dv);
}
CjCx_i = (DFC_j1+((2.4*cjcx01_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-(model_.zcx))));
double  deriv_exp_0_d0 = value_exp_0;

d_DFQ_j_dV_s_c = d_DFQ_j_dV_si_ci =  0.0;
d_DFQ_j_dV_bi_ei = ((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ei*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_bi_ci = ((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ci*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_bp_ei = ((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ei*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_bp_ci = ((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ci*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_b_ci = ((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_b_ci*(1.0-(model_.zcx)))))/(1.0-(model_.zcx)));
d_DFQ_j_dV_tnode_GND = (((cjcx01_t*vdcx_t)*(-(deriv_exp_0_d0*(d_DFb_dV_tnode_GND*(1.0-(model_.zcx)))))+(cjcx01_t*d_vdcx_t_dV_tnode_GND+d_cjcx01_t_dV_tnode_GND*vdcx_t)*(1.0-value_exp_0))/(1.0-(model_.zcx)));
DFQ_j = (((cjcx01_t*vdcx_t)*(1.0-value_exp_0))/(1.0-(model_.zcx)));
}

d_qjcx0_t_i_dV_bi_ei = (d_DFQ_j_dV_bi_ei+(2.4*cjcx01_t)*(-d_DFv_j_dV_bi_ei));
d_qjcx0_t_i_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+((2.4*cjcx01_t)*(-d_DFv_j_dV_tnode_GND)+2.4*d_cjcx01_t_dV_tnode_GND*(Vbci-DFv_j)));
d_qjcx0_t_i_dV_bi_ci = (d_DFQ_j_dV_bi_ci+(2.4*cjcx01_t)*(-d_DFv_j_dV_bi_ci));
d_qjcx0_t_i_dV_bp_ei = (d_DFQ_j_dV_bp_ei+(2.4*cjcx01_t)*(-d_DFv_j_dV_bp_ei));
d_qjcx0_t_i_dV_bp_ci = (d_DFQ_j_dV_bp_ci+(2.4*cjcx01_t)*(-d_DFv_j_dV_bp_ci));
d_qjcx0_t_i_dV_b_ci = (d_DFQ_j_dV_b_ci+(2.4*cjcx01_t)*(d_Vbci_dV_b_ci-d_DFv_j_dV_b_ci));
qjcx0_t_i = (DFQ_j+((2.4*cjcx01_t)*(Vbci-DFv_j)));
}
else
{
CjCx_i = 0.0;

d_qjcx0_t_i_dV_bp_ei = d_qjcx0_t_i_dV_bi_ei = d_qjcx0_t_i_dV_b_ci = d_qjcx0_t_i_dV_bp_ci = d_qjcx0_t_i_dV_tnode_GND = d_qjcx0_t_i_dV_bi_ci =  0.0;
qjcx0_t_i = 0.0;
}
}
if ((vpts_t<1.0e2))
{
if ((cjs0_t>0.0))
{
Dz_r = ((model_.zs)/4.0);

d_Dv_p_dV_tnode_GND = (d_vpts_t_dV_tnode_GND-d_vds_t_dV_tnode_GND);
Dv_p = (vpts_t-vds_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zs)));

d_DV_f_dV_tnode_GND = d_vds_t_dV_tnode_GND*(1.0-value_exp_1);
DV_f = (vds_t*(1.0-value_exp_1));
}

d_DC_max_dV_tnode_GND = 2.4*d_cjs0_t_dV_tnode_GND;
DC_max = (2.4*cjs0_t);
{
double value_log_0 = log((vpts_t/vds_t));
double value_exp_1 = exp(((Dz_r-(model_.zs))*value_log_0));
double  deriv_log_0_d0 = (1.0/(vpts_t/vds_t));
double  deriv_exp_1_d0 = value_exp_1;

d_DC_c_dV_tnode_GND = (cjs0_t*(deriv_exp_1_d0*((Dz_r-(model_.zs))*(deriv_log_0_d0*(((vds_t*d_vpts_t_dV_tnode_GND-vpts_t*d_vds_t_dV_tnode_GND)/vds_t/vds_t)))))+d_cjs0_t_dV_tnode_GND*value_exp_1);
DC_c = (cjs0_t*value_exp_1);
}

d_Dv_e_dV_s_c = d_Dv_e_dV_b_ci = d_Dv_e_dV_bp_ci = d_Dv_e_dV_bi_ci =  0.0;
d_Dv_e_dV_si_ci = ((-d_Vsici_dV_si_ci)/VT);
d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vsici)*d_VT_dV_tnode_GND)/VT/VT);
Dv_e = ((DV_f-Vsici)/VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_e_dV_b_ci));
d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_e_dV_si_ci));
De = value_exp_0;
}

d_De_1_dV_s_c =  0.0;
d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));

d_Dv_j1_dV_s_c =  0.0;
d_Dv_j1_dV_bi_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bi_ci)));
d_Dv_j1_dV_bp_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bp_ci)));
d_Dv_j1_dV_b_ci = (-VT*(deriv_log_0_d0*(d_De_dV_b_ci)));
d_Dv_j1_dV_si_ci = (-VT*(deriv_log_0_d0*(d_De_dV_si_ci)));
d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-(VT*(deriv_log_0_d0*(d_De_dV_tnode_GND))+d_VT_dV_tnode_GND*value_log_0));
Dv_j1 = (DV_f-(VT*value_log_0));
}
}
else
{

d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
De_1 = 1.0;

d_Dv_j1_dV_s_c = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
d_Dv_j1_dV_si_ci = d_Vsici_dV_si_ci;
Dv_j1 = Vsici;
}

d_Da_dV_tnode_GND = (0.1*d_Dv_p_dV_tnode_GND+4.0*d_VT_dV_tnode_GND);
Da = ((0.1*Dv_p)+(4.0*VT));

d_Dv_r_dV_s_c =  0.0;
d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
d_Dv_r_dV_b_ci = (d_Dv_j1_dV_b_ci/Da);
d_Dv_r_dV_si_ci = (d_Dv_j1_dV_si_ci/Da);
d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_s_c =  0.0;
d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_r_dV_b_ci));
d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_r_dV_si_ci));
De = value_exp_0;
}

d_De_2_dV_s_c =  0.0;
d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;

d_Dv_j2_dV_s_c =  0.0;
d_Dv_j2_dV_bi_ci = Da*(deriv_log_0_d0*(d_De_dV_bi_ci));
d_Dv_j2_dV_bp_ci = Da*(deriv_log_0_d0*(d_De_dV_bp_ci));
d_Dv_j2_dV_b_ci = Da*(deriv_log_0_d0*(d_De_dV_b_ci));
d_Dv_j2_dV_si_ci = Da*(deriv_log_0_d0*(d_De_dV_si_ci));
d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+(Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da))))+d_Da_dV_tnode_GND*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{

d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
De_2 = 1.0;

d_Dv_j2_dV_s_c =  0.0;
d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
d_Dv_j2_dV_b_ci = d_Dv_j1_dV_b_ci;
d_Dv_j2_dV_si_ci = d_Dv_j1_dV_si_ci;
Dv_j2 = Dv_j1;
}

d_Dv_j4_dV_s_c =  0.0;
d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
d_Dv_j4_dV_bp_ci = (-d_Dv_j1_dV_bp_ci);
d_Dv_j4_dV_b_ci = (-d_Dv_j1_dV_b_ci);
d_Dv_j4_dV_si_ci = (d_Vsici_dV_si_ci-d_Dv_j1_dV_si_ci);
Dv_j4 = (Vsici-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/vds_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vds_t)));

d_DCln1_dV_s_c =  0.0;
d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vds_t))));
d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vds_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vds_t_dV_tnode_GND)/vds_t/vds_t))));
d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vds_t))));
d_DCln1_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_b_ci/vds_t))));
d_DCln1_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_si_ci/vds_t))));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/vds_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vds_t)));

d_DCln2_dV_s_c =  0.0;
d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vds_t))));
d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vds_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vds_t_dV_tnode_GND)/vds_t/vds_t))));
d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vds_t))));
d_DCln2_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_b_ci/vds_t))));
d_DCln2_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_si_ci/vds_t))));
DCln2 = value_log_0;
}
Dz1 = (1.0-(model_.zs));
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-(model_.zs))));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j1_dV_s_c =  0.0;
d_DC_j1_dV_bi_ci = (((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci+((cjs0_t*value_exp_0)*d_De_1_dV_bi_ci+cjs0_t*(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*(-(model_.zs))))*De_1)*De_2);
d_DC_j1_dV_bp_ci = (((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci+((cjs0_t*value_exp_0)*d_De_1_dV_bp_ci+cjs0_t*(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*(-(model_.zs))))*De_1)*De_2);
d_DC_j1_dV_b_ci = (((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_b_ci+((cjs0_t*value_exp_0)*d_De_1_dV_b_ci+cjs0_t*(deriv_exp_0_d0*(d_DCln2_dV_b_ci*(-(model_.zs))))*De_1)*De_2);
d_DC_j1_dV_si_ci = (((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_si_ci+((cjs0_t*value_exp_0)*d_De_1_dV_si_ci+cjs0_t*(deriv_exp_0_d0*(d_DCln2_dV_si_ci*(-(model_.zs))))*De_1)*De_2);
d_DC_j1_dV_tnode_GND = (((cjs0_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND+((cjs0_t*value_exp_0)*d_De_1_dV_tnode_GND+(cjs0_t*(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*(-(model_.zs))))+d_cjs0_t_dV_tnode_GND*value_exp_0)*De_1)*De_2);
DC_j1 = (((cjs0_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j2_dV_s_c =  0.0;
d_DC_j2_dV_bi_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_bp_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_b_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_b_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_b_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_si_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_si_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_si_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_tnode_GND = ((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND)+(DC_c*(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*(-Dz_r)))+d_DC_c_dV_tnode_GND*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}

d_DC_j3_dV_s_c =  0.0;
d_DC_j3_dV_bi_ci = DC_max*(-d_De_1_dV_bi_ci);
d_DC_j3_dV_bp_ci = DC_max*(-d_De_1_dV_bp_ci);
d_DC_j3_dV_b_ci = DC_max*(-d_De_1_dV_b_ci);
d_DC_j3_dV_si_ci = DC_max*(-d_De_1_dV_si_ci);
d_DC_j3_dV_tnode_GND = (DC_max*(-d_De_1_dV_tnode_GND)+d_DC_max_dV_tnode_GND*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
Cjs = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j1_dV_s_c =  0.0;
d_DQ_j1_dV_bi_ci = (cjs0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dz1)))/Dz1);
d_DQ_j1_dV_bp_ci = (cjs0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dz1)))/Dz1);
d_DQ_j1_dV_b_ci = (cjs0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_b_ci*Dz1)))/Dz1);
d_DQ_j1_dV_si_ci = (cjs0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_si_ci*Dz1)))/Dz1);
d_DQ_j1_dV_tnode_GND = ((cjs0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dz1)))+d_cjs0_t_dV_tnode_GND*(1.0-value_exp_0))/Dz1);
DQ_j1 = ((cjs0_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j2_dV_s_c =  0.0;
d_DQ_j2_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_b_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_b_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_si_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_si_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j3_dV_s_c =  0.0;
d_DQ_j3_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_b_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_b_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_si_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_si_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}

d_Qjs_dV_bp_ei = d_Qjs_dV_bi_ei =  0.0;
d_Qjs_dV_bi_ci = (((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vds_t+DC_max*d_Dv_j4_dV_bi_ci);
d_Qjs_dV_tnode_GND = ((((DQ_j1+DQ_j2)-DQ_j3)*d_vds_t_dV_tnode_GND+((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vds_t)+(DC_max*d_Dv_j4_dV_tnode_GND+d_DC_max_dV_tnode_GND*Dv_j4));
d_Qjs_dV_bp_ci = (((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vds_t+DC_max*d_Dv_j4_dV_bp_ci);
d_Qjs_dV_b_ci = (((d_DQ_j1_dV_b_ci+d_DQ_j2_dV_b_ci)-d_DQ_j3_dV_b_ci)*vds_t+DC_max*d_Dv_j4_dV_b_ci);
d_Qjs_dV_si_ci = (((d_DQ_j1_dV_si_ci+d_DQ_j2_dV_si_ci)-d_DQ_j3_dV_si_ci)*vds_t+DC_max*d_Dv_j4_dV_si_ci);
Qjs = ((((DQ_j1+DQ_j2)-DQ_j3)*vds_t)+(DC_max*Dv_j4));
}
else
{
Cjs = 0.0;

d_Qjs_dV_bp_ei = d_Qjs_dV_bi_ei = d_Qjs_dV_si_ci = d_Qjs_dV_b_ci = d_Qjs_dV_bp_ci = d_Qjs_dV_tnode_GND = d_Qjs_dV_bi_ci =  0.0;
Qjs = 0.0;
}
}
else
{
if ((cjs0_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zs)));

d_DFV_f_dV_tnode_GND = d_vds_t_dV_tnode_GND*(1.0-value_exp_1);
DFV_f = (vds_t*(1.0-value_exp_1));
}

d_DFv_e_dV_s_c = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
d_DFv_e_dV_si_ci = ((-d_Vsici_dV_si_ci)/VT);
d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vsici)*d_VT_dV_tnode_GND)/VT/VT);
DFv_e = ((DFV_f-Vsici)/VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_DFs_q_dV_s_c =  0.0;
d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ei+d_DFv_e_dV_bi_ei*DFv_e)));
d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_tnode_GND+d_DFv_e_dV_tnode_GND*DFv_e)));
d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ci+d_DFv_e_dV_bi_ci*DFv_e)));
d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ei+d_DFv_e_dV_bp_ei*DFv_e)));
d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ci+d_DFv_e_dV_bp_ci*DFv_e)));
d_DFs_q_dV_b_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_b_ci+d_DFv_e_dV_b_ci*DFv_e)));
d_DFs_q_dV_si_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_si_ci+d_DFv_e_dV_si_ci*DFv_e)));
DFs_q = value_sqrt_0;
}

d_DFs_q2_dV_s_c =  0.0;
d_DFs_q2_dV_bi_ei = (d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5;
d_DFs_q2_dV_tnode_GND = (d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5;
d_DFs_q2_dV_bi_ci = (d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5;
d_DFs_q2_dV_bp_ei = (d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5;
d_DFs_q2_dV_bp_ci = (d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5;
d_DFs_q2_dV_b_ci = (d_DFv_e_dV_b_ci+d_DFs_q_dV_b_ci)*0.5;
d_DFs_q2_dV_si_ci = (d_DFv_e_dV_si_ci+d_DFs_q_dV_si_ci)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);

d_DFv_j_dV_s_c =  0.0;
d_DFv_j_dV_bi_ei = (-VT*d_DFs_q2_dV_bi_ei);
d_DFv_j_dV_bi_ci = (-VT*d_DFs_q2_dV_bi_ci);
d_DFv_j_dV_bp_ei = (-VT*d_DFs_q2_dV_bp_ei);
d_DFv_j_dV_bp_ci = (-VT*d_DFs_q2_dV_bp_ci);
d_DFv_j_dV_b_ci = (-VT*d_DFs_q2_dV_b_ci);
d_DFv_j_dV_si_ci = (-VT*d_DFs_q2_dV_si_ci);
d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-(VT*d_DFs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*DFs_q2));
DFv_j = (DFV_f-(VT*DFs_q2));

d_DFdvj_dv_dV_s_c =  0.0;
d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_b_ci = ((DFs_q*d_DFs_q2_dV_b_ci-DFs_q2*d_DFs_q_dV_b_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_si_ci = ((DFs_q*d_DFs_q2_dV_si_ci-DFs_q2*d_DFs_q_dV_si_ci)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/vds_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vds_t)));

d_DFb_dV_s_c =  0.0;
d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vds_t))));
d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vds_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vds_t_dV_tnode_GND)/vds_t/vds_t))));
d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vds_t))));
d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vds_t))));
d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vds_t))));
d_DFb_dV_b_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_b_ci/vds_t))));
d_DFb_dV_si_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_si_ci/vds_t))));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-(model_.zs))*DFb));
double  deriv_exp_0_d0 = value_exp_0;

d_DFC_j1_dV_s_c =  0.0;
d_DFC_j1_dV_bi_ei = ((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei+cjs0_t*(deriv_exp_0_d0*((-(model_.zs))*d_DFb_dV_bi_ei))*DFdvj_dv);
d_DFC_j1_dV_bi_ci = ((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci+cjs0_t*(deriv_exp_0_d0*((-(model_.zs))*d_DFb_dV_bi_ci))*DFdvj_dv);
d_DFC_j1_dV_bp_ei = ((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei+cjs0_t*(deriv_exp_0_d0*((-(model_.zs))*d_DFb_dV_bp_ei))*DFdvj_dv);
d_DFC_j1_dV_bp_ci = ((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci+cjs0_t*(deriv_exp_0_d0*((-(model_.zs))*d_DFb_dV_bp_ci))*DFdvj_dv);
d_DFC_j1_dV_b_ci = ((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_b_ci+cjs0_t*(deriv_exp_0_d0*((-(model_.zs))*d_DFb_dV_b_ci))*DFdvj_dv);
d_DFC_j1_dV_si_ci = ((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_si_ci+cjs0_t*(deriv_exp_0_d0*((-(model_.zs))*d_DFb_dV_si_ci))*DFdvj_dv);
d_DFC_j1_dV_tnode_GND = ((cjs0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND+(cjs0_t*(deriv_exp_0_d0*((-(model_.zs))*d_DFb_dV_tnode_GND))+d_cjs0_t_dV_tnode_GND*value_exp_0)*DFdvj_dv);
DFC_j1 = ((cjs0_t*value_exp_0)*DFdvj_dv);
}
Cjs = (DFC_j1+((2.4*cjs0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-(model_.zs))));
double  deriv_exp_0_d0 = value_exp_0;

d_DFQ_j_dV_s_c =  0.0;
d_DFQ_j_dV_bi_ei = ((cjs0_t*vds_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ei*(1.0-(model_.zs)))))/(1.0-(model_.zs)));
d_DFQ_j_dV_bi_ci = ((cjs0_t*vds_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ci*(1.0-(model_.zs)))))/(1.0-(model_.zs)));
d_DFQ_j_dV_bp_ei = ((cjs0_t*vds_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ei*(1.0-(model_.zs)))))/(1.0-(model_.zs)));
d_DFQ_j_dV_bp_ci = ((cjs0_t*vds_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ci*(1.0-(model_.zs)))))/(1.0-(model_.zs)));
d_DFQ_j_dV_b_ci = ((cjs0_t*vds_t)*(-(deriv_exp_0_d0*(d_DFb_dV_b_ci*(1.0-(model_.zs)))))/(1.0-(model_.zs)));
d_DFQ_j_dV_si_ci = ((cjs0_t*vds_t)*(-(deriv_exp_0_d0*(d_DFb_dV_si_ci*(1.0-(model_.zs)))))/(1.0-(model_.zs)));
d_DFQ_j_dV_tnode_GND = (((cjs0_t*vds_t)*(-(deriv_exp_0_d0*(d_DFb_dV_tnode_GND*(1.0-(model_.zs)))))+(cjs0_t*d_vds_t_dV_tnode_GND+d_cjs0_t_dV_tnode_GND*vds_t)*(1.0-value_exp_0))/(1.0-(model_.zs)));
DFQ_j = (((cjs0_t*vds_t)*(1.0-value_exp_0))/(1.0-(model_.zs)));
}

d_Qjs_dV_bi_ei = (d_DFQ_j_dV_bi_ei+(2.4*cjs0_t)*(-d_DFv_j_dV_bi_ei));
d_Qjs_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+((2.4*cjs0_t)*(-d_DFv_j_dV_tnode_GND)+2.4*d_cjs0_t_dV_tnode_GND*(Vsici-DFv_j)));
d_Qjs_dV_bi_ci = (d_DFQ_j_dV_bi_ci+(2.4*cjs0_t)*(-d_DFv_j_dV_bi_ci));
d_Qjs_dV_bp_ei = (d_DFQ_j_dV_bp_ei+(2.4*cjs0_t)*(-d_DFv_j_dV_bp_ei));
d_Qjs_dV_bp_ci = (d_DFQ_j_dV_bp_ci+(2.4*cjs0_t)*(-d_DFv_j_dV_bp_ci));
d_Qjs_dV_b_ci = (d_DFQ_j_dV_b_ci+(2.4*cjs0_t)*(-d_DFv_j_dV_b_ci));
d_Qjs_dV_si_ci = (d_DFQ_j_dV_si_ci+(2.4*cjs0_t)*(d_Vsici_dV_si_ci-d_DFv_j_dV_si_ci));
Qjs = (DFQ_j+((2.4*cjs0_t)*(Vsici-DFv_j)));
}
else
{
Cjs = 0.0;

d_Qjs_dV_bp_ei = d_Qjs_dV_bi_ei = d_Qjs_dV_si_ci = d_Qjs_dV_b_ci = d_Qjs_dV_bp_ci = d_Qjs_dV_tnode_GND = d_Qjs_dV_bi_ci =  0.0;
Qjs = 0.0;
}
}
if (((model_.vdsp)>0))
{
if ((vptsp_t<1.0e2))
{
if ((cscp0_t>0.0))
{
Dz_r = ((model_.zsp)/4.0);

d_Dv_p_dV_tnode_GND = (d_vptsp_t_dV_tnode_GND-d_vdsp_t_dV_tnode_GND);
Dv_p = (vptsp_t-vdsp_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zsp)));

d_DV_f_dV_tnode_GND = d_vdsp_t_dV_tnode_GND*(1.0-value_exp_1);
DV_f = (vdsp_t*(1.0-value_exp_1));
}

d_DC_max_dV_tnode_GND = 2.4*d_cscp0_t_dV_tnode_GND;
DC_max = (2.4*cscp0_t);
{
double value_log_0 = log((vptsp_t/vdsp_t));
double value_exp_1 = exp(((Dz_r-(model_.zsp))*value_log_0));
double  deriv_log_0_d0 = (1.0/(vptsp_t/vdsp_t));
double  deriv_exp_1_d0 = value_exp_1;

d_DC_c_dV_tnode_GND = (cscp0_t*(deriv_exp_1_d0*((Dz_r-(model_.zsp))*(deriv_log_0_d0*(((vdsp_t*d_vptsp_t_dV_tnode_GND-vptsp_t*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t)))))+d_cscp0_t_dV_tnode_GND*value_exp_1);
DC_c = (cscp0_t*value_exp_1);
}

d_Dv_e_dV_si_ci = d_Dv_e_dV_b_ci = d_Dv_e_dV_bp_ci = d_Dv_e_dV_bi_ci =  0.0;
d_Dv_e_dV_s_c = ((-d_Vsc_dV_s_c)/VT);
d_Dv_e_dV_tnode_GND = ((VT*d_DV_f_dV_tnode_GND-(DV_f-Vsc)*d_VT_dV_tnode_GND)/VT/VT);
Dv_e = ((DV_f-Vsc)/VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_e_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_e_dV_bp_ci));
d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_e_dV_b_ci));
d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_e_dV_si_ci));
d_De_dV_s_c = (deriv_exp_0_d0*(d_Dv_e_dV_s_c));
De = value_exp_0;
}

d_De_1_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_1_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
d_De_1_dV_s_c = (((1.0+De)*d_De_dV_s_c-De*d_De_dV_s_c)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));

d_Dv_j1_dV_bi_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bi_ci)));
d_Dv_j1_dV_bp_ci = (-VT*(deriv_log_0_d0*(d_De_dV_bp_ci)));
d_Dv_j1_dV_b_ci = (-VT*(deriv_log_0_d0*(d_De_dV_b_ci)));
d_Dv_j1_dV_si_ci = (-VT*(deriv_log_0_d0*(d_De_dV_si_ci)));
d_Dv_j1_dV_s_c = (-VT*(deriv_log_0_d0*(d_De_dV_s_c)));
d_Dv_j1_dV_tnode_GND = (d_DV_f_dV_tnode_GND-(VT*(deriv_log_0_d0*(d_De_dV_tnode_GND))+d_VT_dV_tnode_GND*value_log_0));
Dv_j1 = (DV_f-(VT*value_log_0));
}
}
else
{

d_De_1_dV_s_c = d_De_1_dV_si_ci = d_De_1_dV_b_ci = d_De_1_dV_bp_ci = d_De_1_dV_tnode_GND = d_De_1_dV_bi_ci =  0.0;
De_1 = 1.0;

d_Dv_j1_dV_si_ci = d_Dv_j1_dV_b_ci = d_Dv_j1_dV_bp_ci = d_Dv_j1_dV_tnode_GND = d_Dv_j1_dV_bi_ci =  0.0;
d_Dv_j1_dV_s_c = d_Vsc_dV_s_c;
Dv_j1 = Vsc;
}

d_Da_dV_tnode_GND = (0.1*d_Dv_p_dV_tnode_GND+4.0*d_VT_dV_tnode_GND);
Da = ((0.1*Dv_p)+(4.0*VT));

d_Dv_r_dV_bi_ci = (d_Dv_j1_dV_bi_ci/Da);
d_Dv_r_dV_bp_ci = (d_Dv_j1_dV_bp_ci/Da);
d_Dv_r_dV_b_ci = (d_Dv_j1_dV_b_ci/Da);
d_Dv_r_dV_si_ci = (d_Dv_j1_dV_si_ci/Da);
d_Dv_r_dV_s_c = (d_Dv_j1_dV_s_c/Da);
d_Dv_r_dV_tnode_GND = ((Da*(d_Dv_p_dV_tnode_GND+d_Dv_j1_dV_tnode_GND)-(Dv_p+Dv_j1)*d_Da_dV_tnode_GND)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;

d_De_dV_bi_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bi_ci));
d_De_dV_tnode_GND = (deriv_exp_0_d0*(d_Dv_r_dV_tnode_GND));
d_De_dV_bp_ci = (deriv_exp_0_d0*(d_Dv_r_dV_bp_ci));
d_De_dV_b_ci = (deriv_exp_0_d0*(d_Dv_r_dV_b_ci));
d_De_dV_si_ci = (deriv_exp_0_d0*(d_Dv_r_dV_si_ci));
d_De_dV_s_c = (deriv_exp_0_d0*(d_Dv_r_dV_s_c));
De = value_exp_0;
}

d_De_2_dV_bi_ci = (((1.0+De)*d_De_dV_bi_ci-De*d_De_dV_bi_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_tnode_GND = (((1.0+De)*d_De_dV_tnode_GND-De*d_De_dV_tnode_GND)/(1.0+De)/(1.0+De));
d_De_2_dV_bp_ci = (((1.0+De)*d_De_dV_bp_ci-De*d_De_dV_bp_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_b_ci = (((1.0+De)*d_De_dV_b_ci-De*d_De_dV_b_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_si_ci = (((1.0+De)*d_De_dV_si_ci-De*d_De_dV_si_ci)/(1.0+De)/(1.0+De));
d_De_2_dV_s_c = (((1.0+De)*d_De_dV_s_c-De*d_De_dV_s_c)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;

d_Dv_j2_dV_bi_ci = Da*(deriv_log_0_d0*(d_De_dV_bi_ci));
d_Dv_j2_dV_bp_ci = Da*(deriv_log_0_d0*(d_De_dV_bp_ci));
d_Dv_j2_dV_b_ci = Da*(deriv_log_0_d0*(d_De_dV_b_ci));
d_Dv_j2_dV_si_ci = Da*(deriv_log_0_d0*(d_De_dV_si_ci));
d_Dv_j2_dV_s_c = Da*(deriv_log_0_d0*(d_De_dV_s_c));
d_Dv_j2_dV_tnode_GND = ((-d_Dv_p_dV_tnode_GND)+(Da*((deriv_log_0_d0*(d_De_dV_tnode_GND))-(deriv_exp_1_d0*(((Da*(-(d_Dv_p_dV_tnode_GND+d_DV_f_dV_tnode_GND))-(-(Dv_p+DV_f))*d_Da_dV_tnode_GND)/Da/Da))))+d_Da_dV_tnode_GND*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{

d_De_2_dV_s_c = d_De_2_dV_si_ci = d_De_2_dV_b_ci = d_De_2_dV_bp_ci = d_De_2_dV_tnode_GND = d_De_2_dV_bi_ci =  0.0;
De_2 = 1.0;

d_Dv_j2_dV_bi_ci = d_Dv_j1_dV_bi_ci;
d_Dv_j2_dV_tnode_GND = d_Dv_j1_dV_tnode_GND;
d_Dv_j2_dV_bp_ci = d_Dv_j1_dV_bp_ci;
d_Dv_j2_dV_b_ci = d_Dv_j1_dV_b_ci;
d_Dv_j2_dV_si_ci = d_Dv_j1_dV_si_ci;
d_Dv_j2_dV_s_c = d_Dv_j1_dV_s_c;
Dv_j2 = Dv_j1;
}

d_Dv_j4_dV_bi_ci = (-d_Dv_j1_dV_bi_ci);
d_Dv_j4_dV_tnode_GND = (-d_Dv_j1_dV_tnode_GND);
d_Dv_j4_dV_bp_ci = (-d_Dv_j1_dV_bp_ci);
d_Dv_j4_dV_b_ci = (-d_Dv_j1_dV_b_ci);
d_Dv_j4_dV_si_ci = (-d_Dv_j1_dV_si_ci);
d_Dv_j4_dV_s_c = (d_Vsc_dV_s_c-d_Dv_j1_dV_s_c);
Dv_j4 = (Vsc-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/vdsp_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/vdsp_t)));

d_DCln1_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bi_ci/vdsp_t))));
d_DCln1_dV_tnode_GND = (deriv_log_0_d0*((-((vdsp_t*d_Dv_j1_dV_tnode_GND-Dv_j1*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t))));
d_DCln1_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_bp_ci/vdsp_t))));
d_DCln1_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_b_ci/vdsp_t))));
d_DCln1_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j1_dV_si_ci/vdsp_t))));
d_DCln1_dV_s_c = (deriv_log_0_d0*((-(d_Dv_j1_dV_s_c/vdsp_t))));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/vdsp_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/vdsp_t)));

d_DCln2_dV_bi_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bi_ci/vdsp_t))));
d_DCln2_dV_tnode_GND = (deriv_log_0_d0*((-((vdsp_t*d_Dv_j2_dV_tnode_GND-Dv_j2*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t))));
d_DCln2_dV_bp_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_bp_ci/vdsp_t))));
d_DCln2_dV_b_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_b_ci/vdsp_t))));
d_DCln2_dV_si_ci = (deriv_log_0_d0*((-(d_Dv_j2_dV_si_ci/vdsp_t))));
d_DCln2_dV_s_c = (deriv_log_0_d0*((-(d_Dv_j2_dV_s_c/vdsp_t))));
DCln2 = value_log_0;
}
Dz1 = (1.0-(model_.zsp));
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-(model_.zsp))));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j1_dV_bi_ci = (((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_bi_ci+((cscp0_t*value_exp_0)*d_De_1_dV_bi_ci+cscp0_t*(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*(-(model_.zsp))))*De_1)*De_2);
d_DC_j1_dV_bp_ci = (((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_bp_ci+((cscp0_t*value_exp_0)*d_De_1_dV_bp_ci+cscp0_t*(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*(-(model_.zsp))))*De_1)*De_2);
d_DC_j1_dV_b_ci = (((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_b_ci+((cscp0_t*value_exp_0)*d_De_1_dV_b_ci+cscp0_t*(deriv_exp_0_d0*(d_DCln2_dV_b_ci*(-(model_.zsp))))*De_1)*De_2);
d_DC_j1_dV_si_ci = (((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_si_ci+((cscp0_t*value_exp_0)*d_De_1_dV_si_ci+cscp0_t*(deriv_exp_0_d0*(d_DCln2_dV_si_ci*(-(model_.zsp))))*De_1)*De_2);
d_DC_j1_dV_s_c = (((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_s_c+((cscp0_t*value_exp_0)*d_De_1_dV_s_c+cscp0_t*(deriv_exp_0_d0*(d_DCln2_dV_s_c*(-(model_.zsp))))*De_1)*De_2);
d_DC_j1_dV_tnode_GND = (((cscp0_t*value_exp_0)*De_1)*d_De_2_dV_tnode_GND+((cscp0_t*value_exp_0)*d_De_1_dV_tnode_GND+(cscp0_t*(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*(-(model_.zsp))))+d_cscp0_t_dV_tnode_GND*value_exp_0)*De_1)*De_2);
DC_j1 = (((cscp0_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;

d_DC_j2_dV_bi_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bi_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_bp_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_bp_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_b_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_b_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_b_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_si_ci = ((DC_c*value_exp_0)*(-d_De_2_dV_si_ci)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_si_ci*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_s_c = ((DC_c*value_exp_0)*(-d_De_2_dV_s_c)+DC_c*(deriv_exp_0_d0*(d_DCln1_dV_s_c*(-Dz_r)))*(1.0-De_2));
d_DC_j2_dV_tnode_GND = ((DC_c*value_exp_0)*(-d_De_2_dV_tnode_GND)+(DC_c*(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*(-Dz_r)))+d_DC_c_dV_tnode_GND*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}

d_DC_j3_dV_bi_ci = DC_max*(-d_De_1_dV_bi_ci);
d_DC_j3_dV_bp_ci = DC_max*(-d_De_1_dV_bp_ci);
d_DC_j3_dV_b_ci = DC_max*(-d_De_1_dV_b_ci);
d_DC_j3_dV_si_ci = DC_max*(-d_De_1_dV_si_ci);
d_DC_j3_dV_s_c = DC_max*(-d_De_1_dV_s_c);
d_DC_j3_dV_tnode_GND = (DC_max*(-d_De_1_dV_tnode_GND)+d_DC_max_dV_tnode_GND*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
Cscp = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j1_dV_bi_ci = (cscp0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dz1)))/Dz1);
d_DQ_j1_dV_bp_ci = (cscp0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dz1)))/Dz1);
d_DQ_j1_dV_b_ci = (cscp0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_b_ci*Dz1)))/Dz1);
d_DQ_j1_dV_si_ci = (cscp0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_si_ci*Dz1)))/Dz1);
d_DQ_j1_dV_s_c = (cscp0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_s_c*Dz1)))/Dz1);
d_DQ_j1_dV_tnode_GND = ((cscp0_t*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dz1)))+d_cscp0_t_dV_tnode_GND*(1.0-value_exp_0))/Dz1);
DQ_j1 = ((cscp0_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j2_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_b_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_b_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_si_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_si_ci*Dzr1)))/Dzr1);
d_DQ_j2_dV_s_c = (DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_s_c*Dzr1)))/Dzr1);
d_DQ_j2_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln1_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;

d_DQ_j3_dV_bi_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bi_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_bp_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_bp_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_b_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_b_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_si_ci = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_si_ci*Dzr1)))/Dzr1);
d_DQ_j3_dV_s_c = (DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_s_c*Dzr1)))/Dzr1);
d_DQ_j3_dV_tnode_GND = ((DC_c*(-(deriv_exp_0_d0*(d_DCln2_dV_tnode_GND*Dzr1)))+d_DC_c_dV_tnode_GND*(1.0-value_exp_0))/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}

d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei =  0.0;
d_Qscp_dV_bi_ci = (((d_DQ_j1_dV_bi_ci+d_DQ_j2_dV_bi_ci)-d_DQ_j3_dV_bi_ci)*vdsp_t+DC_max*d_Dv_j4_dV_bi_ci);
d_Qscp_dV_tnode_GND = ((((DQ_j1+DQ_j2)-DQ_j3)*d_vdsp_t_dV_tnode_GND+((d_DQ_j1_dV_tnode_GND+d_DQ_j2_dV_tnode_GND)-d_DQ_j3_dV_tnode_GND)*vdsp_t)+(DC_max*d_Dv_j4_dV_tnode_GND+d_DC_max_dV_tnode_GND*Dv_j4));
d_Qscp_dV_bp_ci = (((d_DQ_j1_dV_bp_ci+d_DQ_j2_dV_bp_ci)-d_DQ_j3_dV_bp_ci)*vdsp_t+DC_max*d_Dv_j4_dV_bp_ci);
d_Qscp_dV_b_ci = (((d_DQ_j1_dV_b_ci+d_DQ_j2_dV_b_ci)-d_DQ_j3_dV_b_ci)*vdsp_t+DC_max*d_Dv_j4_dV_b_ci);
d_Qscp_dV_si_ci = (((d_DQ_j1_dV_si_ci+d_DQ_j2_dV_si_ci)-d_DQ_j3_dV_si_ci)*vdsp_t+DC_max*d_Dv_j4_dV_si_ci);
d_Qscp_dV_s_c = (((d_DQ_j1_dV_s_c+d_DQ_j2_dV_s_c)-d_DQ_j3_dV_s_c)*vdsp_t+DC_max*d_Dv_j4_dV_s_c);
Qscp = ((((DQ_j1+DQ_j2)-DQ_j3)*vdsp_t)+(DC_max*Dv_j4));
}
else
{
Cscp = 0.0;

d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei = d_Qscp_dV_s_c = d_Qscp_dV_si_ci = d_Qscp_dV_b_ci = d_Qscp_dV_bp_ci = d_Qscp_dV_tnode_GND = d_Qscp_dV_bi_ci =  0.0;
Qscp = 0.0;
}
}
else
{
if ((cscp0_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/(model_.zsp)));

d_DFV_f_dV_tnode_GND = d_vdsp_t_dV_tnode_GND*(1.0-value_exp_1);
DFV_f = (vdsp_t*(1.0-value_exp_1));
}

d_DFv_e_dV_si_ci = d_DFv_e_dV_b_ci = d_DFv_e_dV_bp_ci = d_DFv_e_dV_bp_ei = d_DFv_e_dV_bi_ci = d_DFv_e_dV_bi_ei =  0.0;
d_DFv_e_dV_s_c = ((-d_Vsc_dV_s_c)/VT);
d_DFv_e_dV_tnode_GND = ((VT*d_DFV_f_dV_tnode_GND-(DFV_f-Vsc)*d_VT_dV_tnode_GND)/VT/VT);
DFv_e = ((DFV_f-Vsc)/VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_DFs_q_dV_bi_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ei+d_DFv_e_dV_bi_ei*DFv_e)));
d_DFs_q_dV_tnode_GND = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_tnode_GND+d_DFv_e_dV_tnode_GND*DFv_e)));
d_DFs_q_dV_bi_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bi_ci+d_DFv_e_dV_bi_ci*DFv_e)));
d_DFs_q_dV_bp_ei = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ei+d_DFv_e_dV_bp_ei*DFv_e)));
d_DFs_q_dV_bp_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_bp_ci+d_DFv_e_dV_bp_ci*DFv_e)));
d_DFs_q_dV_b_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_b_ci+d_DFv_e_dV_b_ci*DFv_e)));
d_DFs_q_dV_si_ci = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_si_ci+d_DFv_e_dV_si_ci*DFv_e)));
d_DFs_q_dV_s_c = (deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dV_s_c+d_DFv_e_dV_s_c*DFv_e)));
DFs_q = value_sqrt_0;
}

d_DFs_q2_dV_bi_ei = (d_DFv_e_dV_bi_ei+d_DFs_q_dV_bi_ei)*0.5;
d_DFs_q2_dV_tnode_GND = (d_DFv_e_dV_tnode_GND+d_DFs_q_dV_tnode_GND)*0.5;
d_DFs_q2_dV_bi_ci = (d_DFv_e_dV_bi_ci+d_DFs_q_dV_bi_ci)*0.5;
d_DFs_q2_dV_bp_ei = (d_DFv_e_dV_bp_ei+d_DFs_q_dV_bp_ei)*0.5;
d_DFs_q2_dV_bp_ci = (d_DFv_e_dV_bp_ci+d_DFs_q_dV_bp_ci)*0.5;
d_DFs_q2_dV_b_ci = (d_DFv_e_dV_b_ci+d_DFs_q_dV_b_ci)*0.5;
d_DFs_q2_dV_si_ci = (d_DFv_e_dV_si_ci+d_DFs_q_dV_si_ci)*0.5;
d_DFs_q2_dV_s_c = (d_DFv_e_dV_s_c+d_DFs_q_dV_s_c)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);

d_DFv_j_dV_bi_ei = (-VT*d_DFs_q2_dV_bi_ei);
d_DFv_j_dV_bi_ci = (-VT*d_DFs_q2_dV_bi_ci);
d_DFv_j_dV_bp_ei = (-VT*d_DFs_q2_dV_bp_ei);
d_DFv_j_dV_bp_ci = (-VT*d_DFs_q2_dV_bp_ci);
d_DFv_j_dV_b_ci = (-VT*d_DFs_q2_dV_b_ci);
d_DFv_j_dV_si_ci = (-VT*d_DFs_q2_dV_si_ci);
d_DFv_j_dV_s_c = (-VT*d_DFs_q2_dV_s_c);
d_DFv_j_dV_tnode_GND = (d_DFV_f_dV_tnode_GND-(VT*d_DFs_q2_dV_tnode_GND+d_VT_dV_tnode_GND*DFs_q2));
DFv_j = (DFV_f-(VT*DFs_q2));

d_DFdvj_dv_dV_bi_ei = ((DFs_q*d_DFs_q2_dV_bi_ei-DFs_q2*d_DFs_q_dV_bi_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_tnode_GND = ((DFs_q*d_DFs_q2_dV_tnode_GND-DFs_q2*d_DFs_q_dV_tnode_GND)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bi_ci = ((DFs_q*d_DFs_q2_dV_bi_ci-DFs_q2*d_DFs_q_dV_bi_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ei = ((DFs_q*d_DFs_q2_dV_bp_ei-DFs_q2*d_DFs_q_dV_bp_ei)/DFs_q/DFs_q);
d_DFdvj_dv_dV_bp_ci = ((DFs_q*d_DFs_q2_dV_bp_ci-DFs_q2*d_DFs_q_dV_bp_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_b_ci = ((DFs_q*d_DFs_q2_dV_b_ci-DFs_q2*d_DFs_q_dV_b_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_si_ci = ((DFs_q*d_DFs_q2_dV_si_ci-DFs_q2*d_DFs_q_dV_si_ci)/DFs_q/DFs_q);
d_DFdvj_dv_dV_s_c = ((DFs_q*d_DFs_q2_dV_s_c-DFs_q2*d_DFs_q_dV_s_c)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/vdsp_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/vdsp_t)));

d_DFb_dV_bi_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ei/vdsp_t))));
d_DFb_dV_tnode_GND = (deriv_log_0_d0*((-((vdsp_t*d_DFv_j_dV_tnode_GND-DFv_j*d_vdsp_t_dV_tnode_GND)/vdsp_t/vdsp_t))));
d_DFb_dV_bi_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bi_ci/vdsp_t))));
d_DFb_dV_bp_ei = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ei/vdsp_t))));
d_DFb_dV_bp_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_bp_ci/vdsp_t))));
d_DFb_dV_b_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_b_ci/vdsp_t))));
d_DFb_dV_si_ci = (deriv_log_0_d0*((-(d_DFv_j_dV_si_ci/vdsp_t))));
d_DFb_dV_s_c = (deriv_log_0_d0*((-(d_DFv_j_dV_s_c/vdsp_t))));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-(model_.zsp))*DFb));
double  deriv_exp_0_d0 = value_exp_0;

d_DFC_j1_dV_bi_ei = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ei+cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_bi_ei))*DFdvj_dv);
d_DFC_j1_dV_bi_ci = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bi_ci+cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_bi_ci))*DFdvj_dv);
d_DFC_j1_dV_bp_ei = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ei+cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_bp_ei))*DFdvj_dv);
d_DFC_j1_dV_bp_ci = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_bp_ci+cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_bp_ci))*DFdvj_dv);
d_DFC_j1_dV_b_ci = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_b_ci+cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_b_ci))*DFdvj_dv);
d_DFC_j1_dV_si_ci = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_si_ci+cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_si_ci))*DFdvj_dv);
d_DFC_j1_dV_s_c = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_s_c+cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_s_c))*DFdvj_dv);
d_DFC_j1_dV_tnode_GND = ((cscp0_t*value_exp_0)*d_DFdvj_dv_dV_tnode_GND+(cscp0_t*(deriv_exp_0_d0*((-(model_.zsp))*d_DFb_dV_tnode_GND))+d_cscp0_t_dV_tnode_GND*value_exp_0)*DFdvj_dv);
DFC_j1 = ((cscp0_t*value_exp_0)*DFdvj_dv);
}
Cscp = (DFC_j1+((2.4*cscp0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-(model_.zsp))));
double  deriv_exp_0_d0 = value_exp_0;

d_DFQ_j_dV_bi_ei = ((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ei*(1.0-(model_.zsp)))))/(1.0-(model_.zsp)));
d_DFQ_j_dV_bi_ci = ((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bi_ci*(1.0-(model_.zsp)))))/(1.0-(model_.zsp)));
d_DFQ_j_dV_bp_ei = ((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ei*(1.0-(model_.zsp)))))/(1.0-(model_.zsp)));
d_DFQ_j_dV_bp_ci = ((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_bp_ci*(1.0-(model_.zsp)))))/(1.0-(model_.zsp)));
d_DFQ_j_dV_b_ci = ((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_b_ci*(1.0-(model_.zsp)))))/(1.0-(model_.zsp)));
d_DFQ_j_dV_si_ci = ((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_si_ci*(1.0-(model_.zsp)))))/(1.0-(model_.zsp)));
d_DFQ_j_dV_s_c = ((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_s_c*(1.0-(model_.zsp)))))/(1.0-(model_.zsp)));
d_DFQ_j_dV_tnode_GND = (((cscp0_t*vdsp_t)*(-(deriv_exp_0_d0*(d_DFb_dV_tnode_GND*(1.0-(model_.zsp)))))+(cscp0_t*d_vdsp_t_dV_tnode_GND+d_cscp0_t_dV_tnode_GND*vdsp_t)*(1.0-value_exp_0))/(1.0-(model_.zsp)));
DFQ_j = (((cscp0_t*vdsp_t)*(1.0-value_exp_0))/(1.0-(model_.zsp)));
}

d_Qscp_dV_bi_ei = (d_DFQ_j_dV_bi_ei+(2.4*cscp0_t)*(-d_DFv_j_dV_bi_ei));
d_Qscp_dV_tnode_GND = (d_DFQ_j_dV_tnode_GND+((2.4*cscp0_t)*(-d_DFv_j_dV_tnode_GND)+2.4*d_cscp0_t_dV_tnode_GND*(Vsc-DFv_j)));
d_Qscp_dV_bi_ci = (d_DFQ_j_dV_bi_ci+(2.4*cscp0_t)*(-d_DFv_j_dV_bi_ci));
d_Qscp_dV_bp_ei = (d_DFQ_j_dV_bp_ei+(2.4*cscp0_t)*(-d_DFv_j_dV_bp_ei));
d_Qscp_dV_bp_ci = (d_DFQ_j_dV_bp_ci+(2.4*cscp0_t)*(-d_DFv_j_dV_bp_ci));
d_Qscp_dV_b_ci = (d_DFQ_j_dV_b_ci+(2.4*cscp0_t)*(-d_DFv_j_dV_b_ci));
d_Qscp_dV_si_ci = (d_DFQ_j_dV_si_ci+(2.4*cscp0_t)*(-d_DFv_j_dV_si_ci));
d_Qscp_dV_s_c = (d_DFQ_j_dV_s_c+(2.4*cscp0_t)*(d_Vsc_dV_s_c-d_DFv_j_dV_s_c));
Qscp = (DFQ_j+((2.4*cscp0_t)*(Vsc-DFv_j)));
}
else
{
Cscp = 0.0;

d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei = d_Qscp_dV_s_c = d_Qscp_dV_si_ci = d_Qscp_dV_b_ci = d_Qscp_dV_bp_ci = d_Qscp_dV_tnode_GND = d_Qscp_dV_bi_ci =  0.0;
Qscp = 0.0;
}
}
}
else
{
Cscp = (model_.cscp0);

d_Qscp_dV_bp_ei = d_Qscp_dV_bi_ei = d_Qscp_dV_si_ci = d_Qscp_dV_b_ci = d_Qscp_dV_bp_ci = d_Qscp_dV_tnode_GND = d_Qscp_dV_bi_ci =  0.0;
d_Qscp_dV_s_c = (model_.cscp0)*d_Vsc_dV_s_c;
Qscp = ((model_.cscp0)*Vsc);
}
if (((model_.itss)>0.0))
//Begin block Sub_Transfer
{

d_HSUM_dV_tnode_GND = (model_.msf)*d_VT_dV_tnode_GND;
HSUM = ((model_.msf)*VT);
{
double value_limexp_0 = limexp((Vbpci/HSUM));
double  deriv_limexp_0_d0 = ((((Vbpci/HSUM))<80)?(value_limexp_0):exp(80.0));

d_HSa_dV_tnode_GND = (deriv_limexp_0_d0*((-Vbpci*d_HSUM_dV_tnode_GND/HSUM/HSUM)));
d_HSa_dV_bp_ci = (deriv_limexp_0_d0*((d_Vbpci_dV_bp_ci/HSUM)));
HSa = value_limexp_0;
}
{
double value_limexp_0 = limexp((Vsici/HSUM));
double  deriv_limexp_0_d0 = ((((Vsici/HSUM))<80)?(value_limexp_0):exp(80.0));

d_HSb_dV_tnode_GND = (deriv_limexp_0_d0*((-Vsici*d_HSUM_dV_tnode_GND/HSUM/HSUM)));
d_HSb_dV_si_ci = (deriv_limexp_0_d0*((d_Vsici_dV_si_ci/HSUM)));
HSb = value_limexp_0;
}

d_HSI_Tsu_dV_si_ci = itss_t*(-d_HSb_dV_si_ci);
d_HSI_Tsu_dV_bp_ci = itss_t*d_HSa_dV_bp_ci;
d_HSI_Tsu_dV_tnode_GND = (itss_t*(d_HSa_dV_tnode_GND-d_HSb_dV_tnode_GND)+d_itss_t_dV_tnode_GND*(HSa-HSb));
HSI_Tsu = (itss_t*(HSa-HSb));
if (((model_.tsf)>0.0))
{

d_Qdsu_dV_bp_ci = (tsf_t*itss_t)*d_HSa_dV_bp_ci;
d_Qdsu_dV_tnode_GND = ((tsf_t*itss_t)*d_HSa_dV_tnode_GND+(tsf_t*d_itss_t_dV_tnode_GND+d_tsf_t_dV_tnode_GND*itss_t)*HSa);
Qdsu = ((tsf_t*itss_t)*HSa);
}
else
{

d_Qdsu_dV_tnode_GND = d_Qdsu_dV_bp_ci =  0.0;
Qdsu = 0.0;
}
}
// End block Sub_Transfer
else
{

d_HSI_Tsu_dV_tnode_GND = d_HSI_Tsu_dV_bp_ci = d_HSI_Tsu_dV_si_ci =  0.0;
HSI_Tsu = 0.0;

d_Qdsu_dV_tnode_GND = d_Qdsu_dV_bp_ci =  0.0;
Qdsu = 0.0;
}
if ((ibei>0.0))
{

d_betadc_dV_bi_ci = (d_it_dV_bi_ci/ibei);
d_betadc_dV_bi_ei = ((ibei*d_it_dV_bi_ei-it*d_ibei_dV_bi_ei)/ibei/ibei);
d_betadc_dV_tnode_GND = ((ibei*d_it_dV_tnode_GND-it*d_ibei_dV_tnode_GND)/ibei/ibei);
betadc = (it/ibei);
}
else
{

d_betadc_dV_tnode_GND = d_betadc_dV_bi_ei = d_betadc_dV_bi_ci =  0.0;
betadc = 0.0;
}

d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei =  0.0;
d_DIOY_dV_tnode_GND = (-Vsici*(model_.msc)*d_VT_dV_tnode_GND/((model_.msc)*VT)/((model_.msc)*VT));
d_DIOY_dV_si_ci = (d_Vsici_dV_si_ci/((model_.msc)*VT));
DIOY = (Vsici/((model_.msc)*VT));
if (((model_.iscs)>0.0))
{
if ((DIOY>80.0))
{

d_le_dV_tnode_GND = d_DIOY_dV_tnode_GND;
d_le_dV_bi_ei = d_DIOY_dV_bi_ei;
d_le_dV_bi_ci = d_DIOY_dV_bi_ci;
d_le_dV_bp_ei = d_DIOY_dV_bp_ei;
d_le_dV_bp_ci = d_DIOY_dV_bp_ci;
d_le_dV_si_ci = d_DIOY_dV_si_ci;
le = (1+(DIOY-80.0));

d_DIOY_dV_si_ci = d_DIOY_dV_bp_ci = d_DIOY_dV_bp_ei = d_DIOY_dV_bi_ci = d_DIOY_dV_bi_ei = d_DIOY_dV_tnode_GND =  0.0;
DIOY = 80.0;
}
else
{

d_le_dV_si_ci = d_le_dV_bp_ci = d_le_dV_bp_ei = d_le_dV_bi_ci = d_le_dV_bi_ei = d_le_dV_tnode_GND =  0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));

d_le_dV_tnode_GND = (le*(deriv_limexp_0_d0*(d_DIOY_dV_tnode_GND))+d_le_dV_tnode_GND*value_limexp_0);
d_le_dV_bi_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ei))+d_le_dV_bi_ei*value_limexp_0);
d_le_dV_bi_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bi_ci))+d_le_dV_bi_ci*value_limexp_0);
d_le_dV_bp_ei = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ei))+d_le_dV_bp_ei*value_limexp_0);
d_le_dV_bp_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_bp_ci))+d_le_dV_bp_ci*value_limexp_0);
d_le_dV_si_ci = (le*(deriv_limexp_0_d0*(d_DIOY_dV_si_ci))+d_le_dV_si_ci*value_limexp_0);
le = (le*value_limexp_0);
}

d_ijsc_dV_bi_ei = iscs_t*d_le_dV_bi_ei;
d_ijsc_dV_bi_ci = iscs_t*d_le_dV_bi_ci;
d_ijsc_dV_bp_ei = iscs_t*d_le_dV_bp_ei;
d_ijsc_dV_bp_ci = iscs_t*d_le_dV_bp_ci;
d_ijsc_dV_si_ci = iscs_t*d_le_dV_si_ci;
d_ijsc_dV_tnode_GND = (iscs_t*d_le_dV_tnode_GND+d_iscs_t_dV_tnode_GND*(le-1.0));
ijsc = (iscs_t*(le-1.0));
if ((DIOY<=(-14.0)))
{

d_ijsc_dV_si_ci = d_ijsc_dV_bp_ci = d_ijsc_dV_bp_ei = d_ijsc_dV_bi_ci = d_ijsc_dV_bi_ei =  0.0;
d_ijsc_dV_tnode_GND = (-d_iscs_t_dV_tnode_GND);
ijsc = (-iscs_t);
}
}
else
{

d_ijsc_dV_tnode_GND = d_ijsc_dV_si_ci = d_ijsc_dV_bp_ci = d_ijsc_dV_bp_ei = d_ijsc_dV_bi_ci = d_ijsc_dV_bi_ei =  0.0;
ijsc = 0.0;
}
if ((((model_.flsh)==1)&&((model_.rth)>=0.001)))
{

d_pterm_dV_b_bp = d_pterm_dV_ci_c = d_pterm_dV_ei_e = d_pterm_dV_bp_bi = d_pterm_dV_bp_ei = d_pterm_dV_bp_ci = d_pterm_dV_si_ci =  0.0;
d_pterm_dV_tnode_GND = (Vciei*d_it_dV_tnode_GND+((vdci_t-Vbici)*d_iavl_dV_tnode_GND+d_vdci_t_dV_tnode_GND*iavl));
d_pterm_dV_bi_ci = ((Vciei*d_it_dV_bi_ci+d_Vciei_dV_bi_ci*it)+((vdci_t-Vbici)*d_iavl_dV_bi_ci+(-d_Vbici_dV_bi_ci)*iavl));
d_pterm_dV_bi_ei = ((Vciei*d_it_dV_bi_ei+d_Vciei_dV_bi_ei*it)+(vdci_t-Vbici)*d_iavl_dV_bi_ei);
pterm = ((Vciei*it)+((vdci_t-Vbici)*iavl));
}
else
{
if ((((model_.flsh)==2)&&((model_.rth)>=0.001)))
{

d_pterm_dV_b_bp = d_pterm_dV_ci_c = d_pterm_dV_ei_e = d_pterm_dV_bp_bi =  0.0;
d_pterm_dV_si_ci = (ijsc*d_Vsici_dV_si_ci+d_ijsc_dV_si_ci*Vsici);
d_pterm_dV_bp_ci = ((ijbcx*d_Vbpci_dV_bp_ci+d_ijbcx_dV_bp_ci*Vbpci)+d_ijsc_dV_bp_ci*Vsici);
d_pterm_dV_bp_ei = (((ibep*d_Vbpei_dV_bp_ei+d_ibep_dV_bp_ei*Vbpei)+d_ijbcx_dV_bp_ei*Vbpci)+d_ijsc_dV_bp_ei*Vsici);
d_pterm_dV_tnode_GND = ((((((Vciei*d_it_dV_tnode_GND+((vdci_t-Vbici)*d_iavl_dV_tnode_GND+d_vdci_t_dV_tnode_GND*iavl))+d_ibei_dV_tnode_GND*Vbiei)+d_ibci_dV_tnode_GND*Vbici)+d_ibep_dV_tnode_GND*Vbpei)+d_ijbcx_dV_tnode_GND*Vbpci)+d_ijsc_dV_tnode_GND*Vsici);
d_pterm_dV_bi_ci = ((((((Vciei*d_it_dV_bi_ci+d_Vciei_dV_bi_ci*it)+((vdci_t-Vbici)*d_iavl_dV_bi_ci+(-d_Vbici_dV_bi_ci)*iavl))+(ibci*d_Vbici_dV_bi_ci+d_ibci_dV_bi_ci*Vbici))+d_ibep_dV_bi_ci*Vbpei)+d_ijbcx_dV_bi_ci*Vbpci)+d_ijsc_dV_bi_ci*Vsici);
d_pterm_dV_bi_ei = (((((((Vciei*d_it_dV_bi_ei+d_Vciei_dV_bi_ei*it)+(vdci_t-Vbici)*d_iavl_dV_bi_ei)+(ibei*d_Vbiei_dV_bi_ei+d_ibei_dV_bi_ei*Vbiei))+d_ibci_dV_bi_ei*Vbici)+d_ibep_dV_bi_ei*Vbpei)+d_ijbcx_dV_bi_ei*Vbpci)+d_ijsc_dV_bi_ei*Vsici);
pterm = (((((((Vciei*it)+((vdci_t-Vbici)*iavl))+(ibei*Vbiei))+(ibci*Vbici))+(ibep*Vbpei))+(ijbcx*Vbpci))+(ijsc*Vsici));
if ((rbi>=0.001))
{

d_pterm_dV_b_bp = d_pterm_dV_ci_c = d_pterm_dV_ei_e =  0.0;
d_pterm_dV_bp_bi = (d_pterm_dV_bp_bi+(((probeVars[admsProbeID_V_bp_bi])*d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]+d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]*(probeVars[admsProbeID_V_bp_bi]))/rbi));
d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))*d_rbi_dV_tnode_GND/rbi/rbi));
d_pterm_dV_bi_ci = (d_pterm_dV_bi_ci+(-((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))*d_rbi_dV_bi_ci/rbi/rbi));
d_pterm_dV_bi_ei = (d_pterm_dV_bi_ei+(-((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))*d_rbi_dV_bi_ei/rbi/rbi));
pterm = (pterm+(((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))/rbi));
}
if ((re_t>=0.001))
{

d_pterm_dV_b_bp = d_pterm_dV_ci_c =  0.0;
d_pterm_dV_ei_e = (d_pterm_dV_ei_e+(((probeVars[admsProbeID_V_ei_e])*d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]+d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]*(probeVars[admsProbeID_V_ei_e]))/re_t));
d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_ei_e])*(probeVars[admsProbeID_V_ei_e]))*d_re_t_dV_tnode_GND/re_t/re_t));
pterm = (pterm+(((probeVars[admsProbeID_V_ei_e])*(probeVars[admsProbeID_V_ei_e]))/re_t));
}
if ((rcx_t>=0.001))
{

d_pterm_dV_b_bp =  0.0;
d_pterm_dV_ci_c = (d_pterm_dV_ci_c+(((probeVars[admsProbeID_V_ci_c])*d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c]+d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c]*(probeVars[admsProbeID_V_ci_c]))/rcx_t));
d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_ci_c])*(probeVars[admsProbeID_V_ci_c]))*d_rcx_t_dV_tnode_GND/rcx_t/rcx_t));
pterm = (pterm+(((probeVars[admsProbeID_V_ci_c])*(probeVars[admsProbeID_V_ci_c]))/rcx_t));
}
if ((rbx_t>=0.001))
{

d_pterm_dV_b_bp = (d_pterm_dV_b_bp+(((probeVars[admsProbeID_V_b_bp])*d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp]+d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp]*(probeVars[admsProbeID_V_b_bp]))/rbx_t));
d_pterm_dV_tnode_GND = (d_pterm_dV_tnode_GND+(-((probeVars[admsProbeID_V_b_bp])*(probeVars[admsProbeID_V_b_bp]))*d_rbx_t_dV_tnode_GND/rbx_t/rbx_t));
pterm = (pterm+(((probeVars[admsProbeID_V_b_bp])*(probeVars[admsProbeID_V_b_bp]))/rbx_t));
}
}
}

d_Itxf_dV_xf2_GND =  0.0;
d_Itxf_dV_bi_ci = d_itf_dV_bi_ci;
d_Itxf_dV_bi_ei = d_itf_dV_bi_ei;
d_Itxf_dV_tnode_GND = d_itf_dV_tnode_GND;
Itxf = itf;

d_Qdeix_dV_xf_GND =  0.0;
d_Qdeix_dV_bi_ei = d_Qdei_dV_bi_ei;
d_Qdeix_dV_bi_ci = d_Qdei_dV_bi_ci;
d_Qdeix_dV_tnode_GND = d_Qdei_dV_tnode_GND;
Qdeix = Qdei;
if (((((((model_.flnqs)!=0)||((model_.flcomp)==0.0))||((model_.flcomp)==2.1))&&(Tf!=0))&&(((model_.alit)>0)||((model_.alqf)>0))))
{

d_Vxf1_dV_xf1_GND = d_probeVars[admsProbeID_V_xf1_GND][admsProbeID_V_xf1_GND];
Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);

d_Vxf2_dV_xf2_GND = d_probeVars[admsProbeID_V_xf2_GND][admsProbeID_V_xf2_GND];
Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);

d_Ixf1_dV_xf1_GND =  0.0;
d_Ixf1_dV_bi_ci = ((Tf*(-d_itf_dV_bi_ci)-(Vxf2-itf)*d_Tf_dV_bi_ci)/Tf/Tf)*(model_.t0);
d_Ixf1_dV_bi_ei = ((Tf*(-d_itf_dV_bi_ei)-(Vxf2-itf)*d_Tf_dV_bi_ei)/Tf/Tf)*(model_.t0);
d_Ixf1_dV_tnode_GND = ((Tf*(-d_itf_dV_tnode_GND)-(Vxf2-itf)*d_Tf_dV_tnode_GND)/Tf/Tf)*(model_.t0);
d_Ixf1_dV_xf2_GND = (d_Vxf2_dV_xf2_GND/Tf)*(model_.t0);
Ixf1 = (((Vxf2-itf)/Tf)*(model_.t0));

d_Ixf2_dV_bi_ci = (-(Vxf2-Vxf1)*d_Tf_dV_bi_ci/Tf/Tf)*(model_.t0);
d_Ixf2_dV_tnode_GND = (-(Vxf2-Vxf1)*d_Tf_dV_tnode_GND/Tf/Tf)*(model_.t0);
d_Ixf2_dV_bi_ei = (-(Vxf2-Vxf1)*d_Tf_dV_bi_ei/Tf/Tf)*(model_.t0);
d_Ixf2_dV_xf1_GND = ((-d_Vxf1_dV_xf1_GND)/Tf)*(model_.t0);
d_Ixf2_dV_xf2_GND = (d_Vxf2_dV_xf2_GND/Tf)*(model_.t0);
Ixf2 = (((Vxf2-Vxf1)/Tf)*(model_.t0));

d_Qxf1_dV_xf1_GND = (model_.alit)*d_Vxf1_dV_xf1_GND*(model_.t0);
Qxf1 = (((model_.alit)*Vxf1)*(model_.t0));

d_Qxf2_dV_xf2_GND = ((model_.alit)*d_Vxf2_dV_xf2_GND/3)*(model_.t0);
Qxf2 = ((((model_.alit)*Vxf2)/3)*(model_.t0));

d_Itxf_dV_tnode_GND = d_Itxf_dV_bi_ei = d_Itxf_dV_bi_ci =  0.0;
d_Itxf_dV_xf2_GND = d_Vxf2_dV_xf2_GND;
Itxf = Vxf2;

d_Vxf_dV_xf_GND = d_probeVars[admsProbeID_V_xf_GND][admsProbeID_V_xf_GND];
Vxf = (probeVars[admsProbeID_V_xf_GND]);

d_fact_dV_bi_ci = (-(model_.t0)*d_Tf_dV_bi_ci/Tf/Tf);
d_fact_dV_tnode_GND = (-(model_.t0)*d_Tf_dV_tnode_GND/Tf/Tf);
d_fact_dV_bi_ei = (-(model_.t0)*d_Tf_dV_bi_ei/Tf/Tf);
fact = ((model_.t0)/Tf);

d_Ixf_dV_bi_ei = ((Vxf-Qdei)*d_fact_dV_bi_ei+(-d_Qdei_dV_bi_ei)*fact);
d_Ixf_dV_bi_ci = ((Vxf-Qdei)*d_fact_dV_bi_ci+(-d_Qdei_dV_bi_ci)*fact);
d_Ixf_dV_tnode_GND = ((Vxf-Qdei)*d_fact_dV_tnode_GND+(-d_Qdei_dV_tnode_GND)*fact);
d_Ixf_dV_xf_GND = d_Vxf_dV_xf_GND*fact;
Ixf = ((Vxf-Qdei)*fact);

d_Qxf_dV_xf_GND = (model_.alqf)*d_Vxf_dV_xf_GND*(model_.t0);
Qxf = (((model_.alqf)*Vxf)*(model_.t0));

d_Qdeix_dV_tnode_GND = d_Qdeix_dV_bi_ci = d_Qdeix_dV_bi_ei =  0.0;
d_Qdeix_dV_xf_GND = d_Vxf_dV_xf_GND;
Qdeix = Vxf;
}
else
{

d_Ixf1_dV_xf2_GND = d_Ixf1_dV_tnode_GND = d_Ixf1_dV_bi_ei = d_Ixf1_dV_bi_ci =  0.0;
d_Ixf1_dV_xf1_GND = d_probeVars[admsProbeID_V_xf1_GND][admsProbeID_V_xf1_GND];
Ixf1 = (probeVars[admsProbeID_V_xf1_GND]);

d_Ixf2_dV_xf1_GND = d_Ixf2_dV_bi_ei = d_Ixf2_dV_tnode_GND = d_Ixf2_dV_bi_ci =  0.0;
d_Ixf2_dV_xf2_GND = d_probeVars[admsProbeID_V_xf2_GND][admsProbeID_V_xf2_GND];
Ixf2 = (probeVars[admsProbeID_V_xf2_GND]);

d_Qxf1_dV_xf1_GND =  0.0;
Qxf1 = 0;

d_Qxf2_dV_xf2_GND =  0.0;
Qxf2 = 0;

d_Ixf_dV_tnode_GND = d_Ixf_dV_bi_ci = d_Ixf_dV_bi_ei =  0.0;
d_Ixf_dV_xf_GND = d_probeVars[admsProbeID_V_xf_GND][admsProbeID_V_xf_GND];
Ixf = (probeVars[admsProbeID_V_xf_GND]);

d_Qxf_dV_xf_GND =  0.0;
Qxf = 0;
}
}
// End block Model_evaluation
//Begin block Load_sources
{
// I(bi,ei) <+ (($simparam("gmin",1e-12)*V(bi,ei)))
staticContributions[admsNodeID_bi] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ei]));
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei];
staticContributions[admsNodeID_ei] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ei]));
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ei][admsProbeID_V_bi_ei];
// I(bi,ci) <+ (($simparam("gmin",1e-12)*V(bi,ci)))
staticContributions[admsNodeID_bi] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ci]));
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci];
staticContributions[admsNodeID_ci] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_bi_ci]));
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= getDeviceOptions().gmin*d_probeVars[admsProbeID_V_bi_ci][admsProbeID_V_bi_ci];
// I(ci,ei) <+ (($simparam("gmin",1e-12)*V(ci,ei)))
staticContributions[admsNodeID_ci] += (getDeviceOptions().gmin*(probeVars[admsProbeID_V_ci_ei]));
d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] += getDeviceOptions().gmin*d_probeVars[admsProbeID_V_ci_ei][admsProbeID_V_ci_ei];
staticContributions[admsNodeID_ei] -= (getDeviceOptions().gmin*(probeVars[admsProbeID_V_ci_ei]));
d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] -= getDeviceOptions().gmin*d_probeVars[admsProbeID_V_ci_ei][admsProbeID_V_ci_ei];
// I(b,ci) <+ (ddt((type*qjcx0_t_i)))
dynamicContributions[admsNodeID_b] += (((model_.type)*qjcx0_t_i));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci] += ((model_.type)*d_qjcx0_t_i_dV_bi_ci);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND] += ((model_.type)*d_qjcx0_t_i_dV_tnode_GND);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] += ((model_.type)*d_qjcx0_t_i_dV_bp_ci);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] += ((model_.type)*d_qjcx0_t_i_dV_b_ci);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] += ((model_.type)*d_qjcx0_t_i_dV_bi_ei);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] += ((model_.type)*d_qjcx0_t_i_dV_bp_ei);
dynamicContributions[admsNodeID_ci] -= (((model_.type)*qjcx0_t_i));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*d_qjcx0_t_i_dV_bi_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*d_qjcx0_t_i_dV_tnode_GND);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= ((model_.type)*d_qjcx0_t_i_dV_bp_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -= ((model_.type)*d_qjcx0_t_i_dV_b_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*d_qjcx0_t_i_dV_bi_ei);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= ((model_.type)*d_qjcx0_t_i_dV_bp_ei);
// I(b,ci) <+ (ddt((cbcpar1*V(b,ci))))
dynamicContributions[admsNodeID_b] += ((cbcpar1*(probeVars[admsProbeID_V_b_ci])));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] += (cbcpar1*d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci]);
dynamicContributions[admsNodeID_ci] -= ((cbcpar1*(probeVars[admsProbeID_V_b_ci])));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -= (cbcpar1*d_probeVars[admsProbeID_V_b_ci][admsProbeID_V_b_ci]);
// I(bp,ci) <+ (ddt((cbcpar2*V(bp,ci))))
dynamicContributions[admsNodeID_bp] += ((cbcpar2*(probeVars[admsProbeID_V_bp_ci])));
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += (cbcpar2*d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci]);
dynamicContributions[admsNodeID_ci] -= ((cbcpar2*(probeVars[admsProbeID_V_bp_ci])));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= (cbcpar2*d_probeVars[admsProbeID_V_bp_ci][admsProbeID_V_bp_ci]);
if (((model_.rbx)>=0.001))
{
// I(b,bp) <+ ((V(b,bp)/rbx_t))
staticContributions[admsNodeID_b] += ((probeVars[admsProbeID_V_b_bp])/rbx_t);
d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_b_bp])*d_rbx_t_dV_tnode_GND/rbx_t/rbx_t);
d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp] += (d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp]/rbx_t);
staticContributions[admsNodeID_bp] -= ((probeVars[admsProbeID_V_b_bp])/rbx_t);
d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_b_bp])*d_rbx_t_dV_tnode_GND/rbx_t/rbx_t);
d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp] -= (d_probeVars[admsProbeID_V_b_bp][admsProbeID_V_b_bp]/rbx_t);
}
else
{
// V(b,bp) <+ (0.0)
// do nothing at all
}
if (((model_.rbi0)>=0.001))
{
// I(bp,bi) <+ ((V(bp,bi)/rbi))
staticContributions[admsNodeID_bp] += ((probeVars[admsProbeID_V_bp_bi])/rbi);
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ci/rbi/rbi);
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ei/rbi/rbi);
d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_tnode_GND/rbi/rbi);
d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] += (d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]/rbi);
staticContributions[admsNodeID_bi] -= ((probeVars[admsProbeID_V_bp_bi])/rbi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -= (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ci/rbi/rbi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] -= (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_bi_ei/rbi/rbi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_bp_bi])*d_rbi_dV_tnode_GND/rbi/rbi);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] -= (d_probeVars[admsProbeID_V_bp_bi][admsProbeID_V_bp_bi]/rbi);
// I(bp,bi) <+ (ddt(qrbi))
dynamicContributions[admsNodeID_bp] += (qrbi);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] += (d_qrbi_dV_bp_bi);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (d_qrbi_dV_bi_ci);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (d_qrbi_dV_bi_ei);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (d_qrbi_dV_tnode_GND);
dynamicContributions[admsNodeID_bi] -= (qrbi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi] -= (d_qrbi_dV_bp_bi);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -= (d_qrbi_dV_bi_ci);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] -= (d_qrbi_dV_bi_ei);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] -= (d_qrbi_dV_tnode_GND);
}
else
{
// V(bp,bi) <+ (0.0)
// do nothing at all
}
if (((model_.tunode)==1.0))
{
// I(bp,ei) <+ (((-type)*ibet))
staticContributions[admsNodeID_bp] += ((-(model_.type))*ibet);
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (-(model_.type))*d_ibet_dV_bi_ei;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (-(model_.type))*d_ibet_dV_bi_ci;
d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (-(model_.type))*d_ibet_dV_tnode_GND;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += (-(model_.type))*d_ibet_dV_bp_ei;
staticContributions[admsNodeID_ei] -= ((-(model_.type))*ibet);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (-(model_.type))*d_ibet_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (-(model_.type))*d_ibet_dV_bi_ci;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (-(model_.type))*d_ibet_dV_tnode_GND;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= (-(model_.type))*d_ibet_dV_bp_ei;
}
else
{
// I(bi,ei) <+ (((-type)*ibet))
staticContributions[admsNodeID_bi] += ((-(model_.type))*ibet);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (-(model_.type))*d_ibet_dV_bi_ei;
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (-(model_.type))*d_ibet_dV_bi_ci;
d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (-(model_.type))*d_ibet_dV_tnode_GND;
d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] += (-(model_.type))*d_ibet_dV_bp_ei;
staticContributions[admsNodeID_ei] -= ((-(model_.type))*ibet);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (-(model_.type))*d_ibet_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (-(model_.type))*d_ibet_dV_bi_ci;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (-(model_.type))*d_ibet_dV_tnode_GND;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= (-(model_.type))*d_ibet_dV_bp_ei;
}
// I(bp,ei) <+ ((type*ibep))
staticContributions[admsNodeID_bp] += ((model_.type)*ibep);
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (model_.type)*d_ibep_dV_bi_ei;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (model_.type)*d_ibep_dV_bi_ci;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += (model_.type)*d_ibep_dV_bp_ei;
d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (model_.type)*d_ibep_dV_tnode_GND;
staticContributions[admsNodeID_ei] -= ((model_.type)*ibep);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (model_.type)*d_ibep_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (model_.type)*d_ibep_dV_bi_ci;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= (model_.type)*d_ibep_dV_bp_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (model_.type)*d_ibep_dV_tnode_GND;
// I(bp,ei) <+ ((type*irep))
staticContributions[admsNodeID_bp] += ((model_.type)*irep);
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (model_.type)*d_irep_dV_bi_ei;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (model_.type)*d_irep_dV_bi_ci;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += (model_.type)*d_irep_dV_bp_ei;
d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (model_.type)*d_irep_dV_tnode_GND;
staticContributions[admsNodeID_ei] -= ((model_.type)*irep);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (model_.type)*d_irep_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (model_.type)*d_irep_dV_bi_ci;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= (model_.type)*d_irep_dV_bp_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (model_.type)*d_irep_dV_tnode_GND;
// I(bp,ei) <+ (ddt((type*Qjep)))
dynamicContributions[admsNodeID_bp] += (((model_.type)*Qjep));
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += ((model_.type)*d_Qjep_dV_bi_ei);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += ((model_.type)*d_Qjep_dV_tnode_GND);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += ((model_.type)*d_Qjep_dV_bi_ci);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += ((model_.type)*d_Qjep_dV_bp_ei);
dynamicContributions[admsNodeID_ei] -= (((model_.type)*Qjep));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*d_Qjep_dV_bi_ei);
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*d_Qjep_dV_tnode_GND);
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((model_.type)*d_Qjep_dV_bi_ci);
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -= ((model_.type)*d_Qjep_dV_bp_ei);
// I(bi,ei) <+ ((type*ibei))
staticContributions[admsNodeID_bi] += ((model_.type)*ibei);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (model_.type)*d_ibei_dV_bi_ei;
d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (model_.type)*d_ibei_dV_tnode_GND;
staticContributions[admsNodeID_ei] -= ((model_.type)*ibei);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (model_.type)*d_ibei_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (model_.type)*d_ibei_dV_tnode_GND;
// I(bi,ei) <+ ((type*irei))
staticContributions[admsNodeID_bi] += ((model_.type)*irei);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (model_.type)*d_irei_dV_bi_ei;
d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (model_.type)*d_irei_dV_tnode_GND;
staticContributions[admsNodeID_ei] -= ((model_.type)*irei);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (model_.type)*d_irei_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (model_.type)*d_irei_dV_tnode_GND;
// I(bi,ei) <+ ((type*ibh_rec))
staticContributions[admsNodeID_bi] += ((model_.type)*ibh_rec);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (model_.type)*d_ibh_rec_dV_bi_ci;
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (model_.type)*d_ibh_rec_dV_bi_ei;
d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (model_.type)*d_ibh_rec_dV_tnode_GND;
staticContributions[admsNodeID_ei] -= ((model_.type)*ibh_rec);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (model_.type)*d_ibh_rec_dV_bi_ci;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (model_.type)*d_ibh_rec_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (model_.type)*d_ibh_rec_dV_tnode_GND;
// I(bi,ei) <+ (ddt((type*(Qdeix+Qjei))))
dynamicContributions[admsNodeID_bi] += (((model_.type)*(Qdeix+Qjei)));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((model_.type)*(d_Qdeix_dV_bi_ei+d_Qjei_dV_bi_ei));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += ((model_.type)*d_Qdeix_dV_bi_ci);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((model_.type)*(d_Qdeix_dV_tnode_GND+d_Qjei_dV_tnode_GND));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND] += ((model_.type)*d_Qdeix_dV_xf_GND);
dynamicContributions[admsNodeID_ei] -= (((model_.type)*(Qdeix+Qjei)));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((model_.type)*(d_Qdeix_dV_bi_ei+d_Qjei_dV_bi_ei));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((model_.type)*d_Qdeix_dV_bi_ci);
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((model_.type)*(d_Qdeix_dV_tnode_GND+d_Qjei_dV_tnode_GND));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND] -= ((model_.type)*d_Qdeix_dV_xf_GND);
// I(bp,si) <+ ((type*HSI_Tsu))
staticContributions[admsNodeID_bp] += ((model_.type)*HSI_Tsu);
d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] += (model_.type)*d_HSI_Tsu_dV_si_ci;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += (model_.type)*d_HSI_Tsu_dV_bp_ci;
d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (model_.type)*d_HSI_Tsu_dV_tnode_GND;
staticContributions[admsNodeID_si] -= ((model_.type)*HSI_Tsu);
d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci] -= (model_.type)*d_HSI_Tsu_dV_si_ci;
d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] -= (model_.type)*d_HSI_Tsu_dV_bp_ci;
d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND] -= (model_.type)*d_HSI_Tsu_dV_tnode_GND;
// I(bp,ci) <+ ((type*ijbcx))
staticContributions[admsNodeID_bp] += ((model_.type)*ijbcx);
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += (model_.type)*d_ijbcx_dV_bi_ei;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += (model_.type)*d_ijbcx_dV_bi_ci;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += (model_.type)*d_ijbcx_dV_bp_ei;
d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += (model_.type)*d_ijbcx_dV_bp_ci;
d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += (model_.type)*d_ijbcx_dV_tnode_GND;
staticContributions[admsNodeID_ci] -= ((model_.type)*ijbcx);
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (model_.type)*d_ijbcx_dV_bi_ei;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (model_.type)*d_ijbcx_dV_bi_ci;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= (model_.type)*d_ijbcx_dV_bp_ei;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= (model_.type)*d_ijbcx_dV_bp_ci;
d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (model_.type)*d_ijbcx_dV_tnode_GND;
// I(bp,ci) <+ (ddt((type*(qjcx0_t_ii+Qdsu))))
dynamicContributions[admsNodeID_bp] += (((model_.type)*(qjcx0_t_ii+Qdsu)));
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] += ((model_.type)*d_qjcx0_t_ii_dV_bi_ci);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] += ((model_.type)*(d_qjcx0_t_ii_dV_tnode_GND+d_Qdsu_dV_tnode_GND));
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci] += ((model_.type)*(d_qjcx0_t_ii_dV_bp_ci+d_Qdsu_dV_bp_ci));
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] += ((model_.type)*d_qjcx0_t_ii_dV_bi_ei);
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] += ((model_.type)*d_qjcx0_t_ii_dV_bp_ei);
dynamicContributions[admsNodeID_ci] -= (((model_.type)*(qjcx0_t_ii+Qdsu)));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*d_qjcx0_t_ii_dV_bi_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*(d_qjcx0_t_ii_dV_tnode_GND+d_Qdsu_dV_tnode_GND));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= ((model_.type)*(d_qjcx0_t_ii_dV_bp_ci+d_Qdsu_dV_bp_ci));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*d_qjcx0_t_ii_dV_bi_ei);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= ((model_.type)*d_qjcx0_t_ii_dV_bp_ei);
// I(b,e) <+ (ddt((cbepar1*V(b,e))))
dynamicContributions[admsNodeID_b] += ((cbepar1*(probeVars[admsProbeID_V_b_e])));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] += (cbepar1*d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e]);
dynamicContributions[admsNodeID_e] -= ((cbepar1*(probeVars[admsProbeID_V_b_e])));
d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e] -= (cbepar1*d_probeVars[admsProbeID_V_b_e][admsProbeID_V_b_e]);
// I(bp,e) <+ (ddt((cbepar2*V(bp,e))))
dynamicContributions[admsNodeID_bp] += ((cbepar2*(probeVars[admsProbeID_V_bp_e])));
d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] += (cbepar2*d_probeVars[admsProbeID_V_bp_e][admsProbeID_V_bp_e]);
dynamicContributions[admsNodeID_e] -= ((cbepar2*(probeVars[admsProbeID_V_bp_e])));
d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] -= (cbepar2*d_probeVars[admsProbeID_V_bp_e][admsProbeID_V_bp_e]);
// I(bi,ci) <+ ((type*(ibci-iavl)))
staticContributions[admsNodeID_bi] += ((model_.type)*(ibci-iavl));
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += (model_.type)*(d_ibci_dV_bi_ei-d_iavl_dV_bi_ei);
d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += (model_.type)*(d_ibci_dV_bi_ci-d_iavl_dV_bi_ci);
d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += (model_.type)*(d_ibci_dV_tnode_GND-d_iavl_dV_tnode_GND);
staticContributions[admsNodeID_ci] -= ((model_.type)*(ibci-iavl));
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (model_.type)*(d_ibci_dV_bi_ei-d_iavl_dV_bi_ei);
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (model_.type)*(d_ibci_dV_bi_ci-d_iavl_dV_bi_ci);
d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (model_.type)*(d_ibci_dV_tnode_GND-d_iavl_dV_tnode_GND);
// I(bi,ci) <+ (ddt((type*(Qdci+Qjci))))
dynamicContributions[admsNodeID_bi] += (((model_.type)*(Qdci+Qjci)));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((model_.type)*(d_Qdci_dV_bi_ei+d_Qjci_dV_bi_ei));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += ((model_.type)*(d_Qdci_dV_bi_ci+d_Qjci_dV_bi_ci));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((model_.type)*(d_Qdci_dV_tnode_GND+d_Qjci_dV_tnode_GND));
dynamicContributions[admsNodeID_ci] -= (((model_.type)*(Qdci+Qjci)));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*(d_Qdci_dV_bi_ei+d_Qjci_dV_bi_ei));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*(d_Qdci_dV_bi_ci+d_Qjci_dV_bi_ci));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*(d_Qdci_dV_tnode_GND+d_Qjci_dV_tnode_GND));
// I(si,ci) <+ ((type*ijsc))
staticContributions[admsNodeID_si] += ((model_.type)*ijsc);
d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei] += (model_.type)*d_ijsc_dV_bi_ei;
d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] += (model_.type)*d_ijsc_dV_bi_ci;
d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] += (model_.type)*d_ijsc_dV_bp_ei;
d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] += (model_.type)*d_ijsc_dV_bp_ci;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci] += (model_.type)*d_ijsc_dV_si_ci;
d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND] += (model_.type)*d_ijsc_dV_tnode_GND;
staticContributions[admsNodeID_ci] -= ((model_.type)*ijsc);
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (model_.type)*d_ijsc_dV_bi_ei;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (model_.type)*d_ijsc_dV_bi_ci;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= (model_.type)*d_ijsc_dV_bp_ei;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= (model_.type)*d_ijsc_dV_bp_ci;
d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] -= (model_.type)*d_ijsc_dV_si_ci;
d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (model_.type)*d_ijsc_dV_tnode_GND;
// I(si,ci) <+ (ddt((type*Qjs)))
dynamicContributions[admsNodeID_si] += (((model_.type)*Qjs));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci] += ((model_.type)*d_Qjs_dV_bi_ci);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND] += ((model_.type)*d_Qjs_dV_tnode_GND);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] += ((model_.type)*d_Qjs_dV_bp_ci);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] += ((model_.type)*d_Qjs_dV_b_ci);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] += ((model_.type)*d_Qjs_dV_si_ci);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] += ((model_.type)*d_Qjs_dV_bi_ei);
d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] += ((model_.type)*d_Qjs_dV_bp_ei);
dynamicContributions[admsNodeID_ci] -= (((model_.type)*Qjs));
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= ((model_.type)*d_Qjs_dV_bi_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= ((model_.type)*d_Qjs_dV_tnode_GND);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -= ((model_.type)*d_Qjs_dV_bp_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -= ((model_.type)*d_Qjs_dV_b_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] -= ((model_.type)*d_Qjs_dV_si_ci);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= ((model_.type)*d_Qjs_dV_bi_ei);
d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -= ((model_.type)*d_Qjs_dV_bp_ei);
// I(s,c) <+ (ddt((type*Qscp)))
dynamicContributions[admsNodeID_s] += (((model_.type)*Qscp));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci] += ((model_.type)*d_Qscp_dV_bi_ci);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND] += ((model_.type)*d_Qscp_dV_tnode_GND);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] += ((model_.type)*d_Qscp_dV_bp_ci);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] += ((model_.type)*d_Qscp_dV_b_ci);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] += ((model_.type)*d_Qscp_dV_si_ci);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c] += ((model_.type)*d_Qscp_dV_s_c);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] += ((model_.type)*d_Qscp_dV_bi_ei);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] += ((model_.type)*d_Qscp_dV_bp_ei);
dynamicContributions[admsNodeID_c] -= (((model_.type)*Qscp));
d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci] -= ((model_.type)*d_Qscp_dV_bi_ci);
d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND] -= ((model_.type)*d_Qscp_dV_tnode_GND);
d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] -= ((model_.type)*d_Qscp_dV_bp_ci);
d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] -= ((model_.type)*d_Qscp_dV_b_ci);
d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] -= ((model_.type)*d_Qscp_dV_si_ci);
d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c] -= ((model_.type)*d_Qscp_dV_s_c);
d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] -= ((model_.type)*d_Qscp_dV_bi_ei);
d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] -= ((model_.type)*d_Qscp_dV_bp_ei);
// I(ci,ei) <+ ((type*Itxf))
staticContributions[admsNodeID_ci] += ((model_.type)*Itxf);
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] += (model_.type)*d_Itxf_dV_bi_ci;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] += (model_.type)*d_Itxf_dV_bi_ei;
d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] += (model_.type)*d_Itxf_dV_tnode_GND;
d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND] += (model_.type)*d_Itxf_dV_xf2_GND;
staticContributions[admsNodeID_ei] -= ((model_.type)*Itxf);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= (model_.type)*d_Itxf_dV_bi_ci;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= (model_.type)*d_Itxf_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= (model_.type)*d_Itxf_dV_tnode_GND;
d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND] -= (model_.type)*d_Itxf_dV_xf2_GND;
// I(ei,ci) <+ ((type*itr))
staticContributions[admsNodeID_ei] += ((model_.type)*itr);
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] += (model_.type)*d_itr_dV_bi_ei;
d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] += (model_.type)*d_itr_dV_bi_ci;
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] += (model_.type)*d_itr_dV_tnode_GND;
staticContributions[admsNodeID_ci] -= ((model_.type)*itr);
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -= (model_.type)*d_itr_dV_bi_ei;
d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] -= (model_.type)*d_itr_dV_bi_ci;
d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] -= (model_.type)*d_itr_dV_tnode_GND;
if (((model_.rcx)>=0.001))
{
// I(ci,c) <+ ((V(ci,c)/rcx_t))
staticContributions[admsNodeID_ci] += ((probeVars[admsProbeID_V_ci_c])/rcx_t);
d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_ci_c])*d_rcx_t_dV_tnode_GND/rcx_t/rcx_t);
d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] += (d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c]/rcx_t);
staticContributions[admsNodeID_c] -= ((probeVars[admsProbeID_V_ci_c])/rcx_t);
d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_ci_c])*d_rcx_t_dV_tnode_GND/rcx_t/rcx_t);
d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c] -= (d_probeVars[admsProbeID_V_ci_c][admsProbeID_V_ci_c]/rcx_t);
}
else
{
// V(ci,c) <+ (0.0)
// do nothing at all
}
if (((model_.re)>=0.001))
{
// I(ei,e) <+ ((V(ei,e)/re_t))
staticContributions[admsNodeID_ei] += ((probeVars[admsProbeID_V_ei_e])/re_t);
d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] += (-(probeVars[admsProbeID_V_ei_e])*d_re_t_dV_tnode_GND/re_t/re_t);
d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] += (d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]/re_t);
staticContributions[admsNodeID_e] -= ((probeVars[admsProbeID_V_ei_e])/re_t);
d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND] -= (-(probeVars[admsProbeID_V_ei_e])*d_re_t_dV_tnode_GND/re_t/re_t);
d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e] -= (d_probeVars[admsProbeID_V_ei_e][admsProbeID_V_ei_e]/re_t);
}
else
{
// V(ei,e) <+ (0.0)
// do nothing at all
}
if (((model_.rsu)>=0.001))
{
// I(si,s) <+ ((V(si,s)/rsu))
staticContributions[admsNodeID_si] += ((probeVars[admsProbeID_V_si_s])/(model_.rsu));
d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] += (d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]/(model_.rsu));
staticContributions[admsNodeID_s] -= ((probeVars[admsProbeID_V_si_s])/(model_.rsu));
d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] -= (d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]/(model_.rsu));
// I(si,s) <+ (ddt((csu*V(si,s))))
dynamicContributions[admsNodeID_si] += (((model_.csu)*(probeVars[admsProbeID_V_si_s])));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] += ((model_.csu)*d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]);
dynamicContributions[admsNodeID_s] -= (((model_.csu)*(probeVars[admsProbeID_V_si_s])));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] -= ((model_.csu)*d_probeVars[admsProbeID_V_si_s][admsProbeID_V_si_s]);
}
else
{
// V(si,s) <+ (0.0)
// do nothing at all
}
if ((((model_.flsh)==0)||((model_.rth)<0.001)))
{
// I(tnode,GND) <+ ((V(tnode,GND)/0.001))
staticContributions[admsNodeID_tnode] += ((probeVars[admsProbeID_V_tnode_GND])/0.001);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] += (d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND]/0.001);
}
else
{
// I(tnode,GND) <+ (((V(tnode,GND)/rth_t)-pterm))
staticContributions[admsNodeID_tnode] += (((probeVars[admsProbeID_V_tnode_GND])/rth_t)-pterm);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci] += (-d_pterm_dV_bi_ci);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] += (-d_pterm_dV_bi_ei);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] += (-d_pterm_dV_si_ci);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] += (-d_pterm_dV_bp_ci);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] += (-d_pterm_dV_bp_ei);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] += (-d_pterm_dV_bp_bi);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] += (-d_pterm_dV_ei_e);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] += (-d_pterm_dV_ci_c);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] += (-d_pterm_dV_b_bp);
d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] += (((rth_t*d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND]-(probeVars[admsProbeID_V_tnode_GND])*d_rth_t_dV_tnode_GND)/rth_t/rth_t)-d_pterm_dV_tnode_GND);
// I(tnode,GND) <+ (ddt((cth*V(tnode,GND))))
dynamicContributions[admsNodeID_tnode] += (((model_.cth)*(probeVars[admsProbeID_V_tnode_GND])));
d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] += ((model_.cth)*d_probeVars[admsProbeID_V_tnode_GND][admsProbeID_V_tnode_GND]);
}
// I(xf1,GND) <+ (Ixf1)
staticContributions[admsNodeID_xf1] += Ixf1;
d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci] += d_Ixf1_dV_bi_ci;
d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] += d_Ixf1_dV_bi_ei;
d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND] += d_Ixf1_dV_tnode_GND;
d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND] += d_Ixf1_dV_xf2_GND;
d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] += d_Ixf1_dV_xf1_GND;
// I(xf1,GND) <+ (ddt(Qxf1))
dynamicContributions[admsNodeID_xf1] += (Qxf1);
d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] += (d_Qxf1_dV_xf1_GND);
// I(xf2,GND) <+ (Ixf2)
staticContributions[admsNodeID_xf2] += Ixf2;
d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci] += d_Ixf2_dV_bi_ci;
d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND] += d_Ixf2_dV_tnode_GND;
d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] += d_Ixf2_dV_bi_ei;
d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND] += d_Ixf2_dV_xf1_GND;
d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] += d_Ixf2_dV_xf2_GND;
// I(xf2,GND) <+ (ddt(Qxf2))
dynamicContributions[admsNodeID_xf2] += (Qxf2);
d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] += (d_Qxf2_dV_xf2_GND);
// I(xf,GND) <+ (Ixf)
staticContributions[admsNodeID_xf] += Ixf;
d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei] += d_Ixf_dV_bi_ei;
d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] += d_Ixf_dV_bi_ci;
d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND] += d_Ixf_dV_tnode_GND;
d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND] += d_Ixf_dV_xf_GND;
// I(xf,GND) <+ (ddt(Qxf))
dynamicContributions[admsNodeID_xf] += (Qxf);
d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND] += (d_Qxf_dV_xf_GND);
}
// End block Load_sources
//Begin block noise
{
fourkt = ((4.0*1.3806503e-23)*Tdev);
if (((model_.rbx)>=0.001))
{
// I(b,bp) <+ (white_noise((fourkt/rbx_t),"rbx"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[0]= (fourkt/rbx_t);
}
}
if (((model_.rbi0)>=0.001))
{
// I(bp,bi) <+ (white_noise((fourkt/rbi),"rbi"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[1]= (fourkt/rbi);
}
}
if (((model_.rcx)>=0.001))
{
// I(ci,c) <+ (white_noise((fourkt/rcx_t),"rcx"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[2]= (fourkt/rcx_t);
}
}
if (((model_.re)>=0.001))
{
// I(ei,e) <+ (white_noise((fourkt/re_t),"re"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[3]= (fourkt/re_t);
}
}
if (((model_.rsu)>=0.001))
{
// I(si,s) <+ (white_noise((fourkt/rsu),"rsu"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[4]= (fourkt/(model_.rsu));
}
}
{
double value_fabs_0 = fabs((ibei+ibep));
double value_pow_1 = pow(value_fabs_0,(model_.af));
double  deriv_fabs_0_d0 = ((((ibei+ibep))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.af)/value_fabs_0));
flicker_Pwr = ((model_.kf)*value_pow_1);
}
if (((model_.cfbe)==(-1)))
{
// I(bi,ei) <+ (flicker_noise(flicker_Pwr,1.0,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[5]= flicker_Pwr;
  noiseContribsExponent[5]= 1.0;
}
}
else
{
// I(bp,ei) <+ (flicker_noise(flicker_Pwr,1.0,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[6]= flicker_Pwr;
  noiseContribsExponent[6]= 1.0;
}
}
if (((model_.re)>=0.001))
{
i_re = ((probeVars[admsProbeID_V_ei_e])/re_t);
{
double value_fabs_0 = fabs(i_re);
double value_pow_1 = pow(value_fabs_0,(model_.afre));
double  deriv_fabs_0_d0 = (((i_re)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.afre)/value_fabs_0));
flicker_Pwr = ((model_.kfre)*value_pow_1);
}
// I(ei,e) <+ (flicker_noise(flicker_Pwr,1.0,"flicker_re"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[7]= flicker_Pwr;
  noiseContribsExponent[7]= 1.0;
}
}
twoq = (2.0*1.6021766208e-19);
// I(ci,bi) <+ (white_noise((twoq*iavl),"iavl"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[8]= (twoq*iavl);
}
// I(bi,ci) <+ (white_noise((twoq*abs(ibci)),"ibci"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(ibci);
  noiseContribsPower[9]= (twoq*value_fabs_0);
}
// I(bp,ei) <+ (white_noise((twoq*abs(ibep)),"ibep"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(ibep);
  noiseContribsPower[10]= (twoq*value_fabs_0);
}
// I(bp,ci) <+ (white_noise((twoq*abs(ijbcx)),"ijbcx"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(ijbcx);
  noiseContribsPower[11]= (twoq*value_fabs_0);
}
// I(si,ci) <+ (white_noise((twoq*abs(ijsc)),"ijsc"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(ijsc);
  noiseContribsPower[12]= (twoq*value_fabs_0);
}
if ((((model_.flcono)==1)&&(((model_.alit)>0)&&((model_.alqf)>0))))
{
n_w = 1;

d_n_1_dV_bi_ci = d_Tf_dV_bi_ci*(model_.alit);
d_n_1_dV_tnode_GND = d_Tf_dV_tnode_GND*(model_.alit);
d_n_1_dV_bi_ei = d_Tf_dV_bi_ei*(model_.alit);
n_1 = (Tf*(model_.alit));

d_sqrt_n2_dV_bi_ci = d_betadc_dV_bi_ci*((2*(model_.alqf))-((model_.alit)*(model_.alit)));
d_sqrt_n2_dV_bi_ei = d_betadc_dV_bi_ei*((2*(model_.alqf))-((model_.alit)*(model_.alit)));
d_sqrt_n2_dV_tnode_GND = d_betadc_dV_tnode_GND*((2*(model_.alqf))-((model_.alit)*(model_.alit)));
sqrt_n2 = (betadc*((2*(model_.alqf))-((model_.alit)*(model_.alit))));
if ((sqrt_n2>0.0))
{
{
double value_sqrt_0 = sqrt(sqrt_n2);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_n_2_dV_bi_ci = (Tf*(deriv_sqrt_0_d0*(d_sqrt_n2_dV_bi_ci))+d_Tf_dV_bi_ci*value_sqrt_0);
d_n_2_dV_tnode_GND = (Tf*(deriv_sqrt_0_d0*(d_sqrt_n2_dV_tnode_GND))+d_Tf_dV_tnode_GND*value_sqrt_0);
d_n_2_dV_bi_ei = (Tf*(deriv_sqrt_0_d0*(d_sqrt_n2_dV_bi_ei))+d_Tf_dV_bi_ei*value_sqrt_0);
n_2 = (Tf*value_sqrt_0);
}
}
else
{

d_n_2_dV_bi_ei = d_n_2_dV_tnode_GND = d_n_2_dV_bi_ci =  0.0;
n_2 = 0;
}
// I(n1,GND) <+ (white_noise(((2*1.6021766208e-19)*abs(ibei)),"ibei"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(ibei);
  noiseContribsPower[13]= ((2*1.6021766208e-19)*value_fabs_0);
}
// I(n1,GND) <+ ((-V(n1,GND)))
staticContributions[admsNodeID_n1] += (-(probeVars[admsProbeID_V_n1_GND]));
d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND] += (-d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND]);
// I(bi,ei) <+ (V(n1,GND))
staticContributions[admsNodeID_bi] += (probeVars[admsProbeID_V_n1_GND]);
d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND] += d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND];
staticContributions[admsNodeID_ei] -= (probeVars[admsProbeID_V_n1_GND]);
d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND] -= d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND];
// I(bi,ei) <+ (((n_2/n_w)*ddt((n_w*V(n1,GND)))))
dynamicContributions[admsNodeID_bi] += ((n_2/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND] += (n_2/n_w)*(n_w*d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND]);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += ((n_2/n_w)*(0.0)+(d_n_2_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((n_2/n_w)*(0.0)+(d_n_2_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((n_2/n_w)*(0.0)+(d_n_2_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
dynamicContributions[admsNodeID_ei] -= ((n_2/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND] -= (n_2/n_w)*(n_w*d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND]);
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((n_2/n_w)*(0.0)+(d_n_2_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((n_2/n_w)*(0.0)+(d_n_2_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((n_2/n_w)*(0.0)+(d_n_2_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n1_GND]))));
// I(bi,ei) <+ (((n_1/n_w)*ddt((n_w*V(n2,GND)))))
dynamicContributions[admsNodeID_bi] += ((n_1/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND] += (n_1/n_w)*(n_w*d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND]);
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] += ((n_1/n_w)*(0.0)+(d_n_1_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] += ((n_1/n_w)*(0.0)+(d_n_1_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] += ((n_1/n_w)*(0.0)+(d_n_1_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
dynamicContributions[admsNodeID_ei] -= ((n_1/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND] -= (n_1/n_w)*(n_w*d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND]);
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] -= ((n_1/n_w)*(0.0)+(d_n_1_dV_bi_ci/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] -= ((n_1/n_w)*(0.0)+(d_n_1_dV_tnode_GND/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] -= ((n_1/n_w)*(0.0)+(d_n_1_dV_bi_ei/n_w)*((n_w*(probeVars[admsProbeID_V_n2_GND]))));
// I(n2,GND) <+ (white_noise(((2*1.6021766208e-19)*abs(it)),"it"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(it);
  noiseContribsPower[14]= ((2*1.6021766208e-19)*value_fabs_0);
}
// I(n2,GND) <+ ((-V(n2,GND)))
staticContributions[admsNodeID_n2] += (-(probeVars[admsProbeID_V_n2_GND]));
d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND] += (-d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND]);
// I(ci,ei) <+ (V(n2,GND))
staticContributions[admsNodeID_ci] += (probeVars[admsProbeID_V_n2_GND]);
d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND] += d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND];
staticContributions[admsNodeID_ei] -= (probeVars[admsProbeID_V_n2_GND]);
d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND] -= d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND];
}
else
{
// I(ci,ei) <+ (white_noise((twoq*abs(it)),"it"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(it);
  noiseContribsPower[15]= (twoq*value_fabs_0);
}
// I(bi,ei) <+ (white_noise((twoq*abs(ibei)),"ibei"))
if (getSolverState().noiseFlag)
{
double value_fabs_0 = fabs(ibei);
  noiseContribsPower[16]= (twoq*value_fabs_0);
}
// I(n1,GND) <+ (V(n1,GND))
staticContributions[admsNodeID_n1] += (probeVars[admsProbeID_V_n1_GND]);
d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND] += d_probeVars[admsProbeID_V_n1_GND][admsProbeID_V_n1_GND];
// I(n2,GND) <+ (V(n2,GND))
staticContributions[admsNodeID_n2] += (probeVars[admsProbeID_V_n2_GND]);
d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND] += d_probeVars[admsProbeID_V_n2_GND][admsProbeID_V_n2_GND];
}
}
// End block noise
//Begin block OPERATING_POINT
{
//Block-local variables for block OPERATING_POINT
double gPIi=0.0;
double gPIx=0.0;
double gBt=0.0;
//End of Block-local variables
//Block-local variables for block OPERATING_POINT
double gMUi=0.0;
double gMUx=0.0;
double gAVL=0.0;
//End of Block-local variables
//Block-local variables for block OPERATING_POINT
double gOi=0.0;
//End of Block-local variables
//Block-local variables for block OPERATING_POINT
double CdEi_ddx=0.0;
double CdCi_ddx=0.0;
double CdS_ddx=0.0;
//End of Block-local variables
IAVL = ((model_.type)*iavl);
VBE = (probeVars[admsProbeID_V_b_e]);
VBC = (probeVars[admsProbeID_V_b_c]);
VCE = (probeVars[admsProbeID_V_c_e]);
VSC = (probeVars[admsProbeID_V_s_c]);
GMi = (((model_.type)*(+d_it_dV_bi_ci+d_it_dV_bi_ei))+getDeviceOptions().gmin);
GMS = (((-(model_.type))*(-d_HSI_Tsu_dV_si_ci-d_HSI_Tsu_dV_bp_ci))+getDeviceOptions().gmin);
gPIi = ((((model_.type)*(+d_ibei_dV_bi_ei))+((model_.type)*(+d_irei_dV_bi_ei)))+getDeviceOptions().gmin);
gPIx = ((((model_.type)*(+d_ibep_dV_bp_ei))+((model_.type)*(+d_irep_dV_bp_ei)))+getDeviceOptions().gmin);
if (((model_.tunode)==1))
{
gBt = ((model_.type)*(+d_ibet_dV_bp_ei));
RPIi = (1.0/gPIi);
RPIx = (1.0/(gPIx-gBt));
}
else
{
gBt = ((model_.type)*(+d_ibet_dV_bi_ei+d_ibet_dV_bi_ci));
RPIi = (1.0/(gPIi-gBt));
RPIx = (1.0/gPIx);
}
gMUi = (((-(model_.type))*(-d_ibci_dV_bi_ci))+getDeviceOptions().gmin);
gMUx = (((-(model_.type))*(-d_ijbcx_dV_bi_ci-d_ijbcx_dV_bp_ci))+getDeviceOptions().gmin);
gAVL = (((model_.type)*(-d_iavl_dV_bi_ci))+getDeviceOptions().gmin);
RMUi = (1/(gMUi-gAVL));
RMUx = (1/gMUx);
gOi = ((model_.type)*(-d_it_dV_bi_ci));
ROi = (1/(gOi+gAVL));
CdEi_ddx = ((-(model_.type))*(-d_Qdei_dV_bi_ei));
CdCi_ddx = ((-(model_.type))*(-d_Qdci_dV_bi_ci));
CPIi = (Cjei+CdEi_ddx);
CPIx = (Cjep+(model_.cbepar));
CdS_ddx = ((-(model_.type))*(-d_Qdsu_dV_bp_ci));
CMUi = (Cjci+CdCi_ddx);
CMUx = (((CjCx_i+CjCx_ii)+(model_.cbcpar))+CdS_ddx);
CCS = (Cjs+Cscp);
rb = (rbi+rbx_t);
if (((gPIi+gPIx)>0.0))
{
BETAAC = (GMi/(gPIi+gPIx));
}
else
{
BETAAC = 0.0;
}
CRBI = Crbi;
TF = Tf;
FT = (GMi/((2*3.14159265358979323846)*((((CPIi+CPIx)+CMUi)+CMUx)+((((rcx_t+re_t)+((re_t+rb)/BETAAC))*GMi)*(CMUi+CMUx)))));
TK = Tdev;
DTSH = (probeVars[admsProbeID_V_tnode_GND]);
}
// End block OPERATING_POINT


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_ei_GND] =  "
         <<probeVars[admsProbeID_V_ei_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_GND] =  "
         <<probeVars[admsProbeID_V_bp_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_GND] =  "
         <<probeVars[admsProbeID_V_ci_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_GND] =  "
         <<probeVars[admsProbeID_V_bi_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_c_e] =  "
         <<probeVars[admsProbeID_V_c_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_c] =  "
         <<probeVars[admsProbeID_V_b_c] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_n2_GND] =  "
         <<probeVars[admsProbeID_V_n2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_n1_GND] =  "
         <<probeVars[admsProbeID_V_n1_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_s] =  "
         <<probeVars[admsProbeID_V_si_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_e] =  "
         <<probeVars[admsProbeID_V_bp_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_e] =  "
         <<probeVars[admsProbeID_V_b_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_ei] =  "
         <<probeVars[admsProbeID_V_ci_ei] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf_GND] =  "
         <<probeVars[admsProbeID_V_xf_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf2_GND] =  "
         <<probeVars[admsProbeID_V_xf2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xf1_GND] =  "
         <<probeVars[admsProbeID_V_xf1_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_bp] =  "
         <<probeVars[admsProbeID_V_b_bp] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ci_c] =  "
         <<probeVars[admsProbeID_V_ci_c] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_ei_e] =  "
         <<probeVars[admsProbeID_V_ei_e] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_bi] =  "
         <<probeVars[admsProbeID_V_bp_bi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_tnode_GND] =  "
         <<probeVars[admsProbeID_V_tnode_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_c] =  "
         <<probeVars[admsProbeID_V_s_c] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_ci] =  "
         <<probeVars[admsProbeID_V_si_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_ci] =  "
         <<probeVars[admsProbeID_V_b_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_ci] =  "
         <<probeVars[admsProbeID_V_bp_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bp_ei] =  "
         <<probeVars[admsProbeID_V_bp_ei] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ci] =  "
         <<probeVars[admsProbeID_V_bi_ci] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_bi_ei] =  "
         <<probeVars[admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_c] =  "
         <<staticContributions[admsNodeID_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_c][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_c] =  "
         <<dynamicContributions[admsNodeID_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_c].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
         <<staticContributions[admsNodeID_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
         <<dynamicContributions[admsNodeID_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_e] =  "
         <<staticContributions[admsNodeID_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_e] =  "
         <<dynamicContributions[admsNodeID_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_e].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_e][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
         <<staticContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
         <<dynamicContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_tnode] =  "
         <<staticContributions[admsNodeID_tnode] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_tnode] =  "
         <<dynamicContributions[admsNodeID_tnode] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tnode].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ci] =  "
         <<staticContributions[admsNodeID_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ci] =  "
         <<dynamicContributions[admsNodeID_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ci].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_ei] =  "
         <<staticContributions[admsNodeID_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_ei] =  "
         <<dynamicContributions[admsNodeID_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_ei].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bp] =  "
         <<staticContributions[admsNodeID_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bp] =  "
         <<dynamicContributions[admsNodeID_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bp].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_bi] =  "
         <<staticContributions[admsNodeID_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_bi] =  "
         <<dynamicContributions[admsNodeID_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_bi].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
         <<staticContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
         <<dynamicContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf1] =  "
         <<staticContributions[admsNodeID_xf1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf1] =  "
         <<dynamicContributions[admsNodeID_xf1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf1].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf2] =  "
         <<staticContributions[admsNodeID_xf2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf2] =  "
         <<dynamicContributions[admsNodeID_xf2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf2].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xf] =  "
         <<staticContributions[admsNodeID_xf] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xf] =  "
         <<dynamicContributions[admsNodeID_xf] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xf].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_xf][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_n1] =  "
         <<staticContributions[admsNodeID_n1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_n1] =  "
         <<dynamicContributions[admsNodeID_n1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n1].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_n1][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_n2] =  "
         <<staticContributions[admsNodeID_n2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ei_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ci_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bi_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_c_e) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_b_c) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_n2_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_n1_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_si_s) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_e) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_b_e) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ci_ei) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_xf_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_xf2_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_xf1_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_b_bp) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ci_c) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_ei_e) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_bi) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_tnode_GND) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_s_c) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_si_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_b_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ei) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ci) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ei) =  " <<d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_n2] =  "
         <<dynamicContributions[admsNodeID_n2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ei_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ei_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ci_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ci_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bi_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_c_e) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_c_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_b_c) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_b_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_n2_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_n2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_n1_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_n1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_si_s) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_si_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_e) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_b_e) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_b_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ci_ei) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ci_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_xf_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_xf_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_xf2_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_xf2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_xf1_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_xf1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_b_bp) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_b_bp] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ci_c) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ci_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_ei_e) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_ei_e] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_bi) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_bi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_tnode_GND) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_s_c) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_s_c] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_si_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_si_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_b_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_b_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bp_ei) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bp_ei] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ci) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bi_ci] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_n2].dx(admsProbeID_V_bi_ei) =  " <<d_dynamicContributions[admsNodeID_n2][admsProbeID_V_bi_ei] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 5 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 15; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 5 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
return 17;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
int numSources=getNumNoiseSources();
noiseData.numSources = numSources;
noiseData.resize(numSources);

noiseData.deviceName = getName().getEncodedName();
std::string theNoiseName;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_b_bp")+std::string("_")+std::string("rbx");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[0]=theNoiseName;
noiseData.li_Pos[0]=li_b;
noiseData.li_Neg[0]=li_bp;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bp_bi")+std::string("_")+std::string("rbi");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[1]=theNoiseName;
noiseData.li_Pos[1]=li_bp;
noiseData.li_Neg[1]=li_bi;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ci_c")+std::string("_")+std::string("rcx");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[2]=theNoiseName;
noiseData.li_Pos[2]=li_ci;
noiseData.li_Neg[2]=li_c;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ei_e")+std::string("_")+std::string("re");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[3]=theNoiseName;
noiseData.li_Pos[3]=li_ei;
noiseData.li_Neg[3]=li_e;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_si_s")+std::string("_")+std::string("rsu");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[4]=theNoiseName;
noiseData.li_Pos[4]=li_si;
noiseData.li_Neg[4]=li_s;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_bi_ei")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[5]=theNoiseName;
noiseData.li_Pos[5]=li_bi;
noiseData.li_Neg[5]=li_ei;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_bp_ei")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[6]=theNoiseName;
noiseData.li_Pos[6]=li_bp;
noiseData.li_Neg[6]=li_ei;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_ei_e")+std::string("_")+std::string("flicker_re");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[7]=theNoiseName;
noiseData.li_Pos[7]=li_ei;
noiseData.li_Neg[7]=li_e;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ci_bi")+std::string("_")+std::string("iavl");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[8]=theNoiseName;
noiseData.li_Pos[8]=li_ci;
noiseData.li_Neg[8]=li_bi;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bi_ci")+std::string("_")+std::string("ibci");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[9]=theNoiseName;
noiseData.li_Pos[9]=li_bi;
noiseData.li_Neg[9]=li_ci;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bp_ei")+std::string("_")+std::string("ibep");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[10]=theNoiseName;
noiseData.li_Pos[10]=li_bp;
noiseData.li_Neg[10]=li_ei;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bp_ci")+std::string("_")+std::string("ijbcx");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[11]=theNoiseName;
noiseData.li_Pos[11]=li_bp;
noiseData.li_Neg[11]=li_ci;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_si_ci")+std::string("_")+std::string("ijsc");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[12]=theNoiseName;
noiseData.li_Pos[12]=li_si;
noiseData.li_Neg[12]=li_ci;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_n1_GND")+std::string("_")+std::string("ibei");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[13]=theNoiseName;
noiseData.li_Pos[13]=li_n1;
noiseData.li_Neg[13]=-1;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_n2_GND")+std::string("_")+std::string("it");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[14]=theNoiseName;
noiseData.li_Pos[14]=li_n2;
noiseData.li_Neg[14]=-1;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_ci_ei")+std::string("_")+std::string("it");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[15]=theNoiseName;
noiseData.li_Pos[15]=li_ci;
noiseData.li_Neg[15]=li_ei;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_bi_ei")+std::string("_")+std::string("ibei");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[16]=theNoiseName;
noiseData.li_Pos[16]=li_bi;
noiseData.li_Neg[16]=li_ei;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
noiseData.noiseDens[1] = noiseContribsPower[1];
noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
noiseData.noiseDens[2] = noiseContribsPower[2];
noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
noiseData.noiseDens[3] = noiseContribsPower[3];
noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
noiseData.noiseDens[4] = noiseContribsPower[4];
noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
noiseData.noiseDens[5] = noiseContribsPower[5];

      noiseData.noiseDens[5] /= pow(noiseData.freq,noiseContribsExponent[5]);noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
noiseData.noiseDens[6] = noiseContribsPower[6];

      noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
noiseData.noiseDens[7] = noiseContribsPower[7];

      noiseData.noiseDens[7] /= pow(noiseData.freq,noiseContribsExponent[7]);noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
noiseData.noiseDens[8] = noiseContribsPower[8];
noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
noiseData.noiseDens[9] = noiseContribsPower[9];
noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
noiseData.noiseDens[10] = noiseContribsPower[10];
noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
noiseData.noiseDens[11] = noiseContribsPower[11];
noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
noiseData.noiseDens[12] = noiseContribsPower[12];
noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
noiseData.noiseDens[13] = noiseContribsPower[13];
noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
noiseData.noiseDens[14] = noiseContribsPower[14];
noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
noiseData.noiseDens[15] = noiseContribsPower[15];
noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));
noiseData.noiseDens[16] = noiseContribsPower[16];
noiseData.lnNoiseDens[16] = std::log(std::max(noiseData.noiseDens[16],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_bi_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  (*f_bi_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  (*f_ei_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*f_ei_Equ_ei_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*f_bi_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  (*f_ci_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*f_ci_Equ_ci_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*f_ci_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei];
  (*f_ei_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei];
  (*f_b_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  (*f_ci_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  (*f_b_Equ_bp_Node_Ptr) +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  (*f_ci_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei];
  (*f_b_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  (*f_bp_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] -d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  (*f_bp_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  (*f_bp_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  (*f_bp_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  (*f_bp_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  (*f_bp_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  (*f_bi_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  (*f_bi_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  (*f_ei_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  (*f_ei_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  (*f_bp_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci];
  (*f_si_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  (*f_si_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  (*f_si_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  (*f_si_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  (*f_e_Equ_e_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  (*f_e_Equ_bp_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei];
  (*f_si_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  (*f_si_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  (*f_ci_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  (*f_c_Equ_ci_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  (*f_s_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  (*f_c_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  (*f_s_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  (*f_s_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  (*f_c_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  (*f_ci_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND];
  (*f_ei_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND];
  (*f_ci_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c];
  (*f_e_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND];
  (*f_ei_Equ_e_Node_Ptr) +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e];
  (*f_e_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  (*f_si_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_si_s];
  (*f_tnode_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  (*f_tnode_Equ_bi_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  (*f_tnode_Equ_ci_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  (*f_tnode_Equ_ei_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei];
  (*f_tnode_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci];
  (*f_tnode_Equ_bp_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci];
  (*f_tnode_Equ_e_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e];
  (*f_tnode_Equ_c_Node_Ptr) +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c];
  (*f_tnode_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp];
  (*f_xf1_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  (*f_xf1_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  (*f_xf1_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei];
  (*f_xf1_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND];
  (*f_xf1_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND];
  (*f_xf1_Equ_xf1_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  (*f_xf2_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  (*f_xf2_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  (*f_xf2_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND];
  (*f_xf2_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei];
  (*f_xf2_Equ_xf1_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND];
  (*f_xf2_Equ_xf2_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  (*f_xf_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  (*f_xf_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  (*f_xf_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci];
  (*f_xf_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND];
  (*f_xf_Equ_xf_Node_Ptr) +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  (*f_e_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  (*f_e_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  (*f_n1_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  (*f_n1_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  (*f_n1_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_tnode_GND];
  (*f_n1_Equ_n1_Node_Ptr) +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND];
  (*f_bi_Equ_n1_Node_Ptr) +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  (*f_ei_Equ_n1_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  (*f_ei_Equ_n2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND];
  (*f_n2_Equ_bi_Node_Ptr) +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  (*f_n2_Equ_ci_Node_Ptr) +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  (*f_n2_Equ_ei_Node_Ptr) +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei];
  (*f_n2_Equ_tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_tnode_GND];
  (*f_n2_Equ_n2_Node_Ptr) +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND];
  (*f_ci_Equ_n2_Node_Ptr) +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND];

#else
  //use the offsets instead of pointers
  dFdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  dFdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  dFdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dFdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dFdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  dFdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dFdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dFdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_ei];
  dFdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_ei][admsProbeID_V_ci_ei];
  dFdx[li_b][A_b_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  dFdx[li_ci][A_ci_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  dFdx[li_b][A_b_Equ_bp_NodeOffset] +=  -d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  dFdx[li_ci][A_ci_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_ci][admsProbeID_V_bp_ei];
  dFdx[li_b][A_b_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_b][admsProbeID_V_b_bp];
  dFdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] -d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  dFdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  dFdx[li_bp][A_bp_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  dFdx[li_bp][A_bp_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_b_bp];
  dFdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ci];
  dFdx[li_bp][A_bp_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  dFdx[li_bi][A_bi_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  dFdx[li_bi][A_bi_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  dFdx[li_ei][A_ei_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  dFdx[li_ei][A_ei_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  dFdx[li_bp][A_bp_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_bp][admsProbeID_V_si_ci];
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_si_s] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  dFdx[li_si][A_si_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_ci];
  dFdx[li_si][A_si_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  dFdx[li_si][A_si_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  dFdx[li_e][A_e_Equ_e_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  dFdx[li_e][A_e_Equ_bp_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei];
  dFdx[li_si][A_si_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  dFdx[li_si][A_si_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  dFdx[li_ci][A_ci_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  dFdx[li_c][A_c_Equ_ci_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  dFdx[li_s][A_s_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  dFdx[li_c][A_c_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  dFdx[li_s][A_s_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_si_s];
  dFdx[li_c][A_c_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_c][admsProbeID_V_ci_c];
  dFdx[li_ci][A_ci_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_xf2_GND];
  dFdx[li_ei][A_ei_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_xf2_GND];
  dFdx[li_ci][A_ci_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_ci][admsProbeID_V_ci_c];
  dFdx[li_e][A_e_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_tnode_GND];
  dFdx[li_ei][A_ei_Equ_e_NodeOffset] +=  -d_staticContributions[admsNodeID_ei][admsProbeID_V_ei_e];
  dFdx[li_e][A_e_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] -d_staticContributions[admsNodeID_e][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_ei_e];
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_si_s];
  dFdx[li_tnode][A_tnode_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  dFdx[li_tnode][A_tnode_Equ_bi_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  dFdx[li_tnode][A_tnode_Equ_ci_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ci];
  dFdx[li_tnode][A_tnode_Equ_ei_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] -d_staticContributions[admsNodeID_tnode][admsProbeID_V_bi_ei];
  dFdx[li_tnode][A_tnode_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_si_ci];
  dFdx[li_tnode][A_tnode_Equ_bp_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_bi] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ei] +d_staticContributions[admsNodeID_tnode][admsProbeID_V_bp_ci];
  dFdx[li_tnode][A_tnode_Equ_e_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ei_e];
  dFdx[li_tnode][A_tnode_Equ_c_NodeOffset] +=  -d_staticContributions[admsNodeID_tnode][admsProbeID_V_ci_c];
  dFdx[li_tnode][A_tnode_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_tnode][admsProbeID_V_b_bp];
  dFdx[li_xf1][A_xf1_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  dFdx[li_xf1][A_xf1_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ci];
  dFdx[li_xf1][A_xf1_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_xf1][admsProbeID_V_bi_ei];
  dFdx[li_xf1][A_xf1_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_tnode_GND];
  dFdx[li_xf1][A_xf1_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf2_GND];
  dFdx[li_xf1][A_xf1_Equ_xf1_NodeOffset] +=  +d_staticContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  dFdx[li_xf2][A_xf2_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  dFdx[li_xf2][A_xf2_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ci];
  dFdx[li_xf2][A_xf2_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_tnode_GND];
  dFdx[li_xf2][A_xf2_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_xf2][admsProbeID_V_bi_ei];
  dFdx[li_xf2][A_xf2_Equ_xf1_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf1_GND];
  dFdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +d_staticContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  dFdx[li_xf][A_xf_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci] +d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  dFdx[li_xf][A_xf_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ei];
  dFdx[li_xf][A_xf_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_xf][admsProbeID_V_bi_ci];
  dFdx[li_xf][A_xf_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_tnode_GND];
  dFdx[li_xf][A_xf_Equ_xf_NodeOffset] +=  +d_staticContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  dFdx[li_e][A_e_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  dFdx[li_e][A_e_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_e][admsProbeID_V_bi_ci];
  dFdx[li_n1][A_n1_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  dFdx[li_n1][A_n1_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_n1][admsProbeID_V_bi_ei];
  dFdx[li_n1][A_n1_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_tnode_GND];
  dFdx[li_n1][A_n1_Equ_n1_NodeOffset] +=  +d_staticContributions[admsNodeID_n1][admsProbeID_V_n1_GND];
  dFdx[li_bi][A_bi_Equ_n1_NodeOffset] +=  +d_staticContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  dFdx[li_ei][A_ei_Equ_n1_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  dFdx[li_ei][A_ei_Equ_n2_NodeOffset] +=  +d_staticContributions[admsNodeID_ei][admsProbeID_V_n2_GND];
  dFdx[li_n2][A_n2_Equ_bi_NodeOffset] +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei] +d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  dFdx[li_n2][A_n2_Equ_ci_NodeOffset] +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ci];
  dFdx[li_n2][A_n2_Equ_ei_NodeOffset] +=  -d_staticContributions[admsNodeID_n2][admsProbeID_V_bi_ei];
  dFdx[li_n2][A_n2_Equ_tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_tnode_GND];
  dFdx[li_n2][A_n2_Equ_n2_NodeOffset] +=  +d_staticContributions[admsNodeID_n2][admsProbeID_V_n2_GND];
  dFdx[li_ci][A_ci_Equ_n2_NodeOffset] +=  +d_staticContributions[admsNodeID_ci][admsProbeID_V_n2_GND];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_bi_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  (*q_bi_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  (*q_ei_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*q_ei_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  (*q_bi_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  (*q_ci_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*q_ci_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  (*q_ci_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei];
  (*q_ei_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci];
  (*q_b_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  (*q_b_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  (*q_b_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  (*q_ci_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  (*q_b_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci];
  (*q_ci_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci];
  (*q_b_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci];
  (*q_ci_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci];
  (*q_b_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei];
  (*q_bp_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  (*q_bp_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  (*q_bp_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  (*q_bp_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi];
  (*q_bp_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  (*q_bi_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  (*q_bi_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  (*q_ei_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  (*q_ei_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  (*q_bi_Equ_xf_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND];
  (*q_ei_Equ_xf_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND];
  (*q_si_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci];
  (*q_si_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  (*q_si_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  (*q_si_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  (*q_b_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  (*q_e_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  (*q_e_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  (*q_bp_Equ_e_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e];
  (*q_e_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e];
  (*q_si_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  (*q_si_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  (*q_ci_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  (*q_si_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci];
  (*q_s_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  (*q_s_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  (*q_c_Equ_bi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  (*q_c_Equ_ci_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  (*q_s_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  (*q_c_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  (*q_s_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci];
  (*q_c_Equ_bp_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci];
  (*q_s_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci];
  (*q_c_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci];
  (*q_s_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci];
  (*q_c_Equ_si_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci];
  (*q_s_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  (*q_s_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  (*q_c_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  (*q_c_Equ_c_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  (*q_s_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei];
  (*q_c_Equ_ei_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei];
  (*q_si_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s];
  (*q_tnode_Equ_tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  (*q_xf1_Equ_xf1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  (*q_xf2_Equ_xf2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  (*q_xf_Equ_xf_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  (*q_bi_Equ_n1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  (*q_ei_Equ_n1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  (*q_bi_Equ_n2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND];
  (*q_ei_Equ_n2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_bi][A_bi_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  dQdx[li_bi][A_bi_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ei];
  dQdx[li_ei][A_ei_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci] +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dQdx[li_ei][A_ei_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ei];
  dQdx[li_bi][A_bi_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bi_ci];
  dQdx[li_ci][A_ci_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dQdx[li_ci][A_ci_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ci];
  dQdx[li_ci][A_ci_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bi_ei];
  dQdx[li_ei][A_ei_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bi_ci];
  dQdx[li_b][A_b_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  dQdx[li_b][A_b_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ci];
  dQdx[li_b][A_b_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_tnode_GND];
  dQdx[li_ci][A_ci_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_tnode_GND];
  dQdx[li_b][A_b_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ci];
  dQdx[li_ci][A_ci_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_bp_ci];
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_ci];
  dQdx[li_ci][A_ci_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_b_ci];
  dQdx[li_b][A_b_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_bi_ei];
  dQdx[li_bp][A_bp_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  dQdx[li_bp][A_bp_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ci];
  dQdx[li_bp][A_bp_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_tnode_GND];
  dQdx[li_bp][A_bp_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ci] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_bi];
  dQdx[li_bp][A_bp_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bi_ei];
  dQdx[li_bi][A_bi_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_tnode_GND];
  dQdx[li_bi][A_bi_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_bp_bi];
  dQdx[li_ei][A_ei_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_tnode_GND];
  dQdx[li_ei][A_ei_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_bp_ei];
  dQdx[li_bi][A_bi_Equ_xf_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_xf_GND];
  dQdx[li_ei][A_ei_Equ_xf_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_xf_GND];
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci];
  dQdx[li_si][A_si_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  dQdx[li_si][A_si_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ci];
  dQdx[li_si][A_si_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_tnode_GND];
  dQdx[li_b][A_b_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_e];
  dQdx[li_e][A_e_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  dQdx[li_e][A_e_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e] -d_dynamicContributions[admsNodeID_e][admsProbeID_V_b_e];
  dQdx[li_bp][A_bp_Equ_e_NodeOffset] +=  -d_dynamicContributions[admsNodeID_bp][admsProbeID_V_bp_e];
  dQdx[li_e][A_e_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_e][admsProbeID_V_bp_e];
  dQdx[li_si][A_si_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ci];
  dQdx[li_si][A_si_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_bi_ei];
  dQdx[li_ci][A_ci_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ci][admsProbeID_V_si_ci];
  dQdx[li_si][A_si_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_ci];
  dQdx[li_s][A_s_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  dQdx[li_s][A_s_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ci];
  dQdx[li_c][A_c_Equ_bi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  dQdx[li_c][A_c_Equ_ci_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ci];
  dQdx[li_s][A_s_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_tnode_GND];
  dQdx[li_c][A_c_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_tnode_GND];
  dQdx[li_s][A_s_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ci];
  dQdx[li_c][A_c_Equ_bp_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] +d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ci];
  dQdx[li_s][A_s_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_ci];
  dQdx[li_c][A_c_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_b_ci];
  dQdx[li_s][A_s_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_ci];
  dQdx[li_c][A_c_Equ_si_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_si_ci];
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  dQdx[li_s][A_s_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_c];
  dQdx[li_c][A_c_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  dQdx[li_c][A_c_Equ_c_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_s_c];
  dQdx[li_s][A_s_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_bi_ei];
  dQdx[li_c][A_c_Equ_ei_NodeOffset] +=  -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bp_ei] -d_dynamicContributions[admsNodeID_c][admsProbeID_V_bi_ei];
  dQdx[li_si][A_si_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_s];
  dQdx[li_tnode][A_tnode_Equ_tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_tnode][admsProbeID_V_tnode_GND];
  dQdx[li_xf1][A_xf1_Equ_xf1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xf1][admsProbeID_V_xf1_GND];
  dQdx[li_xf2][A_xf2_Equ_xf2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xf2][admsProbeID_V_xf2_GND];
  dQdx[li_xf][A_xf_Equ_xf_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xf][admsProbeID_V_xf_GND];
  dQdx[li_bi][A_bi_Equ_n1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n1_GND];
  dQdx[li_ei][A_ei_Equ_n1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n1_GND];
  dQdx[li_bi][A_bi_Equ_n2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_bi][admsProbeID_V_n2_GND];
  dQdx[li_ei][A_ei_Equ_n2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_ei][admsProbeID_V_n2_GND];


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

// set internal model type based on model card type
if (getType() == "pnp" || getType() == "PNP")
    type = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter c10 : [ 0, 1 ]
  if ( (!((c10 >=0 && c10 <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter c10 value " << c10 << " out of range [ 0, 1 ]";
  }

//    Parameter qp0 : ] 0, 1 ]
  if ( (!((qp0 >0 && qp0 <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter qp0 value " << qp0 << " out of range ] 0, 1 ]";
  }

//    Parameter ich : [ 0,  (+inf) [
  if ( (!((ich >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ich value " << ich << " out of range [ 0,  (+inf) [";
  }

//    Parameter hf0 : [ 0,  (+inf) [
  if ( (!((hf0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hf0 value " << hf0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter hfe : [ 0,  (+inf) [
  if ( (!((hfe >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hfe value " << hfe << " out of range [ 0,  (+inf) [";
  }

//    Parameter hfc : [ 0,  (+inf) [
  if ( (!((hfc >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hfc value " << hfc << " out of range [ 0,  (+inf) [";
  }

//    Parameter hjei : [ 0, 100 ]
  if ( (!((hjei >=0 && hjei <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hjei value " << hjei << " out of range [ 0, 100 ]";
  }

//    Parameter ahjei : [ 0, 100 ]
  if ( (!((ahjei >=0 && ahjei <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ahjei value " << ahjei << " out of range [ 0, 100 ]";
  }

//    Parameter rhjei : ] 0, 10 ]
  if ( (!((rhjei >0 && rhjei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rhjei value " << rhjei << " out of range ] 0, 10 ]";
  }

//    Parameter hjci : [ 0, 100 ]
  if ( (!((hjci >=0 && hjci <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter hjci value " << hjci << " out of range [ 0, 100 ]";
  }

//    Parameter ibeis : [ 0, 1 ]
  if ( (!((ibeis >=0 && ibeis <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibeis value " << ibeis << " out of range [ 0, 1 ]";
  }

//    Parameter mbei : ] 0, 10 ]
  if ( (!((mbei >0 && mbei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbei value " << mbei << " out of range ] 0, 10 ]";
  }

//    Parameter ireis : [ 0, 1 ]
  if ( (!((ireis >=0 && ireis <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ireis value " << ireis << " out of range [ 0, 1 ]";
  }

//    Parameter mrei : ] 0, 10 ]
  if ( (!((mrei >0 && mrei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mrei value " << mrei << " out of range ] 0, 10 ]";
  }

//    Parameter ibeps : [ 0, 1 ]
  if ( (!((ibeps >=0 && ibeps <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibeps value " << ibeps << " out of range [ 0, 1 ]";
  }

//    Parameter mbep : ] 0, 10 ]
  if ( (!((mbep >0 && mbep <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbep value " << mbep << " out of range ] 0, 10 ]";
  }

//    Parameter ireps : [ 0, 1 ]
  if ( (!((ireps >=0 && ireps <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ireps value " << ireps << " out of range [ 0, 1 ]";
  }

//    Parameter mrep : ] 0, 10 ]
  if ( (!((mrep >0 && mrep <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mrep value " << mrep << " out of range ] 0, 10 ]";
  }

//    Parameter mcf : ] 0, 10 ]
  if ( (!((mcf >0 && mcf <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mcf value " << mcf << " out of range ] 0, 10 ]";
  }

//    Parameter tbhrec : [ 0,  (+inf) [
  if ( (!((tbhrec >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tbhrec value " << tbhrec << " out of range [ 0,  (+inf) [";
  }

//    Parameter ibcis : [ 0, 1.0 ]
  if ( (!((ibcis >=0 && ibcis <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibcis value " << ibcis << " out of range [ 0, 1.0 ]";
  }

//    Parameter mbci : ] 0, 10 ]
  if ( (!((mbci >0 && mbci <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbci value " << mbci << " out of range ] 0, 10 ]";
  }

//    Parameter ibcxs : [ 0, 1.0 ]
  if ( (!((ibcxs >=0 && ibcxs <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibcxs value " << ibcxs << " out of range [ 0, 1.0 ]";
  }

//    Parameter mbcx : ] 0, 10 ]
  if ( (!((mbcx >0 && mbcx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter mbcx value " << mbcx << " out of range ] 0, 10 ]";
  }

//    Parameter ibets : [ 0, 50 ]
  if ( (!((ibets >=0 && ibets <=50 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ibets value " << ibets << " out of range [ 0, 50 ]";
  }

//    Parameter abet : [ 0,  (+inf) [
  if ( (!((abet >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter abet value " << abet << " out of range [ 0,  (+inf) [";
  }

//    Parameter tunode : [ 0, 1 ]
  if ( (!((tunode >=0 && tunode <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tunode value " << tunode << " out of range [ 0, 1 ]";
  }

//    Parameter favl : [ 0,  (+inf) [
  if ( (!((favl >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter favl value " << favl << " out of range [ 0,  (+inf) [";
  }

//    Parameter qavl : [ 0,  (+inf) [
  if ( (!((qavl >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter qavl value " << qavl << " out of range [ 0,  (+inf) [";
  }

//    Parameter kavl : [ 0, 3 ]
  if ( (!((kavl >=0 && kavl <=3 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter kavl value " << kavl << " out of range [ 0, 3 ]";
  }

//    Parameter rbi0 : [ 0,  (+inf) [
  if ( (!((rbi0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rbi0 value " << rbi0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter rbx : [ 0,  (+inf) [
  if ( (!((rbx >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rbx value " << rbx << " out of range [ 0,  (+inf) [";
  }

//    Parameter fgeo : [ 0,  (+inf) [
  if ( (!((fgeo >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fgeo value " << fgeo << " out of range [ 0,  (+inf) [";
  }

//    Parameter fdqr0 : [ (-0.5), 100 ]
  if ( (!((fdqr0 >=(-0.5) && fdqr0 <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fdqr0 value " << fdqr0 << " out of range [ (-0.5), 100 ]";
  }

//    Parameter fcrbi : [ 0, 1 ]
  if ( (!((fcrbi >=0 && fcrbi <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fcrbi value " << fcrbi << " out of range [ 0, 1 ]";
  }

//    Parameter fqi : [ 0, 1 ]
  if ( (!((fqi >=0 && fqi <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fqi value " << fqi << " out of range [ 0, 1 ]";
  }

//    Parameter re : [ 0,  (+inf) [
  if ( (!((re >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter re value " << re << " out of range [ 0,  (+inf) [";
  }

//    Parameter rcx : [ 0,  (+inf) [
  if ( (!((rcx >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rcx value " << rcx << " out of range [ 0,  (+inf) [";
  }

//    Parameter itss : [ 0, 1.0 ]
  if ( (!((itss >=0 && itss <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter itss value " << itss << " out of range [ 0, 1.0 ]";
  }

//    Parameter msf : ] 0, 10 ]
  if ( (!((msf >0 && msf <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter msf value " << msf << " out of range ] 0, 10 ]";
  }

//    Parameter iscs : [ 0, 1.0 ]
  if ( (!((iscs >=0 && iscs <=1.0 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter iscs value " << iscs << " out of range [ 0, 1.0 ]";
  }

//    Parameter msc : ] 0, 10 ]
  if ( (!((msc >0 && msc <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter msc value " << msc << " out of range ] 0, 10 ]";
  }

//    Parameter tsf : [ 0,  (+inf) [
  if ( (!((tsf >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tsf value " << tsf << " out of range [ 0,  (+inf) [";
  }

//    Parameter rsu : [ 0,  (+inf) [
  if ( (!((rsu >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rsu value " << rsu << " out of range [ 0,  (+inf) [";
  }

//    Parameter csu : [ 0,  (+inf) [
  if ( (!((csu >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter csu value " << csu << " out of range [ 0,  (+inf) [";
  }

//    Parameter cjei0 : [ 0,  (+inf) [
  if ( (!((cjei0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjei0 value " << cjei0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vdei : ] 0, 10 ]
  if ( (!((vdei >0 && vdei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdei value " << vdei << " out of range ] 0, 10 ]";
  }

//    Parameter zei : ] 0, 1 [
  if ( (!((zei >0 && zei <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zei value " << zei << " out of range ] 0, 1 [";
  }

//    Parameter ajei : [ 1,  (+inf) [
  if ( (!((ajei >=1))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ajei value " << ajei << " out of range [ 1,  (+inf) [";
  }

//    Parameter cjep0 : [ 0,  (+inf) [
  if ( (!((cjep0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjep0 value " << cjep0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vdep : ] 0, 10 ]
  if ( (!((vdep >0 && vdep <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdep value " << vdep << " out of range ] 0, 10 ]";
  }

//    Parameter zep : ] 0, 1 [
  if ( (!((zep >0 && zep <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zep value " << zep << " out of range ] 0, 1 [";
  }

//    Parameter ajep : [ 1,  (+inf) [
  if ( (!((ajep >=1))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ajep value " << ajep << " out of range [ 1,  (+inf) [";
  }

//    Parameter cjci0 : [ 0,  (+inf) [
  if ( (!((cjci0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjci0 value " << cjci0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vdci : ] 0, 10 ]
  if ( (!((vdci >0 && vdci <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdci value " << vdci << " out of range ] 0, 10 ]";
  }

//    Parameter zci : ] 0, 1 [
  if ( (!((zci >0 && zci <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zci value " << zci << " out of range ] 0, 1 [";
  }

//    Parameter vptci : ] 0, 100 ]
  if ( (!((vptci >0 && vptci <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vptci value " << vptci << " out of range ] 0, 100 ]";
  }

//    Parameter cjcx0 : [ 0,  (+inf) [
  if ( (!((cjcx0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjcx0 value " << cjcx0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vdcx : ] 0, 10 ]
  if ( (!((vdcx >0 && vdcx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdcx value " << vdcx << " out of range ] 0, 10 ]";
  }

//    Parameter zcx : ] 0, 1 [
  if ( (!((zcx >0 && zcx <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zcx value " << zcx << " out of range ] 0, 1 [";
  }

//    Parameter vptcx : ] 0, 100 ]
  if ( (!((vptcx >0 && vptcx <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vptcx value " << vptcx << " out of range ] 0, 100 ]";
  }

//    Parameter fbcpar : [ 0, 1 ]
  if ( (!((fbcpar >=0 && fbcpar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fbcpar value " << fbcpar << " out of range [ 0, 1 ]";
  }

//    Parameter fbepar : [ 0, 1 ]
  if ( (!((fbepar >=0 && fbepar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fbepar value " << fbepar << " out of range [ 0, 1 ]";
  }

//    Parameter cjs0 : [ 0,  (+inf) [
  if ( (!((cjs0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cjs0 value " << cjs0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vds : ] 0, 10 ]
  if ( (!((vds >0 && vds <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vds value " << vds << " out of range ] 0, 10 ]";
  }

//    Parameter zs : ] 0, 1 [
  if ( (!((zs >0 && zs <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zs value " << zs << " out of range ] 0, 1 [";
  }

//    Parameter vpts : ] 0, 100 ]
  if ( (!((vpts >0 && vpts <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vpts value " << vpts << " out of range ] 0, 100 ]";
  }

//    Parameter cscp0 : [ 0,  (+inf) [
  if ( (!((cscp0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cscp0 value " << cscp0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vdsp : [ 0, 10 ]
  if ( (!((vdsp >=0 && vdsp <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vdsp value " << vdsp << " out of range [ 0, 10 ]";
  }

//    Parameter zsp : ] 0, 1 [
  if ( (!((zsp >0 && zsp <1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zsp value " << zsp << " out of range ] 0, 1 [";
  }

//    Parameter vptsp : ] 0, 100 ]
  if ( (!((vptsp >0 && vptsp <=100 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vptsp value " << vptsp << " out of range ] 0, 100 ]";
  }

//    Parameter t0 : [ 0,  (+inf) [
  if ( (!((t0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter t0 value " << t0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter dt0h :  ] (-inf)  (+inf) [

//    Parameter tbvl :  ] (-inf)  (+inf) [

//    Parameter tef0 : [ 0,  (+inf) [
  if ( (!((tef0 >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tef0 value " << tef0 << " out of range [ 0,  (+inf) [";
  }

//    Parameter gtfe : ] 0, 10 ]
  if ( (!((gtfe >0 && gtfe <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter gtfe value " << gtfe << " out of range ] 0, 10 ]";
  }

//    Parameter thcs : [ 0,  (+inf) [
  if ( (!((thcs >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter thcs value " << thcs << " out of range [ 0,  (+inf) [";
  }

//    Parameter ahc : ] 0, 50 ]
  if ( (!((ahc >0 && ahc <=50 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter ahc value " << ahc << " out of range ] 0, 50 ]";
  }

//    Parameter fthc : [ 0, 1 ]
  if ( (!((fthc >=0 && fthc <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter fthc value " << fthc << " out of range [ 0, 1 ]";
  }

//    Parameter rci0 : ] 0,  (+inf) [
  if ( (!((rci0 >0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rci0 value " << rci0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter vlim : ] 0, 10 ]
  if ( (!((vlim >0 && vlim <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vlim value " << vlim << " out of range ] 0, 10 ]";
  }

//    Parameter vces : [ 0, 1 ]
  if ( (!((vces >=0 && vces <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vces value " << vces << " out of range [ 0, 1 ]";
  }

//    Parameter vpt : ] 0,  (+inf) [
  if ( (!((vpt >0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vpt value " << vpt << " out of range ] 0,  (+inf) [";
  }

//    Parameter aick : ] 0, 10 ]
  if ( (!((aick >0 && aick <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter aick value " << aick << " out of range ] 0, 10 ]";
  }

//    Parameter delck : ] 0, 10 ]
  if ( (!((delck >0 && delck <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter delck value " << delck << " out of range ] 0, 10 ]";
  }

//    Parameter tr : [ 0,  (+inf) [
  if ( (!((tr >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter tr value " << tr << " out of range [ 0,  (+inf) [";
  }

//    Parameter vcbar : [ 0, 1 ]
  if ( (!((vcbar >=0 && vcbar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vcbar value " << vcbar << " out of range [ 0, 1 ]";
  }

//    Parameter icbar : [ 0, 1 ]
  if ( (!((icbar >=0 && icbar <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter icbar value " << icbar << " out of range [ 0, 1 ]";
  }

//    Parameter acbar : ] 0, 10 ]
  if ( (!((acbar >0 && acbar <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter acbar value " << acbar << " out of range ] 0, 10 ]";
  }

//    Parameter cbepar : [ 0,  (+inf) [
  if ( (!((cbepar >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cbepar value " << cbepar << " out of range [ 0,  (+inf) [";
  }

//    Parameter cbcpar : [ 0,  (+inf) [
  if ( (!((cbcpar >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cbcpar value " << cbcpar << " out of range [ 0,  (+inf) [";
  }

//    Parameter alqf : [ 0, 1 ]
  if ( (!((alqf >=0 && alqf <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter alqf value " << alqf << " out of range [ 0, 1 ]";
  }

//    Parameter alit : [ 0, 1 ]
  if ( (!((alit >=0 && alit <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter alit value " << alit << " out of range [ 0, 1 ]";
  }

//    Parameter flnqs : [ 0, 1 ]
  if ( (!((flnqs >=0 && flnqs <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flnqs value " << flnqs << " out of range [ 0, 1 ]";
  }

//    Parameter kf : [ 0,  (+inf) [
  if ( (!((kf >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter kf value " << kf << " out of range [ 0,  (+inf) [";
  }

//    Parameter af : ] 0, 10 ]
  if ( (!((af >0 && af <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter af value " << af << " out of range ] 0, 10 ]";
  }

//    Parameter cfbe : [ (-2), (-1) ]
  if ( (!((cfbe >=(-2) && cfbe <=(-1) ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cfbe value " << cfbe << " out of range [ (-2), (-1) ]";
  }

//    Parameter flcono : [ 0, 1 ]
  if ( (!((flcono >=0 && flcono <=1 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flcono value " << flcono << " out of range [ 0, 1 ]";
  }

//    Parameter kfre : [ 0,  (+inf) [
  if ( (!((kfre >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter kfre value " << kfre << " out of range [ 0,  (+inf) [";
  }

//    Parameter afre : ] 0, 10 ]
  if ( (!((afre >0 && afre <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter afre value " << afre << " out of range ] 0, 10 ]";
  }

//    Parameter latb : [ 0,  (+inf) [
  if ( (!((latb >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter latb value " << latb << " out of range [ 0,  (+inf) [";
  }

//    Parameter latl : [ 0,  (+inf) [
  if ( (!((latl >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter latl value " << latl << " out of range [ 0,  (+inf) [";
  }

//    Parameter vgb : ] 0, 10 ]
  if ( (!((vgb >0 && vgb <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vgb value " << vgb << " out of range ] 0, 10 ]";
  }

//    Parameter zetaci : [ (-10), 10 ]
  if ( (!((zetaci >=(-10) && zetaci <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetaci value " << zetaci << " out of range [ (-10), 10 ]";
  }

//    Parameter zetarbi : [ (-10), 10 ]
  if ( (!((zetarbi >=(-10) && zetarbi <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarbi value " << zetarbi << " out of range [ (-10), 10 ]";
  }

//    Parameter zetarbx : [ (-10), 10 ]
  if ( (!((zetarbx >=(-10) && zetarbx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarbx value " << zetarbx << " out of range [ (-10), 10 ]";
  }

//    Parameter zetarcx : [ (-10), 10 ]
  if ( (!((zetarcx >=(-10) && zetarcx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarcx value " << zetarcx << " out of range [ (-10), 10 ]";
  }

//    Parameter zetare : [ (-10), 10 ]
  if ( (!((zetare >=(-10) && zetare <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetare value " << zetare << " out of range [ (-10), 10 ]";
  }

//    Parameter zetacx : [ (-10), 10 ]
  if ( (!((zetacx >=(-10) && zetacx <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetacx value " << zetacx << " out of range [ (-10), 10 ]";
  }

//    Parameter vge : ] 0, 10 ]
  if ( (!((vge >0 && vge <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vge value " << vge << " out of range ] 0, 10 ]";
  }

//    Parameter vgc : ] 0, 10 ]
  if ( (!((vgc >0 && vgc <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vgc value " << vgc << " out of range ] 0, 10 ]";
  }

//    Parameter vgs : ] 0, 10 ]
  if ( (!((vgs >0 && vgs <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter vgs value " << vgs << " out of range ] 0, 10 ]";
  }

//    Parameter zetact : [ (-10), 10 ]
  if ( (!((zetact >=(-10) && zetact <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetact value " << zetact << " out of range [ (-10), 10 ]";
  }

//    Parameter zetabet : [ (-10), 10 ]
  if ( (!((zetabet >=(-10) && zetabet <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetabet value " << zetabet << " out of range [ (-10), 10 ]";
  }

//    Parameter dvgbe : [ (-10), 10 ]
  if ( (!((dvgbe >=(-10) && dvgbe <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter dvgbe value " << dvgbe << " out of range [ (-10), 10 ]";
  }

//    Parameter zetahjei : [ (-10), 10 ]
  if ( (!((zetahjei >=(-10) && zetahjei <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetahjei value " << zetahjei << " out of range [ (-10), 10 ]";
  }

//    Parameter zetavgbe : [ (-10), 10 ]
  if ( (!((zetavgbe >=(-10) && zetavgbe <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetavgbe value " << zetavgbe << " out of range [ (-10), 10 ]";
  }

//    Parameter flsh : [ 0, 2 ]
  if ( (!((flsh >=0 && flsh <=2 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flsh value " << flsh << " out of range [ 0, 2 ]";
  }

//    Parameter rth : [ 0,  (+inf) [
  if ( (!((rth >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter rth value " << rth << " out of range [ 0,  (+inf) [";
  }

//    Parameter zetarth : [ (-10), 10 ]
  if ( (!((zetarth >=(-10) && zetarth <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter zetarth value " << zetarth << " out of range [ (-10), 10 ]";
  }

//    Parameter alrth : [ (-10), 10 ]
  if ( (!((alrth >=(-10) && alrth <=10 ))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter alrth value " << alrth << " out of range [ (-10), 10 ]";
  }

//    Parameter cth : [ 0,  (+inf) [
  if ( (!((cth >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter cth value " << cth << " out of range [ 0,  (+inf) [";
  }

//    Parameter flcomp : [ 0,  (+inf) [
  if ( (!((flcomp >=0))) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter flcomp value " << flcomp << " out of range [ 0,  (+inf) [";
  }

//    Parameter type : [ (-1), 1 ]] 0, 0 [
  if ( (!((type >=(-1) && type <=1 )) || (type >0 && type <0 )) )
  {
    UserWarning(*this) << "ADMShicumL2va: Parameter type value " << type << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    c10(2.0E-30),
    qp0(2.0E-14),
    ich(0.0),
    hf0(1.0),
    hfe(1.0),
    hfc(1.0),
    hjei(1.0),
    ahjei(0.0),
    rhjei(1.0),
    hjci(1.0),
    ibeis(1.0E-18),
    mbei(1.0),
    ireis(0.0),
    mrei(2.0),
    ibeps(0.0),
    mbep(1.0),
    ireps(0.0),
    mrep(2.0),
    mcf(1.0),
    tbhrec(0.0),
    ibcis(1.0E-16),
    mbci(1.0),
    ibcxs(0.0),
    mbcx(1.0),
    ibets(0.0),
    abet(40),
    tunode(1),
    favl(0.0),
    qavl(0.0),
    kavl(0.0),
    alfav(0.0),
    alqav(0.0),
    alkav(0.0),
    rbi0(0.0),
    rbx(0.0),
    fgeo(0.6557),
    fdqr0(0.0),
    fcrbi(0.0),
    fqi(1.0),
    re(0.0),
    rcx(0.0),
    itss(0.0),
    msf(1.0),
    iscs(0.0),
    msc(1.0),
    tsf(0.0),
    rsu(0.0),
    csu(0.0),
    cjei0(1.0E-20),
    vdei(0.9),
    zei(0.5),
    ajei(2.5),
    cjep0(1.0E-20),
    vdep(0.9),
    zep(0.5),
    ajep(2.5),
    cjci0(1.0E-20),
    vdci(0.7),
    zci(0.4),
    vptci(100),
    cjcx0(1.0E-20),
    vdcx(0.7),
    zcx(0.4),
    vptcx(100),
    fbcpar(0.0),
    fbepar(1.0),
    cjs0(0.0),
    vds(0.6),
    zs(0.5),
    vpts(100),
    cscp0(0.0),
    vdsp(0.6),
    zsp(0.5),
    vptsp(100),
    t0(0.0),
    dt0h(0.0),
    tbvl(0.0),
    tef0(0.0),
    gtfe(1.0),
    thcs(0.0),
    ahc(0.1),
    fthc(0.0),
    rci0(150),
    vlim(0.5),
    vces(0.1),
    vpt(100.0),
    aick(1e-3),
    delck(2.0),
    tr(0.0),
    vcbar(0.0),
    icbar(0.0),
    acbar(0.01),
    cbepar(0.0),
    cbcpar(0.0),
    alqf(0.167),
    alit(0.333),
    flnqs(0),
    kf(0.0),
    af(2.0),
    cfbe((-1)),
    flcono(0),
    kfre(0.0),
    afre(2.0),
    latb(0.0),
    latl(0.0),
    vgb(1.17),
    alt0(0.0),
    kt0(0.0),
    zetaci(0.0),
    alvs(0.0),
    alces(0.0),
    zetarbi(0.0),
    zetarbx(0.0),
    zetarcx(0.0),
    zetare(0.0),
    zetacx(1.0),
    vge(1.17),
    vgc(1.17),
    vgs(1.17),
    f1vg((-1.02377e-4)),
    f2vg(4.3215e-4),
    zetact(3.0),
    zetabet(3.5),
    alb(0.0),
    dvgbe(0),
    zetahjei(1),
    zetavgbe(1),
    flsh(0),
    rth(0.0),
    zetarth(0.0),
    alrth(0.0),
    cth(0.0),
    flcomp(0.0),
    tnom(27.0),
    dt(0.0),
    type(1)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("Q") != deviceMap.end() && (levelSet.find(234)!=levelSet.end()))))
{
BJT::registerDevice();

  Config<Traits>::addConfiguration()
    .registerDevice("q", 234)
    .registerModelType("npn", 234)
    .registerModelType("pnp", 234);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  double C_1=0.0;
double d_C_1_dX=0.0;
  double vge_t0=0.0;
double d_vge_t0_dX=0.0;
  double vgb_t0=0.0;
double d_vgb_t0_dX=0.0;
  double k20=0.0;
double d_k20_dX=0.0;
  double k10=0.0;
double d_k10_dX=0.0;
//Begin block initial_instance
{
instanceStruct.d_instanceVar_Tnom_dX = modelStruct.d_modelPar_tnom_dX;
instanceStruct.instanceVar_Tnom = (modelStruct.modelPar_tnom+273.15);
instanceStruct.instanceVar_Tamb = admsTemperature;
instanceStruct.d_instanceVar_vt0_dX = (1.3806503e-23*instanceStruct.d_instanceVar_Tnom_dX/1.6021766208e-19);
instanceStruct.instanceVar_vt0 = ((1.3806503e-23*instanceStruct.instanceVar_Tnom)/1.6021766208e-19);
{
double value_log_0 = log(instanceStruct.instanceVar_Tnom);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_Tnom);
d_k10_dX = ((modelStruct.modelPar_f1vg*instanceStruct.instanceVar_Tnom)*deriv_log_0_d0*(instanceStruct.d_instanceVar_Tnom_dX)+(modelStruct.modelPar_f1vg*instanceStruct.d_instanceVar_Tnom_dX+modelStruct.d_modelPar_f1vg_dX*instanceStruct.instanceVar_Tnom)*value_log_0);
k10 = ((modelStruct.modelPar_f1vg*instanceStruct.instanceVar_Tnom)*value_log_0);
}
d_k20_dX = (modelStruct.modelPar_f2vg*instanceStruct.d_instanceVar_Tnom_dX+modelStruct.d_modelPar_f2vg_dX*instanceStruct.instanceVar_Tnom);
k20 = (modelStruct.modelPar_f2vg*instanceStruct.instanceVar_Tnom);
instanceStruct.d_instanceVar_avs_dX = (modelStruct.modelPar_alvs*instanceStruct.d_instanceVar_Tnom_dX+modelStruct.d_modelPar_alvs_dX*instanceStruct.instanceVar_Tnom);
instanceStruct.instanceVar_avs = (modelStruct.modelPar_alvs*instanceStruct.instanceVar_Tnom);
d_vgb_t0_dX = ((modelStruct.d_modelPar_vgb_dX+d_k10_dX)+d_k20_dX);
vgb_t0 = ((modelStruct.modelPar_vgb+k10)+k20);
d_vge_t0_dX = ((modelStruct.d_modelPar_vge_dX+d_k10_dX)+d_k20_dX);
vge_t0 = ((modelStruct.modelPar_vge+k10)+k20);
instanceStruct.d_instanceVar_vgbe_t0_dX = ((d_vgb_t0_dX+d_vge_t0_dX)/2);
instanceStruct.instanceVar_vgbe_t0 = ((vgb_t0+vge_t0)/2);
instanceStruct.d_instanceVar_vgbe0_dX = ((modelStruct.d_modelPar_vgb_dX+modelStruct.d_modelPar_vge_dX)/2);
instanceStruct.instanceVar_vgbe0 = ((modelStruct.modelPar_vgb+modelStruct.modelPar_vge)/2);
instanceStruct.d_instanceVar_vgbc0_dX = ((modelStruct.d_modelPar_vgb_dX+modelStruct.d_modelPar_vgc_dX)/2);
instanceStruct.instanceVar_vgbc0 = ((modelStruct.modelPar_vgb+modelStruct.modelPar_vgc)/2);
instanceStruct.d_instanceVar_vgsc0_dX = ((modelStruct.d_modelPar_vgs_dX+modelStruct.d_modelPar_vgc_dX)/2);
instanceStruct.instanceVar_vgsc0 = ((modelStruct.modelPar_vgs+modelStruct.modelPar_vgc)/2);
instanceStruct.d_instanceVar_mg_dX = (-(1.6021766208e-19*modelStruct.d_modelPar_f1vg_dX/1.3806503e-23));
instanceStruct.instanceVar_mg = (3-((1.6021766208e-19*modelStruct.modelPar_f1vg)/1.3806503e-23));
instanceStruct.d_instanceVar_zetabci_dX = (instanceStruct.d_instanceVar_mg_dX-modelStruct.d_modelPar_zetaci_dX);
instanceStruct.instanceVar_zetabci = ((instanceStruct.instanceVar_mg+1)-modelStruct.modelPar_zetaci);
instanceStruct.d_instanceVar_zetabcxt_dX = (instanceStruct.d_instanceVar_mg_dX-modelStruct.d_modelPar_zetacx_dX);
instanceStruct.instanceVar_zetabcxt = ((instanceStruct.instanceVar_mg+1)-modelStruct.modelPar_zetacx);
instanceStruct.d_instanceVar_zetasct_dX = instanceStruct.d_instanceVar_mg_dX;
instanceStruct.instanceVar_zetasct = (instanceStruct.instanceVar_mg-1.5);
d_C_1_dX = ((1.0-modelStruct.modelPar_fbcpar)*(modelStruct.d_modelPar_cjcx0_dX+modelStruct.d_modelPar_cbcpar_dX)+(-modelStruct.d_modelPar_fbcpar_dX)*(modelStruct.modelPar_cjcx0+modelStruct.modelPar_cbcpar));
C_1 = ((1.0-modelStruct.modelPar_fbcpar)*(modelStruct.modelPar_cjcx0+modelStruct.modelPar_cbcpar));
if ((C_1>=modelStruct.modelPar_cbcpar))
{
instanceStruct.d_instanceVar_cbcpar1_dX = modelStruct.d_modelPar_cbcpar_dX;
instanceStruct.instanceVar_cbcpar1 = modelStruct.modelPar_cbcpar;
instanceStruct.d_instanceVar_cbcpar2_dX = 0.0;
instanceStruct.instanceVar_cbcpar2 = 0.0;
instanceStruct.d_instanceVar_cjcx01_dX = (d_C_1_dX-modelStruct.d_modelPar_cbcpar_dX);
instanceStruct.instanceVar_cjcx01 = (C_1-modelStruct.modelPar_cbcpar);
instanceStruct.d_instanceVar_cjcx02_dX = (modelStruct.d_modelPar_cjcx0_dX-instanceStruct.d_instanceVar_cjcx01_dX);
instanceStruct.instanceVar_cjcx02 = (modelStruct.modelPar_cjcx0-instanceStruct.instanceVar_cjcx01);
}
else
{
instanceStruct.d_instanceVar_cbcpar1_dX = d_C_1_dX;
instanceStruct.instanceVar_cbcpar1 = C_1;
instanceStruct.d_instanceVar_cbcpar2_dX = (modelStruct.d_modelPar_cbcpar_dX-instanceStruct.d_instanceVar_cbcpar1_dX);
instanceStruct.instanceVar_cbcpar2 = (modelStruct.modelPar_cbcpar-instanceStruct.instanceVar_cbcpar1);
instanceStruct.d_instanceVar_cjcx01_dX = 0.0;
instanceStruct.instanceVar_cjcx01 = 0.0;
instanceStruct.d_instanceVar_cjcx02_dX = modelStruct.d_modelPar_cjcx0_dX;
instanceStruct.instanceVar_cjcx02 = modelStruct.modelPar_cjcx0;
}
instanceStruct.d_instanceVar_cbepar2_dX = (modelStruct.modelPar_fbepar*modelStruct.d_modelPar_cbepar_dX+modelStruct.d_modelPar_fbepar_dX*modelStruct.modelPar_cbepar);
instanceStruct.instanceVar_cbepar2 = (modelStruct.modelPar_fbepar*modelStruct.modelPar_cbepar);
instanceStruct.d_instanceVar_cbepar1_dX = (modelStruct.d_modelPar_cbepar_dX-instanceStruct.d_instanceVar_cbepar2_dX);
instanceStruct.instanceVar_cbepar1 = (modelStruct.modelPar_cbepar-instanceStruct.instanceVar_cbepar2);
if ((modelStruct.modelPar_ich!=0.0))
{
instanceStruct.d_instanceVar_Oich_dX = (-modelStruct.d_modelPar_ich_dX/modelStruct.modelPar_ich/modelStruct.modelPar_ich);
instanceStruct.instanceVar_Oich = (1.0/modelStruct.modelPar_ich);
}
else
{
instanceStruct.d_instanceVar_Oich_dX = 0.0;
instanceStruct.instanceVar_Oich = 0.0;
}
if ((modelStruct.modelPar_tbhrec!=0.0))
{
instanceStruct.d_instanceVar_Otbhrec_dX = (-modelStruct.d_modelPar_tbhrec_dX/modelStruct.modelPar_tbhrec/modelStruct.modelPar_tbhrec);
instanceStruct.instanceVar_Otbhrec = (1.0/modelStruct.modelPar_tbhrec);
}
else
{
instanceStruct.d_instanceVar_Otbhrec_dX = 0.0;
instanceStruct.instanceVar_Otbhrec = 0.0;
}
if (((modelStruct.modelPar_favl>0.0)&&(modelStruct.modelPar_cjci0>0.0)))
{
instanceStruct.instanceVar_use_aval = 1;
}
else
{
instanceStruct.instanceVar_use_aval = 0;
instanceStruct.d_instanceVar_iavl_dX = 0.0;
instanceStruct.instanceVar_iavl = 0.0;
}
if (((modelStruct.modelPar_flsh==0)||(modelStruct.modelPar_rth<0.001)))
//Begin block Thermal_updat_without_self_heating
{
instanceStruct.d_instanceVar_Tdev_dX = modelStruct.d_modelPar_dt_dX;
instanceStruct.instanceVar_Tdev = (instanceStruct.instanceVar_Tamb+modelStruct.modelPar_dt);
if ((instanceStruct.instanceVar_Tdev<((-100.0)+273.15)))
{
instanceStruct.d_instanceVar_Tdev_dX = 0.0;
instanceStruct.instanceVar_Tdev = ((-100.0)+273.15);
}
else
{
if ((instanceStruct.instanceVar_Tdev>(326.85+273.15)))
{
instanceStruct.d_instanceVar_Tdev_dX = 0.0;
instanceStruct.instanceVar_Tdev = (326.85+273.15);
}
}
instanceStruct.d_instanceVar_VT_dX = (1.3806503e-23*instanceStruct.d_instanceVar_Tdev_dX/1.6021766208e-19);
instanceStruct.instanceVar_VT = ((1.3806503e-23*instanceStruct.instanceVar_Tdev)/1.6021766208e-19);
instanceStruct.d_instanceVar_dT_dX = (instanceStruct.d_instanceVar_Tdev_dX-instanceStruct.d_instanceVar_Tnom_dX);
instanceStruct.instanceVar_dT = (instanceStruct.instanceVar_Tdev-instanceStruct.instanceVar_Tnom);
instanceStruct.d_instanceVar_qtt0_dX = ((instanceStruct.instanceVar_Tnom*instanceStruct.d_instanceVar_Tdev_dX-instanceStruct.instanceVar_Tdev*instanceStruct.d_instanceVar_Tnom_dX)/instanceStruct.instanceVar_Tnom/instanceStruct.instanceVar_Tnom);
instanceStruct.instanceVar_qtt0 = (instanceStruct.instanceVar_Tdev/instanceStruct.instanceVar_Tnom);
{
double value_log_0 = log(instanceStruct.instanceVar_qtt0);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_qtt0);
instanceStruct.d_instanceVar_ln_qtt0_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_qtt0_dX);
instanceStruct.instanceVar_ln_qtt0 = value_log_0;
}
{
double value_log_0 = log(instanceStruct.instanceVar_Tdev);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_Tdev);
instanceStruct.d_instanceVar_k1_dX = ((modelStruct.modelPar_f1vg*instanceStruct.instanceVar_Tdev)*deriv_log_0_d0*(instanceStruct.d_instanceVar_Tdev_dX)+(modelStruct.modelPar_f1vg*instanceStruct.d_instanceVar_Tdev_dX+modelStruct.d_modelPar_f1vg_dX*instanceStruct.instanceVar_Tdev)*value_log_0);
instanceStruct.instanceVar_k1 = ((modelStruct.modelPar_f1vg*instanceStruct.instanceVar_Tdev)*value_log_0);
}
instanceStruct.d_instanceVar_k2_dX = (modelStruct.modelPar_f2vg*instanceStruct.d_instanceVar_Tdev_dX+modelStruct.d_modelPar_f2vg_dX*instanceStruct.instanceVar_Tdev);
instanceStruct.instanceVar_k2 = (modelStruct.modelPar_f2vg*instanceStruct.instanceVar_Tdev);
instanceStruct.d_instanceVar_vgb_t_dX = ((modelStruct.d_modelPar_vgb_dX+instanceStruct.d_instanceVar_k1_dX)+instanceStruct.d_instanceVar_k2_dX);
instanceStruct.instanceVar_vgb_t = ((modelStruct.modelPar_vgb+instanceStruct.instanceVar_k1)+instanceStruct.instanceVar_k2);
instanceStruct.d_instanceVar_vge_t_dX = ((modelStruct.d_modelPar_vge_dX+instanceStruct.d_instanceVar_k1_dX)+instanceStruct.d_instanceVar_k2_dX);
instanceStruct.instanceVar_vge_t = ((modelStruct.modelPar_vge+instanceStruct.instanceVar_k1)+instanceStruct.instanceVar_k2);
instanceStruct.d_instanceVar_vgbe_t_dX = ((instanceStruct.d_instanceVar_vgb_t_dX+instanceStruct.d_instanceVar_vge_t_dX)/2);
instanceStruct.instanceVar_vgbe_t = ((instanceStruct.instanceVar_vgb_t+instanceStruct.instanceVar_vge_t)/2);
if ((modelStruct.modelPar_cjei0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdei*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdei)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdei_dX*0.5-(modelStruct.modelPar_vdei*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdei_dX-((-0.5)*modelStruct.modelPar_vdei)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbe0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdei_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdei_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t));
double value_exp_1 = exp((modelStruct.modelPar_zei*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjei0_t_dX = (modelStruct.modelPar_cjei0*deriv_exp_1_d0*((modelStruct.modelPar_zei*deriv_log_0_d0*(((instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX-modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX)/instanceStruct.instanceVar_vdei_t/instanceStruct.instanceVar_vdei_t))+modelStruct.d_modelPar_zei_dX*value_log_0))+modelStruct.d_modelPar_cjei0_dX*value_exp_1);
instanceStruct.instanceVar_cjei0_t = (modelStruct.modelPar_cjei0*value_exp_1);
}
if ((1==1))
{
instanceStruct.d_instanceVar_ajei_t_dX = ((modelStruct.modelPar_vdei*(modelStruct.modelPar_ajei*instanceStruct.d_instanceVar_vdei_t_dX+modelStruct.d_modelPar_ajei_dX*instanceStruct.instanceVar_vdei_t)-(modelStruct.modelPar_ajei*instanceStruct.instanceVar_vdei_t)*modelStruct.d_modelPar_vdei_dX)/modelStruct.modelPar_vdei/modelStruct.modelPar_vdei);
instanceStruct.instanceVar_ajei_t = ((modelStruct.modelPar_ajei*instanceStruct.instanceVar_vdei_t)/modelStruct.modelPar_vdei);
}
else
{
instanceStruct.d_instanceVar_ajei_t_dX = modelStruct.d_modelPar_ajei_dX;
instanceStruct.instanceVar_ajei_t = modelStruct.modelPar_ajei;
}
}
else
{
instanceStruct.d_instanceVar_cjei0_t_dX = modelStruct.d_modelPar_cjei0_dX;
instanceStruct.instanceVar_cjei0_t = modelStruct.modelPar_cjei0;
instanceStruct.d_instanceVar_vdei_t_dX = modelStruct.d_modelPar_vdei_dX;
instanceStruct.instanceVar_vdei_t = modelStruct.modelPar_vdei;
instanceStruct.d_instanceVar_ajei_t_dX = modelStruct.d_modelPar_ajei_dX;
instanceStruct.instanceVar_ajei_t = modelStruct.modelPar_ajei;
}
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
instanceStruct.d_instanceVar_V_gT_dX = (((3.0*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+3.0*instanceStruct.d_instanceVar_VT_dX*instanceStruct.instanceVar_ln_qtt0)+(modelStruct.modelPar_vgb*instanceStruct.d_instanceVar_qtt0_dX+modelStruct.d_modelPar_vgb_dX*(instanceStruct.instanceVar_qtt0-1.0)));
instanceStruct.instanceVar_V_gT = (((3.0*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0)+(modelStruct.modelPar_vgb*(instanceStruct.instanceVar_qtt0-1.0)));
instanceStruct.d_instanceVar_r_VgVT_dX = ((instanceStruct.instanceVar_VT*instanceStruct.d_instanceVar_V_gT_dX-instanceStruct.instanceVar_V_gT*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
instanceStruct.instanceVar_r_VgVT = (instanceStruct.instanceVar_V_gT/instanceStruct.instanceVar_VT);
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mbei*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mbei_dX)/modelStruct.modelPar_mbei/modelStruct.modelPar_mbei)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mbei)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeis_t_dX = (modelStruct.modelPar_ibeis*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibeis_dX*value_exp_0);
instanceStruct.instanceVar_ibeis_t = (modelStruct.modelPar_ibeis*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mrei*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mrei_dX)/modelStruct.modelPar_mrei/modelStruct.modelPar_mrei)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mrei)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireis_t_dX = (modelStruct.modelPar_ireis*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ireis_dX*value_exp_0);
instanceStruct.instanceVar_ireis_t = (modelStruct.modelPar_ireis*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mbep*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mbep_dX)/modelStruct.modelPar_mbep/modelStruct.modelPar_mbep)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mbep)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeps_t_dX = (modelStruct.modelPar_ibeps*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibeps_dX*value_exp_0);
instanceStruct.instanceVar_ibeps_t = (modelStruct.modelPar_ibeps*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mrep*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mrep_dX)/modelStruct.modelPar_mrep/modelStruct.modelPar_mrep)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mrep)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireps_t_dX = (modelStruct.modelPar_ireps*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ireps_dX*value_exp_0);
instanceStruct.instanceVar_ireps_t = (modelStruct.modelPar_ireps*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_mbci*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_mbci_dX)/modelStruct.modelPar_mbci/modelStruct.modelPar_mbci);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_mbci);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcis_t_dX = (modelStruct.modelPar_ibcis*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibcis_dX*value_exp_0);
instanceStruct.instanceVar_ibcis_t = (modelStruct.modelPar_ibcis*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_mbcx*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_mbcx_dX)/modelStruct.modelPar_mbcx/modelStruct.modelPar_mbcx);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_mbcx);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcxs_t_dX = (modelStruct.modelPar_ibcxs*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibcxs_dX*value_exp_0);
instanceStruct.instanceVar_ibcxs_t = (modelStruct.modelPar_ibcxs*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_msf*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_msf_dX)/modelStruct.modelPar_msf/modelStruct.modelPar_msf);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_msf);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_itss_t_dX = (modelStruct.modelPar_itss*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_itss_dX*value_exp_0);
instanceStruct.instanceVar_itss_t = (modelStruct.modelPar_itss*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_msc*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_msc_dX)/modelStruct.modelPar_msc/modelStruct.modelPar_msc);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_msc);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_iscs_t_dX = (modelStruct.modelPar_iscs*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_iscs_dX*value_exp_0);
instanceStruct.instanceVar_iscs_t = (modelStruct.modelPar_iscs*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX-instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX)/modelStruct.modelPar_vdei/modelStruct.modelPar_vdei);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_vdei_t/modelStruct.modelPar_vdei);
instanceStruct.d_instanceVar_qp0_t_dX = (modelStruct.modelPar_qp0*((0.5*modelStruct.modelPar_zei)*(-instanceStruct.d_instanceVar_a_dX)+0.5*modelStruct.d_modelPar_zei_dX*(1.0-instanceStruct.instanceVar_a))+modelStruct.d_modelPar_qp0_dX*(1.0+((0.5*modelStruct.modelPar_zei)*(1.0-instanceStruct.instanceVar_a))));
instanceStruct.instanceVar_qp0_t = (modelStruct.modelPar_qp0*(1.0+((0.5*modelStruct.modelPar_zei)*(1.0-instanceStruct.instanceVar_a))));
{
double value_exp_0 = exp((modelStruct.modelPar_zetaci*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_vlim*(1.0-(modelStruct.modelPar_alvs*instanceStruct.instanceVar_dT)))*deriv_exp_0_d0*((modelStruct.modelPar_zetaci*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetaci_dX*instanceStruct.instanceVar_ln_qtt0))+(modelStruct.modelPar_vlim*(-(modelStruct.modelPar_alvs*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alvs_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_vlim_dX*(1.0-(modelStruct.modelPar_alvs*instanceStruct.instanceVar_dT)))*value_exp_0);
instanceStruct.instanceVar_a = ((modelStruct.modelPar_vlim*(1.0-(modelStruct.modelPar_alvs*instanceStruct.instanceVar_dT)))*value_exp_0);
}
instanceStruct.d_instanceVar_k_dX = ((instanceStruct.instanceVar_VT*(instanceStruct.d_instanceVar_a_dX-instanceStruct.d_instanceVar_VT_dX)-(instanceStruct.instanceVar_a-instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
instanceStruct.instanceVar_k = ((instanceStruct.instanceVar_a-instanceStruct.instanceVar_VT)/instanceStruct.instanceVar_VT);
if ((instanceStruct.instanceVar_k<11.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_k);
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_vlim_t_dX = (instanceStruct.d_instanceVar_VT_dX+(instanceStruct.instanceVar_VT*deriv_log_1_d0*(deriv_exp_0_d0*(instanceStruct.d_instanceVar_k_dX))+instanceStruct.d_instanceVar_VT_dX*value_log_1));
instanceStruct.instanceVar_vlim_t = (instanceStruct.instanceVar_VT+(instanceStruct.instanceVar_VT*value_log_1));
}
}
else
{
instanceStruct.d_instanceVar_vlim_t_dX = instanceStruct.d_instanceVar_a_dX;
instanceStruct.instanceVar_vlim_t = instanceStruct.instanceVar_a;
}
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT);
instanceStruct.instanceVar_a = (1.0+(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_a*instanceStruct.instanceVar_a)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_k_dX = 0.5*(instanceStruct.d_instanceVar_a_dX+deriv_sqrt_0_d0*((instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX+instanceStruct.d_instanceVar_a_dX*instanceStruct.instanceVar_a)));
instanceStruct.instanceVar_k = (0.5*(instanceStruct.instanceVar_a+value_sqrt_0));
}
instanceStruct.d_instanceVar_tef0_t_dX = ((instanceStruct.instanceVar_k*(modelStruct.modelPar_tef0*instanceStruct.d_instanceVar_qtt0_dX+modelStruct.d_modelPar_tef0_dX*instanceStruct.instanceVar_qtt0)-(modelStruct.modelPar_tef0*instanceStruct.instanceVar_qtt0)*instanceStruct.d_instanceVar_k_dX)/instanceStruct.instanceVar_k/instanceStruct.instanceVar_k);
instanceStruct.instanceVar_tef0_t = ((modelStruct.modelPar_tef0*instanceStruct.instanceVar_qtt0)/instanceStruct.instanceVar_k);
}
else
{
{
double value_exp_0 = exp(((modelStruct.modelPar_zetabet*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeis_t_dX = (modelStruct.modelPar_ibeis*deriv_exp_0_d0*(((modelStruct.modelPar_zetabet*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetabet_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vge_dX-modelStruct.modelPar_vge*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibeis_dX*value_exp_0);
instanceStruct.instanceVar_ibeis_t = (modelStruct.modelPar_ibeis*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
{
double value_exp_0 = exp((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrei)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireis_t_dX = (modelStruct.modelPar_ireis*deriv_exp_0_d0*((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrei)*instanceStruct.d_instanceVar_ln_qtt0_dX+((modelStruct.modelPar_mrei*instanceStruct.d_instanceVar_mg_dX-instanceStruct.instanceVar_mg*modelStruct.d_modelPar_mrei_dX)/modelStruct.modelPar_mrei/modelStruct.modelPar_mrei)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT))*instanceStruct.d_instanceVar_qtt0_dX+(((modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_vgbe0_dX-instanceStruct.instanceVar_vgbe0*(modelStruct.modelPar_mrei*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mrei_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireis_dX*value_exp_0);
instanceStruct.instanceVar_ireis_t = (modelStruct.modelPar_ireis*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireis_t_dX = (modelStruct.modelPar_ireis*deriv_exp_0_d0*((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.d_instanceVar_ln_qtt0_dX+0.5*instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*0.5*instanceStruct.d_instanceVar_vgbe0_dX-(0.5*instanceStruct.instanceVar_vgbe0)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireis_dX*value_exp_0);
instanceStruct.instanceVar_ireis_t = (modelStruct.modelPar_ireis*value_exp_0);
}
}
{
double value_exp_0 = exp(((modelStruct.modelPar_zetabet*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeps_t_dX = (modelStruct.modelPar_ibeps*deriv_exp_0_d0*(((modelStruct.modelPar_zetabet*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetabet_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vge_dX-modelStruct.modelPar_vge*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibeps_dX*value_exp_0);
instanceStruct.instanceVar_ibeps_t = (modelStruct.modelPar_ibeps*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
{
double value_exp_0 = exp((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrep)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireps_t_dX = (modelStruct.modelPar_ireps*deriv_exp_0_d0*((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrep)*instanceStruct.d_instanceVar_ln_qtt0_dX+((modelStruct.modelPar_mrep*instanceStruct.d_instanceVar_mg_dX-instanceStruct.instanceVar_mg*modelStruct.d_modelPar_mrep_dX)/modelStruct.modelPar_mrep/modelStruct.modelPar_mrep)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT))*instanceStruct.d_instanceVar_qtt0_dX+(((modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_vgbe0_dX-instanceStruct.instanceVar_vgbe0*(modelStruct.modelPar_mrep*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mrep_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireps_dX*value_exp_0);
instanceStruct.instanceVar_ireps_t = (modelStruct.modelPar_ireps*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireps_t_dX = (modelStruct.modelPar_ireps*deriv_exp_0_d0*((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.d_instanceVar_ln_qtt0_dX+0.5*instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*0.5*instanceStruct.d_instanceVar_vgbe0_dX-(0.5*instanceStruct.instanceVar_vgbe0)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireps_dX*value_exp_0);
instanceStruct.instanceVar_ireps_t = (modelStruct.modelPar_ireps*value_exp_0);
}
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetabci*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcis_t_dX = (modelStruct.modelPar_ibcis*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetabci*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetabci_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgc_dX-modelStruct.modelPar_vgc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibcis_dX*value_exp_0);
instanceStruct.instanceVar_ibcis_t = (modelStruct.modelPar_ibcis*value_exp_0);
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetabcxt*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcxs_t_dX = (modelStruct.modelPar_ibcxs*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetabcxt*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetabcxt_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgc_dX-modelStruct.modelPar_vgc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibcxs_dX*value_exp_0);
instanceStruct.instanceVar_ibcxs_t = (modelStruct.modelPar_ibcxs*value_exp_0);
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetasct*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_itss_t_dX = (modelStruct.modelPar_itss*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetasct*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetasct_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgc_dX-modelStruct.modelPar_vgc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_itss_dX*value_exp_0);
instanceStruct.instanceVar_itss_t = (modelStruct.modelPar_itss*value_exp_0);
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetasct*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgs/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_iscs_t_dX = (modelStruct.modelPar_iscs*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetasct*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetasct_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgs/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgs_dX-modelStruct.modelPar_vgs*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_iscs_dX*value_exp_0);
instanceStruct.instanceVar_iscs_t = (modelStruct.modelPar_iscs*value_exp_0);
}
{
double value_log_0 = log((instanceStruct.instanceVar_vdei_t/modelStruct.modelPar_vdei));
double value_exp_1 = exp((modelStruct.modelPar_zei*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_vdei_t/modelStruct.modelPar_vdei));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_a_dX = deriv_exp_1_d0*((modelStruct.modelPar_zei*deriv_log_0_d0*(((modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX-instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX)/modelStruct.modelPar_vdei/modelStruct.modelPar_vdei))+modelStruct.d_modelPar_zei_dX*value_log_0));
instanceStruct.instanceVar_a = value_exp_1;
}
instanceStruct.d_instanceVar_qp0_t_dX = (modelStruct.modelPar_qp0*(-instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_qp0_dX*(2.0-instanceStruct.instanceVar_a));
instanceStruct.instanceVar_qp0_t = (modelStruct.modelPar_qp0*(2.0-instanceStruct.instanceVar_a));
{
double value_exp_0 = exp(((modelStruct.modelPar_zetaci-instanceStruct.instanceVar_avs)*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_vlim_t_dX = (modelStruct.modelPar_vlim*deriv_exp_0_d0*(((modelStruct.modelPar_zetaci-instanceStruct.instanceVar_avs)*instanceStruct.d_instanceVar_ln_qtt0_dX+(modelStruct.d_modelPar_zetaci_dX-instanceStruct.d_instanceVar_avs_dX)*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_vlim_dX*value_exp_0);
instanceStruct.instanceVar_vlim_t = (modelStruct.modelPar_vlim*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
instanceStruct.d_instanceVar_tef0_t_dX = modelStruct.d_modelPar_tef0_dX;
instanceStruct.instanceVar_tef0_t = modelStruct.modelPar_tef0;
}
else
{
instanceStruct.d_instanceVar_zetatef_dX = (modelStruct.d_modelPar_zetabet_dX-modelStruct.d_modelPar_zetact_dX);
instanceStruct.instanceVar_zetatef = ((modelStruct.modelPar_zetabet-modelStruct.modelPar_zetact)-0.5);
instanceStruct.d_instanceVar_dvg0_dX = (modelStruct.d_modelPar_vgb_dX-modelStruct.d_modelPar_vge_dX);
instanceStruct.instanceVar_dvg0 = (modelStruct.modelPar_vgb-modelStruct.modelPar_vge);
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetatef*instanceStruct.instanceVar_ln_qtt0)-((instanceStruct.instanceVar_dvg0/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tef0_t_dX = (modelStruct.modelPar_tef0*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetatef*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetatef_dX*instanceStruct.instanceVar_ln_qtt0)-((instanceStruct.instanceVar_dvg0/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*instanceStruct.d_instanceVar_dvg0_dX-instanceStruct.instanceVar_dvg0*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_tef0_dX*value_exp_0);
instanceStruct.instanceVar_tef0_t = (modelStruct.modelPar_tef0*value_exp_0);
}
}
}
{
double value_exp_0 = exp(((modelStruct.modelPar_zetact*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgb/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_c10_t_dX = (modelStruct.modelPar_c10*deriv_exp_0_d0*(((modelStruct.modelPar_zetact*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetact_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgb/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgb_dX-modelStruct.modelPar_vgb*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_c10_dX*value_exp_0);
instanceStruct.instanceVar_c10_t = (modelStruct.modelPar_c10*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetaci*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rci0_t_dX = (modelStruct.modelPar_rci0*deriv_exp_0_d0*((modelStruct.modelPar_zetaci*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetaci_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rci0_dX*value_exp_0);
instanceStruct.instanceVar_rci0_t = (modelStruct.modelPar_rci0*value_exp_0);
}
instanceStruct.d_instanceVar_vces_t_dX = (modelStruct.modelPar_vces*(modelStruct.modelPar_alces*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alces_dX*instanceStruct.instanceVar_dT)+modelStruct.d_modelPar_vces_dX*(1+(modelStruct.modelPar_alces*instanceStruct.instanceVar_dT)));
instanceStruct.instanceVar_vces_t = (modelStruct.modelPar_vces*(1+(modelStruct.modelPar_alces*instanceStruct.instanceVar_dT)));
if ((modelStruct.modelPar_cjci0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdci*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdci)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdci_dX*0.5-(modelStruct.modelPar_vdci*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdci_dX-((-0.5)*modelStruct.modelPar_vdci)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdci_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdci_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdci/instanceStruct.instanceVar_vdci_t));
double value_exp_1 = exp((modelStruct.modelPar_zci*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdci/instanceStruct.instanceVar_vdci_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjci0_t_dX = (modelStruct.modelPar_cjci0*deriv_exp_1_d0*((modelStruct.modelPar_zci*deriv_log_0_d0*(((instanceStruct.instanceVar_vdci_t*modelStruct.d_modelPar_vdci_dX-modelStruct.modelPar_vdci*instanceStruct.d_instanceVar_vdci_t_dX)/instanceStruct.instanceVar_vdci_t/instanceStruct.instanceVar_vdci_t))+modelStruct.d_modelPar_zci_dX*value_log_0))+modelStruct.d_modelPar_cjci0_dX*value_exp_1);
instanceStruct.instanceVar_cjci0_t = (modelStruct.modelPar_cjci0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vptci_t_dX = ((modelStruct.modelPar_vdci*(modelStruct.modelPar_vptci*instanceStruct.d_instanceVar_vdci_t_dX+modelStruct.d_modelPar_vptci_dX*instanceStruct.instanceVar_vdci_t)-(modelStruct.modelPar_vptci*instanceStruct.instanceVar_vdci_t)*modelStruct.d_modelPar_vdci_dX)/modelStruct.modelPar_vdci/modelStruct.modelPar_vdci);
instanceStruct.instanceVar_vptci_t = ((modelStruct.modelPar_vptci*instanceStruct.instanceVar_vdci_t)/modelStruct.modelPar_vdci);
}
else
{
instanceStruct.d_instanceVar_vptci_t_dX = modelStruct.d_modelPar_vptci_dX;
instanceStruct.instanceVar_vptci_t = modelStruct.modelPar_vptci;
}
}
else
{
instanceStruct.d_instanceVar_cjci0_t_dX = modelStruct.d_modelPar_cjci0_dX;
instanceStruct.instanceVar_cjci0_t = modelStruct.modelPar_cjci0;
instanceStruct.d_instanceVar_vdci_t_dX = modelStruct.d_modelPar_vdci_dX;
instanceStruct.instanceVar_vdci_t = modelStruct.modelPar_vdci;
instanceStruct.d_instanceVar_vptci_t_dX = modelStruct.d_modelPar_vptci_dX;
instanceStruct.instanceVar_vptci_t = modelStruct.modelPar_vptci;
}
instanceStruct.d_instanceVar_t0_t_dX = (modelStruct.modelPar_t0*((modelStruct.modelPar_alt0*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alt0_dX*instanceStruct.instanceVar_dT)+((modelStruct.modelPar_kt0*instanceStruct.instanceVar_dT)*instanceStruct.d_instanceVar_dT_dX+(modelStruct.modelPar_kt0*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_kt0_dX*instanceStruct.instanceVar_dT)*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_t0_dX*((1+(modelStruct.modelPar_alt0*instanceStruct.instanceVar_dT))+((modelStruct.modelPar_kt0*instanceStruct.instanceVar_dT)*instanceStruct.instanceVar_dT)));
instanceStruct.instanceVar_t0_t = (modelStruct.modelPar_t0*((1+(modelStruct.modelPar_alt0*instanceStruct.instanceVar_dT))+((modelStruct.modelPar_kt0*instanceStruct.instanceVar_dT)*instanceStruct.instanceVar_dT)));
{
double value_exp_0 = exp(((modelStruct.modelPar_zetaci-1)*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_thcs_t_dX = (modelStruct.modelPar_thcs*deriv_exp_0_d0*(((modelStruct.modelPar_zetaci-1)*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetaci_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_thcs_dX*value_exp_0);
instanceStruct.instanceVar_thcs_t = (modelStruct.modelPar_thcs*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_alfav*instanceStruct.instanceVar_dT));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_favl_t_dX = (modelStruct.modelPar_favl*deriv_exp_0_d0*((modelStruct.modelPar_alfav*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alfav_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_favl_dX*value_exp_0);
instanceStruct.instanceVar_favl_t = (modelStruct.modelPar_favl*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_alqav*instanceStruct.instanceVar_dT));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_qavl_t_dX = (modelStruct.modelPar_qavl*deriv_exp_0_d0*((modelStruct.modelPar_alqav*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alqav_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_qavl_dX*value_exp_0);
instanceStruct.instanceVar_qavl_t = (modelStruct.modelPar_qavl*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_alkav*instanceStruct.instanceVar_dT));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_kavl_t_dX = (modelStruct.modelPar_kavl*deriv_exp_0_d0*((modelStruct.modelPar_alkav*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alkav_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_kavl_dX*value_exp_0);
instanceStruct.instanceVar_kavl_t = (modelStruct.modelPar_kavl*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetarbi*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rbi0_t_dX = (modelStruct.modelPar_rbi0*deriv_exp_0_d0*((modelStruct.modelPar_zetarbi*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarbi_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rbi0_dX*value_exp_0);
instanceStruct.instanceVar_rbi0_t = (modelStruct.modelPar_rbi0*value_exp_0);
}
if ((modelStruct.modelPar_cjep0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdep*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdep)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdep_dX*0.5-(modelStruct.modelPar_vdep*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdep_dX-((-0.5)*modelStruct.modelPar_vdep)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbe0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdep_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdep_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t));
double value_exp_1 = exp((modelStruct.modelPar_zep*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjep0_t_dX = (modelStruct.modelPar_cjep0*deriv_exp_1_d0*((modelStruct.modelPar_zep*deriv_log_0_d0*(((instanceStruct.instanceVar_vdep_t*modelStruct.d_modelPar_vdep_dX-modelStruct.modelPar_vdep*instanceStruct.d_instanceVar_vdep_t_dX)/instanceStruct.instanceVar_vdep_t/instanceStruct.instanceVar_vdep_t))+modelStruct.d_modelPar_zep_dX*value_log_0))+modelStruct.d_modelPar_cjep0_dX*value_exp_1);
instanceStruct.instanceVar_cjep0_t = (modelStruct.modelPar_cjep0*value_exp_1);
}
if ((1==1))
{
instanceStruct.d_instanceVar_ajep_t_dX = ((modelStruct.modelPar_vdep*(modelStruct.modelPar_ajep*instanceStruct.d_instanceVar_vdep_t_dX+modelStruct.d_modelPar_ajep_dX*instanceStruct.instanceVar_vdep_t)-(modelStruct.modelPar_ajep*instanceStruct.instanceVar_vdep_t)*modelStruct.d_modelPar_vdep_dX)/modelStruct.modelPar_vdep/modelStruct.modelPar_vdep);
instanceStruct.instanceVar_ajep_t = ((modelStruct.modelPar_ajep*instanceStruct.instanceVar_vdep_t)/modelStruct.modelPar_vdep);
}
else
{
instanceStruct.d_instanceVar_ajep_t_dX = modelStruct.d_modelPar_ajep_dX;
instanceStruct.instanceVar_ajep_t = modelStruct.modelPar_ajep;
}
}
else
{
instanceStruct.d_instanceVar_cjep0_t_dX = modelStruct.d_modelPar_cjep0_dX;
instanceStruct.instanceVar_cjep0_t = modelStruct.modelPar_cjep0;
instanceStruct.d_instanceVar_vdep_t_dX = modelStruct.d_modelPar_vdep_dX;
instanceStruct.instanceVar_vdep_t = modelStruct.modelPar_vdep;
instanceStruct.d_instanceVar_ajep_t_dX = modelStruct.d_modelPar_ajep_dX;
instanceStruct.instanceVar_ajep_t = modelStruct.modelPar_ajep;
}
if ((modelStruct.modelPar_ibets>0))
//Begin block HICTUN_T
{
//Block-local variables for block HICTUN_T
double a_eg=0.0;
double d_a_eg_dX=0.0;
double ab=0.0;
double d_ab_dX=0.0;
double aa=0.0;
double d_aa_dX=0.0;
//End of Block-local variables
d_ab_dX = 0.0;
ab = 1.0;
d_aa_dX = 0.0;
aa = 1.0;
d_a_eg_dX = ((instanceStruct.instanceVar_vgbe_t*instanceStruct.d_instanceVar_vgbe_t0_dX-instanceStruct.instanceVar_vgbe_t0*instanceStruct.d_instanceVar_vgbe_t_dX)/instanceStruct.instanceVar_vgbe_t/instanceStruct.instanceVar_vgbe_t);
a_eg = (instanceStruct.instanceVar_vgbe_t0/instanceStruct.instanceVar_vgbe_t);
if ((((modelStruct.modelPar_tunode==1)&&(modelStruct.modelPar_cjep0>0.0))&&(modelStruct.modelPar_vdep>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ab_dX = (((modelStruct.modelPar_vdep*modelStruct.modelPar_vdep)*((((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.d_instanceVar_vdep_t_dX+(((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.d_instanceVar_vdep_t_dX+((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*deriv_sqrt_0_d0*(d_a_eg_dX)+((modelStruct.modelPar_cjep0*instanceStruct.d_instanceVar_cjep0_t_dX-instanceStruct.instanceVar_cjep0_t*modelStruct.d_modelPar_cjep0_dX)/modelStruct.modelPar_cjep0/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.instanceVar_vdep_t)-((((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_vdep*modelStruct.d_modelPar_vdep_dX+modelStruct.d_modelPar_vdep_dX*modelStruct.modelPar_vdep))/(modelStruct.modelPar_vdep*modelStruct.modelPar_vdep)/(modelStruct.modelPar_vdep*modelStruct.modelPar_vdep));
ab = (((((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.instanceVar_vdep_t)/(modelStruct.modelPar_vdep*modelStruct.modelPar_vdep));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));
d_aa_dX = (((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_cjep0/instanceStruct.instanceVar_cjep0_t))*(deriv_pow_0_d0*(d_a_eg_dX))+((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t)*((instanceStruct.instanceVar_cjep0_t*modelStruct.d_modelPar_cjep0_dX-modelStruct.modelPar_cjep0*instanceStruct.d_instanceVar_cjep0_t_dX)/instanceStruct.instanceVar_cjep0_t/instanceStruct.instanceVar_cjep0_t)+((instanceStruct.instanceVar_vdep_t*modelStruct.d_modelPar_vdep_dX-modelStruct.modelPar_vdep*instanceStruct.d_instanceVar_vdep_t_dX)/instanceStruct.instanceVar_vdep_t/instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_cjep0/instanceStruct.instanceVar_cjep0_t))*value_pow_0);
aa = (((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_cjep0/instanceStruct.instanceVar_cjep0_t))*value_pow_0);
}
}
else
{
if ((((modelStruct.modelPar_tunode==0)&&(modelStruct.modelPar_cjei0>0.0))&&(modelStruct.modelPar_vdei>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ab_dX = (((modelStruct.modelPar_vdei*modelStruct.modelPar_vdei)*((((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.d_instanceVar_vdei_t_dX+(((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.d_instanceVar_vdei_t_dX+((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*deriv_sqrt_0_d0*(d_a_eg_dX)+((modelStruct.modelPar_cjei0*instanceStruct.d_instanceVar_cjei0_t_dX-instanceStruct.instanceVar_cjei0_t*modelStruct.d_modelPar_cjei0_dX)/modelStruct.modelPar_cjei0/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.instanceVar_vdei_t)-((((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_vdei*modelStruct.d_modelPar_vdei_dX+modelStruct.d_modelPar_vdei_dX*modelStruct.modelPar_vdei))/(modelStruct.modelPar_vdei*modelStruct.modelPar_vdei)/(modelStruct.modelPar_vdei*modelStruct.modelPar_vdei));
ab = (((((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.instanceVar_vdei_t)/(modelStruct.modelPar_vdei*modelStruct.modelPar_vdei));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));
d_aa_dX = (((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_cjei0/instanceStruct.instanceVar_cjei0_t))*(deriv_pow_0_d0*(d_a_eg_dX))+((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t)*((instanceStruct.instanceVar_cjei0_t*modelStruct.d_modelPar_cjei0_dX-modelStruct.modelPar_cjei0*instanceStruct.d_instanceVar_cjei0_t_dX)/instanceStruct.instanceVar_cjei0_t/instanceStruct.instanceVar_cjei0_t)+((instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX-modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX)/instanceStruct.instanceVar_vdei_t/instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_cjei0/instanceStruct.instanceVar_cjei0_t))*value_pow_0);
aa = (((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_cjei0/instanceStruct.instanceVar_cjei0_t))*value_pow_0);
}
}
}
instanceStruct.d_instanceVar_ibets_t_dX = (modelStruct.modelPar_ibets*d_ab_dX+modelStruct.d_modelPar_ibets_dX*ab);
instanceStruct.instanceVar_ibets_t = (modelStruct.modelPar_ibets*ab);
instanceStruct.d_instanceVar_abet_t_dX = (modelStruct.modelPar_abet*d_aa_dX+modelStruct.d_modelPar_abet_dX*aa);
instanceStruct.instanceVar_abet_t = (modelStruct.modelPar_abet*aa);
}
// End block HICTUN_T
else
{
instanceStruct.d_instanceVar_ibets_t_dX = 0.0;
instanceStruct.instanceVar_ibets_t = 0;
instanceStruct.d_instanceVar_abet_t_dX = 0.0;
instanceStruct.instanceVar_abet_t = 1;
}
if ((1.0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdcx*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdcx)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdcx_dX*0.5-(modelStruct.modelPar_vdcx*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdcx_dX-((-0.5)*modelStruct.modelPar_vdcx)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdcx_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdcx_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdcx/instanceStruct.instanceVar_vdcx_t));
double value_exp_1 = exp((modelStruct.modelPar_zcx*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdcx/instanceStruct.instanceVar_vdcx_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cratio_t_dX = 1.0*deriv_exp_1_d0*((modelStruct.modelPar_zcx*deriv_log_0_d0*(((instanceStruct.instanceVar_vdcx_t*modelStruct.d_modelPar_vdcx_dX-modelStruct.modelPar_vdcx*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t))+modelStruct.d_modelPar_zcx_dX*value_log_0));
instanceStruct.instanceVar_cratio_t = (1.0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vptcx_t_dX = ((modelStruct.modelPar_vdcx*(modelStruct.modelPar_vptcx*instanceStruct.d_instanceVar_vdcx_t_dX+modelStruct.d_modelPar_vptcx_dX*instanceStruct.instanceVar_vdcx_t)-(modelStruct.modelPar_vptcx*instanceStruct.instanceVar_vdcx_t)*modelStruct.d_modelPar_vdcx_dX)/modelStruct.modelPar_vdcx/modelStruct.modelPar_vdcx);
instanceStruct.instanceVar_vptcx_t = ((modelStruct.modelPar_vptcx*instanceStruct.instanceVar_vdcx_t)/modelStruct.modelPar_vdcx);
}
else
{
instanceStruct.d_instanceVar_vptcx_t_dX = modelStruct.d_modelPar_vptcx_dX;
instanceStruct.instanceVar_vptcx_t = modelStruct.modelPar_vptcx;
}
}
else
{
instanceStruct.d_instanceVar_cratio_t_dX = 0.0;
instanceStruct.instanceVar_cratio_t = 1.0;
instanceStruct.d_instanceVar_vdcx_t_dX = modelStruct.d_modelPar_vdcx_dX;
instanceStruct.instanceVar_vdcx_t = modelStruct.modelPar_vdcx;
instanceStruct.d_instanceVar_vptcx_t_dX = modelStruct.d_modelPar_vptcx_dX;
instanceStruct.instanceVar_vptcx_t = modelStruct.modelPar_vptcx;
}
instanceStruct.d_instanceVar_cjcx01_t_dX = (instanceStruct.instanceVar_cratio_t*instanceStruct.d_instanceVar_cjcx01_dX+instanceStruct.d_instanceVar_cratio_t_dX*instanceStruct.instanceVar_cjcx01);
instanceStruct.instanceVar_cjcx01_t = (instanceStruct.instanceVar_cratio_t*instanceStruct.instanceVar_cjcx01);
instanceStruct.d_instanceVar_cjcx02_t_dX = (instanceStruct.instanceVar_cratio_t*instanceStruct.d_instanceVar_cjcx02_dX+instanceStruct.d_instanceVar_cratio_t_dX*instanceStruct.instanceVar_cjcx02);
instanceStruct.instanceVar_cjcx02_t = (instanceStruct.instanceVar_cratio_t*instanceStruct.instanceVar_cjcx02);
{
double value_exp_0 = exp((modelStruct.modelPar_zetarcx*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rcx_t_dX = (modelStruct.modelPar_rcx*deriv_exp_0_d0*((modelStruct.modelPar_zetarcx*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarcx_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rcx_dX*value_exp_0);
instanceStruct.instanceVar_rcx_t = (modelStruct.modelPar_rcx*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetarbx*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rbx_t_dX = (modelStruct.modelPar_rbx*deriv_exp_0_d0*((modelStruct.modelPar_zetarbx*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarbx_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rbx_dX*value_exp_0);
instanceStruct.instanceVar_rbx_t = (modelStruct.modelPar_rbx*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetare*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_re_t_dX = (modelStruct.modelPar_re*deriv_exp_0_d0*((modelStruct.modelPar_zetare*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetare_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_re_dX*value_exp_0);
instanceStruct.instanceVar_re_t = (modelStruct.modelPar_re*value_exp_0);
}
{
double value_exp_0 = exp(((modelStruct.modelPar_zetacx-1.0)*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tsf_t_dX = (modelStruct.modelPar_tsf*deriv_exp_0_d0*(((modelStruct.modelPar_zetacx-1.0)*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetacx_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_tsf_dX*value_exp_0);
instanceStruct.instanceVar_tsf_t = (modelStruct.modelPar_tsf*value_exp_0);
}
if ((modelStruct.modelPar_cjs0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vds*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vds)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vds_dX*0.5-(modelStruct.modelPar_vds*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vds_dX-((-0.5)*modelStruct.modelPar_vds)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgsc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vds_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vds_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vds/instanceStruct.instanceVar_vds_t));
double value_exp_1 = exp((modelStruct.modelPar_zs*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vds/instanceStruct.instanceVar_vds_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjs0_t_dX = (modelStruct.modelPar_cjs0*deriv_exp_1_d0*((modelStruct.modelPar_zs*deriv_log_0_d0*(((instanceStruct.instanceVar_vds_t*modelStruct.d_modelPar_vds_dX-modelStruct.modelPar_vds*instanceStruct.d_instanceVar_vds_t_dX)/instanceStruct.instanceVar_vds_t/instanceStruct.instanceVar_vds_t))+modelStruct.d_modelPar_zs_dX*value_log_0))+modelStruct.d_modelPar_cjs0_dX*value_exp_1);
instanceStruct.instanceVar_cjs0_t = (modelStruct.modelPar_cjs0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vpts_t_dX = ((modelStruct.modelPar_vds*(modelStruct.modelPar_vpts*instanceStruct.d_instanceVar_vds_t_dX+modelStruct.d_modelPar_vpts_dX*instanceStruct.instanceVar_vds_t)-(modelStruct.modelPar_vpts*instanceStruct.instanceVar_vds_t)*modelStruct.d_modelPar_vds_dX)/modelStruct.modelPar_vds/modelStruct.modelPar_vds);
instanceStruct.instanceVar_vpts_t = ((modelStruct.modelPar_vpts*instanceStruct.instanceVar_vds_t)/modelStruct.modelPar_vds);
}
else
{
instanceStruct.d_instanceVar_vpts_t_dX = modelStruct.d_modelPar_vpts_dX;
instanceStruct.instanceVar_vpts_t = modelStruct.modelPar_vpts;
}
}
else
{
instanceStruct.d_instanceVar_cjs0_t_dX = modelStruct.d_modelPar_cjs0_dX;
instanceStruct.instanceVar_cjs0_t = modelStruct.modelPar_cjs0;
instanceStruct.d_instanceVar_vds_t_dX = modelStruct.d_modelPar_vds_dX;
instanceStruct.instanceVar_vds_t = modelStruct.modelPar_vds;
instanceStruct.d_instanceVar_vpts_t_dX = modelStruct.d_modelPar_vpts_dX;
instanceStruct.instanceVar_vpts_t = modelStruct.modelPar_vpts;
}
if ((modelStruct.modelPar_vdsp>0))
{
if ((modelStruct.modelPar_cscp0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdsp*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdsp)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdsp_dX*0.5-(modelStruct.modelPar_vdsp*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdsp_dX-((-0.5)*modelStruct.modelPar_vdsp)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgsc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdsp_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdsp_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdsp/instanceStruct.instanceVar_vdsp_t));
double value_exp_1 = exp((modelStruct.modelPar_zsp*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdsp/instanceStruct.instanceVar_vdsp_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cscp0_t_dX = (modelStruct.modelPar_cscp0*deriv_exp_1_d0*((modelStruct.modelPar_zsp*deriv_log_0_d0*(((instanceStruct.instanceVar_vdsp_t*modelStruct.d_modelPar_vdsp_dX-modelStruct.modelPar_vdsp*instanceStruct.d_instanceVar_vdsp_t_dX)/instanceStruct.instanceVar_vdsp_t/instanceStruct.instanceVar_vdsp_t))+modelStruct.d_modelPar_zsp_dX*value_log_0))+modelStruct.d_modelPar_cscp0_dX*value_exp_1);
instanceStruct.instanceVar_cscp0_t = (modelStruct.modelPar_cscp0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vptsp_t_dX = ((modelStruct.modelPar_vdsp*(modelStruct.modelPar_vptsp*instanceStruct.d_instanceVar_vdsp_t_dX+modelStruct.d_modelPar_vptsp_dX*instanceStruct.instanceVar_vdsp_t)-(modelStruct.modelPar_vptsp*instanceStruct.instanceVar_vdsp_t)*modelStruct.d_modelPar_vdsp_dX)/modelStruct.modelPar_vdsp/modelStruct.modelPar_vdsp);
instanceStruct.instanceVar_vptsp_t = ((modelStruct.modelPar_vptsp*instanceStruct.instanceVar_vdsp_t)/modelStruct.modelPar_vdsp);
}
else
{
instanceStruct.d_instanceVar_vptsp_t_dX = modelStruct.d_modelPar_vptsp_dX;
instanceStruct.instanceVar_vptsp_t = modelStruct.modelPar_vptsp;
}
}
else
{
instanceStruct.d_instanceVar_cscp0_t_dX = modelStruct.d_modelPar_cscp0_dX;
instanceStruct.instanceVar_cscp0_t = modelStruct.modelPar_cscp0;
instanceStruct.d_instanceVar_vdsp_t_dX = modelStruct.d_modelPar_vdsp_dX;
instanceStruct.instanceVar_vdsp_t = modelStruct.modelPar_vdsp;
instanceStruct.d_instanceVar_vptsp_t_dX = modelStruct.d_modelPar_vptsp_dX;
instanceStruct.instanceVar_vptsp_t = modelStruct.modelPar_vptsp;
}
}
else
{
instanceStruct.d_instanceVar_cscp0_t_dX = modelStruct.d_modelPar_cscp0_dX;
instanceStruct.instanceVar_cscp0_t = modelStruct.modelPar_cscp0;
instanceStruct.d_instanceVar_vdsp_t_dX = modelStruct.d_modelPar_vdsp_dX;
instanceStruct.instanceVar_vdsp_t = modelStruct.modelPar_vdsp;
instanceStruct.d_instanceVar_vptsp_t_dX = modelStruct.d_modelPar_vptsp_dX;
instanceStruct.instanceVar_vptsp_t = modelStruct.modelPar_vptsp;
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetahjei*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ahjei_t_dX = (modelStruct.modelPar_ahjei*deriv_exp_0_d0*((modelStruct.modelPar_zetahjei*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetahjei_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_ahjei_dX*value_exp_0);
instanceStruct.instanceVar_ahjei_t = (modelStruct.modelPar_ahjei*value_exp_0);
}
{
double value_log_0 = log(instanceStruct.instanceVar_qtt0);
double value_exp_1 = exp((modelStruct.modelPar_zetavgbe*value_log_0));
double value_exp_2 = exp(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*(value_exp_1-1)));
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_qtt0);
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_exp_2_d0 = value_exp_2;
instanceStruct.d_instanceVar_hjei0_t_dX = (modelStruct.modelPar_hjei*deriv_exp_2_d0*(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*deriv_exp_1_d0*((modelStruct.modelPar_zetavgbe*deriv_log_0_d0*(instanceStruct.d_instanceVar_qtt0_dX)+modelStruct.d_modelPar_zetavgbe_dX*value_log_0))+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_dvgbe_dX-modelStruct.modelPar_dvgbe*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(value_exp_1-1)))+modelStruct.d_modelPar_hjei_dX*value_exp_2);
instanceStruct.instanceVar_hjei0_t = (modelStruct.modelPar_hjei*value_exp_2);
}
{
double value_exp_0 = exp(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_hf0_t_dX = (modelStruct.modelPar_hf0*deriv_exp_0_d0*(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_dvgbe_dX-modelStruct.modelPar_dvgbe*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)))+modelStruct.d_modelPar_hf0_dX*value_exp_0);
instanceStruct.instanceVar_hf0_t = (modelStruct.modelPar_hf0*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
{
double value_exp_0 = exp((((modelStruct.modelPar_vgb-modelStruct.modelPar_vge)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_hfe_t_dX = (modelStruct.modelPar_hfe*deriv_exp_0_d0*((((modelStruct.modelPar_vgb-modelStruct.modelPar_vge)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*(modelStruct.d_modelPar_vgb_dX-modelStruct.d_modelPar_vge_dX)-(modelStruct.modelPar_vgb-modelStruct.modelPar_vge)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)))+modelStruct.d_modelPar_hfe_dX*value_exp_0);
instanceStruct.instanceVar_hfe_t = (modelStruct.modelPar_hfe*value_exp_0);
}
{
double value_exp_0 = exp((((modelStruct.modelPar_vgb-modelStruct.modelPar_vgc)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_hfc_t_dX = (modelStruct.modelPar_hfc*deriv_exp_0_d0*((((modelStruct.modelPar_vgb-modelStruct.modelPar_vgc)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*(modelStruct.d_modelPar_vgb_dX-modelStruct.d_modelPar_vgc_dX)-(modelStruct.modelPar_vgb-modelStruct.modelPar_vgc)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)))+modelStruct.d_modelPar_hfc_dX*value_exp_0);
instanceStruct.instanceVar_hfc_t = (modelStruct.modelPar_hfc*value_exp_0);
}
}
else
{
instanceStruct.d_instanceVar_hfe_t_dX = modelStruct.d_modelPar_hfe_dX;
instanceStruct.instanceVar_hfe_t = modelStruct.modelPar_hfe;
instanceStruct.d_instanceVar_hfc_t_dX = modelStruct.d_modelPar_hfc_dX;
instanceStruct.instanceVar_hfc_t = modelStruct.modelPar_hfc;
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetarth*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rth_t_dX = ((modelStruct.modelPar_rth*value_exp_0)*(modelStruct.modelPar_alrth*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alrth_dX*instanceStruct.instanceVar_dT)+(modelStruct.modelPar_rth*deriv_exp_0_d0*((modelStruct.modelPar_zetarth*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarth_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rth_dX*value_exp_0)*(1+(modelStruct.modelPar_alrth*instanceStruct.instanceVar_dT)));
instanceStruct.instanceVar_rth_t = ((modelStruct.modelPar_rth*value_exp_0)*(1+(modelStruct.modelPar_alrth*instanceStruct.instanceVar_dT)));
}
}
// End block Thermal_updat_without_self_heating
}
// End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_ei_GND,
const int admsProbeID_V_bp_GND,
const int admsProbeID_V_ci_GND,
const int admsProbeID_V_bi_GND,
const int admsProbeID_V_c_e,
const int admsProbeID_V_b_c,
const int admsProbeID_V_n2_GND,
const int admsProbeID_V_n1_GND,
const int admsProbeID_V_si_s,
const int admsProbeID_V_bp_e,
const int admsProbeID_V_b_e,
const int admsProbeID_V_ci_ei,
const int admsProbeID_V_xf_GND,
const int admsProbeID_V_xf2_GND,
const int admsProbeID_V_xf1_GND,
const int admsProbeID_V_b_bp,
const int admsProbeID_V_ci_c,
const int admsProbeID_V_ei_e,
const int admsProbeID_V_bp_bi,
const int admsProbeID_V_tnode_GND,
const int admsProbeID_V_s_c,
const int admsProbeID_V_si_ci,
const int admsProbeID_V_b_ci,
const int admsProbeID_V_bp_ci,
const int admsProbeID_V_bp_ei,
const int admsProbeID_V_bi_ci,
const int admsProbeID_V_bi_ei,
// node constants
const int admsNodeID_c,
const int admsNodeID_b,
const int admsNodeID_e,
const int admsNodeID_s,
const int admsNodeID_tnode,
const int admsNodeID_ci,
const int admsNodeID_ei,
const int admsNodeID_bp,
const int admsNodeID_bi,
const int admsNodeID_si,
const int admsNodeID_xf1,
const int admsNodeID_xf2,
const int admsNodeID_xf,
const int admsNodeID_n1,
const int admsNodeID_n2,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double fourkt=0.0;
double d_fourkt_dX=0.0;
  double flicker_Pwr=0.0;
double d_flicker_Pwr_dX=0.0;
  double i_re=0.0;
double d_i_re_dX=0.0;
  double twoq=0.0;
  double n_w=0.0;
  double n_1=0.0;
double d_n_1_dX=0.0;
  double sqrt_n2=0.0;
double d_sqrt_n2_dX=0.0;
  double n_2=0.0;
double d_n_2_dX=0.0;
  double DIOY=0.0;
double d_DIOY_dX=0.0;
  double le=0.0;
double d_le_dX=0.0;
  double irei=0.0;
double d_irei_dX=0.0;
  double Orci0_t=0.0;
double d_Orci0_t_dX=0.0;
  double Tr=0.0;
double d_Tr_dX=0.0;
  double VT_f=0.0;
double d_VT_f_dX=0.0;
  double i_0f=0.0;
double d_i_0f_dX=0.0;
  double i_0r=0.0;
double d_i_0r_dX=0.0;
  double DFV_f=0.0;
double d_DFV_f_dX=0.0;
  double DFv_e=0.0;
double d_DFv_e_dX=0.0;
  double DFs_q=0.0;
double d_DFs_q_dX=0.0;
  double DFs_q2=0.0;
double d_DFs_q2_dX=0.0;
  double DFv_j=0.0;
double d_DFv_j_dX=0.0;
  double DFdvj_dv=0.0;
double d_DFdvj_dv_dX=0.0;
  double DFb=0.0;
double d_DFb_dX=0.0;
  double DFC_j1=0.0;
double d_DFC_j1_dX=0.0;
  double Cjei=0.0;
double d_Cjei_dX=0.0;
  double DFQ_j=0.0;
double d_DFQ_j_dX=0.0;
  double Qjei=0.0;
double d_Qjei_dX=0.0;
  double vj=0.0;
double d_vj_dX=0.0;
  double vj_z=0.0;
double d_vj_z_dX=0.0;
  double hjei_vbe=0.0;
double d_hjei_vbe_dX=0.0;
  double Dz_r=0.0;
double d_Dz_r_dX=0.0;
  double Dv_p=0.0;
double d_Dv_p_dX=0.0;
  double DV_f=0.0;
double d_DV_f_dX=0.0;
  double DC_max=0.0;
double d_DC_max_dX=0.0;
  double DC_c=0.0;
double d_DC_c_dX=0.0;
  double Dv_e=0.0;
double d_Dv_e_dX=0.0;
  double De=0.0;
double d_De_dX=0.0;
  double De_1=0.0;
double d_De_1_dX=0.0;
  double Dv_j1=0.0;
double d_Dv_j1_dX=0.0;
  double Da=0.0;
double d_Da_dX=0.0;
  double Dv_r=0.0;
double d_Dv_r_dX=0.0;
  double De_2=0.0;
double d_De_2_dX=0.0;
  double Dv_j2=0.0;
double d_Dv_j2_dX=0.0;
  double Dv_j4=0.0;
double d_Dv_j4_dX=0.0;
  double DCln1=0.0;
double d_DCln1_dX=0.0;
  double DCln2=0.0;
double d_DCln2_dX=0.0;
  double Dz1=0.0;
double d_Dz1_dX=0.0;
  double Dzr1=0.0;
double d_Dzr1_dX=0.0;
  double DC_j1=0.0;
double d_DC_j1_dX=0.0;
  double DC_j2=0.0;
double d_DC_j2_dX=0.0;
  double DC_j3=0.0;
double d_DC_j3_dX=0.0;
  double Cjci=0.0;
double d_Cjci_dX=0.0;
  double DQ_j1=0.0;
double d_DQ_j1_dX=0.0;
  double DQ_j2=0.0;
double d_DQ_j2_dX=0.0;
  double DQ_j3=0.0;
double d_DQ_j3_dX=0.0;
  double Qjci=0.0;
double d_Qjci_dX=0.0;
  double a_bpt=0.0;
  double Q_0=0.0;
double d_Q_0_dX=0.0;
  double Q_bpt=0.0;
double d_Q_bpt_dX=0.0;
  double b_q=0.0;
double d_b_q_dX=0.0;
  double Cjcit=0.0;
double d_Cjcit_dX=0.0;
  double cc=0.0;
double d_cc_dX=0.0;
  double T_f0=0.0;
double d_T_f0_dX=0.0;
  double vc=0.0;
double d_vc_dX=0.0;
  double ick=0.0;
double d_ick_dX=0.0;
  double ICKa=0.0;
double d_ICKa_dX=0.0;
  double ick2=0.0;
double d_ick2_dX=0.0;
  double ick1=0.0;
double d_ick1_dX=0.0;
  double Odelck=0.0;
double d_Odelck_dX=0.0;
  double a11=0.0;
double d_a11_dX=0.0;
  double a1=0.0;
double d_a1_dX=0.0;
  double vceff=0.0;
double d_vceff_dX=0.0;
  double d1=0.0;
double d_d1_dX=0.0;
  double Ovpt=0.0;
double d_Ovpt_dX=0.0;
  double Q_p=0.0;
double d_Q_p_dX=0.0;
  double A=0.0;
double d_A_dX=0.0;
  double I_Tf1=0.0;
double d_I_Tf1_dX=0.0;
  double a_h=0.0;
double d_a_h_dX=0.0;
  double itf=0.0;
double d_itf_dX=0.0;
  double itr=0.0;
double d_itr_dX=0.0;
  double Q_bf=0.0;
double d_Q_bf_dX=0.0;
  double Qf=0.0;
double d_Qf_dX=0.0;
  double FFitf_ick=0.0;
double d_FFitf_ick_dX=0.0;
  double FFdTef=0.0;
double d_FFdTef_dX=0.0;
  double FFdQef=0.0;
double d_FFdQef_dX=0.0;
  double FFib=0.0;
double d_FFib_dX=0.0;
  double FFfcbar=0.0;
double d_FFfcbar_dX=0.0;
  double FFdib_ditf=0.0;
double d_FFdib_ditf_dX=0.0;
  double FFdVc=0.0;
double d_FFdVc_dX=0.0;
  double FFdVc_ditf=0.0;
double d_FFdVc_ditf_dX=0.0;
  double FFdQbfb=0.0;
double d_FFdQbfb_dX=0.0;
  double FFdTbfb=0.0;
double d_FFdTbfb_dX=0.0;
  double FFic=0.0;
double d_FFic_dX=0.0;
  double FFw=0.0;
double d_FFw_dX=0.0;
  double FFdQfhc=0.0;
double d_FFdQfhc_dX=0.0;
  double FFdTfhc=0.0;
double d_FFdTfhc_dX=0.0;
  double FCa=0.0;
double d_FCa_dX=0.0;
  double FCrt=0.0;
double d_FCrt_dX=0.0;
  double FCa_ck=0.0;
double d_FCa_ck_dX=0.0;
  double FCdaick_ditf=0.0;
double d_FCdaick_ditf_dX=0.0;
  double FCz_1=0.0;
double d_FCz_1_dX=0.0;
  double FCd_f=0.0;
double d_FCd_f_dX=0.0;
  double FCz=0.0;
double d_FCz_dX=0.0;
  double FCxl=0.0;
double d_FCxl_dX=0.0;
  double FCxb=0.0;
double d_FCxb_dX=0.0;
  double FCf1=0.0;
double d_FCf1_dX=0.0;
  double FCln=0.0;
double d_FCln_dX=0.0;
  double FCa1=0.0;
double d_FCa1_dX=0.0;
  double FCd_a=0.0;
double d_FCd_a_dX=0.0;
  double FCw=0.0;
double d_FCw_dX=0.0;
  double FCdw_daick=0.0;
double d_FCdw_daick_dX=0.0;
  double FCda1_dw=0.0;
double d_FCda1_dw_dX=0.0;
  double FCf_CT=0.0;
double d_FCf_CT_dX=0.0;
  double FCw2=0.0;
double d_FCw2_dX=0.0;
  double FCdf1_dw=0.0;
double d_FCdf1_dw_dX=0.0;
  double z=0.0;
double d_z_dX=0.0;
  double lnzb=0.0;
double d_lnzb_dX=0.0;
  double x=0.0;
double d_x_dX=0.0;
  double a2=0.0;
double d_a2_dX=0.0;
  double a3=0.0;
double d_a3_dX=0.0;
  double r=0.0;
double d_r_dX=0.0;
  double FCf2=0.0;
double d_FCf2_dX=0.0;
  double FCdf2_dw=0.0;
double d_FCdf2_dw_dX=0.0;
  double FCf3=0.0;
double d_FCf3_dX=0.0;
  double FCdf3_dw=0.0;
double d_FCdf3_dw_dX=0.0;
  double FCf_ci=0.0;
double d_FCf_ci_dX=0.0;
  double FCdfc_dw=0.0;
double d_FCdfc_dw_dX=0.0;
  double FCdw_ditf=0.0;
double d_FCdw_ditf_dX=0.0;
  double FCdfc_ditf=0.0;
double d_FCdfc_ditf_dX=0.0;
  double lnz=0.0;
double d_lnz_dX=0.0;
  double FCdfCT_dw=0.0;
double d_FCdfCT_dw_dX=0.0;
  double FCdfCT_ditf=0.0;
double d_FCdfCT_ditf_dX=0.0;
  double FFdQcfc=0.0;
double d_FFdQcfc_dX=0.0;
  double FFdTcfc=0.0;
double d_FFdTcfc_dX=0.0;
  double FFdQcfcT=0.0;
double d_FFdQcfcT_dX=0.0;
  double FFdTcfcT=0.0;
double d_FFdTcfcT_dX=0.0;
  double FFdQbfc=0.0;
double d_FFdQbfc_dX=0.0;
  double FFdTbfc=0.0;
double d_FFdTbfc_dX=0.0;
  double Q_fT=0.0;
double d_Q_fT_dX=0.0;
  double T_fT=0.0;
double d_T_fT_dX=0.0;
  double Qr=0.0;
double d_Qr_dX=0.0;
  int l_it=0.0;
  double Q_pT=0.0;
double d_Q_pT_dX=0.0;
  double d_Q=0.0;
double d_d_Q_dX=0.0;
  double d_Q0=0.0;
double d_d_Q0_dX=0.0;
  double Qdei=0.0;
double d_Qdei_dX=0.0;
  double Qdci=0.0;
double d_Qdci_dX=0.0;
  double Cdei=0.0;
double d_Cdei_dX=0.0;
  double Cdci=0.0;
double d_Cdci_dX=0.0;
  double Crbi=0.0;
double d_Crbi_dX=0.0;
  double qrbi=0.0;
double d_qrbi_dX=0.0;
  double ibh_rec=0.0;
double d_ibh_rec_dX=0.0;
  double irep=0.0;
double d_irep_dX=0.0;
  double Cjep=0.0;
double d_Cjep_dX=0.0;
  double Qjep=0.0;
double d_Qjep_dX=0.0;
  double ibet=0.0;
double d_ibet_dX=0.0;
  double CjCx_ii=0.0;
double d_CjCx_ii_dX=0.0;
  double qjcx0_t_ii=0.0;
double d_qjcx0_t_ii_dX=0.0;
  double CjCx_i=0.0;
double d_CjCx_i_dX=0.0;
  double qjcx0_t_i=0.0;
double d_qjcx0_t_i_dX=0.0;
  double Cjs=0.0;
double d_Cjs_dX=0.0;
  double Qjs=0.0;
double d_Qjs_dX=0.0;
  double Cscp=0.0;
double d_Cscp_dX=0.0;
  double Qscp=0.0;
double d_Qscp_dX=0.0;
  double HSUM=0.0;
double d_HSUM_dX=0.0;
  double HSa=0.0;
double d_HSa_dX=0.0;
  double HSb=0.0;
double d_HSb_dX=0.0;
  double HSI_Tsu=0.0;
double d_HSI_Tsu_dX=0.0;
  double Qdsu=0.0;
double d_Qdsu_dX=0.0;
  double pterm=0.0;
double d_pterm_dX=0.0;
  double Itxf=0.0;
double d_Itxf_dX=0.0;
  double Qdeix=0.0;
double d_Qdeix_dX=0.0;
  double Vxf1=0.0;
  double Vxf2=0.0;
  double Ixf1=0.0;
double d_Ixf1_dX=0.0;
  double Ixf2=0.0;
double d_Ixf2_dX=0.0;
  double Qxf1=0.0;
double d_Qxf1_dX=0.0;
  double Qxf2=0.0;
double d_Qxf2_dX=0.0;
  double Vxf=0.0;
  double fact=0.0;
double d_fact_dX=0.0;
  double Ixf=0.0;
double d_Ixf_dX=0.0;
  double Qxf=0.0;
double d_Qxf_dX=0.0;
  double Vsc=0.0;
double d_Vsc_dX=0.0;
  double Vsici=0.0;
double d_Vsici_dX=0.0;
  double Vbci=0.0;
double d_Vbci_dX=0.0;
  double Vbpci=0.0;
double d_Vbpci_dX=0.0;
  double Vbpei=0.0;
double d_Vbpei_dX=0.0;
  double Vciei=0.0;
double d_Vciei_dX=0.0;
  double Vbici=0.0;
double d_Vbici_dX=0.0;
  double Vbiei=0.0;
double d_Vbiei_dX=0.0;


  // -- code converted from analog/code block
d_Vbiei_dX = 0.0;
Vbiei = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_bi_ei]));
d_Vbici_dX = 0.0;
Vbici = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_bi_ci]));
d_Vciei_dX = (d_Vbiei_dX-d_Vbici_dX);
Vciei = (Vbiei-Vbici);
d_Vbpei_dX = 0.0;
Vbpei = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_bp_ei]));
d_Vbpci_dX = 0.0;
Vbpci = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_bp_ci]));
d_Vbci_dX = 0.0;
Vbci = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_b_ci]));
d_Vsici_dX = 0.0;
Vsici = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_si_ci]));
d_Vsc_dX = 0.0;
Vsc = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_c]));
if (((modelStruct.modelPar_flsh!=0)&&(modelStruct.modelPar_rth>=0.001)))
//Begin block Thermal_update_with_self_heating
{
instanceStruct.d_instanceVar_Tdev_dX = modelStruct.d_modelPar_dt_dX;
instanceStruct.instanceVar_Tdev = ((instanceStruct.instanceVar_Tamb+modelStruct.modelPar_dt)+(probeVars[admsProbeID_V_tnode_GND]));
if ((instanceStruct.instanceVar_Tdev<((-100.0)+273.15)))
{
instanceStruct.d_instanceVar_Tdev_dX = 0.0;
instanceStruct.instanceVar_Tdev = ((-100.0)+273.15);
}
else
{
if ((instanceStruct.instanceVar_Tdev>(326.85+273.15)))
{
instanceStruct.d_instanceVar_Tdev_dX = 0.0;
instanceStruct.instanceVar_Tdev = (326.85+273.15);
}
}
instanceStruct.d_instanceVar_VT_dX = (1.3806503e-23*instanceStruct.d_instanceVar_Tdev_dX/1.6021766208e-19);
instanceStruct.instanceVar_VT = ((1.3806503e-23*instanceStruct.instanceVar_Tdev)/1.6021766208e-19);
instanceStruct.d_instanceVar_dT_dX = (instanceStruct.d_instanceVar_Tdev_dX-instanceStruct.d_instanceVar_Tnom_dX);
instanceStruct.instanceVar_dT = (instanceStruct.instanceVar_Tdev-instanceStruct.instanceVar_Tnom);
instanceStruct.d_instanceVar_qtt0_dX = ((instanceStruct.instanceVar_Tnom*instanceStruct.d_instanceVar_Tdev_dX-instanceStruct.instanceVar_Tdev*instanceStruct.d_instanceVar_Tnom_dX)/instanceStruct.instanceVar_Tnom/instanceStruct.instanceVar_Tnom);
instanceStruct.instanceVar_qtt0 = (instanceStruct.instanceVar_Tdev/instanceStruct.instanceVar_Tnom);
{
double value_log_0 = log(instanceStruct.instanceVar_qtt0);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_qtt0);
instanceStruct.d_instanceVar_ln_qtt0_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_qtt0_dX);
instanceStruct.instanceVar_ln_qtt0 = value_log_0;
}
{
double value_log_0 = log(instanceStruct.instanceVar_Tdev);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_Tdev);
instanceStruct.d_instanceVar_k1_dX = ((modelStruct.modelPar_f1vg*instanceStruct.instanceVar_Tdev)*deriv_log_0_d0*(instanceStruct.d_instanceVar_Tdev_dX)+(modelStruct.modelPar_f1vg*instanceStruct.d_instanceVar_Tdev_dX+modelStruct.d_modelPar_f1vg_dX*instanceStruct.instanceVar_Tdev)*value_log_0);
instanceStruct.instanceVar_k1 = ((modelStruct.modelPar_f1vg*instanceStruct.instanceVar_Tdev)*value_log_0);
}
instanceStruct.d_instanceVar_k2_dX = (modelStruct.modelPar_f2vg*instanceStruct.d_instanceVar_Tdev_dX+modelStruct.d_modelPar_f2vg_dX*instanceStruct.instanceVar_Tdev);
instanceStruct.instanceVar_k2 = (modelStruct.modelPar_f2vg*instanceStruct.instanceVar_Tdev);
instanceStruct.d_instanceVar_vgb_t_dX = ((modelStruct.d_modelPar_vgb_dX+instanceStruct.d_instanceVar_k1_dX)+instanceStruct.d_instanceVar_k2_dX);
instanceStruct.instanceVar_vgb_t = ((modelStruct.modelPar_vgb+instanceStruct.instanceVar_k1)+instanceStruct.instanceVar_k2);
instanceStruct.d_instanceVar_vge_t_dX = ((modelStruct.d_modelPar_vge_dX+instanceStruct.d_instanceVar_k1_dX)+instanceStruct.d_instanceVar_k2_dX);
instanceStruct.instanceVar_vge_t = ((modelStruct.modelPar_vge+instanceStruct.instanceVar_k1)+instanceStruct.instanceVar_k2);
instanceStruct.d_instanceVar_vgbe_t_dX = ((instanceStruct.d_instanceVar_vgb_t_dX+instanceStruct.d_instanceVar_vge_t_dX)/2);
instanceStruct.instanceVar_vgbe_t = ((instanceStruct.instanceVar_vgb_t+instanceStruct.instanceVar_vge_t)/2);
if ((modelStruct.modelPar_cjei0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdei*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdei)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdei_dX*0.5-(modelStruct.modelPar_vdei*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdei_dX-((-0.5)*modelStruct.modelPar_vdei)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbe0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdei_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdei_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t));
double value_exp_1 = exp((modelStruct.modelPar_zei*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjei0_t_dX = (modelStruct.modelPar_cjei0*deriv_exp_1_d0*((modelStruct.modelPar_zei*deriv_log_0_d0*(((instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX-modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX)/instanceStruct.instanceVar_vdei_t/instanceStruct.instanceVar_vdei_t))+modelStruct.d_modelPar_zei_dX*value_log_0))+modelStruct.d_modelPar_cjei0_dX*value_exp_1);
instanceStruct.instanceVar_cjei0_t = (modelStruct.modelPar_cjei0*value_exp_1);
}
if ((1==1))
{
instanceStruct.d_instanceVar_ajei_t_dX = ((modelStruct.modelPar_vdei*(modelStruct.modelPar_ajei*instanceStruct.d_instanceVar_vdei_t_dX+modelStruct.d_modelPar_ajei_dX*instanceStruct.instanceVar_vdei_t)-(modelStruct.modelPar_ajei*instanceStruct.instanceVar_vdei_t)*modelStruct.d_modelPar_vdei_dX)/modelStruct.modelPar_vdei/modelStruct.modelPar_vdei);
instanceStruct.instanceVar_ajei_t = ((modelStruct.modelPar_ajei*instanceStruct.instanceVar_vdei_t)/modelStruct.modelPar_vdei);
}
else
{
instanceStruct.d_instanceVar_ajei_t_dX = modelStruct.d_modelPar_ajei_dX;
instanceStruct.instanceVar_ajei_t = modelStruct.modelPar_ajei;
}
}
else
{
instanceStruct.d_instanceVar_cjei0_t_dX = modelStruct.d_modelPar_cjei0_dX;
instanceStruct.instanceVar_cjei0_t = modelStruct.modelPar_cjei0;
instanceStruct.d_instanceVar_vdei_t_dX = modelStruct.d_modelPar_vdei_dX;
instanceStruct.instanceVar_vdei_t = modelStruct.modelPar_vdei;
instanceStruct.d_instanceVar_ajei_t_dX = modelStruct.d_modelPar_ajei_dX;
instanceStruct.instanceVar_ajei_t = modelStruct.modelPar_ajei;
}
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
instanceStruct.d_instanceVar_V_gT_dX = (((3.0*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+3.0*instanceStruct.d_instanceVar_VT_dX*instanceStruct.instanceVar_ln_qtt0)+(modelStruct.modelPar_vgb*instanceStruct.d_instanceVar_qtt0_dX+modelStruct.d_modelPar_vgb_dX*(instanceStruct.instanceVar_qtt0-1.0)));
instanceStruct.instanceVar_V_gT = (((3.0*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0)+(modelStruct.modelPar_vgb*(instanceStruct.instanceVar_qtt0-1.0)));
instanceStruct.d_instanceVar_r_VgVT_dX = ((instanceStruct.instanceVar_VT*instanceStruct.d_instanceVar_V_gT_dX-instanceStruct.instanceVar_V_gT*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
instanceStruct.instanceVar_r_VgVT = (instanceStruct.instanceVar_V_gT/instanceStruct.instanceVar_VT);
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mbei*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mbei_dX)/modelStruct.modelPar_mbei/modelStruct.modelPar_mbei)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mbei)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeis_t_dX = (modelStruct.modelPar_ibeis*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibeis_dX*value_exp_0);
instanceStruct.instanceVar_ibeis_t = (modelStruct.modelPar_ibeis*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mrei*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mrei_dX)/modelStruct.modelPar_mrei/modelStruct.modelPar_mrei)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mrei)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireis_t_dX = (modelStruct.modelPar_ireis*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ireis_dX*value_exp_0);
instanceStruct.instanceVar_ireis_t = (modelStruct.modelPar_ireis*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mbep*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mbep_dX)/modelStruct.modelPar_mbep/modelStruct.modelPar_mbep)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mbep)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeps_t_dX = (modelStruct.modelPar_ibeps*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibeps_dX*value_exp_0);
instanceStruct.instanceVar_ibeps_t = (modelStruct.modelPar_ibeps*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = (((modelStruct.modelPar_mrep*(modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_r_VgVT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_r_VgVT)-(modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)*modelStruct.d_modelPar_mrep_dX)/modelStruct.modelPar_mrep/modelStruct.modelPar_mrep)-(modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT));
instanceStruct.instanceVar_a = (((modelStruct.modelPar_mcf*instanceStruct.instanceVar_r_VgVT)/modelStruct.modelPar_mrep)-(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireps_t_dX = (modelStruct.modelPar_ireps*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ireps_dX*value_exp_0);
instanceStruct.instanceVar_ireps_t = (modelStruct.modelPar_ireps*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_mbci*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_mbci_dX)/modelStruct.modelPar_mbci/modelStruct.modelPar_mbci);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_mbci);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcis_t_dX = (modelStruct.modelPar_ibcis*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibcis_dX*value_exp_0);
instanceStruct.instanceVar_ibcis_t = (modelStruct.modelPar_ibcis*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_mbcx*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_mbcx_dX)/modelStruct.modelPar_mbcx/modelStruct.modelPar_mbcx);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_mbcx);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcxs_t_dX = (modelStruct.modelPar_ibcxs*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_ibcxs_dX*value_exp_0);
instanceStruct.instanceVar_ibcxs_t = (modelStruct.modelPar_ibcxs*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_msf*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_msf_dX)/modelStruct.modelPar_msf/modelStruct.modelPar_msf);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_msf);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_itss_t_dX = (modelStruct.modelPar_itss*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_itss_dX*value_exp_0);
instanceStruct.instanceVar_itss_t = (modelStruct.modelPar_itss*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_msc*instanceStruct.d_instanceVar_r_VgVT_dX-instanceStruct.instanceVar_r_VgVT*modelStruct.d_modelPar_msc_dX)/modelStruct.modelPar_msc/modelStruct.modelPar_msc);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_r_VgVT/modelStruct.modelPar_msc);
{
double value_exp_0 = exp(instanceStruct.instanceVar_a);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_iscs_t_dX = (modelStruct.modelPar_iscs*deriv_exp_0_d0*(instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_iscs_dX*value_exp_0);
instanceStruct.instanceVar_iscs_t = (modelStruct.modelPar_iscs*value_exp_0);
}
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX-instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX)/modelStruct.modelPar_vdei/modelStruct.modelPar_vdei);
instanceStruct.instanceVar_a = (instanceStruct.instanceVar_vdei_t/modelStruct.modelPar_vdei);
instanceStruct.d_instanceVar_qp0_t_dX = (modelStruct.modelPar_qp0*((0.5*modelStruct.modelPar_zei)*(-instanceStruct.d_instanceVar_a_dX)+0.5*modelStruct.d_modelPar_zei_dX*(1.0-instanceStruct.instanceVar_a))+modelStruct.d_modelPar_qp0_dX*(1.0+((0.5*modelStruct.modelPar_zei)*(1.0-instanceStruct.instanceVar_a))));
instanceStruct.instanceVar_qp0_t = (modelStruct.modelPar_qp0*(1.0+((0.5*modelStruct.modelPar_zei)*(1.0-instanceStruct.instanceVar_a))));
{
double value_exp_0 = exp((modelStruct.modelPar_zetaci*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_a_dX = ((modelStruct.modelPar_vlim*(1.0-(modelStruct.modelPar_alvs*instanceStruct.instanceVar_dT)))*deriv_exp_0_d0*((modelStruct.modelPar_zetaci*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetaci_dX*instanceStruct.instanceVar_ln_qtt0))+(modelStruct.modelPar_vlim*(-(modelStruct.modelPar_alvs*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alvs_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_vlim_dX*(1.0-(modelStruct.modelPar_alvs*instanceStruct.instanceVar_dT)))*value_exp_0);
instanceStruct.instanceVar_a = ((modelStruct.modelPar_vlim*(1.0-(modelStruct.modelPar_alvs*instanceStruct.instanceVar_dT)))*value_exp_0);
}
instanceStruct.d_instanceVar_k_dX = ((instanceStruct.instanceVar_VT*(instanceStruct.d_instanceVar_a_dX-instanceStruct.d_instanceVar_VT_dX)-(instanceStruct.instanceVar_a-instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
instanceStruct.instanceVar_k = ((instanceStruct.instanceVar_a-instanceStruct.instanceVar_VT)/instanceStruct.instanceVar_VT);
if ((instanceStruct.instanceVar_k<11.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_k);
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_vlim_t_dX = (instanceStruct.d_instanceVar_VT_dX+(instanceStruct.instanceVar_VT*deriv_log_1_d0*(deriv_exp_0_d0*(instanceStruct.d_instanceVar_k_dX))+instanceStruct.d_instanceVar_VT_dX*value_log_1));
instanceStruct.instanceVar_vlim_t = (instanceStruct.instanceVar_VT+(instanceStruct.instanceVar_VT*value_log_1));
}
}
else
{
instanceStruct.d_instanceVar_vlim_t_dX = instanceStruct.d_instanceVar_a_dX;
instanceStruct.instanceVar_vlim_t = instanceStruct.instanceVar_a;
}
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_alb*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alb_dX*instanceStruct.instanceVar_dT);
instanceStruct.instanceVar_a = (1.0+(modelStruct.modelPar_alb*instanceStruct.instanceVar_dT));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_a*instanceStruct.instanceVar_a)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_k_dX = 0.5*(instanceStruct.d_instanceVar_a_dX+deriv_sqrt_0_d0*((instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX+instanceStruct.d_instanceVar_a_dX*instanceStruct.instanceVar_a)));
instanceStruct.instanceVar_k = (0.5*(instanceStruct.instanceVar_a+value_sqrt_0));
}
instanceStruct.d_instanceVar_tef0_t_dX = ((instanceStruct.instanceVar_k*(modelStruct.modelPar_tef0*instanceStruct.d_instanceVar_qtt0_dX+modelStruct.d_modelPar_tef0_dX*instanceStruct.instanceVar_qtt0)-(modelStruct.modelPar_tef0*instanceStruct.instanceVar_qtt0)*instanceStruct.d_instanceVar_k_dX)/instanceStruct.instanceVar_k/instanceStruct.instanceVar_k);
instanceStruct.instanceVar_tef0_t = ((modelStruct.modelPar_tef0*instanceStruct.instanceVar_qtt0)/instanceStruct.instanceVar_k);
}
else
{
{
double value_exp_0 = exp(((modelStruct.modelPar_zetabet*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeis_t_dX = (modelStruct.modelPar_ibeis*deriv_exp_0_d0*(((modelStruct.modelPar_zetabet*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetabet_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vge_dX-modelStruct.modelPar_vge*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibeis_dX*value_exp_0);
instanceStruct.instanceVar_ibeis_t = (modelStruct.modelPar_ibeis*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
{
double value_exp_0 = exp((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrei)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireis_t_dX = (modelStruct.modelPar_ireis*deriv_exp_0_d0*((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrei)*instanceStruct.d_instanceVar_ln_qtt0_dX+((modelStruct.modelPar_mrei*instanceStruct.d_instanceVar_mg_dX-instanceStruct.instanceVar_mg*modelStruct.d_modelPar_mrei_dX)/modelStruct.modelPar_mrei/modelStruct.modelPar_mrei)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT))*instanceStruct.d_instanceVar_qtt0_dX+(((modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_vgbe0_dX-instanceStruct.instanceVar_vgbe0*(modelStruct.modelPar_mrei*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mrei_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireis_dX*value_exp_0);
instanceStruct.instanceVar_ireis_t = (modelStruct.modelPar_ireis*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireis_t_dX = (modelStruct.modelPar_ireis*deriv_exp_0_d0*((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.d_instanceVar_ln_qtt0_dX+0.5*instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*0.5*instanceStruct.d_instanceVar_vgbe0_dX-(0.5*instanceStruct.instanceVar_vgbe0)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireis_dX*value_exp_0);
instanceStruct.instanceVar_ireis_t = (modelStruct.modelPar_ireis*value_exp_0);
}
}
{
double value_exp_0 = exp(((modelStruct.modelPar_zetabet*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibeps_t_dX = (modelStruct.modelPar_ibeps*deriv_exp_0_d0*(((modelStruct.modelPar_zetabet*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetabet_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vge/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vge_dX-modelStruct.modelPar_vge*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibeps_dX*value_exp_0);
instanceStruct.instanceVar_ibeps_t = (modelStruct.modelPar_ibeps*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
{
double value_exp_0 = exp((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrep)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireps_t_dX = (modelStruct.modelPar_ireps*deriv_exp_0_d0*((((instanceStruct.instanceVar_mg/modelStruct.modelPar_mrep)*instanceStruct.d_instanceVar_ln_qtt0_dX+((modelStruct.modelPar_mrep*instanceStruct.d_instanceVar_mg_dX-instanceStruct.instanceVar_mg*modelStruct.d_modelPar_mrep_dX)/modelStruct.modelPar_mrep/modelStruct.modelPar_mrep)*instanceStruct.instanceVar_ln_qtt0)+((instanceStruct.instanceVar_vgbe0/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT))*instanceStruct.d_instanceVar_qtt0_dX+(((modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_vgbe0_dX-instanceStruct.instanceVar_vgbe0*(modelStruct.modelPar_mrep*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mrep_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT))*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireps_dX*value_exp_0);
instanceStruct.instanceVar_ireps_t = (modelStruct.modelPar_ireps*value_exp_0);
}
}
else
{
{
double value_exp_0 = exp((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ireps_t_dX = (modelStruct.modelPar_ireps*deriv_exp_0_d0*((((0.5*instanceStruct.instanceVar_mg)*instanceStruct.d_instanceVar_ln_qtt0_dX+0.5*instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_ln_qtt0)+(((0.5*instanceStruct.instanceVar_vgbe0)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*0.5*instanceStruct.d_instanceVar_vgbe0_dX-(0.5*instanceStruct.instanceVar_vgbe0)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ireps_dX*value_exp_0);
instanceStruct.instanceVar_ireps_t = (modelStruct.modelPar_ireps*value_exp_0);
}
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetabci*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcis_t_dX = (modelStruct.modelPar_ibcis*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetabci*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetabci_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgc_dX-modelStruct.modelPar_vgc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibcis_dX*value_exp_0);
instanceStruct.instanceVar_ibcis_t = (modelStruct.modelPar_ibcis*value_exp_0);
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetabcxt*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ibcxs_t_dX = (modelStruct.modelPar_ibcxs*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetabcxt*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetabcxt_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgc_dX-modelStruct.modelPar_vgc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_ibcxs_dX*value_exp_0);
instanceStruct.instanceVar_ibcxs_t = (modelStruct.modelPar_ibcxs*value_exp_0);
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetasct*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_itss_t_dX = (modelStruct.modelPar_itss*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetasct*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetasct_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgc/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgc_dX-modelStruct.modelPar_vgc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_itss_dX*value_exp_0);
instanceStruct.instanceVar_itss_t = (modelStruct.modelPar_itss*value_exp_0);
}
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetasct*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgs/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_iscs_t_dX = (modelStruct.modelPar_iscs*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetasct*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetasct_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgs/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgs_dX-modelStruct.modelPar_vgs*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_iscs_dX*value_exp_0);
instanceStruct.instanceVar_iscs_t = (modelStruct.modelPar_iscs*value_exp_0);
}
{
double value_log_0 = log((instanceStruct.instanceVar_vdei_t/modelStruct.modelPar_vdei));
double value_exp_1 = exp((modelStruct.modelPar_zei*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_vdei_t/modelStruct.modelPar_vdei));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_a_dX = deriv_exp_1_d0*((modelStruct.modelPar_zei*deriv_log_0_d0*(((modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX-instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX)/modelStruct.modelPar_vdei/modelStruct.modelPar_vdei))+modelStruct.d_modelPar_zei_dX*value_log_0));
instanceStruct.instanceVar_a = value_exp_1;
}
instanceStruct.d_instanceVar_qp0_t_dX = (modelStruct.modelPar_qp0*(-instanceStruct.d_instanceVar_a_dX)+modelStruct.d_modelPar_qp0_dX*(2.0-instanceStruct.instanceVar_a));
instanceStruct.instanceVar_qp0_t = (modelStruct.modelPar_qp0*(2.0-instanceStruct.instanceVar_a));
{
double value_exp_0 = exp(((modelStruct.modelPar_zetaci-instanceStruct.instanceVar_avs)*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_vlim_t_dX = (modelStruct.modelPar_vlim*deriv_exp_0_d0*(((modelStruct.modelPar_zetaci-instanceStruct.instanceVar_avs)*instanceStruct.d_instanceVar_ln_qtt0_dX+(modelStruct.d_modelPar_zetaci_dX-instanceStruct.d_instanceVar_avs_dX)*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_vlim_dX*value_exp_0);
instanceStruct.instanceVar_vlim_t = (modelStruct.modelPar_vlim*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
instanceStruct.d_instanceVar_tef0_t_dX = modelStruct.d_modelPar_tef0_dX;
instanceStruct.instanceVar_tef0_t = modelStruct.modelPar_tef0;
}
else
{
instanceStruct.d_instanceVar_zetatef_dX = (modelStruct.d_modelPar_zetabet_dX-modelStruct.d_modelPar_zetact_dX);
instanceStruct.instanceVar_zetatef = ((modelStruct.modelPar_zetabet-modelStruct.modelPar_zetact)-0.5);
instanceStruct.d_instanceVar_dvg0_dX = (modelStruct.d_modelPar_vgb_dX-modelStruct.d_modelPar_vge_dX);
instanceStruct.instanceVar_dvg0 = (modelStruct.modelPar_vgb-modelStruct.modelPar_vge);
{
double value_exp_0 = exp(((instanceStruct.instanceVar_zetatef*instanceStruct.instanceVar_ln_qtt0)-((instanceStruct.instanceVar_dvg0/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tef0_t_dX = (modelStruct.modelPar_tef0*deriv_exp_0_d0*(((instanceStruct.instanceVar_zetatef*instanceStruct.d_instanceVar_ln_qtt0_dX+instanceStruct.d_instanceVar_zetatef_dX*instanceStruct.instanceVar_ln_qtt0)-((instanceStruct.instanceVar_dvg0/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*instanceStruct.d_instanceVar_dvg0_dX-instanceStruct.instanceVar_dvg0*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_tef0_dX*value_exp_0);
instanceStruct.instanceVar_tef0_t = (modelStruct.modelPar_tef0*value_exp_0);
}
}
}
{
double value_exp_0 = exp(((modelStruct.modelPar_zetact*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgb/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_c10_t_dX = (modelStruct.modelPar_c10*deriv_exp_0_d0*(((modelStruct.modelPar_zetact*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetact_dX*instanceStruct.instanceVar_ln_qtt0)+((modelStruct.modelPar_vgb/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_vgb_dX-modelStruct.modelPar_vgb*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1))))+modelStruct.d_modelPar_c10_dX*value_exp_0);
instanceStruct.instanceVar_c10_t = (modelStruct.modelPar_c10*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetaci*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rci0_t_dX = (modelStruct.modelPar_rci0*deriv_exp_0_d0*((modelStruct.modelPar_zetaci*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetaci_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rci0_dX*value_exp_0);
instanceStruct.instanceVar_rci0_t = (modelStruct.modelPar_rci0*value_exp_0);
}
instanceStruct.d_instanceVar_vces_t_dX = (modelStruct.modelPar_vces*(modelStruct.modelPar_alces*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alces_dX*instanceStruct.instanceVar_dT)+modelStruct.d_modelPar_vces_dX*(1+(modelStruct.modelPar_alces*instanceStruct.instanceVar_dT)));
instanceStruct.instanceVar_vces_t = (modelStruct.modelPar_vces*(1+(modelStruct.modelPar_alces*instanceStruct.instanceVar_dT)));
if ((modelStruct.modelPar_cjci0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdci*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdci)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdci_dX*0.5-(modelStruct.modelPar_vdci*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdci_dX-((-0.5)*modelStruct.modelPar_vdci)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdci_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdci_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdci/instanceStruct.instanceVar_vdci_t));
double value_exp_1 = exp((modelStruct.modelPar_zci*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdci/instanceStruct.instanceVar_vdci_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjci0_t_dX = (modelStruct.modelPar_cjci0*deriv_exp_1_d0*((modelStruct.modelPar_zci*deriv_log_0_d0*(((instanceStruct.instanceVar_vdci_t*modelStruct.d_modelPar_vdci_dX-modelStruct.modelPar_vdci*instanceStruct.d_instanceVar_vdci_t_dX)/instanceStruct.instanceVar_vdci_t/instanceStruct.instanceVar_vdci_t))+modelStruct.d_modelPar_zci_dX*value_log_0))+modelStruct.d_modelPar_cjci0_dX*value_exp_1);
instanceStruct.instanceVar_cjci0_t = (modelStruct.modelPar_cjci0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vptci_t_dX = ((modelStruct.modelPar_vdci*(modelStruct.modelPar_vptci*instanceStruct.d_instanceVar_vdci_t_dX+modelStruct.d_modelPar_vptci_dX*instanceStruct.instanceVar_vdci_t)-(modelStruct.modelPar_vptci*instanceStruct.instanceVar_vdci_t)*modelStruct.d_modelPar_vdci_dX)/modelStruct.modelPar_vdci/modelStruct.modelPar_vdci);
instanceStruct.instanceVar_vptci_t = ((modelStruct.modelPar_vptci*instanceStruct.instanceVar_vdci_t)/modelStruct.modelPar_vdci);
}
else
{
instanceStruct.d_instanceVar_vptci_t_dX = modelStruct.d_modelPar_vptci_dX;
instanceStruct.instanceVar_vptci_t = modelStruct.modelPar_vptci;
}
}
else
{
instanceStruct.d_instanceVar_cjci0_t_dX = modelStruct.d_modelPar_cjci0_dX;
instanceStruct.instanceVar_cjci0_t = modelStruct.modelPar_cjci0;
instanceStruct.d_instanceVar_vdci_t_dX = modelStruct.d_modelPar_vdci_dX;
instanceStruct.instanceVar_vdci_t = modelStruct.modelPar_vdci;
instanceStruct.d_instanceVar_vptci_t_dX = modelStruct.d_modelPar_vptci_dX;
instanceStruct.instanceVar_vptci_t = modelStruct.modelPar_vptci;
}
instanceStruct.d_instanceVar_t0_t_dX = (modelStruct.modelPar_t0*((modelStruct.modelPar_alt0*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alt0_dX*instanceStruct.instanceVar_dT)+((modelStruct.modelPar_kt0*instanceStruct.instanceVar_dT)*instanceStruct.d_instanceVar_dT_dX+(modelStruct.modelPar_kt0*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_kt0_dX*instanceStruct.instanceVar_dT)*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_t0_dX*((1+(modelStruct.modelPar_alt0*instanceStruct.instanceVar_dT))+((modelStruct.modelPar_kt0*instanceStruct.instanceVar_dT)*instanceStruct.instanceVar_dT)));
instanceStruct.instanceVar_t0_t = (modelStruct.modelPar_t0*((1+(modelStruct.modelPar_alt0*instanceStruct.instanceVar_dT))+((modelStruct.modelPar_kt0*instanceStruct.instanceVar_dT)*instanceStruct.instanceVar_dT)));
{
double value_exp_0 = exp(((modelStruct.modelPar_zetaci-1)*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_thcs_t_dX = (modelStruct.modelPar_thcs*deriv_exp_0_d0*(((modelStruct.modelPar_zetaci-1)*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetaci_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_thcs_dX*value_exp_0);
instanceStruct.instanceVar_thcs_t = (modelStruct.modelPar_thcs*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_alfav*instanceStruct.instanceVar_dT));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_favl_t_dX = (modelStruct.modelPar_favl*deriv_exp_0_d0*((modelStruct.modelPar_alfav*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alfav_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_favl_dX*value_exp_0);
instanceStruct.instanceVar_favl_t = (modelStruct.modelPar_favl*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_alqav*instanceStruct.instanceVar_dT));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_qavl_t_dX = (modelStruct.modelPar_qavl*deriv_exp_0_d0*((modelStruct.modelPar_alqav*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alqav_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_qavl_dX*value_exp_0);
instanceStruct.instanceVar_qavl_t = (modelStruct.modelPar_qavl*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_alkav*instanceStruct.instanceVar_dT));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_kavl_t_dX = (modelStruct.modelPar_kavl*deriv_exp_0_d0*((modelStruct.modelPar_alkav*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alkav_dX*instanceStruct.instanceVar_dT))+modelStruct.d_modelPar_kavl_dX*value_exp_0);
instanceStruct.instanceVar_kavl_t = (modelStruct.modelPar_kavl*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetarbi*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rbi0_t_dX = (modelStruct.modelPar_rbi0*deriv_exp_0_d0*((modelStruct.modelPar_zetarbi*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarbi_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rbi0_dX*value_exp_0);
instanceStruct.instanceVar_rbi0_t = (modelStruct.modelPar_rbi0*value_exp_0);
}
if ((modelStruct.modelPar_cjep0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdep*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdep)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdep_dX*0.5-(modelStruct.modelPar_vdep*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdep_dX-((-0.5)*modelStruct.modelPar_vdep)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbe0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbe0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdep_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdep_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t));
double value_exp_1 = exp((modelStruct.modelPar_zep*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjep0_t_dX = (modelStruct.modelPar_cjep0*deriv_exp_1_d0*((modelStruct.modelPar_zep*deriv_log_0_d0*(((instanceStruct.instanceVar_vdep_t*modelStruct.d_modelPar_vdep_dX-modelStruct.modelPar_vdep*instanceStruct.d_instanceVar_vdep_t_dX)/instanceStruct.instanceVar_vdep_t/instanceStruct.instanceVar_vdep_t))+modelStruct.d_modelPar_zep_dX*value_log_0))+modelStruct.d_modelPar_cjep0_dX*value_exp_1);
instanceStruct.instanceVar_cjep0_t = (modelStruct.modelPar_cjep0*value_exp_1);
}
if ((1==1))
{
instanceStruct.d_instanceVar_ajep_t_dX = ((modelStruct.modelPar_vdep*(modelStruct.modelPar_ajep*instanceStruct.d_instanceVar_vdep_t_dX+modelStruct.d_modelPar_ajep_dX*instanceStruct.instanceVar_vdep_t)-(modelStruct.modelPar_ajep*instanceStruct.instanceVar_vdep_t)*modelStruct.d_modelPar_vdep_dX)/modelStruct.modelPar_vdep/modelStruct.modelPar_vdep);
instanceStruct.instanceVar_ajep_t = ((modelStruct.modelPar_ajep*instanceStruct.instanceVar_vdep_t)/modelStruct.modelPar_vdep);
}
else
{
instanceStruct.d_instanceVar_ajep_t_dX = modelStruct.d_modelPar_ajep_dX;
instanceStruct.instanceVar_ajep_t = modelStruct.modelPar_ajep;
}
}
else
{
instanceStruct.d_instanceVar_cjep0_t_dX = modelStruct.d_modelPar_cjep0_dX;
instanceStruct.instanceVar_cjep0_t = modelStruct.modelPar_cjep0;
instanceStruct.d_instanceVar_vdep_t_dX = modelStruct.d_modelPar_vdep_dX;
instanceStruct.instanceVar_vdep_t = modelStruct.modelPar_vdep;
instanceStruct.d_instanceVar_ajep_t_dX = modelStruct.d_modelPar_ajep_dX;
instanceStruct.instanceVar_ajep_t = modelStruct.modelPar_ajep;
}
if (((modelStruct.modelPar_ibets>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
//Begin block HICTUN_T
{
//Block-local variables for block HICTUN_T
double a_eg=0.0;
double d_a_eg_dX=0.0;
double ab=0.0;
double d_ab_dX=0.0;
double aa=0.0;
double d_aa_dX=0.0;
//End of Block-local variables
d_ab_dX = 0.0;
ab = 1.0;
d_aa_dX = 0.0;
aa = 1.0;
d_a_eg_dX = ((instanceStruct.instanceVar_vgbe_t*instanceStruct.d_instanceVar_vgbe_t0_dX-instanceStruct.instanceVar_vgbe_t0*instanceStruct.d_instanceVar_vgbe_t_dX)/instanceStruct.instanceVar_vgbe_t/instanceStruct.instanceVar_vgbe_t);
a_eg = (instanceStruct.instanceVar_vgbe_t0/instanceStruct.instanceVar_vgbe_t);
if ((((modelStruct.modelPar_tunode==1)&&(modelStruct.modelPar_cjep0>0.0))&&(modelStruct.modelPar_vdep>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ab_dX = (((modelStruct.modelPar_vdep*modelStruct.modelPar_vdep)*((((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.d_instanceVar_vdep_t_dX+(((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.d_instanceVar_vdep_t_dX+((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*deriv_sqrt_0_d0*(d_a_eg_dX)+((modelStruct.modelPar_cjep0*instanceStruct.d_instanceVar_cjep0_t_dX-instanceStruct.instanceVar_cjep0_t*modelStruct.d_modelPar_cjep0_dX)/modelStruct.modelPar_cjep0/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.instanceVar_vdep_t)-((((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_vdep*modelStruct.d_modelPar_vdep_dX+modelStruct.d_modelPar_vdep_dX*modelStruct.modelPar_vdep))/(modelStruct.modelPar_vdep*modelStruct.modelPar_vdep)/(modelStruct.modelPar_vdep*modelStruct.modelPar_vdep));
ab = (((((instanceStruct.instanceVar_cjep0_t/modelStruct.modelPar_cjep0)*value_sqrt_0)*instanceStruct.instanceVar_vdep_t)*instanceStruct.instanceVar_vdep_t)/(modelStruct.modelPar_vdep*modelStruct.modelPar_vdep));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));
d_aa_dX = (((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_cjep0/instanceStruct.instanceVar_cjep0_t))*(deriv_pow_0_d0*(d_a_eg_dX))+((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t)*((instanceStruct.instanceVar_cjep0_t*modelStruct.d_modelPar_cjep0_dX-modelStruct.modelPar_cjep0*instanceStruct.d_instanceVar_cjep0_t_dX)/instanceStruct.instanceVar_cjep0_t/instanceStruct.instanceVar_cjep0_t)+((instanceStruct.instanceVar_vdep_t*modelStruct.d_modelPar_vdep_dX-modelStruct.modelPar_vdep*instanceStruct.d_instanceVar_vdep_t_dX)/instanceStruct.instanceVar_vdep_t/instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_cjep0/instanceStruct.instanceVar_cjep0_t))*value_pow_0);
aa = (((modelStruct.modelPar_vdep/instanceStruct.instanceVar_vdep_t)*(modelStruct.modelPar_cjep0/instanceStruct.instanceVar_cjep0_t))*value_pow_0);
}
}
else
{
if ((((modelStruct.modelPar_tunode==0)&&(modelStruct.modelPar_cjei0>0.0))&&(modelStruct.modelPar_vdei>0.0)))
{
{
double value_sqrt_0 = sqrt(a_eg);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ab_dX = (((modelStruct.modelPar_vdei*modelStruct.modelPar_vdei)*((((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.d_instanceVar_vdei_t_dX+(((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.d_instanceVar_vdei_t_dX+((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*deriv_sqrt_0_d0*(d_a_eg_dX)+((modelStruct.modelPar_cjei0*instanceStruct.d_instanceVar_cjei0_t_dX-instanceStruct.instanceVar_cjei0_t*modelStruct.d_modelPar_cjei0_dX)/modelStruct.modelPar_cjei0/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.instanceVar_vdei_t)-((((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_vdei*modelStruct.d_modelPar_vdei_dX+modelStruct.d_modelPar_vdei_dX*modelStruct.modelPar_vdei))/(modelStruct.modelPar_vdei*modelStruct.modelPar_vdei)/(modelStruct.modelPar_vdei*modelStruct.modelPar_vdei));
ab = (((((instanceStruct.instanceVar_cjei0_t/modelStruct.modelPar_cjei0)*value_sqrt_0)*instanceStruct.instanceVar_vdei_t)*instanceStruct.instanceVar_vdei_t)/(modelStruct.modelPar_vdei*modelStruct.modelPar_vdei));
}
{
double value_pow_0 = pow(a_eg,(-1.5));
double  deriv_pow_0_d0 = ((a_eg == 0.0)?0.0:(value_pow_0*(-1.5)/a_eg));
d_aa_dX = (((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_cjei0/instanceStruct.instanceVar_cjei0_t))*(deriv_pow_0_d0*(d_a_eg_dX))+((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t)*((instanceStruct.instanceVar_cjei0_t*modelStruct.d_modelPar_cjei0_dX-modelStruct.modelPar_cjei0*instanceStruct.d_instanceVar_cjei0_t_dX)/instanceStruct.instanceVar_cjei0_t/instanceStruct.instanceVar_cjei0_t)+((instanceStruct.instanceVar_vdei_t*modelStruct.d_modelPar_vdei_dX-modelStruct.modelPar_vdei*instanceStruct.d_instanceVar_vdei_t_dX)/instanceStruct.instanceVar_vdei_t/instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_cjei0/instanceStruct.instanceVar_cjei0_t))*value_pow_0);
aa = (((modelStruct.modelPar_vdei/instanceStruct.instanceVar_vdei_t)*(modelStruct.modelPar_cjei0/instanceStruct.instanceVar_cjei0_t))*value_pow_0);
}
}
}
instanceStruct.d_instanceVar_ibets_t_dX = (modelStruct.modelPar_ibets*d_ab_dX+modelStruct.d_modelPar_ibets_dX*ab);
instanceStruct.instanceVar_ibets_t = (modelStruct.modelPar_ibets*ab);
instanceStruct.d_instanceVar_abet_t_dX = (modelStruct.modelPar_abet*d_aa_dX+modelStruct.d_modelPar_abet_dX*aa);
instanceStruct.instanceVar_abet_t = (modelStruct.modelPar_abet*aa);
}
// End block HICTUN_T
else
{
instanceStruct.d_instanceVar_ibets_t_dX = 0.0;
instanceStruct.instanceVar_ibets_t = 0;
instanceStruct.d_instanceVar_abet_t_dX = 0.0;
instanceStruct.instanceVar_abet_t = 1;
}
if ((1.0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdcx*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdcx)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdcx_dX*0.5-(modelStruct.modelPar_vdcx*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdcx_dX-((-0.5)*modelStruct.modelPar_vdcx)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgbc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgbc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdcx_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdcx_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdcx/instanceStruct.instanceVar_vdcx_t));
double value_exp_1 = exp((modelStruct.modelPar_zcx*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdcx/instanceStruct.instanceVar_vdcx_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cratio_t_dX = 1.0*deriv_exp_1_d0*((modelStruct.modelPar_zcx*deriv_log_0_d0*(((instanceStruct.instanceVar_vdcx_t*modelStruct.d_modelPar_vdcx_dX-modelStruct.modelPar_vdcx*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t))+modelStruct.d_modelPar_zcx_dX*value_log_0));
instanceStruct.instanceVar_cratio_t = (1.0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vptcx_t_dX = ((modelStruct.modelPar_vdcx*(modelStruct.modelPar_vptcx*instanceStruct.d_instanceVar_vdcx_t_dX+modelStruct.d_modelPar_vptcx_dX*instanceStruct.instanceVar_vdcx_t)-(modelStruct.modelPar_vptcx*instanceStruct.instanceVar_vdcx_t)*modelStruct.d_modelPar_vdcx_dX)/modelStruct.modelPar_vdcx/modelStruct.modelPar_vdcx);
instanceStruct.instanceVar_vptcx_t = ((modelStruct.modelPar_vptcx*instanceStruct.instanceVar_vdcx_t)/modelStruct.modelPar_vdcx);
}
else
{
instanceStruct.d_instanceVar_vptcx_t_dX = modelStruct.d_modelPar_vptcx_dX;
instanceStruct.instanceVar_vptcx_t = modelStruct.modelPar_vptcx;
}
}
else
{
instanceStruct.d_instanceVar_cratio_t_dX = 0.0;
instanceStruct.instanceVar_cratio_t = 1.0;
instanceStruct.d_instanceVar_vdcx_t_dX = modelStruct.d_modelPar_vdcx_dX;
instanceStruct.instanceVar_vdcx_t = modelStruct.modelPar_vdcx;
instanceStruct.d_instanceVar_vptcx_t_dX = modelStruct.d_modelPar_vptcx_dX;
instanceStruct.instanceVar_vptcx_t = modelStruct.modelPar_vptcx;
}
instanceStruct.d_instanceVar_cjcx01_t_dX = (instanceStruct.instanceVar_cratio_t*instanceStruct.d_instanceVar_cjcx01_dX+instanceStruct.d_instanceVar_cratio_t_dX*instanceStruct.instanceVar_cjcx01);
instanceStruct.instanceVar_cjcx01_t = (instanceStruct.instanceVar_cratio_t*instanceStruct.instanceVar_cjcx01);
instanceStruct.d_instanceVar_cjcx02_t_dX = (instanceStruct.instanceVar_cratio_t*instanceStruct.d_instanceVar_cjcx02_dX+instanceStruct.d_instanceVar_cratio_t_dX*instanceStruct.instanceVar_cjcx02);
instanceStruct.instanceVar_cjcx02_t = (instanceStruct.instanceVar_cratio_t*instanceStruct.instanceVar_cjcx02);
{
double value_exp_0 = exp((modelStruct.modelPar_zetarcx*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rcx_t_dX = (modelStruct.modelPar_rcx*deriv_exp_0_d0*((modelStruct.modelPar_zetarcx*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarcx_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rcx_dX*value_exp_0);
instanceStruct.instanceVar_rcx_t = (modelStruct.modelPar_rcx*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetarbx*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rbx_t_dX = (modelStruct.modelPar_rbx*deriv_exp_0_d0*((modelStruct.modelPar_zetarbx*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarbx_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rbx_dX*value_exp_0);
instanceStruct.instanceVar_rbx_t = (modelStruct.modelPar_rbx*value_exp_0);
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetare*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_re_t_dX = (modelStruct.modelPar_re*deriv_exp_0_d0*((modelStruct.modelPar_zetare*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetare_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_re_dX*value_exp_0);
instanceStruct.instanceVar_re_t = (modelStruct.modelPar_re*value_exp_0);
}
{
double value_exp_0 = exp(((modelStruct.modelPar_zetacx-1.0)*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tsf_t_dX = (modelStruct.modelPar_tsf*deriv_exp_0_d0*(((modelStruct.modelPar_zetacx-1.0)*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetacx_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_tsf_dX*value_exp_0);
instanceStruct.instanceVar_tsf_t = (modelStruct.modelPar_tsf*value_exp_0);
}
if ((modelStruct.modelPar_cjs0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vds*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vds)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vds_dX*0.5-(modelStruct.modelPar_vds*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vds_dX-((-0.5)*modelStruct.modelPar_vds)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgsc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vds_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vds_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vds/instanceStruct.instanceVar_vds_t));
double value_exp_1 = exp((modelStruct.modelPar_zs*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vds/instanceStruct.instanceVar_vds_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cjs0_t_dX = (modelStruct.modelPar_cjs0*deriv_exp_1_d0*((modelStruct.modelPar_zs*deriv_log_0_d0*(((instanceStruct.instanceVar_vds_t*modelStruct.d_modelPar_vds_dX-modelStruct.modelPar_vds*instanceStruct.d_instanceVar_vds_t_dX)/instanceStruct.instanceVar_vds_t/instanceStruct.instanceVar_vds_t))+modelStruct.d_modelPar_zs_dX*value_log_0))+modelStruct.d_modelPar_cjs0_dX*value_exp_1);
instanceStruct.instanceVar_cjs0_t = (modelStruct.modelPar_cjs0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vpts_t_dX = ((modelStruct.modelPar_vds*(modelStruct.modelPar_vpts*instanceStruct.d_instanceVar_vds_t_dX+modelStruct.d_modelPar_vpts_dX*instanceStruct.instanceVar_vds_t)-(modelStruct.modelPar_vpts*instanceStruct.instanceVar_vds_t)*modelStruct.d_modelPar_vds_dX)/modelStruct.modelPar_vds/modelStruct.modelPar_vds);
instanceStruct.instanceVar_vpts_t = ((modelStruct.modelPar_vpts*instanceStruct.instanceVar_vds_t)/modelStruct.modelPar_vds);
}
else
{
instanceStruct.d_instanceVar_vpts_t_dX = modelStruct.d_modelPar_vpts_dX;
instanceStruct.instanceVar_vpts_t = modelStruct.modelPar_vpts;
}
}
else
{
instanceStruct.d_instanceVar_cjs0_t_dX = modelStruct.d_modelPar_cjs0_dX;
instanceStruct.instanceVar_cjs0_t = modelStruct.modelPar_cjs0;
instanceStruct.d_instanceVar_vds_t_dX = modelStruct.d_modelPar_vds_dX;
instanceStruct.instanceVar_vds_t = modelStruct.modelPar_vds;
instanceStruct.d_instanceVar_vpts_t_dX = modelStruct.d_modelPar_vpts_dX;
instanceStruct.instanceVar_vpts_t = modelStruct.modelPar_vpts;
}
if ((modelStruct.modelPar_vdsp>0))
{
if ((modelStruct.modelPar_cscp0>0.0))
{
{
double value_exp_0 = exp(((modelStruct.modelPar_vdsp*0.5)/instanceStruct.instanceVar_vt0));
double value_exp_1 = exp((((-0.5)*modelStruct.modelPar_vdsp)/instanceStruct.instanceVar_vt0));
double value_log_2 = log((value_exp_0-value_exp_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(value_exp_0-value_exp_1));
instanceStruct.d_instanceVar_vdj0_dX = ((2*instanceStruct.instanceVar_vt0)*deriv_log_2_d0*((deriv_exp_0_d0*(((instanceStruct.instanceVar_vt0*modelStruct.d_modelPar_vdsp_dX*0.5-(modelStruct.modelPar_vdsp*0.5)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))-deriv_exp_1_d0*(((instanceStruct.instanceVar_vt0*(-0.5)*modelStruct.d_modelPar_vdsp_dX-((-0.5)*modelStruct.modelPar_vdsp)*instanceStruct.d_instanceVar_vt0_dX)/instanceStruct.instanceVar_vt0/instanceStruct.instanceVar_vt0))))+2*instanceStruct.d_instanceVar_vt0_dX*value_log_2);
instanceStruct.instanceVar_vdj0 = ((2*instanceStruct.instanceVar_vt0)*value_log_2);
}
instanceStruct.d_instanceVar_vdjt_dX = (((instanceStruct.instanceVar_vdj0*instanceStruct.d_instanceVar_qtt0_dX+instanceStruct.d_instanceVar_vdj0_dX*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(-instanceStruct.d_instanceVar_qtt0_dX)+instanceStruct.d_instanceVar_vgsc0_dX*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_ln_qtt0_dX+(instanceStruct.instanceVar_mg*instanceStruct.d_instanceVar_VT_dX+instanceStruct.d_instanceVar_mg_dX*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
instanceStruct.instanceVar_vdjt = (((instanceStruct.instanceVar_vdj0*instanceStruct.instanceVar_qtt0)+(instanceStruct.instanceVar_vgsc0*(1-instanceStruct.instanceVar_qtt0)))-((instanceStruct.instanceVar_mg*instanceStruct.instanceVar_VT)*instanceStruct.instanceVar_ln_qtt0));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_vdjt)/instanceStruct.instanceVar_VT));
double value_sqrt_1 = sqrt((1+(4*value_exp_0)));
double value_log_2 = log((0.5*(1+value_sqrt_1)));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_log_2_d0 = (1.0/(0.5*(1+value_sqrt_1)));
instanceStruct.d_instanceVar_vdt_dX = (instanceStruct.d_instanceVar_vdjt_dX+((2*instanceStruct.instanceVar_VT)*deriv_log_2_d0*(0.5*deriv_sqrt_1_d0*(4*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(-instanceStruct.d_instanceVar_vdjt_dX)-(-instanceStruct.instanceVar_vdjt)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))))+2*instanceStruct.d_instanceVar_VT_dX*value_log_2));
instanceStruct.instanceVar_vdt = (instanceStruct.instanceVar_vdjt+((2*instanceStruct.instanceVar_VT)*value_log_2));
}
instanceStruct.d_instanceVar_vdsp_t_dX = instanceStruct.d_instanceVar_vdt_dX;
instanceStruct.instanceVar_vdsp_t = instanceStruct.instanceVar_vdt;
{
double value_log_0 = log((modelStruct.modelPar_vdsp/instanceStruct.instanceVar_vdsp_t));
double value_exp_1 = exp((modelStruct.modelPar_zsp*value_log_0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelPar_vdsp/instanceStruct.instanceVar_vdsp_t));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_cscp0_t_dX = (modelStruct.modelPar_cscp0*deriv_exp_1_d0*((modelStruct.modelPar_zsp*deriv_log_0_d0*(((instanceStruct.instanceVar_vdsp_t*modelStruct.d_modelPar_vdsp_dX-modelStruct.modelPar_vdsp*instanceStruct.d_instanceVar_vdsp_t_dX)/instanceStruct.instanceVar_vdsp_t/instanceStruct.instanceVar_vdsp_t))+modelStruct.d_modelPar_zsp_dX*value_log_0))+modelStruct.d_modelPar_cscp0_dX*value_exp_1);
instanceStruct.instanceVar_cscp0_t = (modelStruct.modelPar_cscp0*value_exp_1);
}
if ((0==1))
{
instanceStruct.d_instanceVar_vptsp_t_dX = ((modelStruct.modelPar_vdsp*(modelStruct.modelPar_vptsp*instanceStruct.d_instanceVar_vdsp_t_dX+modelStruct.d_modelPar_vptsp_dX*instanceStruct.instanceVar_vdsp_t)-(modelStruct.modelPar_vptsp*instanceStruct.instanceVar_vdsp_t)*modelStruct.d_modelPar_vdsp_dX)/modelStruct.modelPar_vdsp/modelStruct.modelPar_vdsp);
instanceStruct.instanceVar_vptsp_t = ((modelStruct.modelPar_vptsp*instanceStruct.instanceVar_vdsp_t)/modelStruct.modelPar_vdsp);
}
else
{
instanceStruct.d_instanceVar_vptsp_t_dX = modelStruct.d_modelPar_vptsp_dX;
instanceStruct.instanceVar_vptsp_t = modelStruct.modelPar_vptsp;
}
}
else
{
instanceStruct.d_instanceVar_cscp0_t_dX = modelStruct.d_modelPar_cscp0_dX;
instanceStruct.instanceVar_cscp0_t = modelStruct.modelPar_cscp0;
instanceStruct.d_instanceVar_vdsp_t_dX = modelStruct.d_modelPar_vdsp_dX;
instanceStruct.instanceVar_vdsp_t = modelStruct.modelPar_vdsp;
instanceStruct.d_instanceVar_vptsp_t_dX = modelStruct.d_modelPar_vptsp_dX;
instanceStruct.instanceVar_vptsp_t = modelStruct.modelPar_vptsp;
}
}
else
{
instanceStruct.d_instanceVar_cscp0_t_dX = modelStruct.d_modelPar_cscp0_dX;
instanceStruct.instanceVar_cscp0_t = modelStruct.modelPar_cscp0;
instanceStruct.d_instanceVar_vdsp_t_dX = modelStruct.d_modelPar_vdsp_dX;
instanceStruct.instanceVar_vdsp_t = modelStruct.modelPar_vdsp;
instanceStruct.d_instanceVar_vptsp_t_dX = modelStruct.d_modelPar_vptsp_dX;
instanceStruct.instanceVar_vptsp_t = modelStruct.modelPar_vptsp;
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetahjei*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ahjei_t_dX = (modelStruct.modelPar_ahjei*deriv_exp_0_d0*((modelStruct.modelPar_zetahjei*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetahjei_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_ahjei_dX*value_exp_0);
instanceStruct.instanceVar_ahjei_t = (modelStruct.modelPar_ahjei*value_exp_0);
}
{
double value_log_0 = log(instanceStruct.instanceVar_qtt0);
double value_exp_1 = exp((modelStruct.modelPar_zetavgbe*value_log_0));
double value_exp_2 = exp(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*(value_exp_1-1)));
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_qtt0);
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_exp_2_d0 = value_exp_2;
instanceStruct.d_instanceVar_hjei0_t_dX = (modelStruct.modelPar_hjei*deriv_exp_2_d0*(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*deriv_exp_1_d0*((modelStruct.modelPar_zetavgbe*deriv_log_0_d0*(instanceStruct.d_instanceVar_qtt0_dX)+modelStruct.d_modelPar_zetavgbe_dX*value_log_0))+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_dvgbe_dX-modelStruct.modelPar_dvgbe*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(value_exp_1-1)))+modelStruct.d_modelPar_hjei_dX*value_exp_2);
instanceStruct.instanceVar_hjei0_t = (modelStruct.modelPar_hjei*value_exp_2);
}
{
double value_exp_0 = exp(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_hf0_t_dX = (modelStruct.modelPar_hf0*deriv_exp_0_d0*(((modelStruct.modelPar_dvgbe/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*modelStruct.d_modelPar_dvgbe_dX-modelStruct.modelPar_dvgbe*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)))+modelStruct.d_modelPar_hf0_dX*value_exp_0);
instanceStruct.instanceVar_hf0_t = (modelStruct.modelPar_hf0*value_exp_0);
}
if ((modelStruct.modelPar_flcomp>=2.3))
{
{
double value_exp_0 = exp((((modelStruct.modelPar_vgb-modelStruct.modelPar_vge)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_hfe_t_dX = (modelStruct.modelPar_hfe*deriv_exp_0_d0*((((modelStruct.modelPar_vgb-modelStruct.modelPar_vge)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*(modelStruct.d_modelPar_vgb_dX-modelStruct.d_modelPar_vge_dX)-(modelStruct.modelPar_vgb-modelStruct.modelPar_vge)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)))+modelStruct.d_modelPar_hfe_dX*value_exp_0);
instanceStruct.instanceVar_hfe_t = (modelStruct.modelPar_hfe*value_exp_0);
}
{
double value_exp_0 = exp((((modelStruct.modelPar_vgb-modelStruct.modelPar_vgc)/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_hfc_t_dX = (modelStruct.modelPar_hfc*deriv_exp_0_d0*((((modelStruct.modelPar_vgb-modelStruct.modelPar_vgc)/instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_qtt0_dX+((instanceStruct.instanceVar_VT*(modelStruct.d_modelPar_vgb_dX-modelStruct.d_modelPar_vgc_dX)-(modelStruct.modelPar_vgb-modelStruct.modelPar_vgc)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*(instanceStruct.instanceVar_qtt0-1)))+modelStruct.d_modelPar_hfc_dX*value_exp_0);
instanceStruct.instanceVar_hfc_t = (modelStruct.modelPar_hfc*value_exp_0);
}
}
else
{
instanceStruct.d_instanceVar_hfe_t_dX = modelStruct.d_modelPar_hfe_dX;
instanceStruct.instanceVar_hfe_t = modelStruct.modelPar_hfe;
instanceStruct.d_instanceVar_hfc_t_dX = modelStruct.d_modelPar_hfc_dX;
instanceStruct.instanceVar_hfc_t = modelStruct.modelPar_hfc;
}
{
double value_exp_0 = exp((modelStruct.modelPar_zetarth*instanceStruct.instanceVar_ln_qtt0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_rth_t_dX = ((modelStruct.modelPar_rth*value_exp_0)*(modelStruct.modelPar_alrth*instanceStruct.d_instanceVar_dT_dX+modelStruct.d_modelPar_alrth_dX*instanceStruct.instanceVar_dT)+(modelStruct.modelPar_rth*deriv_exp_0_d0*((modelStruct.modelPar_zetarth*instanceStruct.d_instanceVar_ln_qtt0_dX+modelStruct.d_modelPar_zetarth_dX*instanceStruct.instanceVar_ln_qtt0))+modelStruct.d_modelPar_rth_dX*value_exp_0)*(1+(modelStruct.modelPar_alrth*instanceStruct.instanceVar_dT)));
instanceStruct.instanceVar_rth_t = ((modelStruct.modelPar_rth*value_exp_0)*(1+(modelStruct.modelPar_alrth*instanceStruct.instanceVar_dT)));
}
}
// End block Thermal_update_with_self_heating
//Begin block Model_evaluation
{
d_DIOY_dX = (((modelStruct.modelPar_mbei*instanceStruct.instanceVar_VT)*d_Vbiei_dX-Vbiei*(modelStruct.modelPar_mbei*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mbei_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mbei*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mbei*instanceStruct.instanceVar_VT));
DIOY = (Vbiei/(modelStruct.modelPar_mbei*instanceStruct.instanceVar_VT));
if ((modelStruct.modelPar_ibeis>0.0))
{
if ((DIOY>80.0))
{
d_le_dX = d_DIOY_dX;
le = (1+(DIOY-80.0));
d_DIOY_dX = 0.0;
DIOY = 80.0;
}
else
{
d_le_dX = 0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));
d_le_dX = (le*deriv_limexp_0_d0*(d_DIOY_dX)+d_le_dX*value_limexp_0);
le = (le*value_limexp_0);
}
instanceStruct.d_instanceVar_ibei_dX = (instanceStruct.instanceVar_ibeis_t*d_le_dX+instanceStruct.d_instanceVar_ibeis_t_dX*(le-1.0));
instanceStruct.instanceVar_ibei = (instanceStruct.instanceVar_ibeis_t*(le-1.0));
if ((DIOY<=(-14.0)))
{
instanceStruct.d_instanceVar_ibei_dX = (-instanceStruct.d_instanceVar_ibeis_t_dX);
instanceStruct.instanceVar_ibei = (-instanceStruct.instanceVar_ibeis_t);
}
}
else
{
instanceStruct.d_instanceVar_ibei_dX = 0.0;
instanceStruct.instanceVar_ibei = 0.0;
}
d_DIOY_dX = (((modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT)*d_Vbiei_dX-Vbiei*(modelStruct.modelPar_mrei*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mrei_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT));
DIOY = (Vbiei/(modelStruct.modelPar_mrei*instanceStruct.instanceVar_VT));
if ((modelStruct.modelPar_ireis>0.0))
{
if ((DIOY>80.0))
{
d_le_dX = d_DIOY_dX;
le = (1+(DIOY-80.0));
d_DIOY_dX = 0.0;
DIOY = 80.0;
}
else
{
d_le_dX = 0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));
d_le_dX = (le*deriv_limexp_0_d0*(d_DIOY_dX)+d_le_dX*value_limexp_0);
le = (le*value_limexp_0);
}
d_irei_dX = (instanceStruct.instanceVar_ireis_t*d_le_dX+instanceStruct.d_instanceVar_ireis_t_dX*(le-1.0));
irei = (instanceStruct.instanceVar_ireis_t*(le-1.0));
if ((DIOY<=(-14.0)))
{
d_irei_dX = (-instanceStruct.d_instanceVar_ireis_t_dX);
irei = (-instanceStruct.instanceVar_ireis_t);
}
}
else
{
d_irei_dX = 0.0;
irei = 0.0;
}
d_Orci0_t_dX = (-instanceStruct.d_instanceVar_rci0_t_dX/instanceStruct.instanceVar_rci0_t/instanceStruct.instanceVar_rci0_t);
Orci0_t = (1.0/instanceStruct.instanceVar_rci0_t);
d_Tr_dX = modelStruct.d_modelPar_tr_dX;
Tr = modelStruct.modelPar_tr;
d_VT_f_dX = (modelStruct.modelPar_mcf*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mcf_dX*instanceStruct.instanceVar_VT);
VT_f = (modelStruct.modelPar_mcf*instanceStruct.instanceVar_VT);
{
double value_limexp_0 = limexp((Vbiei/VT_f));
double  deriv_limexp_0_d0 = ((((Vbiei/VT_f))<80)?(value_limexp_0):exp(80.0));
d_i_0f_dX = (instanceStruct.instanceVar_c10_t*deriv_limexp_0_d0*(((VT_f*d_Vbiei_dX-Vbiei*d_VT_f_dX)/VT_f/VT_f))+instanceStruct.d_instanceVar_c10_t_dX*value_limexp_0);
i_0f = (instanceStruct.instanceVar_c10_t*value_limexp_0);
}
{
double value_limexp_0 = limexp((Vbici/instanceStruct.instanceVar_VT));
double  deriv_limexp_0_d0 = ((((Vbici/instanceStruct.instanceVar_VT))<80)?(value_limexp_0):exp(80.0));
d_i_0r_dX = (instanceStruct.instanceVar_c10_t*deriv_limexp_0_d0*(((instanceStruct.instanceVar_VT*d_Vbici_dX-Vbici*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+instanceStruct.d_instanceVar_c10_t_dX*value_limexp_0);
i_0r = (instanceStruct.instanceVar_c10_t*value_limexp_0);
}
if ((instanceStruct.instanceVar_cjei0_t>0.0))
{
{
double value_log_0 = log(instanceStruct.instanceVar_ajei_t);
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zei));
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_ajei_t);
double  deriv_exp_1_d0 = value_exp_1;
d_DFV_f_dX = (instanceStruct.instanceVar_vdei_t*(-deriv_exp_1_d0*(((modelStruct.modelPar_zei*(-deriv_log_0_d0*(instanceStruct.d_instanceVar_ajei_t_dX))-(-value_log_0)*modelStruct.d_modelPar_zei_dX)/modelStruct.modelPar_zei/modelStruct.modelPar_zei)))+instanceStruct.d_instanceVar_vdei_t_dX*(1.0-value_exp_1));
DFV_f = (instanceStruct.instanceVar_vdei_t*(1.0-value_exp_1));
}
d_DFv_e_dX = ((instanceStruct.instanceVar_VT*(d_DFV_f_dX-d_Vbiei_dX)-(DFV_f-Vbiei)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
DFv_e = ((DFV_f-Vbiei)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_DFs_q_dX = deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dX+d_DFv_e_dX*DFv_e));
DFs_q = value_sqrt_0;
}
d_DFs_q2_dX = (d_DFv_e_dX+d_DFs_q_dX)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);
d_DFv_j_dX = (d_DFV_f_dX-(instanceStruct.instanceVar_VT*d_DFs_q2_dX+instanceStruct.d_instanceVar_VT_dX*DFs_q2));
DFv_j = (DFV_f-(instanceStruct.instanceVar_VT*DFs_q2));
d_DFdvj_dv_dX = ((DFs_q*d_DFs_q2_dX-DFs_q2*d_DFs_q_dX)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/instanceStruct.instanceVar_vdei_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/instanceStruct.instanceVar_vdei_t)));
d_DFb_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdei_t*d_DFv_j_dX-DFv_j*instanceStruct.d_instanceVar_vdei_t_dX)/instanceStruct.instanceVar_vdei_t/instanceStruct.instanceVar_vdei_t)));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-modelStruct.modelPar_zei)*DFb));
double  deriv_exp_0_d0 = value_exp_0;
d_DFC_j1_dX = ((instanceStruct.instanceVar_cjei0_t*value_exp_0)*d_DFdvj_dv_dX+(instanceStruct.instanceVar_cjei0_t*deriv_exp_0_d0*(((-modelStruct.modelPar_zei)*d_DFb_dX+(-modelStruct.d_modelPar_zei_dX)*DFb))+instanceStruct.d_instanceVar_cjei0_t_dX*value_exp_0)*DFdvj_dv);
DFC_j1 = ((instanceStruct.instanceVar_cjei0_t*value_exp_0)*DFdvj_dv);
}
d_Cjei_dX = (d_DFC_j1_dX+((instanceStruct.instanceVar_ajei_t*instanceStruct.instanceVar_cjei0_t)*(-d_DFdvj_dv_dX)+(instanceStruct.instanceVar_ajei_t*instanceStruct.d_instanceVar_cjei0_t_dX+instanceStruct.d_instanceVar_ajei_t_dX*instanceStruct.instanceVar_cjei0_t)*(1.0-DFdvj_dv)));
Cjei = (DFC_j1+((instanceStruct.instanceVar_ajei_t*instanceStruct.instanceVar_cjei0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-modelStruct.modelPar_zei)));
double  deriv_exp_0_d0 = value_exp_0;
d_DFQ_j_dX = (((1.0-modelStruct.modelPar_zei)*((instanceStruct.instanceVar_cjei0_t*instanceStruct.instanceVar_vdei_t)*(-deriv_exp_0_d0*((DFb*(-modelStruct.d_modelPar_zei_dX)+d_DFb_dX*(1.0-modelStruct.modelPar_zei))))+(instanceStruct.instanceVar_cjei0_t*instanceStruct.d_instanceVar_vdei_t_dX+instanceStruct.d_instanceVar_cjei0_t_dX*instanceStruct.instanceVar_vdei_t)*(1.0-value_exp_0))-((instanceStruct.instanceVar_cjei0_t*instanceStruct.instanceVar_vdei_t)*(1.0-value_exp_0))*(-modelStruct.d_modelPar_zei_dX))/(1.0-modelStruct.modelPar_zei)/(1.0-modelStruct.modelPar_zei));
DFQ_j = (((instanceStruct.instanceVar_cjei0_t*instanceStruct.instanceVar_vdei_t)*(1.0-value_exp_0))/(1.0-modelStruct.modelPar_zei));
}
d_Qjei_dX = (d_DFQ_j_dX+((instanceStruct.instanceVar_ajei_t*instanceStruct.instanceVar_cjei0_t)*(d_Vbiei_dX-d_DFv_j_dX)+(instanceStruct.instanceVar_ajei_t*instanceStruct.d_instanceVar_cjei0_t_dX+instanceStruct.d_instanceVar_ajei_t_dX*instanceStruct.instanceVar_cjei0_t)*(Vbiei-DFv_j)));
Qjei = (DFQ_j+((instanceStruct.instanceVar_ajei_t*instanceStruct.instanceVar_cjei0_t)*(Vbiei-DFv_j)));
}
else
{
d_Cjei_dX = 0.0;
Cjei = 0.0;
d_Qjei_dX = 0.0;
Qjei = 0.0;
}
if ((modelStruct.modelPar_ahjei==0.0))
{
d_hjei_vbe_dX = modelStruct.d_modelPar_hjei_dX;
hjei_vbe = modelStruct.modelPar_hjei;
}
else
{
d_vj_dX = (((modelStruct.modelPar_rhjei*instanceStruct.instanceVar_VT)*(instanceStruct.d_instanceVar_vdei_t_dX-d_Vbiei_dX)-(instanceStruct.instanceVar_vdei_t-Vbiei)*(modelStruct.modelPar_rhjei*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_rhjei_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_rhjei*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_rhjei*instanceStruct.instanceVar_VT));
vj = ((instanceStruct.instanceVar_vdei_t-Vbiei)/(modelStruct.modelPar_rhjei*instanceStruct.instanceVar_VT));
{
double value_sqrt_0 = sqrt(((vj*vj)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vj_dX = (instanceStruct.d_instanceVar_vdei_t_dX-((modelStruct.modelPar_rhjei*instanceStruct.instanceVar_VT)*(d_vj_dX+deriv_sqrt_0_d0*((vj*d_vj_dX+d_vj_dX*vj)))+(modelStruct.modelPar_rhjei*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_rhjei_dX*instanceStruct.instanceVar_VT)*(vj+value_sqrt_0))*0.5);
vj = (instanceStruct.instanceVar_vdei_t-(((modelStruct.modelPar_rhjei*instanceStruct.instanceVar_VT)*(vj+value_sqrt_0))*0.5));
}
d_vj_dX = ((instanceStruct.instanceVar_VT*(d_vj_dX-instanceStruct.d_instanceVar_VT_dX)-(vj-instanceStruct.instanceVar_VT)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
vj = ((vj-instanceStruct.instanceVar_VT)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((vj*vj)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vj_dX = (instanceStruct.instanceVar_VT*(d_vj_dX+deriv_sqrt_0_d0*((vj*d_vj_dX+d_vj_dX*vj)))*0.5+instanceStruct.d_instanceVar_VT_dX*(1.0+((vj+value_sqrt_0)*0.5)));
vj = (instanceStruct.instanceVar_VT*(1.0+((vj+value_sqrt_0)*0.5)));
}
{
double value_log_0 = log((1.0-(vj/instanceStruct.instanceVar_vdei_t)));
double value_exp_1 = exp((modelStruct.modelPar_zei*value_log_0));
double  deriv_log_0_d0 = (1.0/(1.0-(vj/instanceStruct.instanceVar_vdei_t)));
double  deriv_exp_1_d0 = value_exp_1;
d_vj_z_dX = ((1.0-value_exp_1)*instanceStruct.d_instanceVar_ahjei_t_dX+(-deriv_exp_1_d0*((modelStruct.modelPar_zei*deriv_log_0_d0*((-((instanceStruct.instanceVar_vdei_t*d_vj_dX-vj*instanceStruct.d_instanceVar_vdei_t_dX)/instanceStruct.instanceVar_vdei_t/instanceStruct.instanceVar_vdei_t)))+modelStruct.d_modelPar_zei_dX*value_log_0)))*instanceStruct.instanceVar_ahjei_t);
vj_z = ((1.0-value_exp_1)*instanceStruct.instanceVar_ahjei_t);
}
{
double value_exp_0 = exp(vj_z);
double  deriv_exp_0_d0 = value_exp_0;
d_hjei_vbe_dX = ((vj_z*(instanceStruct.instanceVar_hjei0_t*deriv_exp_0_d0*(d_vj_z_dX)+instanceStruct.d_instanceVar_hjei0_t_dX*(value_exp_0-1.0))-(instanceStruct.instanceVar_hjei0_t*(value_exp_0-1.0))*d_vj_z_dX)/vj_z/vj_z);
hjei_vbe = ((instanceStruct.instanceVar_hjei0_t*(value_exp_0-1.0))/vj_z);
}
}
if ((instanceStruct.instanceVar_vptci_t<1.0e2))
{
if ((instanceStruct.instanceVar_cjci0_t>0.0))
{
d_Dz_r_dX = (modelStruct.d_modelPar_zci_dX/4.0);
Dz_r = (modelStruct.modelPar_zci/4.0);
d_Dv_p_dX = (instanceStruct.d_instanceVar_vptci_t_dX-instanceStruct.d_instanceVar_vdci_t_dX);
Dv_p = (instanceStruct.instanceVar_vptci_t-instanceStruct.instanceVar_vdci_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zci));
double  deriv_exp_1_d0 = value_exp_1;
d_DV_f_dX = (instanceStruct.instanceVar_vdci_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zci_dX/modelStruct.modelPar_zci/modelStruct.modelPar_zci)))+instanceStruct.d_instanceVar_vdci_t_dX*(1.0-value_exp_1));
DV_f = (instanceStruct.instanceVar_vdci_t*(1.0-value_exp_1));
}
d_DC_max_dX = 2.4*instanceStruct.d_instanceVar_cjci0_t_dX;
DC_max = (2.4*instanceStruct.instanceVar_cjci0_t);
{
double value_log_0 = log((instanceStruct.instanceVar_vptci_t/instanceStruct.instanceVar_vdci_t));
double value_exp_1 = exp(((Dz_r-modelStruct.modelPar_zci)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_vptci_t/instanceStruct.instanceVar_vdci_t));
double  deriv_exp_1_d0 = value_exp_1;
d_DC_c_dX = (instanceStruct.instanceVar_cjci0_t*deriv_exp_1_d0*(((Dz_r-modelStruct.modelPar_zci)*deriv_log_0_d0*(((instanceStruct.instanceVar_vdci_t*instanceStruct.d_instanceVar_vptci_t_dX-instanceStruct.instanceVar_vptci_t*instanceStruct.d_instanceVar_vdci_t_dX)/instanceStruct.instanceVar_vdci_t/instanceStruct.instanceVar_vdci_t))+(d_Dz_r_dX-modelStruct.d_modelPar_zci_dX)*value_log_0))+instanceStruct.d_instanceVar_cjci0_t_dX*value_exp_1);
DC_c = (instanceStruct.instanceVar_cjci0_t*value_exp_1);
}
d_Dv_e_dX = ((instanceStruct.instanceVar_VT*(d_DV_f_dX-d_Vbici_dX)-(DV_f-Vbici)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
Dv_e = ((DV_f-Vbici)/instanceStruct.instanceVar_VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_e_dX);
De = value_exp_0;
}
d_De_1_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));
d_Dv_j1_dX = (d_DV_f_dX-(instanceStruct.instanceVar_VT*deriv_log_0_d0*(d_De_dX)+instanceStruct.d_instanceVar_VT_dX*value_log_0));
Dv_j1 = (DV_f-(instanceStruct.instanceVar_VT*value_log_0));
}
}
else
{
d_De_1_dX = 0.0;
De_1 = 1.0;
d_Dv_j1_dX = d_Vbici_dX;
Dv_j1 = Vbici;
}
d_Da_dX = (0.1*d_Dv_p_dX+4.0*instanceStruct.d_instanceVar_VT_dX);
Da = ((0.1*Dv_p)+(4.0*instanceStruct.instanceVar_VT));
d_Dv_r_dX = ((Da*(d_Dv_p_dX+d_Dv_j1_dX)-(Dv_p+Dv_j1)*d_Da_dX)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_r_dX);
De = value_exp_0;
}
d_De_2_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;
d_Dv_j2_dX = ((-d_Dv_p_dX)+(Da*(deriv_log_0_d0*(d_De_dX)-deriv_exp_1_d0*(((Da*(-(d_Dv_p_dX+d_DV_f_dX))-(-(Dv_p+DV_f))*d_Da_dX)/Da/Da)))+d_Da_dX*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{
d_De_2_dX = 0.0;
De_2 = 1.0;
d_Dv_j2_dX = d_Dv_j1_dX;
Dv_j2 = Dv_j1;
}
d_Dv_j4_dX = (d_Vbici_dX-d_Dv_j1_dX);
Dv_j4 = (Vbici-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/instanceStruct.instanceVar_vdci_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/instanceStruct.instanceVar_vdci_t)));
d_DCln1_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdci_t*d_Dv_j1_dX-Dv_j1*instanceStruct.d_instanceVar_vdci_t_dX)/instanceStruct.instanceVar_vdci_t/instanceStruct.instanceVar_vdci_t)));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/instanceStruct.instanceVar_vdci_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/instanceStruct.instanceVar_vdci_t)));
d_DCln2_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdci_t*d_Dv_j2_dX-Dv_j2*instanceStruct.d_instanceVar_vdci_t_dX)/instanceStruct.instanceVar_vdci_t/instanceStruct.instanceVar_vdci_t)));
DCln2 = value_log_0;
}
d_Dz1_dX = (-modelStruct.d_modelPar_zci_dX);
Dz1 = (1.0-modelStruct.modelPar_zci);
d_Dzr1_dX = (-d_Dz_r_dX);
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-modelStruct.modelPar_zci)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j1_dX = (((instanceStruct.instanceVar_cjci0_t*value_exp_0)*De_1)*d_De_2_dX+((instanceStruct.instanceVar_cjci0_t*value_exp_0)*d_De_1_dX+(instanceStruct.instanceVar_cjci0_t*deriv_exp_0_d0*((DCln2*(-modelStruct.d_modelPar_zci_dX)+d_DCln2_dX*(-modelStruct.modelPar_zci)))+instanceStruct.d_instanceVar_cjci0_t_dX*value_exp_0)*De_1)*De_2);
DC_j1 = (((instanceStruct.instanceVar_cjci0_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j2_dX = ((DC_c*value_exp_0)*(-d_De_2_dX)+(DC_c*deriv_exp_0_d0*((DCln1*(-d_Dz_r_dX)+d_DCln1_dX*(-Dz_r)))+d_DC_c_dX*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}
d_DC_j3_dX = (DC_max*(-d_De_1_dX)+d_DC_max_dX*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
d_Cjci_dX = ((d_DC_j1_dX+d_DC_j2_dX)+d_DC_j3_dX);
Cjci = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j1_dX = ((Dz1*(instanceStruct.instanceVar_cjci0_t*(-deriv_exp_0_d0*((DCln2*d_Dz1_dX+d_DCln2_dX*Dz1)))+instanceStruct.d_instanceVar_cjci0_t_dX*(1.0-value_exp_0))-(instanceStruct.instanceVar_cjci0_t*(1.0-value_exp_0))*d_Dz1_dX)/Dz1/Dz1);
DQ_j1 = ((instanceStruct.instanceVar_cjci0_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j2_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln1*d_Dzr1_dX+d_DCln1_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j3_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln2*d_Dzr1_dX+d_DCln2_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
d_Qjci_dX = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.d_instanceVar_vdci_t_dX+((d_DQ_j1_dX+d_DQ_j2_dX)-d_DQ_j3_dX)*instanceStruct.instanceVar_vdci_t)+(DC_max*d_Dv_j4_dX+d_DC_max_dX*Dv_j4));
Qjci = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.instanceVar_vdci_t)+(DC_max*Dv_j4));
}
else
{
d_Cjci_dX = 0.0;
Cjci = 0.0;
d_Qjci_dX = 0.0;
Qjci = 0.0;
}
}
else
{
if ((instanceStruct.instanceVar_cjci0_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zci));
double  deriv_exp_1_d0 = value_exp_1;
d_DFV_f_dX = (instanceStruct.instanceVar_vdci_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zci_dX/modelStruct.modelPar_zci/modelStruct.modelPar_zci)))+instanceStruct.d_instanceVar_vdci_t_dX*(1.0-value_exp_1));
DFV_f = (instanceStruct.instanceVar_vdci_t*(1.0-value_exp_1));
}
d_DFv_e_dX = ((instanceStruct.instanceVar_VT*(d_DFV_f_dX-d_Vbici_dX)-(DFV_f-Vbici)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
DFv_e = ((DFV_f-Vbici)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_DFs_q_dX = deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dX+d_DFv_e_dX*DFv_e));
DFs_q = value_sqrt_0;
}
d_DFs_q2_dX = (d_DFv_e_dX+d_DFs_q_dX)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);
d_DFv_j_dX = (d_DFV_f_dX-(instanceStruct.instanceVar_VT*d_DFs_q2_dX+instanceStruct.d_instanceVar_VT_dX*DFs_q2));
DFv_j = (DFV_f-(instanceStruct.instanceVar_VT*DFs_q2));
d_DFdvj_dv_dX = ((DFs_q*d_DFs_q2_dX-DFs_q2*d_DFs_q_dX)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/instanceStruct.instanceVar_vdci_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/instanceStruct.instanceVar_vdci_t)));
d_DFb_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdci_t*d_DFv_j_dX-DFv_j*instanceStruct.d_instanceVar_vdci_t_dX)/instanceStruct.instanceVar_vdci_t/instanceStruct.instanceVar_vdci_t)));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-modelStruct.modelPar_zci)*DFb));
double  deriv_exp_0_d0 = value_exp_0;
d_DFC_j1_dX = ((instanceStruct.instanceVar_cjci0_t*value_exp_0)*d_DFdvj_dv_dX+(instanceStruct.instanceVar_cjci0_t*deriv_exp_0_d0*(((-modelStruct.modelPar_zci)*d_DFb_dX+(-modelStruct.d_modelPar_zci_dX)*DFb))+instanceStruct.d_instanceVar_cjci0_t_dX*value_exp_0)*DFdvj_dv);
DFC_j1 = ((instanceStruct.instanceVar_cjci0_t*value_exp_0)*DFdvj_dv);
}
d_Cjci_dX = (d_DFC_j1_dX+((2.4*instanceStruct.instanceVar_cjci0_t)*(-d_DFdvj_dv_dX)+2.4*instanceStruct.d_instanceVar_cjci0_t_dX*(1.0-DFdvj_dv)));
Cjci = (DFC_j1+((2.4*instanceStruct.instanceVar_cjci0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-modelStruct.modelPar_zci)));
double  deriv_exp_0_d0 = value_exp_0;
d_DFQ_j_dX = (((1.0-modelStruct.modelPar_zci)*((instanceStruct.instanceVar_cjci0_t*instanceStruct.instanceVar_vdci_t)*(-deriv_exp_0_d0*((DFb*(-modelStruct.d_modelPar_zci_dX)+d_DFb_dX*(1.0-modelStruct.modelPar_zci))))+(instanceStruct.instanceVar_cjci0_t*instanceStruct.d_instanceVar_vdci_t_dX+instanceStruct.d_instanceVar_cjci0_t_dX*instanceStruct.instanceVar_vdci_t)*(1.0-value_exp_0))-((instanceStruct.instanceVar_cjci0_t*instanceStruct.instanceVar_vdci_t)*(1.0-value_exp_0))*(-modelStruct.d_modelPar_zci_dX))/(1.0-modelStruct.modelPar_zci)/(1.0-modelStruct.modelPar_zci));
DFQ_j = (((instanceStruct.instanceVar_cjci0_t*instanceStruct.instanceVar_vdci_t)*(1.0-value_exp_0))/(1.0-modelStruct.modelPar_zci));
}
d_Qjci_dX = (d_DFQ_j_dX+((2.4*instanceStruct.instanceVar_cjci0_t)*(d_Vbici_dX-d_DFv_j_dX)+2.4*instanceStruct.d_instanceVar_cjci0_t_dX*(Vbici-DFv_j)));
Qjci = (DFQ_j+((2.4*instanceStruct.instanceVar_cjci0_t)*(Vbici-DFv_j)));
}
else
{
d_Cjci_dX = 0.0;
Cjci = 0.0;
d_Qjci_dX = 0.0;
Qjci = 0.0;
}
}
a_bpt = 0.05;
d_Q_0_dX = ((instanceStruct.d_instanceVar_qp0_t_dX+(hjei_vbe*d_Qjei_dX+d_hjei_vbe_dX*Qjei))+(modelStruct.modelPar_hjci*d_Qjci_dX+modelStruct.d_modelPar_hjci_dX*Qjci));
Q_0 = ((instanceStruct.instanceVar_qp0_t+(hjei_vbe*Qjei))+(modelStruct.modelPar_hjci*Qjci));
d_Q_bpt_dX = a_bpt*instanceStruct.d_instanceVar_qp0_t_dX;
Q_bpt = (a_bpt*instanceStruct.instanceVar_qp0_t);
d_b_q_dX = ((Q_bpt*d_Q_0_dX-Q_0*d_Q_bpt_dX)/Q_bpt/Q_bpt);
b_q = ((Q_0/Q_bpt)-1);
{
double value_sqrt_0 = sqrt(((b_q*b_q)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_0_dX = (Q_bpt*((d_b_q_dX+deriv_sqrt_0_d0*((b_q*d_b_q_dX+d_b_q_dX*b_q)))/2)+d_Q_bpt_dX*(1+((b_q+value_sqrt_0)/2)));
Q_0 = (Q_bpt*(1+((b_q+value_sqrt_0)/2)));
}
if ((instanceStruct.instanceVar_cjci0_t>0.0))
//Begin block CJMODF
{
//Block-local variables for block CJMODF
double cV_f=0.0;
double d_cV_f_dX=0.0;
double cv_e=0.0;
double d_cv_e_dX=0.0;
double cs_q=0.0;
double d_cs_q_dX=0.0;
double cs_q2=0.0;
double d_cs_q2_dX=0.0;
double cv_j=0.0;
double d_cv_j_dX=0.0;
double cdvj_dv=0.0;
double d_cdvj_dv_dX=0.0;
//End of Block-local variables
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zci));
double  deriv_exp_1_d0 = value_exp_1;
d_cV_f_dX = (instanceStruct.instanceVar_vdci_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zci_dX/modelStruct.modelPar_zci/modelStruct.modelPar_zci)))+instanceStruct.d_instanceVar_vdci_t_dX*(1.0-value_exp_1));
cV_f = (instanceStruct.instanceVar_vdci_t*(1.0-value_exp_1));
}
d_cv_e_dX = ((instanceStruct.instanceVar_VT*(d_cV_f_dX-d_Vbici_dX)-(cV_f-Vbici)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
cv_e = ((cV_f-Vbici)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((cv_e*cv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_cs_q_dX = deriv_sqrt_0_d0*((cv_e*d_cv_e_dX+d_cv_e_dX*cv_e));
cs_q = value_sqrt_0;
}
d_cs_q2_dX = (d_cv_e_dX+d_cs_q_dX)*0.5;
cs_q2 = ((cv_e+cs_q)*0.5);
d_cv_j_dX = (d_cV_f_dX-(instanceStruct.instanceVar_VT*d_cs_q2_dX+instanceStruct.d_instanceVar_VT_dX*cs_q2));
cv_j = (cV_f-(instanceStruct.instanceVar_VT*cs_q2));
d_cdvj_dv_dX = ((cs_q*d_cs_q2_dX-cs_q2*d_cs_q_dX)/cs_q/cs_q);
cdvj_dv = (cs_q2/cs_q);
{
double value_log_0 = log((1.0-(cv_j/instanceStruct.instanceVar_vdci_t)));
double value_exp_1 = exp(((-modelStruct.modelPar_zci)*value_log_0));
double  deriv_log_0_d0 = (1.0/(1.0-(cv_j/instanceStruct.instanceVar_vdci_t)));
double  deriv_exp_1_d0 = value_exp_1;
d_Cjcit_dX = (((instanceStruct.instanceVar_cjci0_t*value_exp_1)*d_cdvj_dv_dX+(instanceStruct.instanceVar_cjci0_t*deriv_exp_1_d0*(((-modelStruct.modelPar_zci)*deriv_log_0_d0*((-((instanceStruct.instanceVar_vdci_t*d_cv_j_dX-cv_j*instanceStruct.d_instanceVar_vdci_t_dX)/instanceStruct.instanceVar_vdci_t/instanceStruct.instanceVar_vdci_t)))+(-modelStruct.d_modelPar_zci_dX)*value_log_0))+instanceStruct.d_instanceVar_cjci0_t_dX*value_exp_1)*cdvj_dv)+((2.4*instanceStruct.instanceVar_cjci0_t)*(-d_cdvj_dv_dX)+2.4*instanceStruct.d_instanceVar_cjci0_t_dX*(1.0-cdvj_dv)));
Cjcit = (((instanceStruct.instanceVar_cjci0_t*value_exp_1)*cdvj_dv)+((2.4*instanceStruct.instanceVar_cjci0_t)*(1.0-cdvj_dv)));
}
}
// End block CJMODF
else
{
d_Cjcit_dX = 0.0;
Cjcit = 0.0;
}
if ((Cjcit>0.0))
{
d_cc_dX = ((Cjcit*instanceStruct.d_instanceVar_cjci0_t_dX-instanceStruct.instanceVar_cjci0_t*d_Cjcit_dX)/Cjcit/Cjcit);
cc = (instanceStruct.instanceVar_cjci0_t/Cjcit);
}
else
{
d_cc_dX = 0.0;
cc = 1.0;
}
d_T_f0_dX = ((instanceStruct.d_instanceVar_t0_t_dX+(modelStruct.modelPar_dt0h*d_cc_dX+modelStruct.d_modelPar_dt0h_dX*(cc-1.0)))+(modelStruct.modelPar_tbvl*(-1*d_cc_dX/cc/cc)+modelStruct.d_modelPar_tbvl_dX*((1/cc)-1.0)));
T_f0 = ((instanceStruct.instanceVar_t0_t+(modelStruct.modelPar_dt0h*(cc-1.0)))+(modelStruct.modelPar_tbvl*((1/cc)-1.0)));
d_vc_dX = (d_Vciei_dX-instanceStruct.d_instanceVar_vces_t_dX);
vc = (Vciei-instanceStruct.instanceVar_vces_t);
//Begin block HICICK
{
d_Ovpt_dX = (-modelStruct.d_modelPar_vpt_dX/modelStruct.modelPar_vpt/modelStruct.modelPar_vpt);
Ovpt = (1.0/modelStruct.modelPar_vpt);
instanceStruct.d_instanceVar_a_dX = ((instanceStruct.instanceVar_VT*d_vc_dX-vc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
instanceStruct.instanceVar_a = (vc/instanceStruct.instanceVar_VT);
d_d1_dX = instanceStruct.d_instanceVar_a_dX;
d1 = (instanceStruct.instanceVar_a-1);
{
double value_sqrt_0 = sqrt(((d1*d1)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vceff_dX = ((1.0+((d1+value_sqrt_0)/2))*instanceStruct.d_instanceVar_VT_dX+((d_d1_dX+deriv_sqrt_0_d0*((d1*d_d1_dX+d_d1_dX*d1)))/2)*instanceStruct.instanceVar_VT);
vceff = ((1.0+((d1+value_sqrt_0)/2))*instanceStruct.instanceVar_VT);
}
d_a1_dX = ((instanceStruct.instanceVar_vlim_t*d_vceff_dX-vceff*instanceStruct.d_instanceVar_vlim_t_dX)/instanceStruct.instanceVar_vlim_t/instanceStruct.instanceVar_vlim_t);
a1 = (vceff/instanceStruct.instanceVar_vlim_t);
d_a11_dX = (vceff*d_Orci0_t_dX+d_vceff_dX*Orci0_t);
a11 = (vceff*Orci0_t);
d_Odelck_dX = (-1*modelStruct.d_modelPar_delck_dX/modelStruct.modelPar_delck/modelStruct.modelPar_delck);
Odelck = (1/modelStruct.modelPar_delck);
{
double value_log_0 = log(a1);
double value_exp_1 = exp((modelStruct.modelPar_delck*value_log_0));
double value_log_2 = log((1+value_exp_1));
double value_exp_3 = exp((Odelck*value_log_2));
double  deriv_log_0_d0 = (1.0/a1);
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(1+value_exp_1));
double  deriv_exp_3_d0 = value_exp_3;
d_ick1_dX = deriv_exp_3_d0*((Odelck*deriv_log_2_d0*(deriv_exp_1_d0*((modelStruct.modelPar_delck*deriv_log_0_d0*(d_a1_dX)+modelStruct.d_modelPar_delck_dX*value_log_0)))+d_Odelck_dX*value_log_2));
ick1 = value_exp_3;
}
d_ick2_dX = ((ick1*d_a11_dX-a11*d_ick1_dX)/ick1/ick1);
ick2 = (a11/ick1);
d_ICKa_dX = ((vceff-instanceStruct.instanceVar_vlim_t)*d_Ovpt_dX+(d_vceff_dX-instanceStruct.d_instanceVar_vlim_t_dX)*Ovpt);
ICKa = ((vceff-instanceStruct.instanceVar_vlim_t)*Ovpt);
{
double value_sqrt_0 = sqrt(((ICKa*ICKa)+modelStruct.modelPar_aick));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ick_dX = (ick2*0.5*(d_ICKa_dX+deriv_sqrt_0_d0*(((ICKa*d_ICKa_dX+d_ICKa_dX*ICKa)+modelStruct.d_modelPar_aick_dX)))+d_ick2_dX*(1.0+(0.5*(ICKa+value_sqrt_0))));
ick = (ick2*(1.0+(0.5*(ICKa+value_sqrt_0))));
}
}
// End block HICICK
d_Q_p_dX = d_Q_0_dX;
Q_p = Q_0;
if (((T_f0>0.0)||(Tr>0.0)))
{
d_A_dX = 0.5*d_Q_0_dX;
A = (0.5*Q_0);
{
double value_sqrt_0 = sqrt((((A*A)+(T_f0*i_0f))+(Tr*i_0r)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_p_dX = (d_A_dX+deriv_sqrt_0_d0*((((A*d_A_dX+d_A_dX*A)+(T_f0*d_i_0f_dX+d_T_f0_dX*i_0f))+(Tr*d_i_0r_dX+d_Tr_dX*i_0r))));
Q_p = (A+value_sqrt_0);
}
}
d_I_Tf1_dX = ((Q_p*d_i_0f_dX-i_0f*d_Q_p_dX)/Q_p/Q_p);
I_Tf1 = (i_0f/Q_p);
d_a_h_dX = (instanceStruct.instanceVar_Oich*d_I_Tf1_dX+instanceStruct.d_instanceVar_Oich_dX*I_Tf1);
a_h = (instanceStruct.instanceVar_Oich*I_Tf1);
d_itf_dX = (I_Tf1*d_a_h_dX+d_I_Tf1_dX*(1.0+a_h));
itf = (I_Tf1*(1.0+a_h));
d_itr_dX = ((Q_p*d_i_0r_dX-i_0r*d_Q_p_dX)/Q_p/Q_p);
itr = (i_0r/Q_p);
d_Q_bf_dX = 0.0;
Q_bf = 0.0;
instanceStruct.d_instanceVar_Tf_dX = d_T_f0_dX;
instanceStruct.instanceVar_Tf = T_f0;
d_Qf_dX = (T_f0*d_itf_dX+d_T_f0_dX*itf);
Qf = (T_f0*itf);
if ((itf<(1.0e-6*ick)))
{
d_Q_fT_dX = d_Qf_dX;
Q_fT = Qf;
d_T_fT_dX = instanceStruct.d_instanceVar_Tf_dX;
T_fT = instanceStruct.instanceVar_Tf;
d_Q_bf_dX = 0.0;
Q_bf = 0;
}
else
{
d_FFitf_ick_dX = ((ick*d_itf_dX-itf*d_ick_dX)/ick/ick);
FFitf_ick = (itf/ick);
{
double value_log_0 = log(FFitf_ick);
double value_exp_1 = exp((modelStruct.modelPar_gtfe*value_log_0));
double  deriv_log_0_d0 = (1.0/FFitf_ick);
double  deriv_exp_1_d0 = value_exp_1;
d_FFdTef_dX = (instanceStruct.instanceVar_tef0_t*deriv_exp_1_d0*((modelStruct.modelPar_gtfe*deriv_log_0_d0*(d_FFitf_ick_dX)+modelStruct.d_modelPar_gtfe_dX*value_log_0))+instanceStruct.d_instanceVar_tef0_t_dX*value_exp_1);
FFdTef = (instanceStruct.instanceVar_tef0_t*value_exp_1);
}
d_FFdQef_dX = (((1+modelStruct.modelPar_gtfe)*(FFdTef*d_itf_dX+d_FFdTef_dX*itf)-(FFdTef*itf)*modelStruct.d_modelPar_gtfe_dX)/(1+modelStruct.modelPar_gtfe)/(1+modelStruct.modelPar_gtfe));
FFdQef = ((FFdTef*itf)/(1+modelStruct.modelPar_gtfe));
if ((modelStruct.modelPar_icbar<(0.05*(modelStruct.modelPar_vlim/modelStruct.modelPar_rci0))))
{
d_FFdVc_dX = 0.0;
FFdVc = 0;
d_FFdVc_ditf_dX = 0.0;
FFdVc_ditf = 0;
}
else
{
d_FFib_dX = ((modelStruct.modelPar_icbar*(d_itf_dX-d_ick_dX)-(itf-ick)*modelStruct.d_modelPar_icbar_dX)/modelStruct.modelPar_icbar/modelStruct.modelPar_icbar);
FFib = ((itf-ick)/modelStruct.modelPar_icbar);
if ((FFib<(-1.0e10)))
{
d_FFib_dX = 0.0;
FFib = (-1.0e10);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+modelStruct.modelPar_acbar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFfcbar_dX = ((d_FFib_dX+deriv_sqrt_0_d0*(((FFib*d_FFib_dX+d_FFib_dX*FFib)+modelStruct.d_modelPar_acbar_dX)))/2.0);
FFfcbar = ((FFib+value_sqrt_0)/2.0);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+modelStruct.modelPar_acbar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFdib_ditf_dX = ((modelStruct.modelPar_icbar*((value_sqrt_0*d_FFfcbar_dX-FFfcbar*deriv_sqrt_0_d0*(((FFib*d_FFib_dX+d_FFib_dX*FFib)+modelStruct.d_modelPar_acbar_dX)))/value_sqrt_0/value_sqrt_0)-(FFfcbar/value_sqrt_0)*modelStruct.d_modelPar_icbar_dX)/modelStruct.modelPar_icbar/modelStruct.modelPar_icbar);
FFdib_ditf = ((FFfcbar/value_sqrt_0)/modelStruct.modelPar_icbar);
}
{
double value_exp_0 = exp(((-1.0)/FFfcbar));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdVc_dX = (modelStruct.modelPar_vcbar*deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dX/FFfcbar/FFfcbar))+modelStruct.d_modelPar_vcbar_dX*value_exp_0);
FFdVc = (modelStruct.modelPar_vcbar*value_exp_0);
}
d_FFdVc_ditf_dX = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dX+(((FFfcbar*FFfcbar)*d_FFdVc_dX-FFdVc*(FFfcbar*d_FFfcbar_dX+d_FFfcbar_dX*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
}
{
double value_exp_0 = exp((FFdVc/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQbfb_dX = ((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*d_FFdVc_dX-FFdVc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*d_itf_dX+((1-modelStruct.modelPar_fthc)*instanceStruct.d_instanceVar_thcs_t_dX+(-modelStruct.d_modelPar_fthc_dX)*instanceStruct.instanceVar_thcs_t)*itf)*(value_exp_0-1));
FFdQbfb = ((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*(value_exp_0-1));
}
{
double value_exp_0 = exp((FFdVc/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTbfb_dX = (((itf*d_FFdQbfb_dX-FFdQbfb*d_itf_dX)/itf/itf)+((((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*d_FFdVc_dX-FFdVc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*d_itf_dX+((1-modelStruct.modelPar_fthc)*instanceStruct.d_instanceVar_thcs_t_dX+(-modelStruct.d_modelPar_fthc_dX)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)-((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTbfb = ((FFdQbfb/itf)+((((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
d_FFic_dX = (-(-d_FFitf_ick_dX/FFitf_ick/FFitf_ick));
FFic = (1-(1.0/FFitf_ick));
{
double value_sqrt_0 = sqrt(((FFic*FFic)+modelStruct.modelPar_ahc));
double value_sqrt_1 = sqrt((1+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_FFw_dX = (((1+value_sqrt_1)*(d_FFic_dX+deriv_sqrt_0_d0*(((FFic*d_FFic_dX+d_FFic_dX*FFic)+modelStruct.d_modelPar_ahc_dX)))-(FFic+value_sqrt_0)*deriv_sqrt_1_d0*(modelStruct.d_modelPar_ahc_dX))/(1+value_sqrt_1)/(1+value_sqrt_1));
FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQfhc_dX = ((((instanceStruct.instanceVar_thcs_t*itf)*FFw)*FFw)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((instanceStruct.instanceVar_thcs_t*itf)*FFw)*d_FFw_dX+((instanceStruct.instanceVar_thcs_t*itf)*d_FFw_dX+(instanceStruct.instanceVar_thcs_t*d_itf_dX+instanceStruct.d_instanceVar_thcs_t_dX*itf)*FFw)*FFw)*value_exp_0);
FFdQfhc = ((((instanceStruct.instanceVar_thcs_t*itf)*FFw)*FFw)*value_exp_0);
}
{
double value_sqrt_0 = sqrt(((FFic*FFic)+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFdTfhc_dX = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*deriv_sqrt_0_d0*(((FFic*d_FFic_dX+d_FFic_dX*FFic)+modelStruct.d_modelPar_ahc_dX))+d_FFitf_ick_dX*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dX/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+(-instanceStruct.d_instanceVar_VT_dX/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf))+d_FFdQfhc_dX*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*FFdVc_ditf)));
FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*FFdVc_ditf)));
}
if (((modelStruct.modelPar_latb<=0.0)&&(modelStruct.modelPar_latl<=0.0)))
{
d_FFdQcfc_dX = (modelStruct.modelPar_fthc*d_FFdQfhc_dX+modelStruct.d_modelPar_fthc_dX*FFdQfhc);
FFdQcfc = (modelStruct.modelPar_fthc*FFdQfhc);
d_FFdTcfc_dX = (modelStruct.modelPar_fthc*d_FFdTfhc_dX+modelStruct.d_modelPar_fthc_dX*FFdTfhc);
FFdTcfc = (modelStruct.modelPar_fthc*FFdTfhc);
d_FFdQcfcT_dX = d_FFdQcfc_dX;
FFdQcfcT = FFdQcfc;
d_FFdTcfcT_dX = d_FFdTcfc_dX;
FFdTcfcT = FFdTcfc;
}
else
{
d_FFdQcfc_dX = ((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*d_itf_dX+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*itf);
FFdQcfc = ((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*itf);
d_FCa_dX = (-((itf*d_ick_dX-ick*d_itf_dX)/itf/itf));
FCa = (1.0-(ick/itf));
{
double value_sqrt_0 = sqrt(((FCa*FCa)+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FCrt_dX = deriv_sqrt_0_d0*(((FCa*d_FCa_dX+d_FCa_dX*FCa)+modelStruct.d_modelPar_ahc_dX));
FCrt = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((1.0+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FCa_ck_dX = (-(((1.0+value_sqrt_0)*(d_FCa_dX+d_FCrt_dX)-(FCa+FCrt)*deriv_sqrt_0_d0*(modelStruct.d_modelPar_ahc_dX))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0)));
FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
}
d_FCdaick_ditf_dX = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dX)+d_FCa_ck_dX*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dX+d_FCrt_dX*itf))/(FCrt*itf)/(FCrt*itf));
FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
if ((modelStruct.modelPar_latb>modelStruct.modelPar_latl))
{
d_FCz_dX = (modelStruct.d_modelPar_latb_dX-modelStruct.d_modelPar_latl_dX);
FCz = (modelStruct.modelPar_latb-modelStruct.modelPar_latl);
d_FCxl_dX = modelStruct.d_modelPar_latl_dX;
FCxl = (1.0+modelStruct.modelPar_latl);
d_FCxb_dX = modelStruct.d_modelPar_latb_dX;
FCxb = (1.0+modelStruct.modelPar_latb);
if ((modelStruct.modelPar_latb>0.01))
{
{
double value_log_0 = log((FCxb/FCxl));
double  deriv_log_0_d0 = (1.0/(FCxb/FCxl));
d_FCln_dX = deriv_log_0_d0*(((FCxl*d_FCxb_dX-FCxb*d_FCxl_dX)/FCxl/FCxl));
FCln = value_log_0;
}
{
double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
double  deriv_exp_0_d0 = value_exp_0;
d_FCa1_dX = deriv_exp_0_d0*(((FCa_ck-1.0)*d_FCln_dX+d_FCa_ck_dX*FCln));
FCa1 = value_exp_0;
}
d_FCd_a_dX = (-(modelStruct.d_modelPar_latl_dX-(FCa1*modelStruct.d_modelPar_latb_dX+d_FCa1_dX*modelStruct.modelPar_latb))/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb))/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb)));
FCd_a = (1.0/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb)));
d_FCw_dX = ((FCa1-1.0)*d_FCd_a_dX+d_FCa1_dX*FCd_a);
FCw = ((FCa1-1.0)*FCd_a);
d_FCdw_daick_dX = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dX+((((-FCz)*FCa1)*FCln)*d_FCd_a_dX+(((-FCz)*FCa1)*d_FCln_dX+((-FCz)*d_FCa1_dX+(-d_FCz_dX)*FCa1)*FCln)*FCd_a)*FCd_a);
FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
{
double value_log_0 = log(((1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
double  deriv_log_0_d0 = (1.0/((1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
d_FCa1_dX = deriv_log_0_d0*((((1.0+(modelStruct.modelPar_latl*FCw))*(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw)-(1.0+(modelStruct.modelPar_latb*FCw))*(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
FCa1 = value_log_0;
}
d_FCda1_dw_dX = ((((1.0+(modelStruct.modelPar_latb*FCw))*modelStruct.d_modelPar_latb_dX-modelStruct.modelPar_latb*(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw))/(1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latb*FCw)))-(((1.0+(modelStruct.modelPar_latl*FCw))*modelStruct.d_modelPar_latl_dX-modelStruct.modelPar_latl*(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
FCda1_dw = ((modelStruct.modelPar_latb/(1.0+(modelStruct.modelPar_latb*FCw)))-(modelStruct.modelPar_latl/(1.0+(modelStruct.modelPar_latl*FCw))));
}
else
{
d_FCf1_dX = (-d_FCa_ck_dX);
FCf1 = (1.0-FCa_ck);
d_FCd_a_dX = (-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb)/(1.0+(FCa_ck*modelStruct.modelPar_latb))/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
FCd_a = (1.0/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
d_FCw_dX = (FCf1*d_FCd_a_dX+d_FCf1_dX*FCd_a);
FCw = (FCf1*FCd_a);
d_FCdw_daick_dX = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dX+((((-1.0)*FCd_a)*FCd_a)*d_FCxb_dX+(((-1.0)*FCd_a)*d_FCd_a_dX+(-1.0)*d_FCd_a_dX*FCd_a)*FCxb)*FCd_a);
FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);
d_FCa1_dX = (FCz*d_FCw_dX+d_FCz_dX*FCw);
FCa1 = (FCz*FCw);
d_FCda1_dw_dX = d_FCz_dX;
FCda1_dw = FCz;
}
d_FCf_CT_dX = (-2.0*d_FCz_dX/FCz/FCz);
FCf_CT = (2.0/FCz);
d_FCw2_dX = (FCw*d_FCw_dX+d_FCw_dX*FCw);
FCw2 = (FCw*FCw);
d_FCf1_dX = ((((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw)*d_FCw2_dX+((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*d_FCw_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latl)*FCw)*FCw2)/3.0)+(((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*d_FCw2_dX+(modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latl_dX)*FCw2)/2.0))+d_FCw_dX);
FCf1 = ((((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw)*FCw2)/3.0)+(((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*FCw2)/2.0))+FCw);
d_FCdf1_dw_dX = (((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*d_FCw2_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latl)*FCw2)+((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*d_FCw_dX+(modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latl_dX)*FCw));
FCdf1_dw = ((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw2)+((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*FCw))+1.0);
d_z_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
z = (modelStruct.modelPar_latb*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latb*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latb*FCw)));
d_lnzb_dX = deriv_log_0_d0*((modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{
d_x_dX = d_z_dX;
x = (1.0+z);
instanceStruct.d_instanceVar_a_dX = (x*d_x_dX+d_x_dX*x);
instanceStruct.instanceVar_a = (x*x);
d_a2_dX = 0.250*(instanceStruct.instanceVar_a*2.0*d_lnzb_dX+instanceStruct.d_instanceVar_a_dX*((2.0*lnzb)-1.0));
a2 = (0.250*((instanceStruct.instanceVar_a*((2.0*lnzb)-1.0))+1.0));
d_a3_dX = (((instanceStruct.instanceVar_a*x)*3.0*d_lnzb_dX+(instanceStruct.instanceVar_a*d_x_dX+instanceStruct.d_instanceVar_a_dX*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((instanceStruct.instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
d_r_dX = ((modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX-modelStruct.modelPar_latl*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
r = (modelStruct.modelPar_latl/modelStruct.modelPar_latb);
d_FCf2_dX = ((modelStruct.modelPar_latb*(((1.0-r)*d_a2_dX+(-d_r_dX)*a2)+(r*d_a3_dX+d_r_dX*a3))-(((1.0-r)*a2)+(r*a3))*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
FCf2 = ((((1.0-r)*a2)+(r*a3))/modelStruct.modelPar_latb);
d_FCdf2_dw_dX = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*d_lnzb_dX+(((1.0-r)*d_x_dX+(-d_r_dX)*x)+(r*instanceStruct.d_instanceVar_a_dX+d_r_dX*instanceStruct.instanceVar_a))*lnzb);
FCdf2_dw = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*lnzb);
}
else
{
instanceStruct.d_instanceVar_a_dX = (z*d_z_dX+d_z_dX*z);
instanceStruct.instanceVar_a = (z*z);
d_a2_dX = ((d_z_dX-0.25*instanceStruct.d_instanceVar_a_dX)+((0.10*z)*instanceStruct.d_instanceVar_a_dX+0.10*d_z_dX*instanceStruct.instanceVar_a));
a2 = (((3.0+z)-(0.25*instanceStruct.instanceVar_a))+((0.10*z)*instanceStruct.instanceVar_a));
d_a3_dX = ((2.0*d_z_dX+0.75*instanceStruct.d_instanceVar_a_dX)-((0.20*instanceStruct.instanceVar_a)*d_z_dX+0.20*instanceStruct.d_instanceVar_a_dX*z));
a3 = (((2.0*z)+(0.75*instanceStruct.instanceVar_a))-((0.20*instanceStruct.instanceVar_a)*z));
d_FCf2_dX = (((((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*FCw)*d_FCw_dX+(((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*d_FCw_dX+((modelStruct.modelPar_latb*d_a2_dX+modelStruct.d_modelPar_latb_dX*a2)+(modelStruct.modelPar_latl*d_a3_dX+modelStruct.d_modelPar_latl_dX*a3))*FCw)*FCw)/6.0);
FCf2 = (((((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*FCw)*FCw)/6.0);
d_FCdf2_dw_dX = (((1+(modelStruct.modelPar_latl*FCw))*(1+z))*d_lnzb_dX+((1+(modelStruct.modelPar_latl*FCw))*d_z_dX+(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw)*(1+z))*lnzb);
FCdf2_dw = (((1+(modelStruct.modelPar_latl*FCw))*(1+z))*lnzb);
}
d_z_dX = (modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw);
z = (modelStruct.modelPar_latl*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latl*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latl*FCw)));
d_lnzb_dX = deriv_log_0_d0*((modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{
d_x_dX = d_z_dX;
x = (1.0+z);
instanceStruct.d_instanceVar_a_dX = (x*d_x_dX+d_x_dX*x);
instanceStruct.instanceVar_a = (x*x);
d_a2_dX = 0.250*(instanceStruct.instanceVar_a*2.0*d_lnzb_dX+instanceStruct.d_instanceVar_a_dX*((2.0*lnzb)-1.0));
a2 = (0.250*((instanceStruct.instanceVar_a*((2.0*lnzb)-1.0))+1.0));
d_a3_dX = (((instanceStruct.instanceVar_a*x)*3.0*d_lnzb_dX+(instanceStruct.instanceVar_a*d_x_dX+instanceStruct.d_instanceVar_a_dX*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((instanceStruct.instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
d_r_dX = ((modelStruct.modelPar_latl*modelStruct.d_modelPar_latb_dX-modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
r = (modelStruct.modelPar_latb/modelStruct.modelPar_latl);
d_FCf3_dX = ((modelStruct.modelPar_latl*(((1.0-r)*d_a2_dX+(-d_r_dX)*a2)+(r*d_a3_dX+d_r_dX*a3))-(((1.0-r)*a2)+(r*a3))*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
FCf3 = ((((1.0-r)*a2)+(r*a3))/modelStruct.modelPar_latl);
d_FCdf3_dw_dX = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*d_lnzb_dX+(((1.0-r)*d_x_dX+(-d_r_dX)*x)+(r*instanceStruct.d_instanceVar_a_dX+d_r_dX*instanceStruct.instanceVar_a))*lnzb);
FCdf3_dw = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*lnzb);
}
else
{
instanceStruct.d_instanceVar_a_dX = (z*d_z_dX+d_z_dX*z);
instanceStruct.instanceVar_a = (z*z);
d_a2_dX = ((d_z_dX-0.25*instanceStruct.d_instanceVar_a_dX)+((0.10*z)*instanceStruct.d_instanceVar_a_dX+0.10*d_z_dX*instanceStruct.instanceVar_a));
a2 = (((3.0+z)-(0.25*instanceStruct.instanceVar_a))+((0.10*z)*instanceStruct.instanceVar_a));
d_a3_dX = ((2.0*d_z_dX+0.75*instanceStruct.d_instanceVar_a_dX)-((0.20*instanceStruct.instanceVar_a)*d_z_dX+0.20*instanceStruct.d_instanceVar_a_dX*z));
a3 = (((2.0*z)+(0.75*instanceStruct.instanceVar_a))-((0.20*instanceStruct.instanceVar_a)*z));
d_FCf3_dX = (((((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*FCw)*d_FCw_dX+(((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*d_FCw_dX+((modelStruct.modelPar_latl*d_a2_dX+modelStruct.d_modelPar_latl_dX*a2)+(modelStruct.modelPar_latb*d_a3_dX+modelStruct.d_modelPar_latb_dX*a3))*FCw)*FCw)/6.0);
FCf3 = (((((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*FCw)*FCw)/6.0);
d_FCdf3_dw_dX = (((1+(modelStruct.modelPar_latb*FCw))*(1+z))*d_lnzb_dX+((1+(modelStruct.modelPar_latb*FCw))*d_z_dX+(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw)*(1+z))*lnzb);
FCdf3_dw = (((1+(modelStruct.modelPar_latb*FCw))*(1+z))*lnzb);
}
d_FCf_ci_dX = (FCf_CT*(((FCa1*d_FCf1_dX+d_FCa1_dX*FCf1)-d_FCf2_dX)+d_FCf3_dX)+d_FCf_CT_dX*(((FCa1*FCf1)-FCf2)+FCf3));
FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCdfc_dw_dX = (FCf_CT*((((FCa1*d_FCdf1_dw_dX+d_FCa1_dX*FCdf1_dw)+(FCda1_dw*d_FCf1_dX+d_FCda1_dw_dX*FCf1))-d_FCdf2_dw_dX)+d_FCdf3_dw_dX)+d_FCf_CT_dX*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdw_ditf_dX = (FCdw_daick*d_FCdaick_ditf_dX+d_FCdw_daick_dX*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);
d_FCdfc_ditf_dX = (FCdfc_dw*d_FCdw_ditf_dX+d_FCdfc_dw_dX*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
instanceStruct.instanceVar_a = (modelStruct.modelPar_latb*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latb*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latb*FCw)));
d_lnz_dX = deriv_log_0_d0*((modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw));
lnz = value_log_0;
}
if ((instanceStruct.instanceVar_a>1.0e-6))
{
d_FCf2_dX = ((modelStruct.modelPar_latb*(instanceStruct.d_instanceVar_a_dX-d_lnz_dX)-(instanceStruct.instanceVar_a-lnz)*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
FCf2 = ((instanceStruct.instanceVar_a-lnz)/modelStruct.modelPar_latb);
d_FCdf2_dw_dX = (((1.0+instanceStruct.instanceVar_a)*instanceStruct.d_instanceVar_a_dX-instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX)/(1.0+instanceStruct.instanceVar_a)/(1.0+instanceStruct.instanceVar_a));
FCdf2_dw = (instanceStruct.instanceVar_a/(1.0+instanceStruct.instanceVar_a));
}
else
{
d_FCf2_dX = ((0.5*instanceStruct.instanceVar_a)*d_FCw_dX+0.5*instanceStruct.d_instanceVar_a_dX*FCw);
FCf2 = ((0.5*instanceStruct.instanceVar_a)*FCw);
d_FCdf2_dw_dX = instanceStruct.d_instanceVar_a_dX;
FCdf2_dw = instanceStruct.instanceVar_a;
}
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw);
instanceStruct.instanceVar_a = (modelStruct.modelPar_latl*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latl*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latl*FCw)));
d_lnz_dX = deriv_log_0_d0*((modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw));
lnz = value_log_0;
}
if ((instanceStruct.instanceVar_a>1.0e-6))
{
d_FCf3_dX = ((modelStruct.modelPar_latl*(instanceStruct.d_instanceVar_a_dX-d_lnz_dX)-(instanceStruct.instanceVar_a-lnz)*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
FCf3 = ((instanceStruct.instanceVar_a-lnz)/modelStruct.modelPar_latl);
d_FCdf3_dw_dX = (((1.0+instanceStruct.instanceVar_a)*instanceStruct.d_instanceVar_a_dX-instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX)/(1.0+instanceStruct.instanceVar_a)/(1.0+instanceStruct.instanceVar_a));
FCdf3_dw = (instanceStruct.instanceVar_a/(1.0+instanceStruct.instanceVar_a));
}
else
{
d_FCf3_dX = ((0.5*instanceStruct.instanceVar_a)*d_FCw_dX+0.5*instanceStruct.d_instanceVar_a_dX*FCw);
FCf3 = ((0.5*instanceStruct.instanceVar_a)*FCw);
d_FCdf3_dw_dX = instanceStruct.d_instanceVar_a_dX;
FCdf3_dw = instanceStruct.instanceVar_a;
}
d_FCf_CT_dX = (FCf_CT*(d_FCf2_dX-d_FCf3_dX)+d_FCf_CT_dX*(FCf2-FCf3));
FCf_CT = (FCf_CT*(FCf2-FCf3));
d_FCdfCT_dw_dX = (FCf_CT*(d_FCdf2_dw_dX-d_FCdf3_dw_dX)+d_FCf_CT_dX*(FCdf2_dw-FCdf3_dw));
FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_ditf_dX = (FCdfCT_dw*d_FCdw_ditf_dX+d_FCdfCT_dw_dX*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{
d_FCf_CT_dX = d_FCf_ci_dX;
FCf_CT = FCf_ci;
d_FCdfCT_ditf_dX = d_FCdfc_ditf_dX;
FCdfCT_ditf = FCdfc_ditf;
}
}
else
{
if ((modelStruct.modelPar_latb>0.01))
{
d_FCd_a_dX = (-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb)/(1.0+(FCa_ck*modelStruct.modelPar_latb))/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
FCd_a = (1.0/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
d_FCw_dX = ((1.0-FCa_ck)*d_FCd_a_dX+(-d_FCa_ck_dX)*FCd_a);
FCw = ((1.0-FCa_ck)*FCd_a);
d_FCdw_daick_dX = (((-(1.0+modelStruct.modelPar_latb))*FCd_a)*d_FCd_a_dX+((-(1.0+modelStruct.modelPar_latb))*d_FCd_a_dX+(-modelStruct.d_modelPar_latb_dX)*FCd_a)*FCd_a);
FCdw_daick = (((-(1.0+modelStruct.modelPar_latb))*FCd_a)*FCd_a);
}
else
{
d_FCw_dX = ((-d_FCa_ck_dX)-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb));
FCw = ((1.0-FCa_ck)-(FCa_ck*modelStruct.modelPar_latb));
d_FCdw_daick_dX = (-modelStruct.d_modelPar_latb_dX);
FCdw_daick = (-(1.0+modelStruct.modelPar_latb));
}
d_FCw2_dX = (FCw*d_FCw_dX+d_FCw_dX*FCw);
FCw2 = (FCw*FCw);
d_FCz_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
FCz = (modelStruct.modelPar_latb*FCw);
d_FCz_1_dX = d_FCz_dX;
FCz_1 = (1.0+FCz);
d_FCd_f_dX = (-d_FCz_1_dX/FCz_1/FCz_1);
FCd_f = (1.0/FCz_1);
d_FCf_ci_dX = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dX+(FCw2*(d_FCz_dX/3.0)+d_FCw2_dX*(1.0+(FCz/3.0)))*FCd_f);
FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);
d_FCdfc_dw_dX = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dX+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dX+((2.0*FCw)*(d_FCz_1_dX+((FCz*d_FCz_dX+d_FCz_dX*FCz)/3.0))+2.0*d_FCw_dX*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdw_ditf_dX = (FCdw_daick*d_FCdaick_ditf_dX+d_FCdw_daick_dX*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);
d_FCdfc_ditf_dX = (FCdfc_dw*d_FCdw_ditf_dX+d_FCdfc_dw_dX*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
if ((FCz>0.001))
{
{
double value_log_0 = log(FCz_1);
double  deriv_log_0_d0 = (1.0/FCz_1);
d_FCf_CT_dX = ((((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1)*2.0*((FCz_1*deriv_log_0_d0*(d_FCz_1_dX)+d_FCz_1_dX*value_log_0)-d_FCz_dX)-(2.0*((FCz_1*value_log_0)-FCz))*((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*d_FCz_1_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latb)*FCz_1))/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1)/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1));
FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1));
}
d_FCdfCT_dw_dX = (((2.0*FCw)*FCd_f)*d_FCd_f_dX+((2.0*FCw)*d_FCd_f_dX+2.0*d_FCw_dX*FCd_f)*FCd_f);
FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
}
else
{
d_FCf_CT_dX = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dX+(FCw2*(-(d_FCz_dX/3.0))+d_FCw2_dX*(1.0-(FCz/3.0)))*FCd_f);
FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);
d_FCdfCT_dw_dX = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dX+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dX+((2.0*FCw)*(-((FCz*d_FCz_dX+d_FCz_dX*FCz)/3.0))+2.0*d_FCw_dX*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
}
d_FCdfCT_ditf_dX = (FCdfCT_dw*d_FCdw_ditf_dX+d_FCdfCT_dw_dX*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{
d_FCf_CT_dX = d_FCf_ci_dX;
FCf_CT = FCf_ci;
d_FCdfCT_ditf_dX = d_FCdfc_ditf_dX;
FCdfCT_ditf = FCdfc_ditf;
}
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQcfcT_dX = ((FFdQcfc*FCf_CT)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(FFdQcfc*d_FCf_CT_dX+d_FFdQcfc_dX*FCf_CT)*value_exp_0);
FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQcfc_dX = ((FFdQcfc*FCf_ci)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(FFdQcfc*d_FCf_ci_dX+d_FFdQcfc_dX*FCf_ci)*value_exp_0);
FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTcfc_dX = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(d_FCf_ci_dX+(itf*d_FCdfc_ditf_dX+d_itf_dX*FCdfc_ditf))+((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*d_FFdQcfc_dX-FFdQcfc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTcfc = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTcfcT_dX = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(d_FCf_CT_dX+(itf*d_FCdfCT_ditf_dX+d_itf_dX*FCdfCT_ditf))+((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*d_FFdQcfcT_dX-FFdQcfcT*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTcfcT = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
}
d_FFdQbfc_dX = ((1-modelStruct.modelPar_fthc)*d_FFdQfhc_dX+(-modelStruct.d_modelPar_fthc_dX)*FFdQfhc);
FFdQbfc = ((1-modelStruct.modelPar_fthc)*FFdQfhc);
d_FFdTbfc_dX = ((1-modelStruct.modelPar_fthc)*d_FFdTfhc_dX+(-modelStruct.d_modelPar_fthc_dX)*FFdTfhc);
FFdTbfc = ((1-modelStruct.modelPar_fthc)*FFdTfhc);
d_Q_fT_dX = (((((instanceStruct.instanceVar_hf0_t*d_Qf_dX+instanceStruct.d_instanceVar_hf0_t_dX*Qf)+d_FFdQbfb_dX)+d_FFdQbfc_dX)+(instanceStruct.instanceVar_hfe_t*d_FFdQef_dX+instanceStruct.d_instanceVar_hfe_t_dX*FFdQef))+(instanceStruct.instanceVar_hfc_t*d_FFdQcfcT_dX+instanceStruct.d_instanceVar_hfc_t_dX*FFdQcfcT));
Q_fT = (((((instanceStruct.instanceVar_hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(instanceStruct.instanceVar_hfe_t*FFdQef))+(instanceStruct.instanceVar_hfc_t*FFdQcfcT));
d_T_fT_dX = (((((instanceStruct.instanceVar_hf0_t*instanceStruct.d_instanceVar_Tf_dX+instanceStruct.d_instanceVar_hf0_t_dX*instanceStruct.instanceVar_Tf)+d_FFdTbfb_dX)+d_FFdTbfc_dX)+(instanceStruct.instanceVar_hfe_t*d_FFdTef_dX+instanceStruct.d_instanceVar_hfe_t_dX*FFdTef))+(instanceStruct.instanceVar_hfc_t*d_FFdTcfcT_dX+instanceStruct.d_instanceVar_hfc_t_dX*FFdTcfcT));
T_fT = (((((instanceStruct.instanceVar_hf0_t*instanceStruct.instanceVar_Tf)+FFdTbfb)+FFdTbfc)+(instanceStruct.instanceVar_hfe_t*FFdTef))+(instanceStruct.instanceVar_hfc_t*FFdTcfcT));
d_Qf_dX = (((d_Qf_dX+(d_FFdQbfb_dX+d_FFdQbfc_dX))+d_FFdQef_dX)+d_FFdQcfc_dX);
Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);
instanceStruct.d_instanceVar_Tf_dX = (((instanceStruct.d_instanceVar_Tf_dX+(d_FFdTbfb_dX+d_FFdTbfc_dX))+d_FFdTef_dX)+d_FFdTcfc_dX);
instanceStruct.instanceVar_Tf = (((instanceStruct.instanceVar_Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);
d_Q_bf_dX = (d_FFdQbfb_dX+d_FFdQbfc_dX);
Q_bf = (FFdQbfb+FFdQbfc);
}
d_Qr_dX = (Tr*d_itr_dX+d_Tr_dX*itr);
Qr = (Tr*itr);
l_it = 0;
if (((Qf>(1.0e-5*Q_p))||(a_h>1.0e-5)))
{
{
double value_sqrt_0 = sqrt(((T_f0*itf)*Q_fT));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Qf_dX = deriv_sqrt_0_d0*(((T_f0*itf)*d_Q_fT_dX+(T_f0*d_itf_dX+d_T_f0_dX*itf)*Q_fT));
Qf = value_sqrt_0;
}
d_Q_pT_dX = ((d_Q_0_dX+d_Qf_dX)+d_Qr_dX);
Q_pT = ((Q_0+Qf)+Qr);
d_d_Q_dX = d_Q_pT_dX;
d_Q = Q_pT;
while (((fabs(d_Q)>=(1.0e-5*fabs(Q_pT)))&&(l_it<=100)))
{
d_d_Q0_dX = d_d_Q_dX;
d_Q0 = d_Q;
d_I_Tf1_dX = ((Q_pT*d_i_0f_dX-i_0f*d_Q_pT_dX)/Q_pT/Q_pT);
I_Tf1 = (i_0f/Q_pT);
d_a_h_dX = (instanceStruct.instanceVar_Oich*d_I_Tf1_dX+instanceStruct.d_instanceVar_Oich_dX*I_Tf1);
a_h = (instanceStruct.instanceVar_Oich*I_Tf1);
d_itf_dX = (I_Tf1*d_a_h_dX+d_I_Tf1_dX*(1.0+a_h));
itf = (I_Tf1*(1.0+a_h));
d_itr_dX = ((Q_pT*d_i_0r_dX-i_0r*d_Q_pT_dX)/Q_pT/Q_pT);
itr = (i_0r/Q_pT);
instanceStruct.d_instanceVar_Tf_dX = d_T_f0_dX;
instanceStruct.instanceVar_Tf = T_f0;
d_Qf_dX = (T_f0*d_itf_dX+d_T_f0_dX*itf);
Qf = (T_f0*itf);
if ((itf<(1.0e-6*ick)))
{
d_Q_fT_dX = d_Qf_dX;
Q_fT = Qf;
d_T_fT_dX = instanceStruct.d_instanceVar_Tf_dX;
T_fT = instanceStruct.instanceVar_Tf;
d_Q_bf_dX = 0.0;
Q_bf = 0;
}
else
{
d_FFitf_ick_dX = ((ick*d_itf_dX-itf*d_ick_dX)/ick/ick);
FFitf_ick = (itf/ick);
{
double value_log_0 = log(FFitf_ick);
double value_exp_1 = exp((modelStruct.modelPar_gtfe*value_log_0));
double  deriv_log_0_d0 = (1.0/FFitf_ick);
double  deriv_exp_1_d0 = value_exp_1;
d_FFdTef_dX = (instanceStruct.instanceVar_tef0_t*deriv_exp_1_d0*((modelStruct.modelPar_gtfe*deriv_log_0_d0*(d_FFitf_ick_dX)+modelStruct.d_modelPar_gtfe_dX*value_log_0))+instanceStruct.d_instanceVar_tef0_t_dX*value_exp_1);
FFdTef = (instanceStruct.instanceVar_tef0_t*value_exp_1);
}
d_FFdQef_dX = (((1+modelStruct.modelPar_gtfe)*(FFdTef*d_itf_dX+d_FFdTef_dX*itf)-(FFdTef*itf)*modelStruct.d_modelPar_gtfe_dX)/(1+modelStruct.modelPar_gtfe)/(1+modelStruct.modelPar_gtfe));
FFdQef = ((FFdTef*itf)/(1+modelStruct.modelPar_gtfe));
if ((modelStruct.modelPar_icbar<(0.05*(modelStruct.modelPar_vlim/modelStruct.modelPar_rci0))))
{
d_FFdVc_dX = 0.0;
FFdVc = 0;
d_FFdVc_ditf_dX = 0.0;
FFdVc_ditf = 0;
}
else
{
d_FFib_dX = ((modelStruct.modelPar_icbar*(d_itf_dX-d_ick_dX)-(itf-ick)*modelStruct.d_modelPar_icbar_dX)/modelStruct.modelPar_icbar/modelStruct.modelPar_icbar);
FFib = ((itf-ick)/modelStruct.modelPar_icbar);
if ((FFib<(-1.0e10)))
{
d_FFib_dX = 0.0;
FFib = (-1.0e10);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+modelStruct.modelPar_acbar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFfcbar_dX = ((d_FFib_dX+deriv_sqrt_0_d0*(((FFib*d_FFib_dX+d_FFib_dX*FFib)+modelStruct.d_modelPar_acbar_dX)))/2.0);
FFfcbar = ((FFib+value_sqrt_0)/2.0);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+modelStruct.modelPar_acbar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFdib_ditf_dX = ((modelStruct.modelPar_icbar*((value_sqrt_0*d_FFfcbar_dX-FFfcbar*deriv_sqrt_0_d0*(((FFib*d_FFib_dX+d_FFib_dX*FFib)+modelStruct.d_modelPar_acbar_dX)))/value_sqrt_0/value_sqrt_0)-(FFfcbar/value_sqrt_0)*modelStruct.d_modelPar_icbar_dX)/modelStruct.modelPar_icbar/modelStruct.modelPar_icbar);
FFdib_ditf = ((FFfcbar/value_sqrt_0)/modelStruct.modelPar_icbar);
}
{
double value_exp_0 = exp(((-1.0)/FFfcbar));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdVc_dX = (modelStruct.modelPar_vcbar*deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dX/FFfcbar/FFfcbar))+modelStruct.d_modelPar_vcbar_dX*value_exp_0);
FFdVc = (modelStruct.modelPar_vcbar*value_exp_0);
}
d_FFdVc_ditf_dX = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dX+(((FFfcbar*FFfcbar)*d_FFdVc_dX-FFdVc*(FFfcbar*d_FFfcbar_dX+d_FFfcbar_dX*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
}
{
double value_exp_0 = exp((FFdVc/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQbfb_dX = ((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*d_FFdVc_dX-FFdVc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*d_itf_dX+((1-modelStruct.modelPar_fthc)*instanceStruct.d_instanceVar_thcs_t_dX+(-modelStruct.d_modelPar_fthc_dX)*instanceStruct.instanceVar_thcs_t)*itf)*(value_exp_0-1));
FFdQbfb = ((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*(value_exp_0-1));
}
{
double value_exp_0 = exp((FFdVc/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTbfb_dX = (((itf*d_FFdQbfb_dX-FFdQbfb*d_itf_dX)/itf/itf)+((((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*d_FFdVc_dX-FFdVc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*d_itf_dX+((1-modelStruct.modelPar_fthc)*instanceStruct.d_instanceVar_thcs_t_dX+(-modelStruct.d_modelPar_fthc_dX)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)-((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTbfb = ((FFdQbfb/itf)+((((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
d_FFic_dX = (-(-d_FFitf_ick_dX/FFitf_ick/FFitf_ick));
FFic = (1-(1.0/FFitf_ick));
{
double value_sqrt_0 = sqrt(((FFic*FFic)+modelStruct.modelPar_ahc));
double value_sqrt_1 = sqrt((1+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_FFw_dX = (((1+value_sqrt_1)*(d_FFic_dX+deriv_sqrt_0_d0*(((FFic*d_FFic_dX+d_FFic_dX*FFic)+modelStruct.d_modelPar_ahc_dX)))-(FFic+value_sqrt_0)*deriv_sqrt_1_d0*(modelStruct.d_modelPar_ahc_dX))/(1+value_sqrt_1)/(1+value_sqrt_1));
FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQfhc_dX = ((((instanceStruct.instanceVar_thcs_t*itf)*FFw)*FFw)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((instanceStruct.instanceVar_thcs_t*itf)*FFw)*d_FFw_dX+((instanceStruct.instanceVar_thcs_t*itf)*d_FFw_dX+(instanceStruct.instanceVar_thcs_t*d_itf_dX+instanceStruct.d_instanceVar_thcs_t_dX*itf)*FFw)*FFw)*value_exp_0);
FFdQfhc = ((((instanceStruct.instanceVar_thcs_t*itf)*FFw)*FFw)*value_exp_0);
}
{
double value_sqrt_0 = sqrt(((FFic*FFic)+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFdTfhc_dX = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*deriv_sqrt_0_d0*(((FFic*d_FFic_dX+d_FFic_dX*FFic)+modelStruct.d_modelPar_ahc_dX))+d_FFitf_ick_dX*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dX/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+(-instanceStruct.d_instanceVar_VT_dX/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf))+d_FFdQfhc_dX*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*FFdVc_ditf)));
FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*FFdVc_ditf)));
}
if (((modelStruct.modelPar_latb<=0.0)&&(modelStruct.modelPar_latl<=0.0)))
{
d_FFdQcfc_dX = (modelStruct.modelPar_fthc*d_FFdQfhc_dX+modelStruct.d_modelPar_fthc_dX*FFdQfhc);
FFdQcfc = (modelStruct.modelPar_fthc*FFdQfhc);
d_FFdTcfc_dX = (modelStruct.modelPar_fthc*d_FFdTfhc_dX+modelStruct.d_modelPar_fthc_dX*FFdTfhc);
FFdTcfc = (modelStruct.modelPar_fthc*FFdTfhc);
d_FFdQcfcT_dX = d_FFdQcfc_dX;
FFdQcfcT = FFdQcfc;
d_FFdTcfcT_dX = d_FFdTcfc_dX;
FFdTcfcT = FFdTcfc;
}
else
{
d_FFdQcfc_dX = ((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*d_itf_dX+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*itf);
FFdQcfc = ((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*itf);
d_FCa_dX = (-((itf*d_ick_dX-ick*d_itf_dX)/itf/itf));
FCa = (1.0-(ick/itf));
{
double value_sqrt_0 = sqrt(((FCa*FCa)+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FCrt_dX = deriv_sqrt_0_d0*(((FCa*d_FCa_dX+d_FCa_dX*FCa)+modelStruct.d_modelPar_ahc_dX));
FCrt = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((1.0+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FCa_ck_dX = (-(((1.0+value_sqrt_0)*(d_FCa_dX+d_FCrt_dX)-(FCa+FCrt)*deriv_sqrt_0_d0*(modelStruct.d_modelPar_ahc_dX))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0)));
FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
}
d_FCdaick_ditf_dX = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dX)+d_FCa_ck_dX*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dX+d_FCrt_dX*itf))/(FCrt*itf)/(FCrt*itf));
FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
if ((modelStruct.modelPar_latb>modelStruct.modelPar_latl))
{
d_FCz_dX = (modelStruct.d_modelPar_latb_dX-modelStruct.d_modelPar_latl_dX);
FCz = (modelStruct.modelPar_latb-modelStruct.modelPar_latl);
d_FCxl_dX = modelStruct.d_modelPar_latl_dX;
FCxl = (1.0+modelStruct.modelPar_latl);
d_FCxb_dX = modelStruct.d_modelPar_latb_dX;
FCxb = (1.0+modelStruct.modelPar_latb);
if ((modelStruct.modelPar_latb>0.01))
{
{
double value_log_0 = log((FCxb/FCxl));
double  deriv_log_0_d0 = (1.0/(FCxb/FCxl));
d_FCln_dX = deriv_log_0_d0*(((FCxl*d_FCxb_dX-FCxb*d_FCxl_dX)/FCxl/FCxl));
FCln = value_log_0;
}
{
double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
double  deriv_exp_0_d0 = value_exp_0;
d_FCa1_dX = deriv_exp_0_d0*(((FCa_ck-1.0)*d_FCln_dX+d_FCa_ck_dX*FCln));
FCa1 = value_exp_0;
}
d_FCd_a_dX = (-(modelStruct.d_modelPar_latl_dX-(FCa1*modelStruct.d_modelPar_latb_dX+d_FCa1_dX*modelStruct.modelPar_latb))/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb))/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb)));
FCd_a = (1.0/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb)));
d_FCw_dX = ((FCa1-1.0)*d_FCd_a_dX+d_FCa1_dX*FCd_a);
FCw = ((FCa1-1.0)*FCd_a);
d_FCdw_daick_dX = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dX+((((-FCz)*FCa1)*FCln)*d_FCd_a_dX+(((-FCz)*FCa1)*d_FCln_dX+((-FCz)*d_FCa1_dX+(-d_FCz_dX)*FCa1)*FCln)*FCd_a)*FCd_a);
FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
{
double value_log_0 = log(((1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
double  deriv_log_0_d0 = (1.0/((1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
d_FCa1_dX = deriv_log_0_d0*((((1.0+(modelStruct.modelPar_latl*FCw))*(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw)-(1.0+(modelStruct.modelPar_latb*FCw))*(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
FCa1 = value_log_0;
}
d_FCda1_dw_dX = ((((1.0+(modelStruct.modelPar_latb*FCw))*modelStruct.d_modelPar_latb_dX-modelStruct.modelPar_latb*(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw))/(1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latb*FCw)))-(((1.0+(modelStruct.modelPar_latl*FCw))*modelStruct.d_modelPar_latl_dX-modelStruct.modelPar_latl*(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
FCda1_dw = ((modelStruct.modelPar_latb/(1.0+(modelStruct.modelPar_latb*FCw)))-(modelStruct.modelPar_latl/(1.0+(modelStruct.modelPar_latl*FCw))));
}
else
{
d_FCf1_dX = (-d_FCa_ck_dX);
FCf1 = (1.0-FCa_ck);
d_FCd_a_dX = (-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb)/(1.0+(FCa_ck*modelStruct.modelPar_latb))/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
FCd_a = (1.0/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
d_FCw_dX = (FCf1*d_FCd_a_dX+d_FCf1_dX*FCd_a);
FCw = (FCf1*FCd_a);
d_FCdw_daick_dX = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dX+((((-1.0)*FCd_a)*FCd_a)*d_FCxb_dX+(((-1.0)*FCd_a)*d_FCd_a_dX+(-1.0)*d_FCd_a_dX*FCd_a)*FCxb)*FCd_a);
FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);
d_FCa1_dX = (FCz*d_FCw_dX+d_FCz_dX*FCw);
FCa1 = (FCz*FCw);
d_FCda1_dw_dX = d_FCz_dX;
FCda1_dw = FCz;
}
d_FCf_CT_dX = (-2.0*d_FCz_dX/FCz/FCz);
FCf_CT = (2.0/FCz);
d_FCw2_dX = (FCw*d_FCw_dX+d_FCw_dX*FCw);
FCw2 = (FCw*FCw);
d_FCf1_dX = ((((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw)*d_FCw2_dX+((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*d_FCw_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latl)*FCw)*FCw2)/3.0)+(((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*d_FCw2_dX+(modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latl_dX)*FCw2)/2.0))+d_FCw_dX);
FCf1 = ((((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw)*FCw2)/3.0)+(((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*FCw2)/2.0))+FCw);
d_FCdf1_dw_dX = (((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*d_FCw2_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latl)*FCw2)+((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*d_FCw_dX+(modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latl_dX)*FCw));
FCdf1_dw = ((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw2)+((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*FCw))+1.0);
d_z_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
z = (modelStruct.modelPar_latb*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latb*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latb*FCw)));
d_lnzb_dX = deriv_log_0_d0*((modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{
d_x_dX = d_z_dX;
x = (1.0+z);
instanceStruct.d_instanceVar_a_dX = (x*d_x_dX+d_x_dX*x);
instanceStruct.instanceVar_a = (x*x);
d_a2_dX = 0.250*(instanceStruct.instanceVar_a*2.0*d_lnzb_dX+instanceStruct.d_instanceVar_a_dX*((2.0*lnzb)-1.0));
a2 = (0.250*((instanceStruct.instanceVar_a*((2.0*lnzb)-1.0))+1.0));
d_a3_dX = (((instanceStruct.instanceVar_a*x)*3.0*d_lnzb_dX+(instanceStruct.instanceVar_a*d_x_dX+instanceStruct.d_instanceVar_a_dX*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((instanceStruct.instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
d_r_dX = ((modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX-modelStruct.modelPar_latl*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
r = (modelStruct.modelPar_latl/modelStruct.modelPar_latb);
d_FCf2_dX = ((modelStruct.modelPar_latb*(((1.0-r)*d_a2_dX+(-d_r_dX)*a2)+(r*d_a3_dX+d_r_dX*a3))-(((1.0-r)*a2)+(r*a3))*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
FCf2 = ((((1.0-r)*a2)+(r*a3))/modelStruct.modelPar_latb);
d_FCdf2_dw_dX = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*d_lnzb_dX+(((1.0-r)*d_x_dX+(-d_r_dX)*x)+(r*instanceStruct.d_instanceVar_a_dX+d_r_dX*instanceStruct.instanceVar_a))*lnzb);
FCdf2_dw = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*lnzb);
}
else
{
instanceStruct.d_instanceVar_a_dX = (z*d_z_dX+d_z_dX*z);
instanceStruct.instanceVar_a = (z*z);
d_a2_dX = ((d_z_dX-0.25*instanceStruct.d_instanceVar_a_dX)+((0.10*z)*instanceStruct.d_instanceVar_a_dX+0.10*d_z_dX*instanceStruct.instanceVar_a));
a2 = (((3.0+z)-(0.25*instanceStruct.instanceVar_a))+((0.10*z)*instanceStruct.instanceVar_a));
d_a3_dX = ((2.0*d_z_dX+0.75*instanceStruct.d_instanceVar_a_dX)-((0.20*instanceStruct.instanceVar_a)*d_z_dX+0.20*instanceStruct.d_instanceVar_a_dX*z));
a3 = (((2.0*z)+(0.75*instanceStruct.instanceVar_a))-((0.20*instanceStruct.instanceVar_a)*z));
d_FCf2_dX = (((((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*FCw)*d_FCw_dX+(((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*d_FCw_dX+((modelStruct.modelPar_latb*d_a2_dX+modelStruct.d_modelPar_latb_dX*a2)+(modelStruct.modelPar_latl*d_a3_dX+modelStruct.d_modelPar_latl_dX*a3))*FCw)*FCw)/6.0);
FCf2 = (((((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*FCw)*FCw)/6.0);
d_FCdf2_dw_dX = (((1+(modelStruct.modelPar_latl*FCw))*(1+z))*d_lnzb_dX+((1+(modelStruct.modelPar_latl*FCw))*d_z_dX+(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw)*(1+z))*lnzb);
FCdf2_dw = (((1+(modelStruct.modelPar_latl*FCw))*(1+z))*lnzb);
}
d_z_dX = (modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw);
z = (modelStruct.modelPar_latl*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latl*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latl*FCw)));
d_lnzb_dX = deriv_log_0_d0*((modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{
d_x_dX = d_z_dX;
x = (1.0+z);
instanceStruct.d_instanceVar_a_dX = (x*d_x_dX+d_x_dX*x);
instanceStruct.instanceVar_a = (x*x);
d_a2_dX = 0.250*(instanceStruct.instanceVar_a*2.0*d_lnzb_dX+instanceStruct.d_instanceVar_a_dX*((2.0*lnzb)-1.0));
a2 = (0.250*((instanceStruct.instanceVar_a*((2.0*lnzb)-1.0))+1.0));
d_a3_dX = (((instanceStruct.instanceVar_a*x)*3.0*d_lnzb_dX+(instanceStruct.instanceVar_a*d_x_dX+instanceStruct.d_instanceVar_a_dX*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((instanceStruct.instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
d_r_dX = ((modelStruct.modelPar_latl*modelStruct.d_modelPar_latb_dX-modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
r = (modelStruct.modelPar_latb/modelStruct.modelPar_latl);
d_FCf3_dX = ((modelStruct.modelPar_latl*(((1.0-r)*d_a2_dX+(-d_r_dX)*a2)+(r*d_a3_dX+d_r_dX*a3))-(((1.0-r)*a2)+(r*a3))*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
FCf3 = ((((1.0-r)*a2)+(r*a3))/modelStruct.modelPar_latl);
d_FCdf3_dw_dX = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*d_lnzb_dX+(((1.0-r)*d_x_dX+(-d_r_dX)*x)+(r*instanceStruct.d_instanceVar_a_dX+d_r_dX*instanceStruct.instanceVar_a))*lnzb);
FCdf3_dw = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*lnzb);
}
else
{
instanceStruct.d_instanceVar_a_dX = (z*d_z_dX+d_z_dX*z);
instanceStruct.instanceVar_a = (z*z);
d_a2_dX = ((d_z_dX-0.25*instanceStruct.d_instanceVar_a_dX)+((0.10*z)*instanceStruct.d_instanceVar_a_dX+0.10*d_z_dX*instanceStruct.instanceVar_a));
a2 = (((3.0+z)-(0.25*instanceStruct.instanceVar_a))+((0.10*z)*instanceStruct.instanceVar_a));
d_a3_dX = ((2.0*d_z_dX+0.75*instanceStruct.d_instanceVar_a_dX)-((0.20*instanceStruct.instanceVar_a)*d_z_dX+0.20*instanceStruct.d_instanceVar_a_dX*z));
a3 = (((2.0*z)+(0.75*instanceStruct.instanceVar_a))-((0.20*instanceStruct.instanceVar_a)*z));
d_FCf3_dX = (((((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*FCw)*d_FCw_dX+(((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*d_FCw_dX+((modelStruct.modelPar_latl*d_a2_dX+modelStruct.d_modelPar_latl_dX*a2)+(modelStruct.modelPar_latb*d_a3_dX+modelStruct.d_modelPar_latb_dX*a3))*FCw)*FCw)/6.0);
FCf3 = (((((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*FCw)*FCw)/6.0);
d_FCdf3_dw_dX = (((1+(modelStruct.modelPar_latb*FCw))*(1+z))*d_lnzb_dX+((1+(modelStruct.modelPar_latb*FCw))*d_z_dX+(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw)*(1+z))*lnzb);
FCdf3_dw = (((1+(modelStruct.modelPar_latb*FCw))*(1+z))*lnzb);
}
d_FCf_ci_dX = (FCf_CT*(((FCa1*d_FCf1_dX+d_FCa1_dX*FCf1)-d_FCf2_dX)+d_FCf3_dX)+d_FCf_CT_dX*(((FCa1*FCf1)-FCf2)+FCf3));
FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCdfc_dw_dX = (FCf_CT*((((FCa1*d_FCdf1_dw_dX+d_FCa1_dX*FCdf1_dw)+(FCda1_dw*d_FCf1_dX+d_FCda1_dw_dX*FCf1))-d_FCdf2_dw_dX)+d_FCdf3_dw_dX)+d_FCf_CT_dX*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdw_ditf_dX = (FCdw_daick*d_FCdaick_ditf_dX+d_FCdw_daick_dX*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);
d_FCdfc_ditf_dX = (FCdfc_dw*d_FCdw_ditf_dX+d_FCdfc_dw_dX*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
instanceStruct.instanceVar_a = (modelStruct.modelPar_latb*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latb*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latb*FCw)));
d_lnz_dX = deriv_log_0_d0*((modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw));
lnz = value_log_0;
}
if ((instanceStruct.instanceVar_a>1.0e-6))
{
d_FCf2_dX = ((modelStruct.modelPar_latb*(instanceStruct.d_instanceVar_a_dX-d_lnz_dX)-(instanceStruct.instanceVar_a-lnz)*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
FCf2 = ((instanceStruct.instanceVar_a-lnz)/modelStruct.modelPar_latb);
d_FCdf2_dw_dX = (((1.0+instanceStruct.instanceVar_a)*instanceStruct.d_instanceVar_a_dX-instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX)/(1.0+instanceStruct.instanceVar_a)/(1.0+instanceStruct.instanceVar_a));
FCdf2_dw = (instanceStruct.instanceVar_a/(1.0+instanceStruct.instanceVar_a));
}
else
{
d_FCf2_dX = ((0.5*instanceStruct.instanceVar_a)*d_FCw_dX+0.5*instanceStruct.d_instanceVar_a_dX*FCw);
FCf2 = ((0.5*instanceStruct.instanceVar_a)*FCw);
d_FCdf2_dw_dX = instanceStruct.d_instanceVar_a_dX;
FCdf2_dw = instanceStruct.instanceVar_a;
}
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw);
instanceStruct.instanceVar_a = (modelStruct.modelPar_latl*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latl*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latl*FCw)));
d_lnz_dX = deriv_log_0_d0*((modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw));
lnz = value_log_0;
}
if ((instanceStruct.instanceVar_a>1.0e-6))
{
d_FCf3_dX = ((modelStruct.modelPar_latl*(instanceStruct.d_instanceVar_a_dX-d_lnz_dX)-(instanceStruct.instanceVar_a-lnz)*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
FCf3 = ((instanceStruct.instanceVar_a-lnz)/modelStruct.modelPar_latl);
d_FCdf3_dw_dX = (((1.0+instanceStruct.instanceVar_a)*instanceStruct.d_instanceVar_a_dX-instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX)/(1.0+instanceStruct.instanceVar_a)/(1.0+instanceStruct.instanceVar_a));
FCdf3_dw = (instanceStruct.instanceVar_a/(1.0+instanceStruct.instanceVar_a));
}
else
{
d_FCf3_dX = ((0.5*instanceStruct.instanceVar_a)*d_FCw_dX+0.5*instanceStruct.d_instanceVar_a_dX*FCw);
FCf3 = ((0.5*instanceStruct.instanceVar_a)*FCw);
d_FCdf3_dw_dX = instanceStruct.d_instanceVar_a_dX;
FCdf3_dw = instanceStruct.instanceVar_a;
}
d_FCf_CT_dX = (FCf_CT*(d_FCf2_dX-d_FCf3_dX)+d_FCf_CT_dX*(FCf2-FCf3));
FCf_CT = (FCf_CT*(FCf2-FCf3));
d_FCdfCT_dw_dX = (FCf_CT*(d_FCdf2_dw_dX-d_FCdf3_dw_dX)+d_FCf_CT_dX*(FCdf2_dw-FCdf3_dw));
FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_ditf_dX = (FCdfCT_dw*d_FCdw_ditf_dX+d_FCdfCT_dw_dX*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{
d_FCf_CT_dX = d_FCf_ci_dX;
FCf_CT = FCf_ci;
d_FCdfCT_ditf_dX = d_FCdfc_ditf_dX;
FCdfCT_ditf = FCdfc_ditf;
}
}
else
{
if ((modelStruct.modelPar_latb>0.01))
{
d_FCd_a_dX = (-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb)/(1.0+(FCa_ck*modelStruct.modelPar_latb))/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
FCd_a = (1.0/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
d_FCw_dX = ((1.0-FCa_ck)*d_FCd_a_dX+(-d_FCa_ck_dX)*FCd_a);
FCw = ((1.0-FCa_ck)*FCd_a);
d_FCdw_daick_dX = (((-(1.0+modelStruct.modelPar_latb))*FCd_a)*d_FCd_a_dX+((-(1.0+modelStruct.modelPar_latb))*d_FCd_a_dX+(-modelStruct.d_modelPar_latb_dX)*FCd_a)*FCd_a);
FCdw_daick = (((-(1.0+modelStruct.modelPar_latb))*FCd_a)*FCd_a);
}
else
{
d_FCw_dX = ((-d_FCa_ck_dX)-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb));
FCw = ((1.0-FCa_ck)-(FCa_ck*modelStruct.modelPar_latb));
d_FCdw_daick_dX = (-modelStruct.d_modelPar_latb_dX);
FCdw_daick = (-(1.0+modelStruct.modelPar_latb));
}
d_FCw2_dX = (FCw*d_FCw_dX+d_FCw_dX*FCw);
FCw2 = (FCw*FCw);
d_FCz_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
FCz = (modelStruct.modelPar_latb*FCw);
d_FCz_1_dX = d_FCz_dX;
FCz_1 = (1.0+FCz);
d_FCd_f_dX = (-d_FCz_1_dX/FCz_1/FCz_1);
FCd_f = (1.0/FCz_1);
d_FCf_ci_dX = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dX+(FCw2*(d_FCz_dX/3.0)+d_FCw2_dX*(1.0+(FCz/3.0)))*FCd_f);
FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);
d_FCdfc_dw_dX = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dX+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dX+((2.0*FCw)*(d_FCz_1_dX+((FCz*d_FCz_dX+d_FCz_dX*FCz)/3.0))+2.0*d_FCw_dX*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdw_ditf_dX = (FCdw_daick*d_FCdaick_ditf_dX+d_FCdw_daick_dX*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);
d_FCdfc_ditf_dX = (FCdfc_dw*d_FCdw_ditf_dX+d_FCdfc_dw_dX*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
if ((FCz>0.001))
{
{
double value_log_0 = log(FCz_1);
double  deriv_log_0_d0 = (1.0/FCz_1);
d_FCf_CT_dX = ((((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1)*2.0*((FCz_1*deriv_log_0_d0*(d_FCz_1_dX)+d_FCz_1_dX*value_log_0)-d_FCz_dX)-(2.0*((FCz_1*value_log_0)-FCz))*((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*d_FCz_1_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latb)*FCz_1))/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1)/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1));
FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1));
}
d_FCdfCT_dw_dX = (((2.0*FCw)*FCd_f)*d_FCd_f_dX+((2.0*FCw)*d_FCd_f_dX+2.0*d_FCw_dX*FCd_f)*FCd_f);
FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
}
else
{
d_FCf_CT_dX = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dX+(FCw2*(-(d_FCz_dX/3.0))+d_FCw2_dX*(1.0-(FCz/3.0)))*FCd_f);
FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);
d_FCdfCT_dw_dX = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dX+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dX+((2.0*FCw)*(-((FCz*d_FCz_dX+d_FCz_dX*FCz)/3.0))+2.0*d_FCw_dX*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
}
d_FCdfCT_ditf_dX = (FCdfCT_dw*d_FCdw_ditf_dX+d_FCdfCT_dw_dX*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{
d_FCf_CT_dX = d_FCf_ci_dX;
FCf_CT = FCf_ci;
d_FCdfCT_ditf_dX = d_FCdfc_ditf_dX;
FCdfCT_ditf = FCdfc_ditf;
}
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQcfcT_dX = ((FFdQcfc*FCf_CT)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(FFdQcfc*d_FCf_CT_dX+d_FFdQcfc_dX*FCf_CT)*value_exp_0);
FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQcfc_dX = ((FFdQcfc*FCf_ci)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(FFdQcfc*d_FCf_ci_dX+d_FFdQcfc_dX*FCf_ci)*value_exp_0);
FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTcfc_dX = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(d_FCf_ci_dX+(itf*d_FCdfc_ditf_dX+d_itf_dX*FCdfc_ditf))+((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*d_FFdQcfc_dX-FFdQcfc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTcfc = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTcfcT_dX = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(d_FCf_CT_dX+(itf*d_FCdfCT_ditf_dX+d_itf_dX*FCdfCT_ditf))+((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*d_FFdQcfcT_dX-FFdQcfcT*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTcfcT = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
}
d_FFdQbfc_dX = ((1-modelStruct.modelPar_fthc)*d_FFdQfhc_dX+(-modelStruct.d_modelPar_fthc_dX)*FFdQfhc);
FFdQbfc = ((1-modelStruct.modelPar_fthc)*FFdQfhc);
d_FFdTbfc_dX = ((1-modelStruct.modelPar_fthc)*d_FFdTfhc_dX+(-modelStruct.d_modelPar_fthc_dX)*FFdTfhc);
FFdTbfc = ((1-modelStruct.modelPar_fthc)*FFdTfhc);
d_Q_fT_dX = (((((instanceStruct.instanceVar_hf0_t*d_Qf_dX+instanceStruct.d_instanceVar_hf0_t_dX*Qf)+d_FFdQbfb_dX)+d_FFdQbfc_dX)+(instanceStruct.instanceVar_hfe_t*d_FFdQef_dX+instanceStruct.d_instanceVar_hfe_t_dX*FFdQef))+(instanceStruct.instanceVar_hfc_t*d_FFdQcfcT_dX+instanceStruct.d_instanceVar_hfc_t_dX*FFdQcfcT));
Q_fT = (((((instanceStruct.instanceVar_hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(instanceStruct.instanceVar_hfe_t*FFdQef))+(instanceStruct.instanceVar_hfc_t*FFdQcfcT));
d_T_fT_dX = (((((instanceStruct.instanceVar_hf0_t*instanceStruct.d_instanceVar_Tf_dX+instanceStruct.d_instanceVar_hf0_t_dX*instanceStruct.instanceVar_Tf)+d_FFdTbfb_dX)+d_FFdTbfc_dX)+(instanceStruct.instanceVar_hfe_t*d_FFdTef_dX+instanceStruct.d_instanceVar_hfe_t_dX*FFdTef))+(instanceStruct.instanceVar_hfc_t*d_FFdTcfcT_dX+instanceStruct.d_instanceVar_hfc_t_dX*FFdTcfcT));
T_fT = (((((instanceStruct.instanceVar_hf0_t*instanceStruct.instanceVar_Tf)+FFdTbfb)+FFdTbfc)+(instanceStruct.instanceVar_hfe_t*FFdTef))+(instanceStruct.instanceVar_hfc_t*FFdTcfcT));
d_Qf_dX = (((d_Qf_dX+(d_FFdQbfb_dX+d_FFdQbfc_dX))+d_FFdQef_dX)+d_FFdQcfc_dX);
Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);
instanceStruct.d_instanceVar_Tf_dX = (((instanceStruct.d_instanceVar_Tf_dX+(d_FFdTbfb_dX+d_FFdTbfc_dX))+d_FFdTef_dX)+d_FFdTcfc_dX);
instanceStruct.instanceVar_Tf = (((instanceStruct.instanceVar_Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);
d_Q_bf_dX = (d_FFdQbfb_dX+d_FFdQbfc_dX);
Q_bf = (FFdQbfb+FFdQbfc);
}
d_Qr_dX = (Tr*d_itr_dX+d_Tr_dX*itr);
Qr = (Tr*itr);
if ((instanceStruct.instanceVar_Oich==0.0))
{
instanceStruct.d_instanceVar_a_dX = ((Q_pT*((T_fT*d_itf_dX+d_T_fT_dX*itf)+d_Qr_dX)-((T_fT*itf)+Qr)*d_Q_pT_dX)/Q_pT/Q_pT);
instanceStruct.instanceVar_a = (1.0+(((T_fT*itf)+Qr)/Q_pT));
}
else
{
instanceStruct.d_instanceVar_a_dX = ((Q_pT*(((T_fT*I_Tf1)*2.0*d_a_h_dX+(T_fT*d_I_Tf1_dX+d_T_fT_dX*I_Tf1)*(1.0+(2.0*a_h)))+d_Qr_dX)-(((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)*d_Q_pT_dX)/Q_pT/Q_pT);
instanceStruct.instanceVar_a = (1.0+((((T_fT*I_Tf1)*(1.0+(2.0*a_h)))+Qr)/Q_pT));
}
d_d_Q_dX = ((instanceStruct.instanceVar_a*(-(d_Q_pT_dX-((d_Q_0_dX+d_Q_fT_dX)+d_Qr_dX)))-(-(Q_pT-((Q_0+Q_fT)+Qr)))*instanceStruct.d_instanceVar_a_dX)/instanceStruct.instanceVar_a/instanceStruct.instanceVar_a);
d_Q = ((-(Q_pT-((Q_0+Q_fT)+Qr)))/instanceStruct.instanceVar_a);
{
double value_fabs_0 = fabs((0.3*Q_pT));
double  deriv_fabs_0_d0 = ((((0.3*Q_pT))>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_a_dX = deriv_fabs_0_d0*(0.3*d_Q_pT_dX);
instanceStruct.instanceVar_a = value_fabs_0;
}
if ((fabs(d_Q)>instanceStruct.instanceVar_a))
{
if ((d_Q>=0))
{
d_d_Q_dX = instanceStruct.d_instanceVar_a_dX;
d_Q = instanceStruct.instanceVar_a;
}
else
{
d_d_Q_dX = (-instanceStruct.d_instanceVar_a_dX);
d_Q = (-instanceStruct.instanceVar_a);
}
}
d_Q_pT_dX = (d_Q_pT_dX+d_d_Q_dX);
Q_pT = (Q_pT+d_Q);
l_it = (l_it+1);
}
d_I_Tf1_dX = ((Q_pT*d_i_0f_dX-i_0f*d_Q_pT_dX)/Q_pT/Q_pT);
I_Tf1 = (i_0f/Q_pT);
d_a_h_dX = (instanceStruct.instanceVar_Oich*d_I_Tf1_dX+instanceStruct.d_instanceVar_Oich_dX*I_Tf1);
a_h = (instanceStruct.instanceVar_Oich*I_Tf1);
d_itf_dX = (I_Tf1*d_a_h_dX+d_I_Tf1_dX*(1.0+a_h));
itf = (I_Tf1*(1.0+a_h));
d_itr_dX = ((Q_pT*d_i_0r_dX-i_0r*d_Q_pT_dX)/Q_pT/Q_pT);
itr = (i_0r/Q_pT);
instanceStruct.d_instanceVar_Tf_dX = d_T_f0_dX;
instanceStruct.instanceVar_Tf = T_f0;
d_Qf_dX = (T_f0*d_itf_dX+d_T_f0_dX*itf);
Qf = (T_f0*itf);
if ((itf<(1.0e-6*ick)))
{
d_Q_fT_dX = d_Qf_dX;
Q_fT = Qf;
d_T_fT_dX = instanceStruct.d_instanceVar_Tf_dX;
T_fT = instanceStruct.instanceVar_Tf;
d_Q_bf_dX = 0.0;
Q_bf = 0;
}
else
{
d_FFitf_ick_dX = ((ick*d_itf_dX-itf*d_ick_dX)/ick/ick);
FFitf_ick = (itf/ick);
{
double value_log_0 = log(FFitf_ick);
double value_exp_1 = exp((modelStruct.modelPar_gtfe*value_log_0));
double  deriv_log_0_d0 = (1.0/FFitf_ick);
double  deriv_exp_1_d0 = value_exp_1;
d_FFdTef_dX = (instanceStruct.instanceVar_tef0_t*deriv_exp_1_d0*((modelStruct.modelPar_gtfe*deriv_log_0_d0*(d_FFitf_ick_dX)+modelStruct.d_modelPar_gtfe_dX*value_log_0))+instanceStruct.d_instanceVar_tef0_t_dX*value_exp_1);
FFdTef = (instanceStruct.instanceVar_tef0_t*value_exp_1);
}
d_FFdQef_dX = (((1+modelStruct.modelPar_gtfe)*(FFdTef*d_itf_dX+d_FFdTef_dX*itf)-(FFdTef*itf)*modelStruct.d_modelPar_gtfe_dX)/(1+modelStruct.modelPar_gtfe)/(1+modelStruct.modelPar_gtfe));
FFdQef = ((FFdTef*itf)/(1+modelStruct.modelPar_gtfe));
if ((modelStruct.modelPar_icbar<(0.05*(modelStruct.modelPar_vlim/modelStruct.modelPar_rci0))))
{
d_FFdVc_dX = 0.0;
FFdVc = 0;
d_FFdVc_ditf_dX = 0.0;
FFdVc_ditf = 0;
}
else
{
d_FFib_dX = ((modelStruct.modelPar_icbar*(d_itf_dX-d_ick_dX)-(itf-ick)*modelStruct.d_modelPar_icbar_dX)/modelStruct.modelPar_icbar/modelStruct.modelPar_icbar);
FFib = ((itf-ick)/modelStruct.modelPar_icbar);
if ((FFib<(-1.0e10)))
{
d_FFib_dX = 0.0;
FFib = (-1.0e10);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+modelStruct.modelPar_acbar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFfcbar_dX = ((d_FFib_dX+deriv_sqrt_0_d0*(((FFib*d_FFib_dX+d_FFib_dX*FFib)+modelStruct.d_modelPar_acbar_dX)))/2.0);
FFfcbar = ((FFib+value_sqrt_0)/2.0);
}
{
double value_sqrt_0 = sqrt(((FFib*FFib)+modelStruct.modelPar_acbar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFdib_ditf_dX = ((modelStruct.modelPar_icbar*((value_sqrt_0*d_FFfcbar_dX-FFfcbar*deriv_sqrt_0_d0*(((FFib*d_FFib_dX+d_FFib_dX*FFib)+modelStruct.d_modelPar_acbar_dX)))/value_sqrt_0/value_sqrt_0)-(FFfcbar/value_sqrt_0)*modelStruct.d_modelPar_icbar_dX)/modelStruct.modelPar_icbar/modelStruct.modelPar_icbar);
FFdib_ditf = ((FFfcbar/value_sqrt_0)/modelStruct.modelPar_icbar);
}
{
double value_exp_0 = exp(((-1.0)/FFfcbar));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdVc_dX = (modelStruct.modelPar_vcbar*deriv_exp_0_d0*((-(-1.0)*d_FFfcbar_dX/FFfcbar/FFfcbar))+modelStruct.d_modelPar_vcbar_dX*value_exp_0);
FFdVc = (modelStruct.modelPar_vcbar*value_exp_0);
}
d_FFdVc_ditf_dX = ((FFdVc/(FFfcbar*FFfcbar))*d_FFdib_ditf_dX+(((FFfcbar*FFfcbar)*d_FFdVc_dX-FFdVc*(FFfcbar*d_FFfcbar_dX+d_FFfcbar_dX*FFfcbar))/(FFfcbar*FFfcbar)/(FFfcbar*FFfcbar))*FFdib_ditf);
FFdVc_ditf = ((FFdVc/(FFfcbar*FFfcbar))*FFdib_ditf);
}
{
double value_exp_0 = exp((FFdVc/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQbfb_dX = ((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*d_FFdVc_dX-FFdVc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*d_itf_dX+((1-modelStruct.modelPar_fthc)*instanceStruct.d_instanceVar_thcs_t_dX+(-modelStruct.d_modelPar_fthc_dX)*instanceStruct.instanceVar_thcs_t)*itf)*(value_exp_0-1));
FFdQbfb = ((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*(value_exp_0-1));
}
{
double value_exp_0 = exp((FFdVc/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTbfb_dX = (((itf*d_FFdQbfb_dX-FFdQbfb*d_itf_dX)/itf/itf)+((((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*d_FFdVc_dX-FFdVc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*d_itf_dX+((1-modelStruct.modelPar_fthc)*instanceStruct.d_instanceVar_thcs_t_dX+(-modelStruct.d_modelPar_fthc_dX)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)-((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTbfb = ((FFdQbfb/itf)+((((((1-modelStruct.modelPar_fthc)*instanceStruct.instanceVar_thcs_t)*itf)*value_exp_0)/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
d_FFic_dX = (-(-d_FFitf_ick_dX/FFitf_ick/FFitf_ick));
FFic = (1-(1.0/FFitf_ick));
{
double value_sqrt_0 = sqrt(((FFic*FFic)+modelStruct.modelPar_ahc));
double value_sqrt_1 = sqrt((1+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_FFw_dX = (((1+value_sqrt_1)*(d_FFic_dX+deriv_sqrt_0_d0*(((FFic*d_FFic_dX+d_FFic_dX*FFic)+modelStruct.d_modelPar_ahc_dX)))-(FFic+value_sqrt_0)*deriv_sqrt_1_d0*(modelStruct.d_modelPar_ahc_dX))/(1+value_sqrt_1)/(1+value_sqrt_1));
FFw = ((FFic+value_sqrt_0)/(1+value_sqrt_1));
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQfhc_dX = ((((instanceStruct.instanceVar_thcs_t*itf)*FFw)*FFw)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(((instanceStruct.instanceVar_thcs_t*itf)*FFw)*d_FFw_dX+((instanceStruct.instanceVar_thcs_t*itf)*d_FFw_dX+(instanceStruct.instanceVar_thcs_t*d_itf_dX+instanceStruct.d_instanceVar_thcs_t_dX*itf)*FFw)*FFw)*value_exp_0);
FFdQfhc = ((((instanceStruct.instanceVar_thcs_t*itf)*FFw)*FFw)*value_exp_0);
}
{
double value_sqrt_0 = sqrt(((FFic*FFic)+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FFdTfhc_dX = (FFdQfhc*(((1.0/itf)*(-2.0*(FFitf_ick*deriv_sqrt_0_d0*(((FFic*d_FFic_dX+d_FFic_dX*FFic)+modelStruct.d_modelPar_ahc_dX))+d_FFitf_ick_dX*value_sqrt_0)/(FFitf_ick*value_sqrt_0)/(FFitf_ick*value_sqrt_0))+(-d_itf_dX/itf/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+(-instanceStruct.d_instanceVar_VT_dX/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf))+d_FFdQfhc_dX*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*FFdVc_ditf)));
FFdTfhc = (FFdQfhc*(((1.0/itf)*(1.0+(2.0/(FFitf_ick*value_sqrt_0))))+((1.0/instanceStruct.instanceVar_VT)*FFdVc_ditf)));
}
if (((modelStruct.modelPar_latb<=0.0)&&(modelStruct.modelPar_latl<=0.0)))
{
d_FFdQcfc_dX = (modelStruct.modelPar_fthc*d_FFdQfhc_dX+modelStruct.d_modelPar_fthc_dX*FFdQfhc);
FFdQcfc = (modelStruct.modelPar_fthc*FFdQfhc);
d_FFdTcfc_dX = (modelStruct.modelPar_fthc*d_FFdTfhc_dX+modelStruct.d_modelPar_fthc_dX*FFdTfhc);
FFdTcfc = (modelStruct.modelPar_fthc*FFdTfhc);
d_FFdQcfcT_dX = d_FFdQcfc_dX;
FFdQcfcT = FFdQcfc;
d_FFdTcfcT_dX = d_FFdTcfc_dX;
FFdTcfcT = FFdTcfc;
}
else
{
d_FFdQcfc_dX = ((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*d_itf_dX+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*itf);
FFdQcfc = ((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*itf);
d_FCa_dX = (-((itf*d_ick_dX-ick*d_itf_dX)/itf/itf));
FCa = (1.0-(ick/itf));
{
double value_sqrt_0 = sqrt(((FCa*FCa)+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FCrt_dX = deriv_sqrt_0_d0*(((FCa*d_FCa_dX+d_FCa_dX*FCa)+modelStruct.d_modelPar_ahc_dX));
FCrt = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((1.0+modelStruct.modelPar_ahc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_FCa_ck_dX = (-(((1.0+value_sqrt_0)*(d_FCa_dX+d_FCrt_dX)-(FCa+FCrt)*deriv_sqrt_0_d0*(modelStruct.d_modelPar_ahc_dX))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0)));
FCa_ck = (1.0-((FCa+FCrt)/(1.0+value_sqrt_0)));
}
d_FCdaick_ditf_dX = (((FCrt*itf)*((FCa_ck-1.0)*(-d_FCa_dX)+d_FCa_ck_dX*(1-FCa))-((FCa_ck-1.0)*(1-FCa))*(FCrt*d_itf_dX+d_FCrt_dX*itf))/(FCrt*itf)/(FCrt*itf));
FCdaick_ditf = (((FCa_ck-1.0)*(1-FCa))/(FCrt*itf));
if ((modelStruct.modelPar_latb>modelStruct.modelPar_latl))
{
d_FCz_dX = (modelStruct.d_modelPar_latb_dX-modelStruct.d_modelPar_latl_dX);
FCz = (modelStruct.modelPar_latb-modelStruct.modelPar_latl);
d_FCxl_dX = modelStruct.d_modelPar_latl_dX;
FCxl = (1.0+modelStruct.modelPar_latl);
d_FCxb_dX = modelStruct.d_modelPar_latb_dX;
FCxb = (1.0+modelStruct.modelPar_latb);
if ((modelStruct.modelPar_latb>0.01))
{
{
double value_log_0 = log((FCxb/FCxl));
double  deriv_log_0_d0 = (1.0/(FCxb/FCxl));
d_FCln_dX = deriv_log_0_d0*(((FCxl*d_FCxb_dX-FCxb*d_FCxl_dX)/FCxl/FCxl));
FCln = value_log_0;
}
{
double value_exp_0 = exp(((FCa_ck-1.0)*FCln));
double  deriv_exp_0_d0 = value_exp_0;
d_FCa1_dX = deriv_exp_0_d0*(((FCa_ck-1.0)*d_FCln_dX+d_FCa_ck_dX*FCln));
FCa1 = value_exp_0;
}
d_FCd_a_dX = (-(modelStruct.d_modelPar_latl_dX-(FCa1*modelStruct.d_modelPar_latb_dX+d_FCa1_dX*modelStruct.modelPar_latb))/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb))/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb)));
FCd_a = (1.0/(modelStruct.modelPar_latl-(FCa1*modelStruct.modelPar_latb)));
d_FCw_dX = ((FCa1-1.0)*d_FCd_a_dX+d_FCa1_dX*FCd_a);
FCw = ((FCa1-1.0)*FCd_a);
d_FCdw_daick_dX = (((((-FCz)*FCa1)*FCln)*FCd_a)*d_FCd_a_dX+((((-FCz)*FCa1)*FCln)*d_FCd_a_dX+(((-FCz)*FCa1)*d_FCln_dX+((-FCz)*d_FCa1_dX+(-d_FCz_dX)*FCa1)*FCln)*FCd_a)*FCd_a);
FCdw_daick = (((((-FCz)*FCa1)*FCln)*FCd_a)*FCd_a);
{
double value_log_0 = log(((1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
double  deriv_log_0_d0 = (1.0/((1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
d_FCa1_dX = deriv_log_0_d0*((((1.0+(modelStruct.modelPar_latl*FCw))*(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw)-(1.0+(modelStruct.modelPar_latb*FCw))*(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
FCa1 = value_log_0;
}
d_FCda1_dw_dX = ((((1.0+(modelStruct.modelPar_latb*FCw))*modelStruct.d_modelPar_latb_dX-modelStruct.modelPar_latb*(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw))/(1.0+(modelStruct.modelPar_latb*FCw))/(1.0+(modelStruct.modelPar_latb*FCw)))-(((1.0+(modelStruct.modelPar_latl*FCw))*modelStruct.d_modelPar_latl_dX-modelStruct.modelPar_latl*(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))/(1.0+(modelStruct.modelPar_latl*FCw))));
FCda1_dw = ((modelStruct.modelPar_latb/(1.0+(modelStruct.modelPar_latb*FCw)))-(modelStruct.modelPar_latl/(1.0+(modelStruct.modelPar_latl*FCw))));
}
else
{
d_FCf1_dX = (-d_FCa_ck_dX);
FCf1 = (1.0-FCa_ck);
d_FCd_a_dX = (-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb)/(1.0+(FCa_ck*modelStruct.modelPar_latb))/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
FCd_a = (1.0/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
d_FCw_dX = (FCf1*d_FCd_a_dX+d_FCf1_dX*FCd_a);
FCw = (FCf1*FCd_a);
d_FCdw_daick_dX = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*d_FCd_a_dX+((((-1.0)*FCd_a)*FCd_a)*d_FCxb_dX+(((-1.0)*FCd_a)*d_FCd_a_dX+(-1.0)*d_FCd_a_dX*FCd_a)*FCxb)*FCd_a);
FCdw_daick = (((((-1.0)*FCd_a)*FCd_a)*FCxb)*FCd_a);
d_FCa1_dX = (FCz*d_FCw_dX+d_FCz_dX*FCw);
FCa1 = (FCz*FCw);
d_FCda1_dw_dX = d_FCz_dX;
FCda1_dw = FCz;
}
d_FCf_CT_dX = (-2.0*d_FCz_dX/FCz/FCz);
FCf_CT = (2.0/FCz);
d_FCw2_dX = (FCw*d_FCw_dX+d_FCw_dX*FCw);
FCw2 = (FCw*FCw);
d_FCf1_dX = ((((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw)*d_FCw2_dX+((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*d_FCw_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latl)*FCw)*FCw2)/3.0)+(((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*d_FCw2_dX+(modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latl_dX)*FCw2)/2.0))+d_FCw_dX);
FCf1 = ((((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw)*FCw2)/3.0)+(((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*FCw2)/2.0))+FCw);
d_FCdf1_dw_dX = (((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*d_FCw2_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latl)*FCw2)+((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*d_FCw_dX+(modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latl_dX)*FCw));
FCdf1_dw = ((((modelStruct.modelPar_latb*modelStruct.modelPar_latl)*FCw2)+((modelStruct.modelPar_latb+modelStruct.modelPar_latl)*FCw))+1.0);
d_z_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
z = (modelStruct.modelPar_latb*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latb*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latb*FCw)));
d_lnzb_dX = deriv_log_0_d0*((modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{
d_x_dX = d_z_dX;
x = (1.0+z);
instanceStruct.d_instanceVar_a_dX = (x*d_x_dX+d_x_dX*x);
instanceStruct.instanceVar_a = (x*x);
d_a2_dX = 0.250*(instanceStruct.instanceVar_a*2.0*d_lnzb_dX+instanceStruct.d_instanceVar_a_dX*((2.0*lnzb)-1.0));
a2 = (0.250*((instanceStruct.instanceVar_a*((2.0*lnzb)-1.0))+1.0));
d_a3_dX = (((instanceStruct.instanceVar_a*x)*3.0*d_lnzb_dX+(instanceStruct.instanceVar_a*d_x_dX+instanceStruct.d_instanceVar_a_dX*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((instanceStruct.instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
d_r_dX = ((modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX-modelStruct.modelPar_latl*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
r = (modelStruct.modelPar_latl/modelStruct.modelPar_latb);
d_FCf2_dX = ((modelStruct.modelPar_latb*(((1.0-r)*d_a2_dX+(-d_r_dX)*a2)+(r*d_a3_dX+d_r_dX*a3))-(((1.0-r)*a2)+(r*a3))*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
FCf2 = ((((1.0-r)*a2)+(r*a3))/modelStruct.modelPar_latb);
d_FCdf2_dw_dX = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*d_lnzb_dX+(((1.0-r)*d_x_dX+(-d_r_dX)*x)+(r*instanceStruct.d_instanceVar_a_dX+d_r_dX*instanceStruct.instanceVar_a))*lnzb);
FCdf2_dw = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*lnzb);
}
else
{
instanceStruct.d_instanceVar_a_dX = (z*d_z_dX+d_z_dX*z);
instanceStruct.instanceVar_a = (z*z);
d_a2_dX = ((d_z_dX-0.25*instanceStruct.d_instanceVar_a_dX)+((0.10*z)*instanceStruct.d_instanceVar_a_dX+0.10*d_z_dX*instanceStruct.instanceVar_a));
a2 = (((3.0+z)-(0.25*instanceStruct.instanceVar_a))+((0.10*z)*instanceStruct.instanceVar_a));
d_a3_dX = ((2.0*d_z_dX+0.75*instanceStruct.d_instanceVar_a_dX)-((0.20*instanceStruct.instanceVar_a)*d_z_dX+0.20*instanceStruct.d_instanceVar_a_dX*z));
a3 = (((2.0*z)+(0.75*instanceStruct.instanceVar_a))-((0.20*instanceStruct.instanceVar_a)*z));
d_FCf2_dX = (((((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*FCw)*d_FCw_dX+(((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*d_FCw_dX+((modelStruct.modelPar_latb*d_a2_dX+modelStruct.d_modelPar_latb_dX*a2)+(modelStruct.modelPar_latl*d_a3_dX+modelStruct.d_modelPar_latl_dX*a3))*FCw)*FCw)/6.0);
FCf2 = (((((modelStruct.modelPar_latb*a2)+(modelStruct.modelPar_latl*a3))*FCw)*FCw)/6.0);
d_FCdf2_dw_dX = (((1+(modelStruct.modelPar_latl*FCw))*(1+z))*d_lnzb_dX+((1+(modelStruct.modelPar_latl*FCw))*d_z_dX+(modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw)*(1+z))*lnzb);
FCdf2_dw = (((1+(modelStruct.modelPar_latl*FCw))*(1+z))*lnzb);
}
d_z_dX = (modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw);
z = (modelStruct.modelPar_latl*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latl*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latl*FCw)));
d_lnzb_dX = deriv_log_0_d0*((modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw));
lnzb = value_log_0;
}
if ((z>1.0e-6))
{
d_x_dX = d_z_dX;
x = (1.0+z);
instanceStruct.d_instanceVar_a_dX = (x*d_x_dX+d_x_dX*x);
instanceStruct.instanceVar_a = (x*x);
d_a2_dX = 0.250*(instanceStruct.instanceVar_a*2.0*d_lnzb_dX+instanceStruct.d_instanceVar_a_dX*((2.0*lnzb)-1.0));
a2 = (0.250*((instanceStruct.instanceVar_a*((2.0*lnzb)-1.0))+1.0));
d_a3_dX = (((instanceStruct.instanceVar_a*x)*3.0*d_lnzb_dX+(instanceStruct.instanceVar_a*d_x_dX+instanceStruct.d_instanceVar_a_dX*x)*((3.0*lnzb)-1.0))/9.0);
a3 = ((((instanceStruct.instanceVar_a*x)*((3.0*lnzb)-1.0))+1.0)/9.0);
d_r_dX = ((modelStruct.modelPar_latl*modelStruct.d_modelPar_latb_dX-modelStruct.modelPar_latb*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
r = (modelStruct.modelPar_latb/modelStruct.modelPar_latl);
d_FCf3_dX = ((modelStruct.modelPar_latl*(((1.0-r)*d_a2_dX+(-d_r_dX)*a2)+(r*d_a3_dX+d_r_dX*a3))-(((1.0-r)*a2)+(r*a3))*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
FCf3 = ((((1.0-r)*a2)+(r*a3))/modelStruct.modelPar_latl);
d_FCdf3_dw_dX = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*d_lnzb_dX+(((1.0-r)*d_x_dX+(-d_r_dX)*x)+(r*instanceStruct.d_instanceVar_a_dX+d_r_dX*instanceStruct.instanceVar_a))*lnzb);
FCdf3_dw = ((((1.0-r)*x)+(r*instanceStruct.instanceVar_a))*lnzb);
}
else
{
instanceStruct.d_instanceVar_a_dX = (z*d_z_dX+d_z_dX*z);
instanceStruct.instanceVar_a = (z*z);
d_a2_dX = ((d_z_dX-0.25*instanceStruct.d_instanceVar_a_dX)+((0.10*z)*instanceStruct.d_instanceVar_a_dX+0.10*d_z_dX*instanceStruct.instanceVar_a));
a2 = (((3.0+z)-(0.25*instanceStruct.instanceVar_a))+((0.10*z)*instanceStruct.instanceVar_a));
d_a3_dX = ((2.0*d_z_dX+0.75*instanceStruct.d_instanceVar_a_dX)-((0.20*instanceStruct.instanceVar_a)*d_z_dX+0.20*instanceStruct.d_instanceVar_a_dX*z));
a3 = (((2.0*z)+(0.75*instanceStruct.instanceVar_a))-((0.20*instanceStruct.instanceVar_a)*z));
d_FCf3_dX = (((((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*FCw)*d_FCw_dX+(((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*d_FCw_dX+((modelStruct.modelPar_latl*d_a2_dX+modelStruct.d_modelPar_latl_dX*a2)+(modelStruct.modelPar_latb*d_a3_dX+modelStruct.d_modelPar_latb_dX*a3))*FCw)*FCw)/6.0);
FCf3 = (((((modelStruct.modelPar_latl*a2)+(modelStruct.modelPar_latb*a3))*FCw)*FCw)/6.0);
d_FCdf3_dw_dX = (((1+(modelStruct.modelPar_latb*FCw))*(1+z))*d_lnzb_dX+((1+(modelStruct.modelPar_latb*FCw))*d_z_dX+(modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw)*(1+z))*lnzb);
FCdf3_dw = (((1+(modelStruct.modelPar_latb*FCw))*(1+z))*lnzb);
}
d_FCf_ci_dX = (FCf_CT*(((FCa1*d_FCf1_dX+d_FCa1_dX*FCf1)-d_FCf2_dX)+d_FCf3_dX)+d_FCf_CT_dX*(((FCa1*FCf1)-FCf2)+FCf3));
FCf_ci = (FCf_CT*(((FCa1*FCf1)-FCf2)+FCf3));
d_FCdfc_dw_dX = (FCf_CT*((((FCa1*d_FCdf1_dw_dX+d_FCa1_dX*FCdf1_dw)+(FCda1_dw*d_FCf1_dX+d_FCda1_dw_dX*FCf1))-d_FCdf2_dw_dX)+d_FCdf3_dw_dX)+d_FCf_CT_dX*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
FCdfc_dw = (FCf_CT*((((FCa1*FCdf1_dw)+(FCda1_dw*FCf1))-FCdf2_dw)+FCdf3_dw));
d_FCdw_ditf_dX = (FCdw_daick*d_FCdaick_ditf_dX+d_FCdw_daick_dX*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);
d_FCdfc_ditf_dX = (FCdfc_dw*d_FCdw_ditf_dX+d_FCdfc_dw_dX*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
instanceStruct.instanceVar_a = (modelStruct.modelPar_latb*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latb*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latb*FCw)));
d_lnz_dX = deriv_log_0_d0*((modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw));
lnz = value_log_0;
}
if ((instanceStruct.instanceVar_a>1.0e-6))
{
d_FCf2_dX = ((modelStruct.modelPar_latb*(instanceStruct.d_instanceVar_a_dX-d_lnz_dX)-(instanceStruct.instanceVar_a-lnz)*modelStruct.d_modelPar_latb_dX)/modelStruct.modelPar_latb/modelStruct.modelPar_latb);
FCf2 = ((instanceStruct.instanceVar_a-lnz)/modelStruct.modelPar_latb);
d_FCdf2_dw_dX = (((1.0+instanceStruct.instanceVar_a)*instanceStruct.d_instanceVar_a_dX-instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX)/(1.0+instanceStruct.instanceVar_a)/(1.0+instanceStruct.instanceVar_a));
FCdf2_dw = (instanceStruct.instanceVar_a/(1.0+instanceStruct.instanceVar_a));
}
else
{
d_FCf2_dX = ((0.5*instanceStruct.instanceVar_a)*d_FCw_dX+0.5*instanceStruct.d_instanceVar_a_dX*FCw);
FCf2 = ((0.5*instanceStruct.instanceVar_a)*FCw);
d_FCdf2_dw_dX = instanceStruct.d_instanceVar_a_dX;
FCdf2_dw = instanceStruct.instanceVar_a;
}
instanceStruct.d_instanceVar_a_dX = (modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw);
instanceStruct.instanceVar_a = (modelStruct.modelPar_latl*FCw);
{
double value_log_0 = log((1+(modelStruct.modelPar_latl*FCw)));
double  deriv_log_0_d0 = (1.0/(1+(modelStruct.modelPar_latl*FCw)));
d_lnz_dX = deriv_log_0_d0*((modelStruct.modelPar_latl*d_FCw_dX+modelStruct.d_modelPar_latl_dX*FCw));
lnz = value_log_0;
}
if ((instanceStruct.instanceVar_a>1.0e-6))
{
d_FCf3_dX = ((modelStruct.modelPar_latl*(instanceStruct.d_instanceVar_a_dX-d_lnz_dX)-(instanceStruct.instanceVar_a-lnz)*modelStruct.d_modelPar_latl_dX)/modelStruct.modelPar_latl/modelStruct.modelPar_latl);
FCf3 = ((instanceStruct.instanceVar_a-lnz)/modelStruct.modelPar_latl);
d_FCdf3_dw_dX = (((1.0+instanceStruct.instanceVar_a)*instanceStruct.d_instanceVar_a_dX-instanceStruct.instanceVar_a*instanceStruct.d_instanceVar_a_dX)/(1.0+instanceStruct.instanceVar_a)/(1.0+instanceStruct.instanceVar_a));
FCdf3_dw = (instanceStruct.instanceVar_a/(1.0+instanceStruct.instanceVar_a));
}
else
{
d_FCf3_dX = ((0.5*instanceStruct.instanceVar_a)*d_FCw_dX+0.5*instanceStruct.d_instanceVar_a_dX*FCw);
FCf3 = ((0.5*instanceStruct.instanceVar_a)*FCw);
d_FCdf3_dw_dX = instanceStruct.d_instanceVar_a_dX;
FCdf3_dw = instanceStruct.instanceVar_a;
}
d_FCf_CT_dX = (FCf_CT*(d_FCf2_dX-d_FCf3_dX)+d_FCf_CT_dX*(FCf2-FCf3));
FCf_CT = (FCf_CT*(FCf2-FCf3));
d_FCdfCT_dw_dX = (FCf_CT*(d_FCdf2_dw_dX-d_FCdf3_dw_dX)+d_FCf_CT_dX*(FCdf2_dw-FCdf3_dw));
FCdfCT_dw = (FCf_CT*(FCdf2_dw-FCdf3_dw));
d_FCdfCT_ditf_dX = (FCdfCT_dw*d_FCdw_ditf_dX+d_FCdfCT_dw_dX*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{
d_FCf_CT_dX = d_FCf_ci_dX;
FCf_CT = FCf_ci;
d_FCdfCT_ditf_dX = d_FCdfc_ditf_dX;
FCdfCT_ditf = FCdfc_ditf;
}
}
else
{
if ((modelStruct.modelPar_latb>0.01))
{
d_FCd_a_dX = (-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb)/(1.0+(FCa_ck*modelStruct.modelPar_latb))/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
FCd_a = (1.0/(1.0+(FCa_ck*modelStruct.modelPar_latb)));
d_FCw_dX = ((1.0-FCa_ck)*d_FCd_a_dX+(-d_FCa_ck_dX)*FCd_a);
FCw = ((1.0-FCa_ck)*FCd_a);
d_FCdw_daick_dX = (((-(1.0+modelStruct.modelPar_latb))*FCd_a)*d_FCd_a_dX+((-(1.0+modelStruct.modelPar_latb))*d_FCd_a_dX+(-modelStruct.d_modelPar_latb_dX)*FCd_a)*FCd_a);
FCdw_daick = (((-(1.0+modelStruct.modelPar_latb))*FCd_a)*FCd_a);
}
else
{
d_FCw_dX = ((-d_FCa_ck_dX)-(FCa_ck*modelStruct.d_modelPar_latb_dX+d_FCa_ck_dX*modelStruct.modelPar_latb));
FCw = ((1.0-FCa_ck)-(FCa_ck*modelStruct.modelPar_latb));
d_FCdw_daick_dX = (-modelStruct.d_modelPar_latb_dX);
FCdw_daick = (-(1.0+modelStruct.modelPar_latb));
}
d_FCw2_dX = (FCw*d_FCw_dX+d_FCw_dX*FCw);
FCw2 = (FCw*FCw);
d_FCz_dX = (modelStruct.modelPar_latb*d_FCw_dX+modelStruct.d_modelPar_latb_dX*FCw);
FCz = (modelStruct.modelPar_latb*FCw);
d_FCz_1_dX = d_FCz_dX;
FCz_1 = (1.0+FCz);
d_FCd_f_dX = (-d_FCz_1_dX/FCz_1/FCz_1);
FCd_f = (1.0/FCz_1);
d_FCf_ci_dX = ((FCw2*(1.0+(FCz/3.0)))*d_FCd_f_dX+(FCw2*(d_FCz_dX/3.0)+d_FCw2_dX*(1.0+(FCz/3.0)))*FCd_f);
FCf_ci = ((FCw2*(1.0+(FCz/3.0)))*FCd_f);
d_FCdfc_dw_dX = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dX+(((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*d_FCd_f_dX+((2.0*FCw)*(d_FCz_1_dX+((FCz*d_FCz_dX+d_FCz_dX*FCz)/3.0))+2.0*d_FCw_dX*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfc_dw = ((((2.0*FCw)*(FCz_1+((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
d_FCdw_ditf_dX = (FCdw_daick*d_FCdaick_ditf_dX+d_FCdw_daick_dX*FCdaick_ditf);
FCdw_ditf = (FCdw_daick*FCdaick_ditf);
d_FCdfc_ditf_dX = (FCdfc_dw*d_FCdw_ditf_dX+d_FCdfc_dw_dX*FCdw_ditf);
FCdfc_ditf = (FCdfc_dw*FCdw_ditf);
if (((modelStruct.modelPar_flcomp==0.0)||(modelStruct.modelPar_flcomp==2.1)))
{
if ((FCz>0.001))
{
{
double value_log_0 = log(FCz_1);
double  deriv_log_0_d0 = (1.0/FCz_1);
d_FCf_CT_dX = ((((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1)*2.0*((FCz_1*deriv_log_0_d0*(d_FCz_1_dX)+d_FCz_1_dX*value_log_0)-d_FCz_dX)-(2.0*((FCz_1*value_log_0)-FCz))*((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*d_FCz_1_dX+(modelStruct.modelPar_latb*modelStruct.d_modelPar_latb_dX+modelStruct.d_modelPar_latb_dX*modelStruct.modelPar_latb)*FCz_1))/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1)/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1));
FCf_CT = ((2.0*((FCz_1*value_log_0)-FCz))/((modelStruct.modelPar_latb*modelStruct.modelPar_latb)*FCz_1));
}
d_FCdfCT_dw_dX = (((2.0*FCw)*FCd_f)*d_FCd_f_dX+((2.0*FCw)*d_FCd_f_dX+2.0*d_FCw_dX*FCd_f)*FCd_f);
FCdfCT_dw = (((2.0*FCw)*FCd_f)*FCd_f);
}
else
{
d_FCf_CT_dX = ((FCw2*(1.0-(FCz/3.0)))*d_FCd_f_dX+(FCw2*(-(d_FCz_dX/3.0))+d_FCw2_dX*(1.0-(FCz/3.0)))*FCd_f);
FCf_CT = ((FCw2*(1.0-(FCz/3.0)))*FCd_f);
d_FCdfCT_dw_dX = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*d_FCd_f_dX+(((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*d_FCd_f_dX+((2.0*FCw)*(-((FCz*d_FCz_dX+d_FCz_dX*FCz)/3.0))+2.0*d_FCw_dX*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
FCdfCT_dw = ((((2.0*FCw)*(1.0-((FCz*FCz)/3.0)))*FCd_f)*FCd_f);
}
d_FCdfCT_ditf_dX = (FCdfCT_dw*d_FCdw_ditf_dX+d_FCdfCT_dw_dX*FCdw_ditf);
FCdfCT_ditf = (FCdfCT_dw*FCdw_ditf);
}
else
{
d_FCf_CT_dX = d_FCf_ci_dX;
FCf_CT = FCf_ci;
d_FCdfCT_ditf_dX = d_FCdfc_ditf_dX;
FCdfCT_ditf = FCdfc_ditf;
}
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQcfcT_dX = ((FFdQcfc*FCf_CT)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(FFdQcfc*d_FCf_CT_dX+d_FFdQcfc_dX*FCf_CT)*value_exp_0);
FFdQcfcT = ((FFdQcfc*FCf_CT)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdQcfc_dX = ((FFdQcfc*FCf_ci)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(FFdQcfc*d_FCf_ci_dX+d_FFdQcfc_dX*FCf_ci)*value_exp_0);
FFdQcfc = ((FFdQcfc*FCf_ci)*value_exp_0);
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTcfc_dX = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(d_FCf_ci_dX+(itf*d_FCdfc_ditf_dX+d_itf_dX*FCdfc_ditf))+((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*d_FFdQcfc_dX-FFdQcfc*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTcfc = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_ci+(itf*FCdfc_ditf)))+((FFdQcfc/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
{
double value_exp_0 = exp(((FFdVc-modelStruct.modelPar_vcbar)/instanceStruct.instanceVar_VT));
double  deriv_exp_0_d0 = value_exp_0;
d_FFdTcfcT_dX = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(d_FCf_CT_dX+(itf*d_FCdfCT_ditf_dX+d_itf_dX*FCdfCT_ditf))+((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*deriv_exp_0_d0*(((instanceStruct.instanceVar_VT*(d_FFdVc_dX-modelStruct.d_modelPar_vcbar_dX)-(FFdVc-modelStruct.modelPar_vcbar)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT))+(modelStruct.modelPar_fthc*instanceStruct.d_instanceVar_thcs_t_dX+modelStruct.d_modelPar_fthc_dX*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceStruct.instanceVar_VT)*d_FFdVc_ditf_dX+((instanceStruct.instanceVar_VT*d_FFdQcfcT_dX-FFdQcfcT*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
FFdTcfcT = ((((modelStruct.modelPar_fthc*instanceStruct.instanceVar_thcs_t)*value_exp_0)*(FCf_CT+(itf*FCdfCT_ditf)))+((FFdQcfcT/instanceStruct.instanceVar_VT)*FFdVc_ditf));
}
}
d_FFdQbfc_dX = ((1-modelStruct.modelPar_fthc)*d_FFdQfhc_dX+(-modelStruct.d_modelPar_fthc_dX)*FFdQfhc);
FFdQbfc = ((1-modelStruct.modelPar_fthc)*FFdQfhc);
d_FFdTbfc_dX = ((1-modelStruct.modelPar_fthc)*d_FFdTfhc_dX+(-modelStruct.d_modelPar_fthc_dX)*FFdTfhc);
FFdTbfc = ((1-modelStruct.modelPar_fthc)*FFdTfhc);
d_Q_fT_dX = (((((instanceStruct.instanceVar_hf0_t*d_Qf_dX+instanceStruct.d_instanceVar_hf0_t_dX*Qf)+d_FFdQbfb_dX)+d_FFdQbfc_dX)+(instanceStruct.instanceVar_hfe_t*d_FFdQef_dX+instanceStruct.d_instanceVar_hfe_t_dX*FFdQef))+(instanceStruct.instanceVar_hfc_t*d_FFdQcfcT_dX+instanceStruct.d_instanceVar_hfc_t_dX*FFdQcfcT));
Q_fT = (((((instanceStruct.instanceVar_hf0_t*Qf)+FFdQbfb)+FFdQbfc)+(instanceStruct.instanceVar_hfe_t*FFdQef))+(instanceStruct.instanceVar_hfc_t*FFdQcfcT));
d_T_fT_dX = (((((instanceStruct.instanceVar_hf0_t*instanceStruct.d_instanceVar_Tf_dX+instanceStruct.d_instanceVar_hf0_t_dX*instanceStruct.instanceVar_Tf)+d_FFdTbfb_dX)+d_FFdTbfc_dX)+(instanceStruct.instanceVar_hfe_t*d_FFdTef_dX+instanceStruct.d_instanceVar_hfe_t_dX*FFdTef))+(instanceStruct.instanceVar_hfc_t*d_FFdTcfcT_dX+instanceStruct.d_instanceVar_hfc_t_dX*FFdTcfcT));
T_fT = (((((instanceStruct.instanceVar_hf0_t*instanceStruct.instanceVar_Tf)+FFdTbfb)+FFdTbfc)+(instanceStruct.instanceVar_hfe_t*FFdTef))+(instanceStruct.instanceVar_hfc_t*FFdTcfcT));
d_Qf_dX = (((d_Qf_dX+(d_FFdQbfb_dX+d_FFdQbfc_dX))+d_FFdQef_dX)+d_FFdQcfc_dX);
Qf = (((Qf+(FFdQbfb+FFdQbfc))+FFdQef)+FFdQcfc);
instanceStruct.d_instanceVar_Tf_dX = (((instanceStruct.d_instanceVar_Tf_dX+(d_FFdTbfb_dX+d_FFdTbfc_dX))+d_FFdTef_dX)+d_FFdTcfc_dX);
instanceStruct.instanceVar_Tf = (((instanceStruct.instanceVar_Tf+(FFdTbfb+FFdTbfc))+FFdTef)+FFdTcfc);
d_Q_bf_dX = (d_FFdQbfb_dX+d_FFdQbfc_dX);
Q_bf = (FFdQbfb+FFdQbfc);
}
d_Qr_dX = (Tr*d_itr_dX+d_Tr_dX*itr);
Qr = (Tr*itr);
}
instanceStruct.d_instanceVar_it_dX = (d_itf_dX-d_itr_dX);
instanceStruct.instanceVar_it = (itf-itr);
d_Qdei_dX = d_Qf_dX;
Qdei = Qf;
d_Qdci_dX = d_Qr_dX;
Qdci = Qr;
d_Cdei_dX = ((instanceStruct.instanceVar_VT*(T_f0*d_itf_dX+d_T_f0_dX*itf)-(T_f0*itf)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
Cdei = ((T_f0*itf)/instanceStruct.instanceVar_VT);
d_Cdci_dX = ((instanceStruct.instanceVar_VT*(modelStruct.modelPar_tr*d_itr_dX+modelStruct.d_modelPar_tr_dX*itr)-(modelStruct.modelPar_tr*itr)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
Cdci = ((modelStruct.modelPar_tr*itr)/instanceStruct.instanceVar_VT);
d_Crbi_dX = (modelStruct.modelPar_fcrbi*(((d_Cjei_dX+d_Cjci_dX)+d_Cdei_dX)+d_Cdci_dX)+modelStruct.d_modelPar_fcrbi_dX*(((Cjei+Cjci)+Cdei)+Cdci));
Crbi = (modelStruct.modelPar_fcrbi*(((Cjei+Cjci)+Cdei)+Cdci));
d_qrbi_dX = d_Crbi_dX*(probeVars[admsProbeID_V_bp_bi]);
qrbi = (Crbi*(probeVars[admsProbeID_V_bp_bi]));
d_DIOY_dX = (((modelStruct.modelPar_mbci*instanceStruct.instanceVar_VT)*d_Vbici_dX-Vbici*(modelStruct.modelPar_mbci*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mbci_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mbci*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mbci*instanceStruct.instanceVar_VT));
DIOY = (Vbici/(modelStruct.modelPar_mbci*instanceStruct.instanceVar_VT));
if ((modelStruct.modelPar_ibcis>0.0))
{
if ((DIOY>80.0))
{
d_le_dX = d_DIOY_dX;
le = (1+(DIOY-80.0));
d_DIOY_dX = 0.0;
DIOY = 80.0;
}
else
{
d_le_dX = 0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));
d_le_dX = (le*deriv_limexp_0_d0*(d_DIOY_dX)+d_le_dX*value_limexp_0);
le = (le*value_limexp_0);
}
instanceStruct.d_instanceVar_ibci_dX = (instanceStruct.instanceVar_ibcis_t*d_le_dX+instanceStruct.d_instanceVar_ibcis_t_dX*(le-1.0));
instanceStruct.instanceVar_ibci = (instanceStruct.instanceVar_ibcis_t*(le-1.0));
if ((DIOY<=(-14.0)))
{
instanceStruct.d_instanceVar_ibci_dX = (-instanceStruct.d_instanceVar_ibcis_t_dX);
instanceStruct.instanceVar_ibci = (-instanceStruct.instanceVar_ibcis_t);
}
}
else
{
instanceStruct.d_instanceVar_ibci_dX = 0.0;
instanceStruct.instanceVar_ibci = 0.0;
}
if ((instanceStruct.instanceVar_use_aval==1))
//Begin block HICAVL
{
//Block-local variables for block HICAVL
double v_bord=0.0;
double d_v_bord_dX=0.0;
double v_q=0.0;
double d_v_q_dX=0.0;
double U0=0.0;
double d_U0_dX=0.0;
double av=0.0;
double d_av_dX=0.0;
double avl=0.0;
double d_avl_dX=0.0;
//End of Block-local variables
d_v_bord_dX = (instanceStruct.d_instanceVar_vdci_t_dX-d_Vbici_dX);
v_bord = (instanceStruct.instanceVar_vdci_t-Vbici);
if ((v_bord>0))
{
d_v_q_dX = ((Cjci*instanceStruct.d_instanceVar_qavl_t_dX-instanceStruct.instanceVar_qavl_t*d_Cjci_dX)/Cjci/Cjci);
v_q = (instanceStruct.instanceVar_qavl_t/Cjci);
d_U0_dX = ((instanceStruct.instanceVar_cjci0_t*instanceStruct.d_instanceVar_qavl_t_dX-instanceStruct.instanceVar_qavl_t*instanceStruct.d_instanceVar_cjci0_t_dX)/instanceStruct.instanceVar_cjci0_t/instanceStruct.instanceVar_cjci0_t);
U0 = (instanceStruct.instanceVar_qavl_t/instanceStruct.instanceVar_cjci0_t);
if ((v_bord>U0))
{
{
double value_exp_0 = exp(((-v_q)/U0));
double  deriv_exp_0_d0 = value_exp_0;
d_av_dX = (instanceStruct.instanceVar_favl_t*deriv_exp_0_d0*(((U0*(-d_v_q_dX)-(-v_q)*d_U0_dX)/U0/U0))+instanceStruct.d_instanceVar_favl_t_dX*value_exp_0);
av = (instanceStruct.instanceVar_favl_t*value_exp_0);
}
d_avl_dX = (av*(d_U0_dX+((1.0+(v_q/U0))*(d_v_bord_dX-d_U0_dX)+((U0*d_v_q_dX-v_q*d_U0_dX)/U0/U0)*(v_bord-U0)))+d_av_dX*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
avl = (av*(U0+((1.0+(v_q/U0))*(v_bord-U0))));
}
else
{
{
double value_exp_0 = exp(((-v_q)/v_bord));
double  deriv_exp_0_d0 = value_exp_0;
d_avl_dX = ((instanceStruct.instanceVar_favl_t*v_bord)*deriv_exp_0_d0*(((v_bord*(-d_v_q_dX)-(-v_q)*d_v_bord_dX)/v_bord/v_bord))+(instanceStruct.instanceVar_favl_t*d_v_bord_dX+instanceStruct.d_instanceVar_favl_t_dX*v_bord)*value_exp_0);
avl = ((instanceStruct.instanceVar_favl_t*v_bord)*value_exp_0);
}
}
if ((modelStruct.modelPar_kavl>0))
//Begin block HICAVLHIGH
{
//Block-local variables for block HICAVLHIGH
double denom=0.0;
double d_denom_dX=0.0;
double sq_smooth=0.0;
double d_sq_smooth_dX=0.0;
double hl=0.0;
double d_hl_dX=0.0;
//End of Block-local variables
d_denom_dX = (-(instanceStruct.instanceVar_kavl_t*d_avl_dX+instanceStruct.d_instanceVar_kavl_t_dX*avl));
denom = (1-(instanceStruct.instanceVar_kavl_t*avl));
{
double value_sqrt_0 = sqrt(((denom*denom)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sq_smooth_dX = deriv_sqrt_0_d0*((denom*d_denom_dX+d_denom_dX*denom));
sq_smooth = value_sqrt_0;
}
d_hl_dX = 0.5*(d_denom_dX+d_sq_smooth_dX);
hl = (0.5*(denom+sq_smooth));
instanceStruct.d_instanceVar_iavl_dX = ((hl*(itf*d_avl_dX+d_itf_dX*avl)-(itf*avl)*d_hl_dX)/hl/hl);
instanceStruct.instanceVar_iavl = ((itf*avl)/hl);
}
// End block HICAVLHIGH
else
{
instanceStruct.d_instanceVar_iavl_dX = (itf*d_avl_dX+d_itf_dX*avl);
instanceStruct.instanceVar_iavl = (itf*avl);
}
}
else
{
instanceStruct.d_instanceVar_iavl_dX = 0.0;
instanceStruct.instanceVar_iavl = 0.0;
}
}
// End block HICAVL
d_ibh_rec_dX = (Q_bf*instanceStruct.d_instanceVar_Otbhrec_dX+d_Q_bf_dX*instanceStruct.instanceVar_Otbhrec);
ibh_rec = (Q_bf*instanceStruct.instanceVar_Otbhrec);
if ((instanceStruct.instanceVar_rbi0_t>0.0))
//Begin block HICRBI
{
//Block-local variables for block HICRBI
double Qz_nom=0.0;
double d_Qz_nom_dX=0.0;
double f_QR=0.0;
double d_f_QR_dX=0.0;
double ETA=0.0;
double d_ETA_dX=0.0;
double Qz0=0.0;
double d_Qz0_dX=0.0;
double fQz=0.0;
double d_fQz_dX=0.0;
//End of Block-local variables
d_f_QR_dX = ((1+modelStruct.modelPar_fdqr0)*instanceStruct.d_instanceVar_qp0_t_dX+modelStruct.d_modelPar_fdqr0_dX*instanceStruct.instanceVar_qp0_t);
f_QR = ((1+modelStruct.modelPar_fdqr0)*instanceStruct.instanceVar_qp0_t);
d_Qz0_dX = ((d_Qjei_dX+d_Qjci_dX)+d_Qf_dX);
Qz0 = ((Qjei+Qjci)+Qf);
d_Qz_nom_dX = ((f_QR*d_Qz0_dX-Qz0*d_f_QR_dX)/f_QR/f_QR);
Qz_nom = (1+(Qz0/f_QR));
{
double value_sqrt_0 = sqrt(((Qz_nom*Qz_nom)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_fQz_dX = 0.5*(d_Qz_nom_dX+deriv_sqrt_0_d0*((Qz_nom*d_Qz_nom_dX+d_Qz_nom_dX*Qz_nom)));
fQz = (0.5*(Qz_nom+value_sqrt_0));
}
instanceStruct.d_instanceVar_rbi_dX = ((fQz*instanceStruct.d_instanceVar_rbi0_t_dX-instanceStruct.instanceVar_rbi0_t*d_fQz_dX)/fQz/fQz);
instanceStruct.instanceVar_rbi = (instanceStruct.instanceVar_rbi0_t/fQz);
if ((instanceStruct.instanceVar_ibei>0.0))
{
d_ETA_dX = ((instanceStruct.instanceVar_VT*((instanceStruct.instanceVar_rbi*instanceStruct.instanceVar_ibei)*modelStruct.d_modelPar_fgeo_dX+(instanceStruct.instanceVar_rbi*instanceStruct.d_instanceVar_ibei_dX+instanceStruct.d_instanceVar_rbi_dX*instanceStruct.instanceVar_ibei)*modelStruct.modelPar_fgeo)-((instanceStruct.instanceVar_rbi*instanceStruct.instanceVar_ibei)*modelStruct.modelPar_fgeo)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
ETA = (((instanceStruct.instanceVar_rbi*instanceStruct.instanceVar_ibei)*modelStruct.modelPar_fgeo)/instanceStruct.instanceVar_VT);
if ((ETA<1.0e-6))
{
instanceStruct.d_instanceVar_rbi_dX = (instanceStruct.instanceVar_rbi*(-0.5*d_ETA_dX)+instanceStruct.d_instanceVar_rbi_dX*(1.0-(0.5*ETA)));
instanceStruct.instanceVar_rbi = (instanceStruct.instanceVar_rbi*(1.0-(0.5*ETA)));
}
else
{
{
double value_log_0 = log((1.0+ETA));
double  deriv_log_0_d0 = (1.0/(1.0+ETA));
instanceStruct.d_instanceVar_rbi_dX = ((ETA*(instanceStruct.instanceVar_rbi*deriv_log_0_d0*(d_ETA_dX)+instanceStruct.d_instanceVar_rbi_dX*value_log_0)-(instanceStruct.instanceVar_rbi*value_log_0)*d_ETA_dX)/ETA/ETA);
instanceStruct.instanceVar_rbi = ((instanceStruct.instanceVar_rbi*value_log_0)/ETA);
}
}
}
if ((Qf>0.0))
{
instanceStruct.d_instanceVar_rbi_dX = (((Qjei+Qf)*(instanceStruct.instanceVar_rbi*(d_Qjei_dX+(Qf*modelStruct.d_modelPar_fqi_dX+d_Qf_dX*modelStruct.modelPar_fqi))+instanceStruct.d_instanceVar_rbi_dX*(Qjei+(Qf*modelStruct.modelPar_fqi)))-(instanceStruct.instanceVar_rbi*(Qjei+(Qf*modelStruct.modelPar_fqi)))*(d_Qjei_dX+d_Qf_dX))/(Qjei+Qf)/(Qjei+Qf));
instanceStruct.instanceVar_rbi = ((instanceStruct.instanceVar_rbi*(Qjei+(Qf*modelStruct.modelPar_fqi)))/(Qjei+Qf));
}
}
// End block HICRBI
else
{
instanceStruct.d_instanceVar_rbi_dX = 0.0;
instanceStruct.instanceVar_rbi = 0.0;
}
d_DIOY_dX = (((modelStruct.modelPar_mbep*instanceStruct.instanceVar_VT)*d_Vbpei_dX-Vbpei*(modelStruct.modelPar_mbep*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mbep_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mbep*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mbep*instanceStruct.instanceVar_VT));
DIOY = (Vbpei/(modelStruct.modelPar_mbep*instanceStruct.instanceVar_VT));
if ((modelStruct.modelPar_ibeps>0.0))
{
if ((DIOY>80.0))
{
d_le_dX = d_DIOY_dX;
le = (1+(DIOY-80.0));
d_DIOY_dX = 0.0;
DIOY = 80.0;
}
else
{
d_le_dX = 0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));
d_le_dX = (le*deriv_limexp_0_d0*(d_DIOY_dX)+d_le_dX*value_limexp_0);
le = (le*value_limexp_0);
}
instanceStruct.d_instanceVar_ibep_dX = (instanceStruct.instanceVar_ibeps_t*d_le_dX+instanceStruct.d_instanceVar_ibeps_t_dX*(le-1.0));
instanceStruct.instanceVar_ibep = (instanceStruct.instanceVar_ibeps_t*(le-1.0));
if ((DIOY<=(-14.0)))
{
instanceStruct.d_instanceVar_ibep_dX = (-instanceStruct.d_instanceVar_ibeps_t_dX);
instanceStruct.instanceVar_ibep = (-instanceStruct.instanceVar_ibeps_t);
}
}
else
{
instanceStruct.d_instanceVar_ibep_dX = 0.0;
instanceStruct.instanceVar_ibep = 0.0;
}
d_DIOY_dX = (((modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT)*d_Vbpei_dX-Vbpei*(modelStruct.modelPar_mrep*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mrep_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT));
DIOY = (Vbpei/(modelStruct.modelPar_mrep*instanceStruct.instanceVar_VT));
if ((modelStruct.modelPar_ireps>0.0))
{
if ((DIOY>80.0))
{
d_le_dX = d_DIOY_dX;
le = (1+(DIOY-80.0));
d_DIOY_dX = 0.0;
DIOY = 80.0;
}
else
{
d_le_dX = 0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));
d_le_dX = (le*deriv_limexp_0_d0*(d_DIOY_dX)+d_le_dX*value_limexp_0);
le = (le*value_limexp_0);
}
d_irep_dX = (instanceStruct.instanceVar_ireps_t*d_le_dX+instanceStruct.d_instanceVar_ireps_t_dX*(le-1.0));
irep = (instanceStruct.instanceVar_ireps_t*(le-1.0));
if ((DIOY<=(-14.0)))
{
d_irep_dX = (-instanceStruct.d_instanceVar_ireps_t_dX);
irep = (-instanceStruct.instanceVar_ireps_t);
}
}
else
{
d_irep_dX = 0.0;
irep = 0.0;
}
if ((instanceStruct.instanceVar_cjep0_t>0.0))
{
{
double value_log_0 = log(instanceStruct.instanceVar_ajep_t);
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zep));
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_ajep_t);
double  deriv_exp_1_d0 = value_exp_1;
d_DFV_f_dX = (instanceStruct.instanceVar_vdep_t*(-deriv_exp_1_d0*(((modelStruct.modelPar_zep*(-deriv_log_0_d0*(instanceStruct.d_instanceVar_ajep_t_dX))-(-value_log_0)*modelStruct.d_modelPar_zep_dX)/modelStruct.modelPar_zep/modelStruct.modelPar_zep)))+instanceStruct.d_instanceVar_vdep_t_dX*(1.0-value_exp_1));
DFV_f = (instanceStruct.instanceVar_vdep_t*(1.0-value_exp_1));
}
d_DFv_e_dX = ((instanceStruct.instanceVar_VT*(d_DFV_f_dX-d_Vbpei_dX)-(DFV_f-Vbpei)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
DFv_e = ((DFV_f-Vbpei)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_DFs_q_dX = deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dX+d_DFv_e_dX*DFv_e));
DFs_q = value_sqrt_0;
}
d_DFs_q2_dX = (d_DFv_e_dX+d_DFs_q_dX)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);
d_DFv_j_dX = (d_DFV_f_dX-(instanceStruct.instanceVar_VT*d_DFs_q2_dX+instanceStruct.d_instanceVar_VT_dX*DFs_q2));
DFv_j = (DFV_f-(instanceStruct.instanceVar_VT*DFs_q2));
d_DFdvj_dv_dX = ((DFs_q*d_DFs_q2_dX-DFs_q2*d_DFs_q_dX)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/instanceStruct.instanceVar_vdep_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/instanceStruct.instanceVar_vdep_t)));
d_DFb_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdep_t*d_DFv_j_dX-DFv_j*instanceStruct.d_instanceVar_vdep_t_dX)/instanceStruct.instanceVar_vdep_t/instanceStruct.instanceVar_vdep_t)));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-modelStruct.modelPar_zep)*DFb));
double  deriv_exp_0_d0 = value_exp_0;
d_DFC_j1_dX = ((instanceStruct.instanceVar_cjep0_t*value_exp_0)*d_DFdvj_dv_dX+(instanceStruct.instanceVar_cjep0_t*deriv_exp_0_d0*(((-modelStruct.modelPar_zep)*d_DFb_dX+(-modelStruct.d_modelPar_zep_dX)*DFb))+instanceStruct.d_instanceVar_cjep0_t_dX*value_exp_0)*DFdvj_dv);
DFC_j1 = ((instanceStruct.instanceVar_cjep0_t*value_exp_0)*DFdvj_dv);
}
d_Cjep_dX = (d_DFC_j1_dX+((instanceStruct.instanceVar_ajep_t*instanceStruct.instanceVar_cjep0_t)*(-d_DFdvj_dv_dX)+(instanceStruct.instanceVar_ajep_t*instanceStruct.d_instanceVar_cjep0_t_dX+instanceStruct.d_instanceVar_ajep_t_dX*instanceStruct.instanceVar_cjep0_t)*(1.0-DFdvj_dv)));
Cjep = (DFC_j1+((instanceStruct.instanceVar_ajep_t*instanceStruct.instanceVar_cjep0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-modelStruct.modelPar_zep)));
double  deriv_exp_0_d0 = value_exp_0;
d_DFQ_j_dX = (((1.0-modelStruct.modelPar_zep)*((instanceStruct.instanceVar_cjep0_t*instanceStruct.instanceVar_vdep_t)*(-deriv_exp_0_d0*((DFb*(-modelStruct.d_modelPar_zep_dX)+d_DFb_dX*(1.0-modelStruct.modelPar_zep))))+(instanceStruct.instanceVar_cjep0_t*instanceStruct.d_instanceVar_vdep_t_dX+instanceStruct.d_instanceVar_cjep0_t_dX*instanceStruct.instanceVar_vdep_t)*(1.0-value_exp_0))-((instanceStruct.instanceVar_cjep0_t*instanceStruct.instanceVar_vdep_t)*(1.0-value_exp_0))*(-modelStruct.d_modelPar_zep_dX))/(1.0-modelStruct.modelPar_zep)/(1.0-modelStruct.modelPar_zep));
DFQ_j = (((instanceStruct.instanceVar_cjep0_t*instanceStruct.instanceVar_vdep_t)*(1.0-value_exp_0))/(1.0-modelStruct.modelPar_zep));
}
d_Qjep_dX = (d_DFQ_j_dX+((instanceStruct.instanceVar_ajep_t*instanceStruct.instanceVar_cjep0_t)*(d_Vbpei_dX-d_DFv_j_dX)+(instanceStruct.instanceVar_ajep_t*instanceStruct.d_instanceVar_cjep0_t_dX+instanceStruct.d_instanceVar_ajep_t_dX*instanceStruct.instanceVar_cjep0_t)*(Vbpei-DFv_j)));
Qjep = (DFQ_j+((instanceStruct.instanceVar_ajep_t*instanceStruct.instanceVar_cjep0_t)*(Vbpei-DFv_j)));
}
else
{
d_Cjep_dX = 0.0;
Cjep = 0.0;
d_Qjep_dX = 0.0;
Qjep = 0.0;
}
if (((modelStruct.modelPar_ibets>0)&&((Vbpei<0.0)||(Vbiei<0.0))))
//Begin block HICTUN
{
//Block-local variables for block HICTUN
double pocce=0.0;
double d_pocce_dX=0.0;
double czz=0.0;
double d_czz_dX=0.0;
//End of Block-local variables
if ((((modelStruct.modelPar_tunode==1)&&(instanceStruct.instanceVar_cjep0_t>0.0))&&(instanceStruct.instanceVar_vdep_t>0.0)))
{
{
double value_log_0 = log((Cjep/instanceStruct.instanceVar_cjep0_t));
double value_exp_1 = exp(((1-(1/modelStruct.modelPar_zep))*value_log_0));
double  deriv_log_0_d0 = (1.0/(Cjep/instanceStruct.instanceVar_cjep0_t));
double  deriv_exp_1_d0 = value_exp_1;
d_pocce_dX = deriv_exp_1_d0*(((1-(1/modelStruct.modelPar_zep))*deriv_log_0_d0*(((instanceStruct.instanceVar_cjep0_t*d_Cjep_dX-Cjep*instanceStruct.d_instanceVar_cjep0_t_dX)/instanceStruct.instanceVar_cjep0_t/instanceStruct.instanceVar_cjep0_t))+(-(-1*modelStruct.d_modelPar_zep_dX/modelStruct.modelPar_zep/modelStruct.modelPar_zep))*value_log_0));
pocce = value_exp_1;
}
d_czz_dX = (((-(Vbpei/instanceStruct.instanceVar_vdep_t))*instanceStruct.instanceVar_ibets_t)*d_pocce_dX+((-(Vbpei/instanceStruct.instanceVar_vdep_t))*instanceStruct.d_instanceVar_ibets_t_dX+(-((instanceStruct.instanceVar_vdep_t*d_Vbpei_dX-Vbpei*instanceStruct.d_instanceVar_vdep_t_dX)/instanceStruct.instanceVar_vdep_t/instanceStruct.instanceVar_vdep_t))*instanceStruct.instanceVar_ibets_t)*pocce);
czz = (((-(Vbpei/instanceStruct.instanceVar_vdep_t))*instanceStruct.instanceVar_ibets_t)*pocce);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_abet_t)/pocce));
double  deriv_exp_0_d0 = value_exp_0;
d_ibet_dX = (czz*deriv_exp_0_d0*(((pocce*(-instanceStruct.d_instanceVar_abet_t_dX)-(-instanceStruct.instanceVar_abet_t)*d_pocce_dX)/pocce/pocce))+d_czz_dX*value_exp_0);
ibet = (czz*value_exp_0);
}
}
else
{
if ((((modelStruct.modelPar_tunode==0)&&(instanceStruct.instanceVar_cjei0_t>0.0))&&(instanceStruct.instanceVar_vdei_t>0.0)))
{
{
double value_log_0 = log((Cjei/instanceStruct.instanceVar_cjei0_t));
double value_exp_1 = exp(((1-(1/modelStruct.modelPar_zei))*value_log_0));
double  deriv_log_0_d0 = (1.0/(Cjei/instanceStruct.instanceVar_cjei0_t));
double  deriv_exp_1_d0 = value_exp_1;
d_pocce_dX = deriv_exp_1_d0*(((1-(1/modelStruct.modelPar_zei))*deriv_log_0_d0*(((instanceStruct.instanceVar_cjei0_t*d_Cjei_dX-Cjei*instanceStruct.d_instanceVar_cjei0_t_dX)/instanceStruct.instanceVar_cjei0_t/instanceStruct.instanceVar_cjei0_t))+(-(-1*modelStruct.d_modelPar_zei_dX/modelStruct.modelPar_zei/modelStruct.modelPar_zei))*value_log_0));
pocce = value_exp_1;
}
d_czz_dX = (((-(Vbiei/instanceStruct.instanceVar_vdei_t))*instanceStruct.instanceVar_ibets_t)*d_pocce_dX+((-(Vbiei/instanceStruct.instanceVar_vdei_t))*instanceStruct.d_instanceVar_ibets_t_dX+(-((instanceStruct.instanceVar_vdei_t*d_Vbiei_dX-Vbiei*instanceStruct.d_instanceVar_vdei_t_dX)/instanceStruct.instanceVar_vdei_t/instanceStruct.instanceVar_vdei_t))*instanceStruct.instanceVar_ibets_t)*pocce);
czz = (((-(Vbiei/instanceStruct.instanceVar_vdei_t))*instanceStruct.instanceVar_ibets_t)*pocce);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_abet_t)/pocce));
double  deriv_exp_0_d0 = value_exp_0;
d_ibet_dX = (czz*deriv_exp_0_d0*(((pocce*(-instanceStruct.d_instanceVar_abet_t_dX)-(-instanceStruct.instanceVar_abet_t)*d_pocce_dX)/pocce/pocce))+d_czz_dX*value_exp_0);
ibet = (czz*value_exp_0);
}
}
else
{
d_ibet_dX = 0.0;
ibet = 0.0;
}
}
}
// End block HICTUN
else
{
d_ibet_dX = 0.0;
ibet = 0.0;
}
if ((instanceStruct.instanceVar_vptcx_t<1.0e2))
{
if ((instanceStruct.instanceVar_cjcx02_t>0.0))
{
d_Dz_r_dX = (modelStruct.d_modelPar_zcx_dX/4.0);
Dz_r = (modelStruct.modelPar_zcx/4.0);
d_Dv_p_dX = (instanceStruct.d_instanceVar_vptcx_t_dX-instanceStruct.d_instanceVar_vdcx_t_dX);
Dv_p = (instanceStruct.instanceVar_vptcx_t-instanceStruct.instanceVar_vdcx_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zcx));
double  deriv_exp_1_d0 = value_exp_1;
d_DV_f_dX = (instanceStruct.instanceVar_vdcx_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zcx_dX/modelStruct.modelPar_zcx/modelStruct.modelPar_zcx)))+instanceStruct.d_instanceVar_vdcx_t_dX*(1.0-value_exp_1));
DV_f = (instanceStruct.instanceVar_vdcx_t*(1.0-value_exp_1));
}
d_DC_max_dX = 2.4*instanceStruct.d_instanceVar_cjcx02_t_dX;
DC_max = (2.4*instanceStruct.instanceVar_cjcx02_t);
{
double value_log_0 = log((instanceStruct.instanceVar_vptcx_t/instanceStruct.instanceVar_vdcx_t));
double value_exp_1 = exp(((Dz_r-modelStruct.modelPar_zcx)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_vptcx_t/instanceStruct.instanceVar_vdcx_t));
double  deriv_exp_1_d0 = value_exp_1;
d_DC_c_dX = (instanceStruct.instanceVar_cjcx02_t*deriv_exp_1_d0*(((Dz_r-modelStruct.modelPar_zcx)*deriv_log_0_d0*(((instanceStruct.instanceVar_vdcx_t*instanceStruct.d_instanceVar_vptcx_t_dX-instanceStruct.instanceVar_vptcx_t*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t))+(d_Dz_r_dX-modelStruct.d_modelPar_zcx_dX)*value_log_0))+instanceStruct.d_instanceVar_cjcx02_t_dX*value_exp_1);
DC_c = (instanceStruct.instanceVar_cjcx02_t*value_exp_1);
}
d_Dv_e_dX = ((instanceStruct.instanceVar_VT*(d_DV_f_dX-d_Vbpci_dX)-(DV_f-Vbpci)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
Dv_e = ((DV_f-Vbpci)/instanceStruct.instanceVar_VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_e_dX);
De = value_exp_0;
}
d_De_1_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));
d_Dv_j1_dX = (d_DV_f_dX-(instanceStruct.instanceVar_VT*deriv_log_0_d0*(d_De_dX)+instanceStruct.d_instanceVar_VT_dX*value_log_0));
Dv_j1 = (DV_f-(instanceStruct.instanceVar_VT*value_log_0));
}
}
else
{
d_De_1_dX = 0.0;
De_1 = 1.0;
d_Dv_j1_dX = d_Vbpci_dX;
Dv_j1 = Vbpci;
}
d_Da_dX = (0.1*d_Dv_p_dX+4.0*instanceStruct.d_instanceVar_VT_dX);
Da = ((0.1*Dv_p)+(4.0*instanceStruct.instanceVar_VT));
d_Dv_r_dX = ((Da*(d_Dv_p_dX+d_Dv_j1_dX)-(Dv_p+Dv_j1)*d_Da_dX)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_r_dX);
De = value_exp_0;
}
d_De_2_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;
d_Dv_j2_dX = ((-d_Dv_p_dX)+(Da*(deriv_log_0_d0*(d_De_dX)-deriv_exp_1_d0*(((Da*(-(d_Dv_p_dX+d_DV_f_dX))-(-(Dv_p+DV_f))*d_Da_dX)/Da/Da)))+d_Da_dX*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{
d_De_2_dX = 0.0;
De_2 = 1.0;
d_Dv_j2_dX = d_Dv_j1_dX;
Dv_j2 = Dv_j1;
}
d_Dv_j4_dX = (d_Vbpci_dX-d_Dv_j1_dX);
Dv_j4 = (Vbpci-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/instanceStruct.instanceVar_vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/instanceStruct.instanceVar_vdcx_t)));
d_DCln1_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdcx_t*d_Dv_j1_dX-Dv_j1*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t)));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/instanceStruct.instanceVar_vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/instanceStruct.instanceVar_vdcx_t)));
d_DCln2_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdcx_t*d_Dv_j2_dX-Dv_j2*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t)));
DCln2 = value_log_0;
}
d_Dz1_dX = (-modelStruct.d_modelPar_zcx_dX);
Dz1 = (1.0-modelStruct.modelPar_zcx);
d_Dzr1_dX = (-d_Dz_r_dX);
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-modelStruct.modelPar_zcx)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j1_dX = (((instanceStruct.instanceVar_cjcx02_t*value_exp_0)*De_1)*d_De_2_dX+((instanceStruct.instanceVar_cjcx02_t*value_exp_0)*d_De_1_dX+(instanceStruct.instanceVar_cjcx02_t*deriv_exp_0_d0*((DCln2*(-modelStruct.d_modelPar_zcx_dX)+d_DCln2_dX*(-modelStruct.modelPar_zcx)))+instanceStruct.d_instanceVar_cjcx02_t_dX*value_exp_0)*De_1)*De_2);
DC_j1 = (((instanceStruct.instanceVar_cjcx02_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j2_dX = ((DC_c*value_exp_0)*(-d_De_2_dX)+(DC_c*deriv_exp_0_d0*((DCln1*(-d_Dz_r_dX)+d_DCln1_dX*(-Dz_r)))+d_DC_c_dX*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}
d_DC_j3_dX = (DC_max*(-d_De_1_dX)+d_DC_max_dX*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
d_CjCx_ii_dX = ((d_DC_j1_dX+d_DC_j2_dX)+d_DC_j3_dX);
CjCx_ii = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j1_dX = ((Dz1*(instanceStruct.instanceVar_cjcx02_t*(-deriv_exp_0_d0*((DCln2*d_Dz1_dX+d_DCln2_dX*Dz1)))+instanceStruct.d_instanceVar_cjcx02_t_dX*(1.0-value_exp_0))-(instanceStruct.instanceVar_cjcx02_t*(1.0-value_exp_0))*d_Dz1_dX)/Dz1/Dz1);
DQ_j1 = ((instanceStruct.instanceVar_cjcx02_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j2_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln1*d_Dzr1_dX+d_DCln1_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j3_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln2*d_Dzr1_dX+d_DCln2_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
d_qjcx0_t_ii_dX = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.d_instanceVar_vdcx_t_dX+((d_DQ_j1_dX+d_DQ_j2_dX)-d_DQ_j3_dX)*instanceStruct.instanceVar_vdcx_t)+(DC_max*d_Dv_j4_dX+d_DC_max_dX*Dv_j4));
qjcx0_t_ii = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.instanceVar_vdcx_t)+(DC_max*Dv_j4));
}
else
{
d_CjCx_ii_dX = 0.0;
CjCx_ii = 0.0;
d_qjcx0_t_ii_dX = 0.0;
qjcx0_t_ii = 0.0;
}
}
else
{
if ((instanceStruct.instanceVar_cjcx02_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zcx));
double  deriv_exp_1_d0 = value_exp_1;
d_DFV_f_dX = (instanceStruct.instanceVar_vdcx_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zcx_dX/modelStruct.modelPar_zcx/modelStruct.modelPar_zcx)))+instanceStruct.d_instanceVar_vdcx_t_dX*(1.0-value_exp_1));
DFV_f = (instanceStruct.instanceVar_vdcx_t*(1.0-value_exp_1));
}
d_DFv_e_dX = ((instanceStruct.instanceVar_VT*(d_DFV_f_dX-d_Vbpci_dX)-(DFV_f-Vbpci)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
DFv_e = ((DFV_f-Vbpci)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_DFs_q_dX = deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dX+d_DFv_e_dX*DFv_e));
DFs_q = value_sqrt_0;
}
d_DFs_q2_dX = (d_DFv_e_dX+d_DFs_q_dX)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);
d_DFv_j_dX = (d_DFV_f_dX-(instanceStruct.instanceVar_VT*d_DFs_q2_dX+instanceStruct.d_instanceVar_VT_dX*DFs_q2));
DFv_j = (DFV_f-(instanceStruct.instanceVar_VT*DFs_q2));
d_DFdvj_dv_dX = ((DFs_q*d_DFs_q2_dX-DFs_q2*d_DFs_q_dX)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/instanceStruct.instanceVar_vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/instanceStruct.instanceVar_vdcx_t)));
d_DFb_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdcx_t*d_DFv_j_dX-DFv_j*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t)));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-modelStruct.modelPar_zcx)*DFb));
double  deriv_exp_0_d0 = value_exp_0;
d_DFC_j1_dX = ((instanceStruct.instanceVar_cjcx02_t*value_exp_0)*d_DFdvj_dv_dX+(instanceStruct.instanceVar_cjcx02_t*deriv_exp_0_d0*(((-modelStruct.modelPar_zcx)*d_DFb_dX+(-modelStruct.d_modelPar_zcx_dX)*DFb))+instanceStruct.d_instanceVar_cjcx02_t_dX*value_exp_0)*DFdvj_dv);
DFC_j1 = ((instanceStruct.instanceVar_cjcx02_t*value_exp_0)*DFdvj_dv);
}
d_CjCx_ii_dX = (d_DFC_j1_dX+((2.4*instanceStruct.instanceVar_cjcx02_t)*(-d_DFdvj_dv_dX)+2.4*instanceStruct.d_instanceVar_cjcx02_t_dX*(1.0-DFdvj_dv)));
CjCx_ii = (DFC_j1+((2.4*instanceStruct.instanceVar_cjcx02_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-modelStruct.modelPar_zcx)));
double  deriv_exp_0_d0 = value_exp_0;
d_DFQ_j_dX = (((1.0-modelStruct.modelPar_zcx)*((instanceStruct.instanceVar_cjcx02_t*instanceStruct.instanceVar_vdcx_t)*(-deriv_exp_0_d0*((DFb*(-modelStruct.d_modelPar_zcx_dX)+d_DFb_dX*(1.0-modelStruct.modelPar_zcx))))+(instanceStruct.instanceVar_cjcx02_t*instanceStruct.d_instanceVar_vdcx_t_dX+instanceStruct.d_instanceVar_cjcx02_t_dX*instanceStruct.instanceVar_vdcx_t)*(1.0-value_exp_0))-((instanceStruct.instanceVar_cjcx02_t*instanceStruct.instanceVar_vdcx_t)*(1.0-value_exp_0))*(-modelStruct.d_modelPar_zcx_dX))/(1.0-modelStruct.modelPar_zcx)/(1.0-modelStruct.modelPar_zcx));
DFQ_j = (((instanceStruct.instanceVar_cjcx02_t*instanceStruct.instanceVar_vdcx_t)*(1.0-value_exp_0))/(1.0-modelStruct.modelPar_zcx));
}
d_qjcx0_t_ii_dX = (d_DFQ_j_dX+((2.4*instanceStruct.instanceVar_cjcx02_t)*(d_Vbpci_dX-d_DFv_j_dX)+2.4*instanceStruct.d_instanceVar_cjcx02_t_dX*(Vbpci-DFv_j)));
qjcx0_t_ii = (DFQ_j+((2.4*instanceStruct.instanceVar_cjcx02_t)*(Vbpci-DFv_j)));
}
else
{
d_CjCx_ii_dX = 0.0;
CjCx_ii = 0.0;
d_qjcx0_t_ii_dX = 0.0;
qjcx0_t_ii = 0.0;
}
}
d_DIOY_dX = (((modelStruct.modelPar_mbcx*instanceStruct.instanceVar_VT)*d_Vbpci_dX-Vbpci*(modelStruct.modelPar_mbcx*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_mbcx_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_mbcx*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_mbcx*instanceStruct.instanceVar_VT));
DIOY = (Vbpci/(modelStruct.modelPar_mbcx*instanceStruct.instanceVar_VT));
if ((modelStruct.modelPar_ibcxs>0.0))
{
if ((DIOY>80.0))
{
d_le_dX = d_DIOY_dX;
le = (1+(DIOY-80.0));
d_DIOY_dX = 0.0;
DIOY = 80.0;
}
else
{
d_le_dX = 0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));
d_le_dX = (le*deriv_limexp_0_d0*(d_DIOY_dX)+d_le_dX*value_limexp_0);
le = (le*value_limexp_0);
}
instanceStruct.d_instanceVar_ijbcx_dX = (instanceStruct.instanceVar_ibcxs_t*d_le_dX+instanceStruct.d_instanceVar_ibcxs_t_dX*(le-1.0));
instanceStruct.instanceVar_ijbcx = (instanceStruct.instanceVar_ibcxs_t*(le-1.0));
if ((DIOY<=(-14.0)))
{
instanceStruct.d_instanceVar_ijbcx_dX = (-instanceStruct.d_instanceVar_ibcxs_t_dX);
instanceStruct.instanceVar_ijbcx = (-instanceStruct.instanceVar_ibcxs_t);
}
}
else
{
instanceStruct.d_instanceVar_ijbcx_dX = 0.0;
instanceStruct.instanceVar_ijbcx = 0.0;
}
if ((instanceStruct.instanceVar_vptcx_t<1.0e2))
{
if ((instanceStruct.instanceVar_cjcx01_t>0.0))
{
d_Dz_r_dX = (modelStruct.d_modelPar_zcx_dX/4.0);
Dz_r = (modelStruct.modelPar_zcx/4.0);
d_Dv_p_dX = (instanceStruct.d_instanceVar_vptcx_t_dX-instanceStruct.d_instanceVar_vdcx_t_dX);
Dv_p = (instanceStruct.instanceVar_vptcx_t-instanceStruct.instanceVar_vdcx_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zcx));
double  deriv_exp_1_d0 = value_exp_1;
d_DV_f_dX = (instanceStruct.instanceVar_vdcx_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zcx_dX/modelStruct.modelPar_zcx/modelStruct.modelPar_zcx)))+instanceStruct.d_instanceVar_vdcx_t_dX*(1.0-value_exp_1));
DV_f = (instanceStruct.instanceVar_vdcx_t*(1.0-value_exp_1));
}
d_DC_max_dX = 2.4*instanceStruct.d_instanceVar_cjcx01_t_dX;
DC_max = (2.4*instanceStruct.instanceVar_cjcx01_t);
{
double value_log_0 = log((instanceStruct.instanceVar_vptcx_t/instanceStruct.instanceVar_vdcx_t));
double value_exp_1 = exp(((Dz_r-modelStruct.modelPar_zcx)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_vptcx_t/instanceStruct.instanceVar_vdcx_t));
double  deriv_exp_1_d0 = value_exp_1;
d_DC_c_dX = (instanceStruct.instanceVar_cjcx01_t*deriv_exp_1_d0*(((Dz_r-modelStruct.modelPar_zcx)*deriv_log_0_d0*(((instanceStruct.instanceVar_vdcx_t*instanceStruct.d_instanceVar_vptcx_t_dX-instanceStruct.instanceVar_vptcx_t*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t))+(d_Dz_r_dX-modelStruct.d_modelPar_zcx_dX)*value_log_0))+instanceStruct.d_instanceVar_cjcx01_t_dX*value_exp_1);
DC_c = (instanceStruct.instanceVar_cjcx01_t*value_exp_1);
}
d_Dv_e_dX = ((instanceStruct.instanceVar_VT*(d_DV_f_dX-d_Vbci_dX)-(DV_f-Vbci)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
Dv_e = ((DV_f-Vbci)/instanceStruct.instanceVar_VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_e_dX);
De = value_exp_0;
}
d_De_1_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));
d_Dv_j1_dX = (d_DV_f_dX-(instanceStruct.instanceVar_VT*deriv_log_0_d0*(d_De_dX)+instanceStruct.d_instanceVar_VT_dX*value_log_0));
Dv_j1 = (DV_f-(instanceStruct.instanceVar_VT*value_log_0));
}
}
else
{
d_De_1_dX = 0.0;
De_1 = 1.0;
d_Dv_j1_dX = d_Vbci_dX;
Dv_j1 = Vbci;
}
d_Da_dX = (0.1*d_Dv_p_dX+4.0*instanceStruct.d_instanceVar_VT_dX);
Da = ((0.1*Dv_p)+(4.0*instanceStruct.instanceVar_VT));
d_Dv_r_dX = ((Da*(d_Dv_p_dX+d_Dv_j1_dX)-(Dv_p+Dv_j1)*d_Da_dX)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_r_dX);
De = value_exp_0;
}
d_De_2_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;
d_Dv_j2_dX = ((-d_Dv_p_dX)+(Da*(deriv_log_0_d0*(d_De_dX)-deriv_exp_1_d0*(((Da*(-(d_Dv_p_dX+d_DV_f_dX))-(-(Dv_p+DV_f))*d_Da_dX)/Da/Da)))+d_Da_dX*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{
d_De_2_dX = 0.0;
De_2 = 1.0;
d_Dv_j2_dX = d_Dv_j1_dX;
Dv_j2 = Dv_j1;
}
d_Dv_j4_dX = (d_Vbci_dX-d_Dv_j1_dX);
Dv_j4 = (Vbci-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/instanceStruct.instanceVar_vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/instanceStruct.instanceVar_vdcx_t)));
d_DCln1_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdcx_t*d_Dv_j1_dX-Dv_j1*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t)));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/instanceStruct.instanceVar_vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/instanceStruct.instanceVar_vdcx_t)));
d_DCln2_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdcx_t*d_Dv_j2_dX-Dv_j2*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t)));
DCln2 = value_log_0;
}
d_Dz1_dX = (-modelStruct.d_modelPar_zcx_dX);
Dz1 = (1.0-modelStruct.modelPar_zcx);
d_Dzr1_dX = (-d_Dz_r_dX);
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-modelStruct.modelPar_zcx)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j1_dX = (((instanceStruct.instanceVar_cjcx01_t*value_exp_0)*De_1)*d_De_2_dX+((instanceStruct.instanceVar_cjcx01_t*value_exp_0)*d_De_1_dX+(instanceStruct.instanceVar_cjcx01_t*deriv_exp_0_d0*((DCln2*(-modelStruct.d_modelPar_zcx_dX)+d_DCln2_dX*(-modelStruct.modelPar_zcx)))+instanceStruct.d_instanceVar_cjcx01_t_dX*value_exp_0)*De_1)*De_2);
DC_j1 = (((instanceStruct.instanceVar_cjcx01_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j2_dX = ((DC_c*value_exp_0)*(-d_De_2_dX)+(DC_c*deriv_exp_0_d0*((DCln1*(-d_Dz_r_dX)+d_DCln1_dX*(-Dz_r)))+d_DC_c_dX*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}
d_DC_j3_dX = (DC_max*(-d_De_1_dX)+d_DC_max_dX*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
d_CjCx_i_dX = ((d_DC_j1_dX+d_DC_j2_dX)+d_DC_j3_dX);
CjCx_i = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j1_dX = ((Dz1*(instanceStruct.instanceVar_cjcx01_t*(-deriv_exp_0_d0*((DCln2*d_Dz1_dX+d_DCln2_dX*Dz1)))+instanceStruct.d_instanceVar_cjcx01_t_dX*(1.0-value_exp_0))-(instanceStruct.instanceVar_cjcx01_t*(1.0-value_exp_0))*d_Dz1_dX)/Dz1/Dz1);
DQ_j1 = ((instanceStruct.instanceVar_cjcx01_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j2_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln1*d_Dzr1_dX+d_DCln1_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j3_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln2*d_Dzr1_dX+d_DCln2_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
d_qjcx0_t_i_dX = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.d_instanceVar_vdcx_t_dX+((d_DQ_j1_dX+d_DQ_j2_dX)-d_DQ_j3_dX)*instanceStruct.instanceVar_vdcx_t)+(DC_max*d_Dv_j4_dX+d_DC_max_dX*Dv_j4));
qjcx0_t_i = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.instanceVar_vdcx_t)+(DC_max*Dv_j4));
}
else
{
d_CjCx_i_dX = 0.0;
CjCx_i = 0.0;
d_qjcx0_t_i_dX = 0.0;
qjcx0_t_i = 0.0;
}
}
else
{
if ((instanceStruct.instanceVar_cjcx01_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zcx));
double  deriv_exp_1_d0 = value_exp_1;
d_DFV_f_dX = (instanceStruct.instanceVar_vdcx_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zcx_dX/modelStruct.modelPar_zcx/modelStruct.modelPar_zcx)))+instanceStruct.d_instanceVar_vdcx_t_dX*(1.0-value_exp_1));
DFV_f = (instanceStruct.instanceVar_vdcx_t*(1.0-value_exp_1));
}
d_DFv_e_dX = ((instanceStruct.instanceVar_VT*(d_DFV_f_dX-d_Vbci_dX)-(DFV_f-Vbci)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
DFv_e = ((DFV_f-Vbci)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_DFs_q_dX = deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dX+d_DFv_e_dX*DFv_e));
DFs_q = value_sqrt_0;
}
d_DFs_q2_dX = (d_DFv_e_dX+d_DFs_q_dX)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);
d_DFv_j_dX = (d_DFV_f_dX-(instanceStruct.instanceVar_VT*d_DFs_q2_dX+instanceStruct.d_instanceVar_VT_dX*DFs_q2));
DFv_j = (DFV_f-(instanceStruct.instanceVar_VT*DFs_q2));
d_DFdvj_dv_dX = ((DFs_q*d_DFs_q2_dX-DFs_q2*d_DFs_q_dX)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/instanceStruct.instanceVar_vdcx_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/instanceStruct.instanceVar_vdcx_t)));
d_DFb_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdcx_t*d_DFv_j_dX-DFv_j*instanceStruct.d_instanceVar_vdcx_t_dX)/instanceStruct.instanceVar_vdcx_t/instanceStruct.instanceVar_vdcx_t)));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-modelStruct.modelPar_zcx)*DFb));
double  deriv_exp_0_d0 = value_exp_0;
d_DFC_j1_dX = ((instanceStruct.instanceVar_cjcx01_t*value_exp_0)*d_DFdvj_dv_dX+(instanceStruct.instanceVar_cjcx01_t*deriv_exp_0_d0*(((-modelStruct.modelPar_zcx)*d_DFb_dX+(-modelStruct.d_modelPar_zcx_dX)*DFb))+instanceStruct.d_instanceVar_cjcx01_t_dX*value_exp_0)*DFdvj_dv);
DFC_j1 = ((instanceStruct.instanceVar_cjcx01_t*value_exp_0)*DFdvj_dv);
}
d_CjCx_i_dX = (d_DFC_j1_dX+((2.4*instanceStruct.instanceVar_cjcx01_t)*(-d_DFdvj_dv_dX)+2.4*instanceStruct.d_instanceVar_cjcx01_t_dX*(1.0-DFdvj_dv)));
CjCx_i = (DFC_j1+((2.4*instanceStruct.instanceVar_cjcx01_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-modelStruct.modelPar_zcx)));
double  deriv_exp_0_d0 = value_exp_0;
d_DFQ_j_dX = (((1.0-modelStruct.modelPar_zcx)*((instanceStruct.instanceVar_cjcx01_t*instanceStruct.instanceVar_vdcx_t)*(-deriv_exp_0_d0*((DFb*(-modelStruct.d_modelPar_zcx_dX)+d_DFb_dX*(1.0-modelStruct.modelPar_zcx))))+(instanceStruct.instanceVar_cjcx01_t*instanceStruct.d_instanceVar_vdcx_t_dX+instanceStruct.d_instanceVar_cjcx01_t_dX*instanceStruct.instanceVar_vdcx_t)*(1.0-value_exp_0))-((instanceStruct.instanceVar_cjcx01_t*instanceStruct.instanceVar_vdcx_t)*(1.0-value_exp_0))*(-modelStruct.d_modelPar_zcx_dX))/(1.0-modelStruct.modelPar_zcx)/(1.0-modelStruct.modelPar_zcx));
DFQ_j = (((instanceStruct.instanceVar_cjcx01_t*instanceStruct.instanceVar_vdcx_t)*(1.0-value_exp_0))/(1.0-modelStruct.modelPar_zcx));
}
d_qjcx0_t_i_dX = (d_DFQ_j_dX+((2.4*instanceStruct.instanceVar_cjcx01_t)*(d_Vbci_dX-d_DFv_j_dX)+2.4*instanceStruct.d_instanceVar_cjcx01_t_dX*(Vbci-DFv_j)));
qjcx0_t_i = (DFQ_j+((2.4*instanceStruct.instanceVar_cjcx01_t)*(Vbci-DFv_j)));
}
else
{
d_CjCx_i_dX = 0.0;
CjCx_i = 0.0;
d_qjcx0_t_i_dX = 0.0;
qjcx0_t_i = 0.0;
}
}
if ((instanceStruct.instanceVar_vpts_t<1.0e2))
{
if ((instanceStruct.instanceVar_cjs0_t>0.0))
{
d_Dz_r_dX = (modelStruct.d_modelPar_zs_dX/4.0);
Dz_r = (modelStruct.modelPar_zs/4.0);
d_Dv_p_dX = (instanceStruct.d_instanceVar_vpts_t_dX-instanceStruct.d_instanceVar_vds_t_dX);
Dv_p = (instanceStruct.instanceVar_vpts_t-instanceStruct.instanceVar_vds_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zs));
double  deriv_exp_1_d0 = value_exp_1;
d_DV_f_dX = (instanceStruct.instanceVar_vds_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zs_dX/modelStruct.modelPar_zs/modelStruct.modelPar_zs)))+instanceStruct.d_instanceVar_vds_t_dX*(1.0-value_exp_1));
DV_f = (instanceStruct.instanceVar_vds_t*(1.0-value_exp_1));
}
d_DC_max_dX = 2.4*instanceStruct.d_instanceVar_cjs0_t_dX;
DC_max = (2.4*instanceStruct.instanceVar_cjs0_t);
{
double value_log_0 = log((instanceStruct.instanceVar_vpts_t/instanceStruct.instanceVar_vds_t));
double value_exp_1 = exp(((Dz_r-modelStruct.modelPar_zs)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_vpts_t/instanceStruct.instanceVar_vds_t));
double  deriv_exp_1_d0 = value_exp_1;
d_DC_c_dX = (instanceStruct.instanceVar_cjs0_t*deriv_exp_1_d0*(((Dz_r-modelStruct.modelPar_zs)*deriv_log_0_d0*(((instanceStruct.instanceVar_vds_t*instanceStruct.d_instanceVar_vpts_t_dX-instanceStruct.instanceVar_vpts_t*instanceStruct.d_instanceVar_vds_t_dX)/instanceStruct.instanceVar_vds_t/instanceStruct.instanceVar_vds_t))+(d_Dz_r_dX-modelStruct.d_modelPar_zs_dX)*value_log_0))+instanceStruct.d_instanceVar_cjs0_t_dX*value_exp_1);
DC_c = (instanceStruct.instanceVar_cjs0_t*value_exp_1);
}
d_Dv_e_dX = ((instanceStruct.instanceVar_VT*(d_DV_f_dX-d_Vsici_dX)-(DV_f-Vsici)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
Dv_e = ((DV_f-Vsici)/instanceStruct.instanceVar_VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_e_dX);
De = value_exp_0;
}
d_De_1_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));
d_Dv_j1_dX = (d_DV_f_dX-(instanceStruct.instanceVar_VT*deriv_log_0_d0*(d_De_dX)+instanceStruct.d_instanceVar_VT_dX*value_log_0));
Dv_j1 = (DV_f-(instanceStruct.instanceVar_VT*value_log_0));
}
}
else
{
d_De_1_dX = 0.0;
De_1 = 1.0;
d_Dv_j1_dX = d_Vsici_dX;
Dv_j1 = Vsici;
}
d_Da_dX = (0.1*d_Dv_p_dX+4.0*instanceStruct.d_instanceVar_VT_dX);
Da = ((0.1*Dv_p)+(4.0*instanceStruct.instanceVar_VT));
d_Dv_r_dX = ((Da*(d_Dv_p_dX+d_Dv_j1_dX)-(Dv_p+Dv_j1)*d_Da_dX)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_r_dX);
De = value_exp_0;
}
d_De_2_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;
d_Dv_j2_dX = ((-d_Dv_p_dX)+(Da*(deriv_log_0_d0*(d_De_dX)-deriv_exp_1_d0*(((Da*(-(d_Dv_p_dX+d_DV_f_dX))-(-(Dv_p+DV_f))*d_Da_dX)/Da/Da)))+d_Da_dX*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{
d_De_2_dX = 0.0;
De_2 = 1.0;
d_Dv_j2_dX = d_Dv_j1_dX;
Dv_j2 = Dv_j1;
}
d_Dv_j4_dX = (d_Vsici_dX-d_Dv_j1_dX);
Dv_j4 = (Vsici-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/instanceStruct.instanceVar_vds_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/instanceStruct.instanceVar_vds_t)));
d_DCln1_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vds_t*d_Dv_j1_dX-Dv_j1*instanceStruct.d_instanceVar_vds_t_dX)/instanceStruct.instanceVar_vds_t/instanceStruct.instanceVar_vds_t)));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/instanceStruct.instanceVar_vds_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/instanceStruct.instanceVar_vds_t)));
d_DCln2_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vds_t*d_Dv_j2_dX-Dv_j2*instanceStruct.d_instanceVar_vds_t_dX)/instanceStruct.instanceVar_vds_t/instanceStruct.instanceVar_vds_t)));
DCln2 = value_log_0;
}
d_Dz1_dX = (-modelStruct.d_modelPar_zs_dX);
Dz1 = (1.0-modelStruct.modelPar_zs);
d_Dzr1_dX = (-d_Dz_r_dX);
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-modelStruct.modelPar_zs)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j1_dX = (((instanceStruct.instanceVar_cjs0_t*value_exp_0)*De_1)*d_De_2_dX+((instanceStruct.instanceVar_cjs0_t*value_exp_0)*d_De_1_dX+(instanceStruct.instanceVar_cjs0_t*deriv_exp_0_d0*((DCln2*(-modelStruct.d_modelPar_zs_dX)+d_DCln2_dX*(-modelStruct.modelPar_zs)))+instanceStruct.d_instanceVar_cjs0_t_dX*value_exp_0)*De_1)*De_2);
DC_j1 = (((instanceStruct.instanceVar_cjs0_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j2_dX = ((DC_c*value_exp_0)*(-d_De_2_dX)+(DC_c*deriv_exp_0_d0*((DCln1*(-d_Dz_r_dX)+d_DCln1_dX*(-Dz_r)))+d_DC_c_dX*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}
d_DC_j3_dX = (DC_max*(-d_De_1_dX)+d_DC_max_dX*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
d_Cjs_dX = ((d_DC_j1_dX+d_DC_j2_dX)+d_DC_j3_dX);
Cjs = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j1_dX = ((Dz1*(instanceStruct.instanceVar_cjs0_t*(-deriv_exp_0_d0*((DCln2*d_Dz1_dX+d_DCln2_dX*Dz1)))+instanceStruct.d_instanceVar_cjs0_t_dX*(1.0-value_exp_0))-(instanceStruct.instanceVar_cjs0_t*(1.0-value_exp_0))*d_Dz1_dX)/Dz1/Dz1);
DQ_j1 = ((instanceStruct.instanceVar_cjs0_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j2_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln1*d_Dzr1_dX+d_DCln1_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j3_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln2*d_Dzr1_dX+d_DCln2_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
d_Qjs_dX = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.d_instanceVar_vds_t_dX+((d_DQ_j1_dX+d_DQ_j2_dX)-d_DQ_j3_dX)*instanceStruct.instanceVar_vds_t)+(DC_max*d_Dv_j4_dX+d_DC_max_dX*Dv_j4));
Qjs = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.instanceVar_vds_t)+(DC_max*Dv_j4));
}
else
{
d_Cjs_dX = 0.0;
Cjs = 0.0;
d_Qjs_dX = 0.0;
Qjs = 0.0;
}
}
else
{
if ((instanceStruct.instanceVar_cjs0_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zs));
double  deriv_exp_1_d0 = value_exp_1;
d_DFV_f_dX = (instanceStruct.instanceVar_vds_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zs_dX/modelStruct.modelPar_zs/modelStruct.modelPar_zs)))+instanceStruct.d_instanceVar_vds_t_dX*(1.0-value_exp_1));
DFV_f = (instanceStruct.instanceVar_vds_t*(1.0-value_exp_1));
}
d_DFv_e_dX = ((instanceStruct.instanceVar_VT*(d_DFV_f_dX-d_Vsici_dX)-(DFV_f-Vsici)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
DFv_e = ((DFV_f-Vsici)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_DFs_q_dX = deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dX+d_DFv_e_dX*DFv_e));
DFs_q = value_sqrt_0;
}
d_DFs_q2_dX = (d_DFv_e_dX+d_DFs_q_dX)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);
d_DFv_j_dX = (d_DFV_f_dX-(instanceStruct.instanceVar_VT*d_DFs_q2_dX+instanceStruct.d_instanceVar_VT_dX*DFs_q2));
DFv_j = (DFV_f-(instanceStruct.instanceVar_VT*DFs_q2));
d_DFdvj_dv_dX = ((DFs_q*d_DFs_q2_dX-DFs_q2*d_DFs_q_dX)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/instanceStruct.instanceVar_vds_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/instanceStruct.instanceVar_vds_t)));
d_DFb_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vds_t*d_DFv_j_dX-DFv_j*instanceStruct.d_instanceVar_vds_t_dX)/instanceStruct.instanceVar_vds_t/instanceStruct.instanceVar_vds_t)));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-modelStruct.modelPar_zs)*DFb));
double  deriv_exp_0_d0 = value_exp_0;
d_DFC_j1_dX = ((instanceStruct.instanceVar_cjs0_t*value_exp_0)*d_DFdvj_dv_dX+(instanceStruct.instanceVar_cjs0_t*deriv_exp_0_d0*(((-modelStruct.modelPar_zs)*d_DFb_dX+(-modelStruct.d_modelPar_zs_dX)*DFb))+instanceStruct.d_instanceVar_cjs0_t_dX*value_exp_0)*DFdvj_dv);
DFC_j1 = ((instanceStruct.instanceVar_cjs0_t*value_exp_0)*DFdvj_dv);
}
d_Cjs_dX = (d_DFC_j1_dX+((2.4*instanceStruct.instanceVar_cjs0_t)*(-d_DFdvj_dv_dX)+2.4*instanceStruct.d_instanceVar_cjs0_t_dX*(1.0-DFdvj_dv)));
Cjs = (DFC_j1+((2.4*instanceStruct.instanceVar_cjs0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-modelStruct.modelPar_zs)));
double  deriv_exp_0_d0 = value_exp_0;
d_DFQ_j_dX = (((1.0-modelStruct.modelPar_zs)*((instanceStruct.instanceVar_cjs0_t*instanceStruct.instanceVar_vds_t)*(-deriv_exp_0_d0*((DFb*(-modelStruct.d_modelPar_zs_dX)+d_DFb_dX*(1.0-modelStruct.modelPar_zs))))+(instanceStruct.instanceVar_cjs0_t*instanceStruct.d_instanceVar_vds_t_dX+instanceStruct.d_instanceVar_cjs0_t_dX*instanceStruct.instanceVar_vds_t)*(1.0-value_exp_0))-((instanceStruct.instanceVar_cjs0_t*instanceStruct.instanceVar_vds_t)*(1.0-value_exp_0))*(-modelStruct.d_modelPar_zs_dX))/(1.0-modelStruct.modelPar_zs)/(1.0-modelStruct.modelPar_zs));
DFQ_j = (((instanceStruct.instanceVar_cjs0_t*instanceStruct.instanceVar_vds_t)*(1.0-value_exp_0))/(1.0-modelStruct.modelPar_zs));
}
d_Qjs_dX = (d_DFQ_j_dX+((2.4*instanceStruct.instanceVar_cjs0_t)*(d_Vsici_dX-d_DFv_j_dX)+2.4*instanceStruct.d_instanceVar_cjs0_t_dX*(Vsici-DFv_j)));
Qjs = (DFQ_j+((2.4*instanceStruct.instanceVar_cjs0_t)*(Vsici-DFv_j)));
}
else
{
d_Cjs_dX = 0.0;
Cjs = 0.0;
d_Qjs_dX = 0.0;
Qjs = 0.0;
}
}
if ((modelStruct.modelPar_vdsp>0))
{
if ((instanceStruct.instanceVar_vptsp_t<1.0e2))
{
if ((instanceStruct.instanceVar_cscp0_t>0.0))
{
d_Dz_r_dX = (modelStruct.d_modelPar_zsp_dX/4.0);
Dz_r = (modelStruct.modelPar_zsp/4.0);
d_Dv_p_dX = (instanceStruct.d_instanceVar_vptsp_t_dX-instanceStruct.d_instanceVar_vdsp_t_dX);
Dv_p = (instanceStruct.instanceVar_vptsp_t-instanceStruct.instanceVar_vdsp_t);
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zsp));
double  deriv_exp_1_d0 = value_exp_1;
d_DV_f_dX = (instanceStruct.instanceVar_vdsp_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zsp_dX/modelStruct.modelPar_zsp/modelStruct.modelPar_zsp)))+instanceStruct.d_instanceVar_vdsp_t_dX*(1.0-value_exp_1));
DV_f = (instanceStruct.instanceVar_vdsp_t*(1.0-value_exp_1));
}
d_DC_max_dX = 2.4*instanceStruct.d_instanceVar_cscp0_t_dX;
DC_max = (2.4*instanceStruct.instanceVar_cscp0_t);
{
double value_log_0 = log((instanceStruct.instanceVar_vptsp_t/instanceStruct.instanceVar_vdsp_t));
double value_exp_1 = exp(((Dz_r-modelStruct.modelPar_zsp)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_vptsp_t/instanceStruct.instanceVar_vdsp_t));
double  deriv_exp_1_d0 = value_exp_1;
d_DC_c_dX = (instanceStruct.instanceVar_cscp0_t*deriv_exp_1_d0*(((Dz_r-modelStruct.modelPar_zsp)*deriv_log_0_d0*(((instanceStruct.instanceVar_vdsp_t*instanceStruct.d_instanceVar_vptsp_t_dX-instanceStruct.instanceVar_vptsp_t*instanceStruct.d_instanceVar_vdsp_t_dX)/instanceStruct.instanceVar_vdsp_t/instanceStruct.instanceVar_vdsp_t))+(d_Dz_r_dX-modelStruct.d_modelPar_zsp_dX)*value_log_0))+instanceStruct.d_instanceVar_cscp0_t_dX*value_exp_1);
DC_c = (instanceStruct.instanceVar_cscp0_t*value_exp_1);
}
d_Dv_e_dX = ((instanceStruct.instanceVar_VT*(d_DV_f_dX-d_Vsc_dX)-(DV_f-Vsc)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
Dv_e = ((DV_f-Vsc)/instanceStruct.instanceVar_VT);
if ((Dv_e<80.0))
{
{
double value_exp_0 = exp(Dv_e);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_e_dX);
De = value_exp_0;
}
d_De_1_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_1 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double  deriv_log_0_d0 = (1.0/(1.0+De));
d_Dv_j1_dX = (d_DV_f_dX-(instanceStruct.instanceVar_VT*deriv_log_0_d0*(d_De_dX)+instanceStruct.d_instanceVar_VT_dX*value_log_0));
Dv_j1 = (DV_f-(instanceStruct.instanceVar_VT*value_log_0));
}
}
else
{
d_De_1_dX = 0.0;
De_1 = 1.0;
d_Dv_j1_dX = d_Vsc_dX;
Dv_j1 = Vsc;
}
d_Da_dX = (0.1*d_Dv_p_dX+4.0*instanceStruct.d_instanceVar_VT_dX);
Da = ((0.1*Dv_p)+(4.0*instanceStruct.instanceVar_VT));
d_Dv_r_dX = ((Da*(d_Dv_p_dX+d_Dv_j1_dX)-(Dv_p+Dv_j1)*d_Da_dX)/Da/Da);
Dv_r = ((Dv_p+Dv_j1)/Da);
if ((Dv_r<80.0))
{
{
double value_exp_0 = exp(Dv_r);
double  deriv_exp_0_d0 = value_exp_0;
d_De_dX = deriv_exp_0_d0*(d_Dv_r_dX);
De = value_exp_0;
}
d_De_2_dX = (((1.0+De)*d_De_dX-De*d_De_dX)/(1.0+De)/(1.0+De));
De_2 = (De/(1.0+De));
{
double value_log_0 = log((1.0+De));
double value_exp_1 = exp(((-(Dv_p+DV_f))/Da));
double  deriv_log_0_d0 = (1.0/(1.0+De));
double  deriv_exp_1_d0 = value_exp_1;
d_Dv_j2_dX = ((-d_Dv_p_dX)+(Da*(deriv_log_0_d0*(d_De_dX)-deriv_exp_1_d0*(((Da*(-(d_Dv_p_dX+d_DV_f_dX))-(-(Dv_p+DV_f))*d_Da_dX)/Da/Da)))+d_Da_dX*(value_log_0-value_exp_1)));
Dv_j2 = ((-Dv_p)+(Da*(value_log_0-value_exp_1)));
}
}
else
{
d_De_2_dX = 0.0;
De_2 = 1.0;
d_Dv_j2_dX = d_Dv_j1_dX;
Dv_j2 = Dv_j1;
}
d_Dv_j4_dX = (d_Vsc_dX-d_Dv_j1_dX);
Dv_j4 = (Vsc-Dv_j1);
{
double value_log_0 = log((1.0-(Dv_j1/instanceStruct.instanceVar_vdsp_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j1/instanceStruct.instanceVar_vdsp_t)));
d_DCln1_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdsp_t*d_Dv_j1_dX-Dv_j1*instanceStruct.d_instanceVar_vdsp_t_dX)/instanceStruct.instanceVar_vdsp_t/instanceStruct.instanceVar_vdsp_t)));
DCln1 = value_log_0;
}
{
double value_log_0 = log((1.0-(Dv_j2/instanceStruct.instanceVar_vdsp_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(Dv_j2/instanceStruct.instanceVar_vdsp_t)));
d_DCln2_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdsp_t*d_Dv_j2_dX-Dv_j2*instanceStruct.d_instanceVar_vdsp_t_dX)/instanceStruct.instanceVar_vdsp_t/instanceStruct.instanceVar_vdsp_t)));
DCln2 = value_log_0;
}
d_Dz1_dX = (-modelStruct.d_modelPar_zsp_dX);
Dz1 = (1.0-modelStruct.modelPar_zsp);
d_Dzr1_dX = (-d_Dz_r_dX);
Dzr1 = (1.0-Dz_r);
{
double value_exp_0 = exp((DCln2*(-modelStruct.modelPar_zsp)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j1_dX = (((instanceStruct.instanceVar_cscp0_t*value_exp_0)*De_1)*d_De_2_dX+((instanceStruct.instanceVar_cscp0_t*value_exp_0)*d_De_1_dX+(instanceStruct.instanceVar_cscp0_t*deriv_exp_0_d0*((DCln2*(-modelStruct.d_modelPar_zsp_dX)+d_DCln2_dX*(-modelStruct.modelPar_zsp)))+instanceStruct.d_instanceVar_cscp0_t_dX*value_exp_0)*De_1)*De_2);
DC_j1 = (((instanceStruct.instanceVar_cscp0_t*value_exp_0)*De_1)*De_2);
}
{
double value_exp_0 = exp((DCln1*(-Dz_r)));
double  deriv_exp_0_d0 = value_exp_0;
d_DC_j2_dX = ((DC_c*value_exp_0)*(-d_De_2_dX)+(DC_c*deriv_exp_0_d0*((DCln1*(-d_Dz_r_dX)+d_DCln1_dX*(-Dz_r)))+d_DC_c_dX*value_exp_0)*(1.0-De_2));
DC_j2 = ((DC_c*value_exp_0)*(1.0-De_2));
}
d_DC_j3_dX = (DC_max*(-d_De_1_dX)+d_DC_max_dX*(1.0-De_1));
DC_j3 = (DC_max*(1.0-De_1));
d_Cscp_dX = ((d_DC_j1_dX+d_DC_j2_dX)+d_DC_j3_dX);
Cscp = ((DC_j1+DC_j2)+DC_j3);
{
double value_exp_0 = exp((DCln2*Dz1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j1_dX = ((Dz1*(instanceStruct.instanceVar_cscp0_t*(-deriv_exp_0_d0*((DCln2*d_Dz1_dX+d_DCln2_dX*Dz1)))+instanceStruct.d_instanceVar_cscp0_t_dX*(1.0-value_exp_0))-(instanceStruct.instanceVar_cscp0_t*(1.0-value_exp_0))*d_Dz1_dX)/Dz1/Dz1);
DQ_j1 = ((instanceStruct.instanceVar_cscp0_t*(1.0-value_exp_0))/Dz1);
}
{
double value_exp_0 = exp((DCln1*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j2_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln1*d_Dzr1_dX+d_DCln1_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j2 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
{
double value_exp_0 = exp((DCln2*Dzr1));
double  deriv_exp_0_d0 = value_exp_0;
d_DQ_j3_dX = ((Dzr1*(DC_c*(-deriv_exp_0_d0*((DCln2*d_Dzr1_dX+d_DCln2_dX*Dzr1)))+d_DC_c_dX*(1.0-value_exp_0))-(DC_c*(1.0-value_exp_0))*d_Dzr1_dX)/Dzr1/Dzr1);
DQ_j3 = ((DC_c*(1.0-value_exp_0))/Dzr1);
}
d_Qscp_dX = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.d_instanceVar_vdsp_t_dX+((d_DQ_j1_dX+d_DQ_j2_dX)-d_DQ_j3_dX)*instanceStruct.instanceVar_vdsp_t)+(DC_max*d_Dv_j4_dX+d_DC_max_dX*Dv_j4));
Qscp = ((((DQ_j1+DQ_j2)-DQ_j3)*instanceStruct.instanceVar_vdsp_t)+(DC_max*Dv_j4));
}
else
{
d_Cscp_dX = 0.0;
Cscp = 0.0;
d_Qscp_dX = 0.0;
Qscp = 0.0;
}
}
else
{
if ((instanceStruct.instanceVar_cscp0_t>0.0))
{
{
double value_log_0 = log(static_cast<double>(2.4));
double value_exp_1 = exp(((-value_log_0)/modelStruct.modelPar_zsp));
double  deriv_exp_1_d0 = value_exp_1;
d_DFV_f_dX = (instanceStruct.instanceVar_vdsp_t*(-deriv_exp_1_d0*((-(-value_log_0)*modelStruct.d_modelPar_zsp_dX/modelStruct.modelPar_zsp/modelStruct.modelPar_zsp)))+instanceStruct.d_instanceVar_vdsp_t_dX*(1.0-value_exp_1));
DFV_f = (instanceStruct.instanceVar_vdsp_t*(1.0-value_exp_1));
}
d_DFv_e_dX = ((instanceStruct.instanceVar_VT*(d_DFV_f_dX-d_Vsc_dX)-(DFV_f-Vsc)*instanceStruct.d_instanceVar_VT_dX)/instanceStruct.instanceVar_VT/instanceStruct.instanceVar_VT);
DFv_e = ((DFV_f-Vsc)/instanceStruct.instanceVar_VT);
{
double value_sqrt_0 = sqrt(((DFv_e*DFv_e)+1.921812));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_DFs_q_dX = deriv_sqrt_0_d0*((DFv_e*d_DFv_e_dX+d_DFv_e_dX*DFv_e));
DFs_q = value_sqrt_0;
}
d_DFs_q2_dX = (d_DFv_e_dX+d_DFs_q_dX)*0.5;
DFs_q2 = ((DFv_e+DFs_q)*0.5);
d_DFv_j_dX = (d_DFV_f_dX-(instanceStruct.instanceVar_VT*d_DFs_q2_dX+instanceStruct.d_instanceVar_VT_dX*DFs_q2));
DFv_j = (DFV_f-(instanceStruct.instanceVar_VT*DFs_q2));
d_DFdvj_dv_dX = ((DFs_q*d_DFs_q2_dX-DFs_q2*d_DFs_q_dX)/DFs_q/DFs_q);
DFdvj_dv = (DFs_q2/DFs_q);
{
double value_log_0 = log((1.0-(DFv_j/instanceStruct.instanceVar_vdsp_t)));
double  deriv_log_0_d0 = (1.0/(1.0-(DFv_j/instanceStruct.instanceVar_vdsp_t)));
d_DFb_dX = deriv_log_0_d0*((-((instanceStruct.instanceVar_vdsp_t*d_DFv_j_dX-DFv_j*instanceStruct.d_instanceVar_vdsp_t_dX)/instanceStruct.instanceVar_vdsp_t/instanceStruct.instanceVar_vdsp_t)));
DFb = value_log_0;
}
{
double value_exp_0 = exp(((-modelStruct.modelPar_zsp)*DFb));
double  deriv_exp_0_d0 = value_exp_0;
d_DFC_j1_dX = ((instanceStruct.instanceVar_cscp0_t*value_exp_0)*d_DFdvj_dv_dX+(instanceStruct.instanceVar_cscp0_t*deriv_exp_0_d0*(((-modelStruct.modelPar_zsp)*d_DFb_dX+(-modelStruct.d_modelPar_zsp_dX)*DFb))+instanceStruct.d_instanceVar_cscp0_t_dX*value_exp_0)*DFdvj_dv);
DFC_j1 = ((instanceStruct.instanceVar_cscp0_t*value_exp_0)*DFdvj_dv);
}
d_Cscp_dX = (d_DFC_j1_dX+((2.4*instanceStruct.instanceVar_cscp0_t)*(-d_DFdvj_dv_dX)+2.4*instanceStruct.d_instanceVar_cscp0_t_dX*(1.0-DFdvj_dv)));
Cscp = (DFC_j1+((2.4*instanceStruct.instanceVar_cscp0_t)*(1.0-DFdvj_dv)));
{
double value_exp_0 = exp((DFb*(1.0-modelStruct.modelPar_zsp)));
double  deriv_exp_0_d0 = value_exp_0;
d_DFQ_j_dX = (((1.0-modelStruct.modelPar_zsp)*((instanceStruct.instanceVar_cscp0_t*instanceStruct.instanceVar_vdsp_t)*(-deriv_exp_0_d0*((DFb*(-modelStruct.d_modelPar_zsp_dX)+d_DFb_dX*(1.0-modelStruct.modelPar_zsp))))+(instanceStruct.instanceVar_cscp0_t*instanceStruct.d_instanceVar_vdsp_t_dX+instanceStruct.d_instanceVar_cscp0_t_dX*instanceStruct.instanceVar_vdsp_t)*(1.0-value_exp_0))-((instanceStruct.instanceVar_cscp0_t*instanceStruct.instanceVar_vdsp_t)*(1.0-value_exp_0))*(-modelStruct.d_modelPar_zsp_dX))/(1.0-modelStruct.modelPar_zsp)/(1.0-modelStruct.modelPar_zsp));
DFQ_j = (((instanceStruct.instanceVar_cscp0_t*instanceStruct.instanceVar_vdsp_t)*(1.0-value_exp_0))/(1.0-modelStruct.modelPar_zsp));
}
d_Qscp_dX = (d_DFQ_j_dX+((2.4*instanceStruct.instanceVar_cscp0_t)*(d_Vsc_dX-d_DFv_j_dX)+2.4*instanceStruct.d_instanceVar_cscp0_t_dX*(Vsc-DFv_j)));
Qscp = (DFQ_j+((2.4*instanceStruct.instanceVar_cscp0_t)*(Vsc-DFv_j)));
}
else
{
d_Cscp_dX = 0.0;
Cscp = 0.0;
d_Qscp_dX = 0.0;
Qscp = 0.0;
}
}
}
else
{
d_Cscp_dX = modelStruct.d_modelPar_cscp0_dX;
Cscp = modelStruct.modelPar_cscp0;
d_Qscp_dX = (modelStruct.modelPar_cscp0*d_Vsc_dX+modelStruct.d_modelPar_cscp0_dX*Vsc);
Qscp = (modelStruct.modelPar_cscp0*Vsc);
}
if ((modelStruct.modelPar_itss>0.0))
//Begin block Sub_Transfer
{
d_HSUM_dX = (modelStruct.modelPar_msf*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_msf_dX*instanceStruct.instanceVar_VT);
HSUM = (modelStruct.modelPar_msf*instanceStruct.instanceVar_VT);
{
double value_limexp_0 = limexp((Vbpci/HSUM));
double  deriv_limexp_0_d0 = ((((Vbpci/HSUM))<80)?(value_limexp_0):exp(80.0));
d_HSa_dX = deriv_limexp_0_d0*(((HSUM*d_Vbpci_dX-Vbpci*d_HSUM_dX)/HSUM/HSUM));
HSa = value_limexp_0;
}
{
double value_limexp_0 = limexp((Vsici/HSUM));
double  deriv_limexp_0_d0 = ((((Vsici/HSUM))<80)?(value_limexp_0):exp(80.0));
d_HSb_dX = deriv_limexp_0_d0*(((HSUM*d_Vsici_dX-Vsici*d_HSUM_dX)/HSUM/HSUM));
HSb = value_limexp_0;
}
d_HSI_Tsu_dX = (instanceStruct.instanceVar_itss_t*(d_HSa_dX-d_HSb_dX)+instanceStruct.d_instanceVar_itss_t_dX*(HSa-HSb));
HSI_Tsu = (instanceStruct.instanceVar_itss_t*(HSa-HSb));
if ((modelStruct.modelPar_tsf>0.0))
{
d_Qdsu_dX = ((instanceStruct.instanceVar_tsf_t*instanceStruct.instanceVar_itss_t)*d_HSa_dX+(instanceStruct.instanceVar_tsf_t*instanceStruct.d_instanceVar_itss_t_dX+instanceStruct.d_instanceVar_tsf_t_dX*instanceStruct.instanceVar_itss_t)*HSa);
Qdsu = ((instanceStruct.instanceVar_tsf_t*instanceStruct.instanceVar_itss_t)*HSa);
}
else
{
d_Qdsu_dX = 0.0;
Qdsu = 0.0;
}
}
// End block Sub_Transfer
else
{
d_HSI_Tsu_dX = 0.0;
HSI_Tsu = 0.0;
d_Qdsu_dX = 0.0;
Qdsu = 0.0;
}
if ((instanceStruct.instanceVar_ibei>0.0))
{
instanceStruct.d_instanceVar_betadc_dX = ((instanceStruct.instanceVar_ibei*instanceStruct.d_instanceVar_it_dX-instanceStruct.instanceVar_it*instanceStruct.d_instanceVar_ibei_dX)/instanceStruct.instanceVar_ibei/instanceStruct.instanceVar_ibei);
instanceStruct.instanceVar_betadc = (instanceStruct.instanceVar_it/instanceStruct.instanceVar_ibei);
}
else
{
instanceStruct.d_instanceVar_betadc_dX = 0.0;
instanceStruct.instanceVar_betadc = 0.0;
}
d_DIOY_dX = (((modelStruct.modelPar_msc*instanceStruct.instanceVar_VT)*d_Vsici_dX-Vsici*(modelStruct.modelPar_msc*instanceStruct.d_instanceVar_VT_dX+modelStruct.d_modelPar_msc_dX*instanceStruct.instanceVar_VT))/(modelStruct.modelPar_msc*instanceStruct.instanceVar_VT)/(modelStruct.modelPar_msc*instanceStruct.instanceVar_VT));
DIOY = (Vsici/(modelStruct.modelPar_msc*instanceStruct.instanceVar_VT));
if ((modelStruct.modelPar_iscs>0.0))
{
if ((DIOY>80.0))
{
d_le_dX = d_DIOY_dX;
le = (1+(DIOY-80.0));
d_DIOY_dX = 0.0;
DIOY = 80.0;
}
else
{
d_le_dX = 0.0;
le = 1;
}
{
double value_limexp_0 = limexp(DIOY);
double  deriv_limexp_0_d0 = (((DIOY)<80)?(value_limexp_0):exp(80.0));
d_le_dX = (le*deriv_limexp_0_d0*(d_DIOY_dX)+d_le_dX*value_limexp_0);
le = (le*value_limexp_0);
}
instanceStruct.d_instanceVar_ijsc_dX = (instanceStruct.instanceVar_iscs_t*d_le_dX+instanceStruct.d_instanceVar_iscs_t_dX*(le-1.0));
instanceStruct.instanceVar_ijsc = (instanceStruct.instanceVar_iscs_t*(le-1.0));
if ((DIOY<=(-14.0)))
{
instanceStruct.d_instanceVar_ijsc_dX = (-instanceStruct.d_instanceVar_iscs_t_dX);
instanceStruct.instanceVar_ijsc = (-instanceStruct.instanceVar_iscs_t);
}
}
else
{
instanceStruct.d_instanceVar_ijsc_dX = 0.0;
instanceStruct.instanceVar_ijsc = 0.0;
}
if (((modelStruct.modelPar_flsh==1)&&(modelStruct.modelPar_rth>=0.001)))
{
d_pterm_dX = ((Vciei*instanceStruct.d_instanceVar_it_dX+d_Vciei_dX*instanceStruct.instanceVar_it)+((instanceStruct.instanceVar_vdci_t-Vbici)*instanceStruct.d_instanceVar_iavl_dX+(instanceStruct.d_instanceVar_vdci_t_dX-d_Vbici_dX)*instanceStruct.instanceVar_iavl));
pterm = ((Vciei*instanceStruct.instanceVar_it)+((instanceStruct.instanceVar_vdci_t-Vbici)*instanceStruct.instanceVar_iavl));
}
else
{
if (((modelStruct.modelPar_flsh==2)&&(modelStruct.modelPar_rth>=0.001)))
{
d_pterm_dX = (((((((Vciei*instanceStruct.d_instanceVar_it_dX+d_Vciei_dX*instanceStruct.instanceVar_it)+((instanceStruct.instanceVar_vdci_t-Vbici)*instanceStruct.d_instanceVar_iavl_dX+(instanceStruct.d_instanceVar_vdci_t_dX-d_Vbici_dX)*instanceStruct.instanceVar_iavl))+(instanceStruct.instanceVar_ibei*d_Vbiei_dX+instanceStruct.d_instanceVar_ibei_dX*Vbiei))+(instanceStruct.instanceVar_ibci*d_Vbici_dX+instanceStruct.d_instanceVar_ibci_dX*Vbici))+(instanceStruct.instanceVar_ibep*d_Vbpei_dX+instanceStruct.d_instanceVar_ibep_dX*Vbpei))+(instanceStruct.instanceVar_ijbcx*d_Vbpci_dX+instanceStruct.d_instanceVar_ijbcx_dX*Vbpci))+(instanceStruct.instanceVar_ijsc*d_Vsici_dX+instanceStruct.d_instanceVar_ijsc_dX*Vsici));
pterm = (((((((Vciei*instanceStruct.instanceVar_it)+((instanceStruct.instanceVar_vdci_t-Vbici)*instanceStruct.instanceVar_iavl))+(instanceStruct.instanceVar_ibei*Vbiei))+(instanceStruct.instanceVar_ibci*Vbici))+(instanceStruct.instanceVar_ibep*Vbpei))+(instanceStruct.instanceVar_ijbcx*Vbpci))+(instanceStruct.instanceVar_ijsc*Vsici));
if ((instanceStruct.instanceVar_rbi>=0.001))
{
d_pterm_dX = (d_pterm_dX+(-((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))*instanceStruct.d_instanceVar_rbi_dX/instanceStruct.instanceVar_rbi/instanceStruct.instanceVar_rbi));
pterm = (pterm+(((probeVars[admsProbeID_V_bp_bi])*(probeVars[admsProbeID_V_bp_bi]))/instanceStruct.instanceVar_rbi));
}
if ((instanceStruct.instanceVar_re_t>=0.001))
{
d_pterm_dX = (d_pterm_dX+(-((probeVars[admsProbeID_V_ei_e])*(probeVars[admsProbeID_V_ei_e]))*instanceStruct.d_instanceVar_re_t_dX/instanceStruct.instanceVar_re_t/instanceStruct.instanceVar_re_t));
pterm = (pterm+(((probeVars[admsProbeID_V_ei_e])*(probeVars[admsProbeID_V_ei_e]))/instanceStruct.instanceVar_re_t));
}
if ((instanceStruct.instanceVar_rcx_t>=0.001))
{
d_pterm_dX = (d_pterm_dX+(-((probeVars[admsProbeID_V_ci_c])*(probeVars[admsProbeID_V_ci_c]))*instanceStruct.d_instanceVar_rcx_t_dX/instanceStruct.instanceVar_rcx_t/instanceStruct.instanceVar_rcx_t));
pterm = (pterm+(((probeVars[admsProbeID_V_ci_c])*(probeVars[admsProbeID_V_ci_c]))/instanceStruct.instanceVar_rcx_t));
}
if ((instanceStruct.instanceVar_rbx_t>=0.001))
{
d_pterm_dX = (d_pterm_dX+(-((probeVars[admsProbeID_V_b_bp])*(probeVars[admsProbeID_V_b_bp]))*instanceStruct.d_instanceVar_rbx_t_dX/instanceStruct.instanceVar_rbx_t/instanceStruct.instanceVar_rbx_t));
pterm = (pterm+(((probeVars[admsProbeID_V_b_bp])*(probeVars[admsProbeID_V_b_bp]))/instanceStruct.instanceVar_rbx_t));
}
}
}
d_Itxf_dX = d_itf_dX;
Itxf = itf;
d_Qdeix_dX = d_Qdei_dX;
Qdeix = Qdei;
if ((((((modelStruct.modelPar_flnqs!=0)||(modelStruct.modelPar_flcomp==0.0))||(modelStruct.modelPar_flcomp==2.1))&&(instanceStruct.instanceVar_Tf!=0))&&((modelStruct.modelPar_alit>0)||(modelStruct.modelPar_alqf>0))))
{
Vxf1 = (probeVars[admsProbeID_V_xf1_GND]);
Vxf2 = (probeVars[admsProbeID_V_xf2_GND]);
d_Ixf1_dX = (((Vxf2-itf)/instanceStruct.instanceVar_Tf)*modelStruct.d_modelPar_t0_dX+((instanceStruct.instanceVar_Tf*(-d_itf_dX)-(Vxf2-itf)*instanceStruct.d_instanceVar_Tf_dX)/instanceStruct.instanceVar_Tf/instanceStruct.instanceVar_Tf)*modelStruct.modelPar_t0);
Ixf1 = (((Vxf2-itf)/instanceStruct.instanceVar_Tf)*modelStruct.modelPar_t0);
d_Ixf2_dX = (((Vxf2-Vxf1)/instanceStruct.instanceVar_Tf)*modelStruct.d_modelPar_t0_dX+(-(Vxf2-Vxf1)*instanceStruct.d_instanceVar_Tf_dX/instanceStruct.instanceVar_Tf/instanceStruct.instanceVar_Tf)*modelStruct.modelPar_t0);
Ixf2 = (((Vxf2-Vxf1)/instanceStruct.instanceVar_Tf)*modelStruct.modelPar_t0);
d_Qxf1_dX = ((modelStruct.modelPar_alit*Vxf1)*modelStruct.d_modelPar_t0_dX+modelStruct.d_modelPar_alit_dX*Vxf1*modelStruct.modelPar_t0);
Qxf1 = ((modelStruct.modelPar_alit*Vxf1)*modelStruct.modelPar_t0);
d_Qxf2_dX = (((modelStruct.modelPar_alit*Vxf2)/3)*modelStruct.d_modelPar_t0_dX+(modelStruct.d_modelPar_alit_dX*Vxf2/3)*modelStruct.modelPar_t0);
Qxf2 = (((modelStruct.modelPar_alit*Vxf2)/3)*modelStruct.modelPar_t0);
d_Itxf_dX = 0.0;
Itxf = Vxf2;
Vxf = (probeVars[admsProbeID_V_xf_GND]);
d_fact_dX = ((instanceStruct.instanceVar_Tf*modelStruct.d_modelPar_t0_dX-modelStruct.modelPar_t0*instanceStruct.d_instanceVar_Tf_dX)/instanceStruct.instanceVar_Tf/instanceStruct.instanceVar_Tf);
fact = (modelStruct.modelPar_t0/instanceStruct.instanceVar_Tf);
d_Ixf_dX = ((Vxf-Qdei)*d_fact_dX+(-d_Qdei_dX)*fact);
Ixf = ((Vxf-Qdei)*fact);
d_Qxf_dX = ((modelStruct.modelPar_alqf*Vxf)*modelStruct.d_modelPar_t0_dX+modelStruct.d_modelPar_alqf_dX*Vxf*modelStruct.modelPar_t0);
Qxf = ((modelStruct.modelPar_alqf*Vxf)*modelStruct.modelPar_t0);
d_Qdeix_dX = 0.0;
Qdeix = Vxf;
}
else
{
d_Ixf1_dX = 0.0;
Ixf1 = (probeVars[admsProbeID_V_xf1_GND]);
d_Ixf2_dX = 0.0;
Ixf2 = (probeVars[admsProbeID_V_xf2_GND]);
d_Qxf1_dX = 0.0;
Qxf1 = 0;
d_Qxf2_dX = 0.0;
Qxf2 = 0;
d_Ixf_dX = 0.0;
Ixf = (probeVars[admsProbeID_V_xf_GND]);
d_Qxf_dX = 0.0;
Qxf = 0;
}
}
// End block Model_evaluation
//Begin block Load_sources
{
// I(bi,ei) <+ (($simparam("gmin",1e-12)*V(bi,ei)))
d_staticContributions_dX[admsNodeID_bi]+= 0.0;
d_staticContributions_dX[(admsNodeID_ei)]-= 0.0;
// I(bi,ci) <+ (($simparam("gmin",1e-12)*V(bi,ci)))
d_staticContributions_dX[admsNodeID_bi]+= 0.0;
d_staticContributions_dX[(admsNodeID_ci)]-= 0.0;
// I(ci,ei) <+ (($simparam("gmin",1e-12)*V(ci,ei)))
d_staticContributions_dX[admsNodeID_ci]+= 0.0;
d_staticContributions_dX[(admsNodeID_ei)]-= 0.0;
// I(b,ci) <+ (ddt((type*qjcx0_t_i)))
d_dynamicContributions_dX[admsNodeID_b]+= (modelStruct.modelPar_type*d_qjcx0_t_i_dX);
d_dynamicContributions_dX[(admsNodeID_ci)]-= (modelStruct.modelPar_type*d_qjcx0_t_i_dX);
// I(b,ci) <+ (ddt((cbcpar1*V(b,ci))))
d_dynamicContributions_dX[admsNodeID_b]+= (instanceStruct.d_instanceVar_cbcpar1_dX*(probeVars[admsProbeID_V_b_ci]));
d_dynamicContributions_dX[(admsNodeID_ci)]-= (instanceStruct.d_instanceVar_cbcpar1_dX*(probeVars[admsProbeID_V_b_ci]));
// I(bp,ci) <+ (ddt((cbcpar2*V(bp,ci))))
d_dynamicContributions_dX[admsNodeID_bp]+= (instanceStruct.d_instanceVar_cbcpar2_dX*(probeVars[admsProbeID_V_bp_ci]));
d_dynamicContributions_dX[(admsNodeID_ci)]-= (instanceStruct.d_instanceVar_cbcpar2_dX*(probeVars[admsProbeID_V_bp_ci]));
if ((modelStruct.modelPar_rbx>=0.001))
{
// I(b,bp) <+ ((V(b,bp)/rbx_t))
d_staticContributions_dX[admsNodeID_b]+= (-(probeVars[admsProbeID_V_b_bp])*instanceStruct.d_instanceVar_rbx_t_dX/instanceStruct.instanceVar_rbx_t/instanceStruct.instanceVar_rbx_t);
d_staticContributions_dX[(admsNodeID_bp)]-= (-(probeVars[admsProbeID_V_b_bp])*instanceStruct.d_instanceVar_rbx_t_dX/instanceStruct.instanceVar_rbx_t/instanceStruct.instanceVar_rbx_t);
}
else
{
// V(b,bp) <+ (0.0)
// do nothing at all
}
if ((modelStruct.modelPar_rbi0>=0.001))
{
// I(bp,bi) <+ ((V(bp,bi)/rbi))
d_staticContributions_dX[admsNodeID_bp]+= (-(probeVars[admsProbeID_V_bp_bi])*instanceStruct.d_instanceVar_rbi_dX/instanceStruct.instanceVar_rbi/instanceStruct.instanceVar_rbi);
d_staticContributions_dX[(admsNodeID_bi)]-= (-(probeVars[admsProbeID_V_bp_bi])*instanceStruct.d_instanceVar_rbi_dX/instanceStruct.instanceVar_rbi/instanceStruct.instanceVar_rbi);
// I(bp,bi) <+ (ddt(qrbi))
d_dynamicContributions_dX[admsNodeID_bp]+= (d_qrbi_dX);
d_dynamicContributions_dX[(admsNodeID_bi)]-= (d_qrbi_dX);
}
else
{
// V(bp,bi) <+ (0.0)
// do nothing at all
}
if ((modelStruct.modelPar_tunode==1.0))
{
// I(bp,ei) <+ (((-type)*ibet))
d_staticContributions_dX[admsNodeID_bp]+= (-modelStruct.modelPar_type)*d_ibet_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= (-modelStruct.modelPar_type)*d_ibet_dX;
}
else
{
// I(bi,ei) <+ (((-type)*ibet))
d_staticContributions_dX[admsNodeID_bi]+= (-modelStruct.modelPar_type)*d_ibet_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= (-modelStruct.modelPar_type)*d_ibet_dX;
}
// I(bp,ei) <+ ((type*ibep))
d_staticContributions_dX[admsNodeID_bp]+= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ibep_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ibep_dX;
// I(bp,ei) <+ ((type*irep))
d_staticContributions_dX[admsNodeID_bp]+= modelStruct.modelPar_type*d_irep_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= modelStruct.modelPar_type*d_irep_dX;
// I(bp,ei) <+ (ddt((type*Qjep)))
d_dynamicContributions_dX[admsNodeID_bp]+= (modelStruct.modelPar_type*d_Qjep_dX);
d_dynamicContributions_dX[(admsNodeID_ei)]-= (modelStruct.modelPar_type*d_Qjep_dX);
// I(bi,ei) <+ ((type*ibei))
d_staticContributions_dX[admsNodeID_bi]+= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ibei_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ibei_dX;
// I(bi,ei) <+ ((type*irei))
d_staticContributions_dX[admsNodeID_bi]+= modelStruct.modelPar_type*d_irei_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= modelStruct.modelPar_type*d_irei_dX;
// I(bi,ei) <+ ((type*ibh_rec))
d_staticContributions_dX[admsNodeID_bi]+= modelStruct.modelPar_type*d_ibh_rec_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= modelStruct.modelPar_type*d_ibh_rec_dX;
// I(bi,ei) <+ (ddt((type*(Qdeix+Qjei))))
d_dynamicContributions_dX[admsNodeID_bi]+= (modelStruct.modelPar_type*(d_Qdeix_dX+d_Qjei_dX));
d_dynamicContributions_dX[(admsNodeID_ei)]-= (modelStruct.modelPar_type*(d_Qdeix_dX+d_Qjei_dX));
// I(bp,si) <+ ((type*HSI_Tsu))
d_staticContributions_dX[admsNodeID_bp]+= modelStruct.modelPar_type*d_HSI_Tsu_dX;
d_staticContributions_dX[(admsNodeID_si)]-= modelStruct.modelPar_type*d_HSI_Tsu_dX;
// I(bp,ci) <+ ((type*ijbcx))
d_staticContributions_dX[admsNodeID_bp]+= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ijbcx_dX;
d_staticContributions_dX[(admsNodeID_ci)]-= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ijbcx_dX;
// I(bp,ci) <+ (ddt((type*(qjcx0_t_ii+Qdsu))))
d_dynamicContributions_dX[admsNodeID_bp]+= (modelStruct.modelPar_type*(d_qjcx0_t_ii_dX+d_Qdsu_dX));
d_dynamicContributions_dX[(admsNodeID_ci)]-= (modelStruct.modelPar_type*(d_qjcx0_t_ii_dX+d_Qdsu_dX));
// I(b,e) <+ (ddt((cbepar1*V(b,e))))
d_dynamicContributions_dX[admsNodeID_b]+= (instanceStruct.d_instanceVar_cbepar1_dX*(probeVars[admsProbeID_V_b_e]));
d_dynamicContributions_dX[(admsNodeID_e)]-= (instanceStruct.d_instanceVar_cbepar1_dX*(probeVars[admsProbeID_V_b_e]));
// I(bp,e) <+ (ddt((cbepar2*V(bp,e))))
d_dynamicContributions_dX[admsNodeID_bp]+= (instanceStruct.d_instanceVar_cbepar2_dX*(probeVars[admsProbeID_V_bp_e]));
d_dynamicContributions_dX[(admsNodeID_e)]-= (instanceStruct.d_instanceVar_cbepar2_dX*(probeVars[admsProbeID_V_bp_e]));
// I(bi,ci) <+ ((type*(ibci-iavl)))
d_staticContributions_dX[admsNodeID_bi]+= modelStruct.modelPar_type*(instanceStruct.d_instanceVar_ibci_dX-instanceStruct.d_instanceVar_iavl_dX);
d_staticContributions_dX[(admsNodeID_ci)]-= modelStruct.modelPar_type*(instanceStruct.d_instanceVar_ibci_dX-instanceStruct.d_instanceVar_iavl_dX);
// I(bi,ci) <+ (ddt((type*(Qdci+Qjci))))
d_dynamicContributions_dX[admsNodeID_bi]+= (modelStruct.modelPar_type*(d_Qdci_dX+d_Qjci_dX));
d_dynamicContributions_dX[(admsNodeID_ci)]-= (modelStruct.modelPar_type*(d_Qdci_dX+d_Qjci_dX));
// I(si,ci) <+ ((type*ijsc))
d_staticContributions_dX[admsNodeID_si]+= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ijsc_dX;
d_staticContributions_dX[(admsNodeID_ci)]-= modelStruct.modelPar_type*instanceStruct.d_instanceVar_ijsc_dX;
// I(si,ci) <+ (ddt((type*Qjs)))
d_dynamicContributions_dX[admsNodeID_si]+= (modelStruct.modelPar_type*d_Qjs_dX);
d_dynamicContributions_dX[(admsNodeID_ci)]-= (modelStruct.modelPar_type*d_Qjs_dX);
// I(s,c) <+ (ddt((type*Qscp)))
d_dynamicContributions_dX[admsNodeID_s]+= (modelStruct.modelPar_type*d_Qscp_dX);
d_dynamicContributions_dX[(admsNodeID_c)]-= (modelStruct.modelPar_type*d_Qscp_dX);
// I(ci,ei) <+ ((type*Itxf))
d_staticContributions_dX[admsNodeID_ci]+= modelStruct.modelPar_type*d_Itxf_dX;
d_staticContributions_dX[(admsNodeID_ei)]-= modelStruct.modelPar_type*d_Itxf_dX;
// I(ei,ci) <+ ((type*itr))
d_staticContributions_dX[admsNodeID_ei]+= modelStruct.modelPar_type*d_itr_dX;
d_staticContributions_dX[(admsNodeID_ci)]-= modelStruct.modelPar_type*d_itr_dX;
if ((modelStruct.modelPar_rcx>=0.001))
{
// I(ci,c) <+ ((V(ci,c)/rcx_t))
d_staticContributions_dX[admsNodeID_ci]+= (-(probeVars[admsProbeID_V_ci_c])*instanceStruct.d_instanceVar_rcx_t_dX/instanceStruct.instanceVar_rcx_t/instanceStruct.instanceVar_rcx_t);
d_staticContributions_dX[(admsNodeID_c)]-= (-(probeVars[admsProbeID_V_ci_c])*instanceStruct.d_instanceVar_rcx_t_dX/instanceStruct.instanceVar_rcx_t/instanceStruct.instanceVar_rcx_t);
}
else
{
// V(ci,c) <+ (0.0)
// do nothing at all
}
if ((modelStruct.modelPar_re>=0.001))
{
// I(ei,e) <+ ((V(ei,e)/re_t))
d_staticContributions_dX[admsNodeID_ei]+= (-(probeVars[admsProbeID_V_ei_e])*instanceStruct.d_instanceVar_re_t_dX/instanceStruct.instanceVar_re_t/instanceStruct.instanceVar_re_t);
d_staticContributions_dX[(admsNodeID_e)]-= (-(probeVars[admsProbeID_V_ei_e])*instanceStruct.d_instanceVar_re_t_dX/instanceStruct.instanceVar_re_t/instanceStruct.instanceVar_re_t);
}
else
{
// V(ei,e) <+ (0.0)
// do nothing at all
}
if ((modelStruct.modelPar_rsu>=0.001))
{
// I(si,s) <+ ((V(si,s)/rsu))
d_staticContributions_dX[admsNodeID_si]+= (-(probeVars[admsProbeID_V_si_s])*modelStruct.d_modelPar_rsu_dX/modelStruct.modelPar_rsu/modelStruct.modelPar_rsu);
d_staticContributions_dX[(admsNodeID_s)]-= (-(probeVars[admsProbeID_V_si_s])*modelStruct.d_modelPar_rsu_dX/modelStruct.modelPar_rsu/modelStruct.modelPar_rsu);
// I(si,s) <+ (ddt((csu*V(si,s))))
d_dynamicContributions_dX[admsNodeID_si]+= (modelStruct.d_modelPar_csu_dX*(probeVars[admsProbeID_V_si_s]));
d_dynamicContributions_dX[(admsNodeID_s)]-= (modelStruct.d_modelPar_csu_dX*(probeVars[admsProbeID_V_si_s]));
}
else
{
// V(si,s) <+ (0.0)
// do nothing at all
}
if (((modelStruct.modelPar_flsh==0)||(modelStruct.modelPar_rth<0.001)))
{
// I(tnode,GND) <+ ((V(tnode,GND)/0.001))
d_staticContributions_dX[admsNodeID_tnode]+= 0.0;
}
else
{
// I(tnode,GND) <+ (((V(tnode,GND)/rth_t)-pterm))
d_staticContributions_dX[admsNodeID_tnode]+= ((-(probeVars[admsProbeID_V_tnode_GND])*instanceStruct.d_instanceVar_rth_t_dX/instanceStruct.instanceVar_rth_t/instanceStruct.instanceVar_rth_t)-d_pterm_dX);
// I(tnode,GND) <+ (ddt((cth*V(tnode,GND))))
d_dynamicContributions_dX[admsNodeID_tnode]+= (modelStruct.d_modelPar_cth_dX*(probeVars[admsProbeID_V_tnode_GND]));
}
// I(xf1,GND) <+ (Ixf1)
d_staticContributions_dX[admsNodeID_xf1]+= d_Ixf1_dX;
// I(xf1,GND) <+ (ddt(Qxf1))
d_dynamicContributions_dX[admsNodeID_xf1]+= (d_Qxf1_dX);
// I(xf2,GND) <+ (Ixf2)
d_staticContributions_dX[admsNodeID_xf2]+= d_Ixf2_dX;
// I(xf2,GND) <+ (ddt(Qxf2))
d_dynamicContributions_dX[admsNodeID_xf2]+= (d_Qxf2_dX);
// I(xf,GND) <+ (Ixf)
d_staticContributions_dX[admsNodeID_xf]+= d_Ixf_dX;
// I(xf,GND) <+ (ddt(Qxf))
d_dynamicContributions_dX[admsNodeID_xf]+= (d_Qxf_dX);
}
// End block Load_sources
//Begin block OPERATING_POINT
{
//Block-local variables for block OPERATING_POINT
double gPIi=0.0;
double d_gPIi_dX=0.0;
double gPIx=0.0;
double d_gPIx_dX=0.0;
double gBt=0.0;
double d_gBt_dX=0.0;
//End of Block-local variables
//Block-local variables for block OPERATING_POINT
double gMUi=0.0;
double d_gMUi_dX=0.0;
double gMUx=0.0;
double d_gMUx_dX=0.0;
double gAVL=0.0;
double d_gAVL_dX=0.0;
//End of Block-local variables
//Block-local variables for block OPERATING_POINT
double gOi=0.0;
double d_gOi_dX=0.0;
//End of Block-local variables
//Block-local variables for block OPERATING_POINT
double CdEi_ddx=0.0;
double d_CdEi_ddx_dX=0.0;
double CdCi_ddx=0.0;
double d_CdCi_ddx_dX=0.0;
double CdS_ddx=0.0;
double d_CdS_ddx_dX=0.0;
//End of Block-local variables
d_gPIi_dX = 0.0;
gPIi = (((modelStruct.modelPar_type*0.0 /*FIXME: ddx(ibei,V(bi,GND)) not implemented in sensitivity context */)+(modelStruct.modelPar_type*0.0 /*FIXME: ddx(irei,V(bi,GND)) not implemented in sensitivity context */))+ADMSgmin_arg);
d_gPIx_dX = 0.0;
gPIx = (((modelStruct.modelPar_type*0.0 /*FIXME: ddx(ibep,V(bp,GND)) not implemented in sensitivity context */)+(modelStruct.modelPar_type*0.0 /*FIXME: ddx(irep,V(bp,GND)) not implemented in sensitivity context */))+ADMSgmin_arg);
if ((modelStruct.modelPar_tunode==1))
{
d_gBt_dX = 0.0;
gBt = (modelStruct.modelPar_type*0.0 /*FIXME: ddx(ibet,V(bp,GND)) not implemented in sensitivity context */);
}
else
{
d_gBt_dX = 0.0;
gBt = (modelStruct.modelPar_type*0.0 /*FIXME: ddx(ibet,V(bi,GND)) not implemented in sensitivity context */);
}
d_gMUi_dX = 0.0;
gMUi = (((-modelStruct.modelPar_type)*0.0 /*FIXME: ddx(ibci,V(ci,GND)) not implemented in sensitivity context */)+ADMSgmin_arg);
d_gMUx_dX = 0.0;
gMUx = (((-modelStruct.modelPar_type)*0.0 /*FIXME: ddx(ijbcx,V(ci,GND)) not implemented in sensitivity context */)+ADMSgmin_arg);
d_gAVL_dX = 0.0;
gAVL = ((modelStruct.modelPar_type*0.0 /*FIXME: ddx(iavl,V(ci,GND)) not implemented in sensitivity context */)+ADMSgmin_arg);
d_gOi_dX = 0.0;
gOi = (modelStruct.modelPar_type*0.0 /*FIXME: ddx(it,V(ci,GND)) not implemented in sensitivity context */);
d_CdEi_ddx_dX = 0.0;
CdEi_ddx = ((-modelStruct.modelPar_type)*0.0 /*FIXME: ddx(Qdei,V(ei,GND)) not implemented in sensitivity context */);
d_CdCi_ddx_dX = 0.0;
CdCi_ddx = ((-modelStruct.modelPar_type)*0.0 /*FIXME: ddx(Qdci,V(ci,GND)) not implemented in sensitivity context */);
d_CdS_ddx_dX = 0.0;
CdS_ddx = ((-modelStruct.modelPar_type)*0.0 /*FIXME: ddx(Qdsu,V(ci,GND)) not implemented in sensitivity context */);
if (((gPIi+gPIx)>0.0))
{
}
else
{
}
}
// End block OPERATING_POINT
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(15+0);
dqdp.resize(15+0);
Findices.resize(15+0);
Qindices.resize(15+0);

std::vector <double> probeVars(27);
std::vector <double> d_staticContributions_dX(15+0);
std::vector <double> d_dynamicContributions_dX(15+0);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 15+0 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_c10=mod.c10;
modelStruct.d_modelPar_c10_dX=0.0;
modelStruct.modelPar_given_c10=mod.given("c10");
modelStruct.modelPar_qp0=mod.qp0;
modelStruct.d_modelPar_qp0_dX=0.0;
modelStruct.modelPar_given_qp0=mod.given("qp0");
modelStruct.modelPar_ich=mod.ich;
modelStruct.d_modelPar_ich_dX=0.0;
modelStruct.modelPar_given_ich=mod.given("ich");
modelStruct.modelPar_hf0=mod.hf0;
modelStruct.d_modelPar_hf0_dX=0.0;
modelStruct.modelPar_given_hf0=mod.given("hf0");
modelStruct.modelPar_hfe=mod.hfe;
modelStruct.d_modelPar_hfe_dX=0.0;
modelStruct.modelPar_given_hfe=mod.given("hfe");
modelStruct.modelPar_hfc=mod.hfc;
modelStruct.d_modelPar_hfc_dX=0.0;
modelStruct.modelPar_given_hfc=mod.given("hfc");
modelStruct.modelPar_hjei=mod.hjei;
modelStruct.d_modelPar_hjei_dX=0.0;
modelStruct.modelPar_given_hjei=mod.given("hjei");
modelStruct.modelPar_ahjei=mod.ahjei;
modelStruct.d_modelPar_ahjei_dX=0.0;
modelStruct.modelPar_given_ahjei=mod.given("ahjei");
modelStruct.modelPar_rhjei=mod.rhjei;
modelStruct.d_modelPar_rhjei_dX=0.0;
modelStruct.modelPar_given_rhjei=mod.given("rhjei");
modelStruct.modelPar_hjci=mod.hjci;
modelStruct.d_modelPar_hjci_dX=0.0;
modelStruct.modelPar_given_hjci=mod.given("hjci");
modelStruct.modelPar_ibeis=mod.ibeis;
modelStruct.d_modelPar_ibeis_dX=0.0;
modelStruct.modelPar_given_ibeis=mod.given("ibeis");
modelStruct.modelPar_mbei=mod.mbei;
modelStruct.d_modelPar_mbei_dX=0.0;
modelStruct.modelPar_given_mbei=mod.given("mbei");
modelStruct.modelPar_ireis=mod.ireis;
modelStruct.d_modelPar_ireis_dX=0.0;
modelStruct.modelPar_given_ireis=mod.given("ireis");
modelStruct.modelPar_mrei=mod.mrei;
modelStruct.d_modelPar_mrei_dX=0.0;
modelStruct.modelPar_given_mrei=mod.given("mrei");
modelStruct.modelPar_ibeps=mod.ibeps;
modelStruct.d_modelPar_ibeps_dX=0.0;
modelStruct.modelPar_given_ibeps=mod.given("ibeps");
modelStruct.modelPar_mbep=mod.mbep;
modelStruct.d_modelPar_mbep_dX=0.0;
modelStruct.modelPar_given_mbep=mod.given("mbep");
modelStruct.modelPar_ireps=mod.ireps;
modelStruct.d_modelPar_ireps_dX=0.0;
modelStruct.modelPar_given_ireps=mod.given("ireps");
modelStruct.modelPar_mrep=mod.mrep;
modelStruct.d_modelPar_mrep_dX=0.0;
modelStruct.modelPar_given_mrep=mod.given("mrep");
modelStruct.modelPar_mcf=mod.mcf;
modelStruct.d_modelPar_mcf_dX=0.0;
modelStruct.modelPar_given_mcf=mod.given("mcf");
modelStruct.modelPar_tbhrec=mod.tbhrec;
modelStruct.d_modelPar_tbhrec_dX=0.0;
modelStruct.modelPar_given_tbhrec=mod.given("tbhrec");
modelStruct.modelPar_ibcis=mod.ibcis;
modelStruct.d_modelPar_ibcis_dX=0.0;
modelStruct.modelPar_given_ibcis=mod.given("ibcis");
modelStruct.modelPar_mbci=mod.mbci;
modelStruct.d_modelPar_mbci_dX=0.0;
modelStruct.modelPar_given_mbci=mod.given("mbci");
modelStruct.modelPar_ibcxs=mod.ibcxs;
modelStruct.d_modelPar_ibcxs_dX=0.0;
modelStruct.modelPar_given_ibcxs=mod.given("ibcxs");
modelStruct.modelPar_mbcx=mod.mbcx;
modelStruct.d_modelPar_mbcx_dX=0.0;
modelStruct.modelPar_given_mbcx=mod.given("mbcx");
modelStruct.modelPar_ibets=mod.ibets;
modelStruct.d_modelPar_ibets_dX=0.0;
modelStruct.modelPar_given_ibets=mod.given("ibets");
modelStruct.modelPar_abet=mod.abet;
modelStruct.d_modelPar_abet_dX=0.0;
modelStruct.modelPar_given_abet=mod.given("abet");
modelStruct.modelPar_favl=mod.favl;
modelStruct.d_modelPar_favl_dX=0.0;
modelStruct.modelPar_given_favl=mod.given("favl");
modelStruct.modelPar_qavl=mod.qavl;
modelStruct.d_modelPar_qavl_dX=0.0;
modelStruct.modelPar_given_qavl=mod.given("qavl");
modelStruct.modelPar_kavl=mod.kavl;
modelStruct.d_modelPar_kavl_dX=0.0;
modelStruct.modelPar_given_kavl=mod.given("kavl");
modelStruct.modelPar_alfav=mod.alfav;
modelStruct.d_modelPar_alfav_dX=0.0;
modelStruct.modelPar_given_alfav=mod.given("alfav");
modelStruct.modelPar_alqav=mod.alqav;
modelStruct.d_modelPar_alqav_dX=0.0;
modelStruct.modelPar_given_alqav=mod.given("alqav");
modelStruct.modelPar_alkav=mod.alkav;
modelStruct.d_modelPar_alkav_dX=0.0;
modelStruct.modelPar_given_alkav=mod.given("alkav");
modelStruct.modelPar_rbi0=mod.rbi0;
modelStruct.d_modelPar_rbi0_dX=0.0;
modelStruct.modelPar_given_rbi0=mod.given("rbi0");
modelStruct.modelPar_rbx=mod.rbx;
modelStruct.d_modelPar_rbx_dX=0.0;
modelStruct.modelPar_given_rbx=mod.given("rbx");
modelStruct.modelPar_fgeo=mod.fgeo;
modelStruct.d_modelPar_fgeo_dX=0.0;
modelStruct.modelPar_given_fgeo=mod.given("fgeo");
modelStruct.modelPar_fdqr0=mod.fdqr0;
modelStruct.d_modelPar_fdqr0_dX=0.0;
modelStruct.modelPar_given_fdqr0=mod.given("fdqr0");
modelStruct.modelPar_fcrbi=mod.fcrbi;
modelStruct.d_modelPar_fcrbi_dX=0.0;
modelStruct.modelPar_given_fcrbi=mod.given("fcrbi");
modelStruct.modelPar_fqi=mod.fqi;
modelStruct.d_modelPar_fqi_dX=0.0;
modelStruct.modelPar_given_fqi=mod.given("fqi");
modelStruct.modelPar_re=mod.re;
modelStruct.d_modelPar_re_dX=0.0;
modelStruct.modelPar_given_re=mod.given("re");
modelStruct.modelPar_rcx=mod.rcx;
modelStruct.d_modelPar_rcx_dX=0.0;
modelStruct.modelPar_given_rcx=mod.given("rcx");
modelStruct.modelPar_itss=mod.itss;
modelStruct.d_modelPar_itss_dX=0.0;
modelStruct.modelPar_given_itss=mod.given("itss");
modelStruct.modelPar_msf=mod.msf;
modelStruct.d_modelPar_msf_dX=0.0;
modelStruct.modelPar_given_msf=mod.given("msf");
modelStruct.modelPar_iscs=mod.iscs;
modelStruct.d_modelPar_iscs_dX=0.0;
modelStruct.modelPar_given_iscs=mod.given("iscs");
modelStruct.modelPar_msc=mod.msc;
modelStruct.d_modelPar_msc_dX=0.0;
modelStruct.modelPar_given_msc=mod.given("msc");
modelStruct.modelPar_tsf=mod.tsf;
modelStruct.d_modelPar_tsf_dX=0.0;
modelStruct.modelPar_given_tsf=mod.given("tsf");
modelStruct.modelPar_rsu=mod.rsu;
modelStruct.d_modelPar_rsu_dX=0.0;
modelStruct.modelPar_given_rsu=mod.given("rsu");
modelStruct.modelPar_csu=mod.csu;
modelStruct.d_modelPar_csu_dX=0.0;
modelStruct.modelPar_given_csu=mod.given("csu");
modelStruct.modelPar_cjei0=mod.cjei0;
modelStruct.d_modelPar_cjei0_dX=0.0;
modelStruct.modelPar_given_cjei0=mod.given("cjei0");
modelStruct.modelPar_vdei=mod.vdei;
modelStruct.d_modelPar_vdei_dX=0.0;
modelStruct.modelPar_given_vdei=mod.given("vdei");
modelStruct.modelPar_zei=mod.zei;
modelStruct.d_modelPar_zei_dX=0.0;
modelStruct.modelPar_given_zei=mod.given("zei");
modelStruct.modelPar_ajei=mod.ajei;
modelStruct.d_modelPar_ajei_dX=0.0;
modelStruct.modelPar_given_ajei=mod.given("ajei");
modelStruct.modelPar_cjep0=mod.cjep0;
modelStruct.d_modelPar_cjep0_dX=0.0;
modelStruct.modelPar_given_cjep0=mod.given("cjep0");
modelStruct.modelPar_vdep=mod.vdep;
modelStruct.d_modelPar_vdep_dX=0.0;
modelStruct.modelPar_given_vdep=mod.given("vdep");
modelStruct.modelPar_zep=mod.zep;
modelStruct.d_modelPar_zep_dX=0.0;
modelStruct.modelPar_given_zep=mod.given("zep");
modelStruct.modelPar_ajep=mod.ajep;
modelStruct.d_modelPar_ajep_dX=0.0;
modelStruct.modelPar_given_ajep=mod.given("ajep");
modelStruct.modelPar_cjci0=mod.cjci0;
modelStruct.d_modelPar_cjci0_dX=0.0;
modelStruct.modelPar_given_cjci0=mod.given("cjci0");
modelStruct.modelPar_vdci=mod.vdci;
modelStruct.d_modelPar_vdci_dX=0.0;
modelStruct.modelPar_given_vdci=mod.given("vdci");
modelStruct.modelPar_zci=mod.zci;
modelStruct.d_modelPar_zci_dX=0.0;
modelStruct.modelPar_given_zci=mod.given("zci");
modelStruct.modelPar_vptci=mod.vptci;
modelStruct.d_modelPar_vptci_dX=0.0;
modelStruct.modelPar_given_vptci=mod.given("vptci");
modelStruct.modelPar_cjcx0=mod.cjcx0;
modelStruct.d_modelPar_cjcx0_dX=0.0;
modelStruct.modelPar_given_cjcx0=mod.given("cjcx0");
modelStruct.modelPar_vdcx=mod.vdcx;
modelStruct.d_modelPar_vdcx_dX=0.0;
modelStruct.modelPar_given_vdcx=mod.given("vdcx");
modelStruct.modelPar_zcx=mod.zcx;
modelStruct.d_modelPar_zcx_dX=0.0;
modelStruct.modelPar_given_zcx=mod.given("zcx");
modelStruct.modelPar_vptcx=mod.vptcx;
modelStruct.d_modelPar_vptcx_dX=0.0;
modelStruct.modelPar_given_vptcx=mod.given("vptcx");
modelStruct.modelPar_fbcpar=mod.fbcpar;
modelStruct.d_modelPar_fbcpar_dX=0.0;
modelStruct.modelPar_given_fbcpar=mod.given("fbcpar");
modelStruct.modelPar_fbepar=mod.fbepar;
modelStruct.d_modelPar_fbepar_dX=0.0;
modelStruct.modelPar_given_fbepar=mod.given("fbepar");
modelStruct.modelPar_cjs0=mod.cjs0;
modelStruct.d_modelPar_cjs0_dX=0.0;
modelStruct.modelPar_given_cjs0=mod.given("cjs0");
modelStruct.modelPar_vds=mod.vds;
modelStruct.d_modelPar_vds_dX=0.0;
modelStruct.modelPar_given_vds=mod.given("vds");
modelStruct.modelPar_zs=mod.zs;
modelStruct.d_modelPar_zs_dX=0.0;
modelStruct.modelPar_given_zs=mod.given("zs");
modelStruct.modelPar_vpts=mod.vpts;
modelStruct.d_modelPar_vpts_dX=0.0;
modelStruct.modelPar_given_vpts=mod.given("vpts");
modelStruct.modelPar_cscp0=mod.cscp0;
modelStruct.d_modelPar_cscp0_dX=0.0;
modelStruct.modelPar_given_cscp0=mod.given("cscp0");
modelStruct.modelPar_vdsp=mod.vdsp;
modelStruct.d_modelPar_vdsp_dX=0.0;
modelStruct.modelPar_given_vdsp=mod.given("vdsp");
modelStruct.modelPar_zsp=mod.zsp;
modelStruct.d_modelPar_zsp_dX=0.0;
modelStruct.modelPar_given_zsp=mod.given("zsp");
modelStruct.modelPar_vptsp=mod.vptsp;
modelStruct.d_modelPar_vptsp_dX=0.0;
modelStruct.modelPar_given_vptsp=mod.given("vptsp");
modelStruct.modelPar_t0=mod.t0;
modelStruct.d_modelPar_t0_dX=0.0;
modelStruct.modelPar_given_t0=mod.given("t0");
modelStruct.modelPar_dt0h=mod.dt0h;
modelStruct.d_modelPar_dt0h_dX=0.0;
modelStruct.modelPar_given_dt0h=mod.given("dt0h");
modelStruct.modelPar_tbvl=mod.tbvl;
modelStruct.d_modelPar_tbvl_dX=0.0;
modelStruct.modelPar_given_tbvl=mod.given("tbvl");
modelStruct.modelPar_tef0=mod.tef0;
modelStruct.d_modelPar_tef0_dX=0.0;
modelStruct.modelPar_given_tef0=mod.given("tef0");
modelStruct.modelPar_gtfe=mod.gtfe;
modelStruct.d_modelPar_gtfe_dX=0.0;
modelStruct.modelPar_given_gtfe=mod.given("gtfe");
modelStruct.modelPar_thcs=mod.thcs;
modelStruct.d_modelPar_thcs_dX=0.0;
modelStruct.modelPar_given_thcs=mod.given("thcs");
modelStruct.modelPar_ahc=mod.ahc;
modelStruct.d_modelPar_ahc_dX=0.0;
modelStruct.modelPar_given_ahc=mod.given("ahc");
modelStruct.modelPar_fthc=mod.fthc;
modelStruct.d_modelPar_fthc_dX=0.0;
modelStruct.modelPar_given_fthc=mod.given("fthc");
modelStruct.modelPar_rci0=mod.rci0;
modelStruct.d_modelPar_rci0_dX=0.0;
modelStruct.modelPar_given_rci0=mod.given("rci0");
modelStruct.modelPar_vlim=mod.vlim;
modelStruct.d_modelPar_vlim_dX=0.0;
modelStruct.modelPar_given_vlim=mod.given("vlim");
modelStruct.modelPar_vces=mod.vces;
modelStruct.d_modelPar_vces_dX=0.0;
modelStruct.modelPar_given_vces=mod.given("vces");
modelStruct.modelPar_vpt=mod.vpt;
modelStruct.d_modelPar_vpt_dX=0.0;
modelStruct.modelPar_given_vpt=mod.given("vpt");
modelStruct.modelPar_aick=mod.aick;
modelStruct.d_modelPar_aick_dX=0.0;
modelStruct.modelPar_given_aick=mod.given("aick");
modelStruct.modelPar_delck=mod.delck;
modelStruct.d_modelPar_delck_dX=0.0;
modelStruct.modelPar_given_delck=mod.given("delck");
modelStruct.modelPar_tr=mod.tr;
modelStruct.d_modelPar_tr_dX=0.0;
modelStruct.modelPar_given_tr=mod.given("tr");
modelStruct.modelPar_vcbar=mod.vcbar;
modelStruct.d_modelPar_vcbar_dX=0.0;
modelStruct.modelPar_given_vcbar=mod.given("vcbar");
modelStruct.modelPar_icbar=mod.icbar;
modelStruct.d_modelPar_icbar_dX=0.0;
modelStruct.modelPar_given_icbar=mod.given("icbar");
modelStruct.modelPar_acbar=mod.acbar;
modelStruct.d_modelPar_acbar_dX=0.0;
modelStruct.modelPar_given_acbar=mod.given("acbar");
modelStruct.modelPar_cbepar=mod.cbepar;
modelStruct.d_modelPar_cbepar_dX=0.0;
modelStruct.modelPar_given_cbepar=mod.given("cbepar");
modelStruct.modelPar_cbcpar=mod.cbcpar;
modelStruct.d_modelPar_cbcpar_dX=0.0;
modelStruct.modelPar_given_cbcpar=mod.given("cbcpar");
modelStruct.modelPar_alqf=mod.alqf;
modelStruct.d_modelPar_alqf_dX=0.0;
modelStruct.modelPar_given_alqf=mod.given("alqf");
modelStruct.modelPar_alit=mod.alit;
modelStruct.d_modelPar_alit_dX=0.0;
modelStruct.modelPar_given_alit=mod.given("alit");
modelStruct.modelPar_kf=mod.kf;
modelStruct.d_modelPar_kf_dX=0.0;
modelStruct.modelPar_given_kf=mod.given("kf");
modelStruct.modelPar_af=mod.af;
modelStruct.d_modelPar_af_dX=0.0;
modelStruct.modelPar_given_af=mod.given("af");
modelStruct.modelPar_kfre=mod.kfre;
modelStruct.d_modelPar_kfre_dX=0.0;
modelStruct.modelPar_given_kfre=mod.given("kfre");
modelStruct.modelPar_afre=mod.afre;
modelStruct.d_modelPar_afre_dX=0.0;
modelStruct.modelPar_given_afre=mod.given("afre");
modelStruct.modelPar_latb=mod.latb;
modelStruct.d_modelPar_latb_dX=0.0;
modelStruct.modelPar_given_latb=mod.given("latb");
modelStruct.modelPar_latl=mod.latl;
modelStruct.d_modelPar_latl_dX=0.0;
modelStruct.modelPar_given_latl=mod.given("latl");
modelStruct.modelPar_vgb=mod.vgb;
modelStruct.d_modelPar_vgb_dX=0.0;
modelStruct.modelPar_given_vgb=mod.given("vgb");
modelStruct.modelPar_alt0=mod.alt0;
modelStruct.d_modelPar_alt0_dX=0.0;
modelStruct.modelPar_given_alt0=mod.given("alt0");
modelStruct.modelPar_kt0=mod.kt0;
modelStruct.d_modelPar_kt0_dX=0.0;
modelStruct.modelPar_given_kt0=mod.given("kt0");
modelStruct.modelPar_zetaci=mod.zetaci;
modelStruct.d_modelPar_zetaci_dX=0.0;
modelStruct.modelPar_given_zetaci=mod.given("zetaci");
modelStruct.modelPar_alvs=mod.alvs;
modelStruct.d_modelPar_alvs_dX=0.0;
modelStruct.modelPar_given_alvs=mod.given("alvs");
modelStruct.modelPar_alces=mod.alces;
modelStruct.d_modelPar_alces_dX=0.0;
modelStruct.modelPar_given_alces=mod.given("alces");
modelStruct.modelPar_zetarbi=mod.zetarbi;
modelStruct.d_modelPar_zetarbi_dX=0.0;
modelStruct.modelPar_given_zetarbi=mod.given("zetarbi");
modelStruct.modelPar_zetarbx=mod.zetarbx;
modelStruct.d_modelPar_zetarbx_dX=0.0;
modelStruct.modelPar_given_zetarbx=mod.given("zetarbx");
modelStruct.modelPar_zetarcx=mod.zetarcx;
modelStruct.d_modelPar_zetarcx_dX=0.0;
modelStruct.modelPar_given_zetarcx=mod.given("zetarcx");
modelStruct.modelPar_zetare=mod.zetare;
modelStruct.d_modelPar_zetare_dX=0.0;
modelStruct.modelPar_given_zetare=mod.given("zetare");
modelStruct.modelPar_zetacx=mod.zetacx;
modelStruct.d_modelPar_zetacx_dX=0.0;
modelStruct.modelPar_given_zetacx=mod.given("zetacx");
modelStruct.modelPar_vge=mod.vge;
modelStruct.d_modelPar_vge_dX=0.0;
modelStruct.modelPar_given_vge=mod.given("vge");
modelStruct.modelPar_vgc=mod.vgc;
modelStruct.d_modelPar_vgc_dX=0.0;
modelStruct.modelPar_given_vgc=mod.given("vgc");
modelStruct.modelPar_vgs=mod.vgs;
modelStruct.d_modelPar_vgs_dX=0.0;
modelStruct.modelPar_given_vgs=mod.given("vgs");
modelStruct.modelPar_f1vg=mod.f1vg;
modelStruct.d_modelPar_f1vg_dX=0.0;
modelStruct.modelPar_given_f1vg=mod.given("f1vg");
modelStruct.modelPar_f2vg=mod.f2vg;
modelStruct.d_modelPar_f2vg_dX=0.0;
modelStruct.modelPar_given_f2vg=mod.given("f2vg");
modelStruct.modelPar_zetact=mod.zetact;
modelStruct.d_modelPar_zetact_dX=0.0;
modelStruct.modelPar_given_zetact=mod.given("zetact");
modelStruct.modelPar_zetabet=mod.zetabet;
modelStruct.d_modelPar_zetabet_dX=0.0;
modelStruct.modelPar_given_zetabet=mod.given("zetabet");
modelStruct.modelPar_alb=mod.alb;
modelStruct.d_modelPar_alb_dX=0.0;
modelStruct.modelPar_given_alb=mod.given("alb");
modelStruct.modelPar_dvgbe=mod.dvgbe;
modelStruct.d_modelPar_dvgbe_dX=0.0;
modelStruct.modelPar_given_dvgbe=mod.given("dvgbe");
modelStruct.modelPar_zetahjei=mod.zetahjei;
modelStruct.d_modelPar_zetahjei_dX=0.0;
modelStruct.modelPar_given_zetahjei=mod.given("zetahjei");
modelStruct.modelPar_zetavgbe=mod.zetavgbe;
modelStruct.d_modelPar_zetavgbe_dX=0.0;
modelStruct.modelPar_given_zetavgbe=mod.given("zetavgbe");
modelStruct.modelPar_rth=mod.rth;
modelStruct.d_modelPar_rth_dX=0.0;
modelStruct.modelPar_given_rth=mod.given("rth");
modelStruct.modelPar_zetarth=mod.zetarth;
modelStruct.d_modelPar_zetarth_dX=0.0;
modelStruct.modelPar_given_zetarth=mod.given("zetarth");
modelStruct.modelPar_alrth=mod.alrth;
modelStruct.d_modelPar_alrth_dX=0.0;
modelStruct.modelPar_given_alrth=mod.given("alrth");
modelStruct.modelPar_cth=mod.cth;
modelStruct.d_modelPar_cth_dX=0.0;
modelStruct.modelPar_given_cth=mod.given("cth");
modelStruct.modelPar_flcomp=mod.flcomp;
modelStruct.d_modelPar_flcomp_dX=0.0;
modelStruct.modelPar_given_flcomp=mod.given("flcomp");
modelStruct.modelPar_tnom=mod.tnom;
modelStruct.d_modelPar_tnom_dX=0.0;
modelStruct.modelPar_given_tnom=mod.given("tnom");
modelStruct.modelPar_dt=mod.dt;
modelStruct.d_modelPar_dt_dX=0.0;
modelStruct.modelPar_given_dt=mod.given("dt");


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_tunode=mod.tunode;
modelStruct.modelPar_given_tunode=mod.given("tunode");
modelStruct.modelPar_flnqs=mod.flnqs;
modelStruct.modelPar_given_flnqs=mod.given("flnqs");
modelStruct.modelPar_cfbe=mod.cfbe;
modelStruct.modelPar_given_cfbe=mod.given("cfbe");
modelStruct.modelPar_flcono=mod.flcono;
modelStruct.modelPar_given_flcono=mod.given("flcono");
modelStruct.modelPar_flsh=mod.flsh;
modelStruct.modelPar_given_flsh=mod.given("flsh");
modelStruct.modelPar_type=mod.type;
modelStruct.modelPar_given_type=mod.given("type");



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals
instanceStruct.instanceVar_VT=in.VT;
instanceStruct.d_instanceVar_VT_dX=0.0;
instanceStruct.instanceVar_Tdev=in.Tdev;
instanceStruct.d_instanceVar_Tdev_dX=0.0;
instanceStruct.instanceVar_qtt0=in.qtt0;
instanceStruct.d_instanceVar_qtt0_dX=0.0;
instanceStruct.instanceVar_ln_qtt0=in.ln_qtt0;
instanceStruct.d_instanceVar_ln_qtt0_dX=0.0;
instanceStruct.instanceVar_r_VgVT=in.r_VgVT;
instanceStruct.d_instanceVar_r_VgVT_dX=0.0;
instanceStruct.instanceVar_V_gT=in.V_gT;
instanceStruct.d_instanceVar_V_gT_dX=0.0;
instanceStruct.instanceVar_dT=in.dT;
instanceStruct.d_instanceVar_dT_dX=0.0;
instanceStruct.instanceVar_k=in.k;
instanceStruct.d_instanceVar_k_dX=0.0;
instanceStruct.instanceVar_ireis_t=in.ireis_t;
instanceStruct.d_instanceVar_ireis_t_dX=0.0;
instanceStruct.instanceVar_ibeis_t=in.ibeis_t;
instanceStruct.d_instanceVar_ibeis_t_dX=0.0;
instanceStruct.instanceVar_ibcxs_t=in.ibcxs_t;
instanceStruct.d_instanceVar_ibcxs_t_dX=0.0;
instanceStruct.instanceVar_ibcis_t=in.ibcis_t;
instanceStruct.d_instanceVar_ibcis_t_dX=0.0;
instanceStruct.instanceVar_iscs_t=in.iscs_t;
instanceStruct.d_instanceVar_iscs_t_dX=0.0;
instanceStruct.instanceVar_cjci0_t=in.cjci0_t;
instanceStruct.d_instanceVar_cjci0_t_dX=0.0;
instanceStruct.instanceVar_cjs0_t=in.cjs0_t;
instanceStruct.d_instanceVar_cjs0_t_dX=0.0;
instanceStruct.instanceVar_cscp0_t=in.cscp0_t;
instanceStruct.d_instanceVar_cscp0_t_dX=0.0;
instanceStruct.instanceVar_rci0_t=in.rci0_t;
instanceStruct.d_instanceVar_rci0_t_dX=0.0;
instanceStruct.instanceVar_vlim_t=in.vlim_t;
instanceStruct.d_instanceVar_vlim_t_dX=0.0;
instanceStruct.instanceVar_vces_t=in.vces_t;
instanceStruct.d_instanceVar_vces_t_dX=0.0;
instanceStruct.instanceVar_thcs_t=in.thcs_t;
instanceStruct.d_instanceVar_thcs_t_dX=0.0;
instanceStruct.instanceVar_tef0_t=in.tef0_t;
instanceStruct.d_instanceVar_tef0_t_dX=0.0;
instanceStruct.instanceVar_rbi0_t=in.rbi0_t;
instanceStruct.d_instanceVar_rbi0_t_dX=0.0;
instanceStruct.instanceVar_t0_t=in.t0_t;
instanceStruct.d_instanceVar_t0_t_dX=0.0;
instanceStruct.instanceVar_vdei_t=in.vdei_t;
instanceStruct.d_instanceVar_vdei_t_dX=0.0;
instanceStruct.instanceVar_vdci_t=in.vdci_t;
instanceStruct.d_instanceVar_vdci_t_dX=0.0;
instanceStruct.instanceVar_vpts_t=in.vpts_t;
instanceStruct.d_instanceVar_vpts_t_dX=0.0;
instanceStruct.instanceVar_vptsp_t=in.vptsp_t;
instanceStruct.d_instanceVar_vptsp_t_dX=0.0;
instanceStruct.instanceVar_itss_t=in.itss_t;
instanceStruct.d_instanceVar_itss_t_dX=0.0;
instanceStruct.instanceVar_tsf_t=in.tsf_t;
instanceStruct.d_instanceVar_tsf_t_dX=0.0;
instanceStruct.instanceVar_c10_t=in.c10_t;
instanceStruct.d_instanceVar_c10_t_dX=0.0;
instanceStruct.instanceVar_cjei0_t=in.cjei0_t;
instanceStruct.d_instanceVar_cjei0_t_dX=0.0;
instanceStruct.instanceVar_qp0_t=in.qp0_t;
instanceStruct.d_instanceVar_qp0_t_dX=0.0;
instanceStruct.instanceVar_vdcx_t=in.vdcx_t;
instanceStruct.d_instanceVar_vdcx_t_dX=0.0;
instanceStruct.instanceVar_vptcx_t=in.vptcx_t;
instanceStruct.d_instanceVar_vptcx_t_dX=0.0;
instanceStruct.instanceVar_cjcx01_t=in.cjcx01_t;
instanceStruct.d_instanceVar_cjcx01_t_dX=0.0;
instanceStruct.instanceVar_cjcx02_t=in.cjcx02_t;
instanceStruct.d_instanceVar_cjcx02_t_dX=0.0;
instanceStruct.instanceVar_cratio_t=in.cratio_t;
instanceStruct.d_instanceVar_cratio_t_dX=0.0;
instanceStruct.instanceVar_ibeps_t=in.ibeps_t;
instanceStruct.d_instanceVar_ibeps_t_dX=0.0;
instanceStruct.instanceVar_ireps_t=in.ireps_t;
instanceStruct.d_instanceVar_ireps_t_dX=0.0;
instanceStruct.instanceVar_cjep0_t=in.cjep0_t;
instanceStruct.d_instanceVar_cjep0_t_dX=0.0;
instanceStruct.instanceVar_ajei_t=in.ajei_t;
instanceStruct.d_instanceVar_ajei_t_dX=0.0;
instanceStruct.instanceVar_qavl_t=in.qavl_t;
instanceStruct.d_instanceVar_qavl_t_dX=0.0;
instanceStruct.instanceVar_favl_t=in.favl_t;
instanceStruct.d_instanceVar_favl_t_dX=0.0;
instanceStruct.instanceVar_kavl_t=in.kavl_t;
instanceStruct.d_instanceVar_kavl_t_dX=0.0;
instanceStruct.instanceVar_ibets_t=in.ibets_t;
instanceStruct.d_instanceVar_ibets_t_dX=0.0;
instanceStruct.instanceVar_abet_t=in.abet_t;
instanceStruct.d_instanceVar_abet_t_dX=0.0;
instanceStruct.instanceVar_vptci_t=in.vptci_t;
instanceStruct.d_instanceVar_vptci_t_dX=0.0;
instanceStruct.instanceVar_vdep_t=in.vdep_t;
instanceStruct.d_instanceVar_vdep_t_dX=0.0;
instanceStruct.instanceVar_ajep_t=in.ajep_t;
instanceStruct.d_instanceVar_ajep_t_dX=0.0;
instanceStruct.instanceVar_zetatef=in.zetatef;
instanceStruct.d_instanceVar_zetatef_dX=0.0;
instanceStruct.instanceVar_k1=in.k1;
instanceStruct.d_instanceVar_k1_dX=0.0;
instanceStruct.instanceVar_k2=in.k2;
instanceStruct.d_instanceVar_k2_dX=0.0;
instanceStruct.instanceVar_dvg0=in.dvg0;
instanceStruct.d_instanceVar_dvg0_dX=0.0;
instanceStruct.instanceVar_vge_t=in.vge_t;
instanceStruct.d_instanceVar_vge_t_dX=0.0;
instanceStruct.instanceVar_vgb_t=in.vgb_t;
instanceStruct.d_instanceVar_vgb_t_dX=0.0;
instanceStruct.instanceVar_vgbe_t=in.vgbe_t;
instanceStruct.d_instanceVar_vgbe_t_dX=0.0;
instanceStruct.instanceVar_vds_t=in.vds_t;
instanceStruct.d_instanceVar_vds_t_dX=0.0;
instanceStruct.instanceVar_vdsp_t=in.vdsp_t;
instanceStruct.d_instanceVar_vdsp_t_dX=0.0;
instanceStruct.instanceVar_vt0=in.vt0;
instanceStruct.d_instanceVar_vt0_dX=0.0;
instanceStruct.instanceVar_Tnom=in.Tnom;
instanceStruct.d_instanceVar_Tnom_dX=0.0;
instanceStruct.instanceVar_Tamb=in.Tamb;
instanceStruct.instanceVar_a=in.a;
instanceStruct.d_instanceVar_a_dX=0.0;
instanceStruct.instanceVar_avs=in.avs;
instanceStruct.d_instanceVar_avs_dX=0.0;
instanceStruct.instanceVar_zetabci=in.zetabci;
instanceStruct.d_instanceVar_zetabci_dX=0.0;
instanceStruct.instanceVar_zetabcxt=in.zetabcxt;
instanceStruct.d_instanceVar_zetabcxt_dX=0.0;
instanceStruct.instanceVar_zetasct=in.zetasct;
instanceStruct.d_instanceVar_zetasct_dX=0.0;
instanceStruct.instanceVar_vgbe0=in.vgbe0;
instanceStruct.d_instanceVar_vgbe0_dX=0.0;
instanceStruct.instanceVar_mg=in.mg;
instanceStruct.d_instanceVar_mg_dX=0.0;
instanceStruct.instanceVar_vgbe_t0=in.vgbe_t0;
instanceStruct.d_instanceVar_vgbe_t0_dX=0.0;
instanceStruct.instanceVar_vgbc0=in.vgbc0;
instanceStruct.d_instanceVar_vgbc0_dX=0.0;
instanceStruct.instanceVar_vgsc0=in.vgsc0;
instanceStruct.d_instanceVar_vgsc0_dX=0.0;
instanceStruct.instanceVar_cbcpar1=in.cbcpar1;
instanceStruct.d_instanceVar_cbcpar1_dX=0.0;
instanceStruct.instanceVar_cbcpar2=in.cbcpar2;
instanceStruct.d_instanceVar_cbcpar2_dX=0.0;
instanceStruct.instanceVar_cbepar2=in.cbepar2;
instanceStruct.d_instanceVar_cbepar2_dX=0.0;
instanceStruct.instanceVar_cbepar1=in.cbepar1;
instanceStruct.d_instanceVar_cbepar1_dX=0.0;
instanceStruct.instanceVar_Oich=in.Oich;
instanceStruct.d_instanceVar_Oich_dX=0.0;
instanceStruct.instanceVar_Otbhrec=in.Otbhrec;
instanceStruct.d_instanceVar_Otbhrec_dX=0.0;
instanceStruct.instanceVar_it=in.it;
instanceStruct.d_instanceVar_it_dX=0.0;
instanceStruct.instanceVar_ibei=in.ibei;
instanceStruct.d_instanceVar_ibei_dX=0.0;
instanceStruct.instanceVar_ibci=in.ibci;
instanceStruct.d_instanceVar_ibci_dX=0.0;
instanceStruct.instanceVar_ibep=in.ibep;
instanceStruct.d_instanceVar_ibep_dX=0.0;
instanceStruct.instanceVar_iavl=in.iavl;
instanceStruct.d_instanceVar_iavl_dX=0.0;
instanceStruct.instanceVar_ijbcx=in.ijbcx;
instanceStruct.d_instanceVar_ijbcx_dX=0.0;
instanceStruct.instanceVar_ijsc=in.ijsc;
instanceStruct.d_instanceVar_ijsc_dX=0.0;
instanceStruct.instanceVar_rth_t=in.rth_t;
instanceStruct.d_instanceVar_rth_t_dX=0.0;
instanceStruct.instanceVar_vdj0=in.vdj0;
instanceStruct.d_instanceVar_vdj0_dX=0.0;
instanceStruct.instanceVar_vdjt=in.vdjt;
instanceStruct.d_instanceVar_vdjt_dX=0.0;
instanceStruct.instanceVar_vdt=in.vdt;
instanceStruct.d_instanceVar_vdt_dX=0.0;
instanceStruct.instanceVar_Tf=in.Tf;
instanceStruct.d_instanceVar_Tf_dX=0.0;
instanceStruct.instanceVar_cjcx01=in.cjcx01;
instanceStruct.d_instanceVar_cjcx01_dX=0.0;
instanceStruct.instanceVar_cjcx02=in.cjcx02;
instanceStruct.d_instanceVar_cjcx02_dX=0.0;
instanceStruct.instanceVar_betadc=in.betadc;
instanceStruct.d_instanceVar_betadc_dX=0.0;
instanceStruct.instanceVar_hjei0_t=in.hjei0_t;
instanceStruct.d_instanceVar_hjei0_t_dX=0.0;
instanceStruct.instanceVar_ahjei_t=in.ahjei_t;
instanceStruct.d_instanceVar_ahjei_t_dX=0.0;
instanceStruct.instanceVar_hf0_t=in.hf0_t;
instanceStruct.d_instanceVar_hf0_t_dX=0.0;
instanceStruct.instanceVar_hfe_t=in.hfe_t;
instanceStruct.d_instanceVar_hfe_t_dX=0.0;
instanceStruct.instanceVar_hfc_t=in.hfc_t;
instanceStruct.d_instanceVar_hfc_t_dX=0.0;
instanceStruct.instanceVar_rbx_t=in.rbx_t;
instanceStruct.d_instanceVar_rbx_t_dX=0.0;
instanceStruct.instanceVar_rcx_t=in.rcx_t;
instanceStruct.d_instanceVar_rcx_t_dX=0.0;
instanceStruct.instanceVar_re_t=in.re_t;
instanceStruct.d_instanceVar_re_t_dX=0.0;
instanceStruct.instanceVar_rbi=in.rbi;
instanceStruct.d_instanceVar_rbi_dX=0.0;


//non-reals
instanceStruct.instanceVar_use_aval=in.use_aval;


//make local copies of all model vars
//reals


// non-reals



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_ei_GND] = (*solVectorPtr)[in.li_ei];
probeVars[in.admsProbeID_V_bp_GND] = (*solVectorPtr)[in.li_bp];
probeVars[in.admsProbeID_V_ci_GND] = (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bi_GND] = (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_c_e] = (*solVectorPtr)[in.li_c]- (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_c];
probeVars[in.admsProbeID_V_n2_GND] = (*solVectorPtr)[in.li_n2];
probeVars[in.admsProbeID_V_n1_GND] = (*solVectorPtr)[in.li_n1];
probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_bp_e] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_ei];
probeVars[in.admsProbeID_V_xf_GND] = (*solVectorPtr)[in.li_xf];
probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
probeVars[in.admsProbeID_V_b_bp] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_bp];
probeVars[in.admsProbeID_V_ci_c] = (*solVectorPtr)[in.li_ci]- (*solVectorPtr)[in.li_c];
probeVars[in.admsProbeID_V_ei_e] = (*solVectorPtr)[in.li_ei]- (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_bp_bi] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_tnode_GND] = (*solVectorPtr)[in.li_tnode];
probeVars[in.admsProbeID_V_s_c] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_c];
probeVars[in.admsProbeID_V_si_ci] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_b_ci] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bp_ci] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bp_ei] = (*solVectorPtr)[in.li_bp]- (*solVectorPtr)[in.li_ei];
probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi]- (*solVectorPtr)[in.li_ei];


evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_ei_GND,
in.admsProbeID_V_bp_GND,
in.admsProbeID_V_ci_GND,
in.admsProbeID_V_bi_GND,
in.admsProbeID_V_c_e,
in.admsProbeID_V_b_c,
in.admsProbeID_V_n2_GND,
in.admsProbeID_V_n1_GND,
in.admsProbeID_V_si_s,
in.admsProbeID_V_bp_e,
in.admsProbeID_V_b_e,
in.admsProbeID_V_ci_ei,
in.admsProbeID_V_xf_GND,
in.admsProbeID_V_xf2_GND,
in.admsProbeID_V_xf1_GND,
in.admsProbeID_V_b_bp,
in.admsProbeID_V_ci_c,
in.admsProbeID_V_ei_e,
in.admsProbeID_V_bp_bi,
in.admsProbeID_V_tnode_GND,
in.admsProbeID_V_s_c,
in.admsProbeID_V_si_ci,
in.admsProbeID_V_b_ci,
in.admsProbeID_V_bp_ci,
in.admsProbeID_V_bp_ei,
in.admsProbeID_V_bi_ci,
in.admsProbeID_V_bi_ei,

// node constants
in.admsNodeID_c,
in.admsNodeID_b,
in.admsNodeID_e,
in.admsNodeID_s,
in.admsNodeID_tnode,
in.admsNodeID_ci,
in.admsNodeID_ei,
in.admsNodeID_bp,
in.admsNodeID_bi,
in.admsNodeID_si,
in.admsNodeID_xf1,
in.admsNodeID_xf2,
in.admsNodeID_xf,
in.admsNodeID_n1,
in.admsNodeID_n2,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_c] += d_staticContributions_dX[in.admsNodeID_c];
    dqdp[in.admsNodeID_c] += d_dynamicContributions_dX[in.admsNodeID_c];
    Findices[in.admsNodeID_c] = in.li_c;
    Qindices[in.admsNodeID_c] = in.li_c;
    dfdp[in.admsNodeID_b] += d_staticContributions_dX[in.admsNodeID_b];
    dqdp[in.admsNodeID_b] += d_dynamicContributions_dX[in.admsNodeID_b];
    Findices[in.admsNodeID_b] = in.li_b;
    Qindices[in.admsNodeID_b] = in.li_b;
    dfdp[in.admsNodeID_e] += d_staticContributions_dX[in.admsNodeID_e];
    dqdp[in.admsNodeID_e] += d_dynamicContributions_dX[in.admsNodeID_e];
    Findices[in.admsNodeID_e] = in.li_e;
    Qindices[in.admsNodeID_e] = in.li_e;
    dfdp[in.admsNodeID_s] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s] = in.li_s;
    Qindices[in.admsNodeID_s] = in.li_s;
    dfdp[in.admsNodeID_tnode] += d_staticContributions_dX[in.admsNodeID_tnode];
    dqdp[in.admsNodeID_tnode] += d_dynamicContributions_dX[in.admsNodeID_tnode];
    Findices[in.admsNodeID_tnode] = in.li_tnode;
    Qindices[in.admsNodeID_tnode] = in.li_tnode;
    dfdp[in.admsNodeID_ci] += d_staticContributions_dX[in.admsNodeID_ci];
    dqdp[in.admsNodeID_ci] += d_dynamicContributions_dX[in.admsNodeID_ci];
    Findices[in.admsNodeID_ci] = in.li_ci;
    Qindices[in.admsNodeID_ci] = in.li_ci;
    dfdp[in.admsNodeID_ei] += d_staticContributions_dX[in.admsNodeID_ei];
    dqdp[in.admsNodeID_ei] += d_dynamicContributions_dX[in.admsNodeID_ei];
    Findices[in.admsNodeID_ei] = in.li_ei;
    Qindices[in.admsNodeID_ei] = in.li_ei;
    dfdp[in.admsNodeID_bp] += d_staticContributions_dX[in.admsNodeID_bp];
    dqdp[in.admsNodeID_bp] += d_dynamicContributions_dX[in.admsNodeID_bp];
    Findices[in.admsNodeID_bp] = in.li_bp;
    Qindices[in.admsNodeID_bp] = in.li_bp;
    dfdp[in.admsNodeID_bi] += d_staticContributions_dX[in.admsNodeID_bi];
    dqdp[in.admsNodeID_bi] += d_dynamicContributions_dX[in.admsNodeID_bi];
    Findices[in.admsNodeID_bi] = in.li_bi;
    Qindices[in.admsNodeID_bi] = in.li_bi;
    dfdp[in.admsNodeID_si] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si] = in.li_si;
    Qindices[in.admsNodeID_si] = in.li_si;
    dfdp[in.admsNodeID_xf1] += d_staticContributions_dX[in.admsNodeID_xf1];
    dqdp[in.admsNodeID_xf1] += d_dynamicContributions_dX[in.admsNodeID_xf1];
    Findices[in.admsNodeID_xf1] = in.li_xf1;
    Qindices[in.admsNodeID_xf1] = in.li_xf1;
    dfdp[in.admsNodeID_xf2] += d_staticContributions_dX[in.admsNodeID_xf2];
    dqdp[in.admsNodeID_xf2] += d_dynamicContributions_dX[in.admsNodeID_xf2];
    Findices[in.admsNodeID_xf2] = in.li_xf2;
    Qindices[in.admsNodeID_xf2] = in.li_xf2;
    dfdp[in.admsNodeID_xf] += d_staticContributions_dX[in.admsNodeID_xf];
    dqdp[in.admsNodeID_xf] += d_dynamicContributions_dX[in.admsNodeID_xf];
    Findices[in.admsNodeID_xf] = in.li_xf;
    Qindices[in.admsNodeID_xf] = in.li_xf;
    dfdp[in.admsNodeID_n1] += d_staticContributions_dX[in.admsNodeID_n1];
    dqdp[in.admsNodeID_n1] += d_dynamicContributions_dX[in.admsNodeID_n1];
    Findices[in.admsNodeID_n1] = in.li_n1;
    Qindices[in.admsNodeID_n1] = in.li_n1;
    dfdp[in.admsNodeID_n2] += d_staticContributions_dX[in.admsNodeID_n2];
    dqdp[in.admsNodeID_n2] += d_dynamicContributions_dX[in.admsNodeID_n2];
    Findices[in.admsNodeID_n2] = in.li_n2;
    Qindices[in.admsNodeID_n2] = in.li_n2;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((15+0)*sizeInstance);
dqdp.resize((15+0)*sizeInstance);
Findices.resize((15+0)*sizeInstance);
Qindices.resize((15+0)*sizeInstance);

std::vector <double> probeVars(27);
std::vector <double> d_staticContributions_dX(15+0);
std::vector <double> d_dynamicContributions_dX(15+0);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_c10=mod.c10;
modelStruct.d_modelPar_c10_dX=0.0;
modelStruct.modelPar_given_c10=mod.given("c10");
modParamMap["c10"] = &(modelStruct.d_modelPar_c10_dX);
modelStruct.modelPar_qp0=mod.qp0;
modelStruct.d_modelPar_qp0_dX=0.0;
modelStruct.modelPar_given_qp0=mod.given("qp0");
modParamMap["qp0"] = &(modelStruct.d_modelPar_qp0_dX);
modelStruct.modelPar_ich=mod.ich;
modelStruct.d_modelPar_ich_dX=0.0;
modelStruct.modelPar_given_ich=mod.given("ich");
modParamMap["ich"] = &(modelStruct.d_modelPar_ich_dX);
modelStruct.modelPar_hf0=mod.hf0;
modelStruct.d_modelPar_hf0_dX=0.0;
modelStruct.modelPar_given_hf0=mod.given("hf0");
modParamMap["hf0"] = &(modelStruct.d_modelPar_hf0_dX);
modelStruct.modelPar_hfe=mod.hfe;
modelStruct.d_modelPar_hfe_dX=0.0;
modelStruct.modelPar_given_hfe=mod.given("hfe");
modParamMap["hfe"] = &(modelStruct.d_modelPar_hfe_dX);
modelStruct.modelPar_hfc=mod.hfc;
modelStruct.d_modelPar_hfc_dX=0.0;
modelStruct.modelPar_given_hfc=mod.given("hfc");
modParamMap["hfc"] = &(modelStruct.d_modelPar_hfc_dX);
modelStruct.modelPar_hjei=mod.hjei;
modelStruct.d_modelPar_hjei_dX=0.0;
modelStruct.modelPar_given_hjei=mod.given("hjei");
modParamMap["hjei"] = &(modelStruct.d_modelPar_hjei_dX);
modelStruct.modelPar_ahjei=mod.ahjei;
modelStruct.d_modelPar_ahjei_dX=0.0;
modelStruct.modelPar_given_ahjei=mod.given("ahjei");
modParamMap["ahjei"] = &(modelStruct.d_modelPar_ahjei_dX);
modelStruct.modelPar_rhjei=mod.rhjei;
modelStruct.d_modelPar_rhjei_dX=0.0;
modelStruct.modelPar_given_rhjei=mod.given("rhjei");
modParamMap["rhjei"] = &(modelStruct.d_modelPar_rhjei_dX);
modelStruct.modelPar_hjci=mod.hjci;
modelStruct.d_modelPar_hjci_dX=0.0;
modelStruct.modelPar_given_hjci=mod.given("hjci");
modParamMap["hjci"] = &(modelStruct.d_modelPar_hjci_dX);
modelStruct.modelPar_ibeis=mod.ibeis;
modelStruct.d_modelPar_ibeis_dX=0.0;
modelStruct.modelPar_given_ibeis=mod.given("ibeis");
modParamMap["ibeis"] = &(modelStruct.d_modelPar_ibeis_dX);
modelStruct.modelPar_mbei=mod.mbei;
modelStruct.d_modelPar_mbei_dX=0.0;
modelStruct.modelPar_given_mbei=mod.given("mbei");
modParamMap["mbei"] = &(modelStruct.d_modelPar_mbei_dX);
modelStruct.modelPar_ireis=mod.ireis;
modelStruct.d_modelPar_ireis_dX=0.0;
modelStruct.modelPar_given_ireis=mod.given("ireis");
modParamMap["ireis"] = &(modelStruct.d_modelPar_ireis_dX);
modelStruct.modelPar_mrei=mod.mrei;
modelStruct.d_modelPar_mrei_dX=0.0;
modelStruct.modelPar_given_mrei=mod.given("mrei");
modParamMap["mrei"] = &(modelStruct.d_modelPar_mrei_dX);
modelStruct.modelPar_ibeps=mod.ibeps;
modelStruct.d_modelPar_ibeps_dX=0.0;
modelStruct.modelPar_given_ibeps=mod.given("ibeps");
modParamMap["ibeps"] = &(modelStruct.d_modelPar_ibeps_dX);
modelStruct.modelPar_mbep=mod.mbep;
modelStruct.d_modelPar_mbep_dX=0.0;
modelStruct.modelPar_given_mbep=mod.given("mbep");
modParamMap["mbep"] = &(modelStruct.d_modelPar_mbep_dX);
modelStruct.modelPar_ireps=mod.ireps;
modelStruct.d_modelPar_ireps_dX=0.0;
modelStruct.modelPar_given_ireps=mod.given("ireps");
modParamMap["ireps"] = &(modelStruct.d_modelPar_ireps_dX);
modelStruct.modelPar_mrep=mod.mrep;
modelStruct.d_modelPar_mrep_dX=0.0;
modelStruct.modelPar_given_mrep=mod.given("mrep");
modParamMap["mrep"] = &(modelStruct.d_modelPar_mrep_dX);
modelStruct.modelPar_mcf=mod.mcf;
modelStruct.d_modelPar_mcf_dX=0.0;
modelStruct.modelPar_given_mcf=mod.given("mcf");
modParamMap["mcf"] = &(modelStruct.d_modelPar_mcf_dX);
modelStruct.modelPar_tbhrec=mod.tbhrec;
modelStruct.d_modelPar_tbhrec_dX=0.0;
modelStruct.modelPar_given_tbhrec=mod.given("tbhrec");
modParamMap["tbhrec"] = &(modelStruct.d_modelPar_tbhrec_dX);
modelStruct.modelPar_ibcis=mod.ibcis;
modelStruct.d_modelPar_ibcis_dX=0.0;
modelStruct.modelPar_given_ibcis=mod.given("ibcis");
modParamMap["ibcis"] = &(modelStruct.d_modelPar_ibcis_dX);
modelStruct.modelPar_mbci=mod.mbci;
modelStruct.d_modelPar_mbci_dX=0.0;
modelStruct.modelPar_given_mbci=mod.given("mbci");
modParamMap["mbci"] = &(modelStruct.d_modelPar_mbci_dX);
modelStruct.modelPar_ibcxs=mod.ibcxs;
modelStruct.d_modelPar_ibcxs_dX=0.0;
modelStruct.modelPar_given_ibcxs=mod.given("ibcxs");
modParamMap["ibcxs"] = &(modelStruct.d_modelPar_ibcxs_dX);
modelStruct.modelPar_mbcx=mod.mbcx;
modelStruct.d_modelPar_mbcx_dX=0.0;
modelStruct.modelPar_given_mbcx=mod.given("mbcx");
modParamMap["mbcx"] = &(modelStruct.d_modelPar_mbcx_dX);
modelStruct.modelPar_ibets=mod.ibets;
modelStruct.d_modelPar_ibets_dX=0.0;
modelStruct.modelPar_given_ibets=mod.given("ibets");
modParamMap["ibets"] = &(modelStruct.d_modelPar_ibets_dX);
modelStruct.modelPar_abet=mod.abet;
modelStruct.d_modelPar_abet_dX=0.0;
modelStruct.modelPar_given_abet=mod.given("abet");
modParamMap["abet"] = &(modelStruct.d_modelPar_abet_dX);
modelStruct.modelPar_favl=mod.favl;
modelStruct.d_modelPar_favl_dX=0.0;
modelStruct.modelPar_given_favl=mod.given("favl");
modParamMap["favl"] = &(modelStruct.d_modelPar_favl_dX);
modelStruct.modelPar_qavl=mod.qavl;
modelStruct.d_modelPar_qavl_dX=0.0;
modelStruct.modelPar_given_qavl=mod.given("qavl");
modParamMap["qavl"] = &(modelStruct.d_modelPar_qavl_dX);
modelStruct.modelPar_kavl=mod.kavl;
modelStruct.d_modelPar_kavl_dX=0.0;
modelStruct.modelPar_given_kavl=mod.given("kavl");
modParamMap["kavl"] = &(modelStruct.d_modelPar_kavl_dX);
modelStruct.modelPar_alfav=mod.alfav;
modelStruct.d_modelPar_alfav_dX=0.0;
modelStruct.modelPar_given_alfav=mod.given("alfav");
modParamMap["alfav"] = &(modelStruct.d_modelPar_alfav_dX);
modelStruct.modelPar_alqav=mod.alqav;
modelStruct.d_modelPar_alqav_dX=0.0;
modelStruct.modelPar_given_alqav=mod.given("alqav");
modParamMap["alqav"] = &(modelStruct.d_modelPar_alqav_dX);
modelStruct.modelPar_alkav=mod.alkav;
modelStruct.d_modelPar_alkav_dX=0.0;
modelStruct.modelPar_given_alkav=mod.given("alkav");
modParamMap["alkav"] = &(modelStruct.d_modelPar_alkav_dX);
modelStruct.modelPar_rbi0=mod.rbi0;
modelStruct.d_modelPar_rbi0_dX=0.0;
modelStruct.modelPar_given_rbi0=mod.given("rbi0");
modParamMap["rbi0"] = &(modelStruct.d_modelPar_rbi0_dX);
modelStruct.modelPar_rbx=mod.rbx;
modelStruct.d_modelPar_rbx_dX=0.0;
modelStruct.modelPar_given_rbx=mod.given("rbx");
modParamMap["rbx"] = &(modelStruct.d_modelPar_rbx_dX);
modelStruct.modelPar_fgeo=mod.fgeo;
modelStruct.d_modelPar_fgeo_dX=0.0;
modelStruct.modelPar_given_fgeo=mod.given("fgeo");
modParamMap["fgeo"] = &(modelStruct.d_modelPar_fgeo_dX);
modelStruct.modelPar_fdqr0=mod.fdqr0;
modelStruct.d_modelPar_fdqr0_dX=0.0;
modelStruct.modelPar_given_fdqr0=mod.given("fdqr0");
modParamMap["fdqr0"] = &(modelStruct.d_modelPar_fdqr0_dX);
modelStruct.modelPar_fcrbi=mod.fcrbi;
modelStruct.d_modelPar_fcrbi_dX=0.0;
modelStruct.modelPar_given_fcrbi=mod.given("fcrbi");
modParamMap["fcrbi"] = &(modelStruct.d_modelPar_fcrbi_dX);
modelStruct.modelPar_fqi=mod.fqi;
modelStruct.d_modelPar_fqi_dX=0.0;
modelStruct.modelPar_given_fqi=mod.given("fqi");
modParamMap["fqi"] = &(modelStruct.d_modelPar_fqi_dX);
modelStruct.modelPar_re=mod.re;
modelStruct.d_modelPar_re_dX=0.0;
modelStruct.modelPar_given_re=mod.given("re");
modParamMap["re"] = &(modelStruct.d_modelPar_re_dX);
modelStruct.modelPar_rcx=mod.rcx;
modelStruct.d_modelPar_rcx_dX=0.0;
modelStruct.modelPar_given_rcx=mod.given("rcx");
modParamMap["rcx"] = &(modelStruct.d_modelPar_rcx_dX);
modelStruct.modelPar_itss=mod.itss;
modelStruct.d_modelPar_itss_dX=0.0;
modelStruct.modelPar_given_itss=mod.given("itss");
modParamMap["itss"] = &(modelStruct.d_modelPar_itss_dX);
modelStruct.modelPar_msf=mod.msf;
modelStruct.d_modelPar_msf_dX=0.0;
modelStruct.modelPar_given_msf=mod.given("msf");
modParamMap["msf"] = &(modelStruct.d_modelPar_msf_dX);
modelStruct.modelPar_iscs=mod.iscs;
modelStruct.d_modelPar_iscs_dX=0.0;
modelStruct.modelPar_given_iscs=mod.given("iscs");
modParamMap["iscs"] = &(modelStruct.d_modelPar_iscs_dX);
modelStruct.modelPar_msc=mod.msc;
modelStruct.d_modelPar_msc_dX=0.0;
modelStruct.modelPar_given_msc=mod.given("msc");
modParamMap["msc"] = &(modelStruct.d_modelPar_msc_dX);
modelStruct.modelPar_tsf=mod.tsf;
modelStruct.d_modelPar_tsf_dX=0.0;
modelStruct.modelPar_given_tsf=mod.given("tsf");
modParamMap["tsf"] = &(modelStruct.d_modelPar_tsf_dX);
modelStruct.modelPar_rsu=mod.rsu;
modelStruct.d_modelPar_rsu_dX=0.0;
modelStruct.modelPar_given_rsu=mod.given("rsu");
modParamMap["rsu"] = &(modelStruct.d_modelPar_rsu_dX);
modelStruct.modelPar_csu=mod.csu;
modelStruct.d_modelPar_csu_dX=0.0;
modelStruct.modelPar_given_csu=mod.given("csu");
modParamMap["csu"] = &(modelStruct.d_modelPar_csu_dX);
modelStruct.modelPar_cjei0=mod.cjei0;
modelStruct.d_modelPar_cjei0_dX=0.0;
modelStruct.modelPar_given_cjei0=mod.given("cjei0");
modParamMap["cjei0"] = &(modelStruct.d_modelPar_cjei0_dX);
modelStruct.modelPar_vdei=mod.vdei;
modelStruct.d_modelPar_vdei_dX=0.0;
modelStruct.modelPar_given_vdei=mod.given("vdei");
modParamMap["vdei"] = &(modelStruct.d_modelPar_vdei_dX);
modelStruct.modelPar_zei=mod.zei;
modelStruct.d_modelPar_zei_dX=0.0;
modelStruct.modelPar_given_zei=mod.given("zei");
modParamMap["zei"] = &(modelStruct.d_modelPar_zei_dX);
modelStruct.modelPar_ajei=mod.ajei;
modelStruct.d_modelPar_ajei_dX=0.0;
modelStruct.modelPar_given_ajei=mod.given("ajei");
modParamMap["ajei"] = &(modelStruct.d_modelPar_ajei_dX);
modelStruct.modelPar_cjep0=mod.cjep0;
modelStruct.d_modelPar_cjep0_dX=0.0;
modelStruct.modelPar_given_cjep0=mod.given("cjep0");
modParamMap["cjep0"] = &(modelStruct.d_modelPar_cjep0_dX);
modelStruct.modelPar_vdep=mod.vdep;
modelStruct.d_modelPar_vdep_dX=0.0;
modelStruct.modelPar_given_vdep=mod.given("vdep");
modParamMap["vdep"] = &(modelStruct.d_modelPar_vdep_dX);
modelStruct.modelPar_zep=mod.zep;
modelStruct.d_modelPar_zep_dX=0.0;
modelStruct.modelPar_given_zep=mod.given("zep");
modParamMap["zep"] = &(modelStruct.d_modelPar_zep_dX);
modelStruct.modelPar_ajep=mod.ajep;
modelStruct.d_modelPar_ajep_dX=0.0;
modelStruct.modelPar_given_ajep=mod.given("ajep");
modParamMap["ajep"] = &(modelStruct.d_modelPar_ajep_dX);
modelStruct.modelPar_cjci0=mod.cjci0;
modelStruct.d_modelPar_cjci0_dX=0.0;
modelStruct.modelPar_given_cjci0=mod.given("cjci0");
modParamMap["cjci0"] = &(modelStruct.d_modelPar_cjci0_dX);
modelStruct.modelPar_vdci=mod.vdci;
modelStruct.d_modelPar_vdci_dX=0.0;
modelStruct.modelPar_given_vdci=mod.given("vdci");
modParamMap["vdci"] = &(modelStruct.d_modelPar_vdci_dX);
modelStruct.modelPar_zci=mod.zci;
modelStruct.d_modelPar_zci_dX=0.0;
modelStruct.modelPar_given_zci=mod.given("zci");
modParamMap["zci"] = &(modelStruct.d_modelPar_zci_dX);
modelStruct.modelPar_vptci=mod.vptci;
modelStruct.d_modelPar_vptci_dX=0.0;
modelStruct.modelPar_given_vptci=mod.given("vptci");
modParamMap["vptci"] = &(modelStruct.d_modelPar_vptci_dX);
modelStruct.modelPar_cjcx0=mod.cjcx0;
modelStruct.d_modelPar_cjcx0_dX=0.0;
modelStruct.modelPar_given_cjcx0=mod.given("cjcx0");
modParamMap["cjcx0"] = &(modelStruct.d_modelPar_cjcx0_dX);
modelStruct.modelPar_vdcx=mod.vdcx;
modelStruct.d_modelPar_vdcx_dX=0.0;
modelStruct.modelPar_given_vdcx=mod.given("vdcx");
modParamMap["vdcx"] = &(modelStruct.d_modelPar_vdcx_dX);
modelStruct.modelPar_zcx=mod.zcx;
modelStruct.d_modelPar_zcx_dX=0.0;
modelStruct.modelPar_given_zcx=mod.given("zcx");
modParamMap["zcx"] = &(modelStruct.d_modelPar_zcx_dX);
modelStruct.modelPar_vptcx=mod.vptcx;
modelStruct.d_modelPar_vptcx_dX=0.0;
modelStruct.modelPar_given_vptcx=mod.given("vptcx");
modParamMap["vptcx"] = &(modelStruct.d_modelPar_vptcx_dX);
modelStruct.modelPar_fbcpar=mod.fbcpar;
modelStruct.d_modelPar_fbcpar_dX=0.0;
modelStruct.modelPar_given_fbcpar=mod.given("fbcpar");
modParamMap["fbcpar"] = &(modelStruct.d_modelPar_fbcpar_dX);
modelStruct.modelPar_fbepar=mod.fbepar;
modelStruct.d_modelPar_fbepar_dX=0.0;
modelStruct.modelPar_given_fbepar=mod.given("fbepar");
modParamMap["fbepar"] = &(modelStruct.d_modelPar_fbepar_dX);
modelStruct.modelPar_cjs0=mod.cjs0;
modelStruct.d_modelPar_cjs0_dX=0.0;
modelStruct.modelPar_given_cjs0=mod.given("cjs0");
modParamMap["cjs0"] = &(modelStruct.d_modelPar_cjs0_dX);
modelStruct.modelPar_vds=mod.vds;
modelStruct.d_modelPar_vds_dX=0.0;
modelStruct.modelPar_given_vds=mod.given("vds");
modParamMap["vds"] = &(modelStruct.d_modelPar_vds_dX);
modelStruct.modelPar_zs=mod.zs;
modelStruct.d_modelPar_zs_dX=0.0;
modelStruct.modelPar_given_zs=mod.given("zs");
modParamMap["zs"] = &(modelStruct.d_modelPar_zs_dX);
modelStruct.modelPar_vpts=mod.vpts;
modelStruct.d_modelPar_vpts_dX=0.0;
modelStruct.modelPar_given_vpts=mod.given("vpts");
modParamMap["vpts"] = &(modelStruct.d_modelPar_vpts_dX);
modelStruct.modelPar_cscp0=mod.cscp0;
modelStruct.d_modelPar_cscp0_dX=0.0;
modelStruct.modelPar_given_cscp0=mod.given("cscp0");
modParamMap["cscp0"] = &(modelStruct.d_modelPar_cscp0_dX);
modelStruct.modelPar_vdsp=mod.vdsp;
modelStruct.d_modelPar_vdsp_dX=0.0;
modelStruct.modelPar_given_vdsp=mod.given("vdsp");
modParamMap["vdsp"] = &(modelStruct.d_modelPar_vdsp_dX);
modelStruct.modelPar_zsp=mod.zsp;
modelStruct.d_modelPar_zsp_dX=0.0;
modelStruct.modelPar_given_zsp=mod.given("zsp");
modParamMap["zsp"] = &(modelStruct.d_modelPar_zsp_dX);
modelStruct.modelPar_vptsp=mod.vptsp;
modelStruct.d_modelPar_vptsp_dX=0.0;
modelStruct.modelPar_given_vptsp=mod.given("vptsp");
modParamMap["vptsp"] = &(modelStruct.d_modelPar_vptsp_dX);
modelStruct.modelPar_t0=mod.t0;
modelStruct.d_modelPar_t0_dX=0.0;
modelStruct.modelPar_given_t0=mod.given("t0");
modParamMap["t0"] = &(modelStruct.d_modelPar_t0_dX);
modelStruct.modelPar_dt0h=mod.dt0h;
modelStruct.d_modelPar_dt0h_dX=0.0;
modelStruct.modelPar_given_dt0h=mod.given("dt0h");
modParamMap["dt0h"] = &(modelStruct.d_modelPar_dt0h_dX);
modelStruct.modelPar_tbvl=mod.tbvl;
modelStruct.d_modelPar_tbvl_dX=0.0;
modelStruct.modelPar_given_tbvl=mod.given("tbvl");
modParamMap["tbvl"] = &(modelStruct.d_modelPar_tbvl_dX);
modelStruct.modelPar_tef0=mod.tef0;
modelStruct.d_modelPar_tef0_dX=0.0;
modelStruct.modelPar_given_tef0=mod.given("tef0");
modParamMap["tef0"] = &(modelStruct.d_modelPar_tef0_dX);
modelStruct.modelPar_gtfe=mod.gtfe;
modelStruct.d_modelPar_gtfe_dX=0.0;
modelStruct.modelPar_given_gtfe=mod.given("gtfe");
modParamMap["gtfe"] = &(modelStruct.d_modelPar_gtfe_dX);
modelStruct.modelPar_thcs=mod.thcs;
modelStruct.d_modelPar_thcs_dX=0.0;
modelStruct.modelPar_given_thcs=mod.given("thcs");
modParamMap["thcs"] = &(modelStruct.d_modelPar_thcs_dX);
modelStruct.modelPar_ahc=mod.ahc;
modelStruct.d_modelPar_ahc_dX=0.0;
modelStruct.modelPar_given_ahc=mod.given("ahc");
modParamMap["ahc"] = &(modelStruct.d_modelPar_ahc_dX);
modelStruct.modelPar_fthc=mod.fthc;
modelStruct.d_modelPar_fthc_dX=0.0;
modelStruct.modelPar_given_fthc=mod.given("fthc");
modParamMap["fthc"] = &(modelStruct.d_modelPar_fthc_dX);
modelStruct.modelPar_rci0=mod.rci0;
modelStruct.d_modelPar_rci0_dX=0.0;
modelStruct.modelPar_given_rci0=mod.given("rci0");
modParamMap["rci0"] = &(modelStruct.d_modelPar_rci0_dX);
modelStruct.modelPar_vlim=mod.vlim;
modelStruct.d_modelPar_vlim_dX=0.0;
modelStruct.modelPar_given_vlim=mod.given("vlim");
modParamMap["vlim"] = &(modelStruct.d_modelPar_vlim_dX);
modelStruct.modelPar_vces=mod.vces;
modelStruct.d_modelPar_vces_dX=0.0;
modelStruct.modelPar_given_vces=mod.given("vces");
modParamMap["vces"] = &(modelStruct.d_modelPar_vces_dX);
modelStruct.modelPar_vpt=mod.vpt;
modelStruct.d_modelPar_vpt_dX=0.0;
modelStruct.modelPar_given_vpt=mod.given("vpt");
modParamMap["vpt"] = &(modelStruct.d_modelPar_vpt_dX);
modelStruct.modelPar_aick=mod.aick;
modelStruct.d_modelPar_aick_dX=0.0;
modelStruct.modelPar_given_aick=mod.given("aick");
modParamMap["aick"] = &(modelStruct.d_modelPar_aick_dX);
modelStruct.modelPar_delck=mod.delck;
modelStruct.d_modelPar_delck_dX=0.0;
modelStruct.modelPar_given_delck=mod.given("delck");
modParamMap["delck"] = &(modelStruct.d_modelPar_delck_dX);
modelStruct.modelPar_tr=mod.tr;
modelStruct.d_modelPar_tr_dX=0.0;
modelStruct.modelPar_given_tr=mod.given("tr");
modParamMap["tr"] = &(modelStruct.d_modelPar_tr_dX);
modelStruct.modelPar_vcbar=mod.vcbar;
modelStruct.d_modelPar_vcbar_dX=0.0;
modelStruct.modelPar_given_vcbar=mod.given("vcbar");
modParamMap["vcbar"] = &(modelStruct.d_modelPar_vcbar_dX);
modelStruct.modelPar_icbar=mod.icbar;
modelStruct.d_modelPar_icbar_dX=0.0;
modelStruct.modelPar_given_icbar=mod.given("icbar");
modParamMap["icbar"] = &(modelStruct.d_modelPar_icbar_dX);
modelStruct.modelPar_acbar=mod.acbar;
modelStruct.d_modelPar_acbar_dX=0.0;
modelStruct.modelPar_given_acbar=mod.given("acbar");
modParamMap["acbar"] = &(modelStruct.d_modelPar_acbar_dX);
modelStruct.modelPar_cbepar=mod.cbepar;
modelStruct.d_modelPar_cbepar_dX=0.0;
modelStruct.modelPar_given_cbepar=mod.given("cbepar");
modParamMap["cbepar"] = &(modelStruct.d_modelPar_cbepar_dX);
modelStruct.modelPar_cbcpar=mod.cbcpar;
modelStruct.d_modelPar_cbcpar_dX=0.0;
modelStruct.modelPar_given_cbcpar=mod.given("cbcpar");
modParamMap["cbcpar"] = &(modelStruct.d_modelPar_cbcpar_dX);
modelStruct.modelPar_alqf=mod.alqf;
modelStruct.d_modelPar_alqf_dX=0.0;
modelStruct.modelPar_given_alqf=mod.given("alqf");
modParamMap["alqf"] = &(modelStruct.d_modelPar_alqf_dX);
modelStruct.modelPar_alit=mod.alit;
modelStruct.d_modelPar_alit_dX=0.0;
modelStruct.modelPar_given_alit=mod.given("alit");
modParamMap["alit"] = &(modelStruct.d_modelPar_alit_dX);
modelStruct.modelPar_kf=mod.kf;
modelStruct.d_modelPar_kf_dX=0.0;
modelStruct.modelPar_given_kf=mod.given("kf");
modParamMap["kf"] = &(modelStruct.d_modelPar_kf_dX);
modelStruct.modelPar_af=mod.af;
modelStruct.d_modelPar_af_dX=0.0;
modelStruct.modelPar_given_af=mod.given("af");
modParamMap["af"] = &(modelStruct.d_modelPar_af_dX);
modelStruct.modelPar_kfre=mod.kfre;
modelStruct.d_modelPar_kfre_dX=0.0;
modelStruct.modelPar_given_kfre=mod.given("kfre");
modParamMap["kfre"] = &(modelStruct.d_modelPar_kfre_dX);
modelStruct.modelPar_afre=mod.afre;
modelStruct.d_modelPar_afre_dX=0.0;
modelStruct.modelPar_given_afre=mod.given("afre");
modParamMap["afre"] = &(modelStruct.d_modelPar_afre_dX);
modelStruct.modelPar_latb=mod.latb;
modelStruct.d_modelPar_latb_dX=0.0;
modelStruct.modelPar_given_latb=mod.given("latb");
modParamMap["latb"] = &(modelStruct.d_modelPar_latb_dX);
modelStruct.modelPar_latl=mod.latl;
modelStruct.d_modelPar_latl_dX=0.0;
modelStruct.modelPar_given_latl=mod.given("latl");
modParamMap["latl"] = &(modelStruct.d_modelPar_latl_dX);
modelStruct.modelPar_vgb=mod.vgb;
modelStruct.d_modelPar_vgb_dX=0.0;
modelStruct.modelPar_given_vgb=mod.given("vgb");
modParamMap["vgb"] = &(modelStruct.d_modelPar_vgb_dX);
modelStruct.modelPar_alt0=mod.alt0;
modelStruct.d_modelPar_alt0_dX=0.0;
modelStruct.modelPar_given_alt0=mod.given("alt0");
modParamMap["alt0"] = &(modelStruct.d_modelPar_alt0_dX);
modelStruct.modelPar_kt0=mod.kt0;
modelStruct.d_modelPar_kt0_dX=0.0;
modelStruct.modelPar_given_kt0=mod.given("kt0");
modParamMap["kt0"] = &(modelStruct.d_modelPar_kt0_dX);
modelStruct.modelPar_zetaci=mod.zetaci;
modelStruct.d_modelPar_zetaci_dX=0.0;
modelStruct.modelPar_given_zetaci=mod.given("zetaci");
modParamMap["zetaci"] = &(modelStruct.d_modelPar_zetaci_dX);
modelStruct.modelPar_alvs=mod.alvs;
modelStruct.d_modelPar_alvs_dX=0.0;
modelStruct.modelPar_given_alvs=mod.given("alvs");
modParamMap["alvs"] = &(modelStruct.d_modelPar_alvs_dX);
modelStruct.modelPar_alces=mod.alces;
modelStruct.d_modelPar_alces_dX=0.0;
modelStruct.modelPar_given_alces=mod.given("alces");
modParamMap["alces"] = &(modelStruct.d_modelPar_alces_dX);
modelStruct.modelPar_zetarbi=mod.zetarbi;
modelStruct.d_modelPar_zetarbi_dX=0.0;
modelStruct.modelPar_given_zetarbi=mod.given("zetarbi");
modParamMap["zetarbi"] = &(modelStruct.d_modelPar_zetarbi_dX);
modelStruct.modelPar_zetarbx=mod.zetarbx;
modelStruct.d_modelPar_zetarbx_dX=0.0;
modelStruct.modelPar_given_zetarbx=mod.given("zetarbx");
modParamMap["zetarbx"] = &(modelStruct.d_modelPar_zetarbx_dX);
modelStruct.modelPar_zetarcx=mod.zetarcx;
modelStruct.d_modelPar_zetarcx_dX=0.0;
modelStruct.modelPar_given_zetarcx=mod.given("zetarcx");
modParamMap["zetarcx"] = &(modelStruct.d_modelPar_zetarcx_dX);
modelStruct.modelPar_zetare=mod.zetare;
modelStruct.d_modelPar_zetare_dX=0.0;
modelStruct.modelPar_given_zetare=mod.given("zetare");
modParamMap["zetare"] = &(modelStruct.d_modelPar_zetare_dX);
modelStruct.modelPar_zetacx=mod.zetacx;
modelStruct.d_modelPar_zetacx_dX=0.0;
modelStruct.modelPar_given_zetacx=mod.given("zetacx");
modParamMap["zetacx"] = &(modelStruct.d_modelPar_zetacx_dX);
modelStruct.modelPar_vge=mod.vge;
modelStruct.d_modelPar_vge_dX=0.0;
modelStruct.modelPar_given_vge=mod.given("vge");
modParamMap["vge"] = &(modelStruct.d_modelPar_vge_dX);
modelStruct.modelPar_vgc=mod.vgc;
modelStruct.d_modelPar_vgc_dX=0.0;
modelStruct.modelPar_given_vgc=mod.given("vgc");
modParamMap["vgc"] = &(modelStruct.d_modelPar_vgc_dX);
modelStruct.modelPar_vgs=mod.vgs;
modelStruct.d_modelPar_vgs_dX=0.0;
modelStruct.modelPar_given_vgs=mod.given("vgs");
modParamMap["vgs"] = &(modelStruct.d_modelPar_vgs_dX);
modelStruct.modelPar_f1vg=mod.f1vg;
modelStruct.d_modelPar_f1vg_dX=0.0;
modelStruct.modelPar_given_f1vg=mod.given("f1vg");
modParamMap["f1vg"] = &(modelStruct.d_modelPar_f1vg_dX);
modelStruct.modelPar_f2vg=mod.f2vg;
modelStruct.d_modelPar_f2vg_dX=0.0;
modelStruct.modelPar_given_f2vg=mod.given("f2vg");
modParamMap["f2vg"] = &(modelStruct.d_modelPar_f2vg_dX);
modelStruct.modelPar_zetact=mod.zetact;
modelStruct.d_modelPar_zetact_dX=0.0;
modelStruct.modelPar_given_zetact=mod.given("zetact");
modParamMap["zetact"] = &(modelStruct.d_modelPar_zetact_dX);
modelStruct.modelPar_zetabet=mod.zetabet;
modelStruct.d_modelPar_zetabet_dX=0.0;
modelStruct.modelPar_given_zetabet=mod.given("zetabet");
modParamMap["zetabet"] = &(modelStruct.d_modelPar_zetabet_dX);
modelStruct.modelPar_alb=mod.alb;
modelStruct.d_modelPar_alb_dX=0.0;
modelStruct.modelPar_given_alb=mod.given("alb");
modParamMap["alb"] = &(modelStruct.d_modelPar_alb_dX);
modelStruct.modelPar_dvgbe=mod.dvgbe;
modelStruct.d_modelPar_dvgbe_dX=0.0;
modelStruct.modelPar_given_dvgbe=mod.given("dvgbe");
modParamMap["dvgbe"] = &(modelStruct.d_modelPar_dvgbe_dX);
modelStruct.modelPar_zetahjei=mod.zetahjei;
modelStruct.d_modelPar_zetahjei_dX=0.0;
modelStruct.modelPar_given_zetahjei=mod.given("zetahjei");
modParamMap["zetahjei"] = &(modelStruct.d_modelPar_zetahjei_dX);
modelStruct.modelPar_zetavgbe=mod.zetavgbe;
modelStruct.d_modelPar_zetavgbe_dX=0.0;
modelStruct.modelPar_given_zetavgbe=mod.given("zetavgbe");
modParamMap["zetavgbe"] = &(modelStruct.d_modelPar_zetavgbe_dX);
modelStruct.modelPar_rth=mod.rth;
modelStruct.d_modelPar_rth_dX=0.0;
modelStruct.modelPar_given_rth=mod.given("rth");
modParamMap["rth"] = &(modelStruct.d_modelPar_rth_dX);
modelStruct.modelPar_zetarth=mod.zetarth;
modelStruct.d_modelPar_zetarth_dX=0.0;
modelStruct.modelPar_given_zetarth=mod.given("zetarth");
modParamMap["zetarth"] = &(modelStruct.d_modelPar_zetarth_dX);
modelStruct.modelPar_alrth=mod.alrth;
modelStruct.d_modelPar_alrth_dX=0.0;
modelStruct.modelPar_given_alrth=mod.given("alrth");
modParamMap["alrth"] = &(modelStruct.d_modelPar_alrth_dX);
modelStruct.modelPar_cth=mod.cth;
modelStruct.d_modelPar_cth_dX=0.0;
modelStruct.modelPar_given_cth=mod.given("cth");
modParamMap["cth"] = &(modelStruct.d_modelPar_cth_dX);
modelStruct.modelPar_flcomp=mod.flcomp;
modelStruct.d_modelPar_flcomp_dX=0.0;
modelStruct.modelPar_given_flcomp=mod.given("flcomp");
modParamMap["flcomp"] = &(modelStruct.d_modelPar_flcomp_dX);
modelStruct.modelPar_tnom=mod.tnom;
modelStruct.d_modelPar_tnom_dX=0.0;
modelStruct.modelPar_given_tnom=mod.given("tnom");
modParamMap["tnom"] = &(modelStruct.d_modelPar_tnom_dX);
modelStruct.modelPar_dt=mod.dt;
modelStruct.d_modelPar_dt_dX=0.0;
modelStruct.modelPar_given_dt=mod.given("dt");
modParamMap["dt"] = &(modelStruct.d_modelPar_dt_dX);


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_tunode=mod.tunode;
modelStruct.modelPar_given_tunode=mod.given("tunode");
modelStruct.modelPar_flnqs=mod.flnqs;
modelStruct.modelPar_given_flnqs=mod.given("flnqs");
modelStruct.modelPar_cfbe=mod.cfbe;
modelStruct.modelPar_given_cfbe=mod.given("cfbe");
modelStruct.modelPar_flcono=mod.flcono;
modelStruct.modelPar_given_flcono=mod.given("flcono");
modelStruct.modelPar_flsh=mod.flsh;
modelStruct.modelPar_given_flsh=mod.given("flsh");
modelStruct.modelPar_type=mod.type;
modelStruct.modelPar_given_type=mod.given("type");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals


// non-reals



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 15+0 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.


  //make local copies of all instance vars
  //reals
instanceStruct.instanceVar_VT=in.VT;
instanceStruct.d_instanceVar_VT_dX=0.0;
instanceStruct.instanceVar_Tdev=in.Tdev;
instanceStruct.d_instanceVar_Tdev_dX=0.0;
instanceStruct.instanceVar_qtt0=in.qtt0;
instanceStruct.d_instanceVar_qtt0_dX=0.0;
instanceStruct.instanceVar_ln_qtt0=in.ln_qtt0;
instanceStruct.d_instanceVar_ln_qtt0_dX=0.0;
instanceStruct.instanceVar_r_VgVT=in.r_VgVT;
instanceStruct.d_instanceVar_r_VgVT_dX=0.0;
instanceStruct.instanceVar_V_gT=in.V_gT;
instanceStruct.d_instanceVar_V_gT_dX=0.0;
instanceStruct.instanceVar_dT=in.dT;
instanceStruct.d_instanceVar_dT_dX=0.0;
instanceStruct.instanceVar_k=in.k;
instanceStruct.d_instanceVar_k_dX=0.0;
instanceStruct.instanceVar_ireis_t=in.ireis_t;
instanceStruct.d_instanceVar_ireis_t_dX=0.0;
instanceStruct.instanceVar_ibeis_t=in.ibeis_t;
instanceStruct.d_instanceVar_ibeis_t_dX=0.0;
instanceStruct.instanceVar_ibcxs_t=in.ibcxs_t;
instanceStruct.d_instanceVar_ibcxs_t_dX=0.0;
instanceStruct.instanceVar_ibcis_t=in.ibcis_t;
instanceStruct.d_instanceVar_ibcis_t_dX=0.0;
instanceStruct.instanceVar_iscs_t=in.iscs_t;
instanceStruct.d_instanceVar_iscs_t_dX=0.0;
instanceStruct.instanceVar_cjci0_t=in.cjci0_t;
instanceStruct.d_instanceVar_cjci0_t_dX=0.0;
instanceStruct.instanceVar_cjs0_t=in.cjs0_t;
instanceStruct.d_instanceVar_cjs0_t_dX=0.0;
instanceStruct.instanceVar_cscp0_t=in.cscp0_t;
instanceStruct.d_instanceVar_cscp0_t_dX=0.0;
instanceStruct.instanceVar_rci0_t=in.rci0_t;
instanceStruct.d_instanceVar_rci0_t_dX=0.0;
instanceStruct.instanceVar_vlim_t=in.vlim_t;
instanceStruct.d_instanceVar_vlim_t_dX=0.0;
instanceStruct.instanceVar_vces_t=in.vces_t;
instanceStruct.d_instanceVar_vces_t_dX=0.0;
instanceStruct.instanceVar_thcs_t=in.thcs_t;
instanceStruct.d_instanceVar_thcs_t_dX=0.0;
instanceStruct.instanceVar_tef0_t=in.tef0_t;
instanceStruct.d_instanceVar_tef0_t_dX=0.0;
instanceStruct.instanceVar_rbi0_t=in.rbi0_t;
instanceStruct.d_instanceVar_rbi0_t_dX=0.0;
instanceStruct.instanceVar_t0_t=in.t0_t;
instanceStruct.d_instanceVar_t0_t_dX=0.0;
instanceStruct.instanceVar_vdei_t=in.vdei_t;
instanceStruct.d_instanceVar_vdei_t_dX=0.0;
instanceStruct.instanceVar_vdci_t=in.vdci_t;
instanceStruct.d_instanceVar_vdci_t_dX=0.0;
instanceStruct.instanceVar_vpts_t=in.vpts_t;
instanceStruct.d_instanceVar_vpts_t_dX=0.0;
instanceStruct.instanceVar_vptsp_t=in.vptsp_t;
instanceStruct.d_instanceVar_vptsp_t_dX=0.0;
instanceStruct.instanceVar_itss_t=in.itss_t;
instanceStruct.d_instanceVar_itss_t_dX=0.0;
instanceStruct.instanceVar_tsf_t=in.tsf_t;
instanceStruct.d_instanceVar_tsf_t_dX=0.0;
instanceStruct.instanceVar_c10_t=in.c10_t;
instanceStruct.d_instanceVar_c10_t_dX=0.0;
instanceStruct.instanceVar_cjei0_t=in.cjei0_t;
instanceStruct.d_instanceVar_cjei0_t_dX=0.0;
instanceStruct.instanceVar_qp0_t=in.qp0_t;
instanceStruct.d_instanceVar_qp0_t_dX=0.0;
instanceStruct.instanceVar_vdcx_t=in.vdcx_t;
instanceStruct.d_instanceVar_vdcx_t_dX=0.0;
instanceStruct.instanceVar_vptcx_t=in.vptcx_t;
instanceStruct.d_instanceVar_vptcx_t_dX=0.0;
instanceStruct.instanceVar_cjcx01_t=in.cjcx01_t;
instanceStruct.d_instanceVar_cjcx01_t_dX=0.0;
instanceStruct.instanceVar_cjcx02_t=in.cjcx02_t;
instanceStruct.d_instanceVar_cjcx02_t_dX=0.0;
instanceStruct.instanceVar_cratio_t=in.cratio_t;
instanceStruct.d_instanceVar_cratio_t_dX=0.0;
instanceStruct.instanceVar_ibeps_t=in.ibeps_t;
instanceStruct.d_instanceVar_ibeps_t_dX=0.0;
instanceStruct.instanceVar_ireps_t=in.ireps_t;
instanceStruct.d_instanceVar_ireps_t_dX=0.0;
instanceStruct.instanceVar_cjep0_t=in.cjep0_t;
instanceStruct.d_instanceVar_cjep0_t_dX=0.0;
instanceStruct.instanceVar_ajei_t=in.ajei_t;
instanceStruct.d_instanceVar_ajei_t_dX=0.0;
instanceStruct.instanceVar_qavl_t=in.qavl_t;
instanceStruct.d_instanceVar_qavl_t_dX=0.0;
instanceStruct.instanceVar_favl_t=in.favl_t;
instanceStruct.d_instanceVar_favl_t_dX=0.0;
instanceStruct.instanceVar_kavl_t=in.kavl_t;
instanceStruct.d_instanceVar_kavl_t_dX=0.0;
instanceStruct.instanceVar_ibets_t=in.ibets_t;
instanceStruct.d_instanceVar_ibets_t_dX=0.0;
instanceStruct.instanceVar_abet_t=in.abet_t;
instanceStruct.d_instanceVar_abet_t_dX=0.0;
instanceStruct.instanceVar_vptci_t=in.vptci_t;
instanceStruct.d_instanceVar_vptci_t_dX=0.0;
instanceStruct.instanceVar_vdep_t=in.vdep_t;
instanceStruct.d_instanceVar_vdep_t_dX=0.0;
instanceStruct.instanceVar_ajep_t=in.ajep_t;
instanceStruct.d_instanceVar_ajep_t_dX=0.0;
instanceStruct.instanceVar_zetatef=in.zetatef;
instanceStruct.d_instanceVar_zetatef_dX=0.0;
instanceStruct.instanceVar_k1=in.k1;
instanceStruct.d_instanceVar_k1_dX=0.0;
instanceStruct.instanceVar_k2=in.k2;
instanceStruct.d_instanceVar_k2_dX=0.0;
instanceStruct.instanceVar_dvg0=in.dvg0;
instanceStruct.d_instanceVar_dvg0_dX=0.0;
instanceStruct.instanceVar_vge_t=in.vge_t;
instanceStruct.d_instanceVar_vge_t_dX=0.0;
instanceStruct.instanceVar_vgb_t=in.vgb_t;
instanceStruct.d_instanceVar_vgb_t_dX=0.0;
instanceStruct.instanceVar_vgbe_t=in.vgbe_t;
instanceStruct.d_instanceVar_vgbe_t_dX=0.0;
instanceStruct.instanceVar_vds_t=in.vds_t;
instanceStruct.d_instanceVar_vds_t_dX=0.0;
instanceStruct.instanceVar_vdsp_t=in.vdsp_t;
instanceStruct.d_instanceVar_vdsp_t_dX=0.0;
instanceStruct.instanceVar_vt0=in.vt0;
instanceStruct.d_instanceVar_vt0_dX=0.0;
instanceStruct.instanceVar_Tnom=in.Tnom;
instanceStruct.d_instanceVar_Tnom_dX=0.0;
instanceStruct.instanceVar_Tamb=in.Tamb;
instanceStruct.instanceVar_a=in.a;
instanceStruct.d_instanceVar_a_dX=0.0;
instanceStruct.instanceVar_avs=in.avs;
instanceStruct.d_instanceVar_avs_dX=0.0;
instanceStruct.instanceVar_zetabci=in.zetabci;
instanceStruct.d_instanceVar_zetabci_dX=0.0;
instanceStruct.instanceVar_zetabcxt=in.zetabcxt;
instanceStruct.d_instanceVar_zetabcxt_dX=0.0;
instanceStruct.instanceVar_zetasct=in.zetasct;
instanceStruct.d_instanceVar_zetasct_dX=0.0;
instanceStruct.instanceVar_vgbe0=in.vgbe0;
instanceStruct.d_instanceVar_vgbe0_dX=0.0;
instanceStruct.instanceVar_mg=in.mg;
instanceStruct.d_instanceVar_mg_dX=0.0;
instanceStruct.instanceVar_vgbe_t0=in.vgbe_t0;
instanceStruct.d_instanceVar_vgbe_t0_dX=0.0;
instanceStruct.instanceVar_vgbc0=in.vgbc0;
instanceStruct.d_instanceVar_vgbc0_dX=0.0;
instanceStruct.instanceVar_vgsc0=in.vgsc0;
instanceStruct.d_instanceVar_vgsc0_dX=0.0;
instanceStruct.instanceVar_cbcpar1=in.cbcpar1;
instanceStruct.d_instanceVar_cbcpar1_dX=0.0;
instanceStruct.instanceVar_cbcpar2=in.cbcpar2;
instanceStruct.d_instanceVar_cbcpar2_dX=0.0;
instanceStruct.instanceVar_cbepar2=in.cbepar2;
instanceStruct.d_instanceVar_cbepar2_dX=0.0;
instanceStruct.instanceVar_cbepar1=in.cbepar1;
instanceStruct.d_instanceVar_cbepar1_dX=0.0;
instanceStruct.instanceVar_Oich=in.Oich;
instanceStruct.d_instanceVar_Oich_dX=0.0;
instanceStruct.instanceVar_Otbhrec=in.Otbhrec;
instanceStruct.d_instanceVar_Otbhrec_dX=0.0;
instanceStruct.instanceVar_it=in.it;
instanceStruct.d_instanceVar_it_dX=0.0;
instanceStruct.instanceVar_ibei=in.ibei;
instanceStruct.d_instanceVar_ibei_dX=0.0;
instanceStruct.instanceVar_ibci=in.ibci;
instanceStruct.d_instanceVar_ibci_dX=0.0;
instanceStruct.instanceVar_ibep=in.ibep;
instanceStruct.d_instanceVar_ibep_dX=0.0;
instanceStruct.instanceVar_iavl=in.iavl;
instanceStruct.d_instanceVar_iavl_dX=0.0;
instanceStruct.instanceVar_ijbcx=in.ijbcx;
instanceStruct.d_instanceVar_ijbcx_dX=0.0;
instanceStruct.instanceVar_ijsc=in.ijsc;
instanceStruct.d_instanceVar_ijsc_dX=0.0;
instanceStruct.instanceVar_rth_t=in.rth_t;
instanceStruct.d_instanceVar_rth_t_dX=0.0;
instanceStruct.instanceVar_vdj0=in.vdj0;
instanceStruct.d_instanceVar_vdj0_dX=0.0;
instanceStruct.instanceVar_vdjt=in.vdjt;
instanceStruct.d_instanceVar_vdjt_dX=0.0;
instanceStruct.instanceVar_vdt=in.vdt;
instanceStruct.d_instanceVar_vdt_dX=0.0;
instanceStruct.instanceVar_Tf=in.Tf;
instanceStruct.d_instanceVar_Tf_dX=0.0;
instanceStruct.instanceVar_cjcx01=in.cjcx01;
instanceStruct.d_instanceVar_cjcx01_dX=0.0;
instanceStruct.instanceVar_cjcx02=in.cjcx02;
instanceStruct.d_instanceVar_cjcx02_dX=0.0;
instanceStruct.instanceVar_betadc=in.betadc;
instanceStruct.d_instanceVar_betadc_dX=0.0;
instanceStruct.instanceVar_hjei0_t=in.hjei0_t;
instanceStruct.d_instanceVar_hjei0_t_dX=0.0;
instanceStruct.instanceVar_ahjei_t=in.ahjei_t;
instanceStruct.d_instanceVar_ahjei_t_dX=0.0;
instanceStruct.instanceVar_hf0_t=in.hf0_t;
instanceStruct.d_instanceVar_hf0_t_dX=0.0;
instanceStruct.instanceVar_hfe_t=in.hfe_t;
instanceStruct.d_instanceVar_hfe_t_dX=0.0;
instanceStruct.instanceVar_hfc_t=in.hfc_t;
instanceStruct.d_instanceVar_hfc_t_dX=0.0;
instanceStruct.instanceVar_rbx_t=in.rbx_t;
instanceStruct.d_instanceVar_rbx_t_dX=0.0;
instanceStruct.instanceVar_rcx_t=in.rcx_t;
instanceStruct.d_instanceVar_rcx_t_dX=0.0;
instanceStruct.instanceVar_re_t=in.re_t;
instanceStruct.d_instanceVar_re_t_dX=0.0;
instanceStruct.instanceVar_rbi=in.rbi;
instanceStruct.d_instanceVar_rbi_dX=0.0;


  //non-reals
instanceStruct.instanceVar_use_aval=in.use_aval;



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_ei_GND] = (*solVectorPtr)[in.li_ei];
probeVars[in.admsProbeID_V_bp_GND] = (*solVectorPtr)[in.li_bp];
probeVars[in.admsProbeID_V_ci_GND] = (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bi_GND] = (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_c_e] = (*solVectorPtr)[in.li_c] - (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_b_c] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_c];
probeVars[in.admsProbeID_V_n2_GND] = (*solVectorPtr)[in.li_n2];
probeVars[in.admsProbeID_V_n1_GND] = (*solVectorPtr)[in.li_n1];
probeVars[in.admsProbeID_V_si_s] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_bp_e] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_b_e] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_ci_ei] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_ei];
probeVars[in.admsProbeID_V_xf_GND] = (*solVectorPtr)[in.li_xf];
probeVars[in.admsProbeID_V_xf2_GND] = (*solVectorPtr)[in.li_xf2];
probeVars[in.admsProbeID_V_xf1_GND] = (*solVectorPtr)[in.li_xf1];
probeVars[in.admsProbeID_V_b_bp] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_bp];
probeVars[in.admsProbeID_V_ci_c] = (*solVectorPtr)[in.li_ci] - (*solVectorPtr)[in.li_c];
probeVars[in.admsProbeID_V_ei_e] = (*solVectorPtr)[in.li_ei] - (*solVectorPtr)[in.li_e];
probeVars[in.admsProbeID_V_bp_bi] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_bi];
probeVars[in.admsProbeID_V_tnode_GND] = (*solVectorPtr)[in.li_tnode];
probeVars[in.admsProbeID_V_s_c] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_c];
probeVars[in.admsProbeID_V_si_ci] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_b_ci] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bp_ci] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bp_ei] = (*solVectorPtr)[in.li_bp] - (*solVectorPtr)[in.li_ei];
probeVars[in.admsProbeID_V_bi_ci] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ci];
probeVars[in.admsProbeID_V_bi_ei] = (*solVectorPtr)[in.li_bi] - (*solVectorPtr)[in.li_ei];


evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_ei_GND,
in.admsProbeID_V_bp_GND,
in.admsProbeID_V_ci_GND,
in.admsProbeID_V_bi_GND,
in.admsProbeID_V_c_e,
in.admsProbeID_V_b_c,
in.admsProbeID_V_n2_GND,
in.admsProbeID_V_n1_GND,
in.admsProbeID_V_si_s,
in.admsProbeID_V_bp_e,
in.admsProbeID_V_b_e,
in.admsProbeID_V_ci_ei,
in.admsProbeID_V_xf_GND,
in.admsProbeID_V_xf2_GND,
in.admsProbeID_V_xf1_GND,
in.admsProbeID_V_b_bp,
in.admsProbeID_V_ci_c,
in.admsProbeID_V_ei_e,
in.admsProbeID_V_bp_bi,
in.admsProbeID_V_tnode_GND,
in.admsProbeID_V_s_c,
in.admsProbeID_V_si_ci,
in.admsProbeID_V_b_ci,
in.admsProbeID_V_bp_ci,
in.admsProbeID_V_bp_ei,
in.admsProbeID_V_bi_ci,
in.admsProbeID_V_bi_ei,

// node constants
in.admsNodeID_c,
in.admsNodeID_b,
in.admsNodeID_e,
in.admsNodeID_s,
in.admsNodeID_tnode,
in.admsNodeID_ci,
in.admsNodeID_ei,
in.admsNodeID_bp,
in.admsNodeID_bi,
in.admsNodeID_si,
in.admsNodeID_xf1,
in.admsNodeID_xf2,
in.admsNodeID_xf,
in.admsNodeID_n1,
in.admsNodeID_n2,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_c+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_c];
    dqdp[in.admsNodeID_c+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_c];
    Findices[in.admsNodeID_c+inst*(15+0)] = in.li_c;
    Qindices[in.admsNodeID_c+inst*(15+0)] = in.li_c;
    dfdp[in.admsNodeID_b+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_b];
    dqdp[in.admsNodeID_b+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_b];
    Findices[in.admsNodeID_b+inst*(15+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(15+0)] = in.li_b;
    dfdp[in.admsNodeID_e+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_e];
    dqdp[in.admsNodeID_e+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_e];
    Findices[in.admsNodeID_e+inst*(15+0)] = in.li_e;
    Qindices[in.admsNodeID_e+inst*(15+0)] = in.li_e;
    dfdp[in.admsNodeID_s+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s+inst*(15+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(15+0)] = in.li_s;
    dfdp[in.admsNodeID_tnode+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_tnode];
    dqdp[in.admsNodeID_tnode+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_tnode];
    Findices[in.admsNodeID_tnode+inst*(15+0)] = in.li_tnode;
    Qindices[in.admsNodeID_tnode+inst*(15+0)] = in.li_tnode;
    dfdp[in.admsNodeID_ci+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_ci];
    dqdp[in.admsNodeID_ci+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_ci];
    Findices[in.admsNodeID_ci+inst*(15+0)] = in.li_ci;
    Qindices[in.admsNodeID_ci+inst*(15+0)] = in.li_ci;
    dfdp[in.admsNodeID_ei+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_ei];
    dqdp[in.admsNodeID_ei+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_ei];
    Findices[in.admsNodeID_ei+inst*(15+0)] = in.li_ei;
    Qindices[in.admsNodeID_ei+inst*(15+0)] = in.li_ei;
    dfdp[in.admsNodeID_bp+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_bp];
    dqdp[in.admsNodeID_bp+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_bp];
    Findices[in.admsNodeID_bp+inst*(15+0)] = in.li_bp;
    Qindices[in.admsNodeID_bp+inst*(15+0)] = in.li_bp;
    dfdp[in.admsNodeID_bi+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_bi];
    dqdp[in.admsNodeID_bi+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_bi];
    Findices[in.admsNodeID_bi+inst*(15+0)] = in.li_bi;
    Qindices[in.admsNodeID_bi+inst*(15+0)] = in.li_bi;
    dfdp[in.admsNodeID_si+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si+inst*(15+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(15+0)] = in.li_si;
    dfdp[in.admsNodeID_xf1+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_xf1];
    dqdp[in.admsNodeID_xf1+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_xf1];
    Findices[in.admsNodeID_xf1+inst*(15+0)] = in.li_xf1;
    Qindices[in.admsNodeID_xf1+inst*(15+0)] = in.li_xf1;
    dfdp[in.admsNodeID_xf2+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_xf2];
    dqdp[in.admsNodeID_xf2+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_xf2];
    Findices[in.admsNodeID_xf2+inst*(15+0)] = in.li_xf2;
    Qindices[in.admsNodeID_xf2+inst*(15+0)] = in.li_xf2;
    dfdp[in.admsNodeID_xf+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_xf];
    dqdp[in.admsNodeID_xf+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_xf];
    Findices[in.admsNodeID_xf+inst*(15+0)] = in.li_xf;
    Qindices[in.admsNodeID_xf+inst*(15+0)] = in.li_xf;
    dfdp[in.admsNodeID_n1+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_n1];
    dqdp[in.admsNodeID_n1+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_n1];
    Findices[in.admsNodeID_n1+inst*(15+0)] = in.li_n1;
    Qindices[in.admsNodeID_n1+inst*(15+0)] = in.li_n1;
    dfdp[in.admsNodeID_n2+inst*(15+0)] += d_staticContributions_dX[in.admsNodeID_n2];
    dqdp[in.admsNodeID_n2+inst*(15+0)] += d_dynamicContributions_dX[in.admsNodeID_n2];
    Findices[in.admsNodeID_n2+inst*(15+0)] = in.li_n2;
    Qindices[in.admsNodeID_n2+inst*(15+0)] = in.li_n2;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMShicumL2va
} // namespace Device
} // namespace Xyce
