
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file L_UTSOI_102.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:28
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSl_utsoi.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

  #include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMSl_utsoi {
JacobianStamp Instance::jacStamp;
IdVector Instance::nodeMap;
PairMap Instance::pairToJacStampMap;


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_D;
    const int Instance::admsNodeID_G;
    const int Instance::admsNodeID_S;
    const int Instance::admsNodeID_B;
    const int Instance::admsNodeID_Tnode;
    const int Instance::admsNodeID_NSIG;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations
    const int Instance::admsBRA_ID_NSIG_GND;


void
Traits::loadInstanceParameters(ParametricData<ADMSl_utsoi::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSl_utsoi::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(1.0e-06), &ADMSl_utsoi::Instance::L)
    .setUnit(U_METER)
    .setDescription("Channel length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("W", static_cast<double>(1.0e-06), &ADMSl_utsoi::Instance::W)
    .setUnit(U_METER)
    .setDescription("Channel width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ASOURCE", static_cast<double>(1.0e-12), &ADMSl_utsoi::Instance::ASOURCE)
    .setUnit(U_METER2)
    .setDescription("Source region area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ADRAIN", static_cast<double>(1.0e-12), &ADMSl_utsoi::Instance::ADRAIN)
    .setUnit(U_METER2)
    .setDescription("Drain region area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSOURCE", static_cast<double>(1.0e-06), &ADMSl_utsoi::Instance::PSOURCE)
    .setUnit(U_METER)
    .setDescription("Source region perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PDRAIN", static_cast<double>(1.0e-06), &ADMSl_utsoi::Instance::PDRAIN)
    .setUnit(U_METER)
    .setDescription("Drain region perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SA", static_cast<double>(0.0), &ADMSl_utsoi::Instance::SA)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and poly at source side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SB", static_cast<double>(0.0), &ADMSl_utsoi::Instance::SB)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and poly at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SD", static_cast<double>(0.0), &ADMSl_utsoi::Instance::SD)
    .setUnit(U_METER)
    .setDescription("Distance between neighboring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NF", static_cast<int>(1), &ADMSl_utsoi::Instance::NF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers");
  p.addPar("MULT", static_cast<int>(1), &ADMSl_utsoi::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of devices in parallel");
  p.addPar("DELVTO", static_cast<double>(0.0), &ADMSl_utsoi::Instance::DELVTO)
    .setUnit(U_VOLT)
    .setDescription("Threshold voltage shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACTUO", static_cast<double>(1.0), &ADMSl_utsoi::Instance::FACTUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Low-field mobility pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("M", static_cast<int>(1), &ADMSl_utsoi::Instance::M)
    .setUnit(U_UNKNOWN)
    .setDescription("multiplicity factor");


}

void Traits::loadModelParameters(ParametricData<ADMSl_utsoi::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSl_utsoi::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("SWSCALE", static_cast<int>(0), &ADMSl_utsoi::Model::SWSCALE)
    .setUnit(U_UNKNOWN)
    .setDescription("Parameter set mode (local=0, global=1)");
  p.addPar("VERSION", static_cast<double>(102.4), &ADMSl_utsoi::Model::VERSION)
    .setUnit(U_UNKNOWN)
    .setDescription("Model version")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWSUBDEP", static_cast<int>(0), &ADMSl_utsoi::Model::SWSUBDEP)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for substrate depletion model (without=0, with=1)");
  p.addPar("SWIGATE", static_cast<int>(0), &ADMSl_utsoi::Model::SWIGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for gate current (without=0, with=1)");
  p.addPar("SWGIDL", static_cast<int>(0), &ADMSl_utsoi::Model::SWGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for GIDL current (without=0, with=1)");
  p.addPar("SWSHE", static_cast<int>(0), &ADMSl_utsoi::Model::SWSHE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for self heating effect (without=0, with=1)");
  p.addPar("SWIGN", static_cast<int>(1), &ADMSl_utsoi::Model::SWIGN)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for induced gate noise model (without=0, with=1)");
  p.addPar("SWJUNASYM", static_cast<int>(0), &ADMSl_utsoi::Model::SWJUNASYM)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for source/drain junction asymmetry (without=0, with=1)");
  p.addPar("SWIMPACT", static_cast<int>(0), &ADMSl_utsoi::Model::SWIMPACT)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for impact ionization current (without=0, with=1)");
  p.addPar("QMC", static_cast<double>(1.0), &ADMSl_utsoi::Model::QMC)
    .setUnit(U_UNKNOWN)
    .setDescription("Quantum correction factor (no correction=0, full correction=1)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TYPE", static_cast<int>(1), &ADMSl_utsoi::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("Channel type parameter, +1=NMOS -1=PMOS");
  p.addPar("TR", static_cast<double>(21.0), &ADMSl_utsoi::Model::TR)
    .setUnit(U_COULOMB)
    .setDescription("Nominal temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TMAX", static_cast<double>(150.0), &ADMSl_utsoi::Model::TMAX)
    .setUnit(U_COULOMB)
    .setDescription("Maximum self-heating temperature elevation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXE", static_cast<double>(2.0e-09), &ADMSl_utsoi::Model::TOXE)
    .setUnit(U_METER)
    .setDescription("Front gate equivalent oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TSI", static_cast<double>(1.0e-08), &ADMSl_utsoi::Model::TSI)
    .setUnit(U_METER)
    .setDescription("Silicon or SiGe film thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XGE", static_cast<double>(0.0), &ADMSl_utsoi::Model::XGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of Ge content in the channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBOX", static_cast<double>(1.0e-07), &ADMSl_utsoi::Model::TBOX)
    .setUnit(U_METER)
    .setDescription("Buried oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCH", static_cast<double>(0.0), &ADMSl_utsoi::Model::NCH)
    .setUnit(U_UNKNOWN)
    .setDescription("Thin film doping (n-type=negative value, p-type=positive value)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUB", static_cast<double>(3.0e18), &ADMSl_utsoi::Model::NSUB)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate doping (n-type=negative value, p-type=positive value)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CT", static_cast<double>(0.0), &ADMSl_utsoi::Model::CT)
    .setUnit(U_UNKNOWN)
    .setDescription("Interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXP", static_cast<double>(2.0e-09), &ADMSl_utsoi::Model::TOXP)
    .setUnit(U_METER)
    .setDescription("Front gate physical oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOV", static_cast<double>(1.0e20), &ADMSl_utsoi::Model::NOV)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective doping of overlap-ldd regions")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVD", static_cast<double>(1.0e20), &ADMSl_utsoi::Model::NOVD)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective doping of overlap-ldd regions ar drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFB", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFB)
    .setUnit(U_VOLT)
    .setDescription("Flat-band voltage of the front gate at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBB", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBB)
    .setUnit(U_VOLT)
    .setDescription("Flat-band voltage of the back gate at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFB", static_cast<double>(0.0), &ADMSl_utsoi::Model::STVFB)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of VFB and VFBB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CICF", static_cast<double>(1.0), &ADMSl_utsoi::Model::CICF)
    .setUnit(U_UNKNOWN)
    .setDescription("Long channel front interface coupling coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CIC", static_cast<double>(1.0), &ADMSl_utsoi::Model::CIC)
    .setUnit(U_UNKNOWN)
    .setDescription("Long channel back interface coupling coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCE", static_cast<double>(0.0), &ADMSl_utsoi::Model::PSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Short channel effect coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEB", static_cast<double>(1.0), &ADMSl_utsoi::Model::PSCEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Short channel back to front interface asymmetry factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSDDC", static_cast<double>(1.0e22), &ADMSl_utsoi::Model::NSDDC)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/Drain effective doping level for DC model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEDLB", static_cast<double>(0.0), &ADMSl_utsoi::Model::PSCEDLB)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of short channel effect modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNCE", static_cast<double>(0.0), &ADMSl_utsoi::Model::PNCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Narrow channel effect on body factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CF", static_cast<double>(0.0), &ADMSl_utsoi::Model::CF)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFB", static_cast<double>(1.0), &ADMSl_utsoi::Model::CFB)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL back to front interface asymmetry factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCF", static_cast<double>(0.0), &ADMSl_utsoi::Model::STCF)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature dependence of CF, with same scaling as CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFD", static_cast<double>(0.2), &ADMSl_utsoi::Model::CFD)
    .setUnit(U_VOLT)
    .setDescription("Drain voltage dependence parameter of DIBL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDL", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFDL)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL modulation coefficient due to Leff variation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDLB", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFDLB)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of DIBL modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETN", static_cast<double>(5.0e-02), &ADMSl_utsoi::Model::BETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Front channel aspect ratio times zero-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETNB", static_cast<double>(1.0), &ADMSl_utsoi::Model::BETNB)
    .setUnit(U_UNKNOWN)
    .setDescription("Back channel over front channel zero-field mobility ratio")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBET", static_cast<double>(1.5), &ADMSl_utsoi::Model::STBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CS", static_cast<double>(0.0), &ADMSl_utsoi::Model::CS)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSFI", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSFI)
    .setUnit(U_UNKNOWN)
    .setDescription("Field dependence of Coulomb scattering at front interface")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSBI", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSBI)
    .setUnit(U_UNKNOWN)
    .setDescription("Field dependence of Coulomb scattering at back interface")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCS", static_cast<double>(0.0), &ADMSl_utsoi::Model::STCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THECS", static_cast<double>(1.5), &ADMSl_utsoi::Model::THECS)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHECS", static_cast<double>(0.0), &ADMSl_utsoi::Model::STTHECS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THECS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSTHR", static_cast<double>(2.0), &ADMSl_utsoi::Model::CSTHR)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering threshold level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSTHRB", static_cast<double>(1.0), &ADMSl_utsoi::Model::CSTHRB)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering threshold asymmetry parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MUE", static_cast<double>(0.0), &ADMSl_utsoi::Model::MUE)
    .setUnit(U_UNKNOWN)
    .setDescription("Front channel mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STMUE", static_cast<double>(0.0), &ADMSl_utsoi::Model::STMUE)
    .setUnit(U_UNKNOWN)
    .setDescription(" Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THEMU", static_cast<double>(1.5), &ADMSl_utsoi::Model::THEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Front channel mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHEMU", static_cast<double>(0.0), &ADMSl_utsoi::Model::STTHEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCOR", static_cast<double>(0.0), &ADMSl_utsoi::Model::XCOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Front channel non-universality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORB", static_cast<double>(1.0), &ADMSl_utsoi::Model::XCORB)
    .setUnit(U_UNKNOWN)
    .setDescription("Asymmetry term of non-universality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STXCOR", static_cast<double>(0.0), &ADMSl_utsoi::Model::STXCOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FETA", static_cast<double>(1.0), &ADMSl_utsoi::Model::FETA)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RS", static_cast<double>(30.0), &ADMSl_utsoi::Model::RS)
    .setUnit(U_OHM)
    .setDescription("Source/Drain series resistance at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSIG", static_cast<double>(0.0), &ADMSl_utsoi::Model::RSIG)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/Drain extension resistance coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRS", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSG", static_cast<double>(0.0), &ADMSl_utsoi::Model::RSG)
    .setUnit(U_UNKNOWN)
    .setDescription("Transverse electric field dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THERSG", static_cast<double>(2.0), &ADMSl_utsoi::Model::THERSG)
    .setUnit(U_UNKNOWN)
    .setDescription("Transverse electric field dependence exponent of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSB", static_cast<double>(0.0), &ADMSl_utsoi::Model::RSB)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESAT", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESAT", static_cast<double>((-0.1)), &ADMSl_utsoi::Model::STTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATG", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATG)
    .setUnit(U_UNKNOWN)
    .setDescription("Front gate bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATB", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATB)
    .setUnit(U_UNKNOWN)
    .setDescription("Back gate bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AX", static_cast<double>(8.0), &ADMSl_utsoi::Model::AX)
    .setUnit(U_UNKNOWN)
    .setDescription("Linear/saturation transition exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALP)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALP1)
    .setUnit(U_VOLT)
    .setDescription("CLM enhancement factor above threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPB", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALPB)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of channel length modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VP", static_cast<double>(0.05), &ADMSl_utsoi::Model::VP)
    .setUnit(U_VOLT)
    .setDescription("CLM logarithm dependence factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPG", static_cast<double>(0.0), &ADMSl_utsoi::Model::VPG)
    .setUnit(U_UNKNOWN)
    .setDescription("Transverse electric field dependence of CLM logarithm factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCO", static_cast<double>(0.0), &ADMSl_utsoi::Model::GCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunneling energy adjustment in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGINV", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGINV)
    .setUnit(U_AMP)
    .setDescription("Gate to channel current pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVINV", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVINV)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVINVD", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVINVD)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor in inversion at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVACC", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVACC)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVACCD", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVACCD)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor in accumulation at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STIG", static_cast<double>(0.0), &ADMSl_utsoi::Model::STIG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of all gate currents")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2CH", static_cast<double>(0.375), &ADMSl_utsoi::Model::GC2CH)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate to channel current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3CH", static_cast<double>(0.063), &ADMSl_utsoi::Model::GC3CH)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate to channel current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2OVINV", static_cast<double>(0.375), &ADMSl_utsoi::Model::GC2OVINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor for overlap regions in inversion mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3OVINV", static_cast<double>(0.063), &ADMSl_utsoi::Model::GC3OVINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current curvature factor for overlap regions in inversion mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2OVACC", static_cast<double>(0.375), &ADMSl_utsoi::Model::GC2OVACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor for overlap regions in accumulation mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3OVACC", static_cast<double>(0.063), &ADMSl_utsoi::Model::GC3OVACC)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current curvature factor for overlap regions in accumulation mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCDOV", static_cast<double>(0.0), &ADMSl_utsoi::Model::GCDOV)
    .setUnit(U_VOLTM1)
    .setDescription("High drain voltage dependence of overlap gate current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCVDOV", static_cast<double>(1.0), &ADMSl_utsoi::Model::GCVDOV)
    .setUnit(U_VOLT)
    .setDescription("Threshold of high drain voltage effect on overlap gate current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CHIB", static_cast<double>(3.1), &ADMSl_utsoi::Model::CHIB)
    .setUnit(U_VOLT)
    .setDescription("Tunneling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIGINV", static_cast<double>(0.0), &ADMSl_utsoi::Model::NIGINV)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunneling slope adjustment in subthreshold regime")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNOVINV", static_cast<double>(0.0), &ADMSl_utsoi::Model::FNOVINV)
    .setUnit(U_AMP)
    .setDescription("Extra gate to overlap current pre-factor in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNOVINVD", static_cast<double>(0.0), &ADMSl_utsoi::Model::FNOVINVD)
    .setUnit(U_AMP)
    .setDescription("Extra gate to overlap current pre-factor in inversion at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCOVINVFN", static_cast<double>(0.2), &ADMSl_utsoi::Model::GCOVINVFN)
    .setUnit(U_UNKNOWN)
    .setDescription("Extra gate current slope factor for overlap regions in inversion mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STIGFN", static_cast<double>(0.0), &ADMSl_utsoi::Model::STIGFN)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of extra gate to overlap current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDL", static_cast<double>(0.0), &ADMSl_utsoi::Model::AGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLD", static_cast<double>(0.0), &ADMSl_utsoi::Model::AGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDL", static_cast<double>(41.0), &ADMSl_utsoi::Model::BGIDL)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLD", static_cast<double>(41.0), &ADMSl_utsoi::Model::BGIDLD)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDL", static_cast<double>(0.0), &ADMSl_utsoi::Model::STBGIDL)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLD", static_cast<double>(0.0), &ADMSl_utsoi::Model::STBGIDLD)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDL", static_cast<double>(0.0), &ADMSl_utsoi::Model::CGIDL)
    .setUnit(U_VOLTM1)
    .setDescription("Substrate bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLD", static_cast<double>(0.0), &ADMSl_utsoi::Model::CGIDLD)
    .setUnit(U_VOLTM1)
    .setDescription("Substrate bias dependence of GIDL at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGIDL", static_cast<double>(0.0), &ADMSl_utsoi::Model::DGIDL)
    .setUnit(U_VOLTM1)
    .setDescription("High longitudinal field parameter of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGIDLD", static_cast<double>(0.0), &ADMSl_utsoi::Model::DGIDLD)
    .setUnit(U_VOLTM1)
    .setDescription("High longitudinal field parameter of GIDL at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1", static_cast<double>(1.0), &ADMSl_utsoi::Model::A1)
    .setUnit(U_UNKNOWN)
    .setDescription("Impact ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A2", static_cast<double>(10.0), &ADMSl_utsoi::Model::A2)
    .setUnit(U_UNKNOWN)
    .setDescription("Impact ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STA2", static_cast<double>(0.0), &ADMSl_utsoi::Model::STA2)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3", static_cast<double>(1.0), &ADMSl_utsoi::Model::A3)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation voltage dependence of impact-ionization")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AREAQ", static_cast<double>(1.0e-12), &ADMSl_utsoi::Model::AREAQ)
    .setUnit(U_METER2)
    .setDescription("Effective channel area for intrinsic CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBOV", static_cast<double>(0.0), &ADMSl_utsoi::Model::CGBOV)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-substrate overlap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSDAC", static_cast<double>(1.0e22), &ADMSl_utsoi::Model::NSDAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/Drain effective doping level for AC model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FIF", static_cast<double>(0.0), &ADMSl_utsoi::Model::FIF)
    .setUnit(U_UNKNOWN)
    .setDescription("Inner fringe capacitance prefactor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FSCEAC", static_cast<double>(0.0), &ADMSl_utsoi::Model::FSCEAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Short channel effect adjustment factor for charge model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COV", static_cast<double>(0.0), &ADMSl_utsoi::Model::COV)
    .setUnit(U_FARAD)
    .setDescription("Overlap capacitance per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVD", static_cast<double>(0.0), &ADMSl_utsoi::Model::COVD)
    .setUnit(U_FARAD)
    .setDescription("Overlap capacitance at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVDL", static_cast<double>(0.0), &ADMSl_utsoi::Model::COVDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Overlap capacitance modulation coefficient due to Leff variation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVDLB", static_cast<double>(0.0), &ADMSl_utsoi::Model::COVDLB)
    .setUnit(U_UNKNOWN)
    .setDescription("Overlap capacitance modulation with back bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVFBOV", static_cast<double>(0.0), &ADMSl_utsoi::Model::DVFBOV)
    .setUnit(U_VOLT)
    .setDescription("Overlap capacitance flat-band voltage adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFR", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFR)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRD", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFRD)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSD", static_cast<double>(1.04e-18), &ADMSl_utsoi::Model::CSD)
    .setUnit(U_FARAD)
    .setDescription("Drain-source capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSDBP", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSDBP)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain/source to substrate perimeter capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTH", static_cast<double>(1.0e04), &ADMSl_utsoi::Model::RTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRTH", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RTH")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTH", static_cast<double>(1.0e-11), &ADMSl_utsoi::Model::CTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNT", static_cast<double>(1.0), &ADMSl_utsoi::Model::FNT)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEXC", static_cast<double>(0.0), &ADMSl_utsoi::Model::FNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Excess noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFA", static_cast<double>(8.0e22), &ADMSl_utsoi::Model::NFA)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFB", static_cast<double>(3.0e07), &ADMSl_utsoi::Model::NFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFC", static_cast<double>(0.0), &ADMSl_utsoi::Model::NFC)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFE", static_cast<double>(0.0), &ADMSl_utsoi::Model::NFE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise front transverse field effect coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFEB", static_cast<double>(0.0), &ADMSl_utsoi::Model::NFEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise back transverse field effect coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EF", static_cast<double>(1.0), &ADMSl_utsoi::Model::EF)
    .setUnit(U_UNKNOWN)
    .setDescription("Frequency coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARO", static_cast<double>(0.0), &ADMSl_utsoi::Model::LVARO)
    .setUnit(U_METER)
    .setDescription("Geometry independent difference between physical and drawn gate lengths")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARL", static_cast<double>(0.0), &ADMSl_utsoi::Model::LVARL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of LPS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARW", static_cast<double>(0.0), &ADMSl_utsoi::Model::LVARW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of LPS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAP", static_cast<double>(0.0), &ADMSl_utsoi::Model::LAP)
    .setUnit(U_METER)
    .setDescription("Effective channel length reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARO", static_cast<double>(0.0), &ADMSl_utsoi::Model::WVARO)
    .setUnit(U_METER)
    .setDescription("Geometry-independent difference between physical and drawn field-oxide opening")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARL", static_cast<double>(0.0), &ADMSl_utsoi::Model::WVARL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of WOD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARW", static_cast<double>(0.0), &ADMSl_utsoi::Model::WVARW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of WOD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WOT", static_cast<double>(0.0), &ADMSl_utsoi::Model::WOT)
    .setUnit(U_METER)
    .setDescription("Effective reduction of channel width per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLQ", static_cast<double>(0.0), &ADMSl_utsoi::Model::DLQ)
    .setUnit(U_METER)
    .setDescription("Effective channel length additional offset for charge model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DWQ", static_cast<double>(0.0), &ADMSl_utsoi::Model::DWQ)
    .setUnit(U_METER)
    .setDescription("Effective channel width additional offset for charge model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXEO", static_cast<double>(2.0e-09), &ADMSl_utsoi::Model::TOXEO)
    .setUnit(U_METER)
    .setDescription("Front gate equivalent oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TSIO", static_cast<double>(1.0e-08), &ADMSl_utsoi::Model::TSIO)
    .setUnit(U_METER)
    .setDescription("Silicon or SiGe film thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XGEO", static_cast<double>(0.0), &ADMSl_utsoi::Model::XGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction of Ge content in the channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TBOXO", static_cast<double>(1.0e-07), &ADMSl_utsoi::Model::TBOXO)
    .setUnit(U_METER)
    .setDescription("Buried oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NCHO", static_cast<double>(0.0), &ADMSl_utsoi::Model::NCHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Thin film doping (n-type=negative value, p-type=positive value)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBO", static_cast<double>(3.0e18), &ADMSl_utsoi::Model::NSUBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Substrate doping (n-type=negative value, p-type=positive value)")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CTO)
    .setUnit(U_UNKNOWN)
    .setDescription("Interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXPO", static_cast<double>(2.0e-09), &ADMSl_utsoi::Model::TOXPO)
    .setUnit(U_METER)
    .setDescription("Front gate physical oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVO", static_cast<double>(1.0e20), &ADMSl_utsoi::Model::NOVO)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective doping of overlap-ldd regions")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVDO", static_cast<double>(1.0e20), &ADMSl_utsoi::Model::NOVDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective doping of overlap-ldd regions at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBO)
    .setUnit(U_VOLT)
    .setDescription("Geometry-independent front gate flat-band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBL", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBLEXP", static_cast<double>(2.0), &ADMSl_utsoi::Model::VFBLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent describing length dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBL2", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second order length dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBLEXP2", static_cast<double>(2.0), &ADMSl_utsoi::Model::VFBLEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent of second order length dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBW", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBLW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBBO)
    .setUnit(U_VOLT)
    .setDescription("Geometry-independent back gate flat-band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBLBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::VFBLBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Roll-off back to front interface asymmetry factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STVFBO)
    .setUnit(U_VKM1)
    .setDescription("Geometry-independent temperature dependence of VFB and VFBB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBL", static_cast<double>(0.0), &ADMSl_utsoi::Model::STVFBL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STVFBW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STVFBLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CICFO", static_cast<double>(1.0), &ADMSl_utsoi::Model::CICFO)
    .setUnit(U_UNKNOWN)
    .setDescription("Long channel front interface coupling coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CICO", static_cast<double>(1.0), &ADMSl_utsoi::Model::CICO)
    .setUnit(U_UNKNOWN)
    .setDescription("Long channel back interface coupling coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEL", static_cast<double>(0.0), &ADMSl_utsoi::Model::PSCEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCELEXP", static_cast<double>(2.0), &ADMSl_utsoi::Model::PSCELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent describing length dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEW", static_cast<double>(0.0), &ADMSl_utsoi::Model::PSCEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEBO", static_cast<double>(1.0), &ADMSl_utsoi::Model::PSCEBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Short channel back to front interface asymmetry factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSDDCO", static_cast<double>(1.0e22), &ADMSl_utsoi::Model::NSDDCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/Drain effective doping level for DC model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEDLBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::PSCEDLBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of short channel effect modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PNCEW", static_cast<double>(0.0), &ADMSl_utsoi::Model::PNCEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Narrow channel effect on body factor for a width of WEN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFL", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of DIBL-parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFLEXP", static_cast<double>(2.0), &ADMSl_utsoi::Model::CFLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFW", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFBO", static_cast<double>(1.0), &ADMSl_utsoi::Model::CFBO)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL back to front interface asymmetry factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCFL", static_cast<double>(0.0), &ADMSl_utsoi::Model::STCFL)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature dependence of CF, with same scaling as CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDO", static_cast<double>(0.2), &ADMSl_utsoi::Model::CFDO)
    .setUnit(U_VOLT)
    .setDescription("Drain voltage dependence parameter of DIBL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDLL", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFDLL)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL modulation coefficient due to Leff variation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFDLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of CFDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDLBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFDLBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of DIBL modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UO", static_cast<double>(5.0e-02), &ADMSl_utsoi::Model::UO)
    .setUnit(U_M2VM1SM1)
    .setDescription("Front channel zero-field mobility at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET1", static_cast<double>(0.0), &ADMSl_utsoi::Model::FBET1)
    .setUnit(U_UNKNOWN)
    .setDescription("First length dependence modulation of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET1W", static_cast<double>(0.0), &ADMSl_utsoi::Model::FBET1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of FBET1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP1", static_cast<double>(1.0e-08), &ADMSl_utsoi::Model::LP1)
    .setUnit(U_METER)
    .setDescription("First characteristic length of BETN scaling")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP1W", static_cast<double>(0.0), &ADMSl_utsoi::Model::LP1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of LP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET2", static_cast<double>(0.0), &ADMSl_utsoi::Model::FBET2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second length dependence modulation of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP2", static_cast<double>(1.0e-08), &ADMSl_utsoi::Model::LP2)
    .setUnit(U_METER)
    .setDescription("Second characteristic length of BETN scaling")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETW1", static_cast<double>(0.0), &ADMSl_utsoi::Model::BETW1)
    .setUnit(U_UNKNOWN)
    .setDescription("First width dependence modulation of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETW2", static_cast<double>(0.0), &ADMSl_utsoi::Model::BETW2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second width dependence modulation of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBET", static_cast<double>(1.0e-08), &ADMSl_utsoi::Model::WBET)
    .setUnit(U_METER)
    .setDescription("Characteristic width of BETN scaling")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETNBO", static_cast<double>(1.0), &ADMSl_utsoi::Model::BETNBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back channel over front channel zero-field mobility ratio")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETO", static_cast<double>(1.5), &ADMSl_utsoi::Model::STBETO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETL", static_cast<double>(0.0), &ADMSl_utsoi::Model::STBETL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STBETW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STBETLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSL", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSLEXP", static_cast<double>(1.0), &ADMSl_utsoi::Model::CSLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent describing length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSW", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSFIO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSFIO)
    .setUnit(U_UNKNOWN)
    .setDescription("Field dependence of Coulomb scattering at front interface")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSBIO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSBIO)
    .setUnit(U_UNKNOWN)
    .setDescription("Field dependence of Coulomb scattering at back interface")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCSO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STCSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCSL", static_cast<double>(0.0), &ADMSl_utsoi::Model::STCSL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of STCS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCSW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STCSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of STCS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCSLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STCSLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of STCS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THECSO", static_cast<double>(1.5), &ADMSl_utsoi::Model::THECSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHECSO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STTHECSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THECS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSTHRO", static_cast<double>(2.0), &ADMSl_utsoi::Model::CSTHRO)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering threshold level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSTHRBO", static_cast<double>(1.0), &ADMSl_utsoi::Model::CSTHRBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Remote Coulomb scattering threshold asymmetry parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MUEO", static_cast<double>(0.0), &ADMSl_utsoi::Model::MUEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Front channel mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STMUEO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STMUEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THEMUO", static_cast<double>(1.5), &ADMSl_utsoi::Model::THEMUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Front channel mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHEMUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STTHEMUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORO", static_cast<double>(0.0), &ADMSl_utsoi::Model::XCORO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-independent part of non-universality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORL", static_cast<double>(0.0), &ADMSl_utsoi::Model::XCORL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORLEXP", static_cast<double>(1.0), &ADMSl_utsoi::Model::XCORLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent describing length dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORW", static_cast<double>(0.0), &ADMSl_utsoi::Model::XCORW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::XCORLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORBO", static_cast<double>(1.0), &ADMSl_utsoi::Model::XCORBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Asymmetry term of non-universality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STXCORO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STXCORO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FETAO", static_cast<double>(1.0), &ADMSl_utsoi::Model::FETAO)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW1", static_cast<double>(30.0), &ADMSl_utsoi::Model::RSW1)
    .setUnit(U_OHM)
    .setDescription("Source/Drain series resistance for channel width WEN at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW2", static_cast<double>(0.0), &ADMSl_utsoi::Model::RSW2)
    .setUnit(U_UNKNOWN)
    .setDescription("Higher-order width scaling of source/drain series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSIGO", static_cast<double>(0.0), &ADMSl_utsoi::Model::RSIGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/Drain extension resistance coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRSO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSGO", static_cast<double>(0.0), &ADMSl_utsoi::Model::RSGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Transverse electric field dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THERSGO", static_cast<double>(2.0), &ADMSl_utsoi::Model::THERSGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Transverse electric field dependence exponent of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::RSBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATO", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATL", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATLEXP", static_cast<double>(1.0), &ADMSl_utsoi::Model::THESATLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATW", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATO", static_cast<double>((-0.1)), &ADMSl_utsoi::Model::STTHESATO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATL", static_cast<double>(0.0), &ADMSl_utsoi::Model::STTHESATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STTHESATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::STTHESATLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATGO", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Front gate bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::THESATBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back gate bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXO", static_cast<double>(8.0), &ADMSl_utsoi::Model::AXO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent linear/saturation transition exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXL", static_cast<double>(0.0), &ADMSl_utsoi::Model::AXL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXLEXP", static_cast<double>(1.0), &ADMSl_utsoi::Model::AXLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXL2", static_cast<double>(0.0), &ADMSl_utsoi::Model::AXL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second order length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXLEXP2", static_cast<double>(1.5), &ADMSl_utsoi::Model::AXLEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for second order length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPL1", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALPL1)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of CLM pre-factor ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPLEXP", static_cast<double>(1.0), &ADMSl_utsoi::Model::ALPLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPL2", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALPL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second order length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPLEXP2", static_cast<double>(2.0), &ADMSl_utsoi::Model::ALPLEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for second order length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPW", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALPW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1L1", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALP1L1)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of CLM enhancement factor above threshold ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1LEXP", static_cast<double>(0.5), &ADMSl_utsoi::Model::ALP1LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1L2", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALP1L2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second order length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1LEXP2", static_cast<double>(1.5), &ADMSl_utsoi::Model::ALP1LEXP2)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for second order length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1W", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALP1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::ALPBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back bias dependence of channel length modulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPO", static_cast<double>(0.05), &ADMSl_utsoi::Model::VPO)
    .setUnit(U_VOLT)
    .setDescription("CLM logarithm dependence factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPGO", static_cast<double>(0.0), &ADMSl_utsoi::Model::VPGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Transverse electric field dependence of CLM logarithm factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCOO", static_cast<double>(0.0), &ADMSl_utsoi::Model::GCOO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunneling energy adjustment in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGINVLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGINVLW)
    .setUnit(U_AMP)
    .setDescription("Gate to channel current pre-factor for a channel area of WEN.LEN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVINVW", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVINVW)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor for a width of WEN in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVINVDW", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVINVDW)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor for a width of WEN in inversion at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVACCW", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVACCW)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor for a width of WEN in accumulation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVACCDW", static_cast<double>(0.0), &ADMSl_utsoi::Model::IGOVACCDW)
    .setUnit(U_AMP)
    .setDescription("Gate to overlap current pre-factor for a width of WEN in accumulation at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STIGO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STIGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of all gate currents")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2CHO", static_cast<double>(0.375), &ADMSl_utsoi::Model::GC2CHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate to channel current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3CHO", static_cast<double>(0.063), &ADMSl_utsoi::Model::GC3CHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate to channel current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2OVINVO", static_cast<double>(0.375), &ADMSl_utsoi::Model::GC2OVINVO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor for overlap regions in inversion mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3OVINVO", static_cast<double>(0.063), &ADMSl_utsoi::Model::GC3OVINVO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current curvature factor for overlap regions in inversion mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2OVACCO", static_cast<double>(0.375), &ADMSl_utsoi::Model::GC2OVACCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor for overlap regions in accumulation mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3OVACCO", static_cast<double>(0.063), &ADMSl_utsoi::Model::GC3OVACCO)
    .setUnit(U_UNKNOWN)
    .setDescription(" Gate current curvature factor for overlap regions in accumulation mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCDOVL", static_cast<double>(0.0), &ADMSl_utsoi::Model::GCDOVL)
    .setUnit(U_VOLTM1)
    .setDescription("High drain voltage dependence of overlap gate current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCVDOVO", static_cast<double>(1.0), &ADMSl_utsoi::Model::GCVDOVO)
    .setUnit(U_VOLT)
    .setDescription("Threshold of high drain voltage effect on overlap gate current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CHIBO", static_cast<double>(3.1), &ADMSl_utsoi::Model::CHIBO)
    .setUnit(U_VOLT)
    .setDescription("Tunneling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NIGINVO", static_cast<double>(0.0), &ADMSl_utsoi::Model::NIGINVO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunneling slope adjustment in subthreshold regime")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNOVINVW", static_cast<double>(0.0), &ADMSl_utsoi::Model::FNOVINVW)
    .setUnit(U_AMP)
    .setDescription("Extra gate to overlap current pre-factor for a width of WEN in inversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNOVINVDW", static_cast<double>(0.0), &ADMSl_utsoi::Model::FNOVINVDW)
    .setUnit(U_AMP)
    .setDescription("Extra gate to overlap current pre-factor for a width of WEN in inversion at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCOVINVFNO", static_cast<double>(0.2), &ADMSl_utsoi::Model::GCOVINVFNO)
    .setUnit(U_UNKNOWN)
    .setDescription("Extra gate current slope factor for overlap regions in inversion mode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STIGFNO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STIGFNO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of extra gate to overlap current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLO", static_cast<double>(0.0), &ADMSl_utsoi::Model::AGIDLO)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL geometry independent pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLDO", static_cast<double>(0.0), &ADMSl_utsoi::Model::AGIDLDO)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL geometry independent pre-factor at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::AGIDLW)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor for a width of WEN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLDW", static_cast<double>(0.0), &ADMSl_utsoi::Model::AGIDLDW)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor for a width of WEN at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLO", static_cast<double>(41.0), &ADMSl_utsoi::Model::BGIDLO)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLDO", static_cast<double>(41.0), &ADMSl_utsoi::Model::BGIDLDO)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STBGIDLO)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLDO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STBGIDLDO)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CGIDLO)
    .setUnit(U_VOLTM1)
    .setDescription("Substrate bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLDO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CGIDLDO)
    .setUnit(U_VOLTM1)
    .setDescription("Substrate bias dependence of GIDL at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGIDLO", static_cast<double>(0.0), &ADMSl_utsoi::Model::DGIDLO)
    .setUnit(U_VOLTM1)
    .setDescription("High field geometry independent parameter of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGIDLDO", static_cast<double>(0.0), &ADMSl_utsoi::Model::DGIDLDO)
    .setUnit(U_VOLTM1)
    .setDescription("High field geometry independent parameter of GIDL at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGIDLL", static_cast<double>(0.0), &ADMSl_utsoi::Model::DGIDLL)
    .setUnit(U_VOLTM1)
    .setDescription("High longitudinal field parameter of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DGIDLDL", static_cast<double>(0.0), &ADMSl_utsoi::Model::DGIDLDL)
    .setUnit(U_VOLTM1)
    .setDescription("High longitudinal field parameter of GIDL at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1O", static_cast<double>(1.0), &ADMSl_utsoi::Model::A1O)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent impact ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1L", static_cast<double>(0.0), &ADMSl_utsoi::Model::A1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1W", static_cast<double>(0.0), &ADMSl_utsoi::Model::A1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A2O", static_cast<double>(10.0), &ADMSl_utsoi::Model::A2O)
    .setUnit(U_UNKNOWN)
    .setDescription("Impact ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STA2O", static_cast<double>(0.0), &ADMSl_utsoi::Model::STA2O)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3O", static_cast<double>(1.0), &ADMSl_utsoi::Model::A3O)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent saturation-voltage dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3L", static_cast<double>(0.0), &ADMSl_utsoi::Model::A3L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3W", static_cast<double>(0.0), &ADMSl_utsoi::Model::A3W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBOVO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CGBOVO)
    .setUnit(U_FARAD)
    .setDescription("Geometry independent gate-substrate overlap capacitance part")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBOVL", static_cast<double>(0.0), &ADMSl_utsoi::Model::CGBOVL)
    .setUnit(U_FARAD)
    .setDescription("Length dependent gate-substrate overlap capacitance part for a length of LEN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSDACO", static_cast<double>(1.0e22), &ADMSl_utsoi::Model::NSDACO)
    .setUnit(U_UNKNOWN)
    .setDescription("Source/Drain effective doping level for AC model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FIFW", static_cast<double>(0.0), &ADMSl_utsoi::Model::FIFW)
    .setUnit(U_UNKNOWN)
    .setDescription("Inner fringe capacitance prefactor for a width of WEN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FSCEACO", static_cast<double>(0.0), &ADMSl_utsoi::Model::FSCEACO)
    .setUnit(U_UNKNOWN)
    .setDescription("Short channel effect adjustment factor for charge model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LOVO", static_cast<double>(0.0), &ADMSl_utsoi::Model::LOVO)
    .setUnit(U_METER)
    .setDescription("Overlap length for gate/source-drain hdd overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LOVDO", static_cast<double>(0.0), &ADMSl_utsoi::Model::LOVDO)
    .setUnit(U_METER)
    .setDescription("Overlap length for gate/drain hdd overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVDLO", static_cast<double>(0.0), &ADMSl_utsoi::Model::COVDLO)
    .setUnit(U_UNKNOWN)
    .setDescription("Overlap capacitance modulation coefficient due to Leff variation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVDLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::COVDLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of COVDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COVDLBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::COVDLBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Overlap capacitance modulation with back bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVFBOVO", static_cast<double>(0.0), &ADMSl_utsoi::Model::DVFBOVO)
    .setUnit(U_VOLT)
    .setDescription("Overlap capacitance flat-band voltage adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFRO)
    .setUnit(U_FARAD)
    .setDescription("Corner related outer fringe capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRDO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFRDO)
    .setUnit(U_FARAD)
    .setDescription("Corner related outer fringe capacitance at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRW", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFRW)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance per side for a width of WEN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRDW", static_cast<double>(0.0), &ADMSl_utsoi::Model::CFRDW)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance per side for a width of WEN at drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSDO", static_cast<double>(1.0), &ADMSl_utsoi::Model::CSDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain-source capacitance correction factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSDBPO", static_cast<double>(0.0), &ADMSl_utsoi::Model::CSDBPO)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain/source to substrate perimeter capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTHO", static_cast<double>(1.0e05), &ADMSl_utsoi::Model::RTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTHL", static_cast<double>(1.5), &ADMSl_utsoi::Model::RTHL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of RTH")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTHW", static_cast<double>(3.0), &ADMSl_utsoi::Model::RTHW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of RTH")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTHLW", static_cast<double>(4.5), &ADMSl_utsoi::Model::RTHLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of RTH")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRTHO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RTH")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTHO", static_cast<double>(1.0e-12), &ADMSl_utsoi::Model::CTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAMBTHO", static_cast<double>(1.0e-07), &ADMSl_utsoi::Model::LAMBTHO)
    .setUnit(U_METER)
    .setDescription("Characteristic length of lateral thermal coupling for multifinger devices")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FTHO", static_cast<double>(0.0), &ADMSl_utsoi::Model::FTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("First neighbour thermal coupling factor for multifinger devices")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTO", static_cast<double>(1.0), &ADMSl_utsoi::Model::FNTO)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEXCL", static_cast<double>(0.0), &ADMSl_utsoi::Model::FNTEXCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of excess noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEXCLEXP", static_cast<double>(2.0), &ADMSl_utsoi::Model::FNTEXCLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence exponent of excess noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFALW", static_cast<double>(8.0e22), &ADMSl_utsoi::Model::NFALW)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFAW", static_cast<double>(0.0), &ADMSl_utsoi::Model::NFAW)
    .setUnit(U_UNKNOWN)
    .setDescription("Long channel first coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFBLW", static_cast<double>(3.0e07), &ADMSl_utsoi::Model::NFBLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFCLW", static_cast<double>(0.0), &ADMSl_utsoi::Model::NFCLW)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFEO", static_cast<double>(0.0), &ADMSl_utsoi::Model::NFEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise front transverse field effect coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFEBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::NFEBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise back transverse field effect coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EFO", static_cast<double>(1.0), &ADMSl_utsoi::Model::EFO)
    .setUnit(U_UNKNOWN)
    .setDescription("Frequency coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWSTRESS", static_cast<int>(1), &ADMSl_utsoi::Model::SWSTRESS)
    .setUnit(U_UNKNOWN)
    .setDescription("Stress model selection flag: 0=disable, 1=classical STI stress model, 2=strained channel stress model");
  p.addPar("SAREF", static_cast<double>(1.0e-06), &ADMSl_utsoi::Model::SAREF)
    .setUnit(U_METER)
    .setDescription("Reference distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SBREF", static_cast<double>(1.0e-06), &ADMSl_utsoi::Model::SBREF)
    .setUnit(U_METER)
    .setDescription("Reference distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLOD", static_cast<double>(0.0), &ADMSl_utsoi::Model::WLOD)
    .setUnit(U_METER)
    .setDescription("Width parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::KUO)
    .setUnit(U_METER)
    .setDescription("Mobility degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVSAT", static_cast<double>(0.0), &ADMSl_utsoi::Model::KVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation velocity degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TKUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::TKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::LKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::WKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::PKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODKUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::LLODKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODKUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::WLODKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHO", static_cast<double>(0.0), &ADMSl_utsoi::Model::KVTHO)
    .setUnit(U_VM)
    .setDescription("Threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKVTHO", static_cast<double>(0.0), &ADMSl_utsoi::Model::LKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKVTHO", static_cast<double>(0.0), &ADMSl_utsoi::Model::WKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKVTHO", static_cast<double>(0.0), &ADMSl_utsoi::Model::PKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODVTH", static_cast<double>(0.0), &ADMSl_utsoi::Model::LLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Length parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODVTH", static_cast<double>(0.0), &ADMSl_utsoi::Model::WLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Width parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STETAO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STETAO)
    .setUnit(U_METER)
    .setDescription("Eta0 shift factor related to VTHO change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LODETAO", static_cast<double>(1.0), &ADMSl_utsoi::Model::LODETAO)
    .setUnit(U_UNKNOWN)
    .setDescription("Eta0 shift modification factor for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRLAMBDA", static_cast<double>(1.0e-07), &ADMSl_utsoi::Model::STRLAMBDA)
    .setUnit(U_METER)
    .setDescription("Relaxation characteristic length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRALPHA", static_cast<double>(3.0), &ADMSl_utsoi::Model::STRALPHA)
    .setUnit(U_UNKNOWN)
    .setDescription("Asymmetry parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRDVFBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRDVFBO)
    .setUnit(U_VOLT)
    .setDescription("Threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRWDVFBO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRWDVFBO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRDCFL", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRDCFL)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL variation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRRUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRRUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRTRUO", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRTRUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of mobility degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRRVSAT", static_cast<double>(0.0), &ADMSl_utsoi::Model::STRRVSAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation velocity degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter L : [ 1.0e-09,  (+inf) [
  if ( (!((L >=1.0e-09))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter L value " << L << " out of range [ 1.0e-09,  (+inf) [";
  }

//    Parameter W : [ 1.0e-09,  (+inf) [
  if ( (!((W >=1.0e-09))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter W value " << W << " out of range [ 1.0e-09,  (+inf) [";
  }

//    Parameter ASOURCE : [ 0,  (+inf) [
  if ( (!((ASOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter ASOURCE value " << ASOURCE << " out of range [ 0,  (+inf) [";
  }

//    Parameter ADRAIN : [ 0,  (+inf) [
  if ( (!((ADRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter ADRAIN value " << ADRAIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSOURCE : [ 0,  (+inf) [
  if ( (!((PSOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PSOURCE value " << PSOURCE << " out of range [ 0,  (+inf) [";
  }

//    Parameter PDRAIN : [ 0,  (+inf) [
  if ( (!((PDRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PDRAIN value " << PDRAIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter SA : [ 0,  (+inf) [
  if ( (!((SA >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SA value " << SA << " out of range [ 0,  (+inf) [";
  }

//    Parameter SB : [ 0,  (+inf) [
  if ( (!((SB >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SB value " << SB << " out of range [ 0,  (+inf) [";
  }

//    Parameter SD : [ 0,  (+inf) [
  if ( (!((SD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SD value " << SD << " out of range [ 0,  (+inf) [";
  }

//    Parameter NF : [ 1,  (+inf) [
  if ( (!((NF >=1))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NF value " << NF << " out of range [ 1,  (+inf) [";
  }

//    Parameter MULT : [ 0,  (+inf) [
  if ( (!((MULT >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter MULT value " << MULT << " out of range [ 0,  (+inf) [";
  }

//    Parameter FACTUO : [ 0,  (+inf) [
  if ( (!((FACTUO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FACTUO value " << FACTUO << " out of range [ 0,  (+inf) [";
  }

//    Parameter M : [ 0,  (+inf) [
  if ( (!((M >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter M value " << M << " out of range [ 0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double xb_sub=0.0;
  double Ceq_1D=0.0;
  double Cox1Init=0.0;
  double neff_sub=0.0;
  double AX_i=0.0;
  double FETA_i=0.0;
  double CSTHRB_i=0.0;
  double CSTHR_i=0.0;
  double PNCE_i=0.0;
  double NSUB_i=0.0;
  double NCH_i=0.0;
  double TYPECH_i=0.0;
  double TOX2_i=0.0;
  double TOX1_i=0.0;
  double temp0=0.0;
  double Kstressvth0=0.0;
  double rhobetaref=0.0;
  double rhobeta=0.0;
  double Kstressu0=0.0;
  double tempw=0.0;
  double templ=0.0;
  double Wx=0.0;
  double Lx=0.0;
  double Invsbref=0.0;
  double Invsaref=0.0;
  double Invsb=0.0;
  double Invsa=0.0;
  double iloop=0.0;
  double tmpb=0.0;
  double tmpa=0.0;
  double ruo=0.0;
  double str_gref=0.0;
  double str_g=0.0;
  double NFA_p=0.0;
  double CTH_p=0.0;
  double RTH_p=0.0;
  double CFRD_p=0.0;
  double CFR_p=0.0;
  double CGBOV_p=0.0;
  double A3_p=0.0;
  double A1_p=0.0;
  double AGIDLD_p=0.0;
  double AGIDL_p=0.0;
  double ALP1_p=0.0;
  double ALP_p=0.0;
  double AX_p=0.0;
  double THESAT_p=0.0;
  double RS_p=0.0;
  double CS_p=0.0;
  double BETN_p=0.0;
  double GE=0.0;
  double GWE=0.0;
  double GPE=0.0;
  double CF_p=0.0;
  double PNCE_p=0.0;
  double PSCE_p=0.0;
  double lambda_LE=0.0;
  double wphy=0.0;
  double lphy=0.0;
  double iAE=0.0;
  double iWE=0.0;
  double iLE=0.0;
  double WEcv=0.0;
  double LEcv=0.0;
  double WE=0.0;
  double LE=0.0;
  double delWOD=0.0;
  double delLPS=0.0;
  double iW=0.0;
  double iL=0.0;
  double WEN=0.0;
  double LEN=0.0;
  double W_i=0.0;
  double invNF=0.0;
//Begin block initial_instance
{

d_DTC_dTemp_Tnode_GND =  0.0;
DTC = 0.0;

d_TKC_dTemp_Tnode_GND =  0.0;
TKC = (model_.TKD);

d_TKC_sq_dTemp_Tnode_GND =  0.0;
TKC_sq = (TKC*TKC);

d_dT_dTemp_Tnode_GND =  0.0;
dT = (TKC-(model_.TKR));

d_rT_dTemp_Tnode_GND =  0.0;
rT = (TKC/(model_.TKR));

d_rTn_dTemp_Tnode_GND =  0.0;
rTn = ((model_.TKR)/TKC);

d_phit0_dTemp_Tnode_GND =  0.0;
phit0 = (TKC*8.617332384961E-05);

d_inv_phit0_dTemp_Tnode_GND =  0.0;
inv_phit0 = (1.0/phit0);
if (((model_.SWSCALE)==0))
{
ADRAIN_i = ADRAIN;
ASOURCE_i = ASOURCE;
PDRAIN_i = PDRAIN;
PSOURCE_i = PSOURCE;
MULT_i = MULT;
TOX1_i = (model_.TOXE);
TSI_i = (model_.TSI);
XGE_i = (model_.XGE);
TOX2_i = (model_.TBOX);
TYPECH_i = 1.0;
if (((model_.NCH)<0))
{
TYPECH_i = (-1.0);
}
{
double value_fabs_0 = fabs((model_.NCH));
double value_min_1 = std::min(value_fabs_0,static_cast<double>(1.0e19));
NCH_i = (value_min_1*1.0e6);
}
TYPESUB_i = 1.0;
if (((model_.NSUB)<0))
{
TYPESUB_i = (-1.0);
}
{
double value_fabs_0 = fabs((model_.NSUB));
double value_max_1 = std::max(value_fabs_0,static_cast<double>(1.0e16));
double value_min_2 = std::min(value_max_1,static_cast<double>(1.0e21));
NSUB_i = (value_min_2*1.0e6);
}
CT_i = (model_.CT);
TOXP_i = (model_.TOXP);
NOV_i = ((model_.NOV)*1.0e6);
NOVD_i = ((model_.NOVD)*1.0e6);
VFB1_t = (model_.VFB);
VFB2_t = (model_.VFBB);
STVFB_i = (model_.STVFB);
CIC1_i = (model_.CICF);
CIC2_i = (model_.CIC);
PSCE1_i = (model_.PSCE);
PSCE2_i = ((((model_.PSCEB)*PSCE1_i)*TOX2_i)/TOX1_i);
NSDDC_i = ((model_.NSDDC)*1.0e6);
PSCEDLB_i = (model_.PSCEDLB);
PNCE_i = (model_.PNCE);
CF1_t = (model_.CF);
CF2_t = ((((model_.CFB)*CF1_t)*TOX2_i)/TOX1_i);
STCF_i = (model_.STCF);
CFD_i = (model_.CFD);
CFDL_i = (model_.CFDL);
CFDLB_i = (model_.CFDLB);
BETN1_t = (model_.BETN);
BETN2_t = ((model_.BETNB)*BETN1_t);
STBET_i = (model_.STBET);
CS_t = (model_.CS);
CSFI_i = (model_.CSFI);
CSBI_i = (model_.CSBI);
STCS_i = (model_.STCS);
THECS_t = (model_.THECS);
STTHECS_i = (model_.STTHECS);
CSTHR_i = (model_.CSTHR);
CSTHRB_i = (model_.CSTHRB);
MUE_t = (model_.MUE);
STMUE_i = (model_.STMUE);
THEMU_t = (model_.THEMU);
STTHEMU_i = (model_.STTHEMU);
XCOR_t = (model_.XCOR);
XCORB_i = (model_.XCORB);
STXCOR_i = (model_.STXCOR);
FETA_i = (model_.FETA);
RS_t = (model_.RS);
RSIG_i = (model_.RSIG);
STRS_i = (model_.STRS);
RSG_i = (model_.RSG);
THERSG_i = (model_.THERSG);
RSB_i = (model_.RSB);
THESAT_t = (model_.THESAT);
STTHESAT_i = (model_.STTHESAT);
THESAT1_i = (model_.THESATG);
THESAT2_i = (model_.THESATB);
AX_i = (model_.AX);
ALP_i = (model_.ALP);
ALP1_i = (model_.ALP1);
ALPB_i = (model_.ALPB);
VP_i = (model_.VP);
VPG_i = (model_.VPG);
GCO_i = (model_.GCO);
IGINV_t = (model_.IGINV);
IGOVINV_t = (model_.IGOVINV);
IGOVINVD_t = (model_.IGOVINVD);
FNOVINV_t = (model_.FNOVINV);
FNOVINVD_t = (model_.FNOVINVD);
IGOVACC_t = (model_.IGOVACC);
IGOVACCD_t = (model_.IGOVACCD);
STIG_i = (model_.STIG);
STIGFN_i = (model_.STIGFN);
GC2CH_i = (model_.GC2CH);
GC3CH_i = (model_.GC3CH);
GC2OVINV_i = (model_.GC2OVINV);
GCOVINVFN_i = (model_.GCOVINVFN);
GC3OVINV_i = (model_.GC3OVINV);
GC2OVACC_i = (model_.GC2OVACC);
GC3OVACC_i = (model_.GC3OVACC);
GCDOV_i = (model_.GCDOV);
GCVDOV_i = (model_.GCVDOV);
CHIB_i = (model_.CHIB);
NIGINV_i = (model_.NIGINV);
AGIDL_i = (model_.AGIDL);
AGIDLD_i = (model_.AGIDLD);
BGIDL_t = (model_.BGIDL);
BGIDLD_t = (model_.BGIDLD);
STBGIDL_i = (model_.STBGIDL);
STBGIDLD_i = (model_.STBGIDLD);
CGIDL_i = (model_.CGIDL);
CGIDLD_i = (model_.CGIDLD);
DGIDL_i = (model_.DGIDL);
DGIDLD_i = (model_.DGIDLD);
A1_i = (model_.A1);
A2_t = (model_.A2);
STA2_i = (model_.STA2);
A3_i = (model_.A3);
AREAQ_i = (model_.AREAQ);
CGBOV_i = (model_.CGBOV);
NSDAC_i = ((model_.NSDAC)*1.0e6);
FIF_i = (model_.FIF);
FSCEAC_i = (model_.FSCEAC);
COV_i = (model_.COV);
COVD_i = (model_.COVD);
COVDL_i = (model_.COVDL);
COVDLB_i = (model_.COVDLB);
DVFBOV_i = (model_.DVFBOV);
CFR_i = (model_.CFR);
CFRD_i = (model_.CFRD);
CSD_i = (model_.CSD);
CSDBP_i = (model_.CSDBP);
RTH_t = (model_.RTH);
STRTH_i = (model_.STRTH);
CTH_i = (model_.CTH);
FNT_i = (model_.FNT);
FNTEXC_i = (model_.FNTEXC);
NFA_i = (model_.NFA);
NFB_i = (model_.NFB);
NFC_i = (model_.NFC);
NFE_i = (model_.NFE);
NFEB_i = (model_.NFEB);
EF_i = (model_.EF);
}
else
{
invNF = (1.0/NF);
{
double value_max_0 = std::max((W*invNF),static_cast<double>(1.0e-9));
W_i = value_max_0;
}
ADRAIN_i = (ADRAIN*invNF);
ASOURCE_i = (ASOURCE*invNF);
PDRAIN_i = (PDRAIN*invNF);
PSOURCE_i = (PSOURCE*invNF);
MULT_i = (MULT*NF);
LEN = 1.0e-6;
WEN = 1.0e-6;
iL = (LEN/L);
iW = (WEN/W_i);
delLPS = (((model_.LVARO)*(1.0+((model_.LVARL)*iL)))*(1.0+((model_.LVARW)*iW)));
delWOD = (((model_.WVARO)*(1.0+((model_.WVARW)*iW)))*(1.0+((model_.WVARL)*iL)));
{
double value_max_0 = std::max(((L+delLPS)-(2.0*(model_.LAP))),static_cast<double>(1.0e-9));
LE = value_max_0;
}
{
double value_max_0 = std::max(((W_i+delWOD)-(2.0*(model_.WOT))),static_cast<double>(1.0e-9));
WE = value_max_0;
}
{
double value_max_0 = std::max((((L+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ)),static_cast<double>(1.0e-9));
LEcv = value_max_0;
}
{
double value_max_0 = std::max((((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ)),static_cast<double>(1.0e-9));
WEcv = value_max_0;
}
iLE = (LEN/LE);
iWE = (WEN/WE);
iAE = (iLE*iWE);
{
double value_max_0 = std::max((L+delLPS),static_cast<double>(1.0e-9));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = value_max_0;
}
lphy = (temp/LEN);
{
double value_max_0 = std::max((W_i+delWOD),static_cast<double>(1.0e-9));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = value_max_0;
}
wphy = (temp/WEN);
TOX1_i = (model_.TOXEO);
TSI_i = (model_.TSIO);
XGE_i = (model_.XGEO);
TOX2_i = (model_.TBOXO);
TYPECH_i = 1.0;
if (((model_.NCHO)<0))
{
TYPECH_i = (-1.0);
}
{
double value_fabs_0 = fabs((model_.NCHO));
double value_min_1 = std::min(value_fabs_0,static_cast<double>(1.0e19));
NCH_i = (value_min_1*1.0e6);
}
TYPESUB_i = 1.0;
if (((model_.NSUBO)<0))
{
TYPESUB_i = (-1.0);
}
{
double value_fabs_0 = fabs((model_.NSUBO));
double value_max_1 = std::max(value_fabs_0,static_cast<double>(1.0e16));
double value_min_2 = std::min(value_max_1,static_cast<double>(1.0e21));
NSUB_i = (value_min_2*1.0e6);
}
CT_i = (model_.CTO);
TOXP_i = (model_.TOXPO);
NOV_i = ((model_.NOVO)*1.0e6);
NOVD_i = ((model_.NOVDO)*1.0e6);
{
double value_pow_0 = pow(iLE,(model_.VFBLEXP));
double value_pow_1 = pow(iLE,(model_.VFBLEXP2));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (((model_.VFBL)*value_pow_0)/(1.0+((model_.VFBL2)*value_pow_1)));
}
VFB1_t = ((((model_.VFBO)+temp)+((model_.VFBW)*iWE))+((model_.VFBLW)*iAE));
VFB2_t = ((model_.VFBBO)+((((model_.VFBLBO)*TOX2_i)/TOX1_i)*temp));
STVFB_i = ((((model_.STVFBO)*(1.0+((model_.STVFBL)*iLE)))*(1.0+((model_.STVFBW)*iWE)))*(1.0+((model_.STVFBLW)*iAE)));
CIC1_i = (model_.CICFO);
CIC2_i = (model_.CICO);
one_m_xge = (1.0-XGE_i);
epsch = ((1.04479E-10*one_m_xge)+(1.43438E-10*XGE_i));
{
double value_sqrt_0 = sqrt((((epsch/3.45313E-11)*TSI_i)*(TOX1_i+4.0e-10)));
lambda_LE = (value_sqrt_0/LE);
}
{
double value_pow_0 = pow(lambda_LE,(model_.PSCELEXP));
PSCE_p = ((((model_.PSCEL)*2.0)*value_pow_0)*(1.0+((model_.PSCEW)*iWE)));
}
{
double value_max_0 = std::max(PSCE_p,static_cast<double>(0.0));
double value_min_1 = std::min(value_max_0,static_cast<double>(5.0));
PSCE1_i = value_min_1;
}
PSCE2_i = ((((model_.PSCEBO)*PSCE1_i)*TOX2_i)/TOX1_i);
NSDDC_i = ((model_.NSDDCO)*1.0e6);
PSCEDLB_i = (model_.PSCEDLBO);
PNCE_p = ((model_.PNCEW)*iWE);
{
double value_max_0 = std::max(PNCE_p,(-1.0));
double value_min_1 = std::min(value_max_0,static_cast<double>(1.0));
PNCE_i = value_min_1;
}
{
double value_pow_0 = pow(lambda_LE,(model_.CFLEXP));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (value_pow_0*(1.0+((model_.CFW)*iWE)));
}
CF_p = ((model_.CFL)*temp);
{
double value_max_0 = std::max(CF_p,static_cast<double>(0.0));
CF1_t = value_max_0;
}
CF2_t = ((((model_.CFBO)*CF1_t)*TOX2_i)/TOX1_i);
STCF_i = ((model_.STCFL)*temp);
CFD_i = (model_.CFDO);
{
double value_max_0 = std::max((1.0+((model_.CFDLW)*iWE)),static_cast<double>(1.0e-3));
CFDL_i = (((model_.CFDLL)*iLE)/value_max_0);
}
CFDLB_i = (model_.CFDLBO);
{
double value_max_0 = std::max((1.0+((model_.LP1W)*iWE)),static_cast<double>(1.0e-3));

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = ((-LE)/((model_.LP1)*value_max_0));
}
if ((temp1>(-80.0)))
{
{
double value_exp_0 = exp(temp1);

d_temp2_dV_G_S = d_temp2_dTemp_Tnode_GND = d_temp2_dV_D_S = d_temp2_dV_S_B =  0.0;
temp2 = value_exp_0;
}
}
else
{

d_temp2_dV_G_S = d_temp2_dTemp_Tnode_GND = d_temp2_dV_D_S = d_temp2_dV_S_B =  0.0;
temp2 = (1.80485e-35/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
}

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = ((-LE)/(model_.LP2));
if ((temp3>(-80.0)))
{
{
double value_exp_0 = exp(temp3);

d_temp4_dV_G_S = d_temp4_dV_D_S = d_temp4_dTemp_Tnode_GND = d_temp4_dV_S_B =  0.0;
temp4 = value_exp_0;
}
}
else
{

d_temp4_dV_G_S = d_temp4_dV_D_S = d_temp4_dTemp_Tnode_GND = d_temp4_dV_S_B =  0.0;
temp4 = (1.80485e-35/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
}
{
double value_max_0 = std::max(((1.0+((((model_.FBET1)*(1.0+((model_.FBET1W)*iWE)))*(temp2-1.0))/temp1))+(((model_.FBET2)*(temp4-1.0))/temp3)),static_cast<double>(1.0e-6));
GPE = value_max_0;
}
{
double value_log_0 = log((1.0+(WE/(model_.WBET))));
double value_max_1 = std::max(((1.0+((model_.BETW1)*iWE))+(((model_.BETW2)*iWE)*value_log_0)),static_cast<double>(1.0e-6));
GWE = value_max_1;
}
GE = (((model_.UO)/GPE)*GWE);
BETN_p = ((GE*WE)/LE);
{
double value_max_0 = std::max(BETN_p,static_cast<double>(1.0e-10));
BETN1_t = value_max_0;
}
BETN2_t = ((model_.BETNBO)*BETN1_t);
STBET_i = ((((model_.STBETO)*(1.0+((model_.STBETL)*iLE)))*(1.0+((model_.STBETW)*iWE)))*(1.0+((model_.STBETLW)*iAE)));
{
double value_pow_0 = pow(iLE,(model_.CSLEXP));
CS_p = ((((model_.CSO)+((model_.CSL)*value_pow_0))*(1.0+((model_.CSW)*iWE)))*(1.0+((model_.CSLW)*iAE)));
}
{
double value_max_0 = std::max(CS_p,static_cast<double>(0.0));
CS_t = value_max_0;
}
CSFI_i = (model_.CSFIO);
CSBI_i = (model_.CSBIO);
STCS_i = ((((model_.STCSO)*(1.0+((model_.STCSL)*iLE)))*(1.0+((model_.STCSW)*iWE)))*(1.0+((model_.STCSLW)*iAE)));
THECS_t = (model_.THECSO);
STTHECS_i = (model_.STTHECSO);
CSTHR_i = (model_.CSTHRO);
CSTHRB_i = (model_.CSTHRBO);
MUE_t = (model_.MUEO);
STMUE_i = (model_.STMUEO);
THEMU_t = (model_.THEMUO);
STTHEMU_i = (model_.STTHEMUO);
{
double value_pow_0 = pow(iLE,(model_.XCORLEXP));
XCOR_t = ((((model_.XCORO)+((model_.XCORL)*value_pow_0))*(1.0+((model_.XCORW)*iWE)))*(1.0+((model_.XCORLW)*iAE)));
}
XCORB_i = (model_.XCORBO);
STXCOR_i = (model_.STXCORO);
FETA_i = (model_.FETAO);
RS_p = (((model_.RSW1)*iWE)*(1.0+((model_.RSW2)*iWE)));
{
double value_max_0 = std::max(RS_p,static_cast<double>(0.0));
RS_t = value_max_0;
}
RSIG_i = (model_.RSIGO);
STRS_i = (model_.STRSO);
RSG_i = (model_.RSGO);
THERSG_i = (model_.THERSGO);
RSB_i = (model_.RSBO);
{
double value_pow_0 = pow(iLE,(model_.THESATLEXP));
THESAT_p = (((GE*((model_.THESATO)+((model_.THESATL)*value_pow_0)))*(1.0+((model_.THESATW)*iWE)))*(1.0+((model_.THESATLW)*iAE)));
}
{
double value_max_0 = std::max(THESAT_p,static_cast<double>(0.0));
THESAT_t = value_max_0;
}
STTHESAT_i = ((((model_.STTHESATO)*(1.0+((model_.STTHESATL)*iLE)))*(1.0+((model_.STTHESATW)*iWE)))*(1.0+((model_.STTHESATLW)*iAE)));
THESAT1_i = (model_.THESATGO);
THESAT2_i = (model_.THESATBO);
{
double value_pow_0 = pow(iLE,(model_.AXLEXP));
double value_pow_1 = pow(iLE,(model_.AXLEXP2));
AX_p = ((model_.AXO)/(1.0+(((model_.AXL)*value_pow_0)/(1.0+((model_.AXL2)*value_pow_1)))));
}
{
double value_max_0 = std::max(AX_p,static_cast<double>(1.0));
double value_min_1 = std::min(value_max_0,static_cast<double>(16.0));
AX_i = value_min_1;
}
{
double value_pow_0 = pow(iLE,(model_.ALPLEXP));
double value_pow_1 = pow(iLE,(model_.ALPLEXP2));
ALP_p = ((((model_.ALPL1)*value_pow_0)*(1.0+((model_.ALPW)*iWE)))/(1.0+((model_.ALPL2)*value_pow_1)));
}
{
double value_max_0 = std::max(ALP_p,static_cast<double>(0.0));
ALP_i = value_max_0;
}
{
double value_pow_0 = pow(iLE,(model_.ALP1LEXP));
double value_pow_1 = pow(iLE,(model_.ALP1LEXP2));
ALP1_p = ((((model_.ALP1L1)*value_pow_0)*(1.0+((model_.ALP1W)*iWE)))/(1.0+((model_.ALP1L2)*value_pow_1)));
}
{
double value_max_0 = std::max(ALP1_p,static_cast<double>(0.0));
ALP1_i = value_max_0;
}
ALPB_i = (model_.ALPBO);
VP_i = (model_.VPO);
VPG_i = (model_.VPGO);
GCO_i = (model_.GCOO);
IGINV_t = ((model_.IGINVLW)/iAE);
IGOVINV_t = ((model_.IGOVINVW)/iWE);
IGOVINVD_t = ((model_.IGOVINVDW)/iWE);
FNOVINV_t = ((model_.FNOVINVW)/iWE);
FNOVINVD_t = ((model_.FNOVINVDW)/iWE);
IGOVACC_t = ((model_.IGOVACCW)/iWE);
IGOVACCD_t = ((model_.IGOVACCDW)/iWE);
STIG_i = (model_.STIGO);
STIGFN_i = (model_.STIGFNO);
GC2CH_i = (model_.GC2CHO);
GC3CH_i = (model_.GC3CHO);
GC2OVINV_i = (model_.GC2OVINVO);
GCOVINVFN_i = (model_.GCOVINVFNO);
GC3OVINV_i = (model_.GC3OVINVO);
GC2OVACC_i = (model_.GC2OVACCO);
GC3OVACC_i = (model_.GC3OVACCO);
GCDOV_i = ((model_.GCDOVL)*iLE);
GCVDOV_i = (model_.GCVDOVO);
CHIB_i = (model_.CHIBO);
NIGINV_i = (model_.NIGINVO);
AGIDL_p = ((model_.AGIDLO)+((model_.AGIDLW)/iWE));
{
double value_max_0 = std::max(AGIDL_p,static_cast<double>(0.0));
AGIDL_i = value_max_0;
}
AGIDLD_p = ((model_.AGIDLDO)+((model_.AGIDLDW)/iWE));
{
double value_max_0 = std::max(AGIDLD_p,static_cast<double>(0.0));
AGIDLD_i = value_max_0;
}
BGIDL_t = (model_.BGIDLO);
BGIDLD_t = (model_.BGIDLDO);
STBGIDL_i = (model_.STBGIDLO);
STBGIDLD_i = (model_.STBGIDLDO);
CGIDL_i = (model_.CGIDLO);
CGIDLD_i = (model_.CGIDLDO);
DGIDL_i = ((model_.DGIDLO)+((model_.DGIDLL)*iLE));
DGIDLD_i = ((model_.DGIDLDO)+((model_.DGIDLDL)*iLE));
A1_p = (((model_.A1O)*(1.0+((model_.A1L)*iLE)))*(1.0+((model_.A1W)*iWE)));
{
double value_max_0 = std::max(A1_p,static_cast<double>(0.0));
A1_i = value_max_0;
}
A2_t = (model_.A2O);
STA2_i = (model_.STA2O);
A3_p = (((model_.A3O)*(1.0+((model_.A3L)*iLE)))*(1.0+((model_.A3W)*iWE)));
{
double value_max_0 = std::max(A3_p,static_cast<double>(0.0));
A3_i = value_max_0;
}
AREAQ_i = (WEcv*LEcv);
CGBOV_p = ((model_.CGBOVO)+((model_.CGBOVL)*lphy));
{
double value_max_0 = std::max(CGBOV_p,static_cast<double>(0.0));
CGBOV_i = value_max_0;
}
NSDAC_i = ((model_.NSDACO)*1.0e6);
FIF_i = (((model_.FIFW)*WEcv)/WEN);
FSCEAC_i = (model_.FSCEACO);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = ((3.45313E-11/TOX1_i)*WEcv);
COV_i = (temp*(model_.LOVO));
COVD_i = (temp*(model_.LOVDO));
{
double value_max_0 = std::max((1.0+(((model_.COVDLW)*WEN)/WEcv)),static_cast<double>(1.0e-3));
COVDL_i = ((model_.COVDLO)/value_max_0);
}
COVDLB_i = (model_.COVDLBO);
DVFBOV_i = (model_.DVFBOVO);
CFR_p = ((model_.CFRO)+((model_.CFRW)*wphy));
{
double value_max_0 = std::max(CFR_p,static_cast<double>(0.0));
CFR_i = value_max_0;
}
CFRD_p = ((model_.CFRDO)+((model_.CFRDW)*wphy));
{
double value_max_0 = std::max(CFRD_p,static_cast<double>(0.0));
CFRD_i = value_max_0;
}
CSD_i = (((((model_.CSDO)*epsch)*TSI_i)*WE)/LE);
CSDBP_i = (model_.CSDBPO);
{
double value_max_0 = std::max((((1.0+((model_.RTHL)*lphy))+((model_.RTHW)*wphy))+(((model_.RTHLW)*lphy)*wphy)),static_cast<double>(1.0e-10));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = value_max_0;
}

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = 0.0;
if (((NF>1.0)&&(SD>0.0)))
{

d_temp2_dV_G_S = d_temp2_dTemp_Tnode_GND = d_temp2_dV_D_S = d_temp2_dV_S_B =  0.0;
temp2 = ((-(SD+L))/(model_.LAMBTHO));
if ((fabs(temp2)<80.0))
{
{
double value_exp_0 = exp(temp2);

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = value_exp_0;
}
}
else
{
if ((temp2<(-80.0)))
{

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = (1.80485e-35/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))));
}
else
{

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = (5.54062e34*(1.0+((temp2-80.0)*(1.0+((0.5*(temp2-80.0))*(1.0+((temp2-80.0)*0.3333333333333)))))));
}
}

d_temp4_dV_G_S = d_temp4_dV_D_S = d_temp4_dTemp_Tnode_GND = d_temp4_dV_S_B =  0.0;
temp4 = (1.0-temp3);
{
double value_pow_0 = pow(temp3,NF);

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = ((((2.0*(model_.FTHO))*temp3)*(temp4-((1.0-value_pow_0)/NF)))/(temp4*temp4));
}
}

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (temp/(1.0+temp1));
RTH_p = ((model_.RTHO)/temp);
{
double value_max_0 = std::max(RTH_p,static_cast<double>(1.0e-6));
RTH_t = value_max_0;
}
STRTH_i = (model_.STRTHO);
CTH_p = ((model_.CTHO)*temp);
{
double value_max_0 = std::max(CTH_p,static_cast<double>(0.0));
CTH_i = value_max_0;
}
FNT_i = (model_.FNTO);
{
double value_pow_0 = pow(iLE,((model_.FNTEXCLEXP)-2.0));
FNTEXC_i = ((((((model_.FNTEXCL)*BETN_p)*BETN_p)*iWE)*iWE)*value_pow_0);
}
NFA_p = (((model_.NFALW)*iAE)+((model_.NFAW)*iWE));
{
double value_max_0 = std::max(NFA_p,static_cast<double>(0.0));
NFA_i = value_max_0;
}
NFB_i = ((model_.NFBLW)*iAE);
NFC_i = ((model_.NFCLW)*iAE);
NFE_i = (model_.NFEO);
NFEB_i = (model_.NFEBO);
EF_i = (model_.EFO);
if ((((((model_.SWSTRESS)>0)&&(SA>0.0))&&(SB>0.0))&&((NF==1.0)||((NF>1.0)&&(SD>0.0)))))
{
if (((model_.SWSTRESS)==1))
{
tmpa = 0.0;
tmpb = 0.0;
iloop = 0.0;
while ((iloop<(NF-0.5)))
{
tmpa = (tmpa+(1.0/((SA+(0.5*L))+(iloop*(SD+L)))));
tmpb = (tmpb+(1.0/((SB+(0.5*L))+(iloop*(SD+L)))));
iloop = (iloop+1.0);
}
Invsa = (tmpa/NF);
Invsb = (tmpb/NF);
Invsaref = (1.0/((model_.SAREF)+(0.5*L)));
Invsbref = (1.0/((model_.SBREF)+(0.5*L)));
{
double value_max_0 = std::max((L+delLPS),static_cast<double>(1.0e-9));
Lx = value_max_0;
}
{
double value_max_0 = std::max(((W_i+delWOD)+(model_.WLOD)),static_cast<double>(1.0e-9));
Wx = value_max_0;
}
{
double value_pow_0 = pow(Lx,(model_.LLODKUO));
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,(model_.WLODKUO));
tempw = (1.0/value_pow_0);
}
Kstressu0 = ((((1.0+((model_.LKUO)*templ))+((model_.WKUO)*tempw))+(((model_.PKUO)*templ)*tempw))*(1.0+((model_.TKUO)*(rT-1.0))));
rhobeta = (((model_.KUO)*(Invsa+Invsb))/Kstressu0);
rhobetaref = (((model_.KUO)*(Invsaref+Invsbref))/Kstressu0);
{
double value_pow_0 = pow(Lx,(model_.LLODVTH));
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,(model_.WLODVTH));
tempw = (1.0/value_pow_0);
}
{
double value_max_0 = std::max((((1.0+((model_.LKVTHO)*templ))+((model_.WKVTHO)*tempw))+(((model_.PKVTHO)*templ)*tempw)),static_cast<double>(1e-20));
Kstressvth0 = value_max_0;
}
temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
{
double value_max_0 = std::max(BETN_p,static_cast<double>(1.0e-10));
BETN1_t = value_max_0;
}
BETN2_t = ((model_.BETNBO)*BETN1_t);
THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+((model_.KVSAT)*rhobetaref)))/((1.0+rhobetaref)*(1.0+((model_.KVSAT)*rhobeta))));
{
double value_max_0 = std::max(THESAT_p,static_cast<double>(0.0));
THESAT_t = value_max_0;
}
VFB1_t = (VFB1_t+(((model_.KVTHO)*temp0)/Kstressvth0));
VFB2_t = (VFB2_t+(((model_.KVTHO)*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,(model_.LODETAO));
CF_p = (CF_p+(((model_.STETAO)*temp0)/value_pow_0));
}
{
double value_max_0 = std::max(CF_p,static_cast<double>(0.0));
CF1_t = value_max_0;
}
CF2_t = ((((model_.CFBO)*CF1_t)*TOX2_i)/TOX1_i);
}
else
{
tmpa = 0.0;
iloop = 0.0;

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = ((-1.0)/(model_.STRALPHA));
while ((iloop<(NF-0.5)))
{
if ((((-((SA+(0.5*L))+(iloop*(SD+L))))/(model_.STRLAMBDA))>(-80.0)))
{
{
double value_exp_0 = exp(((-((SA+(0.5*L))+(iloop*(SD+L))))/(model_.STRLAMBDA)));

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = value_exp_0;
}
}
else
{

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = (1.80485e-35/(1.0+(((-((-((SA+(0.5*L))+(iloop*(SD+L))))/(model_.STRLAMBDA)))-80.0)*(1.0+((0.5*((-((-((SA+(0.5*L))+(iloop*(SD+L))))/(model_.STRLAMBDA)))-80.0))*(1.0+(((-((-((SA+(0.5*L))+(iloop*(SD+L))))/(model_.STRLAMBDA)))-80.0)*0.3333333333333)))))));
}
if ((((-((SB+(0.5*L))+(((NF-1.0)-iloop)*(SD+L))))/(model_.STRLAMBDA))>(-80.0)))
{
{
double value_exp_0 = exp(((-((SB+(0.5*L))+(((NF-1.0)-iloop)*(SD+L))))/(model_.STRLAMBDA)));

d_temp2_dV_G_S = d_temp2_dTemp_Tnode_GND = d_temp2_dV_D_S = d_temp2_dV_S_B =  0.0;
temp2 = value_exp_0;
}
}
else
{

d_temp2_dV_G_S = d_temp2_dTemp_Tnode_GND = d_temp2_dV_D_S = d_temp2_dV_S_B =  0.0;
temp2 = (1.80485e-35/(1.0+(((-((-((SB+(0.5*L))+(((NF-1.0)-iloop)*(SD+L))))/(model_.STRLAMBDA)))-80.0)*(1.0+((0.5*((-((-((SB+(0.5*L))+(((NF-1.0)-iloop)*(SD+L))))/(model_.STRLAMBDA)))-80.0))*(1.0+(((-((-((SB+(0.5*L))+(((NF-1.0)-iloop)*(SD+L))))/(model_.STRLAMBDA)))-80.0)*0.3333333333333)))))));
}
{
double value_pow_0 = pow((1.0-temp1),(-(model_.STRALPHA)));

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = value_pow_0;
}
{
double value_pow_0 = pow((1.0-temp2),(-(model_.STRALPHA)));

d_temp4_dV_G_S = d_temp4_dV_D_S = d_temp4_dTemp_Tnode_GND = d_temp4_dV_S_B =  0.0;
temp4 = value_pow_0;
}
{
double value_pow_0 = pow((0.5*(temp3+temp4)),temp);
tmpa = (tmpa+value_pow_0);
}
iloop = (iloop+1.0);
}
str_g = (1.0-(tmpa/NF));
if ((((-((model_.SAREF)+(0.5*L)))/(model_.STRLAMBDA))>(-80.0)))
{
{
double value_exp_0 = exp(((-((model_.SAREF)+(0.5*L)))/(model_.STRLAMBDA)));

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = value_exp_0;
}
}
else
{

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = (1.80485e-35/(1.0+(((-((-((model_.SAREF)+(0.5*L)))/(model_.STRLAMBDA)))-80.0)*(1.0+((0.5*((-((-((model_.SAREF)+(0.5*L)))/(model_.STRLAMBDA)))-80.0))*(1.0+(((-((-((model_.SAREF)+(0.5*L)))/(model_.STRLAMBDA)))-80.0)*0.3333333333333)))))));
}
if ((((-((model_.SBREF)+(0.5*L)))/(model_.STRLAMBDA))>(-80.0)))
{
{
double value_exp_0 = exp(((-((model_.SBREF)+(0.5*L)))/(model_.STRLAMBDA)));

d_temp2_dV_G_S = d_temp2_dTemp_Tnode_GND = d_temp2_dV_D_S = d_temp2_dV_S_B =  0.0;
temp2 = value_exp_0;
}
}
else
{

d_temp2_dV_G_S = d_temp2_dTemp_Tnode_GND = d_temp2_dV_D_S = d_temp2_dV_S_B =  0.0;
temp2 = (1.80485e-35/(1.0+(((-((-((model_.SBREF)+(0.5*L)))/(model_.STRLAMBDA)))-80.0)*(1.0+((0.5*((-((-((model_.SBREF)+(0.5*L)))/(model_.STRLAMBDA)))-80.0))*(1.0+(((-((-((model_.SBREF)+(0.5*L)))/(model_.STRLAMBDA)))-80.0)*0.3333333333333)))))));
}
{
double value_pow_0 = pow((1.0-temp1),(-(model_.STRALPHA)));

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = value_pow_0;
}
{
double value_pow_0 = pow((1.0-temp2),(-(model_.STRALPHA)));

d_temp4_dV_G_S = d_temp4_dV_D_S = d_temp4_dTemp_Tnode_GND = d_temp4_dV_S_B =  0.0;
temp4 = value_pow_0;
}
{
double value_pow_0 = pow((0.5*(temp3+temp4)),temp);
str_gref = (1.0-value_pow_0);
}
{
double value_max_0 = std::max(((W_i+delWOD)+(model_.WLOD)),static_cast<double>(1.0e-9));
Wx = value_max_0;
}
ruo = ((model_.STRRUO)/(1.0+((model_.STRTRUO)*(rT-1.0))));
rhobeta = (ruo*str_g);
rhobetaref = (ruo*str_gref);
temp0 = (str_g-str_gref);
{
double value_max_0 = std::max((1.0+(((model_.STRWDVFBO)*Wx)/WEN)),static_cast<double>(1.0e-20));
Kstressvth0 = value_max_0;
}
BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
{
double value_max_0 = std::max(BETN_p,static_cast<double>(1.0e-10));
BETN1_t = value_max_0;
}
BETN2_t = ((model_.BETNBO)*BETN1_t);
THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+((model_.STRRVSAT)*rhobetaref)))/((1.0+rhobetaref)*(1.0+((model_.STRRVSAT)*rhobeta))));
{
double value_max_0 = std::max(THESAT_p,static_cast<double>(0.0));
THESAT_t = value_max_0;
}
VFB1_t = (VFB1_t+(((model_.STRDVFBO)*temp0)/Kstressvth0));
VFB2_t = (VFB2_t+(((model_.STRDVFBO)*temp0)/Kstressvth0));
{
double value_pow_0 = pow(lambda_LE,(model_.CFLEXP));
CF_p = (CF_p+((((model_.STRDCFL)*temp0)*value_pow_0)*(1.0+((model_.CFW)*iWE))));
}
{
double value_max_0 = std::max(CF_p,static_cast<double>(0.0));
CF1_t = value_max_0;
}
CF2_t = ((((model_.CFBO)*CF1_t)*TOX2_i)/TOX1_i);
}
}
}
if (((model_.SWJUNASYM)==0))
{
NOVD_i = NOV_i;
IGOVINVD_t = IGOVINV_t;
FNOVINVD_t = FNOVINV_t;
IGOVACCD_t = IGOVACC_t;
AGIDLD_i = AGIDL_i;
BGIDLD_t = BGIDL_t;
STBGIDLD_i = STBGIDL_i;
CGIDLD_i = CGIDL_i;
DGIDLD_i = DGIDL_i;
COVD_i = COV_i;
CFRD_i = CFR_i;
}
one_m_xge = (1.0-XGE_i);
epsch = ((1.04479E-10*one_m_xge)+(1.43438E-10*XGE_i));

d_EgSi_dTemp_Tnode_GND =  0.0;
EgSi = (1.17-((4.730e-4*TKC_sq)/(636+TKC)));

d_EgGe_dTemp_Tnode_GND =  0.0;
EgGe = (0.744-((4.774e-4*TKC_sq)/(235+TKC)));

d_dEg_dTemp_Tnode_GND =  0.0;
dEg = (((EgGe-EgSi)+((-0.4)*one_m_xge))*XGE_i);

d_Eg_dTemp_Tnode_GND =  0.0;
Eg = (EgSi+dEg);

d_Eg_2phit0_dTemp_Tnode_GND =  0.0;
Eg_2phit0 = ((0.5*Eg)*inv_phit0);
{
double value_sqrt_0 = sqrt((10.0*XGE_i));
niratio = (1.0/(1.0+value_sqrt_0));
}

d_dVfbch_dTemp_Tnode_GND =  0.0;
dVfbch = ((0.05*XGE_i)-(0.5*dEg));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = ((((1.602176565E-19*NCH_i)*0.5)*TSI_i)/3.45313E-11);
if ((TYPECH_i>0))
{
dVfb1Nch = (temp*(TOX1_i+((model_.QMC)*4.0e-10)));
dVfb2Nch = (temp*(TOX2_i+((model_.QMC)*4.0e-10)));
}
else
{
dVfb1Nch = ((-temp)*(TOX1_i+((model_.QMC)*4.0e-10)));
dVfb2Nch = ((-temp)*(TOX2_i+((model_.QMC)*4.0e-10)));
}
{
double value_sqrt_0 = sqrt((TKC*0.0033333333333));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = value_sqrt_0;
}

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
temp1 = (((4.05E25*temp)*temp)*temp);
{
double value_exp_0 = exp((-Eg_2phit0));

d_neff_dTemp_Tnode_GND =  0.0;
neff = ((temp1*niratio)*value_exp_0);
}
{
double value_exp_0 = exp((((-0.5)*EgSi)*inv_phit0));
neff_sub = (temp1*value_exp_0);
}
Cox1Init = (3.45313E-11/TOX1_i);
Cox2Init = (3.45313E-11/TOX2_i);
if ((PNCE_i>0))
{
Cox1Prime = (Cox1Init*(1.0+PNCE_i));
Cox2Prime = Cox2Init;
}
else
{
Cox1Prime = Cox1Init;
Cox2Prime = (Cox2Init*(1.0-PNCE_i));
}
CsiPrime_0 = (epsch/TSI_i);

d_phit_dTemp_Tnode_GND =  0.0;
phit = (phit0*(1.0+(CT_i*rTn)));

d_inv_phit_dTemp_Tnode_GND =  0.0;
inv_phit = (1.0/phit);

d_Eg_2phit_dTemp_Tnode_GND =  0.0;
Eg_2phit = ((0.5*Eg)*inv_phit);
k1_1D = (Cox1Prime/CsiPrime_0);
k2_1D = (Cox2Prime/CsiPrime_0);
keq_1D = (1.0/((1.0+(1.0/k1_1D))+(1.0/k2_1D)));
Ceq_1D = (CsiPrime_0*keq_1D);

d_A0_Csisq_dTemp_Tnode_GND =  0.0;
A0_Csisq = ((((2.0*1.602176565E-19)*neff)*epsch)*inv_phit);
{
double value_log_0 = log(((CsiPrime_0*CsiPrime_0)/A0_Csisq));

d_xth_1D_dTemp_Tnode_GND =  0.0;
xth_1D = (value_log_0-0.6931471805599);
}

d_xSDdep_dTemp_Tnode_GND =  0.0;
xSDdep = (((((0.5*1.602176565E-19)*NSDDC_i)*TSI_i)/(Cox1Prime+Cox2Prime))*inv_phit);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (STCF_i*dT);

d_CF1_i_dTemp_Tnode_GND =  0.0;
CF1_i = (CF1_t+temp);

d_CF2_i_dTemp_Tnode_GND =  0.0;
CF2_i = (CF2_t+temp);

d_xd0_dTemp_Tnode_GND =  0.0;
xd0 = (CFD_i*inv_phit);
{
double value_sqrt_0 = sqrt(((((2.0*1.602176565E-19)*NSUB_i)*1.04479E-10)*inv_phit0));
Gfsub = (value_sqrt_0/Ceq_1D);
}
Gfsub2 = (Gfsub*Gfsub);
inv_Gfsub2 = (1.0/Gfsub2);
xisub = (1.0+(Gfsub/1.4142135623731));
inv_xisub = (1.0/xisub);
margin_sub = (1.0e-5*xisub);
{
double value_log_0 = log((NSUB_i/neff_sub));
xb_sub = value_log_0;
}
xn_sub = (2.0*xb_sub);
if (((model_.SWSUBDEP)>0))
{
VFB2_t = (VFB2_t+((TYPESUB_i*phit0)*xb_sub));
}
dVfbQM = 0.0;

d_qq_dTemp_Tnode_GND =  0.0;
qq = 0.0;
tsisq = ((1.0e18*TSI_i)*TSI_i);
if (((model_.QMC)>0.0))
{
if (((model_.TYPE)==(+1)))
{
dVfbQM = (0.409618895/tsisq);
{
double value_log_0 = log((phit*tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));

d_qq_dTemp_Tnode_GND =  0.0;
qq = (((0.4*(model_.QMC))*1.27520989)*value_exp_1);
}
}
else
{
dVfbQM = (0.723134895/tsisq);
{
double value_log_0 = log((phit*tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));

d_qq_dTemp_Tnode_GND =  0.0;
qq = (((0.4*(model_.QMC))*1.54120870)*value_exp_1);
}
}
}

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = ((((model_.TYPE)*STVFB_i)*dT)+dVfbQM);

d_VFB1_i_dTemp_Tnode_GND =  0.0;
VFB1_i = ((((model_.TYPE)*((VFB1_t+dVfbch)+dVfb1Nch))+temp)+DELVTO);

d_VFB2_i_dTemp_Tnode_GND =  0.0;
VFB2_i = (((model_.TYPE)*((VFB2_t+dVfbch)+dVfb2Nch))+temp);
{
double value_log_0 = log(rTn);

d_lnrTn_dTemp_Tnode_GND =  0.0;
lnrTn = value_log_0;
}
{
double value_exp_0 = exp((STBET_i*lnrTn));

d_tf_bet_dTemp_Tnode_GND =  0.0;
tf_bet = (value_exp_0*FACTUO);
}

d_BETN1_i_dTemp_Tnode_GND =  0.0;
BETN1_i = (BETN1_t*tf_bet);

d_BETN2_i_dTemp_Tnode_GND =  0.0;
BETN2_i = (BETN2_t*tf_bet);
{
double value_exp_0 = exp((STMUE_i*lnrTn));

d_tf_mue_dTemp_Tnode_GND =  0.0;
tf_mue = value_exp_0;
}

d_MUE_i_dTemp_Tnode_GND =  0.0;
MUE_i = (MUE_t*tf_mue);
{
double value_exp_0 = exp((STTHEMU_i*lnrTn));

d_tf_themu_dTemp_Tnode_GND =  0.0;
tf_themu = value_exp_0;
}

d_THEMU_i_dTemp_Tnode_GND =  0.0;
THEMU_i = (THEMU_t*tf_themu);
{
double value_exp_0 = exp((STCS_i*lnrTn));

d_tf_cs_dTemp_Tnode_GND =  0.0;
tf_cs = value_exp_0;
}

d_CS_i_dTemp_Tnode_GND =  0.0;
CS_i = (CS_t*tf_cs);
{
double value_exp_0 = exp((STTHECS_i*lnrTn));

d_tf_thecs_dTemp_Tnode_GND =  0.0;
tf_thecs = value_exp_0;
}

d_THECS_i_dTemp_Tnode_GND =  0.0;
THECS_i = (THECS_t*tf_thecs);
{
double value_exp_0 = exp((STXCOR_i*lnrTn));

d_tf_xcor_dTemp_Tnode_GND =  0.0;
tf_xcor = value_exp_0;
}

d_XCOR_i_dTemp_Tnode_GND =  0.0;
XCOR_i = (XCOR_t*tf_xcor);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = ((1.0e-8*phit)/TSI_i);

d_fmue_dTemp_Tnode_GND =  0.0;
fmue = (temp*MUE_i);
inv_qi1cs = (1.0/(0.5*CSTHR_i));
inv_qi2cs = (inv_qi1cs/CSTHRB_i);
if (((model_.TYPE)==(+1)))
{
eta_mu = (0.5*FETA_i);
}
else
{
eta_mu = (0.3333333333333*FETA_i);
}
one_m_eta = (1.0-eta_mu);
{
double value_exp_0 = exp((STRS_i*lnrTn));

d_tf_ther_dTemp_Tnode_GND =  0.0;
tf_ther = value_exp_0;
}

d_RS_i_dTemp_Tnode_GND =  0.0;
RS_i = (RS_t*tf_ther);

d_frs_dTemp_Tnode_GND =  0.0;
frs = ((2.0*RS_i)*phit);
{
double value_exp_0 = exp(((16.0/AX_i)*0.6931471805599));
double value_log_1 = log((value_exp_0-1.0));
double value_exp_2 = exp((0.375*value_log_1));
gamAX = (value_exp_2-1.0);
}
{
double value_exp_0 = exp((STTHESAT_i*lnrTn));

d_tf_thesat_dTemp_Tnode_GND =  0.0;
tf_thesat = value_exp_0;
}

d_THESAT_i_dTemp_Tnode_GND =  0.0;
THESAT_i = ((THESAT_t*tf_thesat)*tf_bet);

d_sat_phit_dTemp_Tnode_GND =  0.0;
sat_phit = (THESAT_i*phit);

d_alp1_phit_dTemp_Tnode_GND =  0.0;
alp1_phit = (ALP1_i*inv_phit);
{
double value_exp_0 = exp(((-STIG_i)*lnrTn));

d_tf_ig_dTemp_Tnode_GND =  0.0;
tf_ig = value_exp_0;
}

d_IGINV_i_dTemp_Tnode_GND =  0.0;
IGINV_i = (IGINV_t*tf_ig);

d_IGOVINV_i_dTemp_Tnode_GND =  0.0;
IGOVINV_i = (IGOVINV_t*tf_ig);

d_IGOVINVD_i_dTemp_Tnode_GND =  0.0;
IGOVINVD_i = (IGOVINVD_t*tf_ig);

d_IGOVACC_i_dTemp_Tnode_GND =  0.0;
IGOVACC_i = (IGOVACC_t*tf_ig);

d_IGOVACCD_i_dTemp_Tnode_GND =  0.0;
IGOVACCD_i = (IGOVACCD_t*tf_ig);
{
double value_exp_0 = exp(((-STIGFN_i)*lnrTn));

d_tf_ig_dTemp_Tnode_GND =  0.0;
tf_ig = value_exp_0;
}

d_FNOVINV_i_dTemp_Tnode_GND =  0.0;
FNOVINV_i = (FNOVINV_t*tf_ig);

d_FNOVINVD_i_dTemp_Tnode_GND =  0.0;
FNOVINVD_i = (FNOVINVD_t*tf_ig);
inv_CHIB = (1.0/CHIB_i);
{
double value_sqrt_0 = sqrt((((2.0*1.602176565E-19)*9.10938291E-31)*CHIB_i));

d_tempM_dTemp_Tnode_GND =  0.0;
tempM = (((4.0*0.3333333333333)*value_sqrt_0)/1.054571726E-34);
}
BCH = (tempM*TOXP_i);
BOV = (tempM*TOXP_i);
GCQCH = 0.0;
if ((GC3CH_i<0.0))
{
GCQCH = (((-0.495)*GC2CH_i)/GC3CH_i);
}
GCQOVINV = 0.0;
if ((GC3OVINV_i<0.0))
{
GCQOVINV = (((-0.495)*GC2OVINV_i)/GC3OVINV_i);
}
GCQOVACC = 0.0;
if ((GC3OVACC_i<0.0))
{
GCQOVACC = (((-0.495)*GC2OVACC_i)/GC3OVACC_i);
}

d_alpha_b_dTemp_Tnode_GND =  0.0;
alpha_b = (0.5*Eg);

d_Dch_dTemp_Tnode_GND =  0.0;
Dch = (GCO_i*phit);

d_Dov_dTemp_Tnode_GND =  0.0;
Dov = (GCO_i*phit0);

d_n_iginv_dTemp_Tnode_GND =  0.0;
n_iginv = (1.0/(1.0+(NIGINV_i*Eg_2phit)));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (4.0e-18/(TOXP_i*TOXP_i));
AGIDL_i = (AGIDL_i*temp);
AGIDLD_i = (AGIDLD_i*temp);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (TOXP_i*5.0e8);
{
double value_sqrt_0 = sqrt(((((1.0+(STBGIDL_i*dT)))*((1.0+(STBGIDL_i*dT))))+0.01));

d_tempM_dTemp_Tnode_GND =  0.0;
tempM = (0.5*((1.0+(STBGIDL_i*dT))+value_sqrt_0));
}

d_BGIDL_i_dTemp_Tnode_GND =  0.0;
BGIDL_i = ((BGIDL_t*tempM)*temp);
{
double value_sqrt_0 = sqrt(((((1.0+(STBGIDLD_i*dT)))*((1.0+(STBGIDLD_i*dT))))+0.01));

d_tempM_dTemp_Tnode_GND =  0.0;
tempM = (0.5*((1.0+(STBGIDLD_i*dT))+value_sqrt_0));
}

d_BGIDLD_i_dTemp_Tnode_GND =  0.0;
BGIDLD_i = ((BGIDLD_t*tempM)*temp);
{
double value_exp_0 = exp(((-STA2_i)*lnrTn));

d_A2_i_dTemp_Tnode_GND =  0.0;
A2_i = (A2_t*value_exp_0);
}

d_area_phit_dTemp_Tnode_GND =  0.0;
area_phit = (AREAQ_i*phit);

d_inner_sd_dTemp_Tnode_GND =  0.0;
inner_sd = (((0.25*1.602176565E-19)*NSDAC_i)/(epsch*phit));
{
double value_log_0 = log((NSDAC_i/neff));

d_xsd_dTemp_Tnode_GND =  0.0;
xsd = value_log_0;
}

d_fif_phit_dTemp_Tnode_GND =  0.0;
fif_phit = ((FIF_i*1.25e-6)*phit);
{
double value_sqrt_0 = sqrt((((epsch/3.45313E-11)*TSI_i)*(TOX1_i+4.0e-10)));
lambda2D = value_sqrt_0;
}
{
double value_exp_0 = exp((STRTH_i*lnrTn));

d_tf_rth_dTemp_Tnode_GND =  0.0;
tf_rth = value_exp_0;
}

d_RTH_i_dTemp_Tnode_GND =  0.0;
RTH_i = (RTH_t*tf_rth);

d_nt_dTemp_Tnode_GND =  0.0;
nt = (((FNT_i*4.0)*1.3806488E-23)*TKC);
nt0 = nt;
fac_exc = ((9.10938291E-31*1.0e12)*FNTEXC_i);
}
// End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(1.0e-06),
    W(1.0e-06),
    ASOURCE(1.0e-12),
    ADRAIN(1.0e-12),
    PSOURCE(1.0e-06),
    PDRAIN(1.0e-06),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    NF(1),
    MULT(1),
    DELVTO(0.0),
    FACTUO(1.0),
    M(1),
    ASOURCE_i(0.0),
    ADRAIN_i(0.0),
    PSOURCE_i(0.0),
    PDRAIN_i(0.0),
    MULT_i(0.0),
    VFB1_i(0.0),
d_VFB1_i_dTemp_Tnode_GND(0.0),
    CIC1_i(0.0),
    PSCE1_i(0.0),
    CF1_i(0.0),
d_CF1_i_dTemp_Tnode_GND(0.0),
    BETN1_i(0.0),
d_BETN1_i_dTemp_Tnode_GND(0.0),
    THESAT1_i(0.0),
    VFB2_i(0.0),
d_VFB2_i_dTemp_Tnode_GND(0.0),
    CIC2_i(0.0),
    PSCE2_i(0.0),
    CF2_i(0.0),
d_CF2_i_dTemp_Tnode_GND(0.0),
    BETN2_i(0.0),
d_BETN2_i_dTemp_Tnode_GND(0.0),
    THESAT2_i(0.0),
    TSI_i(0.0),
    XGE_i(0.0),
    TYPESUB_i(0.0),
    NOV_i(0.0),
    NOVD_i(0.0),
    STVFB_i(0.0),
    NSDDC_i(0.0),
    PSCEDLB_i(0.0),
    STCF_i(0.0),
    CFD_i(0.0),
    CFDL_i(0.0),
    CFDLB_i(0.0),
    STBET_i(0.0),
    MUE_i(0.0),
d_MUE_i_dTemp_Tnode_GND(0.0),
    STMUE_i(0.0),
    THEMU_i(0.0),
d_THEMU_i_dTemp_Tnode_GND(0.0),
    STTHEMU_i(0.0),
    CS_i(0.0),
d_CS_i_dTemp_Tnode_GND(0.0),
    CSFI_i(0.0),
    CSBI_i(0.0),
    STCS_i(0.0),
    THECS_i(0.0),
d_THECS_i_dTemp_Tnode_GND(0.0),
    STTHECS_i(0.0),
    STXCOR_i(0.0),
    RS_i(0.0),
d_RS_i_dTemp_Tnode_GND(0.0),
    RSIG_i(0.0),
    STRS_i(0.0),
    RSG_i(0.0),
    THERSG_i(0.0),
    RSB_i(0.0),
    CT_i(0.0),
    TOXP_i(0.0),
    XCOR_i(0.0),
d_XCOR_i_dTemp_Tnode_GND(0.0),
    XCORB_i(0.0),
    THESAT_i(0.0),
d_THESAT_i_dTemp_Tnode_GND(0.0),
    STTHESAT_i(0.0),
    ALP_i(0.0),
    ALP1_i(0.0),
    ALPB_i(0.0),
    VP_i(0.0),
    VPG_i(0.0),
    GCO_i(0.0),
    IGINV_i(0.0),
d_IGINV_i_dTemp_Tnode_GND(0.0),
    IGOVINV_i(0.0),
d_IGOVINV_i_dTemp_Tnode_GND(0.0),
    IGOVINVD_i(0.0),
d_IGOVINVD_i_dTemp_Tnode_GND(0.0),
    IGOVACC_i(0.0),
d_IGOVACC_i_dTemp_Tnode_GND(0.0),
    IGOVACCD_i(0.0),
d_IGOVACCD_i_dTemp_Tnode_GND(0.0),
    STIG_i(0.0),
    STIGFN_i(0.0),
    FNOVINV_i(0.0),
d_FNOVINV_i_dTemp_Tnode_GND(0.0),
    FNOVINVD_i(0.0),
d_FNOVINVD_i_dTemp_Tnode_GND(0.0),
    GC2CH_i(0.0),
    GC3CH_i(0.0),
    GC2OVINV_i(0.0),
    GC3OVINV_i(0.0),
    GC2OVACC_i(0.0),
    GC3OVACC_i(0.0),
    GCDOV_i(0.0),
    GCVDOV_i(0.0),
    CHIB_i(0.0),
    NIGINV_i(0.0),
    GCOVINVFN_i(0.0),
    AGIDL_i(0.0),
    AGIDLD_i(0.0),
    BGIDL_i(0.0),
d_BGIDL_i_dTemp_Tnode_GND(0.0),
    BGIDLD_i(0.0),
d_BGIDLD_i_dTemp_Tnode_GND(0.0),
    STBGIDL_i(0.0),
    STBGIDLD_i(0.0),
    CGIDL_i(0.0),
    CGIDLD_i(0.0),
    DGIDL_i(0.0),
    DGIDLD_i(0.0),
    A1_i(0.0),
    A2_i(0.0),
d_A2_i_dTemp_Tnode_GND(0.0),
    STA2_i(0.0),
    A3_i(0.0),
    AREAQ_i(0.0),
    CGBOV_i(0.0),
    NSDAC_i(0.0),
    FIF_i(0.0),
    FSCEAC_i(0.0),
    COV_i(0.0),
    COVD_i(0.0),
    COVDL_i(0.0),
    COVDLB_i(0.0),
    DVFBOV_i(0.0),
    CFR_i(0.0),
    CFRD_i(0.0),
    CSD_i(0.0),
    CSDBP_i(0.0),
    RTH_i(0.0),
d_RTH_i_dTemp_Tnode_GND(0.0),
    STRTH_i(0.0),
    CTH_i(0.0),
    FNT_i(0.0),
    FNTEXC_i(0.0),
    NFA_i(0.0),
    NFB_i(0.0),
    NFC_i(0.0),
    NFE_i(0.0),
    NFEB_i(0.0),
    EF_i(0.0),
    VFB1_t(0.0),
    CF1_t(0.0),
    BETN1_t(0.0),
    VFB2_t(0.0),
    CF2_t(0.0),
    BETN2_t(0.0),
    MUE_t(0.0),
    THEMU_t(0.0),
    CS_t(0.0),
    THECS_t(0.0),
    RS_t(0.0),
    XCOR_t(0.0),
    THESAT_t(0.0),
    IGINV_t(0.0),
    IGOVINV_t(0.0),
    IGOVINVD_t(0.0),
    IGOVACC_t(0.0),
    IGOVACCD_t(0.0),
    FNOVINV_t(0.0),
    FNOVINVD_t(0.0),
    BGIDL_t(0.0),
    BGIDLD_t(0.0),
    A2_t(0.0),
    RTH_t(0.0),
    gamAX(0.0),
    temp(0.0),
d_temp_dV_G_S(0.0),
d_temp_dV_D_S(0.0),
d_temp_dV_S_B(0.0),
d_temp_dTemp_Tnode_GND(0.0),
    temp1(0.0),
d_temp1_dV_S_B(0.0),
d_temp1_dV_G_S(0.0),
d_temp1_dV_D_S(0.0),
d_temp1_dTemp_Tnode_GND(0.0),
    temp2(0.0),
d_temp2_dV_G_S(0.0),
d_temp2_dTemp_Tnode_GND(0.0),
d_temp2_dV_D_S(0.0),
d_temp2_dV_S_B(0.0),
    temp3(0.0),
d_temp3_dV_G_S(0.0),
d_temp3_dV_D_S(0.0),
d_temp3_dTemp_Tnode_GND(0.0),
d_temp3_dV_S_B(0.0),
    temp4(0.0),
d_temp4_dV_G_S(0.0),
d_temp4_dV_D_S(0.0),
d_temp4_dTemp_Tnode_GND(0.0),
d_temp4_dV_S_B(0.0),
    TKC(0.0),
d_TKC_dTemp_Tnode_GND(0.0),
    TKC_sq(0.0),
d_TKC_sq_dTemp_Tnode_GND(0.0),
    DTC(0.0),
d_DTC_dTemp_Tnode_GND(0.0),
    dT(0.0),
d_dT_dTemp_Tnode_GND(0.0),
    rT(0.0),
d_rT_dTemp_Tnode_GND(0.0),
    rTn(0.0),
d_rTn_dTemp_Tnode_GND(0.0),
    phit0(0.0),
d_phit0_dTemp_Tnode_GND(0.0),
    inv_phit0(0.0),
d_inv_phit0_dTemp_Tnode_GND(0.0),
    phit(0.0),
d_phit_dTemp_Tnode_GND(0.0),
    inv_phit(0.0),
d_inv_phit_dTemp_Tnode_GND(0.0),
    one_m_xge(0.0),
    epsch(0.0),
    EgSi(0.0),
d_EgSi_dTemp_Tnode_GND(0.0),
    EgGe(0.0),
d_EgGe_dTemp_Tnode_GND(0.0),
    dEg(0.0),
d_dEg_dTemp_Tnode_GND(0.0),
    Eg(0.0),
d_Eg_dTemp_Tnode_GND(0.0),
    Eg_2phit0(0.0),
d_Eg_2phit0_dTemp_Tnode_GND(0.0),
    Eg_2phit(0.0),
d_Eg_2phit_dTemp_Tnode_GND(0.0),
    dVfbch(0.0),
d_dVfbch_dTemp_Tnode_GND(0.0),
    niratio(0.0),
    Cox2Init(0.0),
    Cox1Prime(0.0),
    Cox2Prime(0.0),
    dVfb1Nch(0.0),
    dVfb2Nch(0.0),
    CsiPrime_0(0.0),
    k1_1D(0.0),
    k2_1D(0.0),
    keq_1D(0.0),
    neff(0.0),
d_neff_dTemp_Tnode_GND(0.0),
    A0_Csisq(0.0),
d_A0_Csisq_dTemp_Tnode_GND(0.0),
    xth_1D(0.0),
d_xth_1D_dTemp_Tnode_GND(0.0),
    xSDdep(0.0),
d_xSDdep_dTemp_Tnode_GND(0.0),
    dVfbQM(0.0),
    qq(0.0),
d_qq_dTemp_Tnode_GND(0.0),
    tsisq(0.0),
    Gfsub(0.0),
    Gfsub2(0.0),
    inv_Gfsub2(0.0),
    xisub(0.0),
    inv_xisub(0.0),
    margin_sub(0.0),
    xn_sub(0.0),
    fmue(0.0),
d_fmue_dTemp_Tnode_GND(0.0),
    inv_qi1cs(0.0),
    inv_qi2cs(0.0),
    eta_mu(0.0),
    one_m_eta(0.0),
    frs(0.0),
d_frs_dTemp_Tnode_GND(0.0),
    sat_phit(0.0),
d_sat_phit_dTemp_Tnode_GND(0.0),
    alp1_phit(0.0),
d_alp1_phit_dTemp_Tnode_GND(0.0),
    inv_CHIB(0.0),
    tempM(0.0),
d_tempM_dTemp_Tnode_GND(0.0),
    BCH(0.0),
    BOV(0.0),
    GCQCH(0.0),
    GCQOVINV(0.0),
    GCQOVACC(0.0),
    alpha_b(0.0),
d_alpha_b_dTemp_Tnode_GND(0.0),
    Dch(0.0),
d_Dch_dTemp_Tnode_GND(0.0),
    Dov(0.0),
d_Dov_dTemp_Tnode_GND(0.0),
    n_iginv(0.0),
d_n_iginv_dTemp_Tnode_GND(0.0),
    area_phit(0.0),
d_area_phit_dTemp_Tnode_GND(0.0),
    inner_sd(0.0),
d_inner_sd_dTemp_Tnode_GND(0.0),
    xsd(0.0),
d_xsd_dTemp_Tnode_GND(0.0),
    fif_phit(0.0),
d_fif_phit_dTemp_Tnode_GND(0.0),
    lambda2D(0.0),
    lnrTn(0.0),
d_lnrTn_dTemp_Tnode_GND(0.0),
    tf_bet(0.0),
d_tf_bet_dTemp_Tnode_GND(0.0),
    tf_mue(0.0),
d_tf_mue_dTemp_Tnode_GND(0.0),
    tf_themu(0.0),
d_tf_themu_dTemp_Tnode_GND(0.0),
    tf_cs(0.0),
d_tf_cs_dTemp_Tnode_GND(0.0),
    tf_thecs(0.0),
d_tf_thecs_dTemp_Tnode_GND(0.0),
    tf_xcor(0.0),
d_tf_xcor_dTemp_Tnode_GND(0.0),
    tf_ther(0.0),
d_tf_ther_dTemp_Tnode_GND(0.0),
    tf_thesat(0.0),
d_tf_thesat_dTemp_Tnode_GND(0.0),
    tf_ig(0.0),
d_tf_ig_dTemp_Tnode_GND(0.0),
    tf_rth(0.0),
d_tf_rth_dTemp_Tnode_GND(0.0),
    nt(0.0),
d_nt_dTemp_Tnode_GND(0.0),
    nt0(0.0),
    fac_exc(0.0),
    sigVds(0.0),
    CsiPrime(0.0),
d_CsiPrime_dV_G_S(0.0),
d_CsiPrime_dV_D_S(0.0),
d_CsiPrime_dTemp_Tnode_GND(0.0),
d_CsiPrime_dV_S_B(0.0),
    xd0(0.0),
d_xd0_dTemp_Tnode_GND(0.0),
    k1(0.0),
d_k1_dV_G_S(0.0),
d_k1_dV_D_S(0.0),
d_k1_dTemp_Tnode_GND(0.0),
d_k1_dV_S_B(0.0),
    qis(0.0),
d_qis_dTemp_Tnode_GND(0.0),
d_qis_dV_G_S(0.0),
d_qis_dV_D_S(0.0),
d_qis_dV_S_B(0.0),
    ds(0.0),
d_ds_dV_G_S(0.0),
d_ds_dV_D_S(0.0),
d_ds_dTemp_Tnode_GND(0.0),
d_ds_dV_S_B(0.0),
    qid(0.0),
d_qid_dTemp_Tnode_GND(0.0),
d_qid_dV_G_S(0.0),
d_qid_dV_D_S(0.0),
d_qid_dV_S_B(0.0),
    dd(0.0),
d_dd_dV_G_S(0.0),
d_dd_dV_D_S(0.0),
d_dd_dTemp_Tnode_GND(0.0),
d_dd_dV_S_B(0.0),
    esurf1(0.0),
d_esurf1_dV_S_B(0.0),
d_esurf1_dV_G_S(0.0),
d_esurf1_dV_D_S(0.0),
d_esurf1_dTemp_Tnode_GND(0.0),
    qmfact1(0.0),
d_qmfact1_dV_G_S(0.0),
d_qmfact1_dV_D_S(0.0),
d_qmfact1_dTemp_Tnode_GND(0.0),
d_qmfact1_dV_S_B(0.0),
    esurf2(0.0),
d_esurf2_dV_G_S(0.0),
d_esurf2_dTemp_Tnode_GND(0.0),
d_esurf2_dV_D_S(0.0),
d_esurf2_dV_S_B(0.0),
    betneff(0.0),
d_betneff_dV_S_B(0.0),
d_betneff_dV_G_S(0.0),
d_betneff_dV_D_S(0.0),
d_betneff_dTemp_Tnode_GND(0.0),
    xdeff(0.0),
d_xdeff_dV_D_S(0.0),
d_xdeff_dTemp_Tnode_GND(0.0),
d_xdeff_dV_G_S(0.0),
d_xdeff_dV_S_B(0.0),
    qim(0.0),
d_qim_dTemp_Tnode_GND(0.0),
d_qim_dV_G_S(0.0),
d_qim_dV_D_S(0.0),
d_qim_dV_S_B(0.0),
    Gmob(0.0),
d_Gmob_dV_G_S(0.0),
d_Gmob_dTemp_Tnode_GND(0.0),
d_Gmob_dV_D_S(0.0),
d_Gmob_dV_S_B(0.0),
    FdL(0.0),
d_FdL_dTemp_Tnode_GND(0.0),
d_FdL_dV_G_S(0.0),
d_FdL_dV_D_S(0.0),
d_FdL_dV_S_B(0.0),
    Ggamma(0.0),
d_Ggamma_dTemp_Tnode_GND(0.0),
d_Ggamma_dV_D_S(0.0),
d_Ggamma_dV_G_S(0.0),
d_Ggamma_dV_S_B(0.0),
    zsat(0.0),
d_zsat_dTemp_Tnode_GND(0.0),
d_zsat_dV_D_S(0.0),
d_zsat_dV_G_S(0.0),
d_zsat_dV_S_B(0.0),
    hsat(0.0),
d_hsat_dTemp_Tnode_GND(0.0),
d_hsat_dV_D_S(0.0),
d_hsat_dV_G_S(0.0),
d_hsat_dV_S_B(0.0),
    Gvsat(0.0),
d_Gvsat_dV_G_S(0.0),
d_Gvsat_dTemp_Tnode_GND(0.0),
d_Gvsat_dV_D_S(0.0),
d_Gvsat_dV_S_B(0.0),
    qmfact(0.0),
d_qmfact_dV_S_B(0.0),
d_qmfact_dV_G_S(0.0),
d_qmfact_dV_D_S(0.0),
d_qmfact_dTemp_Tnode_GND(0.0),
    fact_Ids(0.0),
d_fact_Ids_dTemp_Tnode_GND(0.0),
d_fact_Ids_dV_S_B(0.0),
d_fact_Ids_dV_G_S(0.0),
d_fact_Ids_dV_D_S(0.0),
    Ids(0.0),
d_Ids_dTemp_Tnode_GND(0.0),
d_Ids_dV_S_B(0.0),
d_Ids_dV_G_S(0.0),
d_Ids_dV_D_S(0.0),
    delta_k1q1(0.0),
d_delta_k1q1_dV_G_S(0.0),
d_delta_k1q1_dV_D_S(0.0),
d_delta_k1q1_dTemp_Tnode_GND(0.0),
d_delta_k1q1_dV_S_B(0.0),
    inv_k1h1_0(0.0),
d_inv_k1h1_0_dTemp_Tnode_GND(0.0),
d_inv_k1h1_0_dV_G_S(0.0),
d_inv_k1h1_0_dV_D_S(0.0),
d_inv_k1h1_0_dV_S_B(0.0),
    Igse(0.0),
d_Igse_dTemp_Tnode_GND(0.0),
d_Igse_dV_G_S(0.0),
d_Igse_dV_D_S(0.0),
d_Igse_dV_S_B(0.0),
    Igde(0.0),
d_Igde_dTemp_Tnode_GND(0.0),
d_Igde_dV_G_S(0.0),
d_Igde_dV_D_S(0.0),
d_Igde_dV_S_B(0.0),
    Igidle(0.0),
d_Igidle_dV_D_S(0.0),
d_Igidle_dTemp_Tnode_GND(0.0),
d_Igidle_dV_G_S(0.0),
d_Igidle_dV_S_B(0.0),
    Igisle(0.0),
d_Igisle_dV_D_S(0.0),
d_Igisle_dTemp_Tnode_GND(0.0),
d_Igisle_dV_G_S(0.0),
d_Igisle_dV_S_B(0.0),
    mavl(0.0),
d_mavl_dV_D_S(0.0),
d_mavl_dTemp_Tnode_GND(0.0),
d_mavl_dV_G_S(0.0),
d_mavl_dV_S_B(0.0),
    Iimpact(0.0),
d_Iimpact_dV_D_S(0.0),
d_Iimpact_dTemp_Tnode_GND(0.0),
d_Iimpact_dV_G_S(0.0),
d_Iimpact_dV_S_B(0.0),
    type(0.0),
    vds(0.0),
    vsb(0.0),
    vgs(0.0),
    vth(0.0),
    vth_drive(0.0),
    vdsat(0.0),
    vdsat_marg(0.0),
    id(0.0),
d_id_dTemp_Tnode_GND(0.0),
d_id_dV_S_B(0.0),
d_id_dV_G_S(0.0),
d_id_dV_D_S(0.0),
    ig(0.0),
    is(0.0),
    ib(0.0),
    ids(0.0),
    igidl(0.0),
d_igidl_dV_D_S(0.0),
d_igidl_dTemp_Tnode_GND(0.0),
d_igidl_dV_G_S(0.0),
d_igidl_dV_S_B(0.0),
    igisl(0.0),
d_igisl_dV_D_S(0.0),
d_igisl_dTemp_Tnode_GND(0.0),
d_igisl_dV_G_S(0.0),
d_igisl_dV_S_B(0.0),
    igs(0.0),
    igd(0.0),
d_igd_dTemp_Tnode_GND(0.0),
d_igd_dV_G_S(0.0),
d_igd_dV_D_S(0.0),
d_igd_dV_S_B(0.0),
    idb(0.0),
    isb(0.0),
    gm(0.0),
    gmb(0.0),
    gds(0.0),
    cgg(0.0),
    cgd(0.0),
    cgs(0.0),
    cgb(0.0),
    cdd(0.0),
    cdg(0.0),
    cds(0.0),
    cdb(0.0),
    cbb(0.0),
    cbg(0.0),
    cbs(0.0),
    cbd(0.0),
    css(0.0),
    csg(0.0),
    csb(0.0),
    csd(0.0),
    tk(0.0),
    dtsh(0.0),
    self_gain(0.0),
    rout(0.0),
    beff(0.0),
    ft(0.0),
    rgate(0.0),
    gmoverid(0.0),
    vearly(0.0),
    li_D(-1),
    li_G(-1),
    li_S(-1),
    li_B(-1),
    li_Tnode(-1),
    li_NSIG(-1),
    li_BRA_NSIG_GND(-1),
    li_branch_iD(-1),
    li_branch_iG(-1),
    li_branch_iS(-1),
    li_branch_iB(-1),
    li_branch_iTnode(-1),
    f_S_Equ_D_Node_Ptr(0),
    f_S_Equ_S_Node_Ptr(0),
    f_D_Equ_D_Node_Ptr(0),
    f_D_Equ_S_Node_Ptr(0),
    f_S_Equ_G_Node_Ptr(0),
    f_D_Equ_G_Node_Ptr(0),
    f_S_Equ_B_Node_Ptr(0),
    f_D_Equ_B_Node_Ptr(0),
    f_S_Equ_Tnode_Node_Ptr(0),
    f_D_Equ_Tnode_Node_Ptr(0),
    f_G_Equ_S_Node_Ptr(0),
    f_G_Equ_B_Node_Ptr(0),
    f_G_Equ_D_Node_Ptr(0),
    f_G_Equ_G_Node_Ptr(0),
    f_G_Equ_Tnode_Node_Ptr(0),
    f_Tnode_Equ_Tnode_Node_Ptr(0),
    f_Tnode_Equ_S_Node_Ptr(0),
    f_Tnode_Equ_B_Node_Ptr(0),
    f_Tnode_Equ_D_Node_Ptr(0),
    f_Tnode_Equ_G_Node_Ptr(0),
    f_B_Equ_Tnode_Node_Ptr(0),
    f_B_Equ_S_Node_Ptr(0),
    f_B_Equ_B_Node_Ptr(0),
    f_B_Equ_D_Node_Ptr(0),
    f_B_Equ_G_Node_Ptr(0),
    f_NSIG_Equ_D_Node_Ptr(0),
    f_NSIG_Equ_S_Node_Ptr(0),
    f_NSIG_Equ_G_Node_Ptr(0),
    f_NSIG_Equ_B_Node_Ptr(0),
    f_NSIG_Equ_Tnode_Node_Ptr(0),
    f_NSIG_Equ_NSIG_Node_Ptr(0),
    f_G_Equ_NSIG_Node_Ptr(0),
    f_S_Equ_NSIG_Node_Ptr(0),
    f_D_Equ_NSIG_Node_Ptr(0),
    f_NSIG_Equ_BRA_NSIG_GND_Var_Ptr(0),
    f_BRA_NSIG_GND_Equ_D_Node_Ptr(0),
    f_BRA_NSIG_GND_Equ_S_Node_Ptr(0),
    f_BRA_NSIG_GND_Equ_G_Node_Ptr(0),
    f_BRA_NSIG_GND_Equ_B_Node_Ptr(0),
    f_BRA_NSIG_GND_Equ_Tnode_Node_Ptr(0),
    f_BRA_NSIG_GND_Equ_NSIG_Node_Ptr(0),
    f_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Ptr(0),
    q_S_Equ_D_Node_Ptr(0),
    q_S_Equ_S_Node_Ptr(0),
    q_D_Equ_D_Node_Ptr(0),
    q_D_Equ_S_Node_Ptr(0),
    q_S_Equ_G_Node_Ptr(0),
    q_D_Equ_G_Node_Ptr(0),
    q_S_Equ_B_Node_Ptr(0),
    q_D_Equ_B_Node_Ptr(0),
    q_S_Equ_Tnode_Node_Ptr(0),
    q_D_Equ_Tnode_Node_Ptr(0),
    q_G_Equ_S_Node_Ptr(0),
    q_G_Equ_B_Node_Ptr(0),
    q_G_Equ_D_Node_Ptr(0),
    q_G_Equ_G_Node_Ptr(0),
    q_G_Equ_Tnode_Node_Ptr(0),
    q_Tnode_Equ_Tnode_Node_Ptr(0),
    q_Tnode_Equ_S_Node_Ptr(0),
    q_Tnode_Equ_B_Node_Ptr(0),
    q_Tnode_Equ_D_Node_Ptr(0),
    q_Tnode_Equ_G_Node_Ptr(0),
    q_B_Equ_Tnode_Node_Ptr(0),
    q_B_Equ_S_Node_Ptr(0),
    q_B_Equ_B_Node_Ptr(0),
    q_B_Equ_D_Node_Ptr(0),
    q_B_Equ_G_Node_Ptr(0),
    q_NSIG_Equ_D_Node_Ptr(0),
    q_NSIG_Equ_S_Node_Ptr(0),
    q_NSIG_Equ_G_Node_Ptr(0),
    q_NSIG_Equ_B_Node_Ptr(0),
    q_NSIG_Equ_Tnode_Node_Ptr(0),
    q_NSIG_Equ_NSIG_Node_Ptr(0),
    q_G_Equ_NSIG_Node_Ptr(0),
    q_S_Equ_NSIG_Node_Ptr(0),
    q_D_Equ_NSIG_Node_Ptr(0),
    q_NSIG_Equ_BRA_NSIG_GND_Var_Ptr(0),
    q_BRA_NSIG_GND_Equ_D_Node_Ptr(0),
    q_BRA_NSIG_GND_Equ_S_Node_Ptr(0),
    q_BRA_NSIG_GND_Equ_G_Node_Ptr(0),
    q_BRA_NSIG_GND_Equ_B_Node_Ptr(0),
    q_BRA_NSIG_GND_Equ_Tnode_Node_Ptr(0),
    q_BRA_NSIG_GND_Equ_NSIG_Node_Ptr(0),
    q_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Ptr(0),
    A_S_Equ_D_NodeOffset(-1),
    A_S_Equ_S_NodeOffset(-1),
    A_D_Equ_D_NodeOffset(-1),
    A_D_Equ_S_NodeOffset(-1),
    A_S_Equ_G_NodeOffset(-1),
    A_D_Equ_G_NodeOffset(-1),
    A_S_Equ_B_NodeOffset(-1),
    A_D_Equ_B_NodeOffset(-1),
    A_S_Equ_Tnode_NodeOffset(-1),
    A_D_Equ_Tnode_NodeOffset(-1),
    A_G_Equ_S_NodeOffset(-1),
    A_G_Equ_B_NodeOffset(-1),
    A_G_Equ_D_NodeOffset(-1),
    A_G_Equ_G_NodeOffset(-1),
    A_G_Equ_Tnode_NodeOffset(-1),
    A_Tnode_Equ_Tnode_NodeOffset(-1),
    A_Tnode_Equ_S_NodeOffset(-1),
    A_Tnode_Equ_B_NodeOffset(-1),
    A_Tnode_Equ_D_NodeOffset(-1),
    A_Tnode_Equ_G_NodeOffset(-1),
    A_B_Equ_Tnode_NodeOffset(-1),
    A_B_Equ_S_NodeOffset(-1),
    A_B_Equ_B_NodeOffset(-1),
    A_B_Equ_D_NodeOffset(-1),
    A_B_Equ_G_NodeOffset(-1),
    A_NSIG_Equ_D_NodeOffset(-1),
    A_NSIG_Equ_S_NodeOffset(-1),
    A_NSIG_Equ_G_NodeOffset(-1),
    A_NSIG_Equ_B_NodeOffset(-1),
    A_NSIG_Equ_Tnode_NodeOffset(-1),
    A_NSIG_Equ_NSIG_NodeOffset(-1),
    A_G_Equ_NSIG_NodeOffset(-1),
    A_S_Equ_NSIG_NodeOffset(-1),
    A_D_Equ_NSIG_NodeOffset(-1),
    A_NSIG_Equ_BRA_NSIG_GND_Var_Offset(-1),
    A_BRA_NSIG_GND_Equ_D_Node_Offset(-1),
    A_BRA_NSIG_GND_Equ_S_Node_Offset(-1),
    A_BRA_NSIG_GND_Equ_G_Node_Offset(-1),
    A_BRA_NSIG_GND_Equ_B_Node_Offset(-1),
    A_BRA_NSIG_GND_Equ_Tnode_Node_Offset(-1),
    A_BRA_NSIG_GND_Equ_NSIG_Node_Offset(-1),
    A_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Offset(-1),
    li_store_type(-1),
    li_store_vds(-1),
    li_store_vsb(-1),
    li_store_vgs(-1),
    li_store_vth(-1),
    li_store_vth_drive(-1),
    li_store_vdsat(-1),
    li_store_vdsat_marg(-1),
    li_store_id(-1),
    li_store_ig(-1),
    li_store_is(-1),
    li_store_ib(-1),
    li_store_ids(-1),
    li_store_igidl(-1),
    li_store_igisl(-1),
    li_store_igs(-1),
    li_store_igd(-1),
    li_store_idb(-1),
    li_store_isb(-1),
    li_store_gm(-1),
    li_store_gmb(-1),
    li_store_gds(-1),
    li_store_cgg(-1),
    li_store_cgd(-1),
    li_store_cgs(-1),
    li_store_cgb(-1),
    li_store_cdd(-1),
    li_store_cdg(-1),
    li_store_cds(-1),
    li_store_cdb(-1),
    li_store_cbb(-1),
    li_store_cbg(-1),
    li_store_cbs(-1),
    li_store_cbd(-1),
    li_store_css(-1),
    li_store_csg(-1),
    li_store_csb(-1),
    li_store_csd(-1),
    li_store_tk(-1),
    li_store_dtsh(-1),
    li_store_self_gain(-1),
    li_store_rout(-1),
    li_store_beff(-1),
    li_store_ft(-1),
    li_store_rgate(-1),
    li_store_gmoverid(-1),
    li_store_vearly(-1),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 1 + 1;
    numExtVars = 5;

  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+47);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 5;

  leadCurrentF.resize(5);
  leadCurrentQ.resize(5);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_Tnode));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_NSIG));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_Tnode));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_NSIG));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_Tnode));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_NSIG));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_Tnode));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_Tnode,admsNodeID_Tnode));
    jacobianElements.push_back(IntPair(admsNodeID_Tnode,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_Tnode,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_Tnode,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_Tnode,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_NSIG,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_NSIG,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_NSIG,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_NSIG,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_NSIG,admsNodeID_Tnode));
    jacobianElements.push_back(IntPair(admsNodeID_NSIG,admsNodeID_NSIG));
    // Extra columns for dependence on branches
    jacobianElements.push_back(IntPair(admsNodeID_NSIG,admsBRA_ID_NSIG_GND));
    // Jacobian rows for branch equations
jacobianElements.push_back(IntPair(admsBRA_ID_NSIG_GND,admsNodeID_D));   // Branch eqn NSIG,GND - node D
jacobianElements.push_back(IntPair(admsBRA_ID_NSIG_GND,admsNodeID_S));   // Branch eqn NSIG,GND - node S
jacobianElements.push_back(IntPair(admsBRA_ID_NSIG_GND,admsNodeID_G));   // Branch eqn NSIG,GND - node G
jacobianElements.push_back(IntPair(admsBRA_ID_NSIG_GND,admsNodeID_B));   // Branch eqn NSIG,GND - node B
jacobianElements.push_back(IntPair(admsBRA_ID_NSIG_GND,admsNodeID_Tnode));   // Branch eqn NSIG,GND - node Tnode
jacobianElements.push_back(IntPair(admsBRA_ID_NSIG_GND,admsNodeID_NSIG));   // Branch eqn NSIG,GND - node NSIG
jacobianElements.push_back(IntPair(admsBRA_ID_NSIG_GND,admsBRA_ID_NSIG_GND)); // Branch eqn NSIG,GND - branch var NSIG,GND



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 6+1;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSl_utsoi::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_D = localLIDVec[nodeMap[admsNodeID_D]];
  li_G = localLIDVec[nodeMap[admsNodeID_G]];
  li_S = localLIDVec[nodeMap[admsNodeID_S]];
  li_B = localLIDVec[nodeMap[admsNodeID_B]];
  li_Tnode = localLIDVec[nodeMap[admsNodeID_Tnode]];
  li_NSIG = localLIDVec[nodeMap[admsNodeID_NSIG]];
  li_BRA_NSIG_GND = localLIDVec[nodeMap[admsBRA_ID_NSIG_GND]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_D = " << li_D << std::endl;
      Xyce::dout() << "\nli_G = " << li_G << std::endl;
      Xyce::dout() << "\nli_S = " << li_S << std::endl;
      Xyce::dout() << "\nli_B = " << li_B << std::endl;
      Xyce::dout() << "\nli_Tnode = " << li_Tnode << std::endl;
      Xyce::dout() << "\nli_NSIG = " << li_NSIG << std::endl;
      Xyce::dout() << "\nli_BRA_NSIG_GND = " << li_BRA_NSIG_GND << std::endl;

    Xyce::dout() << "\nEnd of ADMSl_utsoi::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    addInternalNode(symbol_table, li_NSIG, getName(), "NSIG");
    addInternalNode(symbol_table, li_BRA_NSIG_GND, getName(), "NSIG_GND_branch");
    addStoreNode(symbol_table, li_store_type, getName().getEncodedName() + ":type");
    addStoreNode(symbol_table, li_store_vds, getName().getEncodedName() + ":vds");
    addStoreNode(symbol_table, li_store_vsb, getName().getEncodedName() + ":vsb");
    addStoreNode(symbol_table, li_store_vgs, getName().getEncodedName() + ":vgs");
    addStoreNode(symbol_table, li_store_vth, getName().getEncodedName() + ":vth");
    addStoreNode(symbol_table, li_store_vth_drive, getName().getEncodedName() + ":vth_drive");
    addStoreNode(symbol_table, li_store_vdsat, getName().getEncodedName() + ":vdsat");
    addStoreNode(symbol_table, li_store_vdsat_marg, getName().getEncodedName() + ":vdsat_marg");
    addStoreNode(symbol_table, li_store_id, getName().getEncodedName() + ":id");
    addStoreNode(symbol_table, li_store_ig, getName().getEncodedName() + ":ig");
    addStoreNode(symbol_table, li_store_is, getName().getEncodedName() + ":is");
    addStoreNode(symbol_table, li_store_ib, getName().getEncodedName() + ":ib");
    addStoreNode(symbol_table, li_store_ids, getName().getEncodedName() + ":ids");
    addStoreNode(symbol_table, li_store_igidl, getName().getEncodedName() + ":igidl");
    addStoreNode(symbol_table, li_store_igisl, getName().getEncodedName() + ":igisl");
    addStoreNode(symbol_table, li_store_igs, getName().getEncodedName() + ":igs");
    addStoreNode(symbol_table, li_store_igd, getName().getEncodedName() + ":igd");
    addStoreNode(symbol_table, li_store_idb, getName().getEncodedName() + ":idb");
    addStoreNode(symbol_table, li_store_isb, getName().getEncodedName() + ":isb");
    addStoreNode(symbol_table, li_store_gm, getName().getEncodedName() + ":gm");
    addStoreNode(symbol_table, li_store_gmb, getName().getEncodedName() + ":gmb");
    addStoreNode(symbol_table, li_store_gds, getName().getEncodedName() + ":gds");
    addStoreNode(symbol_table, li_store_cgg, getName().getEncodedName() + ":cgg");
    addStoreNode(symbol_table, li_store_cgd, getName().getEncodedName() + ":cgd");
    addStoreNode(symbol_table, li_store_cgs, getName().getEncodedName() + ":cgs");
    addStoreNode(symbol_table, li_store_cgb, getName().getEncodedName() + ":cgb");
    addStoreNode(symbol_table, li_store_cdd, getName().getEncodedName() + ":cdd");
    addStoreNode(symbol_table, li_store_cdg, getName().getEncodedName() + ":cdg");
    addStoreNode(symbol_table, li_store_cds, getName().getEncodedName() + ":cds");
    addStoreNode(symbol_table, li_store_cdb, getName().getEncodedName() + ":cdb");
    addStoreNode(symbol_table, li_store_cbb, getName().getEncodedName() + ":cbb");
    addStoreNode(symbol_table, li_store_cbg, getName().getEncodedName() + ":cbg");
    addStoreNode(symbol_table, li_store_cbs, getName().getEncodedName() + ":cbs");
    addStoreNode(symbol_table, li_store_cbd, getName().getEncodedName() + ":cbd");
    addStoreNode(symbol_table, li_store_css, getName().getEncodedName() + ":css");
    addStoreNode(symbol_table, li_store_csg, getName().getEncodedName() + ":csg");
    addStoreNode(symbol_table, li_store_csb, getName().getEncodedName() + ":csb");
    addStoreNode(symbol_table, li_store_csd, getName().getEncodedName() + ":csd");
    addStoreNode(symbol_table, li_store_tk, getName().getEncodedName() + ":tk");
    addStoreNode(symbol_table, li_store_dtsh, getName().getEncodedName() + ":dtsh");
    addStoreNode(symbol_table, li_store_self_gain, getName().getEncodedName() + ":self_gain");
    addStoreNode(symbol_table, li_store_rout, getName().getEncodedName() + ":rout");
    addStoreNode(symbol_table, li_store_beff, getName().getEncodedName() + ":beff");
    addStoreNode(symbol_table, li_store_ft, getName().getEncodedName() + ":ft");
    addStoreNode(symbol_table, li_store_rgate, getName().getEncodedName() + ":rgate");
    addStoreNode(symbol_table, li_store_gmoverid, getName().getEncodedName() + ":gmoverid");
    addStoreNode(symbol_table, li_store_vearly, getName().getEncodedName() + ":vearly");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_iD, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_iG, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_iS, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_iB, getName(), "BRANCH_D4");
    addBranchDataNode( symbol_table, li_branch_iTnode, getName(), "BRANCH_D5");


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_type= stoLIDVec[i++];
      li_store_vds= stoLIDVec[i++];
      li_store_vsb= stoLIDVec[i++];
      li_store_vgs= stoLIDVec[i++];
      li_store_vth= stoLIDVec[i++];
      li_store_vth_drive= stoLIDVec[i++];
      li_store_vdsat= stoLIDVec[i++];
      li_store_vdsat_marg= stoLIDVec[i++];
      li_store_id= stoLIDVec[i++];
      li_store_ig= stoLIDVec[i++];
      li_store_is= stoLIDVec[i++];
      li_store_ib= stoLIDVec[i++];
      li_store_ids= stoLIDVec[i++];
      li_store_igidl= stoLIDVec[i++];
      li_store_igisl= stoLIDVec[i++];
      li_store_igs= stoLIDVec[i++];
      li_store_igd= stoLIDVec[i++];
      li_store_idb= stoLIDVec[i++];
      li_store_isb= stoLIDVec[i++];
      li_store_gm= stoLIDVec[i++];
      li_store_gmb= stoLIDVec[i++];
      li_store_gds= stoLIDVec[i++];
      li_store_cgg= stoLIDVec[i++];
      li_store_cgd= stoLIDVec[i++];
      li_store_cgs= stoLIDVec[i++];
      li_store_cgb= stoLIDVec[i++];
      li_store_cdd= stoLIDVec[i++];
      li_store_cdg= stoLIDVec[i++];
      li_store_cds= stoLIDVec[i++];
      li_store_cdb= stoLIDVec[i++];
      li_store_cbb= stoLIDVec[i++];
      li_store_cbg= stoLIDVec[i++];
      li_store_cbs= stoLIDVec[i++];
      li_store_cbd= stoLIDVec[i++];
      li_store_css= stoLIDVec[i++];
      li_store_csg= stoLIDVec[i++];
      li_store_csb= stoLIDVec[i++];
      li_store_csd= stoLIDVec[i++];
      li_store_tk= stoLIDVec[i++];
      li_store_dtsh= stoLIDVec[i++];
      li_store_self_gain= stoLIDVec[i++];
      li_store_rout= stoLIDVec[i++];
      li_store_beff= stoLIDVec[i++];
      li_store_ft= stoLIDVec[i++];
      li_store_rgate= stoLIDVec[i++];
      li_store_gmoverid= stoLIDVec[i++];
      li_store_vearly= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_iD = branchLIDVecRef[i++];
    li_branch_iG = branchLIDVecRef[i++];
    li_branch_iS = branchLIDVecRef[i++];
    li_branch_iB = branchLIDVecRef[i++];
    li_branch_iTnode = branchLIDVecRef[i++];

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_D)];
    A_D_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_S)];
    A_D_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_G)];
    A_D_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_B)];
    A_D_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_Tnode)];
    A_D_Equ_Tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_NSIG)];
    A_D_Equ_NSIG_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_S)];
    A_G_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_B)];
    A_G_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_D)];
    A_G_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_G)];
    A_G_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_Tnode)];
    A_G_Equ_Tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_NSIG)];
    A_G_Equ_NSIG_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_D)];
    A_S_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_S)];
    A_S_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_G)];
    A_S_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_B)];
    A_S_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_Tnode)];
    A_S_Equ_Tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_NSIG)];
    A_S_Equ_NSIG_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_Tnode)];
    A_B_Equ_Tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_S)];
    A_B_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_B)];
    A_B_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_D)];
    A_B_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_G)];
    A_B_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_Tnode,admsNodeID_Tnode)];
    A_Tnode_Equ_Tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_Tnode,admsNodeID_S)];
    A_Tnode_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_Tnode,admsNodeID_B)];
    A_Tnode_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_Tnode,admsNodeID_D)];
    A_Tnode_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_Tnode,admsNodeID_G)];
    A_Tnode_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NSIG,admsNodeID_D)];
    A_NSIG_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NSIG,admsNodeID_S)];
    A_NSIG_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NSIG,admsNodeID_G)];
    A_NSIG_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NSIG,admsNodeID_B)];
    A_NSIG_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NSIG,admsNodeID_Tnode)];
    A_NSIG_Equ_Tnode_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NSIG,admsNodeID_NSIG)];
    A_NSIG_Equ_NSIG_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc=pairToJacStampMap[IntPair(admsNodeID_NSIG,admsBRA_ID_NSIG_GND)];
    A_NSIG_Equ_BRA_NSIG_GND_Var_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_NSIG_GND,admsNodeID_D)];
    A_BRA_NSIG_GND_Equ_D_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_NSIG_GND,admsNodeID_S)];
    A_BRA_NSIG_GND_Equ_S_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_NSIG_GND,admsNodeID_G)];
    A_BRA_NSIG_GND_Equ_G_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_NSIG_GND,admsNodeID_B)];
    A_BRA_NSIG_GND_Equ_B_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_NSIG_GND,admsNodeID_Tnode)];
    A_BRA_NSIG_GND_Equ_Tnode_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_NSIG_GND,admsNodeID_NSIG)];
    A_BRA_NSIG_GND_Equ_NSIG_Node_Offset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsBRA_ID_NSIG_GND,admsBRA_ID_NSIG_GND)];
    A_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Offset=jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
    f_D_Equ_D_Node_Ptr = &(dFdx[li_D][A_D_Equ_D_NodeOffset]);
    q_D_Equ_D_Node_Ptr = &(dQdx[li_D][A_D_Equ_D_NodeOffset]);
    f_D_Equ_S_Node_Ptr = &(dFdx[li_D][A_D_Equ_S_NodeOffset]);
    q_D_Equ_S_Node_Ptr = &(dQdx[li_D][A_D_Equ_S_NodeOffset]);
    f_D_Equ_G_Node_Ptr = &(dFdx[li_D][A_D_Equ_G_NodeOffset]);
    q_D_Equ_G_Node_Ptr = &(dQdx[li_D][A_D_Equ_G_NodeOffset]);
    f_D_Equ_B_Node_Ptr = &(dFdx[li_D][A_D_Equ_B_NodeOffset]);
    q_D_Equ_B_Node_Ptr = &(dQdx[li_D][A_D_Equ_B_NodeOffset]);
    f_D_Equ_Tnode_Node_Ptr = &(dFdx[li_D][A_D_Equ_Tnode_NodeOffset]);
    q_D_Equ_Tnode_Node_Ptr = &(dQdx[li_D][A_D_Equ_Tnode_NodeOffset]);
    f_D_Equ_NSIG_Node_Ptr = &(dFdx[li_D][A_D_Equ_NSIG_NodeOffset]);
    q_D_Equ_NSIG_Node_Ptr = &(dQdx[li_D][A_D_Equ_NSIG_NodeOffset]);
    f_G_Equ_S_Node_Ptr = &(dFdx[li_G][A_G_Equ_S_NodeOffset]);
    q_G_Equ_S_Node_Ptr = &(dQdx[li_G][A_G_Equ_S_NodeOffset]);
    f_G_Equ_B_Node_Ptr = &(dFdx[li_G][A_G_Equ_B_NodeOffset]);
    q_G_Equ_B_Node_Ptr = &(dQdx[li_G][A_G_Equ_B_NodeOffset]);
    f_G_Equ_D_Node_Ptr = &(dFdx[li_G][A_G_Equ_D_NodeOffset]);
    q_G_Equ_D_Node_Ptr = &(dQdx[li_G][A_G_Equ_D_NodeOffset]);
    f_G_Equ_G_Node_Ptr = &(dFdx[li_G][A_G_Equ_G_NodeOffset]);
    q_G_Equ_G_Node_Ptr = &(dQdx[li_G][A_G_Equ_G_NodeOffset]);
    f_G_Equ_Tnode_Node_Ptr = &(dFdx[li_G][A_G_Equ_Tnode_NodeOffset]);
    q_G_Equ_Tnode_Node_Ptr = &(dQdx[li_G][A_G_Equ_Tnode_NodeOffset]);
    f_G_Equ_NSIG_Node_Ptr = &(dFdx[li_G][A_G_Equ_NSIG_NodeOffset]);
    q_G_Equ_NSIG_Node_Ptr = &(dQdx[li_G][A_G_Equ_NSIG_NodeOffset]);
    f_S_Equ_D_Node_Ptr = &(dFdx[li_S][A_S_Equ_D_NodeOffset]);
    q_S_Equ_D_Node_Ptr = &(dQdx[li_S][A_S_Equ_D_NodeOffset]);
    f_S_Equ_S_Node_Ptr = &(dFdx[li_S][A_S_Equ_S_NodeOffset]);
    q_S_Equ_S_Node_Ptr = &(dQdx[li_S][A_S_Equ_S_NodeOffset]);
    f_S_Equ_G_Node_Ptr = &(dFdx[li_S][A_S_Equ_G_NodeOffset]);
    q_S_Equ_G_Node_Ptr = &(dQdx[li_S][A_S_Equ_G_NodeOffset]);
    f_S_Equ_B_Node_Ptr = &(dFdx[li_S][A_S_Equ_B_NodeOffset]);
    q_S_Equ_B_Node_Ptr = &(dQdx[li_S][A_S_Equ_B_NodeOffset]);
    f_S_Equ_Tnode_Node_Ptr = &(dFdx[li_S][A_S_Equ_Tnode_NodeOffset]);
    q_S_Equ_Tnode_Node_Ptr = &(dQdx[li_S][A_S_Equ_Tnode_NodeOffset]);
    f_S_Equ_NSIG_Node_Ptr = &(dFdx[li_S][A_S_Equ_NSIG_NodeOffset]);
    q_S_Equ_NSIG_Node_Ptr = &(dQdx[li_S][A_S_Equ_NSIG_NodeOffset]);
    f_B_Equ_Tnode_Node_Ptr = &(dFdx[li_B][A_B_Equ_Tnode_NodeOffset]);
    q_B_Equ_Tnode_Node_Ptr = &(dQdx[li_B][A_B_Equ_Tnode_NodeOffset]);
    f_B_Equ_S_Node_Ptr = &(dFdx[li_B][A_B_Equ_S_NodeOffset]);
    q_B_Equ_S_Node_Ptr = &(dQdx[li_B][A_B_Equ_S_NodeOffset]);
    f_B_Equ_B_Node_Ptr = &(dFdx[li_B][A_B_Equ_B_NodeOffset]);
    q_B_Equ_B_Node_Ptr = &(dQdx[li_B][A_B_Equ_B_NodeOffset]);
    f_B_Equ_D_Node_Ptr = &(dFdx[li_B][A_B_Equ_D_NodeOffset]);
    q_B_Equ_D_Node_Ptr = &(dQdx[li_B][A_B_Equ_D_NodeOffset]);
    f_B_Equ_G_Node_Ptr = &(dFdx[li_B][A_B_Equ_G_NodeOffset]);
    q_B_Equ_G_Node_Ptr = &(dQdx[li_B][A_B_Equ_G_NodeOffset]);
    f_Tnode_Equ_Tnode_Node_Ptr = &(dFdx[li_Tnode][A_Tnode_Equ_Tnode_NodeOffset]);
    q_Tnode_Equ_Tnode_Node_Ptr = &(dQdx[li_Tnode][A_Tnode_Equ_Tnode_NodeOffset]);
    f_Tnode_Equ_S_Node_Ptr = &(dFdx[li_Tnode][A_Tnode_Equ_S_NodeOffset]);
    q_Tnode_Equ_S_Node_Ptr = &(dQdx[li_Tnode][A_Tnode_Equ_S_NodeOffset]);
    f_Tnode_Equ_B_Node_Ptr = &(dFdx[li_Tnode][A_Tnode_Equ_B_NodeOffset]);
    q_Tnode_Equ_B_Node_Ptr = &(dQdx[li_Tnode][A_Tnode_Equ_B_NodeOffset]);
    f_Tnode_Equ_D_Node_Ptr = &(dFdx[li_Tnode][A_Tnode_Equ_D_NodeOffset]);
    q_Tnode_Equ_D_Node_Ptr = &(dQdx[li_Tnode][A_Tnode_Equ_D_NodeOffset]);
    f_Tnode_Equ_G_Node_Ptr = &(dFdx[li_Tnode][A_Tnode_Equ_G_NodeOffset]);
    q_Tnode_Equ_G_Node_Ptr = &(dQdx[li_Tnode][A_Tnode_Equ_G_NodeOffset]);
    f_NSIG_Equ_D_Node_Ptr = &(dFdx[li_NSIG][A_NSIG_Equ_D_NodeOffset]);
    q_NSIG_Equ_D_Node_Ptr = &(dQdx[li_NSIG][A_NSIG_Equ_D_NodeOffset]);
    f_NSIG_Equ_S_Node_Ptr = &(dFdx[li_NSIG][A_NSIG_Equ_S_NodeOffset]);
    q_NSIG_Equ_S_Node_Ptr = &(dQdx[li_NSIG][A_NSIG_Equ_S_NodeOffset]);
    f_NSIG_Equ_G_Node_Ptr = &(dFdx[li_NSIG][A_NSIG_Equ_G_NodeOffset]);
    q_NSIG_Equ_G_Node_Ptr = &(dQdx[li_NSIG][A_NSIG_Equ_G_NodeOffset]);
    f_NSIG_Equ_B_Node_Ptr = &(dFdx[li_NSIG][A_NSIG_Equ_B_NodeOffset]);
    q_NSIG_Equ_B_Node_Ptr = &(dQdx[li_NSIG][A_NSIG_Equ_B_NodeOffset]);
    f_NSIG_Equ_Tnode_Node_Ptr = &(dFdx[li_NSIG][A_NSIG_Equ_Tnode_NodeOffset]);
    q_NSIG_Equ_Tnode_Node_Ptr = &(dQdx[li_NSIG][A_NSIG_Equ_Tnode_NodeOffset]);
    f_NSIG_Equ_NSIG_Node_Ptr = &(dFdx[li_NSIG][A_NSIG_Equ_NSIG_NodeOffset]);
    q_NSIG_Equ_NSIG_Node_Ptr = &(dQdx[li_NSIG][A_NSIG_Equ_NSIG_NodeOffset]);
    f_NSIG_Equ_BRA_NSIG_GND_Var_Ptr = &(dFdx[li_NSIG][A_NSIG_Equ_BRA_NSIG_GND_Var_Offset]);
    q_NSIG_Equ_BRA_NSIG_GND_Var_Ptr = &(dQdx[li_NSIG][A_NSIG_Equ_BRA_NSIG_GND_Var_Offset]);
    f_BRA_NSIG_GND_Equ_D_Node_Ptr = &(dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_D_Node_Offset]);
    q_BRA_NSIG_GND_Equ_D_Node_Ptr =  &(dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_D_Node_Offset]);
    f_BRA_NSIG_GND_Equ_S_Node_Ptr = &(dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_S_Node_Offset]);
    q_BRA_NSIG_GND_Equ_S_Node_Ptr =  &(dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_S_Node_Offset]);
    f_BRA_NSIG_GND_Equ_G_Node_Ptr = &(dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_G_Node_Offset]);
    q_BRA_NSIG_GND_Equ_G_Node_Ptr =  &(dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_G_Node_Offset]);
    f_BRA_NSIG_GND_Equ_B_Node_Ptr = &(dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_B_Node_Offset]);
    q_BRA_NSIG_GND_Equ_B_Node_Ptr =  &(dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_B_Node_Offset]);
    f_BRA_NSIG_GND_Equ_Tnode_Node_Ptr = &(dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_Tnode_Node_Offset]);
    q_BRA_NSIG_GND_Equ_Tnode_Node_Ptr =  &(dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_Tnode_Node_Offset]);
    f_BRA_NSIG_GND_Equ_NSIG_Node_Ptr = &(dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_NSIG_Node_Offset]);
    q_BRA_NSIG_GND_Equ_NSIG_Node_Ptr =  &(dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_NSIG_Node_Offset]);
    f_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Ptr=&(dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Offset]);
    q_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Ptr=&(dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Offset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_D] += staticContributions[admsNodeID_D];
(*extData.daeFVectorPtr)[li_G] += staticContributions[admsNodeID_G];
(*extData.daeFVectorPtr)[li_S] += staticContributions[admsNodeID_S];
(*extData.daeFVectorPtr)[li_B] += staticContributions[admsNodeID_B];
(*extData.daeFVectorPtr)[li_Tnode] += staticContributions[admsNodeID_Tnode];
(*extData.daeFVectorPtr)[li_NSIG] += staticContributions[admsNodeID_NSIG];

    (*extData.daeFVectorPtr)[li_BRA_NSIG_GND] += staticContributions[admsBRA_ID_NSIG_GND];

  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_iD] = leadCurrentF[admsNodeID_D];
    leadF[li_branch_iG] = leadCurrentF[admsNodeID_G];
    leadF[li_branch_iS] = leadCurrentF[admsNodeID_S];
    leadF[li_branch_iB] = leadCurrentF[admsNodeID_B];
    leadF[li_branch_iTnode] = leadCurrentF[admsNodeID_Tnode];



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_iD] = solVec[li_D] - solVec[li_S];
        junctionV[li_branch_iG] = solVec[li_G] - solVec[li_S];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_D] += dynamicContributions[admsNodeID_D];
(*extData.daeQVectorPtr)[li_G] += dynamicContributions[admsNodeID_G];
(*extData.daeQVectorPtr)[li_S] += dynamicContributions[admsNodeID_S];
(*extData.daeQVectorPtr)[li_B] += dynamicContributions[admsNodeID_B];
(*extData.daeQVectorPtr)[li_Tnode] += dynamicContributions[admsNodeID_Tnode];
(*extData.daeQVectorPtr)[li_NSIG] += dynamicContributions[admsNodeID_NSIG];

    (*extData.daeQVectorPtr)[li_BRA_NSIG_GND] += dynamicContributions[admsBRA_ID_NSIG_GND];

  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_iD] = leadCurrentQ[admsNodeID_D];
    leadQ[li_branch_iG] = leadCurrentQ[admsNodeID_G];
    leadQ[li_branch_iS] = leadCurrentQ[admsNodeID_S];
    leadQ[li_branch_iB] = leadCurrentQ[admsNodeID_B];
    leadQ[li_branch_iTnode] = leadCurrentQ[admsNodeID_Tnode];


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_type] = type;
  stoVec[li_store_vds] = vds;
  stoVec[li_store_vsb] = vsb;
  stoVec[li_store_vgs] = vgs;
  stoVec[li_store_vth] = vth;
  stoVec[li_store_vth_drive] = vth_drive;
  stoVec[li_store_vdsat] = vdsat;
  stoVec[li_store_vdsat_marg] = vdsat_marg;
  stoVec[li_store_id] = id;
  stoVec[li_store_ig] = ig;
  stoVec[li_store_is] = is;
  stoVec[li_store_ib] = ib;
  stoVec[li_store_ids] = ids;
  stoVec[li_store_igidl] = igidl;
  stoVec[li_store_igisl] = igisl;
  stoVec[li_store_igs] = igs;
  stoVec[li_store_igd] = igd;
  stoVec[li_store_idb] = idb;
  stoVec[li_store_isb] = isb;
  stoVec[li_store_gm] = gm;
  stoVec[li_store_gmb] = gmb;
  stoVec[li_store_gds] = gds;
  stoVec[li_store_cgg] = cgg;
  stoVec[li_store_cgd] = cgd;
  stoVec[li_store_cgs] = cgs;
  stoVec[li_store_cgb] = cgb;
  stoVec[li_store_cdd] = cdd;
  stoVec[li_store_cdg] = cdg;
  stoVec[li_store_cds] = cds;
  stoVec[li_store_cdb] = cdb;
  stoVec[li_store_cbb] = cbb;
  stoVec[li_store_cbg] = cbg;
  stoVec[li_store_cbs] = cbs;
  stoVec[li_store_cbd] = cbd;
  stoVec[li_store_css] = css;
  stoVec[li_store_csg] = csg;
  stoVec[li_store_csb] = csb;
  stoVec[li_store_csd] = csd;
  stoVec[li_store_tk] = tk;
  stoVec[li_store_dtsh] = dtsh;
  stoVec[li_store_self_gain] = self_gain;
  stoVec[li_store_rout] = rout;
  stoVec[li_store_beff] = beff;
  stoVec[li_store_ft] = ft;
  stoVec[li_store_rgate] = rgate;
  stoVec[li_store_gmoverid] = gmoverid;
  stoVec[li_store_vearly] = vearly;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one l_utsoi instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSl_utsoi::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double r1init_op=0.0;
  double r2init_op=0.0;
  double x1init_op=0.0;
  double x2init_op=0.0;
  double xth1init_op=0.0;
  double xth2init_op=0.0;
  double xg1thinit_op=0.0;
  double vthinit_op=0.0;
  double inv_phit0_op=0.0;
  double EgSi_op=0.0;
  double EgGe_op=0.0;
  double dEg_op=0.0;
  double Eg_op=0.0;
  double Eg_2phit0_op=0.0;
  double dVfbch_op=0.0;
  double neff_op=0.0;
  double inv_phit_op=0.0;
  double A0_Csisq_op=0.0;
  double xth_1D_op=0.0;
  double xSDdep_op=0.0;
  double CF1_op=0.0;
  double CF2_op=0.0;
  double xd0_op=0.0;
  double qq_op=0.0;
  double VFB1_op=0.0;
  double VFB2_op=0.0;
  double xd_op=0.0;
  double xdsx_op=0.0;
  double dxdsx_op=0.0;
  double xg10_op=0.0;
  double xg20_op=0.0;
  double xg2eff_op=0.0;
  double e1_op=0.0;
  double e2_op=0.0;
  double CsiPrime_op=0.0;
  double k1_1D_QM_op=0.0;
  double k2_1D_QM_op=0.0;
  double keq_1D_QM_op=0.0;
  double Dx_WI_1D_op=0.0;
  double x_WI_1D_op=0.0;
  double x_1D_op=0.0;
  double dleff_op=0.0;
  double xedge_op=0.0;
  double sce1_op=0.0;
  double sce2_op=0.0;
  double dxg1_dibl_op=0.0;
  double dxg2_dibl_op=0.0;
  double xg1_op=0.0;
  double xg2_op=0.0;
  double xg2x_op=0.0;
  double k1_op=0.0;
  double k2_op=0.0;
  double A0_op=0.0;
  double exp_dxth_op=0.0;
  double dxth_op=0.0;
  double diff_min_op=0.0;
  double r1_op=0.0;
  double r2_op=0.0;
  double x1sat_op=0.0;
  double x2sat_op=0.0;
  double xth1_op=0.0;
  double xth2_op=0.0;
  double xg1th_op=0.0;
  double Vdsat=0.0;
  double qde=0.0;
     double d_qde_dV_G_S=0.0;
     double d_qde_dV_D_S=0.0;
     double d_qde_dV_S_B=0.0;
     double d_qde_dTemp_Tnode_GND=0.0;
  double qge=0.0;
     double d_qge_dV_G_S=0.0;
     double d_qge_dV_D_S=0.0;
     double d_qge_dV_S_B=0.0;
     double d_qge_dTemp_Tnode_GND=0.0;
  double qbe=0.0;
     double d_qbe_dV_G_S=0.0;
     double d_qbe_dV_D_S=0.0;
     double d_qbe_dV_S_B=0.0;
     double d_qbe_dTemp_Tnode_GND=0.0;
  double Nunit=0.0;
  double dm=0.0;
     double d_dm_dV_G_S=0.0;
     double d_dm_dV_D_S=0.0;
     double d_dm_dTemp_Tnode_GND=0.0;
     double d_dm_dV_S_B=0.0;
  double qimstar=0.0;
     double d_qimstar_dTemp_Tnode_GND=0.0;
     double d_qimstar_dV_G_S=0.0;
     double d_qimstar_dV_D_S=0.0;
     double d_qimstar_dV_S_B=0.0;
  double t1=0.0;
     double d_t1_dV_G_S=0.0;
     double d_t1_dV_D_S=0.0;
     double d_t1_dV_S_B=0.0;
     double d_t1_dTemp_Tnode_GND=0.0;
  double sqrt_t2=0.0;
     double d_sqrt_t2_dV_G_S=0.0;
     double d_sqrt_t2_dV_D_S=0.0;
     double d_sqrt_t2_dTemp_Tnode_GND=0.0;
     double d_sqrt_t2_dV_S_B=0.0;
  double t2=0.0;
     double d_t2_dV_G_S=0.0;
     double d_t2_dV_D_S=0.0;
     double d_t2_dTemp_Tnode_GND=0.0;
     double d_t2_dV_S_B=0.0;
  double r=0.0;
     double d_r_dTemp_Tnode_GND=0.0;
     double d_r_dV_D_S=0.0;
     double d_r_dV_G_S=0.0;
     double d_r_dV_S_B=0.0;
  double lc=0.0;
     double d_lc_dTemp_Tnode_GND=0.0;
     double d_lc_dV_D_S=0.0;
     double d_lc_dV_G_S=0.0;
     double d_lc_dV_S_B=0.0;
  double lcinv2=0.0;
     double d_lcinv2_dTemp_Tnode_GND=0.0;
     double d_lcinv2_dV_D_S=0.0;
     double d_lcinv2_dV_G_S=0.0;
     double d_lcinv2_dV_S_B=0.0;
  double g_ideal=0.0;
     double d_g_ideal_dV_S_B=0.0;
     double d_g_ideal_dV_G_S=0.0;
     double d_g_ideal_dV_D_S=0.0;
     double d_g_ideal_dTemp_Tnode_GND=0.0;
  double t2x12=0.0;
     double d_t2x12_dV_G_S=0.0;
     double d_t2x12_dV_D_S=0.0;
     double d_t2x12_dTemp_Tnode_GND=0.0;
     double d_t2x12_dV_S_B=0.0;
  double gSid=0.0;
     double d_gSid_dV_S_B=0.0;
     double d_gSid_dV_G_S=0.0;
     double d_gSid_dV_D_S=0.0;
     double d_gSid_dTemp_Tnode_GND=0.0;
  double sqrt_zsatexc=0.0;
     double d_sqrt_zsatexc_dTemp_Tnode_GND=0.0;
     double d_sqrt_zsatexc_dV_D_S=0.0;
     double d_sqrt_zsatexc_dV_G_S=0.0;
     double d_sqrt_zsatexc_dV_S_B=0.0;
  double Sidexc=0.0;
     double d_Sidexc_dTemp_Tnode_GND=0.0;
     double d_Sidexc_dV_S_B=0.0;
     double d_Sidexc_dV_G_S=0.0;
     double d_Sidexc_dV_D_S=0.0;
  double Sids_th=0.0;
  double COX_qm=0.0;
     double d_COX_qm_dV_G_S=0.0;
     double d_COX_qm_dV_D_S=0.0;
     double d_COX_qm_dTemp_Tnode_GND=0.0;
     double d_COX_qm_dV_S_B=0.0;
  double CGeff=0.0;
     double d_CGeff_dTemp_Tnode_GND=0.0;
     double d_CGeff_dV_D_S=0.0;
     double d_CGeff_dV_G_S=0.0;
     double d_CGeff_dV_S_B=0.0;
  double CDGeff=0.0;
     double d_CDGeff_dTemp_Tnode_GND=0.0;
     double d_CDGeff_dV_D_S=0.0;
     double d_CDGeff_dV_G_S=0.0;
     double d_CDGeff_dV_S_B=0.0;
  double CSGeff=0.0;
     double d_CSGeff_dTemp_Tnode_GND=0.0;
     double d_CSGeff_dV_D_S=0.0;
     double d_CSGeff_dV_G_S=0.0;
     double d_CSGeff_dV_S_B=0.0;
  double migid=0.0;
     double d_migid_dTemp_Tnode_GND=0.0;
     double d_migid_dV_D_S=0.0;
     double d_migid_dV_G_S=0.0;
     double d_migid_dV_S_B=0.0;
  double cigid2=0.0;
  double gSig=0.0;
     double d_gSig_dV_S_B=0.0;
     double d_gSig_dV_G_S=0.0;
     double d_gSig_dV_D_S=0.0;
     double d_gSig_dTemp_Tnode_GND=0.0;
  double SigR_th=0.0;
  double Sids_th_u=0.0;
  double Nstar=0.0;
  double Nmstar=0.0;
  double DeltaN=0.0;
  double Sids_fl=0.0;
  double Sigs_sh=0.0;
  double Sigd_sh=0.0;
  double shot_iavl=0.0;
  double Sids_sh=0.0;
  double Qs=0.0;
     double d_Qs_dV_G_S=0.0;
     double d_Qs_dV_D_S=0.0;
     double d_Qs_dV_S_B=0.0;
     double d_Qs_dTemp_Tnode_GND=0.0;
  double Idse=0.0;
     double d_Idse_dTemp_Tnode_GND=0.0;
     double d_Idse_dV_S_B=0.0;
     double d_Idse_dV_G_S=0.0;
     double d_Idse_dV_D_S=0.0;
  double Ithpwre=0.0;
     double d_Ithpwre_dV_G_S=0.0;
     double d_Ithpwre_dV_D_S=0.0;
     double d_Ithpwre_dV_S_B=0.0;
     double d_Ithpwre_dTemp_Tnode_GND=0.0;
  double Ithrce=0.0;
     double d_Ithrce_dTemp_Tnode_GND=0.0;
  double k1q1m=0.0;
     double d_k1q1m_dV_G_S=0.0;
     double d_k1q1m_dV_D_S=0.0;
     double d_k1q1m_dTemp_Tnode_GND=0.0;
     double d_k1q1m_dV_S_B=0.0;
  double k2q2m=0.0;
     double d_k2q2m_dV_G_S=0.0;
     double d_k2q2m_dV_D_S=0.0;
     double d_k2q2m_dTemp_Tnode_GND=0.0;
     double d_k2q2m_dV_S_B=0.0;
  double k1q1eff=0.0;
     double d_k1q1eff_dV_G_S=0.0;
     double d_k1q1eff_dV_D_S=0.0;
     double d_k1q1eff_dTemp_Tnode_GND=0.0;
     double d_k1q1eff_dV_S_B=0.0;
  double k2q2eff=0.0;
     double d_k2q2eff_dV_G_S=0.0;
     double d_k2q2eff_dV_D_S=0.0;
     double d_k2q2eff_dTemp_Tnode_GND=0.0;
     double d_k2q2eff_dV_S_B=0.0;
  double k1q1deff=0.0;
     double d_k1q1deff_dV_G_S=0.0;
     double d_k1q1deff_dV_D_S=0.0;
     double d_k1q1deff_dTemp_Tnode_GND=0.0;
     double d_k1q1deff_dV_S_B=0.0;
  double k2q2deff=0.0;
     double d_k2q2deff_dV_G_S=0.0;
     double d_k2q2deff_dV_D_S=0.0;
     double d_k2q2deff_dTemp_Tnode_GND=0.0;
     double d_k2q2deff_dV_S_B=0.0;
  double Qg=0.0;
     double d_Qg_dV_G_S=0.0;
     double d_Qg_dV_D_S=0.0;
     double d_Qg_dV_S_B=0.0;
     double d_Qg_dTemp_Tnode_GND=0.0;
  double Qb=0.0;
     double d_Qb_dV_G_S=0.0;
     double d_Qb_dV_D_S=0.0;
     double d_Qb_dV_S_B=0.0;
     double d_Qb_dTemp_Tnode_GND=0.0;
  double Qd=0.0;
     double d_Qd_dV_G_S=0.0;
     double d_Qd_dV_D_S=0.0;
     double d_Qd_dV_S_B=0.0;
     double d_Qd_dTemp_Tnode_GND=0.0;
  double xeffs=0.0;
     double d_xeffs_dTemp_Tnode_GND=0.0;
     double d_xeffs_dV_G_S=0.0;
     double d_xeffs_dV_D_S=0.0;
     double d_xeffs_dV_S_B=0.0;
  double xeffd=0.0;
     double d_xeffd_dV_D_S=0.0;
     double d_xeffd_dTemp_Tnode_GND=0.0;
     double d_xeffd_dV_G_S=0.0;
     double d_xeffd_dV_S_B=0.0;
  double xstars=0.0;
     double d_xstars_dTemp_Tnode_GND=0.0;
     double d_xstars_dV_G_S=0.0;
     double d_xstars_dV_D_S=0.0;
     double d_xstars_dV_S_B=0.0;
  double xstard=0.0;
     double d_xstard_dV_D_S=0.0;
     double d_xstard_dTemp_Tnode_GND=0.0;
     double d_xstard_dV_G_S=0.0;
     double d_xstard_dV_S_B=0.0;
  double lambdaf=0.0;
     double d_lambdaf_dV_G_S=0.0;
     double d_lambdaf_dV_D_S=0.0;
     double d_lambdaf_dTemp_Tnode_GND=0.0;
     double d_lambdaf_dV_S_B=0.0;
  double lambdab=0.0;
     double d_lambdab_dV_G_S=0.0;
     double d_lambdab_dV_D_S=0.0;
     double d_lambdab_dTemp_Tnode_GND=0.0;
     double d_lambdab_dV_S_B=0.0;
  double xalphaf=0.0;
     double d_xalphaf_dV_G_S=0.0;
     double d_xalphaf_dV_D_S=0.0;
     double d_xalphaf_dTemp_Tnode_GND=0.0;
     double d_xalphaf_dV_S_B=0.0;
  double xalphab=0.0;
     double d_xalphab_dV_G_S=0.0;
     double d_xalphab_dV_D_S=0.0;
     double d_xalphab_dTemp_Tnode_GND=0.0;
     double d_xalphab_dV_S_B=0.0;
  double xedgefs=0.0;
     double d_xedgefs_dTemp_Tnode_GND=0.0;
     double d_xedgefs_dV_G_S=0.0;
     double d_xedgefs_dV_D_S=0.0;
     double d_xedgefs_dV_S_B=0.0;
  double xedgefd=0.0;
     double d_xedgefd_dV_D_S=0.0;
     double d_xedgefd_dTemp_Tnode_GND=0.0;
     double d_xedgefd_dV_G_S=0.0;
     double d_xedgefd_dV_S_B=0.0;
  double xedgebs=0.0;
     double d_xedgebs_dTemp_Tnode_GND=0.0;
     double d_xedgebs_dV_G_S=0.0;
     double d_xedgebs_dV_D_S=0.0;
     double d_xedgebs_dV_S_B=0.0;
  double xedgebd=0.0;
     double d_xedgebd_dV_D_S=0.0;
     double d_xedgebd_dTemp_Tnode_GND=0.0;
     double d_xedgebd_dV_G_S=0.0;
     double d_xedgebd_dV_S_B=0.0;
  double Qgsif=0.0;
     double d_Qgsif_dV_S_B=0.0;
     double d_Qgsif_dV_G_S=0.0;
     double d_Qgsif_dV_D_S=0.0;
     double d_Qgsif_dTemp_Tnode_GND=0.0;
  double Qgdif=0.0;
     double d_Qgdif_dV_S_B=0.0;
     double d_Qgdif_dV_G_S=0.0;
     double d_Qgdif_dV_D_S=0.0;
     double d_Qgdif_dTemp_Tnode_GND=0.0;
  double Qbsif=0.0;
     double d_Qbsif_dV_G_S=0.0;
     double d_Qbsif_dTemp_Tnode_GND=0.0;
     double d_Qbsif_dV_D_S=0.0;
     double d_Qbsif_dV_S_B=0.0;
  double Qbdif=0.0;
     double d_Qbdif_dV_G_S=0.0;
     double d_Qbdif_dTemp_Tnode_GND=0.0;
     double d_Qbdif_dV_D_S=0.0;
     double d_Qbdif_dV_S_B=0.0;
  double Qgse=0.0;
     double d_Qgse_dV_G_S=0.0;
  double Qgde=0.0;
     double d_Qgde_dV_G_S=0.0;
     double d_Qgde_dV_D_S=0.0;
  double Qovs=0.0;
     double d_Qovs_dTemp_Tnode_GND=0.0;
     double d_Qovs_dV_G_S=0.0;
     double d_Qovs_dV_D_S=0.0;
     double d_Qovs_dV_S_B=0.0;
  double Qovd=0.0;
     double d_Qovd_dTemp_Tnode_GND=0.0;
     double d_Qovd_dV_G_S=0.0;
     double d_Qovd_dV_D_S=0.0;
     double d_Qovd_dV_S_B=0.0;
  double Qgbe=0.0;
     double d_Qgbe_dV_G_S=0.0;
     double d_Qgbe_dV_D_S=0.0;
     double d_Qgbe_dV_S_B=0.0;
  double Qdse=0.0;
     double d_Qdse_dV_D_S=0.0;
  double Qssub=0.0;
     double d_Qssub_dV_S_B=0.0;
  double Qdsub=0.0;
     double d_Qdsub_dV_D_S=0.0;
     double d_Qdsub_dV_S_B=0.0;
  double Qth=0.0;
     double d_Qth_dTemp_Tnode_GND=0.0;
  double Vgsu=0.0;
     double d_Vgsu_dV_G_S=0.0;
  double Vdsu=0.0;
     double d_Vdsu_dV_D_S=0.0;
  double Vsbu=0.0;
     double d_Vsbu_dV_S_B=0.0;
  double Vsdu=0.0;
     double d_Vsdu_dV_D_S=0.0;
  double Vgdu=0.0;
     double d_Vgdu_dV_G_S=0.0;
     double d_Vgdu_dV_D_S=0.0;
  double Vdbu=0.0;
     double d_Vdbu_dV_D_S=0.0;
     double d_Vdbu_dV_S_B=0.0;
  double Vds=0.0;
     double d_Vds_dV_D_S=0.0;
  double Vgs=0.0;
     double d_Vgs_dV_G_S=0.0;
     double d_Vgs_dV_D_S=0.0;
  double Vsb=0.0;
     double d_Vsb_dV_D_S=0.0;
     double d_Vsb_dV_S_B=0.0;
  double Vgb=0.0;
     double d_Vgb_dV_G_S=0.0;
     double d_Vgb_dV_D_S=0.0;
     double d_Vgb_dV_S_B=0.0;
  double xd=0.0;
     double d_xd_dV_D_S=0.0;
     double d_xd_dTemp_Tnode_GND=0.0;
  double xdsx=0.0;
     double d_xdsx_dV_D_S=0.0;
     double d_xdsx_dTemp_Tnode_GND=0.0;
  double dxdsx=0.0;
     double d_dxdsx_dV_D_S=0.0;
     double d_dxdsx_dTemp_Tnode_GND=0.0;
  double xg10=0.0;
     double d_xg10_dV_G_S=0.0;
     double d_xg10_dV_D_S=0.0;
     double d_xg10_dTemp_Tnode_GND=0.0;
  double xg20=0.0;
     double d_xg20_dV_D_S=0.0;
     double d_xg20_dV_S_B=0.0;
     double d_xg20_dTemp_Tnode_GND=0.0;
  double xgs_ov=0.0;
     double d_xgs_ov_dV_G_S=0.0;
     double d_xgs_ov_dTemp_Tnode_GND=0.0;
  double xgd_ov=0.0;
     double d_xgd_ov_dV_G_S=0.0;
     double d_xgd_ov_dV_D_S=0.0;
     double d_xgd_ov_dTemp_Tnode_GND=0.0;
  double xgs_ovcv=0.0;
     double d_xgs_ovcv_dV_G_S=0.0;
     double d_xgs_ovcv_dTemp_Tnode_GND=0.0;
  double xgd_ovcv=0.0;
     double d_xgd_ovcv_dV_G_S=0.0;
     double d_xgd_ovcv_dV_D_S=0.0;
     double d_xgd_ovcv_dTemp_Tnode_GND=0.0;
  double SPSUB_xgb=0.0;
     double d_SPSUB_xgb_dV_G_S=0.0;
     double d_SPSUB_xgb_dV_D_S=0.0;
     double d_SPSUB_xgb_dTemp_Tnode_GND=0.0;
     double d_SPSUB_xgb_dV_S_B=0.0;
  double SPSUB_delta=0.0;
  double SPSUB_xg1=0.0;
  double SPSUB_A_fac=0.0;
  double SPSUB_xbar=0.0;
     double d_SPSUB_xbar_dV_G_S=0.0;
     double d_SPSUB_xbar_dV_D_S=0.0;
     double d_SPSUB_xbar_dTemp_Tnode_GND=0.0;
     double d_SPSUB_xbar_dV_S_B=0.0;
  double SPSUB_w=0.0;
     double d_SPSUB_w_dV_G_S=0.0;
     double d_SPSUB_w_dV_D_S=0.0;
     double d_SPSUB_w_dTemp_Tnode_GND=0.0;
     double d_SPSUB_w_dV_S_B=0.0;
  double SPSUB_x1=0.0;
     double d_SPSUB_x1_dV_G_S=0.0;
     double d_SPSUB_x1_dV_D_S=0.0;
     double d_SPSUB_x1_dTemp_Tnode_GND=0.0;
     double d_SPSUB_x1_dV_S_B=0.0;
  double SPSUB_bx=0.0;
  double SPSUB_temp2=0.0;
     double d_SPSUB_temp2_dV_G_S=0.0;
     double d_SPSUB_temp2_dV_D_S=0.0;
     double d_SPSUB_temp2_dTemp_Tnode_GND=0.0;
     double d_SPSUB_temp2_dV_S_B=0.0;
  double SPSUB_b=0.0;
     double d_SPSUB_b_dV_G_S=0.0;
     double d_SPSUB_b_dV_D_S=0.0;
     double d_SPSUB_b_dTemp_Tnode_GND=0.0;
     double d_SPSUB_b_dV_S_B=0.0;
  double SPSUB_x0=0.0;
     double d_SPSUB_x0_dV_G_S=0.0;
     double d_SPSUB_x0_dV_D_S=0.0;
     double d_SPSUB_x0_dTemp_Tnode_GND=0.0;
     double d_SPSUB_x0_dV_S_B=0.0;
  double SPSUB_yg=0.0;
     double d_SPSUB_yg_dV_G_S=0.0;
     double d_SPSUB_yg_dV_D_S=0.0;
     double d_SPSUB_yg_dTemp_Tnode_GND=0.0;
     double d_SPSUB_yg_dV_S_B=0.0;
  double SPSUB_ysub=0.0;
     double d_SPSUB_ysub_dV_G_S=0.0;
     double d_SPSUB_ysub_dV_D_S=0.0;
     double d_SPSUB_ysub_dTemp_Tnode_GND=0.0;
     double d_SPSUB_ysub_dV_S_B=0.0;
  double SPSUB_eta=0.0;
     double d_SPSUB_eta_dV_G_S=0.0;
     double d_SPSUB_eta_dV_D_S=0.0;
     double d_SPSUB_eta_dTemp_Tnode_GND=0.0;
     double d_SPSUB_eta_dV_S_B=0.0;
  double SPSUB_temp=0.0;
     double d_SPSUB_temp_dV_G_S=0.0;
     double d_SPSUB_temp_dV_D_S=0.0;
     double d_SPSUB_temp_dTemp_Tnode_GND=0.0;
     double d_SPSUB_temp_dV_S_B=0.0;
  double SPSUB_a=0.0;
     double d_SPSUB_a_dV_G_S=0.0;
     double d_SPSUB_a_dV_D_S=0.0;
     double d_SPSUB_a_dTemp_Tnode_GND=0.0;
     double d_SPSUB_a_dV_S_B=0.0;
  double SPSUB_c=0.0;
     double d_SPSUB_c_dV_G_S=0.0;
     double d_SPSUB_c_dV_D_S=0.0;
     double d_SPSUB_c_dTemp_Tnode_GND=0.0;
     double d_SPSUB_c_dV_S_B=0.0;
  double SPSUB_tau=0.0;
     double d_SPSUB_tau_dV_G_S=0.0;
     double d_SPSUB_tau_dV_D_S=0.0;
     double d_SPSUB_tau_dTemp_Tnode_GND=0.0;
     double d_SPSUB_tau_dV_S_B=0.0;
  double nu=0.0;
     double d_nu_dV_G_S=0.0;
     double d_nu_dV_D_S=0.0;
     double d_nu_dTemp_Tnode_GND=0.0;
     double d_nu_dV_S_B=0.0;
  double mutau=0.0;
     double d_mutau_dV_G_S=0.0;
     double d_mutau_dV_D_S=0.0;
     double d_mutau_dTemp_Tnode_GND=0.0;
     double d_mutau_dV_S_B=0.0;
  double SPSUB_y0=0.0;
     double d_SPSUB_y0_dV_G_S=0.0;
     double d_SPSUB_y0_dV_D_S=0.0;
     double d_SPSUB_y0_dTemp_Tnode_GND=0.0;
     double d_SPSUB_y0_dV_S_B=0.0;
  double SPSUB_delta0=0.0;
     double d_SPSUB_delta0_dV_G_S=0.0;
     double d_SPSUB_delta0_dV_D_S=0.0;
     double d_SPSUB_delta0_dTemp_Tnode_GND=0.0;
     double d_SPSUB_delta0_dV_S_B=0.0;
  double SPSUB_delta1=0.0;
     double d_SPSUB_delta1_dV_G_S=0.0;
     double d_SPSUB_delta1_dV_D_S=0.0;
     double d_SPSUB_delta1_dTemp_Tnode_GND=0.0;
     double d_SPSUB_delta1_dV_S_B=0.0;
  double SPSUB_xi0=0.0;
     double d_SPSUB_xi0_dV_G_S=0.0;
     double d_SPSUB_xi0_dV_D_S=0.0;
     double d_SPSUB_xi0_dTemp_Tnode_GND=0.0;
     double d_SPSUB_xi0_dV_S_B=0.0;
  double SPSUB_xi1=0.0;
     double d_SPSUB_xi1_dV_G_S=0.0;
     double d_SPSUB_xi1_dV_D_S=0.0;
     double d_SPSUB_xi1_dTemp_Tnode_GND=0.0;
     double d_SPSUB_xi1_dV_S_B=0.0;
  double SPSUB_xi2=0.0;
     double d_SPSUB_xi2_dV_G_S=0.0;
     double d_SPSUB_xi2_dV_D_S=0.0;
     double d_SPSUB_xi2_dTemp_Tnode_GND=0.0;
     double d_SPSUB_xi2_dV_S_B=0.0;
  double SPSUB_pC=0.0;
     double d_SPSUB_pC_dV_G_S=0.0;
     double d_SPSUB_pC_dV_D_S=0.0;
     double d_SPSUB_pC_dTemp_Tnode_GND=0.0;
     double d_SPSUB_pC_dV_S_B=0.0;
  double SPSUB_qC=0.0;
     double d_SPSUB_qC_dV_G_S=0.0;
     double d_SPSUB_qC_dV_D_S=0.0;
     double d_SPSUB_qC_dTemp_Tnode_GND=0.0;
     double d_SPSUB_qC_dV_S_B=0.0;
  double SPSUB_temp1=0.0;
     double d_SPSUB_temp1_dV_G_S=0.0;
     double d_SPSUB_temp1_dV_D_S=0.0;
     double d_SPSUB_temp1_dTemp_Tnode_GND=0.0;
     double d_SPSUB_temp1_dV_S_B=0.0;
  double xg2eff=0.0;
     double d_xg2eff_dTemp_Tnode_GND=0.0;
     double d_xg2eff_dV_G_S=0.0;
     double d_xg2eff_dV_D_S=0.0;
     double d_xg2eff_dV_S_B=0.0;
  double e1=0.0;
     double d_e1_dV_G_S=0.0;
     double d_e1_dV_D_S=0.0;
     double d_e1_dV_S_B=0.0;
     double d_e1_dTemp_Tnode_GND=0.0;
  double e2=0.0;
     double d_e2_dV_G_S=0.0;
     double d_e2_dV_D_S=0.0;
     double d_e2_dV_S_B=0.0;
     double d_e2_dTemp_Tnode_GND=0.0;
  double tox1fact=0.0;
     double d_tox1fact_dV_S_B=0.0;
     double d_tox1fact_dV_G_S=0.0;
     double d_tox1fact_dV_D_S=0.0;
     double d_tox1fact_dTemp_Tnode_GND=0.0;
  double tox2fact=0.0;
     double d_tox2fact_dV_G_S=0.0;
     double d_tox2fact_dTemp_Tnode_GND=0.0;
     double d_tox2fact_dV_D_S=0.0;
     double d_tox2fact_dV_S_B=0.0;
  double k1_1D_QM=0.0;
     double d_k1_1D_QM_dV_G_S=0.0;
     double d_k1_1D_QM_dV_D_S=0.0;
     double d_k1_1D_QM_dTemp_Tnode_GND=0.0;
     double d_k1_1D_QM_dV_S_B=0.0;
  double k2_1D_QM=0.0;
     double d_k2_1D_QM_dV_G_S=0.0;
     double d_k2_1D_QM_dV_D_S=0.0;
     double d_k2_1D_QM_dTemp_Tnode_GND=0.0;
     double d_k2_1D_QM_dV_S_B=0.0;
  double keq_1D_QM=0.0;
     double d_keq_1D_QM_dV_G_S=0.0;
     double d_keq_1D_QM_dV_D_S=0.0;
     double d_keq_1D_QM_dTemp_Tnode_GND=0.0;
     double d_keq_1D_QM_dV_S_B=0.0;
  double Dx_WI_1D=0.0;
     double d_Dx_WI_1D_dV_G_S=0.0;
     double d_Dx_WI_1D_dV_D_S=0.0;
     double d_Dx_WI_1D_dTemp_Tnode_GND=0.0;
     double d_Dx_WI_1D_dV_S_B=0.0;
  double x_WI_1D=0.0;
     double d_x_WI_1D_dV_G_S=0.0;
     double d_x_WI_1D_dV_D_S=0.0;
     double d_x_WI_1D_dTemp_Tnode_GND=0.0;
     double d_x_WI_1D_dV_S_B=0.0;
  double x_1D=0.0;
     double d_x_1D_dV_G_S=0.0;
     double d_x_1D_dV_D_S=0.0;
     double d_x_1D_dTemp_Tnode_GND=0.0;
     double d_x_1D_dV_S_B=0.0;
  double dleff=0.0;
     double d_dleff_dTemp_Tnode_GND=0.0;
     double d_dleff_dV_G_S=0.0;
     double d_dleff_dV_D_S=0.0;
     double d_dleff_dV_S_B=0.0;
  double xedge=0.0;
     double d_xedge_dV_G_S=0.0;
     double d_xedge_dV_D_S=0.0;
     double d_xedge_dTemp_Tnode_GND=0.0;
     double d_xedge_dV_S_B=0.0;
  double sce1=0.0;
     double d_sce1_dV_G_S=0.0;
     double d_sce1_dV_D_S=0.0;
     double d_sce1_dV_S_B=0.0;
     double d_sce1_dTemp_Tnode_GND=0.0;
  double sce2=0.0;
     double d_sce2_dV_G_S=0.0;
     double d_sce2_dV_D_S=0.0;
     double d_sce2_dV_S_B=0.0;
     double d_sce2_dTemp_Tnode_GND=0.0;
  double dxg1_dibl=0.0;
     double d_dxg1_dibl_dTemp_Tnode_GND=0.0;
     double d_dxg1_dibl_dV_G_S=0.0;
     double d_dxg1_dibl_dV_D_S=0.0;
     double d_dxg1_dibl_dV_S_B=0.0;
  double dxg2_dibl=0.0;
     double d_dxg2_dibl_dTemp_Tnode_GND=0.0;
     double d_dxg2_dibl_dV_G_S=0.0;
     double d_dxg2_dibl_dV_D_S=0.0;
     double d_dxg2_dibl_dV_S_B=0.0;
  double xg1=0.0;
     double d_xg1_dV_G_S=0.0;
     double d_xg1_dV_D_S=0.0;
     double d_xg1_dTemp_Tnode_GND=0.0;
     double d_xg1_dV_S_B=0.0;
  double xg2=0.0;
     double d_xg2_dTemp_Tnode_GND=0.0;
     double d_xg2_dV_G_S=0.0;
     double d_xg2_dV_D_S=0.0;
     double d_xg2_dV_S_B=0.0;
  double xg1x=0.0;
     double d_xg1x_dTemp_Tnode_GND=0.0;
     double d_xg1x_dV_G_S=0.0;
     double d_xg1x_dV_D_S=0.0;
     double d_xg1x_dV_S_B=0.0;
  double xg2x=0.0;
     double d_xg2x_dV_G_S=0.0;
     double d_xg2x_dV_D_S=0.0;
     double d_xg2x_dTemp_Tnode_GND=0.0;
     double d_xg2x_dV_S_B=0.0;
  double k2=0.0;
     double d_k2_dV_G_S=0.0;
     double d_k2_dV_D_S=0.0;
     double d_k2_dTemp_Tnode_GND=0.0;
     double d_k2_dV_S_B=0.0;
  double inv_k1=0.0;
     double d_inv_k1_dV_G_S=0.0;
     double d_inv_k1_dV_D_S=0.0;
     double d_inv_k1_dTemp_Tnode_GND=0.0;
     double d_inv_k1_dV_S_B=0.0;
  double inv_k2=0.0;
     double d_inv_k2_dV_G_S=0.0;
     double d_inv_k2_dV_D_S=0.0;
     double d_inv_k2_dTemp_Tnode_GND=0.0;
     double d_inv_k2_dV_S_B=0.0;
  double keq=0.0;
     double d_keq_dV_G_S=0.0;
     double d_keq_dV_D_S=0.0;
     double d_keq_dTemp_Tnode_GND=0.0;
     double d_keq_dV_S_B=0.0;
  double A0=0.0;
     double d_A0_dTemp_Tnode_GND=0.0;
     double d_A0_dV_G_S=0.0;
     double d_A0_dV_D_S=0.0;
     double d_A0_dV_S_B=0.0;
  double exp_dxth=0.0;
     double d_exp_dxth_dV_G_S=0.0;
     double d_exp_dxth_dV_D_S=0.0;
     double d_exp_dxth_dTemp_Tnode_GND=0.0;
     double d_exp_dxth_dV_S_B=0.0;
  double dxth=0.0;
     double d_dxth_dV_G_S=0.0;
     double d_dxth_dV_D_S=0.0;
     double d_dxth_dTemp_Tnode_GND=0.0;
     double d_dxth_dV_S_B=0.0;
  double diff_min=0.0;
     double d_diff_min_dV_G_S=0.0;
     double d_diff_min_dV_D_S=0.0;
     double d_diff_min_dTemp_Tnode_GND=0.0;
     double d_diff_min_dV_S_B=0.0;
  double Dx_WI=0.0;
     double d_Dx_WI_dV_G_S=0.0;
     double d_Dx_WI_dV_D_S=0.0;
     double d_Dx_WI_dTemp_Tnode_GND=0.0;
     double d_Dx_WI_dV_S_B=0.0;
  double Dx_WIsq=0.0;
     double d_Dx_WIsq_dV_G_S=0.0;
     double d_Dx_WIsq_dV_D_S=0.0;
     double d_Dx_WIsq_dTemp_Tnode_GND=0.0;
     double d_Dx_WIsq_dV_S_B=0.0;
  double x1_WI0=0.0;
     double d_x1_WI0_dTemp_Tnode_GND=0.0;
     double d_x1_WI0_dV_G_S=0.0;
     double d_x1_WI0_dV_D_S=0.0;
     double d_x1_WI0_dV_S_B=0.0;
  double x2_WI0=0.0;
     double d_x2_WI0_dV_G_S=0.0;
     double d_x2_WI0_dV_D_S=0.0;
     double d_x2_WI0_dTemp_Tnode_GND=0.0;
     double d_x2_WI0_dV_S_B=0.0;
  double q_temp1=0.0;
     double d_q_temp1_dV_G_S=0.0;
     double d_q_temp1_dV_D_S=0.0;
     double d_q_temp1_dTemp_Tnode_GND=0.0;
     double d_q_temp1_dV_S_B=0.0;
  double q_temp2=0.0;
     double d_q_temp2_dV_G_S=0.0;
     double d_q_temp2_dV_D_S=0.0;
     double d_q_temp2_dTemp_Tnode_GND=0.0;
     double d_q_temp2_dV_S_B=0.0;
  double q_x1sat=0.0;
     double d_q_x1sat_dV_G_S=0.0;
     double d_q_x1sat_dV_D_S=0.0;
     double d_q_x1sat_dTemp_Tnode_GND=0.0;
     double d_q_x1sat_dV_S_B=0.0;
  double q_x2sat=0.0;
     double d_q_x2sat_dV_G_S=0.0;
     double d_q_x2sat_dV_D_S=0.0;
     double d_q_x2sat_dTemp_Tnode_GND=0.0;
     double d_q_x2sat_dV_S_B=0.0;
  double q_temp3=0.0;
     double d_q_temp3_dV_G_S=0.0;
     double d_q_temp3_dV_D_S=0.0;
     double d_q_temp3_dTemp_Tnode_GND=0.0;
     double d_q_temp3_dV_S_B=0.0;
  double q_x1=0.0;
     double d_q_x1_dV_G_S=0.0;
     double d_q_x1_dV_D_S=0.0;
     double d_q_x1_dTemp_Tnode_GND=0.0;
     double d_q_x1_dV_S_B=0.0;
  double q_x2=0.0;
     double d_q_x2_dV_G_S=0.0;
     double d_q_x2_dV_D_S=0.0;
     double d_q_x2_dTemp_Tnode_GND=0.0;
     double d_q_x2_dV_S_B=0.0;
  double q_x1_WI=0.0;
     double d_q_x1_WI_dV_G_S=0.0;
     double d_q_x1_WI_dV_D_S=0.0;
     double d_q_x1_WI_dTemp_Tnode_GND=0.0;
     double d_q_x1_WI_dV_S_B=0.0;
  double q_x2_WI=0.0;
     double d_q_x2_WI_dV_G_S=0.0;
     double d_q_x2_WI_dV_D_S=0.0;
     double d_q_x2_WI_dTemp_Tnode_GND=0.0;
     double d_q_x2_WI_dV_S_B=0.0;
  double q1s=0.0;
     double d_q1s_dTemp_Tnode_GND=0.0;
     double d_q1s_dV_G_S=0.0;
     double d_q1s_dV_D_S=0.0;
     double d_q1s_dV_S_B=0.0;
  double q2s=0.0;
     double d_q2s_dV_G_S=0.0;
     double d_q2s_dV_D_S=0.0;
     double d_q2s_dTemp_Tnode_GND=0.0;
     double d_q2s_dV_S_B=0.0;
  double q_rac_qsq=0.0;
     double d_q_rac_qsq_dV_G_S=0.0;
     double d_q_rac_qsq_dV_D_S=0.0;
     double d_q_rac_qsq_dTemp_Tnode_GND=0.0;
     double d_q_rac_qsq_dV_S_B=0.0;
  double q_invexpq=0.0;
     double d_q_invexpq_dV_G_S=0.0;
     double d_q_invexpq_dV_D_S=0.0;
     double d_q_invexpq_dTemp_Tnode_GND=0.0;
     double d_q_invexpq_dV_S_B=0.0;
  double q_k1q1=0.0;
     double d_q_k1q1_dV_G_S=0.0;
     double d_q_k1q1_dV_D_S=0.0;
     double d_q_k1q1_dTemp_Tnode_GND=0.0;
     double d_q_k1q1_dV_S_B=0.0;
  double q_Aexp=0.0;
     double d_q_Aexp_dTemp_Tnode_GND=0.0;
     double d_q_Aexp_dV_G_S=0.0;
     double d_q_Aexp_dV_D_S=0.0;
     double d_q_Aexp_dV_S_B=0.0;
  double q_qsq=0.0;
     double d_q_qsq_dV_G_S=0.0;
     double d_q_qsq_dV_D_S=0.0;
     double d_q_qsq_dTemp_Tnode_GND=0.0;
     double d_q_qsq_dV_S_B=0.0;
  double q_d1_qsq=0.0;
     double d_q_d1_qsq_dV_G_S=0.0;
     double d_q_d1_qsq_dV_D_S=0.0;
     double d_q_d1_qsq_dTemp_Tnode_GND=0.0;
     double d_q_d1_qsq_dV_S_B=0.0;
  double q_d2_qsq=0.0;
     double d_q_d2_qsq_dV_G_S=0.0;
     double d_q_d2_qsq_dV_D_S=0.0;
     double d_q_d2_qsq_dTemp_Tnode_GND=0.0;
     double d_q_d2_qsq_dV_S_B=0.0;
  double q_qcoth=0.0;
     double d_q_qcoth_dV_G_S=0.0;
     double d_q_qcoth_dV_D_S=0.0;
     double d_q_qcoth_dTemp_Tnode_GND=0.0;
     double d_q_qcoth_dV_S_B=0.0;
  double q_d1_qcoth=0.0;
     double d_q_d1_qcoth_dV_G_S=0.0;
     double d_q_d1_qcoth_dV_D_S=0.0;
     double d_q_d1_qcoth_dTemp_Tnode_GND=0.0;
     double d_q_d1_qcoth_dV_S_B=0.0;
  double q_d2_qcoth=0.0;
     double d_q_d2_qcoth_dV_G_S=0.0;
     double d_q_d2_qcoth_dV_D_S=0.0;
     double d_q_d2_qcoth_dTemp_Tnode_GND=0.0;
     double d_q_d2_qcoth_dV_S_B=0.0;
  double q_d1_ln=0.0;
     double d_q_d1_ln_dV_G_S=0.0;
     double d_q_d1_ln_dV_D_S=0.0;
     double d_q_d1_ln_dTemp_Tnode_GND=0.0;
     double d_q_d1_ln_dV_S_B=0.0;
  double q_d2_ln=0.0;
     double d_q_d2_ln_dV_G_S=0.0;
     double d_q_d2_ln_dV_D_S=0.0;
     double d_q_d2_ln_dTemp_Tnode_GND=0.0;
     double d_q_d2_ln_dV_S_B=0.0;
  double q_sh_term=0.0;
     double d_q_sh_term_dV_G_S=0.0;
     double d_q_sh_term_dV_D_S=0.0;
     double d_q_sh_term_dTemp_Tnode_GND=0.0;
     double d_q_sh_term_dV_S_B=0.0;
  double q_ln_term=0.0;
     double d_q_ln_term_dV_G_S=0.0;
     double d_q_ln_term_dV_D_S=0.0;
     double d_q_ln_term_dTemp_Tnode_GND=0.0;
     double d_q_ln_term_dV_S_B=0.0;
  double q_expnum=0.0;
     double d_q_expnum_dV_G_S=0.0;
     double d_q_expnum_dV_D_S=0.0;
     double d_q_expnum_dTemp_Tnode_GND=0.0;
     double d_q_expnum_dV_S_B=0.0;
  double q_d1_expnum=0.0;
     double d_q_d1_expnum_dV_G_S=0.0;
     double d_q_d1_expnum_dV_D_S=0.0;
     double d_q_d1_expnum_dTemp_Tnode_GND=0.0;
     double d_q_d1_expnum_dV_S_B=0.0;
  double q_d2_expnum=0.0;
     double d_q_d2_expnum_dV_G_S=0.0;
     double d_q_d2_expnum_dV_D_S=0.0;
     double d_q_d2_expnum_dTemp_Tnode_GND=0.0;
     double d_q_d2_expnum_dV_S_B=0.0;
  double q_lnexpnum=0.0;
     double d_q_lnexpnum_dV_G_S=0.0;
     double d_q_lnexpnum_dV_D_S=0.0;
     double d_q_lnexpnum_dTemp_Tnode_GND=0.0;
     double d_q_lnexpnum_dV_S_B=0.0;
  double q_d1_lnexpnum=0.0;
     double d_q_d1_lnexpnum_dV_G_S=0.0;
     double d_q_d1_lnexpnum_dV_D_S=0.0;
     double d_q_d1_lnexpnum_dTemp_Tnode_GND=0.0;
     double d_q_d1_lnexpnum_dV_S_B=0.0;
  double q_d2_lnexpnum=0.0;
     double d_q_d2_lnexpnum_dV_G_S=0.0;
     double d_q_d2_lnexpnum_dV_D_S=0.0;
     double d_q_d2_lnexpnum_dTemp_Tnode_GND=0.0;
     double d_q_d2_lnexpnum_dV_S_B=0.0;
  double q_q2_int=0.0;
     double d_q_q2_int_dV_G_S=0.0;
     double d_q_q2_int_dV_D_S=0.0;
     double d_q_q2_int_dTemp_Tnode_GND=0.0;
     double d_q_q2_int_dV_S_B=0.0;
  double q_d1_q2=0.0;
     double d_q_d1_q2_dV_G_S=0.0;
     double d_q_d1_q2_dV_D_S=0.0;
     double d_q_d1_q2_dTemp_Tnode_GND=0.0;
     double d_q_d1_q2_dV_S_B=0.0;
  double q_d2_q2=0.0;
     double d_q_d2_q2_dV_G_S=0.0;
     double d_q_d2_q2_dV_D_S=0.0;
     double d_q_d2_q2_dTemp_Tnode_GND=0.0;
     double d_q_d2_q2_dV_S_B=0.0;
  double q_qi_int=0.0;
     double d_q_qi_int_dV_G_S=0.0;
     double d_q_qi_int_dV_D_S=0.0;
     double d_q_qi_int_dTemp_Tnode_GND=0.0;
     double d_q_qi_int_dV_S_B=0.0;
  double q_d1_qi=0.0;
     double d_q_d1_qi_dV_G_S=0.0;
     double d_q_d1_qi_dV_D_S=0.0;
     double d_q_d1_qi_dTemp_Tnode_GND=0.0;
     double d_q_d1_qi_dV_S_B=0.0;
  double q_d2_qi=0.0;
     double d_q_d2_qi_dV_G_S=0.0;
     double d_q_d2_qi_dV_D_S=0.0;
     double d_q_d2_qi_dTemp_Tnode_GND=0.0;
     double d_q_d2_qi_dV_S_B=0.0;
  double q_zero=0.0;
     double d_q_zero_dV_G_S=0.0;
     double d_q_zero_dV_D_S=0.0;
     double d_q_zero_dTemp_Tnode_GND=0.0;
     double d_q_zero_dV_S_B=0.0;
  double q_d1_zero=0.0;
     double d_q_d1_zero_dV_G_S=0.0;
     double d_q_d1_zero_dV_D_S=0.0;
     double d_q_d1_zero_dTemp_Tnode_GND=0.0;
     double d_q_d1_zero_dV_S_B=0.0;
  double q_d2_zero=0.0;
     double d_q_d2_zero_dV_G_S=0.0;
     double d_q_d2_zero_dV_D_S=0.0;
     double d_q_d2_zero_dTemp_Tnode_GND=0.0;
     double d_q_d2_zero_dV_S_B=0.0;
  double q_eps1=0.0;
     double d_q_eps1_dV_G_S=0.0;
     double d_q_eps1_dV_D_S=0.0;
     double d_q_eps1_dTemp_Tnode_GND=0.0;
     double d_q_eps1_dV_S_B=0.0;
  double q_eps2=0.0;
     double d_q_eps2_dV_G_S=0.0;
     double d_q_eps2_dV_D_S=0.0;
     double d_q_eps2_dTemp_Tnode_GND=0.0;
     double d_q_eps2_dV_S_B=0.0;
  double q_k2q2=0.0;
     double d_q_k2q2_dV_G_S=0.0;
     double d_q_k2q2_dV_D_S=0.0;
     double d_q_k2q2_dTemp_Tnode_GND=0.0;
     double d_q_k2q2_dV_S_B=0.0;
  double q_a=0.0;
     double d_q_a_dV_G_S=0.0;
     double d_q_a_dV_D_S=0.0;
     double d_q_a_dTemp_Tnode_GND=0.0;
     double d_q_a_dV_S_B=0.0;
  double q_b=0.0;
     double d_q_b_dV_G_S=0.0;
     double d_q_b_dV_D_S=0.0;
     double d_q_b_dTemp_Tnode_GND=0.0;
     double d_q_b_dV_S_B=0.0;
  double q_c=0.0;
     double d_q_c_dV_G_S=0.0;
     double d_q_c_dV_D_S=0.0;
     double d_q_c_dTemp_Tnode_GND=0.0;
     double d_q_c_dV_S_B=0.0;
  double q_disc=0.0;
     double d_q_disc_dV_G_S=0.0;
     double d_q_disc_dV_D_S=0.0;
     double d_q_disc_dTemp_Tnode_GND=0.0;
     double d_q_disc_dV_S_B=0.0;
  double q_delta=0.0;
     double d_q_delta_dV_G_S=0.0;
     double d_q_delta_dV_D_S=0.0;
     double d_q_delta_dTemp_Tnode_GND=0.0;
     double d_q_delta_dV_S_B=0.0;
  double q_dx1=0.0;
     double d_q_dx1_dTemp_Tnode_GND=0.0;
     double d_q_dx1_dV_G_S=0.0;
     double d_q_dx1_dV_D_S=0.0;
     double d_q_dx1_dV_S_B=0.0;
  double k1q1s=0.0;
     double d_k1q1s_dV_G_S=0.0;
     double d_k1q1s_dV_D_S=0.0;
     double d_k1q1s_dTemp_Tnode_GND=0.0;
     double d_k1q1s_dV_S_B=0.0;
  double Aexp1s=0.0;
     double d_Aexp1s_dTemp_Tnode_GND=0.0;
     double d_Aexp1s_dV_G_S=0.0;
     double d_Aexp1s_dV_D_S=0.0;
     double d_Aexp1s_dV_S_B=0.0;
  double qsqs=0.0;
     double d_qsqs_dV_G_S=0.0;
     double d_qsqs_dV_D_S=0.0;
     double d_qsqs_dTemp_Tnode_GND=0.0;
     double d_qsqs_dV_S_B=0.0;
  double k2q2s=0.0;
     double d_k2q2s_dV_G_S=0.0;
     double d_k2q2s_dV_D_S=0.0;
     double d_k2q2s_dTemp_Tnode_GND=0.0;
     double d_k2q2s_dV_S_B=0.0;
  double Aexp2s=0.0;
     double d_Aexp2s_dTemp_Tnode_GND=0.0;
     double d_Aexp2s_dV_G_S=0.0;
     double d_Aexp2s_dV_D_S=0.0;
     double d_Aexp2s_dV_S_B=0.0;
  double a1s=0.0;
     double d_a1s_dTemp_Tnode_GND=0.0;
     double d_a1s_dV_G_S=0.0;
     double d_a1s_dV_D_S=0.0;
     double d_a1s_dV_S_B=0.0;
  double a2s=0.0;
     double d_a2s_dTemp_Tnode_GND=0.0;
     double d_a2s_dV_G_S=0.0;
     double d_a2s_dV_D_S=0.0;
     double d_a2s_dV_S_B=0.0;
  double b1s=0.0;
     double d_b1s_dTemp_Tnode_GND=0.0;
     double d_b1s_dV_G_S=0.0;
     double d_b1s_dV_D_S=0.0;
     double d_b1s_dV_S_B=0.0;
  double b2s=0.0;
     double d_b2s_dTemp_Tnode_GND=0.0;
     double d_b2s_dV_G_S=0.0;
     double d_b2s_dV_D_S=0.0;
     double d_b2s_dV_S_B=0.0;
  double sums=0.0;
     double d_sums_dTemp_Tnode_GND=0.0;
     double d_sums_dV_G_S=0.0;
     double d_sums_dV_D_S=0.0;
     double d_sums_dV_S_B=0.0;
  double dqsqs_dxn_qi=0.0;
     double d_dqsqs_dxn_qi_dV_G_S=0.0;
     double d_dqsqs_dxn_qi_dV_D_S=0.0;
     double d_dqsqs_dxn_qi_dTemp_Tnode_GND=0.0;
     double d_dqsqs_dxn_qi_dV_S_B=0.0;
  double xdrifts=0.0;
     double d_xdrifts_dTemp_Tnode_GND=0.0;
     double d_xdrifts_dV_G_S=0.0;
     double d_xdrifts_dV_D_S=0.0;
     double d_xdrifts_dV_S_B=0.0;
  double esurf1s=0.0;
     double d_esurf1s_dV_S_B=0.0;
     double d_esurf1s_dV_G_S=0.0;
     double d_esurf1s_dV_D_S=0.0;
     double d_esurf1s_dTemp_Tnode_GND=0.0;
  double esurf2s=0.0;
     double d_esurf2s_dV_G_S=0.0;
     double d_esurf2s_dTemp_Tnode_GND=0.0;
     double d_esurf2s_dV_D_S=0.0;
     double d_esurf2s_dV_S_B=0.0;
  double ecpl1s=0.0;
     double d_ecpl1s_dV_G_S=0.0;
     double d_ecpl1s_dTemp_Tnode_GND=0.0;
     double d_ecpl1s_dV_D_S=0.0;
     double d_ecpl1s_dV_S_B=0.0;
  double ecpl2s=0.0;
     double d_ecpl2s_dV_S_B=0.0;
     double d_ecpl2s_dV_G_S=0.0;
     double d_ecpl2s_dV_D_S=0.0;
     double d_ecpl2s_dTemp_Tnode_GND=0.0;
  double eeff1s=0.0;
     double d_eeff1s_dV_S_B=0.0;
     double d_eeff1s_dV_G_S=0.0;
     double d_eeff1s_dV_D_S=0.0;
     double d_eeff1s_dTemp_Tnode_GND=0.0;
  double eeff2s=0.0;
     double d_eeff2s_dV_G_S=0.0;
     double d_eeff2s_dTemp_Tnode_GND=0.0;
     double d_eeff2s_dV_D_S=0.0;
     double d_eeff2s_dV_S_B=0.0;
  double qi1s=0.0;
     double d_qi1s_dV_S_B=0.0;
     double d_qi1s_dV_G_S=0.0;
     double d_qi1s_dV_D_S=0.0;
     double d_qi1s_dTemp_Tnode_GND=0.0;
  double qi2s=0.0;
     double d_qi2s_dV_G_S=0.0;
     double d_qi2s_dTemp_Tnode_GND=0.0;
     double d_qi2s_dV_D_S=0.0;
     double d_qi2s_dV_S_B=0.0;
  double c1s=0.0;
     double d_c1s_dV_S_B=0.0;
     double d_c1s_dV_G_S=0.0;
     double d_c1s_dV_D_S=0.0;
     double d_c1s_dTemp_Tnode_GND=0.0;
  double c2s=0.0;
     double d_c2s_dV_G_S=0.0;
     double d_c2s_dTemp_Tnode_GND=0.0;
     double d_c2s_dV_D_S=0.0;
     double d_c2s_dV_S_B=0.0;
  double fcors=0.0;
     double d_fcors_dV_G_S=0.0;
     double d_fcors_dTemp_Tnode_GND=0.0;
     double d_fcors_dV_D_S=0.0;
     double d_fcors_dV_S_B=0.0;
  double Gcss=0.0;
     double d_Gcss_dTemp_Tnode_GND=0.0;
     double d_Gcss_dV_G_S=0.0;
     double d_Gcss_dV_D_S=0.0;
     double d_Gcss_dV_S_B=0.0;
  double frscsi=0.0;
     double d_frscsi_dTemp_Tnode_GND=0.0;
     double d_frscsi_dV_G_S=0.0;
     double d_frscsi_dV_D_S=0.0;
     double d_frscsi_dV_S_B=0.0;
  double Grss=0.0;
     double d_Grss_dTemp_Tnode_GND=0.0;
     double d_Grss_dV_G_S=0.0;
     double d_Grss_dV_D_S=0.0;
     double d_Grss_dV_S_B=0.0;
  double Gmob1s=0.0;
     double d_Gmob1s_dTemp_Tnode_GND=0.0;
     double d_Gmob1s_dV_S_B=0.0;
     double d_Gmob1s_dV_G_S=0.0;
     double d_Gmob1s_dV_D_S=0.0;
  double Gmob2s=0.0;
     double d_Gmob2s_dTemp_Tnode_GND=0.0;
     double d_Gmob2s_dV_G_S=0.0;
     double d_Gmob2s_dV_D_S=0.0;
     double d_Gmob2s_dV_S_B=0.0;
  double Gmobs=0.0;
     double d_Gmobs_dV_G_S=0.0;
     double d_Gmobs_dTemp_Tnode_GND=0.0;
     double d_Gmobs_dV_D_S=0.0;
     double d_Gmobs_dV_S_B=0.0;
  double s1=0.0;
     double d_s1_dV_G_S=0.0;
     double d_s1_dV_D_S=0.0;
     double d_s1_dTemp_Tnode_GND=0.0;
     double d_s1_dV_S_B=0.0;
  double s2=0.0;
     double d_s2_dV_G_S=0.0;
     double d_s2_dV_D_S=0.0;
     double d_s2_dV_S_B=0.0;
     double d_s2_dTemp_Tnode_GND=0.0;
  double deltaxinf=0.0;
     double d_deltaxinf_dTemp_Tnode_GND=0.0;
     double d_deltaxinf_dV_G_S=0.0;
     double d_deltaxinf_dV_D_S=0.0;
     double d_deltaxinf_dV_S_B=0.0;
  double q1chapinf=0.0;
     double d_q1chapinf_dV_G_S=0.0;
     double d_q1chapinf_dV_D_S=0.0;
     double d_q1chapinf_dTemp_Tnode_GND=0.0;
     double d_q1chapinf_dV_S_B=0.0;
  double q2chapinf=0.0;
     double d_q2chapinf_dV_G_S=0.0;
     double d_q2chapinf_dV_D_S=0.0;
     double d_q2chapinf_dTemp_Tnode_GND=0.0;
     double d_q2chapinf_dV_S_B=0.0;
  double dinf=0.0;
     double d_dinf_dV_G_S=0.0;
     double d_dinf_dV_D_S=0.0;
     double d_dinf_dTemp_Tnode_GND=0.0;
     double d_dinf_dV_S_B=0.0;
  double inv_dinf=0.0;
     double d_inv_dinf_dV_G_S=0.0;
     double d_inv_dinf_dV_D_S=0.0;
     double d_inv_dinf_dTemp_Tnode_GND=0.0;
     double d_inv_dinf_dV_S_B=0.0;
  double wsat1=0.0;
     double d_wsat1_dV_S_B=0.0;
     double d_wsat1_dV_G_S=0.0;
     double d_wsat1_dV_D_S=0.0;
     double d_wsat1_dTemp_Tnode_GND=0.0;
  double sat_fact1=0.0;
     double d_sat_fact1_dV_S_B=0.0;
     double d_sat_fact1_dV_G_S=0.0;
     double d_sat_fact1_dV_D_S=0.0;
     double d_sat_fact1_dTemp_Tnode_GND=0.0;
  double wsat2=0.0;
     double d_wsat2_dV_G_S=0.0;
     double d_wsat2_dTemp_Tnode_GND=0.0;
     double d_wsat2_dV_D_S=0.0;
     double d_wsat2_dV_S_B=0.0;
  double sat_fact2=0.0;
     double d_sat_fact2_dV_G_S=0.0;
     double d_sat_fact2_dTemp_Tnode_GND=0.0;
     double d_sat_fact2_dV_D_S=0.0;
     double d_sat_fact2_dV_S_B=0.0;
  double dqis_dxn_qi=0.0;
     double d_dqis_dxn_qi_dV_G_S=0.0;
     double d_dqis_dxn_qi_dV_D_S=0.0;
     double d_dqis_dxn_qi_dTemp_Tnode_GND=0.0;
     double d_dqis_dxn_qi_dV_S_B=0.0;
  double deltaxi=0.0;
     double d_deltaxi_dTemp_Tnode_GND=0.0;
     double d_deltaxi_dV_G_S=0.0;
     double d_deltaxi_dV_D_S=0.0;
     double d_deltaxi_dV_S_B=0.0;
  double gamma=0.0;
     double d_gamma_dTemp_Tnode_GND=0.0;
     double d_gamma_dV_G_S=0.0;
     double d_gamma_dV_D_S=0.0;
     double d_gamma_dV_S_B=0.0;
  double vs=0.0;
     double d_vs_dTemp_Tnode_GND=0.0;
     double d_vs_dV_G_S=0.0;
     double d_vs_dV_D_S=0.0;
     double d_vs_dV_S_B=0.0;
  double vd=0.0;
     double d_vd_dTemp_Tnode_GND=0.0;
     double d_vd_dV_G_S=0.0;
     double d_vd_dV_D_S=0.0;
     double d_vd_dV_S_B=0.0;
  double wd=0.0;
     double d_wd_dV_G_S=0.0;
     double d_wd_dV_D_S=0.0;
     double d_wd_dTemp_Tnode_GND=0.0;
     double d_wd_dV_S_B=0.0;
  double ps_cub=0.0;
     double d_ps_cub_dTemp_Tnode_GND=0.0;
     double d_ps_cub_dV_G_S=0.0;
     double d_ps_cub_dV_D_S=0.0;
     double d_ps_cub_dV_S_B=0.0;
  double qs_cub=0.0;
     double d_qs_cub_dTemp_Tnode_GND=0.0;
     double d_qs_cub_dV_G_S=0.0;
     double d_qs_cub_dV_D_S=0.0;
     double d_qs_cub_dV_S_B=0.0;
  double pd_cub=0.0;
     double d_pd_cub_dTemp_Tnode_GND=0.0;
     double d_pd_cub_dV_G_S=0.0;
     double d_pd_cub_dV_D_S=0.0;
     double d_pd_cub_dV_S_B=0.0;
  double qd_cub=0.0;
     double d_qd_cub_dTemp_Tnode_GND=0.0;
     double d_qd_cub_dV_G_S=0.0;
     double d_qd_cub_dV_D_S=0.0;
     double d_qd_cub_dV_S_B=0.0;
  double racs=0.0;
     double d_racs_dTemp_Tnode_GND=0.0;
     double d_racs_dV_G_S=0.0;
     double d_racs_dV_D_S=0.0;
     double d_racs_dV_S_B=0.0;
  double racd=0.0;
     double d_racd_dTemp_Tnode_GND=0.0;
     double d_racd_dV_G_S=0.0;
     double d_racd_dV_D_S=0.0;
     double d_racd_dV_S_B=0.0;
  double deltaxsats=0.0;
     double d_deltaxsats_dTemp_Tnode_GND=0.0;
     double d_deltaxsats_dV_G_S=0.0;
     double d_deltaxsats_dV_D_S=0.0;
     double d_deltaxsats_dV_S_B=0.0;
  double deltaxsatd=0.0;
     double d_deltaxsatd_dTemp_Tnode_GND=0.0;
     double d_deltaxsatd_dV_G_S=0.0;
     double d_deltaxsatd_dV_D_S=0.0;
     double d_deltaxsatd_dV_S_B=0.0;
  double deltaxsat=0.0;
     double d_deltaxsat_dTemp_Tnode_GND=0.0;
     double d_deltaxsat_dV_G_S=0.0;
     double d_deltaxsat_dV_D_S=0.0;
     double d_deltaxsat_dV_S_B=0.0;
  double qidsats=0.0;
     double d_qidsats_dTemp_Tnode_GND=0.0;
     double d_qidsats_dV_G_S=0.0;
     double d_qidsats_dV_D_S=0.0;
     double d_qidsats_dV_S_B=0.0;
  double qidsatd=0.0;
     double d_qidsatd_dV_G_S=0.0;
     double d_qidsatd_dV_D_S=0.0;
     double d_qidsatd_dTemp_Tnode_GND=0.0;
     double d_qidsatd_dV_S_B=0.0;
  double qidsat=0.0;
     double d_qidsat_dTemp_Tnode_GND=0.0;
     double d_qidsat_dV_G_S=0.0;
     double d_qidsat_dV_D_S=0.0;
     double d_qidsat_dV_S_B=0.0;
  double xndssat=0.0;
     double d_xndssat_dV_S_B=0.0;
     double d_xndssat_dV_G_S=0.0;
     double d_xndssat_dV_D_S=0.0;
     double d_xndssat_dTemp_Tnode_GND=0.0;
  double q1d=0.0;
     double d_q1d_dTemp_Tnode_GND=0.0;
     double d_q1d_dV_G_S=0.0;
     double d_q1d_dV_D_S=0.0;
     double d_q1d_dV_S_B=0.0;
  double q2d=0.0;
     double d_q2d_dV_G_S=0.0;
     double d_q2d_dV_D_S=0.0;
     double d_q2d_dTemp_Tnode_GND=0.0;
     double d_q2d_dV_S_B=0.0;
  double k1q1d=0.0;
     double d_k1q1d_dV_G_S=0.0;
     double d_k1q1d_dV_D_S=0.0;
     double d_k1q1d_dTemp_Tnode_GND=0.0;
     double d_k1q1d_dV_S_B=0.0;
  double Aexp1d=0.0;
     double d_Aexp1d_dTemp_Tnode_GND=0.0;
     double d_Aexp1d_dV_G_S=0.0;
     double d_Aexp1d_dV_D_S=0.0;
     double d_Aexp1d_dV_S_B=0.0;
  double qsqd=0.0;
     double d_qsqd_dV_G_S=0.0;
     double d_qsqd_dV_D_S=0.0;
     double d_qsqd_dTemp_Tnode_GND=0.0;
     double d_qsqd_dV_S_B=0.0;
  double k2q2d=0.0;
     double d_k2q2d_dV_G_S=0.0;
     double d_k2q2d_dV_D_S=0.0;
     double d_k2q2d_dTemp_Tnode_GND=0.0;
     double d_k2q2d_dV_S_B=0.0;
  double Aexp2d=0.0;
     double d_Aexp2d_dTemp_Tnode_GND=0.0;
     double d_Aexp2d_dV_G_S=0.0;
     double d_Aexp2d_dV_D_S=0.0;
     double d_Aexp2d_dV_S_B=0.0;
  double a1d=0.0;
     double d_a1d_dTemp_Tnode_GND=0.0;
     double d_a1d_dV_G_S=0.0;
     double d_a1d_dV_D_S=0.0;
     double d_a1d_dV_S_B=0.0;
  double a2d=0.0;
     double d_a2d_dTemp_Tnode_GND=0.0;
     double d_a2d_dV_G_S=0.0;
     double d_a2d_dV_D_S=0.0;
     double d_a2d_dV_S_B=0.0;
  double b1d=0.0;
     double d_b1d_dTemp_Tnode_GND=0.0;
     double d_b1d_dV_G_S=0.0;
     double d_b1d_dV_D_S=0.0;
     double d_b1d_dV_S_B=0.0;
  double b2d=0.0;
     double d_b2d_dTemp_Tnode_GND=0.0;
     double d_b2d_dV_G_S=0.0;
     double d_b2d_dV_D_S=0.0;
     double d_b2d_dV_S_B=0.0;
  double sumd=0.0;
     double d_sumd_dTemp_Tnode_GND=0.0;
     double d_sumd_dV_G_S=0.0;
     double d_sumd_dV_D_S=0.0;
     double d_sumd_dV_S_B=0.0;
  double dqsqd_dxn_qi=0.0;
     double d_dqsqd_dxn_qi_dV_G_S=0.0;
     double d_dqsqd_dxn_qi_dV_D_S=0.0;
     double d_dqsqd_dxn_qi_dTemp_Tnode_GND=0.0;
     double d_dqsqd_dxn_qi_dV_S_B=0.0;
  double xdriftd=0.0;
     double d_xdriftd_dV_D_S=0.0;
     double d_xdriftd_dTemp_Tnode_GND=0.0;
     double d_xdriftd_dV_G_S=0.0;
     double d_xdriftd_dV_S_B=0.0;
  double dxdrift=0.0;
     double d_dxdrift_dV_D_S=0.0;
     double d_dxdrift_dTemp_Tnode_GND=0.0;
     double d_dxdrift_dV_G_S=0.0;
     double d_dxdrift_dV_S_B=0.0;
  double esurf1d=0.0;
     double d_esurf1d_dV_S_B=0.0;
     double d_esurf1d_dV_G_S=0.0;
     double d_esurf1d_dV_D_S=0.0;
     double d_esurf1d_dTemp_Tnode_GND=0.0;
  double esurf2d=0.0;
     double d_esurf2d_dV_G_S=0.0;
     double d_esurf2d_dTemp_Tnode_GND=0.0;
     double d_esurf2d_dV_D_S=0.0;
     double d_esurf2d_dV_S_B=0.0;
  double ecpl1d=0.0;
     double d_ecpl1d_dV_G_S=0.0;
     double d_ecpl1d_dTemp_Tnode_GND=0.0;
     double d_ecpl1d_dV_D_S=0.0;
     double d_ecpl1d_dV_S_B=0.0;
  double ecpl2d=0.0;
     double d_ecpl2d_dV_S_B=0.0;
     double d_ecpl2d_dV_G_S=0.0;
     double d_ecpl2d_dV_D_S=0.0;
     double d_ecpl2d_dTemp_Tnode_GND=0.0;
  double eeff1d=0.0;
     double d_eeff1d_dV_S_B=0.0;
     double d_eeff1d_dV_G_S=0.0;
     double d_eeff1d_dV_D_S=0.0;
     double d_eeff1d_dTemp_Tnode_GND=0.0;
  double eeff2d=0.0;
     double d_eeff2d_dV_G_S=0.0;
     double d_eeff2d_dTemp_Tnode_GND=0.0;
     double d_eeff2d_dV_D_S=0.0;
     double d_eeff2d_dV_S_B=0.0;
  double qi1m=0.0;
     double d_qi1m_dTemp_Tnode_GND=0.0;
     double d_qi1m_dV_G_S=0.0;
     double d_qi1m_dV_D_S=0.0;
     double d_qi1m_dV_S_B=0.0;
  double qi2m=0.0;
     double d_qi2m_dTemp_Tnode_GND=0.0;
     double d_qi2m_dV_G_S=0.0;
     double d_qi2m_dV_D_S=0.0;
     double d_qi2m_dV_S_B=0.0;
  double ecpl1=0.0;
     double d_ecpl1_dV_G_S=0.0;
     double d_ecpl1_dTemp_Tnode_GND=0.0;
     double d_ecpl1_dV_D_S=0.0;
     double d_ecpl1_dV_S_B=0.0;
  double ecpl2=0.0;
     double d_ecpl2_dV_S_B=0.0;
     double d_ecpl2_dV_G_S=0.0;
     double d_ecpl2_dV_D_S=0.0;
     double d_ecpl2_dTemp_Tnode_GND=0.0;
  double eeff1=0.0;
     double d_eeff1_dV_S_B=0.0;
     double d_eeff1_dV_G_S=0.0;
     double d_eeff1_dV_D_S=0.0;
     double d_eeff1_dTemp_Tnode_GND=0.0;
  double eeff2=0.0;
     double d_eeff2_dV_G_S=0.0;
     double d_eeff2_dTemp_Tnode_GND=0.0;
     double d_eeff2_dV_D_S=0.0;
     double d_eeff2_dV_S_B=0.0;
  double c1=0.0;
     double d_c1_dV_S_B=0.0;
     double d_c1_dV_G_S=0.0;
     double d_c1_dV_D_S=0.0;
     double d_c1_dTemp_Tnode_GND=0.0;
  double c2=0.0;
     double d_c2_dV_G_S=0.0;
     double d_c2_dTemp_Tnode_GND=0.0;
     double d_c2_dV_D_S=0.0;
     double d_c2_dV_S_B=0.0;
  double csum=0.0;
     double d_csum_dV_S_B=0.0;
     double d_csum_dV_G_S=0.0;
     double d_csum_dV_D_S=0.0;
     double d_csum_dTemp_Tnode_GND=0.0;
  double fcor=0.0;
     double d_fcor_dV_G_S=0.0;
     double d_fcor_dTemp_Tnode_GND=0.0;
     double d_fcor_dV_D_S=0.0;
     double d_fcor_dV_S_B=0.0;
  double Gcs=0.0;
     double d_Gcs_dTemp_Tnode_GND=0.0;
     double d_Gcs_dV_G_S=0.0;
     double d_Gcs_dV_D_S=0.0;
     double d_Gcs_dV_S_B=0.0;
  double Grs=0.0;
     double d_Grs_dTemp_Tnode_GND=0.0;
     double d_Grs_dV_G_S=0.0;
     double d_Grs_dV_D_S=0.0;
     double d_Grs_dV_S_B=0.0;
  double Gmob1=0.0;
     double d_Gmob1_dTemp_Tnode_GND=0.0;
     double d_Gmob1_dV_S_B=0.0;
     double d_Gmob1_dV_G_S=0.0;
     double d_Gmob1_dV_D_S=0.0;
  double Gmob2=0.0;
     double d_Gmob2_dTemp_Tnode_GND=0.0;
     double d_Gmob2_dV_G_S=0.0;
     double d_Gmob2_dV_D_S=0.0;
     double d_Gmob2_dV_S_B=0.0;
  double inv_qimstar1=0.0;
     double d_inv_qimstar1_dTemp_Tnode_GND=0.0;
     double d_inv_qimstar1_dV_G_S=0.0;
     double d_inv_qimstar1_dV_D_S=0.0;
     double d_inv_qimstar1_dV_S_B=0.0;
  double r1=0.0;
     double d_r1_dTemp_Tnode_GND=0.0;
     double d_r1_dV_G_S=0.0;
     double d_r1_dV_D_S=0.0;
     double d_r1_dV_S_B=0.0;
  double dL_L=0.0;
     double d_dL_L_dV_S_B=0.0;
     double d_dL_L_dV_G_S=0.0;
     double d_dL_L_dV_D_S=0.0;
     double d_dL_L_dTemp_Tnode_GND=0.0;
  double GdL=0.0;
     double d_GdL_dV_S_B=0.0;
     double d_GdL_dV_G_S=0.0;
     double d_GdL_dV_D_S=0.0;
     double d_GdL_dTemp_Tnode_GND=0.0;
  double dL1_L=0.0;
     double d_dL1_L_dTemp_Tnode_GND=0.0;
     double d_dL1_L_dV_G_S=0.0;
     double d_dL1_L_dV_D_S=0.0;
     double d_dL1_L_dV_S_B=0.0;
  double sqrt_zsat=0.0;
     double d_sqrt_zsat_dTemp_Tnode_GND=0.0;
     double d_sqrt_zsat_dV_D_S=0.0;
     double d_sqrt_zsat_dV_G_S=0.0;
     double d_sqrt_zsat_dV_S_B=0.0;
  double vsat_fact=0.0;
     double d_vsat_fact_dTemp_Tnode_GND=0.0;
     double d_vsat_fact_dV_D_S=0.0;
     double d_vsat_fact_dV_G_S=0.0;
     double d_vsat_fact_dV_S_B=0.0;
  double qmfact2=0.0;
     double d_qmfact2_dV_G_S=0.0;
     double d_qmfact2_dV_D_S=0.0;
     double d_qmfact2_dTemp_Tnode_GND=0.0;
     double d_qmfact2_dV_S_B=0.0;
  double dqid_dxn_qi=0.0;
     double d_dqid_dxn_qi_dV_G_S=0.0;
     double d_dqid_dxn_qi_dV_D_S=0.0;
     double d_dqid_dxn_qi_dTemp_Tnode_GND=0.0;
     double d_dqid_dxn_qi_dV_S_B=0.0;
  double Ls=0.0;
     double d_Ls_dV_G_S=0.0;
     double d_Ls_dV_D_S=0.0;
     double d_Ls_dTemp_Tnode_GND=0.0;
     double d_Ls_dV_S_B=0.0;
  double Ld=0.0;
     double d_Ld_dV_G_S=0.0;
     double d_Ld_dV_D_S=0.0;
     double d_Ld_dTemp_Tnode_GND=0.0;
     double d_Ld_dV_S_B=0.0;
  double Us=0.0;
     double d_Us_dV_G_S=0.0;
     double d_Us_dV_D_S=0.0;
     double d_Us_dTemp_Tnode_GND=0.0;
     double d_Us_dV_S_B=0.0;
  double Ud=0.0;
     double d_Ud_dV_G_S=0.0;
     double d_Ud_dV_D_S=0.0;
     double d_Ud_dTemp_Tnode_GND=0.0;
     double d_Ud_dV_S_B=0.0;
  double idrift2=0.0;
     double d_idrift2_dV_S_B=0.0;
     double d_idrift2_dV_G_S=0.0;
     double d_idrift2_dV_D_S=0.0;
     double d_idrift2_dTemp_Tnode_GND=0.0;
  double norm_Ids=0.0;
     double d_norm_Ids_dTemp_Tnode_GND=0.0;
     double d_norm_Ids_dV_G_S=0.0;
     double d_norm_Ids_dV_D_S=0.0;
     double d_norm_Ids_dV_S_B=0.0;
  double zeta1=0.0;
     double d_zeta1_dV_G_S=0.0;
     double d_zeta1_dV_D_S=0.0;
     double d_zeta1_dTemp_Tnode_GND=0.0;
     double d_zeta1_dV_S_B=0.0;
  double zeta2=0.0;
     double d_zeta2_dV_G_S=0.0;
     double d_zeta2_dV_D_S=0.0;
     double d_zeta2_dV_S_B=0.0;
     double d_zeta2_dTemp_Tnode_GND=0.0;
  double ksi1=0.0;
     double d_ksi1_dV_G_S=0.0;
     double d_ksi1_dTemp_Tnode_GND=0.0;
     double d_ksi1_dV_D_S=0.0;
     double d_ksi1_dV_S_B=0.0;
  double ksi2=0.0;
     double d_ksi2_dV_S_B=0.0;
     double d_ksi2_dV_G_S=0.0;
     double d_ksi2_dV_D_S=0.0;
     double d_ksi2_dTemp_Tnode_GND=0.0;
  double q1s_chap=0.0;
     double d_q1s_chap_dTemp_Tnode_GND=0.0;
     double d_q1s_chap_dV_G_S=0.0;
     double d_q1s_chap_dV_D_S=0.0;
     double d_q1s_chap_dV_S_B=0.0;
  double q1d_chap=0.0;
     double d_q1d_chap_dTemp_Tnode_GND=0.0;
     double d_q1d_chap_dV_G_S=0.0;
     double d_q1d_chap_dV_D_S=0.0;
     double d_q1d_chap_dV_S_B=0.0;
  double q2s_chap=0.0;
     double d_q2s_chap_dTemp_Tnode_GND=0.0;
     double d_q2s_chap_dV_G_S=0.0;
     double d_q2s_chap_dV_D_S=0.0;
     double d_q2s_chap_dV_S_B=0.0;
  double q2d_chap=0.0;
     double d_q2d_chap_dTemp_Tnode_GND=0.0;
     double d_q2d_chap_dV_G_S=0.0;
     double d_q2d_chap_dV_D_S=0.0;
     double d_q2d_chap_dV_S_B=0.0;
  double inv_k2h2_0=0.0;
     double d_inv_k2h2_0_dTemp_Tnode_GND=0.0;
     double d_inv_k2h2_0_dV_G_S=0.0;
     double d_inv_k2h2_0_dV_D_S=0.0;
     double d_inv_k2h2_0_dV_S_B=0.0;
  double inv_k1h1=0.0;
     double d_inv_k1h1_dTemp_Tnode_GND=0.0;
     double d_inv_k1h1_dV_G_S=0.0;
     double d_inv_k1h1_dV_D_S=0.0;
     double d_inv_k1h1_dV_S_B=0.0;
  double inv_k2h2=0.0;
     double d_inv_k2h2_dTemp_Tnode_GND=0.0;
     double d_inv_k2h2_dV_G_S=0.0;
     double d_inv_k2h2_dV_D_S=0.0;
     double d_inv_k2h2_dV_S_B=0.0;
  double delta_k2q2=0.0;
     double d_delta_k2q2_dV_G_S=0.0;
     double d_delta_k2q2_dV_D_S=0.0;
     double d_delta_k2q2_dTemp_Tnode_GND=0.0;
     double d_delta_k2q2_dV_S_B=0.0;
  double prod1=0.0;
     double d_prod1_dV_G_S=0.0;
     double d_prod1_dV_D_S=0.0;
     double d_prod1_dTemp_Tnode_GND=0.0;
     double d_prod1_dV_S_B=0.0;
  double prod2=0.0;
     double d_prod2_dV_G_S=0.0;
     double d_prod2_dV_D_S=0.0;
     double d_prod2_dTemp_Tnode_GND=0.0;
     double d_prod2_dV_S_B=0.0;
  double xs_ov=0.0;
     double d_xs_ov_dV_G_S=0.0;
     double d_xs_ov_dTemp_Tnode_GND=0.0;
  double xd_ov=0.0;
     double d_xd_ov_dV_G_S=0.0;
     double d_xd_ov_dV_D_S=0.0;
     double d_xd_ov_dTemp_Tnode_GND=0.0;
  double xs_ovcv=0.0;
     double d_xs_ovcv_dV_G_S=0.0;
     double d_xs_ovcv_dTemp_Tnode_GND=0.0;
  double xd_ovcv=0.0;
     double d_xd_ovcv_dV_G_S=0.0;
     double d_xd_ovcv_dV_D_S=0.0;
     double d_xd_ovcv_dTemp_Tnode_GND=0.0;
  double GOV=0.0;
     double d_GOV_dTemp_Tnode_GND=0.0;
  double GOV2=0.0;
     double d_GOV2_dTemp_Tnode_GND=0.0;
  double xi_ov=0.0;
     double d_xi_ov_dTemp_Tnode_GND=0.0;
  double x_mrg_ov=0.0;
     double d_x_mrg_ov_dTemp_Tnode_GND=0.0;
  double inv_xi_ov=0.0;
     double d_inv_xi_ov_dTemp_Tnode_GND=0.0;
  double inv_xg1=0.0;
     double d_inv_xg1_dTemp_Tnode_GND=0.0;
  double SP_OV_Afac=0.0;
     double d_SP_OV_Afac_dTemp_Tnode_GND=0.0;
  double SP_OV_xbar=0.0;
     double d_SP_OV_xbar_dV_D_S=0.0;
     double d_SP_OV_xbar_dV_G_S=0.0;
     double d_SP_OV_xbar_dTemp_Tnode_GND=0.0;
  double SP_OV_x0=0.0;
     double d_SP_OV_x0_dV_D_S=0.0;
     double d_SP_OV_x0_dV_G_S=0.0;
     double d_SP_OV_x0_dTemp_Tnode_GND=0.0;
  double SP_OV_u=0.0;
     double d_SP_OV_u_dV_D_S=0.0;
     double d_SP_OV_u_dV_G_S=0.0;
     double d_SP_OV_u_dTemp_Tnode_GND=0.0;
  double SP_OV_ygf=0.0;
     double d_SP_OV_ygf_dV_D_S=0.0;
     double d_SP_OV_ygf_dV_G_S=0.0;
     double d_SP_OV_ygf_dTemp_Tnode_GND=0.0;
  double SP_OV_z=0.0;
     double d_SP_OV_z_dV_D_S=0.0;
     double d_SP_OV_z_dV_G_S=0.0;
     double d_SP_OV_z_dTemp_Tnode_GND=0.0;
  double SP_OV_eta=0.0;
     double d_SP_OV_eta_dV_D_S=0.0;
     double d_SP_OV_eta_dV_G_S=0.0;
     double d_SP_OV_eta_dTemp_Tnode_GND=0.0;
  double SP_OV_a=0.0;
     double d_SP_OV_a_dV_D_S=0.0;
     double d_SP_OV_a_dV_G_S=0.0;
     double d_SP_OV_a_dTemp_Tnode_GND=0.0;
  double SP_OV_c=0.0;
     double d_SP_OV_c_dV_D_S=0.0;
     double d_SP_OV_c_dV_G_S=0.0;
     double d_SP_OV_c_dTemp_Tnode_GND=0.0;
  double SP_OV_tau=0.0;
     double d_SP_OV_tau_dV_D_S=0.0;
     double d_SP_OV_tau_dV_G_S=0.0;
     double d_SP_OV_tau_dTemp_Tnode_GND=0.0;
  double SP_OV_nu=0.0;
     double d_SP_OV_nu_dV_D_S=0.0;
     double d_SP_OV_nu_dV_G_S=0.0;
     double d_SP_OV_nu_dTemp_Tnode_GND=0.0;
  double SP_OV_mutau=0.0;
     double d_SP_OV_mutau_dV_D_S=0.0;
     double d_SP_OV_mutau_dV_G_S=0.0;
     double d_SP_OV_mutau_dTemp_Tnode_GND=0.0;
  double SP_OV_temp=0.0;
     double d_SP_OV_temp_dV_D_S=0.0;
     double d_SP_OV_temp_dV_G_S=0.0;
     double d_SP_OV_temp_dTemp_Tnode_GND=0.0;
  double SP_OV_y0=0.0;
     double d_SP_OV_y0_dV_D_S=0.0;
     double d_SP_OV_y0_dV_G_S=0.0;
     double d_SP_OV_y0_dTemp_Tnode_GND=0.0;
  double SP_OV_D0=0.0;
     double d_SP_OV_D0_dV_D_S=0.0;
     double d_SP_OV_D0_dV_G_S=0.0;
     double d_SP_OV_D0_dTemp_Tnode_GND=0.0;
  double SP_OV_p=0.0;
     double d_SP_OV_p_dV_D_S=0.0;
     double d_SP_OV_p_dV_G_S=0.0;
     double d_SP_OV_p_dTemp_Tnode_GND=0.0;
  double SP_OV_q=0.0;
     double d_SP_OV_q_dV_D_S=0.0;
     double d_SP_OV_q_dV_G_S=0.0;
     double d_SP_OV_q_dTemp_Tnode_GND=0.0;
  double SP_OV_xi=0.0;
     double d_SP_OV_xi_dV_D_S=0.0;
     double d_SP_OV_xi_dTemp_Tnode_GND=0.0;
     double d_SP_OV_xi_dV_G_S=0.0;
  double SP_OV_w=0.0;
     double d_SP_OV_w_dV_D_S=0.0;
     double d_SP_OV_w_dV_G_S=0.0;
     double d_SP_OV_w_dTemp_Tnode_GND=0.0;
  double Vovs=0.0;
     double d_Vovs_dTemp_Tnode_GND=0.0;
     double d_Vovs_dV_G_S=0.0;
  double Vovd=0.0;
     double d_Vovd_dTemp_Tnode_GND=0.0;
     double d_Vovd_dV_G_S=0.0;
     double d_Vovd_dV_D_S=0.0;
  double Vovscv=0.0;
     double d_Vovscv_dTemp_Tnode_GND=0.0;
     double d_Vovscv_dV_G_S=0.0;
  double Vovdcv=0.0;
     double d_Vovdcv_dTemp_Tnode_GND=0.0;
     double d_Vovdcv_dV_G_S=0.0;
     double d_Vovdcv_dV_D_S=0.0;
  double Igsov=0.0;
     double d_Igsov_dTemp_Tnode_GND=0.0;
     double d_Igsov_dV_S_B=0.0;
     double d_Igsov_dV_G_S=0.0;
     double d_Igsov_dV_D_S=0.0;
  double Igdov=0.0;
     double d_Igdov_dTemp_Tnode_GND=0.0;
     double d_Igdov_dV_S_B=0.0;
     double d_Igdov_dV_G_S=0.0;
     double d_Igdov_dV_D_S=0.0;
  double Igc=0.0;
     double d_Igc_dTemp_Tnode_GND=0.0;
     double d_Igc_dV_G_S=0.0;
     double d_Igc_dV_D_S=0.0;
     double d_Igc_dV_S_B=0.0;
  double Igs=0.0;
     double d_Igs_dTemp_Tnode_GND=0.0;
     double d_Igs_dV_G_S=0.0;
     double d_Igs_dV_D_S=0.0;
     double d_Igs_dV_S_B=0.0;
  double Igd=0.0;
     double d_Igd_dTemp_Tnode_GND=0.0;
     double d_Igd_dV_G_S=0.0;
     double d_Igd_dV_D_S=0.0;
     double d_Igd_dV_S_B=0.0;
  double Igcs=0.0;
     double d_Igcs_dTemp_Tnode_GND=0.0;
     double d_Igcs_dV_G_S=0.0;
     double d_Igcs_dV_D_S=0.0;
     double d_Igcs_dV_S_B=0.0;
  double Igcd=0.0;
     double d_Igcd_dTemp_Tnode_GND=0.0;
     double d_Igcd_dV_G_S=0.0;
     double d_Igcd_dV_D_S=0.0;
     double d_Igcd_dV_S_B=0.0;
  double arg2mina=0.0;
     double d_arg2mina_dV_S_B=0.0;
     double d_arg2mina_dV_D_S=0.0;
     double d_arg2mina_dTemp_Tnode_GND=0.0;
     double d_arg2mina_dV_G_S=0.0;
  double psi_t=0.0;
     double d_psi_t_dV_S_B=0.0;
     double d_psi_t_dV_D_S=0.0;
     double d_psi_t_dTemp_Tnode_GND=0.0;
     double d_psi_t_dV_G_S=0.0;
  double zg=0.0;
     double d_zg_dV_S_B=0.0;
     double d_zg_dV_D_S=0.0;
     double d_zg_dTemp_Tnode_GND=0.0;
     double d_zg_dV_G_S=0.0;
  double gc2oveff=0.0;
     double d_gc2oveff_dV_S_B=0.0;
     double d_gc2oveff_dV_G_S=0.0;
     double d_gc2oveff_dV_D_S=0.0;
     double d_gc2oveff_dTemp_Tnode_GND=0.0;
  double gc3oveff=0.0;
     double d_gc3oveff_dV_S_B=0.0;
     double d_gc3oveff_dV_G_S=0.0;
     double d_gc3oveff_dV_D_S=0.0;
     double d_gc3oveff_dTemp_Tnode_GND=0.0;
  double gcqoveff=0.0;
     double d_gcqoveff_dV_S_B=0.0;
     double d_gcqoveff_dV_G_S=0.0;
     double d_gcqoveff_dV_D_S=0.0;
     double d_gcqoveff_dTemp_Tnode_GND=0.0;
  double igoveff=0.0;
     double d_igoveff_dTemp_Tnode_GND=0.0;
     double d_igoveff_dV_S_B=0.0;
     double d_igoveff_dV_G_S=0.0;
     double d_igoveff_dV_D_S=0.0;
  double igovefffowler=0.0;
     double d_igovefffowler_dTemp_Tnode_GND=0.0;
     double d_igovefffowler_dV_G_S=0.0;
     double d_igovefffowler_dV_D_S=0.0;
     double d_igovefffowler_dV_S_B=0.0;
  double arg1=0.0;
     double d_arg1_dV_S_B=0.0;
     double d_arg1_dV_D_S=0.0;
     double d_arg1_dV_G_S=0.0;
     double d_arg1_dTemp_Tnode_GND=0.0;
  double Dsi=0.0;
     double d_Dsi_dV_S_B=0.0;
     double d_Dsi_dV_D_S=0.0;
     double d_Dsi_dV_G_S=0.0;
     double d_Dsi_dTemp_Tnode_GND=0.0;
  double Dgate=0.0;
     double d_Dgate_dV_S_B=0.0;
     double d_Dgate_dV_D_S=0.0;
     double d_Dgate_dV_G_S=0.0;
     double d_Dgate_dTemp_Tnode_GND=0.0;
  double TP=0.0;
     double d_TP_dV_G_S=0.0;
     double d_TP_dV_D_S=0.0;
     double d_TP_dV_S_B=0.0;
     double d_TP_dTemp_Tnode_GND=0.0;
  double TP2=0.0;
     double d_TP2_dV_S_B=0.0;
     double d_TP2_dV_G_S=0.0;
     double d_TP2_dV_D_S=0.0;
     double d_TP2_dTemp_Tnode_GND=0.0;
  double half_x_ds=0.0;
     double d_half_x_ds_dV_G_S=0.0;
     double d_half_x_ds_dV_D_S=0.0;
     double d_half_x_ds_dTemp_Tnode_GND=0.0;
     double d_half_x_ds_dV_S_B=0.0;
  double Vm=0.0;
     double d_Vm_dTemp_Tnode_GND=0.0;
     double d_Vm_dV_G_S=0.0;
     double d_Vm_dV_D_S=0.0;
     double d_Vm_dV_S_B=0.0;
  double q1m=0.0;
     double d_q1m_dTemp_Tnode_GND=0.0;
     double d_q1m_dV_G_S=0.0;
     double d_q1m_dV_D_S=0.0;
     double d_q1m_dV_S_B=0.0;
  double Voxm=0.0;
     double d_Voxm_dTemp_Tnode_GND=0.0;
     double d_Voxm_dV_G_S=0.0;
     double d_Voxm_dV_D_S=0.0;
     double d_Voxm_dV_S_B=0.0;
  double x_m=0.0;
     double d_x_m_dTemp_Tnode_GND=0.0;
     double d_x_m_dV_G_S=0.0;
     double d_x_m_dV_D_S=0.0;
     double d_x_m_dV_S_B=0.0;
  double Igc0=0.0;
     double d_Igc0_dTemp_Tnode_GND=0.0;
     double d_Igc0_dV_G_S=0.0;
     double d_Igc0_dV_D_S=0.0;
     double d_Igc0_dV_S_B=0.0;
  double u0=0.0;
     double d_u0_dV_G_S=0.0;
     double d_u0_dV_D_S=0.0;
     double d_u0_dV_S_B=0.0;
     double d_u0_dTemp_Tnode_GND=0.0;
  double x=0.0;
     double d_x_dV_G_S=0.0;
     double d_x_dV_D_S=0.0;
     double d_x_dTemp_Tnode_GND=0.0;
     double d_x_dV_S_B=0.0;
  double u0_div_H=0.0;
     double d_u0_div_H_dV_G_S=0.0;
     double d_u0_div_H_dV_D_S=0.0;
     double d_u0_div_H_dV_S_B=0.0;
     double d_u0_div_H_dTemp_Tnode_GND=0.0;
  double Bg=0.0;
     double d_Bg_dV_G_S=0.0;
     double d_Bg_dV_D_S=0.0;
     double d_Bg_dV_S_B=0.0;
     double d_Bg_dTemp_Tnode_GND=0.0;
  double Ag=0.0;
     double d_Ag_dV_G_S=0.0;
     double d_Ag_dV_D_S=0.0;
     double d_Ag_dV_S_B=0.0;
     double d_Ag_dTemp_Tnode_GND=0.0;
  double inv_x=0.0;
     double d_inv_x_dV_G_S=0.0;
     double d_inv_x_dV_D_S=0.0;
     double d_inv_x_dTemp_Tnode_GND=0.0;
     double d_inv_x_dV_S_B=0.0;
  double ex=0.0;
     double d_ex_dV_G_S=0.0;
     double d_ex_dV_D_S=0.0;
     double d_ex_dTemp_Tnode_GND=0.0;
     double d_ex_dV_S_B=0.0;
  double inv_ex=0.0;
     double d_inv_ex_dV_G_S=0.0;
     double d_inv_ex_dV_D_S=0.0;
     double d_inv_ex_dTemp_Tnode_GND=0.0;
     double d_inv_ex_dV_S_B=0.0;
  double xsq=0.0;
     double d_xsq_dV_G_S=0.0;
     double d_xsq_dV_D_S=0.0;
     double d_xsq_dTemp_Tnode_GND=0.0;
     double d_xsq_dV_S_B=0.0;
  double igc=0.0;
     double d_igc_dV_G_S=0.0;
     double d_igc_dV_D_S=0.0;
     double d_igc_dTemp_Tnode_GND=0.0;
     double d_igc_dV_S_B=0.0;
  double igcd_h=0.0;
     double d_igcd_h_dV_G_S=0.0;
     double d_igcd_h_dV_D_S=0.0;
     double d_igcd_h_dTemp_Tnode_GND=0.0;
     double d_igcd_h_dV_S_B=0.0;
  double Igisl=0.0;
     double d_Igisl_dV_D_S=0.0;
     double d_Igisl_dTemp_Tnode_GND=0.0;
     double d_Igisl_dV_G_S=0.0;
     double d_Igisl_dV_S_B=0.0;
  double Vtovs=0.0;
     double d_Vtovs_dTemp_Tnode_GND=0.0;
     double d_Vtovs_dV_G_S=0.0;
     double d_Vtovs_dV_S_B=0.0;
  double Igidl=0.0;
     double d_Igidl_dV_D_S=0.0;
     double d_Igidl_dTemp_Tnode_GND=0.0;
     double d_Igidl_dV_G_S=0.0;
     double d_Igidl_dV_S_B=0.0;
  double Vtovd=0.0;
     double d_Vtovd_dTemp_Tnode_GND=0.0;
     double d_Vtovd_dV_G_S=0.0;
     double d_Vtovd_dV_D_S=0.0;
     double d_Vtovd_dV_S_B=0.0;
  double delVsat=0.0;
     double d_delVsat_dV_D_S=0.0;
     double d_delVsat_dTemp_Tnode_GND=0.0;
     double d_delVsat_dV_G_S=0.0;
     double d_delVsat_dV_S_B=0.0;
  double Ithpwr=0.0;
     double d_Ithpwr_dV_G_S=0.0;
     double d_Ithpwr_dV_D_S=0.0;
     double d_Ithpwr_dV_S_B=0.0;
     double d_Ithpwr_dTemp_Tnode_GND=0.0;
  double Ithrc=0.0;
     double d_Ithrc_dTemp_Tnode_GND=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (10))
  {
    probeVars.resize(10);
    d_probeVars.resize(10);
    for (int i=0;i<10;i++)
    {
      d_probeVars[i].resize(10);
      for (int j=0;j<10;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(6+1);
    d_staticContributions.resize(6+1);
    for (int i=0;i<6+1;i++)
      d_staticContributions[i].resize(10);
    dynamicContributions.resize(6+1);
    d_dynamicContributions.resize(6+1);
    for (int i=0;i<6+1;i++)
      d_dynamicContributions[i].resize(10);
  }

    noiseContribsPower.resize(6);
    noiseContribsExponent.resize(6);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 6+1 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<10;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<10;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_D_GND] = (*solVectorPtr)[li_D];
d_probeVars[admsProbeID_V_D_GND][admsProbeID_V_D_GND] = 1.0;
probeVars[admsProbeID_V_S_GND] = (*solVectorPtr)[li_S];
d_probeVars[admsProbeID_V_S_GND][admsProbeID_V_S_GND] = 1.0;
probeVars[admsProbeID_V_B_GND] = (*solVectorPtr)[li_B];
d_probeVars[admsProbeID_V_B_GND][admsProbeID_V_B_GND] = 1.0;
probeVars[admsProbeID_V_G_GND] = (*solVectorPtr)[li_G];
d_probeVars[admsProbeID_V_G_GND][admsProbeID_V_G_GND] = 1.0;
probeVars[admsProbeID_I_NSIG_GND] = (*solVectorPtr)[li_BRA_NSIG_GND];
d_probeVars[admsProbeID_I_NSIG_GND][admsProbeID_I_NSIG_GND] = 1.0;
probeVars[admsProbeID_V_NSIG_GND] = (*solVectorPtr)[li_NSIG];
d_probeVars[admsProbeID_V_NSIG_GND][admsProbeID_V_NSIG_GND] = 1.0;
probeVars[admsProbeID_Temp_Tnode_GND] = (*solVectorPtr)[li_Tnode];
d_probeVars[admsProbeID_Temp_Tnode_GND][admsProbeID_Temp_Tnode_GND] = 1.0;
probeVars[admsProbeID_V_S_B] = (*solVectorPtr)[li_S] - (*solVectorPtr)[li_B];
d_probeVars[admsProbeID_V_S_B][admsProbeID_V_S_B] = 1.0;
probeVars[admsProbeID_V_D_S] = (*solVectorPtr)[li_D] - (*solVectorPtr)[li_S];
d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S] = 1.0;
probeVars[admsProbeID_V_G_S] = (*solVectorPtr)[li_G] - (*solVectorPtr)[li_S];
d_probeVars[admsProbeID_V_G_S][admsProbeID_V_G_S] = 1.0;
// -- code converted from analog/code block
//Begin block evaluateStatic
{
if (((model_.TYPE)==(+1)))
{

d_Vgsu_dV_G_S = d_probeVars[admsProbeID_V_G_S][admsProbeID_V_G_S];
Vgsu = (probeVars[admsProbeID_V_G_S]);

d_Vdsu_dV_D_S = d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S];
Vdsu = (probeVars[admsProbeID_V_D_S]);

d_Vsbu_dV_S_B = d_probeVars[admsProbeID_V_S_B][admsProbeID_V_S_B];
Vsbu = (probeVars[admsProbeID_V_S_B]);
}
else
{

d_Vgsu_dV_G_S = (-d_probeVars[admsProbeID_V_G_S][admsProbeID_V_G_S]);
Vgsu = (-(probeVars[admsProbeID_V_G_S]));

d_Vdsu_dV_D_S = (-d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S]);
Vdsu = (-(probeVars[admsProbeID_V_D_S]));

d_Vsbu_dV_S_B = (-d_probeVars[admsProbeID_V_S_B][admsProbeID_V_S_B]);
Vsbu = (-(probeVars[admsProbeID_V_S_B]));
}

d_Vsdu_dV_D_S = (-d_Vdsu_dV_D_S);
Vsdu = (-Vdsu);

d_Vgdu_dV_D_S = d_Vsdu_dV_D_S;
d_Vgdu_dV_G_S = d_Vgsu_dV_G_S;
Vgdu = (Vgsu+Vsdu);

d_Vdbu_dV_S_B = d_Vsbu_dV_S_B;
d_Vdbu_dV_D_S = d_Vdsu_dV_D_S;
Vdbu = (Vdsu+Vsbu);
if ((Vdsu<0.0))
{
sigVds = (-1.0);

d_Vds_dV_D_S = d_Vsdu_dV_D_S;
Vds = Vsdu;

d_Vgs_dV_D_S = d_Vgdu_dV_D_S;
d_Vgs_dV_G_S = d_Vgdu_dV_G_S;
Vgs = Vgdu;

d_Vsb_dV_S_B = d_Vdbu_dV_S_B;
d_Vsb_dV_D_S = d_Vdbu_dV_D_S;
Vsb = Vdbu;
}
else
{
sigVds = 1.0;

d_Vds_dV_D_S = d_Vdsu_dV_D_S;
Vds = Vdsu;

d_Vgs_dV_D_S =  0.0;
d_Vgs_dV_G_S = d_Vgsu_dV_G_S;
Vgs = Vgsu;

d_Vsb_dV_D_S =  0.0;
d_Vsb_dV_S_B = d_Vsbu_dV_S_B;
Vsb = Vsbu;
}

d_Vgb_dV_S_B = d_Vsb_dV_S_B;
d_Vgb_dV_D_S = (d_Vgs_dV_D_S+d_Vsb_dV_D_S);
d_Vgb_dV_G_S = d_Vgs_dV_G_S;
Vgb = (Vgs+Vsb);
if (((model_.SWSHE_i)>0))
{

d_DTC_dTemp_Tnode_GND = d_probeVars[admsProbeID_Temp_Tnode_GND][admsProbeID_Temp_Tnode_GND];
DTC = (probeVars[admsProbeID_Temp_Tnode_GND]);

d_TKC_dTemp_Tnode_GND = d_DTC_dTemp_Tnode_GND;
TKC = ((model_.TKD)+DTC);

d_TKC_sq_dTemp_Tnode_GND = (TKC*d_TKC_dTemp_Tnode_GND+d_TKC_dTemp_Tnode_GND*TKC);
TKC_sq = (TKC*TKC);

d_dT_dTemp_Tnode_GND = d_TKC_dTemp_Tnode_GND;
dT = (TKC-(model_.TKR));

d_rT_dTemp_Tnode_GND = (d_TKC_dTemp_Tnode_GND/(model_.TKR));
rT = (TKC/(model_.TKR));

d_rTn_dTemp_Tnode_GND = (-(model_.TKR)*d_TKC_dTemp_Tnode_GND/TKC/TKC);
rTn = ((model_.TKR)/TKC);

d_phit0_dTemp_Tnode_GND = d_TKC_dTemp_Tnode_GND*8.617332384961E-05;
phit0 = (TKC*8.617332384961E-05);

d_inv_phit0_dTemp_Tnode_GND = (-d_phit0_dTemp_Tnode_GND/phit0/phit0);
inv_phit0 = (1.0/phit0);

d_EgSi_dTemp_Tnode_GND = (-(((636+TKC)*4.730e-4*d_TKC_sq_dTemp_Tnode_GND-(4.730e-4*TKC_sq)*d_TKC_dTemp_Tnode_GND)/(636+TKC)/(636+TKC)));
EgSi = (1.17-((4.730e-4*TKC_sq)/(636+TKC)));

d_EgGe_dTemp_Tnode_GND = (-(((235+TKC)*4.774e-4*d_TKC_sq_dTemp_Tnode_GND-(4.774e-4*TKC_sq)*d_TKC_dTemp_Tnode_GND)/(235+TKC)/(235+TKC)));
EgGe = (0.744-((4.774e-4*TKC_sq)/(235+TKC)));

d_dEg_dTemp_Tnode_GND = (d_EgGe_dTemp_Tnode_GND-d_EgSi_dTemp_Tnode_GND)*XGE_i;
dEg = (((EgGe-EgSi)+((-0.4)*one_m_xge))*XGE_i);

d_Eg_dTemp_Tnode_GND = (d_EgSi_dTemp_Tnode_GND+d_dEg_dTemp_Tnode_GND);
Eg = (EgSi+dEg);

d_Eg_2phit0_dTemp_Tnode_GND = ((0.5*Eg)*d_inv_phit0_dTemp_Tnode_GND+0.5*d_Eg_dTemp_Tnode_GND*inv_phit0);
Eg_2phit0 = ((0.5*Eg)*inv_phit0);

d_dVfbch_dTemp_Tnode_GND = (-0.5*d_dEg_dTemp_Tnode_GND);
dVfbch = ((0.05*XGE_i)-(0.5*dEg));
{
double value_sqrt_0 = sqrt((TKC*0.0033333333333));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(d_TKC_dTemp_Tnode_GND*0.0033333333333));
temp = value_sqrt_0;
}

d_temp1_dV_S_B = d_temp1_dV_G_S = d_temp1_dV_D_S =  0.0;
d_temp1_dTemp_Tnode_GND = (((4.05E25*temp)*temp)*d_temp_dTemp_Tnode_GND+((4.05E25*temp)*d_temp_dTemp_Tnode_GND+4.05E25*d_temp_dTemp_Tnode_GND*temp)*temp);
temp1 = (((4.05E25*temp)*temp)*temp);
{
double value_exp_0 = exp((-Eg_2phit0));
double  deriv_exp_0_d0 = value_exp_0;

d_neff_dTemp_Tnode_GND = ((temp1*niratio)*(deriv_exp_0_d0*((-d_Eg_2phit0_dTemp_Tnode_GND)))+d_temp1_dTemp_Tnode_GND*niratio*value_exp_0);
neff = ((temp1*niratio)*value_exp_0);
}

d_phit_dTemp_Tnode_GND = (phit0*CT_i*d_rTn_dTemp_Tnode_GND+d_phit0_dTemp_Tnode_GND*(1.0+(CT_i*rTn)));
phit = (phit0*(1.0+(CT_i*rTn)));

d_inv_phit_dTemp_Tnode_GND = (-d_phit_dTemp_Tnode_GND/phit/phit);
inv_phit = (1.0/phit);

d_Eg_2phit_dTemp_Tnode_GND = ((0.5*Eg)*d_inv_phit_dTemp_Tnode_GND+0.5*d_Eg_dTemp_Tnode_GND*inv_phit);
Eg_2phit = ((0.5*Eg)*inv_phit);

d_A0_Csisq_dTemp_Tnode_GND = ((((2.0*1.602176565E-19)*neff)*epsch)*d_inv_phit_dTemp_Tnode_GND+(2.0*1.602176565E-19)*d_neff_dTemp_Tnode_GND*epsch*inv_phit);
A0_Csisq = ((((2.0*1.602176565E-19)*neff)*epsch)*inv_phit);
{
double value_log_0 = log(((CsiPrime_0*CsiPrime_0)/A0_Csisq));
double  deriv_log_0_d0 = (1.0/((CsiPrime_0*CsiPrime_0)/A0_Csisq));

d_xth_1D_dTemp_Tnode_GND = (deriv_log_0_d0*((-(CsiPrime_0*CsiPrime_0)*d_A0_Csisq_dTemp_Tnode_GND/A0_Csisq/A0_Csisq)));
xth_1D = (value_log_0-0.6931471805599);
}

d_xSDdep_dTemp_Tnode_GND = ((((0.5*1.602176565E-19)*NSDDC_i)*TSI_i)/(Cox1Prime+Cox2Prime))*d_inv_phit_dTemp_Tnode_GND;
xSDdep = (((((0.5*1.602176565E-19)*NSDDC_i)*TSI_i)/(Cox1Prime+Cox2Prime))*inv_phit);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = STCF_i*d_dT_dTemp_Tnode_GND;
temp = (STCF_i*dT);

d_CF1_i_dTemp_Tnode_GND = d_temp_dTemp_Tnode_GND;
CF1_i = (CF1_t+temp);

d_CF2_i_dTemp_Tnode_GND = d_temp_dTemp_Tnode_GND;
CF2_i = (CF2_t+temp);

d_xd0_dTemp_Tnode_GND = CFD_i*d_inv_phit_dTemp_Tnode_GND;
xd0 = (CFD_i*inv_phit);

d_qq_dTemp_Tnode_GND =  0.0;
qq = 0.0;
if (((model_.QMC)>0.0))
{
if (((model_.TYPE)==(+1)))
{
{
double value_log_0 = log((phit*tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(phit*tsisq));
double  deriv_exp_1_d0 = value_exp_1;

d_qq_dTemp_Tnode_GND = ((0.4*(model_.QMC))*1.27520989)*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_phit_dTemp_Tnode_GND*tsisq))));
qq = (((0.4*(model_.QMC))*1.27520989)*value_exp_1);
}
}
else
{
{
double value_log_0 = log((phit*tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(phit*tsisq));
double  deriv_exp_1_d0 = value_exp_1;

d_qq_dTemp_Tnode_GND = ((0.4*(model_.QMC))*1.54120870)*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_phit_dTemp_Tnode_GND*tsisq))));
qq = (((0.4*(model_.QMC))*1.54120870)*value_exp_1);
}
}
}

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = ((model_.TYPE)*STVFB_i)*d_dT_dTemp_Tnode_GND;
temp = ((((model_.TYPE)*STVFB_i)*dT)+dVfbQM);

d_VFB1_i_dTemp_Tnode_GND = ((model_.TYPE)*d_dVfbch_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND);
VFB1_i = ((((model_.TYPE)*((VFB1_t+dVfbch)+dVfb1Nch))+temp)+DELVTO);

d_VFB2_i_dTemp_Tnode_GND = ((model_.TYPE)*d_dVfbch_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND);
VFB2_i = (((model_.TYPE)*((VFB2_t+dVfbch)+dVfb2Nch))+temp);
{
double value_log_0 = log(rTn);
double  deriv_log_0_d0 = (1.0/rTn);

d_lnrTn_dTemp_Tnode_GND = (deriv_log_0_d0*(d_rTn_dTemp_Tnode_GND));
lnrTn = value_log_0;
}
{
double value_exp_0 = exp((STBET_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_bet_dTemp_Tnode_GND = (deriv_exp_0_d0*(STBET_i*d_lnrTn_dTemp_Tnode_GND))*FACTUO;
tf_bet = (value_exp_0*FACTUO);
}

d_BETN1_i_dTemp_Tnode_GND = BETN1_t*d_tf_bet_dTemp_Tnode_GND;
BETN1_i = (BETN1_t*tf_bet);

d_BETN2_i_dTemp_Tnode_GND = BETN2_t*d_tf_bet_dTemp_Tnode_GND;
BETN2_i = (BETN2_t*tf_bet);
{
double value_exp_0 = exp((STMUE_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_mue_dTemp_Tnode_GND = (deriv_exp_0_d0*(STMUE_i*d_lnrTn_dTemp_Tnode_GND));
tf_mue = value_exp_0;
}

d_MUE_i_dTemp_Tnode_GND = MUE_t*d_tf_mue_dTemp_Tnode_GND;
MUE_i = (MUE_t*tf_mue);
{
double value_exp_0 = exp((STTHEMU_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_themu_dTemp_Tnode_GND = (deriv_exp_0_d0*(STTHEMU_i*d_lnrTn_dTemp_Tnode_GND));
tf_themu = value_exp_0;
}

d_THEMU_i_dTemp_Tnode_GND = THEMU_t*d_tf_themu_dTemp_Tnode_GND;
THEMU_i = (THEMU_t*tf_themu);
{
double value_exp_0 = exp((STCS_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_cs_dTemp_Tnode_GND = (deriv_exp_0_d0*(STCS_i*d_lnrTn_dTemp_Tnode_GND));
tf_cs = value_exp_0;
}

d_CS_i_dTemp_Tnode_GND = CS_t*d_tf_cs_dTemp_Tnode_GND;
CS_i = (CS_t*tf_cs);
{
double value_exp_0 = exp((STTHECS_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_thecs_dTemp_Tnode_GND = (deriv_exp_0_d0*(STTHECS_i*d_lnrTn_dTemp_Tnode_GND));
tf_thecs = value_exp_0;
}

d_THECS_i_dTemp_Tnode_GND = THECS_t*d_tf_thecs_dTemp_Tnode_GND;
THECS_i = (THECS_t*tf_thecs);
{
double value_exp_0 = exp((STXCOR_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_xcor_dTemp_Tnode_GND = (deriv_exp_0_d0*(STXCOR_i*d_lnrTn_dTemp_Tnode_GND));
tf_xcor = value_exp_0;
}

d_XCOR_i_dTemp_Tnode_GND = XCOR_t*d_tf_xcor_dTemp_Tnode_GND;
XCOR_i = (XCOR_t*tf_xcor);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (1.0e-8*d_phit_dTemp_Tnode_GND/TSI_i);
temp = ((1.0e-8*phit)/TSI_i);

d_fmue_dTemp_Tnode_GND = (temp*d_MUE_i_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*MUE_i);
fmue = (temp*MUE_i);
{
double value_exp_0 = exp((STRS_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_ther_dTemp_Tnode_GND = (deriv_exp_0_d0*(STRS_i*d_lnrTn_dTemp_Tnode_GND));
tf_ther = value_exp_0;
}

d_RS_i_dTemp_Tnode_GND = RS_t*d_tf_ther_dTemp_Tnode_GND;
RS_i = (RS_t*tf_ther);

d_frs_dTemp_Tnode_GND = ((2.0*RS_i)*d_phit_dTemp_Tnode_GND+2.0*d_RS_i_dTemp_Tnode_GND*phit);
frs = ((2.0*RS_i)*phit);
{
double value_exp_0 = exp((STTHESAT_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_thesat_dTemp_Tnode_GND = (deriv_exp_0_d0*(STTHESAT_i*d_lnrTn_dTemp_Tnode_GND));
tf_thesat = value_exp_0;
}

d_THESAT_i_dTemp_Tnode_GND = ((THESAT_t*tf_thesat)*d_tf_bet_dTemp_Tnode_GND+THESAT_t*d_tf_thesat_dTemp_Tnode_GND*tf_bet);
THESAT_i = ((THESAT_t*tf_thesat)*tf_bet);

d_sat_phit_dTemp_Tnode_GND = (THESAT_i*d_phit_dTemp_Tnode_GND+d_THESAT_i_dTemp_Tnode_GND*phit);
sat_phit = (THESAT_i*phit);

d_alp1_phit_dTemp_Tnode_GND = ALP1_i*d_inv_phit_dTemp_Tnode_GND;
alp1_phit = (ALP1_i*inv_phit);
{
double value_exp_0 = exp(((-STIG_i)*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_ig_dTemp_Tnode_GND = (deriv_exp_0_d0*((-STIG_i)*d_lnrTn_dTemp_Tnode_GND));
tf_ig = value_exp_0;
}

d_IGINV_i_dTemp_Tnode_GND = IGINV_t*d_tf_ig_dTemp_Tnode_GND;
IGINV_i = (IGINV_t*tf_ig);

d_IGOVINV_i_dTemp_Tnode_GND = IGOVINV_t*d_tf_ig_dTemp_Tnode_GND;
IGOVINV_i = (IGOVINV_t*tf_ig);

d_IGOVINVD_i_dTemp_Tnode_GND = IGOVINVD_t*d_tf_ig_dTemp_Tnode_GND;
IGOVINVD_i = (IGOVINVD_t*tf_ig);

d_IGOVACC_i_dTemp_Tnode_GND = IGOVACC_t*d_tf_ig_dTemp_Tnode_GND;
IGOVACC_i = (IGOVACC_t*tf_ig);

d_IGOVACCD_i_dTemp_Tnode_GND = IGOVACCD_t*d_tf_ig_dTemp_Tnode_GND;
IGOVACCD_i = (IGOVACCD_t*tf_ig);
{
double value_exp_0 = exp(((-STIGFN_i)*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_ig_dTemp_Tnode_GND = (deriv_exp_0_d0*((-STIGFN_i)*d_lnrTn_dTemp_Tnode_GND));
tf_ig = value_exp_0;
}

d_FNOVINV_i_dTemp_Tnode_GND = FNOVINV_t*d_tf_ig_dTemp_Tnode_GND;
FNOVINV_i = (FNOVINV_t*tf_ig);

d_FNOVINVD_i_dTemp_Tnode_GND = FNOVINVD_t*d_tf_ig_dTemp_Tnode_GND;
FNOVINVD_i = (FNOVINVD_t*tf_ig);

d_alpha_b_dTemp_Tnode_GND = 0.5*d_Eg_dTemp_Tnode_GND;
alpha_b = (0.5*Eg);

d_Dch_dTemp_Tnode_GND = GCO_i*d_phit_dTemp_Tnode_GND;
Dch = (GCO_i*phit);

d_Dov_dTemp_Tnode_GND = GCO_i*d_phit0_dTemp_Tnode_GND;
Dov = (GCO_i*phit0);

d_n_iginv_dTemp_Tnode_GND = (-NIGINV_i*d_Eg_2phit_dTemp_Tnode_GND/(1.0+(NIGINV_i*Eg_2phit))/(1.0+(NIGINV_i*Eg_2phit)));
n_iginv = (1.0/(1.0+(NIGINV_i*Eg_2phit)));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (TOXP_i*5.0e8);
{
double value_sqrt_0 = sqrt(((((1.0+(STBGIDL_i*dT)))*((1.0+(STBGIDL_i*dT))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tempM_dTemp_Tnode_GND = 0.5*(STBGIDL_i*d_dT_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((((1.0+(STBGIDL_i*dT)))*STBGIDL_i*d_dT_dTemp_Tnode_GND+STBGIDL_i*d_dT_dTemp_Tnode_GND*((1.0+(STBGIDL_i*dT)))))));
tempM = (0.5*((1.0+(STBGIDL_i*dT))+value_sqrt_0));
}

d_BGIDL_i_dTemp_Tnode_GND = ((BGIDL_t*tempM)*d_temp_dTemp_Tnode_GND+BGIDL_t*d_tempM_dTemp_Tnode_GND*temp);
BGIDL_i = ((BGIDL_t*tempM)*temp);
{
double value_sqrt_0 = sqrt(((((1.0+(STBGIDLD_i*dT)))*((1.0+(STBGIDLD_i*dT))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tempM_dTemp_Tnode_GND = 0.5*(STBGIDLD_i*d_dT_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((((1.0+(STBGIDLD_i*dT)))*STBGIDLD_i*d_dT_dTemp_Tnode_GND+STBGIDLD_i*d_dT_dTemp_Tnode_GND*((1.0+(STBGIDLD_i*dT)))))));
tempM = (0.5*((1.0+(STBGIDLD_i*dT))+value_sqrt_0));
}

d_BGIDLD_i_dTemp_Tnode_GND = ((BGIDLD_t*tempM)*d_temp_dTemp_Tnode_GND+BGIDLD_t*d_tempM_dTemp_Tnode_GND*temp);
BGIDLD_i = ((BGIDLD_t*tempM)*temp);
{
double value_exp_0 = exp(((-STA2_i)*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_A2_i_dTemp_Tnode_GND = A2_t*(deriv_exp_0_d0*((-STA2_i)*d_lnrTn_dTemp_Tnode_GND));
A2_i = (A2_t*value_exp_0);
}

d_area_phit_dTemp_Tnode_GND = AREAQ_i*d_phit_dTemp_Tnode_GND;
area_phit = (AREAQ_i*phit);

d_inner_sd_dTemp_Tnode_GND = (-((0.25*1.602176565E-19)*NSDAC_i)*epsch*d_phit_dTemp_Tnode_GND/(epsch*phit)/(epsch*phit));
inner_sd = (((0.25*1.602176565E-19)*NSDAC_i)/(epsch*phit));
{
double value_log_0 = log((NSDAC_i/neff));
double  deriv_log_0_d0 = (1.0/(NSDAC_i/neff));

d_xsd_dTemp_Tnode_GND = (deriv_log_0_d0*((-NSDAC_i*d_neff_dTemp_Tnode_GND/neff/neff)));
xsd = value_log_0;
}

d_fif_phit_dTemp_Tnode_GND = (FIF_i*1.25e-6)*d_phit_dTemp_Tnode_GND;
fif_phit = ((FIF_i*1.25e-6)*phit);
{
double value_exp_0 = exp((STRTH_i*lnrTn));
double  deriv_exp_0_d0 = value_exp_0;

d_tf_rth_dTemp_Tnode_GND = (deriv_exp_0_d0*(STRTH_i*d_lnrTn_dTemp_Tnode_GND));
tf_rth = value_exp_0;
}

d_RTH_i_dTemp_Tnode_GND = RTH_t*d_tf_rth_dTemp_Tnode_GND;
RTH_i = (RTH_t*tf_rth);

d_nt_dTemp_Tnode_GND = ((FNT_i*4.0)*1.3806488E-23)*d_TKC_dTemp_Tnode_GND;
nt = (((FNT_i*4.0)*1.3806488E-23)*TKC);
}

d_xd_dTemp_Tnode_GND = Vds*d_inv_phit_dTemp_Tnode_GND;
d_xd_dV_D_S = d_Vds_dV_D_S*inv_phit;
xd = (Vds*inv_phit);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xdsx_dTemp_Tnode_GND = (value_sqrt_0-0.1)*d_inv_phit_dTemp_Tnode_GND;
d_xdsx_dV_D_S = (deriv_sqrt_0_d0*((Vds*d_Vds_dV_D_S+d_Vds_dV_D_S*Vds)))*inv_phit;
xdsx = ((value_sqrt_0-0.1)*inv_phit);
}

d_dxdsx_dTemp_Tnode_GND = 0.5*(d_xd_dTemp_Tnode_GND-d_xdsx_dTemp_Tnode_GND);
d_dxdsx_dV_D_S = 0.5*(d_xd_dV_D_S-d_xdsx_dV_D_S);
dxdsx = (0.5*(xd-xdsx));

d_xg10_dTemp_Tnode_GND = (((Vgs-VFB1_i)*d_inv_phit_dTemp_Tnode_GND+(-d_VFB1_i_dTemp_Tnode_GND)*inv_phit)-d_dxdsx_dTemp_Tnode_GND);
d_xg10_dV_D_S = (d_Vgs_dV_D_S*inv_phit-d_dxdsx_dV_D_S);
d_xg10_dV_G_S = d_Vgs_dV_G_S*inv_phit;
xg10 = (((Vgs-VFB1_i)*inv_phit)-dxdsx);

d_xg20_dTemp_Tnode_GND = ((((-Vsb)-VFB2_i)*d_inv_phit_dTemp_Tnode_GND+(-d_VFB2_i_dTemp_Tnode_GND)*inv_phit)-d_dxdsx_dTemp_Tnode_GND);
d_xg20_dV_S_B = (-d_Vsb_dV_S_B)*inv_phit;
d_xg20_dV_D_S = ((-d_Vsb_dV_D_S)*inv_phit-d_dxdsx_dV_D_S);
xg20 = ((((-Vsb)-VFB2_i)*inv_phit)-dxdsx);

d_xgs_ov_dTemp_Tnode_GND = (-Vgsu)*d_inv_phit0_dTemp_Tnode_GND;
d_xgs_ov_dV_G_S = (-d_Vgsu_dV_G_S)*inv_phit0;
xgs_ov = ((-Vgsu)*inv_phit0);

d_xgd_ov_dTemp_Tnode_GND = (-Vgdu)*d_inv_phit0_dTemp_Tnode_GND;
d_xgd_ov_dV_D_S = (-d_Vgdu_dV_D_S)*inv_phit0;
d_xgd_ov_dV_G_S = (-d_Vgdu_dV_G_S)*inv_phit0;
xgd_ov = ((-Vgdu)*inv_phit0);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (((model_.TYPE)*DVFBOV_i)*d_inv_phit0_dTemp_Tnode_GND+d_Eg_2phit0_dTemp_Tnode_GND);
temp = ((((model_.TYPE)*DVFBOV_i)*inv_phit0)+Eg_2phit0);

d_xgs_ovcv_dTemp_Tnode_GND = (d_xgs_ov_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND);
d_xgs_ovcv_dV_G_S = (d_xgs_ov_dV_G_S+d_temp_dV_G_S);
xgs_ovcv = (xgs_ov+temp);

d_xgd_ovcv_dTemp_Tnode_GND = (d_xgd_ov_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND);
d_xgd_ovcv_dV_D_S = (d_xgd_ov_dV_D_S+d_temp_dV_D_S);
d_xgd_ovcv_dV_G_S = (d_xgd_ov_dV_G_S+d_temp_dV_G_S);
xgd_ovcv = (xgd_ov+temp);
if (((model_.SWSUBDEP)>0))
{

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = ((model_.TYPE)*TYPESUB_i);

d_temp1_dV_S_B =  0.0;
d_temp1_dV_D_S = (temp*d_xg10_dV_D_S+d_temp_dV_D_S*xg10);
d_temp1_dV_G_S = (temp*d_xg10_dV_G_S+d_temp_dV_G_S*xg10);
d_temp1_dTemp_Tnode_GND = (temp*d_xg10_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*xg10);
temp1 = (temp*xg10);

d_temp2_dV_G_S =  0.0;
d_temp2_dV_S_B = (temp*d_xg20_dV_S_B+d_temp_dV_S_B*xg20);
d_temp2_dV_D_S = (temp*d_xg20_dV_D_S+d_temp_dV_D_S*xg20);
d_temp2_dTemp_Tnode_GND = (temp*d_xg20_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*xg20);
temp2 = (temp*xg20);

d_SPSUB_xgb_dV_S_B = (d_temp1_dV_S_B-d_temp2_dV_S_B);
d_SPSUB_xgb_dTemp_Tnode_GND = (d_temp1_dTemp_Tnode_GND-d_temp2_dTemp_Tnode_GND);
d_SPSUB_xgb_dV_D_S = (d_temp1_dV_D_S-d_temp2_dV_D_S);
d_SPSUB_xgb_dV_G_S = (d_temp1_dV_G_S-d_temp2_dV_G_S);
SPSUB_xgb = (temp1-temp2);
if ((fabs((-xn_sub))<80.0))
{
{
double value_exp_0 = exp((-xn_sub));
SPSUB_delta = value_exp_0;
}
}
else
{
if (((-xn_sub)<(-80.0)))
{
SPSUB_delta = (1.80485e-35/(1.0+(((-(-xn_sub))-80.0)*(1.0+((0.5*((-(-xn_sub))-80.0))*(1.0+(((-(-xn_sub))-80.0)*0.3333333333333)))))));
}
else
{
SPSUB_delta = (5.54062e34*(1.0+(((-xn_sub)-80.0)*(1.0+((0.5*((-xn_sub)-80.0))*(1.0+(((-xn_sub)-80.0)*0.3333333333333)))))));
}
}
if ((fabs(SPSUB_xgb)<=margin_sub))
{

d_SPSUB_temp1_dV_G_S = d_SPSUB_temp1_dV_D_S = d_SPSUB_temp1_dTemp_Tnode_GND = d_SPSUB_temp1_dV_S_B =  0.0;
SPSUB_temp1 = (((inv_xisub*inv_xisub)*0.1666666666667)/1.4142135623731);

d_temp3_dV_S_B = ((SPSUB_xgb*inv_xisub)*(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*d_SPSUB_temp1_dV_S_B+d_SPSUB_xgb_dV_S_B*(1.0-SPSUB_delta)*Gfsub*SPSUB_temp1)+d_SPSUB_xgb_dV_S_B*inv_xisub*(1.0+(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*SPSUB_temp1)));
d_temp3_dTemp_Tnode_GND = ((SPSUB_xgb*inv_xisub)*(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*d_SPSUB_temp1_dTemp_Tnode_GND+d_SPSUB_xgb_dTemp_Tnode_GND*(1.0-SPSUB_delta)*Gfsub*SPSUB_temp1)+d_SPSUB_xgb_dTemp_Tnode_GND*inv_xisub*(1.0+(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*SPSUB_temp1)));
d_temp3_dV_D_S = ((SPSUB_xgb*inv_xisub)*(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*d_SPSUB_temp1_dV_D_S+d_SPSUB_xgb_dV_D_S*(1.0-SPSUB_delta)*Gfsub*SPSUB_temp1)+d_SPSUB_xgb_dV_D_S*inv_xisub*(1.0+(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*SPSUB_temp1)));
d_temp3_dV_G_S = ((SPSUB_xgb*inv_xisub)*(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*d_SPSUB_temp1_dV_G_S+d_SPSUB_xgb_dV_G_S*(1.0-SPSUB_delta)*Gfsub*SPSUB_temp1)+d_SPSUB_xgb_dV_G_S*inv_xisub*(1.0+(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*SPSUB_temp1)));
temp3 = ((SPSUB_xgb*inv_xisub)*(1.0+(((SPSUB_xgb*(1.0-SPSUB_delta))*Gfsub)*SPSUB_temp1)));
}
else
{
if ((SPSUB_xgb<(-margin_sub)))
{

d_SPSUB_yg_dV_S_B = (-d_SPSUB_xgb_dV_S_B);
d_SPSUB_yg_dTemp_Tnode_GND = (-d_SPSUB_xgb_dTemp_Tnode_GND);
d_SPSUB_yg_dV_D_S = (-d_SPSUB_xgb_dV_D_S);
d_SPSUB_yg_dV_G_S = (-d_SPSUB_xgb_dV_G_S);
SPSUB_yg = (-SPSUB_xgb);

d_SPSUB_ysub_dV_S_B = 1.25*d_SPSUB_yg_dV_S_B*inv_xisub;
d_SPSUB_ysub_dTemp_Tnode_GND = 1.25*d_SPSUB_yg_dTemp_Tnode_GND*inv_xisub;
d_SPSUB_ysub_dV_D_S = 1.25*d_SPSUB_yg_dV_D_S*inv_xisub;
d_SPSUB_ysub_dV_G_S = 1.25*d_SPSUB_yg_dV_G_S*inv_xisub;
SPSUB_ysub = (1.25*(SPSUB_yg*inv_xisub));
{
double value_sqrt_0 = sqrt((((SPSUB_ysub-6.0)*(SPSUB_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SPSUB_eta_dV_S_B = 0.5*(d_SPSUB_ysub_dV_S_B-(deriv_sqrt_0_d0*(((SPSUB_ysub-6.0)*d_SPSUB_ysub_dV_S_B+d_SPSUB_ysub_dV_S_B*(SPSUB_ysub-6.0)))));
d_SPSUB_eta_dTemp_Tnode_GND = 0.5*(d_SPSUB_ysub_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((SPSUB_ysub-6.0)*d_SPSUB_ysub_dTemp_Tnode_GND+d_SPSUB_ysub_dTemp_Tnode_GND*(SPSUB_ysub-6.0)))));
d_SPSUB_eta_dV_D_S = 0.5*(d_SPSUB_ysub_dV_D_S-(deriv_sqrt_0_d0*(((SPSUB_ysub-6.0)*d_SPSUB_ysub_dV_D_S+d_SPSUB_ysub_dV_D_S*(SPSUB_ysub-6.0)))));
d_SPSUB_eta_dV_G_S = 0.5*(d_SPSUB_ysub_dV_G_S-(deriv_sqrt_0_d0*(((SPSUB_ysub-6.0)*d_SPSUB_ysub_dV_G_S+d_SPSUB_ysub_dV_G_S*(SPSUB_ysub-6.0)))));
SPSUB_eta = (0.5*((SPSUB_ysub+10.0)-value_sqrt_0));
}

d_SPSUB_temp_dV_S_B = (d_SPSUB_yg_dV_S_B-d_SPSUB_eta_dV_S_B);
d_SPSUB_temp_dTemp_Tnode_GND = (d_SPSUB_yg_dTemp_Tnode_GND-d_SPSUB_eta_dTemp_Tnode_GND);
d_SPSUB_temp_dV_D_S = (d_SPSUB_yg_dV_D_S-d_SPSUB_eta_dV_D_S);
d_SPSUB_temp_dV_G_S = (d_SPSUB_yg_dV_G_S-d_SPSUB_eta_dV_G_S);
SPSUB_temp = (SPSUB_yg-SPSUB_eta);

d_SPSUB_a_dV_S_B = ((SPSUB_temp*d_SPSUB_temp_dV_S_B+d_SPSUB_temp_dV_S_B*SPSUB_temp)+Gfsub2*d_SPSUB_eta_dV_S_B);
d_SPSUB_a_dTemp_Tnode_GND = ((SPSUB_temp*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_temp_dTemp_Tnode_GND*SPSUB_temp)+Gfsub2*d_SPSUB_eta_dTemp_Tnode_GND);
d_SPSUB_a_dV_D_S = ((SPSUB_temp*d_SPSUB_temp_dV_D_S+d_SPSUB_temp_dV_D_S*SPSUB_temp)+Gfsub2*d_SPSUB_eta_dV_D_S);
d_SPSUB_a_dV_G_S = ((SPSUB_temp*d_SPSUB_temp_dV_G_S+d_SPSUB_temp_dV_G_S*SPSUB_temp)+Gfsub2*d_SPSUB_eta_dV_G_S);
SPSUB_a = ((SPSUB_temp*SPSUB_temp)+(Gfsub2*(SPSUB_eta+1.0)));

d_SPSUB_c_dV_S_B = 2.0*d_SPSUB_temp_dV_S_B;
d_SPSUB_c_dTemp_Tnode_GND = 2.0*d_SPSUB_temp_dTemp_Tnode_GND;
d_SPSUB_c_dV_D_S = 2.0*d_SPSUB_temp_dV_D_S;
d_SPSUB_c_dV_G_S = 2.0*d_SPSUB_temp_dV_G_S;
SPSUB_c = ((2.0*SPSUB_temp)-Gfsub2);
{
double value_log_0 = log((SPSUB_a*inv_Gfsub2));
double  deriv_log_0_d0 = (1.0/(SPSUB_a*inv_Gfsub2));

d_SPSUB_tau_dV_S_B = ((-d_SPSUB_eta_dV_S_B)+(deriv_log_0_d0*(d_SPSUB_a_dV_S_B*inv_Gfsub2)));
d_SPSUB_tau_dTemp_Tnode_GND = ((-d_SPSUB_eta_dTemp_Tnode_GND)+(deriv_log_0_d0*(d_SPSUB_a_dTemp_Tnode_GND*inv_Gfsub2)));
d_SPSUB_tau_dV_D_S = ((-d_SPSUB_eta_dV_D_S)+(deriv_log_0_d0*(d_SPSUB_a_dV_D_S*inv_Gfsub2)));
d_SPSUB_tau_dV_G_S = ((-d_SPSUB_eta_dV_G_S)+(deriv_log_0_d0*(d_SPSUB_a_dV_G_S*inv_Gfsub2)));
SPSUB_tau = ((-SPSUB_eta)+value_log_0);
}

d_nu_dV_S_B = (d_SPSUB_a_dV_S_B+d_SPSUB_c_dV_S_B);
d_nu_dTemp_Tnode_GND = (d_SPSUB_a_dTemp_Tnode_GND+d_SPSUB_c_dTemp_Tnode_GND);
d_nu_dV_D_S = (d_SPSUB_a_dV_D_S+d_SPSUB_c_dV_D_S);
d_nu_dV_G_S = (d_SPSUB_a_dV_G_S+d_SPSUB_c_dV_G_S);
nu = (SPSUB_a+SPSUB_c);

d_mutau_dV_S_B = ((nu*d_nu_dV_S_B+d_nu_dV_S_B*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dV_S_B+0.5*d_SPSUB_c_dV_S_B*SPSUB_c)-d_SPSUB_a_dV_S_B)+d_SPSUB_tau_dV_S_B*(((0.5*SPSUB_c)*SPSUB_c)-SPSUB_a)));
d_mutau_dTemp_Tnode_GND = ((nu*d_nu_dTemp_Tnode_GND+d_nu_dTemp_Tnode_GND*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dTemp_Tnode_GND+0.5*d_SPSUB_c_dTemp_Tnode_GND*SPSUB_c)-d_SPSUB_a_dTemp_Tnode_GND)+d_SPSUB_tau_dTemp_Tnode_GND*(((0.5*SPSUB_c)*SPSUB_c)-SPSUB_a)));
d_mutau_dV_D_S = ((nu*d_nu_dV_D_S+d_nu_dV_D_S*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dV_D_S+0.5*d_SPSUB_c_dV_D_S*SPSUB_c)-d_SPSUB_a_dV_D_S)+d_SPSUB_tau_dV_D_S*(((0.5*SPSUB_c)*SPSUB_c)-SPSUB_a)));
d_mutau_dV_G_S = ((nu*d_nu_dV_G_S+d_nu_dV_G_S*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dV_G_S+0.5*d_SPSUB_c_dV_G_S*SPSUB_c)-d_SPSUB_a_dV_G_S)+d_SPSUB_tau_dV_G_S*(((0.5*SPSUB_c)*SPSUB_c)-SPSUB_a)));
mutau = ((nu*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*SPSUB_c)-SPSUB_a)));

d_SPSUB_y0_dV_S_B = (d_SPSUB_eta_dV_S_B+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))*((SPSUB_a*nu)*d_SPSUB_tau_dV_S_B+(SPSUB_a*d_nu_dV_S_B+d_SPSUB_a_dV_S_B*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dV_S_B+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dV_S_B+d_SPSUB_c_dV_S_B*SPSUB_c)*0.3333333333333-d_SPSUB_a_dV_S_B)+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dV_S_B+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dV_S_B+((nu/mutau)*d_SPSUB_tau_dV_S_B+((mutau*d_nu_dV_S_B-nu*d_mutau_dV_S_B)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))));
d_SPSUB_y0_dTemp_Tnode_GND = (d_SPSUB_eta_dTemp_Tnode_GND+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))*((SPSUB_a*nu)*d_SPSUB_tau_dTemp_Tnode_GND+(SPSUB_a*d_nu_dTemp_Tnode_GND+d_SPSUB_a_dTemp_Tnode_GND*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dTemp_Tnode_GND+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dTemp_Tnode_GND+d_SPSUB_c_dTemp_Tnode_GND*SPSUB_c)*0.3333333333333-d_SPSUB_a_dTemp_Tnode_GND)+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dTemp_Tnode_GND+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dTemp_Tnode_GND+((nu/mutau)*d_SPSUB_tau_dTemp_Tnode_GND+((mutau*d_nu_dTemp_Tnode_GND-nu*d_mutau_dTemp_Tnode_GND)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))));
d_SPSUB_y0_dV_D_S = (d_SPSUB_eta_dV_D_S+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))*((SPSUB_a*nu)*d_SPSUB_tau_dV_D_S+(SPSUB_a*d_nu_dV_D_S+d_SPSUB_a_dV_D_S*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dV_D_S+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dV_D_S+d_SPSUB_c_dV_D_S*SPSUB_c)*0.3333333333333-d_SPSUB_a_dV_D_S)+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dV_D_S+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dV_D_S+((nu/mutau)*d_SPSUB_tau_dV_D_S+((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))));
d_SPSUB_y0_dV_G_S = (d_SPSUB_eta_dV_G_S+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))*((SPSUB_a*nu)*d_SPSUB_tau_dV_G_S+(SPSUB_a*d_nu_dV_G_S+d_SPSUB_a_dV_G_S*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dV_G_S+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dV_G_S+d_SPSUB_c_dV_G_S*SPSUB_c)*0.3333333333333-d_SPSUB_a_dV_G_S)+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dV_G_S+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dV_G_S+((nu/mutau)*d_SPSUB_tau_dV_G_S+((mutau*d_nu_dV_G_S-nu*d_mutau_dV_G_S)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))));
SPSUB_y0 = (SPSUB_eta+(((SPSUB_a*nu)*SPSUB_tau)/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))));
if ((SPSUB_y0<80.0))
{
{
double value_exp_0 = exp(SPSUB_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SPSUB_delta0_dV_S_B = (deriv_exp_0_d0*(d_SPSUB_y0_dV_S_B));
d_SPSUB_delta0_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_SPSUB_y0_dTemp_Tnode_GND));
d_SPSUB_delta0_dV_D_S = (deriv_exp_0_d0*(d_SPSUB_y0_dV_D_S));
d_SPSUB_delta0_dV_G_S = (deriv_exp_0_d0*(d_SPSUB_y0_dV_G_S));
SPSUB_delta0 = value_exp_0;
}
}
else
{

d_SPSUB_delta0_dV_S_B = 5.54062e34*((SPSUB_y0-80.0)*((0.5*(SPSUB_y0-80.0))*d_SPSUB_y0_dV_S_B*0.3333333333333+0.5*d_SPSUB_y0_dV_S_B*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))+d_SPSUB_y0_dV_S_B*(1.0+((0.5*(SPSUB_y0-80.0))*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))));
d_SPSUB_delta0_dTemp_Tnode_GND = 5.54062e34*((SPSUB_y0-80.0)*((0.5*(SPSUB_y0-80.0))*d_SPSUB_y0_dTemp_Tnode_GND*0.3333333333333+0.5*d_SPSUB_y0_dTemp_Tnode_GND*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))+d_SPSUB_y0_dTemp_Tnode_GND*(1.0+((0.5*(SPSUB_y0-80.0))*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))));
d_SPSUB_delta0_dV_D_S = 5.54062e34*((SPSUB_y0-80.0)*((0.5*(SPSUB_y0-80.0))*d_SPSUB_y0_dV_D_S*0.3333333333333+0.5*d_SPSUB_y0_dV_D_S*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))+d_SPSUB_y0_dV_D_S*(1.0+((0.5*(SPSUB_y0-80.0))*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))));
d_SPSUB_delta0_dV_G_S = 5.54062e34*((SPSUB_y0-80.0)*((0.5*(SPSUB_y0-80.0))*d_SPSUB_y0_dV_G_S*0.3333333333333+0.5*d_SPSUB_y0_dV_G_S*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))+d_SPSUB_y0_dV_G_S*(1.0+((0.5*(SPSUB_y0-80.0))*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))));
SPSUB_delta0 = (5.54062e34*(1.0+((SPSUB_y0-80.0)*(1.0+((0.5*(SPSUB_y0-80.0))*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))))));
}

d_SPSUB_delta1_dV_S_B = (-d_SPSUB_delta0_dV_S_B/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dTemp_Tnode_GND = (-d_SPSUB_delta0_dTemp_Tnode_GND/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dV_D_S = (-d_SPSUB_delta0_dV_D_S/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dV_G_S = (-d_SPSUB_delta0_dV_G_S/SPSUB_delta0/SPSUB_delta0);
SPSUB_delta1 = (1.0/SPSUB_delta0);

d_SPSUB_temp_dV_S_B = (-(SPSUB_y0*d_SPSUB_y0_dV_S_B+d_SPSUB_y0_dV_S_B*SPSUB_y0)/(2.0+(SPSUB_y0*SPSUB_y0))/(2.0+(SPSUB_y0*SPSUB_y0)));
d_SPSUB_temp_dTemp_Tnode_GND = (-(SPSUB_y0*d_SPSUB_y0_dTemp_Tnode_GND+d_SPSUB_y0_dTemp_Tnode_GND*SPSUB_y0)/(2.0+(SPSUB_y0*SPSUB_y0))/(2.0+(SPSUB_y0*SPSUB_y0)));
d_SPSUB_temp_dV_D_S = (-(SPSUB_y0*d_SPSUB_y0_dV_D_S+d_SPSUB_y0_dV_D_S*SPSUB_y0)/(2.0+(SPSUB_y0*SPSUB_y0))/(2.0+(SPSUB_y0*SPSUB_y0)));
d_SPSUB_temp_dV_G_S = (-(SPSUB_y0*d_SPSUB_y0_dV_G_S+d_SPSUB_y0_dV_G_S*SPSUB_y0)/(2.0+(SPSUB_y0*SPSUB_y0))/(2.0+(SPSUB_y0*SPSUB_y0)));
SPSUB_temp = (1.0/(2.0+(SPSUB_y0*SPSUB_y0)));

d_SPSUB_xi0_dV_S_B = ((SPSUB_y0*SPSUB_y0)*d_SPSUB_temp_dV_S_B+(SPSUB_y0*d_SPSUB_y0_dV_S_B+d_SPSUB_y0_dV_S_B*SPSUB_y0)*SPSUB_temp);
d_SPSUB_xi0_dTemp_Tnode_GND = ((SPSUB_y0*SPSUB_y0)*d_SPSUB_temp_dTemp_Tnode_GND+(SPSUB_y0*d_SPSUB_y0_dTemp_Tnode_GND+d_SPSUB_y0_dTemp_Tnode_GND*SPSUB_y0)*SPSUB_temp);
d_SPSUB_xi0_dV_D_S = ((SPSUB_y0*SPSUB_y0)*d_SPSUB_temp_dV_D_S+(SPSUB_y0*d_SPSUB_y0_dV_D_S+d_SPSUB_y0_dV_D_S*SPSUB_y0)*SPSUB_temp);
d_SPSUB_xi0_dV_G_S = ((SPSUB_y0*SPSUB_y0)*d_SPSUB_temp_dV_G_S+(SPSUB_y0*d_SPSUB_y0_dV_G_S+d_SPSUB_y0_dV_G_S*SPSUB_y0)*SPSUB_temp);
SPSUB_xi0 = ((SPSUB_y0*SPSUB_y0)*SPSUB_temp);

d_SPSUB_xi1_dV_S_B = 4.0*((SPSUB_y0*SPSUB_temp)*d_SPSUB_temp_dV_S_B+(SPSUB_y0*d_SPSUB_temp_dV_S_B+d_SPSUB_y0_dV_S_B*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi1_dTemp_Tnode_GND = 4.0*((SPSUB_y0*SPSUB_temp)*d_SPSUB_temp_dTemp_Tnode_GND+(SPSUB_y0*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_y0_dTemp_Tnode_GND*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi1_dV_D_S = 4.0*((SPSUB_y0*SPSUB_temp)*d_SPSUB_temp_dV_D_S+(SPSUB_y0*d_SPSUB_temp_dV_D_S+d_SPSUB_y0_dV_D_S*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi1_dV_G_S = 4.0*((SPSUB_y0*SPSUB_temp)*d_SPSUB_temp_dV_G_S+(SPSUB_y0*d_SPSUB_temp_dV_G_S+d_SPSUB_y0_dV_G_S*SPSUB_temp)*SPSUB_temp);
SPSUB_xi1 = (4.0*((SPSUB_y0*SPSUB_temp)*SPSUB_temp));

d_SPSUB_xi2_dV_S_B = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dV_S_B+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dV_S_B+(8.0*d_SPSUB_temp_dV_S_B-12.0*d_SPSUB_xi0_dV_S_B)*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi2_dTemp_Tnode_GND = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dTemp_Tnode_GND+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dTemp_Tnode_GND+(8.0*d_SPSUB_temp_dTemp_Tnode_GND-12.0*d_SPSUB_xi0_dTemp_Tnode_GND)*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi2_dV_D_S = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dV_D_S+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dV_D_S+(8.0*d_SPSUB_temp_dV_D_S-12.0*d_SPSUB_xi0_dV_D_S)*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi2_dV_G_S = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dV_G_S+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dV_G_S+(8.0*d_SPSUB_temp_dV_G_S-12.0*d_SPSUB_xi0_dV_G_S)*SPSUB_temp)*SPSUB_temp);
SPSUB_xi2 = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*SPSUB_temp);

d_SPSUB_temp_dV_S_B = (d_SPSUB_yg_dV_S_B-d_SPSUB_y0_dV_S_B);
d_SPSUB_temp_dTemp_Tnode_GND = (d_SPSUB_yg_dTemp_Tnode_GND-d_SPSUB_y0_dTemp_Tnode_GND);
d_SPSUB_temp_dV_D_S = (d_SPSUB_yg_dV_D_S-d_SPSUB_y0_dV_D_S);
d_SPSUB_temp_dV_G_S = (d_SPSUB_yg_dV_G_S-d_SPSUB_y0_dV_G_S);
SPSUB_temp = (SPSUB_yg-SPSUB_y0);

d_SPSUB_temp1_dV_S_B = SPSUB_delta*d_SPSUB_delta1_dV_S_B;
d_SPSUB_temp1_dTemp_Tnode_GND = SPSUB_delta*d_SPSUB_delta1_dTemp_Tnode_GND;
d_SPSUB_temp1_dV_D_S = SPSUB_delta*d_SPSUB_delta1_dV_D_S;
d_SPSUB_temp1_dV_G_S = SPSUB_delta*d_SPSUB_delta1_dV_G_S;
SPSUB_temp1 = (SPSUB_delta*SPSUB_delta1);

d_SPSUB_pC_dV_S_B = (2.0*d_SPSUB_temp_dV_S_B+Gfsub2*((d_SPSUB_delta0_dV_S_B-d_SPSUB_temp1_dV_S_B)+SPSUB_delta*(-d_SPSUB_xi1_dV_S_B)));
d_SPSUB_pC_dTemp_Tnode_GND = (2.0*d_SPSUB_temp_dTemp_Tnode_GND+Gfsub2*((d_SPSUB_delta0_dTemp_Tnode_GND-d_SPSUB_temp1_dTemp_Tnode_GND)+SPSUB_delta*(-d_SPSUB_xi1_dTemp_Tnode_GND)));
d_SPSUB_pC_dV_D_S = (2.0*d_SPSUB_temp_dV_D_S+Gfsub2*((d_SPSUB_delta0_dV_D_S-d_SPSUB_temp1_dV_D_S)+SPSUB_delta*(-d_SPSUB_xi1_dV_D_S)));
d_SPSUB_pC_dV_G_S = (2.0*d_SPSUB_temp_dV_G_S+Gfsub2*((d_SPSUB_delta0_dV_G_S-d_SPSUB_temp1_dV_G_S)+SPSUB_delta*(-d_SPSUB_xi1_dV_G_S)));
SPSUB_pC = ((2.0*SPSUB_temp)+(Gfsub2*(((SPSUB_delta0-1.0)-SPSUB_temp1)+(SPSUB_delta*(1.0-SPSUB_xi1)))));

d_SPSUB_qC_dV_S_B = ((SPSUB_temp*d_SPSUB_temp_dV_S_B+d_SPSUB_temp_dV_S_B*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta0_dV_S_B-d_SPSUB_y0_dV_S_B)+d_SPSUB_temp1_dV_S_B)+SPSUB_delta*(d_SPSUB_y0_dV_S_B-d_SPSUB_xi0_dV_S_B)));
d_SPSUB_qC_dTemp_Tnode_GND = ((SPSUB_temp*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_temp_dTemp_Tnode_GND*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta0_dTemp_Tnode_GND-d_SPSUB_y0_dTemp_Tnode_GND)+d_SPSUB_temp1_dTemp_Tnode_GND)+SPSUB_delta*(d_SPSUB_y0_dTemp_Tnode_GND-d_SPSUB_xi0_dTemp_Tnode_GND)));
d_SPSUB_qC_dV_D_S = ((SPSUB_temp*d_SPSUB_temp_dV_D_S+d_SPSUB_temp_dV_D_S*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta0_dV_D_S-d_SPSUB_y0_dV_D_S)+d_SPSUB_temp1_dV_D_S)+SPSUB_delta*(d_SPSUB_y0_dV_D_S-d_SPSUB_xi0_dV_D_S)));
d_SPSUB_qC_dV_G_S = ((SPSUB_temp*d_SPSUB_temp_dV_G_S+d_SPSUB_temp_dV_G_S*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta0_dV_G_S-d_SPSUB_y0_dV_G_S)+d_SPSUB_temp1_dV_G_S)+SPSUB_delta*(d_SPSUB_y0_dV_G_S-d_SPSUB_xi0_dV_G_S)));
SPSUB_qC = ((SPSUB_temp*SPSUB_temp)-(Gfsub2*((((SPSUB_delta0-SPSUB_y0)-1.0)+SPSUB_temp1)+(SPSUB_delta*((SPSUB_y0-1.0)-SPSUB_xi0)))));

d_SPSUB_temp_dV_S_B = (-Gfsub2*((d_SPSUB_delta0_dV_S_B+d_SPSUB_temp1_dV_S_B)-SPSUB_delta*d_SPSUB_xi2_dV_S_B));
d_SPSUB_temp_dTemp_Tnode_GND = (-Gfsub2*((d_SPSUB_delta0_dTemp_Tnode_GND+d_SPSUB_temp1_dTemp_Tnode_GND)-SPSUB_delta*d_SPSUB_xi2_dTemp_Tnode_GND));
d_SPSUB_temp_dV_D_S = (-Gfsub2*((d_SPSUB_delta0_dV_D_S+d_SPSUB_temp1_dV_D_S)-SPSUB_delta*d_SPSUB_xi2_dV_D_S));
d_SPSUB_temp_dV_G_S = (-Gfsub2*((d_SPSUB_delta0_dV_G_S+d_SPSUB_temp1_dV_G_S)-SPSUB_delta*d_SPSUB_xi2_dV_G_S));
SPSUB_temp = (2.0-(Gfsub2*((SPSUB_delta0+SPSUB_temp1)-(SPSUB_delta*SPSUB_xi2))));

d_SPSUB_temp_dV_S_B = ((SPSUB_pC*d_SPSUB_pC_dV_S_B+d_SPSUB_pC_dV_S_B*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dV_S_B+d_SPSUB_qC_dV_S_B*SPSUB_temp));
d_SPSUB_temp_dTemp_Tnode_GND = ((SPSUB_pC*d_SPSUB_pC_dTemp_Tnode_GND+d_SPSUB_pC_dTemp_Tnode_GND*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_qC_dTemp_Tnode_GND*SPSUB_temp));
d_SPSUB_temp_dV_D_S = ((SPSUB_pC*d_SPSUB_pC_dV_D_S+d_SPSUB_pC_dV_D_S*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dV_D_S+d_SPSUB_qC_dV_D_S*SPSUB_temp));
d_SPSUB_temp_dV_G_S = ((SPSUB_pC*d_SPSUB_pC_dV_G_S+d_SPSUB_pC_dV_G_S*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dV_G_S+d_SPSUB_qC_dV_G_S*SPSUB_temp));
SPSUB_temp = ((SPSUB_pC*SPSUB_pC)-(2.0*(SPSUB_qC*SPSUB_temp)));
{
double value_sqrt_0 = sqrt(SPSUB_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp3_dV_S_B = ((-d_SPSUB_y0_dV_S_B)-2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dV_S_B-SPSUB_qC*(d_SPSUB_pC_dV_S_B+(deriv_sqrt_0_d0*(d_SPSUB_temp_dV_S_B))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
d_temp3_dTemp_Tnode_GND = ((-d_SPSUB_y0_dTemp_Tnode_GND)-2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dTemp_Tnode_GND-SPSUB_qC*(d_SPSUB_pC_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SPSUB_temp_dTemp_Tnode_GND))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
d_temp3_dV_D_S = ((-d_SPSUB_y0_dV_D_S)-2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dV_D_S-SPSUB_qC*(d_SPSUB_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SPSUB_temp_dV_D_S))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
d_temp3_dV_G_S = ((-d_SPSUB_y0_dV_G_S)-2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dV_G_S-SPSUB_qC*(d_SPSUB_pC_dV_G_S+(deriv_sqrt_0_d0*(d_SPSUB_temp_dV_G_S))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
temp3 = ((-SPSUB_y0)-(2.0*(SPSUB_qC/(SPSUB_pC+value_sqrt_0))));
}
}
else
{
SPSUB_xg1 = (1.0/(1.25+(Gfsub*0.732464877560822)));
SPSUB_A_fac = ((((1.25*xisub)*SPSUB_xg1)-1.0)*SPSUB_xg1);

d_SPSUB_xbar_dV_S_B = ((SPSUB_xgb*inv_xisub)*SPSUB_A_fac*d_SPSUB_xgb_dV_S_B+d_SPSUB_xgb_dV_S_B*inv_xisub*(1.0+(SPSUB_A_fac*SPSUB_xgb)));
d_SPSUB_xbar_dTemp_Tnode_GND = ((SPSUB_xgb*inv_xisub)*SPSUB_A_fac*d_SPSUB_xgb_dTemp_Tnode_GND+d_SPSUB_xgb_dTemp_Tnode_GND*inv_xisub*(1.0+(SPSUB_A_fac*SPSUB_xgb)));
d_SPSUB_xbar_dV_D_S = ((SPSUB_xgb*inv_xisub)*SPSUB_A_fac*d_SPSUB_xgb_dV_D_S+d_SPSUB_xgb_dV_D_S*inv_xisub*(1.0+(SPSUB_A_fac*SPSUB_xgb)));
d_SPSUB_xbar_dV_G_S = ((SPSUB_xgb*inv_xisub)*SPSUB_A_fac*d_SPSUB_xgb_dV_G_S+d_SPSUB_xgb_dV_G_S*inv_xisub*(1.0+(SPSUB_A_fac*SPSUB_xgb)));
SPSUB_xbar = ((SPSUB_xgb*inv_xisub)*(1.0+(SPSUB_A_fac*SPSUB_xgb)));
if (((-SPSUB_xbar)>(-80.0)))
{
{
double value_exp_0 = exp((-SPSUB_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SPSUB_temp_dV_S_B = (deriv_exp_0_d0*((-d_SPSUB_xbar_dV_S_B)));
d_SPSUB_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SPSUB_xbar_dTemp_Tnode_GND)));
d_SPSUB_temp_dV_D_S = (deriv_exp_0_d0*((-d_SPSUB_xbar_dV_D_S)));
d_SPSUB_temp_dV_G_S = (deriv_exp_0_d0*((-d_SPSUB_xbar_dV_G_S)));
SPSUB_temp = value_exp_0;
}
}
else
{

d_SPSUB_temp_dV_S_B = (-1.80485e-35*(((-(-SPSUB_xbar))-80.0)*((0.5*((-(-SPSUB_xbar))-80.0))*(-(-d_SPSUB_xbar_dV_S_B))*0.3333333333333+0.5*(-(-d_SPSUB_xbar_dV_S_B))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))+(-(-d_SPSUB_xbar_dV_S_B))*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))));
d_SPSUB_temp_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SPSUB_xbar))-80.0)*((0.5*((-(-SPSUB_xbar))-80.0))*(-(-d_SPSUB_xbar_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SPSUB_xbar_dTemp_Tnode_GND))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))+(-(-d_SPSUB_xbar_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))));
d_SPSUB_temp_dV_D_S = (-1.80485e-35*(((-(-SPSUB_xbar))-80.0)*((0.5*((-(-SPSUB_xbar))-80.0))*(-(-d_SPSUB_xbar_dV_D_S))*0.3333333333333+0.5*(-(-d_SPSUB_xbar_dV_D_S))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))+(-(-d_SPSUB_xbar_dV_D_S))*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))));
d_SPSUB_temp_dV_G_S = (-1.80485e-35*(((-(-SPSUB_xbar))-80.0)*((0.5*((-(-SPSUB_xbar))-80.0))*(-(-d_SPSUB_xbar_dV_G_S))*0.3333333333333+0.5*(-(-d_SPSUB_xbar_dV_G_S))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))+(-(-d_SPSUB_xbar_dV_G_S))*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))));
SPSUB_temp = (1.80485e-35/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))));
}

d_SPSUB_w_dV_S_B = (-d_SPSUB_temp_dV_S_B);
d_SPSUB_w_dTemp_Tnode_GND = (-d_SPSUB_temp_dTemp_Tnode_GND);
d_SPSUB_w_dV_D_S = (-d_SPSUB_temp_dV_D_S);
d_SPSUB_w_dV_G_S = (-d_SPSUB_temp_dV_G_S);
SPSUB_w = (1.0-SPSUB_temp);
{
double value_sqrt_0 = sqrt(((SPSUB_xgb+(Gfsub2*0.25))-SPSUB_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SPSUB_x1_dV_S_B = (d_SPSUB_xgb_dV_S_B-Gfsub*(deriv_sqrt_0_d0*((d_SPSUB_xgb_dV_S_B-d_SPSUB_w_dV_S_B))));
d_SPSUB_x1_dTemp_Tnode_GND = (d_SPSUB_xgb_dTemp_Tnode_GND-Gfsub*(deriv_sqrt_0_d0*((d_SPSUB_xgb_dTemp_Tnode_GND-d_SPSUB_w_dTemp_Tnode_GND))));
d_SPSUB_x1_dV_D_S = (d_SPSUB_xgb_dV_D_S-Gfsub*(deriv_sqrt_0_d0*((d_SPSUB_xgb_dV_D_S-d_SPSUB_w_dV_D_S))));
d_SPSUB_x1_dV_G_S = (d_SPSUB_xgb_dV_G_S-Gfsub*(deriv_sqrt_0_d0*((d_SPSUB_xgb_dV_G_S-d_SPSUB_w_dV_G_S))));
SPSUB_x1 = ((SPSUB_xgb+(Gfsub2*0.5))-(Gfsub*value_sqrt_0));
}
SPSUB_bx = (xn_sub+3.0);
{
double value_sqrt_0 = sqrt((((SPSUB_x1-SPSUB_bx)*(SPSUB_x1-SPSUB_bx))+5.0));
double value_sqrt_1 = sqrt(((SPSUB_bx*SPSUB_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_SPSUB_eta_dV_S_B = 0.5*(d_SPSUB_x1_dV_S_B-(deriv_sqrt_0_d0*(((SPSUB_x1-SPSUB_bx)*d_SPSUB_x1_dV_S_B+d_SPSUB_x1_dV_S_B*(SPSUB_x1-SPSUB_bx)))));
d_SPSUB_eta_dTemp_Tnode_GND = 0.5*(d_SPSUB_x1_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((SPSUB_x1-SPSUB_bx)*d_SPSUB_x1_dTemp_Tnode_GND+d_SPSUB_x1_dTemp_Tnode_GND*(SPSUB_x1-SPSUB_bx)))));
d_SPSUB_eta_dV_D_S = 0.5*(d_SPSUB_x1_dV_D_S-(deriv_sqrt_0_d0*(((SPSUB_x1-SPSUB_bx)*d_SPSUB_x1_dV_D_S+d_SPSUB_x1_dV_D_S*(SPSUB_x1-SPSUB_bx)))));
d_SPSUB_eta_dV_G_S = 0.5*(d_SPSUB_x1_dV_G_S-(deriv_sqrt_0_d0*(((SPSUB_x1-SPSUB_bx)*d_SPSUB_x1_dV_G_S+d_SPSUB_x1_dV_G_S*(SPSUB_x1-SPSUB_bx)))));
SPSUB_eta = ((0.5*((SPSUB_x1+SPSUB_bx)-value_sqrt_0))-(0.5*(SPSUB_bx-value_sqrt_1)));
}

d_SPSUB_temp_dV_S_B = (d_SPSUB_xgb_dV_S_B-d_SPSUB_eta_dV_S_B);
d_SPSUB_temp_dTemp_Tnode_GND = (d_SPSUB_xgb_dTemp_Tnode_GND-d_SPSUB_eta_dTemp_Tnode_GND);
d_SPSUB_temp_dV_D_S = (d_SPSUB_xgb_dV_D_S-d_SPSUB_eta_dV_D_S);
d_SPSUB_temp_dV_G_S = (d_SPSUB_xgb_dV_G_S-d_SPSUB_eta_dV_G_S);
SPSUB_temp = (SPSUB_xgb-SPSUB_eta);
{
double value_exp_0 = exp((-SPSUB_eta));
double  deriv_exp_0_d0 = value_exp_0;

d_SPSUB_temp1_dV_S_B = (deriv_exp_0_d0*((-d_SPSUB_eta_dV_S_B)));
d_SPSUB_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SPSUB_eta_dTemp_Tnode_GND)));
d_SPSUB_temp1_dV_D_S = (deriv_exp_0_d0*((-d_SPSUB_eta_dV_D_S)));
d_SPSUB_temp1_dV_G_S = (deriv_exp_0_d0*((-d_SPSUB_eta_dV_G_S)));
SPSUB_temp1 = value_exp_0;
}

d_SPSUB_temp2_dV_S_B = (-(SPSUB_eta*d_SPSUB_eta_dV_S_B+d_SPSUB_eta_dV_S_B*SPSUB_eta)/(2.0+(SPSUB_eta*SPSUB_eta))/(2.0+(SPSUB_eta*SPSUB_eta)));
d_SPSUB_temp2_dTemp_Tnode_GND = (-(SPSUB_eta*d_SPSUB_eta_dTemp_Tnode_GND+d_SPSUB_eta_dTemp_Tnode_GND*SPSUB_eta)/(2.0+(SPSUB_eta*SPSUB_eta))/(2.0+(SPSUB_eta*SPSUB_eta)));
d_SPSUB_temp2_dV_D_S = (-(SPSUB_eta*d_SPSUB_eta_dV_D_S+d_SPSUB_eta_dV_D_S*SPSUB_eta)/(2.0+(SPSUB_eta*SPSUB_eta))/(2.0+(SPSUB_eta*SPSUB_eta)));
d_SPSUB_temp2_dV_G_S = (-(SPSUB_eta*d_SPSUB_eta_dV_G_S+d_SPSUB_eta_dV_G_S*SPSUB_eta)/(2.0+(SPSUB_eta*SPSUB_eta))/(2.0+(SPSUB_eta*SPSUB_eta)));
SPSUB_temp2 = (1.0/(2.0+(SPSUB_eta*SPSUB_eta)));

d_SPSUB_xi0_dV_S_B = ((SPSUB_eta*SPSUB_eta)*d_SPSUB_temp2_dV_S_B+(SPSUB_eta*d_SPSUB_eta_dV_S_B+d_SPSUB_eta_dV_S_B*SPSUB_eta)*SPSUB_temp2);
d_SPSUB_xi0_dTemp_Tnode_GND = ((SPSUB_eta*SPSUB_eta)*d_SPSUB_temp2_dTemp_Tnode_GND+(SPSUB_eta*d_SPSUB_eta_dTemp_Tnode_GND+d_SPSUB_eta_dTemp_Tnode_GND*SPSUB_eta)*SPSUB_temp2);
d_SPSUB_xi0_dV_D_S = ((SPSUB_eta*SPSUB_eta)*d_SPSUB_temp2_dV_D_S+(SPSUB_eta*d_SPSUB_eta_dV_D_S+d_SPSUB_eta_dV_D_S*SPSUB_eta)*SPSUB_temp2);
d_SPSUB_xi0_dV_G_S = ((SPSUB_eta*SPSUB_eta)*d_SPSUB_temp2_dV_G_S+(SPSUB_eta*d_SPSUB_eta_dV_G_S+d_SPSUB_eta_dV_G_S*SPSUB_eta)*SPSUB_temp2);
SPSUB_xi0 = ((SPSUB_eta*SPSUB_eta)*SPSUB_temp2);

d_SPSUB_xi1_dV_S_B = 4.0*((SPSUB_eta*SPSUB_temp2)*d_SPSUB_temp2_dV_S_B+(SPSUB_eta*d_SPSUB_temp2_dV_S_B+d_SPSUB_eta_dV_S_B*SPSUB_temp2)*SPSUB_temp2);
d_SPSUB_xi1_dTemp_Tnode_GND = 4.0*((SPSUB_eta*SPSUB_temp2)*d_SPSUB_temp2_dTemp_Tnode_GND+(SPSUB_eta*d_SPSUB_temp2_dTemp_Tnode_GND+d_SPSUB_eta_dTemp_Tnode_GND*SPSUB_temp2)*SPSUB_temp2);
d_SPSUB_xi1_dV_D_S = 4.0*((SPSUB_eta*SPSUB_temp2)*d_SPSUB_temp2_dV_D_S+(SPSUB_eta*d_SPSUB_temp2_dV_D_S+d_SPSUB_eta_dV_D_S*SPSUB_temp2)*SPSUB_temp2);
d_SPSUB_xi1_dV_G_S = 4.0*((SPSUB_eta*SPSUB_temp2)*d_SPSUB_temp2_dV_G_S+(SPSUB_eta*d_SPSUB_temp2_dV_G_S+d_SPSUB_eta_dV_G_S*SPSUB_temp2)*SPSUB_temp2);
SPSUB_xi1 = (4.0*((SPSUB_eta*SPSUB_temp2)*SPSUB_temp2));

d_SPSUB_xi2_dV_S_B = ((((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*SPSUB_temp2)*d_SPSUB_temp2_dV_S_B+(((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*d_SPSUB_temp2_dV_S_B+(8.0*d_SPSUB_temp2_dV_S_B-12.0*d_SPSUB_xi0_dV_S_B)*SPSUB_temp2)*SPSUB_temp2);
d_SPSUB_xi2_dTemp_Tnode_GND = ((((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*SPSUB_temp2)*d_SPSUB_temp2_dTemp_Tnode_GND+(((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*d_SPSUB_temp2_dTemp_Tnode_GND+(8.0*d_SPSUB_temp2_dTemp_Tnode_GND-12.0*d_SPSUB_xi0_dTemp_Tnode_GND)*SPSUB_temp2)*SPSUB_temp2);
d_SPSUB_xi2_dV_D_S = ((((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*SPSUB_temp2)*d_SPSUB_temp2_dV_D_S+(((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*d_SPSUB_temp2_dV_D_S+(8.0*d_SPSUB_temp2_dV_D_S-12.0*d_SPSUB_xi0_dV_D_S)*SPSUB_temp2)*SPSUB_temp2);
d_SPSUB_xi2_dV_G_S = ((((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*SPSUB_temp2)*d_SPSUB_temp2_dV_G_S+(((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*d_SPSUB_temp2_dV_G_S+(8.0*d_SPSUB_temp2_dV_G_S-12.0*d_SPSUB_xi0_dV_G_S)*SPSUB_temp2)*SPSUB_temp2);
SPSUB_xi2 = ((((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*SPSUB_temp2)*SPSUB_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SPSUB_temp*SPSUB_temp)-(Gfsub2*(((SPSUB_temp1+SPSUB_eta)-1.0)-(SPSUB_delta*((SPSUB_eta+1.0)+SPSUB_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SPSUB_temp*SPSUB_temp)-(Gfsub2*(((SPSUB_temp1+SPSUB_eta)-1.0)-(SPSUB_delta*((SPSUB_eta+1.0)+SPSUB_xi0))))))?0.0:1.0);

d_SPSUB_a_dV_S_B = (deriv_max_0_d1*(((SPSUB_temp*d_SPSUB_temp_dV_S_B+d_SPSUB_temp_dV_S_B*SPSUB_temp)-Gfsub2*((d_SPSUB_temp1_dV_S_B+d_SPSUB_eta_dV_S_B)-SPSUB_delta*(d_SPSUB_eta_dV_S_B+d_SPSUB_xi0_dV_S_B)))));
d_SPSUB_a_dTemp_Tnode_GND = (deriv_max_0_d1*(((SPSUB_temp*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_temp_dTemp_Tnode_GND*SPSUB_temp)-Gfsub2*((d_SPSUB_temp1_dTemp_Tnode_GND+d_SPSUB_eta_dTemp_Tnode_GND)-SPSUB_delta*(d_SPSUB_eta_dTemp_Tnode_GND+d_SPSUB_xi0_dTemp_Tnode_GND)))));
d_SPSUB_a_dV_D_S = (deriv_max_0_d1*(((SPSUB_temp*d_SPSUB_temp_dV_D_S+d_SPSUB_temp_dV_D_S*SPSUB_temp)-Gfsub2*((d_SPSUB_temp1_dV_D_S+d_SPSUB_eta_dV_D_S)-SPSUB_delta*(d_SPSUB_eta_dV_D_S+d_SPSUB_xi0_dV_D_S)))));
d_SPSUB_a_dV_G_S = (deriv_max_0_d1*(((SPSUB_temp*d_SPSUB_temp_dV_G_S+d_SPSUB_temp_dV_G_S*SPSUB_temp)-Gfsub2*((d_SPSUB_temp1_dV_G_S+d_SPSUB_eta_dV_G_S)-SPSUB_delta*(d_SPSUB_eta_dV_G_S+d_SPSUB_xi0_dV_G_S)))));
SPSUB_a = value_max_0;
}

d_SPSUB_b_dV_S_B = (-0.5*Gfsub2*(d_SPSUB_temp1_dV_S_B-SPSUB_delta*d_SPSUB_xi2_dV_S_B));
d_SPSUB_b_dTemp_Tnode_GND = (-0.5*Gfsub2*(d_SPSUB_temp1_dTemp_Tnode_GND-SPSUB_delta*d_SPSUB_xi2_dTemp_Tnode_GND));
d_SPSUB_b_dV_D_S = (-0.5*Gfsub2*(d_SPSUB_temp1_dV_D_S-SPSUB_delta*d_SPSUB_xi2_dV_D_S));
d_SPSUB_b_dV_G_S = (-0.5*Gfsub2*(d_SPSUB_temp1_dV_G_S-SPSUB_delta*d_SPSUB_xi2_dV_G_S));
SPSUB_b = (1.0-(0.5*(Gfsub2*(SPSUB_temp1-(SPSUB_delta*SPSUB_xi2)))));

d_SPSUB_c_dV_S_B = (2.0*d_SPSUB_temp_dV_S_B+Gfsub2*((-d_SPSUB_temp1_dV_S_B)-SPSUB_delta*d_SPSUB_xi1_dV_S_B));
d_SPSUB_c_dTemp_Tnode_GND = (2.0*d_SPSUB_temp_dTemp_Tnode_GND+Gfsub2*((-d_SPSUB_temp1_dTemp_Tnode_GND)-SPSUB_delta*d_SPSUB_xi1_dTemp_Tnode_GND));
d_SPSUB_c_dV_D_S = (2.0*d_SPSUB_temp_dV_D_S+Gfsub2*((-d_SPSUB_temp1_dV_D_S)-SPSUB_delta*d_SPSUB_xi1_dV_D_S));
d_SPSUB_c_dV_G_S = (2.0*d_SPSUB_temp_dV_G_S+Gfsub2*((-d_SPSUB_temp1_dV_G_S)-SPSUB_delta*d_SPSUB_xi1_dV_G_S));
SPSUB_c = ((2.0*SPSUB_temp)+(Gfsub2*((1.0-SPSUB_temp1)-(SPSUB_delta*(1.0+SPSUB_xi1)))));
{
double value_log_0 = log((SPSUB_a/Gfsub2));
double  deriv_log_0_d0 = (1.0/(SPSUB_a/Gfsub2));

d_SPSUB_tau_dV_S_B = ((-d_SPSUB_eta_dV_S_B)+(deriv_log_0_d0*((d_SPSUB_a_dV_S_B/Gfsub2))));
d_SPSUB_tau_dTemp_Tnode_GND = ((-d_SPSUB_eta_dTemp_Tnode_GND)+(deriv_log_0_d0*((d_SPSUB_a_dTemp_Tnode_GND/Gfsub2))));
d_SPSUB_tau_dV_D_S = ((-d_SPSUB_eta_dV_D_S)+(deriv_log_0_d0*((d_SPSUB_a_dV_D_S/Gfsub2))));
d_SPSUB_tau_dV_G_S = ((-d_SPSUB_eta_dV_G_S)+(deriv_log_0_d0*((d_SPSUB_a_dV_G_S/Gfsub2))));
SPSUB_tau = ((xn_sub-SPSUB_eta)+value_log_0);
}

d_nu_dV_S_B = (d_SPSUB_a_dV_S_B+d_SPSUB_c_dV_S_B);
d_nu_dTemp_Tnode_GND = (d_SPSUB_a_dTemp_Tnode_GND+d_SPSUB_c_dTemp_Tnode_GND);
d_nu_dV_D_S = (d_SPSUB_a_dV_D_S+d_SPSUB_c_dV_D_S);
d_nu_dV_G_S = (d_SPSUB_a_dV_G_S+d_SPSUB_c_dV_G_S);
nu = (SPSUB_a+SPSUB_c);

d_mutau_dV_S_B = ((nu*d_nu_dV_S_B+d_nu_dV_S_B*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dV_S_B+0.5*d_SPSUB_c_dV_S_B*SPSUB_c)-(SPSUB_a*d_SPSUB_b_dV_S_B+d_SPSUB_a_dV_S_B*SPSUB_b))+d_SPSUB_tau_dV_S_B*(((0.5*SPSUB_c)*SPSUB_c)-(SPSUB_a*SPSUB_b))));
d_mutau_dTemp_Tnode_GND = ((nu*d_nu_dTemp_Tnode_GND+d_nu_dTemp_Tnode_GND*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dTemp_Tnode_GND+0.5*d_SPSUB_c_dTemp_Tnode_GND*SPSUB_c)-(SPSUB_a*d_SPSUB_b_dTemp_Tnode_GND+d_SPSUB_a_dTemp_Tnode_GND*SPSUB_b))+d_SPSUB_tau_dTemp_Tnode_GND*(((0.5*SPSUB_c)*SPSUB_c)-(SPSUB_a*SPSUB_b))));
d_mutau_dV_D_S = ((nu*d_nu_dV_D_S+d_nu_dV_D_S*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dV_D_S+0.5*d_SPSUB_c_dV_D_S*SPSUB_c)-(SPSUB_a*d_SPSUB_b_dV_D_S+d_SPSUB_a_dV_D_S*SPSUB_b))+d_SPSUB_tau_dV_D_S*(((0.5*SPSUB_c)*SPSUB_c)-(SPSUB_a*SPSUB_b))));
d_mutau_dV_G_S = ((nu*d_nu_dV_G_S+d_nu_dV_G_S*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dV_G_S+0.5*d_SPSUB_c_dV_G_S*SPSUB_c)-(SPSUB_a*d_SPSUB_b_dV_G_S+d_SPSUB_a_dV_G_S*SPSUB_b))+d_SPSUB_tau_dV_G_S*(((0.5*SPSUB_c)*SPSUB_c)-(SPSUB_a*SPSUB_b))));
mutau = ((nu*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*SPSUB_c)-(SPSUB_a*SPSUB_b))));

d_SPSUB_x0_dV_S_B = (d_SPSUB_eta_dV_S_B+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))*((SPSUB_a*nu)*d_SPSUB_tau_dV_S_B+(SPSUB_a*d_nu_dV_S_B+d_SPSUB_a_dV_S_B*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dV_S_B+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dV_S_B+d_SPSUB_c_dV_S_B*SPSUB_c)*0.3333333333333-(SPSUB_a*d_SPSUB_b_dV_S_B+d_SPSUB_a_dV_S_B*SPSUB_b))+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dV_S_B+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dV_S_B+((nu/mutau)*d_SPSUB_tau_dV_S_B+((mutau*d_nu_dV_S_B-nu*d_mutau_dV_S_B)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b)))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))));
d_SPSUB_x0_dTemp_Tnode_GND = (d_SPSUB_eta_dTemp_Tnode_GND+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))*((SPSUB_a*nu)*d_SPSUB_tau_dTemp_Tnode_GND+(SPSUB_a*d_nu_dTemp_Tnode_GND+d_SPSUB_a_dTemp_Tnode_GND*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dTemp_Tnode_GND+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dTemp_Tnode_GND+d_SPSUB_c_dTemp_Tnode_GND*SPSUB_c)*0.3333333333333-(SPSUB_a*d_SPSUB_b_dTemp_Tnode_GND+d_SPSUB_a_dTemp_Tnode_GND*SPSUB_b))+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dTemp_Tnode_GND+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dTemp_Tnode_GND+((nu/mutau)*d_SPSUB_tau_dTemp_Tnode_GND+((mutau*d_nu_dTemp_Tnode_GND-nu*d_mutau_dTemp_Tnode_GND)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b)))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))));
d_SPSUB_x0_dV_D_S = (d_SPSUB_eta_dV_D_S+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))*((SPSUB_a*nu)*d_SPSUB_tau_dV_D_S+(SPSUB_a*d_nu_dV_D_S+d_SPSUB_a_dV_D_S*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dV_D_S+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dV_D_S+d_SPSUB_c_dV_D_S*SPSUB_c)*0.3333333333333-(SPSUB_a*d_SPSUB_b_dV_D_S+d_SPSUB_a_dV_D_S*SPSUB_b))+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dV_D_S+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dV_D_S+((nu/mutau)*d_SPSUB_tau_dV_D_S+((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b)))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))));
d_SPSUB_x0_dV_G_S = (d_SPSUB_eta_dV_G_S+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))*((SPSUB_a*nu)*d_SPSUB_tau_dV_G_S+(SPSUB_a*d_nu_dV_G_S+d_SPSUB_a_dV_G_S*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dV_G_S+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dV_G_S+d_SPSUB_c_dV_G_S*SPSUB_c)*0.3333333333333-(SPSUB_a*d_SPSUB_b_dV_G_S+d_SPSUB_a_dV_G_S*SPSUB_b))+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dV_G_S+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dV_G_S+((nu/mutau)*d_SPSUB_tau_dV_G_S+((mutau*d_nu_dV_G_S-nu*d_mutau_dV_G_S)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b)))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))));
SPSUB_x0 = (SPSUB_eta+(((SPSUB_a*nu)*SPSUB_tau)/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))));
if ((SPSUB_x0<80.0))
{
{
double value_exp_0 = exp(SPSUB_x0);
double  deriv_exp_0_d0 = value_exp_0;

d_SPSUB_delta0_dV_S_B = (deriv_exp_0_d0*(d_SPSUB_x0_dV_S_B));
d_SPSUB_delta0_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_SPSUB_x0_dTemp_Tnode_GND));
d_SPSUB_delta0_dV_D_S = (deriv_exp_0_d0*(d_SPSUB_x0_dV_D_S));
d_SPSUB_delta0_dV_G_S = (deriv_exp_0_d0*(d_SPSUB_x0_dV_G_S));
SPSUB_delta0 = value_exp_0;
}

d_SPSUB_delta1_dV_S_B = (-d_SPSUB_delta0_dV_S_B/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dTemp_Tnode_GND = (-d_SPSUB_delta0_dTemp_Tnode_GND/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dV_D_S = (-d_SPSUB_delta0_dV_D_S/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dV_G_S = (-d_SPSUB_delta0_dV_G_S/SPSUB_delta0/SPSUB_delta0);
SPSUB_delta1 = (1.0/SPSUB_delta0);

d_SPSUB_delta0_dV_S_B = SPSUB_delta*d_SPSUB_delta0_dV_S_B;
d_SPSUB_delta0_dTemp_Tnode_GND = SPSUB_delta*d_SPSUB_delta0_dTemp_Tnode_GND;
d_SPSUB_delta0_dV_D_S = SPSUB_delta*d_SPSUB_delta0_dV_D_S;
d_SPSUB_delta0_dV_G_S = SPSUB_delta*d_SPSUB_delta0_dV_G_S;
SPSUB_delta0 = (SPSUB_delta*SPSUB_delta0);
}
else
{
if ((SPSUB_x0>(xn_sub-80.0)))
{
{
double value_exp_0 = exp((SPSUB_x0-xn_sub));
double  deriv_exp_0_d0 = value_exp_0;

d_SPSUB_delta0_dV_S_B = (deriv_exp_0_d0*(d_SPSUB_x0_dV_S_B));
d_SPSUB_delta0_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_SPSUB_x0_dTemp_Tnode_GND));
d_SPSUB_delta0_dV_D_S = (deriv_exp_0_d0*(d_SPSUB_x0_dV_D_S));
d_SPSUB_delta0_dV_G_S = (deriv_exp_0_d0*(d_SPSUB_x0_dV_G_S));
SPSUB_delta0 = value_exp_0;
}

d_SPSUB_delta1_dV_S_B = (-SPSUB_delta*d_SPSUB_delta0_dV_S_B/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dTemp_Tnode_GND = (-SPSUB_delta*d_SPSUB_delta0_dTemp_Tnode_GND/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dV_D_S = (-SPSUB_delta*d_SPSUB_delta0_dV_D_S/SPSUB_delta0/SPSUB_delta0);
d_SPSUB_delta1_dV_G_S = (-SPSUB_delta*d_SPSUB_delta0_dV_G_S/SPSUB_delta0/SPSUB_delta0);
SPSUB_delta1 = (SPSUB_delta/SPSUB_delta0);
}
else
{

d_SPSUB_delta0_dV_S_B = (-1.80485e-35*(((xn_sub-SPSUB_x0)-80.0)*((0.5*((xn_sub-SPSUB_x0)-80.0))*(-d_SPSUB_x0_dV_S_B)*0.3333333333333+0.5*(-d_SPSUB_x0_dV_S_B)*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))+(-d_SPSUB_x0_dV_S_B)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333))))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))));
d_SPSUB_delta0_dTemp_Tnode_GND = (-1.80485e-35*(((xn_sub-SPSUB_x0)-80.0)*((0.5*((xn_sub-SPSUB_x0)-80.0))*(-d_SPSUB_x0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SPSUB_x0_dTemp_Tnode_GND)*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))+(-d_SPSUB_x0_dTemp_Tnode_GND)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333))))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))));
d_SPSUB_delta0_dV_D_S = (-1.80485e-35*(((xn_sub-SPSUB_x0)-80.0)*((0.5*((xn_sub-SPSUB_x0)-80.0))*(-d_SPSUB_x0_dV_D_S)*0.3333333333333+0.5*(-d_SPSUB_x0_dV_D_S)*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))+(-d_SPSUB_x0_dV_D_S)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333))))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))));
d_SPSUB_delta0_dV_G_S = (-1.80485e-35*(((xn_sub-SPSUB_x0)-80.0)*((0.5*((xn_sub-SPSUB_x0)-80.0))*(-d_SPSUB_x0_dV_G_S)*0.3333333333333+0.5*(-d_SPSUB_x0_dV_G_S)*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))+(-d_SPSUB_x0_dV_G_S)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333))))))/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))));
SPSUB_delta0 = (1.80485e-35/(1.0+(((xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((xn_sub-SPSUB_x0)-80.0))*(1.0+(((xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))));

d_SPSUB_delta1_dV_S_B = (-1.80485e-35*((SPSUB_x0-80.0)*((0.5*(SPSUB_x0-80.0))*d_SPSUB_x0_dV_S_B*0.3333333333333+0.5*d_SPSUB_x0_dV_S_B*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))+d_SPSUB_x0_dV_S_B*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333))))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))));
d_SPSUB_delta1_dTemp_Tnode_GND = (-1.80485e-35*((SPSUB_x0-80.0)*((0.5*(SPSUB_x0-80.0))*d_SPSUB_x0_dTemp_Tnode_GND*0.3333333333333+0.5*d_SPSUB_x0_dTemp_Tnode_GND*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))+d_SPSUB_x0_dTemp_Tnode_GND*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333))))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))));
d_SPSUB_delta1_dV_D_S = (-1.80485e-35*((SPSUB_x0-80.0)*((0.5*(SPSUB_x0-80.0))*d_SPSUB_x0_dV_D_S*0.3333333333333+0.5*d_SPSUB_x0_dV_D_S*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))+d_SPSUB_x0_dV_D_S*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333))))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))));
d_SPSUB_delta1_dV_G_S = (-1.80485e-35*((SPSUB_x0-80.0)*((0.5*(SPSUB_x0-80.0))*d_SPSUB_x0_dV_G_S*0.3333333333333+0.5*d_SPSUB_x0_dV_G_S*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))+d_SPSUB_x0_dV_G_S*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333))))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))));
SPSUB_delta1 = (1.80485e-35/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))));
}
}

d_SPSUB_temp_dV_S_B = (-(SPSUB_x0*d_SPSUB_x0_dV_S_B+d_SPSUB_x0_dV_S_B*SPSUB_x0)/(2.0+(SPSUB_x0*SPSUB_x0))/(2.0+(SPSUB_x0*SPSUB_x0)));
d_SPSUB_temp_dTemp_Tnode_GND = (-(SPSUB_x0*d_SPSUB_x0_dTemp_Tnode_GND+d_SPSUB_x0_dTemp_Tnode_GND*SPSUB_x0)/(2.0+(SPSUB_x0*SPSUB_x0))/(2.0+(SPSUB_x0*SPSUB_x0)));
d_SPSUB_temp_dV_D_S = (-(SPSUB_x0*d_SPSUB_x0_dV_D_S+d_SPSUB_x0_dV_D_S*SPSUB_x0)/(2.0+(SPSUB_x0*SPSUB_x0))/(2.0+(SPSUB_x0*SPSUB_x0)));
d_SPSUB_temp_dV_G_S = (-(SPSUB_x0*d_SPSUB_x0_dV_G_S+d_SPSUB_x0_dV_G_S*SPSUB_x0)/(2.0+(SPSUB_x0*SPSUB_x0))/(2.0+(SPSUB_x0*SPSUB_x0)));
SPSUB_temp = (1.0/(2.0+(SPSUB_x0*SPSUB_x0)));

d_SPSUB_xi0_dV_S_B = ((SPSUB_x0*SPSUB_x0)*d_SPSUB_temp_dV_S_B+(SPSUB_x0*d_SPSUB_x0_dV_S_B+d_SPSUB_x0_dV_S_B*SPSUB_x0)*SPSUB_temp);
d_SPSUB_xi0_dTemp_Tnode_GND = ((SPSUB_x0*SPSUB_x0)*d_SPSUB_temp_dTemp_Tnode_GND+(SPSUB_x0*d_SPSUB_x0_dTemp_Tnode_GND+d_SPSUB_x0_dTemp_Tnode_GND*SPSUB_x0)*SPSUB_temp);
d_SPSUB_xi0_dV_D_S = ((SPSUB_x0*SPSUB_x0)*d_SPSUB_temp_dV_D_S+(SPSUB_x0*d_SPSUB_x0_dV_D_S+d_SPSUB_x0_dV_D_S*SPSUB_x0)*SPSUB_temp);
d_SPSUB_xi0_dV_G_S = ((SPSUB_x0*SPSUB_x0)*d_SPSUB_temp_dV_G_S+(SPSUB_x0*d_SPSUB_x0_dV_G_S+d_SPSUB_x0_dV_G_S*SPSUB_x0)*SPSUB_temp);
SPSUB_xi0 = ((SPSUB_x0*SPSUB_x0)*SPSUB_temp);

d_SPSUB_xi1_dV_S_B = 4.0*((SPSUB_x0*SPSUB_temp)*d_SPSUB_temp_dV_S_B+(SPSUB_x0*d_SPSUB_temp_dV_S_B+d_SPSUB_x0_dV_S_B*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi1_dTemp_Tnode_GND = 4.0*((SPSUB_x0*SPSUB_temp)*d_SPSUB_temp_dTemp_Tnode_GND+(SPSUB_x0*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_x0_dTemp_Tnode_GND*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi1_dV_D_S = 4.0*((SPSUB_x0*SPSUB_temp)*d_SPSUB_temp_dV_D_S+(SPSUB_x0*d_SPSUB_temp_dV_D_S+d_SPSUB_x0_dV_D_S*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi1_dV_G_S = 4.0*((SPSUB_x0*SPSUB_temp)*d_SPSUB_temp_dV_G_S+(SPSUB_x0*d_SPSUB_temp_dV_G_S+d_SPSUB_x0_dV_G_S*SPSUB_temp)*SPSUB_temp);
SPSUB_xi1 = (4.0*((SPSUB_x0*SPSUB_temp)*SPSUB_temp));

d_SPSUB_xi2_dV_S_B = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dV_S_B+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dV_S_B+(8.0*d_SPSUB_temp_dV_S_B-12.0*d_SPSUB_xi0_dV_S_B)*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi2_dTemp_Tnode_GND = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dTemp_Tnode_GND+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dTemp_Tnode_GND+(8.0*d_SPSUB_temp_dTemp_Tnode_GND-12.0*d_SPSUB_xi0_dTemp_Tnode_GND)*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi2_dV_D_S = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dV_D_S+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dV_D_S+(8.0*d_SPSUB_temp_dV_D_S-12.0*d_SPSUB_xi0_dV_D_S)*SPSUB_temp)*SPSUB_temp);
d_SPSUB_xi2_dV_G_S = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dV_G_S+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dV_G_S+(8.0*d_SPSUB_temp_dV_G_S-12.0*d_SPSUB_xi0_dV_G_S)*SPSUB_temp)*SPSUB_temp);
SPSUB_xi2 = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*SPSUB_temp);

d_SPSUB_temp_dV_S_B = (d_SPSUB_xgb_dV_S_B-d_SPSUB_x0_dV_S_B);
d_SPSUB_temp_dTemp_Tnode_GND = (d_SPSUB_xgb_dTemp_Tnode_GND-d_SPSUB_x0_dTemp_Tnode_GND);
d_SPSUB_temp_dV_D_S = (d_SPSUB_xgb_dV_D_S-d_SPSUB_x0_dV_D_S);
d_SPSUB_temp_dV_G_S = (d_SPSUB_xgb_dV_G_S-d_SPSUB_x0_dV_G_S);
SPSUB_temp = (SPSUB_xgb-SPSUB_x0);

d_SPSUB_pC_dV_S_B = (2.0*d_SPSUB_temp_dV_S_B+Gfsub2*(((-d_SPSUB_delta1_dV_S_B)+d_SPSUB_delta0_dV_S_B)-SPSUB_delta*d_SPSUB_xi1_dV_S_B));
d_SPSUB_pC_dTemp_Tnode_GND = (2.0*d_SPSUB_temp_dTemp_Tnode_GND+Gfsub2*(((-d_SPSUB_delta1_dTemp_Tnode_GND)+d_SPSUB_delta0_dTemp_Tnode_GND)-SPSUB_delta*d_SPSUB_xi1_dTemp_Tnode_GND));
d_SPSUB_pC_dV_D_S = (2.0*d_SPSUB_temp_dV_D_S+Gfsub2*(((-d_SPSUB_delta1_dV_D_S)+d_SPSUB_delta0_dV_D_S)-SPSUB_delta*d_SPSUB_xi1_dV_D_S));
d_SPSUB_pC_dV_G_S = (2.0*d_SPSUB_temp_dV_G_S+Gfsub2*(((-d_SPSUB_delta1_dV_G_S)+d_SPSUB_delta0_dV_G_S)-SPSUB_delta*d_SPSUB_xi1_dV_G_S));
SPSUB_pC = ((2.0*SPSUB_temp)+(Gfsub2*(((1.0-SPSUB_delta1)+SPSUB_delta0)-(SPSUB_delta*(1.0+SPSUB_xi1)))));

d_SPSUB_qC_dV_S_B = ((SPSUB_temp*d_SPSUB_temp_dV_S_B+d_SPSUB_temp_dV_S_B*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta1_dV_S_B+d_SPSUB_x0_dV_S_B)+d_SPSUB_delta0_dV_S_B)-SPSUB_delta*(d_SPSUB_x0_dV_S_B+d_SPSUB_xi0_dV_S_B)));
d_SPSUB_qC_dTemp_Tnode_GND = ((SPSUB_temp*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_temp_dTemp_Tnode_GND*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta1_dTemp_Tnode_GND+d_SPSUB_x0_dTemp_Tnode_GND)+d_SPSUB_delta0_dTemp_Tnode_GND)-SPSUB_delta*(d_SPSUB_x0_dTemp_Tnode_GND+d_SPSUB_xi0_dTemp_Tnode_GND)));
d_SPSUB_qC_dV_D_S = ((SPSUB_temp*d_SPSUB_temp_dV_D_S+d_SPSUB_temp_dV_D_S*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta1_dV_D_S+d_SPSUB_x0_dV_D_S)+d_SPSUB_delta0_dV_D_S)-SPSUB_delta*(d_SPSUB_x0_dV_D_S+d_SPSUB_xi0_dV_D_S)));
d_SPSUB_qC_dV_G_S = ((SPSUB_temp*d_SPSUB_temp_dV_G_S+d_SPSUB_temp_dV_G_S*SPSUB_temp)-Gfsub2*(((d_SPSUB_delta1_dV_G_S+d_SPSUB_x0_dV_G_S)+d_SPSUB_delta0_dV_G_S)-SPSUB_delta*(d_SPSUB_x0_dV_G_S+d_SPSUB_xi0_dV_G_S)));
SPSUB_qC = ((SPSUB_temp*SPSUB_temp)-(Gfsub2*((((SPSUB_delta1+SPSUB_x0)-1.0)+SPSUB_delta0)-(SPSUB_delta*((SPSUB_x0+1.0)+SPSUB_xi0)))));

d_SPSUB_temp_dV_S_B = (-Gfsub2*((d_SPSUB_delta1_dV_S_B+d_SPSUB_delta0_dV_S_B)-SPSUB_delta*d_SPSUB_xi2_dV_S_B));
d_SPSUB_temp_dTemp_Tnode_GND = (-Gfsub2*((d_SPSUB_delta1_dTemp_Tnode_GND+d_SPSUB_delta0_dTemp_Tnode_GND)-SPSUB_delta*d_SPSUB_xi2_dTemp_Tnode_GND));
d_SPSUB_temp_dV_D_S = (-Gfsub2*((d_SPSUB_delta1_dV_D_S+d_SPSUB_delta0_dV_D_S)-SPSUB_delta*d_SPSUB_xi2_dV_D_S));
d_SPSUB_temp_dV_G_S = (-Gfsub2*((d_SPSUB_delta1_dV_G_S+d_SPSUB_delta0_dV_G_S)-SPSUB_delta*d_SPSUB_xi2_dV_G_S));
SPSUB_temp = (2.0-(Gfsub2*((SPSUB_delta1+SPSUB_delta0)-(SPSUB_delta*SPSUB_xi2))));

d_SPSUB_temp_dV_S_B = ((SPSUB_pC*d_SPSUB_pC_dV_S_B+d_SPSUB_pC_dV_S_B*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dV_S_B+d_SPSUB_qC_dV_S_B*SPSUB_temp));
d_SPSUB_temp_dTemp_Tnode_GND = ((SPSUB_pC*d_SPSUB_pC_dTemp_Tnode_GND+d_SPSUB_pC_dTemp_Tnode_GND*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dTemp_Tnode_GND+d_SPSUB_qC_dTemp_Tnode_GND*SPSUB_temp));
d_SPSUB_temp_dV_D_S = ((SPSUB_pC*d_SPSUB_pC_dV_D_S+d_SPSUB_pC_dV_D_S*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dV_D_S+d_SPSUB_qC_dV_D_S*SPSUB_temp));
d_SPSUB_temp_dV_G_S = ((SPSUB_pC*d_SPSUB_pC_dV_G_S+d_SPSUB_pC_dV_G_S*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dV_G_S+d_SPSUB_qC_dV_G_S*SPSUB_temp));
SPSUB_temp = ((SPSUB_pC*SPSUB_pC)-(2.0*(SPSUB_qC*SPSUB_temp)));
{
double value_sqrt_0 = sqrt(SPSUB_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp3_dV_S_B = (d_SPSUB_x0_dV_S_B+2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dV_S_B-SPSUB_qC*(d_SPSUB_pC_dV_S_B+(deriv_sqrt_0_d0*(d_SPSUB_temp_dV_S_B))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
d_temp3_dTemp_Tnode_GND = (d_SPSUB_x0_dTemp_Tnode_GND+2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dTemp_Tnode_GND-SPSUB_qC*(d_SPSUB_pC_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SPSUB_temp_dTemp_Tnode_GND))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
d_temp3_dV_D_S = (d_SPSUB_x0_dV_D_S+2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dV_D_S-SPSUB_qC*(d_SPSUB_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SPSUB_temp_dV_D_S))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
d_temp3_dV_G_S = (d_SPSUB_x0_dV_G_S+2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dV_G_S-SPSUB_qC*(d_SPSUB_pC_dV_G_S+(deriv_sqrt_0_d0*(d_SPSUB_temp_dV_G_S))))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
temp3 = (SPSUB_x0+(2.0*(SPSUB_qC/(SPSUB_pC+value_sqrt_0))));
}
}
}

d_xg2eff_dV_S_B = (temp*(d_temp3_dV_S_B+d_temp2_dV_S_B)+d_temp_dV_S_B*(temp3+temp2));
d_xg2eff_dV_D_S = (temp*(d_temp3_dV_D_S+d_temp2_dV_D_S)+d_temp_dV_D_S*(temp3+temp2));
d_xg2eff_dV_G_S = (temp*(d_temp3_dV_G_S+d_temp2_dV_G_S)+d_temp_dV_G_S*(temp3+temp2));
d_xg2eff_dTemp_Tnode_GND = (temp*(d_temp3_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND)+d_temp_dTemp_Tnode_GND*(temp3+temp2));
xg2eff = (temp*(temp3+temp2));
}
else
{

d_xg2eff_dV_G_S =  0.0;
d_xg2eff_dTemp_Tnode_GND = d_xg20_dTemp_Tnode_GND;
d_xg2eff_dV_S_B = d_xg20_dV_S_B;
d_xg2eff_dV_D_S = d_xg20_dV_D_S;
xg2eff = xg20;
}

d_temp_dV_S_B = keq_1D*(-d_xg2eff_dV_S_B);
d_temp_dTemp_Tnode_GND = keq_1D*(d_xg10_dTemp_Tnode_GND-d_xg2eff_dTemp_Tnode_GND);
d_temp_dV_D_S = keq_1D*(d_xg10_dV_D_S-d_xg2eff_dV_D_S);
d_temp_dV_G_S = keq_1D*(d_xg10_dV_G_S-d_xg2eff_dV_G_S);
temp = (keq_1D*(xg10-xg2eff));
if (((model_.QMC)>0.0))
{
{
double value_sqrt_0 = sqrt((((temp-15.0)*(temp-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_e1_dTemp_Tnode_GND = 0.5*(d_temp_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(((temp-15.0)*d_temp_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*(temp-15.0)))));
d_e1_dV_S_B = 0.5*(d_temp_dV_S_B+(deriv_sqrt_0_d0*(((temp-15.0)*d_temp_dV_S_B+d_temp_dV_S_B*(temp-15.0)))));
d_e1_dV_D_S = 0.5*(d_temp_dV_D_S+(deriv_sqrt_0_d0*(((temp-15.0)*d_temp_dV_D_S+d_temp_dV_D_S*(temp-15.0)))));
d_e1_dV_G_S = 0.5*(d_temp_dV_G_S+(deriv_sqrt_0_d0*(((temp-15.0)*d_temp_dV_G_S+d_temp_dV_G_S*(temp-15.0)))));
e1 = (0.5*((temp+15.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((-temp)-15.0)*((-temp)-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_e2_dTemp_Tnode_GND = 0.5*((-d_temp_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((-temp)-15.0)*(-d_temp_dTemp_Tnode_GND)+(-d_temp_dTemp_Tnode_GND)*((-temp)-15.0)))));
d_e2_dV_S_B = 0.5*((-d_temp_dV_S_B)+(deriv_sqrt_0_d0*((((-temp)-15.0)*(-d_temp_dV_S_B)+(-d_temp_dV_S_B)*((-temp)-15.0)))));
d_e2_dV_D_S = 0.5*((-d_temp_dV_D_S)+(deriv_sqrt_0_d0*((((-temp)-15.0)*(-d_temp_dV_D_S)+(-d_temp_dV_D_S)*((-temp)-15.0)))));
d_e2_dV_G_S = 0.5*((-d_temp_dV_G_S)+(deriv_sqrt_0_d0*((((-temp)-15.0)*(-d_temp_dV_G_S)+(-d_temp_dV_G_S)*((-temp)-15.0)))));
e2 = (0.5*(((-temp)+15.0)+value_sqrt_0));
}
{
double value_log_0 = log(e1);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e1);
double  deriv_exp_1_d0 = value_exp_1;

d_temp1_dV_S_B = qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e1_dV_S_B))));
d_temp1_dV_D_S = qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e1_dV_D_S))));
d_temp1_dV_G_S = qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e1_dV_G_S))));
d_temp1_dTemp_Tnode_GND = (qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e1_dTemp_Tnode_GND))))+d_qq_dTemp_Tnode_GND*value_exp_1);
temp1 = (qq*value_exp_1);
}
{
double value_log_0 = log(e2);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e2);
double  deriv_exp_1_d0 = value_exp_1;

d_temp2_dV_S_B = qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e2_dV_S_B))));
d_temp2_dV_D_S = qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e2_dV_D_S))));
d_temp2_dV_G_S = qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e2_dV_G_S))));
d_temp2_dTemp_Tnode_GND = (qq*(deriv_exp_1_d0*((-0.3333333333333)*(deriv_log_0_d0*(d_e2_dTemp_Tnode_GND))))+d_qq_dTemp_Tnode_GND*value_exp_1);
temp2 = (qq*value_exp_1);
}

d_temp3_dTemp_Tnode_GND = ((-d_temp1_dTemp_Tnode_GND)-d_temp2_dTemp_Tnode_GND);
d_temp3_dV_D_S = ((-d_temp1_dV_D_S)-d_temp2_dV_D_S);
d_temp3_dV_G_S = ((-d_temp1_dV_G_S)-d_temp2_dV_G_S);
d_temp3_dV_S_B = ((-d_temp1_dV_S_B)-d_temp2_dV_S_B);
temp3 = ((1.0-temp1)-temp2);

d_CsiPrime_dV_S_B = (-CsiPrime_0*d_temp3_dV_S_B/temp3/temp3);
d_CsiPrime_dTemp_Tnode_GND = (-CsiPrime_0*d_temp3_dTemp_Tnode_GND/temp3/temp3);
d_CsiPrime_dV_D_S = (-CsiPrime_0*d_temp3_dV_D_S/temp3/temp3);
d_CsiPrime_dV_G_S = (-CsiPrime_0*d_temp3_dV_G_S/temp3/temp3);
CsiPrime = (CsiPrime_0/temp3);

d_tox1fact_dTemp_Tnode_GND = k1_1D*d_temp1_dTemp_Tnode_GND;
d_tox1fact_dV_D_S = k1_1D*d_temp1_dV_D_S;
d_tox1fact_dV_G_S = k1_1D*d_temp1_dV_G_S;
d_tox1fact_dV_S_B = k1_1D*d_temp1_dV_S_B;
tox1fact = (1.0+(k1_1D*temp1));

d_tox2fact_dV_S_B = k2_1D*d_temp2_dV_S_B;
d_tox2fact_dV_D_S = k2_1D*d_temp2_dV_D_S;
d_tox2fact_dTemp_Tnode_GND = k2_1D*d_temp2_dTemp_Tnode_GND;
d_tox2fact_dV_G_S = k2_1D*d_temp2_dV_G_S;
tox2fact = (1.0+(k2_1D*temp2));

d_k1_1D_QM_dV_S_B = ((tox1fact*k1_1D*d_temp3_dV_S_B-(k1_1D*temp3)*d_tox1fact_dV_S_B)/tox1fact/tox1fact);
d_k1_1D_QM_dTemp_Tnode_GND = ((tox1fact*k1_1D*d_temp3_dTemp_Tnode_GND-(k1_1D*temp3)*d_tox1fact_dTemp_Tnode_GND)/tox1fact/tox1fact);
d_k1_1D_QM_dV_D_S = ((tox1fact*k1_1D*d_temp3_dV_D_S-(k1_1D*temp3)*d_tox1fact_dV_D_S)/tox1fact/tox1fact);
d_k1_1D_QM_dV_G_S = ((tox1fact*k1_1D*d_temp3_dV_G_S-(k1_1D*temp3)*d_tox1fact_dV_G_S)/tox1fact/tox1fact);
k1_1D_QM = ((k1_1D*temp3)/tox1fact);

d_k2_1D_QM_dV_S_B = ((tox2fact*k2_1D*d_temp3_dV_S_B-(k2_1D*temp3)*d_tox2fact_dV_S_B)/tox2fact/tox2fact);
d_k2_1D_QM_dTemp_Tnode_GND = ((tox2fact*k2_1D*d_temp3_dTemp_Tnode_GND-(k2_1D*temp3)*d_tox2fact_dTemp_Tnode_GND)/tox2fact/tox2fact);
d_k2_1D_QM_dV_D_S = ((tox2fact*k2_1D*d_temp3_dV_D_S-(k2_1D*temp3)*d_tox2fact_dV_D_S)/tox2fact/tox2fact);
d_k2_1D_QM_dV_G_S = ((tox2fact*k2_1D*d_temp3_dV_G_S-(k2_1D*temp3)*d_tox2fact_dV_G_S)/tox2fact/tox2fact);
k2_1D_QM = ((k2_1D*temp3)/tox2fact);

d_keq_1D_QM_dV_S_B = (-((-d_k1_1D_QM_dV_S_B/k1_1D_QM/k1_1D_QM)+(-d_k2_1D_QM_dV_S_B/k2_1D_QM/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM)));
d_keq_1D_QM_dTemp_Tnode_GND = (-((-d_k1_1D_QM_dTemp_Tnode_GND/k1_1D_QM/k1_1D_QM)+(-d_k2_1D_QM_dTemp_Tnode_GND/k2_1D_QM/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM)));
d_keq_1D_QM_dV_D_S = (-((-d_k1_1D_QM_dV_D_S/k1_1D_QM/k1_1D_QM)+(-d_k2_1D_QM_dV_D_S/k2_1D_QM/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM)));
d_keq_1D_QM_dV_G_S = (-((-d_k1_1D_QM_dV_G_S/k1_1D_QM/k1_1D_QM)+(-d_k2_1D_QM_dV_G_S/k2_1D_QM/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM)));
keq_1D_QM = (1.0/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM)));

d_tox1fact_dV_S_B = (k1_1D_QM*d_temp1_dV_S_B+d_k1_1D_QM_dV_S_B*temp1);
d_tox1fact_dTemp_Tnode_GND = (k1_1D_QM*d_temp1_dTemp_Tnode_GND+d_k1_1D_QM_dTemp_Tnode_GND*temp1);
d_tox1fact_dV_D_S = (k1_1D_QM*d_temp1_dV_D_S+d_k1_1D_QM_dV_D_S*temp1);
d_tox1fact_dV_G_S = (k1_1D_QM*d_temp1_dV_G_S+d_k1_1D_QM_dV_G_S*temp1);
tox1fact = (1.0+(k1_1D_QM*temp1));

d_tox2fact_dV_S_B = (k2_1D_QM*d_temp2_dV_S_B+d_k2_1D_QM_dV_S_B*temp2);
d_tox2fact_dTemp_Tnode_GND = (k2_1D_QM*d_temp2_dTemp_Tnode_GND+d_k2_1D_QM_dTemp_Tnode_GND*temp2);
d_tox2fact_dV_D_S = (k2_1D_QM*d_temp2_dV_D_S+d_k2_1D_QM_dV_D_S*temp2);
d_tox2fact_dV_G_S = (k2_1D_QM*d_temp2_dV_G_S+d_k2_1D_QM_dV_G_S*temp2);
tox2fact = (1.0+(k2_1D_QM*temp2));
}
else
{

d_CsiPrime_dV_G_S = d_CsiPrime_dV_D_S = d_CsiPrime_dTemp_Tnode_GND = d_CsiPrime_dV_S_B =  0.0;
CsiPrime = CsiPrime_0;

d_k1_1D_QM_dV_G_S = d_k1_1D_QM_dV_D_S = d_k1_1D_QM_dTemp_Tnode_GND = d_k1_1D_QM_dV_S_B =  0.0;
k1_1D_QM = k1_1D;

d_k2_1D_QM_dV_G_S = d_k2_1D_QM_dV_D_S = d_k2_1D_QM_dTemp_Tnode_GND = d_k2_1D_QM_dV_S_B =  0.0;
k2_1D_QM = k2_1D;

d_keq_1D_QM_dV_G_S = d_keq_1D_QM_dV_D_S = d_keq_1D_QM_dTemp_Tnode_GND = d_keq_1D_QM_dV_S_B =  0.0;
keq_1D_QM = keq_1D;

d_tox1fact_dV_S_B = d_tox1fact_dV_G_S = d_tox1fact_dV_D_S = d_tox1fact_dTemp_Tnode_GND =  0.0;
tox1fact = 1.0;

d_tox2fact_dV_G_S = d_tox2fact_dTemp_Tnode_GND = d_tox2fact_dV_D_S = d_tox2fact_dV_S_B =  0.0;
tox2fact = 1.0;
}

d_Dx_WI_1D_dV_S_B = (keq_1D_QM*(-d_xg2eff_dV_S_B)+d_keq_1D_QM_dV_S_B*(xg10-xg2eff));
d_Dx_WI_1D_dTemp_Tnode_GND = (keq_1D_QM*(d_xg10_dTemp_Tnode_GND-d_xg2eff_dTemp_Tnode_GND)+d_keq_1D_QM_dTemp_Tnode_GND*(xg10-xg2eff));
d_Dx_WI_1D_dV_D_S = (keq_1D_QM*(d_xg10_dV_D_S-d_xg2eff_dV_D_S)+d_keq_1D_QM_dV_D_S*(xg10-xg2eff));
d_Dx_WI_1D_dV_G_S = (keq_1D_QM*(d_xg10_dV_G_S-d_xg2eff_dV_G_S)+d_keq_1D_QM_dV_G_S*(xg10-xg2eff));
Dx_WI_1D = (keq_1D_QM*(xg10-xg2eff));
if ((Dx_WI_1D>0.0))
{
if (((-Dx_WI_1D)<80.0))
{
{
double value_exp_0 = exp((-Dx_WI_1D));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_Dx_WI_1D_dV_S_B)))));
d_temp_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_Dx_WI_1D_dTemp_Tnode_GND)))));
d_temp_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_Dx_WI_1D_dV_D_S)))));
d_temp_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_Dx_WI_1D_dV_G_S)))));
temp = value_log_1;
}
}
else
{

d_temp_dV_S_B = (-d_Dx_WI_1D_dV_S_B);
d_temp_dTemp_Tnode_GND = (-d_Dx_WI_1D_dTemp_Tnode_GND);
d_temp_dV_D_S = (-d_Dx_WI_1D_dV_D_S);
d_temp_dV_G_S = (-d_Dx_WI_1D_dV_G_S);
temp = (-Dx_WI_1D);
}

d_x_WI_1D_dV_S_B = ((-((k1_1D_QM*d_Dx_WI_1D_dV_S_B-Dx_WI_1D*d_k1_1D_QM_dV_S_B)/k1_1D_QM/k1_1D_QM))+d_temp_dV_S_B);
d_x_WI_1D_dTemp_Tnode_GND = ((d_xg10_dTemp_Tnode_GND-((k1_1D_QM*d_Dx_WI_1D_dTemp_Tnode_GND-Dx_WI_1D*d_k1_1D_QM_dTemp_Tnode_GND)/k1_1D_QM/k1_1D_QM))+d_temp_dTemp_Tnode_GND);
d_x_WI_1D_dV_D_S = ((d_xg10_dV_D_S-((k1_1D_QM*d_Dx_WI_1D_dV_D_S-Dx_WI_1D*d_k1_1D_QM_dV_D_S)/k1_1D_QM/k1_1D_QM))+d_temp_dV_D_S);
d_x_WI_1D_dV_G_S = ((d_xg10_dV_G_S-((k1_1D_QM*d_Dx_WI_1D_dV_G_S-Dx_WI_1D*d_k1_1D_QM_dV_G_S)/k1_1D_QM/k1_1D_QM))+d_temp_dV_G_S);
x_WI_1D = (((xg10-(Dx_WI_1D/k1_1D_QM))+temp)-0.6931471805599);
}
else
{
if ((Dx_WI_1D<80.0))
{
{
double value_exp_0 = exp(Dx_WI_1D);
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*(d_Dx_WI_1D_dV_S_B))));
d_temp_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*(d_Dx_WI_1D_dTemp_Tnode_GND))));
d_temp_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*(d_Dx_WI_1D_dV_D_S))));
d_temp_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*(d_Dx_WI_1D_dV_G_S))));
temp = value_log_1;
}
}
else
{

d_temp_dV_S_B = d_Dx_WI_1D_dV_S_B;
d_temp_dTemp_Tnode_GND = d_Dx_WI_1D_dTemp_Tnode_GND;
d_temp_dV_D_S = d_Dx_WI_1D_dV_D_S;
d_temp_dV_G_S = d_Dx_WI_1D_dV_G_S;
temp = Dx_WI_1D;
}

d_x_WI_1D_dV_S_B = ((d_xg2eff_dV_S_B+((k2_1D_QM*d_Dx_WI_1D_dV_S_B-Dx_WI_1D*d_k2_1D_QM_dV_S_B)/k2_1D_QM/k2_1D_QM))+d_temp_dV_S_B);
d_x_WI_1D_dV_D_S = ((d_xg2eff_dV_D_S+((k2_1D_QM*d_Dx_WI_1D_dV_D_S-Dx_WI_1D*d_k2_1D_QM_dV_D_S)/k2_1D_QM/k2_1D_QM))+d_temp_dV_D_S);
d_x_WI_1D_dV_G_S = ((d_xg2eff_dV_G_S+((k2_1D_QM*d_Dx_WI_1D_dV_G_S-Dx_WI_1D*d_k2_1D_QM_dV_G_S)/k2_1D_QM/k2_1D_QM))+d_temp_dV_G_S);
d_x_WI_1D_dTemp_Tnode_GND = ((d_xg2eff_dTemp_Tnode_GND+((k2_1D_QM*d_Dx_WI_1D_dTemp_Tnode_GND-Dx_WI_1D*d_k2_1D_QM_dTemp_Tnode_GND)/k2_1D_QM/k2_1D_QM))+d_temp_dTemp_Tnode_GND);
x_WI_1D = (((xg2eff+(Dx_WI_1D/k2_1D_QM))+temp)-0.6931471805599);
}
{
double value_sqrt_0 = sqrt((((x_WI_1D-xth_1D)*(x_WI_1D-xth_1D))+4.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_1D_dV_S_B = 0.5*(d_x_WI_1D_dV_S_B-(deriv_sqrt_0_d0*(((x_WI_1D-xth_1D)*d_x_WI_1D_dV_S_B+d_x_WI_1D_dV_S_B*(x_WI_1D-xth_1D)))));
d_x_1D_dTemp_Tnode_GND = 0.5*((d_x_WI_1D_dTemp_Tnode_GND+d_xth_1D_dTemp_Tnode_GND)-(deriv_sqrt_0_d0*(((x_WI_1D-xth_1D)*(d_x_WI_1D_dTemp_Tnode_GND-d_xth_1D_dTemp_Tnode_GND)+(d_x_WI_1D_dTemp_Tnode_GND-d_xth_1D_dTemp_Tnode_GND)*(x_WI_1D-xth_1D)))));
d_x_1D_dV_D_S = 0.5*(d_x_WI_1D_dV_D_S-(deriv_sqrt_0_d0*(((x_WI_1D-xth_1D)*d_x_WI_1D_dV_D_S+d_x_WI_1D_dV_D_S*(x_WI_1D-xth_1D)))));
d_x_1D_dV_G_S = 0.5*(d_x_WI_1D_dV_G_S-(deriv_sqrt_0_d0*(((x_WI_1D-xth_1D)*d_x_WI_1D_dV_G_S+d_x_WI_1D_dV_G_S*(x_WI_1D-xth_1D)))));
x_1D = (0.5*((x_WI_1D+xth_1D)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+((2.0*(xth_1D-x_1D))/xSDdep)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_dleff_dV_S_B = (deriv_sqrt_0_d0*((2.0*(-d_x_1D_dV_S_B)/xSDdep)));
d_dleff_dV_D_S = (deriv_sqrt_0_d0*((2.0*(-d_x_1D_dV_D_S)/xSDdep)));
d_dleff_dV_G_S = (deriv_sqrt_0_d0*((2.0*(-d_x_1D_dV_G_S)/xSDdep)));
d_dleff_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((xSDdep*2.0*(d_xth_1D_dTemp_Tnode_GND-d_x_1D_dTemp_Tnode_GND)-(2.0*(xth_1D-x_1D))*d_xSDdep_dTemp_Tnode_GND)/xSDdep/xSDdep)));
dleff = (value_sqrt_0-1.0);
}

d_xedge_dV_S_B = (d_x_1D_dV_S_B+xSDdep*d_dleff_dV_S_B);
d_xedge_dTemp_Tnode_GND = (d_x_1D_dTemp_Tnode_GND+(xSDdep*d_dleff_dTemp_Tnode_GND+d_xSDdep_dTemp_Tnode_GND*dleff));
d_xedge_dV_D_S = (d_x_1D_dV_D_S+xSDdep*d_dleff_dV_D_S);
d_xedge_dV_G_S = (d_x_1D_dV_G_S+xSDdep*d_dleff_dV_G_S);
xedge = (x_1D+(xSDdep*dleff));
{
double value_sqrt_0 = sqrt(((((1.0+(PSCEDLB_i*xg20))-0.5)*((1.0+(PSCEDLB_i*xg20))-0.5))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_G_S =  0.0;
d_temp_dTemp_Tnode_GND = 0.5*(PSCEDLB_i*d_xg20_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((((1.0+(PSCEDLB_i*xg20))-0.5)*PSCEDLB_i*d_xg20_dTemp_Tnode_GND+PSCEDLB_i*d_xg20_dTemp_Tnode_GND*((1.0+(PSCEDLB_i*xg20))-0.5)))));
d_temp_dV_S_B = 0.5*(PSCEDLB_i*d_xg20_dV_S_B+(deriv_sqrt_0_d0*((((1.0+(PSCEDLB_i*xg20))-0.5)*PSCEDLB_i*d_xg20_dV_S_B+PSCEDLB_i*d_xg20_dV_S_B*((1.0+(PSCEDLB_i*xg20))-0.5)))));
d_temp_dV_D_S = 0.5*(PSCEDLB_i*d_xg20_dV_D_S+(deriv_sqrt_0_d0*((((1.0+(PSCEDLB_i*xg20))-0.5)*PSCEDLB_i*d_xg20_dV_D_S+PSCEDLB_i*d_xg20_dV_D_S*((1.0+(PSCEDLB_i*xg20))-0.5)))));
temp = (0.5*(((1.0+(PSCEDLB_i*xg20))+0.5)+value_sqrt_0));
}

d_sce1_dTemp_Tnode_GND = (-PSCE1_i*d_temp_dTemp_Tnode_GND/(1.0+(PSCE1_i*temp))/(1.0+(PSCE1_i*temp)));
d_sce1_dV_S_B = (-PSCE1_i*d_temp_dV_S_B/(1.0+(PSCE1_i*temp))/(1.0+(PSCE1_i*temp)));
d_sce1_dV_D_S = (-PSCE1_i*d_temp_dV_D_S/(1.0+(PSCE1_i*temp))/(1.0+(PSCE1_i*temp)));
d_sce1_dV_G_S = (-PSCE1_i*d_temp_dV_G_S/(1.0+(PSCE1_i*temp))/(1.0+(PSCE1_i*temp)));
sce1 = (1.0/(1.0+(PSCE1_i*temp)));

d_sce2_dTemp_Tnode_GND = (-PSCE2_i*d_temp_dTemp_Tnode_GND/(1.0+(PSCE2_i*temp))/(1.0+(PSCE2_i*temp)));
d_sce2_dV_S_B = (-PSCE2_i*d_temp_dV_S_B/(1.0+(PSCE2_i*temp))/(1.0+(PSCE2_i*temp)));
d_sce2_dV_D_S = (-PSCE2_i*d_temp_dV_D_S/(1.0+(PSCE2_i*temp))/(1.0+(PSCE2_i*temp)));
d_sce2_dV_G_S = (-PSCE2_i*d_temp_dV_G_S/(1.0+(PSCE2_i*temp))/(1.0+(PSCE2_i*temp)));
sce2 = (1.0/(1.0+(PSCE2_i*temp)));
{
double value_sqrt_0 = sqrt((1.0+(xdsx/xd0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_B = ((((2.0*xd0)*(value_sqrt_0-1.0))*(1.0+(CFDL_i*dleff)))*CFDLB_i*d_xg20_dV_S_B+((2.0*xd0)*(value_sqrt_0-1.0))*CFDL_i*d_dleff_dV_S_B*(1.0+(CFDLB_i*xg20)));
d_temp_dV_G_S = ((2.0*xd0)*(value_sqrt_0-1.0))*CFDL_i*d_dleff_dV_G_S*(1.0+(CFDLB_i*xg20));
d_temp_dV_D_S = ((((2.0*xd0)*(value_sqrt_0-1.0))*(1.0+(CFDL_i*dleff)))*CFDLB_i*d_xg20_dV_D_S+(((2.0*xd0)*(value_sqrt_0-1.0))*CFDL_i*d_dleff_dV_D_S+(2.0*xd0)*(deriv_sqrt_0_d0*((d_xdsx_dV_D_S/xd0)))*(1.0+(CFDL_i*dleff)))*(1.0+(CFDLB_i*xg20)));
d_temp_dTemp_Tnode_GND = ((((2.0*xd0)*(value_sqrt_0-1.0))*(1.0+(CFDL_i*dleff)))*CFDLB_i*d_xg20_dTemp_Tnode_GND+(((2.0*xd0)*(value_sqrt_0-1.0))*CFDL_i*d_dleff_dTemp_Tnode_GND+((2.0*xd0)*(deriv_sqrt_0_d0*(((xd0*d_xdsx_dTemp_Tnode_GND-xdsx*d_xd0_dTemp_Tnode_GND)/xd0/xd0)))+2.0*d_xd0_dTemp_Tnode_GND*(value_sqrt_0-1.0))*(1.0+(CFDL_i*dleff)))*(1.0+(CFDLB_i*xg20)));
temp = ((((2.0*xd0)*(value_sqrt_0-1.0))*(1.0+(CFDL_i*dleff)))*(1.0+(CFDLB_i*xg20)));
}

d_dxg1_dibl_dV_S_B = CF1_i*d_temp_dV_S_B;
d_dxg1_dibl_dV_D_S = CF1_i*d_temp_dV_D_S;
d_dxg1_dibl_dV_G_S = CF1_i*d_temp_dV_G_S;
d_dxg1_dibl_dTemp_Tnode_GND = (CF1_i*d_temp_dTemp_Tnode_GND+d_CF1_i_dTemp_Tnode_GND*temp);
dxg1_dibl = (CF1_i*temp);

d_dxg2_dibl_dV_S_B = CF2_i*d_temp_dV_S_B;
d_dxg2_dibl_dV_D_S = CF2_i*d_temp_dV_D_S;
d_dxg2_dibl_dV_G_S = CF2_i*d_temp_dV_G_S;
d_dxg2_dibl_dTemp_Tnode_GND = (CF2_i*d_temp_dTemp_Tnode_GND+d_CF2_i_dTemp_Tnode_GND*temp);
dxg2_dibl = (CF2_i*temp);

d_xg1_dV_S_B = ((((xg10-xedge)+dxg1_dibl)*d_sce1_dV_S_B+((-d_xedge_dV_S_B)+d_dxg1_dibl_dV_S_B)*sce1)+d_xedge_dV_S_B);
d_xg1_dTemp_Tnode_GND = (((((xg10-xedge)+dxg1_dibl)*d_sce1_dTemp_Tnode_GND+((d_xg10_dTemp_Tnode_GND-d_xedge_dTemp_Tnode_GND)+d_dxg1_dibl_dTemp_Tnode_GND)*sce1)+d_xedge_dTemp_Tnode_GND)+d_dxdsx_dTemp_Tnode_GND);
d_xg1_dV_D_S = (((((xg10-xedge)+dxg1_dibl)*d_sce1_dV_D_S+((d_xg10_dV_D_S-d_xedge_dV_D_S)+d_dxg1_dibl_dV_D_S)*sce1)+d_xedge_dV_D_S)+d_dxdsx_dV_D_S);
d_xg1_dV_G_S = ((((xg10-xedge)+dxg1_dibl)*d_sce1_dV_G_S+((d_xg10_dV_G_S-d_xedge_dV_G_S)+d_dxg1_dibl_dV_G_S)*sce1)+d_xedge_dV_G_S);
xg1 = (((((xg10-xedge)+dxg1_dibl)*sce1)+xedge)+dxdsx);

d_xg2_dV_S_B = ((((xg2eff-xedge)+dxg2_dibl)*d_sce2_dV_S_B+((d_xg2eff_dV_S_B-d_xedge_dV_S_B)+d_dxg2_dibl_dV_S_B)*sce2)+d_xedge_dV_S_B);
d_xg2_dV_D_S = (((((xg2eff-xedge)+dxg2_dibl)*d_sce2_dV_D_S+((d_xg2eff_dV_D_S-d_xedge_dV_D_S)+d_dxg2_dibl_dV_D_S)*sce2)+d_xedge_dV_D_S)+d_dxdsx_dV_D_S);
d_xg2_dV_G_S = ((((xg2eff-xedge)+dxg2_dibl)*d_sce2_dV_G_S+((d_xg2eff_dV_G_S-d_xedge_dV_G_S)+d_dxg2_dibl_dV_G_S)*sce2)+d_xedge_dV_G_S);
d_xg2_dTemp_Tnode_GND = (((((xg2eff-xedge)+dxg2_dibl)*d_sce2_dTemp_Tnode_GND+((d_xg2eff_dTemp_Tnode_GND-d_xedge_dTemp_Tnode_GND)+d_dxg2_dibl_dTemp_Tnode_GND)*sce2)+d_xedge_dTemp_Tnode_GND)+d_dxdsx_dTemp_Tnode_GND);
xg2 = (((((xg2eff-xedge)+dxg2_dibl)*sce2)+xedge)+dxdsx);
{
double value_sqrt_0 = sqrt(((((xg2+(CIC1_i*(xg1-xg2)))-600.0)*((xg2+(CIC1_i*(xg1-xg2)))-600.0))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xg1x_dV_S_B = 0.5*((d_xg2_dV_S_B+CIC1_i*(d_xg1_dV_S_B-d_xg2_dV_S_B))-(deriv_sqrt_0_d0*((((xg2+(CIC1_i*(xg1-xg2)))-600.0)*(d_xg2_dV_S_B+CIC1_i*(d_xg1_dV_S_B-d_xg2_dV_S_B))+(d_xg2_dV_S_B+CIC1_i*(d_xg1_dV_S_B-d_xg2_dV_S_B))*((xg2+(CIC1_i*(xg1-xg2)))-600.0)))));
d_xg1x_dV_D_S = 0.5*((d_xg2_dV_D_S+CIC1_i*(d_xg1_dV_D_S-d_xg2_dV_D_S))-(deriv_sqrt_0_d0*((((xg2+(CIC1_i*(xg1-xg2)))-600.0)*(d_xg2_dV_D_S+CIC1_i*(d_xg1_dV_D_S-d_xg2_dV_D_S))+(d_xg2_dV_D_S+CIC1_i*(d_xg1_dV_D_S-d_xg2_dV_D_S))*((xg2+(CIC1_i*(xg1-xg2)))-600.0)))));
d_xg1x_dV_G_S = 0.5*((d_xg2_dV_G_S+CIC1_i*(d_xg1_dV_G_S-d_xg2_dV_G_S))-(deriv_sqrt_0_d0*((((xg2+(CIC1_i*(xg1-xg2)))-600.0)*(d_xg2_dV_G_S+CIC1_i*(d_xg1_dV_G_S-d_xg2_dV_G_S))+(d_xg2_dV_G_S+CIC1_i*(d_xg1_dV_G_S-d_xg2_dV_G_S))*((xg2+(CIC1_i*(xg1-xg2)))-600.0)))));
d_xg1x_dTemp_Tnode_GND = 0.5*((d_xg2_dTemp_Tnode_GND+CIC1_i*(d_xg1_dTemp_Tnode_GND-d_xg2_dTemp_Tnode_GND))-(deriv_sqrt_0_d0*((((xg2+(CIC1_i*(xg1-xg2)))-600.0)*(d_xg2_dTemp_Tnode_GND+CIC1_i*(d_xg1_dTemp_Tnode_GND-d_xg2_dTemp_Tnode_GND))+(d_xg2_dTemp_Tnode_GND+CIC1_i*(d_xg1_dTemp_Tnode_GND-d_xg2_dTemp_Tnode_GND))*((xg2+(CIC1_i*(xg1-xg2)))-600.0)))));
xg1x = (0.5*(((xg2+(CIC1_i*(xg1-xg2)))+600.0)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((xg1+(CIC2_i*(xg2-xg1)))-600.0)*((xg1+(CIC2_i*(xg2-xg1)))-600.0))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xg2x_dV_S_B = 0.5*((d_xg1_dV_S_B+CIC2_i*(d_xg2_dV_S_B-d_xg1_dV_S_B))-(deriv_sqrt_0_d0*((((xg1+(CIC2_i*(xg2-xg1)))-600.0)*(d_xg1_dV_S_B+CIC2_i*(d_xg2_dV_S_B-d_xg1_dV_S_B))+(d_xg1_dV_S_B+CIC2_i*(d_xg2_dV_S_B-d_xg1_dV_S_B))*((xg1+(CIC2_i*(xg2-xg1)))-600.0)))));
d_xg2x_dTemp_Tnode_GND = 0.5*((d_xg1_dTemp_Tnode_GND+CIC2_i*(d_xg2_dTemp_Tnode_GND-d_xg1_dTemp_Tnode_GND))-(deriv_sqrt_0_d0*((((xg1+(CIC2_i*(xg2-xg1)))-600.0)*(d_xg1_dTemp_Tnode_GND+CIC2_i*(d_xg2_dTemp_Tnode_GND-d_xg1_dTemp_Tnode_GND))+(d_xg1_dTemp_Tnode_GND+CIC2_i*(d_xg2_dTemp_Tnode_GND-d_xg1_dTemp_Tnode_GND))*((xg1+(CIC2_i*(xg2-xg1)))-600.0)))));
d_xg2x_dV_D_S = 0.5*((d_xg1_dV_D_S+CIC2_i*(d_xg2_dV_D_S-d_xg1_dV_D_S))-(deriv_sqrt_0_d0*((((xg1+(CIC2_i*(xg2-xg1)))-600.0)*(d_xg1_dV_D_S+CIC2_i*(d_xg2_dV_D_S-d_xg1_dV_D_S))+(d_xg1_dV_D_S+CIC2_i*(d_xg2_dV_D_S-d_xg1_dV_D_S))*((xg1+(CIC2_i*(xg2-xg1)))-600.0)))));
d_xg2x_dV_G_S = 0.5*((d_xg1_dV_G_S+CIC2_i*(d_xg2_dV_G_S-d_xg1_dV_G_S))-(deriv_sqrt_0_d0*((((xg1+(CIC2_i*(xg2-xg1)))-600.0)*(d_xg1_dV_G_S+CIC2_i*(d_xg2_dV_G_S-d_xg1_dV_G_S))+(d_xg1_dV_G_S+CIC2_i*(d_xg2_dV_G_S-d_xg1_dV_G_S))*((xg1+(CIC2_i*(xg2-xg1)))-600.0)))));
xg2x = (0.5*(((xg1+(CIC2_i*(xg2-xg1)))+600.0)-value_sqrt_0));
}

d_k1_dV_S_B = ((sce1*d_k1_1D_QM_dV_S_B-k1_1D_QM*d_sce1_dV_S_B)/sce1/sce1);
d_k1_dTemp_Tnode_GND = ((sce1*d_k1_1D_QM_dTemp_Tnode_GND-k1_1D_QM*d_sce1_dTemp_Tnode_GND)/sce1/sce1);
d_k1_dV_D_S = ((sce1*d_k1_1D_QM_dV_D_S-k1_1D_QM*d_sce1_dV_D_S)/sce1/sce1);
d_k1_dV_G_S = ((sce1*d_k1_1D_QM_dV_G_S-k1_1D_QM*d_sce1_dV_G_S)/sce1/sce1);
k1 = (k1_1D_QM/sce1);

d_k2_dV_S_B = ((sce2*d_k2_1D_QM_dV_S_B-k2_1D_QM*d_sce2_dV_S_B)/sce2/sce2);
d_k2_dTemp_Tnode_GND = ((sce2*d_k2_1D_QM_dTemp_Tnode_GND-k2_1D_QM*d_sce2_dTemp_Tnode_GND)/sce2/sce2);
d_k2_dV_D_S = ((sce2*d_k2_1D_QM_dV_D_S-k2_1D_QM*d_sce2_dV_D_S)/sce2/sce2);
d_k2_dV_G_S = ((sce2*d_k2_1D_QM_dV_G_S-k2_1D_QM*d_sce2_dV_G_S)/sce2/sce2);
k2 = (k2_1D_QM/sce2);

d_inv_k1_dV_S_B = (-d_k1_dV_S_B/k1/k1);
d_inv_k1_dTemp_Tnode_GND = (-d_k1_dTemp_Tnode_GND/k1/k1);
d_inv_k1_dV_D_S = (-d_k1_dV_D_S/k1/k1);
d_inv_k1_dV_G_S = (-d_k1_dV_G_S/k1/k1);
inv_k1 = (1.0/k1);

d_inv_k2_dV_S_B = (-d_k2_dV_S_B/k2/k2);
d_inv_k2_dTemp_Tnode_GND = (-d_k2_dTemp_Tnode_GND/k2/k2);
d_inv_k2_dV_D_S = (-d_k2_dV_D_S/k2/k2);
d_inv_k2_dV_G_S = (-d_k2_dV_G_S/k2/k2);
inv_k2 = (1.0/k2);

d_keq_dV_S_B = (-(d_inv_k1_dV_S_B+d_inv_k2_dV_S_B)/((1.0+inv_k1)+inv_k2)/((1.0+inv_k1)+inv_k2));
d_keq_dTemp_Tnode_GND = (-(d_inv_k1_dTemp_Tnode_GND+d_inv_k2_dTemp_Tnode_GND)/((1.0+inv_k1)+inv_k2)/((1.0+inv_k1)+inv_k2));
d_keq_dV_D_S = (-(d_inv_k1_dV_D_S+d_inv_k2_dV_D_S)/((1.0+inv_k1)+inv_k2)/((1.0+inv_k1)+inv_k2));
d_keq_dV_G_S = (-(d_inv_k1_dV_G_S+d_inv_k2_dV_G_S)/((1.0+inv_k1)+inv_k2)/((1.0+inv_k1)+inv_k2));
keq = (1.0/((1.0+inv_k1)+inv_k2));

d_A0_dV_S_B = (-A0_Csisq*(CsiPrime*d_CsiPrime_dV_S_B+d_CsiPrime_dV_S_B*CsiPrime)/(CsiPrime*CsiPrime)/(CsiPrime*CsiPrime));
d_A0_dV_D_S = (-A0_Csisq*(CsiPrime*d_CsiPrime_dV_D_S+d_CsiPrime_dV_D_S*CsiPrime)/(CsiPrime*CsiPrime)/(CsiPrime*CsiPrime));
d_A0_dV_G_S = (-A0_Csisq*(CsiPrime*d_CsiPrime_dV_G_S+d_CsiPrime_dV_G_S*CsiPrime)/(CsiPrime*CsiPrime)/(CsiPrime*CsiPrime));
d_A0_dTemp_Tnode_GND = (((CsiPrime*CsiPrime)*d_A0_Csisq_dTemp_Tnode_GND-A0_Csisq*(CsiPrime*d_CsiPrime_dTemp_Tnode_GND+d_CsiPrime_dTemp_Tnode_GND*CsiPrime))/(CsiPrime*CsiPrime)/(CsiPrime*CsiPrime));
A0 = (A0_Csisq/(CsiPrime*CsiPrime));

d_exp_dxth_dV_S_B = (((1.0+k2)*d_k1_dV_S_B-(1.0+k1)*d_k2_dV_S_B)/(1.0+k2)/(1.0+k2));
d_exp_dxth_dTemp_Tnode_GND = (((1.0+k2)*d_k1_dTemp_Tnode_GND-(1.0+k1)*d_k2_dTemp_Tnode_GND)/(1.0+k2)/(1.0+k2));
d_exp_dxth_dV_D_S = (((1.0+k2)*d_k1_dV_D_S-(1.0+k1)*d_k2_dV_D_S)/(1.0+k2)/(1.0+k2));
d_exp_dxth_dV_G_S = (((1.0+k2)*d_k1_dV_G_S-(1.0+k1)*d_k2_dV_G_S)/(1.0+k2)/(1.0+k2));
exp_dxth = ((1.0+k1)/(1.0+k2));
{
double value_log_0 = log(exp_dxth);
double  deriv_log_0_d0 = (1.0/exp_dxth);

d_dxth_dV_S_B = (deriv_log_0_d0*(d_exp_dxth_dV_S_B));
d_dxth_dTemp_Tnode_GND = (deriv_log_0_d0*(d_exp_dxth_dTemp_Tnode_GND));
d_dxth_dV_D_S = (deriv_log_0_d0*(d_exp_dxth_dV_D_S));
d_dxth_dV_G_S = (deriv_log_0_d0*(d_exp_dxth_dV_G_S));
dxth = value_log_0;
}
if ((dxth>1.0e-8))
{

d_diff_min_dV_S_B = (((exp_dxth-1.0)*((2.0*dxth)*d_exp_dxth_dV_S_B+2.0*d_dxth_dV_S_B*(exp_dxth+1.0))-((2.0*dxth)*(exp_dxth+1.0))*d_exp_dxth_dV_S_B)/(exp_dxth-1.0)/(exp_dxth-1.0));
d_diff_min_dTemp_Tnode_GND = (((exp_dxth-1.0)*((2.0*dxth)*d_exp_dxth_dTemp_Tnode_GND+2.0*d_dxth_dTemp_Tnode_GND*(exp_dxth+1.0))-((2.0*dxth)*(exp_dxth+1.0))*d_exp_dxth_dTemp_Tnode_GND)/(exp_dxth-1.0)/(exp_dxth-1.0));
d_diff_min_dV_D_S = (((exp_dxth-1.0)*((2.0*dxth)*d_exp_dxth_dV_D_S+2.0*d_dxth_dV_D_S*(exp_dxth+1.0))-((2.0*dxth)*(exp_dxth+1.0))*d_exp_dxth_dV_D_S)/(exp_dxth-1.0)/(exp_dxth-1.0));
d_diff_min_dV_G_S = (((exp_dxth-1.0)*((2.0*dxth)*d_exp_dxth_dV_G_S+2.0*d_dxth_dV_G_S*(exp_dxth+1.0))-((2.0*dxth)*(exp_dxth+1.0))*d_exp_dxth_dV_G_S)/(exp_dxth-1.0)/(exp_dxth-1.0));
diff_min = (((2.0*dxth)*(exp_dxth+1.0))/(exp_dxth-1.0));
}
else
{

d_diff_min_dV_S_B = 2.0*d_dxth_dV_S_B;
d_diff_min_dTemp_Tnode_GND = 2.0*d_dxth_dTemp_Tnode_GND;
d_diff_min_dV_D_S = 2.0*d_dxth_dV_D_S;
d_diff_min_dV_G_S = 2.0*d_dxth_dV_G_S;
diff_min = (2.0*(2.0+dxth));
}

d_Dx_WI_dV_S_B = (keq*(d_xg1x_dV_S_B-d_xg2x_dV_S_B)+d_keq_dV_S_B*(xg1x-xg2x));
d_Dx_WI_dTemp_Tnode_GND = (keq*(d_xg1x_dTemp_Tnode_GND-d_xg2x_dTemp_Tnode_GND)+d_keq_dTemp_Tnode_GND*(xg1x-xg2x));
d_Dx_WI_dV_D_S = (keq*(d_xg1x_dV_D_S-d_xg2x_dV_D_S)+d_keq_dV_D_S*(xg1x-xg2x));
d_Dx_WI_dV_G_S = (keq*(d_xg1x_dV_G_S-d_xg2x_dV_G_S)+d_keq_dV_G_S*(xg1x-xg2x));
Dx_WI = (keq*(xg1x-xg2x));

d_Dx_WIsq_dV_S_B = (Dx_WI*d_Dx_WI_dV_S_B+d_Dx_WI_dV_S_B*Dx_WI);
d_Dx_WIsq_dTemp_Tnode_GND = (Dx_WI*d_Dx_WI_dTemp_Tnode_GND+d_Dx_WI_dTemp_Tnode_GND*Dx_WI);
d_Dx_WIsq_dV_D_S = (Dx_WI*d_Dx_WI_dV_D_S+d_Dx_WI_dV_D_S*Dx_WI);
d_Dx_WIsq_dV_G_S = (Dx_WI*d_Dx_WI_dV_G_S+d_Dx_WI_dV_G_S*Dx_WI);
Dx_WIsq = (Dx_WI*Dx_WI);

d_x1_WI0_dV_S_B = (d_xg1x_dV_S_B-(Dx_WI*d_inv_k1_dV_S_B+d_Dx_WI_dV_S_B*inv_k1));
d_x1_WI0_dV_D_S = (d_xg1x_dV_D_S-(Dx_WI*d_inv_k1_dV_D_S+d_Dx_WI_dV_D_S*inv_k1));
d_x1_WI0_dV_G_S = (d_xg1x_dV_G_S-(Dx_WI*d_inv_k1_dV_G_S+d_Dx_WI_dV_G_S*inv_k1));
d_x1_WI0_dTemp_Tnode_GND = (d_xg1x_dTemp_Tnode_GND-(Dx_WI*d_inv_k1_dTemp_Tnode_GND+d_Dx_WI_dTemp_Tnode_GND*inv_k1));
x1_WI0 = (xg1x-(Dx_WI*inv_k1));

d_x2_WI0_dV_S_B = (d_xg2x_dV_S_B+(Dx_WI*d_inv_k2_dV_S_B+d_Dx_WI_dV_S_B*inv_k2));
d_x2_WI0_dTemp_Tnode_GND = (d_xg2x_dTemp_Tnode_GND+(Dx_WI*d_inv_k2_dTemp_Tnode_GND+d_Dx_WI_dTemp_Tnode_GND*inv_k2));
d_x2_WI0_dV_D_S = (d_xg2x_dV_D_S+(Dx_WI*d_inv_k2_dV_D_S+d_Dx_WI_dV_D_S*inv_k2));
d_x2_WI0_dV_G_S = (d_xg2x_dV_G_S+(Dx_WI*d_inv_k2_dV_G_S+d_Dx_WI_dV_G_S*inv_k2));
x2_WI0 = (xg2x+(Dx_WI*inv_k2));

d_q_temp1_dV_S_B = (-d_k1_dV_S_B/(k1+1.0)/(k1+1.0));
d_q_temp1_dTemp_Tnode_GND = (-d_k1_dTemp_Tnode_GND/(k1+1.0)/(k1+1.0));
d_q_temp1_dV_D_S = (-d_k1_dV_D_S/(k1+1.0)/(k1+1.0));
d_q_temp1_dV_G_S = (-d_k1_dV_G_S/(k1+1.0)/(k1+1.0));
q_temp1 = (1.0/(k1+1.0));

d_q_temp2_dV_S_B = (-d_k2_dV_S_B/(k2+1.0)/(k2+1.0));
d_q_temp2_dTemp_Tnode_GND = (-d_k2_dTemp_Tnode_GND/(k2+1.0)/(k2+1.0));
d_q_temp2_dV_D_S = (-d_k2_dV_D_S/(k2+1.0)/(k2+1.0));
d_q_temp2_dV_G_S = (-d_k2_dV_G_S/(k2+1.0)/(k2+1.0));
q_temp2 = (1.0/(k2+1.0));
{
double value_log_0 = log((((k1+(k2*q_temp2))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k1+(k2*q_temp2))*diff_min)/A0));

d_q_x1sat_dV_S_B = (deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dV_S_B+(d_k1_dV_S_B+(k2*d_q_temp2_dV_S_B+d_k2_dV_S_B*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dV_S_B)/A0/A0)));
d_q_x1sat_dTemp_Tnode_GND = (deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dTemp_Tnode_GND+(d_k1_dTemp_Tnode_GND+(k2*d_q_temp2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dTemp_Tnode_GND)/A0/A0)));
d_q_x1sat_dV_D_S = (deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dV_D_S+(d_k1_dV_D_S+(k2*d_q_temp2_dV_D_S+d_k2_dV_D_S*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dV_D_S)/A0/A0)));
d_q_x1sat_dV_G_S = (deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dV_G_S+(d_k1_dV_G_S+(k2*d_q_temp2_dV_G_S+d_k2_dV_G_S*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dV_G_S)/A0/A0)));
q_x1sat = (value_log_0+3.0);
}
{
double value_log_0 = log((((k2+(k1*q_temp1))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k2+(k1*q_temp1))*diff_min)/A0));

d_q_x2sat_dV_S_B = (deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dV_S_B+(d_k2_dV_S_B+(k1*d_q_temp1_dV_S_B+d_k1_dV_S_B*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dV_S_B)/A0/A0)));
d_q_x2sat_dTemp_Tnode_GND = (deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dTemp_Tnode_GND+(d_k2_dTemp_Tnode_GND+(k1*d_q_temp1_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dTemp_Tnode_GND)/A0/A0)));
d_q_x2sat_dV_D_S = (deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dV_D_S+(d_k2_dV_D_S+(k1*d_q_temp1_dV_D_S+d_k1_dV_D_S*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dV_D_S)/A0/A0)));
d_q_x2sat_dV_G_S = (deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dV_G_S+(d_k2_dV_G_S+(k1*d_q_temp1_dV_G_S+d_k1_dV_G_S*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dV_G_S)/A0/A0)));
q_x2sat = (value_log_0+3.0);
}
if ((((q_x1sat-x1_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-x1_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_S_B-d_x1_WI0_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dTemp_Tnode_GND-d_x1_WI0_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_D_S-d_x1_WI0_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_G_S-d_x1_WI0_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x1sat_dV_S_B-d_x1_WI0_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-d_x1_WI0_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x1sat_dV_D_S-d_x1_WI0_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x1sat_dV_G_S-d_x1_WI0_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x1sat-x1_WI0)*0.3333333333333);
}

d_q_x1_dV_S_B = (d_q_x1sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x1_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x1_dV_D_S = (d_q_x1sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x1_dV_G_S = (d_q_x1sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-x2_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-x2_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_S_B-d_x2_WI0_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dTemp_Tnode_GND-d_x2_WI0_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_D_S-d_x2_WI0_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_G_S-d_x2_WI0_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x2sat_dV_S_B-d_x2_WI0_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-d_x2_WI0_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x2sat_dV_D_S-d_x2_WI0_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x2sat_dV_G_S-d_x2_WI0_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x2sat-x2_WI0)*0.3333333333333);
}

d_q_x2_dV_S_B = (d_q_x2sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x2_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x2_dV_D_S = (d_q_x2sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x2_dV_G_S = (d_q_x2sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x2 = (q_x2sat-(3.0*q_temp3));

d_q_x1_WI_dV_S_B = (((k1*xg1x)+q_x2)*d_q_temp1_dV_S_B+((k1*d_xg1x_dV_S_B+d_k1_dV_S_B*xg1x)+d_q_x2_dV_S_B)*q_temp1);
d_q_x1_WI_dTemp_Tnode_GND = (((k1*xg1x)+q_x2)*d_q_temp1_dTemp_Tnode_GND+((k1*d_xg1x_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*xg1x)+d_q_x2_dTemp_Tnode_GND)*q_temp1);
d_q_x1_WI_dV_D_S = (((k1*xg1x)+q_x2)*d_q_temp1_dV_D_S+((k1*d_xg1x_dV_D_S+d_k1_dV_D_S*xg1x)+d_q_x2_dV_D_S)*q_temp1);
d_q_x1_WI_dV_G_S = (((k1*xg1x)+q_x2)*d_q_temp1_dV_G_S+((k1*d_xg1x_dV_G_S+d_k1_dV_G_S*xg1x)+d_q_x2_dV_G_S)*q_temp1);
q_x1_WI = (((k1*xg1x)+q_x2)*q_temp1);

d_q_x2_WI_dV_S_B = (((k2*xg2x)+q_x1)*d_q_temp2_dV_S_B+((k2*d_xg2x_dV_S_B+d_k2_dV_S_B*xg2x)+d_q_x1_dV_S_B)*q_temp2);
d_q_x2_WI_dTemp_Tnode_GND = (((k2*xg2x)+q_x1)*d_q_temp2_dTemp_Tnode_GND+((k2*d_xg2x_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*xg2x)+d_q_x1_dTemp_Tnode_GND)*q_temp2);
d_q_x2_WI_dV_D_S = (((k2*xg2x)+q_x1)*d_q_temp2_dV_D_S+((k2*d_xg2x_dV_D_S+d_k2_dV_D_S*xg2x)+d_q_x1_dV_D_S)*q_temp2);
d_q_x2_WI_dV_G_S = (((k2*xg2x)+q_x1)*d_q_temp2_dV_G_S+((k2*d_xg2x_dV_G_S+d_k2_dV_G_S*xg2x)+d_q_x1_dV_G_S)*q_temp2);
q_x2_WI = (((k2*xg2x)+q_x1)*q_temp2);
if ((((q_x1sat-q_x1_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-q_x1_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_S_B-d_q_x1_WI_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dTemp_Tnode_GND-d_q_x1_WI_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_D_S-d_q_x1_WI_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_G_S-d_q_x1_WI_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x1sat_dV_S_B-d_q_x1_WI_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-d_q_x1_WI_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x1sat_dV_D_S-d_q_x1_WI_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x1sat_dV_G_S-d_q_x1_WI_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x1sat-q_x1_WI)*0.3333333333333);
}

d_q_x1_dV_S_B = (d_q_x1sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x1_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x1_dV_D_S = (d_q_x1sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x1_dV_G_S = (d_q_x1sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-q_x2_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-q_x2_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_S_B-d_q_x2_WI_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dTemp_Tnode_GND-d_q_x2_WI_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_D_S-d_q_x2_WI_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_G_S-d_q_x2_WI_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x2sat_dV_S_B-d_q_x2_WI_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-d_q_x2_WI_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x2sat_dV_D_S-d_q_x2_WI_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x2sat_dV_G_S-d_q_x2_WI_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x2sat-q_x2_WI)*0.3333333333333);
}

d_q_x2_dV_S_B = (d_q_x2sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x2_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x2_dV_D_S = (d_q_x2sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x2_dV_G_S = (d_q_x2sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x2 = (q_x2sat-(3.0*q_temp3));

d_q1s_dV_S_B = (d_xg1x_dV_S_B-d_q_x1_dV_S_B);
d_q1s_dV_D_S = (d_xg1x_dV_D_S-d_q_x1_dV_D_S);
d_q1s_dV_G_S = (d_xg1x_dV_G_S-d_q_x1_dV_G_S);
d_q1s_dTemp_Tnode_GND = (d_xg1x_dTemp_Tnode_GND-d_q_x1_dTemp_Tnode_GND);
q1s = (xg1x-q_x1);

d_q2s_dV_S_B = (d_xg2x_dV_S_B-d_q_x2_dV_S_B);
d_q2s_dTemp_Tnode_GND = (d_xg2x_dTemp_Tnode_GND-d_q_x2_dTemp_Tnode_GND);
d_q2s_dV_D_S = (d_xg2x_dV_D_S-d_q_x2_dV_D_S);
d_q2s_dV_G_S = (d_xg2x_dV_G_S-d_q_x2_dV_G_S);
q2s = (xg2x-q_x2);

d_q_rac_qsq_dV_G_S = d_q_rac_qsq_dV_D_S = d_q_rac_qsq_dTemp_Tnode_GND = d_q_rac_qsq_dV_S_B =  0.0;
q_rac_qsq = 0.0;

d_q_invexpq_dV_G_S = d_q_invexpq_dV_D_S = d_q_invexpq_dTemp_Tnode_GND = d_q_invexpq_dV_S_B =  0.0;
q_invexpq = 0.0;

d_q_k1q1_dV_S_B = (k1*d_q1s_dV_S_B+d_k1_dV_S_B*q1s);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1s_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1s);
d_q_k1q1_dV_D_S = (k1*d_q1s_dV_D_S+d_k1_dV_D_S*q1s);
d_q_k1q1_dV_G_S = (k1*d_q1s_dV_G_S+d_k1_dV_G_S*q1s);
q_k1q1 = (k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*((d_xg1x_dV_S_B-d_q1s_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*((d_xg1x_dV_D_S-d_q1s_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*((d_xg1x_dV_G_S-d_q1s_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*((d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*0.3333333333333+0.5*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*0.3333333333333+0.5*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*0.3333333333333+0.5*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*0.3333333333333+0.5*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}

d_q_Aexp_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_q_Aexp_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_q_Aexp_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_q_Aexp_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
q_Aexp = (A0*q_temp1);

d_q_qsq_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_Aexp_dV_S_B);
d_q_qsq_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_qsq_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_Aexp_dV_D_S);
d_q_qsq_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_Aexp_dV_G_S);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);

d_q_d1_qsq_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_Aexp_dV_S_B);
d_q_d1_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_qsq_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_Aexp_dV_D_S);
d_q_d1_qsq_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_Aexp_dV_G_S);
q_d1_qsq = (((2.0*k1)*q_k1q1)+q_Aexp);

d_q_d2_qsq_dV_S_B = (((2.0*k1)*d_k1_dV_S_B+2.0*d_k1_dV_S_B*k1)-d_q_Aexp_dV_S_B);
d_q_d2_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_k1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*k1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_qsq_dV_D_S = (((2.0*k1)*d_k1_dV_D_S+2.0*d_k1_dV_D_S*k1)-d_q_Aexp_dV_D_S);
d_q_d2_qsq_dV_G_S = (((2.0*k1)*d_k1_dV_G_S+2.0*d_k1_dV_G_S*k1)-d_q_Aexp_dV_G_S);
q_d2_qsq = (((2.0*k1)*k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{

d_q_temp3_dV_S_B = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_S_B*0.025)+d_q_qsq_dV_S_B*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_S_B*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dTemp_Tnode_GND*0.025)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_D_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_D_S*0.025)+d_q_qsq_dV_D_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_D_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_G_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_G_S*0.025)+d_q_qsq_dV_G_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_G_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));

d_q_qcoth_dV_S_B = (q_qsq*d_q_temp3_dV_S_B+d_q_qsq_dV_S_B*q_temp3);
d_q_qcoth_dTemp_Tnode_GND = (q_qsq*d_q_temp3_dTemp_Tnode_GND+d_q_qsq_dTemp_Tnode_GND*q_temp3);
d_q_qcoth_dV_D_S = (q_qsq*d_q_temp3_dV_D_S+d_q_qsq_dV_D_S*q_temp3);
d_q_qcoth_dV_G_S = (q_qsq*d_q_temp3_dV_G_S+d_q_qsq_dV_G_S*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));

d_q_temp1_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));

d_q_d1_qcoth_dV_S_B = (q_d1_qsq*d_q_temp1_dV_S_B+d_q_d1_qsq_dV_S_B*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = (q_d1_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_temp1);
d_q_d1_qcoth_dV_D_S = (q_d1_qsq*d_q_temp1_dV_D_S+d_q_d1_qsq_dV_D_S*q_temp1);
d_q_d1_qcoth_dV_G_S = (q_d1_qsq*d_q_temp1_dV_G_S+d_q_d1_qsq_dV_G_S*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);

d_q_temp2_dV_S_B = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_S_B*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dTemp_Tnode_GND = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_D_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_D_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_G_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_G_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));

d_q_d2_qcoth_dV_S_B = ((q_d2_qsq*d_q_temp1_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_S_B+(q_d1_qsq*d_q_d1_qsq_dV_S_B+d_q_d1_qsq_dV_S_B*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dTemp_Tnode_GND = ((q_d2_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dTemp_Tnode_GND+(q_d1_qsq*d_q_d1_qsq_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_D_S = ((q_d2_qsq*d_q_temp1_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_D_S+(q_d1_qsq*d_q_d1_qsq_dV_D_S+d_q_d1_qsq_dV_D_S*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_G_S = ((q_d2_qsq*d_q_temp1_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_G_S+(q_d1_qsq*d_q_d1_qsq_dV_G_S+d_q_d1_qsq_dV_G_S*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));

d_q_d1_ln_dV_S_B = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d1_qsq_dV_S_B*q_temp3);
d_q_d1_ln_dTemp_Tnode_GND = (((-0.5)*q_d1_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d1_qsq_dTemp_Tnode_GND*q_temp3);
d_q_d1_ln_dV_D_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d1_qsq_dV_D_S*q_temp3);
d_q_d1_ln_dV_G_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d1_qsq_dV_G_S*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);

d_q_d2_ln_dV_S_B = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d2_qsq_dV_S_B*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_S_B)+d_q_qsq_dV_S_B*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_S_B+(0.25*0.0055555555556)*d_q_d1_qsq_dV_S_B*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dTemp_Tnode_GND = ((((-0.5)*q_d2_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d2_qsq_dTemp_Tnode_GND*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dTemp_Tnode_GND)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dTemp_Tnode_GND+(0.25*0.0055555555556)*d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_D_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d2_qsq_dV_D_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_D_S)+d_q_qsq_dV_D_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_D_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_D_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_G_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d2_qsq_dV_G_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_G_S)+d_q_qsq_dV_G_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_G_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_G_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{

d_q_temp2_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_S_B-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dTemp_Tnode_GND-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_D_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_G_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));

d_q_sh_term_dV_S_B = (q_temp2*d_q_invexpq_dV_S_B+d_q_temp2_dV_S_B*q_invexpq);
d_q_sh_term_dTemp_Tnode_GND = (q_temp2*d_q_invexpq_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_invexpq);
d_q_sh_term_dV_D_S = (q_temp2*d_q_invexpq_dV_D_S+d_q_temp2_dV_D_S*q_invexpq);
d_q_sh_term_dV_G_S = (q_temp2*d_q_invexpq_dV_G_S+d_q_temp2_dV_G_S*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);

d_q_ln_term_dV_S_B = ((deriv_log_0_d0*(d_q_temp2_dV_S_B))-d_q_rac_qsq_dV_S_B);
d_q_ln_term_dTemp_Tnode_GND = ((deriv_log_0_d0*(d_q_temp2_dTemp_Tnode_GND))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_ln_term_dV_D_S = ((deriv_log_0_d0*(d_q_temp2_dV_D_S))-d_q_rac_qsq_dV_D_S);
d_q_ln_term_dV_G_S = ((deriv_log_0_d0*(d_q_temp2_dV_G_S))-d_q_rac_qsq_dV_G_S);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_sh_term_dV_S_B = (((q_temp2*q_temp2)*(-d_q_qsq_dV_S_B)-(-q_qsq)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dTemp_Tnode_GND = (((q_temp2*q_temp2)*(-d_q_qsq_dTemp_Tnode_GND)-(-q_qsq)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_D_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_D_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_G_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_G_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
else
{

d_q_sh_term_dV_S_B = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_S_B*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dTemp_Tnode_GND = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_D_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_D_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_G_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_G_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{

d_q_expnum_dV_S_B = (d_q_k1q1_dV_S_B+d_q_qcoth_dV_S_B);
d_q_expnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_expnum_dV_D_S = (d_q_k1q1_dV_D_S+d_q_qcoth_dV_D_S);
d_q_expnum_dV_G_S = (d_q_k1q1_dV_G_S+d_q_qcoth_dV_G_S);
q_expnum = (q_k1q1+q_qcoth);

d_q_d1_expnum_dV_S_B = (d_k1_dV_S_B+d_q_d1_qcoth_dV_S_B);
d_q_d1_expnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND);
d_q_d1_expnum_dV_D_S = (d_k1_dV_D_S+d_q_d1_qcoth_dV_D_S);
d_q_d1_expnum_dV_G_S = (d_k1_dV_G_S+d_q_d1_qcoth_dV_G_S);
q_d1_expnum = (k1+q_d1_qcoth);

d_q_d2_expnum_dV_S_B = d_q_d2_qcoth_dV_S_B;
d_q_d2_expnum_dTemp_Tnode_GND = d_q_d2_qcoth_dTemp_Tnode_GND;
d_q_d2_expnum_dV_D_S = d_q_d2_qcoth_dV_D_S;
d_q_d2_expnum_dV_G_S = d_q_d2_qcoth_dV_G_S;
q_d2_expnum = q_d2_qcoth;
}
else
{

d_q_temp2_dV_S_B = (-(d_q_k1q1_dV_S_B-d_q_qcoth_dV_S_B)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dTemp_Tnode_GND = (-(d_q_k1q1_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_D_S = (-(d_q_k1q1_dV_D_S-d_q_qcoth_dV_D_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_G_S = (-(d_q_k1q1_dV_G_S-d_q_qcoth_dV_G_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));

d_q_temp3_dV_S_B = (d_q_d1_qcoth_dV_S_B-d_k1_dV_S_B);
d_q_temp3_dTemp_Tnode_GND = (d_q_d1_qcoth_dTemp_Tnode_GND-d_k1_dTemp_Tnode_GND);
d_q_temp3_dV_D_S = (d_q_d1_qcoth_dV_D_S-d_k1_dV_D_S);
d_q_temp3_dV_G_S = (d_q_d1_qcoth_dV_G_S-d_k1_dV_G_S);
q_temp3 = (q_d1_qcoth-k1);

d_q_expnum_dV_S_B = ((q_Aexp-q_sh_term)*d_q_temp2_dV_S_B+(d_q_Aexp_dV_S_B-d_q_sh_term_dV_S_B)*q_temp2);
d_q_expnum_dV_D_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_D_S+(d_q_Aexp_dV_D_S-d_q_sh_term_dV_D_S)*q_temp2);
d_q_expnum_dV_G_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_G_S+(d_q_Aexp_dV_G_S-d_q_sh_term_dV_G_S)*q_temp2);
d_q_expnum_dTemp_Tnode_GND = ((q_Aexp-q_sh_term)*d_q_temp2_dTemp_Tnode_GND+(d_q_Aexp_dTemp_Tnode_GND-d_q_sh_term_dTemp_Tnode_GND)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);

d_q_d1_expnum_dV_S_B = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_S_B+(((q_temp3*d_q_expnum_dV_S_B+d_q_temp3_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B)-(q_d1_ln*d_q_sh_term_dV_S_B+d_q_d1_ln_dV_S_B*q_sh_term))*q_temp2);
d_q_d1_expnum_dTemp_Tnode_GND = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+(((q_temp3*d_q_expnum_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND)-(q_d1_ln*d_q_sh_term_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_D_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_D_S+(((q_temp3*d_q_expnum_dV_D_S+d_q_temp3_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S)-(q_d1_ln*d_q_sh_term_dV_D_S+d_q_d1_ln_dV_D_S*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_G_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_G_S+(((q_temp3*d_q_expnum_dV_G_S+d_q_temp3_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S)-(q_d1_ln*d_q_sh_term_dV_G_S+d_q_d1_ln_dV_G_S*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);

d_q_d2_expnum_dV_S_B = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_S_B+((((q_d2_qcoth*d_q_expnum_dV_S_B+d_q_d2_qcoth_dV_S_B*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_S_B+2.0*d_q_temp3_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_S_B+(d_q_d2_ln_dV_S_B+(q_d1_ln*d_q_d1_ln_dV_S_B+d_q_d1_ln_dV_S_B*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dTemp_Tnode_GND = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+((((q_d2_qcoth*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qcoth_dTemp_Tnode_GND*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_temp3_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dTemp_Tnode_GND+(d_q_d2_ln_dTemp_Tnode_GND+(q_d1_ln*d_q_d1_ln_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_D_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_D_S+((((q_d2_qcoth*d_q_expnum_dV_D_S+d_q_d2_qcoth_dV_D_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_D_S+2.0*d_q_temp3_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_D_S+(d_q_d2_ln_dV_D_S+(q_d1_ln*d_q_d1_ln_dV_D_S+d_q_d1_ln_dV_D_S*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_G_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_G_S+((((q_d2_qcoth*d_q_expnum_dV_G_S+d_q_d2_qcoth_dV_G_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_G_S+2.0*d_q_temp3_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_G_S+(d_q_d2_ln_dV_G_S+(q_d1_ln*d_q_d1_ln_dV_G_S+d_q_d1_ln_dV_G_S*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);

d_q_lnexpnum_dV_S_B = (deriv_log_0_d0*(d_q_expnum_dV_S_B));
d_q_lnexpnum_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_expnum_dTemp_Tnode_GND));
d_q_lnexpnum_dV_D_S = (deriv_log_0_d0*(d_q_expnum_dV_D_S));
d_q_lnexpnum_dV_G_S = (deriv_log_0_d0*(d_q_expnum_dV_G_S));
q_lnexpnum = value_log_0;
}

d_q_temp1_dV_S_B = (-d_q_expnum_dV_S_B/q_expnum/q_expnum);
d_q_temp1_dTemp_Tnode_GND = (-d_q_expnum_dTemp_Tnode_GND/q_expnum/q_expnum);
d_q_temp1_dV_D_S = (-d_q_expnum_dV_D_S/q_expnum/q_expnum);
d_q_temp1_dV_G_S = (-d_q_expnum_dV_G_S/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);

d_q_d1_lnexpnum_dV_S_B = (q_d1_expnum*d_q_temp1_dV_S_B+d_q_d1_expnum_dV_S_B*q_temp1);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (q_d1_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d1_expnum_dTemp_Tnode_GND*q_temp1);
d_q_d1_lnexpnum_dV_D_S = (q_d1_expnum*d_q_temp1_dV_D_S+d_q_d1_expnum_dV_D_S*q_temp1);
d_q_d1_lnexpnum_dV_G_S = (q_d1_expnum*d_q_temp1_dV_G_S+d_q_d1_expnum_dV_G_S*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((q_d2_expnum*d_q_temp1_dV_S_B+d_q_d2_expnum_dV_S_B*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_S_B+d_q_d1_lnexpnum_dV_S_B*q_d1_lnexpnum));
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((q_d2_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d2_expnum_dTemp_Tnode_GND*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dTemp_Tnode_GND+d_q_d1_lnexpnum_dTemp_Tnode_GND*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_D_S = ((q_d2_expnum*d_q_temp1_dV_D_S+d_q_d2_expnum_dV_D_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_D_S+d_q_d1_lnexpnum_dV_D_S*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_G_S = ((q_d2_expnum*d_q_temp1_dV_G_S+d_q_d2_expnum_dV_G_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_G_S+d_q_d1_lnexpnum_dV_G_S*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));

d_q_lnexpnum_dV_S_B = (d_q_k1q1_dV_S_B+(deriv_log_0_d0*((-d_q_k1q1_dV_S_B))));
d_q_lnexpnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(deriv_log_0_d0*((-d_q_k1q1_dTemp_Tnode_GND))));
d_q_lnexpnum_dV_D_S = (d_q_k1q1_dV_D_S+(deriv_log_0_d0*((-d_q_k1q1_dV_D_S))));
d_q_lnexpnum_dV_G_S = (d_q_k1q1_dV_G_S+(deriv_log_0_d0*((-d_q_k1q1_dV_G_S))));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}

d_q_temp1_dV_S_B = (-d_q1s_dV_S_B/q1s/q1s);
d_q_temp1_dV_D_S = (-d_q1s_dV_D_S/q1s/q1s);
d_q_temp1_dV_G_S = (-d_q1s_dV_G_S/q1s/q1s);
d_q_temp1_dTemp_Tnode_GND = (-d_q1s_dTemp_Tnode_GND/q1s/q1s);
q_temp1 = (1.0/q1s);

d_q_d1_lnexpnum_dV_S_B = (d_k1_dV_S_B+d_q_temp1_dV_S_B);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_temp1_dTemp_Tnode_GND);
d_q_d1_lnexpnum_dV_D_S = (d_k1_dV_D_S+d_q_temp1_dV_D_S);
d_q_d1_lnexpnum_dV_G_S = (d_k1_dV_G_S+d_q_temp1_dV_G_S);
q_d1_lnexpnum = (k1+q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((-q_temp1)*d_q_temp1_dV_S_B+(-d_q_temp1_dV_S_B)*q_temp1);
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((-q_temp1)*d_q_temp1_dTemp_Tnode_GND+(-d_q_temp1_dTemp_Tnode_GND)*q_temp1);
d_q_d2_lnexpnum_dV_D_S = ((-q_temp1)*d_q_temp1_dV_D_S+(-d_q_temp1_dV_D_S)*q_temp1);
d_q_d2_lnexpnum_dV_G_S = ((-q_temp1)*d_q_temp1_dV_G_S+(-d_q_temp1_dV_G_S)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}

d_q_q2_int_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1s_dV_S_B)+2.0*d_q_lnexpnum_dV_S_B)-d_q_ln_term_dV_S_B);
d_q_q2_int_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1s_dTemp_Tnode_GND)+2.0*d_q_lnexpnum_dTemp_Tnode_GND)-d_q_ln_term_dTemp_Tnode_GND);
d_q_q2_int_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1s_dV_D_S)+2.0*d_q_lnexpnum_dV_D_S)-d_q_ln_term_dV_D_S);
d_q_q2_int_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1s_dV_G_S)+2.0*d_q_lnexpnum_dV_G_S)-d_q_ln_term_dV_G_S);
q_q2_int = ((((xg2x-xg1x)+q1s)+(2.0*q_lnexpnum))-q_ln_term);

d_q_d1_q2_dV_S_B = (2.0*d_q_d1_lnexpnum_dV_S_B-d_q_d1_ln_dV_S_B);
d_q_d1_q2_dTemp_Tnode_GND = (2.0*d_q_d1_lnexpnum_dTemp_Tnode_GND-d_q_d1_ln_dTemp_Tnode_GND);
d_q_d1_q2_dV_D_S = (2.0*d_q_d1_lnexpnum_dV_D_S-d_q_d1_ln_dV_D_S);
d_q_d1_q2_dV_G_S = (2.0*d_q_d1_lnexpnum_dV_G_S-d_q_d1_ln_dV_G_S);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);

d_q_d2_q2_dV_S_B = (2.0*d_q_d2_lnexpnum_dV_S_B-d_q_d2_ln_dV_S_B);
d_q_d2_q2_dTemp_Tnode_GND = (2.0*d_q_d2_lnexpnum_dTemp_Tnode_GND-d_q_d2_ln_dTemp_Tnode_GND);
d_q_d2_q2_dV_D_S = (2.0*d_q_d2_lnexpnum_dV_D_S-d_q_d2_ln_dV_D_S);
d_q_d2_q2_dV_G_S = (2.0*d_q_d2_lnexpnum_dV_G_S-d_q_d2_ln_dV_G_S);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+(k2*d_q_q2_int_dV_S_B+d_k2_dV_S_B*q_q2_int));
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(k2*d_q_q2_int_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_q2_int));
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+(k2*d_q_q2_int_dV_D_S+d_k2_dV_D_S*q_q2_int));
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+(k2*d_q_q2_int_dV_G_S+d_k2_dV_G_S*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));

d_q_d1_qi_dV_S_B = (d_k1_dV_S_B+(k2*d_q_d1_q2_dV_S_B+d_k2_dV_S_B*q_d1_q2));
d_q_d1_qi_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+(k2*d_q_d1_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d1_q2));
d_q_d1_qi_dV_D_S = (d_k1_dV_D_S+(k2*d_q_d1_q2_dV_D_S+d_k2_dV_D_S*q_d1_q2));
d_q_d1_qi_dV_G_S = (d_k1_dV_G_S+(k2*d_q_d1_q2_dV_G_S+d_k2_dV_G_S*q_d1_q2));
q_d1_qi = (k1+(k2*q_d1_q2));

d_q_d2_qi_dV_S_B = (k2*d_q_d2_q2_dV_S_B+d_k2_dV_S_B*q_d2_q2);
d_q_d2_qi_dTemp_Tnode_GND = (k2*d_q_d2_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d2_q2);
d_q_d2_qi_dV_D_S = (k2*d_q_d2_q2_dV_D_S+d_k2_dV_D_S*q_d2_q2);
d_q_d2_qi_dV_G_S = (k2*d_q_d2_q2_dV_G_S+d_k2_dV_G_S*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);

d_q_zero_dV_S_B = ((q_qi_int*d_q_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B);
d_q_zero_dTemp_Tnode_GND = ((q_qi_int*d_q_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND);
d_q_zero_dV_D_S = ((q_qi_int*d_q_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S);
d_q_zero_dV_G_S = ((q_qi_int*d_q_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{

d_q_eps2_dV_G_S = d_q_eps2_dV_D_S = d_q_eps2_dTemp_Tnode_GND = d_q_eps2_dV_S_B =  0.0;
q_eps2 = 0.0;
}
else
{

d_q_d1_zero_dV_S_B = (((q_d1_qi*d_q_expnum_dV_S_B+d_q_d1_qi_dV_S_B*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((q_d1_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d1_qi_dTemp_Tnode_GND*q_expnum)+(q_qi_int*d_q_d1_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((q_d1_qi*d_q_expnum_dV_D_S+d_q_d1_qi_dV_D_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S);
d_q_d1_zero_dV_G_S = (((q_d1_qi*d_q_expnum_dV_G_S+d_q_d1_qi_dV_G_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);

d_q_d2_zero_dV_S_B = ((((q_d2_qi*d_q_expnum_dV_S_B+d_q_d2_qi_dV_S_B*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_S_B+2.0*d_q_d1_qi_dV_S_B*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d2_expnum))-d_q_Aexp_dV_S_B);
d_q_d2_zero_dTemp_Tnode_GND = ((((q_d2_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qi_dTemp_Tnode_GND*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_d1_qi_dTemp_Tnode_GND*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d2_expnum))-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_zero_dV_D_S = ((((q_d2_qi*d_q_expnum_dV_D_S+d_q_d2_qi_dV_D_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_D_S+2.0*d_q_d1_qi_dV_D_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d2_expnum))-d_q_Aexp_dV_D_S);
d_q_d2_zero_dV_G_S = ((((q_d2_qi*d_q_expnum_dV_G_S+d_q_d2_qi_dV_G_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_G_S+2.0*d_q_d1_qi_dV_G_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d2_expnum))-d_q_Aexp_dV_G_S);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);

d_q_eps1_dV_S_B = ((q_d1_zero*(-d_q_zero_dV_S_B)-(-q_zero)*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero);
d_q_eps1_dTemp_Tnode_GND = ((q_d1_zero*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_D_S = ((q_d1_zero*(-d_q_zero_dV_D_S)-(-q_zero)*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_G_S = ((q_d1_zero*(-d_q_zero_dV_G_S)-(-q_zero)*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);

d_q_eps2_dV_S_B = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_S_B)-(-q_zero)*(d_q_d1_zero_dV_S_B+((0.5*q_eps1)*d_q_d2_zero_dV_S_B+0.5*d_q_eps1_dV_S_B*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dTemp_Tnode_GND = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*(d_q_d1_zero_dTemp_Tnode_GND+((0.5*q_eps1)*d_q_d2_zero_dTemp_Tnode_GND+0.5*d_q_eps1_dTemp_Tnode_GND*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_D_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_D_S)-(-q_zero)*(d_q_d1_zero_dV_D_S+((0.5*q_eps1)*d_q_d2_zero_dV_D_S+0.5*d_q_eps1_dV_D_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_G_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_G_S)-(-q_zero)*(d_q_d1_zero_dV_G_S+((0.5*q_eps1)*d_q_d2_zero_dV_G_S+0.5*d_q_eps1_dV_G_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}

d_q1s_dV_S_B = (d_q1s_dV_S_B+d_q_eps2_dV_S_B);
d_q1s_dV_D_S = (d_q1s_dV_D_S+d_q_eps2_dV_D_S);
d_q1s_dV_G_S = (d_q1s_dV_G_S+d_q_eps2_dV_G_S);
d_q1s_dTemp_Tnode_GND = (d_q1s_dTemp_Tnode_GND+d_q_eps2_dTemp_Tnode_GND);
q1s = (q1s+q_eps2);

d_q_k1q1_dV_S_B = (k1*d_q1s_dV_S_B+d_k1_dV_S_B*q1s);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1s_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1s);
d_q_k1q1_dV_D_S = (k1*d_q1s_dV_D_S+d_k1_dV_D_S*q1s);
d_q_k1q1_dV_G_S = (k1*d_q1s_dV_G_S+d_k1_dV_G_S*q1s);
q_k1q1 = (k1*q1s);

d_q_k2q2_dV_S_B = (k2*d_q2s_dV_S_B+d_k2_dV_S_B*q2s);
d_q_k2q2_dTemp_Tnode_GND = (k2*d_q2s_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q2s);
d_q_k2q2_dV_D_S = (k2*d_q2s_dV_D_S+d_k2_dV_D_S*q2s);
d_q_k2q2_dV_G_S = (k2*d_q2s_dV_G_S+d_k2_dV_G_S*q2s);
q_k2q2 = (k2*q2s);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+d_q_k2q2_dV_S_B);
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_k2q2_dTemp_Tnode_GND);
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+d_q_k2q2_dV_D_S);
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+d_q_k2q2_dV_G_S);
q_qi_int = (q_k1q1+q_k2q2);

d_q_a_dV_S_B = 0.065345483024*d_q_qi_int_dV_S_B;
d_q_a_dTemp_Tnode_GND = 0.065345483024*d_q_qi_int_dTemp_Tnode_GND;
d_q_a_dV_D_S = 0.065345483024*d_q_qi_int_dV_D_S;
d_q_a_dV_G_S = 0.065345483024*d_q_qi_int_dV_G_S;
q_a = (1.0+(0.065345483024*q_qi_int));

d_q_b_dV_S_B = (8.5797362674*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_b_dTemp_Tnode_GND = (8.5797362674*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_b_dV_D_S = (8.5797362674*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_b_dV_G_S = (8.5797362674*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));

d_q_c_dV_S_B = 39.478417604*(2.0*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_c_dTemp_Tnode_GND = 39.478417604*(2.0*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_c_dV_D_S = 39.478417604*(2.0*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_c_dV_G_S = 39.478417604*(2.0*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_q_disc_dV_S_B = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_S_B+d_q_b_dV_S_B*q_b)-((4.0*q_a)*d_q_c_dV_S_B+4.0*d_q_a_dV_S_B*q_c))));
d_q_disc_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((q_b*d_q_b_dTemp_Tnode_GND+d_q_b_dTemp_Tnode_GND*q_b)-((4.0*q_a)*d_q_c_dTemp_Tnode_GND+4.0*d_q_a_dTemp_Tnode_GND*q_c))));
d_q_disc_dV_D_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_D_S+d_q_b_dV_D_S*q_b)-((4.0*q_a)*d_q_c_dV_D_S+4.0*d_q_a_dV_D_S*q_c))));
d_q_disc_dV_G_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_G_S+d_q_b_dV_G_S*q_b)-((4.0*q_a)*d_q_c_dV_G_S+4.0*d_q_a_dV_G_S*q_c))));
q_disc = value_sqrt_0;
}

d_q_qsq_dV_S_B = (((2.0*q_a)*(d_q_disc_dV_S_B-d_q_b_dV_S_B)-(q_disc-q_b)*2.0*d_q_a_dV_S_B)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dTemp_Tnode_GND = (((2.0*q_a)*(d_q_disc_dTemp_Tnode_GND-d_q_b_dTemp_Tnode_GND)-(q_disc-q_b)*2.0*d_q_a_dTemp_Tnode_GND)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_D_S = (((2.0*q_a)*(d_q_disc_dV_D_S-d_q_b_dV_D_S)-(q_disc-q_b)*2.0*d_q_a_dV_D_S)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_G_S = (((2.0*q_a)*(d_q_disc_dV_G_S-d_q_b_dV_G_S)-(q_disc-q_b)*2.0*d_q_a_dV_G_S)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));

d_q_delta_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_qsq_dV_S_B);
d_q_delta_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_qsq_dTemp_Tnode_GND);
d_q_delta_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_qsq_dV_D_S);
d_q_delta_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_qsq_dV_G_S);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));

d_q_zero_dV_S_B = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dV_S_B-q_delta*d_A0_dV_S_B)/A0/A0)))-d_xg1x_dV_S_B)+d_q1s_dV_S_B)+d_q_delta_dV_S_B*((value_log_0-xg1x)+q1s));
d_q_zero_dTemp_Tnode_GND = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dTemp_Tnode_GND-q_delta*d_A0_dTemp_Tnode_GND)/A0/A0)))-d_xg1x_dTemp_Tnode_GND)+d_q1s_dTemp_Tnode_GND)+d_q_delta_dTemp_Tnode_GND*((value_log_0-xg1x)+q1s));
d_q_zero_dV_D_S = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dV_D_S-q_delta*d_A0_dV_D_S)/A0/A0)))-d_xg1x_dV_D_S)+d_q1s_dV_D_S)+d_q_delta_dV_D_S*((value_log_0-xg1x)+q1s));
d_q_zero_dV_G_S = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dV_G_S-q_delta*d_A0_dV_G_S)/A0/A0)))-d_xg1x_dV_G_S)+d_q1s_dV_G_S)+d_q_delta_dV_G_S*((value_log_0-xg1x)+q1s));
q_zero = (q_delta*((value_log_0-xg1x)+q1s));
}

d_q_d1_zero_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_delta_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_delta_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_delta_dV_D_S);
d_q_d1_zero_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_delta_dV_G_S);
q_d1_zero = (((2.0*k1)*q_k1q1)+q_delta);

d_q_dx1_dV_S_B = ((d_xg1x_dV_S_B-d_q1s_dV_S_B)-d_q_x1sat_dV_S_B);
d_q_dx1_dV_D_S = ((d_xg1x_dV_D_S-d_q1s_dV_D_S)-d_q_x1sat_dV_D_S);
d_q_dx1_dV_G_S = ((d_xg1x_dV_G_S-d_q1s_dV_G_S)-d_q_x1sat_dV_G_S);
d_q_dx1_dTemp_Tnode_GND = ((d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)-d_q_x1sat_dTemp_Tnode_GND);
q_dx1 = ((xg1x-q1s)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(k1))>0.0))||(q_dx1>1.0)))
{

d_q1s_dV_S_B = (d_q1s_dV_S_B-((q_d1_zero*d_q_zero_dV_S_B-q_zero*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero));
d_q1s_dV_D_S = (d_q1s_dV_D_S-((q_d1_zero*d_q_zero_dV_D_S-q_zero*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero));
d_q1s_dV_G_S = (d_q1s_dV_G_S-((q_d1_zero*d_q_zero_dV_G_S-q_zero*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero));
d_q1s_dTemp_Tnode_GND = (d_q1s_dTemp_Tnode_GND-((q_d1_zero*d_q_zero_dTemp_Tnode_GND-q_zero*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero));
q1s = (q1s-(q_zero/q_d1_zero));
}
}

d_q_k1q1_dV_S_B = (k1*d_q1s_dV_S_B+d_k1_dV_S_B*q1s);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1s_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1s);
d_q_k1q1_dV_D_S = (k1*d_q1s_dV_D_S+d_k1_dV_D_S*q1s);
d_q_k1q1_dV_G_S = (k1*d_q1s_dV_G_S+d_k1_dV_G_S*q1s);
q_k1q1 = (k1*q1s);

d_q_k2q2_dV_S_B = (k2*d_q2s_dV_S_B+d_k2_dV_S_B*q2s);
d_q_k2q2_dTemp_Tnode_GND = (k2*d_q2s_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q2s);
d_q_k2q2_dV_D_S = (k2*d_q2s_dV_D_S+d_k2_dV_D_S*q2s);
d_q_k2q2_dV_G_S = (k2*d_q2s_dV_G_S+d_k2_dV_G_S*q2s);
q_k2q2 = (k2*q2s);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+d_q_k2q2_dV_S_B);
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_k2q2_dTemp_Tnode_GND);
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+d_q_k2q2_dV_D_S);
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+d_q_k2q2_dV_G_S);
q_qi_int = (q_k1q1+q_k2q2);

d_q_a_dV_S_B = 0.065345483024*d_q_qi_int_dV_S_B;
d_q_a_dTemp_Tnode_GND = 0.065345483024*d_q_qi_int_dTemp_Tnode_GND;
d_q_a_dV_D_S = 0.065345483024*d_q_qi_int_dV_D_S;
d_q_a_dV_G_S = 0.065345483024*d_q_qi_int_dV_G_S;
q_a = (1.0+(0.065345483024*q_qi_int));

d_q_b_dV_S_B = (8.5797362674*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_b_dTemp_Tnode_GND = (8.5797362674*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_b_dV_D_S = (8.5797362674*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_b_dV_G_S = (8.5797362674*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));

d_q_c_dV_S_B = 39.478417604*(2.0*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_c_dTemp_Tnode_GND = 39.478417604*(2.0*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_c_dV_D_S = 39.478417604*(2.0*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_c_dV_G_S = 39.478417604*(2.0*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_q_disc_dV_S_B = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_S_B+d_q_b_dV_S_B*q_b)-((4.0*q_a)*d_q_c_dV_S_B+4.0*d_q_a_dV_S_B*q_c))));
d_q_disc_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((q_b*d_q_b_dTemp_Tnode_GND+d_q_b_dTemp_Tnode_GND*q_b)-((4.0*q_a)*d_q_c_dTemp_Tnode_GND+4.0*d_q_a_dTemp_Tnode_GND*q_c))));
d_q_disc_dV_D_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_D_S+d_q_b_dV_D_S*q_b)-((4.0*q_a)*d_q_c_dV_D_S+4.0*d_q_a_dV_D_S*q_c))));
d_q_disc_dV_G_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_G_S+d_q_b_dV_G_S*q_b)-((4.0*q_a)*d_q_c_dV_G_S+4.0*d_q_a_dV_G_S*q_c))));
q_disc = value_sqrt_0;
}

d_q_qsq_dV_S_B = (((2.0*q_a)*(d_q_disc_dV_S_B-d_q_b_dV_S_B)-(q_disc-q_b)*2.0*d_q_a_dV_S_B)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dTemp_Tnode_GND = (((2.0*q_a)*(d_q_disc_dTemp_Tnode_GND-d_q_b_dTemp_Tnode_GND)-(q_disc-q_b)*2.0*d_q_a_dTemp_Tnode_GND)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_D_S = (((2.0*q_a)*(d_q_disc_dV_D_S-d_q_b_dV_D_S)-(q_disc-q_b)*2.0*d_q_a_dV_D_S)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_G_S = (((2.0*q_a)*(d_q_disc_dV_G_S-d_q_b_dV_G_S)-(q_disc-q_b)*2.0*d_q_a_dV_G_S)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_d1_qcoth_dV_S_B = ((q_qsq*0.25*(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq*0.25*(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_D_S = ((q_qsq*0.25*(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_G_S = ((q_qsq*0.25*(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_d1_qcoth_dV_S_B = ((q_qsq*0.25*(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq*0.25*(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_D_S = ((q_qsq*0.25*(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_G_S = ((q_qsq*0.25*(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{

d_q_qcoth_dV_S_B = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dV_S_B*0.0238095238095)+d_q_qsq_dV_S_B*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dV_S_B*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
d_q_qcoth_dTemp_Tnode_GND = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dTemp_Tnode_GND*0.0238095238095)+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dTemp_Tnode_GND*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
d_q_qcoth_dV_D_S = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dV_D_S*0.0238095238095)+d_q_qsq_dV_D_S*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dV_D_S*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
d_q_qcoth_dV_G_S = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dV_G_S*0.0238095238095)+d_q_qsq_dV_G_S*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dV_G_S*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
q_qcoth = (2.0+((q_qsq*0.1666666666667)*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095))))));

d_q_d1_qcoth_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_d1_qcoth_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_d1_qcoth_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_d1_qcoth_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_d1_qcoth = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
}
}

d_q_qsq_dV_S_B = (d_q_qsq_dV_S_B-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dV_S_B+d_q_qi_int_dV_S_B*q_qcoth)+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2))+d_q_qsq_dV_S_B)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dV_S_B+d_q_qi_int_dV_S_B*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_qsq_dTemp_Tnode_GND = (d_q_qsq_dTemp_Tnode_GND-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_qcoth)+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2))+d_q_qsq_dTemp_Tnode_GND)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_qsq_dV_D_S = (d_q_qsq_dV_D_S-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dV_D_S+d_q_qi_int_dV_D_S*q_qcoth)+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2))+d_q_qsq_dV_D_S)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dV_D_S+d_q_qi_int_dV_D_S*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_qsq_dV_G_S = (d_q_qsq_dV_G_S-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dV_G_S+d_q_qi_int_dV_G_S*q_qcoth)+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2))+d_q_qsq_dV_G_S)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dV_G_S+d_q_qi_int_dV_G_S*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
q_qsq = (q_qsq-((((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)/((q_qi_int*q_d1_qcoth)+1.0)));

d_q_delta_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_qsq_dV_S_B);
d_q_delta_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_qsq_dTemp_Tnode_GND);
d_q_delta_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_qsq_dV_D_S);
d_q_delta_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_qsq_dV_G_S);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));

d_q_zero_dV_S_B = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dV_S_B-q_delta*d_A0_dV_S_B)/A0/A0)))-d_xg1x_dV_S_B)+d_q1s_dV_S_B)+d_q_delta_dV_S_B*((value_log_0-xg1x)+q1s));
d_q_zero_dTemp_Tnode_GND = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dTemp_Tnode_GND-q_delta*d_A0_dTemp_Tnode_GND)/A0/A0)))-d_xg1x_dTemp_Tnode_GND)+d_q1s_dTemp_Tnode_GND)+d_q_delta_dTemp_Tnode_GND*((value_log_0-xg1x)+q1s));
d_q_zero_dV_D_S = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dV_D_S-q_delta*d_A0_dV_D_S)/A0/A0)))-d_xg1x_dV_D_S)+d_q1s_dV_D_S)+d_q_delta_dV_D_S*((value_log_0-xg1x)+q1s));
d_q_zero_dV_G_S = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dV_G_S-q_delta*d_A0_dV_G_S)/A0/A0)))-d_xg1x_dV_G_S)+d_q1s_dV_G_S)+d_q_delta_dV_G_S*((value_log_0-xg1x)+q1s));
q_zero = (q_delta*((value_log_0-xg1x)+q1s));
}

d_q_d1_zero_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_delta_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_delta_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_delta_dV_D_S);
d_q_d1_zero_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_delta_dV_G_S);
q_d1_zero = (((2.0*k1)*q_k1q1)+q_delta);

d_q_dx1_dV_S_B = ((d_xg1x_dV_S_B-d_q1s_dV_S_B)-d_q_x1sat_dV_S_B);
d_q_dx1_dV_D_S = ((d_xg1x_dV_D_S-d_q1s_dV_D_S)-d_q_x1sat_dV_D_S);
d_q_dx1_dV_G_S = ((d_xg1x_dV_G_S-d_q1s_dV_G_S)-d_q_x1sat_dV_G_S);
d_q_dx1_dTemp_Tnode_GND = ((d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)-d_q_x1sat_dTemp_Tnode_GND);
q_dx1 = ((xg1x-q1s)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(k1))>0.0))||(q_dx1>1.0)))
{

d_q1s_dV_S_B = (d_q1s_dV_S_B-((q_d1_zero*d_q_zero_dV_S_B-q_zero*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero));
d_q1s_dV_D_S = (d_q1s_dV_D_S-((q_d1_zero*d_q_zero_dV_D_S-q_zero*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero));
d_q1s_dV_G_S = (d_q1s_dV_G_S-((q_d1_zero*d_q_zero_dV_G_S-q_zero*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero));
d_q1s_dTemp_Tnode_GND = (d_q1s_dTemp_Tnode_GND-((q_d1_zero*d_q_zero_dTemp_Tnode_GND-q_zero*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero));
q1s = (q1s-(q_zero/q_d1_zero));
}
}

d_q_k1q1_dV_S_B = (k1*d_q1s_dV_S_B+d_k1_dV_S_B*q1s);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1s_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1s);
d_q_k1q1_dV_D_S = (k1*d_q1s_dV_D_S+d_k1_dV_D_S*q1s);
d_q_k1q1_dV_G_S = (k1*d_q1s_dV_G_S+d_k1_dV_G_S*q1s);
q_k1q1 = (k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*((d_xg1x_dV_S_B-d_q1s_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*((d_xg1x_dV_D_S-d_q1s_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*((d_xg1x_dV_G_S-d_q1s_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*((d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*0.3333333333333+0.5*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*0.3333333333333+0.5*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*0.3333333333333+0.5*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*0.3333333333333+0.5*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}

d_q_Aexp_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_q_Aexp_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_q_Aexp_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_q_Aexp_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
q_Aexp = (A0*q_temp1);

d_q_qsq_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_Aexp_dV_S_B);
d_q_qsq_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_qsq_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_Aexp_dV_D_S);
d_q_qsq_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_Aexp_dV_G_S);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);

d_q_d1_qsq_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_Aexp_dV_S_B);
d_q_d1_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_qsq_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_Aexp_dV_D_S);
d_q_d1_qsq_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_Aexp_dV_G_S);
q_d1_qsq = (((2.0*k1)*q_k1q1)+q_Aexp);

d_q_d2_qsq_dV_S_B = (((2.0*k1)*d_k1_dV_S_B+2.0*d_k1_dV_S_B*k1)-d_q_Aexp_dV_S_B);
d_q_d2_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_k1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*k1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_qsq_dV_D_S = (((2.0*k1)*d_k1_dV_D_S+2.0*d_k1_dV_D_S*k1)-d_q_Aexp_dV_D_S);
d_q_d2_qsq_dV_G_S = (((2.0*k1)*d_k1_dV_G_S+2.0*d_k1_dV_G_S*k1)-d_q_Aexp_dV_G_S);
q_d2_qsq = (((2.0*k1)*k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{

d_q_temp3_dV_S_B = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_S_B*0.025)+d_q_qsq_dV_S_B*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_S_B*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dTemp_Tnode_GND*0.025)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_D_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_D_S*0.025)+d_q_qsq_dV_D_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_D_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_G_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_G_S*0.025)+d_q_qsq_dV_G_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_G_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));

d_q_qcoth_dV_S_B = (q_qsq*d_q_temp3_dV_S_B+d_q_qsq_dV_S_B*q_temp3);
d_q_qcoth_dTemp_Tnode_GND = (q_qsq*d_q_temp3_dTemp_Tnode_GND+d_q_qsq_dTemp_Tnode_GND*q_temp3);
d_q_qcoth_dV_D_S = (q_qsq*d_q_temp3_dV_D_S+d_q_qsq_dV_D_S*q_temp3);
d_q_qcoth_dV_G_S = (q_qsq*d_q_temp3_dV_G_S+d_q_qsq_dV_G_S*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));

d_q_temp1_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));

d_q_d1_qcoth_dV_S_B = (q_d1_qsq*d_q_temp1_dV_S_B+d_q_d1_qsq_dV_S_B*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = (q_d1_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_temp1);
d_q_d1_qcoth_dV_D_S = (q_d1_qsq*d_q_temp1_dV_D_S+d_q_d1_qsq_dV_D_S*q_temp1);
d_q_d1_qcoth_dV_G_S = (q_d1_qsq*d_q_temp1_dV_G_S+d_q_d1_qsq_dV_G_S*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);

d_q_temp2_dV_S_B = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_S_B*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dTemp_Tnode_GND = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_D_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_D_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_G_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_G_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));

d_q_d2_qcoth_dV_S_B = ((q_d2_qsq*d_q_temp1_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_S_B+(q_d1_qsq*d_q_d1_qsq_dV_S_B+d_q_d1_qsq_dV_S_B*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dTemp_Tnode_GND = ((q_d2_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dTemp_Tnode_GND+(q_d1_qsq*d_q_d1_qsq_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_D_S = ((q_d2_qsq*d_q_temp1_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_D_S+(q_d1_qsq*d_q_d1_qsq_dV_D_S+d_q_d1_qsq_dV_D_S*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_G_S = ((q_d2_qsq*d_q_temp1_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_G_S+(q_d1_qsq*d_q_d1_qsq_dV_G_S+d_q_d1_qsq_dV_G_S*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));

d_q_d1_ln_dV_S_B = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d1_qsq_dV_S_B*q_temp3);
d_q_d1_ln_dTemp_Tnode_GND = (((-0.5)*q_d1_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d1_qsq_dTemp_Tnode_GND*q_temp3);
d_q_d1_ln_dV_D_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d1_qsq_dV_D_S*q_temp3);
d_q_d1_ln_dV_G_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d1_qsq_dV_G_S*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);

d_q_d2_ln_dV_S_B = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d2_qsq_dV_S_B*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_S_B)+d_q_qsq_dV_S_B*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_S_B+(0.25*0.0055555555556)*d_q_d1_qsq_dV_S_B*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dTemp_Tnode_GND = ((((-0.5)*q_d2_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d2_qsq_dTemp_Tnode_GND*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dTemp_Tnode_GND)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dTemp_Tnode_GND+(0.25*0.0055555555556)*d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_D_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d2_qsq_dV_D_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_D_S)+d_q_qsq_dV_D_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_D_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_D_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_G_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d2_qsq_dV_G_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_G_S)+d_q_qsq_dV_G_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_G_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_G_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{

d_q_temp2_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_S_B-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dTemp_Tnode_GND-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_D_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_G_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));

d_q_sh_term_dV_S_B = (q_temp2*d_q_invexpq_dV_S_B+d_q_temp2_dV_S_B*q_invexpq);
d_q_sh_term_dTemp_Tnode_GND = (q_temp2*d_q_invexpq_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_invexpq);
d_q_sh_term_dV_D_S = (q_temp2*d_q_invexpq_dV_D_S+d_q_temp2_dV_D_S*q_invexpq);
d_q_sh_term_dV_G_S = (q_temp2*d_q_invexpq_dV_G_S+d_q_temp2_dV_G_S*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);

d_q_ln_term_dV_S_B = ((deriv_log_0_d0*(d_q_temp2_dV_S_B))-d_q_rac_qsq_dV_S_B);
d_q_ln_term_dTemp_Tnode_GND = ((deriv_log_0_d0*(d_q_temp2_dTemp_Tnode_GND))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_ln_term_dV_D_S = ((deriv_log_0_d0*(d_q_temp2_dV_D_S))-d_q_rac_qsq_dV_D_S);
d_q_ln_term_dV_G_S = ((deriv_log_0_d0*(d_q_temp2_dV_G_S))-d_q_rac_qsq_dV_G_S);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_sh_term_dV_S_B = (((q_temp2*q_temp2)*(-d_q_qsq_dV_S_B)-(-q_qsq)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dTemp_Tnode_GND = (((q_temp2*q_temp2)*(-d_q_qsq_dTemp_Tnode_GND)-(-q_qsq)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_D_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_D_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_G_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_G_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
else
{

d_q_sh_term_dV_S_B = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_S_B*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dTemp_Tnode_GND = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_D_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_D_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_G_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_G_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{

d_q_expnum_dV_S_B = (d_q_k1q1_dV_S_B+d_q_qcoth_dV_S_B);
d_q_expnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_expnum_dV_D_S = (d_q_k1q1_dV_D_S+d_q_qcoth_dV_D_S);
d_q_expnum_dV_G_S = (d_q_k1q1_dV_G_S+d_q_qcoth_dV_G_S);
q_expnum = (q_k1q1+q_qcoth);

d_q_d1_expnum_dV_S_B = (d_k1_dV_S_B+d_q_d1_qcoth_dV_S_B);
d_q_d1_expnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND);
d_q_d1_expnum_dV_D_S = (d_k1_dV_D_S+d_q_d1_qcoth_dV_D_S);
d_q_d1_expnum_dV_G_S = (d_k1_dV_G_S+d_q_d1_qcoth_dV_G_S);
q_d1_expnum = (k1+q_d1_qcoth);

d_q_d2_expnum_dV_S_B = d_q_d2_qcoth_dV_S_B;
d_q_d2_expnum_dTemp_Tnode_GND = d_q_d2_qcoth_dTemp_Tnode_GND;
d_q_d2_expnum_dV_D_S = d_q_d2_qcoth_dV_D_S;
d_q_d2_expnum_dV_G_S = d_q_d2_qcoth_dV_G_S;
q_d2_expnum = q_d2_qcoth;
}
else
{

d_q_temp2_dV_S_B = (-(d_q_k1q1_dV_S_B-d_q_qcoth_dV_S_B)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dTemp_Tnode_GND = (-(d_q_k1q1_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_D_S = (-(d_q_k1q1_dV_D_S-d_q_qcoth_dV_D_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_G_S = (-(d_q_k1q1_dV_G_S-d_q_qcoth_dV_G_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));

d_q_temp3_dV_S_B = (d_q_d1_qcoth_dV_S_B-d_k1_dV_S_B);
d_q_temp3_dTemp_Tnode_GND = (d_q_d1_qcoth_dTemp_Tnode_GND-d_k1_dTemp_Tnode_GND);
d_q_temp3_dV_D_S = (d_q_d1_qcoth_dV_D_S-d_k1_dV_D_S);
d_q_temp3_dV_G_S = (d_q_d1_qcoth_dV_G_S-d_k1_dV_G_S);
q_temp3 = (q_d1_qcoth-k1);

d_q_expnum_dV_S_B = ((q_Aexp-q_sh_term)*d_q_temp2_dV_S_B+(d_q_Aexp_dV_S_B-d_q_sh_term_dV_S_B)*q_temp2);
d_q_expnum_dV_D_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_D_S+(d_q_Aexp_dV_D_S-d_q_sh_term_dV_D_S)*q_temp2);
d_q_expnum_dV_G_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_G_S+(d_q_Aexp_dV_G_S-d_q_sh_term_dV_G_S)*q_temp2);
d_q_expnum_dTemp_Tnode_GND = ((q_Aexp-q_sh_term)*d_q_temp2_dTemp_Tnode_GND+(d_q_Aexp_dTemp_Tnode_GND-d_q_sh_term_dTemp_Tnode_GND)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);

d_q_d1_expnum_dV_S_B = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_S_B+(((q_temp3*d_q_expnum_dV_S_B+d_q_temp3_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B)-(q_d1_ln*d_q_sh_term_dV_S_B+d_q_d1_ln_dV_S_B*q_sh_term))*q_temp2);
d_q_d1_expnum_dTemp_Tnode_GND = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+(((q_temp3*d_q_expnum_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND)-(q_d1_ln*d_q_sh_term_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_D_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_D_S+(((q_temp3*d_q_expnum_dV_D_S+d_q_temp3_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S)-(q_d1_ln*d_q_sh_term_dV_D_S+d_q_d1_ln_dV_D_S*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_G_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_G_S+(((q_temp3*d_q_expnum_dV_G_S+d_q_temp3_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S)-(q_d1_ln*d_q_sh_term_dV_G_S+d_q_d1_ln_dV_G_S*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);

d_q_d2_expnum_dV_S_B = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_S_B+((((q_d2_qcoth*d_q_expnum_dV_S_B+d_q_d2_qcoth_dV_S_B*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_S_B+2.0*d_q_temp3_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_S_B+(d_q_d2_ln_dV_S_B+(q_d1_ln*d_q_d1_ln_dV_S_B+d_q_d1_ln_dV_S_B*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dTemp_Tnode_GND = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+((((q_d2_qcoth*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qcoth_dTemp_Tnode_GND*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_temp3_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dTemp_Tnode_GND+(d_q_d2_ln_dTemp_Tnode_GND+(q_d1_ln*d_q_d1_ln_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_D_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_D_S+((((q_d2_qcoth*d_q_expnum_dV_D_S+d_q_d2_qcoth_dV_D_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_D_S+2.0*d_q_temp3_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_D_S+(d_q_d2_ln_dV_D_S+(q_d1_ln*d_q_d1_ln_dV_D_S+d_q_d1_ln_dV_D_S*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_G_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_G_S+((((q_d2_qcoth*d_q_expnum_dV_G_S+d_q_d2_qcoth_dV_G_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_G_S+2.0*d_q_temp3_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_G_S+(d_q_d2_ln_dV_G_S+(q_d1_ln*d_q_d1_ln_dV_G_S+d_q_d1_ln_dV_G_S*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);

d_q_lnexpnum_dV_S_B = (deriv_log_0_d0*(d_q_expnum_dV_S_B));
d_q_lnexpnum_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_expnum_dTemp_Tnode_GND));
d_q_lnexpnum_dV_D_S = (deriv_log_0_d0*(d_q_expnum_dV_D_S));
d_q_lnexpnum_dV_G_S = (deriv_log_0_d0*(d_q_expnum_dV_G_S));
q_lnexpnum = value_log_0;
}

d_q_temp1_dV_S_B = (-d_q_expnum_dV_S_B/q_expnum/q_expnum);
d_q_temp1_dTemp_Tnode_GND = (-d_q_expnum_dTemp_Tnode_GND/q_expnum/q_expnum);
d_q_temp1_dV_D_S = (-d_q_expnum_dV_D_S/q_expnum/q_expnum);
d_q_temp1_dV_G_S = (-d_q_expnum_dV_G_S/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);

d_q_d1_lnexpnum_dV_S_B = (q_d1_expnum*d_q_temp1_dV_S_B+d_q_d1_expnum_dV_S_B*q_temp1);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (q_d1_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d1_expnum_dTemp_Tnode_GND*q_temp1);
d_q_d1_lnexpnum_dV_D_S = (q_d1_expnum*d_q_temp1_dV_D_S+d_q_d1_expnum_dV_D_S*q_temp1);
d_q_d1_lnexpnum_dV_G_S = (q_d1_expnum*d_q_temp1_dV_G_S+d_q_d1_expnum_dV_G_S*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((q_d2_expnum*d_q_temp1_dV_S_B+d_q_d2_expnum_dV_S_B*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_S_B+d_q_d1_lnexpnum_dV_S_B*q_d1_lnexpnum));
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((q_d2_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d2_expnum_dTemp_Tnode_GND*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dTemp_Tnode_GND+d_q_d1_lnexpnum_dTemp_Tnode_GND*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_D_S = ((q_d2_expnum*d_q_temp1_dV_D_S+d_q_d2_expnum_dV_D_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_D_S+d_q_d1_lnexpnum_dV_D_S*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_G_S = ((q_d2_expnum*d_q_temp1_dV_G_S+d_q_d2_expnum_dV_G_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_G_S+d_q_d1_lnexpnum_dV_G_S*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));

d_q_lnexpnum_dV_S_B = (d_q_k1q1_dV_S_B+(deriv_log_0_d0*((-d_q_k1q1_dV_S_B))));
d_q_lnexpnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(deriv_log_0_d0*((-d_q_k1q1_dTemp_Tnode_GND))));
d_q_lnexpnum_dV_D_S = (d_q_k1q1_dV_D_S+(deriv_log_0_d0*((-d_q_k1q1_dV_D_S))));
d_q_lnexpnum_dV_G_S = (d_q_k1q1_dV_G_S+(deriv_log_0_d0*((-d_q_k1q1_dV_G_S))));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}

d_q_temp1_dV_S_B = (-d_q1s_dV_S_B/q1s/q1s);
d_q_temp1_dV_D_S = (-d_q1s_dV_D_S/q1s/q1s);
d_q_temp1_dV_G_S = (-d_q1s_dV_G_S/q1s/q1s);
d_q_temp1_dTemp_Tnode_GND = (-d_q1s_dTemp_Tnode_GND/q1s/q1s);
q_temp1 = (1.0/q1s);

d_q_d1_lnexpnum_dV_S_B = (d_k1_dV_S_B+d_q_temp1_dV_S_B);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_temp1_dTemp_Tnode_GND);
d_q_d1_lnexpnum_dV_D_S = (d_k1_dV_D_S+d_q_temp1_dV_D_S);
d_q_d1_lnexpnum_dV_G_S = (d_k1_dV_G_S+d_q_temp1_dV_G_S);
q_d1_lnexpnum = (k1+q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((-q_temp1)*d_q_temp1_dV_S_B+(-d_q_temp1_dV_S_B)*q_temp1);
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((-q_temp1)*d_q_temp1_dTemp_Tnode_GND+(-d_q_temp1_dTemp_Tnode_GND)*q_temp1);
d_q_d2_lnexpnum_dV_D_S = ((-q_temp1)*d_q_temp1_dV_D_S+(-d_q_temp1_dV_D_S)*q_temp1);
d_q_d2_lnexpnum_dV_G_S = ((-q_temp1)*d_q_temp1_dV_G_S+(-d_q_temp1_dV_G_S)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}

d_q_q2_int_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1s_dV_S_B)+2.0*d_q_lnexpnum_dV_S_B)-d_q_ln_term_dV_S_B);
d_q_q2_int_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1s_dTemp_Tnode_GND)+2.0*d_q_lnexpnum_dTemp_Tnode_GND)-d_q_ln_term_dTemp_Tnode_GND);
d_q_q2_int_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1s_dV_D_S)+2.0*d_q_lnexpnum_dV_D_S)-d_q_ln_term_dV_D_S);
d_q_q2_int_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1s_dV_G_S)+2.0*d_q_lnexpnum_dV_G_S)-d_q_ln_term_dV_G_S);
q_q2_int = ((((xg2x-xg1x)+q1s)+(2.0*q_lnexpnum))-q_ln_term);

d_q_d1_q2_dV_S_B = (2.0*d_q_d1_lnexpnum_dV_S_B-d_q_d1_ln_dV_S_B);
d_q_d1_q2_dTemp_Tnode_GND = (2.0*d_q_d1_lnexpnum_dTemp_Tnode_GND-d_q_d1_ln_dTemp_Tnode_GND);
d_q_d1_q2_dV_D_S = (2.0*d_q_d1_lnexpnum_dV_D_S-d_q_d1_ln_dV_D_S);
d_q_d1_q2_dV_G_S = (2.0*d_q_d1_lnexpnum_dV_G_S-d_q_d1_ln_dV_G_S);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);

d_q_d2_q2_dV_S_B = (2.0*d_q_d2_lnexpnum_dV_S_B-d_q_d2_ln_dV_S_B);
d_q_d2_q2_dTemp_Tnode_GND = (2.0*d_q_d2_lnexpnum_dTemp_Tnode_GND-d_q_d2_ln_dTemp_Tnode_GND);
d_q_d2_q2_dV_D_S = (2.0*d_q_d2_lnexpnum_dV_D_S-d_q_d2_ln_dV_D_S);
d_q_d2_q2_dV_G_S = (2.0*d_q_d2_lnexpnum_dV_G_S-d_q_d2_ln_dV_G_S);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+(k2*d_q_q2_int_dV_S_B+d_k2_dV_S_B*q_q2_int));
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(k2*d_q_q2_int_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_q2_int));
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+(k2*d_q_q2_int_dV_D_S+d_k2_dV_D_S*q_q2_int));
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+(k2*d_q_q2_int_dV_G_S+d_k2_dV_G_S*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));

d_q_d1_qi_dV_S_B = (d_k1_dV_S_B+(k2*d_q_d1_q2_dV_S_B+d_k2_dV_S_B*q_d1_q2));
d_q_d1_qi_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+(k2*d_q_d1_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d1_q2));
d_q_d1_qi_dV_D_S = (d_k1_dV_D_S+(k2*d_q_d1_q2_dV_D_S+d_k2_dV_D_S*q_d1_q2));
d_q_d1_qi_dV_G_S = (d_k1_dV_G_S+(k2*d_q_d1_q2_dV_G_S+d_k2_dV_G_S*q_d1_q2));
q_d1_qi = (k1+(k2*q_d1_q2));

d_q_d2_qi_dV_S_B = (k2*d_q_d2_q2_dV_S_B+d_k2_dV_S_B*q_d2_q2);
d_q_d2_qi_dTemp_Tnode_GND = (k2*d_q_d2_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d2_q2);
d_q_d2_qi_dV_D_S = (k2*d_q_d2_q2_dV_D_S+d_k2_dV_D_S*q_d2_q2);
d_q_d2_qi_dV_G_S = (k2*d_q_d2_q2_dV_G_S+d_k2_dV_G_S*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);

d_q_zero_dV_S_B = ((q_qi_int*d_q_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B);
d_q_zero_dTemp_Tnode_GND = ((q_qi_int*d_q_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND);
d_q_zero_dV_D_S = ((q_qi_int*d_q_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S);
d_q_zero_dV_G_S = ((q_qi_int*d_q_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{

d_q_eps2_dV_G_S = d_q_eps2_dV_D_S = d_q_eps2_dTemp_Tnode_GND = d_q_eps2_dV_S_B =  0.0;
q_eps2 = 0.0;
}
else
{

d_q_d1_zero_dV_S_B = (((q_d1_qi*d_q_expnum_dV_S_B+d_q_d1_qi_dV_S_B*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((q_d1_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d1_qi_dTemp_Tnode_GND*q_expnum)+(q_qi_int*d_q_d1_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((q_d1_qi*d_q_expnum_dV_D_S+d_q_d1_qi_dV_D_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S);
d_q_d1_zero_dV_G_S = (((q_d1_qi*d_q_expnum_dV_G_S+d_q_d1_qi_dV_G_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);

d_q_d2_zero_dV_S_B = ((((q_d2_qi*d_q_expnum_dV_S_B+d_q_d2_qi_dV_S_B*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_S_B+2.0*d_q_d1_qi_dV_S_B*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d2_expnum))-d_q_Aexp_dV_S_B);
d_q_d2_zero_dTemp_Tnode_GND = ((((q_d2_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qi_dTemp_Tnode_GND*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_d1_qi_dTemp_Tnode_GND*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d2_expnum))-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_zero_dV_D_S = ((((q_d2_qi*d_q_expnum_dV_D_S+d_q_d2_qi_dV_D_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_D_S+2.0*d_q_d1_qi_dV_D_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d2_expnum))-d_q_Aexp_dV_D_S);
d_q_d2_zero_dV_G_S = ((((q_d2_qi*d_q_expnum_dV_G_S+d_q_d2_qi_dV_G_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_G_S+2.0*d_q_d1_qi_dV_G_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d2_expnum))-d_q_Aexp_dV_G_S);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);

d_q_eps1_dV_S_B = ((q_d1_zero*(-d_q_zero_dV_S_B)-(-q_zero)*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero);
d_q_eps1_dTemp_Tnode_GND = ((q_d1_zero*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_D_S = ((q_d1_zero*(-d_q_zero_dV_D_S)-(-q_zero)*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_G_S = ((q_d1_zero*(-d_q_zero_dV_G_S)-(-q_zero)*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);

d_q_eps2_dV_S_B = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_S_B)-(-q_zero)*(d_q_d1_zero_dV_S_B+((0.5*q_eps1)*d_q_d2_zero_dV_S_B+0.5*d_q_eps1_dV_S_B*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dTemp_Tnode_GND = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*(d_q_d1_zero_dTemp_Tnode_GND+((0.5*q_eps1)*d_q_d2_zero_dTemp_Tnode_GND+0.5*d_q_eps1_dTemp_Tnode_GND*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_D_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_D_S)-(-q_zero)*(d_q_d1_zero_dV_D_S+((0.5*q_eps1)*d_q_d2_zero_dV_D_S+0.5*d_q_eps1_dV_D_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_G_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_G_S)-(-q_zero)*(d_q_d1_zero_dV_G_S+((0.5*q_eps1)*d_q_d2_zero_dV_G_S+0.5*d_q_eps1_dV_G_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}

d_q1s_dV_S_B = (d_q1s_dV_S_B+d_q_eps2_dV_S_B);
d_q1s_dV_D_S = (d_q1s_dV_D_S+d_q_eps2_dV_D_S);
d_q1s_dV_G_S = (d_q1s_dV_G_S+d_q_eps2_dV_G_S);
d_q1s_dTemp_Tnode_GND = (d_q1s_dTemp_Tnode_GND+d_q_eps2_dTemp_Tnode_GND);
q1s = (q1s+q_eps2);

d_q_k1q1_dV_S_B = (k1*d_q1s_dV_S_B+d_k1_dV_S_B*q1s);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1s_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1s);
d_q_k1q1_dV_D_S = (k1*d_q1s_dV_D_S+d_k1_dV_D_S*q1s);
d_q_k1q1_dV_G_S = (k1*d_q1s_dV_G_S+d_k1_dV_G_S*q1s);
q_k1q1 = (k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*((d_xg1x_dV_S_B-d_q1s_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*((d_xg1x_dV_D_S-d_q1s_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*((d_xg1x_dV_G_S-d_q1s_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*((d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*0.3333333333333+0.5*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*0.3333333333333+0.5*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*0.3333333333333+0.5*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*0.3333333333333+0.5*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}

d_q_Aexp_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_q_Aexp_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_q_Aexp_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_q_Aexp_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
q_Aexp = (A0*q_temp1);

d_q_qsq_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_Aexp_dV_S_B);
d_q_qsq_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_qsq_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_Aexp_dV_D_S);
d_q_qsq_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_Aexp_dV_G_S);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);

d_q_d1_qsq_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_Aexp_dV_S_B);
d_q_d1_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_qsq_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_Aexp_dV_D_S);
d_q_d1_qsq_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_Aexp_dV_G_S);
q_d1_qsq = (((2.0*k1)*q_k1q1)+q_Aexp);

d_q_d2_qsq_dV_S_B = (((2.0*k1)*d_k1_dV_S_B+2.0*d_k1_dV_S_B*k1)-d_q_Aexp_dV_S_B);
d_q_d2_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_k1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*k1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_qsq_dV_D_S = (((2.0*k1)*d_k1_dV_D_S+2.0*d_k1_dV_D_S*k1)-d_q_Aexp_dV_D_S);
d_q_d2_qsq_dV_G_S = (((2.0*k1)*d_k1_dV_G_S+2.0*d_k1_dV_G_S*k1)-d_q_Aexp_dV_G_S);
q_d2_qsq = (((2.0*k1)*k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{

d_q_temp3_dV_S_B = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_S_B*0.025)+d_q_qsq_dV_S_B*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_S_B*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dTemp_Tnode_GND*0.025)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_D_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_D_S*0.025)+d_q_qsq_dV_D_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_D_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_G_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_G_S*0.025)+d_q_qsq_dV_G_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_G_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));

d_q_qcoth_dV_S_B = (q_qsq*d_q_temp3_dV_S_B+d_q_qsq_dV_S_B*q_temp3);
d_q_qcoth_dTemp_Tnode_GND = (q_qsq*d_q_temp3_dTemp_Tnode_GND+d_q_qsq_dTemp_Tnode_GND*q_temp3);
d_q_qcoth_dV_D_S = (q_qsq*d_q_temp3_dV_D_S+d_q_qsq_dV_D_S*q_temp3);
d_q_qcoth_dV_G_S = (q_qsq*d_q_temp3_dV_G_S+d_q_qsq_dV_G_S*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));

d_q_temp1_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));

d_q_d1_qcoth_dV_S_B = (q_d1_qsq*d_q_temp1_dV_S_B+d_q_d1_qsq_dV_S_B*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = (q_d1_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_temp1);
d_q_d1_qcoth_dV_D_S = (q_d1_qsq*d_q_temp1_dV_D_S+d_q_d1_qsq_dV_D_S*q_temp1);
d_q_d1_qcoth_dV_G_S = (q_d1_qsq*d_q_temp1_dV_G_S+d_q_d1_qsq_dV_G_S*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);

d_q_temp2_dV_S_B = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_S_B*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dTemp_Tnode_GND = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_D_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_D_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_G_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_G_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));

d_q_d2_qcoth_dV_S_B = ((q_d2_qsq*d_q_temp1_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_S_B+(q_d1_qsq*d_q_d1_qsq_dV_S_B+d_q_d1_qsq_dV_S_B*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dTemp_Tnode_GND = ((q_d2_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dTemp_Tnode_GND+(q_d1_qsq*d_q_d1_qsq_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_D_S = ((q_d2_qsq*d_q_temp1_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_D_S+(q_d1_qsq*d_q_d1_qsq_dV_D_S+d_q_d1_qsq_dV_D_S*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_G_S = ((q_d2_qsq*d_q_temp1_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_G_S+(q_d1_qsq*d_q_d1_qsq_dV_G_S+d_q_d1_qsq_dV_G_S*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));

d_q_d1_ln_dV_S_B = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d1_qsq_dV_S_B*q_temp3);
d_q_d1_ln_dTemp_Tnode_GND = (((-0.5)*q_d1_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d1_qsq_dTemp_Tnode_GND*q_temp3);
d_q_d1_ln_dV_D_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d1_qsq_dV_D_S*q_temp3);
d_q_d1_ln_dV_G_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d1_qsq_dV_G_S*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);

d_q_d2_ln_dV_S_B = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d2_qsq_dV_S_B*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_S_B)+d_q_qsq_dV_S_B*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_S_B+(0.25*0.0055555555556)*d_q_d1_qsq_dV_S_B*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dTemp_Tnode_GND = ((((-0.5)*q_d2_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d2_qsq_dTemp_Tnode_GND*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dTemp_Tnode_GND)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dTemp_Tnode_GND+(0.25*0.0055555555556)*d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_D_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d2_qsq_dV_D_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_D_S)+d_q_qsq_dV_D_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_D_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_D_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_G_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d2_qsq_dV_G_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_G_S)+d_q_qsq_dV_G_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_G_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_G_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{

d_q_temp2_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_S_B-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dTemp_Tnode_GND-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_D_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_G_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));

d_q_sh_term_dV_S_B = (q_temp2*d_q_invexpq_dV_S_B+d_q_temp2_dV_S_B*q_invexpq);
d_q_sh_term_dTemp_Tnode_GND = (q_temp2*d_q_invexpq_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_invexpq);
d_q_sh_term_dV_D_S = (q_temp2*d_q_invexpq_dV_D_S+d_q_temp2_dV_D_S*q_invexpq);
d_q_sh_term_dV_G_S = (q_temp2*d_q_invexpq_dV_G_S+d_q_temp2_dV_G_S*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);

d_q_ln_term_dV_S_B = ((deriv_log_0_d0*(d_q_temp2_dV_S_B))-d_q_rac_qsq_dV_S_B);
d_q_ln_term_dTemp_Tnode_GND = ((deriv_log_0_d0*(d_q_temp2_dTemp_Tnode_GND))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_ln_term_dV_D_S = ((deriv_log_0_d0*(d_q_temp2_dV_D_S))-d_q_rac_qsq_dV_D_S);
d_q_ln_term_dV_G_S = ((deriv_log_0_d0*(d_q_temp2_dV_G_S))-d_q_rac_qsq_dV_G_S);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_sh_term_dV_S_B = (((q_temp2*q_temp2)*(-d_q_qsq_dV_S_B)-(-q_qsq)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dTemp_Tnode_GND = (((q_temp2*q_temp2)*(-d_q_qsq_dTemp_Tnode_GND)-(-q_qsq)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_D_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_D_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_G_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_G_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
else
{

d_q_sh_term_dV_S_B = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_S_B*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dTemp_Tnode_GND = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_D_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_D_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_G_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_G_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{

d_q_expnum_dV_S_B = (d_q_k1q1_dV_S_B+d_q_qcoth_dV_S_B);
d_q_expnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_expnum_dV_D_S = (d_q_k1q1_dV_D_S+d_q_qcoth_dV_D_S);
d_q_expnum_dV_G_S = (d_q_k1q1_dV_G_S+d_q_qcoth_dV_G_S);
q_expnum = (q_k1q1+q_qcoth);

d_q_d1_expnum_dV_S_B = (d_k1_dV_S_B+d_q_d1_qcoth_dV_S_B);
d_q_d1_expnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND);
d_q_d1_expnum_dV_D_S = (d_k1_dV_D_S+d_q_d1_qcoth_dV_D_S);
d_q_d1_expnum_dV_G_S = (d_k1_dV_G_S+d_q_d1_qcoth_dV_G_S);
q_d1_expnum = (k1+q_d1_qcoth);

d_q_d2_expnum_dV_S_B = d_q_d2_qcoth_dV_S_B;
d_q_d2_expnum_dTemp_Tnode_GND = d_q_d2_qcoth_dTemp_Tnode_GND;
d_q_d2_expnum_dV_D_S = d_q_d2_qcoth_dV_D_S;
d_q_d2_expnum_dV_G_S = d_q_d2_qcoth_dV_G_S;
q_d2_expnum = q_d2_qcoth;
}
else
{

d_q_temp2_dV_S_B = (-(d_q_k1q1_dV_S_B-d_q_qcoth_dV_S_B)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dTemp_Tnode_GND = (-(d_q_k1q1_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_D_S = (-(d_q_k1q1_dV_D_S-d_q_qcoth_dV_D_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_G_S = (-(d_q_k1q1_dV_G_S-d_q_qcoth_dV_G_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));

d_q_temp3_dV_S_B = (d_q_d1_qcoth_dV_S_B-d_k1_dV_S_B);
d_q_temp3_dTemp_Tnode_GND = (d_q_d1_qcoth_dTemp_Tnode_GND-d_k1_dTemp_Tnode_GND);
d_q_temp3_dV_D_S = (d_q_d1_qcoth_dV_D_S-d_k1_dV_D_S);
d_q_temp3_dV_G_S = (d_q_d1_qcoth_dV_G_S-d_k1_dV_G_S);
q_temp3 = (q_d1_qcoth-k1);

d_q_expnum_dV_S_B = ((q_Aexp-q_sh_term)*d_q_temp2_dV_S_B+(d_q_Aexp_dV_S_B-d_q_sh_term_dV_S_B)*q_temp2);
d_q_expnum_dV_D_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_D_S+(d_q_Aexp_dV_D_S-d_q_sh_term_dV_D_S)*q_temp2);
d_q_expnum_dV_G_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_G_S+(d_q_Aexp_dV_G_S-d_q_sh_term_dV_G_S)*q_temp2);
d_q_expnum_dTemp_Tnode_GND = ((q_Aexp-q_sh_term)*d_q_temp2_dTemp_Tnode_GND+(d_q_Aexp_dTemp_Tnode_GND-d_q_sh_term_dTemp_Tnode_GND)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);

d_q_d1_expnum_dV_S_B = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_S_B+(((q_temp3*d_q_expnum_dV_S_B+d_q_temp3_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B)-(q_d1_ln*d_q_sh_term_dV_S_B+d_q_d1_ln_dV_S_B*q_sh_term))*q_temp2);
d_q_d1_expnum_dTemp_Tnode_GND = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+(((q_temp3*d_q_expnum_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND)-(q_d1_ln*d_q_sh_term_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_D_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_D_S+(((q_temp3*d_q_expnum_dV_D_S+d_q_temp3_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S)-(q_d1_ln*d_q_sh_term_dV_D_S+d_q_d1_ln_dV_D_S*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_G_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_G_S+(((q_temp3*d_q_expnum_dV_G_S+d_q_temp3_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S)-(q_d1_ln*d_q_sh_term_dV_G_S+d_q_d1_ln_dV_G_S*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);

d_q_d2_expnum_dV_S_B = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_S_B+((((q_d2_qcoth*d_q_expnum_dV_S_B+d_q_d2_qcoth_dV_S_B*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_S_B+2.0*d_q_temp3_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_S_B+(d_q_d2_ln_dV_S_B+(q_d1_ln*d_q_d1_ln_dV_S_B+d_q_d1_ln_dV_S_B*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dTemp_Tnode_GND = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+((((q_d2_qcoth*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qcoth_dTemp_Tnode_GND*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_temp3_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dTemp_Tnode_GND+(d_q_d2_ln_dTemp_Tnode_GND+(q_d1_ln*d_q_d1_ln_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_D_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_D_S+((((q_d2_qcoth*d_q_expnum_dV_D_S+d_q_d2_qcoth_dV_D_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_D_S+2.0*d_q_temp3_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_D_S+(d_q_d2_ln_dV_D_S+(q_d1_ln*d_q_d1_ln_dV_D_S+d_q_d1_ln_dV_D_S*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_G_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_G_S+((((q_d2_qcoth*d_q_expnum_dV_G_S+d_q_d2_qcoth_dV_G_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_G_S+2.0*d_q_temp3_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_G_S+(d_q_d2_ln_dV_G_S+(q_d1_ln*d_q_d1_ln_dV_G_S+d_q_d1_ln_dV_G_S*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);

d_q_lnexpnum_dV_S_B = (deriv_log_0_d0*(d_q_expnum_dV_S_B));
d_q_lnexpnum_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_expnum_dTemp_Tnode_GND));
d_q_lnexpnum_dV_D_S = (deriv_log_0_d0*(d_q_expnum_dV_D_S));
d_q_lnexpnum_dV_G_S = (deriv_log_0_d0*(d_q_expnum_dV_G_S));
q_lnexpnum = value_log_0;
}

d_q_temp1_dV_S_B = (-d_q_expnum_dV_S_B/q_expnum/q_expnum);
d_q_temp1_dTemp_Tnode_GND = (-d_q_expnum_dTemp_Tnode_GND/q_expnum/q_expnum);
d_q_temp1_dV_D_S = (-d_q_expnum_dV_D_S/q_expnum/q_expnum);
d_q_temp1_dV_G_S = (-d_q_expnum_dV_G_S/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);

d_q_d1_lnexpnum_dV_S_B = (q_d1_expnum*d_q_temp1_dV_S_B+d_q_d1_expnum_dV_S_B*q_temp1);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (q_d1_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d1_expnum_dTemp_Tnode_GND*q_temp1);
d_q_d1_lnexpnum_dV_D_S = (q_d1_expnum*d_q_temp1_dV_D_S+d_q_d1_expnum_dV_D_S*q_temp1);
d_q_d1_lnexpnum_dV_G_S = (q_d1_expnum*d_q_temp1_dV_G_S+d_q_d1_expnum_dV_G_S*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((q_d2_expnum*d_q_temp1_dV_S_B+d_q_d2_expnum_dV_S_B*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_S_B+d_q_d1_lnexpnum_dV_S_B*q_d1_lnexpnum));
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((q_d2_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d2_expnum_dTemp_Tnode_GND*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dTemp_Tnode_GND+d_q_d1_lnexpnum_dTemp_Tnode_GND*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_D_S = ((q_d2_expnum*d_q_temp1_dV_D_S+d_q_d2_expnum_dV_D_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_D_S+d_q_d1_lnexpnum_dV_D_S*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_G_S = ((q_d2_expnum*d_q_temp1_dV_G_S+d_q_d2_expnum_dV_G_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_G_S+d_q_d1_lnexpnum_dV_G_S*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));

d_q_lnexpnum_dV_S_B = (d_q_k1q1_dV_S_B+(deriv_log_0_d0*((-d_q_k1q1_dV_S_B))));
d_q_lnexpnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(deriv_log_0_d0*((-d_q_k1q1_dTemp_Tnode_GND))));
d_q_lnexpnum_dV_D_S = (d_q_k1q1_dV_D_S+(deriv_log_0_d0*((-d_q_k1q1_dV_D_S))));
d_q_lnexpnum_dV_G_S = (d_q_k1q1_dV_G_S+(deriv_log_0_d0*((-d_q_k1q1_dV_G_S))));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}

d_q_temp1_dV_S_B = (-d_q1s_dV_S_B/q1s/q1s);
d_q_temp1_dV_D_S = (-d_q1s_dV_D_S/q1s/q1s);
d_q_temp1_dV_G_S = (-d_q1s_dV_G_S/q1s/q1s);
d_q_temp1_dTemp_Tnode_GND = (-d_q1s_dTemp_Tnode_GND/q1s/q1s);
q_temp1 = (1.0/q1s);

d_q_d1_lnexpnum_dV_S_B = (d_k1_dV_S_B+d_q_temp1_dV_S_B);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_temp1_dTemp_Tnode_GND);
d_q_d1_lnexpnum_dV_D_S = (d_k1_dV_D_S+d_q_temp1_dV_D_S);
d_q_d1_lnexpnum_dV_G_S = (d_k1_dV_G_S+d_q_temp1_dV_G_S);
q_d1_lnexpnum = (k1+q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((-q_temp1)*d_q_temp1_dV_S_B+(-d_q_temp1_dV_S_B)*q_temp1);
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((-q_temp1)*d_q_temp1_dTemp_Tnode_GND+(-d_q_temp1_dTemp_Tnode_GND)*q_temp1);
d_q_d2_lnexpnum_dV_D_S = ((-q_temp1)*d_q_temp1_dV_D_S+(-d_q_temp1_dV_D_S)*q_temp1);
d_q_d2_lnexpnum_dV_G_S = ((-q_temp1)*d_q_temp1_dV_G_S+(-d_q_temp1_dV_G_S)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}

d_q_q2_int_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1s_dV_S_B)+2.0*d_q_lnexpnum_dV_S_B)-d_q_ln_term_dV_S_B);
d_q_q2_int_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1s_dTemp_Tnode_GND)+2.0*d_q_lnexpnum_dTemp_Tnode_GND)-d_q_ln_term_dTemp_Tnode_GND);
d_q_q2_int_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1s_dV_D_S)+2.0*d_q_lnexpnum_dV_D_S)-d_q_ln_term_dV_D_S);
d_q_q2_int_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1s_dV_G_S)+2.0*d_q_lnexpnum_dV_G_S)-d_q_ln_term_dV_G_S);
q_q2_int = ((((xg2x-xg1x)+q1s)+(2.0*q_lnexpnum))-q_ln_term);

d_q_d1_q2_dV_S_B = (2.0*d_q_d1_lnexpnum_dV_S_B-d_q_d1_ln_dV_S_B);
d_q_d1_q2_dTemp_Tnode_GND = (2.0*d_q_d1_lnexpnum_dTemp_Tnode_GND-d_q_d1_ln_dTemp_Tnode_GND);
d_q_d1_q2_dV_D_S = (2.0*d_q_d1_lnexpnum_dV_D_S-d_q_d1_ln_dV_D_S);
d_q_d1_q2_dV_G_S = (2.0*d_q_d1_lnexpnum_dV_G_S-d_q_d1_ln_dV_G_S);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);

d_q_d2_q2_dV_S_B = (2.0*d_q_d2_lnexpnum_dV_S_B-d_q_d2_ln_dV_S_B);
d_q_d2_q2_dTemp_Tnode_GND = (2.0*d_q_d2_lnexpnum_dTemp_Tnode_GND-d_q_d2_ln_dTemp_Tnode_GND);
d_q_d2_q2_dV_D_S = (2.0*d_q_d2_lnexpnum_dV_D_S-d_q_d2_ln_dV_D_S);
d_q_d2_q2_dV_G_S = (2.0*d_q_d2_lnexpnum_dV_G_S-d_q_d2_ln_dV_G_S);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+(k2*d_q_q2_int_dV_S_B+d_k2_dV_S_B*q_q2_int));
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(k2*d_q_q2_int_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_q2_int));
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+(k2*d_q_q2_int_dV_D_S+d_k2_dV_D_S*q_q2_int));
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+(k2*d_q_q2_int_dV_G_S+d_k2_dV_G_S*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));

d_q_d1_qi_dV_S_B = (d_k1_dV_S_B+(k2*d_q_d1_q2_dV_S_B+d_k2_dV_S_B*q_d1_q2));
d_q_d1_qi_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+(k2*d_q_d1_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d1_q2));
d_q_d1_qi_dV_D_S = (d_k1_dV_D_S+(k2*d_q_d1_q2_dV_D_S+d_k2_dV_D_S*q_d1_q2));
d_q_d1_qi_dV_G_S = (d_k1_dV_G_S+(k2*d_q_d1_q2_dV_G_S+d_k2_dV_G_S*q_d1_q2));
q_d1_qi = (k1+(k2*q_d1_q2));

d_q_d2_qi_dV_S_B = (k2*d_q_d2_q2_dV_S_B+d_k2_dV_S_B*q_d2_q2);
d_q_d2_qi_dTemp_Tnode_GND = (k2*d_q_d2_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d2_q2);
d_q_d2_qi_dV_D_S = (k2*d_q_d2_q2_dV_D_S+d_k2_dV_D_S*q_d2_q2);
d_q_d2_qi_dV_G_S = (k2*d_q_d2_q2_dV_G_S+d_k2_dV_G_S*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);

d_q_zero_dV_S_B = ((q_qi_int*d_q_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B);
d_q_zero_dTemp_Tnode_GND = ((q_qi_int*d_q_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND);
d_q_zero_dV_D_S = ((q_qi_int*d_q_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S);
d_q_zero_dV_G_S = ((q_qi_int*d_q_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{

d_q_eps2_dV_G_S = d_q_eps2_dV_D_S = d_q_eps2_dTemp_Tnode_GND = d_q_eps2_dV_S_B =  0.0;
q_eps2 = 0.0;
}
else
{

d_q_d1_zero_dV_S_B = (((q_d1_qi*d_q_expnum_dV_S_B+d_q_d1_qi_dV_S_B*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((q_d1_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d1_qi_dTemp_Tnode_GND*q_expnum)+(q_qi_int*d_q_d1_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((q_d1_qi*d_q_expnum_dV_D_S+d_q_d1_qi_dV_D_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S);
d_q_d1_zero_dV_G_S = (((q_d1_qi*d_q_expnum_dV_G_S+d_q_d1_qi_dV_G_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);

d_q_d2_zero_dV_S_B = ((((q_d2_qi*d_q_expnum_dV_S_B+d_q_d2_qi_dV_S_B*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_S_B+2.0*d_q_d1_qi_dV_S_B*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d2_expnum))-d_q_Aexp_dV_S_B);
d_q_d2_zero_dTemp_Tnode_GND = ((((q_d2_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qi_dTemp_Tnode_GND*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_d1_qi_dTemp_Tnode_GND*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d2_expnum))-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_zero_dV_D_S = ((((q_d2_qi*d_q_expnum_dV_D_S+d_q_d2_qi_dV_D_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_D_S+2.0*d_q_d1_qi_dV_D_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d2_expnum))-d_q_Aexp_dV_D_S);
d_q_d2_zero_dV_G_S = ((((q_d2_qi*d_q_expnum_dV_G_S+d_q_d2_qi_dV_G_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_G_S+2.0*d_q_d1_qi_dV_G_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d2_expnum))-d_q_Aexp_dV_G_S);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);

d_q_eps1_dV_S_B = ((q_d1_zero*(-d_q_zero_dV_S_B)-(-q_zero)*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero);
d_q_eps1_dTemp_Tnode_GND = ((q_d1_zero*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_D_S = ((q_d1_zero*(-d_q_zero_dV_D_S)-(-q_zero)*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_G_S = ((q_d1_zero*(-d_q_zero_dV_G_S)-(-q_zero)*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);

d_q_eps2_dV_S_B = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_S_B)-(-q_zero)*(d_q_d1_zero_dV_S_B+((0.5*q_eps1)*d_q_d2_zero_dV_S_B+0.5*d_q_eps1_dV_S_B*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dTemp_Tnode_GND = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*(d_q_d1_zero_dTemp_Tnode_GND+((0.5*q_eps1)*d_q_d2_zero_dTemp_Tnode_GND+0.5*d_q_eps1_dTemp_Tnode_GND*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_D_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_D_S)-(-q_zero)*(d_q_d1_zero_dV_D_S+((0.5*q_eps1)*d_q_d2_zero_dV_D_S+0.5*d_q_eps1_dV_D_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_G_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_G_S)-(-q_zero)*(d_q_d1_zero_dV_G_S+((0.5*q_eps1)*d_q_d2_zero_dV_G_S+0.5*d_q_eps1_dV_G_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}

d_q1s_dV_S_B = (d_q1s_dV_S_B+d_q_eps2_dV_S_B);
d_q1s_dV_D_S = (d_q1s_dV_D_S+d_q_eps2_dV_D_S);
d_q1s_dV_G_S = (d_q1s_dV_G_S+d_q_eps2_dV_G_S);
d_q1s_dTemp_Tnode_GND = (d_q1s_dTemp_Tnode_GND+d_q_eps2_dTemp_Tnode_GND);
q1s = (q1s+q_eps2);

d_k1q1s_dV_S_B = (k1*d_q1s_dV_S_B+d_k1_dV_S_B*q1s);
d_k1q1s_dTemp_Tnode_GND = (k1*d_q1s_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1s);
d_k1q1s_dV_D_S = (k1*d_q1s_dV_D_S+d_k1_dV_D_S*q1s);
d_k1q1s_dV_G_S = (k1*d_q1s_dV_G_S+d_k1_dV_G_S*q1s);
k1q1s = (k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*((d_xg1x_dV_S_B-d_q1s_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*((d_xg1x_dV_D_S-d_q1s_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*((d_xg1x_dV_G_S-d_q1s_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*((d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*0.3333333333333+0.5*(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_S_B-d_q1s_dV_S_B)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*0.3333333333333+0.5*(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_D_S-d_q1s_dV_D_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*0.3333333333333+0.5*(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dV_G_S-d_q1s_dV_G_S)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*0.3333333333333+0.5*(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dTemp_Tnode_GND-d_q1s_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}

d_Aexp1s_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_Aexp1s_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_Aexp1s_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_Aexp1s_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
Aexp1s = (A0*q_temp1);

d_qsqs_dV_S_B = ((k1q1s*d_k1q1s_dV_S_B+d_k1q1s_dV_S_B*k1q1s)-d_Aexp1s_dV_S_B);
d_qsqs_dTemp_Tnode_GND = ((k1q1s*d_k1q1s_dTemp_Tnode_GND+d_k1q1s_dTemp_Tnode_GND*k1q1s)-d_Aexp1s_dTemp_Tnode_GND);
d_qsqs_dV_D_S = ((k1q1s*d_k1q1s_dV_D_S+d_k1q1s_dV_D_S*k1q1s)-d_Aexp1s_dV_D_S);
d_qsqs_dV_G_S = ((k1q1s*d_k1q1s_dV_G_S+d_k1q1s_dV_G_S*k1q1s)-d_Aexp1s_dV_G_S);
qsqs = ((k1q1s*k1q1s)-Aexp1s);
if ((Aexp1s==0.0))
{

d_qis_dTemp_Tnode_GND = d_qis_dV_G_S = d_qis_dV_D_S = d_qis_dV_S_B =  0.0;
qis = 1.0e-80;

d_k2q2s_dV_S_B = (d_qis_dV_S_B-d_k1q1s_dV_S_B);
d_k2q2s_dTemp_Tnode_GND = (d_qis_dTemp_Tnode_GND-d_k1q1s_dTemp_Tnode_GND);
d_k2q2s_dV_D_S = (d_qis_dV_D_S-d_k1q1s_dV_D_S);
d_k2q2s_dV_G_S = (d_qis_dV_G_S-d_k1q1s_dV_G_S);
k2q2s = (qis-k1q1s);

d_q2s_dV_S_B = ((k2*d_k2q2s_dV_S_B-k2q2s*d_k2_dV_S_B)/k2/k2);
d_q2s_dTemp_Tnode_GND = ((k2*d_k2q2s_dTemp_Tnode_GND-k2q2s*d_k2_dTemp_Tnode_GND)/k2/k2);
d_q2s_dV_D_S = ((k2*d_k2q2s_dV_D_S-k2q2s*d_k2_dV_D_S)/k2/k2);
d_q2s_dV_G_S = ((k2*d_k2q2s_dV_G_S-k2q2s*d_k2_dV_G_S)/k2/k2);
q2s = (k2q2s/k2);
}
else
{
if ((qsqs<(-0.005)))
{
{
double value_fabs_0 = fabs(qsqs);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqs)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
}
else
{
if ((qsqs>0.005))
{
{
double value_fabs_0 = fabs(qsqs);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqs)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqs_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
}
else
{

d_q_qcoth_dV_S_B = ((qsqs*0.1666666666667)*(-((qsqs*0.0166666666667)*(-d_qsqs_dV_S_B*0.0238095238095)+d_qsqs_dV_S_B*0.0166666666667*(1.0-(qsqs*0.0238095238095))))+d_qsqs_dV_S_B*0.1666666666667*(1.0-((qsqs*0.0166666666667)*(1.0-(qsqs*0.0238095238095)))));
d_q_qcoth_dTemp_Tnode_GND = ((qsqs*0.1666666666667)*(-((qsqs*0.0166666666667)*(-d_qsqs_dTemp_Tnode_GND*0.0238095238095)+d_qsqs_dTemp_Tnode_GND*0.0166666666667*(1.0-(qsqs*0.0238095238095))))+d_qsqs_dTemp_Tnode_GND*0.1666666666667*(1.0-((qsqs*0.0166666666667)*(1.0-(qsqs*0.0238095238095)))));
d_q_qcoth_dV_D_S = ((qsqs*0.1666666666667)*(-((qsqs*0.0166666666667)*(-d_qsqs_dV_D_S*0.0238095238095)+d_qsqs_dV_D_S*0.0166666666667*(1.0-(qsqs*0.0238095238095))))+d_qsqs_dV_D_S*0.1666666666667*(1.0-((qsqs*0.0166666666667)*(1.0-(qsqs*0.0238095238095)))));
d_q_qcoth_dV_G_S = ((qsqs*0.1666666666667)*(-((qsqs*0.0166666666667)*(-d_qsqs_dV_G_S*0.0238095238095)+d_qsqs_dV_G_S*0.0166666666667*(1.0-(qsqs*0.0238095238095))))+d_qsqs_dV_G_S*0.1666666666667*(1.0-((qsqs*0.0166666666667)*(1.0-(qsqs*0.0238095238095)))));
q_qcoth = (2.0+((qsqs*0.1666666666667)*(1.0-((qsqs*0.0166666666667)*(1.0-(qsqs*0.0238095238095))))));
}
}
if ((((1.01*k1q1s)+q_qcoth)>0.0))
{

d_q_temp1_dV_S_B = (d_k1q1s_dV_S_B+d_q_qcoth_dV_S_B);
d_q_temp1_dTemp_Tnode_GND = (d_k1q1s_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_temp1_dV_D_S = (d_k1q1s_dV_D_S+d_q_qcoth_dV_D_S);
d_q_temp1_dV_G_S = (d_k1q1s_dV_G_S+d_q_qcoth_dV_G_S);
q_temp1 = (k1q1s+q_qcoth);
if (((Aexp1s*k1q1s)<(((0.9*k1q1s)*k1q1s)*q_temp1)))
{

d_qis_dV_S_B = ((q_temp1*d_Aexp1s_dV_S_B-Aexp1s*d_q_temp1_dV_S_B)/q_temp1/q_temp1);
d_qis_dV_D_S = ((q_temp1*d_Aexp1s_dV_D_S-Aexp1s*d_q_temp1_dV_D_S)/q_temp1/q_temp1);
d_qis_dV_G_S = ((q_temp1*d_Aexp1s_dV_G_S-Aexp1s*d_q_temp1_dV_G_S)/q_temp1/q_temp1);
d_qis_dTemp_Tnode_GND = ((q_temp1*d_Aexp1s_dTemp_Tnode_GND-Aexp1s*d_q_temp1_dTemp_Tnode_GND)/q_temp1/q_temp1);
qis = ((Aexp1s/q_temp1)+1.0e-80);

d_k2q2s_dV_S_B = (d_qis_dV_S_B-d_k1q1s_dV_S_B);
d_k2q2s_dV_D_S = (d_qis_dV_D_S-d_k1q1s_dV_D_S);
d_k2q2s_dV_G_S = (d_qis_dV_G_S-d_k1q1s_dV_G_S);
d_k2q2s_dTemp_Tnode_GND = (d_qis_dTemp_Tnode_GND-d_k1q1s_dTemp_Tnode_GND);
k2q2s = (qis-k1q1s);

d_q2s_dV_S_B = ((k2*d_k2q2s_dV_S_B-k2q2s*d_k2_dV_S_B)/k2/k2);
d_q2s_dTemp_Tnode_GND = ((k2*d_k2q2s_dTemp_Tnode_GND-k2q2s*d_k2_dTemp_Tnode_GND)/k2/k2);
d_q2s_dV_D_S = ((k2*d_k2q2s_dV_D_S-k2q2s*d_k2_dV_D_S)/k2/k2);
d_q2s_dV_G_S = ((k2*d_k2q2s_dV_G_S-k2q2s*d_k2_dV_G_S)/k2/k2);
q2s = (k2q2s/k2);
}
else
{
if ((qsqs>0.005))
{
{
double value_log_0 = log(((4.0*qsqs)/(1.0-(q_invexpq*(2.0-q_invexpq)))));
double  deriv_log_0_d0 = (1.0/((4.0*qsqs)/(1.0-(q_invexpq*(2.0-q_invexpq)))));

d_q_temp2_dV_S_B = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqs_dV_S_B-(4.0*qsqs)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqs_dTemp_Tnode_GND-(4.0*qsqs)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqs_dV_D_S-(4.0*qsqs)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dV_D_S);
d_q_temp2_dV_G_S = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqs_dV_G_S-(4.0*qsqs)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dV_G_S);
q_temp2 = (value_log_0-q_rac_qsq);
}
}
else
{
if ((qsqs<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp3_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp3_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp3_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp3_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp3 = value_sin_0;
}
{
double value_log_0 = log(((-qsqs)/(q_temp3*q_temp3)));
double  deriv_log_0_d0 = (1.0/((-qsqs)/(q_temp3*q_temp3)));

d_q_temp2_dV_S_B = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqs_dV_S_B)-(-qsqs)*(q_temp3*d_q_temp3_dV_S_B+d_q_temp3_dV_S_B*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
d_q_temp2_dTemp_Tnode_GND = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqs_dTemp_Tnode_GND)-(-qsqs)*(q_temp3*d_q_temp3_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
d_q_temp2_dV_D_S = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqs_dV_D_S)-(-qsqs)*(q_temp3*d_q_temp3_dV_D_S+d_q_temp3_dV_D_S*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
d_q_temp2_dV_G_S = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqs_dV_G_S)-(-qsqs)*(q_temp3*d_q_temp3_dV_G_S+d_q_temp3_dV_G_S*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
q_temp2 = value_log_0;
}
}
else
{
{
double value_log_0 = log((4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs)))))));
double  deriv_log_0_d0 = (1.0/(4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs)))))));

d_q_temp2_dV_S_B = (deriv_log_0_d0*((-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dV_S_B)+0.05*d_qsqs_dV_S_B*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dV_S_B*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))));
d_q_temp2_dTemp_Tnode_GND = (deriv_log_0_d0*((-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dTemp_Tnode_GND)+0.05*d_qsqs_dTemp_Tnode_GND*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))));
d_q_temp2_dV_D_S = (deriv_log_0_d0*((-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dV_D_S)+0.05*d_qsqs_dV_D_S*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dV_D_S*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))));
d_q_temp2_dV_G_S = (deriv_log_0_d0*((-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dV_G_S)+0.05*d_qsqs_dV_G_S*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dV_G_S*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))));
q_temp2 = value_log_0;
}
}
}
{
double value_log_0 = log(q_temp1);
double  deriv_log_0_d0 = (1.0/q_temp1);

d_q2s_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1s_dV_S_B)+2.0*(deriv_log_0_d0*(d_q_temp1_dV_S_B)))-d_q_temp2_dV_S_B);
d_q2s_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1s_dTemp_Tnode_GND)+2.0*(deriv_log_0_d0*(d_q_temp1_dTemp_Tnode_GND)))-d_q_temp2_dTemp_Tnode_GND);
d_q2s_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1s_dV_D_S)+2.0*(deriv_log_0_d0*(d_q_temp1_dV_D_S)))-d_q_temp2_dV_D_S);
d_q2s_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1s_dV_G_S)+2.0*(deriv_log_0_d0*(d_q_temp1_dV_G_S)))-d_q_temp2_dV_G_S);
q2s = ((((xg2x-xg1x)+q1s)+(2.0*value_log_0))-q_temp2);
}

d_k2q2s_dV_S_B = (k2*d_q2s_dV_S_B+d_k2_dV_S_B*q2s);
d_k2q2s_dTemp_Tnode_GND = (k2*d_q2s_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q2s);
d_k2q2s_dV_D_S = (k2*d_q2s_dV_D_S+d_k2_dV_D_S*q2s);
d_k2q2s_dV_G_S = (k2*d_q2s_dV_G_S+d_k2_dV_G_S*q2s);
k2q2s = (k2*q2s);

d_qis_dV_S_B = (d_k1q1s_dV_S_B+d_k2q2s_dV_S_B);
d_qis_dTemp_Tnode_GND = (d_k1q1s_dTemp_Tnode_GND+d_k2q2s_dTemp_Tnode_GND);
d_qis_dV_D_S = (d_k1q1s_dV_D_S+d_k2q2s_dV_D_S);
d_qis_dV_G_S = (d_k1q1s_dV_G_S+d_k2q2s_dV_G_S);
qis = (k1q1s+k2q2s);
}
}
else
{
if ((qsqs>0.005))
{
if ((((q1s-xg1x)-q_rac_qsq)<80.0))
{
{
double value_exp_0 = exp(((q1s-xg1x)-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp3_dV_S_B = (deriv_exp_0_d0*(((d_q1s_dV_S_B-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)));
d_q_temp3_dV_D_S = (deriv_exp_0_d0*(((d_q1s_dV_D_S-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)));
d_q_temp3_dV_G_S = (deriv_exp_0_d0*(((d_q1s_dV_G_S-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)));
d_q_temp3_dTemp_Tnode_GND = (deriv_exp_0_d0*(((d_q1s_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)));
q_temp3 = value_exp_0;
}
}
else
{

d_q_temp3_dV_S_B = 5.54062e34*((((q1s-xg1x)-q_rac_qsq)-80.0)*((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*((d_q1s_dV_S_B-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)*0.3333333333333+0.5*((d_q1s_dV_S_B-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+((d_q1s_dV_S_B-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)*(1.0+((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
d_q_temp3_dV_D_S = 5.54062e34*((((q1s-xg1x)-q_rac_qsq)-80.0)*((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*((d_q1s_dV_D_S-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)*0.3333333333333+0.5*((d_q1s_dV_D_S-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+((d_q1s_dV_D_S-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)*(1.0+((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
d_q_temp3_dV_G_S = 5.54062e34*((((q1s-xg1x)-q_rac_qsq)-80.0)*((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*((d_q1s_dV_G_S-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)*0.3333333333333+0.5*((d_q1s_dV_G_S-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+((d_q1s_dV_G_S-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)*(1.0+((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
d_q_temp3_dTemp_Tnode_GND = 5.54062e34*((((q1s-xg1x)-q_rac_qsq)-80.0)*((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*((d_q1s_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)*0.3333333333333+0.5*((d_q1s_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+((d_q1s_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)*(1.0+((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
q_temp3 = (5.54062e34*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*(1.0+((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))))));
}

d_q_temp2_dV_S_B = ((A0*d_q_temp3_dV_S_B-q_temp3*d_A0_dV_S_B)/A0/A0);
d_q_temp2_dTemp_Tnode_GND = ((A0*d_q_temp3_dTemp_Tnode_GND-q_temp3*d_A0_dTemp_Tnode_GND)/A0/A0);
d_q_temp2_dV_D_S = ((A0*d_q_temp3_dV_D_S-q_temp3*d_A0_dV_D_S)/A0/A0);
d_q_temp2_dV_G_S = ((A0*d_q_temp3_dV_G_S-q_temp3*d_A0_dV_G_S)/A0/A0);
q_temp2 = (q_temp3/A0);

d_q_temp1_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqs)*d_q_temp2_dV_S_B+4.0*d_qsqs_dV_S_B*q_temp2)-((4.0*qsqs)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp1_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqs)*d_q_temp2_dTemp_Tnode_GND+4.0*d_qsqs_dTemp_Tnode_GND*q_temp2)-((4.0*qsqs)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp1_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqs)*d_q_temp2_dV_D_S+4.0*d_qsqs_dV_D_S*q_temp2)-((4.0*qsqs)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp1_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqs)*d_q_temp2_dV_G_S+4.0*d_qsqs_dV_G_S*q_temp2)-((4.0*qsqs)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp1 = (((4.0*qsqs)*q_temp2)/(1.0-(q_invexpq*(2.0-q_invexpq))));
}
else
{
if ((qsqs<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_temp1_dV_S_B = ((Aexp1s*(((q_temp2*q_temp2)*(-d_qsqs_dV_S_B)-(-qsqs)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqs)/(q_temp2*q_temp2))*d_Aexp1s_dV_S_B)/Aexp1s/Aexp1s);
d_q_temp1_dTemp_Tnode_GND = ((Aexp1s*(((q_temp2*q_temp2)*(-d_qsqs_dTemp_Tnode_GND)-(-qsqs)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqs)/(q_temp2*q_temp2))*d_Aexp1s_dTemp_Tnode_GND)/Aexp1s/Aexp1s);
d_q_temp1_dV_D_S = ((Aexp1s*(((q_temp2*q_temp2)*(-d_qsqs_dV_D_S)-(-qsqs)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqs)/(q_temp2*q_temp2))*d_Aexp1s_dV_D_S)/Aexp1s/Aexp1s);
d_q_temp1_dV_G_S = ((Aexp1s*(((q_temp2*q_temp2)*(-d_qsqs_dV_G_S)-(-qsqs)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqs)/(q_temp2*q_temp2))*d_Aexp1s_dV_G_S)/Aexp1s/Aexp1s);
q_temp1 = (((-qsqs)/(q_temp2*q_temp2))/Aexp1s);
}
else
{

d_q_temp1_dV_S_B = ((Aexp1s*(-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dV_S_B)+0.05*d_qsqs_dV_S_B*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dV_S_B*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))-(4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))*d_Aexp1s_dV_S_B)/Aexp1s/Aexp1s);
d_q_temp1_dTemp_Tnode_GND = ((Aexp1s*(-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dTemp_Tnode_GND)+0.05*d_qsqs_dTemp_Tnode_GND*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))-(4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))*d_Aexp1s_dTemp_Tnode_GND)/Aexp1s/Aexp1s);
d_q_temp1_dV_D_S = ((Aexp1s*(-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dV_D_S)+0.05*d_qsqs_dV_D_S*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dV_D_S*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))-(4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))*d_Aexp1s_dV_D_S)/Aexp1s/Aexp1s);
d_q_temp1_dV_G_S = ((Aexp1s*(-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dV_G_S)+0.05*d_qsqs_dV_G_S*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dV_G_S*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))-(4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))*d_Aexp1s_dV_G_S)/Aexp1s/Aexp1s);
q_temp1 = ((4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))/Aexp1s);
}
}

d_qis_dV_S_B = (((1.0-q_temp1)*(d_k1q1s_dV_S_B-d_q_qcoth_dV_S_B)-(k1q1s-q_qcoth)*(-d_q_temp1_dV_S_B))/(1.0-q_temp1)/(1.0-q_temp1));
d_qis_dTemp_Tnode_GND = (((1.0-q_temp1)*(d_k1q1s_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)-(k1q1s-q_qcoth)*(-d_q_temp1_dTemp_Tnode_GND))/(1.0-q_temp1)/(1.0-q_temp1));
d_qis_dV_D_S = (((1.0-q_temp1)*(d_k1q1s_dV_D_S-d_q_qcoth_dV_D_S)-(k1q1s-q_qcoth)*(-d_q_temp1_dV_D_S))/(1.0-q_temp1)/(1.0-q_temp1));
d_qis_dV_G_S = (((1.0-q_temp1)*(d_k1q1s_dV_G_S-d_q_qcoth_dV_G_S)-(k1q1s-q_qcoth)*(-d_q_temp1_dV_G_S))/(1.0-q_temp1)/(1.0-q_temp1));
qis = (((k1q1s-q_qcoth)/(1.0-q_temp1))+1.0e-80);

d_k2q2s_dV_S_B = (d_qis_dV_S_B-d_k1q1s_dV_S_B);
d_k2q2s_dV_D_S = (d_qis_dV_D_S-d_k1q1s_dV_D_S);
d_k2q2s_dV_G_S = (d_qis_dV_G_S-d_k1q1s_dV_G_S);
d_k2q2s_dTemp_Tnode_GND = (d_qis_dTemp_Tnode_GND-d_k1q1s_dTemp_Tnode_GND);
k2q2s = (qis-k1q1s);

d_q2s_dV_S_B = ((k2*d_k2q2s_dV_S_B-k2q2s*d_k2_dV_S_B)/k2/k2);
d_q2s_dTemp_Tnode_GND = ((k2*d_k2q2s_dTemp_Tnode_GND-k2q2s*d_k2_dTemp_Tnode_GND)/k2/k2);
d_q2s_dV_D_S = ((k2*d_k2q2s_dV_D_S-k2q2s*d_k2_dV_D_S)/k2/k2);
d_q2s_dV_G_S = ((k2*d_k2q2s_dV_G_S-k2q2s*d_k2_dV_G_S)/k2/k2);
q2s = (k2q2s/k2);
}
}
if ((((xg2x-q2s))<80.0))
{
{
double value_exp_0 = exp(((xg2x-q2s)));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*((d_xg2x_dV_S_B-d_q2s_dV_S_B)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*((d_xg2x_dTemp_Tnode_GND-d_q2s_dTemp_Tnode_GND)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*((d_xg2x_dV_D_S-d_q2s_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*((d_xg2x_dV_G_S-d_q2s_dV_G_S)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg2x-q2s))-80.0)*((0.5*(((xg2x-q2s))-80.0))*(d_xg2x_dV_S_B-d_q2s_dV_S_B)*0.3333333333333+0.5*(d_xg2x_dV_S_B-d_q2s_dV_S_B)*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))+(d_xg2x_dV_S_B-d_q2s_dV_S_B)*(1.0+((0.5*(((xg2x-q2s))-80.0))*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg2x-q2s))-80.0)*((0.5*(((xg2x-q2s))-80.0))*(d_xg2x_dTemp_Tnode_GND-d_q2s_dTemp_Tnode_GND)*0.3333333333333+0.5*(d_xg2x_dTemp_Tnode_GND-d_q2s_dTemp_Tnode_GND)*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))+(d_xg2x_dTemp_Tnode_GND-d_q2s_dTemp_Tnode_GND)*(1.0+((0.5*(((xg2x-q2s))-80.0))*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg2x-q2s))-80.0)*((0.5*(((xg2x-q2s))-80.0))*(d_xg2x_dV_D_S-d_q2s_dV_D_S)*0.3333333333333+0.5*(d_xg2x_dV_D_S-d_q2s_dV_D_S)*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))+(d_xg2x_dV_D_S-d_q2s_dV_D_S)*(1.0+((0.5*(((xg2x-q2s))-80.0))*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg2x-q2s))-80.0)*((0.5*(((xg2x-q2s))-80.0))*(d_xg2x_dV_G_S-d_q2s_dV_G_S)*0.3333333333333+0.5*(d_xg2x_dV_G_S-d_q2s_dV_G_S)*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))+(d_xg2x_dV_G_S-d_q2s_dV_G_S)*(1.0+((0.5*(((xg2x-q2s))-80.0))*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg2x-q2s))-80.0)*(1.0+((0.5*(((xg2x-q2s))-80.0))*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))))));
}

d_Aexp2s_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_Aexp2s_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_Aexp2s_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_Aexp2s_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
Aexp2s = (A0*q_temp1);

d_a1s_dTemp_Tnode_GND = d_a1s_dV_G_S = d_a1s_dV_D_S = d_a1s_dV_S_B =  0.0;
a1s = 0.0;

d_a2s_dTemp_Tnode_GND = d_a2s_dV_G_S = d_a2s_dV_D_S = d_a2s_dV_S_B =  0.0;
a2s = 0.0;

d_b1s_dTemp_Tnode_GND = d_b1s_dV_G_S = d_b1s_dV_D_S = d_b1s_dV_S_B =  0.0;
b1s = 0.0;

d_b2s_dTemp_Tnode_GND = d_b2s_dV_G_S = d_b2s_dV_D_S = d_b2s_dV_S_B =  0.0;
b2s = 0.0;

d_sums_dTemp_Tnode_GND = d_sums_dV_G_S = d_sums_dV_D_S = d_sums_dV_S_B =  0.0;
sums = 0.0;

d_dqsqs_dxn_qi_dV_G_S = d_dqsqs_dxn_qi_dV_D_S = d_dqsqs_dxn_qi_dTemp_Tnode_GND = d_dqsqs_dxn_qi_dV_S_B =  0.0;
dqsqs_dxn_qi = 0.0;
if ((qis>1.0E-6))
{

d_b1s_dV_S_B = (Aexp1s*d_inv_k1_dV_S_B+d_Aexp1s_dV_S_B*inv_k1);
d_b1s_dV_D_S = (Aexp1s*d_inv_k1_dV_D_S+d_Aexp1s_dV_D_S*inv_k1);
d_b1s_dV_G_S = (Aexp1s*d_inv_k1_dV_G_S+d_Aexp1s_dV_G_S*inv_k1);
d_b1s_dTemp_Tnode_GND = (Aexp1s*d_inv_k1_dTemp_Tnode_GND+d_Aexp1s_dTemp_Tnode_GND*inv_k1);
b1s = (Aexp1s*inv_k1);

d_b2s_dV_S_B = (Aexp2s*d_inv_k2_dV_S_B+d_Aexp2s_dV_S_B*inv_k2);
d_b2s_dV_D_S = (Aexp2s*d_inv_k2_dV_D_S+d_Aexp2s_dV_D_S*inv_k2);
d_b2s_dV_G_S = (Aexp2s*d_inv_k2_dV_G_S+d_Aexp2s_dV_G_S*inv_k2);
d_b2s_dTemp_Tnode_GND = (Aexp2s*d_inv_k2_dTemp_Tnode_GND+d_Aexp2s_dTemp_Tnode_GND*inv_k2);
b2s = (Aexp2s*inv_k2);

d_a1s_dV_S_B = (d_b1s_dV_S_B+2.0*d_k1q1s_dV_S_B);
d_a1s_dV_D_S = (d_b1s_dV_D_S+2.0*d_k1q1s_dV_D_S);
d_a1s_dV_G_S = (d_b1s_dV_G_S+2.0*d_k1q1s_dV_G_S);
d_a1s_dTemp_Tnode_GND = (d_b1s_dTemp_Tnode_GND+2.0*d_k1q1s_dTemp_Tnode_GND);
a1s = (b1s+(2.0*k1q1s));

d_a2s_dV_S_B = (d_b2s_dV_S_B+2.0*d_k2q2s_dV_S_B);
d_a2s_dV_D_S = (d_b2s_dV_D_S+2.0*d_k2q2s_dV_D_S);
d_a2s_dV_G_S = (d_b2s_dV_G_S+2.0*d_k2q2s_dV_G_S);
d_a2s_dTemp_Tnode_GND = (d_b2s_dTemp_Tnode_GND+2.0*d_k2q2s_dTemp_Tnode_GND);
a2s = (b2s+(2.0*k2q2s));

d_sums_dV_S_B = ((2.0*d_qis_dV_S_B+d_b1s_dV_S_B)+d_b2s_dV_S_B);
d_sums_dV_D_S = ((2.0*d_qis_dV_D_S+d_b1s_dV_D_S)+d_b2s_dV_D_S);
d_sums_dV_G_S = ((2.0*d_qis_dV_G_S+d_b1s_dV_G_S)+d_b2s_dV_G_S);
d_sums_dTemp_Tnode_GND = ((2.0*d_qis_dTemp_Tnode_GND+d_b1s_dTemp_Tnode_GND)+d_b2s_dTemp_Tnode_GND);
sums = (((2.0*qis)+b1s)+b2s);
if ((fabs(qsqs)>0.005))
{

d_temp1_dV_S_B = (((a1s*d_a2s_dV_S_B+d_a1s_dV_S_B*a2s)+((2.0*(q1s+2.0))*d_a2s_dV_S_B+2.0*d_q1s_dV_S_B*a2s))+((2.0*(q2s+2.0))*d_a1s_dV_S_B+2.0*d_q2s_dV_S_B*a1s));
d_temp1_dV_D_S = (((a1s*d_a2s_dV_D_S+d_a1s_dV_D_S*a2s)+((2.0*(q1s+2.0))*d_a2s_dV_D_S+2.0*d_q1s_dV_D_S*a2s))+((2.0*(q2s+2.0))*d_a1s_dV_D_S+2.0*d_q2s_dV_D_S*a1s));
d_temp1_dV_G_S = (((a1s*d_a2s_dV_G_S+d_a1s_dV_G_S*a2s)+((2.0*(q1s+2.0))*d_a2s_dV_G_S+2.0*d_q1s_dV_G_S*a2s))+((2.0*(q2s+2.0))*d_a1s_dV_G_S+2.0*d_q2s_dV_G_S*a1s));
d_temp1_dTemp_Tnode_GND = (((a1s*d_a2s_dTemp_Tnode_GND+d_a1s_dTemp_Tnode_GND*a2s)+((2.0*(q1s+2.0))*d_a2s_dTemp_Tnode_GND+2.0*d_q1s_dTemp_Tnode_GND*a2s))+((2.0*(q2s+2.0))*d_a1s_dTemp_Tnode_GND+2.0*d_q2s_dTemp_Tnode_GND*a1s));
temp1 = (((a1s*a2s)+((2.0*(q1s+2.0))*a2s))+((2.0*(q2s+2.0))*a1s));

d_dqsqs_dxn_qi_dV_S_B = (((qis*temp1)*(((-4.0)*qsqs)*d_sums_dV_S_B+(-4.0)*d_qsqs_dV_S_B*sums)-(((-4.0)*qsqs)*sums)*(qis*d_temp1_dV_S_B+d_qis_dV_S_B*temp1))/(qis*temp1)/(qis*temp1));
d_dqsqs_dxn_qi_dTemp_Tnode_GND = (((qis*temp1)*(((-4.0)*qsqs)*d_sums_dTemp_Tnode_GND+(-4.0)*d_qsqs_dTemp_Tnode_GND*sums)-(((-4.0)*qsqs)*sums)*(qis*d_temp1_dTemp_Tnode_GND+d_qis_dTemp_Tnode_GND*temp1))/(qis*temp1)/(qis*temp1));
d_dqsqs_dxn_qi_dV_D_S = (((qis*temp1)*(((-4.0)*qsqs)*d_sums_dV_D_S+(-4.0)*d_qsqs_dV_D_S*sums)-(((-4.0)*qsqs)*sums)*(qis*d_temp1_dV_D_S+d_qis_dV_D_S*temp1))/(qis*temp1)/(qis*temp1));
d_dqsqs_dxn_qi_dV_G_S = (((qis*temp1)*(((-4.0)*qsqs)*d_sums_dV_G_S+(-4.0)*d_qsqs_dV_G_S*sums)-(((-4.0)*qsqs)*sums)*(qis*d_temp1_dV_G_S+d_qis_dV_G_S*temp1))/(qis*temp1)/(qis*temp1));
dqsqs_dxn_qi = ((((-4.0)*qsqs)*sums)/(qis*temp1));
}
else
{

d_temp1_dV_S_B = 0.1666666666667*(-((qsqs*0.0333333333333)*(-((qsqs*0.0357142857143)*(-d_qsqs_dV_S_B*0.0333333333333)+d_qsqs_dV_S_B*0.0357142857143*(1.0-(qsqs*0.0333333333333))))+d_qsqs_dV_S_B*0.0333333333333*(1.0-((qsqs*0.0357142857143)*(1.0-(qsqs*0.0333333333333))))));
d_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((qsqs*0.0333333333333)*(-((qsqs*0.0357142857143)*(-d_qsqs_dTemp_Tnode_GND*0.0333333333333)+d_qsqs_dTemp_Tnode_GND*0.0357142857143*(1.0-(qsqs*0.0333333333333))))+d_qsqs_dTemp_Tnode_GND*0.0333333333333*(1.0-((qsqs*0.0357142857143)*(1.0-(qsqs*0.0333333333333))))));
d_temp1_dV_D_S = 0.1666666666667*(-((qsqs*0.0333333333333)*(-((qsqs*0.0357142857143)*(-d_qsqs_dV_D_S*0.0333333333333)+d_qsqs_dV_D_S*0.0357142857143*(1.0-(qsqs*0.0333333333333))))+d_qsqs_dV_D_S*0.0333333333333*(1.0-((qsqs*0.0357142857143)*(1.0-(qsqs*0.0333333333333))))));
d_temp1_dV_G_S = 0.1666666666667*(-((qsqs*0.0333333333333)*(-((qsqs*0.0357142857143)*(-d_qsqs_dV_G_S*0.0333333333333)+d_qsqs_dV_G_S*0.0357142857143*(1.0-(qsqs*0.0333333333333))))+d_qsqs_dV_G_S*0.0333333333333*(1.0-((qsqs*0.0357142857143)*(1.0-(qsqs*0.0333333333333))))));
temp1 = (0.1666666666667*(1.0-((qsqs*0.0333333333333)*(1.0-((qsqs*0.0357142857143)*(1.0-(qsqs*0.0333333333333)))))));

d_temp2_dV_S_B = (((a1s*d_Aexp1s_dV_S_B+d_a1s_dV_S_B*Aexp1s)+(a2s*d_Aexp2s_dV_S_B+d_a2s_dV_S_B*Aexp2s))+(((a1s*a2s)*qis)*(qis*d_temp1_dV_S_B+d_qis_dV_S_B*temp1)+((a1s*a2s)*d_qis_dV_S_B+(a1s*d_a2s_dV_S_B+d_a1s_dV_S_B*a2s)*qis)*(1.0+(qis*temp1))));
d_temp2_dV_D_S = (((a1s*d_Aexp1s_dV_D_S+d_a1s_dV_D_S*Aexp1s)+(a2s*d_Aexp2s_dV_D_S+d_a2s_dV_D_S*Aexp2s))+(((a1s*a2s)*qis)*(qis*d_temp1_dV_D_S+d_qis_dV_D_S*temp1)+((a1s*a2s)*d_qis_dV_D_S+(a1s*d_a2s_dV_D_S+d_a1s_dV_D_S*a2s)*qis)*(1.0+(qis*temp1))));
d_temp2_dV_G_S = (((a1s*d_Aexp1s_dV_G_S+d_a1s_dV_G_S*Aexp1s)+(a2s*d_Aexp2s_dV_G_S+d_a2s_dV_G_S*Aexp2s))+(((a1s*a2s)*qis)*(qis*d_temp1_dV_G_S+d_qis_dV_G_S*temp1)+((a1s*a2s)*d_qis_dV_G_S+(a1s*d_a2s_dV_G_S+d_a1s_dV_G_S*a2s)*qis)*(1.0+(qis*temp1))));
d_temp2_dTemp_Tnode_GND = (((a1s*d_Aexp1s_dTemp_Tnode_GND+d_a1s_dTemp_Tnode_GND*Aexp1s)+(a2s*d_Aexp2s_dTemp_Tnode_GND+d_a2s_dTemp_Tnode_GND*Aexp2s))+(((a1s*a2s)*qis)*(qis*d_temp1_dTemp_Tnode_GND+d_qis_dTemp_Tnode_GND*temp1)+((a1s*a2s)*d_qis_dTemp_Tnode_GND+(a1s*d_a2s_dTemp_Tnode_GND+d_a1s_dTemp_Tnode_GND*a2s)*qis)*(1.0+(qis*temp1))));
temp2 = (((a1s*Aexp1s)+(a2s*Aexp2s))+(((a1s*a2s)*qis)*(1.0+(qis*temp1))));

d_dqsqs_dxn_qi_dV_S_B = (((qis*temp2)*((Aexp1s*Aexp2s)*d_sums_dV_S_B+(Aexp1s*d_Aexp2s_dV_S_B+d_Aexp1s_dV_S_B*Aexp2s)*sums)-((Aexp1s*Aexp2s)*sums)*(qis*d_temp2_dV_S_B+d_qis_dV_S_B*temp2))/(qis*temp2)/(qis*temp2));
d_dqsqs_dxn_qi_dV_D_S = (((qis*temp2)*((Aexp1s*Aexp2s)*d_sums_dV_D_S+(Aexp1s*d_Aexp2s_dV_D_S+d_Aexp1s_dV_D_S*Aexp2s)*sums)-((Aexp1s*Aexp2s)*sums)*(qis*d_temp2_dV_D_S+d_qis_dV_D_S*temp2))/(qis*temp2)/(qis*temp2));
d_dqsqs_dxn_qi_dV_G_S = (((qis*temp2)*((Aexp1s*Aexp2s)*d_sums_dV_G_S+(Aexp1s*d_Aexp2s_dV_G_S+d_Aexp1s_dV_G_S*Aexp2s)*sums)-((Aexp1s*Aexp2s)*sums)*(qis*d_temp2_dV_G_S+d_qis_dV_G_S*temp2))/(qis*temp2)/(qis*temp2));
d_dqsqs_dxn_qi_dTemp_Tnode_GND = (((qis*temp2)*((Aexp1s*Aexp2s)*d_sums_dTemp_Tnode_GND+(Aexp1s*d_Aexp2s_dTemp_Tnode_GND+d_Aexp1s_dTemp_Tnode_GND*Aexp2s)*sums)-((Aexp1s*Aexp2s)*sums)*(qis*d_temp2_dTemp_Tnode_GND+d_qis_dTemp_Tnode_GND*temp2))/(qis*temp2)/(qis*temp2));
dqsqs_dxn_qi = (((Aexp1s*Aexp2s)*sums)/(qis*temp2));
}
}
{
double value_log_0 = log(qis);
double  deriv_log_0_d0 = (1.0/qis);

d_xdrifts_dV_S_B = (deriv_log_0_d0*(d_qis_dV_S_B));
d_xdrifts_dV_D_S = (deriv_log_0_d0*(d_qis_dV_D_S));
d_xdrifts_dV_G_S = (deriv_log_0_d0*(d_qis_dV_G_S));
d_xdrifts_dTemp_Tnode_GND = (deriv_log_0_d0*(d_qis_dTemp_Tnode_GND));
xdrifts = value_log_0;
}
if (((k1q1s/2.0)<80.0))
{
{
double value_exp_0 = exp((k1q1s/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp1_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1s_dV_S_B/2.0)))));
d_temp1_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1s_dTemp_Tnode_GND/2.0)))));
d_temp1_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1s_dV_D_S/2.0)))));
d_temp1_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1s_dV_G_S/2.0)))));
temp1 = value_log_1;
}
}
else
{

d_temp1_dV_S_B = (d_k1q1s_dV_S_B/2.0);
d_temp1_dTemp_Tnode_GND = (d_k1q1s_dTemp_Tnode_GND/2.0);
d_temp1_dV_D_S = (d_k1q1s_dV_D_S/2.0);
d_temp1_dV_G_S = (d_k1q1s_dV_G_S/2.0);
temp1 = (k1q1s/2.0);
}

d_esurf1s_dTemp_Tnode_GND = 2.0*d_temp1_dTemp_Tnode_GND;
d_esurf1s_dV_D_S = 2.0*d_temp1_dV_D_S;
d_esurf1s_dV_G_S = 2.0*d_temp1_dV_G_S;
d_esurf1s_dV_S_B = 2.0*d_temp1_dV_S_B;
esurf1s = (2.0*temp1);
if (((k2q2s/2.0)<80.0))
{
{
double value_exp_0 = exp((k2q2s/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp2_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2s_dV_S_B/2.0)))));
d_temp2_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2s_dTemp_Tnode_GND/2.0)))));
d_temp2_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2s_dV_D_S/2.0)))));
d_temp2_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2s_dV_G_S/2.0)))));
temp2 = value_log_1;
}
}
else
{

d_temp2_dV_S_B = (d_k2q2s_dV_S_B/2.0);
d_temp2_dTemp_Tnode_GND = (d_k2q2s_dTemp_Tnode_GND/2.0);
d_temp2_dV_D_S = (d_k2q2s_dV_D_S/2.0);
d_temp2_dV_G_S = (d_k2q2s_dV_G_S/2.0);
temp2 = (k2q2s/2.0);
}

d_esurf2s_dV_S_B = 2.0*d_temp2_dV_S_B;
d_esurf2s_dV_D_S = 2.0*d_temp2_dV_D_S;
d_esurf2s_dTemp_Tnode_GND = 2.0*d_temp2_dTemp_Tnode_GND;
d_esurf2s_dV_G_S = 2.0*d_temp2_dV_G_S;
esurf2s = (2.0*temp2);

d_ecpl1s_dV_S_B = (d_esurf2s_dV_S_B-d_k2q2s_dV_S_B);
d_ecpl1s_dV_D_S = (d_esurf2s_dV_D_S-d_k2q2s_dV_D_S);
d_ecpl1s_dTemp_Tnode_GND = (d_esurf2s_dTemp_Tnode_GND-d_k2q2s_dTemp_Tnode_GND);
d_ecpl1s_dV_G_S = (d_esurf2s_dV_G_S-d_k2q2s_dV_G_S);
ecpl1s = (esurf2s-k2q2s);

d_ecpl2s_dTemp_Tnode_GND = (d_esurf1s_dTemp_Tnode_GND-d_k1q1s_dTemp_Tnode_GND);
d_ecpl2s_dV_D_S = (d_esurf1s_dV_D_S-d_k1q1s_dV_D_S);
d_ecpl2s_dV_G_S = (d_esurf1s_dV_G_S-d_k1q1s_dV_G_S);
d_ecpl2s_dV_S_B = (d_esurf1s_dV_S_B-d_k1q1s_dV_S_B);
ecpl2s = (esurf1s-k1q1s);

d_eeff1s_dTemp_Tnode_GND = (eta_mu*d_esurf1s_dTemp_Tnode_GND+one_m_eta*d_ecpl1s_dTemp_Tnode_GND);
d_eeff1s_dV_D_S = (eta_mu*d_esurf1s_dV_D_S+one_m_eta*d_ecpl1s_dV_D_S);
d_eeff1s_dV_G_S = (eta_mu*d_esurf1s_dV_G_S+one_m_eta*d_ecpl1s_dV_G_S);
d_eeff1s_dV_S_B = (eta_mu*d_esurf1s_dV_S_B+one_m_eta*d_ecpl1s_dV_S_B);
eeff1s = ((eta_mu*esurf1s)+(one_m_eta*ecpl1s));

d_eeff2s_dV_S_B = (eta_mu*d_esurf2s_dV_S_B+one_m_eta*d_ecpl2s_dV_S_B);
d_eeff2s_dV_D_S = (eta_mu*d_esurf2s_dV_D_S+one_m_eta*d_ecpl2s_dV_D_S);
d_eeff2s_dTemp_Tnode_GND = (eta_mu*d_esurf2s_dTemp_Tnode_GND+one_m_eta*d_ecpl2s_dTemp_Tnode_GND);
d_eeff2s_dV_G_S = (eta_mu*d_esurf2s_dV_G_S+one_m_eta*d_ecpl2s_dV_G_S);
eeff2s = ((eta_mu*esurf2s)+(one_m_eta*ecpl2s));

d_temp_dV_S_B = (((esurf1s+esurf2s)*d_qis_dV_S_B-qis*(d_esurf1s_dV_S_B+d_esurf2s_dV_S_B))/(esurf1s+esurf2s)/(esurf1s+esurf2s));
d_temp_dV_D_S = (((esurf1s+esurf2s)*d_qis_dV_D_S-qis*(d_esurf1s_dV_D_S+d_esurf2s_dV_D_S))/(esurf1s+esurf2s)/(esurf1s+esurf2s));
d_temp_dV_G_S = (((esurf1s+esurf2s)*d_qis_dV_G_S-qis*(d_esurf1s_dV_G_S+d_esurf2s_dV_G_S))/(esurf1s+esurf2s)/(esurf1s+esurf2s));
d_temp_dTemp_Tnode_GND = (((esurf1s+esurf2s)*d_qis_dTemp_Tnode_GND-qis*(d_esurf1s_dTemp_Tnode_GND+d_esurf2s_dTemp_Tnode_GND))/(esurf1s+esurf2s)/(esurf1s+esurf2s));
temp = (qis/(esurf1s+esurf2s));

d_qi1s_dTemp_Tnode_GND = (esurf1s*d_temp_dTemp_Tnode_GND+d_esurf1s_dTemp_Tnode_GND*temp);
d_qi1s_dV_D_S = (esurf1s*d_temp_dV_D_S+d_esurf1s_dV_D_S*temp);
d_qi1s_dV_G_S = (esurf1s*d_temp_dV_G_S+d_esurf1s_dV_G_S*temp);
d_qi1s_dV_S_B = (esurf1s*d_temp_dV_S_B+d_esurf1s_dV_S_B*temp);
qi1s = (esurf1s*temp);

d_qi2s_dV_S_B = (esurf2s*d_temp_dV_S_B+d_esurf2s_dV_S_B*temp);
d_qi2s_dV_D_S = (esurf2s*d_temp_dV_D_S+d_esurf2s_dV_D_S*temp);
d_qi2s_dTemp_Tnode_GND = (esurf2s*d_temp_dTemp_Tnode_GND+d_esurf2s_dTemp_Tnode_GND*temp);
d_qi2s_dV_G_S = (esurf2s*d_temp_dV_G_S+d_esurf2s_dV_G_S*temp);
qi2s = (esurf2s*temp);

d_c1s_dTemp_Tnode_GND = (esurf1s*d_BETN1_i_dTemp_Tnode_GND+d_esurf1s_dTemp_Tnode_GND*BETN1_i);
d_c1s_dV_D_S = d_esurf1s_dV_D_S*BETN1_i;
d_c1s_dV_G_S = d_esurf1s_dV_G_S*BETN1_i;
d_c1s_dV_S_B = d_esurf1s_dV_S_B*BETN1_i;
c1s = (esurf1s*BETN1_i);

d_c2s_dV_S_B = d_esurf2s_dV_S_B*BETN2_i;
d_c2s_dV_D_S = d_esurf2s_dV_D_S*BETN2_i;
d_c2s_dTemp_Tnode_GND = (esurf2s*d_BETN2_i_dTemp_Tnode_GND+d_esurf2s_dTemp_Tnode_GND*BETN2_i);
d_c2s_dV_G_S = d_esurf2s_dV_G_S*BETN2_i;
c2s = (esurf2s*BETN2_i);

d_temp1_dV_S_B = XCOR_i*(d_ecpl1s_dV_S_B+XCORB_i*d_ecpl2s_dV_S_B);
d_temp1_dV_D_S = XCOR_i*(d_ecpl1s_dV_D_S+XCORB_i*d_ecpl2s_dV_D_S);
d_temp1_dV_G_S = XCOR_i*(d_ecpl1s_dV_G_S+XCORB_i*d_ecpl2s_dV_G_S);
d_temp1_dTemp_Tnode_GND = (XCOR_i*(d_ecpl1s_dTemp_Tnode_GND+XCORB_i*d_ecpl2s_dTemp_Tnode_GND)+d_XCOR_i_dTemp_Tnode_GND*(ecpl1s+(XCORB_i*ecpl2s)));
temp1 = (XCOR_i*(ecpl1s+(XCORB_i*ecpl2s)));
{
double value_sqrt_0 = sqrt(((((1.0+temp1))*((1.0+temp1)))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp2_dTemp_Tnode_GND = 0.5*(d_temp1_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND*((1.0+temp1))))));
d_temp2_dV_D_S = 0.5*(d_temp1_dV_D_S+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dV_D_S+d_temp1_dV_D_S*((1.0+temp1))))));
d_temp2_dV_G_S = 0.5*(d_temp1_dV_G_S+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dV_G_S+d_temp1_dV_G_S*((1.0+temp1))))));
d_temp2_dV_S_B = 0.5*(d_temp1_dV_S_B+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dV_S_B+d_temp1_dV_S_B*((1.0+temp1))))));
temp2 = (0.5*((1.0+temp1)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((1.0+(0.2*temp1)))*((1.0+(0.2*temp1))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp3_dTemp_Tnode_GND = 0.5*(0.2*d_temp1_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dTemp_Tnode_GND+0.2*d_temp1_dTemp_Tnode_GND*((1.0+(0.2*temp1)))))));
d_temp3_dV_D_S = 0.5*(0.2*d_temp1_dV_D_S+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dV_D_S+0.2*d_temp1_dV_D_S*((1.0+(0.2*temp1)))))));
d_temp3_dV_G_S = 0.5*(0.2*d_temp1_dV_G_S+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dV_G_S+0.2*d_temp1_dV_G_S*((1.0+(0.2*temp1)))))));
d_temp3_dV_S_B = 0.5*(0.2*d_temp1_dV_S_B+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dV_S_B+0.2*d_temp1_dV_S_B*((1.0+(0.2*temp1)))))));
temp3 = (0.5*((1.0+(0.2*temp1))+value_sqrt_0));
}

d_fcors_dV_S_B = ((temp3*d_temp2_dV_S_B-temp2*d_temp3_dV_S_B)/temp3/temp3);
d_fcors_dV_D_S = ((temp3*d_temp2_dV_D_S-temp2*d_temp3_dV_D_S)/temp3/temp3);
d_fcors_dTemp_Tnode_GND = ((temp3*d_temp2_dTemp_Tnode_GND-temp2*d_temp3_dTemp_Tnode_GND)/temp3/temp3);
d_fcors_dV_G_S = ((temp3*d_temp2_dV_G_S-temp2*d_temp3_dV_G_S)/temp3/temp3);
fcors = (temp2/temp3);
{
double value_log_0 = log(((1.0+(qi1s*inv_qi1cs))+(qi2s*inv_qi2cs)));
double value_exp_1 = exp(((-THECS_i)*value_log_0));
double  deriv_log_0_d0 = (1.0/((1.0+(qi1s*inv_qi1cs))+(qi2s*inv_qi2cs)));
double  deriv_exp_1_d0 = value_exp_1;

d_Gcss_dV_S_B = ((CS_i*((1.0+(CSFI_i*ecpl1s))+(CSBI_i*ecpl2s)))*(deriv_exp_1_d0*((-THECS_i)*(deriv_log_0_d0*((d_qi1s_dV_S_B*inv_qi1cs+d_qi2s_dV_S_B*inv_qi2cs)))))+CS_i*(CSFI_i*d_ecpl1s_dV_S_B+CSBI_i*d_ecpl2s_dV_S_B)*value_exp_1);
d_Gcss_dV_D_S = ((CS_i*((1.0+(CSFI_i*ecpl1s))+(CSBI_i*ecpl2s)))*(deriv_exp_1_d0*((-THECS_i)*(deriv_log_0_d0*((d_qi1s_dV_D_S*inv_qi1cs+d_qi2s_dV_D_S*inv_qi2cs)))))+CS_i*(CSFI_i*d_ecpl1s_dV_D_S+CSBI_i*d_ecpl2s_dV_D_S)*value_exp_1);
d_Gcss_dV_G_S = ((CS_i*((1.0+(CSFI_i*ecpl1s))+(CSBI_i*ecpl2s)))*(deriv_exp_1_d0*((-THECS_i)*(deriv_log_0_d0*((d_qi1s_dV_G_S*inv_qi1cs+d_qi2s_dV_G_S*inv_qi2cs)))))+CS_i*(CSFI_i*d_ecpl1s_dV_G_S+CSBI_i*d_ecpl2s_dV_G_S)*value_exp_1);
d_Gcss_dTemp_Tnode_GND = ((CS_i*((1.0+(CSFI_i*ecpl1s))+(CSBI_i*ecpl2s)))*(deriv_exp_1_d0*(((-THECS_i)*(deriv_log_0_d0*((d_qi1s_dTemp_Tnode_GND*inv_qi1cs+d_qi2s_dTemp_Tnode_GND*inv_qi2cs)))+(-d_THECS_i_dTemp_Tnode_GND)*value_log_0)))+(CS_i*(CSFI_i*d_ecpl1s_dTemp_Tnode_GND+CSBI_i*d_ecpl2s_dTemp_Tnode_GND)+d_CS_i_dTemp_Tnode_GND*((1.0+(CSFI_i*ecpl1s))+(CSBI_i*ecpl2s)))*value_exp_1);
Gcss = ((CS_i*((1.0+(CSFI_i*ecpl1s))+(CSBI_i*ecpl2s)))*value_exp_1);
}
if ((RSG_i==0.0))
{

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = 1.0;
}
else
{
if ((RSG_i<0.0))
{
{
double value_log_0 = log((qis+1.0e-12));
double value_exp_1 = exp((THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(qis+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;

d_temp1_dV_S_B = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dV_S_B))));
d_temp1_dV_D_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dV_D_S))));
d_temp1_dV_G_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dV_G_S))));
d_temp1_dTemp_Tnode_GND = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dTemp_Tnode_GND))));
temp1 = (RSG_i*value_exp_1);
}

d_temp3_dTemp_Tnode_GND = (-d_temp1_dTemp_Tnode_GND);
d_temp3_dV_D_S = (-d_temp1_dV_D_S);
d_temp3_dV_G_S = (-d_temp1_dV_G_S);
d_temp3_dV_S_B = (-d_temp1_dV_S_B);
temp3 = (1.0-temp1);
}
else
{
{
double value_log_0 = log((qis+1.0e-12));
double value_exp_1 = exp((THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(qis+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;

d_temp1_dV_S_B = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dV_S_B))));
d_temp1_dV_D_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dV_D_S))));
d_temp1_dV_G_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dV_G_S))));
d_temp1_dTemp_Tnode_GND = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qis_dTemp_Tnode_GND))));
temp1 = (RSG_i*value_exp_1);
}

d_temp3_dTemp_Tnode_GND = (-d_temp1_dTemp_Tnode_GND/(1.0+temp1)/(1.0+temp1));
d_temp3_dV_D_S = (-d_temp1_dV_D_S/(1.0+temp1)/(1.0+temp1));
d_temp3_dV_G_S = (-d_temp1_dV_G_S/(1.0+temp1)/(1.0+temp1));
d_temp3_dV_S_B = (-d_temp1_dV_S_B/(1.0+temp1)/(1.0+temp1));
temp3 = (1.0/(1.0+temp1));
}
}
{
double value_sqrt_0 = sqrt(((((1.0-(RSB_i*xg20)))*((1.0-(RSB_i*xg20))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_frscsi_dV_S_B = (((frs*CsiPrime)*0.5)*((-RSB_i*d_xg20_dV_S_B)+(deriv_sqrt_0_d0*((((1.0-(RSB_i*xg20)))*(-RSB_i*d_xg20_dV_S_B)+(-RSB_i*d_xg20_dV_S_B)*((1.0-(RSB_i*xg20)))))))+frs*d_CsiPrime_dV_S_B*0.5*((1.0-(RSB_i*xg20))+value_sqrt_0));
d_frscsi_dV_D_S = (((frs*CsiPrime)*0.5)*((-RSB_i*d_xg20_dV_D_S)+(deriv_sqrt_0_d0*((((1.0-(RSB_i*xg20)))*(-RSB_i*d_xg20_dV_D_S)+(-RSB_i*d_xg20_dV_D_S)*((1.0-(RSB_i*xg20)))))))+frs*d_CsiPrime_dV_D_S*0.5*((1.0-(RSB_i*xg20))+value_sqrt_0));
d_frscsi_dV_G_S = frs*d_CsiPrime_dV_G_S*0.5*((1.0-(RSB_i*xg20))+value_sqrt_0);
d_frscsi_dTemp_Tnode_GND = (((frs*CsiPrime)*0.5)*((-RSB_i*d_xg20_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((1.0-(RSB_i*xg20)))*(-RSB_i*d_xg20_dTemp_Tnode_GND)+(-RSB_i*d_xg20_dTemp_Tnode_GND)*((1.0-(RSB_i*xg20)))))))+(frs*d_CsiPrime_dTemp_Tnode_GND+d_frs_dTemp_Tnode_GND*CsiPrime)*0.5*((1.0-(RSB_i*xg20))+value_sqrt_0));
frscsi = (((frs*CsiPrime)*0.5)*((1.0-(RSB_i*xg20))+value_sqrt_0));
}

d_Grss_dV_S_B = (frscsi*(qis*d_temp3_dV_S_B+d_qis_dV_S_B*temp3)+d_frscsi_dV_S_B*((qis*temp3)+RSIG_i));
d_Grss_dV_D_S = (frscsi*(qis*d_temp3_dV_D_S+d_qis_dV_D_S*temp3)+d_frscsi_dV_D_S*((qis*temp3)+RSIG_i));
d_Grss_dV_G_S = (frscsi*(qis*d_temp3_dV_G_S+d_qis_dV_G_S*temp3)+d_frscsi_dV_G_S*((qis*temp3)+RSIG_i));
d_Grss_dTemp_Tnode_GND = (frscsi*(qis*d_temp3_dTemp_Tnode_GND+d_qis_dTemp_Tnode_GND*temp3)+d_frscsi_dTemp_Tnode_GND*((qis*temp3)+RSIG_i));
Grss = (frscsi*((qis*temp3)+RSIG_i));
{
double value_log_0 = log(((fmue*eeff1s)+1.0e-6));
double value_exp_1 = exp((THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((fmue*eeff1s)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;

d_Gmob1s_dV_D_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff1s_dV_D_S))))+d_Gcss_dV_D_S)+BETN1_i*d_Grss_dV_D_S);
d_Gmob1s_dV_G_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff1s_dV_G_S))))+d_Gcss_dV_G_S)+BETN1_i*d_Grss_dV_G_S);
d_Gmob1s_dV_S_B = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff1s_dV_S_B))))+d_Gcss_dV_S_B)+BETN1_i*d_Grss_dV_S_B);
d_Gmob1s_dTemp_Tnode_GND = (((deriv_exp_1_d0*((THEMU_i*(deriv_log_0_d0*((fmue*d_eeff1s_dTemp_Tnode_GND+d_fmue_dTemp_Tnode_GND*eeff1s)))+d_THEMU_i_dTemp_Tnode_GND*value_log_0)))+d_Gcss_dTemp_Tnode_GND)+(BETN1_i*d_Grss_dTemp_Tnode_GND+d_BETN1_i_dTemp_Tnode_GND*Grss));
Gmob1s = (((1.0+value_exp_1)+Gcss)+(BETN1_i*Grss));
}
{
double value_log_0 = log(((fmue*eeff2s)+1.0e-6));
double value_exp_1 = exp((THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((fmue*eeff2s)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;

d_Gmob2s_dV_S_B = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff2s_dV_S_B))))+d_Gcss_dV_S_B)+BETN2_i*d_Grss_dV_S_B);
d_Gmob2s_dV_D_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff2s_dV_D_S))))+d_Gcss_dV_D_S)+BETN2_i*d_Grss_dV_D_S);
d_Gmob2s_dV_G_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff2s_dV_G_S))))+d_Gcss_dV_G_S)+BETN2_i*d_Grss_dV_G_S);
d_Gmob2s_dTemp_Tnode_GND = (((deriv_exp_1_d0*((THEMU_i*(deriv_log_0_d0*((fmue*d_eeff2s_dTemp_Tnode_GND+d_fmue_dTemp_Tnode_GND*eeff2s)))+d_THEMU_i_dTemp_Tnode_GND*value_log_0)))+d_Gcss_dTemp_Tnode_GND)+(BETN2_i*d_Grss_dTemp_Tnode_GND+d_BETN2_i_dTemp_Tnode_GND*Grss));
Gmob2s = (((1.0+value_exp_1)+Gcss)+(BETN2_i*Grss));
}

d_Gmobs_dV_S_B = ((((c1s/Gmob1s)+(c2s/Gmob2s))*(fcors*(d_c1s_dV_S_B+d_c2s_dV_S_B)+d_fcors_dV_S_B*(c1s+c2s))-(fcors*(c1s+c2s))*(((Gmob1s*d_c1s_dV_S_B-c1s*d_Gmob1s_dV_S_B)/Gmob1s/Gmob1s)+((Gmob2s*d_c2s_dV_S_B-c2s*d_Gmob2s_dV_S_B)/Gmob2s/Gmob2s)))/((c1s/Gmob1s)+(c2s/Gmob2s))/((c1s/Gmob1s)+(c2s/Gmob2s)));
d_Gmobs_dV_D_S = ((((c1s/Gmob1s)+(c2s/Gmob2s))*(fcors*(d_c1s_dV_D_S+d_c2s_dV_D_S)+d_fcors_dV_D_S*(c1s+c2s))-(fcors*(c1s+c2s))*(((Gmob1s*d_c1s_dV_D_S-c1s*d_Gmob1s_dV_D_S)/Gmob1s/Gmob1s)+((Gmob2s*d_c2s_dV_D_S-c2s*d_Gmob2s_dV_D_S)/Gmob2s/Gmob2s)))/((c1s/Gmob1s)+(c2s/Gmob2s))/((c1s/Gmob1s)+(c2s/Gmob2s)));
d_Gmobs_dTemp_Tnode_GND = ((((c1s/Gmob1s)+(c2s/Gmob2s))*(fcors*(d_c1s_dTemp_Tnode_GND+d_c2s_dTemp_Tnode_GND)+d_fcors_dTemp_Tnode_GND*(c1s+c2s))-(fcors*(c1s+c2s))*(((Gmob1s*d_c1s_dTemp_Tnode_GND-c1s*d_Gmob1s_dTemp_Tnode_GND)/Gmob1s/Gmob1s)+((Gmob2s*d_c2s_dTemp_Tnode_GND-c2s*d_Gmob2s_dTemp_Tnode_GND)/Gmob2s/Gmob2s)))/((c1s/Gmob1s)+(c2s/Gmob2s))/((c1s/Gmob1s)+(c2s/Gmob2s)));
d_Gmobs_dV_G_S = ((((c1s/Gmob1s)+(c2s/Gmob2s))*(fcors*(d_c1s_dV_G_S+d_c2s_dV_G_S)+d_fcors_dV_G_S*(c1s+c2s))-(fcors*(c1s+c2s))*(((Gmob1s*d_c1s_dV_G_S-c1s*d_Gmob1s_dV_G_S)/Gmob1s/Gmob1s)+((Gmob2s*d_c2s_dV_G_S-c2s*d_Gmob2s_dV_G_S)/Gmob2s/Gmob2s)))/((c1s/Gmob1s)+(c2s/Gmob2s))/((c1s/Gmob1s)+(c2s/Gmob2s)));
Gmobs = ((fcors*(c1s+c2s))/((c1s/Gmob1s)+(c2s/Gmob2s)));
if ((fabs(Dx_WI)>0.007))
{
if ((Dx_WI>0.0))
{
{
double value_exp_0 = exp((-Dx_WI));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_B = (deriv_exp_0_d0*((-d_Dx_WI_dV_S_B)));
d_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_Dx_WI_dTemp_Tnode_GND)));
d_temp_dV_D_S = (deriv_exp_0_d0*((-d_Dx_WI_dV_D_S)));
d_temp_dV_G_S = (deriv_exp_0_d0*((-d_Dx_WI_dV_G_S)));
temp = value_exp_0;
}

d_s1_dV_S_B = (((1.0-temp)*d_Dx_WI_dV_S_B-Dx_WI*(-d_temp_dV_S_B))/(1.0-temp)/(1.0-temp));
d_s1_dTemp_Tnode_GND = (((1.0-temp)*d_Dx_WI_dTemp_Tnode_GND-Dx_WI*(-d_temp_dTemp_Tnode_GND))/(1.0-temp)/(1.0-temp));
d_s1_dV_D_S = (((1.0-temp)*d_Dx_WI_dV_D_S-Dx_WI*(-d_temp_dV_D_S))/(1.0-temp)/(1.0-temp));
d_s1_dV_G_S = (((1.0-temp)*d_Dx_WI_dV_G_S-Dx_WI*(-d_temp_dV_G_S))/(1.0-temp)/(1.0-temp));
s1 = (Dx_WI/(1.0-temp));

d_s2_dTemp_Tnode_GND = (temp*d_s1_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*s1);
d_s2_dV_S_B = (temp*d_s1_dV_S_B+d_temp_dV_S_B*s1);
d_s2_dV_D_S = (temp*d_s1_dV_D_S+d_temp_dV_D_S*s1);
d_s2_dV_G_S = (temp*d_s1_dV_G_S+d_temp_dV_G_S*s1);
s2 = (temp*s1);
{
double value_log_0 = log((A0/(qis*s1)));
double  deriv_log_0_d0 = (1.0/(A0/(qis*s1)));

d_deltaxinf_dV_S_B = ((deriv_log_0_d0*((((qis*s1)*d_A0_dV_S_B-A0*(qis*d_s1_dV_S_B+d_qis_dV_S_B*s1))/(qis*s1)/(qis*s1))))+d_x1_WI0_dV_S_B);
d_deltaxinf_dV_D_S = ((deriv_log_0_d0*((((qis*s1)*d_A0_dV_D_S-A0*(qis*d_s1_dV_D_S+d_qis_dV_D_S*s1))/(qis*s1)/(qis*s1))))+d_x1_WI0_dV_D_S);
d_deltaxinf_dV_G_S = ((deriv_log_0_d0*((((qis*s1)*d_A0_dV_G_S-A0*(qis*d_s1_dV_G_S+d_qis_dV_G_S*s1))/(qis*s1)/(qis*s1))))+d_x1_WI0_dV_G_S);
d_deltaxinf_dTemp_Tnode_GND = ((deriv_log_0_d0*((((qis*s1)*d_A0_dTemp_Tnode_GND-A0*(qis*d_s1_dTemp_Tnode_GND+d_qis_dTemp_Tnode_GND*s1))/(qis*s1)/(qis*s1))))+d_x1_WI0_dTemp_Tnode_GND);
deltaxinf = ((value_log_0-0.6931471805599)+x1_WI0);
}
}
else
{
{
double value_exp_0 = exp(Dx_WI);
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_B = (deriv_exp_0_d0*(d_Dx_WI_dV_S_B));
d_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_Dx_WI_dTemp_Tnode_GND));
d_temp_dV_D_S = (deriv_exp_0_d0*(d_Dx_WI_dV_D_S));
d_temp_dV_G_S = (deriv_exp_0_d0*(d_Dx_WI_dV_G_S));
temp = value_exp_0;
}

d_s2_dV_S_B = (((temp-1.0)*d_Dx_WI_dV_S_B-Dx_WI*d_temp_dV_S_B)/(temp-1.0)/(temp-1.0));
d_s2_dTemp_Tnode_GND = (((temp-1.0)*d_Dx_WI_dTemp_Tnode_GND-Dx_WI*d_temp_dTemp_Tnode_GND)/(temp-1.0)/(temp-1.0));
d_s2_dV_D_S = (((temp-1.0)*d_Dx_WI_dV_D_S-Dx_WI*d_temp_dV_D_S)/(temp-1.0)/(temp-1.0));
d_s2_dV_G_S = (((temp-1.0)*d_Dx_WI_dV_G_S-Dx_WI*d_temp_dV_G_S)/(temp-1.0)/(temp-1.0));
s2 = (Dx_WI/(temp-1.0));

d_s1_dTemp_Tnode_GND = (temp*d_s2_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*s2);
d_s1_dV_S_B = (temp*d_s2_dV_S_B+d_temp_dV_S_B*s2);
d_s1_dV_D_S = (temp*d_s2_dV_D_S+d_temp_dV_D_S*s2);
d_s1_dV_G_S = (temp*d_s2_dV_G_S+d_temp_dV_G_S*s2);
s1 = (temp*s2);
{
double value_log_0 = log((A0/(qis*s2)));
double  deriv_log_0_d0 = (1.0/(A0/(qis*s2)));

d_deltaxinf_dV_S_B = ((deriv_log_0_d0*((((qis*s2)*d_A0_dV_S_B-A0*(qis*d_s2_dV_S_B+d_qis_dV_S_B*s2))/(qis*s2)/(qis*s2))))+d_x2_WI0_dV_S_B);
d_deltaxinf_dV_D_S = ((deriv_log_0_d0*((((qis*s2)*d_A0_dV_D_S-A0*(qis*d_s2_dV_D_S+d_qis_dV_D_S*s2))/(qis*s2)/(qis*s2))))+d_x2_WI0_dV_D_S);
d_deltaxinf_dV_G_S = ((deriv_log_0_d0*((((qis*s2)*d_A0_dV_G_S-A0*(qis*d_s2_dV_G_S+d_qis_dV_G_S*s2))/(qis*s2)/(qis*s2))))+d_x2_WI0_dV_G_S);
d_deltaxinf_dTemp_Tnode_GND = ((deriv_log_0_d0*((((qis*s2)*d_A0_dTemp_Tnode_GND-A0*(qis*d_s2_dTemp_Tnode_GND+d_qis_dTemp_Tnode_GND*s2))/(qis*s2)/(qis*s2))))+d_x2_WI0_dTemp_Tnode_GND);
deltaxinf = ((value_log_0-0.6931471805599)+x2_WI0);
}
}

d_q1chapinf_dV_S_B = (((keq*((1.0-s1)-(Dx_WI*inv_k2)))*(-d_Dx_WI_dV_S_B)-(-Dx_WI)*(keq*((-d_s1_dV_S_B)-(Dx_WI*d_inv_k2_dV_S_B+d_Dx_WI_dV_S_B*inv_k2))+d_keq_dV_S_B*((1.0-s1)-(Dx_WI*inv_k2))))/(keq*((1.0-s1)-(Dx_WI*inv_k2)))/(keq*((1.0-s1)-(Dx_WI*inv_k2))));
d_q1chapinf_dTemp_Tnode_GND = (((keq*((1.0-s1)-(Dx_WI*inv_k2)))*(-d_Dx_WI_dTemp_Tnode_GND)-(-Dx_WI)*(keq*((-d_s1_dTemp_Tnode_GND)-(Dx_WI*d_inv_k2_dTemp_Tnode_GND+d_Dx_WI_dTemp_Tnode_GND*inv_k2))+d_keq_dTemp_Tnode_GND*((1.0-s1)-(Dx_WI*inv_k2))))/(keq*((1.0-s1)-(Dx_WI*inv_k2)))/(keq*((1.0-s1)-(Dx_WI*inv_k2))));
d_q1chapinf_dV_D_S = (((keq*((1.0-s1)-(Dx_WI*inv_k2)))*(-d_Dx_WI_dV_D_S)-(-Dx_WI)*(keq*((-d_s1_dV_D_S)-(Dx_WI*d_inv_k2_dV_D_S+d_Dx_WI_dV_D_S*inv_k2))+d_keq_dV_D_S*((1.0-s1)-(Dx_WI*inv_k2))))/(keq*((1.0-s1)-(Dx_WI*inv_k2)))/(keq*((1.0-s1)-(Dx_WI*inv_k2))));
d_q1chapinf_dV_G_S = (((keq*((1.0-s1)-(Dx_WI*inv_k2)))*(-d_Dx_WI_dV_G_S)-(-Dx_WI)*(keq*((-d_s1_dV_G_S)-(Dx_WI*d_inv_k2_dV_G_S+d_Dx_WI_dV_G_S*inv_k2))+d_keq_dV_G_S*((1.0-s1)-(Dx_WI*inv_k2))))/(keq*((1.0-s1)-(Dx_WI*inv_k2)))/(keq*((1.0-s1)-(Dx_WI*inv_k2))));
q1chapinf = ((-Dx_WI)/(keq*((1.0-s1)-(Dx_WI*inv_k2))));

d_q2chapinf_dV_S_B = (((keq*((1.0-s2)+(Dx_WI*inv_k1)))*d_Dx_WI_dV_S_B-Dx_WI*(keq*((-d_s2_dV_S_B)+(Dx_WI*d_inv_k1_dV_S_B+d_Dx_WI_dV_S_B*inv_k1))+d_keq_dV_S_B*((1.0-s2)+(Dx_WI*inv_k1))))/(keq*((1.0-s2)+(Dx_WI*inv_k1)))/(keq*((1.0-s2)+(Dx_WI*inv_k1))));
d_q2chapinf_dTemp_Tnode_GND = (((keq*((1.0-s2)+(Dx_WI*inv_k1)))*d_Dx_WI_dTemp_Tnode_GND-Dx_WI*(keq*((-d_s2_dTemp_Tnode_GND)+(Dx_WI*d_inv_k1_dTemp_Tnode_GND+d_Dx_WI_dTemp_Tnode_GND*inv_k1))+d_keq_dTemp_Tnode_GND*((1.0-s2)+(Dx_WI*inv_k1))))/(keq*((1.0-s2)+(Dx_WI*inv_k1)))/(keq*((1.0-s2)+(Dx_WI*inv_k1))));
d_q2chapinf_dV_D_S = (((keq*((1.0-s2)+(Dx_WI*inv_k1)))*d_Dx_WI_dV_D_S-Dx_WI*(keq*((-d_s2_dV_D_S)+(Dx_WI*d_inv_k1_dV_D_S+d_Dx_WI_dV_D_S*inv_k1))+d_keq_dV_D_S*((1.0-s2)+(Dx_WI*inv_k1))))/(keq*((1.0-s2)+(Dx_WI*inv_k1)))/(keq*((1.0-s2)+(Dx_WI*inv_k1))));
d_q2chapinf_dV_G_S = (((keq*((1.0-s2)+(Dx_WI*inv_k1)))*d_Dx_WI_dV_G_S-Dx_WI*(keq*((-d_s2_dV_G_S)+(Dx_WI*d_inv_k1_dV_G_S+d_Dx_WI_dV_G_S*inv_k1))+d_keq_dV_G_S*((1.0-s2)+(Dx_WI*inv_k1))))/(keq*((1.0-s2)+(Dx_WI*inv_k1)))/(keq*((1.0-s2)+(Dx_WI*inv_k1))));
q2chapinf = (Dx_WI/(keq*((1.0-s2)+(Dx_WI*inv_k1))));

d_dinf_dV_S_B = ((((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))*d_Dx_WI_dV_S_B-Dx_WI*(((q2chapinf*(s2*d_inv_k2_dV_S_B+d_s2_dV_S_B*inv_k2)-((s2*inv_k2)+0.5)*d_q2chapinf_dV_S_B)/q2chapinf/q2chapinf)-((q1chapinf*(s1*d_inv_k1_dV_S_B+d_s1_dV_S_B*inv_k1)-((s1*inv_k1)+0.5)*d_q1chapinf_dV_S_B)/q1chapinf/q1chapinf)))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf)));
d_dinf_dTemp_Tnode_GND = ((((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))*d_Dx_WI_dTemp_Tnode_GND-Dx_WI*(((q2chapinf*(s2*d_inv_k2_dTemp_Tnode_GND+d_s2_dTemp_Tnode_GND*inv_k2)-((s2*inv_k2)+0.5)*d_q2chapinf_dTemp_Tnode_GND)/q2chapinf/q2chapinf)-((q1chapinf*(s1*d_inv_k1_dTemp_Tnode_GND+d_s1_dTemp_Tnode_GND*inv_k1)-((s1*inv_k1)+0.5)*d_q1chapinf_dTemp_Tnode_GND)/q1chapinf/q1chapinf)))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf)));
d_dinf_dV_D_S = ((((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))*d_Dx_WI_dV_D_S-Dx_WI*(((q2chapinf*(s2*d_inv_k2_dV_D_S+d_s2_dV_D_S*inv_k2)-((s2*inv_k2)+0.5)*d_q2chapinf_dV_D_S)/q2chapinf/q2chapinf)-((q1chapinf*(s1*d_inv_k1_dV_D_S+d_s1_dV_D_S*inv_k1)-((s1*inv_k1)+0.5)*d_q1chapinf_dV_D_S)/q1chapinf/q1chapinf)))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf)));
d_dinf_dV_G_S = ((((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))*d_Dx_WI_dV_G_S-Dx_WI*(((q2chapinf*(s2*d_inv_k2_dV_G_S+d_s2_dV_G_S*inv_k2)-((s2*inv_k2)+0.5)*d_q2chapinf_dV_G_S)/q2chapinf/q2chapinf)-((q1chapinf*(s1*d_inv_k1_dV_G_S+d_s1_dV_G_S*inv_k1)-((s1*inv_k1)+0.5)*d_q1chapinf_dV_G_S)/q1chapinf/q1chapinf)))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf)));
dinf = (Dx_WI/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf)));
}
else
{

d_temp_dV_S_B = (0.5*0.1666666666667)*d_Dx_WIsq_dV_S_B;
d_temp_dTemp_Tnode_GND = (0.5*0.1666666666667)*d_Dx_WIsq_dTemp_Tnode_GND;
d_temp_dV_D_S = (0.5*0.1666666666667)*d_Dx_WIsq_dV_D_S;
d_temp_dV_G_S = (0.5*0.1666666666667)*d_Dx_WIsq_dV_G_S;
temp = ((0.5*0.1666666666667)*Dx_WIsq);

d_temp1_dV_S_B = 0.5*d_Dx_WI_dV_S_B;
d_temp1_dTemp_Tnode_GND = 0.5*d_Dx_WI_dTemp_Tnode_GND;
d_temp1_dV_D_S = 0.5*d_Dx_WI_dV_D_S;
d_temp1_dV_G_S = 0.5*d_Dx_WI_dV_G_S;
temp1 = (0.5*Dx_WI);

d_s1_dTemp_Tnode_GND = (d_temp1_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND);
d_s1_dV_D_S = (d_temp1_dV_D_S+d_temp_dV_D_S);
d_s1_dV_G_S = (d_temp1_dV_G_S+d_temp_dV_G_S);
d_s1_dV_S_B = (d_temp1_dV_S_B+d_temp_dV_S_B);
s1 = ((1.0+temp1)+temp);

d_s2_dTemp_Tnode_GND = ((-d_temp1_dTemp_Tnode_GND)+d_temp_dTemp_Tnode_GND);
d_s2_dV_D_S = ((-d_temp1_dV_D_S)+d_temp_dV_D_S);
d_s2_dV_G_S = ((-d_temp1_dV_G_S)+d_temp_dV_G_S);
d_s2_dV_S_B = ((-d_temp1_dV_S_B)+d_temp_dV_S_B);
s2 = ((1.0-temp1)+temp);

d_temp2_dTemp_Tnode_GND = 0.1666666666667*d_temp1_dTemp_Tnode_GND;
d_temp2_dV_D_S = 0.1666666666667*d_temp1_dV_D_S;
d_temp2_dV_G_S = 0.1666666666667*d_temp1_dV_G_S;
d_temp2_dV_S_B = 0.1666666666667*d_temp1_dV_S_B;
temp2 = (0.1666666666667*temp1);

d_q1chapinf_dV_S_B = (-(keq*(d_inv_k2_dV_S_B+d_temp2_dV_S_B)+d_keq_dV_S_B*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2)));
d_q1chapinf_dTemp_Tnode_GND = (-(keq*(d_inv_k2_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND)+d_keq_dTemp_Tnode_GND*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2)));
d_q1chapinf_dV_D_S = (-(keq*(d_inv_k2_dV_D_S+d_temp2_dV_D_S)+d_keq_dV_D_S*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2)));
d_q1chapinf_dV_G_S = (-(keq*(d_inv_k2_dV_G_S+d_temp2_dV_G_S)+d_keq_dV_G_S*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2))/(keq*((0.5+inv_k2)+temp2)));
q1chapinf = (1.0/(keq*((0.5+inv_k2)+temp2)));

d_q2chapinf_dV_S_B = (-(keq*(d_inv_k1_dV_S_B-d_temp2_dV_S_B)+d_keq_dV_S_B*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2)));
d_q2chapinf_dTemp_Tnode_GND = (-(keq*(d_inv_k1_dTemp_Tnode_GND-d_temp2_dTemp_Tnode_GND)+d_keq_dTemp_Tnode_GND*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2)));
d_q2chapinf_dV_D_S = (-(keq*(d_inv_k1_dV_D_S-d_temp2_dV_D_S)+d_keq_dV_D_S*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2)));
d_q2chapinf_dV_G_S = (-(keq*(d_inv_k1_dV_G_S-d_temp2_dV_G_S)+d_keq_dV_G_S*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2))/(keq*((0.5+inv_k1)-temp2)));
q2chapinf = (1.0/(keq*((0.5+inv_k1)-temp2)));
{
double value_log_0 = log((A0/(qis*(1.0-(0.5*temp)))));
double  deriv_log_0_d0 = (1.0/(A0/(qis*(1.0-(0.5*temp)))));

d_deltaxinf_dV_S_B = ((deriv_log_0_d0*((((qis*(1.0-(0.5*temp)))*d_A0_dV_S_B-A0*(qis*(-0.5*d_temp_dV_S_B)+d_qis_dV_S_B*(1.0-(0.5*temp))))/(qis*(1.0-(0.5*temp)))/(qis*(1.0-(0.5*temp))))))+0.5*(d_x1_WI0_dV_S_B+d_x2_WI0_dV_S_B));
d_deltaxinf_dV_D_S = ((deriv_log_0_d0*((((qis*(1.0-(0.5*temp)))*d_A0_dV_D_S-A0*(qis*(-0.5*d_temp_dV_D_S)+d_qis_dV_D_S*(1.0-(0.5*temp))))/(qis*(1.0-(0.5*temp)))/(qis*(1.0-(0.5*temp))))))+0.5*(d_x1_WI0_dV_D_S+d_x2_WI0_dV_D_S));
d_deltaxinf_dV_G_S = ((deriv_log_0_d0*((((qis*(1.0-(0.5*temp)))*d_A0_dV_G_S-A0*(qis*(-0.5*d_temp_dV_G_S)+d_qis_dV_G_S*(1.0-(0.5*temp))))/(qis*(1.0-(0.5*temp)))/(qis*(1.0-(0.5*temp))))))+0.5*(d_x1_WI0_dV_G_S+d_x2_WI0_dV_G_S));
d_deltaxinf_dTemp_Tnode_GND = ((deriv_log_0_d0*((((qis*(1.0-(0.5*temp)))*d_A0_dTemp_Tnode_GND-A0*(qis*(-0.5*d_temp_dTemp_Tnode_GND)+d_qis_dTemp_Tnode_GND*(1.0-(0.5*temp))))/(qis*(1.0-(0.5*temp)))/(qis*(1.0-(0.5*temp))))))+0.5*(d_x1_WI0_dTemp_Tnode_GND+d_x2_WI0_dTemp_Tnode_GND));
deltaxinf = ((value_log_0-0.6931471805599)+(0.5*(x1_WI0+x2_WI0)));
}

d_dinf_dV_S_B = (-(-12.0)*((((-3.0*d_keq_dV_S_B)+(((k1*k2)*12.0*d_keq_dV_S_B-(12.0*keq)*(k1*d_k2_dV_S_B+d_k1_dV_S_B*k2))/(k1*k2)/(k1*k2)))+((keq*(inv_k1-inv_k2))*d_Dx_WI_dV_S_B+(keq*(d_inv_k1_dV_S_B-d_inv_k2_dV_S_B)+d_keq_dV_S_B*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*d_Dx_WIsq_dV_S_B+0.3333333333333*(-0.25*d_keq_dV_S_B)*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq)));
d_dinf_dTemp_Tnode_GND = (-(-12.0)*((((-3.0*d_keq_dTemp_Tnode_GND)+(((k1*k2)*12.0*d_keq_dTemp_Tnode_GND-(12.0*keq)*(k1*d_k2_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*k2))/(k1*k2)/(k1*k2)))+((keq*(inv_k1-inv_k2))*d_Dx_WI_dTemp_Tnode_GND+(keq*(d_inv_k1_dTemp_Tnode_GND-d_inv_k2_dTemp_Tnode_GND)+d_keq_dTemp_Tnode_GND*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*d_Dx_WIsq_dTemp_Tnode_GND+0.3333333333333*(-0.25*d_keq_dTemp_Tnode_GND)*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq)));
d_dinf_dV_D_S = (-(-12.0)*((((-3.0*d_keq_dV_D_S)+(((k1*k2)*12.0*d_keq_dV_D_S-(12.0*keq)*(k1*d_k2_dV_D_S+d_k1_dV_D_S*k2))/(k1*k2)/(k1*k2)))+((keq*(inv_k1-inv_k2))*d_Dx_WI_dV_D_S+(keq*(d_inv_k1_dV_D_S-d_inv_k2_dV_D_S)+d_keq_dV_D_S*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*d_Dx_WIsq_dV_D_S+0.3333333333333*(-0.25*d_keq_dV_D_S)*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq)));
d_dinf_dV_G_S = (-(-12.0)*((((-3.0*d_keq_dV_G_S)+(((k1*k2)*12.0*d_keq_dV_G_S-(12.0*keq)*(k1*d_k2_dV_G_S+d_k1_dV_G_S*k2))/(k1*k2)/(k1*k2)))+((keq*(inv_k1-inv_k2))*d_Dx_WI_dV_G_S+(keq*(d_inv_k1_dV_G_S-d_inv_k2_dV_G_S)+d_keq_dV_G_S*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*d_Dx_WIsq_dV_G_S+0.3333333333333*(-0.25*d_keq_dV_G_S)*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq)));
dinf = ((-12.0)/((((4.0-(3.0*keq))+((12.0*keq)/(k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq)));
}

d_inv_dinf_dV_S_B = (-d_dinf_dV_S_B/dinf/dinf);
d_inv_dinf_dTemp_Tnode_GND = (-d_dinf_dTemp_Tnode_GND/dinf/dinf);
d_inv_dinf_dV_D_S = (-d_dinf_dV_D_S/dinf/dinf);
d_inv_dinf_dV_G_S = (-d_dinf_dV_G_S/dinf/dinf);
inv_dinf = (1.0/dinf);
if ((qis>1.0E-6))
{

d_wsat1_dTemp_Tnode_GND = (((100.0+esurf1s)*100.0*d_esurf1s_dTemp_Tnode_GND-(100.0*esurf1s)*d_esurf1s_dTemp_Tnode_GND)/(100.0+esurf1s)/(100.0+esurf1s));
d_wsat1_dV_D_S = (((100.0+esurf1s)*100.0*d_esurf1s_dV_D_S-(100.0*esurf1s)*d_esurf1s_dV_D_S)/(100.0+esurf1s)/(100.0+esurf1s));
d_wsat1_dV_G_S = (((100.0+esurf1s)*100.0*d_esurf1s_dV_G_S-(100.0*esurf1s)*d_esurf1s_dV_G_S)/(100.0+esurf1s)/(100.0+esurf1s));
d_wsat1_dV_S_B = (((100.0+esurf1s)*100.0*d_esurf1s_dV_S_B-(100.0*esurf1s)*d_esurf1s_dV_S_B)/(100.0+esurf1s)/(100.0+esurf1s));
wsat1 = ((100.0*esurf1s)/(100.0+esurf1s));
if ((THESAT1_i<0.0))
{

d_sat_fact1_dTemp_Tnode_GND = (-(-THESAT1_i*d_wsat1_dTemp_Tnode_GND)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
d_sat_fact1_dV_D_S = (-(-THESAT1_i*d_wsat1_dV_D_S)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
d_sat_fact1_dV_G_S = (-(-THESAT1_i*d_wsat1_dV_G_S)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
d_sat_fact1_dV_S_B = (-(-THESAT1_i*d_wsat1_dV_S_B)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
sat_fact1 = (1.0/(1.0-(THESAT1_i*wsat1)));
}
else
{

d_sat_fact1_dTemp_Tnode_GND = THESAT1_i*d_wsat1_dTemp_Tnode_GND;
d_sat_fact1_dV_D_S = THESAT1_i*d_wsat1_dV_D_S;
d_sat_fact1_dV_G_S = THESAT1_i*d_wsat1_dV_G_S;
d_sat_fact1_dV_S_B = THESAT1_i*d_wsat1_dV_S_B;
sat_fact1 = (1.0+(THESAT1_i*wsat1));
}

d_wsat2_dV_S_B = (((100.0+esurf2s)*100.0*d_esurf2s_dV_S_B-(100.0*esurf2s)*d_esurf2s_dV_S_B)/(100.0+esurf2s)/(100.0+esurf2s));
d_wsat2_dV_D_S = (((100.0+esurf2s)*100.0*d_esurf2s_dV_D_S-(100.0*esurf2s)*d_esurf2s_dV_D_S)/(100.0+esurf2s)/(100.0+esurf2s));
d_wsat2_dTemp_Tnode_GND = (((100.0+esurf2s)*100.0*d_esurf2s_dTemp_Tnode_GND-(100.0*esurf2s)*d_esurf2s_dTemp_Tnode_GND)/(100.0+esurf2s)/(100.0+esurf2s));
d_wsat2_dV_G_S = (((100.0+esurf2s)*100.0*d_esurf2s_dV_G_S-(100.0*esurf2s)*d_esurf2s_dV_G_S)/(100.0+esurf2s)/(100.0+esurf2s));
wsat2 = ((100.0*esurf2s)/(100.0+esurf2s));
if ((THESAT2_i<0.0))
{

d_sat_fact2_dV_S_B = (-(-THESAT2_i*d_wsat2_dV_S_B)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
d_sat_fact2_dV_D_S = (-(-THESAT2_i*d_wsat2_dV_D_S)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
d_sat_fact2_dTemp_Tnode_GND = (-(-THESAT2_i*d_wsat2_dTemp_Tnode_GND)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
d_sat_fact2_dV_G_S = (-(-THESAT2_i*d_wsat2_dV_G_S)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
sat_fact2 = (1.0/(1.0-(THESAT2_i*wsat2)));
}
else
{

d_sat_fact2_dV_S_B = THESAT2_i*d_wsat2_dV_S_B;
d_sat_fact2_dV_D_S = THESAT2_i*d_wsat2_dV_D_S;
d_sat_fact2_dTemp_Tnode_GND = THESAT2_i*d_wsat2_dTemp_Tnode_GND;
d_sat_fact2_dV_G_S = THESAT2_i*d_wsat2_dV_G_S;
sat_fact2 = (1.0+(THESAT2_i*wsat2));
}

d_dqis_dxn_qi_dV_S_B = ((((a1s*a2s)*(dqsqs_dxn_qi*d_sums_dV_S_B+d_dqsqs_dxn_qi_dV_S_B*sums)-(dqsqs_dxn_qi*sums)*(a1s*d_a2s_dV_S_B+d_a1s_dV_S_B*a2s))/(a1s*a2s)/(a1s*a2s))-((qis*(((a1s*d_Aexp1s_dV_S_B-Aexp1s*d_a1s_dV_S_B)/a1s/a1s)+((a2s*d_Aexp2s_dV_S_B-Aexp2s*d_a2s_dV_S_B)/a2s/a2s))-((Aexp1s/a1s)+(Aexp2s/a2s))*d_qis_dV_S_B)/qis/qis));
d_dqis_dxn_qi_dTemp_Tnode_GND = ((((a1s*a2s)*(dqsqs_dxn_qi*d_sums_dTemp_Tnode_GND+d_dqsqs_dxn_qi_dTemp_Tnode_GND*sums)-(dqsqs_dxn_qi*sums)*(a1s*d_a2s_dTemp_Tnode_GND+d_a1s_dTemp_Tnode_GND*a2s))/(a1s*a2s)/(a1s*a2s))-((qis*(((a1s*d_Aexp1s_dTemp_Tnode_GND-Aexp1s*d_a1s_dTemp_Tnode_GND)/a1s/a1s)+((a2s*d_Aexp2s_dTemp_Tnode_GND-Aexp2s*d_a2s_dTemp_Tnode_GND)/a2s/a2s))-((Aexp1s/a1s)+(Aexp2s/a2s))*d_qis_dTemp_Tnode_GND)/qis/qis));
d_dqis_dxn_qi_dV_D_S = ((((a1s*a2s)*(dqsqs_dxn_qi*d_sums_dV_D_S+d_dqsqs_dxn_qi_dV_D_S*sums)-(dqsqs_dxn_qi*sums)*(a1s*d_a2s_dV_D_S+d_a1s_dV_D_S*a2s))/(a1s*a2s)/(a1s*a2s))-((qis*(((a1s*d_Aexp1s_dV_D_S-Aexp1s*d_a1s_dV_D_S)/a1s/a1s)+((a2s*d_Aexp2s_dV_D_S-Aexp2s*d_a2s_dV_D_S)/a2s/a2s))-((Aexp1s/a1s)+(Aexp2s/a2s))*d_qis_dV_D_S)/qis/qis));
d_dqis_dxn_qi_dV_G_S = ((((a1s*a2s)*(dqsqs_dxn_qi*d_sums_dV_G_S+d_dqsqs_dxn_qi_dV_G_S*sums)-(dqsqs_dxn_qi*sums)*(a1s*d_a2s_dV_G_S+d_a1s_dV_G_S*a2s))/(a1s*a2s)/(a1s*a2s))-((qis*(((a1s*d_Aexp1s_dV_G_S-Aexp1s*d_a1s_dV_G_S)/a1s/a1s)+((a2s*d_Aexp2s_dV_G_S-Aexp2s*d_a2s_dV_G_S)/a2s/a2s))-((Aexp1s/a1s)+(Aexp2s/a2s))*d_qis_dV_G_S)/qis/qis));
dqis_dxn_qi = (((dqsqs_dxn_qi*sums)/(a1s*a2s))-(((Aexp1s/a1s)+(Aexp2s/a2s))/qis));

d_ds_dV_S_B = (((dqis_dxn_qi+1.0)*(dqis_dxn_qi*d_qis_dV_S_B+d_dqis_dxn_qi_dV_S_B*qis)-(dqis_dxn_qi*qis)*d_dqis_dxn_qi_dV_S_B)/(dqis_dxn_qi+1.0)/(dqis_dxn_qi+1.0));
d_ds_dTemp_Tnode_GND = (((dqis_dxn_qi+1.0)*(dqis_dxn_qi*d_qis_dTemp_Tnode_GND+d_dqis_dxn_qi_dTemp_Tnode_GND*qis)-(dqis_dxn_qi*qis)*d_dqis_dxn_qi_dTemp_Tnode_GND)/(dqis_dxn_qi+1.0)/(dqis_dxn_qi+1.0));
d_ds_dV_D_S = (((dqis_dxn_qi+1.0)*(dqis_dxn_qi*d_qis_dV_D_S+d_dqis_dxn_qi_dV_D_S*qis)-(dqis_dxn_qi*qis)*d_dqis_dxn_qi_dV_D_S)/(dqis_dxn_qi+1.0)/(dqis_dxn_qi+1.0));
d_ds_dV_G_S = (((dqis_dxn_qi+1.0)*(dqis_dxn_qi*d_qis_dV_G_S+d_dqis_dxn_qi_dV_G_S*qis)-(dqis_dxn_qi*qis)*d_dqis_dxn_qi_dV_G_S)/(dqis_dxn_qi+1.0)/(dqis_dxn_qi+1.0));
ds = ((dqis_dxn_qi*qis)/(dqis_dxn_qi+1.0));

d_temp1_dV_S_B = (d_dinf_dV_S_B-d_ds_dV_S_B);
d_temp1_dTemp_Tnode_GND = (d_dinf_dTemp_Tnode_GND-d_ds_dTemp_Tnode_GND);
d_temp1_dV_D_S = (d_dinf_dV_D_S-d_ds_dV_D_S);
d_temp1_dV_G_S = (d_dinf_dV_G_S-d_ds_dV_G_S);
temp1 = (dinf-ds);

d_deltaxi_dV_S_B = ((temp1*(d_qis_dV_S_B+(dinf*d_deltaxinf_dV_S_B+d_dinf_dV_S_B*deltaxinf))-(qis+(dinf*deltaxinf))*d_temp1_dV_S_B)/temp1/temp1);
d_deltaxi_dV_D_S = ((temp1*(d_qis_dV_D_S+(dinf*d_deltaxinf_dV_D_S+d_dinf_dV_D_S*deltaxinf))-(qis+(dinf*deltaxinf))*d_temp1_dV_D_S)/temp1/temp1);
d_deltaxi_dV_G_S = ((temp1*(d_qis_dV_G_S+(dinf*d_deltaxinf_dV_G_S+d_dinf_dV_G_S*deltaxinf))-(qis+(dinf*deltaxinf))*d_temp1_dV_G_S)/temp1/temp1);
d_deltaxi_dTemp_Tnode_GND = ((temp1*(d_qis_dTemp_Tnode_GND+(dinf*d_deltaxinf_dTemp_Tnode_GND+d_dinf_dTemp_Tnode_GND*deltaxinf))-(qis+(dinf*deltaxinf))*d_temp1_dTemp_Tnode_GND)/temp1/temp1);
deltaxi = ((qis+(dinf*deltaxinf))/temp1);
{
double value_sqrt_0 = sqrt(((deltaxi*deltaxi)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_deltaxi_dV_S_B = 0.5*(d_deltaxi_dV_S_B+(deriv_sqrt_0_d0*((deltaxi*d_deltaxi_dV_S_B+d_deltaxi_dV_S_B*deltaxi))));
d_deltaxi_dV_D_S = 0.5*(d_deltaxi_dV_D_S+(deriv_sqrt_0_d0*((deltaxi*d_deltaxi_dV_D_S+d_deltaxi_dV_D_S*deltaxi))));
d_deltaxi_dV_G_S = 0.5*(d_deltaxi_dV_G_S+(deriv_sqrt_0_d0*((deltaxi*d_deltaxi_dV_G_S+d_deltaxi_dV_G_S*deltaxi))));
d_deltaxi_dTemp_Tnode_GND = 0.5*(d_deltaxi_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((deltaxi*d_deltaxi_dTemp_Tnode_GND+d_deltaxi_dTemp_Tnode_GND*deltaxi))));
deltaxi = (0.5*(deltaxi+value_sqrt_0));
}

d_gamma_dV_S_B = (((sat_phit/Gmobs)*0.5)*(d_sat_fact1_dV_S_B+d_sat_fact2_dV_S_B)+(-sat_phit*d_Gmobs_dV_S_B/Gmobs/Gmobs)*0.5*(sat_fact1+sat_fact2));
d_gamma_dV_D_S = (((sat_phit/Gmobs)*0.5)*(d_sat_fact1_dV_D_S+d_sat_fact2_dV_D_S)+(-sat_phit*d_Gmobs_dV_D_S/Gmobs/Gmobs)*0.5*(sat_fact1+sat_fact2));
d_gamma_dV_G_S = (((sat_phit/Gmobs)*0.5)*(d_sat_fact1_dV_G_S+d_sat_fact2_dV_G_S)+(-sat_phit*d_Gmobs_dV_G_S/Gmobs/Gmobs)*0.5*(sat_fact1+sat_fact2));
d_gamma_dTemp_Tnode_GND = (((sat_phit/Gmobs)*0.5)*(d_sat_fact1_dTemp_Tnode_GND+d_sat_fact2_dTemp_Tnode_GND)+((Gmobs*d_sat_phit_dTemp_Tnode_GND-sat_phit*d_Gmobs_dTemp_Tnode_GND)/Gmobs/Gmobs)*0.5*(sat_fact1+sat_fact2));
gamma = (((sat_phit/Gmobs)*0.5)*(sat_fact1+sat_fact2));

d_vs_dV_S_B = (-((ds*d_qis_dV_S_B-qis*d_ds_dV_S_B)/ds/ds));
d_vs_dV_D_S = (-((ds*d_qis_dV_D_S-qis*d_ds_dV_D_S)/ds/ds));
d_vs_dV_G_S = (-((ds*d_qis_dV_G_S-qis*d_ds_dV_G_S)/ds/ds));
d_vs_dTemp_Tnode_GND = (-((ds*d_qis_dTemp_Tnode_GND-qis*d_ds_dTemp_Tnode_GND)/ds/ds));
vs = (1.0-(qis/ds));

d_vd_dV_S_B = d_deltaxinf_dV_S_B;
d_vd_dV_D_S = d_deltaxinf_dV_D_S;
d_vd_dV_G_S = d_deltaxinf_dV_G_S;
d_vd_dTemp_Tnode_GND = d_deltaxinf_dTemp_Tnode_GND;
vd = (1.0+deltaxinf);

d_wd_dV_S_B = ((((((2.0*ds)-qis)*inv_dinf)-2.0)-deltaxinf)*d_deltaxi_dV_S_B+((((2.0*ds)-qis)*d_inv_dinf_dV_S_B+(2.0*d_ds_dV_S_B-d_qis_dV_S_B)*inv_dinf)-d_deltaxinf_dV_S_B)*deltaxi);
d_wd_dTemp_Tnode_GND = ((((((2.0*ds)-qis)*inv_dinf)-2.0)-deltaxinf)*d_deltaxi_dTemp_Tnode_GND+((((2.0*ds)-qis)*d_inv_dinf_dTemp_Tnode_GND+(2.0*d_ds_dTemp_Tnode_GND-d_qis_dTemp_Tnode_GND)*inv_dinf)-d_deltaxinf_dTemp_Tnode_GND)*deltaxi);
d_wd_dV_D_S = ((((((2.0*ds)-qis)*inv_dinf)-2.0)-deltaxinf)*d_deltaxi_dV_D_S+((((2.0*ds)-qis)*d_inv_dinf_dV_D_S+(2.0*d_ds_dV_D_S-d_qis_dV_D_S)*inv_dinf)-d_deltaxinf_dV_D_S)*deltaxi);
d_wd_dV_G_S = ((((((2.0*ds)-qis)*inv_dinf)-2.0)-deltaxinf)*d_deltaxi_dV_G_S+((((2.0*ds)-qis)*d_inv_dinf_dV_G_S+(2.0*d_ds_dV_G_S-d_qis_dV_G_S)*inv_dinf)-d_deltaxinf_dV_G_S)*deltaxi);
wd = ((((((2.0*ds)-qis)*inv_dinf)-2.0)-deltaxinf)*deltaxi);
if ((gamma>1.0e-14))
{

d_ps_cub_dV_S_B = (-2.0*(gamma*d_gamma_dV_S_B+d_gamma_dV_S_B*gamma)/(gamma*gamma)/(gamma*gamma));
d_ps_cub_dV_D_S = (-2.0*(gamma*d_gamma_dV_D_S+d_gamma_dV_D_S*gamma)/(gamma*gamma)/(gamma*gamma));
d_ps_cub_dV_G_S = (-2.0*(gamma*d_gamma_dV_G_S+d_gamma_dV_G_S*gamma)/(gamma*gamma)/(gamma*gamma));
d_ps_cub_dTemp_Tnode_GND = (-2.0*(gamma*d_gamma_dTemp_Tnode_GND+d_gamma_dTemp_Tnode_GND*gamma)/(gamma*gamma)/(gamma*gamma));
ps_cub = (2.0/(gamma*gamma));

d_qs_cub_dV_S_B = (ps_cub*d_vs_dV_S_B+d_ps_cub_dV_S_B*vs);
d_qs_cub_dV_D_S = (ps_cub*d_vs_dV_D_S+d_ps_cub_dV_D_S*vs);
d_qs_cub_dV_G_S = (ps_cub*d_vs_dV_G_S+d_ps_cub_dV_G_S*vs);
d_qs_cub_dTemp_Tnode_GND = (ps_cub*d_vs_dTemp_Tnode_GND+d_ps_cub_dTemp_Tnode_GND*vs);
qs_cub = (ps_cub*vs);

d_pd_cub_dV_S_B = (d_ps_cub_dV_S_B+d_wd_dV_S_B);
d_pd_cub_dV_D_S = (d_ps_cub_dV_D_S+d_wd_dV_D_S);
d_pd_cub_dV_G_S = (d_ps_cub_dV_G_S+d_wd_dV_G_S);
d_pd_cub_dTemp_Tnode_GND = (d_ps_cub_dTemp_Tnode_GND+d_wd_dTemp_Tnode_GND);
pd_cub = (ps_cub+wd);

d_qd_cub_dV_S_B = (ps_cub*d_vd_dV_S_B+d_ps_cub_dV_S_B*vd);
d_qd_cub_dV_D_S = (ps_cub*d_vd_dV_D_S+d_ps_cub_dV_D_S*vd);
d_qd_cub_dV_G_S = (ps_cub*d_vd_dV_G_S+d_ps_cub_dV_G_S*vd);
d_qd_cub_dTemp_Tnode_GND = (ps_cub*d_vd_dTemp_Tnode_GND+d_ps_cub_dTemp_Tnode_GND*vd);
qd_cub = (ps_cub*vd);
{
double value_sqrt_0 = sqrt((((qs_cub*qs_cub)+(((0.148148148148*ps_cub)*ps_cub)*ps_cub))+1.0e-20));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_racs_dV_S_B = (deriv_sqrt_0_d0*(((qs_cub*d_qs_cub_dV_S_B+d_qs_cub_dV_S_B*qs_cub)+(((0.148148148148*ps_cub)*ps_cub)*d_ps_cub_dV_S_B+((0.148148148148*ps_cub)*d_ps_cub_dV_S_B+0.148148148148*d_ps_cub_dV_S_B*ps_cub)*ps_cub))));
d_racs_dV_D_S = (deriv_sqrt_0_d0*(((qs_cub*d_qs_cub_dV_D_S+d_qs_cub_dV_D_S*qs_cub)+(((0.148148148148*ps_cub)*ps_cub)*d_ps_cub_dV_D_S+((0.148148148148*ps_cub)*d_ps_cub_dV_D_S+0.148148148148*d_ps_cub_dV_D_S*ps_cub)*ps_cub))));
d_racs_dV_G_S = (deriv_sqrt_0_d0*(((qs_cub*d_qs_cub_dV_G_S+d_qs_cub_dV_G_S*qs_cub)+(((0.148148148148*ps_cub)*ps_cub)*d_ps_cub_dV_G_S+((0.148148148148*ps_cub)*d_ps_cub_dV_G_S+0.148148148148*d_ps_cub_dV_G_S*ps_cub)*ps_cub))));
d_racs_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((qs_cub*d_qs_cub_dTemp_Tnode_GND+d_qs_cub_dTemp_Tnode_GND*qs_cub)+(((0.148148148148*ps_cub)*ps_cub)*d_ps_cub_dTemp_Tnode_GND+((0.148148148148*ps_cub)*d_ps_cub_dTemp_Tnode_GND+0.148148148148*d_ps_cub_dTemp_Tnode_GND*ps_cub)*ps_cub))));
racs = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((qd_cub*qd_cub)+(((0.148148148148*pd_cub)*pd_cub)*pd_cub))+1.0e-20));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_racd_dV_S_B = (deriv_sqrt_0_d0*(((qd_cub*d_qd_cub_dV_S_B+d_qd_cub_dV_S_B*qd_cub)+(((0.148148148148*pd_cub)*pd_cub)*d_pd_cub_dV_S_B+((0.148148148148*pd_cub)*d_pd_cub_dV_S_B+0.148148148148*d_pd_cub_dV_S_B*pd_cub)*pd_cub))));
d_racd_dV_D_S = (deriv_sqrt_0_d0*(((qd_cub*d_qd_cub_dV_D_S+d_qd_cub_dV_D_S*qd_cub)+(((0.148148148148*pd_cub)*pd_cub)*d_pd_cub_dV_D_S+((0.148148148148*pd_cub)*d_pd_cub_dV_D_S+0.148148148148*d_pd_cub_dV_D_S*pd_cub)*pd_cub))));
d_racd_dV_G_S = (deriv_sqrt_0_d0*(((qd_cub*d_qd_cub_dV_G_S+d_qd_cub_dV_G_S*qd_cub)+(((0.148148148148*pd_cub)*pd_cub)*d_pd_cub_dV_G_S+((0.148148148148*pd_cub)*d_pd_cub_dV_G_S+0.148148148148*d_pd_cub_dV_G_S*pd_cub)*pd_cub))));
d_racd_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((qd_cub*d_qd_cub_dTemp_Tnode_GND+d_qd_cub_dTemp_Tnode_GND*qd_cub)+(((0.148148148148*pd_cub)*pd_cub)*d_pd_cub_dTemp_Tnode_GND+((0.148148148148*pd_cub)*d_pd_cub_dTemp_Tnode_GND+0.148148148148*d_pd_cub_dTemp_Tnode_GND*pd_cub)*pd_cub))));
racd = value_sqrt_0;
}
{
double value_log_0 = log((0.5*(racs+qs_cub)));
double value_exp_1 = exp((0.3333333333333*value_log_0));
double value_log_2 = log((0.5*(racs-qs_cub)));
double value_exp_3 = exp((0.3333333333333*value_log_2));
double  deriv_log_0_d0 = (1.0/(0.5*(racs+qs_cub)));
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(0.5*(racs-qs_cub)));
double  deriv_exp_3_d0 = value_exp_3;

d_deltaxsats_dV_S_B = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racs_dV_S_B+d_qs_cub_dV_S_B)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racs_dV_S_B-d_qs_cub_dV_S_B))))));
d_deltaxsats_dV_D_S = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racs_dV_D_S+d_qs_cub_dV_D_S)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racs_dV_D_S-d_qs_cub_dV_D_S))))));
d_deltaxsats_dV_G_S = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racs_dV_G_S+d_qs_cub_dV_G_S)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racs_dV_G_S-d_qs_cub_dV_G_S))))));
d_deltaxsats_dTemp_Tnode_GND = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racs_dTemp_Tnode_GND+d_qs_cub_dTemp_Tnode_GND)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racs_dTemp_Tnode_GND-d_qs_cub_dTemp_Tnode_GND))))));
deltaxsats = (value_exp_1-value_exp_3);
}
{
double value_log_0 = log((0.5*(racd+qd_cub)));
double value_exp_1 = exp((0.3333333333333*value_log_0));
double value_log_2 = log((0.5*(racd-qd_cub)));
double value_exp_3 = exp((0.3333333333333*value_log_2));
double  deriv_log_0_d0 = (1.0/(0.5*(racd+qd_cub)));
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(0.5*(racd-qd_cub)));
double  deriv_exp_3_d0 = value_exp_3;

d_deltaxsatd_dV_S_B = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racd_dV_S_B+d_qd_cub_dV_S_B)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racd_dV_S_B-d_qd_cub_dV_S_B))))));
d_deltaxsatd_dV_D_S = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racd_dV_D_S+d_qd_cub_dV_D_S)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racd_dV_D_S-d_qd_cub_dV_D_S))))));
d_deltaxsatd_dV_G_S = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racd_dV_G_S+d_qd_cub_dV_G_S)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racd_dV_G_S-d_qd_cub_dV_G_S))))));
d_deltaxsatd_dTemp_Tnode_GND = ((deriv_exp_1_d0*(0.3333333333333*(deriv_log_0_d0*(0.5*(d_racd_dTemp_Tnode_GND+d_qd_cub_dTemp_Tnode_GND)))))-(deriv_exp_3_d0*(0.3333333333333*(deriv_log_2_d0*(0.5*(d_racd_dTemp_Tnode_GND-d_qd_cub_dTemp_Tnode_GND))))));
deltaxsatd = (value_exp_1-value_exp_3);
}
}
else
{

d_deltaxsats_dV_S_B = d_vs_dV_S_B;
d_deltaxsats_dV_D_S = d_vs_dV_D_S;
d_deltaxsats_dV_G_S = d_vs_dV_G_S;
d_deltaxsats_dTemp_Tnode_GND = d_vs_dTemp_Tnode_GND;
deltaxsats = vs;

d_deltaxsatd_dV_S_B = d_vd_dV_S_B;
d_deltaxsatd_dV_D_S = d_vd_dV_D_S;
d_deltaxsatd_dV_G_S = d_vd_dV_G_S;
d_deltaxsatd_dTemp_Tnode_GND = d_vd_dTemp_Tnode_GND;
deltaxsatd = vd;
}

d_temp3_dTemp_Tnode_GND = (temp1*d_temp1_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND*temp1);
d_temp3_dV_D_S = (temp1*d_temp1_dV_D_S+d_temp1_dV_D_S*temp1);
d_temp3_dV_G_S = (temp1*d_temp1_dV_G_S+d_temp1_dV_G_S*temp1);
d_temp3_dV_S_B = (temp1*d_temp1_dV_S_B+d_temp1_dV_S_B*temp1);
temp3 = (temp1*temp1);
{
double value_sqrt_0 = sqrt((((deltaxsats-deltaxsatd)*(deltaxsats-deltaxsatd))+(10.0*temp3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_deltaxsat_dV_S_B = (0.94*0.5)*((d_deltaxsats_dV_S_B+d_deltaxsatd_dV_S_B)+(deriv_sqrt_0_d0*((((deltaxsats-deltaxsatd)*(d_deltaxsats_dV_S_B-d_deltaxsatd_dV_S_B)+(d_deltaxsats_dV_S_B-d_deltaxsatd_dV_S_B)*(deltaxsats-deltaxsatd))+10.0*d_temp3_dV_S_B))));
d_deltaxsat_dV_D_S = (0.94*0.5)*((d_deltaxsats_dV_D_S+d_deltaxsatd_dV_D_S)+(deriv_sqrt_0_d0*((((deltaxsats-deltaxsatd)*(d_deltaxsats_dV_D_S-d_deltaxsatd_dV_D_S)+(d_deltaxsats_dV_D_S-d_deltaxsatd_dV_D_S)*(deltaxsats-deltaxsatd))+10.0*d_temp3_dV_D_S))));
d_deltaxsat_dV_G_S = (0.94*0.5)*((d_deltaxsats_dV_G_S+d_deltaxsatd_dV_G_S)+(deriv_sqrt_0_d0*((((deltaxsats-deltaxsatd)*(d_deltaxsats_dV_G_S-d_deltaxsatd_dV_G_S)+(d_deltaxsats_dV_G_S-d_deltaxsatd_dV_G_S)*(deltaxsats-deltaxsatd))+10.0*d_temp3_dV_G_S))));
d_deltaxsat_dTemp_Tnode_GND = (0.94*0.5)*((d_deltaxsats_dTemp_Tnode_GND+d_deltaxsatd_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((deltaxsats-deltaxsatd)*(d_deltaxsats_dTemp_Tnode_GND-d_deltaxsatd_dTemp_Tnode_GND)+(d_deltaxsats_dTemp_Tnode_GND-d_deltaxsatd_dTemp_Tnode_GND)*(deltaxsats-deltaxsatd))+10.0*d_temp3_dTemp_Tnode_GND))));
deltaxsat = ((0.94*0.5)*((deltaxsats+deltaxsatd)+value_sqrt_0));
}

d_qidsats_dV_S_B = (d_qis_dV_S_B+(ds*d_deltaxsat_dV_S_B+d_ds_dV_S_B*deltaxsat));
d_qidsats_dV_D_S = (d_qis_dV_D_S+(ds*d_deltaxsat_dV_D_S+d_ds_dV_D_S*deltaxsat));
d_qidsats_dV_G_S = (d_qis_dV_G_S+(ds*d_deltaxsat_dV_G_S+d_ds_dV_G_S*deltaxsat));
d_qidsats_dTemp_Tnode_GND = (d_qis_dTemp_Tnode_GND+(ds*d_deltaxsat_dTemp_Tnode_GND+d_ds_dTemp_Tnode_GND*deltaxsat));
qidsats = (qis+(ds*deltaxsat));

d_qidsatd_dV_S_B = (dinf*(d_deltaxsat_dV_S_B-d_deltaxinf_dV_S_B)+d_dinf_dV_S_B*(deltaxsat-deltaxinf));
d_qidsatd_dTemp_Tnode_GND = (dinf*(d_deltaxsat_dTemp_Tnode_GND-d_deltaxinf_dTemp_Tnode_GND)+d_dinf_dTemp_Tnode_GND*(deltaxsat-deltaxinf));
d_qidsatd_dV_D_S = (dinf*(d_deltaxsat_dV_D_S-d_deltaxinf_dV_D_S)+d_dinf_dV_D_S*(deltaxsat-deltaxinf));
d_qidsatd_dV_G_S = (dinf*(d_deltaxsat_dV_G_S-d_deltaxinf_dV_G_S)+d_dinf_dV_G_S*(deltaxsat-deltaxinf));
qidsatd = (dinf*(deltaxsat-deltaxinf));
{
double value_sqrt_0 = sqrt((((qidsats-qidsatd)*(qidsats-qidsatd))+(36.0*temp3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_qidsat_dV_S_B = 0.5*((d_qidsats_dV_S_B+d_qidsatd_dV_S_B)+(deriv_sqrt_0_d0*((((qidsats-qidsatd)*(d_qidsats_dV_S_B-d_qidsatd_dV_S_B)+(d_qidsats_dV_S_B-d_qidsatd_dV_S_B)*(qidsats-qidsatd))+36.0*d_temp3_dV_S_B))));
d_qidsat_dV_D_S = 0.5*((d_qidsats_dV_D_S+d_qidsatd_dV_D_S)+(deriv_sqrt_0_d0*((((qidsats-qidsatd)*(d_qidsats_dV_D_S-d_qidsatd_dV_D_S)+(d_qidsats_dV_D_S-d_qidsatd_dV_D_S)*(qidsats-qidsatd))+36.0*d_temp3_dV_D_S))));
d_qidsat_dV_G_S = 0.5*((d_qidsats_dV_G_S+d_qidsatd_dV_G_S)+(deriv_sqrt_0_d0*((((qidsats-qidsatd)*(d_qidsats_dV_G_S-d_qidsatd_dV_G_S)+(d_qidsats_dV_G_S-d_qidsatd_dV_G_S)*(qidsats-qidsatd))+36.0*d_temp3_dV_G_S))));
d_qidsat_dTemp_Tnode_GND = 0.5*((d_qidsats_dTemp_Tnode_GND+d_qidsatd_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((qidsats-qidsatd)*(d_qidsats_dTemp_Tnode_GND-d_qidsatd_dTemp_Tnode_GND)+(d_qidsats_dTemp_Tnode_GND-d_qidsatd_dTemp_Tnode_GND)*(qidsats-qidsatd))+36.0*d_temp3_dTemp_Tnode_GND))));
qidsat = (0.5*((qidsats+qidsatd)+value_sqrt_0));
}
}
else
{

d_ds_dV_S_B = d_dinf_dV_S_B;
d_ds_dTemp_Tnode_GND = d_dinf_dTemp_Tnode_GND;
d_ds_dV_D_S = d_dinf_dV_D_S;
d_ds_dV_G_S = d_dinf_dV_G_S;
ds = dinf;

d_deltaxsat_dV_S_B = 0.94*d_deltaxinf_dV_S_B;
d_deltaxsat_dV_D_S = 0.94*d_deltaxinf_dV_D_S;
d_deltaxsat_dV_G_S = 0.94*d_deltaxinf_dV_G_S;
d_deltaxsat_dTemp_Tnode_GND = 0.94*d_deltaxinf_dTemp_Tnode_GND;
deltaxsat = (0.94*(1.0+deltaxinf));

d_qidsat_dV_S_B = (0.5*d_qis_dV_S_B+(dinf*(d_deltaxsat_dV_S_B-0.5*d_deltaxinf_dV_S_B)+d_dinf_dV_S_B*(deltaxsat-(0.5*deltaxinf))));
d_qidsat_dV_D_S = (0.5*d_qis_dV_D_S+(dinf*(d_deltaxsat_dV_D_S-0.5*d_deltaxinf_dV_D_S)+d_dinf_dV_D_S*(deltaxsat-(0.5*deltaxinf))));
d_qidsat_dV_G_S = (0.5*d_qis_dV_G_S+(dinf*(d_deltaxsat_dV_G_S-0.5*d_deltaxinf_dV_G_S)+d_dinf_dV_G_S*(deltaxsat-(0.5*deltaxinf))));
d_qidsat_dTemp_Tnode_GND = (0.5*d_qis_dTemp_Tnode_GND+(dinf*(d_deltaxsat_dTemp_Tnode_GND-0.5*d_deltaxinf_dTemp_Tnode_GND)+d_dinf_dTemp_Tnode_GND*(deltaxsat-(0.5*deltaxinf))));
qidsat = ((0.5*qis)+(dinf*(deltaxsat-(0.5*deltaxinf))));
}
if (((qidsat-0.5)<80.0))
{
{
double value_exp_0 = exp((qidsat-0.5));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp1_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*(d_qidsat_dV_S_B))));
d_temp1_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*(d_qidsat_dV_D_S))));
d_temp1_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*(d_qidsat_dV_G_S))));
d_temp1_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*(d_qidsat_dTemp_Tnode_GND))));
temp1 = value_log_1;
}
}
else
{

d_temp1_dV_S_B = d_qidsat_dV_S_B;
d_temp1_dV_D_S = d_qidsat_dV_D_S;
d_temp1_dV_G_S = d_qidsat_dV_G_S;
d_temp1_dTemp_Tnode_GND = d_qidsat_dTemp_Tnode_GND;
temp1 = (qidsat-0.5);
}

d_temp2_dTemp_Tnode_GND = d_temp1_dTemp_Tnode_GND;
d_temp2_dV_D_S = d_temp1_dV_D_S;
d_temp2_dV_G_S = d_temp1_dV_G_S;
d_temp2_dV_S_B = d_temp1_dV_S_B;
temp2 = (temp1+0.5);
{
double value_log_0 = log((qis/temp2));
double  deriv_log_0_d0 = (1.0/(qis/temp2));

d_temp3_dV_S_B = (d_deltaxsat_dV_S_B+(deriv_log_0_d0*(((temp2*d_qis_dV_S_B-qis*d_temp2_dV_S_B)/temp2/temp2))));
d_temp3_dV_D_S = (d_deltaxsat_dV_D_S+(deriv_log_0_d0*(((temp2*d_qis_dV_D_S-qis*d_temp2_dV_D_S)/temp2/temp2))));
d_temp3_dV_G_S = (d_deltaxsat_dV_G_S+(deriv_log_0_d0*(((temp2*d_qis_dV_G_S-qis*d_temp2_dV_G_S)/temp2/temp2))));
d_temp3_dTemp_Tnode_GND = (d_deltaxsat_dTemp_Tnode_GND+(deriv_log_0_d0*(((temp2*d_qis_dTemp_Tnode_GND-qis*d_temp2_dTemp_Tnode_GND)/temp2/temp2))));
temp3 = (deltaxsat+value_log_0);
}
if (((temp3-6.0)<80.0))
{
{
double value_exp_0 = exp((temp3-6.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp1_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*(d_temp3_dV_S_B))));
d_temp1_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*(d_temp3_dTemp_Tnode_GND))));
d_temp1_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*(d_temp3_dV_D_S))));
d_temp1_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*(d_temp3_dV_G_S))));
temp1 = value_log_1;
}
}
else
{

d_temp1_dV_S_B = d_temp3_dV_S_B;
d_temp1_dTemp_Tnode_GND = d_temp3_dTemp_Tnode_GND;
d_temp1_dV_D_S = d_temp3_dV_D_S;
d_temp1_dV_G_S = d_temp3_dV_G_S;
temp1 = (temp3-6.0);
}

d_temp3_dTemp_Tnode_GND = d_temp1_dTemp_Tnode_GND;
d_temp3_dV_D_S = d_temp1_dV_D_S;
d_temp3_dV_G_S = d_temp1_dV_G_S;
d_temp3_dV_S_B = d_temp1_dV_S_B;
temp3 = (temp1+6.0);
if (((600.0-temp3)<80.0))
{
{
double value_exp_0 = exp((600.0-temp3));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp1_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_temp3_dV_S_B)))));
d_temp1_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_temp3_dTemp_Tnode_GND)))));
d_temp1_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_temp3_dV_D_S)))));
d_temp1_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((-d_temp3_dV_G_S)))));
temp1 = value_log_1;
}
}
else
{

d_temp1_dV_S_B = (-d_temp3_dV_S_B);
d_temp1_dTemp_Tnode_GND = (-d_temp3_dTemp_Tnode_GND);
d_temp1_dV_D_S = (-d_temp3_dV_D_S);
d_temp1_dV_G_S = (-d_temp3_dV_G_S);
temp1 = (600.0-temp3);
}

d_xndssat_dTemp_Tnode_GND = (-d_temp1_dTemp_Tnode_GND);
d_xndssat_dV_D_S = (-d_temp1_dV_D_S);
d_xndssat_dV_G_S = (-d_temp1_dV_G_S);
d_xndssat_dV_S_B = (-d_temp1_dV_S_B);
xndssat = (600.0-temp1);

d_temp1_dV_G_S = (-xd*d_xndssat_dV_G_S/xndssat/xndssat);
d_temp1_dV_S_B = (-xd*d_xndssat_dV_S_B/xndssat/xndssat);
d_temp1_dTemp_Tnode_GND = ((xndssat*d_xd_dTemp_Tnode_GND-xd*d_xndssat_dTemp_Tnode_GND)/xndssat/xndssat);
d_temp1_dV_D_S = ((xndssat*d_xd_dV_D_S-xd*d_xndssat_dV_D_S)/xndssat/xndssat);
temp1 = (xd/xndssat);

d_temp2_dTemp_Tnode_GND = (temp1*d_temp1_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND*temp1);
d_temp2_dV_D_S = (temp1*d_temp1_dV_D_S+d_temp1_dV_D_S*temp1);
d_temp2_dV_G_S = (temp1*d_temp1_dV_G_S+d_temp1_dV_G_S*temp1);
d_temp2_dV_S_B = (temp1*d_temp1_dV_S_B+d_temp1_dV_S_B*temp1);
temp2 = (temp1*temp1);

d_temp3_dV_S_B = (temp2*d_temp2_dV_S_B+d_temp2_dV_S_B*temp2);
d_temp3_dV_D_S = (temp2*d_temp2_dV_D_S+d_temp2_dV_D_S*temp2);
d_temp3_dTemp_Tnode_GND = (temp2*d_temp2_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND*temp2);
d_temp3_dV_G_S = (temp2*d_temp2_dV_G_S+d_temp2_dV_G_S*temp2);
temp3 = (temp2*temp2);

d_temp4_dV_S_B = (temp3*d_temp3_dV_S_B+d_temp3_dV_S_B*temp3);
d_temp4_dTemp_Tnode_GND = (temp3*d_temp3_dTemp_Tnode_GND+d_temp3_dTemp_Tnode_GND*temp3);
d_temp4_dV_D_S = (temp3*d_temp3_dV_D_S+d_temp3_dV_D_S*temp3);
d_temp4_dV_G_S = (temp3*d_temp3_dV_G_S+d_temp3_dV_G_S*temp3);
temp4 = (temp3*temp3);
{
double value_log_0 = log((1.0+(gamAX*temp3)));
double value_exp_1 = exp((2.666666666667*value_log_0));
double  deriv_log_0_d0 = (1.0/(1.0+(gamAX*temp3)));
double  deriv_exp_1_d0 = value_exp_1;

d_temp_dV_S_B = (deriv_exp_1_d0*(2.666666666667*(deriv_log_0_d0*(gamAX*d_temp3_dV_S_B))));
d_temp_dTemp_Tnode_GND = (deriv_exp_1_d0*(2.666666666667*(deriv_log_0_d0*(gamAX*d_temp3_dTemp_Tnode_GND))));
d_temp_dV_D_S = (deriv_exp_1_d0*(2.666666666667*(deriv_log_0_d0*(gamAX*d_temp3_dV_D_S))));
d_temp_dV_G_S = (deriv_exp_1_d0*(2.666666666667*(deriv_log_0_d0*(gamAX*d_temp3_dV_G_S))));
temp = value_exp_1;
}
{
double value_log_0 = log((temp+(temp4*temp4)));
double value_exp_1 = exp(((-0.0625)*value_log_0));
double  deriv_log_0_d0 = (1.0/(temp+(temp4*temp4)));
double  deriv_exp_1_d0 = value_exp_1;

d_xdeff_dV_S_B = xd*(deriv_exp_1_d0*((-0.0625)*(deriv_log_0_d0*((d_temp_dV_S_B+(temp4*d_temp4_dV_S_B+d_temp4_dV_S_B*temp4))))));
d_xdeff_dV_G_S = xd*(deriv_exp_1_d0*((-0.0625)*(deriv_log_0_d0*((d_temp_dV_G_S+(temp4*d_temp4_dV_G_S+d_temp4_dV_G_S*temp4))))));
d_xdeff_dTemp_Tnode_GND = (xd*(deriv_exp_1_d0*((-0.0625)*(deriv_log_0_d0*((d_temp_dTemp_Tnode_GND+(temp4*d_temp4_dTemp_Tnode_GND+d_temp4_dTemp_Tnode_GND*temp4))))))+d_xd_dTemp_Tnode_GND*value_exp_1);
d_xdeff_dV_D_S = (xd*(deriv_exp_1_d0*((-0.0625)*(deriv_log_0_d0*((d_temp_dV_D_S+(temp4*d_temp4_dV_D_S+d_temp4_dV_D_S*temp4))))))+d_xd_dV_D_S*value_exp_1);
xdeff = (xd*value_exp_1);
}

d_q_temp1_dV_S_B = (-d_k1_dV_S_B/(k1+1.0)/(k1+1.0));
d_q_temp1_dTemp_Tnode_GND = (-d_k1_dTemp_Tnode_GND/(k1+1.0)/(k1+1.0));
d_q_temp1_dV_D_S = (-d_k1_dV_D_S/(k1+1.0)/(k1+1.0));
d_q_temp1_dV_G_S = (-d_k1_dV_G_S/(k1+1.0)/(k1+1.0));
q_temp1 = (1.0/(k1+1.0));

d_q_temp2_dV_S_B = (-d_k2_dV_S_B/(k2+1.0)/(k2+1.0));
d_q_temp2_dTemp_Tnode_GND = (-d_k2_dTemp_Tnode_GND/(k2+1.0)/(k2+1.0));
d_q_temp2_dV_D_S = (-d_k2_dV_D_S/(k2+1.0)/(k2+1.0));
d_q_temp2_dV_G_S = (-d_k2_dV_G_S/(k2+1.0)/(k2+1.0));
q_temp2 = (1.0/(k2+1.0));
{
double value_log_0 = log((((k1+(k2*q_temp2))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k1+(k2*q_temp2))*diff_min)/A0));

d_q_x1sat_dV_S_B = ((deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dV_S_B+(d_k1_dV_S_B+(k2*d_q_temp2_dV_S_B+d_k2_dV_S_B*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dV_S_B)/A0/A0)))+d_xdeff_dV_S_B);
d_q_x1sat_dTemp_Tnode_GND = ((deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dTemp_Tnode_GND+(d_k1_dTemp_Tnode_GND+(k2*d_q_temp2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dTemp_Tnode_GND)/A0/A0)))+d_xdeff_dTemp_Tnode_GND);
d_q_x1sat_dV_D_S = ((deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dV_D_S+(d_k1_dV_D_S+(k2*d_q_temp2_dV_D_S+d_k2_dV_D_S*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dV_D_S)/A0/A0)))+d_xdeff_dV_D_S);
d_q_x1sat_dV_G_S = ((deriv_log_0_d0*(((A0*((k1+(k2*q_temp2))*d_diff_min_dV_G_S+(d_k1_dV_G_S+(k2*d_q_temp2_dV_G_S+d_k2_dV_G_S*q_temp2))*diff_min)-((k1+(k2*q_temp2))*diff_min)*d_A0_dV_G_S)/A0/A0)))+d_xdeff_dV_G_S);
q_x1sat = ((value_log_0+xdeff)+3.0);
}
{
double value_log_0 = log((((k2+(k1*q_temp1))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k2+(k1*q_temp1))*diff_min)/A0));

d_q_x2sat_dV_S_B = ((deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dV_S_B+(d_k2_dV_S_B+(k1*d_q_temp1_dV_S_B+d_k1_dV_S_B*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dV_S_B)/A0/A0)))+d_xdeff_dV_S_B);
d_q_x2sat_dTemp_Tnode_GND = ((deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dTemp_Tnode_GND+(d_k2_dTemp_Tnode_GND+(k1*d_q_temp1_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dTemp_Tnode_GND)/A0/A0)))+d_xdeff_dTemp_Tnode_GND);
d_q_x2sat_dV_D_S = ((deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dV_D_S+(d_k2_dV_D_S+(k1*d_q_temp1_dV_D_S+d_k1_dV_D_S*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dV_D_S)/A0/A0)))+d_xdeff_dV_D_S);
d_q_x2sat_dV_G_S = ((deriv_log_0_d0*(((A0*((k2+(k1*q_temp1))*d_diff_min_dV_G_S+(d_k2_dV_G_S+(k1*d_q_temp1_dV_G_S+d_k1_dV_G_S*q_temp1))*diff_min)-((k2+(k1*q_temp1))*diff_min)*d_A0_dV_G_S)/A0/A0)))+d_xdeff_dV_G_S);
q_x2sat = ((value_log_0+xdeff)+3.0);
}
if ((((q_x1sat-x1_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-x1_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_S_B-d_x1_WI0_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dTemp_Tnode_GND-d_x1_WI0_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_D_S-d_x1_WI0_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_G_S-d_x1_WI0_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x1sat_dV_S_B-d_x1_WI0_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-d_x1_WI0_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x1sat_dV_D_S-d_x1_WI0_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x1sat_dV_G_S-d_x1_WI0_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x1sat-x1_WI0)*0.3333333333333);
}

d_q_x1_dV_S_B = (d_q_x1sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x1_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x1_dV_D_S = (d_q_x1sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x1_dV_G_S = (d_q_x1sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-x2_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-x2_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_S_B-d_x2_WI0_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dTemp_Tnode_GND-d_x2_WI0_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_D_S-d_x2_WI0_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_G_S-d_x2_WI0_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x2sat_dV_S_B-d_x2_WI0_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-d_x2_WI0_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x2sat_dV_D_S-d_x2_WI0_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x2sat_dV_G_S-d_x2_WI0_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x2sat-x2_WI0)*0.3333333333333);
}

d_q_x2_dV_S_B = (d_q_x2sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x2_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x2_dV_D_S = (d_q_x2sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x2_dV_G_S = (d_q_x2sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x2 = (q_x2sat-(3.0*q_temp3));

d_q_x1_WI_dV_S_B = (((k1*xg1x)+q_x2)*d_q_temp1_dV_S_B+((k1*d_xg1x_dV_S_B+d_k1_dV_S_B*xg1x)+d_q_x2_dV_S_B)*q_temp1);
d_q_x1_WI_dTemp_Tnode_GND = (((k1*xg1x)+q_x2)*d_q_temp1_dTemp_Tnode_GND+((k1*d_xg1x_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*xg1x)+d_q_x2_dTemp_Tnode_GND)*q_temp1);
d_q_x1_WI_dV_D_S = (((k1*xg1x)+q_x2)*d_q_temp1_dV_D_S+((k1*d_xg1x_dV_D_S+d_k1_dV_D_S*xg1x)+d_q_x2_dV_D_S)*q_temp1);
d_q_x1_WI_dV_G_S = (((k1*xg1x)+q_x2)*d_q_temp1_dV_G_S+((k1*d_xg1x_dV_G_S+d_k1_dV_G_S*xg1x)+d_q_x2_dV_G_S)*q_temp1);
q_x1_WI = (((k1*xg1x)+q_x2)*q_temp1);

d_q_x2_WI_dV_S_B = (((k2*xg2x)+q_x1)*d_q_temp2_dV_S_B+((k2*d_xg2x_dV_S_B+d_k2_dV_S_B*xg2x)+d_q_x1_dV_S_B)*q_temp2);
d_q_x2_WI_dTemp_Tnode_GND = (((k2*xg2x)+q_x1)*d_q_temp2_dTemp_Tnode_GND+((k2*d_xg2x_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*xg2x)+d_q_x1_dTemp_Tnode_GND)*q_temp2);
d_q_x2_WI_dV_D_S = (((k2*xg2x)+q_x1)*d_q_temp2_dV_D_S+((k2*d_xg2x_dV_D_S+d_k2_dV_D_S*xg2x)+d_q_x1_dV_D_S)*q_temp2);
d_q_x2_WI_dV_G_S = (((k2*xg2x)+q_x1)*d_q_temp2_dV_G_S+((k2*d_xg2x_dV_G_S+d_k2_dV_G_S*xg2x)+d_q_x1_dV_G_S)*q_temp2);
q_x2_WI = (((k2*xg2x)+q_x1)*q_temp2);
if ((((q_x1sat-q_x1_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-q_x1_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_S_B-d_q_x1_WI_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dTemp_Tnode_GND-d_q_x1_WI_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_D_S-d_q_x1_WI_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x1sat_dV_G_S-d_q_x1_WI_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x1sat_dV_S_B-d_q_x1_WI_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-d_q_x1_WI_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x1sat_dV_D_S-d_q_x1_WI_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x1sat_dV_G_S-d_q_x1_WI_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x1sat-q_x1_WI)*0.3333333333333);
}

d_q_x1_dV_S_B = (d_q_x1sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x1_dTemp_Tnode_GND = (d_q_x1sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x1_dV_D_S = (d_q_x1sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x1_dV_G_S = (d_q_x1sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-q_x2_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-q_x2_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_q_temp3_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_S_B-d_q_x2_WI_dV_S_B)*0.3333333333333))));
d_q_temp3_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dTemp_Tnode_GND-d_q_x2_WI_dTemp_Tnode_GND)*0.3333333333333))));
d_q_temp3_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_D_S-d_q_x2_WI_dV_D_S)*0.3333333333333))));
d_q_temp3_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_q_x2sat_dV_G_S-d_q_x2_WI_dV_G_S)*0.3333333333333))));
q_temp3 = value_log_1;
}
}
else
{

d_q_temp3_dV_S_B = (d_q_x2sat_dV_S_B-d_q_x2_WI_dV_S_B)*0.3333333333333;
d_q_temp3_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-d_q_x2_WI_dTemp_Tnode_GND)*0.3333333333333;
d_q_temp3_dV_D_S = (d_q_x2sat_dV_D_S-d_q_x2_WI_dV_D_S)*0.3333333333333;
d_q_temp3_dV_G_S = (d_q_x2sat_dV_G_S-d_q_x2_WI_dV_G_S)*0.3333333333333;
q_temp3 = ((q_x2sat-q_x2_WI)*0.3333333333333);
}

d_q_x2_dV_S_B = (d_q_x2sat_dV_S_B-3.0*d_q_temp3_dV_S_B);
d_q_x2_dTemp_Tnode_GND = (d_q_x2sat_dTemp_Tnode_GND-3.0*d_q_temp3_dTemp_Tnode_GND);
d_q_x2_dV_D_S = (d_q_x2sat_dV_D_S-3.0*d_q_temp3_dV_D_S);
d_q_x2_dV_G_S = (d_q_x2sat_dV_G_S-3.0*d_q_temp3_dV_G_S);
q_x2 = (q_x2sat-(3.0*q_temp3));

d_q1d_dV_S_B = (d_xg1x_dV_S_B-d_q_x1_dV_S_B);
d_q1d_dV_D_S = (d_xg1x_dV_D_S-d_q_x1_dV_D_S);
d_q1d_dV_G_S = (d_xg1x_dV_G_S-d_q_x1_dV_G_S);
d_q1d_dTemp_Tnode_GND = (d_xg1x_dTemp_Tnode_GND-d_q_x1_dTemp_Tnode_GND);
q1d = (xg1x-q_x1);

d_q2d_dV_S_B = (d_xg2x_dV_S_B-d_q_x2_dV_S_B);
d_q2d_dTemp_Tnode_GND = (d_xg2x_dTemp_Tnode_GND-d_q_x2_dTemp_Tnode_GND);
d_q2d_dV_D_S = (d_xg2x_dV_D_S-d_q_x2_dV_D_S);
d_q2d_dV_G_S = (d_xg2x_dV_G_S-d_q_x2_dV_G_S);
q2d = (xg2x-q_x2);

d_q_rac_qsq_dV_G_S = d_q_rac_qsq_dV_D_S = d_q_rac_qsq_dTemp_Tnode_GND = d_q_rac_qsq_dV_S_B =  0.0;
q_rac_qsq = 0.0;

d_q_invexpq_dV_G_S = d_q_invexpq_dV_D_S = d_q_invexpq_dTemp_Tnode_GND = d_q_invexpq_dV_S_B =  0.0;
q_invexpq = 0.0;

d_q_k1q1_dV_S_B = (k1*d_q1d_dV_S_B+d_k1_dV_S_B*q1d);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1d_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1d);
d_q_k1q1_dV_D_S = (k1*d_q1d_dV_D_S+d_k1_dV_D_S*q1d);
d_q_k1q1_dV_G_S = (k1*d_q1d_dV_G_S+d_k1_dV_G_S*q1d);
q_k1q1 = (k1*q1d);
if ((((xg1x-q1d)-xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-xdeff));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*(((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*(((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*(((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*(((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*0.3333333333333+0.5*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*0.3333333333333+0.5*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*0.3333333333333+0.5*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*0.3333333333333+0.5*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))))));
}

d_q_Aexp_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_q_Aexp_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_q_Aexp_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_q_Aexp_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
q_Aexp = (A0*q_temp1);

d_q_qsq_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_Aexp_dV_S_B);
d_q_qsq_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_qsq_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_Aexp_dV_D_S);
d_q_qsq_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_Aexp_dV_G_S);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);

d_q_d1_qsq_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_Aexp_dV_S_B);
d_q_d1_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_qsq_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_Aexp_dV_D_S);
d_q_d1_qsq_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_Aexp_dV_G_S);
q_d1_qsq = (((2.0*k1)*q_k1q1)+q_Aexp);

d_q_d2_qsq_dV_S_B = (((2.0*k1)*d_k1_dV_S_B+2.0*d_k1_dV_S_B*k1)-d_q_Aexp_dV_S_B);
d_q_d2_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_k1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*k1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_qsq_dV_D_S = (((2.0*k1)*d_k1_dV_D_S+2.0*d_k1_dV_D_S*k1)-d_q_Aexp_dV_D_S);
d_q_d2_qsq_dV_G_S = (((2.0*k1)*d_k1_dV_G_S+2.0*d_k1_dV_G_S*k1)-d_q_Aexp_dV_G_S);
q_d2_qsq = (((2.0*k1)*k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{

d_q_temp3_dV_S_B = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_S_B*0.025)+d_q_qsq_dV_S_B*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_S_B*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dTemp_Tnode_GND*0.025)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_D_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_D_S*0.025)+d_q_qsq_dV_D_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_D_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_G_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_G_S*0.025)+d_q_qsq_dV_G_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_G_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));

d_q_qcoth_dV_S_B = (q_qsq*d_q_temp3_dV_S_B+d_q_qsq_dV_S_B*q_temp3);
d_q_qcoth_dTemp_Tnode_GND = (q_qsq*d_q_temp3_dTemp_Tnode_GND+d_q_qsq_dTemp_Tnode_GND*q_temp3);
d_q_qcoth_dV_D_S = (q_qsq*d_q_temp3_dV_D_S+d_q_qsq_dV_D_S*q_temp3);
d_q_qcoth_dV_G_S = (q_qsq*d_q_temp3_dV_G_S+d_q_qsq_dV_G_S*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));

d_q_temp1_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));

d_q_d1_qcoth_dV_S_B = (q_d1_qsq*d_q_temp1_dV_S_B+d_q_d1_qsq_dV_S_B*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = (q_d1_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_temp1);
d_q_d1_qcoth_dV_D_S = (q_d1_qsq*d_q_temp1_dV_D_S+d_q_d1_qsq_dV_D_S*q_temp1);
d_q_d1_qcoth_dV_G_S = (q_d1_qsq*d_q_temp1_dV_G_S+d_q_d1_qsq_dV_G_S*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);

d_q_temp2_dV_S_B = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_S_B*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dTemp_Tnode_GND = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_D_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_D_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_G_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_G_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));

d_q_d2_qcoth_dV_S_B = ((q_d2_qsq*d_q_temp1_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_S_B+(q_d1_qsq*d_q_d1_qsq_dV_S_B+d_q_d1_qsq_dV_S_B*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dTemp_Tnode_GND = ((q_d2_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dTemp_Tnode_GND+(q_d1_qsq*d_q_d1_qsq_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_D_S = ((q_d2_qsq*d_q_temp1_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_D_S+(q_d1_qsq*d_q_d1_qsq_dV_D_S+d_q_d1_qsq_dV_D_S*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_G_S = ((q_d2_qsq*d_q_temp1_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_G_S+(q_d1_qsq*d_q_d1_qsq_dV_G_S+d_q_d1_qsq_dV_G_S*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));

d_q_d1_ln_dV_S_B = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d1_qsq_dV_S_B*q_temp3);
d_q_d1_ln_dTemp_Tnode_GND = (((-0.5)*q_d1_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d1_qsq_dTemp_Tnode_GND*q_temp3);
d_q_d1_ln_dV_D_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d1_qsq_dV_D_S*q_temp3);
d_q_d1_ln_dV_G_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d1_qsq_dV_G_S*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);

d_q_d2_ln_dV_S_B = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d2_qsq_dV_S_B*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_S_B)+d_q_qsq_dV_S_B*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_S_B+(0.25*0.0055555555556)*d_q_d1_qsq_dV_S_B*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dTemp_Tnode_GND = ((((-0.5)*q_d2_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d2_qsq_dTemp_Tnode_GND*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dTemp_Tnode_GND)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dTemp_Tnode_GND+(0.25*0.0055555555556)*d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_D_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d2_qsq_dV_D_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_D_S)+d_q_qsq_dV_D_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_D_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_D_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_G_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d2_qsq_dV_G_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_G_S)+d_q_qsq_dV_G_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_G_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_G_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{

d_q_temp2_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_S_B-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dTemp_Tnode_GND-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_D_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_G_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));

d_q_sh_term_dV_S_B = (q_temp2*d_q_invexpq_dV_S_B+d_q_temp2_dV_S_B*q_invexpq);
d_q_sh_term_dTemp_Tnode_GND = (q_temp2*d_q_invexpq_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_invexpq);
d_q_sh_term_dV_D_S = (q_temp2*d_q_invexpq_dV_D_S+d_q_temp2_dV_D_S*q_invexpq);
d_q_sh_term_dV_G_S = (q_temp2*d_q_invexpq_dV_G_S+d_q_temp2_dV_G_S*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);

d_q_ln_term_dV_S_B = ((deriv_log_0_d0*(d_q_temp2_dV_S_B))-d_q_rac_qsq_dV_S_B);
d_q_ln_term_dTemp_Tnode_GND = ((deriv_log_0_d0*(d_q_temp2_dTemp_Tnode_GND))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_ln_term_dV_D_S = ((deriv_log_0_d0*(d_q_temp2_dV_D_S))-d_q_rac_qsq_dV_D_S);
d_q_ln_term_dV_G_S = ((deriv_log_0_d0*(d_q_temp2_dV_G_S))-d_q_rac_qsq_dV_G_S);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_sh_term_dV_S_B = (((q_temp2*q_temp2)*(-d_q_qsq_dV_S_B)-(-q_qsq)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dTemp_Tnode_GND = (((q_temp2*q_temp2)*(-d_q_qsq_dTemp_Tnode_GND)-(-q_qsq)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_D_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_D_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_G_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_G_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
else
{

d_q_sh_term_dV_S_B = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_S_B*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dTemp_Tnode_GND = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_D_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_D_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_G_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_G_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{

d_q_expnum_dV_S_B = (d_q_k1q1_dV_S_B+d_q_qcoth_dV_S_B);
d_q_expnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_expnum_dV_D_S = (d_q_k1q1_dV_D_S+d_q_qcoth_dV_D_S);
d_q_expnum_dV_G_S = (d_q_k1q1_dV_G_S+d_q_qcoth_dV_G_S);
q_expnum = (q_k1q1+q_qcoth);

d_q_d1_expnum_dV_S_B = (d_k1_dV_S_B+d_q_d1_qcoth_dV_S_B);
d_q_d1_expnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND);
d_q_d1_expnum_dV_D_S = (d_k1_dV_D_S+d_q_d1_qcoth_dV_D_S);
d_q_d1_expnum_dV_G_S = (d_k1_dV_G_S+d_q_d1_qcoth_dV_G_S);
q_d1_expnum = (k1+q_d1_qcoth);

d_q_d2_expnum_dV_S_B = d_q_d2_qcoth_dV_S_B;
d_q_d2_expnum_dTemp_Tnode_GND = d_q_d2_qcoth_dTemp_Tnode_GND;
d_q_d2_expnum_dV_D_S = d_q_d2_qcoth_dV_D_S;
d_q_d2_expnum_dV_G_S = d_q_d2_qcoth_dV_G_S;
q_d2_expnum = q_d2_qcoth;
}
else
{

d_q_temp2_dV_S_B = (-(d_q_k1q1_dV_S_B-d_q_qcoth_dV_S_B)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dTemp_Tnode_GND = (-(d_q_k1q1_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_D_S = (-(d_q_k1q1_dV_D_S-d_q_qcoth_dV_D_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_G_S = (-(d_q_k1q1_dV_G_S-d_q_qcoth_dV_G_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));

d_q_temp3_dV_S_B = (d_q_d1_qcoth_dV_S_B-d_k1_dV_S_B);
d_q_temp3_dTemp_Tnode_GND = (d_q_d1_qcoth_dTemp_Tnode_GND-d_k1_dTemp_Tnode_GND);
d_q_temp3_dV_D_S = (d_q_d1_qcoth_dV_D_S-d_k1_dV_D_S);
d_q_temp3_dV_G_S = (d_q_d1_qcoth_dV_G_S-d_k1_dV_G_S);
q_temp3 = (q_d1_qcoth-k1);

d_q_expnum_dV_S_B = ((q_Aexp-q_sh_term)*d_q_temp2_dV_S_B+(d_q_Aexp_dV_S_B-d_q_sh_term_dV_S_B)*q_temp2);
d_q_expnum_dV_D_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_D_S+(d_q_Aexp_dV_D_S-d_q_sh_term_dV_D_S)*q_temp2);
d_q_expnum_dV_G_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_G_S+(d_q_Aexp_dV_G_S-d_q_sh_term_dV_G_S)*q_temp2);
d_q_expnum_dTemp_Tnode_GND = ((q_Aexp-q_sh_term)*d_q_temp2_dTemp_Tnode_GND+(d_q_Aexp_dTemp_Tnode_GND-d_q_sh_term_dTemp_Tnode_GND)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);

d_q_d1_expnum_dV_S_B = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_S_B+(((q_temp3*d_q_expnum_dV_S_B+d_q_temp3_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B)-(q_d1_ln*d_q_sh_term_dV_S_B+d_q_d1_ln_dV_S_B*q_sh_term))*q_temp2);
d_q_d1_expnum_dTemp_Tnode_GND = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+(((q_temp3*d_q_expnum_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND)-(q_d1_ln*d_q_sh_term_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_D_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_D_S+(((q_temp3*d_q_expnum_dV_D_S+d_q_temp3_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S)-(q_d1_ln*d_q_sh_term_dV_D_S+d_q_d1_ln_dV_D_S*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_G_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_G_S+(((q_temp3*d_q_expnum_dV_G_S+d_q_temp3_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S)-(q_d1_ln*d_q_sh_term_dV_G_S+d_q_d1_ln_dV_G_S*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);

d_q_d2_expnum_dV_S_B = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_S_B+((((q_d2_qcoth*d_q_expnum_dV_S_B+d_q_d2_qcoth_dV_S_B*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_S_B+2.0*d_q_temp3_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_S_B+(d_q_d2_ln_dV_S_B+(q_d1_ln*d_q_d1_ln_dV_S_B+d_q_d1_ln_dV_S_B*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dTemp_Tnode_GND = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+((((q_d2_qcoth*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qcoth_dTemp_Tnode_GND*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_temp3_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dTemp_Tnode_GND+(d_q_d2_ln_dTemp_Tnode_GND+(q_d1_ln*d_q_d1_ln_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_D_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_D_S+((((q_d2_qcoth*d_q_expnum_dV_D_S+d_q_d2_qcoth_dV_D_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_D_S+2.0*d_q_temp3_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_D_S+(d_q_d2_ln_dV_D_S+(q_d1_ln*d_q_d1_ln_dV_D_S+d_q_d1_ln_dV_D_S*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_G_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_G_S+((((q_d2_qcoth*d_q_expnum_dV_G_S+d_q_d2_qcoth_dV_G_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_G_S+2.0*d_q_temp3_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_G_S+(d_q_d2_ln_dV_G_S+(q_d1_ln*d_q_d1_ln_dV_G_S+d_q_d1_ln_dV_G_S*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);

d_q_lnexpnum_dV_S_B = (deriv_log_0_d0*(d_q_expnum_dV_S_B));
d_q_lnexpnum_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_expnum_dTemp_Tnode_GND));
d_q_lnexpnum_dV_D_S = (deriv_log_0_d0*(d_q_expnum_dV_D_S));
d_q_lnexpnum_dV_G_S = (deriv_log_0_d0*(d_q_expnum_dV_G_S));
q_lnexpnum = value_log_0;
}

d_q_temp1_dV_S_B = (-d_q_expnum_dV_S_B/q_expnum/q_expnum);
d_q_temp1_dTemp_Tnode_GND = (-d_q_expnum_dTemp_Tnode_GND/q_expnum/q_expnum);
d_q_temp1_dV_D_S = (-d_q_expnum_dV_D_S/q_expnum/q_expnum);
d_q_temp1_dV_G_S = (-d_q_expnum_dV_G_S/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);

d_q_d1_lnexpnum_dV_S_B = (q_d1_expnum*d_q_temp1_dV_S_B+d_q_d1_expnum_dV_S_B*q_temp1);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (q_d1_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d1_expnum_dTemp_Tnode_GND*q_temp1);
d_q_d1_lnexpnum_dV_D_S = (q_d1_expnum*d_q_temp1_dV_D_S+d_q_d1_expnum_dV_D_S*q_temp1);
d_q_d1_lnexpnum_dV_G_S = (q_d1_expnum*d_q_temp1_dV_G_S+d_q_d1_expnum_dV_G_S*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((q_d2_expnum*d_q_temp1_dV_S_B+d_q_d2_expnum_dV_S_B*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_S_B+d_q_d1_lnexpnum_dV_S_B*q_d1_lnexpnum));
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((q_d2_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d2_expnum_dTemp_Tnode_GND*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dTemp_Tnode_GND+d_q_d1_lnexpnum_dTemp_Tnode_GND*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_D_S = ((q_d2_expnum*d_q_temp1_dV_D_S+d_q_d2_expnum_dV_D_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_D_S+d_q_d1_lnexpnum_dV_D_S*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_G_S = ((q_d2_expnum*d_q_temp1_dV_G_S+d_q_d2_expnum_dV_G_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_G_S+d_q_d1_lnexpnum_dV_G_S*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));

d_q_lnexpnum_dV_S_B = (d_q_k1q1_dV_S_B+(deriv_log_0_d0*((-d_q_k1q1_dV_S_B))));
d_q_lnexpnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(deriv_log_0_d0*((-d_q_k1q1_dTemp_Tnode_GND))));
d_q_lnexpnum_dV_D_S = (d_q_k1q1_dV_D_S+(deriv_log_0_d0*((-d_q_k1q1_dV_D_S))));
d_q_lnexpnum_dV_G_S = (d_q_k1q1_dV_G_S+(deriv_log_0_d0*((-d_q_k1q1_dV_G_S))));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}

d_q_temp1_dV_S_B = (-d_q1d_dV_S_B/q1d/q1d);
d_q_temp1_dV_D_S = (-d_q1d_dV_D_S/q1d/q1d);
d_q_temp1_dV_G_S = (-d_q1d_dV_G_S/q1d/q1d);
d_q_temp1_dTemp_Tnode_GND = (-d_q1d_dTemp_Tnode_GND/q1d/q1d);
q_temp1 = (1.0/q1d);

d_q_d1_lnexpnum_dV_S_B = (d_k1_dV_S_B+d_q_temp1_dV_S_B);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_temp1_dTemp_Tnode_GND);
d_q_d1_lnexpnum_dV_D_S = (d_k1_dV_D_S+d_q_temp1_dV_D_S);
d_q_d1_lnexpnum_dV_G_S = (d_k1_dV_G_S+d_q_temp1_dV_G_S);
q_d1_lnexpnum = (k1+q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((-q_temp1)*d_q_temp1_dV_S_B+(-d_q_temp1_dV_S_B)*q_temp1);
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((-q_temp1)*d_q_temp1_dTemp_Tnode_GND+(-d_q_temp1_dTemp_Tnode_GND)*q_temp1);
d_q_d2_lnexpnum_dV_D_S = ((-q_temp1)*d_q_temp1_dV_D_S+(-d_q_temp1_dV_D_S)*q_temp1);
d_q_d2_lnexpnum_dV_G_S = ((-q_temp1)*d_q_temp1_dV_G_S+(-d_q_temp1_dV_G_S)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}

d_q_q2_int_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1d_dV_S_B)+2.0*d_q_lnexpnum_dV_S_B)-d_q_ln_term_dV_S_B);
d_q_q2_int_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1d_dTemp_Tnode_GND)+2.0*d_q_lnexpnum_dTemp_Tnode_GND)-d_q_ln_term_dTemp_Tnode_GND);
d_q_q2_int_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1d_dV_D_S)+2.0*d_q_lnexpnum_dV_D_S)-d_q_ln_term_dV_D_S);
d_q_q2_int_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1d_dV_G_S)+2.0*d_q_lnexpnum_dV_G_S)-d_q_ln_term_dV_G_S);
q_q2_int = ((((xg2x-xg1x)+q1d)+(2.0*q_lnexpnum))-q_ln_term);

d_q_d1_q2_dV_S_B = (2.0*d_q_d1_lnexpnum_dV_S_B-d_q_d1_ln_dV_S_B);
d_q_d1_q2_dTemp_Tnode_GND = (2.0*d_q_d1_lnexpnum_dTemp_Tnode_GND-d_q_d1_ln_dTemp_Tnode_GND);
d_q_d1_q2_dV_D_S = (2.0*d_q_d1_lnexpnum_dV_D_S-d_q_d1_ln_dV_D_S);
d_q_d1_q2_dV_G_S = (2.0*d_q_d1_lnexpnum_dV_G_S-d_q_d1_ln_dV_G_S);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);

d_q_d2_q2_dV_S_B = (2.0*d_q_d2_lnexpnum_dV_S_B-d_q_d2_ln_dV_S_B);
d_q_d2_q2_dTemp_Tnode_GND = (2.0*d_q_d2_lnexpnum_dTemp_Tnode_GND-d_q_d2_ln_dTemp_Tnode_GND);
d_q_d2_q2_dV_D_S = (2.0*d_q_d2_lnexpnum_dV_D_S-d_q_d2_ln_dV_D_S);
d_q_d2_q2_dV_G_S = (2.0*d_q_d2_lnexpnum_dV_G_S-d_q_d2_ln_dV_G_S);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+(k2*d_q_q2_int_dV_S_B+d_k2_dV_S_B*q_q2_int));
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(k2*d_q_q2_int_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_q2_int));
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+(k2*d_q_q2_int_dV_D_S+d_k2_dV_D_S*q_q2_int));
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+(k2*d_q_q2_int_dV_G_S+d_k2_dV_G_S*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));

d_q_d1_qi_dV_S_B = (d_k1_dV_S_B+(k2*d_q_d1_q2_dV_S_B+d_k2_dV_S_B*q_d1_q2));
d_q_d1_qi_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+(k2*d_q_d1_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d1_q2));
d_q_d1_qi_dV_D_S = (d_k1_dV_D_S+(k2*d_q_d1_q2_dV_D_S+d_k2_dV_D_S*q_d1_q2));
d_q_d1_qi_dV_G_S = (d_k1_dV_G_S+(k2*d_q_d1_q2_dV_G_S+d_k2_dV_G_S*q_d1_q2));
q_d1_qi = (k1+(k2*q_d1_q2));

d_q_d2_qi_dV_S_B = (k2*d_q_d2_q2_dV_S_B+d_k2_dV_S_B*q_d2_q2);
d_q_d2_qi_dTemp_Tnode_GND = (k2*d_q_d2_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d2_q2);
d_q_d2_qi_dV_D_S = (k2*d_q_d2_q2_dV_D_S+d_k2_dV_D_S*q_d2_q2);
d_q_d2_qi_dV_G_S = (k2*d_q_d2_q2_dV_G_S+d_k2_dV_G_S*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);

d_q_zero_dV_S_B = ((q_qi_int*d_q_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B);
d_q_zero_dTemp_Tnode_GND = ((q_qi_int*d_q_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND);
d_q_zero_dV_D_S = ((q_qi_int*d_q_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S);
d_q_zero_dV_G_S = ((q_qi_int*d_q_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{

d_q_eps2_dV_G_S = d_q_eps2_dV_D_S = d_q_eps2_dTemp_Tnode_GND = d_q_eps2_dV_S_B =  0.0;
q_eps2 = 0.0;
}
else
{

d_q_d1_zero_dV_S_B = (((q_d1_qi*d_q_expnum_dV_S_B+d_q_d1_qi_dV_S_B*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((q_d1_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d1_qi_dTemp_Tnode_GND*q_expnum)+(q_qi_int*d_q_d1_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((q_d1_qi*d_q_expnum_dV_D_S+d_q_d1_qi_dV_D_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S);
d_q_d1_zero_dV_G_S = (((q_d1_qi*d_q_expnum_dV_G_S+d_q_d1_qi_dV_G_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);

d_q_d2_zero_dV_S_B = ((((q_d2_qi*d_q_expnum_dV_S_B+d_q_d2_qi_dV_S_B*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_S_B+2.0*d_q_d1_qi_dV_S_B*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d2_expnum))-d_q_Aexp_dV_S_B);
d_q_d2_zero_dTemp_Tnode_GND = ((((q_d2_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qi_dTemp_Tnode_GND*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_d1_qi_dTemp_Tnode_GND*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d2_expnum))-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_zero_dV_D_S = ((((q_d2_qi*d_q_expnum_dV_D_S+d_q_d2_qi_dV_D_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_D_S+2.0*d_q_d1_qi_dV_D_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d2_expnum))-d_q_Aexp_dV_D_S);
d_q_d2_zero_dV_G_S = ((((q_d2_qi*d_q_expnum_dV_G_S+d_q_d2_qi_dV_G_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_G_S+2.0*d_q_d1_qi_dV_G_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d2_expnum))-d_q_Aexp_dV_G_S);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);

d_q_eps1_dV_S_B = ((q_d1_zero*(-d_q_zero_dV_S_B)-(-q_zero)*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero);
d_q_eps1_dTemp_Tnode_GND = ((q_d1_zero*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_D_S = ((q_d1_zero*(-d_q_zero_dV_D_S)-(-q_zero)*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_G_S = ((q_d1_zero*(-d_q_zero_dV_G_S)-(-q_zero)*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);

d_q_eps2_dV_S_B = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_S_B)-(-q_zero)*(d_q_d1_zero_dV_S_B+((0.5*q_eps1)*d_q_d2_zero_dV_S_B+0.5*d_q_eps1_dV_S_B*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dTemp_Tnode_GND = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*(d_q_d1_zero_dTemp_Tnode_GND+((0.5*q_eps1)*d_q_d2_zero_dTemp_Tnode_GND+0.5*d_q_eps1_dTemp_Tnode_GND*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_D_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_D_S)-(-q_zero)*(d_q_d1_zero_dV_D_S+((0.5*q_eps1)*d_q_d2_zero_dV_D_S+0.5*d_q_eps1_dV_D_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_G_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_G_S)-(-q_zero)*(d_q_d1_zero_dV_G_S+((0.5*q_eps1)*d_q_d2_zero_dV_G_S+0.5*d_q_eps1_dV_G_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}

d_q1d_dV_S_B = (d_q1d_dV_S_B+d_q_eps2_dV_S_B);
d_q1d_dV_D_S = (d_q1d_dV_D_S+d_q_eps2_dV_D_S);
d_q1d_dV_G_S = (d_q1d_dV_G_S+d_q_eps2_dV_G_S);
d_q1d_dTemp_Tnode_GND = (d_q1d_dTemp_Tnode_GND+d_q_eps2_dTemp_Tnode_GND);
q1d = (q1d+q_eps2);

d_q_k1q1_dV_S_B = (k1*d_q1d_dV_S_B+d_k1_dV_S_B*q1d);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1d_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1d);
d_q_k1q1_dV_D_S = (k1*d_q1d_dV_D_S+d_k1_dV_D_S*q1d);
d_q_k1q1_dV_G_S = (k1*d_q1d_dV_G_S+d_k1_dV_G_S*q1d);
q_k1q1 = (k1*q1d);

d_q_k2q2_dV_S_B = (k2*d_q2d_dV_S_B+d_k2_dV_S_B*q2d);
d_q_k2q2_dTemp_Tnode_GND = (k2*d_q2d_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q2d);
d_q_k2q2_dV_D_S = (k2*d_q2d_dV_D_S+d_k2_dV_D_S*q2d);
d_q_k2q2_dV_G_S = (k2*d_q2d_dV_G_S+d_k2_dV_G_S*q2d);
q_k2q2 = (k2*q2d);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+d_q_k2q2_dV_S_B);
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_k2q2_dTemp_Tnode_GND);
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+d_q_k2q2_dV_D_S);
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+d_q_k2q2_dV_G_S);
q_qi_int = (q_k1q1+q_k2q2);

d_q_a_dV_S_B = 0.065345483024*d_q_qi_int_dV_S_B;
d_q_a_dTemp_Tnode_GND = 0.065345483024*d_q_qi_int_dTemp_Tnode_GND;
d_q_a_dV_D_S = 0.065345483024*d_q_qi_int_dV_D_S;
d_q_a_dV_G_S = 0.065345483024*d_q_qi_int_dV_G_S;
q_a = (1.0+(0.065345483024*q_qi_int));

d_q_b_dV_S_B = (8.5797362674*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_b_dTemp_Tnode_GND = (8.5797362674*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_b_dV_D_S = (8.5797362674*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_b_dV_G_S = (8.5797362674*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));

d_q_c_dV_S_B = 39.478417604*(2.0*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_c_dTemp_Tnode_GND = 39.478417604*(2.0*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_c_dV_D_S = 39.478417604*(2.0*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_c_dV_G_S = 39.478417604*(2.0*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_q_disc_dV_S_B = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_S_B+d_q_b_dV_S_B*q_b)-((4.0*q_a)*d_q_c_dV_S_B+4.0*d_q_a_dV_S_B*q_c))));
d_q_disc_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((q_b*d_q_b_dTemp_Tnode_GND+d_q_b_dTemp_Tnode_GND*q_b)-((4.0*q_a)*d_q_c_dTemp_Tnode_GND+4.0*d_q_a_dTemp_Tnode_GND*q_c))));
d_q_disc_dV_D_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_D_S+d_q_b_dV_D_S*q_b)-((4.0*q_a)*d_q_c_dV_D_S+4.0*d_q_a_dV_D_S*q_c))));
d_q_disc_dV_G_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_G_S+d_q_b_dV_G_S*q_b)-((4.0*q_a)*d_q_c_dV_G_S+4.0*d_q_a_dV_G_S*q_c))));
q_disc = value_sqrt_0;
}

d_q_qsq_dV_S_B = (((2.0*q_a)*(d_q_disc_dV_S_B-d_q_b_dV_S_B)-(q_disc-q_b)*2.0*d_q_a_dV_S_B)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dTemp_Tnode_GND = (((2.0*q_a)*(d_q_disc_dTemp_Tnode_GND-d_q_b_dTemp_Tnode_GND)-(q_disc-q_b)*2.0*d_q_a_dTemp_Tnode_GND)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_D_S = (((2.0*q_a)*(d_q_disc_dV_D_S-d_q_b_dV_D_S)-(q_disc-q_b)*2.0*d_q_a_dV_D_S)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_G_S = (((2.0*q_a)*(d_q_disc_dV_G_S-d_q_b_dV_G_S)-(q_disc-q_b)*2.0*d_q_a_dV_G_S)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));

d_q_delta_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_qsq_dV_S_B);
d_q_delta_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_qsq_dTemp_Tnode_GND);
d_q_delta_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_qsq_dV_D_S);
d_q_delta_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_qsq_dV_G_S);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));

d_q_zero_dV_S_B = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dV_S_B-q_delta*d_A0_dV_S_B)/A0/A0)))+d_xdeff_dV_S_B)-d_xg1x_dV_S_B)+d_q1d_dV_S_B)+d_q_delta_dV_S_B*(((value_log_0+xdeff)-xg1x)+q1d));
d_q_zero_dTemp_Tnode_GND = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dTemp_Tnode_GND-q_delta*d_A0_dTemp_Tnode_GND)/A0/A0)))+d_xdeff_dTemp_Tnode_GND)-d_xg1x_dTemp_Tnode_GND)+d_q1d_dTemp_Tnode_GND)+d_q_delta_dTemp_Tnode_GND*(((value_log_0+xdeff)-xg1x)+q1d));
d_q_zero_dV_D_S = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dV_D_S-q_delta*d_A0_dV_D_S)/A0/A0)))+d_xdeff_dV_D_S)-d_xg1x_dV_D_S)+d_q1d_dV_D_S)+d_q_delta_dV_D_S*(((value_log_0+xdeff)-xg1x)+q1d));
d_q_zero_dV_G_S = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dV_G_S-q_delta*d_A0_dV_G_S)/A0/A0)))+d_xdeff_dV_G_S)-d_xg1x_dV_G_S)+d_q1d_dV_G_S)+d_q_delta_dV_G_S*(((value_log_0+xdeff)-xg1x)+q1d));
q_zero = (q_delta*(((value_log_0+xdeff)-xg1x)+q1d));
}

d_q_d1_zero_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_delta_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_delta_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_delta_dV_D_S);
d_q_d1_zero_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_delta_dV_G_S);
q_d1_zero = (((2.0*k1)*q_k1q1)+q_delta);

d_q_dx1_dV_S_B = ((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_q_x1sat_dV_S_B);
d_q_dx1_dV_D_S = ((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_q_x1sat_dV_D_S);
d_q_dx1_dV_G_S = ((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_q_x1sat_dV_G_S);
d_q_dx1_dTemp_Tnode_GND = ((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_q_x1sat_dTemp_Tnode_GND);
q_dx1 = ((xg1x-q1d)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(k1))>0.0))||(q_dx1>1.0)))
{

d_q1d_dV_S_B = (d_q1d_dV_S_B-((q_d1_zero*d_q_zero_dV_S_B-q_zero*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero));
d_q1d_dV_D_S = (d_q1d_dV_D_S-((q_d1_zero*d_q_zero_dV_D_S-q_zero*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero));
d_q1d_dV_G_S = (d_q1d_dV_G_S-((q_d1_zero*d_q_zero_dV_G_S-q_zero*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero));
d_q1d_dTemp_Tnode_GND = (d_q1d_dTemp_Tnode_GND-((q_d1_zero*d_q_zero_dTemp_Tnode_GND-q_zero*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero));
q1d = (q1d-(q_zero/q_d1_zero));
}
}

d_q_k1q1_dV_S_B = (k1*d_q1d_dV_S_B+d_k1_dV_S_B*q1d);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1d_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1d);
d_q_k1q1_dV_D_S = (k1*d_q1d_dV_D_S+d_k1_dV_D_S*q1d);
d_q_k1q1_dV_G_S = (k1*d_q1d_dV_G_S+d_k1_dV_G_S*q1d);
q_k1q1 = (k1*q1d);

d_q_k2q2_dV_S_B = (k2*d_q2d_dV_S_B+d_k2_dV_S_B*q2d);
d_q_k2q2_dTemp_Tnode_GND = (k2*d_q2d_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q2d);
d_q_k2q2_dV_D_S = (k2*d_q2d_dV_D_S+d_k2_dV_D_S*q2d);
d_q_k2q2_dV_G_S = (k2*d_q2d_dV_G_S+d_k2_dV_G_S*q2d);
q_k2q2 = (k2*q2d);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+d_q_k2q2_dV_S_B);
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_k2q2_dTemp_Tnode_GND);
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+d_q_k2q2_dV_D_S);
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+d_q_k2q2_dV_G_S);
q_qi_int = (q_k1q1+q_k2q2);

d_q_a_dV_S_B = 0.065345483024*d_q_qi_int_dV_S_B;
d_q_a_dTemp_Tnode_GND = 0.065345483024*d_q_qi_int_dTemp_Tnode_GND;
d_q_a_dV_D_S = 0.065345483024*d_q_qi_int_dV_D_S;
d_q_a_dV_G_S = 0.065345483024*d_q_qi_int_dV_G_S;
q_a = (1.0+(0.065345483024*q_qi_int));

d_q_b_dV_S_B = (8.5797362674*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_b_dTemp_Tnode_GND = (8.5797362674*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_b_dV_D_S = (8.5797362674*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_b_dV_G_S = (8.5797362674*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));

d_q_c_dV_S_B = 39.478417604*(2.0*d_q_qi_int_dV_S_B+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2));
d_q_c_dTemp_Tnode_GND = 39.478417604*(2.0*d_q_qi_int_dTemp_Tnode_GND+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2));
d_q_c_dV_D_S = 39.478417604*(2.0*d_q_qi_int_dV_D_S+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2));
d_q_c_dV_G_S = 39.478417604*(2.0*d_q_qi_int_dV_G_S+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_q_disc_dV_S_B = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_S_B+d_q_b_dV_S_B*q_b)-((4.0*q_a)*d_q_c_dV_S_B+4.0*d_q_a_dV_S_B*q_c))));
d_q_disc_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((q_b*d_q_b_dTemp_Tnode_GND+d_q_b_dTemp_Tnode_GND*q_b)-((4.0*q_a)*d_q_c_dTemp_Tnode_GND+4.0*d_q_a_dTemp_Tnode_GND*q_c))));
d_q_disc_dV_D_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_D_S+d_q_b_dV_D_S*q_b)-((4.0*q_a)*d_q_c_dV_D_S+4.0*d_q_a_dV_D_S*q_c))));
d_q_disc_dV_G_S = (deriv_sqrt_0_d0*(((q_b*d_q_b_dV_G_S+d_q_b_dV_G_S*q_b)-((4.0*q_a)*d_q_c_dV_G_S+4.0*d_q_a_dV_G_S*q_c))));
q_disc = value_sqrt_0;
}

d_q_qsq_dV_S_B = (((2.0*q_a)*(d_q_disc_dV_S_B-d_q_b_dV_S_B)-(q_disc-q_b)*2.0*d_q_a_dV_S_B)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dTemp_Tnode_GND = (((2.0*q_a)*(d_q_disc_dTemp_Tnode_GND-d_q_b_dTemp_Tnode_GND)-(q_disc-q_b)*2.0*d_q_a_dTemp_Tnode_GND)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_D_S = (((2.0*q_a)*(d_q_disc_dV_D_S-d_q_b_dV_D_S)-(q_disc-q_b)*2.0*d_q_a_dV_D_S)/(2.0*q_a)/(2.0*q_a));
d_q_qsq_dV_G_S = (((2.0*q_a)*(d_q_disc_dV_G_S-d_q_b_dV_G_S)-(q_disc-q_b)*2.0*d_q_a_dV_G_S)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_d1_qcoth_dV_S_B = ((q_qsq*0.25*(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq*0.25*(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_D_S = ((q_qsq*0.25*(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_G_S = ((q_qsq*0.25*(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_d1_qcoth_dV_S_B = ((q_qsq*0.25*(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq*0.25*(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_D_S = ((q_qsq*0.25*(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d1_qcoth_dV_G_S = ((q_qsq*0.25*(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{

d_q_qcoth_dV_S_B = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dV_S_B*0.0238095238095)+d_q_qsq_dV_S_B*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dV_S_B*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
d_q_qcoth_dTemp_Tnode_GND = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dTemp_Tnode_GND*0.0238095238095)+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dTemp_Tnode_GND*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
d_q_qcoth_dV_D_S = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dV_D_S*0.0238095238095)+d_q_qsq_dV_D_S*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dV_D_S*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
d_q_qcoth_dV_G_S = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dV_G_S*0.0238095238095)+d_q_qsq_dV_G_S*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dV_G_S*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
q_qcoth = (2.0+((q_qsq*0.1666666666667)*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095))))));

d_q_d1_qcoth_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_d1_qcoth_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_d1_qcoth_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_d1_qcoth_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_d1_qcoth = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
}
}

d_q_qsq_dV_S_B = (d_q_qsq_dV_S_B-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dV_S_B+d_q_qi_int_dV_S_B*q_qcoth)+(q_k1q1*d_q_k2q2_dV_S_B+d_q_k1q1_dV_S_B*q_k2q2))+d_q_qsq_dV_S_B)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dV_S_B+d_q_qi_int_dV_S_B*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_qsq_dTemp_Tnode_GND = (d_q_qsq_dTemp_Tnode_GND-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_qcoth)+(q_k1q1*d_q_k2q2_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k2q2))+d_q_qsq_dTemp_Tnode_GND)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_qsq_dV_D_S = (d_q_qsq_dV_D_S-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dV_D_S+d_q_qi_int_dV_D_S*q_qcoth)+(q_k1q1*d_q_k2q2_dV_D_S+d_q_k1q1_dV_D_S*q_k2q2))+d_q_qsq_dV_D_S)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dV_D_S+d_q_qi_int_dV_D_S*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_qsq_dV_G_S = (d_q_qsq_dV_G_S-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dV_G_S+d_q_qi_int_dV_G_S*q_qcoth)+(q_k1q1*d_q_k2q2_dV_G_S+d_q_k1q1_dV_G_S*q_k2q2))+d_q_qsq_dV_G_S)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dV_G_S+d_q_qi_int_dV_G_S*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
q_qsq = (q_qsq-((((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)/((q_qi_int*q_d1_qcoth)+1.0)));

d_q_delta_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_qsq_dV_S_B);
d_q_delta_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_qsq_dTemp_Tnode_GND);
d_q_delta_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_qsq_dV_D_S);
d_q_delta_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_qsq_dV_G_S);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));

d_q_zero_dV_S_B = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dV_S_B-q_delta*d_A0_dV_S_B)/A0/A0)))+d_xdeff_dV_S_B)-d_xg1x_dV_S_B)+d_q1d_dV_S_B)+d_q_delta_dV_S_B*(((value_log_0+xdeff)-xg1x)+q1d));
d_q_zero_dTemp_Tnode_GND = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dTemp_Tnode_GND-q_delta*d_A0_dTemp_Tnode_GND)/A0/A0)))+d_xdeff_dTemp_Tnode_GND)-d_xg1x_dTemp_Tnode_GND)+d_q1d_dTemp_Tnode_GND)+d_q_delta_dTemp_Tnode_GND*(((value_log_0+xdeff)-xg1x)+q1d));
d_q_zero_dV_D_S = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dV_D_S-q_delta*d_A0_dV_D_S)/A0/A0)))+d_xdeff_dV_D_S)-d_xg1x_dV_D_S)+d_q1d_dV_D_S)+d_q_delta_dV_D_S*(((value_log_0+xdeff)-xg1x)+q1d));
d_q_zero_dV_G_S = (q_delta*((((deriv_log_0_d0*(((A0*d_q_delta_dV_G_S-q_delta*d_A0_dV_G_S)/A0/A0)))+d_xdeff_dV_G_S)-d_xg1x_dV_G_S)+d_q1d_dV_G_S)+d_q_delta_dV_G_S*(((value_log_0+xdeff)-xg1x)+q1d));
q_zero = (q_delta*(((value_log_0+xdeff)-xg1x)+q1d));
}

d_q_d1_zero_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_delta_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_delta_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_delta_dV_D_S);
d_q_d1_zero_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_delta_dV_G_S);
q_d1_zero = (((2.0*k1)*q_k1q1)+q_delta);

d_q_dx1_dV_S_B = ((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_q_x1sat_dV_S_B);
d_q_dx1_dV_D_S = ((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_q_x1sat_dV_D_S);
d_q_dx1_dV_G_S = ((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_q_x1sat_dV_G_S);
d_q_dx1_dTemp_Tnode_GND = ((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_q_x1sat_dTemp_Tnode_GND);
q_dx1 = ((xg1x-q1d)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(k1))>0.0))||(q_dx1>1.0)))
{

d_q1d_dV_S_B = (d_q1d_dV_S_B-((q_d1_zero*d_q_zero_dV_S_B-q_zero*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero));
d_q1d_dV_D_S = (d_q1d_dV_D_S-((q_d1_zero*d_q_zero_dV_D_S-q_zero*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero));
d_q1d_dV_G_S = (d_q1d_dV_G_S-((q_d1_zero*d_q_zero_dV_G_S-q_zero*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero));
d_q1d_dTemp_Tnode_GND = (d_q1d_dTemp_Tnode_GND-((q_d1_zero*d_q_zero_dTemp_Tnode_GND-q_zero*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero));
q1d = (q1d-(q_zero/q_d1_zero));
}
}

d_q_k1q1_dV_S_B = (k1*d_q1d_dV_S_B+d_k1_dV_S_B*q1d);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1d_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1d);
d_q_k1q1_dV_D_S = (k1*d_q1d_dV_D_S+d_k1_dV_D_S*q1d);
d_q_k1q1_dV_G_S = (k1*d_q1d_dV_G_S+d_k1_dV_G_S*q1d);
q_k1q1 = (k1*q1d);
if ((((xg1x-q1d)-xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-xdeff));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*(((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*(((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*(((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*(((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*0.3333333333333+0.5*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*0.3333333333333+0.5*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*0.3333333333333+0.5*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*0.3333333333333+0.5*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))))));
}

d_q_Aexp_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_q_Aexp_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_q_Aexp_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_q_Aexp_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
q_Aexp = (A0*q_temp1);

d_q_qsq_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_Aexp_dV_S_B);
d_q_qsq_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_qsq_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_Aexp_dV_D_S);
d_q_qsq_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_Aexp_dV_G_S);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);

d_q_d1_qsq_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_Aexp_dV_S_B);
d_q_d1_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_qsq_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_Aexp_dV_D_S);
d_q_d1_qsq_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_Aexp_dV_G_S);
q_d1_qsq = (((2.0*k1)*q_k1q1)+q_Aexp);

d_q_d2_qsq_dV_S_B = (((2.0*k1)*d_k1_dV_S_B+2.0*d_k1_dV_S_B*k1)-d_q_Aexp_dV_S_B);
d_q_d2_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_k1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*k1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_qsq_dV_D_S = (((2.0*k1)*d_k1_dV_D_S+2.0*d_k1_dV_D_S*k1)-d_q_Aexp_dV_D_S);
d_q_d2_qsq_dV_G_S = (((2.0*k1)*d_k1_dV_G_S+2.0*d_k1_dV_G_S*k1)-d_q_Aexp_dV_G_S);
q_d2_qsq = (((2.0*k1)*k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{

d_q_temp3_dV_S_B = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_S_B*0.025)+d_q_qsq_dV_S_B*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_S_B*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dTemp_Tnode_GND*0.025)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_D_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_D_S*0.025)+d_q_qsq_dV_D_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_D_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_G_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_G_S*0.025)+d_q_qsq_dV_G_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_G_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));

d_q_qcoth_dV_S_B = (q_qsq*d_q_temp3_dV_S_B+d_q_qsq_dV_S_B*q_temp3);
d_q_qcoth_dTemp_Tnode_GND = (q_qsq*d_q_temp3_dTemp_Tnode_GND+d_q_qsq_dTemp_Tnode_GND*q_temp3);
d_q_qcoth_dV_D_S = (q_qsq*d_q_temp3_dV_D_S+d_q_qsq_dV_D_S*q_temp3);
d_q_qcoth_dV_G_S = (q_qsq*d_q_temp3_dV_G_S+d_q_qsq_dV_G_S*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));

d_q_temp1_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));

d_q_d1_qcoth_dV_S_B = (q_d1_qsq*d_q_temp1_dV_S_B+d_q_d1_qsq_dV_S_B*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = (q_d1_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_temp1);
d_q_d1_qcoth_dV_D_S = (q_d1_qsq*d_q_temp1_dV_D_S+d_q_d1_qsq_dV_D_S*q_temp1);
d_q_d1_qcoth_dV_G_S = (q_d1_qsq*d_q_temp1_dV_G_S+d_q_d1_qsq_dV_G_S*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);

d_q_temp2_dV_S_B = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_S_B*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dTemp_Tnode_GND = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_D_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_D_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_G_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_G_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));

d_q_d2_qcoth_dV_S_B = ((q_d2_qsq*d_q_temp1_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_S_B+(q_d1_qsq*d_q_d1_qsq_dV_S_B+d_q_d1_qsq_dV_S_B*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dTemp_Tnode_GND = ((q_d2_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dTemp_Tnode_GND+(q_d1_qsq*d_q_d1_qsq_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_D_S = ((q_d2_qsq*d_q_temp1_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_D_S+(q_d1_qsq*d_q_d1_qsq_dV_D_S+d_q_d1_qsq_dV_D_S*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_G_S = ((q_d2_qsq*d_q_temp1_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_G_S+(q_d1_qsq*d_q_d1_qsq_dV_G_S+d_q_d1_qsq_dV_G_S*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));

d_q_d1_ln_dV_S_B = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d1_qsq_dV_S_B*q_temp3);
d_q_d1_ln_dTemp_Tnode_GND = (((-0.5)*q_d1_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d1_qsq_dTemp_Tnode_GND*q_temp3);
d_q_d1_ln_dV_D_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d1_qsq_dV_D_S*q_temp3);
d_q_d1_ln_dV_G_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d1_qsq_dV_G_S*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);

d_q_d2_ln_dV_S_B = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d2_qsq_dV_S_B*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_S_B)+d_q_qsq_dV_S_B*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_S_B+(0.25*0.0055555555556)*d_q_d1_qsq_dV_S_B*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dTemp_Tnode_GND = ((((-0.5)*q_d2_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d2_qsq_dTemp_Tnode_GND*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dTemp_Tnode_GND)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dTemp_Tnode_GND+(0.25*0.0055555555556)*d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_D_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d2_qsq_dV_D_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_D_S)+d_q_qsq_dV_D_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_D_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_D_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_G_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d2_qsq_dV_G_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_G_S)+d_q_qsq_dV_G_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_G_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_G_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{

d_q_temp2_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_S_B-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dTemp_Tnode_GND-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_D_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_G_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));

d_q_sh_term_dV_S_B = (q_temp2*d_q_invexpq_dV_S_B+d_q_temp2_dV_S_B*q_invexpq);
d_q_sh_term_dTemp_Tnode_GND = (q_temp2*d_q_invexpq_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_invexpq);
d_q_sh_term_dV_D_S = (q_temp2*d_q_invexpq_dV_D_S+d_q_temp2_dV_D_S*q_invexpq);
d_q_sh_term_dV_G_S = (q_temp2*d_q_invexpq_dV_G_S+d_q_temp2_dV_G_S*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);

d_q_ln_term_dV_S_B = ((deriv_log_0_d0*(d_q_temp2_dV_S_B))-d_q_rac_qsq_dV_S_B);
d_q_ln_term_dTemp_Tnode_GND = ((deriv_log_0_d0*(d_q_temp2_dTemp_Tnode_GND))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_ln_term_dV_D_S = ((deriv_log_0_d0*(d_q_temp2_dV_D_S))-d_q_rac_qsq_dV_D_S);
d_q_ln_term_dV_G_S = ((deriv_log_0_d0*(d_q_temp2_dV_G_S))-d_q_rac_qsq_dV_G_S);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_sh_term_dV_S_B = (((q_temp2*q_temp2)*(-d_q_qsq_dV_S_B)-(-q_qsq)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dTemp_Tnode_GND = (((q_temp2*q_temp2)*(-d_q_qsq_dTemp_Tnode_GND)-(-q_qsq)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_D_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_D_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_G_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_G_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
else
{

d_q_sh_term_dV_S_B = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_S_B*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dTemp_Tnode_GND = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_D_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_D_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_G_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_G_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{

d_q_expnum_dV_S_B = (d_q_k1q1_dV_S_B+d_q_qcoth_dV_S_B);
d_q_expnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_expnum_dV_D_S = (d_q_k1q1_dV_D_S+d_q_qcoth_dV_D_S);
d_q_expnum_dV_G_S = (d_q_k1q1_dV_G_S+d_q_qcoth_dV_G_S);
q_expnum = (q_k1q1+q_qcoth);

d_q_d1_expnum_dV_S_B = (d_k1_dV_S_B+d_q_d1_qcoth_dV_S_B);
d_q_d1_expnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND);
d_q_d1_expnum_dV_D_S = (d_k1_dV_D_S+d_q_d1_qcoth_dV_D_S);
d_q_d1_expnum_dV_G_S = (d_k1_dV_G_S+d_q_d1_qcoth_dV_G_S);
q_d1_expnum = (k1+q_d1_qcoth);

d_q_d2_expnum_dV_S_B = d_q_d2_qcoth_dV_S_B;
d_q_d2_expnum_dTemp_Tnode_GND = d_q_d2_qcoth_dTemp_Tnode_GND;
d_q_d2_expnum_dV_D_S = d_q_d2_qcoth_dV_D_S;
d_q_d2_expnum_dV_G_S = d_q_d2_qcoth_dV_G_S;
q_d2_expnum = q_d2_qcoth;
}
else
{

d_q_temp2_dV_S_B = (-(d_q_k1q1_dV_S_B-d_q_qcoth_dV_S_B)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dTemp_Tnode_GND = (-(d_q_k1q1_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_D_S = (-(d_q_k1q1_dV_D_S-d_q_qcoth_dV_D_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_G_S = (-(d_q_k1q1_dV_G_S-d_q_qcoth_dV_G_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));

d_q_temp3_dV_S_B = (d_q_d1_qcoth_dV_S_B-d_k1_dV_S_B);
d_q_temp3_dTemp_Tnode_GND = (d_q_d1_qcoth_dTemp_Tnode_GND-d_k1_dTemp_Tnode_GND);
d_q_temp3_dV_D_S = (d_q_d1_qcoth_dV_D_S-d_k1_dV_D_S);
d_q_temp3_dV_G_S = (d_q_d1_qcoth_dV_G_S-d_k1_dV_G_S);
q_temp3 = (q_d1_qcoth-k1);

d_q_expnum_dV_S_B = ((q_Aexp-q_sh_term)*d_q_temp2_dV_S_B+(d_q_Aexp_dV_S_B-d_q_sh_term_dV_S_B)*q_temp2);
d_q_expnum_dV_D_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_D_S+(d_q_Aexp_dV_D_S-d_q_sh_term_dV_D_S)*q_temp2);
d_q_expnum_dV_G_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_G_S+(d_q_Aexp_dV_G_S-d_q_sh_term_dV_G_S)*q_temp2);
d_q_expnum_dTemp_Tnode_GND = ((q_Aexp-q_sh_term)*d_q_temp2_dTemp_Tnode_GND+(d_q_Aexp_dTemp_Tnode_GND-d_q_sh_term_dTemp_Tnode_GND)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);

d_q_d1_expnum_dV_S_B = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_S_B+(((q_temp3*d_q_expnum_dV_S_B+d_q_temp3_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B)-(q_d1_ln*d_q_sh_term_dV_S_B+d_q_d1_ln_dV_S_B*q_sh_term))*q_temp2);
d_q_d1_expnum_dTemp_Tnode_GND = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+(((q_temp3*d_q_expnum_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND)-(q_d1_ln*d_q_sh_term_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_D_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_D_S+(((q_temp3*d_q_expnum_dV_D_S+d_q_temp3_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S)-(q_d1_ln*d_q_sh_term_dV_D_S+d_q_d1_ln_dV_D_S*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_G_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_G_S+(((q_temp3*d_q_expnum_dV_G_S+d_q_temp3_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S)-(q_d1_ln*d_q_sh_term_dV_G_S+d_q_d1_ln_dV_G_S*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);

d_q_d2_expnum_dV_S_B = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_S_B+((((q_d2_qcoth*d_q_expnum_dV_S_B+d_q_d2_qcoth_dV_S_B*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_S_B+2.0*d_q_temp3_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_S_B+(d_q_d2_ln_dV_S_B+(q_d1_ln*d_q_d1_ln_dV_S_B+d_q_d1_ln_dV_S_B*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dTemp_Tnode_GND = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+((((q_d2_qcoth*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qcoth_dTemp_Tnode_GND*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_temp3_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dTemp_Tnode_GND+(d_q_d2_ln_dTemp_Tnode_GND+(q_d1_ln*d_q_d1_ln_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_D_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_D_S+((((q_d2_qcoth*d_q_expnum_dV_D_S+d_q_d2_qcoth_dV_D_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_D_S+2.0*d_q_temp3_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_D_S+(d_q_d2_ln_dV_D_S+(q_d1_ln*d_q_d1_ln_dV_D_S+d_q_d1_ln_dV_D_S*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_G_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_G_S+((((q_d2_qcoth*d_q_expnum_dV_G_S+d_q_d2_qcoth_dV_G_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_G_S+2.0*d_q_temp3_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_G_S+(d_q_d2_ln_dV_G_S+(q_d1_ln*d_q_d1_ln_dV_G_S+d_q_d1_ln_dV_G_S*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);

d_q_lnexpnum_dV_S_B = (deriv_log_0_d0*(d_q_expnum_dV_S_B));
d_q_lnexpnum_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_expnum_dTemp_Tnode_GND));
d_q_lnexpnum_dV_D_S = (deriv_log_0_d0*(d_q_expnum_dV_D_S));
d_q_lnexpnum_dV_G_S = (deriv_log_0_d0*(d_q_expnum_dV_G_S));
q_lnexpnum = value_log_0;
}

d_q_temp1_dV_S_B = (-d_q_expnum_dV_S_B/q_expnum/q_expnum);
d_q_temp1_dTemp_Tnode_GND = (-d_q_expnum_dTemp_Tnode_GND/q_expnum/q_expnum);
d_q_temp1_dV_D_S = (-d_q_expnum_dV_D_S/q_expnum/q_expnum);
d_q_temp1_dV_G_S = (-d_q_expnum_dV_G_S/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);

d_q_d1_lnexpnum_dV_S_B = (q_d1_expnum*d_q_temp1_dV_S_B+d_q_d1_expnum_dV_S_B*q_temp1);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (q_d1_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d1_expnum_dTemp_Tnode_GND*q_temp1);
d_q_d1_lnexpnum_dV_D_S = (q_d1_expnum*d_q_temp1_dV_D_S+d_q_d1_expnum_dV_D_S*q_temp1);
d_q_d1_lnexpnum_dV_G_S = (q_d1_expnum*d_q_temp1_dV_G_S+d_q_d1_expnum_dV_G_S*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((q_d2_expnum*d_q_temp1_dV_S_B+d_q_d2_expnum_dV_S_B*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_S_B+d_q_d1_lnexpnum_dV_S_B*q_d1_lnexpnum));
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((q_d2_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d2_expnum_dTemp_Tnode_GND*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dTemp_Tnode_GND+d_q_d1_lnexpnum_dTemp_Tnode_GND*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_D_S = ((q_d2_expnum*d_q_temp1_dV_D_S+d_q_d2_expnum_dV_D_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_D_S+d_q_d1_lnexpnum_dV_D_S*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_G_S = ((q_d2_expnum*d_q_temp1_dV_G_S+d_q_d2_expnum_dV_G_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_G_S+d_q_d1_lnexpnum_dV_G_S*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));

d_q_lnexpnum_dV_S_B = (d_q_k1q1_dV_S_B+(deriv_log_0_d0*((-d_q_k1q1_dV_S_B))));
d_q_lnexpnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(deriv_log_0_d0*((-d_q_k1q1_dTemp_Tnode_GND))));
d_q_lnexpnum_dV_D_S = (d_q_k1q1_dV_D_S+(deriv_log_0_d0*((-d_q_k1q1_dV_D_S))));
d_q_lnexpnum_dV_G_S = (d_q_k1q1_dV_G_S+(deriv_log_0_d0*((-d_q_k1q1_dV_G_S))));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}

d_q_temp1_dV_S_B = (-d_q1d_dV_S_B/q1d/q1d);
d_q_temp1_dV_D_S = (-d_q1d_dV_D_S/q1d/q1d);
d_q_temp1_dV_G_S = (-d_q1d_dV_G_S/q1d/q1d);
d_q_temp1_dTemp_Tnode_GND = (-d_q1d_dTemp_Tnode_GND/q1d/q1d);
q_temp1 = (1.0/q1d);

d_q_d1_lnexpnum_dV_S_B = (d_k1_dV_S_B+d_q_temp1_dV_S_B);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_temp1_dTemp_Tnode_GND);
d_q_d1_lnexpnum_dV_D_S = (d_k1_dV_D_S+d_q_temp1_dV_D_S);
d_q_d1_lnexpnum_dV_G_S = (d_k1_dV_G_S+d_q_temp1_dV_G_S);
q_d1_lnexpnum = (k1+q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((-q_temp1)*d_q_temp1_dV_S_B+(-d_q_temp1_dV_S_B)*q_temp1);
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((-q_temp1)*d_q_temp1_dTemp_Tnode_GND+(-d_q_temp1_dTemp_Tnode_GND)*q_temp1);
d_q_d2_lnexpnum_dV_D_S = ((-q_temp1)*d_q_temp1_dV_D_S+(-d_q_temp1_dV_D_S)*q_temp1);
d_q_d2_lnexpnum_dV_G_S = ((-q_temp1)*d_q_temp1_dV_G_S+(-d_q_temp1_dV_G_S)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}

d_q_q2_int_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1d_dV_S_B)+2.0*d_q_lnexpnum_dV_S_B)-d_q_ln_term_dV_S_B);
d_q_q2_int_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1d_dTemp_Tnode_GND)+2.0*d_q_lnexpnum_dTemp_Tnode_GND)-d_q_ln_term_dTemp_Tnode_GND);
d_q_q2_int_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1d_dV_D_S)+2.0*d_q_lnexpnum_dV_D_S)-d_q_ln_term_dV_D_S);
d_q_q2_int_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1d_dV_G_S)+2.0*d_q_lnexpnum_dV_G_S)-d_q_ln_term_dV_G_S);
q_q2_int = ((((xg2x-xg1x)+q1d)+(2.0*q_lnexpnum))-q_ln_term);

d_q_d1_q2_dV_S_B = (2.0*d_q_d1_lnexpnum_dV_S_B-d_q_d1_ln_dV_S_B);
d_q_d1_q2_dTemp_Tnode_GND = (2.0*d_q_d1_lnexpnum_dTemp_Tnode_GND-d_q_d1_ln_dTemp_Tnode_GND);
d_q_d1_q2_dV_D_S = (2.0*d_q_d1_lnexpnum_dV_D_S-d_q_d1_ln_dV_D_S);
d_q_d1_q2_dV_G_S = (2.0*d_q_d1_lnexpnum_dV_G_S-d_q_d1_ln_dV_G_S);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);

d_q_d2_q2_dV_S_B = (2.0*d_q_d2_lnexpnum_dV_S_B-d_q_d2_ln_dV_S_B);
d_q_d2_q2_dTemp_Tnode_GND = (2.0*d_q_d2_lnexpnum_dTemp_Tnode_GND-d_q_d2_ln_dTemp_Tnode_GND);
d_q_d2_q2_dV_D_S = (2.0*d_q_d2_lnexpnum_dV_D_S-d_q_d2_ln_dV_D_S);
d_q_d2_q2_dV_G_S = (2.0*d_q_d2_lnexpnum_dV_G_S-d_q_d2_ln_dV_G_S);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+(k2*d_q_q2_int_dV_S_B+d_k2_dV_S_B*q_q2_int));
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(k2*d_q_q2_int_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_q2_int));
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+(k2*d_q_q2_int_dV_D_S+d_k2_dV_D_S*q_q2_int));
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+(k2*d_q_q2_int_dV_G_S+d_k2_dV_G_S*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));

d_q_d1_qi_dV_S_B = (d_k1_dV_S_B+(k2*d_q_d1_q2_dV_S_B+d_k2_dV_S_B*q_d1_q2));
d_q_d1_qi_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+(k2*d_q_d1_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d1_q2));
d_q_d1_qi_dV_D_S = (d_k1_dV_D_S+(k2*d_q_d1_q2_dV_D_S+d_k2_dV_D_S*q_d1_q2));
d_q_d1_qi_dV_G_S = (d_k1_dV_G_S+(k2*d_q_d1_q2_dV_G_S+d_k2_dV_G_S*q_d1_q2));
q_d1_qi = (k1+(k2*q_d1_q2));

d_q_d2_qi_dV_S_B = (k2*d_q_d2_q2_dV_S_B+d_k2_dV_S_B*q_d2_q2);
d_q_d2_qi_dTemp_Tnode_GND = (k2*d_q_d2_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d2_q2);
d_q_d2_qi_dV_D_S = (k2*d_q_d2_q2_dV_D_S+d_k2_dV_D_S*q_d2_q2);
d_q_d2_qi_dV_G_S = (k2*d_q_d2_q2_dV_G_S+d_k2_dV_G_S*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);

d_q_zero_dV_S_B = ((q_qi_int*d_q_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B);
d_q_zero_dTemp_Tnode_GND = ((q_qi_int*d_q_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND);
d_q_zero_dV_D_S = ((q_qi_int*d_q_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S);
d_q_zero_dV_G_S = ((q_qi_int*d_q_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{

d_q_eps2_dV_G_S = d_q_eps2_dV_D_S = d_q_eps2_dTemp_Tnode_GND = d_q_eps2_dV_S_B =  0.0;
q_eps2 = 0.0;
}
else
{

d_q_d1_zero_dV_S_B = (((q_d1_qi*d_q_expnum_dV_S_B+d_q_d1_qi_dV_S_B*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((q_d1_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d1_qi_dTemp_Tnode_GND*q_expnum)+(q_qi_int*d_q_d1_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((q_d1_qi*d_q_expnum_dV_D_S+d_q_d1_qi_dV_D_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S);
d_q_d1_zero_dV_G_S = (((q_d1_qi*d_q_expnum_dV_G_S+d_q_d1_qi_dV_G_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);

d_q_d2_zero_dV_S_B = ((((q_d2_qi*d_q_expnum_dV_S_B+d_q_d2_qi_dV_S_B*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_S_B+2.0*d_q_d1_qi_dV_S_B*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d2_expnum))-d_q_Aexp_dV_S_B);
d_q_d2_zero_dTemp_Tnode_GND = ((((q_d2_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qi_dTemp_Tnode_GND*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_d1_qi_dTemp_Tnode_GND*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d2_expnum))-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_zero_dV_D_S = ((((q_d2_qi*d_q_expnum_dV_D_S+d_q_d2_qi_dV_D_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_D_S+2.0*d_q_d1_qi_dV_D_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d2_expnum))-d_q_Aexp_dV_D_S);
d_q_d2_zero_dV_G_S = ((((q_d2_qi*d_q_expnum_dV_G_S+d_q_d2_qi_dV_G_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_G_S+2.0*d_q_d1_qi_dV_G_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d2_expnum))-d_q_Aexp_dV_G_S);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);

d_q_eps1_dV_S_B = ((q_d1_zero*(-d_q_zero_dV_S_B)-(-q_zero)*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero);
d_q_eps1_dTemp_Tnode_GND = ((q_d1_zero*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_D_S = ((q_d1_zero*(-d_q_zero_dV_D_S)-(-q_zero)*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_G_S = ((q_d1_zero*(-d_q_zero_dV_G_S)-(-q_zero)*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);

d_q_eps2_dV_S_B = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_S_B)-(-q_zero)*(d_q_d1_zero_dV_S_B+((0.5*q_eps1)*d_q_d2_zero_dV_S_B+0.5*d_q_eps1_dV_S_B*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dTemp_Tnode_GND = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*(d_q_d1_zero_dTemp_Tnode_GND+((0.5*q_eps1)*d_q_d2_zero_dTemp_Tnode_GND+0.5*d_q_eps1_dTemp_Tnode_GND*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_D_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_D_S)-(-q_zero)*(d_q_d1_zero_dV_D_S+((0.5*q_eps1)*d_q_d2_zero_dV_D_S+0.5*d_q_eps1_dV_D_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_G_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_G_S)-(-q_zero)*(d_q_d1_zero_dV_G_S+((0.5*q_eps1)*d_q_d2_zero_dV_G_S+0.5*d_q_eps1_dV_G_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}

d_q1d_dV_S_B = (d_q1d_dV_S_B+d_q_eps2_dV_S_B);
d_q1d_dV_D_S = (d_q1d_dV_D_S+d_q_eps2_dV_D_S);
d_q1d_dV_G_S = (d_q1d_dV_G_S+d_q_eps2_dV_G_S);
d_q1d_dTemp_Tnode_GND = (d_q1d_dTemp_Tnode_GND+d_q_eps2_dTemp_Tnode_GND);
q1d = (q1d+q_eps2);

d_q_k1q1_dV_S_B = (k1*d_q1d_dV_S_B+d_k1_dV_S_B*q1d);
d_q_k1q1_dTemp_Tnode_GND = (k1*d_q1d_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1d);
d_q_k1q1_dV_D_S = (k1*d_q1d_dV_D_S+d_k1_dV_D_S*q1d);
d_q_k1q1_dV_G_S = (k1*d_q1d_dV_G_S+d_k1_dV_G_S*q1d);
q_k1q1 = (k1*q1d);
if ((((xg1x-q1d)-xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-xdeff));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*(((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*(((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*(((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*(((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*0.3333333333333+0.5*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*0.3333333333333+0.5*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*0.3333333333333+0.5*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*0.3333333333333+0.5*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))))));
}

d_q_Aexp_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_q_Aexp_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_q_Aexp_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_q_Aexp_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
q_Aexp = (A0*q_temp1);

d_q_qsq_dV_S_B = ((q_k1q1*d_q_k1q1_dV_S_B+d_q_k1q1_dV_S_B*q_k1q1)-d_q_Aexp_dV_S_B);
d_q_qsq_dTemp_Tnode_GND = ((q_k1q1*d_q_k1q1_dTemp_Tnode_GND+d_q_k1q1_dTemp_Tnode_GND*q_k1q1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_qsq_dV_D_S = ((q_k1q1*d_q_k1q1_dV_D_S+d_q_k1q1_dV_D_S*q_k1q1)-d_q_Aexp_dV_D_S);
d_q_qsq_dV_G_S = ((q_k1q1*d_q_k1q1_dV_G_S+d_q_k1q1_dV_G_S*q_k1q1)-d_q_Aexp_dV_G_S);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);

d_q_d1_qsq_dV_S_B = (((2.0*k1)*d_q_k1q1_dV_S_B+2.0*d_k1_dV_S_B*q_k1q1)+d_q_Aexp_dV_S_B);
d_q_d1_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_q_k1q1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*q_k1q1)+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_qsq_dV_D_S = (((2.0*k1)*d_q_k1q1_dV_D_S+2.0*d_k1_dV_D_S*q_k1q1)+d_q_Aexp_dV_D_S);
d_q_d1_qsq_dV_G_S = (((2.0*k1)*d_q_k1q1_dV_G_S+2.0*d_k1_dV_G_S*q_k1q1)+d_q_Aexp_dV_G_S);
q_d1_qsq = (((2.0*k1)*q_k1q1)+q_Aexp);

d_q_d2_qsq_dV_S_B = (((2.0*k1)*d_k1_dV_S_B+2.0*d_k1_dV_S_B*k1)-d_q_Aexp_dV_S_B);
d_q_d2_qsq_dTemp_Tnode_GND = (((2.0*k1)*d_k1_dTemp_Tnode_GND+2.0*d_k1_dTemp_Tnode_GND*k1)-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_qsq_dV_D_S = (((2.0*k1)*d_k1_dV_D_S+2.0*d_k1_dV_D_S*k1)-d_q_Aexp_dV_D_S);
d_q_d2_qsq_dV_G_S = (((2.0*k1)*d_k1_dV_G_S+2.0*d_k1_dV_G_S*k1)-d_q_Aexp_dV_G_S);
q_d2_qsq = (((2.0*k1)*k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_q_qsq_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));

d_q_temp1_dV_S_B = ((q_qsq*0.25*d_q_d1_qsq_dV_S_B-(0.25*q_d1_qsq)*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_temp1_dTemp_Tnode_GND = ((q_qsq*0.25*d_q_d1_qsq_dTemp_Tnode_GND-(0.25*q_d1_qsq)*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_temp1_dV_D_S = ((q_qsq*0.25*d_q_d1_qsq_dV_D_S-(0.25*q_d1_qsq)*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_temp1_dV_G_S = ((q_qsq*0.25*d_q_d1_qsq_dV_G_S-(0.25*q_d1_qsq)*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);

d_q_d1_qcoth_dV_S_B = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_S_B+(d_q_qsq_dV_S_B+(q_qcoth*(-d_q_qcoth_dV_S_B)+d_q_qcoth_dV_S_B*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_qsq_dTemp_Tnode_GND+(q_qcoth*(-d_q_qcoth_dTemp_Tnode_GND)+d_q_qcoth_dTemp_Tnode_GND*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_D_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_D_S+(d_q_qsq_dV_D_S+(q_qcoth*(-d_q_qcoth_dV_D_S)+d_q_qcoth_dV_D_S*(2.0-q_qcoth)))*q_temp1);
d_q_d1_qcoth_dV_G_S = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dV_G_S+(d_q_qsq_dV_G_S+(q_qcoth*(-d_q_qcoth_dV_G_S)+d_q_qcoth_dV_G_S*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);

d_q_d2_qcoth_dV_S_B = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_S_B+(d_q_d1_qsq_dV_S_B-((2.0*q_d1_qcoth)*d_q_qcoth_dV_S_B+2.0*d_q_d1_qcoth_dV_S_B*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_S_B+d_q_d1_qcoth_dV_S_B*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_S_B)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dTemp_Tnode_GND = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dTemp_Tnode_GND+(d_q_d1_qsq_dTemp_Tnode_GND-((2.0*q_d1_qcoth)*d_q_qcoth_dTemp_Tnode_GND+2.0*d_q_d1_qcoth_dTemp_Tnode_GND*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dTemp_Tnode_GND)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_D_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_D_S+(d_q_d1_qsq_dV_D_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_D_S+2.0*d_q_d1_qcoth_dV_D_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_D_S+d_q_d1_qcoth_dV_D_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_D_S)/q_d1_qsq/q_d1_qsq));
d_q_d2_qcoth_dV_G_S = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dV_G_S+(d_q_d1_qsq_dV_G_S-((2.0*q_d1_qcoth)*d_q_qcoth_dV_G_S+2.0*d_q_d1_qcoth_dV_G_S*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dV_G_S+d_q_d1_qcoth_dV_G_S*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dV_G_S)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));

d_q_temp2_dV_S_B = (-0.5*d_q_qcoth_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = (-0.5*d_q_qcoth_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = (-0.5*d_q_qcoth_dV_D_S);
d_q_temp2_dV_G_S = (-0.5*d_q_qcoth_dV_G_S);
q_temp2 = (1.0-(0.5*q_qcoth));

d_q_d1_ln_dV_S_B = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_S_B+((q_qsq*d_q_d1_qsq_dV_S_B-q_d1_qsq*d_q_qsq_dV_S_B)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dTemp_Tnode_GND = ((q_d1_qsq/q_qsq)*d_q_temp2_dTemp_Tnode_GND+((q_qsq*d_q_d1_qsq_dTemp_Tnode_GND-q_d1_qsq*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_D_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_D_S+((q_qsq*d_q_d1_qsq_dV_D_S-q_d1_qsq*d_q_qsq_dV_D_S)/q_qsq/q_qsq)*q_temp2);
d_q_d1_ln_dV_G_S = ((q_d1_qsq/q_qsq)*d_q_temp2_dV_G_S+((q_qsq*d_q_d1_qsq_dV_G_S-q_d1_qsq*d_q_qsq_dV_G_S)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);

d_q_d2_ln_dV_S_B = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_S_B+0.5*d_q_d1_qcoth_dV_S_B)+d_q_d1_qsq_dV_S_B*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_S_B)/q_qsq/q_qsq);
d_q_d2_ln_dTemp_Tnode_GND = ((q_qsq*((q_d2_qsq*d_q_temp2_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dTemp_Tnode_GND+0.5*d_q_d1_qcoth_dTemp_Tnode_GND)+d_q_d1_qsq_dTemp_Tnode_GND*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dTemp_Tnode_GND)/q_qsq/q_qsq);
d_q_d2_ln_dV_D_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_D_S+0.5*d_q_d1_qcoth_dV_D_S)+d_q_d1_qsq_dV_D_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_D_S)/q_qsq/q_qsq);
d_q_d2_ln_dV_G_S = ((q_qsq*((q_d2_qsq*d_q_temp2_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dV_G_S+0.5*d_q_d1_qcoth_dV_G_S)+d_q_d1_qsq_dV_G_S*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dV_G_S)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{

d_q_temp3_dV_S_B = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_S_B*0.025)+d_q_qsq_dV_S_B*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_S_B*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dTemp_Tnode_GND*0.025)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dTemp_Tnode_GND*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_D_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_D_S*0.025)+d_q_qsq_dV_D_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_D_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
d_q_temp3_dV_G_S = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dV_G_S*0.025)+d_q_qsq_dV_G_S*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dV_G_S*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));

d_q_qcoth_dV_S_B = (q_qsq*d_q_temp3_dV_S_B+d_q_qsq_dV_S_B*q_temp3);
d_q_qcoth_dTemp_Tnode_GND = (q_qsq*d_q_temp3_dTemp_Tnode_GND+d_q_qsq_dTemp_Tnode_GND*q_temp3);
d_q_qcoth_dV_D_S = (q_qsq*d_q_temp3_dV_D_S+d_q_qsq_dV_D_S*q_temp3);
d_q_qcoth_dV_G_S = (q_qsq*d_q_temp3_dV_G_S+d_q_qsq_dV_G_S*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));

d_q_temp1_dV_S_B = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_S_B*0.0333333333333)+d_q_qsq_dV_S_B*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_S_B*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dTemp_Tnode_GND*0.0333333333333)+d_q_qsq_dTemp_Tnode_GND*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dTemp_Tnode_GND*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_D_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_D_S*0.0333333333333)+d_q_qsq_dV_D_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_D_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
d_q_temp1_dV_G_S = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dV_G_S*0.0333333333333)+d_q_qsq_dV_G_S*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dV_G_S*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));

d_q_d1_qcoth_dV_S_B = (q_d1_qsq*d_q_temp1_dV_S_B+d_q_d1_qsq_dV_S_B*q_temp1);
d_q_d1_qcoth_dTemp_Tnode_GND = (q_d1_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_temp1);
d_q_d1_qcoth_dV_D_S = (q_d1_qsq*d_q_temp1_dV_D_S+d_q_d1_qsq_dV_D_S*q_temp1);
d_q_d1_qcoth_dV_G_S = (q_d1_qsq*d_q_temp1_dV_G_S+d_q_d1_qsq_dV_G_S*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);

d_q_temp2_dV_S_B = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_S_B*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dTemp_Tnode_GND = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_D_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_D_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
d_q_temp2_dV_G_S = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dV_G_S*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));

d_q_d2_qcoth_dV_S_B = ((q_d2_qsq*d_q_temp1_dV_S_B+d_q_d2_qsq_dV_S_B*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_S_B+(q_d1_qsq*d_q_d1_qsq_dV_S_B+d_q_d1_qsq_dV_S_B*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dTemp_Tnode_GND = ((q_d2_qsq*d_q_temp1_dTemp_Tnode_GND+d_q_d2_qsq_dTemp_Tnode_GND*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dTemp_Tnode_GND+(q_d1_qsq*d_q_d1_qsq_dTemp_Tnode_GND+d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_D_S = ((q_d2_qsq*d_q_temp1_dV_D_S+d_q_d2_qsq_dV_D_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_D_S+(q_d1_qsq*d_q_d1_qsq_dV_D_S+d_q_d1_qsq_dV_D_S*q_d1_qsq)*q_temp2));
d_q_d2_qcoth_dV_G_S = ((q_d2_qsq*d_q_temp1_dV_G_S+d_q_d2_qsq_dV_G_S*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dV_G_S+(q_d1_qsq*d_q_d1_qsq_dV_G_S+d_q_d1_qsq_dV_G_S*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));

d_q_d1_ln_dV_S_B = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d1_qsq_dV_S_B*q_temp3);
d_q_d1_ln_dTemp_Tnode_GND = (((-0.5)*q_d1_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d1_qsq_dTemp_Tnode_GND*q_temp3);
d_q_d1_ln_dV_D_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d1_qsq_dV_D_S*q_temp3);
d_q_d1_ln_dV_G_S = (((-0.5)*q_d1_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d1_qsq_dV_G_S*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);

d_q_d2_ln_dV_S_B = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_S_B+(-0.5)*d_q_d2_qsq_dV_S_B*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_S_B)+d_q_qsq_dV_S_B*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_S_B+(0.25*0.0055555555556)*d_q_d1_qsq_dV_S_B*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dTemp_Tnode_GND = ((((-0.5)*q_d2_qsq)*d_q_temp3_dTemp_Tnode_GND+(-0.5)*d_q_d2_qsq_dTemp_Tnode_GND*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dTemp_Tnode_GND)+d_q_qsq_dTemp_Tnode_GND*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dTemp_Tnode_GND+(0.25*0.0055555555556)*d_q_d1_qsq_dTemp_Tnode_GND*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_D_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_D_S+(-0.5)*d_q_d2_qsq_dV_D_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_D_S)+d_q_qsq_dV_D_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_D_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_D_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
d_q_d2_ln_dV_G_S = ((((-0.5)*q_d2_qsq)*d_q_temp3_dV_G_S+(-0.5)*d_q_d2_qsq_dV_G_S*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dV_G_S)+d_q_qsq_dV_G_S*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dV_G_S+(0.25*0.0055555555556)*d_q_d1_qsq_dV_G_S*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{

d_q_temp2_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_S_B-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dTemp_Tnode_GND-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_D_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp2_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dV_G_S-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));

d_q_sh_term_dV_S_B = (q_temp2*d_q_invexpq_dV_S_B+d_q_temp2_dV_S_B*q_invexpq);
d_q_sh_term_dTemp_Tnode_GND = (q_temp2*d_q_invexpq_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_invexpq);
d_q_sh_term_dV_D_S = (q_temp2*d_q_invexpq_dV_D_S+d_q_temp2_dV_D_S*q_invexpq);
d_q_sh_term_dV_G_S = (q_temp2*d_q_invexpq_dV_G_S+d_q_temp2_dV_G_S*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);

d_q_ln_term_dV_S_B = ((deriv_log_0_d0*(d_q_temp2_dV_S_B))-d_q_rac_qsq_dV_S_B);
d_q_ln_term_dTemp_Tnode_GND = ((deriv_log_0_d0*(d_q_temp2_dTemp_Tnode_GND))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_ln_term_dV_D_S = ((deriv_log_0_d0*(d_q_temp2_dV_D_S))-d_q_rac_qsq_dV_D_S);
d_q_ln_term_dV_G_S = ((deriv_log_0_d0*(d_q_temp2_dV_G_S))-d_q_rac_qsq_dV_G_S);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_sh_term_dV_S_B = (((q_temp2*q_temp2)*(-d_q_qsq_dV_S_B)-(-q_qsq)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dTemp_Tnode_GND = (((q_temp2*q_temp2)*(-d_q_qsq_dTemp_Tnode_GND)-(-q_qsq)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_D_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_D_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
d_q_sh_term_dV_G_S = (((q_temp2*q_temp2)*(-d_q_qsq_dV_G_S)-(-q_qsq)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
else
{

d_q_sh_term_dV_S_B = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_S_B)+0.05*d_q_qsq_dV_S_B*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_S_B*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dTemp_Tnode_GND = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dTemp_Tnode_GND)+0.05*d_q_qsq_dTemp_Tnode_GND*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_D_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_D_S)+0.05*d_q_qsq_dV_D_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_D_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
d_q_sh_term_dV_G_S = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dV_G_S)+0.05*d_q_qsq_dV_G_S*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dV_G_S*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);

d_q_ln_term_dV_S_B = (deriv_log_0_d0*(d_q_sh_term_dV_S_B));
d_q_ln_term_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_sh_term_dTemp_Tnode_GND));
d_q_ln_term_dV_D_S = (deriv_log_0_d0*(d_q_sh_term_dV_D_S));
d_q_ln_term_dV_G_S = (deriv_log_0_d0*(d_q_sh_term_dV_G_S));
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{

d_q_expnum_dV_S_B = (d_q_k1q1_dV_S_B+d_q_qcoth_dV_S_B);
d_q_expnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_expnum_dV_D_S = (d_q_k1q1_dV_D_S+d_q_qcoth_dV_D_S);
d_q_expnum_dV_G_S = (d_q_k1q1_dV_G_S+d_q_qcoth_dV_G_S);
q_expnum = (q_k1q1+q_qcoth);

d_q_d1_expnum_dV_S_B = (d_k1_dV_S_B+d_q_d1_qcoth_dV_S_B);
d_q_d1_expnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_d1_qcoth_dTemp_Tnode_GND);
d_q_d1_expnum_dV_D_S = (d_k1_dV_D_S+d_q_d1_qcoth_dV_D_S);
d_q_d1_expnum_dV_G_S = (d_k1_dV_G_S+d_q_d1_qcoth_dV_G_S);
q_d1_expnum = (k1+q_d1_qcoth);

d_q_d2_expnum_dV_S_B = d_q_d2_qcoth_dV_S_B;
d_q_d2_expnum_dTemp_Tnode_GND = d_q_d2_qcoth_dTemp_Tnode_GND;
d_q_d2_expnum_dV_D_S = d_q_d2_qcoth_dV_D_S;
d_q_d2_expnum_dV_G_S = d_q_d2_qcoth_dV_G_S;
q_d2_expnum = q_d2_qcoth;
}
else
{

d_q_temp2_dV_S_B = (-(d_q_k1q1_dV_S_B-d_q_qcoth_dV_S_B)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dTemp_Tnode_GND = (-(d_q_k1q1_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_D_S = (-(d_q_k1q1_dV_D_S-d_q_qcoth_dV_D_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
d_q_temp2_dV_G_S = (-(d_q_k1q1_dV_G_S-d_q_qcoth_dV_G_S)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));

d_q_temp3_dV_S_B = (d_q_d1_qcoth_dV_S_B-d_k1_dV_S_B);
d_q_temp3_dTemp_Tnode_GND = (d_q_d1_qcoth_dTemp_Tnode_GND-d_k1_dTemp_Tnode_GND);
d_q_temp3_dV_D_S = (d_q_d1_qcoth_dV_D_S-d_k1_dV_D_S);
d_q_temp3_dV_G_S = (d_q_d1_qcoth_dV_G_S-d_k1_dV_G_S);
q_temp3 = (q_d1_qcoth-k1);

d_q_expnum_dV_S_B = ((q_Aexp-q_sh_term)*d_q_temp2_dV_S_B+(d_q_Aexp_dV_S_B-d_q_sh_term_dV_S_B)*q_temp2);
d_q_expnum_dV_D_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_D_S+(d_q_Aexp_dV_D_S-d_q_sh_term_dV_D_S)*q_temp2);
d_q_expnum_dV_G_S = ((q_Aexp-q_sh_term)*d_q_temp2_dV_G_S+(d_q_Aexp_dV_G_S-d_q_sh_term_dV_G_S)*q_temp2);
d_q_expnum_dTemp_Tnode_GND = ((q_Aexp-q_sh_term)*d_q_temp2_dTemp_Tnode_GND+(d_q_Aexp_dTemp_Tnode_GND-d_q_sh_term_dTemp_Tnode_GND)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);

d_q_d1_expnum_dV_S_B = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_S_B+(((q_temp3*d_q_expnum_dV_S_B+d_q_temp3_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B)-(q_d1_ln*d_q_sh_term_dV_S_B+d_q_d1_ln_dV_S_B*q_sh_term))*q_temp2);
d_q_d1_expnum_dTemp_Tnode_GND = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+(((q_temp3*d_q_expnum_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND)-(q_d1_ln*d_q_sh_term_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_D_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_D_S+(((q_temp3*d_q_expnum_dV_D_S+d_q_temp3_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S)-(q_d1_ln*d_q_sh_term_dV_D_S+d_q_d1_ln_dV_D_S*q_sh_term))*q_temp2);
d_q_d1_expnum_dV_G_S = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dV_G_S+(((q_temp3*d_q_expnum_dV_G_S+d_q_temp3_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S)-(q_d1_ln*d_q_sh_term_dV_G_S+d_q_d1_ln_dV_G_S*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);

d_q_d2_expnum_dV_S_B = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_S_B+((((q_d2_qcoth*d_q_expnum_dV_S_B+d_q_d2_qcoth_dV_S_B*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_S_B+2.0*d_q_temp3_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_S_B+(d_q_d2_ln_dV_S_B+(q_d1_ln*d_q_d1_ln_dV_S_B+d_q_d1_ln_dV_S_B*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dTemp_Tnode_GND = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dTemp_Tnode_GND+((((q_d2_qcoth*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qcoth_dTemp_Tnode_GND*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_temp3_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dTemp_Tnode_GND+(d_q_d2_ln_dTemp_Tnode_GND+(q_d1_ln*d_q_d1_ln_dTemp_Tnode_GND+d_q_d1_ln_dTemp_Tnode_GND*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_D_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_D_S+((((q_d2_qcoth*d_q_expnum_dV_D_S+d_q_d2_qcoth_dV_D_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_D_S+2.0*d_q_temp3_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_D_S+(d_q_d2_ln_dV_D_S+(q_d1_ln*d_q_d1_ln_dV_D_S+d_q_d1_ln_dV_D_S*q_d1_ln))*q_sh_term))*q_temp2);
d_q_d2_expnum_dV_G_S = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dV_G_S+((((q_d2_qcoth*d_q_expnum_dV_G_S+d_q_d2_qcoth_dV_G_S*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dV_G_S+2.0*d_q_temp3_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dV_G_S+(d_q_d2_ln_dV_G_S+(q_d1_ln*d_q_d1_ln_dV_G_S+d_q_d1_ln_dV_G_S*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);

d_q_lnexpnum_dV_S_B = (deriv_log_0_d0*(d_q_expnum_dV_S_B));
d_q_lnexpnum_dTemp_Tnode_GND = (deriv_log_0_d0*(d_q_expnum_dTemp_Tnode_GND));
d_q_lnexpnum_dV_D_S = (deriv_log_0_d0*(d_q_expnum_dV_D_S));
d_q_lnexpnum_dV_G_S = (deriv_log_0_d0*(d_q_expnum_dV_G_S));
q_lnexpnum = value_log_0;
}

d_q_temp1_dV_S_B = (-d_q_expnum_dV_S_B/q_expnum/q_expnum);
d_q_temp1_dTemp_Tnode_GND = (-d_q_expnum_dTemp_Tnode_GND/q_expnum/q_expnum);
d_q_temp1_dV_D_S = (-d_q_expnum_dV_D_S/q_expnum/q_expnum);
d_q_temp1_dV_G_S = (-d_q_expnum_dV_G_S/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);

d_q_d1_lnexpnum_dV_S_B = (q_d1_expnum*d_q_temp1_dV_S_B+d_q_d1_expnum_dV_S_B*q_temp1);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (q_d1_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d1_expnum_dTemp_Tnode_GND*q_temp1);
d_q_d1_lnexpnum_dV_D_S = (q_d1_expnum*d_q_temp1_dV_D_S+d_q_d1_expnum_dV_D_S*q_temp1);
d_q_d1_lnexpnum_dV_G_S = (q_d1_expnum*d_q_temp1_dV_G_S+d_q_d1_expnum_dV_G_S*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((q_d2_expnum*d_q_temp1_dV_S_B+d_q_d2_expnum_dV_S_B*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_S_B+d_q_d1_lnexpnum_dV_S_B*q_d1_lnexpnum));
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((q_d2_expnum*d_q_temp1_dTemp_Tnode_GND+d_q_d2_expnum_dTemp_Tnode_GND*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dTemp_Tnode_GND+d_q_d1_lnexpnum_dTemp_Tnode_GND*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_D_S = ((q_d2_expnum*d_q_temp1_dV_D_S+d_q_d2_expnum_dV_D_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_D_S+d_q_d1_lnexpnum_dV_D_S*q_d1_lnexpnum));
d_q_d2_lnexpnum_dV_G_S = ((q_d2_expnum*d_q_temp1_dV_G_S+d_q_d2_expnum_dV_G_S*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dV_G_S+d_q_d1_lnexpnum_dV_G_S*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));

d_q_lnexpnum_dV_S_B = (d_q_k1q1_dV_S_B+(deriv_log_0_d0*((-d_q_k1q1_dV_S_B))));
d_q_lnexpnum_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(deriv_log_0_d0*((-d_q_k1q1_dTemp_Tnode_GND))));
d_q_lnexpnum_dV_D_S = (d_q_k1q1_dV_D_S+(deriv_log_0_d0*((-d_q_k1q1_dV_D_S))));
d_q_lnexpnum_dV_G_S = (d_q_k1q1_dV_G_S+(deriv_log_0_d0*((-d_q_k1q1_dV_G_S))));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}

d_q_temp1_dV_S_B = (-d_q1d_dV_S_B/q1d/q1d);
d_q_temp1_dV_D_S = (-d_q1d_dV_D_S/q1d/q1d);
d_q_temp1_dV_G_S = (-d_q1d_dV_G_S/q1d/q1d);
d_q_temp1_dTemp_Tnode_GND = (-d_q1d_dTemp_Tnode_GND/q1d/q1d);
q_temp1 = (1.0/q1d);

d_q_d1_lnexpnum_dV_S_B = (d_k1_dV_S_B+d_q_temp1_dV_S_B);
d_q_d1_lnexpnum_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+d_q_temp1_dTemp_Tnode_GND);
d_q_d1_lnexpnum_dV_D_S = (d_k1_dV_D_S+d_q_temp1_dV_D_S);
d_q_d1_lnexpnum_dV_G_S = (d_k1_dV_G_S+d_q_temp1_dV_G_S);
q_d1_lnexpnum = (k1+q_temp1);

d_q_d2_lnexpnum_dV_S_B = ((-q_temp1)*d_q_temp1_dV_S_B+(-d_q_temp1_dV_S_B)*q_temp1);
d_q_d2_lnexpnum_dTemp_Tnode_GND = ((-q_temp1)*d_q_temp1_dTemp_Tnode_GND+(-d_q_temp1_dTemp_Tnode_GND)*q_temp1);
d_q_d2_lnexpnum_dV_D_S = ((-q_temp1)*d_q_temp1_dV_D_S+(-d_q_temp1_dV_D_S)*q_temp1);
d_q_d2_lnexpnum_dV_G_S = ((-q_temp1)*d_q_temp1_dV_G_S+(-d_q_temp1_dV_G_S)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}

d_q_q2_int_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1d_dV_S_B)+2.0*d_q_lnexpnum_dV_S_B)-d_q_ln_term_dV_S_B);
d_q_q2_int_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1d_dTemp_Tnode_GND)+2.0*d_q_lnexpnum_dTemp_Tnode_GND)-d_q_ln_term_dTemp_Tnode_GND);
d_q_q2_int_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1d_dV_D_S)+2.0*d_q_lnexpnum_dV_D_S)-d_q_ln_term_dV_D_S);
d_q_q2_int_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1d_dV_G_S)+2.0*d_q_lnexpnum_dV_G_S)-d_q_ln_term_dV_G_S);
q_q2_int = ((((xg2x-xg1x)+q1d)+(2.0*q_lnexpnum))-q_ln_term);

d_q_d1_q2_dV_S_B = (2.0*d_q_d1_lnexpnum_dV_S_B-d_q_d1_ln_dV_S_B);
d_q_d1_q2_dTemp_Tnode_GND = (2.0*d_q_d1_lnexpnum_dTemp_Tnode_GND-d_q_d1_ln_dTemp_Tnode_GND);
d_q_d1_q2_dV_D_S = (2.0*d_q_d1_lnexpnum_dV_D_S-d_q_d1_ln_dV_D_S);
d_q_d1_q2_dV_G_S = (2.0*d_q_d1_lnexpnum_dV_G_S-d_q_d1_ln_dV_G_S);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);

d_q_d2_q2_dV_S_B = (2.0*d_q_d2_lnexpnum_dV_S_B-d_q_d2_ln_dV_S_B);
d_q_d2_q2_dTemp_Tnode_GND = (2.0*d_q_d2_lnexpnum_dTemp_Tnode_GND-d_q_d2_ln_dTemp_Tnode_GND);
d_q_d2_q2_dV_D_S = (2.0*d_q_d2_lnexpnum_dV_D_S-d_q_d2_ln_dV_D_S);
d_q_d2_q2_dV_G_S = (2.0*d_q_d2_lnexpnum_dV_G_S-d_q_d2_ln_dV_G_S);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);

d_q_qi_int_dV_S_B = (d_q_k1q1_dV_S_B+(k2*d_q_q2_int_dV_S_B+d_k2_dV_S_B*q_q2_int));
d_q_qi_int_dTemp_Tnode_GND = (d_q_k1q1_dTemp_Tnode_GND+(k2*d_q_q2_int_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_q2_int));
d_q_qi_int_dV_D_S = (d_q_k1q1_dV_D_S+(k2*d_q_q2_int_dV_D_S+d_k2_dV_D_S*q_q2_int));
d_q_qi_int_dV_G_S = (d_q_k1q1_dV_G_S+(k2*d_q_q2_int_dV_G_S+d_k2_dV_G_S*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));

d_q_d1_qi_dV_S_B = (d_k1_dV_S_B+(k2*d_q_d1_q2_dV_S_B+d_k2_dV_S_B*q_d1_q2));
d_q_d1_qi_dTemp_Tnode_GND = (d_k1_dTemp_Tnode_GND+(k2*d_q_d1_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d1_q2));
d_q_d1_qi_dV_D_S = (d_k1_dV_D_S+(k2*d_q_d1_q2_dV_D_S+d_k2_dV_D_S*q_d1_q2));
d_q_d1_qi_dV_G_S = (d_k1_dV_G_S+(k2*d_q_d1_q2_dV_G_S+d_k2_dV_G_S*q_d1_q2));
q_d1_qi = (k1+(k2*q_d1_q2));

d_q_d2_qi_dV_S_B = (k2*d_q_d2_q2_dV_S_B+d_k2_dV_S_B*q_d2_q2);
d_q_d2_qi_dTemp_Tnode_GND = (k2*d_q_d2_q2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q_d2_q2);
d_q_d2_qi_dV_D_S = (k2*d_q_d2_q2_dV_D_S+d_k2_dV_D_S*q_d2_q2);
d_q_d2_qi_dV_G_S = (k2*d_q_d2_q2_dV_G_S+d_k2_dV_G_S*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);

d_q_zero_dV_S_B = ((q_qi_int*d_q_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_expnum)-d_q_Aexp_dV_S_B);
d_q_zero_dTemp_Tnode_GND = ((q_qi_int*d_q_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_expnum)-d_q_Aexp_dTemp_Tnode_GND);
d_q_zero_dV_D_S = ((q_qi_int*d_q_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_expnum)-d_q_Aexp_dV_D_S);
d_q_zero_dV_G_S = ((q_qi_int*d_q_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_expnum)-d_q_Aexp_dV_G_S);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{

d_q_eps2_dV_G_S = d_q_eps2_dV_D_S = d_q_eps2_dTemp_Tnode_GND = d_q_eps2_dV_S_B =  0.0;
q_eps2 = 0.0;
}
else
{

d_q_d1_zero_dV_S_B = (((q_d1_qi*d_q_expnum_dV_S_B+d_q_d1_qi_dV_S_B*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d1_expnum))+d_q_Aexp_dV_S_B);
d_q_d1_zero_dTemp_Tnode_GND = (((q_d1_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d1_qi_dTemp_Tnode_GND*q_expnum)+(q_qi_int*d_q_d1_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d1_expnum))+d_q_Aexp_dTemp_Tnode_GND);
d_q_d1_zero_dV_D_S = (((q_d1_qi*d_q_expnum_dV_D_S+d_q_d1_qi_dV_D_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d1_expnum))+d_q_Aexp_dV_D_S);
d_q_d1_zero_dV_G_S = (((q_d1_qi*d_q_expnum_dV_G_S+d_q_d1_qi_dV_G_S*q_expnum)+(q_qi_int*d_q_d1_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d1_expnum))+d_q_Aexp_dV_G_S);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);

d_q_d2_zero_dV_S_B = ((((q_d2_qi*d_q_expnum_dV_S_B+d_q_d2_qi_dV_S_B*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_S_B+2.0*d_q_d1_qi_dV_S_B*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_S_B+d_q_qi_int_dV_S_B*q_d2_expnum))-d_q_Aexp_dV_S_B);
d_q_d2_zero_dTemp_Tnode_GND = ((((q_d2_qi*d_q_expnum_dTemp_Tnode_GND+d_q_d2_qi_dTemp_Tnode_GND*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dTemp_Tnode_GND+2.0*d_q_d1_qi_dTemp_Tnode_GND*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dTemp_Tnode_GND+d_q_qi_int_dTemp_Tnode_GND*q_d2_expnum))-d_q_Aexp_dTemp_Tnode_GND);
d_q_d2_zero_dV_D_S = ((((q_d2_qi*d_q_expnum_dV_D_S+d_q_d2_qi_dV_D_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_D_S+2.0*d_q_d1_qi_dV_D_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_D_S+d_q_qi_int_dV_D_S*q_d2_expnum))-d_q_Aexp_dV_D_S);
d_q_d2_zero_dV_G_S = ((((q_d2_qi*d_q_expnum_dV_G_S+d_q_d2_qi_dV_G_S*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dV_G_S+2.0*d_q_d1_qi_dV_G_S*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dV_G_S+d_q_qi_int_dV_G_S*q_d2_expnum))-d_q_Aexp_dV_G_S);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);

d_q_eps1_dV_S_B = ((q_d1_zero*(-d_q_zero_dV_S_B)-(-q_zero)*d_q_d1_zero_dV_S_B)/q_d1_zero/q_d1_zero);
d_q_eps1_dTemp_Tnode_GND = ((q_d1_zero*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*d_q_d1_zero_dTemp_Tnode_GND)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_D_S = ((q_d1_zero*(-d_q_zero_dV_D_S)-(-q_zero)*d_q_d1_zero_dV_D_S)/q_d1_zero/q_d1_zero);
d_q_eps1_dV_G_S = ((q_d1_zero*(-d_q_zero_dV_G_S)-(-q_zero)*d_q_d1_zero_dV_G_S)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);

d_q_eps2_dV_S_B = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_S_B)-(-q_zero)*(d_q_d1_zero_dV_S_B+((0.5*q_eps1)*d_q_d2_zero_dV_S_B+0.5*d_q_eps1_dV_S_B*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dTemp_Tnode_GND = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dTemp_Tnode_GND)-(-q_zero)*(d_q_d1_zero_dTemp_Tnode_GND+((0.5*q_eps1)*d_q_d2_zero_dTemp_Tnode_GND+0.5*d_q_eps1_dTemp_Tnode_GND*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_D_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_D_S)-(-q_zero)*(d_q_d1_zero_dV_D_S+((0.5*q_eps1)*d_q_d2_zero_dV_D_S+0.5*d_q_eps1_dV_D_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
d_q_eps2_dV_G_S = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dV_G_S)-(-q_zero)*(d_q_d1_zero_dV_G_S+((0.5*q_eps1)*d_q_d2_zero_dV_G_S+0.5*d_q_eps1_dV_G_S*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}

d_q1d_dV_S_B = (d_q1d_dV_S_B+d_q_eps2_dV_S_B);
d_q1d_dV_D_S = (d_q1d_dV_D_S+d_q_eps2_dV_D_S);
d_q1d_dV_G_S = (d_q1d_dV_G_S+d_q_eps2_dV_G_S);
d_q1d_dTemp_Tnode_GND = (d_q1d_dTemp_Tnode_GND+d_q_eps2_dTemp_Tnode_GND);
q1d = (q1d+q_eps2);

d_k1q1d_dV_S_B = (k1*d_q1d_dV_S_B+d_k1_dV_S_B*q1d);
d_k1q1d_dTemp_Tnode_GND = (k1*d_q1d_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*q1d);
d_k1q1d_dV_D_S = (k1*d_q1d_dV_D_S+d_k1_dV_D_S*q1d);
d_k1q1d_dV_G_S = (k1*d_q1d_dV_G_S+d_k1_dV_G_S*q1d);
k1q1d = (k1*q1d);
if ((((xg1x-q1d)-xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-xdeff));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*(((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*(((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*(((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*(((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*0.3333333333333+0.5*((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_S_B-d_q1d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*0.3333333333333+0.5*((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_D_S-d_q1d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*0.3333333333333+0.5*((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dV_G_S-d_q1d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg1x-q1d)-xdeff)-80.0)*((0.5*(((xg1x-q1d)-xdeff)-80.0))*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*0.3333333333333+0.5*((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dTemp_Tnode_GND-d_q1d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-xdeff)-80.0))*(1.0+((((xg1x-q1d)-xdeff)-80.0)*0.3333333333333)))))));
}

d_Aexp1d_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_Aexp1d_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_Aexp1d_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_Aexp1d_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
Aexp1d = (A0*q_temp1);

d_qsqd_dV_S_B = ((k1q1d*d_k1q1d_dV_S_B+d_k1q1d_dV_S_B*k1q1d)-d_Aexp1d_dV_S_B);
d_qsqd_dTemp_Tnode_GND = ((k1q1d*d_k1q1d_dTemp_Tnode_GND+d_k1q1d_dTemp_Tnode_GND*k1q1d)-d_Aexp1d_dTemp_Tnode_GND);
d_qsqd_dV_D_S = ((k1q1d*d_k1q1d_dV_D_S+d_k1q1d_dV_D_S*k1q1d)-d_Aexp1d_dV_D_S);
d_qsqd_dV_G_S = ((k1q1d*d_k1q1d_dV_G_S+d_k1q1d_dV_G_S*k1q1d)-d_Aexp1d_dV_G_S);
qsqd = ((k1q1d*k1q1d)-Aexp1d);
if ((Aexp1d==0.0))
{

d_qid_dTemp_Tnode_GND = d_qid_dV_G_S = d_qid_dV_D_S = d_qid_dV_S_B =  0.0;
qid = 1.0e-80;

d_k2q2d_dV_S_B = (d_qid_dV_S_B-d_k1q1d_dV_S_B);
d_k2q2d_dTemp_Tnode_GND = (d_qid_dTemp_Tnode_GND-d_k1q1d_dTemp_Tnode_GND);
d_k2q2d_dV_D_S = (d_qid_dV_D_S-d_k1q1d_dV_D_S);
d_k2q2d_dV_G_S = (d_qid_dV_G_S-d_k1q1d_dV_G_S);
k2q2d = (qid-k1q1d);

d_q2d_dV_S_B = ((k2*d_k2q2d_dV_S_B-k2q2d*d_k2_dV_S_B)/k2/k2);
d_q2d_dTemp_Tnode_GND = ((k2*d_k2q2d_dTemp_Tnode_GND-k2q2d*d_k2_dTemp_Tnode_GND)/k2/k2);
d_q2d_dV_D_S = ((k2*d_k2q2d_dV_D_S-k2q2d*d_k2_dV_D_S)/k2/k2);
d_q2d_dV_G_S = ((k2*d_k2q2d_dV_G_S-k2q2d*d_k2_dV_G_S)/k2/k2);
q2d = (k2q2d/k2);
}
else
{
if ((qsqd<(-0.005)))
{
{
double value_fabs_0 = fabs(qsqd);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqd)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));

d_q_qcoth_dV_S_B = ((value_tan_0*d_q_rac_qsq_dV_S_B-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_S_B)))/value_tan_0/value_tan_0);
d_q_qcoth_dTemp_Tnode_GND = ((value_tan_0*d_q_rac_qsq_dTemp_Tnode_GND-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_D_S = ((value_tan_0*d_q_rac_qsq_dV_D_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_D_S)))/value_tan_0/value_tan_0);
d_q_qcoth_dV_G_S = ((value_tan_0*d_q_rac_qsq_dV_G_S-q_rac_qsq*(deriv_tan_0_d0*(0.5*d_q_rac_qsq_dV_G_S)))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
}
else
{
if ((qsqd>0.005))
{
{
double value_fabs_0 = fabs(qsqd);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqd)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_q_rac_qsq_dV_S_B = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dV_S_B))));
d_q_rac_qsq_dTemp_Tnode_GND = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dTemp_Tnode_GND))));
d_q_rac_qsq_dV_D_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dV_D_S))));
d_q_rac_qsq_dV_G_S = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_qsqd_dV_G_S))));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_invexpq_dV_S_B = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_S_B)));
d_q_invexpq_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_q_rac_qsq_dTemp_Tnode_GND)));
d_q_invexpq_dV_D_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_D_S)));
d_q_invexpq_dV_G_S = (deriv_exp_0_d0*((-d_q_rac_qsq_dV_G_S)));
q_invexpq = value_exp_0;
}

d_q_qcoth_dV_S_B = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_S_B+d_q_rac_qsq_dV_S_B*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_S_B))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dTemp_Tnode_GND = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dTemp_Tnode_GND+d_q_rac_qsq_dTemp_Tnode_GND*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dTemp_Tnode_GND))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_D_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_D_S+d_q_rac_qsq_dV_D_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_D_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
d_q_qcoth_dV_G_S = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dV_G_S+d_q_rac_qsq_dV_G_S*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dV_G_S))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
}
else
{

d_q_qcoth_dV_S_B = ((qsqd*0.1666666666667)*(-((qsqd*0.0166666666667)*(-d_qsqd_dV_S_B*0.0238095238095)+d_qsqd_dV_S_B*0.0166666666667*(1.0-(qsqd*0.0238095238095))))+d_qsqd_dV_S_B*0.1666666666667*(1.0-((qsqd*0.0166666666667)*(1.0-(qsqd*0.0238095238095)))));
d_q_qcoth_dTemp_Tnode_GND = ((qsqd*0.1666666666667)*(-((qsqd*0.0166666666667)*(-d_qsqd_dTemp_Tnode_GND*0.0238095238095)+d_qsqd_dTemp_Tnode_GND*0.0166666666667*(1.0-(qsqd*0.0238095238095))))+d_qsqd_dTemp_Tnode_GND*0.1666666666667*(1.0-((qsqd*0.0166666666667)*(1.0-(qsqd*0.0238095238095)))));
d_q_qcoth_dV_D_S = ((qsqd*0.1666666666667)*(-((qsqd*0.0166666666667)*(-d_qsqd_dV_D_S*0.0238095238095)+d_qsqd_dV_D_S*0.0166666666667*(1.0-(qsqd*0.0238095238095))))+d_qsqd_dV_D_S*0.1666666666667*(1.0-((qsqd*0.0166666666667)*(1.0-(qsqd*0.0238095238095)))));
d_q_qcoth_dV_G_S = ((qsqd*0.1666666666667)*(-((qsqd*0.0166666666667)*(-d_qsqd_dV_G_S*0.0238095238095)+d_qsqd_dV_G_S*0.0166666666667*(1.0-(qsqd*0.0238095238095))))+d_qsqd_dV_G_S*0.1666666666667*(1.0-((qsqd*0.0166666666667)*(1.0-(qsqd*0.0238095238095)))));
q_qcoth = (2.0+((qsqd*0.1666666666667)*(1.0-((qsqd*0.0166666666667)*(1.0-(qsqd*0.0238095238095))))));
}
}
if ((((1.01*k1q1d)+q_qcoth)>0.0))
{

d_q_temp1_dV_S_B = (d_k1q1d_dV_S_B+d_q_qcoth_dV_S_B);
d_q_temp1_dTemp_Tnode_GND = (d_k1q1d_dTemp_Tnode_GND+d_q_qcoth_dTemp_Tnode_GND);
d_q_temp1_dV_D_S = (d_k1q1d_dV_D_S+d_q_qcoth_dV_D_S);
d_q_temp1_dV_G_S = (d_k1q1d_dV_G_S+d_q_qcoth_dV_G_S);
q_temp1 = (k1q1d+q_qcoth);
if (((Aexp1d*k1q1d)<(((0.9*k1q1d)*k1q1d)*q_temp1)))
{

d_qid_dV_S_B = ((q_temp1*d_Aexp1d_dV_S_B-Aexp1d*d_q_temp1_dV_S_B)/q_temp1/q_temp1);
d_qid_dV_D_S = ((q_temp1*d_Aexp1d_dV_D_S-Aexp1d*d_q_temp1_dV_D_S)/q_temp1/q_temp1);
d_qid_dV_G_S = ((q_temp1*d_Aexp1d_dV_G_S-Aexp1d*d_q_temp1_dV_G_S)/q_temp1/q_temp1);
d_qid_dTemp_Tnode_GND = ((q_temp1*d_Aexp1d_dTemp_Tnode_GND-Aexp1d*d_q_temp1_dTemp_Tnode_GND)/q_temp1/q_temp1);
qid = ((Aexp1d/q_temp1)+1.0e-80);

d_k2q2d_dV_S_B = (d_qid_dV_S_B-d_k1q1d_dV_S_B);
d_k2q2d_dV_D_S = (d_qid_dV_D_S-d_k1q1d_dV_D_S);
d_k2q2d_dV_G_S = (d_qid_dV_G_S-d_k1q1d_dV_G_S);
d_k2q2d_dTemp_Tnode_GND = (d_qid_dTemp_Tnode_GND-d_k1q1d_dTemp_Tnode_GND);
k2q2d = (qid-k1q1d);

d_q2d_dV_S_B = ((k2*d_k2q2d_dV_S_B-k2q2d*d_k2_dV_S_B)/k2/k2);
d_q2d_dTemp_Tnode_GND = ((k2*d_k2q2d_dTemp_Tnode_GND-k2q2d*d_k2_dTemp_Tnode_GND)/k2/k2);
d_q2d_dV_D_S = ((k2*d_k2q2d_dV_D_S-k2q2d*d_k2_dV_D_S)/k2/k2);
d_q2d_dV_G_S = ((k2*d_k2q2d_dV_G_S-k2q2d*d_k2_dV_G_S)/k2/k2);
q2d = (k2q2d/k2);
}
else
{
if ((qsqd>0.005))
{
{
double value_log_0 = log(((4.0*qsqd)/(1.0-(q_invexpq*(2.0-q_invexpq)))));
double  deriv_log_0_d0 = (1.0/((4.0*qsqd)/(1.0-(q_invexpq*(2.0-q_invexpq)))));

d_q_temp2_dV_S_B = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqd_dV_S_B-(4.0*qsqd)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dV_S_B);
d_q_temp2_dTemp_Tnode_GND = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqd_dTemp_Tnode_GND-(4.0*qsqd)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dTemp_Tnode_GND);
d_q_temp2_dV_D_S = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqd_dV_D_S-(4.0*qsqd)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dV_D_S);
d_q_temp2_dV_G_S = ((deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqd_dV_G_S-(4.0*qsqd)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))))))-d_q_rac_qsq_dV_G_S);
q_temp2 = (value_log_0-q_rac_qsq);
}
}
else
{
if ((qsqd<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp3_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp3_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp3_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp3_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp3 = value_sin_0;
}
{
double value_log_0 = log(((-qsqd)/(q_temp3*q_temp3)));
double  deriv_log_0_d0 = (1.0/((-qsqd)/(q_temp3*q_temp3)));

d_q_temp2_dV_S_B = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqd_dV_S_B)-(-qsqd)*(q_temp3*d_q_temp3_dV_S_B+d_q_temp3_dV_S_B*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
d_q_temp2_dTemp_Tnode_GND = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqd_dTemp_Tnode_GND)-(-qsqd)*(q_temp3*d_q_temp3_dTemp_Tnode_GND+d_q_temp3_dTemp_Tnode_GND*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
d_q_temp2_dV_D_S = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqd_dV_D_S)-(-qsqd)*(q_temp3*d_q_temp3_dV_D_S+d_q_temp3_dV_D_S*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
d_q_temp2_dV_G_S = (deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqd_dV_G_S)-(-qsqd)*(q_temp3*d_q_temp3_dV_G_S+d_q_temp3_dV_G_S*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3))));
q_temp2 = value_log_0;
}
}
else
{
{
double value_log_0 = log((4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd)))))));
double  deriv_log_0_d0 = (1.0/(4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd)))))));

d_q_temp2_dV_S_B = (deriv_log_0_d0*((-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dV_S_B)+0.05*d_qsqd_dV_S_B*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dV_S_B*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))));
d_q_temp2_dTemp_Tnode_GND = (deriv_log_0_d0*((-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dTemp_Tnode_GND)+0.05*d_qsqd_dTemp_Tnode_GND*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))));
d_q_temp2_dV_D_S = (deriv_log_0_d0*((-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dV_D_S)+0.05*d_qsqd_dV_D_S*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dV_D_S*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))));
d_q_temp2_dV_G_S = (deriv_log_0_d0*((-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dV_G_S)+0.05*d_qsqd_dV_G_S*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dV_G_S*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))));
q_temp2 = value_log_0;
}
}
}
{
double value_log_0 = log(q_temp1);
double  deriv_log_0_d0 = (1.0/q_temp1);

d_q2d_dV_S_B = ((((d_xg2x_dV_S_B-d_xg1x_dV_S_B)+d_q1d_dV_S_B)+2.0*(deriv_log_0_d0*(d_q_temp1_dV_S_B)))-d_q_temp2_dV_S_B);
d_q2d_dTemp_Tnode_GND = ((((d_xg2x_dTemp_Tnode_GND-d_xg1x_dTemp_Tnode_GND)+d_q1d_dTemp_Tnode_GND)+2.0*(deriv_log_0_d0*(d_q_temp1_dTemp_Tnode_GND)))-d_q_temp2_dTemp_Tnode_GND);
d_q2d_dV_D_S = ((((d_xg2x_dV_D_S-d_xg1x_dV_D_S)+d_q1d_dV_D_S)+2.0*(deriv_log_0_d0*(d_q_temp1_dV_D_S)))-d_q_temp2_dV_D_S);
d_q2d_dV_G_S = ((((d_xg2x_dV_G_S-d_xg1x_dV_G_S)+d_q1d_dV_G_S)+2.0*(deriv_log_0_d0*(d_q_temp1_dV_G_S)))-d_q_temp2_dV_G_S);
q2d = ((((xg2x-xg1x)+q1d)+(2.0*value_log_0))-q_temp2);
}

d_k2q2d_dV_S_B = (k2*d_q2d_dV_S_B+d_k2_dV_S_B*q2d);
d_k2q2d_dTemp_Tnode_GND = (k2*d_q2d_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*q2d);
d_k2q2d_dV_D_S = (k2*d_q2d_dV_D_S+d_k2_dV_D_S*q2d);
d_k2q2d_dV_G_S = (k2*d_q2d_dV_G_S+d_k2_dV_G_S*q2d);
k2q2d = (k2*q2d);

d_qid_dV_S_B = (d_k1q1d_dV_S_B+d_k2q2d_dV_S_B);
d_qid_dTemp_Tnode_GND = (d_k1q1d_dTemp_Tnode_GND+d_k2q2d_dTemp_Tnode_GND);
d_qid_dV_D_S = (d_k1q1d_dV_D_S+d_k2q2d_dV_D_S);
d_qid_dV_G_S = (d_k1q1d_dV_G_S+d_k2q2d_dV_G_S);
qid = (k1q1d+k2q2d);
}
}
else
{
if ((qsqd>0.005))
{
if (((((q1d+xdeff)-xg1x)-q_rac_qsq)<80.0))
{
{
double value_exp_0 = exp((((q1d+xdeff)-xg1x)-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp3_dV_S_B = (deriv_exp_0_d0*((((d_q1d_dV_S_B+d_xdeff_dV_S_B)-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)));
d_q_temp3_dV_D_S = (deriv_exp_0_d0*((((d_q1d_dV_D_S+d_xdeff_dV_D_S)-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)));
d_q_temp3_dV_G_S = (deriv_exp_0_d0*((((d_q1d_dV_G_S+d_xdeff_dV_G_S)-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)));
d_q_temp3_dTemp_Tnode_GND = (deriv_exp_0_d0*((((d_q1d_dTemp_Tnode_GND+d_xdeff_dTemp_Tnode_GND)-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)));
q_temp3 = value_exp_0;
}
}
else
{

d_q_temp3_dV_S_B = 5.54062e34*(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(((d_q1d_dV_S_B+d_xdeff_dV_S_B)-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)*0.3333333333333+0.5*(((d_q1d_dV_S_B+d_xdeff_dV_S_B)-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+(((d_q1d_dV_S_B+d_xdeff_dV_S_B)-d_xg1x_dV_S_B)-d_q_rac_qsq_dV_S_B)*(1.0+((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
d_q_temp3_dV_D_S = 5.54062e34*(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(((d_q1d_dV_D_S+d_xdeff_dV_D_S)-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)*0.3333333333333+0.5*(((d_q1d_dV_D_S+d_xdeff_dV_D_S)-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+(((d_q1d_dV_D_S+d_xdeff_dV_D_S)-d_xg1x_dV_D_S)-d_q_rac_qsq_dV_D_S)*(1.0+((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
d_q_temp3_dV_G_S = 5.54062e34*(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(((d_q1d_dV_G_S+d_xdeff_dV_G_S)-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)*0.3333333333333+0.5*(((d_q1d_dV_G_S+d_xdeff_dV_G_S)-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+(((d_q1d_dV_G_S+d_xdeff_dV_G_S)-d_xg1x_dV_G_S)-d_q_rac_qsq_dV_G_S)*(1.0+((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
d_q_temp3_dTemp_Tnode_GND = 5.54062e34*(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(((d_q1d_dTemp_Tnode_GND+d_xdeff_dTemp_Tnode_GND)-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)*0.3333333333333+0.5*(((d_q1d_dTemp_Tnode_GND+d_xdeff_dTemp_Tnode_GND)-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+(((d_q1d_dTemp_Tnode_GND+d_xdeff_dTemp_Tnode_GND)-d_xg1x_dTemp_Tnode_GND)-d_q_rac_qsq_dTemp_Tnode_GND)*(1.0+((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
q_temp3 = (5.54062e34*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*(1.0+((0.5*((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0))*(1.0+(((((q1d+xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))))));
}

d_q_temp2_dV_S_B = ((A0*d_q_temp3_dV_S_B-q_temp3*d_A0_dV_S_B)/A0/A0);
d_q_temp2_dTemp_Tnode_GND = ((A0*d_q_temp3_dTemp_Tnode_GND-q_temp3*d_A0_dTemp_Tnode_GND)/A0/A0);
d_q_temp2_dV_D_S = ((A0*d_q_temp3_dV_D_S-q_temp3*d_A0_dV_D_S)/A0/A0);
d_q_temp2_dV_G_S = ((A0*d_q_temp3_dV_G_S-q_temp3*d_A0_dV_G_S)/A0/A0);
q_temp2 = (q_temp3/A0);

d_q_temp1_dV_S_B = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqd)*d_q_temp2_dV_S_B+4.0*d_qsqd_dV_S_B*q_temp2)-((4.0*qsqd)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dV_S_B)+d_q_invexpq_dV_S_B*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp1_dTemp_Tnode_GND = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqd)*d_q_temp2_dTemp_Tnode_GND+4.0*d_qsqd_dTemp_Tnode_GND*q_temp2)-((4.0*qsqd)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dTemp_Tnode_GND)+d_q_invexpq_dTemp_Tnode_GND*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp1_dV_D_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqd)*d_q_temp2_dV_D_S+4.0*d_qsqd_dV_D_S*q_temp2)-((4.0*qsqd)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dV_D_S)+d_q_invexpq_dV_D_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_temp1_dV_G_S = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqd)*d_q_temp2_dV_G_S+4.0*d_qsqd_dV_G_S*q_temp2)-((4.0*qsqd)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dV_G_S)+d_q_invexpq_dV_G_S*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp1 = (((4.0*qsqd)*q_temp2)/(1.0-(q_invexpq*(2.0-q_invexpq))));
}
else
{
if ((qsqd<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));

d_q_temp2_dV_S_B = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_S_B));
d_q_temp2_dTemp_Tnode_GND = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dTemp_Tnode_GND));
d_q_temp2_dV_D_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_D_S));
d_q_temp2_dV_G_S = (deriv_sin_0_d0*(0.5*d_q_rac_qsq_dV_G_S));
q_temp2 = value_sin_0;
}

d_q_temp1_dV_S_B = ((Aexp1d*(((q_temp2*q_temp2)*(-d_qsqd_dV_S_B)-(-qsqd)*(q_temp2*d_q_temp2_dV_S_B+d_q_temp2_dV_S_B*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqd)/(q_temp2*q_temp2))*d_Aexp1d_dV_S_B)/Aexp1d/Aexp1d);
d_q_temp1_dTemp_Tnode_GND = ((Aexp1d*(((q_temp2*q_temp2)*(-d_qsqd_dTemp_Tnode_GND)-(-qsqd)*(q_temp2*d_q_temp2_dTemp_Tnode_GND+d_q_temp2_dTemp_Tnode_GND*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqd)/(q_temp2*q_temp2))*d_Aexp1d_dTemp_Tnode_GND)/Aexp1d/Aexp1d);
d_q_temp1_dV_D_S = ((Aexp1d*(((q_temp2*q_temp2)*(-d_qsqd_dV_D_S)-(-qsqd)*(q_temp2*d_q_temp2_dV_D_S+d_q_temp2_dV_D_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqd)/(q_temp2*q_temp2))*d_Aexp1d_dV_D_S)/Aexp1d/Aexp1d);
d_q_temp1_dV_G_S = ((Aexp1d*(((q_temp2*q_temp2)*(-d_qsqd_dV_G_S)-(-qsqd)*(q_temp2*d_q_temp2_dV_G_S+d_q_temp2_dV_G_S*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqd)/(q_temp2*q_temp2))*d_Aexp1d_dV_G_S)/Aexp1d/Aexp1d);
q_temp1 = (((-qsqd)/(q_temp2*q_temp2))/Aexp1d);
}
else
{

d_q_temp1_dV_S_B = ((Aexp1d*(-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dV_S_B)+0.05*d_qsqd_dV_S_B*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dV_S_B*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))-(4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))*d_Aexp1d_dV_S_B)/Aexp1d/Aexp1d);
d_q_temp1_dTemp_Tnode_GND = ((Aexp1d*(-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dTemp_Tnode_GND)+0.05*d_qsqd_dTemp_Tnode_GND*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dTemp_Tnode_GND*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))-(4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))*d_Aexp1d_dTemp_Tnode_GND)/Aexp1d/Aexp1d);
d_q_temp1_dV_D_S = ((Aexp1d*(-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dV_D_S)+0.05*d_qsqd_dV_D_S*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dV_D_S*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))-(4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))*d_Aexp1d_dV_D_S)/Aexp1d/Aexp1d);
d_q_temp1_dV_G_S = ((Aexp1d*(-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dV_G_S)+0.05*d_qsqd_dV_G_S*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dV_G_S*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))-(4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))*d_Aexp1d_dV_G_S)/Aexp1d/Aexp1d);
q_temp1 = ((4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))/Aexp1d);
}
}

d_qid_dV_S_B = (((1.0-q_temp1)*(d_k1q1d_dV_S_B-d_q_qcoth_dV_S_B)-(k1q1d-q_qcoth)*(-d_q_temp1_dV_S_B))/(1.0-q_temp1)/(1.0-q_temp1));
d_qid_dTemp_Tnode_GND = (((1.0-q_temp1)*(d_k1q1d_dTemp_Tnode_GND-d_q_qcoth_dTemp_Tnode_GND)-(k1q1d-q_qcoth)*(-d_q_temp1_dTemp_Tnode_GND))/(1.0-q_temp1)/(1.0-q_temp1));
d_qid_dV_D_S = (((1.0-q_temp1)*(d_k1q1d_dV_D_S-d_q_qcoth_dV_D_S)-(k1q1d-q_qcoth)*(-d_q_temp1_dV_D_S))/(1.0-q_temp1)/(1.0-q_temp1));
d_qid_dV_G_S = (((1.0-q_temp1)*(d_k1q1d_dV_G_S-d_q_qcoth_dV_G_S)-(k1q1d-q_qcoth)*(-d_q_temp1_dV_G_S))/(1.0-q_temp1)/(1.0-q_temp1));
qid = (((k1q1d-q_qcoth)/(1.0-q_temp1))+1.0e-80);

d_k2q2d_dV_S_B = (d_qid_dV_S_B-d_k1q1d_dV_S_B);
d_k2q2d_dV_D_S = (d_qid_dV_D_S-d_k1q1d_dV_D_S);
d_k2q2d_dV_G_S = (d_qid_dV_G_S-d_k1q1d_dV_G_S);
d_k2q2d_dTemp_Tnode_GND = (d_qid_dTemp_Tnode_GND-d_k1q1d_dTemp_Tnode_GND);
k2q2d = (qid-k1q1d);

d_q2d_dV_S_B = ((k2*d_k2q2d_dV_S_B-k2q2d*d_k2_dV_S_B)/k2/k2);
d_q2d_dTemp_Tnode_GND = ((k2*d_k2q2d_dTemp_Tnode_GND-k2q2d*d_k2_dTemp_Tnode_GND)/k2/k2);
d_q2d_dV_D_S = ((k2*d_k2q2d_dV_D_S-k2q2d*d_k2_dV_D_S)/k2/k2);
d_q2d_dV_G_S = ((k2*d_k2q2d_dV_G_S-k2q2d*d_k2_dV_G_S)/k2/k2);
q2d = (k2q2d/k2);
}
}
if ((((xg2x-q2d)-xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg2x-q2d)-xdeff));
double  deriv_exp_0_d0 = value_exp_0;

d_q_temp1_dV_S_B = (deriv_exp_0_d0*(((d_xg2x_dV_S_B-d_q2d_dV_S_B)-d_xdeff_dV_S_B)));
d_q_temp1_dTemp_Tnode_GND = (deriv_exp_0_d0*(((d_xg2x_dTemp_Tnode_GND-d_q2d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)));
d_q_temp1_dV_D_S = (deriv_exp_0_d0*(((d_xg2x_dV_D_S-d_q2d_dV_D_S)-d_xdeff_dV_D_S)));
d_q_temp1_dV_G_S = (deriv_exp_0_d0*(((d_xg2x_dV_G_S-d_q2d_dV_G_S)-d_xdeff_dV_G_S)));
q_temp1 = value_exp_0;
}
}
else
{

d_q_temp1_dV_S_B = 5.54062e34*((((xg2x-q2d)-xdeff)-80.0)*((0.5*(((xg2x-q2d)-xdeff)-80.0))*((d_xg2x_dV_S_B-d_q2d_dV_S_B)-d_xdeff_dV_S_B)*0.3333333333333+0.5*((d_xg2x_dV_S_B-d_q2d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))+((d_xg2x_dV_S_B-d_q2d_dV_S_B)-d_xdeff_dV_S_B)*(1.0+((0.5*(((xg2x-q2d)-xdeff)-80.0))*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dTemp_Tnode_GND = 5.54062e34*((((xg2x-q2d)-xdeff)-80.0)*((0.5*(((xg2x-q2d)-xdeff)-80.0))*((d_xg2x_dTemp_Tnode_GND-d_q2d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*0.3333333333333+0.5*((d_xg2x_dTemp_Tnode_GND-d_q2d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))+((d_xg2x_dTemp_Tnode_GND-d_q2d_dTemp_Tnode_GND)-d_xdeff_dTemp_Tnode_GND)*(1.0+((0.5*(((xg2x-q2d)-xdeff)-80.0))*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_D_S = 5.54062e34*((((xg2x-q2d)-xdeff)-80.0)*((0.5*(((xg2x-q2d)-xdeff)-80.0))*((d_xg2x_dV_D_S-d_q2d_dV_D_S)-d_xdeff_dV_D_S)*0.3333333333333+0.5*((d_xg2x_dV_D_S-d_q2d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))+((d_xg2x_dV_D_S-d_q2d_dV_D_S)-d_xdeff_dV_D_S)*(1.0+((0.5*(((xg2x-q2d)-xdeff)-80.0))*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))));
d_q_temp1_dV_G_S = 5.54062e34*((((xg2x-q2d)-xdeff)-80.0)*((0.5*(((xg2x-q2d)-xdeff)-80.0))*((d_xg2x_dV_G_S-d_q2d_dV_G_S)-d_xdeff_dV_G_S)*0.3333333333333+0.5*((d_xg2x_dV_G_S-d_q2d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))+((d_xg2x_dV_G_S-d_q2d_dV_G_S)-d_xdeff_dV_G_S)*(1.0+((0.5*(((xg2x-q2d)-xdeff)-80.0))*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg2x-q2d)-xdeff)-80.0)*(1.0+((0.5*(((xg2x-q2d)-xdeff)-80.0))*(1.0+((((xg2x-q2d)-xdeff)-80.0)*0.3333333333333)))))));
}

d_Aexp2d_dV_S_B = (A0*d_q_temp1_dV_S_B+d_A0_dV_S_B*q_temp1);
d_Aexp2d_dV_D_S = (A0*d_q_temp1_dV_D_S+d_A0_dV_D_S*q_temp1);
d_Aexp2d_dV_G_S = (A0*d_q_temp1_dV_G_S+d_A0_dV_G_S*q_temp1);
d_Aexp2d_dTemp_Tnode_GND = (A0*d_q_temp1_dTemp_Tnode_GND+d_A0_dTemp_Tnode_GND*q_temp1);
Aexp2d = (A0*q_temp1);

d_a1d_dTemp_Tnode_GND = d_a1d_dV_G_S = d_a1d_dV_D_S = d_a1d_dV_S_B =  0.0;
a1d = 0.0;

d_a2d_dTemp_Tnode_GND = d_a2d_dV_G_S = d_a2d_dV_D_S = d_a2d_dV_S_B =  0.0;
a2d = 0.0;

d_b1d_dTemp_Tnode_GND = d_b1d_dV_G_S = d_b1d_dV_D_S = d_b1d_dV_S_B =  0.0;
b1d = 0.0;

d_b2d_dTemp_Tnode_GND = d_b2d_dV_G_S = d_b2d_dV_D_S = d_b2d_dV_S_B =  0.0;
b2d = 0.0;

d_sumd_dTemp_Tnode_GND = d_sumd_dV_G_S = d_sumd_dV_D_S = d_sumd_dV_S_B =  0.0;
sumd = 0.0;

d_dqsqd_dxn_qi_dV_G_S = d_dqsqd_dxn_qi_dV_D_S = d_dqsqd_dxn_qi_dTemp_Tnode_GND = d_dqsqd_dxn_qi_dV_S_B =  0.0;
dqsqd_dxn_qi = 0.0;
if ((qis>1.0E-6))
{

d_b1d_dV_S_B = (Aexp1d*d_inv_k1_dV_S_B+d_Aexp1d_dV_S_B*inv_k1);
d_b1d_dV_D_S = (Aexp1d*d_inv_k1_dV_D_S+d_Aexp1d_dV_D_S*inv_k1);
d_b1d_dV_G_S = (Aexp1d*d_inv_k1_dV_G_S+d_Aexp1d_dV_G_S*inv_k1);
d_b1d_dTemp_Tnode_GND = (Aexp1d*d_inv_k1_dTemp_Tnode_GND+d_Aexp1d_dTemp_Tnode_GND*inv_k1);
b1d = (Aexp1d*inv_k1);

d_b2d_dV_S_B = (Aexp2d*d_inv_k2_dV_S_B+d_Aexp2d_dV_S_B*inv_k2);
d_b2d_dV_D_S = (Aexp2d*d_inv_k2_dV_D_S+d_Aexp2d_dV_D_S*inv_k2);
d_b2d_dV_G_S = (Aexp2d*d_inv_k2_dV_G_S+d_Aexp2d_dV_G_S*inv_k2);
d_b2d_dTemp_Tnode_GND = (Aexp2d*d_inv_k2_dTemp_Tnode_GND+d_Aexp2d_dTemp_Tnode_GND*inv_k2);
b2d = (Aexp2d*inv_k2);

d_a1d_dV_S_B = (d_b1d_dV_S_B+2.0*d_k1q1d_dV_S_B);
d_a1d_dV_D_S = (d_b1d_dV_D_S+2.0*d_k1q1d_dV_D_S);
d_a1d_dV_G_S = (d_b1d_dV_G_S+2.0*d_k1q1d_dV_G_S);
d_a1d_dTemp_Tnode_GND = (d_b1d_dTemp_Tnode_GND+2.0*d_k1q1d_dTemp_Tnode_GND);
a1d = (b1d+(2.0*k1q1d));

d_a2d_dV_S_B = (d_b2d_dV_S_B+2.0*d_k2q2d_dV_S_B);
d_a2d_dV_D_S = (d_b2d_dV_D_S+2.0*d_k2q2d_dV_D_S);
d_a2d_dV_G_S = (d_b2d_dV_G_S+2.0*d_k2q2d_dV_G_S);
d_a2d_dTemp_Tnode_GND = (d_b2d_dTemp_Tnode_GND+2.0*d_k2q2d_dTemp_Tnode_GND);
a2d = (b2d+(2.0*k2q2d));

d_sumd_dV_S_B = ((2.0*d_qid_dV_S_B+d_b1d_dV_S_B)+d_b2d_dV_S_B);
d_sumd_dV_D_S = ((2.0*d_qid_dV_D_S+d_b1d_dV_D_S)+d_b2d_dV_D_S);
d_sumd_dV_G_S = ((2.0*d_qid_dV_G_S+d_b1d_dV_G_S)+d_b2d_dV_G_S);
d_sumd_dTemp_Tnode_GND = ((2.0*d_qid_dTemp_Tnode_GND+d_b1d_dTemp_Tnode_GND)+d_b2d_dTemp_Tnode_GND);
sumd = (((2.0*qid)+b1d)+b2d);
if ((fabs(qsqd)>0.005))
{

d_temp1_dV_S_B = (((a1d*d_a2d_dV_S_B+d_a1d_dV_S_B*a2d)+((2.0*(q1d+2.0))*d_a2d_dV_S_B+2.0*d_q1d_dV_S_B*a2d))+((2.0*(q2d+2.0))*d_a1d_dV_S_B+2.0*d_q2d_dV_S_B*a1d));
d_temp1_dV_D_S = (((a1d*d_a2d_dV_D_S+d_a1d_dV_D_S*a2d)+((2.0*(q1d+2.0))*d_a2d_dV_D_S+2.0*d_q1d_dV_D_S*a2d))+((2.0*(q2d+2.0))*d_a1d_dV_D_S+2.0*d_q2d_dV_D_S*a1d));
d_temp1_dV_G_S = (((a1d*d_a2d_dV_G_S+d_a1d_dV_G_S*a2d)+((2.0*(q1d+2.0))*d_a2d_dV_G_S+2.0*d_q1d_dV_G_S*a2d))+((2.0*(q2d+2.0))*d_a1d_dV_G_S+2.0*d_q2d_dV_G_S*a1d));
d_temp1_dTemp_Tnode_GND = (((a1d*d_a2d_dTemp_Tnode_GND+d_a1d_dTemp_Tnode_GND*a2d)+((2.0*(q1d+2.0))*d_a2d_dTemp_Tnode_GND+2.0*d_q1d_dTemp_Tnode_GND*a2d))+((2.0*(q2d+2.0))*d_a1d_dTemp_Tnode_GND+2.0*d_q2d_dTemp_Tnode_GND*a1d));
temp1 = (((a1d*a2d)+((2.0*(q1d+2.0))*a2d))+((2.0*(q2d+2.0))*a1d));

d_dqsqd_dxn_qi_dV_S_B = (((qid*temp1)*(((-4.0)*qsqd)*d_sumd_dV_S_B+(-4.0)*d_qsqd_dV_S_B*sumd)-(((-4.0)*qsqd)*sumd)*(qid*d_temp1_dV_S_B+d_qid_dV_S_B*temp1))/(qid*temp1)/(qid*temp1));
d_dqsqd_dxn_qi_dTemp_Tnode_GND = (((qid*temp1)*(((-4.0)*qsqd)*d_sumd_dTemp_Tnode_GND+(-4.0)*d_qsqd_dTemp_Tnode_GND*sumd)-(((-4.0)*qsqd)*sumd)*(qid*d_temp1_dTemp_Tnode_GND+d_qid_dTemp_Tnode_GND*temp1))/(qid*temp1)/(qid*temp1));
d_dqsqd_dxn_qi_dV_D_S = (((qid*temp1)*(((-4.0)*qsqd)*d_sumd_dV_D_S+(-4.0)*d_qsqd_dV_D_S*sumd)-(((-4.0)*qsqd)*sumd)*(qid*d_temp1_dV_D_S+d_qid_dV_D_S*temp1))/(qid*temp1)/(qid*temp1));
d_dqsqd_dxn_qi_dV_G_S = (((qid*temp1)*(((-4.0)*qsqd)*d_sumd_dV_G_S+(-4.0)*d_qsqd_dV_G_S*sumd)-(((-4.0)*qsqd)*sumd)*(qid*d_temp1_dV_G_S+d_qid_dV_G_S*temp1))/(qid*temp1)/(qid*temp1));
dqsqd_dxn_qi = ((((-4.0)*qsqd)*sumd)/(qid*temp1));
}
else
{

d_temp1_dV_S_B = 0.1666666666667*(-((qsqd*0.0333333333333)*(-((qsqd*0.0357142857143)*(-d_qsqd_dV_S_B*0.0333333333333)+d_qsqd_dV_S_B*0.0357142857143*(1.0-(qsqd*0.0333333333333))))+d_qsqd_dV_S_B*0.0333333333333*(1.0-((qsqd*0.0357142857143)*(1.0-(qsqd*0.0333333333333))))));
d_temp1_dTemp_Tnode_GND = 0.1666666666667*(-((qsqd*0.0333333333333)*(-((qsqd*0.0357142857143)*(-d_qsqd_dTemp_Tnode_GND*0.0333333333333)+d_qsqd_dTemp_Tnode_GND*0.0357142857143*(1.0-(qsqd*0.0333333333333))))+d_qsqd_dTemp_Tnode_GND*0.0333333333333*(1.0-((qsqd*0.0357142857143)*(1.0-(qsqd*0.0333333333333))))));
d_temp1_dV_D_S = 0.1666666666667*(-((qsqd*0.0333333333333)*(-((qsqd*0.0357142857143)*(-d_qsqd_dV_D_S*0.0333333333333)+d_qsqd_dV_D_S*0.0357142857143*(1.0-(qsqd*0.0333333333333))))+d_qsqd_dV_D_S*0.0333333333333*(1.0-((qsqd*0.0357142857143)*(1.0-(qsqd*0.0333333333333))))));
d_temp1_dV_G_S = 0.1666666666667*(-((qsqd*0.0333333333333)*(-((qsqd*0.0357142857143)*(-d_qsqd_dV_G_S*0.0333333333333)+d_qsqd_dV_G_S*0.0357142857143*(1.0-(qsqd*0.0333333333333))))+d_qsqd_dV_G_S*0.0333333333333*(1.0-((qsqd*0.0357142857143)*(1.0-(qsqd*0.0333333333333))))));
temp1 = (0.1666666666667*(1.0-((qsqd*0.0333333333333)*(1.0-((qsqd*0.0357142857143)*(1.0-(qsqd*0.0333333333333)))))));

d_temp2_dV_S_B = (((a1d*d_Aexp1d_dV_S_B+d_a1d_dV_S_B*Aexp1d)+(a2d*d_Aexp2d_dV_S_B+d_a2d_dV_S_B*Aexp2d))+(((a1d*a2d)*qid)*(qid*d_temp1_dV_S_B+d_qid_dV_S_B*temp1)+((a1d*a2d)*d_qid_dV_S_B+(a1d*d_a2d_dV_S_B+d_a1d_dV_S_B*a2d)*qid)*(1.0+(qid*temp1))));
d_temp2_dV_D_S = (((a1d*d_Aexp1d_dV_D_S+d_a1d_dV_D_S*Aexp1d)+(a2d*d_Aexp2d_dV_D_S+d_a2d_dV_D_S*Aexp2d))+(((a1d*a2d)*qid)*(qid*d_temp1_dV_D_S+d_qid_dV_D_S*temp1)+((a1d*a2d)*d_qid_dV_D_S+(a1d*d_a2d_dV_D_S+d_a1d_dV_D_S*a2d)*qid)*(1.0+(qid*temp1))));
d_temp2_dV_G_S = (((a1d*d_Aexp1d_dV_G_S+d_a1d_dV_G_S*Aexp1d)+(a2d*d_Aexp2d_dV_G_S+d_a2d_dV_G_S*Aexp2d))+(((a1d*a2d)*qid)*(qid*d_temp1_dV_G_S+d_qid_dV_G_S*temp1)+((a1d*a2d)*d_qid_dV_G_S+(a1d*d_a2d_dV_G_S+d_a1d_dV_G_S*a2d)*qid)*(1.0+(qid*temp1))));
d_temp2_dTemp_Tnode_GND = (((a1d*d_Aexp1d_dTemp_Tnode_GND+d_a1d_dTemp_Tnode_GND*Aexp1d)+(a2d*d_Aexp2d_dTemp_Tnode_GND+d_a2d_dTemp_Tnode_GND*Aexp2d))+(((a1d*a2d)*qid)*(qid*d_temp1_dTemp_Tnode_GND+d_qid_dTemp_Tnode_GND*temp1)+((a1d*a2d)*d_qid_dTemp_Tnode_GND+(a1d*d_a2d_dTemp_Tnode_GND+d_a1d_dTemp_Tnode_GND*a2d)*qid)*(1.0+(qid*temp1))));
temp2 = (((a1d*Aexp1d)+(a2d*Aexp2d))+(((a1d*a2d)*qid)*(1.0+(qid*temp1))));

d_dqsqd_dxn_qi_dV_S_B = (((qid*temp2)*((Aexp1d*Aexp2d)*d_sumd_dV_S_B+(Aexp1d*d_Aexp2d_dV_S_B+d_Aexp1d_dV_S_B*Aexp2d)*sumd)-((Aexp1d*Aexp2d)*sumd)*(qid*d_temp2_dV_S_B+d_qid_dV_S_B*temp2))/(qid*temp2)/(qid*temp2));
d_dqsqd_dxn_qi_dV_D_S = (((qid*temp2)*((Aexp1d*Aexp2d)*d_sumd_dV_D_S+(Aexp1d*d_Aexp2d_dV_D_S+d_Aexp1d_dV_D_S*Aexp2d)*sumd)-((Aexp1d*Aexp2d)*sumd)*(qid*d_temp2_dV_D_S+d_qid_dV_D_S*temp2))/(qid*temp2)/(qid*temp2));
d_dqsqd_dxn_qi_dV_G_S = (((qid*temp2)*((Aexp1d*Aexp2d)*d_sumd_dV_G_S+(Aexp1d*d_Aexp2d_dV_G_S+d_Aexp1d_dV_G_S*Aexp2d)*sumd)-((Aexp1d*Aexp2d)*sumd)*(qid*d_temp2_dV_G_S+d_qid_dV_G_S*temp2))/(qid*temp2)/(qid*temp2));
d_dqsqd_dxn_qi_dTemp_Tnode_GND = (((qid*temp2)*((Aexp1d*Aexp2d)*d_sumd_dTemp_Tnode_GND+(Aexp1d*d_Aexp2d_dTemp_Tnode_GND+d_Aexp1d_dTemp_Tnode_GND*Aexp2d)*sumd)-((Aexp1d*Aexp2d)*sumd)*(qid*d_temp2_dTemp_Tnode_GND+d_qid_dTemp_Tnode_GND*temp2))/(qid*temp2)/(qid*temp2));
dqsqd_dxn_qi = (((Aexp1d*Aexp2d)*sumd)/(qid*temp2));
}
}
{
double value_log_0 = log(qid);
double  deriv_log_0_d0 = (1.0/qid);

d_xdriftd_dV_S_B = (d_xdeff_dV_S_B+(deriv_log_0_d0*(d_qid_dV_S_B)));
d_xdriftd_dV_G_S = (d_xdeff_dV_G_S+(deriv_log_0_d0*(d_qid_dV_G_S)));
d_xdriftd_dTemp_Tnode_GND = (d_xdeff_dTemp_Tnode_GND+(deriv_log_0_d0*(d_qid_dTemp_Tnode_GND)));
d_xdriftd_dV_D_S = (d_xdeff_dV_D_S+(deriv_log_0_d0*(d_qid_dV_D_S)));
xdriftd = (xdeff+value_log_0);
}

d_qim_dV_S_B = 0.5*(d_qis_dV_S_B+d_qid_dV_S_B);
d_qim_dV_D_S = 0.5*(d_qis_dV_D_S+d_qid_dV_D_S);
d_qim_dV_G_S = 0.5*(d_qis_dV_G_S+d_qid_dV_G_S);
d_qim_dTemp_Tnode_GND = 0.5*(d_qis_dTemp_Tnode_GND+d_qid_dTemp_Tnode_GND);
qim = (0.5*(qis+qid));

d_dxdrift_dV_S_B = (d_xdriftd_dV_S_B-d_xdrifts_dV_S_B);
d_dxdrift_dV_G_S = (d_xdriftd_dV_G_S-d_xdrifts_dV_G_S);
d_dxdrift_dTemp_Tnode_GND = (d_xdriftd_dTemp_Tnode_GND-d_xdrifts_dTemp_Tnode_GND);
d_dxdrift_dV_D_S = (d_xdriftd_dV_D_S-d_xdrifts_dV_D_S);
dxdrift = (xdriftd-xdrifts);
if (((k1q1d/2.0)<80.0))
{
{
double value_exp_0 = exp((k1q1d/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp1_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1d_dV_S_B/2.0)))));
d_temp1_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1d_dTemp_Tnode_GND/2.0)))));
d_temp1_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1d_dV_D_S/2.0)))));
d_temp1_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k1q1d_dV_G_S/2.0)))));
temp1 = value_log_1;
}
}
else
{

d_temp1_dV_S_B = (d_k1q1d_dV_S_B/2.0);
d_temp1_dTemp_Tnode_GND = (d_k1q1d_dTemp_Tnode_GND/2.0);
d_temp1_dV_D_S = (d_k1q1d_dV_D_S/2.0);
d_temp1_dV_G_S = (d_k1q1d_dV_G_S/2.0);
temp1 = (k1q1d/2.0);
}

d_esurf1d_dTemp_Tnode_GND = 2.0*d_temp1_dTemp_Tnode_GND;
d_esurf1d_dV_D_S = 2.0*d_temp1_dV_D_S;
d_esurf1d_dV_G_S = 2.0*d_temp1_dV_G_S;
d_esurf1d_dV_S_B = 2.0*d_temp1_dV_S_B;
esurf1d = (2.0*temp1);
if (((k2q2d/2.0)<80.0))
{
{
double value_exp_0 = exp((k2q2d/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp2_dV_S_B = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2d_dV_S_B/2.0)))));
d_temp2_dTemp_Tnode_GND = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2d_dTemp_Tnode_GND/2.0)))));
d_temp2_dV_D_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2d_dV_D_S/2.0)))));
d_temp2_dV_G_S = (deriv_log_1_d0*((deriv_exp_0_d0*((d_k2q2d_dV_G_S/2.0)))));
temp2 = value_log_1;
}
}
else
{

d_temp2_dV_S_B = (d_k2q2d_dV_S_B/2.0);
d_temp2_dTemp_Tnode_GND = (d_k2q2d_dTemp_Tnode_GND/2.0);
d_temp2_dV_D_S = (d_k2q2d_dV_D_S/2.0);
d_temp2_dV_G_S = (d_k2q2d_dV_G_S/2.0);
temp2 = (k2q2d/2.0);
}

d_esurf2d_dV_S_B = 2.0*d_temp2_dV_S_B;
d_esurf2d_dV_D_S = 2.0*d_temp2_dV_D_S;
d_esurf2d_dTemp_Tnode_GND = 2.0*d_temp2_dTemp_Tnode_GND;
d_esurf2d_dV_G_S = 2.0*d_temp2_dV_G_S;
esurf2d = (2.0*temp2);

d_ecpl1d_dV_S_B = (d_esurf2d_dV_S_B-d_k2q2d_dV_S_B);
d_ecpl1d_dV_D_S = (d_esurf2d_dV_D_S-d_k2q2d_dV_D_S);
d_ecpl1d_dTemp_Tnode_GND = (d_esurf2d_dTemp_Tnode_GND-d_k2q2d_dTemp_Tnode_GND);
d_ecpl1d_dV_G_S = (d_esurf2d_dV_G_S-d_k2q2d_dV_G_S);
ecpl1d = (esurf2d-k2q2d);

d_ecpl2d_dTemp_Tnode_GND = (d_esurf1d_dTemp_Tnode_GND-d_k1q1d_dTemp_Tnode_GND);
d_ecpl2d_dV_D_S = (d_esurf1d_dV_D_S-d_k1q1d_dV_D_S);
d_ecpl2d_dV_G_S = (d_esurf1d_dV_G_S-d_k1q1d_dV_G_S);
d_ecpl2d_dV_S_B = (d_esurf1d_dV_S_B-d_k1q1d_dV_S_B);
ecpl2d = (esurf1d-k1q1d);

d_eeff1d_dTemp_Tnode_GND = (eta_mu*d_esurf1d_dTemp_Tnode_GND+one_m_eta*d_ecpl1d_dTemp_Tnode_GND);
d_eeff1d_dV_D_S = (eta_mu*d_esurf1d_dV_D_S+one_m_eta*d_ecpl1d_dV_D_S);
d_eeff1d_dV_G_S = (eta_mu*d_esurf1d_dV_G_S+one_m_eta*d_ecpl1d_dV_G_S);
d_eeff1d_dV_S_B = (eta_mu*d_esurf1d_dV_S_B+one_m_eta*d_ecpl1d_dV_S_B);
eeff1d = ((eta_mu*esurf1d)+(one_m_eta*ecpl1d));

d_eeff2d_dV_S_B = (eta_mu*d_esurf2d_dV_S_B+one_m_eta*d_ecpl2d_dV_S_B);
d_eeff2d_dV_D_S = (eta_mu*d_esurf2d_dV_D_S+one_m_eta*d_ecpl2d_dV_D_S);
d_eeff2d_dTemp_Tnode_GND = (eta_mu*d_esurf2d_dTemp_Tnode_GND+one_m_eta*d_ecpl2d_dTemp_Tnode_GND);
d_eeff2d_dV_G_S = (eta_mu*d_esurf2d_dV_G_S+one_m_eta*d_ecpl2d_dV_G_S);
eeff2d = ((eta_mu*esurf2d)+(one_m_eta*ecpl2d));

d_esurf1_dTemp_Tnode_GND = 0.5*(d_esurf1s_dTemp_Tnode_GND+d_esurf1d_dTemp_Tnode_GND);
d_esurf1_dV_D_S = 0.5*(d_esurf1s_dV_D_S+d_esurf1d_dV_D_S);
d_esurf1_dV_G_S = 0.5*(d_esurf1s_dV_G_S+d_esurf1d_dV_G_S);
d_esurf1_dV_S_B = 0.5*(d_esurf1s_dV_S_B+d_esurf1d_dV_S_B);
esurf1 = (0.5*(esurf1s+esurf1d));

d_esurf2_dV_S_B = 0.5*(d_esurf2s_dV_S_B+d_esurf2d_dV_S_B);
d_esurf2_dV_D_S = 0.5*(d_esurf2s_dV_D_S+d_esurf2d_dV_D_S);
d_esurf2_dTemp_Tnode_GND = 0.5*(d_esurf2s_dTemp_Tnode_GND+d_esurf2d_dTemp_Tnode_GND);
d_esurf2_dV_G_S = 0.5*(d_esurf2s_dV_G_S+d_esurf2d_dV_G_S);
esurf2 = (0.5*(esurf2s+esurf2d));

d_temp_dTemp_Tnode_GND = (-(d_esurf1_dTemp_Tnode_GND+d_esurf2_dTemp_Tnode_GND)/(esurf1+esurf2)/(esurf1+esurf2));
d_temp_dV_D_S = (-(d_esurf1_dV_D_S+d_esurf2_dV_D_S)/(esurf1+esurf2)/(esurf1+esurf2));
d_temp_dV_G_S = (-(d_esurf1_dV_G_S+d_esurf2_dV_G_S)/(esurf1+esurf2)/(esurf1+esurf2));
d_temp_dV_S_B = (-(d_esurf1_dV_S_B+d_esurf2_dV_S_B)/(esurf1+esurf2)/(esurf1+esurf2));
temp = (1.0/(esurf1+esurf2));

d_qi1m_dV_S_B = ((qim*esurf1)*d_temp_dV_S_B+(qim*d_esurf1_dV_S_B+d_qim_dV_S_B*esurf1)*temp);
d_qi1m_dV_D_S = ((qim*esurf1)*d_temp_dV_D_S+(qim*d_esurf1_dV_D_S+d_qim_dV_D_S*esurf1)*temp);
d_qi1m_dV_G_S = ((qim*esurf1)*d_temp_dV_G_S+(qim*d_esurf1_dV_G_S+d_qim_dV_G_S*esurf1)*temp);
d_qi1m_dTemp_Tnode_GND = ((qim*esurf1)*d_temp_dTemp_Tnode_GND+(qim*d_esurf1_dTemp_Tnode_GND+d_qim_dTemp_Tnode_GND*esurf1)*temp);
qi1m = ((qim*esurf1)*temp);

d_qi2m_dV_S_B = ((qim*esurf2)*d_temp_dV_S_B+(qim*d_esurf2_dV_S_B+d_qim_dV_S_B*esurf2)*temp);
d_qi2m_dV_D_S = ((qim*esurf2)*d_temp_dV_D_S+(qim*d_esurf2_dV_D_S+d_qim_dV_D_S*esurf2)*temp);
d_qi2m_dV_G_S = ((qim*esurf2)*d_temp_dV_G_S+(qim*d_esurf2_dV_G_S+d_qim_dV_G_S*esurf2)*temp);
d_qi2m_dTemp_Tnode_GND = ((qim*esurf2)*d_temp_dTemp_Tnode_GND+(qim*d_esurf2_dTemp_Tnode_GND+d_qim_dTemp_Tnode_GND*esurf2)*temp);
qi2m = ((qim*esurf2)*temp);

d_ecpl1_dV_S_B = 0.5*(d_ecpl1s_dV_S_B+d_ecpl1d_dV_S_B);
d_ecpl1_dV_D_S = 0.5*(d_ecpl1s_dV_D_S+d_ecpl1d_dV_D_S);
d_ecpl1_dTemp_Tnode_GND = 0.5*(d_ecpl1s_dTemp_Tnode_GND+d_ecpl1d_dTemp_Tnode_GND);
d_ecpl1_dV_G_S = 0.5*(d_ecpl1s_dV_G_S+d_ecpl1d_dV_G_S);
ecpl1 = (0.5*(ecpl1s+ecpl1d));

d_ecpl2_dTemp_Tnode_GND = 0.5*(d_ecpl2s_dTemp_Tnode_GND+d_ecpl2d_dTemp_Tnode_GND);
d_ecpl2_dV_D_S = 0.5*(d_ecpl2s_dV_D_S+d_ecpl2d_dV_D_S);
d_ecpl2_dV_G_S = 0.5*(d_ecpl2s_dV_G_S+d_ecpl2d_dV_G_S);
d_ecpl2_dV_S_B = 0.5*(d_ecpl2s_dV_S_B+d_ecpl2d_dV_S_B);
ecpl2 = (0.5*(ecpl2s+ecpl2d));

d_eeff1_dTemp_Tnode_GND = 0.5*(d_eeff1s_dTemp_Tnode_GND+d_eeff1d_dTemp_Tnode_GND);
d_eeff1_dV_D_S = 0.5*(d_eeff1s_dV_D_S+d_eeff1d_dV_D_S);
d_eeff1_dV_G_S = 0.5*(d_eeff1s_dV_G_S+d_eeff1d_dV_G_S);
d_eeff1_dV_S_B = 0.5*(d_eeff1s_dV_S_B+d_eeff1d_dV_S_B);
eeff1 = (0.5*(eeff1s+eeff1d));

d_eeff2_dV_S_B = 0.5*(d_eeff2s_dV_S_B+d_eeff2d_dV_S_B);
d_eeff2_dV_D_S = 0.5*(d_eeff2s_dV_D_S+d_eeff2d_dV_D_S);
d_eeff2_dTemp_Tnode_GND = 0.5*(d_eeff2s_dTemp_Tnode_GND+d_eeff2d_dTemp_Tnode_GND);
d_eeff2_dV_G_S = 0.5*(d_eeff2s_dV_G_S+d_eeff2d_dV_G_S);
eeff2 = (0.5*(eeff2s+eeff2d));

d_c1_dTemp_Tnode_GND = (esurf1*d_BETN1_i_dTemp_Tnode_GND+d_esurf1_dTemp_Tnode_GND*BETN1_i);
d_c1_dV_D_S = d_esurf1_dV_D_S*BETN1_i;
d_c1_dV_G_S = d_esurf1_dV_G_S*BETN1_i;
d_c1_dV_S_B = d_esurf1_dV_S_B*BETN1_i;
c1 = (esurf1*BETN1_i);

d_c2_dV_S_B = d_esurf2_dV_S_B*BETN2_i;
d_c2_dV_D_S = d_esurf2_dV_D_S*BETN2_i;
d_c2_dTemp_Tnode_GND = (esurf2*d_BETN2_i_dTemp_Tnode_GND+d_esurf2_dTemp_Tnode_GND*BETN2_i);
d_c2_dV_G_S = d_esurf2_dV_G_S*BETN2_i;
c2 = (esurf2*BETN2_i);

d_csum_dTemp_Tnode_GND = (d_c1_dTemp_Tnode_GND+d_c2_dTemp_Tnode_GND);
d_csum_dV_D_S = (d_c1_dV_D_S+d_c2_dV_D_S);
d_csum_dV_G_S = (d_c1_dV_G_S+d_c2_dV_G_S);
d_csum_dV_S_B = (d_c1_dV_S_B+d_c2_dV_S_B);
csum = (c1+c2);

d_betneff_dTemp_Tnode_GND = (csum*d_temp_dTemp_Tnode_GND+d_csum_dTemp_Tnode_GND*temp);
d_betneff_dV_D_S = (csum*d_temp_dV_D_S+d_csum_dV_D_S*temp);
d_betneff_dV_G_S = (csum*d_temp_dV_G_S+d_csum_dV_G_S*temp);
d_betneff_dV_S_B = (csum*d_temp_dV_S_B+d_csum_dV_S_B*temp);
betneff = (csum*temp);

d_temp1_dV_S_B = XCOR_i*(d_ecpl1_dV_S_B+XCORB_i*d_ecpl2_dV_S_B);
d_temp1_dV_D_S = XCOR_i*(d_ecpl1_dV_D_S+XCORB_i*d_ecpl2_dV_D_S);
d_temp1_dV_G_S = XCOR_i*(d_ecpl1_dV_G_S+XCORB_i*d_ecpl2_dV_G_S);
d_temp1_dTemp_Tnode_GND = (XCOR_i*(d_ecpl1_dTemp_Tnode_GND+XCORB_i*d_ecpl2_dTemp_Tnode_GND)+d_XCOR_i_dTemp_Tnode_GND*(ecpl1+(XCORB_i*ecpl2)));
temp1 = (XCOR_i*(ecpl1+(XCORB_i*ecpl2)));
{
double value_sqrt_0 = sqrt(((((1.0+temp1))*((1.0+temp1)))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp2_dTemp_Tnode_GND = 0.5*(d_temp1_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND*((1.0+temp1))))));
d_temp2_dV_D_S = 0.5*(d_temp1_dV_D_S+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dV_D_S+d_temp1_dV_D_S*((1.0+temp1))))));
d_temp2_dV_G_S = 0.5*(d_temp1_dV_G_S+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dV_G_S+d_temp1_dV_G_S*((1.0+temp1))))));
d_temp2_dV_S_B = 0.5*(d_temp1_dV_S_B+(deriv_sqrt_0_d0*((((1.0+temp1))*d_temp1_dV_S_B+d_temp1_dV_S_B*((1.0+temp1))))));
temp2 = (0.5*((1.0+temp1)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((1.0+(0.2*temp1)))*((1.0+(0.2*temp1))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp3_dTemp_Tnode_GND = 0.5*(0.2*d_temp1_dTemp_Tnode_GND+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dTemp_Tnode_GND+0.2*d_temp1_dTemp_Tnode_GND*((1.0+(0.2*temp1)))))));
d_temp3_dV_D_S = 0.5*(0.2*d_temp1_dV_D_S+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dV_D_S+0.2*d_temp1_dV_D_S*((1.0+(0.2*temp1)))))));
d_temp3_dV_G_S = 0.5*(0.2*d_temp1_dV_G_S+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dV_G_S+0.2*d_temp1_dV_G_S*((1.0+(0.2*temp1)))))));
d_temp3_dV_S_B = 0.5*(0.2*d_temp1_dV_S_B+(deriv_sqrt_0_d0*((((1.0+(0.2*temp1)))*0.2*d_temp1_dV_S_B+0.2*d_temp1_dV_S_B*((1.0+(0.2*temp1)))))));
temp3 = (0.5*((1.0+(0.2*temp1))+value_sqrt_0));
}

d_fcor_dV_S_B = ((temp3*d_temp2_dV_S_B-temp2*d_temp3_dV_S_B)/temp3/temp3);
d_fcor_dV_D_S = ((temp3*d_temp2_dV_D_S-temp2*d_temp3_dV_D_S)/temp3/temp3);
d_fcor_dTemp_Tnode_GND = ((temp3*d_temp2_dTemp_Tnode_GND-temp2*d_temp3_dTemp_Tnode_GND)/temp3/temp3);
d_fcor_dV_G_S = ((temp3*d_temp2_dV_G_S-temp2*d_temp3_dV_G_S)/temp3/temp3);
fcor = (temp2/temp3);
{
double value_log_0 = log(((1.0+(qi1m*inv_qi1cs))+(qi2m*inv_qi2cs)));
double value_exp_1 = exp(((-THECS_i)*value_log_0));
double  deriv_log_0_d0 = (1.0/((1.0+(qi1m*inv_qi1cs))+(qi2m*inv_qi2cs)));
double  deriv_exp_1_d0 = value_exp_1;

d_Gcs_dV_S_B = ((CS_i*((1.0+(CSFI_i*ecpl1))+(CSBI_i*ecpl2)))*(deriv_exp_1_d0*((-THECS_i)*(deriv_log_0_d0*((d_qi1m_dV_S_B*inv_qi1cs+d_qi2m_dV_S_B*inv_qi2cs)))))+CS_i*(CSFI_i*d_ecpl1_dV_S_B+CSBI_i*d_ecpl2_dV_S_B)*value_exp_1);
d_Gcs_dV_D_S = ((CS_i*((1.0+(CSFI_i*ecpl1))+(CSBI_i*ecpl2)))*(deriv_exp_1_d0*((-THECS_i)*(deriv_log_0_d0*((d_qi1m_dV_D_S*inv_qi1cs+d_qi2m_dV_D_S*inv_qi2cs)))))+CS_i*(CSFI_i*d_ecpl1_dV_D_S+CSBI_i*d_ecpl2_dV_D_S)*value_exp_1);
d_Gcs_dV_G_S = ((CS_i*((1.0+(CSFI_i*ecpl1))+(CSBI_i*ecpl2)))*(deriv_exp_1_d0*((-THECS_i)*(deriv_log_0_d0*((d_qi1m_dV_G_S*inv_qi1cs+d_qi2m_dV_G_S*inv_qi2cs)))))+CS_i*(CSFI_i*d_ecpl1_dV_G_S+CSBI_i*d_ecpl2_dV_G_S)*value_exp_1);
d_Gcs_dTemp_Tnode_GND = ((CS_i*((1.0+(CSFI_i*ecpl1))+(CSBI_i*ecpl2)))*(deriv_exp_1_d0*(((-THECS_i)*(deriv_log_0_d0*((d_qi1m_dTemp_Tnode_GND*inv_qi1cs+d_qi2m_dTemp_Tnode_GND*inv_qi2cs)))+(-d_THECS_i_dTemp_Tnode_GND)*value_log_0)))+(CS_i*(CSFI_i*d_ecpl1_dTemp_Tnode_GND+CSBI_i*d_ecpl2_dTemp_Tnode_GND)+d_CS_i_dTemp_Tnode_GND*((1.0+(CSFI_i*ecpl1))+(CSBI_i*ecpl2)))*value_exp_1);
Gcs = ((CS_i*((1.0+(CSFI_i*ecpl1))+(CSBI_i*ecpl2)))*value_exp_1);
}
if ((RSG_i==0.0))
{

d_temp3_dV_G_S = d_temp3_dV_D_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
temp3 = 1.0;
}
else
{
if ((RSG_i<0.0))
{
{
double value_log_0 = log((qim+1.0e-12));
double value_exp_1 = exp((THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(qim+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;

d_temp1_dV_S_B = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dV_S_B))));
d_temp1_dV_D_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dV_D_S))));
d_temp1_dV_G_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dV_G_S))));
d_temp1_dTemp_Tnode_GND = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dTemp_Tnode_GND))));
temp1 = (RSG_i*value_exp_1);
}

d_temp3_dTemp_Tnode_GND = (-d_temp1_dTemp_Tnode_GND);
d_temp3_dV_D_S = (-d_temp1_dV_D_S);
d_temp3_dV_G_S = (-d_temp1_dV_G_S);
d_temp3_dV_S_B = (-d_temp1_dV_S_B);
temp3 = (1.0-temp1);
}
else
{
{
double value_log_0 = log((qim+1.0e-12));
double value_exp_1 = exp((THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(qim+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;

d_temp1_dV_S_B = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dV_S_B))));
d_temp1_dV_D_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dV_D_S))));
d_temp1_dV_G_S = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dV_G_S))));
d_temp1_dTemp_Tnode_GND = RSG_i*(deriv_exp_1_d0*(THERSG_i*(deriv_log_0_d0*(d_qim_dTemp_Tnode_GND))));
temp1 = (RSG_i*value_exp_1);
}

d_temp3_dTemp_Tnode_GND = (-d_temp1_dTemp_Tnode_GND/(1.0+temp1)/(1.0+temp1));
d_temp3_dV_D_S = (-d_temp1_dV_D_S/(1.0+temp1)/(1.0+temp1));
d_temp3_dV_G_S = (-d_temp1_dV_G_S/(1.0+temp1)/(1.0+temp1));
d_temp3_dV_S_B = (-d_temp1_dV_S_B/(1.0+temp1)/(1.0+temp1));
temp3 = (1.0/(1.0+temp1));
}
}

d_Grs_dV_S_B = (frscsi*(qim*d_temp3_dV_S_B+d_qim_dV_S_B*temp3)+d_frscsi_dV_S_B*((qim*temp3)+RSIG_i));
d_Grs_dV_D_S = (frscsi*(qim*d_temp3_dV_D_S+d_qim_dV_D_S*temp3)+d_frscsi_dV_D_S*((qim*temp3)+RSIG_i));
d_Grs_dV_G_S = (frscsi*(qim*d_temp3_dV_G_S+d_qim_dV_G_S*temp3)+d_frscsi_dV_G_S*((qim*temp3)+RSIG_i));
d_Grs_dTemp_Tnode_GND = (frscsi*(qim*d_temp3_dTemp_Tnode_GND+d_qim_dTemp_Tnode_GND*temp3)+d_frscsi_dTemp_Tnode_GND*((qim*temp3)+RSIG_i));
Grs = (frscsi*((qim*temp3)+RSIG_i));
{
double value_log_0 = log(((fmue*eeff1)+1.0e-6));
double value_exp_1 = exp((THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((fmue*eeff1)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;

d_Gmob1_dV_D_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff1_dV_D_S))))+d_Gcs_dV_D_S)+BETN1_i*d_Grs_dV_D_S);
d_Gmob1_dV_G_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff1_dV_G_S))))+d_Gcs_dV_G_S)+BETN1_i*d_Grs_dV_G_S);
d_Gmob1_dV_S_B = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff1_dV_S_B))))+d_Gcs_dV_S_B)+BETN1_i*d_Grs_dV_S_B);
d_Gmob1_dTemp_Tnode_GND = (((deriv_exp_1_d0*((THEMU_i*(deriv_log_0_d0*((fmue*d_eeff1_dTemp_Tnode_GND+d_fmue_dTemp_Tnode_GND*eeff1)))+d_THEMU_i_dTemp_Tnode_GND*value_log_0)))+d_Gcs_dTemp_Tnode_GND)+(BETN1_i*d_Grs_dTemp_Tnode_GND+d_BETN1_i_dTemp_Tnode_GND*Grs));
Gmob1 = (((1.0+value_exp_1)+Gcs)+(BETN1_i*Grs));
}
{
double value_log_0 = log(((fmue*eeff2)+1.0e-6));
double value_exp_1 = exp((THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((fmue*eeff2)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;

d_Gmob2_dV_S_B = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff2_dV_S_B))))+d_Gcs_dV_S_B)+BETN2_i*d_Grs_dV_S_B);
d_Gmob2_dV_D_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff2_dV_D_S))))+d_Gcs_dV_D_S)+BETN2_i*d_Grs_dV_D_S);
d_Gmob2_dV_G_S = (((deriv_exp_1_d0*(THEMU_i*(deriv_log_0_d0*(fmue*d_eeff2_dV_G_S))))+d_Gcs_dV_G_S)+BETN2_i*d_Grs_dV_G_S);
d_Gmob2_dTemp_Tnode_GND = (((deriv_exp_1_d0*((THEMU_i*(deriv_log_0_d0*((fmue*d_eeff2_dTemp_Tnode_GND+d_fmue_dTemp_Tnode_GND*eeff2)))+d_THEMU_i_dTemp_Tnode_GND*value_log_0)))+d_Gcs_dTemp_Tnode_GND)+(BETN2_i*d_Grs_dTemp_Tnode_GND+d_BETN2_i_dTemp_Tnode_GND*Grs));
Gmob2 = (((1.0+value_exp_1)+Gcs)+(BETN2_i*Grs));
}

d_Gmob_dV_S_B = ((((c1/Gmob1)+(c2/Gmob2))*(fcor*d_csum_dV_S_B+d_fcor_dV_S_B*csum)-(fcor*csum)*(((Gmob1*d_c1_dV_S_B-c1*d_Gmob1_dV_S_B)/Gmob1/Gmob1)+((Gmob2*d_c2_dV_S_B-c2*d_Gmob2_dV_S_B)/Gmob2/Gmob2)))/((c1/Gmob1)+(c2/Gmob2))/((c1/Gmob1)+(c2/Gmob2)));
d_Gmob_dV_D_S = ((((c1/Gmob1)+(c2/Gmob2))*(fcor*d_csum_dV_D_S+d_fcor_dV_D_S*csum)-(fcor*csum)*(((Gmob1*d_c1_dV_D_S-c1*d_Gmob1_dV_D_S)/Gmob1/Gmob1)+((Gmob2*d_c2_dV_D_S-c2*d_Gmob2_dV_D_S)/Gmob2/Gmob2)))/((c1/Gmob1)+(c2/Gmob2))/((c1/Gmob1)+(c2/Gmob2)));
d_Gmob_dTemp_Tnode_GND = ((((c1/Gmob1)+(c2/Gmob2))*(fcor*d_csum_dTemp_Tnode_GND+d_fcor_dTemp_Tnode_GND*csum)-(fcor*csum)*(((Gmob1*d_c1_dTemp_Tnode_GND-c1*d_Gmob1_dTemp_Tnode_GND)/Gmob1/Gmob1)+((Gmob2*d_c2_dTemp_Tnode_GND-c2*d_Gmob2_dTemp_Tnode_GND)/Gmob2/Gmob2)))/((c1/Gmob1)+(c2/Gmob2))/((c1/Gmob1)+(c2/Gmob2)));
d_Gmob_dV_G_S = ((((c1/Gmob1)+(c2/Gmob2))*(fcor*d_csum_dV_G_S+d_fcor_dV_G_S*csum)-(fcor*csum)*(((Gmob1*d_c1_dV_G_S-c1*d_Gmob1_dV_G_S)/Gmob1/Gmob1)+((Gmob2*d_c2_dV_G_S-c2*d_Gmob2_dV_G_S)/Gmob2/Gmob2)))/((c1/Gmob1)+(c2/Gmob2))/((c1/Gmob1)+(c2/Gmob2)));
Gmob = ((fcor*csum)/((c1/Gmob1)+(c2/Gmob2)));

d_inv_qimstar1_dV_S_B = (-d_qim_dV_S_B/(4.0+qim)/(4.0+qim));
d_inv_qimstar1_dV_D_S = (-d_qim_dV_D_S/(4.0+qim)/(4.0+qim));
d_inv_qimstar1_dV_G_S = (-d_qim_dV_G_S/(4.0+qim)/(4.0+qim));
d_inv_qimstar1_dTemp_Tnode_GND = (-d_qim_dTemp_Tnode_GND/(4.0+qim)/(4.0+qim));
inv_qimstar1 = (1.0/(4.0+qim));
if ((ALPB_i>0))
{

d_temp_dV_S_B = (-ALPB_i*d_qi2m_dV_S_B/(1.0+(ALPB_i*qi2m))/(1.0+(ALPB_i*qi2m)));
d_temp_dV_D_S = (-ALPB_i*d_qi2m_dV_D_S/(1.0+(ALPB_i*qi2m))/(1.0+(ALPB_i*qi2m)));
d_temp_dV_G_S = (-ALPB_i*d_qi2m_dV_G_S/(1.0+(ALPB_i*qi2m))/(1.0+(ALPB_i*qi2m)));
d_temp_dTemp_Tnode_GND = (-ALPB_i*d_qi2m_dTemp_Tnode_GND/(1.0+(ALPB_i*qi2m))/(1.0+(ALPB_i*qi2m)));
temp = (1.0/(1.0+(ALPB_i*qi2m)));
}
else
{

d_temp_dV_S_B = (-ALPB_i*d_qi2m_dV_S_B);
d_temp_dV_D_S = (-ALPB_i*d_qi2m_dV_D_S);
d_temp_dV_G_S = (-ALPB_i*d_qi2m_dV_G_S);
d_temp_dTemp_Tnode_GND = (-ALPB_i*d_qi2m_dTemp_Tnode_GND);
temp = (1.0-(ALPB_i*qi2m));
}

d_r1_dV_S_B = ((qim*inv_qimstar1)*d_temp_dV_S_B+(qim*d_inv_qimstar1_dV_S_B+d_qim_dV_S_B*inv_qimstar1)*temp);
d_r1_dV_D_S = ((qim*inv_qimstar1)*d_temp_dV_D_S+(qim*d_inv_qimstar1_dV_D_S+d_qim_dV_D_S*inv_qimstar1)*temp);
d_r1_dV_G_S = ((qim*inv_qimstar1)*d_temp_dV_G_S+(qim*d_inv_qimstar1_dV_G_S+d_qim_dV_G_S*inv_qimstar1)*temp);
d_r1_dTemp_Tnode_GND = ((qim*inv_qimstar1)*d_temp_dTemp_Tnode_GND+(qim*d_inv_qimstar1_dTemp_Tnode_GND+d_qim_dTemp_Tnode_GND*inv_qimstar1)*temp);
r1 = ((qim*inv_qimstar1)*temp);
{
double value_log_0 = log((1.0+((xd-xdeff)/((VP_i*inv_phit)+((VPG_i*qim)*qim)))));
double  deriv_log_0_d0 = (1.0/(1.0+((xd-xdeff)/((VP_i*inv_phit)+((VPG_i*qim)*qim)))));

d_temp1_dV_S_B = (value_log_0*d_r1_dV_S_B+(deriv_log_0_d0*(((((VP_i*inv_phit)+((VPG_i*qim)*qim))*(-d_xdeff_dV_S_B)-(xd-xdeff)*((VPG_i*qim)*d_qim_dV_S_B+VPG_i*d_qim_dV_S_B*qim))/((VP_i*inv_phit)+((VPG_i*qim)*qim))/((VP_i*inv_phit)+((VPG_i*qim)*qim)))))*r1);
d_temp1_dV_G_S = (value_log_0*d_r1_dV_G_S+(deriv_log_0_d0*(((((VP_i*inv_phit)+((VPG_i*qim)*qim))*(-d_xdeff_dV_G_S)-(xd-xdeff)*((VPG_i*qim)*d_qim_dV_G_S+VPG_i*d_qim_dV_G_S*qim))/((VP_i*inv_phit)+((VPG_i*qim)*qim))/((VP_i*inv_phit)+((VPG_i*qim)*qim)))))*r1);
d_temp1_dTemp_Tnode_GND = (value_log_0*d_r1_dTemp_Tnode_GND+(deriv_log_0_d0*(((((VP_i*inv_phit)+((VPG_i*qim)*qim))*(d_xd_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)-(xd-xdeff)*(VP_i*d_inv_phit_dTemp_Tnode_GND+((VPG_i*qim)*d_qim_dTemp_Tnode_GND+VPG_i*d_qim_dTemp_Tnode_GND*qim)))/((VP_i*inv_phit)+((VPG_i*qim)*qim))/((VP_i*inv_phit)+((VPG_i*qim)*qim)))))*r1);
d_temp1_dV_D_S = (value_log_0*d_r1_dV_D_S+(deriv_log_0_d0*(((((VP_i*inv_phit)+((VPG_i*qim)*qim))*(d_xd_dV_D_S-d_xdeff_dV_D_S)-(xd-xdeff)*((VPG_i*qim)*d_qim_dV_D_S+VPG_i*d_qim_dV_D_S*qim))/((VP_i*inv_phit)+((VPG_i*qim)*qim))/((VP_i*inv_phit)+((VPG_i*qim)*qim)))))*r1);
temp1 = (value_log_0*r1);
}

d_dL_L_dTemp_Tnode_GND = ALP_i*d_temp1_dTemp_Tnode_GND;
d_dL_L_dV_D_S = ALP_i*d_temp1_dV_D_S;
d_dL_L_dV_G_S = ALP_i*d_temp1_dV_G_S;
d_dL_L_dV_S_B = ALP_i*d_temp1_dV_S_B;
dL_L = (ALP_i*temp1);

d_GdL_dTemp_Tnode_GND = (-(dL_L*d_dL_L_dTemp_Tnode_GND+d_dL_L_dTemp_Tnode_GND*(1.0+dL_L))/(1.0+(dL_L*(1.0+dL_L)))/(1.0+(dL_L*(1.0+dL_L))));
d_GdL_dV_D_S = (-(dL_L*d_dL_L_dV_D_S+d_dL_L_dV_D_S*(1.0+dL_L))/(1.0+(dL_L*(1.0+dL_L)))/(1.0+(dL_L*(1.0+dL_L))));
d_GdL_dV_G_S = (-(dL_L*d_dL_L_dV_G_S+d_dL_L_dV_G_S*(1.0+dL_L))/(1.0+(dL_L*(1.0+dL_L)))/(1.0+(dL_L*(1.0+dL_L))));
d_GdL_dV_S_B = (-(dL_L*d_dL_L_dV_S_B+d_dL_L_dV_S_B*(1.0+dL_L))/(1.0+(dL_L*(1.0+dL_L)))/(1.0+(dL_L*(1.0+dL_L))));
GdL = (1.0/(1.0+(dL_L*(1.0+dL_L))));

d_dL1_L_dV_S_B = ((ALP_i+(alp1_phit*inv_qimstar1))*d_temp1_dV_S_B+alp1_phit*d_inv_qimstar1_dV_S_B*temp1);
d_dL1_L_dV_D_S = ((ALP_i+(alp1_phit*inv_qimstar1))*d_temp1_dV_D_S+alp1_phit*d_inv_qimstar1_dV_D_S*temp1);
d_dL1_L_dV_G_S = ((ALP_i+(alp1_phit*inv_qimstar1))*d_temp1_dV_G_S+alp1_phit*d_inv_qimstar1_dV_G_S*temp1);
d_dL1_L_dTemp_Tnode_GND = ((ALP_i+(alp1_phit*inv_qimstar1))*d_temp1_dTemp_Tnode_GND+(alp1_phit*d_inv_qimstar1_dTemp_Tnode_GND+d_alp1_phit_dTemp_Tnode_GND*inv_qimstar1)*temp1);
dL1_L = ((ALP_i+(alp1_phit*inv_qimstar1))*temp1);

d_FdL_dV_S_B = ((1.0+(dL1_L*(1.0+dL1_L)))*d_GdL_dV_S_B+(dL1_L*d_dL1_L_dV_S_B+d_dL1_L_dV_S_B*(1.0+dL1_L))*GdL);
d_FdL_dV_D_S = ((1.0+(dL1_L*(1.0+dL1_L)))*d_GdL_dV_D_S+(dL1_L*d_dL1_L_dV_D_S+d_dL1_L_dV_D_S*(1.0+dL1_L))*GdL);
d_FdL_dV_G_S = ((1.0+(dL1_L*(1.0+dL1_L)))*d_GdL_dV_G_S+(dL1_L*d_dL1_L_dV_G_S+d_dL1_L_dV_G_S*(1.0+dL1_L))*GdL);
d_FdL_dTemp_Tnode_GND = ((1.0+(dL1_L*(1.0+dL1_L)))*d_GdL_dTemp_Tnode_GND+(dL1_L*d_dL1_L_dTemp_Tnode_GND+d_dL1_L_dTemp_Tnode_GND*(1.0+dL1_L))*GdL);
FdL = ((1.0+(dL1_L*(1.0+dL1_L)))*GdL);

d_wsat1_dTemp_Tnode_GND = (((100.0+esurf1)*100.0*d_esurf1_dTemp_Tnode_GND-(100.0*esurf1)*d_esurf1_dTemp_Tnode_GND)/(100.0+esurf1)/(100.0+esurf1));
d_wsat1_dV_D_S = (((100.0+esurf1)*100.0*d_esurf1_dV_D_S-(100.0*esurf1)*d_esurf1_dV_D_S)/(100.0+esurf1)/(100.0+esurf1));
d_wsat1_dV_G_S = (((100.0+esurf1)*100.0*d_esurf1_dV_G_S-(100.0*esurf1)*d_esurf1_dV_G_S)/(100.0+esurf1)/(100.0+esurf1));
d_wsat1_dV_S_B = (((100.0+esurf1)*100.0*d_esurf1_dV_S_B-(100.0*esurf1)*d_esurf1_dV_S_B)/(100.0+esurf1)/(100.0+esurf1));
wsat1 = ((100.0*esurf1)/(100.0+esurf1));
if ((THESAT1_i<0.0))
{

d_sat_fact1_dTemp_Tnode_GND = (-(-THESAT1_i*d_wsat1_dTemp_Tnode_GND)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
d_sat_fact1_dV_D_S = (-(-THESAT1_i*d_wsat1_dV_D_S)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
d_sat_fact1_dV_G_S = (-(-THESAT1_i*d_wsat1_dV_G_S)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
d_sat_fact1_dV_S_B = (-(-THESAT1_i*d_wsat1_dV_S_B)/(1.0-(THESAT1_i*wsat1))/(1.0-(THESAT1_i*wsat1)));
sat_fact1 = (1.0/(1.0-(THESAT1_i*wsat1)));
}
else
{

d_sat_fact1_dTemp_Tnode_GND = THESAT1_i*d_wsat1_dTemp_Tnode_GND;
d_sat_fact1_dV_D_S = THESAT1_i*d_wsat1_dV_D_S;
d_sat_fact1_dV_G_S = THESAT1_i*d_wsat1_dV_G_S;
d_sat_fact1_dV_S_B = THESAT1_i*d_wsat1_dV_S_B;
sat_fact1 = (1.0+(THESAT1_i*wsat1));
}

d_wsat2_dV_S_B = (((100.0+esurf2)*100.0*d_esurf2_dV_S_B-(100.0*esurf2)*d_esurf2_dV_S_B)/(100.0+esurf2)/(100.0+esurf2));
d_wsat2_dV_D_S = (((100.0+esurf2)*100.0*d_esurf2_dV_D_S-(100.0*esurf2)*d_esurf2_dV_D_S)/(100.0+esurf2)/(100.0+esurf2));
d_wsat2_dTemp_Tnode_GND = (((100.0+esurf2)*100.0*d_esurf2_dTemp_Tnode_GND-(100.0*esurf2)*d_esurf2_dTemp_Tnode_GND)/(100.0+esurf2)/(100.0+esurf2));
d_wsat2_dV_G_S = (((100.0+esurf2)*100.0*d_esurf2_dV_G_S-(100.0*esurf2)*d_esurf2_dV_G_S)/(100.0+esurf2)/(100.0+esurf2));
wsat2 = ((100.0*esurf2)/(100.0+esurf2));
if ((THESAT2_i<0.0))
{

d_sat_fact2_dV_S_B = (-(-THESAT2_i*d_wsat2_dV_S_B)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
d_sat_fact2_dV_D_S = (-(-THESAT2_i*d_wsat2_dV_D_S)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
d_sat_fact2_dTemp_Tnode_GND = (-(-THESAT2_i*d_wsat2_dTemp_Tnode_GND)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
d_sat_fact2_dV_G_S = (-(-THESAT2_i*d_wsat2_dV_G_S)/(1.0-(THESAT2_i*wsat2))/(1.0-(THESAT2_i*wsat2)));
sat_fact2 = (1.0/(1.0-(THESAT2_i*wsat2)));
}
else
{

d_sat_fact2_dV_S_B = THESAT2_i*d_wsat2_dV_S_B;
d_sat_fact2_dV_D_S = THESAT2_i*d_wsat2_dV_D_S;
d_sat_fact2_dTemp_Tnode_GND = THESAT2_i*d_wsat2_dTemp_Tnode_GND;
d_sat_fact2_dV_G_S = THESAT2_i*d_wsat2_dV_G_S;
sat_fact2 = (1.0+(THESAT2_i*wsat2));
}

d_Ggamma_dV_S_B = (((sat_phit*dxdrift)*0.5)*(d_sat_fact1_dV_S_B+d_sat_fact2_dV_S_B)+sat_phit*d_dxdrift_dV_S_B*0.5*(sat_fact1+sat_fact2));
d_Ggamma_dV_G_S = (((sat_phit*dxdrift)*0.5)*(d_sat_fact1_dV_G_S+d_sat_fact2_dV_G_S)+sat_phit*d_dxdrift_dV_G_S*0.5*(sat_fact1+sat_fact2));
d_Ggamma_dV_D_S = (((sat_phit*dxdrift)*0.5)*(d_sat_fact1_dV_D_S+d_sat_fact2_dV_D_S)+sat_phit*d_dxdrift_dV_D_S*0.5*(sat_fact1+sat_fact2));
d_Ggamma_dTemp_Tnode_GND = (((sat_phit*dxdrift)*0.5)*(d_sat_fact1_dTemp_Tnode_GND+d_sat_fact2_dTemp_Tnode_GND)+(sat_phit*d_dxdrift_dTemp_Tnode_GND+d_sat_phit_dTemp_Tnode_GND*dxdrift)*0.5*(sat_fact1+sat_fact2));
Ggamma = (((sat_phit*dxdrift)*0.5)*(sat_fact1+sat_fact2));

d_sqrt_zsat_dV_S_B = (((Gmob*GdL)*d_Ggamma_dV_S_B-Ggamma*(Gmob*d_GdL_dV_S_B+d_Gmob_dV_S_B*GdL))/(Gmob*GdL)/(Gmob*GdL));
d_sqrt_zsat_dV_G_S = (((Gmob*GdL)*d_Ggamma_dV_G_S-Ggamma*(Gmob*d_GdL_dV_G_S+d_Gmob_dV_G_S*GdL))/(Gmob*GdL)/(Gmob*GdL));
d_sqrt_zsat_dV_D_S = (((Gmob*GdL)*d_Ggamma_dV_D_S-Ggamma*(Gmob*d_GdL_dV_D_S+d_Gmob_dV_D_S*GdL))/(Gmob*GdL)/(Gmob*GdL));
d_sqrt_zsat_dTemp_Tnode_GND = (((Gmob*GdL)*d_Ggamma_dTemp_Tnode_GND-Ggamma*(Gmob*d_GdL_dTemp_Tnode_GND+d_Gmob_dTemp_Tnode_GND*GdL))/(Gmob*GdL)/(Gmob*GdL));
sqrt_zsat = (Ggamma/(Gmob*GdL));

d_zsat_dV_S_B = (sqrt_zsat*d_sqrt_zsat_dV_S_B+d_sqrt_zsat_dV_S_B*sqrt_zsat);
d_zsat_dV_G_S = (sqrt_zsat*d_sqrt_zsat_dV_G_S+d_sqrt_zsat_dV_G_S*sqrt_zsat);
d_zsat_dV_D_S = (sqrt_zsat*d_sqrt_zsat_dV_D_S+d_sqrt_zsat_dV_D_S*sqrt_zsat);
d_zsat_dTemp_Tnode_GND = (sqrt_zsat*d_sqrt_zsat_dTemp_Tnode_GND+d_sqrt_zsat_dTemp_Tnode_GND*sqrt_zsat);
zsat = (sqrt_zsat*sqrt_zsat);
{
double value_sqrt_0 = sqrt((1.0+zsat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vsat_fact_dV_S_B = (deriv_sqrt_0_d0*(d_zsat_dV_S_B));
d_vsat_fact_dV_G_S = (deriv_sqrt_0_d0*(d_zsat_dV_G_S));
d_vsat_fact_dV_D_S = (deriv_sqrt_0_d0*(d_zsat_dV_D_S));
d_vsat_fact_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(d_zsat_dTemp_Tnode_GND));
vsat_fact = value_sqrt_0;
}

d_hsat_dV_S_B = ((vsat_fact*1.5*d_zsat_dV_S_B-(1.0+(1.5*zsat))*d_vsat_fact_dV_S_B)/vsat_fact/vsat_fact);
d_hsat_dV_G_S = ((vsat_fact*1.5*d_zsat_dV_G_S-(1.0+(1.5*zsat))*d_vsat_fact_dV_G_S)/vsat_fact/vsat_fact);
d_hsat_dV_D_S = ((vsat_fact*1.5*d_zsat_dV_D_S-(1.0+(1.5*zsat))*d_vsat_fact_dV_D_S)/vsat_fact/vsat_fact);
d_hsat_dTemp_Tnode_GND = ((vsat_fact*1.5*d_zsat_dTemp_Tnode_GND-(1.0+(1.5*zsat))*d_vsat_fact_dTemp_Tnode_GND)/vsat_fact/vsat_fact);
hsat = ((1.0+(1.5*zsat))/vsat_fact);

d_Gvsat_dV_S_B = ((Gmob*GdL)*d_vsat_fact_dV_S_B+(Gmob*d_GdL_dV_S_B+d_Gmob_dV_S_B*GdL)*vsat_fact);
d_Gvsat_dV_D_S = ((Gmob*GdL)*d_vsat_fact_dV_D_S+(Gmob*d_GdL_dV_D_S+d_Gmob_dV_D_S*GdL)*vsat_fact);
d_Gvsat_dTemp_Tnode_GND = ((Gmob*GdL)*d_vsat_fact_dTemp_Tnode_GND+(Gmob*d_GdL_dTemp_Tnode_GND+d_Gmob_dTemp_Tnode_GND*GdL)*vsat_fact);
d_Gvsat_dV_G_S = ((Gmob*GdL)*d_vsat_fact_dV_G_S+(Gmob*d_GdL_dV_G_S+d_Gmob_dV_G_S*GdL)*vsat_fact);
Gvsat = ((Gmob*GdL)*vsat_fact);
if (((model_.QMC)>0.0))
{
{
double value_log_0 = log(((esurf1*esurf1)+60.0));
double value_exp_1 = exp(((-0.1666666666667)*value_log_0));
double  deriv_log_0_d0 = (1.0/((esurf1*esurf1)+60.0));
double  deriv_exp_1_d0 = value_exp_1;

d_temp1_dV_D_S = (0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf1*d_esurf1_dV_D_S+d_esurf1_dV_D_S*esurf1)))));
d_temp1_dV_G_S = (0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf1*d_esurf1_dV_G_S+d_esurf1_dV_G_S*esurf1)))));
d_temp1_dV_S_B = (0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf1*d_esurf1_dV_S_B+d_esurf1_dV_S_B*esurf1)))));
d_temp1_dTemp_Tnode_GND = ((0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf1*d_esurf1_dTemp_Tnode_GND+d_esurf1_dTemp_Tnode_GND*esurf1)))))+0.6*d_qq_dTemp_Tnode_GND*value_exp_1);
temp1 = ((0.6*qq)*value_exp_1);
}
{
double value_log_0 = log(((esurf2*esurf2)+60.0));
double value_exp_1 = exp(((-0.1666666666667)*value_log_0));
double  deriv_log_0_d0 = (1.0/((esurf2*esurf2)+60.0));
double  deriv_exp_1_d0 = value_exp_1;

d_temp2_dV_S_B = (0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf2*d_esurf2_dV_S_B+d_esurf2_dV_S_B*esurf2)))));
d_temp2_dV_D_S = (0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf2*d_esurf2_dV_D_S+d_esurf2_dV_D_S*esurf2)))));
d_temp2_dV_G_S = (0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf2*d_esurf2_dV_G_S+d_esurf2_dV_G_S*esurf2)))));
d_temp2_dTemp_Tnode_GND = ((0.6*qq)*(deriv_exp_1_d0*((-0.1666666666667)*(deriv_log_0_d0*((esurf2*d_esurf2_dTemp_Tnode_GND+d_esurf2_dTemp_Tnode_GND*esurf2)))))+0.6*d_qq_dTemp_Tnode_GND*value_exp_1);
temp2 = ((0.6*qq)*value_exp_1);
}

d_qmfact1_dV_S_B = ((tox1fact*(k1*d_temp1_dV_S_B+d_k1_dV_S_B*temp1)-(1.0+(k1*temp1))*d_tox1fact_dV_S_B)/tox1fact/tox1fact);
d_qmfact1_dTemp_Tnode_GND = ((tox1fact*(k1*d_temp1_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*temp1)-(1.0+(k1*temp1))*d_tox1fact_dTemp_Tnode_GND)/tox1fact/tox1fact);
d_qmfact1_dV_D_S = ((tox1fact*(k1*d_temp1_dV_D_S+d_k1_dV_D_S*temp1)-(1.0+(k1*temp1))*d_tox1fact_dV_D_S)/tox1fact/tox1fact);
d_qmfact1_dV_G_S = ((tox1fact*(k1*d_temp1_dV_G_S+d_k1_dV_G_S*temp1)-(1.0+(k1*temp1))*d_tox1fact_dV_G_S)/tox1fact/tox1fact);
qmfact1 = ((1.0+(k1*temp1))/tox1fact);

d_qmfact2_dV_S_B = ((tox2fact*(k2*d_temp2_dV_S_B+d_k2_dV_S_B*temp2)-(1.0+(k2*temp2))*d_tox2fact_dV_S_B)/tox2fact/tox2fact);
d_qmfact2_dTemp_Tnode_GND = ((tox2fact*(k2*d_temp2_dTemp_Tnode_GND+d_k2_dTemp_Tnode_GND*temp2)-(1.0+(k2*temp2))*d_tox2fact_dTemp_Tnode_GND)/tox2fact/tox2fact);
d_qmfact2_dV_D_S = ((tox2fact*(k2*d_temp2_dV_D_S+d_k2_dV_D_S*temp2)-(1.0+(k2*temp2))*d_tox2fact_dV_D_S)/tox2fact/tox2fact);
d_qmfact2_dV_G_S = ((tox2fact*(k2*d_temp2_dV_G_S+d_k2_dV_G_S*temp2)-(1.0+(k2*temp2))*d_tox2fact_dV_G_S)/tox2fact/tox2fact);
qmfact2 = ((1.0+(k2*temp2))/tox2fact);

d_qmfact_dTemp_Tnode_GND = ((((esurf1/qmfact1)+(esurf2/qmfact2))*(d_esurf1_dTemp_Tnode_GND+d_esurf2_dTemp_Tnode_GND)-(esurf1+esurf2)*(((qmfact1*d_esurf1_dTemp_Tnode_GND-esurf1*d_qmfact1_dTemp_Tnode_GND)/qmfact1/qmfact1)+((qmfact2*d_esurf2_dTemp_Tnode_GND-esurf2*d_qmfact2_dTemp_Tnode_GND)/qmfact2/qmfact2)))/((esurf1/qmfact1)+(esurf2/qmfact2))/((esurf1/qmfact1)+(esurf2/qmfact2)));
d_qmfact_dV_D_S = ((((esurf1/qmfact1)+(esurf2/qmfact2))*(d_esurf1_dV_D_S+d_esurf2_dV_D_S)-(esurf1+esurf2)*(((qmfact1*d_esurf1_dV_D_S-esurf1*d_qmfact1_dV_D_S)/qmfact1/qmfact1)+((qmfact2*d_esurf2_dV_D_S-esurf2*d_qmfact2_dV_D_S)/qmfact2/qmfact2)))/((esurf1/qmfact1)+(esurf2/qmfact2))/((esurf1/qmfact1)+(esurf2/qmfact2)));
d_qmfact_dV_G_S = ((((esurf1/qmfact1)+(esurf2/qmfact2))*(d_esurf1_dV_G_S+d_esurf2_dV_G_S)-(esurf1+esurf2)*(((qmfact1*d_esurf1_dV_G_S-esurf1*d_qmfact1_dV_G_S)/qmfact1/qmfact1)+((qmfact2*d_esurf2_dV_G_S-esurf2*d_qmfact2_dV_G_S)/qmfact2/qmfact2)))/((esurf1/qmfact1)+(esurf2/qmfact2))/((esurf1/qmfact1)+(esurf2/qmfact2)));
d_qmfact_dV_S_B = ((((esurf1/qmfact1)+(esurf2/qmfact2))*(d_esurf1_dV_S_B+d_esurf2_dV_S_B)-(esurf1+esurf2)*(((qmfact1*d_esurf1_dV_S_B-esurf1*d_qmfact1_dV_S_B)/qmfact1/qmfact1)+((qmfact2*d_esurf2_dV_S_B-esurf2*d_qmfact2_dV_S_B)/qmfact2/qmfact2)))/((esurf1/qmfact1)+(esurf2/qmfact2))/((esurf1/qmfact1)+(esurf2/qmfact2)));
qmfact = ((esurf1+esurf2)/((esurf1/qmfact1)+(esurf2/qmfact2)));
}
else
{

d_qmfact1_dV_G_S = d_qmfact1_dV_D_S = d_qmfact1_dTemp_Tnode_GND = d_qmfact1_dV_S_B =  0.0;
qmfact1 = 1.0;

d_qmfact2_dV_G_S = d_qmfact2_dV_D_S = d_qmfact2_dTemp_Tnode_GND = d_qmfact2_dV_S_B =  0.0;
qmfact2 = 1.0;

d_qmfact_dV_S_B = d_qmfact_dV_G_S = d_qmfact_dV_D_S = d_qmfact_dTemp_Tnode_GND =  0.0;
qmfact = 1.0;
}
if ((qis>1.0E-6))
{
if ((qid>1.0E-6))
{

d_dqid_dxn_qi_dV_S_B = ((((a1d*a2d)*(dqsqd_dxn_qi*d_sumd_dV_S_B+d_dqsqd_dxn_qi_dV_S_B*sumd)-(dqsqd_dxn_qi*sumd)*(a1d*d_a2d_dV_S_B+d_a1d_dV_S_B*a2d))/(a1d*a2d)/(a1d*a2d))-((qid*(((a1d*d_Aexp1d_dV_S_B-Aexp1d*d_a1d_dV_S_B)/a1d/a1d)+((a2d*d_Aexp2d_dV_S_B-Aexp2d*d_a2d_dV_S_B)/a2d/a2d))-((Aexp1d/a1d)+(Aexp2d/a2d))*d_qid_dV_S_B)/qid/qid));
d_dqid_dxn_qi_dTemp_Tnode_GND = ((((a1d*a2d)*(dqsqd_dxn_qi*d_sumd_dTemp_Tnode_GND+d_dqsqd_dxn_qi_dTemp_Tnode_GND*sumd)-(dqsqd_dxn_qi*sumd)*(a1d*d_a2d_dTemp_Tnode_GND+d_a1d_dTemp_Tnode_GND*a2d))/(a1d*a2d)/(a1d*a2d))-((qid*(((a1d*d_Aexp1d_dTemp_Tnode_GND-Aexp1d*d_a1d_dTemp_Tnode_GND)/a1d/a1d)+((a2d*d_Aexp2d_dTemp_Tnode_GND-Aexp2d*d_a2d_dTemp_Tnode_GND)/a2d/a2d))-((Aexp1d/a1d)+(Aexp2d/a2d))*d_qid_dTemp_Tnode_GND)/qid/qid));
d_dqid_dxn_qi_dV_D_S = ((((a1d*a2d)*(dqsqd_dxn_qi*d_sumd_dV_D_S+d_dqsqd_dxn_qi_dV_D_S*sumd)-(dqsqd_dxn_qi*sumd)*(a1d*d_a2d_dV_D_S+d_a1d_dV_D_S*a2d))/(a1d*a2d)/(a1d*a2d))-((qid*(((a1d*d_Aexp1d_dV_D_S-Aexp1d*d_a1d_dV_D_S)/a1d/a1d)+((a2d*d_Aexp2d_dV_D_S-Aexp2d*d_a2d_dV_D_S)/a2d/a2d))-((Aexp1d/a1d)+(Aexp2d/a2d))*d_qid_dV_D_S)/qid/qid));
d_dqid_dxn_qi_dV_G_S = ((((a1d*a2d)*(dqsqd_dxn_qi*d_sumd_dV_G_S+d_dqsqd_dxn_qi_dV_G_S*sumd)-(dqsqd_dxn_qi*sumd)*(a1d*d_a2d_dV_G_S+d_a1d_dV_G_S*a2d))/(a1d*a2d)/(a1d*a2d))-((qid*(((a1d*d_Aexp1d_dV_G_S-Aexp1d*d_a1d_dV_G_S)/a1d/a1d)+((a2d*d_Aexp2d_dV_G_S-Aexp2d*d_a2d_dV_G_S)/a2d/a2d))-((Aexp1d/a1d)+(Aexp2d/a2d))*d_qid_dV_G_S)/qid/qid));
dqid_dxn_qi = (((dqsqd_dxn_qi*sumd)/(a1d*a2d))-(((Aexp1d/a1d)+(Aexp2d/a2d))/qid));

d_dd_dV_S_B = (((dqid_dxn_qi+1.0)*(dqid_dxn_qi*d_qid_dV_S_B+d_dqid_dxn_qi_dV_S_B*qid)-(dqid_dxn_qi*qid)*d_dqid_dxn_qi_dV_S_B)/(dqid_dxn_qi+1.0)/(dqid_dxn_qi+1.0));
d_dd_dTemp_Tnode_GND = (((dqid_dxn_qi+1.0)*(dqid_dxn_qi*d_qid_dTemp_Tnode_GND+d_dqid_dxn_qi_dTemp_Tnode_GND*qid)-(dqid_dxn_qi*qid)*d_dqid_dxn_qi_dTemp_Tnode_GND)/(dqid_dxn_qi+1.0)/(dqid_dxn_qi+1.0));
d_dd_dV_D_S = (((dqid_dxn_qi+1.0)*(dqid_dxn_qi*d_qid_dV_D_S+d_dqid_dxn_qi_dV_D_S*qid)-(dqid_dxn_qi*qid)*d_dqid_dxn_qi_dV_D_S)/(dqid_dxn_qi+1.0)/(dqid_dxn_qi+1.0));
d_dd_dV_G_S = (((dqid_dxn_qi+1.0)*(dqid_dxn_qi*d_qid_dV_G_S+d_dqid_dxn_qi_dV_G_S*qid)-(dqid_dxn_qi*qid)*d_dqid_dxn_qi_dV_G_S)/(dqid_dxn_qi+1.0)/(dqid_dxn_qi+1.0));
dd = ((dqid_dxn_qi*qid)/(dqid_dxn_qi+1.0));
}
else
{

d_dd_dV_S_B = d_dinf_dV_S_B;
d_dd_dTemp_Tnode_GND = d_dinf_dTemp_Tnode_GND;
d_dd_dV_D_S = d_dinf_dV_D_S;
d_dd_dV_G_S = d_dinf_dV_G_S;
dd = dinf;
}

d_temp1_dV_S_B = (d_dd_dV_S_B-d_ds_dV_S_B);
d_temp1_dTemp_Tnode_GND = (d_dd_dTemp_Tnode_GND-d_ds_dTemp_Tnode_GND);
d_temp1_dV_D_S = (d_dd_dV_D_S-d_ds_dV_D_S);
d_temp1_dV_G_S = (d_dd_dV_G_S-d_ds_dV_G_S);
temp1 = (dd-ds);

d_temp2_dTemp_Tnode_GND = ((36.0*temp1)*d_temp1_dTemp_Tnode_GND+36.0*d_temp1_dTemp_Tnode_GND*temp1);
d_temp2_dV_D_S = ((36.0*temp1)*d_temp1_dV_D_S+36.0*d_temp1_dV_D_S*temp1);
d_temp2_dV_G_S = ((36.0*temp1)*d_temp1_dV_G_S+36.0*d_temp1_dV_G_S*temp1);
d_temp2_dV_S_B = ((36.0*temp1)*d_temp1_dV_S_B+36.0*d_temp1_dV_S_B*temp1);
temp2 = (1.0+((36.0*temp1)*temp1));
if ((fabs(temp1)>1.0e-3))
{

d_temp3_dV_S_B = (d_qid_dV_S_B-d_qis_dV_S_B);
d_temp3_dV_D_S = (d_qid_dV_D_S-d_qis_dV_D_S);
d_temp3_dV_G_S = (d_qid_dV_G_S-d_qis_dV_G_S);
d_temp3_dTemp_Tnode_GND = (d_qid_dTemp_Tnode_GND-d_qis_dTemp_Tnode_GND);
temp3 = (qid-qis);

d_Ls_dV_S_B = (d_temp3_dV_S_B-(dd*d_dxdrift_dV_S_B+d_dd_dV_S_B*dxdrift));
d_Ls_dTemp_Tnode_GND = (d_temp3_dTemp_Tnode_GND-(dd*d_dxdrift_dTemp_Tnode_GND+d_dd_dTemp_Tnode_GND*dxdrift));
d_Ls_dV_D_S = (d_temp3_dV_D_S-(dd*d_dxdrift_dV_D_S+d_dd_dV_D_S*dxdrift));
d_Ls_dV_G_S = (d_temp3_dV_G_S-(dd*d_dxdrift_dV_G_S+d_dd_dV_G_S*dxdrift));
Ls = (temp3-(dd*dxdrift));

d_Ld_dV_S_B = (d_temp3_dV_S_B-(ds*d_dxdrift_dV_S_B+d_ds_dV_S_B*dxdrift));
d_Ld_dTemp_Tnode_GND = (d_temp3_dTemp_Tnode_GND-(ds*d_dxdrift_dTemp_Tnode_GND+d_ds_dTemp_Tnode_GND*dxdrift));
d_Ld_dV_D_S = (d_temp3_dV_D_S-(ds*d_dxdrift_dV_D_S+d_ds_dV_D_S*dxdrift));
d_Ld_dV_G_S = (d_temp3_dV_G_S-(ds*d_dxdrift_dV_G_S+d_ds_dV_G_S*dxdrift));
Ld = (temp3-(ds*dxdrift));
{
double value_sqrt_0 = sqrt(((Ls*Ls)+temp2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Us_dV_S_B = (deriv_sqrt_0_d0*(((Ls*d_Ls_dV_S_B+d_Ls_dV_S_B*Ls)+d_temp2_dV_S_B)));
d_Us_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((Ls*d_Ls_dTemp_Tnode_GND+d_Ls_dTemp_Tnode_GND*Ls)+d_temp2_dTemp_Tnode_GND)));
d_Us_dV_D_S = (deriv_sqrt_0_d0*(((Ls*d_Ls_dV_D_S+d_Ls_dV_D_S*Ls)+d_temp2_dV_D_S)));
d_Us_dV_G_S = (deriv_sqrt_0_d0*(((Ls*d_Ls_dV_G_S+d_Ls_dV_G_S*Ls)+d_temp2_dV_G_S)));
Us = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt(((Ld*Ld)+temp2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Ud_dV_S_B = (deriv_sqrt_0_d0*(((Ld*d_Ld_dV_S_B+d_Ld_dV_S_B*Ld)+d_temp2_dV_S_B)));
d_Ud_dTemp_Tnode_GND = (deriv_sqrt_0_d0*(((Ld*d_Ld_dTemp_Tnode_GND+d_Ld_dTemp_Tnode_GND*Ld)+d_temp2_dTemp_Tnode_GND)));
d_Ud_dV_D_S = (deriv_sqrt_0_d0*(((Ld*d_Ld_dV_D_S+d_Ld_dV_D_S*Ld)+d_temp2_dV_D_S)));
d_Ud_dV_G_S = (deriv_sqrt_0_d0*(((Ld*d_Ld_dV_G_S+d_Ld_dV_G_S*Ld)+d_temp2_dV_G_S)));
Ud = value_sqrt_0;
}
{
double value_log_0 = log(((Ld+Ud)/(Ls+Us)));
double  deriv_log_0_d0 = (1.0/((Ld+Ud)/(Ls+Us)));

d_idrift2_dTemp_Tnode_GND = ((0.25/temp1)*(((Ud*d_Ls_dTemp_Tnode_GND+d_Ud_dTemp_Tnode_GND*Ls)-(Us*d_Ld_dTemp_Tnode_GND+d_Us_dTemp_Tnode_GND*Ld))+(temp2*(deriv_log_0_d0*((((Ls+Us)*(d_Ld_dTemp_Tnode_GND+d_Ud_dTemp_Tnode_GND)-(Ld+Ud)*(d_Ls_dTemp_Tnode_GND+d_Us_dTemp_Tnode_GND))/(Ls+Us)/(Ls+Us))))+d_temp2_dTemp_Tnode_GND*value_log_0))+(-0.25*d_temp1_dTemp_Tnode_GND/temp1/temp1)*(((Ud*Ls)-(Us*Ld))+(temp2*value_log_0)));
d_idrift2_dV_D_S = ((0.25/temp1)*(((Ud*d_Ls_dV_D_S+d_Ud_dV_D_S*Ls)-(Us*d_Ld_dV_D_S+d_Us_dV_D_S*Ld))+(temp2*(deriv_log_0_d0*((((Ls+Us)*(d_Ld_dV_D_S+d_Ud_dV_D_S)-(Ld+Ud)*(d_Ls_dV_D_S+d_Us_dV_D_S))/(Ls+Us)/(Ls+Us))))+d_temp2_dV_D_S*value_log_0))+(-0.25*d_temp1_dV_D_S/temp1/temp1)*(((Ud*Ls)-(Us*Ld))+(temp2*value_log_0)));
d_idrift2_dV_G_S = ((0.25/temp1)*(((Ud*d_Ls_dV_G_S+d_Ud_dV_G_S*Ls)-(Us*d_Ld_dV_G_S+d_Us_dV_G_S*Ld))+(temp2*(deriv_log_0_d0*((((Ls+Us)*(d_Ld_dV_G_S+d_Ud_dV_G_S)-(Ld+Ud)*(d_Ls_dV_G_S+d_Us_dV_G_S))/(Ls+Us)/(Ls+Us))))+d_temp2_dV_G_S*value_log_0))+(-0.25*d_temp1_dV_G_S/temp1/temp1)*(((Ud*Ls)-(Us*Ld))+(temp2*value_log_0)));
d_idrift2_dV_S_B = ((0.25/temp1)*(((Ud*d_Ls_dV_S_B+d_Ud_dV_S_B*Ls)-(Us*d_Ld_dV_S_B+d_Us_dV_S_B*Ld))+(temp2*(deriv_log_0_d0*((((Ls+Us)*(d_Ld_dV_S_B+d_Ud_dV_S_B)-(Ld+Ud)*(d_Ls_dV_S_B+d_Us_dV_S_B))/(Ls+Us)/(Ls+Us))))+d_temp2_dV_S_B*value_log_0))+(-0.25*d_temp1_dV_S_B/temp1/temp1)*(((Ud*Ls)-(Us*Ld))+(temp2*value_log_0)));
idrift2 = ((0.25/temp1)*(((Ud*Ls)-(Us*Ld))+(temp2*value_log_0)));
}
}
else
{

d_temp3_dV_S_B = (dxdrift*d_temp1_dV_S_B+d_dxdrift_dV_S_B*temp1);
d_temp3_dV_G_S = (dxdrift*d_temp1_dV_G_S+d_dxdrift_dV_G_S*temp1);
d_temp3_dTemp_Tnode_GND = (dxdrift*d_temp1_dTemp_Tnode_GND+d_dxdrift_dTemp_Tnode_GND*temp1);
d_temp3_dV_D_S = (dxdrift*d_temp1_dV_D_S+d_dxdrift_dV_D_S*temp1);
temp3 = (dxdrift*temp1);
{
double value_sqrt_0 = sqrt(temp2);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_idrift2_dV_S_B = ((value_sqrt_0*(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*d_temp3_dV_S_B+((((-0.25)*0.1666666666667)*dxdrift)*d_temp3_dV_S_B+((-0.25)*0.1666666666667)*d_dxdrift_dV_S_B*temp3)*temp3)-(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*temp3)*(deriv_sqrt_0_d0*(d_temp2_dV_S_B)))/value_sqrt_0/value_sqrt_0);
d_idrift2_dV_G_S = ((value_sqrt_0*(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*d_temp3_dV_G_S+((((-0.25)*0.1666666666667)*dxdrift)*d_temp3_dV_G_S+((-0.25)*0.1666666666667)*d_dxdrift_dV_G_S*temp3)*temp3)-(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*temp3)*(deriv_sqrt_0_d0*(d_temp2_dV_G_S)))/value_sqrt_0/value_sqrt_0);
d_idrift2_dTemp_Tnode_GND = ((value_sqrt_0*(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*d_temp3_dTemp_Tnode_GND+((((-0.25)*0.1666666666667)*dxdrift)*d_temp3_dTemp_Tnode_GND+((-0.25)*0.1666666666667)*d_dxdrift_dTemp_Tnode_GND*temp3)*temp3)-(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*temp3)*(deriv_sqrt_0_d0*(d_temp2_dTemp_Tnode_GND)))/value_sqrt_0/value_sqrt_0);
d_idrift2_dV_D_S = ((value_sqrt_0*(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*d_temp3_dV_D_S+((((-0.25)*0.1666666666667)*dxdrift)*d_temp3_dV_D_S+((-0.25)*0.1666666666667)*d_dxdrift_dV_D_S*temp3)*temp3)-(((((-0.25)*0.1666666666667)*dxdrift)*temp3)*temp3)*(deriv_sqrt_0_d0*(d_temp2_dV_D_S)))/value_sqrt_0/value_sqrt_0);
idrift2 = ((((((-0.25)*0.1666666666667)*dxdrift)*temp3)*temp3)/value_sqrt_0);
}
}
}
else
{

d_dd_dV_S_B = d_dinf_dV_S_B;
d_dd_dTemp_Tnode_GND = d_dinf_dTemp_Tnode_GND;
d_dd_dV_D_S = d_dinf_dV_D_S;
d_dd_dV_G_S = d_dinf_dV_G_S;
dd = dinf;

d_idrift2_dV_S_B = d_idrift2_dV_G_S = d_idrift2_dV_D_S = d_idrift2_dTemp_Tnode_GND =  0.0;
idrift2 = 0.0;
}

d_norm_Ids_dV_S_B = ((((qim*d_dxdrift_dV_S_B+d_qim_dV_S_B*dxdrift)+d_idrift2_dV_S_B)+d_qis_dV_S_B)-d_qid_dV_S_B);
d_norm_Ids_dV_D_S = ((((qim*d_dxdrift_dV_D_S+d_qim_dV_D_S*dxdrift)+d_idrift2_dV_D_S)+d_qis_dV_D_S)-d_qid_dV_D_S);
d_norm_Ids_dV_G_S = ((((qim*d_dxdrift_dV_G_S+d_qim_dV_G_S*dxdrift)+d_idrift2_dV_G_S)+d_qis_dV_G_S)-d_qid_dV_G_S);
d_norm_Ids_dTemp_Tnode_GND = ((((qim*d_dxdrift_dTemp_Tnode_GND+d_qim_dTemp_Tnode_GND*dxdrift)+d_idrift2_dTemp_Tnode_GND)+d_qis_dTemp_Tnode_GND)-d_qid_dTemp_Tnode_GND);
norm_Ids = ((((qim*dxdrift)+idrift2)+qis)-qid);

d_fact_Ids_dV_D_S = (phit*phit)*d_betneff_dV_D_S;
d_fact_Ids_dV_G_S = (phit*phit)*d_betneff_dV_G_S;
d_fact_Ids_dV_S_B = (phit*phit)*d_betneff_dV_S_B;
d_fact_Ids_dTemp_Tnode_GND = ((phit*phit)*d_betneff_dTemp_Tnode_GND+(phit*d_phit_dTemp_Tnode_GND+d_phit_dTemp_Tnode_GND*phit)*betneff);
fact_Ids = ((phit*phit)*betneff);

d_Ids_dV_D_S = ((qmfact*((Gvsat*(((fact_Ids*CsiPrime)*norm_Ids)*d_FdL_dV_D_S+((fact_Ids*CsiPrime)*d_norm_Ids_dV_D_S+(fact_Ids*d_CsiPrime_dV_D_S+d_fact_Ids_dV_D_S*CsiPrime)*norm_Ids)*FdL)-(((fact_Ids*CsiPrime)*norm_Ids)*FdL)*d_Gvsat_dV_D_S)/Gvsat/Gvsat)-((((fact_Ids*CsiPrime)*norm_Ids)*FdL)/Gvsat)*d_qmfact_dV_D_S)/qmfact/qmfact);
d_Ids_dV_G_S = ((qmfact*((Gvsat*(((fact_Ids*CsiPrime)*norm_Ids)*d_FdL_dV_G_S+((fact_Ids*CsiPrime)*d_norm_Ids_dV_G_S+(fact_Ids*d_CsiPrime_dV_G_S+d_fact_Ids_dV_G_S*CsiPrime)*norm_Ids)*FdL)-(((fact_Ids*CsiPrime)*norm_Ids)*FdL)*d_Gvsat_dV_G_S)/Gvsat/Gvsat)-((((fact_Ids*CsiPrime)*norm_Ids)*FdL)/Gvsat)*d_qmfact_dV_G_S)/qmfact/qmfact);
d_Ids_dV_S_B = ((qmfact*((Gvsat*(((fact_Ids*CsiPrime)*norm_Ids)*d_FdL_dV_S_B+((fact_Ids*CsiPrime)*d_norm_Ids_dV_S_B+(fact_Ids*d_CsiPrime_dV_S_B+d_fact_Ids_dV_S_B*CsiPrime)*norm_Ids)*FdL)-(((fact_Ids*CsiPrime)*norm_Ids)*FdL)*d_Gvsat_dV_S_B)/Gvsat/Gvsat)-((((fact_Ids*CsiPrime)*norm_Ids)*FdL)/Gvsat)*d_qmfact_dV_S_B)/qmfact/qmfact);
d_Ids_dTemp_Tnode_GND = ((qmfact*((Gvsat*(((fact_Ids*CsiPrime)*norm_Ids)*d_FdL_dTemp_Tnode_GND+((fact_Ids*CsiPrime)*d_norm_Ids_dTemp_Tnode_GND+(fact_Ids*d_CsiPrime_dTemp_Tnode_GND+d_fact_Ids_dTemp_Tnode_GND*CsiPrime)*norm_Ids)*FdL)-(((fact_Ids*CsiPrime)*norm_Ids)*FdL)*d_Gvsat_dTemp_Tnode_GND)/Gvsat/Gvsat)-((((fact_Ids*CsiPrime)*norm_Ids)*FdL)/Gvsat)*d_qmfact_dTemp_Tnode_GND)/qmfact/qmfact);
Ids = (((((fact_Ids*CsiPrime)*norm_Ids)*FdL)/Gvsat)/qmfact);
if ((qis>1.0E-6))
{
if ((norm_Ids>1.0e-30))
{

d_q1s_chap_dV_S_B = ((((Aexp1s/qis)-dqsqs_dxn_qi)*d_a1s_dV_S_B-a1s*(((qis*d_Aexp1s_dV_S_B-Aexp1s*d_qis_dV_S_B)/qis/qis)-d_dqsqs_dxn_qi_dV_S_B))/((Aexp1s/qis)-dqsqs_dxn_qi)/((Aexp1s/qis)-dqsqs_dxn_qi));
d_q1s_chap_dV_D_S = ((((Aexp1s/qis)-dqsqs_dxn_qi)*d_a1s_dV_D_S-a1s*(((qis*d_Aexp1s_dV_D_S-Aexp1s*d_qis_dV_D_S)/qis/qis)-d_dqsqs_dxn_qi_dV_D_S))/((Aexp1s/qis)-dqsqs_dxn_qi)/((Aexp1s/qis)-dqsqs_dxn_qi));
d_q1s_chap_dV_G_S = ((((Aexp1s/qis)-dqsqs_dxn_qi)*d_a1s_dV_G_S-a1s*(((qis*d_Aexp1s_dV_G_S-Aexp1s*d_qis_dV_G_S)/qis/qis)-d_dqsqs_dxn_qi_dV_G_S))/((Aexp1s/qis)-dqsqs_dxn_qi)/((Aexp1s/qis)-dqsqs_dxn_qi));
d_q1s_chap_dTemp_Tnode_GND = ((((Aexp1s/qis)-dqsqs_dxn_qi)*d_a1s_dTemp_Tnode_GND-a1s*(((qis*d_Aexp1s_dTemp_Tnode_GND-Aexp1s*d_qis_dTemp_Tnode_GND)/qis/qis)-d_dqsqs_dxn_qi_dTemp_Tnode_GND))/((Aexp1s/qis)-dqsqs_dxn_qi)/((Aexp1s/qis)-dqsqs_dxn_qi));
q1s_chap = (a1s/((Aexp1s/qis)-dqsqs_dxn_qi));

d_q1d_chap_dV_S_B = ((((Aexp1d/qid)-dqsqd_dxn_qi)*d_a1d_dV_S_B-a1d*(((qid*d_Aexp1d_dV_S_B-Aexp1d*d_qid_dV_S_B)/qid/qid)-d_dqsqd_dxn_qi_dV_S_B))/((Aexp1d/qid)-dqsqd_dxn_qi)/((Aexp1d/qid)-dqsqd_dxn_qi));
d_q1d_chap_dV_D_S = ((((Aexp1d/qid)-dqsqd_dxn_qi)*d_a1d_dV_D_S-a1d*(((qid*d_Aexp1d_dV_D_S-Aexp1d*d_qid_dV_D_S)/qid/qid)-d_dqsqd_dxn_qi_dV_D_S))/((Aexp1d/qid)-dqsqd_dxn_qi)/((Aexp1d/qid)-dqsqd_dxn_qi));
d_q1d_chap_dV_G_S = ((((Aexp1d/qid)-dqsqd_dxn_qi)*d_a1d_dV_G_S-a1d*(((qid*d_Aexp1d_dV_G_S-Aexp1d*d_qid_dV_G_S)/qid/qid)-d_dqsqd_dxn_qi_dV_G_S))/((Aexp1d/qid)-dqsqd_dxn_qi)/((Aexp1d/qid)-dqsqd_dxn_qi));
d_q1d_chap_dTemp_Tnode_GND = ((((Aexp1d/qid)-dqsqd_dxn_qi)*d_a1d_dTemp_Tnode_GND-a1d*(((qid*d_Aexp1d_dTemp_Tnode_GND-Aexp1d*d_qid_dTemp_Tnode_GND)/qid/qid)-d_dqsqd_dxn_qi_dTemp_Tnode_GND))/((Aexp1d/qid)-dqsqd_dxn_qi)/((Aexp1d/qid)-dqsqd_dxn_qi));
q1d_chap = (a1d/((Aexp1d/qid)-dqsqd_dxn_qi));

d_inv_k1h1_0_dV_S_B = ((norm_Ids*(d_q1s_chap_dV_S_B-d_q1d_chap_dV_S_B)-(q1s_chap-q1d_chap)*d_norm_Ids_dV_S_B)/norm_Ids/norm_Ids);
d_inv_k1h1_0_dV_D_S = ((norm_Ids*(d_q1s_chap_dV_D_S-d_q1d_chap_dV_D_S)-(q1s_chap-q1d_chap)*d_norm_Ids_dV_D_S)/norm_Ids/norm_Ids);
d_inv_k1h1_0_dV_G_S = ((norm_Ids*(d_q1s_chap_dV_G_S-d_q1d_chap_dV_G_S)-(q1s_chap-q1d_chap)*d_norm_Ids_dV_G_S)/norm_Ids/norm_Ids);
d_inv_k1h1_0_dTemp_Tnode_GND = ((norm_Ids*(d_q1s_chap_dTemp_Tnode_GND-d_q1d_chap_dTemp_Tnode_GND)-(q1s_chap-q1d_chap)*d_norm_Ids_dTemp_Tnode_GND)/norm_Ids/norm_Ids);
inv_k1h1_0 = ((q1s_chap-q1d_chap)/norm_Ids);

d_q2s_chap_dV_S_B = ((((Aexp2s/qis)-dqsqs_dxn_qi)*d_a2s_dV_S_B-a2s*(((qis*d_Aexp2s_dV_S_B-Aexp2s*d_qis_dV_S_B)/qis/qis)-d_dqsqs_dxn_qi_dV_S_B))/((Aexp2s/qis)-dqsqs_dxn_qi)/((Aexp2s/qis)-dqsqs_dxn_qi));
d_q2s_chap_dV_D_S = ((((Aexp2s/qis)-dqsqs_dxn_qi)*d_a2s_dV_D_S-a2s*(((qis*d_Aexp2s_dV_D_S-Aexp2s*d_qis_dV_D_S)/qis/qis)-d_dqsqs_dxn_qi_dV_D_S))/((Aexp2s/qis)-dqsqs_dxn_qi)/((Aexp2s/qis)-dqsqs_dxn_qi));
d_q2s_chap_dV_G_S = ((((Aexp2s/qis)-dqsqs_dxn_qi)*d_a2s_dV_G_S-a2s*(((qis*d_Aexp2s_dV_G_S-Aexp2s*d_qis_dV_G_S)/qis/qis)-d_dqsqs_dxn_qi_dV_G_S))/((Aexp2s/qis)-dqsqs_dxn_qi)/((Aexp2s/qis)-dqsqs_dxn_qi));
d_q2s_chap_dTemp_Tnode_GND = ((((Aexp2s/qis)-dqsqs_dxn_qi)*d_a2s_dTemp_Tnode_GND-a2s*(((qis*d_Aexp2s_dTemp_Tnode_GND-Aexp2s*d_qis_dTemp_Tnode_GND)/qis/qis)-d_dqsqs_dxn_qi_dTemp_Tnode_GND))/((Aexp2s/qis)-dqsqs_dxn_qi)/((Aexp2s/qis)-dqsqs_dxn_qi));
q2s_chap = (a2s/((Aexp2s/qis)-dqsqs_dxn_qi));

d_q2d_chap_dV_S_B = ((((Aexp2d/qid)-dqsqd_dxn_qi)*d_a2d_dV_S_B-a2d*(((qid*d_Aexp2d_dV_S_B-Aexp2d*d_qid_dV_S_B)/qid/qid)-d_dqsqd_dxn_qi_dV_S_B))/((Aexp2d/qid)-dqsqd_dxn_qi)/((Aexp2d/qid)-dqsqd_dxn_qi));
d_q2d_chap_dV_D_S = ((((Aexp2d/qid)-dqsqd_dxn_qi)*d_a2d_dV_D_S-a2d*(((qid*d_Aexp2d_dV_D_S-Aexp2d*d_qid_dV_D_S)/qid/qid)-d_dqsqd_dxn_qi_dV_D_S))/((Aexp2d/qid)-dqsqd_dxn_qi)/((Aexp2d/qid)-dqsqd_dxn_qi));
d_q2d_chap_dV_G_S = ((((Aexp2d/qid)-dqsqd_dxn_qi)*d_a2d_dV_G_S-a2d*(((qid*d_Aexp2d_dV_G_S-Aexp2d*d_qid_dV_G_S)/qid/qid)-d_dqsqd_dxn_qi_dV_G_S))/((Aexp2d/qid)-dqsqd_dxn_qi)/((Aexp2d/qid)-dqsqd_dxn_qi));
d_q2d_chap_dTemp_Tnode_GND = ((((Aexp2d/qid)-dqsqd_dxn_qi)*d_a2d_dTemp_Tnode_GND-a2d*(((qid*d_Aexp2d_dTemp_Tnode_GND-Aexp2d*d_qid_dTemp_Tnode_GND)/qid/qid)-d_dqsqd_dxn_qi_dTemp_Tnode_GND))/((Aexp2d/qid)-dqsqd_dxn_qi)/((Aexp2d/qid)-dqsqd_dxn_qi));
q2d_chap = (a2d/((Aexp2d/qid)-dqsqd_dxn_qi));

d_inv_k2h2_0_dV_S_B = ((norm_Ids*(d_q2s_chap_dV_S_B-d_q2d_chap_dV_S_B)-(q2s_chap-q2d_chap)*d_norm_Ids_dV_S_B)/norm_Ids/norm_Ids);
d_inv_k2h2_0_dV_D_S = ((norm_Ids*(d_q2s_chap_dV_D_S-d_q2d_chap_dV_D_S)-(q2s_chap-q2d_chap)*d_norm_Ids_dV_D_S)/norm_Ids/norm_Ids);
d_inv_k2h2_0_dV_G_S = ((norm_Ids*(d_q2s_chap_dV_G_S-d_q2d_chap_dV_G_S)-(q2s_chap-q2d_chap)*d_norm_Ids_dV_G_S)/norm_Ids/norm_Ids);
d_inv_k2h2_0_dTemp_Tnode_GND = ((norm_Ids*(d_q2s_chap_dTemp_Tnode_GND-d_q2d_chap_dTemp_Tnode_GND)-(q2s_chap-q2d_chap)*d_norm_Ids_dTemp_Tnode_GND)/norm_Ids/norm_Ids);
inv_k2h2_0 = ((q2s_chap-q2d_chap)/norm_Ids);
}
else
{

d_inv_k1h1_0_dTemp_Tnode_GND = d_inv_k1h1_0_dV_G_S = d_inv_k1h1_0_dV_D_S = d_inv_k1h1_0_dV_S_B =  0.0;
inv_k1h1_0 = 0.0;

d_inv_k2h2_0_dTemp_Tnode_GND = d_inv_k2h2_0_dV_G_S = d_inv_k2h2_0_dV_D_S = d_inv_k2h2_0_dV_S_B =  0.0;
inv_k2h2_0 = 0.0;
}
}
else
{

d_zeta1_dV_S_B = (((-2.0)*s1)*(((q1chapinf*d_inv_k1_dV_S_B-inv_k1*d_q1chapinf_dV_S_B)/q1chapinf/q1chapinf)+d_inv_dinf_dV_S_B)+(-2.0)*d_s1_dV_S_B*((inv_k1/q1chapinf)+inv_dinf));
d_zeta1_dTemp_Tnode_GND = (((-2.0)*s1)*(((q1chapinf*d_inv_k1_dTemp_Tnode_GND-inv_k1*d_q1chapinf_dTemp_Tnode_GND)/q1chapinf/q1chapinf)+d_inv_dinf_dTemp_Tnode_GND)+(-2.0)*d_s1_dTemp_Tnode_GND*((inv_k1/q1chapinf)+inv_dinf));
d_zeta1_dV_D_S = (((-2.0)*s1)*(((q1chapinf*d_inv_k1_dV_D_S-inv_k1*d_q1chapinf_dV_D_S)/q1chapinf/q1chapinf)+d_inv_dinf_dV_D_S)+(-2.0)*d_s1_dV_D_S*((inv_k1/q1chapinf)+inv_dinf));
d_zeta1_dV_G_S = (((-2.0)*s1)*(((q1chapinf*d_inv_k1_dV_G_S-inv_k1*d_q1chapinf_dV_G_S)/q1chapinf/q1chapinf)+d_inv_dinf_dV_G_S)+(-2.0)*d_s1_dV_G_S*((inv_k1/q1chapinf)+inv_dinf));
zeta1 = (((-2.0)*s1)*((inv_k1/q1chapinf)+inv_dinf));

d_zeta2_dTemp_Tnode_GND = (((-2.0)*s2)*(((q2chapinf*d_inv_k2_dTemp_Tnode_GND-inv_k2*d_q2chapinf_dTemp_Tnode_GND)/q2chapinf/q2chapinf)+d_inv_dinf_dTemp_Tnode_GND)+(-2.0)*d_s2_dTemp_Tnode_GND*((inv_k2/q2chapinf)+inv_dinf));
d_zeta2_dV_S_B = (((-2.0)*s2)*(((q2chapinf*d_inv_k2_dV_S_B-inv_k2*d_q2chapinf_dV_S_B)/q2chapinf/q2chapinf)+d_inv_dinf_dV_S_B)+(-2.0)*d_s2_dV_S_B*((inv_k2/q2chapinf)+inv_dinf));
d_zeta2_dV_D_S = (((-2.0)*s2)*(((q2chapinf*d_inv_k2_dV_D_S-inv_k2*d_q2chapinf_dV_D_S)/q2chapinf/q2chapinf)+d_inv_dinf_dV_D_S)+(-2.0)*d_s2_dV_D_S*((inv_k2/q2chapinf)+inv_dinf));
d_zeta2_dV_G_S = (((-2.0)*s2)*(((q2chapinf*d_inv_k2_dV_G_S-inv_k2*d_q2chapinf_dV_G_S)/q2chapinf/q2chapinf)+d_inv_dinf_dV_G_S)+(-2.0)*d_s2_dV_G_S*((inv_k2/q2chapinf)+inv_dinf));
zeta2 = (((-2.0)*s2)*((inv_k2/q2chapinf)+inv_dinf));

d_temp_dTemp_Tnode_GND = ((zeta2-zeta1)*d_inv_dinf_dTemp_Tnode_GND+(d_zeta2_dTemp_Tnode_GND-d_zeta1_dTemp_Tnode_GND)*inv_dinf);
d_temp_dV_S_B = ((zeta2-zeta1)*d_inv_dinf_dV_S_B+(d_zeta2_dV_S_B-d_zeta1_dV_S_B)*inv_dinf);
d_temp_dV_D_S = ((zeta2-zeta1)*d_inv_dinf_dV_D_S+(d_zeta2_dV_D_S-d_zeta1_dV_D_S)*inv_dinf);
d_temp_dV_G_S = ((zeta2-zeta1)*d_inv_dinf_dV_G_S+(d_zeta2_dV_G_S-d_zeta1_dV_G_S)*inv_dinf);
temp = ((zeta2-zeta1)*inv_dinf);

d_temp1_dV_S_B = (zeta1*d_inv_k1_dV_S_B+d_zeta1_dV_S_B*inv_k1);
d_temp1_dTemp_Tnode_GND = (zeta1*d_inv_k1_dTemp_Tnode_GND+d_zeta1_dTemp_Tnode_GND*inv_k1);
d_temp1_dV_D_S = (zeta1*d_inv_k1_dV_D_S+d_zeta1_dV_D_S*inv_k1);
d_temp1_dV_G_S = (zeta1*d_inv_k1_dV_G_S+d_zeta1_dV_G_S*inv_k1);
temp1 = (zeta1*inv_k1);

d_temp2_dTemp_Tnode_GND = (zeta2*d_inv_k2_dTemp_Tnode_GND+d_zeta2_dTemp_Tnode_GND*inv_k2);
d_temp2_dV_S_B = (zeta2*d_inv_k2_dV_S_B+d_zeta2_dV_S_B*inv_k2);
d_temp2_dV_D_S = (zeta2*d_inv_k2_dV_D_S+d_zeta2_dV_D_S*inv_k2);
d_temp2_dV_G_S = (zeta2*d_inv_k2_dV_G_S+d_zeta2_dV_G_S*inv_k2);
temp2 = (zeta2*inv_k2);

d_temp3_dTemp_Tnode_GND = (d_temp1_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND);
d_temp3_dV_D_S = (d_temp1_dV_D_S+d_temp2_dV_D_S);
d_temp3_dV_G_S = (d_temp1_dV_G_S+d_temp2_dV_G_S);
d_temp3_dV_S_B = (d_temp1_dV_S_B+d_temp2_dV_S_B);
temp3 = (temp1+temp2);

d_temp4_dV_S_B = 2.0*((s1*d_inv_k1_dV_S_B+d_s1_dV_S_B*inv_k1)+(s2*d_inv_k2_dV_S_B+d_s2_dV_S_B*inv_k2));
d_temp4_dTemp_Tnode_GND = 2.0*((s1*d_inv_k1_dTemp_Tnode_GND+d_s1_dTemp_Tnode_GND*inv_k1)+(s2*d_inv_k2_dTemp_Tnode_GND+d_s2_dTemp_Tnode_GND*inv_k2));
d_temp4_dV_D_S = 2.0*((s1*d_inv_k1_dV_D_S+d_s1_dV_D_S*inv_k1)+(s2*d_inv_k2_dV_D_S+d_s2_dV_D_S*inv_k2));
d_temp4_dV_G_S = 2.0*((s1*d_inv_k1_dV_G_S+d_s1_dV_G_S*inv_k1)+(s2*d_inv_k2_dV_G_S+d_s2_dV_G_S*inv_k2));
temp4 = (3.0+(2.0*((s1*inv_k1)+(s2*inv_k2))));

d_ksi1_dV_S_B = ((temp4*((d_temp2_dV_S_B+d_temp_dV_S_B)-((q1chapinf*d_temp3_dV_S_B-temp3*d_q1chapinf_dV_S_B)/q1chapinf/q1chapinf))-((temp2+temp)-(temp3/q1chapinf))*d_temp4_dV_S_B)/temp4/temp4);
d_ksi1_dV_D_S = ((temp4*((d_temp2_dV_D_S+d_temp_dV_D_S)-((q1chapinf*d_temp3_dV_D_S-temp3*d_q1chapinf_dV_D_S)/q1chapinf/q1chapinf))-((temp2+temp)-(temp3/q1chapinf))*d_temp4_dV_D_S)/temp4/temp4);
d_ksi1_dTemp_Tnode_GND = ((temp4*((d_temp2_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND)-((q1chapinf*d_temp3_dTemp_Tnode_GND-temp3*d_q1chapinf_dTemp_Tnode_GND)/q1chapinf/q1chapinf))-((temp2+temp)-(temp3/q1chapinf))*d_temp4_dTemp_Tnode_GND)/temp4/temp4);
d_ksi1_dV_G_S = ((temp4*((d_temp2_dV_G_S+d_temp_dV_G_S)-((q1chapinf*d_temp3_dV_G_S-temp3*d_q1chapinf_dV_G_S)/q1chapinf/q1chapinf))-((temp2+temp)-(temp3/q1chapinf))*d_temp4_dV_G_S)/temp4/temp4);
ksi1 = (((temp2+temp)-(temp3/q1chapinf))/temp4);

d_ksi2_dTemp_Tnode_GND = ((temp4*((d_temp1_dTemp_Tnode_GND-d_temp_dTemp_Tnode_GND)-((q2chapinf*d_temp3_dTemp_Tnode_GND-temp3*d_q2chapinf_dTemp_Tnode_GND)/q2chapinf/q2chapinf))-((temp1-temp)-(temp3/q2chapinf))*d_temp4_dTemp_Tnode_GND)/temp4/temp4);
d_ksi2_dV_D_S = ((temp4*((d_temp1_dV_D_S-d_temp_dV_D_S)-((q2chapinf*d_temp3_dV_D_S-temp3*d_q2chapinf_dV_D_S)/q2chapinf/q2chapinf))-((temp1-temp)-(temp3/q2chapinf))*d_temp4_dV_D_S)/temp4/temp4);
d_ksi2_dV_G_S = ((temp4*((d_temp1_dV_G_S-d_temp_dV_G_S)-((q2chapinf*d_temp3_dV_G_S-temp3*d_q2chapinf_dV_G_S)/q2chapinf/q2chapinf))-((temp1-temp)-(temp3/q2chapinf))*d_temp4_dV_G_S)/temp4/temp4);
d_ksi2_dV_S_B = ((temp4*((d_temp1_dV_S_B-d_temp_dV_S_B)-((q2chapinf*d_temp3_dV_S_B-temp3*d_q2chapinf_dV_S_B)/q2chapinf/q2chapinf))-((temp1-temp)-(temp3/q2chapinf))*d_temp4_dV_S_B)/temp4/temp4);
ksi2 = (((temp1-temp)-(temp3/q2chapinf))/temp4);

d_inv_k1h1_0_dV_S_B = ((-q1chapinf)*((ksi1*d_q1chapinf_dV_S_B+d_ksi1_dV_S_B*q1chapinf)+d_inv_dinf_dV_S_B)+(-d_q1chapinf_dV_S_B)*((ksi1*q1chapinf)+inv_dinf));
d_inv_k1h1_0_dTemp_Tnode_GND = ((-q1chapinf)*((ksi1*d_q1chapinf_dTemp_Tnode_GND+d_ksi1_dTemp_Tnode_GND*q1chapinf)+d_inv_dinf_dTemp_Tnode_GND)+(-d_q1chapinf_dTemp_Tnode_GND)*((ksi1*q1chapinf)+inv_dinf));
d_inv_k1h1_0_dV_D_S = ((-q1chapinf)*((ksi1*d_q1chapinf_dV_D_S+d_ksi1_dV_D_S*q1chapinf)+d_inv_dinf_dV_D_S)+(-d_q1chapinf_dV_D_S)*((ksi1*q1chapinf)+inv_dinf));
d_inv_k1h1_0_dV_G_S = ((-q1chapinf)*((ksi1*d_q1chapinf_dV_G_S+d_ksi1_dV_G_S*q1chapinf)+d_inv_dinf_dV_G_S)+(-d_q1chapinf_dV_G_S)*((ksi1*q1chapinf)+inv_dinf));
inv_k1h1_0 = ((-q1chapinf)*((ksi1*q1chapinf)+inv_dinf));

d_inv_k2h2_0_dV_S_B = ((-q2chapinf)*((ksi2*d_q2chapinf_dV_S_B+d_ksi2_dV_S_B*q2chapinf)+d_inv_dinf_dV_S_B)+(-d_q2chapinf_dV_S_B)*((ksi2*q2chapinf)+inv_dinf));
d_inv_k2h2_0_dTemp_Tnode_GND = ((-q2chapinf)*((ksi2*d_q2chapinf_dTemp_Tnode_GND+d_ksi2_dTemp_Tnode_GND*q2chapinf)+d_inv_dinf_dTemp_Tnode_GND)+(-d_q2chapinf_dTemp_Tnode_GND)*((ksi2*q2chapinf)+inv_dinf));
d_inv_k2h2_0_dV_D_S = ((-q2chapinf)*((ksi2*d_q2chapinf_dV_D_S+d_ksi2_dV_D_S*q2chapinf)+d_inv_dinf_dV_D_S)+(-d_q2chapinf_dV_D_S)*((ksi2*q2chapinf)+inv_dinf));
d_inv_k2h2_0_dV_G_S = ((-q2chapinf)*((ksi2*d_q2chapinf_dV_G_S+d_ksi2_dV_G_S*q2chapinf)+d_inv_dinf_dV_G_S)+(-d_q2chapinf_dV_G_S)*((ksi2*q2chapinf)+inv_dinf));
inv_k2h2_0 = ((-q2chapinf)*((ksi2*q2chapinf)+inv_dinf));
}

d_inv_k1h1_dV_S_B = (inv_k1h1_0*d_hsat_dV_S_B+d_inv_k1h1_0_dV_S_B*hsat);
d_inv_k1h1_dV_D_S = (inv_k1h1_0*d_hsat_dV_D_S+d_inv_k1h1_0_dV_D_S*hsat);
d_inv_k1h1_dV_G_S = (inv_k1h1_0*d_hsat_dV_G_S+d_inv_k1h1_0_dV_G_S*hsat);
d_inv_k1h1_dTemp_Tnode_GND = (inv_k1h1_0*d_hsat_dTemp_Tnode_GND+d_inv_k1h1_0_dTemp_Tnode_GND*hsat);
inv_k1h1 = (inv_k1h1_0*hsat);

d_inv_k2h2_dV_S_B = (inv_k2h2_0*d_hsat_dV_S_B+d_inv_k2h2_0_dV_S_B*hsat);
d_inv_k2h2_dV_D_S = (inv_k2h2_0*d_hsat_dV_D_S+d_inv_k2h2_0_dV_D_S*hsat);
d_inv_k2h2_dV_G_S = (inv_k2h2_0*d_hsat_dV_G_S+d_inv_k2h2_0_dV_G_S*hsat);
d_inv_k2h2_dTemp_Tnode_GND = (inv_k2h2_0*d_hsat_dTemp_Tnode_GND+d_inv_k2h2_0_dTemp_Tnode_GND*hsat);
inv_k2h2 = (inv_k2h2_0*hsat);

d_delta_k1q1_dV_S_B = 0.5*(d_k1q1d_dV_S_B-d_k1q1s_dV_S_B);
d_delta_k1q1_dTemp_Tnode_GND = 0.5*(d_k1q1d_dTemp_Tnode_GND-d_k1q1s_dTemp_Tnode_GND);
d_delta_k1q1_dV_D_S = 0.5*(d_k1q1d_dV_D_S-d_k1q1s_dV_D_S);
d_delta_k1q1_dV_G_S = 0.5*(d_k1q1d_dV_G_S-d_k1q1s_dV_G_S);
delta_k1q1 = (0.5*(k1q1d-k1q1s));

d_delta_k2q2_dV_S_B = 0.5*(d_k2q2d_dV_S_B-d_k2q2s_dV_S_B);
d_delta_k2q2_dTemp_Tnode_GND = 0.5*(d_k2q2d_dTemp_Tnode_GND-d_k2q2s_dTemp_Tnode_GND);
d_delta_k2q2_dV_D_S = 0.5*(d_k2q2d_dV_D_S-d_k2q2s_dV_D_S);
d_delta_k2q2_dV_G_S = 0.5*(d_k2q2d_dV_G_S-d_k2q2s_dV_G_S);
delta_k2q2 = (0.5*(k2q2d-k2q2s));

d_prod1_dV_S_B = (delta_k1q1*d_inv_k1h1_dV_S_B+d_delta_k1q1_dV_S_B*inv_k1h1);
d_prod1_dTemp_Tnode_GND = (delta_k1q1*d_inv_k1h1_dTemp_Tnode_GND+d_delta_k1q1_dTemp_Tnode_GND*inv_k1h1);
d_prod1_dV_D_S = (delta_k1q1*d_inv_k1h1_dV_D_S+d_delta_k1q1_dV_D_S*inv_k1h1);
d_prod1_dV_G_S = (delta_k1q1*d_inv_k1h1_dV_G_S+d_delta_k1q1_dV_G_S*inv_k1h1);
prod1 = (delta_k1q1*inv_k1h1);

d_prod2_dV_S_B = (delta_k2q2*d_inv_k2h2_dV_S_B+d_delta_k2q2_dV_S_B*inv_k2h2);
d_prod2_dTemp_Tnode_GND = (delta_k2q2*d_inv_k2h2_dTemp_Tnode_GND+d_delta_k2q2_dTemp_Tnode_GND*inv_k2h2);
d_prod2_dV_D_S = (delta_k2q2*d_inv_k2h2_dV_D_S+d_delta_k2q2_dV_D_S*inv_k2h2);
d_prod2_dV_G_S = (delta_k2q2*d_inv_k2h2_dV_G_S+d_delta_k2q2_dV_G_S*inv_k2h2);
prod2 = (delta_k2q2*inv_k2h2);

d_xs_ov_dV_G_S = d_xs_ov_dTemp_Tnode_GND =  0.0;
xs_ov = 0.0;

d_xd_ov_dV_G_S = d_xd_ov_dV_D_S = d_xd_ov_dTemp_Tnode_GND =  0.0;
xd_ov = 0.0;

d_xs_ovcv_dV_G_S = d_xs_ovcv_dTemp_Tnode_GND =  0.0;
xs_ovcv = 0.0;

d_xd_ovcv_dV_G_S = d_xd_ovcv_dV_D_S = d_xd_ovcv_dTemp_Tnode_GND =  0.0;
xd_ovcv = 0.0;
{
double value_sqrt_0 = sqrt(((((2.0*1.602176565E-19)*NOV_i)*epsch)*inv_phit0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_GOV_dTemp_Tnode_GND = ((deriv_sqrt_0_d0*((((2.0*1.602176565E-19)*NOV_i)*epsch)*d_inv_phit0_dTemp_Tnode_GND))/Cox1Prime);
GOV = (value_sqrt_0/Cox1Prime);
}

d_GOV2_dTemp_Tnode_GND = (GOV*d_GOV_dTemp_Tnode_GND+d_GOV_dTemp_Tnode_GND*GOV);
GOV2 = (GOV*GOV);

d_xi_ov_dTemp_Tnode_GND = (d_GOV_dTemp_Tnode_GND/1.4142135623731);
xi_ov = (1.0+(GOV/1.4142135623731));

d_x_mrg_ov_dTemp_Tnode_GND = 1.0e-5*d_xi_ov_dTemp_Tnode_GND;
x_mrg_ov = (1.0e-5*xi_ov);

d_inv_xi_ov_dTemp_Tnode_GND = (-d_xi_ov_dTemp_Tnode_GND/xi_ov/xi_ov);
inv_xi_ov = (1.0/xi_ov);

d_inv_xg1_dTemp_Tnode_GND = (-d_GOV_dTemp_Tnode_GND*7.324648775608221e-1/(1.25+(GOV*7.324648775608221e-1))/(1.25+(GOV*7.324648775608221e-1)));
inv_xg1 = (1.0/(1.25+(GOV*7.324648775608221e-1)));
if (((((model_.SWIGATE)>0)&&((IGOVINV_i>0.0)||(IGOVACC_i>0.0)))||(((model_.SWGIDL)>0)&&(AGIDL_i>0.0))))
{
if ((fabs(xgs_ov)<=x_mrg_ov))
{

d_xs_ov_dTemp_Tnode_GND = ((-xgs_ov)*d_inv_xi_ov_dTemp_Tnode_GND+(-d_xgs_ov_dTemp_Tnode_GND)*inv_xi_ov);
d_xs_ov_dV_G_S = (-d_xgs_ov_dV_G_S)*inv_xi_ov;
xs_ov = ((-xgs_ov)*inv_xi_ov);
}
else
{
if ((xgs_ov<(-x_mrg_ov)))
{

d_SP_OV_ygf_dV_D_S =  0.0;
d_SP_OV_ygf_dTemp_Tnode_GND = (-d_xgs_ov_dTemp_Tnode_GND);
d_SP_OV_ygf_dV_G_S = (-d_xgs_ov_dV_G_S);
SP_OV_ygf = (-xgs_ov);

d_SP_OV_z_dV_D_S =  0.0;
d_SP_OV_z_dTemp_Tnode_GND = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dTemp_Tnode_GND+1.25*d_SP_OV_ygf_dTemp_Tnode_GND*inv_xi_ov);
d_SP_OV_z_dV_G_S = 1.25*d_SP_OV_ygf_dV_G_S*inv_xi_ov;
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_eta_dV_D_S =  0.0;
d_SP_OV_eta_dTemp_Tnode_GND = 0.5*(d_SP_OV_z_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dTemp_Tnode_GND+d_SP_OV_z_dTemp_Tnode_GND*(SP_OV_z-6.0)))));
d_SP_OV_eta_dV_G_S = 0.5*(d_SP_OV_z_dV_G_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_G_S+d_SP_OV_z_dV_G_S*(SP_OV_z-6.0)))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}

d_SP_OV_a_dV_D_S =  0.0;
d_SP_OV_a_dTemp_Tnode_GND = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)+(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_eta+1.0)));
d_SP_OV_a_dV_G_S = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)+(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)*(SP_OV_ygf-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_G_S);
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

d_SP_OV_c_dV_D_S =  0.0;
d_SP_OV_c_dTemp_Tnode_GND = (2.0*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)-d_GOV2_dTemp_Tnode_GND);
d_SP_OV_c_dV_G_S = 2.0*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

d_SP_OV_tau_dV_D_S =  0.0;
d_SP_OV_tau_dTemp_Tnode_GND = ((deriv_log_0_d0*(((GOV2*d_SP_OV_a_dTemp_Tnode_GND-SP_OV_a*d_GOV2_dTemp_Tnode_GND)/GOV2/GOV2)))-d_SP_OV_eta_dTemp_Tnode_GND);
d_SP_OV_tau_dV_G_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_G_S/GOV2)))-d_SP_OV_eta_dV_G_S);
SP_OV_tau = (value_log_0-SP_OV_eta);
}

d_SP_OV_nu_dV_D_S =  0.0;
d_SP_OV_nu_dTemp_Tnode_GND = (d_SP_OV_a_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND);
d_SP_OV_nu_dV_G_S = (d_SP_OV_a_dV_G_S+d_SP_OV_c_dV_G_S);
SP_OV_nu = (SP_OV_a+SP_OV_c);

d_SP_OV_mutau_dV_D_S =  0.0;
d_SP_OV_mutau_dTemp_Tnode_GND = ((SP_OV_nu*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_nu_dTemp_Tnode_GND*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dTemp_Tnode_GND+0.5*d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)-d_SP_OV_a_dTemp_Tnode_GND)+d_SP_OV_tau_dTemp_Tnode_GND*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_mutau_dV_G_S = ((SP_OV_nu*d_SP_OV_nu_dV_G_S+d_SP_OV_nu_dV_G_S*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dV_G_S+0.5*d_SP_OV_c_dV_G_S*SP_OV_c)-d_SP_OV_a_dV_G_S)+d_SP_OV_tau_dV_G_S*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_mutau_dTemp_Tnode_GND+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)*0.3333333333333-d_SP_OV_a_dTemp_Tnode_GND)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dTemp_Tnode_GND+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_mutau*d_SP_OV_nu_dTemp_Tnode_GND-SP_OV_nu*d_SP_OV_mutau_dTemp_Tnode_GND)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_temp_dV_G_S = (d_SP_OV_mutau_dV_G_S+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_G_S+d_SP_OV_c_dV_G_S*SP_OV_c)*0.3333333333333-d_SP_OV_a_dV_G_S)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_G_S+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dV_G_S+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dV_G_S+((SP_OV_mutau*d_SP_OV_nu_dV_G_S-SP_OV_nu*d_SP_OV_mutau_dV_G_S)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));

d_SP_OV_y0_dV_D_S =  0.0;
d_SP_OV_y0_dTemp_Tnode_GND = (d_SP_OV_eta_dTemp_Tnode_GND+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dTemp_Tnode_GND+(SP_OV_a*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_a_dTemp_Tnode_GND*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dTemp_Tnode_GND)/SP_OV_temp/SP_OV_temp));
d_SP_OV_y0_dV_G_S = (d_SP_OV_eta_dV_G_S+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dV_G_S+(SP_OV_a*d_SP_OV_nu_dV_G_S+d_SP_OV_a_dV_G_S*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dV_G_S)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_SP_OV_y0_dTemp_Tnode_GND));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_G_S));
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_y0_dV_G_S)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dV_G_S)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dTemp_Tnode_GND*0.3333333333333+0.5*d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dV_G_S*0.3333333333333+0.5*d_SP_OV_y0_dV_G_S*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dV_G_S*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_y0_dTemp_Tnode_GND);
d_SP_OV_temp_dV_G_S = (d_SP_OV_ygf_dV_G_S-d_SP_OV_y0_dV_G_S);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);

d_SP_OV_p_dV_D_S =  0.0;
d_SP_OV_p_dTemp_Tnode_GND = (2.0*d_SP_OV_temp_dTemp_Tnode_GND+(GOV2*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_D0-1.0)));
d_SP_OV_p_dV_G_S = (2.0*d_SP_OV_temp_dV_G_S+GOV2*d_SP_OV_D0_dV_G_S);
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

d_SP_OV_q_dV_D_S =  0.0;
d_SP_OV_q_dTemp_Tnode_GND = ((SP_OV_temp*d_SP_OV_temp_dTemp_Tnode_GND+d_SP_OV_temp_dTemp_Tnode_GND*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dTemp_Tnode_GND-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_q_dV_G_S = ((SP_OV_temp*d_SP_OV_temp_dV_G_S+d_SP_OV_temp_dV_G_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_G_S-d_SP_OV_D0_dV_G_S));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

d_SP_OV_xi_dV_D_S =  0.0;
d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_w_dV_D_S =  0.0;
d_SP_OV_w_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xs_ov_dTemp_Tnode_GND = (-(d_SP_OV_y0_dTemp_Tnode_GND+d_SP_OV_w_dTemp_Tnode_GND));
d_xs_ov_dV_G_S = (-(d_SP_OV_y0_dV_G_S+d_SP_OV_w_dV_G_S));
xs_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{

d_SP_OV_Afac_dTemp_Tnode_GND = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dTemp_Tnode_GND+((xi_ov*1.25)*d_inv_xg1_dTemp_Tnode_GND+d_xi_ov_dTemp_Tnode_GND*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);

d_SP_OV_xbar_dV_D_S =  0.0;
d_SP_OV_xbar_dTemp_Tnode_GND = ((xgs_ov*inv_xi_ov)*(SP_OV_Afac*d_xgs_ov_dTemp_Tnode_GND+d_SP_OV_Afac_dTemp_Tnode_GND*xgs_ov)+(xgs_ov*d_inv_xi_ov_dTemp_Tnode_GND+d_xgs_ov_dTemp_Tnode_GND*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
d_SP_OV_xbar_dV_G_S = ((xgs_ov*inv_xi_ov)*SP_OV_Afac*d_xgs_ov_dV_G_S+d_xgs_ov_dV_G_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgs_ov)));
SP_OV_xbar = ((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_xbar_dTemp_Tnode_GND)));
d_SP_OV_temp_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_G_S)));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
d_SP_OV_temp_dV_G_S = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dV_G_S))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dV_G_S))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
d_SP_OV_temp_dV_G_S = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_xbar_dV_G_S)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dV_G_S)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_w_dV_D_S =  0.0;
d_SP_OV_w_dTemp_Tnode_GND = (-d_SP_OV_temp_dTemp_Tnode_GND);
d_SP_OV_w_dV_G_S = (-d_SP_OV_temp_dV_G_S);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_x0_dV_D_S =  0.0;
d_SP_OV_x0_dTemp_Tnode_GND = ((d_xgs_ov_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5)-(GOV*(deriv_sqrt_0_d0*(((d_xgs_ov_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.25)-d_SP_OV_w_dTemp_Tnode_GND)))+d_GOV_dTemp_Tnode_GND*value_sqrt_0));
d_SP_OV_x0_dV_G_S = (d_xgs_ov_dV_G_S-GOV*(deriv_sqrt_0_d0*((d_xgs_ov_dV_G_S-d_SP_OV_w_dV_G_S))));
SP_OV_x0 = ((xgs_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_x0_dTemp_Tnode_GND)));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_G_S)));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dV_G_S))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dV_G_S))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_x0_dV_G_S)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dV_G_S)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_p_dV_D_S =  0.0;
d_SP_OV_p_dTemp_Tnode_GND = (2.0*(d_xgs_ov_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(GOV2*(-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*(1-SP_OV_D0)));
d_SP_OV_p_dV_G_S = (2.0*(d_xgs_ov_dV_G_S-d_SP_OV_x0_dV_G_S)+GOV2*(-d_SP_OV_D0_dV_G_S));
SP_OV_p = ((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

d_SP_OV_q_dV_D_S =  0.0;
d_SP_OV_q_dTemp_Tnode_GND = (((xgs_ov-SP_OV_x0)*(d_xgs_ov_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(d_xgs_ov_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)*(xgs_ov-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_q_dV_G_S = (((xgs_ov-SP_OV_x0)*(d_xgs_ov_dV_G_S-d_SP_OV_x0_dV_G_S)+(d_xgs_ov_dV_G_S-d_SP_OV_x0_dV_G_S)*(xgs_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_G_S+d_SP_OV_D0_dV_G_S));
SP_OV_q = (((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

d_SP_OV_xi_dV_D_S =  0.0;
d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_u_dV_D_S =  0.0;
d_SP_OV_u_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xs_ov_dTemp_Tnode_GND = (d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_u_dTemp_Tnode_GND);
d_xs_ov_dV_G_S = (d_SP_OV_x0_dV_G_S+d_SP_OV_u_dV_G_S);
xs_ov = (SP_OV_x0+SP_OV_u);
}

d_xs_ov_dTemp_Tnode_GND = (-d_xs_ov_dTemp_Tnode_GND);
d_xs_ov_dV_G_S = (-d_xs_ov_dV_G_S);
xs_ov = (-xs_ov);
}
}
if ((COV_i>0.0))
{
if ((fabs(xgs_ovcv)<=x_mrg_ov))
{

d_xs_ovcv_dTemp_Tnode_GND = ((-xgs_ovcv)*d_inv_xi_ov_dTemp_Tnode_GND+(-d_xgs_ovcv_dTemp_Tnode_GND)*inv_xi_ov);
d_xs_ovcv_dV_G_S = (-d_xgs_ovcv_dV_G_S)*inv_xi_ov;
xs_ovcv = ((-xgs_ovcv)*inv_xi_ov);
}
else
{
if ((xgs_ovcv<(-x_mrg_ov)))
{

d_SP_OV_ygf_dV_D_S =  0.0;
d_SP_OV_ygf_dTemp_Tnode_GND = (-d_xgs_ovcv_dTemp_Tnode_GND);
d_SP_OV_ygf_dV_G_S = (-d_xgs_ovcv_dV_G_S);
SP_OV_ygf = (-xgs_ovcv);

d_SP_OV_z_dV_D_S =  0.0;
d_SP_OV_z_dTemp_Tnode_GND = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dTemp_Tnode_GND+1.25*d_SP_OV_ygf_dTemp_Tnode_GND*inv_xi_ov);
d_SP_OV_z_dV_G_S = 1.25*d_SP_OV_ygf_dV_G_S*inv_xi_ov;
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_eta_dV_D_S =  0.0;
d_SP_OV_eta_dTemp_Tnode_GND = 0.5*(d_SP_OV_z_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dTemp_Tnode_GND+d_SP_OV_z_dTemp_Tnode_GND*(SP_OV_z-6.0)))));
d_SP_OV_eta_dV_G_S = 0.5*(d_SP_OV_z_dV_G_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_G_S+d_SP_OV_z_dV_G_S*(SP_OV_z-6.0)))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}

d_SP_OV_a_dV_D_S =  0.0;
d_SP_OV_a_dTemp_Tnode_GND = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)+(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_eta+1.0)));
d_SP_OV_a_dV_G_S = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)+(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)*(SP_OV_ygf-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_G_S);
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

d_SP_OV_c_dV_D_S =  0.0;
d_SP_OV_c_dTemp_Tnode_GND = (2.0*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)-d_GOV2_dTemp_Tnode_GND);
d_SP_OV_c_dV_G_S = 2.0*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

d_SP_OV_tau_dV_D_S =  0.0;
d_SP_OV_tau_dTemp_Tnode_GND = ((deriv_log_0_d0*(((GOV2*d_SP_OV_a_dTemp_Tnode_GND-SP_OV_a*d_GOV2_dTemp_Tnode_GND)/GOV2/GOV2)))-d_SP_OV_eta_dTemp_Tnode_GND);
d_SP_OV_tau_dV_G_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_G_S/GOV2)))-d_SP_OV_eta_dV_G_S);
SP_OV_tau = (value_log_0-SP_OV_eta);
}

d_SP_OV_nu_dV_D_S =  0.0;
d_SP_OV_nu_dTemp_Tnode_GND = (d_SP_OV_a_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND);
d_SP_OV_nu_dV_G_S = (d_SP_OV_a_dV_G_S+d_SP_OV_c_dV_G_S);
SP_OV_nu = (SP_OV_a+SP_OV_c);

d_SP_OV_mutau_dV_D_S =  0.0;
d_SP_OV_mutau_dTemp_Tnode_GND = ((SP_OV_nu*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_nu_dTemp_Tnode_GND*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dTemp_Tnode_GND+0.5*d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)-d_SP_OV_a_dTemp_Tnode_GND)+d_SP_OV_tau_dTemp_Tnode_GND*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_mutau_dV_G_S = ((SP_OV_nu*d_SP_OV_nu_dV_G_S+d_SP_OV_nu_dV_G_S*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dV_G_S+0.5*d_SP_OV_c_dV_G_S*SP_OV_c)-d_SP_OV_a_dV_G_S)+d_SP_OV_tau_dV_G_S*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_mutau_dTemp_Tnode_GND+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)*0.3333333333333-d_SP_OV_a_dTemp_Tnode_GND)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dTemp_Tnode_GND+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_mutau*d_SP_OV_nu_dTemp_Tnode_GND-SP_OV_nu*d_SP_OV_mutau_dTemp_Tnode_GND)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_temp_dV_G_S = (d_SP_OV_mutau_dV_G_S+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_G_S+d_SP_OV_c_dV_G_S*SP_OV_c)*0.3333333333333-d_SP_OV_a_dV_G_S)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_G_S+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dV_G_S+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dV_G_S+((SP_OV_mutau*d_SP_OV_nu_dV_G_S-SP_OV_nu*d_SP_OV_mutau_dV_G_S)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));

d_SP_OV_y0_dV_D_S =  0.0;
d_SP_OV_y0_dTemp_Tnode_GND = (d_SP_OV_eta_dTemp_Tnode_GND+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dTemp_Tnode_GND+(SP_OV_a*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_a_dTemp_Tnode_GND*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dTemp_Tnode_GND)/SP_OV_temp/SP_OV_temp));
d_SP_OV_y0_dV_G_S = (d_SP_OV_eta_dV_G_S+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dV_G_S+(SP_OV_a*d_SP_OV_nu_dV_G_S+d_SP_OV_a_dV_G_S*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dV_G_S)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_SP_OV_y0_dTemp_Tnode_GND));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_G_S));
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_y0_dV_G_S)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dV_G_S)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dTemp_Tnode_GND*0.3333333333333+0.5*d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dV_G_S*0.3333333333333+0.5*d_SP_OV_y0_dV_G_S*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dV_G_S*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_y0_dTemp_Tnode_GND);
d_SP_OV_temp_dV_G_S = (d_SP_OV_ygf_dV_G_S-d_SP_OV_y0_dV_G_S);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);

d_SP_OV_p_dV_D_S =  0.0;
d_SP_OV_p_dTemp_Tnode_GND = (2.0*d_SP_OV_temp_dTemp_Tnode_GND+(GOV2*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_D0-1.0)));
d_SP_OV_p_dV_G_S = (2.0*d_SP_OV_temp_dV_G_S+GOV2*d_SP_OV_D0_dV_G_S);
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

d_SP_OV_q_dV_D_S =  0.0;
d_SP_OV_q_dTemp_Tnode_GND = ((SP_OV_temp*d_SP_OV_temp_dTemp_Tnode_GND+d_SP_OV_temp_dTemp_Tnode_GND*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dTemp_Tnode_GND-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_q_dV_G_S = ((SP_OV_temp*d_SP_OV_temp_dV_G_S+d_SP_OV_temp_dV_G_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_G_S-d_SP_OV_D0_dV_G_S));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

d_SP_OV_xi_dV_D_S =  0.0;
d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_w_dV_D_S =  0.0;
d_SP_OV_w_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xs_ovcv_dTemp_Tnode_GND = (-(d_SP_OV_y0_dTemp_Tnode_GND+d_SP_OV_w_dTemp_Tnode_GND));
d_xs_ovcv_dV_G_S = (-(d_SP_OV_y0_dV_G_S+d_SP_OV_w_dV_G_S));
xs_ovcv = (-(SP_OV_y0+SP_OV_w));
}
else
{

d_SP_OV_Afac_dTemp_Tnode_GND = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dTemp_Tnode_GND+((xi_ov*1.25)*d_inv_xg1_dTemp_Tnode_GND+d_xi_ov_dTemp_Tnode_GND*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);

d_SP_OV_xbar_dV_D_S =  0.0;
d_SP_OV_xbar_dTemp_Tnode_GND = ((xgs_ovcv*inv_xi_ov)*(SP_OV_Afac*d_xgs_ovcv_dTemp_Tnode_GND+d_SP_OV_Afac_dTemp_Tnode_GND*xgs_ovcv)+(xgs_ovcv*d_inv_xi_ov_dTemp_Tnode_GND+d_xgs_ovcv_dTemp_Tnode_GND*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ovcv)));
d_SP_OV_xbar_dV_G_S = ((xgs_ovcv*inv_xi_ov)*SP_OV_Afac*d_xgs_ovcv_dV_G_S+d_xgs_ovcv_dV_G_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgs_ovcv)));
SP_OV_xbar = ((xgs_ovcv*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ovcv)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_xbar_dTemp_Tnode_GND)));
d_SP_OV_temp_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_G_S)));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
d_SP_OV_temp_dV_G_S = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dV_G_S))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dV_G_S))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
d_SP_OV_temp_dV_G_S = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_xbar_dV_G_S)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dV_G_S)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_w_dV_D_S =  0.0;
d_SP_OV_w_dTemp_Tnode_GND = (-d_SP_OV_temp_dTemp_Tnode_GND);
d_SP_OV_w_dV_G_S = (-d_SP_OV_temp_dV_G_S);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgs_ovcv+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_x0_dV_D_S =  0.0;
d_SP_OV_x0_dTemp_Tnode_GND = ((d_xgs_ovcv_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5)-(GOV*(deriv_sqrt_0_d0*(((d_xgs_ovcv_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.25)-d_SP_OV_w_dTemp_Tnode_GND)))+d_GOV_dTemp_Tnode_GND*value_sqrt_0));
d_SP_OV_x0_dV_G_S = (d_xgs_ovcv_dV_G_S-GOV*(deriv_sqrt_0_d0*((d_xgs_ovcv_dV_G_S-d_SP_OV_w_dV_G_S))));
SP_OV_x0 = ((xgs_ovcv+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_x0_dTemp_Tnode_GND)));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_G_S)));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dV_G_S))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dV_G_S))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dV_D_S =  0.0;
d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_x0_dV_G_S)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dV_G_S)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_p_dV_D_S =  0.0;
d_SP_OV_p_dTemp_Tnode_GND = (2.0*(d_xgs_ovcv_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(GOV2*(-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*(1-SP_OV_D0)));
d_SP_OV_p_dV_G_S = (2.0*(d_xgs_ovcv_dV_G_S-d_SP_OV_x0_dV_G_S)+GOV2*(-d_SP_OV_D0_dV_G_S));
SP_OV_p = ((2.0*(xgs_ovcv-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

d_SP_OV_q_dV_D_S =  0.0;
d_SP_OV_q_dTemp_Tnode_GND = (((xgs_ovcv-SP_OV_x0)*(d_xgs_ovcv_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(d_xgs_ovcv_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)*(xgs_ovcv-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_q_dV_G_S = (((xgs_ovcv-SP_OV_x0)*(d_xgs_ovcv_dV_G_S-d_SP_OV_x0_dV_G_S)+(d_xgs_ovcv_dV_G_S-d_SP_OV_x0_dV_G_S)*(xgs_ovcv-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_G_S+d_SP_OV_D0_dV_G_S));
SP_OV_q = (((xgs_ovcv-SP_OV_x0)*(xgs_ovcv-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

d_SP_OV_xi_dV_D_S =  0.0;
d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_D_S =  0.0;
d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_u_dV_D_S =  0.0;
d_SP_OV_u_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xs_ovcv_dTemp_Tnode_GND = (d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_u_dTemp_Tnode_GND);
d_xs_ovcv_dV_G_S = (d_SP_OV_x0_dV_G_S+d_SP_OV_u_dV_G_S);
xs_ovcv = (SP_OV_x0+SP_OV_u);
}

d_xs_ovcv_dTemp_Tnode_GND = (-d_xs_ovcv_dTemp_Tnode_GND);
d_xs_ovcv_dV_G_S = (-d_xs_ovcv_dV_G_S);
xs_ovcv = (-xs_ovcv);
}
}
{
double value_sqrt_0 = sqrt(((((2.0*1.602176565E-19)*NOVD_i)*epsch)*inv_phit0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_GOV_dTemp_Tnode_GND = ((deriv_sqrt_0_d0*((((2.0*1.602176565E-19)*NOVD_i)*epsch)*d_inv_phit0_dTemp_Tnode_GND))/Cox1Prime);
GOV = (value_sqrt_0/Cox1Prime);
}

d_GOV2_dTemp_Tnode_GND = (GOV*d_GOV_dTemp_Tnode_GND+d_GOV_dTemp_Tnode_GND*GOV);
GOV2 = (GOV*GOV);

d_xi_ov_dTemp_Tnode_GND = (d_GOV_dTemp_Tnode_GND/1.4142135623731);
xi_ov = (1.0+(GOV/1.4142135623731));

d_x_mrg_ov_dTemp_Tnode_GND = 1.0e-5*d_xi_ov_dTemp_Tnode_GND;
x_mrg_ov = (1.0e-5*xi_ov);

d_inv_xi_ov_dTemp_Tnode_GND = (-d_xi_ov_dTemp_Tnode_GND/xi_ov/xi_ov);
inv_xi_ov = (1.0/xi_ov);

d_inv_xg1_dTemp_Tnode_GND = (-d_GOV_dTemp_Tnode_GND*7.324648775608221e-1/(1.25+(GOV*7.324648775608221e-1))/(1.25+(GOV*7.324648775608221e-1)));
inv_xg1 = (1.0/(1.25+(GOV*7.324648775608221e-1)));
if (((((model_.SWIGATE)>0)&&((IGOVINVD_i>0.0)||(IGOVACCD_i>0.0)))||(((model_.SWGIDL)>0)&&(AGIDLD_i>0.0))))
{
if ((fabs(xgd_ov)<=x_mrg_ov))
{

d_xd_ov_dTemp_Tnode_GND = ((-xgd_ov)*d_inv_xi_ov_dTemp_Tnode_GND+(-d_xgd_ov_dTemp_Tnode_GND)*inv_xi_ov);
d_xd_ov_dV_D_S = (-d_xgd_ov_dV_D_S)*inv_xi_ov;
d_xd_ov_dV_G_S = (-d_xgd_ov_dV_G_S)*inv_xi_ov;
xd_ov = ((-xgd_ov)*inv_xi_ov);
}
else
{
if ((xgd_ov<(-x_mrg_ov)))
{

d_SP_OV_ygf_dTemp_Tnode_GND = (-d_xgd_ov_dTemp_Tnode_GND);
d_SP_OV_ygf_dV_D_S = (-d_xgd_ov_dV_D_S);
d_SP_OV_ygf_dV_G_S = (-d_xgd_ov_dV_G_S);
SP_OV_ygf = (-xgd_ov);

d_SP_OV_z_dTemp_Tnode_GND = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dTemp_Tnode_GND+1.25*d_SP_OV_ygf_dTemp_Tnode_GND*inv_xi_ov);
d_SP_OV_z_dV_G_S = 1.25*d_SP_OV_ygf_dV_G_S*inv_xi_ov;
d_SP_OV_z_dV_D_S = 1.25*d_SP_OV_ygf_dV_D_S*inv_xi_ov;
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_eta_dTemp_Tnode_GND = 0.5*(d_SP_OV_z_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dTemp_Tnode_GND+d_SP_OV_z_dTemp_Tnode_GND*(SP_OV_z-6.0)))));
d_SP_OV_eta_dV_G_S = 0.5*(d_SP_OV_z_dV_G_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_G_S+d_SP_OV_z_dV_G_S*(SP_OV_z-6.0)))));
d_SP_OV_eta_dV_D_S = 0.5*(d_SP_OV_z_dV_D_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_D_S+d_SP_OV_z_dV_D_S*(SP_OV_z-6.0)))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}

d_SP_OV_a_dTemp_Tnode_GND = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)+(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_eta+1.0)));
d_SP_OV_a_dV_G_S = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)+(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)*(SP_OV_ygf-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_G_S);
d_SP_OV_a_dV_D_S = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dV_D_S-d_SP_OV_eta_dV_D_S)+(d_SP_OV_ygf_dV_D_S-d_SP_OV_eta_dV_D_S)*(SP_OV_ygf-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_D_S);
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

d_SP_OV_c_dTemp_Tnode_GND = (2.0*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)-d_GOV2_dTemp_Tnode_GND);
d_SP_OV_c_dV_G_S = 2.0*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S);
d_SP_OV_c_dV_D_S = 2.0*(d_SP_OV_ygf_dV_D_S-d_SP_OV_eta_dV_D_S);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

d_SP_OV_tau_dTemp_Tnode_GND = ((deriv_log_0_d0*(((GOV2*d_SP_OV_a_dTemp_Tnode_GND-SP_OV_a*d_GOV2_dTemp_Tnode_GND)/GOV2/GOV2)))-d_SP_OV_eta_dTemp_Tnode_GND);
d_SP_OV_tau_dV_G_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_G_S/GOV2)))-d_SP_OV_eta_dV_G_S);
d_SP_OV_tau_dV_D_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_D_S/GOV2)))-d_SP_OV_eta_dV_D_S);
SP_OV_tau = (value_log_0-SP_OV_eta);
}

d_SP_OV_nu_dTemp_Tnode_GND = (d_SP_OV_a_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND);
d_SP_OV_nu_dV_G_S = (d_SP_OV_a_dV_G_S+d_SP_OV_c_dV_G_S);
d_SP_OV_nu_dV_D_S = (d_SP_OV_a_dV_D_S+d_SP_OV_c_dV_D_S);
SP_OV_nu = (SP_OV_a+SP_OV_c);

d_SP_OV_mutau_dTemp_Tnode_GND = ((SP_OV_nu*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_nu_dTemp_Tnode_GND*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dTemp_Tnode_GND+0.5*d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)-d_SP_OV_a_dTemp_Tnode_GND)+d_SP_OV_tau_dTemp_Tnode_GND*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_mutau_dV_G_S = ((SP_OV_nu*d_SP_OV_nu_dV_G_S+d_SP_OV_nu_dV_G_S*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dV_G_S+0.5*d_SP_OV_c_dV_G_S*SP_OV_c)-d_SP_OV_a_dV_G_S)+d_SP_OV_tau_dV_G_S*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_mutau_dV_D_S = ((SP_OV_nu*d_SP_OV_nu_dV_D_S+d_SP_OV_nu_dV_D_S*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dV_D_S+0.5*d_SP_OV_c_dV_D_S*SP_OV_c)-d_SP_OV_a_dV_D_S)+d_SP_OV_tau_dV_D_S*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));

d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_mutau_dTemp_Tnode_GND+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)*0.3333333333333-d_SP_OV_a_dTemp_Tnode_GND)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dTemp_Tnode_GND+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_mutau*d_SP_OV_nu_dTemp_Tnode_GND-SP_OV_nu*d_SP_OV_mutau_dTemp_Tnode_GND)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_temp_dV_G_S = (d_SP_OV_mutau_dV_G_S+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_G_S+d_SP_OV_c_dV_G_S*SP_OV_c)*0.3333333333333-d_SP_OV_a_dV_G_S)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_G_S+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dV_G_S+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dV_G_S+((SP_OV_mutau*d_SP_OV_nu_dV_G_S-SP_OV_nu*d_SP_OV_mutau_dV_G_S)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_temp_dV_D_S = (d_SP_OV_mutau_dV_D_S+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_D_S+d_SP_OV_c_dV_D_S*SP_OV_c)*0.3333333333333-d_SP_OV_a_dV_D_S)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_D_S+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dV_D_S+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dV_D_S+((SP_OV_mutau*d_SP_OV_nu_dV_D_S-SP_OV_nu*d_SP_OV_mutau_dV_D_S)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));

d_SP_OV_y0_dTemp_Tnode_GND = (d_SP_OV_eta_dTemp_Tnode_GND+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dTemp_Tnode_GND+(SP_OV_a*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_a_dTemp_Tnode_GND*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dTemp_Tnode_GND)/SP_OV_temp/SP_OV_temp));
d_SP_OV_y0_dV_G_S = (d_SP_OV_eta_dV_G_S+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dV_G_S+(SP_OV_a*d_SP_OV_nu_dV_G_S+d_SP_OV_a_dV_G_S*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dV_G_S)/SP_OV_temp/SP_OV_temp));
d_SP_OV_y0_dV_D_S = (d_SP_OV_eta_dV_D_S+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dV_D_S+(SP_OV_a*d_SP_OV_nu_dV_D_S+d_SP_OV_a_dV_D_S*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dV_D_S)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_SP_OV_y0_dTemp_Tnode_GND));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_G_S));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_D_S));
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{

d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_y0_dV_G_S)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dV_G_S)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_D_S = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dV_D_S)*0.3333333333333+0.5*(-d_SP_OV_y0_dV_D_S)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dV_D_S)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dTemp_Tnode_GND*0.3333333333333+0.5*d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dV_G_S*0.3333333333333+0.5*d_SP_OV_y0_dV_G_S*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dV_G_S*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_D_S = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dV_D_S*0.3333333333333+0.5*d_SP_OV_y0_dV_D_S*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dV_D_S*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_y0_dTemp_Tnode_GND);
d_SP_OV_temp_dV_G_S = (d_SP_OV_ygf_dV_G_S-d_SP_OV_y0_dV_G_S);
d_SP_OV_temp_dV_D_S = (d_SP_OV_ygf_dV_D_S-d_SP_OV_y0_dV_D_S);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);

d_SP_OV_p_dTemp_Tnode_GND = (2.0*d_SP_OV_temp_dTemp_Tnode_GND+(GOV2*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_D0-1.0)));
d_SP_OV_p_dV_G_S = (2.0*d_SP_OV_temp_dV_G_S+GOV2*d_SP_OV_D0_dV_G_S);
d_SP_OV_p_dV_D_S = (2.0*d_SP_OV_temp_dV_D_S+GOV2*d_SP_OV_D0_dV_D_S);
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

d_SP_OV_q_dTemp_Tnode_GND = ((SP_OV_temp*d_SP_OV_temp_dTemp_Tnode_GND+d_SP_OV_temp_dTemp_Tnode_GND*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dTemp_Tnode_GND-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_q_dV_G_S = ((SP_OV_temp*d_SP_OV_temp_dV_G_S+d_SP_OV_temp_dV_G_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_G_S-d_SP_OV_D0_dV_G_S));
d_SP_OV_q_dV_D_S = ((SP_OV_temp*d_SP_OV_temp_dV_D_S+d_SP_OV_temp_dV_D_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_D_S-d_SP_OV_D0_dV_D_S));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_w_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_D_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_D_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xd_ov_dTemp_Tnode_GND = (-(d_SP_OV_y0_dTemp_Tnode_GND+d_SP_OV_w_dTemp_Tnode_GND));
d_xd_ov_dV_G_S = (-(d_SP_OV_y0_dV_G_S+d_SP_OV_w_dV_G_S));
d_xd_ov_dV_D_S = (-(d_SP_OV_y0_dV_D_S+d_SP_OV_w_dV_D_S));
xd_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{

d_SP_OV_Afac_dTemp_Tnode_GND = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dTemp_Tnode_GND+((xi_ov*1.25)*d_inv_xg1_dTemp_Tnode_GND+d_xi_ov_dTemp_Tnode_GND*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);

d_SP_OV_xbar_dTemp_Tnode_GND = ((xgd_ov*inv_xi_ov)*(SP_OV_Afac*d_xgd_ov_dTemp_Tnode_GND+d_SP_OV_Afac_dTemp_Tnode_GND*xgd_ov)+(xgd_ov*d_inv_xi_ov_dTemp_Tnode_GND+d_xgd_ov_dTemp_Tnode_GND*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
d_SP_OV_xbar_dV_D_S = ((xgd_ov*inv_xi_ov)*SP_OV_Afac*d_xgd_ov_dV_D_S+d_xgd_ov_dV_D_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ov)));
d_SP_OV_xbar_dV_G_S = ((xgd_ov*inv_xi_ov)*SP_OV_Afac*d_xgd_ov_dV_G_S+d_xgd_ov_dV_G_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ov)));
SP_OV_xbar = ((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_xbar_dTemp_Tnode_GND)));
d_SP_OV_temp_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_G_S)));
d_SP_OV_temp_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_D_S)));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{

d_SP_OV_temp_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
d_SP_OV_temp_dV_G_S = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dV_G_S))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dV_G_S))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
d_SP_OV_temp_dV_D_S = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dV_D_S))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dV_D_S))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dV_D_S))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_temp_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
d_SP_OV_temp_dV_G_S = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_xbar_dV_G_S)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dV_G_S)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
d_SP_OV_temp_dV_D_S = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dV_D_S)*0.3333333333333+0.5*(-d_SP_OV_xbar_dV_D_S)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dV_D_S)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_w_dTemp_Tnode_GND = (-d_SP_OV_temp_dTemp_Tnode_GND);
d_SP_OV_w_dV_G_S = (-d_SP_OV_temp_dV_G_S);
d_SP_OV_w_dV_D_S = (-d_SP_OV_temp_dV_D_S);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_x0_dTemp_Tnode_GND = ((d_xgd_ov_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5)-(GOV*(deriv_sqrt_0_d0*(((d_xgd_ov_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.25)-d_SP_OV_w_dTemp_Tnode_GND)))+d_GOV_dTemp_Tnode_GND*value_sqrt_0));
d_SP_OV_x0_dV_D_S = (d_xgd_ov_dV_D_S-GOV*(deriv_sqrt_0_d0*((d_xgd_ov_dV_D_S-d_SP_OV_w_dV_D_S))));
d_SP_OV_x0_dV_G_S = (d_xgd_ov_dV_G_S-GOV*(deriv_sqrt_0_d0*((d_xgd_ov_dV_G_S-d_SP_OV_w_dV_G_S))));
SP_OV_x0 = ((xgd_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_x0_dTemp_Tnode_GND)));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_G_S)));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_D_S)));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{

d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dV_G_S))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dV_G_S))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_D_S = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dV_D_S))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dV_D_S))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dV_D_S))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_x0_dV_G_S)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dV_G_S)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_D_S = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dV_D_S)*0.3333333333333+0.5*(-d_SP_OV_x0_dV_D_S)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dV_D_S)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_p_dTemp_Tnode_GND = (2.0*(d_xgd_ov_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(GOV2*(-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*(1-SP_OV_D0)));
d_SP_OV_p_dV_D_S = (2.0*(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S)+GOV2*(-d_SP_OV_D0_dV_D_S));
d_SP_OV_p_dV_G_S = (2.0*(d_xgd_ov_dV_G_S-d_SP_OV_x0_dV_G_S)+GOV2*(-d_SP_OV_D0_dV_G_S));
SP_OV_p = ((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

d_SP_OV_q_dTemp_Tnode_GND = (((xgd_ov-SP_OV_x0)*(d_xgd_ov_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(d_xgd_ov_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)*(xgd_ov-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_q_dV_D_S = (((xgd_ov-SP_OV_x0)*(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S)+(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S)*(xgd_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_D_S+d_SP_OV_D0_dV_D_S));
d_SP_OV_q_dV_G_S = (((xgd_ov-SP_OV_x0)*(d_xgd_ov_dV_G_S-d_SP_OV_x0_dV_G_S)+(d_xgd_ov_dV_G_S-d_SP_OV_x0_dV_G_S)*(xgd_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_G_S+d_SP_OV_D0_dV_G_S));
SP_OV_q = (((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_u_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_D_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_D_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xd_ov_dTemp_Tnode_GND = (d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_u_dTemp_Tnode_GND);
d_xd_ov_dV_G_S = (d_SP_OV_x0_dV_G_S+d_SP_OV_u_dV_G_S);
d_xd_ov_dV_D_S = (d_SP_OV_x0_dV_D_S+d_SP_OV_u_dV_D_S);
xd_ov = (SP_OV_x0+SP_OV_u);
}

d_xd_ov_dTemp_Tnode_GND = (-d_xd_ov_dTemp_Tnode_GND);
d_xd_ov_dV_D_S = (-d_xd_ov_dV_D_S);
d_xd_ov_dV_G_S = (-d_xd_ov_dV_G_S);
xd_ov = (-xd_ov);
}
}
if ((COVD_i>0.0))
{
if ((fabs(xgd_ovcv)<=x_mrg_ov))
{

d_xd_ovcv_dTemp_Tnode_GND = ((-xgd_ovcv)*d_inv_xi_ov_dTemp_Tnode_GND+(-d_xgd_ovcv_dTemp_Tnode_GND)*inv_xi_ov);
d_xd_ovcv_dV_D_S = (-d_xgd_ovcv_dV_D_S)*inv_xi_ov;
d_xd_ovcv_dV_G_S = (-d_xgd_ovcv_dV_G_S)*inv_xi_ov;
xd_ovcv = ((-xgd_ovcv)*inv_xi_ov);
}
else
{
if ((xgd_ovcv<(-x_mrg_ov)))
{

d_SP_OV_ygf_dTemp_Tnode_GND = (-d_xgd_ovcv_dTemp_Tnode_GND);
d_SP_OV_ygf_dV_D_S = (-d_xgd_ovcv_dV_D_S);
d_SP_OV_ygf_dV_G_S = (-d_xgd_ovcv_dV_G_S);
SP_OV_ygf = (-xgd_ovcv);

d_SP_OV_z_dTemp_Tnode_GND = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dTemp_Tnode_GND+1.25*d_SP_OV_ygf_dTemp_Tnode_GND*inv_xi_ov);
d_SP_OV_z_dV_G_S = 1.25*d_SP_OV_ygf_dV_G_S*inv_xi_ov;
d_SP_OV_z_dV_D_S = 1.25*d_SP_OV_ygf_dV_D_S*inv_xi_ov;
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_eta_dTemp_Tnode_GND = 0.5*(d_SP_OV_z_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dTemp_Tnode_GND+d_SP_OV_z_dTemp_Tnode_GND*(SP_OV_z-6.0)))));
d_SP_OV_eta_dV_G_S = 0.5*(d_SP_OV_z_dV_G_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_G_S+d_SP_OV_z_dV_G_S*(SP_OV_z-6.0)))));
d_SP_OV_eta_dV_D_S = 0.5*(d_SP_OV_z_dV_D_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_D_S+d_SP_OV_z_dV_D_S*(SP_OV_z-6.0)))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}

d_SP_OV_a_dTemp_Tnode_GND = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)+(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_eta+1.0)));
d_SP_OV_a_dV_G_S = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)+(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S)*(SP_OV_ygf-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_G_S);
d_SP_OV_a_dV_D_S = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dV_D_S-d_SP_OV_eta_dV_D_S)+(d_SP_OV_ygf_dV_D_S-d_SP_OV_eta_dV_D_S)*(SP_OV_ygf-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_D_S);
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

d_SP_OV_c_dTemp_Tnode_GND = (2.0*(d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_eta_dTemp_Tnode_GND)-d_GOV2_dTemp_Tnode_GND);
d_SP_OV_c_dV_G_S = 2.0*(d_SP_OV_ygf_dV_G_S-d_SP_OV_eta_dV_G_S);
d_SP_OV_c_dV_D_S = 2.0*(d_SP_OV_ygf_dV_D_S-d_SP_OV_eta_dV_D_S);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

d_SP_OV_tau_dTemp_Tnode_GND = ((deriv_log_0_d0*(((GOV2*d_SP_OV_a_dTemp_Tnode_GND-SP_OV_a*d_GOV2_dTemp_Tnode_GND)/GOV2/GOV2)))-d_SP_OV_eta_dTemp_Tnode_GND);
d_SP_OV_tau_dV_G_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_G_S/GOV2)))-d_SP_OV_eta_dV_G_S);
d_SP_OV_tau_dV_D_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_D_S/GOV2)))-d_SP_OV_eta_dV_D_S);
SP_OV_tau = (value_log_0-SP_OV_eta);
}

d_SP_OV_nu_dTemp_Tnode_GND = (d_SP_OV_a_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND);
d_SP_OV_nu_dV_G_S = (d_SP_OV_a_dV_G_S+d_SP_OV_c_dV_G_S);
d_SP_OV_nu_dV_D_S = (d_SP_OV_a_dV_D_S+d_SP_OV_c_dV_D_S);
SP_OV_nu = (SP_OV_a+SP_OV_c);

d_SP_OV_mutau_dTemp_Tnode_GND = ((SP_OV_nu*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_nu_dTemp_Tnode_GND*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dTemp_Tnode_GND+0.5*d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)-d_SP_OV_a_dTemp_Tnode_GND)+d_SP_OV_tau_dTemp_Tnode_GND*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_mutau_dV_G_S = ((SP_OV_nu*d_SP_OV_nu_dV_G_S+d_SP_OV_nu_dV_G_S*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dV_G_S+0.5*d_SP_OV_c_dV_G_S*SP_OV_c)-d_SP_OV_a_dV_G_S)+d_SP_OV_tau_dV_G_S*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_mutau_dV_D_S = ((SP_OV_nu*d_SP_OV_nu_dV_D_S+d_SP_OV_nu_dV_D_S*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dV_D_S+0.5*d_SP_OV_c_dV_D_S*SP_OV_c)-d_SP_OV_a_dV_D_S)+d_SP_OV_tau_dV_D_S*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));

d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_mutau_dTemp_Tnode_GND+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dTemp_Tnode_GND+d_SP_OV_c_dTemp_Tnode_GND*SP_OV_c)*0.3333333333333-d_SP_OV_a_dTemp_Tnode_GND)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dTemp_Tnode_GND+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dTemp_Tnode_GND+((SP_OV_mutau*d_SP_OV_nu_dTemp_Tnode_GND-SP_OV_nu*d_SP_OV_mutau_dTemp_Tnode_GND)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_temp_dV_G_S = (d_SP_OV_mutau_dV_G_S+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_G_S+d_SP_OV_c_dV_G_S*SP_OV_c)*0.3333333333333-d_SP_OV_a_dV_G_S)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_G_S+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dV_G_S+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dV_G_S+((SP_OV_mutau*d_SP_OV_nu_dV_G_S-SP_OV_nu*d_SP_OV_mutau_dV_G_S)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_temp_dV_D_S = (d_SP_OV_mutau_dV_D_S+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_D_S+d_SP_OV_c_dV_D_S*SP_OV_c)*0.3333333333333-d_SP_OV_a_dV_D_S)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_D_S+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dV_D_S+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dV_D_S+((SP_OV_mutau*d_SP_OV_nu_dV_D_S-SP_OV_nu*d_SP_OV_mutau_dV_D_S)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));

d_SP_OV_y0_dTemp_Tnode_GND = (d_SP_OV_eta_dTemp_Tnode_GND+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dTemp_Tnode_GND+(SP_OV_a*d_SP_OV_nu_dTemp_Tnode_GND+d_SP_OV_a_dTemp_Tnode_GND*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dTemp_Tnode_GND)/SP_OV_temp/SP_OV_temp));
d_SP_OV_y0_dV_G_S = (d_SP_OV_eta_dV_G_S+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dV_G_S+(SP_OV_a*d_SP_OV_nu_dV_G_S+d_SP_OV_a_dV_G_S*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dV_G_S)/SP_OV_temp/SP_OV_temp));
d_SP_OV_y0_dV_D_S = (d_SP_OV_eta_dV_D_S+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dV_D_S+(SP_OV_a*d_SP_OV_nu_dV_D_S+d_SP_OV_a_dV_D_S*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dV_D_S)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_SP_OV_y0_dTemp_Tnode_GND));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_G_S));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_D_S));
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{

d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_y0_dV_G_S)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dV_G_S)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_D_S = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dV_D_S)*0.3333333333333+0.5*(-d_SP_OV_y0_dV_D_S)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dV_D_S)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dTemp_Tnode_GND*0.3333333333333+0.5*d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dTemp_Tnode_GND*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dV_G_S*0.3333333333333+0.5*d_SP_OV_y0_dV_G_S*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dV_G_S*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_D_S = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dV_D_S*0.3333333333333+0.5*d_SP_OV_y0_dV_D_S*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dV_D_S*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_temp_dTemp_Tnode_GND = (d_SP_OV_ygf_dTemp_Tnode_GND-d_SP_OV_y0_dTemp_Tnode_GND);
d_SP_OV_temp_dV_G_S = (d_SP_OV_ygf_dV_G_S-d_SP_OV_y0_dV_G_S);
d_SP_OV_temp_dV_D_S = (d_SP_OV_ygf_dV_D_S-d_SP_OV_y0_dV_D_S);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);

d_SP_OV_p_dTemp_Tnode_GND = (2.0*d_SP_OV_temp_dTemp_Tnode_GND+(GOV2*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*(SP_OV_D0-1.0)));
d_SP_OV_p_dV_G_S = (2.0*d_SP_OV_temp_dV_G_S+GOV2*d_SP_OV_D0_dV_G_S);
d_SP_OV_p_dV_D_S = (2.0*d_SP_OV_temp_dV_D_S+GOV2*d_SP_OV_D0_dV_D_S);
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

d_SP_OV_q_dTemp_Tnode_GND = ((SP_OV_temp*d_SP_OV_temp_dTemp_Tnode_GND+d_SP_OV_temp_dTemp_Tnode_GND*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dTemp_Tnode_GND-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_q_dV_G_S = ((SP_OV_temp*d_SP_OV_temp_dV_G_S+d_SP_OV_temp_dV_G_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_G_S-d_SP_OV_D0_dV_G_S));
d_SP_OV_q_dV_D_S = ((SP_OV_temp*d_SP_OV_temp_dV_D_S+d_SP_OV_temp_dV_D_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_D_S-d_SP_OV_D0_dV_D_S));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_w_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_D_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_D_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xd_ovcv_dTemp_Tnode_GND = (-(d_SP_OV_y0_dTemp_Tnode_GND+d_SP_OV_w_dTemp_Tnode_GND));
d_xd_ovcv_dV_G_S = (-(d_SP_OV_y0_dV_G_S+d_SP_OV_w_dV_G_S));
d_xd_ovcv_dV_D_S = (-(d_SP_OV_y0_dV_D_S+d_SP_OV_w_dV_D_S));
xd_ovcv = (-(SP_OV_y0+SP_OV_w));
}
else
{

d_SP_OV_Afac_dTemp_Tnode_GND = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dTemp_Tnode_GND+((xi_ov*1.25)*d_inv_xg1_dTemp_Tnode_GND+d_xi_ov_dTemp_Tnode_GND*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);

d_SP_OV_xbar_dTemp_Tnode_GND = ((xgd_ovcv*inv_xi_ov)*(SP_OV_Afac*d_xgd_ovcv_dTemp_Tnode_GND+d_SP_OV_Afac_dTemp_Tnode_GND*xgd_ovcv)+(xgd_ovcv*d_inv_xi_ov_dTemp_Tnode_GND+d_xgd_ovcv_dTemp_Tnode_GND*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ovcv)));
d_SP_OV_xbar_dV_D_S = ((xgd_ovcv*inv_xi_ov)*SP_OV_Afac*d_xgd_ovcv_dV_D_S+d_xgd_ovcv_dV_D_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ovcv)));
d_SP_OV_xbar_dV_G_S = ((xgd_ovcv*inv_xi_ov)*SP_OV_Afac*d_xgd_ovcv_dV_G_S+d_xgd_ovcv_dV_G_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ovcv)));
SP_OV_xbar = ((xgd_ovcv*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ovcv)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_xbar_dTemp_Tnode_GND)));
d_SP_OV_temp_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_G_S)));
d_SP_OV_temp_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_D_S)));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{

d_SP_OV_temp_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
d_SP_OV_temp_dV_G_S = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dV_G_S))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dV_G_S))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
d_SP_OV_temp_dV_D_S = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dV_D_S))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dV_D_S))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dV_D_S))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_temp_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
d_SP_OV_temp_dV_G_S = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_xbar_dV_G_S)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dV_G_S)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
d_SP_OV_temp_dV_D_S = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dV_D_S)*0.3333333333333+0.5*(-d_SP_OV_xbar_dV_D_S)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dV_D_S)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_w_dTemp_Tnode_GND = (-d_SP_OV_temp_dTemp_Tnode_GND);
d_SP_OV_w_dV_G_S = (-d_SP_OV_temp_dV_G_S);
d_SP_OV_w_dV_D_S = (-d_SP_OV_temp_dV_D_S);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgd_ovcv+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_x0_dTemp_Tnode_GND = ((d_xgd_ovcv_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5)-(GOV*(deriv_sqrt_0_d0*(((d_xgd_ovcv_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.25)-d_SP_OV_w_dTemp_Tnode_GND)))+d_GOV_dTemp_Tnode_GND*value_sqrt_0));
d_SP_OV_x0_dV_D_S = (d_xgd_ovcv_dV_D_S-GOV*(deriv_sqrt_0_d0*((d_xgd_ovcv_dV_D_S-d_SP_OV_w_dV_D_S))));
d_SP_OV_x0_dV_G_S = (d_xgd_ovcv_dV_G_S-GOV*(deriv_sqrt_0_d0*((d_xgd_ovcv_dV_G_S-d_SP_OV_w_dV_G_S))));
SP_OV_x0 = ((xgd_ovcv+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dTemp_Tnode_GND = (deriv_exp_0_d0*((-d_SP_OV_x0_dTemp_Tnode_GND)));
d_SP_OV_D0_dV_G_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_G_S)));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_D_S)));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{

d_SP_OV_D0_dTemp_Tnode_GND = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dTemp_Tnode_GND))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_G_S = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dV_G_S))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dV_G_S))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dV_G_S))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
d_SP_OV_D0_dV_D_S = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dV_D_S))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dV_D_S))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dV_D_S))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{

d_SP_OV_D0_dTemp_Tnode_GND = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dTemp_Tnode_GND)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_G_S = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dV_G_S)*0.3333333333333+0.5*(-d_SP_OV_x0_dV_G_S)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dV_G_S)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
d_SP_OV_D0_dV_D_S = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dV_D_S)*0.3333333333333+0.5*(-d_SP_OV_x0_dV_D_S)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dV_D_S)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}

d_SP_OV_p_dTemp_Tnode_GND = (2.0*(d_xgd_ovcv_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(GOV2*(-d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*(1-SP_OV_D0)));
d_SP_OV_p_dV_D_S = (2.0*(d_xgd_ovcv_dV_D_S-d_SP_OV_x0_dV_D_S)+GOV2*(-d_SP_OV_D0_dV_D_S));
d_SP_OV_p_dV_G_S = (2.0*(d_xgd_ovcv_dV_G_S-d_SP_OV_x0_dV_G_S)+GOV2*(-d_SP_OV_D0_dV_G_S));
SP_OV_p = ((2.0*(xgd_ovcv-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

d_SP_OV_q_dTemp_Tnode_GND = (((xgd_ovcv-SP_OV_x0)*(d_xgd_ovcv_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)+(d_xgd_ovcv_dTemp_Tnode_GND-d_SP_OV_x0_dTemp_Tnode_GND)*(xgd_ovcv-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_D0_dTemp_Tnode_GND)+d_GOV2_dTemp_Tnode_GND*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_q_dV_D_S = (((xgd_ovcv-SP_OV_x0)*(d_xgd_ovcv_dV_D_S-d_SP_OV_x0_dV_D_S)+(d_xgd_ovcv_dV_D_S-d_SP_OV_x0_dV_D_S)*(xgd_ovcv-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_D_S+d_SP_OV_D0_dV_D_S));
d_SP_OV_q_dV_G_S = (((xgd_ovcv-SP_OV_x0)*(d_xgd_ovcv_dV_G_S-d_SP_OV_x0_dV_G_S)+(d_xgd_ovcv_dV_G_S-d_SP_OV_x0_dV_G_S)*(xgd_ovcv-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_G_S+d_SP_OV_D0_dV_G_S));
SP_OV_q = (((xgd_ovcv-SP_OV_x0)*(xgd_ovcv-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

d_SP_OV_xi_dV_G_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_G_S);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dTemp_Tnode_GND = (-((GOV2*0.5)*d_SP_OV_D0_dTemp_Tnode_GND+d_GOV2_dTemp_Tnode_GND*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dTemp_Tnode_GND = ((SP_OV_p*d_SP_OV_p_dTemp_Tnode_GND+d_SP_OV_p_dTemp_Tnode_GND*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dTemp_Tnode_GND+d_SP_OV_xi_dTemp_Tnode_GND*SP_OV_q));
d_SP_OV_temp_dV_G_S = ((SP_OV_p*d_SP_OV_p_dV_G_S+d_SP_OV_p_dV_G_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_G_S+d_SP_OV_xi_dV_G_S*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_u_dTemp_Tnode_GND = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dTemp_Tnode_GND-(2.0*SP_OV_q)*(d_SP_OV_p_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(d_SP_OV_temp_dTemp_Tnode_GND))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_G_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_G_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_G_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_G_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_D_S = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dV_D_S-(2.0*SP_OV_q)*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}

d_xd_ovcv_dTemp_Tnode_GND = (d_SP_OV_x0_dTemp_Tnode_GND+d_SP_OV_u_dTemp_Tnode_GND);
d_xd_ovcv_dV_G_S = (d_SP_OV_x0_dV_G_S+d_SP_OV_u_dV_G_S);
d_xd_ovcv_dV_D_S = (d_SP_OV_x0_dV_D_S+d_SP_OV_u_dV_D_S);
xd_ovcv = (SP_OV_x0+SP_OV_u);
}

d_xd_ovcv_dTemp_Tnode_GND = (-d_xd_ovcv_dTemp_Tnode_GND);
d_xd_ovcv_dV_D_S = (-d_xd_ovcv_dV_D_S);
d_xd_ovcv_dV_G_S = (-d_xd_ovcv_dV_G_S);
xd_ovcv = (-xd_ovcv);
}
}

d_Vovs_dV_G_S = (-phit0)*(d_xgs_ov_dV_G_S+d_xs_ov_dV_G_S);
d_Vovs_dTemp_Tnode_GND = ((-phit0)*(d_xgs_ov_dTemp_Tnode_GND+d_xs_ov_dTemp_Tnode_GND)+(-d_phit0_dTemp_Tnode_GND)*(xgs_ov+xs_ov));
Vovs = ((-phit0)*(xgs_ov+xs_ov));

d_Vovd_dV_D_S = (-phit0)*(d_xgd_ov_dV_D_S+d_xd_ov_dV_D_S);
d_Vovd_dV_G_S = (-phit0)*(d_xgd_ov_dV_G_S+d_xd_ov_dV_G_S);
d_Vovd_dTemp_Tnode_GND = ((-phit0)*(d_xgd_ov_dTemp_Tnode_GND+d_xd_ov_dTemp_Tnode_GND)+(-d_phit0_dTemp_Tnode_GND)*(xgd_ov+xd_ov));
Vovd = ((-phit0)*(xgd_ov+xd_ov));

d_Vovscv_dV_G_S = (-phit0)*(d_xgs_ovcv_dV_G_S+d_xs_ovcv_dV_G_S);
d_Vovscv_dTemp_Tnode_GND = ((-phit0)*(d_xgs_ovcv_dTemp_Tnode_GND+d_xs_ovcv_dTemp_Tnode_GND)+(-d_phit0_dTemp_Tnode_GND)*(xgs_ovcv+xs_ovcv));
Vovscv = ((-phit0)*(xgs_ovcv+xs_ovcv));

d_Vovdcv_dV_D_S = (-phit0)*(d_xgd_ovcv_dV_D_S+d_xd_ovcv_dV_D_S);
d_Vovdcv_dV_G_S = (-phit0)*(d_xgd_ovcv_dV_G_S+d_xd_ovcv_dV_G_S);
d_Vovdcv_dTemp_Tnode_GND = ((-phit0)*(d_xgd_ovcv_dTemp_Tnode_GND+d_xd_ovcv_dTemp_Tnode_GND)+(-d_phit0_dTemp_Tnode_GND)*(xgd_ovcv+xd_ovcv));
Vovdcv = ((-phit0)*(xgd_ovcv+xd_ovcv));

d_Igsov_dTemp_Tnode_GND = d_Igsov_dV_S_B = d_Igsov_dV_G_S = d_Igsov_dV_D_S =  0.0;
Igsov = 0.0;

d_Igdov_dTemp_Tnode_GND = d_Igdov_dV_S_B = d_Igdov_dV_G_S = d_Igdov_dV_D_S =  0.0;
Igdov = 0.0;

d_Igc_dTemp_Tnode_GND = d_Igc_dV_G_S = d_Igc_dV_D_S = d_Igc_dV_S_B =  0.0;
Igc = 0.0;

d_Igs_dTemp_Tnode_GND = d_Igs_dV_G_S = d_Igs_dV_D_S = d_Igs_dV_S_B =  0.0;
Igs = 0.0;

d_Igd_dTemp_Tnode_GND = d_Igd_dV_G_S = d_Igd_dV_D_S = d_Igd_dV_S_B =  0.0;
Igd = 0.0;

d_Igcs_dTemp_Tnode_GND = d_Igcs_dV_G_S = d_Igcs_dV_D_S = d_Igcs_dV_S_B =  0.0;
Igcs = 0.0;

d_Igcd_dTemp_Tnode_GND = d_Igcd_dV_G_S = d_Igcd_dV_D_S = d_Igcd_dV_S_B =  0.0;
Igcd = 0.0;
if (((model_.SWIGATE)>0))
{
if (((IGOVINV_i>0.0)||(IGOVACC_i>0.0)))
{

d_arg2mina_dV_S_B = d_arg2mina_dV_D_S =  0.0;
d_arg2mina_dV_G_S = d_Vovs_dV_G_S;
d_arg2mina_dTemp_Tnode_GND = (d_Vovs_dTemp_Tnode_GND+d_Dov_dTemp_Tnode_GND);
arg2mina = (Vovs+Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psi_t_dV_S_B = d_psi_t_dV_D_S =  0.0;
d_psi_t_dV_G_S = 0.5*(d_arg2mina_dV_G_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_G_S)+(-d_arg2mina_dV_G_S)*(-arg2mina)))));
d_psi_t_dTemp_Tnode_GND = 0.5*(d_arg2mina_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dTemp_Tnode_GND)+(-d_arg2mina_dTemp_Tnode_GND)*(-arg2mina)))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_B = d_zg_dV_D_S =  0.0;
d_zg_dV_G_S = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_G_S+d_Vovs_dV_G_S*Vovs)))*inv_CHIB;
d_zg_dTemp_Tnode_GND = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dTemp_Tnode_GND+d_Vovs_dTemp_Tnode_GND*Vovs)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((fabs((0.5*xgs_ov))<80.0))
{
{
double value_exp_0 = exp((0.5*xgs_ov));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*(0.5*d_xgs_ov_dTemp_Tnode_GND));
d_temp_dV_G_S = (deriv_exp_0_d0*(0.5*d_xgs_ov_dV_G_S));
temp = value_exp_0;
}
}
else
{
if (((0.5*xgs_ov)<(-80.0)))
{

d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (-1.80485e-35*((((-0.5)*xgs_ov)-80.0)*((0.5*(((-0.5)*xgs_ov)-80.0))*(-0.5)*d_xgs_ov_dTemp_Tnode_GND*0.3333333333333+0.5*(-0.5)*d_xgs_ov_dTemp_Tnode_GND*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))+(-0.5)*d_xgs_ov_dTemp_Tnode_GND*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))))/(1.0+((((-0.5)*xgs_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333))))))/(1.0+((((-0.5)*xgs_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))))));
d_temp_dV_G_S = (-1.80485e-35*((((-0.5)*xgs_ov)-80.0)*((0.5*(((-0.5)*xgs_ov)-80.0))*(-0.5)*d_xgs_ov_dV_G_S*0.3333333333333+0.5*(-0.5)*d_xgs_ov_dV_G_S*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))+(-0.5)*d_xgs_ov_dV_G_S*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))))/(1.0+((((-0.5)*xgs_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333))))))/(1.0+((((-0.5)*xgs_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))))));
temp = (1.80485e-35/(1.0+((((-0.5)*xgs_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))))));
}
else
{

d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = 5.54062e34*(((0.5*xgs_ov)-80.0)*((0.5*((0.5*xgs_ov)-80.0))*0.5*d_xgs_ov_dTemp_Tnode_GND*0.3333333333333+0.5*0.5*d_xgs_ov_dTemp_Tnode_GND*(1.0+(((0.5*xgs_ov)-80.0)*0.3333333333333)))+0.5*d_xgs_ov_dTemp_Tnode_GND*(1.0+((0.5*((0.5*xgs_ov)-80.0))*(1.0+(((0.5*xgs_ov)-80.0)*0.3333333333333)))));
d_temp_dV_G_S = 5.54062e34*(((0.5*xgs_ov)-80.0)*((0.5*((0.5*xgs_ov)-80.0))*0.5*d_xgs_ov_dV_G_S*0.3333333333333+0.5*0.5*d_xgs_ov_dV_G_S*(1.0+(((0.5*xgs_ov)-80.0)*0.3333333333333)))+0.5*d_xgs_ov_dV_G_S*(1.0+((0.5*((0.5*xgs_ov)-80.0))*(1.0+(((0.5*xgs_ov)-80.0)*0.3333333333333)))));
temp = (5.54062e34*(1.0+(((0.5*xgs_ov)-80.0)*(1.0+((0.5*((0.5*xgs_ov)-80.0))*(1.0+(((0.5*xgs_ov)-80.0)*0.3333333333333)))))));
}
}

d_temp1_dTemp_Tnode_GND = (-d_temp_dTemp_Tnode_GND/(1.0+temp)/(1.0+temp));
d_temp1_dV_S_B = (-d_temp_dV_S_B/(1.0+temp)/(1.0+temp));
d_temp1_dV_D_S = (-d_temp_dV_D_S/(1.0+temp)/(1.0+temp));
d_temp1_dV_G_S = (-d_temp_dV_G_S/(1.0+temp)/(1.0+temp));
temp1 = (1.0/(1.0+temp));

d_temp2_dTemp_Tnode_GND = (-d_temp1_dTemp_Tnode_GND);
d_temp2_dV_D_S = (-d_temp1_dV_D_S);
d_temp2_dV_G_S = (-d_temp1_dV_G_S);
d_temp2_dV_S_B = (-d_temp1_dV_S_B);
temp2 = (1.0-temp1);

d_gc2oveff_dTemp_Tnode_GND = (GC2OVACC_i*d_temp1_dTemp_Tnode_GND+GC2OVINV_i*d_temp2_dTemp_Tnode_GND);
d_gc2oveff_dV_D_S = (GC2OVACC_i*d_temp1_dV_D_S+GC2OVINV_i*d_temp2_dV_D_S);
d_gc2oveff_dV_G_S = (GC2OVACC_i*d_temp1_dV_G_S+GC2OVINV_i*d_temp2_dV_G_S);
d_gc2oveff_dV_S_B = (GC2OVACC_i*d_temp1_dV_S_B+GC2OVINV_i*d_temp2_dV_S_B);
gc2oveff = ((GC2OVACC_i*temp1)+(GC2OVINV_i*temp2));

d_gc3oveff_dTemp_Tnode_GND = (GC3OVACC_i*d_temp1_dTemp_Tnode_GND+GC3OVINV_i*d_temp2_dTemp_Tnode_GND);
d_gc3oveff_dV_D_S = (GC3OVACC_i*d_temp1_dV_D_S+GC3OVINV_i*d_temp2_dV_D_S);
d_gc3oveff_dV_G_S = (GC3OVACC_i*d_temp1_dV_G_S+GC3OVINV_i*d_temp2_dV_G_S);
d_gc3oveff_dV_S_B = (GC3OVACC_i*d_temp1_dV_S_B+GC3OVINV_i*d_temp2_dV_S_B);
gc3oveff = ((GC3OVACC_i*temp1)+(GC3OVINV_i*temp2));

d_gcqoveff_dTemp_Tnode_GND = (GCQOVACC*d_temp1_dTemp_Tnode_GND+GCQOVINV*d_temp2_dTemp_Tnode_GND);
d_gcqoveff_dV_D_S = (GCQOVACC*d_temp1_dV_D_S+GCQOVINV*d_temp2_dV_D_S);
d_gcqoveff_dV_G_S = (GCQOVACC*d_temp1_dV_G_S+GCQOVINV*d_temp2_dV_G_S);
d_gcqoveff_dV_S_B = (GCQOVACC*d_temp1_dV_S_B+GCQOVINV*d_temp2_dV_S_B);
gcqoveff = ((GCQOVACC*temp1)+(GCQOVINV*temp2));

d_igoveff_dV_D_S = (IGOVACC_i*d_temp1_dV_D_S+IGOVINV_i*d_temp2_dV_D_S);
d_igoveff_dV_G_S = (IGOVACC_i*d_temp1_dV_G_S+IGOVINV_i*d_temp2_dV_G_S);
d_igoveff_dV_S_B = (IGOVACC_i*d_temp1_dV_S_B+IGOVINV_i*d_temp2_dV_S_B);
d_igoveff_dTemp_Tnode_GND = ((IGOVACC_i*d_temp1_dTemp_Tnode_GND+d_IGOVACC_i_dTemp_Tnode_GND*temp1)+(IGOVINV_i*d_temp2_dTemp_Tnode_GND+d_IGOVINV_i_dTemp_Tnode_GND*temp2));
igoveff = ((IGOVACC_i*temp1)+(IGOVINV_i*temp2));

d_igovefffowler_dV_S_B = FNOVINV_i*d_temp2_dV_S_B*1.0e-6;
d_igovefffowler_dV_D_S = FNOVINV_i*d_temp2_dV_D_S*1.0e-6;
d_igovefffowler_dV_G_S = FNOVINV_i*d_temp2_dV_G_S*1.0e-6;
d_igovefffowler_dTemp_Tnode_GND = (FNOVINV_i*d_temp2_dTemp_Tnode_GND+d_FNOVINV_i_dTemp_Tnode_GND*temp2)*1.0e-6;
igovefffowler = ((FNOVINV_i*temp2)*1.0e-6);

d_temp1_dV_S_B = d_temp1_dV_D_S =  0.0;
d_temp1_dV_G_S = BOV*(-((-1.0)*GCOVINVFN_i)*d_zg_dV_G_S/zg/zg);
d_temp1_dTemp_Tnode_GND = BOV*(-((-1.0)*GCOVINVFN_i)*d_zg_dTemp_Tnode_GND/zg/zg);
temp1 = (BOV*(((-1.0)*GCOVINVFN_i)/zg));
if ((gc3oveff<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-gcqoveff)*(zg-gcqoveff))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_D_S = 0.5*((d_zg_dV_D_S+d_gcqoveff_dV_D_S)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dV_D_S-d_gcqoveff_dV_D_S)+(d_zg_dV_D_S-d_gcqoveff_dV_D_S)*(zg-gcqoveff)))));
d_zg_dV_S_B = 0.5*((d_zg_dV_S_B+d_gcqoveff_dV_S_B)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dV_S_B-d_gcqoveff_dV_S_B)+(d_zg_dV_S_B-d_gcqoveff_dV_S_B)*(zg-gcqoveff)))));
d_zg_dV_G_S = 0.5*((d_zg_dV_G_S+d_gcqoveff_dV_G_S)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dV_G_S-d_gcqoveff_dV_G_S)+(d_zg_dV_G_S-d_gcqoveff_dV_G_S)*(zg-gcqoveff)))));
d_zg_dTemp_Tnode_GND = 0.5*((d_zg_dTemp_Tnode_GND+d_gcqoveff_dTemp_Tnode_GND)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dTemp_Tnode_GND-d_gcqoveff_dTemp_Tnode_GND)+(d_zg_dTemp_Tnode_GND-d_gcqoveff_dTemp_Tnode_GND)*(zg-gcqoveff)))));
zg = (0.5*((zg+gcqoveff)-value_sqrt_0));
}
}

d_arg1_dV_S_B = d_arg1_dV_D_S =  0.0;
d_arg1_dTemp_Tnode_GND = (d_xs_ov_dTemp_Tnode_GND+(psi_t*d_inv_phit0_dTemp_Tnode_GND+d_psi_t_dTemp_Tnode_GND*inv_phit0));
d_arg1_dV_G_S = (d_xs_ov_dV_G_S+d_psi_t_dV_G_S*inv_phit0);
arg1 = ((3.0+xs_ov)+(psi_t*inv_phit0));
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dsi_dV_S_B = d_Dsi_dV_D_S =  0.0;
d_Dsi_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_arg1_dTemp_Tnode_GND));
d_Dsi_dV_G_S = (deriv_exp_0_d0*(d_arg1_dV_G_S));
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{

d_Dsi_dV_S_B = d_Dsi_dV_D_S =  0.0;
d_Dsi_dTemp_Tnode_GND = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_arg1_dTemp_Tnode_GND)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dTemp_Tnode_GND)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dsi_dV_G_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_G_S)*0.3333333333333+0.5*(-d_arg1_dV_G_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_G_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dsi = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{

d_Dsi_dV_S_B = d_Dsi_dV_D_S =  0.0;
d_Dsi_dTemp_Tnode_GND = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dTemp_Tnode_GND*0.3333333333333+0.5*d_arg1_dTemp_Tnode_GND*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dTemp_Tnode_GND*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dsi_dV_G_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_G_S*0.3333333333333+0.5*d_arg1_dV_G_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_G_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dsi = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}

d_arg1_dV_S_B = d_arg1_dV_D_S =  0.0;
d_arg1_dTemp_Tnode_GND = ((d_xs_ov_dTemp_Tnode_GND+(psi_t*d_inv_phit0_dTemp_Tnode_GND+d_psi_t_dTemp_Tnode_GND*inv_phit0))+d_xgs_ov_dTemp_Tnode_GND);
d_arg1_dV_G_S = ((d_xs_ov_dV_G_S+d_psi_t_dV_G_S*inv_phit0)+d_xgs_ov_dV_G_S);
arg1 = (((3.0+xs_ov)+(psi_t*inv_phit0))+xgs_ov);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dgate_dV_S_B = d_Dgate_dV_D_S =  0.0;
d_Dgate_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_arg1_dTemp_Tnode_GND));
d_Dgate_dV_G_S = (deriv_exp_0_d0*(d_arg1_dV_G_S));
Dgate = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{

d_Dgate_dV_S_B = d_Dgate_dV_D_S =  0.0;
d_Dgate_dTemp_Tnode_GND = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_arg1_dTemp_Tnode_GND)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dTemp_Tnode_GND)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dgate_dV_G_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_G_S)*0.3333333333333+0.5*(-d_arg1_dV_G_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_G_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dgate = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{

d_Dgate_dV_S_B = d_Dgate_dV_D_S =  0.0;
d_Dgate_dTemp_Tnode_GND = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dTemp_Tnode_GND*0.3333333333333+0.5*d_arg1_dTemp_Tnode_GND*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dTemp_Tnode_GND*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dgate_dV_G_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_G_S*0.3333333333333+0.5*d_arg1_dV_G_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_G_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dgate = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}

d_temp_dV_G_S = BOV*(zg*(d_gc2oveff_dV_G_S+(gc3oveff*d_zg_dV_G_S+d_gc3oveff_dV_G_S*zg))+d_zg_dV_G_S*(gc2oveff+(gc3oveff*zg)));
d_temp_dTemp_Tnode_GND = BOV*(zg*(d_gc2oveff_dTemp_Tnode_GND+(gc3oveff*d_zg_dTemp_Tnode_GND+d_gc3oveff_dTemp_Tnode_GND*zg))+d_zg_dTemp_Tnode_GND*(gc2oveff+(gc3oveff*zg)));
d_temp_dV_D_S = BOV*(zg*(d_gc2oveff_dV_D_S+(gc3oveff*d_zg_dV_D_S+d_gc3oveff_dV_D_S*zg))+d_zg_dV_D_S*(gc2oveff+(gc3oveff*zg)));
d_temp_dV_S_B = BOV*(zg*(d_gc2oveff_dV_S_B+(gc3oveff*d_zg_dV_S_B+d_gc3oveff_dV_S_B*zg))+d_zg_dV_S_B*(gc2oveff+(gc3oveff*zg)));
temp = (BOV*((-1.5)+(zg*(gc2oveff+(gc3oveff*zg)))));
if ((temp>0.0))
{

d_TP_dTemp_Tnode_GND = (temp*((0.5*temp)*d_temp_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp_dTemp_Tnode_GND*(1.0+(temp*0.3333333333333)))+d_temp_dTemp_Tnode_GND*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_S_B = (temp*((0.5*temp)*d_temp_dV_S_B*0.3333333333333+0.5*d_temp_dV_S_B*(1.0+(temp*0.3333333333333)))+d_temp_dV_S_B*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_D_S = (temp*((0.5*temp)*d_temp_dV_D_S*0.3333333333333+0.5*d_temp_dV_D_S*(1.0+(temp*0.3333333333333)))+d_temp_dV_D_S*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_G_S = (temp*((0.5*temp)*d_temp_dV_G_S*0.3333333333333+0.5*d_temp_dV_G_S*(1.0+(temp*0.3333333333333)))+d_temp_dV_G_S*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
TP = (1.0+(temp*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333))))));
}
else
{
if ((temp>(-80.0)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp_dTemp_Tnode_GND));
d_TP_dV_S_B = (deriv_exp_0_d0*(d_temp_dV_S_B));
d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_TP_dV_G_S = (deriv_exp_0_d0*(d_temp_dV_G_S));
TP = value_exp_0;
}
}
else
{

d_TP_dTemp_Tnode_GND = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp_dTemp_Tnode_GND)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dTemp_Tnode_GND)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_S_B = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_S_B)*0.3333333333333+0.5*(-d_temp_dV_S_B)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_S_B)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_D_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_D_S)*0.3333333333333+0.5*(-d_temp_dV_D_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_D_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_G_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_G_S)*0.3333333333333+0.5*(-d_temp_dV_G_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_G_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
TP = (1.80485e-35/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
}
}
if ((temp1>0.0))
{

d_TP2_dTemp_Tnode_GND = (temp1*((0.5*temp1)*d_temp1_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp1_dTemp_Tnode_GND*(1.0+(temp1*0.3333333333333)))+d_temp1_dTemp_Tnode_GND*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
d_TP2_dV_D_S = (temp1*((0.5*temp1)*d_temp1_dV_D_S*0.3333333333333+0.5*d_temp1_dV_D_S*(1.0+(temp1*0.3333333333333)))+d_temp1_dV_D_S*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
d_TP2_dV_G_S = (temp1*((0.5*temp1)*d_temp1_dV_G_S*0.3333333333333+0.5*d_temp1_dV_G_S*(1.0+(temp1*0.3333333333333)))+d_temp1_dV_G_S*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
d_TP2_dV_S_B = (temp1*((0.5*temp1)*d_temp1_dV_S_B*0.3333333333333+0.5*d_temp1_dV_S_B*(1.0+(temp1*0.3333333333333)))+d_temp1_dV_S_B*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
TP2 = (1.0+(temp1*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333))))));
}
else
{
if ((temp1>(-80.0)))
{
{
double value_exp_0 = exp(temp1);
double  deriv_exp_0_d0 = value_exp_0;

d_TP2_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp1_dTemp_Tnode_GND));
d_TP2_dV_D_S = (deriv_exp_0_d0*(d_temp1_dV_D_S));
d_TP2_dV_G_S = (deriv_exp_0_d0*(d_temp1_dV_G_S));
d_TP2_dV_S_B = (deriv_exp_0_d0*(d_temp1_dV_S_B));
TP2 = value_exp_0;
}
}
else
{

d_TP2_dTemp_Tnode_GND = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp1_dTemp_Tnode_GND)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dTemp_Tnode_GND)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_TP2_dV_D_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_D_S)*0.3333333333333+0.5*(-d_temp1_dV_D_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_D_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_TP2_dV_G_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_G_S)*0.3333333333333+0.5*(-d_temp1_dV_G_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_G_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_TP2_dV_S_B = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_S_B)*0.3333333333333+0.5*(-d_temp1_dV_S_B)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_S_B)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
TP2 = (1.80485e-35/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
}
}

d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (((1.0+Dgate)*d_Dsi_dTemp_Tnode_GND-(1.0+Dsi)*d_Dgate_dTemp_Tnode_GND)/(1.0+Dgate)/(1.0+Dgate));
d_temp_dV_G_S = (((1.0+Dgate)*d_Dsi_dV_G_S-(1.0+Dsi)*d_Dgate_dV_G_S)/(1.0+Dgate)/(1.0+Dgate));
temp = ((1.0+Dsi)/(1.0+Dgate));
if ((temp<1.0e-80))
{

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = 1.0e-80;
}

d_temp1_dV_S_B = d_temp1_dTemp_Tnode_GND =  0.0;
d_temp1_dV_D_S = GCDOV_i*d_Vgdu_dV_D_S;
d_temp1_dV_G_S = GCDOV_i*d_Vgdu_dV_G_S;
temp1 = (GCDOV_i*(Vgdu-GCVDOV_i));
if ((fabs(temp1)<80.0))
{
{
double value_exp_0 = exp(temp1);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp1_dTemp_Tnode_GND));
d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp1_dV_D_S));
d_temp2_dV_G_S = (deriv_exp_0_d0*(d_temp1_dV_G_S));
d_temp2_dV_S_B = (deriv_exp_0_d0*(d_temp1_dV_S_B));
temp2 = value_exp_0;
}
}
else
{
if ((temp1<(-80.0)))
{

d_temp2_dTemp_Tnode_GND = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp1_dTemp_Tnode_GND)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dTemp_Tnode_GND)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_temp2_dV_D_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_D_S)*0.3333333333333+0.5*(-d_temp1_dV_D_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_D_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_temp2_dV_G_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_G_S)*0.3333333333333+0.5*(-d_temp1_dV_G_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_G_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_temp2_dV_S_B = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_S_B)*0.3333333333333+0.5*(-d_temp1_dV_S_B)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_S_B)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
temp2 = (1.80485e-35/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
}
else
{

d_temp2_dTemp_Tnode_GND = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp1_dTemp_Tnode_GND*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dTemp_Tnode_GND*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
d_temp2_dV_D_S = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dV_D_S*0.3333333333333+0.5*d_temp1_dV_D_S*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dV_D_S*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
d_temp2_dV_G_S = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dV_G_S*0.3333333333333+0.5*d_temp1_dV_G_S*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dV_G_S*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
d_temp2_dV_S_B = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dV_S_B*0.3333333333333+0.5*d_temp1_dV_S_B*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dV_S_B*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
temp2 = (5.54062e34*(1.0+((temp1-80.0)*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))))));
}
}

d_temp3_dTemp_Tnode_GND = d_temp1_dTemp_Tnode_GND;
d_temp3_dV_G_S = d_temp1_dV_G_S;
d_temp3_dV_S_B = d_temp1_dV_S_B;
d_temp3_dV_D_S = (GCDOV_i*d_Vsdu_dV_D_S+d_temp1_dV_D_S);
temp3 = ((GCDOV_i*Vsdu)+temp1);
if ((fabs(temp3)<80.0))
{
{
double value_exp_0 = exp(temp3);
double  deriv_exp_0_d0 = value_exp_0;

d_temp4_dV_S_B = (deriv_exp_0_d0*(d_temp3_dV_S_B));
d_temp4_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp3_dTemp_Tnode_GND));
d_temp4_dV_D_S = (deriv_exp_0_d0*(d_temp3_dV_D_S));
d_temp4_dV_G_S = (deriv_exp_0_d0*(d_temp3_dV_G_S));
temp4 = value_exp_0;
}
}
else
{
if ((temp3<(-80.0)))
{

d_temp4_dV_S_B = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_S_B)*0.3333333333333+0.5*(-d_temp3_dV_S_B)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_S_B)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dTemp_Tnode_GND = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp3_dTemp_Tnode_GND)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dTemp_Tnode_GND)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_D_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_D_S)*0.3333333333333+0.5*(-d_temp3_dV_D_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_D_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_G_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_G_S)*0.3333333333333+0.5*(-d_temp3_dV_G_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_G_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
temp4 = (1.80485e-35/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
}
else
{

d_temp4_dV_S_B = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_S_B*0.3333333333333+0.5*d_temp3_dV_S_B*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_S_B*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dTemp_Tnode_GND = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp3_dTemp_Tnode_GND*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dTemp_Tnode_GND*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_D_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_D_S*0.3333333333333+0.5*d_temp3_dV_D_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_D_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_G_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_G_S*0.3333333333333+0.5*d_temp3_dV_G_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_G_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
temp4 = (5.54062e34*(1.0+((temp3-80.0)*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))))));
}
}
{
double value_log_0 = log(temp);
double  deriv_log_0_d0 = (1.0/temp);

d_Igsov_dV_D_S = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dV_D_S+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dV_D_S))+(igoveff*d_TP_dV_D_S+d_igoveff_dV_D_S*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dV_D_S)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dV_D_S+(igovefffowler*d_TP2_dV_D_S+d_igovefffowler_dV_D_S*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dV_D_S)/(1.0+temp4)/(1.0+temp4)));
d_Igsov_dV_G_S = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dV_G_S+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dV_G_S))+(igoveff*d_TP_dV_G_S+d_igoveff_dV_G_S*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dV_G_S)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dV_G_S+(igovefffowler*d_TP2_dV_G_S+d_igovefffowler_dV_G_S*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dV_G_S)/(1.0+temp4)/(1.0+temp4)));
d_Igsov_dV_S_B = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dV_S_B+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dV_S_B))+(igoveff*d_TP_dV_S_B+d_igoveff_dV_S_B*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dV_S_B)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dV_S_B+(igovefffowler*d_TP2_dV_S_B+d_igovefffowler_dV_S_B*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dV_S_B)/(1.0+temp4)/(1.0+temp4)));
d_Igsov_dTemp_Tnode_GND = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dTemp_Tnode_GND+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dTemp_Tnode_GND))+(igoveff*d_TP_dTemp_Tnode_GND+d_igoveff_dTemp_Tnode_GND*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dTemp_Tnode_GND)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dTemp_Tnode_GND+(igovefffowler*d_TP2_dTemp_Tnode_GND+d_igovefffowler_dTemp_Tnode_GND*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dTemp_Tnode_GND)/(1.0+temp4)/(1.0+temp4)));
Igsov = (((((igoveff*TP)*value_log_0)*(1.0+temp2))/(1.0+temp4))-(((igovefffowler*TP2)*(1.0+temp2))/(1.0+temp4)));
}
}
if (((IGOVINVD_i>0.0)||(IGOVACCD_i>0.0)))
{

d_arg2mina_dV_S_B =  0.0;
d_arg2mina_dV_D_S = d_Vovd_dV_D_S;
d_arg2mina_dV_G_S = d_Vovd_dV_G_S;
d_arg2mina_dTemp_Tnode_GND = (d_Vovd_dTemp_Tnode_GND+d_Dov_dTemp_Tnode_GND);
arg2mina = (Vovd+Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psi_t_dV_S_B =  0.0;
d_psi_t_dV_G_S = 0.5*(d_arg2mina_dV_G_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_G_S)+(-d_arg2mina_dV_G_S)*(-arg2mina)))));
d_psi_t_dTemp_Tnode_GND = 0.5*(d_arg2mina_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dTemp_Tnode_GND)+(-d_arg2mina_dTemp_Tnode_GND)*(-arg2mina)))));
d_psi_t_dV_D_S = 0.5*(d_arg2mina_dV_D_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_D_S)+(-d_arg2mina_dV_D_S)*(-arg2mina)))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_B =  0.0;
d_zg_dV_D_S = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_D_S+d_Vovd_dV_D_S*Vovd)))*inv_CHIB;
d_zg_dV_G_S = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_G_S+d_Vovd_dV_G_S*Vovd)))*inv_CHIB;
d_zg_dTemp_Tnode_GND = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dTemp_Tnode_GND+d_Vovd_dTemp_Tnode_GND*Vovd)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((fabs((0.5*xgd_ov))<80.0))
{
{
double value_exp_0 = exp((0.5*xgd_ov));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*(0.5*d_xgd_ov_dTemp_Tnode_GND));
d_temp_dV_D_S = (deriv_exp_0_d0*(0.5*d_xgd_ov_dV_D_S));
d_temp_dV_G_S = (deriv_exp_0_d0*(0.5*d_xgd_ov_dV_G_S));
temp = value_exp_0;
}
}
else
{
if (((0.5*xgd_ov)<(-80.0)))
{

d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (-1.80485e-35*((((-0.5)*xgd_ov)-80.0)*((0.5*(((-0.5)*xgd_ov)-80.0))*(-0.5)*d_xgd_ov_dTemp_Tnode_GND*0.3333333333333+0.5*(-0.5)*d_xgd_ov_dTemp_Tnode_GND*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))+(-0.5)*d_xgd_ov_dTemp_Tnode_GND*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333))))))/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))));
d_temp_dV_D_S = (-1.80485e-35*((((-0.5)*xgd_ov)-80.0)*((0.5*(((-0.5)*xgd_ov)-80.0))*(-0.5)*d_xgd_ov_dV_D_S*0.3333333333333+0.5*(-0.5)*d_xgd_ov_dV_D_S*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))+(-0.5)*d_xgd_ov_dV_D_S*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333))))))/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))));
d_temp_dV_G_S = (-1.80485e-35*((((-0.5)*xgd_ov)-80.0)*((0.5*(((-0.5)*xgd_ov)-80.0))*(-0.5)*d_xgd_ov_dV_G_S*0.3333333333333+0.5*(-0.5)*d_xgd_ov_dV_G_S*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))+(-0.5)*d_xgd_ov_dV_G_S*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333))))))/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))));
temp = (1.80485e-35/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))));
}
else
{

d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = 5.54062e34*(((0.5*xgd_ov)-80.0)*((0.5*((0.5*xgd_ov)-80.0))*0.5*d_xgd_ov_dTemp_Tnode_GND*0.3333333333333+0.5*0.5*d_xgd_ov_dTemp_Tnode_GND*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))+0.5*d_xgd_ov_dTemp_Tnode_GND*(1.0+((0.5*((0.5*xgd_ov)-80.0))*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))));
d_temp_dV_D_S = 5.54062e34*(((0.5*xgd_ov)-80.0)*((0.5*((0.5*xgd_ov)-80.0))*0.5*d_xgd_ov_dV_D_S*0.3333333333333+0.5*0.5*d_xgd_ov_dV_D_S*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))+0.5*d_xgd_ov_dV_D_S*(1.0+((0.5*((0.5*xgd_ov)-80.0))*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))));
d_temp_dV_G_S = 5.54062e34*(((0.5*xgd_ov)-80.0)*((0.5*((0.5*xgd_ov)-80.0))*0.5*d_xgd_ov_dV_G_S*0.3333333333333+0.5*0.5*d_xgd_ov_dV_G_S*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))+0.5*d_xgd_ov_dV_G_S*(1.0+((0.5*((0.5*xgd_ov)-80.0))*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))));
temp = (5.54062e34*(1.0+(((0.5*xgd_ov)-80.0)*(1.0+((0.5*((0.5*xgd_ov)-80.0))*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))))));
}
}

d_temp1_dTemp_Tnode_GND = (-d_temp_dTemp_Tnode_GND/(1.0+temp)/(1.0+temp));
d_temp1_dV_S_B = (-d_temp_dV_S_B/(1.0+temp)/(1.0+temp));
d_temp1_dV_D_S = (-d_temp_dV_D_S/(1.0+temp)/(1.0+temp));
d_temp1_dV_G_S = (-d_temp_dV_G_S/(1.0+temp)/(1.0+temp));
temp1 = (1.0/(1.0+temp));

d_temp2_dTemp_Tnode_GND = (-d_temp1_dTemp_Tnode_GND);
d_temp2_dV_D_S = (-d_temp1_dV_D_S);
d_temp2_dV_G_S = (-d_temp1_dV_G_S);
d_temp2_dV_S_B = (-d_temp1_dV_S_B);
temp2 = (1.0-temp1);

d_gc2oveff_dTemp_Tnode_GND = (GC2OVACC_i*d_temp1_dTemp_Tnode_GND+GC2OVINV_i*d_temp2_dTemp_Tnode_GND);
d_gc2oveff_dV_D_S = (GC2OVACC_i*d_temp1_dV_D_S+GC2OVINV_i*d_temp2_dV_D_S);
d_gc2oveff_dV_G_S = (GC2OVACC_i*d_temp1_dV_G_S+GC2OVINV_i*d_temp2_dV_G_S);
d_gc2oveff_dV_S_B = (GC2OVACC_i*d_temp1_dV_S_B+GC2OVINV_i*d_temp2_dV_S_B);
gc2oveff = ((GC2OVACC_i*temp1)+(GC2OVINV_i*temp2));

d_gc3oveff_dTemp_Tnode_GND = (GC3OVACC_i*d_temp1_dTemp_Tnode_GND+GC3OVINV_i*d_temp2_dTemp_Tnode_GND);
d_gc3oveff_dV_D_S = (GC3OVACC_i*d_temp1_dV_D_S+GC3OVINV_i*d_temp2_dV_D_S);
d_gc3oveff_dV_G_S = (GC3OVACC_i*d_temp1_dV_G_S+GC3OVINV_i*d_temp2_dV_G_S);
d_gc3oveff_dV_S_B = (GC3OVACC_i*d_temp1_dV_S_B+GC3OVINV_i*d_temp2_dV_S_B);
gc3oveff = ((GC3OVACC_i*temp1)+(GC3OVINV_i*temp2));

d_gcqoveff_dTemp_Tnode_GND = (GCQOVACC*d_temp1_dTemp_Tnode_GND+GCQOVINV*d_temp2_dTemp_Tnode_GND);
d_gcqoveff_dV_D_S = (GCQOVACC*d_temp1_dV_D_S+GCQOVINV*d_temp2_dV_D_S);
d_gcqoveff_dV_G_S = (GCQOVACC*d_temp1_dV_G_S+GCQOVINV*d_temp2_dV_G_S);
d_gcqoveff_dV_S_B = (GCQOVACC*d_temp1_dV_S_B+GCQOVINV*d_temp2_dV_S_B);
gcqoveff = ((GCQOVACC*temp1)+(GCQOVINV*temp2));

d_igoveff_dV_D_S = (IGOVACCD_i*d_temp1_dV_D_S+IGOVINVD_i*d_temp2_dV_D_S);
d_igoveff_dV_G_S = (IGOVACCD_i*d_temp1_dV_G_S+IGOVINVD_i*d_temp2_dV_G_S);
d_igoveff_dV_S_B = (IGOVACCD_i*d_temp1_dV_S_B+IGOVINVD_i*d_temp2_dV_S_B);
d_igoveff_dTemp_Tnode_GND = ((IGOVACCD_i*d_temp1_dTemp_Tnode_GND+d_IGOVACCD_i_dTemp_Tnode_GND*temp1)+(IGOVINVD_i*d_temp2_dTemp_Tnode_GND+d_IGOVINVD_i_dTemp_Tnode_GND*temp2));
igoveff = ((IGOVACCD_i*temp1)+(IGOVINVD_i*temp2));

d_igovefffowler_dV_S_B = FNOVINVD_i*d_temp2_dV_S_B*1.0e-6;
d_igovefffowler_dV_D_S = FNOVINVD_i*d_temp2_dV_D_S*1.0e-6;
d_igovefffowler_dV_G_S = FNOVINVD_i*d_temp2_dV_G_S*1.0e-6;
d_igovefffowler_dTemp_Tnode_GND = (FNOVINVD_i*d_temp2_dTemp_Tnode_GND+d_FNOVINVD_i_dTemp_Tnode_GND*temp2)*1.0e-6;
igovefffowler = ((FNOVINVD_i*temp2)*1.0e-6);

d_temp1_dV_G_S = BOV*(-((-1.0)*GCOVINVFN_i)*d_zg_dV_G_S/zg/zg);
d_temp1_dTemp_Tnode_GND = BOV*(-((-1.0)*GCOVINVFN_i)*d_zg_dTemp_Tnode_GND/zg/zg);
d_temp1_dV_D_S = BOV*(-((-1.0)*GCOVINVFN_i)*d_zg_dV_D_S/zg/zg);
d_temp1_dV_S_B = BOV*(-((-1.0)*GCOVINVFN_i)*d_zg_dV_S_B/zg/zg);
temp1 = (BOV*(((-1.0)*GCOVINVFN_i)/zg));
if ((gc3oveff<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-gcqoveff)*(zg-gcqoveff))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_G_S = 0.5*((d_zg_dV_G_S+d_gcqoveff_dV_G_S)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dV_G_S-d_gcqoveff_dV_G_S)+(d_zg_dV_G_S-d_gcqoveff_dV_G_S)*(zg-gcqoveff)))));
d_zg_dTemp_Tnode_GND = 0.5*((d_zg_dTemp_Tnode_GND+d_gcqoveff_dTemp_Tnode_GND)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dTemp_Tnode_GND-d_gcqoveff_dTemp_Tnode_GND)+(d_zg_dTemp_Tnode_GND-d_gcqoveff_dTemp_Tnode_GND)*(zg-gcqoveff)))));
d_zg_dV_D_S = 0.5*((d_zg_dV_D_S+d_gcqoveff_dV_D_S)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dV_D_S-d_gcqoveff_dV_D_S)+(d_zg_dV_D_S-d_gcqoveff_dV_D_S)*(zg-gcqoveff)))));
d_zg_dV_S_B = 0.5*((d_zg_dV_S_B+d_gcqoveff_dV_S_B)-(deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dV_S_B-d_gcqoveff_dV_S_B)+(d_zg_dV_S_B-d_gcqoveff_dV_S_B)*(zg-gcqoveff)))));
zg = (0.5*((zg+gcqoveff)-value_sqrt_0));
}
}

d_arg1_dV_S_B =  0.0;
d_arg1_dTemp_Tnode_GND = (d_xd_ov_dTemp_Tnode_GND+(psi_t*d_inv_phit0_dTemp_Tnode_GND+d_psi_t_dTemp_Tnode_GND*inv_phit0));
d_arg1_dV_D_S = (d_xd_ov_dV_D_S+d_psi_t_dV_D_S*inv_phit0);
d_arg1_dV_G_S = (d_xd_ov_dV_G_S+d_psi_t_dV_G_S*inv_phit0);
arg1 = ((3.0+xd_ov)+(psi_t*inv_phit0));
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dsi_dV_S_B =  0.0;
d_Dsi_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_arg1_dTemp_Tnode_GND));
d_Dsi_dV_G_S = (deriv_exp_0_d0*(d_arg1_dV_G_S));
d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{

d_Dsi_dV_S_B =  0.0;
d_Dsi_dTemp_Tnode_GND = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_arg1_dTemp_Tnode_GND)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dTemp_Tnode_GND)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dsi_dV_G_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_G_S)*0.3333333333333+0.5*(-d_arg1_dV_G_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_G_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dsi_dV_D_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_D_S)*0.3333333333333+0.5*(-d_arg1_dV_D_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_D_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dsi = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{

d_Dsi_dV_S_B =  0.0;
d_Dsi_dTemp_Tnode_GND = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dTemp_Tnode_GND*0.3333333333333+0.5*d_arg1_dTemp_Tnode_GND*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dTemp_Tnode_GND*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dsi_dV_G_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_G_S*0.3333333333333+0.5*d_arg1_dV_G_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_G_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dsi_dV_D_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_D_S*0.3333333333333+0.5*d_arg1_dV_D_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_D_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dsi = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}

d_arg1_dV_S_B =  0.0;
d_arg1_dTemp_Tnode_GND = ((d_xd_ov_dTemp_Tnode_GND+(psi_t*d_inv_phit0_dTemp_Tnode_GND+d_psi_t_dTemp_Tnode_GND*inv_phit0))+d_xgd_ov_dTemp_Tnode_GND);
d_arg1_dV_D_S = ((d_xd_ov_dV_D_S+d_psi_t_dV_D_S*inv_phit0)+d_xgd_ov_dV_D_S);
d_arg1_dV_G_S = ((d_xd_ov_dV_G_S+d_psi_t_dV_G_S*inv_phit0)+d_xgd_ov_dV_G_S);
arg1 = (((3.0+xd_ov)+(psi_t*inv_phit0))+xgd_ov);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dgate_dV_S_B =  0.0;
d_Dgate_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_arg1_dTemp_Tnode_GND));
d_Dgate_dV_G_S = (deriv_exp_0_d0*(d_arg1_dV_G_S));
d_Dgate_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
Dgate = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{

d_Dgate_dV_S_B =  0.0;
d_Dgate_dTemp_Tnode_GND = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_arg1_dTemp_Tnode_GND)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dTemp_Tnode_GND)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dgate_dV_G_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_G_S)*0.3333333333333+0.5*(-d_arg1_dV_G_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_G_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dgate_dV_D_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_D_S)*0.3333333333333+0.5*(-d_arg1_dV_D_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_D_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dgate = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{

d_Dgate_dV_S_B =  0.0;
d_Dgate_dTemp_Tnode_GND = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dTemp_Tnode_GND*0.3333333333333+0.5*d_arg1_dTemp_Tnode_GND*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dTemp_Tnode_GND*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dgate_dV_G_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_G_S*0.3333333333333+0.5*d_arg1_dV_G_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_G_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dgate_dV_D_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_D_S*0.3333333333333+0.5*d_arg1_dV_D_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_D_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dgate = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}

d_temp_dV_G_S = BOV*(zg*(d_gc2oveff_dV_G_S+(gc3oveff*d_zg_dV_G_S+d_gc3oveff_dV_G_S*zg))+d_zg_dV_G_S*(gc2oveff+(gc3oveff*zg)));
d_temp_dTemp_Tnode_GND = BOV*(zg*(d_gc2oveff_dTemp_Tnode_GND+(gc3oveff*d_zg_dTemp_Tnode_GND+d_gc3oveff_dTemp_Tnode_GND*zg))+d_zg_dTemp_Tnode_GND*(gc2oveff+(gc3oveff*zg)));
d_temp_dV_D_S = BOV*(zg*(d_gc2oveff_dV_D_S+(gc3oveff*d_zg_dV_D_S+d_gc3oveff_dV_D_S*zg))+d_zg_dV_D_S*(gc2oveff+(gc3oveff*zg)));
d_temp_dV_S_B = BOV*(zg*(d_gc2oveff_dV_S_B+(gc3oveff*d_zg_dV_S_B+d_gc3oveff_dV_S_B*zg))+d_zg_dV_S_B*(gc2oveff+(gc3oveff*zg)));
temp = (BOV*((-1.5)+(zg*(gc2oveff+(gc3oveff*zg)))));
if ((temp>0.0))
{

d_TP_dTemp_Tnode_GND = (temp*((0.5*temp)*d_temp_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp_dTemp_Tnode_GND*(1.0+(temp*0.3333333333333)))+d_temp_dTemp_Tnode_GND*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_S_B = (temp*((0.5*temp)*d_temp_dV_S_B*0.3333333333333+0.5*d_temp_dV_S_B*(1.0+(temp*0.3333333333333)))+d_temp_dV_S_B*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_D_S = (temp*((0.5*temp)*d_temp_dV_D_S*0.3333333333333+0.5*d_temp_dV_D_S*(1.0+(temp*0.3333333333333)))+d_temp_dV_D_S*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_G_S = (temp*((0.5*temp)*d_temp_dV_G_S*0.3333333333333+0.5*d_temp_dV_G_S*(1.0+(temp*0.3333333333333)))+d_temp_dV_G_S*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
TP = (1.0+(temp*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333))))));
}
else
{
if ((temp>(-80.0)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp_dTemp_Tnode_GND));
d_TP_dV_S_B = (deriv_exp_0_d0*(d_temp_dV_S_B));
d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_TP_dV_G_S = (deriv_exp_0_d0*(d_temp_dV_G_S));
TP = value_exp_0;
}
}
else
{

d_TP_dTemp_Tnode_GND = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp_dTemp_Tnode_GND)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dTemp_Tnode_GND)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_S_B = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_S_B)*0.3333333333333+0.5*(-d_temp_dV_S_B)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_S_B)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_D_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_D_S)*0.3333333333333+0.5*(-d_temp_dV_D_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_D_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_G_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_G_S)*0.3333333333333+0.5*(-d_temp_dV_G_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_G_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
TP = (1.80485e-35/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
}
}
if ((temp1>0.0))
{

d_TP2_dTemp_Tnode_GND = (temp1*((0.5*temp1)*d_temp1_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp1_dTemp_Tnode_GND*(1.0+(temp1*0.3333333333333)))+d_temp1_dTemp_Tnode_GND*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
d_TP2_dV_D_S = (temp1*((0.5*temp1)*d_temp1_dV_D_S*0.3333333333333+0.5*d_temp1_dV_D_S*(1.0+(temp1*0.3333333333333)))+d_temp1_dV_D_S*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
d_TP2_dV_G_S = (temp1*((0.5*temp1)*d_temp1_dV_G_S*0.3333333333333+0.5*d_temp1_dV_G_S*(1.0+(temp1*0.3333333333333)))+d_temp1_dV_G_S*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
d_TP2_dV_S_B = (temp1*((0.5*temp1)*d_temp1_dV_S_B*0.3333333333333+0.5*d_temp1_dV_S_B*(1.0+(temp1*0.3333333333333)))+d_temp1_dV_S_B*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333)))));
TP2 = (1.0+(temp1*(1.0+((0.5*temp1)*(1.0+(temp1*0.3333333333333))))));
}
else
{
if ((temp1>(-80.0)))
{
{
double value_exp_0 = exp(temp1);
double  deriv_exp_0_d0 = value_exp_0;

d_TP2_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp1_dTemp_Tnode_GND));
d_TP2_dV_D_S = (deriv_exp_0_d0*(d_temp1_dV_D_S));
d_TP2_dV_G_S = (deriv_exp_0_d0*(d_temp1_dV_G_S));
d_TP2_dV_S_B = (deriv_exp_0_d0*(d_temp1_dV_S_B));
TP2 = value_exp_0;
}
}
else
{

d_TP2_dTemp_Tnode_GND = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp1_dTemp_Tnode_GND)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dTemp_Tnode_GND)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_TP2_dV_D_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_D_S)*0.3333333333333+0.5*(-d_temp1_dV_D_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_D_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_TP2_dV_G_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_G_S)*0.3333333333333+0.5*(-d_temp1_dV_G_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_G_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_TP2_dV_S_B = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_S_B)*0.3333333333333+0.5*(-d_temp1_dV_S_B)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_S_B)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
TP2 = (1.80485e-35/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
}
}

d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = (((1.0+Dgate)*d_Dsi_dTemp_Tnode_GND-(1.0+Dsi)*d_Dgate_dTemp_Tnode_GND)/(1.0+Dgate)/(1.0+Dgate));
d_temp_dV_G_S = (((1.0+Dgate)*d_Dsi_dV_G_S-(1.0+Dsi)*d_Dgate_dV_G_S)/(1.0+Dgate)/(1.0+Dgate));
d_temp_dV_D_S = (((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate));
temp = ((1.0+Dsi)/(1.0+Dgate));
if ((temp<1.0e-80))
{

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = 1.0e-80;
}

d_temp1_dV_S_B = d_temp1_dV_D_S = d_temp1_dTemp_Tnode_GND =  0.0;
d_temp1_dV_G_S = GCDOV_i*d_Vgsu_dV_G_S;
temp1 = (GCDOV_i*(Vgsu-GCVDOV_i));
if ((fabs(temp1)<80.0))
{
{
double value_exp_0 = exp(temp1);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp1_dTemp_Tnode_GND));
d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp1_dV_D_S));
d_temp2_dV_G_S = (deriv_exp_0_d0*(d_temp1_dV_G_S));
d_temp2_dV_S_B = (deriv_exp_0_d0*(d_temp1_dV_S_B));
temp2 = value_exp_0;
}
}
else
{
if ((temp1<(-80.0)))
{

d_temp2_dTemp_Tnode_GND = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp1_dTemp_Tnode_GND)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dTemp_Tnode_GND)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_temp2_dV_D_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_D_S)*0.3333333333333+0.5*(-d_temp1_dV_D_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_D_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_temp2_dV_G_S = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_G_S)*0.3333333333333+0.5*(-d_temp1_dV_G_S)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_G_S)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
d_temp2_dV_S_B = (-1.80485e-35*(((-temp1)-80.0)*((0.5*((-temp1)-80.0))*(-d_temp1_dV_S_B)*0.3333333333333+0.5*(-d_temp1_dV_S_B)*(1.0+(((-temp1)-80.0)*0.3333333333333)))+(-d_temp1_dV_S_B)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333))))))/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
temp2 = (1.80485e-35/(1.0+(((-temp1)-80.0)*(1.0+((0.5*((-temp1)-80.0))*(1.0+(((-temp1)-80.0)*0.3333333333333)))))));
}
else
{

d_temp2_dTemp_Tnode_GND = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp1_dTemp_Tnode_GND*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dTemp_Tnode_GND*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
d_temp2_dV_D_S = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dV_D_S*0.3333333333333+0.5*d_temp1_dV_D_S*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dV_D_S*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
d_temp2_dV_G_S = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dV_G_S*0.3333333333333+0.5*d_temp1_dV_G_S*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dV_G_S*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
d_temp2_dV_S_B = 5.54062e34*((temp1-80.0)*((0.5*(temp1-80.0))*d_temp1_dV_S_B*0.3333333333333+0.5*d_temp1_dV_S_B*(1.0+((temp1-80.0)*0.3333333333333)))+d_temp1_dV_S_B*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))));
temp2 = (5.54062e34*(1.0+((temp1-80.0)*(1.0+((0.5*(temp1-80.0))*(1.0+((temp1-80.0)*0.3333333333333)))))));
}
}

d_temp3_dTemp_Tnode_GND = d_temp1_dTemp_Tnode_GND;
d_temp3_dV_G_S = d_temp1_dV_G_S;
d_temp3_dV_S_B = d_temp1_dV_S_B;
d_temp3_dV_D_S = (GCDOV_i*d_Vdsu_dV_D_S+d_temp1_dV_D_S);
temp3 = ((GCDOV_i*Vdsu)+temp1);
if ((fabs(temp3)<80.0))
{
{
double value_exp_0 = exp(temp3);
double  deriv_exp_0_d0 = value_exp_0;

d_temp4_dV_S_B = (deriv_exp_0_d0*(d_temp3_dV_S_B));
d_temp4_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp3_dTemp_Tnode_GND));
d_temp4_dV_D_S = (deriv_exp_0_d0*(d_temp3_dV_D_S));
d_temp4_dV_G_S = (deriv_exp_0_d0*(d_temp3_dV_G_S));
temp4 = value_exp_0;
}
}
else
{
if ((temp3<(-80.0)))
{

d_temp4_dV_S_B = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_S_B)*0.3333333333333+0.5*(-d_temp3_dV_S_B)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_S_B)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dTemp_Tnode_GND = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp3_dTemp_Tnode_GND)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dTemp_Tnode_GND)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_D_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_D_S)*0.3333333333333+0.5*(-d_temp3_dV_D_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_D_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_G_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_G_S)*0.3333333333333+0.5*(-d_temp3_dV_G_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_G_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
temp4 = (1.80485e-35/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
}
else
{

d_temp4_dV_S_B = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_S_B*0.3333333333333+0.5*d_temp3_dV_S_B*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_S_B*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dTemp_Tnode_GND = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp3_dTemp_Tnode_GND*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dTemp_Tnode_GND*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_D_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_D_S*0.3333333333333+0.5*d_temp3_dV_D_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_D_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_G_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_G_S*0.3333333333333+0.5*d_temp3_dV_G_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_G_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
temp4 = (5.54062e34*(1.0+((temp3-80.0)*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))))));
}
}
{
double value_log_0 = log(temp);
double  deriv_log_0_d0 = (1.0/temp);

d_Igdov_dV_D_S = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dV_D_S+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dV_D_S))+(igoveff*d_TP_dV_D_S+d_igoveff_dV_D_S*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dV_D_S)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dV_D_S+(igovefffowler*d_TP2_dV_D_S+d_igovefffowler_dV_D_S*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dV_D_S)/(1.0+temp4)/(1.0+temp4)));
d_Igdov_dV_G_S = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dV_G_S+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dV_G_S))+(igoveff*d_TP_dV_G_S+d_igoveff_dV_G_S*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dV_G_S)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dV_G_S+(igovefffowler*d_TP2_dV_G_S+d_igovefffowler_dV_G_S*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dV_G_S)/(1.0+temp4)/(1.0+temp4)));
d_Igdov_dV_S_B = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dV_S_B+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dV_S_B))+(igoveff*d_TP_dV_S_B+d_igoveff_dV_S_B*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dV_S_B)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dV_S_B+(igovefffowler*d_TP2_dV_S_B+d_igovefffowler_dV_S_B*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dV_S_B)/(1.0+temp4)/(1.0+temp4)));
d_Igdov_dTemp_Tnode_GND = ((((1.0+temp4)*(((igoveff*TP)*value_log_0)*d_temp2_dTemp_Tnode_GND+((igoveff*TP)*(deriv_log_0_d0*(d_temp_dTemp_Tnode_GND))+(igoveff*d_TP_dTemp_Tnode_GND+d_igoveff_dTemp_Tnode_GND*TP)*value_log_0)*(1.0+temp2))-(((igoveff*TP)*value_log_0)*(1.0+temp2))*d_temp4_dTemp_Tnode_GND)/(1.0+temp4)/(1.0+temp4))-(((1.0+temp4)*((igovefffowler*TP2)*d_temp2_dTemp_Tnode_GND+(igovefffowler*d_TP2_dTemp_Tnode_GND+d_igovefffowler_dTemp_Tnode_GND*TP2)*(1.0+temp2))-((igovefffowler*TP2)*(1.0+temp2))*d_temp4_dTemp_Tnode_GND)/(1.0+temp4)/(1.0+temp4)));
Igdov = (((((igoveff*TP)*value_log_0)*(1.0+temp2))/(1.0+temp4))-(((igovefffowler*TP2)*(1.0+temp2))/(1.0+temp4)));
}
}
if ((IGINV_i>0.0))
{

d_half_x_ds_dV_S_B = ((-delta_k1q1)*d_inv_k1_dV_S_B+(-d_delta_k1q1_dV_S_B)*inv_k1);
d_half_x_ds_dTemp_Tnode_GND = ((-delta_k1q1)*d_inv_k1_dTemp_Tnode_GND+(-d_delta_k1q1_dTemp_Tnode_GND)*inv_k1);
d_half_x_ds_dV_D_S = ((-delta_k1q1)*d_inv_k1_dV_D_S+(-d_delta_k1q1_dV_D_S)*inv_k1);
d_half_x_ds_dV_G_S = ((-delta_k1q1)*d_inv_k1_dV_G_S+(-d_delta_k1q1_dV_G_S)*inv_k1);
half_x_ds = ((-delta_k1q1)*inv_k1);
if ((fabs(((2.0*half_x_ds)-xdeff))<80.0))
{
{
double value_exp_0 = exp(((2.0*half_x_ds)-xdeff));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_B = (deriv_exp_0_d0*((2.0*d_half_x_ds_dV_S_B-d_xdeff_dV_S_B)));
d_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*((2.0*d_half_x_ds_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)));
d_temp_dV_D_S = (deriv_exp_0_d0*((2.0*d_half_x_ds_dV_D_S-d_xdeff_dV_D_S)));
d_temp_dV_G_S = (deriv_exp_0_d0*((2.0*d_half_x_ds_dV_G_S-d_xdeff_dV_G_S)));
temp = value_exp_0;
}
}
else
{
if ((((2.0*half_x_ds)-xdeff)<(-80.0)))
{

d_temp_dV_S_B = (-1.80485e-35*(((((-2.0)*half_x_ds)-xdeff)-80.0)*((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*((-2.0)*d_half_x_ds_dV_S_B-d_xdeff_dV_S_B)*0.3333333333333+0.5*((-2.0)*d_half_x_ds_dV_S_B-d_xdeff_dV_S_B)*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+((-2.0)*d_half_x_ds_dV_S_B-d_xdeff_dV_S_B)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333))))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))));
d_temp_dTemp_Tnode_GND = (-1.80485e-35*(((((-2.0)*half_x_ds)-xdeff)-80.0)*((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*((-2.0)*d_half_x_ds_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)*0.3333333333333+0.5*((-2.0)*d_half_x_ds_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+((-2.0)*d_half_x_ds_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333))))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))));
d_temp_dV_D_S = (-1.80485e-35*(((((-2.0)*half_x_ds)-xdeff)-80.0)*((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*((-2.0)*d_half_x_ds_dV_D_S-d_xdeff_dV_D_S)*0.3333333333333+0.5*((-2.0)*d_half_x_ds_dV_D_S-d_xdeff_dV_D_S)*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+((-2.0)*d_half_x_ds_dV_D_S-d_xdeff_dV_D_S)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333))))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))));
d_temp_dV_G_S = (-1.80485e-35*(((((-2.0)*half_x_ds)-xdeff)-80.0)*((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*((-2.0)*d_half_x_ds_dV_G_S-d_xdeff_dV_G_S)*0.3333333333333+0.5*((-2.0)*d_half_x_ds_dV_G_S-d_xdeff_dV_G_S)*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+((-2.0)*d_half_x_ds_dV_G_S-d_xdeff_dV_G_S)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333))))))/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))));
temp = (1.80485e-35/(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))));
}
else
{

d_temp_dV_S_B = 5.54062e34*((((2.0*half_x_ds)-xdeff)-80.0)*((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(2.0*d_half_x_ds_dV_S_B-d_xdeff_dV_S_B)*0.3333333333333+0.5*(2.0*d_half_x_ds_dV_S_B-d_xdeff_dV_S_B)*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+(2.0*d_half_x_ds_dV_S_B-d_xdeff_dV_S_B)*(1.0+((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))));
d_temp_dTemp_Tnode_GND = 5.54062e34*((((2.0*half_x_ds)-xdeff)-80.0)*((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(2.0*d_half_x_ds_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)*0.3333333333333+0.5*(2.0*d_half_x_ds_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+(2.0*d_half_x_ds_dTemp_Tnode_GND-d_xdeff_dTemp_Tnode_GND)*(1.0+((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))));
d_temp_dV_D_S = 5.54062e34*((((2.0*half_x_ds)-xdeff)-80.0)*((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(2.0*d_half_x_ds_dV_D_S-d_xdeff_dV_D_S)*0.3333333333333+0.5*(2.0*d_half_x_ds_dV_D_S-d_xdeff_dV_D_S)*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+(2.0*d_half_x_ds_dV_D_S-d_xdeff_dV_D_S)*(1.0+((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))));
d_temp_dV_G_S = 5.54062e34*((((2.0*half_x_ds)-xdeff)-80.0)*((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(2.0*d_half_x_ds_dV_G_S-d_xdeff_dV_G_S)*0.3333333333333+0.5*(2.0*d_half_x_ds_dV_G_S-d_xdeff_dV_G_S)*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))+(2.0*d_half_x_ds_dV_G_S-d_xdeff_dV_G_S)*(1.0+((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))));
temp = (5.54062e34*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*(1.0+((0.5*(((2.0*half_x_ds)-xdeff)-80.0))*(1.0+((((2.0*half_x_ds)-xdeff)-80.0)*0.3333333333333)))))));
}
}
{
double value_log_0 = log((1.0+temp));
double  deriv_log_0_d0 = (1.0/(1.0+temp));

d_Vm_dV_S_B = phit*(d_half_x_ds_dV_S_B-(deriv_log_0_d0*(d_temp_dV_S_B)));
d_Vm_dV_D_S = phit*(d_half_x_ds_dV_D_S-(deriv_log_0_d0*(d_temp_dV_D_S)));
d_Vm_dV_G_S = phit*(d_half_x_ds_dV_G_S-(deriv_log_0_d0*(d_temp_dV_G_S)));
d_Vm_dTemp_Tnode_GND = (phit*(d_half_x_ds_dTemp_Tnode_GND-(deriv_log_0_d0*(d_temp_dTemp_Tnode_GND)))+d_phit_dTemp_Tnode_GND*((half_x_ds+0.6931471805599)-value_log_0));
Vm = (phit*((half_x_ds+0.6931471805599)-value_log_0));
}

d_q1m_dV_S_B = 0.5*(d_q1s_dV_S_B+d_q1d_dV_S_B);
d_q1m_dV_D_S = 0.5*(d_q1s_dV_D_S+d_q1d_dV_D_S);
d_q1m_dV_G_S = 0.5*(d_q1s_dV_G_S+d_q1d_dV_G_S);
d_q1m_dTemp_Tnode_GND = 0.5*(d_q1s_dTemp_Tnode_GND+d_q1d_dTemp_Tnode_GND);
q1m = (0.5*(q1s+q1d));

d_Voxm_dV_S_B = phit*d_q1m_dV_S_B;
d_Voxm_dV_D_S = phit*d_q1m_dV_D_S;
d_Voxm_dV_G_S = phit*d_q1m_dV_G_S;
d_Voxm_dTemp_Tnode_GND = (phit*d_q1m_dTemp_Tnode_GND+d_phit_dTemp_Tnode_GND*q1m);
Voxm = (phit*q1m);

d_arg2mina_dV_S_B = d_Voxm_dV_S_B;
d_arg2mina_dV_D_S = d_Voxm_dV_D_S;
d_arg2mina_dV_G_S = d_Voxm_dV_G_S;
d_arg2mina_dTemp_Tnode_GND = (d_Voxm_dTemp_Tnode_GND+d_Dch_dTemp_Tnode_GND);
arg2mina = (Voxm+Dch);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psi_t_dV_G_S = 0.5*(d_arg2mina_dV_G_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_G_S)+(-d_arg2mina_dV_G_S)*(-arg2mina)))));
d_psi_t_dTemp_Tnode_GND = 0.5*(d_arg2mina_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dTemp_Tnode_GND)+(-d_arg2mina_dTemp_Tnode_GND)*(-arg2mina)))));
d_psi_t_dV_D_S = 0.5*(d_arg2mina_dV_D_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_D_S)+(-d_arg2mina_dV_D_S)*(-arg2mina)))));
d_psi_t_dV_S_B = 0.5*(d_arg2mina_dV_S_B-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_S_B)+(-d_arg2mina_dV_S_B)*(-arg2mina)))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_B = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_S_B+d_Voxm_dV_S_B*Voxm)))*inv_CHIB;
d_zg_dV_D_S = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_D_S+d_Voxm_dV_D_S*Voxm)))*inv_CHIB;
d_zg_dV_G_S = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_G_S+d_Voxm_dV_G_S*Voxm)))*inv_CHIB;
d_zg_dTemp_Tnode_GND = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dTemp_Tnode_GND+d_Voxm_dTemp_Tnode_GND*Voxm)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((GC3CH_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-GCQCH)*(zg-GCQCH))+1.0e-06));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_G_S = 0.5*(d_zg_dV_G_S-(deriv_sqrt_0_d0*(((zg-GCQCH)*d_zg_dV_G_S+d_zg_dV_G_S*(zg-GCQCH)))));
d_zg_dTemp_Tnode_GND = 0.5*(d_zg_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((zg-GCQCH)*d_zg_dTemp_Tnode_GND+d_zg_dTemp_Tnode_GND*(zg-GCQCH)))));
d_zg_dV_D_S = 0.5*(d_zg_dV_D_S-(deriv_sqrt_0_d0*(((zg-GCQCH)*d_zg_dV_D_S+d_zg_dV_D_S*(zg-GCQCH)))));
d_zg_dV_S_B = 0.5*(d_zg_dV_S_B-(deriv_sqrt_0_d0*(((zg-GCQCH)*d_zg_dV_S_B+d_zg_dV_S_B*(zg-GCQCH)))));
zg = (0.5*((zg+GCQCH)-value_sqrt_0));
}
}

d_x_m_dV_S_B = (d_xg1x_dV_S_B-d_q1m_dV_S_B);
d_x_m_dV_D_S = (d_xg1x_dV_D_S-d_q1m_dV_D_S);
d_x_m_dV_G_S = (d_xg1x_dV_G_S-d_q1m_dV_G_S);
d_x_m_dTemp_Tnode_GND = (d_xg1x_dTemp_Tnode_GND-d_q1m_dTemp_Tnode_GND);
x_m = (xg1x-q1m);

d_arg1_dV_S_B = (d_x_m_dV_S_B+(d_psi_t_dV_S_B-d_Vm_dV_S_B)*inv_phit)*n_iginv;
d_arg1_dV_D_S = (d_x_m_dV_D_S+(d_psi_t_dV_D_S-d_Vm_dV_D_S)*inv_phit)*n_iginv;
d_arg1_dV_G_S = (d_x_m_dV_G_S+(d_psi_t_dV_G_S-d_Vm_dV_G_S)*inv_phit)*n_iginv;
d_arg1_dTemp_Tnode_GND = ((x_m+(((psi_t-alpha_b)-Vm)*inv_phit))*d_n_iginv_dTemp_Tnode_GND+(d_x_m_dTemp_Tnode_GND+(((psi_t-alpha_b)-Vm)*d_inv_phit_dTemp_Tnode_GND+((d_psi_t_dTemp_Tnode_GND-d_alpha_b_dTemp_Tnode_GND)-d_Vm_dTemp_Tnode_GND)*inv_phit))*n_iginv);
arg1 = ((x_m+(((psi_t-alpha_b)-Vm)*inv_phit))*n_iginv);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dsi_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_arg1_dTemp_Tnode_GND));
d_Dsi_dV_G_S = (deriv_exp_0_d0*(d_arg1_dV_G_S));
d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
d_Dsi_dV_S_B = (deriv_exp_0_d0*(d_arg1_dV_S_B));
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{

d_Dsi_dTemp_Tnode_GND = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_arg1_dTemp_Tnode_GND)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dTemp_Tnode_GND)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dsi_dV_G_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_G_S)*0.3333333333333+0.5*(-d_arg1_dV_G_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_G_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dsi_dV_D_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_D_S)*0.3333333333333+0.5*(-d_arg1_dV_D_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_D_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_Dsi_dV_S_B = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_S_B)*0.3333333333333+0.5*(-d_arg1_dV_S_B)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_S_B)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dsi = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{

d_Dsi_dTemp_Tnode_GND = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dTemp_Tnode_GND*0.3333333333333+0.5*d_arg1_dTemp_Tnode_GND*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dTemp_Tnode_GND*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dsi_dV_G_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_G_S*0.3333333333333+0.5*d_arg1_dV_G_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_G_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dsi_dV_D_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_D_S*0.3333333333333+0.5*d_arg1_dV_D_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_D_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_Dsi_dV_S_B = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_S_B*0.3333333333333+0.5*d_arg1_dV_S_B*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_S_B*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dsi = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}

d_arg1_dV_S_B = (-(-d_Vm_dV_S_B))*inv_phit*n_iginv;
d_arg1_dTemp_Tnode_GND = (((-(Vgs-Vm))*inv_phit)*d_n_iginv_dTemp_Tnode_GND+((-(Vgs-Vm))*d_inv_phit_dTemp_Tnode_GND+(-(-d_Vm_dTemp_Tnode_GND))*inv_phit)*n_iginv);
d_arg1_dV_D_S = (-(d_Vgs_dV_D_S-d_Vm_dV_D_S))*inv_phit*n_iginv;
d_arg1_dV_G_S = (-(d_Vgs_dV_G_S-d_Vm_dV_G_S))*inv_phit*n_iginv;
arg1 = (((-(Vgs-Vm))*inv_phit)*n_iginv);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_arg1_dTemp_Tnode_GND));
d_temp_dV_G_S = (deriv_exp_0_d0*(d_arg1_dV_G_S));
d_temp_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
d_temp_dV_S_B = (deriv_exp_0_d0*(d_arg1_dV_S_B));
temp = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{

d_temp_dTemp_Tnode_GND = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_arg1_dTemp_Tnode_GND)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dTemp_Tnode_GND)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_temp_dV_G_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_G_S)*0.3333333333333+0.5*(-d_arg1_dV_G_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_G_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_temp_dV_D_S = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_D_S)*0.3333333333333+0.5*(-d_arg1_dV_D_S)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_D_S)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
d_temp_dV_S_B = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dV_S_B)*0.3333333333333+0.5*(-d_arg1_dV_S_B)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dV_S_B)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
temp = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{

d_temp_dTemp_Tnode_GND = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dTemp_Tnode_GND*0.3333333333333+0.5*d_arg1_dTemp_Tnode_GND*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dTemp_Tnode_GND*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_temp_dV_G_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_G_S*0.3333333333333+0.5*d_arg1_dV_G_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_G_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_temp_dV_D_S = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_D_S*0.3333333333333+0.5*d_arg1_dV_D_S*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_D_S*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
d_temp_dV_S_B = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dV_S_B*0.3333333333333+0.5*d_arg1_dV_S_B*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dV_S_B*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
temp = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}

d_Dgate_dTemp_Tnode_GND = (Dsi*d_temp_dTemp_Tnode_GND+d_Dsi_dTemp_Tnode_GND*temp);
d_Dgate_dV_G_S = (Dsi*d_temp_dV_G_S+d_Dsi_dV_G_S*temp);
d_Dgate_dV_D_S = (Dsi*d_temp_dV_D_S+d_Dsi_dV_D_S*temp);
d_Dgate_dV_S_B = (Dsi*d_temp_dV_S_B+d_Dsi_dV_S_B*temp);
Dgate = (Dsi*temp);

d_temp_dV_G_S = BCH*(zg*GC3CH_i*d_zg_dV_G_S+d_zg_dV_G_S*(GC2CH_i+(GC3CH_i*zg)));
d_temp_dTemp_Tnode_GND = BCH*(zg*GC3CH_i*d_zg_dTemp_Tnode_GND+d_zg_dTemp_Tnode_GND*(GC2CH_i+(GC3CH_i*zg)));
d_temp_dV_D_S = BCH*(zg*GC3CH_i*d_zg_dV_D_S+d_zg_dV_D_S*(GC2CH_i+(GC3CH_i*zg)));
d_temp_dV_S_B = BCH*(zg*GC3CH_i*d_zg_dV_S_B+d_zg_dV_S_B*(GC2CH_i+(GC3CH_i*zg)));
temp = (BCH*((-1.5)+(zg*(GC2CH_i+(GC3CH_i*zg)))));
if ((temp>0.0))
{

d_TP_dTemp_Tnode_GND = (temp*((0.5*temp)*d_temp_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp_dTemp_Tnode_GND*(1.0+(temp*0.3333333333333)))+d_temp_dTemp_Tnode_GND*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_S_B = (temp*((0.5*temp)*d_temp_dV_S_B*0.3333333333333+0.5*d_temp_dV_S_B*(1.0+(temp*0.3333333333333)))+d_temp_dV_S_B*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_D_S = (temp*((0.5*temp)*d_temp_dV_D_S*0.3333333333333+0.5*d_temp_dV_D_S*(1.0+(temp*0.3333333333333)))+d_temp_dV_D_S*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
d_TP_dV_G_S = (temp*((0.5*temp)*d_temp_dV_G_S*0.3333333333333+0.5*d_temp_dV_G_S*(1.0+(temp*0.3333333333333)))+d_temp_dV_G_S*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333)))));
TP = (1.0+(temp*(1.0+((0.5*temp)*(1.0+(temp*0.3333333333333))))));
}
else
{
if ((fabs(temp)<80.0))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp_dTemp_Tnode_GND));
d_TP_dV_S_B = (deriv_exp_0_d0*(d_temp_dV_S_B));
d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_TP_dV_G_S = (deriv_exp_0_d0*(d_temp_dV_G_S));
TP = value_exp_0;
}
}
else
{
if ((temp<(-80.0)))
{

d_TP_dTemp_Tnode_GND = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp_dTemp_Tnode_GND)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dTemp_Tnode_GND)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_S_B = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_S_B)*0.3333333333333+0.5*(-d_temp_dV_S_B)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_S_B)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_D_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_D_S)*0.3333333333333+0.5*(-d_temp_dV_D_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_D_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_TP_dV_G_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_G_S)*0.3333333333333+0.5*(-d_temp_dV_G_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_G_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
TP = (1.80485e-35/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
}
else
{

d_TP_dTemp_Tnode_GND = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp_dTemp_Tnode_GND*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dTemp_Tnode_GND*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_TP_dV_S_B = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_S_B*0.3333333333333+0.5*d_temp_dV_S_B*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_S_B*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_TP_dV_D_S = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_D_S*0.3333333333333+0.5*d_temp_dV_D_S*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_D_S*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_TP_dV_G_S = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_G_S*0.3333333333333+0.5*d_temp_dV_G_S*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_G_S*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
TP = (5.54062e34*(1.0+((temp-80.0)*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))))));
}
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

d_Igc0_dV_S_B = ((IGINV_i*TP)*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_S_B-(1.0+Dsi)*d_Dgate_dV_S_B)/(1.0+Dgate)/(1.0+Dgate))))+IGINV_i*d_TP_dV_S_B*value_log_0);
d_Igc0_dV_D_S = ((IGINV_i*TP)*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate))))+IGINV_i*d_TP_dV_D_S*value_log_0);
d_Igc0_dV_G_S = ((IGINV_i*TP)*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_G_S-(1.0+Dsi)*d_Dgate_dV_G_S)/(1.0+Dgate)/(1.0+Dgate))))+IGINV_i*d_TP_dV_G_S*value_log_0);
d_Igc0_dTemp_Tnode_GND = ((IGINV_i*TP)*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dTemp_Tnode_GND-(1.0+Dsi)*d_Dgate_dTemp_Tnode_GND)/(1.0+Dgate)/(1.0+Dgate))))+(IGINV_i*d_TP_dTemp_Tnode_GND+d_IGINV_i_dTemp_Tnode_GND*TP)*value_log_0);
Igc0 = ((IGINV_i*TP)*value_log_0);
}
if (((xg1x<=0.0)||((GC2CH_i==0.0)&&(GC3CH_i==0.0))))
{

d_igc_dV_G_S = d_igc_dV_D_S = d_igc_dTemp_Tnode_GND = d_igc_dV_S_B =  0.0;
igc = 1.0;

d_igcd_h_dV_G_S = d_igcd_h_dV_D_S = d_igcd_h_dTemp_Tnode_GND = d_igcd_h_dV_S_B =  0.0;
igcd_h = 0.5;
}
else
{

d_temp_dV_G_S = (2.0*GC3CH_i)*d_zg_dV_G_S;
d_temp_dTemp_Tnode_GND = (2.0*GC3CH_i)*d_zg_dTemp_Tnode_GND;
d_temp_dV_D_S = (2.0*GC3CH_i)*d_zg_dV_D_S;
d_temp_dV_S_B = (2.0*GC3CH_i)*d_zg_dV_S_B;
temp = (GC2CH_i+((2.0*GC3CH_i)*zg));

d_u0_dTemp_Tnode_GND = ((CHIB_i/(temp*BCH))*d_inv_phit_dTemp_Tnode_GND+(-CHIB_i*d_temp_dTemp_Tnode_GND*BCH/(temp*BCH)/(temp*BCH))*inv_phit);
d_u0_dV_S_B = (-CHIB_i*d_temp_dV_S_B*BCH/(temp*BCH)/(temp*BCH))*inv_phit;
d_u0_dV_D_S = (-CHIB_i*d_temp_dV_D_S*BCH/(temp*BCH)/(temp*BCH))*inv_phit;
d_u0_dV_G_S = (-CHIB_i*d_temp_dV_G_S*BCH/(temp*BCH)/(temp*BCH))*inv_phit;
u0 = ((CHIB_i/(temp*BCH))*inv_phit);

d_x_dV_S_B = ((u0*d_half_x_ds_dV_S_B-half_x_ds*d_u0_dV_S_B)/u0/u0);
d_x_dTemp_Tnode_GND = ((u0*d_half_x_ds_dTemp_Tnode_GND-half_x_ds*d_u0_dTemp_Tnode_GND)/u0/u0);
d_x_dV_D_S = ((u0*d_half_x_ds_dV_D_S-half_x_ds*d_u0_dV_D_S)/u0/u0);
d_x_dV_G_S = ((u0*d_half_x_ds_dV_G_S-half_x_ds*d_u0_dV_G_S)/u0/u0);
x = (half_x_ds/u0);

d_u0_div_H_dTemp_Tnode_GND = ((u0*inv_k1h1)*d_k1_dTemp_Tnode_GND+(u0*d_inv_k1h1_dTemp_Tnode_GND+d_u0_dTemp_Tnode_GND*inv_k1h1)*k1);
d_u0_div_H_dV_S_B = ((u0*inv_k1h1)*d_k1_dV_S_B+(u0*d_inv_k1h1_dV_S_B+d_u0_dV_S_B*inv_k1h1)*k1);
d_u0_div_H_dV_D_S = ((u0*inv_k1h1)*d_k1_dV_D_S+(u0*d_inv_k1h1_dV_D_S+d_u0_dV_D_S*inv_k1h1)*k1);
d_u0_div_H_dV_G_S = ((u0*inv_k1h1)*d_k1_dV_G_S+(u0*d_inv_k1h1_dV_G_S+d_u0_dV_G_S*inv_k1h1)*k1);
u0_div_H = ((u0*inv_k1h1)*k1);

d_Bg_dTemp_Tnode_GND = (u0_div_H*(-d_u0_div_H_dTemp_Tnode_GND)+d_u0_div_H_dTemp_Tnode_GND*(1.0-u0_div_H))*0.5;
d_Bg_dV_S_B = (u0_div_H*(-d_u0_div_H_dV_S_B)+d_u0_div_H_dV_S_B*(1.0-u0_div_H))*0.5;
d_Bg_dV_D_S = (u0_div_H*(-d_u0_div_H_dV_D_S)+d_u0_div_H_dV_D_S*(1.0-u0_div_H))*0.5;
d_Bg_dV_G_S = (u0_div_H*(-d_u0_div_H_dV_G_S)+d_u0_div_H_dV_G_S*(1.0-u0_div_H))*0.5;
Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);

d_Ag_dTemp_Tnode_GND = (-3.0*d_Bg_dTemp_Tnode_GND);
d_Ag_dV_S_B = (-3.0*d_Bg_dV_S_B);
d_Ag_dV_D_S = (-3.0*d_Bg_dV_D_S);
d_Ag_dV_G_S = (-3.0*d_Bg_dV_G_S);
Ag = (0.5-(3.0*Bg));
if ((x<1.0e-3))
{

d_xsq_dV_S_B = (x*d_x_dV_S_B+d_x_dV_S_B*x);
d_xsq_dTemp_Tnode_GND = (x*d_x_dTemp_Tnode_GND+d_x_dTemp_Tnode_GND*x);
d_xsq_dV_D_S = (x*d_x_dV_D_S+d_x_dV_D_S*x);
d_xsq_dV_G_S = (x*d_x_dV_G_S+d_x_dV_G_S*x);
xsq = (x*x);

d_igc_dV_S_B = (xsq*(d_u0_div_H_dV_S_B*0.3333333333333+((xsq*0.1666666666667)*0.2*d_u0_div_H_dV_S_B+d_xsq_dV_S_B*0.1666666666667*(0.05+(0.2*u0_div_H))))+d_xsq_dV_S_B*((0.1666666666667+(u0_div_H*0.3333333333333))+((xsq*0.1666666666667)*(0.05+(0.2*u0_div_H)))));
d_igc_dTemp_Tnode_GND = (xsq*(d_u0_div_H_dTemp_Tnode_GND*0.3333333333333+((xsq*0.1666666666667)*0.2*d_u0_div_H_dTemp_Tnode_GND+d_xsq_dTemp_Tnode_GND*0.1666666666667*(0.05+(0.2*u0_div_H))))+d_xsq_dTemp_Tnode_GND*((0.1666666666667+(u0_div_H*0.3333333333333))+((xsq*0.1666666666667)*(0.05+(0.2*u0_div_H)))));
d_igc_dV_D_S = (xsq*(d_u0_div_H_dV_D_S*0.3333333333333+((xsq*0.1666666666667)*0.2*d_u0_div_H_dV_D_S+d_xsq_dV_D_S*0.1666666666667*(0.05+(0.2*u0_div_H))))+d_xsq_dV_D_S*((0.1666666666667+(u0_div_H*0.3333333333333))+((xsq*0.1666666666667)*(0.05+(0.2*u0_div_H)))));
d_igc_dV_G_S = (xsq*(d_u0_div_H_dV_G_S*0.3333333333333+((xsq*0.1666666666667)*0.2*d_u0_div_H_dV_G_S+d_xsq_dV_G_S*0.1666666666667*(0.05+(0.2*u0_div_H))))+d_xsq_dV_G_S*((0.1666666666667+(u0_div_H*0.3333333333333))+((xsq*0.1666666666667)*(0.05+(0.2*u0_div_H)))));
igc = (1.0+(xsq*((0.1666666666667+(u0_div_H*0.3333333333333))+((xsq*0.1666666666667)*(0.05+(0.2*u0_div_H))))));

d_igcd_h_dV_S_B = (0.5*d_igc_dV_S_B-((x*0.1666666666667)*(xsq*(0.4*d_Bg_dV_S_B+((0.0285714285714*xsq)*d_Bg_dV_S_B+0.0285714285714*d_xsq_dV_S_B*(0.125+Bg)))+d_xsq_dV_S_B*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg))))+d_x_dV_S_B*0.1666666666667*(1.0+(xsq*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg)))))));
d_igcd_h_dTemp_Tnode_GND = (0.5*d_igc_dTemp_Tnode_GND-((x*0.1666666666667)*(xsq*(0.4*d_Bg_dTemp_Tnode_GND+((0.0285714285714*xsq)*d_Bg_dTemp_Tnode_GND+0.0285714285714*d_xsq_dTemp_Tnode_GND*(0.125+Bg)))+d_xsq_dTemp_Tnode_GND*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg))))+d_x_dTemp_Tnode_GND*0.1666666666667*(1.0+(xsq*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg)))))));
d_igcd_h_dV_D_S = (0.5*d_igc_dV_D_S-((x*0.1666666666667)*(xsq*(0.4*d_Bg_dV_D_S+((0.0285714285714*xsq)*d_Bg_dV_D_S+0.0285714285714*d_xsq_dV_D_S*(0.125+Bg)))+d_xsq_dV_D_S*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg))))+d_x_dV_D_S*0.1666666666667*(1.0+(xsq*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg)))))));
d_igcd_h_dV_G_S = (0.5*d_igc_dV_G_S-((x*0.1666666666667)*(xsq*(0.4*d_Bg_dV_G_S+((0.0285714285714*xsq)*d_Bg_dV_G_S+0.0285714285714*d_xsq_dV_G_S*(0.125+Bg)))+d_xsq_dV_G_S*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg))))+d_x_dV_G_S*0.1666666666667*(1.0+(xsq*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg)))))));
igcd_h = ((0.5*igc)-((x*0.1666666666667)*(1.0+(xsq*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg)))))));
}
else
{

d_inv_x_dV_S_B = (-d_x_dV_S_B/x/x);
d_inv_x_dTemp_Tnode_GND = (-d_x_dTemp_Tnode_GND/x/x);
d_inv_x_dV_D_S = (-d_x_dV_D_S/x/x);
d_inv_x_dV_G_S = (-d_x_dV_G_S/x/x);
inv_x = (1.0/x);
if ((fabs(x)<80.0))
{
{
double value_exp_0 = exp(x);
double  deriv_exp_0_d0 = value_exp_0;

d_ex_dV_S_B = (deriv_exp_0_d0*(d_x_dV_S_B));
d_ex_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_x_dTemp_Tnode_GND));
d_ex_dV_D_S = (deriv_exp_0_d0*(d_x_dV_D_S));
d_ex_dV_G_S = (deriv_exp_0_d0*(d_x_dV_G_S));
ex = value_exp_0;
}
}
else
{
if ((x<(-80.0)))
{

d_ex_dV_S_B = (-1.80485e-35*(((-x)-80.0)*((0.5*((-x)-80.0))*(-d_x_dV_S_B)*0.3333333333333+0.5*(-d_x_dV_S_B)*(1.0+(((-x)-80.0)*0.3333333333333)))+(-d_x_dV_S_B)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333))))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))));
d_ex_dTemp_Tnode_GND = (-1.80485e-35*(((-x)-80.0)*((0.5*((-x)-80.0))*(-d_x_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_x_dTemp_Tnode_GND)*(1.0+(((-x)-80.0)*0.3333333333333)))+(-d_x_dTemp_Tnode_GND)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333))))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))));
d_ex_dV_D_S = (-1.80485e-35*(((-x)-80.0)*((0.5*((-x)-80.0))*(-d_x_dV_D_S)*0.3333333333333+0.5*(-d_x_dV_D_S)*(1.0+(((-x)-80.0)*0.3333333333333)))+(-d_x_dV_D_S)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333))))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))));
d_ex_dV_G_S = (-1.80485e-35*(((-x)-80.0)*((0.5*((-x)-80.0))*(-d_x_dV_G_S)*0.3333333333333+0.5*(-d_x_dV_G_S)*(1.0+(((-x)-80.0)*0.3333333333333)))+(-d_x_dV_G_S)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333))))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))));
ex = (1.80485e-35/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))));
}
else
{

d_ex_dV_S_B = 5.54062e34*((x-80.0)*((0.5*(x-80.0))*d_x_dV_S_B*0.3333333333333+0.5*d_x_dV_S_B*(1.0+((x-80.0)*0.3333333333333)))+d_x_dV_S_B*(1.0+((0.5*(x-80.0))*(1.0+((x-80.0)*0.3333333333333)))));
d_ex_dTemp_Tnode_GND = 5.54062e34*((x-80.0)*((0.5*(x-80.0))*d_x_dTemp_Tnode_GND*0.3333333333333+0.5*d_x_dTemp_Tnode_GND*(1.0+((x-80.0)*0.3333333333333)))+d_x_dTemp_Tnode_GND*(1.0+((0.5*(x-80.0))*(1.0+((x-80.0)*0.3333333333333)))));
d_ex_dV_D_S = 5.54062e34*((x-80.0)*((0.5*(x-80.0))*d_x_dV_D_S*0.3333333333333+0.5*d_x_dV_D_S*(1.0+((x-80.0)*0.3333333333333)))+d_x_dV_D_S*(1.0+((0.5*(x-80.0))*(1.0+((x-80.0)*0.3333333333333)))));
d_ex_dV_G_S = 5.54062e34*((x-80.0)*((0.5*(x-80.0))*d_x_dV_G_S*0.3333333333333+0.5*d_x_dV_G_S*(1.0+((x-80.0)*0.3333333333333)))+d_x_dV_G_S*(1.0+((0.5*(x-80.0))*(1.0+((x-80.0)*0.3333333333333)))));
ex = (5.54062e34*(1.0+((x-80.0)*(1.0+((0.5*(x-80.0))*(1.0+((x-80.0)*0.3333333333333)))))));
}
}

d_inv_ex_dV_S_B = (-d_ex_dV_S_B/ex/ex);
d_inv_ex_dTemp_Tnode_GND = (-d_ex_dTemp_Tnode_GND/ex/ex);
d_inv_ex_dV_D_S = (-d_ex_dV_D_S/ex/ex);
d_inv_ex_dV_G_S = (-d_ex_dV_G_S/ex/ex);
inv_ex = (1.0/ex);

d_temp_dV_S_B = (d_ex_dV_S_B-d_inv_ex_dV_S_B);
d_temp_dTemp_Tnode_GND = (d_ex_dTemp_Tnode_GND-d_inv_ex_dTemp_Tnode_GND);
d_temp_dV_D_S = (d_ex_dV_D_S-d_inv_ex_dV_D_S);
d_temp_dV_G_S = (d_ex_dV_G_S-d_inv_ex_dV_G_S);
temp = (ex-inv_ex);

d_temp2_dV_S_B = (d_ex_dV_S_B+d_inv_ex_dV_S_B);
d_temp2_dTemp_Tnode_GND = (d_ex_dTemp_Tnode_GND+d_inv_ex_dTemp_Tnode_GND);
d_temp2_dV_D_S = (d_ex_dV_D_S+d_inv_ex_dV_D_S);
d_temp2_dV_G_S = (d_ex_dV_G_S+d_inv_ex_dV_G_S);
temp2 = (ex+inv_ex);

d_igc_dTemp_Tnode_GND = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dTemp_Tnode_GND+((1.0-u0_div_H)*d_temp_dTemp_Tnode_GND+(-d_u0_div_H_dTemp_Tnode_GND)*temp)*inv_x)+(u0_div_H*d_temp2_dTemp_Tnode_GND+d_u0_div_H_dTemp_Tnode_GND*temp2));
d_igc_dV_S_B = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_S_B+((1.0-u0_div_H)*d_temp_dV_S_B+(-d_u0_div_H_dV_S_B)*temp)*inv_x)+(u0_div_H*d_temp2_dV_S_B+d_u0_div_H_dV_S_B*temp2));
d_igc_dV_D_S = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_D_S+((1.0-u0_div_H)*d_temp_dV_D_S+(-d_u0_div_H_dV_D_S)*temp)*inv_x)+(u0_div_H*d_temp2_dV_D_S+d_u0_div_H_dV_D_S*temp2));
d_igc_dV_G_S = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_G_S+((1.0-u0_div_H)*d_temp_dV_G_S+(-d_u0_div_H_dV_G_S)*temp)*inv_x)+(u0_div_H*d_temp2_dV_G_S+d_u0_div_H_dV_G_S*temp2));
igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));

d_igcd_h_dV_S_B = 0.5*((d_igc_dV_S_B-(temp*(d_Bg_dV_S_B-((Ag*inv_x)*d_inv_x_dV_S_B+(Ag*d_inv_x_dV_S_B+d_Ag_dV_S_B*inv_x)*inv_x))+d_temp_dV_S_B*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_S_B+(Ag*d_temp2_dV_S_B+d_Ag_dV_S_B*temp2)*inv_x));
d_igcd_h_dTemp_Tnode_GND = 0.5*((d_igc_dTemp_Tnode_GND-(temp*(d_Bg_dTemp_Tnode_GND-((Ag*inv_x)*d_inv_x_dTemp_Tnode_GND+(Ag*d_inv_x_dTemp_Tnode_GND+d_Ag_dTemp_Tnode_GND*inv_x)*inv_x))+d_temp_dTemp_Tnode_GND*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dTemp_Tnode_GND+(Ag*d_temp2_dTemp_Tnode_GND+d_Ag_dTemp_Tnode_GND*temp2)*inv_x));
d_igcd_h_dV_D_S = 0.5*((d_igc_dV_D_S-(temp*(d_Bg_dV_D_S-((Ag*inv_x)*d_inv_x_dV_D_S+(Ag*d_inv_x_dV_D_S+d_Ag_dV_D_S*inv_x)*inv_x))+d_temp_dV_D_S*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_D_S+(Ag*d_temp2_dV_D_S+d_Ag_dV_D_S*temp2)*inv_x));
d_igcd_h_dV_G_S = 0.5*((d_igc_dV_G_S-(temp*(d_Bg_dV_G_S-((Ag*inv_x)*d_inv_x_dV_G_S+(Ag*d_inv_x_dV_G_S+d_Ag_dV_G_S*inv_x)*inv_x))+d_temp_dV_G_S*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_G_S+(Ag*d_temp2_dV_G_S+d_Ag_dV_G_S*temp2)*inv_x));
igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
}
}

d_Igc_dV_S_B = (Igc0*d_igc_dV_S_B+d_Igc0_dV_S_B*igc);
d_Igc_dV_D_S = (Igc0*d_igc_dV_D_S+d_Igc0_dV_D_S*igc);
d_Igc_dV_G_S = (Igc0*d_igc_dV_G_S+d_Igc0_dV_G_S*igc);
d_Igc_dTemp_Tnode_GND = (Igc0*d_igc_dTemp_Tnode_GND+d_Igc0_dTemp_Tnode_GND*igc);
Igc = (Igc0*igc);

d_Igcd_dV_S_B = (Igc0*d_igcd_h_dV_S_B+d_Igc0_dV_S_B*igcd_h);
d_Igcd_dV_D_S = (Igc0*d_igcd_h_dV_D_S+d_Igc0_dV_D_S*igcd_h);
d_Igcd_dV_G_S = (Igc0*d_igcd_h_dV_G_S+d_Igc0_dV_G_S*igcd_h);
d_Igcd_dTemp_Tnode_GND = (Igc0*d_igcd_h_dTemp_Tnode_GND+d_Igc0_dTemp_Tnode_GND*igcd_h);
Igcd = (Igc0*igcd_h);

d_Igcs_dV_S_B = (d_Igc_dV_S_B-d_Igcd_dV_S_B);
d_Igcs_dV_D_S = (d_Igc_dV_D_S-d_Igcd_dV_D_S);
d_Igcs_dV_G_S = (d_Igc_dV_G_S-d_Igcd_dV_G_S);
d_Igcs_dTemp_Tnode_GND = (d_Igc_dTemp_Tnode_GND-d_Igcd_dTemp_Tnode_GND);
Igcs = (Igc-Igcd);
}
if ((sigVds<0.0))
{

d_Igs_dV_S_B = (d_Igcd_dV_S_B+d_Igsov_dV_S_B);
d_Igs_dV_D_S = (d_Igcd_dV_D_S+d_Igsov_dV_D_S);
d_Igs_dV_G_S = (d_Igcd_dV_G_S+d_Igsov_dV_G_S);
d_Igs_dTemp_Tnode_GND = (d_Igcd_dTemp_Tnode_GND+d_Igsov_dTemp_Tnode_GND);
Igs = (Igcd+Igsov);

d_Igd_dV_S_B = (d_Igcs_dV_S_B+d_Igdov_dV_S_B);
d_Igd_dV_D_S = (d_Igcs_dV_D_S+d_Igdov_dV_D_S);
d_Igd_dV_G_S = (d_Igcs_dV_G_S+d_Igdov_dV_G_S);
d_Igd_dTemp_Tnode_GND = (d_Igcs_dTemp_Tnode_GND+d_Igdov_dTemp_Tnode_GND);
Igd = (Igcs+Igdov);
}
else
{

d_Igs_dV_S_B = (d_Igcs_dV_S_B+d_Igsov_dV_S_B);
d_Igs_dV_D_S = (d_Igcs_dV_D_S+d_Igsov_dV_D_S);
d_Igs_dV_G_S = (d_Igcs_dV_G_S+d_Igsov_dV_G_S);
d_Igs_dTemp_Tnode_GND = (d_Igcs_dTemp_Tnode_GND+d_Igsov_dTemp_Tnode_GND);
Igs = (Igcs+Igsov);

d_Igd_dV_S_B = (d_Igcd_dV_S_B+d_Igdov_dV_S_B);
d_Igd_dV_D_S = (d_Igcd_dV_D_S+d_Igdov_dV_D_S);
d_Igd_dV_G_S = (d_Igcd_dV_G_S+d_Igdov_dV_G_S);
d_Igd_dTemp_Tnode_GND = (d_Igcd_dTemp_Tnode_GND+d_Igdov_dTemp_Tnode_GND);
Igd = (Igcd+Igdov);
}
}

d_Igisl_dV_D_S = d_Igisl_dTemp_Tnode_GND = d_Igisl_dV_G_S = d_Igisl_dV_S_B =  0.0;
Igisl = 0.0;
if (((((model_.SWGIDL)>0)&&(AGIDL_i>0.0))&&(Vovs<0.0)))
{
{
double value_sqrt_0 = sqrt((((Vovs*Vovs)+(((CGIDL_i*CGIDL_i)*Vsbu)*Vsbu))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vtovs_dV_S_B = (deriv_sqrt_0_d0*((((CGIDL_i*CGIDL_i)*Vsbu)*d_Vsbu_dV_S_B+(CGIDL_i*CGIDL_i)*d_Vsbu_dV_S_B*Vsbu)));
d_Vtovs_dV_G_S = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_G_S+d_Vovs_dV_G_S*Vovs)));
d_Vtovs_dTemp_Tnode_GND = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dTemp_Tnode_GND+d_Vovs_dTemp_Tnode_GND*Vovs)));
Vtovs = value_sqrt_0;
}

d_temp_dV_D_S =  0.0;
d_temp_dV_S_B = (-(-BGIDL_i)*d_Vtovs_dV_S_B/Vtovs/Vtovs);
d_temp_dV_G_S = (-(-BGIDL_i)*d_Vtovs_dV_G_S/Vtovs/Vtovs);
d_temp_dTemp_Tnode_GND = ((Vtovs*(-d_BGIDL_i_dTemp_Tnode_GND)-(-BGIDL_i)*d_Vtovs_dTemp_Tnode_GND)/Vtovs/Vtovs);
temp = ((-BGIDL_i)/Vtovs);
if ((fabs(temp)<80.0))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp_dTemp_Tnode_GND));
d_temp2_dV_S_B = (deriv_exp_0_d0*(d_temp_dV_S_B));
d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_temp2_dV_G_S = (deriv_exp_0_d0*(d_temp_dV_G_S));
temp2 = value_exp_0;
}
}
else
{
if ((temp<(-80.0)))
{

d_temp2_dTemp_Tnode_GND = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp_dTemp_Tnode_GND)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dTemp_Tnode_GND)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_temp2_dV_S_B = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_S_B)*0.3333333333333+0.5*(-d_temp_dV_S_B)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_S_B)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_temp2_dV_D_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_D_S)*0.3333333333333+0.5*(-d_temp_dV_D_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_D_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_temp2_dV_G_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_G_S)*0.3333333333333+0.5*(-d_temp_dV_G_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_G_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
temp2 = (1.80485e-35/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
}
else
{

d_temp2_dTemp_Tnode_GND = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp_dTemp_Tnode_GND*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dTemp_Tnode_GND*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_temp2_dV_S_B = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_S_B*0.3333333333333+0.5*d_temp_dV_S_B*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_S_B*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_temp2_dV_D_S = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_D_S*0.3333333333333+0.5*d_temp_dV_D_S*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_D_S*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_temp2_dV_G_S = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_G_S*0.3333333333333+0.5*d_temp_dV_G_S*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_G_S*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
temp2 = (5.54062e34*(1.0+((temp-80.0)*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))))));
}
}

d_temp3_dV_G_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
d_temp3_dV_D_S = DGIDL_i*d_Vsdu_dV_D_S;
temp3 = (DGIDL_i*Vsdu);
if ((fabs(temp3)<80.0))
{
{
double value_exp_0 = exp(temp3);
double  deriv_exp_0_d0 = value_exp_0;

d_temp4_dV_S_B = (deriv_exp_0_d0*(d_temp3_dV_S_B));
d_temp4_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp3_dTemp_Tnode_GND));
d_temp4_dV_D_S = (deriv_exp_0_d0*(d_temp3_dV_D_S));
d_temp4_dV_G_S = (deriv_exp_0_d0*(d_temp3_dV_G_S));
temp4 = value_exp_0;
}
}
else
{
if ((temp3<(-80.0)))
{

d_temp4_dV_S_B = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_S_B)*0.3333333333333+0.5*(-d_temp3_dV_S_B)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_S_B)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dTemp_Tnode_GND = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp3_dTemp_Tnode_GND)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dTemp_Tnode_GND)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_D_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_D_S)*0.3333333333333+0.5*(-d_temp3_dV_D_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_D_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_G_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_G_S)*0.3333333333333+0.5*(-d_temp3_dV_G_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_G_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
temp4 = (1.80485e-35/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
}
else
{

d_temp4_dV_S_B = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_S_B*0.3333333333333+0.5*d_temp3_dV_S_B*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_S_B*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dTemp_Tnode_GND = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp3_dTemp_Tnode_GND*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dTemp_Tnode_GND*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_D_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_D_S*0.3333333333333+0.5*d_temp3_dV_D_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_D_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_G_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_G_S*0.3333333333333+0.5*d_temp3_dV_G_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_G_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
temp4 = (5.54062e34*(1.0+((temp3-80.0)*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))))));
}
}

d_Igisl_dV_S_B = (((((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*temp2)*0.5)*d_temp4_dV_S_B+(((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*d_temp2_dV_S_B+(((-AGIDL_i)*Vsdu)*Vovs)*d_Vtovs_dV_S_B*temp2)*0.5*(1.0+temp4));
d_Igisl_dV_G_S = (((((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*temp2)*0.5)*d_temp4_dV_G_S+(((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*d_temp2_dV_G_S+((((-AGIDL_i)*Vsdu)*Vovs)*d_Vtovs_dV_G_S+((-AGIDL_i)*Vsdu)*d_Vovs_dV_G_S*Vtovs)*temp2)*0.5*(1.0+temp4));
d_Igisl_dTemp_Tnode_GND = (((((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*temp2)*0.5)*d_temp4_dTemp_Tnode_GND+(((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*d_temp2_dTemp_Tnode_GND+((((-AGIDL_i)*Vsdu)*Vovs)*d_Vtovs_dTemp_Tnode_GND+((-AGIDL_i)*Vsdu)*d_Vovs_dTemp_Tnode_GND*Vtovs)*temp2)*0.5*(1.0+temp4));
d_Igisl_dV_D_S = (((((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*temp2)*0.5)*d_temp4_dV_D_S+(((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*d_temp2_dV_D_S+(-AGIDL_i)*d_Vsdu_dV_D_S*Vovs*Vtovs*temp2)*0.5*(1.0+temp4));
Igisl = (((((((-AGIDL_i)*Vsdu)*Vovs)*Vtovs)*temp2)*0.5)*(1.0+temp4));
}

d_Igidl_dV_D_S = d_Igidl_dTemp_Tnode_GND = d_Igidl_dV_G_S = d_Igidl_dV_S_B =  0.0;
Igidl = 0.0;
if (((((model_.SWGIDL)>0)&&(AGIDLD_i>0.0))&&(Vovd<0.0)))
{
{
double value_sqrt_0 = sqrt((((Vovd*Vovd)+(((CGIDLD_i*CGIDLD_i)*Vdbu)*Vdbu))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vtovd_dV_S_B = (deriv_sqrt_0_d0*((((CGIDLD_i*CGIDLD_i)*Vdbu)*d_Vdbu_dV_S_B+(CGIDLD_i*CGIDLD_i)*d_Vdbu_dV_S_B*Vdbu)));
d_Vtovd_dV_D_S = (deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_D_S+d_Vovd_dV_D_S*Vovd)+(((CGIDLD_i*CGIDLD_i)*Vdbu)*d_Vdbu_dV_D_S+(CGIDLD_i*CGIDLD_i)*d_Vdbu_dV_D_S*Vdbu))));
d_Vtovd_dV_G_S = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_G_S+d_Vovd_dV_G_S*Vovd)));
d_Vtovd_dTemp_Tnode_GND = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dTemp_Tnode_GND+d_Vovd_dTemp_Tnode_GND*Vovd)));
Vtovd = value_sqrt_0;
}

d_temp_dV_S_B = (-(-BGIDLD_i)*d_Vtovd_dV_S_B/Vtovd/Vtovd);
d_temp_dV_D_S = (-(-BGIDLD_i)*d_Vtovd_dV_D_S/Vtovd/Vtovd);
d_temp_dV_G_S = (-(-BGIDLD_i)*d_Vtovd_dV_G_S/Vtovd/Vtovd);
d_temp_dTemp_Tnode_GND = ((Vtovd*(-d_BGIDLD_i_dTemp_Tnode_GND)-(-BGIDLD_i)*d_Vtovd_dTemp_Tnode_GND)/Vtovd/Vtovd);
temp = ((-BGIDLD_i)/Vtovd);
if ((fabs(temp)<80.0))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp_dTemp_Tnode_GND));
d_temp2_dV_S_B = (deriv_exp_0_d0*(d_temp_dV_S_B));
d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_temp2_dV_G_S = (deriv_exp_0_d0*(d_temp_dV_G_S));
temp2 = value_exp_0;
}
}
else
{
if ((temp<(-80.0)))
{

d_temp2_dTemp_Tnode_GND = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp_dTemp_Tnode_GND)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dTemp_Tnode_GND)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_temp2_dV_S_B = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_S_B)*0.3333333333333+0.5*(-d_temp_dV_S_B)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_S_B)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_temp2_dV_D_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_D_S)*0.3333333333333+0.5*(-d_temp_dV_D_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_D_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
d_temp2_dV_G_S = (-1.80485e-35*(((-temp)-80.0)*((0.5*((-temp)-80.0))*(-d_temp_dV_G_S)*0.3333333333333+0.5*(-d_temp_dV_G_S)*(1.0+(((-temp)-80.0)*0.3333333333333)))+(-d_temp_dV_G_S)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333))))))/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
temp2 = (1.80485e-35/(1.0+(((-temp)-80.0)*(1.0+((0.5*((-temp)-80.0))*(1.0+(((-temp)-80.0)*0.3333333333333)))))));
}
else
{

d_temp2_dTemp_Tnode_GND = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp_dTemp_Tnode_GND*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dTemp_Tnode_GND*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_temp2_dV_S_B = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_S_B*0.3333333333333+0.5*d_temp_dV_S_B*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_S_B*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_temp2_dV_D_S = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_D_S*0.3333333333333+0.5*d_temp_dV_D_S*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_D_S*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
d_temp2_dV_G_S = 5.54062e34*((temp-80.0)*((0.5*(temp-80.0))*d_temp_dV_G_S*0.3333333333333+0.5*d_temp_dV_G_S*(1.0+((temp-80.0)*0.3333333333333)))+d_temp_dV_G_S*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))));
temp2 = (5.54062e34*(1.0+((temp-80.0)*(1.0+((0.5*(temp-80.0))*(1.0+((temp-80.0)*0.3333333333333)))))));
}
}

d_temp3_dV_G_S = d_temp3_dTemp_Tnode_GND = d_temp3_dV_S_B =  0.0;
d_temp3_dV_D_S = DGIDLD_i*d_Vdsu_dV_D_S;
temp3 = (DGIDLD_i*Vdsu);
if ((fabs(temp3)<80.0))
{
{
double value_exp_0 = exp(temp3);
double  deriv_exp_0_d0 = value_exp_0;

d_temp4_dV_S_B = (deriv_exp_0_d0*(d_temp3_dV_S_B));
d_temp4_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp3_dTemp_Tnode_GND));
d_temp4_dV_D_S = (deriv_exp_0_d0*(d_temp3_dV_D_S));
d_temp4_dV_G_S = (deriv_exp_0_d0*(d_temp3_dV_G_S));
temp4 = value_exp_0;
}
}
else
{
if ((temp3<(-80.0)))
{

d_temp4_dV_S_B = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_S_B)*0.3333333333333+0.5*(-d_temp3_dV_S_B)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_S_B)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dTemp_Tnode_GND = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp3_dTemp_Tnode_GND)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dTemp_Tnode_GND)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_D_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_D_S)*0.3333333333333+0.5*(-d_temp3_dV_D_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_D_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
d_temp4_dV_G_S = (-1.80485e-35*(((-temp3)-80.0)*((0.5*((-temp3)-80.0))*(-d_temp3_dV_G_S)*0.3333333333333+0.5*(-d_temp3_dV_G_S)*(1.0+(((-temp3)-80.0)*0.3333333333333)))+(-d_temp3_dV_G_S)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333))))))/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
temp4 = (1.80485e-35/(1.0+(((-temp3)-80.0)*(1.0+((0.5*((-temp3)-80.0))*(1.0+(((-temp3)-80.0)*0.3333333333333)))))));
}
else
{

d_temp4_dV_S_B = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_S_B*0.3333333333333+0.5*d_temp3_dV_S_B*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_S_B*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dTemp_Tnode_GND = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp3_dTemp_Tnode_GND*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dTemp_Tnode_GND*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_D_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_D_S*0.3333333333333+0.5*d_temp3_dV_D_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_D_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
d_temp4_dV_G_S = 5.54062e34*((temp3-80.0)*((0.5*(temp3-80.0))*d_temp3_dV_G_S*0.3333333333333+0.5*d_temp3_dV_G_S*(1.0+((temp3-80.0)*0.3333333333333)))+d_temp3_dV_G_S*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))));
temp4 = (5.54062e34*(1.0+((temp3-80.0)*(1.0+((0.5*(temp3-80.0))*(1.0+((temp3-80.0)*0.3333333333333)))))));
}
}

d_Igidl_dV_S_B = (((((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*temp2)*0.5)*d_temp4_dV_S_B+(((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*d_temp2_dV_S_B+(((-AGIDLD_i)*Vdsu)*Vovd)*d_Vtovd_dV_S_B*temp2)*0.5*(1.0+temp4));
d_Igidl_dV_G_S = (((((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*temp2)*0.5)*d_temp4_dV_G_S+(((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*d_temp2_dV_G_S+((((-AGIDLD_i)*Vdsu)*Vovd)*d_Vtovd_dV_G_S+((-AGIDLD_i)*Vdsu)*d_Vovd_dV_G_S*Vtovd)*temp2)*0.5*(1.0+temp4));
d_Igidl_dTemp_Tnode_GND = (((((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*temp2)*0.5)*d_temp4_dTemp_Tnode_GND+(((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*d_temp2_dTemp_Tnode_GND+((((-AGIDLD_i)*Vdsu)*Vovd)*d_Vtovd_dTemp_Tnode_GND+((-AGIDLD_i)*Vdsu)*d_Vovd_dTemp_Tnode_GND*Vtovd)*temp2)*0.5*(1.0+temp4));
d_Igidl_dV_D_S = (((((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*temp2)*0.5)*d_temp4_dV_D_S+(((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*d_temp2_dV_D_S+((((-AGIDLD_i)*Vdsu)*Vovd)*d_Vtovd_dV_D_S+(((-AGIDLD_i)*Vdsu)*d_Vovd_dV_D_S+(-AGIDLD_i)*d_Vdsu_dV_D_S*Vovd)*Vtovd)*temp2)*0.5*(1.0+temp4));
Igidl = (((((((-AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*temp2)*0.5)*(1.0+temp4));
}

d_mavl_dV_D_S = d_mavl_dTemp_Tnode_GND = d_mavl_dV_G_S = d_mavl_dV_S_B =  0.0;
mavl = 0.0;

d_Iimpact_dV_D_S = d_Iimpact_dTemp_Tnode_GND = d_Iimpact_dV_G_S = d_Iimpact_dV_S_B =  0.0;
Iimpact = 0.0;
if (((model_.SWIMPACT)!=0))
{

d_delVsat_dV_S_B = ((-A3_i*d_xdeff_dV_S_B)/inv_phit);
d_delVsat_dV_G_S = ((-A3_i*d_xdeff_dV_G_S)/inv_phit);
d_delVsat_dTemp_Tnode_GND = ((inv_phit*(d_xd_dTemp_Tnode_GND-A3_i*d_xdeff_dTemp_Tnode_GND)-(xd-(A3_i*xdeff))*d_inv_phit_dTemp_Tnode_GND)/inv_phit/inv_phit);
d_delVsat_dV_D_S = ((d_xd_dV_D_S-A3_i*d_xdeff_dV_D_S)/inv_phit);
delVsat = ((xd-(A3_i*xdeff))/inv_phit);
if ((delVsat>0))
{

d_temp2_dV_S_B = (-((-1.0)*A2_i)*d_delVsat_dV_S_B/(delVsat+1.0e-30)/(delVsat+1.0e-30));
d_temp2_dV_G_S = (-((-1.0)*A2_i)*d_delVsat_dV_G_S/(delVsat+1.0e-30)/(delVsat+1.0e-30));
d_temp2_dV_D_S = (-((-1.0)*A2_i)*d_delVsat_dV_D_S/(delVsat+1.0e-30)/(delVsat+1.0e-30));
d_temp2_dTemp_Tnode_GND = (((delVsat+1.0e-30)*(-1.0)*d_A2_i_dTemp_Tnode_GND-((-1.0)*A2_i)*d_delVsat_dTemp_Tnode_GND)/(delVsat+1.0e-30)/(delVsat+1.0e-30));
temp2 = (((-1.0)*A2_i)/(delVsat+1.0e-30));
if ((fabs(temp2)<80.0))
{
{
double value_exp_0 = exp(temp2);
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_B = (deriv_exp_0_d0*(d_temp2_dV_S_B));
d_temp_dV_D_S = (deriv_exp_0_d0*(d_temp2_dV_D_S));
d_temp_dTemp_Tnode_GND = (deriv_exp_0_d0*(d_temp2_dTemp_Tnode_GND));
d_temp_dV_G_S = (deriv_exp_0_d0*(d_temp2_dV_G_S));
temp = value_exp_0;
}
}
else
{
if ((temp2<(-80.0)))
{

d_temp_dV_S_B = (-1.80485e-35*(((-temp2)-80.0)*((0.5*((-temp2)-80.0))*(-d_temp2_dV_S_B)*0.3333333333333+0.5*(-d_temp2_dV_S_B)*(1.0+(((-temp2)-80.0)*0.3333333333333)))+(-d_temp2_dV_S_B)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333))))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))));
d_temp_dV_D_S = (-1.80485e-35*(((-temp2)-80.0)*((0.5*((-temp2)-80.0))*(-d_temp2_dV_D_S)*0.3333333333333+0.5*(-d_temp2_dV_D_S)*(1.0+(((-temp2)-80.0)*0.3333333333333)))+(-d_temp2_dV_D_S)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333))))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))));
d_temp_dTemp_Tnode_GND = (-1.80485e-35*(((-temp2)-80.0)*((0.5*((-temp2)-80.0))*(-d_temp2_dTemp_Tnode_GND)*0.3333333333333+0.5*(-d_temp2_dTemp_Tnode_GND)*(1.0+(((-temp2)-80.0)*0.3333333333333)))+(-d_temp2_dTemp_Tnode_GND)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333))))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))));
d_temp_dV_G_S = (-1.80485e-35*(((-temp2)-80.0)*((0.5*((-temp2)-80.0))*(-d_temp2_dV_G_S)*0.3333333333333+0.5*(-d_temp2_dV_G_S)*(1.0+(((-temp2)-80.0)*0.3333333333333)))+(-d_temp2_dV_G_S)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333))))))/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))));
temp = (1.80485e-35/(1.0+(((-temp2)-80.0)*(1.0+((0.5*((-temp2)-80.0))*(1.0+(((-temp2)-80.0)*0.3333333333333)))))));
}
else
{

d_temp_dV_S_B = 5.54062e34*((temp2-80.0)*((0.5*(temp2-80.0))*d_temp2_dV_S_B*0.3333333333333+0.5*d_temp2_dV_S_B*(1.0+((temp2-80.0)*0.3333333333333)))+d_temp2_dV_S_B*(1.0+((0.5*(temp2-80.0))*(1.0+((temp2-80.0)*0.3333333333333)))));
d_temp_dV_D_S = 5.54062e34*((temp2-80.0)*((0.5*(temp2-80.0))*d_temp2_dV_D_S*0.3333333333333+0.5*d_temp2_dV_D_S*(1.0+((temp2-80.0)*0.3333333333333)))+d_temp2_dV_D_S*(1.0+((0.5*(temp2-80.0))*(1.0+((temp2-80.0)*0.3333333333333)))));
d_temp_dTemp_Tnode_GND = 5.54062e34*((temp2-80.0)*((0.5*(temp2-80.0))*d_temp2_dTemp_Tnode_GND*0.3333333333333+0.5*d_temp2_dTemp_Tnode_GND*(1.0+((temp2-80.0)*0.3333333333333)))+d_temp2_dTemp_Tnode_GND*(1.0+((0.5*(temp2-80.0))*(1.0+((temp2-80.0)*0.3333333333333)))));
d_temp_dV_G_S = 5.54062e34*((temp2-80.0)*((0.5*(temp2-80.0))*d_temp2_dV_G_S*0.3333333333333+0.5*d_temp2_dV_G_S*(1.0+((temp2-80.0)*0.3333333333333)))+d_temp2_dV_G_S*(1.0+((0.5*(temp2-80.0))*(1.0+((temp2-80.0)*0.3333333333333)))));
temp = (5.54062e34*(1.0+((temp2-80.0)*(1.0+((0.5*(temp2-80.0))*(1.0+((temp2-80.0)*0.3333333333333)))))));
}
}

d_mavl_dV_S_B = ((A1_i*delVsat)*d_temp_dV_S_B+A1_i*d_delVsat_dV_S_B*temp);
d_mavl_dV_G_S = ((A1_i*delVsat)*d_temp_dV_G_S+A1_i*d_delVsat_dV_G_S*temp);
d_mavl_dTemp_Tnode_GND = ((A1_i*delVsat)*d_temp_dTemp_Tnode_GND+A1_i*d_delVsat_dTemp_Tnode_GND*temp);
d_mavl_dV_D_S = ((A1_i*delVsat)*d_temp_dV_D_S+A1_i*d_delVsat_dV_D_S*temp);
mavl = ((A1_i*delVsat)*temp);

d_Iimpact_dV_S_B = (mavl*d_Ids_dV_S_B+d_mavl_dV_S_B*Ids);
d_Iimpact_dV_G_S = (mavl*d_Ids_dV_G_S+d_mavl_dV_G_S*Ids);
d_Iimpact_dTemp_Tnode_GND = (mavl*d_Ids_dTemp_Tnode_GND+d_mavl_dTemp_Tnode_GND*Ids);
d_Iimpact_dV_D_S = (mavl*d_Ids_dV_D_S+d_mavl_dV_D_S*Ids);
Iimpact = (mavl*Ids);
}
}
if (((model_.SWSHE_i)>0))
{
{
double value_fabs_0 = fabs((Ids*Vds));
double  deriv_fabs_0_d0 = ((((Ids*Vds))>=0)?(+1.0):(-1.0));

d_temp_dV_D_S = (deriv_fabs_0_d0*((Ids*d_Vds_dV_D_S+d_Ids_dV_D_S*Vds)))*RTH_i;
d_temp_dV_G_S = (deriv_fabs_0_d0*(d_Ids_dV_G_S*Vds))*RTH_i;
d_temp_dV_S_B = (deriv_fabs_0_d0*(d_Ids_dV_S_B*Vds))*RTH_i;
d_temp_dTemp_Tnode_GND = (value_fabs_0*d_RTH_i_dTemp_Tnode_GND+(deriv_fabs_0_d0*(d_Ids_dTemp_Tnode_GND*Vds))*RTH_i);
temp = (value_fabs_0*RTH_i);
}
if ((temp>(1.0e8*(model_.TMAX))))
{

d_Ithpwr_dV_G_S = d_Ithpwr_dV_D_S = d_Ithpwr_dV_S_B =  0.0;
d_Ithpwr_dTemp_Tnode_GND = (-(-((model_.TMAX)+(0.25/(model_.TMAX))))*d_RTH_i_dTemp_Tnode_GND/RTH_i/RTH_i);
Ithpwr = ((-((model_.TMAX)+(0.25/(model_.TMAX))))/RTH_i);
}
else
{
{
double value_sqrt_0 = sqrt((((temp-(model_.TMAX))*(temp-(model_.TMAX)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Ithpwr_dTemp_Tnode_GND = ((RTH_i*(-(1.0*0.5)*(d_temp_dTemp_Tnode_GND-(deriv_sqrt_0_d0*(((temp-(model_.TMAX))*d_temp_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*(temp-(model_.TMAX)))))))-(-(((1.0*0.5)*((temp+(model_.TMAX))-value_sqrt_0))+(0.25/(model_.TMAX))))*d_RTH_i_dTemp_Tnode_GND)/RTH_i/RTH_i);
d_Ithpwr_dV_S_B = ((-(1.0*0.5)*(d_temp_dV_S_B-(deriv_sqrt_0_d0*(((temp-(model_.TMAX))*d_temp_dV_S_B+d_temp_dV_S_B*(temp-(model_.TMAX)))))))/RTH_i);
d_Ithpwr_dV_D_S = ((-(1.0*0.5)*(d_temp_dV_D_S-(deriv_sqrt_0_d0*(((temp-(model_.TMAX))*d_temp_dV_D_S+d_temp_dV_D_S*(temp-(model_.TMAX)))))))/RTH_i);
d_Ithpwr_dV_G_S = ((-(1.0*0.5)*(d_temp_dV_G_S-(deriv_sqrt_0_d0*(((temp-(model_.TMAX))*d_temp_dV_G_S+d_temp_dV_G_S*(temp-(model_.TMAX)))))))/RTH_i);
Ithpwr = ((-(((1.0*0.5)*((temp+(model_.TMAX))-value_sqrt_0))+(0.25/(model_.TMAX))))/RTH_i);
}
}

d_Ithrc_dTemp_Tnode_GND = ((RTH_i*d_DTC_dTemp_Tnode_GND-DTC*d_RTH_i_dTemp_Tnode_GND)/RTH_i/RTH_i);
Ithrc = (DTC/RTH_i);
}
else
{

d_Ithpwr_dV_G_S = d_Ithpwr_dV_D_S = d_Ithpwr_dV_S_B = d_Ithpwr_dTemp_Tnode_GND =  0.0;
Ithpwr = 0.0;

d_Ithrc_dTemp_Tnode_GND = 0.001*d_probeVars[admsProbeID_Temp_Tnode_GND][admsProbeID_Temp_Tnode_GND];
Ithrc = (0.001*(probeVars[admsProbeID_Temp_Tnode_GND]));
}
}
// End block evaluateStatic
//Begin block evaluateDynamic
{

d_temp_dV_S_B = (((1.0+(0.25*qim))*FSCEAC_i*(d_Dx_WI_1D_dV_S_B-d_Dx_WI_dV_S_B)-(FSCEAC_i*(Dx_WI_1D-Dx_WI))*0.25*d_qim_dV_S_B)/(1.0+(0.25*qim))/(1.0+(0.25*qim)));
d_temp_dTemp_Tnode_GND = (((1.0+(0.25*qim))*FSCEAC_i*(d_Dx_WI_1D_dTemp_Tnode_GND-d_Dx_WI_dTemp_Tnode_GND)-(FSCEAC_i*(Dx_WI_1D-Dx_WI))*0.25*d_qim_dTemp_Tnode_GND)/(1.0+(0.25*qim))/(1.0+(0.25*qim)));
d_temp_dV_D_S = (((1.0+(0.25*qim))*FSCEAC_i*(d_Dx_WI_1D_dV_D_S-d_Dx_WI_dV_D_S)-(FSCEAC_i*(Dx_WI_1D-Dx_WI))*0.25*d_qim_dV_D_S)/(1.0+(0.25*qim))/(1.0+(0.25*qim)));
d_temp_dV_G_S = (((1.0+(0.25*qim))*FSCEAC_i*(d_Dx_WI_1D_dV_G_S-d_Dx_WI_dV_G_S)-(FSCEAC_i*(Dx_WI_1D-Dx_WI))*0.25*d_qim_dV_G_S)/(1.0+(0.25*qim))/(1.0+(0.25*qim)));
temp = ((FSCEAC_i*(Dx_WI_1D-Dx_WI))/(1.0+(0.25*qim)));

d_k1q1m_dV_S_B = (0.5*(d_k1q1s_dV_S_B+d_k1q1d_dV_S_B)+d_temp_dV_S_B);
d_k1q1m_dTemp_Tnode_GND = (0.5*(d_k1q1s_dTemp_Tnode_GND+d_k1q1d_dTemp_Tnode_GND)+d_temp_dTemp_Tnode_GND);
d_k1q1m_dV_D_S = (0.5*(d_k1q1s_dV_D_S+d_k1q1d_dV_D_S)+d_temp_dV_D_S);
d_k1q1m_dV_G_S = (0.5*(d_k1q1s_dV_G_S+d_k1q1d_dV_G_S)+d_temp_dV_G_S);
k1q1m = ((0.5*(k1q1s+k1q1d))+temp);

d_k2q2m_dV_S_B = (0.5*(d_k2q2s_dV_S_B+d_k2q2d_dV_S_B)-d_temp_dV_S_B);
d_k2q2m_dTemp_Tnode_GND = (0.5*(d_k2q2s_dTemp_Tnode_GND+d_k2q2d_dTemp_Tnode_GND)-d_temp_dTemp_Tnode_GND);
d_k2q2m_dV_D_S = (0.5*(d_k2q2s_dV_D_S+d_k2q2d_dV_D_S)-d_temp_dV_D_S);
d_k2q2m_dV_G_S = (0.5*(d_k2q2s_dV_G_S+d_k2q2d_dV_G_S)-d_temp_dV_G_S);
k2q2m = ((0.5*(k2q2s+k2q2d))-temp);
if (((model_.QMC)>0.0))
{

d_k1q1eff_dV_S_B = ((d_k1q1m_dV_S_B+((qmfact1*d_qi1m_dV_S_B-qi1m*d_qmfact1_dV_S_B)/qmfact1/qmfact1))-d_qi1m_dV_S_B);
d_k1q1eff_dTemp_Tnode_GND = ((d_k1q1m_dTemp_Tnode_GND+((qmfact1*d_qi1m_dTemp_Tnode_GND-qi1m*d_qmfact1_dTemp_Tnode_GND)/qmfact1/qmfact1))-d_qi1m_dTemp_Tnode_GND);
d_k1q1eff_dV_D_S = ((d_k1q1m_dV_D_S+((qmfact1*d_qi1m_dV_D_S-qi1m*d_qmfact1_dV_D_S)/qmfact1/qmfact1))-d_qi1m_dV_D_S);
d_k1q1eff_dV_G_S = ((d_k1q1m_dV_G_S+((qmfact1*d_qi1m_dV_G_S-qi1m*d_qmfact1_dV_G_S)/qmfact1/qmfact1))-d_qi1m_dV_G_S);
k1q1eff = ((k1q1m+(qi1m/qmfact1))-qi1m);

d_k2q2eff_dV_S_B = ((d_k2q2m_dV_S_B+((qmfact2*d_qi2m_dV_S_B-qi2m*d_qmfact2_dV_S_B)/qmfact2/qmfact2))-d_qi2m_dV_S_B);
d_k2q2eff_dTemp_Tnode_GND = ((d_k2q2m_dTemp_Tnode_GND+((qmfact2*d_qi2m_dTemp_Tnode_GND-qi2m*d_qmfact2_dTemp_Tnode_GND)/qmfact2/qmfact2))-d_qi2m_dTemp_Tnode_GND);
d_k2q2eff_dV_D_S = ((d_k2q2m_dV_D_S+((qmfact2*d_qi2m_dV_D_S-qi2m*d_qmfact2_dV_D_S)/qmfact2/qmfact2))-d_qi2m_dV_D_S);
d_k2q2eff_dV_G_S = ((d_k2q2m_dV_G_S+((qmfact2*d_qi2m_dV_G_S-qi2m*d_qmfact2_dV_G_S)/qmfact2/qmfact2))-d_qi2m_dV_G_S);
k2q2eff = ((k2q2m+(qi2m/qmfact2))-qi2m);
}
else
{

d_k1q1eff_dV_S_B = d_k1q1m_dV_S_B;
d_k1q1eff_dTemp_Tnode_GND = d_k1q1m_dTemp_Tnode_GND;
d_k1q1eff_dV_D_S = d_k1q1m_dV_D_S;
d_k1q1eff_dV_G_S = d_k1q1m_dV_G_S;
k1q1eff = k1q1m;

d_k2q2eff_dV_S_B = d_k2q2m_dV_S_B;
d_k2q2eff_dTemp_Tnode_GND = d_k2q2m_dTemp_Tnode_GND;
d_k2q2eff_dV_D_S = d_k2q2m_dV_D_S;
d_k2q2eff_dV_G_S = d_k2q2m_dV_G_S;
k2q2eff = k2q2m;
}

d_temp1_dV_S_B = (delta_k1q1*d_prod1_dV_S_B+d_delta_k1q1_dV_S_B*prod1)*0.3333333333333;
d_temp1_dTemp_Tnode_GND = (delta_k1q1*d_prod1_dTemp_Tnode_GND+d_delta_k1q1_dTemp_Tnode_GND*prod1)*0.3333333333333;
d_temp1_dV_D_S = (delta_k1q1*d_prod1_dV_D_S+d_delta_k1q1_dV_D_S*prod1)*0.3333333333333;
d_temp1_dV_G_S = (delta_k1q1*d_prod1_dV_G_S+d_delta_k1q1_dV_G_S*prod1)*0.3333333333333;
temp1 = ((delta_k1q1*prod1)*0.3333333333333);

d_temp2_dV_S_B = ((delta_k1q1*0.1666666666667)*(prod1*(-0.2*d_prod1_dV_S_B)+d_prod1_dV_S_B*(1.0-(0.2*prod1)))+d_delta_k1q1_dV_S_B*0.1666666666667*(1.0+(prod1*(1.0-(0.2*prod1)))));
d_temp2_dTemp_Tnode_GND = ((delta_k1q1*0.1666666666667)*(prod1*(-0.2*d_prod1_dTemp_Tnode_GND)+d_prod1_dTemp_Tnode_GND*(1.0-(0.2*prod1)))+d_delta_k1q1_dTemp_Tnode_GND*0.1666666666667*(1.0+(prod1*(1.0-(0.2*prod1)))));
d_temp2_dV_D_S = ((delta_k1q1*0.1666666666667)*(prod1*(-0.2*d_prod1_dV_D_S)+d_prod1_dV_D_S*(1.0-(0.2*prod1)))+d_delta_k1q1_dV_D_S*0.1666666666667*(1.0+(prod1*(1.0-(0.2*prod1)))));
d_temp2_dV_G_S = ((delta_k1q1*0.1666666666667)*(prod1*(-0.2*d_prod1_dV_G_S)+d_prod1_dV_G_S*(1.0-(0.2*prod1)))+d_delta_k1q1_dV_G_S*0.1666666666667*(1.0+(prod1*(1.0-(0.2*prod1)))));
temp2 = ((delta_k1q1*0.1666666666667)*(1.0+(prod1*(1.0-(0.2*prod1)))));

d_k1q1deff_dV_S_B = (0.5*d_k1q1eff_dV_S_B+d_temp2_dV_S_B);
d_k1q1deff_dTemp_Tnode_GND = (0.5*d_k1q1eff_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND);
d_k1q1deff_dV_D_S = (0.5*d_k1q1eff_dV_D_S+d_temp2_dV_D_S);
d_k1q1deff_dV_G_S = (0.5*d_k1q1eff_dV_G_S+d_temp2_dV_G_S);
k1q1deff = ((0.5*k1q1eff)+temp2);

d_k1q1eff_dV_S_B = (d_k1q1eff_dV_S_B+d_temp1_dV_S_B);
d_k1q1eff_dTemp_Tnode_GND = (d_k1q1eff_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND);
d_k1q1eff_dV_D_S = (d_k1q1eff_dV_D_S+d_temp1_dV_D_S);
d_k1q1eff_dV_G_S = (d_k1q1eff_dV_G_S+d_temp1_dV_G_S);
k1q1eff = (k1q1eff+temp1);

d_temp1_dV_S_B = (delta_k2q2*d_prod2_dV_S_B+d_delta_k2q2_dV_S_B*prod2)*0.3333333333333;
d_temp1_dTemp_Tnode_GND = (delta_k2q2*d_prod2_dTemp_Tnode_GND+d_delta_k2q2_dTemp_Tnode_GND*prod2)*0.3333333333333;
d_temp1_dV_D_S = (delta_k2q2*d_prod2_dV_D_S+d_delta_k2q2_dV_D_S*prod2)*0.3333333333333;
d_temp1_dV_G_S = (delta_k2q2*d_prod2_dV_G_S+d_delta_k2q2_dV_G_S*prod2)*0.3333333333333;
temp1 = ((delta_k2q2*prod2)*0.3333333333333);

d_temp2_dV_S_B = ((delta_k2q2*0.1666666666667)*(prod2*(-0.2*d_prod2_dV_S_B)+d_prod2_dV_S_B*(1.0-(0.2*prod2)))+d_delta_k2q2_dV_S_B*0.1666666666667*(1.0+(prod2*(1.0-(0.2*prod2)))));
d_temp2_dTemp_Tnode_GND = ((delta_k2q2*0.1666666666667)*(prod2*(-0.2*d_prod2_dTemp_Tnode_GND)+d_prod2_dTemp_Tnode_GND*(1.0-(0.2*prod2)))+d_delta_k2q2_dTemp_Tnode_GND*0.1666666666667*(1.0+(prod2*(1.0-(0.2*prod2)))));
d_temp2_dV_D_S = ((delta_k2q2*0.1666666666667)*(prod2*(-0.2*d_prod2_dV_D_S)+d_prod2_dV_D_S*(1.0-(0.2*prod2)))+d_delta_k2q2_dV_D_S*0.1666666666667*(1.0+(prod2*(1.0-(0.2*prod2)))));
d_temp2_dV_G_S = ((delta_k2q2*0.1666666666667)*(prod2*(-0.2*d_prod2_dV_G_S)+d_prod2_dV_G_S*(1.0-(0.2*prod2)))+d_delta_k2q2_dV_G_S*0.1666666666667*(1.0+(prod2*(1.0-(0.2*prod2)))));
temp2 = ((delta_k2q2*0.1666666666667)*(1.0+(prod2*(1.0-(0.2*prod2)))));

d_k2q2deff_dV_S_B = (0.5*d_k2q2eff_dV_S_B+d_temp2_dV_S_B);
d_k2q2deff_dTemp_Tnode_GND = (0.5*d_k2q2eff_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND);
d_k2q2deff_dV_D_S = (0.5*d_k2q2eff_dV_D_S+d_temp2_dV_D_S);
d_k2q2deff_dV_G_S = (0.5*d_k2q2eff_dV_G_S+d_temp2_dV_G_S);
k2q2deff = ((0.5*k2q2eff)+temp2);

d_k2q2eff_dV_S_B = (d_k2q2eff_dV_S_B+d_temp1_dV_S_B);
d_k2q2eff_dTemp_Tnode_GND = (d_k2q2eff_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND);
d_k2q2eff_dV_D_S = (d_k2q2eff_dV_D_S+d_temp1_dV_D_S);
d_k2q2eff_dV_G_S = (d_k2q2eff_dV_G_S+d_temp1_dV_G_S);
k2q2eff = (k2q2eff+temp1);

d_temp_dV_S_B = d_CsiPrime_dV_S_B*area_phit;
d_temp_dTemp_Tnode_GND = (CsiPrime*d_area_phit_dTemp_Tnode_GND+d_CsiPrime_dTemp_Tnode_GND*area_phit);
d_temp_dV_D_S = d_CsiPrime_dV_D_S*area_phit;
d_temp_dV_G_S = d_CsiPrime_dV_G_S*area_phit;
temp = (CsiPrime*area_phit);

d_Qg_dTemp_Tnode_GND = (temp*d_k1q1eff_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*k1q1eff);
d_Qg_dV_S_B = (temp*d_k1q1eff_dV_S_B+d_temp_dV_S_B*k1q1eff);
d_Qg_dV_D_S = (temp*d_k1q1eff_dV_D_S+d_temp_dV_D_S*k1q1eff);
d_Qg_dV_G_S = (temp*d_k1q1eff_dV_G_S+d_temp_dV_G_S*k1q1eff);
Qg = (temp*k1q1eff);

d_Qb_dTemp_Tnode_GND = (temp*d_k2q2eff_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*k2q2eff);
d_Qb_dV_S_B = (temp*d_k2q2eff_dV_S_B+d_temp_dV_S_B*k2q2eff);
d_Qb_dV_D_S = (temp*d_k2q2eff_dV_D_S+d_temp_dV_D_S*k2q2eff);
d_Qb_dV_G_S = (temp*d_k2q2eff_dV_G_S+d_temp_dV_G_S*k2q2eff);
Qb = (temp*k2q2eff);

d_Qd_dTemp_Tnode_GND = ((-temp)*(d_k1q1deff_dTemp_Tnode_GND+d_k2q2deff_dTemp_Tnode_GND)+(-d_temp_dTemp_Tnode_GND)*(k1q1deff+k2q2deff));
d_Qd_dV_S_B = ((-temp)*(d_k1q1deff_dV_S_B+d_k2q2deff_dV_S_B)+(-d_temp_dV_S_B)*(k1q1deff+k2q2deff));
d_Qd_dV_D_S = ((-temp)*(d_k1q1deff_dV_D_S+d_k2q2deff_dV_D_S)+(-d_temp_dV_D_S)*(k1q1deff+k2q2deff));
d_Qd_dV_G_S = ((-temp)*(d_k1q1deff_dV_G_S+d_k2q2deff_dV_G_S)+(-d_temp_dV_G_S)*(k1q1deff+k2q2deff));
Qd = ((-temp)*(k1q1deff+k2q2deff));
if ((FIF_i>0.0))
{

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B =  0.0;
d_temp_dTemp_Tnode_GND = d_xth_1D_dTemp_Tnode_GND;
temp = (xth_1D+(2.0*0.6931471805599));

d_xeffs_dV_S_B = (d_xdrifts_dV_S_B+d_temp_dV_S_B);
d_xeffs_dV_D_S = (d_xdrifts_dV_D_S+d_temp_dV_D_S);
d_xeffs_dV_G_S = (d_xdrifts_dV_G_S+d_temp_dV_G_S);
d_xeffs_dTemp_Tnode_GND = (d_xdrifts_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND);
xeffs = (xdrifts+temp);

d_xeffd_dV_S_B = (d_xdriftd_dV_S_B+d_temp_dV_S_B);
d_xeffd_dV_G_S = (d_xdriftd_dV_G_S+d_temp_dV_G_S);
d_xeffd_dTemp_Tnode_GND = (d_xdriftd_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND);
d_xeffd_dV_D_S = (d_xdriftd_dV_D_S+d_temp_dV_D_S);
xeffd = (xdriftd+temp);
{
double value_sqrt_0 = sqrt((((xeffs-xth_1D)*(xeffs-xth_1D))+9.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xstars_dV_S_B = 0.5*(d_xeffs_dV_S_B-(deriv_sqrt_0_d0*(((xeffs-xth_1D)*d_xeffs_dV_S_B+d_xeffs_dV_S_B*(xeffs-xth_1D)))));
d_xstars_dV_D_S = 0.5*(d_xeffs_dV_D_S-(deriv_sqrt_0_d0*(((xeffs-xth_1D)*d_xeffs_dV_D_S+d_xeffs_dV_D_S*(xeffs-xth_1D)))));
d_xstars_dV_G_S = 0.5*(d_xeffs_dV_G_S-(deriv_sqrt_0_d0*(((xeffs-xth_1D)*d_xeffs_dV_G_S+d_xeffs_dV_G_S*(xeffs-xth_1D)))));
d_xstars_dTemp_Tnode_GND = 0.5*((d_xeffs_dTemp_Tnode_GND+d_xth_1D_dTemp_Tnode_GND)-(deriv_sqrt_0_d0*(((xeffs-xth_1D)*(d_xeffs_dTemp_Tnode_GND-d_xth_1D_dTemp_Tnode_GND)+(d_xeffs_dTemp_Tnode_GND-d_xth_1D_dTemp_Tnode_GND)*(xeffs-xth_1D)))));
xstars = (0.5*((xeffs+xth_1D)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((xeffd-(xth_1D+xd))*(xeffd-(xth_1D+xd)))+9.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xstard_dV_S_B = 0.5*(d_xeffd_dV_S_B-(deriv_sqrt_0_d0*(((xeffd-(xth_1D+xd))*d_xeffd_dV_S_B+d_xeffd_dV_S_B*(xeffd-(xth_1D+xd))))));
d_xstard_dV_G_S = 0.5*(d_xeffd_dV_G_S-(deriv_sqrt_0_d0*(((xeffd-(xth_1D+xd))*d_xeffd_dV_G_S+d_xeffd_dV_G_S*(xeffd-(xth_1D+xd))))));
d_xstard_dTemp_Tnode_GND = 0.5*((d_xeffd_dTemp_Tnode_GND+(d_xth_1D_dTemp_Tnode_GND+d_xd_dTemp_Tnode_GND))-(deriv_sqrt_0_d0*(((xeffd-(xth_1D+xd))*(d_xeffd_dTemp_Tnode_GND-(d_xth_1D_dTemp_Tnode_GND+d_xd_dTemp_Tnode_GND))+(d_xeffd_dTemp_Tnode_GND-(d_xth_1D_dTemp_Tnode_GND+d_xd_dTemp_Tnode_GND))*(xeffd-(xth_1D+xd))))));
d_xstard_dV_D_S = 0.5*((d_xeffd_dV_D_S+d_xd_dV_D_S)-(deriv_sqrt_0_d0*(((xeffd-(xth_1D+xd))*(d_xeffd_dV_D_S-d_xd_dV_D_S)+(d_xeffd_dV_D_S-d_xd_dV_D_S)*(xeffd-(xth_1D+xd))))));
xstard = (0.5*((xeffd+(xth_1D+xd))-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((keq*(0.5+inv_k2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_lambdaf_dV_S_B = lambda2D*(deriv_sqrt_0_d0*((keq*d_inv_k2_dV_S_B+d_keq_dV_S_B*(0.5+inv_k2))));
d_lambdaf_dTemp_Tnode_GND = lambda2D*(deriv_sqrt_0_d0*((keq*d_inv_k2_dTemp_Tnode_GND+d_keq_dTemp_Tnode_GND*(0.5+inv_k2))));
d_lambdaf_dV_D_S = lambda2D*(deriv_sqrt_0_d0*((keq*d_inv_k2_dV_D_S+d_keq_dV_D_S*(0.5+inv_k2))));
d_lambdaf_dV_G_S = lambda2D*(deriv_sqrt_0_d0*((keq*d_inv_k2_dV_G_S+d_keq_dV_G_S*(0.5+inv_k2))));
lambdaf = (lambda2D*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt((((keq*k1)*inv_k2)*(0.5+inv_k1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_lambdab_dV_S_B = lambda2D*(deriv_sqrt_0_d0*((((keq*k1)*inv_k2)*d_inv_k1_dV_S_B+((keq*k1)*d_inv_k2_dV_S_B+(keq*d_k1_dV_S_B+d_keq_dV_S_B*k1)*inv_k2)*(0.5+inv_k1))));
d_lambdab_dTemp_Tnode_GND = lambda2D*(deriv_sqrt_0_d0*((((keq*k1)*inv_k2)*d_inv_k1_dTemp_Tnode_GND+((keq*k1)*d_inv_k2_dTemp_Tnode_GND+(keq*d_k1_dTemp_Tnode_GND+d_keq_dTemp_Tnode_GND*k1)*inv_k2)*(0.5+inv_k1))));
d_lambdab_dV_D_S = lambda2D*(deriv_sqrt_0_d0*((((keq*k1)*inv_k2)*d_inv_k1_dV_D_S+((keq*k1)*d_inv_k2_dV_D_S+(keq*d_k1_dV_D_S+d_keq_dV_D_S*k1)*inv_k2)*(0.5+inv_k1))));
d_lambdab_dV_G_S = lambda2D*(deriv_sqrt_0_d0*((((keq*k1)*inv_k2)*d_inv_k1_dV_G_S+((keq*k1)*d_inv_k2_dV_G_S+(keq*d_k1_dV_G_S+d_keq_dV_G_S*k1)*inv_k2)*(0.5+inv_k1))));
lambdab = (lambda2D*value_sqrt_0);
}

d_xalphaf_dV_S_B = (lambdaf*d_lambdaf_dV_S_B+d_lambdaf_dV_S_B*lambdaf)*inner_sd;
d_xalphaf_dTemp_Tnode_GND = ((lambdaf*lambdaf)*d_inner_sd_dTemp_Tnode_GND+(lambdaf*d_lambdaf_dTemp_Tnode_GND+d_lambdaf_dTemp_Tnode_GND*lambdaf)*inner_sd);
d_xalphaf_dV_D_S = (lambdaf*d_lambdaf_dV_D_S+d_lambdaf_dV_D_S*lambdaf)*inner_sd;
d_xalphaf_dV_G_S = (lambdaf*d_lambdaf_dV_G_S+d_lambdaf_dV_G_S*lambdaf)*inner_sd;
xalphaf = ((lambdaf*lambdaf)*inner_sd);

d_xalphab_dV_S_B = (lambdab*d_lambdab_dV_S_B+d_lambdab_dV_S_B*lambdab)*inner_sd;
d_xalphab_dTemp_Tnode_GND = ((lambdab*lambdab)*d_inner_sd_dTemp_Tnode_GND+(lambdab*d_lambdab_dTemp_Tnode_GND+d_lambdab_dTemp_Tnode_GND*lambdab)*inner_sd);
d_xalphab_dV_D_S = (lambdab*d_lambdab_dV_D_S+d_lambdab_dV_D_S*lambdab)*inner_sd;
d_xalphab_dV_G_S = (lambdab*d_lambdab_dV_G_S+d_lambdab_dV_G_S*lambdab)*inner_sd;
xalphab = ((lambdab*lambdab)*inner_sd);

d_temp1_dV_S_B = (-d_xstars_dV_S_B);
d_temp1_dV_D_S = (-d_xstars_dV_D_S);
d_temp1_dV_G_S = (-d_xstars_dV_G_S);
d_temp1_dTemp_Tnode_GND = (d_xsd_dTemp_Tnode_GND-d_xstars_dTemp_Tnode_GND);
temp1 = (xsd-xstars);

d_temp2_dV_S_B = (-d_xstard_dV_S_B);
d_temp2_dV_G_S = (-d_xstard_dV_G_S);
d_temp2_dV_D_S = (d_xd_dV_D_S-d_xstard_dV_D_S);
d_temp2_dTemp_Tnode_GND = ((d_xsd_dTemp_Tnode_GND+d_xd_dTemp_Tnode_GND)-d_xstard_dTemp_Tnode_GND);
temp2 = ((xsd+xd)-xstard);

d_temp_dV_S_B = 2.0*d_xalphaf_dV_S_B;
d_temp_dTemp_Tnode_GND = 2.0*d_xalphaf_dTemp_Tnode_GND;
d_temp_dV_D_S = 2.0*d_xalphaf_dV_D_S;
d_temp_dV_G_S = 2.0*d_xalphaf_dV_G_S;
temp = (2.0*xalphaf);
{
double value_sqrt_0 = sqrt((1.0+(temp1/xalphaf)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xedgefs_dV_S_B = (d_xstars_dV_S_B+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp1_dV_S_B-temp1*d_xalphaf_dV_S_B)/xalphaf/xalphaf)))+d_temp_dV_S_B*(value_sqrt_0-1.0)));
d_xedgefs_dV_D_S = (d_xstars_dV_D_S+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp1_dV_D_S-temp1*d_xalphaf_dV_D_S)/xalphaf/xalphaf)))+d_temp_dV_D_S*(value_sqrt_0-1.0)));
d_xedgefs_dV_G_S = (d_xstars_dV_G_S+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp1_dV_G_S-temp1*d_xalphaf_dV_G_S)/xalphaf/xalphaf)))+d_temp_dV_G_S*(value_sqrt_0-1.0)));
d_xedgefs_dTemp_Tnode_GND = (d_xstars_dTemp_Tnode_GND+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp1_dTemp_Tnode_GND-temp1*d_xalphaf_dTemp_Tnode_GND)/xalphaf/xalphaf)))+d_temp_dTemp_Tnode_GND*(value_sqrt_0-1.0)));
xedgefs = (xstars+(temp*(value_sqrt_0-1.0)));
}
{
double value_sqrt_0 = sqrt((1.0+(temp2/xalphaf)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xedgefd_dV_S_B = (d_xstard_dV_S_B+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp2_dV_S_B-temp2*d_xalphaf_dV_S_B)/xalphaf/xalphaf)))+d_temp_dV_S_B*(value_sqrt_0-1.0)));
d_xedgefd_dV_G_S = (d_xstard_dV_G_S+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp2_dV_G_S-temp2*d_xalphaf_dV_G_S)/xalphaf/xalphaf)))+d_temp_dV_G_S*(value_sqrt_0-1.0)));
d_xedgefd_dTemp_Tnode_GND = (d_xstard_dTemp_Tnode_GND+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp2_dTemp_Tnode_GND-temp2*d_xalphaf_dTemp_Tnode_GND)/xalphaf/xalphaf)))+d_temp_dTemp_Tnode_GND*(value_sqrt_0-1.0)));
d_xedgefd_dV_D_S = (d_xstard_dV_D_S+(temp*(deriv_sqrt_0_d0*(((xalphaf*d_temp2_dV_D_S-temp2*d_xalphaf_dV_D_S)/xalphaf/xalphaf)))+d_temp_dV_D_S*(value_sqrt_0-1.0)));
xedgefd = (xstard+(temp*(value_sqrt_0-1.0)));
}

d_temp_dV_S_B = 2.0*d_xalphab_dV_S_B;
d_temp_dTemp_Tnode_GND = 2.0*d_xalphab_dTemp_Tnode_GND;
d_temp_dV_D_S = 2.0*d_xalphab_dV_D_S;
d_temp_dV_G_S = 2.0*d_xalphab_dV_G_S;
temp = (2.0*xalphab);
{
double value_sqrt_0 = sqrt((1.0+(temp1/xalphab)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xedgebs_dV_S_B = (d_xstars_dV_S_B+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp1_dV_S_B-temp1*d_xalphab_dV_S_B)/xalphab/xalphab)))+d_temp_dV_S_B*(value_sqrt_0-1.0)));
d_xedgebs_dV_D_S = (d_xstars_dV_D_S+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp1_dV_D_S-temp1*d_xalphab_dV_D_S)/xalphab/xalphab)))+d_temp_dV_D_S*(value_sqrt_0-1.0)));
d_xedgebs_dV_G_S = (d_xstars_dV_G_S+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp1_dV_G_S-temp1*d_xalphab_dV_G_S)/xalphab/xalphab)))+d_temp_dV_G_S*(value_sqrt_0-1.0)));
d_xedgebs_dTemp_Tnode_GND = (d_xstars_dTemp_Tnode_GND+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp1_dTemp_Tnode_GND-temp1*d_xalphab_dTemp_Tnode_GND)/xalphab/xalphab)))+d_temp_dTemp_Tnode_GND*(value_sqrt_0-1.0)));
xedgebs = (xstars+(temp*(value_sqrt_0-1.0)));
}
{
double value_sqrt_0 = sqrt((1.0+(temp2/xalphab)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xedgebd_dV_S_B = (d_xstard_dV_S_B+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp2_dV_S_B-temp2*d_xalphab_dV_S_B)/xalphab/xalphab)))+d_temp_dV_S_B*(value_sqrt_0-1.0)));
d_xedgebd_dV_G_S = (d_xstard_dV_G_S+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp2_dV_G_S-temp2*d_xalphab_dV_G_S)/xalphab/xalphab)))+d_temp_dV_G_S*(value_sqrt_0-1.0)));
d_xedgebd_dTemp_Tnode_GND = (d_xstard_dTemp_Tnode_GND+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp2_dTemp_Tnode_GND-temp2*d_xalphab_dTemp_Tnode_GND)/xalphab/xalphab)))+d_temp_dTemp_Tnode_GND*(value_sqrt_0-1.0)));
d_xedgebd_dV_D_S = (d_xstard_dV_D_S+(temp*(deriv_sqrt_0_d0*(((xalphab*d_temp2_dV_D_S-temp2*d_xalphab_dV_D_S)/xalphab/xalphab)))+d_temp_dV_D_S*(value_sqrt_0-1.0)));
xedgebd = (xstard+(temp*(value_sqrt_0-1.0)));
}

d_temp_dV_S_B = fif_phit*d_CsiPrime_dV_S_B;
d_temp_dV_D_S = fif_phit*d_CsiPrime_dV_D_S;
d_temp_dV_G_S = fif_phit*d_CsiPrime_dV_G_S;
d_temp_dTemp_Tnode_GND = (fif_phit*d_CsiPrime_dTemp_Tnode_GND+d_fif_phit_dTemp_Tnode_GND*CsiPrime);
temp = (fif_phit*CsiPrime);

d_temp1_dTemp_Tnode_GND = ((((-temp)*lambdaf)*k1)*d_sce1_dTemp_Tnode_GND+(((-temp)*lambdaf)*d_k1_dTemp_Tnode_GND+((-temp)*d_lambdaf_dTemp_Tnode_GND+(-d_temp_dTemp_Tnode_GND)*lambdaf)*k1)*sce1);
d_temp1_dV_S_B = ((((-temp)*lambdaf)*k1)*d_sce1_dV_S_B+(((-temp)*lambdaf)*d_k1_dV_S_B+((-temp)*d_lambdaf_dV_S_B+(-d_temp_dV_S_B)*lambdaf)*k1)*sce1);
d_temp1_dV_D_S = ((((-temp)*lambdaf)*k1)*d_sce1_dV_D_S+(((-temp)*lambdaf)*d_k1_dV_D_S+((-temp)*d_lambdaf_dV_D_S+(-d_temp_dV_D_S)*lambdaf)*k1)*sce1);
d_temp1_dV_G_S = ((((-temp)*lambdaf)*k1)*d_sce1_dV_G_S+(((-temp)*lambdaf)*d_k1_dV_G_S+((-temp)*d_lambdaf_dV_G_S+(-d_temp_dV_G_S)*lambdaf)*k1)*sce1);
temp1 = ((((-temp)*lambdaf)*k1)*sce1);

d_temp2_dTemp_Tnode_GND = ((((-temp)*lambdab)*k2)*d_sce2_dTemp_Tnode_GND+(((-temp)*lambdab)*d_k2_dTemp_Tnode_GND+((-temp)*d_lambdab_dTemp_Tnode_GND+(-d_temp_dTemp_Tnode_GND)*lambdab)*k2)*sce2);
d_temp2_dV_S_B = ((((-temp)*lambdab)*k2)*d_sce2_dV_S_B+(((-temp)*lambdab)*d_k2_dV_S_B+((-temp)*d_lambdab_dV_S_B+(-d_temp_dV_S_B)*lambdab)*k2)*sce2);
d_temp2_dV_D_S = ((((-temp)*lambdab)*k2)*d_sce2_dV_D_S+(((-temp)*lambdab)*d_k2_dV_D_S+((-temp)*d_lambdab_dV_D_S+(-d_temp_dV_D_S)*lambdab)*k2)*sce2);
d_temp2_dV_G_S = ((((-temp)*lambdab)*k2)*d_sce2_dV_G_S+(((-temp)*lambdab)*d_k2_dV_G_S+((-temp)*d_lambdab_dV_G_S+(-d_temp_dV_G_S)*lambdab)*k2)*sce2);
temp2 = ((((-temp)*lambdab)*k2)*sce2);
{
double value_sqrt_0 = sqrt(((((xedgefs-xeffs))*((xedgefs-xeffs)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_B = 0.5*((d_xedgefs_dV_S_B-d_xeffs_dV_S_B)+(deriv_sqrt_0_d0*((((xedgefs-xeffs))*(d_xedgefs_dV_S_B-d_xeffs_dV_S_B)+(d_xedgefs_dV_S_B-d_xeffs_dV_S_B)*((xedgefs-xeffs))))));
d_temp_dV_D_S = 0.5*((d_xedgefs_dV_D_S-d_xeffs_dV_D_S)+(deriv_sqrt_0_d0*((((xedgefs-xeffs))*(d_xedgefs_dV_D_S-d_xeffs_dV_D_S)+(d_xedgefs_dV_D_S-d_xeffs_dV_D_S)*((xedgefs-xeffs))))));
d_temp_dV_G_S = 0.5*((d_xedgefs_dV_G_S-d_xeffs_dV_G_S)+(deriv_sqrt_0_d0*((((xedgefs-xeffs))*(d_xedgefs_dV_G_S-d_xeffs_dV_G_S)+(d_xedgefs_dV_G_S-d_xeffs_dV_G_S)*((xedgefs-xeffs))))));
d_temp_dTemp_Tnode_GND = 0.5*((d_xedgefs_dTemp_Tnode_GND-d_xeffs_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((xedgefs-xeffs))*(d_xedgefs_dTemp_Tnode_GND-d_xeffs_dTemp_Tnode_GND)+(d_xedgefs_dTemp_Tnode_GND-d_xeffs_dTemp_Tnode_GND)*((xedgefs-xeffs))))));
temp = (0.5*((xedgefs-xeffs)+value_sqrt_0));
}

d_Qgsif_dTemp_Tnode_GND = (((xedgefs-xstars)*((temp1*temp)*d_temp_dTemp_Tnode_GND+(temp1*d_temp_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND*temp)*temp)-((temp1*temp)*temp)*(d_xedgefs_dTemp_Tnode_GND-d_xstars_dTemp_Tnode_GND))/(xedgefs-xstars)/(xedgefs-xstars));
d_Qgsif_dV_D_S = (((xedgefs-xstars)*((temp1*temp)*d_temp_dV_D_S+(temp1*d_temp_dV_D_S+d_temp1_dV_D_S*temp)*temp)-((temp1*temp)*temp)*(d_xedgefs_dV_D_S-d_xstars_dV_D_S))/(xedgefs-xstars)/(xedgefs-xstars));
d_Qgsif_dV_G_S = (((xedgefs-xstars)*((temp1*temp)*d_temp_dV_G_S+(temp1*d_temp_dV_G_S+d_temp1_dV_G_S*temp)*temp)-((temp1*temp)*temp)*(d_xedgefs_dV_G_S-d_xstars_dV_G_S))/(xedgefs-xstars)/(xedgefs-xstars));
d_Qgsif_dV_S_B = (((xedgefs-xstars)*((temp1*temp)*d_temp_dV_S_B+(temp1*d_temp_dV_S_B+d_temp1_dV_S_B*temp)*temp)-((temp1*temp)*temp)*(d_xedgefs_dV_S_B-d_xstars_dV_S_B))/(xedgefs-xstars)/(xedgefs-xstars));
Qgsif = (((temp1*temp)*temp)/(xedgefs-xstars));
{
double value_sqrt_0 = sqrt(((((xedgefd-xeffd))*((xedgefd-xeffd)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_B = 0.5*((d_xedgefd_dV_S_B-d_xeffd_dV_S_B)+(deriv_sqrt_0_d0*((((xedgefd-xeffd))*(d_xedgefd_dV_S_B-d_xeffd_dV_S_B)+(d_xedgefd_dV_S_B-d_xeffd_dV_S_B)*((xedgefd-xeffd))))));
d_temp_dV_G_S = 0.5*((d_xedgefd_dV_G_S-d_xeffd_dV_G_S)+(deriv_sqrt_0_d0*((((xedgefd-xeffd))*(d_xedgefd_dV_G_S-d_xeffd_dV_G_S)+(d_xedgefd_dV_G_S-d_xeffd_dV_G_S)*((xedgefd-xeffd))))));
d_temp_dTemp_Tnode_GND = 0.5*((d_xedgefd_dTemp_Tnode_GND-d_xeffd_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((xedgefd-xeffd))*(d_xedgefd_dTemp_Tnode_GND-d_xeffd_dTemp_Tnode_GND)+(d_xedgefd_dTemp_Tnode_GND-d_xeffd_dTemp_Tnode_GND)*((xedgefd-xeffd))))));
d_temp_dV_D_S = 0.5*((d_xedgefd_dV_D_S-d_xeffd_dV_D_S)+(deriv_sqrt_0_d0*((((xedgefd-xeffd))*(d_xedgefd_dV_D_S-d_xeffd_dV_D_S)+(d_xedgefd_dV_D_S-d_xeffd_dV_D_S)*((xedgefd-xeffd))))));
temp = (0.5*((xedgefd-xeffd)+value_sqrt_0));
}

d_Qgdif_dTemp_Tnode_GND = (((xedgefd-xstard)*((temp1*temp)*d_temp_dTemp_Tnode_GND+(temp1*d_temp_dTemp_Tnode_GND+d_temp1_dTemp_Tnode_GND*temp)*temp)-((temp1*temp)*temp)*(d_xedgefd_dTemp_Tnode_GND-d_xstard_dTemp_Tnode_GND))/(xedgefd-xstard)/(xedgefd-xstard));
d_Qgdif_dV_D_S = (((xedgefd-xstard)*((temp1*temp)*d_temp_dV_D_S+(temp1*d_temp_dV_D_S+d_temp1_dV_D_S*temp)*temp)-((temp1*temp)*temp)*(d_xedgefd_dV_D_S-d_xstard_dV_D_S))/(xedgefd-xstard)/(xedgefd-xstard));
d_Qgdif_dV_G_S = (((xedgefd-xstard)*((temp1*temp)*d_temp_dV_G_S+(temp1*d_temp_dV_G_S+d_temp1_dV_G_S*temp)*temp)-((temp1*temp)*temp)*(d_xedgefd_dV_G_S-d_xstard_dV_G_S))/(xedgefd-xstard)/(xedgefd-xstard));
d_Qgdif_dV_S_B = (((xedgefd-xstard)*((temp1*temp)*d_temp_dV_S_B+(temp1*d_temp_dV_S_B+d_temp1_dV_S_B*temp)*temp)-((temp1*temp)*temp)*(d_xedgefd_dV_S_B-d_xstard_dV_S_B))/(xedgefd-xstard)/(xedgefd-xstard));
Qgdif = (((temp1*temp)*temp)/(xedgefd-xstard));
{
double value_sqrt_0 = sqrt(((((xedgebs-xeffs))*((xedgebs-xeffs)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_B = 0.5*((d_xedgebs_dV_S_B-d_xeffs_dV_S_B)+(deriv_sqrt_0_d0*((((xedgebs-xeffs))*(d_xedgebs_dV_S_B-d_xeffs_dV_S_B)+(d_xedgebs_dV_S_B-d_xeffs_dV_S_B)*((xedgebs-xeffs))))));
d_temp_dV_D_S = 0.5*((d_xedgebs_dV_D_S-d_xeffs_dV_D_S)+(deriv_sqrt_0_d0*((((xedgebs-xeffs))*(d_xedgebs_dV_D_S-d_xeffs_dV_D_S)+(d_xedgebs_dV_D_S-d_xeffs_dV_D_S)*((xedgebs-xeffs))))));
d_temp_dV_G_S = 0.5*((d_xedgebs_dV_G_S-d_xeffs_dV_G_S)+(deriv_sqrt_0_d0*((((xedgebs-xeffs))*(d_xedgebs_dV_G_S-d_xeffs_dV_G_S)+(d_xedgebs_dV_G_S-d_xeffs_dV_G_S)*((xedgebs-xeffs))))));
d_temp_dTemp_Tnode_GND = 0.5*((d_xedgebs_dTemp_Tnode_GND-d_xeffs_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((xedgebs-xeffs))*(d_xedgebs_dTemp_Tnode_GND-d_xeffs_dTemp_Tnode_GND)+(d_xedgebs_dTemp_Tnode_GND-d_xeffs_dTemp_Tnode_GND)*((xedgebs-xeffs))))));
temp = (0.5*((xedgebs-xeffs)+value_sqrt_0));
}

d_Qbsif_dV_S_B = (((xedgebs-xstars)*((temp2*temp)*d_temp_dV_S_B+(temp2*d_temp_dV_S_B+d_temp2_dV_S_B*temp)*temp)-((temp2*temp)*temp)*(d_xedgebs_dV_S_B-d_xstars_dV_S_B))/(xedgebs-xstars)/(xedgebs-xstars));
d_Qbsif_dV_D_S = (((xedgebs-xstars)*((temp2*temp)*d_temp_dV_D_S+(temp2*d_temp_dV_D_S+d_temp2_dV_D_S*temp)*temp)-((temp2*temp)*temp)*(d_xedgebs_dV_D_S-d_xstars_dV_D_S))/(xedgebs-xstars)/(xedgebs-xstars));
d_Qbsif_dTemp_Tnode_GND = (((xedgebs-xstars)*((temp2*temp)*d_temp_dTemp_Tnode_GND+(temp2*d_temp_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND*temp)*temp)-((temp2*temp)*temp)*(d_xedgebs_dTemp_Tnode_GND-d_xstars_dTemp_Tnode_GND))/(xedgebs-xstars)/(xedgebs-xstars));
d_Qbsif_dV_G_S = (((xedgebs-xstars)*((temp2*temp)*d_temp_dV_G_S+(temp2*d_temp_dV_G_S+d_temp2_dV_G_S*temp)*temp)-((temp2*temp)*temp)*(d_xedgebs_dV_G_S-d_xstars_dV_G_S))/(xedgebs-xstars)/(xedgebs-xstars));
Qbsif = (((temp2*temp)*temp)/(xedgebs-xstars));
{
double value_sqrt_0 = sqrt(((((xedgebd-xeffd))*((xedgebd-xeffd)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_B = 0.5*((d_xedgebd_dV_S_B-d_xeffd_dV_S_B)+(deriv_sqrt_0_d0*((((xedgebd-xeffd))*(d_xedgebd_dV_S_B-d_xeffd_dV_S_B)+(d_xedgebd_dV_S_B-d_xeffd_dV_S_B)*((xedgebd-xeffd))))));
d_temp_dV_G_S = 0.5*((d_xedgebd_dV_G_S-d_xeffd_dV_G_S)+(deriv_sqrt_0_d0*((((xedgebd-xeffd))*(d_xedgebd_dV_G_S-d_xeffd_dV_G_S)+(d_xedgebd_dV_G_S-d_xeffd_dV_G_S)*((xedgebd-xeffd))))));
d_temp_dTemp_Tnode_GND = 0.5*((d_xedgebd_dTemp_Tnode_GND-d_xeffd_dTemp_Tnode_GND)+(deriv_sqrt_0_d0*((((xedgebd-xeffd))*(d_xedgebd_dTemp_Tnode_GND-d_xeffd_dTemp_Tnode_GND)+(d_xedgebd_dTemp_Tnode_GND-d_xeffd_dTemp_Tnode_GND)*((xedgebd-xeffd))))));
d_temp_dV_D_S = 0.5*((d_xedgebd_dV_D_S-d_xeffd_dV_D_S)+(deriv_sqrt_0_d0*((((xedgebd-xeffd))*(d_xedgebd_dV_D_S-d_xeffd_dV_D_S)+(d_xedgebd_dV_D_S-d_xeffd_dV_D_S)*((xedgebd-xeffd))))));
temp = (0.5*((xedgebd-xeffd)+value_sqrt_0));
}

d_Qbdif_dV_S_B = (((xedgebd-xstard)*((temp2*temp)*d_temp_dV_S_B+(temp2*d_temp_dV_S_B+d_temp2_dV_S_B*temp)*temp)-((temp2*temp)*temp)*(d_xedgebd_dV_S_B-d_xstard_dV_S_B))/(xedgebd-xstard)/(xedgebd-xstard));
d_Qbdif_dV_D_S = (((xedgebd-xstard)*((temp2*temp)*d_temp_dV_D_S+(temp2*d_temp_dV_D_S+d_temp2_dV_D_S*temp)*temp)-((temp2*temp)*temp)*(d_xedgebd_dV_D_S-d_xstard_dV_D_S))/(xedgebd-xstard)/(xedgebd-xstard));
d_Qbdif_dTemp_Tnode_GND = (((xedgebd-xstard)*((temp2*temp)*d_temp_dTemp_Tnode_GND+(temp2*d_temp_dTemp_Tnode_GND+d_temp2_dTemp_Tnode_GND*temp)*temp)-((temp2*temp)*temp)*(d_xedgebd_dTemp_Tnode_GND-d_xstard_dTemp_Tnode_GND))/(xedgebd-xstard)/(xedgebd-xstard));
d_Qbdif_dV_G_S = (((xedgebd-xstard)*((temp2*temp)*d_temp_dV_G_S+(temp2*d_temp_dV_G_S+d_temp2_dV_G_S*temp)*temp)-((temp2*temp)*temp)*(d_xedgebd_dV_G_S-d_xstard_dV_G_S))/(xedgebd-xstard)/(xedgebd-xstard));
Qbdif = (((temp2*temp)*temp)/(xedgebd-xstard));
}
else
{

d_Qgsif_dV_S_B = d_Qgsif_dV_G_S = d_Qgsif_dV_D_S = d_Qgsif_dTemp_Tnode_GND =  0.0;
Qgsif = 0.0;

d_Qgdif_dV_S_B = d_Qgdif_dV_G_S = d_Qgdif_dV_D_S = d_Qgdif_dTemp_Tnode_GND =  0.0;
Qgdif = 0.0;

d_Qbsif_dV_G_S = d_Qbsif_dTemp_Tnode_GND = d_Qbsif_dV_D_S = d_Qbsif_dV_S_B =  0.0;
Qbsif = 0.0;

d_Qbdif_dV_G_S = d_Qbdif_dTemp_Tnode_GND = d_Qbdif_dV_D_S = d_Qbdif_dV_S_B =  0.0;
Qbdif = 0.0;
}

d_Qgse_dV_G_S = CFR_i*d_Vgsu_dV_G_S;
Qgse = (CFR_i*Vgsu);

d_Qgde_dV_D_S = CFRD_i*d_Vgdu_dV_D_S;
d_Qgde_dV_G_S = CFRD_i*d_Vgdu_dV_G_S;
Qgde = (CFRD_i*Vgdu);
{
double value_sqrt_0 = sqrt(((((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))*((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20))))))+0.2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_B = 0.5*((-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dV_S_B)+COVDL_i*d_dleff_dV_S_B*(1.0-(COVDLB_i*xg20))))+(deriv_sqrt_0_d0*((((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))*(-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dV_S_B)+COVDL_i*d_dleff_dV_S_B*(1.0-(COVDLB_i*xg20))))+(-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dV_S_B)+COVDL_i*d_dleff_dV_S_B*(1.0-(COVDLB_i*xg20))))*((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))))));
d_temp_dV_D_S = 0.5*((-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dV_D_S)+COVDL_i*d_dleff_dV_D_S*(1.0-(COVDLB_i*xg20))))+(deriv_sqrt_0_d0*((((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))*(-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dV_D_S)+COVDL_i*d_dleff_dV_D_S*(1.0-(COVDLB_i*xg20))))+(-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dV_D_S)+COVDL_i*d_dleff_dV_D_S*(1.0-(COVDLB_i*xg20))))*((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))))));
d_temp_dV_G_S = 0.5*((-COVDL_i*d_dleff_dV_G_S*(1.0-(COVDLB_i*xg20)))+(deriv_sqrt_0_d0*((((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))*(-COVDL_i*d_dleff_dV_G_S*(1.0-(COVDLB_i*xg20)))+(-COVDL_i*d_dleff_dV_G_S*(1.0-(COVDLB_i*xg20)))*((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))))));
d_temp_dTemp_Tnode_GND = 0.5*((-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dTemp_Tnode_GND)+COVDL_i*d_dleff_dTemp_Tnode_GND*(1.0-(COVDLB_i*xg20))))+(deriv_sqrt_0_d0*((((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))*(-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dTemp_Tnode_GND)+COVDL_i*d_dleff_dTemp_Tnode_GND*(1.0-(COVDLB_i*xg20))))+(-((COVDL_i*dleff)*(-COVDLB_i*d_xg20_dTemp_Tnode_GND)+COVDL_i*d_dleff_dTemp_Tnode_GND*(1.0-(COVDLB_i*xg20))))*((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20)))))))));
temp = (0.5*((1.0-((COVDL_i*dleff)*(1.0-(COVDLB_i*xg20))))+value_sqrt_0));
}

d_Qovs_dV_S_B = (COV_i*Vovscv)*d_temp_dV_S_B;
d_Qovs_dV_D_S = (COV_i*Vovscv)*d_temp_dV_D_S;
d_Qovs_dV_G_S = ((COV_i*Vovscv)*d_temp_dV_G_S+COV_i*d_Vovscv_dV_G_S*temp);
d_Qovs_dTemp_Tnode_GND = ((COV_i*Vovscv)*d_temp_dTemp_Tnode_GND+COV_i*d_Vovscv_dTemp_Tnode_GND*temp);
Qovs = ((COV_i*Vovscv)*temp);

d_Qovd_dV_S_B = (COVD_i*Vovdcv)*d_temp_dV_S_B;
d_Qovd_dV_D_S = ((COVD_i*Vovdcv)*d_temp_dV_D_S+COVD_i*d_Vovdcv_dV_D_S*temp);
d_Qovd_dV_G_S = ((COVD_i*Vovdcv)*d_temp_dV_G_S+COVD_i*d_Vovdcv_dV_G_S*temp);
d_Qovd_dTemp_Tnode_GND = ((COVD_i*Vovdcv)*d_temp_dTemp_Tnode_GND+COVD_i*d_Vovdcv_dTemp_Tnode_GND*temp);
Qovd = ((COVD_i*Vovdcv)*temp);

d_Qgbe_dV_S_B = CGBOV_i*d_Vgb_dV_S_B;
d_Qgbe_dV_D_S = CGBOV_i*d_Vgb_dV_D_S;
d_Qgbe_dV_G_S = CGBOV_i*d_Vgb_dV_G_S;
Qgbe = (CGBOV_i*Vgb);

d_Qdse_dV_D_S = CSD_i*d_Vds_dV_D_S;
Qdse = (CSD_i*Vds);

d_Qssub_dV_S_B = (-((Cox2Init*ASOURCE_i)+(CSDBP_i*PSOURCE_i)))*d_Vsbu_dV_S_B;
Qssub = ((-((Cox2Init*ASOURCE_i)+(CSDBP_i*PSOURCE_i)))*Vsbu);

d_Qdsub_dV_S_B = (-((Cox2Init*ADRAIN_i)+(CSDBP_i*PDRAIN_i)))*d_Vdbu_dV_S_B;
d_Qdsub_dV_D_S = (-((Cox2Init*ADRAIN_i)+(CSDBP_i*PDRAIN_i)))*d_Vdbu_dV_D_S;
Qdsub = ((-((Cox2Init*ADRAIN_i)+(CSDBP_i*PDRAIN_i)))*Vdbu);
if (((model_.SWSHE_i)>0))
{

d_Qth_dTemp_Tnode_GND = CTH_i*d_DTC_dTemp_Tnode_GND;
Qth = (CTH_i*DTC);
}
else
{

d_Qth_dTemp_Tnode_GND =  0.0;
Qth = 0.0;
}
}
// End block evaluateDynamic
//Begin block loadStatic
{

d_Idse_dV_D_S = MULT_i*(d_Ids_dV_D_S+d_Iimpact_dV_D_S);
d_Idse_dV_G_S = MULT_i*(d_Ids_dV_G_S+d_Iimpact_dV_G_S);
d_Idse_dV_S_B = MULT_i*(d_Ids_dV_S_B+d_Iimpact_dV_S_B);
d_Idse_dTemp_Tnode_GND = MULT_i*(d_Ids_dTemp_Tnode_GND+d_Iimpact_dTemp_Tnode_GND);
Idse = (MULT_i*(Ids+Iimpact));

d_Igse_dV_S_B = MULT_i*d_Igs_dV_S_B;
d_Igse_dV_D_S = MULT_i*d_Igs_dV_D_S;
d_Igse_dV_G_S = MULT_i*d_Igs_dV_G_S;
d_Igse_dTemp_Tnode_GND = MULT_i*d_Igs_dTemp_Tnode_GND;
Igse = (MULT_i*Igs);

d_Igde_dV_S_B = MULT_i*d_Igd_dV_S_B;
d_Igde_dV_D_S = MULT_i*d_Igd_dV_D_S;
d_Igde_dV_G_S = MULT_i*d_Igd_dV_G_S;
d_Igde_dTemp_Tnode_GND = MULT_i*d_Igd_dTemp_Tnode_GND;
Igde = (MULT_i*Igd);

d_Igidle_dV_S_B = MULT_i*d_Igidl_dV_S_B;
d_Igidle_dV_G_S = MULT_i*d_Igidl_dV_G_S;
d_Igidle_dTemp_Tnode_GND = MULT_i*d_Igidl_dTemp_Tnode_GND;
d_Igidle_dV_D_S = MULT_i*d_Igidl_dV_D_S;
Igidle = (MULT_i*Igidl);

d_Igisle_dV_S_B = MULT_i*d_Igisl_dV_S_B;
d_Igisle_dV_G_S = MULT_i*d_Igisl_dV_G_S;
d_Igisle_dTemp_Tnode_GND = MULT_i*d_Igisl_dTemp_Tnode_GND;
d_Igisle_dV_D_S = MULT_i*d_Igisl_dV_D_S;
Igisle = (MULT_i*Igisl);

d_Ithpwre_dTemp_Tnode_GND = MULT_i*d_Ithpwr_dTemp_Tnode_GND;
d_Ithpwre_dV_S_B = MULT_i*d_Ithpwr_dV_S_B;
d_Ithpwre_dV_D_S = MULT_i*d_Ithpwr_dV_D_S;
d_Ithpwre_dV_G_S = MULT_i*d_Ithpwr_dV_G_S;
Ithpwre = (MULT_i*Ithpwr);

d_Ithrce_dTemp_Tnode_GND = MULT_i*d_Ithrc_dTemp_Tnode_GND;
Ithrce = (MULT_i*Ithrc);
if ((sigVds<0))
{
// I(S,D) <+ (((M*TYPE)*Idse))
staticContributions[admsNodeID_S] += ((M*(model_.TYPE))*Idse);
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] += (M*(model_.TYPE))*d_Idse_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] += (M*(model_.TYPE))*d_Idse_dV_G_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] += (M*(model_.TYPE))*d_Idse_dV_S_B;
d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*d_Idse_dTemp_Tnode_GND;
staticContributions[admsNodeID_D] -= ((M*(model_.TYPE))*Idse);
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= (M*(model_.TYPE))*d_Idse_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] -= (M*(model_.TYPE))*d_Idse_dV_G_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] -= (M*(model_.TYPE))*d_Idse_dV_S_B;
d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*d_Idse_dTemp_Tnode_GND;
}
else
{
// I(D,S) <+ (((M*TYPE)*Idse))
staticContributions[admsNodeID_D] += ((M*(model_.TYPE))*Idse);
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (M*(model_.TYPE))*d_Idse_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] += (M*(model_.TYPE))*d_Idse_dV_G_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] += (M*(model_.TYPE))*d_Idse_dV_S_B;
d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*d_Idse_dTemp_Tnode_GND;
staticContributions[admsNodeID_S] -= ((M*(model_.TYPE))*Idse);
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*(model_.TYPE))*d_Idse_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] -= (M*(model_.TYPE))*d_Idse_dV_G_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] -= (M*(model_.TYPE))*d_Idse_dV_S_B;
d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*d_Idse_dTemp_Tnode_GND;
}
// I(D,S) <+ (((M*TYPE)*(Igidle-Igisle)))
staticContributions[admsNodeID_D] += ((M*(model_.TYPE))*(Igidle-Igisle));
d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] += (M*(model_.TYPE))*(d_Igidle_dV_S_B-d_Igisle_dV_S_B);
d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] += (M*(model_.TYPE))*(d_Igidle_dV_G_S-d_Igisle_dV_G_S);
d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*(d_Igidle_dTemp_Tnode_GND-d_Igisle_dTemp_Tnode_GND);
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (M*(model_.TYPE))*(d_Igidle_dV_D_S-d_Igisle_dV_D_S);
staticContributions[admsNodeID_S] -= ((M*(model_.TYPE))*(Igidle-Igisle));
d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] -= (M*(model_.TYPE))*(d_Igidle_dV_S_B-d_Igisle_dV_S_B);
d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] -= (M*(model_.TYPE))*(d_Igidle_dV_G_S-d_Igisle_dV_G_S);
d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*(d_Igidle_dTemp_Tnode_GND-d_Igisle_dTemp_Tnode_GND);
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*(model_.TYPE))*(d_Igidle_dV_D_S-d_Igisle_dV_D_S);
// I(G,S) <+ (((M*TYPE)*Igse))
staticContributions[admsNodeID_G] += ((M*(model_.TYPE))*Igse);
d_staticContributions[admsNodeID_G][admsProbeID_V_S_B] += (M*(model_.TYPE))*d_Igse_dV_S_B;
d_staticContributions[admsNodeID_G][admsProbeID_V_D_S] += (M*(model_.TYPE))*d_Igse_dV_D_S;
d_staticContributions[admsNodeID_G][admsProbeID_V_G_S] += (M*(model_.TYPE))*d_Igse_dV_G_S;
d_staticContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*d_Igse_dTemp_Tnode_GND;
staticContributions[admsNodeID_S] -= ((M*(model_.TYPE))*Igse);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] -= (M*(model_.TYPE))*d_Igse_dV_S_B;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*(model_.TYPE))*d_Igse_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] -= (M*(model_.TYPE))*d_Igse_dV_G_S;
d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*d_Igse_dTemp_Tnode_GND;
// I(G,D) <+ (((M*TYPE)*Igde))
staticContributions[admsNodeID_G] += ((M*(model_.TYPE))*Igde);
d_staticContributions[admsNodeID_G][admsProbeID_V_S_B] += (M*(model_.TYPE))*d_Igde_dV_S_B;
d_staticContributions[admsNodeID_G][admsProbeID_V_D_S] += (M*(model_.TYPE))*d_Igde_dV_D_S;
d_staticContributions[admsNodeID_G][admsProbeID_V_G_S] += (M*(model_.TYPE))*d_Igde_dV_G_S;
d_staticContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*d_Igde_dTemp_Tnode_GND;
staticContributions[admsNodeID_D] -= ((M*(model_.TYPE))*Igde);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] -= (M*(model_.TYPE))*d_Igde_dV_S_B;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= (M*(model_.TYPE))*d_Igde_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] -= (M*(model_.TYPE))*d_Igde_dV_G_S;
d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*d_Igde_dTemp_Tnode_GND;
// I(S,B) <+ (0.0)
staticContributions[admsNodeID_S] += 0.0;
staticContributions[admsNodeID_B] -= 0.0;
// I(D,B) <+ (0.0)
staticContributions[admsNodeID_D] += 0.0;
staticContributions[admsNodeID_B] -= 0.0;
// I(G,B) <+ (0.0)
staticContributions[admsNodeID_G] += 0.0;
staticContributions[admsNodeID_B] -= 0.0;
// I(D,S) <+ (((M*gmin)*V(D,S)))
staticContributions[admsNodeID_D] += ((M*(model_.gmin))*(probeVars[admsProbeID_V_D_S]));
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (M*(model_.gmin))*d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S];
staticContributions[admsNodeID_S] -= ((M*(model_.gmin))*(probeVars[admsProbeID_V_D_S]));
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*(model_.gmin))*d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S];
// Pwr(Tnode,GND) <+ ((M*Ithpwre))
staticContributions[admsNodeID_Tnode] += (M*Ithpwre);
d_staticContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND] += M*d_Ithpwre_dTemp_Tnode_GND;
d_staticContributions[admsNodeID_Tnode][admsProbeID_V_S_B] += M*d_Ithpwre_dV_S_B;
d_staticContributions[admsNodeID_Tnode][admsProbeID_V_D_S] += M*d_Ithpwre_dV_D_S;
d_staticContributions[admsNodeID_Tnode][admsProbeID_V_G_S] += M*d_Ithpwre_dV_G_S;
// Pwr(Tnode,GND) <+ ((M*Ithrce))
staticContributions[admsNodeID_Tnode] += (M*Ithrce);
d_staticContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND] += M*d_Ithrce_dTemp_Tnode_GND;
}
// End block loadStatic
//Begin block loadDynamic
{

d_Qg_dTemp_Tnode_GND = MULT_i*d_Qg_dTemp_Tnode_GND;
d_Qg_dV_S_B = MULT_i*d_Qg_dV_S_B;
d_Qg_dV_D_S = MULT_i*d_Qg_dV_D_S;
d_Qg_dV_G_S = MULT_i*d_Qg_dV_G_S;
Qg = (MULT_i*Qg);

d_Qb_dTemp_Tnode_GND = MULT_i*d_Qb_dTemp_Tnode_GND;
d_Qb_dV_S_B = MULT_i*d_Qb_dV_S_B;
d_Qb_dV_D_S = MULT_i*d_Qb_dV_D_S;
d_Qb_dV_G_S = MULT_i*d_Qb_dV_G_S;
Qb = (MULT_i*Qb);

d_Qd_dTemp_Tnode_GND = MULT_i*d_Qd_dTemp_Tnode_GND;
d_Qd_dV_S_B = MULT_i*d_Qd_dV_S_B;
d_Qd_dV_D_S = MULT_i*d_Qd_dV_D_S;
d_Qd_dV_G_S = MULT_i*d_Qd_dV_G_S;
Qd = (MULT_i*Qd);

d_Qs_dTemp_Tnode_GND = (-((d_Qg_dTemp_Tnode_GND+d_Qb_dTemp_Tnode_GND)+d_Qd_dTemp_Tnode_GND));
d_Qs_dV_S_B = (-((d_Qg_dV_S_B+d_Qb_dV_S_B)+d_Qd_dV_S_B));
d_Qs_dV_D_S = (-((d_Qg_dV_D_S+d_Qb_dV_D_S)+d_Qd_dV_D_S));
d_Qs_dV_G_S = (-((d_Qg_dV_G_S+d_Qb_dV_G_S)+d_Qd_dV_G_S));
Qs = (-((Qg+Qb)+Qd));

d_Qgsif_dTemp_Tnode_GND = MULT_i*d_Qgsif_dTemp_Tnode_GND;
d_Qgsif_dV_D_S = MULT_i*d_Qgsif_dV_D_S;
d_Qgsif_dV_G_S = MULT_i*d_Qgsif_dV_G_S;
d_Qgsif_dV_S_B = MULT_i*d_Qgsif_dV_S_B;
Qgsif = (MULT_i*Qgsif);

d_Qgdif_dTemp_Tnode_GND = MULT_i*d_Qgdif_dTemp_Tnode_GND;
d_Qgdif_dV_D_S = MULT_i*d_Qgdif_dV_D_S;
d_Qgdif_dV_G_S = MULT_i*d_Qgdif_dV_G_S;
d_Qgdif_dV_S_B = MULT_i*d_Qgdif_dV_S_B;
Qgdif = (MULT_i*Qgdif);

d_Qbsif_dV_S_B = MULT_i*d_Qbsif_dV_S_B;
d_Qbsif_dV_D_S = MULT_i*d_Qbsif_dV_D_S;
d_Qbsif_dTemp_Tnode_GND = MULT_i*d_Qbsif_dTemp_Tnode_GND;
d_Qbsif_dV_G_S = MULT_i*d_Qbsif_dV_G_S;
Qbsif = (MULT_i*Qbsif);

d_Qbdif_dV_S_B = MULT_i*d_Qbdif_dV_S_B;
d_Qbdif_dV_D_S = MULT_i*d_Qbdif_dV_D_S;
d_Qbdif_dTemp_Tnode_GND = MULT_i*d_Qbdif_dTemp_Tnode_GND;
d_Qbdif_dV_G_S = MULT_i*d_Qbdif_dV_G_S;
Qbdif = (MULT_i*Qbdif);

d_Qgse_dV_G_S = MULT_i*d_Qgse_dV_G_S;
Qgse = (MULT_i*Qgse);

d_Qgde_dV_D_S = MULT_i*d_Qgde_dV_D_S;
d_Qgde_dV_G_S = MULT_i*d_Qgde_dV_G_S;
Qgde = (MULT_i*Qgde);

d_Qovs_dV_S_B = MULT_i*d_Qovs_dV_S_B;
d_Qovs_dV_D_S = MULT_i*d_Qovs_dV_D_S;
d_Qovs_dV_G_S = MULT_i*d_Qovs_dV_G_S;
d_Qovs_dTemp_Tnode_GND = MULT_i*d_Qovs_dTemp_Tnode_GND;
Qovs = (MULT_i*Qovs);

d_Qovd_dV_S_B = MULT_i*d_Qovd_dV_S_B;
d_Qovd_dV_D_S = MULT_i*d_Qovd_dV_D_S;
d_Qovd_dV_G_S = MULT_i*d_Qovd_dV_G_S;
d_Qovd_dTemp_Tnode_GND = MULT_i*d_Qovd_dTemp_Tnode_GND;
Qovd = (MULT_i*Qovd);

d_Qgbe_dV_S_B = MULT_i*d_Qgbe_dV_S_B;
d_Qgbe_dV_D_S = MULT_i*d_Qgbe_dV_D_S;
d_Qgbe_dV_G_S = MULT_i*d_Qgbe_dV_G_S;
Qgbe = (MULT_i*Qgbe);

d_Qssub_dV_S_B = MULT_i*d_Qssub_dV_S_B;
Qssub = (MULT_i*Qssub);

d_Qdsub_dV_S_B = MULT_i*d_Qdsub_dV_S_B;
d_Qdsub_dV_D_S = MULT_i*d_Qdsub_dV_D_S;
Qdsub = (MULT_i*Qdsub);

d_Qdse_dV_D_S = MULT_i*d_Qdse_dV_D_S;
Qdse = (MULT_i*Qdse);

d_Qth_dTemp_Tnode_GND = MULT_i*d_Qth_dTemp_Tnode_GND;
Qth = (MULT_i*Qth);
if ((sigVds<0.0))
{

d_temp_dTemp_Tnode_GND = d_Qd_dTemp_Tnode_GND;
d_temp_dV_S_B = d_Qd_dV_S_B;
d_temp_dV_D_S = d_Qd_dV_D_S;
d_temp_dV_G_S = d_Qd_dV_G_S;
temp = Qd;

d_Qd_dTemp_Tnode_GND = d_Qs_dTemp_Tnode_GND;
d_Qd_dV_S_B = d_Qs_dV_S_B;
d_Qd_dV_D_S = d_Qs_dV_D_S;
d_Qd_dV_G_S = d_Qs_dV_G_S;
Qd = Qs;

d_Qs_dTemp_Tnode_GND = d_temp_dTemp_Tnode_GND;
d_Qs_dV_S_B = d_temp_dV_S_B;
d_Qs_dV_D_S = d_temp_dV_D_S;
d_Qs_dV_G_S = d_temp_dV_G_S;
Qs = temp;

d_Qdse_dV_D_S = (-d_Qdse_dV_D_S);
Qdse = (-Qdse);

d_temp_dTemp_Tnode_GND = d_Qgdif_dTemp_Tnode_GND;
d_temp_dV_D_S = d_Qgdif_dV_D_S;
d_temp_dV_G_S = d_Qgdif_dV_G_S;
d_temp_dV_S_B = d_Qgdif_dV_S_B;
temp = Qgdif;

d_Qgdif_dTemp_Tnode_GND = d_Qgsif_dTemp_Tnode_GND;
d_Qgdif_dV_D_S = d_Qgsif_dV_D_S;
d_Qgdif_dV_G_S = d_Qgsif_dV_G_S;
d_Qgdif_dV_S_B = d_Qgsif_dV_S_B;
Qgdif = Qgsif;

d_Qgsif_dTemp_Tnode_GND = d_temp_dTemp_Tnode_GND;
d_Qgsif_dV_S_B = d_temp_dV_S_B;
d_Qgsif_dV_D_S = d_temp_dV_D_S;
d_Qgsif_dV_G_S = d_temp_dV_G_S;
Qgsif = temp;

d_temp_dV_S_B = d_Qbdif_dV_S_B;
d_temp_dV_D_S = d_Qbdif_dV_D_S;
d_temp_dTemp_Tnode_GND = d_Qbdif_dTemp_Tnode_GND;
d_temp_dV_G_S = d_Qbdif_dV_G_S;
temp = Qbdif;

d_Qbdif_dV_S_B = d_Qbsif_dV_S_B;
d_Qbdif_dV_D_S = d_Qbsif_dV_D_S;
d_Qbdif_dTemp_Tnode_GND = d_Qbsif_dTemp_Tnode_GND;
d_Qbdif_dV_G_S = d_Qbsif_dV_G_S;
Qbdif = Qbsif;

d_Qbsif_dTemp_Tnode_GND = d_temp_dTemp_Tnode_GND;
d_Qbsif_dV_S_B = d_temp_dV_S_B;
d_Qbsif_dV_D_S = d_temp_dV_D_S;
d_Qbsif_dV_G_S = d_temp_dV_G_S;
Qbsif = temp;
}
// I(G,S) <+ (((M*TYPE)*(((ddt(Qg)+ddt(Qgse))+ddt(Qovs))+ddt(Qgsif))))
dynamicContributions[admsNodeID_G] += ((M*(model_.TYPE))*((((Qg)+(Qgse))+(Qovs))+(Qgsif)));
d_dynamicContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*((((d_Qg_dTemp_Tnode_GND)+(0.0))+(d_Qovs_dTemp_Tnode_GND))+(d_Qgsif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B] += (M*(model_.TYPE))*((((d_Qg_dV_S_B)+(0.0))+(d_Qovs_dV_S_B))+(d_Qgsif_dV_S_B));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] += (M*(model_.TYPE))*((((d_Qg_dV_D_S)+(0.0))+(d_Qovs_dV_D_S))+(d_Qgsif_dV_D_S));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] += (M*(model_.TYPE))*((((d_Qg_dV_G_S)+(d_Qgse_dV_G_S))+(d_Qovs_dV_G_S))+(d_Qgsif_dV_G_S));
dynamicContributions[admsNodeID_S] -= ((M*(model_.TYPE))*((((Qg)+(Qgse))+(Qovs))+(Qgsif)));
d_dynamicContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*((((d_Qg_dTemp_Tnode_GND)+(0.0))+(d_Qovs_dTemp_Tnode_GND))+(d_Qgsif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B] -= (M*(model_.TYPE))*((((d_Qg_dV_S_B)+(0.0))+(d_Qovs_dV_S_B))+(d_Qgsif_dV_S_B));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*(model_.TYPE))*((((d_Qg_dV_D_S)+(0.0))+(d_Qovs_dV_D_S))+(d_Qgsif_dV_D_S));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S] -= (M*(model_.TYPE))*((((d_Qg_dV_G_S)+(d_Qgse_dV_G_S))+(d_Qovs_dV_G_S))+(d_Qgsif_dV_G_S));
// I(B,S) <+ (((M*TYPE)*((ddt(Qb)+ddt(Qssub))+ddt(Qbsif))))
dynamicContributions[admsNodeID_B] += ((M*(model_.TYPE))*(((Qb)+(Qssub))+(Qbsif)));
d_dynamicContributions[admsNodeID_B][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*(((d_Qb_dTemp_Tnode_GND)+(0.0))+(d_Qbsif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B] += (M*(model_.TYPE))*(((d_Qb_dV_S_B)+(d_Qssub_dV_S_B))+(d_Qbsif_dV_S_B));
d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] += (M*(model_.TYPE))*(((d_Qb_dV_D_S)+(0.0))+(d_Qbsif_dV_D_S));
d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S] += (M*(model_.TYPE))*(((d_Qb_dV_G_S)+(0.0))+(d_Qbsif_dV_G_S));
dynamicContributions[admsNodeID_S] -= ((M*(model_.TYPE))*(((Qb)+(Qssub))+(Qbsif)));
d_dynamicContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*(((d_Qb_dTemp_Tnode_GND)+(0.0))+(d_Qbsif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B] -= (M*(model_.TYPE))*(((d_Qb_dV_S_B)+(d_Qssub_dV_S_B))+(d_Qbsif_dV_S_B));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*(model_.TYPE))*(((d_Qb_dV_D_S)+(0.0))+(d_Qbsif_dV_D_S));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S] -= (M*(model_.TYPE))*(((d_Qb_dV_G_S)+(0.0))+(d_Qbsif_dV_G_S));
// I(D,S) <+ (((M*TYPE)*(ddt(Qd)+ddt(Qdse))))
dynamicContributions[admsNodeID_D] += ((M*(model_.TYPE))*((Qd)+(Qdse)));
d_dynamicContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*((d_Qd_dTemp_Tnode_GND)+(0.0));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B] += (M*(model_.TYPE))*((d_Qd_dV_S_B)+(0.0));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] += (M*(model_.TYPE))*((d_Qd_dV_D_S)+(d_Qdse_dV_D_S));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S] += (M*(model_.TYPE))*((d_Qd_dV_G_S)+(0.0));
dynamicContributions[admsNodeID_S] -= ((M*(model_.TYPE))*((Qd)+(Qdse)));
d_dynamicContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*((d_Qd_dTemp_Tnode_GND)+(0.0));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B] -= (M*(model_.TYPE))*((d_Qd_dV_S_B)+(0.0));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*(model_.TYPE))*((d_Qd_dV_D_S)+(d_Qdse_dV_D_S));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S] -= (M*(model_.TYPE))*((d_Qd_dV_G_S)+(0.0));
// I(G,D) <+ (((M*TYPE)*((ddt(Qgde)+ddt(Qovd))+ddt(Qgdif))))
dynamicContributions[admsNodeID_G] += ((M*(model_.TYPE))*(((Qgde)+(Qovd))+(Qgdif)));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B] += (M*(model_.TYPE))*(((0.0)+(d_Qovd_dV_S_B))+(d_Qgdif_dV_S_B));
d_dynamicContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*(((0.0)+(d_Qovd_dTemp_Tnode_GND))+(d_Qgdif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] += (M*(model_.TYPE))*(((d_Qgde_dV_D_S)+(d_Qovd_dV_D_S))+(d_Qgdif_dV_D_S));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] += (M*(model_.TYPE))*(((d_Qgde_dV_G_S)+(d_Qovd_dV_G_S))+(d_Qgdif_dV_G_S));
dynamicContributions[admsNodeID_D] -= ((M*(model_.TYPE))*(((Qgde)+(Qovd))+(Qgdif)));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B] -= (M*(model_.TYPE))*(((0.0)+(d_Qovd_dV_S_B))+(d_Qgdif_dV_S_B));
d_dynamicContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*(((0.0)+(d_Qovd_dTemp_Tnode_GND))+(d_Qgdif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] -= (M*(model_.TYPE))*(((d_Qgde_dV_D_S)+(d_Qovd_dV_D_S))+(d_Qgdif_dV_D_S));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S] -= (M*(model_.TYPE))*(((d_Qgde_dV_G_S)+(d_Qovd_dV_G_S))+(d_Qgdif_dV_G_S));
// I(B,D) <+ (((M*TYPE)*(ddt(Qdsub)+ddt(Qbdif))))
dynamicContributions[admsNodeID_B] += ((M*(model_.TYPE))*((Qdsub)+(Qbdif)));
d_dynamicContributions[admsNodeID_B][admsProbeID_Temp_Tnode_GND] += (M*(model_.TYPE))*((0.0)+(d_Qbdif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S] += (M*(model_.TYPE))*((0.0)+(d_Qbdif_dV_G_S));
d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B] += (M*(model_.TYPE))*((d_Qdsub_dV_S_B)+(d_Qbdif_dV_S_B));
d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] += (M*(model_.TYPE))*((d_Qdsub_dV_D_S)+(d_Qbdif_dV_D_S));
dynamicContributions[admsNodeID_D] -= ((M*(model_.TYPE))*((Qdsub)+(Qbdif)));
d_dynamicContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] -= (M*(model_.TYPE))*((0.0)+(d_Qbdif_dTemp_Tnode_GND));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S] -= (M*(model_.TYPE))*((0.0)+(d_Qbdif_dV_G_S));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B] -= (M*(model_.TYPE))*((d_Qdsub_dV_S_B)+(d_Qbdif_dV_S_B));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] -= (M*(model_.TYPE))*((d_Qdsub_dV_D_S)+(d_Qbdif_dV_D_S));
// I(G,B) <+ (((M*TYPE)*ddt(Qgbe)))
dynamicContributions[admsNodeID_G] += ((M*(model_.TYPE))*(Qgbe));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B] += (M*(model_.TYPE))*(d_Qgbe_dV_S_B);
d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] += (M*(model_.TYPE))*(d_Qgbe_dV_D_S);
d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] += (M*(model_.TYPE))*(d_Qgbe_dV_G_S);
dynamicContributions[admsNodeID_B] -= ((M*(model_.TYPE))*(Qgbe));
d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B] -= (M*(model_.TYPE))*(d_Qgbe_dV_S_B);
d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] -= (M*(model_.TYPE))*(d_Qgbe_dV_D_S);
d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S] -= (M*(model_.TYPE))*(d_Qgbe_dV_G_S);
// Pwr(Tnode,GND) <+ ((M*ddt(Qth)))
dynamicContributions[admsNodeID_Tnode] += (M*(Qth));
d_dynamicContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND] += M*(d_Qth_dTemp_Tnode_GND);
}
// End block loadDynamic
//Begin block noise
{
Nunit = ((CsiPrime/1.602176565E-19)*phit);

d_dm_dV_S_B = (-0.5)*(d_ds_dV_S_B+d_dd_dV_S_B);
d_dm_dTemp_Tnode_GND = (-0.5)*(d_ds_dTemp_Tnode_GND+d_dd_dTemp_Tnode_GND);
d_dm_dV_D_S = (-0.5)*(d_ds_dV_D_S+d_dd_dV_D_S);
d_dm_dV_G_S = (-0.5)*(d_ds_dV_G_S+d_dd_dV_G_S);
dm = ((-0.5)*(ds+dd));

d_qimstar_dV_S_B = (d_qim_dV_S_B+d_dm_dV_S_B);
d_qimstar_dV_D_S = (d_qim_dV_D_S+d_dm_dV_D_S);
d_qimstar_dV_G_S = (d_qim_dV_G_S+d_dm_dV_G_S);
d_qimstar_dTemp_Tnode_GND = (d_qim_dTemp_Tnode_GND+d_dm_dTemp_Tnode_GND);
qimstar = (qim+dm);

d_temp_dV_S_B = ((qimstar*d_qim_dV_S_B-qim*d_qimstar_dV_S_B)/qimstar/qimstar);
d_temp_dV_D_S = ((qimstar*d_qim_dV_D_S-qim*d_qimstar_dV_D_S)/qimstar/qimstar);
d_temp_dV_G_S = ((qimstar*d_qim_dV_G_S-qim*d_qimstar_dV_G_S)/qimstar/qimstar);
d_temp_dTemp_Tnode_GND = ((qimstar*d_qim_dTemp_Tnode_GND-qim*d_qimstar_dTemp_Tnode_GND)/qimstar/qimstar);
temp = (qim/qimstar);
{
double value_sqrt_0 = sqrt((((temp)*(temp))+1.0e-20));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_t1_dTemp_Tnode_GND = 0.5*(d_temp_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(((temp)*d_temp_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*(temp)))));
d_t1_dV_S_B = 0.5*(d_temp_dV_S_B+(deriv_sqrt_0_d0*(((temp)*d_temp_dV_S_B+d_temp_dV_S_B*(temp)))));
d_t1_dV_D_S = 0.5*(d_temp_dV_D_S+(deriv_sqrt_0_d0*(((temp)*d_temp_dV_D_S+d_temp_dV_D_S*(temp)))));
d_t1_dV_G_S = 0.5*(d_temp_dV_G_S+(deriv_sqrt_0_d0*(((temp)*d_temp_dV_G_S+d_temp_dV_G_S*(temp)))));
t1 = (0.5*(temp+value_sqrt_0));
}

d_sqrt_t2_dV_S_B = (((-0.1666666666667)*delta_k1q1)*d_inv_k1h1_0_dV_S_B+(-0.1666666666667)*d_delta_k1q1_dV_S_B*inv_k1h1_0);
d_sqrt_t2_dTemp_Tnode_GND = (((-0.1666666666667)*delta_k1q1)*d_inv_k1h1_0_dTemp_Tnode_GND+(-0.1666666666667)*d_delta_k1q1_dTemp_Tnode_GND*inv_k1h1_0);
d_sqrt_t2_dV_D_S = (((-0.1666666666667)*delta_k1q1)*d_inv_k1h1_0_dV_D_S+(-0.1666666666667)*d_delta_k1q1_dV_D_S*inv_k1h1_0);
d_sqrt_t2_dV_G_S = (((-0.1666666666667)*delta_k1q1)*d_inv_k1h1_0_dV_G_S+(-0.1666666666667)*d_delta_k1q1_dV_G_S*inv_k1h1_0);
sqrt_t2 = (((-0.1666666666667)*delta_k1q1)*inv_k1h1_0);

d_t2_dV_S_B = (sqrt_t2*d_sqrt_t2_dV_S_B+d_sqrt_t2_dV_S_B*sqrt_t2);
d_t2_dTemp_Tnode_GND = (sqrt_t2*d_sqrt_t2_dTemp_Tnode_GND+d_sqrt_t2_dTemp_Tnode_GND*sqrt_t2);
d_t2_dV_D_S = (sqrt_t2*d_sqrt_t2_dV_D_S+d_sqrt_t2_dV_D_S*sqrt_t2);
d_t2_dV_G_S = (sqrt_t2*d_sqrt_t2_dV_G_S+d_sqrt_t2_dV_G_S*sqrt_t2);
t2 = (sqrt_t2*sqrt_t2);

d_r_dV_S_B = d_hsat_dV_S_B;
d_r_dV_G_S = d_hsat_dV_G_S;
d_r_dV_D_S = d_hsat_dV_D_S;
d_r_dTemp_Tnode_GND = d_hsat_dTemp_Tnode_GND;
r = (hsat-1.0);
{
double value_max_0 = std::max((1.0-((12.0*r)*t2)),static_cast<double>(1.0e-20));
double  deriv_max_0_d0 = (((1.0-((12.0*r)*t2))>=1.0e-20)?1.0:0.0);

d_lc_dV_S_B = (deriv_max_0_d0*((-((12.0*r)*d_t2_dV_S_B+12.0*d_r_dV_S_B*t2))));
d_lc_dV_G_S = (deriv_max_0_d0*((-((12.0*r)*d_t2_dV_G_S+12.0*d_r_dV_G_S*t2))));
d_lc_dV_D_S = (deriv_max_0_d0*((-((12.0*r)*d_t2_dV_D_S+12.0*d_r_dV_D_S*t2))));
d_lc_dTemp_Tnode_GND = (deriv_max_0_d0*((-((12.0*r)*d_t2_dTemp_Tnode_GND+12.0*d_r_dTemp_Tnode_GND*t2))));
lc = value_max_0;
}

d_lcinv2_dV_S_B = (-(lc*d_lc_dV_S_B+d_lc_dV_S_B*lc)/(lc*lc)/(lc*lc));
d_lcinv2_dV_G_S = (-(lc*d_lc_dV_G_S+d_lc_dV_G_S*lc)/(lc*lc)/(lc*lc));
d_lcinv2_dV_D_S = (-(lc*d_lc_dV_D_S+d_lc_dV_D_S*lc)/(lc*lc)/(lc*lc));
d_lcinv2_dTemp_Tnode_GND = (-(lc*d_lc_dTemp_Tnode_GND+d_lc_dTemp_Tnode_GND*lc)/(lc*lc)/(lc*lc));
lcinv2 = (1.0/(lc*lc));

d_g_ideal_dTemp_Tnode_GND = ((qmfact*((Gvsat*((((betneff*CsiPrime)*phit)*qimstar)*d_FdL_dTemp_Tnode_GND+(((betneff*CsiPrime)*phit)*d_qimstar_dTemp_Tnode_GND+((betneff*CsiPrime)*d_phit_dTemp_Tnode_GND+(betneff*d_CsiPrime_dTemp_Tnode_GND+d_betneff_dTemp_Tnode_GND*CsiPrime)*phit)*qimstar)*FdL)-((((betneff*CsiPrime)*phit)*qimstar)*FdL)*d_Gvsat_dTemp_Tnode_GND)/Gvsat/Gvsat)-(((((betneff*CsiPrime)*phit)*qimstar)*FdL)/Gvsat)*d_qmfact_dTemp_Tnode_GND)/qmfact/qmfact);
d_g_ideal_dV_D_S = ((qmfact*((Gvsat*((((betneff*CsiPrime)*phit)*qimstar)*d_FdL_dV_D_S+(((betneff*CsiPrime)*phit)*d_qimstar_dV_D_S+(betneff*d_CsiPrime_dV_D_S+d_betneff_dV_D_S*CsiPrime)*phit*qimstar)*FdL)-((((betneff*CsiPrime)*phit)*qimstar)*FdL)*d_Gvsat_dV_D_S)/Gvsat/Gvsat)-(((((betneff*CsiPrime)*phit)*qimstar)*FdL)/Gvsat)*d_qmfact_dV_D_S)/qmfact/qmfact);
d_g_ideal_dV_G_S = ((qmfact*((Gvsat*((((betneff*CsiPrime)*phit)*qimstar)*d_FdL_dV_G_S+(((betneff*CsiPrime)*phit)*d_qimstar_dV_G_S+(betneff*d_CsiPrime_dV_G_S+d_betneff_dV_G_S*CsiPrime)*phit*qimstar)*FdL)-((((betneff*CsiPrime)*phit)*qimstar)*FdL)*d_Gvsat_dV_G_S)/Gvsat/Gvsat)-(((((betneff*CsiPrime)*phit)*qimstar)*FdL)/Gvsat)*d_qmfact_dV_G_S)/qmfact/qmfact);
d_g_ideal_dV_S_B = ((qmfact*((Gvsat*((((betneff*CsiPrime)*phit)*qimstar)*d_FdL_dV_S_B+(((betneff*CsiPrime)*phit)*d_qimstar_dV_S_B+(betneff*d_CsiPrime_dV_S_B+d_betneff_dV_S_B*CsiPrime)*phit*qimstar)*FdL)-((((betneff*CsiPrime)*phit)*qimstar)*FdL)*d_Gvsat_dV_S_B)/Gvsat/Gvsat)-(((((betneff*CsiPrime)*phit)*qimstar)*FdL)/Gvsat)*d_qmfact_dV_S_B)/qmfact/qmfact);
g_ideal = ((((((betneff*CsiPrime)*phit)*qimstar)*FdL)/Gvsat)/qmfact);

d_t2x12_dV_S_B = 12.0*d_t2_dV_S_B;
d_t2x12_dTemp_Tnode_GND = 12.0*d_t2_dTemp_Tnode_GND;
d_t2x12_dV_D_S = 12.0*d_t2_dV_D_S;
d_t2x12_dV_G_S = 12.0*d_t2_dV_G_S;
t2x12 = (12.0*t2);

d_temp1_dTemp_Tnode_GND = ((d_t1_dTemp_Tnode_GND+d_t2x12_dTemp_Tnode_GND)-(((2.0*(1.0+t1))*t2x12)*d_r_dTemp_Tnode_GND+((2.0*(1.0+t1))*d_t2x12_dTemp_Tnode_GND+2.0*d_t1_dTemp_Tnode_GND*t2x12)*r));
d_temp1_dV_S_B = ((d_t1_dV_S_B+d_t2x12_dV_S_B)-(((2.0*(1.0+t1))*t2x12)*d_r_dV_S_B+((2.0*(1.0+t1))*d_t2x12_dV_S_B+2.0*d_t1_dV_S_B*t2x12)*r));
d_temp1_dV_D_S = ((d_t1_dV_D_S+d_t2x12_dV_D_S)-(((2.0*(1.0+t1))*t2x12)*d_r_dV_D_S+((2.0*(1.0+t1))*d_t2x12_dV_D_S+2.0*d_t1_dV_D_S*t2x12)*r));
d_temp1_dV_G_S = ((d_t1_dV_G_S+d_t2x12_dV_G_S)-(((2.0*(1.0+t1))*t2x12)*d_r_dV_G_S+((2.0*(1.0+t1))*d_t2x12_dV_G_S+2.0*d_t1_dV_G_S*t2x12)*r));
temp1 = ((t1+t2x12)-(((2.0*(1.0+t1))*t2x12)*r));
{
double value_max_0 = std::max(temp1,static_cast<double>(1.0e-40));
double  deriv_max_0_d0 = ((temp1>=1.0e-40)?1.0:0.0);

d_temp2_dTemp_Tnode_GND = (deriv_max_0_d0*(d_temp1_dTemp_Tnode_GND));
d_temp2_dV_D_S = (deriv_max_0_d0*(d_temp1_dV_D_S));
d_temp2_dV_G_S = (deriv_max_0_d0*(d_temp1_dV_G_S));
d_temp2_dV_S_B = (deriv_max_0_d0*(d_temp1_dV_S_B));
temp2 = value_max_0;
}

d_gSid_dTemp_Tnode_GND = ((g_ideal*lcinv2)*d_temp2_dTemp_Tnode_GND+(g_ideal*d_lcinv2_dTemp_Tnode_GND+d_g_ideal_dTemp_Tnode_GND*lcinv2)*temp2);
d_gSid_dV_D_S = ((g_ideal*lcinv2)*d_temp2_dV_D_S+(g_ideal*d_lcinv2_dV_D_S+d_g_ideal_dV_D_S*lcinv2)*temp2);
d_gSid_dV_G_S = ((g_ideal*lcinv2)*d_temp2_dV_G_S+(g_ideal*d_lcinv2_dV_G_S+d_g_ideal_dV_G_S*lcinv2)*temp2);
d_gSid_dV_S_B = ((g_ideal*lcinv2)*d_temp2_dV_S_B+(g_ideal*d_lcinv2_dV_S_B+d_g_ideal_dV_S_B*lcinv2)*temp2);
gSid = ((g_ideal*lcinv2)*temp2);
if ((FNTEXC_i>0.0))
{

d_sqrt_zsatexc_dV_S_B = ((Gmob*d_Ggamma_dV_S_B-Ggamma*d_Gmob_dV_S_B)/Gmob/Gmob);
d_sqrt_zsatexc_dV_G_S = ((Gmob*d_Ggamma_dV_G_S-Ggamma*d_Gmob_dV_G_S)/Gmob/Gmob);
d_sqrt_zsatexc_dV_D_S = ((Gmob*d_Ggamma_dV_D_S-Ggamma*d_Gmob_dV_D_S)/Gmob/Gmob);
d_sqrt_zsatexc_dTemp_Tnode_GND = ((Gmob*d_Ggamma_dTemp_Tnode_GND-Ggamma*d_Gmob_dTemp_Tnode_GND)/Gmob/Gmob);
sqrt_zsatexc = (Ggamma/Gmob);

d_Sidexc_dV_D_S = (((((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)*((fac_exc*Ids)*d_xdeff_dV_D_S+fac_exc*d_Ids_dV_D_S*xdeff)*phit0-(((fac_exc*Ids)*xdeff)*phit0)*(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*d_lc_dV_D_S+((1.0+(sqrt_zsatexc*sqrt_zsatexc))*d_lc_dV_D_S+(sqrt_zsatexc*d_sqrt_zsatexc_dV_D_S+d_sqrt_zsatexc_dV_D_S*sqrt_zsatexc)*lc)*lc))/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc));
d_Sidexc_dV_G_S = (((((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)*((fac_exc*Ids)*d_xdeff_dV_G_S+fac_exc*d_Ids_dV_G_S*xdeff)*phit0-(((fac_exc*Ids)*xdeff)*phit0)*(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*d_lc_dV_G_S+((1.0+(sqrt_zsatexc*sqrt_zsatexc))*d_lc_dV_G_S+(sqrt_zsatexc*d_sqrt_zsatexc_dV_G_S+d_sqrt_zsatexc_dV_G_S*sqrt_zsatexc)*lc)*lc))/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc));
d_Sidexc_dV_S_B = (((((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)*((fac_exc*Ids)*d_xdeff_dV_S_B+fac_exc*d_Ids_dV_S_B*xdeff)*phit0-(((fac_exc*Ids)*xdeff)*phit0)*(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*d_lc_dV_S_B+((1.0+(sqrt_zsatexc*sqrt_zsatexc))*d_lc_dV_S_B+(sqrt_zsatexc*d_sqrt_zsatexc_dV_S_B+d_sqrt_zsatexc_dV_S_B*sqrt_zsatexc)*lc)*lc))/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc));
d_Sidexc_dTemp_Tnode_GND = (((((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)*(((fac_exc*Ids)*xdeff)*d_phit0_dTemp_Tnode_GND+((fac_exc*Ids)*d_xdeff_dTemp_Tnode_GND+fac_exc*d_Ids_dTemp_Tnode_GND*xdeff)*phit0)-(((fac_exc*Ids)*xdeff)*phit0)*(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*d_lc_dTemp_Tnode_GND+((1.0+(sqrt_zsatexc*sqrt_zsatexc))*d_lc_dTemp_Tnode_GND+(sqrt_zsatexc*d_sqrt_zsatexc_dTemp_Tnode_GND+d_sqrt_zsatexc_dTemp_Tnode_GND*sqrt_zsatexc)*lc)*lc))/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc)/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc));
Sidexc = ((((fac_exc*Ids)*xdeff)*phit0)/(((1.0+(sqrt_zsatexc*sqrt_zsatexc))*lc)*lc));

d_gSid_dTemp_Tnode_GND = (d_gSid_dTemp_Tnode_GND+(d_Sidexc_dTemp_Tnode_GND/nt0));
d_gSid_dV_D_S = (d_gSid_dV_D_S+(d_Sidexc_dV_D_S/nt0));
d_gSid_dV_G_S = (d_gSid_dV_G_S+(d_Sidexc_dV_G_S/nt0));
d_gSid_dV_S_B = (d_gSid_dV_S_B+(d_Sidexc_dV_S_B/nt0));
gSid = (gSid+(Sidexc/nt0));
}
Sids_th = ((MULT_i*nt)*gSid);

d_COX_qm_dV_S_B = ((qmfact1*(k1*d_CsiPrime_dV_S_B+d_k1_dV_S_B*CsiPrime)*AREAQ_i-((k1*CsiPrime)*AREAQ_i)*d_qmfact1_dV_S_B)/qmfact1/qmfact1);
d_COX_qm_dTemp_Tnode_GND = ((qmfact1*(k1*d_CsiPrime_dTemp_Tnode_GND+d_k1_dTemp_Tnode_GND*CsiPrime)*AREAQ_i-((k1*CsiPrime)*AREAQ_i)*d_qmfact1_dTemp_Tnode_GND)/qmfact1/qmfact1);
d_COX_qm_dV_D_S = ((qmfact1*(k1*d_CsiPrime_dV_D_S+d_k1_dV_D_S*CsiPrime)*AREAQ_i-((k1*CsiPrime)*AREAQ_i)*d_qmfact1_dV_D_S)/qmfact1/qmfact1);
d_COX_qm_dV_G_S = ((qmfact1*(k1*d_CsiPrime_dV_G_S+d_k1_dV_G_S*CsiPrime)*AREAQ_i-((k1*CsiPrime)*AREAQ_i)*d_qmfact1_dV_G_S)/qmfact1/qmfact1);
COX_qm = (((k1*CsiPrime)*AREAQ_i)/qmfact1);

d_CGeff_dV_S_B = ((1.0+zsat)*d_COX_qm_dV_S_B+d_zsat_dV_S_B*COX_qm);
d_CGeff_dV_G_S = ((1.0+zsat)*d_COX_qm_dV_G_S+d_zsat_dV_G_S*COX_qm);
d_CGeff_dV_D_S = ((1.0+zsat)*d_COX_qm_dV_D_S+d_zsat_dV_D_S*COX_qm);
d_CGeff_dTemp_Tnode_GND = ((1.0+zsat)*d_COX_qm_dTemp_Tnode_GND+d_zsat_dTemp_Tnode_GND*COX_qm);
CGeff = ((1.0+zsat)*COX_qm);

d_CDGeff_dV_S_B = (CGeff*(-(0.25*sigVds)*d_sqrt_t2_dV_S_B)+d_CGeff_dV_S_B*(0.5-((0.25*sigVds)*sqrt_t2)));
d_CDGeff_dV_G_S = (CGeff*(-(0.25*sigVds)*d_sqrt_t2_dV_G_S)+d_CGeff_dV_G_S*(0.5-((0.25*sigVds)*sqrt_t2)));
d_CDGeff_dV_D_S = (CGeff*(-(0.25*sigVds)*d_sqrt_t2_dV_D_S)+d_CGeff_dV_D_S*(0.5-((0.25*sigVds)*sqrt_t2)));
d_CDGeff_dTemp_Tnode_GND = (CGeff*(-(0.25*sigVds)*d_sqrt_t2_dTemp_Tnode_GND)+d_CGeff_dTemp_Tnode_GND*(0.5-((0.25*sigVds)*sqrt_t2)));
CDGeff = (CGeff*(0.5-((0.25*sigVds)*sqrt_t2)));

d_CSGeff_dV_S_B = (d_CGeff_dV_S_B-d_CDGeff_dV_S_B);
d_CSGeff_dV_G_S = (d_CGeff_dV_G_S-d_CDGeff_dV_G_S);
d_CSGeff_dV_D_S = (d_CGeff_dV_D_S-d_CDGeff_dV_D_S);
d_CSGeff_dTemp_Tnode_GND = (d_CGeff_dTemp_Tnode_GND-d_CDGeff_dTemp_Tnode_GND);
CSGeff = (CGeff-CDGeff);

d_migid_dTemp_Tnode_GND = d_migid_dV_D_S = d_migid_dV_G_S = d_migid_dV_S_B =  0.0;
migid = 0.0;
cigid2 = 0.0;
if (((model_.SWIGN)>0))
{

d_temp1_dTemp_Tnode_GND = (((d_t1_dTemp_Tnode_GND/12.0)-(t2*(d_t1_dTemp_Tnode_GND-d_t2x12_dTemp_Tnode_GND)+d_t2_dTemp_Tnode_GND*((t1+0.2)-t2x12)))-(((1.6*t2)*((t1+1.0)-t2x12))*d_r_dTemp_Tnode_GND+((1.6*t2)*(d_t1_dTemp_Tnode_GND-d_t2x12_dTemp_Tnode_GND)+1.6*d_t2_dTemp_Tnode_GND*((t1+1.0)-t2x12))*r));
d_temp1_dV_S_B = (((d_t1_dV_S_B/12.0)-(t2*(d_t1_dV_S_B-d_t2x12_dV_S_B)+d_t2_dV_S_B*((t1+0.2)-t2x12)))-(((1.6*t2)*((t1+1.0)-t2x12))*d_r_dV_S_B+((1.6*t2)*(d_t1_dV_S_B-d_t2x12_dV_S_B)+1.6*d_t2_dV_S_B*((t1+1.0)-t2x12))*r));
d_temp1_dV_D_S = (((d_t1_dV_D_S/12.0)-(t2*(d_t1_dV_D_S-d_t2x12_dV_D_S)+d_t2_dV_D_S*((t1+0.2)-t2x12)))-(((1.6*t2)*((t1+1.0)-t2x12))*d_r_dV_D_S+((1.6*t2)*(d_t1_dV_D_S-d_t2x12_dV_D_S)+1.6*d_t2_dV_D_S*((t1+1.0)-t2x12))*r));
d_temp1_dV_G_S = (((d_t1_dV_G_S/12.0)-(t2*(d_t1_dV_G_S-d_t2x12_dV_G_S)+d_t2_dV_G_S*((t1+0.2)-t2x12)))-(((1.6*t2)*((t1+1.0)-t2x12))*d_r_dV_G_S+((1.6*t2)*(d_t1_dV_G_S-d_t2x12_dV_G_S)+1.6*d_t2_dV_G_S*((t1+1.0)-t2x12))*r));
temp1 = (((t1/12.0)-(t2*((t1+0.2)-t2x12)))-(((1.6*t2)*((t1+1.0)-t2x12))*r));
{
double value_max_0 = std::max(temp1,static_cast<double>(1.0e-40));
double  deriv_max_0_d0 = ((temp1>=1.0e-40)?1.0:0.0);

d_temp2_dTemp_Tnode_GND = (deriv_max_0_d0*(d_temp1_dTemp_Tnode_GND));
d_temp2_dV_D_S = (deriv_max_0_d0*(d_temp1_dV_D_S));
d_temp2_dV_G_S = (deriv_max_0_d0*(d_temp1_dV_G_S));
d_temp2_dV_S_B = (deriv_max_0_d0*(d_temp1_dV_S_B));
temp2 = value_max_0;
}

d_gSig_dTemp_Tnode_GND = ((temp2*((g_ideal*lc)*d_lc_dTemp_Tnode_GND+(g_ideal*d_lc_dTemp_Tnode_GND+d_g_ideal_dTemp_Tnode_GND*lc)*lc)-((g_ideal*lc)*lc)*d_temp2_dTemp_Tnode_GND)/temp2/temp2);
d_gSig_dV_D_S = ((temp2*((g_ideal*lc)*d_lc_dV_D_S+(g_ideal*d_lc_dV_D_S+d_g_ideal_dV_D_S*lc)*lc)-((g_ideal*lc)*lc)*d_temp2_dV_D_S)/temp2/temp2);
d_gSig_dV_G_S = ((temp2*((g_ideal*lc)*d_lc_dV_G_S+(g_ideal*d_lc_dV_G_S+d_g_ideal_dV_G_S*lc)*lc)-((g_ideal*lc)*lc)*d_temp2_dV_G_S)/temp2/temp2);
d_gSig_dV_S_B = ((temp2*((g_ideal*lc)*d_lc_dV_S_B+(g_ideal*d_lc_dV_S_B+d_g_ideal_dV_S_B*lc)*lc)-((g_ideal*lc)*lc)*d_temp2_dV_S_B)/temp2/temp2);
gSig = (((g_ideal*lc)*lc)/temp2);
SigR_th = ((MULT_i*nt)*gSig);
if ((gSid>0))
{

d_migid_dV_S_B = ((lcinv2*sqrt_t2)*((-d_t2x12_dV_S_B)-(((t1+(19.2*t2))-(t1*t2x12))*d_r_dV_S_B+((d_t1_dV_S_B+19.2*d_t2_dV_S_B)-(t1*d_t2x12_dV_S_B+d_t1_dV_S_B*t2x12))*r))+(lcinv2*d_sqrt_t2_dV_S_B+d_lcinv2_dV_S_B*sqrt_t2)*((1.0-t2x12)-(((t1+(19.2*t2))-(t1*t2x12))*r)));
d_migid_dV_G_S = ((lcinv2*sqrt_t2)*((-d_t2x12_dV_G_S)-(((t1+(19.2*t2))-(t1*t2x12))*d_r_dV_G_S+((d_t1_dV_G_S+19.2*d_t2_dV_G_S)-(t1*d_t2x12_dV_G_S+d_t1_dV_G_S*t2x12))*r))+(lcinv2*d_sqrt_t2_dV_G_S+d_lcinv2_dV_G_S*sqrt_t2)*((1.0-t2x12)-(((t1+(19.2*t2))-(t1*t2x12))*r)));
d_migid_dV_D_S = ((lcinv2*sqrt_t2)*((-d_t2x12_dV_D_S)-(((t1+(19.2*t2))-(t1*t2x12))*d_r_dV_D_S+((d_t1_dV_D_S+19.2*d_t2_dV_D_S)-(t1*d_t2x12_dV_D_S+d_t1_dV_D_S*t2x12))*r))+(lcinv2*d_sqrt_t2_dV_D_S+d_lcinv2_dV_D_S*sqrt_t2)*((1.0-t2x12)-(((t1+(19.2*t2))-(t1*t2x12))*r)));
d_migid_dTemp_Tnode_GND = ((lcinv2*sqrt_t2)*((-d_t2x12_dTemp_Tnode_GND)-(((t1+(19.2*t2))-(t1*t2x12))*d_r_dTemp_Tnode_GND+((d_t1_dTemp_Tnode_GND+19.2*d_t2_dTemp_Tnode_GND)-(t1*d_t2x12_dTemp_Tnode_GND+d_t1_dTemp_Tnode_GND*t2x12))*r))+(lcinv2*d_sqrt_t2_dTemp_Tnode_GND+d_lcinv2_dTemp_Tnode_GND*sqrt_t2)*((1.0-t2x12)-(((t1+(19.2*t2))-(t1*t2x12))*r)));
migid = ((lcinv2*sqrt_t2)*((1.0-t2x12)-(((t1+(19.2*t2))-(t1*t2x12))*r)));
cigid2 = (((migid*migid)*gSig)/gSid);
{
double value_sqrt_0 = sqrt((((cigid2)*(cigid2))+1.0e-40));
double value_sqrt_1 = sqrt((((cigid2)*(cigid2))+1.0e-40));
double value_sqrt_2 = sqrt((((cigid2)*(cigid2))+1.0e-40));
double value_sqrt_3 = sqrt(((((0.5*(cigid2+value_sqrt_1))-1.0)*((0.5*(cigid2+value_sqrt_2))-1.0))+1.0e-40));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
double  deriv_sqrt_2_d0 = (0.5/value_sqrt_2);
double  deriv_sqrt_3_d0 = (0.5/value_sqrt_3);
cigid2 = (0.5*(((0.5*(cigid2+value_sqrt_0))+1.0)-value_sqrt_3));
}
}
}
else
{

d_gSig_dV_S_B = d_gSig_dV_G_S = d_gSig_dV_D_S = d_gSig_dTemp_Tnode_GND =  0.0;
gSig = 1.0;
SigR_th = 0.0;
}
Sids_th_u = (Sids_th*(1.0-cigid2));
Nstar = Nunit;
Nmstar = (Nunit*(qim+1.0));
DeltaN = (Nunit*(qis-qid));
{
double value_log_0 = log(((Nmstar+(0.5*DeltaN))/(Nmstar-(0.5*DeltaN))));
double  deriv_log_0_d0 = (1.0/((Nmstar+(0.5*DeltaN))/(Nmstar-(0.5*DeltaN))));

d_temp1_dV_S_B = 0.0;
d_temp1_dTemp_Tnode_GND = 0.0;
d_temp1_dV_D_S = 0.0;
d_temp1_dV_G_S = 0.0;
temp1 = (((NFA_i-(NFB_i*Nstar))+((NFC_i*Nstar)*Nstar))*value_log_0);
}

d_temp2_dTemp_Tnode_GND = d_temp1_dTemp_Tnode_GND;
d_temp2_dV_D_S = d_temp1_dV_D_S;
d_temp2_dV_G_S = d_temp1_dV_G_S;
d_temp2_dV_S_B = d_temp1_dV_S_B;
temp2 = (temp1+((NFB_i+(NFC_i*(Nmstar-(2.0*Nstar))))*DeltaN));

d_temp_dTemp_Tnode_GND = (((qim+1.0)*(NFE_i*d_esurf1_dTemp_Tnode_GND+NFEB_i*d_esurf2_dTemp_Tnode_GND)-((NFE_i*esurf1)+(NFEB_i*esurf2))*d_qim_dTemp_Tnode_GND)/(qim+1.0)/(qim+1.0));
d_temp_dV_D_S = (((qim+1.0)*(NFE_i*d_esurf1_dV_D_S+NFEB_i*d_esurf2_dV_D_S)-((NFE_i*esurf1)+(NFEB_i*esurf2))*d_qim_dV_D_S)/(qim+1.0)/(qim+1.0));
d_temp_dV_G_S = (((qim+1.0)*(NFE_i*d_esurf1_dV_G_S+NFEB_i*d_esurf2_dV_G_S)-((NFE_i*esurf1)+(NFEB_i*esurf2))*d_qim_dV_G_S)/(qim+1.0)/(qim+1.0));
d_temp_dV_S_B = (((qim+1.0)*(NFE_i*d_esurf1_dV_S_B+NFEB_i*d_esurf2_dV_S_B)-((NFE_i*esurf1)+(NFEB_i*esurf2))*d_qim_dV_S_B)/(qim+1.0)/(qim+1.0));
temp = (1.0+(((NFE_i*esurf1)+(NFEB_i*esurf2))/(qim+1.0)));
{
double value_sqrt_0 = sqrt((((temp-0.01)*(temp-0.01))+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp3_dTemp_Tnode_GND = 0.5*(d_temp_dTemp_Tnode_GND+(deriv_sqrt_0_d0*(((temp-0.01)*d_temp_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*(temp-0.01)))));
d_temp3_dV_S_B = 0.5*(d_temp_dV_S_B+(deriv_sqrt_0_d0*(((temp-0.01)*d_temp_dV_S_B+d_temp_dV_S_B*(temp-0.01)))));
d_temp3_dV_D_S = 0.5*(d_temp_dV_D_S+(deriv_sqrt_0_d0*(((temp-0.01)*d_temp_dV_D_S+d_temp_dV_D_S*(temp-0.01)))));
d_temp3_dV_G_S = 0.5*(d_temp_dV_G_S+(deriv_sqrt_0_d0*(((temp-0.01)*d_temp_dV_G_S+d_temp_dV_G_S*(temp-0.01)))));
temp3 = (0.5*((temp+0.01)+value_sqrt_0));
}

d_temp_dV_D_S = ((((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*temp2)/Nstar)*d_temp3_dV_D_S+(((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*d_temp2_dV_D_S+((Gvsat*((1.602176565E-19*fact_Ids)*d_Ids_dV_D_S+1.602176565E-19*d_fact_Ids_dV_D_S*Ids)-((1.602176565E-19*fact_Ids)*Ids)*d_Gvsat_dV_D_S)/Gvsat/Gvsat)*temp2)/Nstar)*temp3);
d_temp_dV_G_S = ((((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*temp2)/Nstar)*d_temp3_dV_G_S+(((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*d_temp2_dV_G_S+((Gvsat*((1.602176565E-19*fact_Ids)*d_Ids_dV_G_S+1.602176565E-19*d_fact_Ids_dV_G_S*Ids)-((1.602176565E-19*fact_Ids)*Ids)*d_Gvsat_dV_G_S)/Gvsat/Gvsat)*temp2)/Nstar)*temp3);
d_temp_dV_S_B = ((((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*temp2)/Nstar)*d_temp3_dV_S_B+(((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*d_temp2_dV_S_B+((Gvsat*((1.602176565E-19*fact_Ids)*d_Ids_dV_S_B+1.602176565E-19*d_fact_Ids_dV_S_B*Ids)-((1.602176565E-19*fact_Ids)*Ids)*d_Gvsat_dV_S_B)/Gvsat/Gvsat)*temp2)/Nstar)*temp3);
d_temp_dTemp_Tnode_GND = ((((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*temp2)/Nstar)*d_temp3_dTemp_Tnode_GND+(((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*d_temp2_dTemp_Tnode_GND+((Gvsat*((1.602176565E-19*fact_Ids)*d_Ids_dTemp_Tnode_GND+1.602176565E-19*d_fact_Ids_dTemp_Tnode_GND*Ids)-((1.602176565E-19*fact_Ids)*Ids)*d_Gvsat_dTemp_Tnode_GND)/Gvsat/Gvsat)*temp2)/Nstar)*temp3);
temp = ((((((1.602176565E-19*fact_Ids)*Ids)/Gvsat)*temp2)/Nstar)*temp3);
{
double value_max_0 = std::max(temp,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((temp>=0.0)?1.0:0.0);
Sids_fl = (MULT_i*value_max_0);
}
{
double value_fabs_0 = fabs(Igse);
double  deriv_fabs_0_d0 = (((Igse)>=0)?(+1.0):(-1.0));
Sigs_sh = ((2.0*1.602176565E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igde);
double  deriv_fabs_0_d0 = (((Igde)>=0)?(+1.0):(-1.0));
Sigd_sh = ((2.0*1.602176565E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Iimpact);
double  deriv_fabs_0_d0 = (((Iimpact)>=0)?(+1.0):(-1.0));
shot_iavl = ((2.0*1.602176565E-19)*((mavl+1.0)*value_fabs_0));
}
{
double value_fabs_0 = fabs((Igidle-Igisle));
double  deriv_fabs_0_d0 = ((((Igidle-Igisle))>=0)?(+1.0):(-1.0));
Sids_sh = (((2.0*1.602176565E-19)*value_fabs_0)+shot_iavl);
}
// I(NSIG,GND) <+ (white_noise((M*SigR_th),"ign_g"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[0]= (M*SigR_th);
}
// I(NSIG,GND) <+ (((M*gSig)*V(NSIG,GND)))
staticContributions[admsNodeID_NSIG] += ((M*gSig)*(probeVars[admsProbeID_V_NSIG_GND]));
d_staticContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND] += (M*gSig)*d_probeVars[admsProbeID_V_NSIG_GND][admsProbeID_V_NSIG_GND];
d_staticContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND] += M*d_gSig_dTemp_Tnode_GND*(probeVars[admsProbeID_V_NSIG_GND]);
d_staticContributions[admsNodeID_NSIG][admsProbeID_V_D_S] += M*d_gSig_dV_D_S*(probeVars[admsProbeID_V_NSIG_GND]);
d_staticContributions[admsNodeID_NSIG][admsProbeID_V_G_S] += M*d_gSig_dV_G_S*(probeVars[admsProbeID_V_NSIG_GND]);
d_staticContributions[admsNodeID_NSIG][admsProbeID_V_S_B] += M*d_gSig_dV_S_B*(probeVars[admsProbeID_V_NSIG_GND]);
// I(NSIG,GND) <+ ((M*ddt((CGeff*V(NSIG,GND)))))
dynamicContributions[admsNodeID_NSIG] += (M*((CGeff*(probeVars[admsProbeID_V_NSIG_GND]))));
d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND] += M*(CGeff*d_probeVars[admsProbeID_V_NSIG_GND][admsProbeID_V_NSIG_GND]);
d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_S_B] += M*(d_CGeff_dV_S_B*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_G_S] += M*(d_CGeff_dV_G_S*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_D_S] += M*(d_CGeff_dV_D_S*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND] += M*(d_CGeff_dTemp_Tnode_GND*(probeVars[admsProbeID_V_NSIG_GND]));
// I(G,S) <+ ((M*ddt(((-CSGeff)*V(NSIG,GND)))))
dynamicContributions[admsNodeID_G] += (M*(((-CSGeff)*(probeVars[admsProbeID_V_NSIG_GND]))));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_NSIG_GND] += M*((-CSGeff)*d_probeVars[admsProbeID_V_NSIG_GND][admsProbeID_V_NSIG_GND]);
d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B] += M*((-d_CSGeff_dV_S_B)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] += M*((-d_CSGeff_dV_G_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] += M*((-d_CSGeff_dV_D_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] += M*((-d_CSGeff_dTemp_Tnode_GND)*(probeVars[admsProbeID_V_NSIG_GND]));
dynamicContributions[admsNodeID_S] -= (M*(((-CSGeff)*(probeVars[admsProbeID_V_NSIG_GND]))));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_NSIG_GND] -= M*((-CSGeff)*d_probeVars[admsProbeID_V_NSIG_GND][admsProbeID_V_NSIG_GND]);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B] -= M*((-d_CSGeff_dV_S_B)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S] -= M*((-d_CSGeff_dV_G_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= M*((-d_CSGeff_dV_D_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= M*((-d_CSGeff_dTemp_Tnode_GND)*(probeVars[admsProbeID_V_NSIG_GND]));
// I(G,D) <+ ((M*ddt(((-CDGeff)*V(NSIG,GND)))))
dynamicContributions[admsNodeID_G] += (M*(((-CDGeff)*(probeVars[admsProbeID_V_NSIG_GND]))));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_NSIG_GND] += M*((-CDGeff)*d_probeVars[admsProbeID_V_NSIG_GND][admsProbeID_V_NSIG_GND]);
d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B] += M*((-d_CDGeff_dV_S_B)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] += M*((-d_CDGeff_dV_G_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] += M*((-d_CDGeff_dV_D_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] += M*((-d_CDGeff_dTemp_Tnode_GND)*(probeVars[admsProbeID_V_NSIG_GND]));
dynamicContributions[admsNodeID_D] -= (M*(((-CDGeff)*(probeVars[admsProbeID_V_NSIG_GND]))));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_NSIG_GND] -= M*((-CDGeff)*d_probeVars[admsProbeID_V_NSIG_GND][admsProbeID_V_NSIG_GND]);
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B] -= M*((-d_CDGeff_dV_S_B)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S] -= M*((-d_CDGeff_dV_G_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] -= M*((-d_CDGeff_dV_D_S)*(probeVars[admsProbeID_V_NSIG_GND]));
d_dynamicContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] -= M*((-d_CDGeff_dTemp_Tnode_GND)*(probeVars[admsProbeID_V_NSIG_GND]));
// I(D,S) <+ (white_noise((M*Sids_th_u),"thermal_ids"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[1]= (M*Sids_th_u);
}
// I(D,S) <+ ((((M*sigVds)*migid)*I(NSIG,GND)))
staticContributions[admsNodeID_D] += (((M*sigVds)*migid)*(probeVars[admsProbeID_I_NSIG_GND]));
d_staticContributions[admsNodeID_D][admsProbeID_I_NSIG_GND] += ((M*sigVds)*migid)*d_probeVars[admsProbeID_I_NSIG_GND][admsProbeID_I_NSIG_GND];
d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] += (M*sigVds)*d_migid_dV_S_B*(probeVars[admsProbeID_I_NSIG_GND]);
d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] += (M*sigVds)*d_migid_dV_G_S*(probeVars[admsProbeID_I_NSIG_GND]);
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += (M*sigVds)*d_migid_dV_D_S*(probeVars[admsProbeID_I_NSIG_GND]);
d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] += (M*sigVds)*d_migid_dTemp_Tnode_GND*(probeVars[admsProbeID_I_NSIG_GND]);
staticContributions[admsNodeID_S] -= (((M*sigVds)*migid)*(probeVars[admsProbeID_I_NSIG_GND]));
d_staticContributions[admsNodeID_S][admsProbeID_I_NSIG_GND] -= ((M*sigVds)*migid)*d_probeVars[admsProbeID_I_NSIG_GND][admsProbeID_I_NSIG_GND];
d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] -= (M*sigVds)*d_migid_dV_S_B*(probeVars[admsProbeID_I_NSIG_GND]);
d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] -= (M*sigVds)*d_migid_dV_G_S*(probeVars[admsProbeID_I_NSIG_GND]);
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= (M*sigVds)*d_migid_dV_D_S*(probeVars[admsProbeID_I_NSIG_GND]);
d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] -= (M*sigVds)*d_migid_dTemp_Tnode_GND*(probeVars[admsProbeID_I_NSIG_GND]);
// I(D,S) <+ (flicker_noise((M*Sids_fl),EF_i,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[2]= (M*Sids_fl);
  noiseContribsExponent[2]= EF_i;
}
// I(G,S) <+ (white_noise((M*Sigs_sh),"shot_igs"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[3]= (M*Sigs_sh);
}
// I(G,D) <+ (white_noise((M*Sigd_sh),"shot_igd"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[4]= (M*Sigd_sh);
}
// I(D,S) <+ (white_noise((M*Sids_sh),"shot_ids"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[5]= (M*Sids_sh);
}
}
// End block noise
//Begin block OPinfo
{
type = (model_.TYPE);
r1init_op = ((k2/k1)/(1.0+k2));
r2init_op = ((k1/k2)/(1.0+k1));
{
double value_log_0 = log((((k1*(1.0+r1init_op))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k1*(1.0+r1init_op))*diff_min)/A0));
x1init_op = (value_log_0+2.0);
}
{
double value_log_0 = log((((k2*(1.0+r2init_op))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k2*(1.0+r2init_op))*diff_min)/A0));
x2init_op = (value_log_0+2.0);
}
xth1init_op = (((1.0+r1init_op)*x1init_op)-(xg2x*r1init_op));
xth2init_op = (((1.0+(1.0/r2init_op))*x2init_op)-(xg2x/r2init_op));
{
double value_sqrt_0 = sqrt((((xth1init_op-xth2init_op)*(xth1init_op-xth2init_op))+38.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
xg1thinit_op = ((((0.5*((xth1init_op+xth2init_op)-value_sqrt_0))-xg2)/CIC1_i)+xg2);
}
vthinit_op = ((phit*((((xg1thinit_op-xedge)/sce1)-dxg1_dibl)+xedge))+VFB1_i);
inv_phit0_op = (1.0/((model_.TKD)*8.617332384961E-05));
EgSi_op = (1.17-(((4.730e-4*(model_.TKD))*(model_.TKD))/(636+(model_.TKD))));
EgGe_op = (0.744-(((4.774e-4*(model_.TKD))*(model_.TKD))/(235+(model_.TKD))));
dEg_op = (((EgGe_op-EgSi_op)+((-0.4)*one_m_xge))*XGE_i);
Eg_op = (EgSi_op+dEg_op);
Eg_2phit0_op = ((0.5*Eg_op)*inv_phit0_op);
dVfbch_op = ((0.05*XGE_i)-(0.5*dEg_op));
{
double value_sqrt_0 = sqrt(((model_.TKD)*0.0033333333333));

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = value_sqrt_0;
}

d_temp1_dTemp_Tnode_GND = (((4.05E25*temp)*temp)*d_temp_dTemp_Tnode_GND+((4.05E25*temp)*d_temp_dTemp_Tnode_GND+4.05E25*d_temp_dTemp_Tnode_GND*temp)*temp);
d_temp1_dV_S_B = (((4.05E25*temp)*temp)*d_temp_dV_S_B+((4.05E25*temp)*d_temp_dV_S_B+4.05E25*d_temp_dV_S_B*temp)*temp);
d_temp1_dV_D_S = (((4.05E25*temp)*temp)*d_temp_dV_D_S+((4.05E25*temp)*d_temp_dV_D_S+4.05E25*d_temp_dV_D_S*temp)*temp);
d_temp1_dV_G_S = (((4.05E25*temp)*temp)*d_temp_dV_G_S+((4.05E25*temp)*d_temp_dV_G_S+4.05E25*d_temp_dV_G_S*temp)*temp);
temp1 = (((4.05E25*temp)*temp)*temp);
{
double value_exp_0 = exp((-Eg_2phit0_op));
neff_op = ((temp1*niratio)*value_exp_0);
}
inv_phit_op = (inv_phit0_op/(1.0+((CT_i*(model_.TKR))/(model_.TKD))));
A0_Csisq_op = ((((2.0*1.602176565E-19)*neff_op)*epsch)*inv_phit_op);
{
double value_log_0 = log(((CsiPrime_0*CsiPrime_0)/A0_Csisq_op));
double  deriv_log_0_d0 = (1.0/((CsiPrime_0*CsiPrime_0)/A0_Csisq_op));
xth_1D_op = (value_log_0-0.6931471805599);
}
xSDdep_op = (((((0.5*1.602176565E-19)*NSDDC_i)*TSI_i)/(Cox1Prime+Cox2Prime))*inv_phit_op);

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = (STCF_i*((model_.TKD)-(model_.TKR)));
CF1_op = (CF1_t+temp);
CF2_op = (CF2_t+temp);
xd0_op = (CFD_i*inv_phit_op);
qq_op = 0.0;
if (((model_.QMC)>0.0))
{
if (((model_.TYPE)==(+1)))
{
{
double value_log_0 = log((tsisq/inv_phit_op));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
qq_op = (((0.4*(model_.QMC))*1.27520989)*value_exp_1);
}
}
else
{
{
double value_log_0 = log((tsisq/inv_phit_op));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
qq_op = (((0.4*(model_.QMC))*1.54120870)*value_exp_1);
}
}
}

d_temp_dV_G_S = d_temp_dV_D_S = d_temp_dV_S_B = d_temp_dTemp_Tnode_GND =  0.0;
temp = ((((model_.TYPE)*STVFB_i)*((model_.TKD)-(model_.TKR)))+dVfbQM);
VFB1_op = ((((model_.TYPE)*((VFB1_t+dVfbch_op)+dVfb1Nch))+temp)+DELVTO);
VFB2_op = (((model_.TYPE)*((VFB2_t+dVfbch_op)+dVfb2Nch))+temp);
xd_op = (Vds*inv_phit_op);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
xdsx_op = ((value_sqrt_0-0.1)*inv_phit_op);
}
dxdsx_op = (0.5*(xd_op-xdsx_op));
xg10_op = (((vthinit_op-VFB1_op)*inv_phit_op)-dxdsx_op);
xg20_op = ((((-Vsb)-VFB2_op)*inv_phit_op)-dxdsx_op);
if (((model_.SWSUBDEP)>0))
{

d_temp_dV_S_B = 0.0;
d_temp_dV_D_S = 0.0;
d_temp_dV_G_S = 0.0;
d_temp_dTemp_Tnode_GND = 0.0;
temp = ((((model_.TYPE)*TYPESUB_i)*(xg10_op-xg20_op))/Gfsub);
if ((temp<0.0))
{
{
double value_log_0 = log((1.0-temp));
double  deriv_log_0_d0 = (1.0/(1.0-temp));

d_temp1_dTemp_Tnode_GND = (-2.0)*(deriv_log_0_d0*((-d_temp_dTemp_Tnode_GND)));
d_temp1_dV_S_B = (-2.0)*(deriv_log_0_d0*((-d_temp_dV_S_B)));
d_temp1_dV_D_S = (-2.0)*(deriv_log_0_d0*((-d_temp_dV_D_S)));
d_temp1_dV_G_S = (-2.0)*(deriv_log_0_d0*((-d_temp_dV_G_S)));
temp1 = ((-2.0)*value_log_0);
}
}
else
{

d_temp1_dTemp_Tnode_GND = (((1.0+((2.0*temp)/Gfsub))*(temp*d_temp_dTemp_Tnode_GND+d_temp_dTemp_Tnode_GND*temp)-(temp*temp)*(2.0*d_temp_dTemp_Tnode_GND/Gfsub))/(1.0+((2.0*temp)/Gfsub))/(1.0+((2.0*temp)/Gfsub)));
d_temp1_dV_S_B = (((1.0+((2.0*temp)/Gfsub))*(temp*d_temp_dV_S_B+d_temp_dV_S_B*temp)-(temp*temp)*(2.0*d_temp_dV_S_B/Gfsub))/(1.0+((2.0*temp)/Gfsub))/(1.0+((2.0*temp)/Gfsub)));
d_temp1_dV_D_S = (((1.0+((2.0*temp)/Gfsub))*(temp*d_temp_dV_D_S+d_temp_dV_D_S*temp)-(temp*temp)*(2.0*d_temp_dV_D_S/Gfsub))/(1.0+((2.0*temp)/Gfsub))/(1.0+((2.0*temp)/Gfsub)));
d_temp1_dV_G_S = (((1.0+((2.0*temp)/Gfsub))*(temp*d_temp_dV_G_S+d_temp_dV_G_S*temp)-(temp*temp)*(2.0*d_temp_dV_G_S/Gfsub))/(1.0+((2.0*temp)/Gfsub))/(1.0+((2.0*temp)/Gfsub)));
temp1 = ((temp*temp)/(1.0+((2.0*temp)/Gfsub)));
}
xg2eff_op = (xg20_op+(((model_.TYPE)*TYPESUB_i)*temp1));
}
else
{
xg2eff_op = xg20_op;
}

d_temp_dV_S_B = 0.0;
d_temp_dV_D_S = 0.0;
d_temp_dV_G_S = 0.0;
d_temp_dTemp_Tnode_GND = 0.0;
temp = (keq_1D*(xg10_op-xg2eff_op));
if (((model_.QMC)>0.0))
{
{
double value_sqrt_0 = sqrt((((temp-15.0)*(temp-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
e1_op = (0.5*((temp+15.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((-temp)-15.0)*((-temp)-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
e2_op = (0.5*(((-temp)+15.0)+value_sqrt_0));
}
{
double value_log_0 = log(e1_op);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e1_op);
double  deriv_exp_1_d0 = value_exp_1;

d_temp1_dTemp_Tnode_GND = 0.0;
d_temp1_dV_S_B = 0.0;
d_temp1_dV_D_S = 0.0;
d_temp1_dV_G_S = 0.0;
temp1 = (qq_op*value_exp_1);
}
{
double value_log_0 = log(e2_op);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e2_op);
double  deriv_exp_1_d0 = value_exp_1;

d_temp2_dTemp_Tnode_GND = 0.0;
d_temp2_dV_S_B = 0.0;
d_temp2_dV_D_S = 0.0;
d_temp2_dV_G_S = 0.0;
temp2 = (qq_op*value_exp_1);
}

d_temp3_dTemp_Tnode_GND = ((-d_temp1_dTemp_Tnode_GND)-d_temp2_dTemp_Tnode_GND);
d_temp3_dV_D_S = ((-d_temp1_dV_D_S)-d_temp2_dV_D_S);
d_temp3_dV_G_S = ((-d_temp1_dV_G_S)-d_temp2_dV_G_S);
d_temp3_dV_S_B = ((-d_temp1_dV_S_B)-d_temp2_dV_S_B);
temp3 = ((1.0-temp1)-temp2);
CsiPrime_op = (CsiPrime_0/temp3);
k1_1D_QM_op = ((k1_1D*temp3)/(1.0+(k1_1D*temp1)));
k2_1D_QM_op = ((k2_1D*temp3)/(1.0+(k2_1D*temp2)));
keq_1D_QM_op = (1.0/((1.0+(1.0/k1_1D_QM_op))+(1.0/k2_1D_QM_op)));
}
else
{
CsiPrime_op = CsiPrime_0;
k1_1D_QM_op = k1_1D;
k2_1D_QM_op = k2_1D;
keq_1D_QM_op = keq_1D;
}
Dx_WI_1D_op = (keq_1D_QM_op*(xg10_op-xg2eff_op));
if ((Dx_WI_1D_op>0.0))
{
if (((-Dx_WI_1D_op)<80.0))
{
{
double value_exp_0 = exp((-Dx_WI_1D_op));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp_dV_S_B = 0.0;
d_temp_dTemp_Tnode_GND = 0.0;
d_temp_dV_D_S = 0.0;
d_temp_dV_G_S = 0.0;
temp = value_log_1;
}
}
else
{

d_temp_dV_S_B = 0.0;
d_temp_dTemp_Tnode_GND = 0.0;
d_temp_dV_D_S = 0.0;
d_temp_dV_G_S = 0.0;
temp = (-Dx_WI_1D_op);
}
x_WI_1D_op = (((xg10_op-(Dx_WI_1D_op/k1_1D_QM_op))+temp)-0.6931471805599);
}
else
{
if ((Dx_WI_1D_op<80.0))
{
{
double value_exp_0 = exp(Dx_WI_1D_op);
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));

d_temp_dV_S_B = 0.0;
d_temp_dTemp_Tnode_GND = 0.0;
d_temp_dV_D_S = 0.0;
d_temp_dV_G_S = 0.0;
temp = value_log_1;
}
}
else
{

d_temp_dV_S_B = 0.0;
d_temp_dTemp_Tnode_GND = 0.0;
d_temp_dV_D_S = 0.0;
d_temp_dV_G_S = 0.0;
temp = Dx_WI_1D_op;
}
x_WI_1D_op = (((xg2eff_op+(Dx_WI_1D_op/k2_1D_QM_op))+temp)-0.6931471805599);
}
{
double value_sqrt_0 = sqrt((((x_WI_1D_op-xth_1D_op)*(x_WI_1D_op-xth_1D_op))+4.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
x_1D_op = (0.5*((x_WI_1D_op+xth_1D_op)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+((2.0*(xth_1D_op-x_1D_op))/xSDdep_op)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
dleff_op = (value_sqrt_0-1.0);
}
xedge_op = (x_1D_op+(xSDdep_op*dleff_op));
{
double value_sqrt_0 = sqrt(((((1.0+(PSCEDLB_i*xg20_op))-0.5)*((1.0+(PSCEDLB_i*xg20_op))-0.5))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dTemp_Tnode_GND = 0.0;
d_temp_dV_G_S = 0.0;
d_temp_dV_S_B = 0.0;
d_temp_dV_D_S = 0.0;
temp = (0.5*(((1.0+(PSCEDLB_i*xg20_op))+0.5)+value_sqrt_0));
}
sce1_op = (1.0/(1.0+(PSCE1_i*temp)));
sce2_op = (1.0/(1.0+(PSCE2_i*temp)));
{
double value_sqrt_0 = sqrt((1.0+(xdsx_op/xd0_op)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dTemp_Tnode_GND = 0.0;
d_temp_dV_G_S = 0.0;
d_temp_dV_S_B = 0.0;
d_temp_dV_D_S = 0.0;
temp = ((((2.0*xd0_op)*(value_sqrt_0-1.0))*(1.0+(CFDL_i*dleff_op)))*(1.0+(CFDLB_i*xg20_op)));
}
dxg1_dibl_op = (CF1_op*temp);
dxg2_dibl_op = (CF2_op*temp);
xg1_op = (((((xg10_op-xedge_op)+dxg1_dibl_op)*sce1_op)+xedge_op)+dxdsx_op);
xg2_op = (((((xg2eff_op-xedge_op)+dxg2_dibl_op)*sce2_op)+xedge_op)+dxdsx_op);
xg2x_op = (xg1_op+(CIC2_i*(xg2_op-xg1_op)));
k1_op = (k1_1D_QM_op/sce1_op);
k2_op = (k2_1D_QM_op/sce2_op);
A0_op = (A0_Csisq_op/(CsiPrime_op*CsiPrime_op));
exp_dxth_op = ((1.0+k1_op)/(1.0+k2_op));
{
double value_log_0 = log(exp_dxth_op);
double  deriv_log_0_d0 = (1.0/exp_dxth_op);
dxth_op = value_log_0;
}
if ((dxth_op>1.0e-8))
{
diff_min_op = (((2.0*dxth_op)*(exp_dxth_op+1.0))/(exp_dxth_op-1.0));
}
else
{
diff_min_op = (2.0*(2.0+dxth_op));
}
r1_op = ((k2_op/k1_op)/(1.0+k2_op));
r2_op = ((k1_op/k2_op)/(1.0+k1_op));
{
double value_log_0 = log((((k1_op*(1.0+r1_op))*diff_min_op)/A0_op));
double  deriv_log_0_d0 = (1.0/(((k1_op*(1.0+r1_op))*diff_min_op)/A0_op));
x1sat_op = (value_log_0+2.0);
}
{
double value_log_0 = log((((k2_op*(1.0+r2_op))*diff_min_op)/A0_op));
double  deriv_log_0_d0 = (1.0/(((k2_op*(1.0+r2_op))*diff_min_op)/A0_op));
x2sat_op = (value_log_0+2.0);
}
xth1_op = (((1.0+r1_op)*x1sat_op)-(xg2x_op*r1_op));
xth2_op = (((1.0+(1.0/r2_op))*x2sat_op)-(xg2x_op/r2_op));
{
double value_sqrt_0 = sqrt((((xth1_op-xth2_op)*(xth1_op-xth2_op))+38.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
xg1th_op = ((((0.5*((xth1_op+xth2_op)-value_sqrt_0))-xg2)/CIC1_i)+xg2);
}
vth = ((((((xg1th_op-xedge_op)/sce1_op)-dxg1_dibl_op)+xedge_op)/inv_phit_op)+VFB1_op);
Vdsat = (phit*xndssat);
vds = Vds;
vsb = Vsb;
vgs = Vgs;
vth_drive = (vgs-vth);
vdsat = Vdsat;
vdsat_marg = (vds-vdsat);
if ((sigVds<0))
{

d_igidl_dV_S_B = d_Igisle_dV_S_B;
d_igidl_dV_G_S = d_Igisle_dV_G_S;
d_igidl_dTemp_Tnode_GND = d_Igisle_dTemp_Tnode_GND;
d_igidl_dV_D_S = d_Igisle_dV_D_S;
igidl = Igisle;

d_igisl_dV_S_B = d_Igidle_dV_S_B;
d_igisl_dV_G_S = d_Igidle_dV_G_S;
d_igisl_dTemp_Tnode_GND = d_Igidle_dTemp_Tnode_GND;
d_igisl_dV_D_S = d_Igidle_dV_D_S;
igisl = Igidle;
igs = Igde;

d_igd_dV_S_B = d_Igse_dV_S_B;
d_igd_dV_D_S = d_Igse_dV_D_S;
d_igd_dV_G_S = d_Igse_dV_G_S;
d_igd_dTemp_Tnode_GND = d_Igse_dTemp_Tnode_GND;
igd = Igse;
}
else
{

d_igidl_dV_S_B = d_Igidle_dV_S_B;
d_igidl_dV_G_S = d_Igidle_dV_G_S;
d_igidl_dTemp_Tnode_GND = d_Igidle_dTemp_Tnode_GND;
d_igidl_dV_D_S = d_Igidle_dV_D_S;
igidl = Igidle;

d_igisl_dV_S_B = d_Igisle_dV_S_B;
d_igisl_dV_G_S = d_Igisle_dV_G_S;
d_igisl_dTemp_Tnode_GND = d_Igisle_dTemp_Tnode_GND;
d_igisl_dV_D_S = d_Igisle_dV_D_S;
igisl = Igisle;
igs = Igse;

d_igd_dV_S_B = d_Igde_dV_S_B;
d_igd_dV_D_S = d_Igde_dV_D_S;
d_igd_dV_G_S = d_Igde_dV_G_S;
d_igd_dTemp_Tnode_GND = d_Igde_dTemp_Tnode_GND;
igd = Igde;
}
ids = Idse;

d_id_dV_D_S = (((d_Idse_dV_D_S+d_igidl_dV_D_S)-d_igisl_dV_D_S)-d_igd_dV_D_S);
d_id_dV_G_S = (((d_Idse_dV_G_S+d_igidl_dV_G_S)-d_igisl_dV_G_S)-d_igd_dV_G_S);
d_id_dV_S_B = (((d_Idse_dV_S_B+d_igidl_dV_S_B)-d_igisl_dV_S_B)-d_igd_dV_S_B);
d_id_dTemp_Tnode_GND = (((d_Idse_dTemp_Tnode_GND+d_igidl_dTemp_Tnode_GND)-d_igisl_dTemp_Tnode_GND)-d_igd_dTemp_Tnode_GND);
id = (((Idse+igidl)-igisl)-igd);
is = ((((-Idse)-igidl)+igisl)-igs);
ig = (Igse+Igde);
ib = 0.0;
idb = 0.0;
isb = 0.0;
gm = ((model_.TYPE)*(+d_id_dV_G_S));
gmb = ((model_.TYPE)*(-d_id_dV_S_B));
if ((sigVds<0.0))
{
gds = ((model_.TYPE)*(-d_id_dV_D_S-d_id_dV_G_S+d_id_dV_S_B));
}
else
{
gds = ((model_.TYPE)*(+d_id_dV_D_S));
}
if ((sigVds<0.0))
{

d_qde_dTemp_Tnode_GND = (((d_Qs_dTemp_Tnode_GND-d_Qovs_dTemp_Tnode_GND)-d_Qgsif_dTemp_Tnode_GND)-d_Qbsif_dTemp_Tnode_GND);
d_qde_dV_S_B = ((((d_Qs_dV_S_B-d_Qovs_dV_S_B)-d_Qssub_dV_S_B)-d_Qgsif_dV_S_B)-d_Qbsif_dV_S_B);
d_qde_dV_D_S = ((((d_Qs_dV_D_S-d_Qdse_dV_D_S)-d_Qovs_dV_D_S)-d_Qgsif_dV_D_S)-d_Qbsif_dV_D_S);
d_qde_dV_G_S = ((((d_Qs_dV_G_S-d_Qgse_dV_G_S)-d_Qovs_dV_G_S)-d_Qgsif_dV_G_S)-d_Qbsif_dV_G_S);
qde = ((((((Qs-Qdse)-Qgse)-Qovs)-Qssub)-Qgsif)-Qbsif);
}
else
{

d_qde_dTemp_Tnode_GND = (((d_Qd_dTemp_Tnode_GND-d_Qovd_dTemp_Tnode_GND)-d_Qgdif_dTemp_Tnode_GND)-d_Qbdif_dTemp_Tnode_GND);
d_qde_dV_S_B = ((((d_Qd_dV_S_B-d_Qovd_dV_S_B)-d_Qdsub_dV_S_B)-d_Qgdif_dV_S_B)-d_Qbdif_dV_S_B);
d_qde_dV_D_S = ((((((d_Qd_dV_D_S+d_Qdse_dV_D_S)-d_Qgde_dV_D_S)-d_Qovd_dV_D_S)-d_Qdsub_dV_D_S)-d_Qgdif_dV_D_S)-d_Qbdif_dV_D_S);
d_qde_dV_G_S = ((((d_Qd_dV_G_S-d_Qgde_dV_G_S)-d_Qovd_dV_G_S)-d_Qgdif_dV_G_S)-d_Qbdif_dV_G_S);
qde = ((((((Qd+Qdse)-Qgde)-Qovd)-Qdsub)-Qgdif)-Qbdif);
}

d_qge_dTemp_Tnode_GND = ((((d_Qg_dTemp_Tnode_GND+d_Qovs_dTemp_Tnode_GND)+d_Qovd_dTemp_Tnode_GND)+d_Qgsif_dTemp_Tnode_GND)+d_Qgdif_dTemp_Tnode_GND);
d_qge_dV_S_B = (((((d_Qg_dV_S_B+d_Qovs_dV_S_B)+d_Qovd_dV_S_B)+d_Qgbe_dV_S_B)+d_Qgsif_dV_S_B)+d_Qgdif_dV_S_B);
d_qge_dV_D_S = ((((((d_Qg_dV_D_S+d_Qgde_dV_D_S)+d_Qovs_dV_D_S)+d_Qovd_dV_D_S)+d_Qgbe_dV_D_S)+d_Qgsif_dV_D_S)+d_Qgdif_dV_D_S);
d_qge_dV_G_S = (((((((d_Qg_dV_G_S+d_Qgse_dV_G_S)+d_Qgde_dV_G_S)+d_Qovs_dV_G_S)+d_Qovd_dV_G_S)+d_Qgbe_dV_G_S)+d_Qgsif_dV_G_S)+d_Qgdif_dV_G_S);
qge = (((((((Qg+Qgse)+Qgde)+Qovs)+Qovd)+Qgbe)+Qgsif)+Qgdif);

d_qbe_dTemp_Tnode_GND = ((d_Qb_dTemp_Tnode_GND+d_Qbsif_dTemp_Tnode_GND)+d_Qbdif_dTemp_Tnode_GND);
d_qbe_dV_S_B = (((((d_Qb_dV_S_B+d_Qssub_dV_S_B)+d_Qdsub_dV_S_B)-d_Qgbe_dV_S_B)+d_Qbsif_dV_S_B)+d_Qbdif_dV_S_B);
d_qbe_dV_D_S = ((((d_Qb_dV_D_S+d_Qdsub_dV_D_S)-d_Qgbe_dV_D_S)+d_Qbsif_dV_D_S)+d_Qbdif_dV_D_S);
d_qbe_dV_G_S = (((d_Qb_dV_G_S-d_Qgbe_dV_G_S)+d_Qbsif_dV_G_S)+d_Qbdif_dV_G_S);
qbe = (((((Qb+Qssub)+Qdsub)-Qgbe)+Qbsif)+Qbdif);
if ((sigVds<0.0))
{
cdd = ((model_.TYPE)*(+d_qde_dV_S_B-d_qde_dV_D_S-d_qde_dV_G_S));
cgd = ((-(model_.TYPE))*(+d_qge_dV_S_B-d_qge_dV_D_S-d_qge_dV_G_S));
cbd = ((-(model_.TYPE))*(+d_qbe_dV_S_B-d_qbe_dV_D_S-d_qbe_dV_G_S));
}
else
{
cdd = ((model_.TYPE)*(+d_qde_dV_D_S));
cgd = ((-(model_.TYPE))*(+d_qge_dV_D_S));
cbd = ((-(model_.TYPE))*(+d_qbe_dV_D_S));
}
cdg = ((-(model_.TYPE))*(+d_qde_dV_G_S));
cgg = ((model_.TYPE)*(+d_qge_dV_G_S));
cbg = ((-(model_.TYPE))*(+d_qbe_dV_G_S));
cdb = ((-(model_.TYPE))*(-d_qde_dV_S_B));
cgb = ((-(model_.TYPE))*(-d_qge_dV_S_B));
cbb = ((model_.TYPE)*(-d_qbe_dV_S_B));
cds = ((cdd-cdg)-cdb);
cgs = ((cgg-cgd)-cgb);
cbs = ((cbb-cbd)-cbg);
csd = ((cdd-cgd)-cbd);
csg = ((cgg-cdg)-cbg);
csb = ((cbb-cgb)-cdb);
css = ((csg+csd)+csb);
tk = TKC;
dtsh = DTC;
if ((fabs(gds)<1.0e-40))
{
self_gain = 0.0;
rout = 0.0;
vearly = 0.0;
}
else
{
self_gain = (gm/gds);
rout = (1.0/gds);
vearly = (id/gds);
}
if ((fabs(vth_drive)<1.0e-40))
{
beff = 0.0;
}
else
{
{
double value_fabs_0 = fabs(id);
double  deriv_fabs_0_d0 = (((id)>=0)?(+1.0):(-1.0));
beff = ((2.0*value_fabs_0)/(vth_drive*vth_drive));
}
}
if ((fabs(cgg)<1.0e-40))
{
ft = 0.0;
}
else
{
ft = (gm/((2.0*3.1415926535898)*cgg));
}
rgate = 0.0;
if ((fabs(id)<1.0e-40))
{
gmoverid = 0.0;
}
else
{
gmoverid = (gm/id);
}
}
// End block OPinfo
  // Final term for branch equation admsBRA_ID_NSIG_GND 
  staticContributions[admsBRA_ID_NSIG_GND] -= probeVars[admsProbeID_I_NSIG_GND];
  d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_I_NSIG_GND] -= d_probeVars[admsProbeID_I_NSIG_GND][admsProbeID_I_NSIG_GND];


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_D_GND] =  "
         <<probeVars[admsProbeID_V_D_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_GND] =  "
         <<probeVars[admsProbeID_V_S_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_B_GND] =  "
         <<probeVars[admsProbeID_V_B_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_G_GND] =  "
         <<probeVars[admsProbeID_V_G_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_I_NSIG_GND] =  "
         <<probeVars[admsProbeID_I_NSIG_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_NSIG_GND] =  "
         <<probeVars[admsProbeID_V_NSIG_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_Temp_Tnode_GND] =  "
         <<probeVars[admsProbeID_Temp_Tnode_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_B] =  "
         <<probeVars[admsProbeID_V_S_B] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_D_S] =  "
         <<probeVars[admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_G_S] =  "
         <<probeVars[admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_D] =  "
         <<staticContributions[admsNodeID_D] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_B_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_G_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_I_NSIG_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NSIG_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_B) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_G_S) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_D] =  "
         <<dynamicContributions[admsNodeID_D] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_B_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_G_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_I_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_B) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_G_S) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_G] =  "
         <<staticContributions[admsNodeID_G] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_B_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_G_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_I_NSIG_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NSIG_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_B) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_G_S) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_G] =  "
         <<dynamicContributions[admsNodeID_G] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_B_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_G_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_I_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_B) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_G_S) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_S] =  "
         <<staticContributions[admsNodeID_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_B_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_G_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_I_NSIG_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NSIG_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_B) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_G_S) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_S] =  "
         <<dynamicContributions[admsNodeID_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_B_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_G_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_I_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_B) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_G_S) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_B] =  "
         <<staticContributions[admsNodeID_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_B_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_G_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_I_NSIG_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NSIG_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_B) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_G_S) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_B] =  "
         <<dynamicContributions[admsNodeID_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_B_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_G_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_I_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_B) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_G_S) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_Tnode] =  "
         <<staticContributions[admsNodeID_Tnode] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_B_GND) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_G_GND) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_I_NSIG_GND) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_NSIG_GND) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_S_B) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_Tnode].dx(admsProbeID_V_G_S) =  " <<d_staticContributions[admsNodeID_Tnode][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_Tnode] =  "
         <<dynamicContributions[admsNodeID_Tnode] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_B_GND) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_G_GND) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_I_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_S_B) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_Tnode].dx(admsProbeID_V_G_S) =  " <<d_dynamicContributions[admsNodeID_Tnode][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NSIG] =  "
         <<staticContributions[admsNodeID_NSIG] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_B_GND) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_G_GND) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_I_NSIG_GND) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_NSIG_GND) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_S_B) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NSIG].dx(admsProbeID_V_G_S) =  " <<d_staticContributions[admsNodeID_NSIG][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NSIG] =  "
         <<dynamicContributions[admsNodeID_NSIG] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_B_GND) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_G_GND) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_I_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_NSIG_GND) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_S_B) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NSIG].dx(admsProbeID_V_G_S) =  " <<d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " staticContributions[admsBRA_ID_NSIG_GND] =  "
         <<staticContributions[admsBRA_ID_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_B_GND) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_G_GND) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_I_NSIG_GND) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_NSIG_GND) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_S_B) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_G_S) =  " <<d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_G_S] << std::endl;
    Xyce::dout() << " dynamicContributions[admsBRA_ID_NSIG_GND] =  "
         <<dynamicContributions[admsBRA_ID_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_B_GND) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_B_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_G_GND) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_G_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_I_NSIG_GND) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_I_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_NSIG_GND) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_NSIG_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_Temp_Tnode_GND) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_Temp_Tnode_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_S_B) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_S_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsBRA_ID_NSIG_GND].dx(admsProbeID_V_G_S) =  " <<d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_V_G_S] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 5 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 6; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 5 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
return 6;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
int numSources=getNumNoiseSources();
noiseData.numSources = numSources;
noiseData.resize(numSources);

noiseData.deviceName = getName().getEncodedName();
std::string theNoiseName;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_NSIG_GND")+std::string("_")+std::string("ign_g");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[0]=theNoiseName;
noiseData.li_Pos[0]=li_NSIG;
noiseData.li_Neg[0]=-1;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_D_S")+std::string("_")+std::string("thermal_ids");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[1]=theNoiseName;
noiseData.li_Pos[1]=li_D;
noiseData.li_Neg[1]=li_S;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_D_S")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[2]=theNoiseName;
noiseData.li_Pos[2]=li_D;
noiseData.li_Neg[2]=li_S;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_G_S")+std::string("_")+std::string("shot_igs");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[3]=theNoiseName;
noiseData.li_Pos[3]=li_G;
noiseData.li_Neg[3]=li_S;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_G_D")+std::string("_")+std::string("shot_igd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[4]=theNoiseName;
noiseData.li_Pos[4]=li_G;
noiseData.li_Neg[4]=li_D;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_D_S")+std::string("_")+std::string("shot_ids");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[5]=theNoiseName;
noiseData.li_Pos[5]=li_D;
noiseData.li_Neg[5]=li_S;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
noiseData.noiseDens[1] = noiseContribsPower[1];
noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
noiseData.noiseDens[2] = noiseContribsPower[2];

      noiseData.noiseDens[2] /= pow(noiseData.freq,noiseContribsExponent[2]);noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
noiseData.noiseDens[3] = noiseContribsPower[3];
noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
noiseData.noiseDens[4] = noiseContribsPower[4];
noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
noiseData.noiseDens[5] = noiseContribsPower[5];
noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_S_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  (*f_S_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] -d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  (*f_D_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  (*f_D_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] -d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  (*f_S_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_G_S];
  (*f_D_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_G_S];
  (*f_S_Equ_B_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_B];
  (*f_D_Equ_B_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_B];
  (*f_S_Equ_Tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND];
  (*f_D_Equ_Tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND];
  (*f_G_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_G][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_G][admsProbeID_V_S_B];
  (*f_G_Equ_B_Node_Ptr) +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_S_B];
  (*f_G_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_D_S];
  (*f_G_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_S];
  (*f_G_Equ_Tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND];
  (*f_Tnode_Equ_Tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND];
  (*f_Tnode_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_Tnode][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_Tnode][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_Tnode][admsProbeID_V_S_B];
  (*f_Tnode_Equ_B_Node_Ptr) +=  -d_staticContributions[admsNodeID_Tnode][admsProbeID_V_S_B];
  (*f_Tnode_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_Tnode][admsProbeID_V_D_S];
  (*f_Tnode_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_Tnode][admsProbeID_V_G_S];
  (*f_NSIG_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_D_S];
  (*f_NSIG_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_S_B] -d_staticContributions[admsNodeID_NSIG][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_NSIG][admsProbeID_V_D_S];
  (*f_NSIG_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_G_S];
  (*f_NSIG_Equ_B_Node_Ptr) +=  -d_staticContributions[admsNodeID_NSIG][admsProbeID_V_S_B];
  (*f_NSIG_Equ_Tnode_Node_Ptr) +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND];
  (*f_NSIG_Equ_NSIG_Node_Ptr) +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND];
  (*f_NSIG_Equ_BRA_NSIG_GND_Var_Ptr) += d_staticContributions[admsNodeID_NSIG][admsProbeID_I_NSIG_GND];
    // there also need to be extra loads for branch NSIG,GND
    // Load for branch NSIG,GND equ var D
    // Load for branch NSIG,GND equ var S
    // Load for branch NSIG,GND equ var G
    // Load for branch NSIG,GND equ var B
    // Load for branch NSIG,GND equ var Tnode
    // Load for branch NSIG,GND equ var NSIG
  (*f_BRA_NSIG_GND_Equ_NSIG_Node_Ptr) +=  -1;
    //load for branch NSIG,GND equ branch NSIG,GND var
  (*f_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Ptr) += d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_I_NSIG_GND];

#else
  //use the offsets instead of pointers
  dFdx[li_S][A_S_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  dFdx[li_S][A_S_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_B] -d_staticContributions[admsNodeID_S][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  dFdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  dFdx[li_D][A_D_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_S_B] -d_staticContributions[admsNodeID_D][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  dFdx[li_S][A_S_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_G_S];
  dFdx[li_D][A_D_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_G_S];
  dFdx[li_S][A_S_Equ_B_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_B];
  dFdx[li_D][A_D_Equ_B_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_B];
  dFdx[li_S][A_S_Equ_Tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND];
  dFdx[li_D][A_D_Equ_Tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND];
  dFdx[li_G][A_G_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_G][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_G][admsProbeID_V_S_B];
  dFdx[li_G][A_G_Equ_B_NodeOffset] +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_S_B];
  dFdx[li_G][A_G_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_D_S];
  dFdx[li_G][A_G_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_S];
  dFdx[li_G][A_G_Equ_Tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND];
  dFdx[li_Tnode][A_Tnode_Equ_Tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND];
  dFdx[li_Tnode][A_Tnode_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_Tnode][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_Tnode][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_Tnode][admsProbeID_V_S_B];
  dFdx[li_Tnode][A_Tnode_Equ_B_NodeOffset] +=  -d_staticContributions[admsNodeID_Tnode][admsProbeID_V_S_B];
  dFdx[li_Tnode][A_Tnode_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_Tnode][admsProbeID_V_D_S];
  dFdx[li_Tnode][A_Tnode_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_Tnode][admsProbeID_V_G_S];
  dFdx[li_NSIG][A_NSIG_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_D_S];
  dFdx[li_NSIG][A_NSIG_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_S_B] -d_staticContributions[admsNodeID_NSIG][admsProbeID_V_G_S] -d_staticContributions[admsNodeID_NSIG][admsProbeID_V_D_S];
  dFdx[li_NSIG][A_NSIG_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_G_S];
  dFdx[li_NSIG][A_NSIG_Equ_B_NodeOffset] +=  -d_staticContributions[admsNodeID_NSIG][admsProbeID_V_S_B];
  dFdx[li_NSIG][A_NSIG_Equ_Tnode_NodeOffset] +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND];
  dFdx[li_NSIG][A_NSIG_Equ_NSIG_NodeOffset] +=  +d_staticContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND];
  dFdx[li_NSIG][A_NSIG_Equ_BRA_NSIG_GND_Var_Offset] += d_staticContributions[admsNodeID_NSIG][admsProbeID_I_NSIG_GND];
    // there also need to be extra loads for branch NSIG,GND
    // Load for branch NSIG,GND equ var D
    // Load for branch NSIG,GND equ var S
    // Load for branch NSIG,GND equ var G
    // Load for branch NSIG,GND equ var B
    // Load for branch NSIG,GND equ var Tnode
    // Load for branch NSIG,GND equ var NSIG
  dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_NSIG_Node_Offset] +=  -1;
    //load for branch NSIG,GND equ branch NSIG,GND var
  dFdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Offset] += d_staticContributions[admsBRA_ID_NSIG_GND][admsProbeID_I_NSIG_GND];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_S_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S];
  (*q_S_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B];
  (*q_D_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S];
  (*q_D_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B];
  (*q_S_Equ_G_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S];
  (*q_D_Equ_G_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S];
  (*q_S_Equ_B_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B];
  (*q_D_Equ_B_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B];
  (*q_S_Equ_Tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND];
  (*q_D_Equ_Tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND];
  (*q_G_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B];
  (*q_G_Equ_B_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B];
  (*q_G_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S];
  (*q_G_Equ_G_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S];
  (*q_G_Equ_Tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND];
  (*q_Tnode_Equ_Tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND];
  (*q_B_Equ_Tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_B][admsProbeID_Temp_Tnode_GND];
  (*q_B_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B];
  (*q_B_Equ_B_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B];
  (*q_B_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S];
  (*q_B_Equ_G_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S];
  (*q_NSIG_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_D_S];
  (*q_NSIG_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_G_S] +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_S_B];
  (*q_NSIG_Equ_G_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_G_S];
  (*q_NSIG_Equ_B_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_S_B];
  (*q_NSIG_Equ_Tnode_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND];
  (*q_NSIG_Equ_NSIG_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND];
  (*q_G_Equ_NSIG_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_V_NSIG_GND];
  (*q_S_Equ_NSIG_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_NSIG_GND];
  (*q_D_Equ_NSIG_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_NSIG_GND];
  (*q_NSIG_Equ_BRA_NSIG_GND_Var_Ptr) += d_dynamicContributions[admsNodeID_NSIG][admsProbeID_I_NSIG_GND];
    // there also need to be extra loads for branch NSIG,GND
    // Load for branch NSIG,GND equ var D
    // Load for branch NSIG,GND equ var S
    // Load for branch NSIG,GND equ var G
    // Load for branch NSIG,GND equ var B
    // Load for branch NSIG,GND equ var Tnode
    // Load for branch NSIG,GND equ var NSIG
    //load for branch NSIG,GND equ branch NSIG,GND var
  (*q_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Ptr) += d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_I_NSIG_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_S][A_S_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S];
  dQdx[li_S][A_S_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B];
  dQdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S];
  dQdx[li_D][A_D_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B];
  dQdx[li_S][A_S_Equ_G_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_S];
  dQdx[li_D][A_D_Equ_G_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_S];
  dQdx[li_S][A_S_Equ_B_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_B];
  dQdx[li_D][A_D_Equ_B_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_B];
  dQdx[li_S][A_S_Equ_Tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_Temp_Tnode_GND];
  dQdx[li_D][A_D_Equ_Tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_Temp_Tnode_GND];
  dQdx[li_G][A_G_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B];
  dQdx[li_G][A_G_Equ_B_NodeOffset] +=  -d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_B];
  dQdx[li_G][A_G_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S];
  dQdx[li_G][A_G_Equ_G_NodeOffset] +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_S];
  dQdx[li_G][A_G_Equ_Tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_Temp_Tnode_GND];
  dQdx[li_Tnode][A_Tnode_Equ_Tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_Tnode][admsProbeID_Temp_Tnode_GND];
  dQdx[li_B][A_B_Equ_Tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_B][admsProbeID_Temp_Tnode_GND];
  dQdx[li_B][A_B_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S] -d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B];
  dQdx[li_B][A_B_Equ_B_NodeOffset] +=  -d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_B];
  dQdx[li_B][A_B_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S];
  dQdx[li_B][A_B_Equ_G_NodeOffset] +=  +d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_S];
  dQdx[li_NSIG][A_NSIG_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_D_S];
  dQdx[li_NSIG][A_NSIG_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_G_S] +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_S_B];
  dQdx[li_NSIG][A_NSIG_Equ_G_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_G_S];
  dQdx[li_NSIG][A_NSIG_Equ_B_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_S_B];
  dQdx[li_NSIG][A_NSIG_Equ_Tnode_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_Temp_Tnode_GND];
  dQdx[li_NSIG][A_NSIG_Equ_NSIG_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NSIG][admsProbeID_V_NSIG_GND];
  dQdx[li_G][A_G_Equ_NSIG_NodeOffset] +=  +d_dynamicContributions[admsNodeID_G][admsProbeID_V_NSIG_GND];
  dQdx[li_S][A_S_Equ_NSIG_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_NSIG_GND];
  dQdx[li_D][A_D_Equ_NSIG_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_NSIG_GND];
  dQdx[li_NSIG][A_NSIG_Equ_BRA_NSIG_GND_Var_Offset] += d_dynamicContributions[admsNodeID_NSIG][admsProbeID_I_NSIG_GND];
    // there also need to be extra loads for branch NSIG,GND
    // Load for branch NSIG,GND equ var D
    // Load for branch NSIG,GND equ var S
    // Load for branch NSIG,GND equ var G
    // Load for branch NSIG,GND equ var B
    // Load for branch NSIG,GND equ var Tnode
    // Load for branch NSIG,GND equ var NSIG
    //load for branch NSIG,GND equ branch NSIG,GND var
  dQdx[li_BRA_NSIG_GND][A_BRA_NSIG_GND_Equ_BRA_NSIG_GND_Var_Offset] += d_dynamicContributions[admsBRA_ID_NSIG_GND][admsProbeID_I_NSIG_GND];


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

// set internal model type based on model card type
if (getType() == "pmos" || getType() == "PMOS")
    TYPE = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter SWSCALE : [ 0, 1 ]
  if ( (!((SWSCALE >=0 && SWSCALE <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWSCALE value " << SWSCALE << " out of range [ 0, 1 ]";
  }

//    Parameter SWSUBDEP : [ 0, 1 ]
  if ( (!((SWSUBDEP >=0 && SWSUBDEP <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWSUBDEP value " << SWSUBDEP << " out of range [ 0, 1 ]";
  }

//    Parameter SWIGATE : [ 0, 1 ]
  if ( (!((SWIGATE >=0 && SWIGATE <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWIGATE value " << SWIGATE << " out of range [ 0, 1 ]";
  }

//    Parameter SWGIDL : [ 0, 1 ]
  if ( (!((SWGIDL >=0 && SWGIDL <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWGIDL value " << SWGIDL << " out of range [ 0, 1 ]";
  }

//    Parameter SWSHE : [ 0, 1 ]
  if ( (!((SWSHE >=0 && SWSHE <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWSHE value " << SWSHE << " out of range [ 0, 1 ]";
  }

//    Parameter SWIGN : [ 0, 1 ]
  if ( (!((SWIGN >=0 && SWIGN <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWIGN value " << SWIGN << " out of range [ 0, 1 ]";
  }

//    Parameter SWJUNASYM : [ 0, 1 ]
  if ( (!((SWJUNASYM >=0 && SWJUNASYM <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWJUNASYM value " << SWJUNASYM << " out of range [ 0, 1 ]";
  }

//    Parameter SWIMPACT : [ 0, 1 ]
  if ( (!((SWIMPACT >=0 && SWIMPACT <=1 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWIMPACT value " << SWIMPACT << " out of range [ 0, 1 ]";
  }

//    Parameter QMC : [ 0,  (+inf) [
  if ( (!((QMC >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter QMC value " << QMC << " out of range [ 0,  (+inf) [";
  }

//    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

//    Parameter TR : [ (-273.0),  (+inf) [
  if ( (!((TR >=(-273.0)))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TR value " << TR << " out of range [ (-273.0),  (+inf) [";
  }

//    Parameter TMAX : [ 0.0,  (+inf) [
  if ( (!((TMAX >=0.0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TMAX value " << TMAX << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter TOXE : [ 3.0e-10, 1.0e-06 ]
  if ( (!((TOXE >=3.0e-10 && TOXE <=1.0e-06 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TOXE value " << TOXE << " out of range [ 3.0e-10, 1.0e-06 ]";
  }

//    Parameter TSI : [ 3.0e-09, 2.0e-08 ]
  if ( (!((TSI >=3.0e-09 && TSI <=2.0e-08 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TSI value " << TSI << " out of range [ 3.0e-09, 2.0e-08 ]";
  }

//    Parameter XGE : [ 0.0, 1.0 ]
  if ( (!((XGE >=0.0 && XGE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter XGE value " << XGE << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter TBOX : [ 3.0e-10, 1.0e-06 ]
  if ( (!((TBOX >=3.0e-10 && TBOX <=1.0e-06 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TBOX value " << TBOX << " out of range [ 3.0e-10, 1.0e-06 ]";
  }

//    Parameter CT : [ 0,  (+inf) [
  if ( (!((CT >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CT value " << CT << " out of range [ 0,  (+inf) [";
  }

//    Parameter TOXP : [ 3.0e-10, 1.0e-06 ]
  if ( (!((TOXP >=3.0e-10 && TOXP <=1.0e-06 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TOXP value " << TOXP << " out of range [ 3.0e-10, 1.0e-06 ]";
  }

//    Parameter NOV : [ 1.0e15, 1.0e21 ]
  if ( (!((NOV >=1.0e15 && NOV <=1.0e21 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NOV value " << NOV << " out of range [ 1.0e15, 1.0e21 ]";
  }

//    Parameter NOVD : [ 1.0e15, 1.0e21 ]
  if ( (!((NOVD >=1.0e15 && NOVD <=1.0e21 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NOVD value " << NOVD << " out of range [ 1.0e15, 1.0e21 ]";
  }

//    Parameter CICF : [ 0.1, 10.0 ]
  if ( (!((CICF >=0.1 && CICF <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CICF value " << CICF << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter CIC : [ 0.1, 10.0 ]
  if ( (!((CIC >=0.1 && CIC <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CIC value " << CIC << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter PSCE : [ 0.0, 5.0 ]
  if ( (!((PSCE >=0.0 && PSCE <=5.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PSCE value " << PSCE << " out of range [ 0.0, 5.0 ]";
  }

//    Parameter PSCEB : [ 0,  (+inf) [
  if ( (!((PSCEB >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PSCEB value " << PSCEB << " out of range [ 0,  (+inf) [";
  }

//    Parameter NSDDC : [ 1.0e18, 1.0e22 ]
  if ( (!((NSDDC >=1.0e18 && NSDDC <=1.0e22 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NSDDC value " << NSDDC << " out of range [ 1.0e18, 1.0e22 ]";
  }

//    Parameter PSCEDLB : [ 0,  (+inf) [
  if ( (!((PSCEDLB >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PSCEDLB value " << PSCEDLB << " out of range [ 0,  (+inf) [";
  }

//    Parameter PNCE : [ (-1.0), 1.0 ]
  if ( (!((PNCE >=(-1.0) && PNCE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PNCE value " << PNCE << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter CF : [ 0,  (+inf) [
  if ( (!((CF >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CF value " << CF << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFB : [ 0,  (+inf) [
  if ( (!((CFB >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFB value " << CFB << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFD : [ 0.05,  (+inf) [
  if ( (!((CFD >=0.05))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFD value " << CFD << " out of range [ 0.05,  (+inf) [";
  }

//    Parameter CFDLB : [ 0,  (+inf) [
  if ( (!((CFDLB >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFDLB value " << CFDLB << " out of range [ 0,  (+inf) [";
  }

//    Parameter BETN : [ 1.0e-10,  (+inf) [
  if ( (!((BETN >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter BETN value " << BETN << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter BETNB : [ 0.1, 10.0 ]
  if ( (!((BETNB >=0.1 && BETNB <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter BETNB value " << BETNB << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter CS : [ 0,  (+inf) [
  if ( (!((CS >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CS value " << CS << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSFI : [ 0,  (+inf) [
  if ( (!((CSFI >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSFI value " << CSFI << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSBI : [ 0,  (+inf) [
  if ( (!((CSBI >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSBI value " << CSBI << " out of range [ 0,  (+inf) [";
  }

//    Parameter THECS : [ 0,  (+inf) [
  if ( (!((THECS >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THECS value " << THECS << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSTHR : [ 1.0e-03,  (+inf) [
  if ( (!((CSTHR >=1.0e-03))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSTHR value " << CSTHR << " out of range [ 1.0e-03,  (+inf) [";
  }

//    Parameter CSTHRB : [ 0.1,  (+inf) [
  if ( (!((CSTHRB >=0.1))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSTHRB value " << CSTHRB << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter MUE : [ 0,  (+inf) [
  if ( (!((MUE >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter MUE value " << MUE << " out of range [ 0,  (+inf) [";
  }

//    Parameter THEMU : [ 0,  (+inf) [
  if ( (!((THEMU >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THEMU value " << THEMU << " out of range [ 0,  (+inf) [";
  }

//    Parameter FETA : [ 0,  (+inf) [
  if ( (!((FETA >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FETA value " << FETA << " out of range [ 0,  (+inf) [";
  }

//    Parameter RS : [ 0,  (+inf) [
  if ( (!((RS >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter RS value " << RS << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSIG : [ 0,  (+inf) [
  if ( (!((RSIG >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter RSIG value " << RSIG << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSG : [ (-0.5),  (+inf) [
  if ( (!((RSG >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter RSG value " << RSG << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter THESAT : [ 0,  (+inf) [
  if ( (!((THESAT >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THESAT value " << THESAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter THESATG : [ (-0.5),  (+inf) [
  if ( (!((THESATG >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THESATG value " << THESATG << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter THESATB : [ (-0.5),  (+inf) [
  if ( (!((THESATB >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THESATB value " << THESATB << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter AX : [ 1.0, 16.0 ]
  if ( (!((AX >=1.0 && AX <=16.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter AX value " << AX << " out of range [ 1.0, 16.0 ]";
  }

//    Parameter ALP : [ 0,  (+inf) [
  if ( (!((ALP >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter ALP value " << ALP << " out of range [ 0,  (+inf) [";
  }

//    Parameter ALP1 : [ 0,  (+inf) [
  if ( (!((ALP1 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter ALP1 value " << ALP1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter VP : [ 1.0e-10,  (+inf) [
  if ( (!((VP >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter VP value " << VP << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter VPG : [ 0,  (+inf) [
  if ( (!((VPG >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter VPG value " << VPG << " out of range [ 0,  (+inf) [";
  }

//    Parameter GCO : [ (-10.0), 10.0 ]
  if ( (!((GCO >=(-10.0) && GCO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GCO value " << GCO << " out of range [ (-10.0), 10.0 ]";
  }

//    Parameter IGINV : [ 0,  (+inf) [
  if ( (!((IGINV >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGINV value " << IGINV << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVINV : [ 0,  (+inf) [
  if ( (!((IGOVINV >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVINV value " << IGOVINV << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVINVD : [ 0,  (+inf) [
  if ( (!((IGOVINVD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVINVD value " << IGOVINVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVACC : [ 0,  (+inf) [
  if ( (!((IGOVACC >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVACC value " << IGOVACC << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVACCD : [ 0,  (+inf) [
  if ( (!((IGOVACCD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVACCD value " << IGOVACCD << " out of range [ 0,  (+inf) [";
  }

//    Parameter GC2CH : [ 0.0, 10.0 ]
  if ( (!((GC2CH >=0.0 && GC2CH <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC2CH value " << GC2CH << " out of range [ 0.0, 10.0 ]";
  }

//    Parameter GC3CH : [ (-2.0), 2.0 ]
  if ( (!((GC3CH >=(-2.0) && GC3CH <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC3CH value " << GC3CH << " out of range [ (-2.0), 2.0 ]";
  }

//    Parameter GC2OVINV : [ 0.0, 10.0 ]
  if ( (!((GC2OVINV >=0.0 && GC2OVINV <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC2OVINV value " << GC2OVINV << " out of range [ 0.0, 10.0 ]";
  }

//    Parameter GC3OVINV : [ (-2.0), 2.0 ]
  if ( (!((GC3OVINV >=(-2.0) && GC3OVINV <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC3OVINV value " << GC3OVINV << " out of range [ (-2.0), 2.0 ]";
  }

//    Parameter GC2OVACC : [ 0.0, 10.0 ]
  if ( (!((GC2OVACC >=0.0 && GC2OVACC <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC2OVACC value " << GC2OVACC << " out of range [ 0.0, 10.0 ]";
  }

//    Parameter GC3OVACC : [ (-2.0), 2.0 ]
  if ( (!((GC3OVACC >=(-2.0) && GC3OVACC <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC3OVACC value " << GC3OVACC << " out of range [ (-2.0), 2.0 ]";
  }

//    Parameter CHIB : [ 1.0,  (+inf) [
  if ( (!((CHIB >=1.0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CHIB value " << CHIB << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter NIGINV : [ 0,  (+inf) [
  if ( (!((NIGINV >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NIGINV value " << NIGINV << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNOVINV : [ 0,  (+inf) [
  if ( (!((FNOVINV >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNOVINV value " << FNOVINV << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNOVINVD : [ 0,  (+inf) [
  if ( (!((FNOVINVD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNOVINVD value " << FNOVINVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter GCOVINVFN : [ 0.1, 10.0 ]
  if ( (!((GCOVINVFN >=0.1 && GCOVINVFN <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GCOVINVFN value " << GCOVINVFN << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter AGIDL : [ 0,  (+inf) [
  if ( (!((AGIDL >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter AGIDL value " << AGIDL << " out of range [ 0,  (+inf) [";
  }

//    Parameter AGIDLD : [ 0,  (+inf) [
  if ( (!((AGIDLD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter AGIDLD value " << AGIDLD << " out of range [ 0,  (+inf) [";
  }

//    Parameter BGIDL : [ 0,  (+inf) [
  if ( (!((BGIDL >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter BGIDL value " << BGIDL << " out of range [ 0,  (+inf) [";
  }

//    Parameter BGIDLD : [ 0,  (+inf) [
  if ( (!((BGIDLD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter BGIDLD value " << BGIDLD << " out of range [ 0,  (+inf) [";
  }

//    Parameter A1 : [ 0,  (+inf) [
  if ( (!((A1 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter A1 value " << A1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter A2 : [ 0,  (+inf) [
  if ( (!((A2 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter A2 value " << A2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter A3 : [ 0,  (+inf) [
  if ( (!((A3 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter A3 value " << A3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter AREAQ : [ 1.0e-18,  (+inf) [
  if ( (!((AREAQ >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter AREAQ value " << AREAQ << " out of range [ 1.0e-18,  (+inf) [";
  }

//    Parameter CGBOV : [ 0,  (+inf) [
  if ( (!((CGBOV >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CGBOV value " << CGBOV << " out of range [ 0,  (+inf) [";
  }

//    Parameter NSDAC : [ 1.0e18, 1.0e22 ]
  if ( (!((NSDAC >=1.0e18 && NSDAC <=1.0e22 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NSDAC value " << NSDAC << " out of range [ 1.0e18, 1.0e22 ]";
  }

//    Parameter FIF : [ 0,  (+inf) [
  if ( (!((FIF >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FIF value " << FIF << " out of range [ 0,  (+inf) [";
  }

//    Parameter FSCEAC : [ 0,  (+inf) [
  if ( (!((FSCEAC >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FSCEAC value " << FSCEAC << " out of range [ 0,  (+inf) [";
  }

//    Parameter COV : [ 0,  (+inf) [
  if ( (!((COV >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter COV value " << COV << " out of range [ 0,  (+inf) [";
  }

//    Parameter COVD : [ 0,  (+inf) [
  if ( (!((COVD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter COVD value " << COVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFR : [ 0,  (+inf) [
  if ( (!((CFR >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFR value " << CFR << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFRD : [ 0,  (+inf) [
  if ( (!((CFRD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFRD value " << CFRD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSD : [ 0,  (+inf) [
  if ( (!((CSD >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSD value " << CSD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSDBP : [ 0,  (+inf) [
  if ( (!((CSDBP >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSDBP value " << CSDBP << " out of range [ 0,  (+inf) [";
  }

//    Parameter RTH : [ 1.0e-06,  (+inf) [
  if ( (!((RTH >=1.0e-06))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter RTH value " << RTH << " out of range [ 1.0e-06,  (+inf) [";
  }

//    Parameter CTH : [ 0,  (+inf) [
  if ( (!((CTH >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CTH value " << CTH << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNT : [ 0,  (+inf) [
  if ( (!((FNT >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNT value " << FNT << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNTEXC : [ 0,  (+inf) [
  if ( (!((FNTEXC >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNTEXC value " << FNTEXC << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFA : [ 0,  (+inf) [
  if ( (!((NFA >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFA value " << NFA << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFB : [ 0,  (+inf) [
  if ( (!((NFB >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFB value " << NFB << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFC : [ 0,  (+inf) [
  if ( (!((NFC >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFC value " << NFC << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFE : [ (-1.0), 1.0 ]
  if ( (!((NFE >=(-1.0) && NFE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFE value " << NFE << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter NFEB : [ (-1.0), 1.0 ]
  if ( (!((NFEB >=(-1.0) && NFEB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFEB value " << NFEB << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter EF : [ 0.1,  (+inf) [
  if ( (!((EF >=0.1))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter EF value " << EF << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter TOXEO : [ 3.0e-10, 1.0e-06 ]
  if ( (!((TOXEO >=3.0e-10 && TOXEO <=1.0e-06 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TOXEO value " << TOXEO << " out of range [ 3.0e-10, 1.0e-06 ]";
  }

//    Parameter TSIO : [ 3.0e-09, 2.0e-08 ]
  if ( (!((TSIO >=3.0e-09 && TSIO <=2.0e-08 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TSIO value " << TSIO << " out of range [ 3.0e-09, 2.0e-08 ]";
  }

//    Parameter XGEO : [ 0.0, 1.0 ]
  if ( (!((XGEO >=0.0 && XGEO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter XGEO value " << XGEO << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter TBOXO : [ 3.0e-10, 1.0e-06 ]
  if ( (!((TBOXO >=3.0e-10 && TBOXO <=1.0e-06 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TBOXO value " << TBOXO << " out of range [ 3.0e-10, 1.0e-06 ]";
  }

//    Parameter CTO : [ 0,  (+inf) [
  if ( (!((CTO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CTO value " << CTO << " out of range [ 0,  (+inf) [";
  }

//    Parameter TOXPO : [ 3.0e-10, 1.0e-06 ]
  if ( (!((TOXPO >=3.0e-10 && TOXPO <=1.0e-06 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter TOXPO value " << TOXPO << " out of range [ 3.0e-10, 1.0e-06 ]";
  }

//    Parameter NOVO : [ 1.0e15, 1.0e21 ]
  if ( (!((NOVO >=1.0e15 && NOVO <=1.0e21 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NOVO value " << NOVO << " out of range [ 1.0e15, 1.0e21 ]";
  }

//    Parameter NOVDO : [ 1.0e15, 1.0e21 ]
  if ( (!((NOVDO >=1.0e15 && NOVDO <=1.0e21 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NOVDO value " << NOVDO << " out of range [ 1.0e15, 1.0e21 ]";
  }

//    Parameter VFBL2 : [ 0,  (+inf) [
  if ( (!((VFBL2 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter VFBL2 value " << VFBL2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter VFBLBO : [ 0,  (+inf) [
  if ( (!((VFBLBO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter VFBLBO value " << VFBLBO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CICFO : [ 0.1, 10.0 ]
  if ( (!((CICFO >=0.1 && CICFO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CICFO value " << CICFO << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter CICO : [ 0.1, 10.0 ]
  if ( (!((CICO >=0.1 && CICO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CICO value " << CICO << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter PSCEBO : [ 0,  (+inf) [
  if ( (!((PSCEBO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PSCEBO value " << PSCEBO << " out of range [ 0,  (+inf) [";
  }

//    Parameter NSDDCO : [ 1.0e18, 1.0e22 ]
  if ( (!((NSDDCO >=1.0e18 && NSDDCO <=1.0e22 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NSDDCO value " << NSDDCO << " out of range [ 1.0e18, 1.0e22 ]";
  }

//    Parameter PSCEDLBO : [ 0,  (+inf) [
  if ( (!((PSCEDLBO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter PSCEDLBO value " << PSCEDLBO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFBO : [ 0,  (+inf) [
  if ( (!((CFBO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFBO value " << CFBO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFDO : [ 0.05,  (+inf) [
  if ( (!((CFDO >=0.05))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFDO value " << CFDO << " out of range [ 0.05,  (+inf) [";
  }

//    Parameter CFDLBO : [ 0,  (+inf) [
  if ( (!((CFDLBO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CFDLBO value " << CFDLBO << " out of range [ 0,  (+inf) [";
  }

//    Parameter UO : [ 0,  (+inf) [
  if ( (!((UO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter UO value " << UO << " out of range [ 0,  (+inf) [";
  }

//    Parameter LP1 : [ 1.0e-10,  (+inf) [
  if ( (!((LP1 >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LP1 value " << LP1 << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter LP2 : [ 1.0e-10,  (+inf) [
  if ( (!((LP2 >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LP2 value " << LP2 << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter WBET : [ 1.0e-10,  (+inf) [
  if ( (!((WBET >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter WBET value " << WBET << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter BETNBO : [ 0.1, 10.0 ]
  if ( (!((BETNBO >=0.1 && BETNBO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter BETNBO value " << BETNBO << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter CSFIO : [ 0,  (+inf) [
  if ( (!((CSFIO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSFIO value " << CSFIO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSBIO : [ 0,  (+inf) [
  if ( (!((CSBIO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSBIO value " << CSBIO << " out of range [ 0,  (+inf) [";
  }

//    Parameter THECSO : [ 0,  (+inf) [
  if ( (!((THECSO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THECSO value " << THECSO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSTHRO : [ 1.0e-03,  (+inf) [
  if ( (!((CSTHRO >=1.0e-03))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSTHRO value " << CSTHRO << " out of range [ 1.0e-03,  (+inf) [";
  }

//    Parameter CSTHRBO : [ 0.1,  (+inf) [
  if ( (!((CSTHRBO >=0.1))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSTHRBO value " << CSTHRBO << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter MUEO : [ 0,  (+inf) [
  if ( (!((MUEO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter MUEO value " << MUEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter THEMUO : [ 0,  (+inf) [
  if ( (!((THEMUO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THEMUO value " << THEMUO << " out of range [ 0,  (+inf) [";
  }

//    Parameter FETAO : [ 0,  (+inf) [
  if ( (!((FETAO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FETAO value " << FETAO << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSIGO : [ 0,  (+inf) [
  if ( (!((RSIGO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter RSIGO value " << RSIGO << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSGO : [ (-0.5),  (+inf) [
  if ( (!((RSGO >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter RSGO value " << RSGO << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter THESATO : [ 0,  (+inf) [
  if ( (!((THESATO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THESATO value " << THESATO << " out of range [ 0,  (+inf) [";
  }

//    Parameter THESATGO : [ (-0.5),  (+inf) [
  if ( (!((THESATGO >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THESATGO value " << THESATGO << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter THESATBO : [ (-0.5),  (+inf) [
  if ( (!((THESATBO >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter THESATBO value " << THESATBO << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter AXL : [ 0,  (+inf) [
  if ( (!((AXL >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter AXL value " << AXL << " out of range [ 0,  (+inf) [";
  }

//    Parameter AXL2 : [ 0,  (+inf) [
  if ( (!((AXL2 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter AXL2 value " << AXL2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter ALPL2 : [ 0,  (+inf) [
  if ( (!((ALPL2 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter ALPL2 value " << ALPL2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter ALP1L2 : [ 0,  (+inf) [
  if ( (!((ALP1L2 >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter ALP1L2 value " << ALP1L2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter VPO : [ 1.0e-10,  (+inf) [
  if ( (!((VPO >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter VPO value " << VPO << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter VPGO : [ 0,  (+inf) [
  if ( (!((VPGO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter VPGO value " << VPGO << " out of range [ 0,  (+inf) [";
  }

//    Parameter GCOO : [ (-10.0), 10.0 ]
  if ( (!((GCOO >=(-10.0) && GCOO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GCOO value " << GCOO << " out of range [ (-10.0), 10.0 ]";
  }

//    Parameter IGINVLW : [ 0,  (+inf) [
  if ( (!((IGINVLW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGINVLW value " << IGINVLW << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVINVW : [ 0,  (+inf) [
  if ( (!((IGOVINVW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVINVW value " << IGOVINVW << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVINVDW : [ 0,  (+inf) [
  if ( (!((IGOVINVDW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVINVDW value " << IGOVINVDW << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVACCW : [ 0,  (+inf) [
  if ( (!((IGOVACCW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVACCW value " << IGOVACCW << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVACCDW : [ 0,  (+inf) [
  if ( (!((IGOVACCDW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter IGOVACCDW value " << IGOVACCDW << " out of range [ 0,  (+inf) [";
  }

//    Parameter GC2CHO : [ 0.0, 10.0 ]
  if ( (!((GC2CHO >=0.0 && GC2CHO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC2CHO value " << GC2CHO << " out of range [ 0.0, 10.0 ]";
  }

//    Parameter GC3CHO : [ (-2.0), 2.0 ]
  if ( (!((GC3CHO >=(-2.0) && GC3CHO <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC3CHO value " << GC3CHO << " out of range [ (-2.0), 2.0 ]";
  }

//    Parameter GC2OVINVO : [ 0.0, 10.0 ]
  if ( (!((GC2OVINVO >=0.0 && GC2OVINVO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC2OVINVO value " << GC2OVINVO << " out of range [ 0.0, 10.0 ]";
  }

//    Parameter GC3OVINVO : [ (-2.0), 2.0 ]
  if ( (!((GC3OVINVO >=(-2.0) && GC3OVINVO <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC3OVINVO value " << GC3OVINVO << " out of range [ (-2.0), 2.0 ]";
  }

//    Parameter GC2OVACCO : [ 0.0, 10.0 ]
  if ( (!((GC2OVACCO >=0.0 && GC2OVACCO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC2OVACCO value " << GC2OVACCO << " out of range [ 0.0, 10.0 ]";
  }

//    Parameter GC3OVACCO : [ (-2.0), 2.0 ]
  if ( (!((GC3OVACCO >=(-2.0) && GC3OVACCO <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GC3OVACCO value " << GC3OVACCO << " out of range [ (-2.0), 2.0 ]";
  }

//    Parameter CHIBO : [ 1.0,  (+inf) [
  if ( (!((CHIBO >=1.0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CHIBO value " << CHIBO << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter NIGINVO : [ 0,  (+inf) [
  if ( (!((NIGINVO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NIGINVO value " << NIGINVO << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNOVINVW : [ 0,  (+inf) [
  if ( (!((FNOVINVW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNOVINVW value " << FNOVINVW << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNOVINVDW : [ 0,  (+inf) [
  if ( (!((FNOVINVDW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNOVINVDW value " << FNOVINVDW << " out of range [ 0,  (+inf) [";
  }

//    Parameter GCOVINVFNO : [ 0.1, 10.0 ]
  if ( (!((GCOVINVFNO >=0.1 && GCOVINVFNO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter GCOVINVFNO value " << GCOVINVFNO << " out of range [ 0.1, 10.0 ]";
  }

//    Parameter BGIDLO : [ 0,  (+inf) [
  if ( (!((BGIDLO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter BGIDLO value " << BGIDLO << " out of range [ 0,  (+inf) [";
  }

//    Parameter BGIDLDO : [ 0,  (+inf) [
  if ( (!((BGIDLDO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter BGIDLDO value " << BGIDLDO << " out of range [ 0,  (+inf) [";
  }

//    Parameter A2O : [ 0,  (+inf) [
  if ( (!((A2O >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter A2O value " << A2O << " out of range [ 0,  (+inf) [";
  }

//    Parameter NSDACO : [ 1.0e18, 1.0e22 ]
  if ( (!((NSDACO >=1.0e18 && NSDACO <=1.0e22 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NSDACO value " << NSDACO << " out of range [ 1.0e18, 1.0e22 ]";
  }

//    Parameter FIFW : [ 0,  (+inf) [
  if ( (!((FIFW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FIFW value " << FIFW << " out of range [ 0,  (+inf) [";
  }

//    Parameter FSCEACO : [ 0,  (+inf) [
  if ( (!((FSCEACO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FSCEACO value " << FSCEACO << " out of range [ 0,  (+inf) [";
  }

//    Parameter LOVO : [ 0,  (+inf) [
  if ( (!((LOVO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LOVO value " << LOVO << " out of range [ 0,  (+inf) [";
  }

//    Parameter LOVDO : [ 0,  (+inf) [
  if ( (!((LOVDO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LOVDO value " << LOVDO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSDO : [ 0,  (+inf) [
  if ( (!((CSDO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSDO value " << CSDO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSDBPO : [ 0,  (+inf) [
  if ( (!((CSDBPO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CSDBPO value " << CSDBPO << " out of range [ 0,  (+inf) [";
  }

//    Parameter RTHO : [ 0,  (+inf) [
  if ( (!((RTHO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter RTHO value " << RTHO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTHO : [ 0,  (+inf) [
  if ( (!((CTHO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter CTHO value " << CTHO << " out of range [ 0,  (+inf) [";
  }

//    Parameter LAMBTHO : [ 1.0e-09,  (+inf) [
  if ( (!((LAMBTHO >=1.0e-09))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LAMBTHO value " << LAMBTHO << " out of range [ 1.0e-09,  (+inf) [";
  }

//    Parameter FTHO : [ 0,  (+inf) [
  if ( (!((FTHO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FTHO value " << FTHO << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNTO : [ 0,  (+inf) [
  if ( (!((FNTO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNTO value " << FNTO << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNTEXCL : [ 0,  (+inf) [
  if ( (!((FNTEXCL >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter FNTEXCL value " << FNTEXCL << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFBLW : [ 0,  (+inf) [
  if ( (!((NFBLW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFBLW value " << NFBLW << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFCLW : [ 0,  (+inf) [
  if ( (!((NFCLW >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFCLW value " << NFCLW << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFEO : [ (-1.0), 1.0 ]
  if ( (!((NFEO >=(-1.0) && NFEO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFEO value " << NFEO << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter NFEBO : [ (-1.0), 1.0 ]
  if ( (!((NFEBO >=(-1.0) && NFEBO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter NFEBO value " << NFEBO << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter EFO : [ 0.1,  (+inf) [
  if ( (!((EFO >=0.1))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter EFO value " << EFO << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter SWSTRESS : [ 0, 2 ]
  if ( (!((SWSTRESS >=0 && SWSTRESS <=2 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SWSTRESS value " << SWSTRESS << " out of range [ 0, 2 ]";
  }

//    Parameter SAREF : [ 1.0e-09,  (+inf) [
  if ( (!((SAREF >=1.0e-09))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SAREF value " << SAREF << " out of range [ 1.0e-09,  (+inf) [";
  }

//    Parameter SBREF : [ 1.0e-09,  (+inf) [
  if ( (!((SBREF >=1.0e-09))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter SBREF value " << SBREF << " out of range [ 1.0e-09,  (+inf) [";
  }

//    Parameter KVSAT : [ (-1.0), 1.0 ]
  if ( (!((KVSAT >=(-1.0) && KVSAT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter KVSAT value " << KVSAT << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter LLODKUO : [ 0,  (+inf) [
  if ( (!((LLODKUO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LLODKUO value " << LLODKUO << " out of range [ 0,  (+inf) [";
  }

//    Parameter WLODKUO : [ 0,  (+inf) [
  if ( (!((WLODKUO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter WLODKUO value " << WLODKUO << " out of range [ 0,  (+inf) [";
  }

//    Parameter LLODVTH : [ 0,  (+inf) [
  if ( (!((LLODVTH >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LLODVTH value " << LLODVTH << " out of range [ 0,  (+inf) [";
  }

//    Parameter WLODVTH : [ 0,  (+inf) [
  if ( (!((WLODVTH >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter WLODVTH value " << WLODVTH << " out of range [ 0,  (+inf) [";
  }

//    Parameter LODETAO : [ 0,  (+inf) [
  if ( (!((LODETAO >=0))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter LODETAO value " << LODETAO << " out of range [ 0,  (+inf) [";
  }

//    Parameter STRLAMBDA : [ 1.0e-09, 1.0e-05 ]
  if ( (!((STRLAMBDA >=1.0e-09 && STRLAMBDA <=1.0e-05 ))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter STRLAMBDA value " << STRLAMBDA << " out of range [ 1.0e-09, 1.0e-05 ]";
  }

//    Parameter STRALPHA : [ 0.5,  (+inf) [
  if ( (!((STRALPHA >=0.5))) )
  {
    UserWarning(*this) << "ADMSl_utsoi: Parameter STRALPHA value " << STRALPHA << " out of range [ 0.5,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff
//Begin block initial_model
{
TKR = (273.15+TR);
{
double value_min_0 = std::min(admsModTemp,static_cast<double>(1000.0));
TKD = value_min_0;
}
if ((((SWSCALE==0)&&(RTH>0.0))||((SWSCALE>0)&&(RTHO>0.0))))
{
SWSHE_i = SWSHE;
}
else
{
SWSHE_i = 0;
}
gmin = getDeviceOptions().gmin;
}
// End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    SWSCALE(0),
    VERSION(102.4),
    SWSUBDEP(0),
    SWIGATE(0),
    SWGIDL(0),
    SWSHE(0),
    SWIGN(1),
    SWJUNASYM(0),
    SWIMPACT(0),
    QMC(1.0),
    TYPE(1),
    TR(21.0),
    TMAX(150.0),
    TOXE(2.0e-09),
    TSI(1.0e-08),
    XGE(0.0),
    TBOX(1.0e-07),
    NCH(0.0),
    NSUB(3.0e18),
    CT(0.0),
    TOXP(2.0e-09),
    NOV(1.0e20),
    NOVD(1.0e20),
    VFB(0.0),
    VFBB(0.0),
    STVFB(0.0),
    CICF(1.0),
    CIC(1.0),
    PSCE(0.0),
    PSCEB(1.0),
    NSDDC(1.0e22),
    PSCEDLB(0.0),
    PNCE(0.0),
    CF(0.0),
    CFB(1.0),
    STCF(0.0),
    CFD(0.2),
    CFDL(0.0),
    CFDLB(0.0),
    BETN(5.0e-02),
    BETNB(1.0),
    STBET(1.5),
    CS(0.0),
    CSFI(0.0),
    CSBI(0.0),
    STCS(0.0),
    THECS(1.5),
    STTHECS(0.0),
    CSTHR(2.0),
    CSTHRB(1.0),
    MUE(0.0),
    STMUE(0.0),
    THEMU(1.5),
    STTHEMU(0.0),
    XCOR(0.0),
    XCORB(1.0),
    STXCOR(0.0),
    FETA(1.0),
    RS(30.0),
    RSIG(0.0),
    STRS(0.0),
    RSG(0.0),
    THERSG(2.0),
    RSB(0.0),
    THESAT(0.0),
    STTHESAT((-0.1)),
    THESATG(0.0),
    THESATB(0.0),
    AX(8.0),
    ALP(0.0),
    ALP1(0.0),
    ALPB(0.0),
    VP(0.05),
    VPG(0.0),
    GCO(0.0),
    IGINV(0.0),
    IGOVINV(0.0),
    IGOVINVD(0.0),
    IGOVACC(0.0),
    IGOVACCD(0.0),
    STIG(0.0),
    GC2CH(0.375),
    GC3CH(0.063),
    GC2OVINV(0.375),
    GC3OVINV(0.063),
    GC2OVACC(0.375),
    GC3OVACC(0.063),
    GCDOV(0.0),
    GCVDOV(1.0),
    CHIB(3.1),
    NIGINV(0.0),
    FNOVINV(0.0),
    FNOVINVD(0.0),
    GCOVINVFN(0.2),
    STIGFN(0.0),
    AGIDL(0.0),
    AGIDLD(0.0),
    BGIDL(41.0),
    BGIDLD(41.0),
    STBGIDL(0.0),
    STBGIDLD(0.0),
    CGIDL(0.0),
    CGIDLD(0.0),
    DGIDL(0.0),
    DGIDLD(0.0),
    A1(1.0),
    A2(10.0),
    STA2(0.0),
    A3(1.0),
    AREAQ(1.0e-12),
    CGBOV(0.0),
    NSDAC(1.0e22),
    FIF(0.0),
    FSCEAC(0.0),
    COV(0.0),
    COVD(0.0),
    COVDL(0.0),
    COVDLB(0.0),
    DVFBOV(0.0),
    CFR(0.0),
    CFRD(0.0),
    CSD(1.04e-18),
    CSDBP(0.0),
    RTH(1.0e04),
    STRTH(0.0),
    CTH(1.0e-11),
    FNT(1.0),
    FNTEXC(0.0),
    NFA(8.0e22),
    NFB(3.0e07),
    NFC(0.0),
    NFE(0.0),
    NFEB(0.0),
    EF(1.0),
    LVARO(0.0),
    LVARL(0.0),
    LVARW(0.0),
    LAP(0.0),
    WVARO(0.0),
    WVARL(0.0),
    WVARW(0.0),
    WOT(0.0),
    DLQ(0.0),
    DWQ(0.0),
    TOXEO(2.0e-09),
    TSIO(1.0e-08),
    XGEO(0.0),
    TBOXO(1.0e-07),
    NCHO(0.0),
    NSUBO(3.0e18),
    CTO(0.0),
    TOXPO(2.0e-09),
    NOVO(1.0e20),
    NOVDO(1.0e20),
    VFBO(0.0),
    VFBL(0.0),
    VFBLEXP(2.0),
    VFBL2(0.0),
    VFBLEXP2(2.0),
    VFBW(0.0),
    VFBLW(0.0),
    VFBBO(0.0),
    VFBLBO(0.0),
    STVFBO(0.0),
    STVFBL(0.0),
    STVFBW(0.0),
    STVFBLW(0.0),
    CICFO(1.0),
    CICO(1.0),
    PSCEL(0.0),
    PSCELEXP(2.0),
    PSCEW(0.0),
    PSCEBO(1.0),
    NSDDCO(1.0e22),
    PSCEDLBO(0.0),
    PNCEW(0.0),
    CFL(0.0),
    CFLEXP(2.0),
    CFW(0.0),
    CFBO(1.0),
    STCFL(0.0),
    CFDO(0.2),
    CFDLL(0.0),
    CFDLW(0.0),
    CFDLBO(0.0),
    UO(5.0e-02),
    FBET1(0.0),
    FBET1W(0.0),
    LP1(1.0e-08),
    LP1W(0.0),
    FBET2(0.0),
    LP2(1.0e-08),
    BETW1(0.0),
    BETW2(0.0),
    WBET(1.0e-08),
    BETNBO(1.0),
    STBETO(1.5),
    STBETL(0.0),
    STBETW(0.0),
    STBETLW(0.0),
    CSO(0.0),
    CSL(0.0),
    CSLEXP(1.0),
    CSW(0.0),
    CSLW(0.0),
    CSFIO(0.0),
    CSBIO(0.0),
    STCSO(0.0),
    STCSL(0.0),
    STCSW(0.0),
    STCSLW(0.0),
    THECSO(1.5),
    STTHECSO(0.0),
    CSTHRO(2.0),
    CSTHRBO(1.0),
    MUEO(0.0),
    STMUEO(0.0),
    THEMUO(1.5),
    STTHEMUO(0.0),
    XCORO(0.0),
    XCORL(0.0),
    XCORLEXP(1.0),
    XCORW(0.0),
    XCORLW(0.0),
    XCORBO(1.0),
    STXCORO(0.0),
    FETAO(1.0),
    RSW1(30.0),
    RSW2(0.0),
    RSIGO(0.0),
    STRSO(0.0),
    RSGO(0.0),
    THERSGO(2.0),
    RSBO(0.0),
    THESATO(0.0),
    THESATL(0.0),
    THESATLEXP(1.0),
    THESATW(0.0),
    THESATLW(0.0),
    STTHESATO((-0.1)),
    STTHESATL(0.0),
    STTHESATW(0.0),
    STTHESATLW(0.0),
    THESATGO(0.0),
    THESATBO(0.0),
    AXO(8.0),
    AXL(0.0),
    AXLEXP(1.0),
    AXL2(0.0),
    AXLEXP2(1.5),
    ALPL1(0.0),
    ALPLEXP(1.0),
    ALPL2(0.0),
    ALPLEXP2(2.0),
    ALPW(0.0),
    ALP1L1(0.0),
    ALP1LEXP(0.5),
    ALP1L2(0.0),
    ALP1LEXP2(1.5),
    ALP1W(0.0),
    ALPBO(0.0),
    VPO(0.05),
    VPGO(0.0),
    GCOO(0.0),
    IGINVLW(0.0),
    IGOVINVW(0.0),
    IGOVINVDW(0.0),
    IGOVACCW(0.0),
    IGOVACCDW(0.0),
    STIGO(0.0),
    GC2CHO(0.375),
    GC3CHO(0.063),
    GC2OVINVO(0.375),
    GC3OVINVO(0.063),
    GC2OVACCO(0.375),
    GC3OVACCO(0.063),
    GCDOVL(0.0),
    GCVDOVO(1.0),
    CHIBO(3.1),
    NIGINVO(0.0),
    FNOVINVW(0.0),
    FNOVINVDW(0.0),
    GCOVINVFNO(0.2),
    STIGFNO(0.0),
    AGIDLO(0.0),
    AGIDLDO(0.0),
    AGIDLW(0.0),
    AGIDLDW(0.0),
    BGIDLO(41.0),
    BGIDLDO(41.0),
    STBGIDLO(0.0),
    STBGIDLDO(0.0),
    CGIDLO(0.0),
    CGIDLDO(0.0),
    DGIDLO(0.0),
    DGIDLDO(0.0),
    DGIDLL(0.0),
    DGIDLDL(0.0),
    A1O(1.0),
    A1L(0.0),
    A1W(0.0),
    A2O(10.0),
    STA2O(0.0),
    A3O(1.0),
    A3L(0.0),
    A3W(0.0),
    CGBOVO(0.0),
    CGBOVL(0.0),
    NSDACO(1.0e22),
    FIFW(0.0),
    FSCEACO(0.0),
    LOVO(0.0),
    LOVDO(0.0),
    COVDLO(0.0),
    COVDLW(0.0),
    COVDLBO(0.0),
    DVFBOVO(0.0),
    CFRO(0.0),
    CFRDO(0.0),
    CFRW(0.0),
    CFRDW(0.0),
    CSDO(1.0),
    CSDBPO(0.0),
    RTHO(1.0e05),
    RTHL(1.5),
    RTHW(3.0),
    RTHLW(4.5),
    STRTHO(0.0),
    CTHO(1.0e-12),
    LAMBTHO(1.0e-07),
    FTHO(0.0),
    FNTO(1.0),
    FNTEXCL(0.0),
    FNTEXCLEXP(2.0),
    NFALW(8.0e22),
    NFAW(0.0),
    NFBLW(3.0e07),
    NFCLW(0.0),
    NFEO(0.0),
    NFEBO(0.0),
    EFO(1.0),
    SWSTRESS(1),
    SAREF(1.0e-06),
    SBREF(1.0e-06),
    WLOD(0.0),
    KUO(0.0),
    KVSAT(0.0),
    TKUO(0.0),
    LKUO(0.0),
    WKUO(0.0),
    PKUO(0.0),
    LLODKUO(0.0),
    WLODKUO(0.0),
    KVTHO(0.0),
    LKVTHO(0.0),
    WKVTHO(0.0),
    PKVTHO(0.0),
    LLODVTH(0.0),
    WLODVTH(0.0),
    STETAO(0.0),
    LODETAO(1.0),
    STRLAMBDA(1.0e-07),
    STRALPHA(3.0),
    STRDVFBO(0.0),
    STRWDVFBO(0.0),
    STRDCFL(0.0),
    STRRUO(0.0),
    STRTRUO(0.0),
    STRRVSAT(0.0),
    SWSHE_i(0),
    TKR(0.0),
    TKD(0.0),
    gmin(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
      os << "L  =  " << (*iter)->L << std::endl;
      os << "W  =  " << (*iter)->W << std::endl;
      os << "ASOURCE  =  " << (*iter)->ASOURCE << std::endl;
      os << "ADRAIN  =  " << (*iter)->ADRAIN << std::endl;
      os << "PSOURCE  =  " << (*iter)->PSOURCE << std::endl;
      os << "PDRAIN  =  " << (*iter)->PDRAIN << std::endl;
      os << "SA  =  " << (*iter)->SA << std::endl;
      os << "SB  =  " << (*iter)->SB << std::endl;
      os << "SD  =  " << (*iter)->SD << std::endl;
      os << "NF  =  " << (*iter)->NF << std::endl;
      os << "MULT  =  " << (*iter)->MULT << std::endl;
      os << "DELVTO  =  " << (*iter)->DELVTO << std::endl;
      os << "FACTUO  =  " << (*iter)->FACTUO << std::endl;
      os << "M  =  " << (*iter)->M << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("M") != deviceMap.end() && (levelSet.find(10240)!=levelSet.end()))))
{
MOSFET1::registerDevice();
  Config<Traits>::addConfiguration()
    .registerDevice("m", 10240)
    .registerModelType("nmos", 10240)
    .registerModelType("pmos", 10240);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  double xb_sub=0.0;
double d_xb_sub_dX=0.0;
  double Ceq_1D=0.0;
double d_Ceq_1D_dX=0.0;
  double Cox1Init=0.0;
double d_Cox1Init_dX=0.0;
  double neff_sub=0.0;
double d_neff_sub_dX=0.0;
  double AX_i=0.0;
double d_AX_i_dX=0.0;
  double FETA_i=0.0;
double d_FETA_i_dX=0.0;
  double CSTHRB_i=0.0;
double d_CSTHRB_i_dX=0.0;
  double CSTHR_i=0.0;
double d_CSTHR_i_dX=0.0;
  double PNCE_i=0.0;
double d_PNCE_i_dX=0.0;
  double NSUB_i=0.0;
double d_NSUB_i_dX=0.0;
  double NCH_i=0.0;
double d_NCH_i_dX=0.0;
  double TYPECH_i=0.0;
  double TOX2_i=0.0;
double d_TOX2_i_dX=0.0;
  double TOX1_i=0.0;
double d_TOX1_i_dX=0.0;
  double temp0=0.0;
double d_temp0_dX=0.0;
  double Kstressvth0=0.0;
double d_Kstressvth0_dX=0.0;
  double rhobetaref=0.0;
double d_rhobetaref_dX=0.0;
  double rhobeta=0.0;
double d_rhobeta_dX=0.0;
  double Kstressu0=0.0;
double d_Kstressu0_dX=0.0;
  double tempw=0.0;
double d_tempw_dX=0.0;
  double templ=0.0;
double d_templ_dX=0.0;
  double Wx=0.0;
double d_Wx_dX=0.0;
  double Lx=0.0;
double d_Lx_dX=0.0;
  double Invsbref=0.0;
double d_Invsbref_dX=0.0;
  double Invsaref=0.0;
double d_Invsaref_dX=0.0;
  double Invsb=0.0;
double d_Invsb_dX=0.0;
  double Invsa=0.0;
double d_Invsa_dX=0.0;
  double iloop=0.0;
  double tmpb=0.0;
double d_tmpb_dX=0.0;
  double tmpa=0.0;
double d_tmpa_dX=0.0;
  double ruo=0.0;
double d_ruo_dX=0.0;
  double str_gref=0.0;
double d_str_gref_dX=0.0;
  double str_g=0.0;
double d_str_g_dX=0.0;
  double NFA_p=0.0;
double d_NFA_p_dX=0.0;
  double CTH_p=0.0;
double d_CTH_p_dX=0.0;
  double RTH_p=0.0;
double d_RTH_p_dX=0.0;
  double CFRD_p=0.0;
double d_CFRD_p_dX=0.0;
  double CFR_p=0.0;
double d_CFR_p_dX=0.0;
  double CGBOV_p=0.0;
double d_CGBOV_p_dX=0.0;
  double A3_p=0.0;
double d_A3_p_dX=0.0;
  double A1_p=0.0;
double d_A1_p_dX=0.0;
  double AGIDLD_p=0.0;
double d_AGIDLD_p_dX=0.0;
  double AGIDL_p=0.0;
double d_AGIDL_p_dX=0.0;
  double ALP1_p=0.0;
double d_ALP1_p_dX=0.0;
  double ALP_p=0.0;
double d_ALP_p_dX=0.0;
  double AX_p=0.0;
double d_AX_p_dX=0.0;
  double THESAT_p=0.0;
double d_THESAT_p_dX=0.0;
  double RS_p=0.0;
double d_RS_p_dX=0.0;
  double CS_p=0.0;
double d_CS_p_dX=0.0;
  double BETN_p=0.0;
double d_BETN_p_dX=0.0;
  double GE=0.0;
double d_GE_dX=0.0;
  double GWE=0.0;
double d_GWE_dX=0.0;
  double GPE=0.0;
double d_GPE_dX=0.0;
  double CF_p=0.0;
double d_CF_p_dX=0.0;
  double PNCE_p=0.0;
double d_PNCE_p_dX=0.0;
  double PSCE_p=0.0;
double d_PSCE_p_dX=0.0;
  double lambda_LE=0.0;
double d_lambda_LE_dX=0.0;
  double wphy=0.0;
double d_wphy_dX=0.0;
  double lphy=0.0;
double d_lphy_dX=0.0;
  double iAE=0.0;
double d_iAE_dX=0.0;
  double iWE=0.0;
double d_iWE_dX=0.0;
  double iLE=0.0;
double d_iLE_dX=0.0;
  double WEcv=0.0;
double d_WEcv_dX=0.0;
  double LEcv=0.0;
double d_LEcv_dX=0.0;
  double WE=0.0;
double d_WE_dX=0.0;
  double LE=0.0;
double d_LE_dX=0.0;
  double delWOD=0.0;
double d_delWOD_dX=0.0;
  double delLPS=0.0;
double d_delLPS_dX=0.0;
  double iW=0.0;
double d_iW_dX=0.0;
  double iL=0.0;
double d_iL_dX=0.0;
  double WEN=0.0;
  double LEN=0.0;
  double W_i=0.0;
double d_W_i_dX=0.0;
  double invNF=0.0;
double d_invNF_dX=0.0;
//Begin block initial_instance
{
instanceStruct.instanceVar_DTC = 0.0;
instanceStruct.instanceVar_TKC = modelStruct.modelVar_TKD;
instanceStruct.instanceVar_TKC_sq = (instanceStruct.instanceVar_TKC*instanceStruct.instanceVar_TKC);
instanceStruct.d_instanceVar_dT_dX = (-modelStruct.d_modelVar_TKR_dX);
instanceStruct.instanceVar_dT = (instanceStruct.instanceVar_TKC-modelStruct.modelVar_TKR);
instanceStruct.d_instanceVar_rT_dX = (-instanceStruct.instanceVar_TKC*modelStruct.d_modelVar_TKR_dX/modelStruct.modelVar_TKR/modelStruct.modelVar_TKR);
instanceStruct.instanceVar_rT = (instanceStruct.instanceVar_TKC/modelStruct.modelVar_TKR);
instanceStruct.d_instanceVar_rTn_dX = (modelStruct.d_modelVar_TKR_dX/instanceStruct.instanceVar_TKC);
instanceStruct.instanceVar_rTn = (modelStruct.modelVar_TKR/instanceStruct.instanceVar_TKC);
instanceStruct.instanceVar_phit0 = (instanceStruct.instanceVar_TKC*8.617332384961E-05);
instanceStruct.instanceVar_inv_phit0 = (1.0/instanceStruct.instanceVar_phit0);
if ((modelStruct.modelPar_SWSCALE==0))
{
instanceStruct.d_instanceVar_ADRAIN_i_dX = instanceStruct.d_instancePar_ADRAIN_dX;
instanceStruct.instanceVar_ADRAIN_i = instanceStruct.instancePar_ADRAIN;
instanceStruct.d_instanceVar_ASOURCE_i_dX = instanceStruct.d_instancePar_ASOURCE_dX;
instanceStruct.instanceVar_ASOURCE_i = instanceStruct.instancePar_ASOURCE;
instanceStruct.d_instanceVar_PDRAIN_i_dX = instanceStruct.d_instancePar_PDRAIN_dX;
instanceStruct.instanceVar_PDRAIN_i = instanceStruct.instancePar_PDRAIN;
instanceStruct.d_instanceVar_PSOURCE_i_dX = instanceStruct.d_instancePar_PSOURCE_dX;
instanceStruct.instanceVar_PSOURCE_i = instanceStruct.instancePar_PSOURCE;
instanceStruct.d_instanceVar_MULT_i_dX = 0.0;
instanceStruct.instanceVar_MULT_i = instanceStruct.instancePar_MULT;
d_TOX1_i_dX = modelStruct.d_modelPar_TOXE_dX;
TOX1_i = modelStruct.modelPar_TOXE;
instanceStruct.d_instanceVar_TSI_i_dX = modelStruct.d_modelPar_TSI_dX;
instanceStruct.instanceVar_TSI_i = modelStruct.modelPar_TSI;
instanceStruct.d_instanceVar_XGE_i_dX = modelStruct.d_modelPar_XGE_dX;
instanceStruct.instanceVar_XGE_i = modelStruct.modelPar_XGE;
d_TOX2_i_dX = modelStruct.d_modelPar_TBOX_dX;
TOX2_i = modelStruct.modelPar_TBOX;
TYPECH_i = 1.0;
if ((modelStruct.modelPar_NCH<0))
{
TYPECH_i = (-1.0);
}
{
double value_fabs_0 = fabs(modelStruct.modelPar_NCH);
double value_min_1 = std::min(value_fabs_0,static_cast<double>(1.0e19));
double  deriv_fabs_0_d0 = (((modelStruct.modelPar_NCH)>=0)?(+1.0):(-1.0));
double  deriv_min_1_d0 = ((value_fabs_0<=1.0e19)?1.0:0.0);
d_NCH_i_dX = (deriv_min_1_d0*(deriv_fabs_0_d0*(modelStruct.d_modelPar_NCH_dX)))*1.0e6;
NCH_i = (value_min_1*1.0e6);
}
instanceStruct.instanceVar_TYPESUB_i = 1.0;
if ((modelStruct.modelPar_NSUB<0))
{
instanceStruct.instanceVar_TYPESUB_i = (-1.0);
}
{
double value_fabs_0 = fabs(modelStruct.modelPar_NSUB);
double value_max_1 = std::max(value_fabs_0,static_cast<double>(1.0e16));
double value_min_2 = std::min(value_max_1,static_cast<double>(1.0e21));
double  deriv_fabs_0_d0 = (((modelStruct.modelPar_NSUB)>=0)?(+1.0):(-1.0));
double  deriv_max_1_d0 = ((value_fabs_0>=1.0e16)?1.0:0.0);
double  deriv_min_2_d0 = ((value_max_1<=1.0e21)?1.0:0.0);
d_NSUB_i_dX = (deriv_min_2_d0*((deriv_max_1_d0*(deriv_fabs_0_d0*(modelStruct.d_modelPar_NSUB_dX)))))*1.0e6;
NSUB_i = (value_min_2*1.0e6);
}
instanceStruct.d_instanceVar_CT_i_dX = modelStruct.d_modelPar_CT_dX;
instanceStruct.instanceVar_CT_i = modelStruct.modelPar_CT;
instanceStruct.d_instanceVar_TOXP_i_dX = modelStruct.d_modelPar_TOXP_dX;
instanceStruct.instanceVar_TOXP_i = modelStruct.modelPar_TOXP;
instanceStruct.d_instanceVar_NOV_i_dX = modelStruct.d_modelPar_NOV_dX*1.0e6;
instanceStruct.instanceVar_NOV_i = (modelStruct.modelPar_NOV*1.0e6);
instanceStruct.d_instanceVar_NOVD_i_dX = modelStruct.d_modelPar_NOVD_dX*1.0e6;
instanceStruct.instanceVar_NOVD_i = (modelStruct.modelPar_NOVD*1.0e6);
instanceStruct.d_instanceVar_VFB1_t_dX = modelStruct.d_modelPar_VFB_dX;
instanceStruct.instanceVar_VFB1_t = modelStruct.modelPar_VFB;
instanceStruct.d_instanceVar_VFB2_t_dX = modelStruct.d_modelPar_VFBB_dX;
instanceStruct.instanceVar_VFB2_t = modelStruct.modelPar_VFBB;
instanceStruct.d_instanceVar_STVFB_i_dX = modelStruct.d_modelPar_STVFB_dX;
instanceStruct.instanceVar_STVFB_i = modelStruct.modelPar_STVFB;
instanceStruct.d_instanceVar_CIC1_i_dX = modelStruct.d_modelPar_CICF_dX;
instanceStruct.instanceVar_CIC1_i = modelStruct.modelPar_CICF;
instanceStruct.d_instanceVar_CIC2_i_dX = modelStruct.d_modelPar_CIC_dX;
instanceStruct.instanceVar_CIC2_i = modelStruct.modelPar_CIC;
instanceStruct.d_instanceVar_PSCE1_i_dX = modelStruct.d_modelPar_PSCE_dX;
instanceStruct.instanceVar_PSCE1_i = modelStruct.modelPar_PSCE;
instanceStruct.d_instanceVar_PSCE2_i_dX = ((TOX1_i*((modelStruct.modelPar_PSCEB*instanceStruct.instanceVar_PSCE1_i)*d_TOX2_i_dX+(modelStruct.modelPar_PSCEB*instanceStruct.d_instanceVar_PSCE1_i_dX+modelStruct.d_modelPar_PSCEB_dX*instanceStruct.instanceVar_PSCE1_i)*TOX2_i)-((modelStruct.modelPar_PSCEB*instanceStruct.instanceVar_PSCE1_i)*TOX2_i)*d_TOX1_i_dX)/TOX1_i/TOX1_i);
instanceStruct.instanceVar_PSCE2_i = (((modelStruct.modelPar_PSCEB*instanceStruct.instanceVar_PSCE1_i)*TOX2_i)/TOX1_i);
instanceStruct.d_instanceVar_NSDDC_i_dX = modelStruct.d_modelPar_NSDDC_dX*1.0e6;
instanceStruct.instanceVar_NSDDC_i = (modelStruct.modelPar_NSDDC*1.0e6);
instanceStruct.d_instanceVar_PSCEDLB_i_dX = modelStruct.d_modelPar_PSCEDLB_dX;
instanceStruct.instanceVar_PSCEDLB_i = modelStruct.modelPar_PSCEDLB;
d_PNCE_i_dX = modelStruct.d_modelPar_PNCE_dX;
PNCE_i = modelStruct.modelPar_PNCE;
instanceStruct.d_instanceVar_CF1_t_dX = modelStruct.d_modelPar_CF_dX;
instanceStruct.instanceVar_CF1_t = modelStruct.modelPar_CF;
instanceStruct.d_instanceVar_CF2_t_dX = ((TOX1_i*((modelStruct.modelPar_CFB*instanceStruct.instanceVar_CF1_t)*d_TOX2_i_dX+(modelStruct.modelPar_CFB*instanceStruct.d_instanceVar_CF1_t_dX+modelStruct.d_modelPar_CFB_dX*instanceStruct.instanceVar_CF1_t)*TOX2_i)-((modelStruct.modelPar_CFB*instanceStruct.instanceVar_CF1_t)*TOX2_i)*d_TOX1_i_dX)/TOX1_i/TOX1_i);
instanceStruct.instanceVar_CF2_t = (((modelStruct.modelPar_CFB*instanceStruct.instanceVar_CF1_t)*TOX2_i)/TOX1_i);
instanceStruct.d_instanceVar_STCF_i_dX = modelStruct.d_modelPar_STCF_dX;
instanceStruct.instanceVar_STCF_i = modelStruct.modelPar_STCF;
instanceStruct.d_instanceVar_CFD_i_dX = modelStruct.d_modelPar_CFD_dX;
instanceStruct.instanceVar_CFD_i = modelStruct.modelPar_CFD;
instanceStruct.d_instanceVar_CFDL_i_dX = modelStruct.d_modelPar_CFDL_dX;
instanceStruct.instanceVar_CFDL_i = modelStruct.modelPar_CFDL;
instanceStruct.d_instanceVar_CFDLB_i_dX = modelStruct.d_modelPar_CFDLB_dX;
instanceStruct.instanceVar_CFDLB_i = modelStruct.modelPar_CFDLB;
instanceStruct.d_instanceVar_BETN1_t_dX = modelStruct.d_modelPar_BETN_dX;
instanceStruct.instanceVar_BETN1_t = modelStruct.modelPar_BETN;
instanceStruct.d_instanceVar_BETN2_t_dX = (modelStruct.modelPar_BETNB*instanceStruct.d_instanceVar_BETN1_t_dX+modelStruct.d_modelPar_BETNB_dX*instanceStruct.instanceVar_BETN1_t);
instanceStruct.instanceVar_BETN2_t = (modelStruct.modelPar_BETNB*instanceStruct.instanceVar_BETN1_t);
instanceStruct.d_instanceVar_STBET_i_dX = modelStruct.d_modelPar_STBET_dX;
instanceStruct.instanceVar_STBET_i = modelStruct.modelPar_STBET;
instanceStruct.d_instanceVar_CS_t_dX = modelStruct.d_modelPar_CS_dX;
instanceStruct.instanceVar_CS_t = modelStruct.modelPar_CS;
instanceStruct.d_instanceVar_CSFI_i_dX = modelStruct.d_modelPar_CSFI_dX;
instanceStruct.instanceVar_CSFI_i = modelStruct.modelPar_CSFI;
instanceStruct.d_instanceVar_CSBI_i_dX = modelStruct.d_modelPar_CSBI_dX;
instanceStruct.instanceVar_CSBI_i = modelStruct.modelPar_CSBI;
instanceStruct.d_instanceVar_STCS_i_dX = modelStruct.d_modelPar_STCS_dX;
instanceStruct.instanceVar_STCS_i = modelStruct.modelPar_STCS;
instanceStruct.d_instanceVar_THECS_t_dX = modelStruct.d_modelPar_THECS_dX;
instanceStruct.instanceVar_THECS_t = modelStruct.modelPar_THECS;
instanceStruct.d_instanceVar_STTHECS_i_dX = modelStruct.d_modelPar_STTHECS_dX;
instanceStruct.instanceVar_STTHECS_i = modelStruct.modelPar_STTHECS;
d_CSTHR_i_dX = modelStruct.d_modelPar_CSTHR_dX;
CSTHR_i = modelStruct.modelPar_CSTHR;
d_CSTHRB_i_dX = modelStruct.d_modelPar_CSTHRB_dX;
CSTHRB_i = modelStruct.modelPar_CSTHRB;
instanceStruct.d_instanceVar_MUE_t_dX = modelStruct.d_modelPar_MUE_dX;
instanceStruct.instanceVar_MUE_t = modelStruct.modelPar_MUE;
instanceStruct.d_instanceVar_STMUE_i_dX = modelStruct.d_modelPar_STMUE_dX;
instanceStruct.instanceVar_STMUE_i = modelStruct.modelPar_STMUE;
instanceStruct.d_instanceVar_THEMU_t_dX = modelStruct.d_modelPar_THEMU_dX;
instanceStruct.instanceVar_THEMU_t = modelStruct.modelPar_THEMU;
instanceStruct.d_instanceVar_STTHEMU_i_dX = modelStruct.d_modelPar_STTHEMU_dX;
instanceStruct.instanceVar_STTHEMU_i = modelStruct.modelPar_STTHEMU;
instanceStruct.d_instanceVar_XCOR_t_dX = modelStruct.d_modelPar_XCOR_dX;
instanceStruct.instanceVar_XCOR_t = modelStruct.modelPar_XCOR;
instanceStruct.d_instanceVar_XCORB_i_dX = modelStruct.d_modelPar_XCORB_dX;
instanceStruct.instanceVar_XCORB_i = modelStruct.modelPar_XCORB;
instanceStruct.d_instanceVar_STXCOR_i_dX = modelStruct.d_modelPar_STXCOR_dX;
instanceStruct.instanceVar_STXCOR_i = modelStruct.modelPar_STXCOR;
d_FETA_i_dX = modelStruct.d_modelPar_FETA_dX;
FETA_i = modelStruct.modelPar_FETA;
instanceStruct.d_instanceVar_RS_t_dX = modelStruct.d_modelPar_RS_dX;
instanceStruct.instanceVar_RS_t = modelStruct.modelPar_RS;
instanceStruct.d_instanceVar_RSIG_i_dX = modelStruct.d_modelPar_RSIG_dX;
instanceStruct.instanceVar_RSIG_i = modelStruct.modelPar_RSIG;
instanceStruct.d_instanceVar_STRS_i_dX = modelStruct.d_modelPar_STRS_dX;
instanceStruct.instanceVar_STRS_i = modelStruct.modelPar_STRS;
instanceStruct.d_instanceVar_RSG_i_dX = modelStruct.d_modelPar_RSG_dX;
instanceStruct.instanceVar_RSG_i = modelStruct.modelPar_RSG;
instanceStruct.d_instanceVar_THERSG_i_dX = modelStruct.d_modelPar_THERSG_dX;
instanceStruct.instanceVar_THERSG_i = modelStruct.modelPar_THERSG;
instanceStruct.d_instanceVar_RSB_i_dX = modelStruct.d_modelPar_RSB_dX;
instanceStruct.instanceVar_RSB_i = modelStruct.modelPar_RSB;
instanceStruct.d_instanceVar_THESAT_t_dX = modelStruct.d_modelPar_THESAT_dX;
instanceStruct.instanceVar_THESAT_t = modelStruct.modelPar_THESAT;
instanceStruct.d_instanceVar_STTHESAT_i_dX = modelStruct.d_modelPar_STTHESAT_dX;
instanceStruct.instanceVar_STTHESAT_i = modelStruct.modelPar_STTHESAT;
instanceStruct.d_instanceVar_THESAT1_i_dX = modelStruct.d_modelPar_THESATG_dX;
instanceStruct.instanceVar_THESAT1_i = modelStruct.modelPar_THESATG;
instanceStruct.d_instanceVar_THESAT2_i_dX = modelStruct.d_modelPar_THESATB_dX;
instanceStruct.instanceVar_THESAT2_i = modelStruct.modelPar_THESATB;
d_AX_i_dX = modelStruct.d_modelPar_AX_dX;
AX_i = modelStruct.modelPar_AX;
instanceStruct.d_instanceVar_ALP_i_dX = modelStruct.d_modelPar_ALP_dX;
instanceStruct.instanceVar_ALP_i = modelStruct.modelPar_ALP;
instanceStruct.d_instanceVar_ALP1_i_dX = modelStruct.d_modelPar_ALP1_dX;
instanceStruct.instanceVar_ALP1_i = modelStruct.modelPar_ALP1;
instanceStruct.d_instanceVar_ALPB_i_dX = modelStruct.d_modelPar_ALPB_dX;
instanceStruct.instanceVar_ALPB_i = modelStruct.modelPar_ALPB;
instanceStruct.d_instanceVar_VP_i_dX = modelStruct.d_modelPar_VP_dX;
instanceStruct.instanceVar_VP_i = modelStruct.modelPar_VP;
instanceStruct.d_instanceVar_VPG_i_dX = modelStruct.d_modelPar_VPG_dX;
instanceStruct.instanceVar_VPG_i = modelStruct.modelPar_VPG;
instanceStruct.d_instanceVar_GCO_i_dX = modelStruct.d_modelPar_GCO_dX;
instanceStruct.instanceVar_GCO_i = modelStruct.modelPar_GCO;
instanceStruct.d_instanceVar_IGINV_t_dX = modelStruct.d_modelPar_IGINV_dX;
instanceStruct.instanceVar_IGINV_t = modelStruct.modelPar_IGINV;
instanceStruct.d_instanceVar_IGOVINV_t_dX = modelStruct.d_modelPar_IGOVINV_dX;
instanceStruct.instanceVar_IGOVINV_t = modelStruct.modelPar_IGOVINV;
instanceStruct.d_instanceVar_IGOVINVD_t_dX = modelStruct.d_modelPar_IGOVINVD_dX;
instanceStruct.instanceVar_IGOVINVD_t = modelStruct.modelPar_IGOVINVD;
instanceStruct.d_instanceVar_FNOVINV_t_dX = modelStruct.d_modelPar_FNOVINV_dX;
instanceStruct.instanceVar_FNOVINV_t = modelStruct.modelPar_FNOVINV;
instanceStruct.d_instanceVar_FNOVINVD_t_dX = modelStruct.d_modelPar_FNOVINVD_dX;
instanceStruct.instanceVar_FNOVINVD_t = modelStruct.modelPar_FNOVINVD;
instanceStruct.d_instanceVar_IGOVACC_t_dX = modelStruct.d_modelPar_IGOVACC_dX;
instanceStruct.instanceVar_IGOVACC_t = modelStruct.modelPar_IGOVACC;
instanceStruct.d_instanceVar_IGOVACCD_t_dX = modelStruct.d_modelPar_IGOVACCD_dX;
instanceStruct.instanceVar_IGOVACCD_t = modelStruct.modelPar_IGOVACCD;
instanceStruct.d_instanceVar_STIG_i_dX = modelStruct.d_modelPar_STIG_dX;
instanceStruct.instanceVar_STIG_i = modelStruct.modelPar_STIG;
instanceStruct.d_instanceVar_STIGFN_i_dX = modelStruct.d_modelPar_STIGFN_dX;
instanceStruct.instanceVar_STIGFN_i = modelStruct.modelPar_STIGFN;
instanceStruct.d_instanceVar_GC2CH_i_dX = modelStruct.d_modelPar_GC2CH_dX;
instanceStruct.instanceVar_GC2CH_i = modelStruct.modelPar_GC2CH;
instanceStruct.d_instanceVar_GC3CH_i_dX = modelStruct.d_modelPar_GC3CH_dX;
instanceStruct.instanceVar_GC3CH_i = modelStruct.modelPar_GC3CH;
instanceStruct.d_instanceVar_GC2OVINV_i_dX = modelStruct.d_modelPar_GC2OVINV_dX;
instanceStruct.instanceVar_GC2OVINV_i = modelStruct.modelPar_GC2OVINV;
instanceStruct.d_instanceVar_GCOVINVFN_i_dX = modelStruct.d_modelPar_GCOVINVFN_dX;
instanceStruct.instanceVar_GCOVINVFN_i = modelStruct.modelPar_GCOVINVFN;
instanceStruct.d_instanceVar_GC3OVINV_i_dX = modelStruct.d_modelPar_GC3OVINV_dX;
instanceStruct.instanceVar_GC3OVINV_i = modelStruct.modelPar_GC3OVINV;
instanceStruct.d_instanceVar_GC2OVACC_i_dX = modelStruct.d_modelPar_GC2OVACC_dX;
instanceStruct.instanceVar_GC2OVACC_i = modelStruct.modelPar_GC2OVACC;
instanceStruct.d_instanceVar_GC3OVACC_i_dX = modelStruct.d_modelPar_GC3OVACC_dX;
instanceStruct.instanceVar_GC3OVACC_i = modelStruct.modelPar_GC3OVACC;
instanceStruct.d_instanceVar_GCDOV_i_dX = modelStruct.d_modelPar_GCDOV_dX;
instanceStruct.instanceVar_GCDOV_i = modelStruct.modelPar_GCDOV;
instanceStruct.d_instanceVar_GCVDOV_i_dX = modelStruct.d_modelPar_GCVDOV_dX;
instanceStruct.instanceVar_GCVDOV_i = modelStruct.modelPar_GCVDOV;
instanceStruct.d_instanceVar_CHIB_i_dX = modelStruct.d_modelPar_CHIB_dX;
instanceStruct.instanceVar_CHIB_i = modelStruct.modelPar_CHIB;
instanceStruct.d_instanceVar_NIGINV_i_dX = modelStruct.d_modelPar_NIGINV_dX;
instanceStruct.instanceVar_NIGINV_i = modelStruct.modelPar_NIGINV;
instanceStruct.d_instanceVar_AGIDL_i_dX = modelStruct.d_modelPar_AGIDL_dX;
instanceStruct.instanceVar_AGIDL_i = modelStruct.modelPar_AGIDL;
instanceStruct.d_instanceVar_AGIDLD_i_dX = modelStruct.d_modelPar_AGIDLD_dX;
instanceStruct.instanceVar_AGIDLD_i = modelStruct.modelPar_AGIDLD;
instanceStruct.d_instanceVar_BGIDL_t_dX = modelStruct.d_modelPar_BGIDL_dX;
instanceStruct.instanceVar_BGIDL_t = modelStruct.modelPar_BGIDL;
instanceStruct.d_instanceVar_BGIDLD_t_dX = modelStruct.d_modelPar_BGIDLD_dX;
instanceStruct.instanceVar_BGIDLD_t = modelStruct.modelPar_BGIDLD;
instanceStruct.d_instanceVar_STBGIDL_i_dX = modelStruct.d_modelPar_STBGIDL_dX;
instanceStruct.instanceVar_STBGIDL_i = modelStruct.modelPar_STBGIDL;
instanceStruct.d_instanceVar_STBGIDLD_i_dX = modelStruct.d_modelPar_STBGIDLD_dX;
instanceStruct.instanceVar_STBGIDLD_i = modelStruct.modelPar_STBGIDLD;
instanceStruct.d_instanceVar_CGIDL_i_dX = modelStruct.d_modelPar_CGIDL_dX;
instanceStruct.instanceVar_CGIDL_i = modelStruct.modelPar_CGIDL;
instanceStruct.d_instanceVar_CGIDLD_i_dX = modelStruct.d_modelPar_CGIDLD_dX;
instanceStruct.instanceVar_CGIDLD_i = modelStruct.modelPar_CGIDLD;
instanceStruct.d_instanceVar_DGIDL_i_dX = modelStruct.d_modelPar_DGIDL_dX;
instanceStruct.instanceVar_DGIDL_i = modelStruct.modelPar_DGIDL;
instanceStruct.d_instanceVar_DGIDLD_i_dX = modelStruct.d_modelPar_DGIDLD_dX;
instanceStruct.instanceVar_DGIDLD_i = modelStruct.modelPar_DGIDLD;
instanceStruct.d_instanceVar_A1_i_dX = modelStruct.d_modelPar_A1_dX;
instanceStruct.instanceVar_A1_i = modelStruct.modelPar_A1;
instanceStruct.d_instanceVar_A2_t_dX = modelStruct.d_modelPar_A2_dX;
instanceStruct.instanceVar_A2_t = modelStruct.modelPar_A2;
instanceStruct.d_instanceVar_STA2_i_dX = modelStruct.d_modelPar_STA2_dX;
instanceStruct.instanceVar_STA2_i = modelStruct.modelPar_STA2;
instanceStruct.d_instanceVar_A3_i_dX = modelStruct.d_modelPar_A3_dX;
instanceStruct.instanceVar_A3_i = modelStruct.modelPar_A3;
instanceStruct.d_instanceVar_AREAQ_i_dX = modelStruct.d_modelPar_AREAQ_dX;
instanceStruct.instanceVar_AREAQ_i = modelStruct.modelPar_AREAQ;
instanceStruct.d_instanceVar_CGBOV_i_dX = modelStruct.d_modelPar_CGBOV_dX;
instanceStruct.instanceVar_CGBOV_i = modelStruct.modelPar_CGBOV;
instanceStruct.d_instanceVar_NSDAC_i_dX = modelStruct.d_modelPar_NSDAC_dX*1.0e6;
instanceStruct.instanceVar_NSDAC_i = (modelStruct.modelPar_NSDAC*1.0e6);
instanceStruct.d_instanceVar_FIF_i_dX = modelStruct.d_modelPar_FIF_dX;
instanceStruct.instanceVar_FIF_i = modelStruct.modelPar_FIF;
instanceStruct.d_instanceVar_FSCEAC_i_dX = modelStruct.d_modelPar_FSCEAC_dX;
instanceStruct.instanceVar_FSCEAC_i = modelStruct.modelPar_FSCEAC;
instanceStruct.d_instanceVar_COV_i_dX = modelStruct.d_modelPar_COV_dX;
instanceStruct.instanceVar_COV_i = modelStruct.modelPar_COV;
instanceStruct.d_instanceVar_COVD_i_dX = modelStruct.d_modelPar_COVD_dX;
instanceStruct.instanceVar_COVD_i = modelStruct.modelPar_COVD;
instanceStruct.d_instanceVar_COVDL_i_dX = modelStruct.d_modelPar_COVDL_dX;
instanceStruct.instanceVar_COVDL_i = modelStruct.modelPar_COVDL;
instanceStruct.d_instanceVar_COVDLB_i_dX = modelStruct.d_modelPar_COVDLB_dX;
instanceStruct.instanceVar_COVDLB_i = modelStruct.modelPar_COVDLB;
instanceStruct.d_instanceVar_DVFBOV_i_dX = modelStruct.d_modelPar_DVFBOV_dX;
instanceStruct.instanceVar_DVFBOV_i = modelStruct.modelPar_DVFBOV;
instanceStruct.d_instanceVar_CFR_i_dX = modelStruct.d_modelPar_CFR_dX;
instanceStruct.instanceVar_CFR_i = modelStruct.modelPar_CFR;
instanceStruct.d_instanceVar_CFRD_i_dX = modelStruct.d_modelPar_CFRD_dX;
instanceStruct.instanceVar_CFRD_i = modelStruct.modelPar_CFRD;
instanceStruct.d_instanceVar_CSD_i_dX = modelStruct.d_modelPar_CSD_dX;
instanceStruct.instanceVar_CSD_i = modelStruct.modelPar_CSD;
instanceStruct.d_instanceVar_CSDBP_i_dX = modelStruct.d_modelPar_CSDBP_dX;
instanceStruct.instanceVar_CSDBP_i = modelStruct.modelPar_CSDBP;
instanceStruct.d_instanceVar_RTH_t_dX = modelStruct.d_modelPar_RTH_dX;
instanceStruct.instanceVar_RTH_t = modelStruct.modelPar_RTH;
instanceStruct.d_instanceVar_STRTH_i_dX = modelStruct.d_modelPar_STRTH_dX;
instanceStruct.instanceVar_STRTH_i = modelStruct.modelPar_STRTH;
instanceStruct.d_instanceVar_CTH_i_dX = modelStruct.d_modelPar_CTH_dX;
instanceStruct.instanceVar_CTH_i = modelStruct.modelPar_CTH;
instanceStruct.d_instanceVar_FNT_i_dX = modelStruct.d_modelPar_FNT_dX;
instanceStruct.instanceVar_FNT_i = modelStruct.modelPar_FNT;
instanceStruct.d_instanceVar_FNTEXC_i_dX = modelStruct.d_modelPar_FNTEXC_dX;
instanceStruct.instanceVar_FNTEXC_i = modelStruct.modelPar_FNTEXC;
instanceStruct.d_instanceVar_NFA_i_dX = modelStruct.d_modelPar_NFA_dX;
instanceStruct.instanceVar_NFA_i = modelStruct.modelPar_NFA;
instanceStruct.d_instanceVar_NFB_i_dX = modelStruct.d_modelPar_NFB_dX;
instanceStruct.instanceVar_NFB_i = modelStruct.modelPar_NFB;
instanceStruct.d_instanceVar_NFC_i_dX = modelStruct.d_modelPar_NFC_dX;
instanceStruct.instanceVar_NFC_i = modelStruct.modelPar_NFC;
instanceStruct.d_instanceVar_NFE_i_dX = modelStruct.d_modelPar_NFE_dX;
instanceStruct.instanceVar_NFE_i = modelStruct.modelPar_NFE;
instanceStruct.d_instanceVar_NFEB_i_dX = modelStruct.d_modelPar_NFEB_dX;
instanceStruct.instanceVar_NFEB_i = modelStruct.modelPar_NFEB;
instanceStruct.d_instanceVar_EF_i_dX = modelStruct.d_modelPar_EF_dX;
instanceStruct.instanceVar_EF_i = modelStruct.modelPar_EF;
}
else
{
d_invNF_dX = 0.0;
invNF = (1.0/instanceStruct.instancePar_NF);
{
double value_max_0 = std::max((instanceStruct.instancePar_W*invNF),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = (((instanceStruct.instancePar_W*invNF)>=1.0e-9)?1.0:0.0);
d_W_i_dX = (deriv_max_0_d0*((instanceStruct.instancePar_W*d_invNF_dX+instanceStruct.d_instancePar_W_dX*invNF)));
W_i = value_max_0;
}
instanceStruct.d_instanceVar_ADRAIN_i_dX = (instanceStruct.instancePar_ADRAIN*d_invNF_dX+instanceStruct.d_instancePar_ADRAIN_dX*invNF);
instanceStruct.instanceVar_ADRAIN_i = (instanceStruct.instancePar_ADRAIN*invNF);
instanceStruct.d_instanceVar_ASOURCE_i_dX = (instanceStruct.instancePar_ASOURCE*d_invNF_dX+instanceStruct.d_instancePar_ASOURCE_dX*invNF);
instanceStruct.instanceVar_ASOURCE_i = (instanceStruct.instancePar_ASOURCE*invNF);
instanceStruct.d_instanceVar_PDRAIN_i_dX = (instanceStruct.instancePar_PDRAIN*d_invNF_dX+instanceStruct.d_instancePar_PDRAIN_dX*invNF);
instanceStruct.instanceVar_PDRAIN_i = (instanceStruct.instancePar_PDRAIN*invNF);
instanceStruct.d_instanceVar_PSOURCE_i_dX = (instanceStruct.instancePar_PSOURCE*d_invNF_dX+instanceStruct.d_instancePar_PSOURCE_dX*invNF);
instanceStruct.instanceVar_PSOURCE_i = (instanceStruct.instancePar_PSOURCE*invNF);
instanceStruct.d_instanceVar_MULT_i_dX = 0.0;
instanceStruct.instanceVar_MULT_i = (instanceStruct.instancePar_MULT*instanceStruct.instancePar_NF);
LEN = 1.0e-6;
WEN = 1.0e-6;
d_iL_dX = (-LEN*instanceStruct.d_instancePar_L_dX/instanceStruct.instancePar_L/instanceStruct.instancePar_L);
iL = (LEN/instanceStruct.instancePar_L);
d_iW_dX = (-WEN*d_W_i_dX/W_i/W_i);
iW = (WEN/W_i);
d_delLPS_dX = ((modelStruct.modelPar_LVARO*(1.0+(modelStruct.modelPar_LVARL*iL)))*(modelStruct.modelPar_LVARW*d_iW_dX+modelStruct.d_modelPar_LVARW_dX*iW)+(modelStruct.modelPar_LVARO*(modelStruct.modelPar_LVARL*d_iL_dX+modelStruct.d_modelPar_LVARL_dX*iL)+modelStruct.d_modelPar_LVARO_dX*(1.0+(modelStruct.modelPar_LVARL*iL)))*(1.0+(modelStruct.modelPar_LVARW*iW)));
delLPS = ((modelStruct.modelPar_LVARO*(1.0+(modelStruct.modelPar_LVARL*iL)))*(1.0+(modelStruct.modelPar_LVARW*iW)));
d_delWOD_dX = ((modelStruct.modelPar_WVARO*(1.0+(modelStruct.modelPar_WVARW*iW)))*(modelStruct.modelPar_WVARL*d_iL_dX+modelStruct.d_modelPar_WVARL_dX*iL)+(modelStruct.modelPar_WVARO*(modelStruct.modelPar_WVARW*d_iW_dX+modelStruct.d_modelPar_WVARW_dX*iW)+modelStruct.d_modelPar_WVARO_dX*(1.0+(modelStruct.modelPar_WVARW*iW)))*(1.0+(modelStruct.modelPar_WVARL*iL)));
delWOD = ((modelStruct.modelPar_WVARO*(1.0+(modelStruct.modelPar_WVARW*iW)))*(1.0+(modelStruct.modelPar_WVARL*iL)));
{
double value_max_0 = std::max(((instanceStruct.instancePar_L+delLPS)-(2.0*modelStruct.modelPar_LAP)),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = ((((instanceStruct.instancePar_L+delLPS)-(2.0*modelStruct.modelPar_LAP))>=1.0e-9)?1.0:0.0);
d_LE_dX = (deriv_max_0_d0*(((instanceStruct.d_instancePar_L_dX+d_delLPS_dX)-2.0*modelStruct.d_modelPar_LAP_dX)));
LE = value_max_0;
}
{
double value_max_0 = std::max(((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT)),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = ((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))>=1.0e-9)?1.0:0.0);
d_WE_dX = (deriv_max_0_d0*(((d_W_i_dX+d_delWOD_dX)-2.0*modelStruct.d_modelPar_WOT_dX)));
WE = value_max_0;
}
{
double value_max_0 = std::max((((instanceStruct.instancePar_L+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = (((((instanceStruct.instancePar_L+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ)>=1.0e-9)?1.0:0.0);
d_LEcv_dX = (deriv_max_0_d0*((((instanceStruct.d_instancePar_L_dX+d_delLPS_dX)-2.0*modelStruct.d_modelPar_LAP_dX)+modelStruct.d_modelPar_DLQ_dX)));
LEcv = value_max_0;
}
{
double value_max_0 = std::max((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = (((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ)>=1.0e-9)?1.0:0.0);
d_WEcv_dX = (deriv_max_0_d0*((((d_W_i_dX+d_delWOD_dX)-2.0*modelStruct.d_modelPar_WOT_dX)+modelStruct.d_modelPar_DWQ_dX)));
WEcv = value_max_0;
}
d_iLE_dX = (-LEN*d_LE_dX/LE/LE);
iLE = (LEN/LE);
d_iWE_dX = (-WEN*d_WE_dX/WE/WE);
iWE = (WEN/WE);
d_iAE_dX = (iLE*d_iWE_dX+d_iLE_dX*iWE);
iAE = (iLE*iWE);
{
double value_max_0 = std::max((instanceStruct.instancePar_L+delLPS),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = (((instanceStruct.instancePar_L+delLPS)>=1.0e-9)?1.0:0.0);
instanceStruct.d_instanceVar_temp_dX = (deriv_max_0_d0*((instanceStruct.d_instancePar_L_dX+d_delLPS_dX)));
instanceStruct.instanceVar_temp = value_max_0;
}
d_lphy_dX = (instanceStruct.d_instanceVar_temp_dX/LEN);
lphy = (instanceStruct.instanceVar_temp/LEN);
{
double value_max_0 = std::max((W_i+delWOD),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = (((W_i+delWOD)>=1.0e-9)?1.0:0.0);
instanceStruct.d_instanceVar_temp_dX = (deriv_max_0_d0*((d_W_i_dX+d_delWOD_dX)));
instanceStruct.instanceVar_temp = value_max_0;
}
d_wphy_dX = (instanceStruct.d_instanceVar_temp_dX/WEN);
wphy = (instanceStruct.instanceVar_temp/WEN);
d_TOX1_i_dX = modelStruct.d_modelPar_TOXEO_dX;
TOX1_i = modelStruct.modelPar_TOXEO;
instanceStruct.d_instanceVar_TSI_i_dX = modelStruct.d_modelPar_TSIO_dX;
instanceStruct.instanceVar_TSI_i = modelStruct.modelPar_TSIO;
instanceStruct.d_instanceVar_XGE_i_dX = modelStruct.d_modelPar_XGEO_dX;
instanceStruct.instanceVar_XGE_i = modelStruct.modelPar_XGEO;
d_TOX2_i_dX = modelStruct.d_modelPar_TBOXO_dX;
TOX2_i = modelStruct.modelPar_TBOXO;
TYPECH_i = 1.0;
if ((modelStruct.modelPar_NCHO<0))
{
TYPECH_i = (-1.0);
}
{
double value_fabs_0 = fabs(modelStruct.modelPar_NCHO);
double value_min_1 = std::min(value_fabs_0,static_cast<double>(1.0e19));
double  deriv_fabs_0_d0 = (((modelStruct.modelPar_NCHO)>=0)?(+1.0):(-1.0));
double  deriv_min_1_d0 = ((value_fabs_0<=1.0e19)?1.0:0.0);
d_NCH_i_dX = (deriv_min_1_d0*(deriv_fabs_0_d0*(modelStruct.d_modelPar_NCHO_dX)))*1.0e6;
NCH_i = (value_min_1*1.0e6);
}
instanceStruct.instanceVar_TYPESUB_i = 1.0;
if ((modelStruct.modelPar_NSUBO<0))
{
instanceStruct.instanceVar_TYPESUB_i = (-1.0);
}
{
double value_fabs_0 = fabs(modelStruct.modelPar_NSUBO);
double value_max_1 = std::max(value_fabs_0,static_cast<double>(1.0e16));
double value_min_2 = std::min(value_max_1,static_cast<double>(1.0e21));
double  deriv_fabs_0_d0 = (((modelStruct.modelPar_NSUBO)>=0)?(+1.0):(-1.0));
double  deriv_max_1_d0 = ((value_fabs_0>=1.0e16)?1.0:0.0);
double  deriv_min_2_d0 = ((value_max_1<=1.0e21)?1.0:0.0);
d_NSUB_i_dX = (deriv_min_2_d0*((deriv_max_1_d0*(deriv_fabs_0_d0*(modelStruct.d_modelPar_NSUBO_dX)))))*1.0e6;
NSUB_i = (value_min_2*1.0e6);
}
instanceStruct.d_instanceVar_CT_i_dX = modelStruct.d_modelPar_CTO_dX;
instanceStruct.instanceVar_CT_i = modelStruct.modelPar_CTO;
instanceStruct.d_instanceVar_TOXP_i_dX = modelStruct.d_modelPar_TOXPO_dX;
instanceStruct.instanceVar_TOXP_i = modelStruct.modelPar_TOXPO;
instanceStruct.d_instanceVar_NOV_i_dX = modelStruct.d_modelPar_NOVO_dX*1.0e6;
instanceStruct.instanceVar_NOV_i = (modelStruct.modelPar_NOVO*1.0e6);
instanceStruct.d_instanceVar_NOVD_i_dX = modelStruct.d_modelPar_NOVDO_dX*1.0e6;
instanceStruct.instanceVar_NOVD_i = (modelStruct.modelPar_NOVDO*1.0e6);
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_VFBLEXP);
double value_pow_1 = pow(iLE,modelStruct.modelPar_VFBLEXP2);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_VFBLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
double  deriv_pow_1_d0 = ((iLE == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_VFBLEXP2/iLE));
double  deriv_pow_1_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_1);
instanceStruct.d_instanceVar_temp_dX = (((1.0+(modelStruct.modelPar_VFBL2*value_pow_1))*(modelStruct.modelPar_VFBL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_VFBLEXP_dX)))+modelStruct.d_modelPar_VFBL_dX*value_pow_0)-(modelStruct.modelPar_VFBL*value_pow_0)*(modelStruct.modelPar_VFBL2*((deriv_pow_1_d0*(d_iLE_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_VFBLEXP2_dX)))+modelStruct.d_modelPar_VFBL2_dX*value_pow_1))/(1.0+(modelStruct.modelPar_VFBL2*value_pow_1))/(1.0+(modelStruct.modelPar_VFBL2*value_pow_1)));
instanceStruct.instanceVar_temp = ((modelStruct.modelPar_VFBL*value_pow_0)/(1.0+(modelStruct.modelPar_VFBL2*value_pow_1)));
}
instanceStruct.d_instanceVar_VFB1_t_dX = (((modelStruct.d_modelPar_VFBO_dX+instanceStruct.d_instanceVar_temp_dX)+(modelStruct.modelPar_VFBW*d_iWE_dX+modelStruct.d_modelPar_VFBW_dX*iWE))+(modelStruct.modelPar_VFBLW*d_iAE_dX+modelStruct.d_modelPar_VFBLW_dX*iAE));
instanceStruct.instanceVar_VFB1_t = (((modelStruct.modelPar_VFBO+instanceStruct.instanceVar_temp)+(modelStruct.modelPar_VFBW*iWE))+(modelStruct.modelPar_VFBLW*iAE));
instanceStruct.d_instanceVar_VFB2_t_dX = (modelStruct.d_modelPar_VFBBO_dX+(((modelStruct.modelPar_VFBLBO*TOX2_i)/TOX1_i)*instanceStruct.d_instanceVar_temp_dX+((TOX1_i*(modelStruct.modelPar_VFBLBO*d_TOX2_i_dX+modelStruct.d_modelPar_VFBLBO_dX*TOX2_i)-(modelStruct.modelPar_VFBLBO*TOX2_i)*d_TOX1_i_dX)/TOX1_i/TOX1_i)*instanceStruct.instanceVar_temp));
instanceStruct.instanceVar_VFB2_t = (modelStruct.modelPar_VFBBO+(((modelStruct.modelPar_VFBLBO*TOX2_i)/TOX1_i)*instanceStruct.instanceVar_temp));
instanceStruct.d_instanceVar_STVFB_i_dX = (((modelStruct.modelPar_STVFBO*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(1.0+(modelStruct.modelPar_STVFBW*iWE)))*(modelStruct.modelPar_STVFBLW*d_iAE_dX+modelStruct.d_modelPar_STVFBLW_dX*iAE)+((modelStruct.modelPar_STVFBO*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(modelStruct.modelPar_STVFBW*d_iWE_dX+modelStruct.d_modelPar_STVFBW_dX*iWE)+(modelStruct.modelPar_STVFBO*(modelStruct.modelPar_STVFBL*d_iLE_dX+modelStruct.d_modelPar_STVFBL_dX*iLE)+modelStruct.d_modelPar_STVFBO_dX*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(1.0+(modelStruct.modelPar_STVFBW*iWE)))*(1.0+(modelStruct.modelPar_STVFBLW*iAE)));
instanceStruct.instanceVar_STVFB_i = (((modelStruct.modelPar_STVFBO*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(1.0+(modelStruct.modelPar_STVFBW*iWE)))*(1.0+(modelStruct.modelPar_STVFBLW*iAE)));
instanceStruct.d_instanceVar_CIC1_i_dX = modelStruct.d_modelPar_CICFO_dX;
instanceStruct.instanceVar_CIC1_i = modelStruct.modelPar_CICFO;
instanceStruct.d_instanceVar_CIC2_i_dX = modelStruct.d_modelPar_CICO_dX;
instanceStruct.instanceVar_CIC2_i = modelStruct.modelPar_CICO;
instanceStruct.d_instanceVar_one_m_xge_dX = (-instanceStruct.d_instanceVar_XGE_i_dX);
instanceStruct.instanceVar_one_m_xge = (1.0-instanceStruct.instanceVar_XGE_i);
instanceStruct.d_instanceVar_epsch_dX = (1.04479E-10*instanceStruct.d_instanceVar_one_m_xge_dX+1.43438E-10*instanceStruct.d_instanceVar_XGE_i_dX);
instanceStruct.instanceVar_epsch = ((1.04479E-10*instanceStruct.instanceVar_one_m_xge)+(1.43438E-10*instanceStruct.instanceVar_XGE_i));
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_epsch/3.45313E-11)*instanceStruct.instanceVar_TSI_i)*(TOX1_i+4.0e-10)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_lambda_LE_dX = ((LE*deriv_sqrt_0_d0*((((instanceStruct.instanceVar_epsch/3.45313E-11)*instanceStruct.instanceVar_TSI_i)*d_TOX1_i_dX+((instanceStruct.instanceVar_epsch/3.45313E-11)*instanceStruct.d_instanceVar_TSI_i_dX+(instanceStruct.d_instanceVar_epsch_dX/3.45313E-11)*instanceStruct.instanceVar_TSI_i)*(TOX1_i+4.0e-10)))-value_sqrt_0*d_LE_dX)/LE/LE);
lambda_LE = (value_sqrt_0/LE);
}
{
double value_pow_0 = pow(lambda_LE,modelStruct.modelPar_PSCELEXP);
double  deriv_pow_0_d0 = ((lambda_LE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PSCELEXP/lambda_LE));
double  deriv_pow_0_d1 = (lambda_LE == 0.0)?0.0:(log(lambda_LE)*value_pow_0);
d_PSCE_p_dX = (((modelStruct.modelPar_PSCEL*2.0)*value_pow_0)*(modelStruct.modelPar_PSCEW*d_iWE_dX+modelStruct.d_modelPar_PSCEW_dX*iWE)+((modelStruct.modelPar_PSCEL*2.0)*((deriv_pow_0_d0*(d_lambda_LE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PSCELEXP_dX)))+modelStruct.d_modelPar_PSCEL_dX*2.0*value_pow_0)*(1.0+(modelStruct.modelPar_PSCEW*iWE)));
PSCE_p = (((modelStruct.modelPar_PSCEL*2.0)*value_pow_0)*(1.0+(modelStruct.modelPar_PSCEW*iWE)));
}
{
double value_max_0 = std::max(PSCE_p,static_cast<double>(0.0));
double value_min_1 = std::min(value_max_0,static_cast<double>(5.0));
double  deriv_max_0_d0 = ((PSCE_p>=0.0)?1.0:0.0);
double  deriv_min_1_d0 = ((value_max_0<=5.0)?1.0:0.0);
instanceStruct.d_instanceVar_PSCE1_i_dX = (deriv_min_1_d0*((deriv_max_0_d0*(d_PSCE_p_dX))));
instanceStruct.instanceVar_PSCE1_i = value_min_1;
}
instanceStruct.d_instanceVar_PSCE2_i_dX = ((TOX1_i*((modelStruct.modelPar_PSCEBO*instanceStruct.instanceVar_PSCE1_i)*d_TOX2_i_dX+(modelStruct.modelPar_PSCEBO*instanceStruct.d_instanceVar_PSCE1_i_dX+modelStruct.d_modelPar_PSCEBO_dX*instanceStruct.instanceVar_PSCE1_i)*TOX2_i)-((modelStruct.modelPar_PSCEBO*instanceStruct.instanceVar_PSCE1_i)*TOX2_i)*d_TOX1_i_dX)/TOX1_i/TOX1_i);
instanceStruct.instanceVar_PSCE2_i = (((modelStruct.modelPar_PSCEBO*instanceStruct.instanceVar_PSCE1_i)*TOX2_i)/TOX1_i);
instanceStruct.d_instanceVar_NSDDC_i_dX = modelStruct.d_modelPar_NSDDCO_dX*1.0e6;
instanceStruct.instanceVar_NSDDC_i = (modelStruct.modelPar_NSDDCO*1.0e6);
instanceStruct.d_instanceVar_PSCEDLB_i_dX = modelStruct.d_modelPar_PSCEDLBO_dX;
instanceStruct.instanceVar_PSCEDLB_i = modelStruct.modelPar_PSCEDLBO;
d_PNCE_p_dX = (modelStruct.modelPar_PNCEW*d_iWE_dX+modelStruct.d_modelPar_PNCEW_dX*iWE);
PNCE_p = (modelStruct.modelPar_PNCEW*iWE);
{
double value_max_0 = std::max(PNCE_p,(-1.0));
double value_min_1 = std::min(value_max_0,static_cast<double>(1.0));
double  deriv_max_0_d0 = ((PNCE_p>=(-1.0))?1.0:0.0);
double  deriv_min_1_d0 = ((value_max_0<=1.0)?1.0:0.0);
d_PNCE_i_dX = (deriv_min_1_d0*((deriv_max_0_d0*(d_PNCE_p_dX))));
PNCE_i = value_min_1;
}
{
double value_pow_0 = pow(lambda_LE,modelStruct.modelPar_CFLEXP);
double  deriv_pow_0_d0 = ((lambda_LE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CFLEXP/lambda_LE));
double  deriv_pow_0_d1 = (lambda_LE == 0.0)?0.0:(log(lambda_LE)*value_pow_0);
instanceStruct.d_instanceVar_temp_dX = (value_pow_0*(modelStruct.modelPar_CFW*d_iWE_dX+modelStruct.d_modelPar_CFW_dX*iWE)+((deriv_pow_0_d0*(d_lambda_LE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CFLEXP_dX)))*(1.0+(modelStruct.modelPar_CFW*iWE)));
instanceStruct.instanceVar_temp = (value_pow_0*(1.0+(modelStruct.modelPar_CFW*iWE)));
}
d_CF_p_dX = (modelStruct.modelPar_CFL*instanceStruct.d_instanceVar_temp_dX+modelStruct.d_modelPar_CFL_dX*instanceStruct.instanceVar_temp);
CF_p = (modelStruct.modelPar_CFL*instanceStruct.instanceVar_temp);
{
double value_max_0 = std::max(CF_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CF_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CF1_t_dX = (deriv_max_0_d0*(d_CF_p_dX));
instanceStruct.instanceVar_CF1_t = value_max_0;
}
instanceStruct.d_instanceVar_CF2_t_dX = ((TOX1_i*((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*d_TOX2_i_dX+(modelStruct.modelPar_CFBO*instanceStruct.d_instanceVar_CF1_t_dX+modelStruct.d_modelPar_CFBO_dX*instanceStruct.instanceVar_CF1_t)*TOX2_i)-((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*TOX2_i)*d_TOX1_i_dX)/TOX1_i/TOX1_i);
instanceStruct.instanceVar_CF2_t = (((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*TOX2_i)/TOX1_i);
instanceStruct.d_instanceVar_STCF_i_dX = (modelStruct.modelPar_STCFL*instanceStruct.d_instanceVar_temp_dX+modelStruct.d_modelPar_STCFL_dX*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_STCF_i = (modelStruct.modelPar_STCFL*instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_CFD_i_dX = modelStruct.d_modelPar_CFDO_dX;
instanceStruct.instanceVar_CFD_i = modelStruct.modelPar_CFDO;
{
double value_max_0 = std::max((1.0+(modelStruct.modelPar_CFDLW*iWE)),static_cast<double>(1.0e-3));
double  deriv_max_0_d0 = (((1.0+(modelStruct.modelPar_CFDLW*iWE))>=1.0e-3)?1.0:0.0);
instanceStruct.d_instanceVar_CFDL_i_dX = ((value_max_0*(modelStruct.modelPar_CFDLL*d_iLE_dX+modelStruct.d_modelPar_CFDLL_dX*iLE)-(modelStruct.modelPar_CFDLL*iLE)*(deriv_max_0_d0*((modelStruct.modelPar_CFDLW*d_iWE_dX+modelStruct.d_modelPar_CFDLW_dX*iWE))))/value_max_0/value_max_0);
instanceStruct.instanceVar_CFDL_i = ((modelStruct.modelPar_CFDLL*iLE)/value_max_0);
}
instanceStruct.d_instanceVar_CFDLB_i_dX = modelStruct.d_modelPar_CFDLBO_dX;
instanceStruct.instanceVar_CFDLB_i = modelStruct.modelPar_CFDLBO;
{
double value_max_0 = std::max((1.0+(modelStruct.modelPar_LP1W*iWE)),static_cast<double>(1.0e-3));
double  deriv_max_0_d0 = (((1.0+(modelStruct.modelPar_LP1W*iWE))>=1.0e-3)?1.0:0.0);
instanceStruct.d_instanceVar_temp1_dX = (((modelStruct.modelPar_LP1*value_max_0)*(-d_LE_dX)-(-LE)*(modelStruct.modelPar_LP1*(deriv_max_0_d0*((modelStruct.modelPar_LP1W*d_iWE_dX+modelStruct.d_modelPar_LP1W_dX*iWE)))+modelStruct.d_modelPar_LP1_dX*value_max_0))/(modelStruct.modelPar_LP1*value_max_0)/(modelStruct.modelPar_LP1*value_max_0));
instanceStruct.instanceVar_temp1 = ((-LE)/(modelStruct.modelPar_LP1*value_max_0));
}
if ((instanceStruct.instanceVar_temp1>(-80.0)))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp1);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp2 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_temp2_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp1)-80.0)*((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(-instanceStruct.d_instanceVar_temp1_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp2 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
}
instanceStruct.d_instanceVar_temp3_dX = ((modelStruct.modelPar_LP2*(-d_LE_dX)-(-LE)*modelStruct.d_modelPar_LP2_dX)/modelStruct.modelPar_LP2/modelStruct.modelPar_LP2);
instanceStruct.instanceVar_temp3 = ((-LE)/modelStruct.modelPar_LP2);
if ((instanceStruct.instanceVar_temp3>(-80.0)))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp3);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp4_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp3_dX);
instanceStruct.instanceVar_temp4 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_temp4_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp3)-80.0)*((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(-instanceStruct.d_instanceVar_temp3_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp4 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
}
{
double value_max_0 = std::max(((1.0+(((modelStruct.modelPar_FBET1*(1.0+(modelStruct.modelPar_FBET1W*iWE)))*(instanceStruct.instanceVar_temp2-1.0))/instanceStruct.instanceVar_temp1))+((modelStruct.modelPar_FBET2*(instanceStruct.instanceVar_temp4-1.0))/instanceStruct.instanceVar_temp3)),static_cast<double>(1.0e-6));
double  deriv_max_0_d0 = ((((1.0+(((modelStruct.modelPar_FBET1*(1.0+(modelStruct.modelPar_FBET1W*iWE)))*(instanceStruct.instanceVar_temp2-1.0))/instanceStruct.instanceVar_temp1))+((modelStruct.modelPar_FBET2*(instanceStruct.instanceVar_temp4-1.0))/instanceStruct.instanceVar_temp3))>=1.0e-6)?1.0:0.0);
d_GPE_dX = (deriv_max_0_d0*((((instanceStruct.instanceVar_temp1*((modelStruct.modelPar_FBET1*(1.0+(modelStruct.modelPar_FBET1W*iWE)))*instanceStruct.d_instanceVar_temp2_dX+(modelStruct.modelPar_FBET1*(modelStruct.modelPar_FBET1W*d_iWE_dX+modelStruct.d_modelPar_FBET1W_dX*iWE)+modelStruct.d_modelPar_FBET1_dX*(1.0+(modelStruct.modelPar_FBET1W*iWE)))*(instanceStruct.instanceVar_temp2-1.0))-((modelStruct.modelPar_FBET1*(1.0+(modelStruct.modelPar_FBET1W*iWE)))*(instanceStruct.instanceVar_temp2-1.0))*instanceStruct.d_instanceVar_temp1_dX)/instanceStruct.instanceVar_temp1/instanceStruct.instanceVar_temp1)+((instanceStruct.instanceVar_temp3*(modelStruct.modelPar_FBET2*instanceStruct.d_instanceVar_temp4_dX+modelStruct.d_modelPar_FBET2_dX*(instanceStruct.instanceVar_temp4-1.0))-(modelStruct.modelPar_FBET2*(instanceStruct.instanceVar_temp4-1.0))*instanceStruct.d_instanceVar_temp3_dX)/instanceStruct.instanceVar_temp3/instanceStruct.instanceVar_temp3))));
GPE = value_max_0;
}
{
double value_log_0 = log((1.0+(WE/modelStruct.modelPar_WBET)));
double value_max_1 = std::max(((1.0+(modelStruct.modelPar_BETW1*iWE))+((modelStruct.modelPar_BETW2*iWE)*value_log_0)),static_cast<double>(1.0e-6));
double  deriv_log_0_d0 = (1.0/(1.0+(WE/modelStruct.modelPar_WBET)));
double  deriv_max_1_d0 = ((((1.0+(modelStruct.modelPar_BETW1*iWE))+((modelStruct.modelPar_BETW2*iWE)*value_log_0))>=1.0e-6)?1.0:0.0);
d_GWE_dX = (deriv_max_1_d0*(((modelStruct.modelPar_BETW1*d_iWE_dX+modelStruct.d_modelPar_BETW1_dX*iWE)+((modelStruct.modelPar_BETW2*iWE)*deriv_log_0_d0*(((modelStruct.modelPar_WBET*d_WE_dX-WE*modelStruct.d_modelPar_WBET_dX)/modelStruct.modelPar_WBET/modelStruct.modelPar_WBET))+(modelStruct.modelPar_BETW2*d_iWE_dX+modelStruct.d_modelPar_BETW2_dX*iWE)*value_log_0))));
GWE = value_max_1;
}
d_GE_dX = ((modelStruct.modelPar_UO/GPE)*d_GWE_dX+((GPE*modelStruct.d_modelPar_UO_dX-modelStruct.modelPar_UO*d_GPE_dX)/GPE/GPE)*GWE);
GE = ((modelStruct.modelPar_UO/GPE)*GWE);
d_BETN_p_dX = ((LE*(GE*d_WE_dX+d_GE_dX*WE)-(GE*WE)*d_LE_dX)/LE/LE);
BETN_p = ((GE*WE)/LE);
{
double value_max_0 = std::max(BETN_p,static_cast<double>(1.0e-10));
double  deriv_max_0_d0 = ((BETN_p>=1.0e-10)?1.0:0.0);
instanceStruct.d_instanceVar_BETN1_t_dX = (deriv_max_0_d0*(d_BETN_p_dX));
instanceStruct.instanceVar_BETN1_t = value_max_0;
}
instanceStruct.d_instanceVar_BETN2_t_dX = (modelStruct.modelPar_BETNBO*instanceStruct.d_instanceVar_BETN1_t_dX+modelStruct.d_modelPar_BETNBO_dX*instanceStruct.instanceVar_BETN1_t);
instanceStruct.instanceVar_BETN2_t = (modelStruct.modelPar_BETNBO*instanceStruct.instanceVar_BETN1_t);
instanceStruct.d_instanceVar_STBET_i_dX = (((modelStruct.modelPar_STBETO*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(1.0+(modelStruct.modelPar_STBETW*iWE)))*(modelStruct.modelPar_STBETLW*d_iAE_dX+modelStruct.d_modelPar_STBETLW_dX*iAE)+((modelStruct.modelPar_STBETO*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(modelStruct.modelPar_STBETW*d_iWE_dX+modelStruct.d_modelPar_STBETW_dX*iWE)+(modelStruct.modelPar_STBETO*(modelStruct.modelPar_STBETL*d_iLE_dX+modelStruct.d_modelPar_STBETL_dX*iLE)+modelStruct.d_modelPar_STBETO_dX*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(1.0+(modelStruct.modelPar_STBETW*iWE)))*(1.0+(modelStruct.modelPar_STBETLW*iAE)));
instanceStruct.instanceVar_STBET_i = (((modelStruct.modelPar_STBETO*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(1.0+(modelStruct.modelPar_STBETW*iWE)))*(1.0+(modelStruct.modelPar_STBETLW*iAE)));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CSLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CSLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CS_p_dX = (((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*(modelStruct.modelPar_CSLW*d_iAE_dX+modelStruct.d_modelPar_CSLW_dX*iAE)+((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(modelStruct.modelPar_CSW*d_iWE_dX+modelStruct.d_modelPar_CSW_dX*iWE)+(modelStruct.d_modelPar_CSO_dX+(modelStruct.modelPar_CSL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CSLEXP_dX)))+modelStruct.d_modelPar_CSL_dX*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*(1.0+(modelStruct.modelPar_CSLW*iAE)));
CS_p = (((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*(1.0+(modelStruct.modelPar_CSLW*iAE)));
}
{
double value_max_0 = std::max(CS_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CS_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CS_t_dX = (deriv_max_0_d0*(d_CS_p_dX));
instanceStruct.instanceVar_CS_t = value_max_0;
}
instanceStruct.d_instanceVar_CSFI_i_dX = modelStruct.d_modelPar_CSFIO_dX;
instanceStruct.instanceVar_CSFI_i = modelStruct.modelPar_CSFIO;
instanceStruct.d_instanceVar_CSBI_i_dX = modelStruct.d_modelPar_CSBIO_dX;
instanceStruct.instanceVar_CSBI_i = modelStruct.modelPar_CSBIO;
instanceStruct.d_instanceVar_STCS_i_dX = (((modelStruct.modelPar_STCSO*(1.0+(modelStruct.modelPar_STCSL*iLE)))*(1.0+(modelStruct.modelPar_STCSW*iWE)))*(modelStruct.modelPar_STCSLW*d_iAE_dX+modelStruct.d_modelPar_STCSLW_dX*iAE)+((modelStruct.modelPar_STCSO*(1.0+(modelStruct.modelPar_STCSL*iLE)))*(modelStruct.modelPar_STCSW*d_iWE_dX+modelStruct.d_modelPar_STCSW_dX*iWE)+(modelStruct.modelPar_STCSO*(modelStruct.modelPar_STCSL*d_iLE_dX+modelStruct.d_modelPar_STCSL_dX*iLE)+modelStruct.d_modelPar_STCSO_dX*(1.0+(modelStruct.modelPar_STCSL*iLE)))*(1.0+(modelStruct.modelPar_STCSW*iWE)))*(1.0+(modelStruct.modelPar_STCSLW*iAE)));
instanceStruct.instanceVar_STCS_i = (((modelStruct.modelPar_STCSO*(1.0+(modelStruct.modelPar_STCSL*iLE)))*(1.0+(modelStruct.modelPar_STCSW*iWE)))*(1.0+(modelStruct.modelPar_STCSLW*iAE)));
instanceStruct.d_instanceVar_THECS_t_dX = modelStruct.d_modelPar_THECSO_dX;
instanceStruct.instanceVar_THECS_t = modelStruct.modelPar_THECSO;
instanceStruct.d_instanceVar_STTHECS_i_dX = modelStruct.d_modelPar_STTHECSO_dX;
instanceStruct.instanceVar_STTHECS_i = modelStruct.modelPar_STTHECSO;
d_CSTHR_i_dX = modelStruct.d_modelPar_CSTHRO_dX;
CSTHR_i = modelStruct.modelPar_CSTHRO;
d_CSTHRB_i_dX = modelStruct.d_modelPar_CSTHRBO_dX;
CSTHRB_i = modelStruct.modelPar_CSTHRBO;
instanceStruct.d_instanceVar_MUE_t_dX = modelStruct.d_modelPar_MUEO_dX;
instanceStruct.instanceVar_MUE_t = modelStruct.modelPar_MUEO;
instanceStruct.d_instanceVar_STMUE_i_dX = modelStruct.d_modelPar_STMUEO_dX;
instanceStruct.instanceVar_STMUE_i = modelStruct.modelPar_STMUEO;
instanceStruct.d_instanceVar_THEMU_t_dX = modelStruct.d_modelPar_THEMUO_dX;
instanceStruct.instanceVar_THEMU_t = modelStruct.modelPar_THEMUO;
instanceStruct.d_instanceVar_STTHEMU_i_dX = modelStruct.d_modelPar_STTHEMUO_dX;
instanceStruct.instanceVar_STTHEMU_i = modelStruct.modelPar_STTHEMUO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_XCORLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_XCORLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
instanceStruct.d_instanceVar_XCOR_t_dX = (((modelStruct.modelPar_XCORO+(modelStruct.modelPar_XCORL*value_pow_0))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*(modelStruct.modelPar_XCORLW*d_iAE_dX+modelStruct.d_modelPar_XCORLW_dX*iAE)+((modelStruct.modelPar_XCORO+(modelStruct.modelPar_XCORL*value_pow_0))*(modelStruct.modelPar_XCORW*d_iWE_dX+modelStruct.d_modelPar_XCORW_dX*iWE)+(modelStruct.d_modelPar_XCORO_dX+(modelStruct.modelPar_XCORL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_XCORLEXP_dX)))+modelStruct.d_modelPar_XCORL_dX*value_pow_0))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*(1.0+(modelStruct.modelPar_XCORLW*iAE)));
instanceStruct.instanceVar_XCOR_t = (((modelStruct.modelPar_XCORO+(modelStruct.modelPar_XCORL*value_pow_0))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*(1.0+(modelStruct.modelPar_XCORLW*iAE)));
}
instanceStruct.d_instanceVar_XCORB_i_dX = modelStruct.d_modelPar_XCORBO_dX;
instanceStruct.instanceVar_XCORB_i = modelStruct.modelPar_XCORBO;
instanceStruct.d_instanceVar_STXCOR_i_dX = modelStruct.d_modelPar_STXCORO_dX;
instanceStruct.instanceVar_STXCOR_i = modelStruct.modelPar_STXCORO;
d_FETA_i_dX = modelStruct.d_modelPar_FETAO_dX;
FETA_i = modelStruct.modelPar_FETAO;
d_RS_p_dX = ((modelStruct.modelPar_RSW1*iWE)*(modelStruct.modelPar_RSW2*d_iWE_dX+modelStruct.d_modelPar_RSW2_dX*iWE)+(modelStruct.modelPar_RSW1*d_iWE_dX+modelStruct.d_modelPar_RSW1_dX*iWE)*(1.0+(modelStruct.modelPar_RSW2*iWE)));
RS_p = ((modelStruct.modelPar_RSW1*iWE)*(1.0+(modelStruct.modelPar_RSW2*iWE)));
{
double value_max_0 = std::max(RS_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((RS_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_RS_t_dX = (deriv_max_0_d0*(d_RS_p_dX));
instanceStruct.instanceVar_RS_t = value_max_0;
}
instanceStruct.d_instanceVar_RSIG_i_dX = modelStruct.d_modelPar_RSIGO_dX;
instanceStruct.instanceVar_RSIG_i = modelStruct.modelPar_RSIGO;
instanceStruct.d_instanceVar_STRS_i_dX = modelStruct.d_modelPar_STRSO_dX;
instanceStruct.instanceVar_STRS_i = modelStruct.modelPar_STRSO;
instanceStruct.d_instanceVar_RSG_i_dX = modelStruct.d_modelPar_RSGO_dX;
instanceStruct.instanceVar_RSG_i = modelStruct.modelPar_RSGO;
instanceStruct.d_instanceVar_THERSG_i_dX = modelStruct.d_modelPar_THERSGO_dX;
instanceStruct.instanceVar_THERSG_i = modelStruct.modelPar_THERSGO;
instanceStruct.d_instanceVar_RSB_i_dX = modelStruct.d_modelPar_RSBO_dX;
instanceStruct.instanceVar_RSB_i = modelStruct.modelPar_RSBO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_THESATLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_THESATLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_THESAT_p_dX = (((GE*(modelStruct.modelPar_THESATO+(modelStruct.modelPar_THESATL*value_pow_0)))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*(modelStruct.modelPar_THESATLW*d_iAE_dX+modelStruct.d_modelPar_THESATLW_dX*iAE)+((GE*(modelStruct.modelPar_THESATO+(modelStruct.modelPar_THESATL*value_pow_0)))*(modelStruct.modelPar_THESATW*d_iWE_dX+modelStruct.d_modelPar_THESATW_dX*iWE)+(GE*(modelStruct.d_modelPar_THESATO_dX+(modelStruct.modelPar_THESATL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_THESATLEXP_dX)))+modelStruct.d_modelPar_THESATL_dX*value_pow_0))+d_GE_dX*(modelStruct.modelPar_THESATO+(modelStruct.modelPar_THESATL*value_pow_0)))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*(1.0+(modelStruct.modelPar_THESATLW*iAE)));
THESAT_p = (((GE*(modelStruct.modelPar_THESATO+(modelStruct.modelPar_THESATL*value_pow_0)))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*(1.0+(modelStruct.modelPar_THESATLW*iAE)));
}
{
double value_max_0 = std::max(THESAT_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((THESAT_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_THESAT_t_dX = (deriv_max_0_d0*(d_THESAT_p_dX));
instanceStruct.instanceVar_THESAT_t = value_max_0;
}
instanceStruct.d_instanceVar_STTHESAT_i_dX = (((modelStruct.modelPar_STTHESATO*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(1.0+(modelStruct.modelPar_STTHESATW*iWE)))*(modelStruct.modelPar_STTHESATLW*d_iAE_dX+modelStruct.d_modelPar_STTHESATLW_dX*iAE)+((modelStruct.modelPar_STTHESATO*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(modelStruct.modelPar_STTHESATW*d_iWE_dX+modelStruct.d_modelPar_STTHESATW_dX*iWE)+(modelStruct.modelPar_STTHESATO*(modelStruct.modelPar_STTHESATL*d_iLE_dX+modelStruct.d_modelPar_STTHESATL_dX*iLE)+modelStruct.d_modelPar_STTHESATO_dX*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(1.0+(modelStruct.modelPar_STTHESATW*iWE)))*(1.0+(modelStruct.modelPar_STTHESATLW*iAE)));
instanceStruct.instanceVar_STTHESAT_i = (((modelStruct.modelPar_STTHESATO*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(1.0+(modelStruct.modelPar_STTHESATW*iWE)))*(1.0+(modelStruct.modelPar_STTHESATLW*iAE)));
instanceStruct.d_instanceVar_THESAT1_i_dX = modelStruct.d_modelPar_THESATGO_dX;
instanceStruct.instanceVar_THESAT1_i = modelStruct.modelPar_THESATGO;
instanceStruct.d_instanceVar_THESAT2_i_dX = modelStruct.d_modelPar_THESATBO_dX;
instanceStruct.instanceVar_THESAT2_i = modelStruct.modelPar_THESATBO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_AXLEXP);
double value_pow_1 = pow(iLE,modelStruct.modelPar_AXLEXP2);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_AXLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
double  deriv_pow_1_d0 = ((iLE == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_AXLEXP2/iLE));
double  deriv_pow_1_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_1);
d_AX_p_dX = (((1.0+((modelStruct.modelPar_AXL*value_pow_0)/(1.0+(modelStruct.modelPar_AXL2*value_pow_1))))*modelStruct.d_modelPar_AXO_dX-modelStruct.modelPar_AXO*(((1.0+(modelStruct.modelPar_AXL2*value_pow_1))*(modelStruct.modelPar_AXL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_AXLEXP_dX)))+modelStruct.d_modelPar_AXL_dX*value_pow_0)-(modelStruct.modelPar_AXL*value_pow_0)*(modelStruct.modelPar_AXL2*((deriv_pow_1_d0*(d_iLE_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_AXLEXP2_dX)))+modelStruct.d_modelPar_AXL2_dX*value_pow_1))/(1.0+(modelStruct.modelPar_AXL2*value_pow_1))/(1.0+(modelStruct.modelPar_AXL2*value_pow_1))))/(1.0+((modelStruct.modelPar_AXL*value_pow_0)/(1.0+(modelStruct.modelPar_AXL2*value_pow_1))))/(1.0+((modelStruct.modelPar_AXL*value_pow_0)/(1.0+(modelStruct.modelPar_AXL2*value_pow_1)))));
AX_p = (modelStruct.modelPar_AXO/(1.0+((modelStruct.modelPar_AXL*value_pow_0)/(1.0+(modelStruct.modelPar_AXL2*value_pow_1)))));
}
{
double value_max_0 = std::max(AX_p,static_cast<double>(1.0));
double value_min_1 = std::min(value_max_0,static_cast<double>(16.0));
double  deriv_max_0_d0 = ((AX_p>=1.0)?1.0:0.0);
double  deriv_min_1_d0 = ((value_max_0<=16.0)?1.0:0.0);
d_AX_i_dX = (deriv_min_1_d0*((deriv_max_0_d0*(d_AX_p_dX))));
AX_i = value_min_1;
}
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALPLEXP);
double value_pow_1 = pow(iLE,modelStruct.modelPar_ALPLEXP2);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALPLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
double  deriv_pow_1_d0 = ((iLE == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_ALPLEXP2/iLE));
double  deriv_pow_1_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_1);
d_ALP_p_dX = (((1.0+(modelStruct.modelPar_ALPL2*value_pow_1))*((modelStruct.modelPar_ALPL1*value_pow_0)*(modelStruct.modelPar_ALPW*d_iWE_dX+modelStruct.d_modelPar_ALPW_dX*iWE)+(modelStruct.modelPar_ALPL1*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALPLEXP_dX)))+modelStruct.d_modelPar_ALPL1_dX*value_pow_0)*(1.0+(modelStruct.modelPar_ALPW*iWE)))-((modelStruct.modelPar_ALPL1*value_pow_0)*(1.0+(modelStruct.modelPar_ALPW*iWE)))*(modelStruct.modelPar_ALPL2*((deriv_pow_1_d0*(d_iLE_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_ALPLEXP2_dX)))+modelStruct.d_modelPar_ALPL2_dX*value_pow_1))/(1.0+(modelStruct.modelPar_ALPL2*value_pow_1))/(1.0+(modelStruct.modelPar_ALPL2*value_pow_1)));
ALP_p = (((modelStruct.modelPar_ALPL1*value_pow_0)*(1.0+(modelStruct.modelPar_ALPW*iWE)))/(1.0+(modelStruct.modelPar_ALPL2*value_pow_1)));
}
{
double value_max_0 = std::max(ALP_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((ALP_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_ALP_i_dX = (deriv_max_0_d0*(d_ALP_p_dX));
instanceStruct.instanceVar_ALP_i = value_max_0;
}
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALP1LEXP);
double value_pow_1 = pow(iLE,modelStruct.modelPar_ALP1LEXP2);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALP1LEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
double  deriv_pow_1_d0 = ((iLE == 0.0)?0.0:(value_pow_1*modelStruct.modelPar_ALP1LEXP2/iLE));
double  deriv_pow_1_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_1);
d_ALP1_p_dX = (((1.0+(modelStruct.modelPar_ALP1L2*value_pow_1))*((modelStruct.modelPar_ALP1L1*value_pow_0)*(modelStruct.modelPar_ALP1W*d_iWE_dX+modelStruct.d_modelPar_ALP1W_dX*iWE)+(modelStruct.modelPar_ALP1L1*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALP1LEXP_dX)))+modelStruct.d_modelPar_ALP1L1_dX*value_pow_0)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))-((modelStruct.modelPar_ALP1L1*value_pow_0)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))*(modelStruct.modelPar_ALP1L2*((deriv_pow_1_d0*(d_iLE_dX))+(deriv_pow_1_d1*(modelStruct.d_modelPar_ALP1LEXP2_dX)))+modelStruct.d_modelPar_ALP1L2_dX*value_pow_1))/(1.0+(modelStruct.modelPar_ALP1L2*value_pow_1))/(1.0+(modelStruct.modelPar_ALP1L2*value_pow_1)));
ALP1_p = (((modelStruct.modelPar_ALP1L1*value_pow_0)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))/(1.0+(modelStruct.modelPar_ALP1L2*value_pow_1)));
}
{
double value_max_0 = std::max(ALP1_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((ALP1_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_ALP1_i_dX = (deriv_max_0_d0*(d_ALP1_p_dX));
instanceStruct.instanceVar_ALP1_i = value_max_0;
}
instanceStruct.d_instanceVar_ALPB_i_dX = modelStruct.d_modelPar_ALPBO_dX;
instanceStruct.instanceVar_ALPB_i = modelStruct.modelPar_ALPBO;
instanceStruct.d_instanceVar_VP_i_dX = modelStruct.d_modelPar_VPO_dX;
instanceStruct.instanceVar_VP_i = modelStruct.modelPar_VPO;
instanceStruct.d_instanceVar_VPG_i_dX = modelStruct.d_modelPar_VPGO_dX;
instanceStruct.instanceVar_VPG_i = modelStruct.modelPar_VPGO;
instanceStruct.d_instanceVar_GCO_i_dX = modelStruct.d_modelPar_GCOO_dX;
instanceStruct.instanceVar_GCO_i = modelStruct.modelPar_GCOO;
instanceStruct.d_instanceVar_IGINV_t_dX = ((iAE*modelStruct.d_modelPar_IGINVLW_dX-modelStruct.modelPar_IGINVLW*d_iAE_dX)/iAE/iAE);
instanceStruct.instanceVar_IGINV_t = (modelStruct.modelPar_IGINVLW/iAE);
instanceStruct.d_instanceVar_IGOVINV_t_dX = ((iWE*modelStruct.d_modelPar_IGOVINVW_dX-modelStruct.modelPar_IGOVINVW*d_iWE_dX)/iWE/iWE);
instanceStruct.instanceVar_IGOVINV_t = (modelStruct.modelPar_IGOVINVW/iWE);
instanceStruct.d_instanceVar_IGOVINVD_t_dX = ((iWE*modelStruct.d_modelPar_IGOVINVDW_dX-modelStruct.modelPar_IGOVINVDW*d_iWE_dX)/iWE/iWE);
instanceStruct.instanceVar_IGOVINVD_t = (modelStruct.modelPar_IGOVINVDW/iWE);
instanceStruct.d_instanceVar_FNOVINV_t_dX = ((iWE*modelStruct.d_modelPar_FNOVINVW_dX-modelStruct.modelPar_FNOVINVW*d_iWE_dX)/iWE/iWE);
instanceStruct.instanceVar_FNOVINV_t = (modelStruct.modelPar_FNOVINVW/iWE);
instanceStruct.d_instanceVar_FNOVINVD_t_dX = ((iWE*modelStruct.d_modelPar_FNOVINVDW_dX-modelStruct.modelPar_FNOVINVDW*d_iWE_dX)/iWE/iWE);
instanceStruct.instanceVar_FNOVINVD_t = (modelStruct.modelPar_FNOVINVDW/iWE);
instanceStruct.d_instanceVar_IGOVACC_t_dX = ((iWE*modelStruct.d_modelPar_IGOVACCW_dX-modelStruct.modelPar_IGOVACCW*d_iWE_dX)/iWE/iWE);
instanceStruct.instanceVar_IGOVACC_t = (modelStruct.modelPar_IGOVACCW/iWE);
instanceStruct.d_instanceVar_IGOVACCD_t_dX = ((iWE*modelStruct.d_modelPar_IGOVACCDW_dX-modelStruct.modelPar_IGOVACCDW*d_iWE_dX)/iWE/iWE);
instanceStruct.instanceVar_IGOVACCD_t = (modelStruct.modelPar_IGOVACCDW/iWE);
instanceStruct.d_instanceVar_STIG_i_dX = modelStruct.d_modelPar_STIGO_dX;
instanceStruct.instanceVar_STIG_i = modelStruct.modelPar_STIGO;
instanceStruct.d_instanceVar_STIGFN_i_dX = modelStruct.d_modelPar_STIGFNO_dX;
instanceStruct.instanceVar_STIGFN_i = modelStruct.modelPar_STIGFNO;
instanceStruct.d_instanceVar_GC2CH_i_dX = modelStruct.d_modelPar_GC2CHO_dX;
instanceStruct.instanceVar_GC2CH_i = modelStruct.modelPar_GC2CHO;
instanceStruct.d_instanceVar_GC3CH_i_dX = modelStruct.d_modelPar_GC3CHO_dX;
instanceStruct.instanceVar_GC3CH_i = modelStruct.modelPar_GC3CHO;
instanceStruct.d_instanceVar_GC2OVINV_i_dX = modelStruct.d_modelPar_GC2OVINVO_dX;
instanceStruct.instanceVar_GC2OVINV_i = modelStruct.modelPar_GC2OVINVO;
instanceStruct.d_instanceVar_GCOVINVFN_i_dX = modelStruct.d_modelPar_GCOVINVFNO_dX;
instanceStruct.instanceVar_GCOVINVFN_i = modelStruct.modelPar_GCOVINVFNO;
instanceStruct.d_instanceVar_GC3OVINV_i_dX = modelStruct.d_modelPar_GC3OVINVO_dX;
instanceStruct.instanceVar_GC3OVINV_i = modelStruct.modelPar_GC3OVINVO;
instanceStruct.d_instanceVar_GC2OVACC_i_dX = modelStruct.d_modelPar_GC2OVACCO_dX;
instanceStruct.instanceVar_GC2OVACC_i = modelStruct.modelPar_GC2OVACCO;
instanceStruct.d_instanceVar_GC3OVACC_i_dX = modelStruct.d_modelPar_GC3OVACCO_dX;
instanceStruct.instanceVar_GC3OVACC_i = modelStruct.modelPar_GC3OVACCO;
instanceStruct.d_instanceVar_GCDOV_i_dX = (modelStruct.modelPar_GCDOVL*d_iLE_dX+modelStruct.d_modelPar_GCDOVL_dX*iLE);
instanceStruct.instanceVar_GCDOV_i = (modelStruct.modelPar_GCDOVL*iLE);
instanceStruct.d_instanceVar_GCVDOV_i_dX = modelStruct.d_modelPar_GCVDOVO_dX;
instanceStruct.instanceVar_GCVDOV_i = modelStruct.modelPar_GCVDOVO;
instanceStruct.d_instanceVar_CHIB_i_dX = modelStruct.d_modelPar_CHIBO_dX;
instanceStruct.instanceVar_CHIB_i = modelStruct.modelPar_CHIBO;
instanceStruct.d_instanceVar_NIGINV_i_dX = modelStruct.d_modelPar_NIGINVO_dX;
instanceStruct.instanceVar_NIGINV_i = modelStruct.modelPar_NIGINVO;
d_AGIDL_p_dX = (modelStruct.d_modelPar_AGIDLO_dX+((iWE*modelStruct.d_modelPar_AGIDLW_dX-modelStruct.modelPar_AGIDLW*d_iWE_dX)/iWE/iWE));
AGIDL_p = (modelStruct.modelPar_AGIDLO+(modelStruct.modelPar_AGIDLW/iWE));
{
double value_max_0 = std::max(AGIDL_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((AGIDL_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_AGIDL_i_dX = (deriv_max_0_d0*(d_AGIDL_p_dX));
instanceStruct.instanceVar_AGIDL_i = value_max_0;
}
d_AGIDLD_p_dX = (modelStruct.d_modelPar_AGIDLDO_dX+((iWE*modelStruct.d_modelPar_AGIDLDW_dX-modelStruct.modelPar_AGIDLDW*d_iWE_dX)/iWE/iWE));
AGIDLD_p = (modelStruct.modelPar_AGIDLDO+(modelStruct.modelPar_AGIDLDW/iWE));
{
double value_max_0 = std::max(AGIDLD_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((AGIDLD_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_AGIDLD_i_dX = (deriv_max_0_d0*(d_AGIDLD_p_dX));
instanceStruct.instanceVar_AGIDLD_i = value_max_0;
}
instanceStruct.d_instanceVar_BGIDL_t_dX = modelStruct.d_modelPar_BGIDLO_dX;
instanceStruct.instanceVar_BGIDL_t = modelStruct.modelPar_BGIDLO;
instanceStruct.d_instanceVar_BGIDLD_t_dX = modelStruct.d_modelPar_BGIDLDO_dX;
instanceStruct.instanceVar_BGIDLD_t = modelStruct.modelPar_BGIDLDO;
instanceStruct.d_instanceVar_STBGIDL_i_dX = modelStruct.d_modelPar_STBGIDLO_dX;
instanceStruct.instanceVar_STBGIDL_i = modelStruct.modelPar_STBGIDLO;
instanceStruct.d_instanceVar_STBGIDLD_i_dX = modelStruct.d_modelPar_STBGIDLDO_dX;
instanceStruct.instanceVar_STBGIDLD_i = modelStruct.modelPar_STBGIDLDO;
instanceStruct.d_instanceVar_CGIDL_i_dX = modelStruct.d_modelPar_CGIDLO_dX;
instanceStruct.instanceVar_CGIDL_i = modelStruct.modelPar_CGIDLO;
instanceStruct.d_instanceVar_CGIDLD_i_dX = modelStruct.d_modelPar_CGIDLDO_dX;
instanceStruct.instanceVar_CGIDLD_i = modelStruct.modelPar_CGIDLDO;
instanceStruct.d_instanceVar_DGIDL_i_dX = (modelStruct.d_modelPar_DGIDLO_dX+(modelStruct.modelPar_DGIDLL*d_iLE_dX+modelStruct.d_modelPar_DGIDLL_dX*iLE));
instanceStruct.instanceVar_DGIDL_i = (modelStruct.modelPar_DGIDLO+(modelStruct.modelPar_DGIDLL*iLE));
instanceStruct.d_instanceVar_DGIDLD_i_dX = (modelStruct.d_modelPar_DGIDLDO_dX+(modelStruct.modelPar_DGIDLDL*d_iLE_dX+modelStruct.d_modelPar_DGIDLDL_dX*iLE));
instanceStruct.instanceVar_DGIDLD_i = (modelStruct.modelPar_DGIDLDO+(modelStruct.modelPar_DGIDLDL*iLE));
d_A1_p_dX = ((modelStruct.modelPar_A1O*(1.0+(modelStruct.modelPar_A1L*iLE)))*(modelStruct.modelPar_A1W*d_iWE_dX+modelStruct.d_modelPar_A1W_dX*iWE)+(modelStruct.modelPar_A1O*(modelStruct.modelPar_A1L*d_iLE_dX+modelStruct.d_modelPar_A1L_dX*iLE)+modelStruct.d_modelPar_A1O_dX*(1.0+(modelStruct.modelPar_A1L*iLE)))*(1.0+(modelStruct.modelPar_A1W*iWE)));
A1_p = ((modelStruct.modelPar_A1O*(1.0+(modelStruct.modelPar_A1L*iLE)))*(1.0+(modelStruct.modelPar_A1W*iWE)));
{
double value_max_0 = std::max(A1_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((A1_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_A1_i_dX = (deriv_max_0_d0*(d_A1_p_dX));
instanceStruct.instanceVar_A1_i = value_max_0;
}
instanceStruct.d_instanceVar_A2_t_dX = modelStruct.d_modelPar_A2O_dX;
instanceStruct.instanceVar_A2_t = modelStruct.modelPar_A2O;
instanceStruct.d_instanceVar_STA2_i_dX = modelStruct.d_modelPar_STA2O_dX;
instanceStruct.instanceVar_STA2_i = modelStruct.modelPar_STA2O;
d_A3_p_dX = ((modelStruct.modelPar_A3O*(1.0+(modelStruct.modelPar_A3L*iLE)))*(modelStruct.modelPar_A3W*d_iWE_dX+modelStruct.d_modelPar_A3W_dX*iWE)+(modelStruct.modelPar_A3O*(modelStruct.modelPar_A3L*d_iLE_dX+modelStruct.d_modelPar_A3L_dX*iLE)+modelStruct.d_modelPar_A3O_dX*(1.0+(modelStruct.modelPar_A3L*iLE)))*(1.0+(modelStruct.modelPar_A3W*iWE)));
A3_p = ((modelStruct.modelPar_A3O*(1.0+(modelStruct.modelPar_A3L*iLE)))*(1.0+(modelStruct.modelPar_A3W*iWE)));
{
double value_max_0 = std::max(A3_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((A3_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_A3_i_dX = (deriv_max_0_d0*(d_A3_p_dX));
instanceStruct.instanceVar_A3_i = value_max_0;
}
instanceStruct.d_instanceVar_AREAQ_i_dX = (WEcv*d_LEcv_dX+d_WEcv_dX*LEcv);
instanceStruct.instanceVar_AREAQ_i = (WEcv*LEcv);
d_CGBOV_p_dX = (modelStruct.d_modelPar_CGBOVO_dX+(modelStruct.modelPar_CGBOVL*d_lphy_dX+modelStruct.d_modelPar_CGBOVL_dX*lphy));
CGBOV_p = (modelStruct.modelPar_CGBOVO+(modelStruct.modelPar_CGBOVL*lphy));
{
double value_max_0 = std::max(CGBOV_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CGBOV_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CGBOV_i_dX = (deriv_max_0_d0*(d_CGBOV_p_dX));
instanceStruct.instanceVar_CGBOV_i = value_max_0;
}
instanceStruct.d_instanceVar_NSDAC_i_dX = modelStruct.d_modelPar_NSDACO_dX*1.0e6;
instanceStruct.instanceVar_NSDAC_i = (modelStruct.modelPar_NSDACO*1.0e6);
instanceStruct.d_instanceVar_FIF_i_dX = ((modelStruct.modelPar_FIFW*d_WEcv_dX+modelStruct.d_modelPar_FIFW_dX*WEcv)/WEN);
instanceStruct.instanceVar_FIF_i = ((modelStruct.modelPar_FIFW*WEcv)/WEN);
instanceStruct.d_instanceVar_FSCEAC_i_dX = modelStruct.d_modelPar_FSCEACO_dX;
instanceStruct.instanceVar_FSCEAC_i = modelStruct.modelPar_FSCEACO;
instanceStruct.d_instanceVar_temp_dX = ((3.45313E-11/TOX1_i)*d_WEcv_dX+(-3.45313E-11*d_TOX1_i_dX/TOX1_i/TOX1_i)*WEcv);
instanceStruct.instanceVar_temp = ((3.45313E-11/TOX1_i)*WEcv);
instanceStruct.d_instanceVar_COV_i_dX = (instanceStruct.instanceVar_temp*modelStruct.d_modelPar_LOVO_dX+instanceStruct.d_instanceVar_temp_dX*modelStruct.modelPar_LOVO);
instanceStruct.instanceVar_COV_i = (instanceStruct.instanceVar_temp*modelStruct.modelPar_LOVO);
instanceStruct.d_instanceVar_COVD_i_dX = (instanceStruct.instanceVar_temp*modelStruct.d_modelPar_LOVDO_dX+instanceStruct.d_instanceVar_temp_dX*modelStruct.modelPar_LOVDO);
instanceStruct.instanceVar_COVD_i = (instanceStruct.instanceVar_temp*modelStruct.modelPar_LOVDO);
{
double value_max_0 = std::max((1.0+((modelStruct.modelPar_COVDLW*WEN)/WEcv)),static_cast<double>(1.0e-3));
double  deriv_max_0_d0 = (((1.0+((modelStruct.modelPar_COVDLW*WEN)/WEcv))>=1.0e-3)?1.0:0.0);
instanceStruct.d_instanceVar_COVDL_i_dX = ((value_max_0*modelStruct.d_modelPar_COVDLO_dX-modelStruct.modelPar_COVDLO*(deriv_max_0_d0*(((WEcv*modelStruct.d_modelPar_COVDLW_dX*WEN-(modelStruct.modelPar_COVDLW*WEN)*d_WEcv_dX)/WEcv/WEcv))))/value_max_0/value_max_0);
instanceStruct.instanceVar_COVDL_i = (modelStruct.modelPar_COVDLO/value_max_0);
}
instanceStruct.d_instanceVar_COVDLB_i_dX = modelStruct.d_modelPar_COVDLBO_dX;
instanceStruct.instanceVar_COVDLB_i = modelStruct.modelPar_COVDLBO;
instanceStruct.d_instanceVar_DVFBOV_i_dX = modelStruct.d_modelPar_DVFBOVO_dX;
instanceStruct.instanceVar_DVFBOV_i = modelStruct.modelPar_DVFBOVO;
d_CFR_p_dX = (modelStruct.d_modelPar_CFRO_dX+(modelStruct.modelPar_CFRW*d_wphy_dX+modelStruct.d_modelPar_CFRW_dX*wphy));
CFR_p = (modelStruct.modelPar_CFRO+(modelStruct.modelPar_CFRW*wphy));
{
double value_max_0 = std::max(CFR_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CFR_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CFR_i_dX = (deriv_max_0_d0*(d_CFR_p_dX));
instanceStruct.instanceVar_CFR_i = value_max_0;
}
d_CFRD_p_dX = (modelStruct.d_modelPar_CFRDO_dX+(modelStruct.modelPar_CFRDW*d_wphy_dX+modelStruct.d_modelPar_CFRDW_dX*wphy));
CFRD_p = (modelStruct.modelPar_CFRDO+(modelStruct.modelPar_CFRDW*wphy));
{
double value_max_0 = std::max(CFRD_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CFRD_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CFRD_i_dX = (deriv_max_0_d0*(d_CFRD_p_dX));
instanceStruct.instanceVar_CFRD_i = value_max_0;
}
instanceStruct.d_instanceVar_CSD_i_dX = ((LE*(((modelStruct.modelPar_CSDO*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_TSI_i)*d_WE_dX+((modelStruct.modelPar_CSDO*instanceStruct.instanceVar_epsch)*instanceStruct.d_instanceVar_TSI_i_dX+(modelStruct.modelPar_CSDO*instanceStruct.d_instanceVar_epsch_dX+modelStruct.d_modelPar_CSDO_dX*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_TSI_i)*WE)-(((modelStruct.modelPar_CSDO*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_TSI_i)*WE)*d_LE_dX)/LE/LE);
instanceStruct.instanceVar_CSD_i = ((((modelStruct.modelPar_CSDO*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_TSI_i)*WE)/LE);
instanceStruct.d_instanceVar_CSDBP_i_dX = modelStruct.d_modelPar_CSDBPO_dX;
instanceStruct.instanceVar_CSDBP_i = modelStruct.modelPar_CSDBPO;
{
double value_max_0 = std::max((((1.0+(modelStruct.modelPar_RTHL*lphy))+(modelStruct.modelPar_RTHW*wphy))+((modelStruct.modelPar_RTHLW*lphy)*wphy)),static_cast<double>(1.0e-10));
double  deriv_max_0_d0 = (((((1.0+(modelStruct.modelPar_RTHL*lphy))+(modelStruct.modelPar_RTHW*wphy))+((modelStruct.modelPar_RTHLW*lphy)*wphy))>=1.0e-10)?1.0:0.0);
instanceStruct.d_instanceVar_temp_dX = (deriv_max_0_d0*((((modelStruct.modelPar_RTHL*d_lphy_dX+modelStruct.d_modelPar_RTHL_dX*lphy)+(modelStruct.modelPar_RTHW*d_wphy_dX+modelStruct.d_modelPar_RTHW_dX*wphy))+((modelStruct.modelPar_RTHLW*lphy)*d_wphy_dX+(modelStruct.modelPar_RTHLW*d_lphy_dX+modelStruct.d_modelPar_RTHLW_dX*lphy)*wphy))));
instanceStruct.instanceVar_temp = value_max_0;
}
instanceStruct.d_instanceVar_temp1_dX = 0.0;
instanceStruct.instanceVar_temp1 = 0.0;
if (((instanceStruct.instancePar_NF>1.0)&&(instanceStruct.instancePar_SD>0.0)))
{
instanceStruct.d_instanceVar_temp2_dX = ((modelStruct.modelPar_LAMBTHO*(-(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX))-(-(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))*modelStruct.d_modelPar_LAMBTHO_dX)/modelStruct.modelPar_LAMBTHO/modelStruct.modelPar_LAMBTHO);
instanceStruct.instanceVar_temp2 = ((-(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))/modelStruct.modelPar_LAMBTHO);
if ((fabs(instanceStruct.instanceVar_temp2)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp2);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp3_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp2_dX);
instanceStruct.instanceVar_temp3 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp2<(-80.0)))
{
instanceStruct.d_instanceVar_temp3_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp2)-80.0)*((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(-instanceStruct.d_instanceVar_temp2_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp2_dX)*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp2_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp3 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp3_dX = 5.54062e34*((instanceStruct.instanceVar_temp2-80.0)*((0.5*(instanceStruct.instanceVar_temp2-80.0))*instanceStruct.d_instanceVar_temp2_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp2_dX*(1.0+((instanceStruct.instanceVar_temp2-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp2_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp2-80.0))*(1.0+((instanceStruct.instanceVar_temp2-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp3 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp2-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp2-80.0))*(1.0+((instanceStruct.instanceVar_temp2-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp4_dX = (-instanceStruct.d_instanceVar_temp3_dX);
instanceStruct.instanceVar_temp4 = (1.0-instanceStruct.instanceVar_temp3);
{
double value_pow_0 = pow(instanceStruct.instanceVar_temp3,instanceStruct.instancePar_NF);
double  deriv_pow_0_d0 = ((instanceStruct.instanceVar_temp3 == 0.0)?0.0:(value_pow_0*instanceStruct.instancePar_NF/instanceStruct.instanceVar_temp3));
instanceStruct.d_instanceVar_temp1_dX = (((instanceStruct.instanceVar_temp4*instanceStruct.instanceVar_temp4)*(((2.0*modelStruct.modelPar_FTHO)*instanceStruct.instanceVar_temp3)*(instanceStruct.d_instanceVar_temp4_dX-((-(deriv_pow_0_d0*(instanceStruct.d_instanceVar_temp3_dX)))/instanceStruct.instancePar_NF))+((2.0*modelStruct.modelPar_FTHO)*instanceStruct.d_instanceVar_temp3_dX+2.0*modelStruct.d_modelPar_FTHO_dX*instanceStruct.instanceVar_temp3)*(instanceStruct.instanceVar_temp4-((1.0-value_pow_0)/instanceStruct.instancePar_NF)))-(((2.0*modelStruct.modelPar_FTHO)*instanceStruct.instanceVar_temp3)*(instanceStruct.instanceVar_temp4-((1.0-value_pow_0)/instanceStruct.instancePar_NF)))*(instanceStruct.instanceVar_temp4*instanceStruct.d_instanceVar_temp4_dX+instanceStruct.d_instanceVar_temp4_dX*instanceStruct.instanceVar_temp4))/(instanceStruct.instanceVar_temp4*instanceStruct.instanceVar_temp4)/(instanceStruct.instanceVar_temp4*instanceStruct.instanceVar_temp4));
instanceStruct.instanceVar_temp1 = ((((2.0*modelStruct.modelPar_FTHO)*instanceStruct.instanceVar_temp3)*(instanceStruct.instanceVar_temp4-((1.0-value_pow_0)/instanceStruct.instancePar_NF)))/(instanceStruct.instanceVar_temp4*instanceStruct.instanceVar_temp4));
}
}
instanceStruct.d_instanceVar_temp_dX = (((1.0+instanceStruct.instanceVar_temp1)*instanceStruct.d_instanceVar_temp_dX-instanceStruct.instanceVar_temp*instanceStruct.d_instanceVar_temp1_dX)/(1.0+instanceStruct.instanceVar_temp1)/(1.0+instanceStruct.instanceVar_temp1));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_temp/(1.0+instanceStruct.instanceVar_temp1));
d_RTH_p_dX = ((instanceStruct.instanceVar_temp*modelStruct.d_modelPar_RTHO_dX-modelStruct.modelPar_RTHO*instanceStruct.d_instanceVar_temp_dX)/instanceStruct.instanceVar_temp/instanceStruct.instanceVar_temp);
RTH_p = (modelStruct.modelPar_RTHO/instanceStruct.instanceVar_temp);
{
double value_max_0 = std::max(RTH_p,static_cast<double>(1.0e-6));
double  deriv_max_0_d0 = ((RTH_p>=1.0e-6)?1.0:0.0);
instanceStruct.d_instanceVar_RTH_t_dX = (deriv_max_0_d0*(d_RTH_p_dX));
instanceStruct.instanceVar_RTH_t = value_max_0;
}
instanceStruct.d_instanceVar_STRTH_i_dX = modelStruct.d_modelPar_STRTHO_dX;
instanceStruct.instanceVar_STRTH_i = modelStruct.modelPar_STRTHO;
d_CTH_p_dX = (modelStruct.modelPar_CTHO*instanceStruct.d_instanceVar_temp_dX+modelStruct.d_modelPar_CTHO_dX*instanceStruct.instanceVar_temp);
CTH_p = (modelStruct.modelPar_CTHO*instanceStruct.instanceVar_temp);
{
double value_max_0 = std::max(CTH_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CTH_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CTH_i_dX = (deriv_max_0_d0*(d_CTH_p_dX));
instanceStruct.instanceVar_CTH_i = value_max_0;
}
instanceStruct.d_instanceVar_FNT_i_dX = modelStruct.d_modelPar_FNTO_dX;
instanceStruct.instanceVar_FNT_i = modelStruct.modelPar_FNTO;
{
double value_pow_0 = pow(iLE,(modelStruct.modelPar_FNTEXCLEXP-2.0));
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*(modelStruct.modelPar_FNTEXCLEXP-2.0)/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
instanceStruct.d_instanceVar_FNTEXC_i_dX = (((((modelStruct.modelPar_FNTEXCL*BETN_p)*BETN_p)*iWE)*iWE)*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_FNTEXCLEXP_dX)))+((((modelStruct.modelPar_FNTEXCL*BETN_p)*BETN_p)*iWE)*d_iWE_dX+(((modelStruct.modelPar_FNTEXCL*BETN_p)*BETN_p)*d_iWE_dX+((modelStruct.modelPar_FNTEXCL*BETN_p)*d_BETN_p_dX+(modelStruct.modelPar_FNTEXCL*d_BETN_p_dX+modelStruct.d_modelPar_FNTEXCL_dX*BETN_p)*BETN_p)*iWE)*iWE)*value_pow_0);
instanceStruct.instanceVar_FNTEXC_i = (((((modelStruct.modelPar_FNTEXCL*BETN_p)*BETN_p)*iWE)*iWE)*value_pow_0);
}
d_NFA_p_dX = ((modelStruct.modelPar_NFALW*d_iAE_dX+modelStruct.d_modelPar_NFALW_dX*iAE)+(modelStruct.modelPar_NFAW*d_iWE_dX+modelStruct.d_modelPar_NFAW_dX*iWE));
NFA_p = ((modelStruct.modelPar_NFALW*iAE)+(modelStruct.modelPar_NFAW*iWE));
{
double value_max_0 = std::max(NFA_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((NFA_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_NFA_i_dX = (deriv_max_0_d0*(d_NFA_p_dX));
instanceStruct.instanceVar_NFA_i = value_max_0;
}
instanceStruct.d_instanceVar_NFB_i_dX = (modelStruct.modelPar_NFBLW*d_iAE_dX+modelStruct.d_modelPar_NFBLW_dX*iAE);
instanceStruct.instanceVar_NFB_i = (modelStruct.modelPar_NFBLW*iAE);
instanceStruct.d_instanceVar_NFC_i_dX = (modelStruct.modelPar_NFCLW*d_iAE_dX+modelStruct.d_modelPar_NFCLW_dX*iAE);
instanceStruct.instanceVar_NFC_i = (modelStruct.modelPar_NFCLW*iAE);
instanceStruct.d_instanceVar_NFE_i_dX = modelStruct.d_modelPar_NFEO_dX;
instanceStruct.instanceVar_NFE_i = modelStruct.modelPar_NFEO;
instanceStruct.d_instanceVar_NFEB_i_dX = modelStruct.d_modelPar_NFEBO_dX;
instanceStruct.instanceVar_NFEB_i = modelStruct.modelPar_NFEBO;
instanceStruct.d_instanceVar_EF_i_dX = modelStruct.d_modelPar_EFO_dX;
instanceStruct.instanceVar_EF_i = modelStruct.modelPar_EFO;
if (((((modelStruct.modelPar_SWSTRESS>0)&&(instanceStruct.instancePar_SA>0.0))&&(instanceStruct.instancePar_SB>0.0))&&((instanceStruct.instancePar_NF==1.0)||((instanceStruct.instancePar_NF>1.0)&&(instanceStruct.instancePar_SD>0.0)))))
{
if ((modelStruct.modelPar_SWSTRESS==1))
{
d_tmpa_dX = 0.0;
tmpa = 0.0;
d_tmpb_dX = 0.0;
tmpb = 0.0;
iloop = 0.0;
while ((iloop<(instanceStruct.instancePar_NF-0.5)))
{
d_tmpa_dX = (d_tmpa_dX+(-((instanceStruct.d_instancePar_SA_dX+0.5*instanceStruct.d_instancePar_L_dX)+iloop*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX))/((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L)))/((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L)))));
tmpa = (tmpa+(1.0/((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L)))));
d_tmpb_dX = (d_tmpb_dX+(-((instanceStruct.d_instancePar_SB_dX+0.5*instanceStruct.d_instancePar_L_dX)+iloop*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX))/((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L)))/((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L)))));
tmpb = (tmpb+(1.0/((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L)))));
iloop = (iloop+1.0);
}
d_Invsa_dX = (d_tmpa_dX/instanceStruct.instancePar_NF);
Invsa = (tmpa/instanceStruct.instancePar_NF);
d_Invsb_dX = (d_tmpb_dX/instanceStruct.instancePar_NF);
Invsb = (tmpb/instanceStruct.instancePar_NF);
d_Invsaref_dX = (-(modelStruct.d_modelPar_SAREF_dX+0.5*instanceStruct.d_instancePar_L_dX)/(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L))/(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)));
Invsaref = (1.0/(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)));
d_Invsbref_dX = (-(modelStruct.d_modelPar_SBREF_dX+0.5*instanceStruct.d_instancePar_L_dX)/(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L))/(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)));
Invsbref = (1.0/(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)));
{
double value_max_0 = std::max((instanceStruct.instancePar_L+delLPS),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = (((instanceStruct.instancePar_L+delLPS)>=1.0e-9)?1.0:0.0);
d_Lx_dX = (deriv_max_0_d0*((instanceStruct.d_instancePar_L_dX+d_delLPS_dX)));
Lx = value_max_0;
}
{
double value_max_0 = std::max(((W_i+delWOD)+modelStruct.modelPar_WLOD),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = ((((W_i+delWOD)+modelStruct.modelPar_WLOD)>=1.0e-9)?1.0:0.0);
d_Wx_dX = (deriv_max_0_d0*(((d_W_i_dX+d_delWOD_dX)+modelStruct.d_modelPar_WLOD_dX)));
Wx = value_max_0;
}
{
double value_pow_0 = pow(Lx,modelStruct.modelPar_LLODKUO);
double  deriv_pow_0_d0 = ((Lx == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_LLODKUO/Lx));
double  deriv_pow_0_d1 = (Lx == 0.0)?0.0:(log(Lx)*value_pow_0);
d_templ_dX = (-((deriv_pow_0_d0*(d_Lx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_LLODKUO_dX)))/value_pow_0/value_pow_0);
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,modelStruct.modelPar_WLODKUO);
double  deriv_pow_0_d0 = ((Wx == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_WLODKUO/Wx));
double  deriv_pow_0_d1 = (Wx == 0.0)?0.0:(log(Wx)*value_pow_0);
d_tempw_dX = (-((deriv_pow_0_d0*(d_Wx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_WLODKUO_dX)))/value_pow_0/value_pow_0);
tempw = (1.0/value_pow_0);
}
d_Kstressu0_dX = ((((1.0+(modelStruct.modelPar_LKUO*templ))+(modelStruct.modelPar_WKUO*tempw))+((modelStruct.modelPar_PKUO*templ)*tempw))*(modelStruct.modelPar_TKUO*instanceStruct.d_instanceVar_rT_dX+modelStruct.d_modelPar_TKUO_dX*(instanceStruct.instanceVar_rT-1.0))+(((modelStruct.modelPar_LKUO*d_templ_dX+modelStruct.d_modelPar_LKUO_dX*templ)+(modelStruct.modelPar_WKUO*d_tempw_dX+modelStruct.d_modelPar_WKUO_dX*tempw))+((modelStruct.modelPar_PKUO*templ)*d_tempw_dX+(modelStruct.modelPar_PKUO*d_templ_dX+modelStruct.d_modelPar_PKUO_dX*templ)*tempw))*(1.0+(modelStruct.modelPar_TKUO*(instanceStruct.instanceVar_rT-1.0))));
Kstressu0 = ((((1.0+(modelStruct.modelPar_LKUO*templ))+(modelStruct.modelPar_WKUO*tempw))+((modelStruct.modelPar_PKUO*templ)*tempw))*(1.0+(modelStruct.modelPar_TKUO*(instanceStruct.instanceVar_rT-1.0))));
d_rhobeta_dX = ((Kstressu0*(modelStruct.modelPar_KUO*(d_Invsa_dX+d_Invsb_dX)+modelStruct.d_modelPar_KUO_dX*(Invsa+Invsb))-(modelStruct.modelPar_KUO*(Invsa+Invsb))*d_Kstressu0_dX)/Kstressu0/Kstressu0);
rhobeta = ((modelStruct.modelPar_KUO*(Invsa+Invsb))/Kstressu0);
d_rhobetaref_dX = ((Kstressu0*(modelStruct.modelPar_KUO*(d_Invsaref_dX+d_Invsbref_dX)+modelStruct.d_modelPar_KUO_dX*(Invsaref+Invsbref))-(modelStruct.modelPar_KUO*(Invsaref+Invsbref))*d_Kstressu0_dX)/Kstressu0/Kstressu0);
rhobetaref = ((modelStruct.modelPar_KUO*(Invsaref+Invsbref))/Kstressu0);
{
double value_pow_0 = pow(Lx,modelStruct.modelPar_LLODVTH);
double  deriv_pow_0_d0 = ((Lx == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_LLODVTH/Lx));
double  deriv_pow_0_d1 = (Lx == 0.0)?0.0:(log(Lx)*value_pow_0);
d_templ_dX = (-((deriv_pow_0_d0*(d_Lx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_LLODVTH_dX)))/value_pow_0/value_pow_0);
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,modelStruct.modelPar_WLODVTH);
double  deriv_pow_0_d0 = ((Wx == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_WLODVTH/Wx));
double  deriv_pow_0_d1 = (Wx == 0.0)?0.0:(log(Wx)*value_pow_0);
d_tempw_dX = (-((deriv_pow_0_d0*(d_Wx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_WLODVTH_dX)))/value_pow_0/value_pow_0);
tempw = (1.0/value_pow_0);
}
{
double value_max_0 = std::max((((1.0+(modelStruct.modelPar_LKVTHO*templ))+(modelStruct.modelPar_WKVTHO*tempw))+((modelStruct.modelPar_PKVTHO*templ)*tempw)),static_cast<double>(1e-20));
double  deriv_max_0_d0 = (((((1.0+(modelStruct.modelPar_LKVTHO*templ))+(modelStruct.modelPar_WKVTHO*tempw))+((modelStruct.modelPar_PKVTHO*templ)*tempw))>=1e-20)?1.0:0.0);
d_Kstressvth0_dX = (deriv_max_0_d0*((((modelStruct.modelPar_LKVTHO*d_templ_dX+modelStruct.d_modelPar_LKVTHO_dX*templ)+(modelStruct.modelPar_WKVTHO*d_tempw_dX+modelStruct.d_modelPar_WKVTHO_dX*tempw))+((modelStruct.modelPar_PKVTHO*templ)*d_tempw_dX+(modelStruct.modelPar_PKVTHO*d_templ_dX+modelStruct.d_modelPar_PKVTHO_dX*templ)*tempw))));
Kstressvth0 = value_max_0;
}
d_temp0_dX = (((d_Invsa_dX+d_Invsb_dX)-d_Invsaref_dX)-d_Invsbref_dX);
temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
d_BETN_p_dX = (((1.0+rhobetaref)*(BETN_p*d_rhobeta_dX+d_BETN_p_dX*(1.0+rhobeta))-(BETN_p*(1.0+rhobeta))*d_rhobetaref_dX)/(1.0+rhobetaref)/(1.0+rhobetaref));
BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
{
double value_max_0 = std::max(BETN_p,static_cast<double>(1.0e-10));
double  deriv_max_0_d0 = ((BETN_p>=1.0e-10)?1.0:0.0);
instanceStruct.d_instanceVar_BETN1_t_dX = (deriv_max_0_d0*(d_BETN_p_dX));
instanceStruct.instanceVar_BETN1_t = value_max_0;
}
instanceStruct.d_instanceVar_BETN2_t_dX = (modelStruct.modelPar_BETNBO*instanceStruct.d_instanceVar_BETN1_t_dX+modelStruct.d_modelPar_BETNBO_dX*instanceStruct.instanceVar_BETN1_t);
instanceStruct.instanceVar_BETN2_t = (modelStruct.modelPar_BETNBO*instanceStruct.instanceVar_BETN1_t);
d_THESAT_p_dX = ((((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_KVSAT*rhobeta)))*((THESAT_p*(1.0+rhobeta))*(modelStruct.modelPar_KVSAT*d_rhobetaref_dX+modelStruct.d_modelPar_KVSAT_dX*rhobetaref)+(THESAT_p*d_rhobeta_dX+d_THESAT_p_dX*(1.0+rhobeta))*(1.0+(modelStruct.modelPar_KVSAT*rhobetaref)))-((THESAT_p*(1.0+rhobeta))*(1.0+(modelStruct.modelPar_KVSAT*rhobetaref)))*((1.0+rhobetaref)*(modelStruct.modelPar_KVSAT*d_rhobeta_dX+modelStruct.d_modelPar_KVSAT_dX*rhobeta)+d_rhobetaref_dX*(1.0+(modelStruct.modelPar_KVSAT*rhobeta))))/((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_KVSAT*rhobeta)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_KVSAT*rhobeta))));
THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+(modelStruct.modelPar_KVSAT*rhobetaref)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_KVSAT*rhobeta))));
{
double value_max_0 = std::max(THESAT_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((THESAT_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_THESAT_t_dX = (deriv_max_0_d0*(d_THESAT_p_dX));
instanceStruct.instanceVar_THESAT_t = value_max_0;
}
instanceStruct.d_instanceVar_VFB1_t_dX = (instanceStruct.d_instanceVar_VFB1_t_dX+((Kstressvth0*(modelStruct.modelPar_KVTHO*d_temp0_dX+modelStruct.d_modelPar_KVTHO_dX*temp0)-(modelStruct.modelPar_KVTHO*temp0)*d_Kstressvth0_dX)/Kstressvth0/Kstressvth0));
instanceStruct.instanceVar_VFB1_t = (instanceStruct.instanceVar_VFB1_t+((modelStruct.modelPar_KVTHO*temp0)/Kstressvth0));
instanceStruct.d_instanceVar_VFB2_t_dX = (instanceStruct.d_instanceVar_VFB2_t_dX+((Kstressvth0*(modelStruct.modelPar_KVTHO*d_temp0_dX+modelStruct.d_modelPar_KVTHO_dX*temp0)-(modelStruct.modelPar_KVTHO*temp0)*d_Kstressvth0_dX)/Kstressvth0/Kstressvth0));
instanceStruct.instanceVar_VFB2_t = (instanceStruct.instanceVar_VFB2_t+((modelStruct.modelPar_KVTHO*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,modelStruct.modelPar_LODETAO);
double  deriv_pow_0_d0 = ((Kstressvth0 == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_LODETAO/Kstressvth0));
double  deriv_pow_0_d1 = (Kstressvth0 == 0.0)?0.0:(log(Kstressvth0)*value_pow_0);
d_CF_p_dX = (d_CF_p_dX+((value_pow_0*(modelStruct.modelPar_STETAO*d_temp0_dX+modelStruct.d_modelPar_STETAO_dX*temp0)-(modelStruct.modelPar_STETAO*temp0)*((deriv_pow_0_d0*(d_Kstressvth0_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_LODETAO_dX))))/value_pow_0/value_pow_0));
CF_p = (CF_p+((modelStruct.modelPar_STETAO*temp0)/value_pow_0));
}
{
double value_max_0 = std::max(CF_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CF_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CF1_t_dX = (deriv_max_0_d0*(d_CF_p_dX));
instanceStruct.instanceVar_CF1_t = value_max_0;
}
instanceStruct.d_instanceVar_CF2_t_dX = ((TOX1_i*((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*d_TOX2_i_dX+(modelStruct.modelPar_CFBO*instanceStruct.d_instanceVar_CF1_t_dX+modelStruct.d_modelPar_CFBO_dX*instanceStruct.instanceVar_CF1_t)*TOX2_i)-((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*TOX2_i)*d_TOX1_i_dX)/TOX1_i/TOX1_i);
instanceStruct.instanceVar_CF2_t = (((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*TOX2_i)/TOX1_i);
}
else
{
d_tmpa_dX = 0.0;
tmpa = 0.0;
iloop = 0.0;
instanceStruct.d_instanceVar_temp_dX = (-(-1.0)*modelStruct.d_modelPar_STRALPHA_dX/modelStruct.modelPar_STRALPHA/modelStruct.modelPar_STRALPHA);
instanceStruct.instanceVar_temp = ((-1.0)/modelStruct.modelPar_STRALPHA);
while ((iloop<(instanceStruct.instancePar_NF-0.5)))
{
if ((((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA)>(-80.0)))
{
{
double value_exp_0 = exp(((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp1_dX = deriv_exp_0_d0*(((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SA_dX+0.5*instanceStruct.d_instancePar_L_dX)+iloop*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA));
instanceStruct.instanceVar_temp1 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = (-1.80485e-35*(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*((0.5*((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(-((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SA_dX+0.5*instanceStruct.d_instancePar_L_dX)+iloop*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*0.3333333333333+0.5*(-((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SA_dX+0.5*instanceStruct.d_instancePar_L_dX)+iloop*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))+(-((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SA_dX+0.5*instanceStruct.d_instancePar_L_dX)+iloop*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+((0.5*((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))/(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333))))))/(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp1 = (1.80485e-35/(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SA+(0.5*instanceStruct.instancePar_L))+(iloop*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
}
if ((((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA)>(-80.0)))
{
{
double value_exp_0 = exp(((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp2_dX = deriv_exp_0_d0*(((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SB_dX+0.5*instanceStruct.d_instancePar_L_dX)+((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA));
instanceStruct.instanceVar_temp2 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_temp2_dX = (-1.80485e-35*(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*((0.5*((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(-((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SB_dX+0.5*instanceStruct.d_instancePar_L_dX)+((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*0.3333333333333+0.5*(-((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SB_dX+0.5*instanceStruct.d_instancePar_L_dX)+((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))+(-((modelStruct.modelPar_STRLAMBDA*(-((instanceStruct.d_instancePar_SB_dX+0.5*instanceStruct.d_instancePar_L_dX)+((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.d_instancePar_SD_dX+instanceStruct.d_instancePar_L_dX)))-(-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+((0.5*((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))/(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333))))))/(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp2 = (1.80485e-35/(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-((instanceStruct.instancePar_SB+(0.5*instanceStruct.instancePar_L))+(((instanceStruct.instancePar_NF-1.0)-iloop)*(instanceStruct.instancePar_SD+instanceStruct.instancePar_L))))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
}
{
double value_pow_0 = pow((1.0-instanceStruct.instanceVar_temp1),(-modelStruct.modelPar_STRALPHA));
double  deriv_pow_0_d0 = (((1.0-instanceStruct.instanceVar_temp1) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_STRALPHA)/(1.0-instanceStruct.instanceVar_temp1)));
double  deriv_pow_0_d1 = ((1.0-instanceStruct.instanceVar_temp1) == 0.0)?0.0:(log((1.0-instanceStruct.instanceVar_temp1))*value_pow_0);
instanceStruct.d_instanceVar_temp3_dX = ((deriv_pow_0_d0*((-instanceStruct.d_instanceVar_temp1_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_STRALPHA_dX))));
instanceStruct.instanceVar_temp3 = value_pow_0;
}
{
double value_pow_0 = pow((1.0-instanceStruct.instanceVar_temp2),(-modelStruct.modelPar_STRALPHA));
double  deriv_pow_0_d0 = (((1.0-instanceStruct.instanceVar_temp2) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_STRALPHA)/(1.0-instanceStruct.instanceVar_temp2)));
double  deriv_pow_0_d1 = ((1.0-instanceStruct.instanceVar_temp2) == 0.0)?0.0:(log((1.0-instanceStruct.instanceVar_temp2))*value_pow_0);
instanceStruct.d_instanceVar_temp4_dX = ((deriv_pow_0_d0*((-instanceStruct.d_instanceVar_temp2_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_STRALPHA_dX))));
instanceStruct.instanceVar_temp4 = value_pow_0;
}
{
double value_pow_0 = pow((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)),instanceStruct.instanceVar_temp);
double  deriv_pow_0_d0 = (((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_temp/(0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4))));
double  deriv_pow_0_d1 = ((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)) == 0.0)?0.0:(log((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)))*value_pow_0);
d_tmpa_dX = (d_tmpa_dX+((deriv_pow_0_d0*(0.5*(instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_temp4_dX)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_temp_dX))));
tmpa = (tmpa+value_pow_0);
}
iloop = (iloop+1.0);
}
d_str_g_dX = (-(d_tmpa_dX/instanceStruct.instancePar_NF));
str_g = (1.0-(tmpa/instanceStruct.instancePar_NF));
if ((((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA)>(-80.0)))
{
{
double value_exp_0 = exp(((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp1_dX = deriv_exp_0_d0*(((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SAREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA));
instanceStruct.instanceVar_temp1 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = (-1.80485e-35*(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*((0.5*((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(-((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SAREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*0.3333333333333+0.5*(-((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SAREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))+(-((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SAREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+((0.5*((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))/(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333))))))/(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp1 = (1.80485e-35/(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SAREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
}
if ((((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA)>(-80.0)))
{
{
double value_exp_0 = exp(((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp2_dX = deriv_exp_0_d0*(((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SBREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA));
instanceStruct.instanceVar_temp2 = value_exp_0;
}
}
else
{
instanceStruct.d_instanceVar_temp2_dX = (-1.80485e-35*(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*((0.5*((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(-((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SBREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*0.3333333333333+0.5*(-((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SBREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))+(-((modelStruct.modelPar_STRLAMBDA*(-(modelStruct.d_modelPar_SBREF_dX+0.5*instanceStruct.d_instancePar_L_dX))-(-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))*modelStruct.d_modelPar_STRLAMBDA_dX)/modelStruct.modelPar_STRLAMBDA/modelStruct.modelPar_STRLAMBDA))*(1.0+((0.5*((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))/(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333))))))/(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp2 = (1.80485e-35/(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*(1.0+((0.5*((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0))*(1.0+(((-((-(modelStruct.modelPar_SBREF+(0.5*instanceStruct.instancePar_L)))/modelStruct.modelPar_STRLAMBDA))-80.0)*0.3333333333333)))))));
}
{
double value_pow_0 = pow((1.0-instanceStruct.instanceVar_temp1),(-modelStruct.modelPar_STRALPHA));
double  deriv_pow_0_d0 = (((1.0-instanceStruct.instanceVar_temp1) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_STRALPHA)/(1.0-instanceStruct.instanceVar_temp1)));
double  deriv_pow_0_d1 = ((1.0-instanceStruct.instanceVar_temp1) == 0.0)?0.0:(log((1.0-instanceStruct.instanceVar_temp1))*value_pow_0);
instanceStruct.d_instanceVar_temp3_dX = ((deriv_pow_0_d0*((-instanceStruct.d_instanceVar_temp1_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_STRALPHA_dX))));
instanceStruct.instanceVar_temp3 = value_pow_0;
}
{
double value_pow_0 = pow((1.0-instanceStruct.instanceVar_temp2),(-modelStruct.modelPar_STRALPHA));
double  deriv_pow_0_d0 = (((1.0-instanceStruct.instanceVar_temp2) == 0.0)?0.0:(value_pow_0*(-modelStruct.modelPar_STRALPHA)/(1.0-instanceStruct.instanceVar_temp2)));
double  deriv_pow_0_d1 = ((1.0-instanceStruct.instanceVar_temp2) == 0.0)?0.0:(log((1.0-instanceStruct.instanceVar_temp2))*value_pow_0);
instanceStruct.d_instanceVar_temp4_dX = ((deriv_pow_0_d0*((-instanceStruct.d_instanceVar_temp2_dX)))+(deriv_pow_0_d1*((-modelStruct.d_modelPar_STRALPHA_dX))));
instanceStruct.instanceVar_temp4 = value_pow_0;
}
{
double value_pow_0 = pow((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)),instanceStruct.instanceVar_temp);
double  deriv_pow_0_d0 = (((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_temp/(0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4))));
double  deriv_pow_0_d1 = ((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)) == 0.0)?0.0:(log((0.5*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp4)))*value_pow_0);
d_str_gref_dX = (-((deriv_pow_0_d0*(0.5*(instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_temp4_dX)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_temp_dX))));
str_gref = (1.0-value_pow_0);
}
{
double value_max_0 = std::max(((W_i+delWOD)+modelStruct.modelPar_WLOD),static_cast<double>(1.0e-9));
double  deriv_max_0_d0 = ((((W_i+delWOD)+modelStruct.modelPar_WLOD)>=1.0e-9)?1.0:0.0);
d_Wx_dX = (deriv_max_0_d0*(((d_W_i_dX+d_delWOD_dX)+modelStruct.d_modelPar_WLOD_dX)));
Wx = value_max_0;
}
d_ruo_dX = (((1.0+(modelStruct.modelPar_STRTRUO*(instanceStruct.instanceVar_rT-1.0)))*modelStruct.d_modelPar_STRRUO_dX-modelStruct.modelPar_STRRUO*(modelStruct.modelPar_STRTRUO*instanceStruct.d_instanceVar_rT_dX+modelStruct.d_modelPar_STRTRUO_dX*(instanceStruct.instanceVar_rT-1.0)))/(1.0+(modelStruct.modelPar_STRTRUO*(instanceStruct.instanceVar_rT-1.0)))/(1.0+(modelStruct.modelPar_STRTRUO*(instanceStruct.instanceVar_rT-1.0))));
ruo = (modelStruct.modelPar_STRRUO/(1.0+(modelStruct.modelPar_STRTRUO*(instanceStruct.instanceVar_rT-1.0))));
d_rhobeta_dX = (ruo*d_str_g_dX+d_ruo_dX*str_g);
rhobeta = (ruo*str_g);
d_rhobetaref_dX = (ruo*d_str_gref_dX+d_ruo_dX*str_gref);
rhobetaref = (ruo*str_gref);
d_temp0_dX = (d_str_g_dX-d_str_gref_dX);
temp0 = (str_g-str_gref);
{
double value_max_0 = std::max((1.0+((modelStruct.modelPar_STRWDVFBO*Wx)/WEN)),static_cast<double>(1.0e-20));
double  deriv_max_0_d0 = (((1.0+((modelStruct.modelPar_STRWDVFBO*Wx)/WEN))>=1.0e-20)?1.0:0.0);
d_Kstressvth0_dX = (deriv_max_0_d0*(((modelStruct.modelPar_STRWDVFBO*d_Wx_dX+modelStruct.d_modelPar_STRWDVFBO_dX*Wx)/WEN)));
Kstressvth0 = value_max_0;
}
d_BETN_p_dX = (((1.0+rhobetaref)*(BETN_p*d_rhobeta_dX+d_BETN_p_dX*(1.0+rhobeta))-(BETN_p*(1.0+rhobeta))*d_rhobetaref_dX)/(1.0+rhobetaref)/(1.0+rhobetaref));
BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
{
double value_max_0 = std::max(BETN_p,static_cast<double>(1.0e-10));
double  deriv_max_0_d0 = ((BETN_p>=1.0e-10)?1.0:0.0);
instanceStruct.d_instanceVar_BETN1_t_dX = (deriv_max_0_d0*(d_BETN_p_dX));
instanceStruct.instanceVar_BETN1_t = value_max_0;
}
instanceStruct.d_instanceVar_BETN2_t_dX = (modelStruct.modelPar_BETNBO*instanceStruct.d_instanceVar_BETN1_t_dX+modelStruct.d_modelPar_BETNBO_dX*instanceStruct.instanceVar_BETN1_t);
instanceStruct.instanceVar_BETN2_t = (modelStruct.modelPar_BETNBO*instanceStruct.instanceVar_BETN1_t);
d_THESAT_p_dX = ((((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_STRRVSAT*rhobeta)))*((THESAT_p*(1.0+rhobeta))*(modelStruct.modelPar_STRRVSAT*d_rhobetaref_dX+modelStruct.d_modelPar_STRRVSAT_dX*rhobetaref)+(THESAT_p*d_rhobeta_dX+d_THESAT_p_dX*(1.0+rhobeta))*(1.0+(modelStruct.modelPar_STRRVSAT*rhobetaref)))-((THESAT_p*(1.0+rhobeta))*(1.0+(modelStruct.modelPar_STRRVSAT*rhobetaref)))*((1.0+rhobetaref)*(modelStruct.modelPar_STRRVSAT*d_rhobeta_dX+modelStruct.d_modelPar_STRRVSAT_dX*rhobeta)+d_rhobetaref_dX*(1.0+(modelStruct.modelPar_STRRVSAT*rhobeta))))/((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_STRRVSAT*rhobeta)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_STRRVSAT*rhobeta))));
THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+(modelStruct.modelPar_STRRVSAT*rhobetaref)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelPar_STRRVSAT*rhobeta))));
{
double value_max_0 = std::max(THESAT_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((THESAT_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_THESAT_t_dX = (deriv_max_0_d0*(d_THESAT_p_dX));
instanceStruct.instanceVar_THESAT_t = value_max_0;
}
instanceStruct.d_instanceVar_VFB1_t_dX = (instanceStruct.d_instanceVar_VFB1_t_dX+((Kstressvth0*(modelStruct.modelPar_STRDVFBO*d_temp0_dX+modelStruct.d_modelPar_STRDVFBO_dX*temp0)-(modelStruct.modelPar_STRDVFBO*temp0)*d_Kstressvth0_dX)/Kstressvth0/Kstressvth0));
instanceStruct.instanceVar_VFB1_t = (instanceStruct.instanceVar_VFB1_t+((modelStruct.modelPar_STRDVFBO*temp0)/Kstressvth0));
instanceStruct.d_instanceVar_VFB2_t_dX = (instanceStruct.d_instanceVar_VFB2_t_dX+((Kstressvth0*(modelStruct.modelPar_STRDVFBO*d_temp0_dX+modelStruct.d_modelPar_STRDVFBO_dX*temp0)-(modelStruct.modelPar_STRDVFBO*temp0)*d_Kstressvth0_dX)/Kstressvth0/Kstressvth0));
instanceStruct.instanceVar_VFB2_t = (instanceStruct.instanceVar_VFB2_t+((modelStruct.modelPar_STRDVFBO*temp0)/Kstressvth0));
{
double value_pow_0 = pow(lambda_LE,modelStruct.modelPar_CFLEXP);
double  deriv_pow_0_d0 = ((lambda_LE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CFLEXP/lambda_LE));
double  deriv_pow_0_d1 = (lambda_LE == 0.0)?0.0:(log(lambda_LE)*value_pow_0);
d_CF_p_dX = (d_CF_p_dX+(((modelStruct.modelPar_STRDCFL*temp0)*value_pow_0)*(modelStruct.modelPar_CFW*d_iWE_dX+modelStruct.d_modelPar_CFW_dX*iWE)+((modelStruct.modelPar_STRDCFL*temp0)*((deriv_pow_0_d0*(d_lambda_LE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CFLEXP_dX)))+(modelStruct.modelPar_STRDCFL*d_temp0_dX+modelStruct.d_modelPar_STRDCFL_dX*temp0)*value_pow_0)*(1.0+(modelStruct.modelPar_CFW*iWE))));
CF_p = (CF_p+(((modelStruct.modelPar_STRDCFL*temp0)*value_pow_0)*(1.0+(modelStruct.modelPar_CFW*iWE))));
}
{
double value_max_0 = std::max(CF_p,static_cast<double>(0.0));
double  deriv_max_0_d0 = ((CF_p>=0.0)?1.0:0.0);
instanceStruct.d_instanceVar_CF1_t_dX = (deriv_max_0_d0*(d_CF_p_dX));
instanceStruct.instanceVar_CF1_t = value_max_0;
}
instanceStruct.d_instanceVar_CF2_t_dX = ((TOX1_i*((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*d_TOX2_i_dX+(modelStruct.modelPar_CFBO*instanceStruct.d_instanceVar_CF1_t_dX+modelStruct.d_modelPar_CFBO_dX*instanceStruct.instanceVar_CF1_t)*TOX2_i)-((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*TOX2_i)*d_TOX1_i_dX)/TOX1_i/TOX1_i);
instanceStruct.instanceVar_CF2_t = (((modelStruct.modelPar_CFBO*instanceStruct.instanceVar_CF1_t)*TOX2_i)/TOX1_i);
}
}
}
if ((modelStruct.modelPar_SWJUNASYM==0))
{
instanceStruct.d_instanceVar_NOVD_i_dX = instanceStruct.d_instanceVar_NOV_i_dX;
instanceStruct.instanceVar_NOVD_i = instanceStruct.instanceVar_NOV_i;
instanceStruct.d_instanceVar_IGOVINVD_t_dX = instanceStruct.d_instanceVar_IGOVINV_t_dX;
instanceStruct.instanceVar_IGOVINVD_t = instanceStruct.instanceVar_IGOVINV_t;
instanceStruct.d_instanceVar_FNOVINVD_t_dX = instanceStruct.d_instanceVar_FNOVINV_t_dX;
instanceStruct.instanceVar_FNOVINVD_t = instanceStruct.instanceVar_FNOVINV_t;
instanceStruct.d_instanceVar_IGOVACCD_t_dX = instanceStruct.d_instanceVar_IGOVACC_t_dX;
instanceStruct.instanceVar_IGOVACCD_t = instanceStruct.instanceVar_IGOVACC_t;
instanceStruct.d_instanceVar_AGIDLD_i_dX = instanceStruct.d_instanceVar_AGIDL_i_dX;
instanceStruct.instanceVar_AGIDLD_i = instanceStruct.instanceVar_AGIDL_i;
instanceStruct.d_instanceVar_BGIDLD_t_dX = instanceStruct.d_instanceVar_BGIDL_t_dX;
instanceStruct.instanceVar_BGIDLD_t = instanceStruct.instanceVar_BGIDL_t;
instanceStruct.d_instanceVar_STBGIDLD_i_dX = instanceStruct.d_instanceVar_STBGIDL_i_dX;
instanceStruct.instanceVar_STBGIDLD_i = instanceStruct.instanceVar_STBGIDL_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX = instanceStruct.d_instanceVar_CGIDL_i_dX;
instanceStruct.instanceVar_CGIDLD_i = instanceStruct.instanceVar_CGIDL_i;
instanceStruct.d_instanceVar_DGIDLD_i_dX = instanceStruct.d_instanceVar_DGIDL_i_dX;
instanceStruct.instanceVar_DGIDLD_i = instanceStruct.instanceVar_DGIDL_i;
instanceStruct.d_instanceVar_COVD_i_dX = instanceStruct.d_instanceVar_COV_i_dX;
instanceStruct.instanceVar_COVD_i = instanceStruct.instanceVar_COV_i;
instanceStruct.d_instanceVar_CFRD_i_dX = instanceStruct.d_instanceVar_CFR_i_dX;
instanceStruct.instanceVar_CFRD_i = instanceStruct.instanceVar_CFR_i;
}
instanceStruct.d_instanceVar_one_m_xge_dX = (-instanceStruct.d_instanceVar_XGE_i_dX);
instanceStruct.instanceVar_one_m_xge = (1.0-instanceStruct.instanceVar_XGE_i);
instanceStruct.d_instanceVar_epsch_dX = (1.04479E-10*instanceStruct.d_instanceVar_one_m_xge_dX+1.43438E-10*instanceStruct.d_instanceVar_XGE_i_dX);
instanceStruct.instanceVar_epsch = ((1.04479E-10*instanceStruct.instanceVar_one_m_xge)+(1.43438E-10*instanceStruct.instanceVar_XGE_i));
instanceStruct.instanceVar_EgSi = (1.17-((4.730e-4*instanceStruct.instanceVar_TKC_sq)/(636+instanceStruct.instanceVar_TKC)));
instanceStruct.instanceVar_EgGe = (0.744-((4.774e-4*instanceStruct.instanceVar_TKC_sq)/(235+instanceStruct.instanceVar_TKC)));
instanceStruct.d_instanceVar_dEg_dX = (((instanceStruct.instanceVar_EgGe-instanceStruct.instanceVar_EgSi)+((-0.4)*instanceStruct.instanceVar_one_m_xge))*instanceStruct.d_instanceVar_XGE_i_dX+(-0.4)*instanceStruct.d_instanceVar_one_m_xge_dX*instanceStruct.instanceVar_XGE_i);
instanceStruct.instanceVar_dEg = (((instanceStruct.instanceVar_EgGe-instanceStruct.instanceVar_EgSi)+((-0.4)*instanceStruct.instanceVar_one_m_xge))*instanceStruct.instanceVar_XGE_i);
instanceStruct.d_instanceVar_Eg_dX = instanceStruct.d_instanceVar_dEg_dX;
instanceStruct.instanceVar_Eg = (instanceStruct.instanceVar_EgSi+instanceStruct.instanceVar_dEg);
instanceStruct.d_instanceVar_Eg_2phit0_dX = 0.5*instanceStruct.d_instanceVar_Eg_dX*instanceStruct.instanceVar_inv_phit0;
instanceStruct.instanceVar_Eg_2phit0 = ((0.5*instanceStruct.instanceVar_Eg)*instanceStruct.instanceVar_inv_phit0);
{
double value_sqrt_0 = sqrt((10.0*instanceStruct.instanceVar_XGE_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_niratio_dX = (-deriv_sqrt_0_d0*(10.0*instanceStruct.d_instanceVar_XGE_i_dX)/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
instanceStruct.instanceVar_niratio = (1.0/(1.0+value_sqrt_0));
}
instanceStruct.d_instanceVar_dVfbch_dX = (0.05*instanceStruct.d_instanceVar_XGE_i_dX-0.5*instanceStruct.d_instanceVar_dEg_dX);
instanceStruct.instanceVar_dVfbch = ((0.05*instanceStruct.instanceVar_XGE_i)-(0.5*instanceStruct.instanceVar_dEg));
instanceStruct.d_instanceVar_temp_dX = ((((1.602176565E-19*NCH_i)*0.5)*instanceStruct.d_instanceVar_TSI_i_dX+1.602176565E-19*d_NCH_i_dX*0.5*instanceStruct.instanceVar_TSI_i)/3.45313E-11);
instanceStruct.instanceVar_temp = ((((1.602176565E-19*NCH_i)*0.5)*instanceStruct.instanceVar_TSI_i)/3.45313E-11);
if ((TYPECH_i>0))
{
instanceStruct.d_instanceVar_dVfb1Nch_dX = (instanceStruct.instanceVar_temp*(d_TOX1_i_dX+modelStruct.d_modelPar_QMC_dX*4.0e-10)+instanceStruct.d_instanceVar_temp_dX*(TOX1_i+(modelStruct.modelPar_QMC*4.0e-10)));
instanceStruct.instanceVar_dVfb1Nch = (instanceStruct.instanceVar_temp*(TOX1_i+(modelStruct.modelPar_QMC*4.0e-10)));
instanceStruct.d_instanceVar_dVfb2Nch_dX = (instanceStruct.instanceVar_temp*(d_TOX2_i_dX+modelStruct.d_modelPar_QMC_dX*4.0e-10)+instanceStruct.d_instanceVar_temp_dX*(TOX2_i+(modelStruct.modelPar_QMC*4.0e-10)));
instanceStruct.instanceVar_dVfb2Nch = (instanceStruct.instanceVar_temp*(TOX2_i+(modelStruct.modelPar_QMC*4.0e-10)));
}
else
{
instanceStruct.d_instanceVar_dVfb1Nch_dX = ((-instanceStruct.instanceVar_temp)*(d_TOX1_i_dX+modelStruct.d_modelPar_QMC_dX*4.0e-10)+(-instanceStruct.d_instanceVar_temp_dX)*(TOX1_i+(modelStruct.modelPar_QMC*4.0e-10)));
instanceStruct.instanceVar_dVfb1Nch = ((-instanceStruct.instanceVar_temp)*(TOX1_i+(modelStruct.modelPar_QMC*4.0e-10)));
instanceStruct.d_instanceVar_dVfb2Nch_dX = ((-instanceStruct.instanceVar_temp)*(d_TOX2_i_dX+modelStruct.d_modelPar_QMC_dX*4.0e-10)+(-instanceStruct.d_instanceVar_temp_dX)*(TOX2_i+(modelStruct.modelPar_QMC*4.0e-10)));
instanceStruct.instanceVar_dVfb2Nch = ((-instanceStruct.instanceVar_temp)*(TOX2_i+(modelStruct.modelPar_QMC*4.0e-10)));
}
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_TKC*0.0033333333333));
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = value_sqrt_0;
}
instanceStruct.d_instanceVar_temp1_dX = (((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+4.05E25*instanceStruct.d_instanceVar_temp_dX*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_temp1 = (((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp);
{
double value_exp_0 = exp((-instanceStruct.instanceVar_Eg_2phit0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_neff_dX = ((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_niratio)*deriv_exp_0_d0*((-instanceStruct.d_instanceVar_Eg_2phit0_dX))+(instanceStruct.instanceVar_temp1*instanceStruct.d_instanceVar_niratio_dX+instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_niratio)*value_exp_0);
instanceStruct.instanceVar_neff = ((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_niratio)*value_exp_0);
}
{
double value_exp_0 = exp((((-0.5)*instanceStruct.instanceVar_EgSi)*instanceStruct.instanceVar_inv_phit0));
d_neff_sub_dX = instanceStruct.d_instanceVar_temp1_dX*value_exp_0;
neff_sub = (instanceStruct.instanceVar_temp1*value_exp_0);
}
d_Cox1Init_dX = (-3.45313E-11*d_TOX1_i_dX/TOX1_i/TOX1_i);
Cox1Init = (3.45313E-11/TOX1_i);
instanceStruct.d_instanceVar_Cox2Init_dX = (-3.45313E-11*d_TOX2_i_dX/TOX2_i/TOX2_i);
instanceStruct.instanceVar_Cox2Init = (3.45313E-11/TOX2_i);
if ((PNCE_i>0))
{
instanceStruct.d_instanceVar_Cox1Prime_dX = (Cox1Init*d_PNCE_i_dX+d_Cox1Init_dX*(1.0+PNCE_i));
instanceStruct.instanceVar_Cox1Prime = (Cox1Init*(1.0+PNCE_i));
instanceStruct.d_instanceVar_Cox2Prime_dX = instanceStruct.d_instanceVar_Cox2Init_dX;
instanceStruct.instanceVar_Cox2Prime = instanceStruct.instanceVar_Cox2Init;
}
else
{
instanceStruct.d_instanceVar_Cox1Prime_dX = d_Cox1Init_dX;
instanceStruct.instanceVar_Cox1Prime = Cox1Init;
instanceStruct.d_instanceVar_Cox2Prime_dX = (instanceStruct.instanceVar_Cox2Init*(-d_PNCE_i_dX)+instanceStruct.d_instanceVar_Cox2Init_dX*(1.0-PNCE_i));
instanceStruct.instanceVar_Cox2Prime = (instanceStruct.instanceVar_Cox2Init*(1.0-PNCE_i));
}
instanceStruct.d_instanceVar_CsiPrime_0_dX = ((instanceStruct.instanceVar_TSI_i*instanceStruct.d_instanceVar_epsch_dX-instanceStruct.instanceVar_epsch*instanceStruct.d_instanceVar_TSI_i_dX)/instanceStruct.instanceVar_TSI_i/instanceStruct.instanceVar_TSI_i);
instanceStruct.instanceVar_CsiPrime_0 = (instanceStruct.instanceVar_epsch/instanceStruct.instanceVar_TSI_i);
instanceStruct.d_instanceVar_phit_dX = instanceStruct.instanceVar_phit0*(instanceStruct.instanceVar_CT_i*instanceStruct.d_instanceVar_rTn_dX+instanceStruct.d_instanceVar_CT_i_dX*instanceStruct.instanceVar_rTn);
instanceStruct.instanceVar_phit = (instanceStruct.instanceVar_phit0*(1.0+(instanceStruct.instanceVar_CT_i*instanceStruct.instanceVar_rTn)));
instanceStruct.d_instanceVar_inv_phit_dX = (-instanceStruct.d_instanceVar_phit_dX/instanceStruct.instanceVar_phit/instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_inv_phit = (1.0/instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_Eg_2phit_dX = ((0.5*instanceStruct.instanceVar_Eg)*instanceStruct.d_instanceVar_inv_phit_dX+0.5*instanceStruct.d_instanceVar_Eg_dX*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_Eg_2phit = ((0.5*instanceStruct.instanceVar_Eg)*instanceStruct.instanceVar_inv_phit);
instanceStruct.d_instanceVar_k1_1D_dX = ((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_Cox1Prime_dX-instanceStruct.instanceVar_Cox1Prime*instanceStruct.d_instanceVar_CsiPrime_0_dX)/instanceStruct.instanceVar_CsiPrime_0/instanceStruct.instanceVar_CsiPrime_0);
instanceStruct.instanceVar_k1_1D = (instanceStruct.instanceVar_Cox1Prime/instanceStruct.instanceVar_CsiPrime_0);
instanceStruct.d_instanceVar_k2_1D_dX = ((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_Cox2Prime_dX-instanceStruct.instanceVar_Cox2Prime*instanceStruct.d_instanceVar_CsiPrime_0_dX)/instanceStruct.instanceVar_CsiPrime_0/instanceStruct.instanceVar_CsiPrime_0);
instanceStruct.instanceVar_k2_1D = (instanceStruct.instanceVar_Cox2Prime/instanceStruct.instanceVar_CsiPrime_0);
instanceStruct.d_instanceVar_keq_1D_dX = (-((-instanceStruct.d_instanceVar_k1_1D_dX/instanceStruct.instanceVar_k1_1D/instanceStruct.instanceVar_k1_1D)+(-instanceStruct.d_instanceVar_k2_1D_dX/instanceStruct.instanceVar_k2_1D/instanceStruct.instanceVar_k2_1D))/((1.0+(1.0/instanceStruct.instanceVar_k1_1D))+(1.0/instanceStruct.instanceVar_k2_1D))/((1.0+(1.0/instanceStruct.instanceVar_k1_1D))+(1.0/instanceStruct.instanceVar_k2_1D)));
instanceStruct.instanceVar_keq_1D = (1.0/((1.0+(1.0/instanceStruct.instanceVar_k1_1D))+(1.0/instanceStruct.instanceVar_k2_1D)));
d_Ceq_1D_dX = (instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_keq_1D_dX+instanceStruct.d_instanceVar_CsiPrime_0_dX*instanceStruct.instanceVar_keq_1D);
Ceq_1D = (instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_keq_1D);
instanceStruct.d_instanceVar_A0_Csisq_dX = ((((2.0*1.602176565E-19)*instanceStruct.instanceVar_neff)*instanceStruct.instanceVar_epsch)*instanceStruct.d_instanceVar_inv_phit_dX+(((2.0*1.602176565E-19)*instanceStruct.instanceVar_neff)*instanceStruct.d_instanceVar_epsch_dX+(2.0*1.602176565E-19)*instanceStruct.d_instanceVar_neff_dX*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_A0_Csisq = ((((2.0*1.602176565E-19)*instanceStruct.instanceVar_neff)*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit);
{
double value_log_0 = log(((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)/instanceStruct.instanceVar_A0_Csisq));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)/instanceStruct.instanceVar_A0_Csisq));
instanceStruct.d_instanceVar_xth_1D_dX = deriv_log_0_d0*(((instanceStruct.instanceVar_A0_Csisq*(instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_CsiPrime_0_dX+instanceStruct.d_instanceVar_CsiPrime_0_dX*instanceStruct.instanceVar_CsiPrime_0)-(instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)*instanceStruct.d_instanceVar_A0_Csisq_dX)/instanceStruct.instanceVar_A0_Csisq/instanceStruct.instanceVar_A0_Csisq));
instanceStruct.instanceVar_xth_1D = (value_log_0-0.6931471805599);
}
instanceStruct.d_instanceVar_xSDdep_dX = (((((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*instanceStruct.d_instanceVar_inv_phit_dX+(((instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime)*(((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.d_instanceVar_TSI_i_dX+(0.5*1.602176565E-19)*instanceStruct.d_instanceVar_NSDDC_i_dX*instanceStruct.instanceVar_TSI_i)-(((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)*(instanceStruct.d_instanceVar_Cox1Prime_dX+instanceStruct.d_instanceVar_Cox2Prime_dX))/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_xSDdep = (((((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*instanceStruct.instanceVar_inv_phit);
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_STCF_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STCF_i_dX*instanceStruct.instanceVar_dT);
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_STCF_i*instanceStruct.instanceVar_dT);
instanceStruct.d_instanceVar_CF1_i_dX = (instanceStruct.d_instanceVar_CF1_t_dX+instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_CF1_i = (instanceStruct.instanceVar_CF1_t+instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_CF2_i_dX = (instanceStruct.d_instanceVar_CF2_t_dX+instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_CF2_i = (instanceStruct.instanceVar_CF2_t+instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_xd0_dX = (instanceStruct.instanceVar_CFD_i*instanceStruct.d_instanceVar_inv_phit_dX+instanceStruct.d_instanceVar_CFD_i_dX*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_xd0 = (instanceStruct.instanceVar_CFD_i*instanceStruct.instanceVar_inv_phit);
{
double value_sqrt_0 = sqrt(((((2.0*1.602176565E-19)*NSUB_i)*1.04479E-10)*instanceStruct.instanceVar_inv_phit0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_Gfsub_dX = ((Ceq_1D*deriv_sqrt_0_d0*((2.0*1.602176565E-19)*d_NSUB_i_dX*1.04479E-10*instanceStruct.instanceVar_inv_phit0)-value_sqrt_0*d_Ceq_1D_dX)/Ceq_1D/Ceq_1D);
instanceStruct.instanceVar_Gfsub = (value_sqrt_0/Ceq_1D);
}
instanceStruct.d_instanceVar_Gfsub2_dX = (instanceStruct.instanceVar_Gfsub*instanceStruct.d_instanceVar_Gfsub_dX+instanceStruct.d_instanceVar_Gfsub_dX*instanceStruct.instanceVar_Gfsub);
instanceStruct.instanceVar_Gfsub2 = (instanceStruct.instanceVar_Gfsub*instanceStruct.instanceVar_Gfsub);
instanceStruct.d_instanceVar_inv_Gfsub2_dX = (-instanceStruct.d_instanceVar_Gfsub2_dX/instanceStruct.instanceVar_Gfsub2/instanceStruct.instanceVar_Gfsub2);
instanceStruct.instanceVar_inv_Gfsub2 = (1.0/instanceStruct.instanceVar_Gfsub2);
instanceStruct.d_instanceVar_xisub_dX = (instanceStruct.d_instanceVar_Gfsub_dX/1.4142135623731);
instanceStruct.instanceVar_xisub = (1.0+(instanceStruct.instanceVar_Gfsub/1.4142135623731));
instanceStruct.d_instanceVar_inv_xisub_dX = (-instanceStruct.d_instanceVar_xisub_dX/instanceStruct.instanceVar_xisub/instanceStruct.instanceVar_xisub);
instanceStruct.instanceVar_inv_xisub = (1.0/instanceStruct.instanceVar_xisub);
instanceStruct.d_instanceVar_margin_sub_dX = 1.0e-5*instanceStruct.d_instanceVar_xisub_dX;
instanceStruct.instanceVar_margin_sub = (1.0e-5*instanceStruct.instanceVar_xisub);
{
double value_log_0 = log((NSUB_i/neff_sub));
double  deriv_log_0_d0 = (1.0/(NSUB_i/neff_sub));
d_xb_sub_dX = deriv_log_0_d0*(((neff_sub*d_NSUB_i_dX-NSUB_i*d_neff_sub_dX)/neff_sub/neff_sub));
xb_sub = value_log_0;
}
instanceStruct.d_instanceVar_xn_sub_dX = 2.0*d_xb_sub_dX;
instanceStruct.instanceVar_xn_sub = (2.0*xb_sub);
if ((modelStruct.modelPar_SWSUBDEP>0))
{
instanceStruct.d_instanceVar_VFB2_t_dX = (instanceStruct.d_instanceVar_VFB2_t_dX+(instanceStruct.instanceVar_TYPESUB_i*instanceStruct.instanceVar_phit0)*d_xb_sub_dX);
instanceStruct.instanceVar_VFB2_t = (instanceStruct.instanceVar_VFB2_t+((instanceStruct.instanceVar_TYPESUB_i*instanceStruct.instanceVar_phit0)*xb_sub));
}
instanceStruct.d_instanceVar_dVfbQM_dX = 0.0;
instanceStruct.instanceVar_dVfbQM = 0.0;
instanceStruct.d_instanceVar_qq_dX = 0.0;
instanceStruct.instanceVar_qq = 0.0;
instanceStruct.d_instanceVar_tsisq_dX = ((1.0e18*instanceStruct.instanceVar_TSI_i)*instanceStruct.d_instanceVar_TSI_i_dX+1.0e18*instanceStruct.d_instanceVar_TSI_i_dX*instanceStruct.instanceVar_TSI_i);
instanceStruct.instanceVar_tsisq = ((1.0e18*instanceStruct.instanceVar_TSI_i)*instanceStruct.instanceVar_TSI_i);
if ((modelStruct.modelPar_QMC>0.0))
{
if ((modelStruct.modelPar_TYPE==(+1)))
{
instanceStruct.d_instanceVar_dVfbQM_dX = (-0.409618895*instanceStruct.d_instanceVar_tsisq_dX/instanceStruct.instanceVar_tsisq/instanceStruct.instanceVar_tsisq);
instanceStruct.instanceVar_dVfbQM = (0.409618895/instanceStruct.instanceVar_tsisq);
{
double value_log_0 = log((instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_qq_dX = (((0.4*modelStruct.modelPar_QMC)*1.27520989)*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*((instanceStruct.instanceVar_phit*instanceStruct.d_instanceVar_tsisq_dX+instanceStruct.d_instanceVar_phit_dX*instanceStruct.instanceVar_tsisq)))+0.4*modelStruct.d_modelPar_QMC_dX*1.27520989*value_exp_1);
instanceStruct.instanceVar_qq = (((0.4*modelStruct.modelPar_QMC)*1.27520989)*value_exp_1);
}
}
else
{
instanceStruct.d_instanceVar_dVfbQM_dX = (-0.723134895*instanceStruct.d_instanceVar_tsisq_dX/instanceStruct.instanceVar_tsisq/instanceStruct.instanceVar_tsisq);
instanceStruct.instanceVar_dVfbQM = (0.723134895/instanceStruct.instanceVar_tsisq);
{
double value_log_0 = log((instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_qq_dX = (((0.4*modelStruct.modelPar_QMC)*1.54120870)*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*((instanceStruct.instanceVar_phit*instanceStruct.d_instanceVar_tsisq_dX+instanceStruct.d_instanceVar_phit_dX*instanceStruct.instanceVar_tsisq)))+0.4*modelStruct.d_modelPar_QMC_dX*1.54120870*value_exp_1);
instanceStruct.instanceVar_qq = (((0.4*modelStruct.modelPar_QMC)*1.54120870)*value_exp_1);
}
}
}
instanceStruct.d_instanceVar_temp_dX = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_STVFB_i)*instanceStruct.d_instanceVar_dT_dX+modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_STVFB_i_dX*instanceStruct.instanceVar_dT)+instanceStruct.d_instanceVar_dVfbQM_dX);
instanceStruct.instanceVar_temp = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_STVFB_i)*instanceStruct.instanceVar_dT)+instanceStruct.instanceVar_dVfbQM);
instanceStruct.d_instanceVar_VFB1_i_dX = ((modelStruct.modelPar_TYPE*((instanceStruct.d_instanceVar_VFB1_t_dX+instanceStruct.d_instanceVar_dVfbch_dX)+instanceStruct.d_instanceVar_dVfb1Nch_dX)+instanceStruct.d_instanceVar_temp_dX)+instanceStruct.d_instancePar_DELVTO_dX);
instanceStruct.instanceVar_VFB1_i = (((modelStruct.modelPar_TYPE*((instanceStruct.instanceVar_VFB1_t+instanceStruct.instanceVar_dVfbch)+instanceStruct.instanceVar_dVfb1Nch))+instanceStruct.instanceVar_temp)+instanceStruct.instancePar_DELVTO);
instanceStruct.d_instanceVar_VFB2_i_dX = (modelStruct.modelPar_TYPE*((instanceStruct.d_instanceVar_VFB2_t_dX+instanceStruct.d_instanceVar_dVfbch_dX)+instanceStruct.d_instanceVar_dVfb2Nch_dX)+instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_VFB2_i = ((modelStruct.modelPar_TYPE*((instanceStruct.instanceVar_VFB2_t+instanceStruct.instanceVar_dVfbch)+instanceStruct.instanceVar_dVfb2Nch))+instanceStruct.instanceVar_temp);
{
double value_log_0 = log(instanceStruct.instanceVar_rTn);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_rTn);
instanceStruct.d_instanceVar_lnrTn_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_rTn_dX);
instanceStruct.instanceVar_lnrTn = value_log_0;
}
{
double value_exp_0 = exp((instanceStruct.instanceVar_STBET_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_bet_dX = (value_exp_0*instanceStruct.d_instancePar_FACTUO_dX+deriv_exp_0_d0*((instanceStruct.instanceVar_STBET_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STBET_i_dX*instanceStruct.instanceVar_lnrTn))*instanceStruct.instancePar_FACTUO);
instanceStruct.instanceVar_tf_bet = (value_exp_0*instanceStruct.instancePar_FACTUO);
}
instanceStruct.d_instanceVar_BETN1_i_dX = (instanceStruct.instanceVar_BETN1_t*instanceStruct.d_instanceVar_tf_bet_dX+instanceStruct.d_instanceVar_BETN1_t_dX*instanceStruct.instanceVar_tf_bet);
instanceStruct.instanceVar_BETN1_i = (instanceStruct.instanceVar_BETN1_t*instanceStruct.instanceVar_tf_bet);
instanceStruct.d_instanceVar_BETN2_i_dX = (instanceStruct.instanceVar_BETN2_t*instanceStruct.d_instanceVar_tf_bet_dX+instanceStruct.d_instanceVar_BETN2_t_dX*instanceStruct.instanceVar_tf_bet);
instanceStruct.instanceVar_BETN2_i = (instanceStruct.instanceVar_BETN2_t*instanceStruct.instanceVar_tf_bet);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STMUE_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_mue_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STMUE_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STMUE_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_mue = value_exp_0;
}
instanceStruct.d_instanceVar_MUE_i_dX = (instanceStruct.instanceVar_MUE_t*instanceStruct.d_instanceVar_tf_mue_dX+instanceStruct.d_instanceVar_MUE_t_dX*instanceStruct.instanceVar_tf_mue);
instanceStruct.instanceVar_MUE_i = (instanceStruct.instanceVar_MUE_t*instanceStruct.instanceVar_tf_mue);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHEMU_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_themu_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STTHEMU_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STTHEMU_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_themu = value_exp_0;
}
instanceStruct.d_instanceVar_THEMU_i_dX = (instanceStruct.instanceVar_THEMU_t*instanceStruct.d_instanceVar_tf_themu_dX+instanceStruct.d_instanceVar_THEMU_t_dX*instanceStruct.instanceVar_tf_themu);
instanceStruct.instanceVar_THEMU_i = (instanceStruct.instanceVar_THEMU_t*instanceStruct.instanceVar_tf_themu);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STCS_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_cs_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STCS_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STCS_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_cs = value_exp_0;
}
instanceStruct.d_instanceVar_CS_i_dX = (instanceStruct.instanceVar_CS_t*instanceStruct.d_instanceVar_tf_cs_dX+instanceStruct.d_instanceVar_CS_t_dX*instanceStruct.instanceVar_tf_cs);
instanceStruct.instanceVar_CS_i = (instanceStruct.instanceVar_CS_t*instanceStruct.instanceVar_tf_cs);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHECS_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_thecs_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STTHECS_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STTHECS_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_thecs = value_exp_0;
}
instanceStruct.d_instanceVar_THECS_i_dX = (instanceStruct.instanceVar_THECS_t*instanceStruct.d_instanceVar_tf_thecs_dX+instanceStruct.d_instanceVar_THECS_t_dX*instanceStruct.instanceVar_tf_thecs);
instanceStruct.instanceVar_THECS_i = (instanceStruct.instanceVar_THECS_t*instanceStruct.instanceVar_tf_thecs);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STXCOR_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_xcor_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STXCOR_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STXCOR_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_xcor = value_exp_0;
}
instanceStruct.d_instanceVar_XCOR_i_dX = (instanceStruct.instanceVar_XCOR_t*instanceStruct.d_instanceVar_tf_xcor_dX+instanceStruct.d_instanceVar_XCOR_t_dX*instanceStruct.instanceVar_tf_xcor);
instanceStruct.instanceVar_XCOR_i = (instanceStruct.instanceVar_XCOR_t*instanceStruct.instanceVar_tf_xcor);
instanceStruct.d_instanceVar_temp_dX = ((instanceStruct.instanceVar_TSI_i*1.0e-8*instanceStruct.d_instanceVar_phit_dX-(1.0e-8*instanceStruct.instanceVar_phit)*instanceStruct.d_instanceVar_TSI_i_dX)/instanceStruct.instanceVar_TSI_i/instanceStruct.instanceVar_TSI_i);
instanceStruct.instanceVar_temp = ((1.0e-8*instanceStruct.instanceVar_phit)/instanceStruct.instanceVar_TSI_i);
instanceStruct.d_instanceVar_fmue_dX = (instanceStruct.instanceVar_temp*instanceStruct.d_instanceVar_MUE_i_dX+instanceStruct.d_instanceVar_temp_dX*instanceStruct.instanceVar_MUE_i);
instanceStruct.instanceVar_fmue = (instanceStruct.instanceVar_temp*instanceStruct.instanceVar_MUE_i);
instanceStruct.d_instanceVar_inv_qi1cs_dX = (-0.5*d_CSTHR_i_dX/(0.5*CSTHR_i)/(0.5*CSTHR_i));
instanceStruct.instanceVar_inv_qi1cs = (1.0/(0.5*CSTHR_i));
instanceStruct.d_instanceVar_inv_qi2cs_dX = ((CSTHRB_i*instanceStruct.d_instanceVar_inv_qi1cs_dX-instanceStruct.instanceVar_inv_qi1cs*d_CSTHRB_i_dX)/CSTHRB_i/CSTHRB_i);
instanceStruct.instanceVar_inv_qi2cs = (instanceStruct.instanceVar_inv_qi1cs/CSTHRB_i);
if ((modelStruct.modelPar_TYPE==(+1)))
{
instanceStruct.d_instanceVar_eta_mu_dX = 0.5*d_FETA_i_dX;
instanceStruct.instanceVar_eta_mu = (0.5*FETA_i);
}
else
{
instanceStruct.d_instanceVar_eta_mu_dX = 0.3333333333333*d_FETA_i_dX;
instanceStruct.instanceVar_eta_mu = (0.3333333333333*FETA_i);
}
instanceStruct.d_instanceVar_one_m_eta_dX = (-instanceStruct.d_instanceVar_eta_mu_dX);
instanceStruct.instanceVar_one_m_eta = (1.0-instanceStruct.instanceVar_eta_mu);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STRS_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_ther_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STRS_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STRS_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_ther = value_exp_0;
}
instanceStruct.d_instanceVar_RS_i_dX = (instanceStruct.instanceVar_RS_t*instanceStruct.d_instanceVar_tf_ther_dX+instanceStruct.d_instanceVar_RS_t_dX*instanceStruct.instanceVar_tf_ther);
instanceStruct.instanceVar_RS_i = (instanceStruct.instanceVar_RS_t*instanceStruct.instanceVar_tf_ther);
instanceStruct.d_instanceVar_frs_dX = ((2.0*instanceStruct.instanceVar_RS_i)*instanceStruct.d_instanceVar_phit_dX+2.0*instanceStruct.d_instanceVar_RS_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_frs = ((2.0*instanceStruct.instanceVar_RS_i)*instanceStruct.instanceVar_phit);
{
double value_exp_0 = exp(((16.0/AX_i)*0.6931471805599));
double value_log_1 = log((value_exp_0-1.0));
double value_exp_2 = exp((0.375*value_log_1));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(value_exp_0-1.0));
double  deriv_exp_2_d0 = value_exp_2;
instanceStruct.d_instanceVar_gamAX_dX = deriv_exp_2_d0*(0.375*deriv_log_1_d0*(deriv_exp_0_d0*((-16.0*d_AX_i_dX/AX_i/AX_i)*0.6931471805599)));
instanceStruct.instanceVar_gamAX = (value_exp_2-1.0);
}
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHESAT_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_thesat_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STTHESAT_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STTHESAT_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_thesat = value_exp_0;
}
instanceStruct.d_instanceVar_THESAT_i_dX = ((instanceStruct.instanceVar_THESAT_t*instanceStruct.instanceVar_tf_thesat)*instanceStruct.d_instanceVar_tf_bet_dX+(instanceStruct.instanceVar_THESAT_t*instanceStruct.d_instanceVar_tf_thesat_dX+instanceStruct.d_instanceVar_THESAT_t_dX*instanceStruct.instanceVar_tf_thesat)*instanceStruct.instanceVar_tf_bet);
instanceStruct.instanceVar_THESAT_i = ((instanceStruct.instanceVar_THESAT_t*instanceStruct.instanceVar_tf_thesat)*instanceStruct.instanceVar_tf_bet);
instanceStruct.d_instanceVar_sat_phit_dX = (instanceStruct.instanceVar_THESAT_i*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_THESAT_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_sat_phit = (instanceStruct.instanceVar_THESAT_i*instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_alp1_phit_dX = (instanceStruct.instanceVar_ALP1_i*instanceStruct.d_instanceVar_inv_phit_dX+instanceStruct.d_instanceVar_ALP1_i_dX*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_alp1_phit = (instanceStruct.instanceVar_ALP1_i*instanceStruct.instanceVar_inv_phit);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_STIG_i)*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_ig_dX = deriv_exp_0_d0*(((-instanceStruct.instanceVar_STIG_i)*instanceStruct.d_instanceVar_lnrTn_dX+(-instanceStruct.d_instanceVar_STIG_i_dX)*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_ig = value_exp_0;
}
instanceStruct.d_instanceVar_IGINV_i_dX = (instanceStruct.instanceVar_IGINV_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGINV_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGINV_i = (instanceStruct.instanceVar_IGINV_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVINV_i_dX = (instanceStruct.instanceVar_IGOVINV_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVINV_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVINV_i = (instanceStruct.instanceVar_IGOVINV_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVINVD_i_dX = (instanceStruct.instanceVar_IGOVINVD_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVINVD_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVINVD_i = (instanceStruct.instanceVar_IGOVINVD_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVACC_i_dX = (instanceStruct.instanceVar_IGOVACC_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVACC_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVACC_i = (instanceStruct.instanceVar_IGOVACC_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVACCD_i_dX = (instanceStruct.instanceVar_IGOVACCD_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVACCD_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVACCD_i = (instanceStruct.instanceVar_IGOVACCD_t*instanceStruct.instanceVar_tf_ig);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_STIGFN_i)*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_ig_dX = deriv_exp_0_d0*(((-instanceStruct.instanceVar_STIGFN_i)*instanceStruct.d_instanceVar_lnrTn_dX+(-instanceStruct.d_instanceVar_STIGFN_i_dX)*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_ig = value_exp_0;
}
instanceStruct.d_instanceVar_FNOVINV_i_dX = (instanceStruct.instanceVar_FNOVINV_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_FNOVINV_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_FNOVINV_i = (instanceStruct.instanceVar_FNOVINV_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_FNOVINVD_i_dX = (instanceStruct.instanceVar_FNOVINVD_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_FNOVINVD_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_FNOVINVD_i = (instanceStruct.instanceVar_FNOVINVD_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_inv_CHIB_dX = (-instanceStruct.d_instanceVar_CHIB_i_dX/instanceStruct.instanceVar_CHIB_i/instanceStruct.instanceVar_CHIB_i);
instanceStruct.instanceVar_inv_CHIB = (1.0/instanceStruct.instanceVar_CHIB_i);
{
double value_sqrt_0 = sqrt((((2.0*1.602176565E-19)*9.10938291E-31)*instanceStruct.instanceVar_CHIB_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tempM_dX = ((4.0*0.3333333333333)*deriv_sqrt_0_d0*(((2.0*1.602176565E-19)*9.10938291E-31)*instanceStruct.d_instanceVar_CHIB_i_dX)/1.054571726E-34);
instanceStruct.instanceVar_tempM = (((4.0*0.3333333333333)*value_sqrt_0)/1.054571726E-34);
}
instanceStruct.d_instanceVar_BCH_dX = (instanceStruct.instanceVar_tempM*instanceStruct.d_instanceVar_TOXP_i_dX+instanceStruct.d_instanceVar_tempM_dX*instanceStruct.instanceVar_TOXP_i);
instanceStruct.instanceVar_BCH = (instanceStruct.instanceVar_tempM*instanceStruct.instanceVar_TOXP_i);
instanceStruct.d_instanceVar_BOV_dX = (instanceStruct.instanceVar_tempM*instanceStruct.d_instanceVar_TOXP_i_dX+instanceStruct.d_instanceVar_tempM_dX*instanceStruct.instanceVar_TOXP_i);
instanceStruct.instanceVar_BOV = (instanceStruct.instanceVar_tempM*instanceStruct.instanceVar_TOXP_i);
instanceStruct.d_instanceVar_GCQCH_dX = 0.0;
instanceStruct.instanceVar_GCQCH = 0.0;
if ((instanceStruct.instanceVar_GC3CH_i<0.0))
{
instanceStruct.d_instanceVar_GCQCH_dX = ((instanceStruct.instanceVar_GC3CH_i*(-0.495)*instanceStruct.d_instanceVar_GC2CH_i_dX-((-0.495)*instanceStruct.instanceVar_GC2CH_i)*instanceStruct.d_instanceVar_GC3CH_i_dX)/instanceStruct.instanceVar_GC3CH_i/instanceStruct.instanceVar_GC3CH_i);
instanceStruct.instanceVar_GCQCH = (((-0.495)*instanceStruct.instanceVar_GC2CH_i)/instanceStruct.instanceVar_GC3CH_i);
}
instanceStruct.d_instanceVar_GCQOVINV_dX = 0.0;
instanceStruct.instanceVar_GCQOVINV = 0.0;
if ((instanceStruct.instanceVar_GC3OVINV_i<0.0))
{
instanceStruct.d_instanceVar_GCQOVINV_dX = ((instanceStruct.instanceVar_GC3OVINV_i*(-0.495)*instanceStruct.d_instanceVar_GC2OVINV_i_dX-((-0.495)*instanceStruct.instanceVar_GC2OVINV_i)*instanceStruct.d_instanceVar_GC3OVINV_i_dX)/instanceStruct.instanceVar_GC3OVINV_i/instanceStruct.instanceVar_GC3OVINV_i);
instanceStruct.instanceVar_GCQOVINV = (((-0.495)*instanceStruct.instanceVar_GC2OVINV_i)/instanceStruct.instanceVar_GC3OVINV_i);
}
instanceStruct.d_instanceVar_GCQOVACC_dX = 0.0;
instanceStruct.instanceVar_GCQOVACC = 0.0;
if ((instanceStruct.instanceVar_GC3OVACC_i<0.0))
{
instanceStruct.d_instanceVar_GCQOVACC_dX = ((instanceStruct.instanceVar_GC3OVACC_i*(-0.495)*instanceStruct.d_instanceVar_GC2OVACC_i_dX-((-0.495)*instanceStruct.instanceVar_GC2OVACC_i)*instanceStruct.d_instanceVar_GC3OVACC_i_dX)/instanceStruct.instanceVar_GC3OVACC_i/instanceStruct.instanceVar_GC3OVACC_i);
instanceStruct.instanceVar_GCQOVACC = (((-0.495)*instanceStruct.instanceVar_GC2OVACC_i)/instanceStruct.instanceVar_GC3OVACC_i);
}
instanceStruct.d_instanceVar_alpha_b_dX = 0.5*instanceStruct.d_instanceVar_Eg_dX;
instanceStruct.instanceVar_alpha_b = (0.5*instanceStruct.instanceVar_Eg);
instanceStruct.d_instanceVar_Dch_dX = (instanceStruct.instanceVar_GCO_i*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_GCO_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_Dch = (instanceStruct.instanceVar_GCO_i*instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_Dov_dX = instanceStruct.d_instanceVar_GCO_i_dX*instanceStruct.instanceVar_phit0;
instanceStruct.instanceVar_Dov = (instanceStruct.instanceVar_GCO_i*instanceStruct.instanceVar_phit0);
instanceStruct.d_instanceVar_n_iginv_dX = (-(instanceStruct.instanceVar_NIGINV_i*instanceStruct.d_instanceVar_Eg_2phit_dX+instanceStruct.d_instanceVar_NIGINV_i_dX*instanceStruct.instanceVar_Eg_2phit)/(1.0+(instanceStruct.instanceVar_NIGINV_i*instanceStruct.instanceVar_Eg_2phit))/(1.0+(instanceStruct.instanceVar_NIGINV_i*instanceStruct.instanceVar_Eg_2phit)));
instanceStruct.instanceVar_n_iginv = (1.0/(1.0+(instanceStruct.instanceVar_NIGINV_i*instanceStruct.instanceVar_Eg_2phit)));
instanceStruct.d_instanceVar_temp_dX = (-4.0e-18*(instanceStruct.instanceVar_TOXP_i*instanceStruct.d_instanceVar_TOXP_i_dX+instanceStruct.d_instanceVar_TOXP_i_dX*instanceStruct.instanceVar_TOXP_i)/(instanceStruct.instanceVar_TOXP_i*instanceStruct.instanceVar_TOXP_i)/(instanceStruct.instanceVar_TOXP_i*instanceStruct.instanceVar_TOXP_i));
instanceStruct.instanceVar_temp = (4.0e-18/(instanceStruct.instanceVar_TOXP_i*instanceStruct.instanceVar_TOXP_i));
instanceStruct.d_instanceVar_AGIDL_i_dX = (instanceStruct.instanceVar_AGIDL_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_AGIDL_i_dX*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_AGIDL_i = (instanceStruct.instanceVar_AGIDL_i*instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_AGIDLD_i_dX = (instanceStruct.instanceVar_AGIDLD_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_AGIDLD_i_dX*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_AGIDLD_i = (instanceStruct.instanceVar_AGIDLD_i*instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_temp_dX = instanceStruct.d_instanceVar_TOXP_i_dX*5.0e8;
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_TOXP_i*5.0e8);
{
double value_sqrt_0 = sqrt(((((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT)))*((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tempM_dX = 0.5*((instanceStruct.instanceVar_STBGIDL_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*instanceStruct.instanceVar_dT)+deriv_sqrt_0_d0*((((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT)))*(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*instanceStruct.instanceVar_dT)+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*instanceStruct.instanceVar_dT)*((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT))))));
instanceStruct.instanceVar_tempM = (0.5*((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT))+value_sqrt_0));
}
instanceStruct.d_instanceVar_BGIDL_i_dX = ((instanceStruct.instanceVar_BGIDL_t*instanceStruct.instanceVar_tempM)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_BGIDL_t*instanceStruct.d_instanceVar_tempM_dX+instanceStruct.d_instanceVar_BGIDL_t_dX*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_BGIDL_i = ((instanceStruct.instanceVar_BGIDL_t*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
{
double value_sqrt_0 = sqrt(((((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT)))*((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tempM_dX = 0.5*((instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*instanceStruct.instanceVar_dT)+deriv_sqrt_0_d0*((((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT)))*(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*instanceStruct.instanceVar_dT)+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*instanceStruct.instanceVar_dT)*((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT))))));
instanceStruct.instanceVar_tempM = (0.5*((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT))+value_sqrt_0));
}
instanceStruct.d_instanceVar_BGIDLD_i_dX = ((instanceStruct.instanceVar_BGIDLD_t*instanceStruct.instanceVar_tempM)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_BGIDLD_t*instanceStruct.d_instanceVar_tempM_dX+instanceStruct.d_instanceVar_BGIDLD_t_dX*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_BGIDLD_i = ((instanceStruct.instanceVar_BGIDLD_t*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_STA2_i)*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_A2_i_dX = (instanceStruct.instanceVar_A2_t*deriv_exp_0_d0*(((-instanceStruct.instanceVar_STA2_i)*instanceStruct.d_instanceVar_lnrTn_dX+(-instanceStruct.d_instanceVar_STA2_i_dX)*instanceStruct.instanceVar_lnrTn))+instanceStruct.d_instanceVar_A2_t_dX*value_exp_0);
instanceStruct.instanceVar_A2_i = (instanceStruct.instanceVar_A2_t*value_exp_0);
}
instanceStruct.d_instanceVar_area_phit_dX = (instanceStruct.instanceVar_AREAQ_i*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_AREAQ_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_area_phit = (instanceStruct.instanceVar_AREAQ_i*instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_inner_sd_dX = (((instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit)*(0.25*1.602176565E-19)*instanceStruct.d_instanceVar_NSDAC_i_dX-((0.25*1.602176565E-19)*instanceStruct.instanceVar_NSDAC_i)*(instanceStruct.instanceVar_epsch*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_epsch_dX*instanceStruct.instanceVar_phit))/(instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit)/(instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit));
instanceStruct.instanceVar_inner_sd = (((0.25*1.602176565E-19)*instanceStruct.instanceVar_NSDAC_i)/(instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit));
{
double value_log_0 = log((instanceStruct.instanceVar_NSDAC_i/instanceStruct.instanceVar_neff));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_NSDAC_i/instanceStruct.instanceVar_neff));
instanceStruct.d_instanceVar_xsd_dX = deriv_log_0_d0*(((instanceStruct.instanceVar_neff*instanceStruct.d_instanceVar_NSDAC_i_dX-instanceStruct.instanceVar_NSDAC_i*instanceStruct.d_instanceVar_neff_dX)/instanceStruct.instanceVar_neff/instanceStruct.instanceVar_neff));
instanceStruct.instanceVar_xsd = value_log_0;
}
instanceStruct.d_instanceVar_fif_phit_dX = ((instanceStruct.instanceVar_FIF_i*1.25e-6)*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_FIF_i_dX*1.25e-6*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_fif_phit = ((instanceStruct.instanceVar_FIF_i*1.25e-6)*instanceStruct.instanceVar_phit);
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_epsch/3.45313E-11)*instanceStruct.instanceVar_TSI_i)*(TOX1_i+4.0e-10)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_lambda2D_dX = deriv_sqrt_0_d0*((((instanceStruct.instanceVar_epsch/3.45313E-11)*instanceStruct.instanceVar_TSI_i)*d_TOX1_i_dX+((instanceStruct.instanceVar_epsch/3.45313E-11)*instanceStruct.d_instanceVar_TSI_i_dX+(instanceStruct.d_instanceVar_epsch_dX/3.45313E-11)*instanceStruct.instanceVar_TSI_i)*(TOX1_i+4.0e-10)));
instanceStruct.instanceVar_lambda2D = value_sqrt_0;
}
{
double value_exp_0 = exp((instanceStruct.instanceVar_STRTH_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_rth_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STRTH_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STRTH_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_rth = value_exp_0;
}
instanceStruct.d_instanceVar_RTH_i_dX = (instanceStruct.instanceVar_RTH_t*instanceStruct.d_instanceVar_tf_rth_dX+instanceStruct.d_instanceVar_RTH_t_dX*instanceStruct.instanceVar_tf_rth);
instanceStruct.instanceVar_RTH_i = (instanceStruct.instanceVar_RTH_t*instanceStruct.instanceVar_tf_rth);
instanceStruct.d_instanceVar_nt_dX = instanceStruct.d_instanceVar_FNT_i_dX*4.0*1.3806488E-23*instanceStruct.instanceVar_TKC;
instanceStruct.instanceVar_nt = (((instanceStruct.instanceVar_FNT_i*4.0)*1.3806488E-23)*instanceStruct.instanceVar_TKC);
instanceStruct.d_instanceVar_nt0_dX = instanceStruct.d_instanceVar_nt_dX;
instanceStruct.instanceVar_nt0 = instanceStruct.instanceVar_nt;
instanceStruct.d_instanceVar_fac_exc_dX = (9.10938291E-31*1.0e12)*instanceStruct.d_instanceVar_FNTEXC_i_dX;
instanceStruct.instanceVar_fac_exc = ((9.10938291E-31*1.0e12)*instanceStruct.instanceVar_FNTEXC_i);
}
// End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
//Begin block initial_model
{
modelStruct.d_modelVar_TKR_dX = modelStruct.d_modelPar_TR_dX;
modelStruct.modelVar_TKR = (273.15+modelStruct.modelPar_TR);
{
double value_min_0 = std::min(admsTemperature,static_cast<double>(1000.0));
modelStruct.modelVar_TKD = value_min_0;
}
if ((((modelStruct.modelPar_SWSCALE==0)&&(modelStruct.modelPar_RTH>0.0))||((modelStruct.modelPar_SWSCALE>0)&&(modelStruct.modelPar_RTHO>0.0))))
{
modelStruct.modelVar_SWSHE_i = modelStruct.modelPar_SWSHE;
}
else
{
modelStruct.modelVar_SWSHE_i = 0;
}
modelStruct.modelVar_gmin = ADMSgmin_arg;
}
// End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_D_GND,
const int admsProbeID_V_S_GND,
const int admsProbeID_V_B_GND,
const int admsProbeID_V_G_GND,
const int admsProbeID_I_NSIG_GND,
const int admsProbeID_V_NSIG_GND,
const int admsProbeID_Temp_Tnode_GND,
const int admsProbeID_V_S_B,
const int admsProbeID_V_D_S,
const int admsProbeID_V_G_S,
// node constants
const int admsNodeID_D,
const int admsNodeID_G,
const int admsNodeID_S,
const int admsNodeID_B,
const int admsNodeID_Tnode,
const int admsNodeID_NSIG,
const int admsBRA_ID_NSIG_GND,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double r1init_op=0.0;
double d_r1init_op_dX=0.0;
  double r2init_op=0.0;
double d_r2init_op_dX=0.0;
  double x1init_op=0.0;
double d_x1init_op_dX=0.0;
  double x2init_op=0.0;
double d_x2init_op_dX=0.0;
  double xth1init_op=0.0;
double d_xth1init_op_dX=0.0;
  double xth2init_op=0.0;
double d_xth2init_op_dX=0.0;
  double xg1thinit_op=0.0;
double d_xg1thinit_op_dX=0.0;
  double vthinit_op=0.0;
double d_vthinit_op_dX=0.0;
  double inv_phit0_op=0.0;
  double EgSi_op=0.0;
  double EgGe_op=0.0;
  double dEg_op=0.0;
double d_dEg_op_dX=0.0;
  double Eg_op=0.0;
double d_Eg_op_dX=0.0;
  double Eg_2phit0_op=0.0;
double d_Eg_2phit0_op_dX=0.0;
  double dVfbch_op=0.0;
double d_dVfbch_op_dX=0.0;
  double neff_op=0.0;
double d_neff_op_dX=0.0;
  double inv_phit_op=0.0;
double d_inv_phit_op_dX=0.0;
  double A0_Csisq_op=0.0;
double d_A0_Csisq_op_dX=0.0;
  double xth_1D_op=0.0;
double d_xth_1D_op_dX=0.0;
  double xSDdep_op=0.0;
double d_xSDdep_op_dX=0.0;
  double CF1_op=0.0;
double d_CF1_op_dX=0.0;
  double CF2_op=0.0;
double d_CF2_op_dX=0.0;
  double xd0_op=0.0;
double d_xd0_op_dX=0.0;
  double qq_op=0.0;
double d_qq_op_dX=0.0;
  double VFB1_op=0.0;
double d_VFB1_op_dX=0.0;
  double VFB2_op=0.0;
double d_VFB2_op_dX=0.0;
  double xd_op=0.0;
double d_xd_op_dX=0.0;
  double xdsx_op=0.0;
double d_xdsx_op_dX=0.0;
  double dxdsx_op=0.0;
double d_dxdsx_op_dX=0.0;
  double xg10_op=0.0;
double d_xg10_op_dX=0.0;
  double xg20_op=0.0;
double d_xg20_op_dX=0.0;
  double xg2eff_op=0.0;
double d_xg2eff_op_dX=0.0;
  double e1_op=0.0;
double d_e1_op_dX=0.0;
  double e2_op=0.0;
double d_e2_op_dX=0.0;
  double CsiPrime_op=0.0;
double d_CsiPrime_op_dX=0.0;
  double k1_1D_QM_op=0.0;
double d_k1_1D_QM_op_dX=0.0;
  double k2_1D_QM_op=0.0;
double d_k2_1D_QM_op_dX=0.0;
  double keq_1D_QM_op=0.0;
double d_keq_1D_QM_op_dX=0.0;
  double Dx_WI_1D_op=0.0;
double d_Dx_WI_1D_op_dX=0.0;
  double x_WI_1D_op=0.0;
double d_x_WI_1D_op_dX=0.0;
  double x_1D_op=0.0;
double d_x_1D_op_dX=0.0;
  double dleff_op=0.0;
double d_dleff_op_dX=0.0;
  double xedge_op=0.0;
double d_xedge_op_dX=0.0;
  double sce1_op=0.0;
double d_sce1_op_dX=0.0;
  double sce2_op=0.0;
double d_sce2_op_dX=0.0;
  double dxg1_dibl_op=0.0;
double d_dxg1_dibl_op_dX=0.0;
  double dxg2_dibl_op=0.0;
double d_dxg2_dibl_op_dX=0.0;
  double xg1_op=0.0;
double d_xg1_op_dX=0.0;
  double xg2_op=0.0;
double d_xg2_op_dX=0.0;
  double xg2x_op=0.0;
double d_xg2x_op_dX=0.0;
  double k1_op=0.0;
double d_k1_op_dX=0.0;
  double k2_op=0.0;
double d_k2_op_dX=0.0;
  double A0_op=0.0;
double d_A0_op_dX=0.0;
  double exp_dxth_op=0.0;
double d_exp_dxth_op_dX=0.0;
  double dxth_op=0.0;
double d_dxth_op_dX=0.0;
  double diff_min_op=0.0;
double d_diff_min_op_dX=0.0;
  double r1_op=0.0;
double d_r1_op_dX=0.0;
  double r2_op=0.0;
double d_r2_op_dX=0.0;
  double x1sat_op=0.0;
double d_x1sat_op_dX=0.0;
  double x2sat_op=0.0;
double d_x2sat_op_dX=0.0;
  double xth1_op=0.0;
double d_xth1_op_dX=0.0;
  double xth2_op=0.0;
double d_xth2_op_dX=0.0;
  double xg1th_op=0.0;
double d_xg1th_op_dX=0.0;
  double Vdsat=0.0;
double d_Vdsat_dX=0.0;
  double qde=0.0;
double d_qde_dX=0.0;
  double qge=0.0;
double d_qge_dX=0.0;
  double qbe=0.0;
double d_qbe_dX=0.0;
  double Nunit=0.0;
double d_Nunit_dX=0.0;
  double dm=0.0;
double d_dm_dX=0.0;
  double qimstar=0.0;
double d_qimstar_dX=0.0;
  double t1=0.0;
double d_t1_dX=0.0;
  double sqrt_t2=0.0;
double d_sqrt_t2_dX=0.0;
  double t2=0.0;
double d_t2_dX=0.0;
  double r=0.0;
double d_r_dX=0.0;
  double lc=0.0;
double d_lc_dX=0.0;
  double lcinv2=0.0;
double d_lcinv2_dX=0.0;
  double g_ideal=0.0;
double d_g_ideal_dX=0.0;
  double t2x12=0.0;
double d_t2x12_dX=0.0;
  double gSid=0.0;
double d_gSid_dX=0.0;
  double sqrt_zsatexc=0.0;
double d_sqrt_zsatexc_dX=0.0;
  double Sidexc=0.0;
double d_Sidexc_dX=0.0;
  double Sids_th=0.0;
double d_Sids_th_dX=0.0;
  double COX_qm=0.0;
double d_COX_qm_dX=0.0;
  double CGeff=0.0;
double d_CGeff_dX=0.0;
  double CDGeff=0.0;
double d_CDGeff_dX=0.0;
  double CSGeff=0.0;
double d_CSGeff_dX=0.0;
  double migid=0.0;
double d_migid_dX=0.0;
  double cigid2=0.0;
double d_cigid2_dX=0.0;
  double gSig=0.0;
double d_gSig_dX=0.0;
  double SigR_th=0.0;
double d_SigR_th_dX=0.0;
  double Sids_th_u=0.0;
double d_Sids_th_u_dX=0.0;
  double Nstar=0.0;
double d_Nstar_dX=0.0;
  double Nmstar=0.0;
double d_Nmstar_dX=0.0;
  double DeltaN=0.0;
double d_DeltaN_dX=0.0;
  double Sids_fl=0.0;
double d_Sids_fl_dX=0.0;
  double Sigs_sh=0.0;
double d_Sigs_sh_dX=0.0;
  double Sigd_sh=0.0;
double d_Sigd_sh_dX=0.0;
  double shot_iavl=0.0;
double d_shot_iavl_dX=0.0;
  double Sids_sh=0.0;
double d_Sids_sh_dX=0.0;
  double Qs=0.0;
double d_Qs_dX=0.0;
  double Idse=0.0;
double d_Idse_dX=0.0;
  double Ithpwre=0.0;
double d_Ithpwre_dX=0.0;
  double Ithrce=0.0;
double d_Ithrce_dX=0.0;
  double k1q1m=0.0;
double d_k1q1m_dX=0.0;
  double k2q2m=0.0;
double d_k2q2m_dX=0.0;
  double k1q1eff=0.0;
double d_k1q1eff_dX=0.0;
  double k2q2eff=0.0;
double d_k2q2eff_dX=0.0;
  double k1q1deff=0.0;
double d_k1q1deff_dX=0.0;
  double k2q2deff=0.0;
double d_k2q2deff_dX=0.0;
  double Qg=0.0;
double d_Qg_dX=0.0;
  double Qb=0.0;
double d_Qb_dX=0.0;
  double Qd=0.0;
double d_Qd_dX=0.0;
  double xeffs=0.0;
double d_xeffs_dX=0.0;
  double xeffd=0.0;
double d_xeffd_dX=0.0;
  double xstars=0.0;
double d_xstars_dX=0.0;
  double xstard=0.0;
double d_xstard_dX=0.0;
  double lambdaf=0.0;
double d_lambdaf_dX=0.0;
  double lambdab=0.0;
double d_lambdab_dX=0.0;
  double xalphaf=0.0;
double d_xalphaf_dX=0.0;
  double xalphab=0.0;
double d_xalphab_dX=0.0;
  double xedgefs=0.0;
double d_xedgefs_dX=0.0;
  double xedgefd=0.0;
double d_xedgefd_dX=0.0;
  double xedgebs=0.0;
double d_xedgebs_dX=0.0;
  double xedgebd=0.0;
double d_xedgebd_dX=0.0;
  double Qgsif=0.0;
double d_Qgsif_dX=0.0;
  double Qgdif=0.0;
double d_Qgdif_dX=0.0;
  double Qbsif=0.0;
double d_Qbsif_dX=0.0;
  double Qbdif=0.0;
double d_Qbdif_dX=0.0;
  double Qgse=0.0;
double d_Qgse_dX=0.0;
  double Qgde=0.0;
double d_Qgde_dX=0.0;
  double Qovs=0.0;
double d_Qovs_dX=0.0;
  double Qovd=0.0;
double d_Qovd_dX=0.0;
  double Qgbe=0.0;
double d_Qgbe_dX=0.0;
  double Qdse=0.0;
double d_Qdse_dX=0.0;
  double Qssub=0.0;
double d_Qssub_dX=0.0;
  double Qdsub=0.0;
double d_Qdsub_dX=0.0;
  double Qth=0.0;
double d_Qth_dX=0.0;
  double Vgsu=0.0;
  double Vdsu=0.0;
  double Vsbu=0.0;
  double Vsdu=0.0;
  double Vgdu=0.0;
  double Vdbu=0.0;
  double Vds=0.0;
  double Vgs=0.0;
  double Vsb=0.0;
  double Vgb=0.0;
  double xd=0.0;
double d_xd_dX=0.0;
  double xdsx=0.0;
double d_xdsx_dX=0.0;
  double dxdsx=0.0;
double d_dxdsx_dX=0.0;
  double xg10=0.0;
double d_xg10_dX=0.0;
  double xg20=0.0;
double d_xg20_dX=0.0;
  double xgs_ov=0.0;
  double xgd_ov=0.0;
  double xgs_ovcv=0.0;
double d_xgs_ovcv_dX=0.0;
  double xgd_ovcv=0.0;
double d_xgd_ovcv_dX=0.0;
  double SPSUB_xgb=0.0;
double d_SPSUB_xgb_dX=0.0;
  double SPSUB_delta=0.0;
double d_SPSUB_delta_dX=0.0;
  double SPSUB_xg1=0.0;
double d_SPSUB_xg1_dX=0.0;
  double SPSUB_A_fac=0.0;
double d_SPSUB_A_fac_dX=0.0;
  double SPSUB_xbar=0.0;
double d_SPSUB_xbar_dX=0.0;
  double SPSUB_w=0.0;
double d_SPSUB_w_dX=0.0;
  double SPSUB_x1=0.0;
double d_SPSUB_x1_dX=0.0;
  double SPSUB_bx=0.0;
double d_SPSUB_bx_dX=0.0;
  double SPSUB_temp2=0.0;
double d_SPSUB_temp2_dX=0.0;
  double SPSUB_b=0.0;
double d_SPSUB_b_dX=0.0;
  double SPSUB_x0=0.0;
double d_SPSUB_x0_dX=0.0;
  double SPSUB_yg=0.0;
double d_SPSUB_yg_dX=0.0;
  double SPSUB_ysub=0.0;
double d_SPSUB_ysub_dX=0.0;
  double SPSUB_eta=0.0;
double d_SPSUB_eta_dX=0.0;
  double SPSUB_temp=0.0;
double d_SPSUB_temp_dX=0.0;
  double SPSUB_a=0.0;
double d_SPSUB_a_dX=0.0;
  double SPSUB_c=0.0;
double d_SPSUB_c_dX=0.0;
  double SPSUB_tau=0.0;
double d_SPSUB_tau_dX=0.0;
  double nu=0.0;
double d_nu_dX=0.0;
  double mutau=0.0;
double d_mutau_dX=0.0;
  double SPSUB_y0=0.0;
double d_SPSUB_y0_dX=0.0;
  double SPSUB_delta0=0.0;
double d_SPSUB_delta0_dX=0.0;
  double SPSUB_delta1=0.0;
double d_SPSUB_delta1_dX=0.0;
  double SPSUB_xi0=0.0;
double d_SPSUB_xi0_dX=0.0;
  double SPSUB_xi1=0.0;
double d_SPSUB_xi1_dX=0.0;
  double SPSUB_xi2=0.0;
double d_SPSUB_xi2_dX=0.0;
  double SPSUB_pC=0.0;
double d_SPSUB_pC_dX=0.0;
  double SPSUB_qC=0.0;
double d_SPSUB_qC_dX=0.0;
  double SPSUB_temp1=0.0;
double d_SPSUB_temp1_dX=0.0;
  double xg2eff=0.0;
double d_xg2eff_dX=0.0;
  double e1=0.0;
double d_e1_dX=0.0;
  double e2=0.0;
double d_e2_dX=0.0;
  double tox1fact=0.0;
double d_tox1fact_dX=0.0;
  double tox2fact=0.0;
double d_tox2fact_dX=0.0;
  double k1_1D_QM=0.0;
double d_k1_1D_QM_dX=0.0;
  double k2_1D_QM=0.0;
double d_k2_1D_QM_dX=0.0;
  double keq_1D_QM=0.0;
double d_keq_1D_QM_dX=0.0;
  double Dx_WI_1D=0.0;
double d_Dx_WI_1D_dX=0.0;
  double x_WI_1D=0.0;
double d_x_WI_1D_dX=0.0;
  double x_1D=0.0;
double d_x_1D_dX=0.0;
  double dleff=0.0;
double d_dleff_dX=0.0;
  double xedge=0.0;
double d_xedge_dX=0.0;
  double sce1=0.0;
double d_sce1_dX=0.0;
  double sce2=0.0;
double d_sce2_dX=0.0;
  double dxg1_dibl=0.0;
double d_dxg1_dibl_dX=0.0;
  double dxg2_dibl=0.0;
double d_dxg2_dibl_dX=0.0;
  double xg1=0.0;
double d_xg1_dX=0.0;
  double xg2=0.0;
double d_xg2_dX=0.0;
  double xg1x=0.0;
double d_xg1x_dX=0.0;
  double xg2x=0.0;
double d_xg2x_dX=0.0;
  double k2=0.0;
double d_k2_dX=0.0;
  double inv_k1=0.0;
double d_inv_k1_dX=0.0;
  double inv_k2=0.0;
double d_inv_k2_dX=0.0;
  double keq=0.0;
double d_keq_dX=0.0;
  double A0=0.0;
double d_A0_dX=0.0;
  double exp_dxth=0.0;
double d_exp_dxth_dX=0.0;
  double dxth=0.0;
double d_dxth_dX=0.0;
  double diff_min=0.0;
double d_diff_min_dX=0.0;
  double Dx_WI=0.0;
double d_Dx_WI_dX=0.0;
  double Dx_WIsq=0.0;
double d_Dx_WIsq_dX=0.0;
  double x1_WI0=0.0;
double d_x1_WI0_dX=0.0;
  double x2_WI0=0.0;
double d_x2_WI0_dX=0.0;
  double q_temp1=0.0;
double d_q_temp1_dX=0.0;
  double q_temp2=0.0;
double d_q_temp2_dX=0.0;
  double q_x1sat=0.0;
double d_q_x1sat_dX=0.0;
  double q_x2sat=0.0;
double d_q_x2sat_dX=0.0;
  double q_temp3=0.0;
double d_q_temp3_dX=0.0;
  double q_x1=0.0;
double d_q_x1_dX=0.0;
  double q_x2=0.0;
double d_q_x2_dX=0.0;
  double q_x1_WI=0.0;
double d_q_x1_WI_dX=0.0;
  double q_x2_WI=0.0;
double d_q_x2_WI_dX=0.0;
  double q1s=0.0;
double d_q1s_dX=0.0;
  double q2s=0.0;
double d_q2s_dX=0.0;
  double q_rac_qsq=0.0;
double d_q_rac_qsq_dX=0.0;
  double q_invexpq=0.0;
double d_q_invexpq_dX=0.0;
  double q_k1q1=0.0;
double d_q_k1q1_dX=0.0;
  double q_Aexp=0.0;
double d_q_Aexp_dX=0.0;
  double q_qsq=0.0;
double d_q_qsq_dX=0.0;
  double q_d1_qsq=0.0;
double d_q_d1_qsq_dX=0.0;
  double q_d2_qsq=0.0;
double d_q_d2_qsq_dX=0.0;
  double q_qcoth=0.0;
double d_q_qcoth_dX=0.0;
  double q_d1_qcoth=0.0;
double d_q_d1_qcoth_dX=0.0;
  double q_d2_qcoth=0.0;
double d_q_d2_qcoth_dX=0.0;
  double q_d1_ln=0.0;
double d_q_d1_ln_dX=0.0;
  double q_d2_ln=0.0;
double d_q_d2_ln_dX=0.0;
  double q_sh_term=0.0;
double d_q_sh_term_dX=0.0;
  double q_ln_term=0.0;
double d_q_ln_term_dX=0.0;
  double q_expnum=0.0;
double d_q_expnum_dX=0.0;
  double q_d1_expnum=0.0;
double d_q_d1_expnum_dX=0.0;
  double q_d2_expnum=0.0;
double d_q_d2_expnum_dX=0.0;
  double q_lnexpnum=0.0;
double d_q_lnexpnum_dX=0.0;
  double q_d1_lnexpnum=0.0;
double d_q_d1_lnexpnum_dX=0.0;
  double q_d2_lnexpnum=0.0;
double d_q_d2_lnexpnum_dX=0.0;
  double q_q2_int=0.0;
double d_q_q2_int_dX=0.0;
  double q_d1_q2=0.0;
double d_q_d1_q2_dX=0.0;
  double q_d2_q2=0.0;
double d_q_d2_q2_dX=0.0;
  double q_qi_int=0.0;
double d_q_qi_int_dX=0.0;
  double q_d1_qi=0.0;
double d_q_d1_qi_dX=0.0;
  double q_d2_qi=0.0;
double d_q_d2_qi_dX=0.0;
  double q_zero=0.0;
double d_q_zero_dX=0.0;
  double q_d1_zero=0.0;
double d_q_d1_zero_dX=0.0;
  double q_d2_zero=0.0;
double d_q_d2_zero_dX=0.0;
  double q_eps1=0.0;
double d_q_eps1_dX=0.0;
  double q_eps2=0.0;
double d_q_eps2_dX=0.0;
  double q_k2q2=0.0;
double d_q_k2q2_dX=0.0;
  double q_a=0.0;
double d_q_a_dX=0.0;
  double q_b=0.0;
double d_q_b_dX=0.0;
  double q_c=0.0;
double d_q_c_dX=0.0;
  double q_disc=0.0;
double d_q_disc_dX=0.0;
  double q_delta=0.0;
double d_q_delta_dX=0.0;
  double q_dx1=0.0;
double d_q_dx1_dX=0.0;
  double k1q1s=0.0;
double d_k1q1s_dX=0.0;
  double Aexp1s=0.0;
double d_Aexp1s_dX=0.0;
  double qsqs=0.0;
double d_qsqs_dX=0.0;
  double k2q2s=0.0;
double d_k2q2s_dX=0.0;
  double Aexp2s=0.0;
double d_Aexp2s_dX=0.0;
  double a1s=0.0;
double d_a1s_dX=0.0;
  double a2s=0.0;
double d_a2s_dX=0.0;
  double b1s=0.0;
double d_b1s_dX=0.0;
  double b2s=0.0;
double d_b2s_dX=0.0;
  double sums=0.0;
double d_sums_dX=0.0;
  double dqsqs_dxn_qi=0.0;
double d_dqsqs_dxn_qi_dX=0.0;
  double xdrifts=0.0;
double d_xdrifts_dX=0.0;
  double esurf1s=0.0;
double d_esurf1s_dX=0.0;
  double esurf2s=0.0;
double d_esurf2s_dX=0.0;
  double ecpl1s=0.0;
double d_ecpl1s_dX=0.0;
  double ecpl2s=0.0;
double d_ecpl2s_dX=0.0;
  double eeff1s=0.0;
double d_eeff1s_dX=0.0;
  double eeff2s=0.0;
double d_eeff2s_dX=0.0;
  double qi1s=0.0;
double d_qi1s_dX=0.0;
  double qi2s=0.0;
double d_qi2s_dX=0.0;
  double c1s=0.0;
double d_c1s_dX=0.0;
  double c2s=0.0;
double d_c2s_dX=0.0;
  double fcors=0.0;
double d_fcors_dX=0.0;
  double Gcss=0.0;
double d_Gcss_dX=0.0;
  double frscsi=0.0;
double d_frscsi_dX=0.0;
  double Grss=0.0;
double d_Grss_dX=0.0;
  double Gmob1s=0.0;
double d_Gmob1s_dX=0.0;
  double Gmob2s=0.0;
double d_Gmob2s_dX=0.0;
  double Gmobs=0.0;
double d_Gmobs_dX=0.0;
  double s1=0.0;
double d_s1_dX=0.0;
  double s2=0.0;
double d_s2_dX=0.0;
  double deltaxinf=0.0;
double d_deltaxinf_dX=0.0;
  double q1chapinf=0.0;
double d_q1chapinf_dX=0.0;
  double q2chapinf=0.0;
double d_q2chapinf_dX=0.0;
  double dinf=0.0;
double d_dinf_dX=0.0;
  double inv_dinf=0.0;
double d_inv_dinf_dX=0.0;
  double wsat1=0.0;
double d_wsat1_dX=0.0;
  double sat_fact1=0.0;
double d_sat_fact1_dX=0.0;
  double wsat2=0.0;
double d_wsat2_dX=0.0;
  double sat_fact2=0.0;
double d_sat_fact2_dX=0.0;
  double dqis_dxn_qi=0.0;
double d_dqis_dxn_qi_dX=0.0;
  double deltaxi=0.0;
double d_deltaxi_dX=0.0;
  double gamma=0.0;
double d_gamma_dX=0.0;
  double vs=0.0;
double d_vs_dX=0.0;
  double vd=0.0;
double d_vd_dX=0.0;
  double wd=0.0;
double d_wd_dX=0.0;
  double ps_cub=0.0;
double d_ps_cub_dX=0.0;
  double qs_cub=0.0;
double d_qs_cub_dX=0.0;
  double pd_cub=0.0;
double d_pd_cub_dX=0.0;
  double qd_cub=0.0;
double d_qd_cub_dX=0.0;
  double racs=0.0;
double d_racs_dX=0.0;
  double racd=0.0;
double d_racd_dX=0.0;
  double deltaxsats=0.0;
double d_deltaxsats_dX=0.0;
  double deltaxsatd=0.0;
double d_deltaxsatd_dX=0.0;
  double deltaxsat=0.0;
double d_deltaxsat_dX=0.0;
  double qidsats=0.0;
double d_qidsats_dX=0.0;
  double qidsatd=0.0;
double d_qidsatd_dX=0.0;
  double qidsat=0.0;
double d_qidsat_dX=0.0;
  double xndssat=0.0;
double d_xndssat_dX=0.0;
  double q1d=0.0;
double d_q1d_dX=0.0;
  double q2d=0.0;
double d_q2d_dX=0.0;
  double k1q1d=0.0;
double d_k1q1d_dX=0.0;
  double Aexp1d=0.0;
double d_Aexp1d_dX=0.0;
  double qsqd=0.0;
double d_qsqd_dX=0.0;
  double k2q2d=0.0;
double d_k2q2d_dX=0.0;
  double Aexp2d=0.0;
double d_Aexp2d_dX=0.0;
  double a1d=0.0;
double d_a1d_dX=0.0;
  double a2d=0.0;
double d_a2d_dX=0.0;
  double b1d=0.0;
double d_b1d_dX=0.0;
  double b2d=0.0;
double d_b2d_dX=0.0;
  double sumd=0.0;
double d_sumd_dX=0.0;
  double dqsqd_dxn_qi=0.0;
double d_dqsqd_dxn_qi_dX=0.0;
  double xdriftd=0.0;
double d_xdriftd_dX=0.0;
  double dxdrift=0.0;
double d_dxdrift_dX=0.0;
  double esurf1d=0.0;
double d_esurf1d_dX=0.0;
  double esurf2d=0.0;
double d_esurf2d_dX=0.0;
  double ecpl1d=0.0;
double d_ecpl1d_dX=0.0;
  double ecpl2d=0.0;
double d_ecpl2d_dX=0.0;
  double eeff1d=0.0;
double d_eeff1d_dX=0.0;
  double eeff2d=0.0;
double d_eeff2d_dX=0.0;
  double qi1m=0.0;
double d_qi1m_dX=0.0;
  double qi2m=0.0;
double d_qi2m_dX=0.0;
  double ecpl1=0.0;
double d_ecpl1_dX=0.0;
  double ecpl2=0.0;
double d_ecpl2_dX=0.0;
  double eeff1=0.0;
double d_eeff1_dX=0.0;
  double eeff2=0.0;
double d_eeff2_dX=0.0;
  double c1=0.0;
double d_c1_dX=0.0;
  double c2=0.0;
double d_c2_dX=0.0;
  double csum=0.0;
double d_csum_dX=0.0;
  double fcor=0.0;
double d_fcor_dX=0.0;
  double Gcs=0.0;
double d_Gcs_dX=0.0;
  double Grs=0.0;
double d_Grs_dX=0.0;
  double Gmob1=0.0;
double d_Gmob1_dX=0.0;
  double Gmob2=0.0;
double d_Gmob2_dX=0.0;
  double inv_qimstar1=0.0;
double d_inv_qimstar1_dX=0.0;
  double r1=0.0;
double d_r1_dX=0.0;
  double dL_L=0.0;
double d_dL_L_dX=0.0;
  double GdL=0.0;
double d_GdL_dX=0.0;
  double dL1_L=0.0;
double d_dL1_L_dX=0.0;
  double sqrt_zsat=0.0;
double d_sqrt_zsat_dX=0.0;
  double vsat_fact=0.0;
double d_vsat_fact_dX=0.0;
  double qmfact2=0.0;
double d_qmfact2_dX=0.0;
  double dqid_dxn_qi=0.0;
double d_dqid_dxn_qi_dX=0.0;
  double Ls=0.0;
double d_Ls_dX=0.0;
  double Ld=0.0;
double d_Ld_dX=0.0;
  double Us=0.0;
double d_Us_dX=0.0;
  double Ud=0.0;
double d_Ud_dX=0.0;
  double idrift2=0.0;
double d_idrift2_dX=0.0;
  double norm_Ids=0.0;
double d_norm_Ids_dX=0.0;
  double zeta1=0.0;
double d_zeta1_dX=0.0;
  double zeta2=0.0;
double d_zeta2_dX=0.0;
  double ksi1=0.0;
double d_ksi1_dX=0.0;
  double ksi2=0.0;
double d_ksi2_dX=0.0;
  double q1s_chap=0.0;
double d_q1s_chap_dX=0.0;
  double q1d_chap=0.0;
double d_q1d_chap_dX=0.0;
  double q2s_chap=0.0;
double d_q2s_chap_dX=0.0;
  double q2d_chap=0.0;
double d_q2d_chap_dX=0.0;
  double inv_k2h2_0=0.0;
double d_inv_k2h2_0_dX=0.0;
  double inv_k1h1=0.0;
double d_inv_k1h1_dX=0.0;
  double inv_k2h2=0.0;
double d_inv_k2h2_dX=0.0;
  double delta_k2q2=0.0;
double d_delta_k2q2_dX=0.0;
  double prod1=0.0;
double d_prod1_dX=0.0;
  double prod2=0.0;
double d_prod2_dX=0.0;
  double xs_ov=0.0;
double d_xs_ov_dX=0.0;
  double xd_ov=0.0;
double d_xd_ov_dX=0.0;
  double xs_ovcv=0.0;
double d_xs_ovcv_dX=0.0;
  double xd_ovcv=0.0;
double d_xd_ovcv_dX=0.0;
  double GOV=0.0;
double d_GOV_dX=0.0;
  double GOV2=0.0;
double d_GOV2_dX=0.0;
  double xi_ov=0.0;
double d_xi_ov_dX=0.0;
  double x_mrg_ov=0.0;
double d_x_mrg_ov_dX=0.0;
  double inv_xi_ov=0.0;
double d_inv_xi_ov_dX=0.0;
  double inv_xg1=0.0;
double d_inv_xg1_dX=0.0;
  double SP_OV_Afac=0.0;
double d_SP_OV_Afac_dX=0.0;
  double SP_OV_xbar=0.0;
double d_SP_OV_xbar_dX=0.0;
  double SP_OV_x0=0.0;
double d_SP_OV_x0_dX=0.0;
  double SP_OV_u=0.0;
double d_SP_OV_u_dX=0.0;
  double SP_OV_ygf=0.0;
double d_SP_OV_ygf_dX=0.0;
  double SP_OV_z=0.0;
double d_SP_OV_z_dX=0.0;
  double SP_OV_eta=0.0;
double d_SP_OV_eta_dX=0.0;
  double SP_OV_a=0.0;
double d_SP_OV_a_dX=0.0;
  double SP_OV_c=0.0;
double d_SP_OV_c_dX=0.0;
  double SP_OV_tau=0.0;
double d_SP_OV_tau_dX=0.0;
  double SP_OV_nu=0.0;
double d_SP_OV_nu_dX=0.0;
  double SP_OV_mutau=0.0;
double d_SP_OV_mutau_dX=0.0;
  double SP_OV_temp=0.0;
double d_SP_OV_temp_dX=0.0;
  double SP_OV_y0=0.0;
double d_SP_OV_y0_dX=0.0;
  double SP_OV_D0=0.0;
double d_SP_OV_D0_dX=0.0;
  double SP_OV_p=0.0;
double d_SP_OV_p_dX=0.0;
  double SP_OV_q=0.0;
double d_SP_OV_q_dX=0.0;
  double SP_OV_xi=0.0;
double d_SP_OV_xi_dX=0.0;
  double SP_OV_w=0.0;
double d_SP_OV_w_dX=0.0;
  double Vovs=0.0;
double d_Vovs_dX=0.0;
  double Vovd=0.0;
double d_Vovd_dX=0.0;
  double Vovscv=0.0;
double d_Vovscv_dX=0.0;
  double Vovdcv=0.0;
double d_Vovdcv_dX=0.0;
  double Igsov=0.0;
double d_Igsov_dX=0.0;
  double Igdov=0.0;
double d_Igdov_dX=0.0;
  double Igc=0.0;
double d_Igc_dX=0.0;
  double Igs=0.0;
double d_Igs_dX=0.0;
  double Igd=0.0;
double d_Igd_dX=0.0;
  double Igcs=0.0;
double d_Igcs_dX=0.0;
  double Igcd=0.0;
double d_Igcd_dX=0.0;
  double arg2mina=0.0;
double d_arg2mina_dX=0.0;
  double psi_t=0.0;
double d_psi_t_dX=0.0;
  double zg=0.0;
double d_zg_dX=0.0;
  double gc2oveff=0.0;
double d_gc2oveff_dX=0.0;
  double gc3oveff=0.0;
double d_gc3oveff_dX=0.0;
  double gcqoveff=0.0;
double d_gcqoveff_dX=0.0;
  double igoveff=0.0;
double d_igoveff_dX=0.0;
  double igovefffowler=0.0;
double d_igovefffowler_dX=0.0;
  double arg1=0.0;
double d_arg1_dX=0.0;
  double Dsi=0.0;
double d_Dsi_dX=0.0;
  double Dgate=0.0;
double d_Dgate_dX=0.0;
  double TP=0.0;
double d_TP_dX=0.0;
  double TP2=0.0;
double d_TP2_dX=0.0;
  double half_x_ds=0.0;
double d_half_x_ds_dX=0.0;
  double Vm=0.0;
double d_Vm_dX=0.0;
  double q1m=0.0;
double d_q1m_dX=0.0;
  double Voxm=0.0;
double d_Voxm_dX=0.0;
  double x_m=0.0;
double d_x_m_dX=0.0;
  double Igc0=0.0;
double d_Igc0_dX=0.0;
  double u0=0.0;
double d_u0_dX=0.0;
  double x=0.0;
double d_x_dX=0.0;
  double u0_div_H=0.0;
double d_u0_div_H_dX=0.0;
  double Bg=0.0;
double d_Bg_dX=0.0;
  double Ag=0.0;
double d_Ag_dX=0.0;
  double inv_x=0.0;
double d_inv_x_dX=0.0;
  double ex=0.0;
double d_ex_dX=0.0;
  double inv_ex=0.0;
double d_inv_ex_dX=0.0;
  double xsq=0.0;
double d_xsq_dX=0.0;
  double igc=0.0;
double d_igc_dX=0.0;
  double igcd_h=0.0;
double d_igcd_h_dX=0.0;
  double Igisl=0.0;
double d_Igisl_dX=0.0;
  double Vtovs=0.0;
double d_Vtovs_dX=0.0;
  double Igidl=0.0;
double d_Igidl_dX=0.0;
  double Vtovd=0.0;
double d_Vtovd_dX=0.0;
  double delVsat=0.0;
double d_delVsat_dX=0.0;
  double Ithpwr=0.0;
double d_Ithpwr_dX=0.0;
  double Ithrc=0.0;
double d_Ithrc_dX=0.0;


  // -- code converted from analog/code block
//Begin block evaluateStatic
{
if ((modelStruct.modelPar_TYPE==(+1)))
{
Vgsu = (probeVars[admsProbeID_V_G_S]);
Vdsu = (probeVars[admsProbeID_V_D_S]);
Vsbu = (probeVars[admsProbeID_V_S_B]);
}
else
{
Vgsu = (-(probeVars[admsProbeID_V_G_S]));
Vdsu = (-(probeVars[admsProbeID_V_D_S]));
Vsbu = (-(probeVars[admsProbeID_V_S_B]));
}
Vsdu = (-Vdsu);
Vgdu = (Vgsu+Vsdu);
Vdbu = (Vdsu+Vsbu);
if ((Vdsu<0.0))
{
instanceStruct.instanceVar_sigVds = (-1.0);
Vds = Vsdu;
Vgs = Vgdu;
Vsb = Vdbu;
}
else
{
instanceStruct.instanceVar_sigVds = 1.0;
Vds = Vdsu;
Vgs = Vgsu;
Vsb = Vsbu;
}
Vgb = (Vgs+Vsb);
if ((modelStruct.modelVar_SWSHE_i>0))
{
instanceStruct.instanceVar_DTC = (probeVars[admsProbeID_Temp_Tnode_GND]);
instanceStruct.instanceVar_TKC = (modelStruct.modelVar_TKD+instanceStruct.instanceVar_DTC);
instanceStruct.instanceVar_TKC_sq = (instanceStruct.instanceVar_TKC*instanceStruct.instanceVar_TKC);
instanceStruct.d_instanceVar_dT_dX = (-modelStruct.d_modelVar_TKR_dX);
instanceStruct.instanceVar_dT = (instanceStruct.instanceVar_TKC-modelStruct.modelVar_TKR);
instanceStruct.d_instanceVar_rT_dX = (-instanceStruct.instanceVar_TKC*modelStruct.d_modelVar_TKR_dX/modelStruct.modelVar_TKR/modelStruct.modelVar_TKR);
instanceStruct.instanceVar_rT = (instanceStruct.instanceVar_TKC/modelStruct.modelVar_TKR);
instanceStruct.d_instanceVar_rTn_dX = (modelStruct.d_modelVar_TKR_dX/instanceStruct.instanceVar_TKC);
instanceStruct.instanceVar_rTn = (modelStruct.modelVar_TKR/instanceStruct.instanceVar_TKC);
instanceStruct.instanceVar_phit0 = (instanceStruct.instanceVar_TKC*8.617332384961E-05);
instanceStruct.instanceVar_inv_phit0 = (1.0/instanceStruct.instanceVar_phit0);
instanceStruct.instanceVar_EgSi = (1.17-((4.730e-4*instanceStruct.instanceVar_TKC_sq)/(636+instanceStruct.instanceVar_TKC)));
instanceStruct.instanceVar_EgGe = (0.744-((4.774e-4*instanceStruct.instanceVar_TKC_sq)/(235+instanceStruct.instanceVar_TKC)));
instanceStruct.d_instanceVar_dEg_dX = (((instanceStruct.instanceVar_EgGe-instanceStruct.instanceVar_EgSi)+((-0.4)*instanceStruct.instanceVar_one_m_xge))*instanceStruct.d_instanceVar_XGE_i_dX+(-0.4)*instanceStruct.d_instanceVar_one_m_xge_dX*instanceStruct.instanceVar_XGE_i);
instanceStruct.instanceVar_dEg = (((instanceStruct.instanceVar_EgGe-instanceStruct.instanceVar_EgSi)+((-0.4)*instanceStruct.instanceVar_one_m_xge))*instanceStruct.instanceVar_XGE_i);
instanceStruct.d_instanceVar_Eg_dX = instanceStruct.d_instanceVar_dEg_dX;
instanceStruct.instanceVar_Eg = (instanceStruct.instanceVar_EgSi+instanceStruct.instanceVar_dEg);
instanceStruct.d_instanceVar_Eg_2phit0_dX = 0.5*instanceStruct.d_instanceVar_Eg_dX*instanceStruct.instanceVar_inv_phit0;
instanceStruct.instanceVar_Eg_2phit0 = ((0.5*instanceStruct.instanceVar_Eg)*instanceStruct.instanceVar_inv_phit0);
instanceStruct.d_instanceVar_dVfbch_dX = (0.05*instanceStruct.d_instanceVar_XGE_i_dX-0.5*instanceStruct.d_instanceVar_dEg_dX);
instanceStruct.instanceVar_dVfbch = ((0.05*instanceStruct.instanceVar_XGE_i)-(0.5*instanceStruct.instanceVar_dEg));
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_TKC*0.0033333333333));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = value_sqrt_0;
}
instanceStruct.d_instanceVar_temp1_dX = (((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+4.05E25*instanceStruct.d_instanceVar_temp_dX*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_temp1 = (((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp);
{
double value_exp_0 = exp((-instanceStruct.instanceVar_Eg_2phit0));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_neff_dX = ((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_niratio)*deriv_exp_0_d0*((-instanceStruct.d_instanceVar_Eg_2phit0_dX))+(instanceStruct.instanceVar_temp1*instanceStruct.d_instanceVar_niratio_dX+instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_niratio)*value_exp_0);
instanceStruct.instanceVar_neff = ((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_niratio)*value_exp_0);
}
instanceStruct.d_instanceVar_phit_dX = instanceStruct.instanceVar_phit0*(instanceStruct.instanceVar_CT_i*instanceStruct.d_instanceVar_rTn_dX+instanceStruct.d_instanceVar_CT_i_dX*instanceStruct.instanceVar_rTn);
instanceStruct.instanceVar_phit = (instanceStruct.instanceVar_phit0*(1.0+(instanceStruct.instanceVar_CT_i*instanceStruct.instanceVar_rTn)));
instanceStruct.d_instanceVar_inv_phit_dX = (-instanceStruct.d_instanceVar_phit_dX/instanceStruct.instanceVar_phit/instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_inv_phit = (1.0/instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_Eg_2phit_dX = ((0.5*instanceStruct.instanceVar_Eg)*instanceStruct.d_instanceVar_inv_phit_dX+0.5*instanceStruct.d_instanceVar_Eg_dX*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_Eg_2phit = ((0.5*instanceStruct.instanceVar_Eg)*instanceStruct.instanceVar_inv_phit);
instanceStruct.d_instanceVar_A0_Csisq_dX = ((((2.0*1.602176565E-19)*instanceStruct.instanceVar_neff)*instanceStruct.instanceVar_epsch)*instanceStruct.d_instanceVar_inv_phit_dX+(((2.0*1.602176565E-19)*instanceStruct.instanceVar_neff)*instanceStruct.d_instanceVar_epsch_dX+(2.0*1.602176565E-19)*instanceStruct.d_instanceVar_neff_dX*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_A0_Csisq = ((((2.0*1.602176565E-19)*instanceStruct.instanceVar_neff)*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit);
{
double value_log_0 = log(((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)/instanceStruct.instanceVar_A0_Csisq));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)/instanceStruct.instanceVar_A0_Csisq));
instanceStruct.d_instanceVar_xth_1D_dX = deriv_log_0_d0*(((instanceStruct.instanceVar_A0_Csisq*(instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_CsiPrime_0_dX+instanceStruct.d_instanceVar_CsiPrime_0_dX*instanceStruct.instanceVar_CsiPrime_0)-(instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)*instanceStruct.d_instanceVar_A0_Csisq_dX)/instanceStruct.instanceVar_A0_Csisq/instanceStruct.instanceVar_A0_Csisq));
instanceStruct.instanceVar_xth_1D = (value_log_0-0.6931471805599);
}
instanceStruct.d_instanceVar_xSDdep_dX = (((((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*instanceStruct.d_instanceVar_inv_phit_dX+(((instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime)*(((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.d_instanceVar_TSI_i_dX+(0.5*1.602176565E-19)*instanceStruct.d_instanceVar_NSDDC_i_dX*instanceStruct.instanceVar_TSI_i)-(((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)*(instanceStruct.d_instanceVar_Cox1Prime_dX+instanceStruct.d_instanceVar_Cox2Prime_dX))/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_xSDdep = (((((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*instanceStruct.instanceVar_inv_phit);
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_STCF_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STCF_i_dX*instanceStruct.instanceVar_dT);
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_STCF_i*instanceStruct.instanceVar_dT);
instanceStruct.d_instanceVar_CF1_i_dX = (instanceStruct.d_instanceVar_CF1_t_dX+instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_CF1_i = (instanceStruct.instanceVar_CF1_t+instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_CF2_i_dX = (instanceStruct.d_instanceVar_CF2_t_dX+instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_CF2_i = (instanceStruct.instanceVar_CF2_t+instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_xd0_dX = (instanceStruct.instanceVar_CFD_i*instanceStruct.d_instanceVar_inv_phit_dX+instanceStruct.d_instanceVar_CFD_i_dX*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_xd0 = (instanceStruct.instanceVar_CFD_i*instanceStruct.instanceVar_inv_phit);
instanceStruct.d_instanceVar_qq_dX = 0.0;
instanceStruct.instanceVar_qq = 0.0;
if ((modelStruct.modelPar_QMC>0.0))
{
if ((modelStruct.modelPar_TYPE==(+1)))
{
{
double value_log_0 = log((instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_qq_dX = (((0.4*modelStruct.modelPar_QMC)*1.27520989)*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*((instanceStruct.instanceVar_phit*instanceStruct.d_instanceVar_tsisq_dX+instanceStruct.d_instanceVar_phit_dX*instanceStruct.instanceVar_tsisq)))+0.4*modelStruct.d_modelPar_QMC_dX*1.27520989*value_exp_1);
instanceStruct.instanceVar_qq = (((0.4*modelStruct.modelPar_QMC)*1.27520989)*value_exp_1);
}
}
else
{
{
double value_log_0 = log((instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_phit*instanceStruct.instanceVar_tsisq));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_qq_dX = (((0.4*modelStruct.modelPar_QMC)*1.54120870)*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*((instanceStruct.instanceVar_phit*instanceStruct.d_instanceVar_tsisq_dX+instanceStruct.d_instanceVar_phit_dX*instanceStruct.instanceVar_tsisq)))+0.4*modelStruct.d_modelPar_QMC_dX*1.54120870*value_exp_1);
instanceStruct.instanceVar_qq = (((0.4*modelStruct.modelPar_QMC)*1.54120870)*value_exp_1);
}
}
}
instanceStruct.d_instanceVar_temp_dX = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_STVFB_i)*instanceStruct.d_instanceVar_dT_dX+modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_STVFB_i_dX*instanceStruct.instanceVar_dT)+instanceStruct.d_instanceVar_dVfbQM_dX);
instanceStruct.instanceVar_temp = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_STVFB_i)*instanceStruct.instanceVar_dT)+instanceStruct.instanceVar_dVfbQM);
instanceStruct.d_instanceVar_VFB1_i_dX = ((modelStruct.modelPar_TYPE*((instanceStruct.d_instanceVar_VFB1_t_dX+instanceStruct.d_instanceVar_dVfbch_dX)+instanceStruct.d_instanceVar_dVfb1Nch_dX)+instanceStruct.d_instanceVar_temp_dX)+instanceStruct.d_instancePar_DELVTO_dX);
instanceStruct.instanceVar_VFB1_i = (((modelStruct.modelPar_TYPE*((instanceStruct.instanceVar_VFB1_t+instanceStruct.instanceVar_dVfbch)+instanceStruct.instanceVar_dVfb1Nch))+instanceStruct.instanceVar_temp)+instanceStruct.instancePar_DELVTO);
instanceStruct.d_instanceVar_VFB2_i_dX = (modelStruct.modelPar_TYPE*((instanceStruct.d_instanceVar_VFB2_t_dX+instanceStruct.d_instanceVar_dVfbch_dX)+instanceStruct.d_instanceVar_dVfb2Nch_dX)+instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_VFB2_i = ((modelStruct.modelPar_TYPE*((instanceStruct.instanceVar_VFB2_t+instanceStruct.instanceVar_dVfbch)+instanceStruct.instanceVar_dVfb2Nch))+instanceStruct.instanceVar_temp);
{
double value_log_0 = log(instanceStruct.instanceVar_rTn);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_rTn);
instanceStruct.d_instanceVar_lnrTn_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_rTn_dX);
instanceStruct.instanceVar_lnrTn = value_log_0;
}
{
double value_exp_0 = exp((instanceStruct.instanceVar_STBET_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_bet_dX = (value_exp_0*instanceStruct.d_instancePar_FACTUO_dX+deriv_exp_0_d0*((instanceStruct.instanceVar_STBET_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STBET_i_dX*instanceStruct.instanceVar_lnrTn))*instanceStruct.instancePar_FACTUO);
instanceStruct.instanceVar_tf_bet = (value_exp_0*instanceStruct.instancePar_FACTUO);
}
instanceStruct.d_instanceVar_BETN1_i_dX = (instanceStruct.instanceVar_BETN1_t*instanceStruct.d_instanceVar_tf_bet_dX+instanceStruct.d_instanceVar_BETN1_t_dX*instanceStruct.instanceVar_tf_bet);
instanceStruct.instanceVar_BETN1_i = (instanceStruct.instanceVar_BETN1_t*instanceStruct.instanceVar_tf_bet);
instanceStruct.d_instanceVar_BETN2_i_dX = (instanceStruct.instanceVar_BETN2_t*instanceStruct.d_instanceVar_tf_bet_dX+instanceStruct.d_instanceVar_BETN2_t_dX*instanceStruct.instanceVar_tf_bet);
instanceStruct.instanceVar_BETN2_i = (instanceStruct.instanceVar_BETN2_t*instanceStruct.instanceVar_tf_bet);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STMUE_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_mue_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STMUE_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STMUE_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_mue = value_exp_0;
}
instanceStruct.d_instanceVar_MUE_i_dX = (instanceStruct.instanceVar_MUE_t*instanceStruct.d_instanceVar_tf_mue_dX+instanceStruct.d_instanceVar_MUE_t_dX*instanceStruct.instanceVar_tf_mue);
instanceStruct.instanceVar_MUE_i = (instanceStruct.instanceVar_MUE_t*instanceStruct.instanceVar_tf_mue);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHEMU_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_themu_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STTHEMU_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STTHEMU_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_themu = value_exp_0;
}
instanceStruct.d_instanceVar_THEMU_i_dX = (instanceStruct.instanceVar_THEMU_t*instanceStruct.d_instanceVar_tf_themu_dX+instanceStruct.d_instanceVar_THEMU_t_dX*instanceStruct.instanceVar_tf_themu);
instanceStruct.instanceVar_THEMU_i = (instanceStruct.instanceVar_THEMU_t*instanceStruct.instanceVar_tf_themu);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STCS_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_cs_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STCS_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STCS_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_cs = value_exp_0;
}
instanceStruct.d_instanceVar_CS_i_dX = (instanceStruct.instanceVar_CS_t*instanceStruct.d_instanceVar_tf_cs_dX+instanceStruct.d_instanceVar_CS_t_dX*instanceStruct.instanceVar_tf_cs);
instanceStruct.instanceVar_CS_i = (instanceStruct.instanceVar_CS_t*instanceStruct.instanceVar_tf_cs);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHECS_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_thecs_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STTHECS_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STTHECS_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_thecs = value_exp_0;
}
instanceStruct.d_instanceVar_THECS_i_dX = (instanceStruct.instanceVar_THECS_t*instanceStruct.d_instanceVar_tf_thecs_dX+instanceStruct.d_instanceVar_THECS_t_dX*instanceStruct.instanceVar_tf_thecs);
instanceStruct.instanceVar_THECS_i = (instanceStruct.instanceVar_THECS_t*instanceStruct.instanceVar_tf_thecs);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STXCOR_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_xcor_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STXCOR_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STXCOR_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_xcor = value_exp_0;
}
instanceStruct.d_instanceVar_XCOR_i_dX = (instanceStruct.instanceVar_XCOR_t*instanceStruct.d_instanceVar_tf_xcor_dX+instanceStruct.d_instanceVar_XCOR_t_dX*instanceStruct.instanceVar_tf_xcor);
instanceStruct.instanceVar_XCOR_i = (instanceStruct.instanceVar_XCOR_t*instanceStruct.instanceVar_tf_xcor);
instanceStruct.d_instanceVar_temp_dX = ((instanceStruct.instanceVar_TSI_i*1.0e-8*instanceStruct.d_instanceVar_phit_dX-(1.0e-8*instanceStruct.instanceVar_phit)*instanceStruct.d_instanceVar_TSI_i_dX)/instanceStruct.instanceVar_TSI_i/instanceStruct.instanceVar_TSI_i);
instanceStruct.instanceVar_temp = ((1.0e-8*instanceStruct.instanceVar_phit)/instanceStruct.instanceVar_TSI_i);
instanceStruct.d_instanceVar_fmue_dX = (instanceStruct.instanceVar_temp*instanceStruct.d_instanceVar_MUE_i_dX+instanceStruct.d_instanceVar_temp_dX*instanceStruct.instanceVar_MUE_i);
instanceStruct.instanceVar_fmue = (instanceStruct.instanceVar_temp*instanceStruct.instanceVar_MUE_i);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STRS_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_ther_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STRS_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STRS_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_ther = value_exp_0;
}
instanceStruct.d_instanceVar_RS_i_dX = (instanceStruct.instanceVar_RS_t*instanceStruct.d_instanceVar_tf_ther_dX+instanceStruct.d_instanceVar_RS_t_dX*instanceStruct.instanceVar_tf_ther);
instanceStruct.instanceVar_RS_i = (instanceStruct.instanceVar_RS_t*instanceStruct.instanceVar_tf_ther);
instanceStruct.d_instanceVar_frs_dX = ((2.0*instanceStruct.instanceVar_RS_i)*instanceStruct.d_instanceVar_phit_dX+2.0*instanceStruct.d_instanceVar_RS_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_frs = ((2.0*instanceStruct.instanceVar_RS_i)*instanceStruct.instanceVar_phit);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHESAT_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_thesat_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STTHESAT_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STTHESAT_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_thesat = value_exp_0;
}
instanceStruct.d_instanceVar_THESAT_i_dX = ((instanceStruct.instanceVar_THESAT_t*instanceStruct.instanceVar_tf_thesat)*instanceStruct.d_instanceVar_tf_bet_dX+(instanceStruct.instanceVar_THESAT_t*instanceStruct.d_instanceVar_tf_thesat_dX+instanceStruct.d_instanceVar_THESAT_t_dX*instanceStruct.instanceVar_tf_thesat)*instanceStruct.instanceVar_tf_bet);
instanceStruct.instanceVar_THESAT_i = ((instanceStruct.instanceVar_THESAT_t*instanceStruct.instanceVar_tf_thesat)*instanceStruct.instanceVar_tf_bet);
instanceStruct.d_instanceVar_sat_phit_dX = (instanceStruct.instanceVar_THESAT_i*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_THESAT_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_sat_phit = (instanceStruct.instanceVar_THESAT_i*instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_alp1_phit_dX = (instanceStruct.instanceVar_ALP1_i*instanceStruct.d_instanceVar_inv_phit_dX+instanceStruct.d_instanceVar_ALP1_i_dX*instanceStruct.instanceVar_inv_phit);
instanceStruct.instanceVar_alp1_phit = (instanceStruct.instanceVar_ALP1_i*instanceStruct.instanceVar_inv_phit);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_STIG_i)*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_ig_dX = deriv_exp_0_d0*(((-instanceStruct.instanceVar_STIG_i)*instanceStruct.d_instanceVar_lnrTn_dX+(-instanceStruct.d_instanceVar_STIG_i_dX)*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_ig = value_exp_0;
}
instanceStruct.d_instanceVar_IGINV_i_dX = (instanceStruct.instanceVar_IGINV_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGINV_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGINV_i = (instanceStruct.instanceVar_IGINV_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVINV_i_dX = (instanceStruct.instanceVar_IGOVINV_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVINV_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVINV_i = (instanceStruct.instanceVar_IGOVINV_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVINVD_i_dX = (instanceStruct.instanceVar_IGOVINVD_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVINVD_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVINVD_i = (instanceStruct.instanceVar_IGOVINVD_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVACC_i_dX = (instanceStruct.instanceVar_IGOVACC_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVACC_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVACC_i = (instanceStruct.instanceVar_IGOVACC_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_IGOVACCD_i_dX = (instanceStruct.instanceVar_IGOVACCD_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_IGOVACCD_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_IGOVACCD_i = (instanceStruct.instanceVar_IGOVACCD_t*instanceStruct.instanceVar_tf_ig);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_STIGFN_i)*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_ig_dX = deriv_exp_0_d0*(((-instanceStruct.instanceVar_STIGFN_i)*instanceStruct.d_instanceVar_lnrTn_dX+(-instanceStruct.d_instanceVar_STIGFN_i_dX)*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_ig = value_exp_0;
}
instanceStruct.d_instanceVar_FNOVINV_i_dX = (instanceStruct.instanceVar_FNOVINV_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_FNOVINV_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_FNOVINV_i = (instanceStruct.instanceVar_FNOVINV_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_FNOVINVD_i_dX = (instanceStruct.instanceVar_FNOVINVD_t*instanceStruct.d_instanceVar_tf_ig_dX+instanceStruct.d_instanceVar_FNOVINVD_t_dX*instanceStruct.instanceVar_tf_ig);
instanceStruct.instanceVar_FNOVINVD_i = (instanceStruct.instanceVar_FNOVINVD_t*instanceStruct.instanceVar_tf_ig);
instanceStruct.d_instanceVar_alpha_b_dX = 0.5*instanceStruct.d_instanceVar_Eg_dX;
instanceStruct.instanceVar_alpha_b = (0.5*instanceStruct.instanceVar_Eg);
instanceStruct.d_instanceVar_Dch_dX = (instanceStruct.instanceVar_GCO_i*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_GCO_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_Dch = (instanceStruct.instanceVar_GCO_i*instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_Dov_dX = instanceStruct.d_instanceVar_GCO_i_dX*instanceStruct.instanceVar_phit0;
instanceStruct.instanceVar_Dov = (instanceStruct.instanceVar_GCO_i*instanceStruct.instanceVar_phit0);
instanceStruct.d_instanceVar_n_iginv_dX = (-(instanceStruct.instanceVar_NIGINV_i*instanceStruct.d_instanceVar_Eg_2phit_dX+instanceStruct.d_instanceVar_NIGINV_i_dX*instanceStruct.instanceVar_Eg_2phit)/(1.0+(instanceStruct.instanceVar_NIGINV_i*instanceStruct.instanceVar_Eg_2phit))/(1.0+(instanceStruct.instanceVar_NIGINV_i*instanceStruct.instanceVar_Eg_2phit)));
instanceStruct.instanceVar_n_iginv = (1.0/(1.0+(instanceStruct.instanceVar_NIGINV_i*instanceStruct.instanceVar_Eg_2phit)));
instanceStruct.d_instanceVar_temp_dX = instanceStruct.d_instanceVar_TOXP_i_dX*5.0e8;
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_TOXP_i*5.0e8);
{
double value_sqrt_0 = sqrt(((((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT)))*((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tempM_dX = 0.5*((instanceStruct.instanceVar_STBGIDL_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*instanceStruct.instanceVar_dT)+deriv_sqrt_0_d0*((((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT)))*(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*instanceStruct.instanceVar_dT)+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*instanceStruct.instanceVar_dT)*((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT))))));
instanceStruct.instanceVar_tempM = (0.5*((1.0+(instanceStruct.instanceVar_STBGIDL_i*instanceStruct.instanceVar_dT))+value_sqrt_0));
}
instanceStruct.d_instanceVar_BGIDL_i_dX = ((instanceStruct.instanceVar_BGIDL_t*instanceStruct.instanceVar_tempM)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_BGIDL_t*instanceStruct.d_instanceVar_tempM_dX+instanceStruct.d_instanceVar_BGIDL_t_dX*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_BGIDL_i = ((instanceStruct.instanceVar_BGIDL_t*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
{
double value_sqrt_0 = sqrt(((((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT)))*((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tempM_dX = 0.5*((instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*instanceStruct.instanceVar_dT)+deriv_sqrt_0_d0*((((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT)))*(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*instanceStruct.instanceVar_dT)+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.d_instanceVar_dT_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*instanceStruct.instanceVar_dT)*((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT))))));
instanceStruct.instanceVar_tempM = (0.5*((1.0+(instanceStruct.instanceVar_STBGIDLD_i*instanceStruct.instanceVar_dT))+value_sqrt_0));
}
instanceStruct.d_instanceVar_BGIDLD_i_dX = ((instanceStruct.instanceVar_BGIDLD_t*instanceStruct.instanceVar_tempM)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_BGIDLD_t*instanceStruct.d_instanceVar_tempM_dX+instanceStruct.d_instanceVar_BGIDLD_t_dX*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_BGIDLD_i = ((instanceStruct.instanceVar_BGIDLD_t*instanceStruct.instanceVar_tempM)*instanceStruct.instanceVar_temp);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_STA2_i)*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_A2_i_dX = (instanceStruct.instanceVar_A2_t*deriv_exp_0_d0*(((-instanceStruct.instanceVar_STA2_i)*instanceStruct.d_instanceVar_lnrTn_dX+(-instanceStruct.d_instanceVar_STA2_i_dX)*instanceStruct.instanceVar_lnrTn))+instanceStruct.d_instanceVar_A2_t_dX*value_exp_0);
instanceStruct.instanceVar_A2_i = (instanceStruct.instanceVar_A2_t*value_exp_0);
}
instanceStruct.d_instanceVar_area_phit_dX = (instanceStruct.instanceVar_AREAQ_i*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_AREAQ_i_dX*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_area_phit = (instanceStruct.instanceVar_AREAQ_i*instanceStruct.instanceVar_phit);
instanceStruct.d_instanceVar_inner_sd_dX = (((instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit)*(0.25*1.602176565E-19)*instanceStruct.d_instanceVar_NSDAC_i_dX-((0.25*1.602176565E-19)*instanceStruct.instanceVar_NSDAC_i)*(instanceStruct.instanceVar_epsch*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_epsch_dX*instanceStruct.instanceVar_phit))/(instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit)/(instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit));
instanceStruct.instanceVar_inner_sd = (((0.25*1.602176565E-19)*instanceStruct.instanceVar_NSDAC_i)/(instanceStruct.instanceVar_epsch*instanceStruct.instanceVar_phit));
{
double value_log_0 = log((instanceStruct.instanceVar_NSDAC_i/instanceStruct.instanceVar_neff));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_NSDAC_i/instanceStruct.instanceVar_neff));
instanceStruct.d_instanceVar_xsd_dX = deriv_log_0_d0*(((instanceStruct.instanceVar_neff*instanceStruct.d_instanceVar_NSDAC_i_dX-instanceStruct.instanceVar_NSDAC_i*instanceStruct.d_instanceVar_neff_dX)/instanceStruct.instanceVar_neff/instanceStruct.instanceVar_neff));
instanceStruct.instanceVar_xsd = value_log_0;
}
instanceStruct.d_instanceVar_fif_phit_dX = ((instanceStruct.instanceVar_FIF_i*1.25e-6)*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_FIF_i_dX*1.25e-6*instanceStruct.instanceVar_phit);
instanceStruct.instanceVar_fif_phit = ((instanceStruct.instanceVar_FIF_i*1.25e-6)*instanceStruct.instanceVar_phit);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STRTH_i*instanceStruct.instanceVar_lnrTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_tf_rth_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STRTH_i*instanceStruct.d_instanceVar_lnrTn_dX+instanceStruct.d_instanceVar_STRTH_i_dX*instanceStruct.instanceVar_lnrTn));
instanceStruct.instanceVar_tf_rth = value_exp_0;
}
instanceStruct.d_instanceVar_RTH_i_dX = (instanceStruct.instanceVar_RTH_t*instanceStruct.d_instanceVar_tf_rth_dX+instanceStruct.d_instanceVar_RTH_t_dX*instanceStruct.instanceVar_tf_rth);
instanceStruct.instanceVar_RTH_i = (instanceStruct.instanceVar_RTH_t*instanceStruct.instanceVar_tf_rth);
instanceStruct.d_instanceVar_nt_dX = instanceStruct.d_instanceVar_FNT_i_dX*4.0*1.3806488E-23*instanceStruct.instanceVar_TKC;
instanceStruct.instanceVar_nt = (((instanceStruct.instanceVar_FNT_i*4.0)*1.3806488E-23)*instanceStruct.instanceVar_TKC);
}
d_xd_dX = Vds*instanceStruct.d_instanceVar_inv_phit_dX;
xd = (Vds*instanceStruct.instanceVar_inv_phit);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xdsx_dX = (value_sqrt_0-0.1)*instanceStruct.d_instanceVar_inv_phit_dX;
xdsx = ((value_sqrt_0-0.1)*instanceStruct.instanceVar_inv_phit);
}
d_dxdsx_dX = 0.5*(d_xd_dX-d_xdsx_dX);
dxdsx = (0.5*(xd-xdsx));
d_xg10_dX = (((Vgs-instanceStruct.instanceVar_VFB1_i)*instanceStruct.d_instanceVar_inv_phit_dX+(-instanceStruct.d_instanceVar_VFB1_i_dX)*instanceStruct.instanceVar_inv_phit)-d_dxdsx_dX);
xg10 = (((Vgs-instanceStruct.instanceVar_VFB1_i)*instanceStruct.instanceVar_inv_phit)-dxdsx);
d_xg20_dX = ((((-Vsb)-instanceStruct.instanceVar_VFB2_i)*instanceStruct.d_instanceVar_inv_phit_dX+(-instanceStruct.d_instanceVar_VFB2_i_dX)*instanceStruct.instanceVar_inv_phit)-d_dxdsx_dX);
xg20 = ((((-Vsb)-instanceStruct.instanceVar_VFB2_i)*instanceStruct.instanceVar_inv_phit)-dxdsx);
xgs_ov = ((-Vgsu)*instanceStruct.instanceVar_inv_phit0);
xgd_ov = ((-Vgdu)*instanceStruct.instanceVar_inv_phit0);
instanceStruct.d_instanceVar_temp_dX = (modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_DVFBOV_i_dX*instanceStruct.instanceVar_inv_phit0+instanceStruct.d_instanceVar_Eg_2phit0_dX);
instanceStruct.instanceVar_temp = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_DVFBOV_i)*instanceStruct.instanceVar_inv_phit0)+instanceStruct.instanceVar_Eg_2phit0);
d_xgs_ovcv_dX = instanceStruct.d_instanceVar_temp_dX;
xgs_ovcv = (xgs_ov+instanceStruct.instanceVar_temp);
d_xgd_ovcv_dX = instanceStruct.d_instanceVar_temp_dX;
xgd_ovcv = (xgd_ov+instanceStruct.instanceVar_temp);
if ((modelStruct.modelPar_SWSUBDEP>0))
{
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = (modelStruct.modelPar_TYPE*instanceStruct.instanceVar_TYPESUB_i);
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_temp*d_xg10_dX+instanceStruct.d_instanceVar_temp_dX*xg10);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_temp*xg10);
instanceStruct.d_instanceVar_temp2_dX = (instanceStruct.instanceVar_temp*d_xg20_dX+instanceStruct.d_instanceVar_temp_dX*xg20);
instanceStruct.instanceVar_temp2 = (instanceStruct.instanceVar_temp*xg20);
d_SPSUB_xgb_dX = (instanceStruct.d_instanceVar_temp1_dX-instanceStruct.d_instanceVar_temp2_dX);
SPSUB_xgb = (instanceStruct.instanceVar_temp1-instanceStruct.instanceVar_temp2);
if ((fabs((-instanceStruct.instanceVar_xn_sub))<80.0))
{
{
double value_exp_0 = exp((-instanceStruct.instanceVar_xn_sub));
double  deriv_exp_0_d0 = value_exp_0;
d_SPSUB_delta_dX = deriv_exp_0_d0*((-instanceStruct.d_instanceVar_xn_sub_dX));
SPSUB_delta = value_exp_0;
}
}
else
{
if (((-instanceStruct.instanceVar_xn_sub)<(-80.0)))
{
d_SPSUB_delta_dX = (-1.80485e-35*(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*((0.5*((-(-instanceStruct.instanceVar_xn_sub))-80.0))*(-(-instanceStruct.d_instanceVar_xn_sub_dX))*0.3333333333333+0.5*(-(-instanceStruct.d_instanceVar_xn_sub_dX))*(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*0.3333333333333)))+(-(-instanceStruct.d_instanceVar_xn_sub_dX))*(1.0+((0.5*((-(-instanceStruct.instanceVar_xn_sub))-80.0))*(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*0.3333333333333)))))/(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*(1.0+((0.5*((-(-instanceStruct.instanceVar_xn_sub))-80.0))*(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*0.3333333333333))))))/(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*(1.0+((0.5*((-(-instanceStruct.instanceVar_xn_sub))-80.0))*(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*0.3333333333333)))))));
SPSUB_delta = (1.80485e-35/(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*(1.0+((0.5*((-(-instanceStruct.instanceVar_xn_sub))-80.0))*(1.0+(((-(-instanceStruct.instanceVar_xn_sub))-80.0)*0.3333333333333)))))));
}
else
{
d_SPSUB_delta_dX = 5.54062e34*(((-instanceStruct.instanceVar_xn_sub)-80.0)*((0.5*((-instanceStruct.instanceVar_xn_sub)-80.0))*(-instanceStruct.d_instanceVar_xn_sub_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_xn_sub_dX)*(1.0+(((-instanceStruct.instanceVar_xn_sub)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_xn_sub_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_xn_sub)-80.0))*(1.0+(((-instanceStruct.instanceVar_xn_sub)-80.0)*0.3333333333333)))));
SPSUB_delta = (5.54062e34*(1.0+(((-instanceStruct.instanceVar_xn_sub)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_xn_sub)-80.0))*(1.0+(((-instanceStruct.instanceVar_xn_sub)-80.0)*0.3333333333333)))))));
}
}
if ((fabs(SPSUB_xgb)<=instanceStruct.instanceVar_margin_sub))
{
d_SPSUB_temp1_dX = ((instanceStruct.instanceVar_inv_xisub*instanceStruct.d_instanceVar_inv_xisub_dX+instanceStruct.d_instanceVar_inv_xisub_dX*instanceStruct.instanceVar_inv_xisub)*0.1666666666667/1.4142135623731);
SPSUB_temp1 = (((instanceStruct.instanceVar_inv_xisub*instanceStruct.instanceVar_inv_xisub)*0.1666666666667)/1.4142135623731);
instanceStruct.d_instanceVar_temp3_dX = ((SPSUB_xgb*instanceStruct.instanceVar_inv_xisub)*(((SPSUB_xgb*(1.0-SPSUB_delta))*instanceStruct.instanceVar_Gfsub)*d_SPSUB_temp1_dX+((SPSUB_xgb*(1.0-SPSUB_delta))*instanceStruct.d_instanceVar_Gfsub_dX+(SPSUB_xgb*(-d_SPSUB_delta_dX)+d_SPSUB_xgb_dX*(1.0-SPSUB_delta))*instanceStruct.instanceVar_Gfsub)*SPSUB_temp1)+(SPSUB_xgb*instanceStruct.d_instanceVar_inv_xisub_dX+d_SPSUB_xgb_dX*instanceStruct.instanceVar_inv_xisub)*(1.0+(((SPSUB_xgb*(1.0-SPSUB_delta))*instanceStruct.instanceVar_Gfsub)*SPSUB_temp1)));
instanceStruct.instanceVar_temp3 = ((SPSUB_xgb*instanceStruct.instanceVar_inv_xisub)*(1.0+(((SPSUB_xgb*(1.0-SPSUB_delta))*instanceStruct.instanceVar_Gfsub)*SPSUB_temp1)));
}
else
{
if ((SPSUB_xgb<(-instanceStruct.instanceVar_margin_sub)))
{
d_SPSUB_yg_dX = (-d_SPSUB_xgb_dX);
SPSUB_yg = (-SPSUB_xgb);
d_SPSUB_ysub_dX = 1.25*(SPSUB_yg*instanceStruct.d_instanceVar_inv_xisub_dX+d_SPSUB_yg_dX*instanceStruct.instanceVar_inv_xisub);
SPSUB_ysub = (1.25*(SPSUB_yg*instanceStruct.instanceVar_inv_xisub));
{
double value_sqrt_0 = sqrt((((SPSUB_ysub-6.0)*(SPSUB_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SPSUB_eta_dX = 0.5*(d_SPSUB_ysub_dX-deriv_sqrt_0_d0*(((SPSUB_ysub-6.0)*d_SPSUB_ysub_dX+d_SPSUB_ysub_dX*(SPSUB_ysub-6.0))));
SPSUB_eta = (0.5*((SPSUB_ysub+10.0)-value_sqrt_0));
}
d_SPSUB_temp_dX = (d_SPSUB_yg_dX-d_SPSUB_eta_dX);
SPSUB_temp = (SPSUB_yg-SPSUB_eta);
d_SPSUB_a_dX = ((SPSUB_temp*d_SPSUB_temp_dX+d_SPSUB_temp_dX*SPSUB_temp)+(instanceStruct.instanceVar_Gfsub2*d_SPSUB_eta_dX+instanceStruct.d_instanceVar_Gfsub2_dX*(SPSUB_eta+1.0)));
SPSUB_a = ((SPSUB_temp*SPSUB_temp)+(instanceStruct.instanceVar_Gfsub2*(SPSUB_eta+1.0)));
d_SPSUB_c_dX = (2.0*d_SPSUB_temp_dX-instanceStruct.d_instanceVar_Gfsub2_dX);
SPSUB_c = ((2.0*SPSUB_temp)-instanceStruct.instanceVar_Gfsub2);
{
double value_log_0 = log((SPSUB_a*instanceStruct.instanceVar_inv_Gfsub2));
double  deriv_log_0_d0 = (1.0/(SPSUB_a*instanceStruct.instanceVar_inv_Gfsub2));
d_SPSUB_tau_dX = ((-d_SPSUB_eta_dX)+deriv_log_0_d0*((SPSUB_a*instanceStruct.d_instanceVar_inv_Gfsub2_dX+d_SPSUB_a_dX*instanceStruct.instanceVar_inv_Gfsub2)));
SPSUB_tau = ((-SPSUB_eta)+value_log_0);
}
d_nu_dX = (d_SPSUB_a_dX+d_SPSUB_c_dX);
nu = (SPSUB_a+SPSUB_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dX+0.5*d_SPSUB_c_dX*SPSUB_c)-d_SPSUB_a_dX)+d_SPSUB_tau_dX*(((0.5*SPSUB_c)*SPSUB_c)-SPSUB_a)));
mutau = ((nu*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*SPSUB_c)-SPSUB_a)));
d_SPSUB_y0_dX = (d_SPSUB_eta_dX+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))*((SPSUB_a*nu)*d_SPSUB_tau_dX+(SPSUB_a*d_nu_dX+d_SPSUB_a_dX*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dX+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dX+d_SPSUB_c_dX*SPSUB_c)*0.3333333333333-d_SPSUB_a_dX)+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dX+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dX+((nu/mutau)*d_SPSUB_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))));
SPSUB_y0 = (SPSUB_eta+(((SPSUB_a*nu)*SPSUB_tau)/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-SPSUB_a)))));
if ((SPSUB_y0<80.0))
{
{
double value_exp_0 = exp(SPSUB_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SPSUB_delta0_dX = deriv_exp_0_d0*(d_SPSUB_y0_dX);
SPSUB_delta0 = value_exp_0;
}
}
else
{
d_SPSUB_delta0_dX = 5.54062e34*((SPSUB_y0-80.0)*((0.5*(SPSUB_y0-80.0))*d_SPSUB_y0_dX*0.3333333333333+0.5*d_SPSUB_y0_dX*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))+d_SPSUB_y0_dX*(1.0+((0.5*(SPSUB_y0-80.0))*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))));
SPSUB_delta0 = (5.54062e34*(1.0+((SPSUB_y0-80.0)*(1.0+((0.5*(SPSUB_y0-80.0))*(1.0+((SPSUB_y0-80.0)*0.3333333333333)))))));
}
d_SPSUB_delta1_dX = (-d_SPSUB_delta0_dX/SPSUB_delta0/SPSUB_delta0);
SPSUB_delta1 = (1.0/SPSUB_delta0);
d_SPSUB_temp_dX = (-(SPSUB_y0*d_SPSUB_y0_dX+d_SPSUB_y0_dX*SPSUB_y0)/(2.0+(SPSUB_y0*SPSUB_y0))/(2.0+(SPSUB_y0*SPSUB_y0)));
SPSUB_temp = (1.0/(2.0+(SPSUB_y0*SPSUB_y0)));
d_SPSUB_xi0_dX = ((SPSUB_y0*SPSUB_y0)*d_SPSUB_temp_dX+(SPSUB_y0*d_SPSUB_y0_dX+d_SPSUB_y0_dX*SPSUB_y0)*SPSUB_temp);
SPSUB_xi0 = ((SPSUB_y0*SPSUB_y0)*SPSUB_temp);
d_SPSUB_xi1_dX = 4.0*((SPSUB_y0*SPSUB_temp)*d_SPSUB_temp_dX+(SPSUB_y0*d_SPSUB_temp_dX+d_SPSUB_y0_dX*SPSUB_temp)*SPSUB_temp);
SPSUB_xi1 = (4.0*((SPSUB_y0*SPSUB_temp)*SPSUB_temp));
d_SPSUB_xi2_dX = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dX+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dX+(8.0*d_SPSUB_temp_dX-12.0*d_SPSUB_xi0_dX)*SPSUB_temp)*SPSUB_temp);
SPSUB_xi2 = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*SPSUB_temp);
d_SPSUB_temp_dX = (d_SPSUB_yg_dX-d_SPSUB_y0_dX);
SPSUB_temp = (SPSUB_yg-SPSUB_y0);
d_SPSUB_temp1_dX = (SPSUB_delta*d_SPSUB_delta1_dX+d_SPSUB_delta_dX*SPSUB_delta1);
SPSUB_temp1 = (SPSUB_delta*SPSUB_delta1);
d_SPSUB_pC_dX = (2.0*d_SPSUB_temp_dX+(instanceStruct.instanceVar_Gfsub2*((d_SPSUB_delta0_dX-d_SPSUB_temp1_dX)+(SPSUB_delta*(-d_SPSUB_xi1_dX)+d_SPSUB_delta_dX*(1.0-SPSUB_xi1)))+instanceStruct.d_instanceVar_Gfsub2_dX*(((SPSUB_delta0-1.0)-SPSUB_temp1)+(SPSUB_delta*(1.0-SPSUB_xi1)))));
SPSUB_pC = ((2.0*SPSUB_temp)+(instanceStruct.instanceVar_Gfsub2*(((SPSUB_delta0-1.0)-SPSUB_temp1)+(SPSUB_delta*(1.0-SPSUB_xi1)))));
d_SPSUB_qC_dX = ((SPSUB_temp*d_SPSUB_temp_dX+d_SPSUB_temp_dX*SPSUB_temp)-(instanceStruct.instanceVar_Gfsub2*(((d_SPSUB_delta0_dX-d_SPSUB_y0_dX)+d_SPSUB_temp1_dX)+(SPSUB_delta*(d_SPSUB_y0_dX-d_SPSUB_xi0_dX)+d_SPSUB_delta_dX*((SPSUB_y0-1.0)-SPSUB_xi0)))+instanceStruct.d_instanceVar_Gfsub2_dX*((((SPSUB_delta0-SPSUB_y0)-1.0)+SPSUB_temp1)+(SPSUB_delta*((SPSUB_y0-1.0)-SPSUB_xi0)))));
SPSUB_qC = ((SPSUB_temp*SPSUB_temp)-(instanceStruct.instanceVar_Gfsub2*((((SPSUB_delta0-SPSUB_y0)-1.0)+SPSUB_temp1)+(SPSUB_delta*((SPSUB_y0-1.0)-SPSUB_xi0)))));
d_SPSUB_temp_dX = (-(instanceStruct.instanceVar_Gfsub2*((d_SPSUB_delta0_dX+d_SPSUB_temp1_dX)-(SPSUB_delta*d_SPSUB_xi2_dX+d_SPSUB_delta_dX*SPSUB_xi2))+instanceStruct.d_instanceVar_Gfsub2_dX*((SPSUB_delta0+SPSUB_temp1)-(SPSUB_delta*SPSUB_xi2))));
SPSUB_temp = (2.0-(instanceStruct.instanceVar_Gfsub2*((SPSUB_delta0+SPSUB_temp1)-(SPSUB_delta*SPSUB_xi2))));
d_SPSUB_temp_dX = ((SPSUB_pC*d_SPSUB_pC_dX+d_SPSUB_pC_dX*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dX+d_SPSUB_qC_dX*SPSUB_temp));
SPSUB_temp = ((SPSUB_pC*SPSUB_pC)-(2.0*(SPSUB_qC*SPSUB_temp)));
{
double value_sqrt_0 = sqrt(SPSUB_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp3_dX = ((-d_SPSUB_y0_dX)-2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dX-SPSUB_qC*(d_SPSUB_pC_dX+deriv_sqrt_0_d0*(d_SPSUB_temp_dX)))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
instanceStruct.instanceVar_temp3 = ((-SPSUB_y0)-(2.0*(SPSUB_qC/(SPSUB_pC+value_sqrt_0))));
}
}
else
{
d_SPSUB_xg1_dX = (-instanceStruct.d_instanceVar_Gfsub_dX*0.732464877560822/(1.25+(instanceStruct.instanceVar_Gfsub*0.732464877560822))/(1.25+(instanceStruct.instanceVar_Gfsub*0.732464877560822)));
SPSUB_xg1 = (1.0/(1.25+(instanceStruct.instanceVar_Gfsub*0.732464877560822)));
d_SPSUB_A_fac_dX = ((((1.25*instanceStruct.instanceVar_xisub)*SPSUB_xg1)-1.0)*d_SPSUB_xg1_dX+((1.25*instanceStruct.instanceVar_xisub)*d_SPSUB_xg1_dX+1.25*instanceStruct.d_instanceVar_xisub_dX*SPSUB_xg1)*SPSUB_xg1);
SPSUB_A_fac = ((((1.25*instanceStruct.instanceVar_xisub)*SPSUB_xg1)-1.0)*SPSUB_xg1);
d_SPSUB_xbar_dX = ((SPSUB_xgb*instanceStruct.instanceVar_inv_xisub)*(SPSUB_A_fac*d_SPSUB_xgb_dX+d_SPSUB_A_fac_dX*SPSUB_xgb)+(SPSUB_xgb*instanceStruct.d_instanceVar_inv_xisub_dX+d_SPSUB_xgb_dX*instanceStruct.instanceVar_inv_xisub)*(1.0+(SPSUB_A_fac*SPSUB_xgb)));
SPSUB_xbar = ((SPSUB_xgb*instanceStruct.instanceVar_inv_xisub)*(1.0+(SPSUB_A_fac*SPSUB_xgb)));
if (((-SPSUB_xbar)>(-80.0)))
{
{
double value_exp_0 = exp((-SPSUB_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SPSUB_temp_dX = deriv_exp_0_d0*((-d_SPSUB_xbar_dX));
SPSUB_temp = value_exp_0;
}
}
else
{
d_SPSUB_temp_dX = (-1.80485e-35*(((-(-SPSUB_xbar))-80.0)*((0.5*((-(-SPSUB_xbar))-80.0))*(-(-d_SPSUB_xbar_dX))*0.3333333333333+0.5*(-(-d_SPSUB_xbar_dX))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))+(-(-d_SPSUB_xbar_dX))*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))));
SPSUB_temp = (1.80485e-35/(1.0+(((-(-SPSUB_xbar))-80.0)*(1.0+((0.5*((-(-SPSUB_xbar))-80.0))*(1.0+(((-(-SPSUB_xbar))-80.0)*0.3333333333333)))))));
}
d_SPSUB_w_dX = (-d_SPSUB_temp_dX);
SPSUB_w = (1.0-SPSUB_temp);
{
double value_sqrt_0 = sqrt(((SPSUB_xgb+(instanceStruct.instanceVar_Gfsub2*0.25))-SPSUB_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SPSUB_x1_dX = ((d_SPSUB_xgb_dX+instanceStruct.d_instanceVar_Gfsub2_dX*0.5)-(instanceStruct.instanceVar_Gfsub*deriv_sqrt_0_d0*(((d_SPSUB_xgb_dX+instanceStruct.d_instanceVar_Gfsub2_dX*0.25)-d_SPSUB_w_dX))+instanceStruct.d_instanceVar_Gfsub_dX*value_sqrt_0));
SPSUB_x1 = ((SPSUB_xgb+(instanceStruct.instanceVar_Gfsub2*0.5))-(instanceStruct.instanceVar_Gfsub*value_sqrt_0));
}
d_SPSUB_bx_dX = instanceStruct.d_instanceVar_xn_sub_dX;
SPSUB_bx = (instanceStruct.instanceVar_xn_sub+3.0);
{
double value_sqrt_0 = sqrt((((SPSUB_x1-SPSUB_bx)*(SPSUB_x1-SPSUB_bx))+5.0));
double value_sqrt_1 = sqrt(((SPSUB_bx*SPSUB_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_SPSUB_eta_dX = (0.5*((d_SPSUB_x1_dX+d_SPSUB_bx_dX)-deriv_sqrt_0_d0*(((SPSUB_x1-SPSUB_bx)*(d_SPSUB_x1_dX-d_SPSUB_bx_dX)+(d_SPSUB_x1_dX-d_SPSUB_bx_dX)*(SPSUB_x1-SPSUB_bx))))-0.5*(d_SPSUB_bx_dX-deriv_sqrt_1_d0*((SPSUB_bx*d_SPSUB_bx_dX+d_SPSUB_bx_dX*SPSUB_bx))));
SPSUB_eta = ((0.5*((SPSUB_x1+SPSUB_bx)-value_sqrt_0))-(0.5*(SPSUB_bx-value_sqrt_1)));
}
d_SPSUB_temp_dX = (d_SPSUB_xgb_dX-d_SPSUB_eta_dX);
SPSUB_temp = (SPSUB_xgb-SPSUB_eta);
{
double value_exp_0 = exp((-SPSUB_eta));
double  deriv_exp_0_d0 = value_exp_0;
d_SPSUB_temp1_dX = deriv_exp_0_d0*((-d_SPSUB_eta_dX));
SPSUB_temp1 = value_exp_0;
}
d_SPSUB_temp2_dX = (-(SPSUB_eta*d_SPSUB_eta_dX+d_SPSUB_eta_dX*SPSUB_eta)/(2.0+(SPSUB_eta*SPSUB_eta))/(2.0+(SPSUB_eta*SPSUB_eta)));
SPSUB_temp2 = (1.0/(2.0+(SPSUB_eta*SPSUB_eta)));
d_SPSUB_xi0_dX = ((SPSUB_eta*SPSUB_eta)*d_SPSUB_temp2_dX+(SPSUB_eta*d_SPSUB_eta_dX+d_SPSUB_eta_dX*SPSUB_eta)*SPSUB_temp2);
SPSUB_xi0 = ((SPSUB_eta*SPSUB_eta)*SPSUB_temp2);
d_SPSUB_xi1_dX = 4.0*((SPSUB_eta*SPSUB_temp2)*d_SPSUB_temp2_dX+(SPSUB_eta*d_SPSUB_temp2_dX+d_SPSUB_eta_dX*SPSUB_temp2)*SPSUB_temp2);
SPSUB_xi1 = (4.0*((SPSUB_eta*SPSUB_temp2)*SPSUB_temp2));
d_SPSUB_xi2_dX = ((((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*SPSUB_temp2)*d_SPSUB_temp2_dX+(((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*d_SPSUB_temp2_dX+(8.0*d_SPSUB_temp2_dX-12.0*d_SPSUB_xi0_dX)*SPSUB_temp2)*SPSUB_temp2);
SPSUB_xi2 = ((((8.0*SPSUB_temp2)-(12.0*SPSUB_xi0))*SPSUB_temp2)*SPSUB_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SPSUB_temp*SPSUB_temp)-(instanceStruct.instanceVar_Gfsub2*(((SPSUB_temp1+SPSUB_eta)-1.0)-(SPSUB_delta*((SPSUB_eta+1.0)+SPSUB_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SPSUB_temp*SPSUB_temp)-(instanceStruct.instanceVar_Gfsub2*(((SPSUB_temp1+SPSUB_eta)-1.0)-(SPSUB_delta*((SPSUB_eta+1.0)+SPSUB_xi0))))))?0.0:1.0);
d_SPSUB_a_dX = (deriv_max_0_d1*(((SPSUB_temp*d_SPSUB_temp_dX+d_SPSUB_temp_dX*SPSUB_temp)-(instanceStruct.instanceVar_Gfsub2*((d_SPSUB_temp1_dX+d_SPSUB_eta_dX)-(SPSUB_delta*(d_SPSUB_eta_dX+d_SPSUB_xi0_dX)+d_SPSUB_delta_dX*((SPSUB_eta+1.0)+SPSUB_xi0)))+instanceStruct.d_instanceVar_Gfsub2_dX*(((SPSUB_temp1+SPSUB_eta)-1.0)-(SPSUB_delta*((SPSUB_eta+1.0)+SPSUB_xi0)))))));
SPSUB_a = value_max_0;
}
d_SPSUB_b_dX = (-0.5*(instanceStruct.instanceVar_Gfsub2*(d_SPSUB_temp1_dX-(SPSUB_delta*d_SPSUB_xi2_dX+d_SPSUB_delta_dX*SPSUB_xi2))+instanceStruct.d_instanceVar_Gfsub2_dX*(SPSUB_temp1-(SPSUB_delta*SPSUB_xi2))));
SPSUB_b = (1.0-(0.5*(instanceStruct.instanceVar_Gfsub2*(SPSUB_temp1-(SPSUB_delta*SPSUB_xi2)))));
d_SPSUB_c_dX = (2.0*d_SPSUB_temp_dX+(instanceStruct.instanceVar_Gfsub2*((-d_SPSUB_temp1_dX)-(SPSUB_delta*d_SPSUB_xi1_dX+d_SPSUB_delta_dX*(1.0+SPSUB_xi1)))+instanceStruct.d_instanceVar_Gfsub2_dX*((1.0-SPSUB_temp1)-(SPSUB_delta*(1.0+SPSUB_xi1)))));
SPSUB_c = ((2.0*SPSUB_temp)+(instanceStruct.instanceVar_Gfsub2*((1.0-SPSUB_temp1)-(SPSUB_delta*(1.0+SPSUB_xi1)))));
{
double value_log_0 = log((SPSUB_a/instanceStruct.instanceVar_Gfsub2));
double  deriv_log_0_d0 = (1.0/(SPSUB_a/instanceStruct.instanceVar_Gfsub2));
d_SPSUB_tau_dX = ((instanceStruct.d_instanceVar_xn_sub_dX-d_SPSUB_eta_dX)+deriv_log_0_d0*(((instanceStruct.instanceVar_Gfsub2*d_SPSUB_a_dX-SPSUB_a*instanceStruct.d_instanceVar_Gfsub2_dX)/instanceStruct.instanceVar_Gfsub2/instanceStruct.instanceVar_Gfsub2)));
SPSUB_tau = ((instanceStruct.instanceVar_xn_sub-SPSUB_eta)+value_log_0);
}
d_nu_dX = (d_SPSUB_a_dX+d_SPSUB_c_dX);
nu = (SPSUB_a+SPSUB_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*d_SPSUB_c_dX+0.5*d_SPSUB_c_dX*SPSUB_c)-(SPSUB_a*d_SPSUB_b_dX+d_SPSUB_a_dX*SPSUB_b))+d_SPSUB_tau_dX*(((0.5*SPSUB_c)*SPSUB_c)-(SPSUB_a*SPSUB_b))));
mutau = ((nu*nu)+(SPSUB_tau*(((0.5*SPSUB_c)*SPSUB_c)-(SPSUB_a*SPSUB_b))));
d_SPSUB_x0_dX = (d_SPSUB_eta_dX+(((mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))*((SPSUB_a*nu)*d_SPSUB_tau_dX+(SPSUB_a*d_nu_dX+d_SPSUB_a_dX*nu)*SPSUB_tau)-((SPSUB_a*nu)*SPSUB_tau)*(d_mutau_dX+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*((SPSUB_c*d_SPSUB_c_dX+d_SPSUB_c_dX*SPSUB_c)*0.3333333333333-(SPSUB_a*d_SPSUB_b_dX+d_SPSUB_a_dX*SPSUB_b))+((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*d_SPSUB_c_dX+(((nu/mutau)*SPSUB_tau)*d_SPSUB_tau_dX+((nu/mutau)*d_SPSUB_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b)))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))));
SPSUB_x0 = (SPSUB_eta+(((SPSUB_a*nu)*SPSUB_tau)/(mutau+(((((nu/mutau)*SPSUB_tau)*SPSUB_tau)*SPSUB_c)*(((SPSUB_c*SPSUB_c)*0.3333333333333)-(SPSUB_a*SPSUB_b))))));
if ((SPSUB_x0<80.0))
{
{
double value_exp_0 = exp(SPSUB_x0);
double  deriv_exp_0_d0 = value_exp_0;
d_SPSUB_delta0_dX = deriv_exp_0_d0*(d_SPSUB_x0_dX);
SPSUB_delta0 = value_exp_0;
}
d_SPSUB_delta1_dX = (-d_SPSUB_delta0_dX/SPSUB_delta0/SPSUB_delta0);
SPSUB_delta1 = (1.0/SPSUB_delta0);
d_SPSUB_delta0_dX = (SPSUB_delta*d_SPSUB_delta0_dX+d_SPSUB_delta_dX*SPSUB_delta0);
SPSUB_delta0 = (SPSUB_delta*SPSUB_delta0);
}
else
{
if ((SPSUB_x0>(instanceStruct.instanceVar_xn_sub-80.0)))
{
{
double value_exp_0 = exp((SPSUB_x0-instanceStruct.instanceVar_xn_sub));
double  deriv_exp_0_d0 = value_exp_0;
d_SPSUB_delta0_dX = deriv_exp_0_d0*((d_SPSUB_x0_dX-instanceStruct.d_instanceVar_xn_sub_dX));
SPSUB_delta0 = value_exp_0;
}
d_SPSUB_delta1_dX = ((SPSUB_delta0*d_SPSUB_delta_dX-SPSUB_delta*d_SPSUB_delta0_dX)/SPSUB_delta0/SPSUB_delta0);
SPSUB_delta1 = (SPSUB_delta/SPSUB_delta0);
}
else
{
d_SPSUB_delta0_dX = (-1.80485e-35*(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*((0.5*((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0))*(instanceStruct.d_instanceVar_xn_sub_dX-d_SPSUB_x0_dX)*0.3333333333333+0.5*(instanceStruct.d_instanceVar_xn_sub_dX-d_SPSUB_x0_dX)*(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))+(instanceStruct.d_instanceVar_xn_sub_dX-d_SPSUB_x0_dX)*(1.0+((0.5*((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0))*(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))/(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0))*(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*0.3333333333333))))))/(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0))*(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))));
SPSUB_delta0 = (1.80485e-35/(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*(1.0+((0.5*((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0))*(1.0+(((instanceStruct.instanceVar_xn_sub-SPSUB_x0)-80.0)*0.3333333333333)))))));
d_SPSUB_delta1_dX = (-1.80485e-35*((SPSUB_x0-80.0)*((0.5*(SPSUB_x0-80.0))*d_SPSUB_x0_dX*0.3333333333333+0.5*d_SPSUB_x0_dX*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))+d_SPSUB_x0_dX*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333))))))/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))));
SPSUB_delta1 = (1.80485e-35/(1.0+((SPSUB_x0-80.0)*(1.0+((0.5*(SPSUB_x0-80.0))*(1.0+((SPSUB_x0-80.0)*0.3333333333333)))))));
}
}
d_SPSUB_temp_dX = (-(SPSUB_x0*d_SPSUB_x0_dX+d_SPSUB_x0_dX*SPSUB_x0)/(2.0+(SPSUB_x0*SPSUB_x0))/(2.0+(SPSUB_x0*SPSUB_x0)));
SPSUB_temp = (1.0/(2.0+(SPSUB_x0*SPSUB_x0)));
d_SPSUB_xi0_dX = ((SPSUB_x0*SPSUB_x0)*d_SPSUB_temp_dX+(SPSUB_x0*d_SPSUB_x0_dX+d_SPSUB_x0_dX*SPSUB_x0)*SPSUB_temp);
SPSUB_xi0 = ((SPSUB_x0*SPSUB_x0)*SPSUB_temp);
d_SPSUB_xi1_dX = 4.0*((SPSUB_x0*SPSUB_temp)*d_SPSUB_temp_dX+(SPSUB_x0*d_SPSUB_temp_dX+d_SPSUB_x0_dX*SPSUB_temp)*SPSUB_temp);
SPSUB_xi1 = (4.0*((SPSUB_x0*SPSUB_temp)*SPSUB_temp));
d_SPSUB_xi2_dX = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*d_SPSUB_temp_dX+(((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*d_SPSUB_temp_dX+(8.0*d_SPSUB_temp_dX-12.0*d_SPSUB_xi0_dX)*SPSUB_temp)*SPSUB_temp);
SPSUB_xi2 = ((((8.0*SPSUB_temp)-(12.0*SPSUB_xi0))*SPSUB_temp)*SPSUB_temp);
d_SPSUB_temp_dX = (d_SPSUB_xgb_dX-d_SPSUB_x0_dX);
SPSUB_temp = (SPSUB_xgb-SPSUB_x0);
d_SPSUB_pC_dX = (2.0*d_SPSUB_temp_dX+(instanceStruct.instanceVar_Gfsub2*(((-d_SPSUB_delta1_dX)+d_SPSUB_delta0_dX)-(SPSUB_delta*d_SPSUB_xi1_dX+d_SPSUB_delta_dX*(1.0+SPSUB_xi1)))+instanceStruct.d_instanceVar_Gfsub2_dX*(((1.0-SPSUB_delta1)+SPSUB_delta0)-(SPSUB_delta*(1.0+SPSUB_xi1)))));
SPSUB_pC = ((2.0*SPSUB_temp)+(instanceStruct.instanceVar_Gfsub2*(((1.0-SPSUB_delta1)+SPSUB_delta0)-(SPSUB_delta*(1.0+SPSUB_xi1)))));
d_SPSUB_qC_dX = ((SPSUB_temp*d_SPSUB_temp_dX+d_SPSUB_temp_dX*SPSUB_temp)-(instanceStruct.instanceVar_Gfsub2*(((d_SPSUB_delta1_dX+d_SPSUB_x0_dX)+d_SPSUB_delta0_dX)-(SPSUB_delta*(d_SPSUB_x0_dX+d_SPSUB_xi0_dX)+d_SPSUB_delta_dX*((SPSUB_x0+1.0)+SPSUB_xi0)))+instanceStruct.d_instanceVar_Gfsub2_dX*((((SPSUB_delta1+SPSUB_x0)-1.0)+SPSUB_delta0)-(SPSUB_delta*((SPSUB_x0+1.0)+SPSUB_xi0)))));
SPSUB_qC = ((SPSUB_temp*SPSUB_temp)-(instanceStruct.instanceVar_Gfsub2*((((SPSUB_delta1+SPSUB_x0)-1.0)+SPSUB_delta0)-(SPSUB_delta*((SPSUB_x0+1.0)+SPSUB_xi0)))));
d_SPSUB_temp_dX = (-(instanceStruct.instanceVar_Gfsub2*((d_SPSUB_delta1_dX+d_SPSUB_delta0_dX)-(SPSUB_delta*d_SPSUB_xi2_dX+d_SPSUB_delta_dX*SPSUB_xi2))+instanceStruct.d_instanceVar_Gfsub2_dX*((SPSUB_delta1+SPSUB_delta0)-(SPSUB_delta*SPSUB_xi2))));
SPSUB_temp = (2.0-(instanceStruct.instanceVar_Gfsub2*((SPSUB_delta1+SPSUB_delta0)-(SPSUB_delta*SPSUB_xi2))));
d_SPSUB_temp_dX = ((SPSUB_pC*d_SPSUB_pC_dX+d_SPSUB_pC_dX*SPSUB_pC)-2.0*(SPSUB_qC*d_SPSUB_temp_dX+d_SPSUB_qC_dX*SPSUB_temp));
SPSUB_temp = ((SPSUB_pC*SPSUB_pC)-(2.0*(SPSUB_qC*SPSUB_temp)));
{
double value_sqrt_0 = sqrt(SPSUB_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp3_dX = (d_SPSUB_x0_dX+2.0*(((SPSUB_pC+value_sqrt_0)*d_SPSUB_qC_dX-SPSUB_qC*(d_SPSUB_pC_dX+deriv_sqrt_0_d0*(d_SPSUB_temp_dX)))/(SPSUB_pC+value_sqrt_0)/(SPSUB_pC+value_sqrt_0)));
instanceStruct.instanceVar_temp3 = (SPSUB_x0+(2.0*(SPSUB_qC/(SPSUB_pC+value_sqrt_0))));
}
}
}
d_xg2eff_dX = (instanceStruct.instanceVar_temp*(instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_temp2_dX)+instanceStruct.d_instanceVar_temp_dX*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp2));
xg2eff = (instanceStruct.instanceVar_temp*(instanceStruct.instanceVar_temp3+instanceStruct.instanceVar_temp2));
}
else
{
d_xg2eff_dX = d_xg20_dX;
xg2eff = xg20;
}
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_keq_1D*(d_xg10_dX-d_xg2eff_dX)+instanceStruct.d_instanceVar_keq_1D_dX*(xg10-xg2eff));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_keq_1D*(xg10-xg2eff));
if ((modelStruct.modelPar_QMC>0.0))
{
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_temp-15.0)*(instanceStruct.instanceVar_temp-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_e1_dX = 0.5*(instanceStruct.d_instanceVar_temp_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_temp-15.0)*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_temp_dX*(instanceStruct.instanceVar_temp-15.0))));
e1 = (0.5*((instanceStruct.instanceVar_temp+15.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((-instanceStruct.instanceVar_temp)-15.0)*((-instanceStruct.instanceVar_temp)-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_e2_dX = 0.5*((-instanceStruct.d_instanceVar_temp_dX)+deriv_sqrt_0_d0*((((-instanceStruct.instanceVar_temp)-15.0)*(-instanceStruct.d_instanceVar_temp_dX)+(-instanceStruct.d_instanceVar_temp_dX)*((-instanceStruct.instanceVar_temp)-15.0))));
e2 = (0.5*(((-instanceStruct.instanceVar_temp)+15.0)+value_sqrt_0));
}
{
double value_log_0 = log(e1);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e1);
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_qq*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*(d_e1_dX))+instanceStruct.d_instanceVar_qq_dX*value_exp_1);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_qq*value_exp_1);
}
{
double value_log_0 = log(e2);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e2);
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp2_dX = (instanceStruct.instanceVar_qq*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*(d_e2_dX))+instanceStruct.d_instanceVar_qq_dX*value_exp_1);
instanceStruct.instanceVar_temp2 = (instanceStruct.instanceVar_qq*value_exp_1);
}
instanceStruct.d_instanceVar_temp3_dX = ((-instanceStruct.d_instanceVar_temp1_dX)-instanceStruct.d_instanceVar_temp2_dX);
instanceStruct.instanceVar_temp3 = ((1.0-instanceStruct.instanceVar_temp1)-instanceStruct.instanceVar_temp2);
instanceStruct.d_instanceVar_CsiPrime_dX = ((instanceStruct.instanceVar_temp3*instanceStruct.d_instanceVar_CsiPrime_0_dX-instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_temp3_dX)/instanceStruct.instanceVar_temp3/instanceStruct.instanceVar_temp3);
instanceStruct.instanceVar_CsiPrime = (instanceStruct.instanceVar_CsiPrime_0/instanceStruct.instanceVar_temp3);
d_tox1fact_dX = (instanceStruct.instanceVar_k1_1D*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_k1_1D_dX*instanceStruct.instanceVar_temp1);
tox1fact = (1.0+(instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp1));
d_tox2fact_dX = (instanceStruct.instanceVar_k2_1D*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_k2_1D_dX*instanceStruct.instanceVar_temp2);
tox2fact = (1.0+(instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp2));
d_k1_1D_QM_dX = ((tox1fact*(instanceStruct.instanceVar_k1_1D*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_k1_1D_dX*instanceStruct.instanceVar_temp3)-(instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp3)*d_tox1fact_dX)/tox1fact/tox1fact);
k1_1D_QM = ((instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp3)/tox1fact);
d_k2_1D_QM_dX = ((tox2fact*(instanceStruct.instanceVar_k2_1D*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_k2_1D_dX*instanceStruct.instanceVar_temp3)-(instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp3)*d_tox2fact_dX)/tox2fact/tox2fact);
k2_1D_QM = ((instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp3)/tox2fact);
d_keq_1D_QM_dX = (-((-d_k1_1D_QM_dX/k1_1D_QM/k1_1D_QM)+(-d_k2_1D_QM_dX/k2_1D_QM/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM))/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM)));
keq_1D_QM = (1.0/((1.0+(1.0/k1_1D_QM))+(1.0/k2_1D_QM)));
d_tox1fact_dX = (k1_1D_QM*instanceStruct.d_instanceVar_temp1_dX+d_k1_1D_QM_dX*instanceStruct.instanceVar_temp1);
tox1fact = (1.0+(k1_1D_QM*instanceStruct.instanceVar_temp1));
d_tox2fact_dX = (k2_1D_QM*instanceStruct.d_instanceVar_temp2_dX+d_k2_1D_QM_dX*instanceStruct.instanceVar_temp2);
tox2fact = (1.0+(k2_1D_QM*instanceStruct.instanceVar_temp2));
}
else
{
instanceStruct.d_instanceVar_CsiPrime_dX = instanceStruct.d_instanceVar_CsiPrime_0_dX;
instanceStruct.instanceVar_CsiPrime = instanceStruct.instanceVar_CsiPrime_0;
d_k1_1D_QM_dX = instanceStruct.d_instanceVar_k1_1D_dX;
k1_1D_QM = instanceStruct.instanceVar_k1_1D;
d_k2_1D_QM_dX = instanceStruct.d_instanceVar_k2_1D_dX;
k2_1D_QM = instanceStruct.instanceVar_k2_1D;
d_keq_1D_QM_dX = instanceStruct.d_instanceVar_keq_1D_dX;
keq_1D_QM = instanceStruct.instanceVar_keq_1D;
d_tox1fact_dX = 0.0;
tox1fact = 1.0;
d_tox2fact_dX = 0.0;
tox2fact = 1.0;
}
d_Dx_WI_1D_dX = (keq_1D_QM*(d_xg10_dX-d_xg2eff_dX)+d_keq_1D_QM_dX*(xg10-xg2eff));
Dx_WI_1D = (keq_1D_QM*(xg10-xg2eff));
if ((Dx_WI_1D>0.0))
{
if (((-Dx_WI_1D)<80.0))
{
{
double value_exp_0 = exp((-Dx_WI_1D));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp_dX = deriv_log_1_d0*(deriv_exp_0_d0*((-d_Dx_WI_1D_dX)));
instanceStruct.instanceVar_temp = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp_dX = (-d_Dx_WI_1D_dX);
instanceStruct.instanceVar_temp = (-Dx_WI_1D);
}
d_x_WI_1D_dX = ((d_xg10_dX-((k1_1D_QM*d_Dx_WI_1D_dX-Dx_WI_1D*d_k1_1D_QM_dX)/k1_1D_QM/k1_1D_QM))+instanceStruct.d_instanceVar_temp_dX);
x_WI_1D = (((xg10-(Dx_WI_1D/k1_1D_QM))+instanceStruct.instanceVar_temp)-0.6931471805599);
}
else
{
if ((Dx_WI_1D<80.0))
{
{
double value_exp_0 = exp(Dx_WI_1D);
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp_dX = deriv_log_1_d0*(deriv_exp_0_d0*(d_Dx_WI_1D_dX));
instanceStruct.instanceVar_temp = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp_dX = d_Dx_WI_1D_dX;
instanceStruct.instanceVar_temp = Dx_WI_1D;
}
d_x_WI_1D_dX = ((d_xg2eff_dX+((k2_1D_QM*d_Dx_WI_1D_dX-Dx_WI_1D*d_k2_1D_QM_dX)/k2_1D_QM/k2_1D_QM))+instanceStruct.d_instanceVar_temp_dX);
x_WI_1D = (((xg2eff+(Dx_WI_1D/k2_1D_QM))+instanceStruct.instanceVar_temp)-0.6931471805599);
}
{
double value_sqrt_0 = sqrt((((x_WI_1D-instanceStruct.instanceVar_xth_1D)*(x_WI_1D-instanceStruct.instanceVar_xth_1D))+4.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_1D_dX = 0.5*((d_x_WI_1D_dX+instanceStruct.d_instanceVar_xth_1D_dX)-deriv_sqrt_0_d0*(((x_WI_1D-instanceStruct.instanceVar_xth_1D)*(d_x_WI_1D_dX-instanceStruct.d_instanceVar_xth_1D_dX)+(d_x_WI_1D_dX-instanceStruct.d_instanceVar_xth_1D_dX)*(x_WI_1D-instanceStruct.instanceVar_xth_1D))));
x_1D = (0.5*((x_WI_1D+instanceStruct.instanceVar_xth_1D)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+((2.0*(instanceStruct.instanceVar_xth_1D-x_1D))/instanceStruct.instanceVar_xSDdep)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dleff_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_xSDdep*2.0*(instanceStruct.d_instanceVar_xth_1D_dX-d_x_1D_dX)-(2.0*(instanceStruct.instanceVar_xth_1D-x_1D))*instanceStruct.d_instanceVar_xSDdep_dX)/instanceStruct.instanceVar_xSDdep/instanceStruct.instanceVar_xSDdep));
dleff = (value_sqrt_0-1.0);
}
d_xedge_dX = (d_x_1D_dX+(instanceStruct.instanceVar_xSDdep*d_dleff_dX+instanceStruct.d_instanceVar_xSDdep_dX*dleff));
xedge = (x_1D+(instanceStruct.instanceVar_xSDdep*dleff));
{
double value_sqrt_0 = sqrt(((((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20))-0.5)*((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20))-0.5))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.5*((instanceStruct.instanceVar_PSCEDLB_i*d_xg20_dX+instanceStruct.d_instanceVar_PSCEDLB_i_dX*xg20)+deriv_sqrt_0_d0*((((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20))-0.5)*(instanceStruct.instanceVar_PSCEDLB_i*d_xg20_dX+instanceStruct.d_instanceVar_PSCEDLB_i_dX*xg20)+(instanceStruct.instanceVar_PSCEDLB_i*d_xg20_dX+instanceStruct.d_instanceVar_PSCEDLB_i_dX*xg20)*((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20))-0.5))));
instanceStruct.instanceVar_temp = (0.5*(((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20))+0.5)+value_sqrt_0));
}
d_sce1_dX = (-(instanceStruct.instanceVar_PSCE1_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_PSCE1_i_dX*instanceStruct.instanceVar_temp)/(1.0+(instanceStruct.instanceVar_PSCE1_i*instanceStruct.instanceVar_temp))/(1.0+(instanceStruct.instanceVar_PSCE1_i*instanceStruct.instanceVar_temp)));
sce1 = (1.0/(1.0+(instanceStruct.instanceVar_PSCE1_i*instanceStruct.instanceVar_temp)));
d_sce2_dX = (-(instanceStruct.instanceVar_PSCE2_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_PSCE2_i_dX*instanceStruct.instanceVar_temp)/(1.0+(instanceStruct.instanceVar_PSCE2_i*instanceStruct.instanceVar_temp))/(1.0+(instanceStruct.instanceVar_PSCE2_i*instanceStruct.instanceVar_temp)));
sce2 = (1.0/(1.0+(instanceStruct.instanceVar_PSCE2_i*instanceStruct.instanceVar_temp)));
{
double value_sqrt_0 = sqrt((1.0+(xdsx/instanceStruct.instanceVar_xd0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = ((((2.0*instanceStruct.instanceVar_xd0)*(value_sqrt_0-1.0))*(1.0+(instanceStruct.instanceVar_CFDL_i*dleff)))*(instanceStruct.instanceVar_CFDLB_i*d_xg20_dX+instanceStruct.d_instanceVar_CFDLB_i_dX*xg20)+(((2.0*instanceStruct.instanceVar_xd0)*(value_sqrt_0-1.0))*(instanceStruct.instanceVar_CFDL_i*d_dleff_dX+instanceStruct.d_instanceVar_CFDL_i_dX*dleff)+((2.0*instanceStruct.instanceVar_xd0)*deriv_sqrt_0_d0*(((instanceStruct.instanceVar_xd0*d_xdsx_dX-xdsx*instanceStruct.d_instanceVar_xd0_dX)/instanceStruct.instanceVar_xd0/instanceStruct.instanceVar_xd0))+2.0*instanceStruct.d_instanceVar_xd0_dX*(value_sqrt_0-1.0))*(1.0+(instanceStruct.instanceVar_CFDL_i*dleff)))*(1.0+(instanceStruct.instanceVar_CFDLB_i*xg20)));
instanceStruct.instanceVar_temp = ((((2.0*instanceStruct.instanceVar_xd0)*(value_sqrt_0-1.0))*(1.0+(instanceStruct.instanceVar_CFDL_i*dleff)))*(1.0+(instanceStruct.instanceVar_CFDLB_i*xg20)));
}
d_dxg1_dibl_dX = (instanceStruct.instanceVar_CF1_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_CF1_i_dX*instanceStruct.instanceVar_temp);
dxg1_dibl = (instanceStruct.instanceVar_CF1_i*instanceStruct.instanceVar_temp);
d_dxg2_dibl_dX = (instanceStruct.instanceVar_CF2_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_CF2_i_dX*instanceStruct.instanceVar_temp);
dxg2_dibl = (instanceStruct.instanceVar_CF2_i*instanceStruct.instanceVar_temp);
d_xg1_dX = (((((xg10-xedge)+dxg1_dibl)*d_sce1_dX+((d_xg10_dX-d_xedge_dX)+d_dxg1_dibl_dX)*sce1)+d_xedge_dX)+d_dxdsx_dX);
xg1 = (((((xg10-xedge)+dxg1_dibl)*sce1)+xedge)+dxdsx);
d_xg2_dX = (((((xg2eff-xedge)+dxg2_dibl)*d_sce2_dX+((d_xg2eff_dX-d_xedge_dX)+d_dxg2_dibl_dX)*sce2)+d_xedge_dX)+d_dxdsx_dX);
xg2 = (((((xg2eff-xedge)+dxg2_dibl)*sce2)+xedge)+dxdsx);
{
double value_sqrt_0 = sqrt(((((xg2+(instanceStruct.instanceVar_CIC1_i*(xg1-xg2)))-600.0)*((xg2+(instanceStruct.instanceVar_CIC1_i*(xg1-xg2)))-600.0))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xg1x_dX = 0.5*((d_xg2_dX+(instanceStruct.instanceVar_CIC1_i*(d_xg1_dX-d_xg2_dX)+instanceStruct.d_instanceVar_CIC1_i_dX*(xg1-xg2)))-deriv_sqrt_0_d0*((((xg2+(instanceStruct.instanceVar_CIC1_i*(xg1-xg2)))-600.0)*(d_xg2_dX+(instanceStruct.instanceVar_CIC1_i*(d_xg1_dX-d_xg2_dX)+instanceStruct.d_instanceVar_CIC1_i_dX*(xg1-xg2)))+(d_xg2_dX+(instanceStruct.instanceVar_CIC1_i*(d_xg1_dX-d_xg2_dX)+instanceStruct.d_instanceVar_CIC1_i_dX*(xg1-xg2)))*((xg2+(instanceStruct.instanceVar_CIC1_i*(xg1-xg2)))-600.0))));
xg1x = (0.5*(((xg2+(instanceStruct.instanceVar_CIC1_i*(xg1-xg2)))+600.0)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((xg1+(instanceStruct.instanceVar_CIC2_i*(xg2-xg1)))-600.0)*((xg1+(instanceStruct.instanceVar_CIC2_i*(xg2-xg1)))-600.0))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xg2x_dX = 0.5*((d_xg1_dX+(instanceStruct.instanceVar_CIC2_i*(d_xg2_dX-d_xg1_dX)+instanceStruct.d_instanceVar_CIC2_i_dX*(xg2-xg1)))-deriv_sqrt_0_d0*((((xg1+(instanceStruct.instanceVar_CIC2_i*(xg2-xg1)))-600.0)*(d_xg1_dX+(instanceStruct.instanceVar_CIC2_i*(d_xg2_dX-d_xg1_dX)+instanceStruct.d_instanceVar_CIC2_i_dX*(xg2-xg1)))+(d_xg1_dX+(instanceStruct.instanceVar_CIC2_i*(d_xg2_dX-d_xg1_dX)+instanceStruct.d_instanceVar_CIC2_i_dX*(xg2-xg1)))*((xg1+(instanceStruct.instanceVar_CIC2_i*(xg2-xg1)))-600.0))));
xg2x = (0.5*(((xg1+(instanceStruct.instanceVar_CIC2_i*(xg2-xg1)))+600.0)-value_sqrt_0));
}
instanceStruct.d_instanceVar_k1_dX = ((sce1*d_k1_1D_QM_dX-k1_1D_QM*d_sce1_dX)/sce1/sce1);
instanceStruct.instanceVar_k1 = (k1_1D_QM/sce1);
d_k2_dX = ((sce2*d_k2_1D_QM_dX-k2_1D_QM*d_sce2_dX)/sce2/sce2);
k2 = (k2_1D_QM/sce2);
d_inv_k1_dX = (-instanceStruct.d_instanceVar_k1_dX/instanceStruct.instanceVar_k1/instanceStruct.instanceVar_k1);
inv_k1 = (1.0/instanceStruct.instanceVar_k1);
d_inv_k2_dX = (-d_k2_dX/k2/k2);
inv_k2 = (1.0/k2);
d_keq_dX = (-(d_inv_k1_dX+d_inv_k2_dX)/((1.0+inv_k1)+inv_k2)/((1.0+inv_k1)+inv_k2));
keq = (1.0/((1.0+inv_k1)+inv_k2));
d_A0_dX = (((instanceStruct.instanceVar_CsiPrime*instanceStruct.instanceVar_CsiPrime)*instanceStruct.d_instanceVar_A0_Csisq_dX-instanceStruct.instanceVar_A0_Csisq*(instanceStruct.instanceVar_CsiPrime*instanceStruct.d_instanceVar_CsiPrime_dX+instanceStruct.d_instanceVar_CsiPrime_dX*instanceStruct.instanceVar_CsiPrime))/(instanceStruct.instanceVar_CsiPrime*instanceStruct.instanceVar_CsiPrime)/(instanceStruct.instanceVar_CsiPrime*instanceStruct.instanceVar_CsiPrime));
A0 = (instanceStruct.instanceVar_A0_Csisq/(instanceStruct.instanceVar_CsiPrime*instanceStruct.instanceVar_CsiPrime));
d_exp_dxth_dX = (((1.0+k2)*instanceStruct.d_instanceVar_k1_dX-(1.0+instanceStruct.instanceVar_k1)*d_k2_dX)/(1.0+k2)/(1.0+k2));
exp_dxth = ((1.0+instanceStruct.instanceVar_k1)/(1.0+k2));
{
double value_log_0 = log(exp_dxth);
double  deriv_log_0_d0 = (1.0/exp_dxth);
d_dxth_dX = deriv_log_0_d0*(d_exp_dxth_dX);
dxth = value_log_0;
}
if ((dxth>1.0e-8))
{
d_diff_min_dX = (((exp_dxth-1.0)*((2.0*dxth)*d_exp_dxth_dX+2.0*d_dxth_dX*(exp_dxth+1.0))-((2.0*dxth)*(exp_dxth+1.0))*d_exp_dxth_dX)/(exp_dxth-1.0)/(exp_dxth-1.0));
diff_min = (((2.0*dxth)*(exp_dxth+1.0))/(exp_dxth-1.0));
}
else
{
d_diff_min_dX = 2.0*d_dxth_dX;
diff_min = (2.0*(2.0+dxth));
}
d_Dx_WI_dX = (keq*(d_xg1x_dX-d_xg2x_dX)+d_keq_dX*(xg1x-xg2x));
Dx_WI = (keq*(xg1x-xg2x));
d_Dx_WIsq_dX = (Dx_WI*d_Dx_WI_dX+d_Dx_WI_dX*Dx_WI);
Dx_WIsq = (Dx_WI*Dx_WI);
d_x1_WI0_dX = (d_xg1x_dX-(Dx_WI*d_inv_k1_dX+d_Dx_WI_dX*inv_k1));
x1_WI0 = (xg1x-(Dx_WI*inv_k1));
d_x2_WI0_dX = (d_xg2x_dX+(Dx_WI*d_inv_k2_dX+d_Dx_WI_dX*inv_k2));
x2_WI0 = (xg2x+(Dx_WI*inv_k2));
d_q_temp1_dX = (-instanceStruct.d_instanceVar_k1_dX/(instanceStruct.instanceVar_k1+1.0)/(instanceStruct.instanceVar_k1+1.0));
q_temp1 = (1.0/(instanceStruct.instanceVar_k1+1.0));
d_q_temp2_dX = (-d_k2_dX/(k2+1.0)/(k2+1.0));
q_temp2 = (1.0/(k2+1.0));
{
double value_log_0 = log((((instanceStruct.instanceVar_k1+(k2*q_temp2))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((instanceStruct.instanceVar_k1+(k2*q_temp2))*diff_min)/A0));
d_q_x1sat_dX = deriv_log_0_d0*(((A0*((instanceStruct.instanceVar_k1+(k2*q_temp2))*d_diff_min_dX+(instanceStruct.d_instanceVar_k1_dX+(k2*d_q_temp2_dX+d_k2_dX*q_temp2))*diff_min)-((instanceStruct.instanceVar_k1+(k2*q_temp2))*diff_min)*d_A0_dX)/A0/A0));
q_x1sat = (value_log_0+3.0);
}
{
double value_log_0 = log((((k2+(instanceStruct.instanceVar_k1*q_temp1))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k2+(instanceStruct.instanceVar_k1*q_temp1))*diff_min)/A0));
d_q_x2sat_dX = deriv_log_0_d0*(((A0*((k2+(instanceStruct.instanceVar_k1*q_temp1))*d_diff_min_dX+(d_k2_dX+(instanceStruct.instanceVar_k1*d_q_temp1_dX+instanceStruct.d_instanceVar_k1_dX*q_temp1))*diff_min)-((k2+(instanceStruct.instanceVar_k1*q_temp1))*diff_min)*d_A0_dX)/A0/A0));
q_x2sat = (value_log_0+3.0);
}
if ((((q_x1sat-x1_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-x1_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x1sat_dX-d_x1_WI0_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x1sat_dX-d_x1_WI0_dX)*0.3333333333333;
q_temp3 = ((q_x1sat-x1_WI0)*0.3333333333333);
}
d_q_x1_dX = (d_q_x1sat_dX-3.0*d_q_temp3_dX);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-x2_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-x2_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x2sat_dX-d_x2_WI0_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x2sat_dX-d_x2_WI0_dX)*0.3333333333333;
q_temp3 = ((q_x2sat-x2_WI0)*0.3333333333333);
}
d_q_x2_dX = (d_q_x2sat_dX-3.0*d_q_temp3_dX);
q_x2 = (q_x2sat-(3.0*q_temp3));
d_q_x1_WI_dX = (((instanceStruct.instanceVar_k1*xg1x)+q_x2)*d_q_temp1_dX+((instanceStruct.instanceVar_k1*d_xg1x_dX+instanceStruct.d_instanceVar_k1_dX*xg1x)+d_q_x2_dX)*q_temp1);
q_x1_WI = (((instanceStruct.instanceVar_k1*xg1x)+q_x2)*q_temp1);
d_q_x2_WI_dX = (((k2*xg2x)+q_x1)*d_q_temp2_dX+((k2*d_xg2x_dX+d_k2_dX*xg2x)+d_q_x1_dX)*q_temp2);
q_x2_WI = (((k2*xg2x)+q_x1)*q_temp2);
if ((((q_x1sat-q_x1_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-q_x1_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x1sat_dX-d_q_x1_WI_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x1sat_dX-d_q_x1_WI_dX)*0.3333333333333;
q_temp3 = ((q_x1sat-q_x1_WI)*0.3333333333333);
}
d_q_x1_dX = (d_q_x1sat_dX-3.0*d_q_temp3_dX);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-q_x2_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-q_x2_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x2sat_dX-d_q_x2_WI_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x2sat_dX-d_q_x2_WI_dX)*0.3333333333333;
q_temp3 = ((q_x2sat-q_x2_WI)*0.3333333333333);
}
d_q_x2_dX = (d_q_x2sat_dX-3.0*d_q_temp3_dX);
q_x2 = (q_x2sat-(3.0*q_temp3));
d_q1s_dX = (d_xg1x_dX-d_q_x1_dX);
q1s = (xg1x-q_x1);
d_q2s_dX = (d_xg2x_dX-d_q_x2_dX);
q2s = (xg2x-q_x2);
d_q_rac_qsq_dX = 0.0;
q_rac_qsq = 0.0;
d_q_invexpq_dX = 0.0;
q_invexpq = 0.0;
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1s_dX+instanceStruct.d_instanceVar_k1_dX*q1s);
q_k1q1 = (instanceStruct.instanceVar_k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*((d_xg1x_dX-d_q1s_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dX-d_q1s_dX)*0.3333333333333+0.5*(d_xg1x_dX-d_q1s_dX)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dX-d_q1s_dX)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}
d_q_Aexp_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
q_Aexp = (A0*q_temp1);
d_q_qsq_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_Aexp_dX);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);
d_q_d1_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_Aexp_dX);
q_d1_qsq = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_Aexp);
d_q_d2_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.d_instanceVar_k1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*instanceStruct.instanceVar_k1)-d_q_Aexp_dX);
q_d2_qsq = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.instanceVar_k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
d_q_temp3_dX = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dX*0.025)+d_q_qsq_dX*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dX*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));
d_q_qcoth_dX = (q_qsq*d_q_temp3_dX+d_q_qsq_dX*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));
d_q_temp1_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
d_q_d1_qcoth_dX = (q_d1_qsq*d_q_temp1_dX+d_q_d1_qsq_dX*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);
d_q_temp2_dX = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dX*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));
d_q_d2_qcoth_dX = ((q_d2_qsq*d_q_temp1_dX+d_q_d2_qsq_dX*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dX+(q_d1_qsq*d_q_d1_qsq_dX+d_q_d1_qsq_dX*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));
d_q_d1_ln_dX = (((-0.5)*q_d1_qsq)*d_q_temp3_dX+(-0.5)*d_q_d1_qsq_dX*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);
d_q_d2_ln_dX = ((((-0.5)*q_d2_qsq)*d_q_temp3_dX+(-0.5)*d_q_d2_qsq_dX*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dX)+d_q_qsq_dX*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dX+(0.25*0.0055555555556)*d_q_d1_qsq_dX*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{
d_q_temp2_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dX-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_sh_term_dX = (q_temp2*d_q_invexpq_dX+d_q_temp2_dX*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);
d_q_ln_term_dX = (deriv_log_0_d0*(d_q_temp2_dX)-d_q_rac_qsq_dX);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_sh_term_dX = (((q_temp2*q_temp2)*(-d_q_qsq_dX)-(-q_qsq)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
else
{
d_q_sh_term_dX = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dX*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{
d_q_expnum_dX = (d_q_k1q1_dX+d_q_qcoth_dX);
q_expnum = (q_k1q1+q_qcoth);
d_q_d1_expnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_d1_qcoth_dX);
q_d1_expnum = (instanceStruct.instanceVar_k1+q_d1_qcoth);
d_q_d2_expnum_dX = d_q_d2_qcoth_dX;
q_d2_expnum = q_d2_qcoth;
}
else
{
d_q_temp2_dX = (-(d_q_k1q1_dX-d_q_qcoth_dX)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));
d_q_temp3_dX = (d_q_d1_qcoth_dX-instanceStruct.d_instanceVar_k1_dX);
q_temp3 = (q_d1_qcoth-instanceStruct.instanceVar_k1);
d_q_expnum_dX = ((q_Aexp-q_sh_term)*d_q_temp2_dX+(d_q_Aexp_dX-d_q_sh_term_dX)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);
d_q_d1_expnum_dX = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dX+(((q_temp3*d_q_expnum_dX+d_q_temp3_dX*q_expnum)-d_q_Aexp_dX)-(q_d1_ln*d_q_sh_term_dX+d_q_d1_ln_dX*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);
d_q_d2_expnum_dX = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dX+((((q_d2_qcoth*d_q_expnum_dX+d_q_d2_qcoth_dX*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dX+2.0*d_q_temp3_dX*q_d1_expnum))+d_q_Aexp_dX)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dX+(d_q_d2_ln_dX+(q_d1_ln*d_q_d1_ln_dX+d_q_d1_ln_dX*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);
d_q_lnexpnum_dX = deriv_log_0_d0*(d_q_expnum_dX);
q_lnexpnum = value_log_0;
}
d_q_temp1_dX = (-d_q_expnum_dX/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);
d_q_d1_lnexpnum_dX = (q_d1_expnum*d_q_temp1_dX+d_q_d1_expnum_dX*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);
d_q_d2_lnexpnum_dX = ((q_d2_expnum*d_q_temp1_dX+d_q_d2_expnum_dX*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dX+d_q_d1_lnexpnum_dX*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));
d_q_lnexpnum_dX = (d_q_k1q1_dX+deriv_log_0_d0*((-d_q_k1q1_dX)));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}
d_q_temp1_dX = (-d_q1s_dX/q1s/q1s);
q_temp1 = (1.0/q1s);
d_q_d1_lnexpnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_temp1_dX);
q_d1_lnexpnum = (instanceStruct.instanceVar_k1+q_temp1);
d_q_d2_lnexpnum_dX = ((-q_temp1)*d_q_temp1_dX+(-d_q_temp1_dX)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}
d_q_q2_int_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1s_dX)+2.0*d_q_lnexpnum_dX)-d_q_ln_term_dX);
q_q2_int = ((((xg2x-xg1x)+q1s)+(2.0*q_lnexpnum))-q_ln_term);
d_q_d1_q2_dX = (2.0*d_q_d1_lnexpnum_dX-d_q_d1_ln_dX);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);
d_q_d2_q2_dX = (2.0*d_q_d2_lnexpnum_dX-d_q_d2_ln_dX);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);
d_q_qi_int_dX = (d_q_k1q1_dX+(k2*d_q_q2_int_dX+d_k2_dX*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));
d_q_d1_qi_dX = (instanceStruct.d_instanceVar_k1_dX+(k2*d_q_d1_q2_dX+d_k2_dX*q_d1_q2));
q_d1_qi = (instanceStruct.instanceVar_k1+(k2*q_d1_q2));
d_q_d2_qi_dX = (k2*d_q_d2_q2_dX+d_k2_dX*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);
d_q_zero_dX = ((q_qi_int*d_q_expnum_dX+d_q_qi_int_dX*q_expnum)-d_q_Aexp_dX);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{
d_q_eps2_dX = 0.0;
q_eps2 = 0.0;
}
else
{
d_q_d1_zero_dX = (((q_d1_qi*d_q_expnum_dX+d_q_d1_qi_dX*q_expnum)+(q_qi_int*d_q_d1_expnum_dX+d_q_qi_int_dX*q_d1_expnum))+d_q_Aexp_dX);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);
d_q_d2_zero_dX = ((((q_d2_qi*d_q_expnum_dX+d_q_d2_qi_dX*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dX+2.0*d_q_d1_qi_dX*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dX+d_q_qi_int_dX*q_d2_expnum))-d_q_Aexp_dX);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);
d_q_eps1_dX = ((q_d1_zero*(-d_q_zero_dX)-(-q_zero)*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);
d_q_eps2_dX = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dX)-(-q_zero)*(d_q_d1_zero_dX+((0.5*q_eps1)*d_q_d2_zero_dX+0.5*d_q_eps1_dX*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}
d_q1s_dX = (d_q1s_dX+d_q_eps2_dX);
q1s = (q1s+q_eps2);
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1s_dX+instanceStruct.d_instanceVar_k1_dX*q1s);
q_k1q1 = (instanceStruct.instanceVar_k1*q1s);
d_q_k2q2_dX = (k2*d_q2s_dX+d_k2_dX*q2s);
q_k2q2 = (k2*q2s);
d_q_qi_int_dX = (d_q_k1q1_dX+d_q_k2q2_dX);
q_qi_int = (q_k1q1+q_k2q2);
d_q_a_dX = 0.065345483024*d_q_qi_int_dX;
q_a = (1.0+(0.065345483024*q_qi_int));
d_q_b_dX = (8.5797362674*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));
d_q_c_dX = 39.478417604*(2.0*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_q_disc_dX = deriv_sqrt_0_d0*(((q_b*d_q_b_dX+d_q_b_dX*q_b)-((4.0*q_a)*d_q_c_dX+4.0*d_q_a_dX*q_c)));
q_disc = value_sqrt_0;
}
d_q_qsq_dX = (((2.0*q_a)*(d_q_disc_dX-d_q_b_dX)-(q_disc-q_b)*2.0*d_q_a_dX)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));
d_q_delta_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_qsq_dX);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));
d_q_zero_dX = (q_delta*((deriv_log_0_d0*(((A0*d_q_delta_dX-q_delta*d_A0_dX)/A0/A0))-d_xg1x_dX)+d_q1s_dX)+d_q_delta_dX*((value_log_0-xg1x)+q1s));
q_zero = (q_delta*((value_log_0-xg1x)+q1s));
}
d_q_d1_zero_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_delta_dX);
q_d1_zero = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_delta);
d_q_dx1_dX = ((d_xg1x_dX-d_q1s_dX)-d_q_x1sat_dX);
q_dx1 = ((xg1x-q1s)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(instanceStruct.instanceVar_k1))>0.0))||(q_dx1>1.0)))
{
d_q1s_dX = (d_q1s_dX-((q_d1_zero*d_q_zero_dX-q_zero*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero));
q1s = (q1s-(q_zero/q_d1_zero));
}
}
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1s_dX+instanceStruct.d_instanceVar_k1_dX*q1s);
q_k1q1 = (instanceStruct.instanceVar_k1*q1s);
d_q_k2q2_dX = (k2*d_q2s_dX+d_k2_dX*q2s);
q_k2q2 = (k2*q2s);
d_q_qi_int_dX = (d_q_k1q1_dX+d_q_k2q2_dX);
q_qi_int = (q_k1q1+q_k2q2);
d_q_a_dX = 0.065345483024*d_q_qi_int_dX;
q_a = (1.0+(0.065345483024*q_qi_int));
d_q_b_dX = (8.5797362674*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));
d_q_c_dX = 39.478417604*(2.0*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_q_disc_dX = deriv_sqrt_0_d0*(((q_b*d_q_b_dX+d_q_b_dX*q_b)-((4.0*q_a)*d_q_c_dX+4.0*d_q_a_dX*q_c)));
q_disc = value_sqrt_0;
}
d_q_qsq_dX = (((2.0*q_a)*(d_q_disc_dX-d_q_b_dX)-(q_disc-q_b)*2.0*d_q_a_dX)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_d1_qcoth_dX = ((q_qsq*0.25*(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_d1_qcoth_dX = ((q_qsq*0.25*(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{
d_q_qcoth_dX = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dX*0.0238095238095)+d_q_qsq_dX*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dX*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
q_qcoth = (2.0+((q_qsq*0.1666666666667)*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095))))));
d_q_d1_qcoth_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_d1_qcoth = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
}
}
d_q_qsq_dX = (d_q_qsq_dX-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dX+d_q_qi_int_dX*q_qcoth)+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2))+d_q_qsq_dX)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dX+d_q_qi_int_dX*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
q_qsq = (q_qsq-((((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_delta_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_qsq_dX);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));
d_q_zero_dX = (q_delta*((deriv_log_0_d0*(((A0*d_q_delta_dX-q_delta*d_A0_dX)/A0/A0))-d_xg1x_dX)+d_q1s_dX)+d_q_delta_dX*((value_log_0-xg1x)+q1s));
q_zero = (q_delta*((value_log_0-xg1x)+q1s));
}
d_q_d1_zero_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_delta_dX);
q_d1_zero = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_delta);
d_q_dx1_dX = ((d_xg1x_dX-d_q1s_dX)-d_q_x1sat_dX);
q_dx1 = ((xg1x-q1s)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(instanceStruct.instanceVar_k1))>0.0))||(q_dx1>1.0)))
{
d_q1s_dX = (d_q1s_dX-((q_d1_zero*d_q_zero_dX-q_zero*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero));
q1s = (q1s-(q_zero/q_d1_zero));
}
}
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1s_dX+instanceStruct.d_instanceVar_k1_dX*q1s);
q_k1q1 = (instanceStruct.instanceVar_k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*((d_xg1x_dX-d_q1s_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dX-d_q1s_dX)*0.3333333333333+0.5*(d_xg1x_dX-d_q1s_dX)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dX-d_q1s_dX)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}
d_q_Aexp_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
q_Aexp = (A0*q_temp1);
d_q_qsq_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_Aexp_dX);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);
d_q_d1_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_Aexp_dX);
q_d1_qsq = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_Aexp);
d_q_d2_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.d_instanceVar_k1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*instanceStruct.instanceVar_k1)-d_q_Aexp_dX);
q_d2_qsq = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.instanceVar_k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
d_q_temp3_dX = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dX*0.025)+d_q_qsq_dX*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dX*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));
d_q_qcoth_dX = (q_qsq*d_q_temp3_dX+d_q_qsq_dX*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));
d_q_temp1_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
d_q_d1_qcoth_dX = (q_d1_qsq*d_q_temp1_dX+d_q_d1_qsq_dX*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);
d_q_temp2_dX = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dX*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));
d_q_d2_qcoth_dX = ((q_d2_qsq*d_q_temp1_dX+d_q_d2_qsq_dX*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dX+(q_d1_qsq*d_q_d1_qsq_dX+d_q_d1_qsq_dX*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));
d_q_d1_ln_dX = (((-0.5)*q_d1_qsq)*d_q_temp3_dX+(-0.5)*d_q_d1_qsq_dX*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);
d_q_d2_ln_dX = ((((-0.5)*q_d2_qsq)*d_q_temp3_dX+(-0.5)*d_q_d2_qsq_dX*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dX)+d_q_qsq_dX*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dX+(0.25*0.0055555555556)*d_q_d1_qsq_dX*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{
d_q_temp2_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dX-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_sh_term_dX = (q_temp2*d_q_invexpq_dX+d_q_temp2_dX*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);
d_q_ln_term_dX = (deriv_log_0_d0*(d_q_temp2_dX)-d_q_rac_qsq_dX);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_sh_term_dX = (((q_temp2*q_temp2)*(-d_q_qsq_dX)-(-q_qsq)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
else
{
d_q_sh_term_dX = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dX*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{
d_q_expnum_dX = (d_q_k1q1_dX+d_q_qcoth_dX);
q_expnum = (q_k1q1+q_qcoth);
d_q_d1_expnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_d1_qcoth_dX);
q_d1_expnum = (instanceStruct.instanceVar_k1+q_d1_qcoth);
d_q_d2_expnum_dX = d_q_d2_qcoth_dX;
q_d2_expnum = q_d2_qcoth;
}
else
{
d_q_temp2_dX = (-(d_q_k1q1_dX-d_q_qcoth_dX)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));
d_q_temp3_dX = (d_q_d1_qcoth_dX-instanceStruct.d_instanceVar_k1_dX);
q_temp3 = (q_d1_qcoth-instanceStruct.instanceVar_k1);
d_q_expnum_dX = ((q_Aexp-q_sh_term)*d_q_temp2_dX+(d_q_Aexp_dX-d_q_sh_term_dX)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);
d_q_d1_expnum_dX = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dX+(((q_temp3*d_q_expnum_dX+d_q_temp3_dX*q_expnum)-d_q_Aexp_dX)-(q_d1_ln*d_q_sh_term_dX+d_q_d1_ln_dX*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);
d_q_d2_expnum_dX = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dX+((((q_d2_qcoth*d_q_expnum_dX+d_q_d2_qcoth_dX*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dX+2.0*d_q_temp3_dX*q_d1_expnum))+d_q_Aexp_dX)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dX+(d_q_d2_ln_dX+(q_d1_ln*d_q_d1_ln_dX+d_q_d1_ln_dX*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);
d_q_lnexpnum_dX = deriv_log_0_d0*(d_q_expnum_dX);
q_lnexpnum = value_log_0;
}
d_q_temp1_dX = (-d_q_expnum_dX/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);
d_q_d1_lnexpnum_dX = (q_d1_expnum*d_q_temp1_dX+d_q_d1_expnum_dX*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);
d_q_d2_lnexpnum_dX = ((q_d2_expnum*d_q_temp1_dX+d_q_d2_expnum_dX*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dX+d_q_d1_lnexpnum_dX*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));
d_q_lnexpnum_dX = (d_q_k1q1_dX+deriv_log_0_d0*((-d_q_k1q1_dX)));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}
d_q_temp1_dX = (-d_q1s_dX/q1s/q1s);
q_temp1 = (1.0/q1s);
d_q_d1_lnexpnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_temp1_dX);
q_d1_lnexpnum = (instanceStruct.instanceVar_k1+q_temp1);
d_q_d2_lnexpnum_dX = ((-q_temp1)*d_q_temp1_dX+(-d_q_temp1_dX)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}
d_q_q2_int_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1s_dX)+2.0*d_q_lnexpnum_dX)-d_q_ln_term_dX);
q_q2_int = ((((xg2x-xg1x)+q1s)+(2.0*q_lnexpnum))-q_ln_term);
d_q_d1_q2_dX = (2.0*d_q_d1_lnexpnum_dX-d_q_d1_ln_dX);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);
d_q_d2_q2_dX = (2.0*d_q_d2_lnexpnum_dX-d_q_d2_ln_dX);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);
d_q_qi_int_dX = (d_q_k1q1_dX+(k2*d_q_q2_int_dX+d_k2_dX*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));
d_q_d1_qi_dX = (instanceStruct.d_instanceVar_k1_dX+(k2*d_q_d1_q2_dX+d_k2_dX*q_d1_q2));
q_d1_qi = (instanceStruct.instanceVar_k1+(k2*q_d1_q2));
d_q_d2_qi_dX = (k2*d_q_d2_q2_dX+d_k2_dX*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);
d_q_zero_dX = ((q_qi_int*d_q_expnum_dX+d_q_qi_int_dX*q_expnum)-d_q_Aexp_dX);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{
d_q_eps2_dX = 0.0;
q_eps2 = 0.0;
}
else
{
d_q_d1_zero_dX = (((q_d1_qi*d_q_expnum_dX+d_q_d1_qi_dX*q_expnum)+(q_qi_int*d_q_d1_expnum_dX+d_q_qi_int_dX*q_d1_expnum))+d_q_Aexp_dX);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);
d_q_d2_zero_dX = ((((q_d2_qi*d_q_expnum_dX+d_q_d2_qi_dX*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dX+2.0*d_q_d1_qi_dX*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dX+d_q_qi_int_dX*q_d2_expnum))-d_q_Aexp_dX);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);
d_q_eps1_dX = ((q_d1_zero*(-d_q_zero_dX)-(-q_zero)*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);
d_q_eps2_dX = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dX)-(-q_zero)*(d_q_d1_zero_dX+((0.5*q_eps1)*d_q_d2_zero_dX+0.5*d_q_eps1_dX*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}
d_q1s_dX = (d_q1s_dX+d_q_eps2_dX);
q1s = (q1s+q_eps2);
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1s_dX+instanceStruct.d_instanceVar_k1_dX*q1s);
q_k1q1 = (instanceStruct.instanceVar_k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*((d_xg1x_dX-d_q1s_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dX-d_q1s_dX)*0.3333333333333+0.5*(d_xg1x_dX-d_q1s_dX)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dX-d_q1s_dX)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}
d_q_Aexp_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
q_Aexp = (A0*q_temp1);
d_q_qsq_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_Aexp_dX);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);
d_q_d1_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_Aexp_dX);
q_d1_qsq = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_Aexp);
d_q_d2_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.d_instanceVar_k1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*instanceStruct.instanceVar_k1)-d_q_Aexp_dX);
q_d2_qsq = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.instanceVar_k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
d_q_temp3_dX = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dX*0.025)+d_q_qsq_dX*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dX*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));
d_q_qcoth_dX = (q_qsq*d_q_temp3_dX+d_q_qsq_dX*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));
d_q_temp1_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
d_q_d1_qcoth_dX = (q_d1_qsq*d_q_temp1_dX+d_q_d1_qsq_dX*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);
d_q_temp2_dX = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dX*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));
d_q_d2_qcoth_dX = ((q_d2_qsq*d_q_temp1_dX+d_q_d2_qsq_dX*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dX+(q_d1_qsq*d_q_d1_qsq_dX+d_q_d1_qsq_dX*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));
d_q_d1_ln_dX = (((-0.5)*q_d1_qsq)*d_q_temp3_dX+(-0.5)*d_q_d1_qsq_dX*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);
d_q_d2_ln_dX = ((((-0.5)*q_d2_qsq)*d_q_temp3_dX+(-0.5)*d_q_d2_qsq_dX*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dX)+d_q_qsq_dX*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dX+(0.25*0.0055555555556)*d_q_d1_qsq_dX*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{
d_q_temp2_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dX-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_sh_term_dX = (q_temp2*d_q_invexpq_dX+d_q_temp2_dX*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);
d_q_ln_term_dX = (deriv_log_0_d0*(d_q_temp2_dX)-d_q_rac_qsq_dX);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_sh_term_dX = (((q_temp2*q_temp2)*(-d_q_qsq_dX)-(-q_qsq)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
else
{
d_q_sh_term_dX = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dX*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{
d_q_expnum_dX = (d_q_k1q1_dX+d_q_qcoth_dX);
q_expnum = (q_k1q1+q_qcoth);
d_q_d1_expnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_d1_qcoth_dX);
q_d1_expnum = (instanceStruct.instanceVar_k1+q_d1_qcoth);
d_q_d2_expnum_dX = d_q_d2_qcoth_dX;
q_d2_expnum = q_d2_qcoth;
}
else
{
d_q_temp2_dX = (-(d_q_k1q1_dX-d_q_qcoth_dX)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));
d_q_temp3_dX = (d_q_d1_qcoth_dX-instanceStruct.d_instanceVar_k1_dX);
q_temp3 = (q_d1_qcoth-instanceStruct.instanceVar_k1);
d_q_expnum_dX = ((q_Aexp-q_sh_term)*d_q_temp2_dX+(d_q_Aexp_dX-d_q_sh_term_dX)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);
d_q_d1_expnum_dX = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dX+(((q_temp3*d_q_expnum_dX+d_q_temp3_dX*q_expnum)-d_q_Aexp_dX)-(q_d1_ln*d_q_sh_term_dX+d_q_d1_ln_dX*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);
d_q_d2_expnum_dX = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dX+((((q_d2_qcoth*d_q_expnum_dX+d_q_d2_qcoth_dX*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dX+2.0*d_q_temp3_dX*q_d1_expnum))+d_q_Aexp_dX)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dX+(d_q_d2_ln_dX+(q_d1_ln*d_q_d1_ln_dX+d_q_d1_ln_dX*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);
d_q_lnexpnum_dX = deriv_log_0_d0*(d_q_expnum_dX);
q_lnexpnum = value_log_0;
}
d_q_temp1_dX = (-d_q_expnum_dX/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);
d_q_d1_lnexpnum_dX = (q_d1_expnum*d_q_temp1_dX+d_q_d1_expnum_dX*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);
d_q_d2_lnexpnum_dX = ((q_d2_expnum*d_q_temp1_dX+d_q_d2_expnum_dX*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dX+d_q_d1_lnexpnum_dX*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));
d_q_lnexpnum_dX = (d_q_k1q1_dX+deriv_log_0_d0*((-d_q_k1q1_dX)));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}
d_q_temp1_dX = (-d_q1s_dX/q1s/q1s);
q_temp1 = (1.0/q1s);
d_q_d1_lnexpnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_temp1_dX);
q_d1_lnexpnum = (instanceStruct.instanceVar_k1+q_temp1);
d_q_d2_lnexpnum_dX = ((-q_temp1)*d_q_temp1_dX+(-d_q_temp1_dX)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}
d_q_q2_int_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1s_dX)+2.0*d_q_lnexpnum_dX)-d_q_ln_term_dX);
q_q2_int = ((((xg2x-xg1x)+q1s)+(2.0*q_lnexpnum))-q_ln_term);
d_q_d1_q2_dX = (2.0*d_q_d1_lnexpnum_dX-d_q_d1_ln_dX);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);
d_q_d2_q2_dX = (2.0*d_q_d2_lnexpnum_dX-d_q_d2_ln_dX);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);
d_q_qi_int_dX = (d_q_k1q1_dX+(k2*d_q_q2_int_dX+d_k2_dX*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));
d_q_d1_qi_dX = (instanceStruct.d_instanceVar_k1_dX+(k2*d_q_d1_q2_dX+d_k2_dX*q_d1_q2));
q_d1_qi = (instanceStruct.instanceVar_k1+(k2*q_d1_q2));
d_q_d2_qi_dX = (k2*d_q_d2_q2_dX+d_k2_dX*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);
d_q_zero_dX = ((q_qi_int*d_q_expnum_dX+d_q_qi_int_dX*q_expnum)-d_q_Aexp_dX);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{
d_q_eps2_dX = 0.0;
q_eps2 = 0.0;
}
else
{
d_q_d1_zero_dX = (((q_d1_qi*d_q_expnum_dX+d_q_d1_qi_dX*q_expnum)+(q_qi_int*d_q_d1_expnum_dX+d_q_qi_int_dX*q_d1_expnum))+d_q_Aexp_dX);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);
d_q_d2_zero_dX = ((((q_d2_qi*d_q_expnum_dX+d_q_d2_qi_dX*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dX+2.0*d_q_d1_qi_dX*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dX+d_q_qi_int_dX*q_d2_expnum))-d_q_Aexp_dX);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);
d_q_eps1_dX = ((q_d1_zero*(-d_q_zero_dX)-(-q_zero)*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);
d_q_eps2_dX = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dX)-(-q_zero)*(d_q_d1_zero_dX+((0.5*q_eps1)*d_q_d2_zero_dX+0.5*d_q_eps1_dX*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}
d_q1s_dX = (d_q1s_dX+d_q_eps2_dX);
q1s = (q1s+q_eps2);
d_k1q1s_dX = (instanceStruct.instanceVar_k1*d_q1s_dX+instanceStruct.d_instanceVar_k1_dX*q1s);
k1q1s = (instanceStruct.instanceVar_k1*q1s);
if ((((xg1x-q1s))<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1s)));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*((d_xg1x_dX-d_q1s_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1s))-80.0)*((0.5*(((xg1x-q1s))-80.0))*(d_xg1x_dX-d_q1s_dX)*0.3333333333333+0.5*(d_xg1x_dX-d_q1s_dX)*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))+(d_xg1x_dX-d_q1s_dX)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1s))-80.0)*(1.0+((0.5*(((xg1x-q1s))-80.0))*(1.0+((((xg1x-q1s))-80.0)*0.3333333333333)))))));
}
d_Aexp1s_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
Aexp1s = (A0*q_temp1);
d_qsqs_dX = ((k1q1s*d_k1q1s_dX+d_k1q1s_dX*k1q1s)-d_Aexp1s_dX);
qsqs = ((k1q1s*k1q1s)-Aexp1s);
if ((Aexp1s==0.0))
{
instanceStruct.d_instanceVar_qis_dX = 0.0;
instanceStruct.instanceVar_qis = 1.0e-80;
d_k2q2s_dX = (instanceStruct.d_instanceVar_qis_dX-d_k1q1s_dX);
k2q2s = (instanceStruct.instanceVar_qis-k1q1s);
d_q2s_dX = ((k2*d_k2q2s_dX-k2q2s*d_k2_dX)/k2/k2);
q2s = (k2q2s/k2);
}
else
{
if ((qsqs<(-0.005)))
{
{
double value_fabs_0 = fabs(qsqs);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqs)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_qsqs_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
}
else
{
if ((qsqs>0.005))
{
{
double value_fabs_0 = fabs(qsqs);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqs)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_qsqs_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
}
else
{
d_q_qcoth_dX = ((qsqs*0.1666666666667)*(-((qsqs*0.0166666666667)*(-d_qsqs_dX*0.0238095238095)+d_qsqs_dX*0.0166666666667*(1.0-(qsqs*0.0238095238095))))+d_qsqs_dX*0.1666666666667*(1.0-((qsqs*0.0166666666667)*(1.0-(qsqs*0.0238095238095)))));
q_qcoth = (2.0+((qsqs*0.1666666666667)*(1.0-((qsqs*0.0166666666667)*(1.0-(qsqs*0.0238095238095))))));
}
}
if ((((1.01*k1q1s)+q_qcoth)>0.0))
{
d_q_temp1_dX = (d_k1q1s_dX+d_q_qcoth_dX);
q_temp1 = (k1q1s+q_qcoth);
if (((Aexp1s*k1q1s)<(((0.9*k1q1s)*k1q1s)*q_temp1)))
{
instanceStruct.d_instanceVar_qis_dX = ((q_temp1*d_Aexp1s_dX-Aexp1s*d_q_temp1_dX)/q_temp1/q_temp1);
instanceStruct.instanceVar_qis = ((Aexp1s/q_temp1)+1.0e-80);
d_k2q2s_dX = (instanceStruct.d_instanceVar_qis_dX-d_k1q1s_dX);
k2q2s = (instanceStruct.instanceVar_qis-k1q1s);
d_q2s_dX = ((k2*d_k2q2s_dX-k2q2s*d_k2_dX)/k2/k2);
q2s = (k2q2s/k2);
}
else
{
if ((qsqs>0.005))
{
{
double value_log_0 = log(((4.0*qsqs)/(1.0-(q_invexpq*(2.0-q_invexpq)))));
double  deriv_log_0_d0 = (1.0/((4.0*qsqs)/(1.0-(q_invexpq*(2.0-q_invexpq)))));
d_q_temp2_dX = (deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqs_dX-(4.0*qsqs)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq)))))-d_q_rac_qsq_dX);
q_temp2 = (value_log_0-q_rac_qsq);
}
}
else
{
if ((qsqs<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp3_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp3 = value_sin_0;
}
{
double value_log_0 = log(((-qsqs)/(q_temp3*q_temp3)));
double  deriv_log_0_d0 = (1.0/((-qsqs)/(q_temp3*q_temp3)));
d_q_temp2_dX = deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqs_dX)-(-qsqs)*(q_temp3*d_q_temp3_dX+d_q_temp3_dX*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3)));
q_temp2 = value_log_0;
}
}
else
{
{
double value_log_0 = log((4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs)))))));
double  deriv_log_0_d0 = (1.0/(4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs)))))));
d_q_temp2_dX = deriv_log_0_d0*((-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dX)+0.05*d_qsqs_dX*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dX*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs)))))));
q_temp2 = value_log_0;
}
}
}
{
double value_log_0 = log(q_temp1);
double  deriv_log_0_d0 = (1.0/q_temp1);
d_q2s_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1s_dX)+2.0*deriv_log_0_d0*(d_q_temp1_dX))-d_q_temp2_dX);
q2s = ((((xg2x-xg1x)+q1s)+(2.0*value_log_0))-q_temp2);
}
d_k2q2s_dX = (k2*d_q2s_dX+d_k2_dX*q2s);
k2q2s = (k2*q2s);
instanceStruct.d_instanceVar_qis_dX = (d_k1q1s_dX+d_k2q2s_dX);
instanceStruct.instanceVar_qis = (k1q1s+k2q2s);
}
}
else
{
if ((qsqs>0.005))
{
if ((((q1s-xg1x)-q_rac_qsq)<80.0))
{
{
double value_exp_0 = exp(((q1s-xg1x)-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp3_dX = deriv_exp_0_d0*(((d_q1s_dX-d_xg1x_dX)-d_q_rac_qsq_dX));
q_temp3 = value_exp_0;
}
}
else
{
d_q_temp3_dX = 5.54062e34*((((q1s-xg1x)-q_rac_qsq)-80.0)*((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*((d_q1s_dX-d_xg1x_dX)-d_q_rac_qsq_dX)*0.3333333333333+0.5*((d_q1s_dX-d_xg1x_dX)-d_q_rac_qsq_dX)*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+((d_q1s_dX-d_xg1x_dX)-d_q_rac_qsq_dX)*(1.0+((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
q_temp3 = (5.54062e34*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*(1.0+((0.5*(((q1s-xg1x)-q_rac_qsq)-80.0))*(1.0+((((q1s-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))))));
}
d_q_temp2_dX = ((A0*d_q_temp3_dX-q_temp3*d_A0_dX)/A0/A0);
q_temp2 = (q_temp3/A0);
d_q_temp1_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqs)*d_q_temp2_dX+4.0*d_qsqs_dX*q_temp2)-((4.0*qsqs)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp1 = (((4.0*qsqs)*q_temp2)/(1.0-(q_invexpq*(2.0-q_invexpq))));
}
else
{
if ((qsqs<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_temp1_dX = ((Aexp1s*(((q_temp2*q_temp2)*(-d_qsqs_dX)-(-qsqs)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqs)/(q_temp2*q_temp2))*d_Aexp1s_dX)/Aexp1s/Aexp1s);
q_temp1 = (((-qsqs)/(q_temp2*q_temp2))/Aexp1s);
}
else
{
d_q_temp1_dX = ((Aexp1s*(-((qsqs*0.3333333333333)*(-((0.05*qsqs)*(-0.0396825396825397*d_qsqs_dX)+0.05*d_qsqs_dX*(1.0-(0.0396825396825397*qsqs))))+d_qsqs_dX*0.3333333333333*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))-(4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))*d_Aexp1s_dX)/Aexp1s/Aexp1s);
q_temp1 = ((4.0-((qsqs*0.3333333333333)*(1.0-((0.05*qsqs)*(1.0-(0.0396825396825397*qsqs))))))/Aexp1s);
}
}
instanceStruct.d_instanceVar_qis_dX = (((1.0-q_temp1)*(d_k1q1s_dX-d_q_qcoth_dX)-(k1q1s-q_qcoth)*(-d_q_temp1_dX))/(1.0-q_temp1)/(1.0-q_temp1));
instanceStruct.instanceVar_qis = (((k1q1s-q_qcoth)/(1.0-q_temp1))+1.0e-80);
d_k2q2s_dX = (instanceStruct.d_instanceVar_qis_dX-d_k1q1s_dX);
k2q2s = (instanceStruct.instanceVar_qis-k1q1s);
d_q2s_dX = ((k2*d_k2q2s_dX-k2q2s*d_k2_dX)/k2/k2);
q2s = (k2q2s/k2);
}
}
if ((((xg2x-q2s))<80.0))
{
{
double value_exp_0 = exp(((xg2x-q2s)));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*((d_xg2x_dX-d_q2s_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg2x-q2s))-80.0)*((0.5*(((xg2x-q2s))-80.0))*(d_xg2x_dX-d_q2s_dX)*0.3333333333333+0.5*(d_xg2x_dX-d_q2s_dX)*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))+(d_xg2x_dX-d_q2s_dX)*(1.0+((0.5*(((xg2x-q2s))-80.0))*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg2x-q2s))-80.0)*(1.0+((0.5*(((xg2x-q2s))-80.0))*(1.0+((((xg2x-q2s))-80.0)*0.3333333333333)))))));
}
d_Aexp2s_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
Aexp2s = (A0*q_temp1);
d_a1s_dX = 0.0;
a1s = 0.0;
d_a2s_dX = 0.0;
a2s = 0.0;
d_b1s_dX = 0.0;
b1s = 0.0;
d_b2s_dX = 0.0;
b2s = 0.0;
d_sums_dX = 0.0;
sums = 0.0;
d_dqsqs_dxn_qi_dX = 0.0;
dqsqs_dxn_qi = 0.0;
if ((instanceStruct.instanceVar_qis>1.0E-6))
{
d_b1s_dX = (Aexp1s*d_inv_k1_dX+d_Aexp1s_dX*inv_k1);
b1s = (Aexp1s*inv_k1);
d_b2s_dX = (Aexp2s*d_inv_k2_dX+d_Aexp2s_dX*inv_k2);
b2s = (Aexp2s*inv_k2);
d_a1s_dX = (d_b1s_dX+2.0*d_k1q1s_dX);
a1s = (b1s+(2.0*k1q1s));
d_a2s_dX = (d_b2s_dX+2.0*d_k2q2s_dX);
a2s = (b2s+(2.0*k2q2s));
d_sums_dX = ((2.0*instanceStruct.d_instanceVar_qis_dX+d_b1s_dX)+d_b2s_dX);
sums = (((2.0*instanceStruct.instanceVar_qis)+b1s)+b2s);
if ((fabs(qsqs)>0.005))
{
instanceStruct.d_instanceVar_temp1_dX = (((a1s*d_a2s_dX+d_a1s_dX*a2s)+((2.0*(q1s+2.0))*d_a2s_dX+2.0*d_q1s_dX*a2s))+((2.0*(q2s+2.0))*d_a1s_dX+2.0*d_q2s_dX*a1s));
instanceStruct.instanceVar_temp1 = (((a1s*a2s)+((2.0*(q1s+2.0))*a2s))+((2.0*(q2s+2.0))*a1s));
d_dqsqs_dxn_qi_dX = (((instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp1)*(((-4.0)*qsqs)*d_sums_dX+(-4.0)*d_qsqs_dX*sums)-(((-4.0)*qsqs)*sums)*(instanceStruct.instanceVar_qis*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_qis_dX*instanceStruct.instanceVar_temp1))/(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp1)/(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp1));
dqsqs_dxn_qi = ((((-4.0)*qsqs)*sums)/(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp1));
}
else
{
instanceStruct.d_instanceVar_temp1_dX = 0.1666666666667*(-((qsqs*0.0333333333333)*(-((qsqs*0.0357142857143)*(-d_qsqs_dX*0.0333333333333)+d_qsqs_dX*0.0357142857143*(1.0-(qsqs*0.0333333333333))))+d_qsqs_dX*0.0333333333333*(1.0-((qsqs*0.0357142857143)*(1.0-(qsqs*0.0333333333333))))));
instanceStruct.instanceVar_temp1 = (0.1666666666667*(1.0-((qsqs*0.0333333333333)*(1.0-((qsqs*0.0357142857143)*(1.0-(qsqs*0.0333333333333)))))));
instanceStruct.d_instanceVar_temp2_dX = (((a1s*d_Aexp1s_dX+d_a1s_dX*Aexp1s)+(a2s*d_Aexp2s_dX+d_a2s_dX*Aexp2s))+(((a1s*a2s)*instanceStruct.instanceVar_qis)*(instanceStruct.instanceVar_qis*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_qis_dX*instanceStruct.instanceVar_temp1)+((a1s*a2s)*instanceStruct.d_instanceVar_qis_dX+(a1s*d_a2s_dX+d_a1s_dX*a2s)*instanceStruct.instanceVar_qis)*(1.0+(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp1))));
instanceStruct.instanceVar_temp2 = (((a1s*Aexp1s)+(a2s*Aexp2s))+(((a1s*a2s)*instanceStruct.instanceVar_qis)*(1.0+(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp1))));
d_dqsqs_dxn_qi_dX = (((instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp2)*((Aexp1s*Aexp2s)*d_sums_dX+(Aexp1s*d_Aexp2s_dX+d_Aexp1s_dX*Aexp2s)*sums)-((Aexp1s*Aexp2s)*sums)*(instanceStruct.instanceVar_qis*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_qis_dX*instanceStruct.instanceVar_temp2))/(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp2)/(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp2));
dqsqs_dxn_qi = (((Aexp1s*Aexp2s)*sums)/(instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp2));
}
}
{
double value_log_0 = log(instanceStruct.instanceVar_qis);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_qis);
d_xdrifts_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_qis_dX);
xdrifts = value_log_0;
}
if (((k1q1s/2.0)<80.0))
{
{
double value_exp_0 = exp((k1q1s/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp1_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_k1q1s_dX/2.0)));
instanceStruct.instanceVar_temp1 = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = (d_k1q1s_dX/2.0);
instanceStruct.instanceVar_temp1 = (k1q1s/2.0);
}
d_esurf1s_dX = 2.0*instanceStruct.d_instanceVar_temp1_dX;
esurf1s = (2.0*instanceStruct.instanceVar_temp1);
if (((k2q2s/2.0)<80.0))
{
{
double value_exp_0 = exp((k2q2s/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp2_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_k2q2s_dX/2.0)));
instanceStruct.instanceVar_temp2 = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp2_dX = (d_k2q2s_dX/2.0);
instanceStruct.instanceVar_temp2 = (k2q2s/2.0);
}
d_esurf2s_dX = 2.0*instanceStruct.d_instanceVar_temp2_dX;
esurf2s = (2.0*instanceStruct.instanceVar_temp2);
d_ecpl1s_dX = (d_esurf2s_dX-d_k2q2s_dX);
ecpl1s = (esurf2s-k2q2s);
d_ecpl2s_dX = (d_esurf1s_dX-d_k1q1s_dX);
ecpl2s = (esurf1s-k1q1s);
d_eeff1s_dX = ((instanceStruct.instanceVar_eta_mu*d_esurf1s_dX+instanceStruct.d_instanceVar_eta_mu_dX*esurf1s)+(instanceStruct.instanceVar_one_m_eta*d_ecpl1s_dX+instanceStruct.d_instanceVar_one_m_eta_dX*ecpl1s));
eeff1s = ((instanceStruct.instanceVar_eta_mu*esurf1s)+(instanceStruct.instanceVar_one_m_eta*ecpl1s));
d_eeff2s_dX = ((instanceStruct.instanceVar_eta_mu*d_esurf2s_dX+instanceStruct.d_instanceVar_eta_mu_dX*esurf2s)+(instanceStruct.instanceVar_one_m_eta*d_ecpl2s_dX+instanceStruct.d_instanceVar_one_m_eta_dX*ecpl2s));
eeff2s = ((instanceStruct.instanceVar_eta_mu*esurf2s)+(instanceStruct.instanceVar_one_m_eta*ecpl2s));
instanceStruct.d_instanceVar_temp_dX = (((esurf1s+esurf2s)*instanceStruct.d_instanceVar_qis_dX-instanceStruct.instanceVar_qis*(d_esurf1s_dX+d_esurf2s_dX))/(esurf1s+esurf2s)/(esurf1s+esurf2s));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_qis/(esurf1s+esurf2s));
d_qi1s_dX = (esurf1s*instanceStruct.d_instanceVar_temp_dX+d_esurf1s_dX*instanceStruct.instanceVar_temp);
qi1s = (esurf1s*instanceStruct.instanceVar_temp);
d_qi2s_dX = (esurf2s*instanceStruct.d_instanceVar_temp_dX+d_esurf2s_dX*instanceStruct.instanceVar_temp);
qi2s = (esurf2s*instanceStruct.instanceVar_temp);
d_c1s_dX = (esurf1s*instanceStruct.d_instanceVar_BETN1_i_dX+d_esurf1s_dX*instanceStruct.instanceVar_BETN1_i);
c1s = (esurf1s*instanceStruct.instanceVar_BETN1_i);
d_c2s_dX = (esurf2s*instanceStruct.d_instanceVar_BETN2_i_dX+d_esurf2s_dX*instanceStruct.instanceVar_BETN2_i);
c2s = (esurf2s*instanceStruct.instanceVar_BETN2_i);
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_XCOR_i*(d_ecpl1s_dX+(instanceStruct.instanceVar_XCORB_i*d_ecpl2s_dX+instanceStruct.d_instanceVar_XCORB_i_dX*ecpl2s))+instanceStruct.d_instanceVar_XCOR_i_dX*(ecpl1s+(instanceStruct.instanceVar_XCORB_i*ecpl2s)));
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_XCOR_i*(ecpl1s+(instanceStruct.instanceVar_XCORB_i*ecpl2s)));
{
double value_sqrt_0 = sqrt(((((1.0+instanceStruct.instanceVar_temp1))*((1.0+instanceStruct.instanceVar_temp1)))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp2_dX = 0.5*(instanceStruct.d_instanceVar_temp1_dX+deriv_sqrt_0_d0*((((1.0+instanceStruct.instanceVar_temp1))*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_temp1_dX*((1.0+instanceStruct.instanceVar_temp1)))));
instanceStruct.instanceVar_temp2 = (0.5*((1.0+instanceStruct.instanceVar_temp1)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((1.0+(0.2*instanceStruct.instanceVar_temp1)))*((1.0+(0.2*instanceStruct.instanceVar_temp1))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp3_dX = 0.5*(0.2*instanceStruct.d_instanceVar_temp1_dX+deriv_sqrt_0_d0*((((1.0+(0.2*instanceStruct.instanceVar_temp1)))*0.2*instanceStruct.d_instanceVar_temp1_dX+0.2*instanceStruct.d_instanceVar_temp1_dX*((1.0+(0.2*instanceStruct.instanceVar_temp1))))));
instanceStruct.instanceVar_temp3 = (0.5*((1.0+(0.2*instanceStruct.instanceVar_temp1))+value_sqrt_0));
}
d_fcors_dX = ((instanceStruct.instanceVar_temp3*instanceStruct.d_instanceVar_temp2_dX-instanceStruct.instanceVar_temp2*instanceStruct.d_instanceVar_temp3_dX)/instanceStruct.instanceVar_temp3/instanceStruct.instanceVar_temp3);
fcors = (instanceStruct.instanceVar_temp2/instanceStruct.instanceVar_temp3);
{
double value_log_0 = log(((1.0+(qi1s*instanceStruct.instanceVar_inv_qi1cs))+(qi2s*instanceStruct.instanceVar_inv_qi2cs)));
double value_exp_1 = exp(((-instanceStruct.instanceVar_THECS_i)*value_log_0));
double  deriv_log_0_d0 = (1.0/((1.0+(qi1s*instanceStruct.instanceVar_inv_qi1cs))+(qi2s*instanceStruct.instanceVar_inv_qi2cs)));
double  deriv_exp_1_d0 = value_exp_1;
d_Gcss_dX = ((instanceStruct.instanceVar_CS_i*((1.0+(instanceStruct.instanceVar_CSFI_i*ecpl1s))+(instanceStruct.instanceVar_CSBI_i*ecpl2s)))*deriv_exp_1_d0*(((-instanceStruct.instanceVar_THECS_i)*deriv_log_0_d0*(((qi1s*instanceStruct.d_instanceVar_inv_qi1cs_dX+d_qi1s_dX*instanceStruct.instanceVar_inv_qi1cs)+(qi2s*instanceStruct.d_instanceVar_inv_qi2cs_dX+d_qi2s_dX*instanceStruct.instanceVar_inv_qi2cs)))+(-instanceStruct.d_instanceVar_THECS_i_dX)*value_log_0))+(instanceStruct.instanceVar_CS_i*((instanceStruct.instanceVar_CSFI_i*d_ecpl1s_dX+instanceStruct.d_instanceVar_CSFI_i_dX*ecpl1s)+(instanceStruct.instanceVar_CSBI_i*d_ecpl2s_dX+instanceStruct.d_instanceVar_CSBI_i_dX*ecpl2s))+instanceStruct.d_instanceVar_CS_i_dX*((1.0+(instanceStruct.instanceVar_CSFI_i*ecpl1s))+(instanceStruct.instanceVar_CSBI_i*ecpl2s)))*value_exp_1);
Gcss = ((instanceStruct.instanceVar_CS_i*((1.0+(instanceStruct.instanceVar_CSFI_i*ecpl1s))+(instanceStruct.instanceVar_CSBI_i*ecpl2s)))*value_exp_1);
}
if ((instanceStruct.instanceVar_RSG_i==0.0))
{
instanceStruct.d_instanceVar_temp3_dX = 0.0;
instanceStruct.instanceVar_temp3 = 1.0;
}
else
{
if ((instanceStruct.instanceVar_RSG_i<0.0))
{
{
double value_log_0 = log((instanceStruct.instanceVar_qis+1.0e-12));
double value_exp_1 = exp((instanceStruct.instanceVar_THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_qis+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_RSG_i*deriv_exp_1_d0*((instanceStruct.instanceVar_THERSG_i*deriv_log_0_d0*(instanceStruct.d_instanceVar_qis_dX)+instanceStruct.d_instanceVar_THERSG_i_dX*value_log_0))+instanceStruct.d_instanceVar_RSG_i_dX*value_exp_1);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_RSG_i*value_exp_1);
}
instanceStruct.d_instanceVar_temp3_dX = (-instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp3 = (1.0-instanceStruct.instanceVar_temp1);
}
else
{
{
double value_log_0 = log((instanceStruct.instanceVar_qis+1.0e-12));
double value_exp_1 = exp((instanceStruct.instanceVar_THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_qis+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_RSG_i*deriv_exp_1_d0*((instanceStruct.instanceVar_THERSG_i*deriv_log_0_d0*(instanceStruct.d_instanceVar_qis_dX)+instanceStruct.d_instanceVar_THERSG_i_dX*value_log_0))+instanceStruct.d_instanceVar_RSG_i_dX*value_exp_1);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_RSG_i*value_exp_1);
}
instanceStruct.d_instanceVar_temp3_dX = (-instanceStruct.d_instanceVar_temp1_dX/(1.0+instanceStruct.instanceVar_temp1)/(1.0+instanceStruct.instanceVar_temp1));
instanceStruct.instanceVar_temp3 = (1.0/(1.0+instanceStruct.instanceVar_temp1));
}
}
{
double value_sqrt_0 = sqrt(((((1.0-(instanceStruct.instanceVar_RSB_i*xg20)))*((1.0-(instanceStruct.instanceVar_RSB_i*xg20))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_frscsi_dX = (((instanceStruct.instanceVar_frs*instanceStruct.instanceVar_CsiPrime)*0.5)*((-(instanceStruct.instanceVar_RSB_i*d_xg20_dX+instanceStruct.d_instanceVar_RSB_i_dX*xg20))+deriv_sqrt_0_d0*((((1.0-(instanceStruct.instanceVar_RSB_i*xg20)))*(-(instanceStruct.instanceVar_RSB_i*d_xg20_dX+instanceStruct.d_instanceVar_RSB_i_dX*xg20))+(-(instanceStruct.instanceVar_RSB_i*d_xg20_dX+instanceStruct.d_instanceVar_RSB_i_dX*xg20))*((1.0-(instanceStruct.instanceVar_RSB_i*xg20))))))+(instanceStruct.instanceVar_frs*instanceStruct.d_instanceVar_CsiPrime_dX+instanceStruct.d_instanceVar_frs_dX*instanceStruct.instanceVar_CsiPrime)*0.5*((1.0-(instanceStruct.instanceVar_RSB_i*xg20))+value_sqrt_0));
frscsi = (((instanceStruct.instanceVar_frs*instanceStruct.instanceVar_CsiPrime)*0.5)*((1.0-(instanceStruct.instanceVar_RSB_i*xg20))+value_sqrt_0));
}
d_Grss_dX = (frscsi*((instanceStruct.instanceVar_qis*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_qis_dX*instanceStruct.instanceVar_temp3)+instanceStruct.d_instanceVar_RSIG_i_dX)+d_frscsi_dX*((instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp3)+instanceStruct.instanceVar_RSIG_i));
Grss = (frscsi*((instanceStruct.instanceVar_qis*instanceStruct.instanceVar_temp3)+instanceStruct.instanceVar_RSIG_i));
{
double value_log_0 = log(((instanceStruct.instanceVar_fmue*eeff1s)+1.0e-6));
double value_exp_1 = exp((instanceStruct.instanceVar_THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_fmue*eeff1s)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;
d_Gmob1s_dX = ((deriv_exp_1_d0*((instanceStruct.instanceVar_THEMU_i*deriv_log_0_d0*((instanceStruct.instanceVar_fmue*d_eeff1s_dX+instanceStruct.d_instanceVar_fmue_dX*eeff1s))+instanceStruct.d_instanceVar_THEMU_i_dX*value_log_0))+d_Gcss_dX)+(instanceStruct.instanceVar_BETN1_i*d_Grss_dX+instanceStruct.d_instanceVar_BETN1_i_dX*Grss));
Gmob1s = (((1.0+value_exp_1)+Gcss)+(instanceStruct.instanceVar_BETN1_i*Grss));
}
{
double value_log_0 = log(((instanceStruct.instanceVar_fmue*eeff2s)+1.0e-6));
double value_exp_1 = exp((instanceStruct.instanceVar_THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_fmue*eeff2s)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;
d_Gmob2s_dX = ((deriv_exp_1_d0*((instanceStruct.instanceVar_THEMU_i*deriv_log_0_d0*((instanceStruct.instanceVar_fmue*d_eeff2s_dX+instanceStruct.d_instanceVar_fmue_dX*eeff2s))+instanceStruct.d_instanceVar_THEMU_i_dX*value_log_0))+d_Gcss_dX)+(instanceStruct.instanceVar_BETN2_i*d_Grss_dX+instanceStruct.d_instanceVar_BETN2_i_dX*Grss));
Gmob2s = (((1.0+value_exp_1)+Gcss)+(instanceStruct.instanceVar_BETN2_i*Grss));
}
d_Gmobs_dX = ((((c1s/Gmob1s)+(c2s/Gmob2s))*(fcors*(d_c1s_dX+d_c2s_dX)+d_fcors_dX*(c1s+c2s))-(fcors*(c1s+c2s))*(((Gmob1s*d_c1s_dX-c1s*d_Gmob1s_dX)/Gmob1s/Gmob1s)+((Gmob2s*d_c2s_dX-c2s*d_Gmob2s_dX)/Gmob2s/Gmob2s)))/((c1s/Gmob1s)+(c2s/Gmob2s))/((c1s/Gmob1s)+(c2s/Gmob2s)));
Gmobs = ((fcors*(c1s+c2s))/((c1s/Gmob1s)+(c2s/Gmob2s)));
if ((fabs(Dx_WI)>0.007))
{
if ((Dx_WI>0.0))
{
{
double value_exp_0 = exp((-Dx_WI));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp_dX = deriv_exp_0_d0*((-d_Dx_WI_dX));
instanceStruct.instanceVar_temp = value_exp_0;
}
d_s1_dX = (((1.0-instanceStruct.instanceVar_temp)*d_Dx_WI_dX-Dx_WI*(-instanceStruct.d_instanceVar_temp_dX))/(1.0-instanceStruct.instanceVar_temp)/(1.0-instanceStruct.instanceVar_temp));
s1 = (Dx_WI/(1.0-instanceStruct.instanceVar_temp));
d_s2_dX = (instanceStruct.instanceVar_temp*d_s1_dX+instanceStruct.d_instanceVar_temp_dX*s1);
s2 = (instanceStruct.instanceVar_temp*s1);
{
double value_log_0 = log((A0/(instanceStruct.instanceVar_qis*s1)));
double  deriv_log_0_d0 = (1.0/(A0/(instanceStruct.instanceVar_qis*s1)));
d_deltaxinf_dX = (deriv_log_0_d0*((((instanceStruct.instanceVar_qis*s1)*d_A0_dX-A0*(instanceStruct.instanceVar_qis*d_s1_dX+instanceStruct.d_instanceVar_qis_dX*s1))/(instanceStruct.instanceVar_qis*s1)/(instanceStruct.instanceVar_qis*s1)))+d_x1_WI0_dX);
deltaxinf = ((value_log_0-0.6931471805599)+x1_WI0);
}
}
else
{
{
double value_exp_0 = exp(Dx_WI);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp_dX = deriv_exp_0_d0*(d_Dx_WI_dX);
instanceStruct.instanceVar_temp = value_exp_0;
}
d_s2_dX = (((instanceStruct.instanceVar_temp-1.0)*d_Dx_WI_dX-Dx_WI*instanceStruct.d_instanceVar_temp_dX)/(instanceStruct.instanceVar_temp-1.0)/(instanceStruct.instanceVar_temp-1.0));
s2 = (Dx_WI/(instanceStruct.instanceVar_temp-1.0));
d_s1_dX = (instanceStruct.instanceVar_temp*d_s2_dX+instanceStruct.d_instanceVar_temp_dX*s2);
s1 = (instanceStruct.instanceVar_temp*s2);
{
double value_log_0 = log((A0/(instanceStruct.instanceVar_qis*s2)));
double  deriv_log_0_d0 = (1.0/(A0/(instanceStruct.instanceVar_qis*s2)));
d_deltaxinf_dX = (deriv_log_0_d0*((((instanceStruct.instanceVar_qis*s2)*d_A0_dX-A0*(instanceStruct.instanceVar_qis*d_s2_dX+instanceStruct.d_instanceVar_qis_dX*s2))/(instanceStruct.instanceVar_qis*s2)/(instanceStruct.instanceVar_qis*s2)))+d_x2_WI0_dX);
deltaxinf = ((value_log_0-0.6931471805599)+x2_WI0);
}
}
d_q1chapinf_dX = (((keq*((1.0-s1)-(Dx_WI*inv_k2)))*(-d_Dx_WI_dX)-(-Dx_WI)*(keq*((-d_s1_dX)-(Dx_WI*d_inv_k2_dX+d_Dx_WI_dX*inv_k2))+d_keq_dX*((1.0-s1)-(Dx_WI*inv_k2))))/(keq*((1.0-s1)-(Dx_WI*inv_k2)))/(keq*((1.0-s1)-(Dx_WI*inv_k2))));
q1chapinf = ((-Dx_WI)/(keq*((1.0-s1)-(Dx_WI*inv_k2))));
d_q2chapinf_dX = (((keq*((1.0-s2)+(Dx_WI*inv_k1)))*d_Dx_WI_dX-Dx_WI*(keq*((-d_s2_dX)+(Dx_WI*d_inv_k1_dX+d_Dx_WI_dX*inv_k1))+d_keq_dX*((1.0-s2)+(Dx_WI*inv_k1))))/(keq*((1.0-s2)+(Dx_WI*inv_k1)))/(keq*((1.0-s2)+(Dx_WI*inv_k1))));
q2chapinf = (Dx_WI/(keq*((1.0-s2)+(Dx_WI*inv_k1))));
d_dinf_dX = ((((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))*d_Dx_WI_dX-Dx_WI*(((q2chapinf*(s2*d_inv_k2_dX+d_s2_dX*inv_k2)-((s2*inv_k2)+0.5)*d_q2chapinf_dX)/q2chapinf/q2chapinf)-((q1chapinf*(s1*d_inv_k1_dX+d_s1_dX*inv_k1)-((s1*inv_k1)+0.5)*d_q1chapinf_dX)/q1chapinf/q1chapinf)))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf))/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf)));
dinf = (Dx_WI/((((s2*inv_k2)+0.5)/q2chapinf)-(((s1*inv_k1)+0.5)/q1chapinf)));
}
else
{
instanceStruct.d_instanceVar_temp_dX = (0.5*0.1666666666667)*d_Dx_WIsq_dX;
instanceStruct.instanceVar_temp = ((0.5*0.1666666666667)*Dx_WIsq);
instanceStruct.d_instanceVar_temp1_dX = 0.5*d_Dx_WI_dX;
instanceStruct.instanceVar_temp1 = (0.5*Dx_WI);
d_s1_dX = (instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_temp_dX);
s1 = ((1.0+instanceStruct.instanceVar_temp1)+instanceStruct.instanceVar_temp);
d_s2_dX = ((-instanceStruct.d_instanceVar_temp1_dX)+instanceStruct.d_instanceVar_temp_dX);
s2 = ((1.0-instanceStruct.instanceVar_temp1)+instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_temp2_dX = 0.1666666666667*instanceStruct.d_instanceVar_temp1_dX;
instanceStruct.instanceVar_temp2 = (0.1666666666667*instanceStruct.instanceVar_temp1);
d_q1chapinf_dX = (-(keq*(d_inv_k2_dX+instanceStruct.d_instanceVar_temp2_dX)+d_keq_dX*((0.5+inv_k2)+instanceStruct.instanceVar_temp2))/(keq*((0.5+inv_k2)+instanceStruct.instanceVar_temp2))/(keq*((0.5+inv_k2)+instanceStruct.instanceVar_temp2)));
q1chapinf = (1.0/(keq*((0.5+inv_k2)+instanceStruct.instanceVar_temp2)));
d_q2chapinf_dX = (-(keq*(d_inv_k1_dX-instanceStruct.d_instanceVar_temp2_dX)+d_keq_dX*((0.5+inv_k1)-instanceStruct.instanceVar_temp2))/(keq*((0.5+inv_k1)-instanceStruct.instanceVar_temp2))/(keq*((0.5+inv_k1)-instanceStruct.instanceVar_temp2)));
q2chapinf = (1.0/(keq*((0.5+inv_k1)-instanceStruct.instanceVar_temp2)));
{
double value_log_0 = log((A0/(instanceStruct.instanceVar_qis*(1.0-(0.5*instanceStruct.instanceVar_temp)))));
double  deriv_log_0_d0 = (1.0/(A0/(instanceStruct.instanceVar_qis*(1.0-(0.5*instanceStruct.instanceVar_temp)))));
d_deltaxinf_dX = (deriv_log_0_d0*((((instanceStruct.instanceVar_qis*(1.0-(0.5*instanceStruct.instanceVar_temp)))*d_A0_dX-A0*(instanceStruct.instanceVar_qis*(-0.5*instanceStruct.d_instanceVar_temp_dX)+instanceStruct.d_instanceVar_qis_dX*(1.0-(0.5*instanceStruct.instanceVar_temp))))/(instanceStruct.instanceVar_qis*(1.0-(0.5*instanceStruct.instanceVar_temp)))/(instanceStruct.instanceVar_qis*(1.0-(0.5*instanceStruct.instanceVar_temp)))))+0.5*(d_x1_WI0_dX+d_x2_WI0_dX));
deltaxinf = ((value_log_0-0.6931471805599)+(0.5*(x1_WI0+x2_WI0)));
}
d_dinf_dX = (-(-12.0)*((((-3.0*d_keq_dX)+(((instanceStruct.instanceVar_k1*k2)*12.0*d_keq_dX-(12.0*keq)*(instanceStruct.instanceVar_k1*d_k2_dX+instanceStruct.d_instanceVar_k1_dX*k2))/(instanceStruct.instanceVar_k1*k2)/(instanceStruct.instanceVar_k1*k2)))+((keq*(inv_k1-inv_k2))*d_Dx_WI_dX+(keq*(d_inv_k1_dX-d_inv_k2_dX)+d_keq_dX*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*d_Dx_WIsq_dX+0.3333333333333*(-0.25*d_keq_dX)*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(instanceStruct.instanceVar_k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq))/((((4.0-(3.0*keq))+((12.0*keq)/(instanceStruct.instanceVar_k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq)));
dinf = ((-12.0)/((((4.0-(3.0*keq))+((12.0*keq)/(instanceStruct.instanceVar_k1*k2)))+((keq*(inv_k1-inv_k2))*Dx_WI))+((0.3333333333333*(0.2-(0.25*keq)))*Dx_WIsq)));
}
d_inv_dinf_dX = (-d_dinf_dX/dinf/dinf);
inv_dinf = (1.0/dinf);
if ((instanceStruct.instanceVar_qis>1.0E-6))
{
d_wsat1_dX = (((100.0+esurf1s)*100.0*d_esurf1s_dX-(100.0*esurf1s)*d_esurf1s_dX)/(100.0+esurf1s)/(100.0+esurf1s));
wsat1 = ((100.0*esurf1s)/(100.0+esurf1s));
if ((instanceStruct.instanceVar_THESAT1_i<0.0))
{
d_sat_fact1_dX = (-(-(instanceStruct.instanceVar_THESAT1_i*d_wsat1_dX+instanceStruct.d_instanceVar_THESAT1_i_dX*wsat1))/(1.0-(instanceStruct.instanceVar_THESAT1_i*wsat1))/(1.0-(instanceStruct.instanceVar_THESAT1_i*wsat1)));
sat_fact1 = (1.0/(1.0-(instanceStruct.instanceVar_THESAT1_i*wsat1)));
}
else
{
d_sat_fact1_dX = (instanceStruct.instanceVar_THESAT1_i*d_wsat1_dX+instanceStruct.d_instanceVar_THESAT1_i_dX*wsat1);
sat_fact1 = (1.0+(instanceStruct.instanceVar_THESAT1_i*wsat1));
}
d_wsat2_dX = (((100.0+esurf2s)*100.0*d_esurf2s_dX-(100.0*esurf2s)*d_esurf2s_dX)/(100.0+esurf2s)/(100.0+esurf2s));
wsat2 = ((100.0*esurf2s)/(100.0+esurf2s));
if ((instanceStruct.instanceVar_THESAT2_i<0.0))
{
d_sat_fact2_dX = (-(-(instanceStruct.instanceVar_THESAT2_i*d_wsat2_dX+instanceStruct.d_instanceVar_THESAT2_i_dX*wsat2))/(1.0-(instanceStruct.instanceVar_THESAT2_i*wsat2))/(1.0-(instanceStruct.instanceVar_THESAT2_i*wsat2)));
sat_fact2 = (1.0/(1.0-(instanceStruct.instanceVar_THESAT2_i*wsat2)));
}
else
{
d_sat_fact2_dX = (instanceStruct.instanceVar_THESAT2_i*d_wsat2_dX+instanceStruct.d_instanceVar_THESAT2_i_dX*wsat2);
sat_fact2 = (1.0+(instanceStruct.instanceVar_THESAT2_i*wsat2));
}
d_dqis_dxn_qi_dX = ((((a1s*a2s)*(dqsqs_dxn_qi*d_sums_dX+d_dqsqs_dxn_qi_dX*sums)-(dqsqs_dxn_qi*sums)*(a1s*d_a2s_dX+d_a1s_dX*a2s))/(a1s*a2s)/(a1s*a2s))-((instanceStruct.instanceVar_qis*(((a1s*d_Aexp1s_dX-Aexp1s*d_a1s_dX)/a1s/a1s)+((a2s*d_Aexp2s_dX-Aexp2s*d_a2s_dX)/a2s/a2s))-((Aexp1s/a1s)+(Aexp2s/a2s))*instanceStruct.d_instanceVar_qis_dX)/instanceStruct.instanceVar_qis/instanceStruct.instanceVar_qis));
dqis_dxn_qi = (((dqsqs_dxn_qi*sums)/(a1s*a2s))-(((Aexp1s/a1s)+(Aexp2s/a2s))/instanceStruct.instanceVar_qis));
instanceStruct.d_instanceVar_ds_dX = (((dqis_dxn_qi+1.0)*(dqis_dxn_qi*instanceStruct.d_instanceVar_qis_dX+d_dqis_dxn_qi_dX*instanceStruct.instanceVar_qis)-(dqis_dxn_qi*instanceStruct.instanceVar_qis)*d_dqis_dxn_qi_dX)/(dqis_dxn_qi+1.0)/(dqis_dxn_qi+1.0));
instanceStruct.instanceVar_ds = ((dqis_dxn_qi*instanceStruct.instanceVar_qis)/(dqis_dxn_qi+1.0));
instanceStruct.d_instanceVar_temp1_dX = (d_dinf_dX-instanceStruct.d_instanceVar_ds_dX);
instanceStruct.instanceVar_temp1 = (dinf-instanceStruct.instanceVar_ds);
d_deltaxi_dX = ((instanceStruct.instanceVar_temp1*(instanceStruct.d_instanceVar_qis_dX+(dinf*d_deltaxinf_dX+d_dinf_dX*deltaxinf))-(instanceStruct.instanceVar_qis+(dinf*deltaxinf))*instanceStruct.d_instanceVar_temp1_dX)/instanceStruct.instanceVar_temp1/instanceStruct.instanceVar_temp1);
deltaxi = ((instanceStruct.instanceVar_qis+(dinf*deltaxinf))/instanceStruct.instanceVar_temp1);
{
double value_sqrt_0 = sqrt(((deltaxi*deltaxi)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_deltaxi_dX = 0.5*(d_deltaxi_dX+deriv_sqrt_0_d0*((deltaxi*d_deltaxi_dX+d_deltaxi_dX*deltaxi)));
deltaxi = (0.5*(deltaxi+value_sqrt_0));
}
d_gamma_dX = (((instanceStruct.instanceVar_sat_phit/Gmobs)*0.5)*(d_sat_fact1_dX+d_sat_fact2_dX)+((Gmobs*instanceStruct.d_instanceVar_sat_phit_dX-instanceStruct.instanceVar_sat_phit*d_Gmobs_dX)/Gmobs/Gmobs)*0.5*(sat_fact1+sat_fact2));
gamma = (((instanceStruct.instanceVar_sat_phit/Gmobs)*0.5)*(sat_fact1+sat_fact2));
d_vs_dX = (-((instanceStruct.instanceVar_ds*instanceStruct.d_instanceVar_qis_dX-instanceStruct.instanceVar_qis*instanceStruct.d_instanceVar_ds_dX)/instanceStruct.instanceVar_ds/instanceStruct.instanceVar_ds));
vs = (1.0-(instanceStruct.instanceVar_qis/instanceStruct.instanceVar_ds));
d_vd_dX = d_deltaxinf_dX;
vd = (1.0+deltaxinf);
d_wd_dX = ((((((2.0*instanceStruct.instanceVar_ds)-instanceStruct.instanceVar_qis)*inv_dinf)-2.0)-deltaxinf)*d_deltaxi_dX+((((2.0*instanceStruct.instanceVar_ds)-instanceStruct.instanceVar_qis)*d_inv_dinf_dX+(2.0*instanceStruct.d_instanceVar_ds_dX-instanceStruct.d_instanceVar_qis_dX)*inv_dinf)-d_deltaxinf_dX)*deltaxi);
wd = ((((((2.0*instanceStruct.instanceVar_ds)-instanceStruct.instanceVar_qis)*inv_dinf)-2.0)-deltaxinf)*deltaxi);
if ((gamma>1.0e-14))
{
d_ps_cub_dX = (-2.0*(gamma*d_gamma_dX+d_gamma_dX*gamma)/(gamma*gamma)/(gamma*gamma));
ps_cub = (2.0/(gamma*gamma));
d_qs_cub_dX = (ps_cub*d_vs_dX+d_ps_cub_dX*vs);
qs_cub = (ps_cub*vs);
d_pd_cub_dX = (d_ps_cub_dX+d_wd_dX);
pd_cub = (ps_cub+wd);
d_qd_cub_dX = (ps_cub*d_vd_dX+d_ps_cub_dX*vd);
qd_cub = (ps_cub*vd);
{
double value_sqrt_0 = sqrt((((qs_cub*qs_cub)+(((0.148148148148*ps_cub)*ps_cub)*ps_cub))+1.0e-20));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_racs_dX = deriv_sqrt_0_d0*(((qs_cub*d_qs_cub_dX+d_qs_cub_dX*qs_cub)+(((0.148148148148*ps_cub)*ps_cub)*d_ps_cub_dX+((0.148148148148*ps_cub)*d_ps_cub_dX+0.148148148148*d_ps_cub_dX*ps_cub)*ps_cub)));
racs = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((((qd_cub*qd_cub)+(((0.148148148148*pd_cub)*pd_cub)*pd_cub))+1.0e-20));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_racd_dX = deriv_sqrt_0_d0*(((qd_cub*d_qd_cub_dX+d_qd_cub_dX*qd_cub)+(((0.148148148148*pd_cub)*pd_cub)*d_pd_cub_dX+((0.148148148148*pd_cub)*d_pd_cub_dX+0.148148148148*d_pd_cub_dX*pd_cub)*pd_cub)));
racd = value_sqrt_0;
}
{
double value_log_0 = log((0.5*(racs+qs_cub)));
double value_exp_1 = exp((0.3333333333333*value_log_0));
double value_log_2 = log((0.5*(racs-qs_cub)));
double value_exp_3 = exp((0.3333333333333*value_log_2));
double  deriv_log_0_d0 = (1.0/(0.5*(racs+qs_cub)));
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(0.5*(racs-qs_cub)));
double  deriv_exp_3_d0 = value_exp_3;
d_deltaxsats_dX = (deriv_exp_1_d0*(0.3333333333333*deriv_log_0_d0*(0.5*(d_racs_dX+d_qs_cub_dX)))-deriv_exp_3_d0*(0.3333333333333*deriv_log_2_d0*(0.5*(d_racs_dX-d_qs_cub_dX))));
deltaxsats = (value_exp_1-value_exp_3);
}
{
double value_log_0 = log((0.5*(racd+qd_cub)));
double value_exp_1 = exp((0.3333333333333*value_log_0));
double value_log_2 = log((0.5*(racd-qd_cub)));
double value_exp_3 = exp((0.3333333333333*value_log_2));
double  deriv_log_0_d0 = (1.0/(0.5*(racd+qd_cub)));
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(0.5*(racd-qd_cub)));
double  deriv_exp_3_d0 = value_exp_3;
d_deltaxsatd_dX = (deriv_exp_1_d0*(0.3333333333333*deriv_log_0_d0*(0.5*(d_racd_dX+d_qd_cub_dX)))-deriv_exp_3_d0*(0.3333333333333*deriv_log_2_d0*(0.5*(d_racd_dX-d_qd_cub_dX))));
deltaxsatd = (value_exp_1-value_exp_3);
}
}
else
{
d_deltaxsats_dX = d_vs_dX;
deltaxsats = vs;
d_deltaxsatd_dX = d_vd_dX;
deltaxsatd = vd;
}
instanceStruct.d_instanceVar_temp3_dX = (instanceStruct.instanceVar_temp1*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_temp1);
instanceStruct.instanceVar_temp3 = (instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp1);
{
double value_sqrt_0 = sqrt((((deltaxsats-deltaxsatd)*(deltaxsats-deltaxsatd))+(10.0*instanceStruct.instanceVar_temp3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_deltaxsat_dX = (0.94*0.5)*((d_deltaxsats_dX+d_deltaxsatd_dX)+deriv_sqrt_0_d0*((((deltaxsats-deltaxsatd)*(d_deltaxsats_dX-d_deltaxsatd_dX)+(d_deltaxsats_dX-d_deltaxsatd_dX)*(deltaxsats-deltaxsatd))+10.0*instanceStruct.d_instanceVar_temp3_dX)));
deltaxsat = ((0.94*0.5)*((deltaxsats+deltaxsatd)+value_sqrt_0));
}
d_qidsats_dX = (instanceStruct.d_instanceVar_qis_dX+(instanceStruct.instanceVar_ds*d_deltaxsat_dX+instanceStruct.d_instanceVar_ds_dX*deltaxsat));
qidsats = (instanceStruct.instanceVar_qis+(instanceStruct.instanceVar_ds*deltaxsat));
d_qidsatd_dX = (dinf*(d_deltaxsat_dX-d_deltaxinf_dX)+d_dinf_dX*(deltaxsat-deltaxinf));
qidsatd = (dinf*(deltaxsat-deltaxinf));
{
double value_sqrt_0 = sqrt((((qidsats-qidsatd)*(qidsats-qidsatd))+(36.0*instanceStruct.instanceVar_temp3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qidsat_dX = 0.5*((d_qidsats_dX+d_qidsatd_dX)+deriv_sqrt_0_d0*((((qidsats-qidsatd)*(d_qidsats_dX-d_qidsatd_dX)+(d_qidsats_dX-d_qidsatd_dX)*(qidsats-qidsatd))+36.0*instanceStruct.d_instanceVar_temp3_dX)));
qidsat = (0.5*((qidsats+qidsatd)+value_sqrt_0));
}
}
else
{
instanceStruct.d_instanceVar_ds_dX = d_dinf_dX;
instanceStruct.instanceVar_ds = dinf;
d_deltaxsat_dX = 0.94*d_deltaxinf_dX;
deltaxsat = (0.94*(1.0+deltaxinf));
d_qidsat_dX = (0.5*instanceStruct.d_instanceVar_qis_dX+(dinf*(d_deltaxsat_dX-0.5*d_deltaxinf_dX)+d_dinf_dX*(deltaxsat-(0.5*deltaxinf))));
qidsat = ((0.5*instanceStruct.instanceVar_qis)+(dinf*(deltaxsat-(0.5*deltaxinf))));
}
if (((qidsat-0.5)<80.0))
{
{
double value_exp_0 = exp((qidsat-0.5));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp1_dX = deriv_log_1_d0*(deriv_exp_0_d0*(d_qidsat_dX));
instanceStruct.instanceVar_temp1 = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = d_qidsat_dX;
instanceStruct.instanceVar_temp1 = (qidsat-0.5);
}
instanceStruct.d_instanceVar_temp2_dX = instanceStruct.d_instanceVar_temp1_dX;
instanceStruct.instanceVar_temp2 = (instanceStruct.instanceVar_temp1+0.5);
{
double value_log_0 = log((instanceStruct.instanceVar_qis/instanceStruct.instanceVar_temp2));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_qis/instanceStruct.instanceVar_temp2));
instanceStruct.d_instanceVar_temp3_dX = (d_deltaxsat_dX+deriv_log_0_d0*(((instanceStruct.instanceVar_temp2*instanceStruct.d_instanceVar_qis_dX-instanceStruct.instanceVar_qis*instanceStruct.d_instanceVar_temp2_dX)/instanceStruct.instanceVar_temp2/instanceStruct.instanceVar_temp2)));
instanceStruct.instanceVar_temp3 = (deltaxsat+value_log_0);
}
if (((instanceStruct.instanceVar_temp3-6.0)<80.0))
{
{
double value_exp_0 = exp((instanceStruct.instanceVar_temp3-6.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp1_dX = deriv_log_1_d0*(deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp3_dX));
instanceStruct.instanceVar_temp1 = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = instanceStruct.d_instanceVar_temp3_dX;
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_temp3-6.0);
}
instanceStruct.d_instanceVar_temp3_dX = instanceStruct.d_instanceVar_temp1_dX;
instanceStruct.instanceVar_temp3 = (instanceStruct.instanceVar_temp1+6.0);
if (((600.0-instanceStruct.instanceVar_temp3)<80.0))
{
{
double value_exp_0 = exp((600.0-instanceStruct.instanceVar_temp3));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp1_dX = deriv_log_1_d0*(deriv_exp_0_d0*((-instanceStruct.d_instanceVar_temp3_dX)));
instanceStruct.instanceVar_temp1 = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = (-instanceStruct.d_instanceVar_temp3_dX);
instanceStruct.instanceVar_temp1 = (600.0-instanceStruct.instanceVar_temp3);
}
d_xndssat_dX = (-instanceStruct.d_instanceVar_temp1_dX);
xndssat = (600.0-instanceStruct.instanceVar_temp1);
instanceStruct.d_instanceVar_temp1_dX = ((xndssat*d_xd_dX-xd*d_xndssat_dX)/xndssat/xndssat);
instanceStruct.instanceVar_temp1 = (xd/xndssat);
instanceStruct.d_instanceVar_temp2_dX = (instanceStruct.instanceVar_temp1*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_temp1);
instanceStruct.instanceVar_temp2 = (instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp1);
instanceStruct.d_instanceVar_temp3_dX = (instanceStruct.instanceVar_temp2*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_temp2_dX*instanceStruct.instanceVar_temp2);
instanceStruct.instanceVar_temp3 = (instanceStruct.instanceVar_temp2*instanceStruct.instanceVar_temp2);
instanceStruct.d_instanceVar_temp4_dX = (instanceStruct.instanceVar_temp3*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_temp3_dX*instanceStruct.instanceVar_temp3);
instanceStruct.instanceVar_temp4 = (instanceStruct.instanceVar_temp3*instanceStruct.instanceVar_temp3);
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_gamAX*instanceStruct.instanceVar_temp3)));
double value_exp_1 = exp((2.666666666667*value_log_0));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_gamAX*instanceStruct.instanceVar_temp3)));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp_dX = deriv_exp_1_d0*(2.666666666667*deriv_log_0_d0*((instanceStruct.instanceVar_gamAX*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_gamAX_dX*instanceStruct.instanceVar_temp3)));
instanceStruct.instanceVar_temp = value_exp_1;
}
{
double value_log_0 = log((instanceStruct.instanceVar_temp+(instanceStruct.instanceVar_temp4*instanceStruct.instanceVar_temp4)));
double value_exp_1 = exp(((-0.0625)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_temp+(instanceStruct.instanceVar_temp4*instanceStruct.instanceVar_temp4)));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_xdeff_dX = (xd*deriv_exp_1_d0*((-0.0625)*deriv_log_0_d0*((instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_temp4*instanceStruct.d_instanceVar_temp4_dX+instanceStruct.d_instanceVar_temp4_dX*instanceStruct.instanceVar_temp4))))+d_xd_dX*value_exp_1);
instanceStruct.instanceVar_xdeff = (xd*value_exp_1);
}
d_q_temp1_dX = (-instanceStruct.d_instanceVar_k1_dX/(instanceStruct.instanceVar_k1+1.0)/(instanceStruct.instanceVar_k1+1.0));
q_temp1 = (1.0/(instanceStruct.instanceVar_k1+1.0));
d_q_temp2_dX = (-d_k2_dX/(k2+1.0)/(k2+1.0));
q_temp2 = (1.0/(k2+1.0));
{
double value_log_0 = log((((instanceStruct.instanceVar_k1+(k2*q_temp2))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((instanceStruct.instanceVar_k1+(k2*q_temp2))*diff_min)/A0));
d_q_x1sat_dX = (deriv_log_0_d0*(((A0*((instanceStruct.instanceVar_k1+(k2*q_temp2))*d_diff_min_dX+(instanceStruct.d_instanceVar_k1_dX+(k2*d_q_temp2_dX+d_k2_dX*q_temp2))*diff_min)-((instanceStruct.instanceVar_k1+(k2*q_temp2))*diff_min)*d_A0_dX)/A0/A0))+instanceStruct.d_instanceVar_xdeff_dX);
q_x1sat = ((value_log_0+instanceStruct.instanceVar_xdeff)+3.0);
}
{
double value_log_0 = log((((k2+(instanceStruct.instanceVar_k1*q_temp1))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k2+(instanceStruct.instanceVar_k1*q_temp1))*diff_min)/A0));
d_q_x2sat_dX = (deriv_log_0_d0*(((A0*((k2+(instanceStruct.instanceVar_k1*q_temp1))*d_diff_min_dX+(d_k2_dX+(instanceStruct.instanceVar_k1*d_q_temp1_dX+instanceStruct.d_instanceVar_k1_dX*q_temp1))*diff_min)-((k2+(instanceStruct.instanceVar_k1*q_temp1))*diff_min)*d_A0_dX)/A0/A0))+instanceStruct.d_instanceVar_xdeff_dX);
q_x2sat = ((value_log_0+instanceStruct.instanceVar_xdeff)+3.0);
}
if ((((q_x1sat-x1_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-x1_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x1sat_dX-d_x1_WI0_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x1sat_dX-d_x1_WI0_dX)*0.3333333333333;
q_temp3 = ((q_x1sat-x1_WI0)*0.3333333333333);
}
d_q_x1_dX = (d_q_x1sat_dX-3.0*d_q_temp3_dX);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-x2_WI0)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-x2_WI0)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x2sat_dX-d_x2_WI0_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x2sat_dX-d_x2_WI0_dX)*0.3333333333333;
q_temp3 = ((q_x2sat-x2_WI0)*0.3333333333333);
}
d_q_x2_dX = (d_q_x2sat_dX-3.0*d_q_temp3_dX);
q_x2 = (q_x2sat-(3.0*q_temp3));
d_q_x1_WI_dX = (((instanceStruct.instanceVar_k1*xg1x)+q_x2)*d_q_temp1_dX+((instanceStruct.instanceVar_k1*d_xg1x_dX+instanceStruct.d_instanceVar_k1_dX*xg1x)+d_q_x2_dX)*q_temp1);
q_x1_WI = (((instanceStruct.instanceVar_k1*xg1x)+q_x2)*q_temp1);
d_q_x2_WI_dX = (((k2*xg2x)+q_x1)*d_q_temp2_dX+((k2*d_xg2x_dX+d_k2_dX*xg2x)+d_q_x1_dX)*q_temp2);
q_x2_WI = (((k2*xg2x)+q_x1)*q_temp2);
if ((((q_x1sat-q_x1_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x1sat-q_x1_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x1sat_dX-d_q_x1_WI_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x1sat_dX-d_q_x1_WI_dX)*0.3333333333333;
q_temp3 = ((q_x1sat-q_x1_WI)*0.3333333333333);
}
d_q_x1_dX = (d_q_x1sat_dX-3.0*d_q_temp3_dX);
q_x1 = (q_x1sat-(3.0*q_temp3));
if ((((q_x2sat-q_x2_WI)*0.3333333333333)<80.0))
{
{
double value_exp_0 = exp(((q_x2sat-q_x2_WI)*0.3333333333333));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
d_q_temp3_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_q_x2sat_dX-d_q_x2_WI_dX)*0.3333333333333));
q_temp3 = value_log_1;
}
}
else
{
d_q_temp3_dX = (d_q_x2sat_dX-d_q_x2_WI_dX)*0.3333333333333;
q_temp3 = ((q_x2sat-q_x2_WI)*0.3333333333333);
}
d_q_x2_dX = (d_q_x2sat_dX-3.0*d_q_temp3_dX);
q_x2 = (q_x2sat-(3.0*q_temp3));
d_q1d_dX = (d_xg1x_dX-d_q_x1_dX);
q1d = (xg1x-q_x1);
d_q2d_dX = (d_xg2x_dX-d_q_x2_dX);
q2d = (xg2x-q_x2);
d_q_rac_qsq_dX = 0.0;
q_rac_qsq = 0.0;
d_q_invexpq_dX = 0.0;
q_invexpq = 0.0;
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1d_dX+instanceStruct.d_instanceVar_k1_dX*q1d);
q_k1q1 = (instanceStruct.instanceVar_k1*q1d);
if ((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-instanceStruct.instanceVar_xdeff));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*(((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*0.3333333333333+0.5*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
}
d_q_Aexp_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
q_Aexp = (A0*q_temp1);
d_q_qsq_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_Aexp_dX);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);
d_q_d1_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_Aexp_dX);
q_d1_qsq = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_Aexp);
d_q_d2_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.d_instanceVar_k1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*instanceStruct.instanceVar_k1)-d_q_Aexp_dX);
q_d2_qsq = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.instanceVar_k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
d_q_temp3_dX = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dX*0.025)+d_q_qsq_dX*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dX*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));
d_q_qcoth_dX = (q_qsq*d_q_temp3_dX+d_q_qsq_dX*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));
d_q_temp1_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
d_q_d1_qcoth_dX = (q_d1_qsq*d_q_temp1_dX+d_q_d1_qsq_dX*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);
d_q_temp2_dX = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dX*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));
d_q_d2_qcoth_dX = ((q_d2_qsq*d_q_temp1_dX+d_q_d2_qsq_dX*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dX+(q_d1_qsq*d_q_d1_qsq_dX+d_q_d1_qsq_dX*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));
d_q_d1_ln_dX = (((-0.5)*q_d1_qsq)*d_q_temp3_dX+(-0.5)*d_q_d1_qsq_dX*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);
d_q_d2_ln_dX = ((((-0.5)*q_d2_qsq)*d_q_temp3_dX+(-0.5)*d_q_d2_qsq_dX*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dX)+d_q_qsq_dX*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dX+(0.25*0.0055555555556)*d_q_d1_qsq_dX*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{
d_q_temp2_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dX-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_sh_term_dX = (q_temp2*d_q_invexpq_dX+d_q_temp2_dX*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);
d_q_ln_term_dX = (deriv_log_0_d0*(d_q_temp2_dX)-d_q_rac_qsq_dX);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_sh_term_dX = (((q_temp2*q_temp2)*(-d_q_qsq_dX)-(-q_qsq)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
else
{
d_q_sh_term_dX = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dX*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{
d_q_expnum_dX = (d_q_k1q1_dX+d_q_qcoth_dX);
q_expnum = (q_k1q1+q_qcoth);
d_q_d1_expnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_d1_qcoth_dX);
q_d1_expnum = (instanceStruct.instanceVar_k1+q_d1_qcoth);
d_q_d2_expnum_dX = d_q_d2_qcoth_dX;
q_d2_expnum = q_d2_qcoth;
}
else
{
d_q_temp2_dX = (-(d_q_k1q1_dX-d_q_qcoth_dX)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));
d_q_temp3_dX = (d_q_d1_qcoth_dX-instanceStruct.d_instanceVar_k1_dX);
q_temp3 = (q_d1_qcoth-instanceStruct.instanceVar_k1);
d_q_expnum_dX = ((q_Aexp-q_sh_term)*d_q_temp2_dX+(d_q_Aexp_dX-d_q_sh_term_dX)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);
d_q_d1_expnum_dX = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dX+(((q_temp3*d_q_expnum_dX+d_q_temp3_dX*q_expnum)-d_q_Aexp_dX)-(q_d1_ln*d_q_sh_term_dX+d_q_d1_ln_dX*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);
d_q_d2_expnum_dX = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dX+((((q_d2_qcoth*d_q_expnum_dX+d_q_d2_qcoth_dX*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dX+2.0*d_q_temp3_dX*q_d1_expnum))+d_q_Aexp_dX)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dX+(d_q_d2_ln_dX+(q_d1_ln*d_q_d1_ln_dX+d_q_d1_ln_dX*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);
d_q_lnexpnum_dX = deriv_log_0_d0*(d_q_expnum_dX);
q_lnexpnum = value_log_0;
}
d_q_temp1_dX = (-d_q_expnum_dX/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);
d_q_d1_lnexpnum_dX = (q_d1_expnum*d_q_temp1_dX+d_q_d1_expnum_dX*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);
d_q_d2_lnexpnum_dX = ((q_d2_expnum*d_q_temp1_dX+d_q_d2_expnum_dX*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dX+d_q_d1_lnexpnum_dX*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));
d_q_lnexpnum_dX = (d_q_k1q1_dX+deriv_log_0_d0*((-d_q_k1q1_dX)));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}
d_q_temp1_dX = (-d_q1d_dX/q1d/q1d);
q_temp1 = (1.0/q1d);
d_q_d1_lnexpnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_temp1_dX);
q_d1_lnexpnum = (instanceStruct.instanceVar_k1+q_temp1);
d_q_d2_lnexpnum_dX = ((-q_temp1)*d_q_temp1_dX+(-d_q_temp1_dX)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}
d_q_q2_int_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1d_dX)+2.0*d_q_lnexpnum_dX)-d_q_ln_term_dX);
q_q2_int = ((((xg2x-xg1x)+q1d)+(2.0*q_lnexpnum))-q_ln_term);
d_q_d1_q2_dX = (2.0*d_q_d1_lnexpnum_dX-d_q_d1_ln_dX);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);
d_q_d2_q2_dX = (2.0*d_q_d2_lnexpnum_dX-d_q_d2_ln_dX);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);
d_q_qi_int_dX = (d_q_k1q1_dX+(k2*d_q_q2_int_dX+d_k2_dX*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));
d_q_d1_qi_dX = (instanceStruct.d_instanceVar_k1_dX+(k2*d_q_d1_q2_dX+d_k2_dX*q_d1_q2));
q_d1_qi = (instanceStruct.instanceVar_k1+(k2*q_d1_q2));
d_q_d2_qi_dX = (k2*d_q_d2_q2_dX+d_k2_dX*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);
d_q_zero_dX = ((q_qi_int*d_q_expnum_dX+d_q_qi_int_dX*q_expnum)-d_q_Aexp_dX);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{
d_q_eps2_dX = 0.0;
q_eps2 = 0.0;
}
else
{
d_q_d1_zero_dX = (((q_d1_qi*d_q_expnum_dX+d_q_d1_qi_dX*q_expnum)+(q_qi_int*d_q_d1_expnum_dX+d_q_qi_int_dX*q_d1_expnum))+d_q_Aexp_dX);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);
d_q_d2_zero_dX = ((((q_d2_qi*d_q_expnum_dX+d_q_d2_qi_dX*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dX+2.0*d_q_d1_qi_dX*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dX+d_q_qi_int_dX*q_d2_expnum))-d_q_Aexp_dX);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);
d_q_eps1_dX = ((q_d1_zero*(-d_q_zero_dX)-(-q_zero)*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);
d_q_eps2_dX = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dX)-(-q_zero)*(d_q_d1_zero_dX+((0.5*q_eps1)*d_q_d2_zero_dX+0.5*d_q_eps1_dX*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}
d_q1d_dX = (d_q1d_dX+d_q_eps2_dX);
q1d = (q1d+q_eps2);
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1d_dX+instanceStruct.d_instanceVar_k1_dX*q1d);
q_k1q1 = (instanceStruct.instanceVar_k1*q1d);
d_q_k2q2_dX = (k2*d_q2d_dX+d_k2_dX*q2d);
q_k2q2 = (k2*q2d);
d_q_qi_int_dX = (d_q_k1q1_dX+d_q_k2q2_dX);
q_qi_int = (q_k1q1+q_k2q2);
d_q_a_dX = 0.065345483024*d_q_qi_int_dX;
q_a = (1.0+(0.065345483024*q_qi_int));
d_q_b_dX = (8.5797362674*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));
d_q_c_dX = 39.478417604*(2.0*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_q_disc_dX = deriv_sqrt_0_d0*(((q_b*d_q_b_dX+d_q_b_dX*q_b)-((4.0*q_a)*d_q_c_dX+4.0*d_q_a_dX*q_c)));
q_disc = value_sqrt_0;
}
d_q_qsq_dX = (((2.0*q_a)*(d_q_disc_dX-d_q_b_dX)-(q_disc-q_b)*2.0*d_q_a_dX)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));
d_q_delta_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_qsq_dX);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));
d_q_zero_dX = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dX-q_delta*d_A0_dX)/A0/A0))+instanceStruct.d_instanceVar_xdeff_dX)-d_xg1x_dX)+d_q1d_dX)+d_q_delta_dX*(((value_log_0+instanceStruct.instanceVar_xdeff)-xg1x)+q1d));
q_zero = (q_delta*(((value_log_0+instanceStruct.instanceVar_xdeff)-xg1x)+q1d));
}
d_q_d1_zero_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_delta_dX);
q_d1_zero = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_delta);
d_q_dx1_dX = ((d_xg1x_dX-d_q1d_dX)-d_q_x1sat_dX);
q_dx1 = ((xg1x-q1d)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(instanceStruct.instanceVar_k1))>0.0))||(q_dx1>1.0)))
{
d_q1d_dX = (d_q1d_dX-((q_d1_zero*d_q_zero_dX-q_zero*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero));
q1d = (q1d-(q_zero/q_d1_zero));
}
}
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1d_dX+instanceStruct.d_instanceVar_k1_dX*q1d);
q_k1q1 = (instanceStruct.instanceVar_k1*q1d);
d_q_k2q2_dX = (k2*d_q2d_dX+d_k2_dX*q2d);
q_k2q2 = (k2*q2d);
d_q_qi_int_dX = (d_q_k1q1_dX+d_q_k2q2_dX);
q_qi_int = (q_k1q1+q_k2q2);
d_q_a_dX = 0.065345483024*d_q_qi_int_dX;
q_a = (1.0+(0.065345483024*q_qi_int));
d_q_b_dX = (8.5797362674*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_b = ((39.478417604+(8.5797362674*q_qi_int))+(q_k1q1*q_k2q2));
d_q_c_dX = 39.478417604*(2.0*d_q_qi_int_dX+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2));
q_c = (39.478417604*((2.0*q_qi_int)+(q_k1q1*q_k2q2)));
{
double value_sqrt_0 = sqrt(((q_b*q_b)-((4.0*q_a)*q_c)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_q_disc_dX = deriv_sqrt_0_d0*(((q_b*d_q_b_dX+d_q_b_dX*q_b)-((4.0*q_a)*d_q_c_dX+4.0*d_q_a_dX*q_c)));
q_disc = value_sqrt_0;
}
d_q_qsq_dX = (((2.0*q_a)*(d_q_disc_dX-d_q_b_dX)-(q_disc-q_b)*2.0*d_q_a_dX)/(2.0*q_a)/(2.0*q_a));
q_qsq = ((q_disc-q_b)/(2.0*q_a));
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_d1_qcoth_dX = ((q_qsq*0.25*(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_d1_qcoth_dX = ((q_qsq*0.25*(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))-(0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d1_qcoth = ((0.25*(q_qsq+(q_qcoth*(2.0-q_qcoth))))/q_qsq);
}
else
{
d_q_qcoth_dX = ((q_qsq*0.1666666666667)*(-((q_qsq*0.0166666666667)*(-d_q_qsq_dX*0.0238095238095)+d_q_qsq_dX*0.0166666666667*(1.0-(q_qsq*0.0238095238095))))+d_q_qsq_dX*0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095)))));
q_qcoth = (2.0+((q_qsq*0.1666666666667)*(1.0-((q_qsq*0.0166666666667)*(1.0-(q_qsq*0.0238095238095))))));
d_q_d1_qcoth_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_d1_qcoth = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
}
}
d_q_qsq_dX = (d_q_qsq_dX-((((q_qi_int*q_d1_qcoth)+1.0)*(((q_qi_int*d_q_qcoth_dX+d_q_qi_int_dX*q_qcoth)+(q_k1q1*d_q_k2q2_dX+d_q_k1q1_dX*q_k2q2))+d_q_qsq_dX)-(((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)*(q_qi_int*d_q_d1_qcoth_dX+d_q_qi_int_dX*q_d1_qcoth))/((q_qi_int*q_d1_qcoth)+1.0)/((q_qi_int*q_d1_qcoth)+1.0)));
q_qsq = (q_qsq-((((q_qi_int*q_qcoth)+(q_k1q1*q_k2q2))+q_qsq)/((q_qi_int*q_d1_qcoth)+1.0)));
d_q_delta_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_qsq_dX);
q_delta = ((q_k1q1*q_k1q1)-q_qsq);
if ((q_delta>0.0))
{
{
double value_log_0 = log((q_delta/A0));
double  deriv_log_0_d0 = (1.0/(q_delta/A0));
d_q_zero_dX = (q_delta*(((deriv_log_0_d0*(((A0*d_q_delta_dX-q_delta*d_A0_dX)/A0/A0))+instanceStruct.d_instanceVar_xdeff_dX)-d_xg1x_dX)+d_q1d_dX)+d_q_delta_dX*(((value_log_0+instanceStruct.instanceVar_xdeff)-xg1x)+q1d));
q_zero = (q_delta*(((value_log_0+instanceStruct.instanceVar_xdeff)-xg1x)+q1d));
}
d_q_d1_zero_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_delta_dX);
q_d1_zero = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_delta);
d_q_dx1_dX = ((d_xg1x_dX-d_q1d_dX)-d_q_x1sat_dX);
q_dx1 = ((xg1x-q1d)-q_x1sat);
if (((((q_zero<0.0)&&(q_d1_zero>0.0))&&(((q_dx1+2.3025850929941)+log(instanceStruct.instanceVar_k1))>0.0))||(q_dx1>1.0)))
{
d_q1d_dX = (d_q1d_dX-((q_d1_zero*d_q_zero_dX-q_zero*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero));
q1d = (q1d-(q_zero/q_d1_zero));
}
}
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1d_dX+instanceStruct.d_instanceVar_k1_dX*q1d);
q_k1q1 = (instanceStruct.instanceVar_k1*q1d);
if ((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-instanceStruct.instanceVar_xdeff));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*(((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*0.3333333333333+0.5*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
}
d_q_Aexp_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
q_Aexp = (A0*q_temp1);
d_q_qsq_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_Aexp_dX);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);
d_q_d1_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_Aexp_dX);
q_d1_qsq = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_Aexp);
d_q_d2_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.d_instanceVar_k1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*instanceStruct.instanceVar_k1)-d_q_Aexp_dX);
q_d2_qsq = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.instanceVar_k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
d_q_temp3_dX = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dX*0.025)+d_q_qsq_dX*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dX*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));
d_q_qcoth_dX = (q_qsq*d_q_temp3_dX+d_q_qsq_dX*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));
d_q_temp1_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
d_q_d1_qcoth_dX = (q_d1_qsq*d_q_temp1_dX+d_q_d1_qsq_dX*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);
d_q_temp2_dX = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dX*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));
d_q_d2_qcoth_dX = ((q_d2_qsq*d_q_temp1_dX+d_q_d2_qsq_dX*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dX+(q_d1_qsq*d_q_d1_qsq_dX+d_q_d1_qsq_dX*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));
d_q_d1_ln_dX = (((-0.5)*q_d1_qsq)*d_q_temp3_dX+(-0.5)*d_q_d1_qsq_dX*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);
d_q_d2_ln_dX = ((((-0.5)*q_d2_qsq)*d_q_temp3_dX+(-0.5)*d_q_d2_qsq_dX*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dX)+d_q_qsq_dX*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dX+(0.25*0.0055555555556)*d_q_d1_qsq_dX*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{
d_q_temp2_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dX-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_sh_term_dX = (q_temp2*d_q_invexpq_dX+d_q_temp2_dX*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);
d_q_ln_term_dX = (deriv_log_0_d0*(d_q_temp2_dX)-d_q_rac_qsq_dX);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_sh_term_dX = (((q_temp2*q_temp2)*(-d_q_qsq_dX)-(-q_qsq)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
else
{
d_q_sh_term_dX = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dX*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{
d_q_expnum_dX = (d_q_k1q1_dX+d_q_qcoth_dX);
q_expnum = (q_k1q1+q_qcoth);
d_q_d1_expnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_d1_qcoth_dX);
q_d1_expnum = (instanceStruct.instanceVar_k1+q_d1_qcoth);
d_q_d2_expnum_dX = d_q_d2_qcoth_dX;
q_d2_expnum = q_d2_qcoth;
}
else
{
d_q_temp2_dX = (-(d_q_k1q1_dX-d_q_qcoth_dX)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));
d_q_temp3_dX = (d_q_d1_qcoth_dX-instanceStruct.d_instanceVar_k1_dX);
q_temp3 = (q_d1_qcoth-instanceStruct.instanceVar_k1);
d_q_expnum_dX = ((q_Aexp-q_sh_term)*d_q_temp2_dX+(d_q_Aexp_dX-d_q_sh_term_dX)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);
d_q_d1_expnum_dX = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dX+(((q_temp3*d_q_expnum_dX+d_q_temp3_dX*q_expnum)-d_q_Aexp_dX)-(q_d1_ln*d_q_sh_term_dX+d_q_d1_ln_dX*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);
d_q_d2_expnum_dX = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dX+((((q_d2_qcoth*d_q_expnum_dX+d_q_d2_qcoth_dX*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dX+2.0*d_q_temp3_dX*q_d1_expnum))+d_q_Aexp_dX)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dX+(d_q_d2_ln_dX+(q_d1_ln*d_q_d1_ln_dX+d_q_d1_ln_dX*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);
d_q_lnexpnum_dX = deriv_log_0_d0*(d_q_expnum_dX);
q_lnexpnum = value_log_0;
}
d_q_temp1_dX = (-d_q_expnum_dX/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);
d_q_d1_lnexpnum_dX = (q_d1_expnum*d_q_temp1_dX+d_q_d1_expnum_dX*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);
d_q_d2_lnexpnum_dX = ((q_d2_expnum*d_q_temp1_dX+d_q_d2_expnum_dX*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dX+d_q_d1_lnexpnum_dX*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));
d_q_lnexpnum_dX = (d_q_k1q1_dX+deriv_log_0_d0*((-d_q_k1q1_dX)));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}
d_q_temp1_dX = (-d_q1d_dX/q1d/q1d);
q_temp1 = (1.0/q1d);
d_q_d1_lnexpnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_temp1_dX);
q_d1_lnexpnum = (instanceStruct.instanceVar_k1+q_temp1);
d_q_d2_lnexpnum_dX = ((-q_temp1)*d_q_temp1_dX+(-d_q_temp1_dX)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}
d_q_q2_int_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1d_dX)+2.0*d_q_lnexpnum_dX)-d_q_ln_term_dX);
q_q2_int = ((((xg2x-xg1x)+q1d)+(2.0*q_lnexpnum))-q_ln_term);
d_q_d1_q2_dX = (2.0*d_q_d1_lnexpnum_dX-d_q_d1_ln_dX);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);
d_q_d2_q2_dX = (2.0*d_q_d2_lnexpnum_dX-d_q_d2_ln_dX);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);
d_q_qi_int_dX = (d_q_k1q1_dX+(k2*d_q_q2_int_dX+d_k2_dX*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));
d_q_d1_qi_dX = (instanceStruct.d_instanceVar_k1_dX+(k2*d_q_d1_q2_dX+d_k2_dX*q_d1_q2));
q_d1_qi = (instanceStruct.instanceVar_k1+(k2*q_d1_q2));
d_q_d2_qi_dX = (k2*d_q_d2_q2_dX+d_k2_dX*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);
d_q_zero_dX = ((q_qi_int*d_q_expnum_dX+d_q_qi_int_dX*q_expnum)-d_q_Aexp_dX);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{
d_q_eps2_dX = 0.0;
q_eps2 = 0.0;
}
else
{
d_q_d1_zero_dX = (((q_d1_qi*d_q_expnum_dX+d_q_d1_qi_dX*q_expnum)+(q_qi_int*d_q_d1_expnum_dX+d_q_qi_int_dX*q_d1_expnum))+d_q_Aexp_dX);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);
d_q_d2_zero_dX = ((((q_d2_qi*d_q_expnum_dX+d_q_d2_qi_dX*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dX+2.0*d_q_d1_qi_dX*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dX+d_q_qi_int_dX*q_d2_expnum))-d_q_Aexp_dX);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);
d_q_eps1_dX = ((q_d1_zero*(-d_q_zero_dX)-(-q_zero)*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);
d_q_eps2_dX = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dX)-(-q_zero)*(d_q_d1_zero_dX+((0.5*q_eps1)*d_q_d2_zero_dX+0.5*d_q_eps1_dX*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}
d_q1d_dX = (d_q1d_dX+d_q_eps2_dX);
q1d = (q1d+q_eps2);
d_q_k1q1_dX = (instanceStruct.instanceVar_k1*d_q1d_dX+instanceStruct.d_instanceVar_k1_dX*q1d);
q_k1q1 = (instanceStruct.instanceVar_k1*q1d);
if ((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-instanceStruct.instanceVar_xdeff));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*(((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*0.3333333333333+0.5*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
}
d_q_Aexp_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
q_Aexp = (A0*q_temp1);
d_q_qsq_dX = ((q_k1q1*d_q_k1q1_dX+d_q_k1q1_dX*q_k1q1)-d_q_Aexp_dX);
q_qsq = ((q_k1q1*q_k1q1)-q_Aexp);
d_q_d1_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*d_q_k1q1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*q_k1q1)+d_q_Aexp_dX);
q_d1_qsq = (((2.0*instanceStruct.instanceVar_k1)*q_k1q1)+q_Aexp);
d_q_d2_qsq_dX = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.d_instanceVar_k1_dX+2.0*instanceStruct.d_instanceVar_k1_dX*instanceStruct.instanceVar_k1)-d_q_Aexp_dX);
q_d2_qsq = (((2.0*instanceStruct.instanceVar_k1)*instanceStruct.instanceVar_k1)-q_Aexp);
if ((q_qsq<(-0.005)))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
if ((q_qsq>0.005))
{
{
double value_fabs_0 = fabs(q_qsq);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((q_qsq)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_q_qsq_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
d_q_temp1_dX = ((q_qsq*0.25*d_q_d1_qsq_dX-(0.25*q_d1_qsq)*d_q_qsq_dX)/q_qsq/q_qsq);
q_temp1 = ((0.25*q_d1_qsq)/q_qsq);
d_q_d1_qcoth_dX = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*d_q_temp1_dX+(d_q_qsq_dX+(q_qcoth*(-d_q_qcoth_dX)+d_q_qcoth_dX*(2.0-q_qcoth)))*q_temp1);
q_d1_qcoth = ((q_qsq+(q_qcoth*(2.0-q_qcoth)))*q_temp1);
d_q_d2_qcoth_dX = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*d_q_temp1_dX+(d_q_d1_qsq_dX-((2.0*q_d1_qcoth)*d_q_qcoth_dX+2.0*d_q_d1_qcoth_dX*(1.0+q_qcoth)))*q_temp1)+((q_d1_qsq*(q_d1_qcoth*d_q_d2_qsq_dX+d_q_d1_qcoth_dX*q_d2_qsq)-(q_d1_qcoth*q_d2_qsq)*d_q_d1_qsq_dX)/q_d1_qsq/q_d1_qsq));
q_d2_qcoth = (((q_d1_qsq-((2.0*q_d1_qcoth)*(1.0+q_qcoth)))*q_temp1)+((q_d1_qcoth*q_d2_qsq)/q_d1_qsq));
d_q_temp2_dX = (-0.5*d_q_qcoth_dX);
q_temp2 = (1.0-(0.5*q_qcoth));
d_q_d1_ln_dX = ((q_d1_qsq/q_qsq)*d_q_temp2_dX+((q_qsq*d_q_d1_qsq_dX-q_d1_qsq*d_q_qsq_dX)/q_qsq/q_qsq)*q_temp2);
q_d1_ln = ((q_d1_qsq/q_qsq)*q_temp2);
d_q_d2_ln_dX = ((q_qsq*((q_d2_qsq*d_q_temp2_dX+d_q_d2_qsq_dX*q_temp2)-(q_d1_qsq*(d_q_d1_ln_dX+0.5*d_q_d1_qcoth_dX)+d_q_d1_qsq_dX*(q_d1_ln+(0.5*q_d1_qcoth))))-((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))*d_q_qsq_dX)/q_qsq/q_qsq);
q_d2_ln = (((q_d2_qsq*q_temp2)-(q_d1_qsq*(q_d1_ln+(0.5*q_d1_qcoth))))/q_qsq);
}
else
{
d_q_temp3_dX = 0.1666666666667*(-((q_qsq*0.0166666666667)*(-((q_qsq*0.0238095238095)*(-d_q_qsq_dX*0.025)+d_q_qsq_dX*0.0238095238095*(1.0-(q_qsq*0.025))))+d_q_qsq_dX*0.0166666666667*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025))))));
q_temp3 = (0.1666666666667*(1.0-((q_qsq*0.0166666666667)*(1.0-((q_qsq*0.0238095238095)*(1.0-(q_qsq*0.025)))))));
d_q_qcoth_dX = (q_qsq*d_q_temp3_dX+d_q_qsq_dX*q_temp3);
q_qcoth = (2.0+(q_qsq*q_temp3));
d_q_temp1_dX = 0.1666666666667*(-((q_qsq*0.0333333333333)*(-((q_qsq*0.0357142857143)*(-d_q_qsq_dX*0.0333333333333)+d_q_qsq_dX*0.0357142857143*(1.0-(q_qsq*0.0333333333333))))+d_q_qsq_dX*0.0333333333333*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333))))));
q_temp1 = (0.1666666666667*(1.0-((q_qsq*0.0333333333333)*(1.0-((q_qsq*0.0357142857143)*(1.0-(q_qsq*0.0333333333333)))))));
d_q_d1_qcoth_dX = (q_d1_qsq*d_q_temp1_dX+d_q_d1_qsq_dX*q_temp1);
q_d1_qcoth = (q_d1_qsq*q_temp1);
d_q_temp2_dX = 0.0055555555556*(-((q_qsq*0.0714285714286)*(-((0.05*q_qsq)*(-0.0420875420875421*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0420875420875421*q_qsq))))+d_q_qsq_dX*0.0714285714286*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq))))));
q_temp2 = (0.0055555555556*(1.0-((q_qsq*0.0714285714286)*(1.0-((0.05*q_qsq)*(1.0-(0.0420875420875421*q_qsq)))))));
d_q_d2_qcoth_dX = ((q_d2_qsq*d_q_temp1_dX+d_q_d2_qsq_dX*q_temp1)-((q_d1_qsq*q_d1_qsq)*d_q_temp2_dX+(q_d1_qsq*d_q_d1_qsq_dX+d_q_d1_qsq_dX*q_d1_qsq)*q_temp2));
q_d2_qcoth = ((q_d2_qsq*q_temp1)-((q_d1_qsq*q_d1_qsq)*q_temp2));
d_q_d1_ln_dX = (((-0.5)*q_d1_qsq)*d_q_temp3_dX+(-0.5)*d_q_d1_qsq_dX*q_temp3);
q_d1_ln = (((-0.5)*q_d1_qsq)*q_temp3);
d_q_d2_ln_dX = ((((-0.5)*q_d2_qsq)*d_q_temp3_dX+(-0.5)*d_q_d2_qsq_dX*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(-((q_qsq*0.0238095238095)*(-0.075*d_q_qsq_dX)+d_q_qsq_dX*0.0238095238095*(2.0-(0.075*q_qsq))))+(((0.25*0.0055555555556)*q_d1_qsq)*d_q_d1_qsq_dX+(0.25*0.0055555555556)*d_q_d1_qsq_dX*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
q_d2_ln = ((((-0.5)*q_d2_qsq)*q_temp3)+((((0.25*0.0055555555556)*q_d1_qsq)*q_d1_qsq)*(1.0-((q_qsq*0.0238095238095)*(2.0-(0.075*q_qsq))))));
}
}
if ((q_qsq>0.005))
{
d_q_temp2_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_q_qsq_dX-(4.0*q_qsq)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp2 = ((4.0*q_qsq)/(1.0-(q_invexpq*(2.0-q_invexpq))));
d_q_sh_term_dX = (q_temp2*d_q_invexpq_dX+d_q_temp2_dX*q_invexpq);
q_sh_term = (q_temp2*q_invexpq);
{
double value_log_0 = log(q_temp2);
double  deriv_log_0_d0 = (1.0/q_temp2);
d_q_ln_term_dX = (deriv_log_0_d0*(d_q_temp2_dX)-d_q_rac_qsq_dX);
q_ln_term = (value_log_0-q_rac_qsq);
}
}
else
{
if ((q_qsq<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_sh_term_dX = (((q_temp2*q_temp2)*(-d_q_qsq_dX)-(-q_qsq)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2));
q_sh_term = ((-q_qsq)/(q_temp2*q_temp2));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
else
{
d_q_sh_term_dX = (-((q_qsq*0.3333333333333)*(-((0.05*q_qsq)*(-0.0396825396825397*d_q_qsq_dX)+0.05*d_q_qsq_dX*(1.0-(0.0396825396825397*q_qsq))))+d_q_qsq_dX*0.3333333333333*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
q_sh_term = (4.0-((q_qsq*0.3333333333333)*(1.0-((0.05*q_qsq)*(1.0-(0.0396825396825397*q_qsq))))));
{
double value_log_0 = log(q_sh_term);
double  deriv_log_0_d0 = (1.0/q_sh_term);
d_q_ln_term_dX = deriv_log_0_d0*(d_q_sh_term_dX);
q_ln_term = value_log_0;
}
}
}
if ((((1.01*q_k1q1)+q_qcoth)>0.0))
{
d_q_expnum_dX = (d_q_k1q1_dX+d_q_qcoth_dX);
q_expnum = (q_k1q1+q_qcoth);
d_q_d1_expnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_d1_qcoth_dX);
q_d1_expnum = (instanceStruct.instanceVar_k1+q_d1_qcoth);
d_q_d2_expnum_dX = d_q_d2_qcoth_dX;
q_d2_expnum = q_d2_qcoth;
}
else
{
d_q_temp2_dX = (-(d_q_k1q1_dX-d_q_qcoth_dX)/(q_k1q1-q_qcoth)/(q_k1q1-q_qcoth));
q_temp2 = (1.0/(q_k1q1-q_qcoth));
d_q_temp3_dX = (d_q_d1_qcoth_dX-instanceStruct.d_instanceVar_k1_dX);
q_temp3 = (q_d1_qcoth-instanceStruct.instanceVar_k1);
d_q_expnum_dX = ((q_Aexp-q_sh_term)*d_q_temp2_dX+(d_q_Aexp_dX-d_q_sh_term_dX)*q_temp2);
q_expnum = ((q_Aexp-q_sh_term)*q_temp2);
d_q_d1_expnum_dX = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*d_q_temp2_dX+(((q_temp3*d_q_expnum_dX+d_q_temp3_dX*q_expnum)-d_q_Aexp_dX)-(q_d1_ln*d_q_sh_term_dX+d_q_d1_ln_dX*q_sh_term))*q_temp2);
q_d1_expnum = ((((q_temp3*q_expnum)-q_Aexp)-(q_d1_ln*q_sh_term))*q_temp2);
d_q_d2_expnum_dX = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*d_q_temp2_dX+((((q_d2_qcoth*d_q_expnum_dX+d_q_d2_qcoth_dX*q_expnum)+((2.0*q_temp3)*d_q_d1_expnum_dX+2.0*d_q_temp3_dX*q_d1_expnum))+d_q_Aexp_dX)-((q_d2_ln+(q_d1_ln*q_d1_ln))*d_q_sh_term_dX+(d_q_d2_ln_dX+(q_d1_ln*d_q_d1_ln_dX+d_q_d1_ln_dX*q_d1_ln))*q_sh_term))*q_temp2);
q_d2_expnum = (((((q_d2_qcoth*q_expnum)+((2.0*q_temp3)*q_d1_expnum))+q_Aexp)-((q_d2_ln+(q_d1_ln*q_d1_ln))*q_sh_term))*q_temp2);
}
if ((q_expnum>0.0))
{
{
double value_log_0 = log(q_expnum);
double  deriv_log_0_d0 = (1.0/q_expnum);
d_q_lnexpnum_dX = deriv_log_0_d0*(d_q_expnum_dX);
q_lnexpnum = value_log_0;
}
d_q_temp1_dX = (-d_q_expnum_dX/q_expnum/q_expnum);
q_temp1 = (1.0/q_expnum);
d_q_d1_lnexpnum_dX = (q_d1_expnum*d_q_temp1_dX+d_q_d1_expnum_dX*q_temp1);
q_d1_lnexpnum = (q_d1_expnum*q_temp1);
d_q_d2_lnexpnum_dX = ((q_d2_expnum*d_q_temp1_dX+d_q_d2_expnum_dX*q_temp1)-(q_d1_lnexpnum*d_q_d1_lnexpnum_dX+d_q_d1_lnexpnum_dX*q_d1_lnexpnum));
q_d2_lnexpnum = ((q_d2_expnum*q_temp1)-(q_d1_lnexpnum*q_d1_lnexpnum));
}
else
{
{
double value_log_0 = log((-q_k1q1));
double  deriv_log_0_d0 = (1.0/(-q_k1q1));
d_q_lnexpnum_dX = (d_q_k1q1_dX+deriv_log_0_d0*((-d_q_k1q1_dX)));
q_lnexpnum = ((q_k1q1+0.6931471805599)+value_log_0);
}
d_q_temp1_dX = (-d_q1d_dX/q1d/q1d);
q_temp1 = (1.0/q1d);
d_q_d1_lnexpnum_dX = (instanceStruct.d_instanceVar_k1_dX+d_q_temp1_dX);
q_d1_lnexpnum = (instanceStruct.instanceVar_k1+q_temp1);
d_q_d2_lnexpnum_dX = ((-q_temp1)*d_q_temp1_dX+(-d_q_temp1_dX)*q_temp1);
q_d2_lnexpnum = ((-q_temp1)*q_temp1);
}
d_q_q2_int_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1d_dX)+2.0*d_q_lnexpnum_dX)-d_q_ln_term_dX);
q_q2_int = ((((xg2x-xg1x)+q1d)+(2.0*q_lnexpnum))-q_ln_term);
d_q_d1_q2_dX = (2.0*d_q_d1_lnexpnum_dX-d_q_d1_ln_dX);
q_d1_q2 = ((1.0+(2.0*q_d1_lnexpnum))-q_d1_ln);
d_q_d2_q2_dX = (2.0*d_q_d2_lnexpnum_dX-d_q_d2_ln_dX);
q_d2_q2 = ((2.0*q_d2_lnexpnum)-q_d2_ln);
d_q_qi_int_dX = (d_q_k1q1_dX+(k2*d_q_q2_int_dX+d_k2_dX*q_q2_int));
q_qi_int = (q_k1q1+(k2*q_q2_int));
d_q_d1_qi_dX = (instanceStruct.d_instanceVar_k1_dX+(k2*d_q_d1_q2_dX+d_k2_dX*q_d1_q2));
q_d1_qi = (instanceStruct.instanceVar_k1+(k2*q_d1_q2));
d_q_d2_qi_dX = (k2*d_q_d2_q2_dX+d_k2_dX*q_d2_q2);
q_d2_qi = (k2*q_d2_q2);
d_q_zero_dX = ((q_qi_int*d_q_expnum_dX+d_q_qi_int_dX*q_expnum)-d_q_Aexp_dX);
q_zero = ((q_qi_int*q_expnum)-q_Aexp);
if ((q_zero==0.0))
{
d_q_eps2_dX = 0.0;
q_eps2 = 0.0;
}
else
{
d_q_d1_zero_dX = (((q_d1_qi*d_q_expnum_dX+d_q_d1_qi_dX*q_expnum)+(q_qi_int*d_q_d1_expnum_dX+d_q_qi_int_dX*q_d1_expnum))+d_q_Aexp_dX);
q_d1_zero = (((q_d1_qi*q_expnum)+(q_qi_int*q_d1_expnum))+q_Aexp);
d_q_d2_zero_dX = ((((q_d2_qi*d_q_expnum_dX+d_q_d2_qi_dX*q_expnum)+((2.0*q_d1_qi)*d_q_d1_expnum_dX+2.0*d_q_d1_qi_dX*q_d1_expnum))+(q_qi_int*d_q_d2_expnum_dX+d_q_qi_int_dX*q_d2_expnum))-d_q_Aexp_dX);
q_d2_zero = ((((q_d2_qi*q_expnum)+((2.0*q_d1_qi)*q_d1_expnum))+(q_qi_int*q_d2_expnum))-q_Aexp);
d_q_eps1_dX = ((q_d1_zero*(-d_q_zero_dX)-(-q_zero)*d_q_d1_zero_dX)/q_d1_zero/q_d1_zero);
q_eps1 = ((-q_zero)/q_d1_zero);
d_q_eps2_dX = (((q_d1_zero+((0.5*q_eps1)*q_d2_zero))*(-d_q_zero_dX)-(-q_zero)*(d_q_d1_zero_dX+((0.5*q_eps1)*d_q_d2_zero_dX+0.5*d_q_eps1_dX*q_d2_zero)))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero))/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
q_eps2 = ((-q_zero)/(q_d1_zero+((0.5*q_eps1)*q_d2_zero)));
}
d_q1d_dX = (d_q1d_dX+d_q_eps2_dX);
q1d = (q1d+q_eps2);
d_k1q1d_dX = (instanceStruct.instanceVar_k1*d_q1d_dX+instanceStruct.d_instanceVar_k1_dX*q1d);
k1q1d = (instanceStruct.instanceVar_k1*q1d);
if ((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg1x-q1d)-instanceStruct.instanceVar_xdeff));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*(((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*0.3333333333333+0.5*((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))+((d_xg1x_dX-d_q1d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*(((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg1x-q1d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
}
d_Aexp1d_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
Aexp1d = (A0*q_temp1);
d_qsqd_dX = ((k1q1d*d_k1q1d_dX+d_k1q1d_dX*k1q1d)-d_Aexp1d_dX);
qsqd = ((k1q1d*k1q1d)-Aexp1d);
if ((Aexp1d==0.0))
{
instanceStruct.d_instanceVar_qid_dX = 0.0;
instanceStruct.instanceVar_qid = 1.0e-80;
d_k2q2d_dX = (instanceStruct.d_instanceVar_qid_dX-d_k1q1d_dX);
k2q2d = (instanceStruct.instanceVar_qid-k1q1d);
d_q2d_dX = ((k2*d_k2q2d_dX-k2q2d*d_k2_dX)/k2/k2);
q2d = (k2q2d/k2);
}
else
{
if ((qsqd<(-0.005)))
{
{
double value_fabs_0 = fabs(qsqd);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqd)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_qsqd_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_tan_0 = tan((0.5*q_rac_qsq));
double  deriv_tan_0_d0 = (1.0/cos((0.5*q_rac_qsq))/cos((0.5*q_rac_qsq)));
d_q_qcoth_dX = ((value_tan_0*d_q_rac_qsq_dX-q_rac_qsq*deriv_tan_0_d0*(0.5*d_q_rac_qsq_dX))/value_tan_0/value_tan_0);
q_qcoth = (q_rac_qsq/value_tan_0);
}
}
else
{
if ((qsqd>0.005))
{
{
double value_fabs_0 = fabs(qsqd);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((qsqd)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_q_rac_qsq_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_qsqd_dX));
q_rac_qsq = value_sqrt_1;
}
{
double value_exp_0 = exp((-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_invexpq_dX = deriv_exp_0_d0*((-d_q_rac_qsq_dX));
q_invexpq = value_exp_0;
}
d_q_qcoth_dX = (((1.0-q_invexpq)*(q_rac_qsq*d_q_invexpq_dX+d_q_rac_qsq_dX*(1.0+q_invexpq))-(q_rac_qsq*(1.0+q_invexpq))*(-d_q_invexpq_dX))/(1.0-q_invexpq)/(1.0-q_invexpq));
q_qcoth = ((q_rac_qsq*(1.0+q_invexpq))/(1.0-q_invexpq));
}
else
{
d_q_qcoth_dX = ((qsqd*0.1666666666667)*(-((qsqd*0.0166666666667)*(-d_qsqd_dX*0.0238095238095)+d_qsqd_dX*0.0166666666667*(1.0-(qsqd*0.0238095238095))))+d_qsqd_dX*0.1666666666667*(1.0-((qsqd*0.0166666666667)*(1.0-(qsqd*0.0238095238095)))));
q_qcoth = (2.0+((qsqd*0.1666666666667)*(1.0-((qsqd*0.0166666666667)*(1.0-(qsqd*0.0238095238095))))));
}
}
if ((((1.01*k1q1d)+q_qcoth)>0.0))
{
d_q_temp1_dX = (d_k1q1d_dX+d_q_qcoth_dX);
q_temp1 = (k1q1d+q_qcoth);
if (((Aexp1d*k1q1d)<(((0.9*k1q1d)*k1q1d)*q_temp1)))
{
instanceStruct.d_instanceVar_qid_dX = ((q_temp1*d_Aexp1d_dX-Aexp1d*d_q_temp1_dX)/q_temp1/q_temp1);
instanceStruct.instanceVar_qid = ((Aexp1d/q_temp1)+1.0e-80);
d_k2q2d_dX = (instanceStruct.d_instanceVar_qid_dX-d_k1q1d_dX);
k2q2d = (instanceStruct.instanceVar_qid-k1q1d);
d_q2d_dX = ((k2*d_k2q2d_dX-k2q2d*d_k2_dX)/k2/k2);
q2d = (k2q2d/k2);
}
else
{
if ((qsqd>0.005))
{
{
double value_log_0 = log(((4.0*qsqd)/(1.0-(q_invexpq*(2.0-q_invexpq)))));
double  deriv_log_0_d0 = (1.0/((4.0*qsqd)/(1.0-(q_invexpq*(2.0-q_invexpq)))));
d_q_temp2_dX = (deriv_log_0_d0*((((1.0-(q_invexpq*(2.0-q_invexpq)))*4.0*d_qsqd_dX-(4.0*qsqd)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq)))))-d_q_rac_qsq_dX);
q_temp2 = (value_log_0-q_rac_qsq);
}
}
else
{
if ((qsqd<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp3_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp3 = value_sin_0;
}
{
double value_log_0 = log(((-qsqd)/(q_temp3*q_temp3)));
double  deriv_log_0_d0 = (1.0/((-qsqd)/(q_temp3*q_temp3)));
d_q_temp2_dX = deriv_log_0_d0*((((q_temp3*q_temp3)*(-d_qsqd_dX)-(-qsqd)*(q_temp3*d_q_temp3_dX+d_q_temp3_dX*q_temp3))/(q_temp3*q_temp3)/(q_temp3*q_temp3)));
q_temp2 = value_log_0;
}
}
else
{
{
double value_log_0 = log((4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd)))))));
double  deriv_log_0_d0 = (1.0/(4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd)))))));
d_q_temp2_dX = deriv_log_0_d0*((-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dX)+0.05*d_qsqd_dX*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dX*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd)))))));
q_temp2 = value_log_0;
}
}
}
{
double value_log_0 = log(q_temp1);
double  deriv_log_0_d0 = (1.0/q_temp1);
d_q2d_dX = ((((d_xg2x_dX-d_xg1x_dX)+d_q1d_dX)+2.0*deriv_log_0_d0*(d_q_temp1_dX))-d_q_temp2_dX);
q2d = ((((xg2x-xg1x)+q1d)+(2.0*value_log_0))-q_temp2);
}
d_k2q2d_dX = (k2*d_q2d_dX+d_k2_dX*q2d);
k2q2d = (k2*q2d);
instanceStruct.d_instanceVar_qid_dX = (d_k1q1d_dX+d_k2q2d_dX);
instanceStruct.instanceVar_qid = (k1q1d+k2q2d);
}
}
else
{
if ((qsqd>0.005))
{
if (((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)<80.0))
{
{
double value_exp_0 = exp((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp3_dX = deriv_exp_0_d0*((((d_q1d_dX+instanceStruct.d_instanceVar_xdeff_dX)-d_xg1x_dX)-d_q_rac_qsq_dX));
q_temp3 = value_exp_0;
}
}
else
{
d_q_temp3_dX = 5.54062e34*(((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0)*((0.5*((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0))*(((d_q1d_dX+instanceStruct.d_instanceVar_xdeff_dX)-d_xg1x_dX)-d_q_rac_qsq_dX)*0.3333333333333+0.5*(((d_q1d_dX+instanceStruct.d_instanceVar_xdeff_dX)-d_xg1x_dX)-d_q_rac_qsq_dX)*(1.0+(((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))+(((d_q1d_dX+instanceStruct.d_instanceVar_xdeff_dX)-d_xg1x_dX)-d_q_rac_qsq_dX)*(1.0+((0.5*((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0))*(1.0+(((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))));
q_temp3 = (5.54062e34*(1.0+(((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0)*(1.0+((0.5*((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0))*(1.0+(((((q1d+instanceStruct.instanceVar_xdeff)-xg1x)-q_rac_qsq)-80.0)*0.3333333333333)))))));
}
d_q_temp2_dX = ((A0*d_q_temp3_dX-q_temp3*d_A0_dX)/A0/A0);
q_temp2 = (q_temp3/A0);
d_q_temp1_dX = (((1.0-(q_invexpq*(2.0-q_invexpq)))*((4.0*qsqd)*d_q_temp2_dX+4.0*d_qsqd_dX*q_temp2)-((4.0*qsqd)*q_temp2)*(-(q_invexpq*(-d_q_invexpq_dX)+d_q_invexpq_dX*(2.0-q_invexpq))))/(1.0-(q_invexpq*(2.0-q_invexpq)))/(1.0-(q_invexpq*(2.0-q_invexpq))));
q_temp1 = (((4.0*qsqd)*q_temp2)/(1.0-(q_invexpq*(2.0-q_invexpq))));
}
else
{
if ((qsqd<(-0.005)))
{
{
double value_sin_0 = sin((0.5*q_rac_qsq));
double  deriv_sin_0_d0 = (cos((0.5*q_rac_qsq)));
d_q_temp2_dX = deriv_sin_0_d0*(0.5*d_q_rac_qsq_dX);
q_temp2 = value_sin_0;
}
d_q_temp1_dX = ((Aexp1d*(((q_temp2*q_temp2)*(-d_qsqd_dX)-(-qsqd)*(q_temp2*d_q_temp2_dX+d_q_temp2_dX*q_temp2))/(q_temp2*q_temp2)/(q_temp2*q_temp2))-((-qsqd)/(q_temp2*q_temp2))*d_Aexp1d_dX)/Aexp1d/Aexp1d);
q_temp1 = (((-qsqd)/(q_temp2*q_temp2))/Aexp1d);
}
else
{
d_q_temp1_dX = ((Aexp1d*(-((qsqd*0.3333333333333)*(-((0.05*qsqd)*(-0.0396825396825397*d_qsqd_dX)+0.05*d_qsqd_dX*(1.0-(0.0396825396825397*qsqd))))+d_qsqd_dX*0.3333333333333*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))-(4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))*d_Aexp1d_dX)/Aexp1d/Aexp1d);
q_temp1 = ((4.0-((qsqd*0.3333333333333)*(1.0-((0.05*qsqd)*(1.0-(0.0396825396825397*qsqd))))))/Aexp1d);
}
}
instanceStruct.d_instanceVar_qid_dX = (((1.0-q_temp1)*(d_k1q1d_dX-d_q_qcoth_dX)-(k1q1d-q_qcoth)*(-d_q_temp1_dX))/(1.0-q_temp1)/(1.0-q_temp1));
instanceStruct.instanceVar_qid = (((k1q1d-q_qcoth)/(1.0-q_temp1))+1.0e-80);
d_k2q2d_dX = (instanceStruct.d_instanceVar_qid_dX-d_k1q1d_dX);
k2q2d = (instanceStruct.instanceVar_qid-k1q1d);
d_q2d_dX = ((k2*d_k2q2d_dX-k2q2d*d_k2_dX)/k2/k2);
q2d = (k2q2d/k2);
}
}
if ((((xg2x-q2d)-instanceStruct.instanceVar_xdeff)<80.0))
{
{
double value_exp_0 = exp(((xg2x-q2d)-instanceStruct.instanceVar_xdeff));
double  deriv_exp_0_d0 = value_exp_0;
d_q_temp1_dX = deriv_exp_0_d0*(((d_xg2x_dX-d_q2d_dX)-instanceStruct.d_instanceVar_xdeff_dX));
q_temp1 = value_exp_0;
}
}
else
{
d_q_temp1_dX = 5.54062e34*((((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0)*((0.5*(((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0))*((d_xg2x_dX-d_q2d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*0.3333333333333+0.5*((d_xg2x_dX-d_q2d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))+((d_xg2x_dX-d_q2d_dX)-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((0.5*(((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))));
q_temp1 = (5.54062e34*(1.0+((((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*(((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((xg2x-q2d)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
}
d_Aexp2d_dX = (A0*d_q_temp1_dX+d_A0_dX*q_temp1);
Aexp2d = (A0*q_temp1);
d_a1d_dX = 0.0;
a1d = 0.0;
d_a2d_dX = 0.0;
a2d = 0.0;
d_b1d_dX = 0.0;
b1d = 0.0;
d_b2d_dX = 0.0;
b2d = 0.0;
d_sumd_dX = 0.0;
sumd = 0.0;
d_dqsqd_dxn_qi_dX = 0.0;
dqsqd_dxn_qi = 0.0;
if ((instanceStruct.instanceVar_qis>1.0E-6))
{
d_b1d_dX = (Aexp1d*d_inv_k1_dX+d_Aexp1d_dX*inv_k1);
b1d = (Aexp1d*inv_k1);
d_b2d_dX = (Aexp2d*d_inv_k2_dX+d_Aexp2d_dX*inv_k2);
b2d = (Aexp2d*inv_k2);
d_a1d_dX = (d_b1d_dX+2.0*d_k1q1d_dX);
a1d = (b1d+(2.0*k1q1d));
d_a2d_dX = (d_b2d_dX+2.0*d_k2q2d_dX);
a2d = (b2d+(2.0*k2q2d));
d_sumd_dX = ((2.0*instanceStruct.d_instanceVar_qid_dX+d_b1d_dX)+d_b2d_dX);
sumd = (((2.0*instanceStruct.instanceVar_qid)+b1d)+b2d);
if ((fabs(qsqd)>0.005))
{
instanceStruct.d_instanceVar_temp1_dX = (((a1d*d_a2d_dX+d_a1d_dX*a2d)+((2.0*(q1d+2.0))*d_a2d_dX+2.0*d_q1d_dX*a2d))+((2.0*(q2d+2.0))*d_a1d_dX+2.0*d_q2d_dX*a1d));
instanceStruct.instanceVar_temp1 = (((a1d*a2d)+((2.0*(q1d+2.0))*a2d))+((2.0*(q2d+2.0))*a1d));
d_dqsqd_dxn_qi_dX = (((instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp1)*(((-4.0)*qsqd)*d_sumd_dX+(-4.0)*d_qsqd_dX*sumd)-(((-4.0)*qsqd)*sumd)*(instanceStruct.instanceVar_qid*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_qid_dX*instanceStruct.instanceVar_temp1))/(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp1)/(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp1));
dqsqd_dxn_qi = ((((-4.0)*qsqd)*sumd)/(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp1));
}
else
{
instanceStruct.d_instanceVar_temp1_dX = 0.1666666666667*(-((qsqd*0.0333333333333)*(-((qsqd*0.0357142857143)*(-d_qsqd_dX*0.0333333333333)+d_qsqd_dX*0.0357142857143*(1.0-(qsqd*0.0333333333333))))+d_qsqd_dX*0.0333333333333*(1.0-((qsqd*0.0357142857143)*(1.0-(qsqd*0.0333333333333))))));
instanceStruct.instanceVar_temp1 = (0.1666666666667*(1.0-((qsqd*0.0333333333333)*(1.0-((qsqd*0.0357142857143)*(1.0-(qsqd*0.0333333333333)))))));
instanceStruct.d_instanceVar_temp2_dX = (((a1d*d_Aexp1d_dX+d_a1d_dX*Aexp1d)+(a2d*d_Aexp2d_dX+d_a2d_dX*Aexp2d))+(((a1d*a2d)*instanceStruct.instanceVar_qid)*(instanceStruct.instanceVar_qid*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_qid_dX*instanceStruct.instanceVar_temp1)+((a1d*a2d)*instanceStruct.d_instanceVar_qid_dX+(a1d*d_a2d_dX+d_a1d_dX*a2d)*instanceStruct.instanceVar_qid)*(1.0+(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp1))));
instanceStruct.instanceVar_temp2 = (((a1d*Aexp1d)+(a2d*Aexp2d))+(((a1d*a2d)*instanceStruct.instanceVar_qid)*(1.0+(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp1))));
d_dqsqd_dxn_qi_dX = (((instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp2)*((Aexp1d*Aexp2d)*d_sumd_dX+(Aexp1d*d_Aexp2d_dX+d_Aexp1d_dX*Aexp2d)*sumd)-((Aexp1d*Aexp2d)*sumd)*(instanceStruct.instanceVar_qid*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_qid_dX*instanceStruct.instanceVar_temp2))/(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp2)/(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp2));
dqsqd_dxn_qi = (((Aexp1d*Aexp2d)*sumd)/(instanceStruct.instanceVar_qid*instanceStruct.instanceVar_temp2));
}
}
{
double value_log_0 = log(instanceStruct.instanceVar_qid);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_qid);
d_xdriftd_dX = (instanceStruct.d_instanceVar_xdeff_dX+deriv_log_0_d0*(instanceStruct.d_instanceVar_qid_dX));
xdriftd = (instanceStruct.instanceVar_xdeff+value_log_0);
}
instanceStruct.d_instanceVar_qim_dX = 0.5*(instanceStruct.d_instanceVar_qis_dX+instanceStruct.d_instanceVar_qid_dX);
instanceStruct.instanceVar_qim = (0.5*(instanceStruct.instanceVar_qis+instanceStruct.instanceVar_qid));
d_dxdrift_dX = (d_xdriftd_dX-d_xdrifts_dX);
dxdrift = (xdriftd-xdrifts);
if (((k1q1d/2.0)<80.0))
{
{
double value_exp_0 = exp((k1q1d/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp1_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_k1q1d_dX/2.0)));
instanceStruct.instanceVar_temp1 = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = (d_k1q1d_dX/2.0);
instanceStruct.instanceVar_temp1 = (k1q1d/2.0);
}
d_esurf1d_dX = 2.0*instanceStruct.d_instanceVar_temp1_dX;
esurf1d = (2.0*instanceStruct.instanceVar_temp1);
if (((k2q2d/2.0)<80.0))
{
{
double value_exp_0 = exp((k2q2d/2.0));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp2_dX = deriv_log_1_d0*(deriv_exp_0_d0*((d_k2q2d_dX/2.0)));
instanceStruct.instanceVar_temp2 = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp2_dX = (d_k2q2d_dX/2.0);
instanceStruct.instanceVar_temp2 = (k2q2d/2.0);
}
d_esurf2d_dX = 2.0*instanceStruct.d_instanceVar_temp2_dX;
esurf2d = (2.0*instanceStruct.instanceVar_temp2);
d_ecpl1d_dX = (d_esurf2d_dX-d_k2q2d_dX);
ecpl1d = (esurf2d-k2q2d);
d_ecpl2d_dX = (d_esurf1d_dX-d_k1q1d_dX);
ecpl2d = (esurf1d-k1q1d);
d_eeff1d_dX = ((instanceStruct.instanceVar_eta_mu*d_esurf1d_dX+instanceStruct.d_instanceVar_eta_mu_dX*esurf1d)+(instanceStruct.instanceVar_one_m_eta*d_ecpl1d_dX+instanceStruct.d_instanceVar_one_m_eta_dX*ecpl1d));
eeff1d = ((instanceStruct.instanceVar_eta_mu*esurf1d)+(instanceStruct.instanceVar_one_m_eta*ecpl1d));
d_eeff2d_dX = ((instanceStruct.instanceVar_eta_mu*d_esurf2d_dX+instanceStruct.d_instanceVar_eta_mu_dX*esurf2d)+(instanceStruct.instanceVar_one_m_eta*d_ecpl2d_dX+instanceStruct.d_instanceVar_one_m_eta_dX*ecpl2d));
eeff2d = ((instanceStruct.instanceVar_eta_mu*esurf2d)+(instanceStruct.instanceVar_one_m_eta*ecpl2d));
instanceStruct.d_instanceVar_esurf1_dX = 0.5*(d_esurf1s_dX+d_esurf1d_dX);
instanceStruct.instanceVar_esurf1 = (0.5*(esurf1s+esurf1d));
instanceStruct.d_instanceVar_esurf2_dX = 0.5*(d_esurf2s_dX+d_esurf2d_dX);
instanceStruct.instanceVar_esurf2 = (0.5*(esurf2s+esurf2d));
instanceStruct.d_instanceVar_temp_dX = (-(instanceStruct.d_instanceVar_esurf1_dX+instanceStruct.d_instanceVar_esurf2_dX)/(instanceStruct.instanceVar_esurf1+instanceStruct.instanceVar_esurf2)/(instanceStruct.instanceVar_esurf1+instanceStruct.instanceVar_esurf2));
instanceStruct.instanceVar_temp = (1.0/(instanceStruct.instanceVar_esurf1+instanceStruct.instanceVar_esurf2));
d_qi1m_dX = ((instanceStruct.instanceVar_qim*instanceStruct.instanceVar_esurf1)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_qim*instanceStruct.d_instanceVar_esurf1_dX+instanceStruct.d_instanceVar_qim_dX*instanceStruct.instanceVar_esurf1)*instanceStruct.instanceVar_temp);
qi1m = ((instanceStruct.instanceVar_qim*instanceStruct.instanceVar_esurf1)*instanceStruct.instanceVar_temp);
d_qi2m_dX = ((instanceStruct.instanceVar_qim*instanceStruct.instanceVar_esurf2)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_qim*instanceStruct.d_instanceVar_esurf2_dX+instanceStruct.d_instanceVar_qim_dX*instanceStruct.instanceVar_esurf2)*instanceStruct.instanceVar_temp);
qi2m = ((instanceStruct.instanceVar_qim*instanceStruct.instanceVar_esurf2)*instanceStruct.instanceVar_temp);
d_ecpl1_dX = 0.5*(d_ecpl1s_dX+d_ecpl1d_dX);
ecpl1 = (0.5*(ecpl1s+ecpl1d));
d_ecpl2_dX = 0.5*(d_ecpl2s_dX+d_ecpl2d_dX);
ecpl2 = (0.5*(ecpl2s+ecpl2d));
d_eeff1_dX = 0.5*(d_eeff1s_dX+d_eeff1d_dX);
eeff1 = (0.5*(eeff1s+eeff1d));
d_eeff2_dX = 0.5*(d_eeff2s_dX+d_eeff2d_dX);
eeff2 = (0.5*(eeff2s+eeff2d));
d_c1_dX = (instanceStruct.instanceVar_esurf1*instanceStruct.d_instanceVar_BETN1_i_dX+instanceStruct.d_instanceVar_esurf1_dX*instanceStruct.instanceVar_BETN1_i);
c1 = (instanceStruct.instanceVar_esurf1*instanceStruct.instanceVar_BETN1_i);
d_c2_dX = (instanceStruct.instanceVar_esurf2*instanceStruct.d_instanceVar_BETN2_i_dX+instanceStruct.d_instanceVar_esurf2_dX*instanceStruct.instanceVar_BETN2_i);
c2 = (instanceStruct.instanceVar_esurf2*instanceStruct.instanceVar_BETN2_i);
d_csum_dX = (d_c1_dX+d_c2_dX);
csum = (c1+c2);
instanceStruct.d_instanceVar_betneff_dX = (csum*instanceStruct.d_instanceVar_temp_dX+d_csum_dX*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_betneff = (csum*instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_XCOR_i*(d_ecpl1_dX+(instanceStruct.instanceVar_XCORB_i*d_ecpl2_dX+instanceStruct.d_instanceVar_XCORB_i_dX*ecpl2))+instanceStruct.d_instanceVar_XCOR_i_dX*(ecpl1+(instanceStruct.instanceVar_XCORB_i*ecpl2)));
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_XCOR_i*(ecpl1+(instanceStruct.instanceVar_XCORB_i*ecpl2)));
{
double value_sqrt_0 = sqrt(((((1.0+instanceStruct.instanceVar_temp1))*((1.0+instanceStruct.instanceVar_temp1)))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp2_dX = 0.5*(instanceStruct.d_instanceVar_temp1_dX+deriv_sqrt_0_d0*((((1.0+instanceStruct.instanceVar_temp1))*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_temp1_dX*((1.0+instanceStruct.instanceVar_temp1)))));
instanceStruct.instanceVar_temp2 = (0.5*((1.0+instanceStruct.instanceVar_temp1)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((1.0+(0.2*instanceStruct.instanceVar_temp1)))*((1.0+(0.2*instanceStruct.instanceVar_temp1))))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp3_dX = 0.5*(0.2*instanceStruct.d_instanceVar_temp1_dX+deriv_sqrt_0_d0*((((1.0+(0.2*instanceStruct.instanceVar_temp1)))*0.2*instanceStruct.d_instanceVar_temp1_dX+0.2*instanceStruct.d_instanceVar_temp1_dX*((1.0+(0.2*instanceStruct.instanceVar_temp1))))));
instanceStruct.instanceVar_temp3 = (0.5*((1.0+(0.2*instanceStruct.instanceVar_temp1))+value_sqrt_0));
}
d_fcor_dX = ((instanceStruct.instanceVar_temp3*instanceStruct.d_instanceVar_temp2_dX-instanceStruct.instanceVar_temp2*instanceStruct.d_instanceVar_temp3_dX)/instanceStruct.instanceVar_temp3/instanceStruct.instanceVar_temp3);
fcor = (instanceStruct.instanceVar_temp2/instanceStruct.instanceVar_temp3);
{
double value_log_0 = log(((1.0+(qi1m*instanceStruct.instanceVar_inv_qi1cs))+(qi2m*instanceStruct.instanceVar_inv_qi2cs)));
double value_exp_1 = exp(((-instanceStruct.instanceVar_THECS_i)*value_log_0));
double  deriv_log_0_d0 = (1.0/((1.0+(qi1m*instanceStruct.instanceVar_inv_qi1cs))+(qi2m*instanceStruct.instanceVar_inv_qi2cs)));
double  deriv_exp_1_d0 = value_exp_1;
d_Gcs_dX = ((instanceStruct.instanceVar_CS_i*((1.0+(instanceStruct.instanceVar_CSFI_i*ecpl1))+(instanceStruct.instanceVar_CSBI_i*ecpl2)))*deriv_exp_1_d0*(((-instanceStruct.instanceVar_THECS_i)*deriv_log_0_d0*(((qi1m*instanceStruct.d_instanceVar_inv_qi1cs_dX+d_qi1m_dX*instanceStruct.instanceVar_inv_qi1cs)+(qi2m*instanceStruct.d_instanceVar_inv_qi2cs_dX+d_qi2m_dX*instanceStruct.instanceVar_inv_qi2cs)))+(-instanceStruct.d_instanceVar_THECS_i_dX)*value_log_0))+(instanceStruct.instanceVar_CS_i*((instanceStruct.instanceVar_CSFI_i*d_ecpl1_dX+instanceStruct.d_instanceVar_CSFI_i_dX*ecpl1)+(instanceStruct.instanceVar_CSBI_i*d_ecpl2_dX+instanceStruct.d_instanceVar_CSBI_i_dX*ecpl2))+instanceStruct.d_instanceVar_CS_i_dX*((1.0+(instanceStruct.instanceVar_CSFI_i*ecpl1))+(instanceStruct.instanceVar_CSBI_i*ecpl2)))*value_exp_1);
Gcs = ((instanceStruct.instanceVar_CS_i*((1.0+(instanceStruct.instanceVar_CSFI_i*ecpl1))+(instanceStruct.instanceVar_CSBI_i*ecpl2)))*value_exp_1);
}
if ((instanceStruct.instanceVar_RSG_i==0.0))
{
instanceStruct.d_instanceVar_temp3_dX = 0.0;
instanceStruct.instanceVar_temp3 = 1.0;
}
else
{
if ((instanceStruct.instanceVar_RSG_i<0.0))
{
{
double value_log_0 = log((instanceStruct.instanceVar_qim+1.0e-12));
double value_exp_1 = exp((instanceStruct.instanceVar_THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_qim+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_RSG_i*deriv_exp_1_d0*((instanceStruct.instanceVar_THERSG_i*deriv_log_0_d0*(instanceStruct.d_instanceVar_qim_dX)+instanceStruct.d_instanceVar_THERSG_i_dX*value_log_0))+instanceStruct.d_instanceVar_RSG_i_dX*value_exp_1);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_RSG_i*value_exp_1);
}
instanceStruct.d_instanceVar_temp3_dX = (-instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp3 = (1.0-instanceStruct.instanceVar_temp1);
}
else
{
{
double value_log_0 = log((instanceStruct.instanceVar_qim+1.0e-12));
double value_exp_1 = exp((instanceStruct.instanceVar_THERSG_i*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_qim+1.0e-12));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_RSG_i*deriv_exp_1_d0*((instanceStruct.instanceVar_THERSG_i*deriv_log_0_d0*(instanceStruct.d_instanceVar_qim_dX)+instanceStruct.d_instanceVar_THERSG_i_dX*value_log_0))+instanceStruct.d_instanceVar_RSG_i_dX*value_exp_1);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_RSG_i*value_exp_1);
}
instanceStruct.d_instanceVar_temp3_dX = (-instanceStruct.d_instanceVar_temp1_dX/(1.0+instanceStruct.instanceVar_temp1)/(1.0+instanceStruct.instanceVar_temp1));
instanceStruct.instanceVar_temp3 = (1.0/(1.0+instanceStruct.instanceVar_temp1));
}
}
d_Grs_dX = (frscsi*((instanceStruct.instanceVar_qim*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_qim_dX*instanceStruct.instanceVar_temp3)+instanceStruct.d_instanceVar_RSIG_i_dX)+d_frscsi_dX*((instanceStruct.instanceVar_qim*instanceStruct.instanceVar_temp3)+instanceStruct.instanceVar_RSIG_i));
Grs = (frscsi*((instanceStruct.instanceVar_qim*instanceStruct.instanceVar_temp3)+instanceStruct.instanceVar_RSIG_i));
{
double value_log_0 = log(((instanceStruct.instanceVar_fmue*eeff1)+1.0e-6));
double value_exp_1 = exp((instanceStruct.instanceVar_THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_fmue*eeff1)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;
d_Gmob1_dX = ((deriv_exp_1_d0*((instanceStruct.instanceVar_THEMU_i*deriv_log_0_d0*((instanceStruct.instanceVar_fmue*d_eeff1_dX+instanceStruct.d_instanceVar_fmue_dX*eeff1))+instanceStruct.d_instanceVar_THEMU_i_dX*value_log_0))+d_Gcs_dX)+(instanceStruct.instanceVar_BETN1_i*d_Grs_dX+instanceStruct.d_instanceVar_BETN1_i_dX*Grs));
Gmob1 = (((1.0+value_exp_1)+Gcs)+(instanceStruct.instanceVar_BETN1_i*Grs));
}
{
double value_log_0 = log(((instanceStruct.instanceVar_fmue*eeff2)+1.0e-6));
double value_exp_1 = exp((instanceStruct.instanceVar_THEMU_i*value_log_0));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_fmue*eeff2)+1.0e-6));
double  deriv_exp_1_d0 = value_exp_1;
d_Gmob2_dX = ((deriv_exp_1_d0*((instanceStruct.instanceVar_THEMU_i*deriv_log_0_d0*((instanceStruct.instanceVar_fmue*d_eeff2_dX+instanceStruct.d_instanceVar_fmue_dX*eeff2))+instanceStruct.d_instanceVar_THEMU_i_dX*value_log_0))+d_Gcs_dX)+(instanceStruct.instanceVar_BETN2_i*d_Grs_dX+instanceStruct.d_instanceVar_BETN2_i_dX*Grs));
Gmob2 = (((1.0+value_exp_1)+Gcs)+(instanceStruct.instanceVar_BETN2_i*Grs));
}
instanceStruct.d_instanceVar_Gmob_dX = ((((c1/Gmob1)+(c2/Gmob2))*(fcor*d_csum_dX+d_fcor_dX*csum)-(fcor*csum)*(((Gmob1*d_c1_dX-c1*d_Gmob1_dX)/Gmob1/Gmob1)+((Gmob2*d_c2_dX-c2*d_Gmob2_dX)/Gmob2/Gmob2)))/((c1/Gmob1)+(c2/Gmob2))/((c1/Gmob1)+(c2/Gmob2)));
instanceStruct.instanceVar_Gmob = ((fcor*csum)/((c1/Gmob1)+(c2/Gmob2)));
d_inv_qimstar1_dX = (-instanceStruct.d_instanceVar_qim_dX/(4.0+instanceStruct.instanceVar_qim)/(4.0+instanceStruct.instanceVar_qim));
inv_qimstar1 = (1.0/(4.0+instanceStruct.instanceVar_qim));
if ((instanceStruct.instanceVar_ALPB_i>0))
{
instanceStruct.d_instanceVar_temp_dX = (-(instanceStruct.instanceVar_ALPB_i*d_qi2m_dX+instanceStruct.d_instanceVar_ALPB_i_dX*qi2m)/(1.0+(instanceStruct.instanceVar_ALPB_i*qi2m))/(1.0+(instanceStruct.instanceVar_ALPB_i*qi2m)));
instanceStruct.instanceVar_temp = (1.0/(1.0+(instanceStruct.instanceVar_ALPB_i*qi2m)));
}
else
{
instanceStruct.d_instanceVar_temp_dX = (-(instanceStruct.instanceVar_ALPB_i*d_qi2m_dX+instanceStruct.d_instanceVar_ALPB_i_dX*qi2m));
instanceStruct.instanceVar_temp = (1.0-(instanceStruct.instanceVar_ALPB_i*qi2m));
}
d_r1_dX = ((instanceStruct.instanceVar_qim*inv_qimstar1)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_qim*d_inv_qimstar1_dX+instanceStruct.d_instanceVar_qim_dX*inv_qimstar1)*instanceStruct.instanceVar_temp);
r1 = ((instanceStruct.instanceVar_qim*inv_qimstar1)*instanceStruct.instanceVar_temp);
{
double value_log_0 = log((1.0+((xd-instanceStruct.instanceVar_xdeff)/((instanceStruct.instanceVar_VP_i*instanceStruct.instanceVar_inv_phit)+((instanceStruct.instanceVar_VPG_i*instanceStruct.instanceVar_qim)*instanceStruct.instanceVar_qim)))));
double  deriv_log_0_d0 = (1.0/(1.0+((xd-instanceStruct.instanceVar_xdeff)/((instanceStruct.instanceVar_VP_i*instanceStruct.instanceVar_inv_phit)+((instanceStruct.instanceVar_VPG_i*instanceStruct.instanceVar_qim)*instanceStruct.instanceVar_qim)))));
instanceStruct.d_instanceVar_temp1_dX = (value_log_0*d_r1_dX+deriv_log_0_d0*(((((instanceStruct.instanceVar_VP_i*instanceStruct.instanceVar_inv_phit)+((instanceStruct.instanceVar_VPG_i*instanceStruct.instanceVar_qim)*instanceStruct.instanceVar_qim))*(d_xd_dX-instanceStruct.d_instanceVar_xdeff_dX)-(xd-instanceStruct.instanceVar_xdeff)*((instanceStruct.instanceVar_VP_i*instanceStruct.d_instanceVar_inv_phit_dX+instanceStruct.d_instanceVar_VP_i_dX*instanceStruct.instanceVar_inv_phit)+((instanceStruct.instanceVar_VPG_i*instanceStruct.instanceVar_qim)*instanceStruct.d_instanceVar_qim_dX+(instanceStruct.instanceVar_VPG_i*instanceStruct.d_instanceVar_qim_dX+instanceStruct.d_instanceVar_VPG_i_dX*instanceStruct.instanceVar_qim)*instanceStruct.instanceVar_qim)))/((instanceStruct.instanceVar_VP_i*instanceStruct.instanceVar_inv_phit)+((instanceStruct.instanceVar_VPG_i*instanceStruct.instanceVar_qim)*instanceStruct.instanceVar_qim))/((instanceStruct.instanceVar_VP_i*instanceStruct.instanceVar_inv_phit)+((instanceStruct.instanceVar_VPG_i*instanceStruct.instanceVar_qim)*instanceStruct.instanceVar_qim))))*r1);
instanceStruct.instanceVar_temp1 = (value_log_0*r1);
}
d_dL_L_dX = (instanceStruct.instanceVar_ALP_i*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_ALP_i_dX*instanceStruct.instanceVar_temp1);
dL_L = (instanceStruct.instanceVar_ALP_i*instanceStruct.instanceVar_temp1);
d_GdL_dX = (-(dL_L*d_dL_L_dX+d_dL_L_dX*(1.0+dL_L))/(1.0+(dL_L*(1.0+dL_L)))/(1.0+(dL_L*(1.0+dL_L))));
GdL = (1.0/(1.0+(dL_L*(1.0+dL_L))));
d_dL1_L_dX = ((instanceStruct.instanceVar_ALP_i+(instanceStruct.instanceVar_alp1_phit*inv_qimstar1))*instanceStruct.d_instanceVar_temp1_dX+(instanceStruct.d_instanceVar_ALP_i_dX+(instanceStruct.instanceVar_alp1_phit*d_inv_qimstar1_dX+instanceStruct.d_instanceVar_alp1_phit_dX*inv_qimstar1))*instanceStruct.instanceVar_temp1);
dL1_L = ((instanceStruct.instanceVar_ALP_i+(instanceStruct.instanceVar_alp1_phit*inv_qimstar1))*instanceStruct.instanceVar_temp1);
instanceStruct.d_instanceVar_FdL_dX = ((1.0+(dL1_L*(1.0+dL1_L)))*d_GdL_dX+(dL1_L*d_dL1_L_dX+d_dL1_L_dX*(1.0+dL1_L))*GdL);
instanceStruct.instanceVar_FdL = ((1.0+(dL1_L*(1.0+dL1_L)))*GdL);
d_wsat1_dX = (((100.0+instanceStruct.instanceVar_esurf1)*100.0*instanceStruct.d_instanceVar_esurf1_dX-(100.0*instanceStruct.instanceVar_esurf1)*instanceStruct.d_instanceVar_esurf1_dX)/(100.0+instanceStruct.instanceVar_esurf1)/(100.0+instanceStruct.instanceVar_esurf1));
wsat1 = ((100.0*instanceStruct.instanceVar_esurf1)/(100.0+instanceStruct.instanceVar_esurf1));
if ((instanceStruct.instanceVar_THESAT1_i<0.0))
{
d_sat_fact1_dX = (-(-(instanceStruct.instanceVar_THESAT1_i*d_wsat1_dX+instanceStruct.d_instanceVar_THESAT1_i_dX*wsat1))/(1.0-(instanceStruct.instanceVar_THESAT1_i*wsat1))/(1.0-(instanceStruct.instanceVar_THESAT1_i*wsat1)));
sat_fact1 = (1.0/(1.0-(instanceStruct.instanceVar_THESAT1_i*wsat1)));
}
else
{
d_sat_fact1_dX = (instanceStruct.instanceVar_THESAT1_i*d_wsat1_dX+instanceStruct.d_instanceVar_THESAT1_i_dX*wsat1);
sat_fact1 = (1.0+(instanceStruct.instanceVar_THESAT1_i*wsat1));
}
d_wsat2_dX = (((100.0+instanceStruct.instanceVar_esurf2)*100.0*instanceStruct.d_instanceVar_esurf2_dX-(100.0*instanceStruct.instanceVar_esurf2)*instanceStruct.d_instanceVar_esurf2_dX)/(100.0+instanceStruct.instanceVar_esurf2)/(100.0+instanceStruct.instanceVar_esurf2));
wsat2 = ((100.0*instanceStruct.instanceVar_esurf2)/(100.0+instanceStruct.instanceVar_esurf2));
if ((instanceStruct.instanceVar_THESAT2_i<0.0))
{
d_sat_fact2_dX = (-(-(instanceStruct.instanceVar_THESAT2_i*d_wsat2_dX+instanceStruct.d_instanceVar_THESAT2_i_dX*wsat2))/(1.0-(instanceStruct.instanceVar_THESAT2_i*wsat2))/(1.0-(instanceStruct.instanceVar_THESAT2_i*wsat2)));
sat_fact2 = (1.0/(1.0-(instanceStruct.instanceVar_THESAT2_i*wsat2)));
}
else
{
d_sat_fact2_dX = (instanceStruct.instanceVar_THESAT2_i*d_wsat2_dX+instanceStruct.d_instanceVar_THESAT2_i_dX*wsat2);
sat_fact2 = (1.0+(instanceStruct.instanceVar_THESAT2_i*wsat2));
}
instanceStruct.d_instanceVar_Ggamma_dX = (((instanceStruct.instanceVar_sat_phit*dxdrift)*0.5)*(d_sat_fact1_dX+d_sat_fact2_dX)+(instanceStruct.instanceVar_sat_phit*d_dxdrift_dX+instanceStruct.d_instanceVar_sat_phit_dX*dxdrift)*0.5*(sat_fact1+sat_fact2));
instanceStruct.instanceVar_Ggamma = (((instanceStruct.instanceVar_sat_phit*dxdrift)*0.5)*(sat_fact1+sat_fact2));
d_sqrt_zsat_dX = (((instanceStruct.instanceVar_Gmob*GdL)*instanceStruct.d_instanceVar_Ggamma_dX-instanceStruct.instanceVar_Ggamma*(instanceStruct.instanceVar_Gmob*d_GdL_dX+instanceStruct.d_instanceVar_Gmob_dX*GdL))/(instanceStruct.instanceVar_Gmob*GdL)/(instanceStruct.instanceVar_Gmob*GdL));
sqrt_zsat = (instanceStruct.instanceVar_Ggamma/(instanceStruct.instanceVar_Gmob*GdL));
instanceStruct.d_instanceVar_zsat_dX = (sqrt_zsat*d_sqrt_zsat_dX+d_sqrt_zsat_dX*sqrt_zsat);
instanceStruct.instanceVar_zsat = (sqrt_zsat*sqrt_zsat);
{
double value_sqrt_0 = sqrt((1.0+instanceStruct.instanceVar_zsat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vsat_fact_dX = deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_zsat_dX);
vsat_fact = value_sqrt_0;
}
instanceStruct.d_instanceVar_hsat_dX = ((vsat_fact*1.5*instanceStruct.d_instanceVar_zsat_dX-(1.0+(1.5*instanceStruct.instanceVar_zsat))*d_vsat_fact_dX)/vsat_fact/vsat_fact);
instanceStruct.instanceVar_hsat = ((1.0+(1.5*instanceStruct.instanceVar_zsat))/vsat_fact);
instanceStruct.d_instanceVar_Gvsat_dX = ((instanceStruct.instanceVar_Gmob*GdL)*d_vsat_fact_dX+(instanceStruct.instanceVar_Gmob*d_GdL_dX+instanceStruct.d_instanceVar_Gmob_dX*GdL)*vsat_fact);
instanceStruct.instanceVar_Gvsat = ((instanceStruct.instanceVar_Gmob*GdL)*vsat_fact);
if ((modelStruct.modelPar_QMC>0.0))
{
{
double value_log_0 = log(((instanceStruct.instanceVar_esurf1*instanceStruct.instanceVar_esurf1)+60.0));
double value_exp_1 = exp(((-0.1666666666667)*value_log_0));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_esurf1*instanceStruct.instanceVar_esurf1)+60.0));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp1_dX = ((0.6*instanceStruct.instanceVar_qq)*deriv_exp_1_d0*((-0.1666666666667)*deriv_log_0_d0*((instanceStruct.instanceVar_esurf1*instanceStruct.d_instanceVar_esurf1_dX+instanceStruct.d_instanceVar_esurf1_dX*instanceStruct.instanceVar_esurf1)))+0.6*instanceStruct.d_instanceVar_qq_dX*value_exp_1);
instanceStruct.instanceVar_temp1 = ((0.6*instanceStruct.instanceVar_qq)*value_exp_1);
}
{
double value_log_0 = log(((instanceStruct.instanceVar_esurf2*instanceStruct.instanceVar_esurf2)+60.0));
double value_exp_1 = exp(((-0.1666666666667)*value_log_0));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_esurf2*instanceStruct.instanceVar_esurf2)+60.0));
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp2_dX = ((0.6*instanceStruct.instanceVar_qq)*deriv_exp_1_d0*((-0.1666666666667)*deriv_log_0_d0*((instanceStruct.instanceVar_esurf2*instanceStruct.d_instanceVar_esurf2_dX+instanceStruct.d_instanceVar_esurf2_dX*instanceStruct.instanceVar_esurf2)))+0.6*instanceStruct.d_instanceVar_qq_dX*value_exp_1);
instanceStruct.instanceVar_temp2 = ((0.6*instanceStruct.instanceVar_qq)*value_exp_1);
}
instanceStruct.d_instanceVar_qmfact1_dX = ((tox1fact*(instanceStruct.instanceVar_k1*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_k1_dX*instanceStruct.instanceVar_temp1)-(1.0+(instanceStruct.instanceVar_k1*instanceStruct.instanceVar_temp1))*d_tox1fact_dX)/tox1fact/tox1fact);
instanceStruct.instanceVar_qmfact1 = ((1.0+(instanceStruct.instanceVar_k1*instanceStruct.instanceVar_temp1))/tox1fact);
d_qmfact2_dX = ((tox2fact*(k2*instanceStruct.d_instanceVar_temp2_dX+d_k2_dX*instanceStruct.instanceVar_temp2)-(1.0+(k2*instanceStruct.instanceVar_temp2))*d_tox2fact_dX)/tox2fact/tox2fact);
qmfact2 = ((1.0+(k2*instanceStruct.instanceVar_temp2))/tox2fact);
instanceStruct.d_instanceVar_qmfact_dX = ((((instanceStruct.instanceVar_esurf1/instanceStruct.instanceVar_qmfact1)+(instanceStruct.instanceVar_esurf2/qmfact2))*(instanceStruct.d_instanceVar_esurf1_dX+instanceStruct.d_instanceVar_esurf2_dX)-(instanceStruct.instanceVar_esurf1+instanceStruct.instanceVar_esurf2)*(((instanceStruct.instanceVar_qmfact1*instanceStruct.d_instanceVar_esurf1_dX-instanceStruct.instanceVar_esurf1*instanceStruct.d_instanceVar_qmfact1_dX)/instanceStruct.instanceVar_qmfact1/instanceStruct.instanceVar_qmfact1)+((qmfact2*instanceStruct.d_instanceVar_esurf2_dX-instanceStruct.instanceVar_esurf2*d_qmfact2_dX)/qmfact2/qmfact2)))/((instanceStruct.instanceVar_esurf1/instanceStruct.instanceVar_qmfact1)+(instanceStruct.instanceVar_esurf2/qmfact2))/((instanceStruct.instanceVar_esurf1/instanceStruct.instanceVar_qmfact1)+(instanceStruct.instanceVar_esurf2/qmfact2)));
instanceStruct.instanceVar_qmfact = ((instanceStruct.instanceVar_esurf1+instanceStruct.instanceVar_esurf2)/((instanceStruct.instanceVar_esurf1/instanceStruct.instanceVar_qmfact1)+(instanceStruct.instanceVar_esurf2/qmfact2)));
}
else
{
instanceStruct.d_instanceVar_qmfact1_dX = 0.0;
instanceStruct.instanceVar_qmfact1 = 1.0;
d_qmfact2_dX = 0.0;
qmfact2 = 1.0;
instanceStruct.d_instanceVar_qmfact_dX = 0.0;
instanceStruct.instanceVar_qmfact = 1.0;
}
if ((instanceStruct.instanceVar_qis>1.0E-6))
{
if ((instanceStruct.instanceVar_qid>1.0E-6))
{
d_dqid_dxn_qi_dX = ((((a1d*a2d)*(dqsqd_dxn_qi*d_sumd_dX+d_dqsqd_dxn_qi_dX*sumd)-(dqsqd_dxn_qi*sumd)*(a1d*d_a2d_dX+d_a1d_dX*a2d))/(a1d*a2d)/(a1d*a2d))-((instanceStruct.instanceVar_qid*(((a1d*d_Aexp1d_dX-Aexp1d*d_a1d_dX)/a1d/a1d)+((a2d*d_Aexp2d_dX-Aexp2d*d_a2d_dX)/a2d/a2d))-((Aexp1d/a1d)+(Aexp2d/a2d))*instanceStruct.d_instanceVar_qid_dX)/instanceStruct.instanceVar_qid/instanceStruct.instanceVar_qid));
dqid_dxn_qi = (((dqsqd_dxn_qi*sumd)/(a1d*a2d))-(((Aexp1d/a1d)+(Aexp2d/a2d))/instanceStruct.instanceVar_qid));
instanceStruct.d_instanceVar_dd_dX = (((dqid_dxn_qi+1.0)*(dqid_dxn_qi*instanceStruct.d_instanceVar_qid_dX+d_dqid_dxn_qi_dX*instanceStruct.instanceVar_qid)-(dqid_dxn_qi*instanceStruct.instanceVar_qid)*d_dqid_dxn_qi_dX)/(dqid_dxn_qi+1.0)/(dqid_dxn_qi+1.0));
instanceStruct.instanceVar_dd = ((dqid_dxn_qi*instanceStruct.instanceVar_qid)/(dqid_dxn_qi+1.0));
}
else
{
instanceStruct.d_instanceVar_dd_dX = d_dinf_dX;
instanceStruct.instanceVar_dd = dinf;
}
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.d_instanceVar_dd_dX-instanceStruct.d_instanceVar_ds_dX);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_dd-instanceStruct.instanceVar_ds);
instanceStruct.d_instanceVar_temp2_dX = ((36.0*instanceStruct.instanceVar_temp1)*instanceStruct.d_instanceVar_temp1_dX+36.0*instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_temp1);
instanceStruct.instanceVar_temp2 = (1.0+((36.0*instanceStruct.instanceVar_temp1)*instanceStruct.instanceVar_temp1));
if ((fabs(instanceStruct.instanceVar_temp1)>1.0e-3))
{
instanceStruct.d_instanceVar_temp3_dX = (instanceStruct.d_instanceVar_qid_dX-instanceStruct.d_instanceVar_qis_dX);
instanceStruct.instanceVar_temp3 = (instanceStruct.instanceVar_qid-instanceStruct.instanceVar_qis);
d_Ls_dX = (instanceStruct.d_instanceVar_temp3_dX-(instanceStruct.instanceVar_dd*d_dxdrift_dX+instanceStruct.d_instanceVar_dd_dX*dxdrift));
Ls = (instanceStruct.instanceVar_temp3-(instanceStruct.instanceVar_dd*dxdrift));
d_Ld_dX = (instanceStruct.d_instanceVar_temp3_dX-(instanceStruct.instanceVar_ds*d_dxdrift_dX+instanceStruct.d_instanceVar_ds_dX*dxdrift));
Ld = (instanceStruct.instanceVar_temp3-(instanceStruct.instanceVar_ds*dxdrift));
{
double value_sqrt_0 = sqrt(((Ls*Ls)+instanceStruct.instanceVar_temp2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Us_dX = deriv_sqrt_0_d0*(((Ls*d_Ls_dX+d_Ls_dX*Ls)+instanceStruct.d_instanceVar_temp2_dX));
Us = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt(((Ld*Ld)+instanceStruct.instanceVar_temp2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Ud_dX = deriv_sqrt_0_d0*(((Ld*d_Ld_dX+d_Ld_dX*Ld)+instanceStruct.d_instanceVar_temp2_dX));
Ud = value_sqrt_0;
}
{
double value_log_0 = log(((Ld+Ud)/(Ls+Us)));
double  deriv_log_0_d0 = (1.0/((Ld+Ud)/(Ls+Us)));
d_idrift2_dX = ((0.25/instanceStruct.instanceVar_temp1)*(((Ud*d_Ls_dX+d_Ud_dX*Ls)-(Us*d_Ld_dX+d_Us_dX*Ld))+(instanceStruct.instanceVar_temp2*deriv_log_0_d0*((((Ls+Us)*(d_Ld_dX+d_Ud_dX)-(Ld+Ud)*(d_Ls_dX+d_Us_dX))/(Ls+Us)/(Ls+Us)))+instanceStruct.d_instanceVar_temp2_dX*value_log_0))+(-0.25*instanceStruct.d_instanceVar_temp1_dX/instanceStruct.instanceVar_temp1/instanceStruct.instanceVar_temp1)*(((Ud*Ls)-(Us*Ld))+(instanceStruct.instanceVar_temp2*value_log_0)));
idrift2 = ((0.25/instanceStruct.instanceVar_temp1)*(((Ud*Ls)-(Us*Ld))+(instanceStruct.instanceVar_temp2*value_log_0)));
}
}
else
{
instanceStruct.d_instanceVar_temp3_dX = (dxdrift*instanceStruct.d_instanceVar_temp1_dX+d_dxdrift_dX*instanceStruct.instanceVar_temp1);
instanceStruct.instanceVar_temp3 = (dxdrift*instanceStruct.instanceVar_temp1);
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_temp2);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_idrift2_dX = ((value_sqrt_0*(((((-0.25)*0.1666666666667)*dxdrift)*instanceStruct.instanceVar_temp3)*instanceStruct.d_instanceVar_temp3_dX+((((-0.25)*0.1666666666667)*dxdrift)*instanceStruct.d_instanceVar_temp3_dX+((-0.25)*0.1666666666667)*d_dxdrift_dX*instanceStruct.instanceVar_temp3)*instanceStruct.instanceVar_temp3)-(((((-0.25)*0.1666666666667)*dxdrift)*instanceStruct.instanceVar_temp3)*instanceStruct.instanceVar_temp3)*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_temp2_dX))/value_sqrt_0/value_sqrt_0);
idrift2 = ((((((-0.25)*0.1666666666667)*dxdrift)*instanceStruct.instanceVar_temp3)*instanceStruct.instanceVar_temp3)/value_sqrt_0);
}
}
}
else
{
instanceStruct.d_instanceVar_dd_dX = d_dinf_dX;
instanceStruct.instanceVar_dd = dinf;
d_idrift2_dX = 0.0;
idrift2 = 0.0;
}
d_norm_Ids_dX = ((((instanceStruct.instanceVar_qim*d_dxdrift_dX+instanceStruct.d_instanceVar_qim_dX*dxdrift)+d_idrift2_dX)+instanceStruct.d_instanceVar_qis_dX)-instanceStruct.d_instanceVar_qid_dX);
norm_Ids = ((((instanceStruct.instanceVar_qim*dxdrift)+idrift2)+instanceStruct.instanceVar_qis)-instanceStruct.instanceVar_qid);
instanceStruct.d_instanceVar_fact_Ids_dX = ((instanceStruct.instanceVar_phit*instanceStruct.instanceVar_phit)*instanceStruct.d_instanceVar_betneff_dX+(instanceStruct.instanceVar_phit*instanceStruct.d_instanceVar_phit_dX+instanceStruct.d_instanceVar_phit_dX*instanceStruct.instanceVar_phit)*instanceStruct.instanceVar_betneff);
instanceStruct.instanceVar_fact_Ids = ((instanceStruct.instanceVar_phit*instanceStruct.instanceVar_phit)*instanceStruct.instanceVar_betneff);
instanceStruct.d_instanceVar_Ids_dX = ((instanceStruct.instanceVar_qmfact*((instanceStruct.instanceVar_Gvsat*(((instanceStruct.instanceVar_fact_Ids*instanceStruct.instanceVar_CsiPrime)*norm_Ids)*instanceStruct.d_instanceVar_FdL_dX+((instanceStruct.instanceVar_fact_Ids*instanceStruct.instanceVar_CsiPrime)*d_norm_Ids_dX+(instanceStruct.instanceVar_fact_Ids*instanceStruct.d_instanceVar_CsiPrime_dX+instanceStruct.d_instanceVar_fact_Ids_dX*instanceStruct.instanceVar_CsiPrime)*norm_Ids)*instanceStruct.instanceVar_FdL)-(((instanceStruct.instanceVar_fact_Ids*instanceStruct.instanceVar_CsiPrime)*norm_Ids)*instanceStruct.instanceVar_FdL)*instanceStruct.d_instanceVar_Gvsat_dX)/instanceStruct.instanceVar_Gvsat/instanceStruct.instanceVar_Gvsat)-((((instanceStruct.instanceVar_fact_Ids*instanceStruct.instanceVar_CsiPrime)*norm_Ids)*instanceStruct.instanceVar_FdL)/instanceStruct.instanceVar_Gvsat)*instanceStruct.d_instanceVar_qmfact_dX)/instanceStruct.instanceVar_qmfact/instanceStruct.instanceVar_qmfact);
instanceStruct.instanceVar_Ids = (((((instanceStruct.instanceVar_fact_Ids*instanceStruct.instanceVar_CsiPrime)*norm_Ids)*instanceStruct.instanceVar_FdL)/instanceStruct.instanceVar_Gvsat)/instanceStruct.instanceVar_qmfact);
if ((instanceStruct.instanceVar_qis>1.0E-6))
{
if ((norm_Ids>1.0e-30))
{
d_q1s_chap_dX = ((((Aexp1s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi)*d_a1s_dX-a1s*(((instanceStruct.instanceVar_qis*d_Aexp1s_dX-Aexp1s*instanceStruct.d_instanceVar_qis_dX)/instanceStruct.instanceVar_qis/instanceStruct.instanceVar_qis)-d_dqsqs_dxn_qi_dX))/((Aexp1s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi)/((Aexp1s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi));
q1s_chap = (a1s/((Aexp1s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi));
d_q1d_chap_dX = ((((Aexp1d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi)*d_a1d_dX-a1d*(((instanceStruct.instanceVar_qid*d_Aexp1d_dX-Aexp1d*instanceStruct.d_instanceVar_qid_dX)/instanceStruct.instanceVar_qid/instanceStruct.instanceVar_qid)-d_dqsqd_dxn_qi_dX))/((Aexp1d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi)/((Aexp1d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi));
q1d_chap = (a1d/((Aexp1d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi));
instanceStruct.d_instanceVar_inv_k1h1_0_dX = ((norm_Ids*(d_q1s_chap_dX-d_q1d_chap_dX)-(q1s_chap-q1d_chap)*d_norm_Ids_dX)/norm_Ids/norm_Ids);
instanceStruct.instanceVar_inv_k1h1_0 = ((q1s_chap-q1d_chap)/norm_Ids);
d_q2s_chap_dX = ((((Aexp2s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi)*d_a2s_dX-a2s*(((instanceStruct.instanceVar_qis*d_Aexp2s_dX-Aexp2s*instanceStruct.d_instanceVar_qis_dX)/instanceStruct.instanceVar_qis/instanceStruct.instanceVar_qis)-d_dqsqs_dxn_qi_dX))/((Aexp2s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi)/((Aexp2s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi));
q2s_chap = (a2s/((Aexp2s/instanceStruct.instanceVar_qis)-dqsqs_dxn_qi));
d_q2d_chap_dX = ((((Aexp2d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi)*d_a2d_dX-a2d*(((instanceStruct.instanceVar_qid*d_Aexp2d_dX-Aexp2d*instanceStruct.d_instanceVar_qid_dX)/instanceStruct.instanceVar_qid/instanceStruct.instanceVar_qid)-d_dqsqd_dxn_qi_dX))/((Aexp2d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi)/((Aexp2d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi));
q2d_chap = (a2d/((Aexp2d/instanceStruct.instanceVar_qid)-dqsqd_dxn_qi));
d_inv_k2h2_0_dX = ((norm_Ids*(d_q2s_chap_dX-d_q2d_chap_dX)-(q2s_chap-q2d_chap)*d_norm_Ids_dX)/norm_Ids/norm_Ids);
inv_k2h2_0 = ((q2s_chap-q2d_chap)/norm_Ids);
}
else
{
instanceStruct.d_instanceVar_inv_k1h1_0_dX = 0.0;
instanceStruct.instanceVar_inv_k1h1_0 = 0.0;
d_inv_k2h2_0_dX = 0.0;
inv_k2h2_0 = 0.0;
}
}
else
{
d_zeta1_dX = (((-2.0)*s1)*(((q1chapinf*d_inv_k1_dX-inv_k1*d_q1chapinf_dX)/q1chapinf/q1chapinf)+d_inv_dinf_dX)+(-2.0)*d_s1_dX*((inv_k1/q1chapinf)+inv_dinf));
zeta1 = (((-2.0)*s1)*((inv_k1/q1chapinf)+inv_dinf));
d_zeta2_dX = (((-2.0)*s2)*(((q2chapinf*d_inv_k2_dX-inv_k2*d_q2chapinf_dX)/q2chapinf/q2chapinf)+d_inv_dinf_dX)+(-2.0)*d_s2_dX*((inv_k2/q2chapinf)+inv_dinf));
zeta2 = (((-2.0)*s2)*((inv_k2/q2chapinf)+inv_dinf));
instanceStruct.d_instanceVar_temp_dX = ((zeta2-zeta1)*d_inv_dinf_dX+(d_zeta2_dX-d_zeta1_dX)*inv_dinf);
instanceStruct.instanceVar_temp = ((zeta2-zeta1)*inv_dinf);
instanceStruct.d_instanceVar_temp1_dX = (zeta1*d_inv_k1_dX+d_zeta1_dX*inv_k1);
instanceStruct.instanceVar_temp1 = (zeta1*inv_k1);
instanceStruct.d_instanceVar_temp2_dX = (zeta2*d_inv_k2_dX+d_zeta2_dX*inv_k2);
instanceStruct.instanceVar_temp2 = (zeta2*inv_k2);
instanceStruct.d_instanceVar_temp3_dX = (instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_temp2_dX);
instanceStruct.instanceVar_temp3 = (instanceStruct.instanceVar_temp1+instanceStruct.instanceVar_temp2);
instanceStruct.d_instanceVar_temp4_dX = 2.0*((s1*d_inv_k1_dX+d_s1_dX*inv_k1)+(s2*d_inv_k2_dX+d_s2_dX*inv_k2));
instanceStruct.instanceVar_temp4 = (3.0+(2.0*((s1*inv_k1)+(s2*inv_k2))));
d_ksi1_dX = ((instanceStruct.instanceVar_temp4*((instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_temp_dX)-((q1chapinf*instanceStruct.d_instanceVar_temp3_dX-instanceStruct.instanceVar_temp3*d_q1chapinf_dX)/q1chapinf/q1chapinf))-((instanceStruct.instanceVar_temp2+instanceStruct.instanceVar_temp)-(instanceStruct.instanceVar_temp3/q1chapinf))*instanceStruct.d_instanceVar_temp4_dX)/instanceStruct.instanceVar_temp4/instanceStruct.instanceVar_temp4);
ksi1 = (((instanceStruct.instanceVar_temp2+instanceStruct.instanceVar_temp)-(instanceStruct.instanceVar_temp3/q1chapinf))/instanceStruct.instanceVar_temp4);
d_ksi2_dX = ((instanceStruct.instanceVar_temp4*((instanceStruct.d_instanceVar_temp1_dX-instanceStruct.d_instanceVar_temp_dX)-((q2chapinf*instanceStruct.d_instanceVar_temp3_dX-instanceStruct.instanceVar_temp3*d_q2chapinf_dX)/q2chapinf/q2chapinf))-((instanceStruct.instanceVar_temp1-instanceStruct.instanceVar_temp)-(instanceStruct.instanceVar_temp3/q2chapinf))*instanceStruct.d_instanceVar_temp4_dX)/instanceStruct.instanceVar_temp4/instanceStruct.instanceVar_temp4);
ksi2 = (((instanceStruct.instanceVar_temp1-instanceStruct.instanceVar_temp)-(instanceStruct.instanceVar_temp3/q2chapinf))/instanceStruct.instanceVar_temp4);
instanceStruct.d_instanceVar_inv_k1h1_0_dX = ((-q1chapinf)*((ksi1*d_q1chapinf_dX+d_ksi1_dX*q1chapinf)+d_inv_dinf_dX)+(-d_q1chapinf_dX)*((ksi1*q1chapinf)+inv_dinf));
instanceStruct.instanceVar_inv_k1h1_0 = ((-q1chapinf)*((ksi1*q1chapinf)+inv_dinf));
d_inv_k2h2_0_dX = ((-q2chapinf)*((ksi2*d_q2chapinf_dX+d_ksi2_dX*q2chapinf)+d_inv_dinf_dX)+(-d_q2chapinf_dX)*((ksi2*q2chapinf)+inv_dinf));
inv_k2h2_0 = ((-q2chapinf)*((ksi2*q2chapinf)+inv_dinf));
}
d_inv_k1h1_dX = (instanceStruct.instanceVar_inv_k1h1_0*instanceStruct.d_instanceVar_hsat_dX+instanceStruct.d_instanceVar_inv_k1h1_0_dX*instanceStruct.instanceVar_hsat);
inv_k1h1 = (instanceStruct.instanceVar_inv_k1h1_0*instanceStruct.instanceVar_hsat);
d_inv_k2h2_dX = (inv_k2h2_0*instanceStruct.d_instanceVar_hsat_dX+d_inv_k2h2_0_dX*instanceStruct.instanceVar_hsat);
inv_k2h2 = (inv_k2h2_0*instanceStruct.instanceVar_hsat);
instanceStruct.d_instanceVar_delta_k1q1_dX = 0.5*(d_k1q1d_dX-d_k1q1s_dX);
instanceStruct.instanceVar_delta_k1q1 = (0.5*(k1q1d-k1q1s));
d_delta_k2q2_dX = 0.5*(d_k2q2d_dX-d_k2q2s_dX);
delta_k2q2 = (0.5*(k2q2d-k2q2s));
d_prod1_dX = (instanceStruct.instanceVar_delta_k1q1*d_inv_k1h1_dX+instanceStruct.d_instanceVar_delta_k1q1_dX*inv_k1h1);
prod1 = (instanceStruct.instanceVar_delta_k1q1*inv_k1h1);
d_prod2_dX = (delta_k2q2*d_inv_k2h2_dX+d_delta_k2q2_dX*inv_k2h2);
prod2 = (delta_k2q2*inv_k2h2);
d_xs_ov_dX = 0.0;
xs_ov = 0.0;
d_xd_ov_dX = 0.0;
xd_ov = 0.0;
d_xs_ovcv_dX = 0.0;
xs_ovcv = 0.0;
d_xd_ovcv_dX = 0.0;
xd_ovcv = 0.0;
{
double value_sqrt_0 = sqrt(((((2.0*1.602176565E-19)*instanceStruct.instanceVar_NOV_i)*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_GOV_dX = ((instanceStruct.instanceVar_Cox1Prime*deriv_sqrt_0_d0*((((2.0*1.602176565E-19)*instanceStruct.instanceVar_NOV_i)*instanceStruct.d_instanceVar_epsch_dX+(2.0*1.602176565E-19)*instanceStruct.d_instanceVar_NOV_i_dX*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit0)-value_sqrt_0*instanceStruct.d_instanceVar_Cox1Prime_dX)/instanceStruct.instanceVar_Cox1Prime/instanceStruct.instanceVar_Cox1Prime);
GOV = (value_sqrt_0/instanceStruct.instanceVar_Cox1Prime);
}
d_GOV2_dX = (GOV*d_GOV_dX+d_GOV_dX*GOV);
GOV2 = (GOV*GOV);
d_xi_ov_dX = (d_GOV_dX/1.4142135623731);
xi_ov = (1.0+(GOV/1.4142135623731));
d_x_mrg_ov_dX = 1.0e-5*d_xi_ov_dX;
x_mrg_ov = (1.0e-5*xi_ov);
d_inv_xi_ov_dX = (-d_xi_ov_dX/xi_ov/xi_ov);
inv_xi_ov = (1.0/xi_ov);
d_inv_xg1_dX = (-d_GOV_dX*7.324648775608221e-1/(1.25+(GOV*7.324648775608221e-1))/(1.25+(GOV*7.324648775608221e-1)));
inv_xg1 = (1.0/(1.25+(GOV*7.324648775608221e-1)));
if ((((modelStruct.modelPar_SWIGATE>0)&&((instanceStruct.instanceVar_IGOVINV_i>0.0)||(instanceStruct.instanceVar_IGOVACC_i>0.0)))||((modelStruct.modelPar_SWGIDL>0)&&(instanceStruct.instanceVar_AGIDL_i>0.0))))
{
if ((fabs(xgs_ov)<=x_mrg_ov))
{
d_xs_ov_dX = (-xgs_ov)*d_inv_xi_ov_dX;
xs_ov = ((-xgs_ov)*inv_xi_ov);
}
else
{
if ((xgs_ov<(-x_mrg_ov)))
{
d_SP_OV_ygf_dX = 0.0;
SP_OV_ygf = (-xgs_ov);
d_SP_OV_z_dX = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dX+1.25*d_SP_OV_ygf_dX*inv_xi_ov);
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_eta_dX = 0.5*(d_SP_OV_z_dX-deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dX+d_SP_OV_z_dX*(SP_OV_z-6.0))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}
d_SP_OV_a_dX = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)+(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dX+d_GOV2_dX*(SP_OV_eta+1.0)));
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
d_SP_OV_c_dX = (2.0*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)-d_GOV2_dX);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));
d_SP_OV_tau_dX = (deriv_log_0_d0*(((GOV2*d_SP_OV_a_dX-SP_OV_a*d_GOV2_dX)/GOV2/GOV2))-d_SP_OV_eta_dX);
SP_OV_tau = (value_log_0-SP_OV_eta);
}
d_SP_OV_nu_dX = (d_SP_OV_a_dX+d_SP_OV_c_dX);
SP_OV_nu = (SP_OV_a+SP_OV_c);
d_SP_OV_mutau_dX = ((SP_OV_nu*d_SP_OV_nu_dX+d_SP_OV_nu_dX*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dX+0.5*d_SP_OV_c_dX*SP_OV_c)-d_SP_OV_a_dX)+d_SP_OV_tau_dX*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_temp_dX = (d_SP_OV_mutau_dX+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)*0.3333333333333-d_SP_OV_a_dX)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dX+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dX+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dX+((SP_OV_mutau*d_SP_OV_nu_dX-SP_OV_nu*d_SP_OV_mutau_dX)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_y0_dX = (d_SP_OV_eta_dX+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dX+(SP_OV_a*d_SP_OV_nu_dX+d_SP_OV_a_dX*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dX)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*(d_SP_OV_y0_dX);
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dX)*0.3333333333333+0.5*(-d_SP_OV_y0_dX)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dX)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dX*0.3333333333333+0.5*d_SP_OV_y0_dX*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dX*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_temp_dX = (d_SP_OV_ygf_dX-d_SP_OV_y0_dX);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);
d_SP_OV_p_dX = (2.0*d_SP_OV_temp_dX+(GOV2*d_SP_OV_D0_dX+d_GOV2_dX*(SP_OV_D0-1.0)));
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
d_SP_OV_q_dX = ((SP_OV_temp*d_SP_OV_temp_dX+d_SP_OV_temp_dX*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dX-d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_y0+1.0)-SP_OV_D0)));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_w_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xs_ov_dX = (-(d_SP_OV_y0_dX+d_SP_OV_w_dX));
xs_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{
d_SP_OV_Afac_dX = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dX+((xi_ov*1.25)*d_inv_xg1_dX+d_xi_ov_dX*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);
d_SP_OV_xbar_dX = ((xgs_ov*inv_xi_ov)*d_SP_OV_Afac_dX*xgs_ov+xgs_ov*d_inv_xi_ov_dX*(1.0+(SP_OV_Afac*xgs_ov)));
SP_OV_xbar = ((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_temp_dX = deriv_exp_0_d0*((-d_SP_OV_xbar_dX));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{
d_SP_OV_temp_dX = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dX))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dX))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dX))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_temp_dX = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dX)*0.3333333333333+0.5*(-d_SP_OV_xbar_dX)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dX)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_w_dX = (-d_SP_OV_temp_dX);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_x0_dX = (d_GOV2_dX*0.5-(GOV*deriv_sqrt_0_d0*((d_GOV2_dX*0.25-d_SP_OV_w_dX))+d_GOV_dX*value_sqrt_0));
SP_OV_x0 = ((xgs_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*((-d_SP_OV_x0_dX));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dX))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dX))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dX))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dX)*0.3333333333333+0.5*(-d_SP_OV_x0_dX)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dX)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_p_dX = (2.0*(-d_SP_OV_x0_dX)+(GOV2*(-d_SP_OV_D0_dX)+d_GOV2_dX*(1-SP_OV_D0)));
SP_OV_p = ((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
d_SP_OV_q_dX = (((xgs_ov-SP_OV_x0)*(-d_SP_OV_x0_dX)+(-d_SP_OV_x0_dX)*(xgs_ov-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dX+d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_x0-1.0)+SP_OV_D0)));
SP_OV_q = (((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_u_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xs_ov_dX = (d_SP_OV_x0_dX+d_SP_OV_u_dX);
xs_ov = (SP_OV_x0+SP_OV_u);
}
d_xs_ov_dX = (-d_xs_ov_dX);
xs_ov = (-xs_ov);
}
}
if ((instanceStruct.instanceVar_COV_i>0.0))
{
if ((fabs(xgs_ovcv)<=x_mrg_ov))
{
d_xs_ovcv_dX = ((-xgs_ovcv)*d_inv_xi_ov_dX+(-d_xgs_ovcv_dX)*inv_xi_ov);
xs_ovcv = ((-xgs_ovcv)*inv_xi_ov);
}
else
{
if ((xgs_ovcv<(-x_mrg_ov)))
{
d_SP_OV_ygf_dX = (-d_xgs_ovcv_dX);
SP_OV_ygf = (-xgs_ovcv);
d_SP_OV_z_dX = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dX+1.25*d_SP_OV_ygf_dX*inv_xi_ov);
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_eta_dX = 0.5*(d_SP_OV_z_dX-deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dX+d_SP_OV_z_dX*(SP_OV_z-6.0))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}
d_SP_OV_a_dX = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)+(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dX+d_GOV2_dX*(SP_OV_eta+1.0)));
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
d_SP_OV_c_dX = (2.0*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)-d_GOV2_dX);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));
d_SP_OV_tau_dX = (deriv_log_0_d0*(((GOV2*d_SP_OV_a_dX-SP_OV_a*d_GOV2_dX)/GOV2/GOV2))-d_SP_OV_eta_dX);
SP_OV_tau = (value_log_0-SP_OV_eta);
}
d_SP_OV_nu_dX = (d_SP_OV_a_dX+d_SP_OV_c_dX);
SP_OV_nu = (SP_OV_a+SP_OV_c);
d_SP_OV_mutau_dX = ((SP_OV_nu*d_SP_OV_nu_dX+d_SP_OV_nu_dX*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dX+0.5*d_SP_OV_c_dX*SP_OV_c)-d_SP_OV_a_dX)+d_SP_OV_tau_dX*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_temp_dX = (d_SP_OV_mutau_dX+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)*0.3333333333333-d_SP_OV_a_dX)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dX+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dX+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dX+((SP_OV_mutau*d_SP_OV_nu_dX-SP_OV_nu*d_SP_OV_mutau_dX)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_y0_dX = (d_SP_OV_eta_dX+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dX+(SP_OV_a*d_SP_OV_nu_dX+d_SP_OV_a_dX*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dX)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*(d_SP_OV_y0_dX);
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dX)*0.3333333333333+0.5*(-d_SP_OV_y0_dX)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dX)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dX*0.3333333333333+0.5*d_SP_OV_y0_dX*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dX*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_temp_dX = (d_SP_OV_ygf_dX-d_SP_OV_y0_dX);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);
d_SP_OV_p_dX = (2.0*d_SP_OV_temp_dX+(GOV2*d_SP_OV_D0_dX+d_GOV2_dX*(SP_OV_D0-1.0)));
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
d_SP_OV_q_dX = ((SP_OV_temp*d_SP_OV_temp_dX+d_SP_OV_temp_dX*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dX-d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_y0+1.0)-SP_OV_D0)));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_w_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xs_ovcv_dX = (-(d_SP_OV_y0_dX+d_SP_OV_w_dX));
xs_ovcv = (-(SP_OV_y0+SP_OV_w));
}
else
{
d_SP_OV_Afac_dX = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dX+((xi_ov*1.25)*d_inv_xg1_dX+d_xi_ov_dX*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);
d_SP_OV_xbar_dX = ((xgs_ovcv*inv_xi_ov)*(SP_OV_Afac*d_xgs_ovcv_dX+d_SP_OV_Afac_dX*xgs_ovcv)+(xgs_ovcv*d_inv_xi_ov_dX+d_xgs_ovcv_dX*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ovcv)));
SP_OV_xbar = ((xgs_ovcv*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ovcv)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_temp_dX = deriv_exp_0_d0*((-d_SP_OV_xbar_dX));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{
d_SP_OV_temp_dX = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dX))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dX))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dX))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_temp_dX = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dX)*0.3333333333333+0.5*(-d_SP_OV_xbar_dX)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dX)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_w_dX = (-d_SP_OV_temp_dX);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgs_ovcv+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_x0_dX = ((d_xgs_ovcv_dX+d_GOV2_dX*0.5)-(GOV*deriv_sqrt_0_d0*(((d_xgs_ovcv_dX+d_GOV2_dX*0.25)-d_SP_OV_w_dX))+d_GOV_dX*value_sqrt_0));
SP_OV_x0 = ((xgs_ovcv+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*((-d_SP_OV_x0_dX));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dX))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dX))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dX))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dX)*0.3333333333333+0.5*(-d_SP_OV_x0_dX)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dX)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_p_dX = (2.0*(d_xgs_ovcv_dX-d_SP_OV_x0_dX)+(GOV2*(-d_SP_OV_D0_dX)+d_GOV2_dX*(1-SP_OV_D0)));
SP_OV_p = ((2.0*(xgs_ovcv-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
d_SP_OV_q_dX = (((xgs_ovcv-SP_OV_x0)*(d_xgs_ovcv_dX-d_SP_OV_x0_dX)+(d_xgs_ovcv_dX-d_SP_OV_x0_dX)*(xgs_ovcv-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dX+d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_x0-1.0)+SP_OV_D0)));
SP_OV_q = (((xgs_ovcv-SP_OV_x0)*(xgs_ovcv-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_u_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xs_ovcv_dX = (d_SP_OV_x0_dX+d_SP_OV_u_dX);
xs_ovcv = (SP_OV_x0+SP_OV_u);
}
d_xs_ovcv_dX = (-d_xs_ovcv_dX);
xs_ovcv = (-xs_ovcv);
}
}
{
double value_sqrt_0 = sqrt(((((2.0*1.602176565E-19)*instanceStruct.instanceVar_NOVD_i)*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_GOV_dX = ((instanceStruct.instanceVar_Cox1Prime*deriv_sqrt_0_d0*((((2.0*1.602176565E-19)*instanceStruct.instanceVar_NOVD_i)*instanceStruct.d_instanceVar_epsch_dX+(2.0*1.602176565E-19)*instanceStruct.d_instanceVar_NOVD_i_dX*instanceStruct.instanceVar_epsch)*instanceStruct.instanceVar_inv_phit0)-value_sqrt_0*instanceStruct.d_instanceVar_Cox1Prime_dX)/instanceStruct.instanceVar_Cox1Prime/instanceStruct.instanceVar_Cox1Prime);
GOV = (value_sqrt_0/instanceStruct.instanceVar_Cox1Prime);
}
d_GOV2_dX = (GOV*d_GOV_dX+d_GOV_dX*GOV);
GOV2 = (GOV*GOV);
d_xi_ov_dX = (d_GOV_dX/1.4142135623731);
xi_ov = (1.0+(GOV/1.4142135623731));
d_x_mrg_ov_dX = 1.0e-5*d_xi_ov_dX;
x_mrg_ov = (1.0e-5*xi_ov);
d_inv_xi_ov_dX = (-d_xi_ov_dX/xi_ov/xi_ov);
inv_xi_ov = (1.0/xi_ov);
d_inv_xg1_dX = (-d_GOV_dX*7.324648775608221e-1/(1.25+(GOV*7.324648775608221e-1))/(1.25+(GOV*7.324648775608221e-1)));
inv_xg1 = (1.0/(1.25+(GOV*7.324648775608221e-1)));
if ((((modelStruct.modelPar_SWIGATE>0)&&((instanceStruct.instanceVar_IGOVINVD_i>0.0)||(instanceStruct.instanceVar_IGOVACCD_i>0.0)))||((modelStruct.modelPar_SWGIDL>0)&&(instanceStruct.instanceVar_AGIDLD_i>0.0))))
{
if ((fabs(xgd_ov)<=x_mrg_ov))
{
d_xd_ov_dX = (-xgd_ov)*d_inv_xi_ov_dX;
xd_ov = ((-xgd_ov)*inv_xi_ov);
}
else
{
if ((xgd_ov<(-x_mrg_ov)))
{
d_SP_OV_ygf_dX = 0.0;
SP_OV_ygf = (-xgd_ov);
d_SP_OV_z_dX = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dX+1.25*d_SP_OV_ygf_dX*inv_xi_ov);
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_eta_dX = 0.5*(d_SP_OV_z_dX-deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dX+d_SP_OV_z_dX*(SP_OV_z-6.0))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}
d_SP_OV_a_dX = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)+(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dX+d_GOV2_dX*(SP_OV_eta+1.0)));
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
d_SP_OV_c_dX = (2.0*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)-d_GOV2_dX);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));
d_SP_OV_tau_dX = (deriv_log_0_d0*(((GOV2*d_SP_OV_a_dX-SP_OV_a*d_GOV2_dX)/GOV2/GOV2))-d_SP_OV_eta_dX);
SP_OV_tau = (value_log_0-SP_OV_eta);
}
d_SP_OV_nu_dX = (d_SP_OV_a_dX+d_SP_OV_c_dX);
SP_OV_nu = (SP_OV_a+SP_OV_c);
d_SP_OV_mutau_dX = ((SP_OV_nu*d_SP_OV_nu_dX+d_SP_OV_nu_dX*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dX+0.5*d_SP_OV_c_dX*SP_OV_c)-d_SP_OV_a_dX)+d_SP_OV_tau_dX*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_temp_dX = (d_SP_OV_mutau_dX+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)*0.3333333333333-d_SP_OV_a_dX)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dX+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dX+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dX+((SP_OV_mutau*d_SP_OV_nu_dX-SP_OV_nu*d_SP_OV_mutau_dX)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_y0_dX = (d_SP_OV_eta_dX+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dX+(SP_OV_a*d_SP_OV_nu_dX+d_SP_OV_a_dX*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dX)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*(d_SP_OV_y0_dX);
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dX)*0.3333333333333+0.5*(-d_SP_OV_y0_dX)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dX)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dX*0.3333333333333+0.5*d_SP_OV_y0_dX*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dX*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_temp_dX = (d_SP_OV_ygf_dX-d_SP_OV_y0_dX);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);
d_SP_OV_p_dX = (2.0*d_SP_OV_temp_dX+(GOV2*d_SP_OV_D0_dX+d_GOV2_dX*(SP_OV_D0-1.0)));
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
d_SP_OV_q_dX = ((SP_OV_temp*d_SP_OV_temp_dX+d_SP_OV_temp_dX*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dX-d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_y0+1.0)-SP_OV_D0)));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_w_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xd_ov_dX = (-(d_SP_OV_y0_dX+d_SP_OV_w_dX));
xd_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{
d_SP_OV_Afac_dX = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dX+((xi_ov*1.25)*d_inv_xg1_dX+d_xi_ov_dX*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);
d_SP_OV_xbar_dX = ((xgd_ov*inv_xi_ov)*d_SP_OV_Afac_dX*xgd_ov+xgd_ov*d_inv_xi_ov_dX*(1.0+(SP_OV_Afac*xgd_ov)));
SP_OV_xbar = ((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_temp_dX = deriv_exp_0_d0*((-d_SP_OV_xbar_dX));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{
d_SP_OV_temp_dX = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dX))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dX))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dX))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_temp_dX = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dX)*0.3333333333333+0.5*(-d_SP_OV_xbar_dX)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dX)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_w_dX = (-d_SP_OV_temp_dX);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_x0_dX = (d_GOV2_dX*0.5-(GOV*deriv_sqrt_0_d0*((d_GOV2_dX*0.25-d_SP_OV_w_dX))+d_GOV_dX*value_sqrt_0));
SP_OV_x0 = ((xgd_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*((-d_SP_OV_x0_dX));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dX))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dX))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dX))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dX)*0.3333333333333+0.5*(-d_SP_OV_x0_dX)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dX)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_p_dX = (2.0*(-d_SP_OV_x0_dX)+(GOV2*(-d_SP_OV_D0_dX)+d_GOV2_dX*(1-SP_OV_D0)));
SP_OV_p = ((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
d_SP_OV_q_dX = (((xgd_ov-SP_OV_x0)*(-d_SP_OV_x0_dX)+(-d_SP_OV_x0_dX)*(xgd_ov-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dX+d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_x0-1.0)+SP_OV_D0)));
SP_OV_q = (((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_u_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xd_ov_dX = (d_SP_OV_x0_dX+d_SP_OV_u_dX);
xd_ov = (SP_OV_x0+SP_OV_u);
}
d_xd_ov_dX = (-d_xd_ov_dX);
xd_ov = (-xd_ov);
}
}
if ((instanceStruct.instanceVar_COVD_i>0.0))
{
if ((fabs(xgd_ovcv)<=x_mrg_ov))
{
d_xd_ovcv_dX = ((-xgd_ovcv)*d_inv_xi_ov_dX+(-d_xgd_ovcv_dX)*inv_xi_ov);
xd_ovcv = ((-xgd_ovcv)*inv_xi_ov);
}
else
{
if ((xgd_ovcv<(-x_mrg_ov)))
{
d_SP_OV_ygf_dX = (-d_xgd_ovcv_dX);
SP_OV_ygf = (-xgd_ovcv);
d_SP_OV_z_dX = ((1.25*SP_OV_ygf)*d_inv_xi_ov_dX+1.25*d_SP_OV_ygf_dX*inv_xi_ov);
SP_OV_z = ((1.25*SP_OV_ygf)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_eta_dX = 0.5*(d_SP_OV_z_dX-deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dX+d_SP_OV_z_dX*(SP_OV_z-6.0))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}
d_SP_OV_a_dX = (((SP_OV_ygf-SP_OV_eta)*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)+(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)*(SP_OV_ygf-SP_OV_eta))+(GOV2*d_SP_OV_eta_dX+d_GOV2_dX*(SP_OV_eta+1.0)));
SP_OV_a = (((SP_OV_ygf-SP_OV_eta)*(SP_OV_ygf-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
d_SP_OV_c_dX = (2.0*(d_SP_OV_ygf_dX-d_SP_OV_eta_dX)-d_GOV2_dX);
SP_OV_c = ((2.0*(SP_OV_ygf-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));
d_SP_OV_tau_dX = (deriv_log_0_d0*(((GOV2*d_SP_OV_a_dX-SP_OV_a*d_GOV2_dX)/GOV2/GOV2))-d_SP_OV_eta_dX);
SP_OV_tau = (value_log_0-SP_OV_eta);
}
d_SP_OV_nu_dX = (d_SP_OV_a_dX+d_SP_OV_c_dX);
SP_OV_nu = (SP_OV_a+SP_OV_c);
d_SP_OV_mutau_dX = ((SP_OV_nu*d_SP_OV_nu_dX+d_SP_OV_nu_dX*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*d_SP_OV_c_dX+0.5*d_SP_OV_c_dX*SP_OV_c)-d_SP_OV_a_dX)+d_SP_OV_tau_dX*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
SP_OV_mutau = ((SP_OV_nu*SP_OV_nu)+(SP_OV_tau*(((0.5*SP_OV_c)*SP_OV_c)-SP_OV_a)));
d_SP_OV_temp_dX = (d_SP_OV_mutau_dX+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)*0.3333333333333-d_SP_OV_a_dX)+((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dX+(((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*d_SP_OV_tau_dX+((SP_OV_nu/SP_OV_mutau)*d_SP_OV_tau_dX+((SP_OV_mutau*d_SP_OV_nu_dX-SP_OV_nu*d_SP_OV_mutau_dX)/SP_OV_mutau/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
SP_OV_temp = (SP_OV_mutau+(((((SP_OV_nu/SP_OV_mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*0.3333333333333)-SP_OV_a)));
d_SP_OV_y0_dX = (d_SP_OV_eta_dX+((SP_OV_temp*((SP_OV_a*SP_OV_nu)*d_SP_OV_tau_dX+(SP_OV_a*d_SP_OV_nu_dX+d_SP_OV_a_dX*SP_OV_nu)*SP_OV_tau)-((SP_OV_a*SP_OV_nu)*SP_OV_tau)*d_SP_OV_temp_dX)/SP_OV_temp/SP_OV_temp));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*SP_OV_nu)*SP_OV_tau)/SP_OV_temp));
if ((fabs(SP_OV_y0)<80.0))
{
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*(d_SP_OV_y0_dX);
SP_OV_D0 = value_exp_0;
}
}
else
{
if ((SP_OV_y0<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-SP_OV_y0)-80.0)*((0.5*((-SP_OV_y0)-80.0))*(-d_SP_OV_y0_dX)*0.3333333333333+0.5*(-d_SP_OV_y0_dX)*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))+(-d_SP_OV_y0_dX)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333))))))/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-SP_OV_y0)-80.0)*(1.0+((0.5*((-SP_OV_y0)-80.0))*(1.0+(((-SP_OV_y0)-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*((SP_OV_y0-80.0)*((0.5*(SP_OV_y0-80.0))*d_SP_OV_y0_dX*0.3333333333333+0.5*d_SP_OV_y0_dX*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))+d_SP_OV_y0_dX*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+((SP_OV_y0-80.0)*(1.0+((0.5*(SP_OV_y0-80.0))*(1.0+((SP_OV_y0-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_temp_dX = (d_SP_OV_ygf_dX-d_SP_OV_y0_dX);
SP_OV_temp = (SP_OV_ygf-SP_OV_y0);
d_SP_OV_p_dX = (2.0*d_SP_OV_temp_dX+(GOV2*d_SP_OV_D0_dX+d_GOV2_dX*(SP_OV_D0-1.0)));
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
d_SP_OV_q_dX = ((SP_OV_temp*d_SP_OV_temp_dX+d_SP_OV_temp_dX*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dX-d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_y0+1.0)-SP_OV_D0)));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_w_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xd_ovcv_dX = (-(d_SP_OV_y0_dX+d_SP_OV_w_dX));
xd_ovcv = (-(SP_OV_y0+SP_OV_w));
}
else
{
d_SP_OV_Afac_dX = ((((xi_ov*1.25)*inv_xg1)-1.0)*d_inv_xg1_dX+((xi_ov*1.25)*d_inv_xg1_dX+d_xi_ov_dX*1.25*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*1.25)*inv_xg1)-1.0)*inv_xg1);
d_SP_OV_xbar_dX = ((xgd_ovcv*inv_xi_ov)*(SP_OV_Afac*d_xgd_ovcv_dX+d_SP_OV_Afac_dX*xgd_ovcv)+(xgd_ovcv*d_inv_xi_ov_dX+d_xgd_ovcv_dX*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ovcv)));
SP_OV_xbar = ((xgd_ovcv*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ovcv)));
if ((fabs((-SP_OV_xbar))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_temp_dX = deriv_exp_0_d0*((-d_SP_OV_xbar_dX));
SP_OV_temp = value_exp_0;
}
}
else
{
if (((-SP_OV_xbar)<(-80.0)))
{
d_SP_OV_temp_dX = (-1.80485e-35*(((-(-SP_OV_xbar))-80.0)*((0.5*((-(-SP_OV_xbar))-80.0))*(-(-d_SP_OV_xbar_dX))*0.3333333333333+0.5*(-(-d_SP_OV_xbar_dX))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))+(-(-d_SP_OV_xbar_dX))*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
SP_OV_temp = (1.80485e-35/(1.0+(((-(-SP_OV_xbar))-80.0)*(1.0+((0.5*((-(-SP_OV_xbar))-80.0))*(1.0+(((-(-SP_OV_xbar))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_temp_dX = 5.54062e34*(((-SP_OV_xbar)-80.0)*((0.5*((-SP_OV_xbar)-80.0))*(-d_SP_OV_xbar_dX)*0.3333333333333+0.5*(-d_SP_OV_xbar_dX)*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))+(-d_SP_OV_xbar_dX)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))));
SP_OV_temp = (5.54062e34*(1.0+(((-SP_OV_xbar)-80.0)*(1.0+((0.5*((-SP_OV_xbar)-80.0))*(1.0+(((-SP_OV_xbar)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_w_dX = (-d_SP_OV_temp_dX);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgd_ovcv+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_x0_dX = ((d_xgd_ovcv_dX+d_GOV2_dX*0.5)-(GOV*deriv_sqrt_0_d0*(((d_xgd_ovcv_dX+d_GOV2_dX*0.25)-d_SP_OV_w_dX))+d_GOV_dX*value_sqrt_0));
SP_OV_x0 = ((xgd_ovcv+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if ((fabs((-SP_OV_x0))<80.0))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*((-d_SP_OV_x0_dX));
SP_OV_D0 = value_exp_0;
}
}
else
{
if (((-SP_OV_x0)<(-80.0)))
{
d_SP_OV_D0_dX = (-1.80485e-35*(((-(-SP_OV_x0))-80.0)*((0.5*((-(-SP_OV_x0))-80.0))*(-(-d_SP_OV_x0_dX))*0.3333333333333+0.5*(-(-d_SP_OV_x0_dX))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))+(-(-d_SP_OV_x0_dX))*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333))))))/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
SP_OV_D0 = (1.80485e-35/(1.0+(((-(-SP_OV_x0))-80.0)*(1.0+((0.5*((-(-SP_OV_x0))-80.0))*(1.0+(((-(-SP_OV_x0))-80.0)*0.3333333333333)))))));
}
else
{
d_SP_OV_D0_dX = 5.54062e34*(((-SP_OV_x0)-80.0)*((0.5*((-SP_OV_x0)-80.0))*(-d_SP_OV_x0_dX)*0.3333333333333+0.5*(-d_SP_OV_x0_dX)*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))+(-d_SP_OV_x0_dX)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))));
SP_OV_D0 = (5.54062e34*(1.0+(((-SP_OV_x0)-80.0)*(1.0+((0.5*((-SP_OV_x0)-80.0))*(1.0+(((-SP_OV_x0)-80.0)*0.3333333333333)))))));
}
}
d_SP_OV_p_dX = (2.0*(d_xgd_ovcv_dX-d_SP_OV_x0_dX)+(GOV2*(-d_SP_OV_D0_dX)+d_GOV2_dX*(1-SP_OV_D0)));
SP_OV_p = ((2.0*(xgd_ovcv-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
d_SP_OV_q_dX = (((xgd_ovcv-SP_OV_x0)*(d_xgd_ovcv_dX-d_SP_OV_x0_dX)+(d_xgd_ovcv_dX-d_SP_OV_x0_dX)*(xgd_ovcv-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dX+d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_x0-1.0)+SP_OV_D0)));
SP_OV_q = (((xgd_ovcv-SP_OV_x0)*(xgd_ovcv-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_u_dX = (((SP_OV_p+value_sqrt_0)*2.0*d_SP_OV_q_dX-(2.0*SP_OV_q)*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = ((2.0*SP_OV_q)/(SP_OV_p+value_sqrt_0));
}
d_xd_ovcv_dX = (d_SP_OV_x0_dX+d_SP_OV_u_dX);
xd_ovcv = (SP_OV_x0+SP_OV_u);
}
d_xd_ovcv_dX = (-d_xd_ovcv_dX);
xd_ovcv = (-xd_ovcv);
}
}
d_Vovs_dX = (-instanceStruct.instanceVar_phit0)*d_xs_ov_dX;
Vovs = ((-instanceStruct.instanceVar_phit0)*(xgs_ov+xs_ov));
d_Vovd_dX = (-instanceStruct.instanceVar_phit0)*d_xd_ov_dX;
Vovd = ((-instanceStruct.instanceVar_phit0)*(xgd_ov+xd_ov));
d_Vovscv_dX = (-instanceStruct.instanceVar_phit0)*(d_xgs_ovcv_dX+d_xs_ovcv_dX);
Vovscv = ((-instanceStruct.instanceVar_phit0)*(xgs_ovcv+xs_ovcv));
d_Vovdcv_dX = (-instanceStruct.instanceVar_phit0)*(d_xgd_ovcv_dX+d_xd_ovcv_dX);
Vovdcv = ((-instanceStruct.instanceVar_phit0)*(xgd_ovcv+xd_ovcv));
d_Igsov_dX = 0.0;
Igsov = 0.0;
d_Igdov_dX = 0.0;
Igdov = 0.0;
d_Igc_dX = 0.0;
Igc = 0.0;
d_Igs_dX = 0.0;
Igs = 0.0;
d_Igd_dX = 0.0;
Igd = 0.0;
d_Igcs_dX = 0.0;
Igcs = 0.0;
d_Igcd_dX = 0.0;
Igcd = 0.0;
if ((modelStruct.modelPar_SWIGATE>0))
{
if (((instanceStruct.instanceVar_IGOVINV_i>0.0)||(instanceStruct.instanceVar_IGOVACC_i>0.0)))
{
d_arg2mina_dX = (d_Vovs_dX+instanceStruct.d_instanceVar_Dov_dX);
arg2mina = (Vovs+instanceStruct.instanceVar_Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psi_t_dX = 0.5*(d_arg2mina_dX-deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dX)+(-d_arg2mina_dX)*(-arg2mina))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Vovs*d_Vovs_dX+d_Vovs_dX*Vovs))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((fabs((0.5*xgs_ov))<80.0))
{
{
double value_exp_0 = exp((0.5*xgs_ov));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = value_exp_0;
}
}
else
{
if (((0.5*xgs_ov)<(-80.0)))
{
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = (1.80485e-35/(1.0+((((-0.5)*xgs_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgs_ov)-80.0))*(1.0+((((-0.5)*xgs_ov)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = (5.54062e34*(1.0+(((0.5*xgs_ov)-80.0)*(1.0+((0.5*((0.5*xgs_ov)-80.0))*(1.0+(((0.5*xgs_ov)-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp1_dX = (-instanceStruct.d_instanceVar_temp_dX/(1.0+instanceStruct.instanceVar_temp)/(1.0+instanceStruct.instanceVar_temp));
instanceStruct.instanceVar_temp1 = (1.0/(1.0+instanceStruct.instanceVar_temp));
instanceStruct.d_instanceVar_temp2_dX = (-instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp2 = (1.0-instanceStruct.instanceVar_temp1);
d_gc2oveff_dX = ((instanceStruct.instanceVar_GC2OVACC_i*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_GC2OVACC_i_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC2OVINV_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_GC2OVINV_i_dX*instanceStruct.instanceVar_temp2));
gc2oveff = ((instanceStruct.instanceVar_GC2OVACC_i*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC2OVINV_i*instanceStruct.instanceVar_temp2));
d_gc3oveff_dX = ((instanceStruct.instanceVar_GC3OVACC_i*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_GC3OVACC_i_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC3OVINV_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_GC3OVINV_i_dX*instanceStruct.instanceVar_temp2));
gc3oveff = ((instanceStruct.instanceVar_GC3OVACC_i*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC3OVINV_i*instanceStruct.instanceVar_temp2));
d_gcqoveff_dX = ((instanceStruct.instanceVar_GCQOVACC*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_GCQOVACC_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GCQOVINV*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_GCQOVINV_dX*instanceStruct.instanceVar_temp2));
gcqoveff = ((instanceStruct.instanceVar_GCQOVACC*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GCQOVINV*instanceStruct.instanceVar_temp2));
d_igoveff_dX = ((instanceStruct.instanceVar_IGOVACC_i*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_IGOVACC_i_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_IGOVINV_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_IGOVINV_i_dX*instanceStruct.instanceVar_temp2));
igoveff = ((instanceStruct.instanceVar_IGOVACC_i*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_IGOVINV_i*instanceStruct.instanceVar_temp2));
d_igovefffowler_dX = (instanceStruct.instanceVar_FNOVINV_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_FNOVINV_i_dX*instanceStruct.instanceVar_temp2)*1.0e-6;
igovefffowler = ((instanceStruct.instanceVar_FNOVINV_i*instanceStruct.instanceVar_temp2)*1.0e-6);
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_BOV*((zg*(-1.0)*instanceStruct.d_instanceVar_GCOVINVFN_i_dX-((-1.0)*instanceStruct.instanceVar_GCOVINVFN_i)*d_zg_dX)/zg/zg)+instanceStruct.d_instanceVar_BOV_dX*(((-1.0)*instanceStruct.instanceVar_GCOVINVFN_i)/zg));
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_BOV*(((-1.0)*instanceStruct.instanceVar_GCOVINVFN_i)/zg));
if ((gc3oveff<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-gcqoveff)*(zg-gcqoveff))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+d_gcqoveff_dX)-deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dX-d_gcqoveff_dX)+(d_zg_dX-d_gcqoveff_dX)*(zg-gcqoveff))));
zg = (0.5*((zg+gcqoveff)-value_sqrt_0));
}
}
d_arg1_dX = (d_xs_ov_dX+d_psi_t_dX*instanceStruct.instanceVar_inv_phit0);
arg1 = ((3.0+xs_ov)+(psi_t*instanceStruct.instanceVar_inv_phit0));
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dsi_dX = deriv_exp_0_d0*(d_arg1_dX);
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{
d_Dsi_dX = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dX)*0.3333333333333+0.5*(-d_arg1_dX)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dX)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dsi = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{
d_Dsi_dX = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dX*0.3333333333333+0.5*d_arg1_dX*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dX*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dsi = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}
d_arg1_dX = (d_xs_ov_dX+d_psi_t_dX*instanceStruct.instanceVar_inv_phit0);
arg1 = (((3.0+xs_ov)+(psi_t*instanceStruct.instanceVar_inv_phit0))+xgs_ov);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dgate_dX = deriv_exp_0_d0*(d_arg1_dX);
Dgate = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{
d_Dgate_dX = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dX)*0.3333333333333+0.5*(-d_arg1_dX)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dX)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dgate = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{
d_Dgate_dX = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dX*0.3333333333333+0.5*d_arg1_dX*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dX*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dgate = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_BOV*(zg*(d_gc2oveff_dX+(gc3oveff*d_zg_dX+d_gc3oveff_dX*zg))+d_zg_dX*(gc2oveff+(gc3oveff*zg)))+instanceStruct.d_instanceVar_BOV_dX*((-1.5)+(zg*(gc2oveff+(gc3oveff*zg)))));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_BOV*((-1.5)+(zg*(gc2oveff+(gc3oveff*zg)))));
if ((instanceStruct.instanceVar_temp>0.0))
{
d_TP_dX = (instanceStruct.instanceVar_temp*((0.5*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp_dX*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333)))+instanceStruct.d_instanceVar_temp_dX*(1.0+((0.5*instanceStruct.instanceVar_temp)*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333)))));
TP = (1.0+(instanceStruct.instanceVar_temp*(1.0+((0.5*instanceStruct.instanceVar_temp)*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333))))));
}
else
{
if ((instanceStruct.instanceVar_temp>(-80.0)))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp)-80.0)*((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(-instanceStruct.d_instanceVar_temp_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp_dX)*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
TP = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
}
}
if ((instanceStruct.instanceVar_temp1>0.0))
{
d_TP2_dX = (instanceStruct.instanceVar_temp1*((0.5*instanceStruct.instanceVar_temp1)*instanceStruct.d_instanceVar_temp1_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp1_dX*(1.0+(instanceStruct.instanceVar_temp1*0.3333333333333)))+instanceStruct.d_instanceVar_temp1_dX*(1.0+((0.5*instanceStruct.instanceVar_temp1)*(1.0+(instanceStruct.instanceVar_temp1*0.3333333333333)))));
TP2 = (1.0+(instanceStruct.instanceVar_temp1*(1.0+((0.5*instanceStruct.instanceVar_temp1)*(1.0+(instanceStruct.instanceVar_temp1*0.3333333333333))))));
}
else
{
if ((instanceStruct.instanceVar_temp1>(-80.0)))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp1);
double  deriv_exp_0_d0 = value_exp_0;
d_TP2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp1_dX);
TP2 = value_exp_0;
}
}
else
{
d_TP2_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp1)-80.0)*((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(-instanceStruct.d_instanceVar_temp1_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
TP2 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp_dX = (((1.0+Dgate)*d_Dsi_dX-(1.0+Dsi)*d_Dgate_dX)/(1.0+Dgate)/(1.0+Dgate));
instanceStruct.instanceVar_temp = ((1.0+Dsi)/(1.0+Dgate));
if ((instanceStruct.instanceVar_temp<1.0e-80))
{
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = 1.0e-80;
}
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_GCDOV_i*(-instanceStruct.d_instanceVar_GCVDOV_i_dX)+instanceStruct.d_instanceVar_GCDOV_i_dX*(Vgdu-instanceStruct.instanceVar_GCVDOV_i));
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_GCDOV_i*(Vgdu-instanceStruct.instanceVar_GCVDOV_i));
if ((fabs(instanceStruct.instanceVar_temp1)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp1);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp2 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp1<(-80.0)))
{
instanceStruct.d_instanceVar_temp2_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp1)-80.0)*((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(-instanceStruct.d_instanceVar_temp1_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp2 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp2_dX = 5.54062e34*((instanceStruct.instanceVar_temp1-80.0)*((0.5*(instanceStruct.instanceVar_temp1-80.0))*instanceStruct.d_instanceVar_temp1_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp1_dX*(1.0+((instanceStruct.instanceVar_temp1-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp1_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp1-80.0))*(1.0+((instanceStruct.instanceVar_temp1-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp2 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp1-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp1-80.0))*(1.0+((instanceStruct.instanceVar_temp1-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp3_dX = (instanceStruct.d_instanceVar_GCDOV_i_dX*Vsdu+instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp3 = ((instanceStruct.instanceVar_GCDOV_i*Vsdu)+instanceStruct.instanceVar_temp1);
if ((fabs(instanceStruct.instanceVar_temp3)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp3);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp4_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp3_dX);
instanceStruct.instanceVar_temp4 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp3<(-80.0)))
{
instanceStruct.d_instanceVar_temp4_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp3)-80.0)*((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(-instanceStruct.d_instanceVar_temp3_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp4 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp4_dX = 5.54062e34*((instanceStruct.instanceVar_temp3-80.0)*((0.5*(instanceStruct.instanceVar_temp3-80.0))*instanceStruct.d_instanceVar_temp3_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp3_dX*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp3_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp4 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp3-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))))));
}
}
{
double value_log_0 = log(instanceStruct.instanceVar_temp);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_temp);
d_Igsov_dX = ((((1.0+instanceStruct.instanceVar_temp4)*(((igoveff*TP)*value_log_0)*instanceStruct.d_instanceVar_temp2_dX+((igoveff*TP)*deriv_log_0_d0*(instanceStruct.d_instanceVar_temp_dX)+(igoveff*d_TP_dX+d_igoveff_dX*TP)*value_log_0)*(1.0+instanceStruct.instanceVar_temp2))-(((igoveff*TP)*value_log_0)*(1.0+instanceStruct.instanceVar_temp2))*instanceStruct.d_instanceVar_temp4_dX)/(1.0+instanceStruct.instanceVar_temp4)/(1.0+instanceStruct.instanceVar_temp4))-(((1.0+instanceStruct.instanceVar_temp4)*((igovefffowler*TP2)*instanceStruct.d_instanceVar_temp2_dX+(igovefffowler*d_TP2_dX+d_igovefffowler_dX*TP2)*(1.0+instanceStruct.instanceVar_temp2))-((igovefffowler*TP2)*(1.0+instanceStruct.instanceVar_temp2))*instanceStruct.d_instanceVar_temp4_dX)/(1.0+instanceStruct.instanceVar_temp4)/(1.0+instanceStruct.instanceVar_temp4)));
Igsov = (((((igoveff*TP)*value_log_0)*(1.0+instanceStruct.instanceVar_temp2))/(1.0+instanceStruct.instanceVar_temp4))-(((igovefffowler*TP2)*(1.0+instanceStruct.instanceVar_temp2))/(1.0+instanceStruct.instanceVar_temp4)));
}
}
if (((instanceStruct.instanceVar_IGOVINVD_i>0.0)||(instanceStruct.instanceVar_IGOVACCD_i>0.0)))
{
d_arg2mina_dX = (d_Vovd_dX+instanceStruct.d_instanceVar_Dov_dX);
arg2mina = (Vovd+instanceStruct.instanceVar_Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psi_t_dX = 0.5*(d_arg2mina_dX-deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dX)+(-d_arg2mina_dX)*(-arg2mina))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Vovd*d_Vovd_dX+d_Vovd_dX*Vovd))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((fabs((0.5*xgd_ov))<80.0))
{
{
double value_exp_0 = exp((0.5*xgd_ov));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = value_exp_0;
}
}
else
{
if (((0.5*xgd_ov)<(-80.0)))
{
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = (1.80485e-35/(1.0+((((-0.5)*xgd_ov)-80.0)*(1.0+((0.5*(((-0.5)*xgd_ov)-80.0))*(1.0+((((-0.5)*xgd_ov)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = (5.54062e34*(1.0+(((0.5*xgd_ov)-80.0)*(1.0+((0.5*((0.5*xgd_ov)-80.0))*(1.0+(((0.5*xgd_ov)-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp1_dX = (-instanceStruct.d_instanceVar_temp_dX/(1.0+instanceStruct.instanceVar_temp)/(1.0+instanceStruct.instanceVar_temp));
instanceStruct.instanceVar_temp1 = (1.0/(1.0+instanceStruct.instanceVar_temp));
instanceStruct.d_instanceVar_temp2_dX = (-instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp2 = (1.0-instanceStruct.instanceVar_temp1);
d_gc2oveff_dX = ((instanceStruct.instanceVar_GC2OVACC_i*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_GC2OVACC_i_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC2OVINV_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_GC2OVINV_i_dX*instanceStruct.instanceVar_temp2));
gc2oveff = ((instanceStruct.instanceVar_GC2OVACC_i*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC2OVINV_i*instanceStruct.instanceVar_temp2));
d_gc3oveff_dX = ((instanceStruct.instanceVar_GC3OVACC_i*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_GC3OVACC_i_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC3OVINV_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_GC3OVINV_i_dX*instanceStruct.instanceVar_temp2));
gc3oveff = ((instanceStruct.instanceVar_GC3OVACC_i*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GC3OVINV_i*instanceStruct.instanceVar_temp2));
d_gcqoveff_dX = ((instanceStruct.instanceVar_GCQOVACC*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_GCQOVACC_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GCQOVINV*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_GCQOVINV_dX*instanceStruct.instanceVar_temp2));
gcqoveff = ((instanceStruct.instanceVar_GCQOVACC*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_GCQOVINV*instanceStruct.instanceVar_temp2));
d_igoveff_dX = ((instanceStruct.instanceVar_IGOVACCD_i*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_IGOVACCD_i_dX*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_IGOVINVD_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_IGOVINVD_i_dX*instanceStruct.instanceVar_temp2));
igoveff = ((instanceStruct.instanceVar_IGOVACCD_i*instanceStruct.instanceVar_temp1)+(instanceStruct.instanceVar_IGOVINVD_i*instanceStruct.instanceVar_temp2));
d_igovefffowler_dX = (instanceStruct.instanceVar_FNOVINVD_i*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_FNOVINVD_i_dX*instanceStruct.instanceVar_temp2)*1.0e-6;
igovefffowler = ((instanceStruct.instanceVar_FNOVINVD_i*instanceStruct.instanceVar_temp2)*1.0e-6);
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_BOV*((zg*(-1.0)*instanceStruct.d_instanceVar_GCOVINVFN_i_dX-((-1.0)*instanceStruct.instanceVar_GCOVINVFN_i)*d_zg_dX)/zg/zg)+instanceStruct.d_instanceVar_BOV_dX*(((-1.0)*instanceStruct.instanceVar_GCOVINVFN_i)/zg));
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_BOV*(((-1.0)*instanceStruct.instanceVar_GCOVINVFN_i)/zg));
if ((gc3oveff<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-gcqoveff)*(zg-gcqoveff))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+d_gcqoveff_dX)-deriv_sqrt_0_d0*(((zg-gcqoveff)*(d_zg_dX-d_gcqoveff_dX)+(d_zg_dX-d_gcqoveff_dX)*(zg-gcqoveff))));
zg = (0.5*((zg+gcqoveff)-value_sqrt_0));
}
}
d_arg1_dX = (d_xd_ov_dX+d_psi_t_dX*instanceStruct.instanceVar_inv_phit0);
arg1 = ((3.0+xd_ov)+(psi_t*instanceStruct.instanceVar_inv_phit0));
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dsi_dX = deriv_exp_0_d0*(d_arg1_dX);
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{
d_Dsi_dX = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dX)*0.3333333333333+0.5*(-d_arg1_dX)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dX)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dsi = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{
d_Dsi_dX = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dX*0.3333333333333+0.5*d_arg1_dX*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dX*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dsi = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}
d_arg1_dX = (d_xd_ov_dX+d_psi_t_dX*instanceStruct.instanceVar_inv_phit0);
arg1 = (((3.0+xd_ov)+(psi_t*instanceStruct.instanceVar_inv_phit0))+xgd_ov);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dgate_dX = deriv_exp_0_d0*(d_arg1_dX);
Dgate = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{
d_Dgate_dX = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dX)*0.3333333333333+0.5*(-d_arg1_dX)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dX)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dgate = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{
d_Dgate_dX = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dX*0.3333333333333+0.5*d_arg1_dX*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dX*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dgate = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_BOV*(zg*(d_gc2oveff_dX+(gc3oveff*d_zg_dX+d_gc3oveff_dX*zg))+d_zg_dX*(gc2oveff+(gc3oveff*zg)))+instanceStruct.d_instanceVar_BOV_dX*((-1.5)+(zg*(gc2oveff+(gc3oveff*zg)))));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_BOV*((-1.5)+(zg*(gc2oveff+(gc3oveff*zg)))));
if ((instanceStruct.instanceVar_temp>0.0))
{
d_TP_dX = (instanceStruct.instanceVar_temp*((0.5*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp_dX*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333)))+instanceStruct.d_instanceVar_temp_dX*(1.0+((0.5*instanceStruct.instanceVar_temp)*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333)))));
TP = (1.0+(instanceStruct.instanceVar_temp*(1.0+((0.5*instanceStruct.instanceVar_temp)*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333))))));
}
else
{
if ((instanceStruct.instanceVar_temp>(-80.0)))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp)-80.0)*((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(-instanceStruct.d_instanceVar_temp_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp_dX)*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
TP = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
}
}
if ((instanceStruct.instanceVar_temp1>0.0))
{
d_TP2_dX = (instanceStruct.instanceVar_temp1*((0.5*instanceStruct.instanceVar_temp1)*instanceStruct.d_instanceVar_temp1_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp1_dX*(1.0+(instanceStruct.instanceVar_temp1*0.3333333333333)))+instanceStruct.d_instanceVar_temp1_dX*(1.0+((0.5*instanceStruct.instanceVar_temp1)*(1.0+(instanceStruct.instanceVar_temp1*0.3333333333333)))));
TP2 = (1.0+(instanceStruct.instanceVar_temp1*(1.0+((0.5*instanceStruct.instanceVar_temp1)*(1.0+(instanceStruct.instanceVar_temp1*0.3333333333333))))));
}
else
{
if ((instanceStruct.instanceVar_temp1>(-80.0)))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp1);
double  deriv_exp_0_d0 = value_exp_0;
d_TP2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp1_dX);
TP2 = value_exp_0;
}
}
else
{
d_TP2_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp1)-80.0)*((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(-instanceStruct.d_instanceVar_temp1_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
TP2 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp_dX = (((1.0+Dgate)*d_Dsi_dX-(1.0+Dsi)*d_Dgate_dX)/(1.0+Dgate)/(1.0+Dgate));
instanceStruct.instanceVar_temp = ((1.0+Dsi)/(1.0+Dgate));
if ((instanceStruct.instanceVar_temp<1.0e-80))
{
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = 1.0e-80;
}
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_GCDOV_i*(-instanceStruct.d_instanceVar_GCVDOV_i_dX)+instanceStruct.d_instanceVar_GCDOV_i_dX*(Vgsu-instanceStruct.instanceVar_GCVDOV_i));
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_GCDOV_i*(Vgsu-instanceStruct.instanceVar_GCVDOV_i));
if ((fabs(instanceStruct.instanceVar_temp1)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp1);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp2 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp1<(-80.0)))
{
instanceStruct.d_instanceVar_temp2_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp1)-80.0)*((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(-instanceStruct.d_instanceVar_temp1_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp1_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp2 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp1)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp1)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp2_dX = 5.54062e34*((instanceStruct.instanceVar_temp1-80.0)*((0.5*(instanceStruct.instanceVar_temp1-80.0))*instanceStruct.d_instanceVar_temp1_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp1_dX*(1.0+((instanceStruct.instanceVar_temp1-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp1_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp1-80.0))*(1.0+((instanceStruct.instanceVar_temp1-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp2 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp1-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp1-80.0))*(1.0+((instanceStruct.instanceVar_temp1-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp3_dX = (instanceStruct.d_instanceVar_GCDOV_i_dX*Vdsu+instanceStruct.d_instanceVar_temp1_dX);
instanceStruct.instanceVar_temp3 = ((instanceStruct.instanceVar_GCDOV_i*Vdsu)+instanceStruct.instanceVar_temp1);
if ((fabs(instanceStruct.instanceVar_temp3)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp3);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp4_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp3_dX);
instanceStruct.instanceVar_temp4 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp3<(-80.0)))
{
instanceStruct.d_instanceVar_temp4_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp3)-80.0)*((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(-instanceStruct.d_instanceVar_temp3_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp4 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp4_dX = 5.54062e34*((instanceStruct.instanceVar_temp3-80.0)*((0.5*(instanceStruct.instanceVar_temp3-80.0))*instanceStruct.d_instanceVar_temp3_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp3_dX*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp3_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp4 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp3-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))))));
}
}
{
double value_log_0 = log(instanceStruct.instanceVar_temp);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_temp);
d_Igdov_dX = ((((1.0+instanceStruct.instanceVar_temp4)*(((igoveff*TP)*value_log_0)*instanceStruct.d_instanceVar_temp2_dX+((igoveff*TP)*deriv_log_0_d0*(instanceStruct.d_instanceVar_temp_dX)+(igoveff*d_TP_dX+d_igoveff_dX*TP)*value_log_0)*(1.0+instanceStruct.instanceVar_temp2))-(((igoveff*TP)*value_log_0)*(1.0+instanceStruct.instanceVar_temp2))*instanceStruct.d_instanceVar_temp4_dX)/(1.0+instanceStruct.instanceVar_temp4)/(1.0+instanceStruct.instanceVar_temp4))-(((1.0+instanceStruct.instanceVar_temp4)*((igovefffowler*TP2)*instanceStruct.d_instanceVar_temp2_dX+(igovefffowler*d_TP2_dX+d_igovefffowler_dX*TP2)*(1.0+instanceStruct.instanceVar_temp2))-((igovefffowler*TP2)*(1.0+instanceStruct.instanceVar_temp2))*instanceStruct.d_instanceVar_temp4_dX)/(1.0+instanceStruct.instanceVar_temp4)/(1.0+instanceStruct.instanceVar_temp4)));
Igdov = (((((igoveff*TP)*value_log_0)*(1.0+instanceStruct.instanceVar_temp2))/(1.0+instanceStruct.instanceVar_temp4))-(((igovefffowler*TP2)*(1.0+instanceStruct.instanceVar_temp2))/(1.0+instanceStruct.instanceVar_temp4)));
}
}
if ((instanceStruct.instanceVar_IGINV_i>0.0))
{
d_half_x_ds_dX = ((-instanceStruct.instanceVar_delta_k1q1)*d_inv_k1_dX+(-instanceStruct.d_instanceVar_delta_k1q1_dX)*inv_k1);
half_x_ds = ((-instanceStruct.instanceVar_delta_k1q1)*inv_k1);
if ((fabs(((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff))<80.0))
{
{
double value_exp_0 = exp(((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp_dX = deriv_exp_0_d0*((2.0*d_half_x_ds_dX-instanceStruct.d_instanceVar_xdeff_dX));
instanceStruct.instanceVar_temp = value_exp_0;
}
}
else
{
if ((((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)<(-80.0)))
{
instanceStruct.d_instanceVar_temp_dX = (-1.80485e-35*(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*((0.5*((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*((-2.0)*d_half_x_ds_dX-instanceStruct.d_instanceVar_xdeff_dX)*0.3333333333333+0.5*((-2.0)*d_half_x_ds_dX-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))+((-2.0)*d_half_x_ds_dX-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((0.5*((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))/(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333))))))/(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp = (1.80485e-35/(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+(((((-2.0)*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp_dX = 5.54062e34*((((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*((0.5*(((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*(2.0*d_half_x_ds_dX-instanceStruct.d_instanceVar_xdeff_dX)*0.3333333333333+0.5*(2.0*d_half_x_ds_dX-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))+(2.0*d_half_x_ds_dX-instanceStruct.d_instanceVar_xdeff_dX)*(1.0+((0.5*(((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp = (5.54062e34*(1.0+((((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*(1.0+((0.5*(((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0))*(1.0+((((2.0*half_x_ds)-instanceStruct.instanceVar_xdeff)-80.0)*0.3333333333333)))))));
}
}
{
double value_log_0 = log((1.0+instanceStruct.instanceVar_temp));
double  deriv_log_0_d0 = (1.0/(1.0+instanceStruct.instanceVar_temp));
d_Vm_dX = (instanceStruct.instanceVar_phit*(d_half_x_ds_dX-deriv_log_0_d0*(instanceStruct.d_instanceVar_temp_dX))+instanceStruct.d_instanceVar_phit_dX*((half_x_ds+0.6931471805599)-value_log_0));
Vm = (instanceStruct.instanceVar_phit*((half_x_ds+0.6931471805599)-value_log_0));
}
d_q1m_dX = 0.5*(d_q1s_dX+d_q1d_dX);
q1m = (0.5*(q1s+q1d));
d_Voxm_dX = (instanceStruct.instanceVar_phit*d_q1m_dX+instanceStruct.d_instanceVar_phit_dX*q1m);
Voxm = (instanceStruct.instanceVar_phit*q1m);
d_arg2mina_dX = (d_Voxm_dX+instanceStruct.d_instanceVar_Dch_dX);
arg2mina = (Voxm+instanceStruct.instanceVar_Dch);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psi_t_dX = 0.5*(d_arg2mina_dX-deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dX)+(-d_arg2mina_dX)*(-arg2mina))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0e-4));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Voxm*d_Voxm_dX+d_Voxm_dX*Voxm))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((instanceStruct.instanceVar_GC3CH_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-instanceStruct.instanceVar_GCQCH)*(zg-instanceStruct.instanceVar_GCQCH))+1.0e-06));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+instanceStruct.d_instanceVar_GCQCH_dX)-deriv_sqrt_0_d0*(((zg-instanceStruct.instanceVar_GCQCH)*(d_zg_dX-instanceStruct.d_instanceVar_GCQCH_dX)+(d_zg_dX-instanceStruct.d_instanceVar_GCQCH_dX)*(zg-instanceStruct.instanceVar_GCQCH))));
zg = (0.5*((zg+instanceStruct.instanceVar_GCQCH)-value_sqrt_0));
}
}
d_x_m_dX = (d_xg1x_dX-d_q1m_dX);
x_m = (xg1x-q1m);
d_arg1_dX = ((x_m+(((psi_t-instanceStruct.instanceVar_alpha_b)-Vm)*instanceStruct.instanceVar_inv_phit))*instanceStruct.d_instanceVar_n_iginv_dX+(d_x_m_dX+(((psi_t-instanceStruct.instanceVar_alpha_b)-Vm)*instanceStruct.d_instanceVar_inv_phit_dX+((d_psi_t_dX-instanceStruct.d_instanceVar_alpha_b_dX)-d_Vm_dX)*instanceStruct.instanceVar_inv_phit))*instanceStruct.instanceVar_n_iginv);
arg1 = ((x_m+(((psi_t-instanceStruct.instanceVar_alpha_b)-Vm)*instanceStruct.instanceVar_inv_phit))*instanceStruct.instanceVar_n_iginv);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dsi_dX = deriv_exp_0_d0*(d_arg1_dX);
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{
d_Dsi_dX = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dX)*0.3333333333333+0.5*(-d_arg1_dX)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dX)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
Dsi = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{
d_Dsi_dX = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dX*0.3333333333333+0.5*d_arg1_dX*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dX*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
Dsi = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}
d_arg1_dX = (((-(Vgs-Vm))*instanceStruct.instanceVar_inv_phit)*instanceStruct.d_instanceVar_n_iginv_dX+((-(Vgs-Vm))*instanceStruct.d_instanceVar_inv_phit_dX+(-(-d_Vm_dX))*instanceStruct.instanceVar_inv_phit)*instanceStruct.instanceVar_n_iginv);
arg1 = (((-(Vgs-Vm))*instanceStruct.instanceVar_inv_phit)*instanceStruct.instanceVar_n_iginv);
if ((fabs(arg1)<80.0))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp_dX = deriv_exp_0_d0*(d_arg1_dX);
instanceStruct.instanceVar_temp = value_exp_0;
}
}
else
{
if ((arg1<(-80.0)))
{
instanceStruct.d_instanceVar_temp_dX = (-1.80485e-35*(((-arg1)-80.0)*((0.5*((-arg1)-80.0))*(-d_arg1_dX)*0.3333333333333+0.5*(-d_arg1_dX)*(1.0+(((-arg1)-80.0)*0.3333333333333)))+(-d_arg1_dX)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333))))))/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp = (1.80485e-35/(1.0+(((-arg1)-80.0)*(1.0+((0.5*((-arg1)-80.0))*(1.0+(((-arg1)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp_dX = 5.54062e34*((arg1-80.0)*((0.5*(arg1-80.0))*d_arg1_dX*0.3333333333333+0.5*d_arg1_dX*(1.0+((arg1-80.0)*0.3333333333333)))+d_arg1_dX*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp = (5.54062e34*(1.0+((arg1-80.0)*(1.0+((0.5*(arg1-80.0))*(1.0+((arg1-80.0)*0.3333333333333)))))));
}
}
d_Dgate_dX = (Dsi*instanceStruct.d_instanceVar_temp_dX+d_Dsi_dX*instanceStruct.instanceVar_temp);
Dgate = (Dsi*instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_BCH*(zg*(instanceStruct.d_instanceVar_GC2CH_i_dX+(instanceStruct.instanceVar_GC3CH_i*d_zg_dX+instanceStruct.d_instanceVar_GC3CH_i_dX*zg))+d_zg_dX*(instanceStruct.instanceVar_GC2CH_i+(instanceStruct.instanceVar_GC3CH_i*zg)))+instanceStruct.d_instanceVar_BCH_dX*((-1.5)+(zg*(instanceStruct.instanceVar_GC2CH_i+(instanceStruct.instanceVar_GC3CH_i*zg)))));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_BCH*((-1.5)+(zg*(instanceStruct.instanceVar_GC2CH_i+(instanceStruct.instanceVar_GC3CH_i*zg)))));
if ((instanceStruct.instanceVar_temp>0.0))
{
d_TP_dX = (instanceStruct.instanceVar_temp*((0.5*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp_dX*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333)))+instanceStruct.d_instanceVar_temp_dX*(1.0+((0.5*instanceStruct.instanceVar_temp)*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333)))));
TP = (1.0+(instanceStruct.instanceVar_temp*(1.0+((0.5*instanceStruct.instanceVar_temp)*(1.0+(instanceStruct.instanceVar_temp*0.3333333333333))))));
}
else
{
if ((fabs(instanceStruct.instanceVar_temp)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp_dX);
TP = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp<(-80.0)))
{
d_TP_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp)-80.0)*((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(-instanceStruct.d_instanceVar_temp_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp_dX)*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
TP = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
}
else
{
d_TP_dX = 5.54062e34*((instanceStruct.instanceVar_temp-80.0)*((0.5*(instanceStruct.instanceVar_temp-80.0))*instanceStruct.d_instanceVar_temp_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp_dX*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp-80.0))*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))));
TP = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp-80.0))*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))))));
}
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));
d_Igc0_dX = ((instanceStruct.instanceVar_IGINV_i*TP)*deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dX-(1.0+Dsi)*d_Dgate_dX)/(1.0+Dgate)/(1.0+Dgate)))+(instanceStruct.instanceVar_IGINV_i*d_TP_dX+instanceStruct.d_instanceVar_IGINV_i_dX*TP)*value_log_0);
Igc0 = ((instanceStruct.instanceVar_IGINV_i*TP)*value_log_0);
}
if (((xg1x<=0.0)||((instanceStruct.instanceVar_GC2CH_i==0.0)&&(instanceStruct.instanceVar_GC3CH_i==0.0))))
{
d_igc_dX = 0.0;
igc = 1.0;
d_igcd_h_dX = 0.0;
igcd_h = 0.5;
}
else
{
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.d_instanceVar_GC2CH_i_dX+((2.0*instanceStruct.instanceVar_GC3CH_i)*d_zg_dX+2.0*instanceStruct.d_instanceVar_GC3CH_i_dX*zg));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_GC2CH_i+((2.0*instanceStruct.instanceVar_GC3CH_i)*zg));
d_u0_dX = ((instanceStruct.instanceVar_CHIB_i/(instanceStruct.instanceVar_temp*instanceStruct.instanceVar_BCH))*instanceStruct.d_instanceVar_inv_phit_dX+(((instanceStruct.instanceVar_temp*instanceStruct.instanceVar_BCH)*instanceStruct.d_instanceVar_CHIB_i_dX-instanceStruct.instanceVar_CHIB_i*(instanceStruct.instanceVar_temp*instanceStruct.d_instanceVar_BCH_dX+instanceStruct.d_instanceVar_temp_dX*instanceStruct.instanceVar_BCH))/(instanceStruct.instanceVar_temp*instanceStruct.instanceVar_BCH)/(instanceStruct.instanceVar_temp*instanceStruct.instanceVar_BCH))*instanceStruct.instanceVar_inv_phit);
u0 = ((instanceStruct.instanceVar_CHIB_i/(instanceStruct.instanceVar_temp*instanceStruct.instanceVar_BCH))*instanceStruct.instanceVar_inv_phit);
d_x_dX = ((u0*d_half_x_ds_dX-half_x_ds*d_u0_dX)/u0/u0);
x = (half_x_ds/u0);
d_u0_div_H_dX = ((u0*inv_k1h1)*instanceStruct.d_instanceVar_k1_dX+(u0*d_inv_k1h1_dX+d_u0_dX*inv_k1h1)*instanceStruct.instanceVar_k1);
u0_div_H = ((u0*inv_k1h1)*instanceStruct.instanceVar_k1);
d_Bg_dX = (u0_div_H*(-d_u0_div_H_dX)+d_u0_div_H_dX*(1.0-u0_div_H))*0.5;
Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);
d_Ag_dX = (-3.0*d_Bg_dX);
Ag = (0.5-(3.0*Bg));
if ((x<1.0e-3))
{
d_xsq_dX = (x*d_x_dX+d_x_dX*x);
xsq = (x*x);
d_igc_dX = (xsq*(d_u0_div_H_dX*0.3333333333333+((xsq*0.1666666666667)*0.2*d_u0_div_H_dX+d_xsq_dX*0.1666666666667*(0.05+(0.2*u0_div_H))))+d_xsq_dX*((0.1666666666667+(u0_div_H*0.3333333333333))+((xsq*0.1666666666667)*(0.05+(0.2*u0_div_H)))));
igc = (1.0+(xsq*((0.1666666666667+(u0_div_H*0.3333333333333))+((xsq*0.1666666666667)*(0.05+(0.2*u0_div_H))))));
d_igcd_h_dX = (0.5*d_igc_dX-((x*0.1666666666667)*(xsq*(0.4*d_Bg_dX+((0.0285714285714*xsq)*d_Bg_dX+0.0285714285714*d_xsq_dX*(0.125+Bg)))+d_xsq_dX*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg))))+d_x_dX*0.1666666666667*(1.0+(xsq*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg)))))));
igcd_h = ((0.5*igc)-((x*0.1666666666667)*(1.0+(xsq*((0.4*(Bg+0.25))+((0.0285714285714*xsq)*(0.125+Bg)))))));
}
else
{
d_inv_x_dX = (-d_x_dX/x/x);
inv_x = (1.0/x);
if ((fabs(x)<80.0))
{
{
double value_exp_0 = exp(x);
double  deriv_exp_0_d0 = value_exp_0;
d_ex_dX = deriv_exp_0_d0*(d_x_dX);
ex = value_exp_0;
}
}
else
{
if ((x<(-80.0)))
{
d_ex_dX = (-1.80485e-35*(((-x)-80.0)*((0.5*((-x)-80.0))*(-d_x_dX)*0.3333333333333+0.5*(-d_x_dX)*(1.0+(((-x)-80.0)*0.3333333333333)))+(-d_x_dX)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333))))))/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))));
ex = (1.80485e-35/(1.0+(((-x)-80.0)*(1.0+((0.5*((-x)-80.0))*(1.0+(((-x)-80.0)*0.3333333333333)))))));
}
else
{
d_ex_dX = 5.54062e34*((x-80.0)*((0.5*(x-80.0))*d_x_dX*0.3333333333333+0.5*d_x_dX*(1.0+((x-80.0)*0.3333333333333)))+d_x_dX*(1.0+((0.5*(x-80.0))*(1.0+((x-80.0)*0.3333333333333)))));
ex = (5.54062e34*(1.0+((x-80.0)*(1.0+((0.5*(x-80.0))*(1.0+((x-80.0)*0.3333333333333)))))));
}
}
d_inv_ex_dX = (-d_ex_dX/ex/ex);
inv_ex = (1.0/ex);
instanceStruct.d_instanceVar_temp_dX = (d_ex_dX-d_inv_ex_dX);
instanceStruct.instanceVar_temp = (ex-inv_ex);
instanceStruct.d_instanceVar_temp2_dX = (d_ex_dX+d_inv_ex_dX);
instanceStruct.instanceVar_temp2 = (ex+inv_ex);
d_igc_dX = 0.5*((((1.0-u0_div_H)*instanceStruct.instanceVar_temp)*d_inv_x_dX+((1.0-u0_div_H)*instanceStruct.d_instanceVar_temp_dX+(-d_u0_div_H_dX)*instanceStruct.instanceVar_temp)*inv_x)+(u0_div_H*instanceStruct.d_instanceVar_temp2_dX+d_u0_div_H_dX*instanceStruct.instanceVar_temp2));
igc = (0.5*((((1.0-u0_div_H)*instanceStruct.instanceVar_temp)*inv_x)+(u0_div_H*instanceStruct.instanceVar_temp2)));
d_igcd_h_dX = 0.5*((d_igc_dX-(instanceStruct.instanceVar_temp*(d_Bg_dX-((Ag*inv_x)*d_inv_x_dX+(Ag*d_inv_x_dX+d_Ag_dX*inv_x)*inv_x))+instanceStruct.d_instanceVar_temp_dX*(Bg-((Ag*inv_x)*inv_x))))-((Ag*instanceStruct.instanceVar_temp2)*d_inv_x_dX+(Ag*instanceStruct.d_instanceVar_temp2_dX+d_Ag_dX*instanceStruct.instanceVar_temp2)*inv_x));
igcd_h = (0.5*((igc-(instanceStruct.instanceVar_temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*instanceStruct.instanceVar_temp2)*inv_x)));
}
}
d_Igc_dX = (Igc0*d_igc_dX+d_Igc0_dX*igc);
Igc = (Igc0*igc);
d_Igcd_dX = (Igc0*d_igcd_h_dX+d_Igc0_dX*igcd_h);
Igcd = (Igc0*igcd_h);
d_Igcs_dX = (d_Igc_dX-d_Igcd_dX);
Igcs = (Igc-Igcd);
}
if ((instanceStruct.instanceVar_sigVds<0.0))
{
d_Igs_dX = (d_Igcd_dX+d_Igsov_dX);
Igs = (Igcd+Igsov);
d_Igd_dX = (d_Igcs_dX+d_Igdov_dX);
Igd = (Igcs+Igdov);
}
else
{
d_Igs_dX = (d_Igcs_dX+d_Igsov_dX);
Igs = (Igcs+Igsov);
d_Igd_dX = (d_Igcd_dX+d_Igdov_dX);
Igd = (Igcd+Igdov);
}
}
d_Igisl_dX = 0.0;
Igisl = 0.0;
if ((((modelStruct.modelPar_SWGIDL>0)&&(instanceStruct.instanceVar_AGIDL_i>0.0))&&(Vovs<0.0)))
{
{
double value_sqrt_0 = sqrt((((Vovs*Vovs)+(((instanceStruct.instanceVar_CGIDL_i*instanceStruct.instanceVar_CGIDL_i)*Vsbu)*Vsbu))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vtovs_dX = deriv_sqrt_0_d0*(((Vovs*d_Vovs_dX+d_Vovs_dX*Vovs)+(instanceStruct.instanceVar_CGIDL_i*instanceStruct.d_instanceVar_CGIDL_i_dX+instanceStruct.d_instanceVar_CGIDL_i_dX*instanceStruct.instanceVar_CGIDL_i)*Vsbu*Vsbu));
Vtovs = value_sqrt_0;
}
instanceStruct.d_instanceVar_temp_dX = ((Vtovs*(-instanceStruct.d_instanceVar_BGIDL_i_dX)-(-instanceStruct.instanceVar_BGIDL_i)*d_Vtovs_dX)/Vtovs/Vtovs);
instanceStruct.instanceVar_temp = ((-instanceStruct.instanceVar_BGIDL_i)/Vtovs);
if ((fabs(instanceStruct.instanceVar_temp)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_temp2 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp<(-80.0)))
{
instanceStruct.d_instanceVar_temp2_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp)-80.0)*((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(-instanceStruct.d_instanceVar_temp_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp_dX)*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp2 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp2_dX = 5.54062e34*((instanceStruct.instanceVar_temp-80.0)*((0.5*(instanceStruct.instanceVar_temp-80.0))*instanceStruct.d_instanceVar_temp_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp_dX*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp-80.0))*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp2 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp-80.0))*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp3_dX = instanceStruct.d_instanceVar_DGIDL_i_dX*Vsdu;
instanceStruct.instanceVar_temp3 = (instanceStruct.instanceVar_DGIDL_i*Vsdu);
if ((fabs(instanceStruct.instanceVar_temp3)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp3);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp4_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp3_dX);
instanceStruct.instanceVar_temp4 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp3<(-80.0)))
{
instanceStruct.d_instanceVar_temp4_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp3)-80.0)*((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(-instanceStruct.d_instanceVar_temp3_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp4 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp4_dX = 5.54062e34*((instanceStruct.instanceVar_temp3-80.0)*((0.5*(instanceStruct.instanceVar_temp3-80.0))*instanceStruct.d_instanceVar_temp3_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp3_dX*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp3_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp4 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp3-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))))));
}
}
d_Igisl_dX = (((((((-instanceStruct.instanceVar_AGIDL_i)*Vsdu)*Vovs)*Vtovs)*instanceStruct.instanceVar_temp2)*0.5)*instanceStruct.d_instanceVar_temp4_dX+(((((-instanceStruct.instanceVar_AGIDL_i)*Vsdu)*Vovs)*Vtovs)*instanceStruct.d_instanceVar_temp2_dX+((((-instanceStruct.instanceVar_AGIDL_i)*Vsdu)*Vovs)*d_Vtovs_dX+(((-instanceStruct.instanceVar_AGIDL_i)*Vsdu)*d_Vovs_dX+(-instanceStruct.d_instanceVar_AGIDL_i_dX)*Vsdu*Vovs)*Vtovs)*instanceStruct.instanceVar_temp2)*0.5*(1.0+instanceStruct.instanceVar_temp4));
Igisl = (((((((-instanceStruct.instanceVar_AGIDL_i)*Vsdu)*Vovs)*Vtovs)*instanceStruct.instanceVar_temp2)*0.5)*(1.0+instanceStruct.instanceVar_temp4));
}
d_Igidl_dX = 0.0;
Igidl = 0.0;
if ((((modelStruct.modelPar_SWGIDL>0)&&(instanceStruct.instanceVar_AGIDLD_i>0.0))&&(Vovd<0.0)))
{
{
double value_sqrt_0 = sqrt((((Vovd*Vovd)+(((instanceStruct.instanceVar_CGIDLD_i*instanceStruct.instanceVar_CGIDLD_i)*Vdbu)*Vdbu))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vtovd_dX = deriv_sqrt_0_d0*(((Vovd*d_Vovd_dX+d_Vovd_dX*Vovd)+(instanceStruct.instanceVar_CGIDLD_i*instanceStruct.d_instanceVar_CGIDLD_i_dX+instanceStruct.d_instanceVar_CGIDLD_i_dX*instanceStruct.instanceVar_CGIDLD_i)*Vdbu*Vdbu));
Vtovd = value_sqrt_0;
}
instanceStruct.d_instanceVar_temp_dX = ((Vtovd*(-instanceStruct.d_instanceVar_BGIDLD_i_dX)-(-instanceStruct.instanceVar_BGIDLD_i)*d_Vtovd_dX)/Vtovd/Vtovd);
instanceStruct.instanceVar_temp = ((-instanceStruct.instanceVar_BGIDLD_i)/Vtovd);
if ((fabs(instanceStruct.instanceVar_temp)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp_dX);
instanceStruct.instanceVar_temp2 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp<(-80.0)))
{
instanceStruct.d_instanceVar_temp2_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp)-80.0)*((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(-instanceStruct.d_instanceVar_temp_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp_dX)*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp2 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp2_dX = 5.54062e34*((instanceStruct.instanceVar_temp-80.0)*((0.5*(instanceStruct.instanceVar_temp-80.0))*instanceStruct.d_instanceVar_temp_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp_dX*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp-80.0))*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp2 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp-80.0))*(1.0+((instanceStruct.instanceVar_temp-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_temp3_dX = instanceStruct.d_instanceVar_DGIDLD_i_dX*Vdsu;
instanceStruct.instanceVar_temp3 = (instanceStruct.instanceVar_DGIDLD_i*Vdsu);
if ((fabs(instanceStruct.instanceVar_temp3)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp3);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp4_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp3_dX);
instanceStruct.instanceVar_temp4 = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp3<(-80.0)))
{
instanceStruct.d_instanceVar_temp4_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp3)-80.0)*((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(-instanceStruct.d_instanceVar_temp3_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp3_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp4 = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp3)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp3)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp4_dX = 5.54062e34*((instanceStruct.instanceVar_temp3-80.0)*((0.5*(instanceStruct.instanceVar_temp3-80.0))*instanceStruct.d_instanceVar_temp3_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp3_dX*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp3_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp4 = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp3-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp3-80.0))*(1.0+((instanceStruct.instanceVar_temp3-80.0)*0.3333333333333)))))));
}
}
d_Igidl_dX = (((((((-instanceStruct.instanceVar_AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*instanceStruct.instanceVar_temp2)*0.5)*instanceStruct.d_instanceVar_temp4_dX+(((((-instanceStruct.instanceVar_AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*instanceStruct.d_instanceVar_temp2_dX+((((-instanceStruct.instanceVar_AGIDLD_i)*Vdsu)*Vovd)*d_Vtovd_dX+(((-instanceStruct.instanceVar_AGIDLD_i)*Vdsu)*d_Vovd_dX+(-instanceStruct.d_instanceVar_AGIDLD_i_dX)*Vdsu*Vovd)*Vtovd)*instanceStruct.instanceVar_temp2)*0.5*(1.0+instanceStruct.instanceVar_temp4));
Igidl = (((((((-instanceStruct.instanceVar_AGIDLD_i)*Vdsu)*Vovd)*Vtovd)*instanceStruct.instanceVar_temp2)*0.5)*(1.0+instanceStruct.instanceVar_temp4));
}
instanceStruct.d_instanceVar_mavl_dX = 0.0;
instanceStruct.instanceVar_mavl = 0.0;
instanceStruct.d_instanceVar_Iimpact_dX = 0.0;
instanceStruct.instanceVar_Iimpact = 0.0;
if ((modelStruct.modelPar_SWIMPACT!=0))
{
d_delVsat_dX = ((instanceStruct.instanceVar_inv_phit*(d_xd_dX-(instanceStruct.instanceVar_A3_i*instanceStruct.d_instanceVar_xdeff_dX+instanceStruct.d_instanceVar_A3_i_dX*instanceStruct.instanceVar_xdeff))-(xd-(instanceStruct.instanceVar_A3_i*instanceStruct.instanceVar_xdeff))*instanceStruct.d_instanceVar_inv_phit_dX)/instanceStruct.instanceVar_inv_phit/instanceStruct.instanceVar_inv_phit);
delVsat = ((xd-(instanceStruct.instanceVar_A3_i*instanceStruct.instanceVar_xdeff))/instanceStruct.instanceVar_inv_phit);
if ((delVsat>0))
{
instanceStruct.d_instanceVar_temp2_dX = (((delVsat+1.0e-30)*(-1.0)*instanceStruct.d_instanceVar_A2_i_dX-((-1.0)*instanceStruct.instanceVar_A2_i)*d_delVsat_dX)/(delVsat+1.0e-30)/(delVsat+1.0e-30));
instanceStruct.instanceVar_temp2 = (((-1.0)*instanceStruct.instanceVar_A2_i)/(delVsat+1.0e-30));
if ((fabs(instanceStruct.instanceVar_temp2)<80.0))
{
{
double value_exp_0 = exp(instanceStruct.instanceVar_temp2);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_temp_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_temp2_dX);
instanceStruct.instanceVar_temp = value_exp_0;
}
}
else
{
if ((instanceStruct.instanceVar_temp2<(-80.0)))
{
instanceStruct.d_instanceVar_temp_dX = (-1.80485e-35*(((-instanceStruct.instanceVar_temp2)-80.0)*((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(-instanceStruct.d_instanceVar_temp2_dX)*0.3333333333333+0.5*(-instanceStruct.d_instanceVar_temp2_dX)*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))+(-instanceStruct.d_instanceVar_temp2_dX)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))))/(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333))))))/(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))))));
instanceStruct.instanceVar_temp = (1.80485e-35/(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*(1.0+((0.5*((-instanceStruct.instanceVar_temp2)-80.0))*(1.0+(((-instanceStruct.instanceVar_temp2)-80.0)*0.3333333333333)))))));
}
else
{
instanceStruct.d_instanceVar_temp_dX = 5.54062e34*((instanceStruct.instanceVar_temp2-80.0)*((0.5*(instanceStruct.instanceVar_temp2-80.0))*instanceStruct.d_instanceVar_temp2_dX*0.3333333333333+0.5*instanceStruct.d_instanceVar_temp2_dX*(1.0+((instanceStruct.instanceVar_temp2-80.0)*0.3333333333333)))+instanceStruct.d_instanceVar_temp2_dX*(1.0+((0.5*(instanceStruct.instanceVar_temp2-80.0))*(1.0+((instanceStruct.instanceVar_temp2-80.0)*0.3333333333333)))));
instanceStruct.instanceVar_temp = (5.54062e34*(1.0+((instanceStruct.instanceVar_temp2-80.0)*(1.0+((0.5*(instanceStruct.instanceVar_temp2-80.0))*(1.0+((instanceStruct.instanceVar_temp2-80.0)*0.3333333333333)))))));
}
}
instanceStruct.d_instanceVar_mavl_dX = ((instanceStruct.instanceVar_A1_i*delVsat)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_A1_i*d_delVsat_dX+instanceStruct.d_instanceVar_A1_i_dX*delVsat)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_mavl = ((instanceStruct.instanceVar_A1_i*delVsat)*instanceStruct.instanceVar_temp);
instanceStruct.d_instanceVar_Iimpact_dX = (instanceStruct.instanceVar_mavl*instanceStruct.d_instanceVar_Ids_dX+instanceStruct.d_instanceVar_mavl_dX*instanceStruct.instanceVar_Ids);
instanceStruct.instanceVar_Iimpact = (instanceStruct.instanceVar_mavl*instanceStruct.instanceVar_Ids);
}
}
if ((modelStruct.modelVar_SWSHE_i>0))
{
{
double value_fabs_0 = fabs((instanceStruct.instanceVar_Ids*Vds));
double  deriv_fabs_0_d0 = ((((instanceStruct.instanceVar_Ids*Vds))>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_temp_dX = (value_fabs_0*instanceStruct.d_instanceVar_RTH_i_dX+deriv_fabs_0_d0*(instanceStruct.d_instanceVar_Ids_dX*Vds)*instanceStruct.instanceVar_RTH_i);
instanceStruct.instanceVar_temp = (value_fabs_0*instanceStruct.instanceVar_RTH_i);
}
if ((instanceStruct.instanceVar_temp>(1.0e8*modelStruct.modelPar_TMAX)))
{
d_Ithpwr_dX = ((instanceStruct.instanceVar_RTH_i*(-(modelStruct.d_modelPar_TMAX_dX+(-0.25*modelStruct.d_modelPar_TMAX_dX/modelStruct.modelPar_TMAX/modelStruct.modelPar_TMAX)))-(-(modelStruct.modelPar_TMAX+(0.25/modelStruct.modelPar_TMAX)))*instanceStruct.d_instanceVar_RTH_i_dX)/instanceStruct.instanceVar_RTH_i/instanceStruct.instanceVar_RTH_i);
Ithpwr = ((-(modelStruct.modelPar_TMAX+(0.25/modelStruct.modelPar_TMAX)))/instanceStruct.instanceVar_RTH_i);
}
else
{
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_temp-modelStruct.modelPar_TMAX)*(instanceStruct.instanceVar_temp-modelStruct.modelPar_TMAX))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Ithpwr_dX = ((instanceStruct.instanceVar_RTH_i*(-((1.0*0.5)*((instanceStruct.d_instanceVar_temp_dX+modelStruct.d_modelPar_TMAX_dX)-deriv_sqrt_0_d0*(((instanceStruct.instanceVar_temp-modelStruct.modelPar_TMAX)*(instanceStruct.d_instanceVar_temp_dX-modelStruct.d_modelPar_TMAX_dX)+(instanceStruct.d_instanceVar_temp_dX-modelStruct.d_modelPar_TMAX_dX)*(instanceStruct.instanceVar_temp-modelStruct.modelPar_TMAX))))+(-0.25*modelStruct.d_modelPar_TMAX_dX/modelStruct.modelPar_TMAX/modelStruct.modelPar_TMAX)))-(-(((1.0*0.5)*((instanceStruct.instanceVar_temp+modelStruct.modelPar_TMAX)-value_sqrt_0))+(0.25/modelStruct.modelPar_TMAX)))*instanceStruct.d_instanceVar_RTH_i_dX)/instanceStruct.instanceVar_RTH_i/instanceStruct.instanceVar_RTH_i);
Ithpwr = ((-(((1.0*0.5)*((instanceStruct.instanceVar_temp+modelStruct.modelPar_TMAX)-value_sqrt_0))+(0.25/modelStruct.modelPar_TMAX)))/instanceStruct.instanceVar_RTH_i);
}
}
d_Ithrc_dX = (-instanceStruct.instanceVar_DTC*instanceStruct.d_instanceVar_RTH_i_dX/instanceStruct.instanceVar_RTH_i/instanceStruct.instanceVar_RTH_i);
Ithrc = (instanceStruct.instanceVar_DTC/instanceStruct.instanceVar_RTH_i);
}
else
{
d_Ithpwr_dX = 0.0;
Ithpwr = 0.0;
d_Ithrc_dX = 0.0;
Ithrc = (0.001*(probeVars[admsProbeID_Temp_Tnode_GND]));
}
}
// End block evaluateStatic
//Begin block evaluateDynamic
{
instanceStruct.d_instanceVar_temp_dX = (((1.0+(0.25*instanceStruct.instanceVar_qim))*(instanceStruct.instanceVar_FSCEAC_i*(d_Dx_WI_1D_dX-d_Dx_WI_dX)+instanceStruct.d_instanceVar_FSCEAC_i_dX*(Dx_WI_1D-Dx_WI))-(instanceStruct.instanceVar_FSCEAC_i*(Dx_WI_1D-Dx_WI))*0.25*instanceStruct.d_instanceVar_qim_dX)/(1.0+(0.25*instanceStruct.instanceVar_qim))/(1.0+(0.25*instanceStruct.instanceVar_qim)));
instanceStruct.instanceVar_temp = ((instanceStruct.instanceVar_FSCEAC_i*(Dx_WI_1D-Dx_WI))/(1.0+(0.25*instanceStruct.instanceVar_qim)));
d_k1q1m_dX = (0.5*(d_k1q1s_dX+d_k1q1d_dX)+instanceStruct.d_instanceVar_temp_dX);
k1q1m = ((0.5*(k1q1s+k1q1d))+instanceStruct.instanceVar_temp);
d_k2q2m_dX = (0.5*(d_k2q2s_dX+d_k2q2d_dX)-instanceStruct.d_instanceVar_temp_dX);
k2q2m = ((0.5*(k2q2s+k2q2d))-instanceStruct.instanceVar_temp);
if ((modelStruct.modelPar_QMC>0.0))
{
d_k1q1eff_dX = ((d_k1q1m_dX+((instanceStruct.instanceVar_qmfact1*d_qi1m_dX-qi1m*instanceStruct.d_instanceVar_qmfact1_dX)/instanceStruct.instanceVar_qmfact1/instanceStruct.instanceVar_qmfact1))-d_qi1m_dX);
k1q1eff = ((k1q1m+(qi1m/instanceStruct.instanceVar_qmfact1))-qi1m);
d_k2q2eff_dX = ((d_k2q2m_dX+((qmfact2*d_qi2m_dX-qi2m*d_qmfact2_dX)/qmfact2/qmfact2))-d_qi2m_dX);
k2q2eff = ((k2q2m+(qi2m/qmfact2))-qi2m);
}
else
{
d_k1q1eff_dX = d_k1q1m_dX;
k1q1eff = k1q1m;
d_k2q2eff_dX = d_k2q2m_dX;
k2q2eff = k2q2m;
}
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.instanceVar_delta_k1q1*d_prod1_dX+instanceStruct.d_instanceVar_delta_k1q1_dX*prod1)*0.3333333333333;
instanceStruct.instanceVar_temp1 = ((instanceStruct.instanceVar_delta_k1q1*prod1)*0.3333333333333);
instanceStruct.d_instanceVar_temp2_dX = ((instanceStruct.instanceVar_delta_k1q1*0.1666666666667)*(prod1*(-0.2*d_prod1_dX)+d_prod1_dX*(1.0-(0.2*prod1)))+instanceStruct.d_instanceVar_delta_k1q1_dX*0.1666666666667*(1.0+(prod1*(1.0-(0.2*prod1)))));
instanceStruct.instanceVar_temp2 = ((instanceStruct.instanceVar_delta_k1q1*0.1666666666667)*(1.0+(prod1*(1.0-(0.2*prod1)))));
d_k1q1deff_dX = (0.5*d_k1q1eff_dX+instanceStruct.d_instanceVar_temp2_dX);
k1q1deff = ((0.5*k1q1eff)+instanceStruct.instanceVar_temp2);
d_k1q1eff_dX = (d_k1q1eff_dX+instanceStruct.d_instanceVar_temp1_dX);
k1q1eff = (k1q1eff+instanceStruct.instanceVar_temp1);
instanceStruct.d_instanceVar_temp1_dX = (delta_k2q2*d_prod2_dX+d_delta_k2q2_dX*prod2)*0.3333333333333;
instanceStruct.instanceVar_temp1 = ((delta_k2q2*prod2)*0.3333333333333);
instanceStruct.d_instanceVar_temp2_dX = ((delta_k2q2*0.1666666666667)*(prod2*(-0.2*d_prod2_dX)+d_prod2_dX*(1.0-(0.2*prod2)))+d_delta_k2q2_dX*0.1666666666667*(1.0+(prod2*(1.0-(0.2*prod2)))));
instanceStruct.instanceVar_temp2 = ((delta_k2q2*0.1666666666667)*(1.0+(prod2*(1.0-(0.2*prod2)))));
d_k2q2deff_dX = (0.5*d_k2q2eff_dX+instanceStruct.d_instanceVar_temp2_dX);
k2q2deff = ((0.5*k2q2eff)+instanceStruct.instanceVar_temp2);
d_k2q2eff_dX = (d_k2q2eff_dX+instanceStruct.d_instanceVar_temp1_dX);
k2q2eff = (k2q2eff+instanceStruct.instanceVar_temp1);
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_CsiPrime*instanceStruct.d_instanceVar_area_phit_dX+instanceStruct.d_instanceVar_CsiPrime_dX*instanceStruct.instanceVar_area_phit);
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_CsiPrime*instanceStruct.instanceVar_area_phit);
d_Qg_dX = (instanceStruct.instanceVar_temp*d_k1q1eff_dX+instanceStruct.d_instanceVar_temp_dX*k1q1eff);
Qg = (instanceStruct.instanceVar_temp*k1q1eff);
d_Qb_dX = (instanceStruct.instanceVar_temp*d_k2q2eff_dX+instanceStruct.d_instanceVar_temp_dX*k2q2eff);
Qb = (instanceStruct.instanceVar_temp*k2q2eff);
d_Qd_dX = ((-instanceStruct.instanceVar_temp)*(d_k1q1deff_dX+d_k2q2deff_dX)+(-instanceStruct.d_instanceVar_temp_dX)*(k1q1deff+k2q2deff));
Qd = ((-instanceStruct.instanceVar_temp)*(k1q1deff+k2q2deff));
if ((instanceStruct.instanceVar_FIF_i>0.0))
{
instanceStruct.d_instanceVar_temp_dX = instanceStruct.d_instanceVar_xth_1D_dX;
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_xth_1D+(2.0*0.6931471805599));
d_xeffs_dX = (d_xdrifts_dX+instanceStruct.d_instanceVar_temp_dX);
xeffs = (xdrifts+instanceStruct.instanceVar_temp);
d_xeffd_dX = (d_xdriftd_dX+instanceStruct.d_instanceVar_temp_dX);
xeffd = (xdriftd+instanceStruct.instanceVar_temp);
{
double value_sqrt_0 = sqrt((((xeffs-instanceStruct.instanceVar_xth_1D)*(xeffs-instanceStruct.instanceVar_xth_1D))+9.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xstars_dX = 0.5*((d_xeffs_dX+instanceStruct.d_instanceVar_xth_1D_dX)-deriv_sqrt_0_d0*(((xeffs-instanceStruct.instanceVar_xth_1D)*(d_xeffs_dX-instanceStruct.d_instanceVar_xth_1D_dX)+(d_xeffs_dX-instanceStruct.d_instanceVar_xth_1D_dX)*(xeffs-instanceStruct.instanceVar_xth_1D))));
xstars = (0.5*((xeffs+instanceStruct.instanceVar_xth_1D)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((xeffd-(instanceStruct.instanceVar_xth_1D+xd))*(xeffd-(instanceStruct.instanceVar_xth_1D+xd)))+9.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xstard_dX = 0.5*((d_xeffd_dX+(instanceStruct.d_instanceVar_xth_1D_dX+d_xd_dX))-deriv_sqrt_0_d0*(((xeffd-(instanceStruct.instanceVar_xth_1D+xd))*(d_xeffd_dX-(instanceStruct.d_instanceVar_xth_1D_dX+d_xd_dX))+(d_xeffd_dX-(instanceStruct.d_instanceVar_xth_1D_dX+d_xd_dX))*(xeffd-(instanceStruct.instanceVar_xth_1D+xd)))));
xstard = (0.5*((xeffd+(instanceStruct.instanceVar_xth_1D+xd))-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((keq*(0.5+inv_k2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_lambdaf_dX = (instanceStruct.instanceVar_lambda2D*deriv_sqrt_0_d0*((keq*d_inv_k2_dX+d_keq_dX*(0.5+inv_k2)))+instanceStruct.d_instanceVar_lambda2D_dX*value_sqrt_0);
lambdaf = (instanceStruct.instanceVar_lambda2D*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt((((keq*instanceStruct.instanceVar_k1)*inv_k2)*(0.5+inv_k1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_lambdab_dX = (instanceStruct.instanceVar_lambda2D*deriv_sqrt_0_d0*((((keq*instanceStruct.instanceVar_k1)*inv_k2)*d_inv_k1_dX+((keq*instanceStruct.instanceVar_k1)*d_inv_k2_dX+(keq*instanceStruct.d_instanceVar_k1_dX+d_keq_dX*instanceStruct.instanceVar_k1)*inv_k2)*(0.5+inv_k1)))+instanceStruct.d_instanceVar_lambda2D_dX*value_sqrt_0);
lambdab = (instanceStruct.instanceVar_lambda2D*value_sqrt_0);
}
d_xalphaf_dX = ((lambdaf*lambdaf)*instanceStruct.d_instanceVar_inner_sd_dX+(lambdaf*d_lambdaf_dX+d_lambdaf_dX*lambdaf)*instanceStruct.instanceVar_inner_sd);
xalphaf = ((lambdaf*lambdaf)*instanceStruct.instanceVar_inner_sd);
d_xalphab_dX = ((lambdab*lambdab)*instanceStruct.d_instanceVar_inner_sd_dX+(lambdab*d_lambdab_dX+d_lambdab_dX*lambdab)*instanceStruct.instanceVar_inner_sd);
xalphab = ((lambdab*lambdab)*instanceStruct.instanceVar_inner_sd);
instanceStruct.d_instanceVar_temp1_dX = (instanceStruct.d_instanceVar_xsd_dX-d_xstars_dX);
instanceStruct.instanceVar_temp1 = (instanceStruct.instanceVar_xsd-xstars);
instanceStruct.d_instanceVar_temp2_dX = ((instanceStruct.d_instanceVar_xsd_dX+d_xd_dX)-d_xstard_dX);
instanceStruct.instanceVar_temp2 = ((instanceStruct.instanceVar_xsd+xd)-xstard);
instanceStruct.d_instanceVar_temp_dX = 2.0*d_xalphaf_dX;
instanceStruct.instanceVar_temp = (2.0*xalphaf);
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_temp1/xalphaf)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xedgefs_dX = (d_xstars_dX+(instanceStruct.instanceVar_temp*deriv_sqrt_0_d0*(((xalphaf*instanceStruct.d_instanceVar_temp1_dX-instanceStruct.instanceVar_temp1*d_xalphaf_dX)/xalphaf/xalphaf))+instanceStruct.d_instanceVar_temp_dX*(value_sqrt_0-1.0)));
xedgefs = (xstars+(instanceStruct.instanceVar_temp*(value_sqrt_0-1.0)));
}
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_temp2/xalphaf)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xedgefd_dX = (d_xstard_dX+(instanceStruct.instanceVar_temp*deriv_sqrt_0_d0*(((xalphaf*instanceStruct.d_instanceVar_temp2_dX-instanceStruct.instanceVar_temp2*d_xalphaf_dX)/xalphaf/xalphaf))+instanceStruct.d_instanceVar_temp_dX*(value_sqrt_0-1.0)));
xedgefd = (xstard+(instanceStruct.instanceVar_temp*(value_sqrt_0-1.0)));
}
instanceStruct.d_instanceVar_temp_dX = 2.0*d_xalphab_dX;
instanceStruct.instanceVar_temp = (2.0*xalphab);
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_temp1/xalphab)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xedgebs_dX = (d_xstars_dX+(instanceStruct.instanceVar_temp*deriv_sqrt_0_d0*(((xalphab*instanceStruct.d_instanceVar_temp1_dX-instanceStruct.instanceVar_temp1*d_xalphab_dX)/xalphab/xalphab))+instanceStruct.d_instanceVar_temp_dX*(value_sqrt_0-1.0)));
xedgebs = (xstars+(instanceStruct.instanceVar_temp*(value_sqrt_0-1.0)));
}
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_temp2/xalphab)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xedgebd_dX = (d_xstard_dX+(instanceStruct.instanceVar_temp*deriv_sqrt_0_d0*(((xalphab*instanceStruct.d_instanceVar_temp2_dX-instanceStruct.instanceVar_temp2*d_xalphab_dX)/xalphab/xalphab))+instanceStruct.d_instanceVar_temp_dX*(value_sqrt_0-1.0)));
xedgebd = (xstard+(instanceStruct.instanceVar_temp*(value_sqrt_0-1.0)));
}
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_fif_phit*instanceStruct.d_instanceVar_CsiPrime_dX+instanceStruct.d_instanceVar_fif_phit_dX*instanceStruct.instanceVar_CsiPrime);
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_fif_phit*instanceStruct.instanceVar_CsiPrime);
instanceStruct.d_instanceVar_temp1_dX = ((((-instanceStruct.instanceVar_temp)*lambdaf)*instanceStruct.instanceVar_k1)*d_sce1_dX+(((-instanceStruct.instanceVar_temp)*lambdaf)*instanceStruct.d_instanceVar_k1_dX+((-instanceStruct.instanceVar_temp)*d_lambdaf_dX+(-instanceStruct.d_instanceVar_temp_dX)*lambdaf)*instanceStruct.instanceVar_k1)*sce1);
instanceStruct.instanceVar_temp1 = ((((-instanceStruct.instanceVar_temp)*lambdaf)*instanceStruct.instanceVar_k1)*sce1);
instanceStruct.d_instanceVar_temp2_dX = ((((-instanceStruct.instanceVar_temp)*lambdab)*k2)*d_sce2_dX+(((-instanceStruct.instanceVar_temp)*lambdab)*d_k2_dX+((-instanceStruct.instanceVar_temp)*d_lambdab_dX+(-instanceStruct.d_instanceVar_temp_dX)*lambdab)*k2)*sce2);
instanceStruct.instanceVar_temp2 = ((((-instanceStruct.instanceVar_temp)*lambdab)*k2)*sce2);
{
double value_sqrt_0 = sqrt(((((xedgefs-xeffs))*((xedgefs-xeffs)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.5*((d_xedgefs_dX-d_xeffs_dX)+deriv_sqrt_0_d0*((((xedgefs-xeffs))*(d_xedgefs_dX-d_xeffs_dX)+(d_xedgefs_dX-d_xeffs_dX)*((xedgefs-xeffs)))));
instanceStruct.instanceVar_temp = (0.5*((xedgefs-xeffs)+value_sqrt_0));
}
d_Qgsif_dX = (((xedgefs-xstars)*((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_temp1*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)-((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*(d_xedgefs_dX-d_xstars_dX))/(xedgefs-xstars)/(xedgefs-xstars));
Qgsif = (((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)/(xedgefs-xstars));
{
double value_sqrt_0 = sqrt(((((xedgefd-xeffd))*((xedgefd-xeffd)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.5*((d_xedgefd_dX-d_xeffd_dX)+deriv_sqrt_0_d0*((((xedgefd-xeffd))*(d_xedgefd_dX-d_xeffd_dX)+(d_xedgefd_dX-d_xeffd_dX)*((xedgefd-xeffd)))));
instanceStruct.instanceVar_temp = (0.5*((xedgefd-xeffd)+value_sqrt_0));
}
d_Qgdif_dX = (((xedgefd-xstard)*((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_temp1*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)-((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*(d_xedgefd_dX-d_xstard_dX))/(xedgefd-xstard)/(xedgefd-xstard));
Qgdif = (((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)/(xedgefd-xstard));
{
double value_sqrt_0 = sqrt(((((xedgebs-xeffs))*((xedgebs-xeffs)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.5*((d_xedgebs_dX-d_xeffs_dX)+deriv_sqrt_0_d0*((((xedgebs-xeffs))*(d_xedgebs_dX-d_xeffs_dX)+(d_xedgebs_dX-d_xeffs_dX)*((xedgebs-xeffs)))));
instanceStruct.instanceVar_temp = (0.5*((xedgebs-xeffs)+value_sqrt_0));
}
d_Qbsif_dX = (((xedgebs-xstars)*((instanceStruct.instanceVar_temp2*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_temp2*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_temp2_dX*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)-((instanceStruct.instanceVar_temp2*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*(d_xedgebs_dX-d_xstars_dX))/(xedgebs-xstars)/(xedgebs-xstars));
Qbsif = (((instanceStruct.instanceVar_temp2*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)/(xedgebs-xstars));
{
double value_sqrt_0 = sqrt(((((xedgebd-xeffd))*((xedgebd-xeffd)))+1.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.5*((d_xedgebd_dX-d_xeffd_dX)+deriv_sqrt_0_d0*((((xedgebd-xeffd))*(d_xedgebd_dX-d_xeffd_dX)+(d_xedgebd_dX-d_xeffd_dX)*((xedgebd-xeffd)))));
instanceStruct.instanceVar_temp = (0.5*((xedgebd-xeffd)+value_sqrt_0));
}
d_Qbdif_dX = (((xedgebd-xstard)*((instanceStruct.instanceVar_temp2*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_temp2*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_temp2_dX*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)-((instanceStruct.instanceVar_temp2*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*(d_xedgebd_dX-d_xstard_dX))/(xedgebd-xstard)/(xedgebd-xstard));
Qbdif = (((instanceStruct.instanceVar_temp2*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)/(xedgebd-xstard));
}
else
{
d_Qgsif_dX = 0.0;
Qgsif = 0.0;
d_Qgdif_dX = 0.0;
Qgdif = 0.0;
d_Qbsif_dX = 0.0;
Qbsif = 0.0;
d_Qbdif_dX = 0.0;
Qbdif = 0.0;
}
d_Qgse_dX = instanceStruct.d_instanceVar_CFR_i_dX*Vgsu;
Qgse = (instanceStruct.instanceVar_CFR_i*Vgsu);
d_Qgde_dX = instanceStruct.d_instanceVar_CFRD_i_dX*Vgdu;
Qgde = (instanceStruct.instanceVar_CFRD_i*Vgdu);
{
double value_sqrt_0 = sqrt(((((1.0-((instanceStruct.instanceVar_COVDL_i*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20)))))*((1.0-((instanceStruct.instanceVar_COVDL_i*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20))))))+0.2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.5*((-((instanceStruct.instanceVar_COVDL_i*dleff)*(-(instanceStruct.instanceVar_COVDLB_i*d_xg20_dX+instanceStruct.d_instanceVar_COVDLB_i_dX*xg20))+(instanceStruct.instanceVar_COVDL_i*d_dleff_dX+instanceStruct.d_instanceVar_COVDL_i_dX*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20))))+deriv_sqrt_0_d0*((((1.0-((instanceStruct.instanceVar_COVDL_i*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20)))))*(-((instanceStruct.instanceVar_COVDL_i*dleff)*(-(instanceStruct.instanceVar_COVDLB_i*d_xg20_dX+instanceStruct.d_instanceVar_COVDLB_i_dX*xg20))+(instanceStruct.instanceVar_COVDL_i*d_dleff_dX+instanceStruct.d_instanceVar_COVDL_i_dX*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20))))+(-((instanceStruct.instanceVar_COVDL_i*dleff)*(-(instanceStruct.instanceVar_COVDLB_i*d_xg20_dX+instanceStruct.d_instanceVar_COVDLB_i_dX*xg20))+(instanceStruct.instanceVar_COVDL_i*d_dleff_dX+instanceStruct.d_instanceVar_COVDL_i_dX*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20))))*((1.0-((instanceStruct.instanceVar_COVDL_i*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20))))))));
instanceStruct.instanceVar_temp = (0.5*((1.0-((instanceStruct.instanceVar_COVDL_i*dleff)*(1.0-(instanceStruct.instanceVar_COVDLB_i*xg20))))+value_sqrt_0));
}
d_Qovs_dX = ((instanceStruct.instanceVar_COV_i*Vovscv)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_COV_i*d_Vovscv_dX+instanceStruct.d_instanceVar_COV_i_dX*Vovscv)*instanceStruct.instanceVar_temp);
Qovs = ((instanceStruct.instanceVar_COV_i*Vovscv)*instanceStruct.instanceVar_temp);
d_Qovd_dX = ((instanceStruct.instanceVar_COVD_i*Vovdcv)*instanceStruct.d_instanceVar_temp_dX+(instanceStruct.instanceVar_COVD_i*d_Vovdcv_dX+instanceStruct.d_instanceVar_COVD_i_dX*Vovdcv)*instanceStruct.instanceVar_temp);
Qovd = ((instanceStruct.instanceVar_COVD_i*Vovdcv)*instanceStruct.instanceVar_temp);
d_Qgbe_dX = instanceStruct.d_instanceVar_CGBOV_i_dX*Vgb;
Qgbe = (instanceStruct.instanceVar_CGBOV_i*Vgb);
d_Qdse_dX = instanceStruct.d_instanceVar_CSD_i_dX*Vds;
Qdse = (instanceStruct.instanceVar_CSD_i*Vds);
d_Qssub_dX = (-((instanceStruct.instanceVar_Cox2Init*instanceStruct.d_instanceVar_ASOURCE_i_dX+instanceStruct.d_instanceVar_Cox2Init_dX*instanceStruct.instanceVar_ASOURCE_i)+(instanceStruct.instanceVar_CSDBP_i*instanceStruct.d_instanceVar_PSOURCE_i_dX+instanceStruct.d_instanceVar_CSDBP_i_dX*instanceStruct.instanceVar_PSOURCE_i)))*Vsbu;
Qssub = ((-((instanceStruct.instanceVar_Cox2Init*instanceStruct.instanceVar_ASOURCE_i)+(instanceStruct.instanceVar_CSDBP_i*instanceStruct.instanceVar_PSOURCE_i)))*Vsbu);
d_Qdsub_dX = (-((instanceStruct.instanceVar_Cox2Init*instanceStruct.d_instanceVar_ADRAIN_i_dX+instanceStruct.d_instanceVar_Cox2Init_dX*instanceStruct.instanceVar_ADRAIN_i)+(instanceStruct.instanceVar_CSDBP_i*instanceStruct.d_instanceVar_PDRAIN_i_dX+instanceStruct.d_instanceVar_CSDBP_i_dX*instanceStruct.instanceVar_PDRAIN_i)))*Vdbu;
Qdsub = ((-((instanceStruct.instanceVar_Cox2Init*instanceStruct.instanceVar_ADRAIN_i)+(instanceStruct.instanceVar_CSDBP_i*instanceStruct.instanceVar_PDRAIN_i)))*Vdbu);
if ((modelStruct.modelVar_SWSHE_i>0))
{
d_Qth_dX = instanceStruct.d_instanceVar_CTH_i_dX*instanceStruct.instanceVar_DTC;
Qth = (instanceStruct.instanceVar_CTH_i*instanceStruct.instanceVar_DTC);
}
else
{
d_Qth_dX = 0.0;
Qth = 0.0;
}
}
// End block evaluateDynamic
//Begin block loadStatic
{
d_Idse_dX = (instanceStruct.instanceVar_MULT_i*(instanceStruct.d_instanceVar_Ids_dX+instanceStruct.d_instanceVar_Iimpact_dX)+instanceStruct.d_instanceVar_MULT_i_dX*(instanceStruct.instanceVar_Ids+instanceStruct.instanceVar_Iimpact));
Idse = (instanceStruct.instanceVar_MULT_i*(instanceStruct.instanceVar_Ids+instanceStruct.instanceVar_Iimpact));
instanceStruct.d_instanceVar_Igse_dX = (instanceStruct.instanceVar_MULT_i*d_Igs_dX+instanceStruct.d_instanceVar_MULT_i_dX*Igs);
instanceStruct.instanceVar_Igse = (instanceStruct.instanceVar_MULT_i*Igs);
instanceStruct.d_instanceVar_Igde_dX = (instanceStruct.instanceVar_MULT_i*d_Igd_dX+instanceStruct.d_instanceVar_MULT_i_dX*Igd);
instanceStruct.instanceVar_Igde = (instanceStruct.instanceVar_MULT_i*Igd);
instanceStruct.d_instanceVar_Igidle_dX = (instanceStruct.instanceVar_MULT_i*d_Igidl_dX+instanceStruct.d_instanceVar_MULT_i_dX*Igidl);
instanceStruct.instanceVar_Igidle = (instanceStruct.instanceVar_MULT_i*Igidl);
instanceStruct.d_instanceVar_Igisle_dX = (instanceStruct.instanceVar_MULT_i*d_Igisl_dX+instanceStruct.d_instanceVar_MULT_i_dX*Igisl);
instanceStruct.instanceVar_Igisle = (instanceStruct.instanceVar_MULT_i*Igisl);
d_Ithpwre_dX = (instanceStruct.instanceVar_MULT_i*d_Ithpwr_dX+instanceStruct.d_instanceVar_MULT_i_dX*Ithpwr);
Ithpwre = (instanceStruct.instanceVar_MULT_i*Ithpwr);
d_Ithrce_dX = (instanceStruct.instanceVar_MULT_i*d_Ithrc_dX+instanceStruct.d_instanceVar_MULT_i_dX*Ithrc);
Ithrce = (instanceStruct.instanceVar_MULT_i*Ithrc);
if ((instanceStruct.instanceVar_sigVds<0))
{
// I(S,D) <+ (((M*TYPE)*Idse))
d_staticContributions_dX[admsNodeID_S]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*d_Idse_dX;
d_staticContributions_dX[(admsNodeID_D)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*d_Idse_dX;
}
else
{
// I(D,S) <+ (((M*TYPE)*Idse))
d_staticContributions_dX[admsNodeID_D]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*d_Idse_dX;
d_staticContributions_dX[(admsNodeID_S)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*d_Idse_dX;
}
// I(D,S) <+ (((M*TYPE)*(Igidle-Igisle)))
d_staticContributions_dX[admsNodeID_D]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(instanceStruct.d_instanceVar_Igidle_dX-instanceStruct.d_instanceVar_Igisle_dX);
d_staticContributions_dX[(admsNodeID_S)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(instanceStruct.d_instanceVar_Igidle_dX-instanceStruct.d_instanceVar_Igisle_dX);
// I(G,S) <+ (((M*TYPE)*Igse))
d_staticContributions_dX[admsNodeID_G]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*instanceStruct.d_instanceVar_Igse_dX;
d_staticContributions_dX[(admsNodeID_S)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*instanceStruct.d_instanceVar_Igse_dX;
// I(G,D) <+ (((M*TYPE)*Igde))
d_staticContributions_dX[admsNodeID_G]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*instanceStruct.d_instanceVar_Igde_dX;
d_staticContributions_dX[(admsNodeID_D)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*instanceStruct.d_instanceVar_Igde_dX;
// I(S,B) <+ (0.0)
d_staticContributions_dX[admsNodeID_S]+= 0.0;
d_staticContributions_dX[(admsNodeID_B)]-= 0.0;
// I(D,B) <+ (0.0)
d_staticContributions_dX[admsNodeID_D]+= 0.0;
d_staticContributions_dX[(admsNodeID_B)]-= 0.0;
// I(G,B) <+ (0.0)
d_staticContributions_dX[admsNodeID_G]+= 0.0;
d_staticContributions_dX[(admsNodeID_B)]-= 0.0;
// I(D,S) <+ (((M*gmin)*V(D,S)))
d_staticContributions_dX[admsNodeID_D]+= 0.0;
d_staticContributions_dX[(admsNodeID_S)]-= 0.0;
// Pwr(Tnode,GND) <+ ((M*Ithpwre))
d_staticContributions_dX[admsNodeID_Tnode]+= instanceStruct.instancePar_M*d_Ithpwre_dX;
// Pwr(Tnode,GND) <+ ((M*Ithrce))
d_staticContributions_dX[admsNodeID_Tnode]+= instanceStruct.instancePar_M*d_Ithrce_dX;
}
// End block loadStatic
//Begin block loadDynamic
{
d_Qg_dX = (instanceStruct.instanceVar_MULT_i*d_Qg_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qg);
Qg = (instanceStruct.instanceVar_MULT_i*Qg);
d_Qb_dX = (instanceStruct.instanceVar_MULT_i*d_Qb_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qb);
Qb = (instanceStruct.instanceVar_MULT_i*Qb);
d_Qd_dX = (instanceStruct.instanceVar_MULT_i*d_Qd_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qd);
Qd = (instanceStruct.instanceVar_MULT_i*Qd);
d_Qs_dX = (-((d_Qg_dX+d_Qb_dX)+d_Qd_dX));
Qs = (-((Qg+Qb)+Qd));
d_Qgsif_dX = (instanceStruct.instanceVar_MULT_i*d_Qgsif_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qgsif);
Qgsif = (instanceStruct.instanceVar_MULT_i*Qgsif);
d_Qgdif_dX = (instanceStruct.instanceVar_MULT_i*d_Qgdif_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qgdif);
Qgdif = (instanceStruct.instanceVar_MULT_i*Qgdif);
d_Qbsif_dX = (instanceStruct.instanceVar_MULT_i*d_Qbsif_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qbsif);
Qbsif = (instanceStruct.instanceVar_MULT_i*Qbsif);
d_Qbdif_dX = (instanceStruct.instanceVar_MULT_i*d_Qbdif_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qbdif);
Qbdif = (instanceStruct.instanceVar_MULT_i*Qbdif);
d_Qgse_dX = (instanceStruct.instanceVar_MULT_i*d_Qgse_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qgse);
Qgse = (instanceStruct.instanceVar_MULT_i*Qgse);
d_Qgde_dX = (instanceStruct.instanceVar_MULT_i*d_Qgde_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qgde);
Qgde = (instanceStruct.instanceVar_MULT_i*Qgde);
d_Qovs_dX = (instanceStruct.instanceVar_MULT_i*d_Qovs_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qovs);
Qovs = (instanceStruct.instanceVar_MULT_i*Qovs);
d_Qovd_dX = (instanceStruct.instanceVar_MULT_i*d_Qovd_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qovd);
Qovd = (instanceStruct.instanceVar_MULT_i*Qovd);
d_Qgbe_dX = (instanceStruct.instanceVar_MULT_i*d_Qgbe_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qgbe);
Qgbe = (instanceStruct.instanceVar_MULT_i*Qgbe);
d_Qssub_dX = (instanceStruct.instanceVar_MULT_i*d_Qssub_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qssub);
Qssub = (instanceStruct.instanceVar_MULT_i*Qssub);
d_Qdsub_dX = (instanceStruct.instanceVar_MULT_i*d_Qdsub_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qdsub);
Qdsub = (instanceStruct.instanceVar_MULT_i*Qdsub);
d_Qdse_dX = (instanceStruct.instanceVar_MULT_i*d_Qdse_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qdse);
Qdse = (instanceStruct.instanceVar_MULT_i*Qdse);
d_Qth_dX = (instanceStruct.instanceVar_MULT_i*d_Qth_dX+instanceStruct.d_instanceVar_MULT_i_dX*Qth);
Qth = (instanceStruct.instanceVar_MULT_i*Qth);
if ((instanceStruct.instanceVar_sigVds<0.0))
{
instanceStruct.d_instanceVar_temp_dX = d_Qd_dX;
instanceStruct.instanceVar_temp = Qd;
d_Qd_dX = d_Qs_dX;
Qd = Qs;
d_Qs_dX = instanceStruct.d_instanceVar_temp_dX;
Qs = instanceStruct.instanceVar_temp;
d_Qdse_dX = (-d_Qdse_dX);
Qdse = (-Qdse);
instanceStruct.d_instanceVar_temp_dX = d_Qgdif_dX;
instanceStruct.instanceVar_temp = Qgdif;
d_Qgdif_dX = d_Qgsif_dX;
Qgdif = Qgsif;
d_Qgsif_dX = instanceStruct.d_instanceVar_temp_dX;
Qgsif = instanceStruct.instanceVar_temp;
instanceStruct.d_instanceVar_temp_dX = d_Qbdif_dX;
instanceStruct.instanceVar_temp = Qbdif;
d_Qbdif_dX = d_Qbsif_dX;
Qbdif = Qbsif;
d_Qbsif_dX = instanceStruct.d_instanceVar_temp_dX;
Qbsif = instanceStruct.instanceVar_temp;
}
// I(G,S) <+ (((M*TYPE)*(((ddt(Qg)+ddt(Qgse))+ddt(Qovs))+ddt(Qgsif))))
d_dynamicContributions_dX[admsNodeID_G]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*((((d_Qg_dX)+(d_Qgse_dX))+(d_Qovs_dX))+(d_Qgsif_dX));
d_dynamicContributions_dX[(admsNodeID_S)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*((((d_Qg_dX)+(d_Qgse_dX))+(d_Qovs_dX))+(d_Qgsif_dX));
// I(B,S) <+ (((M*TYPE)*((ddt(Qb)+ddt(Qssub))+ddt(Qbsif))))
d_dynamicContributions_dX[admsNodeID_B]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(((d_Qb_dX)+(d_Qssub_dX))+(d_Qbsif_dX));
d_dynamicContributions_dX[(admsNodeID_S)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(((d_Qb_dX)+(d_Qssub_dX))+(d_Qbsif_dX));
// I(D,S) <+ (((M*TYPE)*(ddt(Qd)+ddt(Qdse))))
d_dynamicContributions_dX[admsNodeID_D]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*((d_Qd_dX)+(d_Qdse_dX));
d_dynamicContributions_dX[(admsNodeID_S)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*((d_Qd_dX)+(d_Qdse_dX));
// I(G,D) <+ (((M*TYPE)*((ddt(Qgde)+ddt(Qovd))+ddt(Qgdif))))
d_dynamicContributions_dX[admsNodeID_G]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(((d_Qgde_dX)+(d_Qovd_dX))+(d_Qgdif_dX));
d_dynamicContributions_dX[(admsNodeID_D)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(((d_Qgde_dX)+(d_Qovd_dX))+(d_Qgdif_dX));
// I(B,D) <+ (((M*TYPE)*(ddt(Qdsub)+ddt(Qbdif))))
d_dynamicContributions_dX[admsNodeID_B]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*((d_Qdsub_dX)+(d_Qbdif_dX));
d_dynamicContributions_dX[(admsNodeID_D)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*((d_Qdsub_dX)+(d_Qbdif_dX));
// I(G,B) <+ (((M*TYPE)*ddt(Qgbe)))
d_dynamicContributions_dX[admsNodeID_G]+= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(d_Qgbe_dX);
d_dynamicContributions_dX[(admsNodeID_B)]-= (instanceStruct.instancePar_M*modelStruct.modelPar_TYPE)*(d_Qgbe_dX);
// Pwr(Tnode,GND) <+ ((M*ddt(Qth)))
d_dynamicContributions_dX[admsNodeID_Tnode]+= instanceStruct.instancePar_M*(d_Qth_dX);
}
// End block loadDynamic
//Begin block OPinfo
{
d_r1init_op_dX = (((1.0+k2)*((instanceStruct.instanceVar_k1*d_k2_dX-k2*instanceStruct.d_instanceVar_k1_dX)/instanceStruct.instanceVar_k1/instanceStruct.instanceVar_k1)-(k2/instanceStruct.instanceVar_k1)*d_k2_dX)/(1.0+k2)/(1.0+k2));
r1init_op = ((k2/instanceStruct.instanceVar_k1)/(1.0+k2));
d_r2init_op_dX = (((1.0+instanceStruct.instanceVar_k1)*((k2*instanceStruct.d_instanceVar_k1_dX-instanceStruct.instanceVar_k1*d_k2_dX)/k2/k2)-(instanceStruct.instanceVar_k1/k2)*instanceStruct.d_instanceVar_k1_dX)/(1.0+instanceStruct.instanceVar_k1)/(1.0+instanceStruct.instanceVar_k1));
r2init_op = ((instanceStruct.instanceVar_k1/k2)/(1.0+instanceStruct.instanceVar_k1));
{
double value_log_0 = log((((instanceStruct.instanceVar_k1*(1.0+r1init_op))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((instanceStruct.instanceVar_k1*(1.0+r1init_op))*diff_min)/A0));
d_x1init_op_dX = deriv_log_0_d0*(((A0*((instanceStruct.instanceVar_k1*(1.0+r1init_op))*d_diff_min_dX+(instanceStruct.instanceVar_k1*d_r1init_op_dX+instanceStruct.d_instanceVar_k1_dX*(1.0+r1init_op))*diff_min)-((instanceStruct.instanceVar_k1*(1.0+r1init_op))*diff_min)*d_A0_dX)/A0/A0));
x1init_op = (value_log_0+2.0);
}
{
double value_log_0 = log((((k2*(1.0+r2init_op))*diff_min)/A0));
double  deriv_log_0_d0 = (1.0/(((k2*(1.0+r2init_op))*diff_min)/A0));
d_x2init_op_dX = deriv_log_0_d0*(((A0*((k2*(1.0+r2init_op))*d_diff_min_dX+(k2*d_r2init_op_dX+d_k2_dX*(1.0+r2init_op))*diff_min)-((k2*(1.0+r2init_op))*diff_min)*d_A0_dX)/A0/A0));
x2init_op = (value_log_0+2.0);
}
d_xth1init_op_dX = (((1.0+r1init_op)*d_x1init_op_dX+d_r1init_op_dX*x1init_op)-(xg2x*d_r1init_op_dX+d_xg2x_dX*r1init_op));
xth1init_op = (((1.0+r1init_op)*x1init_op)-(xg2x*r1init_op));
d_xth2init_op_dX = (((1.0+(1.0/r2init_op))*d_x2init_op_dX+(-d_r2init_op_dX/r2init_op/r2init_op)*x2init_op)-((r2init_op*d_xg2x_dX-xg2x*d_r2init_op_dX)/r2init_op/r2init_op));
xth2init_op = (((1.0+(1.0/r2init_op))*x2init_op)-(xg2x/r2init_op));
{
double value_sqrt_0 = sqrt((((xth1init_op-xth2init_op)*(xth1init_op-xth2init_op))+38.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xg1thinit_op_dX = (((instanceStruct.instanceVar_CIC1_i*(0.5*((d_xth1init_op_dX+d_xth2init_op_dX)-deriv_sqrt_0_d0*(((xth1init_op-xth2init_op)*(d_xth1init_op_dX-d_xth2init_op_dX)+(d_xth1init_op_dX-d_xth2init_op_dX)*(xth1init_op-xth2init_op))))-d_xg2_dX)-((0.5*((xth1init_op+xth2init_op)-value_sqrt_0))-xg2)*instanceStruct.d_instanceVar_CIC1_i_dX)/instanceStruct.instanceVar_CIC1_i/instanceStruct.instanceVar_CIC1_i)+d_xg2_dX);
xg1thinit_op = ((((0.5*((xth1init_op+xth2init_op)-value_sqrt_0))-xg2)/instanceStruct.instanceVar_CIC1_i)+xg2);
}
d_vthinit_op_dX = ((instanceStruct.instanceVar_phit*((((sce1*(d_xg1thinit_op_dX-d_xedge_dX)-(xg1thinit_op-xedge)*d_sce1_dX)/sce1/sce1)-d_dxg1_dibl_dX)+d_xedge_dX)+instanceStruct.d_instanceVar_phit_dX*((((xg1thinit_op-xedge)/sce1)-dxg1_dibl)+xedge))+instanceStruct.d_instanceVar_VFB1_i_dX);
vthinit_op = ((instanceStruct.instanceVar_phit*((((xg1thinit_op-xedge)/sce1)-dxg1_dibl)+xedge))+instanceStruct.instanceVar_VFB1_i);
inv_phit0_op = (1.0/(modelStruct.modelVar_TKD*8.617332384961E-05));
EgSi_op = (1.17-(((4.730e-4*modelStruct.modelVar_TKD)*modelStruct.modelVar_TKD)/(636+modelStruct.modelVar_TKD)));
EgGe_op = (0.744-(((4.774e-4*modelStruct.modelVar_TKD)*modelStruct.modelVar_TKD)/(235+modelStruct.modelVar_TKD)));
d_dEg_op_dX = (((EgGe_op-EgSi_op)+((-0.4)*instanceStruct.instanceVar_one_m_xge))*instanceStruct.d_instanceVar_XGE_i_dX+(-0.4)*instanceStruct.d_instanceVar_one_m_xge_dX*instanceStruct.instanceVar_XGE_i);
dEg_op = (((EgGe_op-EgSi_op)+((-0.4)*instanceStruct.instanceVar_one_m_xge))*instanceStruct.instanceVar_XGE_i);
d_Eg_op_dX = d_dEg_op_dX;
Eg_op = (EgSi_op+dEg_op);
d_Eg_2phit0_op_dX = 0.5*d_Eg_op_dX*inv_phit0_op;
Eg_2phit0_op = ((0.5*Eg_op)*inv_phit0_op);
d_dVfbch_op_dX = (0.05*instanceStruct.d_instanceVar_XGE_i_dX-0.5*d_dEg_op_dX);
dVfbch_op = ((0.05*instanceStruct.instanceVar_XGE_i)-(0.5*dEg_op));
{
double value_sqrt_0 = sqrt((modelStruct.modelVar_TKD*0.0033333333333));
instanceStruct.d_instanceVar_temp_dX = 0.0;
instanceStruct.instanceVar_temp = value_sqrt_0;
}
instanceStruct.d_instanceVar_temp1_dX = (((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_temp_dX+4.05E25*instanceStruct.d_instanceVar_temp_dX*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp);
instanceStruct.instanceVar_temp1 = (((4.05E25*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp)*instanceStruct.instanceVar_temp);
{
double value_exp_0 = exp((-Eg_2phit0_op));
double  deriv_exp_0_d0 = value_exp_0;
d_neff_op_dX = ((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_niratio)*deriv_exp_0_d0*((-d_Eg_2phit0_op_dX))+(instanceStruct.instanceVar_temp1*instanceStruct.d_instanceVar_niratio_dX+instanceStruct.d_instanceVar_temp1_dX*instanceStruct.instanceVar_niratio)*value_exp_0);
neff_op = ((instanceStruct.instanceVar_temp1*instanceStruct.instanceVar_niratio)*value_exp_0);
}
d_inv_phit_op_dX = (-inv_phit0_op*((instanceStruct.instanceVar_CT_i*modelStruct.d_modelVar_TKR_dX+instanceStruct.d_instanceVar_CT_i_dX*modelStruct.modelVar_TKR)/modelStruct.modelVar_TKD)/(1.0+((instanceStruct.instanceVar_CT_i*modelStruct.modelVar_TKR)/modelStruct.modelVar_TKD))/(1.0+((instanceStruct.instanceVar_CT_i*modelStruct.modelVar_TKR)/modelStruct.modelVar_TKD)));
inv_phit_op = (inv_phit0_op/(1.0+((instanceStruct.instanceVar_CT_i*modelStruct.modelVar_TKR)/modelStruct.modelVar_TKD)));
d_A0_Csisq_op_dX = ((((2.0*1.602176565E-19)*neff_op)*instanceStruct.instanceVar_epsch)*d_inv_phit_op_dX+(((2.0*1.602176565E-19)*neff_op)*instanceStruct.d_instanceVar_epsch_dX+(2.0*1.602176565E-19)*d_neff_op_dX*instanceStruct.instanceVar_epsch)*inv_phit_op);
A0_Csisq_op = ((((2.0*1.602176565E-19)*neff_op)*instanceStruct.instanceVar_epsch)*inv_phit_op);
{
double value_log_0 = log(((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)/A0_Csisq_op));
double  deriv_log_0_d0 = (1.0/((instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)/A0_Csisq_op));
d_xth_1D_op_dX = deriv_log_0_d0*(((A0_Csisq_op*(instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_CsiPrime_0_dX+instanceStruct.d_instanceVar_CsiPrime_0_dX*instanceStruct.instanceVar_CsiPrime_0)-(instanceStruct.instanceVar_CsiPrime_0*instanceStruct.instanceVar_CsiPrime_0)*d_A0_Csisq_op_dX)/A0_Csisq_op/A0_Csisq_op));
xth_1D_op = (value_log_0-0.6931471805599);
}
d_xSDdep_op_dX = (((((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*d_inv_phit_op_dX+(((instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime)*(((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.d_instanceVar_TSI_i_dX+(0.5*1.602176565E-19)*instanceStruct.d_instanceVar_NSDDC_i_dX*instanceStruct.instanceVar_TSI_i)-(((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)*(instanceStruct.d_instanceVar_Cox1Prime_dX+instanceStruct.d_instanceVar_Cox2Prime_dX))/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*inv_phit_op);
xSDdep_op = (((((0.5*1.602176565E-19)*instanceStruct.instanceVar_NSDDC_i)*instanceStruct.instanceVar_TSI_i)/(instanceStruct.instanceVar_Cox1Prime+instanceStruct.instanceVar_Cox2Prime))*inv_phit_op);
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_STCF_i*(-modelStruct.d_modelVar_TKR_dX)+instanceStruct.d_instanceVar_STCF_i_dX*(modelStruct.modelVar_TKD-modelStruct.modelVar_TKR));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_STCF_i*(modelStruct.modelVar_TKD-modelStruct.modelVar_TKR));
d_CF1_op_dX = (instanceStruct.d_instanceVar_CF1_t_dX+instanceStruct.d_instanceVar_temp_dX);
CF1_op = (instanceStruct.instanceVar_CF1_t+instanceStruct.instanceVar_temp);
d_CF2_op_dX = (instanceStruct.d_instanceVar_CF2_t_dX+instanceStruct.d_instanceVar_temp_dX);
CF2_op = (instanceStruct.instanceVar_CF2_t+instanceStruct.instanceVar_temp);
d_xd0_op_dX = (instanceStruct.instanceVar_CFD_i*d_inv_phit_op_dX+instanceStruct.d_instanceVar_CFD_i_dX*inv_phit_op);
xd0_op = (instanceStruct.instanceVar_CFD_i*inv_phit_op);
d_qq_op_dX = 0.0;
qq_op = 0.0;
if ((modelStruct.modelPar_QMC>0.0))
{
if ((modelStruct.modelPar_TYPE==(+1)))
{
{
double value_log_0 = log((instanceStruct.instanceVar_tsisq/inv_phit_op));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_tsisq/inv_phit_op));
double  deriv_exp_1_d0 = value_exp_1;
d_qq_op_dX = (((0.4*modelStruct.modelPar_QMC)*1.27520989)*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*(((inv_phit_op*instanceStruct.d_instanceVar_tsisq_dX-instanceStruct.instanceVar_tsisq*d_inv_phit_op_dX)/inv_phit_op/inv_phit_op)))+0.4*modelStruct.d_modelPar_QMC_dX*1.27520989*value_exp_1);
qq_op = (((0.4*modelStruct.modelPar_QMC)*1.27520989)*value_exp_1);
}
}
else
{
{
double value_log_0 = log((instanceStruct.instanceVar_tsisq/inv_phit_op));
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/(instanceStruct.instanceVar_tsisq/inv_phit_op));
double  deriv_exp_1_d0 = value_exp_1;
d_qq_op_dX = (((0.4*modelStruct.modelPar_QMC)*1.54120870)*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*(((inv_phit_op*instanceStruct.d_instanceVar_tsisq_dX-instanceStruct.instanceVar_tsisq*d_inv_phit_op_dX)/inv_phit_op/inv_phit_op)))+0.4*modelStruct.d_modelPar_QMC_dX*1.54120870*value_exp_1);
qq_op = (((0.4*modelStruct.modelPar_QMC)*1.54120870)*value_exp_1);
}
}
}
instanceStruct.d_instanceVar_temp_dX = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_STVFB_i)*(-modelStruct.d_modelVar_TKR_dX)+modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_STVFB_i_dX*(modelStruct.modelVar_TKD-modelStruct.modelVar_TKR))+instanceStruct.d_instanceVar_dVfbQM_dX);
instanceStruct.instanceVar_temp = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_STVFB_i)*(modelStruct.modelVar_TKD-modelStruct.modelVar_TKR))+instanceStruct.instanceVar_dVfbQM);
d_VFB1_op_dX = ((modelStruct.modelPar_TYPE*((instanceStruct.d_instanceVar_VFB1_t_dX+d_dVfbch_op_dX)+instanceStruct.d_instanceVar_dVfb1Nch_dX)+instanceStruct.d_instanceVar_temp_dX)+instanceStruct.d_instancePar_DELVTO_dX);
VFB1_op = (((modelStruct.modelPar_TYPE*((instanceStruct.instanceVar_VFB1_t+dVfbch_op)+instanceStruct.instanceVar_dVfb1Nch))+instanceStruct.instanceVar_temp)+instanceStruct.instancePar_DELVTO);
d_VFB2_op_dX = (modelStruct.modelPar_TYPE*((instanceStruct.d_instanceVar_VFB2_t_dX+d_dVfbch_op_dX)+instanceStruct.d_instanceVar_dVfb2Nch_dX)+instanceStruct.d_instanceVar_temp_dX);
VFB2_op = ((modelStruct.modelPar_TYPE*((instanceStruct.instanceVar_VFB2_t+dVfbch_op)+instanceStruct.instanceVar_dVfb2Nch))+instanceStruct.instanceVar_temp);
d_xd_op_dX = Vds*d_inv_phit_op_dX;
xd_op = (Vds*inv_phit_op);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xdsx_op_dX = (value_sqrt_0-0.1)*d_inv_phit_op_dX;
xdsx_op = ((value_sqrt_0-0.1)*inv_phit_op);
}
d_dxdsx_op_dX = 0.5*(d_xd_op_dX-d_xdsx_op_dX);
dxdsx_op = (0.5*(xd_op-xdsx_op));
d_xg10_op_dX = (((vthinit_op-VFB1_op)*d_inv_phit_op_dX+(d_vthinit_op_dX-d_VFB1_op_dX)*inv_phit_op)-d_dxdsx_op_dX);
xg10_op = (((vthinit_op-VFB1_op)*inv_phit_op)-dxdsx_op);
d_xg20_op_dX = ((((-Vsb)-VFB2_op)*d_inv_phit_op_dX+(-d_VFB2_op_dX)*inv_phit_op)-d_dxdsx_op_dX);
xg20_op = ((((-Vsb)-VFB2_op)*inv_phit_op)-dxdsx_op);
if ((modelStruct.modelPar_SWSUBDEP>0))
{
instanceStruct.d_instanceVar_temp_dX = ((instanceStruct.instanceVar_Gfsub*(modelStruct.modelPar_TYPE*instanceStruct.instanceVar_TYPESUB_i)*(d_xg10_op_dX-d_xg20_op_dX)-((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_TYPESUB_i)*(xg10_op-xg20_op))*instanceStruct.d_instanceVar_Gfsub_dX)/instanceStruct.instanceVar_Gfsub/instanceStruct.instanceVar_Gfsub);
instanceStruct.instanceVar_temp = (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_TYPESUB_i)*(xg10_op-xg20_op))/instanceStruct.instanceVar_Gfsub);
if ((instanceStruct.instanceVar_temp<0.0))
{
{
double value_log_0 = log((1.0-instanceStruct.instanceVar_temp));
double  deriv_log_0_d0 = (1.0/(1.0-instanceStruct.instanceVar_temp));
instanceStruct.d_instanceVar_temp1_dX = (-2.0)*deriv_log_0_d0*((-instanceStruct.d_instanceVar_temp_dX));
instanceStruct.instanceVar_temp1 = ((-2.0)*value_log_0);
}
}
else
{
instanceStruct.d_instanceVar_temp1_dX = (((1.0+((2.0*instanceStruct.instanceVar_temp)/instanceStruct.instanceVar_Gfsub))*(instanceStruct.instanceVar_temp*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_temp_dX*instanceStruct.instanceVar_temp)-(instanceStruct.instanceVar_temp*instanceStruct.instanceVar_temp)*((instanceStruct.instanceVar_Gfsub*2.0*instanceStruct.d_instanceVar_temp_dX-(2.0*instanceStruct.instanceVar_temp)*instanceStruct.d_instanceVar_Gfsub_dX)/instanceStruct.instanceVar_Gfsub/instanceStruct.instanceVar_Gfsub))/(1.0+((2.0*instanceStruct.instanceVar_temp)/instanceStruct.instanceVar_Gfsub))/(1.0+((2.0*instanceStruct.instanceVar_temp)/instanceStruct.instanceVar_Gfsub)));
instanceStruct.instanceVar_temp1 = ((instanceStruct.instanceVar_temp*instanceStruct.instanceVar_temp)/(1.0+((2.0*instanceStruct.instanceVar_temp)/instanceStruct.instanceVar_Gfsub)));
}
d_xg2eff_op_dX = (d_xg20_op_dX+(modelStruct.modelPar_TYPE*instanceStruct.instanceVar_TYPESUB_i)*instanceStruct.d_instanceVar_temp1_dX);
xg2eff_op = (xg20_op+((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_TYPESUB_i)*instanceStruct.instanceVar_temp1));
}
else
{
d_xg2eff_op_dX = d_xg20_op_dX;
xg2eff_op = xg20_op;
}
instanceStruct.d_instanceVar_temp_dX = (instanceStruct.instanceVar_keq_1D*(d_xg10_op_dX-d_xg2eff_op_dX)+instanceStruct.d_instanceVar_keq_1D_dX*(xg10_op-xg2eff_op));
instanceStruct.instanceVar_temp = (instanceStruct.instanceVar_keq_1D*(xg10_op-xg2eff_op));
if ((modelStruct.modelPar_QMC>0.0))
{
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_temp-15.0)*(instanceStruct.instanceVar_temp-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_e1_op_dX = 0.5*(instanceStruct.d_instanceVar_temp_dX+deriv_sqrt_0_d0*(((instanceStruct.instanceVar_temp-15.0)*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_temp_dX*(instanceStruct.instanceVar_temp-15.0))));
e1_op = (0.5*((instanceStruct.instanceVar_temp+15.0)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((((-instanceStruct.instanceVar_temp)-15.0)*((-instanceStruct.instanceVar_temp)-15.0))+225.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_e2_op_dX = 0.5*((-instanceStruct.d_instanceVar_temp_dX)+deriv_sqrt_0_d0*((((-instanceStruct.instanceVar_temp)-15.0)*(-instanceStruct.d_instanceVar_temp_dX)+(-instanceStruct.d_instanceVar_temp_dX)*((-instanceStruct.instanceVar_temp)-15.0))));
e2_op = (0.5*(((-instanceStruct.instanceVar_temp)+15.0)+value_sqrt_0));
}
{
double value_log_0 = log(e1_op);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e1_op);
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp1_dX = (qq_op*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*(d_e1_op_dX))+d_qq_op_dX*value_exp_1);
instanceStruct.instanceVar_temp1 = (qq_op*value_exp_1);
}
{
double value_log_0 = log(e2_op);
double value_exp_1 = exp(((-0.3333333333333)*value_log_0));
double  deriv_log_0_d0 = (1.0/e2_op);
double  deriv_exp_1_d0 = value_exp_1;
instanceStruct.d_instanceVar_temp2_dX = (qq_op*deriv_exp_1_d0*((-0.3333333333333)*deriv_log_0_d0*(d_e2_op_dX))+d_qq_op_dX*value_exp_1);
instanceStruct.instanceVar_temp2 = (qq_op*value_exp_1);
}
instanceStruct.d_instanceVar_temp3_dX = ((-instanceStruct.d_instanceVar_temp1_dX)-instanceStruct.d_instanceVar_temp2_dX);
instanceStruct.instanceVar_temp3 = ((1.0-instanceStruct.instanceVar_temp1)-instanceStruct.instanceVar_temp2);
d_CsiPrime_op_dX = ((instanceStruct.instanceVar_temp3*instanceStruct.d_instanceVar_CsiPrime_0_dX-instanceStruct.instanceVar_CsiPrime_0*instanceStruct.d_instanceVar_temp3_dX)/instanceStruct.instanceVar_temp3/instanceStruct.instanceVar_temp3);
CsiPrime_op = (instanceStruct.instanceVar_CsiPrime_0/instanceStruct.instanceVar_temp3);
d_k1_1D_QM_op_dX = (((1.0+(instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp1))*(instanceStruct.instanceVar_k1_1D*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_k1_1D_dX*instanceStruct.instanceVar_temp3)-(instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp3)*(instanceStruct.instanceVar_k1_1D*instanceStruct.d_instanceVar_temp1_dX+instanceStruct.d_instanceVar_k1_1D_dX*instanceStruct.instanceVar_temp1))/(1.0+(instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp1))/(1.0+(instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp1)));
k1_1D_QM_op = ((instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp3)/(1.0+(instanceStruct.instanceVar_k1_1D*instanceStruct.instanceVar_temp1)));
d_k2_1D_QM_op_dX = (((1.0+(instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp2))*(instanceStruct.instanceVar_k2_1D*instanceStruct.d_instanceVar_temp3_dX+instanceStruct.d_instanceVar_k2_1D_dX*instanceStruct.instanceVar_temp3)-(instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp3)*(instanceStruct.instanceVar_k2_1D*instanceStruct.d_instanceVar_temp2_dX+instanceStruct.d_instanceVar_k2_1D_dX*instanceStruct.instanceVar_temp2))/(1.0+(instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp2))/(1.0+(instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp2)));
k2_1D_QM_op = ((instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp3)/(1.0+(instanceStruct.instanceVar_k2_1D*instanceStruct.instanceVar_temp2)));
d_keq_1D_QM_op_dX = (-((-d_k1_1D_QM_op_dX/k1_1D_QM_op/k1_1D_QM_op)+(-d_k2_1D_QM_op_dX/k2_1D_QM_op/k2_1D_QM_op))/((1.0+(1.0/k1_1D_QM_op))+(1.0/k2_1D_QM_op))/((1.0+(1.0/k1_1D_QM_op))+(1.0/k2_1D_QM_op)));
keq_1D_QM_op = (1.0/((1.0+(1.0/k1_1D_QM_op))+(1.0/k2_1D_QM_op)));
}
else
{
d_CsiPrime_op_dX = instanceStruct.d_instanceVar_CsiPrime_0_dX;
CsiPrime_op = instanceStruct.instanceVar_CsiPrime_0;
d_k1_1D_QM_op_dX = instanceStruct.d_instanceVar_k1_1D_dX;
k1_1D_QM_op = instanceStruct.instanceVar_k1_1D;
d_k2_1D_QM_op_dX = instanceStruct.d_instanceVar_k2_1D_dX;
k2_1D_QM_op = instanceStruct.instanceVar_k2_1D;
d_keq_1D_QM_op_dX = instanceStruct.d_instanceVar_keq_1D_dX;
keq_1D_QM_op = instanceStruct.instanceVar_keq_1D;
}
d_Dx_WI_1D_op_dX = (keq_1D_QM_op*(d_xg10_op_dX-d_xg2eff_op_dX)+d_keq_1D_QM_op_dX*(xg10_op-xg2eff_op));
Dx_WI_1D_op = (keq_1D_QM_op*(xg10_op-xg2eff_op));
if ((Dx_WI_1D_op>0.0))
{
if (((-Dx_WI_1D_op)<80.0))
{
{
double value_exp_0 = exp((-Dx_WI_1D_op));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp_dX = deriv_log_1_d0*(deriv_exp_0_d0*((-d_Dx_WI_1D_op_dX)));
instanceStruct.instanceVar_temp = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp_dX = (-d_Dx_WI_1D_op_dX);
instanceStruct.instanceVar_temp = (-Dx_WI_1D_op);
}
d_x_WI_1D_op_dX = ((d_xg10_op_dX-((k1_1D_QM_op*d_Dx_WI_1D_op_dX-Dx_WI_1D_op*d_k1_1D_QM_op_dX)/k1_1D_QM_op/k1_1D_QM_op))+instanceStruct.d_instanceVar_temp_dX);
x_WI_1D_op = (((xg10_op-(Dx_WI_1D_op/k1_1D_QM_op))+instanceStruct.instanceVar_temp)-0.6931471805599);
}
else
{
if ((Dx_WI_1D_op<80.0))
{
{
double value_exp_0 = exp(Dx_WI_1D_op);
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
instanceStruct.d_instanceVar_temp_dX = deriv_log_1_d0*(deriv_exp_0_d0*(d_Dx_WI_1D_op_dX));
instanceStruct.instanceVar_temp = value_log_1;
}
}
else
{
instanceStruct.d_instanceVar_temp_dX = d_Dx_WI_1D_op_dX;
instanceStruct.instanceVar_temp = Dx_WI_1D_op;
}
d_x_WI_1D_op_dX = ((d_xg2eff_op_dX+((k2_1D_QM_op*d_Dx_WI_1D_op_dX-Dx_WI_1D_op*d_k2_1D_QM_op_dX)/k2_1D_QM_op/k2_1D_QM_op))+instanceStruct.d_instanceVar_temp_dX);
x_WI_1D_op = (((xg2eff_op+(Dx_WI_1D_op/k2_1D_QM_op))+instanceStruct.instanceVar_temp)-0.6931471805599);
}
{
double value_sqrt_0 = sqrt((((x_WI_1D_op-xth_1D_op)*(x_WI_1D_op-xth_1D_op))+4.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_1D_op_dX = 0.5*((d_x_WI_1D_op_dX+d_xth_1D_op_dX)-deriv_sqrt_0_d0*(((x_WI_1D_op-xth_1D_op)*(d_x_WI_1D_op_dX-d_xth_1D_op_dX)+(d_x_WI_1D_op_dX-d_xth_1D_op_dX)*(x_WI_1D_op-xth_1D_op))));
x_1D_op = (0.5*((x_WI_1D_op+xth_1D_op)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+((2.0*(xth_1D_op-x_1D_op))/xSDdep_op)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dleff_op_dX = deriv_sqrt_0_d0*(((xSDdep_op*2.0*(d_xth_1D_op_dX-d_x_1D_op_dX)-(2.0*(xth_1D_op-x_1D_op))*d_xSDdep_op_dX)/xSDdep_op/xSDdep_op));
dleff_op = (value_sqrt_0-1.0);
}
d_xedge_op_dX = (d_x_1D_op_dX+(xSDdep_op*d_dleff_op_dX+d_xSDdep_op_dX*dleff_op));
xedge_op = (x_1D_op+(xSDdep_op*dleff_op));
{
double value_sqrt_0 = sqrt(((((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20_op))-0.5)*((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20_op))-0.5))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = 0.5*((instanceStruct.instanceVar_PSCEDLB_i*d_xg20_op_dX+instanceStruct.d_instanceVar_PSCEDLB_i_dX*xg20_op)+deriv_sqrt_0_d0*((((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20_op))-0.5)*(instanceStruct.instanceVar_PSCEDLB_i*d_xg20_op_dX+instanceStruct.d_instanceVar_PSCEDLB_i_dX*xg20_op)+(instanceStruct.instanceVar_PSCEDLB_i*d_xg20_op_dX+instanceStruct.d_instanceVar_PSCEDLB_i_dX*xg20_op)*((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20_op))-0.5))));
instanceStruct.instanceVar_temp = (0.5*(((1.0+(instanceStruct.instanceVar_PSCEDLB_i*xg20_op))+0.5)+value_sqrt_0));
}
d_sce1_op_dX = (-(instanceStruct.instanceVar_PSCE1_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_PSCE1_i_dX*instanceStruct.instanceVar_temp)/(1.0+(instanceStruct.instanceVar_PSCE1_i*instanceStruct.instanceVar_temp))/(1.0+(instanceStruct.instanceVar_PSCE1_i*instanceStruct.instanceVar_temp)));
sce1_op = (1.0/(1.0+(instanceStruct.instanceVar_PSCE1_i*instanceStruct.instanceVar_temp)));
d_sce2_op_dX = (-(instanceStruct.instanceVar_PSCE2_i*instanceStruct.d_instanceVar_temp_dX+instanceStruct.d_instanceVar_PSCE2_i_dX*instanceStruct.instanceVar_temp)/(1.0+(instanceStruct.instanceVar_PSCE2_i*instanceStruct.instanceVar_temp))/(1.0+(instanceStruct.instanceVar_PSCE2_i*instanceStruct.instanceVar_temp)));
sce2_op = (1.0/(1.0+(instanceStruct.instanceVar_PSCE2_i*instanceStruct.instanceVar_temp)));
{
double value_sqrt_0 = sqrt((1.0+(xdsx_op/xd0_op)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_temp_dX = ((((2.0*xd0_op)*(value_sqrt_0-1.0))*(1.0+(instanceStruct.instanceVar_CFDL_i*dleff_op)))*(instanceStruct.instanceVar_CFDLB_i*d_xg20_op_dX+instanceStruct.d_instanceVar_CFDLB_i_dX*xg20_op)+(((2.0*xd0_op)*(value_sqrt_0-1.0))*(instanceStruct.instanceVar_CFDL_i*d_dleff_op_dX+instanceStruct.d_instanceVar_CFDL_i_dX*dleff_op)+((2.0*xd0_op)*deriv_sqrt_0_d0*(((xd0_op*d_xdsx_op_dX-xdsx_op*d_xd0_op_dX)/xd0_op/xd0_op))+2.0*d_xd0_op_dX*(value_sqrt_0-1.0))*(1.0+(instanceStruct.instanceVar_CFDL_i*dleff_op)))*(1.0+(instanceStruct.instanceVar_CFDLB_i*xg20_op)));
instanceStruct.instanceVar_temp = ((((2.0*xd0_op)*(value_sqrt_0-1.0))*(1.0+(instanceStruct.instanceVar_CFDL_i*dleff_op)))*(1.0+(instanceStruct.instanceVar_CFDLB_i*xg20_op)));
}
d_dxg1_dibl_op_dX = (CF1_op*instanceStruct.d_instanceVar_temp_dX+d_CF1_op_dX*instanceStruct.instanceVar_temp);
dxg1_dibl_op = (CF1_op*instanceStruct.instanceVar_temp);
d_dxg2_dibl_op_dX = (CF2_op*instanceStruct.d_instanceVar_temp_dX+d_CF2_op_dX*instanceStruct.instanceVar_temp);
dxg2_dibl_op = (CF2_op*instanceStruct.instanceVar_temp);
d_xg1_op_dX = (((((xg10_op-xedge_op)+dxg1_dibl_op)*d_sce1_op_dX+((d_xg10_op_dX-d_xedge_op_dX)+d_dxg1_dibl_op_dX)*sce1_op)+d_xedge_op_dX)+d_dxdsx_op_dX);
xg1_op = (((((xg10_op-xedge_op)+dxg1_dibl_op)*sce1_op)+xedge_op)+dxdsx_op);
d_xg2_op_dX = (((((xg2eff_op-xedge_op)+dxg2_dibl_op)*d_sce2_op_dX+((d_xg2eff_op_dX-d_xedge_op_dX)+d_dxg2_dibl_op_dX)*sce2_op)+d_xedge_op_dX)+d_dxdsx_op_dX);
xg2_op = (((((xg2eff_op-xedge_op)+dxg2_dibl_op)*sce2_op)+xedge_op)+dxdsx_op);
d_xg2x_op_dX = (d_xg1_op_dX+(instanceStruct.instanceVar_CIC2_i*(d_xg2_op_dX-d_xg1_op_dX)+instanceStruct.d_instanceVar_CIC2_i_dX*(xg2_op-xg1_op)));
xg2x_op = (xg1_op+(instanceStruct.instanceVar_CIC2_i*(xg2_op-xg1_op)));
d_k1_op_dX = ((sce1_op*d_k1_1D_QM_op_dX-k1_1D_QM_op*d_sce1_op_dX)/sce1_op/sce1_op);
k1_op = (k1_1D_QM_op/sce1_op);
d_k2_op_dX = ((sce2_op*d_k2_1D_QM_op_dX-k2_1D_QM_op*d_sce2_op_dX)/sce2_op/sce2_op);
k2_op = (k2_1D_QM_op/sce2_op);
d_A0_op_dX = (((CsiPrime_op*CsiPrime_op)*d_A0_Csisq_op_dX-A0_Csisq_op*(CsiPrime_op*d_CsiPrime_op_dX+d_CsiPrime_op_dX*CsiPrime_op))/(CsiPrime_op*CsiPrime_op)/(CsiPrime_op*CsiPrime_op));
A0_op = (A0_Csisq_op/(CsiPrime_op*CsiPrime_op));
d_exp_dxth_op_dX = (((1.0+k2_op)*d_k1_op_dX-(1.0+k1_op)*d_k2_op_dX)/(1.0+k2_op)/(1.0+k2_op));
exp_dxth_op = ((1.0+k1_op)/(1.0+k2_op));
{
double value_log_0 = log(exp_dxth_op);
double  deriv_log_0_d0 = (1.0/exp_dxth_op);
d_dxth_op_dX = deriv_log_0_d0*(d_exp_dxth_op_dX);
dxth_op = value_log_0;
}
if ((dxth_op>1.0e-8))
{
d_diff_min_op_dX = (((exp_dxth_op-1.0)*((2.0*dxth_op)*d_exp_dxth_op_dX+2.0*d_dxth_op_dX*(exp_dxth_op+1.0))-((2.0*dxth_op)*(exp_dxth_op+1.0))*d_exp_dxth_op_dX)/(exp_dxth_op-1.0)/(exp_dxth_op-1.0));
diff_min_op = (((2.0*dxth_op)*(exp_dxth_op+1.0))/(exp_dxth_op-1.0));
}
else
{
d_diff_min_op_dX = 2.0*d_dxth_op_dX;
diff_min_op = (2.0*(2.0+dxth_op));
}
d_r1_op_dX = (((1.0+k2_op)*((k1_op*d_k2_op_dX-k2_op*d_k1_op_dX)/k1_op/k1_op)-(k2_op/k1_op)*d_k2_op_dX)/(1.0+k2_op)/(1.0+k2_op));
r1_op = ((k2_op/k1_op)/(1.0+k2_op));
d_r2_op_dX = (((1.0+k1_op)*((k2_op*d_k1_op_dX-k1_op*d_k2_op_dX)/k2_op/k2_op)-(k1_op/k2_op)*d_k1_op_dX)/(1.0+k1_op)/(1.0+k1_op));
r2_op = ((k1_op/k2_op)/(1.0+k1_op));
{
double value_log_0 = log((((k1_op*(1.0+r1_op))*diff_min_op)/A0_op));
double  deriv_log_0_d0 = (1.0/(((k1_op*(1.0+r1_op))*diff_min_op)/A0_op));
d_x1sat_op_dX = deriv_log_0_d0*(((A0_op*((k1_op*(1.0+r1_op))*d_diff_min_op_dX+(k1_op*d_r1_op_dX+d_k1_op_dX*(1.0+r1_op))*diff_min_op)-((k1_op*(1.0+r1_op))*diff_min_op)*d_A0_op_dX)/A0_op/A0_op));
x1sat_op = (value_log_0+2.0);
}
{
double value_log_0 = log((((k2_op*(1.0+r2_op))*diff_min_op)/A0_op));
double  deriv_log_0_d0 = (1.0/(((k2_op*(1.0+r2_op))*diff_min_op)/A0_op));
d_x2sat_op_dX = deriv_log_0_d0*(((A0_op*((k2_op*(1.0+r2_op))*d_diff_min_op_dX+(k2_op*d_r2_op_dX+d_k2_op_dX*(1.0+r2_op))*diff_min_op)-((k2_op*(1.0+r2_op))*diff_min_op)*d_A0_op_dX)/A0_op/A0_op));
x2sat_op = (value_log_0+2.0);
}
d_xth1_op_dX = (((1.0+r1_op)*d_x1sat_op_dX+d_r1_op_dX*x1sat_op)-(xg2x_op*d_r1_op_dX+d_xg2x_op_dX*r1_op));
xth1_op = (((1.0+r1_op)*x1sat_op)-(xg2x_op*r1_op));
d_xth2_op_dX = (((1.0+(1.0/r2_op))*d_x2sat_op_dX+(-d_r2_op_dX/r2_op/r2_op)*x2sat_op)-((r2_op*d_xg2x_op_dX-xg2x_op*d_r2_op_dX)/r2_op/r2_op));
xth2_op = (((1.0+(1.0/r2_op))*x2sat_op)-(xg2x_op/r2_op));
{
double value_sqrt_0 = sqrt((((xth1_op-xth2_op)*(xth1_op-xth2_op))+38.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xg1th_op_dX = (((instanceStruct.instanceVar_CIC1_i*(0.5*((d_xth1_op_dX+d_xth2_op_dX)-deriv_sqrt_0_d0*(((xth1_op-xth2_op)*(d_xth1_op_dX-d_xth2_op_dX)+(d_xth1_op_dX-d_xth2_op_dX)*(xth1_op-xth2_op))))-d_xg2_dX)-((0.5*((xth1_op+xth2_op)-value_sqrt_0))-xg2)*instanceStruct.d_instanceVar_CIC1_i_dX)/instanceStruct.instanceVar_CIC1_i/instanceStruct.instanceVar_CIC1_i)+d_xg2_dX);
xg1th_op = ((((0.5*((xth1_op+xth2_op)-value_sqrt_0))-xg2)/instanceStruct.instanceVar_CIC1_i)+xg2);
}
d_Vdsat_dX = (instanceStruct.instanceVar_phit*d_xndssat_dX+instanceStruct.d_instanceVar_phit_dX*xndssat);
Vdsat = (instanceStruct.instanceVar_phit*xndssat);
if ((instanceStruct.instanceVar_sigVds<0))
{
}
else
{
}
if ((instanceStruct.instanceVar_sigVds<0.0))
{
}
else
{
}
if ((instanceStruct.instanceVar_sigVds<0.0))
{
d_qde_dX = ((((((d_Qs_dX-d_Qdse_dX)-d_Qgse_dX)-d_Qovs_dX)-d_Qssub_dX)-d_Qgsif_dX)-d_Qbsif_dX);
qde = ((((((Qs-Qdse)-Qgse)-Qovs)-Qssub)-Qgsif)-Qbsif);
}
else
{
d_qde_dX = ((((((d_Qd_dX+d_Qdse_dX)-d_Qgde_dX)-d_Qovd_dX)-d_Qdsub_dX)-d_Qgdif_dX)-d_Qbdif_dX);
qde = ((((((Qd+Qdse)-Qgde)-Qovd)-Qdsub)-Qgdif)-Qbdif);
}
d_qge_dX = (((((((d_Qg_dX+d_Qgse_dX)+d_Qgde_dX)+d_Qovs_dX)+d_Qovd_dX)+d_Qgbe_dX)+d_Qgsif_dX)+d_Qgdif_dX);
qge = (((((((Qg+Qgse)+Qgde)+Qovs)+Qovd)+Qgbe)+Qgsif)+Qgdif);
d_qbe_dX = (((((d_Qb_dX+d_Qssub_dX)+d_Qdsub_dX)-d_Qgbe_dX)+d_Qbsif_dX)+d_Qbdif_dX);
qbe = (((((Qb+Qssub)+Qdsub)-Qgbe)+Qbsif)+Qbdif);
if ((instanceStruct.instanceVar_sigVds<0.0))
{
}
else
{
}
if ((fabs(1.0)<1.0e-40))
{
}
else
{
}
if ((fabs(1.0)<1.0e-40))
{
}
else
{
}
if ((fabs(1.0)<1.0e-40))
{
}
else
{
}
if ((fabs(1.0)<1.0e-40))
{
}
else
{
}
}
// End block OPinfo
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(6+1);
dqdp.resize(6+1);
Findices.resize(6+1);
Qindices.resize(6+1);

std::vector <double> probeVars(10);
std::vector <double> d_staticContributions_dX(6+1);
std::vector <double> d_dynamicContributions_dX(6+1);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 6+1 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_VERSION=mod.VERSION;
modelStruct.d_modelPar_VERSION_dX=0.0;
modelStruct.modelPar_given_VERSION=mod.given("VERSION");
modelStruct.modelPar_QMC=mod.QMC;
modelStruct.d_modelPar_QMC_dX=0.0;
modelStruct.modelPar_given_QMC=mod.given("QMC");
modelStruct.modelPar_TR=mod.TR;
modelStruct.d_modelPar_TR_dX=0.0;
modelStruct.modelPar_given_TR=mod.given("TR");
modelStruct.modelPar_TMAX=mod.TMAX;
modelStruct.d_modelPar_TMAX_dX=0.0;
modelStruct.modelPar_given_TMAX=mod.given("TMAX");
modelStruct.modelPar_TOXE=mod.TOXE;
modelStruct.d_modelPar_TOXE_dX=0.0;
modelStruct.modelPar_given_TOXE=mod.given("TOXE");
modelStruct.modelPar_TSI=mod.TSI;
modelStruct.d_modelPar_TSI_dX=0.0;
modelStruct.modelPar_given_TSI=mod.given("TSI");
modelStruct.modelPar_XGE=mod.XGE;
modelStruct.d_modelPar_XGE_dX=0.0;
modelStruct.modelPar_given_XGE=mod.given("XGE");
modelStruct.modelPar_TBOX=mod.TBOX;
modelStruct.d_modelPar_TBOX_dX=0.0;
modelStruct.modelPar_given_TBOX=mod.given("TBOX");
modelStruct.modelPar_NCH=mod.NCH;
modelStruct.d_modelPar_NCH_dX=0.0;
modelStruct.modelPar_given_NCH=mod.given("NCH");
modelStruct.modelPar_NSUB=mod.NSUB;
modelStruct.d_modelPar_NSUB_dX=0.0;
modelStruct.modelPar_given_NSUB=mod.given("NSUB");
modelStruct.modelPar_CT=mod.CT;
modelStruct.d_modelPar_CT_dX=0.0;
modelStruct.modelPar_given_CT=mod.given("CT");
modelStruct.modelPar_TOXP=mod.TOXP;
modelStruct.d_modelPar_TOXP_dX=0.0;
modelStruct.modelPar_given_TOXP=mod.given("TOXP");
modelStruct.modelPar_NOV=mod.NOV;
modelStruct.d_modelPar_NOV_dX=0.0;
modelStruct.modelPar_given_NOV=mod.given("NOV");
modelStruct.modelPar_NOVD=mod.NOVD;
modelStruct.d_modelPar_NOVD_dX=0.0;
modelStruct.modelPar_given_NOVD=mod.given("NOVD");
modelStruct.modelPar_VFB=mod.VFB;
modelStruct.d_modelPar_VFB_dX=0.0;
modelStruct.modelPar_given_VFB=mod.given("VFB");
modelStruct.modelPar_VFBB=mod.VFBB;
modelStruct.d_modelPar_VFBB_dX=0.0;
modelStruct.modelPar_given_VFBB=mod.given("VFBB");
modelStruct.modelPar_STVFB=mod.STVFB;
modelStruct.d_modelPar_STVFB_dX=0.0;
modelStruct.modelPar_given_STVFB=mod.given("STVFB");
modelStruct.modelPar_CICF=mod.CICF;
modelStruct.d_modelPar_CICF_dX=0.0;
modelStruct.modelPar_given_CICF=mod.given("CICF");
modelStruct.modelPar_CIC=mod.CIC;
modelStruct.d_modelPar_CIC_dX=0.0;
modelStruct.modelPar_given_CIC=mod.given("CIC");
modelStruct.modelPar_PSCE=mod.PSCE;
modelStruct.d_modelPar_PSCE_dX=0.0;
modelStruct.modelPar_given_PSCE=mod.given("PSCE");
modelStruct.modelPar_PSCEB=mod.PSCEB;
modelStruct.d_modelPar_PSCEB_dX=0.0;
modelStruct.modelPar_given_PSCEB=mod.given("PSCEB");
modelStruct.modelPar_NSDDC=mod.NSDDC;
modelStruct.d_modelPar_NSDDC_dX=0.0;
modelStruct.modelPar_given_NSDDC=mod.given("NSDDC");
modelStruct.modelPar_PSCEDLB=mod.PSCEDLB;
modelStruct.d_modelPar_PSCEDLB_dX=0.0;
modelStruct.modelPar_given_PSCEDLB=mod.given("PSCEDLB");
modelStruct.modelPar_PNCE=mod.PNCE;
modelStruct.d_modelPar_PNCE_dX=0.0;
modelStruct.modelPar_given_PNCE=mod.given("PNCE");
modelStruct.modelPar_CF=mod.CF;
modelStruct.d_modelPar_CF_dX=0.0;
modelStruct.modelPar_given_CF=mod.given("CF");
modelStruct.modelPar_CFB=mod.CFB;
modelStruct.d_modelPar_CFB_dX=0.0;
modelStruct.modelPar_given_CFB=mod.given("CFB");
modelStruct.modelPar_STCF=mod.STCF;
modelStruct.d_modelPar_STCF_dX=0.0;
modelStruct.modelPar_given_STCF=mod.given("STCF");
modelStruct.modelPar_CFD=mod.CFD;
modelStruct.d_modelPar_CFD_dX=0.0;
modelStruct.modelPar_given_CFD=mod.given("CFD");
modelStruct.modelPar_CFDL=mod.CFDL;
modelStruct.d_modelPar_CFDL_dX=0.0;
modelStruct.modelPar_given_CFDL=mod.given("CFDL");
modelStruct.modelPar_CFDLB=mod.CFDLB;
modelStruct.d_modelPar_CFDLB_dX=0.0;
modelStruct.modelPar_given_CFDLB=mod.given("CFDLB");
modelStruct.modelPar_BETN=mod.BETN;
modelStruct.d_modelPar_BETN_dX=0.0;
modelStruct.modelPar_given_BETN=mod.given("BETN");
modelStruct.modelPar_BETNB=mod.BETNB;
modelStruct.d_modelPar_BETNB_dX=0.0;
modelStruct.modelPar_given_BETNB=mod.given("BETNB");
modelStruct.modelPar_STBET=mod.STBET;
modelStruct.d_modelPar_STBET_dX=0.0;
modelStruct.modelPar_given_STBET=mod.given("STBET");
modelStruct.modelPar_CS=mod.CS;
modelStruct.d_modelPar_CS_dX=0.0;
modelStruct.modelPar_given_CS=mod.given("CS");
modelStruct.modelPar_CSFI=mod.CSFI;
modelStruct.d_modelPar_CSFI_dX=0.0;
modelStruct.modelPar_given_CSFI=mod.given("CSFI");
modelStruct.modelPar_CSBI=mod.CSBI;
modelStruct.d_modelPar_CSBI_dX=0.0;
modelStruct.modelPar_given_CSBI=mod.given("CSBI");
modelStruct.modelPar_STCS=mod.STCS;
modelStruct.d_modelPar_STCS_dX=0.0;
modelStruct.modelPar_given_STCS=mod.given("STCS");
modelStruct.modelPar_THECS=mod.THECS;
modelStruct.d_modelPar_THECS_dX=0.0;
modelStruct.modelPar_given_THECS=mod.given("THECS");
modelStruct.modelPar_STTHECS=mod.STTHECS;
modelStruct.d_modelPar_STTHECS_dX=0.0;
modelStruct.modelPar_given_STTHECS=mod.given("STTHECS");
modelStruct.modelPar_CSTHR=mod.CSTHR;
modelStruct.d_modelPar_CSTHR_dX=0.0;
modelStruct.modelPar_given_CSTHR=mod.given("CSTHR");
modelStruct.modelPar_CSTHRB=mod.CSTHRB;
modelStruct.d_modelPar_CSTHRB_dX=0.0;
modelStruct.modelPar_given_CSTHRB=mod.given("CSTHRB");
modelStruct.modelPar_MUE=mod.MUE;
modelStruct.d_modelPar_MUE_dX=0.0;
modelStruct.modelPar_given_MUE=mod.given("MUE");
modelStruct.modelPar_STMUE=mod.STMUE;
modelStruct.d_modelPar_STMUE_dX=0.0;
modelStruct.modelPar_given_STMUE=mod.given("STMUE");
modelStruct.modelPar_THEMU=mod.THEMU;
modelStruct.d_modelPar_THEMU_dX=0.0;
modelStruct.modelPar_given_THEMU=mod.given("THEMU");
modelStruct.modelPar_STTHEMU=mod.STTHEMU;
modelStruct.d_modelPar_STTHEMU_dX=0.0;
modelStruct.modelPar_given_STTHEMU=mod.given("STTHEMU");
modelStruct.modelPar_XCOR=mod.XCOR;
modelStruct.d_modelPar_XCOR_dX=0.0;
modelStruct.modelPar_given_XCOR=mod.given("XCOR");
modelStruct.modelPar_XCORB=mod.XCORB;
modelStruct.d_modelPar_XCORB_dX=0.0;
modelStruct.modelPar_given_XCORB=mod.given("XCORB");
modelStruct.modelPar_STXCOR=mod.STXCOR;
modelStruct.d_modelPar_STXCOR_dX=0.0;
modelStruct.modelPar_given_STXCOR=mod.given("STXCOR");
modelStruct.modelPar_FETA=mod.FETA;
modelStruct.d_modelPar_FETA_dX=0.0;
modelStruct.modelPar_given_FETA=mod.given("FETA");
modelStruct.modelPar_RS=mod.RS;
modelStruct.d_modelPar_RS_dX=0.0;
modelStruct.modelPar_given_RS=mod.given("RS");
modelStruct.modelPar_RSIG=mod.RSIG;
modelStruct.d_modelPar_RSIG_dX=0.0;
modelStruct.modelPar_given_RSIG=mod.given("RSIG");
modelStruct.modelPar_STRS=mod.STRS;
modelStruct.d_modelPar_STRS_dX=0.0;
modelStruct.modelPar_given_STRS=mod.given("STRS");
modelStruct.modelPar_RSG=mod.RSG;
modelStruct.d_modelPar_RSG_dX=0.0;
modelStruct.modelPar_given_RSG=mod.given("RSG");
modelStruct.modelPar_THERSG=mod.THERSG;
modelStruct.d_modelPar_THERSG_dX=0.0;
modelStruct.modelPar_given_THERSG=mod.given("THERSG");
modelStruct.modelPar_RSB=mod.RSB;
modelStruct.d_modelPar_RSB_dX=0.0;
modelStruct.modelPar_given_RSB=mod.given("RSB");
modelStruct.modelPar_THESAT=mod.THESAT;
modelStruct.d_modelPar_THESAT_dX=0.0;
modelStruct.modelPar_given_THESAT=mod.given("THESAT");
modelStruct.modelPar_STTHESAT=mod.STTHESAT;
modelStruct.d_modelPar_STTHESAT_dX=0.0;
modelStruct.modelPar_given_STTHESAT=mod.given("STTHESAT");
modelStruct.modelPar_THESATG=mod.THESATG;
modelStruct.d_modelPar_THESATG_dX=0.0;
modelStruct.modelPar_given_THESATG=mod.given("THESATG");
modelStruct.modelPar_THESATB=mod.THESATB;
modelStruct.d_modelPar_THESATB_dX=0.0;
modelStruct.modelPar_given_THESATB=mod.given("THESATB");
modelStruct.modelPar_AX=mod.AX;
modelStruct.d_modelPar_AX_dX=0.0;
modelStruct.modelPar_given_AX=mod.given("AX");
modelStruct.modelPar_ALP=mod.ALP;
modelStruct.d_modelPar_ALP_dX=0.0;
modelStruct.modelPar_given_ALP=mod.given("ALP");
modelStruct.modelPar_ALP1=mod.ALP1;
modelStruct.d_modelPar_ALP1_dX=0.0;
modelStruct.modelPar_given_ALP1=mod.given("ALP1");
modelStruct.modelPar_ALPB=mod.ALPB;
modelStruct.d_modelPar_ALPB_dX=0.0;
modelStruct.modelPar_given_ALPB=mod.given("ALPB");
modelStruct.modelPar_VP=mod.VP;
modelStruct.d_modelPar_VP_dX=0.0;
modelStruct.modelPar_given_VP=mod.given("VP");
modelStruct.modelPar_VPG=mod.VPG;
modelStruct.d_modelPar_VPG_dX=0.0;
modelStruct.modelPar_given_VPG=mod.given("VPG");
modelStruct.modelPar_GCO=mod.GCO;
modelStruct.d_modelPar_GCO_dX=0.0;
modelStruct.modelPar_given_GCO=mod.given("GCO");
modelStruct.modelPar_IGINV=mod.IGINV;
modelStruct.d_modelPar_IGINV_dX=0.0;
modelStruct.modelPar_given_IGINV=mod.given("IGINV");
modelStruct.modelPar_IGOVINV=mod.IGOVINV;
modelStruct.d_modelPar_IGOVINV_dX=0.0;
modelStruct.modelPar_given_IGOVINV=mod.given("IGOVINV");
modelStruct.modelPar_IGOVINVD=mod.IGOVINVD;
modelStruct.d_modelPar_IGOVINVD_dX=0.0;
modelStruct.modelPar_given_IGOVINVD=mod.given("IGOVINVD");
modelStruct.modelPar_IGOVACC=mod.IGOVACC;
modelStruct.d_modelPar_IGOVACC_dX=0.0;
modelStruct.modelPar_given_IGOVACC=mod.given("IGOVACC");
modelStruct.modelPar_IGOVACCD=mod.IGOVACCD;
modelStruct.d_modelPar_IGOVACCD_dX=0.0;
modelStruct.modelPar_given_IGOVACCD=mod.given("IGOVACCD");
modelStruct.modelPar_STIG=mod.STIG;
modelStruct.d_modelPar_STIG_dX=0.0;
modelStruct.modelPar_given_STIG=mod.given("STIG");
modelStruct.modelPar_GC2CH=mod.GC2CH;
modelStruct.d_modelPar_GC2CH_dX=0.0;
modelStruct.modelPar_given_GC2CH=mod.given("GC2CH");
modelStruct.modelPar_GC3CH=mod.GC3CH;
modelStruct.d_modelPar_GC3CH_dX=0.0;
modelStruct.modelPar_given_GC3CH=mod.given("GC3CH");
modelStruct.modelPar_GC2OVINV=mod.GC2OVINV;
modelStruct.d_modelPar_GC2OVINV_dX=0.0;
modelStruct.modelPar_given_GC2OVINV=mod.given("GC2OVINV");
modelStruct.modelPar_GC3OVINV=mod.GC3OVINV;
modelStruct.d_modelPar_GC3OVINV_dX=0.0;
modelStruct.modelPar_given_GC3OVINV=mod.given("GC3OVINV");
modelStruct.modelPar_GC2OVACC=mod.GC2OVACC;
modelStruct.d_modelPar_GC2OVACC_dX=0.0;
modelStruct.modelPar_given_GC2OVACC=mod.given("GC2OVACC");
modelStruct.modelPar_GC3OVACC=mod.GC3OVACC;
modelStruct.d_modelPar_GC3OVACC_dX=0.0;
modelStruct.modelPar_given_GC3OVACC=mod.given("GC3OVACC");
modelStruct.modelPar_GCDOV=mod.GCDOV;
modelStruct.d_modelPar_GCDOV_dX=0.0;
modelStruct.modelPar_given_GCDOV=mod.given("GCDOV");
modelStruct.modelPar_GCVDOV=mod.GCVDOV;
modelStruct.d_modelPar_GCVDOV_dX=0.0;
modelStruct.modelPar_given_GCVDOV=mod.given("GCVDOV");
modelStruct.modelPar_CHIB=mod.CHIB;
modelStruct.d_modelPar_CHIB_dX=0.0;
modelStruct.modelPar_given_CHIB=mod.given("CHIB");
modelStruct.modelPar_NIGINV=mod.NIGINV;
modelStruct.d_modelPar_NIGINV_dX=0.0;
modelStruct.modelPar_given_NIGINV=mod.given("NIGINV");
modelStruct.modelPar_FNOVINV=mod.FNOVINV;
modelStruct.d_modelPar_FNOVINV_dX=0.0;
modelStruct.modelPar_given_FNOVINV=mod.given("FNOVINV");
modelStruct.modelPar_FNOVINVD=mod.FNOVINVD;
modelStruct.d_modelPar_FNOVINVD_dX=0.0;
modelStruct.modelPar_given_FNOVINVD=mod.given("FNOVINVD");
modelStruct.modelPar_GCOVINVFN=mod.GCOVINVFN;
modelStruct.d_modelPar_GCOVINVFN_dX=0.0;
modelStruct.modelPar_given_GCOVINVFN=mod.given("GCOVINVFN");
modelStruct.modelPar_STIGFN=mod.STIGFN;
modelStruct.d_modelPar_STIGFN_dX=0.0;
modelStruct.modelPar_given_STIGFN=mod.given("STIGFN");
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modelStruct.modelPar_AGIDLD=mod.AGIDLD;
modelStruct.d_modelPar_AGIDLD_dX=0.0;
modelStruct.modelPar_given_AGIDLD=mod.given("AGIDLD");
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modelStruct.modelPar_BGIDLD=mod.BGIDLD;
modelStruct.d_modelPar_BGIDLD_dX=0.0;
modelStruct.modelPar_given_BGIDLD=mod.given("BGIDLD");
modelStruct.modelPar_STBGIDL=mod.STBGIDL;
modelStruct.d_modelPar_STBGIDL_dX=0.0;
modelStruct.modelPar_given_STBGIDL=mod.given("STBGIDL");
modelStruct.modelPar_STBGIDLD=mod.STBGIDLD;
modelStruct.d_modelPar_STBGIDLD_dX=0.0;
modelStruct.modelPar_given_STBGIDLD=mod.given("STBGIDLD");
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modelStruct.modelPar_CGIDLD=mod.CGIDLD;
modelStruct.d_modelPar_CGIDLD_dX=0.0;
modelStruct.modelPar_given_CGIDLD=mod.given("CGIDLD");
modelStruct.modelPar_DGIDL=mod.DGIDL;
modelStruct.d_modelPar_DGIDL_dX=0.0;
modelStruct.modelPar_given_DGIDL=mod.given("DGIDL");
modelStruct.modelPar_DGIDLD=mod.DGIDLD;
modelStruct.d_modelPar_DGIDLD_dX=0.0;
modelStruct.modelPar_given_DGIDLD=mod.given("DGIDLD");
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modelStruct.modelPar_STA2=mod.STA2;
modelStruct.d_modelPar_STA2_dX=0.0;
modelStruct.modelPar_given_STA2=mod.given("STA2");
modelStruct.modelPar_A3=mod.A3;
modelStruct.d_modelPar_A3_dX=0.0;
modelStruct.modelPar_given_A3=mod.given("A3");
modelStruct.modelPar_AREAQ=mod.AREAQ;
modelStruct.d_modelPar_AREAQ_dX=0.0;
modelStruct.modelPar_given_AREAQ=mod.given("AREAQ");
modelStruct.modelPar_CGBOV=mod.CGBOV;
modelStruct.d_modelPar_CGBOV_dX=0.0;
modelStruct.modelPar_given_CGBOV=mod.given("CGBOV");
modelStruct.modelPar_NSDAC=mod.NSDAC;
modelStruct.d_modelPar_NSDAC_dX=0.0;
modelStruct.modelPar_given_NSDAC=mod.given("NSDAC");
modelStruct.modelPar_FIF=mod.FIF;
modelStruct.d_modelPar_FIF_dX=0.0;
modelStruct.modelPar_given_FIF=mod.given("FIF");
modelStruct.modelPar_FSCEAC=mod.FSCEAC;
modelStruct.d_modelPar_FSCEAC_dX=0.0;
modelStruct.modelPar_given_FSCEAC=mod.given("FSCEAC");
modelStruct.modelPar_COV=mod.COV;
modelStruct.d_modelPar_COV_dX=0.0;
modelStruct.modelPar_given_COV=mod.given("COV");
modelStruct.modelPar_COVD=mod.COVD;
modelStruct.d_modelPar_COVD_dX=0.0;
modelStruct.modelPar_given_COVD=mod.given("COVD");
modelStruct.modelPar_COVDL=mod.COVDL;
modelStruct.d_modelPar_COVDL_dX=0.0;
modelStruct.modelPar_given_COVDL=mod.given("COVDL");
modelStruct.modelPar_COVDLB=mod.COVDLB;
modelStruct.d_modelPar_COVDLB_dX=0.0;
modelStruct.modelPar_given_COVDLB=mod.given("COVDLB");
modelStruct.modelPar_DVFBOV=mod.DVFBOV;
modelStruct.d_modelPar_DVFBOV_dX=0.0;
modelStruct.modelPar_given_DVFBOV=mod.given("DVFBOV");
modelStruct.modelPar_CFR=mod.CFR;
modelStruct.d_modelPar_CFR_dX=0.0;
modelStruct.modelPar_given_CFR=mod.given("CFR");
modelStruct.modelPar_CFRD=mod.CFRD;
modelStruct.d_modelPar_CFRD_dX=0.0;
modelStruct.modelPar_given_CFRD=mod.given("CFRD");
modelStruct.modelPar_CSD=mod.CSD;
modelStruct.d_modelPar_CSD_dX=0.0;
modelStruct.modelPar_given_CSD=mod.given("CSD");
modelStruct.modelPar_CSDBP=mod.CSDBP;
modelStruct.d_modelPar_CSDBP_dX=0.0;
modelStruct.modelPar_given_CSDBP=mod.given("CSDBP");
modelStruct.modelPar_RTH=mod.RTH;
modelStruct.d_modelPar_RTH_dX=0.0;
modelStruct.modelPar_given_RTH=mod.given("RTH");
modelStruct.modelPar_STRTH=mod.STRTH;
modelStruct.d_modelPar_STRTH_dX=0.0;
modelStruct.modelPar_given_STRTH=mod.given("STRTH");
modelStruct.modelPar_CTH=mod.CTH;
modelStruct.d_modelPar_CTH_dX=0.0;
modelStruct.modelPar_given_CTH=mod.given("CTH");
modelStruct.modelPar_FNT=mod.FNT;
modelStruct.d_modelPar_FNT_dX=0.0;
modelStruct.modelPar_given_FNT=mod.given("FNT");
modelStruct.modelPar_FNTEXC=mod.FNTEXC;
modelStruct.d_modelPar_FNTEXC_dX=0.0;
modelStruct.modelPar_given_FNTEXC=mod.given("FNTEXC");
modelStruct.modelPar_NFA=mod.NFA;
modelStruct.d_modelPar_NFA_dX=0.0;
modelStruct.modelPar_given_NFA=mod.given("NFA");
modelStruct.modelPar_NFB=mod.NFB;
modelStruct.d_modelPar_NFB_dX=0.0;
modelStruct.modelPar_given_NFB=mod.given("NFB");
modelStruct.modelPar_NFC=mod.NFC;
modelStruct.d_modelPar_NFC_dX=0.0;
modelStruct.modelPar_given_NFC=mod.given("NFC");
modelStruct.modelPar_NFE=mod.NFE;
modelStruct.d_modelPar_NFE_dX=0.0;
modelStruct.modelPar_given_NFE=mod.given("NFE");
modelStruct.modelPar_NFEB=mod.NFEB;
modelStruct.d_modelPar_NFEB_dX=0.0;
modelStruct.modelPar_given_NFEB=mod.given("NFEB");
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modelStruct.modelPar_LVARO=mod.LVARO;
modelStruct.d_modelPar_LVARO_dX=0.0;
modelStruct.modelPar_given_LVARO=mod.given("LVARO");
modelStruct.modelPar_LVARL=mod.LVARL;
modelStruct.d_modelPar_LVARL_dX=0.0;
modelStruct.modelPar_given_LVARL=mod.given("LVARL");
modelStruct.modelPar_LVARW=mod.LVARW;
modelStruct.d_modelPar_LVARW_dX=0.0;
modelStruct.modelPar_given_LVARW=mod.given("LVARW");
modelStruct.modelPar_LAP=mod.LAP;
modelStruct.d_modelPar_LAP_dX=0.0;
modelStruct.modelPar_given_LAP=mod.given("LAP");
modelStruct.modelPar_WVARO=mod.WVARO;
modelStruct.d_modelPar_WVARO_dX=0.0;
modelStruct.modelPar_given_WVARO=mod.given("WVARO");
modelStruct.modelPar_WVARL=mod.WVARL;
modelStruct.d_modelPar_WVARL_dX=0.0;
modelStruct.modelPar_given_WVARL=mod.given("WVARL");
modelStruct.modelPar_WVARW=mod.WVARW;
modelStruct.d_modelPar_WVARW_dX=0.0;
modelStruct.modelPar_given_WVARW=mod.given("WVARW");
modelStruct.modelPar_WOT=mod.WOT;
modelStruct.d_modelPar_WOT_dX=0.0;
modelStruct.modelPar_given_WOT=mod.given("WOT");
modelStruct.modelPar_DLQ=mod.DLQ;
modelStruct.d_modelPar_DLQ_dX=0.0;
modelStruct.modelPar_given_DLQ=mod.given("DLQ");
modelStruct.modelPar_DWQ=mod.DWQ;
modelStruct.d_modelPar_DWQ_dX=0.0;
modelStruct.modelPar_given_DWQ=mod.given("DWQ");
modelStruct.modelPar_TOXEO=mod.TOXEO;
modelStruct.d_modelPar_TOXEO_dX=0.0;
modelStruct.modelPar_given_TOXEO=mod.given("TOXEO");
modelStruct.modelPar_TSIO=mod.TSIO;
modelStruct.d_modelPar_TSIO_dX=0.0;
modelStruct.modelPar_given_TSIO=mod.given("TSIO");
modelStruct.modelPar_XGEO=mod.XGEO;
modelStruct.d_modelPar_XGEO_dX=0.0;
modelStruct.modelPar_given_XGEO=mod.given("XGEO");
modelStruct.modelPar_TBOXO=mod.TBOXO;
modelStruct.d_modelPar_TBOXO_dX=0.0;
modelStruct.modelPar_given_TBOXO=mod.given("TBOXO");
modelStruct.modelPar_NCHO=mod.NCHO;
modelStruct.d_modelPar_NCHO_dX=0.0;
modelStruct.modelPar_given_NCHO=mod.given("NCHO");
modelStruct.modelPar_NSUBO=mod.NSUBO;
modelStruct.d_modelPar_NSUBO_dX=0.0;
modelStruct.modelPar_given_NSUBO=mod.given("NSUBO");
modelStruct.modelPar_CTO=mod.CTO;
modelStruct.d_modelPar_CTO_dX=0.0;
modelStruct.modelPar_given_CTO=mod.given("CTO");
modelStruct.modelPar_TOXPO=mod.TOXPO;
modelStruct.d_modelPar_TOXPO_dX=0.0;
modelStruct.modelPar_given_TOXPO=mod.given("TOXPO");
modelStruct.modelPar_NOVO=mod.NOVO;
modelStruct.d_modelPar_NOVO_dX=0.0;
modelStruct.modelPar_given_NOVO=mod.given("NOVO");
modelStruct.modelPar_NOVDO=mod.NOVDO;
modelStruct.d_modelPar_NOVDO_dX=0.0;
modelStruct.modelPar_given_NOVDO=mod.given("NOVDO");
modelStruct.modelPar_VFBO=mod.VFBO;
modelStruct.d_modelPar_VFBO_dX=0.0;
modelStruct.modelPar_given_VFBO=mod.given("VFBO");
modelStruct.modelPar_VFBL=mod.VFBL;
modelStruct.d_modelPar_VFBL_dX=0.0;
modelStruct.modelPar_given_VFBL=mod.given("VFBL");
modelStruct.modelPar_VFBLEXP=mod.VFBLEXP;
modelStruct.d_modelPar_VFBLEXP_dX=0.0;
modelStruct.modelPar_given_VFBLEXP=mod.given("VFBLEXP");
modelStruct.modelPar_VFBL2=mod.VFBL2;
modelStruct.d_modelPar_VFBL2_dX=0.0;
modelStruct.modelPar_given_VFBL2=mod.given("VFBL2");
modelStruct.modelPar_VFBLEXP2=mod.VFBLEXP2;
modelStruct.d_modelPar_VFBLEXP2_dX=0.0;
modelStruct.modelPar_given_VFBLEXP2=mod.given("VFBLEXP2");
modelStruct.modelPar_VFBW=mod.VFBW;
modelStruct.d_modelPar_VFBW_dX=0.0;
modelStruct.modelPar_given_VFBW=mod.given("VFBW");
modelStruct.modelPar_VFBLW=mod.VFBLW;
modelStruct.d_modelPar_VFBLW_dX=0.0;
modelStruct.modelPar_given_VFBLW=mod.given("VFBLW");
modelStruct.modelPar_VFBBO=mod.VFBBO;
modelStruct.d_modelPar_VFBBO_dX=0.0;
modelStruct.modelPar_given_VFBBO=mod.given("VFBBO");
modelStruct.modelPar_VFBLBO=mod.VFBLBO;
modelStruct.d_modelPar_VFBLBO_dX=0.0;
modelStruct.modelPar_given_VFBLBO=mod.given("VFBLBO");
modelStruct.modelPar_STVFBO=mod.STVFBO;
modelStruct.d_modelPar_STVFBO_dX=0.0;
modelStruct.modelPar_given_STVFBO=mod.given("STVFBO");
modelStruct.modelPar_STVFBL=mod.STVFBL;
modelStruct.d_modelPar_STVFBL_dX=0.0;
modelStruct.modelPar_given_STVFBL=mod.given("STVFBL");
modelStruct.modelPar_STVFBW=mod.STVFBW;
modelStruct.d_modelPar_STVFBW_dX=0.0;
modelStruct.modelPar_given_STVFBW=mod.given("STVFBW");
modelStruct.modelPar_STVFBLW=mod.STVFBLW;
modelStruct.d_modelPar_STVFBLW_dX=0.0;
modelStruct.modelPar_given_STVFBLW=mod.given("STVFBLW");
modelStruct.modelPar_CICFO=mod.CICFO;
modelStruct.d_modelPar_CICFO_dX=0.0;
modelStruct.modelPar_given_CICFO=mod.given("CICFO");
modelStruct.modelPar_CICO=mod.CICO;
modelStruct.d_modelPar_CICO_dX=0.0;
modelStruct.modelPar_given_CICO=mod.given("CICO");
modelStruct.modelPar_PSCEL=mod.PSCEL;
modelStruct.d_modelPar_PSCEL_dX=0.0;
modelStruct.modelPar_given_PSCEL=mod.given("PSCEL");
modelStruct.modelPar_PSCELEXP=mod.PSCELEXP;
modelStruct.d_modelPar_PSCELEXP_dX=0.0;
modelStruct.modelPar_given_PSCELEXP=mod.given("PSCELEXP");
modelStruct.modelPar_PSCEW=mod.PSCEW;
modelStruct.d_modelPar_PSCEW_dX=0.0;
modelStruct.modelPar_given_PSCEW=mod.given("PSCEW");
modelStruct.modelPar_PSCEBO=mod.PSCEBO;
modelStruct.d_modelPar_PSCEBO_dX=0.0;
modelStruct.modelPar_given_PSCEBO=mod.given("PSCEBO");
modelStruct.modelPar_NSDDCO=mod.NSDDCO;
modelStruct.d_modelPar_NSDDCO_dX=0.0;
modelStruct.modelPar_given_NSDDCO=mod.given("NSDDCO");
modelStruct.modelPar_PSCEDLBO=mod.PSCEDLBO;
modelStruct.d_modelPar_PSCEDLBO_dX=0.0;
modelStruct.modelPar_given_PSCEDLBO=mod.given("PSCEDLBO");
modelStruct.modelPar_PNCEW=mod.PNCEW;
modelStruct.d_modelPar_PNCEW_dX=0.0;
modelStruct.modelPar_given_PNCEW=mod.given("PNCEW");
modelStruct.modelPar_CFL=mod.CFL;
modelStruct.d_modelPar_CFL_dX=0.0;
modelStruct.modelPar_given_CFL=mod.given("CFL");
modelStruct.modelPar_CFLEXP=mod.CFLEXP;
modelStruct.d_modelPar_CFLEXP_dX=0.0;
modelStruct.modelPar_given_CFLEXP=mod.given("CFLEXP");
modelStruct.modelPar_CFW=mod.CFW;
modelStruct.d_modelPar_CFW_dX=0.0;
modelStruct.modelPar_given_CFW=mod.given("CFW");
modelStruct.modelPar_CFBO=mod.CFBO;
modelStruct.d_modelPar_CFBO_dX=0.0;
modelStruct.modelPar_given_CFBO=mod.given("CFBO");
modelStruct.modelPar_STCFL=mod.STCFL;
modelStruct.d_modelPar_STCFL_dX=0.0;
modelStruct.modelPar_given_STCFL=mod.given("STCFL");
modelStruct.modelPar_CFDO=mod.CFDO;
modelStruct.d_modelPar_CFDO_dX=0.0;
modelStruct.modelPar_given_CFDO=mod.given("CFDO");
modelStruct.modelPar_CFDLL=mod.CFDLL;
modelStruct.d_modelPar_CFDLL_dX=0.0;
modelStruct.modelPar_given_CFDLL=mod.given("CFDLL");
modelStruct.modelPar_CFDLW=mod.CFDLW;
modelStruct.d_modelPar_CFDLW_dX=0.0;
modelStruct.modelPar_given_CFDLW=mod.given("CFDLW");
modelStruct.modelPar_CFDLBO=mod.CFDLBO;
modelStruct.d_modelPar_CFDLBO_dX=0.0;
modelStruct.modelPar_given_CFDLBO=mod.given("CFDLBO");
modelStruct.modelPar_UO=mod.UO;
modelStruct.d_modelPar_UO_dX=0.0;
modelStruct.modelPar_given_UO=mod.given("UO");
modelStruct.modelPar_FBET1=mod.FBET1;
modelStruct.d_modelPar_FBET1_dX=0.0;
modelStruct.modelPar_given_FBET1=mod.given("FBET1");
modelStruct.modelPar_FBET1W=mod.FBET1W;
modelStruct.d_modelPar_FBET1W_dX=0.0;
modelStruct.modelPar_given_FBET1W=mod.given("FBET1W");
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modelStruct.modelPar_LP1W=mod.LP1W;
modelStruct.d_modelPar_LP1W_dX=0.0;
modelStruct.modelPar_given_LP1W=mod.given("LP1W");
modelStruct.modelPar_FBET2=mod.FBET2;
modelStruct.d_modelPar_FBET2_dX=0.0;
modelStruct.modelPar_given_FBET2=mod.given("FBET2");
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modelStruct.modelPar_BETW1=mod.BETW1;
modelStruct.d_modelPar_BETW1_dX=0.0;
modelStruct.modelPar_given_BETW1=mod.given("BETW1");
modelStruct.modelPar_BETW2=mod.BETW2;
modelStruct.d_modelPar_BETW2_dX=0.0;
modelStruct.modelPar_given_BETW2=mod.given("BETW2");
modelStruct.modelPar_WBET=mod.WBET;
modelStruct.d_modelPar_WBET_dX=0.0;
modelStruct.modelPar_given_WBET=mod.given("WBET");
modelStruct.modelPar_BETNBO=mod.BETNBO;
modelStruct.d_modelPar_BETNBO_dX=0.0;
modelStruct.modelPar_given_BETNBO=mod.given("BETNBO");
modelStruct.modelPar_STBETO=mod.STBETO;
modelStruct.d_modelPar_STBETO_dX=0.0;
modelStruct.modelPar_given_STBETO=mod.given("STBETO");
modelStruct.modelPar_STBETL=mod.STBETL;
modelStruct.d_modelPar_STBETL_dX=0.0;
modelStruct.modelPar_given_STBETL=mod.given("STBETL");
modelStruct.modelPar_STBETW=mod.STBETW;
modelStruct.d_modelPar_STBETW_dX=0.0;
modelStruct.modelPar_given_STBETW=mod.given("STBETW");
modelStruct.modelPar_STBETLW=mod.STBETLW;
modelStruct.d_modelPar_STBETLW_dX=0.0;
modelStruct.modelPar_given_STBETLW=mod.given("STBETLW");
modelStruct.modelPar_CSO=mod.CSO;
modelStruct.d_modelPar_CSO_dX=0.0;
modelStruct.modelPar_given_CSO=mod.given("CSO");
modelStruct.modelPar_CSL=mod.CSL;
modelStruct.d_modelPar_CSL_dX=0.0;
modelStruct.modelPar_given_CSL=mod.given("CSL");
modelStruct.modelPar_CSLEXP=mod.CSLEXP;
modelStruct.d_modelPar_CSLEXP_dX=0.0;
modelStruct.modelPar_given_CSLEXP=mod.given("CSLEXP");
modelStruct.modelPar_CSW=mod.CSW;
modelStruct.d_modelPar_CSW_dX=0.0;
modelStruct.modelPar_given_CSW=mod.given("CSW");
modelStruct.modelPar_CSLW=mod.CSLW;
modelStruct.d_modelPar_CSLW_dX=0.0;
modelStruct.modelPar_given_CSLW=mod.given("CSLW");
modelStruct.modelPar_CSFIO=mod.CSFIO;
modelStruct.d_modelPar_CSFIO_dX=0.0;
modelStruct.modelPar_given_CSFIO=mod.given("CSFIO");
modelStruct.modelPar_CSBIO=mod.CSBIO;
modelStruct.d_modelPar_CSBIO_dX=0.0;
modelStruct.modelPar_given_CSBIO=mod.given("CSBIO");
modelStruct.modelPar_STCSO=mod.STCSO;
modelStruct.d_modelPar_STCSO_dX=0.0;
modelStruct.modelPar_given_STCSO=mod.given("STCSO");
modelStruct.modelPar_STCSL=mod.STCSL;
modelStruct.d_modelPar_STCSL_dX=0.0;
modelStruct.modelPar_given_STCSL=mod.given("STCSL");
modelStruct.modelPar_STCSW=mod.STCSW;
modelStruct.d_modelPar_STCSW_dX=0.0;
modelStruct.modelPar_given_STCSW=mod.given("STCSW");
modelStruct.modelPar_STCSLW=mod.STCSLW;
modelStruct.d_modelPar_STCSLW_dX=0.0;
modelStruct.modelPar_given_STCSLW=mod.given("STCSLW");
modelStruct.modelPar_THECSO=mod.THECSO;
modelStruct.d_modelPar_THECSO_dX=0.0;
modelStruct.modelPar_given_THECSO=mod.given("THECSO");
modelStruct.modelPar_STTHECSO=mod.STTHECSO;
modelStruct.d_modelPar_STTHECSO_dX=0.0;
modelStruct.modelPar_given_STTHECSO=mod.given("STTHECSO");
modelStruct.modelPar_CSTHRO=mod.CSTHRO;
modelStruct.d_modelPar_CSTHRO_dX=0.0;
modelStruct.modelPar_given_CSTHRO=mod.given("CSTHRO");
modelStruct.modelPar_CSTHRBO=mod.CSTHRBO;
modelStruct.d_modelPar_CSTHRBO_dX=0.0;
modelStruct.modelPar_given_CSTHRBO=mod.given("CSTHRBO");
modelStruct.modelPar_MUEO=mod.MUEO;
modelStruct.d_modelPar_MUEO_dX=0.0;
modelStruct.modelPar_given_MUEO=mod.given("MUEO");
modelStruct.modelPar_STMUEO=mod.STMUEO;
modelStruct.d_modelPar_STMUEO_dX=0.0;
modelStruct.modelPar_given_STMUEO=mod.given("STMUEO");
modelStruct.modelPar_THEMUO=mod.THEMUO;
modelStruct.d_modelPar_THEMUO_dX=0.0;
modelStruct.modelPar_given_THEMUO=mod.given("THEMUO");
modelStruct.modelPar_STTHEMUO=mod.STTHEMUO;
modelStruct.d_modelPar_STTHEMUO_dX=0.0;
modelStruct.modelPar_given_STTHEMUO=mod.given("STTHEMUO");
modelStruct.modelPar_XCORO=mod.XCORO;
modelStruct.d_modelPar_XCORO_dX=0.0;
modelStruct.modelPar_given_XCORO=mod.given("XCORO");
modelStruct.modelPar_XCORL=mod.XCORL;
modelStruct.d_modelPar_XCORL_dX=0.0;
modelStruct.modelPar_given_XCORL=mod.given("XCORL");
modelStruct.modelPar_XCORLEXP=mod.XCORLEXP;
modelStruct.d_modelPar_XCORLEXP_dX=0.0;
modelStruct.modelPar_given_XCORLEXP=mod.given("XCORLEXP");
modelStruct.modelPar_XCORW=mod.XCORW;
modelStruct.d_modelPar_XCORW_dX=0.0;
modelStruct.modelPar_given_XCORW=mod.given("XCORW");
modelStruct.modelPar_XCORLW=mod.XCORLW;
modelStruct.d_modelPar_XCORLW_dX=0.0;
modelStruct.modelPar_given_XCORLW=mod.given("XCORLW");
modelStruct.modelPar_XCORBO=mod.XCORBO;
modelStruct.d_modelPar_XCORBO_dX=0.0;
modelStruct.modelPar_given_XCORBO=mod.given("XCORBO");
modelStruct.modelPar_STXCORO=mod.STXCORO;
modelStruct.d_modelPar_STXCORO_dX=0.0;
modelStruct.modelPar_given_STXCORO=mod.given("STXCORO");
modelStruct.modelPar_FETAO=mod.FETAO;
modelStruct.d_modelPar_FETAO_dX=0.0;
modelStruct.modelPar_given_FETAO=mod.given("FETAO");
modelStruct.modelPar_RSW1=mod.RSW1;
modelStruct.d_modelPar_RSW1_dX=0.0;
modelStruct.modelPar_given_RSW1=mod.given("RSW1");
modelStruct.modelPar_RSW2=mod.RSW2;
modelStruct.d_modelPar_RSW2_dX=0.0;
modelStruct.modelPar_given_RSW2=mod.given("RSW2");
modelStruct.modelPar_RSIGO=mod.RSIGO;
modelStruct.d_modelPar_RSIGO_dX=0.0;
modelStruct.modelPar_given_RSIGO=mod.given("RSIGO");
modelStruct.modelPar_STRSO=mod.STRSO;
modelStruct.d_modelPar_STRSO_dX=0.0;
modelStruct.modelPar_given_STRSO=mod.given("STRSO");
modelStruct.modelPar_RSGO=mod.RSGO;
modelStruct.d_modelPar_RSGO_dX=0.0;
modelStruct.modelPar_given_RSGO=mod.given("RSGO");
modelStruct.modelPar_THERSGO=mod.THERSGO;
modelStruct.d_modelPar_THERSGO_dX=0.0;
modelStruct.modelPar_given_THERSGO=mod.given("THERSGO");
modelStruct.modelPar_RSBO=mod.RSBO;
modelStruct.d_modelPar_RSBO_dX=0.0;
modelStruct.modelPar_given_RSBO=mod.given("RSBO");
modelStruct.modelPar_THESATO=mod.THESATO;
modelStruct.d_modelPar_THESATO_dX=0.0;
modelStruct.modelPar_given_THESATO=mod.given("THESATO");
modelStruct.modelPar_THESATL=mod.THESATL;
modelStruct.d_modelPar_THESATL_dX=0.0;
modelStruct.modelPar_given_THESATL=mod.given("THESATL");
modelStruct.modelPar_THESATLEXP=mod.THESATLEXP;
modelStruct.d_modelPar_THESATLEXP_dX=0.0;
modelStruct.modelPar_given_THESATLEXP=mod.given("THESATLEXP");
modelStruct.modelPar_THESATW=mod.THESATW;
modelStruct.d_modelPar_THESATW_dX=0.0;
modelStruct.modelPar_given_THESATW=mod.given("THESATW");
modelStruct.modelPar_THESATLW=mod.THESATLW;
modelStruct.d_modelPar_THESATLW_dX=0.0;
modelStruct.modelPar_given_THESATLW=mod.given("THESATLW");
modelStruct.modelPar_STTHESATO=mod.STTHESATO;
modelStruct.d_modelPar_STTHESATO_dX=0.0;
modelStruct.modelPar_given_STTHESATO=mod.given("STTHESATO");
modelStruct.modelPar_STTHESATL=mod.STTHESATL;
modelStruct.d_modelPar_STTHESATL_dX=0.0;
modelStruct.modelPar_given_STTHESATL=mod.given("STTHESATL");
modelStruct.modelPar_STTHESATW=mod.STTHESATW;
modelStruct.d_modelPar_STTHESATW_dX=0.0;
modelStruct.modelPar_given_STTHESATW=mod.given("STTHESATW");
modelStruct.modelPar_STTHESATLW=mod.STTHESATLW;
modelStruct.d_modelPar_STTHESATLW_dX=0.0;
modelStruct.modelPar_given_STTHESATLW=mod.given("STTHESATLW");
modelStruct.modelPar_THESATGO=mod.THESATGO;
modelStruct.d_modelPar_THESATGO_dX=0.0;
modelStruct.modelPar_given_THESATGO=mod.given("THESATGO");
modelStruct.modelPar_THESATBO=mod.THESATBO;
modelStruct.d_modelPar_THESATBO_dX=0.0;
modelStruct.modelPar_given_THESATBO=mod.given("THESATBO");
modelStruct.modelPar_AXO=mod.AXO;
modelStruct.d_modelPar_AXO_dX=0.0;
modelStruct.modelPar_given_AXO=mod.given("AXO");
modelStruct.modelPar_AXL=mod.AXL;
modelStruct.d_modelPar_AXL_dX=0.0;
modelStruct.modelPar_given_AXL=mod.given("AXL");
modelStruct.modelPar_AXLEXP=mod.AXLEXP;
modelStruct.d_modelPar_AXLEXP_dX=0.0;
modelStruct.modelPar_given_AXLEXP=mod.given("AXLEXP");
modelStruct.modelPar_AXL2=mod.AXL2;
modelStruct.d_modelPar_AXL2_dX=0.0;
modelStruct.modelPar_given_AXL2=mod.given("AXL2");
modelStruct.modelPar_AXLEXP2=mod.AXLEXP2;
modelStruct.d_modelPar_AXLEXP2_dX=0.0;
modelStruct.modelPar_given_AXLEXP2=mod.given("AXLEXP2");
modelStruct.modelPar_ALPL1=mod.ALPL1;
modelStruct.d_modelPar_ALPL1_dX=0.0;
modelStruct.modelPar_given_ALPL1=mod.given("ALPL1");
modelStruct.modelPar_ALPLEXP=mod.ALPLEXP;
modelStruct.d_modelPar_ALPLEXP_dX=0.0;
modelStruct.modelPar_given_ALPLEXP=mod.given("ALPLEXP");
modelStruct.modelPar_ALPL2=mod.ALPL2;
modelStruct.d_modelPar_ALPL2_dX=0.0;
modelStruct.modelPar_given_ALPL2=mod.given("ALPL2");
modelStruct.modelPar_ALPLEXP2=mod.ALPLEXP2;
modelStruct.d_modelPar_ALPLEXP2_dX=0.0;
modelStruct.modelPar_given_ALPLEXP2=mod.given("ALPLEXP2");
modelStruct.modelPar_ALPW=mod.ALPW;
modelStruct.d_modelPar_ALPW_dX=0.0;
modelStruct.modelPar_given_ALPW=mod.given("ALPW");
modelStruct.modelPar_ALP1L1=mod.ALP1L1;
modelStruct.d_modelPar_ALP1L1_dX=0.0;
modelStruct.modelPar_given_ALP1L1=mod.given("ALP1L1");
modelStruct.modelPar_ALP1LEXP=mod.ALP1LEXP;
modelStruct.d_modelPar_ALP1LEXP_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
modelStruct.modelPar_ALP1L2=mod.ALP1L2;
modelStruct.d_modelPar_ALP1L2_dX=0.0;
modelStruct.modelPar_given_ALP1L2=mod.given("ALP1L2");
modelStruct.modelPar_ALP1LEXP2=mod.ALP1LEXP2;
modelStruct.d_modelPar_ALP1LEXP2_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP2=mod.given("ALP1LEXP2");
modelStruct.modelPar_ALP1W=mod.ALP1W;
modelStruct.d_modelPar_ALP1W_dX=0.0;
modelStruct.modelPar_given_ALP1W=mod.given("ALP1W");
modelStruct.modelPar_ALPBO=mod.ALPBO;
modelStruct.d_modelPar_ALPBO_dX=0.0;
modelStruct.modelPar_given_ALPBO=mod.given("ALPBO");
modelStruct.modelPar_VPO=mod.VPO;
modelStruct.d_modelPar_VPO_dX=0.0;
modelStruct.modelPar_given_VPO=mod.given("VPO");
modelStruct.modelPar_VPGO=mod.VPGO;
modelStruct.d_modelPar_VPGO_dX=0.0;
modelStruct.modelPar_given_VPGO=mod.given("VPGO");
modelStruct.modelPar_GCOO=mod.GCOO;
modelStruct.d_modelPar_GCOO_dX=0.0;
modelStruct.modelPar_given_GCOO=mod.given("GCOO");
modelStruct.modelPar_IGINVLW=mod.IGINVLW;
modelStruct.d_modelPar_IGINVLW_dX=0.0;
modelStruct.modelPar_given_IGINVLW=mod.given("IGINVLW");
modelStruct.modelPar_IGOVINVW=mod.IGOVINVW;
modelStruct.d_modelPar_IGOVINVW_dX=0.0;
modelStruct.modelPar_given_IGOVINVW=mod.given("IGOVINVW");
modelStruct.modelPar_IGOVINVDW=mod.IGOVINVDW;
modelStruct.d_modelPar_IGOVINVDW_dX=0.0;
modelStruct.modelPar_given_IGOVINVDW=mod.given("IGOVINVDW");
modelStruct.modelPar_IGOVACCW=mod.IGOVACCW;
modelStruct.d_modelPar_IGOVACCW_dX=0.0;
modelStruct.modelPar_given_IGOVACCW=mod.given("IGOVACCW");
modelStruct.modelPar_IGOVACCDW=mod.IGOVACCDW;
modelStruct.d_modelPar_IGOVACCDW_dX=0.0;
modelStruct.modelPar_given_IGOVACCDW=mod.given("IGOVACCDW");
modelStruct.modelPar_STIGO=mod.STIGO;
modelStruct.d_modelPar_STIGO_dX=0.0;
modelStruct.modelPar_given_STIGO=mod.given("STIGO");
modelStruct.modelPar_GC2CHO=mod.GC2CHO;
modelStruct.d_modelPar_GC2CHO_dX=0.0;
modelStruct.modelPar_given_GC2CHO=mod.given("GC2CHO");
modelStruct.modelPar_GC3CHO=mod.GC3CHO;
modelStruct.d_modelPar_GC3CHO_dX=0.0;
modelStruct.modelPar_given_GC3CHO=mod.given("GC3CHO");
modelStruct.modelPar_GC2OVINVO=mod.GC2OVINVO;
modelStruct.d_modelPar_GC2OVINVO_dX=0.0;
modelStruct.modelPar_given_GC2OVINVO=mod.given("GC2OVINVO");
modelStruct.modelPar_GC3OVINVO=mod.GC3OVINVO;
modelStruct.d_modelPar_GC3OVINVO_dX=0.0;
modelStruct.modelPar_given_GC3OVINVO=mod.given("GC3OVINVO");
modelStruct.modelPar_GC2OVACCO=mod.GC2OVACCO;
modelStruct.d_modelPar_GC2OVACCO_dX=0.0;
modelStruct.modelPar_given_GC2OVACCO=mod.given("GC2OVACCO");
modelStruct.modelPar_GC3OVACCO=mod.GC3OVACCO;
modelStruct.d_modelPar_GC3OVACCO_dX=0.0;
modelStruct.modelPar_given_GC3OVACCO=mod.given("GC3OVACCO");
modelStruct.modelPar_GCDOVL=mod.GCDOVL;
modelStruct.d_modelPar_GCDOVL_dX=0.0;
modelStruct.modelPar_given_GCDOVL=mod.given("GCDOVL");
modelStruct.modelPar_GCVDOVO=mod.GCVDOVO;
modelStruct.d_modelPar_GCVDOVO_dX=0.0;
modelStruct.modelPar_given_GCVDOVO=mod.given("GCVDOVO");
modelStruct.modelPar_CHIBO=mod.CHIBO;
modelStruct.d_modelPar_CHIBO_dX=0.0;
modelStruct.modelPar_given_CHIBO=mod.given("CHIBO");
modelStruct.modelPar_NIGINVO=mod.NIGINVO;
modelStruct.d_modelPar_NIGINVO_dX=0.0;
modelStruct.modelPar_given_NIGINVO=mod.given("NIGINVO");
modelStruct.modelPar_FNOVINVW=mod.FNOVINVW;
modelStruct.d_modelPar_FNOVINVW_dX=0.0;
modelStruct.modelPar_given_FNOVINVW=mod.given("FNOVINVW");
modelStruct.modelPar_FNOVINVDW=mod.FNOVINVDW;
modelStruct.d_modelPar_FNOVINVDW_dX=0.0;
modelStruct.modelPar_given_FNOVINVDW=mod.given("FNOVINVDW");
modelStruct.modelPar_GCOVINVFNO=mod.GCOVINVFNO;
modelStruct.d_modelPar_GCOVINVFNO_dX=0.0;
modelStruct.modelPar_given_GCOVINVFNO=mod.given("GCOVINVFNO");
modelStruct.modelPar_STIGFNO=mod.STIGFNO;
modelStruct.d_modelPar_STIGFNO_dX=0.0;
modelStruct.modelPar_given_STIGFNO=mod.given("STIGFNO");
modelStruct.modelPar_AGIDLO=mod.AGIDLO;
modelStruct.d_modelPar_AGIDLO_dX=0.0;
modelStruct.modelPar_given_AGIDLO=mod.given("AGIDLO");
modelStruct.modelPar_AGIDLDO=mod.AGIDLDO;
modelStruct.d_modelPar_AGIDLDO_dX=0.0;
modelStruct.modelPar_given_AGIDLDO=mod.given("AGIDLDO");
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modelStruct.modelPar_AGIDLDW=mod.AGIDLDW;
modelStruct.d_modelPar_AGIDLDW_dX=0.0;
modelStruct.modelPar_given_AGIDLDW=mod.given("AGIDLDW");
modelStruct.modelPar_BGIDLO=mod.BGIDLO;
modelStruct.d_modelPar_BGIDLO_dX=0.0;
modelStruct.modelPar_given_BGIDLO=mod.given("BGIDLO");
modelStruct.modelPar_BGIDLDO=mod.BGIDLDO;
modelStruct.d_modelPar_BGIDLDO_dX=0.0;
modelStruct.modelPar_given_BGIDLDO=mod.given("BGIDLDO");
modelStruct.modelPar_STBGIDLO=mod.STBGIDLO;
modelStruct.d_modelPar_STBGIDLO_dX=0.0;
modelStruct.modelPar_given_STBGIDLO=mod.given("STBGIDLO");
modelStruct.modelPar_STBGIDLDO=mod.STBGIDLDO;
modelStruct.d_modelPar_STBGIDLDO_dX=0.0;
modelStruct.modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
modelStruct.modelPar_CGIDLO=mod.CGIDLO;
modelStruct.d_modelPar_CGIDLO_dX=0.0;
modelStruct.modelPar_given_CGIDLO=mod.given("CGIDLO");
modelStruct.modelPar_CGIDLDO=mod.CGIDLDO;
modelStruct.d_modelPar_CGIDLDO_dX=0.0;
modelStruct.modelPar_given_CGIDLDO=mod.given("CGIDLDO");
modelStruct.modelPar_DGIDLO=mod.DGIDLO;
modelStruct.d_modelPar_DGIDLO_dX=0.0;
modelStruct.modelPar_given_DGIDLO=mod.given("DGIDLO");
modelStruct.modelPar_DGIDLDO=mod.DGIDLDO;
modelStruct.d_modelPar_DGIDLDO_dX=0.0;
modelStruct.modelPar_given_DGIDLDO=mod.given("DGIDLDO");
modelStruct.modelPar_DGIDLL=mod.DGIDLL;
modelStruct.d_modelPar_DGIDLL_dX=0.0;
modelStruct.modelPar_given_DGIDLL=mod.given("DGIDLL");
modelStruct.modelPar_DGIDLDL=mod.DGIDLDL;
modelStruct.d_modelPar_DGIDLDL_dX=0.0;
modelStruct.modelPar_given_DGIDLDL=mod.given("DGIDLDL");
modelStruct.modelPar_A1O=mod.A1O;
modelStruct.d_modelPar_A1O_dX=0.0;
modelStruct.modelPar_given_A1O=mod.given("A1O");
modelStruct.modelPar_A1L=mod.A1L;
modelStruct.d_modelPar_A1L_dX=0.0;
modelStruct.modelPar_given_A1L=mod.given("A1L");
modelStruct.modelPar_A1W=mod.A1W;
modelStruct.d_modelPar_A1W_dX=0.0;
modelStruct.modelPar_given_A1W=mod.given("A1W");
modelStruct.modelPar_A2O=mod.A2O;
modelStruct.d_modelPar_A2O_dX=0.0;
modelStruct.modelPar_given_A2O=mod.given("A2O");
modelStruct.modelPar_STA2O=mod.STA2O;
modelStruct.d_modelPar_STA2O_dX=0.0;
modelStruct.modelPar_given_STA2O=mod.given("STA2O");
modelStruct.modelPar_A3O=mod.A3O;
modelStruct.d_modelPar_A3O_dX=0.0;
modelStruct.modelPar_given_A3O=mod.given("A3O");
modelStruct.modelPar_A3L=mod.A3L;
modelStruct.d_modelPar_A3L_dX=0.0;
modelStruct.modelPar_given_A3L=mod.given("A3L");
modelStruct.modelPar_A3W=mod.A3W;
modelStruct.d_modelPar_A3W_dX=0.0;
modelStruct.modelPar_given_A3W=mod.given("A3W");
modelStruct.modelPar_CGBOVO=mod.CGBOVO;
modelStruct.d_modelPar_CGBOVO_dX=0.0;
modelStruct.modelPar_given_CGBOVO=mod.given("CGBOVO");
modelStruct.modelPar_CGBOVL=mod.CGBOVL;
modelStruct.d_modelPar_CGBOVL_dX=0.0;
modelStruct.modelPar_given_CGBOVL=mod.given("CGBOVL");
modelStruct.modelPar_NSDACO=mod.NSDACO;
modelStruct.d_modelPar_NSDACO_dX=0.0;
modelStruct.modelPar_given_NSDACO=mod.given("NSDACO");
modelStruct.modelPar_FIFW=mod.FIFW;
modelStruct.d_modelPar_FIFW_dX=0.0;
modelStruct.modelPar_given_FIFW=mod.given("FIFW");
modelStruct.modelPar_FSCEACO=mod.FSCEACO;
modelStruct.d_modelPar_FSCEACO_dX=0.0;
modelStruct.modelPar_given_FSCEACO=mod.given("FSCEACO");
modelStruct.modelPar_LOVO=mod.LOVO;
modelStruct.d_modelPar_LOVO_dX=0.0;
modelStruct.modelPar_given_LOVO=mod.given("LOVO");
modelStruct.modelPar_LOVDO=mod.LOVDO;
modelStruct.d_modelPar_LOVDO_dX=0.0;
modelStruct.modelPar_given_LOVDO=mod.given("LOVDO");
modelStruct.modelPar_COVDLO=mod.COVDLO;
modelStruct.d_modelPar_COVDLO_dX=0.0;
modelStruct.modelPar_given_COVDLO=mod.given("COVDLO");
modelStruct.modelPar_COVDLW=mod.COVDLW;
modelStruct.d_modelPar_COVDLW_dX=0.0;
modelStruct.modelPar_given_COVDLW=mod.given("COVDLW");
modelStruct.modelPar_COVDLBO=mod.COVDLBO;
modelStruct.d_modelPar_COVDLBO_dX=0.0;
modelStruct.modelPar_given_COVDLBO=mod.given("COVDLBO");
modelStruct.modelPar_DVFBOVO=mod.DVFBOVO;
modelStruct.d_modelPar_DVFBOVO_dX=0.0;
modelStruct.modelPar_given_DVFBOVO=mod.given("DVFBOVO");
modelStruct.modelPar_CFRO=mod.CFRO;
modelStruct.d_modelPar_CFRO_dX=0.0;
modelStruct.modelPar_given_CFRO=mod.given("CFRO");
modelStruct.modelPar_CFRDO=mod.CFRDO;
modelStruct.d_modelPar_CFRDO_dX=0.0;
modelStruct.modelPar_given_CFRDO=mod.given("CFRDO");
modelStruct.modelPar_CFRW=mod.CFRW;
modelStruct.d_modelPar_CFRW_dX=0.0;
modelStruct.modelPar_given_CFRW=mod.given("CFRW");
modelStruct.modelPar_CFRDW=mod.CFRDW;
modelStruct.d_modelPar_CFRDW_dX=0.0;
modelStruct.modelPar_given_CFRDW=mod.given("CFRDW");
modelStruct.modelPar_CSDO=mod.CSDO;
modelStruct.d_modelPar_CSDO_dX=0.0;
modelStruct.modelPar_given_CSDO=mod.given("CSDO");
modelStruct.modelPar_CSDBPO=mod.CSDBPO;
modelStruct.d_modelPar_CSDBPO_dX=0.0;
modelStruct.modelPar_given_CSDBPO=mod.given("CSDBPO");
modelStruct.modelPar_RTHO=mod.RTHO;
modelStruct.d_modelPar_RTHO_dX=0.0;
modelStruct.modelPar_given_RTHO=mod.given("RTHO");
modelStruct.modelPar_RTHL=mod.RTHL;
modelStruct.d_modelPar_RTHL_dX=0.0;
modelStruct.modelPar_given_RTHL=mod.given("RTHL");
modelStruct.modelPar_RTHW=mod.RTHW;
modelStruct.d_modelPar_RTHW_dX=0.0;
modelStruct.modelPar_given_RTHW=mod.given("RTHW");
modelStruct.modelPar_RTHLW=mod.RTHLW;
modelStruct.d_modelPar_RTHLW_dX=0.0;
modelStruct.modelPar_given_RTHLW=mod.given("RTHLW");
modelStruct.modelPar_STRTHO=mod.STRTHO;
modelStruct.d_modelPar_STRTHO_dX=0.0;
modelStruct.modelPar_given_STRTHO=mod.given("STRTHO");
modelStruct.modelPar_CTHO=mod.CTHO;
modelStruct.d_modelPar_CTHO_dX=0.0;
modelStruct.modelPar_given_CTHO=mod.given("CTHO");
modelStruct.modelPar_LAMBTHO=mod.LAMBTHO;
modelStruct.d_modelPar_LAMBTHO_dX=0.0;
modelStruct.modelPar_given_LAMBTHO=mod.given("LAMBTHO");
modelStruct.modelPar_FTHO=mod.FTHO;
modelStruct.d_modelPar_FTHO_dX=0.0;
modelStruct.modelPar_given_FTHO=mod.given("FTHO");
modelStruct.modelPar_FNTO=mod.FNTO;
modelStruct.d_modelPar_FNTO_dX=0.0;
modelStruct.modelPar_given_FNTO=mod.given("FNTO");
modelStruct.modelPar_FNTEXCL=mod.FNTEXCL;
modelStruct.d_modelPar_FNTEXCL_dX=0.0;
modelStruct.modelPar_given_FNTEXCL=mod.given("FNTEXCL");
modelStruct.modelPar_FNTEXCLEXP=mod.FNTEXCLEXP;
modelStruct.d_modelPar_FNTEXCLEXP_dX=0.0;
modelStruct.modelPar_given_FNTEXCLEXP=mod.given("FNTEXCLEXP");
modelStruct.modelPar_NFALW=mod.NFALW;
modelStruct.d_modelPar_NFALW_dX=0.0;
modelStruct.modelPar_given_NFALW=mod.given("NFALW");
modelStruct.modelPar_NFAW=mod.NFAW;
modelStruct.d_modelPar_NFAW_dX=0.0;
modelStruct.modelPar_given_NFAW=mod.given("NFAW");
modelStruct.modelPar_NFBLW=mod.NFBLW;
modelStruct.d_modelPar_NFBLW_dX=0.0;
modelStruct.modelPar_given_NFBLW=mod.given("NFBLW");
modelStruct.modelPar_NFCLW=mod.NFCLW;
modelStruct.d_modelPar_NFCLW_dX=0.0;
modelStruct.modelPar_given_NFCLW=mod.given("NFCLW");
modelStruct.modelPar_NFEO=mod.NFEO;
modelStruct.d_modelPar_NFEO_dX=0.0;
modelStruct.modelPar_given_NFEO=mod.given("NFEO");
modelStruct.modelPar_NFEBO=mod.NFEBO;
modelStruct.d_modelPar_NFEBO_dX=0.0;
modelStruct.modelPar_given_NFEBO=mod.given("NFEBO");
modelStruct.modelPar_EFO=mod.EFO;
modelStruct.d_modelPar_EFO_dX=0.0;
modelStruct.modelPar_given_EFO=mod.given("EFO");
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modelStruct.modelPar_KUO=mod.KUO;
modelStruct.d_modelPar_KUO_dX=0.0;
modelStruct.modelPar_given_KUO=mod.given("KUO");
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modelStruct.modelPar_TKUO=mod.TKUO;
modelStruct.d_modelPar_TKUO_dX=0.0;
modelStruct.modelPar_given_TKUO=mod.given("TKUO");
modelStruct.modelPar_LKUO=mod.LKUO;
modelStruct.d_modelPar_LKUO_dX=0.0;
modelStruct.modelPar_given_LKUO=mod.given("LKUO");
modelStruct.modelPar_WKUO=mod.WKUO;
modelStruct.d_modelPar_WKUO_dX=0.0;
modelStruct.modelPar_given_WKUO=mod.given("WKUO");
modelStruct.modelPar_PKUO=mod.PKUO;
modelStruct.d_modelPar_PKUO_dX=0.0;
modelStruct.modelPar_given_PKUO=mod.given("PKUO");
modelStruct.modelPar_LLODKUO=mod.LLODKUO;
modelStruct.d_modelPar_LLODKUO_dX=0.0;
modelStruct.modelPar_given_LLODKUO=mod.given("LLODKUO");
modelStruct.modelPar_WLODKUO=mod.WLODKUO;
modelStruct.d_modelPar_WLODKUO_dX=0.0;
modelStruct.modelPar_given_WLODKUO=mod.given("WLODKUO");
modelStruct.modelPar_KVTHO=mod.KVTHO;
modelStruct.d_modelPar_KVTHO_dX=0.0;
modelStruct.modelPar_given_KVTHO=mod.given("KVTHO");
modelStruct.modelPar_LKVTHO=mod.LKVTHO;
modelStruct.d_modelPar_LKVTHO_dX=0.0;
modelStruct.modelPar_given_LKVTHO=mod.given("LKVTHO");
modelStruct.modelPar_WKVTHO=mod.WKVTHO;
modelStruct.d_modelPar_WKVTHO_dX=0.0;
modelStruct.modelPar_given_WKVTHO=mod.given("WKVTHO");
modelStruct.modelPar_PKVTHO=mod.PKVTHO;
modelStruct.d_modelPar_PKVTHO_dX=0.0;
modelStruct.modelPar_given_PKVTHO=mod.given("PKVTHO");
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modelStruct.modelPar_STETAO=mod.STETAO;
modelStruct.d_modelPar_STETAO_dX=0.0;
modelStruct.modelPar_given_STETAO=mod.given("STETAO");
modelStruct.modelPar_LODETAO=mod.LODETAO;
modelStruct.d_modelPar_LODETAO_dX=0.0;
modelStruct.modelPar_given_LODETAO=mod.given("LODETAO");
modelStruct.modelPar_STRLAMBDA=mod.STRLAMBDA;
modelStruct.d_modelPar_STRLAMBDA_dX=0.0;
modelStruct.modelPar_given_STRLAMBDA=mod.given("STRLAMBDA");
modelStruct.modelPar_STRALPHA=mod.STRALPHA;
modelStruct.d_modelPar_STRALPHA_dX=0.0;
modelStruct.modelPar_given_STRALPHA=mod.given("STRALPHA");
modelStruct.modelPar_STRDVFBO=mod.STRDVFBO;
modelStruct.d_modelPar_STRDVFBO_dX=0.0;
modelStruct.modelPar_given_STRDVFBO=mod.given("STRDVFBO");
modelStruct.modelPar_STRWDVFBO=mod.STRWDVFBO;
modelStruct.d_modelPar_STRWDVFBO_dX=0.0;
modelStruct.modelPar_given_STRWDVFBO=mod.given("STRWDVFBO");
modelStruct.modelPar_STRDCFL=mod.STRDCFL;
modelStruct.d_modelPar_STRDCFL_dX=0.0;
modelStruct.modelPar_given_STRDCFL=mod.given("STRDCFL");
modelStruct.modelPar_STRRUO=mod.STRRUO;
modelStruct.d_modelPar_STRRUO_dX=0.0;
modelStruct.modelPar_given_STRRUO=mod.given("STRRUO");
modelStruct.modelPar_STRTRUO=mod.STRTRUO;
modelStruct.d_modelPar_STRTRUO_dX=0.0;
modelStruct.modelPar_given_STRTRUO=mod.given("STRTRUO");
modelStruct.modelPar_STRRVSAT=mod.STRRVSAT;
modelStruct.d_modelPar_STRRVSAT_dX=0.0;
modelStruct.modelPar_given_STRRVSAT=mod.given("STRRVSAT");


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_SWSCALE=mod.SWSCALE;
modelStruct.modelPar_given_SWSCALE=mod.given("SWSCALE");
modelStruct.modelPar_SWSUBDEP=mod.SWSUBDEP;
modelStruct.modelPar_given_SWSUBDEP=mod.given("SWSUBDEP");
modelStruct.modelPar_SWIGATE=mod.SWIGATE;
modelStruct.modelPar_given_SWIGATE=mod.given("SWIGATE");
modelStruct.modelPar_SWGIDL=mod.SWGIDL;
modelStruct.modelPar_given_SWGIDL=mod.given("SWGIDL");
modelStruct.modelPar_SWSHE=mod.SWSHE;
modelStruct.modelPar_given_SWSHE=mod.given("SWSHE");
modelStruct.modelPar_SWIGN=mod.SWIGN;
modelStruct.modelPar_given_SWIGN=mod.given("SWIGN");
modelStruct.modelPar_SWJUNASYM=mod.SWJUNASYM;
modelStruct.modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
modelStruct.modelPar_SWIMPACT=mod.SWIMPACT;
modelStruct.modelPar_given_SWIMPACT=mod.given("SWIMPACT");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_SWSTRESS=mod.SWSTRESS;
modelStruct.modelPar_given_SWSTRESS=mod.given("SWSTRESS");



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
inParamMap["L"] = &(instanceStruct.d_instancePar_L_dX);
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
inParamMap["W"] = &(instanceStruct.d_instancePar_W_dX);
instanceStruct.instancePar_ASOURCE=in.ASOURCE;
instanceStruct.d_instancePar_ASOURCE_dX=0.0;
instanceStruct.instancePar_given_ASOURCE=in.given("ASOURCE");
inParamMap["ASOURCE"] = &(instanceStruct.d_instancePar_ASOURCE_dX);
instanceStruct.instancePar_ADRAIN=in.ADRAIN;
instanceStruct.d_instancePar_ADRAIN_dX=0.0;
instanceStruct.instancePar_given_ADRAIN=in.given("ADRAIN");
inParamMap["ADRAIN"] = &(instanceStruct.d_instancePar_ADRAIN_dX);
instanceStruct.instancePar_PSOURCE=in.PSOURCE;
instanceStruct.d_instancePar_PSOURCE_dX=0.0;
instanceStruct.instancePar_given_PSOURCE=in.given("PSOURCE");
inParamMap["PSOURCE"] = &(instanceStruct.d_instancePar_PSOURCE_dX);
instanceStruct.instancePar_PDRAIN=in.PDRAIN;
instanceStruct.d_instancePar_PDRAIN_dX=0.0;
instanceStruct.instancePar_given_PDRAIN=in.given("PDRAIN");
inParamMap["PDRAIN"] = &(instanceStruct.d_instancePar_PDRAIN_dX);
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
inParamMap["SA"] = &(instanceStruct.d_instancePar_SA_dX);
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
inParamMap["SB"] = &(instanceStruct.d_instancePar_SB_dX);
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
inParamMap["SD"] = &(instanceStruct.d_instancePar_SD_dX);
instanceStruct.instancePar_DELVTO=in.DELVTO;
instanceStruct.d_instancePar_DELVTO_dX=0.0;
instanceStruct.instancePar_given_DELVTO=in.given("DELVTO");
inParamMap["DELVTO"] = &(instanceStruct.d_instancePar_DELVTO_dX);
instanceStruct.instancePar_FACTUO=in.FACTUO;
instanceStruct.d_instancePar_FACTUO_dX=0.0;
instanceStruct.instancePar_given_FACTUO=in.given("FACTUO");
inParamMap["FACTUO"] = &(instanceStruct.d_instancePar_FACTUO_dX);


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_NF=in.NF;
instanceStruct.instancePar_given_NF=in.given("NF");
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.instancePar_given_MULT=in.given("MULT");
instanceStruct.instancePar_M=in.M;
instanceStruct.instancePar_given_M=in.given("M");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals
instanceStruct.instanceVar_ASOURCE_i=in.ASOURCE_i;
instanceStruct.d_instanceVar_ASOURCE_i_dX=0.0;
instanceStruct.instanceVar_ADRAIN_i=in.ADRAIN_i;
instanceStruct.d_instanceVar_ADRAIN_i_dX=0.0;
instanceStruct.instanceVar_PSOURCE_i=in.PSOURCE_i;
instanceStruct.d_instanceVar_PSOURCE_i_dX=0.0;
instanceStruct.instanceVar_PDRAIN_i=in.PDRAIN_i;
instanceStruct.d_instanceVar_PDRAIN_i_dX=0.0;
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_VFB1_i=in.VFB1_i;
instanceStruct.d_instanceVar_VFB1_i_dX=0.0;
instanceStruct.instanceVar_CIC1_i=in.CIC1_i;
instanceStruct.d_instanceVar_CIC1_i_dX=0.0;
instanceStruct.instanceVar_PSCE1_i=in.PSCE1_i;
instanceStruct.d_instanceVar_PSCE1_i_dX=0.0;
instanceStruct.instanceVar_CF1_i=in.CF1_i;
instanceStruct.d_instanceVar_CF1_i_dX=0.0;
instanceStruct.instanceVar_BETN1_i=in.BETN1_i;
instanceStruct.d_instanceVar_BETN1_i_dX=0.0;
instanceStruct.instanceVar_THESAT1_i=in.THESAT1_i;
instanceStruct.d_instanceVar_THESAT1_i_dX=0.0;
instanceStruct.instanceVar_VFB2_i=in.VFB2_i;
instanceStruct.d_instanceVar_VFB2_i_dX=0.0;
instanceStruct.instanceVar_CIC2_i=in.CIC2_i;
instanceStruct.d_instanceVar_CIC2_i_dX=0.0;
instanceStruct.instanceVar_PSCE2_i=in.PSCE2_i;
instanceStruct.d_instanceVar_PSCE2_i_dX=0.0;
instanceStruct.instanceVar_CF2_i=in.CF2_i;
instanceStruct.d_instanceVar_CF2_i_dX=0.0;
instanceStruct.instanceVar_BETN2_i=in.BETN2_i;
instanceStruct.d_instanceVar_BETN2_i_dX=0.0;
instanceStruct.instanceVar_THESAT2_i=in.THESAT2_i;
instanceStruct.d_instanceVar_THESAT2_i_dX=0.0;
instanceStruct.instanceVar_TSI_i=in.TSI_i;
instanceStruct.d_instanceVar_TSI_i_dX=0.0;
instanceStruct.instanceVar_XGE_i=in.XGE_i;
instanceStruct.d_instanceVar_XGE_i_dX=0.0;
instanceStruct.instanceVar_TYPESUB_i=in.TYPESUB_i;
instanceStruct.instanceVar_NOV_i=in.NOV_i;
instanceStruct.d_instanceVar_NOV_i_dX=0.0;
instanceStruct.instanceVar_NOVD_i=in.NOVD_i;
instanceStruct.d_instanceVar_NOVD_i_dX=0.0;
instanceStruct.instanceVar_STVFB_i=in.STVFB_i;
instanceStruct.d_instanceVar_STVFB_i_dX=0.0;
instanceStruct.instanceVar_NSDDC_i=in.NSDDC_i;
instanceStruct.d_instanceVar_NSDDC_i_dX=0.0;
instanceStruct.instanceVar_PSCEDLB_i=in.PSCEDLB_i;
instanceStruct.d_instanceVar_PSCEDLB_i_dX=0.0;
instanceStruct.instanceVar_STCF_i=in.STCF_i;
instanceStruct.d_instanceVar_STCF_i_dX=0.0;
instanceStruct.instanceVar_CFD_i=in.CFD_i;
instanceStruct.d_instanceVar_CFD_i_dX=0.0;
instanceStruct.instanceVar_CFDL_i=in.CFDL_i;
instanceStruct.d_instanceVar_CFDL_i_dX=0.0;
instanceStruct.instanceVar_CFDLB_i=in.CFDLB_i;
instanceStruct.d_instanceVar_CFDLB_i_dX=0.0;
instanceStruct.instanceVar_STBET_i=in.STBET_i;
instanceStruct.d_instanceVar_STBET_i_dX=0.0;
instanceStruct.instanceVar_MUE_i=in.MUE_i;
instanceStruct.d_instanceVar_MUE_i_dX=0.0;
instanceStruct.instanceVar_STMUE_i=in.STMUE_i;
instanceStruct.d_instanceVar_STMUE_i_dX=0.0;
instanceStruct.instanceVar_THEMU_i=in.THEMU_i;
instanceStruct.d_instanceVar_THEMU_i_dX=0.0;
instanceStruct.instanceVar_STTHEMU_i=in.STTHEMU_i;
instanceStruct.d_instanceVar_STTHEMU_i_dX=0.0;
instanceStruct.instanceVar_CS_i=in.CS_i;
instanceStruct.d_instanceVar_CS_i_dX=0.0;
instanceStruct.instanceVar_CSFI_i=in.CSFI_i;
instanceStruct.d_instanceVar_CSFI_i_dX=0.0;
instanceStruct.instanceVar_CSBI_i=in.CSBI_i;
instanceStruct.d_instanceVar_CSBI_i_dX=0.0;
instanceStruct.instanceVar_STCS_i=in.STCS_i;
instanceStruct.d_instanceVar_STCS_i_dX=0.0;
instanceStruct.instanceVar_THECS_i=in.THECS_i;
instanceStruct.d_instanceVar_THECS_i_dX=0.0;
instanceStruct.instanceVar_STTHECS_i=in.STTHECS_i;
instanceStruct.d_instanceVar_STTHECS_i_dX=0.0;
instanceStruct.instanceVar_STXCOR_i=in.STXCOR_i;
instanceStruct.d_instanceVar_STXCOR_i_dX=0.0;
instanceStruct.instanceVar_RS_i=in.RS_i;
instanceStruct.d_instanceVar_RS_i_dX=0.0;
instanceStruct.instanceVar_RSIG_i=in.RSIG_i;
instanceStruct.d_instanceVar_RSIG_i_dX=0.0;
instanceStruct.instanceVar_STRS_i=in.STRS_i;
instanceStruct.d_instanceVar_STRS_i_dX=0.0;
instanceStruct.instanceVar_RSG_i=in.RSG_i;
instanceStruct.d_instanceVar_RSG_i_dX=0.0;
instanceStruct.instanceVar_THERSG_i=in.THERSG_i;
instanceStruct.d_instanceVar_THERSG_i_dX=0.0;
instanceStruct.instanceVar_RSB_i=in.RSB_i;
instanceStruct.d_instanceVar_RSB_i_dX=0.0;
instanceStruct.instanceVar_CT_i=in.CT_i;
instanceStruct.d_instanceVar_CT_i_dX=0.0;
instanceStruct.instanceVar_TOXP_i=in.TOXP_i;
instanceStruct.d_instanceVar_TOXP_i_dX=0.0;
instanceStruct.instanceVar_XCOR_i=in.XCOR_i;
instanceStruct.d_instanceVar_XCOR_i_dX=0.0;
instanceStruct.instanceVar_XCORB_i=in.XCORB_i;
instanceStruct.d_instanceVar_XCORB_i_dX=0.0;
instanceStruct.instanceVar_THESAT_i=in.THESAT_i;
instanceStruct.d_instanceVar_THESAT_i_dX=0.0;
instanceStruct.instanceVar_STTHESAT_i=in.STTHESAT_i;
instanceStruct.d_instanceVar_STTHESAT_i_dX=0.0;
instanceStruct.instanceVar_ALP_i=in.ALP_i;
instanceStruct.d_instanceVar_ALP_i_dX=0.0;
instanceStruct.instanceVar_ALP1_i=in.ALP1_i;
instanceStruct.d_instanceVar_ALP1_i_dX=0.0;
instanceStruct.instanceVar_ALPB_i=in.ALPB_i;
instanceStruct.d_instanceVar_ALPB_i_dX=0.0;
instanceStruct.instanceVar_VP_i=in.VP_i;
instanceStruct.d_instanceVar_VP_i_dX=0.0;
instanceStruct.instanceVar_VPG_i=in.VPG_i;
instanceStruct.d_instanceVar_VPG_i_dX=0.0;
instanceStruct.instanceVar_GCO_i=in.GCO_i;
instanceStruct.d_instanceVar_GCO_i_dX=0.0;
instanceStruct.instanceVar_IGINV_i=in.IGINV_i;
instanceStruct.d_instanceVar_IGINV_i_dX=0.0;
instanceStruct.instanceVar_IGOVINV_i=in.IGOVINV_i;
instanceStruct.d_instanceVar_IGOVINV_i_dX=0.0;
instanceStruct.instanceVar_IGOVINVD_i=in.IGOVINVD_i;
instanceStruct.d_instanceVar_IGOVINVD_i_dX=0.0;
instanceStruct.instanceVar_IGOVACC_i=in.IGOVACC_i;
instanceStruct.d_instanceVar_IGOVACC_i_dX=0.0;
instanceStruct.instanceVar_IGOVACCD_i=in.IGOVACCD_i;
instanceStruct.d_instanceVar_IGOVACCD_i_dX=0.0;
instanceStruct.instanceVar_STIG_i=in.STIG_i;
instanceStruct.d_instanceVar_STIG_i_dX=0.0;
instanceStruct.instanceVar_STIGFN_i=in.STIGFN_i;
instanceStruct.d_instanceVar_STIGFN_i_dX=0.0;
instanceStruct.instanceVar_FNOVINV_i=in.FNOVINV_i;
instanceStruct.d_instanceVar_FNOVINV_i_dX=0.0;
instanceStruct.instanceVar_FNOVINVD_i=in.FNOVINVD_i;
instanceStruct.d_instanceVar_FNOVINVD_i_dX=0.0;
instanceStruct.instanceVar_GC2CH_i=in.GC2CH_i;
instanceStruct.d_instanceVar_GC2CH_i_dX=0.0;
instanceStruct.instanceVar_GC3CH_i=in.GC3CH_i;
instanceStruct.d_instanceVar_GC3CH_i_dX=0.0;
instanceStruct.instanceVar_GC2OVINV_i=in.GC2OVINV_i;
instanceStruct.d_instanceVar_GC2OVINV_i_dX=0.0;
instanceStruct.instanceVar_GC3OVINV_i=in.GC3OVINV_i;
instanceStruct.d_instanceVar_GC3OVINV_i_dX=0.0;
instanceStruct.instanceVar_GC2OVACC_i=in.GC2OVACC_i;
instanceStruct.d_instanceVar_GC2OVACC_i_dX=0.0;
instanceStruct.instanceVar_GC3OVACC_i=in.GC3OVACC_i;
instanceStruct.d_instanceVar_GC3OVACC_i_dX=0.0;
instanceStruct.instanceVar_GCDOV_i=in.GCDOV_i;
instanceStruct.d_instanceVar_GCDOV_i_dX=0.0;
instanceStruct.instanceVar_GCVDOV_i=in.GCVDOV_i;
instanceStruct.d_instanceVar_GCVDOV_i_dX=0.0;
instanceStruct.instanceVar_CHIB_i=in.CHIB_i;
instanceStruct.d_instanceVar_CHIB_i_dX=0.0;
instanceStruct.instanceVar_NIGINV_i=in.NIGINV_i;
instanceStruct.d_instanceVar_NIGINV_i_dX=0.0;
instanceStruct.instanceVar_GCOVINVFN_i=in.GCOVINVFN_i;
instanceStruct.d_instanceVar_GCOVINVFN_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGIDLD_i=in.AGIDLD_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX=0.0;
instanceStruct.instanceVar_BGIDL_i=in.BGIDL_i;
instanceStruct.d_instanceVar_BGIDL_i_dX=0.0;
instanceStruct.instanceVar_BGIDLD_i=in.BGIDLD_i;
instanceStruct.d_instanceVar_BGIDLD_i_dX=0.0;
instanceStruct.instanceVar_STBGIDL_i=in.STBGIDL_i;
instanceStruct.d_instanceVar_STBGIDL_i_dX=0.0;
instanceStruct.instanceVar_STBGIDLD_i=in.STBGIDLD_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDLD_i=in.CGIDLD_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX=0.0;
instanceStruct.instanceVar_DGIDL_i=in.DGIDL_i;
instanceStruct.d_instanceVar_DGIDL_i_dX=0.0;
instanceStruct.instanceVar_DGIDLD_i=in.DGIDLD_i;
instanceStruct.d_instanceVar_DGIDLD_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_A2_i=in.A2_i;
instanceStruct.d_instanceVar_A2_i_dX=0.0;
instanceStruct.instanceVar_STA2_i=in.STA2_i;
instanceStruct.d_instanceVar_STA2_i_dX=0.0;
instanceStruct.instanceVar_A3_i=in.A3_i;
instanceStruct.d_instanceVar_A3_i_dX=0.0;
instanceStruct.instanceVar_AREAQ_i=in.AREAQ_i;
instanceStruct.d_instanceVar_AREAQ_i_dX=0.0;
instanceStruct.instanceVar_CGBOV_i=in.CGBOV_i;
instanceStruct.d_instanceVar_CGBOV_i_dX=0.0;
instanceStruct.instanceVar_NSDAC_i=in.NSDAC_i;
instanceStruct.d_instanceVar_NSDAC_i_dX=0.0;
instanceStruct.instanceVar_FIF_i=in.FIF_i;
instanceStruct.d_instanceVar_FIF_i_dX=0.0;
instanceStruct.instanceVar_FSCEAC_i=in.FSCEAC_i;
instanceStruct.d_instanceVar_FSCEAC_i_dX=0.0;
instanceStruct.instanceVar_COV_i=in.COV_i;
instanceStruct.d_instanceVar_COV_i_dX=0.0;
instanceStruct.instanceVar_COVD_i=in.COVD_i;
instanceStruct.d_instanceVar_COVD_i_dX=0.0;
instanceStruct.instanceVar_COVDL_i=in.COVDL_i;
instanceStruct.d_instanceVar_COVDL_i_dX=0.0;
instanceStruct.instanceVar_COVDLB_i=in.COVDLB_i;
instanceStruct.d_instanceVar_COVDLB_i_dX=0.0;
instanceStruct.instanceVar_DVFBOV_i=in.DVFBOV_i;
instanceStruct.d_instanceVar_DVFBOV_i_dX=0.0;
instanceStruct.instanceVar_CFR_i=in.CFR_i;
instanceStruct.d_instanceVar_CFR_i_dX=0.0;
instanceStruct.instanceVar_CFRD_i=in.CFRD_i;
instanceStruct.d_instanceVar_CFRD_i_dX=0.0;
instanceStruct.instanceVar_CSD_i=in.CSD_i;
instanceStruct.d_instanceVar_CSD_i_dX=0.0;
instanceStruct.instanceVar_CSDBP_i=in.CSDBP_i;
instanceStruct.d_instanceVar_CSDBP_i_dX=0.0;
instanceStruct.instanceVar_RTH_i=in.RTH_i;
instanceStruct.d_instanceVar_RTH_i_dX=0.0;
instanceStruct.instanceVar_STRTH_i=in.STRTH_i;
instanceStruct.d_instanceVar_STRTH_i_dX=0.0;
instanceStruct.instanceVar_CTH_i=in.CTH_i;
instanceStruct.d_instanceVar_CTH_i_dX=0.0;
instanceStruct.instanceVar_FNT_i=in.FNT_i;
instanceStruct.d_instanceVar_FNT_i_dX=0.0;
instanceStruct.instanceVar_FNTEXC_i=in.FNTEXC_i;
instanceStruct.d_instanceVar_FNTEXC_i_dX=0.0;
instanceStruct.instanceVar_NFA_i=in.NFA_i;
instanceStruct.d_instanceVar_NFA_i_dX=0.0;
instanceStruct.instanceVar_NFB_i=in.NFB_i;
instanceStruct.d_instanceVar_NFB_i_dX=0.0;
instanceStruct.instanceVar_NFC_i=in.NFC_i;
instanceStruct.d_instanceVar_NFC_i_dX=0.0;
instanceStruct.instanceVar_NFE_i=in.NFE_i;
instanceStruct.d_instanceVar_NFE_i_dX=0.0;
instanceStruct.instanceVar_NFEB_i=in.NFEB_i;
instanceStruct.d_instanceVar_NFEB_i_dX=0.0;
instanceStruct.instanceVar_EF_i=in.EF_i;
instanceStruct.d_instanceVar_EF_i_dX=0.0;
instanceStruct.instanceVar_VFB1_t=in.VFB1_t;
instanceStruct.d_instanceVar_VFB1_t_dX=0.0;
instanceStruct.instanceVar_CF1_t=in.CF1_t;
instanceStruct.d_instanceVar_CF1_t_dX=0.0;
instanceStruct.instanceVar_BETN1_t=in.BETN1_t;
instanceStruct.d_instanceVar_BETN1_t_dX=0.0;
instanceStruct.instanceVar_VFB2_t=in.VFB2_t;
instanceStruct.d_instanceVar_VFB2_t_dX=0.0;
instanceStruct.instanceVar_CF2_t=in.CF2_t;
instanceStruct.d_instanceVar_CF2_t_dX=0.0;
instanceStruct.instanceVar_BETN2_t=in.BETN2_t;
instanceStruct.d_instanceVar_BETN2_t_dX=0.0;
instanceStruct.instanceVar_MUE_t=in.MUE_t;
instanceStruct.d_instanceVar_MUE_t_dX=0.0;
instanceStruct.instanceVar_THEMU_t=in.THEMU_t;
instanceStruct.d_instanceVar_THEMU_t_dX=0.0;
instanceStruct.instanceVar_CS_t=in.CS_t;
instanceStruct.d_instanceVar_CS_t_dX=0.0;
instanceStruct.instanceVar_THECS_t=in.THECS_t;
instanceStruct.d_instanceVar_THECS_t_dX=0.0;
instanceStruct.instanceVar_RS_t=in.RS_t;
instanceStruct.d_instanceVar_RS_t_dX=0.0;
instanceStruct.instanceVar_XCOR_t=in.XCOR_t;
instanceStruct.d_instanceVar_XCOR_t_dX=0.0;
instanceStruct.instanceVar_THESAT_t=in.THESAT_t;
instanceStruct.d_instanceVar_THESAT_t_dX=0.0;
instanceStruct.instanceVar_IGINV_t=in.IGINV_t;
instanceStruct.d_instanceVar_IGINV_t_dX=0.0;
instanceStruct.instanceVar_IGOVINV_t=in.IGOVINV_t;
instanceStruct.d_instanceVar_IGOVINV_t_dX=0.0;
instanceStruct.instanceVar_IGOVINVD_t=in.IGOVINVD_t;
instanceStruct.d_instanceVar_IGOVINVD_t_dX=0.0;
instanceStruct.instanceVar_IGOVACC_t=in.IGOVACC_t;
instanceStruct.d_instanceVar_IGOVACC_t_dX=0.0;
instanceStruct.instanceVar_IGOVACCD_t=in.IGOVACCD_t;
instanceStruct.d_instanceVar_IGOVACCD_t_dX=0.0;
instanceStruct.instanceVar_FNOVINV_t=in.FNOVINV_t;
instanceStruct.d_instanceVar_FNOVINV_t_dX=0.0;
instanceStruct.instanceVar_FNOVINVD_t=in.FNOVINVD_t;
instanceStruct.d_instanceVar_FNOVINVD_t_dX=0.0;
instanceStruct.instanceVar_BGIDL_t=in.BGIDL_t;
instanceStruct.d_instanceVar_BGIDL_t_dX=0.0;
instanceStruct.instanceVar_BGIDLD_t=in.BGIDLD_t;
instanceStruct.d_instanceVar_BGIDLD_t_dX=0.0;
instanceStruct.instanceVar_A2_t=in.A2_t;
instanceStruct.d_instanceVar_A2_t_dX=0.0;
instanceStruct.instanceVar_RTH_t=in.RTH_t;
instanceStruct.d_instanceVar_RTH_t_dX=0.0;
instanceStruct.instanceVar_gamAX=in.gamAX;
instanceStruct.d_instanceVar_gamAX_dX=0.0;
instanceStruct.instanceVar_temp=in.temp;
instanceStruct.d_instanceVar_temp_dX=0.0;
instanceStruct.instanceVar_temp1=in.temp1;
instanceStruct.d_instanceVar_temp1_dX=0.0;
instanceStruct.instanceVar_temp2=in.temp2;
instanceStruct.d_instanceVar_temp2_dX=0.0;
instanceStruct.instanceVar_temp3=in.temp3;
instanceStruct.d_instanceVar_temp3_dX=0.0;
instanceStruct.instanceVar_temp4=in.temp4;
instanceStruct.d_instanceVar_temp4_dX=0.0;
instanceStruct.instanceVar_TKC=in.TKC;
instanceStruct.instanceVar_TKC_sq=in.TKC_sq;
instanceStruct.instanceVar_DTC=in.DTC;
instanceStruct.instanceVar_dT=in.dT;
instanceStruct.d_instanceVar_dT_dX=0.0;
instanceStruct.instanceVar_rT=in.rT;
instanceStruct.d_instanceVar_rT_dX=0.0;
instanceStruct.instanceVar_rTn=in.rTn;
instanceStruct.d_instanceVar_rTn_dX=0.0;
instanceStruct.instanceVar_phit0=in.phit0;
instanceStruct.instanceVar_inv_phit0=in.inv_phit0;
instanceStruct.instanceVar_phit=in.phit;
instanceStruct.d_instanceVar_phit_dX=0.0;
instanceStruct.instanceVar_inv_phit=in.inv_phit;
instanceStruct.d_instanceVar_inv_phit_dX=0.0;
instanceStruct.instanceVar_one_m_xge=in.one_m_xge;
instanceStruct.d_instanceVar_one_m_xge_dX=0.0;
instanceStruct.instanceVar_epsch=in.epsch;
instanceStruct.d_instanceVar_epsch_dX=0.0;
instanceStruct.instanceVar_EgSi=in.EgSi;
instanceStruct.instanceVar_EgGe=in.EgGe;
instanceStruct.instanceVar_dEg=in.dEg;
instanceStruct.d_instanceVar_dEg_dX=0.0;
instanceStruct.instanceVar_Eg=in.Eg;
instanceStruct.d_instanceVar_Eg_dX=0.0;
instanceStruct.instanceVar_Eg_2phit0=in.Eg_2phit0;
instanceStruct.d_instanceVar_Eg_2phit0_dX=0.0;
instanceStruct.instanceVar_Eg_2phit=in.Eg_2phit;
instanceStruct.d_instanceVar_Eg_2phit_dX=0.0;
instanceStruct.instanceVar_dVfbch=in.dVfbch;
instanceStruct.d_instanceVar_dVfbch_dX=0.0;
instanceStruct.instanceVar_niratio=in.niratio;
instanceStruct.d_instanceVar_niratio_dX=0.0;
instanceStruct.instanceVar_Cox2Init=in.Cox2Init;
instanceStruct.d_instanceVar_Cox2Init_dX=0.0;
instanceStruct.instanceVar_Cox1Prime=in.Cox1Prime;
instanceStruct.d_instanceVar_Cox1Prime_dX=0.0;
instanceStruct.instanceVar_Cox2Prime=in.Cox2Prime;
instanceStruct.d_instanceVar_Cox2Prime_dX=0.0;
instanceStruct.instanceVar_dVfb1Nch=in.dVfb1Nch;
instanceStruct.d_instanceVar_dVfb1Nch_dX=0.0;
instanceStruct.instanceVar_dVfb2Nch=in.dVfb2Nch;
instanceStruct.d_instanceVar_dVfb2Nch_dX=0.0;
instanceStruct.instanceVar_CsiPrime_0=in.CsiPrime_0;
instanceStruct.d_instanceVar_CsiPrime_0_dX=0.0;
instanceStruct.instanceVar_k1_1D=in.k1_1D;
instanceStruct.d_instanceVar_k1_1D_dX=0.0;
instanceStruct.instanceVar_k2_1D=in.k2_1D;
instanceStruct.d_instanceVar_k2_1D_dX=0.0;
instanceStruct.instanceVar_keq_1D=in.keq_1D;
instanceStruct.d_instanceVar_keq_1D_dX=0.0;
instanceStruct.instanceVar_neff=in.neff;
instanceStruct.d_instanceVar_neff_dX=0.0;
instanceStruct.instanceVar_A0_Csisq=in.A0_Csisq;
instanceStruct.d_instanceVar_A0_Csisq_dX=0.0;
instanceStruct.instanceVar_xth_1D=in.xth_1D;
instanceStruct.d_instanceVar_xth_1D_dX=0.0;
instanceStruct.instanceVar_xSDdep=in.xSDdep;
instanceStruct.d_instanceVar_xSDdep_dX=0.0;
instanceStruct.instanceVar_dVfbQM=in.dVfbQM;
instanceStruct.d_instanceVar_dVfbQM_dX=0.0;
instanceStruct.instanceVar_qq=in.qq;
instanceStruct.d_instanceVar_qq_dX=0.0;
instanceStruct.instanceVar_tsisq=in.tsisq;
instanceStruct.d_instanceVar_tsisq_dX=0.0;
instanceStruct.instanceVar_Gfsub=in.Gfsub;
instanceStruct.d_instanceVar_Gfsub_dX=0.0;
instanceStruct.instanceVar_Gfsub2=in.Gfsub2;
instanceStruct.d_instanceVar_Gfsub2_dX=0.0;
instanceStruct.instanceVar_inv_Gfsub2=in.inv_Gfsub2;
instanceStruct.d_instanceVar_inv_Gfsub2_dX=0.0;
instanceStruct.instanceVar_xisub=in.xisub;
instanceStruct.d_instanceVar_xisub_dX=0.0;
instanceStruct.instanceVar_inv_xisub=in.inv_xisub;
instanceStruct.d_instanceVar_inv_xisub_dX=0.0;
instanceStruct.instanceVar_margin_sub=in.margin_sub;
instanceStruct.d_instanceVar_margin_sub_dX=0.0;
instanceStruct.instanceVar_xn_sub=in.xn_sub;
instanceStruct.d_instanceVar_xn_sub_dX=0.0;
instanceStruct.instanceVar_fmue=in.fmue;
instanceStruct.d_instanceVar_fmue_dX=0.0;
instanceStruct.instanceVar_inv_qi1cs=in.inv_qi1cs;
instanceStruct.d_instanceVar_inv_qi1cs_dX=0.0;
instanceStruct.instanceVar_inv_qi2cs=in.inv_qi2cs;
instanceStruct.d_instanceVar_inv_qi2cs_dX=0.0;
instanceStruct.instanceVar_eta_mu=in.eta_mu;
instanceStruct.d_instanceVar_eta_mu_dX=0.0;
instanceStruct.instanceVar_one_m_eta=in.one_m_eta;
instanceStruct.d_instanceVar_one_m_eta_dX=0.0;
instanceStruct.instanceVar_frs=in.frs;
instanceStruct.d_instanceVar_frs_dX=0.0;
instanceStruct.instanceVar_sat_phit=in.sat_phit;
instanceStruct.d_instanceVar_sat_phit_dX=0.0;
instanceStruct.instanceVar_alp1_phit=in.alp1_phit;
instanceStruct.d_instanceVar_alp1_phit_dX=0.0;
instanceStruct.instanceVar_inv_CHIB=in.inv_CHIB;
instanceStruct.d_instanceVar_inv_CHIB_dX=0.0;
instanceStruct.instanceVar_tempM=in.tempM;
instanceStruct.d_instanceVar_tempM_dX=0.0;
instanceStruct.instanceVar_BCH=in.BCH;
instanceStruct.d_instanceVar_BCH_dX=0.0;
instanceStruct.instanceVar_BOV=in.BOV;
instanceStruct.d_instanceVar_BOV_dX=0.0;
instanceStruct.instanceVar_GCQCH=in.GCQCH;
instanceStruct.d_instanceVar_GCQCH_dX=0.0;
instanceStruct.instanceVar_GCQOVINV=in.GCQOVINV;
instanceStruct.d_instanceVar_GCQOVINV_dX=0.0;
instanceStruct.instanceVar_GCQOVACC=in.GCQOVACC;
instanceStruct.d_instanceVar_GCQOVACC_dX=0.0;
instanceStruct.instanceVar_alpha_b=in.alpha_b;
instanceStruct.d_instanceVar_alpha_b_dX=0.0;
instanceStruct.instanceVar_Dch=in.Dch;
instanceStruct.d_instanceVar_Dch_dX=0.0;
instanceStruct.instanceVar_Dov=in.Dov;
instanceStruct.d_instanceVar_Dov_dX=0.0;
instanceStruct.instanceVar_n_iginv=in.n_iginv;
instanceStruct.d_instanceVar_n_iginv_dX=0.0;
instanceStruct.instanceVar_area_phit=in.area_phit;
instanceStruct.d_instanceVar_area_phit_dX=0.0;
instanceStruct.instanceVar_inner_sd=in.inner_sd;
instanceStruct.d_instanceVar_inner_sd_dX=0.0;
instanceStruct.instanceVar_xsd=in.xsd;
instanceStruct.d_instanceVar_xsd_dX=0.0;
instanceStruct.instanceVar_fif_phit=in.fif_phit;
instanceStruct.d_instanceVar_fif_phit_dX=0.0;
instanceStruct.instanceVar_lambda2D=in.lambda2D;
instanceStruct.d_instanceVar_lambda2D_dX=0.0;
instanceStruct.instanceVar_lnrTn=in.lnrTn;
instanceStruct.d_instanceVar_lnrTn_dX=0.0;
instanceStruct.instanceVar_tf_bet=in.tf_bet;
instanceStruct.d_instanceVar_tf_bet_dX=0.0;
instanceStruct.instanceVar_tf_mue=in.tf_mue;
instanceStruct.d_instanceVar_tf_mue_dX=0.0;
instanceStruct.instanceVar_tf_themu=in.tf_themu;
instanceStruct.d_instanceVar_tf_themu_dX=0.0;
instanceStruct.instanceVar_tf_cs=in.tf_cs;
instanceStruct.d_instanceVar_tf_cs_dX=0.0;
instanceStruct.instanceVar_tf_thecs=in.tf_thecs;
instanceStruct.d_instanceVar_tf_thecs_dX=0.0;
instanceStruct.instanceVar_tf_xcor=in.tf_xcor;
instanceStruct.d_instanceVar_tf_xcor_dX=0.0;
instanceStruct.instanceVar_tf_ther=in.tf_ther;
instanceStruct.d_instanceVar_tf_ther_dX=0.0;
instanceStruct.instanceVar_tf_thesat=in.tf_thesat;
instanceStruct.d_instanceVar_tf_thesat_dX=0.0;
instanceStruct.instanceVar_tf_ig=in.tf_ig;
instanceStruct.d_instanceVar_tf_ig_dX=0.0;
instanceStruct.instanceVar_tf_rth=in.tf_rth;
instanceStruct.d_instanceVar_tf_rth_dX=0.0;
instanceStruct.instanceVar_nt=in.nt;
instanceStruct.d_instanceVar_nt_dX=0.0;
instanceStruct.instanceVar_nt0=in.nt0;
instanceStruct.d_instanceVar_nt0_dX=0.0;
instanceStruct.instanceVar_fac_exc=in.fac_exc;
instanceStruct.d_instanceVar_fac_exc_dX=0.0;
instanceStruct.instanceVar_sigVds=in.sigVds;
instanceStruct.instanceVar_CsiPrime=in.CsiPrime;
instanceStruct.d_instanceVar_CsiPrime_dX=0.0;
instanceStruct.instanceVar_xd0=in.xd0;
instanceStruct.d_instanceVar_xd0_dX=0.0;
instanceStruct.instanceVar_k1=in.k1;
instanceStruct.d_instanceVar_k1_dX=0.0;
instanceStruct.instanceVar_qis=in.qis;
instanceStruct.d_instanceVar_qis_dX=0.0;
instanceStruct.instanceVar_ds=in.ds;
instanceStruct.d_instanceVar_ds_dX=0.0;
instanceStruct.instanceVar_qid=in.qid;
instanceStruct.d_instanceVar_qid_dX=0.0;
instanceStruct.instanceVar_dd=in.dd;
instanceStruct.d_instanceVar_dd_dX=0.0;
instanceStruct.instanceVar_esurf1=in.esurf1;
instanceStruct.d_instanceVar_esurf1_dX=0.0;
instanceStruct.instanceVar_qmfact1=in.qmfact1;
instanceStruct.d_instanceVar_qmfact1_dX=0.0;
instanceStruct.instanceVar_esurf2=in.esurf2;
instanceStruct.d_instanceVar_esurf2_dX=0.0;
instanceStruct.instanceVar_betneff=in.betneff;
instanceStruct.d_instanceVar_betneff_dX=0.0;
instanceStruct.instanceVar_xdeff=in.xdeff;
instanceStruct.d_instanceVar_xdeff_dX=0.0;
instanceStruct.instanceVar_qim=in.qim;
instanceStruct.d_instanceVar_qim_dX=0.0;
instanceStruct.instanceVar_Gmob=in.Gmob;
instanceStruct.d_instanceVar_Gmob_dX=0.0;
instanceStruct.instanceVar_FdL=in.FdL;
instanceStruct.d_instanceVar_FdL_dX=0.0;
instanceStruct.instanceVar_Ggamma=in.Ggamma;
instanceStruct.d_instanceVar_Ggamma_dX=0.0;
instanceStruct.instanceVar_zsat=in.zsat;
instanceStruct.d_instanceVar_zsat_dX=0.0;
instanceStruct.instanceVar_hsat=in.hsat;
instanceStruct.d_instanceVar_hsat_dX=0.0;
instanceStruct.instanceVar_Gvsat=in.Gvsat;
instanceStruct.d_instanceVar_Gvsat_dX=0.0;
instanceStruct.instanceVar_qmfact=in.qmfact;
instanceStruct.d_instanceVar_qmfact_dX=0.0;
instanceStruct.instanceVar_fact_Ids=in.fact_Ids;
instanceStruct.d_instanceVar_fact_Ids_dX=0.0;
instanceStruct.instanceVar_Ids=in.Ids;
instanceStruct.d_instanceVar_Ids_dX=0.0;
instanceStruct.instanceVar_delta_k1q1=in.delta_k1q1;
instanceStruct.d_instanceVar_delta_k1q1_dX=0.0;
instanceStruct.instanceVar_inv_k1h1_0=in.inv_k1h1_0;
instanceStruct.d_instanceVar_inv_k1h1_0_dX=0.0;
instanceStruct.instanceVar_Igse=in.Igse;
instanceStruct.d_instanceVar_Igse_dX=0.0;
instanceStruct.instanceVar_Igde=in.Igde;
instanceStruct.d_instanceVar_Igde_dX=0.0;
instanceStruct.instanceVar_Igidle=in.Igidle;
instanceStruct.d_instanceVar_Igidle_dX=0.0;
instanceStruct.instanceVar_Igisle=in.Igisle;
instanceStruct.d_instanceVar_Igisle_dX=0.0;
instanceStruct.instanceVar_mavl=in.mavl;
instanceStruct.d_instanceVar_mavl_dX=0.0;
instanceStruct.instanceVar_Iimpact=in.Iimpact;
instanceStruct.d_instanceVar_Iimpact_dX=0.0;


//non-reals


//make local copies of all model vars
//reals
modelStruct.modelVar_TKR=mod.TKR;
modelStruct.d_modelVar_TKR_dX=0.0;
modelStruct.modelVar_TKD=mod.TKD;
modelStruct.modelVar_gmin=mod.gmin;


// non-reals
modelStruct.modelVar_SWSHE_i=mod.SWSHE_i;



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_D_GND] = (*solVectorPtr)[in.li_D];
probeVars[in.admsProbeID_V_S_GND] = (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_B_GND] = (*solVectorPtr)[in.li_B];
probeVars[in.admsProbeID_V_G_GND] = (*solVectorPtr)[in.li_G];

      probeVars[in.admsProbeID_I_NSIG_GND] = (*solVectorPtr)[in.li_BRA_NSIG_GND];probeVars[in.admsProbeID_V_NSIG_GND] = (*solVectorPtr)[in.li_NSIG];
probeVars[in.admsProbeID_Temp_Tnode_GND] = (*solVectorPtr)[in.li_Tnode];
probeVars[in.admsProbeID_V_S_B] = (*solVectorPtr)[in.li_S]- (*solVectorPtr)[in.li_B];
probeVars[in.admsProbeID_V_D_S] = (*solVectorPtr)[in.li_D]- (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_G_S] = (*solVectorPtr)[in.li_G]- (*solVectorPtr)[in.li_S];



  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_D_GND,
in.admsProbeID_V_S_GND,
in.admsProbeID_V_B_GND,
in.admsProbeID_V_G_GND,
in.admsProbeID_I_NSIG_GND,
in.admsProbeID_V_NSIG_GND,
in.admsProbeID_Temp_Tnode_GND,
in.admsProbeID_V_S_B,
in.admsProbeID_V_D_S,
in.admsProbeID_V_G_S,

// node constants
in.admsNodeID_D,
in.admsNodeID_G,
in.admsNodeID_S,
in.admsNodeID_B,
in.admsNodeID_Tnode,
in.admsNodeID_NSIG,
in.admsBRA_ID_NSIG_GND,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D] += d_staticContributions_dX[in.admsNodeID_D];
    dqdp[in.admsNodeID_D] += d_dynamicContributions_dX[in.admsNodeID_D];
    Findices[in.admsNodeID_D] = in.li_D;
    Qindices[in.admsNodeID_D] = in.li_D;
    dfdp[in.admsNodeID_G] += d_staticContributions_dX[in.admsNodeID_G];
    dqdp[in.admsNodeID_G] += d_dynamicContributions_dX[in.admsNodeID_G];
    Findices[in.admsNodeID_G] = in.li_G;
    Qindices[in.admsNodeID_G] = in.li_G;
    dfdp[in.admsNodeID_S] += d_staticContributions_dX[in.admsNodeID_S];
    dqdp[in.admsNodeID_S] += d_dynamicContributions_dX[in.admsNodeID_S];
    Findices[in.admsNodeID_S] = in.li_S;
    Qindices[in.admsNodeID_S] = in.li_S;
    dfdp[in.admsNodeID_B] += d_staticContributions_dX[in.admsNodeID_B];
    dqdp[in.admsNodeID_B] += d_dynamicContributions_dX[in.admsNodeID_B];
    Findices[in.admsNodeID_B] = in.li_B;
    Qindices[in.admsNodeID_B] = in.li_B;
    dfdp[in.admsNodeID_Tnode] += d_staticContributions_dX[in.admsNodeID_Tnode];
    dqdp[in.admsNodeID_Tnode] += d_dynamicContributions_dX[in.admsNodeID_Tnode];
    Findices[in.admsNodeID_Tnode] = in.li_Tnode;
    Qindices[in.admsNodeID_Tnode] = in.li_Tnode;
    dfdp[in.admsNodeID_NSIG] += d_staticContributions_dX[in.admsNodeID_NSIG];
    dqdp[in.admsNodeID_NSIG] += d_dynamicContributions_dX[in.admsNodeID_NSIG];
    Findices[in.admsNodeID_NSIG] = in.li_NSIG;
    Qindices[in.admsNodeID_NSIG] = in.li_NSIG;
  dfdp[in.admsBRA_ID_NSIG_GND] += d_staticContributions_dX[in.admsBRA_ID_NSIG_GND];
  dqdp[in.admsBRA_ID_NSIG_GND] += d_dynamicContributions_dX[in.admsBRA_ID_NSIG_GND];
  Findices[in.admsBRA_ID_NSIG_GND] = in.li_BRA_NSIG_GND;
  Qindices[in.admsBRA_ID_NSIG_GND] = in.li_BRA_NSIG_GND;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((6+1)*sizeInstance);
dqdp.resize((6+1)*sizeInstance);
Findices.resize((6+1)*sizeInstance);
Qindices.resize((6+1)*sizeInstance);

std::vector <double> probeVars(10);
std::vector <double> d_staticContributions_dX(6+1);
std::vector <double> d_dynamicContributions_dX(6+1);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_VERSION=mod.VERSION;
modelStruct.d_modelPar_VERSION_dX=0.0;
modelStruct.modelPar_given_VERSION=mod.given("VERSION");
modParamMap["VERSION"] = &(modelStruct.d_modelPar_VERSION_dX);
modelStruct.modelPar_QMC=mod.QMC;
modelStruct.d_modelPar_QMC_dX=0.0;
modelStruct.modelPar_given_QMC=mod.given("QMC");
modParamMap["QMC"] = &(modelStruct.d_modelPar_QMC_dX);
modelStruct.modelPar_TR=mod.TR;
modelStruct.d_modelPar_TR_dX=0.0;
modelStruct.modelPar_given_TR=mod.given("TR");
modParamMap["TR"] = &(modelStruct.d_modelPar_TR_dX);
modelStruct.modelPar_TMAX=mod.TMAX;
modelStruct.d_modelPar_TMAX_dX=0.0;
modelStruct.modelPar_given_TMAX=mod.given("TMAX");
modParamMap["TMAX"] = &(modelStruct.d_modelPar_TMAX_dX);
modelStruct.modelPar_TOXE=mod.TOXE;
modelStruct.d_modelPar_TOXE_dX=0.0;
modelStruct.modelPar_given_TOXE=mod.given("TOXE");
modParamMap["TOXE"] = &(modelStruct.d_modelPar_TOXE_dX);
modelStruct.modelPar_TSI=mod.TSI;
modelStruct.d_modelPar_TSI_dX=0.0;
modelStruct.modelPar_given_TSI=mod.given("TSI");
modParamMap["TSI"] = &(modelStruct.d_modelPar_TSI_dX);
modelStruct.modelPar_XGE=mod.XGE;
modelStruct.d_modelPar_XGE_dX=0.0;
modelStruct.modelPar_given_XGE=mod.given("XGE");
modParamMap["XGE"] = &(modelStruct.d_modelPar_XGE_dX);
modelStruct.modelPar_TBOX=mod.TBOX;
modelStruct.d_modelPar_TBOX_dX=0.0;
modelStruct.modelPar_given_TBOX=mod.given("TBOX");
modParamMap["TBOX"] = &(modelStruct.d_modelPar_TBOX_dX);
modelStruct.modelPar_NCH=mod.NCH;
modelStruct.d_modelPar_NCH_dX=0.0;
modelStruct.modelPar_given_NCH=mod.given("NCH");
modParamMap["NCH"] = &(modelStruct.d_modelPar_NCH_dX);
modelStruct.modelPar_NSUB=mod.NSUB;
modelStruct.d_modelPar_NSUB_dX=0.0;
modelStruct.modelPar_given_NSUB=mod.given("NSUB");
modParamMap["NSUB"] = &(modelStruct.d_modelPar_NSUB_dX);
modelStruct.modelPar_CT=mod.CT;
modelStruct.d_modelPar_CT_dX=0.0;
modelStruct.modelPar_given_CT=mod.given("CT");
modParamMap["CT"] = &(modelStruct.d_modelPar_CT_dX);
modelStruct.modelPar_TOXP=mod.TOXP;
modelStruct.d_modelPar_TOXP_dX=0.0;
modelStruct.modelPar_given_TOXP=mod.given("TOXP");
modParamMap["TOXP"] = &(modelStruct.d_modelPar_TOXP_dX);
modelStruct.modelPar_NOV=mod.NOV;
modelStruct.d_modelPar_NOV_dX=0.0;
modelStruct.modelPar_given_NOV=mod.given("NOV");
modParamMap["NOV"] = &(modelStruct.d_modelPar_NOV_dX);
modelStruct.modelPar_NOVD=mod.NOVD;
modelStruct.d_modelPar_NOVD_dX=0.0;
modelStruct.modelPar_given_NOVD=mod.given("NOVD");
modParamMap["NOVD"] = &(modelStruct.d_modelPar_NOVD_dX);
modelStruct.modelPar_VFB=mod.VFB;
modelStruct.d_modelPar_VFB_dX=0.0;
modelStruct.modelPar_given_VFB=mod.given("VFB");
modParamMap["VFB"] = &(modelStruct.d_modelPar_VFB_dX);
modelStruct.modelPar_VFBB=mod.VFBB;
modelStruct.d_modelPar_VFBB_dX=0.0;
modelStruct.modelPar_given_VFBB=mod.given("VFBB");
modParamMap["VFBB"] = &(modelStruct.d_modelPar_VFBB_dX);
modelStruct.modelPar_STVFB=mod.STVFB;
modelStruct.d_modelPar_STVFB_dX=0.0;
modelStruct.modelPar_given_STVFB=mod.given("STVFB");
modParamMap["STVFB"] = &(modelStruct.d_modelPar_STVFB_dX);
modelStruct.modelPar_CICF=mod.CICF;
modelStruct.d_modelPar_CICF_dX=0.0;
modelStruct.modelPar_given_CICF=mod.given("CICF");
modParamMap["CICF"] = &(modelStruct.d_modelPar_CICF_dX);
modelStruct.modelPar_CIC=mod.CIC;
modelStruct.d_modelPar_CIC_dX=0.0;
modelStruct.modelPar_given_CIC=mod.given("CIC");
modParamMap["CIC"] = &(modelStruct.d_modelPar_CIC_dX);
modelStruct.modelPar_PSCE=mod.PSCE;
modelStruct.d_modelPar_PSCE_dX=0.0;
modelStruct.modelPar_given_PSCE=mod.given("PSCE");
modParamMap["PSCE"] = &(modelStruct.d_modelPar_PSCE_dX);
modelStruct.modelPar_PSCEB=mod.PSCEB;
modelStruct.d_modelPar_PSCEB_dX=0.0;
modelStruct.modelPar_given_PSCEB=mod.given("PSCEB");
modParamMap["PSCEB"] = &(modelStruct.d_modelPar_PSCEB_dX);
modelStruct.modelPar_NSDDC=mod.NSDDC;
modelStruct.d_modelPar_NSDDC_dX=0.0;
modelStruct.modelPar_given_NSDDC=mod.given("NSDDC");
modParamMap["NSDDC"] = &(modelStruct.d_modelPar_NSDDC_dX);
modelStruct.modelPar_PSCEDLB=mod.PSCEDLB;
modelStruct.d_modelPar_PSCEDLB_dX=0.0;
modelStruct.modelPar_given_PSCEDLB=mod.given("PSCEDLB");
modParamMap["PSCEDLB"] = &(modelStruct.d_modelPar_PSCEDLB_dX);
modelStruct.modelPar_PNCE=mod.PNCE;
modelStruct.d_modelPar_PNCE_dX=0.0;
modelStruct.modelPar_given_PNCE=mod.given("PNCE");
modParamMap["PNCE"] = &(modelStruct.d_modelPar_PNCE_dX);
modelStruct.modelPar_CF=mod.CF;
modelStruct.d_modelPar_CF_dX=0.0;
modelStruct.modelPar_given_CF=mod.given("CF");
modParamMap["CF"] = &(modelStruct.d_modelPar_CF_dX);
modelStruct.modelPar_CFB=mod.CFB;
modelStruct.d_modelPar_CFB_dX=0.0;
modelStruct.modelPar_given_CFB=mod.given("CFB");
modParamMap["CFB"] = &(modelStruct.d_modelPar_CFB_dX);
modelStruct.modelPar_STCF=mod.STCF;
modelStruct.d_modelPar_STCF_dX=0.0;
modelStruct.modelPar_given_STCF=mod.given("STCF");
modParamMap["STCF"] = &(modelStruct.d_modelPar_STCF_dX);
modelStruct.modelPar_CFD=mod.CFD;
modelStruct.d_modelPar_CFD_dX=0.0;
modelStruct.modelPar_given_CFD=mod.given("CFD");
modParamMap["CFD"] = &(modelStruct.d_modelPar_CFD_dX);
modelStruct.modelPar_CFDL=mod.CFDL;
modelStruct.d_modelPar_CFDL_dX=0.0;
modelStruct.modelPar_given_CFDL=mod.given("CFDL");
modParamMap["CFDL"] = &(modelStruct.d_modelPar_CFDL_dX);
modelStruct.modelPar_CFDLB=mod.CFDLB;
modelStruct.d_modelPar_CFDLB_dX=0.0;
modelStruct.modelPar_given_CFDLB=mod.given("CFDLB");
modParamMap["CFDLB"] = &(modelStruct.d_modelPar_CFDLB_dX);
modelStruct.modelPar_BETN=mod.BETN;
modelStruct.d_modelPar_BETN_dX=0.0;
modelStruct.modelPar_given_BETN=mod.given("BETN");
modParamMap["BETN"] = &(modelStruct.d_modelPar_BETN_dX);
modelStruct.modelPar_BETNB=mod.BETNB;
modelStruct.d_modelPar_BETNB_dX=0.0;
modelStruct.modelPar_given_BETNB=mod.given("BETNB");
modParamMap["BETNB"] = &(modelStruct.d_modelPar_BETNB_dX);
modelStruct.modelPar_STBET=mod.STBET;
modelStruct.d_modelPar_STBET_dX=0.0;
modelStruct.modelPar_given_STBET=mod.given("STBET");
modParamMap["STBET"] = &(modelStruct.d_modelPar_STBET_dX);
modelStruct.modelPar_CS=mod.CS;
modelStruct.d_modelPar_CS_dX=0.0;
modelStruct.modelPar_given_CS=mod.given("CS");
modParamMap["CS"] = &(modelStruct.d_modelPar_CS_dX);
modelStruct.modelPar_CSFI=mod.CSFI;
modelStruct.d_modelPar_CSFI_dX=0.0;
modelStruct.modelPar_given_CSFI=mod.given("CSFI");
modParamMap["CSFI"] = &(modelStruct.d_modelPar_CSFI_dX);
modelStruct.modelPar_CSBI=mod.CSBI;
modelStruct.d_modelPar_CSBI_dX=0.0;
modelStruct.modelPar_given_CSBI=mod.given("CSBI");
modParamMap["CSBI"] = &(modelStruct.d_modelPar_CSBI_dX);
modelStruct.modelPar_STCS=mod.STCS;
modelStruct.d_modelPar_STCS_dX=0.0;
modelStruct.modelPar_given_STCS=mod.given("STCS");
modParamMap["STCS"] = &(modelStruct.d_modelPar_STCS_dX);
modelStruct.modelPar_THECS=mod.THECS;
modelStruct.d_modelPar_THECS_dX=0.0;
modelStruct.modelPar_given_THECS=mod.given("THECS");
modParamMap["THECS"] = &(modelStruct.d_modelPar_THECS_dX);
modelStruct.modelPar_STTHECS=mod.STTHECS;
modelStruct.d_modelPar_STTHECS_dX=0.0;
modelStruct.modelPar_given_STTHECS=mod.given("STTHECS");
modParamMap["STTHECS"] = &(modelStruct.d_modelPar_STTHECS_dX);
modelStruct.modelPar_CSTHR=mod.CSTHR;
modelStruct.d_modelPar_CSTHR_dX=0.0;
modelStruct.modelPar_given_CSTHR=mod.given("CSTHR");
modParamMap["CSTHR"] = &(modelStruct.d_modelPar_CSTHR_dX);
modelStruct.modelPar_CSTHRB=mod.CSTHRB;
modelStruct.d_modelPar_CSTHRB_dX=0.0;
modelStruct.modelPar_given_CSTHRB=mod.given("CSTHRB");
modParamMap["CSTHRB"] = &(modelStruct.d_modelPar_CSTHRB_dX);
modelStruct.modelPar_MUE=mod.MUE;
modelStruct.d_modelPar_MUE_dX=0.0;
modelStruct.modelPar_given_MUE=mod.given("MUE");
modParamMap["MUE"] = &(modelStruct.d_modelPar_MUE_dX);
modelStruct.modelPar_STMUE=mod.STMUE;
modelStruct.d_modelPar_STMUE_dX=0.0;
modelStruct.modelPar_given_STMUE=mod.given("STMUE");
modParamMap["STMUE"] = &(modelStruct.d_modelPar_STMUE_dX);
modelStruct.modelPar_THEMU=mod.THEMU;
modelStruct.d_modelPar_THEMU_dX=0.0;
modelStruct.modelPar_given_THEMU=mod.given("THEMU");
modParamMap["THEMU"] = &(modelStruct.d_modelPar_THEMU_dX);
modelStruct.modelPar_STTHEMU=mod.STTHEMU;
modelStruct.d_modelPar_STTHEMU_dX=0.0;
modelStruct.modelPar_given_STTHEMU=mod.given("STTHEMU");
modParamMap["STTHEMU"] = &(modelStruct.d_modelPar_STTHEMU_dX);
modelStruct.modelPar_XCOR=mod.XCOR;
modelStruct.d_modelPar_XCOR_dX=0.0;
modelStruct.modelPar_given_XCOR=mod.given("XCOR");
modParamMap["XCOR"] = &(modelStruct.d_modelPar_XCOR_dX);
modelStruct.modelPar_XCORB=mod.XCORB;
modelStruct.d_modelPar_XCORB_dX=0.0;
modelStruct.modelPar_given_XCORB=mod.given("XCORB");
modParamMap["XCORB"] = &(modelStruct.d_modelPar_XCORB_dX);
modelStruct.modelPar_STXCOR=mod.STXCOR;
modelStruct.d_modelPar_STXCOR_dX=0.0;
modelStruct.modelPar_given_STXCOR=mod.given("STXCOR");
modParamMap["STXCOR"] = &(modelStruct.d_modelPar_STXCOR_dX);
modelStruct.modelPar_FETA=mod.FETA;
modelStruct.d_modelPar_FETA_dX=0.0;
modelStruct.modelPar_given_FETA=mod.given("FETA");
modParamMap["FETA"] = &(modelStruct.d_modelPar_FETA_dX);
modelStruct.modelPar_RS=mod.RS;
modelStruct.d_modelPar_RS_dX=0.0;
modelStruct.modelPar_given_RS=mod.given("RS");
modParamMap["RS"] = &(modelStruct.d_modelPar_RS_dX);
modelStruct.modelPar_RSIG=mod.RSIG;
modelStruct.d_modelPar_RSIG_dX=0.0;
modelStruct.modelPar_given_RSIG=mod.given("RSIG");
modParamMap["RSIG"] = &(modelStruct.d_modelPar_RSIG_dX);
modelStruct.modelPar_STRS=mod.STRS;
modelStruct.d_modelPar_STRS_dX=0.0;
modelStruct.modelPar_given_STRS=mod.given("STRS");
modParamMap["STRS"] = &(modelStruct.d_modelPar_STRS_dX);
modelStruct.modelPar_RSG=mod.RSG;
modelStruct.d_modelPar_RSG_dX=0.0;
modelStruct.modelPar_given_RSG=mod.given("RSG");
modParamMap["RSG"] = &(modelStruct.d_modelPar_RSG_dX);
modelStruct.modelPar_THERSG=mod.THERSG;
modelStruct.d_modelPar_THERSG_dX=0.0;
modelStruct.modelPar_given_THERSG=mod.given("THERSG");
modParamMap["THERSG"] = &(modelStruct.d_modelPar_THERSG_dX);
modelStruct.modelPar_RSB=mod.RSB;
modelStruct.d_modelPar_RSB_dX=0.0;
modelStruct.modelPar_given_RSB=mod.given("RSB");
modParamMap["RSB"] = &(modelStruct.d_modelPar_RSB_dX);
modelStruct.modelPar_THESAT=mod.THESAT;
modelStruct.d_modelPar_THESAT_dX=0.0;
modelStruct.modelPar_given_THESAT=mod.given("THESAT");
modParamMap["THESAT"] = &(modelStruct.d_modelPar_THESAT_dX);
modelStruct.modelPar_STTHESAT=mod.STTHESAT;
modelStruct.d_modelPar_STTHESAT_dX=0.0;
modelStruct.modelPar_given_STTHESAT=mod.given("STTHESAT");
modParamMap["STTHESAT"] = &(modelStruct.d_modelPar_STTHESAT_dX);
modelStruct.modelPar_THESATG=mod.THESATG;
modelStruct.d_modelPar_THESATG_dX=0.0;
modelStruct.modelPar_given_THESATG=mod.given("THESATG");
modParamMap["THESATG"] = &(modelStruct.d_modelPar_THESATG_dX);
modelStruct.modelPar_THESATB=mod.THESATB;
modelStruct.d_modelPar_THESATB_dX=0.0;
modelStruct.modelPar_given_THESATB=mod.given("THESATB");
modParamMap["THESATB"] = &(modelStruct.d_modelPar_THESATB_dX);
modelStruct.modelPar_AX=mod.AX;
modelStruct.d_modelPar_AX_dX=0.0;
modelStruct.modelPar_given_AX=mod.given("AX");
modParamMap["AX"] = &(modelStruct.d_modelPar_AX_dX);
modelStruct.modelPar_ALP=mod.ALP;
modelStruct.d_modelPar_ALP_dX=0.0;
modelStruct.modelPar_given_ALP=mod.given("ALP");
modParamMap["ALP"] = &(modelStruct.d_modelPar_ALP_dX);
modelStruct.modelPar_ALP1=mod.ALP1;
modelStruct.d_modelPar_ALP1_dX=0.0;
modelStruct.modelPar_given_ALP1=mod.given("ALP1");
modParamMap["ALP1"] = &(modelStruct.d_modelPar_ALP1_dX);
modelStruct.modelPar_ALPB=mod.ALPB;
modelStruct.d_modelPar_ALPB_dX=0.0;
modelStruct.modelPar_given_ALPB=mod.given("ALPB");
modParamMap["ALPB"] = &(modelStruct.d_modelPar_ALPB_dX);
modelStruct.modelPar_VP=mod.VP;
modelStruct.d_modelPar_VP_dX=0.0;
modelStruct.modelPar_given_VP=mod.given("VP");
modParamMap["VP"] = &(modelStruct.d_modelPar_VP_dX);
modelStruct.modelPar_VPG=mod.VPG;
modelStruct.d_modelPar_VPG_dX=0.0;
modelStruct.modelPar_given_VPG=mod.given("VPG");
modParamMap["VPG"] = &(modelStruct.d_modelPar_VPG_dX);
modelStruct.modelPar_GCO=mod.GCO;
modelStruct.d_modelPar_GCO_dX=0.0;
modelStruct.modelPar_given_GCO=mod.given("GCO");
modParamMap["GCO"] = &(modelStruct.d_modelPar_GCO_dX);
modelStruct.modelPar_IGINV=mod.IGINV;
modelStruct.d_modelPar_IGINV_dX=0.0;
modelStruct.modelPar_given_IGINV=mod.given("IGINV");
modParamMap["IGINV"] = &(modelStruct.d_modelPar_IGINV_dX);
modelStruct.modelPar_IGOVINV=mod.IGOVINV;
modelStruct.d_modelPar_IGOVINV_dX=0.0;
modelStruct.modelPar_given_IGOVINV=mod.given("IGOVINV");
modParamMap["IGOVINV"] = &(modelStruct.d_modelPar_IGOVINV_dX);
modelStruct.modelPar_IGOVINVD=mod.IGOVINVD;
modelStruct.d_modelPar_IGOVINVD_dX=0.0;
modelStruct.modelPar_given_IGOVINVD=mod.given("IGOVINVD");
modParamMap["IGOVINVD"] = &(modelStruct.d_modelPar_IGOVINVD_dX);
modelStruct.modelPar_IGOVACC=mod.IGOVACC;
modelStruct.d_modelPar_IGOVACC_dX=0.0;
modelStruct.modelPar_given_IGOVACC=mod.given("IGOVACC");
modParamMap["IGOVACC"] = &(modelStruct.d_modelPar_IGOVACC_dX);
modelStruct.modelPar_IGOVACCD=mod.IGOVACCD;
modelStruct.d_modelPar_IGOVACCD_dX=0.0;
modelStruct.modelPar_given_IGOVACCD=mod.given("IGOVACCD");
modParamMap["IGOVACCD"] = &(modelStruct.d_modelPar_IGOVACCD_dX);
modelStruct.modelPar_STIG=mod.STIG;
modelStruct.d_modelPar_STIG_dX=0.0;
modelStruct.modelPar_given_STIG=mod.given("STIG");
modParamMap["STIG"] = &(modelStruct.d_modelPar_STIG_dX);
modelStruct.modelPar_GC2CH=mod.GC2CH;
modelStruct.d_modelPar_GC2CH_dX=0.0;
modelStruct.modelPar_given_GC2CH=mod.given("GC2CH");
modParamMap["GC2CH"] = &(modelStruct.d_modelPar_GC2CH_dX);
modelStruct.modelPar_GC3CH=mod.GC3CH;
modelStruct.d_modelPar_GC3CH_dX=0.0;
modelStruct.modelPar_given_GC3CH=mod.given("GC3CH");
modParamMap["GC3CH"] = &(modelStruct.d_modelPar_GC3CH_dX);
modelStruct.modelPar_GC2OVINV=mod.GC2OVINV;
modelStruct.d_modelPar_GC2OVINV_dX=0.0;
modelStruct.modelPar_given_GC2OVINV=mod.given("GC2OVINV");
modParamMap["GC2OVINV"] = &(modelStruct.d_modelPar_GC2OVINV_dX);
modelStruct.modelPar_GC3OVINV=mod.GC3OVINV;
modelStruct.d_modelPar_GC3OVINV_dX=0.0;
modelStruct.modelPar_given_GC3OVINV=mod.given("GC3OVINV");
modParamMap["GC3OVINV"] = &(modelStruct.d_modelPar_GC3OVINV_dX);
modelStruct.modelPar_GC2OVACC=mod.GC2OVACC;
modelStruct.d_modelPar_GC2OVACC_dX=0.0;
modelStruct.modelPar_given_GC2OVACC=mod.given("GC2OVACC");
modParamMap["GC2OVACC"] = &(modelStruct.d_modelPar_GC2OVACC_dX);
modelStruct.modelPar_GC3OVACC=mod.GC3OVACC;
modelStruct.d_modelPar_GC3OVACC_dX=0.0;
modelStruct.modelPar_given_GC3OVACC=mod.given("GC3OVACC");
modParamMap["GC3OVACC"] = &(modelStruct.d_modelPar_GC3OVACC_dX);
modelStruct.modelPar_GCDOV=mod.GCDOV;
modelStruct.d_modelPar_GCDOV_dX=0.0;
modelStruct.modelPar_given_GCDOV=mod.given("GCDOV");
modParamMap["GCDOV"] = &(modelStruct.d_modelPar_GCDOV_dX);
modelStruct.modelPar_GCVDOV=mod.GCVDOV;
modelStruct.d_modelPar_GCVDOV_dX=0.0;
modelStruct.modelPar_given_GCVDOV=mod.given("GCVDOV");
modParamMap["GCVDOV"] = &(modelStruct.d_modelPar_GCVDOV_dX);
modelStruct.modelPar_CHIB=mod.CHIB;
modelStruct.d_modelPar_CHIB_dX=0.0;
modelStruct.modelPar_given_CHIB=mod.given("CHIB");
modParamMap["CHIB"] = &(modelStruct.d_modelPar_CHIB_dX);
modelStruct.modelPar_NIGINV=mod.NIGINV;
modelStruct.d_modelPar_NIGINV_dX=0.0;
modelStruct.modelPar_given_NIGINV=mod.given("NIGINV");
modParamMap["NIGINV"] = &(modelStruct.d_modelPar_NIGINV_dX);
modelStruct.modelPar_FNOVINV=mod.FNOVINV;
modelStruct.d_modelPar_FNOVINV_dX=0.0;
modelStruct.modelPar_given_FNOVINV=mod.given("FNOVINV");
modParamMap["FNOVINV"] = &(modelStruct.d_modelPar_FNOVINV_dX);
modelStruct.modelPar_FNOVINVD=mod.FNOVINVD;
modelStruct.d_modelPar_FNOVINVD_dX=0.0;
modelStruct.modelPar_given_FNOVINVD=mod.given("FNOVINVD");
modParamMap["FNOVINVD"] = &(modelStruct.d_modelPar_FNOVINVD_dX);
modelStruct.modelPar_GCOVINVFN=mod.GCOVINVFN;
modelStruct.d_modelPar_GCOVINVFN_dX=0.0;
modelStruct.modelPar_given_GCOVINVFN=mod.given("GCOVINVFN");
modParamMap["GCOVINVFN"] = &(modelStruct.d_modelPar_GCOVINVFN_dX);
modelStruct.modelPar_STIGFN=mod.STIGFN;
modelStruct.d_modelPar_STIGFN_dX=0.0;
modelStruct.modelPar_given_STIGFN=mod.given("STIGFN");
modParamMap["STIGFN"] = &(modelStruct.d_modelPar_STIGFN_dX);
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modParamMap["AGIDL"] = &(modelStruct.d_modelPar_AGIDL_dX);
modelStruct.modelPar_AGIDLD=mod.AGIDLD;
modelStruct.d_modelPar_AGIDLD_dX=0.0;
modelStruct.modelPar_given_AGIDLD=mod.given("AGIDLD");
modParamMap["AGIDLD"] = &(modelStruct.d_modelPar_AGIDLD_dX);
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modParamMap["BGIDL"] = &(modelStruct.d_modelPar_BGIDL_dX);
modelStruct.modelPar_BGIDLD=mod.BGIDLD;
modelStruct.d_modelPar_BGIDLD_dX=0.0;
modelStruct.modelPar_given_BGIDLD=mod.given("BGIDLD");
modParamMap["BGIDLD"] = &(modelStruct.d_modelPar_BGIDLD_dX);
modelStruct.modelPar_STBGIDL=mod.STBGIDL;
modelStruct.d_modelPar_STBGIDL_dX=0.0;
modelStruct.modelPar_given_STBGIDL=mod.given("STBGIDL");
modParamMap["STBGIDL"] = &(modelStruct.d_modelPar_STBGIDL_dX);
modelStruct.modelPar_STBGIDLD=mod.STBGIDLD;
modelStruct.d_modelPar_STBGIDLD_dX=0.0;
modelStruct.modelPar_given_STBGIDLD=mod.given("STBGIDLD");
modParamMap["STBGIDLD"] = &(modelStruct.d_modelPar_STBGIDLD_dX);
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modParamMap["CGIDL"] = &(modelStruct.d_modelPar_CGIDL_dX);
modelStruct.modelPar_CGIDLD=mod.CGIDLD;
modelStruct.d_modelPar_CGIDLD_dX=0.0;
modelStruct.modelPar_given_CGIDLD=mod.given("CGIDLD");
modParamMap["CGIDLD"] = &(modelStruct.d_modelPar_CGIDLD_dX);
modelStruct.modelPar_DGIDL=mod.DGIDL;
modelStruct.d_modelPar_DGIDL_dX=0.0;
modelStruct.modelPar_given_DGIDL=mod.given("DGIDL");
modParamMap["DGIDL"] = &(modelStruct.d_modelPar_DGIDL_dX);
modelStruct.modelPar_DGIDLD=mod.DGIDLD;
modelStruct.d_modelPar_DGIDLD_dX=0.0;
modelStruct.modelPar_given_DGIDLD=mod.given("DGIDLD");
modParamMap["DGIDLD"] = &(modelStruct.d_modelPar_DGIDLD_dX);
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modParamMap["A1"] = &(modelStruct.d_modelPar_A1_dX);
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modParamMap["A2"] = &(modelStruct.d_modelPar_A2_dX);
modelStruct.modelPar_STA2=mod.STA2;
modelStruct.d_modelPar_STA2_dX=0.0;
modelStruct.modelPar_given_STA2=mod.given("STA2");
modParamMap["STA2"] = &(modelStruct.d_modelPar_STA2_dX);
modelStruct.modelPar_A3=mod.A3;
modelStruct.d_modelPar_A3_dX=0.0;
modelStruct.modelPar_given_A3=mod.given("A3");
modParamMap["A3"] = &(modelStruct.d_modelPar_A3_dX);
modelStruct.modelPar_AREAQ=mod.AREAQ;
modelStruct.d_modelPar_AREAQ_dX=0.0;
modelStruct.modelPar_given_AREAQ=mod.given("AREAQ");
modParamMap["AREAQ"] = &(modelStruct.d_modelPar_AREAQ_dX);
modelStruct.modelPar_CGBOV=mod.CGBOV;
modelStruct.d_modelPar_CGBOV_dX=0.0;
modelStruct.modelPar_given_CGBOV=mod.given("CGBOV");
modParamMap["CGBOV"] = &(modelStruct.d_modelPar_CGBOV_dX);
modelStruct.modelPar_NSDAC=mod.NSDAC;
modelStruct.d_modelPar_NSDAC_dX=0.0;
modelStruct.modelPar_given_NSDAC=mod.given("NSDAC");
modParamMap["NSDAC"] = &(modelStruct.d_modelPar_NSDAC_dX);
modelStruct.modelPar_FIF=mod.FIF;
modelStruct.d_modelPar_FIF_dX=0.0;
modelStruct.modelPar_given_FIF=mod.given("FIF");
modParamMap["FIF"] = &(modelStruct.d_modelPar_FIF_dX);
modelStruct.modelPar_FSCEAC=mod.FSCEAC;
modelStruct.d_modelPar_FSCEAC_dX=0.0;
modelStruct.modelPar_given_FSCEAC=mod.given("FSCEAC");
modParamMap["FSCEAC"] = &(modelStruct.d_modelPar_FSCEAC_dX);
modelStruct.modelPar_COV=mod.COV;
modelStruct.d_modelPar_COV_dX=0.0;
modelStruct.modelPar_given_COV=mod.given("COV");
modParamMap["COV"] = &(modelStruct.d_modelPar_COV_dX);
modelStruct.modelPar_COVD=mod.COVD;
modelStruct.d_modelPar_COVD_dX=0.0;
modelStruct.modelPar_given_COVD=mod.given("COVD");
modParamMap["COVD"] = &(modelStruct.d_modelPar_COVD_dX);
modelStruct.modelPar_COVDL=mod.COVDL;
modelStruct.d_modelPar_COVDL_dX=0.0;
modelStruct.modelPar_given_COVDL=mod.given("COVDL");
modParamMap["COVDL"] = &(modelStruct.d_modelPar_COVDL_dX);
modelStruct.modelPar_COVDLB=mod.COVDLB;
modelStruct.d_modelPar_COVDLB_dX=0.0;
modelStruct.modelPar_given_COVDLB=mod.given("COVDLB");
modParamMap["COVDLB"] = &(modelStruct.d_modelPar_COVDLB_dX);
modelStruct.modelPar_DVFBOV=mod.DVFBOV;
modelStruct.d_modelPar_DVFBOV_dX=0.0;
modelStruct.modelPar_given_DVFBOV=mod.given("DVFBOV");
modParamMap["DVFBOV"] = &(modelStruct.d_modelPar_DVFBOV_dX);
modelStruct.modelPar_CFR=mod.CFR;
modelStruct.d_modelPar_CFR_dX=0.0;
modelStruct.modelPar_given_CFR=mod.given("CFR");
modParamMap["CFR"] = &(modelStruct.d_modelPar_CFR_dX);
modelStruct.modelPar_CFRD=mod.CFRD;
modelStruct.d_modelPar_CFRD_dX=0.0;
modelStruct.modelPar_given_CFRD=mod.given("CFRD");
modParamMap["CFRD"] = &(modelStruct.d_modelPar_CFRD_dX);
modelStruct.modelPar_CSD=mod.CSD;
modelStruct.d_modelPar_CSD_dX=0.0;
modelStruct.modelPar_given_CSD=mod.given("CSD");
modParamMap["CSD"] = &(modelStruct.d_modelPar_CSD_dX);
modelStruct.modelPar_CSDBP=mod.CSDBP;
modelStruct.d_modelPar_CSDBP_dX=0.0;
modelStruct.modelPar_given_CSDBP=mod.given("CSDBP");
modParamMap["CSDBP"] = &(modelStruct.d_modelPar_CSDBP_dX);
modelStruct.modelPar_RTH=mod.RTH;
modelStruct.d_modelPar_RTH_dX=0.0;
modelStruct.modelPar_given_RTH=mod.given("RTH");
modParamMap["RTH"] = &(modelStruct.d_modelPar_RTH_dX);
modelStruct.modelPar_STRTH=mod.STRTH;
modelStruct.d_modelPar_STRTH_dX=0.0;
modelStruct.modelPar_given_STRTH=mod.given("STRTH");
modParamMap["STRTH"] = &(modelStruct.d_modelPar_STRTH_dX);
modelStruct.modelPar_CTH=mod.CTH;
modelStruct.d_modelPar_CTH_dX=0.0;
modelStruct.modelPar_given_CTH=mod.given("CTH");
modParamMap["CTH"] = &(modelStruct.d_modelPar_CTH_dX);
modelStruct.modelPar_FNT=mod.FNT;
modelStruct.d_modelPar_FNT_dX=0.0;
modelStruct.modelPar_given_FNT=mod.given("FNT");
modParamMap["FNT"] = &(modelStruct.d_modelPar_FNT_dX);
modelStruct.modelPar_FNTEXC=mod.FNTEXC;
modelStruct.d_modelPar_FNTEXC_dX=0.0;
modelStruct.modelPar_given_FNTEXC=mod.given("FNTEXC");
modParamMap["FNTEXC"] = &(modelStruct.d_modelPar_FNTEXC_dX);
modelStruct.modelPar_NFA=mod.NFA;
modelStruct.d_modelPar_NFA_dX=0.0;
modelStruct.modelPar_given_NFA=mod.given("NFA");
modParamMap["NFA"] = &(modelStruct.d_modelPar_NFA_dX);
modelStruct.modelPar_NFB=mod.NFB;
modelStruct.d_modelPar_NFB_dX=0.0;
modelStruct.modelPar_given_NFB=mod.given("NFB");
modParamMap["NFB"] = &(modelStruct.d_modelPar_NFB_dX);
modelStruct.modelPar_NFC=mod.NFC;
modelStruct.d_modelPar_NFC_dX=0.0;
modelStruct.modelPar_given_NFC=mod.given("NFC");
modParamMap["NFC"] = &(modelStruct.d_modelPar_NFC_dX);
modelStruct.modelPar_NFE=mod.NFE;
modelStruct.d_modelPar_NFE_dX=0.0;
modelStruct.modelPar_given_NFE=mod.given("NFE");
modParamMap["NFE"] = &(modelStruct.d_modelPar_NFE_dX);
modelStruct.modelPar_NFEB=mod.NFEB;
modelStruct.d_modelPar_NFEB_dX=0.0;
modelStruct.modelPar_given_NFEB=mod.given("NFEB");
modParamMap["NFEB"] = &(modelStruct.d_modelPar_NFEB_dX);
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modParamMap["EF"] = &(modelStruct.d_modelPar_EF_dX);
modelStruct.modelPar_LVARO=mod.LVARO;
modelStruct.d_modelPar_LVARO_dX=0.0;
modelStruct.modelPar_given_LVARO=mod.given("LVARO");
modParamMap["LVARO"] = &(modelStruct.d_modelPar_LVARO_dX);
modelStruct.modelPar_LVARL=mod.LVARL;
modelStruct.d_modelPar_LVARL_dX=0.0;
modelStruct.modelPar_given_LVARL=mod.given("LVARL");
modParamMap["LVARL"] = &(modelStruct.d_modelPar_LVARL_dX);
modelStruct.modelPar_LVARW=mod.LVARW;
modelStruct.d_modelPar_LVARW_dX=0.0;
modelStruct.modelPar_given_LVARW=mod.given("LVARW");
modParamMap["LVARW"] = &(modelStruct.d_modelPar_LVARW_dX);
modelStruct.modelPar_LAP=mod.LAP;
modelStruct.d_modelPar_LAP_dX=0.0;
modelStruct.modelPar_given_LAP=mod.given("LAP");
modParamMap["LAP"] = &(modelStruct.d_modelPar_LAP_dX);
modelStruct.modelPar_WVARO=mod.WVARO;
modelStruct.d_modelPar_WVARO_dX=0.0;
modelStruct.modelPar_given_WVARO=mod.given("WVARO");
modParamMap["WVARO"] = &(modelStruct.d_modelPar_WVARO_dX);
modelStruct.modelPar_WVARL=mod.WVARL;
modelStruct.d_modelPar_WVARL_dX=0.0;
modelStruct.modelPar_given_WVARL=mod.given("WVARL");
modParamMap["WVARL"] = &(modelStruct.d_modelPar_WVARL_dX);
modelStruct.modelPar_WVARW=mod.WVARW;
modelStruct.d_modelPar_WVARW_dX=0.0;
modelStruct.modelPar_given_WVARW=mod.given("WVARW");
modParamMap["WVARW"] = &(modelStruct.d_modelPar_WVARW_dX);
modelStruct.modelPar_WOT=mod.WOT;
modelStruct.d_modelPar_WOT_dX=0.0;
modelStruct.modelPar_given_WOT=mod.given("WOT");
modParamMap["WOT"] = &(modelStruct.d_modelPar_WOT_dX);
modelStruct.modelPar_DLQ=mod.DLQ;
modelStruct.d_modelPar_DLQ_dX=0.0;
modelStruct.modelPar_given_DLQ=mod.given("DLQ");
modParamMap["DLQ"] = &(modelStruct.d_modelPar_DLQ_dX);
modelStruct.modelPar_DWQ=mod.DWQ;
modelStruct.d_modelPar_DWQ_dX=0.0;
modelStruct.modelPar_given_DWQ=mod.given("DWQ");
modParamMap["DWQ"] = &(modelStruct.d_modelPar_DWQ_dX);
modelStruct.modelPar_TOXEO=mod.TOXEO;
modelStruct.d_modelPar_TOXEO_dX=0.0;
modelStruct.modelPar_given_TOXEO=mod.given("TOXEO");
modParamMap["TOXEO"] = &(modelStruct.d_modelPar_TOXEO_dX);
modelStruct.modelPar_TSIO=mod.TSIO;
modelStruct.d_modelPar_TSIO_dX=0.0;
modelStruct.modelPar_given_TSIO=mod.given("TSIO");
modParamMap["TSIO"] = &(modelStruct.d_modelPar_TSIO_dX);
modelStruct.modelPar_XGEO=mod.XGEO;
modelStruct.d_modelPar_XGEO_dX=0.0;
modelStruct.modelPar_given_XGEO=mod.given("XGEO");
modParamMap["XGEO"] = &(modelStruct.d_modelPar_XGEO_dX);
modelStruct.modelPar_TBOXO=mod.TBOXO;
modelStruct.d_modelPar_TBOXO_dX=0.0;
modelStruct.modelPar_given_TBOXO=mod.given("TBOXO");
modParamMap["TBOXO"] = &(modelStruct.d_modelPar_TBOXO_dX);
modelStruct.modelPar_NCHO=mod.NCHO;
modelStruct.d_modelPar_NCHO_dX=0.0;
modelStruct.modelPar_given_NCHO=mod.given("NCHO");
modParamMap["NCHO"] = &(modelStruct.d_modelPar_NCHO_dX);
modelStruct.modelPar_NSUBO=mod.NSUBO;
modelStruct.d_modelPar_NSUBO_dX=0.0;
modelStruct.modelPar_given_NSUBO=mod.given("NSUBO");
modParamMap["NSUBO"] = &(modelStruct.d_modelPar_NSUBO_dX);
modelStruct.modelPar_CTO=mod.CTO;
modelStruct.d_modelPar_CTO_dX=0.0;
modelStruct.modelPar_given_CTO=mod.given("CTO");
modParamMap["CTO"] = &(modelStruct.d_modelPar_CTO_dX);
modelStruct.modelPar_TOXPO=mod.TOXPO;
modelStruct.d_modelPar_TOXPO_dX=0.0;
modelStruct.modelPar_given_TOXPO=mod.given("TOXPO");
modParamMap["TOXPO"] = &(modelStruct.d_modelPar_TOXPO_dX);
modelStruct.modelPar_NOVO=mod.NOVO;
modelStruct.d_modelPar_NOVO_dX=0.0;
modelStruct.modelPar_given_NOVO=mod.given("NOVO");
modParamMap["NOVO"] = &(modelStruct.d_modelPar_NOVO_dX);
modelStruct.modelPar_NOVDO=mod.NOVDO;
modelStruct.d_modelPar_NOVDO_dX=0.0;
modelStruct.modelPar_given_NOVDO=mod.given("NOVDO");
modParamMap["NOVDO"] = &(modelStruct.d_modelPar_NOVDO_dX);
modelStruct.modelPar_VFBO=mod.VFBO;
modelStruct.d_modelPar_VFBO_dX=0.0;
modelStruct.modelPar_given_VFBO=mod.given("VFBO");
modParamMap["VFBO"] = &(modelStruct.d_modelPar_VFBO_dX);
modelStruct.modelPar_VFBL=mod.VFBL;
modelStruct.d_modelPar_VFBL_dX=0.0;
modelStruct.modelPar_given_VFBL=mod.given("VFBL");
modParamMap["VFBL"] = &(modelStruct.d_modelPar_VFBL_dX);
modelStruct.modelPar_VFBLEXP=mod.VFBLEXP;
modelStruct.d_modelPar_VFBLEXP_dX=0.0;
modelStruct.modelPar_given_VFBLEXP=mod.given("VFBLEXP");
modParamMap["VFBLEXP"] = &(modelStruct.d_modelPar_VFBLEXP_dX);
modelStruct.modelPar_VFBL2=mod.VFBL2;
modelStruct.d_modelPar_VFBL2_dX=0.0;
modelStruct.modelPar_given_VFBL2=mod.given("VFBL2");
modParamMap["VFBL2"] = &(modelStruct.d_modelPar_VFBL2_dX);
modelStruct.modelPar_VFBLEXP2=mod.VFBLEXP2;
modelStruct.d_modelPar_VFBLEXP2_dX=0.0;
modelStruct.modelPar_given_VFBLEXP2=mod.given("VFBLEXP2");
modParamMap["VFBLEXP2"] = &(modelStruct.d_modelPar_VFBLEXP2_dX);
modelStruct.modelPar_VFBW=mod.VFBW;
modelStruct.d_modelPar_VFBW_dX=0.0;
modelStruct.modelPar_given_VFBW=mod.given("VFBW");
modParamMap["VFBW"] = &(modelStruct.d_modelPar_VFBW_dX);
modelStruct.modelPar_VFBLW=mod.VFBLW;
modelStruct.d_modelPar_VFBLW_dX=0.0;
modelStruct.modelPar_given_VFBLW=mod.given("VFBLW");
modParamMap["VFBLW"] = &(modelStruct.d_modelPar_VFBLW_dX);
modelStruct.modelPar_VFBBO=mod.VFBBO;
modelStruct.d_modelPar_VFBBO_dX=0.0;
modelStruct.modelPar_given_VFBBO=mod.given("VFBBO");
modParamMap["VFBBO"] = &(modelStruct.d_modelPar_VFBBO_dX);
modelStruct.modelPar_VFBLBO=mod.VFBLBO;
modelStruct.d_modelPar_VFBLBO_dX=0.0;
modelStruct.modelPar_given_VFBLBO=mod.given("VFBLBO");
modParamMap["VFBLBO"] = &(modelStruct.d_modelPar_VFBLBO_dX);
modelStruct.modelPar_STVFBO=mod.STVFBO;
modelStruct.d_modelPar_STVFBO_dX=0.0;
modelStruct.modelPar_given_STVFBO=mod.given("STVFBO");
modParamMap["STVFBO"] = &(modelStruct.d_modelPar_STVFBO_dX);
modelStruct.modelPar_STVFBL=mod.STVFBL;
modelStruct.d_modelPar_STVFBL_dX=0.0;
modelStruct.modelPar_given_STVFBL=mod.given("STVFBL");
modParamMap["STVFBL"] = &(modelStruct.d_modelPar_STVFBL_dX);
modelStruct.modelPar_STVFBW=mod.STVFBW;
modelStruct.d_modelPar_STVFBW_dX=0.0;
modelStruct.modelPar_given_STVFBW=mod.given("STVFBW");
modParamMap["STVFBW"] = &(modelStruct.d_modelPar_STVFBW_dX);
modelStruct.modelPar_STVFBLW=mod.STVFBLW;
modelStruct.d_modelPar_STVFBLW_dX=0.0;
modelStruct.modelPar_given_STVFBLW=mod.given("STVFBLW");
modParamMap["STVFBLW"] = &(modelStruct.d_modelPar_STVFBLW_dX);
modelStruct.modelPar_CICFO=mod.CICFO;
modelStruct.d_modelPar_CICFO_dX=0.0;
modelStruct.modelPar_given_CICFO=mod.given("CICFO");
modParamMap["CICFO"] = &(modelStruct.d_modelPar_CICFO_dX);
modelStruct.modelPar_CICO=mod.CICO;
modelStruct.d_modelPar_CICO_dX=0.0;
modelStruct.modelPar_given_CICO=mod.given("CICO");
modParamMap["CICO"] = &(modelStruct.d_modelPar_CICO_dX);
modelStruct.modelPar_PSCEL=mod.PSCEL;
modelStruct.d_modelPar_PSCEL_dX=0.0;
modelStruct.modelPar_given_PSCEL=mod.given("PSCEL");
modParamMap["PSCEL"] = &(modelStruct.d_modelPar_PSCEL_dX);
modelStruct.modelPar_PSCELEXP=mod.PSCELEXP;
modelStruct.d_modelPar_PSCELEXP_dX=0.0;
modelStruct.modelPar_given_PSCELEXP=mod.given("PSCELEXP");
modParamMap["PSCELEXP"] = &(modelStruct.d_modelPar_PSCELEXP_dX);
modelStruct.modelPar_PSCEW=mod.PSCEW;
modelStruct.d_modelPar_PSCEW_dX=0.0;
modelStruct.modelPar_given_PSCEW=mod.given("PSCEW");
modParamMap["PSCEW"] = &(modelStruct.d_modelPar_PSCEW_dX);
modelStruct.modelPar_PSCEBO=mod.PSCEBO;
modelStruct.d_modelPar_PSCEBO_dX=0.0;
modelStruct.modelPar_given_PSCEBO=mod.given("PSCEBO");
modParamMap["PSCEBO"] = &(modelStruct.d_modelPar_PSCEBO_dX);
modelStruct.modelPar_NSDDCO=mod.NSDDCO;
modelStruct.d_modelPar_NSDDCO_dX=0.0;
modelStruct.modelPar_given_NSDDCO=mod.given("NSDDCO");
modParamMap["NSDDCO"] = &(modelStruct.d_modelPar_NSDDCO_dX);
modelStruct.modelPar_PSCEDLBO=mod.PSCEDLBO;
modelStruct.d_modelPar_PSCEDLBO_dX=0.0;
modelStruct.modelPar_given_PSCEDLBO=mod.given("PSCEDLBO");
modParamMap["PSCEDLBO"] = &(modelStruct.d_modelPar_PSCEDLBO_dX);
modelStruct.modelPar_PNCEW=mod.PNCEW;
modelStruct.d_modelPar_PNCEW_dX=0.0;
modelStruct.modelPar_given_PNCEW=mod.given("PNCEW");
modParamMap["PNCEW"] = &(modelStruct.d_modelPar_PNCEW_dX);
modelStruct.modelPar_CFL=mod.CFL;
modelStruct.d_modelPar_CFL_dX=0.0;
modelStruct.modelPar_given_CFL=mod.given("CFL");
modParamMap["CFL"] = &(modelStruct.d_modelPar_CFL_dX);
modelStruct.modelPar_CFLEXP=mod.CFLEXP;
modelStruct.d_modelPar_CFLEXP_dX=0.0;
modelStruct.modelPar_given_CFLEXP=mod.given("CFLEXP");
modParamMap["CFLEXP"] = &(modelStruct.d_modelPar_CFLEXP_dX);
modelStruct.modelPar_CFW=mod.CFW;
modelStruct.d_modelPar_CFW_dX=0.0;
modelStruct.modelPar_given_CFW=mod.given("CFW");
modParamMap["CFW"] = &(modelStruct.d_modelPar_CFW_dX);
modelStruct.modelPar_CFBO=mod.CFBO;
modelStruct.d_modelPar_CFBO_dX=0.0;
modelStruct.modelPar_given_CFBO=mod.given("CFBO");
modParamMap["CFBO"] = &(modelStruct.d_modelPar_CFBO_dX);
modelStruct.modelPar_STCFL=mod.STCFL;
modelStruct.d_modelPar_STCFL_dX=0.0;
modelStruct.modelPar_given_STCFL=mod.given("STCFL");
modParamMap["STCFL"] = &(modelStruct.d_modelPar_STCFL_dX);
modelStruct.modelPar_CFDO=mod.CFDO;
modelStruct.d_modelPar_CFDO_dX=0.0;
modelStruct.modelPar_given_CFDO=mod.given("CFDO");
modParamMap["CFDO"] = &(modelStruct.d_modelPar_CFDO_dX);
modelStruct.modelPar_CFDLL=mod.CFDLL;
modelStruct.d_modelPar_CFDLL_dX=0.0;
modelStruct.modelPar_given_CFDLL=mod.given("CFDLL");
modParamMap["CFDLL"] = &(modelStruct.d_modelPar_CFDLL_dX);
modelStruct.modelPar_CFDLW=mod.CFDLW;
modelStruct.d_modelPar_CFDLW_dX=0.0;
modelStruct.modelPar_given_CFDLW=mod.given("CFDLW");
modParamMap["CFDLW"] = &(modelStruct.d_modelPar_CFDLW_dX);
modelStruct.modelPar_CFDLBO=mod.CFDLBO;
modelStruct.d_modelPar_CFDLBO_dX=0.0;
modelStruct.modelPar_given_CFDLBO=mod.given("CFDLBO");
modParamMap["CFDLBO"] = &(modelStruct.d_modelPar_CFDLBO_dX);
modelStruct.modelPar_UO=mod.UO;
modelStruct.d_modelPar_UO_dX=0.0;
modelStruct.modelPar_given_UO=mod.given("UO");
modParamMap["UO"] = &(modelStruct.d_modelPar_UO_dX);
modelStruct.modelPar_FBET1=mod.FBET1;
modelStruct.d_modelPar_FBET1_dX=0.0;
modelStruct.modelPar_given_FBET1=mod.given("FBET1");
modParamMap["FBET1"] = &(modelStruct.d_modelPar_FBET1_dX);
modelStruct.modelPar_FBET1W=mod.FBET1W;
modelStruct.d_modelPar_FBET1W_dX=0.0;
modelStruct.modelPar_given_FBET1W=mod.given("FBET1W");
modParamMap["FBET1W"] = &(modelStruct.d_modelPar_FBET1W_dX);
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modParamMap["LP1"] = &(modelStruct.d_modelPar_LP1_dX);
modelStruct.modelPar_LP1W=mod.LP1W;
modelStruct.d_modelPar_LP1W_dX=0.0;
modelStruct.modelPar_given_LP1W=mod.given("LP1W");
modParamMap["LP1W"] = &(modelStruct.d_modelPar_LP1W_dX);
modelStruct.modelPar_FBET2=mod.FBET2;
modelStruct.d_modelPar_FBET2_dX=0.0;
modelStruct.modelPar_given_FBET2=mod.given("FBET2");
modParamMap["FBET2"] = &(modelStruct.d_modelPar_FBET2_dX);
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modParamMap["LP2"] = &(modelStruct.d_modelPar_LP2_dX);
modelStruct.modelPar_BETW1=mod.BETW1;
modelStruct.d_modelPar_BETW1_dX=0.0;
modelStruct.modelPar_given_BETW1=mod.given("BETW1");
modParamMap["BETW1"] = &(modelStruct.d_modelPar_BETW1_dX);
modelStruct.modelPar_BETW2=mod.BETW2;
modelStruct.d_modelPar_BETW2_dX=0.0;
modelStruct.modelPar_given_BETW2=mod.given("BETW2");
modParamMap["BETW2"] = &(modelStruct.d_modelPar_BETW2_dX);
modelStruct.modelPar_WBET=mod.WBET;
modelStruct.d_modelPar_WBET_dX=0.0;
modelStruct.modelPar_given_WBET=mod.given("WBET");
modParamMap["WBET"] = &(modelStruct.d_modelPar_WBET_dX);
modelStruct.modelPar_BETNBO=mod.BETNBO;
modelStruct.d_modelPar_BETNBO_dX=0.0;
modelStruct.modelPar_given_BETNBO=mod.given("BETNBO");
modParamMap["BETNBO"] = &(modelStruct.d_modelPar_BETNBO_dX);
modelStruct.modelPar_STBETO=mod.STBETO;
modelStruct.d_modelPar_STBETO_dX=0.0;
modelStruct.modelPar_given_STBETO=mod.given("STBETO");
modParamMap["STBETO"] = &(modelStruct.d_modelPar_STBETO_dX);
modelStruct.modelPar_STBETL=mod.STBETL;
modelStruct.d_modelPar_STBETL_dX=0.0;
modelStruct.modelPar_given_STBETL=mod.given("STBETL");
modParamMap["STBETL"] = &(modelStruct.d_modelPar_STBETL_dX);
modelStruct.modelPar_STBETW=mod.STBETW;
modelStruct.d_modelPar_STBETW_dX=0.0;
modelStruct.modelPar_given_STBETW=mod.given("STBETW");
modParamMap["STBETW"] = &(modelStruct.d_modelPar_STBETW_dX);
modelStruct.modelPar_STBETLW=mod.STBETLW;
modelStruct.d_modelPar_STBETLW_dX=0.0;
modelStruct.modelPar_given_STBETLW=mod.given("STBETLW");
modParamMap["STBETLW"] = &(modelStruct.d_modelPar_STBETLW_dX);
modelStruct.modelPar_CSO=mod.CSO;
modelStruct.d_modelPar_CSO_dX=0.0;
modelStruct.modelPar_given_CSO=mod.given("CSO");
modParamMap["CSO"] = &(modelStruct.d_modelPar_CSO_dX);
modelStruct.modelPar_CSL=mod.CSL;
modelStruct.d_modelPar_CSL_dX=0.0;
modelStruct.modelPar_given_CSL=mod.given("CSL");
modParamMap["CSL"] = &(modelStruct.d_modelPar_CSL_dX);
modelStruct.modelPar_CSLEXP=mod.CSLEXP;
modelStruct.d_modelPar_CSLEXP_dX=0.0;
modelStruct.modelPar_given_CSLEXP=mod.given("CSLEXP");
modParamMap["CSLEXP"] = &(modelStruct.d_modelPar_CSLEXP_dX);
modelStruct.modelPar_CSW=mod.CSW;
modelStruct.d_modelPar_CSW_dX=0.0;
modelStruct.modelPar_given_CSW=mod.given("CSW");
modParamMap["CSW"] = &(modelStruct.d_modelPar_CSW_dX);
modelStruct.modelPar_CSLW=mod.CSLW;
modelStruct.d_modelPar_CSLW_dX=0.0;
modelStruct.modelPar_given_CSLW=mod.given("CSLW");
modParamMap["CSLW"] = &(modelStruct.d_modelPar_CSLW_dX);
modelStruct.modelPar_CSFIO=mod.CSFIO;
modelStruct.d_modelPar_CSFIO_dX=0.0;
modelStruct.modelPar_given_CSFIO=mod.given("CSFIO");
modParamMap["CSFIO"] = &(modelStruct.d_modelPar_CSFIO_dX);
modelStruct.modelPar_CSBIO=mod.CSBIO;
modelStruct.d_modelPar_CSBIO_dX=0.0;
modelStruct.modelPar_given_CSBIO=mod.given("CSBIO");
modParamMap["CSBIO"] = &(modelStruct.d_modelPar_CSBIO_dX);
modelStruct.modelPar_STCSO=mod.STCSO;
modelStruct.d_modelPar_STCSO_dX=0.0;
modelStruct.modelPar_given_STCSO=mod.given("STCSO");
modParamMap["STCSO"] = &(modelStruct.d_modelPar_STCSO_dX);
modelStruct.modelPar_STCSL=mod.STCSL;
modelStruct.d_modelPar_STCSL_dX=0.0;
modelStruct.modelPar_given_STCSL=mod.given("STCSL");
modParamMap["STCSL"] = &(modelStruct.d_modelPar_STCSL_dX);
modelStruct.modelPar_STCSW=mod.STCSW;
modelStruct.d_modelPar_STCSW_dX=0.0;
modelStruct.modelPar_given_STCSW=mod.given("STCSW");
modParamMap["STCSW"] = &(modelStruct.d_modelPar_STCSW_dX);
modelStruct.modelPar_STCSLW=mod.STCSLW;
modelStruct.d_modelPar_STCSLW_dX=0.0;
modelStruct.modelPar_given_STCSLW=mod.given("STCSLW");
modParamMap["STCSLW"] = &(modelStruct.d_modelPar_STCSLW_dX);
modelStruct.modelPar_THECSO=mod.THECSO;
modelStruct.d_modelPar_THECSO_dX=0.0;
modelStruct.modelPar_given_THECSO=mod.given("THECSO");
modParamMap["THECSO"] = &(modelStruct.d_modelPar_THECSO_dX);
modelStruct.modelPar_STTHECSO=mod.STTHECSO;
modelStruct.d_modelPar_STTHECSO_dX=0.0;
modelStruct.modelPar_given_STTHECSO=mod.given("STTHECSO");
modParamMap["STTHECSO"] = &(modelStruct.d_modelPar_STTHECSO_dX);
modelStruct.modelPar_CSTHRO=mod.CSTHRO;
modelStruct.d_modelPar_CSTHRO_dX=0.0;
modelStruct.modelPar_given_CSTHRO=mod.given("CSTHRO");
modParamMap["CSTHRO"] = &(modelStruct.d_modelPar_CSTHRO_dX);
modelStruct.modelPar_CSTHRBO=mod.CSTHRBO;
modelStruct.d_modelPar_CSTHRBO_dX=0.0;
modelStruct.modelPar_given_CSTHRBO=mod.given("CSTHRBO");
modParamMap["CSTHRBO"] = &(modelStruct.d_modelPar_CSTHRBO_dX);
modelStruct.modelPar_MUEO=mod.MUEO;
modelStruct.d_modelPar_MUEO_dX=0.0;
modelStruct.modelPar_given_MUEO=mod.given("MUEO");
modParamMap["MUEO"] = &(modelStruct.d_modelPar_MUEO_dX);
modelStruct.modelPar_STMUEO=mod.STMUEO;
modelStruct.d_modelPar_STMUEO_dX=0.0;
modelStruct.modelPar_given_STMUEO=mod.given("STMUEO");
modParamMap["STMUEO"] = &(modelStruct.d_modelPar_STMUEO_dX);
modelStruct.modelPar_THEMUO=mod.THEMUO;
modelStruct.d_modelPar_THEMUO_dX=0.0;
modelStruct.modelPar_given_THEMUO=mod.given("THEMUO");
modParamMap["THEMUO"] = &(modelStruct.d_modelPar_THEMUO_dX);
modelStruct.modelPar_STTHEMUO=mod.STTHEMUO;
modelStruct.d_modelPar_STTHEMUO_dX=0.0;
modelStruct.modelPar_given_STTHEMUO=mod.given("STTHEMUO");
modParamMap["STTHEMUO"] = &(modelStruct.d_modelPar_STTHEMUO_dX);
modelStruct.modelPar_XCORO=mod.XCORO;
modelStruct.d_modelPar_XCORO_dX=0.0;
modelStruct.modelPar_given_XCORO=mod.given("XCORO");
modParamMap["XCORO"] = &(modelStruct.d_modelPar_XCORO_dX);
modelStruct.modelPar_XCORL=mod.XCORL;
modelStruct.d_modelPar_XCORL_dX=0.0;
modelStruct.modelPar_given_XCORL=mod.given("XCORL");
modParamMap["XCORL"] = &(modelStruct.d_modelPar_XCORL_dX);
modelStruct.modelPar_XCORLEXP=mod.XCORLEXP;
modelStruct.d_modelPar_XCORLEXP_dX=0.0;
modelStruct.modelPar_given_XCORLEXP=mod.given("XCORLEXP");
modParamMap["XCORLEXP"] = &(modelStruct.d_modelPar_XCORLEXP_dX);
modelStruct.modelPar_XCORW=mod.XCORW;
modelStruct.d_modelPar_XCORW_dX=0.0;
modelStruct.modelPar_given_XCORW=mod.given("XCORW");
modParamMap["XCORW"] = &(modelStruct.d_modelPar_XCORW_dX);
modelStruct.modelPar_XCORLW=mod.XCORLW;
modelStruct.d_modelPar_XCORLW_dX=0.0;
modelStruct.modelPar_given_XCORLW=mod.given("XCORLW");
modParamMap["XCORLW"] = &(modelStruct.d_modelPar_XCORLW_dX);
modelStruct.modelPar_XCORBO=mod.XCORBO;
modelStruct.d_modelPar_XCORBO_dX=0.0;
modelStruct.modelPar_given_XCORBO=mod.given("XCORBO");
modParamMap["XCORBO"] = &(modelStruct.d_modelPar_XCORBO_dX);
modelStruct.modelPar_STXCORO=mod.STXCORO;
modelStruct.d_modelPar_STXCORO_dX=0.0;
modelStruct.modelPar_given_STXCORO=mod.given("STXCORO");
modParamMap["STXCORO"] = &(modelStruct.d_modelPar_STXCORO_dX);
modelStruct.modelPar_FETAO=mod.FETAO;
modelStruct.d_modelPar_FETAO_dX=0.0;
modelStruct.modelPar_given_FETAO=mod.given("FETAO");
modParamMap["FETAO"] = &(modelStruct.d_modelPar_FETAO_dX);
modelStruct.modelPar_RSW1=mod.RSW1;
modelStruct.d_modelPar_RSW1_dX=0.0;
modelStruct.modelPar_given_RSW1=mod.given("RSW1");
modParamMap["RSW1"] = &(modelStruct.d_modelPar_RSW1_dX);
modelStruct.modelPar_RSW2=mod.RSW2;
modelStruct.d_modelPar_RSW2_dX=0.0;
modelStruct.modelPar_given_RSW2=mod.given("RSW2");
modParamMap["RSW2"] = &(modelStruct.d_modelPar_RSW2_dX);
modelStruct.modelPar_RSIGO=mod.RSIGO;
modelStruct.d_modelPar_RSIGO_dX=0.0;
modelStruct.modelPar_given_RSIGO=mod.given("RSIGO");
modParamMap["RSIGO"] = &(modelStruct.d_modelPar_RSIGO_dX);
modelStruct.modelPar_STRSO=mod.STRSO;
modelStruct.d_modelPar_STRSO_dX=0.0;
modelStruct.modelPar_given_STRSO=mod.given("STRSO");
modParamMap["STRSO"] = &(modelStruct.d_modelPar_STRSO_dX);
modelStruct.modelPar_RSGO=mod.RSGO;
modelStruct.d_modelPar_RSGO_dX=0.0;
modelStruct.modelPar_given_RSGO=mod.given("RSGO");
modParamMap["RSGO"] = &(modelStruct.d_modelPar_RSGO_dX);
modelStruct.modelPar_THERSGO=mod.THERSGO;
modelStruct.d_modelPar_THERSGO_dX=0.0;
modelStruct.modelPar_given_THERSGO=mod.given("THERSGO");
modParamMap["THERSGO"] = &(modelStruct.d_modelPar_THERSGO_dX);
modelStruct.modelPar_RSBO=mod.RSBO;
modelStruct.d_modelPar_RSBO_dX=0.0;
modelStruct.modelPar_given_RSBO=mod.given("RSBO");
modParamMap["RSBO"] = &(modelStruct.d_modelPar_RSBO_dX);
modelStruct.modelPar_THESATO=mod.THESATO;
modelStruct.d_modelPar_THESATO_dX=0.0;
modelStruct.modelPar_given_THESATO=mod.given("THESATO");
modParamMap["THESATO"] = &(modelStruct.d_modelPar_THESATO_dX);
modelStruct.modelPar_THESATL=mod.THESATL;
modelStruct.d_modelPar_THESATL_dX=0.0;
modelStruct.modelPar_given_THESATL=mod.given("THESATL");
modParamMap["THESATL"] = &(modelStruct.d_modelPar_THESATL_dX);
modelStruct.modelPar_THESATLEXP=mod.THESATLEXP;
modelStruct.d_modelPar_THESATLEXP_dX=0.0;
modelStruct.modelPar_given_THESATLEXP=mod.given("THESATLEXP");
modParamMap["THESATLEXP"] = &(modelStruct.d_modelPar_THESATLEXP_dX);
modelStruct.modelPar_THESATW=mod.THESATW;
modelStruct.d_modelPar_THESATW_dX=0.0;
modelStruct.modelPar_given_THESATW=mod.given("THESATW");
modParamMap["THESATW"] = &(modelStruct.d_modelPar_THESATW_dX);
modelStruct.modelPar_THESATLW=mod.THESATLW;
modelStruct.d_modelPar_THESATLW_dX=0.0;
modelStruct.modelPar_given_THESATLW=mod.given("THESATLW");
modParamMap["THESATLW"] = &(modelStruct.d_modelPar_THESATLW_dX);
modelStruct.modelPar_STTHESATO=mod.STTHESATO;
modelStruct.d_modelPar_STTHESATO_dX=0.0;
modelStruct.modelPar_given_STTHESATO=mod.given("STTHESATO");
modParamMap["STTHESATO"] = &(modelStruct.d_modelPar_STTHESATO_dX);
modelStruct.modelPar_STTHESATL=mod.STTHESATL;
modelStruct.d_modelPar_STTHESATL_dX=0.0;
modelStruct.modelPar_given_STTHESATL=mod.given("STTHESATL");
modParamMap["STTHESATL"] = &(modelStruct.d_modelPar_STTHESATL_dX);
modelStruct.modelPar_STTHESATW=mod.STTHESATW;
modelStruct.d_modelPar_STTHESATW_dX=0.0;
modelStruct.modelPar_given_STTHESATW=mod.given("STTHESATW");
modParamMap["STTHESATW"] = &(modelStruct.d_modelPar_STTHESATW_dX);
modelStruct.modelPar_STTHESATLW=mod.STTHESATLW;
modelStruct.d_modelPar_STTHESATLW_dX=0.0;
modelStruct.modelPar_given_STTHESATLW=mod.given("STTHESATLW");
modParamMap["STTHESATLW"] = &(modelStruct.d_modelPar_STTHESATLW_dX);
modelStruct.modelPar_THESATGO=mod.THESATGO;
modelStruct.d_modelPar_THESATGO_dX=0.0;
modelStruct.modelPar_given_THESATGO=mod.given("THESATGO");
modParamMap["THESATGO"] = &(modelStruct.d_modelPar_THESATGO_dX);
modelStruct.modelPar_THESATBO=mod.THESATBO;
modelStruct.d_modelPar_THESATBO_dX=0.0;
modelStruct.modelPar_given_THESATBO=mod.given("THESATBO");
modParamMap["THESATBO"] = &(modelStruct.d_modelPar_THESATBO_dX);
modelStruct.modelPar_AXO=mod.AXO;
modelStruct.d_modelPar_AXO_dX=0.0;
modelStruct.modelPar_given_AXO=mod.given("AXO");
modParamMap["AXO"] = &(modelStruct.d_modelPar_AXO_dX);
modelStruct.modelPar_AXL=mod.AXL;
modelStruct.d_modelPar_AXL_dX=0.0;
modelStruct.modelPar_given_AXL=mod.given("AXL");
modParamMap["AXL"] = &(modelStruct.d_modelPar_AXL_dX);
modelStruct.modelPar_AXLEXP=mod.AXLEXP;
modelStruct.d_modelPar_AXLEXP_dX=0.0;
modelStruct.modelPar_given_AXLEXP=mod.given("AXLEXP");
modParamMap["AXLEXP"] = &(modelStruct.d_modelPar_AXLEXP_dX);
modelStruct.modelPar_AXL2=mod.AXL2;
modelStruct.d_modelPar_AXL2_dX=0.0;
modelStruct.modelPar_given_AXL2=mod.given("AXL2");
modParamMap["AXL2"] = &(modelStruct.d_modelPar_AXL2_dX);
modelStruct.modelPar_AXLEXP2=mod.AXLEXP2;
modelStruct.d_modelPar_AXLEXP2_dX=0.0;
modelStruct.modelPar_given_AXLEXP2=mod.given("AXLEXP2");
modParamMap["AXLEXP2"] = &(modelStruct.d_modelPar_AXLEXP2_dX);
modelStruct.modelPar_ALPL1=mod.ALPL1;
modelStruct.d_modelPar_ALPL1_dX=0.0;
modelStruct.modelPar_given_ALPL1=mod.given("ALPL1");
modParamMap["ALPL1"] = &(modelStruct.d_modelPar_ALPL1_dX);
modelStruct.modelPar_ALPLEXP=mod.ALPLEXP;
modelStruct.d_modelPar_ALPLEXP_dX=0.0;
modelStruct.modelPar_given_ALPLEXP=mod.given("ALPLEXP");
modParamMap["ALPLEXP"] = &(modelStruct.d_modelPar_ALPLEXP_dX);
modelStruct.modelPar_ALPL2=mod.ALPL2;
modelStruct.d_modelPar_ALPL2_dX=0.0;
modelStruct.modelPar_given_ALPL2=mod.given("ALPL2");
modParamMap["ALPL2"] = &(modelStruct.d_modelPar_ALPL2_dX);
modelStruct.modelPar_ALPLEXP2=mod.ALPLEXP2;
modelStruct.d_modelPar_ALPLEXP2_dX=0.0;
modelStruct.modelPar_given_ALPLEXP2=mod.given("ALPLEXP2");
modParamMap["ALPLEXP2"] = &(modelStruct.d_modelPar_ALPLEXP2_dX);
modelStruct.modelPar_ALPW=mod.ALPW;
modelStruct.d_modelPar_ALPW_dX=0.0;
modelStruct.modelPar_given_ALPW=mod.given("ALPW");
modParamMap["ALPW"] = &(modelStruct.d_modelPar_ALPW_dX);
modelStruct.modelPar_ALP1L1=mod.ALP1L1;
modelStruct.d_modelPar_ALP1L1_dX=0.0;
modelStruct.modelPar_given_ALP1L1=mod.given("ALP1L1");
modParamMap["ALP1L1"] = &(modelStruct.d_modelPar_ALP1L1_dX);
modelStruct.modelPar_ALP1LEXP=mod.ALP1LEXP;
modelStruct.d_modelPar_ALP1LEXP_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
modParamMap["ALP1LEXP"] = &(modelStruct.d_modelPar_ALP1LEXP_dX);
modelStruct.modelPar_ALP1L2=mod.ALP1L2;
modelStruct.d_modelPar_ALP1L2_dX=0.0;
modelStruct.modelPar_given_ALP1L2=mod.given("ALP1L2");
modParamMap["ALP1L2"] = &(modelStruct.d_modelPar_ALP1L2_dX);
modelStruct.modelPar_ALP1LEXP2=mod.ALP1LEXP2;
modelStruct.d_modelPar_ALP1LEXP2_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP2=mod.given("ALP1LEXP2");
modParamMap["ALP1LEXP2"] = &(modelStruct.d_modelPar_ALP1LEXP2_dX);
modelStruct.modelPar_ALP1W=mod.ALP1W;
modelStruct.d_modelPar_ALP1W_dX=0.0;
modelStruct.modelPar_given_ALP1W=mod.given("ALP1W");
modParamMap["ALP1W"] = &(modelStruct.d_modelPar_ALP1W_dX);
modelStruct.modelPar_ALPBO=mod.ALPBO;
modelStruct.d_modelPar_ALPBO_dX=0.0;
modelStruct.modelPar_given_ALPBO=mod.given("ALPBO");
modParamMap["ALPBO"] = &(modelStruct.d_modelPar_ALPBO_dX);
modelStruct.modelPar_VPO=mod.VPO;
modelStruct.d_modelPar_VPO_dX=0.0;
modelStruct.modelPar_given_VPO=mod.given("VPO");
modParamMap["VPO"] = &(modelStruct.d_modelPar_VPO_dX);
modelStruct.modelPar_VPGO=mod.VPGO;
modelStruct.d_modelPar_VPGO_dX=0.0;
modelStruct.modelPar_given_VPGO=mod.given("VPGO");
modParamMap["VPGO"] = &(modelStruct.d_modelPar_VPGO_dX);
modelStruct.modelPar_GCOO=mod.GCOO;
modelStruct.d_modelPar_GCOO_dX=0.0;
modelStruct.modelPar_given_GCOO=mod.given("GCOO");
modParamMap["GCOO"] = &(modelStruct.d_modelPar_GCOO_dX);
modelStruct.modelPar_IGINVLW=mod.IGINVLW;
modelStruct.d_modelPar_IGINVLW_dX=0.0;
modelStruct.modelPar_given_IGINVLW=mod.given("IGINVLW");
modParamMap["IGINVLW"] = &(modelStruct.d_modelPar_IGINVLW_dX);
modelStruct.modelPar_IGOVINVW=mod.IGOVINVW;
modelStruct.d_modelPar_IGOVINVW_dX=0.0;
modelStruct.modelPar_given_IGOVINVW=mod.given("IGOVINVW");
modParamMap["IGOVINVW"] = &(modelStruct.d_modelPar_IGOVINVW_dX);
modelStruct.modelPar_IGOVINVDW=mod.IGOVINVDW;
modelStruct.d_modelPar_IGOVINVDW_dX=0.0;
modelStruct.modelPar_given_IGOVINVDW=mod.given("IGOVINVDW");
modParamMap["IGOVINVDW"] = &(modelStruct.d_modelPar_IGOVINVDW_dX);
modelStruct.modelPar_IGOVACCW=mod.IGOVACCW;
modelStruct.d_modelPar_IGOVACCW_dX=0.0;
modelStruct.modelPar_given_IGOVACCW=mod.given("IGOVACCW");
modParamMap["IGOVACCW"] = &(modelStruct.d_modelPar_IGOVACCW_dX);
modelStruct.modelPar_IGOVACCDW=mod.IGOVACCDW;
modelStruct.d_modelPar_IGOVACCDW_dX=0.0;
modelStruct.modelPar_given_IGOVACCDW=mod.given("IGOVACCDW");
modParamMap["IGOVACCDW"] = &(modelStruct.d_modelPar_IGOVACCDW_dX);
modelStruct.modelPar_STIGO=mod.STIGO;
modelStruct.d_modelPar_STIGO_dX=0.0;
modelStruct.modelPar_given_STIGO=mod.given("STIGO");
modParamMap["STIGO"] = &(modelStruct.d_modelPar_STIGO_dX);
modelStruct.modelPar_GC2CHO=mod.GC2CHO;
modelStruct.d_modelPar_GC2CHO_dX=0.0;
modelStruct.modelPar_given_GC2CHO=mod.given("GC2CHO");
modParamMap["GC2CHO"] = &(modelStruct.d_modelPar_GC2CHO_dX);
modelStruct.modelPar_GC3CHO=mod.GC3CHO;
modelStruct.d_modelPar_GC3CHO_dX=0.0;
modelStruct.modelPar_given_GC3CHO=mod.given("GC3CHO");
modParamMap["GC3CHO"] = &(modelStruct.d_modelPar_GC3CHO_dX);
modelStruct.modelPar_GC2OVINVO=mod.GC2OVINVO;
modelStruct.d_modelPar_GC2OVINVO_dX=0.0;
modelStruct.modelPar_given_GC2OVINVO=mod.given("GC2OVINVO");
modParamMap["GC2OVINVO"] = &(modelStruct.d_modelPar_GC2OVINVO_dX);
modelStruct.modelPar_GC3OVINVO=mod.GC3OVINVO;
modelStruct.d_modelPar_GC3OVINVO_dX=0.0;
modelStruct.modelPar_given_GC3OVINVO=mod.given("GC3OVINVO");
modParamMap["GC3OVINVO"] = &(modelStruct.d_modelPar_GC3OVINVO_dX);
modelStruct.modelPar_GC2OVACCO=mod.GC2OVACCO;
modelStruct.d_modelPar_GC2OVACCO_dX=0.0;
modelStruct.modelPar_given_GC2OVACCO=mod.given("GC2OVACCO");
modParamMap["GC2OVACCO"] = &(modelStruct.d_modelPar_GC2OVACCO_dX);
modelStruct.modelPar_GC3OVACCO=mod.GC3OVACCO;
modelStruct.d_modelPar_GC3OVACCO_dX=0.0;
modelStruct.modelPar_given_GC3OVACCO=mod.given("GC3OVACCO");
modParamMap["GC3OVACCO"] = &(modelStruct.d_modelPar_GC3OVACCO_dX);
modelStruct.modelPar_GCDOVL=mod.GCDOVL;
modelStruct.d_modelPar_GCDOVL_dX=0.0;
modelStruct.modelPar_given_GCDOVL=mod.given("GCDOVL");
modParamMap["GCDOVL"] = &(modelStruct.d_modelPar_GCDOVL_dX);
modelStruct.modelPar_GCVDOVO=mod.GCVDOVO;
modelStruct.d_modelPar_GCVDOVO_dX=0.0;
modelStruct.modelPar_given_GCVDOVO=mod.given("GCVDOVO");
modParamMap["GCVDOVO"] = &(modelStruct.d_modelPar_GCVDOVO_dX);
modelStruct.modelPar_CHIBO=mod.CHIBO;
modelStruct.d_modelPar_CHIBO_dX=0.0;
modelStruct.modelPar_given_CHIBO=mod.given("CHIBO");
modParamMap["CHIBO"] = &(modelStruct.d_modelPar_CHIBO_dX);
modelStruct.modelPar_NIGINVO=mod.NIGINVO;
modelStruct.d_modelPar_NIGINVO_dX=0.0;
modelStruct.modelPar_given_NIGINVO=mod.given("NIGINVO");
modParamMap["NIGINVO"] = &(modelStruct.d_modelPar_NIGINVO_dX);
modelStruct.modelPar_FNOVINVW=mod.FNOVINVW;
modelStruct.d_modelPar_FNOVINVW_dX=0.0;
modelStruct.modelPar_given_FNOVINVW=mod.given("FNOVINVW");
modParamMap["FNOVINVW"] = &(modelStruct.d_modelPar_FNOVINVW_dX);
modelStruct.modelPar_FNOVINVDW=mod.FNOVINVDW;
modelStruct.d_modelPar_FNOVINVDW_dX=0.0;
modelStruct.modelPar_given_FNOVINVDW=mod.given("FNOVINVDW");
modParamMap["FNOVINVDW"] = &(modelStruct.d_modelPar_FNOVINVDW_dX);
modelStruct.modelPar_GCOVINVFNO=mod.GCOVINVFNO;
modelStruct.d_modelPar_GCOVINVFNO_dX=0.0;
modelStruct.modelPar_given_GCOVINVFNO=mod.given("GCOVINVFNO");
modParamMap["GCOVINVFNO"] = &(modelStruct.d_modelPar_GCOVINVFNO_dX);
modelStruct.modelPar_STIGFNO=mod.STIGFNO;
modelStruct.d_modelPar_STIGFNO_dX=0.0;
modelStruct.modelPar_given_STIGFNO=mod.given("STIGFNO");
modParamMap["STIGFNO"] = &(modelStruct.d_modelPar_STIGFNO_dX);
modelStruct.modelPar_AGIDLO=mod.AGIDLO;
modelStruct.d_modelPar_AGIDLO_dX=0.0;
modelStruct.modelPar_given_AGIDLO=mod.given("AGIDLO");
modParamMap["AGIDLO"] = &(modelStruct.d_modelPar_AGIDLO_dX);
modelStruct.modelPar_AGIDLDO=mod.AGIDLDO;
modelStruct.d_modelPar_AGIDLDO_dX=0.0;
modelStruct.modelPar_given_AGIDLDO=mod.given("AGIDLDO");
modParamMap["AGIDLDO"] = &(modelStruct.d_modelPar_AGIDLDO_dX);
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modParamMap["AGIDLW"] = &(modelStruct.d_modelPar_AGIDLW_dX);
modelStruct.modelPar_AGIDLDW=mod.AGIDLDW;
modelStruct.d_modelPar_AGIDLDW_dX=0.0;
modelStruct.modelPar_given_AGIDLDW=mod.given("AGIDLDW");
modParamMap["AGIDLDW"] = &(modelStruct.d_modelPar_AGIDLDW_dX);
modelStruct.modelPar_BGIDLO=mod.BGIDLO;
modelStruct.d_modelPar_BGIDLO_dX=0.0;
modelStruct.modelPar_given_BGIDLO=mod.given("BGIDLO");
modParamMap["BGIDLO"] = &(modelStruct.d_modelPar_BGIDLO_dX);
modelStruct.modelPar_BGIDLDO=mod.BGIDLDO;
modelStruct.d_modelPar_BGIDLDO_dX=0.0;
modelStruct.modelPar_given_BGIDLDO=mod.given("BGIDLDO");
modParamMap["BGIDLDO"] = &(modelStruct.d_modelPar_BGIDLDO_dX);
modelStruct.modelPar_STBGIDLO=mod.STBGIDLO;
modelStruct.d_modelPar_STBGIDLO_dX=0.0;
modelStruct.modelPar_given_STBGIDLO=mod.given("STBGIDLO");
modParamMap["STBGIDLO"] = &(modelStruct.d_modelPar_STBGIDLO_dX);
modelStruct.modelPar_STBGIDLDO=mod.STBGIDLDO;
modelStruct.d_modelPar_STBGIDLDO_dX=0.0;
modelStruct.modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
modParamMap["STBGIDLDO"] = &(modelStruct.d_modelPar_STBGIDLDO_dX);
modelStruct.modelPar_CGIDLO=mod.CGIDLO;
modelStruct.d_modelPar_CGIDLO_dX=0.0;
modelStruct.modelPar_given_CGIDLO=mod.given("CGIDLO");
modParamMap["CGIDLO"] = &(modelStruct.d_modelPar_CGIDLO_dX);
modelStruct.modelPar_CGIDLDO=mod.CGIDLDO;
modelStruct.d_modelPar_CGIDLDO_dX=0.0;
modelStruct.modelPar_given_CGIDLDO=mod.given("CGIDLDO");
modParamMap["CGIDLDO"] = &(modelStruct.d_modelPar_CGIDLDO_dX);
modelStruct.modelPar_DGIDLO=mod.DGIDLO;
modelStruct.d_modelPar_DGIDLO_dX=0.0;
modelStruct.modelPar_given_DGIDLO=mod.given("DGIDLO");
modParamMap["DGIDLO"] = &(modelStruct.d_modelPar_DGIDLO_dX);
modelStruct.modelPar_DGIDLDO=mod.DGIDLDO;
modelStruct.d_modelPar_DGIDLDO_dX=0.0;
modelStruct.modelPar_given_DGIDLDO=mod.given("DGIDLDO");
modParamMap["DGIDLDO"] = &(modelStruct.d_modelPar_DGIDLDO_dX);
modelStruct.modelPar_DGIDLL=mod.DGIDLL;
modelStruct.d_modelPar_DGIDLL_dX=0.0;
modelStruct.modelPar_given_DGIDLL=mod.given("DGIDLL");
modParamMap["DGIDLL"] = &(modelStruct.d_modelPar_DGIDLL_dX);
modelStruct.modelPar_DGIDLDL=mod.DGIDLDL;
modelStruct.d_modelPar_DGIDLDL_dX=0.0;
modelStruct.modelPar_given_DGIDLDL=mod.given("DGIDLDL");
modParamMap["DGIDLDL"] = &(modelStruct.d_modelPar_DGIDLDL_dX);
modelStruct.modelPar_A1O=mod.A1O;
modelStruct.d_modelPar_A1O_dX=0.0;
modelStruct.modelPar_given_A1O=mod.given("A1O");
modParamMap["A1O"] = &(modelStruct.d_modelPar_A1O_dX);
modelStruct.modelPar_A1L=mod.A1L;
modelStruct.d_modelPar_A1L_dX=0.0;
modelStruct.modelPar_given_A1L=mod.given("A1L");
modParamMap["A1L"] = &(modelStruct.d_modelPar_A1L_dX);
modelStruct.modelPar_A1W=mod.A1W;
modelStruct.d_modelPar_A1W_dX=0.0;
modelStruct.modelPar_given_A1W=mod.given("A1W");
modParamMap["A1W"] = &(modelStruct.d_modelPar_A1W_dX);
modelStruct.modelPar_A2O=mod.A2O;
modelStruct.d_modelPar_A2O_dX=0.0;
modelStruct.modelPar_given_A2O=mod.given("A2O");
modParamMap["A2O"] = &(modelStruct.d_modelPar_A2O_dX);
modelStruct.modelPar_STA2O=mod.STA2O;
modelStruct.d_modelPar_STA2O_dX=0.0;
modelStruct.modelPar_given_STA2O=mod.given("STA2O");
modParamMap["STA2O"] = &(modelStruct.d_modelPar_STA2O_dX);
modelStruct.modelPar_A3O=mod.A3O;
modelStruct.d_modelPar_A3O_dX=0.0;
modelStruct.modelPar_given_A3O=mod.given("A3O");
modParamMap["A3O"] = &(modelStruct.d_modelPar_A3O_dX);
modelStruct.modelPar_A3L=mod.A3L;
modelStruct.d_modelPar_A3L_dX=0.0;
modelStruct.modelPar_given_A3L=mod.given("A3L");
modParamMap["A3L"] = &(modelStruct.d_modelPar_A3L_dX);
modelStruct.modelPar_A3W=mod.A3W;
modelStruct.d_modelPar_A3W_dX=0.0;
modelStruct.modelPar_given_A3W=mod.given("A3W");
modParamMap["A3W"] = &(modelStruct.d_modelPar_A3W_dX);
modelStruct.modelPar_CGBOVO=mod.CGBOVO;
modelStruct.d_modelPar_CGBOVO_dX=0.0;
modelStruct.modelPar_given_CGBOVO=mod.given("CGBOVO");
modParamMap["CGBOVO"] = &(modelStruct.d_modelPar_CGBOVO_dX);
modelStruct.modelPar_CGBOVL=mod.CGBOVL;
modelStruct.d_modelPar_CGBOVL_dX=0.0;
modelStruct.modelPar_given_CGBOVL=mod.given("CGBOVL");
modParamMap["CGBOVL"] = &(modelStruct.d_modelPar_CGBOVL_dX);
modelStruct.modelPar_NSDACO=mod.NSDACO;
modelStruct.d_modelPar_NSDACO_dX=0.0;
modelStruct.modelPar_given_NSDACO=mod.given("NSDACO");
modParamMap["NSDACO"] = &(modelStruct.d_modelPar_NSDACO_dX);
modelStruct.modelPar_FIFW=mod.FIFW;
modelStruct.d_modelPar_FIFW_dX=0.0;
modelStruct.modelPar_given_FIFW=mod.given("FIFW");
modParamMap["FIFW"] = &(modelStruct.d_modelPar_FIFW_dX);
modelStruct.modelPar_FSCEACO=mod.FSCEACO;
modelStruct.d_modelPar_FSCEACO_dX=0.0;
modelStruct.modelPar_given_FSCEACO=mod.given("FSCEACO");
modParamMap["FSCEACO"] = &(modelStruct.d_modelPar_FSCEACO_dX);
modelStruct.modelPar_LOVO=mod.LOVO;
modelStruct.d_modelPar_LOVO_dX=0.0;
modelStruct.modelPar_given_LOVO=mod.given("LOVO");
modParamMap["LOVO"] = &(modelStruct.d_modelPar_LOVO_dX);
modelStruct.modelPar_LOVDO=mod.LOVDO;
modelStruct.d_modelPar_LOVDO_dX=0.0;
modelStruct.modelPar_given_LOVDO=mod.given("LOVDO");
modParamMap["LOVDO"] = &(modelStruct.d_modelPar_LOVDO_dX);
modelStruct.modelPar_COVDLO=mod.COVDLO;
modelStruct.d_modelPar_COVDLO_dX=0.0;
modelStruct.modelPar_given_COVDLO=mod.given("COVDLO");
modParamMap["COVDLO"] = &(modelStruct.d_modelPar_COVDLO_dX);
modelStruct.modelPar_COVDLW=mod.COVDLW;
modelStruct.d_modelPar_COVDLW_dX=0.0;
modelStruct.modelPar_given_COVDLW=mod.given("COVDLW");
modParamMap["COVDLW"] = &(modelStruct.d_modelPar_COVDLW_dX);
modelStruct.modelPar_COVDLBO=mod.COVDLBO;
modelStruct.d_modelPar_COVDLBO_dX=0.0;
modelStruct.modelPar_given_COVDLBO=mod.given("COVDLBO");
modParamMap["COVDLBO"] = &(modelStruct.d_modelPar_COVDLBO_dX);
modelStruct.modelPar_DVFBOVO=mod.DVFBOVO;
modelStruct.d_modelPar_DVFBOVO_dX=0.0;
modelStruct.modelPar_given_DVFBOVO=mod.given("DVFBOVO");
modParamMap["DVFBOVO"] = &(modelStruct.d_modelPar_DVFBOVO_dX);
modelStruct.modelPar_CFRO=mod.CFRO;
modelStruct.d_modelPar_CFRO_dX=0.0;
modelStruct.modelPar_given_CFRO=mod.given("CFRO");
modParamMap["CFRO"] = &(modelStruct.d_modelPar_CFRO_dX);
modelStruct.modelPar_CFRDO=mod.CFRDO;
modelStruct.d_modelPar_CFRDO_dX=0.0;
modelStruct.modelPar_given_CFRDO=mod.given("CFRDO");
modParamMap["CFRDO"] = &(modelStruct.d_modelPar_CFRDO_dX);
modelStruct.modelPar_CFRW=mod.CFRW;
modelStruct.d_modelPar_CFRW_dX=0.0;
modelStruct.modelPar_given_CFRW=mod.given("CFRW");
modParamMap["CFRW"] = &(modelStruct.d_modelPar_CFRW_dX);
modelStruct.modelPar_CFRDW=mod.CFRDW;
modelStruct.d_modelPar_CFRDW_dX=0.0;
modelStruct.modelPar_given_CFRDW=mod.given("CFRDW");
modParamMap["CFRDW"] = &(modelStruct.d_modelPar_CFRDW_dX);
modelStruct.modelPar_CSDO=mod.CSDO;
modelStruct.d_modelPar_CSDO_dX=0.0;
modelStruct.modelPar_given_CSDO=mod.given("CSDO");
modParamMap["CSDO"] = &(modelStruct.d_modelPar_CSDO_dX);
modelStruct.modelPar_CSDBPO=mod.CSDBPO;
modelStruct.d_modelPar_CSDBPO_dX=0.0;
modelStruct.modelPar_given_CSDBPO=mod.given("CSDBPO");
modParamMap["CSDBPO"] = &(modelStruct.d_modelPar_CSDBPO_dX);
modelStruct.modelPar_RTHO=mod.RTHO;
modelStruct.d_modelPar_RTHO_dX=0.0;
modelStruct.modelPar_given_RTHO=mod.given("RTHO");
modParamMap["RTHO"] = &(modelStruct.d_modelPar_RTHO_dX);
modelStruct.modelPar_RTHL=mod.RTHL;
modelStruct.d_modelPar_RTHL_dX=0.0;
modelStruct.modelPar_given_RTHL=mod.given("RTHL");
modParamMap["RTHL"] = &(modelStruct.d_modelPar_RTHL_dX);
modelStruct.modelPar_RTHW=mod.RTHW;
modelStruct.d_modelPar_RTHW_dX=0.0;
modelStruct.modelPar_given_RTHW=mod.given("RTHW");
modParamMap["RTHW"] = &(modelStruct.d_modelPar_RTHW_dX);
modelStruct.modelPar_RTHLW=mod.RTHLW;
modelStruct.d_modelPar_RTHLW_dX=0.0;
modelStruct.modelPar_given_RTHLW=mod.given("RTHLW");
modParamMap["RTHLW"] = &(modelStruct.d_modelPar_RTHLW_dX);
modelStruct.modelPar_STRTHO=mod.STRTHO;
modelStruct.d_modelPar_STRTHO_dX=0.0;
modelStruct.modelPar_given_STRTHO=mod.given("STRTHO");
modParamMap["STRTHO"] = &(modelStruct.d_modelPar_STRTHO_dX);
modelStruct.modelPar_CTHO=mod.CTHO;
modelStruct.d_modelPar_CTHO_dX=0.0;
modelStruct.modelPar_given_CTHO=mod.given("CTHO");
modParamMap["CTHO"] = &(modelStruct.d_modelPar_CTHO_dX);
modelStruct.modelPar_LAMBTHO=mod.LAMBTHO;
modelStruct.d_modelPar_LAMBTHO_dX=0.0;
modelStruct.modelPar_given_LAMBTHO=mod.given("LAMBTHO");
modParamMap["LAMBTHO"] = &(modelStruct.d_modelPar_LAMBTHO_dX);
modelStruct.modelPar_FTHO=mod.FTHO;
modelStruct.d_modelPar_FTHO_dX=0.0;
modelStruct.modelPar_given_FTHO=mod.given("FTHO");
modParamMap["FTHO"] = &(modelStruct.d_modelPar_FTHO_dX);
modelStruct.modelPar_FNTO=mod.FNTO;
modelStruct.d_modelPar_FNTO_dX=0.0;
modelStruct.modelPar_given_FNTO=mod.given("FNTO");
modParamMap["FNTO"] = &(modelStruct.d_modelPar_FNTO_dX);
modelStruct.modelPar_FNTEXCL=mod.FNTEXCL;
modelStruct.d_modelPar_FNTEXCL_dX=0.0;
modelStruct.modelPar_given_FNTEXCL=mod.given("FNTEXCL");
modParamMap["FNTEXCL"] = &(modelStruct.d_modelPar_FNTEXCL_dX);
modelStruct.modelPar_FNTEXCLEXP=mod.FNTEXCLEXP;
modelStruct.d_modelPar_FNTEXCLEXP_dX=0.0;
modelStruct.modelPar_given_FNTEXCLEXP=mod.given("FNTEXCLEXP");
modParamMap["FNTEXCLEXP"] = &(modelStruct.d_modelPar_FNTEXCLEXP_dX);
modelStruct.modelPar_NFALW=mod.NFALW;
modelStruct.d_modelPar_NFALW_dX=0.0;
modelStruct.modelPar_given_NFALW=mod.given("NFALW");
modParamMap["NFALW"] = &(modelStruct.d_modelPar_NFALW_dX);
modelStruct.modelPar_NFAW=mod.NFAW;
modelStruct.d_modelPar_NFAW_dX=0.0;
modelStruct.modelPar_given_NFAW=mod.given("NFAW");
modParamMap["NFAW"] = &(modelStruct.d_modelPar_NFAW_dX);
modelStruct.modelPar_NFBLW=mod.NFBLW;
modelStruct.d_modelPar_NFBLW_dX=0.0;
modelStruct.modelPar_given_NFBLW=mod.given("NFBLW");
modParamMap["NFBLW"] = &(modelStruct.d_modelPar_NFBLW_dX);
modelStruct.modelPar_NFCLW=mod.NFCLW;
modelStruct.d_modelPar_NFCLW_dX=0.0;
modelStruct.modelPar_given_NFCLW=mod.given("NFCLW");
modParamMap["NFCLW"] = &(modelStruct.d_modelPar_NFCLW_dX);
modelStruct.modelPar_NFEO=mod.NFEO;
modelStruct.d_modelPar_NFEO_dX=0.0;
modelStruct.modelPar_given_NFEO=mod.given("NFEO");
modParamMap["NFEO"] = &(modelStruct.d_modelPar_NFEO_dX);
modelStruct.modelPar_NFEBO=mod.NFEBO;
modelStruct.d_modelPar_NFEBO_dX=0.0;
modelStruct.modelPar_given_NFEBO=mod.given("NFEBO");
modParamMap["NFEBO"] = &(modelStruct.d_modelPar_NFEBO_dX);
modelStruct.modelPar_EFO=mod.EFO;
modelStruct.d_modelPar_EFO_dX=0.0;
modelStruct.modelPar_given_EFO=mod.given("EFO");
modParamMap["EFO"] = &(modelStruct.d_modelPar_EFO_dX);
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modParamMap["SAREF"] = &(modelStruct.d_modelPar_SAREF_dX);
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modParamMap["SBREF"] = &(modelStruct.d_modelPar_SBREF_dX);
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modParamMap["WLOD"] = &(modelStruct.d_modelPar_WLOD_dX);
modelStruct.modelPar_KUO=mod.KUO;
modelStruct.d_modelPar_KUO_dX=0.0;
modelStruct.modelPar_given_KUO=mod.given("KUO");
modParamMap["KUO"] = &(modelStruct.d_modelPar_KUO_dX);
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modParamMap["KVSAT"] = &(modelStruct.d_modelPar_KVSAT_dX);
modelStruct.modelPar_TKUO=mod.TKUO;
modelStruct.d_modelPar_TKUO_dX=0.0;
modelStruct.modelPar_given_TKUO=mod.given("TKUO");
modParamMap["TKUO"] = &(modelStruct.d_modelPar_TKUO_dX);
modelStruct.modelPar_LKUO=mod.LKUO;
modelStruct.d_modelPar_LKUO_dX=0.0;
modelStruct.modelPar_given_LKUO=mod.given("LKUO");
modParamMap["LKUO"] = &(modelStruct.d_modelPar_LKUO_dX);
modelStruct.modelPar_WKUO=mod.WKUO;
modelStruct.d_modelPar_WKUO_dX=0.0;
modelStruct.modelPar_given_WKUO=mod.given("WKUO");
modParamMap["WKUO"] = &(modelStruct.d_modelPar_WKUO_dX);
modelStruct.modelPar_PKUO=mod.PKUO;
modelStruct.d_modelPar_PKUO_dX=0.0;
modelStruct.modelPar_given_PKUO=mod.given("PKUO");
modParamMap["PKUO"] = &(modelStruct.d_modelPar_PKUO_dX);
modelStruct.modelPar_LLODKUO=mod.LLODKUO;
modelStruct.d_modelPar_LLODKUO_dX=0.0;
modelStruct.modelPar_given_LLODKUO=mod.given("LLODKUO");
modParamMap["LLODKUO"] = &(modelStruct.d_modelPar_LLODKUO_dX);
modelStruct.modelPar_WLODKUO=mod.WLODKUO;
modelStruct.d_modelPar_WLODKUO_dX=0.0;
modelStruct.modelPar_given_WLODKUO=mod.given("WLODKUO");
modParamMap["WLODKUO"] = &(modelStruct.d_modelPar_WLODKUO_dX);
modelStruct.modelPar_KVTHO=mod.KVTHO;
modelStruct.d_modelPar_KVTHO_dX=0.0;
modelStruct.modelPar_given_KVTHO=mod.given("KVTHO");
modParamMap["KVTHO"] = &(modelStruct.d_modelPar_KVTHO_dX);
modelStruct.modelPar_LKVTHO=mod.LKVTHO;
modelStruct.d_modelPar_LKVTHO_dX=0.0;
modelStruct.modelPar_given_LKVTHO=mod.given("LKVTHO");
modParamMap["LKVTHO"] = &(modelStruct.d_modelPar_LKVTHO_dX);
modelStruct.modelPar_WKVTHO=mod.WKVTHO;
modelStruct.d_modelPar_WKVTHO_dX=0.0;
modelStruct.modelPar_given_WKVTHO=mod.given("WKVTHO");
modParamMap["WKVTHO"] = &(modelStruct.d_modelPar_WKVTHO_dX);
modelStruct.modelPar_PKVTHO=mod.PKVTHO;
modelStruct.d_modelPar_PKVTHO_dX=0.0;
modelStruct.modelPar_given_PKVTHO=mod.given("PKVTHO");
modParamMap["PKVTHO"] = &(modelStruct.d_modelPar_PKVTHO_dX);
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modParamMap["LLODVTH"] = &(modelStruct.d_modelPar_LLODVTH_dX);
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modParamMap["WLODVTH"] = &(modelStruct.d_modelPar_WLODVTH_dX);
modelStruct.modelPar_STETAO=mod.STETAO;
modelStruct.d_modelPar_STETAO_dX=0.0;
modelStruct.modelPar_given_STETAO=mod.given("STETAO");
modParamMap["STETAO"] = &(modelStruct.d_modelPar_STETAO_dX);
modelStruct.modelPar_LODETAO=mod.LODETAO;
modelStruct.d_modelPar_LODETAO_dX=0.0;
modelStruct.modelPar_given_LODETAO=mod.given("LODETAO");
modParamMap["LODETAO"] = &(modelStruct.d_modelPar_LODETAO_dX);
modelStruct.modelPar_STRLAMBDA=mod.STRLAMBDA;
modelStruct.d_modelPar_STRLAMBDA_dX=0.0;
modelStruct.modelPar_given_STRLAMBDA=mod.given("STRLAMBDA");
modParamMap["STRLAMBDA"] = &(modelStruct.d_modelPar_STRLAMBDA_dX);
modelStruct.modelPar_STRALPHA=mod.STRALPHA;
modelStruct.d_modelPar_STRALPHA_dX=0.0;
modelStruct.modelPar_given_STRALPHA=mod.given("STRALPHA");
modParamMap["STRALPHA"] = &(modelStruct.d_modelPar_STRALPHA_dX);
modelStruct.modelPar_STRDVFBO=mod.STRDVFBO;
modelStruct.d_modelPar_STRDVFBO_dX=0.0;
modelStruct.modelPar_given_STRDVFBO=mod.given("STRDVFBO");
modParamMap["STRDVFBO"] = &(modelStruct.d_modelPar_STRDVFBO_dX);
modelStruct.modelPar_STRWDVFBO=mod.STRWDVFBO;
modelStruct.d_modelPar_STRWDVFBO_dX=0.0;
modelStruct.modelPar_given_STRWDVFBO=mod.given("STRWDVFBO");
modParamMap["STRWDVFBO"] = &(modelStruct.d_modelPar_STRWDVFBO_dX);
modelStruct.modelPar_STRDCFL=mod.STRDCFL;
modelStruct.d_modelPar_STRDCFL_dX=0.0;
modelStruct.modelPar_given_STRDCFL=mod.given("STRDCFL");
modParamMap["STRDCFL"] = &(modelStruct.d_modelPar_STRDCFL_dX);
modelStruct.modelPar_STRRUO=mod.STRRUO;
modelStruct.d_modelPar_STRRUO_dX=0.0;
modelStruct.modelPar_given_STRRUO=mod.given("STRRUO");
modParamMap["STRRUO"] = &(modelStruct.d_modelPar_STRRUO_dX);
modelStruct.modelPar_STRTRUO=mod.STRTRUO;
modelStruct.d_modelPar_STRTRUO_dX=0.0;
modelStruct.modelPar_given_STRTRUO=mod.given("STRTRUO");
modParamMap["STRTRUO"] = &(modelStruct.d_modelPar_STRTRUO_dX);
modelStruct.modelPar_STRRVSAT=mod.STRRVSAT;
modelStruct.d_modelPar_STRRVSAT_dX=0.0;
modelStruct.modelPar_given_STRRVSAT=mod.given("STRRVSAT");
modParamMap["STRRVSAT"] = &(modelStruct.d_modelPar_STRRVSAT_dX);


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_SWSCALE=mod.SWSCALE;
modelStruct.modelPar_given_SWSCALE=mod.given("SWSCALE");
modelStruct.modelPar_SWSUBDEP=mod.SWSUBDEP;
modelStruct.modelPar_given_SWSUBDEP=mod.given("SWSUBDEP");
modelStruct.modelPar_SWIGATE=mod.SWIGATE;
modelStruct.modelPar_given_SWIGATE=mod.given("SWIGATE");
modelStruct.modelPar_SWGIDL=mod.SWGIDL;
modelStruct.modelPar_given_SWGIDL=mod.given("SWGIDL");
modelStruct.modelPar_SWSHE=mod.SWSHE;
modelStruct.modelPar_given_SWSHE=mod.given("SWSHE");
modelStruct.modelPar_SWIGN=mod.SWIGN;
modelStruct.modelPar_given_SWIGN=mod.given("SWIGN");
modelStruct.modelPar_SWJUNASYM=mod.SWJUNASYM;
modelStruct.modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
modelStruct.modelPar_SWIMPACT=mod.SWIMPACT;
modelStruct.modelPar_given_SWIMPACT=mod.given("SWIMPACT");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_SWSTRESS=mod.SWSTRESS;
modelStruct.modelPar_given_SWSTRESS=mod.given("SWSTRESS");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals
modelStruct.modelVar_TKR=mod.TKR;
modelStruct.d_modelVar_TKR_dX=0.0;
modelStruct.modelVar_TKD=mod.TKD;
modelStruct.modelVar_gmin=mod.gmin;


// non-reals
modelStruct.modelVar_SWSHE_i=mod.SWSHE_i;



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 6+1 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
instanceStruct.instancePar_ASOURCE=in.ASOURCE;
instanceStruct.d_instancePar_ASOURCE_dX=0.0;
instanceStruct.instancePar_given_ASOURCE=in.given("ASOURCE");
instanceStruct.instancePar_ADRAIN=in.ADRAIN;
instanceStruct.d_instancePar_ADRAIN_dX=0.0;
instanceStruct.instancePar_given_ADRAIN=in.given("ADRAIN");
instanceStruct.instancePar_PSOURCE=in.PSOURCE;
instanceStruct.d_instancePar_PSOURCE_dX=0.0;
instanceStruct.instancePar_given_PSOURCE=in.given("PSOURCE");
instanceStruct.instancePar_PDRAIN=in.PDRAIN;
instanceStruct.d_instancePar_PDRAIN_dX=0.0;
instanceStruct.instancePar_given_PDRAIN=in.given("PDRAIN");
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
instanceStruct.instancePar_DELVTO=in.DELVTO;
instanceStruct.d_instancePar_DELVTO_dX=0.0;
instanceStruct.instancePar_given_DELVTO=in.given("DELVTO");
instanceStruct.instancePar_FACTUO=in.FACTUO;
instanceStruct.d_instancePar_FACTUO_dX=0.0;
instanceStruct.instancePar_given_FACTUO=in.given("FACTUO");


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_NF=in.NF;
instanceStruct.instancePar_given_NF=in.given("NF");
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.instancePar_given_MULT=in.given("MULT");
instanceStruct.instancePar_M=in.M;
instanceStruct.instancePar_given_M=in.given("M");




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.


  //make local copies of all instance vars
  //reals
instanceStruct.instanceVar_ASOURCE_i=in.ASOURCE_i;
instanceStruct.d_instanceVar_ASOURCE_i_dX=0.0;
instanceStruct.instanceVar_ADRAIN_i=in.ADRAIN_i;
instanceStruct.d_instanceVar_ADRAIN_i_dX=0.0;
instanceStruct.instanceVar_PSOURCE_i=in.PSOURCE_i;
instanceStruct.d_instanceVar_PSOURCE_i_dX=0.0;
instanceStruct.instanceVar_PDRAIN_i=in.PDRAIN_i;
instanceStruct.d_instanceVar_PDRAIN_i_dX=0.0;
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_VFB1_i=in.VFB1_i;
instanceStruct.d_instanceVar_VFB1_i_dX=0.0;
instanceStruct.instanceVar_CIC1_i=in.CIC1_i;
instanceStruct.d_instanceVar_CIC1_i_dX=0.0;
instanceStruct.instanceVar_PSCE1_i=in.PSCE1_i;
instanceStruct.d_instanceVar_PSCE1_i_dX=0.0;
instanceStruct.instanceVar_CF1_i=in.CF1_i;
instanceStruct.d_instanceVar_CF1_i_dX=0.0;
instanceStruct.instanceVar_BETN1_i=in.BETN1_i;
instanceStruct.d_instanceVar_BETN1_i_dX=0.0;
instanceStruct.instanceVar_THESAT1_i=in.THESAT1_i;
instanceStruct.d_instanceVar_THESAT1_i_dX=0.0;
instanceStruct.instanceVar_VFB2_i=in.VFB2_i;
instanceStruct.d_instanceVar_VFB2_i_dX=0.0;
instanceStruct.instanceVar_CIC2_i=in.CIC2_i;
instanceStruct.d_instanceVar_CIC2_i_dX=0.0;
instanceStruct.instanceVar_PSCE2_i=in.PSCE2_i;
instanceStruct.d_instanceVar_PSCE2_i_dX=0.0;
instanceStruct.instanceVar_CF2_i=in.CF2_i;
instanceStruct.d_instanceVar_CF2_i_dX=0.0;
instanceStruct.instanceVar_BETN2_i=in.BETN2_i;
instanceStruct.d_instanceVar_BETN2_i_dX=0.0;
instanceStruct.instanceVar_THESAT2_i=in.THESAT2_i;
instanceStruct.d_instanceVar_THESAT2_i_dX=0.0;
instanceStruct.instanceVar_TSI_i=in.TSI_i;
instanceStruct.d_instanceVar_TSI_i_dX=0.0;
instanceStruct.instanceVar_XGE_i=in.XGE_i;
instanceStruct.d_instanceVar_XGE_i_dX=0.0;
instanceStruct.instanceVar_TYPESUB_i=in.TYPESUB_i;
instanceStruct.instanceVar_NOV_i=in.NOV_i;
instanceStruct.d_instanceVar_NOV_i_dX=0.0;
instanceStruct.instanceVar_NOVD_i=in.NOVD_i;
instanceStruct.d_instanceVar_NOVD_i_dX=0.0;
instanceStruct.instanceVar_STVFB_i=in.STVFB_i;
instanceStruct.d_instanceVar_STVFB_i_dX=0.0;
instanceStruct.instanceVar_NSDDC_i=in.NSDDC_i;
instanceStruct.d_instanceVar_NSDDC_i_dX=0.0;
instanceStruct.instanceVar_PSCEDLB_i=in.PSCEDLB_i;
instanceStruct.d_instanceVar_PSCEDLB_i_dX=0.0;
instanceStruct.instanceVar_STCF_i=in.STCF_i;
instanceStruct.d_instanceVar_STCF_i_dX=0.0;
instanceStruct.instanceVar_CFD_i=in.CFD_i;
instanceStruct.d_instanceVar_CFD_i_dX=0.0;
instanceStruct.instanceVar_CFDL_i=in.CFDL_i;
instanceStruct.d_instanceVar_CFDL_i_dX=0.0;
instanceStruct.instanceVar_CFDLB_i=in.CFDLB_i;
instanceStruct.d_instanceVar_CFDLB_i_dX=0.0;
instanceStruct.instanceVar_STBET_i=in.STBET_i;
instanceStruct.d_instanceVar_STBET_i_dX=0.0;
instanceStruct.instanceVar_MUE_i=in.MUE_i;
instanceStruct.d_instanceVar_MUE_i_dX=0.0;
instanceStruct.instanceVar_STMUE_i=in.STMUE_i;
instanceStruct.d_instanceVar_STMUE_i_dX=0.0;
instanceStruct.instanceVar_THEMU_i=in.THEMU_i;
instanceStruct.d_instanceVar_THEMU_i_dX=0.0;
instanceStruct.instanceVar_STTHEMU_i=in.STTHEMU_i;
instanceStruct.d_instanceVar_STTHEMU_i_dX=0.0;
instanceStruct.instanceVar_CS_i=in.CS_i;
instanceStruct.d_instanceVar_CS_i_dX=0.0;
instanceStruct.instanceVar_CSFI_i=in.CSFI_i;
instanceStruct.d_instanceVar_CSFI_i_dX=0.0;
instanceStruct.instanceVar_CSBI_i=in.CSBI_i;
instanceStruct.d_instanceVar_CSBI_i_dX=0.0;
instanceStruct.instanceVar_STCS_i=in.STCS_i;
instanceStruct.d_instanceVar_STCS_i_dX=0.0;
instanceStruct.instanceVar_THECS_i=in.THECS_i;
instanceStruct.d_instanceVar_THECS_i_dX=0.0;
instanceStruct.instanceVar_STTHECS_i=in.STTHECS_i;
instanceStruct.d_instanceVar_STTHECS_i_dX=0.0;
instanceStruct.instanceVar_STXCOR_i=in.STXCOR_i;
instanceStruct.d_instanceVar_STXCOR_i_dX=0.0;
instanceStruct.instanceVar_RS_i=in.RS_i;
instanceStruct.d_instanceVar_RS_i_dX=0.0;
instanceStruct.instanceVar_RSIG_i=in.RSIG_i;
instanceStruct.d_instanceVar_RSIG_i_dX=0.0;
instanceStruct.instanceVar_STRS_i=in.STRS_i;
instanceStruct.d_instanceVar_STRS_i_dX=0.0;
instanceStruct.instanceVar_RSG_i=in.RSG_i;
instanceStruct.d_instanceVar_RSG_i_dX=0.0;
instanceStruct.instanceVar_THERSG_i=in.THERSG_i;
instanceStruct.d_instanceVar_THERSG_i_dX=0.0;
instanceStruct.instanceVar_RSB_i=in.RSB_i;
instanceStruct.d_instanceVar_RSB_i_dX=0.0;
instanceStruct.instanceVar_CT_i=in.CT_i;
instanceStruct.d_instanceVar_CT_i_dX=0.0;
instanceStruct.instanceVar_TOXP_i=in.TOXP_i;
instanceStruct.d_instanceVar_TOXP_i_dX=0.0;
instanceStruct.instanceVar_XCOR_i=in.XCOR_i;
instanceStruct.d_instanceVar_XCOR_i_dX=0.0;
instanceStruct.instanceVar_XCORB_i=in.XCORB_i;
instanceStruct.d_instanceVar_XCORB_i_dX=0.0;
instanceStruct.instanceVar_THESAT_i=in.THESAT_i;
instanceStruct.d_instanceVar_THESAT_i_dX=0.0;
instanceStruct.instanceVar_STTHESAT_i=in.STTHESAT_i;
instanceStruct.d_instanceVar_STTHESAT_i_dX=0.0;
instanceStruct.instanceVar_ALP_i=in.ALP_i;
instanceStruct.d_instanceVar_ALP_i_dX=0.0;
instanceStruct.instanceVar_ALP1_i=in.ALP1_i;
instanceStruct.d_instanceVar_ALP1_i_dX=0.0;
instanceStruct.instanceVar_ALPB_i=in.ALPB_i;
instanceStruct.d_instanceVar_ALPB_i_dX=0.0;
instanceStruct.instanceVar_VP_i=in.VP_i;
instanceStruct.d_instanceVar_VP_i_dX=0.0;
instanceStruct.instanceVar_VPG_i=in.VPG_i;
instanceStruct.d_instanceVar_VPG_i_dX=0.0;
instanceStruct.instanceVar_GCO_i=in.GCO_i;
instanceStruct.d_instanceVar_GCO_i_dX=0.0;
instanceStruct.instanceVar_IGINV_i=in.IGINV_i;
instanceStruct.d_instanceVar_IGINV_i_dX=0.0;
instanceStruct.instanceVar_IGOVINV_i=in.IGOVINV_i;
instanceStruct.d_instanceVar_IGOVINV_i_dX=0.0;
instanceStruct.instanceVar_IGOVINVD_i=in.IGOVINVD_i;
instanceStruct.d_instanceVar_IGOVINVD_i_dX=0.0;
instanceStruct.instanceVar_IGOVACC_i=in.IGOVACC_i;
instanceStruct.d_instanceVar_IGOVACC_i_dX=0.0;
instanceStruct.instanceVar_IGOVACCD_i=in.IGOVACCD_i;
instanceStruct.d_instanceVar_IGOVACCD_i_dX=0.0;
instanceStruct.instanceVar_STIG_i=in.STIG_i;
instanceStruct.d_instanceVar_STIG_i_dX=0.0;
instanceStruct.instanceVar_STIGFN_i=in.STIGFN_i;
instanceStruct.d_instanceVar_STIGFN_i_dX=0.0;
instanceStruct.instanceVar_FNOVINV_i=in.FNOVINV_i;
instanceStruct.d_instanceVar_FNOVINV_i_dX=0.0;
instanceStruct.instanceVar_FNOVINVD_i=in.FNOVINVD_i;
instanceStruct.d_instanceVar_FNOVINVD_i_dX=0.0;
instanceStruct.instanceVar_GC2CH_i=in.GC2CH_i;
instanceStruct.d_instanceVar_GC2CH_i_dX=0.0;
instanceStruct.instanceVar_GC3CH_i=in.GC3CH_i;
instanceStruct.d_instanceVar_GC3CH_i_dX=0.0;
instanceStruct.instanceVar_GC2OVINV_i=in.GC2OVINV_i;
instanceStruct.d_instanceVar_GC2OVINV_i_dX=0.0;
instanceStruct.instanceVar_GC3OVINV_i=in.GC3OVINV_i;
instanceStruct.d_instanceVar_GC3OVINV_i_dX=0.0;
instanceStruct.instanceVar_GC2OVACC_i=in.GC2OVACC_i;
instanceStruct.d_instanceVar_GC2OVACC_i_dX=0.0;
instanceStruct.instanceVar_GC3OVACC_i=in.GC3OVACC_i;
instanceStruct.d_instanceVar_GC3OVACC_i_dX=0.0;
instanceStruct.instanceVar_GCDOV_i=in.GCDOV_i;
instanceStruct.d_instanceVar_GCDOV_i_dX=0.0;
instanceStruct.instanceVar_GCVDOV_i=in.GCVDOV_i;
instanceStruct.d_instanceVar_GCVDOV_i_dX=0.0;
instanceStruct.instanceVar_CHIB_i=in.CHIB_i;
instanceStruct.d_instanceVar_CHIB_i_dX=0.0;
instanceStruct.instanceVar_NIGINV_i=in.NIGINV_i;
instanceStruct.d_instanceVar_NIGINV_i_dX=0.0;
instanceStruct.instanceVar_GCOVINVFN_i=in.GCOVINVFN_i;
instanceStruct.d_instanceVar_GCOVINVFN_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGIDLD_i=in.AGIDLD_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX=0.0;
instanceStruct.instanceVar_BGIDL_i=in.BGIDL_i;
instanceStruct.d_instanceVar_BGIDL_i_dX=0.0;
instanceStruct.instanceVar_BGIDLD_i=in.BGIDLD_i;
instanceStruct.d_instanceVar_BGIDLD_i_dX=0.0;
instanceStruct.instanceVar_STBGIDL_i=in.STBGIDL_i;
instanceStruct.d_instanceVar_STBGIDL_i_dX=0.0;
instanceStruct.instanceVar_STBGIDLD_i=in.STBGIDLD_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDLD_i=in.CGIDLD_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX=0.0;
instanceStruct.instanceVar_DGIDL_i=in.DGIDL_i;
instanceStruct.d_instanceVar_DGIDL_i_dX=0.0;
instanceStruct.instanceVar_DGIDLD_i=in.DGIDLD_i;
instanceStruct.d_instanceVar_DGIDLD_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_A2_i=in.A2_i;
instanceStruct.d_instanceVar_A2_i_dX=0.0;
instanceStruct.instanceVar_STA2_i=in.STA2_i;
instanceStruct.d_instanceVar_STA2_i_dX=0.0;
instanceStruct.instanceVar_A3_i=in.A3_i;
instanceStruct.d_instanceVar_A3_i_dX=0.0;
instanceStruct.instanceVar_AREAQ_i=in.AREAQ_i;
instanceStruct.d_instanceVar_AREAQ_i_dX=0.0;
instanceStruct.instanceVar_CGBOV_i=in.CGBOV_i;
instanceStruct.d_instanceVar_CGBOV_i_dX=0.0;
instanceStruct.instanceVar_NSDAC_i=in.NSDAC_i;
instanceStruct.d_instanceVar_NSDAC_i_dX=0.0;
instanceStruct.instanceVar_FIF_i=in.FIF_i;
instanceStruct.d_instanceVar_FIF_i_dX=0.0;
instanceStruct.instanceVar_FSCEAC_i=in.FSCEAC_i;
instanceStruct.d_instanceVar_FSCEAC_i_dX=0.0;
instanceStruct.instanceVar_COV_i=in.COV_i;
instanceStruct.d_instanceVar_COV_i_dX=0.0;
instanceStruct.instanceVar_COVD_i=in.COVD_i;
instanceStruct.d_instanceVar_COVD_i_dX=0.0;
instanceStruct.instanceVar_COVDL_i=in.COVDL_i;
instanceStruct.d_instanceVar_COVDL_i_dX=0.0;
instanceStruct.instanceVar_COVDLB_i=in.COVDLB_i;
instanceStruct.d_instanceVar_COVDLB_i_dX=0.0;
instanceStruct.instanceVar_DVFBOV_i=in.DVFBOV_i;
instanceStruct.d_instanceVar_DVFBOV_i_dX=0.0;
instanceStruct.instanceVar_CFR_i=in.CFR_i;
instanceStruct.d_instanceVar_CFR_i_dX=0.0;
instanceStruct.instanceVar_CFRD_i=in.CFRD_i;
instanceStruct.d_instanceVar_CFRD_i_dX=0.0;
instanceStruct.instanceVar_CSD_i=in.CSD_i;
instanceStruct.d_instanceVar_CSD_i_dX=0.0;
instanceStruct.instanceVar_CSDBP_i=in.CSDBP_i;
instanceStruct.d_instanceVar_CSDBP_i_dX=0.0;
instanceStruct.instanceVar_RTH_i=in.RTH_i;
instanceStruct.d_instanceVar_RTH_i_dX=0.0;
instanceStruct.instanceVar_STRTH_i=in.STRTH_i;
instanceStruct.d_instanceVar_STRTH_i_dX=0.0;
instanceStruct.instanceVar_CTH_i=in.CTH_i;
instanceStruct.d_instanceVar_CTH_i_dX=0.0;
instanceStruct.instanceVar_FNT_i=in.FNT_i;
instanceStruct.d_instanceVar_FNT_i_dX=0.0;
instanceStruct.instanceVar_FNTEXC_i=in.FNTEXC_i;
instanceStruct.d_instanceVar_FNTEXC_i_dX=0.0;
instanceStruct.instanceVar_NFA_i=in.NFA_i;
instanceStruct.d_instanceVar_NFA_i_dX=0.0;
instanceStruct.instanceVar_NFB_i=in.NFB_i;
instanceStruct.d_instanceVar_NFB_i_dX=0.0;
instanceStruct.instanceVar_NFC_i=in.NFC_i;
instanceStruct.d_instanceVar_NFC_i_dX=0.0;
instanceStruct.instanceVar_NFE_i=in.NFE_i;
instanceStruct.d_instanceVar_NFE_i_dX=0.0;
instanceStruct.instanceVar_NFEB_i=in.NFEB_i;
instanceStruct.d_instanceVar_NFEB_i_dX=0.0;
instanceStruct.instanceVar_EF_i=in.EF_i;
instanceStruct.d_instanceVar_EF_i_dX=0.0;
instanceStruct.instanceVar_VFB1_t=in.VFB1_t;
instanceStruct.d_instanceVar_VFB1_t_dX=0.0;
instanceStruct.instanceVar_CF1_t=in.CF1_t;
instanceStruct.d_instanceVar_CF1_t_dX=0.0;
instanceStruct.instanceVar_BETN1_t=in.BETN1_t;
instanceStruct.d_instanceVar_BETN1_t_dX=0.0;
instanceStruct.instanceVar_VFB2_t=in.VFB2_t;
instanceStruct.d_instanceVar_VFB2_t_dX=0.0;
instanceStruct.instanceVar_CF2_t=in.CF2_t;
instanceStruct.d_instanceVar_CF2_t_dX=0.0;
instanceStruct.instanceVar_BETN2_t=in.BETN2_t;
instanceStruct.d_instanceVar_BETN2_t_dX=0.0;
instanceStruct.instanceVar_MUE_t=in.MUE_t;
instanceStruct.d_instanceVar_MUE_t_dX=0.0;
instanceStruct.instanceVar_THEMU_t=in.THEMU_t;
instanceStruct.d_instanceVar_THEMU_t_dX=0.0;
instanceStruct.instanceVar_CS_t=in.CS_t;
instanceStruct.d_instanceVar_CS_t_dX=0.0;
instanceStruct.instanceVar_THECS_t=in.THECS_t;
instanceStruct.d_instanceVar_THECS_t_dX=0.0;
instanceStruct.instanceVar_RS_t=in.RS_t;
instanceStruct.d_instanceVar_RS_t_dX=0.0;
instanceStruct.instanceVar_XCOR_t=in.XCOR_t;
instanceStruct.d_instanceVar_XCOR_t_dX=0.0;
instanceStruct.instanceVar_THESAT_t=in.THESAT_t;
instanceStruct.d_instanceVar_THESAT_t_dX=0.0;
instanceStruct.instanceVar_IGINV_t=in.IGINV_t;
instanceStruct.d_instanceVar_IGINV_t_dX=0.0;
instanceStruct.instanceVar_IGOVINV_t=in.IGOVINV_t;
instanceStruct.d_instanceVar_IGOVINV_t_dX=0.0;
instanceStruct.instanceVar_IGOVINVD_t=in.IGOVINVD_t;
instanceStruct.d_instanceVar_IGOVINVD_t_dX=0.0;
instanceStruct.instanceVar_IGOVACC_t=in.IGOVACC_t;
instanceStruct.d_instanceVar_IGOVACC_t_dX=0.0;
instanceStruct.instanceVar_IGOVACCD_t=in.IGOVACCD_t;
instanceStruct.d_instanceVar_IGOVACCD_t_dX=0.0;
instanceStruct.instanceVar_FNOVINV_t=in.FNOVINV_t;
instanceStruct.d_instanceVar_FNOVINV_t_dX=0.0;
instanceStruct.instanceVar_FNOVINVD_t=in.FNOVINVD_t;
instanceStruct.d_instanceVar_FNOVINVD_t_dX=0.0;
instanceStruct.instanceVar_BGIDL_t=in.BGIDL_t;
instanceStruct.d_instanceVar_BGIDL_t_dX=0.0;
instanceStruct.instanceVar_BGIDLD_t=in.BGIDLD_t;
instanceStruct.d_instanceVar_BGIDLD_t_dX=0.0;
instanceStruct.instanceVar_A2_t=in.A2_t;
instanceStruct.d_instanceVar_A2_t_dX=0.0;
instanceStruct.instanceVar_RTH_t=in.RTH_t;
instanceStruct.d_instanceVar_RTH_t_dX=0.0;
instanceStruct.instanceVar_gamAX=in.gamAX;
instanceStruct.d_instanceVar_gamAX_dX=0.0;
instanceStruct.instanceVar_temp=in.temp;
instanceStruct.d_instanceVar_temp_dX=0.0;
instanceStruct.instanceVar_temp1=in.temp1;
instanceStruct.d_instanceVar_temp1_dX=0.0;
instanceStruct.instanceVar_temp2=in.temp2;
instanceStruct.d_instanceVar_temp2_dX=0.0;
instanceStruct.instanceVar_temp3=in.temp3;
instanceStruct.d_instanceVar_temp3_dX=0.0;
instanceStruct.instanceVar_temp4=in.temp4;
instanceStruct.d_instanceVar_temp4_dX=0.0;
instanceStruct.instanceVar_TKC=in.TKC;
instanceStruct.instanceVar_TKC_sq=in.TKC_sq;
instanceStruct.instanceVar_DTC=in.DTC;
instanceStruct.instanceVar_dT=in.dT;
instanceStruct.d_instanceVar_dT_dX=0.0;
instanceStruct.instanceVar_rT=in.rT;
instanceStruct.d_instanceVar_rT_dX=0.0;
instanceStruct.instanceVar_rTn=in.rTn;
instanceStruct.d_instanceVar_rTn_dX=0.0;
instanceStruct.instanceVar_phit0=in.phit0;
instanceStruct.instanceVar_inv_phit0=in.inv_phit0;
instanceStruct.instanceVar_phit=in.phit;
instanceStruct.d_instanceVar_phit_dX=0.0;
instanceStruct.instanceVar_inv_phit=in.inv_phit;
instanceStruct.d_instanceVar_inv_phit_dX=0.0;
instanceStruct.instanceVar_one_m_xge=in.one_m_xge;
instanceStruct.d_instanceVar_one_m_xge_dX=0.0;
instanceStruct.instanceVar_epsch=in.epsch;
instanceStruct.d_instanceVar_epsch_dX=0.0;
instanceStruct.instanceVar_EgSi=in.EgSi;
instanceStruct.instanceVar_EgGe=in.EgGe;
instanceStruct.instanceVar_dEg=in.dEg;
instanceStruct.d_instanceVar_dEg_dX=0.0;
instanceStruct.instanceVar_Eg=in.Eg;
instanceStruct.d_instanceVar_Eg_dX=0.0;
instanceStruct.instanceVar_Eg_2phit0=in.Eg_2phit0;
instanceStruct.d_instanceVar_Eg_2phit0_dX=0.0;
instanceStruct.instanceVar_Eg_2phit=in.Eg_2phit;
instanceStruct.d_instanceVar_Eg_2phit_dX=0.0;
instanceStruct.instanceVar_dVfbch=in.dVfbch;
instanceStruct.d_instanceVar_dVfbch_dX=0.0;
instanceStruct.instanceVar_niratio=in.niratio;
instanceStruct.d_instanceVar_niratio_dX=0.0;
instanceStruct.instanceVar_Cox2Init=in.Cox2Init;
instanceStruct.d_instanceVar_Cox2Init_dX=0.0;
instanceStruct.instanceVar_Cox1Prime=in.Cox1Prime;
instanceStruct.d_instanceVar_Cox1Prime_dX=0.0;
instanceStruct.instanceVar_Cox2Prime=in.Cox2Prime;
instanceStruct.d_instanceVar_Cox2Prime_dX=0.0;
instanceStruct.instanceVar_dVfb1Nch=in.dVfb1Nch;
instanceStruct.d_instanceVar_dVfb1Nch_dX=0.0;
instanceStruct.instanceVar_dVfb2Nch=in.dVfb2Nch;
instanceStruct.d_instanceVar_dVfb2Nch_dX=0.0;
instanceStruct.instanceVar_CsiPrime_0=in.CsiPrime_0;
instanceStruct.d_instanceVar_CsiPrime_0_dX=0.0;
instanceStruct.instanceVar_k1_1D=in.k1_1D;
instanceStruct.d_instanceVar_k1_1D_dX=0.0;
instanceStruct.instanceVar_k2_1D=in.k2_1D;
instanceStruct.d_instanceVar_k2_1D_dX=0.0;
instanceStruct.instanceVar_keq_1D=in.keq_1D;
instanceStruct.d_instanceVar_keq_1D_dX=0.0;
instanceStruct.instanceVar_neff=in.neff;
instanceStruct.d_instanceVar_neff_dX=0.0;
instanceStruct.instanceVar_A0_Csisq=in.A0_Csisq;
instanceStruct.d_instanceVar_A0_Csisq_dX=0.0;
instanceStruct.instanceVar_xth_1D=in.xth_1D;
instanceStruct.d_instanceVar_xth_1D_dX=0.0;
instanceStruct.instanceVar_xSDdep=in.xSDdep;
instanceStruct.d_instanceVar_xSDdep_dX=0.0;
instanceStruct.instanceVar_dVfbQM=in.dVfbQM;
instanceStruct.d_instanceVar_dVfbQM_dX=0.0;
instanceStruct.instanceVar_qq=in.qq;
instanceStruct.d_instanceVar_qq_dX=0.0;
instanceStruct.instanceVar_tsisq=in.tsisq;
instanceStruct.d_instanceVar_tsisq_dX=0.0;
instanceStruct.instanceVar_Gfsub=in.Gfsub;
instanceStruct.d_instanceVar_Gfsub_dX=0.0;
instanceStruct.instanceVar_Gfsub2=in.Gfsub2;
instanceStruct.d_instanceVar_Gfsub2_dX=0.0;
instanceStruct.instanceVar_inv_Gfsub2=in.inv_Gfsub2;
instanceStruct.d_instanceVar_inv_Gfsub2_dX=0.0;
instanceStruct.instanceVar_xisub=in.xisub;
instanceStruct.d_instanceVar_xisub_dX=0.0;
instanceStruct.instanceVar_inv_xisub=in.inv_xisub;
instanceStruct.d_instanceVar_inv_xisub_dX=0.0;
instanceStruct.instanceVar_margin_sub=in.margin_sub;
instanceStruct.d_instanceVar_margin_sub_dX=0.0;
instanceStruct.instanceVar_xn_sub=in.xn_sub;
instanceStruct.d_instanceVar_xn_sub_dX=0.0;
instanceStruct.instanceVar_fmue=in.fmue;
instanceStruct.d_instanceVar_fmue_dX=0.0;
instanceStruct.instanceVar_inv_qi1cs=in.inv_qi1cs;
instanceStruct.d_instanceVar_inv_qi1cs_dX=0.0;
instanceStruct.instanceVar_inv_qi2cs=in.inv_qi2cs;
instanceStruct.d_instanceVar_inv_qi2cs_dX=0.0;
instanceStruct.instanceVar_eta_mu=in.eta_mu;
instanceStruct.d_instanceVar_eta_mu_dX=0.0;
instanceStruct.instanceVar_one_m_eta=in.one_m_eta;
instanceStruct.d_instanceVar_one_m_eta_dX=0.0;
instanceStruct.instanceVar_frs=in.frs;
instanceStruct.d_instanceVar_frs_dX=0.0;
instanceStruct.instanceVar_sat_phit=in.sat_phit;
instanceStruct.d_instanceVar_sat_phit_dX=0.0;
instanceStruct.instanceVar_alp1_phit=in.alp1_phit;
instanceStruct.d_instanceVar_alp1_phit_dX=0.0;
instanceStruct.instanceVar_inv_CHIB=in.inv_CHIB;
instanceStruct.d_instanceVar_inv_CHIB_dX=0.0;
instanceStruct.instanceVar_tempM=in.tempM;
instanceStruct.d_instanceVar_tempM_dX=0.0;
instanceStruct.instanceVar_BCH=in.BCH;
instanceStruct.d_instanceVar_BCH_dX=0.0;
instanceStruct.instanceVar_BOV=in.BOV;
instanceStruct.d_instanceVar_BOV_dX=0.0;
instanceStruct.instanceVar_GCQCH=in.GCQCH;
instanceStruct.d_instanceVar_GCQCH_dX=0.0;
instanceStruct.instanceVar_GCQOVINV=in.GCQOVINV;
instanceStruct.d_instanceVar_GCQOVINV_dX=0.0;
instanceStruct.instanceVar_GCQOVACC=in.GCQOVACC;
instanceStruct.d_instanceVar_GCQOVACC_dX=0.0;
instanceStruct.instanceVar_alpha_b=in.alpha_b;
instanceStruct.d_instanceVar_alpha_b_dX=0.0;
instanceStruct.instanceVar_Dch=in.Dch;
instanceStruct.d_instanceVar_Dch_dX=0.0;
instanceStruct.instanceVar_Dov=in.Dov;
instanceStruct.d_instanceVar_Dov_dX=0.0;
instanceStruct.instanceVar_n_iginv=in.n_iginv;
instanceStruct.d_instanceVar_n_iginv_dX=0.0;
instanceStruct.instanceVar_area_phit=in.area_phit;
instanceStruct.d_instanceVar_area_phit_dX=0.0;
instanceStruct.instanceVar_inner_sd=in.inner_sd;
instanceStruct.d_instanceVar_inner_sd_dX=0.0;
instanceStruct.instanceVar_xsd=in.xsd;
instanceStruct.d_instanceVar_xsd_dX=0.0;
instanceStruct.instanceVar_fif_phit=in.fif_phit;
instanceStruct.d_instanceVar_fif_phit_dX=0.0;
instanceStruct.instanceVar_lambda2D=in.lambda2D;
instanceStruct.d_instanceVar_lambda2D_dX=0.0;
instanceStruct.instanceVar_lnrTn=in.lnrTn;
instanceStruct.d_instanceVar_lnrTn_dX=0.0;
instanceStruct.instanceVar_tf_bet=in.tf_bet;
instanceStruct.d_instanceVar_tf_bet_dX=0.0;
instanceStruct.instanceVar_tf_mue=in.tf_mue;
instanceStruct.d_instanceVar_tf_mue_dX=0.0;
instanceStruct.instanceVar_tf_themu=in.tf_themu;
instanceStruct.d_instanceVar_tf_themu_dX=0.0;
instanceStruct.instanceVar_tf_cs=in.tf_cs;
instanceStruct.d_instanceVar_tf_cs_dX=0.0;
instanceStruct.instanceVar_tf_thecs=in.tf_thecs;
instanceStruct.d_instanceVar_tf_thecs_dX=0.0;
instanceStruct.instanceVar_tf_xcor=in.tf_xcor;
instanceStruct.d_instanceVar_tf_xcor_dX=0.0;
instanceStruct.instanceVar_tf_ther=in.tf_ther;
instanceStruct.d_instanceVar_tf_ther_dX=0.0;
instanceStruct.instanceVar_tf_thesat=in.tf_thesat;
instanceStruct.d_instanceVar_tf_thesat_dX=0.0;
instanceStruct.instanceVar_tf_ig=in.tf_ig;
instanceStruct.d_instanceVar_tf_ig_dX=0.0;
instanceStruct.instanceVar_tf_rth=in.tf_rth;
instanceStruct.d_instanceVar_tf_rth_dX=0.0;
instanceStruct.instanceVar_nt=in.nt;
instanceStruct.d_instanceVar_nt_dX=0.0;
instanceStruct.instanceVar_nt0=in.nt0;
instanceStruct.d_instanceVar_nt0_dX=0.0;
instanceStruct.instanceVar_fac_exc=in.fac_exc;
instanceStruct.d_instanceVar_fac_exc_dX=0.0;
instanceStruct.instanceVar_sigVds=in.sigVds;
instanceStruct.instanceVar_CsiPrime=in.CsiPrime;
instanceStruct.d_instanceVar_CsiPrime_dX=0.0;
instanceStruct.instanceVar_xd0=in.xd0;
instanceStruct.d_instanceVar_xd0_dX=0.0;
instanceStruct.instanceVar_k1=in.k1;
instanceStruct.d_instanceVar_k1_dX=0.0;
instanceStruct.instanceVar_qis=in.qis;
instanceStruct.d_instanceVar_qis_dX=0.0;
instanceStruct.instanceVar_ds=in.ds;
instanceStruct.d_instanceVar_ds_dX=0.0;
instanceStruct.instanceVar_qid=in.qid;
instanceStruct.d_instanceVar_qid_dX=0.0;
instanceStruct.instanceVar_dd=in.dd;
instanceStruct.d_instanceVar_dd_dX=0.0;
instanceStruct.instanceVar_esurf1=in.esurf1;
instanceStruct.d_instanceVar_esurf1_dX=0.0;
instanceStruct.instanceVar_qmfact1=in.qmfact1;
instanceStruct.d_instanceVar_qmfact1_dX=0.0;
instanceStruct.instanceVar_esurf2=in.esurf2;
instanceStruct.d_instanceVar_esurf2_dX=0.0;
instanceStruct.instanceVar_betneff=in.betneff;
instanceStruct.d_instanceVar_betneff_dX=0.0;
instanceStruct.instanceVar_xdeff=in.xdeff;
instanceStruct.d_instanceVar_xdeff_dX=0.0;
instanceStruct.instanceVar_qim=in.qim;
instanceStruct.d_instanceVar_qim_dX=0.0;
instanceStruct.instanceVar_Gmob=in.Gmob;
instanceStruct.d_instanceVar_Gmob_dX=0.0;
instanceStruct.instanceVar_FdL=in.FdL;
instanceStruct.d_instanceVar_FdL_dX=0.0;
instanceStruct.instanceVar_Ggamma=in.Ggamma;
instanceStruct.d_instanceVar_Ggamma_dX=0.0;
instanceStruct.instanceVar_zsat=in.zsat;
instanceStruct.d_instanceVar_zsat_dX=0.0;
instanceStruct.instanceVar_hsat=in.hsat;
instanceStruct.d_instanceVar_hsat_dX=0.0;
instanceStruct.instanceVar_Gvsat=in.Gvsat;
instanceStruct.d_instanceVar_Gvsat_dX=0.0;
instanceStruct.instanceVar_qmfact=in.qmfact;
instanceStruct.d_instanceVar_qmfact_dX=0.0;
instanceStruct.instanceVar_fact_Ids=in.fact_Ids;
instanceStruct.d_instanceVar_fact_Ids_dX=0.0;
instanceStruct.instanceVar_Ids=in.Ids;
instanceStruct.d_instanceVar_Ids_dX=0.0;
instanceStruct.instanceVar_delta_k1q1=in.delta_k1q1;
instanceStruct.d_instanceVar_delta_k1q1_dX=0.0;
instanceStruct.instanceVar_inv_k1h1_0=in.inv_k1h1_0;
instanceStruct.d_instanceVar_inv_k1h1_0_dX=0.0;
instanceStruct.instanceVar_Igse=in.Igse;
instanceStruct.d_instanceVar_Igse_dX=0.0;
instanceStruct.instanceVar_Igde=in.Igde;
instanceStruct.d_instanceVar_Igde_dX=0.0;
instanceStruct.instanceVar_Igidle=in.Igidle;
instanceStruct.d_instanceVar_Igidle_dX=0.0;
instanceStruct.instanceVar_Igisle=in.Igisle;
instanceStruct.d_instanceVar_Igisle_dX=0.0;
instanceStruct.instanceVar_mavl=in.mavl;
instanceStruct.d_instanceVar_mavl_dX=0.0;
instanceStruct.instanceVar_Iimpact=in.Iimpact;
instanceStruct.d_instanceVar_Iimpact_dX=0.0;


  //non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_D_GND] = (*solVectorPtr)[in.li_D];
probeVars[in.admsProbeID_V_S_GND] = (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_B_GND] = (*solVectorPtr)[in.li_B];
probeVars[in.admsProbeID_V_G_GND] = (*solVectorPtr)[in.li_G];
probeVars[in.admsProbeID_I_NSIG_GND] = (*solVectorPtr)[in.li_BRA_NSIG_GND];
probeVars[in.admsProbeID_V_NSIG_GND] = (*solVectorPtr)[in.li_NSIG];
probeVars[in.admsProbeID_Temp_Tnode_GND] = (*solVectorPtr)[in.li_Tnode];
probeVars[in.admsProbeID_V_S_B] = (*solVectorPtr)[in.li_S] - (*solVectorPtr)[in.li_B];
probeVars[in.admsProbeID_V_D_S] = (*solVectorPtr)[in.li_D] - (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_G_S] = (*solVectorPtr)[in.li_G] - (*solVectorPtr)[in.li_S];



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_D_GND,
in.admsProbeID_V_S_GND,
in.admsProbeID_V_B_GND,
in.admsProbeID_V_G_GND,
in.admsProbeID_I_NSIG_GND,
in.admsProbeID_V_NSIG_GND,
in.admsProbeID_Temp_Tnode_GND,
in.admsProbeID_V_S_B,
in.admsProbeID_V_D_S,
in.admsProbeID_V_G_S,

// node constants
in.admsNodeID_D,
in.admsNodeID_G,
in.admsNodeID_S,
in.admsNodeID_B,
in.admsNodeID_Tnode,
in.admsNodeID_NSIG,
in.admsBRA_ID_NSIG_GND,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D+inst*(6+1)] += d_staticContributions_dX[in.admsNodeID_D];
    dqdp[in.admsNodeID_D+inst*(6+1)] += d_dynamicContributions_dX[in.admsNodeID_D];
    Findices[in.admsNodeID_D+inst*(6+1)] = in.li_D;
    Qindices[in.admsNodeID_D+inst*(6+1)] = in.li_D;
    dfdp[in.admsNodeID_G+inst*(6+1)] += d_staticContributions_dX[in.admsNodeID_G];
    dqdp[in.admsNodeID_G+inst*(6+1)] += d_dynamicContributions_dX[in.admsNodeID_G];
    Findices[in.admsNodeID_G+inst*(6+1)] = in.li_G;
    Qindices[in.admsNodeID_G+inst*(6+1)] = in.li_G;
    dfdp[in.admsNodeID_S+inst*(6+1)] += d_staticContributions_dX[in.admsNodeID_S];
    dqdp[in.admsNodeID_S+inst*(6+1)] += d_dynamicContributions_dX[in.admsNodeID_S];
    Findices[in.admsNodeID_S+inst*(6+1)] = in.li_S;
    Qindices[in.admsNodeID_S+inst*(6+1)] = in.li_S;
    dfdp[in.admsNodeID_B+inst*(6+1)] += d_staticContributions_dX[in.admsNodeID_B];
    dqdp[in.admsNodeID_B+inst*(6+1)] += d_dynamicContributions_dX[in.admsNodeID_B];
    Findices[in.admsNodeID_B+inst*(6+1)] = in.li_B;
    Qindices[in.admsNodeID_B+inst*(6+1)] = in.li_B;
    dfdp[in.admsNodeID_Tnode+inst*(6+1)] += d_staticContributions_dX[in.admsNodeID_Tnode];
    dqdp[in.admsNodeID_Tnode+inst*(6+1)] += d_dynamicContributions_dX[in.admsNodeID_Tnode];
    Findices[in.admsNodeID_Tnode+inst*(6+1)] = in.li_Tnode;
    Qindices[in.admsNodeID_Tnode+inst*(6+1)] = in.li_Tnode;
    dfdp[in.admsNodeID_NSIG+inst*(6+1)] += d_staticContributions_dX[in.admsNodeID_NSIG];
    dqdp[in.admsNodeID_NSIG+inst*(6+1)] += d_dynamicContributions_dX[in.admsNodeID_NSIG];
    Findices[in.admsNodeID_NSIG+inst*(6+1)] = in.li_NSIG;
    Qindices[in.admsNodeID_NSIG+inst*(6+1)] = in.li_NSIG;
    dfdp[in.admsBRA_ID_NSIG_GND+inst*(6+1)] += d_staticContributions_dX[in.admsBRA_ID_NSIG_GND];
    dqdp[in.admsBRA_ID_NSIG_GND+inst*(6+1)] += d_dynamicContributions_dX[in.admsBRA_ID_NSIG_GND];
    Findices[in.admsBRA_ID_NSIG_GND+inst*(6+1)] = in.li_BRA_NSIG_GND;
    Qindices[in.admsBRA_ID_NSIG_GND+inst*(6+1)] = in.li_BRA_NSIG_GND;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSl_utsoi
} // namespace Device
} // namespace Xyce
