
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file mvsg_cmc_1.1.0.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:28
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSmvsg_cmc.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>


#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMSmvsg_cmc {
namespace AnalogFunctions {
// Derivative of Analog Function absfunc
double d_absfunc(double x  , double d_x )
{
// Function return variable and total deriv
double absfunc;
double d_absfunc;
// Derivatives of return value w.r.t input vars
double d_absfunc_d_x;
{
d_absfunc_d_x=(0.5/sqrt(((x*x)+(4.0*1e-5))))*(x+x);
absfunc=sqrt(((x*x)+(4.0*1e-5)));
}
d_absfunc = d_absfunc_d_x*d_x;
return(d_absfunc);
}

// Evaluator class implementations for Analog Function absfunc
  // Constructor
  absfuncEvaluator::absfuncEvaluator(double x)
  {
    absfuncReturn_ = evaluator_(x);
  }
  // method to get precomputed values into double vars 
  double absfuncEvaluator::getValues(double  x)
  {
    // Silence unused argument warnings
    (void) x;
    // Copy all precomputed values into corresponding output
    return(absfuncReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double absfuncEvaluator::getDerivs(double x  , double d_x)
  {
    // Function total deriv
    double d_absfunc;
    // Silence unused argument warnings
    (void) x;
    d_absfunc = absfuncReturn_.deriv_WRT_x*d_x;
    return(d_absfunc);
  }
  // method that actually performs our computations.
  absfuncEvaluator::returnType absfuncEvaluator::evaluator_(double x)
  {
  // Function value and derivs variables, and a returnType to store everything
  double absfunc;
  absfuncEvaluator::returnType absfuncReturn;
  // Derivatives of return value w.r.t input vars
  double d_absfunc_d_x;
  // declared local variables
{
d_absfunc_d_x=(0.5/sqrt(((x*x)+(4.0*1e-5))))*(x+x);
absfunc=sqrt(((x*x)+(4.0*1e-5)));
}
  // now save outputs and derivs into appropriate return vars
  absfuncReturn.value=absfunc;
  absfuncReturn.deriv_WRT_x = d_absfunc_d_x;
  return(absfuncReturn);
  }

// Derivative of Analog Function mmax
double d_mmax(double x , double y  , double d_x , double d_y )
{
// Function return variable and total deriv
double mmax;
double d_mmax;
// Derivatives of return value w.r.t input vars
double d_mmax_d_x;
double d_mmax_d_y;
{
d_mmax_d_x=(0.5*(1.0+(0.5/sqrt((((x-y)*(x-y))+(4.0*1e-5))))*((x-y)+(x-y))));
d_mmax_d_y=(0.5*(1.0+(0.5/sqrt((((x-y)*(x-y))+(4.0*1e-5))))*(((x-y)*(-1.0))+((-1.0)*(x-y)))));
mmax=(0.5*((x+y)+sqrt((((x-y)*(x-y))+(4.0*1e-5)))));
}
d_mmax = d_mmax_d_x*d_x+d_mmax_d_y*d_y;
return(d_mmax);
}

// Evaluator class implementations for Analog Function mmax
  // Constructor
  mmaxEvaluator::mmaxEvaluator(double x, double y)
  {
    mmaxReturn_ = evaluator_(x, y);
  }
  // method to get precomputed values into double vars 
  double mmaxEvaluator::getValues(double  x, double  y)
  {
    // Silence unused argument warnings
    (void) x;
    (void) y;
    // Copy all precomputed values into corresponding output
    return(mmaxReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double mmaxEvaluator::getDerivs(double x , double y  , double d_x, double d_y)
  {
    // Function total deriv
    double d_mmax;
    // Silence unused argument warnings
    (void) x;
    (void) y;
    d_mmax = mmaxReturn_.deriv_WRT_x*d_x+mmaxReturn_.deriv_WRT_y*d_y;
    return(d_mmax);
  }
  // method that actually performs our computations.
  mmaxEvaluator::returnType mmaxEvaluator::evaluator_(double x, double y)
  {
  // Function value and derivs variables, and a returnType to store everything
  double mmax;
  mmaxEvaluator::returnType mmaxReturn;
  // Derivatives of return value w.r.t input vars
  double d_mmax_d_x;
  double d_mmax_d_y;
  // declared local variables
{
d_mmax_d_x=(0.5*(1.0+(0.5/sqrt((((x-y)*(x-y))+(4.0*1e-5))))*((x-y)+(x-y))));
d_mmax_d_y=(0.5*(1.0+(0.5/sqrt((((x-y)*(x-y))+(4.0*1e-5))))*(((x-y)*(-1.0))+((-1.0)*(x-y)))));
mmax=(0.5*((x+y)+sqrt((((x-y)*(x-y))+(4.0*1e-5)))));
}
  // now save outputs and derivs into appropriate return vars
  mmaxReturn.value=mmax;
  mmaxReturn.deriv_WRT_x = d_mmax_d_x;
  mmaxReturn.deriv_WRT_y = d_mmax_d_y;
  return(mmaxReturn);
  }

// Derivative of Analog Function explim
double d_explim(double x  , double d_x )
{
// Function return variable and total deriv
double explim;
double d_explim;
// Derivatives of return value w.r.t input vars
double d_explim_d_x;
{
if((x>50.0))
{
d_explim_d_x=(exp(50.0));
explim=(exp(50.0)*(1.0+(x-50.0)));
}
else
{
if((x<(-50.0)))
{
d_explim_d_x=0.0;
explim=exp((-50.0));
}
else
{
d_explim_d_x=exp(x);
explim=exp(x);
}
}
}
d_explim = d_explim_d_x*d_x;
return(d_explim);
}

// Evaluator class implementations for Analog Function explim
  // Constructor
  explimEvaluator::explimEvaluator(double x)
  {
    explimReturn_ = evaluator_(x);
  }
  // method to get precomputed values into double vars 
  double explimEvaluator::getValues(double  x)
  {
    // Silence unused argument warnings
    (void) x;
    // Copy all precomputed values into corresponding output
    return(explimReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double explimEvaluator::getDerivs(double x  , double d_x)
  {
    // Function total deriv
    double d_explim;
    // Silence unused argument warnings
    (void) x;
    d_explim = explimReturn_.deriv_WRT_x*d_x;
    return(d_explim);
  }
  // method that actually performs our computations.
  explimEvaluator::returnType explimEvaluator::evaluator_(double x)
  {
  // Function value and derivs variables, and a returnType to store everything
  double explim;
  explimEvaluator::returnType explimReturn;
  // Derivatives of return value w.r.t input vars
  double d_explim_d_x;
  // declared local variables
{
if((x>50.0))
{
d_explim_d_x=(exp(50.0));
explim=(exp(50.0)*(1.0+(x-50.0)));
}
else
{
if((x<(-50.0)))
{
d_explim_d_x=0.0;
explim=exp((-50.0));
}
else
{
d_explim_d_x=exp(x);
explim=exp(x);
}
}
}
  // now save outputs and derivs into appropriate return vars
  explimReturn.value=explim;
  explimReturn.deriv_WRT_x = d_explim_d_x;
  return(explimReturn);
  }

// Derivative of Analog Function calc_iq
double d_calc_iq(double idsout , double qgsout , double qgdout , double qcout , double qbout , double qsout , double vtdibl , double vdsat1 , double vgsin , double vdsin , double qcbflag , double vcin , double vbin , double qgsflag , double tambin , double tnomin , double phitin , double w , double lin , double cgin , double cs , double cc , double cb , double vto , double ss , double delta1 , double delta2 , double nd , double alpha , double vel0 , double mu0 , double beta , double mtheta , double vtheta , double vtzeta , double dibsat , double epsilon , double vzeta , double lambda , double ngf , double type  , double & d_idsout , double & d_qgsout , double & d_qgdout , double & d_qcout , double & d_qbout , double & d_qsout , double & d_vtdibl , double & d_vdsat1 , double d_vgsin , double d_vdsin , double d_qcbflag , double d_vcin , double d_vbin , double d_qgsflag , double d_tambin , double d_tnomin , double d_phitin , double d_w , double d_lin , double d_cgin , double d_cs , double d_cc , double d_cb , double d_vto , double d_ss , double d_delta1 , double d_delta2 , double d_nd , double d_alpha , double d_vel0 , double d_mu0 , double d_beta , double d_mtheta , double d_vtheta , double d_vtzeta , double d_dibsat , double d_epsilon , double d_vzeta , double d_lambda , double d_ngf , double d_type )
{
// Function return variable and total deriv
double calc_iq;
double d_calc_iq;
// Derivatives of return value w.r.t input vars
double d_calc_iq_d_vgsin;
double d_calc_iq_d_vdsin;
double d_calc_iq_d_qcbflag;
double d_calc_iq_d_vcin;
double d_calc_iq_d_vbin;
double d_calc_iq_d_qgsflag;
double d_calc_iq_d_tambin;
double d_calc_iq_d_tnomin;
double d_calc_iq_d_phitin;
double d_calc_iq_d_w;
double d_calc_iq_d_lin;
double d_calc_iq_d_cgin;
double d_calc_iq_d_cs;
double d_calc_iq_d_cc;
double d_calc_iq_d_cb;
double d_calc_iq_d_vto;
double d_calc_iq_d_ss;
double d_calc_iq_d_delta1;
double d_calc_iq_d_delta2;
double d_calc_iq_d_nd;
double d_calc_iq_d_alpha;
double d_calc_iq_d_vel0;
double d_calc_iq_d_mu0;
double d_calc_iq_d_beta;
double d_calc_iq_d_mtheta;
double d_calc_iq_d_vtheta;
double d_calc_iq_d_vtzeta;
double d_calc_iq_d_dibsat;
double d_calc_iq_d_epsilon;
double d_calc_iq_d_vzeta;
double d_calc_iq_d_lambda;
double d_calc_iq_d_ngf;
double d_calc_iq_d_type;
// Derivatives of additional output vars w.r.t input vars
double d_idsout_d_vgsin;
double d_qgsout_d_vgsin;
double d_qgdout_d_vgsin;
double d_qcout_d_vgsin;
double d_qbout_d_vgsin;
double d_qsout_d_vgsin;
double d_vtdibl_d_vgsin;
double d_vdsat1_d_vgsin;
double d_idsout_d_vdsin;
double d_qgsout_d_vdsin;
double d_qgdout_d_vdsin;
double d_qcout_d_vdsin;
double d_qbout_d_vdsin;
double d_qsout_d_vdsin;
double d_vtdibl_d_vdsin;
double d_vdsat1_d_vdsin;
double d_idsout_d_qcbflag;
double d_qgsout_d_qcbflag;
double d_qgdout_d_qcbflag;
double d_qcout_d_qcbflag;
double d_qbout_d_qcbflag;
double d_qsout_d_qcbflag;
double d_vtdibl_d_qcbflag;
double d_vdsat1_d_qcbflag;
double d_idsout_d_vcin;
double d_qgsout_d_vcin;
double d_qgdout_d_vcin;
double d_qcout_d_vcin;
double d_qbout_d_vcin;
double d_qsout_d_vcin;
double d_vtdibl_d_vcin;
double d_vdsat1_d_vcin;
double d_idsout_d_vbin;
double d_qgsout_d_vbin;
double d_qgdout_d_vbin;
double d_qcout_d_vbin;
double d_qbout_d_vbin;
double d_qsout_d_vbin;
double d_vtdibl_d_vbin;
double d_vdsat1_d_vbin;
double d_idsout_d_qgsflag;
double d_qgsout_d_qgsflag;
double d_qgdout_d_qgsflag;
double d_qcout_d_qgsflag;
double d_qbout_d_qgsflag;
double d_qsout_d_qgsflag;
double d_vtdibl_d_qgsflag;
double d_vdsat1_d_qgsflag;
double d_idsout_d_tambin;
double d_qgsout_d_tambin;
double d_qgdout_d_tambin;
double d_qcout_d_tambin;
double d_qbout_d_tambin;
double d_qsout_d_tambin;
double d_vtdibl_d_tambin;
double d_vdsat1_d_tambin;
double d_idsout_d_tnomin;
double d_qgsout_d_tnomin;
double d_qgdout_d_tnomin;
double d_qcout_d_tnomin;
double d_qbout_d_tnomin;
double d_qsout_d_tnomin;
double d_vtdibl_d_tnomin;
double d_vdsat1_d_tnomin;
double d_idsout_d_phitin;
double d_qgsout_d_phitin;
double d_qgdout_d_phitin;
double d_qcout_d_phitin;
double d_qbout_d_phitin;
double d_qsout_d_phitin;
double d_vtdibl_d_phitin;
double d_vdsat1_d_phitin;
double d_idsout_d_w;
double d_qgsout_d_w;
double d_qgdout_d_w;
double d_qcout_d_w;
double d_qbout_d_w;
double d_qsout_d_w;
double d_vtdibl_d_w;
double d_vdsat1_d_w;
double d_idsout_d_lin;
double d_qgsout_d_lin;
double d_qgdout_d_lin;
double d_qcout_d_lin;
double d_qbout_d_lin;
double d_qsout_d_lin;
double d_vtdibl_d_lin;
double d_vdsat1_d_lin;
double d_idsout_d_cgin;
double d_qgsout_d_cgin;
double d_qgdout_d_cgin;
double d_qcout_d_cgin;
double d_qbout_d_cgin;
double d_qsout_d_cgin;
double d_vtdibl_d_cgin;
double d_vdsat1_d_cgin;
double d_idsout_d_cs;
double d_qgsout_d_cs;
double d_qgdout_d_cs;
double d_qcout_d_cs;
double d_qbout_d_cs;
double d_qsout_d_cs;
double d_vtdibl_d_cs;
double d_vdsat1_d_cs;
double d_idsout_d_cc;
double d_qgsout_d_cc;
double d_qgdout_d_cc;
double d_qcout_d_cc;
double d_qbout_d_cc;
double d_qsout_d_cc;
double d_vtdibl_d_cc;
double d_vdsat1_d_cc;
double d_idsout_d_cb;
double d_qgsout_d_cb;
double d_qgdout_d_cb;
double d_qcout_d_cb;
double d_qbout_d_cb;
double d_qsout_d_cb;
double d_vtdibl_d_cb;
double d_vdsat1_d_cb;
double d_idsout_d_vto;
double d_qgsout_d_vto;
double d_qgdout_d_vto;
double d_qcout_d_vto;
double d_qbout_d_vto;
double d_qsout_d_vto;
double d_vtdibl_d_vto;
double d_vdsat1_d_vto;
double d_idsout_d_ss;
double d_qgsout_d_ss;
double d_qgdout_d_ss;
double d_qcout_d_ss;
double d_qbout_d_ss;
double d_qsout_d_ss;
double d_vtdibl_d_ss;
double d_vdsat1_d_ss;
double d_idsout_d_delta1;
double d_qgsout_d_delta1;
double d_qgdout_d_delta1;
double d_qcout_d_delta1;
double d_qbout_d_delta1;
double d_qsout_d_delta1;
double d_vtdibl_d_delta1;
double d_vdsat1_d_delta1;
double d_idsout_d_delta2;
double d_qgsout_d_delta2;
double d_qgdout_d_delta2;
double d_qcout_d_delta2;
double d_qbout_d_delta2;
double d_qsout_d_delta2;
double d_vtdibl_d_delta2;
double d_vdsat1_d_delta2;
double d_idsout_d_nd;
double d_qgsout_d_nd;
double d_qgdout_d_nd;
double d_qcout_d_nd;
double d_qbout_d_nd;
double d_qsout_d_nd;
double d_vtdibl_d_nd;
double d_vdsat1_d_nd;
double d_idsout_d_alpha;
double d_qgsout_d_alpha;
double d_qgdout_d_alpha;
double d_qcout_d_alpha;
double d_qbout_d_alpha;
double d_qsout_d_alpha;
double d_vtdibl_d_alpha;
double d_vdsat1_d_alpha;
double d_idsout_d_vel0;
double d_qgsout_d_vel0;
double d_qgdout_d_vel0;
double d_qcout_d_vel0;
double d_qbout_d_vel0;
double d_qsout_d_vel0;
double d_vtdibl_d_vel0;
double d_vdsat1_d_vel0;
double d_idsout_d_mu0;
double d_qgsout_d_mu0;
double d_qgdout_d_mu0;
double d_qcout_d_mu0;
double d_qbout_d_mu0;
double d_qsout_d_mu0;
double d_vtdibl_d_mu0;
double d_vdsat1_d_mu0;
double d_idsout_d_beta;
double d_qgsout_d_beta;
double d_qgdout_d_beta;
double d_qcout_d_beta;
double d_qbout_d_beta;
double d_qsout_d_beta;
double d_vtdibl_d_beta;
double d_vdsat1_d_beta;
double d_idsout_d_mtheta;
double d_qgsout_d_mtheta;
double d_qgdout_d_mtheta;
double d_qcout_d_mtheta;
double d_qbout_d_mtheta;
double d_qsout_d_mtheta;
double d_vtdibl_d_mtheta;
double d_vdsat1_d_mtheta;
double d_idsout_d_vtheta;
double d_qgsout_d_vtheta;
double d_qgdout_d_vtheta;
double d_qcout_d_vtheta;
double d_qbout_d_vtheta;
double d_qsout_d_vtheta;
double d_vtdibl_d_vtheta;
double d_vdsat1_d_vtheta;
double d_idsout_d_vtzeta;
double d_qgsout_d_vtzeta;
double d_qgdout_d_vtzeta;
double d_qcout_d_vtzeta;
double d_qbout_d_vtzeta;
double d_qsout_d_vtzeta;
double d_vtdibl_d_vtzeta;
double d_vdsat1_d_vtzeta;
double d_idsout_d_dibsat;
double d_qgsout_d_dibsat;
double d_qgdout_d_dibsat;
double d_qcout_d_dibsat;
double d_qbout_d_dibsat;
double d_qsout_d_dibsat;
double d_vtdibl_d_dibsat;
double d_vdsat1_d_dibsat;
double d_idsout_d_epsilon;
double d_qgsout_d_epsilon;
double d_qgdout_d_epsilon;
double d_qcout_d_epsilon;
double d_qbout_d_epsilon;
double d_qsout_d_epsilon;
double d_vtdibl_d_epsilon;
double d_vdsat1_d_epsilon;
double d_idsout_d_vzeta;
double d_qgsout_d_vzeta;
double d_qgdout_d_vzeta;
double d_qcout_d_vzeta;
double d_qbout_d_vzeta;
double d_qsout_d_vzeta;
double d_vtdibl_d_vzeta;
double d_vdsat1_d_vzeta;
double d_idsout_d_lambda;
double d_qgsout_d_lambda;
double d_qgdout_d_lambda;
double d_qcout_d_lambda;
double d_qbout_d_lambda;
double d_qsout_d_lambda;
double d_vtdibl_d_lambda;
double d_vdsat1_d_lambda;
double d_idsout_d_ngf;
double d_qgsout_d_ngf;
double d_qgdout_d_ngf;
double d_qcout_d_ngf;
double d_qbout_d_ngf;
double d_qsout_d_ngf;
double d_vtdibl_d_ngf;
double d_vdsat1_d_ngf;
double d_idsout_d_type;
double d_qgsout_d_type;
double d_qgdout_d_type;
double d_qcout_d_type;
double d_qbout_d_type;
double d_qsout_d_type;
double d_vtdibl_d_type;
double d_vdsat1_d_type;
double alpha_phit;
double d_alpha_phit_d_vgsin;
double d_alpha_phit_d_vdsin;
double d_alpha_phit_d_qcbflag;
double d_alpha_phit_d_vcin;
double d_alpha_phit_d_vbin;
double d_alpha_phit_d_qgsflag;
double d_alpha_phit_d_tambin;
double d_alpha_phit_d_tnomin;
double d_alpha_phit_d_phitin;
double d_alpha_phit_d_w;
double d_alpha_phit_d_lin;
double d_alpha_phit_d_cgin;
double d_alpha_phit_d_cs;
double d_alpha_phit_d_cc;
double d_alpha_phit_d_cb;
double d_alpha_phit_d_vto;
double d_alpha_phit_d_ss;
double d_alpha_phit_d_delta1;
double d_alpha_phit_d_delta2;
double d_alpha_phit_d_nd;
double d_alpha_phit_d_alpha;
double d_alpha_phit_d_vel0;
double d_alpha_phit_d_mu0;
double d_alpha_phit_d_beta;
double d_alpha_phit_d_mtheta;
double d_alpha_phit_d_vtheta;
double d_alpha_phit_d_vtzeta;
double d_alpha_phit_d_dibsat;
double d_alpha_phit_d_epsilon;
double d_alpha_phit_d_vzeta;
double d_alpha_phit_d_lambda;
double d_alpha_phit_d_ngf;
double d_alpha_phit_d_type;
double delta;
double d_delta_d_vgsin;
double d_delta_d_vdsin;
double d_delta_d_qcbflag;
double d_delta_d_vcin;
double d_delta_d_vbin;
double d_delta_d_qgsflag;
double d_delta_d_tambin;
double d_delta_d_tnomin;
double d_delta_d_phitin;
double d_delta_d_w;
double d_delta_d_lin;
double d_delta_d_cgin;
double d_delta_d_cs;
double d_delta_d_cc;
double d_delta_d_cb;
double d_delta_d_vto;
double d_delta_d_ss;
double d_delta_d_delta1;
double d_delta_d_delta2;
double d_delta_d_nd;
double d_delta_d_alpha;
double d_delta_d_vel0;
double d_delta_d_mu0;
double d_delta_d_beta;
double d_delta_d_mtheta;
double d_delta_d_vtheta;
double d_delta_d_vtzeta;
double d_delta_d_dibsat;
double d_delta_d_epsilon;
double d_delta_d_vzeta;
double d_delta_d_lambda;
double d_delta_d_ngf;
double d_delta_d_type;
double n;
double d_n_d_vgsin;
double d_n_d_vdsin;
double d_n_d_qcbflag;
double d_n_d_vcin;
double d_n_d_vbin;
double d_n_d_qgsflag;
double d_n_d_tambin;
double d_n_d_tnomin;
double d_n_d_phitin;
double d_n_d_w;
double d_n_d_lin;
double d_n_d_cgin;
double d_n_d_cs;
double d_n_d_cc;
double d_n_d_cb;
double d_n_d_vto;
double d_n_d_ss;
double d_n_d_delta1;
double d_n_d_delta2;
double d_n_d_nd;
double d_n_d_alpha;
double d_n_d_vel0;
double d_n_d_mu0;
double d_n_d_beta;
double d_n_d_mtheta;
double d_n_d_vtheta;
double d_n_d_vtzeta;
double d_n_d_dibsat;
double d_n_d_epsilon;
double d_n_d_vzeta;
double d_n_d_lambda;
double d_n_d_ngf;
double d_n_d_type;
double vtof;
double d_vtof_d_vgsin;
double d_vtof_d_vdsin;
double d_vtof_d_qcbflag;
double d_vtof_d_vcin;
double d_vtof_d_vbin;
double d_vtof_d_qgsflag;
double d_vtof_d_tambin;
double d_vtof_d_tnomin;
double d_vtof_d_phitin;
double d_vtof_d_w;
double d_vtof_d_lin;
double d_vtof_d_cgin;
double d_vtof_d_cs;
double d_vtof_d_cc;
double d_vtof_d_cb;
double d_vtof_d_vto;
double d_vtof_d_ss;
double d_vtof_d_delta1;
double d_vtof_d_delta2;
double d_vtof_d_nd;
double d_vtof_d_alpha;
double d_vtof_d_vel0;
double d_vtof_d_mu0;
double d_vtof_d_beta;
double d_vtof_d_mtheta;
double d_vtof_d_vtheta;
double d_vtof_d_vtzeta;
double d_vtof_d_dibsat;
double d_vtof_d_epsilon;
double d_vtof_d_vzeta;
double d_vtof_d_lambda;
double d_vtof_d_ngf;
double d_vtof_d_type;
double vsatdibl;
double d_vsatdibl_d_vgsin;
double d_vsatdibl_d_vdsin;
double d_vsatdibl_d_qcbflag;
double d_vsatdibl_d_vcin;
double d_vsatdibl_d_vbin;
double d_vsatdibl_d_qgsflag;
double d_vsatdibl_d_tambin;
double d_vsatdibl_d_tnomin;
double d_vsatdibl_d_phitin;
double d_vsatdibl_d_w;
double d_vsatdibl_d_lin;
double d_vsatdibl_d_cgin;
double d_vsatdibl_d_cs;
double d_vsatdibl_d_cc;
double d_vsatdibl_d_cb;
double d_vsatdibl_d_vto;
double d_vsatdibl_d_ss;
double d_vsatdibl_d_delta1;
double d_vsatdibl_d_delta2;
double d_vsatdibl_d_nd;
double d_vsatdibl_d_alpha;
double d_vsatdibl_d_vel0;
double d_vsatdibl_d_mu0;
double d_vsatdibl_d_beta;
double d_vsatdibl_d_mtheta;
double d_vsatdibl_d_vtheta;
double d_vsatdibl_d_vtzeta;
double d_vsatdibl_d_dibsat;
double d_vsatdibl_d_epsilon;
double d_vsatdibl_d_vzeta;
double d_vsatdibl_d_lambda;
double d_vsatdibl_d_ngf;
double d_vsatdibl_d_type;
double ffs;
double d_ffs_d_vgsin;
double d_ffs_d_vdsin;
double d_ffs_d_qcbflag;
double d_ffs_d_vcin;
double d_ffs_d_vbin;
double d_ffs_d_qgsflag;
double d_ffs_d_tambin;
double d_ffs_d_tnomin;
double d_ffs_d_phitin;
double d_ffs_d_w;
double d_ffs_d_lin;
double d_ffs_d_cgin;
double d_ffs_d_cs;
double d_ffs_d_cc;
double d_ffs_d_cb;
double d_ffs_d_vto;
double d_ffs_d_ss;
double d_ffs_d_delta1;
double d_ffs_d_delta2;
double d_ffs_d_nd;
double d_ffs_d_alpha;
double d_ffs_d_vel0;
double d_ffs_d_mu0;
double d_ffs_d_beta;
double d_ffs_d_mtheta;
double d_ffs_d_vtheta;
double d_ffs_d_vtzeta;
double d_ffs_d_dibsat;
double d_ffs_d_epsilon;
double d_ffs_d_vzeta;
double d_ffs_d_lambda;
double d_ffs_d_ngf;
double d_ffs_d_type;
double two_n_phit;
double d_two_n_phit_d_vgsin;
double d_two_n_phit_d_vdsin;
double d_two_n_phit_d_qcbflag;
double d_two_n_phit_d_vcin;
double d_two_n_phit_d_vbin;
double d_two_n_phit_d_qgsflag;
double d_two_n_phit_d_tambin;
double d_two_n_phit_d_tnomin;
double d_two_n_phit_d_phitin;
double d_two_n_phit_d_w;
double d_two_n_phit_d_lin;
double d_two_n_phit_d_cgin;
double d_two_n_phit_d_cs;
double d_two_n_phit_d_cc;
double d_two_n_phit_d_cb;
double d_two_n_phit_d_vto;
double d_two_n_phit_d_ss;
double d_two_n_phit_d_delta1;
double d_two_n_phit_d_delta2;
double d_two_n_phit_d_nd;
double d_two_n_phit_d_alpha;
double d_two_n_phit_d_vel0;
double d_two_n_phit_d_mu0;
double d_two_n_phit_d_beta;
double d_two_n_phit_d_mtheta;
double d_two_n_phit_d_vtheta;
double d_two_n_phit_d_vtzeta;
double d_two_n_phit_d_dibsat;
double d_two_n_phit_d_epsilon;
double d_two_n_phit_d_vzeta;
double d_two_n_phit_d_lambda;
double d_two_n_phit_d_ngf;
double d_two_n_phit_d_type;
double qref;
double d_qref_d_vgsin;
double d_qref_d_vdsin;
double d_qref_d_qcbflag;
double d_qref_d_vcin;
double d_qref_d_vbin;
double d_qref_d_qgsflag;
double d_qref_d_tambin;
double d_qref_d_tnomin;
double d_qref_d_phitin;
double d_qref_d_w;
double d_qref_d_lin;
double d_qref_d_cgin;
double d_qref_d_cs;
double d_qref_d_cc;
double d_qref_d_cb;
double d_qref_d_vto;
double d_qref_d_ss;
double d_qref_d_delta1;
double d_qref_d_delta2;
double d_qref_d_nd;
double d_qref_d_alpha;
double d_qref_d_vel0;
double d_qref_d_mu0;
double d_qref_d_beta;
double d_qref_d_mtheta;
double d_qref_d_vtheta;
double d_qref_d_vtzeta;
double d_qref_d_dibsat;
double d_qref_d_epsilon;
double d_qref_d_vzeta;
double d_qref_d_lambda;
double d_qref_d_ngf;
double d_qref_d_type;
double etas;
double d_etas_d_vgsin;
double d_etas_d_vdsin;
double d_etas_d_qcbflag;
double d_etas_d_vcin;
double d_etas_d_vbin;
double d_etas_d_qgsflag;
double d_etas_d_tambin;
double d_etas_d_tnomin;
double d_etas_d_phitin;
double d_etas_d_w;
double d_etas_d_lin;
double d_etas_d_cgin;
double d_etas_d_cs;
double d_etas_d_cc;
double d_etas_d_cb;
double d_etas_d_vto;
double d_etas_d_ss;
double d_etas_d_delta1;
double d_etas_d_delta2;
double d_etas_d_nd;
double d_etas_d_alpha;
double d_etas_d_vel0;
double d_etas_d_mu0;
double d_etas_d_beta;
double d_etas_d_mtheta;
double d_etas_d_vtheta;
double d_etas_d_vtzeta;
double d_etas_d_dibsat;
double d_etas_d_epsilon;
double d_etas_d_vzeta;
double d_etas_d_lambda;
double d_etas_d_ngf;
double d_etas_d_type;
double qinvs;
double d_qinvs_d_vgsin;
double d_qinvs_d_vdsin;
double d_qinvs_d_qcbflag;
double d_qinvs_d_vcin;
double d_qinvs_d_vbin;
double d_qinvs_d_qgsflag;
double d_qinvs_d_tambin;
double d_qinvs_d_tnomin;
double d_qinvs_d_phitin;
double d_qinvs_d_w;
double d_qinvs_d_lin;
double d_qinvs_d_cgin;
double d_qinvs_d_cs;
double d_qinvs_d_cc;
double d_qinvs_d_cb;
double d_qinvs_d_vto;
double d_qinvs_d_ss;
double d_qinvs_d_delta1;
double d_qinvs_d_delta2;
double d_qinvs_d_nd;
double d_qinvs_d_alpha;
double d_qinvs_d_vel0;
double d_qinvs_d_mu0;
double d_qinvs_d_beta;
double d_qinvs_d_mtheta;
double d_qinvs_d_vtheta;
double d_qinvs_d_vtzeta;
double d_qinvs_d_dibsat;
double d_qinvs_d_epsilon;
double d_qinvs_d_vzeta;
double d_qinvs_d_lambda;
double d_qinvs_d_ngf;
double d_qinvs_d_type;
double muf;
double d_muf_d_vgsin;
double d_muf_d_vdsin;
double d_muf_d_qcbflag;
double d_muf_d_vcin;
double d_muf_d_vbin;
double d_muf_d_qgsflag;
double d_muf_d_tambin;
double d_muf_d_tnomin;
double d_muf_d_phitin;
double d_muf_d_w;
double d_muf_d_lin;
double d_muf_d_cgin;
double d_muf_d_cs;
double d_muf_d_cc;
double d_muf_d_cb;
double d_muf_d_vto;
double d_muf_d_ss;
double d_muf_d_delta1;
double d_muf_d_delta2;
double d_muf_d_nd;
double d_muf_d_alpha;
double d_muf_d_vel0;
double d_muf_d_mu0;
double d_muf_d_beta;
double d_muf_d_mtheta;
double d_muf_d_vtheta;
double d_muf_d_vtzeta;
double d_muf_d_dibsat;
double d_muf_d_epsilon;
double d_muf_d_vzeta;
double d_muf_d_lambda;
double d_muf_d_ngf;
double d_muf_d_type;
double vx;
double d_vx_d_vgsin;
double d_vx_d_vdsin;
double d_vx_d_qcbflag;
double d_vx_d_vcin;
double d_vx_d_vbin;
double d_vx_d_qgsflag;
double d_vx_d_tambin;
double d_vx_d_tnomin;
double d_vx_d_phitin;
double d_vx_d_w;
double d_vx_d_lin;
double d_vx_d_cgin;
double d_vx_d_cs;
double d_vx_d_cc;
double d_vx_d_cb;
double d_vx_d_vto;
double d_vx_d_ss;
double d_vx_d_delta1;
double d_vx_d_delta2;
double d_vx_d_nd;
double d_vx_d_alpha;
double d_vx_d_vel0;
double d_vx_d_mu0;
double d_vx_d_beta;
double d_vx_d_mtheta;
double d_vx_d_vtheta;
double d_vx_d_vtzeta;
double d_vx_d_dibsat;
double d_vx_d_epsilon;
double d_vx_d_vzeta;
double d_vx_d_lambda;
double d_vx_d_ngf;
double d_vx_d_type;
double vxf;
double d_vxf_d_vgsin;
double d_vxf_d_vdsin;
double d_vxf_d_qcbflag;
double d_vxf_d_vcin;
double d_vxf_d_vbin;
double d_vxf_d_qgsflag;
double d_vxf_d_tambin;
double d_vxf_d_tnomin;
double d_vxf_d_phitin;
double d_vxf_d_w;
double d_vxf_d_lin;
double d_vxf_d_cgin;
double d_vxf_d_cs;
double d_vxf_d_cc;
double d_vxf_d_cb;
double d_vxf_d_vto;
double d_vxf_d_ss;
double d_vxf_d_delta1;
double d_vxf_d_delta2;
double d_vxf_d_nd;
double d_vxf_d_alpha;
double d_vxf_d_vel0;
double d_vxf_d_mu0;
double d_vxf_d_beta;
double d_vxf_d_mtheta;
double d_vxf_d_vtheta;
double d_vxf_d_vtzeta;
double d_vxf_d_dibsat;
double d_vxf_d_epsilon;
double d_vxf_d_vzeta;
double d_vxf_d_lambda;
double d_vxf_d_ngf;
double d_vxf_d_type;
double n0;
double d_n0_d_vgsin;
double d_n0_d_vdsin;
double d_n0_d_qcbflag;
double d_n0_d_vcin;
double d_n0_d_vbin;
double d_n0_d_qgsflag;
double d_n0_d_tambin;
double d_n0_d_tnomin;
double d_n0_d_phitin;
double d_n0_d_w;
double d_n0_d_lin;
double d_n0_d_cgin;
double d_n0_d_cs;
double d_n0_d_cc;
double d_n0_d_cb;
double d_n0_d_vto;
double d_n0_d_ss;
double d_n0_d_delta1;
double d_n0_d_delta2;
double d_n0_d_nd;
double d_n0_d_alpha;
double d_n0_d_vel0;
double d_n0_d_mu0;
double d_n0_d_beta;
double d_n0_d_mtheta;
double d_n0_d_vtheta;
double d_n0_d_vtzeta;
double d_n0_d_dibsat;
double d_n0_d_epsilon;
double d_n0_d_vzeta;
double d_n0_d_lambda;
double d_n0_d_ngf;
double d_n0_d_type;
double ffs0;
double d_ffs0_d_vgsin;
double d_ffs0_d_vdsin;
double d_ffs0_d_qcbflag;
double d_ffs0_d_vcin;
double d_ffs0_d_vbin;
double d_ffs0_d_qgsflag;
double d_ffs0_d_tambin;
double d_ffs0_d_tnomin;
double d_ffs0_d_phitin;
double d_ffs0_d_w;
double d_ffs0_d_lin;
double d_ffs0_d_cgin;
double d_ffs0_d_cs;
double d_ffs0_d_cc;
double d_ffs0_d_cb;
double d_ffs0_d_vto;
double d_ffs0_d_ss;
double d_ffs0_d_delta1;
double d_ffs0_d_delta2;
double d_ffs0_d_nd;
double d_ffs0_d_alpha;
double d_ffs0_d_vel0;
double d_ffs0_d_mu0;
double d_ffs0_d_beta;
double d_ffs0_d_mtheta;
double d_ffs0_d_vtheta;
double d_ffs0_d_vtzeta;
double d_ffs0_d_dibsat;
double d_ffs0_d_epsilon;
double d_ffs0_d_vzeta;
double d_ffs0_d_lambda;
double d_ffs0_d_ngf;
double d_ffs0_d_type;
double two_n_phit0;
double d_two_n_phit0_d_vgsin;
double d_two_n_phit0_d_vdsin;
double d_two_n_phit0_d_qcbflag;
double d_two_n_phit0_d_vcin;
double d_two_n_phit0_d_vbin;
double d_two_n_phit0_d_qgsflag;
double d_two_n_phit0_d_tambin;
double d_two_n_phit0_d_tnomin;
double d_two_n_phit0_d_phitin;
double d_two_n_phit0_d_w;
double d_two_n_phit0_d_lin;
double d_two_n_phit0_d_cgin;
double d_two_n_phit0_d_cs;
double d_two_n_phit0_d_cc;
double d_two_n_phit0_d_cb;
double d_two_n_phit0_d_vto;
double d_two_n_phit0_d_ss;
double d_two_n_phit0_d_delta1;
double d_two_n_phit0_d_delta2;
double d_two_n_phit0_d_nd;
double d_two_n_phit0_d_alpha;
double d_two_n_phit0_d_vel0;
double d_two_n_phit0_d_mu0;
double d_two_n_phit0_d_beta;
double d_two_n_phit0_d_mtheta;
double d_two_n_phit0_d_vtheta;
double d_two_n_phit0_d_vtzeta;
double d_two_n_phit0_d_dibsat;
double d_two_n_phit0_d_epsilon;
double d_two_n_phit0_d_vzeta;
double d_two_n_phit0_d_lambda;
double d_two_n_phit0_d_ngf;
double d_two_n_phit0_d_type;
double qref0;
double d_qref0_d_vgsin;
double d_qref0_d_vdsin;
double d_qref0_d_qcbflag;
double d_qref0_d_vcin;
double d_qref0_d_vbin;
double d_qref0_d_qgsflag;
double d_qref0_d_tambin;
double d_qref0_d_tnomin;
double d_qref0_d_phitin;
double d_qref0_d_w;
double d_qref0_d_lin;
double d_qref0_d_cgin;
double d_qref0_d_cs;
double d_qref0_d_cc;
double d_qref0_d_cb;
double d_qref0_d_vto;
double d_qref0_d_ss;
double d_qref0_d_delta1;
double d_qref0_d_delta2;
double d_qref0_d_nd;
double d_qref0_d_alpha;
double d_qref0_d_vel0;
double d_qref0_d_mu0;
double d_qref0_d_beta;
double d_qref0_d_mtheta;
double d_qref0_d_vtheta;
double d_qref0_d_vtzeta;
double d_qref0_d_dibsat;
double d_qref0_d_epsilon;
double d_qref0_d_vzeta;
double d_qref0_d_lambda;
double d_qref0_d_ngf;
double d_qref0_d_type;
double etas0;
double d_etas0_d_vgsin;
double d_etas0_d_vdsin;
double d_etas0_d_qcbflag;
double d_etas0_d_vcin;
double d_etas0_d_vbin;
double d_etas0_d_qgsflag;
double d_etas0_d_tambin;
double d_etas0_d_tnomin;
double d_etas0_d_phitin;
double d_etas0_d_w;
double d_etas0_d_lin;
double d_etas0_d_cgin;
double d_etas0_d_cs;
double d_etas0_d_cc;
double d_etas0_d_cb;
double d_etas0_d_vto;
double d_etas0_d_ss;
double d_etas0_d_delta1;
double d_etas0_d_delta2;
double d_etas0_d_nd;
double d_etas0_d_alpha;
double d_etas0_d_vel0;
double d_etas0_d_mu0;
double d_etas0_d_beta;
double d_etas0_d_mtheta;
double d_etas0_d_vtheta;
double d_etas0_d_vtzeta;
double d_etas0_d_dibsat;
double d_etas0_d_epsilon;
double d_etas0_d_vzeta;
double d_etas0_d_lambda;
double d_etas0_d_ngf;
double d_etas0_d_type;
double qinvs0;
double d_qinvs0_d_vgsin;
double d_qinvs0_d_vdsin;
double d_qinvs0_d_qcbflag;
double d_qinvs0_d_vcin;
double d_qinvs0_d_vbin;
double d_qinvs0_d_qgsflag;
double d_qinvs0_d_tambin;
double d_qinvs0_d_tnomin;
double d_qinvs0_d_phitin;
double d_qinvs0_d_w;
double d_qinvs0_d_lin;
double d_qinvs0_d_cgin;
double d_qinvs0_d_cs;
double d_qinvs0_d_cc;
double d_qinvs0_d_cb;
double d_qinvs0_d_vto;
double d_qinvs0_d_ss;
double d_qinvs0_d_delta1;
double d_qinvs0_d_delta2;
double d_qinvs0_d_nd;
double d_qinvs0_d_alpha;
double d_qinvs0_d_vel0;
double d_qinvs0_d_mu0;
double d_qinvs0_d_beta;
double d_qinvs0_d_mtheta;
double d_qinvs0_d_vtheta;
double d_qinvs0_d_vtzeta;
double d_qinvs0_d_dibsat;
double d_qinvs0_d_epsilon;
double d_qinvs0_d_vzeta;
double d_qinvs0_d_lambda;
double d_qinvs0_d_ngf;
double d_qinvs0_d_type;
double muf0;
double d_muf0_d_vgsin;
double d_muf0_d_vdsin;
double d_muf0_d_qcbflag;
double d_muf0_d_vcin;
double d_muf0_d_vbin;
double d_muf0_d_qgsflag;
double d_muf0_d_tambin;
double d_muf0_d_tnomin;
double d_muf0_d_phitin;
double d_muf0_d_w;
double d_muf0_d_lin;
double d_muf0_d_cgin;
double d_muf0_d_cs;
double d_muf0_d_cc;
double d_muf0_d_cb;
double d_muf0_d_vto;
double d_muf0_d_ss;
double d_muf0_d_delta1;
double d_muf0_d_delta2;
double d_muf0_d_nd;
double d_muf0_d_alpha;
double d_muf0_d_vel0;
double d_muf0_d_mu0;
double d_muf0_d_beta;
double d_muf0_d_mtheta;
double d_muf0_d_vtheta;
double d_muf0_d_vtzeta;
double d_muf0_d_dibsat;
double d_muf0_d_epsilon;
double d_muf0_d_vzeta;
double d_muf0_d_lambda;
double d_muf0_d_ngf;
double d_muf0_d_type;
double vx0;
double d_vx0_d_vgsin;
double d_vx0_d_vdsin;
double d_vx0_d_qcbflag;
double d_vx0_d_vcin;
double d_vx0_d_vbin;
double d_vx0_d_qgsflag;
double d_vx0_d_tambin;
double d_vx0_d_tnomin;
double d_vx0_d_phitin;
double d_vx0_d_w;
double d_vx0_d_lin;
double d_vx0_d_cgin;
double d_vx0_d_cs;
double d_vx0_d_cc;
double d_vx0_d_cb;
double d_vx0_d_vto;
double d_vx0_d_ss;
double d_vx0_d_delta1;
double d_vx0_d_delta2;
double d_vx0_d_nd;
double d_vx0_d_alpha;
double d_vx0_d_vel0;
double d_vx0_d_mu0;
double d_vx0_d_beta;
double d_vx0_d_mtheta;
double d_vx0_d_vtheta;
double d_vx0_d_vtzeta;
double d_vx0_d_dibsat;
double d_vx0_d_epsilon;
double d_vx0_d_vzeta;
double d_vx0_d_lambda;
double d_vx0_d_ngf;
double d_vx0_d_type;
double ff;
double d_ff_d_vgsin;
double d_ff_d_vdsin;
double d_ff_d_qcbflag;
double d_ff_d_vcin;
double d_ff_d_vbin;
double d_ff_d_qgsflag;
double d_ff_d_tambin;
double d_ff_d_tnomin;
double d_ff_d_phitin;
double d_ff_d_w;
double d_ff_d_lin;
double d_ff_d_cgin;
double d_ff_d_cs;
double d_ff_d_cc;
double d_ff_d_cb;
double d_ff_d_vto;
double d_ff_d_ss;
double d_ff_d_delta1;
double d_ff_d_delta2;
double d_ff_d_nd;
double d_ff_d_alpha;
double d_ff_d_vel0;
double d_ff_d_mu0;
double d_ff_d_beta;
double d_ff_d_mtheta;
double d_ff_d_vtheta;
double d_ff_d_vtzeta;
double d_ff_d_dibsat;
double d_ff_d_epsilon;
double d_ff_d_vzeta;
double d_ff_d_lambda;
double d_ff_d_ngf;
double d_ff_d_type;
double eta;
double d_eta_d_vgsin;
double d_eta_d_vdsin;
double d_eta_d_qcbflag;
double d_eta_d_vcin;
double d_eta_d_vbin;
double d_eta_d_qgsflag;
double d_eta_d_tambin;
double d_eta_d_tnomin;
double d_eta_d_phitin;
double d_eta_d_w;
double d_eta_d_lin;
double d_eta_d_cgin;
double d_eta_d_cs;
double d_eta_d_cc;
double d_eta_d_cb;
double d_eta_d_vto;
double d_eta_d_ss;
double d_eta_d_delta1;
double d_eta_d_delta2;
double d_eta_d_nd;
double d_eta_d_alpha;
double d_eta_d_vel0;
double d_eta_d_mu0;
double d_eta_d_beta;
double d_eta_d_mtheta;
double d_eta_d_vtheta;
double d_eta_d_vtzeta;
double d_eta_d_dibsat;
double d_eta_d_epsilon;
double d_eta_d_vzeta;
double d_eta_d_lambda;
double d_eta_d_ngf;
double d_eta_d_type;
double qinvv;
double d_qinvv_d_vgsin;
double d_qinvv_d_vdsin;
double d_qinvv_d_qcbflag;
double d_qinvv_d_vcin;
double d_qinvv_d_vbin;
double d_qinvv_d_qgsflag;
double d_qinvv_d_tambin;
double d_qinvv_d_tnomin;
double d_qinvv_d_phitin;
double d_qinvv_d_w;
double d_qinvv_d_lin;
double d_qinvv_d_cgin;
double d_qinvv_d_cs;
double d_qinvv_d_cc;
double d_qinvv_d_cb;
double d_qinvv_d_vto;
double d_qinvv_d_ss;
double d_qinvv_d_delta1;
double d_qinvv_d_delta2;
double d_qinvv_d_nd;
double d_qinvv_d_alpha;
double d_qinvv_d_vel0;
double d_qinvv_d_mu0;
double d_qinvv_d_beta;
double d_qinvv_d_mtheta;
double d_qinvv_d_vtheta;
double d_qinvv_d_vtzeta;
double d_qinvv_d_dibsat;
double d_qinvv_d_epsilon;
double d_qinvv_d_vzeta;
double d_qinvv_d_lambda;
double d_qinvv_d_ngf;
double d_qinvv_d_type;
double ff0;
double d_ff0_d_vgsin;
double d_ff0_d_vdsin;
double d_ff0_d_qcbflag;
double d_ff0_d_vcin;
double d_ff0_d_vbin;
double d_ff0_d_qgsflag;
double d_ff0_d_tambin;
double d_ff0_d_tnomin;
double d_ff0_d_phitin;
double d_ff0_d_w;
double d_ff0_d_lin;
double d_ff0_d_cgin;
double d_ff0_d_cs;
double d_ff0_d_cc;
double d_ff0_d_cb;
double d_ff0_d_vto;
double d_ff0_d_ss;
double d_ff0_d_delta1;
double d_ff0_d_delta2;
double d_ff0_d_nd;
double d_ff0_d_alpha;
double d_ff0_d_vel0;
double d_ff0_d_mu0;
double d_ff0_d_beta;
double d_ff0_d_mtheta;
double d_ff0_d_vtheta;
double d_ff0_d_vtzeta;
double d_ff0_d_dibsat;
double d_ff0_d_epsilon;
double d_ff0_d_vzeta;
double d_ff0_d_lambda;
double d_ff0_d_ngf;
double d_ff0_d_type;
double eta0;
double d_eta0_d_vgsin;
double d_eta0_d_vdsin;
double d_eta0_d_qcbflag;
double d_eta0_d_vcin;
double d_eta0_d_vbin;
double d_eta0_d_qgsflag;
double d_eta0_d_tambin;
double d_eta0_d_tnomin;
double d_eta0_d_phitin;
double d_eta0_d_w;
double d_eta0_d_lin;
double d_eta0_d_cgin;
double d_eta0_d_cs;
double d_eta0_d_cc;
double d_eta0_d_cb;
double d_eta0_d_vto;
double d_eta0_d_ss;
double d_eta0_d_delta1;
double d_eta0_d_delta2;
double d_eta0_d_nd;
double d_eta0_d_alpha;
double d_eta0_d_vel0;
double d_eta0_d_mu0;
double d_eta0_d_beta;
double d_eta0_d_mtheta;
double d_eta0_d_vtheta;
double d_eta0_d_vtzeta;
double d_eta0_d_dibsat;
double d_eta0_d_epsilon;
double d_eta0_d_vzeta;
double d_eta0_d_lambda;
double d_eta0_d_ngf;
double d_eta0_d_type;
double qinvv0;
double d_qinvv0_d_vgsin;
double d_qinvv0_d_vdsin;
double d_qinvv0_d_qcbflag;
double d_qinvv0_d_vcin;
double d_qinvv0_d_vbin;
double d_qinvv0_d_qgsflag;
double d_qinvv0_d_tambin;
double d_qinvv0_d_tnomin;
double d_qinvv0_d_phitin;
double d_qinvv0_d_w;
double d_qinvv0_d_lin;
double d_qinvv0_d_cgin;
double d_qinvv0_d_cs;
double d_qinvv0_d_cc;
double d_qinvv0_d_cb;
double d_qinvv0_d_vto;
double d_qinvv0_d_ss;
double d_qinvv0_d_delta1;
double d_qinvv0_d_delta2;
double d_qinvv0_d_nd;
double d_qinvv0_d_alpha;
double d_qinvv0_d_vel0;
double d_qinvv0_d_mu0;
double d_qinvv0_d_beta;
double d_qinvv0_d_mtheta;
double d_qinvv0_d_vtheta;
double d_qinvv0_d_vtzeta;
double d_qinvv0_d_dibsat;
double d_qinvv0_d_epsilon;
double d_qinvv0_d_vzeta;
double d_qinvv0_d_lambda;
double d_qinvv0_d_ngf;
double d_qinvv0_d_type;
double vdsats;
double d_vdsats_d_vgsin;
double d_vdsats_d_vdsin;
double d_vdsats_d_qcbflag;
double d_vdsats_d_vcin;
double d_vdsats_d_vbin;
double d_vdsats_d_qgsflag;
double d_vdsats_d_tambin;
double d_vdsats_d_tnomin;
double d_vdsats_d_phitin;
double d_vdsats_d_w;
double d_vdsats_d_lin;
double d_vdsats_d_cgin;
double d_vdsats_d_cs;
double d_vdsats_d_cc;
double d_vdsats_d_cb;
double d_vdsats_d_vto;
double d_vdsats_d_ss;
double d_vdsats_d_delta1;
double d_vdsats_d_delta2;
double d_vdsats_d_nd;
double d_vdsats_d_alpha;
double d_vdsats_d_vel0;
double d_vdsats_d_mu0;
double d_vdsats_d_beta;
double d_vdsats_d_mtheta;
double d_vdsats_d_vtheta;
double d_vdsats_d_vtzeta;
double d_vdsats_d_dibsat;
double d_vdsats_d_epsilon;
double d_vdsats_d_vzeta;
double d_vdsats_d_lambda;
double d_vdsats_d_ngf;
double d_vdsats_d_type;
double vdsats1;
double d_vdsats1_d_vgsin;
double d_vdsats1_d_vdsin;
double d_vdsats1_d_qcbflag;
double d_vdsats1_d_vcin;
double d_vdsats1_d_vbin;
double d_vdsats1_d_qgsflag;
double d_vdsats1_d_tambin;
double d_vdsats1_d_tnomin;
double d_vdsats1_d_phitin;
double d_vdsats1_d_w;
double d_vdsats1_d_lin;
double d_vdsats1_d_cgin;
double d_vdsats1_d_cs;
double d_vdsats1_d_cc;
double d_vdsats1_d_cb;
double d_vdsats1_d_vto;
double d_vdsats1_d_ss;
double d_vdsats1_d_delta1;
double d_vdsats1_d_delta2;
double d_vdsats1_d_nd;
double d_vdsats1_d_alpha;
double d_vdsats1_d_vel0;
double d_vdsats1_d_mu0;
double d_vdsats1_d_beta;
double d_vdsats1_d_mtheta;
double d_vdsats1_d_vtheta;
double d_vdsats1_d_vtzeta;
double d_vdsats1_d_dibsat;
double d_vdsats1_d_epsilon;
double d_vdsats1_d_vzeta;
double d_vdsats1_d_lambda;
double d_vdsats1_d_ngf;
double d_vdsats1_d_type;
double vdsat;
double d_vdsat_d_vgsin;
double d_vdsat_d_vdsin;
double d_vdsat_d_qcbflag;
double d_vdsat_d_vcin;
double d_vdsat_d_vbin;
double d_vdsat_d_qgsflag;
double d_vdsat_d_tambin;
double d_vdsat_d_tnomin;
double d_vdsat_d_phitin;
double d_vdsat_d_w;
double d_vdsat_d_lin;
double d_vdsat_d_cgin;
double d_vdsat_d_cs;
double d_vdsat_d_cc;
double d_vdsat_d_cb;
double d_vdsat_d_vto;
double d_vdsat_d_ss;
double d_vdsat_d_delta1;
double d_vdsat_d_delta2;
double d_vdsat_d_nd;
double d_vdsat_d_alpha;
double d_vdsat_d_vel0;
double d_vdsat_d_mu0;
double d_vdsat_d_beta;
double d_vdsat_d_mtheta;
double d_vdsat_d_vtheta;
double d_vdsat_d_vtzeta;
double d_vdsat_d_dibsat;
double d_vdsat_d_epsilon;
double d_vdsat_d_vzeta;
double d_vdsat_d_lambda;
double d_vdsat_d_ngf;
double d_vdsat_d_type;
double fsd;
double d_fsd_d_vgsin;
double d_fsd_d_vdsin;
double d_fsd_d_qcbflag;
double d_fsd_d_vcin;
double d_fsd_d_vbin;
double d_fsd_d_qgsflag;
double d_fsd_d_tambin;
double d_fsd_d_tnomin;
double d_fsd_d_phitin;
double d_fsd_d_w;
double d_fsd_d_lin;
double d_fsd_d_cgin;
double d_fsd_d_cs;
double d_fsd_d_cc;
double d_fsd_d_cb;
double d_fsd_d_vto;
double d_fsd_d_ss;
double d_fsd_d_delta1;
double d_fsd_d_delta2;
double d_fsd_d_nd;
double d_fsd_d_alpha;
double d_fsd_d_vel0;
double d_fsd_d_mu0;
double d_fsd_d_beta;
double d_fsd_d_mtheta;
double d_fsd_d_vtheta;
double d_fsd_d_vtzeta;
double d_fsd_d_dibsat;
double d_fsd_d_epsilon;
double d_fsd_d_vzeta;
double d_fsd_d_lambda;
double d_fsd_d_ngf;
double d_fsd_d_type;
double vdx;
double d_vdx_d_vgsin;
double d_vdx_d_vdsin;
double d_vdx_d_qcbflag;
double d_vdx_d_vcin;
double d_vdx_d_vbin;
double d_vdx_d_qgsflag;
double d_vdx_d_tambin;
double d_vdx_d_tnomin;
double d_vdx_d_phitin;
double d_vdx_d_w;
double d_vdx_d_lin;
double d_vdx_d_cgin;
double d_vdx_d_cs;
double d_vdx_d_cc;
double d_vdx_d_cb;
double d_vdx_d_vto;
double d_vdx_d_ss;
double d_vdx_d_delta1;
double d_vdx_d_delta2;
double d_vdx_d_nd;
double d_vdx_d_alpha;
double d_vdx_d_vel0;
double d_vdx_d_mu0;
double d_vdx_d_beta;
double d_vdx_d_mtheta;
double d_vdx_d_vtheta;
double d_vdx_d_vtzeta;
double d_vdx_d_dibsat;
double d_vdx_d_epsilon;
double d_vdx_d_vzeta;
double d_vdx_d_lambda;
double d_vdx_d_ngf;
double d_vdx_d_type;
double fds;
double d_fds_d_vgsin;
double d_fds_d_vdsin;
double d_fds_d_qcbflag;
double d_fds_d_vcin;
double d_fds_d_vbin;
double d_fds_d_qgsflag;
double d_fds_d_tambin;
double d_fds_d_tnomin;
double d_fds_d_phitin;
double d_fds_d_w;
double d_fds_d_lin;
double d_fds_d_cgin;
double d_fds_d_cs;
double d_fds_d_cc;
double d_fds_d_cb;
double d_fds_d_vto;
double d_fds_d_ss;
double d_fds_d_delta1;
double d_fds_d_delta2;
double d_fds_d_nd;
double d_fds_d_alpha;
double d_fds_d_vel0;
double d_fds_d_mu0;
double d_fds_d_beta;
double d_fds_d_mtheta;
double d_fds_d_vtheta;
double d_fds_d_vtzeta;
double d_fds_d_dibsat;
double d_fds_d_epsilon;
double d_fds_d_vzeta;
double d_fds_d_lambda;
double d_fds_d_ngf;
double d_fds_d_type;
double vsx;
double d_vsx_d_vgsin;
double d_vsx_d_vdsin;
double d_vsx_d_qcbflag;
double d_vsx_d_vcin;
double d_vsx_d_vbin;
double d_vsx_d_qgsflag;
double d_vsx_d_tambin;
double d_vsx_d_tnomin;
double d_vsx_d_phitin;
double d_vsx_d_w;
double d_vsx_d_lin;
double d_vsx_d_cgin;
double d_vsx_d_cs;
double d_vsx_d_cc;
double d_vsx_d_cb;
double d_vsx_d_vto;
double d_vsx_d_ss;
double d_vsx_d_delta1;
double d_vsx_d_delta2;
double d_vsx_d_nd;
double d_vsx_d_alpha;
double d_vsx_d_vel0;
double d_vsx_d_mu0;
double d_vsx_d_beta;
double d_vsx_d_mtheta;
double d_vsx_d_vtheta;
double d_vsx_d_vtzeta;
double d_vsx_d_dibsat;
double d_vsx_d_epsilon;
double d_vsx_d_vzeta;
double d_vsx_d_lambda;
double d_vsx_d_ngf;
double d_vsx_d_type;
double ffd;
double d_ffd_d_vgsin;
double d_ffd_d_vdsin;
double d_ffd_d_qcbflag;
double d_ffd_d_vcin;
double d_ffd_d_vbin;
double d_ffd_d_qgsflag;
double d_ffd_d_tambin;
double d_ffd_d_tnomin;
double d_ffd_d_phitin;
double d_ffd_d_w;
double d_ffd_d_lin;
double d_ffd_d_cgin;
double d_ffd_d_cs;
double d_ffd_d_cc;
double d_ffd_d_cb;
double d_ffd_d_vto;
double d_ffd_d_ss;
double d_ffd_d_delta1;
double d_ffd_d_delta2;
double d_ffd_d_nd;
double d_ffd_d_alpha;
double d_ffd_d_vel0;
double d_ffd_d_mu0;
double d_ffd_d_beta;
double d_ffd_d_mtheta;
double d_ffd_d_vtheta;
double d_ffd_d_vtzeta;
double d_ffd_d_dibsat;
double d_ffd_d_epsilon;
double d_ffd_d_vzeta;
double d_ffd_d_lambda;
double d_ffd_d_ngf;
double d_ffd_d_type;
double etad;
double d_etad_d_vgsin;
double d_etad_d_vdsin;
double d_etad_d_qcbflag;
double d_etad_d_vcin;
double d_etad_d_vbin;
double d_etad_d_qgsflag;
double d_etad_d_tambin;
double d_etad_d_tnomin;
double d_etad_d_phitin;
double d_etad_d_w;
double d_etad_d_lin;
double d_etad_d_cgin;
double d_etad_d_cs;
double d_etad_d_cc;
double d_etad_d_cb;
double d_etad_d_vto;
double d_etad_d_ss;
double d_etad_d_delta1;
double d_etad_d_delta2;
double d_etad_d_nd;
double d_etad_d_alpha;
double d_etad_d_vel0;
double d_etad_d_mu0;
double d_etad_d_beta;
double d_etad_d_mtheta;
double d_etad_d_vtheta;
double d_etad_d_vtzeta;
double d_etad_d_dibsat;
double d_etad_d_epsilon;
double d_etad_d_vzeta;
double d_etad_d_lambda;
double d_etad_d_ngf;
double d_etad_d_type;
double qinvd;
double d_qinvd_d_vgsin;
double d_qinvd_d_vdsin;
double d_qinvd_d_qcbflag;
double d_qinvd_d_vcin;
double d_qinvd_d_vbin;
double d_qinvd_d_qgsflag;
double d_qinvd_d_tambin;
double d_qinvd_d_tnomin;
double d_qinvd_d_phitin;
double d_qinvd_d_w;
double d_qinvd_d_lin;
double d_qinvd_d_cgin;
double d_qinvd_d_cs;
double d_qinvd_d_cc;
double d_qinvd_d_cb;
double d_qinvd_d_vto;
double d_qinvd_d_ss;
double d_qinvd_d_delta1;
double d_qinvd_d_delta2;
double d_qinvd_d_nd;
double d_qinvd_d_alpha;
double d_qinvd_d_vel0;
double d_qinvd_d_mu0;
double d_qinvd_d_beta;
double d_qinvd_d_mtheta;
double d_qinvd_d_vtheta;
double d_qinvd_d_vtzeta;
double d_qinvd_d_dibsat;
double d_qinvd_d_epsilon;
double d_qinvd_d_vzeta;
double d_qinvd_d_lambda;
double d_qinvd_d_ngf;
double d_qinvd_d_type;
double vdsc;
double d_vdsc_d_vgsin;
double d_vdsc_d_vdsin;
double d_vdsc_d_qcbflag;
double d_vdsc_d_vcin;
double d_vdsc_d_vbin;
double d_vdsc_d_qgsflag;
double d_vdsc_d_tambin;
double d_vdsc_d_tnomin;
double d_vdsc_d_phitin;
double d_vdsc_d_w;
double d_vdsc_d_lin;
double d_vdsc_d_cgin;
double d_vdsc_d_cs;
double d_vdsc_d_cc;
double d_vdsc_d_cb;
double d_vdsc_d_vto;
double d_vdsc_d_ss;
double d_vdsc_d_delta1;
double d_vdsc_d_delta2;
double d_vdsc_d_nd;
double d_vdsc_d_alpha;
double d_vdsc_d_vel0;
double d_vdsc_d_mu0;
double d_vdsc_d_beta;
double d_vdsc_d_mtheta;
double d_vdsc_d_vtheta;
double d_vdsc_d_vtzeta;
double d_vdsc_d_dibsat;
double d_vdsc_d_epsilon;
double d_vdsc_d_vzeta;
double d_vdsc_d_lambda;
double d_vdsc_d_ngf;
double d_vdsc_d_type;
double fsat;
double d_fsat_d_vgsin;
double d_fsat_d_vdsin;
double d_fsat_d_qcbflag;
double d_fsat_d_vcin;
double d_fsat_d_vbin;
double d_fsat_d_qgsflag;
double d_fsat_d_tambin;
double d_fsat_d_tnomin;
double d_fsat_d_phitin;
double d_fsat_d_w;
double d_fsat_d_lin;
double d_fsat_d_cgin;
double d_fsat_d_cs;
double d_fsat_d_cc;
double d_fsat_d_cb;
double d_fsat_d_vto;
double d_fsat_d_ss;
double d_fsat_d_delta1;
double d_fsat_d_delta2;
double d_fsat_d_nd;
double d_fsat_d_alpha;
double d_fsat_d_vel0;
double d_fsat_d_mu0;
double d_fsat_d_beta;
double d_fsat_d_mtheta;
double d_fsat_d_vtheta;
double d_fsat_d_vtzeta;
double d_fsat_d_dibsat;
double d_fsat_d_epsilon;
double d_fsat_d_vzeta;
double d_fsat_d_lambda;
double d_fsat_d_ngf;
double d_fsat_d_type;
double vel;
double d_vel_d_vgsin;
double d_vel_d_vdsin;
double d_vel_d_qcbflag;
double d_vel_d_vcin;
double d_vel_d_vbin;
double d_vel_d_qgsflag;
double d_vel_d_tambin;
double d_vel_d_tnomin;
double d_vel_d_phitin;
double d_vel_d_w;
double d_vel_d_lin;
double d_vel_d_cgin;
double d_vel_d_cs;
double d_vel_d_cc;
double d_vel_d_cb;
double d_vel_d_vto;
double d_vel_d_ss;
double d_vel_d_delta1;
double d_vel_d_delta2;
double d_vel_d_nd;
double d_vel_d_alpha;
double d_vel_d_vel0;
double d_vel_d_mu0;
double d_vel_d_beta;
double d_vel_d_mtheta;
double d_vel_d_vtheta;
double d_vel_d_vtzeta;
double d_vel_d_dibsat;
double d_vel_d_epsilon;
double d_vel_d_vzeta;
double d_vel_d_lambda;
double d_vel_d_ngf;
double d_vel_d_type;
double vdsats0;
double d_vdsats0_d_vgsin;
double d_vdsats0_d_vdsin;
double d_vdsats0_d_qcbflag;
double d_vdsats0_d_vcin;
double d_vdsats0_d_vbin;
double d_vdsats0_d_qgsflag;
double d_vdsats0_d_tambin;
double d_vdsats0_d_tnomin;
double d_vdsats0_d_phitin;
double d_vdsats0_d_w;
double d_vdsats0_d_lin;
double d_vdsats0_d_cgin;
double d_vdsats0_d_cs;
double d_vdsats0_d_cc;
double d_vdsats0_d_cb;
double d_vdsats0_d_vto;
double d_vdsats0_d_ss;
double d_vdsats0_d_delta1;
double d_vdsats0_d_delta2;
double d_vdsats0_d_nd;
double d_vdsats0_d_alpha;
double d_vdsats0_d_vel0;
double d_vdsats0_d_mu0;
double d_vdsats0_d_beta;
double d_vdsats0_d_mtheta;
double d_vdsats0_d_vtheta;
double d_vdsats0_d_vtzeta;
double d_vdsats0_d_dibsat;
double d_vdsats0_d_epsilon;
double d_vdsats0_d_vzeta;
double d_vdsats0_d_lambda;
double d_vdsats0_d_ngf;
double d_vdsats0_d_type;
double vdsats10;
double d_vdsats10_d_vgsin;
double d_vdsats10_d_vdsin;
double d_vdsats10_d_qcbflag;
double d_vdsats10_d_vcin;
double d_vdsats10_d_vbin;
double d_vdsats10_d_qgsflag;
double d_vdsats10_d_tambin;
double d_vdsats10_d_tnomin;
double d_vdsats10_d_phitin;
double d_vdsats10_d_w;
double d_vdsats10_d_lin;
double d_vdsats10_d_cgin;
double d_vdsats10_d_cs;
double d_vdsats10_d_cc;
double d_vdsats10_d_cb;
double d_vdsats10_d_vto;
double d_vdsats10_d_ss;
double d_vdsats10_d_delta1;
double d_vdsats10_d_delta2;
double d_vdsats10_d_nd;
double d_vdsats10_d_alpha;
double d_vdsats10_d_vel0;
double d_vdsats10_d_mu0;
double d_vdsats10_d_beta;
double d_vdsats10_d_mtheta;
double d_vdsats10_d_vtheta;
double d_vdsats10_d_vtzeta;
double d_vdsats10_d_dibsat;
double d_vdsats10_d_epsilon;
double d_vdsats10_d_vzeta;
double d_vdsats10_d_lambda;
double d_vdsats10_d_ngf;
double d_vdsats10_d_type;
double vdsat10;
double d_vdsat10_d_vgsin;
double d_vdsat10_d_vdsin;
double d_vdsat10_d_qcbflag;
double d_vdsat10_d_vcin;
double d_vdsat10_d_vbin;
double d_vdsat10_d_qgsflag;
double d_vdsat10_d_tambin;
double d_vdsat10_d_tnomin;
double d_vdsat10_d_phitin;
double d_vdsat10_d_w;
double d_vdsat10_d_lin;
double d_vdsat10_d_cgin;
double d_vdsat10_d_cs;
double d_vdsat10_d_cc;
double d_vdsat10_d_cb;
double d_vdsat10_d_vto;
double d_vdsat10_d_ss;
double d_vdsat10_d_delta1;
double d_vdsat10_d_delta2;
double d_vdsat10_d_nd;
double d_vdsat10_d_alpha;
double d_vdsat10_d_vel0;
double d_vdsat10_d_mu0;
double d_vdsat10_d_beta;
double d_vdsat10_d_mtheta;
double d_vdsat10_d_vtheta;
double d_vdsat10_d_vtzeta;
double d_vdsat10_d_dibsat;
double d_vdsat10_d_epsilon;
double d_vdsat10_d_vzeta;
double d_vdsat10_d_lambda;
double d_vdsat10_d_ngf;
double d_vdsat10_d_type;
double fsd0;
double d_fsd0_d_vgsin;
double d_fsd0_d_vdsin;
double d_fsd0_d_qcbflag;
double d_fsd0_d_vcin;
double d_fsd0_d_vbin;
double d_fsd0_d_qgsflag;
double d_fsd0_d_tambin;
double d_fsd0_d_tnomin;
double d_fsd0_d_phitin;
double d_fsd0_d_w;
double d_fsd0_d_lin;
double d_fsd0_d_cgin;
double d_fsd0_d_cs;
double d_fsd0_d_cc;
double d_fsd0_d_cb;
double d_fsd0_d_vto;
double d_fsd0_d_ss;
double d_fsd0_d_delta1;
double d_fsd0_d_delta2;
double d_fsd0_d_nd;
double d_fsd0_d_alpha;
double d_fsd0_d_vel0;
double d_fsd0_d_mu0;
double d_fsd0_d_beta;
double d_fsd0_d_mtheta;
double d_fsd0_d_vtheta;
double d_fsd0_d_vtzeta;
double d_fsd0_d_dibsat;
double d_fsd0_d_epsilon;
double d_fsd0_d_vzeta;
double d_fsd0_d_lambda;
double d_fsd0_d_ngf;
double d_fsd0_d_type;
double vdx0;
double d_vdx0_d_vgsin;
double d_vdx0_d_vdsin;
double d_vdx0_d_qcbflag;
double d_vdx0_d_vcin;
double d_vdx0_d_vbin;
double d_vdx0_d_qgsflag;
double d_vdx0_d_tambin;
double d_vdx0_d_tnomin;
double d_vdx0_d_phitin;
double d_vdx0_d_w;
double d_vdx0_d_lin;
double d_vdx0_d_cgin;
double d_vdx0_d_cs;
double d_vdx0_d_cc;
double d_vdx0_d_cb;
double d_vdx0_d_vto;
double d_vdx0_d_ss;
double d_vdx0_d_delta1;
double d_vdx0_d_delta2;
double d_vdx0_d_nd;
double d_vdx0_d_alpha;
double d_vdx0_d_vel0;
double d_vdx0_d_mu0;
double d_vdx0_d_beta;
double d_vdx0_d_mtheta;
double d_vdx0_d_vtheta;
double d_vdx0_d_vtzeta;
double d_vdx0_d_dibsat;
double d_vdx0_d_epsilon;
double d_vdx0_d_vzeta;
double d_vdx0_d_lambda;
double d_vdx0_d_ngf;
double d_vdx0_d_type;
double fds0;
double d_fds0_d_vgsin;
double d_fds0_d_vdsin;
double d_fds0_d_qcbflag;
double d_fds0_d_vcin;
double d_fds0_d_vbin;
double d_fds0_d_qgsflag;
double d_fds0_d_tambin;
double d_fds0_d_tnomin;
double d_fds0_d_phitin;
double d_fds0_d_w;
double d_fds0_d_lin;
double d_fds0_d_cgin;
double d_fds0_d_cs;
double d_fds0_d_cc;
double d_fds0_d_cb;
double d_fds0_d_vto;
double d_fds0_d_ss;
double d_fds0_d_delta1;
double d_fds0_d_delta2;
double d_fds0_d_nd;
double d_fds0_d_alpha;
double d_fds0_d_vel0;
double d_fds0_d_mu0;
double d_fds0_d_beta;
double d_fds0_d_mtheta;
double d_fds0_d_vtheta;
double d_fds0_d_vtzeta;
double d_fds0_d_dibsat;
double d_fds0_d_epsilon;
double d_fds0_d_vzeta;
double d_fds0_d_lambda;
double d_fds0_d_ngf;
double d_fds0_d_type;
double vsx0;
double d_vsx0_d_vgsin;
double d_vsx0_d_vdsin;
double d_vsx0_d_qcbflag;
double d_vsx0_d_vcin;
double d_vsx0_d_vbin;
double d_vsx0_d_qgsflag;
double d_vsx0_d_tambin;
double d_vsx0_d_tnomin;
double d_vsx0_d_phitin;
double d_vsx0_d_w;
double d_vsx0_d_lin;
double d_vsx0_d_cgin;
double d_vsx0_d_cs;
double d_vsx0_d_cc;
double d_vsx0_d_cb;
double d_vsx0_d_vto;
double d_vsx0_d_ss;
double d_vsx0_d_delta1;
double d_vsx0_d_delta2;
double d_vsx0_d_nd;
double d_vsx0_d_alpha;
double d_vsx0_d_vel0;
double d_vsx0_d_mu0;
double d_vsx0_d_beta;
double d_vsx0_d_mtheta;
double d_vsx0_d_vtheta;
double d_vsx0_d_vtzeta;
double d_vsx0_d_dibsat;
double d_vsx0_d_epsilon;
double d_vsx0_d_vzeta;
double d_vsx0_d_lambda;
double d_vsx0_d_ngf;
double d_vsx0_d_type;
double ffd0;
double d_ffd0_d_vgsin;
double d_ffd0_d_vdsin;
double d_ffd0_d_qcbflag;
double d_ffd0_d_vcin;
double d_ffd0_d_vbin;
double d_ffd0_d_qgsflag;
double d_ffd0_d_tambin;
double d_ffd0_d_tnomin;
double d_ffd0_d_phitin;
double d_ffd0_d_w;
double d_ffd0_d_lin;
double d_ffd0_d_cgin;
double d_ffd0_d_cs;
double d_ffd0_d_cc;
double d_ffd0_d_cb;
double d_ffd0_d_vto;
double d_ffd0_d_ss;
double d_ffd0_d_delta1;
double d_ffd0_d_delta2;
double d_ffd0_d_nd;
double d_ffd0_d_alpha;
double d_ffd0_d_vel0;
double d_ffd0_d_mu0;
double d_ffd0_d_beta;
double d_ffd0_d_mtheta;
double d_ffd0_d_vtheta;
double d_ffd0_d_vtzeta;
double d_ffd0_d_dibsat;
double d_ffd0_d_epsilon;
double d_ffd0_d_vzeta;
double d_ffd0_d_lambda;
double d_ffd0_d_ngf;
double d_ffd0_d_type;
double etad0;
double d_etad0_d_vgsin;
double d_etad0_d_vdsin;
double d_etad0_d_qcbflag;
double d_etad0_d_vcin;
double d_etad0_d_vbin;
double d_etad0_d_qgsflag;
double d_etad0_d_tambin;
double d_etad0_d_tnomin;
double d_etad0_d_phitin;
double d_etad0_d_w;
double d_etad0_d_lin;
double d_etad0_d_cgin;
double d_etad0_d_cs;
double d_etad0_d_cc;
double d_etad0_d_cb;
double d_etad0_d_vto;
double d_etad0_d_ss;
double d_etad0_d_delta1;
double d_etad0_d_delta2;
double d_etad0_d_nd;
double d_etad0_d_alpha;
double d_etad0_d_vel0;
double d_etad0_d_mu0;
double d_etad0_d_beta;
double d_etad0_d_mtheta;
double d_etad0_d_vtheta;
double d_etad0_d_vtzeta;
double d_etad0_d_dibsat;
double d_etad0_d_epsilon;
double d_etad0_d_vzeta;
double d_etad0_d_lambda;
double d_etad0_d_ngf;
double d_etad0_d_type;
double qinvd0;
double d_qinvd0_d_vgsin;
double d_qinvd0_d_vdsin;
double d_qinvd0_d_qcbflag;
double d_qinvd0_d_vcin;
double d_qinvd0_d_vbin;
double d_qinvd0_d_qgsflag;
double d_qinvd0_d_tambin;
double d_qinvd0_d_tnomin;
double d_qinvd0_d_phitin;
double d_qinvd0_d_w;
double d_qinvd0_d_lin;
double d_qinvd0_d_cgin;
double d_qinvd0_d_cs;
double d_qinvd0_d_cc;
double d_qinvd0_d_cb;
double d_qinvd0_d_vto;
double d_qinvd0_d_ss;
double d_qinvd0_d_delta1;
double d_qinvd0_d_delta2;
double d_qinvd0_d_nd;
double d_qinvd0_d_alpha;
double d_qinvd0_d_vel0;
double d_qinvd0_d_mu0;
double d_qinvd0_d_beta;
double d_qinvd0_d_mtheta;
double d_qinvd0_d_vtheta;
double d_qinvd0_d_vtzeta;
double d_qinvd0_d_dibsat;
double d_qinvd0_d_epsilon;
double d_qinvd0_d_vzeta;
double d_qinvd0_d_lambda;
double d_qinvd0_d_ngf;
double d_qinvd0_d_type;
double qs2;
double d_qs2_d_vgsin;
double d_qs2_d_vdsin;
double d_qs2_d_qcbflag;
double d_qs2_d_vcin;
double d_qs2_d_vbin;
double d_qs2_d_qgsflag;
double d_qs2_d_tambin;
double d_qs2_d_tnomin;
double d_qs2_d_phitin;
double d_qs2_d_w;
double d_qs2_d_lin;
double d_qs2_d_cgin;
double d_qs2_d_cs;
double d_qs2_d_cc;
double d_qs2_d_cb;
double d_qs2_d_vto;
double d_qs2_d_ss;
double d_qs2_d_delta1;
double d_qs2_d_delta2;
double d_qs2_d_nd;
double d_qs2_d_alpha;
double d_qs2_d_vel0;
double d_qs2_d_mu0;
double d_qs2_d_beta;
double d_qs2_d_mtheta;
double d_qs2_d_vtheta;
double d_qs2_d_vtzeta;
double d_qs2_d_dibsat;
double d_qs2_d_epsilon;
double d_qs2_d_vzeta;
double d_qs2_d_lambda;
double d_qs2_d_ngf;
double d_qs2_d_type;
double qs3;
double d_qs3_d_vgsin;
double d_qs3_d_vdsin;
double d_qs3_d_qcbflag;
double d_qs3_d_vcin;
double d_qs3_d_vbin;
double d_qs3_d_qgsflag;
double d_qs3_d_tambin;
double d_qs3_d_tnomin;
double d_qs3_d_phitin;
double d_qs3_d_w;
double d_qs3_d_lin;
double d_qs3_d_cgin;
double d_qs3_d_cs;
double d_qs3_d_cc;
double d_qs3_d_cb;
double d_qs3_d_vto;
double d_qs3_d_ss;
double d_qs3_d_delta1;
double d_qs3_d_delta2;
double d_qs3_d_nd;
double d_qs3_d_alpha;
double d_qs3_d_vel0;
double d_qs3_d_mu0;
double d_qs3_d_beta;
double d_qs3_d_mtheta;
double d_qs3_d_vtheta;
double d_qs3_d_vtzeta;
double d_qs3_d_dibsat;
double d_qs3_d_epsilon;
double d_qs3_d_vzeta;
double d_qs3_d_lambda;
double d_qs3_d_ngf;
double d_qs3_d_type;
double qd2;
double d_qd2_d_vgsin;
double d_qd2_d_vdsin;
double d_qd2_d_qcbflag;
double d_qd2_d_vcin;
double d_qd2_d_vbin;
double d_qd2_d_qgsflag;
double d_qd2_d_tambin;
double d_qd2_d_tnomin;
double d_qd2_d_phitin;
double d_qd2_d_w;
double d_qd2_d_lin;
double d_qd2_d_cgin;
double d_qd2_d_cs;
double d_qd2_d_cc;
double d_qd2_d_cb;
double d_qd2_d_vto;
double d_qd2_d_ss;
double d_qd2_d_delta1;
double d_qd2_d_delta2;
double d_qd2_d_nd;
double d_qd2_d_alpha;
double d_qd2_d_vel0;
double d_qd2_d_mu0;
double d_qd2_d_beta;
double d_qd2_d_mtheta;
double d_qd2_d_vtheta;
double d_qd2_d_vtzeta;
double d_qd2_d_dibsat;
double d_qd2_d_epsilon;
double d_qd2_d_vzeta;
double d_qd2_d_lambda;
double d_qd2_d_ngf;
double d_qd2_d_type;
double qd3;
double d_qd3_d_vgsin;
double d_qd3_d_vdsin;
double d_qd3_d_qcbflag;
double d_qd3_d_vcin;
double d_qd3_d_vbin;
double d_qd3_d_qgsflag;
double d_qd3_d_tambin;
double d_qd3_d_tnomin;
double d_qd3_d_phitin;
double d_qd3_d_w;
double d_qd3_d_lin;
double d_qd3_d_cgin;
double d_qd3_d_cs;
double d_qd3_d_cc;
double d_qd3_d_cb;
double d_qd3_d_vto;
double d_qd3_d_ss;
double d_qd3_d_delta1;
double d_qd3_d_delta2;
double d_qd3_d_nd;
double d_qd3_d_alpha;
double d_qd3_d_vel0;
double d_qd3_d_mu0;
double d_qd3_d_beta;
double d_qd3_d_mtheta;
double d_qd3_d_vtheta;
double d_qd3_d_vtzeta;
double d_qd3_d_dibsat;
double d_qd3_d_epsilon;
double d_qd3_d_vzeta;
double d_qd3_d_lambda;
double d_qd3_d_ngf;
double d_qd3_d_type;
double qsqd;
double d_qsqd_d_vgsin;
double d_qsqd_d_vdsin;
double d_qsqd_d_qcbflag;
double d_qsqd_d_vcin;
double d_qsqd_d_vbin;
double d_qsqd_d_qgsflag;
double d_qsqd_d_tambin;
double d_qsqd_d_tnomin;
double d_qsqd_d_phitin;
double d_qsqd_d_w;
double d_qsqd_d_lin;
double d_qsqd_d_cgin;
double d_qsqd_d_cs;
double d_qsqd_d_cc;
double d_qsqd_d_cb;
double d_qsqd_d_vto;
double d_qsqd_d_ss;
double d_qsqd_d_delta1;
double d_qsqd_d_delta2;
double d_qsqd_d_nd;
double d_qsqd_d_alpha;
double d_qsqd_d_vel0;
double d_qsqd_d_mu0;
double d_qsqd_d_beta;
double d_qsqd_d_mtheta;
double d_qsqd_d_vtheta;
double d_qsqd_d_vtzeta;
double d_qsqd_d_dibsat;
double d_qsqd_d_epsilon;
double d_qsqd_d_vzeta;
double d_qsqd_d_lambda;
double d_qsqd_d_ngf;
double d_qsqd_d_type;
double qinvdd;
double d_qinvdd_d_vgsin;
double d_qinvdd_d_vdsin;
double d_qinvdd_d_qcbflag;
double d_qinvdd_d_vcin;
double d_qinvdd_d_vbin;
double d_qinvdd_d_qgsflag;
double d_qinvdd_d_tambin;
double d_qinvdd_d_tnomin;
double d_qinvdd_d_phitin;
double d_qinvdd_d_w;
double d_qinvdd_d_lin;
double d_qinvdd_d_cgin;
double d_qinvdd_d_cs;
double d_qinvdd_d_cc;
double d_qinvdd_d_cb;
double d_qinvdd_d_vto;
double d_qinvdd_d_ss;
double d_qinvdd_d_delta1;
double d_qinvdd_d_delta2;
double d_qinvdd_d_nd;
double d_qinvdd_d_alpha;
double d_qinvdd_d_vel0;
double d_qinvdd_d_mu0;
double d_qinvdd_d_beta;
double d_qinvdd_d_mtheta;
double d_qinvdd_d_vtheta;
double d_qinvdd_d_vtzeta;
double d_qinvdd_d_dibsat;
double d_qinvdd_d_epsilon;
double d_qinvdd_d_vzeta;
double d_qinvdd_d_lambda;
double d_qinvdd_d_ngf;
double d_qinvdd_d_type;
double qd1;
double d_qd1_d_vgsin;
double d_qd1_d_vdsin;
double d_qd1_d_qcbflag;
double d_qd1_d_vcin;
double d_qd1_d_vbin;
double d_qd1_d_qgsflag;
double d_qd1_d_tambin;
double d_qd1_d_tnomin;
double d_qd1_d_phitin;
double d_qd1_d_w;
double d_qd1_d_lin;
double d_qd1_d_cgin;
double d_qd1_d_cs;
double d_qd1_d_cc;
double d_qd1_d_cb;
double d_qd1_d_vto;
double d_qd1_d_ss;
double d_qd1_d_delta1;
double d_qd1_d_delta2;
double d_qd1_d_nd;
double d_qd1_d_alpha;
double d_qd1_d_vel0;
double d_qd1_d_mu0;
double d_qd1_d_beta;
double d_qd1_d_mtheta;
double d_qd1_d_vtheta;
double d_qd1_d_vtzeta;
double d_qd1_d_dibsat;
double d_qd1_d_epsilon;
double d_qd1_d_vzeta;
double d_qd1_d_lambda;
double d_qd1_d_ngf;
double d_qd1_d_type;
double qs;
double d_qs_d_vgsin;
double d_qs_d_vdsin;
double d_qs_d_qcbflag;
double d_qs_d_vcin;
double d_qs_d_vbin;
double d_qs_d_qgsflag;
double d_qs_d_tambin;
double d_qs_d_tnomin;
double d_qs_d_phitin;
double d_qs_d_w;
double d_qs_d_lin;
double d_qs_d_cgin;
double d_qs_d_cs;
double d_qs_d_cc;
double d_qs_d_cb;
double d_qs_d_vto;
double d_qs_d_ss;
double d_qs_d_delta1;
double d_qs_d_delta2;
double d_qs_d_nd;
double d_qs_d_alpha;
double d_qs_d_vel0;
double d_qs_d_mu0;
double d_qs_d_beta;
double d_qs_d_mtheta;
double d_qs_d_vtheta;
double d_qs_d_vtzeta;
double d_qs_d_dibsat;
double d_qs_d_epsilon;
double d_qs_d_vzeta;
double d_qs_d_lambda;
double d_qs_d_ngf;
double d_qs_d_type;
double qd;
double d_qd_d_vgsin;
double d_qd_d_vdsin;
double d_qd_d_qcbflag;
double d_qd_d_vcin;
double d_qd_d_vbin;
double d_qd_d_qgsflag;
double d_qd_d_tambin;
double d_qd_d_tnomin;
double d_qd_d_phitin;
double d_qd_d_w;
double d_qd_d_lin;
double d_qd_d_cgin;
double d_qd_d_cs;
double d_qd_d_cc;
double d_qd_d_cb;
double d_qd_d_vto;
double d_qd_d_ss;
double d_qd_d_delta1;
double d_qd_d_delta2;
double d_qd_d_nd;
double d_qd_d_alpha;
double d_qd_d_vel0;
double d_qd_d_mu0;
double d_qd_d_beta;
double d_qd_d_mtheta;
double d_qd_d_vtheta;
double d_qd_d_vtzeta;
double d_qd_d_dibsat;
double d_qd_d_epsilon;
double d_qd_d_vzeta;
double d_qd_d_lambda;
double d_qd_d_ngf;
double d_qd_d_type;
double etac;
double d_etac_d_vgsin;
double d_etac_d_vdsin;
double d_etac_d_qcbflag;
double d_etac_d_vcin;
double d_etac_d_vbin;
double d_etac_d_qgsflag;
double d_etac_d_tambin;
double d_etac_d_tnomin;
double d_etac_d_phitin;
double d_etac_d_w;
double d_etac_d_lin;
double d_etac_d_cgin;
double d_etac_d_cs;
double d_etac_d_cc;
double d_etac_d_cb;
double d_etac_d_vto;
double d_etac_d_ss;
double d_etac_d_delta1;
double d_etac_d_delta2;
double d_etac_d_nd;
double d_etac_d_alpha;
double d_etac_d_vel0;
double d_etac_d_mu0;
double d_etac_d_beta;
double d_etac_d_mtheta;
double d_etac_d_vtheta;
double d_etac_d_vtzeta;
double d_etac_d_dibsat;
double d_etac_d_epsilon;
double d_etac_d_vzeta;
double d_etac_d_lambda;
double d_etac_d_ngf;
double d_etac_d_type;
double etab;
double d_etab_d_vgsin;
double d_etab_d_vdsin;
double d_etab_d_qcbflag;
double d_etab_d_vcin;
double d_etab_d_vbin;
double d_etab_d_qgsflag;
double d_etab_d_tambin;
double d_etab_d_tnomin;
double d_etab_d_phitin;
double d_etab_d_w;
double d_etab_d_lin;
double d_etab_d_cgin;
double d_etab_d_cs;
double d_etab_d_cc;
double d_etab_d_cb;
double d_etab_d_vto;
double d_etab_d_ss;
double d_etab_d_delta1;
double d_etab_d_delta2;
double d_etab_d_nd;
double d_etab_d_alpha;
double d_etab_d_vel0;
double d_etab_d_mu0;
double d_etab_d_beta;
double d_etab_d_mtheta;
double d_etab_d_vtheta;
double d_etab_d_vtzeta;
double d_etab_d_dibsat;
double d_etab_d_epsilon;
double d_etab_d_vzeta;
double d_etab_d_lambda;
double d_etab_d_ngf;
double d_etab_d_type;
double etags;
double d_etags_d_vgsin;
double d_etags_d_vdsin;
double d_etags_d_qcbflag;
double d_etags_d_vcin;
double d_etags_d_vbin;
double d_etags_d_qgsflag;
double d_etags_d_tambin;
double d_etags_d_tnomin;
double d_etags_d_phitin;
double d_etags_d_w;
double d_etags_d_lin;
double d_etags_d_cgin;
double d_etags_d_cs;
double d_etags_d_cc;
double d_etags_d_cb;
double d_etags_d_vto;
double d_etags_d_ss;
double d_etags_d_delta1;
double d_etags_d_delta2;
double d_etags_d_nd;
double d_etags_d_alpha;
double d_etags_d_vel0;
double d_etags_d_mu0;
double d_etags_d_beta;
double d_etags_d_mtheta;
double d_etags_d_vtheta;
double d_etags_d_vtzeta;
double d_etags_d_dibsat;
double d_etags_d_epsilon;
double d_etags_d_vzeta;
double d_etags_d_lambda;
double d_etags_d_ngf;
double d_etags_d_type;
double exparg;
double d_exparg_d_vgsin;
double d_exparg_d_vdsin;
double d_exparg_d_qcbflag;
double d_exparg_d_vcin;
double d_exparg_d_vbin;
double d_exparg_d_qgsflag;
double d_exparg_d_tambin;
double d_exparg_d_tnomin;
double d_exparg_d_phitin;
double d_exparg_d_w;
double d_exparg_d_lin;
double d_exparg_d_cgin;
double d_exparg_d_cs;
double d_exparg_d_cc;
double d_exparg_d_cb;
double d_exparg_d_vto;
double d_exparg_d_ss;
double d_exparg_d_delta1;
double d_exparg_d_delta2;
double d_exparg_d_nd;
double d_exparg_d_alpha;
double d_exparg_d_vel0;
double d_exparg_d_mu0;
double d_exparg_d_beta;
double d_exparg_d_mtheta;
double d_exparg_d_vtheta;
double d_exparg_d_vtzeta;
double d_exparg_d_dibsat;
double d_exparg_d_epsilon;
double d_exparg_d_vzeta;
double d_exparg_d_lambda;
double d_exparg_d_ngf;
double d_exparg_d_type;
double myarg;
double d_myarg_d_vgsin;
double d_myarg_d_vdsin;
double d_myarg_d_qcbflag;
double d_myarg_d_vcin;
double d_myarg_d_vbin;
double d_myarg_d_qgsflag;
double d_myarg_d_tambin;
double d_myarg_d_tnomin;
double d_myarg_d_phitin;
double d_myarg_d_w;
double d_myarg_d_lin;
double d_myarg_d_cgin;
double d_myarg_d_cs;
double d_myarg_d_cc;
double d_myarg_d_cb;
double d_myarg_d_vto;
double d_myarg_d_ss;
double d_myarg_d_delta1;
double d_myarg_d_delta2;
double d_myarg_d_nd;
double d_myarg_d_alpha;
double d_myarg_d_vel0;
double d_myarg_d_mu0;
double d_myarg_d_beta;
double d_myarg_d_mtheta;
double d_myarg_d_vtheta;
double d_myarg_d_vtzeta;
double d_myarg_d_dibsat;
double d_myarg_d_epsilon;
double d_myarg_d_vzeta;
double d_myarg_d_lambda;
double d_myarg_d_ngf;
double d_myarg_d_type;
double absvdsin;
double d_absvdsin_d_vgsin;
double d_absvdsin_d_vdsin;
double d_absvdsin_d_qcbflag;
double d_absvdsin_d_vcin;
double d_absvdsin_d_vbin;
double d_absvdsin_d_qgsflag;
double d_absvdsin_d_tambin;
double d_absvdsin_d_tnomin;
double d_absvdsin_d_phitin;
double d_absvdsin_d_w;
double d_absvdsin_d_lin;
double d_absvdsin_d_cgin;
double d_absvdsin_d_cs;
double d_absvdsin_d_cc;
double d_absvdsin_d_cb;
double d_absvdsin_d_vto;
double d_absvdsin_d_ss;
double d_absvdsin_d_delta1;
double d_absvdsin_d_delta2;
double d_absvdsin_d_nd;
double d_absvdsin_d_alpha;
double d_absvdsin_d_vel0;
double d_absvdsin_d_mu0;
double d_absvdsin_d_beta;
double d_absvdsin_d_mtheta;
double d_absvdsin_d_vtheta;
double d_absvdsin_d_vtzeta;
double d_absvdsin_d_dibsat;
double d_absvdsin_d_epsilon;
double d_absvdsin_d_vzeta;
double d_absvdsin_d_lambda;
double d_absvdsin_d_ngf;
double d_absvdsin_d_type;
double vgdin;
double d_vgdin_d_vgsin;
double d_vgdin_d_vdsin;
double d_vgdin_d_qcbflag;
double d_vgdin_d_vcin;
double d_vgdin_d_vbin;
double d_vgdin_d_qgsflag;
double d_vgdin_d_tambin;
double d_vgdin_d_tnomin;
double d_vgdin_d_phitin;
double d_vgdin_d_w;
double d_vgdin_d_lin;
double d_vgdin_d_cgin;
double d_vgdin_d_cs;
double d_vgdin_d_cc;
double d_vgdin_d_cb;
double d_vgdin_d_vto;
double d_vgdin_d_ss;
double d_vgdin_d_delta1;
double d_vgdin_d_delta2;
double d_vgdin_d_nd;
double d_vgdin_d_alpha;
double d_vgdin_d_vel0;
double d_vgdin_d_mu0;
double d_vgdin_d_beta;
double d_vgdin_d_mtheta;
double d_vgdin_d_vtheta;
double d_vgdin_d_vtzeta;
double d_vgdin_d_dibsat;
double d_vgdin_d_epsilon;
double d_vgdin_d_vzeta;
double d_vgdin_d_lambda;
double d_vgdin_d_ngf;
double d_vgdin_d_type;
double exparg0;
double d_exparg0_d_vgsin;
double d_exparg0_d_vdsin;
double d_exparg0_d_qcbflag;
double d_exparg0_d_vcin;
double d_exparg0_d_vbin;
double d_exparg0_d_qgsflag;
double d_exparg0_d_tambin;
double d_exparg0_d_tnomin;
double d_exparg0_d_phitin;
double d_exparg0_d_w;
double d_exparg0_d_lin;
double d_exparg0_d_cgin;
double d_exparg0_d_cs;
double d_exparg0_d_cc;
double d_exparg0_d_cb;
double d_exparg0_d_vto;
double d_exparg0_d_ss;
double d_exparg0_d_delta1;
double d_exparg0_d_delta2;
double d_exparg0_d_nd;
double d_exparg0_d_alpha;
double d_exparg0_d_vel0;
double d_exparg0_d_mu0;
double d_exparg0_d_beta;
double d_exparg0_d_mtheta;
double d_exparg0_d_vtheta;
double d_exparg0_d_vtzeta;
double d_exparg0_d_dibsat;
double d_exparg0_d_epsilon;
double d_exparg0_d_vzeta;
double d_exparg0_d_lambda;
double d_exparg0_d_ngf;
double d_exparg0_d_type;
double myarg0;
double d_myarg0_d_vgsin;
double d_myarg0_d_vdsin;
double d_myarg0_d_qcbflag;
double d_myarg0_d_vcin;
double d_myarg0_d_vbin;
double d_myarg0_d_qgsflag;
double d_myarg0_d_tambin;
double d_myarg0_d_tnomin;
double d_myarg0_d_phitin;
double d_myarg0_d_w;
double d_myarg0_d_lin;
double d_myarg0_d_cgin;
double d_myarg0_d_cs;
double d_myarg0_d_cc;
double d_myarg0_d_cb;
double d_myarg0_d_vto;
double d_myarg0_d_ss;
double d_myarg0_d_delta1;
double d_myarg0_d_delta2;
double d_myarg0_d_nd;
double d_myarg0_d_alpha;
double d_myarg0_d_vel0;
double d_myarg0_d_mu0;
double d_myarg0_d_beta;
double d_myarg0_d_mtheta;
double d_myarg0_d_vtheta;
double d_myarg0_d_vtzeta;
double d_myarg0_d_dibsat;
double d_myarg0_d_epsilon;
double d_myarg0_d_vzeta;
double d_myarg0_d_lambda;
double d_myarg0_d_ngf;
double d_myarg0_d_type;
{
d_absvdsin_d_vgsin=0.0;
d_absvdsin_d_vdsin=d_absfunc(vdsin,1.0);
d_absvdsin_d_qcbflag=0.0;
d_absvdsin_d_vcin=0.0;
d_absvdsin_d_vbin=0.0;
d_absvdsin_d_qgsflag=0.0;
d_absvdsin_d_tambin=0.0;
d_absvdsin_d_tnomin=0.0;
d_absvdsin_d_phitin=0.0;
d_absvdsin_d_w=0.0;
d_absvdsin_d_lin=0.0;
d_absvdsin_d_cgin=0.0;
d_absvdsin_d_cs=0.0;
d_absvdsin_d_cc=0.0;
d_absvdsin_d_cb=0.0;
d_absvdsin_d_vto=0.0;
d_absvdsin_d_ss=0.0;
d_absvdsin_d_delta1=0.0;
d_absvdsin_d_delta2=0.0;
d_absvdsin_d_nd=0.0;
d_absvdsin_d_alpha=0.0;
d_absvdsin_d_vel0=0.0;
d_absvdsin_d_mu0=0.0;
d_absvdsin_d_beta=0.0;
d_absvdsin_d_mtheta=0.0;
d_absvdsin_d_vtheta=0.0;
d_absvdsin_d_vtzeta=0.0;
d_absvdsin_d_dibsat=0.0;
d_absvdsin_d_epsilon=0.0;
d_absvdsin_d_vzeta=0.0;
d_absvdsin_d_lambda=0.0;
d_absvdsin_d_ngf=0.0;
d_absvdsin_d_type=0.0;
absvdsin=absfunc(vdsin);
d_vgdin_d_vgsin=1.0;
d_vgdin_d_vdsin=(-1.0);
d_vgdin_d_qcbflag=0.0;
d_vgdin_d_vcin=0.0;
d_vgdin_d_vbin=0.0;
d_vgdin_d_qgsflag=0.0;
d_vgdin_d_tambin=0.0;
d_vgdin_d_tnomin=0.0;
d_vgdin_d_phitin=0.0;
d_vgdin_d_w=0.0;
d_vgdin_d_lin=0.0;
d_vgdin_d_cgin=0.0;
d_vgdin_d_cs=0.0;
d_vgdin_d_cc=0.0;
d_vgdin_d_cb=0.0;
d_vgdin_d_vto=0.0;
d_vgdin_d_ss=0.0;
d_vgdin_d_delta1=0.0;
d_vgdin_d_delta2=0.0;
d_vgdin_d_nd=0.0;
d_vgdin_d_alpha=0.0;
d_vgdin_d_vel0=0.0;
d_vgdin_d_mu0=0.0;
d_vgdin_d_beta=0.0;
d_vgdin_d_mtheta=0.0;
d_vgdin_d_vtheta=0.0;
d_vgdin_d_vtzeta=0.0;
d_vgdin_d_dibsat=0.0;
d_vgdin_d_epsilon=0.0;
d_vgdin_d_vzeta=0.0;
d_vgdin_d_lambda=0.0;
d_vgdin_d_ngf=0.0;
d_vgdin_d_type=0.0;
vgdin=(vgsin-vdsin);
d_alpha_phit_d_vgsin=0.0;
d_alpha_phit_d_vdsin=0.0;
d_alpha_phit_d_qcbflag=0.0;
d_alpha_phit_d_vcin=0.0;
d_alpha_phit_d_vbin=0.0;
d_alpha_phit_d_qgsflag=0.0;
d_alpha_phit_d_tambin=0.0;
d_alpha_phit_d_tnomin=0.0;
d_alpha_phit_d_phitin=(alpha);
d_alpha_phit_d_w=0.0;
d_alpha_phit_d_lin=0.0;
d_alpha_phit_d_cgin=0.0;
d_alpha_phit_d_cs=0.0;
d_alpha_phit_d_cc=0.0;
d_alpha_phit_d_cb=0.0;
d_alpha_phit_d_vto=0.0;
d_alpha_phit_d_ss=0.0;
d_alpha_phit_d_delta1=0.0;
d_alpha_phit_d_delta2=0.0;
d_alpha_phit_d_nd=0.0;
d_alpha_phit_d_alpha=(phitin);
d_alpha_phit_d_vel0=0.0;
d_alpha_phit_d_mu0=0.0;
d_alpha_phit_d_beta=0.0;
d_alpha_phit_d_mtheta=0.0;
d_alpha_phit_d_vtheta=0.0;
d_alpha_phit_d_vtzeta=0.0;
d_alpha_phit_d_dibsat=0.0;
d_alpha_phit_d_epsilon=0.0;
d_alpha_phit_d_vzeta=0.0;
d_alpha_phit_d_lambda=0.0;
d_alpha_phit_d_ngf=0.0;
d_alpha_phit_d_type=0.0;
alpha_phit=(alpha*phitin);
d_n_d_vgsin=(nd*d_absvdsin_d_vgsin);
d_n_d_vdsin=(nd*d_absvdsin_d_vdsin);
d_n_d_qcbflag=(nd*d_absvdsin_d_qcbflag);
d_n_d_vcin=(nd*d_absvdsin_d_vcin);
d_n_d_vbin=(nd*d_absvdsin_d_vbin);
d_n_d_qgsflag=(nd*d_absvdsin_d_qgsflag);
d_n_d_tambin=(nd*d_absvdsin_d_tambin);
d_n_d_tnomin=(nd*d_absvdsin_d_tnomin);
d_n_d_phitin=((-ss*(2.30258509299404568401)/(2.30258509299404568401*phitin)/(2.30258509299404568401*phitin))+(nd*d_absvdsin_d_phitin));
d_n_d_w=(nd*d_absvdsin_d_w);
d_n_d_lin=(nd*d_absvdsin_d_lin);
d_n_d_cgin=(nd*d_absvdsin_d_cgin);
d_n_d_cs=(nd*d_absvdsin_d_cs);
d_n_d_cc=(nd*d_absvdsin_d_cc);
d_n_d_cb=(nd*d_absvdsin_d_cb);
d_n_d_vto=(nd*d_absvdsin_d_vto);
d_n_d_ss=((1.0/(2.30258509299404568401*phitin))+(nd*d_absvdsin_d_ss));
d_n_d_delta1=(nd*d_absvdsin_d_delta1);
d_n_d_delta2=(nd*d_absvdsin_d_delta2);
d_n_d_nd=(nd*d_absvdsin_d_nd+absvdsin);
d_n_d_alpha=(nd*d_absvdsin_d_alpha);
d_n_d_vel0=(nd*d_absvdsin_d_vel0);
d_n_d_mu0=(nd*d_absvdsin_d_mu0);
d_n_d_beta=(nd*d_absvdsin_d_beta);
d_n_d_mtheta=(nd*d_absvdsin_d_mtheta);
d_n_d_vtheta=(nd*d_absvdsin_d_vtheta);
d_n_d_vtzeta=(nd*d_absvdsin_d_vtzeta);
d_n_d_dibsat=(nd*d_absvdsin_d_dibsat);
d_n_d_epsilon=(nd*d_absvdsin_d_epsilon);
d_n_d_vzeta=(nd*d_absvdsin_d_vzeta);
d_n_d_lambda=(nd*d_absvdsin_d_lambda);
d_n_d_ngf=(nd*d_absvdsin_d_ngf);
d_n_d_type=(nd*d_absvdsin_d_type);
n=((ss/(2.30258509299404568401*phitin))+(nd*absvdsin));
d_vtof_d_vgsin=0.0;
d_vtof_d_vdsin=0.0;
d_vtof_d_qcbflag=0.0;
d_vtof_d_vcin=0.0;
d_vtof_d_vbin=0.0;
d_vtof_d_qgsflag=0.0;
d_vtof_d_tambin=(vtzeta);
d_vtof_d_tnomin=(vtzeta*(-1.0));
d_vtof_d_phitin=0.0;
d_vtof_d_w=0.0;
d_vtof_d_lin=0.0;
d_vtof_d_cgin=0.0;
d_vtof_d_cs=0.0;
d_vtof_d_cc=0.0;
d_vtof_d_cb=0.0;
d_vtof_d_vto=1.0;
d_vtof_d_ss=0.0;
d_vtof_d_delta1=0.0;
d_vtof_d_delta2=0.0;
d_vtof_d_nd=0.0;
d_vtof_d_alpha=0.0;
d_vtof_d_vel0=0.0;
d_vtof_d_mu0=0.0;
d_vtof_d_beta=0.0;
d_vtof_d_mtheta=0.0;
d_vtof_d_vtheta=0.0;
d_vtof_d_vtzeta=((tambin-tnomin));
d_vtof_d_dibsat=0.0;
d_vtof_d_epsilon=0.0;
d_vtof_d_vzeta=0.0;
d_vtof_d_lambda=0.0;
d_vtof_d_ngf=0.0;
d_vtof_d_type=0.0;
vtof=(vto+(vtzeta*(tambin-tnomin)));
if((dibsat!=0))
{
d_vsatdibl_d_vgsin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vgsin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vgsin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vdsin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vdsin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vdsin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_qcbflag=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_qcbflag-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_qcbflag/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vcin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vcin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vcin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vbin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vbin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vbin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_qgsflag=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_qgsflag-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_qgsflag/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_tambin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_tambin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_tambin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_tnomin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_tnomin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_tnomin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_phitin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_phitin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_phitin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_w=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_w-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_w/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_lin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_lin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_lin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cgin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cgin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cgin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cs=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cs-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cs/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cc=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cc-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cc/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cb=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cb-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cb/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vto=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vto-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vto/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_ss=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_ss-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_ss/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_delta1=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_delta1-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_delta1/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_delta2=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_delta2-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_delta2/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_nd=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_nd-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_nd/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_alpha=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_alpha-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_alpha/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vel0=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vel0-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vel0/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_mu0=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_mu0-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_mu0/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_beta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_beta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_beta/dibsat)+(((absvdsin/dibsat)==0.0)?0.0:(log((absvdsin/dibsat)*pow((absvdsin/dibsat),beta))))+(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(log((1.0+pow((absvdsin/dibsat),beta))*pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)))))*(-1.0/beta/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_mtheta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_mtheta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_mtheta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vtheta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vtheta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vtheta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vtzeta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vtzeta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vtzeta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_dibsat=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_dibsat-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*((dibsat*d_absvdsin_d_dibsat-absvdsin)/dibsat/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_epsilon=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_epsilon-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_epsilon/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vzeta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vzeta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vzeta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_lambda=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_lambda-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_lambda/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_ngf=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_ngf-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_ngf/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_type=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_type-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_type/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
vsatdibl=(absvdsin/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
}
else
{
d_vsatdibl_d_vgsin=0.0;
d_vsatdibl_d_vdsin=0.0;
d_vsatdibl_d_qcbflag=0.0;
d_vsatdibl_d_vcin=0.0;
d_vsatdibl_d_vbin=0.0;
d_vsatdibl_d_qgsflag=0.0;
d_vsatdibl_d_tambin=0.0;
d_vsatdibl_d_tnomin=0.0;
d_vsatdibl_d_phitin=0.0;
d_vsatdibl_d_w=0.0;
d_vsatdibl_d_lin=0.0;
d_vsatdibl_d_cgin=0.0;
d_vsatdibl_d_cs=0.0;
d_vsatdibl_d_cc=0.0;
d_vsatdibl_d_cb=0.0;
d_vsatdibl_d_vto=0.0;
d_vsatdibl_d_ss=0.0;
d_vsatdibl_d_delta1=0.0;
d_vsatdibl_d_delta2=0.0;
d_vsatdibl_d_nd=0.0;
d_vsatdibl_d_alpha=0.0;
d_vsatdibl_d_vel0=0.0;
d_vsatdibl_d_mu0=0.0;
d_vsatdibl_d_beta=0.0;
d_vsatdibl_d_mtheta=0.0;
d_vsatdibl_d_vtheta=0.0;
d_vsatdibl_d_vtzeta=0.0;
d_vsatdibl_d_dibsat=0.0;
d_vsatdibl_d_epsilon=0.0;
d_vsatdibl_d_vzeta=0.0;
d_vsatdibl_d_lambda=0.0;
d_vsatdibl_d_ngf=0.0;
d_vsatdibl_d_type=0.0;
vsatdibl=0;
}
d_delta_d_vgsin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vgsin)+((-(d_vsatdibl_d_vgsin*delta2))*absvdsin));
d_delta_d_vdsin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vdsin)+((-(d_vsatdibl_d_vdsin*delta2))*absvdsin));
d_delta_d_qcbflag=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_qcbflag)+((-(d_vsatdibl_d_qcbflag*delta2))*absvdsin));
d_delta_d_vcin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vcin)+((-(d_vsatdibl_d_vcin*delta2))*absvdsin));
d_delta_d_vbin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vbin)+((-(d_vsatdibl_d_vbin*delta2))*absvdsin));
d_delta_d_qgsflag=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_qgsflag)+((-(d_vsatdibl_d_qgsflag*delta2))*absvdsin));
d_delta_d_tambin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_tambin)+((-(d_vsatdibl_d_tambin*delta2))*absvdsin));
d_delta_d_tnomin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_tnomin)+((-(d_vsatdibl_d_tnomin*delta2))*absvdsin));
d_delta_d_phitin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_phitin)+((-(d_vsatdibl_d_phitin*delta2))*absvdsin));
d_delta_d_w=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_w)+((-(d_vsatdibl_d_w*delta2))*absvdsin));
d_delta_d_lin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_lin)+((-(d_vsatdibl_d_lin*delta2))*absvdsin));
d_delta_d_cgin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cgin)+((-(d_vsatdibl_d_cgin*delta2))*absvdsin));
d_delta_d_cs=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cs)+((-(d_vsatdibl_d_cs*delta2))*absvdsin));
d_delta_d_cc=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cc)+((-(d_vsatdibl_d_cc*delta2))*absvdsin));
d_delta_d_cb=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cb)+((-(d_vsatdibl_d_cb*delta2))*absvdsin));
d_delta_d_vto=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vto)+((-(d_vsatdibl_d_vto*delta2))*absvdsin));
d_delta_d_ss=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_ss)+((-(d_vsatdibl_d_ss*delta2))*absvdsin));
d_delta_d_delta1=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_delta1)+((1.0-(d_vsatdibl_d_delta1*delta2))*absvdsin));
d_delta_d_delta2=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_delta2)+((-(vsatdibl+delta2*d_vsatdibl_d_delta2))*absvdsin));
d_delta_d_nd=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_nd)+((-(d_vsatdibl_d_nd*delta2))*absvdsin));
d_delta_d_alpha=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_alpha)+((-(d_vsatdibl_d_alpha*delta2))*absvdsin));
d_delta_d_vel0=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vel0)+((-(d_vsatdibl_d_vel0*delta2))*absvdsin));
d_delta_d_mu0=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_mu0)+((-(d_vsatdibl_d_mu0*delta2))*absvdsin));
d_delta_d_beta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_beta)+((-(d_vsatdibl_d_beta*delta2))*absvdsin));
d_delta_d_mtheta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_mtheta)+((-(d_vsatdibl_d_mtheta*delta2))*absvdsin));
d_delta_d_vtheta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vtheta)+((-(d_vsatdibl_d_vtheta*delta2))*absvdsin));
d_delta_d_vtzeta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vtzeta)+((-(d_vsatdibl_d_vtzeta*delta2))*absvdsin));
d_delta_d_dibsat=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_dibsat)+((-(d_vsatdibl_d_dibsat*delta2))*absvdsin));
d_delta_d_epsilon=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_epsilon)+((-(d_vsatdibl_d_epsilon*delta2))*absvdsin));
d_delta_d_vzeta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vzeta)+((-(d_vsatdibl_d_vzeta*delta2))*absvdsin));
d_delta_d_lambda=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_lambda)+((-(d_vsatdibl_d_lambda*delta2))*absvdsin));
d_delta_d_ngf=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_ngf)+((-(d_vsatdibl_d_ngf*delta2))*absvdsin));
d_delta_d_type=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_type)+((-(d_vsatdibl_d_type*delta2))*absvdsin));
delta=((delta1-(vsatdibl*delta2))*absvdsin);
d_vtdibl_d_vgsin=(d_vtof_d_vgsin-d_delta_d_vgsin);
d_vtdibl_d_vdsin=(d_vtof_d_vdsin-d_delta_d_vdsin);
d_vtdibl_d_qcbflag=(d_vtof_d_qcbflag-d_delta_d_qcbflag);
d_vtdibl_d_vcin=(d_vtof_d_vcin-d_delta_d_vcin);
d_vtdibl_d_vbin=(d_vtof_d_vbin-d_delta_d_vbin);
d_vtdibl_d_qgsflag=(d_vtof_d_qgsflag-d_delta_d_qgsflag);
d_vtdibl_d_tambin=(d_vtof_d_tambin-d_delta_d_tambin);
d_vtdibl_d_tnomin=(d_vtof_d_tnomin-d_delta_d_tnomin);
d_vtdibl_d_phitin=(d_vtof_d_phitin-d_delta_d_phitin);
d_vtdibl_d_w=(d_vtof_d_w-d_delta_d_w);
d_vtdibl_d_lin=(d_vtof_d_lin-d_delta_d_lin);
d_vtdibl_d_cgin=(d_vtof_d_cgin-d_delta_d_cgin);
d_vtdibl_d_cs=(d_vtof_d_cs-d_delta_d_cs);
d_vtdibl_d_cc=(d_vtof_d_cc-d_delta_d_cc);
d_vtdibl_d_cb=(d_vtof_d_cb-d_delta_d_cb);
d_vtdibl_d_vto=(d_vtof_d_vto-d_delta_d_vto);
d_vtdibl_d_ss=(d_vtof_d_ss-d_delta_d_ss);
d_vtdibl_d_delta1=(d_vtof_d_delta1-d_delta_d_delta1);
d_vtdibl_d_delta2=(d_vtof_d_delta2-d_delta_d_delta2);
d_vtdibl_d_nd=(d_vtof_d_nd-d_delta_d_nd);
d_vtdibl_d_alpha=(d_vtof_d_alpha-d_delta_d_alpha);
d_vtdibl_d_vel0=(d_vtof_d_vel0-d_delta_d_vel0);
d_vtdibl_d_mu0=(d_vtof_d_mu0-d_delta_d_mu0);
d_vtdibl_d_beta=(d_vtof_d_beta-d_delta_d_beta);
d_vtdibl_d_mtheta=(d_vtof_d_mtheta-d_delta_d_mtheta);
d_vtdibl_d_vtheta=(d_vtof_d_vtheta-d_delta_d_vtheta);
d_vtdibl_d_vtzeta=(d_vtof_d_vtzeta-d_delta_d_vtzeta);
d_vtdibl_d_dibsat=(d_vtof_d_dibsat-d_delta_d_dibsat);
d_vtdibl_d_epsilon=(d_vtof_d_epsilon-d_delta_d_epsilon);
d_vtdibl_d_vzeta=(d_vtof_d_vzeta-d_delta_d_vzeta);
d_vtdibl_d_lambda=(d_vtof_d_lambda-d_delta_d_lambda);
d_vtdibl_d_ngf=(d_vtof_d_ngf-d_delta_d_ngf);
d_vtdibl_d_type=(d_vtof_d_type-d_delta_d_type);
vtdibl=(vtof-delta);
d_two_n_phit_d_vgsin=((2.0*d_n_d_vgsin)*phitin);
d_two_n_phit_d_vdsin=((2.0*d_n_d_vdsin)*phitin);
d_two_n_phit_d_qcbflag=((2.0*d_n_d_qcbflag)*phitin);
d_two_n_phit_d_vcin=((2.0*d_n_d_vcin)*phitin);
d_two_n_phit_d_vbin=((2.0*d_n_d_vbin)*phitin);
d_two_n_phit_d_qgsflag=((2.0*d_n_d_qgsflag)*phitin);
d_two_n_phit_d_tambin=((2.0*d_n_d_tambin)*phitin);
d_two_n_phit_d_tnomin=((2.0*d_n_d_tnomin)*phitin);
d_two_n_phit_d_phitin=((2.0*n)+phitin*(2.0*d_n_d_phitin));
d_two_n_phit_d_w=((2.0*d_n_d_w)*phitin);
d_two_n_phit_d_lin=((2.0*d_n_d_lin)*phitin);
d_two_n_phit_d_cgin=((2.0*d_n_d_cgin)*phitin);
d_two_n_phit_d_cs=((2.0*d_n_d_cs)*phitin);
d_two_n_phit_d_cc=((2.0*d_n_d_cc)*phitin);
d_two_n_phit_d_cb=((2.0*d_n_d_cb)*phitin);
d_two_n_phit_d_vto=((2.0*d_n_d_vto)*phitin);
d_two_n_phit_d_ss=((2.0*d_n_d_ss)*phitin);
d_two_n_phit_d_delta1=((2.0*d_n_d_delta1)*phitin);
d_two_n_phit_d_delta2=((2.0*d_n_d_delta2)*phitin);
d_two_n_phit_d_nd=((2.0*d_n_d_nd)*phitin);
d_two_n_phit_d_alpha=((2.0*d_n_d_alpha)*phitin);
d_two_n_phit_d_vel0=((2.0*d_n_d_vel0)*phitin);
d_two_n_phit_d_mu0=((2.0*d_n_d_mu0)*phitin);
d_two_n_phit_d_beta=((2.0*d_n_d_beta)*phitin);
d_two_n_phit_d_mtheta=((2.0*d_n_d_mtheta)*phitin);
d_two_n_phit_d_vtheta=((2.0*d_n_d_vtheta)*phitin);
d_two_n_phit_d_vtzeta=((2.0*d_n_d_vtzeta)*phitin);
d_two_n_phit_d_dibsat=((2.0*d_n_d_dibsat)*phitin);
d_two_n_phit_d_epsilon=((2.0*d_n_d_epsilon)*phitin);
d_two_n_phit_d_vzeta=((2.0*d_n_d_vzeta)*phitin);
d_two_n_phit_d_lambda=((2.0*d_n_d_lambda)*phitin);
d_two_n_phit_d_ngf=((2.0*d_n_d_ngf)*phitin);
d_two_n_phit_d_type=((2.0*d_n_d_type)*phitin);
two_n_phit=((2.0*n)*phitin);
d_qref_d_vgsin=(cgin*d_two_n_phit_d_vgsin);
d_qref_d_vdsin=(cgin*d_two_n_phit_d_vdsin);
d_qref_d_qcbflag=(cgin*d_two_n_phit_d_qcbflag);
d_qref_d_vcin=(cgin*d_two_n_phit_d_vcin);
d_qref_d_vbin=(cgin*d_two_n_phit_d_vbin);
d_qref_d_qgsflag=(cgin*d_two_n_phit_d_qgsflag);
d_qref_d_tambin=(cgin*d_two_n_phit_d_tambin);
d_qref_d_tnomin=(cgin*d_two_n_phit_d_tnomin);
d_qref_d_phitin=(cgin*d_two_n_phit_d_phitin);
d_qref_d_w=(cgin*d_two_n_phit_d_w);
d_qref_d_lin=(cgin*d_two_n_phit_d_lin);
d_qref_d_cgin=(cgin*d_two_n_phit_d_cgin+two_n_phit);
d_qref_d_cs=(cgin*d_two_n_phit_d_cs);
d_qref_d_cc=(cgin*d_two_n_phit_d_cc);
d_qref_d_cb=(cgin*d_two_n_phit_d_cb);
d_qref_d_vto=(cgin*d_two_n_phit_d_vto);
d_qref_d_ss=(cgin*d_two_n_phit_d_ss);
d_qref_d_delta1=(cgin*d_two_n_phit_d_delta1);
d_qref_d_delta2=(cgin*d_two_n_phit_d_delta2);
d_qref_d_nd=(cgin*d_two_n_phit_d_nd);
d_qref_d_alpha=(cgin*d_two_n_phit_d_alpha);
d_qref_d_vel0=(cgin*d_two_n_phit_d_vel0);
d_qref_d_mu0=(cgin*d_two_n_phit_d_mu0);
d_qref_d_beta=(cgin*d_two_n_phit_d_beta);
d_qref_d_mtheta=(cgin*d_two_n_phit_d_mtheta);
d_qref_d_vtheta=(cgin*d_two_n_phit_d_vtheta);
d_qref_d_vtzeta=(cgin*d_two_n_phit_d_vtzeta);
d_qref_d_dibsat=(cgin*d_two_n_phit_d_dibsat);
d_qref_d_epsilon=(cgin*d_two_n_phit_d_epsilon);
d_qref_d_vzeta=(cgin*d_two_n_phit_d_vzeta);
d_qref_d_lambda=(cgin*d_two_n_phit_d_lambda);
d_qref_d_ngf=(cgin*d_two_n_phit_d_ngf);
d_qref_d_type=(cgin*d_two_n_phit_d_type);
qref=(cgin*two_n_phit);
d_myarg_d_vgsin=(d_vtdibl_d_vgsin-(d_alpha_phit_d_vgsin/2.0));
d_myarg_d_vdsin=(d_vtdibl_d_vdsin-(d_alpha_phit_d_vdsin/2.0));
d_myarg_d_qcbflag=(d_vtdibl_d_qcbflag-(d_alpha_phit_d_qcbflag/2.0));
d_myarg_d_vcin=(d_vtdibl_d_vcin-(d_alpha_phit_d_vcin/2.0));
d_myarg_d_vbin=(d_vtdibl_d_vbin-(d_alpha_phit_d_vbin/2.0));
d_myarg_d_qgsflag=(d_vtdibl_d_qgsflag-(d_alpha_phit_d_qgsflag/2.0));
d_myarg_d_tambin=(d_vtdibl_d_tambin-(d_alpha_phit_d_tambin/2.0));
d_myarg_d_tnomin=(d_vtdibl_d_tnomin-(d_alpha_phit_d_tnomin/2.0));
d_myarg_d_phitin=(d_vtdibl_d_phitin-(d_alpha_phit_d_phitin/2.0));
d_myarg_d_w=(d_vtdibl_d_w-(d_alpha_phit_d_w/2.0));
d_myarg_d_lin=(d_vtdibl_d_lin-(d_alpha_phit_d_lin/2.0));
d_myarg_d_cgin=(d_vtdibl_d_cgin-(d_alpha_phit_d_cgin/2.0));
d_myarg_d_cs=(d_vtdibl_d_cs-(d_alpha_phit_d_cs/2.0));
d_myarg_d_cc=(d_vtdibl_d_cc-(d_alpha_phit_d_cc/2.0));
d_myarg_d_cb=(d_vtdibl_d_cb-(d_alpha_phit_d_cb/2.0));
d_myarg_d_vto=(d_vtdibl_d_vto-(d_alpha_phit_d_vto/2.0));
d_myarg_d_ss=(d_vtdibl_d_ss-(d_alpha_phit_d_ss/2.0));
d_myarg_d_delta1=(d_vtdibl_d_delta1-(d_alpha_phit_d_delta1/2.0));
d_myarg_d_delta2=(d_vtdibl_d_delta2-(d_alpha_phit_d_delta2/2.0));
d_myarg_d_nd=(d_vtdibl_d_nd-(d_alpha_phit_d_nd/2.0));
d_myarg_d_alpha=(d_vtdibl_d_alpha-(d_alpha_phit_d_alpha/2.0));
d_myarg_d_vel0=(d_vtdibl_d_vel0-(d_alpha_phit_d_vel0/2.0));
d_myarg_d_mu0=(d_vtdibl_d_mu0-(d_alpha_phit_d_mu0/2.0));
d_myarg_d_beta=(d_vtdibl_d_beta-(d_alpha_phit_d_beta/2.0));
d_myarg_d_mtheta=(d_vtdibl_d_mtheta-(d_alpha_phit_d_mtheta/2.0));
d_myarg_d_vtheta=(d_vtdibl_d_vtheta-(d_alpha_phit_d_vtheta/2.0));
d_myarg_d_vtzeta=(d_vtdibl_d_vtzeta-(d_alpha_phit_d_vtzeta/2.0));
d_myarg_d_dibsat=(d_vtdibl_d_dibsat-(d_alpha_phit_d_dibsat/2.0));
d_myarg_d_epsilon=(d_vtdibl_d_epsilon-(d_alpha_phit_d_epsilon/2.0));
d_myarg_d_vzeta=(d_vtdibl_d_vzeta-(d_alpha_phit_d_vzeta/2.0));
d_myarg_d_lambda=(d_vtdibl_d_lambda-(d_alpha_phit_d_lambda/2.0));
d_myarg_d_ngf=(d_vtdibl_d_ngf-(d_alpha_phit_d_ngf/2.0));
d_myarg_d_type=(d_vtdibl_d_type-(d_alpha_phit_d_type/2.0));
myarg=(vtdibl-(alpha_phit/2.0));
d_exparg_d_vgsin=((alpha_phit*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-d_myarg_d_vgsin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg_d_vdsin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-d_myarg_d_vdsin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg_d_qcbflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-d_myarg_d_qcbflag)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg_d_vcin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-d_myarg_d_vcin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg_d_vbin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-d_myarg_d_vbin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg_d_qgsflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-d_myarg_d_qgsflag)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg_d_tambin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-d_myarg_d_tambin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg_d_tnomin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-d_myarg_d_tnomin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg_d_phitin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-d_myarg_d_phitin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg_d_w=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-d_myarg_d_w)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg_d_lin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-d_myarg_d_lin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg_d_cgin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-d_myarg_d_cgin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg_d_cs=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-d_myarg_d_cs)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg_d_cc=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-d_myarg_d_cc)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg_d_cb=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-d_myarg_d_cb)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg_d_vto=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-d_myarg_d_vto)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg_d_ss=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-d_myarg_d_ss)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg_d_delta1=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-d_myarg_d_delta1)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg_d_delta2=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-d_myarg_d_delta2)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg_d_nd=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-d_myarg_d_nd)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg_d_alpha=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-d_myarg_d_alpha)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg_d_vel0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-d_myarg_d_vel0)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg_d_mu0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-d_myarg_d_mu0)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg_d_beta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-d_myarg_d_beta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg_d_mtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-d_myarg_d_mtheta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-d_myarg_d_vtheta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-d_myarg_d_vtzeta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg_d_dibsat=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-d_myarg_d_dibsat)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg_d_epsilon=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-d_myarg_d_epsilon)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg_d_vzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-d_myarg_d_vzeta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg_d_lambda=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-d_myarg_d_lambda)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg_d_ngf=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-d_myarg_d_ngf)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg_d_type=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-d_myarg_d_type)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg=((mmax(vgsin,vgdin)-myarg)/alpha_phit);
if((exparg>50.0))
{
d_ff_d_vgsin=0.0;
d_ff_d_vdsin=0.0;
d_ff_d_qcbflag=0.0;
d_ff_d_vcin=0.0;
d_ff_d_vbin=0.0;
d_ff_d_qgsflag=0.0;
d_ff_d_tambin=0.0;
d_ff_d_tnomin=0.0;
d_ff_d_phitin=0.0;
d_ff_d_w=0.0;
d_ff_d_lin=0.0;
d_ff_d_cgin=0.0;
d_ff_d_cs=0.0;
d_ff_d_cc=0.0;
d_ff_d_cb=0.0;
d_ff_d_vto=0.0;
d_ff_d_ss=0.0;
d_ff_d_delta1=0.0;
d_ff_d_delta2=0.0;
d_ff_d_nd=0.0;
d_ff_d_alpha=0.0;
d_ff_d_vel0=0.0;
d_ff_d_mu0=0.0;
d_ff_d_beta=0.0;
d_ff_d_mtheta=0.0;
d_ff_d_vtheta=0.0;
d_ff_d_vtzeta=0.0;
d_ff_d_dibsat=0.0;
d_ff_d_epsilon=0.0;
d_ff_d_vzeta=0.0;
d_ff_d_lambda=0.0;
d_ff_d_ngf=0.0;
d_ff_d_type=0.0;
ff=0.0;
}
else
{
if((exparg<(-50.0)))
{
d_ff_d_vgsin=0.0;
d_ff_d_vdsin=0.0;
d_ff_d_qcbflag=0.0;
d_ff_d_vcin=0.0;
d_ff_d_vbin=0.0;
d_ff_d_qgsflag=0.0;
d_ff_d_tambin=0.0;
d_ff_d_tnomin=0.0;
d_ff_d_phitin=0.0;
d_ff_d_w=0.0;
d_ff_d_lin=0.0;
d_ff_d_cgin=0.0;
d_ff_d_cs=0.0;
d_ff_d_cc=0.0;
d_ff_d_cb=0.0;
d_ff_d_vto=0.0;
d_ff_d_ss=0.0;
d_ff_d_delta1=0.0;
d_ff_d_delta2=0.0;
d_ff_d_nd=0.0;
d_ff_d_alpha=0.0;
d_ff_d_vel0=0.0;
d_ff_d_mu0=0.0;
d_ff_d_beta=0.0;
d_ff_d_mtheta=0.0;
d_ff_d_vtheta=0.0;
d_ff_d_vtzeta=0.0;
d_ff_d_dibsat=0.0;
d_ff_d_epsilon=0.0;
d_ff_d_vzeta=0.0;
d_ff_d_lambda=0.0;
d_ff_d_ngf=0.0;
d_ff_d_type=0.0;
ff=1.0;
}
else
{
d_ff_d_vgsin=(-exp(exparg)*d_exparg_d_vgsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vdsin=(-exp(exparg)*d_exparg_d_vdsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_qcbflag=(-exp(exparg)*d_exparg_d_qcbflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vcin=(-exp(exparg)*d_exparg_d_vcin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vbin=(-exp(exparg)*d_exparg_d_vbin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_qgsflag=(-exp(exparg)*d_exparg_d_qgsflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_tambin=(-exp(exparg)*d_exparg_d_tambin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_tnomin=(-exp(exparg)*d_exparg_d_tnomin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_phitin=(-exp(exparg)*d_exparg_d_phitin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_w=(-exp(exparg)*d_exparg_d_w/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_lin=(-exp(exparg)*d_exparg_d_lin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cgin=(-exp(exparg)*d_exparg_d_cgin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cs=(-exp(exparg)*d_exparg_d_cs/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cc=(-exp(exparg)*d_exparg_d_cc/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cb=(-exp(exparg)*d_exparg_d_cb/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vto=(-exp(exparg)*d_exparg_d_vto/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_ss=(-exp(exparg)*d_exparg_d_ss/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_delta1=(-exp(exparg)*d_exparg_d_delta1/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_delta2=(-exp(exparg)*d_exparg_d_delta2/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_nd=(-exp(exparg)*d_exparg_d_nd/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_alpha=(-exp(exparg)*d_exparg_d_alpha/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vel0=(-exp(exparg)*d_exparg_d_vel0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_mu0=(-exp(exparg)*d_exparg_d_mu0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_beta=(-exp(exparg)*d_exparg_d_beta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_mtheta=(-exp(exparg)*d_exparg_d_mtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vtheta=(-exp(exparg)*d_exparg_d_vtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vtzeta=(-exp(exparg)*d_exparg_d_vtzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_dibsat=(-exp(exparg)*d_exparg_d_dibsat/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_epsilon=(-exp(exparg)*d_exparg_d_epsilon/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vzeta=(-exp(exparg)*d_exparg_d_vzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_lambda=(-exp(exparg)*d_exparg_d_lambda/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_ngf=(-exp(exparg)*d_exparg_d_ngf/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_type=(-exp(exparg)*d_exparg_d_type/(1.0+exp(exparg))/(1.0+exp(exparg)));
ff=(1.0/(1.0+exp(exparg)));
}
}
d_eta_d_vgsin=((two_n_phit*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-(d_vtdibl_d_vgsin-(((0.1*alpha_phit)*d_ff_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vgsin)/two_n_phit/two_n_phit);
d_eta_d_vdsin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-(d_vtdibl_d_vdsin-(((0.1*alpha_phit)*d_ff_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vdsin)/two_n_phit/two_n_phit);
d_eta_d_qcbflag=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-(d_vtdibl_d_qcbflag-(((0.1*alpha_phit)*d_ff_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_qcbflag)/two_n_phit/two_n_phit);
d_eta_d_vcin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-(d_vtdibl_d_vcin-(((0.1*alpha_phit)*d_ff_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vcin)/two_n_phit/two_n_phit);
d_eta_d_vbin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-(d_vtdibl_d_vbin-(((0.1*alpha_phit)*d_ff_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vbin)/two_n_phit/two_n_phit);
d_eta_d_qgsflag=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-(d_vtdibl_d_qgsflag-(((0.1*alpha_phit)*d_ff_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_qgsflag)/two_n_phit/two_n_phit);
d_eta_d_tambin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-(d_vtdibl_d_tambin-(((0.1*alpha_phit)*d_ff_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_tambin)/two_n_phit/two_n_phit);
d_eta_d_tnomin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-(d_vtdibl_d_tnomin-(((0.1*alpha_phit)*d_ff_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_tnomin)/two_n_phit/two_n_phit);
d_eta_d_phitin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-(d_vtdibl_d_phitin-(((0.1*alpha_phit)*d_ff_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_phitin)/two_n_phit/two_n_phit);
d_eta_d_w=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-(d_vtdibl_d_w-(((0.1*alpha_phit)*d_ff_d_w)+((0.1*d_alpha_phit_d_w)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_w)/two_n_phit/two_n_phit);
d_eta_d_lin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-(d_vtdibl_d_lin-(((0.1*alpha_phit)*d_ff_d_lin)+((0.1*d_alpha_phit_d_lin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_lin)/two_n_phit/two_n_phit);
d_eta_d_cgin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-(d_vtdibl_d_cgin-(((0.1*alpha_phit)*d_ff_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cgin)/two_n_phit/two_n_phit);
d_eta_d_cs=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-(d_vtdibl_d_cs-(((0.1*alpha_phit)*d_ff_d_cs)+((0.1*d_alpha_phit_d_cs)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cs)/two_n_phit/two_n_phit);
d_eta_d_cc=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-(d_vtdibl_d_cc-(((0.1*alpha_phit)*d_ff_d_cc)+((0.1*d_alpha_phit_d_cc)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cc)/two_n_phit/two_n_phit);
d_eta_d_cb=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-(d_vtdibl_d_cb-(((0.1*alpha_phit)*d_ff_d_cb)+((0.1*d_alpha_phit_d_cb)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cb)/two_n_phit/two_n_phit);
d_eta_d_vto=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-(d_vtdibl_d_vto-(((0.1*alpha_phit)*d_ff_d_vto)+((0.1*d_alpha_phit_d_vto)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vto)/two_n_phit/two_n_phit);
d_eta_d_ss=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-(d_vtdibl_d_ss-(((0.1*alpha_phit)*d_ff_d_ss)+((0.1*d_alpha_phit_d_ss)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_ss)/two_n_phit/two_n_phit);
d_eta_d_delta1=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-(d_vtdibl_d_delta1-(((0.1*alpha_phit)*d_ff_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_delta1)/two_n_phit/two_n_phit);
d_eta_d_delta2=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-(d_vtdibl_d_delta2-(((0.1*alpha_phit)*d_ff_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_delta2)/two_n_phit/two_n_phit);
d_eta_d_nd=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-(d_vtdibl_d_nd-(((0.1*alpha_phit)*d_ff_d_nd)+((0.1*d_alpha_phit_d_nd)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_nd)/two_n_phit/two_n_phit);
d_eta_d_alpha=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-(d_vtdibl_d_alpha-(((0.1*alpha_phit)*d_ff_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_alpha)/two_n_phit/two_n_phit);
d_eta_d_vel0=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-(d_vtdibl_d_vel0-(((0.1*alpha_phit)*d_ff_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vel0)/two_n_phit/two_n_phit);
d_eta_d_mu0=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-(d_vtdibl_d_mu0-(((0.1*alpha_phit)*d_ff_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_mu0)/two_n_phit/two_n_phit);
d_eta_d_beta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-(d_vtdibl_d_beta-(((0.1*alpha_phit)*d_ff_d_beta)+((0.1*d_alpha_phit_d_beta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_beta)/two_n_phit/two_n_phit);
d_eta_d_mtheta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-(d_vtdibl_d_mtheta-(((0.1*alpha_phit)*d_ff_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_mtheta)/two_n_phit/two_n_phit);
d_eta_d_vtheta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-(d_vtdibl_d_vtheta-(((0.1*alpha_phit)*d_ff_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vtheta)/two_n_phit/two_n_phit);
d_eta_d_vtzeta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-(d_vtdibl_d_vtzeta-(((0.1*alpha_phit)*d_ff_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vtzeta)/two_n_phit/two_n_phit);
d_eta_d_dibsat=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-(d_vtdibl_d_dibsat-(((0.1*alpha_phit)*d_ff_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_dibsat)/two_n_phit/two_n_phit);
d_eta_d_epsilon=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-(d_vtdibl_d_epsilon-(((0.1*alpha_phit)*d_ff_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_epsilon)/two_n_phit/two_n_phit);
d_eta_d_vzeta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-(d_vtdibl_d_vzeta-(((0.1*alpha_phit)*d_ff_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vzeta)/two_n_phit/two_n_phit);
d_eta_d_lambda=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-(d_vtdibl_d_lambda-(((0.1*alpha_phit)*d_ff_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_lambda)/two_n_phit/two_n_phit);
d_eta_d_ngf=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-(d_vtdibl_d_ngf-(((0.1*alpha_phit)*d_ff_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_ngf)/two_n_phit/two_n_phit);
d_eta_d_type=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-(d_vtdibl_d_type-(((0.1*alpha_phit)*d_ff_d_type)+((0.1*d_alpha_phit_d_type)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_type)/two_n_phit/two_n_phit);
eta=((mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))/two_n_phit);
if((eta>50.0))
{
d_qinvv_d_vgsin=((qref*d_eta_d_vgsin)+(d_qref_d_vgsin*eta));
d_qinvv_d_vdsin=((qref*d_eta_d_vdsin)+(d_qref_d_vdsin*eta));
d_qinvv_d_qcbflag=((qref*d_eta_d_qcbflag)+(d_qref_d_qcbflag*eta));
d_qinvv_d_vcin=((qref*d_eta_d_vcin)+(d_qref_d_vcin*eta));
d_qinvv_d_vbin=((qref*d_eta_d_vbin)+(d_qref_d_vbin*eta));
d_qinvv_d_qgsflag=((qref*d_eta_d_qgsflag)+(d_qref_d_qgsflag*eta));
d_qinvv_d_tambin=((qref*d_eta_d_tambin)+(d_qref_d_tambin*eta));
d_qinvv_d_tnomin=((qref*d_eta_d_tnomin)+(d_qref_d_tnomin*eta));
d_qinvv_d_phitin=((qref*d_eta_d_phitin)+(d_qref_d_phitin*eta));
d_qinvv_d_w=((qref*d_eta_d_w)+(d_qref_d_w*eta));
d_qinvv_d_lin=((qref*d_eta_d_lin)+(d_qref_d_lin*eta));
d_qinvv_d_cgin=((qref*d_eta_d_cgin)+(d_qref_d_cgin*eta));
d_qinvv_d_cs=((qref*d_eta_d_cs)+(d_qref_d_cs*eta));
d_qinvv_d_cc=((qref*d_eta_d_cc)+(d_qref_d_cc*eta));
d_qinvv_d_cb=((qref*d_eta_d_cb)+(d_qref_d_cb*eta));
d_qinvv_d_vto=((qref*d_eta_d_vto)+(d_qref_d_vto*eta));
d_qinvv_d_ss=((qref*d_eta_d_ss)+(d_qref_d_ss*eta));
d_qinvv_d_delta1=((qref*d_eta_d_delta1)+(d_qref_d_delta1*eta));
d_qinvv_d_delta2=((qref*d_eta_d_delta2)+(d_qref_d_delta2*eta));
d_qinvv_d_nd=((qref*d_eta_d_nd)+(d_qref_d_nd*eta));
d_qinvv_d_alpha=((qref*d_eta_d_alpha)+(d_qref_d_alpha*eta));
d_qinvv_d_vel0=((qref*d_eta_d_vel0)+(d_qref_d_vel0*eta));
d_qinvv_d_mu0=((qref*d_eta_d_mu0)+(d_qref_d_mu0*eta));
d_qinvv_d_beta=((qref*d_eta_d_beta)+(d_qref_d_beta*eta));
d_qinvv_d_mtheta=((qref*d_eta_d_mtheta)+(d_qref_d_mtheta*eta));
d_qinvv_d_vtheta=((qref*d_eta_d_vtheta)+(d_qref_d_vtheta*eta));
d_qinvv_d_vtzeta=((qref*d_eta_d_vtzeta)+(d_qref_d_vtzeta*eta));
d_qinvv_d_dibsat=((qref*d_eta_d_dibsat)+(d_qref_d_dibsat*eta));
d_qinvv_d_epsilon=((qref*d_eta_d_epsilon)+(d_qref_d_epsilon*eta));
d_qinvv_d_vzeta=((qref*d_eta_d_vzeta)+(d_qref_d_vzeta*eta));
d_qinvv_d_lambda=((qref*d_eta_d_lambda)+(d_qref_d_lambda*eta));
d_qinvv_d_ngf=((qref*d_eta_d_ngf)+(d_qref_d_ngf*eta));
d_qinvv_d_type=((qref*d_eta_d_type)+(d_qref_d_type*eta));
qinvv=(qref*eta);
}
else
{
if((eta<(-50.0)))
{
d_qinvv_d_vgsin=0.0;
d_qinvv_d_vdsin=0.0;
d_qinvv_d_qcbflag=0.0;
d_qinvv_d_vcin=0.0;
d_qinvv_d_vbin=0.0;
d_qinvv_d_qgsflag=0.0;
d_qinvv_d_tambin=0.0;
d_qinvv_d_tnomin=0.0;
d_qinvv_d_phitin=0.0;
d_qinvv_d_w=0.0;
d_qinvv_d_lin=0.0;
d_qinvv_d_cgin=0.0;
d_qinvv_d_cs=0.0;
d_qinvv_d_cc=0.0;
d_qinvv_d_cb=0.0;
d_qinvv_d_vto=0.0;
d_qinvv_d_ss=0.0;
d_qinvv_d_delta1=0.0;
d_qinvv_d_delta2=0.0;
d_qinvv_d_nd=0.0;
d_qinvv_d_alpha=0.0;
d_qinvv_d_vel0=0.0;
d_qinvv_d_mu0=0.0;
d_qinvv_d_beta=0.0;
d_qinvv_d_mtheta=0.0;
d_qinvv_d_vtheta=0.0;
d_qinvv_d_vtzeta=0.0;
d_qinvv_d_dibsat=0.0;
d_qinvv_d_epsilon=0.0;
d_qinvv_d_vzeta=0.0;
d_qinvv_d_lambda=0.0;
d_qinvv_d_ngf=0.0;
d_qinvv_d_type=0.0;
qinvv=0;
}
else
{
d_qinvv_d_vgsin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vgsin)+(d_qref_d_vgsin*log((1.0+exp(eta)))));
d_qinvv_d_vdsin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vdsin)+(d_qref_d_vdsin*log((1.0+exp(eta)))));
d_qinvv_d_qcbflag=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_qcbflag)+(d_qref_d_qcbflag*log((1.0+exp(eta)))));
d_qinvv_d_vcin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vcin)+(d_qref_d_vcin*log((1.0+exp(eta)))));
d_qinvv_d_vbin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vbin)+(d_qref_d_vbin*log((1.0+exp(eta)))));
d_qinvv_d_qgsflag=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_qgsflag)+(d_qref_d_qgsflag*log((1.0+exp(eta)))));
d_qinvv_d_tambin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_tambin)+(d_qref_d_tambin*log((1.0+exp(eta)))));
d_qinvv_d_tnomin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_tnomin)+(d_qref_d_tnomin*log((1.0+exp(eta)))));
d_qinvv_d_phitin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_phitin)+(d_qref_d_phitin*log((1.0+exp(eta)))));
d_qinvv_d_w=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_w)+(d_qref_d_w*log((1.0+exp(eta)))));
d_qinvv_d_lin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_lin)+(d_qref_d_lin*log((1.0+exp(eta)))));
d_qinvv_d_cgin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cgin)+(d_qref_d_cgin*log((1.0+exp(eta)))));
d_qinvv_d_cs=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cs)+(d_qref_d_cs*log((1.0+exp(eta)))));
d_qinvv_d_cc=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cc)+(d_qref_d_cc*log((1.0+exp(eta)))));
d_qinvv_d_cb=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cb)+(d_qref_d_cb*log((1.0+exp(eta)))));
d_qinvv_d_vto=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vto)+(d_qref_d_vto*log((1.0+exp(eta)))));
d_qinvv_d_ss=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_ss)+(d_qref_d_ss*log((1.0+exp(eta)))));
d_qinvv_d_delta1=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_delta1)+(d_qref_d_delta1*log((1.0+exp(eta)))));
d_qinvv_d_delta2=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_delta2)+(d_qref_d_delta2*log((1.0+exp(eta)))));
d_qinvv_d_nd=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_nd)+(d_qref_d_nd*log((1.0+exp(eta)))));
d_qinvv_d_alpha=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_alpha)+(d_qref_d_alpha*log((1.0+exp(eta)))));
d_qinvv_d_vel0=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vel0)+(d_qref_d_vel0*log((1.0+exp(eta)))));
d_qinvv_d_mu0=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_mu0)+(d_qref_d_mu0*log((1.0+exp(eta)))));
d_qinvv_d_beta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_beta)+(d_qref_d_beta*log((1.0+exp(eta)))));
d_qinvv_d_mtheta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_mtheta)+(d_qref_d_mtheta*log((1.0+exp(eta)))));
d_qinvv_d_vtheta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vtheta)+(d_qref_d_vtheta*log((1.0+exp(eta)))));
d_qinvv_d_vtzeta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vtzeta)+(d_qref_d_vtzeta*log((1.0+exp(eta)))));
d_qinvv_d_dibsat=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_dibsat)+(d_qref_d_dibsat*log((1.0+exp(eta)))));
d_qinvv_d_epsilon=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_epsilon)+(d_qref_d_epsilon*log((1.0+exp(eta)))));
d_qinvv_d_vzeta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vzeta)+(d_qref_d_vzeta*log((1.0+exp(eta)))));
d_qinvv_d_lambda=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_lambda)+(d_qref_d_lambda*log((1.0+exp(eta)))));
d_qinvv_d_ngf=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_ngf)+(d_qref_d_ngf*log((1.0+exp(eta)))));
d_qinvv_d_type=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_type)+(d_qref_d_type*log((1.0+exp(eta)))));
qinvv=(qref*log((1.0+exp(eta))));
}
}
d_muf_d_vgsin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vgsin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vdsin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vdsin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_qcbflag=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_qcbflag)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vcin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vcin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vbin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vbin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_qgsflag=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_qgsflag)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_tambin=(-mu0*((pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_tambin)/cgin))+((((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(1.0/tnomin)*(1.0+((mtheta*qinvv)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_tnomin=(-mu0*((pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_tnomin)/cgin))+((((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(-tambin/tnomin/tnomin)*(1.0+((mtheta*qinvv)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_phitin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_phitin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_w=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_w)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_lin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_lin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cgin=(-mu0*(pow((tambin/tnomin),epsilon)*((cgin*(mtheta*d_qinvv_d_cgin)-(mtheta*qinvv))/cgin/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cs=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_cs)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cc=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_cc)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cb=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_cb)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vto=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vto)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_ss=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_ss)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_delta1=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_delta1)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_delta2=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_delta2)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_nd=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_nd)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_alpha=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_alpha)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vel0=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vel0)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_mu0=(((pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))-(mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_mu0)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_beta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_beta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_mtheta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_mtheta+qinvv)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vtheta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vtheta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vtzeta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vtzeta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_dibsat=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_dibsat)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_epsilon=(-mu0*((pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_epsilon)/cgin))+((((tambin/tnomin)==0.0)?0.0:(log((tambin/tnomin)*pow((tambin/tnomin),epsilon))))*(1.0+((mtheta*qinvv)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vzeta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vzeta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_lambda=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_lambda)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_ngf=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_ngf)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_type=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_type)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
muf=(mu0/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_vx_d_vgsin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vgsin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vgsin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vdsin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vdsin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vdsin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_qcbflag=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_qcbflag)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_qcbflag)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vcin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vcin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vcin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vbin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vbin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vbin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_qgsflag=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_qgsflag)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_qgsflag)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_tambin=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_tambin)/lin))+((vel0*(-(1.0+(vzeta*tnomin))*(vzeta)/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_tambin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_tnomin=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_tnomin)/lin))+((vel0*((vzeta)/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_tnomin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_phitin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_phitin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_phitin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_w=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_w)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_w)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_lin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lin*(lambda*d_absvdsin_d_lin)-(lambda*absvdsin))/lin/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_lin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cgin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cgin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((cgin*(vtheta*d_qinvv_d_cgin)-(vtheta*qinvv))/cgin/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cs=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cs)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_cs)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cc=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cc)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_cc)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cb=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cb)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_cb)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vto=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vto)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vto)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_ss=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_ss)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_ss)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_delta1=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_delta1)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_delta1)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_delta2=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_delta2)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_delta2)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_nd=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_nd)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_nd)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_alpha=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_alpha)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_alpha)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vel0=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vel0)/lin))+((((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vel0)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_mu0=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_mu0)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_mu0)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_beta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_beta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_beta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_mtheta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_mtheta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_mtheta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vtheta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vtheta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vtheta+qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vtzeta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vtzeta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vtzeta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_dibsat=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_dibsat)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_dibsat)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_epsilon=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_epsilon)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_epsilon)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vzeta=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vzeta)/lin))+((vel0*(((1.0+(vzeta*tambin))*(tnomin)-(1.0+(vzeta*tnomin))*(tambin))/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vzeta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_lambda=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_lambda+absvdsin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_lambda)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_ngf=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_ngf)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_ngf)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_type=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_type)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_type)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
vx=(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))/(1.0+((vtheta*qinvv)/cgin)));
d_vxf_d_vgsin=((((((2.0*ff)*phitin)*d_muf_d_vgsin)+(((2.0*d_ff_d_vgsin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vgsin)+((-d_ff_d_vgsin)*vx)));
d_vxf_d_vdsin=((((((2.0*ff)*phitin)*d_muf_d_vdsin)+(((2.0*d_ff_d_vdsin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vdsin)+((-d_ff_d_vdsin)*vx)));
d_vxf_d_qcbflag=((((((2.0*ff)*phitin)*d_muf_d_qcbflag)+(((2.0*d_ff_d_qcbflag)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_qcbflag)+((-d_ff_d_qcbflag)*vx)));
d_vxf_d_vcin=((((((2.0*ff)*phitin)*d_muf_d_vcin)+(((2.0*d_ff_d_vcin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vcin)+((-d_ff_d_vcin)*vx)));
d_vxf_d_vbin=((((((2.0*ff)*phitin)*d_muf_d_vbin)+(((2.0*d_ff_d_vbin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vbin)+((-d_ff_d_vbin)*vx)));
d_vxf_d_qgsflag=((((((2.0*ff)*phitin)*d_muf_d_qgsflag)+(((2.0*d_ff_d_qgsflag)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_qgsflag)+((-d_ff_d_qgsflag)*vx)));
d_vxf_d_tambin=((((((2.0*ff)*phitin)*d_muf_d_tambin)+(((2.0*d_ff_d_tambin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_tambin)+((-d_ff_d_tambin)*vx)));
d_vxf_d_tnomin=((((((2.0*ff)*phitin)*d_muf_d_tnomin)+(((2.0*d_ff_d_tnomin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_tnomin)+((-d_ff_d_tnomin)*vx)));
d_vxf_d_phitin=((((((2.0*ff)*phitin)*d_muf_d_phitin)+(((2.0*ff)+phitin*(2.0*d_ff_d_phitin))*muf))/lin)+(((1.0-ff)*d_vx_d_phitin)+((-d_ff_d_phitin)*vx)));
d_vxf_d_w=((((((2.0*ff)*phitin)*d_muf_d_w)+(((2.0*d_ff_d_w)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_w)+((-d_ff_d_w)*vx)));
d_vxf_d_lin=(((lin*((((2.0*ff)*phitin)*d_muf_d_lin)+(((2.0*d_ff_d_lin)*phitin)*muf))-(((2.0*ff)*phitin)*muf))/lin/lin)+(((1.0-ff)*d_vx_d_lin)+((-d_ff_d_lin)*vx)));
d_vxf_d_cgin=((((((2.0*ff)*phitin)*d_muf_d_cgin)+(((2.0*d_ff_d_cgin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cgin)+((-d_ff_d_cgin)*vx)));
d_vxf_d_cs=((((((2.0*ff)*phitin)*d_muf_d_cs)+(((2.0*d_ff_d_cs)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cs)+((-d_ff_d_cs)*vx)));
d_vxf_d_cc=((((((2.0*ff)*phitin)*d_muf_d_cc)+(((2.0*d_ff_d_cc)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cc)+((-d_ff_d_cc)*vx)));
d_vxf_d_cb=((((((2.0*ff)*phitin)*d_muf_d_cb)+(((2.0*d_ff_d_cb)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cb)+((-d_ff_d_cb)*vx)));
d_vxf_d_vto=((((((2.0*ff)*phitin)*d_muf_d_vto)+(((2.0*d_ff_d_vto)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vto)+((-d_ff_d_vto)*vx)));
d_vxf_d_ss=((((((2.0*ff)*phitin)*d_muf_d_ss)+(((2.0*d_ff_d_ss)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_ss)+((-d_ff_d_ss)*vx)));
d_vxf_d_delta1=((((((2.0*ff)*phitin)*d_muf_d_delta1)+(((2.0*d_ff_d_delta1)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_delta1)+((-d_ff_d_delta1)*vx)));
d_vxf_d_delta2=((((((2.0*ff)*phitin)*d_muf_d_delta2)+(((2.0*d_ff_d_delta2)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_delta2)+((-d_ff_d_delta2)*vx)));
d_vxf_d_nd=((((((2.0*ff)*phitin)*d_muf_d_nd)+(((2.0*d_ff_d_nd)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_nd)+((-d_ff_d_nd)*vx)));
d_vxf_d_alpha=((((((2.0*ff)*phitin)*d_muf_d_alpha)+(((2.0*d_ff_d_alpha)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_alpha)+((-d_ff_d_alpha)*vx)));
d_vxf_d_vel0=((((((2.0*ff)*phitin)*d_muf_d_vel0)+(((2.0*d_ff_d_vel0)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vel0)+((-d_ff_d_vel0)*vx)));
d_vxf_d_mu0=((((((2.0*ff)*phitin)*d_muf_d_mu0)+(((2.0*d_ff_d_mu0)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_mu0)+((-d_ff_d_mu0)*vx)));
d_vxf_d_beta=((((((2.0*ff)*phitin)*d_muf_d_beta)+(((2.0*d_ff_d_beta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_beta)+((-d_ff_d_beta)*vx)));
d_vxf_d_mtheta=((((((2.0*ff)*phitin)*d_muf_d_mtheta)+(((2.0*d_ff_d_mtheta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_mtheta)+((-d_ff_d_mtheta)*vx)));
d_vxf_d_vtheta=((((((2.0*ff)*phitin)*d_muf_d_vtheta)+(((2.0*d_ff_d_vtheta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vtheta)+((-d_ff_d_vtheta)*vx)));
d_vxf_d_vtzeta=((((((2.0*ff)*phitin)*d_muf_d_vtzeta)+(((2.0*d_ff_d_vtzeta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vtzeta)+((-d_ff_d_vtzeta)*vx)));
d_vxf_d_dibsat=((((((2.0*ff)*phitin)*d_muf_d_dibsat)+(((2.0*d_ff_d_dibsat)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_dibsat)+((-d_ff_d_dibsat)*vx)));
d_vxf_d_epsilon=((((((2.0*ff)*phitin)*d_muf_d_epsilon)+(((2.0*d_ff_d_epsilon)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_epsilon)+((-d_ff_d_epsilon)*vx)));
d_vxf_d_vzeta=((((((2.0*ff)*phitin)*d_muf_d_vzeta)+(((2.0*d_ff_d_vzeta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vzeta)+((-d_ff_d_vzeta)*vx)));
d_vxf_d_lambda=((((((2.0*ff)*phitin)*d_muf_d_lambda)+(((2.0*d_ff_d_lambda)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_lambda)+((-d_ff_d_lambda)*vx)));
d_vxf_d_ngf=((((((2.0*ff)*phitin)*d_muf_d_ngf)+(((2.0*d_ff_d_ngf)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_ngf)+((-d_ff_d_ngf)*vx)));
d_vxf_d_type=((((((2.0*ff)*phitin)*d_muf_d_type)+(((2.0*d_ff_d_type)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_type)+((-d_ff_d_type)*vx)));
vxf=(((((2.0*ff)*phitin)*muf)/lin)+((1.0-ff)*vx));
d_vdsats_d_vgsin=((muf*(d_vx_d_vgsin*lin)-(vx*lin)*d_muf_d_vgsin)/muf/muf);
d_vdsats_d_vdsin=((muf*(d_vx_d_vdsin*lin)-(vx*lin)*d_muf_d_vdsin)/muf/muf);
d_vdsats_d_qcbflag=((muf*(d_vx_d_qcbflag*lin)-(vx*lin)*d_muf_d_qcbflag)/muf/muf);
d_vdsats_d_vcin=((muf*(d_vx_d_vcin*lin)-(vx*lin)*d_muf_d_vcin)/muf/muf);
d_vdsats_d_vbin=((muf*(d_vx_d_vbin*lin)-(vx*lin)*d_muf_d_vbin)/muf/muf);
d_vdsats_d_qgsflag=((muf*(d_vx_d_qgsflag*lin)-(vx*lin)*d_muf_d_qgsflag)/muf/muf);
d_vdsats_d_tambin=((muf*(d_vx_d_tambin*lin)-(vx*lin)*d_muf_d_tambin)/muf/muf);
d_vdsats_d_tnomin=((muf*(d_vx_d_tnomin*lin)-(vx*lin)*d_muf_d_tnomin)/muf/muf);
d_vdsats_d_phitin=((muf*(d_vx_d_phitin*lin)-(vx*lin)*d_muf_d_phitin)/muf/muf);
d_vdsats_d_w=((muf*(d_vx_d_w*lin)-(vx*lin)*d_muf_d_w)/muf/muf);
d_vdsats_d_lin=((muf*(vx+lin*d_vx_d_lin)-(vx*lin)*d_muf_d_lin)/muf/muf);
d_vdsats_d_cgin=((muf*(d_vx_d_cgin*lin)-(vx*lin)*d_muf_d_cgin)/muf/muf);
d_vdsats_d_cs=((muf*(d_vx_d_cs*lin)-(vx*lin)*d_muf_d_cs)/muf/muf);
d_vdsats_d_cc=((muf*(d_vx_d_cc*lin)-(vx*lin)*d_muf_d_cc)/muf/muf);
d_vdsats_d_cb=((muf*(d_vx_d_cb*lin)-(vx*lin)*d_muf_d_cb)/muf/muf);
d_vdsats_d_vto=((muf*(d_vx_d_vto*lin)-(vx*lin)*d_muf_d_vto)/muf/muf);
d_vdsats_d_ss=((muf*(d_vx_d_ss*lin)-(vx*lin)*d_muf_d_ss)/muf/muf);
d_vdsats_d_delta1=((muf*(d_vx_d_delta1*lin)-(vx*lin)*d_muf_d_delta1)/muf/muf);
d_vdsats_d_delta2=((muf*(d_vx_d_delta2*lin)-(vx*lin)*d_muf_d_delta2)/muf/muf);
d_vdsats_d_nd=((muf*(d_vx_d_nd*lin)-(vx*lin)*d_muf_d_nd)/muf/muf);
d_vdsats_d_alpha=((muf*(d_vx_d_alpha*lin)-(vx*lin)*d_muf_d_alpha)/muf/muf);
d_vdsats_d_vel0=((muf*(d_vx_d_vel0*lin)-(vx*lin)*d_muf_d_vel0)/muf/muf);
d_vdsats_d_mu0=((muf*(d_vx_d_mu0*lin)-(vx*lin)*d_muf_d_mu0)/muf/muf);
d_vdsats_d_beta=((muf*(d_vx_d_beta*lin)-(vx*lin)*d_muf_d_beta)/muf/muf);
d_vdsats_d_mtheta=((muf*(d_vx_d_mtheta*lin)-(vx*lin)*d_muf_d_mtheta)/muf/muf);
d_vdsats_d_vtheta=((muf*(d_vx_d_vtheta*lin)-(vx*lin)*d_muf_d_vtheta)/muf/muf);
d_vdsats_d_vtzeta=((muf*(d_vx_d_vtzeta*lin)-(vx*lin)*d_muf_d_vtzeta)/muf/muf);
d_vdsats_d_dibsat=((muf*(d_vx_d_dibsat*lin)-(vx*lin)*d_muf_d_dibsat)/muf/muf);
d_vdsats_d_epsilon=((muf*(d_vx_d_epsilon*lin)-(vx*lin)*d_muf_d_epsilon)/muf/muf);
d_vdsats_d_vzeta=((muf*(d_vx_d_vzeta*lin)-(vx*lin)*d_muf_d_vzeta)/muf/muf);
d_vdsats_d_lambda=((muf*(d_vx_d_lambda*lin)-(vx*lin)*d_muf_d_lambda)/muf/muf);
d_vdsats_d_ngf=((muf*(d_vx_d_ngf*lin)-(vx*lin)*d_muf_d_ngf)/muf/muf);
d_vdsats_d_type=((muf*(d_vx_d_type*lin)-(vx*lin)*d_muf_d_type)/muf/muf);
vdsats=((vx*lin)/muf);
d_vdsats1_d_vgsin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vgsin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vgsin)/vdsats/vdsats))+(d_vdsats_d_vgsin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vgsin);
d_vdsats1_d_vdsin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vdsin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vdsin)/vdsats/vdsats))+(d_vdsats_d_vdsin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vdsin);
d_vdsats1_d_qcbflag=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_qcbflag)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_qcbflag)/vdsats/vdsats))+(d_vdsats_d_qcbflag*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_qcbflag);
d_vdsats1_d_vcin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vcin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vcin)/vdsats/vdsats))+(d_vdsats_d_vcin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vcin);
d_vdsats1_d_vbin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vbin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vbin)/vdsats/vdsats))+(d_vdsats_d_vbin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vbin);
d_vdsats1_d_qgsflag=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_qgsflag)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_qgsflag)/vdsats/vdsats))+(d_vdsats_d_qgsflag*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_qgsflag);
d_vdsats1_d_tambin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_tambin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_tambin)/vdsats/vdsats))+(d_vdsats_d_tambin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_tambin);
d_vdsats1_d_tnomin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_tnomin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_tnomin)/vdsats/vdsats))+(d_vdsats_d_tnomin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_tnomin);
d_vdsats1_d_phitin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_phitin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_phitin)/vdsats/vdsats))+(d_vdsats_d_phitin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_phitin);
d_vdsats1_d_w=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_w)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_w)/vdsats/vdsats))+(d_vdsats_d_w*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_w);
d_vdsats1_d_lin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_lin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_lin)/vdsats/vdsats))+(d_vdsats_d_lin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_lin);
d_vdsats1_d_cgin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((cgin*(2.0*d_qinvv_d_cgin)-(2.0*qinvv))/cgin/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cgin)/vdsats/vdsats))+(d_vdsats_d_cgin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cgin);
d_vdsats1_d_cs=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_cs)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cs)/vdsats/vdsats))+(d_vdsats_d_cs*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cs);
d_vdsats1_d_cc=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_cc)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cc)/vdsats/vdsats))+(d_vdsats_d_cc*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cc);
d_vdsats1_d_cb=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_cb)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cb)/vdsats/vdsats))+(d_vdsats_d_cb*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cb);
d_vdsats1_d_vto=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vto)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vto)/vdsats/vdsats))+(d_vdsats_d_vto*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vto);
d_vdsats1_d_ss=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_ss)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_ss)/vdsats/vdsats))+(d_vdsats_d_ss*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_ss);
d_vdsats1_d_delta1=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_delta1)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_delta1)/vdsats/vdsats))+(d_vdsats_d_delta1*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_delta1);
d_vdsats1_d_delta2=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_delta2)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_delta2)/vdsats/vdsats))+(d_vdsats_d_delta2*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_delta2);
d_vdsats1_d_nd=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_nd)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_nd)/vdsats/vdsats))+(d_vdsats_d_nd*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_nd);
d_vdsats1_d_alpha=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_alpha)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_alpha)/vdsats/vdsats))+(d_vdsats_d_alpha*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_alpha);
d_vdsats1_d_vel0=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vel0)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vel0)/vdsats/vdsats))+(d_vdsats_d_vel0*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vel0);
d_vdsats1_d_mu0=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_mu0)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_mu0)/vdsats/vdsats))+(d_vdsats_d_mu0*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_mu0);
d_vdsats1_d_beta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_beta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_beta)/vdsats/vdsats))+(d_vdsats_d_beta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_beta);
d_vdsats1_d_mtheta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_mtheta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_mtheta)/vdsats/vdsats))+(d_vdsats_d_mtheta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_mtheta);
d_vdsats1_d_vtheta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vtheta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vtheta)/vdsats/vdsats))+(d_vdsats_d_vtheta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vtheta);
d_vdsats1_d_vtzeta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vtzeta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vtzeta)/vdsats/vdsats))+(d_vdsats_d_vtzeta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vtzeta);
d_vdsats1_d_dibsat=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_dibsat)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_dibsat)/vdsats/vdsats))+(d_vdsats_d_dibsat*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_dibsat);
d_vdsats1_d_epsilon=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_epsilon)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_epsilon)/vdsats/vdsats))+(d_vdsats_d_epsilon*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_epsilon);
d_vdsats1_d_vzeta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vzeta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vzeta)/vdsats/vdsats))+(d_vdsats_d_vzeta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vzeta);
d_vdsats1_d_lambda=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_lambda)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_lambda)/vdsats/vdsats))+(d_vdsats_d_lambda*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_lambda);
d_vdsats1_d_ngf=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_ngf)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_ngf)/vdsats/vdsats))+(d_vdsats_d_ngf*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_ngf);
d_vdsats1_d_type=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_type)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_type)/vdsats/vdsats))+(d_vdsats_d_type*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_type);
vdsats1=((vdsats*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))-vdsats);
d_vdsat_d_vgsin=(((vdsats*(-d_ff_d_vgsin))+(d_vdsats_d_vgsin*(1.0-ff)))+((two_n_phit*d_ff_d_vgsin)+(d_two_n_phit_d_vgsin*ff)));
d_vdsat_d_vdsin=(((vdsats*(-d_ff_d_vdsin))+(d_vdsats_d_vdsin*(1.0-ff)))+((two_n_phit*d_ff_d_vdsin)+(d_two_n_phit_d_vdsin*ff)));
d_vdsat_d_qcbflag=(((vdsats*(-d_ff_d_qcbflag))+(d_vdsats_d_qcbflag*(1.0-ff)))+((two_n_phit*d_ff_d_qcbflag)+(d_two_n_phit_d_qcbflag*ff)));
d_vdsat_d_vcin=(((vdsats*(-d_ff_d_vcin))+(d_vdsats_d_vcin*(1.0-ff)))+((two_n_phit*d_ff_d_vcin)+(d_two_n_phit_d_vcin*ff)));
d_vdsat_d_vbin=(((vdsats*(-d_ff_d_vbin))+(d_vdsats_d_vbin*(1.0-ff)))+((two_n_phit*d_ff_d_vbin)+(d_two_n_phit_d_vbin*ff)));
d_vdsat_d_qgsflag=(((vdsats*(-d_ff_d_qgsflag))+(d_vdsats_d_qgsflag*(1.0-ff)))+((two_n_phit*d_ff_d_qgsflag)+(d_two_n_phit_d_qgsflag*ff)));
d_vdsat_d_tambin=(((vdsats*(-d_ff_d_tambin))+(d_vdsats_d_tambin*(1.0-ff)))+((two_n_phit*d_ff_d_tambin)+(d_two_n_phit_d_tambin*ff)));
d_vdsat_d_tnomin=(((vdsats*(-d_ff_d_tnomin))+(d_vdsats_d_tnomin*(1.0-ff)))+((two_n_phit*d_ff_d_tnomin)+(d_two_n_phit_d_tnomin*ff)));
d_vdsat_d_phitin=(((vdsats*(-d_ff_d_phitin))+(d_vdsats_d_phitin*(1.0-ff)))+((two_n_phit*d_ff_d_phitin)+(d_two_n_phit_d_phitin*ff)));
d_vdsat_d_w=(((vdsats*(-d_ff_d_w))+(d_vdsats_d_w*(1.0-ff)))+((two_n_phit*d_ff_d_w)+(d_two_n_phit_d_w*ff)));
d_vdsat_d_lin=(((vdsats*(-d_ff_d_lin))+(d_vdsats_d_lin*(1.0-ff)))+((two_n_phit*d_ff_d_lin)+(d_two_n_phit_d_lin*ff)));
d_vdsat_d_cgin=(((vdsats*(-d_ff_d_cgin))+(d_vdsats_d_cgin*(1.0-ff)))+((two_n_phit*d_ff_d_cgin)+(d_two_n_phit_d_cgin*ff)));
d_vdsat_d_cs=(((vdsats*(-d_ff_d_cs))+(d_vdsats_d_cs*(1.0-ff)))+((two_n_phit*d_ff_d_cs)+(d_two_n_phit_d_cs*ff)));
d_vdsat_d_cc=(((vdsats*(-d_ff_d_cc))+(d_vdsats_d_cc*(1.0-ff)))+((two_n_phit*d_ff_d_cc)+(d_two_n_phit_d_cc*ff)));
d_vdsat_d_cb=(((vdsats*(-d_ff_d_cb))+(d_vdsats_d_cb*(1.0-ff)))+((two_n_phit*d_ff_d_cb)+(d_two_n_phit_d_cb*ff)));
d_vdsat_d_vto=(((vdsats*(-d_ff_d_vto))+(d_vdsats_d_vto*(1.0-ff)))+((two_n_phit*d_ff_d_vto)+(d_two_n_phit_d_vto*ff)));
d_vdsat_d_ss=(((vdsats*(-d_ff_d_ss))+(d_vdsats_d_ss*(1.0-ff)))+((two_n_phit*d_ff_d_ss)+(d_two_n_phit_d_ss*ff)));
d_vdsat_d_delta1=(((vdsats*(-d_ff_d_delta1))+(d_vdsats_d_delta1*(1.0-ff)))+((two_n_phit*d_ff_d_delta1)+(d_two_n_phit_d_delta1*ff)));
d_vdsat_d_delta2=(((vdsats*(-d_ff_d_delta2))+(d_vdsats_d_delta2*(1.0-ff)))+((two_n_phit*d_ff_d_delta2)+(d_two_n_phit_d_delta2*ff)));
d_vdsat_d_nd=(((vdsats*(-d_ff_d_nd))+(d_vdsats_d_nd*(1.0-ff)))+((two_n_phit*d_ff_d_nd)+(d_two_n_phit_d_nd*ff)));
d_vdsat_d_alpha=(((vdsats*(-d_ff_d_alpha))+(d_vdsats_d_alpha*(1.0-ff)))+((two_n_phit*d_ff_d_alpha)+(d_two_n_phit_d_alpha*ff)));
d_vdsat_d_vel0=(((vdsats*(-d_ff_d_vel0))+(d_vdsats_d_vel0*(1.0-ff)))+((two_n_phit*d_ff_d_vel0)+(d_two_n_phit_d_vel0*ff)));
d_vdsat_d_mu0=(((vdsats*(-d_ff_d_mu0))+(d_vdsats_d_mu0*(1.0-ff)))+((two_n_phit*d_ff_d_mu0)+(d_two_n_phit_d_mu0*ff)));
d_vdsat_d_beta=(((vdsats*(-d_ff_d_beta))+(d_vdsats_d_beta*(1.0-ff)))+((two_n_phit*d_ff_d_beta)+(d_two_n_phit_d_beta*ff)));
d_vdsat_d_mtheta=(((vdsats*(-d_ff_d_mtheta))+(d_vdsats_d_mtheta*(1.0-ff)))+((two_n_phit*d_ff_d_mtheta)+(d_two_n_phit_d_mtheta*ff)));
d_vdsat_d_vtheta=(((vdsats*(-d_ff_d_vtheta))+(d_vdsats_d_vtheta*(1.0-ff)))+((two_n_phit*d_ff_d_vtheta)+(d_two_n_phit_d_vtheta*ff)));
d_vdsat_d_vtzeta=(((vdsats*(-d_ff_d_vtzeta))+(d_vdsats_d_vtzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vtzeta)+(d_two_n_phit_d_vtzeta*ff)));
d_vdsat_d_dibsat=(((vdsats*(-d_ff_d_dibsat))+(d_vdsats_d_dibsat*(1.0-ff)))+((two_n_phit*d_ff_d_dibsat)+(d_two_n_phit_d_dibsat*ff)));
d_vdsat_d_epsilon=(((vdsats*(-d_ff_d_epsilon))+(d_vdsats_d_epsilon*(1.0-ff)))+((two_n_phit*d_ff_d_epsilon)+(d_two_n_phit_d_epsilon*ff)));
d_vdsat_d_vzeta=(((vdsats*(-d_ff_d_vzeta))+(d_vdsats_d_vzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vzeta)+(d_two_n_phit_d_vzeta*ff)));
d_vdsat_d_lambda=(((vdsats*(-d_ff_d_lambda))+(d_vdsats_d_lambda*(1.0-ff)))+((two_n_phit*d_ff_d_lambda)+(d_two_n_phit_d_lambda*ff)));
d_vdsat_d_ngf=(((vdsats*(-d_ff_d_ngf))+(d_vdsats_d_ngf*(1.0-ff)))+((two_n_phit*d_ff_d_ngf)+(d_two_n_phit_d_ngf*ff)));
d_vdsat_d_type=(((vdsats*(-d_ff_d_type))+(d_vdsats_d_type*(1.0-ff)))+((two_n_phit*d_ff_d_type)+(d_two_n_phit_d_type*ff)));
vdsat=((vdsats*(1.0-ff))+(two_n_phit*ff));
d_vdsat1_d_vgsin=(((vdsats1*(-d_ff_d_vgsin))+(d_vdsats1_d_vgsin*(1.0-ff)))+((two_n_phit*d_ff_d_vgsin)+(d_two_n_phit_d_vgsin*ff)));
d_vdsat1_d_vdsin=(((vdsats1*(-d_ff_d_vdsin))+(d_vdsats1_d_vdsin*(1.0-ff)))+((two_n_phit*d_ff_d_vdsin)+(d_two_n_phit_d_vdsin*ff)));
d_vdsat1_d_qcbflag=(((vdsats1*(-d_ff_d_qcbflag))+(d_vdsats1_d_qcbflag*(1.0-ff)))+((two_n_phit*d_ff_d_qcbflag)+(d_two_n_phit_d_qcbflag*ff)));
d_vdsat1_d_vcin=(((vdsats1*(-d_ff_d_vcin))+(d_vdsats1_d_vcin*(1.0-ff)))+((two_n_phit*d_ff_d_vcin)+(d_two_n_phit_d_vcin*ff)));
d_vdsat1_d_vbin=(((vdsats1*(-d_ff_d_vbin))+(d_vdsats1_d_vbin*(1.0-ff)))+((two_n_phit*d_ff_d_vbin)+(d_two_n_phit_d_vbin*ff)));
d_vdsat1_d_qgsflag=(((vdsats1*(-d_ff_d_qgsflag))+(d_vdsats1_d_qgsflag*(1.0-ff)))+((two_n_phit*d_ff_d_qgsflag)+(d_two_n_phit_d_qgsflag*ff)));
d_vdsat1_d_tambin=(((vdsats1*(-d_ff_d_tambin))+(d_vdsats1_d_tambin*(1.0-ff)))+((two_n_phit*d_ff_d_tambin)+(d_two_n_phit_d_tambin*ff)));
d_vdsat1_d_tnomin=(((vdsats1*(-d_ff_d_tnomin))+(d_vdsats1_d_tnomin*(1.0-ff)))+((two_n_phit*d_ff_d_tnomin)+(d_two_n_phit_d_tnomin*ff)));
d_vdsat1_d_phitin=(((vdsats1*(-d_ff_d_phitin))+(d_vdsats1_d_phitin*(1.0-ff)))+((two_n_phit*d_ff_d_phitin)+(d_two_n_phit_d_phitin*ff)));
d_vdsat1_d_w=(((vdsats1*(-d_ff_d_w))+(d_vdsats1_d_w*(1.0-ff)))+((two_n_phit*d_ff_d_w)+(d_two_n_phit_d_w*ff)));
d_vdsat1_d_lin=(((vdsats1*(-d_ff_d_lin))+(d_vdsats1_d_lin*(1.0-ff)))+((two_n_phit*d_ff_d_lin)+(d_two_n_phit_d_lin*ff)));
d_vdsat1_d_cgin=(((vdsats1*(-d_ff_d_cgin))+(d_vdsats1_d_cgin*(1.0-ff)))+((two_n_phit*d_ff_d_cgin)+(d_two_n_phit_d_cgin*ff)));
d_vdsat1_d_cs=(((vdsats1*(-d_ff_d_cs))+(d_vdsats1_d_cs*(1.0-ff)))+((two_n_phit*d_ff_d_cs)+(d_two_n_phit_d_cs*ff)));
d_vdsat1_d_cc=(((vdsats1*(-d_ff_d_cc))+(d_vdsats1_d_cc*(1.0-ff)))+((two_n_phit*d_ff_d_cc)+(d_two_n_phit_d_cc*ff)));
d_vdsat1_d_cb=(((vdsats1*(-d_ff_d_cb))+(d_vdsats1_d_cb*(1.0-ff)))+((two_n_phit*d_ff_d_cb)+(d_two_n_phit_d_cb*ff)));
d_vdsat1_d_vto=(((vdsats1*(-d_ff_d_vto))+(d_vdsats1_d_vto*(1.0-ff)))+((two_n_phit*d_ff_d_vto)+(d_two_n_phit_d_vto*ff)));
d_vdsat1_d_ss=(((vdsats1*(-d_ff_d_ss))+(d_vdsats1_d_ss*(1.0-ff)))+((two_n_phit*d_ff_d_ss)+(d_two_n_phit_d_ss*ff)));
d_vdsat1_d_delta1=(((vdsats1*(-d_ff_d_delta1))+(d_vdsats1_d_delta1*(1.0-ff)))+((two_n_phit*d_ff_d_delta1)+(d_two_n_phit_d_delta1*ff)));
d_vdsat1_d_delta2=(((vdsats1*(-d_ff_d_delta2))+(d_vdsats1_d_delta2*(1.0-ff)))+((two_n_phit*d_ff_d_delta2)+(d_two_n_phit_d_delta2*ff)));
d_vdsat1_d_nd=(((vdsats1*(-d_ff_d_nd))+(d_vdsats1_d_nd*(1.0-ff)))+((two_n_phit*d_ff_d_nd)+(d_two_n_phit_d_nd*ff)));
d_vdsat1_d_alpha=(((vdsats1*(-d_ff_d_alpha))+(d_vdsats1_d_alpha*(1.0-ff)))+((two_n_phit*d_ff_d_alpha)+(d_two_n_phit_d_alpha*ff)));
d_vdsat1_d_vel0=(((vdsats1*(-d_ff_d_vel0))+(d_vdsats1_d_vel0*(1.0-ff)))+((two_n_phit*d_ff_d_vel0)+(d_two_n_phit_d_vel0*ff)));
d_vdsat1_d_mu0=(((vdsats1*(-d_ff_d_mu0))+(d_vdsats1_d_mu0*(1.0-ff)))+((two_n_phit*d_ff_d_mu0)+(d_two_n_phit_d_mu0*ff)));
d_vdsat1_d_beta=(((vdsats1*(-d_ff_d_beta))+(d_vdsats1_d_beta*(1.0-ff)))+((two_n_phit*d_ff_d_beta)+(d_two_n_phit_d_beta*ff)));
d_vdsat1_d_mtheta=(((vdsats1*(-d_ff_d_mtheta))+(d_vdsats1_d_mtheta*(1.0-ff)))+((two_n_phit*d_ff_d_mtheta)+(d_two_n_phit_d_mtheta*ff)));
d_vdsat1_d_vtheta=(((vdsats1*(-d_ff_d_vtheta))+(d_vdsats1_d_vtheta*(1.0-ff)))+((two_n_phit*d_ff_d_vtheta)+(d_two_n_phit_d_vtheta*ff)));
d_vdsat1_d_vtzeta=(((vdsats1*(-d_ff_d_vtzeta))+(d_vdsats1_d_vtzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vtzeta)+(d_two_n_phit_d_vtzeta*ff)));
d_vdsat1_d_dibsat=(((vdsats1*(-d_ff_d_dibsat))+(d_vdsats1_d_dibsat*(1.0-ff)))+((two_n_phit*d_ff_d_dibsat)+(d_two_n_phit_d_dibsat*ff)));
d_vdsat1_d_epsilon=(((vdsats1*(-d_ff_d_epsilon))+(d_vdsats1_d_epsilon*(1.0-ff)))+((two_n_phit*d_ff_d_epsilon)+(d_two_n_phit_d_epsilon*ff)));
d_vdsat1_d_vzeta=(((vdsats1*(-d_ff_d_vzeta))+(d_vdsats1_d_vzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vzeta)+(d_two_n_phit_d_vzeta*ff)));
d_vdsat1_d_lambda=(((vdsats1*(-d_ff_d_lambda))+(d_vdsats1_d_lambda*(1.0-ff)))+((two_n_phit*d_ff_d_lambda)+(d_two_n_phit_d_lambda*ff)));
d_vdsat1_d_ngf=(((vdsats1*(-d_ff_d_ngf))+(d_vdsats1_d_ngf*(1.0-ff)))+((two_n_phit*d_ff_d_ngf)+(d_two_n_phit_d_ngf*ff)));
d_vdsat1_d_type=(((vdsats1*(-d_ff_d_type))+(d_vdsats1_d_type*(1.0-ff)))+((two_n_phit*d_ff_d_type)+(d_two_n_phit_d_type*ff)));
vdsat1=((vdsats1*(1.0-ff))+(two_n_phit*ff));
d_fsd_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vgsin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,((vdsat1-(vdsin*d_vdsat1_d_vdsin))/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_qcbflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vcin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vbin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_qgsflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_tambin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_tnomin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_phitin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_w/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_lin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cgin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cs/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cc/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cb/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vto/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_ss/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_delta1/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_delta2/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_nd/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_alpha/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vel0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_mu0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_beta/vdsat1/vdsat1))+((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(log(mmax( static_cast<double>(0),(vdsin/vdsat1))*pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_mtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vtzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_dibsat/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_epsilon/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_lambda/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_ngf/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_type/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
fsd=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_vdx_d_vgsin=(vdsin*d_fsd_d_vgsin);
d_vdx_d_vdsin=(vdsin*d_fsd_d_vdsin+fsd);
d_vdx_d_qcbflag=(vdsin*d_fsd_d_qcbflag);
d_vdx_d_vcin=(vdsin*d_fsd_d_vcin);
d_vdx_d_vbin=(vdsin*d_fsd_d_vbin);
d_vdx_d_qgsflag=(vdsin*d_fsd_d_qgsflag);
d_vdx_d_tambin=(vdsin*d_fsd_d_tambin);
d_vdx_d_tnomin=(vdsin*d_fsd_d_tnomin);
d_vdx_d_phitin=(vdsin*d_fsd_d_phitin);
d_vdx_d_w=(vdsin*d_fsd_d_w);
d_vdx_d_lin=(vdsin*d_fsd_d_lin);
d_vdx_d_cgin=(vdsin*d_fsd_d_cgin);
d_vdx_d_cs=(vdsin*d_fsd_d_cs);
d_vdx_d_cc=(vdsin*d_fsd_d_cc);
d_vdx_d_cb=(vdsin*d_fsd_d_cb);
d_vdx_d_vto=(vdsin*d_fsd_d_vto);
d_vdx_d_ss=(vdsin*d_fsd_d_ss);
d_vdx_d_delta1=(vdsin*d_fsd_d_delta1);
d_vdx_d_delta2=(vdsin*d_fsd_d_delta2);
d_vdx_d_nd=(vdsin*d_fsd_d_nd);
d_vdx_d_alpha=(vdsin*d_fsd_d_alpha);
d_vdx_d_vel0=(vdsin*d_fsd_d_vel0);
d_vdx_d_mu0=(vdsin*d_fsd_d_mu0);
d_vdx_d_beta=(vdsin*d_fsd_d_beta);
d_vdx_d_mtheta=(vdsin*d_fsd_d_mtheta);
d_vdx_d_vtheta=(vdsin*d_fsd_d_vtheta);
d_vdx_d_vtzeta=(vdsin*d_fsd_d_vtzeta);
d_vdx_d_dibsat=(vdsin*d_fsd_d_dibsat);
d_vdx_d_epsilon=(vdsin*d_fsd_d_epsilon);
d_vdx_d_vzeta=(vdsin*d_fsd_d_vzeta);
d_vdx_d_lambda=(vdsin*d_fsd_d_lambda);
d_vdx_d_ngf=(vdsin*d_fsd_d_ngf);
d_vdx_d_type=(vdsin*d_fsd_d_type);
vdx=(vdsin*fsd);
d_fds_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vgsin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,((vdsat1*(-1.0)-(-vdsin)*d_vdsat1_d_vdsin)/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_qcbflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vcin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vbin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_qgsflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_tambin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_tnomin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_phitin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_w/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_lin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cgin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cs/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cc/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cb/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vto/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_ss/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_delta1/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_delta2/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_nd/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_alpha/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vel0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_mu0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_beta/vdsat1/vdsat1))+((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(log(mmax( static_cast<double>(0),((-vdsin)/vdsat1))*pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_mtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vtzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_dibsat/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_epsilon/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_lambda/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_ngf/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_type/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
fds=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_vsx_d_vgsin=((-vdsin)*d_fds_d_vgsin);
d_vsx_d_vdsin=(((-vdsin)*d_fds_d_vdsin)+((-1.0)*fds));
d_vsx_d_qcbflag=((-vdsin)*d_fds_d_qcbflag);
d_vsx_d_vcin=((-vdsin)*d_fds_d_vcin);
d_vsx_d_vbin=((-vdsin)*d_fds_d_vbin);
d_vsx_d_qgsflag=((-vdsin)*d_fds_d_qgsflag);
d_vsx_d_tambin=((-vdsin)*d_fds_d_tambin);
d_vsx_d_tnomin=((-vdsin)*d_fds_d_tnomin);
d_vsx_d_phitin=((-vdsin)*d_fds_d_phitin);
d_vsx_d_w=((-vdsin)*d_fds_d_w);
d_vsx_d_lin=((-vdsin)*d_fds_d_lin);
d_vsx_d_cgin=((-vdsin)*d_fds_d_cgin);
d_vsx_d_cs=((-vdsin)*d_fds_d_cs);
d_vsx_d_cc=((-vdsin)*d_fds_d_cc);
d_vsx_d_cb=((-vdsin)*d_fds_d_cb);
d_vsx_d_vto=((-vdsin)*d_fds_d_vto);
d_vsx_d_ss=((-vdsin)*d_fds_d_ss);
d_vsx_d_delta1=((-vdsin)*d_fds_d_delta1);
d_vsx_d_delta2=((-vdsin)*d_fds_d_delta2);
d_vsx_d_nd=((-vdsin)*d_fds_d_nd);
d_vsx_d_alpha=((-vdsin)*d_fds_d_alpha);
d_vsx_d_vel0=((-vdsin)*d_fds_d_vel0);
d_vsx_d_mu0=((-vdsin)*d_fds_d_mu0);
d_vsx_d_beta=((-vdsin)*d_fds_d_beta);
d_vsx_d_mtheta=((-vdsin)*d_fds_d_mtheta);
d_vsx_d_vtheta=((-vdsin)*d_fds_d_vtheta);
d_vsx_d_vtzeta=((-vdsin)*d_fds_d_vtzeta);
d_vsx_d_dibsat=((-vdsin)*d_fds_d_dibsat);
d_vsx_d_epsilon=((-vdsin)*d_fds_d_epsilon);
d_vsx_d_vzeta=((-vdsin)*d_fds_d_vzeta);
d_vsx_d_lambda=((-vdsin)*d_fds_d_lambda);
d_vsx_d_ngf=((-vdsin)*d_fds_d_ngf);
d_vsx_d_type=((-vdsin)*d_fds_d_type);
vsx=((-vdsin)*fds);
d_exparg_d_vgsin=((alpha_phit*(1.0-d_myarg_d_vgsin)-(vgsin-myarg)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg_d_vdsin=((alpha_phit*(-d_myarg_d_vdsin)-(vgsin-myarg)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg_d_qcbflag=((alpha_phit*(-d_myarg_d_qcbflag)-(vgsin-myarg)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg_d_vcin=((alpha_phit*(-d_myarg_d_vcin)-(vgsin-myarg)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg_d_vbin=((alpha_phit*(-d_myarg_d_vbin)-(vgsin-myarg)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg_d_qgsflag=((alpha_phit*(-d_myarg_d_qgsflag)-(vgsin-myarg)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg_d_tambin=((alpha_phit*(-d_myarg_d_tambin)-(vgsin-myarg)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg_d_tnomin=((alpha_phit*(-d_myarg_d_tnomin)-(vgsin-myarg)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg_d_phitin=((alpha_phit*(-d_myarg_d_phitin)-(vgsin-myarg)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg_d_w=((alpha_phit*(-d_myarg_d_w)-(vgsin-myarg)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg_d_lin=((alpha_phit*(-d_myarg_d_lin)-(vgsin-myarg)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg_d_cgin=((alpha_phit*(-d_myarg_d_cgin)-(vgsin-myarg)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg_d_cs=((alpha_phit*(-d_myarg_d_cs)-(vgsin-myarg)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg_d_cc=((alpha_phit*(-d_myarg_d_cc)-(vgsin-myarg)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg_d_cb=((alpha_phit*(-d_myarg_d_cb)-(vgsin-myarg)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg_d_vto=((alpha_phit*(-d_myarg_d_vto)-(vgsin-myarg)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg_d_ss=((alpha_phit*(-d_myarg_d_ss)-(vgsin-myarg)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg_d_delta1=((alpha_phit*(-d_myarg_d_delta1)-(vgsin-myarg)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg_d_delta2=((alpha_phit*(-d_myarg_d_delta2)-(vgsin-myarg)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg_d_nd=((alpha_phit*(-d_myarg_d_nd)-(vgsin-myarg)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg_d_alpha=((alpha_phit*(-d_myarg_d_alpha)-(vgsin-myarg)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg_d_vel0=((alpha_phit*(-d_myarg_d_vel0)-(vgsin-myarg)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg_d_mu0=((alpha_phit*(-d_myarg_d_mu0)-(vgsin-myarg)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg_d_beta=((alpha_phit*(-d_myarg_d_beta)-(vgsin-myarg)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg_d_mtheta=((alpha_phit*(-d_myarg_d_mtheta)-(vgsin-myarg)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtheta=((alpha_phit*(-d_myarg_d_vtheta)-(vgsin-myarg)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtzeta=((alpha_phit*(-d_myarg_d_vtzeta)-(vgsin-myarg)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg_d_dibsat=((alpha_phit*(-d_myarg_d_dibsat)-(vgsin-myarg)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg_d_epsilon=((alpha_phit*(-d_myarg_d_epsilon)-(vgsin-myarg)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg_d_vzeta=((alpha_phit*(-d_myarg_d_vzeta)-(vgsin-myarg)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg_d_lambda=((alpha_phit*(-d_myarg_d_lambda)-(vgsin-myarg)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg_d_ngf=((alpha_phit*(-d_myarg_d_ngf)-(vgsin-myarg)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg_d_type=((alpha_phit*(-d_myarg_d_type)-(vgsin-myarg)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg=((vgsin-myarg)/alpha_phit);
if((exparg>50.0))
{
d_ffs_d_vgsin=0.0;
d_ffs_d_vdsin=0.0;
d_ffs_d_qcbflag=0.0;
d_ffs_d_vcin=0.0;
d_ffs_d_vbin=0.0;
d_ffs_d_qgsflag=0.0;
d_ffs_d_tambin=0.0;
d_ffs_d_tnomin=0.0;
d_ffs_d_phitin=0.0;
d_ffs_d_w=0.0;
d_ffs_d_lin=0.0;
d_ffs_d_cgin=0.0;
d_ffs_d_cs=0.0;
d_ffs_d_cc=0.0;
d_ffs_d_cb=0.0;
d_ffs_d_vto=0.0;
d_ffs_d_ss=0.0;
d_ffs_d_delta1=0.0;
d_ffs_d_delta2=0.0;
d_ffs_d_nd=0.0;
d_ffs_d_alpha=0.0;
d_ffs_d_vel0=0.0;
d_ffs_d_mu0=0.0;
d_ffs_d_beta=0.0;
d_ffs_d_mtheta=0.0;
d_ffs_d_vtheta=0.0;
d_ffs_d_vtzeta=0.0;
d_ffs_d_dibsat=0.0;
d_ffs_d_epsilon=0.0;
d_ffs_d_vzeta=0.0;
d_ffs_d_lambda=0.0;
d_ffs_d_ngf=0.0;
d_ffs_d_type=0.0;
ffs=0.0;
}
else
{
if((exparg<(-50.0)))
{
d_ffs_d_vgsin=0.0;
d_ffs_d_vdsin=0.0;
d_ffs_d_qcbflag=0.0;
d_ffs_d_vcin=0.0;
d_ffs_d_vbin=0.0;
d_ffs_d_qgsflag=0.0;
d_ffs_d_tambin=0.0;
d_ffs_d_tnomin=0.0;
d_ffs_d_phitin=0.0;
d_ffs_d_w=0.0;
d_ffs_d_lin=0.0;
d_ffs_d_cgin=0.0;
d_ffs_d_cs=0.0;
d_ffs_d_cc=0.0;
d_ffs_d_cb=0.0;
d_ffs_d_vto=0.0;
d_ffs_d_ss=0.0;
d_ffs_d_delta1=0.0;
d_ffs_d_delta2=0.0;
d_ffs_d_nd=0.0;
d_ffs_d_alpha=0.0;
d_ffs_d_vel0=0.0;
d_ffs_d_mu0=0.0;
d_ffs_d_beta=0.0;
d_ffs_d_mtheta=0.0;
d_ffs_d_vtheta=0.0;
d_ffs_d_vtzeta=0.0;
d_ffs_d_dibsat=0.0;
d_ffs_d_epsilon=0.0;
d_ffs_d_vzeta=0.0;
d_ffs_d_lambda=0.0;
d_ffs_d_ngf=0.0;
d_ffs_d_type=0.0;
ffs=1.0;
}
else
{
d_ffs_d_vgsin=(-exp(exparg)*d_exparg_d_vgsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vdsin=(-exp(exparg)*d_exparg_d_vdsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_qcbflag=(-exp(exparg)*d_exparg_d_qcbflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vcin=(-exp(exparg)*d_exparg_d_vcin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vbin=(-exp(exparg)*d_exparg_d_vbin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_qgsflag=(-exp(exparg)*d_exparg_d_qgsflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_tambin=(-exp(exparg)*d_exparg_d_tambin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_tnomin=(-exp(exparg)*d_exparg_d_tnomin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_phitin=(-exp(exparg)*d_exparg_d_phitin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_w=(-exp(exparg)*d_exparg_d_w/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_lin=(-exp(exparg)*d_exparg_d_lin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cgin=(-exp(exparg)*d_exparg_d_cgin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cs=(-exp(exparg)*d_exparg_d_cs/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cc=(-exp(exparg)*d_exparg_d_cc/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cb=(-exp(exparg)*d_exparg_d_cb/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vto=(-exp(exparg)*d_exparg_d_vto/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_ss=(-exp(exparg)*d_exparg_d_ss/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_delta1=(-exp(exparg)*d_exparg_d_delta1/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_delta2=(-exp(exparg)*d_exparg_d_delta2/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_nd=(-exp(exparg)*d_exparg_d_nd/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_alpha=(-exp(exparg)*d_exparg_d_alpha/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vel0=(-exp(exparg)*d_exparg_d_vel0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_mu0=(-exp(exparg)*d_exparg_d_mu0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_beta=(-exp(exparg)*d_exparg_d_beta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_mtheta=(-exp(exparg)*d_exparg_d_mtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vtheta=(-exp(exparg)*d_exparg_d_vtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vtzeta=(-exp(exparg)*d_exparg_d_vtzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_dibsat=(-exp(exparg)*d_exparg_d_dibsat/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_epsilon=(-exp(exparg)*d_exparg_d_epsilon/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vzeta=(-exp(exparg)*d_exparg_d_vzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_lambda=(-exp(exparg)*d_exparg_d_lambda/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_ngf=(-exp(exparg)*d_exparg_d_ngf/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_type=(-exp(exparg)*d_exparg_d_type/(1.0+exp(exparg))/(1.0+exp(exparg)));
ffs=(1.0/(1.0+exp(exparg)));
}
}
d_etas_d_vgsin=((two_n_phit*((d_vgdin_d_vgsin-d_vsx_d_vgsin)-(d_vtdibl_d_vgsin-(((0.1*alpha_phit)*d_ffs_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vgsin)/two_n_phit/two_n_phit);
d_etas_d_vdsin=((two_n_phit*((d_vgdin_d_vdsin-d_vsx_d_vdsin)-(d_vtdibl_d_vdsin-(((0.1*alpha_phit)*d_ffs_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vdsin)/two_n_phit/two_n_phit);
d_etas_d_qcbflag=((two_n_phit*((d_vgdin_d_qcbflag-d_vsx_d_qcbflag)-(d_vtdibl_d_qcbflag-(((0.1*alpha_phit)*d_ffs_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_qcbflag)/two_n_phit/two_n_phit);
d_etas_d_vcin=((two_n_phit*((d_vgdin_d_vcin-d_vsx_d_vcin)-(d_vtdibl_d_vcin-(((0.1*alpha_phit)*d_ffs_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vcin)/two_n_phit/two_n_phit);
d_etas_d_vbin=((two_n_phit*((d_vgdin_d_vbin-d_vsx_d_vbin)-(d_vtdibl_d_vbin-(((0.1*alpha_phit)*d_ffs_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vbin)/two_n_phit/two_n_phit);
d_etas_d_qgsflag=((two_n_phit*((d_vgdin_d_qgsflag-d_vsx_d_qgsflag)-(d_vtdibl_d_qgsflag-(((0.1*alpha_phit)*d_ffs_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_qgsflag)/two_n_phit/two_n_phit);
d_etas_d_tambin=((two_n_phit*((d_vgdin_d_tambin-d_vsx_d_tambin)-(d_vtdibl_d_tambin-(((0.1*alpha_phit)*d_ffs_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_tambin)/two_n_phit/two_n_phit);
d_etas_d_tnomin=((two_n_phit*((d_vgdin_d_tnomin-d_vsx_d_tnomin)-(d_vtdibl_d_tnomin-(((0.1*alpha_phit)*d_ffs_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_tnomin)/two_n_phit/two_n_phit);
d_etas_d_phitin=((two_n_phit*((d_vgdin_d_phitin-d_vsx_d_phitin)-(d_vtdibl_d_phitin-(((0.1*alpha_phit)*d_ffs_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_phitin)/two_n_phit/two_n_phit);
d_etas_d_w=((two_n_phit*((d_vgdin_d_w-d_vsx_d_w)-(d_vtdibl_d_w-(((0.1*alpha_phit)*d_ffs_d_w)+((0.1*d_alpha_phit_d_w)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_w)/two_n_phit/two_n_phit);
d_etas_d_lin=((two_n_phit*((d_vgdin_d_lin-d_vsx_d_lin)-(d_vtdibl_d_lin-(((0.1*alpha_phit)*d_ffs_d_lin)+((0.1*d_alpha_phit_d_lin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_lin)/two_n_phit/two_n_phit);
d_etas_d_cgin=((two_n_phit*((d_vgdin_d_cgin-d_vsx_d_cgin)-(d_vtdibl_d_cgin-(((0.1*alpha_phit)*d_ffs_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cgin)/two_n_phit/two_n_phit);
d_etas_d_cs=((two_n_phit*((d_vgdin_d_cs-d_vsx_d_cs)-(d_vtdibl_d_cs-(((0.1*alpha_phit)*d_ffs_d_cs)+((0.1*d_alpha_phit_d_cs)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cs)/two_n_phit/two_n_phit);
d_etas_d_cc=((two_n_phit*((d_vgdin_d_cc-d_vsx_d_cc)-(d_vtdibl_d_cc-(((0.1*alpha_phit)*d_ffs_d_cc)+((0.1*d_alpha_phit_d_cc)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cc)/two_n_phit/two_n_phit);
d_etas_d_cb=((two_n_phit*((d_vgdin_d_cb-d_vsx_d_cb)-(d_vtdibl_d_cb-(((0.1*alpha_phit)*d_ffs_d_cb)+((0.1*d_alpha_phit_d_cb)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cb)/two_n_phit/two_n_phit);
d_etas_d_vto=((two_n_phit*((d_vgdin_d_vto-d_vsx_d_vto)-(d_vtdibl_d_vto-(((0.1*alpha_phit)*d_ffs_d_vto)+((0.1*d_alpha_phit_d_vto)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vto)/two_n_phit/two_n_phit);
d_etas_d_ss=((two_n_phit*((d_vgdin_d_ss-d_vsx_d_ss)-(d_vtdibl_d_ss-(((0.1*alpha_phit)*d_ffs_d_ss)+((0.1*d_alpha_phit_d_ss)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_ss)/two_n_phit/two_n_phit);
d_etas_d_delta1=((two_n_phit*((d_vgdin_d_delta1-d_vsx_d_delta1)-(d_vtdibl_d_delta1-(((0.1*alpha_phit)*d_ffs_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_delta1)/two_n_phit/two_n_phit);
d_etas_d_delta2=((two_n_phit*((d_vgdin_d_delta2-d_vsx_d_delta2)-(d_vtdibl_d_delta2-(((0.1*alpha_phit)*d_ffs_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_delta2)/two_n_phit/two_n_phit);
d_etas_d_nd=((two_n_phit*((d_vgdin_d_nd-d_vsx_d_nd)-(d_vtdibl_d_nd-(((0.1*alpha_phit)*d_ffs_d_nd)+((0.1*d_alpha_phit_d_nd)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_nd)/two_n_phit/two_n_phit);
d_etas_d_alpha=((two_n_phit*((d_vgdin_d_alpha-d_vsx_d_alpha)-(d_vtdibl_d_alpha-(((0.1*alpha_phit)*d_ffs_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_alpha)/two_n_phit/two_n_phit);
d_etas_d_vel0=((two_n_phit*((d_vgdin_d_vel0-d_vsx_d_vel0)-(d_vtdibl_d_vel0-(((0.1*alpha_phit)*d_ffs_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vel0)/two_n_phit/two_n_phit);
d_etas_d_mu0=((two_n_phit*((d_vgdin_d_mu0-d_vsx_d_mu0)-(d_vtdibl_d_mu0-(((0.1*alpha_phit)*d_ffs_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_mu0)/two_n_phit/two_n_phit);
d_etas_d_beta=((two_n_phit*((d_vgdin_d_beta-d_vsx_d_beta)-(d_vtdibl_d_beta-(((0.1*alpha_phit)*d_ffs_d_beta)+((0.1*d_alpha_phit_d_beta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_beta)/two_n_phit/two_n_phit);
d_etas_d_mtheta=((two_n_phit*((d_vgdin_d_mtheta-d_vsx_d_mtheta)-(d_vtdibl_d_mtheta-(((0.1*alpha_phit)*d_ffs_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_mtheta)/two_n_phit/two_n_phit);
d_etas_d_vtheta=((two_n_phit*((d_vgdin_d_vtheta-d_vsx_d_vtheta)-(d_vtdibl_d_vtheta-(((0.1*alpha_phit)*d_ffs_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vtheta)/two_n_phit/two_n_phit);
d_etas_d_vtzeta=((two_n_phit*((d_vgdin_d_vtzeta-d_vsx_d_vtzeta)-(d_vtdibl_d_vtzeta-(((0.1*alpha_phit)*d_ffs_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vtzeta)/two_n_phit/two_n_phit);
d_etas_d_dibsat=((two_n_phit*((d_vgdin_d_dibsat-d_vsx_d_dibsat)-(d_vtdibl_d_dibsat-(((0.1*alpha_phit)*d_ffs_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_dibsat)/two_n_phit/two_n_phit);
d_etas_d_epsilon=((two_n_phit*((d_vgdin_d_epsilon-d_vsx_d_epsilon)-(d_vtdibl_d_epsilon-(((0.1*alpha_phit)*d_ffs_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_epsilon)/two_n_phit/two_n_phit);
d_etas_d_vzeta=((two_n_phit*((d_vgdin_d_vzeta-d_vsx_d_vzeta)-(d_vtdibl_d_vzeta-(((0.1*alpha_phit)*d_ffs_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vzeta)/two_n_phit/two_n_phit);
d_etas_d_lambda=((two_n_phit*((d_vgdin_d_lambda-d_vsx_d_lambda)-(d_vtdibl_d_lambda-(((0.1*alpha_phit)*d_ffs_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_lambda)/two_n_phit/two_n_phit);
d_etas_d_ngf=((two_n_phit*((d_vgdin_d_ngf-d_vsx_d_ngf)-(d_vtdibl_d_ngf-(((0.1*alpha_phit)*d_ffs_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_ngf)/two_n_phit/two_n_phit);
d_etas_d_type=((two_n_phit*((d_vgdin_d_type-d_vsx_d_type)-(d_vtdibl_d_type-(((0.1*alpha_phit)*d_ffs_d_type)+((0.1*d_alpha_phit_d_type)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_type)/two_n_phit/two_n_phit);
etas=(((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))/two_n_phit);
if((etas>50.0))
{
d_qinvs_d_vgsin=((qref*d_etas_d_vgsin)+(d_qref_d_vgsin*etas));
d_qinvs_d_vdsin=((qref*d_etas_d_vdsin)+(d_qref_d_vdsin*etas));
d_qinvs_d_qcbflag=((qref*d_etas_d_qcbflag)+(d_qref_d_qcbflag*etas));
d_qinvs_d_vcin=((qref*d_etas_d_vcin)+(d_qref_d_vcin*etas));
d_qinvs_d_vbin=((qref*d_etas_d_vbin)+(d_qref_d_vbin*etas));
d_qinvs_d_qgsflag=((qref*d_etas_d_qgsflag)+(d_qref_d_qgsflag*etas));
d_qinvs_d_tambin=((qref*d_etas_d_tambin)+(d_qref_d_tambin*etas));
d_qinvs_d_tnomin=((qref*d_etas_d_tnomin)+(d_qref_d_tnomin*etas));
d_qinvs_d_phitin=((qref*d_etas_d_phitin)+(d_qref_d_phitin*etas));
d_qinvs_d_w=((qref*d_etas_d_w)+(d_qref_d_w*etas));
d_qinvs_d_lin=((qref*d_etas_d_lin)+(d_qref_d_lin*etas));
d_qinvs_d_cgin=((qref*d_etas_d_cgin)+(d_qref_d_cgin*etas));
d_qinvs_d_cs=((qref*d_etas_d_cs)+(d_qref_d_cs*etas));
d_qinvs_d_cc=((qref*d_etas_d_cc)+(d_qref_d_cc*etas));
d_qinvs_d_cb=((qref*d_etas_d_cb)+(d_qref_d_cb*etas));
d_qinvs_d_vto=((qref*d_etas_d_vto)+(d_qref_d_vto*etas));
d_qinvs_d_ss=((qref*d_etas_d_ss)+(d_qref_d_ss*etas));
d_qinvs_d_delta1=((qref*d_etas_d_delta1)+(d_qref_d_delta1*etas));
d_qinvs_d_delta2=((qref*d_etas_d_delta2)+(d_qref_d_delta2*etas));
d_qinvs_d_nd=((qref*d_etas_d_nd)+(d_qref_d_nd*etas));
d_qinvs_d_alpha=((qref*d_etas_d_alpha)+(d_qref_d_alpha*etas));
d_qinvs_d_vel0=((qref*d_etas_d_vel0)+(d_qref_d_vel0*etas));
d_qinvs_d_mu0=((qref*d_etas_d_mu0)+(d_qref_d_mu0*etas));
d_qinvs_d_beta=((qref*d_etas_d_beta)+(d_qref_d_beta*etas));
d_qinvs_d_mtheta=((qref*d_etas_d_mtheta)+(d_qref_d_mtheta*etas));
d_qinvs_d_vtheta=((qref*d_etas_d_vtheta)+(d_qref_d_vtheta*etas));
d_qinvs_d_vtzeta=((qref*d_etas_d_vtzeta)+(d_qref_d_vtzeta*etas));
d_qinvs_d_dibsat=((qref*d_etas_d_dibsat)+(d_qref_d_dibsat*etas));
d_qinvs_d_epsilon=((qref*d_etas_d_epsilon)+(d_qref_d_epsilon*etas));
d_qinvs_d_vzeta=((qref*d_etas_d_vzeta)+(d_qref_d_vzeta*etas));
d_qinvs_d_lambda=((qref*d_etas_d_lambda)+(d_qref_d_lambda*etas));
d_qinvs_d_ngf=((qref*d_etas_d_ngf)+(d_qref_d_ngf*etas));
d_qinvs_d_type=((qref*d_etas_d_type)+(d_qref_d_type*etas));
qinvs=(qref*etas);
}
else
{
if((etas<(-50.0)))
{
d_qinvs_d_vgsin=0.0;
d_qinvs_d_vdsin=0.0;
d_qinvs_d_qcbflag=0.0;
d_qinvs_d_vcin=0.0;
d_qinvs_d_vbin=0.0;
d_qinvs_d_qgsflag=0.0;
d_qinvs_d_tambin=0.0;
d_qinvs_d_tnomin=0.0;
d_qinvs_d_phitin=0.0;
d_qinvs_d_w=0.0;
d_qinvs_d_lin=0.0;
d_qinvs_d_cgin=0.0;
d_qinvs_d_cs=0.0;
d_qinvs_d_cc=0.0;
d_qinvs_d_cb=0.0;
d_qinvs_d_vto=0.0;
d_qinvs_d_ss=0.0;
d_qinvs_d_delta1=0.0;
d_qinvs_d_delta2=0.0;
d_qinvs_d_nd=0.0;
d_qinvs_d_alpha=0.0;
d_qinvs_d_vel0=0.0;
d_qinvs_d_mu0=0.0;
d_qinvs_d_beta=0.0;
d_qinvs_d_mtheta=0.0;
d_qinvs_d_vtheta=0.0;
d_qinvs_d_vtzeta=0.0;
d_qinvs_d_dibsat=0.0;
d_qinvs_d_epsilon=0.0;
d_qinvs_d_vzeta=0.0;
d_qinvs_d_lambda=0.0;
d_qinvs_d_ngf=0.0;
d_qinvs_d_type=0.0;
qinvs=0;
}
else
{
d_qinvs_d_vgsin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vgsin)+(d_qref_d_vgsin*log((1.0+exp(etas)))));
d_qinvs_d_vdsin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vdsin)+(d_qref_d_vdsin*log((1.0+exp(etas)))));
d_qinvs_d_qcbflag=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_qcbflag)+(d_qref_d_qcbflag*log((1.0+exp(etas)))));
d_qinvs_d_vcin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vcin)+(d_qref_d_vcin*log((1.0+exp(etas)))));
d_qinvs_d_vbin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vbin)+(d_qref_d_vbin*log((1.0+exp(etas)))));
d_qinvs_d_qgsflag=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_qgsflag)+(d_qref_d_qgsflag*log((1.0+exp(etas)))));
d_qinvs_d_tambin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_tambin)+(d_qref_d_tambin*log((1.0+exp(etas)))));
d_qinvs_d_tnomin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_tnomin)+(d_qref_d_tnomin*log((1.0+exp(etas)))));
d_qinvs_d_phitin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_phitin)+(d_qref_d_phitin*log((1.0+exp(etas)))));
d_qinvs_d_w=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_w)+(d_qref_d_w*log((1.0+exp(etas)))));
d_qinvs_d_lin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_lin)+(d_qref_d_lin*log((1.0+exp(etas)))));
d_qinvs_d_cgin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cgin)+(d_qref_d_cgin*log((1.0+exp(etas)))));
d_qinvs_d_cs=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cs)+(d_qref_d_cs*log((1.0+exp(etas)))));
d_qinvs_d_cc=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cc)+(d_qref_d_cc*log((1.0+exp(etas)))));
d_qinvs_d_cb=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cb)+(d_qref_d_cb*log((1.0+exp(etas)))));
d_qinvs_d_vto=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vto)+(d_qref_d_vto*log((1.0+exp(etas)))));
d_qinvs_d_ss=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_ss)+(d_qref_d_ss*log((1.0+exp(etas)))));
d_qinvs_d_delta1=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_delta1)+(d_qref_d_delta1*log((1.0+exp(etas)))));
d_qinvs_d_delta2=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_delta2)+(d_qref_d_delta2*log((1.0+exp(etas)))));
d_qinvs_d_nd=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_nd)+(d_qref_d_nd*log((1.0+exp(etas)))));
d_qinvs_d_alpha=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_alpha)+(d_qref_d_alpha*log((1.0+exp(etas)))));
d_qinvs_d_vel0=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vel0)+(d_qref_d_vel0*log((1.0+exp(etas)))));
d_qinvs_d_mu0=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_mu0)+(d_qref_d_mu0*log((1.0+exp(etas)))));
d_qinvs_d_beta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_beta)+(d_qref_d_beta*log((1.0+exp(etas)))));
d_qinvs_d_mtheta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_mtheta)+(d_qref_d_mtheta*log((1.0+exp(etas)))));
d_qinvs_d_vtheta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vtheta)+(d_qref_d_vtheta*log((1.0+exp(etas)))));
d_qinvs_d_vtzeta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vtzeta)+(d_qref_d_vtzeta*log((1.0+exp(etas)))));
d_qinvs_d_dibsat=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_dibsat)+(d_qref_d_dibsat*log((1.0+exp(etas)))));
d_qinvs_d_epsilon=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_epsilon)+(d_qref_d_epsilon*log((1.0+exp(etas)))));
d_qinvs_d_vzeta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vzeta)+(d_qref_d_vzeta*log((1.0+exp(etas)))));
d_qinvs_d_lambda=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_lambda)+(d_qref_d_lambda*log((1.0+exp(etas)))));
d_qinvs_d_ngf=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_ngf)+(d_qref_d_ngf*log((1.0+exp(etas)))));
d_qinvs_d_type=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_type)+(d_qref_d_type*log((1.0+exp(etas)))));
qinvs=(qref*log((1.0+exp(etas))));
}
}
d_exparg_d_vgsin=((alpha_phit*(d_vgdin_d_vgsin-d_myarg_d_vgsin)-(vgdin-myarg)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg_d_vdsin=((alpha_phit*(d_vgdin_d_vdsin-d_myarg_d_vdsin)-(vgdin-myarg)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg_d_qcbflag=((alpha_phit*(d_vgdin_d_qcbflag-d_myarg_d_qcbflag)-(vgdin-myarg)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg_d_vcin=((alpha_phit*(d_vgdin_d_vcin-d_myarg_d_vcin)-(vgdin-myarg)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg_d_vbin=((alpha_phit*(d_vgdin_d_vbin-d_myarg_d_vbin)-(vgdin-myarg)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg_d_qgsflag=((alpha_phit*(d_vgdin_d_qgsflag-d_myarg_d_qgsflag)-(vgdin-myarg)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg_d_tambin=((alpha_phit*(d_vgdin_d_tambin-d_myarg_d_tambin)-(vgdin-myarg)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg_d_tnomin=((alpha_phit*(d_vgdin_d_tnomin-d_myarg_d_tnomin)-(vgdin-myarg)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg_d_phitin=((alpha_phit*(d_vgdin_d_phitin-d_myarg_d_phitin)-(vgdin-myarg)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg_d_w=((alpha_phit*(d_vgdin_d_w-d_myarg_d_w)-(vgdin-myarg)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg_d_lin=((alpha_phit*(d_vgdin_d_lin-d_myarg_d_lin)-(vgdin-myarg)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg_d_cgin=((alpha_phit*(d_vgdin_d_cgin-d_myarg_d_cgin)-(vgdin-myarg)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg_d_cs=((alpha_phit*(d_vgdin_d_cs-d_myarg_d_cs)-(vgdin-myarg)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg_d_cc=((alpha_phit*(d_vgdin_d_cc-d_myarg_d_cc)-(vgdin-myarg)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg_d_cb=((alpha_phit*(d_vgdin_d_cb-d_myarg_d_cb)-(vgdin-myarg)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg_d_vto=((alpha_phit*(d_vgdin_d_vto-d_myarg_d_vto)-(vgdin-myarg)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg_d_ss=((alpha_phit*(d_vgdin_d_ss-d_myarg_d_ss)-(vgdin-myarg)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg_d_delta1=((alpha_phit*(d_vgdin_d_delta1-d_myarg_d_delta1)-(vgdin-myarg)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg_d_delta2=((alpha_phit*(d_vgdin_d_delta2-d_myarg_d_delta2)-(vgdin-myarg)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg_d_nd=((alpha_phit*(d_vgdin_d_nd-d_myarg_d_nd)-(vgdin-myarg)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg_d_alpha=((alpha_phit*(d_vgdin_d_alpha-d_myarg_d_alpha)-(vgdin-myarg)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg_d_vel0=((alpha_phit*(d_vgdin_d_vel0-d_myarg_d_vel0)-(vgdin-myarg)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg_d_mu0=((alpha_phit*(d_vgdin_d_mu0-d_myarg_d_mu0)-(vgdin-myarg)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg_d_beta=((alpha_phit*(d_vgdin_d_beta-d_myarg_d_beta)-(vgdin-myarg)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg_d_mtheta=((alpha_phit*(d_vgdin_d_mtheta-d_myarg_d_mtheta)-(vgdin-myarg)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtheta=((alpha_phit*(d_vgdin_d_vtheta-d_myarg_d_vtheta)-(vgdin-myarg)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtzeta=((alpha_phit*(d_vgdin_d_vtzeta-d_myarg_d_vtzeta)-(vgdin-myarg)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg_d_dibsat=((alpha_phit*(d_vgdin_d_dibsat-d_myarg_d_dibsat)-(vgdin-myarg)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg_d_epsilon=((alpha_phit*(d_vgdin_d_epsilon-d_myarg_d_epsilon)-(vgdin-myarg)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg_d_vzeta=((alpha_phit*(d_vgdin_d_vzeta-d_myarg_d_vzeta)-(vgdin-myarg)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg_d_lambda=((alpha_phit*(d_vgdin_d_lambda-d_myarg_d_lambda)-(vgdin-myarg)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg_d_ngf=((alpha_phit*(d_vgdin_d_ngf-d_myarg_d_ngf)-(vgdin-myarg)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg_d_type=((alpha_phit*(d_vgdin_d_type-d_myarg_d_type)-(vgdin-myarg)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg=((vgdin-myarg)/alpha_phit);
if((exparg>50.0))
{
d_ffd_d_vgsin=0.0;
d_ffd_d_vdsin=0.0;
d_ffd_d_qcbflag=0.0;
d_ffd_d_vcin=0.0;
d_ffd_d_vbin=0.0;
d_ffd_d_qgsflag=0.0;
d_ffd_d_tambin=0.0;
d_ffd_d_tnomin=0.0;
d_ffd_d_phitin=0.0;
d_ffd_d_w=0.0;
d_ffd_d_lin=0.0;
d_ffd_d_cgin=0.0;
d_ffd_d_cs=0.0;
d_ffd_d_cc=0.0;
d_ffd_d_cb=0.0;
d_ffd_d_vto=0.0;
d_ffd_d_ss=0.0;
d_ffd_d_delta1=0.0;
d_ffd_d_delta2=0.0;
d_ffd_d_nd=0.0;
d_ffd_d_alpha=0.0;
d_ffd_d_vel0=0.0;
d_ffd_d_mu0=0.0;
d_ffd_d_beta=0.0;
d_ffd_d_mtheta=0.0;
d_ffd_d_vtheta=0.0;
d_ffd_d_vtzeta=0.0;
d_ffd_d_dibsat=0.0;
d_ffd_d_epsilon=0.0;
d_ffd_d_vzeta=0.0;
d_ffd_d_lambda=0.0;
d_ffd_d_ngf=0.0;
d_ffd_d_type=0.0;
ffd=0.0;
}
else
{
if((exparg<(-50.0)))
{
d_ffd_d_vgsin=0.0;
d_ffd_d_vdsin=0.0;
d_ffd_d_qcbflag=0.0;
d_ffd_d_vcin=0.0;
d_ffd_d_vbin=0.0;
d_ffd_d_qgsflag=0.0;
d_ffd_d_tambin=0.0;
d_ffd_d_tnomin=0.0;
d_ffd_d_phitin=0.0;
d_ffd_d_w=0.0;
d_ffd_d_lin=0.0;
d_ffd_d_cgin=0.0;
d_ffd_d_cs=0.0;
d_ffd_d_cc=0.0;
d_ffd_d_cb=0.0;
d_ffd_d_vto=0.0;
d_ffd_d_ss=0.0;
d_ffd_d_delta1=0.0;
d_ffd_d_delta2=0.0;
d_ffd_d_nd=0.0;
d_ffd_d_alpha=0.0;
d_ffd_d_vel0=0.0;
d_ffd_d_mu0=0.0;
d_ffd_d_beta=0.0;
d_ffd_d_mtheta=0.0;
d_ffd_d_vtheta=0.0;
d_ffd_d_vtzeta=0.0;
d_ffd_d_dibsat=0.0;
d_ffd_d_epsilon=0.0;
d_ffd_d_vzeta=0.0;
d_ffd_d_lambda=0.0;
d_ffd_d_ngf=0.0;
d_ffd_d_type=0.0;
ffd=1.0;
}
else
{
d_ffd_d_vgsin=(-exp(exparg)*d_exparg_d_vgsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vdsin=(-exp(exparg)*d_exparg_d_vdsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_qcbflag=(-exp(exparg)*d_exparg_d_qcbflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vcin=(-exp(exparg)*d_exparg_d_vcin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vbin=(-exp(exparg)*d_exparg_d_vbin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_qgsflag=(-exp(exparg)*d_exparg_d_qgsflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_tambin=(-exp(exparg)*d_exparg_d_tambin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_tnomin=(-exp(exparg)*d_exparg_d_tnomin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_phitin=(-exp(exparg)*d_exparg_d_phitin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_w=(-exp(exparg)*d_exparg_d_w/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_lin=(-exp(exparg)*d_exparg_d_lin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cgin=(-exp(exparg)*d_exparg_d_cgin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cs=(-exp(exparg)*d_exparg_d_cs/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cc=(-exp(exparg)*d_exparg_d_cc/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cb=(-exp(exparg)*d_exparg_d_cb/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vto=(-exp(exparg)*d_exparg_d_vto/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_ss=(-exp(exparg)*d_exparg_d_ss/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_delta1=(-exp(exparg)*d_exparg_d_delta1/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_delta2=(-exp(exparg)*d_exparg_d_delta2/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_nd=(-exp(exparg)*d_exparg_d_nd/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_alpha=(-exp(exparg)*d_exparg_d_alpha/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vel0=(-exp(exparg)*d_exparg_d_vel0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_mu0=(-exp(exparg)*d_exparg_d_mu0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_beta=(-exp(exparg)*d_exparg_d_beta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_mtheta=(-exp(exparg)*d_exparg_d_mtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vtheta=(-exp(exparg)*d_exparg_d_vtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vtzeta=(-exp(exparg)*d_exparg_d_vtzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_dibsat=(-exp(exparg)*d_exparg_d_dibsat/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_epsilon=(-exp(exparg)*d_exparg_d_epsilon/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vzeta=(-exp(exparg)*d_exparg_d_vzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_lambda=(-exp(exparg)*d_exparg_d_lambda/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_ngf=(-exp(exparg)*d_exparg_d_ngf/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_type=(-exp(exparg)*d_exparg_d_type/(1.0+exp(exparg))/(1.0+exp(exparg)));
ffd=(1.0/(1.0+exp(exparg)));
}
}
d_etad_d_vgsin=((two_n_phit*((1.0-d_vdx_d_vgsin)-(d_vtdibl_d_vgsin-(((0.1*alpha_phit)*d_ffd_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vgsin)/two_n_phit/two_n_phit);
d_etad_d_vdsin=((two_n_phit*((-d_vdx_d_vdsin)-(d_vtdibl_d_vdsin-(((0.1*alpha_phit)*d_ffd_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vdsin)/two_n_phit/two_n_phit);
d_etad_d_qcbflag=((two_n_phit*((-d_vdx_d_qcbflag)-(d_vtdibl_d_qcbflag-(((0.1*alpha_phit)*d_ffd_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_qcbflag)/two_n_phit/two_n_phit);
d_etad_d_vcin=((two_n_phit*((-d_vdx_d_vcin)-(d_vtdibl_d_vcin-(((0.1*alpha_phit)*d_ffd_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vcin)/two_n_phit/two_n_phit);
d_etad_d_vbin=((two_n_phit*((-d_vdx_d_vbin)-(d_vtdibl_d_vbin-(((0.1*alpha_phit)*d_ffd_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vbin)/two_n_phit/two_n_phit);
d_etad_d_qgsflag=((two_n_phit*((-d_vdx_d_qgsflag)-(d_vtdibl_d_qgsflag-(((0.1*alpha_phit)*d_ffd_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_qgsflag)/two_n_phit/two_n_phit);
d_etad_d_tambin=((two_n_phit*((-d_vdx_d_tambin)-(d_vtdibl_d_tambin-(((0.1*alpha_phit)*d_ffd_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_tambin)/two_n_phit/two_n_phit);
d_etad_d_tnomin=((two_n_phit*((-d_vdx_d_tnomin)-(d_vtdibl_d_tnomin-(((0.1*alpha_phit)*d_ffd_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_tnomin)/two_n_phit/two_n_phit);
d_etad_d_phitin=((two_n_phit*((-d_vdx_d_phitin)-(d_vtdibl_d_phitin-(((0.1*alpha_phit)*d_ffd_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_phitin)/two_n_phit/two_n_phit);
d_etad_d_w=((two_n_phit*((-d_vdx_d_w)-(d_vtdibl_d_w-(((0.1*alpha_phit)*d_ffd_d_w)+((0.1*d_alpha_phit_d_w)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_w)/two_n_phit/two_n_phit);
d_etad_d_lin=((two_n_phit*((-d_vdx_d_lin)-(d_vtdibl_d_lin-(((0.1*alpha_phit)*d_ffd_d_lin)+((0.1*d_alpha_phit_d_lin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_lin)/two_n_phit/two_n_phit);
d_etad_d_cgin=((two_n_phit*((-d_vdx_d_cgin)-(d_vtdibl_d_cgin-(((0.1*alpha_phit)*d_ffd_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cgin)/two_n_phit/two_n_phit);
d_etad_d_cs=((two_n_phit*((-d_vdx_d_cs)-(d_vtdibl_d_cs-(((0.1*alpha_phit)*d_ffd_d_cs)+((0.1*d_alpha_phit_d_cs)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cs)/two_n_phit/two_n_phit);
d_etad_d_cc=((two_n_phit*((-d_vdx_d_cc)-(d_vtdibl_d_cc-(((0.1*alpha_phit)*d_ffd_d_cc)+((0.1*d_alpha_phit_d_cc)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cc)/two_n_phit/two_n_phit);
d_etad_d_cb=((two_n_phit*((-d_vdx_d_cb)-(d_vtdibl_d_cb-(((0.1*alpha_phit)*d_ffd_d_cb)+((0.1*d_alpha_phit_d_cb)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cb)/two_n_phit/two_n_phit);
d_etad_d_vto=((two_n_phit*((-d_vdx_d_vto)-(d_vtdibl_d_vto-(((0.1*alpha_phit)*d_ffd_d_vto)+((0.1*d_alpha_phit_d_vto)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vto)/two_n_phit/two_n_phit);
d_etad_d_ss=((two_n_phit*((-d_vdx_d_ss)-(d_vtdibl_d_ss-(((0.1*alpha_phit)*d_ffd_d_ss)+((0.1*d_alpha_phit_d_ss)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_ss)/two_n_phit/two_n_phit);
d_etad_d_delta1=((two_n_phit*((-d_vdx_d_delta1)-(d_vtdibl_d_delta1-(((0.1*alpha_phit)*d_ffd_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_delta1)/two_n_phit/two_n_phit);
d_etad_d_delta2=((two_n_phit*((-d_vdx_d_delta2)-(d_vtdibl_d_delta2-(((0.1*alpha_phit)*d_ffd_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_delta2)/two_n_phit/two_n_phit);
d_etad_d_nd=((two_n_phit*((-d_vdx_d_nd)-(d_vtdibl_d_nd-(((0.1*alpha_phit)*d_ffd_d_nd)+((0.1*d_alpha_phit_d_nd)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_nd)/two_n_phit/two_n_phit);
d_etad_d_alpha=((two_n_phit*((-d_vdx_d_alpha)-(d_vtdibl_d_alpha-(((0.1*alpha_phit)*d_ffd_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_alpha)/two_n_phit/two_n_phit);
d_etad_d_vel0=((two_n_phit*((-d_vdx_d_vel0)-(d_vtdibl_d_vel0-(((0.1*alpha_phit)*d_ffd_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vel0)/two_n_phit/two_n_phit);
d_etad_d_mu0=((two_n_phit*((-d_vdx_d_mu0)-(d_vtdibl_d_mu0-(((0.1*alpha_phit)*d_ffd_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_mu0)/two_n_phit/two_n_phit);
d_etad_d_beta=((two_n_phit*((-d_vdx_d_beta)-(d_vtdibl_d_beta-(((0.1*alpha_phit)*d_ffd_d_beta)+((0.1*d_alpha_phit_d_beta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_beta)/two_n_phit/two_n_phit);
d_etad_d_mtheta=((two_n_phit*((-d_vdx_d_mtheta)-(d_vtdibl_d_mtheta-(((0.1*alpha_phit)*d_ffd_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_mtheta)/two_n_phit/two_n_phit);
d_etad_d_vtheta=((two_n_phit*((-d_vdx_d_vtheta)-(d_vtdibl_d_vtheta-(((0.1*alpha_phit)*d_ffd_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vtheta)/two_n_phit/two_n_phit);
d_etad_d_vtzeta=((two_n_phit*((-d_vdx_d_vtzeta)-(d_vtdibl_d_vtzeta-(((0.1*alpha_phit)*d_ffd_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vtzeta)/two_n_phit/two_n_phit);
d_etad_d_dibsat=((two_n_phit*((-d_vdx_d_dibsat)-(d_vtdibl_d_dibsat-(((0.1*alpha_phit)*d_ffd_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_dibsat)/two_n_phit/two_n_phit);
d_etad_d_epsilon=((two_n_phit*((-d_vdx_d_epsilon)-(d_vtdibl_d_epsilon-(((0.1*alpha_phit)*d_ffd_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_epsilon)/two_n_phit/two_n_phit);
d_etad_d_vzeta=((two_n_phit*((-d_vdx_d_vzeta)-(d_vtdibl_d_vzeta-(((0.1*alpha_phit)*d_ffd_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vzeta)/two_n_phit/two_n_phit);
d_etad_d_lambda=((two_n_phit*((-d_vdx_d_lambda)-(d_vtdibl_d_lambda-(((0.1*alpha_phit)*d_ffd_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_lambda)/two_n_phit/two_n_phit);
d_etad_d_ngf=((two_n_phit*((-d_vdx_d_ngf)-(d_vtdibl_d_ngf-(((0.1*alpha_phit)*d_ffd_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_ngf)/two_n_phit/two_n_phit);
d_etad_d_type=((two_n_phit*((-d_vdx_d_type)-(d_vtdibl_d_type-(((0.1*alpha_phit)*d_ffd_d_type)+((0.1*d_alpha_phit_d_type)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_type)/two_n_phit/two_n_phit);
etad=(((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))/two_n_phit);
if((etad>50.0))
{
d_qinvd_d_vgsin=((qref*d_etad_d_vgsin)+(d_qref_d_vgsin*etad));
d_qinvd_d_vdsin=((qref*d_etad_d_vdsin)+(d_qref_d_vdsin*etad));
d_qinvd_d_qcbflag=((qref*d_etad_d_qcbflag)+(d_qref_d_qcbflag*etad));
d_qinvd_d_vcin=((qref*d_etad_d_vcin)+(d_qref_d_vcin*etad));
d_qinvd_d_vbin=((qref*d_etad_d_vbin)+(d_qref_d_vbin*etad));
d_qinvd_d_qgsflag=((qref*d_etad_d_qgsflag)+(d_qref_d_qgsflag*etad));
d_qinvd_d_tambin=((qref*d_etad_d_tambin)+(d_qref_d_tambin*etad));
d_qinvd_d_tnomin=((qref*d_etad_d_tnomin)+(d_qref_d_tnomin*etad));
d_qinvd_d_phitin=((qref*d_etad_d_phitin)+(d_qref_d_phitin*etad));
d_qinvd_d_w=((qref*d_etad_d_w)+(d_qref_d_w*etad));
d_qinvd_d_lin=((qref*d_etad_d_lin)+(d_qref_d_lin*etad));
d_qinvd_d_cgin=((qref*d_etad_d_cgin)+(d_qref_d_cgin*etad));
d_qinvd_d_cs=((qref*d_etad_d_cs)+(d_qref_d_cs*etad));
d_qinvd_d_cc=((qref*d_etad_d_cc)+(d_qref_d_cc*etad));
d_qinvd_d_cb=((qref*d_etad_d_cb)+(d_qref_d_cb*etad));
d_qinvd_d_vto=((qref*d_etad_d_vto)+(d_qref_d_vto*etad));
d_qinvd_d_ss=((qref*d_etad_d_ss)+(d_qref_d_ss*etad));
d_qinvd_d_delta1=((qref*d_etad_d_delta1)+(d_qref_d_delta1*etad));
d_qinvd_d_delta2=((qref*d_etad_d_delta2)+(d_qref_d_delta2*etad));
d_qinvd_d_nd=((qref*d_etad_d_nd)+(d_qref_d_nd*etad));
d_qinvd_d_alpha=((qref*d_etad_d_alpha)+(d_qref_d_alpha*etad));
d_qinvd_d_vel0=((qref*d_etad_d_vel0)+(d_qref_d_vel0*etad));
d_qinvd_d_mu0=((qref*d_etad_d_mu0)+(d_qref_d_mu0*etad));
d_qinvd_d_beta=((qref*d_etad_d_beta)+(d_qref_d_beta*etad));
d_qinvd_d_mtheta=((qref*d_etad_d_mtheta)+(d_qref_d_mtheta*etad));
d_qinvd_d_vtheta=((qref*d_etad_d_vtheta)+(d_qref_d_vtheta*etad));
d_qinvd_d_vtzeta=((qref*d_etad_d_vtzeta)+(d_qref_d_vtzeta*etad));
d_qinvd_d_dibsat=((qref*d_etad_d_dibsat)+(d_qref_d_dibsat*etad));
d_qinvd_d_epsilon=((qref*d_etad_d_epsilon)+(d_qref_d_epsilon*etad));
d_qinvd_d_vzeta=((qref*d_etad_d_vzeta)+(d_qref_d_vzeta*etad));
d_qinvd_d_lambda=((qref*d_etad_d_lambda)+(d_qref_d_lambda*etad));
d_qinvd_d_ngf=((qref*d_etad_d_ngf)+(d_qref_d_ngf*etad));
d_qinvd_d_type=((qref*d_etad_d_type)+(d_qref_d_type*etad));
qinvd=(qref*etad);
}
else
{
if((etad<(-50.0)))
{
d_qinvd_d_vgsin=0.0;
d_qinvd_d_vdsin=0.0;
d_qinvd_d_qcbflag=0.0;
d_qinvd_d_vcin=0.0;
d_qinvd_d_vbin=0.0;
d_qinvd_d_qgsflag=0.0;
d_qinvd_d_tambin=0.0;
d_qinvd_d_tnomin=0.0;
d_qinvd_d_phitin=0.0;
d_qinvd_d_w=0.0;
d_qinvd_d_lin=0.0;
d_qinvd_d_cgin=0.0;
d_qinvd_d_cs=0.0;
d_qinvd_d_cc=0.0;
d_qinvd_d_cb=0.0;
d_qinvd_d_vto=0.0;
d_qinvd_d_ss=0.0;
d_qinvd_d_delta1=0.0;
d_qinvd_d_delta2=0.0;
d_qinvd_d_nd=0.0;
d_qinvd_d_alpha=0.0;
d_qinvd_d_vel0=0.0;
d_qinvd_d_mu0=0.0;
d_qinvd_d_beta=0.0;
d_qinvd_d_mtheta=0.0;
d_qinvd_d_vtheta=0.0;
d_qinvd_d_vtzeta=0.0;
d_qinvd_d_dibsat=0.0;
d_qinvd_d_epsilon=0.0;
d_qinvd_d_vzeta=0.0;
d_qinvd_d_lambda=0.0;
d_qinvd_d_ngf=0.0;
d_qinvd_d_type=0.0;
qinvd=0;
}
else
{
d_qinvd_d_vgsin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vgsin)+(d_qref_d_vgsin*log((1.0+exp(etad)))));
d_qinvd_d_vdsin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vdsin)+(d_qref_d_vdsin*log((1.0+exp(etad)))));
d_qinvd_d_qcbflag=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_qcbflag)+(d_qref_d_qcbflag*log((1.0+exp(etad)))));
d_qinvd_d_vcin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vcin)+(d_qref_d_vcin*log((1.0+exp(etad)))));
d_qinvd_d_vbin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vbin)+(d_qref_d_vbin*log((1.0+exp(etad)))));
d_qinvd_d_qgsflag=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_qgsflag)+(d_qref_d_qgsflag*log((1.0+exp(etad)))));
d_qinvd_d_tambin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_tambin)+(d_qref_d_tambin*log((1.0+exp(etad)))));
d_qinvd_d_tnomin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_tnomin)+(d_qref_d_tnomin*log((1.0+exp(etad)))));
d_qinvd_d_phitin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_phitin)+(d_qref_d_phitin*log((1.0+exp(etad)))));
d_qinvd_d_w=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_w)+(d_qref_d_w*log((1.0+exp(etad)))));
d_qinvd_d_lin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_lin)+(d_qref_d_lin*log((1.0+exp(etad)))));
d_qinvd_d_cgin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cgin)+(d_qref_d_cgin*log((1.0+exp(etad)))));
d_qinvd_d_cs=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cs)+(d_qref_d_cs*log((1.0+exp(etad)))));
d_qinvd_d_cc=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cc)+(d_qref_d_cc*log((1.0+exp(etad)))));
d_qinvd_d_cb=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cb)+(d_qref_d_cb*log((1.0+exp(etad)))));
d_qinvd_d_vto=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vto)+(d_qref_d_vto*log((1.0+exp(etad)))));
d_qinvd_d_ss=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_ss)+(d_qref_d_ss*log((1.0+exp(etad)))));
d_qinvd_d_delta1=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_delta1)+(d_qref_d_delta1*log((1.0+exp(etad)))));
d_qinvd_d_delta2=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_delta2)+(d_qref_d_delta2*log((1.0+exp(etad)))));
d_qinvd_d_nd=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_nd)+(d_qref_d_nd*log((1.0+exp(etad)))));
d_qinvd_d_alpha=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_alpha)+(d_qref_d_alpha*log((1.0+exp(etad)))));
d_qinvd_d_vel0=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vel0)+(d_qref_d_vel0*log((1.0+exp(etad)))));
d_qinvd_d_mu0=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_mu0)+(d_qref_d_mu0*log((1.0+exp(etad)))));
d_qinvd_d_beta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_beta)+(d_qref_d_beta*log((1.0+exp(etad)))));
d_qinvd_d_mtheta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_mtheta)+(d_qref_d_mtheta*log((1.0+exp(etad)))));
d_qinvd_d_vtheta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vtheta)+(d_qref_d_vtheta*log((1.0+exp(etad)))));
d_qinvd_d_vtzeta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vtzeta)+(d_qref_d_vtzeta*log((1.0+exp(etad)))));
d_qinvd_d_dibsat=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_dibsat)+(d_qref_d_dibsat*log((1.0+exp(etad)))));
d_qinvd_d_epsilon=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_epsilon)+(d_qref_d_epsilon*log((1.0+exp(etad)))));
d_qinvd_d_vzeta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vzeta)+(d_qref_d_vzeta*log((1.0+exp(etad)))));
d_qinvd_d_lambda=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_lambda)+(d_qref_d_lambda*log((1.0+exp(etad)))));
d_qinvd_d_ngf=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_ngf)+(d_qref_d_ngf*log((1.0+exp(etad)))));
d_qinvd_d_type=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_type)+(d_qref_d_type*log((1.0+exp(etad)))));
qinvd=(qref*log((1.0+exp(etad))));
}
}
d_vdsc_d_vgsin=((d_qinvs_d_vgsin-d_qinvd_d_vgsin)/cgin);
d_vdsc_d_vdsin=((d_qinvs_d_vdsin-d_qinvd_d_vdsin)/cgin);
d_vdsc_d_qcbflag=((d_qinvs_d_qcbflag-d_qinvd_d_qcbflag)/cgin);
d_vdsc_d_vcin=((d_qinvs_d_vcin-d_qinvd_d_vcin)/cgin);
d_vdsc_d_vbin=((d_qinvs_d_vbin-d_qinvd_d_vbin)/cgin);
d_vdsc_d_qgsflag=((d_qinvs_d_qgsflag-d_qinvd_d_qgsflag)/cgin);
d_vdsc_d_tambin=((d_qinvs_d_tambin-d_qinvd_d_tambin)/cgin);
d_vdsc_d_tnomin=((d_qinvs_d_tnomin-d_qinvd_d_tnomin)/cgin);
d_vdsc_d_phitin=((d_qinvs_d_phitin-d_qinvd_d_phitin)/cgin);
d_vdsc_d_w=((d_qinvs_d_w-d_qinvd_d_w)/cgin);
d_vdsc_d_lin=((d_qinvs_d_lin-d_qinvd_d_lin)/cgin);
d_vdsc_d_cgin=((cgin*(d_qinvs_d_cgin-d_qinvd_d_cgin)-(qinvs-qinvd))/cgin/cgin);
d_vdsc_d_cs=((d_qinvs_d_cs-d_qinvd_d_cs)/cgin);
d_vdsc_d_cc=((d_qinvs_d_cc-d_qinvd_d_cc)/cgin);
d_vdsc_d_cb=((d_qinvs_d_cb-d_qinvd_d_cb)/cgin);
d_vdsc_d_vto=((d_qinvs_d_vto-d_qinvd_d_vto)/cgin);
d_vdsc_d_ss=((d_qinvs_d_ss-d_qinvd_d_ss)/cgin);
d_vdsc_d_delta1=((d_qinvs_d_delta1-d_qinvd_d_delta1)/cgin);
d_vdsc_d_delta2=((d_qinvs_d_delta2-d_qinvd_d_delta2)/cgin);
d_vdsc_d_nd=((d_qinvs_d_nd-d_qinvd_d_nd)/cgin);
d_vdsc_d_alpha=((d_qinvs_d_alpha-d_qinvd_d_alpha)/cgin);
d_vdsc_d_vel0=((d_qinvs_d_vel0-d_qinvd_d_vel0)/cgin);
d_vdsc_d_mu0=((d_qinvs_d_mu0-d_qinvd_d_mu0)/cgin);
d_vdsc_d_beta=((d_qinvs_d_beta-d_qinvd_d_beta)/cgin);
d_vdsc_d_mtheta=((d_qinvs_d_mtheta-d_qinvd_d_mtheta)/cgin);
d_vdsc_d_vtheta=((d_qinvs_d_vtheta-d_qinvd_d_vtheta)/cgin);
d_vdsc_d_vtzeta=((d_qinvs_d_vtzeta-d_qinvd_d_vtzeta)/cgin);
d_vdsc_d_dibsat=((d_qinvs_d_dibsat-d_qinvd_d_dibsat)/cgin);
d_vdsc_d_epsilon=((d_qinvs_d_epsilon-d_qinvd_d_epsilon)/cgin);
d_vdsc_d_vzeta=((d_qinvs_d_vzeta-d_qinvd_d_vzeta)/cgin);
d_vdsc_d_lambda=((d_qinvs_d_lambda-d_qinvd_d_lambda)/cgin);
d_vdsc_d_ngf=((d_qinvs_d_ngf-d_qinvd_d_ngf)/cgin);
d_vdsc_d_type=((d_qinvs_d_type-d_qinvd_d_type)/cgin);
vdsc=((qinvs-qinvd)/cgin);
d_myarg_d_vgsin=((vdsat*d_vdsc_d_vgsin-vdsc*d_vdsat_d_vgsin)/vdsat/vdsat);
d_myarg_d_vdsin=((vdsat*d_vdsc_d_vdsin-vdsc*d_vdsat_d_vdsin)/vdsat/vdsat);
d_myarg_d_qcbflag=((vdsat*d_vdsc_d_qcbflag-vdsc*d_vdsat_d_qcbflag)/vdsat/vdsat);
d_myarg_d_vcin=((vdsat*d_vdsc_d_vcin-vdsc*d_vdsat_d_vcin)/vdsat/vdsat);
d_myarg_d_vbin=((vdsat*d_vdsc_d_vbin-vdsc*d_vdsat_d_vbin)/vdsat/vdsat);
d_myarg_d_qgsflag=((vdsat*d_vdsc_d_qgsflag-vdsc*d_vdsat_d_qgsflag)/vdsat/vdsat);
d_myarg_d_tambin=((vdsat*d_vdsc_d_tambin-vdsc*d_vdsat_d_tambin)/vdsat/vdsat);
d_myarg_d_tnomin=((vdsat*d_vdsc_d_tnomin-vdsc*d_vdsat_d_tnomin)/vdsat/vdsat);
d_myarg_d_phitin=((vdsat*d_vdsc_d_phitin-vdsc*d_vdsat_d_phitin)/vdsat/vdsat);
d_myarg_d_w=((vdsat*d_vdsc_d_w-vdsc*d_vdsat_d_w)/vdsat/vdsat);
d_myarg_d_lin=((vdsat*d_vdsc_d_lin-vdsc*d_vdsat_d_lin)/vdsat/vdsat);
d_myarg_d_cgin=((vdsat*d_vdsc_d_cgin-vdsc*d_vdsat_d_cgin)/vdsat/vdsat);
d_myarg_d_cs=((vdsat*d_vdsc_d_cs-vdsc*d_vdsat_d_cs)/vdsat/vdsat);
d_myarg_d_cc=((vdsat*d_vdsc_d_cc-vdsc*d_vdsat_d_cc)/vdsat/vdsat);
d_myarg_d_cb=((vdsat*d_vdsc_d_cb-vdsc*d_vdsat_d_cb)/vdsat/vdsat);
d_myarg_d_vto=((vdsat*d_vdsc_d_vto-vdsc*d_vdsat_d_vto)/vdsat/vdsat);
d_myarg_d_ss=((vdsat*d_vdsc_d_ss-vdsc*d_vdsat_d_ss)/vdsat/vdsat);
d_myarg_d_delta1=((vdsat*d_vdsc_d_delta1-vdsc*d_vdsat_d_delta1)/vdsat/vdsat);
d_myarg_d_delta2=((vdsat*d_vdsc_d_delta2-vdsc*d_vdsat_d_delta2)/vdsat/vdsat);
d_myarg_d_nd=((vdsat*d_vdsc_d_nd-vdsc*d_vdsat_d_nd)/vdsat/vdsat);
d_myarg_d_alpha=((vdsat*d_vdsc_d_alpha-vdsc*d_vdsat_d_alpha)/vdsat/vdsat);
d_myarg_d_vel0=((vdsat*d_vdsc_d_vel0-vdsc*d_vdsat_d_vel0)/vdsat/vdsat);
d_myarg_d_mu0=((vdsat*d_vdsc_d_mu0-vdsc*d_vdsat_d_mu0)/vdsat/vdsat);
d_myarg_d_beta=((vdsat*d_vdsc_d_beta-vdsc*d_vdsat_d_beta)/vdsat/vdsat);
d_myarg_d_mtheta=((vdsat*d_vdsc_d_mtheta-vdsc*d_vdsat_d_mtheta)/vdsat/vdsat);
d_myarg_d_vtheta=((vdsat*d_vdsc_d_vtheta-vdsc*d_vdsat_d_vtheta)/vdsat/vdsat);
d_myarg_d_vtzeta=((vdsat*d_vdsc_d_vtzeta-vdsc*d_vdsat_d_vtzeta)/vdsat/vdsat);
d_myarg_d_dibsat=((vdsat*d_vdsc_d_dibsat-vdsc*d_vdsat_d_dibsat)/vdsat/vdsat);
d_myarg_d_epsilon=((vdsat*d_vdsc_d_epsilon-vdsc*d_vdsat_d_epsilon)/vdsat/vdsat);
d_myarg_d_vzeta=((vdsat*d_vdsc_d_vzeta-vdsc*d_vdsat_d_vzeta)/vdsat/vdsat);
d_myarg_d_lambda=((vdsat*d_vdsc_d_lambda-vdsc*d_vdsat_d_lambda)/vdsat/vdsat);
d_myarg_d_ngf=((vdsat*d_vdsc_d_ngf-vdsc*d_vdsat_d_ngf)/vdsat/vdsat);
d_myarg_d_type=((vdsat*d_vdsc_d_type-vdsc*d_vdsat_d_type)/vdsat/vdsat);
myarg=(vdsc/vdsat);
d_fsat_d_vgsin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vgsin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vgsin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vdsin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vdsin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vdsin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_qcbflag=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_qcbflag-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_qcbflag))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vcin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vcin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vcin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vbin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vbin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vbin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_qgsflag=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_qgsflag-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_qgsflag))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_tambin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_tambin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_tambin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_tnomin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_tnomin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_tnomin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_phitin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_phitin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_phitin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_w=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_w-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_w))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_lin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_lin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_lin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cgin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cgin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cgin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cs=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cs-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cs))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cc=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cc-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cc))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cb=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cb-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cb))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vto=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vto-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vto))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_ss=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_ss-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_ss))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_delta1=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_delta1-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_delta1))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_delta2=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_delta2-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_delta2))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_nd=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_nd-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_nd))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_alpha=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_alpha-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_alpha))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vel0=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vel0-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vel0))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_mu0=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_mu0-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_mu0))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_beta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_beta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_beta)+((absfunc(myarg)==0.0)?0.0:(log(absfunc(myarg)*pow(absfunc(myarg),beta))))+(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(log((1.0+pow(absfunc(myarg),beta))*pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)))))*(-1.0/beta/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_mtheta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_mtheta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_mtheta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vtheta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vtheta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vtheta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vtzeta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vtzeta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vtzeta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_dibsat=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_dibsat-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_dibsat))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_epsilon=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_epsilon-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_epsilon))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vzeta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vzeta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vzeta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_lambda=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_lambda-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_lambda))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_ngf=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_ngf-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_ngf))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_type=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_type-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_type))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
fsat=(myarg/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_vel_d_vgsin=((vxf*d_fsat_d_vgsin)+(d_vxf_d_vgsin*fsat));
d_vel_d_vdsin=((vxf*d_fsat_d_vdsin)+(d_vxf_d_vdsin*fsat));
d_vel_d_qcbflag=((vxf*d_fsat_d_qcbflag)+(d_vxf_d_qcbflag*fsat));
d_vel_d_vcin=((vxf*d_fsat_d_vcin)+(d_vxf_d_vcin*fsat));
d_vel_d_vbin=((vxf*d_fsat_d_vbin)+(d_vxf_d_vbin*fsat));
d_vel_d_qgsflag=((vxf*d_fsat_d_qgsflag)+(d_vxf_d_qgsflag*fsat));
d_vel_d_tambin=((vxf*d_fsat_d_tambin)+(d_vxf_d_tambin*fsat));
d_vel_d_tnomin=((vxf*d_fsat_d_tnomin)+(d_vxf_d_tnomin*fsat));
d_vel_d_phitin=((vxf*d_fsat_d_phitin)+(d_vxf_d_phitin*fsat));
d_vel_d_w=((vxf*d_fsat_d_w)+(d_vxf_d_w*fsat));
d_vel_d_lin=((vxf*d_fsat_d_lin)+(d_vxf_d_lin*fsat));
d_vel_d_cgin=((vxf*d_fsat_d_cgin)+(d_vxf_d_cgin*fsat));
d_vel_d_cs=((vxf*d_fsat_d_cs)+(d_vxf_d_cs*fsat));
d_vel_d_cc=((vxf*d_fsat_d_cc)+(d_vxf_d_cc*fsat));
d_vel_d_cb=((vxf*d_fsat_d_cb)+(d_vxf_d_cb*fsat));
d_vel_d_vto=((vxf*d_fsat_d_vto)+(d_vxf_d_vto*fsat));
d_vel_d_ss=((vxf*d_fsat_d_ss)+(d_vxf_d_ss*fsat));
d_vel_d_delta1=((vxf*d_fsat_d_delta1)+(d_vxf_d_delta1*fsat));
d_vel_d_delta2=((vxf*d_fsat_d_delta2)+(d_vxf_d_delta2*fsat));
d_vel_d_nd=((vxf*d_fsat_d_nd)+(d_vxf_d_nd*fsat));
d_vel_d_alpha=((vxf*d_fsat_d_alpha)+(d_vxf_d_alpha*fsat));
d_vel_d_vel0=((vxf*d_fsat_d_vel0)+(d_vxf_d_vel0*fsat));
d_vel_d_mu0=((vxf*d_fsat_d_mu0)+(d_vxf_d_mu0*fsat));
d_vel_d_beta=((vxf*d_fsat_d_beta)+(d_vxf_d_beta*fsat));
d_vel_d_mtheta=((vxf*d_fsat_d_mtheta)+(d_vxf_d_mtheta*fsat));
d_vel_d_vtheta=((vxf*d_fsat_d_vtheta)+(d_vxf_d_vtheta*fsat));
d_vel_d_vtzeta=((vxf*d_fsat_d_vtzeta)+(d_vxf_d_vtzeta*fsat));
d_vel_d_dibsat=((vxf*d_fsat_d_dibsat)+(d_vxf_d_dibsat*fsat));
d_vel_d_epsilon=((vxf*d_fsat_d_epsilon)+(d_vxf_d_epsilon*fsat));
d_vel_d_vzeta=((vxf*d_fsat_d_vzeta)+(d_vxf_d_vzeta*fsat));
d_vel_d_lambda=((vxf*d_fsat_d_lambda)+(d_vxf_d_lambda*fsat));
d_vel_d_ngf=((vxf*d_fsat_d_ngf)+(d_vxf_d_ngf*fsat));
d_vel_d_type=((vxf*d_fsat_d_type)+(d_vxf_d_type*fsat));
vel=(vxf*fsat);
d_idsout_d_vgsin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vgsin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vgsin+d_qinvd_d_vgsin))*vel));
d_idsout_d_vdsin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vdsin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vdsin+d_qinvd_d_vdsin))*vel));
d_idsout_d_qcbflag=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_qcbflag)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_qcbflag+d_qinvd_d_qcbflag))*vel));
d_idsout_d_vcin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vcin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vcin+d_qinvd_d_vcin))*vel));
d_idsout_d_vbin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vbin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vbin+d_qinvd_d_vbin))*vel));
d_idsout_d_qgsflag=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_qgsflag)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_qgsflag+d_qinvd_d_qgsflag))*vel));
d_idsout_d_tambin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_tambin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_tambin+d_qinvd_d_tambin))*vel));
d_idsout_d_tnomin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_tnomin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_tnomin+d_qinvd_d_tnomin))*vel));
d_idsout_d_phitin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_phitin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_phitin+d_qinvd_d_phitin))*vel));
d_idsout_d_w=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_w)+((((((type*w)*ngf)*0.5)*(d_qinvs_d_w+d_qinvd_d_w))+((((type)*ngf)*0.5)*(qinvs+qinvd)))*vel));
d_idsout_d_lin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_lin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_lin+d_qinvd_d_lin))*vel));
d_idsout_d_cgin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cgin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cgin+d_qinvd_d_cgin))*vel));
d_idsout_d_cs=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cs)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cs+d_qinvd_d_cs))*vel));
d_idsout_d_cc=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cc)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cc+d_qinvd_d_cc))*vel));
d_idsout_d_cb=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cb)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cb+d_qinvd_d_cb))*vel));
d_idsout_d_vto=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vto)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vto+d_qinvd_d_vto))*vel));
d_idsout_d_ss=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_ss)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_ss+d_qinvd_d_ss))*vel));
d_idsout_d_delta1=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_delta1)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_delta1+d_qinvd_d_delta1))*vel));
d_idsout_d_delta2=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_delta2)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_delta2+d_qinvd_d_delta2))*vel));
d_idsout_d_nd=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_nd)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_nd+d_qinvd_d_nd))*vel));
d_idsout_d_alpha=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_alpha)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_alpha+d_qinvd_d_alpha))*vel));
d_idsout_d_vel0=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vel0)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vel0+d_qinvd_d_vel0))*vel));
d_idsout_d_mu0=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_mu0)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_mu0+d_qinvd_d_mu0))*vel));
d_idsout_d_beta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_beta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_beta+d_qinvd_d_beta))*vel));
d_idsout_d_mtheta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_mtheta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_mtheta+d_qinvd_d_mtheta))*vel));
d_idsout_d_vtheta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vtheta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vtheta+d_qinvd_d_vtheta))*vel));
d_idsout_d_vtzeta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vtzeta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vtzeta+d_qinvd_d_vtzeta))*vel));
d_idsout_d_dibsat=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_dibsat)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_dibsat+d_qinvd_d_dibsat))*vel));
d_idsout_d_epsilon=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_epsilon)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_epsilon+d_qinvd_d_epsilon))*vel));
d_idsout_d_vzeta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vzeta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vzeta+d_qinvd_d_vzeta))*vel));
d_idsout_d_lambda=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_lambda)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_lambda+d_qinvd_d_lambda))*vel));
d_idsout_d_ngf=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_ngf)+((((((type*w)*ngf)*0.5)*(d_qinvs_d_ngf+d_qinvd_d_ngf))+((((type*w))*0.5)*(qinvs+qinvd)))*vel));
d_idsout_d_type=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_type)+((((((type*w)*ngf)*0.5)*(d_qinvs_d_type+d_qinvd_d_type))+((((w)*ngf)*0.5)*(qinvs+qinvd)))*vel));
idsout=(((((type*w)*ngf)*0.5)*(qinvs+qinvd))*vel);
d_n0_d_vgsin=0.0;
d_n0_d_vdsin=0.0;
d_n0_d_qcbflag=0.0;
d_n0_d_vcin=0.0;
d_n0_d_vbin=0.0;
d_n0_d_qgsflag=0.0;
d_n0_d_tambin=0.0;
d_n0_d_tnomin=0.0;
d_n0_d_phitin=(-ss*(2.30258509299404568401)/(2.30258509299404568401*phitin)/(2.30258509299404568401*phitin));
d_n0_d_w=0.0;
d_n0_d_lin=0.0;
d_n0_d_cgin=0.0;
d_n0_d_cs=0.0;
d_n0_d_cc=0.0;
d_n0_d_cb=0.0;
d_n0_d_vto=0.0;
d_n0_d_ss=(1.0/(2.30258509299404568401*phitin));
d_n0_d_delta1=0.0;
d_n0_d_delta2=0.0;
d_n0_d_nd=0.0;
d_n0_d_alpha=0.0;
d_n0_d_vel0=0.0;
d_n0_d_mu0=0.0;
d_n0_d_beta=0.0;
d_n0_d_mtheta=0.0;
d_n0_d_vtheta=0.0;
d_n0_d_vtzeta=0.0;
d_n0_d_dibsat=0.0;
d_n0_d_epsilon=0.0;
d_n0_d_vzeta=0.0;
d_n0_d_lambda=0.0;
d_n0_d_ngf=0.0;
d_n0_d_type=0.0;
n0=(ss/(2.30258509299404568401*phitin));
d_two_n_phit0_d_vgsin=((2.0*d_n0_d_vgsin)*phitin);
d_two_n_phit0_d_vdsin=((2.0*d_n0_d_vdsin)*phitin);
d_two_n_phit0_d_qcbflag=((2.0*d_n0_d_qcbflag)*phitin);
d_two_n_phit0_d_vcin=((2.0*d_n0_d_vcin)*phitin);
d_two_n_phit0_d_vbin=((2.0*d_n0_d_vbin)*phitin);
d_two_n_phit0_d_qgsflag=((2.0*d_n0_d_qgsflag)*phitin);
d_two_n_phit0_d_tambin=((2.0*d_n0_d_tambin)*phitin);
d_two_n_phit0_d_tnomin=((2.0*d_n0_d_tnomin)*phitin);
d_two_n_phit0_d_phitin=((2.0*n0)+phitin*(2.0*d_n0_d_phitin));
d_two_n_phit0_d_w=((2.0*d_n0_d_w)*phitin);
d_two_n_phit0_d_lin=((2.0*d_n0_d_lin)*phitin);
d_two_n_phit0_d_cgin=((2.0*d_n0_d_cgin)*phitin);
d_two_n_phit0_d_cs=((2.0*d_n0_d_cs)*phitin);
d_two_n_phit0_d_cc=((2.0*d_n0_d_cc)*phitin);
d_two_n_phit0_d_cb=((2.0*d_n0_d_cb)*phitin);
d_two_n_phit0_d_vto=((2.0*d_n0_d_vto)*phitin);
d_two_n_phit0_d_ss=((2.0*d_n0_d_ss)*phitin);
d_two_n_phit0_d_delta1=((2.0*d_n0_d_delta1)*phitin);
d_two_n_phit0_d_delta2=((2.0*d_n0_d_delta2)*phitin);
d_two_n_phit0_d_nd=((2.0*d_n0_d_nd)*phitin);
d_two_n_phit0_d_alpha=((2.0*d_n0_d_alpha)*phitin);
d_two_n_phit0_d_vel0=((2.0*d_n0_d_vel0)*phitin);
d_two_n_phit0_d_mu0=((2.0*d_n0_d_mu0)*phitin);
d_two_n_phit0_d_beta=((2.0*d_n0_d_beta)*phitin);
d_two_n_phit0_d_mtheta=((2.0*d_n0_d_mtheta)*phitin);
d_two_n_phit0_d_vtheta=((2.0*d_n0_d_vtheta)*phitin);
d_two_n_phit0_d_vtzeta=((2.0*d_n0_d_vtzeta)*phitin);
d_two_n_phit0_d_dibsat=((2.0*d_n0_d_dibsat)*phitin);
d_two_n_phit0_d_epsilon=((2.0*d_n0_d_epsilon)*phitin);
d_two_n_phit0_d_vzeta=((2.0*d_n0_d_vzeta)*phitin);
d_two_n_phit0_d_lambda=((2.0*d_n0_d_lambda)*phitin);
d_two_n_phit0_d_ngf=((2.0*d_n0_d_ngf)*phitin);
d_two_n_phit0_d_type=((2.0*d_n0_d_type)*phitin);
two_n_phit0=((2.0*n0)*phitin);
d_qref0_d_vgsin=(cgin*d_two_n_phit0_d_vgsin);
d_qref0_d_vdsin=(cgin*d_two_n_phit0_d_vdsin);
d_qref0_d_qcbflag=(cgin*d_two_n_phit0_d_qcbflag);
d_qref0_d_vcin=(cgin*d_two_n_phit0_d_vcin);
d_qref0_d_vbin=(cgin*d_two_n_phit0_d_vbin);
d_qref0_d_qgsflag=(cgin*d_two_n_phit0_d_qgsflag);
d_qref0_d_tambin=(cgin*d_two_n_phit0_d_tambin);
d_qref0_d_tnomin=(cgin*d_two_n_phit0_d_tnomin);
d_qref0_d_phitin=(cgin*d_two_n_phit0_d_phitin);
d_qref0_d_w=(cgin*d_two_n_phit0_d_w);
d_qref0_d_lin=(cgin*d_two_n_phit0_d_lin);
d_qref0_d_cgin=(cgin*d_two_n_phit0_d_cgin+two_n_phit0);
d_qref0_d_cs=(cgin*d_two_n_phit0_d_cs);
d_qref0_d_cc=(cgin*d_two_n_phit0_d_cc);
d_qref0_d_cb=(cgin*d_two_n_phit0_d_cb);
d_qref0_d_vto=(cgin*d_two_n_phit0_d_vto);
d_qref0_d_ss=(cgin*d_two_n_phit0_d_ss);
d_qref0_d_delta1=(cgin*d_two_n_phit0_d_delta1);
d_qref0_d_delta2=(cgin*d_two_n_phit0_d_delta2);
d_qref0_d_nd=(cgin*d_two_n_phit0_d_nd);
d_qref0_d_alpha=(cgin*d_two_n_phit0_d_alpha);
d_qref0_d_vel0=(cgin*d_two_n_phit0_d_vel0);
d_qref0_d_mu0=(cgin*d_two_n_phit0_d_mu0);
d_qref0_d_beta=(cgin*d_two_n_phit0_d_beta);
d_qref0_d_mtheta=(cgin*d_two_n_phit0_d_mtheta);
d_qref0_d_vtheta=(cgin*d_two_n_phit0_d_vtheta);
d_qref0_d_vtzeta=(cgin*d_two_n_phit0_d_vtzeta);
d_qref0_d_dibsat=(cgin*d_two_n_phit0_d_dibsat);
d_qref0_d_epsilon=(cgin*d_two_n_phit0_d_epsilon);
d_qref0_d_vzeta=(cgin*d_two_n_phit0_d_vzeta);
d_qref0_d_lambda=(cgin*d_two_n_phit0_d_lambda);
d_qref0_d_ngf=(cgin*d_two_n_phit0_d_ngf);
d_qref0_d_type=(cgin*d_two_n_phit0_d_type);
qref0=(cgin*two_n_phit0);
d_myarg0_d_vgsin=(d_vtof_d_vgsin-(d_alpha_phit_d_vgsin/2.0));
d_myarg0_d_vdsin=(d_vtof_d_vdsin-(d_alpha_phit_d_vdsin/2.0));
d_myarg0_d_qcbflag=(d_vtof_d_qcbflag-(d_alpha_phit_d_qcbflag/2.0));
d_myarg0_d_vcin=(d_vtof_d_vcin-(d_alpha_phit_d_vcin/2.0));
d_myarg0_d_vbin=(d_vtof_d_vbin-(d_alpha_phit_d_vbin/2.0));
d_myarg0_d_qgsflag=(d_vtof_d_qgsflag-(d_alpha_phit_d_qgsflag/2.0));
d_myarg0_d_tambin=(d_vtof_d_tambin-(d_alpha_phit_d_tambin/2.0));
d_myarg0_d_tnomin=(d_vtof_d_tnomin-(d_alpha_phit_d_tnomin/2.0));
d_myarg0_d_phitin=(d_vtof_d_phitin-(d_alpha_phit_d_phitin/2.0));
d_myarg0_d_w=(d_vtof_d_w-(d_alpha_phit_d_w/2.0));
d_myarg0_d_lin=(d_vtof_d_lin-(d_alpha_phit_d_lin/2.0));
d_myarg0_d_cgin=(d_vtof_d_cgin-(d_alpha_phit_d_cgin/2.0));
d_myarg0_d_cs=(d_vtof_d_cs-(d_alpha_phit_d_cs/2.0));
d_myarg0_d_cc=(d_vtof_d_cc-(d_alpha_phit_d_cc/2.0));
d_myarg0_d_cb=(d_vtof_d_cb-(d_alpha_phit_d_cb/2.0));
d_myarg0_d_vto=(d_vtof_d_vto-(d_alpha_phit_d_vto/2.0));
d_myarg0_d_ss=(d_vtof_d_ss-(d_alpha_phit_d_ss/2.0));
d_myarg0_d_delta1=(d_vtof_d_delta1-(d_alpha_phit_d_delta1/2.0));
d_myarg0_d_delta2=(d_vtof_d_delta2-(d_alpha_phit_d_delta2/2.0));
d_myarg0_d_nd=(d_vtof_d_nd-(d_alpha_phit_d_nd/2.0));
d_myarg0_d_alpha=(d_vtof_d_alpha-(d_alpha_phit_d_alpha/2.0));
d_myarg0_d_vel0=(d_vtof_d_vel0-(d_alpha_phit_d_vel0/2.0));
d_myarg0_d_mu0=(d_vtof_d_mu0-(d_alpha_phit_d_mu0/2.0));
d_myarg0_d_beta=(d_vtof_d_beta-(d_alpha_phit_d_beta/2.0));
d_myarg0_d_mtheta=(d_vtof_d_mtheta-(d_alpha_phit_d_mtheta/2.0));
d_myarg0_d_vtheta=(d_vtof_d_vtheta-(d_alpha_phit_d_vtheta/2.0));
d_myarg0_d_vtzeta=(d_vtof_d_vtzeta-(d_alpha_phit_d_vtzeta/2.0));
d_myarg0_d_dibsat=(d_vtof_d_dibsat-(d_alpha_phit_d_dibsat/2.0));
d_myarg0_d_epsilon=(d_vtof_d_epsilon-(d_alpha_phit_d_epsilon/2.0));
d_myarg0_d_vzeta=(d_vtof_d_vzeta-(d_alpha_phit_d_vzeta/2.0));
d_myarg0_d_lambda=(d_vtof_d_lambda-(d_alpha_phit_d_lambda/2.0));
d_myarg0_d_ngf=(d_vtof_d_ngf-(d_alpha_phit_d_ngf/2.0));
d_myarg0_d_type=(d_vtof_d_type-(d_alpha_phit_d_type/2.0));
myarg0=(vtof-(alpha_phit/2.0));
d_exparg0_d_vgsin=((alpha_phit*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-d_myarg0_d_vgsin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg0_d_vdsin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-d_myarg0_d_vdsin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg0_d_qcbflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-d_myarg0_d_qcbflag)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg0_d_vcin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-d_myarg0_d_vcin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg0_d_vbin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-d_myarg0_d_vbin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg0_d_qgsflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-d_myarg0_d_qgsflag)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg0_d_tambin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-d_myarg0_d_tambin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg0_d_tnomin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-d_myarg0_d_tnomin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg0_d_phitin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-d_myarg0_d_phitin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg0_d_w=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-d_myarg0_d_w)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg0_d_lin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-d_myarg0_d_lin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg0_d_cgin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-d_myarg0_d_cgin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg0_d_cs=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-d_myarg0_d_cs)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg0_d_cc=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-d_myarg0_d_cc)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg0_d_cb=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-d_myarg0_d_cb)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg0_d_vto=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-d_myarg0_d_vto)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg0_d_ss=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-d_myarg0_d_ss)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg0_d_delta1=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-d_myarg0_d_delta1)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg0_d_delta2=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-d_myarg0_d_delta2)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg0_d_nd=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-d_myarg0_d_nd)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg0_d_alpha=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-d_myarg0_d_alpha)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg0_d_vel0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-d_myarg0_d_vel0)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg0_d_mu0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-d_myarg0_d_mu0)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg0_d_beta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-d_myarg0_d_beta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg0_d_mtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-d_myarg0_d_mtheta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-d_myarg0_d_vtheta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-d_myarg0_d_vtzeta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg0_d_dibsat=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-d_myarg0_d_dibsat)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg0_d_epsilon=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-d_myarg0_d_epsilon)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg0_d_vzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-d_myarg0_d_vzeta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg0_d_lambda=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-d_myarg0_d_lambda)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg0_d_ngf=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-d_myarg0_d_ngf)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg0_d_type=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-d_myarg0_d_type)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg0=((mmax(vgsin,vgdin)-myarg0)/alpha_phit);
if((exparg0>50.0))
{
d_ff0_d_vgsin=0.0;
d_ff0_d_vdsin=0.0;
d_ff0_d_qcbflag=0.0;
d_ff0_d_vcin=0.0;
d_ff0_d_vbin=0.0;
d_ff0_d_qgsflag=0.0;
d_ff0_d_tambin=0.0;
d_ff0_d_tnomin=0.0;
d_ff0_d_phitin=0.0;
d_ff0_d_w=0.0;
d_ff0_d_lin=0.0;
d_ff0_d_cgin=0.0;
d_ff0_d_cs=0.0;
d_ff0_d_cc=0.0;
d_ff0_d_cb=0.0;
d_ff0_d_vto=0.0;
d_ff0_d_ss=0.0;
d_ff0_d_delta1=0.0;
d_ff0_d_delta2=0.0;
d_ff0_d_nd=0.0;
d_ff0_d_alpha=0.0;
d_ff0_d_vel0=0.0;
d_ff0_d_mu0=0.0;
d_ff0_d_beta=0.0;
d_ff0_d_mtheta=0.0;
d_ff0_d_vtheta=0.0;
d_ff0_d_vtzeta=0.0;
d_ff0_d_dibsat=0.0;
d_ff0_d_epsilon=0.0;
d_ff0_d_vzeta=0.0;
d_ff0_d_lambda=0.0;
d_ff0_d_ngf=0.0;
d_ff0_d_type=0.0;
ff0=0.0;
}
else
{
if((exparg0<(-50.0)))
{
d_ff0_d_vgsin=0.0;
d_ff0_d_vdsin=0.0;
d_ff0_d_qcbflag=0.0;
d_ff0_d_vcin=0.0;
d_ff0_d_vbin=0.0;
d_ff0_d_qgsflag=0.0;
d_ff0_d_tambin=0.0;
d_ff0_d_tnomin=0.0;
d_ff0_d_phitin=0.0;
d_ff0_d_w=0.0;
d_ff0_d_lin=0.0;
d_ff0_d_cgin=0.0;
d_ff0_d_cs=0.0;
d_ff0_d_cc=0.0;
d_ff0_d_cb=0.0;
d_ff0_d_vto=0.0;
d_ff0_d_ss=0.0;
d_ff0_d_delta1=0.0;
d_ff0_d_delta2=0.0;
d_ff0_d_nd=0.0;
d_ff0_d_alpha=0.0;
d_ff0_d_vel0=0.0;
d_ff0_d_mu0=0.0;
d_ff0_d_beta=0.0;
d_ff0_d_mtheta=0.0;
d_ff0_d_vtheta=0.0;
d_ff0_d_vtzeta=0.0;
d_ff0_d_dibsat=0.0;
d_ff0_d_epsilon=0.0;
d_ff0_d_vzeta=0.0;
d_ff0_d_lambda=0.0;
d_ff0_d_ngf=0.0;
d_ff0_d_type=0.0;
ff0=1.0;
}
else
{
d_ff0_d_vgsin=(-exp(exparg0)*d_exparg0_d_vgsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vdsin=(-exp(exparg0)*d_exparg0_d_vdsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_qcbflag=(-exp(exparg0)*d_exparg0_d_qcbflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vcin=(-exp(exparg0)*d_exparg0_d_vcin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vbin=(-exp(exparg0)*d_exparg0_d_vbin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_qgsflag=(-exp(exparg0)*d_exparg0_d_qgsflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_tambin=(-exp(exparg0)*d_exparg0_d_tambin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_tnomin=(-exp(exparg0)*d_exparg0_d_tnomin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_phitin=(-exp(exparg0)*d_exparg0_d_phitin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_w=(-exp(exparg0)*d_exparg0_d_w/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_lin=(-exp(exparg0)*d_exparg0_d_lin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cgin=(-exp(exparg0)*d_exparg0_d_cgin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cs=(-exp(exparg0)*d_exparg0_d_cs/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cc=(-exp(exparg0)*d_exparg0_d_cc/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cb=(-exp(exparg0)*d_exparg0_d_cb/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vto=(-exp(exparg0)*d_exparg0_d_vto/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_ss=(-exp(exparg0)*d_exparg0_d_ss/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_delta1=(-exp(exparg0)*d_exparg0_d_delta1/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_delta2=(-exp(exparg0)*d_exparg0_d_delta2/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_nd=(-exp(exparg0)*d_exparg0_d_nd/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_alpha=(-exp(exparg0)*d_exparg0_d_alpha/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vel0=(-exp(exparg0)*d_exparg0_d_vel0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_mu0=(-exp(exparg0)*d_exparg0_d_mu0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_beta=(-exp(exparg0)*d_exparg0_d_beta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_mtheta=(-exp(exparg0)*d_exparg0_d_mtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vtheta=(-exp(exparg0)*d_exparg0_d_vtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vtzeta=(-exp(exparg0)*d_exparg0_d_vtzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_dibsat=(-exp(exparg0)*d_exparg0_d_dibsat/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_epsilon=(-exp(exparg0)*d_exparg0_d_epsilon/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vzeta=(-exp(exparg0)*d_exparg0_d_vzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_lambda=(-exp(exparg0)*d_exparg0_d_lambda/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_ngf=(-exp(exparg0)*d_exparg0_d_ngf/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_type=(-exp(exparg0)*d_exparg0_d_type/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
ff0=(1.0/(1.0+exp(exparg0)));
}
}
d_eta0_d_vgsin=((two_n_phit0*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-(d_vtof_d_vgsin-(((0.1*alpha_phit)*d_ff0_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_eta0_d_vdsin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-(d_vtof_d_vdsin-(((0.1*alpha_phit)*d_ff0_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_eta0_d_qcbflag=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-(d_vtof_d_qcbflag-(((0.1*alpha_phit)*d_ff0_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_eta0_d_vcin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-(d_vtof_d_vcin-(((0.1*alpha_phit)*d_ff0_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_eta0_d_vbin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-(d_vtof_d_vbin-(((0.1*alpha_phit)*d_ff0_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_eta0_d_qgsflag=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-(d_vtof_d_qgsflag-(((0.1*alpha_phit)*d_ff0_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_eta0_d_tambin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-(d_vtof_d_tambin-(((0.1*alpha_phit)*d_ff0_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_eta0_d_tnomin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-(d_vtof_d_tnomin-(((0.1*alpha_phit)*d_ff0_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_eta0_d_phitin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-(d_vtof_d_phitin-(((0.1*alpha_phit)*d_ff0_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_eta0_d_w=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-(d_vtof_d_w-(((0.1*alpha_phit)*d_ff0_d_w)+((0.1*d_alpha_phit_d_w)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_eta0_d_lin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-(d_vtof_d_lin-(((0.1*alpha_phit)*d_ff0_d_lin)+((0.1*d_alpha_phit_d_lin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_eta0_d_cgin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-(d_vtof_d_cgin-(((0.1*alpha_phit)*d_ff0_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_eta0_d_cs=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-(d_vtof_d_cs-(((0.1*alpha_phit)*d_ff0_d_cs)+((0.1*d_alpha_phit_d_cs)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_eta0_d_cc=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-(d_vtof_d_cc-(((0.1*alpha_phit)*d_ff0_d_cc)+((0.1*d_alpha_phit_d_cc)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_eta0_d_cb=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-(d_vtof_d_cb-(((0.1*alpha_phit)*d_ff0_d_cb)+((0.1*d_alpha_phit_d_cb)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_eta0_d_vto=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-(d_vtof_d_vto-(((0.1*alpha_phit)*d_ff0_d_vto)+((0.1*d_alpha_phit_d_vto)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_eta0_d_ss=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-(d_vtof_d_ss-(((0.1*alpha_phit)*d_ff0_d_ss)+((0.1*d_alpha_phit_d_ss)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_eta0_d_delta1=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-(d_vtof_d_delta1-(((0.1*alpha_phit)*d_ff0_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_eta0_d_delta2=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-(d_vtof_d_delta2-(((0.1*alpha_phit)*d_ff0_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_eta0_d_nd=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-(d_vtof_d_nd-(((0.1*alpha_phit)*d_ff0_d_nd)+((0.1*d_alpha_phit_d_nd)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_eta0_d_alpha=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-(d_vtof_d_alpha-(((0.1*alpha_phit)*d_ff0_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_eta0_d_vel0=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-(d_vtof_d_vel0-(((0.1*alpha_phit)*d_ff0_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_eta0_d_mu0=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-(d_vtof_d_mu0-(((0.1*alpha_phit)*d_ff0_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_eta0_d_beta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-(d_vtof_d_beta-(((0.1*alpha_phit)*d_ff0_d_beta)+((0.1*d_alpha_phit_d_beta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_eta0_d_mtheta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-(d_vtof_d_mtheta-(((0.1*alpha_phit)*d_ff0_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_eta0_d_vtheta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-(d_vtof_d_vtheta-(((0.1*alpha_phit)*d_ff0_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_eta0_d_vtzeta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-(d_vtof_d_vtzeta-(((0.1*alpha_phit)*d_ff0_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_eta0_d_dibsat=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-(d_vtof_d_dibsat-(((0.1*alpha_phit)*d_ff0_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_eta0_d_epsilon=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-(d_vtof_d_epsilon-(((0.1*alpha_phit)*d_ff0_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_eta0_d_vzeta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-(d_vtof_d_vzeta-(((0.1*alpha_phit)*d_ff0_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_eta0_d_lambda=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-(d_vtof_d_lambda-(((0.1*alpha_phit)*d_ff0_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_eta0_d_ngf=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-(d_vtof_d_ngf-(((0.1*alpha_phit)*d_ff0_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_eta0_d_type=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-(d_vtof_d_type-(((0.1*alpha_phit)*d_ff0_d_type)+((0.1*d_alpha_phit_d_type)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
eta0=((mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))/two_n_phit0);
if((eta0>50.0))
{
d_qinvv0_d_vgsin=((qref0*d_eta0_d_vgsin)+(d_qref0_d_vgsin*eta0));
d_qinvv0_d_vdsin=((qref0*d_eta0_d_vdsin)+(d_qref0_d_vdsin*eta0));
d_qinvv0_d_qcbflag=((qref0*d_eta0_d_qcbflag)+(d_qref0_d_qcbflag*eta0));
d_qinvv0_d_vcin=((qref0*d_eta0_d_vcin)+(d_qref0_d_vcin*eta0));
d_qinvv0_d_vbin=((qref0*d_eta0_d_vbin)+(d_qref0_d_vbin*eta0));
d_qinvv0_d_qgsflag=((qref0*d_eta0_d_qgsflag)+(d_qref0_d_qgsflag*eta0));
d_qinvv0_d_tambin=((qref0*d_eta0_d_tambin)+(d_qref0_d_tambin*eta0));
d_qinvv0_d_tnomin=((qref0*d_eta0_d_tnomin)+(d_qref0_d_tnomin*eta0));
d_qinvv0_d_phitin=((qref0*d_eta0_d_phitin)+(d_qref0_d_phitin*eta0));
d_qinvv0_d_w=((qref0*d_eta0_d_w)+(d_qref0_d_w*eta0));
d_qinvv0_d_lin=((qref0*d_eta0_d_lin)+(d_qref0_d_lin*eta0));
d_qinvv0_d_cgin=((qref0*d_eta0_d_cgin)+(d_qref0_d_cgin*eta0));
d_qinvv0_d_cs=((qref0*d_eta0_d_cs)+(d_qref0_d_cs*eta0));
d_qinvv0_d_cc=((qref0*d_eta0_d_cc)+(d_qref0_d_cc*eta0));
d_qinvv0_d_cb=((qref0*d_eta0_d_cb)+(d_qref0_d_cb*eta0));
d_qinvv0_d_vto=((qref0*d_eta0_d_vto)+(d_qref0_d_vto*eta0));
d_qinvv0_d_ss=((qref0*d_eta0_d_ss)+(d_qref0_d_ss*eta0));
d_qinvv0_d_delta1=((qref0*d_eta0_d_delta1)+(d_qref0_d_delta1*eta0));
d_qinvv0_d_delta2=((qref0*d_eta0_d_delta2)+(d_qref0_d_delta2*eta0));
d_qinvv0_d_nd=((qref0*d_eta0_d_nd)+(d_qref0_d_nd*eta0));
d_qinvv0_d_alpha=((qref0*d_eta0_d_alpha)+(d_qref0_d_alpha*eta0));
d_qinvv0_d_vel0=((qref0*d_eta0_d_vel0)+(d_qref0_d_vel0*eta0));
d_qinvv0_d_mu0=((qref0*d_eta0_d_mu0)+(d_qref0_d_mu0*eta0));
d_qinvv0_d_beta=((qref0*d_eta0_d_beta)+(d_qref0_d_beta*eta0));
d_qinvv0_d_mtheta=((qref0*d_eta0_d_mtheta)+(d_qref0_d_mtheta*eta0));
d_qinvv0_d_vtheta=((qref0*d_eta0_d_vtheta)+(d_qref0_d_vtheta*eta0));
d_qinvv0_d_vtzeta=((qref0*d_eta0_d_vtzeta)+(d_qref0_d_vtzeta*eta0));
d_qinvv0_d_dibsat=((qref0*d_eta0_d_dibsat)+(d_qref0_d_dibsat*eta0));
d_qinvv0_d_epsilon=((qref0*d_eta0_d_epsilon)+(d_qref0_d_epsilon*eta0));
d_qinvv0_d_vzeta=((qref0*d_eta0_d_vzeta)+(d_qref0_d_vzeta*eta0));
d_qinvv0_d_lambda=((qref0*d_eta0_d_lambda)+(d_qref0_d_lambda*eta0));
d_qinvv0_d_ngf=((qref0*d_eta0_d_ngf)+(d_qref0_d_ngf*eta0));
d_qinvv0_d_type=((qref0*d_eta0_d_type)+(d_qref0_d_type*eta0));
qinvv0=(qref0*eta0);
}
else
{
if((eta0<(-50.0)))
{
d_qinvv0_d_vgsin=0.0;
d_qinvv0_d_vdsin=0.0;
d_qinvv0_d_qcbflag=0.0;
d_qinvv0_d_vcin=0.0;
d_qinvv0_d_vbin=0.0;
d_qinvv0_d_qgsflag=0.0;
d_qinvv0_d_tambin=0.0;
d_qinvv0_d_tnomin=0.0;
d_qinvv0_d_phitin=0.0;
d_qinvv0_d_w=0.0;
d_qinvv0_d_lin=0.0;
d_qinvv0_d_cgin=0.0;
d_qinvv0_d_cs=0.0;
d_qinvv0_d_cc=0.0;
d_qinvv0_d_cb=0.0;
d_qinvv0_d_vto=0.0;
d_qinvv0_d_ss=0.0;
d_qinvv0_d_delta1=0.0;
d_qinvv0_d_delta2=0.0;
d_qinvv0_d_nd=0.0;
d_qinvv0_d_alpha=0.0;
d_qinvv0_d_vel0=0.0;
d_qinvv0_d_mu0=0.0;
d_qinvv0_d_beta=0.0;
d_qinvv0_d_mtheta=0.0;
d_qinvv0_d_vtheta=0.0;
d_qinvv0_d_vtzeta=0.0;
d_qinvv0_d_dibsat=0.0;
d_qinvv0_d_epsilon=0.0;
d_qinvv0_d_vzeta=0.0;
d_qinvv0_d_lambda=0.0;
d_qinvv0_d_ngf=0.0;
d_qinvv0_d_type=0.0;
qinvv0=0;
}
else
{
d_qinvv0_d_vgsin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vgsin)+(d_qref0_d_vgsin*log((1.0+exp(eta0)))));
d_qinvv0_d_vdsin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vdsin)+(d_qref0_d_vdsin*log((1.0+exp(eta0)))));
d_qinvv0_d_qcbflag=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_qcbflag)+(d_qref0_d_qcbflag*log((1.0+exp(eta0)))));
d_qinvv0_d_vcin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vcin)+(d_qref0_d_vcin*log((1.0+exp(eta0)))));
d_qinvv0_d_vbin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vbin)+(d_qref0_d_vbin*log((1.0+exp(eta0)))));
d_qinvv0_d_qgsflag=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_qgsflag)+(d_qref0_d_qgsflag*log((1.0+exp(eta0)))));
d_qinvv0_d_tambin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_tambin)+(d_qref0_d_tambin*log((1.0+exp(eta0)))));
d_qinvv0_d_tnomin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_tnomin)+(d_qref0_d_tnomin*log((1.0+exp(eta0)))));
d_qinvv0_d_phitin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_phitin)+(d_qref0_d_phitin*log((1.0+exp(eta0)))));
d_qinvv0_d_w=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_w)+(d_qref0_d_w*log((1.0+exp(eta0)))));
d_qinvv0_d_lin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_lin)+(d_qref0_d_lin*log((1.0+exp(eta0)))));
d_qinvv0_d_cgin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cgin)+(d_qref0_d_cgin*log((1.0+exp(eta0)))));
d_qinvv0_d_cs=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cs)+(d_qref0_d_cs*log((1.0+exp(eta0)))));
d_qinvv0_d_cc=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cc)+(d_qref0_d_cc*log((1.0+exp(eta0)))));
d_qinvv0_d_cb=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cb)+(d_qref0_d_cb*log((1.0+exp(eta0)))));
d_qinvv0_d_vto=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vto)+(d_qref0_d_vto*log((1.0+exp(eta0)))));
d_qinvv0_d_ss=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_ss)+(d_qref0_d_ss*log((1.0+exp(eta0)))));
d_qinvv0_d_delta1=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_delta1)+(d_qref0_d_delta1*log((1.0+exp(eta0)))));
d_qinvv0_d_delta2=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_delta2)+(d_qref0_d_delta2*log((1.0+exp(eta0)))));
d_qinvv0_d_nd=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_nd)+(d_qref0_d_nd*log((1.0+exp(eta0)))));
d_qinvv0_d_alpha=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_alpha)+(d_qref0_d_alpha*log((1.0+exp(eta0)))));
d_qinvv0_d_vel0=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vel0)+(d_qref0_d_vel0*log((1.0+exp(eta0)))));
d_qinvv0_d_mu0=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_mu0)+(d_qref0_d_mu0*log((1.0+exp(eta0)))));
d_qinvv0_d_beta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_beta)+(d_qref0_d_beta*log((1.0+exp(eta0)))));
d_qinvv0_d_mtheta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_mtheta)+(d_qref0_d_mtheta*log((1.0+exp(eta0)))));
d_qinvv0_d_vtheta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vtheta)+(d_qref0_d_vtheta*log((1.0+exp(eta0)))));
d_qinvv0_d_vtzeta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vtzeta)+(d_qref0_d_vtzeta*log((1.0+exp(eta0)))));
d_qinvv0_d_dibsat=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_dibsat)+(d_qref0_d_dibsat*log((1.0+exp(eta0)))));
d_qinvv0_d_epsilon=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_epsilon)+(d_qref0_d_epsilon*log((1.0+exp(eta0)))));
d_qinvv0_d_vzeta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vzeta)+(d_qref0_d_vzeta*log((1.0+exp(eta0)))));
d_qinvv0_d_lambda=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_lambda)+(d_qref0_d_lambda*log((1.0+exp(eta0)))));
d_qinvv0_d_ngf=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_ngf)+(d_qref0_d_ngf*log((1.0+exp(eta0)))));
d_qinvv0_d_type=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_type)+(d_qref0_d_type*log((1.0+exp(eta0)))));
qinvv0=(qref0*log((1.0+exp(eta0))));
}
}
d_muf0_d_vgsin=0.0;
d_muf0_d_vdsin=0.0;
d_muf0_d_qcbflag=0.0;
d_muf0_d_vcin=0.0;
d_muf0_d_vbin=0.0;
d_muf0_d_qgsflag=0.0;
d_muf0_d_tambin=(-mu0*(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(1.0/tnomin)/pow((tambin/tnomin),epsilon)/pow((tambin/tnomin),epsilon));
d_muf0_d_tnomin=(-mu0*(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(-tambin/tnomin/tnomin)/pow((tambin/tnomin),epsilon)/pow((tambin/tnomin),epsilon));
d_muf0_d_phitin=0.0;
d_muf0_d_w=0.0;
d_muf0_d_lin=0.0;
d_muf0_d_cgin=0.0;
d_muf0_d_cs=0.0;
d_muf0_d_cc=0.0;
d_muf0_d_cb=0.0;
d_muf0_d_vto=0.0;
d_muf0_d_ss=0.0;
d_muf0_d_delta1=0.0;
d_muf0_d_delta2=0.0;
d_muf0_d_nd=0.0;
d_muf0_d_alpha=0.0;
d_muf0_d_vel0=0.0;
d_muf0_d_mu0=(1.0/pow((tambin/tnomin),epsilon));
d_muf0_d_beta=0.0;
d_muf0_d_mtheta=0.0;
d_muf0_d_vtheta=0.0;
d_muf0_d_vtzeta=0.0;
d_muf0_d_dibsat=0.0;
d_muf0_d_epsilon=(-mu0*(((tambin/tnomin)==0.0)?0.0:(log((tambin/tnomin)*pow((tambin/tnomin),epsilon))))/pow((tambin/tnomin),epsilon)/pow((tambin/tnomin),epsilon));
d_muf0_d_vzeta=0.0;
d_muf0_d_lambda=0.0;
d_muf0_d_ngf=0.0;
d_muf0_d_type=0.0;
muf0=(mu0/pow((tambin/tnomin),epsilon));
d_vx0_d_vgsin=0.0;
d_vx0_d_vdsin=0.0;
d_vx0_d_qcbflag=0.0;
d_vx0_d_vcin=0.0;
d_vx0_d_vbin=0.0;
d_vx0_d_qgsflag=0.0;
d_vx0_d_tambin=(vel0*(-(1.0+(vzeta*tnomin))*(vzeta)/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))));
d_vx0_d_tnomin=(vel0*((vzeta)/(1.0+(vzeta*tambin))));
d_vx0_d_phitin=0.0;
d_vx0_d_w=0.0;
d_vx0_d_lin=0.0;
d_vx0_d_cgin=0.0;
d_vx0_d_cs=0.0;
d_vx0_d_cc=0.0;
d_vx0_d_cb=0.0;
d_vx0_d_vto=0.0;
d_vx0_d_ss=0.0;
d_vx0_d_delta1=0.0;
d_vx0_d_delta2=0.0;
d_vx0_d_nd=0.0;
d_vx0_d_alpha=0.0;
d_vx0_d_vel0=(((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))));
d_vx0_d_mu0=0.0;
d_vx0_d_beta=0.0;
d_vx0_d_mtheta=0.0;
d_vx0_d_vtheta=0.0;
d_vx0_d_vtzeta=0.0;
d_vx0_d_dibsat=0.0;
d_vx0_d_epsilon=0.0;
d_vx0_d_vzeta=(vel0*(((1.0+(vzeta*tambin))*(tnomin)-(1.0+(vzeta*tnomin))*(tambin))/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))));
d_vx0_d_lambda=0.0;
d_vx0_d_ngf=0.0;
d_vx0_d_type=0.0;
vx0=(vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))));
d_vdsats0_d_vgsin=((muf0*(d_vx0_d_vgsin*lin)-(vx0*lin)*d_muf0_d_vgsin)/muf0/muf0);
d_vdsats0_d_vdsin=((muf0*(d_vx0_d_vdsin*lin)-(vx0*lin)*d_muf0_d_vdsin)/muf0/muf0);
d_vdsats0_d_qcbflag=((muf0*(d_vx0_d_qcbflag*lin)-(vx0*lin)*d_muf0_d_qcbflag)/muf0/muf0);
d_vdsats0_d_vcin=((muf0*(d_vx0_d_vcin*lin)-(vx0*lin)*d_muf0_d_vcin)/muf0/muf0);
d_vdsats0_d_vbin=((muf0*(d_vx0_d_vbin*lin)-(vx0*lin)*d_muf0_d_vbin)/muf0/muf0);
d_vdsats0_d_qgsflag=((muf0*(d_vx0_d_qgsflag*lin)-(vx0*lin)*d_muf0_d_qgsflag)/muf0/muf0);
d_vdsats0_d_tambin=((muf0*(d_vx0_d_tambin*lin)-(vx0*lin)*d_muf0_d_tambin)/muf0/muf0);
d_vdsats0_d_tnomin=((muf0*(d_vx0_d_tnomin*lin)-(vx0*lin)*d_muf0_d_tnomin)/muf0/muf0);
d_vdsats0_d_phitin=((muf0*(d_vx0_d_phitin*lin)-(vx0*lin)*d_muf0_d_phitin)/muf0/muf0);
d_vdsats0_d_w=((muf0*(d_vx0_d_w*lin)-(vx0*lin)*d_muf0_d_w)/muf0/muf0);
d_vdsats0_d_lin=((muf0*(vx0+lin*d_vx0_d_lin)-(vx0*lin)*d_muf0_d_lin)/muf0/muf0);
d_vdsats0_d_cgin=((muf0*(d_vx0_d_cgin*lin)-(vx0*lin)*d_muf0_d_cgin)/muf0/muf0);
d_vdsats0_d_cs=((muf0*(d_vx0_d_cs*lin)-(vx0*lin)*d_muf0_d_cs)/muf0/muf0);
d_vdsats0_d_cc=((muf0*(d_vx0_d_cc*lin)-(vx0*lin)*d_muf0_d_cc)/muf0/muf0);
d_vdsats0_d_cb=((muf0*(d_vx0_d_cb*lin)-(vx0*lin)*d_muf0_d_cb)/muf0/muf0);
d_vdsats0_d_vto=((muf0*(d_vx0_d_vto*lin)-(vx0*lin)*d_muf0_d_vto)/muf0/muf0);
d_vdsats0_d_ss=((muf0*(d_vx0_d_ss*lin)-(vx0*lin)*d_muf0_d_ss)/muf0/muf0);
d_vdsats0_d_delta1=((muf0*(d_vx0_d_delta1*lin)-(vx0*lin)*d_muf0_d_delta1)/muf0/muf0);
d_vdsats0_d_delta2=((muf0*(d_vx0_d_delta2*lin)-(vx0*lin)*d_muf0_d_delta2)/muf0/muf0);
d_vdsats0_d_nd=((muf0*(d_vx0_d_nd*lin)-(vx0*lin)*d_muf0_d_nd)/muf0/muf0);
d_vdsats0_d_alpha=((muf0*(d_vx0_d_alpha*lin)-(vx0*lin)*d_muf0_d_alpha)/muf0/muf0);
d_vdsats0_d_vel0=((muf0*(d_vx0_d_vel0*lin)-(vx0*lin)*d_muf0_d_vel0)/muf0/muf0);
d_vdsats0_d_mu0=((muf0*(d_vx0_d_mu0*lin)-(vx0*lin)*d_muf0_d_mu0)/muf0/muf0);
d_vdsats0_d_beta=((muf0*(d_vx0_d_beta*lin)-(vx0*lin)*d_muf0_d_beta)/muf0/muf0);
d_vdsats0_d_mtheta=((muf0*(d_vx0_d_mtheta*lin)-(vx0*lin)*d_muf0_d_mtheta)/muf0/muf0);
d_vdsats0_d_vtheta=((muf0*(d_vx0_d_vtheta*lin)-(vx0*lin)*d_muf0_d_vtheta)/muf0/muf0);
d_vdsats0_d_vtzeta=((muf0*(d_vx0_d_vtzeta*lin)-(vx0*lin)*d_muf0_d_vtzeta)/muf0/muf0);
d_vdsats0_d_dibsat=((muf0*(d_vx0_d_dibsat*lin)-(vx0*lin)*d_muf0_d_dibsat)/muf0/muf0);
d_vdsats0_d_epsilon=((muf0*(d_vx0_d_epsilon*lin)-(vx0*lin)*d_muf0_d_epsilon)/muf0/muf0);
d_vdsats0_d_vzeta=((muf0*(d_vx0_d_vzeta*lin)-(vx0*lin)*d_muf0_d_vzeta)/muf0/muf0);
d_vdsats0_d_lambda=((muf0*(d_vx0_d_lambda*lin)-(vx0*lin)*d_muf0_d_lambda)/muf0/muf0);
d_vdsats0_d_ngf=((muf0*(d_vx0_d_ngf*lin)-(vx0*lin)*d_muf0_d_ngf)/muf0/muf0);
d_vdsats0_d_type=((muf0*(d_vx0_d_type*lin)-(vx0*lin)*d_muf0_d_type)/muf0/muf0);
vdsats0=((vx0*lin)/muf0);
d_vdsats10_d_vgsin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vgsin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vgsin)/vdsats0/vdsats0))+(d_vdsats0_d_vgsin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vgsin);
d_vdsats10_d_vdsin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vdsin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vdsin)/vdsats0/vdsats0))+(d_vdsats0_d_vdsin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vdsin);
d_vdsats10_d_qcbflag=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_qcbflag)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_qcbflag)/vdsats0/vdsats0))+(d_vdsats0_d_qcbflag*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_qcbflag);
d_vdsats10_d_vcin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vcin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vcin)/vdsats0/vdsats0))+(d_vdsats0_d_vcin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vcin);
d_vdsats10_d_vbin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vbin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vbin)/vdsats0/vdsats0))+(d_vdsats0_d_vbin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vbin);
d_vdsats10_d_qgsflag=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_qgsflag)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_qgsflag)/vdsats0/vdsats0))+(d_vdsats0_d_qgsflag*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_qgsflag);
d_vdsats10_d_tambin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_tambin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_tambin)/vdsats0/vdsats0))+(d_vdsats0_d_tambin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_tambin);
d_vdsats10_d_tnomin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_tnomin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_tnomin)/vdsats0/vdsats0))+(d_vdsats0_d_tnomin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_tnomin);
d_vdsats10_d_phitin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_phitin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_phitin)/vdsats0/vdsats0))+(d_vdsats0_d_phitin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_phitin);
d_vdsats10_d_w=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_w)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_w)/vdsats0/vdsats0))+(d_vdsats0_d_w*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_w);
d_vdsats10_d_lin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_lin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_lin)/vdsats0/vdsats0))+(d_vdsats0_d_lin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_lin);
d_vdsats10_d_cgin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((cgin*(2.0*d_qinvv0_d_cgin)-(2.0*qinvv0))/cgin/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cgin)/vdsats0/vdsats0))+(d_vdsats0_d_cgin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cgin);
d_vdsats10_d_cs=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_cs)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cs)/vdsats0/vdsats0))+(d_vdsats0_d_cs*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cs);
d_vdsats10_d_cc=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_cc)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cc)/vdsats0/vdsats0))+(d_vdsats0_d_cc*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cc);
d_vdsats10_d_cb=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_cb)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cb)/vdsats0/vdsats0))+(d_vdsats0_d_cb*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cb);
d_vdsats10_d_vto=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vto)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vto)/vdsats0/vdsats0))+(d_vdsats0_d_vto*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vto);
d_vdsats10_d_ss=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_ss)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_ss)/vdsats0/vdsats0))+(d_vdsats0_d_ss*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_ss);
d_vdsats10_d_delta1=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_delta1)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_delta1)/vdsats0/vdsats0))+(d_vdsats0_d_delta1*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_delta1);
d_vdsats10_d_delta2=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_delta2)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_delta2)/vdsats0/vdsats0))+(d_vdsats0_d_delta2*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_delta2);
d_vdsats10_d_nd=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_nd)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_nd)/vdsats0/vdsats0))+(d_vdsats0_d_nd*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_nd);
d_vdsats10_d_alpha=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_alpha)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_alpha)/vdsats0/vdsats0))+(d_vdsats0_d_alpha*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_alpha);
d_vdsats10_d_vel0=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vel0)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vel0)/vdsats0/vdsats0))+(d_vdsats0_d_vel0*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vel0);
d_vdsats10_d_mu0=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_mu0)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_mu0)/vdsats0/vdsats0))+(d_vdsats0_d_mu0*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_mu0);
d_vdsats10_d_beta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_beta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_beta)/vdsats0/vdsats0))+(d_vdsats0_d_beta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_beta);
d_vdsats10_d_mtheta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_mtheta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_mtheta)/vdsats0/vdsats0))+(d_vdsats0_d_mtheta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_mtheta);
d_vdsats10_d_vtheta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vtheta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vtheta)/vdsats0/vdsats0))+(d_vdsats0_d_vtheta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vtheta);
d_vdsats10_d_vtzeta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vtzeta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vtzeta)/vdsats0/vdsats0))+(d_vdsats0_d_vtzeta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vtzeta);
d_vdsats10_d_dibsat=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_dibsat)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_dibsat)/vdsats0/vdsats0))+(d_vdsats0_d_dibsat*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_dibsat);
d_vdsats10_d_epsilon=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_epsilon)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_epsilon)/vdsats0/vdsats0))+(d_vdsats0_d_epsilon*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_epsilon);
d_vdsats10_d_vzeta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vzeta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vzeta)/vdsats0/vdsats0))+(d_vdsats0_d_vzeta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vzeta);
d_vdsats10_d_lambda=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_lambda)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_lambda)/vdsats0/vdsats0))+(d_vdsats0_d_lambda*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_lambda);
d_vdsats10_d_ngf=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_ngf)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_ngf)/vdsats0/vdsats0))+(d_vdsats0_d_ngf*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_ngf);
d_vdsats10_d_type=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_type)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_type)/vdsats0/vdsats0))+(d_vdsats0_d_type*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_type);
vdsats10=((vdsats0*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))-vdsats0);
d_vdsat10_d_vgsin=(((vdsats10*(-d_ff0_d_vgsin))+(d_vdsats10_d_vgsin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vgsin)+(d_two_n_phit0_d_vgsin*ff0)));
d_vdsat10_d_vdsin=(((vdsats10*(-d_ff0_d_vdsin))+(d_vdsats10_d_vdsin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vdsin)+(d_two_n_phit0_d_vdsin*ff0)));
d_vdsat10_d_qcbflag=(((vdsats10*(-d_ff0_d_qcbflag))+(d_vdsats10_d_qcbflag*(1.0-ff0)))+((two_n_phit0*d_ff0_d_qcbflag)+(d_two_n_phit0_d_qcbflag*ff0)));
d_vdsat10_d_vcin=(((vdsats10*(-d_ff0_d_vcin))+(d_vdsats10_d_vcin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vcin)+(d_two_n_phit0_d_vcin*ff0)));
d_vdsat10_d_vbin=(((vdsats10*(-d_ff0_d_vbin))+(d_vdsats10_d_vbin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vbin)+(d_two_n_phit0_d_vbin*ff0)));
d_vdsat10_d_qgsflag=(((vdsats10*(-d_ff0_d_qgsflag))+(d_vdsats10_d_qgsflag*(1.0-ff0)))+((two_n_phit0*d_ff0_d_qgsflag)+(d_two_n_phit0_d_qgsflag*ff0)));
d_vdsat10_d_tambin=(((vdsats10*(-d_ff0_d_tambin))+(d_vdsats10_d_tambin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_tambin)+(d_two_n_phit0_d_tambin*ff0)));
d_vdsat10_d_tnomin=(((vdsats10*(-d_ff0_d_tnomin))+(d_vdsats10_d_tnomin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_tnomin)+(d_two_n_phit0_d_tnomin*ff0)));
d_vdsat10_d_phitin=(((vdsats10*(-d_ff0_d_phitin))+(d_vdsats10_d_phitin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_phitin)+(d_two_n_phit0_d_phitin*ff0)));
d_vdsat10_d_w=(((vdsats10*(-d_ff0_d_w))+(d_vdsats10_d_w*(1.0-ff0)))+((two_n_phit0*d_ff0_d_w)+(d_two_n_phit0_d_w*ff0)));
d_vdsat10_d_lin=(((vdsats10*(-d_ff0_d_lin))+(d_vdsats10_d_lin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_lin)+(d_two_n_phit0_d_lin*ff0)));
d_vdsat10_d_cgin=(((vdsats10*(-d_ff0_d_cgin))+(d_vdsats10_d_cgin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cgin)+(d_two_n_phit0_d_cgin*ff0)));
d_vdsat10_d_cs=(((vdsats10*(-d_ff0_d_cs))+(d_vdsats10_d_cs*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cs)+(d_two_n_phit0_d_cs*ff0)));
d_vdsat10_d_cc=(((vdsats10*(-d_ff0_d_cc))+(d_vdsats10_d_cc*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cc)+(d_two_n_phit0_d_cc*ff0)));
d_vdsat10_d_cb=(((vdsats10*(-d_ff0_d_cb))+(d_vdsats10_d_cb*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cb)+(d_two_n_phit0_d_cb*ff0)));
d_vdsat10_d_vto=(((vdsats10*(-d_ff0_d_vto))+(d_vdsats10_d_vto*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vto)+(d_two_n_phit0_d_vto*ff0)));
d_vdsat10_d_ss=(((vdsats10*(-d_ff0_d_ss))+(d_vdsats10_d_ss*(1.0-ff0)))+((two_n_phit0*d_ff0_d_ss)+(d_two_n_phit0_d_ss*ff0)));
d_vdsat10_d_delta1=(((vdsats10*(-d_ff0_d_delta1))+(d_vdsats10_d_delta1*(1.0-ff0)))+((two_n_phit0*d_ff0_d_delta1)+(d_two_n_phit0_d_delta1*ff0)));
d_vdsat10_d_delta2=(((vdsats10*(-d_ff0_d_delta2))+(d_vdsats10_d_delta2*(1.0-ff0)))+((two_n_phit0*d_ff0_d_delta2)+(d_two_n_phit0_d_delta2*ff0)));
d_vdsat10_d_nd=(((vdsats10*(-d_ff0_d_nd))+(d_vdsats10_d_nd*(1.0-ff0)))+((two_n_phit0*d_ff0_d_nd)+(d_two_n_phit0_d_nd*ff0)));
d_vdsat10_d_alpha=(((vdsats10*(-d_ff0_d_alpha))+(d_vdsats10_d_alpha*(1.0-ff0)))+((two_n_phit0*d_ff0_d_alpha)+(d_two_n_phit0_d_alpha*ff0)));
d_vdsat10_d_vel0=(((vdsats10*(-d_ff0_d_vel0))+(d_vdsats10_d_vel0*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vel0)+(d_two_n_phit0_d_vel0*ff0)));
d_vdsat10_d_mu0=(((vdsats10*(-d_ff0_d_mu0))+(d_vdsats10_d_mu0*(1.0-ff0)))+((two_n_phit0*d_ff0_d_mu0)+(d_two_n_phit0_d_mu0*ff0)));
d_vdsat10_d_beta=(((vdsats10*(-d_ff0_d_beta))+(d_vdsats10_d_beta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_beta)+(d_two_n_phit0_d_beta*ff0)));
d_vdsat10_d_mtheta=(((vdsats10*(-d_ff0_d_mtheta))+(d_vdsats10_d_mtheta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_mtheta)+(d_two_n_phit0_d_mtheta*ff0)));
d_vdsat10_d_vtheta=(((vdsats10*(-d_ff0_d_vtheta))+(d_vdsats10_d_vtheta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vtheta)+(d_two_n_phit0_d_vtheta*ff0)));
d_vdsat10_d_vtzeta=(((vdsats10*(-d_ff0_d_vtzeta))+(d_vdsats10_d_vtzeta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vtzeta)+(d_two_n_phit0_d_vtzeta*ff0)));
d_vdsat10_d_dibsat=(((vdsats10*(-d_ff0_d_dibsat))+(d_vdsats10_d_dibsat*(1.0-ff0)))+((two_n_phit0*d_ff0_d_dibsat)+(d_two_n_phit0_d_dibsat*ff0)));
d_vdsat10_d_epsilon=(((vdsats10*(-d_ff0_d_epsilon))+(d_vdsats10_d_epsilon*(1.0-ff0)))+((two_n_phit0*d_ff0_d_epsilon)+(d_two_n_phit0_d_epsilon*ff0)));
d_vdsat10_d_vzeta=(((vdsats10*(-d_ff0_d_vzeta))+(d_vdsats10_d_vzeta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vzeta)+(d_two_n_phit0_d_vzeta*ff0)));
d_vdsat10_d_lambda=(((vdsats10*(-d_ff0_d_lambda))+(d_vdsats10_d_lambda*(1.0-ff0)))+((two_n_phit0*d_ff0_d_lambda)+(d_two_n_phit0_d_lambda*ff0)));
d_vdsat10_d_ngf=(((vdsats10*(-d_ff0_d_ngf))+(d_vdsats10_d_ngf*(1.0-ff0)))+((two_n_phit0*d_ff0_d_ngf)+(d_two_n_phit0_d_ngf*ff0)));
d_vdsat10_d_type=(((vdsats10*(-d_ff0_d_type))+(d_vdsats10_d_type*(1.0-ff0)))+((two_n_phit0*d_ff0_d_type)+(d_two_n_phit0_d_type*ff0)));
vdsat10=((vdsats10*(1.0-ff0))+(two_n_phit0*ff0));
d_fsd0_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vgsin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,((vdsat10-(vdsin*d_vdsat10_d_vdsin))/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_qcbflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vcin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vbin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_qgsflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_tambin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_tnomin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_phitin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_w/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_lin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cgin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cs/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cc/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cb/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vto/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_ss/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_delta1/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_delta2/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_nd/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_alpha/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vel0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_mu0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_beta/vdsat10/vdsat10))+((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(log(mmax( static_cast<double>(0),(vdsin/vdsat10))*pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_mtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vtzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_dibsat/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_epsilon/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_lambda/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_ngf/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_type/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
fsd0=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_vdx0_d_vgsin=(vdsin*d_fsd0_d_vgsin);
d_vdx0_d_vdsin=(vdsin*d_fsd0_d_vdsin+fsd0);
d_vdx0_d_qcbflag=(vdsin*d_fsd0_d_qcbflag);
d_vdx0_d_vcin=(vdsin*d_fsd0_d_vcin);
d_vdx0_d_vbin=(vdsin*d_fsd0_d_vbin);
d_vdx0_d_qgsflag=(vdsin*d_fsd0_d_qgsflag);
d_vdx0_d_tambin=(vdsin*d_fsd0_d_tambin);
d_vdx0_d_tnomin=(vdsin*d_fsd0_d_tnomin);
d_vdx0_d_phitin=(vdsin*d_fsd0_d_phitin);
d_vdx0_d_w=(vdsin*d_fsd0_d_w);
d_vdx0_d_lin=(vdsin*d_fsd0_d_lin);
d_vdx0_d_cgin=(vdsin*d_fsd0_d_cgin);
d_vdx0_d_cs=(vdsin*d_fsd0_d_cs);
d_vdx0_d_cc=(vdsin*d_fsd0_d_cc);
d_vdx0_d_cb=(vdsin*d_fsd0_d_cb);
d_vdx0_d_vto=(vdsin*d_fsd0_d_vto);
d_vdx0_d_ss=(vdsin*d_fsd0_d_ss);
d_vdx0_d_delta1=(vdsin*d_fsd0_d_delta1);
d_vdx0_d_delta2=(vdsin*d_fsd0_d_delta2);
d_vdx0_d_nd=(vdsin*d_fsd0_d_nd);
d_vdx0_d_alpha=(vdsin*d_fsd0_d_alpha);
d_vdx0_d_vel0=(vdsin*d_fsd0_d_vel0);
d_vdx0_d_mu0=(vdsin*d_fsd0_d_mu0);
d_vdx0_d_beta=(vdsin*d_fsd0_d_beta);
d_vdx0_d_mtheta=(vdsin*d_fsd0_d_mtheta);
d_vdx0_d_vtheta=(vdsin*d_fsd0_d_vtheta);
d_vdx0_d_vtzeta=(vdsin*d_fsd0_d_vtzeta);
d_vdx0_d_dibsat=(vdsin*d_fsd0_d_dibsat);
d_vdx0_d_epsilon=(vdsin*d_fsd0_d_epsilon);
d_vdx0_d_vzeta=(vdsin*d_fsd0_d_vzeta);
d_vdx0_d_lambda=(vdsin*d_fsd0_d_lambda);
d_vdx0_d_ngf=(vdsin*d_fsd0_d_ngf);
d_vdx0_d_type=(vdsin*d_fsd0_d_type);
vdx0=(vdsin*fsd0);
d_fds0_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vgsin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,((vdsat10*(-1.0)-(-vdsin)*d_vdsat10_d_vdsin)/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_qcbflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vcin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vbin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_qgsflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_tambin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_tnomin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_phitin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_w/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_lin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cgin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cs/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cc/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cb/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vto/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_ss/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_delta1/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_delta2/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_nd/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_alpha/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vel0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_mu0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_beta/vdsat10/vdsat10))+((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(log(mmax( static_cast<double>(0),((-vdsin)/vdsat10))*pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_mtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vtzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_dibsat/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_epsilon/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_lambda/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_ngf/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_type/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
fds0=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_vsx0_d_vgsin=((-vdsin)*d_fds0_d_vgsin);
d_vsx0_d_vdsin=(((-vdsin)*d_fds0_d_vdsin)+((-1.0)*fds0));
d_vsx0_d_qcbflag=((-vdsin)*d_fds0_d_qcbflag);
d_vsx0_d_vcin=((-vdsin)*d_fds0_d_vcin);
d_vsx0_d_vbin=((-vdsin)*d_fds0_d_vbin);
d_vsx0_d_qgsflag=((-vdsin)*d_fds0_d_qgsflag);
d_vsx0_d_tambin=((-vdsin)*d_fds0_d_tambin);
d_vsx0_d_tnomin=((-vdsin)*d_fds0_d_tnomin);
d_vsx0_d_phitin=((-vdsin)*d_fds0_d_phitin);
d_vsx0_d_w=((-vdsin)*d_fds0_d_w);
d_vsx0_d_lin=((-vdsin)*d_fds0_d_lin);
d_vsx0_d_cgin=((-vdsin)*d_fds0_d_cgin);
d_vsx0_d_cs=((-vdsin)*d_fds0_d_cs);
d_vsx0_d_cc=((-vdsin)*d_fds0_d_cc);
d_vsx0_d_cb=((-vdsin)*d_fds0_d_cb);
d_vsx0_d_vto=((-vdsin)*d_fds0_d_vto);
d_vsx0_d_ss=((-vdsin)*d_fds0_d_ss);
d_vsx0_d_delta1=((-vdsin)*d_fds0_d_delta1);
d_vsx0_d_delta2=((-vdsin)*d_fds0_d_delta2);
d_vsx0_d_nd=((-vdsin)*d_fds0_d_nd);
d_vsx0_d_alpha=((-vdsin)*d_fds0_d_alpha);
d_vsx0_d_vel0=((-vdsin)*d_fds0_d_vel0);
d_vsx0_d_mu0=((-vdsin)*d_fds0_d_mu0);
d_vsx0_d_beta=((-vdsin)*d_fds0_d_beta);
d_vsx0_d_mtheta=((-vdsin)*d_fds0_d_mtheta);
d_vsx0_d_vtheta=((-vdsin)*d_fds0_d_vtheta);
d_vsx0_d_vtzeta=((-vdsin)*d_fds0_d_vtzeta);
d_vsx0_d_dibsat=((-vdsin)*d_fds0_d_dibsat);
d_vsx0_d_epsilon=((-vdsin)*d_fds0_d_epsilon);
d_vsx0_d_vzeta=((-vdsin)*d_fds0_d_vzeta);
d_vsx0_d_lambda=((-vdsin)*d_fds0_d_lambda);
d_vsx0_d_ngf=((-vdsin)*d_fds0_d_ngf);
d_vsx0_d_type=((-vdsin)*d_fds0_d_type);
vsx0=((-vdsin)*fds0);
d_exparg0_d_vgsin=((alpha_phit*(1.0-d_myarg0_d_vgsin)-(vgsin-myarg0)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg0_d_vdsin=((alpha_phit*(-d_myarg0_d_vdsin)-(vgsin-myarg0)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg0_d_qcbflag=((alpha_phit*(-d_myarg0_d_qcbflag)-(vgsin-myarg0)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg0_d_vcin=((alpha_phit*(-d_myarg0_d_vcin)-(vgsin-myarg0)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg0_d_vbin=((alpha_phit*(-d_myarg0_d_vbin)-(vgsin-myarg0)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg0_d_qgsflag=((alpha_phit*(-d_myarg0_d_qgsflag)-(vgsin-myarg0)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg0_d_tambin=((alpha_phit*(-d_myarg0_d_tambin)-(vgsin-myarg0)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg0_d_tnomin=((alpha_phit*(-d_myarg0_d_tnomin)-(vgsin-myarg0)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg0_d_phitin=((alpha_phit*(-d_myarg0_d_phitin)-(vgsin-myarg0)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg0_d_w=((alpha_phit*(-d_myarg0_d_w)-(vgsin-myarg0)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg0_d_lin=((alpha_phit*(-d_myarg0_d_lin)-(vgsin-myarg0)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg0_d_cgin=((alpha_phit*(-d_myarg0_d_cgin)-(vgsin-myarg0)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg0_d_cs=((alpha_phit*(-d_myarg0_d_cs)-(vgsin-myarg0)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg0_d_cc=((alpha_phit*(-d_myarg0_d_cc)-(vgsin-myarg0)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg0_d_cb=((alpha_phit*(-d_myarg0_d_cb)-(vgsin-myarg0)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg0_d_vto=((alpha_phit*(-d_myarg0_d_vto)-(vgsin-myarg0)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg0_d_ss=((alpha_phit*(-d_myarg0_d_ss)-(vgsin-myarg0)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg0_d_delta1=((alpha_phit*(-d_myarg0_d_delta1)-(vgsin-myarg0)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg0_d_delta2=((alpha_phit*(-d_myarg0_d_delta2)-(vgsin-myarg0)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg0_d_nd=((alpha_phit*(-d_myarg0_d_nd)-(vgsin-myarg0)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg0_d_alpha=((alpha_phit*(-d_myarg0_d_alpha)-(vgsin-myarg0)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg0_d_vel0=((alpha_phit*(-d_myarg0_d_vel0)-(vgsin-myarg0)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg0_d_mu0=((alpha_phit*(-d_myarg0_d_mu0)-(vgsin-myarg0)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg0_d_beta=((alpha_phit*(-d_myarg0_d_beta)-(vgsin-myarg0)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg0_d_mtheta=((alpha_phit*(-d_myarg0_d_mtheta)-(vgsin-myarg0)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtheta=((alpha_phit*(-d_myarg0_d_vtheta)-(vgsin-myarg0)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtzeta=((alpha_phit*(-d_myarg0_d_vtzeta)-(vgsin-myarg0)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg0_d_dibsat=((alpha_phit*(-d_myarg0_d_dibsat)-(vgsin-myarg0)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg0_d_epsilon=((alpha_phit*(-d_myarg0_d_epsilon)-(vgsin-myarg0)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg0_d_vzeta=((alpha_phit*(-d_myarg0_d_vzeta)-(vgsin-myarg0)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg0_d_lambda=((alpha_phit*(-d_myarg0_d_lambda)-(vgsin-myarg0)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg0_d_ngf=((alpha_phit*(-d_myarg0_d_ngf)-(vgsin-myarg0)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg0_d_type=((alpha_phit*(-d_myarg0_d_type)-(vgsin-myarg0)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg0=((vgsin-myarg0)/alpha_phit);
if((exparg0>50.0))
{
d_ffs0_d_vgsin=0.0;
d_ffs0_d_vdsin=0.0;
d_ffs0_d_qcbflag=0.0;
d_ffs0_d_vcin=0.0;
d_ffs0_d_vbin=0.0;
d_ffs0_d_qgsflag=0.0;
d_ffs0_d_tambin=0.0;
d_ffs0_d_tnomin=0.0;
d_ffs0_d_phitin=0.0;
d_ffs0_d_w=0.0;
d_ffs0_d_lin=0.0;
d_ffs0_d_cgin=0.0;
d_ffs0_d_cs=0.0;
d_ffs0_d_cc=0.0;
d_ffs0_d_cb=0.0;
d_ffs0_d_vto=0.0;
d_ffs0_d_ss=0.0;
d_ffs0_d_delta1=0.0;
d_ffs0_d_delta2=0.0;
d_ffs0_d_nd=0.0;
d_ffs0_d_alpha=0.0;
d_ffs0_d_vel0=0.0;
d_ffs0_d_mu0=0.0;
d_ffs0_d_beta=0.0;
d_ffs0_d_mtheta=0.0;
d_ffs0_d_vtheta=0.0;
d_ffs0_d_vtzeta=0.0;
d_ffs0_d_dibsat=0.0;
d_ffs0_d_epsilon=0.0;
d_ffs0_d_vzeta=0.0;
d_ffs0_d_lambda=0.0;
d_ffs0_d_ngf=0.0;
d_ffs0_d_type=0.0;
ffs0=0.0;
}
else
{
if((exparg0<(-50.0)))
{
d_ffs0_d_vgsin=0.0;
d_ffs0_d_vdsin=0.0;
d_ffs0_d_qcbflag=0.0;
d_ffs0_d_vcin=0.0;
d_ffs0_d_vbin=0.0;
d_ffs0_d_qgsflag=0.0;
d_ffs0_d_tambin=0.0;
d_ffs0_d_tnomin=0.0;
d_ffs0_d_phitin=0.0;
d_ffs0_d_w=0.0;
d_ffs0_d_lin=0.0;
d_ffs0_d_cgin=0.0;
d_ffs0_d_cs=0.0;
d_ffs0_d_cc=0.0;
d_ffs0_d_cb=0.0;
d_ffs0_d_vto=0.0;
d_ffs0_d_ss=0.0;
d_ffs0_d_delta1=0.0;
d_ffs0_d_delta2=0.0;
d_ffs0_d_nd=0.0;
d_ffs0_d_alpha=0.0;
d_ffs0_d_vel0=0.0;
d_ffs0_d_mu0=0.0;
d_ffs0_d_beta=0.0;
d_ffs0_d_mtheta=0.0;
d_ffs0_d_vtheta=0.0;
d_ffs0_d_vtzeta=0.0;
d_ffs0_d_dibsat=0.0;
d_ffs0_d_epsilon=0.0;
d_ffs0_d_vzeta=0.0;
d_ffs0_d_lambda=0.0;
d_ffs0_d_ngf=0.0;
d_ffs0_d_type=0.0;
ffs0=1.0;
}
else
{
d_ffs0_d_vgsin=(-exp(exparg0)*d_exparg0_d_vgsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vdsin=(-exp(exparg0)*d_exparg0_d_vdsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_qcbflag=(-exp(exparg0)*d_exparg0_d_qcbflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vcin=(-exp(exparg0)*d_exparg0_d_vcin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vbin=(-exp(exparg0)*d_exparg0_d_vbin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_qgsflag=(-exp(exparg0)*d_exparg0_d_qgsflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_tambin=(-exp(exparg0)*d_exparg0_d_tambin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_tnomin=(-exp(exparg0)*d_exparg0_d_tnomin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_phitin=(-exp(exparg0)*d_exparg0_d_phitin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_w=(-exp(exparg0)*d_exparg0_d_w/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_lin=(-exp(exparg0)*d_exparg0_d_lin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cgin=(-exp(exparg0)*d_exparg0_d_cgin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cs=(-exp(exparg0)*d_exparg0_d_cs/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cc=(-exp(exparg0)*d_exparg0_d_cc/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cb=(-exp(exparg0)*d_exparg0_d_cb/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vto=(-exp(exparg0)*d_exparg0_d_vto/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_ss=(-exp(exparg0)*d_exparg0_d_ss/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_delta1=(-exp(exparg0)*d_exparg0_d_delta1/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_delta2=(-exp(exparg0)*d_exparg0_d_delta2/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_nd=(-exp(exparg0)*d_exparg0_d_nd/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_alpha=(-exp(exparg0)*d_exparg0_d_alpha/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vel0=(-exp(exparg0)*d_exparg0_d_vel0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_mu0=(-exp(exparg0)*d_exparg0_d_mu0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_beta=(-exp(exparg0)*d_exparg0_d_beta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_mtheta=(-exp(exparg0)*d_exparg0_d_mtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vtheta=(-exp(exparg0)*d_exparg0_d_vtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vtzeta=(-exp(exparg0)*d_exparg0_d_vtzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_dibsat=(-exp(exparg0)*d_exparg0_d_dibsat/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_epsilon=(-exp(exparg0)*d_exparg0_d_epsilon/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vzeta=(-exp(exparg0)*d_exparg0_d_vzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_lambda=(-exp(exparg0)*d_exparg0_d_lambda/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_ngf=(-exp(exparg0)*d_exparg0_d_ngf/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_type=(-exp(exparg0)*d_exparg0_d_type/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
ffs0=(1.0/(1.0+exp(exparg0)));
}
}
d_etas0_d_vgsin=((two_n_phit0*((d_vgdin_d_vgsin-d_vsx0_d_vgsin)-(d_vtof_d_vgsin-(((0.1*alpha_phit)*d_ffs0_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etas0_d_vdsin=((two_n_phit0*((d_vgdin_d_vdsin-d_vsx0_d_vdsin)-(d_vtof_d_vdsin-(((0.1*alpha_phit)*d_ffs0_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etas0_d_qcbflag=((two_n_phit0*((d_vgdin_d_qcbflag-d_vsx0_d_qcbflag)-(d_vtof_d_qcbflag-(((0.1*alpha_phit)*d_ffs0_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etas0_d_vcin=((two_n_phit0*((d_vgdin_d_vcin-d_vsx0_d_vcin)-(d_vtof_d_vcin-(((0.1*alpha_phit)*d_ffs0_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etas0_d_vbin=((two_n_phit0*((d_vgdin_d_vbin-d_vsx0_d_vbin)-(d_vtof_d_vbin-(((0.1*alpha_phit)*d_ffs0_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etas0_d_qgsflag=((two_n_phit0*((d_vgdin_d_qgsflag-d_vsx0_d_qgsflag)-(d_vtof_d_qgsflag-(((0.1*alpha_phit)*d_ffs0_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etas0_d_tambin=((two_n_phit0*((d_vgdin_d_tambin-d_vsx0_d_tambin)-(d_vtof_d_tambin-(((0.1*alpha_phit)*d_ffs0_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etas0_d_tnomin=((two_n_phit0*((d_vgdin_d_tnomin-d_vsx0_d_tnomin)-(d_vtof_d_tnomin-(((0.1*alpha_phit)*d_ffs0_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etas0_d_phitin=((two_n_phit0*((d_vgdin_d_phitin-d_vsx0_d_phitin)-(d_vtof_d_phitin-(((0.1*alpha_phit)*d_ffs0_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etas0_d_w=((two_n_phit0*((d_vgdin_d_w-d_vsx0_d_w)-(d_vtof_d_w-(((0.1*alpha_phit)*d_ffs0_d_w)+((0.1*d_alpha_phit_d_w)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etas0_d_lin=((two_n_phit0*((d_vgdin_d_lin-d_vsx0_d_lin)-(d_vtof_d_lin-(((0.1*alpha_phit)*d_ffs0_d_lin)+((0.1*d_alpha_phit_d_lin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etas0_d_cgin=((two_n_phit0*((d_vgdin_d_cgin-d_vsx0_d_cgin)-(d_vtof_d_cgin-(((0.1*alpha_phit)*d_ffs0_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etas0_d_cs=((two_n_phit0*((d_vgdin_d_cs-d_vsx0_d_cs)-(d_vtof_d_cs-(((0.1*alpha_phit)*d_ffs0_d_cs)+((0.1*d_alpha_phit_d_cs)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etas0_d_cc=((two_n_phit0*((d_vgdin_d_cc-d_vsx0_d_cc)-(d_vtof_d_cc-(((0.1*alpha_phit)*d_ffs0_d_cc)+((0.1*d_alpha_phit_d_cc)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etas0_d_cb=((two_n_phit0*((d_vgdin_d_cb-d_vsx0_d_cb)-(d_vtof_d_cb-(((0.1*alpha_phit)*d_ffs0_d_cb)+((0.1*d_alpha_phit_d_cb)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etas0_d_vto=((two_n_phit0*((d_vgdin_d_vto-d_vsx0_d_vto)-(d_vtof_d_vto-(((0.1*alpha_phit)*d_ffs0_d_vto)+((0.1*d_alpha_phit_d_vto)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etas0_d_ss=((two_n_phit0*((d_vgdin_d_ss-d_vsx0_d_ss)-(d_vtof_d_ss-(((0.1*alpha_phit)*d_ffs0_d_ss)+((0.1*d_alpha_phit_d_ss)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etas0_d_delta1=((two_n_phit0*((d_vgdin_d_delta1-d_vsx0_d_delta1)-(d_vtof_d_delta1-(((0.1*alpha_phit)*d_ffs0_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etas0_d_delta2=((two_n_phit0*((d_vgdin_d_delta2-d_vsx0_d_delta2)-(d_vtof_d_delta2-(((0.1*alpha_phit)*d_ffs0_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etas0_d_nd=((two_n_phit0*((d_vgdin_d_nd-d_vsx0_d_nd)-(d_vtof_d_nd-(((0.1*alpha_phit)*d_ffs0_d_nd)+((0.1*d_alpha_phit_d_nd)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etas0_d_alpha=((two_n_phit0*((d_vgdin_d_alpha-d_vsx0_d_alpha)-(d_vtof_d_alpha-(((0.1*alpha_phit)*d_ffs0_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etas0_d_vel0=((two_n_phit0*((d_vgdin_d_vel0-d_vsx0_d_vel0)-(d_vtof_d_vel0-(((0.1*alpha_phit)*d_ffs0_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etas0_d_mu0=((two_n_phit0*((d_vgdin_d_mu0-d_vsx0_d_mu0)-(d_vtof_d_mu0-(((0.1*alpha_phit)*d_ffs0_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etas0_d_beta=((two_n_phit0*((d_vgdin_d_beta-d_vsx0_d_beta)-(d_vtof_d_beta-(((0.1*alpha_phit)*d_ffs0_d_beta)+((0.1*d_alpha_phit_d_beta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etas0_d_mtheta=((two_n_phit0*((d_vgdin_d_mtheta-d_vsx0_d_mtheta)-(d_vtof_d_mtheta-(((0.1*alpha_phit)*d_ffs0_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etas0_d_vtheta=((two_n_phit0*((d_vgdin_d_vtheta-d_vsx0_d_vtheta)-(d_vtof_d_vtheta-(((0.1*alpha_phit)*d_ffs0_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etas0_d_vtzeta=((two_n_phit0*((d_vgdin_d_vtzeta-d_vsx0_d_vtzeta)-(d_vtof_d_vtzeta-(((0.1*alpha_phit)*d_ffs0_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etas0_d_dibsat=((two_n_phit0*((d_vgdin_d_dibsat-d_vsx0_d_dibsat)-(d_vtof_d_dibsat-(((0.1*alpha_phit)*d_ffs0_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etas0_d_epsilon=((two_n_phit0*((d_vgdin_d_epsilon-d_vsx0_d_epsilon)-(d_vtof_d_epsilon-(((0.1*alpha_phit)*d_ffs0_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etas0_d_vzeta=((two_n_phit0*((d_vgdin_d_vzeta-d_vsx0_d_vzeta)-(d_vtof_d_vzeta-(((0.1*alpha_phit)*d_ffs0_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etas0_d_lambda=((two_n_phit0*((d_vgdin_d_lambda-d_vsx0_d_lambda)-(d_vtof_d_lambda-(((0.1*alpha_phit)*d_ffs0_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etas0_d_ngf=((two_n_phit0*((d_vgdin_d_ngf-d_vsx0_d_ngf)-(d_vtof_d_ngf-(((0.1*alpha_phit)*d_ffs0_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etas0_d_type=((two_n_phit0*((d_vgdin_d_type-d_vsx0_d_type)-(d_vtof_d_type-(((0.1*alpha_phit)*d_ffs0_d_type)+((0.1*d_alpha_phit_d_type)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etas0=(((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))/two_n_phit0);
if((etas0>50.0))
{
d_qinvs0_d_vgsin=((qref0*d_etas0_d_vgsin)+(d_qref0_d_vgsin*etas0));
d_qinvs0_d_vdsin=((qref0*d_etas0_d_vdsin)+(d_qref0_d_vdsin*etas0));
d_qinvs0_d_qcbflag=((qref0*d_etas0_d_qcbflag)+(d_qref0_d_qcbflag*etas0));
d_qinvs0_d_vcin=((qref0*d_etas0_d_vcin)+(d_qref0_d_vcin*etas0));
d_qinvs0_d_vbin=((qref0*d_etas0_d_vbin)+(d_qref0_d_vbin*etas0));
d_qinvs0_d_qgsflag=((qref0*d_etas0_d_qgsflag)+(d_qref0_d_qgsflag*etas0));
d_qinvs0_d_tambin=((qref0*d_etas0_d_tambin)+(d_qref0_d_tambin*etas0));
d_qinvs0_d_tnomin=((qref0*d_etas0_d_tnomin)+(d_qref0_d_tnomin*etas0));
d_qinvs0_d_phitin=((qref0*d_etas0_d_phitin)+(d_qref0_d_phitin*etas0));
d_qinvs0_d_w=((qref0*d_etas0_d_w)+(d_qref0_d_w*etas0));
d_qinvs0_d_lin=((qref0*d_etas0_d_lin)+(d_qref0_d_lin*etas0));
d_qinvs0_d_cgin=((qref0*d_etas0_d_cgin)+(d_qref0_d_cgin*etas0));
d_qinvs0_d_cs=((qref0*d_etas0_d_cs)+(d_qref0_d_cs*etas0));
d_qinvs0_d_cc=((qref0*d_etas0_d_cc)+(d_qref0_d_cc*etas0));
d_qinvs0_d_cb=((qref0*d_etas0_d_cb)+(d_qref0_d_cb*etas0));
d_qinvs0_d_vto=((qref0*d_etas0_d_vto)+(d_qref0_d_vto*etas0));
d_qinvs0_d_ss=((qref0*d_etas0_d_ss)+(d_qref0_d_ss*etas0));
d_qinvs0_d_delta1=((qref0*d_etas0_d_delta1)+(d_qref0_d_delta1*etas0));
d_qinvs0_d_delta2=((qref0*d_etas0_d_delta2)+(d_qref0_d_delta2*etas0));
d_qinvs0_d_nd=((qref0*d_etas0_d_nd)+(d_qref0_d_nd*etas0));
d_qinvs0_d_alpha=((qref0*d_etas0_d_alpha)+(d_qref0_d_alpha*etas0));
d_qinvs0_d_vel0=((qref0*d_etas0_d_vel0)+(d_qref0_d_vel0*etas0));
d_qinvs0_d_mu0=((qref0*d_etas0_d_mu0)+(d_qref0_d_mu0*etas0));
d_qinvs0_d_beta=((qref0*d_etas0_d_beta)+(d_qref0_d_beta*etas0));
d_qinvs0_d_mtheta=((qref0*d_etas0_d_mtheta)+(d_qref0_d_mtheta*etas0));
d_qinvs0_d_vtheta=((qref0*d_etas0_d_vtheta)+(d_qref0_d_vtheta*etas0));
d_qinvs0_d_vtzeta=((qref0*d_etas0_d_vtzeta)+(d_qref0_d_vtzeta*etas0));
d_qinvs0_d_dibsat=((qref0*d_etas0_d_dibsat)+(d_qref0_d_dibsat*etas0));
d_qinvs0_d_epsilon=((qref0*d_etas0_d_epsilon)+(d_qref0_d_epsilon*etas0));
d_qinvs0_d_vzeta=((qref0*d_etas0_d_vzeta)+(d_qref0_d_vzeta*etas0));
d_qinvs0_d_lambda=((qref0*d_etas0_d_lambda)+(d_qref0_d_lambda*etas0));
d_qinvs0_d_ngf=((qref0*d_etas0_d_ngf)+(d_qref0_d_ngf*etas0));
d_qinvs0_d_type=((qref0*d_etas0_d_type)+(d_qref0_d_type*etas0));
qinvs0=(qref0*etas0);
}
else
{
if((etas0<(-50.0)))
{
d_qinvs0_d_vgsin=0.0;
d_qinvs0_d_vdsin=0.0;
d_qinvs0_d_qcbflag=0.0;
d_qinvs0_d_vcin=0.0;
d_qinvs0_d_vbin=0.0;
d_qinvs0_d_qgsflag=0.0;
d_qinvs0_d_tambin=0.0;
d_qinvs0_d_tnomin=0.0;
d_qinvs0_d_phitin=0.0;
d_qinvs0_d_w=0.0;
d_qinvs0_d_lin=0.0;
d_qinvs0_d_cgin=0.0;
d_qinvs0_d_cs=0.0;
d_qinvs0_d_cc=0.0;
d_qinvs0_d_cb=0.0;
d_qinvs0_d_vto=0.0;
d_qinvs0_d_ss=0.0;
d_qinvs0_d_delta1=0.0;
d_qinvs0_d_delta2=0.0;
d_qinvs0_d_nd=0.0;
d_qinvs0_d_alpha=0.0;
d_qinvs0_d_vel0=0.0;
d_qinvs0_d_mu0=0.0;
d_qinvs0_d_beta=0.0;
d_qinvs0_d_mtheta=0.0;
d_qinvs0_d_vtheta=0.0;
d_qinvs0_d_vtzeta=0.0;
d_qinvs0_d_dibsat=0.0;
d_qinvs0_d_epsilon=0.0;
d_qinvs0_d_vzeta=0.0;
d_qinvs0_d_lambda=0.0;
d_qinvs0_d_ngf=0.0;
d_qinvs0_d_type=0.0;
qinvs0=0;
}
else
{
d_qinvs0_d_vgsin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vgsin)+(d_qref0_d_vgsin*log((1.0+exp(etas0)))));
d_qinvs0_d_vdsin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vdsin)+(d_qref0_d_vdsin*log((1.0+exp(etas0)))));
d_qinvs0_d_qcbflag=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_qcbflag)+(d_qref0_d_qcbflag*log((1.0+exp(etas0)))));
d_qinvs0_d_vcin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vcin)+(d_qref0_d_vcin*log((1.0+exp(etas0)))));
d_qinvs0_d_vbin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vbin)+(d_qref0_d_vbin*log((1.0+exp(etas0)))));
d_qinvs0_d_qgsflag=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_qgsflag)+(d_qref0_d_qgsflag*log((1.0+exp(etas0)))));
d_qinvs0_d_tambin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_tambin)+(d_qref0_d_tambin*log((1.0+exp(etas0)))));
d_qinvs0_d_tnomin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_tnomin)+(d_qref0_d_tnomin*log((1.0+exp(etas0)))));
d_qinvs0_d_phitin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_phitin)+(d_qref0_d_phitin*log((1.0+exp(etas0)))));
d_qinvs0_d_w=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_w)+(d_qref0_d_w*log((1.0+exp(etas0)))));
d_qinvs0_d_lin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_lin)+(d_qref0_d_lin*log((1.0+exp(etas0)))));
d_qinvs0_d_cgin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cgin)+(d_qref0_d_cgin*log((1.0+exp(etas0)))));
d_qinvs0_d_cs=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cs)+(d_qref0_d_cs*log((1.0+exp(etas0)))));
d_qinvs0_d_cc=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cc)+(d_qref0_d_cc*log((1.0+exp(etas0)))));
d_qinvs0_d_cb=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cb)+(d_qref0_d_cb*log((1.0+exp(etas0)))));
d_qinvs0_d_vto=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vto)+(d_qref0_d_vto*log((1.0+exp(etas0)))));
d_qinvs0_d_ss=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_ss)+(d_qref0_d_ss*log((1.0+exp(etas0)))));
d_qinvs0_d_delta1=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_delta1)+(d_qref0_d_delta1*log((1.0+exp(etas0)))));
d_qinvs0_d_delta2=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_delta2)+(d_qref0_d_delta2*log((1.0+exp(etas0)))));
d_qinvs0_d_nd=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_nd)+(d_qref0_d_nd*log((1.0+exp(etas0)))));
d_qinvs0_d_alpha=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_alpha)+(d_qref0_d_alpha*log((1.0+exp(etas0)))));
d_qinvs0_d_vel0=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vel0)+(d_qref0_d_vel0*log((1.0+exp(etas0)))));
d_qinvs0_d_mu0=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_mu0)+(d_qref0_d_mu0*log((1.0+exp(etas0)))));
d_qinvs0_d_beta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_beta)+(d_qref0_d_beta*log((1.0+exp(etas0)))));
d_qinvs0_d_mtheta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_mtheta)+(d_qref0_d_mtheta*log((1.0+exp(etas0)))));
d_qinvs0_d_vtheta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vtheta)+(d_qref0_d_vtheta*log((1.0+exp(etas0)))));
d_qinvs0_d_vtzeta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vtzeta)+(d_qref0_d_vtzeta*log((1.0+exp(etas0)))));
d_qinvs0_d_dibsat=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_dibsat)+(d_qref0_d_dibsat*log((1.0+exp(etas0)))));
d_qinvs0_d_epsilon=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_epsilon)+(d_qref0_d_epsilon*log((1.0+exp(etas0)))));
d_qinvs0_d_vzeta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vzeta)+(d_qref0_d_vzeta*log((1.0+exp(etas0)))));
d_qinvs0_d_lambda=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_lambda)+(d_qref0_d_lambda*log((1.0+exp(etas0)))));
d_qinvs0_d_ngf=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_ngf)+(d_qref0_d_ngf*log((1.0+exp(etas0)))));
d_qinvs0_d_type=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_type)+(d_qref0_d_type*log((1.0+exp(etas0)))));
qinvs0=(qref0*log((1.0+exp(etas0))));
}
}
d_exparg0_d_vgsin=((alpha_phit*(d_vgdin_d_vgsin-d_myarg0_d_vgsin)-(vgdin-myarg0)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg0_d_vdsin=((alpha_phit*(d_vgdin_d_vdsin-d_myarg0_d_vdsin)-(vgdin-myarg0)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg0_d_qcbflag=((alpha_phit*(d_vgdin_d_qcbflag-d_myarg0_d_qcbflag)-(vgdin-myarg0)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg0_d_vcin=((alpha_phit*(d_vgdin_d_vcin-d_myarg0_d_vcin)-(vgdin-myarg0)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg0_d_vbin=((alpha_phit*(d_vgdin_d_vbin-d_myarg0_d_vbin)-(vgdin-myarg0)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg0_d_qgsflag=((alpha_phit*(d_vgdin_d_qgsflag-d_myarg0_d_qgsflag)-(vgdin-myarg0)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg0_d_tambin=((alpha_phit*(d_vgdin_d_tambin-d_myarg0_d_tambin)-(vgdin-myarg0)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg0_d_tnomin=((alpha_phit*(d_vgdin_d_tnomin-d_myarg0_d_tnomin)-(vgdin-myarg0)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg0_d_phitin=((alpha_phit*(d_vgdin_d_phitin-d_myarg0_d_phitin)-(vgdin-myarg0)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg0_d_w=((alpha_phit*(d_vgdin_d_w-d_myarg0_d_w)-(vgdin-myarg0)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg0_d_lin=((alpha_phit*(d_vgdin_d_lin-d_myarg0_d_lin)-(vgdin-myarg0)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg0_d_cgin=((alpha_phit*(d_vgdin_d_cgin-d_myarg0_d_cgin)-(vgdin-myarg0)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg0_d_cs=((alpha_phit*(d_vgdin_d_cs-d_myarg0_d_cs)-(vgdin-myarg0)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg0_d_cc=((alpha_phit*(d_vgdin_d_cc-d_myarg0_d_cc)-(vgdin-myarg0)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg0_d_cb=((alpha_phit*(d_vgdin_d_cb-d_myarg0_d_cb)-(vgdin-myarg0)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg0_d_vto=((alpha_phit*(d_vgdin_d_vto-d_myarg0_d_vto)-(vgdin-myarg0)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg0_d_ss=((alpha_phit*(d_vgdin_d_ss-d_myarg0_d_ss)-(vgdin-myarg0)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg0_d_delta1=((alpha_phit*(d_vgdin_d_delta1-d_myarg0_d_delta1)-(vgdin-myarg0)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg0_d_delta2=((alpha_phit*(d_vgdin_d_delta2-d_myarg0_d_delta2)-(vgdin-myarg0)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg0_d_nd=((alpha_phit*(d_vgdin_d_nd-d_myarg0_d_nd)-(vgdin-myarg0)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg0_d_alpha=((alpha_phit*(d_vgdin_d_alpha-d_myarg0_d_alpha)-(vgdin-myarg0)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg0_d_vel0=((alpha_phit*(d_vgdin_d_vel0-d_myarg0_d_vel0)-(vgdin-myarg0)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg0_d_mu0=((alpha_phit*(d_vgdin_d_mu0-d_myarg0_d_mu0)-(vgdin-myarg0)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg0_d_beta=((alpha_phit*(d_vgdin_d_beta-d_myarg0_d_beta)-(vgdin-myarg0)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg0_d_mtheta=((alpha_phit*(d_vgdin_d_mtheta-d_myarg0_d_mtheta)-(vgdin-myarg0)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtheta=((alpha_phit*(d_vgdin_d_vtheta-d_myarg0_d_vtheta)-(vgdin-myarg0)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtzeta=((alpha_phit*(d_vgdin_d_vtzeta-d_myarg0_d_vtzeta)-(vgdin-myarg0)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg0_d_dibsat=((alpha_phit*(d_vgdin_d_dibsat-d_myarg0_d_dibsat)-(vgdin-myarg0)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg0_d_epsilon=((alpha_phit*(d_vgdin_d_epsilon-d_myarg0_d_epsilon)-(vgdin-myarg0)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg0_d_vzeta=((alpha_phit*(d_vgdin_d_vzeta-d_myarg0_d_vzeta)-(vgdin-myarg0)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg0_d_lambda=((alpha_phit*(d_vgdin_d_lambda-d_myarg0_d_lambda)-(vgdin-myarg0)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg0_d_ngf=((alpha_phit*(d_vgdin_d_ngf-d_myarg0_d_ngf)-(vgdin-myarg0)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg0_d_type=((alpha_phit*(d_vgdin_d_type-d_myarg0_d_type)-(vgdin-myarg0)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg0=((vgdin-myarg0)/alpha_phit);
if((exparg0>50.0))
{
d_ffd0_d_vgsin=0.0;
d_ffd0_d_vdsin=0.0;
d_ffd0_d_qcbflag=0.0;
d_ffd0_d_vcin=0.0;
d_ffd0_d_vbin=0.0;
d_ffd0_d_qgsflag=0.0;
d_ffd0_d_tambin=0.0;
d_ffd0_d_tnomin=0.0;
d_ffd0_d_phitin=0.0;
d_ffd0_d_w=0.0;
d_ffd0_d_lin=0.0;
d_ffd0_d_cgin=0.0;
d_ffd0_d_cs=0.0;
d_ffd0_d_cc=0.0;
d_ffd0_d_cb=0.0;
d_ffd0_d_vto=0.0;
d_ffd0_d_ss=0.0;
d_ffd0_d_delta1=0.0;
d_ffd0_d_delta2=0.0;
d_ffd0_d_nd=0.0;
d_ffd0_d_alpha=0.0;
d_ffd0_d_vel0=0.0;
d_ffd0_d_mu0=0.0;
d_ffd0_d_beta=0.0;
d_ffd0_d_mtheta=0.0;
d_ffd0_d_vtheta=0.0;
d_ffd0_d_vtzeta=0.0;
d_ffd0_d_dibsat=0.0;
d_ffd0_d_epsilon=0.0;
d_ffd0_d_vzeta=0.0;
d_ffd0_d_lambda=0.0;
d_ffd0_d_ngf=0.0;
d_ffd0_d_type=0.0;
ffd0=0.0;
}
else
{
if((exparg0<(-50.0)))
{
d_ffd0_d_vgsin=0.0;
d_ffd0_d_vdsin=0.0;
d_ffd0_d_qcbflag=0.0;
d_ffd0_d_vcin=0.0;
d_ffd0_d_vbin=0.0;
d_ffd0_d_qgsflag=0.0;
d_ffd0_d_tambin=0.0;
d_ffd0_d_tnomin=0.0;
d_ffd0_d_phitin=0.0;
d_ffd0_d_w=0.0;
d_ffd0_d_lin=0.0;
d_ffd0_d_cgin=0.0;
d_ffd0_d_cs=0.0;
d_ffd0_d_cc=0.0;
d_ffd0_d_cb=0.0;
d_ffd0_d_vto=0.0;
d_ffd0_d_ss=0.0;
d_ffd0_d_delta1=0.0;
d_ffd0_d_delta2=0.0;
d_ffd0_d_nd=0.0;
d_ffd0_d_alpha=0.0;
d_ffd0_d_vel0=0.0;
d_ffd0_d_mu0=0.0;
d_ffd0_d_beta=0.0;
d_ffd0_d_mtheta=0.0;
d_ffd0_d_vtheta=0.0;
d_ffd0_d_vtzeta=0.0;
d_ffd0_d_dibsat=0.0;
d_ffd0_d_epsilon=0.0;
d_ffd0_d_vzeta=0.0;
d_ffd0_d_lambda=0.0;
d_ffd0_d_ngf=0.0;
d_ffd0_d_type=0.0;
ffd0=1.0;
}
else
{
d_ffd0_d_vgsin=(-exp(exparg0)*d_exparg0_d_vgsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vdsin=(-exp(exparg0)*d_exparg0_d_vdsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_qcbflag=(-exp(exparg0)*d_exparg0_d_qcbflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vcin=(-exp(exparg0)*d_exparg0_d_vcin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vbin=(-exp(exparg0)*d_exparg0_d_vbin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_qgsflag=(-exp(exparg0)*d_exparg0_d_qgsflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_tambin=(-exp(exparg0)*d_exparg0_d_tambin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_tnomin=(-exp(exparg0)*d_exparg0_d_tnomin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_phitin=(-exp(exparg0)*d_exparg0_d_phitin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_w=(-exp(exparg0)*d_exparg0_d_w/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_lin=(-exp(exparg0)*d_exparg0_d_lin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cgin=(-exp(exparg0)*d_exparg0_d_cgin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cs=(-exp(exparg0)*d_exparg0_d_cs/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cc=(-exp(exparg0)*d_exparg0_d_cc/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cb=(-exp(exparg0)*d_exparg0_d_cb/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vto=(-exp(exparg0)*d_exparg0_d_vto/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_ss=(-exp(exparg0)*d_exparg0_d_ss/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_delta1=(-exp(exparg0)*d_exparg0_d_delta1/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_delta2=(-exp(exparg0)*d_exparg0_d_delta2/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_nd=(-exp(exparg0)*d_exparg0_d_nd/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_alpha=(-exp(exparg0)*d_exparg0_d_alpha/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vel0=(-exp(exparg0)*d_exparg0_d_vel0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_mu0=(-exp(exparg0)*d_exparg0_d_mu0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_beta=(-exp(exparg0)*d_exparg0_d_beta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_mtheta=(-exp(exparg0)*d_exparg0_d_mtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vtheta=(-exp(exparg0)*d_exparg0_d_vtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vtzeta=(-exp(exparg0)*d_exparg0_d_vtzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_dibsat=(-exp(exparg0)*d_exparg0_d_dibsat/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_epsilon=(-exp(exparg0)*d_exparg0_d_epsilon/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vzeta=(-exp(exparg0)*d_exparg0_d_vzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_lambda=(-exp(exparg0)*d_exparg0_d_lambda/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_ngf=(-exp(exparg0)*d_exparg0_d_ngf/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_type=(-exp(exparg0)*d_exparg0_d_type/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
ffd0=(1.0/(1.0+exp(exparg0)));
}
}
d_etad0_d_vgsin=((two_n_phit0*((1.0-d_vdx0_d_vgsin)-(d_vtof_d_vgsin-(((0.1*alpha_phit)*d_ffd0_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etad0_d_vdsin=((two_n_phit0*((-d_vdx0_d_vdsin)-(d_vtof_d_vdsin-(((0.1*alpha_phit)*d_ffd0_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etad0_d_qcbflag=((two_n_phit0*((-d_vdx0_d_qcbflag)-(d_vtof_d_qcbflag-(((0.1*alpha_phit)*d_ffd0_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etad0_d_vcin=((two_n_phit0*((-d_vdx0_d_vcin)-(d_vtof_d_vcin-(((0.1*alpha_phit)*d_ffd0_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etad0_d_vbin=((two_n_phit0*((-d_vdx0_d_vbin)-(d_vtof_d_vbin-(((0.1*alpha_phit)*d_ffd0_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etad0_d_qgsflag=((two_n_phit0*((-d_vdx0_d_qgsflag)-(d_vtof_d_qgsflag-(((0.1*alpha_phit)*d_ffd0_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etad0_d_tambin=((two_n_phit0*((-d_vdx0_d_tambin)-(d_vtof_d_tambin-(((0.1*alpha_phit)*d_ffd0_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etad0_d_tnomin=((two_n_phit0*((-d_vdx0_d_tnomin)-(d_vtof_d_tnomin-(((0.1*alpha_phit)*d_ffd0_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etad0_d_phitin=((two_n_phit0*((-d_vdx0_d_phitin)-(d_vtof_d_phitin-(((0.1*alpha_phit)*d_ffd0_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etad0_d_w=((two_n_phit0*((-d_vdx0_d_w)-(d_vtof_d_w-(((0.1*alpha_phit)*d_ffd0_d_w)+((0.1*d_alpha_phit_d_w)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etad0_d_lin=((two_n_phit0*((-d_vdx0_d_lin)-(d_vtof_d_lin-(((0.1*alpha_phit)*d_ffd0_d_lin)+((0.1*d_alpha_phit_d_lin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etad0_d_cgin=((two_n_phit0*((-d_vdx0_d_cgin)-(d_vtof_d_cgin-(((0.1*alpha_phit)*d_ffd0_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etad0_d_cs=((two_n_phit0*((-d_vdx0_d_cs)-(d_vtof_d_cs-(((0.1*alpha_phit)*d_ffd0_d_cs)+((0.1*d_alpha_phit_d_cs)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etad0_d_cc=((two_n_phit0*((-d_vdx0_d_cc)-(d_vtof_d_cc-(((0.1*alpha_phit)*d_ffd0_d_cc)+((0.1*d_alpha_phit_d_cc)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etad0_d_cb=((two_n_phit0*((-d_vdx0_d_cb)-(d_vtof_d_cb-(((0.1*alpha_phit)*d_ffd0_d_cb)+((0.1*d_alpha_phit_d_cb)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etad0_d_vto=((two_n_phit0*((-d_vdx0_d_vto)-(d_vtof_d_vto-(((0.1*alpha_phit)*d_ffd0_d_vto)+((0.1*d_alpha_phit_d_vto)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etad0_d_ss=((two_n_phit0*((-d_vdx0_d_ss)-(d_vtof_d_ss-(((0.1*alpha_phit)*d_ffd0_d_ss)+((0.1*d_alpha_phit_d_ss)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etad0_d_delta1=((two_n_phit0*((-d_vdx0_d_delta1)-(d_vtof_d_delta1-(((0.1*alpha_phit)*d_ffd0_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etad0_d_delta2=((two_n_phit0*((-d_vdx0_d_delta2)-(d_vtof_d_delta2-(((0.1*alpha_phit)*d_ffd0_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etad0_d_nd=((two_n_phit0*((-d_vdx0_d_nd)-(d_vtof_d_nd-(((0.1*alpha_phit)*d_ffd0_d_nd)+((0.1*d_alpha_phit_d_nd)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etad0_d_alpha=((two_n_phit0*((-d_vdx0_d_alpha)-(d_vtof_d_alpha-(((0.1*alpha_phit)*d_ffd0_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etad0_d_vel0=((two_n_phit0*((-d_vdx0_d_vel0)-(d_vtof_d_vel0-(((0.1*alpha_phit)*d_ffd0_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etad0_d_mu0=((two_n_phit0*((-d_vdx0_d_mu0)-(d_vtof_d_mu0-(((0.1*alpha_phit)*d_ffd0_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etad0_d_beta=((two_n_phit0*((-d_vdx0_d_beta)-(d_vtof_d_beta-(((0.1*alpha_phit)*d_ffd0_d_beta)+((0.1*d_alpha_phit_d_beta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etad0_d_mtheta=((two_n_phit0*((-d_vdx0_d_mtheta)-(d_vtof_d_mtheta-(((0.1*alpha_phit)*d_ffd0_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etad0_d_vtheta=((two_n_phit0*((-d_vdx0_d_vtheta)-(d_vtof_d_vtheta-(((0.1*alpha_phit)*d_ffd0_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etad0_d_vtzeta=((two_n_phit0*((-d_vdx0_d_vtzeta)-(d_vtof_d_vtzeta-(((0.1*alpha_phit)*d_ffd0_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etad0_d_dibsat=((two_n_phit0*((-d_vdx0_d_dibsat)-(d_vtof_d_dibsat-(((0.1*alpha_phit)*d_ffd0_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etad0_d_epsilon=((two_n_phit0*((-d_vdx0_d_epsilon)-(d_vtof_d_epsilon-(((0.1*alpha_phit)*d_ffd0_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etad0_d_vzeta=((two_n_phit0*((-d_vdx0_d_vzeta)-(d_vtof_d_vzeta-(((0.1*alpha_phit)*d_ffd0_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etad0_d_lambda=((two_n_phit0*((-d_vdx0_d_lambda)-(d_vtof_d_lambda-(((0.1*alpha_phit)*d_ffd0_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etad0_d_ngf=((two_n_phit0*((-d_vdx0_d_ngf)-(d_vtof_d_ngf-(((0.1*alpha_phit)*d_ffd0_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etad0_d_type=((two_n_phit0*((-d_vdx0_d_type)-(d_vtof_d_type-(((0.1*alpha_phit)*d_ffd0_d_type)+((0.1*d_alpha_phit_d_type)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etad0=(((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))/two_n_phit0);
if((etad0>50.0))
{
d_qinvd0_d_vgsin=((qref0*d_etad0_d_vgsin)+(d_qref0_d_vgsin*etad0));
d_qinvd0_d_vdsin=((qref0*d_etad0_d_vdsin)+(d_qref0_d_vdsin*etad0));
d_qinvd0_d_qcbflag=((qref0*d_etad0_d_qcbflag)+(d_qref0_d_qcbflag*etad0));
d_qinvd0_d_vcin=((qref0*d_etad0_d_vcin)+(d_qref0_d_vcin*etad0));
d_qinvd0_d_vbin=((qref0*d_etad0_d_vbin)+(d_qref0_d_vbin*etad0));
d_qinvd0_d_qgsflag=((qref0*d_etad0_d_qgsflag)+(d_qref0_d_qgsflag*etad0));
d_qinvd0_d_tambin=((qref0*d_etad0_d_tambin)+(d_qref0_d_tambin*etad0));
d_qinvd0_d_tnomin=((qref0*d_etad0_d_tnomin)+(d_qref0_d_tnomin*etad0));
d_qinvd0_d_phitin=((qref0*d_etad0_d_phitin)+(d_qref0_d_phitin*etad0));
d_qinvd0_d_w=((qref0*d_etad0_d_w)+(d_qref0_d_w*etad0));
d_qinvd0_d_lin=((qref0*d_etad0_d_lin)+(d_qref0_d_lin*etad0));
d_qinvd0_d_cgin=((qref0*d_etad0_d_cgin)+(d_qref0_d_cgin*etad0));
d_qinvd0_d_cs=((qref0*d_etad0_d_cs)+(d_qref0_d_cs*etad0));
d_qinvd0_d_cc=((qref0*d_etad0_d_cc)+(d_qref0_d_cc*etad0));
d_qinvd0_d_cb=((qref0*d_etad0_d_cb)+(d_qref0_d_cb*etad0));
d_qinvd0_d_vto=((qref0*d_etad0_d_vto)+(d_qref0_d_vto*etad0));
d_qinvd0_d_ss=((qref0*d_etad0_d_ss)+(d_qref0_d_ss*etad0));
d_qinvd0_d_delta1=((qref0*d_etad0_d_delta1)+(d_qref0_d_delta1*etad0));
d_qinvd0_d_delta2=((qref0*d_etad0_d_delta2)+(d_qref0_d_delta2*etad0));
d_qinvd0_d_nd=((qref0*d_etad0_d_nd)+(d_qref0_d_nd*etad0));
d_qinvd0_d_alpha=((qref0*d_etad0_d_alpha)+(d_qref0_d_alpha*etad0));
d_qinvd0_d_vel0=((qref0*d_etad0_d_vel0)+(d_qref0_d_vel0*etad0));
d_qinvd0_d_mu0=((qref0*d_etad0_d_mu0)+(d_qref0_d_mu0*etad0));
d_qinvd0_d_beta=((qref0*d_etad0_d_beta)+(d_qref0_d_beta*etad0));
d_qinvd0_d_mtheta=((qref0*d_etad0_d_mtheta)+(d_qref0_d_mtheta*etad0));
d_qinvd0_d_vtheta=((qref0*d_etad0_d_vtheta)+(d_qref0_d_vtheta*etad0));
d_qinvd0_d_vtzeta=((qref0*d_etad0_d_vtzeta)+(d_qref0_d_vtzeta*etad0));
d_qinvd0_d_dibsat=((qref0*d_etad0_d_dibsat)+(d_qref0_d_dibsat*etad0));
d_qinvd0_d_epsilon=((qref0*d_etad0_d_epsilon)+(d_qref0_d_epsilon*etad0));
d_qinvd0_d_vzeta=((qref0*d_etad0_d_vzeta)+(d_qref0_d_vzeta*etad0));
d_qinvd0_d_lambda=((qref0*d_etad0_d_lambda)+(d_qref0_d_lambda*etad0));
d_qinvd0_d_ngf=((qref0*d_etad0_d_ngf)+(d_qref0_d_ngf*etad0));
d_qinvd0_d_type=((qref0*d_etad0_d_type)+(d_qref0_d_type*etad0));
qinvd0=(qref0*etad0);
}
else
{
if((etad0<(-50.0)))
{
d_qinvd0_d_vgsin=0.0;
d_qinvd0_d_vdsin=0.0;
d_qinvd0_d_qcbflag=0.0;
d_qinvd0_d_vcin=0.0;
d_qinvd0_d_vbin=0.0;
d_qinvd0_d_qgsflag=0.0;
d_qinvd0_d_tambin=0.0;
d_qinvd0_d_tnomin=0.0;
d_qinvd0_d_phitin=0.0;
d_qinvd0_d_w=0.0;
d_qinvd0_d_lin=0.0;
d_qinvd0_d_cgin=0.0;
d_qinvd0_d_cs=0.0;
d_qinvd0_d_cc=0.0;
d_qinvd0_d_cb=0.0;
d_qinvd0_d_vto=0.0;
d_qinvd0_d_ss=0.0;
d_qinvd0_d_delta1=0.0;
d_qinvd0_d_delta2=0.0;
d_qinvd0_d_nd=0.0;
d_qinvd0_d_alpha=0.0;
d_qinvd0_d_vel0=0.0;
d_qinvd0_d_mu0=0.0;
d_qinvd0_d_beta=0.0;
d_qinvd0_d_mtheta=0.0;
d_qinvd0_d_vtheta=0.0;
d_qinvd0_d_vtzeta=0.0;
d_qinvd0_d_dibsat=0.0;
d_qinvd0_d_epsilon=0.0;
d_qinvd0_d_vzeta=0.0;
d_qinvd0_d_lambda=0.0;
d_qinvd0_d_ngf=0.0;
d_qinvd0_d_type=0.0;
qinvd0=0;
}
else
{
d_qinvd0_d_vgsin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vgsin)+(d_qref0_d_vgsin*log((1.0+exp(etad0)))));
d_qinvd0_d_vdsin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vdsin)+(d_qref0_d_vdsin*log((1.0+exp(etad0)))));
d_qinvd0_d_qcbflag=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_qcbflag)+(d_qref0_d_qcbflag*log((1.0+exp(etad0)))));
d_qinvd0_d_vcin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vcin)+(d_qref0_d_vcin*log((1.0+exp(etad0)))));
d_qinvd0_d_vbin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vbin)+(d_qref0_d_vbin*log((1.0+exp(etad0)))));
d_qinvd0_d_qgsflag=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_qgsflag)+(d_qref0_d_qgsflag*log((1.0+exp(etad0)))));
d_qinvd0_d_tambin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_tambin)+(d_qref0_d_tambin*log((1.0+exp(etad0)))));
d_qinvd0_d_tnomin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_tnomin)+(d_qref0_d_tnomin*log((1.0+exp(etad0)))));
d_qinvd0_d_phitin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_phitin)+(d_qref0_d_phitin*log((1.0+exp(etad0)))));
d_qinvd0_d_w=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_w)+(d_qref0_d_w*log((1.0+exp(etad0)))));
d_qinvd0_d_lin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_lin)+(d_qref0_d_lin*log((1.0+exp(etad0)))));
d_qinvd0_d_cgin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cgin)+(d_qref0_d_cgin*log((1.0+exp(etad0)))));
d_qinvd0_d_cs=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cs)+(d_qref0_d_cs*log((1.0+exp(etad0)))));
d_qinvd0_d_cc=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cc)+(d_qref0_d_cc*log((1.0+exp(etad0)))));
d_qinvd0_d_cb=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cb)+(d_qref0_d_cb*log((1.0+exp(etad0)))));
d_qinvd0_d_vto=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vto)+(d_qref0_d_vto*log((1.0+exp(etad0)))));
d_qinvd0_d_ss=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_ss)+(d_qref0_d_ss*log((1.0+exp(etad0)))));
d_qinvd0_d_delta1=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_delta1)+(d_qref0_d_delta1*log((1.0+exp(etad0)))));
d_qinvd0_d_delta2=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_delta2)+(d_qref0_d_delta2*log((1.0+exp(etad0)))));
d_qinvd0_d_nd=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_nd)+(d_qref0_d_nd*log((1.0+exp(etad0)))));
d_qinvd0_d_alpha=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_alpha)+(d_qref0_d_alpha*log((1.0+exp(etad0)))));
d_qinvd0_d_vel0=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vel0)+(d_qref0_d_vel0*log((1.0+exp(etad0)))));
d_qinvd0_d_mu0=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_mu0)+(d_qref0_d_mu0*log((1.0+exp(etad0)))));
d_qinvd0_d_beta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_beta)+(d_qref0_d_beta*log((1.0+exp(etad0)))));
d_qinvd0_d_mtheta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_mtheta)+(d_qref0_d_mtheta*log((1.0+exp(etad0)))));
d_qinvd0_d_vtheta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vtheta)+(d_qref0_d_vtheta*log((1.0+exp(etad0)))));
d_qinvd0_d_vtzeta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vtzeta)+(d_qref0_d_vtzeta*log((1.0+exp(etad0)))));
d_qinvd0_d_dibsat=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_dibsat)+(d_qref0_d_dibsat*log((1.0+exp(etad0)))));
d_qinvd0_d_epsilon=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_epsilon)+(d_qref0_d_epsilon*log((1.0+exp(etad0)))));
d_qinvd0_d_vzeta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vzeta)+(d_qref0_d_vzeta*log((1.0+exp(etad0)))));
d_qinvd0_d_lambda=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_lambda)+(d_qref0_d_lambda*log((1.0+exp(etad0)))));
d_qinvd0_d_ngf=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_ngf)+(d_qref0_d_ngf*log((1.0+exp(etad0)))));
d_qinvd0_d_type=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_type)+(d_qref0_d_type*log((1.0+exp(etad0)))));
qinvd0=(qref0*log((1.0+exp(etad0))));
}
}
d_qs2_d_vgsin=((qinvs0*d_qinvs0_d_vgsin)+(d_qinvs0_d_vgsin*qinvs0));
d_qs2_d_vdsin=((qinvs0*d_qinvs0_d_vdsin)+(d_qinvs0_d_vdsin*qinvs0));
d_qs2_d_qcbflag=((qinvs0*d_qinvs0_d_qcbflag)+(d_qinvs0_d_qcbflag*qinvs0));
d_qs2_d_vcin=((qinvs0*d_qinvs0_d_vcin)+(d_qinvs0_d_vcin*qinvs0));
d_qs2_d_vbin=((qinvs0*d_qinvs0_d_vbin)+(d_qinvs0_d_vbin*qinvs0));
d_qs2_d_qgsflag=((qinvs0*d_qinvs0_d_qgsflag)+(d_qinvs0_d_qgsflag*qinvs0));
d_qs2_d_tambin=((qinvs0*d_qinvs0_d_tambin)+(d_qinvs0_d_tambin*qinvs0));
d_qs2_d_tnomin=((qinvs0*d_qinvs0_d_tnomin)+(d_qinvs0_d_tnomin*qinvs0));
d_qs2_d_phitin=((qinvs0*d_qinvs0_d_phitin)+(d_qinvs0_d_phitin*qinvs0));
d_qs2_d_w=((qinvs0*d_qinvs0_d_w)+(d_qinvs0_d_w*qinvs0));
d_qs2_d_lin=((qinvs0*d_qinvs0_d_lin)+(d_qinvs0_d_lin*qinvs0));
d_qs2_d_cgin=((qinvs0*d_qinvs0_d_cgin)+(d_qinvs0_d_cgin*qinvs0));
d_qs2_d_cs=((qinvs0*d_qinvs0_d_cs)+(d_qinvs0_d_cs*qinvs0));
d_qs2_d_cc=((qinvs0*d_qinvs0_d_cc)+(d_qinvs0_d_cc*qinvs0));
d_qs2_d_cb=((qinvs0*d_qinvs0_d_cb)+(d_qinvs0_d_cb*qinvs0));
d_qs2_d_vto=((qinvs0*d_qinvs0_d_vto)+(d_qinvs0_d_vto*qinvs0));
d_qs2_d_ss=((qinvs0*d_qinvs0_d_ss)+(d_qinvs0_d_ss*qinvs0));
d_qs2_d_delta1=((qinvs0*d_qinvs0_d_delta1)+(d_qinvs0_d_delta1*qinvs0));
d_qs2_d_delta2=((qinvs0*d_qinvs0_d_delta2)+(d_qinvs0_d_delta2*qinvs0));
d_qs2_d_nd=((qinvs0*d_qinvs0_d_nd)+(d_qinvs0_d_nd*qinvs0));
d_qs2_d_alpha=((qinvs0*d_qinvs0_d_alpha)+(d_qinvs0_d_alpha*qinvs0));
d_qs2_d_vel0=((qinvs0*d_qinvs0_d_vel0)+(d_qinvs0_d_vel0*qinvs0));
d_qs2_d_mu0=((qinvs0*d_qinvs0_d_mu0)+(d_qinvs0_d_mu0*qinvs0));
d_qs2_d_beta=((qinvs0*d_qinvs0_d_beta)+(d_qinvs0_d_beta*qinvs0));
d_qs2_d_mtheta=((qinvs0*d_qinvs0_d_mtheta)+(d_qinvs0_d_mtheta*qinvs0));
d_qs2_d_vtheta=((qinvs0*d_qinvs0_d_vtheta)+(d_qinvs0_d_vtheta*qinvs0));
d_qs2_d_vtzeta=((qinvs0*d_qinvs0_d_vtzeta)+(d_qinvs0_d_vtzeta*qinvs0));
d_qs2_d_dibsat=((qinvs0*d_qinvs0_d_dibsat)+(d_qinvs0_d_dibsat*qinvs0));
d_qs2_d_epsilon=((qinvs0*d_qinvs0_d_epsilon)+(d_qinvs0_d_epsilon*qinvs0));
d_qs2_d_vzeta=((qinvs0*d_qinvs0_d_vzeta)+(d_qinvs0_d_vzeta*qinvs0));
d_qs2_d_lambda=((qinvs0*d_qinvs0_d_lambda)+(d_qinvs0_d_lambda*qinvs0));
d_qs2_d_ngf=((qinvs0*d_qinvs0_d_ngf)+(d_qinvs0_d_ngf*qinvs0));
d_qs2_d_type=((qinvs0*d_qinvs0_d_type)+(d_qinvs0_d_type*qinvs0));
qs2=((qinvs0*qinvs0)+1e-38);
d_qs3_d_vgsin=((qs2*d_qinvs0_d_vgsin)+(d_qs2_d_vgsin*qinvs0));
d_qs3_d_vdsin=((qs2*d_qinvs0_d_vdsin)+(d_qs2_d_vdsin*qinvs0));
d_qs3_d_qcbflag=((qs2*d_qinvs0_d_qcbflag)+(d_qs2_d_qcbflag*qinvs0));
d_qs3_d_vcin=((qs2*d_qinvs0_d_vcin)+(d_qs2_d_vcin*qinvs0));
d_qs3_d_vbin=((qs2*d_qinvs0_d_vbin)+(d_qs2_d_vbin*qinvs0));
d_qs3_d_qgsflag=((qs2*d_qinvs0_d_qgsflag)+(d_qs2_d_qgsflag*qinvs0));
d_qs3_d_tambin=((qs2*d_qinvs0_d_tambin)+(d_qs2_d_tambin*qinvs0));
d_qs3_d_tnomin=((qs2*d_qinvs0_d_tnomin)+(d_qs2_d_tnomin*qinvs0));
d_qs3_d_phitin=((qs2*d_qinvs0_d_phitin)+(d_qs2_d_phitin*qinvs0));
d_qs3_d_w=((qs2*d_qinvs0_d_w)+(d_qs2_d_w*qinvs0));
d_qs3_d_lin=((qs2*d_qinvs0_d_lin)+(d_qs2_d_lin*qinvs0));
d_qs3_d_cgin=((qs2*d_qinvs0_d_cgin)+(d_qs2_d_cgin*qinvs0));
d_qs3_d_cs=((qs2*d_qinvs0_d_cs)+(d_qs2_d_cs*qinvs0));
d_qs3_d_cc=((qs2*d_qinvs0_d_cc)+(d_qs2_d_cc*qinvs0));
d_qs3_d_cb=((qs2*d_qinvs0_d_cb)+(d_qs2_d_cb*qinvs0));
d_qs3_d_vto=((qs2*d_qinvs0_d_vto)+(d_qs2_d_vto*qinvs0));
d_qs3_d_ss=((qs2*d_qinvs0_d_ss)+(d_qs2_d_ss*qinvs0));
d_qs3_d_delta1=((qs2*d_qinvs0_d_delta1)+(d_qs2_d_delta1*qinvs0));
d_qs3_d_delta2=((qs2*d_qinvs0_d_delta2)+(d_qs2_d_delta2*qinvs0));
d_qs3_d_nd=((qs2*d_qinvs0_d_nd)+(d_qs2_d_nd*qinvs0));
d_qs3_d_alpha=((qs2*d_qinvs0_d_alpha)+(d_qs2_d_alpha*qinvs0));
d_qs3_d_vel0=((qs2*d_qinvs0_d_vel0)+(d_qs2_d_vel0*qinvs0));
d_qs3_d_mu0=((qs2*d_qinvs0_d_mu0)+(d_qs2_d_mu0*qinvs0));
d_qs3_d_beta=((qs2*d_qinvs0_d_beta)+(d_qs2_d_beta*qinvs0));
d_qs3_d_mtheta=((qs2*d_qinvs0_d_mtheta)+(d_qs2_d_mtheta*qinvs0));
d_qs3_d_vtheta=((qs2*d_qinvs0_d_vtheta)+(d_qs2_d_vtheta*qinvs0));
d_qs3_d_vtzeta=((qs2*d_qinvs0_d_vtzeta)+(d_qs2_d_vtzeta*qinvs0));
d_qs3_d_dibsat=((qs2*d_qinvs0_d_dibsat)+(d_qs2_d_dibsat*qinvs0));
d_qs3_d_epsilon=((qs2*d_qinvs0_d_epsilon)+(d_qs2_d_epsilon*qinvs0));
d_qs3_d_vzeta=((qs2*d_qinvs0_d_vzeta)+(d_qs2_d_vzeta*qinvs0));
d_qs3_d_lambda=((qs2*d_qinvs0_d_lambda)+(d_qs2_d_lambda*qinvs0));
d_qs3_d_ngf=((qs2*d_qinvs0_d_ngf)+(d_qs2_d_ngf*qinvs0));
d_qs3_d_type=((qs2*d_qinvs0_d_type)+(d_qs2_d_type*qinvs0));
qs3=((qs2*qinvs0)+1e-57);
d_qd2_d_vgsin=((qinvd0*d_qinvd0_d_vgsin)+(d_qinvd0_d_vgsin*qinvd0));
d_qd2_d_vdsin=((qinvd0*d_qinvd0_d_vdsin)+(d_qinvd0_d_vdsin*qinvd0));
d_qd2_d_qcbflag=((qinvd0*d_qinvd0_d_qcbflag)+(d_qinvd0_d_qcbflag*qinvd0));
d_qd2_d_vcin=((qinvd0*d_qinvd0_d_vcin)+(d_qinvd0_d_vcin*qinvd0));
d_qd2_d_vbin=((qinvd0*d_qinvd0_d_vbin)+(d_qinvd0_d_vbin*qinvd0));
d_qd2_d_qgsflag=((qinvd0*d_qinvd0_d_qgsflag)+(d_qinvd0_d_qgsflag*qinvd0));
d_qd2_d_tambin=((qinvd0*d_qinvd0_d_tambin)+(d_qinvd0_d_tambin*qinvd0));
d_qd2_d_tnomin=((qinvd0*d_qinvd0_d_tnomin)+(d_qinvd0_d_tnomin*qinvd0));
d_qd2_d_phitin=((qinvd0*d_qinvd0_d_phitin)+(d_qinvd0_d_phitin*qinvd0));
d_qd2_d_w=((qinvd0*d_qinvd0_d_w)+(d_qinvd0_d_w*qinvd0));
d_qd2_d_lin=((qinvd0*d_qinvd0_d_lin)+(d_qinvd0_d_lin*qinvd0));
d_qd2_d_cgin=((qinvd0*d_qinvd0_d_cgin)+(d_qinvd0_d_cgin*qinvd0));
d_qd2_d_cs=((qinvd0*d_qinvd0_d_cs)+(d_qinvd0_d_cs*qinvd0));
d_qd2_d_cc=((qinvd0*d_qinvd0_d_cc)+(d_qinvd0_d_cc*qinvd0));
d_qd2_d_cb=((qinvd0*d_qinvd0_d_cb)+(d_qinvd0_d_cb*qinvd0));
d_qd2_d_vto=((qinvd0*d_qinvd0_d_vto)+(d_qinvd0_d_vto*qinvd0));
d_qd2_d_ss=((qinvd0*d_qinvd0_d_ss)+(d_qinvd0_d_ss*qinvd0));
d_qd2_d_delta1=((qinvd0*d_qinvd0_d_delta1)+(d_qinvd0_d_delta1*qinvd0));
d_qd2_d_delta2=((qinvd0*d_qinvd0_d_delta2)+(d_qinvd0_d_delta2*qinvd0));
d_qd2_d_nd=((qinvd0*d_qinvd0_d_nd)+(d_qinvd0_d_nd*qinvd0));
d_qd2_d_alpha=((qinvd0*d_qinvd0_d_alpha)+(d_qinvd0_d_alpha*qinvd0));
d_qd2_d_vel0=((qinvd0*d_qinvd0_d_vel0)+(d_qinvd0_d_vel0*qinvd0));
d_qd2_d_mu0=((qinvd0*d_qinvd0_d_mu0)+(d_qinvd0_d_mu0*qinvd0));
d_qd2_d_beta=((qinvd0*d_qinvd0_d_beta)+(d_qinvd0_d_beta*qinvd0));
d_qd2_d_mtheta=((qinvd0*d_qinvd0_d_mtheta)+(d_qinvd0_d_mtheta*qinvd0));
d_qd2_d_vtheta=((qinvd0*d_qinvd0_d_vtheta)+(d_qinvd0_d_vtheta*qinvd0));
d_qd2_d_vtzeta=((qinvd0*d_qinvd0_d_vtzeta)+(d_qinvd0_d_vtzeta*qinvd0));
d_qd2_d_dibsat=((qinvd0*d_qinvd0_d_dibsat)+(d_qinvd0_d_dibsat*qinvd0));
d_qd2_d_epsilon=((qinvd0*d_qinvd0_d_epsilon)+(d_qinvd0_d_epsilon*qinvd0));
d_qd2_d_vzeta=((qinvd0*d_qinvd0_d_vzeta)+(d_qinvd0_d_vzeta*qinvd0));
d_qd2_d_lambda=((qinvd0*d_qinvd0_d_lambda)+(d_qinvd0_d_lambda*qinvd0));
d_qd2_d_ngf=((qinvd0*d_qinvd0_d_ngf)+(d_qinvd0_d_ngf*qinvd0));
d_qd2_d_type=((qinvd0*d_qinvd0_d_type)+(d_qinvd0_d_type*qinvd0));
qd2=((qinvd0*qinvd0)+1e-38);
d_qd3_d_vgsin=((qd2*d_qinvd0_d_vgsin)+(d_qd2_d_vgsin*qinvd0));
d_qd3_d_vdsin=((qd2*d_qinvd0_d_vdsin)+(d_qd2_d_vdsin*qinvd0));
d_qd3_d_qcbflag=((qd2*d_qinvd0_d_qcbflag)+(d_qd2_d_qcbflag*qinvd0));
d_qd3_d_vcin=((qd2*d_qinvd0_d_vcin)+(d_qd2_d_vcin*qinvd0));
d_qd3_d_vbin=((qd2*d_qinvd0_d_vbin)+(d_qd2_d_vbin*qinvd0));
d_qd3_d_qgsflag=((qd2*d_qinvd0_d_qgsflag)+(d_qd2_d_qgsflag*qinvd0));
d_qd3_d_tambin=((qd2*d_qinvd0_d_tambin)+(d_qd2_d_tambin*qinvd0));
d_qd3_d_tnomin=((qd2*d_qinvd0_d_tnomin)+(d_qd2_d_tnomin*qinvd0));
d_qd3_d_phitin=((qd2*d_qinvd0_d_phitin)+(d_qd2_d_phitin*qinvd0));
d_qd3_d_w=((qd2*d_qinvd0_d_w)+(d_qd2_d_w*qinvd0));
d_qd3_d_lin=((qd2*d_qinvd0_d_lin)+(d_qd2_d_lin*qinvd0));
d_qd3_d_cgin=((qd2*d_qinvd0_d_cgin)+(d_qd2_d_cgin*qinvd0));
d_qd3_d_cs=((qd2*d_qinvd0_d_cs)+(d_qd2_d_cs*qinvd0));
d_qd3_d_cc=((qd2*d_qinvd0_d_cc)+(d_qd2_d_cc*qinvd0));
d_qd3_d_cb=((qd2*d_qinvd0_d_cb)+(d_qd2_d_cb*qinvd0));
d_qd3_d_vto=((qd2*d_qinvd0_d_vto)+(d_qd2_d_vto*qinvd0));
d_qd3_d_ss=((qd2*d_qinvd0_d_ss)+(d_qd2_d_ss*qinvd0));
d_qd3_d_delta1=((qd2*d_qinvd0_d_delta1)+(d_qd2_d_delta1*qinvd0));
d_qd3_d_delta2=((qd2*d_qinvd0_d_delta2)+(d_qd2_d_delta2*qinvd0));
d_qd3_d_nd=((qd2*d_qinvd0_d_nd)+(d_qd2_d_nd*qinvd0));
d_qd3_d_alpha=((qd2*d_qinvd0_d_alpha)+(d_qd2_d_alpha*qinvd0));
d_qd3_d_vel0=((qd2*d_qinvd0_d_vel0)+(d_qd2_d_vel0*qinvd0));
d_qd3_d_mu0=((qd2*d_qinvd0_d_mu0)+(d_qd2_d_mu0*qinvd0));
d_qd3_d_beta=((qd2*d_qinvd0_d_beta)+(d_qd2_d_beta*qinvd0));
d_qd3_d_mtheta=((qd2*d_qinvd0_d_mtheta)+(d_qd2_d_mtheta*qinvd0));
d_qd3_d_vtheta=((qd2*d_qinvd0_d_vtheta)+(d_qd2_d_vtheta*qinvd0));
d_qd3_d_vtzeta=((qd2*d_qinvd0_d_vtzeta)+(d_qd2_d_vtzeta*qinvd0));
d_qd3_d_dibsat=((qd2*d_qinvd0_d_dibsat)+(d_qd2_d_dibsat*qinvd0));
d_qd3_d_epsilon=((qd2*d_qinvd0_d_epsilon)+(d_qd2_d_epsilon*qinvd0));
d_qd3_d_vzeta=((qd2*d_qinvd0_d_vzeta)+(d_qd2_d_vzeta*qinvd0));
d_qd3_d_lambda=((qd2*d_qinvd0_d_lambda)+(d_qd2_d_lambda*qinvd0));
d_qd3_d_ngf=((qd2*d_qinvd0_d_ngf)+(d_qd2_d_ngf*qinvd0));
d_qd3_d_type=((qd2*d_qinvd0_d_type)+(d_qd2_d_type*qinvd0));
qd3=((qd2*qinvd0)+1e-57);
d_qsqd_d_vgsin=((qinvs0*d_qinvd0_d_vgsin)+(d_qinvs0_d_vgsin*qinvd0));
d_qsqd_d_vdsin=((qinvs0*d_qinvd0_d_vdsin)+(d_qinvs0_d_vdsin*qinvd0));
d_qsqd_d_qcbflag=((qinvs0*d_qinvd0_d_qcbflag)+(d_qinvs0_d_qcbflag*qinvd0));
d_qsqd_d_vcin=((qinvs0*d_qinvd0_d_vcin)+(d_qinvs0_d_vcin*qinvd0));
d_qsqd_d_vbin=((qinvs0*d_qinvd0_d_vbin)+(d_qinvs0_d_vbin*qinvd0));
d_qsqd_d_qgsflag=((qinvs0*d_qinvd0_d_qgsflag)+(d_qinvs0_d_qgsflag*qinvd0));
d_qsqd_d_tambin=((qinvs0*d_qinvd0_d_tambin)+(d_qinvs0_d_tambin*qinvd0));
d_qsqd_d_tnomin=((qinvs0*d_qinvd0_d_tnomin)+(d_qinvs0_d_tnomin*qinvd0));
d_qsqd_d_phitin=((qinvs0*d_qinvd0_d_phitin)+(d_qinvs0_d_phitin*qinvd0));
d_qsqd_d_w=((qinvs0*d_qinvd0_d_w)+(d_qinvs0_d_w*qinvd0));
d_qsqd_d_lin=((qinvs0*d_qinvd0_d_lin)+(d_qinvs0_d_lin*qinvd0));
d_qsqd_d_cgin=((qinvs0*d_qinvd0_d_cgin)+(d_qinvs0_d_cgin*qinvd0));
d_qsqd_d_cs=((qinvs0*d_qinvd0_d_cs)+(d_qinvs0_d_cs*qinvd0));
d_qsqd_d_cc=((qinvs0*d_qinvd0_d_cc)+(d_qinvs0_d_cc*qinvd0));
d_qsqd_d_cb=((qinvs0*d_qinvd0_d_cb)+(d_qinvs0_d_cb*qinvd0));
d_qsqd_d_vto=((qinvs0*d_qinvd0_d_vto)+(d_qinvs0_d_vto*qinvd0));
d_qsqd_d_ss=((qinvs0*d_qinvd0_d_ss)+(d_qinvs0_d_ss*qinvd0));
d_qsqd_d_delta1=((qinvs0*d_qinvd0_d_delta1)+(d_qinvs0_d_delta1*qinvd0));
d_qsqd_d_delta2=((qinvs0*d_qinvd0_d_delta2)+(d_qinvs0_d_delta2*qinvd0));
d_qsqd_d_nd=((qinvs0*d_qinvd0_d_nd)+(d_qinvs0_d_nd*qinvd0));
d_qsqd_d_alpha=((qinvs0*d_qinvd0_d_alpha)+(d_qinvs0_d_alpha*qinvd0));
d_qsqd_d_vel0=((qinvs0*d_qinvd0_d_vel0)+(d_qinvs0_d_vel0*qinvd0));
d_qsqd_d_mu0=((qinvs0*d_qinvd0_d_mu0)+(d_qinvs0_d_mu0*qinvd0));
d_qsqd_d_beta=((qinvs0*d_qinvd0_d_beta)+(d_qinvs0_d_beta*qinvd0));
d_qsqd_d_mtheta=((qinvs0*d_qinvd0_d_mtheta)+(d_qinvs0_d_mtheta*qinvd0));
d_qsqd_d_vtheta=((qinvs0*d_qinvd0_d_vtheta)+(d_qinvs0_d_vtheta*qinvd0));
d_qsqd_d_vtzeta=((qinvs0*d_qinvd0_d_vtzeta)+(d_qinvs0_d_vtzeta*qinvd0));
d_qsqd_d_dibsat=((qinvs0*d_qinvd0_d_dibsat)+(d_qinvs0_d_dibsat*qinvd0));
d_qsqd_d_epsilon=((qinvs0*d_qinvd0_d_epsilon)+(d_qinvs0_d_epsilon*qinvd0));
d_qsqd_d_vzeta=((qinvs0*d_qinvd0_d_vzeta)+(d_qinvs0_d_vzeta*qinvd0));
d_qsqd_d_lambda=((qinvs0*d_qinvd0_d_lambda)+(d_qinvs0_d_lambda*qinvd0));
d_qsqd_d_ngf=((qinvs0*d_qinvd0_d_ngf)+(d_qinvs0_d_ngf*qinvd0));
d_qsqd_d_type=((qinvs0*d_qinvd0_d_type)+(d_qinvs0_d_type*qinvd0));
qsqd=((qinvs0*qinvd0)+1e-38);
d_qinvdd_d_vgsin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vgsin+d_qd2_d_vgsin)+d_qsqd_d_vgsin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vgsin+d_qinvd0_d_vgsin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vdsin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vdsin+d_qd2_d_vdsin)+d_qsqd_d_vdsin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vdsin+d_qinvd0_d_vdsin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_qcbflag=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_qcbflag+d_qd2_d_qcbflag)+d_qsqd_d_qcbflag))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_qcbflag+d_qinvd0_d_qcbflag))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vcin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vcin+d_qd2_d_vcin)+d_qsqd_d_vcin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vcin+d_qinvd0_d_vcin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vbin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vbin+d_qd2_d_vbin)+d_qsqd_d_vbin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vbin+d_qinvd0_d_vbin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_qgsflag=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_qgsflag+d_qd2_d_qgsflag)+d_qsqd_d_qgsflag))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_qgsflag+d_qinvd0_d_qgsflag))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_tambin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_tambin+d_qd2_d_tambin)+d_qsqd_d_tambin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_tambin+d_qinvd0_d_tambin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_tnomin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_tnomin+d_qd2_d_tnomin)+d_qsqd_d_tnomin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_tnomin+d_qinvd0_d_tnomin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_phitin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_phitin+d_qd2_d_phitin)+d_qsqd_d_phitin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_phitin+d_qinvd0_d_phitin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_w=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_w+d_qd2_d_w)+d_qsqd_d_w))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_w+d_qinvd0_d_w))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_lin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_lin+d_qd2_d_lin)+d_qsqd_d_lin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_lin+d_qinvd0_d_lin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cgin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cgin+d_qd2_d_cgin)+d_qsqd_d_cgin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cgin+d_qinvd0_d_cgin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cs=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cs+d_qd2_d_cs)+d_qsqd_d_cs))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cs+d_qinvd0_d_cs))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cc=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cc+d_qd2_d_cc)+d_qsqd_d_cc))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cc+d_qinvd0_d_cc))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cb=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cb+d_qd2_d_cb)+d_qsqd_d_cb))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cb+d_qinvd0_d_cb))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vto=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vto+d_qd2_d_vto)+d_qsqd_d_vto))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vto+d_qinvd0_d_vto))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_ss=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_ss+d_qd2_d_ss)+d_qsqd_d_ss))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_ss+d_qinvd0_d_ss))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_delta1=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_delta1+d_qd2_d_delta1)+d_qsqd_d_delta1))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_delta1+d_qinvd0_d_delta1))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_delta2=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_delta2+d_qd2_d_delta2)+d_qsqd_d_delta2))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_delta2+d_qinvd0_d_delta2))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_nd=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_nd+d_qd2_d_nd)+d_qsqd_d_nd))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_nd+d_qinvd0_d_nd))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_alpha=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_alpha+d_qd2_d_alpha)+d_qsqd_d_alpha))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_alpha+d_qinvd0_d_alpha))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vel0=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vel0+d_qd2_d_vel0)+d_qsqd_d_vel0))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vel0+d_qinvd0_d_vel0))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_mu0=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_mu0+d_qd2_d_mu0)+d_qsqd_d_mu0))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_mu0+d_qinvd0_d_mu0))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_beta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_beta+d_qd2_d_beta)+d_qsqd_d_beta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_beta+d_qinvd0_d_beta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_mtheta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_mtheta+d_qd2_d_mtheta)+d_qsqd_d_mtheta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_mtheta+d_qinvd0_d_mtheta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vtheta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vtheta+d_qd2_d_vtheta)+d_qsqd_d_vtheta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vtheta+d_qinvd0_d_vtheta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vtzeta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vtzeta+d_qd2_d_vtzeta)+d_qsqd_d_vtzeta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vtzeta+d_qinvd0_d_vtzeta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_dibsat=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_dibsat+d_qd2_d_dibsat)+d_qsqd_d_dibsat))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_dibsat+d_qinvd0_d_dibsat))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_epsilon=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_epsilon+d_qd2_d_epsilon)+d_qsqd_d_epsilon))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_epsilon+d_qinvd0_d_epsilon))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vzeta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vzeta+d_qd2_d_vzeta)+d_qsqd_d_vzeta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vzeta+d_qinvd0_d_vzeta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_lambda=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_lambda+d_qd2_d_lambda)+d_qsqd_d_lambda))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_lambda+d_qinvd0_d_lambda))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_ngf=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_ngf+d_qd2_d_ngf)+d_qsqd_d_ngf))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_ngf+d_qinvd0_d_ngf))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_type=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_type+d_qd2_d_type)+d_qsqd_d_type))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_type+d_qinvd0_d_type))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
qinvdd=(((2.0/3.0)*((qs2+qd2)+qsqd))/((qinvs0+qinvd0)+2e-19));
d_qd1_d_vgsin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vgsin)+(3.0*d_qd3_d_vgsin))+(((4.0*qs2)*d_qinvd0_d_vgsin)+((4.0*d_qs2_d_vgsin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vgsin)+((6.0*d_qd2_d_vgsin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vgsin+d_qd2_d_vgsin)+(2.0*d_qsqd_d_vgsin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vdsin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vdsin)+(3.0*d_qd3_d_vdsin))+(((4.0*qs2)*d_qinvd0_d_vdsin)+((4.0*d_qs2_d_vdsin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vdsin)+((6.0*d_qd2_d_vdsin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vdsin+d_qd2_d_vdsin)+(2.0*d_qsqd_d_vdsin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_qcbflag=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_qcbflag)+(3.0*d_qd3_d_qcbflag))+(((4.0*qs2)*d_qinvd0_d_qcbflag)+((4.0*d_qs2_d_qcbflag)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_qcbflag)+((6.0*d_qd2_d_qcbflag)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_qcbflag+d_qd2_d_qcbflag)+(2.0*d_qsqd_d_qcbflag))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vcin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vcin)+(3.0*d_qd3_d_vcin))+(((4.0*qs2)*d_qinvd0_d_vcin)+((4.0*d_qs2_d_vcin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vcin)+((6.0*d_qd2_d_vcin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vcin+d_qd2_d_vcin)+(2.0*d_qsqd_d_vcin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vbin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vbin)+(3.0*d_qd3_d_vbin))+(((4.0*qs2)*d_qinvd0_d_vbin)+((4.0*d_qs2_d_vbin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vbin)+((6.0*d_qd2_d_vbin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vbin+d_qd2_d_vbin)+(2.0*d_qsqd_d_vbin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_qgsflag=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_qgsflag)+(3.0*d_qd3_d_qgsflag))+(((4.0*qs2)*d_qinvd0_d_qgsflag)+((4.0*d_qs2_d_qgsflag)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_qgsflag)+((6.0*d_qd2_d_qgsflag)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_qgsflag+d_qd2_d_qgsflag)+(2.0*d_qsqd_d_qgsflag))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_tambin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_tambin)+(3.0*d_qd3_d_tambin))+(((4.0*qs2)*d_qinvd0_d_tambin)+((4.0*d_qs2_d_tambin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_tambin)+((6.0*d_qd2_d_tambin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_tambin+d_qd2_d_tambin)+(2.0*d_qsqd_d_tambin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_tnomin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_tnomin)+(3.0*d_qd3_d_tnomin))+(((4.0*qs2)*d_qinvd0_d_tnomin)+((4.0*d_qs2_d_tnomin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_tnomin)+((6.0*d_qd2_d_tnomin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_tnomin+d_qd2_d_tnomin)+(2.0*d_qsqd_d_tnomin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_phitin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_phitin)+(3.0*d_qd3_d_phitin))+(((4.0*qs2)*d_qinvd0_d_phitin)+((4.0*d_qs2_d_phitin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_phitin)+((6.0*d_qd2_d_phitin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_phitin+d_qd2_d_phitin)+(2.0*d_qsqd_d_phitin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_w=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_w)+(3.0*d_qd3_d_w))+(((4.0*qs2)*d_qinvd0_d_w)+((4.0*d_qs2_d_w)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_w)+((6.0*d_qd2_d_w)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_w+d_qd2_d_w)+(2.0*d_qsqd_d_w))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_lin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_lin)+(3.0*d_qd3_d_lin))+(((4.0*qs2)*d_qinvd0_d_lin)+((4.0*d_qs2_d_lin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_lin)+((6.0*d_qd2_d_lin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_lin+d_qd2_d_lin)+(2.0*d_qsqd_d_lin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cgin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cgin)+(3.0*d_qd3_d_cgin))+(((4.0*qs2)*d_qinvd0_d_cgin)+((4.0*d_qs2_d_cgin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cgin)+((6.0*d_qd2_d_cgin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cgin+d_qd2_d_cgin)+(2.0*d_qsqd_d_cgin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cs=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cs)+(3.0*d_qd3_d_cs))+(((4.0*qs2)*d_qinvd0_d_cs)+((4.0*d_qs2_d_cs)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cs)+((6.0*d_qd2_d_cs)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cs+d_qd2_d_cs)+(2.0*d_qsqd_d_cs))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cc=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cc)+(3.0*d_qd3_d_cc))+(((4.0*qs2)*d_qinvd0_d_cc)+((4.0*d_qs2_d_cc)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cc)+((6.0*d_qd2_d_cc)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cc+d_qd2_d_cc)+(2.0*d_qsqd_d_cc))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cb=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cb)+(3.0*d_qd3_d_cb))+(((4.0*qs2)*d_qinvd0_d_cb)+((4.0*d_qs2_d_cb)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cb)+((6.0*d_qd2_d_cb)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cb+d_qd2_d_cb)+(2.0*d_qsqd_d_cb))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vto=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vto)+(3.0*d_qd3_d_vto))+(((4.0*qs2)*d_qinvd0_d_vto)+((4.0*d_qs2_d_vto)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vto)+((6.0*d_qd2_d_vto)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vto+d_qd2_d_vto)+(2.0*d_qsqd_d_vto))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_ss=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_ss)+(3.0*d_qd3_d_ss))+(((4.0*qs2)*d_qinvd0_d_ss)+((4.0*d_qs2_d_ss)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_ss)+((6.0*d_qd2_d_ss)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_ss+d_qd2_d_ss)+(2.0*d_qsqd_d_ss))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_delta1=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_delta1)+(3.0*d_qd3_d_delta1))+(((4.0*qs2)*d_qinvd0_d_delta1)+((4.0*d_qs2_d_delta1)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_delta1)+((6.0*d_qd2_d_delta1)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_delta1+d_qd2_d_delta1)+(2.0*d_qsqd_d_delta1))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_delta2=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_delta2)+(3.0*d_qd3_d_delta2))+(((4.0*qs2)*d_qinvd0_d_delta2)+((4.0*d_qs2_d_delta2)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_delta2)+((6.0*d_qd2_d_delta2)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_delta2+d_qd2_d_delta2)+(2.0*d_qsqd_d_delta2))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_nd=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_nd)+(3.0*d_qd3_d_nd))+(((4.0*qs2)*d_qinvd0_d_nd)+((4.0*d_qs2_d_nd)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_nd)+((6.0*d_qd2_d_nd)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_nd+d_qd2_d_nd)+(2.0*d_qsqd_d_nd))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_alpha=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_alpha)+(3.0*d_qd3_d_alpha))+(((4.0*qs2)*d_qinvd0_d_alpha)+((4.0*d_qs2_d_alpha)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_alpha)+((6.0*d_qd2_d_alpha)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_alpha+d_qd2_d_alpha)+(2.0*d_qsqd_d_alpha))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vel0=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vel0)+(3.0*d_qd3_d_vel0))+(((4.0*qs2)*d_qinvd0_d_vel0)+((4.0*d_qs2_d_vel0)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vel0)+((6.0*d_qd2_d_vel0)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vel0+d_qd2_d_vel0)+(2.0*d_qsqd_d_vel0))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_mu0=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_mu0)+(3.0*d_qd3_d_mu0))+(((4.0*qs2)*d_qinvd0_d_mu0)+((4.0*d_qs2_d_mu0)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_mu0)+((6.0*d_qd2_d_mu0)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_mu0+d_qd2_d_mu0)+(2.0*d_qsqd_d_mu0))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_beta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_beta)+(3.0*d_qd3_d_beta))+(((4.0*qs2)*d_qinvd0_d_beta)+((4.0*d_qs2_d_beta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_beta)+((6.0*d_qd2_d_beta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_beta+d_qd2_d_beta)+(2.0*d_qsqd_d_beta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_mtheta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_mtheta)+(3.0*d_qd3_d_mtheta))+(((4.0*qs2)*d_qinvd0_d_mtheta)+((4.0*d_qs2_d_mtheta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_mtheta)+((6.0*d_qd2_d_mtheta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_mtheta+d_qd2_d_mtheta)+(2.0*d_qsqd_d_mtheta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vtheta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vtheta)+(3.0*d_qd3_d_vtheta))+(((4.0*qs2)*d_qinvd0_d_vtheta)+((4.0*d_qs2_d_vtheta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vtheta)+((6.0*d_qd2_d_vtheta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vtheta+d_qd2_d_vtheta)+(2.0*d_qsqd_d_vtheta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vtzeta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vtzeta)+(3.0*d_qd3_d_vtzeta))+(((4.0*qs2)*d_qinvd0_d_vtzeta)+((4.0*d_qs2_d_vtzeta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vtzeta)+((6.0*d_qd2_d_vtzeta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vtzeta+d_qd2_d_vtzeta)+(2.0*d_qsqd_d_vtzeta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_dibsat=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_dibsat)+(3.0*d_qd3_d_dibsat))+(((4.0*qs2)*d_qinvd0_d_dibsat)+((4.0*d_qs2_d_dibsat)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_dibsat)+((6.0*d_qd2_d_dibsat)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_dibsat+d_qd2_d_dibsat)+(2.0*d_qsqd_d_dibsat))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_epsilon=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_epsilon)+(3.0*d_qd3_d_epsilon))+(((4.0*qs2)*d_qinvd0_d_epsilon)+((4.0*d_qs2_d_epsilon)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_epsilon)+((6.0*d_qd2_d_epsilon)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_epsilon+d_qd2_d_epsilon)+(2.0*d_qsqd_d_epsilon))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vzeta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vzeta)+(3.0*d_qd3_d_vzeta))+(((4.0*qs2)*d_qinvd0_d_vzeta)+((4.0*d_qs2_d_vzeta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vzeta)+((6.0*d_qd2_d_vzeta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vzeta+d_qd2_d_vzeta)+(2.0*d_qsqd_d_vzeta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_lambda=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_lambda)+(3.0*d_qd3_d_lambda))+(((4.0*qs2)*d_qinvd0_d_lambda)+((4.0*d_qs2_d_lambda)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_lambda)+((6.0*d_qd2_d_lambda)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_lambda+d_qd2_d_lambda)+(2.0*d_qsqd_d_lambda))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_ngf=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_ngf)+(3.0*d_qd3_d_ngf))+(((4.0*qs2)*d_qinvd0_d_ngf)+((4.0*d_qs2_d_ngf)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_ngf)+((6.0*d_qd2_d_ngf)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_ngf+d_qd2_d_ngf)+(2.0*d_qsqd_d_ngf))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_type=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_type)+(3.0*d_qd3_d_type))+(((4.0*qs2)*d_qinvd0_d_type)+((4.0*d_qs2_d_type)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_type)+((6.0*d_qd2_d_type)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_type+d_qd2_d_type)+(2.0*d_qsqd_d_type))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
qd1=((2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qs_d_vgsin=(d_qinvdd_d_vgsin-d_qd1_d_vgsin);
d_qs_d_vdsin=(d_qinvdd_d_vdsin-d_qd1_d_vdsin);
d_qs_d_qcbflag=(d_qinvdd_d_qcbflag-d_qd1_d_qcbflag);
d_qs_d_vcin=(d_qinvdd_d_vcin-d_qd1_d_vcin);
d_qs_d_vbin=(d_qinvdd_d_vbin-d_qd1_d_vbin);
d_qs_d_qgsflag=(d_qinvdd_d_qgsflag-d_qd1_d_qgsflag);
d_qs_d_tambin=(d_qinvdd_d_tambin-d_qd1_d_tambin);
d_qs_d_tnomin=(d_qinvdd_d_tnomin-d_qd1_d_tnomin);
d_qs_d_phitin=(d_qinvdd_d_phitin-d_qd1_d_phitin);
d_qs_d_w=(d_qinvdd_d_w-d_qd1_d_w);
d_qs_d_lin=(d_qinvdd_d_lin-d_qd1_d_lin);
d_qs_d_cgin=(d_qinvdd_d_cgin-d_qd1_d_cgin);
d_qs_d_cs=(d_qinvdd_d_cs-d_qd1_d_cs);
d_qs_d_cc=(d_qinvdd_d_cc-d_qd1_d_cc);
d_qs_d_cb=(d_qinvdd_d_cb-d_qd1_d_cb);
d_qs_d_vto=(d_qinvdd_d_vto-d_qd1_d_vto);
d_qs_d_ss=(d_qinvdd_d_ss-d_qd1_d_ss);
d_qs_d_delta1=(d_qinvdd_d_delta1-d_qd1_d_delta1);
d_qs_d_delta2=(d_qinvdd_d_delta2-d_qd1_d_delta2);
d_qs_d_nd=(d_qinvdd_d_nd-d_qd1_d_nd);
d_qs_d_alpha=(d_qinvdd_d_alpha-d_qd1_d_alpha);
d_qs_d_vel0=(d_qinvdd_d_vel0-d_qd1_d_vel0);
d_qs_d_mu0=(d_qinvdd_d_mu0-d_qd1_d_mu0);
d_qs_d_beta=(d_qinvdd_d_beta-d_qd1_d_beta);
d_qs_d_mtheta=(d_qinvdd_d_mtheta-d_qd1_d_mtheta);
d_qs_d_vtheta=(d_qinvdd_d_vtheta-d_qd1_d_vtheta);
d_qs_d_vtzeta=(d_qinvdd_d_vtzeta-d_qd1_d_vtzeta);
d_qs_d_dibsat=(d_qinvdd_d_dibsat-d_qd1_d_dibsat);
d_qs_d_epsilon=(d_qinvdd_d_epsilon-d_qd1_d_epsilon);
d_qs_d_vzeta=(d_qinvdd_d_vzeta-d_qd1_d_vzeta);
d_qs_d_lambda=(d_qinvdd_d_lambda-d_qd1_d_lambda);
d_qs_d_ngf=(d_qinvdd_d_ngf-d_qd1_d_ngf);
d_qs_d_type=(d_qinvdd_d_type-d_qd1_d_type);
qs=(qinvdd-qd1);
d_qd_d_vgsin=d_qd1_d_vgsin;
d_qd_d_vdsin=d_qd1_d_vdsin;
d_qd_d_qcbflag=d_qd1_d_qcbflag;
d_qd_d_vcin=d_qd1_d_vcin;
d_qd_d_vbin=d_qd1_d_vbin;
d_qd_d_qgsflag=d_qd1_d_qgsflag;
d_qd_d_tambin=d_qd1_d_tambin;
d_qd_d_tnomin=d_qd1_d_tnomin;
d_qd_d_phitin=d_qd1_d_phitin;
d_qd_d_w=d_qd1_d_w;
d_qd_d_lin=d_qd1_d_lin;
d_qd_d_cgin=d_qd1_d_cgin;
d_qd_d_cs=d_qd1_d_cs;
d_qd_d_cc=d_qd1_d_cc;
d_qd_d_cb=d_qd1_d_cb;
d_qd_d_vto=d_qd1_d_vto;
d_qd_d_ss=d_qd1_d_ss;
d_qd_d_delta1=d_qd1_d_delta1;
d_qd_d_delta2=d_qd1_d_delta2;
d_qd_d_nd=d_qd1_d_nd;
d_qd_d_alpha=d_qd1_d_alpha;
d_qd_d_vel0=d_qd1_d_vel0;
d_qd_d_mu0=d_qd1_d_mu0;
d_qd_d_beta=d_qd1_d_beta;
d_qd_d_mtheta=d_qd1_d_mtheta;
d_qd_d_vtheta=d_qd1_d_vtheta;
d_qd_d_vtzeta=d_qd1_d_vtzeta;
d_qd_d_dibsat=d_qd1_d_dibsat;
d_qd_d_epsilon=d_qd1_d_epsilon;
d_qd_d_vzeta=d_qd1_d_vzeta;
d_qd_d_lambda=d_qd1_d_lambda;
d_qd_d_ngf=d_qd1_d_ngf;
d_qd_d_type=d_qd1_d_type;
qd=qd1;
d_qgsout_d_vgsin=((((w*ngf)*lin)*type)*d_qs_d_vgsin);
d_qgsout_d_vdsin=((((w*ngf)*lin)*type)*d_qs_d_vdsin);
d_qgsout_d_qcbflag=((((w*ngf)*lin)*type)*d_qs_d_qcbflag);
d_qgsout_d_vcin=((((w*ngf)*lin)*type)*d_qs_d_vcin);
d_qgsout_d_vbin=((((w*ngf)*lin)*type)*d_qs_d_vbin);
d_qgsout_d_qgsflag=((((w*ngf)*lin)*type)*d_qs_d_qgsflag);
d_qgsout_d_tambin=((((w*ngf)*lin)*type)*d_qs_d_tambin);
d_qgsout_d_tnomin=((((w*ngf)*lin)*type)*d_qs_d_tnomin);
d_qgsout_d_phitin=((((w*ngf)*lin)*type)*d_qs_d_phitin);
d_qgsout_d_w=(((((w*ngf)*lin)*type)*d_qs_d_w)+((((ngf)*lin)*type)*qs));
d_qgsout_d_lin=(((((w*ngf)*lin)*type)*d_qs_d_lin)+((((w*ngf))*type)*qs));
d_qgsout_d_cgin=((((w*ngf)*lin)*type)*d_qs_d_cgin);
d_qgsout_d_cs=((((w*ngf)*lin)*type)*d_qs_d_cs);
d_qgsout_d_cc=((((w*ngf)*lin)*type)*d_qs_d_cc);
d_qgsout_d_cb=((((w*ngf)*lin)*type)*d_qs_d_cb);
d_qgsout_d_vto=((((w*ngf)*lin)*type)*d_qs_d_vto);
d_qgsout_d_ss=((((w*ngf)*lin)*type)*d_qs_d_ss);
d_qgsout_d_delta1=((((w*ngf)*lin)*type)*d_qs_d_delta1);
d_qgsout_d_delta2=((((w*ngf)*lin)*type)*d_qs_d_delta2);
d_qgsout_d_nd=((((w*ngf)*lin)*type)*d_qs_d_nd);
d_qgsout_d_alpha=((((w*ngf)*lin)*type)*d_qs_d_alpha);
d_qgsout_d_vel0=((((w*ngf)*lin)*type)*d_qs_d_vel0);
d_qgsout_d_mu0=((((w*ngf)*lin)*type)*d_qs_d_mu0);
d_qgsout_d_beta=((((w*ngf)*lin)*type)*d_qs_d_beta);
d_qgsout_d_mtheta=((((w*ngf)*lin)*type)*d_qs_d_mtheta);
d_qgsout_d_vtheta=((((w*ngf)*lin)*type)*d_qs_d_vtheta);
d_qgsout_d_vtzeta=((((w*ngf)*lin)*type)*d_qs_d_vtzeta);
d_qgsout_d_dibsat=((((w*ngf)*lin)*type)*d_qs_d_dibsat);
d_qgsout_d_epsilon=((((w*ngf)*lin)*type)*d_qs_d_epsilon);
d_qgsout_d_vzeta=((((w*ngf)*lin)*type)*d_qs_d_vzeta);
d_qgsout_d_lambda=((((w*ngf)*lin)*type)*d_qs_d_lambda);
d_qgsout_d_ngf=(((((w*ngf)*lin)*type)*d_qs_d_ngf)+((((w)*lin)*type)*qs));
d_qgsout_d_type=(((((w*ngf)*lin)*type)*d_qs_d_type)+((((w*ngf)*lin))*qs));
qgsout=((((w*ngf)*lin)*type)*qs);
d_qgdout_d_vgsin=((((w*ngf)*lin)*type)*d_qd_d_vgsin);
d_qgdout_d_vdsin=((((w*ngf)*lin)*type)*d_qd_d_vdsin);
d_qgdout_d_qcbflag=((((w*ngf)*lin)*type)*d_qd_d_qcbflag);
d_qgdout_d_vcin=((((w*ngf)*lin)*type)*d_qd_d_vcin);
d_qgdout_d_vbin=((((w*ngf)*lin)*type)*d_qd_d_vbin);
d_qgdout_d_qgsflag=((((w*ngf)*lin)*type)*d_qd_d_qgsflag);
d_qgdout_d_tambin=((((w*ngf)*lin)*type)*d_qd_d_tambin);
d_qgdout_d_tnomin=((((w*ngf)*lin)*type)*d_qd_d_tnomin);
d_qgdout_d_phitin=((((w*ngf)*lin)*type)*d_qd_d_phitin);
d_qgdout_d_w=(((((w*ngf)*lin)*type)*d_qd_d_w)+((((ngf)*lin)*type)*qd));
d_qgdout_d_lin=(((((w*ngf)*lin)*type)*d_qd_d_lin)+((((w*ngf))*type)*qd));
d_qgdout_d_cgin=((((w*ngf)*lin)*type)*d_qd_d_cgin);
d_qgdout_d_cs=((((w*ngf)*lin)*type)*d_qd_d_cs);
d_qgdout_d_cc=((((w*ngf)*lin)*type)*d_qd_d_cc);
d_qgdout_d_cb=((((w*ngf)*lin)*type)*d_qd_d_cb);
d_qgdout_d_vto=((((w*ngf)*lin)*type)*d_qd_d_vto);
d_qgdout_d_ss=((((w*ngf)*lin)*type)*d_qd_d_ss);
d_qgdout_d_delta1=((((w*ngf)*lin)*type)*d_qd_d_delta1);
d_qgdout_d_delta2=((((w*ngf)*lin)*type)*d_qd_d_delta2);
d_qgdout_d_nd=((((w*ngf)*lin)*type)*d_qd_d_nd);
d_qgdout_d_alpha=((((w*ngf)*lin)*type)*d_qd_d_alpha);
d_qgdout_d_vel0=((((w*ngf)*lin)*type)*d_qd_d_vel0);
d_qgdout_d_mu0=((((w*ngf)*lin)*type)*d_qd_d_mu0);
d_qgdout_d_beta=((((w*ngf)*lin)*type)*d_qd_d_beta);
d_qgdout_d_mtheta=((((w*ngf)*lin)*type)*d_qd_d_mtheta);
d_qgdout_d_vtheta=((((w*ngf)*lin)*type)*d_qd_d_vtheta);
d_qgdout_d_vtzeta=((((w*ngf)*lin)*type)*d_qd_d_vtzeta);
d_qgdout_d_dibsat=((((w*ngf)*lin)*type)*d_qd_d_dibsat);
d_qgdout_d_epsilon=((((w*ngf)*lin)*type)*d_qd_d_epsilon);
d_qgdout_d_vzeta=((((w*ngf)*lin)*type)*d_qd_d_vzeta);
d_qgdout_d_lambda=((((w*ngf)*lin)*type)*d_qd_d_lambda);
d_qgdout_d_ngf=(((((w*ngf)*lin)*type)*d_qd_d_ngf)+((((w)*lin)*type)*qd));
d_qgdout_d_type=(((((w*ngf)*lin)*type)*d_qd_d_type)+((((w*ngf)*lin))*qd));
qgdout=((((w*ngf)*lin)*type)*qd);
if((qcbflag==1))
{
d_etac_d_vgsin=((two_n_phit0*(-(d_vtof_d_vgsin-(0.5*d_alpha_phit_d_vgsin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etac_d_vdsin=((two_n_phit0*(-(d_vtof_d_vdsin-(0.5*d_alpha_phit_d_vdsin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etac_d_qcbflag=((two_n_phit0*(-(d_vtof_d_qcbflag-(0.5*d_alpha_phit_d_qcbflag)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etac_d_vcin=((two_n_phit0*(1.0-(d_vtof_d_vcin-(0.5*d_alpha_phit_d_vcin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etac_d_vbin=((two_n_phit0*(-(d_vtof_d_vbin-(0.5*d_alpha_phit_d_vbin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etac_d_qgsflag=((two_n_phit0*(-(d_vtof_d_qgsflag-(0.5*d_alpha_phit_d_qgsflag)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etac_d_tambin=((two_n_phit0*(-(d_vtof_d_tambin-(0.5*d_alpha_phit_d_tambin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etac_d_tnomin=((two_n_phit0*(-(d_vtof_d_tnomin-(0.5*d_alpha_phit_d_tnomin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etac_d_phitin=((two_n_phit0*(-(d_vtof_d_phitin-(0.5*d_alpha_phit_d_phitin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etac_d_w=((two_n_phit0*(-(d_vtof_d_w-(0.5*d_alpha_phit_d_w)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etac_d_lin=((two_n_phit0*(-(d_vtof_d_lin-(0.5*d_alpha_phit_d_lin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etac_d_cgin=((two_n_phit0*(-(d_vtof_d_cgin-(0.5*d_alpha_phit_d_cgin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etac_d_cs=((two_n_phit0*(-(d_vtof_d_cs-(0.5*d_alpha_phit_d_cs)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etac_d_cc=((two_n_phit0*(-(d_vtof_d_cc-(0.5*d_alpha_phit_d_cc)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etac_d_cb=((two_n_phit0*(-(d_vtof_d_cb-(0.5*d_alpha_phit_d_cb)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etac_d_vto=((two_n_phit0*(-(d_vtof_d_vto-(0.5*d_alpha_phit_d_vto)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etac_d_ss=((two_n_phit0*(-(d_vtof_d_ss-(0.5*d_alpha_phit_d_ss)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etac_d_delta1=((two_n_phit0*(-(d_vtof_d_delta1-(0.5*d_alpha_phit_d_delta1)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etac_d_delta2=((two_n_phit0*(-(d_vtof_d_delta2-(0.5*d_alpha_phit_d_delta2)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etac_d_nd=((two_n_phit0*(-(d_vtof_d_nd-(0.5*d_alpha_phit_d_nd)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etac_d_alpha=((two_n_phit0*(-(d_vtof_d_alpha-(0.5*d_alpha_phit_d_alpha)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etac_d_vel0=((two_n_phit0*(-(d_vtof_d_vel0-(0.5*d_alpha_phit_d_vel0)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etac_d_mu0=((two_n_phit0*(-(d_vtof_d_mu0-(0.5*d_alpha_phit_d_mu0)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etac_d_beta=((two_n_phit0*(-(d_vtof_d_beta-(0.5*d_alpha_phit_d_beta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etac_d_mtheta=((two_n_phit0*(-(d_vtof_d_mtheta-(0.5*d_alpha_phit_d_mtheta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etac_d_vtheta=((two_n_phit0*(-(d_vtof_d_vtheta-(0.5*d_alpha_phit_d_vtheta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etac_d_vtzeta=((two_n_phit0*(-(d_vtof_d_vtzeta-(0.5*d_alpha_phit_d_vtzeta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etac_d_dibsat=((two_n_phit0*(-(d_vtof_d_dibsat-(0.5*d_alpha_phit_d_dibsat)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etac_d_epsilon=((two_n_phit0*(-(d_vtof_d_epsilon-(0.5*d_alpha_phit_d_epsilon)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etac_d_vzeta=((two_n_phit0*(-(d_vtof_d_vzeta-(0.5*d_alpha_phit_d_vzeta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etac_d_lambda=((two_n_phit0*(-(d_vtof_d_lambda-(0.5*d_alpha_phit_d_lambda)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etac_d_ngf=((two_n_phit0*(-(d_vtof_d_ngf-(0.5*d_alpha_phit_d_ngf)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etac_d_type=((two_n_phit0*(-(d_vtof_d_type-(0.5*d_alpha_phit_d_type)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etac=((vcin-(vtof-(0.5*alpha_phit)))/two_n_phit0);
if((etac>50.0))
{
d_exparg_d_vgsin=d_etac_d_vgsin;
d_exparg_d_vdsin=d_etac_d_vdsin;
d_exparg_d_qcbflag=d_etac_d_qcbflag;
d_exparg_d_vcin=d_etac_d_vcin;
d_exparg_d_vbin=d_etac_d_vbin;
d_exparg_d_qgsflag=d_etac_d_qgsflag;
d_exparg_d_tambin=d_etac_d_tambin;
d_exparg_d_tnomin=d_etac_d_tnomin;
d_exparg_d_phitin=d_etac_d_phitin;
d_exparg_d_w=d_etac_d_w;
d_exparg_d_lin=d_etac_d_lin;
d_exparg_d_cgin=d_etac_d_cgin;
d_exparg_d_cs=d_etac_d_cs;
d_exparg_d_cc=d_etac_d_cc;
d_exparg_d_cb=d_etac_d_cb;
d_exparg_d_vto=d_etac_d_vto;
d_exparg_d_ss=d_etac_d_ss;
d_exparg_d_delta1=d_etac_d_delta1;
d_exparg_d_delta2=d_etac_d_delta2;
d_exparg_d_nd=d_etac_d_nd;
d_exparg_d_alpha=d_etac_d_alpha;
d_exparg_d_vel0=d_etac_d_vel0;
d_exparg_d_mu0=d_etac_d_mu0;
d_exparg_d_beta=d_etac_d_beta;
d_exparg_d_mtheta=d_etac_d_mtheta;
d_exparg_d_vtheta=d_etac_d_vtheta;
d_exparg_d_vtzeta=d_etac_d_vtzeta;
d_exparg_d_dibsat=d_etac_d_dibsat;
d_exparg_d_epsilon=d_etac_d_epsilon;
d_exparg_d_vzeta=d_etac_d_vzeta;
d_exparg_d_lambda=d_etac_d_lambda;
d_exparg_d_ngf=d_etac_d_ngf;
d_exparg_d_type=d_etac_d_type;
exparg=etac;
}
else
{
if((etac<(-50.0)))
{
d_exparg_d_vgsin=0.0;
d_exparg_d_vdsin=0.0;
d_exparg_d_qcbflag=0.0;
d_exparg_d_vcin=0.0;
d_exparg_d_vbin=0.0;
d_exparg_d_qgsflag=0.0;
d_exparg_d_tambin=0.0;
d_exparg_d_tnomin=0.0;
d_exparg_d_phitin=0.0;
d_exparg_d_w=0.0;
d_exparg_d_lin=0.0;
d_exparg_d_cgin=0.0;
d_exparg_d_cs=0.0;
d_exparg_d_cc=0.0;
d_exparg_d_cb=0.0;
d_exparg_d_vto=0.0;
d_exparg_d_ss=0.0;
d_exparg_d_delta1=0.0;
d_exparg_d_delta2=0.0;
d_exparg_d_nd=0.0;
d_exparg_d_alpha=0.0;
d_exparg_d_vel0=0.0;
d_exparg_d_mu0=0.0;
d_exparg_d_beta=0.0;
d_exparg_d_mtheta=0.0;
d_exparg_d_vtheta=0.0;
d_exparg_d_vtzeta=0.0;
d_exparg_d_dibsat=0.0;
d_exparg_d_epsilon=0.0;
d_exparg_d_vzeta=0.0;
d_exparg_d_lambda=0.0;
d_exparg_d_ngf=0.0;
d_exparg_d_type=0.0;
exparg=0;
}
else
{
d_exparg_d_vgsin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vgsin;
d_exparg_d_vdsin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vdsin;
d_exparg_d_qcbflag=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_qcbflag;
d_exparg_d_vcin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vcin;
d_exparg_d_vbin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vbin;
d_exparg_d_qgsflag=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_qgsflag;
d_exparg_d_tambin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_tambin;
d_exparg_d_tnomin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_tnomin;
d_exparg_d_phitin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_phitin;
d_exparg_d_w=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_w;
d_exparg_d_lin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_lin;
d_exparg_d_cgin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cgin;
d_exparg_d_cs=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cs;
d_exparg_d_cc=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cc;
d_exparg_d_cb=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cb;
d_exparg_d_vto=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vto;
d_exparg_d_ss=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_ss;
d_exparg_d_delta1=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_delta1;
d_exparg_d_delta2=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_delta2;
d_exparg_d_nd=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_nd;
d_exparg_d_alpha=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_alpha;
d_exparg_d_vel0=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vel0;
d_exparg_d_mu0=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_mu0;
d_exparg_d_beta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_beta;
d_exparg_d_mtheta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_mtheta;
d_exparg_d_vtheta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vtheta;
d_exparg_d_vtzeta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vtzeta;
d_exparg_d_dibsat=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_dibsat;
d_exparg_d_epsilon=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_epsilon;
d_exparg_d_vzeta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vzeta;
d_exparg_d_lambda=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_lambda;
d_exparg_d_ngf=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_ngf;
d_exparg_d_type=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_type;
exparg=log((1.0+exp(etac)));
}
}
d_qcout_d_vgsin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vgsin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vgsin)*exparg));
d_qcout_d_vdsin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vdsin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vdsin)*exparg));
d_qcout_d_qcbflag=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_qcbflag)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_qcbflag)*exparg));
d_qcout_d_vcin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vcin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vcin)*exparg));
d_qcout_d_vbin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vbin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vbin)*exparg));
d_qcout_d_qgsflag=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_qgsflag)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_qgsflag)*exparg));
d_qcout_d_tambin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_tambin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_tambin)*exparg));
d_qcout_d_tnomin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_tnomin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_tnomin)*exparg));
d_qcout_d_phitin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_phitin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_phitin)*exparg));
d_qcout_d_w=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_w)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_w)+((((ngf)*type)*cc)*two_n_phit0))*exparg));
d_qcout_d_lin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_lin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_lin)*exparg));
d_qcout_d_cgin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cgin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_cgin)*exparg));
d_qcout_d_cs=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cs)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_cs)*exparg));
d_qcout_d_cc=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cc)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_cc)+((((w*ngf)*type))*two_n_phit0))*exparg));
d_qcout_d_cb=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cb)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_cb)*exparg));
d_qcout_d_vto=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vto)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vto)*exparg));
d_qcout_d_ss=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_ss)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_ss)*exparg));
d_qcout_d_delta1=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_delta1)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_delta1)*exparg));
d_qcout_d_delta2=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_delta2)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_delta2)*exparg));
d_qcout_d_nd=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_nd)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_nd)*exparg));
d_qcout_d_alpha=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_alpha)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_alpha)*exparg));
d_qcout_d_vel0=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vel0)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vel0)*exparg));
d_qcout_d_mu0=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_mu0)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_mu0)*exparg));
d_qcout_d_beta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_beta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_beta)*exparg));
d_qcout_d_mtheta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_mtheta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_mtheta)*exparg));
d_qcout_d_vtheta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vtheta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vtheta)*exparg));
d_qcout_d_vtzeta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vtzeta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vtzeta)*exparg));
d_qcout_d_dibsat=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_dibsat)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_dibsat)*exparg));
d_qcout_d_epsilon=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_epsilon)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_epsilon)*exparg));
d_qcout_d_vzeta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vzeta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vzeta)*exparg));
d_qcout_d_lambda=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_lambda)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_lambda)*exparg));
d_qcout_d_ngf=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_ngf)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_ngf)+((((w)*type)*cc)*two_n_phit0))*exparg));
d_qcout_d_type=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_type)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_type)+((((w*ngf))*cc)*two_n_phit0))*exparg));
qcout=(((((w*ngf)*type)*cc)*two_n_phit0)*exparg);
d_etab_d_vgsin=((two_n_phit0*(-(d_vtof_d_vgsin-(0.5*d_alpha_phit_d_vgsin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etab_d_vdsin=((two_n_phit0*(-(d_vtof_d_vdsin-(0.5*d_alpha_phit_d_vdsin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etab_d_qcbflag=((two_n_phit0*(-(d_vtof_d_qcbflag-(0.5*d_alpha_phit_d_qcbflag)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etab_d_vcin=((two_n_phit0*(-(d_vtof_d_vcin-(0.5*d_alpha_phit_d_vcin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etab_d_vbin=((two_n_phit0*(1.0-(d_vtof_d_vbin-(0.5*d_alpha_phit_d_vbin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etab_d_qgsflag=((two_n_phit0*(-(d_vtof_d_qgsflag-(0.5*d_alpha_phit_d_qgsflag)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etab_d_tambin=((two_n_phit0*(-(d_vtof_d_tambin-(0.5*d_alpha_phit_d_tambin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etab_d_tnomin=((two_n_phit0*(-(d_vtof_d_tnomin-(0.5*d_alpha_phit_d_tnomin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etab_d_phitin=((two_n_phit0*(-(d_vtof_d_phitin-(0.5*d_alpha_phit_d_phitin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etab_d_w=((two_n_phit0*(-(d_vtof_d_w-(0.5*d_alpha_phit_d_w)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etab_d_lin=((two_n_phit0*(-(d_vtof_d_lin-(0.5*d_alpha_phit_d_lin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etab_d_cgin=((two_n_phit0*(-(d_vtof_d_cgin-(0.5*d_alpha_phit_d_cgin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etab_d_cs=((two_n_phit0*(-(d_vtof_d_cs-(0.5*d_alpha_phit_d_cs)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etab_d_cc=((two_n_phit0*(-(d_vtof_d_cc-(0.5*d_alpha_phit_d_cc)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etab_d_cb=((two_n_phit0*(-(d_vtof_d_cb-(0.5*d_alpha_phit_d_cb)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etab_d_vto=((two_n_phit0*(-(d_vtof_d_vto-(0.5*d_alpha_phit_d_vto)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etab_d_ss=((two_n_phit0*(-(d_vtof_d_ss-(0.5*d_alpha_phit_d_ss)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etab_d_delta1=((two_n_phit0*(-(d_vtof_d_delta1-(0.5*d_alpha_phit_d_delta1)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etab_d_delta2=((two_n_phit0*(-(d_vtof_d_delta2-(0.5*d_alpha_phit_d_delta2)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etab_d_nd=((two_n_phit0*(-(d_vtof_d_nd-(0.5*d_alpha_phit_d_nd)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etab_d_alpha=((two_n_phit0*(-(d_vtof_d_alpha-(0.5*d_alpha_phit_d_alpha)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etab_d_vel0=((two_n_phit0*(-(d_vtof_d_vel0-(0.5*d_alpha_phit_d_vel0)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etab_d_mu0=((two_n_phit0*(-(d_vtof_d_mu0-(0.5*d_alpha_phit_d_mu0)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etab_d_beta=((two_n_phit0*(-(d_vtof_d_beta-(0.5*d_alpha_phit_d_beta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etab_d_mtheta=((two_n_phit0*(-(d_vtof_d_mtheta-(0.5*d_alpha_phit_d_mtheta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etab_d_vtheta=((two_n_phit0*(-(d_vtof_d_vtheta-(0.5*d_alpha_phit_d_vtheta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etab_d_vtzeta=((two_n_phit0*(-(d_vtof_d_vtzeta-(0.5*d_alpha_phit_d_vtzeta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etab_d_dibsat=((two_n_phit0*(-(d_vtof_d_dibsat-(0.5*d_alpha_phit_d_dibsat)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etab_d_epsilon=((two_n_phit0*(-(d_vtof_d_epsilon-(0.5*d_alpha_phit_d_epsilon)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etab_d_vzeta=((two_n_phit0*(-(d_vtof_d_vzeta-(0.5*d_alpha_phit_d_vzeta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etab_d_lambda=((two_n_phit0*(-(d_vtof_d_lambda-(0.5*d_alpha_phit_d_lambda)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etab_d_ngf=((two_n_phit0*(-(d_vtof_d_ngf-(0.5*d_alpha_phit_d_ngf)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etab_d_type=((two_n_phit0*(-(d_vtof_d_type-(0.5*d_alpha_phit_d_type)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etab=((vbin-(vtof-(0.5*alpha_phit)))/two_n_phit0);
if((etab>50.0))
{
d_exparg_d_vgsin=d_etab_d_vgsin;
d_exparg_d_vdsin=d_etab_d_vdsin;
d_exparg_d_qcbflag=d_etab_d_qcbflag;
d_exparg_d_vcin=d_etab_d_vcin;
d_exparg_d_vbin=d_etab_d_vbin;
d_exparg_d_qgsflag=d_etab_d_qgsflag;
d_exparg_d_tambin=d_etab_d_tambin;
d_exparg_d_tnomin=d_etab_d_tnomin;
d_exparg_d_phitin=d_etab_d_phitin;
d_exparg_d_w=d_etab_d_w;
d_exparg_d_lin=d_etab_d_lin;
d_exparg_d_cgin=d_etab_d_cgin;
d_exparg_d_cs=d_etab_d_cs;
d_exparg_d_cc=d_etab_d_cc;
d_exparg_d_cb=d_etab_d_cb;
d_exparg_d_vto=d_etab_d_vto;
d_exparg_d_ss=d_etab_d_ss;
d_exparg_d_delta1=d_etab_d_delta1;
d_exparg_d_delta2=d_etab_d_delta2;
d_exparg_d_nd=d_etab_d_nd;
d_exparg_d_alpha=d_etab_d_alpha;
d_exparg_d_vel0=d_etab_d_vel0;
d_exparg_d_mu0=d_etab_d_mu0;
d_exparg_d_beta=d_etab_d_beta;
d_exparg_d_mtheta=d_etab_d_mtheta;
d_exparg_d_vtheta=d_etab_d_vtheta;
d_exparg_d_vtzeta=d_etab_d_vtzeta;
d_exparg_d_dibsat=d_etab_d_dibsat;
d_exparg_d_epsilon=d_etab_d_epsilon;
d_exparg_d_vzeta=d_etab_d_vzeta;
d_exparg_d_lambda=d_etab_d_lambda;
d_exparg_d_ngf=d_etab_d_ngf;
d_exparg_d_type=d_etab_d_type;
exparg=etab;
}
else
{
if((etab<(-50.0)))
{
d_exparg_d_vgsin=0.0;
d_exparg_d_vdsin=0.0;
d_exparg_d_qcbflag=0.0;
d_exparg_d_vcin=0.0;
d_exparg_d_vbin=0.0;
d_exparg_d_qgsflag=0.0;
d_exparg_d_tambin=0.0;
d_exparg_d_tnomin=0.0;
d_exparg_d_phitin=0.0;
d_exparg_d_w=0.0;
d_exparg_d_lin=0.0;
d_exparg_d_cgin=0.0;
d_exparg_d_cs=0.0;
d_exparg_d_cc=0.0;
d_exparg_d_cb=0.0;
d_exparg_d_vto=0.0;
d_exparg_d_ss=0.0;
d_exparg_d_delta1=0.0;
d_exparg_d_delta2=0.0;
d_exparg_d_nd=0.0;
d_exparg_d_alpha=0.0;
d_exparg_d_vel0=0.0;
d_exparg_d_mu0=0.0;
d_exparg_d_beta=0.0;
d_exparg_d_mtheta=0.0;
d_exparg_d_vtheta=0.0;
d_exparg_d_vtzeta=0.0;
d_exparg_d_dibsat=0.0;
d_exparg_d_epsilon=0.0;
d_exparg_d_vzeta=0.0;
d_exparg_d_lambda=0.0;
d_exparg_d_ngf=0.0;
d_exparg_d_type=0.0;
exparg=0;
}
else
{
d_exparg_d_vgsin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vgsin;
d_exparg_d_vdsin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vdsin;
d_exparg_d_qcbflag=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_qcbflag;
d_exparg_d_vcin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vcin;
d_exparg_d_vbin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vbin;
d_exparg_d_qgsflag=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_qgsflag;
d_exparg_d_tambin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_tambin;
d_exparg_d_tnomin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_tnomin;
d_exparg_d_phitin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_phitin;
d_exparg_d_w=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_w;
d_exparg_d_lin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_lin;
d_exparg_d_cgin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cgin;
d_exparg_d_cs=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cs;
d_exparg_d_cc=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cc;
d_exparg_d_cb=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cb;
d_exparg_d_vto=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vto;
d_exparg_d_ss=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_ss;
d_exparg_d_delta1=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_delta1;
d_exparg_d_delta2=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_delta2;
d_exparg_d_nd=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_nd;
d_exparg_d_alpha=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_alpha;
d_exparg_d_vel0=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vel0;
d_exparg_d_mu0=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_mu0;
d_exparg_d_beta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_beta;
d_exparg_d_mtheta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_mtheta;
d_exparg_d_vtheta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vtheta;
d_exparg_d_vtzeta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vtzeta;
d_exparg_d_dibsat=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_dibsat;
d_exparg_d_epsilon=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_epsilon;
d_exparg_d_vzeta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vzeta;
d_exparg_d_lambda=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_lambda;
d_exparg_d_ngf=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_ngf;
d_exparg_d_type=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_type;
exparg=log((1.0+exp(etab)));
}
}
d_qbout_d_vgsin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vgsin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vgsin)*exparg));
d_qbout_d_vdsin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vdsin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vdsin)*exparg));
d_qbout_d_qcbflag=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_qcbflag)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_qcbflag)*exparg));
d_qbout_d_vcin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vcin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vcin)*exparg));
d_qbout_d_vbin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vbin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vbin)*exparg));
d_qbout_d_qgsflag=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_qgsflag)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_qgsflag)*exparg));
d_qbout_d_tambin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_tambin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_tambin)*exparg));
d_qbout_d_tnomin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_tnomin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_tnomin)*exparg));
d_qbout_d_phitin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_phitin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_phitin)*exparg));
d_qbout_d_w=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_w)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_w)+((((ngf)*type)*cb)*two_n_phit0))*exparg));
d_qbout_d_lin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_lin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_lin)*exparg));
d_qbout_d_cgin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cgin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_cgin)*exparg));
d_qbout_d_cs=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cs)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_cs)*exparg));
d_qbout_d_cc=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cc)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_cc)*exparg));
d_qbout_d_cb=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cb)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_cb)+((((w*ngf)*type))*two_n_phit0))*exparg));
d_qbout_d_vto=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vto)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vto)*exparg));
d_qbout_d_ss=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_ss)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_ss)*exparg));
d_qbout_d_delta1=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_delta1)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_delta1)*exparg));
d_qbout_d_delta2=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_delta2)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_delta2)*exparg));
d_qbout_d_nd=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_nd)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_nd)*exparg));
d_qbout_d_alpha=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_alpha)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_alpha)*exparg));
d_qbout_d_vel0=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vel0)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vel0)*exparg));
d_qbout_d_mu0=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_mu0)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_mu0)*exparg));
d_qbout_d_beta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_beta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_beta)*exparg));
d_qbout_d_mtheta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_mtheta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_mtheta)*exparg));
d_qbout_d_vtheta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vtheta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vtheta)*exparg));
d_qbout_d_vtzeta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vtzeta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vtzeta)*exparg));
d_qbout_d_dibsat=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_dibsat)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_dibsat)*exparg));
d_qbout_d_epsilon=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_epsilon)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_epsilon)*exparg));
d_qbout_d_vzeta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vzeta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vzeta)*exparg));
d_qbout_d_lambda=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_lambda)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_lambda)*exparg));
d_qbout_d_ngf=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_ngf)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_ngf)+((((w)*type)*cb)*two_n_phit0))*exparg));
d_qbout_d_type=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_type)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_type)+((((w*ngf))*cb)*two_n_phit0))*exparg));
qbout=(((((w*ngf)*type)*cb)*two_n_phit0)*exparg);
}
else
{
d_qcout_d_vgsin=0.0;
d_qcout_d_vdsin=0.0;
d_qcout_d_qcbflag=0.0;
d_qcout_d_vcin=0.0;
d_qcout_d_vbin=0.0;
d_qcout_d_qgsflag=0.0;
d_qcout_d_tambin=0.0;
d_qcout_d_tnomin=0.0;
d_qcout_d_phitin=0.0;
d_qcout_d_w=0.0;
d_qcout_d_lin=0.0;
d_qcout_d_cgin=0.0;
d_qcout_d_cs=0.0;
d_qcout_d_cc=0.0;
d_qcout_d_cb=0.0;
d_qcout_d_vto=0.0;
d_qcout_d_ss=0.0;
d_qcout_d_delta1=0.0;
d_qcout_d_delta2=0.0;
d_qcout_d_nd=0.0;
d_qcout_d_alpha=0.0;
d_qcout_d_vel0=0.0;
d_qcout_d_mu0=0.0;
d_qcout_d_beta=0.0;
d_qcout_d_mtheta=0.0;
d_qcout_d_vtheta=0.0;
d_qcout_d_vtzeta=0.0;
d_qcout_d_dibsat=0.0;
d_qcout_d_epsilon=0.0;
d_qcout_d_vzeta=0.0;
d_qcout_d_lambda=0.0;
d_qcout_d_ngf=0.0;
d_qcout_d_type=0.0;
qcout=0;
d_qbout_d_vgsin=0.0;
d_qbout_d_vdsin=0.0;
d_qbout_d_qcbflag=0.0;
d_qbout_d_vcin=0.0;
d_qbout_d_vbin=0.0;
d_qbout_d_qgsflag=0.0;
d_qbout_d_tambin=0.0;
d_qbout_d_tnomin=0.0;
d_qbout_d_phitin=0.0;
d_qbout_d_w=0.0;
d_qbout_d_lin=0.0;
d_qbout_d_cgin=0.0;
d_qbout_d_cs=0.0;
d_qbout_d_cc=0.0;
d_qbout_d_cb=0.0;
d_qbout_d_vto=0.0;
d_qbout_d_ss=0.0;
d_qbout_d_delta1=0.0;
d_qbout_d_delta2=0.0;
d_qbout_d_nd=0.0;
d_qbout_d_alpha=0.0;
d_qbout_d_vel0=0.0;
d_qbout_d_mu0=0.0;
d_qbout_d_beta=0.0;
d_qbout_d_mtheta=0.0;
d_qbout_d_vtheta=0.0;
d_qbout_d_vtzeta=0.0;
d_qbout_d_dibsat=0.0;
d_qbout_d_epsilon=0.0;
d_qbout_d_vzeta=0.0;
d_qbout_d_lambda=0.0;
d_qbout_d_ngf=0.0;
d_qbout_d_type=0.0;
qbout=0;
}
if((qgsflag==1))
{
d_etags_d_vgsin=((two_n_phit0*(1.0-(d_vtof_d_vgsin-(0.5*d_alpha_phit_d_vgsin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etags_d_vdsin=((two_n_phit0*(-(d_vtof_d_vdsin-(0.5*d_alpha_phit_d_vdsin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etags_d_qcbflag=((two_n_phit0*(-(d_vtof_d_qcbflag-(0.5*d_alpha_phit_d_qcbflag)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etags_d_vcin=((two_n_phit0*(-(d_vtof_d_vcin-(0.5*d_alpha_phit_d_vcin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etags_d_vbin=((two_n_phit0*(-(d_vtof_d_vbin-(0.5*d_alpha_phit_d_vbin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etags_d_qgsflag=((two_n_phit0*(-(d_vtof_d_qgsflag-(0.5*d_alpha_phit_d_qgsflag)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etags_d_tambin=((two_n_phit0*(-(d_vtof_d_tambin-(0.5*d_alpha_phit_d_tambin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etags_d_tnomin=((two_n_phit0*(-(d_vtof_d_tnomin-(0.5*d_alpha_phit_d_tnomin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etags_d_phitin=((two_n_phit0*(-(d_vtof_d_phitin-(0.5*d_alpha_phit_d_phitin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etags_d_w=((two_n_phit0*(-(d_vtof_d_w-(0.5*d_alpha_phit_d_w)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etags_d_lin=((two_n_phit0*(-(d_vtof_d_lin-(0.5*d_alpha_phit_d_lin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etags_d_cgin=((two_n_phit0*(-(d_vtof_d_cgin-(0.5*d_alpha_phit_d_cgin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etags_d_cs=((two_n_phit0*(-(d_vtof_d_cs-(0.5*d_alpha_phit_d_cs)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etags_d_cc=((two_n_phit0*(-(d_vtof_d_cc-(0.5*d_alpha_phit_d_cc)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etags_d_cb=((two_n_phit0*(-(d_vtof_d_cb-(0.5*d_alpha_phit_d_cb)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etags_d_vto=((two_n_phit0*(-(d_vtof_d_vto-(0.5*d_alpha_phit_d_vto)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etags_d_ss=((two_n_phit0*(-(d_vtof_d_ss-(0.5*d_alpha_phit_d_ss)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etags_d_delta1=((two_n_phit0*(-(d_vtof_d_delta1-(0.5*d_alpha_phit_d_delta1)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etags_d_delta2=((two_n_phit0*(-(d_vtof_d_delta2-(0.5*d_alpha_phit_d_delta2)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etags_d_nd=((two_n_phit0*(-(d_vtof_d_nd-(0.5*d_alpha_phit_d_nd)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etags_d_alpha=((two_n_phit0*(-(d_vtof_d_alpha-(0.5*d_alpha_phit_d_alpha)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etags_d_vel0=((two_n_phit0*(-(d_vtof_d_vel0-(0.5*d_alpha_phit_d_vel0)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etags_d_mu0=((two_n_phit0*(-(d_vtof_d_mu0-(0.5*d_alpha_phit_d_mu0)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etags_d_beta=((two_n_phit0*(-(d_vtof_d_beta-(0.5*d_alpha_phit_d_beta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etags_d_mtheta=((two_n_phit0*(-(d_vtof_d_mtheta-(0.5*d_alpha_phit_d_mtheta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etags_d_vtheta=((two_n_phit0*(-(d_vtof_d_vtheta-(0.5*d_alpha_phit_d_vtheta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etags_d_vtzeta=((two_n_phit0*(-(d_vtof_d_vtzeta-(0.5*d_alpha_phit_d_vtzeta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etags_d_dibsat=((two_n_phit0*(-(d_vtof_d_dibsat-(0.5*d_alpha_phit_d_dibsat)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etags_d_epsilon=((two_n_phit0*(-(d_vtof_d_epsilon-(0.5*d_alpha_phit_d_epsilon)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etags_d_vzeta=((two_n_phit0*(-(d_vtof_d_vzeta-(0.5*d_alpha_phit_d_vzeta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etags_d_lambda=((two_n_phit0*(-(d_vtof_d_lambda-(0.5*d_alpha_phit_d_lambda)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etags_d_ngf=((two_n_phit0*(-(d_vtof_d_ngf-(0.5*d_alpha_phit_d_ngf)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etags_d_type=((two_n_phit0*(-(d_vtof_d_type-(0.5*d_alpha_phit_d_type)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etags=((vgsin-(vtof-(0.5*alpha_phit)))/two_n_phit0);
if((etags>50.0))
{
d_exparg_d_vgsin=d_etags_d_vgsin;
d_exparg_d_vdsin=d_etags_d_vdsin;
d_exparg_d_qcbflag=d_etags_d_qcbflag;
d_exparg_d_vcin=d_etags_d_vcin;
d_exparg_d_vbin=d_etags_d_vbin;
d_exparg_d_qgsflag=d_etags_d_qgsflag;
d_exparg_d_tambin=d_etags_d_tambin;
d_exparg_d_tnomin=d_etags_d_tnomin;
d_exparg_d_phitin=d_etags_d_phitin;
d_exparg_d_w=d_etags_d_w;
d_exparg_d_lin=d_etags_d_lin;
d_exparg_d_cgin=d_etags_d_cgin;
d_exparg_d_cs=d_etags_d_cs;
d_exparg_d_cc=d_etags_d_cc;
d_exparg_d_cb=d_etags_d_cb;
d_exparg_d_vto=d_etags_d_vto;
d_exparg_d_ss=d_etags_d_ss;
d_exparg_d_delta1=d_etags_d_delta1;
d_exparg_d_delta2=d_etags_d_delta2;
d_exparg_d_nd=d_etags_d_nd;
d_exparg_d_alpha=d_etags_d_alpha;
d_exparg_d_vel0=d_etags_d_vel0;
d_exparg_d_mu0=d_etags_d_mu0;
d_exparg_d_beta=d_etags_d_beta;
d_exparg_d_mtheta=d_etags_d_mtheta;
d_exparg_d_vtheta=d_etags_d_vtheta;
d_exparg_d_vtzeta=d_etags_d_vtzeta;
d_exparg_d_dibsat=d_etags_d_dibsat;
d_exparg_d_epsilon=d_etags_d_epsilon;
d_exparg_d_vzeta=d_etags_d_vzeta;
d_exparg_d_lambda=d_etags_d_lambda;
d_exparg_d_ngf=d_etags_d_ngf;
d_exparg_d_type=d_etags_d_type;
exparg=etags;
}
else
{
if((etags<(-50.0)))
{
d_exparg_d_vgsin=0.0;
d_exparg_d_vdsin=0.0;
d_exparg_d_qcbflag=0.0;
d_exparg_d_vcin=0.0;
d_exparg_d_vbin=0.0;
d_exparg_d_qgsflag=0.0;
d_exparg_d_tambin=0.0;
d_exparg_d_tnomin=0.0;
d_exparg_d_phitin=0.0;
d_exparg_d_w=0.0;
d_exparg_d_lin=0.0;
d_exparg_d_cgin=0.0;
d_exparg_d_cs=0.0;
d_exparg_d_cc=0.0;
d_exparg_d_cb=0.0;
d_exparg_d_vto=0.0;
d_exparg_d_ss=0.0;
d_exparg_d_delta1=0.0;
d_exparg_d_delta2=0.0;
d_exparg_d_nd=0.0;
d_exparg_d_alpha=0.0;
d_exparg_d_vel0=0.0;
d_exparg_d_mu0=0.0;
d_exparg_d_beta=0.0;
d_exparg_d_mtheta=0.0;
d_exparg_d_vtheta=0.0;
d_exparg_d_vtzeta=0.0;
d_exparg_d_dibsat=0.0;
d_exparg_d_epsilon=0.0;
d_exparg_d_vzeta=0.0;
d_exparg_d_lambda=0.0;
d_exparg_d_ngf=0.0;
d_exparg_d_type=0.0;
exparg=0;
}
else
{
d_exparg_d_vgsin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vgsin;
d_exparg_d_vdsin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vdsin;
d_exparg_d_qcbflag=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_qcbflag;
d_exparg_d_vcin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vcin;
d_exparg_d_vbin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vbin;
d_exparg_d_qgsflag=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_qgsflag;
d_exparg_d_tambin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_tambin;
d_exparg_d_tnomin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_tnomin;
d_exparg_d_phitin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_phitin;
d_exparg_d_w=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_w;
d_exparg_d_lin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_lin;
d_exparg_d_cgin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cgin;
d_exparg_d_cs=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cs;
d_exparg_d_cc=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cc;
d_exparg_d_cb=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cb;
d_exparg_d_vto=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vto;
d_exparg_d_ss=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_ss;
d_exparg_d_delta1=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_delta1;
d_exparg_d_delta2=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_delta2;
d_exparg_d_nd=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_nd;
d_exparg_d_alpha=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_alpha;
d_exparg_d_vel0=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vel0;
d_exparg_d_mu0=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_mu0;
d_exparg_d_beta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_beta;
d_exparg_d_mtheta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_mtheta;
d_exparg_d_vtheta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vtheta;
d_exparg_d_vtzeta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vtzeta;
d_exparg_d_dibsat=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_dibsat;
d_exparg_d_epsilon=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_epsilon;
d_exparg_d_vzeta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vzeta;
d_exparg_d_lambda=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_lambda;
d_exparg_d_ngf=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_ngf;
d_exparg_d_type=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_type;
exparg=log((1.0+exp(etags)));
}
}
d_qsout_d_vgsin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vgsin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vgsin)*exparg));
d_qsout_d_vdsin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vdsin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vdsin)*exparg));
d_qsout_d_qcbflag=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_qcbflag)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_qcbflag)*exparg));
d_qsout_d_vcin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vcin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vcin)*exparg));
d_qsout_d_vbin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vbin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vbin)*exparg));
d_qsout_d_qgsflag=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_qgsflag)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_qgsflag)*exparg));
d_qsout_d_tambin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_tambin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_tambin)*exparg));
d_qsout_d_tnomin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_tnomin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_tnomin)*exparg));
d_qsout_d_phitin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_phitin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_phitin)*exparg));
d_qsout_d_w=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_w)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_w)+((((ngf)*type)*cs)*two_n_phit0))*exparg));
d_qsout_d_lin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_lin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_lin)*exparg));
d_qsout_d_cgin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cgin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_cgin)*exparg));
d_qsout_d_cs=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cs)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_cs)+((((w*ngf)*type))*two_n_phit0))*exparg));
d_qsout_d_cc=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cc)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_cc)*exparg));
d_qsout_d_cb=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cb)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_cb)*exparg));
d_qsout_d_vto=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vto)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vto)*exparg));
d_qsout_d_ss=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_ss)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_ss)*exparg));
d_qsout_d_delta1=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_delta1)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_delta1)*exparg));
d_qsout_d_delta2=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_delta2)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_delta2)*exparg));
d_qsout_d_nd=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_nd)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_nd)*exparg));
d_qsout_d_alpha=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_alpha)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_alpha)*exparg));
d_qsout_d_vel0=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vel0)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vel0)*exparg));
d_qsout_d_mu0=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_mu0)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_mu0)*exparg));
d_qsout_d_beta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_beta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_beta)*exparg));
d_qsout_d_mtheta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_mtheta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_mtheta)*exparg));
d_qsout_d_vtheta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vtheta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vtheta)*exparg));
d_qsout_d_vtzeta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vtzeta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vtzeta)*exparg));
d_qsout_d_dibsat=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_dibsat)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_dibsat)*exparg));
d_qsout_d_epsilon=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_epsilon)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_epsilon)*exparg));
d_qsout_d_vzeta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vzeta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vzeta)*exparg));
d_qsout_d_lambda=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_lambda)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_lambda)*exparg));
d_qsout_d_ngf=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_ngf)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_ngf)+((((w)*type)*cs)*two_n_phit0))*exparg));
d_qsout_d_type=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_type)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_type)+((((w*ngf))*cs)*two_n_phit0))*exparg));
qsout=(((((w*ngf)*type)*cs)*two_n_phit0)*exparg);
}
else
{
d_qsout_d_vgsin=0.0;
d_qsout_d_vdsin=0.0;
d_qsout_d_qcbflag=0.0;
d_qsout_d_vcin=0.0;
d_qsout_d_vbin=0.0;
d_qsout_d_qgsflag=0.0;
d_qsout_d_tambin=0.0;
d_qsout_d_tnomin=0.0;
d_qsout_d_phitin=0.0;
d_qsout_d_w=0.0;
d_qsout_d_lin=0.0;
d_qsout_d_cgin=0.0;
d_qsout_d_cs=0.0;
d_qsout_d_cc=0.0;
d_qsout_d_cb=0.0;
d_qsout_d_vto=0.0;
d_qsout_d_ss=0.0;
d_qsout_d_delta1=0.0;
d_qsout_d_delta2=0.0;
d_qsout_d_nd=0.0;
d_qsout_d_alpha=0.0;
d_qsout_d_vel0=0.0;
d_qsout_d_mu0=0.0;
d_qsout_d_beta=0.0;
d_qsout_d_mtheta=0.0;
d_qsout_d_vtheta=0.0;
d_qsout_d_vtzeta=0.0;
d_qsout_d_dibsat=0.0;
d_qsout_d_epsilon=0.0;
d_qsout_d_vzeta=0.0;
d_qsout_d_lambda=0.0;
d_qsout_d_ngf=0.0;
d_qsout_d_type=0.0;
qsout=0;
}
d_calc_iq_d_vgsin=d_idsout_d_vgsin;
d_calc_iq_d_vdsin=d_idsout_d_vdsin;
d_calc_iq_d_qcbflag=d_idsout_d_qcbflag;
d_calc_iq_d_vcin=d_idsout_d_vcin;
d_calc_iq_d_vbin=d_idsout_d_vbin;
d_calc_iq_d_qgsflag=d_idsout_d_qgsflag;
d_calc_iq_d_tambin=d_idsout_d_tambin;
d_calc_iq_d_tnomin=d_idsout_d_tnomin;
d_calc_iq_d_phitin=d_idsout_d_phitin;
d_calc_iq_d_w=d_idsout_d_w;
d_calc_iq_d_lin=d_idsout_d_lin;
d_calc_iq_d_cgin=d_idsout_d_cgin;
d_calc_iq_d_cs=d_idsout_d_cs;
d_calc_iq_d_cc=d_idsout_d_cc;
d_calc_iq_d_cb=d_idsout_d_cb;
d_calc_iq_d_vto=d_idsout_d_vto;
d_calc_iq_d_ss=d_idsout_d_ss;
d_calc_iq_d_delta1=d_idsout_d_delta1;
d_calc_iq_d_delta2=d_idsout_d_delta2;
d_calc_iq_d_nd=d_idsout_d_nd;
d_calc_iq_d_alpha=d_idsout_d_alpha;
d_calc_iq_d_vel0=d_idsout_d_vel0;
d_calc_iq_d_mu0=d_idsout_d_mu0;
d_calc_iq_d_beta=d_idsout_d_beta;
d_calc_iq_d_mtheta=d_idsout_d_mtheta;
d_calc_iq_d_vtheta=d_idsout_d_vtheta;
d_calc_iq_d_vtzeta=d_idsout_d_vtzeta;
d_calc_iq_d_dibsat=d_idsout_d_dibsat;
d_calc_iq_d_epsilon=d_idsout_d_epsilon;
d_calc_iq_d_vzeta=d_idsout_d_vzeta;
d_calc_iq_d_lambda=d_idsout_d_lambda;
d_calc_iq_d_ngf=d_idsout_d_ngf;
d_calc_iq_d_type=d_idsout_d_type;
calc_iq=idsout;
}
d_calc_iq = d_calc_iq_d_vgsin*d_vgsin+d_calc_iq_d_vdsin*d_vdsin+d_calc_iq_d_qcbflag*d_qcbflag+d_calc_iq_d_vcin*d_vcin+d_calc_iq_d_vbin*d_vbin+d_calc_iq_d_qgsflag*d_qgsflag+d_calc_iq_d_tambin*d_tambin+d_calc_iq_d_tnomin*d_tnomin+d_calc_iq_d_phitin*d_phitin+d_calc_iq_d_w*d_w+d_calc_iq_d_lin*d_lin+d_calc_iq_d_cgin*d_cgin+d_calc_iq_d_cs*d_cs+d_calc_iq_d_cc*d_cc+d_calc_iq_d_cb*d_cb+d_calc_iq_d_vto*d_vto+d_calc_iq_d_ss*d_ss+d_calc_iq_d_delta1*d_delta1+d_calc_iq_d_delta2*d_delta2+d_calc_iq_d_nd*d_nd+d_calc_iq_d_alpha*d_alpha+d_calc_iq_d_vel0*d_vel0+d_calc_iq_d_mu0*d_mu0+d_calc_iq_d_beta*d_beta+d_calc_iq_d_mtheta*d_mtheta+d_calc_iq_d_vtheta*d_vtheta+d_calc_iq_d_vtzeta*d_vtzeta+d_calc_iq_d_dibsat*d_dibsat+d_calc_iq_d_epsilon*d_epsilon+d_calc_iq_d_vzeta*d_vzeta+d_calc_iq_d_lambda*d_lambda+d_calc_iq_d_ngf*d_ngf+d_calc_iq_d_type*d_type;
d_idsout = d_idsout_d_vgsin*d_vgsin+d_idsout_d_vdsin*d_vdsin+d_idsout_d_qcbflag*d_qcbflag+d_idsout_d_vcin*d_vcin+d_idsout_d_vbin*d_vbin+d_idsout_d_qgsflag*d_qgsflag+d_idsout_d_tambin*d_tambin+d_idsout_d_tnomin*d_tnomin+d_idsout_d_phitin*d_phitin+d_idsout_d_w*d_w+d_idsout_d_lin*d_lin+d_idsout_d_cgin*d_cgin+d_idsout_d_cs*d_cs+d_idsout_d_cc*d_cc+d_idsout_d_cb*d_cb+d_idsout_d_vto*d_vto+d_idsout_d_ss*d_ss+d_idsout_d_delta1*d_delta1+d_idsout_d_delta2*d_delta2+d_idsout_d_nd*d_nd+d_idsout_d_alpha*d_alpha+d_idsout_d_vel0*d_vel0+d_idsout_d_mu0*d_mu0+d_idsout_d_beta*d_beta+d_idsout_d_mtheta*d_mtheta+d_idsout_d_vtheta*d_vtheta+d_idsout_d_vtzeta*d_vtzeta+d_idsout_d_dibsat*d_dibsat+d_idsout_d_epsilon*d_epsilon+d_idsout_d_vzeta*d_vzeta+d_idsout_d_lambda*d_lambda+d_idsout_d_ngf*d_ngf+d_idsout_d_type*d_type;
d_qgsout = d_qgsout_d_vgsin*d_vgsin+d_qgsout_d_vdsin*d_vdsin+d_qgsout_d_qcbflag*d_qcbflag+d_qgsout_d_vcin*d_vcin+d_qgsout_d_vbin*d_vbin+d_qgsout_d_qgsflag*d_qgsflag+d_qgsout_d_tambin*d_tambin+d_qgsout_d_tnomin*d_tnomin+d_qgsout_d_phitin*d_phitin+d_qgsout_d_w*d_w+d_qgsout_d_lin*d_lin+d_qgsout_d_cgin*d_cgin+d_qgsout_d_cs*d_cs+d_qgsout_d_cc*d_cc+d_qgsout_d_cb*d_cb+d_qgsout_d_vto*d_vto+d_qgsout_d_ss*d_ss+d_qgsout_d_delta1*d_delta1+d_qgsout_d_delta2*d_delta2+d_qgsout_d_nd*d_nd+d_qgsout_d_alpha*d_alpha+d_qgsout_d_vel0*d_vel0+d_qgsout_d_mu0*d_mu0+d_qgsout_d_beta*d_beta+d_qgsout_d_mtheta*d_mtheta+d_qgsout_d_vtheta*d_vtheta+d_qgsout_d_vtzeta*d_vtzeta+d_qgsout_d_dibsat*d_dibsat+d_qgsout_d_epsilon*d_epsilon+d_qgsout_d_vzeta*d_vzeta+d_qgsout_d_lambda*d_lambda+d_qgsout_d_ngf*d_ngf+d_qgsout_d_type*d_type;
d_qgdout = d_qgdout_d_vgsin*d_vgsin+d_qgdout_d_vdsin*d_vdsin+d_qgdout_d_qcbflag*d_qcbflag+d_qgdout_d_vcin*d_vcin+d_qgdout_d_vbin*d_vbin+d_qgdout_d_qgsflag*d_qgsflag+d_qgdout_d_tambin*d_tambin+d_qgdout_d_tnomin*d_tnomin+d_qgdout_d_phitin*d_phitin+d_qgdout_d_w*d_w+d_qgdout_d_lin*d_lin+d_qgdout_d_cgin*d_cgin+d_qgdout_d_cs*d_cs+d_qgdout_d_cc*d_cc+d_qgdout_d_cb*d_cb+d_qgdout_d_vto*d_vto+d_qgdout_d_ss*d_ss+d_qgdout_d_delta1*d_delta1+d_qgdout_d_delta2*d_delta2+d_qgdout_d_nd*d_nd+d_qgdout_d_alpha*d_alpha+d_qgdout_d_vel0*d_vel0+d_qgdout_d_mu0*d_mu0+d_qgdout_d_beta*d_beta+d_qgdout_d_mtheta*d_mtheta+d_qgdout_d_vtheta*d_vtheta+d_qgdout_d_vtzeta*d_vtzeta+d_qgdout_d_dibsat*d_dibsat+d_qgdout_d_epsilon*d_epsilon+d_qgdout_d_vzeta*d_vzeta+d_qgdout_d_lambda*d_lambda+d_qgdout_d_ngf*d_ngf+d_qgdout_d_type*d_type;
d_qcout = d_qcout_d_vgsin*d_vgsin+d_qcout_d_vdsin*d_vdsin+d_qcout_d_qcbflag*d_qcbflag+d_qcout_d_vcin*d_vcin+d_qcout_d_vbin*d_vbin+d_qcout_d_qgsflag*d_qgsflag+d_qcout_d_tambin*d_tambin+d_qcout_d_tnomin*d_tnomin+d_qcout_d_phitin*d_phitin+d_qcout_d_w*d_w+d_qcout_d_lin*d_lin+d_qcout_d_cgin*d_cgin+d_qcout_d_cs*d_cs+d_qcout_d_cc*d_cc+d_qcout_d_cb*d_cb+d_qcout_d_vto*d_vto+d_qcout_d_ss*d_ss+d_qcout_d_delta1*d_delta1+d_qcout_d_delta2*d_delta2+d_qcout_d_nd*d_nd+d_qcout_d_alpha*d_alpha+d_qcout_d_vel0*d_vel0+d_qcout_d_mu0*d_mu0+d_qcout_d_beta*d_beta+d_qcout_d_mtheta*d_mtheta+d_qcout_d_vtheta*d_vtheta+d_qcout_d_vtzeta*d_vtzeta+d_qcout_d_dibsat*d_dibsat+d_qcout_d_epsilon*d_epsilon+d_qcout_d_vzeta*d_vzeta+d_qcout_d_lambda*d_lambda+d_qcout_d_ngf*d_ngf+d_qcout_d_type*d_type;
d_qbout = d_qbout_d_vgsin*d_vgsin+d_qbout_d_vdsin*d_vdsin+d_qbout_d_qcbflag*d_qcbflag+d_qbout_d_vcin*d_vcin+d_qbout_d_vbin*d_vbin+d_qbout_d_qgsflag*d_qgsflag+d_qbout_d_tambin*d_tambin+d_qbout_d_tnomin*d_tnomin+d_qbout_d_phitin*d_phitin+d_qbout_d_w*d_w+d_qbout_d_lin*d_lin+d_qbout_d_cgin*d_cgin+d_qbout_d_cs*d_cs+d_qbout_d_cc*d_cc+d_qbout_d_cb*d_cb+d_qbout_d_vto*d_vto+d_qbout_d_ss*d_ss+d_qbout_d_delta1*d_delta1+d_qbout_d_delta2*d_delta2+d_qbout_d_nd*d_nd+d_qbout_d_alpha*d_alpha+d_qbout_d_vel0*d_vel0+d_qbout_d_mu0*d_mu0+d_qbout_d_beta*d_beta+d_qbout_d_mtheta*d_mtheta+d_qbout_d_vtheta*d_vtheta+d_qbout_d_vtzeta*d_vtzeta+d_qbout_d_dibsat*d_dibsat+d_qbout_d_epsilon*d_epsilon+d_qbout_d_vzeta*d_vzeta+d_qbout_d_lambda*d_lambda+d_qbout_d_ngf*d_ngf+d_qbout_d_type*d_type;
d_qsout = d_qsout_d_vgsin*d_vgsin+d_qsout_d_vdsin*d_vdsin+d_qsout_d_qcbflag*d_qcbflag+d_qsout_d_vcin*d_vcin+d_qsout_d_vbin*d_vbin+d_qsout_d_qgsflag*d_qgsflag+d_qsout_d_tambin*d_tambin+d_qsout_d_tnomin*d_tnomin+d_qsout_d_phitin*d_phitin+d_qsout_d_w*d_w+d_qsout_d_lin*d_lin+d_qsout_d_cgin*d_cgin+d_qsout_d_cs*d_cs+d_qsout_d_cc*d_cc+d_qsout_d_cb*d_cb+d_qsout_d_vto*d_vto+d_qsout_d_ss*d_ss+d_qsout_d_delta1*d_delta1+d_qsout_d_delta2*d_delta2+d_qsout_d_nd*d_nd+d_qsout_d_alpha*d_alpha+d_qsout_d_vel0*d_vel0+d_qsout_d_mu0*d_mu0+d_qsout_d_beta*d_beta+d_qsout_d_mtheta*d_mtheta+d_qsout_d_vtheta*d_vtheta+d_qsout_d_vtzeta*d_vtzeta+d_qsout_d_dibsat*d_dibsat+d_qsout_d_epsilon*d_epsilon+d_qsout_d_vzeta*d_vzeta+d_qsout_d_lambda*d_lambda+d_qsout_d_ngf*d_ngf+d_qsout_d_type*d_type;
d_vtdibl = d_vtdibl_d_vgsin*d_vgsin+d_vtdibl_d_vdsin*d_vdsin+d_vtdibl_d_qcbflag*d_qcbflag+d_vtdibl_d_vcin*d_vcin+d_vtdibl_d_vbin*d_vbin+d_vtdibl_d_qgsflag*d_qgsflag+d_vtdibl_d_tambin*d_tambin+d_vtdibl_d_tnomin*d_tnomin+d_vtdibl_d_phitin*d_phitin+d_vtdibl_d_w*d_w+d_vtdibl_d_lin*d_lin+d_vtdibl_d_cgin*d_cgin+d_vtdibl_d_cs*d_cs+d_vtdibl_d_cc*d_cc+d_vtdibl_d_cb*d_cb+d_vtdibl_d_vto*d_vto+d_vtdibl_d_ss*d_ss+d_vtdibl_d_delta1*d_delta1+d_vtdibl_d_delta2*d_delta2+d_vtdibl_d_nd*d_nd+d_vtdibl_d_alpha*d_alpha+d_vtdibl_d_vel0*d_vel0+d_vtdibl_d_mu0*d_mu0+d_vtdibl_d_beta*d_beta+d_vtdibl_d_mtheta*d_mtheta+d_vtdibl_d_vtheta*d_vtheta+d_vtdibl_d_vtzeta*d_vtzeta+d_vtdibl_d_dibsat*d_dibsat+d_vtdibl_d_epsilon*d_epsilon+d_vtdibl_d_vzeta*d_vzeta+d_vtdibl_d_lambda*d_lambda+d_vtdibl_d_ngf*d_ngf+d_vtdibl_d_type*d_type;
d_vdsat1 = d_vdsat1_d_vgsin*d_vgsin+d_vdsat1_d_vdsin*d_vdsin+d_vdsat1_d_qcbflag*d_qcbflag+d_vdsat1_d_vcin*d_vcin+d_vdsat1_d_vbin*d_vbin+d_vdsat1_d_qgsflag*d_qgsflag+d_vdsat1_d_tambin*d_tambin+d_vdsat1_d_tnomin*d_tnomin+d_vdsat1_d_phitin*d_phitin+d_vdsat1_d_w*d_w+d_vdsat1_d_lin*d_lin+d_vdsat1_d_cgin*d_cgin+d_vdsat1_d_cs*d_cs+d_vdsat1_d_cc*d_cc+d_vdsat1_d_cb*d_cb+d_vdsat1_d_vto*d_vto+d_vdsat1_d_ss*d_ss+d_vdsat1_d_delta1*d_delta1+d_vdsat1_d_delta2*d_delta2+d_vdsat1_d_nd*d_nd+d_vdsat1_d_alpha*d_alpha+d_vdsat1_d_vel0*d_vel0+d_vdsat1_d_mu0*d_mu0+d_vdsat1_d_beta*d_beta+d_vdsat1_d_mtheta*d_mtheta+d_vdsat1_d_vtheta*d_vtheta+d_vdsat1_d_vtzeta*d_vtzeta+d_vdsat1_d_dibsat*d_dibsat+d_vdsat1_d_epsilon*d_epsilon+d_vdsat1_d_vzeta*d_vzeta+d_vdsat1_d_lambda*d_lambda+d_vdsat1_d_ngf*d_ngf+d_vdsat1_d_type*d_type;
return(d_calc_iq);
}

// Evaluator class implementations for Analog Function calc_iq
  // Constructor
  calc_iqEvaluator::calc_iqEvaluator(double idsout, double qgsout, double qgdout, double qcout, double qbout, double qsout, double vtdibl, double vdsat1, double vgsin, double vdsin, double qcbflag, double vcin, double vbin, double qgsflag, double tambin, double tnomin, double phitin, double w, double lin, double cgin, double cs, double cc, double cb, double vto, double ss, double delta1, double delta2, double nd, double alpha, double vel0, double mu0, double beta, double mtheta, double vtheta, double vtzeta, double dibsat, double epsilon, double vzeta, double lambda, double ngf, double type)
  {
    calc_iqReturn_ = evaluator_(idsoutReturn_, qgsoutReturn_, qgdoutReturn_, qcoutReturn_, qboutReturn_, qsoutReturn_, vtdiblReturn_, vdsat1Return_, vgsin, vdsin, qcbflag, vcin, vbin, qgsflag, tambin, tnomin, phitin, w, lin, cgin, cs, cc, cb, vto, ss, delta1, delta2, nd, alpha, vel0, mu0, beta, mtheta, vtheta, vtzeta, dibsat, epsilon, vzeta, lambda, ngf, type);
  }
  // method to get precomputed values into double vars 
  double calc_iqEvaluator::getValues(double &  idsout, double &  qgsout, double &  qgdout, double &  qcout, double &  qbout, double &  qsout, double &  vtdibl, double &  vdsat1, double  vgsin, double  vdsin, double  qcbflag, double  vcin, double  vbin, double  qgsflag, double  tambin, double  tnomin, double  phitin, double  w, double  lin, double  cgin, double  cs, double  cc, double  cb, double  vto, double  ss, double  delta1, double  delta2, double  nd, double  alpha, double  vel0, double  mu0, double  beta, double  mtheta, double  vtheta, double  vtzeta, double  dibsat, double  epsilon, double  vzeta, double  lambda, double  ngf, double  type)
  {
    // Silence unused argument warnings
    (void) vgsin;
    (void) vdsin;
    (void) qcbflag;
    (void) vcin;
    (void) vbin;
    (void) qgsflag;
    (void) tambin;
    (void) tnomin;
    (void) phitin;
    (void) w;
    (void) lin;
    (void) cgin;
    (void) cs;
    (void) cc;
    (void) cb;
    (void) vto;
    (void) ss;
    (void) delta1;
    (void) delta2;
    (void) nd;
    (void) alpha;
    (void) vel0;
    (void) mu0;
    (void) beta;
    (void) mtheta;
    (void) vtheta;
    (void) vtzeta;
    (void) dibsat;
    (void) epsilon;
    (void) vzeta;
    (void) lambda;
    (void) ngf;
    (void) type;
    // Copy all precomputed values into corresponding output
    idsout = idsoutReturn_.value;
    qgsout = qgsoutReturn_.value;
    qgdout = qgdoutReturn_.value;
    qcout = qcoutReturn_.value;
    qbout = qboutReturn_.value;
    qsout = qsoutReturn_.value;
    vtdibl = vtdiblReturn_.value;
    vdsat1 = vdsat1Return_.value;
    return(calc_iqReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double calc_iqEvaluator::getDerivs(double idsout , double qgsout , double qgdout , double qcout , double qbout , double qsout , double vtdibl , double vdsat1 , double vgsin , double vdsin , double qcbflag , double vcin , double vbin , double qgsflag , double tambin , double tnomin , double phitin , double w , double lin , double cgin , double cs , double cc , double cb , double vto , double ss , double delta1 , double delta2 , double nd , double alpha , double vel0 , double mu0 , double beta , double mtheta , double vtheta , double vtzeta , double dibsat , double epsilon , double vzeta , double lambda , double ngf , double type  , double & d_idsout, double & d_qgsout, double & d_qgdout, double & d_qcout, double & d_qbout, double & d_qsout, double & d_vtdibl, double & d_vdsat1, double d_vgsin, double d_vdsin, double d_qcbflag, double d_vcin, double d_vbin, double d_qgsflag, double d_tambin, double d_tnomin, double d_phitin, double d_w, double d_lin, double d_cgin, double d_cs, double d_cc, double d_cb, double d_vto, double d_ss, double d_delta1, double d_delta2, double d_nd, double d_alpha, double d_vel0, double d_mu0, double d_beta, double d_mtheta, double d_vtheta, double d_vtzeta, double d_dibsat, double d_epsilon, double d_vzeta, double d_lambda, double d_ngf, double d_type)
  {
    // Function total deriv
    double d_calc_iq;
    // Silence unused argument warnings
    (void) vgsin;
    (void) vdsin;
    (void) qcbflag;
    (void) vcin;
    (void) vbin;
    (void) qgsflag;
    (void) tambin;
    (void) tnomin;
    (void) phitin;
    (void) w;
    (void) lin;
    (void) cgin;
    (void) cs;
    (void) cc;
    (void) cb;
    (void) vto;
    (void) ss;
    (void) delta1;
    (void) delta2;
    (void) nd;
    (void) alpha;
    (void) vel0;
    (void) mu0;
    (void) beta;
    (void) mtheta;
    (void) vtheta;
    (void) vtzeta;
    (void) dibsat;
    (void) epsilon;
    (void) vzeta;
    (void) lambda;
    (void) ngf;
    (void) type;
    d_calc_iq = calc_iqReturn_.deriv_WRT_vgsin*d_vgsin+calc_iqReturn_.deriv_WRT_vdsin*d_vdsin+calc_iqReturn_.deriv_WRT_qcbflag*d_qcbflag+calc_iqReturn_.deriv_WRT_vcin*d_vcin+calc_iqReturn_.deriv_WRT_vbin*d_vbin+calc_iqReturn_.deriv_WRT_qgsflag*d_qgsflag+calc_iqReturn_.deriv_WRT_tambin*d_tambin+calc_iqReturn_.deriv_WRT_tnomin*d_tnomin+calc_iqReturn_.deriv_WRT_phitin*d_phitin+calc_iqReturn_.deriv_WRT_w*d_w+calc_iqReturn_.deriv_WRT_lin*d_lin+calc_iqReturn_.deriv_WRT_cgin*d_cgin+calc_iqReturn_.deriv_WRT_cs*d_cs+calc_iqReturn_.deriv_WRT_cc*d_cc+calc_iqReturn_.deriv_WRT_cb*d_cb+calc_iqReturn_.deriv_WRT_vto*d_vto+calc_iqReturn_.deriv_WRT_ss*d_ss+calc_iqReturn_.deriv_WRT_delta1*d_delta1+calc_iqReturn_.deriv_WRT_delta2*d_delta2+calc_iqReturn_.deriv_WRT_nd*d_nd+calc_iqReturn_.deriv_WRT_alpha*d_alpha+calc_iqReturn_.deriv_WRT_vel0*d_vel0+calc_iqReturn_.deriv_WRT_mu0*d_mu0+calc_iqReturn_.deriv_WRT_beta*d_beta+calc_iqReturn_.deriv_WRT_mtheta*d_mtheta+calc_iqReturn_.deriv_WRT_vtheta*d_vtheta+calc_iqReturn_.deriv_WRT_vtzeta*d_vtzeta+calc_iqReturn_.deriv_WRT_dibsat*d_dibsat+calc_iqReturn_.deriv_WRT_epsilon*d_epsilon+calc_iqReturn_.deriv_WRT_vzeta*d_vzeta+calc_iqReturn_.deriv_WRT_lambda*d_lambda+calc_iqReturn_.deriv_WRT_ngf*d_ngf+calc_iqReturn_.deriv_WRT_type*d_type;
    d_idsout = idsoutReturn_.deriv_WRT_vgsin*d_vgsin+idsoutReturn_.deriv_WRT_vdsin*d_vdsin+idsoutReturn_.deriv_WRT_qcbflag*d_qcbflag+idsoutReturn_.deriv_WRT_vcin*d_vcin+idsoutReturn_.deriv_WRT_vbin*d_vbin+idsoutReturn_.deriv_WRT_qgsflag*d_qgsflag+idsoutReturn_.deriv_WRT_tambin*d_tambin+idsoutReturn_.deriv_WRT_tnomin*d_tnomin+idsoutReturn_.deriv_WRT_phitin*d_phitin+idsoutReturn_.deriv_WRT_w*d_w+idsoutReturn_.deriv_WRT_lin*d_lin+idsoutReturn_.deriv_WRT_cgin*d_cgin+idsoutReturn_.deriv_WRT_cs*d_cs+idsoutReturn_.deriv_WRT_cc*d_cc+idsoutReturn_.deriv_WRT_cb*d_cb+idsoutReturn_.deriv_WRT_vto*d_vto+idsoutReturn_.deriv_WRT_ss*d_ss+idsoutReturn_.deriv_WRT_delta1*d_delta1+idsoutReturn_.deriv_WRT_delta2*d_delta2+idsoutReturn_.deriv_WRT_nd*d_nd+idsoutReturn_.deriv_WRT_alpha*d_alpha+idsoutReturn_.deriv_WRT_vel0*d_vel0+idsoutReturn_.deriv_WRT_mu0*d_mu0+idsoutReturn_.deriv_WRT_beta*d_beta+idsoutReturn_.deriv_WRT_mtheta*d_mtheta+idsoutReturn_.deriv_WRT_vtheta*d_vtheta+idsoutReturn_.deriv_WRT_vtzeta*d_vtzeta+idsoutReturn_.deriv_WRT_dibsat*d_dibsat+idsoutReturn_.deriv_WRT_epsilon*d_epsilon+idsoutReturn_.deriv_WRT_vzeta*d_vzeta+idsoutReturn_.deriv_WRT_lambda*d_lambda+idsoutReturn_.deriv_WRT_ngf*d_ngf+idsoutReturn_.deriv_WRT_type*d_type;
    d_qgsout = qgsoutReturn_.deriv_WRT_vgsin*d_vgsin+qgsoutReturn_.deriv_WRT_vdsin*d_vdsin+qgsoutReturn_.deriv_WRT_qcbflag*d_qcbflag+qgsoutReturn_.deriv_WRT_vcin*d_vcin+qgsoutReturn_.deriv_WRT_vbin*d_vbin+qgsoutReturn_.deriv_WRT_qgsflag*d_qgsflag+qgsoutReturn_.deriv_WRT_tambin*d_tambin+qgsoutReturn_.deriv_WRT_tnomin*d_tnomin+qgsoutReturn_.deriv_WRT_phitin*d_phitin+qgsoutReturn_.deriv_WRT_w*d_w+qgsoutReturn_.deriv_WRT_lin*d_lin+qgsoutReturn_.deriv_WRT_cgin*d_cgin+qgsoutReturn_.deriv_WRT_cs*d_cs+qgsoutReturn_.deriv_WRT_cc*d_cc+qgsoutReturn_.deriv_WRT_cb*d_cb+qgsoutReturn_.deriv_WRT_vto*d_vto+qgsoutReturn_.deriv_WRT_ss*d_ss+qgsoutReturn_.deriv_WRT_delta1*d_delta1+qgsoutReturn_.deriv_WRT_delta2*d_delta2+qgsoutReturn_.deriv_WRT_nd*d_nd+qgsoutReturn_.deriv_WRT_alpha*d_alpha+qgsoutReturn_.deriv_WRT_vel0*d_vel0+qgsoutReturn_.deriv_WRT_mu0*d_mu0+qgsoutReturn_.deriv_WRT_beta*d_beta+qgsoutReturn_.deriv_WRT_mtheta*d_mtheta+qgsoutReturn_.deriv_WRT_vtheta*d_vtheta+qgsoutReturn_.deriv_WRT_vtzeta*d_vtzeta+qgsoutReturn_.deriv_WRT_dibsat*d_dibsat+qgsoutReturn_.deriv_WRT_epsilon*d_epsilon+qgsoutReturn_.deriv_WRT_vzeta*d_vzeta+qgsoutReturn_.deriv_WRT_lambda*d_lambda+qgsoutReturn_.deriv_WRT_ngf*d_ngf+qgsoutReturn_.deriv_WRT_type*d_type;
    d_qgdout = qgdoutReturn_.deriv_WRT_vgsin*d_vgsin+qgdoutReturn_.deriv_WRT_vdsin*d_vdsin+qgdoutReturn_.deriv_WRT_qcbflag*d_qcbflag+qgdoutReturn_.deriv_WRT_vcin*d_vcin+qgdoutReturn_.deriv_WRT_vbin*d_vbin+qgdoutReturn_.deriv_WRT_qgsflag*d_qgsflag+qgdoutReturn_.deriv_WRT_tambin*d_tambin+qgdoutReturn_.deriv_WRT_tnomin*d_tnomin+qgdoutReturn_.deriv_WRT_phitin*d_phitin+qgdoutReturn_.deriv_WRT_w*d_w+qgdoutReturn_.deriv_WRT_lin*d_lin+qgdoutReturn_.deriv_WRT_cgin*d_cgin+qgdoutReturn_.deriv_WRT_cs*d_cs+qgdoutReturn_.deriv_WRT_cc*d_cc+qgdoutReturn_.deriv_WRT_cb*d_cb+qgdoutReturn_.deriv_WRT_vto*d_vto+qgdoutReturn_.deriv_WRT_ss*d_ss+qgdoutReturn_.deriv_WRT_delta1*d_delta1+qgdoutReturn_.deriv_WRT_delta2*d_delta2+qgdoutReturn_.deriv_WRT_nd*d_nd+qgdoutReturn_.deriv_WRT_alpha*d_alpha+qgdoutReturn_.deriv_WRT_vel0*d_vel0+qgdoutReturn_.deriv_WRT_mu0*d_mu0+qgdoutReturn_.deriv_WRT_beta*d_beta+qgdoutReturn_.deriv_WRT_mtheta*d_mtheta+qgdoutReturn_.deriv_WRT_vtheta*d_vtheta+qgdoutReturn_.deriv_WRT_vtzeta*d_vtzeta+qgdoutReturn_.deriv_WRT_dibsat*d_dibsat+qgdoutReturn_.deriv_WRT_epsilon*d_epsilon+qgdoutReturn_.deriv_WRT_vzeta*d_vzeta+qgdoutReturn_.deriv_WRT_lambda*d_lambda+qgdoutReturn_.deriv_WRT_ngf*d_ngf+qgdoutReturn_.deriv_WRT_type*d_type;
    d_qcout = qcoutReturn_.deriv_WRT_vgsin*d_vgsin+qcoutReturn_.deriv_WRT_vdsin*d_vdsin+qcoutReturn_.deriv_WRT_qcbflag*d_qcbflag+qcoutReturn_.deriv_WRT_vcin*d_vcin+qcoutReturn_.deriv_WRT_vbin*d_vbin+qcoutReturn_.deriv_WRT_qgsflag*d_qgsflag+qcoutReturn_.deriv_WRT_tambin*d_tambin+qcoutReturn_.deriv_WRT_tnomin*d_tnomin+qcoutReturn_.deriv_WRT_phitin*d_phitin+qcoutReturn_.deriv_WRT_w*d_w+qcoutReturn_.deriv_WRT_lin*d_lin+qcoutReturn_.deriv_WRT_cgin*d_cgin+qcoutReturn_.deriv_WRT_cs*d_cs+qcoutReturn_.deriv_WRT_cc*d_cc+qcoutReturn_.deriv_WRT_cb*d_cb+qcoutReturn_.deriv_WRT_vto*d_vto+qcoutReturn_.deriv_WRT_ss*d_ss+qcoutReturn_.deriv_WRT_delta1*d_delta1+qcoutReturn_.deriv_WRT_delta2*d_delta2+qcoutReturn_.deriv_WRT_nd*d_nd+qcoutReturn_.deriv_WRT_alpha*d_alpha+qcoutReturn_.deriv_WRT_vel0*d_vel0+qcoutReturn_.deriv_WRT_mu0*d_mu0+qcoutReturn_.deriv_WRT_beta*d_beta+qcoutReturn_.deriv_WRT_mtheta*d_mtheta+qcoutReturn_.deriv_WRT_vtheta*d_vtheta+qcoutReturn_.deriv_WRT_vtzeta*d_vtzeta+qcoutReturn_.deriv_WRT_dibsat*d_dibsat+qcoutReturn_.deriv_WRT_epsilon*d_epsilon+qcoutReturn_.deriv_WRT_vzeta*d_vzeta+qcoutReturn_.deriv_WRT_lambda*d_lambda+qcoutReturn_.deriv_WRT_ngf*d_ngf+qcoutReturn_.deriv_WRT_type*d_type;
    d_qbout = qboutReturn_.deriv_WRT_vgsin*d_vgsin+qboutReturn_.deriv_WRT_vdsin*d_vdsin+qboutReturn_.deriv_WRT_qcbflag*d_qcbflag+qboutReturn_.deriv_WRT_vcin*d_vcin+qboutReturn_.deriv_WRT_vbin*d_vbin+qboutReturn_.deriv_WRT_qgsflag*d_qgsflag+qboutReturn_.deriv_WRT_tambin*d_tambin+qboutReturn_.deriv_WRT_tnomin*d_tnomin+qboutReturn_.deriv_WRT_phitin*d_phitin+qboutReturn_.deriv_WRT_w*d_w+qboutReturn_.deriv_WRT_lin*d_lin+qboutReturn_.deriv_WRT_cgin*d_cgin+qboutReturn_.deriv_WRT_cs*d_cs+qboutReturn_.deriv_WRT_cc*d_cc+qboutReturn_.deriv_WRT_cb*d_cb+qboutReturn_.deriv_WRT_vto*d_vto+qboutReturn_.deriv_WRT_ss*d_ss+qboutReturn_.deriv_WRT_delta1*d_delta1+qboutReturn_.deriv_WRT_delta2*d_delta2+qboutReturn_.deriv_WRT_nd*d_nd+qboutReturn_.deriv_WRT_alpha*d_alpha+qboutReturn_.deriv_WRT_vel0*d_vel0+qboutReturn_.deriv_WRT_mu0*d_mu0+qboutReturn_.deriv_WRT_beta*d_beta+qboutReturn_.deriv_WRT_mtheta*d_mtheta+qboutReturn_.deriv_WRT_vtheta*d_vtheta+qboutReturn_.deriv_WRT_vtzeta*d_vtzeta+qboutReturn_.deriv_WRT_dibsat*d_dibsat+qboutReturn_.deriv_WRT_epsilon*d_epsilon+qboutReturn_.deriv_WRT_vzeta*d_vzeta+qboutReturn_.deriv_WRT_lambda*d_lambda+qboutReturn_.deriv_WRT_ngf*d_ngf+qboutReturn_.deriv_WRT_type*d_type;
    d_qsout = qsoutReturn_.deriv_WRT_vgsin*d_vgsin+qsoutReturn_.deriv_WRT_vdsin*d_vdsin+qsoutReturn_.deriv_WRT_qcbflag*d_qcbflag+qsoutReturn_.deriv_WRT_vcin*d_vcin+qsoutReturn_.deriv_WRT_vbin*d_vbin+qsoutReturn_.deriv_WRT_qgsflag*d_qgsflag+qsoutReturn_.deriv_WRT_tambin*d_tambin+qsoutReturn_.deriv_WRT_tnomin*d_tnomin+qsoutReturn_.deriv_WRT_phitin*d_phitin+qsoutReturn_.deriv_WRT_w*d_w+qsoutReturn_.deriv_WRT_lin*d_lin+qsoutReturn_.deriv_WRT_cgin*d_cgin+qsoutReturn_.deriv_WRT_cs*d_cs+qsoutReturn_.deriv_WRT_cc*d_cc+qsoutReturn_.deriv_WRT_cb*d_cb+qsoutReturn_.deriv_WRT_vto*d_vto+qsoutReturn_.deriv_WRT_ss*d_ss+qsoutReturn_.deriv_WRT_delta1*d_delta1+qsoutReturn_.deriv_WRT_delta2*d_delta2+qsoutReturn_.deriv_WRT_nd*d_nd+qsoutReturn_.deriv_WRT_alpha*d_alpha+qsoutReturn_.deriv_WRT_vel0*d_vel0+qsoutReturn_.deriv_WRT_mu0*d_mu0+qsoutReturn_.deriv_WRT_beta*d_beta+qsoutReturn_.deriv_WRT_mtheta*d_mtheta+qsoutReturn_.deriv_WRT_vtheta*d_vtheta+qsoutReturn_.deriv_WRT_vtzeta*d_vtzeta+qsoutReturn_.deriv_WRT_dibsat*d_dibsat+qsoutReturn_.deriv_WRT_epsilon*d_epsilon+qsoutReturn_.deriv_WRT_vzeta*d_vzeta+qsoutReturn_.deriv_WRT_lambda*d_lambda+qsoutReturn_.deriv_WRT_ngf*d_ngf+qsoutReturn_.deriv_WRT_type*d_type;
    d_vtdibl = vtdiblReturn_.deriv_WRT_vgsin*d_vgsin+vtdiblReturn_.deriv_WRT_vdsin*d_vdsin+vtdiblReturn_.deriv_WRT_qcbflag*d_qcbflag+vtdiblReturn_.deriv_WRT_vcin*d_vcin+vtdiblReturn_.deriv_WRT_vbin*d_vbin+vtdiblReturn_.deriv_WRT_qgsflag*d_qgsflag+vtdiblReturn_.deriv_WRT_tambin*d_tambin+vtdiblReturn_.deriv_WRT_tnomin*d_tnomin+vtdiblReturn_.deriv_WRT_phitin*d_phitin+vtdiblReturn_.deriv_WRT_w*d_w+vtdiblReturn_.deriv_WRT_lin*d_lin+vtdiblReturn_.deriv_WRT_cgin*d_cgin+vtdiblReturn_.deriv_WRT_cs*d_cs+vtdiblReturn_.deriv_WRT_cc*d_cc+vtdiblReturn_.deriv_WRT_cb*d_cb+vtdiblReturn_.deriv_WRT_vto*d_vto+vtdiblReturn_.deriv_WRT_ss*d_ss+vtdiblReturn_.deriv_WRT_delta1*d_delta1+vtdiblReturn_.deriv_WRT_delta2*d_delta2+vtdiblReturn_.deriv_WRT_nd*d_nd+vtdiblReturn_.deriv_WRT_alpha*d_alpha+vtdiblReturn_.deriv_WRT_vel0*d_vel0+vtdiblReturn_.deriv_WRT_mu0*d_mu0+vtdiblReturn_.deriv_WRT_beta*d_beta+vtdiblReturn_.deriv_WRT_mtheta*d_mtheta+vtdiblReturn_.deriv_WRT_vtheta*d_vtheta+vtdiblReturn_.deriv_WRT_vtzeta*d_vtzeta+vtdiblReturn_.deriv_WRT_dibsat*d_dibsat+vtdiblReturn_.deriv_WRT_epsilon*d_epsilon+vtdiblReturn_.deriv_WRT_vzeta*d_vzeta+vtdiblReturn_.deriv_WRT_lambda*d_lambda+vtdiblReturn_.deriv_WRT_ngf*d_ngf+vtdiblReturn_.deriv_WRT_type*d_type;
    d_vdsat1 = vdsat1Return_.deriv_WRT_vgsin*d_vgsin+vdsat1Return_.deriv_WRT_vdsin*d_vdsin+vdsat1Return_.deriv_WRT_qcbflag*d_qcbflag+vdsat1Return_.deriv_WRT_vcin*d_vcin+vdsat1Return_.deriv_WRT_vbin*d_vbin+vdsat1Return_.deriv_WRT_qgsflag*d_qgsflag+vdsat1Return_.deriv_WRT_tambin*d_tambin+vdsat1Return_.deriv_WRT_tnomin*d_tnomin+vdsat1Return_.deriv_WRT_phitin*d_phitin+vdsat1Return_.deriv_WRT_w*d_w+vdsat1Return_.deriv_WRT_lin*d_lin+vdsat1Return_.deriv_WRT_cgin*d_cgin+vdsat1Return_.deriv_WRT_cs*d_cs+vdsat1Return_.deriv_WRT_cc*d_cc+vdsat1Return_.deriv_WRT_cb*d_cb+vdsat1Return_.deriv_WRT_vto*d_vto+vdsat1Return_.deriv_WRT_ss*d_ss+vdsat1Return_.deriv_WRT_delta1*d_delta1+vdsat1Return_.deriv_WRT_delta2*d_delta2+vdsat1Return_.deriv_WRT_nd*d_nd+vdsat1Return_.deriv_WRT_alpha*d_alpha+vdsat1Return_.deriv_WRT_vel0*d_vel0+vdsat1Return_.deriv_WRT_mu0*d_mu0+vdsat1Return_.deriv_WRT_beta*d_beta+vdsat1Return_.deriv_WRT_mtheta*d_mtheta+vdsat1Return_.deriv_WRT_vtheta*d_vtheta+vdsat1Return_.deriv_WRT_vtzeta*d_vtzeta+vdsat1Return_.deriv_WRT_dibsat*d_dibsat+vdsat1Return_.deriv_WRT_epsilon*d_epsilon+vdsat1Return_.deriv_WRT_vzeta*d_vzeta+vdsat1Return_.deriv_WRT_lambda*d_lambda+vdsat1Return_.deriv_WRT_ngf*d_ngf+vdsat1Return_.deriv_WRT_type*d_type;
    return(d_calc_iq);
  }
  // method that actually performs our computations.
  calc_iqEvaluator::returnType calc_iqEvaluator::evaluator_(calc_iqEvaluator::returnType & idsoutReturn, calc_iqEvaluator::returnType & qgsoutReturn, calc_iqEvaluator::returnType & qgdoutReturn, calc_iqEvaluator::returnType & qcoutReturn, calc_iqEvaluator::returnType & qboutReturn, calc_iqEvaluator::returnType & qsoutReturn, calc_iqEvaluator::returnType & vtdiblReturn, calc_iqEvaluator::returnType & vdsat1Return, double vgsin, double vdsin, double qcbflag, double vcin, double vbin, double qgsflag, double tambin, double tnomin, double phitin, double w, double lin, double cgin, double cs, double cc, double cb, double vto, double ss, double delta1, double delta2, double nd, double alpha, double vel0, double mu0, double beta, double mtheta, double vtheta, double vtzeta, double dibsat, double epsilon, double vzeta, double lambda, double ngf, double type)
  {
  // Function value and derivs variables, and a returnType to store everything
  double calc_iq;
  calc_iqEvaluator::returnType calc_iqReturn;
  // Derivatives of return value w.r.t input vars
  double d_calc_iq_d_vgsin;
  double d_calc_iq_d_vdsin;
  double d_calc_iq_d_qcbflag;
  double d_calc_iq_d_vcin;
  double d_calc_iq_d_vbin;
  double d_calc_iq_d_qgsflag;
  double d_calc_iq_d_tambin;
  double d_calc_iq_d_tnomin;
  double d_calc_iq_d_phitin;
  double d_calc_iq_d_w;
  double d_calc_iq_d_lin;
  double d_calc_iq_d_cgin;
  double d_calc_iq_d_cs;
  double d_calc_iq_d_cc;
  double d_calc_iq_d_cb;
  double d_calc_iq_d_vto;
  double d_calc_iq_d_ss;
  double d_calc_iq_d_delta1;
  double d_calc_iq_d_delta2;
  double d_calc_iq_d_nd;
  double d_calc_iq_d_alpha;
  double d_calc_iq_d_vel0;
  double d_calc_iq_d_mu0;
  double d_calc_iq_d_beta;
  double d_calc_iq_d_mtheta;
  double d_calc_iq_d_vtheta;
  double d_calc_iq_d_vtzeta;
  double d_calc_iq_d_dibsat;
  double d_calc_iq_d_epsilon;
  double d_calc_iq_d_vzeta;
  double d_calc_iq_d_lambda;
  double d_calc_iq_d_ngf;
  double d_calc_iq_d_type;
  // additional output vars  and derivs w.r.t input vars
  double idsout;
  double d_idsout_d_vgsin;
  double d_idsout_d_vdsin;
  double d_idsout_d_qcbflag;
  double d_idsout_d_vcin;
  double d_idsout_d_vbin;
  double d_idsout_d_qgsflag;
  double d_idsout_d_tambin;
  double d_idsout_d_tnomin;
  double d_idsout_d_phitin;
  double d_idsout_d_w;
  double d_idsout_d_lin;
  double d_idsout_d_cgin;
  double d_idsout_d_cs;
  double d_idsout_d_cc;
  double d_idsout_d_cb;
  double d_idsout_d_vto;
  double d_idsout_d_ss;
  double d_idsout_d_delta1;
  double d_idsout_d_delta2;
  double d_idsout_d_nd;
  double d_idsout_d_alpha;
  double d_idsout_d_vel0;
  double d_idsout_d_mu0;
  double d_idsout_d_beta;
  double d_idsout_d_mtheta;
  double d_idsout_d_vtheta;
  double d_idsout_d_vtzeta;
  double d_idsout_d_dibsat;
  double d_idsout_d_epsilon;
  double d_idsout_d_vzeta;
  double d_idsout_d_lambda;
  double d_idsout_d_ngf;
  double d_idsout_d_type;
  double qgsout;
  double d_qgsout_d_vgsin;
  double d_qgsout_d_vdsin;
  double d_qgsout_d_qcbflag;
  double d_qgsout_d_vcin;
  double d_qgsout_d_vbin;
  double d_qgsout_d_qgsflag;
  double d_qgsout_d_tambin;
  double d_qgsout_d_tnomin;
  double d_qgsout_d_phitin;
  double d_qgsout_d_w;
  double d_qgsout_d_lin;
  double d_qgsout_d_cgin;
  double d_qgsout_d_cs;
  double d_qgsout_d_cc;
  double d_qgsout_d_cb;
  double d_qgsout_d_vto;
  double d_qgsout_d_ss;
  double d_qgsout_d_delta1;
  double d_qgsout_d_delta2;
  double d_qgsout_d_nd;
  double d_qgsout_d_alpha;
  double d_qgsout_d_vel0;
  double d_qgsout_d_mu0;
  double d_qgsout_d_beta;
  double d_qgsout_d_mtheta;
  double d_qgsout_d_vtheta;
  double d_qgsout_d_vtzeta;
  double d_qgsout_d_dibsat;
  double d_qgsout_d_epsilon;
  double d_qgsout_d_vzeta;
  double d_qgsout_d_lambda;
  double d_qgsout_d_ngf;
  double d_qgsout_d_type;
  double qgdout;
  double d_qgdout_d_vgsin;
  double d_qgdout_d_vdsin;
  double d_qgdout_d_qcbflag;
  double d_qgdout_d_vcin;
  double d_qgdout_d_vbin;
  double d_qgdout_d_qgsflag;
  double d_qgdout_d_tambin;
  double d_qgdout_d_tnomin;
  double d_qgdout_d_phitin;
  double d_qgdout_d_w;
  double d_qgdout_d_lin;
  double d_qgdout_d_cgin;
  double d_qgdout_d_cs;
  double d_qgdout_d_cc;
  double d_qgdout_d_cb;
  double d_qgdout_d_vto;
  double d_qgdout_d_ss;
  double d_qgdout_d_delta1;
  double d_qgdout_d_delta2;
  double d_qgdout_d_nd;
  double d_qgdout_d_alpha;
  double d_qgdout_d_vel0;
  double d_qgdout_d_mu0;
  double d_qgdout_d_beta;
  double d_qgdout_d_mtheta;
  double d_qgdout_d_vtheta;
  double d_qgdout_d_vtzeta;
  double d_qgdout_d_dibsat;
  double d_qgdout_d_epsilon;
  double d_qgdout_d_vzeta;
  double d_qgdout_d_lambda;
  double d_qgdout_d_ngf;
  double d_qgdout_d_type;
  double qcout;
  double d_qcout_d_vgsin;
  double d_qcout_d_vdsin;
  double d_qcout_d_qcbflag;
  double d_qcout_d_vcin;
  double d_qcout_d_vbin;
  double d_qcout_d_qgsflag;
  double d_qcout_d_tambin;
  double d_qcout_d_tnomin;
  double d_qcout_d_phitin;
  double d_qcout_d_w;
  double d_qcout_d_lin;
  double d_qcout_d_cgin;
  double d_qcout_d_cs;
  double d_qcout_d_cc;
  double d_qcout_d_cb;
  double d_qcout_d_vto;
  double d_qcout_d_ss;
  double d_qcout_d_delta1;
  double d_qcout_d_delta2;
  double d_qcout_d_nd;
  double d_qcout_d_alpha;
  double d_qcout_d_vel0;
  double d_qcout_d_mu0;
  double d_qcout_d_beta;
  double d_qcout_d_mtheta;
  double d_qcout_d_vtheta;
  double d_qcout_d_vtzeta;
  double d_qcout_d_dibsat;
  double d_qcout_d_epsilon;
  double d_qcout_d_vzeta;
  double d_qcout_d_lambda;
  double d_qcout_d_ngf;
  double d_qcout_d_type;
  double qbout;
  double d_qbout_d_vgsin;
  double d_qbout_d_vdsin;
  double d_qbout_d_qcbflag;
  double d_qbout_d_vcin;
  double d_qbout_d_vbin;
  double d_qbout_d_qgsflag;
  double d_qbout_d_tambin;
  double d_qbout_d_tnomin;
  double d_qbout_d_phitin;
  double d_qbout_d_w;
  double d_qbout_d_lin;
  double d_qbout_d_cgin;
  double d_qbout_d_cs;
  double d_qbout_d_cc;
  double d_qbout_d_cb;
  double d_qbout_d_vto;
  double d_qbout_d_ss;
  double d_qbout_d_delta1;
  double d_qbout_d_delta2;
  double d_qbout_d_nd;
  double d_qbout_d_alpha;
  double d_qbout_d_vel0;
  double d_qbout_d_mu0;
  double d_qbout_d_beta;
  double d_qbout_d_mtheta;
  double d_qbout_d_vtheta;
  double d_qbout_d_vtzeta;
  double d_qbout_d_dibsat;
  double d_qbout_d_epsilon;
  double d_qbout_d_vzeta;
  double d_qbout_d_lambda;
  double d_qbout_d_ngf;
  double d_qbout_d_type;
  double qsout;
  double d_qsout_d_vgsin;
  double d_qsout_d_vdsin;
  double d_qsout_d_qcbflag;
  double d_qsout_d_vcin;
  double d_qsout_d_vbin;
  double d_qsout_d_qgsflag;
  double d_qsout_d_tambin;
  double d_qsout_d_tnomin;
  double d_qsout_d_phitin;
  double d_qsout_d_w;
  double d_qsout_d_lin;
  double d_qsout_d_cgin;
  double d_qsout_d_cs;
  double d_qsout_d_cc;
  double d_qsout_d_cb;
  double d_qsout_d_vto;
  double d_qsout_d_ss;
  double d_qsout_d_delta1;
  double d_qsout_d_delta2;
  double d_qsout_d_nd;
  double d_qsout_d_alpha;
  double d_qsout_d_vel0;
  double d_qsout_d_mu0;
  double d_qsout_d_beta;
  double d_qsout_d_mtheta;
  double d_qsout_d_vtheta;
  double d_qsout_d_vtzeta;
  double d_qsout_d_dibsat;
  double d_qsout_d_epsilon;
  double d_qsout_d_vzeta;
  double d_qsout_d_lambda;
  double d_qsout_d_ngf;
  double d_qsout_d_type;
  double vtdibl;
  double d_vtdibl_d_vgsin;
  double d_vtdibl_d_vdsin;
  double d_vtdibl_d_qcbflag;
  double d_vtdibl_d_vcin;
  double d_vtdibl_d_vbin;
  double d_vtdibl_d_qgsflag;
  double d_vtdibl_d_tambin;
  double d_vtdibl_d_tnomin;
  double d_vtdibl_d_phitin;
  double d_vtdibl_d_w;
  double d_vtdibl_d_lin;
  double d_vtdibl_d_cgin;
  double d_vtdibl_d_cs;
  double d_vtdibl_d_cc;
  double d_vtdibl_d_cb;
  double d_vtdibl_d_vto;
  double d_vtdibl_d_ss;
  double d_vtdibl_d_delta1;
  double d_vtdibl_d_delta2;
  double d_vtdibl_d_nd;
  double d_vtdibl_d_alpha;
  double d_vtdibl_d_vel0;
  double d_vtdibl_d_mu0;
  double d_vtdibl_d_beta;
  double d_vtdibl_d_mtheta;
  double d_vtdibl_d_vtheta;
  double d_vtdibl_d_vtzeta;
  double d_vtdibl_d_dibsat;
  double d_vtdibl_d_epsilon;
  double d_vtdibl_d_vzeta;
  double d_vtdibl_d_lambda;
  double d_vtdibl_d_ngf;
  double d_vtdibl_d_type;
  double vdsat1;
  double d_vdsat1_d_vgsin;
  double d_vdsat1_d_vdsin;
  double d_vdsat1_d_qcbflag;
  double d_vdsat1_d_vcin;
  double d_vdsat1_d_vbin;
  double d_vdsat1_d_qgsflag;
  double d_vdsat1_d_tambin;
  double d_vdsat1_d_tnomin;
  double d_vdsat1_d_phitin;
  double d_vdsat1_d_w;
  double d_vdsat1_d_lin;
  double d_vdsat1_d_cgin;
  double d_vdsat1_d_cs;
  double d_vdsat1_d_cc;
  double d_vdsat1_d_cb;
  double d_vdsat1_d_vto;
  double d_vdsat1_d_ss;
  double d_vdsat1_d_delta1;
  double d_vdsat1_d_delta2;
  double d_vdsat1_d_nd;
  double d_vdsat1_d_alpha;
  double d_vdsat1_d_vel0;
  double d_vdsat1_d_mu0;
  double d_vdsat1_d_beta;
  double d_vdsat1_d_mtheta;
  double d_vdsat1_d_vtheta;
  double d_vdsat1_d_vtzeta;
  double d_vdsat1_d_dibsat;
  double d_vdsat1_d_epsilon;
  double d_vdsat1_d_vzeta;
  double d_vdsat1_d_lambda;
  double d_vdsat1_d_ngf;
  double d_vdsat1_d_type;
  // declared local variables
  double alpha_phit;
  double d_alpha_phit_d_vgsin;
  double d_alpha_phit_d_vdsin;
  double d_alpha_phit_d_qcbflag;
  double d_alpha_phit_d_vcin;
  double d_alpha_phit_d_vbin;
  double d_alpha_phit_d_qgsflag;
  double d_alpha_phit_d_tambin;
  double d_alpha_phit_d_tnomin;
  double d_alpha_phit_d_phitin;
  double d_alpha_phit_d_w;
  double d_alpha_phit_d_lin;
  double d_alpha_phit_d_cgin;
  double d_alpha_phit_d_cs;
  double d_alpha_phit_d_cc;
  double d_alpha_phit_d_cb;
  double d_alpha_phit_d_vto;
  double d_alpha_phit_d_ss;
  double d_alpha_phit_d_delta1;
  double d_alpha_phit_d_delta2;
  double d_alpha_phit_d_nd;
  double d_alpha_phit_d_alpha;
  double d_alpha_phit_d_vel0;
  double d_alpha_phit_d_mu0;
  double d_alpha_phit_d_beta;
  double d_alpha_phit_d_mtheta;
  double d_alpha_phit_d_vtheta;
  double d_alpha_phit_d_vtzeta;
  double d_alpha_phit_d_dibsat;
  double d_alpha_phit_d_epsilon;
  double d_alpha_phit_d_vzeta;
  double d_alpha_phit_d_lambda;
  double d_alpha_phit_d_ngf;
  double d_alpha_phit_d_type;
  double delta;
  double d_delta_d_vgsin;
  double d_delta_d_vdsin;
  double d_delta_d_qcbflag;
  double d_delta_d_vcin;
  double d_delta_d_vbin;
  double d_delta_d_qgsflag;
  double d_delta_d_tambin;
  double d_delta_d_tnomin;
  double d_delta_d_phitin;
  double d_delta_d_w;
  double d_delta_d_lin;
  double d_delta_d_cgin;
  double d_delta_d_cs;
  double d_delta_d_cc;
  double d_delta_d_cb;
  double d_delta_d_vto;
  double d_delta_d_ss;
  double d_delta_d_delta1;
  double d_delta_d_delta2;
  double d_delta_d_nd;
  double d_delta_d_alpha;
  double d_delta_d_vel0;
  double d_delta_d_mu0;
  double d_delta_d_beta;
  double d_delta_d_mtheta;
  double d_delta_d_vtheta;
  double d_delta_d_vtzeta;
  double d_delta_d_dibsat;
  double d_delta_d_epsilon;
  double d_delta_d_vzeta;
  double d_delta_d_lambda;
  double d_delta_d_ngf;
  double d_delta_d_type;
  double n;
  double d_n_d_vgsin;
  double d_n_d_vdsin;
  double d_n_d_qcbflag;
  double d_n_d_vcin;
  double d_n_d_vbin;
  double d_n_d_qgsflag;
  double d_n_d_tambin;
  double d_n_d_tnomin;
  double d_n_d_phitin;
  double d_n_d_w;
  double d_n_d_lin;
  double d_n_d_cgin;
  double d_n_d_cs;
  double d_n_d_cc;
  double d_n_d_cb;
  double d_n_d_vto;
  double d_n_d_ss;
  double d_n_d_delta1;
  double d_n_d_delta2;
  double d_n_d_nd;
  double d_n_d_alpha;
  double d_n_d_vel0;
  double d_n_d_mu0;
  double d_n_d_beta;
  double d_n_d_mtheta;
  double d_n_d_vtheta;
  double d_n_d_vtzeta;
  double d_n_d_dibsat;
  double d_n_d_epsilon;
  double d_n_d_vzeta;
  double d_n_d_lambda;
  double d_n_d_ngf;
  double d_n_d_type;
  double vtof;
  double d_vtof_d_vgsin;
  double d_vtof_d_vdsin;
  double d_vtof_d_qcbflag;
  double d_vtof_d_vcin;
  double d_vtof_d_vbin;
  double d_vtof_d_qgsflag;
  double d_vtof_d_tambin;
  double d_vtof_d_tnomin;
  double d_vtof_d_phitin;
  double d_vtof_d_w;
  double d_vtof_d_lin;
  double d_vtof_d_cgin;
  double d_vtof_d_cs;
  double d_vtof_d_cc;
  double d_vtof_d_cb;
  double d_vtof_d_vto;
  double d_vtof_d_ss;
  double d_vtof_d_delta1;
  double d_vtof_d_delta2;
  double d_vtof_d_nd;
  double d_vtof_d_alpha;
  double d_vtof_d_vel0;
  double d_vtof_d_mu0;
  double d_vtof_d_beta;
  double d_vtof_d_mtheta;
  double d_vtof_d_vtheta;
  double d_vtof_d_vtzeta;
  double d_vtof_d_dibsat;
  double d_vtof_d_epsilon;
  double d_vtof_d_vzeta;
  double d_vtof_d_lambda;
  double d_vtof_d_ngf;
  double d_vtof_d_type;
  double vsatdibl;
  double d_vsatdibl_d_vgsin;
  double d_vsatdibl_d_vdsin;
  double d_vsatdibl_d_qcbflag;
  double d_vsatdibl_d_vcin;
  double d_vsatdibl_d_vbin;
  double d_vsatdibl_d_qgsflag;
  double d_vsatdibl_d_tambin;
  double d_vsatdibl_d_tnomin;
  double d_vsatdibl_d_phitin;
  double d_vsatdibl_d_w;
  double d_vsatdibl_d_lin;
  double d_vsatdibl_d_cgin;
  double d_vsatdibl_d_cs;
  double d_vsatdibl_d_cc;
  double d_vsatdibl_d_cb;
  double d_vsatdibl_d_vto;
  double d_vsatdibl_d_ss;
  double d_vsatdibl_d_delta1;
  double d_vsatdibl_d_delta2;
  double d_vsatdibl_d_nd;
  double d_vsatdibl_d_alpha;
  double d_vsatdibl_d_vel0;
  double d_vsatdibl_d_mu0;
  double d_vsatdibl_d_beta;
  double d_vsatdibl_d_mtheta;
  double d_vsatdibl_d_vtheta;
  double d_vsatdibl_d_vtzeta;
  double d_vsatdibl_d_dibsat;
  double d_vsatdibl_d_epsilon;
  double d_vsatdibl_d_vzeta;
  double d_vsatdibl_d_lambda;
  double d_vsatdibl_d_ngf;
  double d_vsatdibl_d_type;
  double ffs;
  double d_ffs_d_vgsin;
  double d_ffs_d_vdsin;
  double d_ffs_d_qcbflag;
  double d_ffs_d_vcin;
  double d_ffs_d_vbin;
  double d_ffs_d_qgsflag;
  double d_ffs_d_tambin;
  double d_ffs_d_tnomin;
  double d_ffs_d_phitin;
  double d_ffs_d_w;
  double d_ffs_d_lin;
  double d_ffs_d_cgin;
  double d_ffs_d_cs;
  double d_ffs_d_cc;
  double d_ffs_d_cb;
  double d_ffs_d_vto;
  double d_ffs_d_ss;
  double d_ffs_d_delta1;
  double d_ffs_d_delta2;
  double d_ffs_d_nd;
  double d_ffs_d_alpha;
  double d_ffs_d_vel0;
  double d_ffs_d_mu0;
  double d_ffs_d_beta;
  double d_ffs_d_mtheta;
  double d_ffs_d_vtheta;
  double d_ffs_d_vtzeta;
  double d_ffs_d_dibsat;
  double d_ffs_d_epsilon;
  double d_ffs_d_vzeta;
  double d_ffs_d_lambda;
  double d_ffs_d_ngf;
  double d_ffs_d_type;
  double two_n_phit;
  double d_two_n_phit_d_vgsin;
  double d_two_n_phit_d_vdsin;
  double d_two_n_phit_d_qcbflag;
  double d_two_n_phit_d_vcin;
  double d_two_n_phit_d_vbin;
  double d_two_n_phit_d_qgsflag;
  double d_two_n_phit_d_tambin;
  double d_two_n_phit_d_tnomin;
  double d_two_n_phit_d_phitin;
  double d_two_n_phit_d_w;
  double d_two_n_phit_d_lin;
  double d_two_n_phit_d_cgin;
  double d_two_n_phit_d_cs;
  double d_two_n_phit_d_cc;
  double d_two_n_phit_d_cb;
  double d_two_n_phit_d_vto;
  double d_two_n_phit_d_ss;
  double d_two_n_phit_d_delta1;
  double d_two_n_phit_d_delta2;
  double d_two_n_phit_d_nd;
  double d_two_n_phit_d_alpha;
  double d_two_n_phit_d_vel0;
  double d_two_n_phit_d_mu0;
  double d_two_n_phit_d_beta;
  double d_two_n_phit_d_mtheta;
  double d_two_n_phit_d_vtheta;
  double d_two_n_phit_d_vtzeta;
  double d_two_n_phit_d_dibsat;
  double d_two_n_phit_d_epsilon;
  double d_two_n_phit_d_vzeta;
  double d_two_n_phit_d_lambda;
  double d_two_n_phit_d_ngf;
  double d_two_n_phit_d_type;
  double qref;
  double d_qref_d_vgsin;
  double d_qref_d_vdsin;
  double d_qref_d_qcbflag;
  double d_qref_d_vcin;
  double d_qref_d_vbin;
  double d_qref_d_qgsflag;
  double d_qref_d_tambin;
  double d_qref_d_tnomin;
  double d_qref_d_phitin;
  double d_qref_d_w;
  double d_qref_d_lin;
  double d_qref_d_cgin;
  double d_qref_d_cs;
  double d_qref_d_cc;
  double d_qref_d_cb;
  double d_qref_d_vto;
  double d_qref_d_ss;
  double d_qref_d_delta1;
  double d_qref_d_delta2;
  double d_qref_d_nd;
  double d_qref_d_alpha;
  double d_qref_d_vel0;
  double d_qref_d_mu0;
  double d_qref_d_beta;
  double d_qref_d_mtheta;
  double d_qref_d_vtheta;
  double d_qref_d_vtzeta;
  double d_qref_d_dibsat;
  double d_qref_d_epsilon;
  double d_qref_d_vzeta;
  double d_qref_d_lambda;
  double d_qref_d_ngf;
  double d_qref_d_type;
  double etas;
  double d_etas_d_vgsin;
  double d_etas_d_vdsin;
  double d_etas_d_qcbflag;
  double d_etas_d_vcin;
  double d_etas_d_vbin;
  double d_etas_d_qgsflag;
  double d_etas_d_tambin;
  double d_etas_d_tnomin;
  double d_etas_d_phitin;
  double d_etas_d_w;
  double d_etas_d_lin;
  double d_etas_d_cgin;
  double d_etas_d_cs;
  double d_etas_d_cc;
  double d_etas_d_cb;
  double d_etas_d_vto;
  double d_etas_d_ss;
  double d_etas_d_delta1;
  double d_etas_d_delta2;
  double d_etas_d_nd;
  double d_etas_d_alpha;
  double d_etas_d_vel0;
  double d_etas_d_mu0;
  double d_etas_d_beta;
  double d_etas_d_mtheta;
  double d_etas_d_vtheta;
  double d_etas_d_vtzeta;
  double d_etas_d_dibsat;
  double d_etas_d_epsilon;
  double d_etas_d_vzeta;
  double d_etas_d_lambda;
  double d_etas_d_ngf;
  double d_etas_d_type;
  double qinvs;
  double d_qinvs_d_vgsin;
  double d_qinvs_d_vdsin;
  double d_qinvs_d_qcbflag;
  double d_qinvs_d_vcin;
  double d_qinvs_d_vbin;
  double d_qinvs_d_qgsflag;
  double d_qinvs_d_tambin;
  double d_qinvs_d_tnomin;
  double d_qinvs_d_phitin;
  double d_qinvs_d_w;
  double d_qinvs_d_lin;
  double d_qinvs_d_cgin;
  double d_qinvs_d_cs;
  double d_qinvs_d_cc;
  double d_qinvs_d_cb;
  double d_qinvs_d_vto;
  double d_qinvs_d_ss;
  double d_qinvs_d_delta1;
  double d_qinvs_d_delta2;
  double d_qinvs_d_nd;
  double d_qinvs_d_alpha;
  double d_qinvs_d_vel0;
  double d_qinvs_d_mu0;
  double d_qinvs_d_beta;
  double d_qinvs_d_mtheta;
  double d_qinvs_d_vtheta;
  double d_qinvs_d_vtzeta;
  double d_qinvs_d_dibsat;
  double d_qinvs_d_epsilon;
  double d_qinvs_d_vzeta;
  double d_qinvs_d_lambda;
  double d_qinvs_d_ngf;
  double d_qinvs_d_type;
  double muf;
  double d_muf_d_vgsin;
  double d_muf_d_vdsin;
  double d_muf_d_qcbflag;
  double d_muf_d_vcin;
  double d_muf_d_vbin;
  double d_muf_d_qgsflag;
  double d_muf_d_tambin;
  double d_muf_d_tnomin;
  double d_muf_d_phitin;
  double d_muf_d_w;
  double d_muf_d_lin;
  double d_muf_d_cgin;
  double d_muf_d_cs;
  double d_muf_d_cc;
  double d_muf_d_cb;
  double d_muf_d_vto;
  double d_muf_d_ss;
  double d_muf_d_delta1;
  double d_muf_d_delta2;
  double d_muf_d_nd;
  double d_muf_d_alpha;
  double d_muf_d_vel0;
  double d_muf_d_mu0;
  double d_muf_d_beta;
  double d_muf_d_mtheta;
  double d_muf_d_vtheta;
  double d_muf_d_vtzeta;
  double d_muf_d_dibsat;
  double d_muf_d_epsilon;
  double d_muf_d_vzeta;
  double d_muf_d_lambda;
  double d_muf_d_ngf;
  double d_muf_d_type;
  double vx;
  double d_vx_d_vgsin;
  double d_vx_d_vdsin;
  double d_vx_d_qcbflag;
  double d_vx_d_vcin;
  double d_vx_d_vbin;
  double d_vx_d_qgsflag;
  double d_vx_d_tambin;
  double d_vx_d_tnomin;
  double d_vx_d_phitin;
  double d_vx_d_w;
  double d_vx_d_lin;
  double d_vx_d_cgin;
  double d_vx_d_cs;
  double d_vx_d_cc;
  double d_vx_d_cb;
  double d_vx_d_vto;
  double d_vx_d_ss;
  double d_vx_d_delta1;
  double d_vx_d_delta2;
  double d_vx_d_nd;
  double d_vx_d_alpha;
  double d_vx_d_vel0;
  double d_vx_d_mu0;
  double d_vx_d_beta;
  double d_vx_d_mtheta;
  double d_vx_d_vtheta;
  double d_vx_d_vtzeta;
  double d_vx_d_dibsat;
  double d_vx_d_epsilon;
  double d_vx_d_vzeta;
  double d_vx_d_lambda;
  double d_vx_d_ngf;
  double d_vx_d_type;
  double vxf;
  double d_vxf_d_vgsin;
  double d_vxf_d_vdsin;
  double d_vxf_d_qcbflag;
  double d_vxf_d_vcin;
  double d_vxf_d_vbin;
  double d_vxf_d_qgsflag;
  double d_vxf_d_tambin;
  double d_vxf_d_tnomin;
  double d_vxf_d_phitin;
  double d_vxf_d_w;
  double d_vxf_d_lin;
  double d_vxf_d_cgin;
  double d_vxf_d_cs;
  double d_vxf_d_cc;
  double d_vxf_d_cb;
  double d_vxf_d_vto;
  double d_vxf_d_ss;
  double d_vxf_d_delta1;
  double d_vxf_d_delta2;
  double d_vxf_d_nd;
  double d_vxf_d_alpha;
  double d_vxf_d_vel0;
  double d_vxf_d_mu0;
  double d_vxf_d_beta;
  double d_vxf_d_mtheta;
  double d_vxf_d_vtheta;
  double d_vxf_d_vtzeta;
  double d_vxf_d_dibsat;
  double d_vxf_d_epsilon;
  double d_vxf_d_vzeta;
  double d_vxf_d_lambda;
  double d_vxf_d_ngf;
  double d_vxf_d_type;
  double n0;
  double d_n0_d_vgsin;
  double d_n0_d_vdsin;
  double d_n0_d_qcbflag;
  double d_n0_d_vcin;
  double d_n0_d_vbin;
  double d_n0_d_qgsflag;
  double d_n0_d_tambin;
  double d_n0_d_tnomin;
  double d_n0_d_phitin;
  double d_n0_d_w;
  double d_n0_d_lin;
  double d_n0_d_cgin;
  double d_n0_d_cs;
  double d_n0_d_cc;
  double d_n0_d_cb;
  double d_n0_d_vto;
  double d_n0_d_ss;
  double d_n0_d_delta1;
  double d_n0_d_delta2;
  double d_n0_d_nd;
  double d_n0_d_alpha;
  double d_n0_d_vel0;
  double d_n0_d_mu0;
  double d_n0_d_beta;
  double d_n0_d_mtheta;
  double d_n0_d_vtheta;
  double d_n0_d_vtzeta;
  double d_n0_d_dibsat;
  double d_n0_d_epsilon;
  double d_n0_d_vzeta;
  double d_n0_d_lambda;
  double d_n0_d_ngf;
  double d_n0_d_type;
  double ffs0;
  double d_ffs0_d_vgsin;
  double d_ffs0_d_vdsin;
  double d_ffs0_d_qcbflag;
  double d_ffs0_d_vcin;
  double d_ffs0_d_vbin;
  double d_ffs0_d_qgsflag;
  double d_ffs0_d_tambin;
  double d_ffs0_d_tnomin;
  double d_ffs0_d_phitin;
  double d_ffs0_d_w;
  double d_ffs0_d_lin;
  double d_ffs0_d_cgin;
  double d_ffs0_d_cs;
  double d_ffs0_d_cc;
  double d_ffs0_d_cb;
  double d_ffs0_d_vto;
  double d_ffs0_d_ss;
  double d_ffs0_d_delta1;
  double d_ffs0_d_delta2;
  double d_ffs0_d_nd;
  double d_ffs0_d_alpha;
  double d_ffs0_d_vel0;
  double d_ffs0_d_mu0;
  double d_ffs0_d_beta;
  double d_ffs0_d_mtheta;
  double d_ffs0_d_vtheta;
  double d_ffs0_d_vtzeta;
  double d_ffs0_d_dibsat;
  double d_ffs0_d_epsilon;
  double d_ffs0_d_vzeta;
  double d_ffs0_d_lambda;
  double d_ffs0_d_ngf;
  double d_ffs0_d_type;
  double two_n_phit0;
  double d_two_n_phit0_d_vgsin;
  double d_two_n_phit0_d_vdsin;
  double d_two_n_phit0_d_qcbflag;
  double d_two_n_phit0_d_vcin;
  double d_two_n_phit0_d_vbin;
  double d_two_n_phit0_d_qgsflag;
  double d_two_n_phit0_d_tambin;
  double d_two_n_phit0_d_tnomin;
  double d_two_n_phit0_d_phitin;
  double d_two_n_phit0_d_w;
  double d_two_n_phit0_d_lin;
  double d_two_n_phit0_d_cgin;
  double d_two_n_phit0_d_cs;
  double d_two_n_phit0_d_cc;
  double d_two_n_phit0_d_cb;
  double d_two_n_phit0_d_vto;
  double d_two_n_phit0_d_ss;
  double d_two_n_phit0_d_delta1;
  double d_two_n_phit0_d_delta2;
  double d_two_n_phit0_d_nd;
  double d_two_n_phit0_d_alpha;
  double d_two_n_phit0_d_vel0;
  double d_two_n_phit0_d_mu0;
  double d_two_n_phit0_d_beta;
  double d_two_n_phit0_d_mtheta;
  double d_two_n_phit0_d_vtheta;
  double d_two_n_phit0_d_vtzeta;
  double d_two_n_phit0_d_dibsat;
  double d_two_n_phit0_d_epsilon;
  double d_two_n_phit0_d_vzeta;
  double d_two_n_phit0_d_lambda;
  double d_two_n_phit0_d_ngf;
  double d_two_n_phit0_d_type;
  double qref0;
  double d_qref0_d_vgsin;
  double d_qref0_d_vdsin;
  double d_qref0_d_qcbflag;
  double d_qref0_d_vcin;
  double d_qref0_d_vbin;
  double d_qref0_d_qgsflag;
  double d_qref0_d_tambin;
  double d_qref0_d_tnomin;
  double d_qref0_d_phitin;
  double d_qref0_d_w;
  double d_qref0_d_lin;
  double d_qref0_d_cgin;
  double d_qref0_d_cs;
  double d_qref0_d_cc;
  double d_qref0_d_cb;
  double d_qref0_d_vto;
  double d_qref0_d_ss;
  double d_qref0_d_delta1;
  double d_qref0_d_delta2;
  double d_qref0_d_nd;
  double d_qref0_d_alpha;
  double d_qref0_d_vel0;
  double d_qref0_d_mu0;
  double d_qref0_d_beta;
  double d_qref0_d_mtheta;
  double d_qref0_d_vtheta;
  double d_qref0_d_vtzeta;
  double d_qref0_d_dibsat;
  double d_qref0_d_epsilon;
  double d_qref0_d_vzeta;
  double d_qref0_d_lambda;
  double d_qref0_d_ngf;
  double d_qref0_d_type;
  double etas0;
  double d_etas0_d_vgsin;
  double d_etas0_d_vdsin;
  double d_etas0_d_qcbflag;
  double d_etas0_d_vcin;
  double d_etas0_d_vbin;
  double d_etas0_d_qgsflag;
  double d_etas0_d_tambin;
  double d_etas0_d_tnomin;
  double d_etas0_d_phitin;
  double d_etas0_d_w;
  double d_etas0_d_lin;
  double d_etas0_d_cgin;
  double d_etas0_d_cs;
  double d_etas0_d_cc;
  double d_etas0_d_cb;
  double d_etas0_d_vto;
  double d_etas0_d_ss;
  double d_etas0_d_delta1;
  double d_etas0_d_delta2;
  double d_etas0_d_nd;
  double d_etas0_d_alpha;
  double d_etas0_d_vel0;
  double d_etas0_d_mu0;
  double d_etas0_d_beta;
  double d_etas0_d_mtheta;
  double d_etas0_d_vtheta;
  double d_etas0_d_vtzeta;
  double d_etas0_d_dibsat;
  double d_etas0_d_epsilon;
  double d_etas0_d_vzeta;
  double d_etas0_d_lambda;
  double d_etas0_d_ngf;
  double d_etas0_d_type;
  double qinvs0;
  double d_qinvs0_d_vgsin;
  double d_qinvs0_d_vdsin;
  double d_qinvs0_d_qcbflag;
  double d_qinvs0_d_vcin;
  double d_qinvs0_d_vbin;
  double d_qinvs0_d_qgsflag;
  double d_qinvs0_d_tambin;
  double d_qinvs0_d_tnomin;
  double d_qinvs0_d_phitin;
  double d_qinvs0_d_w;
  double d_qinvs0_d_lin;
  double d_qinvs0_d_cgin;
  double d_qinvs0_d_cs;
  double d_qinvs0_d_cc;
  double d_qinvs0_d_cb;
  double d_qinvs0_d_vto;
  double d_qinvs0_d_ss;
  double d_qinvs0_d_delta1;
  double d_qinvs0_d_delta2;
  double d_qinvs0_d_nd;
  double d_qinvs0_d_alpha;
  double d_qinvs0_d_vel0;
  double d_qinvs0_d_mu0;
  double d_qinvs0_d_beta;
  double d_qinvs0_d_mtheta;
  double d_qinvs0_d_vtheta;
  double d_qinvs0_d_vtzeta;
  double d_qinvs0_d_dibsat;
  double d_qinvs0_d_epsilon;
  double d_qinvs0_d_vzeta;
  double d_qinvs0_d_lambda;
  double d_qinvs0_d_ngf;
  double d_qinvs0_d_type;
  double muf0;
  double d_muf0_d_vgsin;
  double d_muf0_d_vdsin;
  double d_muf0_d_qcbflag;
  double d_muf0_d_vcin;
  double d_muf0_d_vbin;
  double d_muf0_d_qgsflag;
  double d_muf0_d_tambin;
  double d_muf0_d_tnomin;
  double d_muf0_d_phitin;
  double d_muf0_d_w;
  double d_muf0_d_lin;
  double d_muf0_d_cgin;
  double d_muf0_d_cs;
  double d_muf0_d_cc;
  double d_muf0_d_cb;
  double d_muf0_d_vto;
  double d_muf0_d_ss;
  double d_muf0_d_delta1;
  double d_muf0_d_delta2;
  double d_muf0_d_nd;
  double d_muf0_d_alpha;
  double d_muf0_d_vel0;
  double d_muf0_d_mu0;
  double d_muf0_d_beta;
  double d_muf0_d_mtheta;
  double d_muf0_d_vtheta;
  double d_muf0_d_vtzeta;
  double d_muf0_d_dibsat;
  double d_muf0_d_epsilon;
  double d_muf0_d_vzeta;
  double d_muf0_d_lambda;
  double d_muf0_d_ngf;
  double d_muf0_d_type;
  double vx0;
  double d_vx0_d_vgsin;
  double d_vx0_d_vdsin;
  double d_vx0_d_qcbflag;
  double d_vx0_d_vcin;
  double d_vx0_d_vbin;
  double d_vx0_d_qgsflag;
  double d_vx0_d_tambin;
  double d_vx0_d_tnomin;
  double d_vx0_d_phitin;
  double d_vx0_d_w;
  double d_vx0_d_lin;
  double d_vx0_d_cgin;
  double d_vx0_d_cs;
  double d_vx0_d_cc;
  double d_vx0_d_cb;
  double d_vx0_d_vto;
  double d_vx0_d_ss;
  double d_vx0_d_delta1;
  double d_vx0_d_delta2;
  double d_vx0_d_nd;
  double d_vx0_d_alpha;
  double d_vx0_d_vel0;
  double d_vx0_d_mu0;
  double d_vx0_d_beta;
  double d_vx0_d_mtheta;
  double d_vx0_d_vtheta;
  double d_vx0_d_vtzeta;
  double d_vx0_d_dibsat;
  double d_vx0_d_epsilon;
  double d_vx0_d_vzeta;
  double d_vx0_d_lambda;
  double d_vx0_d_ngf;
  double d_vx0_d_type;
  double ff;
  double d_ff_d_vgsin;
  double d_ff_d_vdsin;
  double d_ff_d_qcbflag;
  double d_ff_d_vcin;
  double d_ff_d_vbin;
  double d_ff_d_qgsflag;
  double d_ff_d_tambin;
  double d_ff_d_tnomin;
  double d_ff_d_phitin;
  double d_ff_d_w;
  double d_ff_d_lin;
  double d_ff_d_cgin;
  double d_ff_d_cs;
  double d_ff_d_cc;
  double d_ff_d_cb;
  double d_ff_d_vto;
  double d_ff_d_ss;
  double d_ff_d_delta1;
  double d_ff_d_delta2;
  double d_ff_d_nd;
  double d_ff_d_alpha;
  double d_ff_d_vel0;
  double d_ff_d_mu0;
  double d_ff_d_beta;
  double d_ff_d_mtheta;
  double d_ff_d_vtheta;
  double d_ff_d_vtzeta;
  double d_ff_d_dibsat;
  double d_ff_d_epsilon;
  double d_ff_d_vzeta;
  double d_ff_d_lambda;
  double d_ff_d_ngf;
  double d_ff_d_type;
  double eta;
  double d_eta_d_vgsin;
  double d_eta_d_vdsin;
  double d_eta_d_qcbflag;
  double d_eta_d_vcin;
  double d_eta_d_vbin;
  double d_eta_d_qgsflag;
  double d_eta_d_tambin;
  double d_eta_d_tnomin;
  double d_eta_d_phitin;
  double d_eta_d_w;
  double d_eta_d_lin;
  double d_eta_d_cgin;
  double d_eta_d_cs;
  double d_eta_d_cc;
  double d_eta_d_cb;
  double d_eta_d_vto;
  double d_eta_d_ss;
  double d_eta_d_delta1;
  double d_eta_d_delta2;
  double d_eta_d_nd;
  double d_eta_d_alpha;
  double d_eta_d_vel0;
  double d_eta_d_mu0;
  double d_eta_d_beta;
  double d_eta_d_mtheta;
  double d_eta_d_vtheta;
  double d_eta_d_vtzeta;
  double d_eta_d_dibsat;
  double d_eta_d_epsilon;
  double d_eta_d_vzeta;
  double d_eta_d_lambda;
  double d_eta_d_ngf;
  double d_eta_d_type;
  double qinvv;
  double d_qinvv_d_vgsin;
  double d_qinvv_d_vdsin;
  double d_qinvv_d_qcbflag;
  double d_qinvv_d_vcin;
  double d_qinvv_d_vbin;
  double d_qinvv_d_qgsflag;
  double d_qinvv_d_tambin;
  double d_qinvv_d_tnomin;
  double d_qinvv_d_phitin;
  double d_qinvv_d_w;
  double d_qinvv_d_lin;
  double d_qinvv_d_cgin;
  double d_qinvv_d_cs;
  double d_qinvv_d_cc;
  double d_qinvv_d_cb;
  double d_qinvv_d_vto;
  double d_qinvv_d_ss;
  double d_qinvv_d_delta1;
  double d_qinvv_d_delta2;
  double d_qinvv_d_nd;
  double d_qinvv_d_alpha;
  double d_qinvv_d_vel0;
  double d_qinvv_d_mu0;
  double d_qinvv_d_beta;
  double d_qinvv_d_mtheta;
  double d_qinvv_d_vtheta;
  double d_qinvv_d_vtzeta;
  double d_qinvv_d_dibsat;
  double d_qinvv_d_epsilon;
  double d_qinvv_d_vzeta;
  double d_qinvv_d_lambda;
  double d_qinvv_d_ngf;
  double d_qinvv_d_type;
  double ff0;
  double d_ff0_d_vgsin;
  double d_ff0_d_vdsin;
  double d_ff0_d_qcbflag;
  double d_ff0_d_vcin;
  double d_ff0_d_vbin;
  double d_ff0_d_qgsflag;
  double d_ff0_d_tambin;
  double d_ff0_d_tnomin;
  double d_ff0_d_phitin;
  double d_ff0_d_w;
  double d_ff0_d_lin;
  double d_ff0_d_cgin;
  double d_ff0_d_cs;
  double d_ff0_d_cc;
  double d_ff0_d_cb;
  double d_ff0_d_vto;
  double d_ff0_d_ss;
  double d_ff0_d_delta1;
  double d_ff0_d_delta2;
  double d_ff0_d_nd;
  double d_ff0_d_alpha;
  double d_ff0_d_vel0;
  double d_ff0_d_mu0;
  double d_ff0_d_beta;
  double d_ff0_d_mtheta;
  double d_ff0_d_vtheta;
  double d_ff0_d_vtzeta;
  double d_ff0_d_dibsat;
  double d_ff0_d_epsilon;
  double d_ff0_d_vzeta;
  double d_ff0_d_lambda;
  double d_ff0_d_ngf;
  double d_ff0_d_type;
  double eta0;
  double d_eta0_d_vgsin;
  double d_eta0_d_vdsin;
  double d_eta0_d_qcbflag;
  double d_eta0_d_vcin;
  double d_eta0_d_vbin;
  double d_eta0_d_qgsflag;
  double d_eta0_d_tambin;
  double d_eta0_d_tnomin;
  double d_eta0_d_phitin;
  double d_eta0_d_w;
  double d_eta0_d_lin;
  double d_eta0_d_cgin;
  double d_eta0_d_cs;
  double d_eta0_d_cc;
  double d_eta0_d_cb;
  double d_eta0_d_vto;
  double d_eta0_d_ss;
  double d_eta0_d_delta1;
  double d_eta0_d_delta2;
  double d_eta0_d_nd;
  double d_eta0_d_alpha;
  double d_eta0_d_vel0;
  double d_eta0_d_mu0;
  double d_eta0_d_beta;
  double d_eta0_d_mtheta;
  double d_eta0_d_vtheta;
  double d_eta0_d_vtzeta;
  double d_eta0_d_dibsat;
  double d_eta0_d_epsilon;
  double d_eta0_d_vzeta;
  double d_eta0_d_lambda;
  double d_eta0_d_ngf;
  double d_eta0_d_type;
  double qinvv0;
  double d_qinvv0_d_vgsin;
  double d_qinvv0_d_vdsin;
  double d_qinvv0_d_qcbflag;
  double d_qinvv0_d_vcin;
  double d_qinvv0_d_vbin;
  double d_qinvv0_d_qgsflag;
  double d_qinvv0_d_tambin;
  double d_qinvv0_d_tnomin;
  double d_qinvv0_d_phitin;
  double d_qinvv0_d_w;
  double d_qinvv0_d_lin;
  double d_qinvv0_d_cgin;
  double d_qinvv0_d_cs;
  double d_qinvv0_d_cc;
  double d_qinvv0_d_cb;
  double d_qinvv0_d_vto;
  double d_qinvv0_d_ss;
  double d_qinvv0_d_delta1;
  double d_qinvv0_d_delta2;
  double d_qinvv0_d_nd;
  double d_qinvv0_d_alpha;
  double d_qinvv0_d_vel0;
  double d_qinvv0_d_mu0;
  double d_qinvv0_d_beta;
  double d_qinvv0_d_mtheta;
  double d_qinvv0_d_vtheta;
  double d_qinvv0_d_vtzeta;
  double d_qinvv0_d_dibsat;
  double d_qinvv0_d_epsilon;
  double d_qinvv0_d_vzeta;
  double d_qinvv0_d_lambda;
  double d_qinvv0_d_ngf;
  double d_qinvv0_d_type;
  double vdsats;
  double d_vdsats_d_vgsin;
  double d_vdsats_d_vdsin;
  double d_vdsats_d_qcbflag;
  double d_vdsats_d_vcin;
  double d_vdsats_d_vbin;
  double d_vdsats_d_qgsflag;
  double d_vdsats_d_tambin;
  double d_vdsats_d_tnomin;
  double d_vdsats_d_phitin;
  double d_vdsats_d_w;
  double d_vdsats_d_lin;
  double d_vdsats_d_cgin;
  double d_vdsats_d_cs;
  double d_vdsats_d_cc;
  double d_vdsats_d_cb;
  double d_vdsats_d_vto;
  double d_vdsats_d_ss;
  double d_vdsats_d_delta1;
  double d_vdsats_d_delta2;
  double d_vdsats_d_nd;
  double d_vdsats_d_alpha;
  double d_vdsats_d_vel0;
  double d_vdsats_d_mu0;
  double d_vdsats_d_beta;
  double d_vdsats_d_mtheta;
  double d_vdsats_d_vtheta;
  double d_vdsats_d_vtzeta;
  double d_vdsats_d_dibsat;
  double d_vdsats_d_epsilon;
  double d_vdsats_d_vzeta;
  double d_vdsats_d_lambda;
  double d_vdsats_d_ngf;
  double d_vdsats_d_type;
  double vdsats1;
  double d_vdsats1_d_vgsin;
  double d_vdsats1_d_vdsin;
  double d_vdsats1_d_qcbflag;
  double d_vdsats1_d_vcin;
  double d_vdsats1_d_vbin;
  double d_vdsats1_d_qgsflag;
  double d_vdsats1_d_tambin;
  double d_vdsats1_d_tnomin;
  double d_vdsats1_d_phitin;
  double d_vdsats1_d_w;
  double d_vdsats1_d_lin;
  double d_vdsats1_d_cgin;
  double d_vdsats1_d_cs;
  double d_vdsats1_d_cc;
  double d_vdsats1_d_cb;
  double d_vdsats1_d_vto;
  double d_vdsats1_d_ss;
  double d_vdsats1_d_delta1;
  double d_vdsats1_d_delta2;
  double d_vdsats1_d_nd;
  double d_vdsats1_d_alpha;
  double d_vdsats1_d_vel0;
  double d_vdsats1_d_mu0;
  double d_vdsats1_d_beta;
  double d_vdsats1_d_mtheta;
  double d_vdsats1_d_vtheta;
  double d_vdsats1_d_vtzeta;
  double d_vdsats1_d_dibsat;
  double d_vdsats1_d_epsilon;
  double d_vdsats1_d_vzeta;
  double d_vdsats1_d_lambda;
  double d_vdsats1_d_ngf;
  double d_vdsats1_d_type;
  double vdsat;
  double d_vdsat_d_vgsin;
  double d_vdsat_d_vdsin;
  double d_vdsat_d_qcbflag;
  double d_vdsat_d_vcin;
  double d_vdsat_d_vbin;
  double d_vdsat_d_qgsflag;
  double d_vdsat_d_tambin;
  double d_vdsat_d_tnomin;
  double d_vdsat_d_phitin;
  double d_vdsat_d_w;
  double d_vdsat_d_lin;
  double d_vdsat_d_cgin;
  double d_vdsat_d_cs;
  double d_vdsat_d_cc;
  double d_vdsat_d_cb;
  double d_vdsat_d_vto;
  double d_vdsat_d_ss;
  double d_vdsat_d_delta1;
  double d_vdsat_d_delta2;
  double d_vdsat_d_nd;
  double d_vdsat_d_alpha;
  double d_vdsat_d_vel0;
  double d_vdsat_d_mu0;
  double d_vdsat_d_beta;
  double d_vdsat_d_mtheta;
  double d_vdsat_d_vtheta;
  double d_vdsat_d_vtzeta;
  double d_vdsat_d_dibsat;
  double d_vdsat_d_epsilon;
  double d_vdsat_d_vzeta;
  double d_vdsat_d_lambda;
  double d_vdsat_d_ngf;
  double d_vdsat_d_type;
  double fsd;
  double d_fsd_d_vgsin;
  double d_fsd_d_vdsin;
  double d_fsd_d_qcbflag;
  double d_fsd_d_vcin;
  double d_fsd_d_vbin;
  double d_fsd_d_qgsflag;
  double d_fsd_d_tambin;
  double d_fsd_d_tnomin;
  double d_fsd_d_phitin;
  double d_fsd_d_w;
  double d_fsd_d_lin;
  double d_fsd_d_cgin;
  double d_fsd_d_cs;
  double d_fsd_d_cc;
  double d_fsd_d_cb;
  double d_fsd_d_vto;
  double d_fsd_d_ss;
  double d_fsd_d_delta1;
  double d_fsd_d_delta2;
  double d_fsd_d_nd;
  double d_fsd_d_alpha;
  double d_fsd_d_vel0;
  double d_fsd_d_mu0;
  double d_fsd_d_beta;
  double d_fsd_d_mtheta;
  double d_fsd_d_vtheta;
  double d_fsd_d_vtzeta;
  double d_fsd_d_dibsat;
  double d_fsd_d_epsilon;
  double d_fsd_d_vzeta;
  double d_fsd_d_lambda;
  double d_fsd_d_ngf;
  double d_fsd_d_type;
  double vdx;
  double d_vdx_d_vgsin;
  double d_vdx_d_vdsin;
  double d_vdx_d_qcbflag;
  double d_vdx_d_vcin;
  double d_vdx_d_vbin;
  double d_vdx_d_qgsflag;
  double d_vdx_d_tambin;
  double d_vdx_d_tnomin;
  double d_vdx_d_phitin;
  double d_vdx_d_w;
  double d_vdx_d_lin;
  double d_vdx_d_cgin;
  double d_vdx_d_cs;
  double d_vdx_d_cc;
  double d_vdx_d_cb;
  double d_vdx_d_vto;
  double d_vdx_d_ss;
  double d_vdx_d_delta1;
  double d_vdx_d_delta2;
  double d_vdx_d_nd;
  double d_vdx_d_alpha;
  double d_vdx_d_vel0;
  double d_vdx_d_mu0;
  double d_vdx_d_beta;
  double d_vdx_d_mtheta;
  double d_vdx_d_vtheta;
  double d_vdx_d_vtzeta;
  double d_vdx_d_dibsat;
  double d_vdx_d_epsilon;
  double d_vdx_d_vzeta;
  double d_vdx_d_lambda;
  double d_vdx_d_ngf;
  double d_vdx_d_type;
  double fds;
  double d_fds_d_vgsin;
  double d_fds_d_vdsin;
  double d_fds_d_qcbflag;
  double d_fds_d_vcin;
  double d_fds_d_vbin;
  double d_fds_d_qgsflag;
  double d_fds_d_tambin;
  double d_fds_d_tnomin;
  double d_fds_d_phitin;
  double d_fds_d_w;
  double d_fds_d_lin;
  double d_fds_d_cgin;
  double d_fds_d_cs;
  double d_fds_d_cc;
  double d_fds_d_cb;
  double d_fds_d_vto;
  double d_fds_d_ss;
  double d_fds_d_delta1;
  double d_fds_d_delta2;
  double d_fds_d_nd;
  double d_fds_d_alpha;
  double d_fds_d_vel0;
  double d_fds_d_mu0;
  double d_fds_d_beta;
  double d_fds_d_mtheta;
  double d_fds_d_vtheta;
  double d_fds_d_vtzeta;
  double d_fds_d_dibsat;
  double d_fds_d_epsilon;
  double d_fds_d_vzeta;
  double d_fds_d_lambda;
  double d_fds_d_ngf;
  double d_fds_d_type;
  double vsx;
  double d_vsx_d_vgsin;
  double d_vsx_d_vdsin;
  double d_vsx_d_qcbflag;
  double d_vsx_d_vcin;
  double d_vsx_d_vbin;
  double d_vsx_d_qgsflag;
  double d_vsx_d_tambin;
  double d_vsx_d_tnomin;
  double d_vsx_d_phitin;
  double d_vsx_d_w;
  double d_vsx_d_lin;
  double d_vsx_d_cgin;
  double d_vsx_d_cs;
  double d_vsx_d_cc;
  double d_vsx_d_cb;
  double d_vsx_d_vto;
  double d_vsx_d_ss;
  double d_vsx_d_delta1;
  double d_vsx_d_delta2;
  double d_vsx_d_nd;
  double d_vsx_d_alpha;
  double d_vsx_d_vel0;
  double d_vsx_d_mu0;
  double d_vsx_d_beta;
  double d_vsx_d_mtheta;
  double d_vsx_d_vtheta;
  double d_vsx_d_vtzeta;
  double d_vsx_d_dibsat;
  double d_vsx_d_epsilon;
  double d_vsx_d_vzeta;
  double d_vsx_d_lambda;
  double d_vsx_d_ngf;
  double d_vsx_d_type;
  double ffd;
  double d_ffd_d_vgsin;
  double d_ffd_d_vdsin;
  double d_ffd_d_qcbflag;
  double d_ffd_d_vcin;
  double d_ffd_d_vbin;
  double d_ffd_d_qgsflag;
  double d_ffd_d_tambin;
  double d_ffd_d_tnomin;
  double d_ffd_d_phitin;
  double d_ffd_d_w;
  double d_ffd_d_lin;
  double d_ffd_d_cgin;
  double d_ffd_d_cs;
  double d_ffd_d_cc;
  double d_ffd_d_cb;
  double d_ffd_d_vto;
  double d_ffd_d_ss;
  double d_ffd_d_delta1;
  double d_ffd_d_delta2;
  double d_ffd_d_nd;
  double d_ffd_d_alpha;
  double d_ffd_d_vel0;
  double d_ffd_d_mu0;
  double d_ffd_d_beta;
  double d_ffd_d_mtheta;
  double d_ffd_d_vtheta;
  double d_ffd_d_vtzeta;
  double d_ffd_d_dibsat;
  double d_ffd_d_epsilon;
  double d_ffd_d_vzeta;
  double d_ffd_d_lambda;
  double d_ffd_d_ngf;
  double d_ffd_d_type;
  double etad;
  double d_etad_d_vgsin;
  double d_etad_d_vdsin;
  double d_etad_d_qcbflag;
  double d_etad_d_vcin;
  double d_etad_d_vbin;
  double d_etad_d_qgsflag;
  double d_etad_d_tambin;
  double d_etad_d_tnomin;
  double d_etad_d_phitin;
  double d_etad_d_w;
  double d_etad_d_lin;
  double d_etad_d_cgin;
  double d_etad_d_cs;
  double d_etad_d_cc;
  double d_etad_d_cb;
  double d_etad_d_vto;
  double d_etad_d_ss;
  double d_etad_d_delta1;
  double d_etad_d_delta2;
  double d_etad_d_nd;
  double d_etad_d_alpha;
  double d_etad_d_vel0;
  double d_etad_d_mu0;
  double d_etad_d_beta;
  double d_etad_d_mtheta;
  double d_etad_d_vtheta;
  double d_etad_d_vtzeta;
  double d_etad_d_dibsat;
  double d_etad_d_epsilon;
  double d_etad_d_vzeta;
  double d_etad_d_lambda;
  double d_etad_d_ngf;
  double d_etad_d_type;
  double qinvd;
  double d_qinvd_d_vgsin;
  double d_qinvd_d_vdsin;
  double d_qinvd_d_qcbflag;
  double d_qinvd_d_vcin;
  double d_qinvd_d_vbin;
  double d_qinvd_d_qgsflag;
  double d_qinvd_d_tambin;
  double d_qinvd_d_tnomin;
  double d_qinvd_d_phitin;
  double d_qinvd_d_w;
  double d_qinvd_d_lin;
  double d_qinvd_d_cgin;
  double d_qinvd_d_cs;
  double d_qinvd_d_cc;
  double d_qinvd_d_cb;
  double d_qinvd_d_vto;
  double d_qinvd_d_ss;
  double d_qinvd_d_delta1;
  double d_qinvd_d_delta2;
  double d_qinvd_d_nd;
  double d_qinvd_d_alpha;
  double d_qinvd_d_vel0;
  double d_qinvd_d_mu0;
  double d_qinvd_d_beta;
  double d_qinvd_d_mtheta;
  double d_qinvd_d_vtheta;
  double d_qinvd_d_vtzeta;
  double d_qinvd_d_dibsat;
  double d_qinvd_d_epsilon;
  double d_qinvd_d_vzeta;
  double d_qinvd_d_lambda;
  double d_qinvd_d_ngf;
  double d_qinvd_d_type;
  double vdsc;
  double d_vdsc_d_vgsin;
  double d_vdsc_d_vdsin;
  double d_vdsc_d_qcbflag;
  double d_vdsc_d_vcin;
  double d_vdsc_d_vbin;
  double d_vdsc_d_qgsflag;
  double d_vdsc_d_tambin;
  double d_vdsc_d_tnomin;
  double d_vdsc_d_phitin;
  double d_vdsc_d_w;
  double d_vdsc_d_lin;
  double d_vdsc_d_cgin;
  double d_vdsc_d_cs;
  double d_vdsc_d_cc;
  double d_vdsc_d_cb;
  double d_vdsc_d_vto;
  double d_vdsc_d_ss;
  double d_vdsc_d_delta1;
  double d_vdsc_d_delta2;
  double d_vdsc_d_nd;
  double d_vdsc_d_alpha;
  double d_vdsc_d_vel0;
  double d_vdsc_d_mu0;
  double d_vdsc_d_beta;
  double d_vdsc_d_mtheta;
  double d_vdsc_d_vtheta;
  double d_vdsc_d_vtzeta;
  double d_vdsc_d_dibsat;
  double d_vdsc_d_epsilon;
  double d_vdsc_d_vzeta;
  double d_vdsc_d_lambda;
  double d_vdsc_d_ngf;
  double d_vdsc_d_type;
  double fsat;
  double d_fsat_d_vgsin;
  double d_fsat_d_vdsin;
  double d_fsat_d_qcbflag;
  double d_fsat_d_vcin;
  double d_fsat_d_vbin;
  double d_fsat_d_qgsflag;
  double d_fsat_d_tambin;
  double d_fsat_d_tnomin;
  double d_fsat_d_phitin;
  double d_fsat_d_w;
  double d_fsat_d_lin;
  double d_fsat_d_cgin;
  double d_fsat_d_cs;
  double d_fsat_d_cc;
  double d_fsat_d_cb;
  double d_fsat_d_vto;
  double d_fsat_d_ss;
  double d_fsat_d_delta1;
  double d_fsat_d_delta2;
  double d_fsat_d_nd;
  double d_fsat_d_alpha;
  double d_fsat_d_vel0;
  double d_fsat_d_mu0;
  double d_fsat_d_beta;
  double d_fsat_d_mtheta;
  double d_fsat_d_vtheta;
  double d_fsat_d_vtzeta;
  double d_fsat_d_dibsat;
  double d_fsat_d_epsilon;
  double d_fsat_d_vzeta;
  double d_fsat_d_lambda;
  double d_fsat_d_ngf;
  double d_fsat_d_type;
  double vel;
  double d_vel_d_vgsin;
  double d_vel_d_vdsin;
  double d_vel_d_qcbflag;
  double d_vel_d_vcin;
  double d_vel_d_vbin;
  double d_vel_d_qgsflag;
  double d_vel_d_tambin;
  double d_vel_d_tnomin;
  double d_vel_d_phitin;
  double d_vel_d_w;
  double d_vel_d_lin;
  double d_vel_d_cgin;
  double d_vel_d_cs;
  double d_vel_d_cc;
  double d_vel_d_cb;
  double d_vel_d_vto;
  double d_vel_d_ss;
  double d_vel_d_delta1;
  double d_vel_d_delta2;
  double d_vel_d_nd;
  double d_vel_d_alpha;
  double d_vel_d_vel0;
  double d_vel_d_mu0;
  double d_vel_d_beta;
  double d_vel_d_mtheta;
  double d_vel_d_vtheta;
  double d_vel_d_vtzeta;
  double d_vel_d_dibsat;
  double d_vel_d_epsilon;
  double d_vel_d_vzeta;
  double d_vel_d_lambda;
  double d_vel_d_ngf;
  double d_vel_d_type;
  double vdsats0;
  double d_vdsats0_d_vgsin;
  double d_vdsats0_d_vdsin;
  double d_vdsats0_d_qcbflag;
  double d_vdsats0_d_vcin;
  double d_vdsats0_d_vbin;
  double d_vdsats0_d_qgsflag;
  double d_vdsats0_d_tambin;
  double d_vdsats0_d_tnomin;
  double d_vdsats0_d_phitin;
  double d_vdsats0_d_w;
  double d_vdsats0_d_lin;
  double d_vdsats0_d_cgin;
  double d_vdsats0_d_cs;
  double d_vdsats0_d_cc;
  double d_vdsats0_d_cb;
  double d_vdsats0_d_vto;
  double d_vdsats0_d_ss;
  double d_vdsats0_d_delta1;
  double d_vdsats0_d_delta2;
  double d_vdsats0_d_nd;
  double d_vdsats0_d_alpha;
  double d_vdsats0_d_vel0;
  double d_vdsats0_d_mu0;
  double d_vdsats0_d_beta;
  double d_vdsats0_d_mtheta;
  double d_vdsats0_d_vtheta;
  double d_vdsats0_d_vtzeta;
  double d_vdsats0_d_dibsat;
  double d_vdsats0_d_epsilon;
  double d_vdsats0_d_vzeta;
  double d_vdsats0_d_lambda;
  double d_vdsats0_d_ngf;
  double d_vdsats0_d_type;
  double vdsats10;
  double d_vdsats10_d_vgsin;
  double d_vdsats10_d_vdsin;
  double d_vdsats10_d_qcbflag;
  double d_vdsats10_d_vcin;
  double d_vdsats10_d_vbin;
  double d_vdsats10_d_qgsflag;
  double d_vdsats10_d_tambin;
  double d_vdsats10_d_tnomin;
  double d_vdsats10_d_phitin;
  double d_vdsats10_d_w;
  double d_vdsats10_d_lin;
  double d_vdsats10_d_cgin;
  double d_vdsats10_d_cs;
  double d_vdsats10_d_cc;
  double d_vdsats10_d_cb;
  double d_vdsats10_d_vto;
  double d_vdsats10_d_ss;
  double d_vdsats10_d_delta1;
  double d_vdsats10_d_delta2;
  double d_vdsats10_d_nd;
  double d_vdsats10_d_alpha;
  double d_vdsats10_d_vel0;
  double d_vdsats10_d_mu0;
  double d_vdsats10_d_beta;
  double d_vdsats10_d_mtheta;
  double d_vdsats10_d_vtheta;
  double d_vdsats10_d_vtzeta;
  double d_vdsats10_d_dibsat;
  double d_vdsats10_d_epsilon;
  double d_vdsats10_d_vzeta;
  double d_vdsats10_d_lambda;
  double d_vdsats10_d_ngf;
  double d_vdsats10_d_type;
  double vdsat10;
  double d_vdsat10_d_vgsin;
  double d_vdsat10_d_vdsin;
  double d_vdsat10_d_qcbflag;
  double d_vdsat10_d_vcin;
  double d_vdsat10_d_vbin;
  double d_vdsat10_d_qgsflag;
  double d_vdsat10_d_tambin;
  double d_vdsat10_d_tnomin;
  double d_vdsat10_d_phitin;
  double d_vdsat10_d_w;
  double d_vdsat10_d_lin;
  double d_vdsat10_d_cgin;
  double d_vdsat10_d_cs;
  double d_vdsat10_d_cc;
  double d_vdsat10_d_cb;
  double d_vdsat10_d_vto;
  double d_vdsat10_d_ss;
  double d_vdsat10_d_delta1;
  double d_vdsat10_d_delta2;
  double d_vdsat10_d_nd;
  double d_vdsat10_d_alpha;
  double d_vdsat10_d_vel0;
  double d_vdsat10_d_mu0;
  double d_vdsat10_d_beta;
  double d_vdsat10_d_mtheta;
  double d_vdsat10_d_vtheta;
  double d_vdsat10_d_vtzeta;
  double d_vdsat10_d_dibsat;
  double d_vdsat10_d_epsilon;
  double d_vdsat10_d_vzeta;
  double d_vdsat10_d_lambda;
  double d_vdsat10_d_ngf;
  double d_vdsat10_d_type;
  double fsd0;
  double d_fsd0_d_vgsin;
  double d_fsd0_d_vdsin;
  double d_fsd0_d_qcbflag;
  double d_fsd0_d_vcin;
  double d_fsd0_d_vbin;
  double d_fsd0_d_qgsflag;
  double d_fsd0_d_tambin;
  double d_fsd0_d_tnomin;
  double d_fsd0_d_phitin;
  double d_fsd0_d_w;
  double d_fsd0_d_lin;
  double d_fsd0_d_cgin;
  double d_fsd0_d_cs;
  double d_fsd0_d_cc;
  double d_fsd0_d_cb;
  double d_fsd0_d_vto;
  double d_fsd0_d_ss;
  double d_fsd0_d_delta1;
  double d_fsd0_d_delta2;
  double d_fsd0_d_nd;
  double d_fsd0_d_alpha;
  double d_fsd0_d_vel0;
  double d_fsd0_d_mu0;
  double d_fsd0_d_beta;
  double d_fsd0_d_mtheta;
  double d_fsd0_d_vtheta;
  double d_fsd0_d_vtzeta;
  double d_fsd0_d_dibsat;
  double d_fsd0_d_epsilon;
  double d_fsd0_d_vzeta;
  double d_fsd0_d_lambda;
  double d_fsd0_d_ngf;
  double d_fsd0_d_type;
  double vdx0;
  double d_vdx0_d_vgsin;
  double d_vdx0_d_vdsin;
  double d_vdx0_d_qcbflag;
  double d_vdx0_d_vcin;
  double d_vdx0_d_vbin;
  double d_vdx0_d_qgsflag;
  double d_vdx0_d_tambin;
  double d_vdx0_d_tnomin;
  double d_vdx0_d_phitin;
  double d_vdx0_d_w;
  double d_vdx0_d_lin;
  double d_vdx0_d_cgin;
  double d_vdx0_d_cs;
  double d_vdx0_d_cc;
  double d_vdx0_d_cb;
  double d_vdx0_d_vto;
  double d_vdx0_d_ss;
  double d_vdx0_d_delta1;
  double d_vdx0_d_delta2;
  double d_vdx0_d_nd;
  double d_vdx0_d_alpha;
  double d_vdx0_d_vel0;
  double d_vdx0_d_mu0;
  double d_vdx0_d_beta;
  double d_vdx0_d_mtheta;
  double d_vdx0_d_vtheta;
  double d_vdx0_d_vtzeta;
  double d_vdx0_d_dibsat;
  double d_vdx0_d_epsilon;
  double d_vdx0_d_vzeta;
  double d_vdx0_d_lambda;
  double d_vdx0_d_ngf;
  double d_vdx0_d_type;
  double fds0;
  double d_fds0_d_vgsin;
  double d_fds0_d_vdsin;
  double d_fds0_d_qcbflag;
  double d_fds0_d_vcin;
  double d_fds0_d_vbin;
  double d_fds0_d_qgsflag;
  double d_fds0_d_tambin;
  double d_fds0_d_tnomin;
  double d_fds0_d_phitin;
  double d_fds0_d_w;
  double d_fds0_d_lin;
  double d_fds0_d_cgin;
  double d_fds0_d_cs;
  double d_fds0_d_cc;
  double d_fds0_d_cb;
  double d_fds0_d_vto;
  double d_fds0_d_ss;
  double d_fds0_d_delta1;
  double d_fds0_d_delta2;
  double d_fds0_d_nd;
  double d_fds0_d_alpha;
  double d_fds0_d_vel0;
  double d_fds0_d_mu0;
  double d_fds0_d_beta;
  double d_fds0_d_mtheta;
  double d_fds0_d_vtheta;
  double d_fds0_d_vtzeta;
  double d_fds0_d_dibsat;
  double d_fds0_d_epsilon;
  double d_fds0_d_vzeta;
  double d_fds0_d_lambda;
  double d_fds0_d_ngf;
  double d_fds0_d_type;
  double vsx0;
  double d_vsx0_d_vgsin;
  double d_vsx0_d_vdsin;
  double d_vsx0_d_qcbflag;
  double d_vsx0_d_vcin;
  double d_vsx0_d_vbin;
  double d_vsx0_d_qgsflag;
  double d_vsx0_d_tambin;
  double d_vsx0_d_tnomin;
  double d_vsx0_d_phitin;
  double d_vsx0_d_w;
  double d_vsx0_d_lin;
  double d_vsx0_d_cgin;
  double d_vsx0_d_cs;
  double d_vsx0_d_cc;
  double d_vsx0_d_cb;
  double d_vsx0_d_vto;
  double d_vsx0_d_ss;
  double d_vsx0_d_delta1;
  double d_vsx0_d_delta2;
  double d_vsx0_d_nd;
  double d_vsx0_d_alpha;
  double d_vsx0_d_vel0;
  double d_vsx0_d_mu0;
  double d_vsx0_d_beta;
  double d_vsx0_d_mtheta;
  double d_vsx0_d_vtheta;
  double d_vsx0_d_vtzeta;
  double d_vsx0_d_dibsat;
  double d_vsx0_d_epsilon;
  double d_vsx0_d_vzeta;
  double d_vsx0_d_lambda;
  double d_vsx0_d_ngf;
  double d_vsx0_d_type;
  double ffd0;
  double d_ffd0_d_vgsin;
  double d_ffd0_d_vdsin;
  double d_ffd0_d_qcbflag;
  double d_ffd0_d_vcin;
  double d_ffd0_d_vbin;
  double d_ffd0_d_qgsflag;
  double d_ffd0_d_tambin;
  double d_ffd0_d_tnomin;
  double d_ffd0_d_phitin;
  double d_ffd0_d_w;
  double d_ffd0_d_lin;
  double d_ffd0_d_cgin;
  double d_ffd0_d_cs;
  double d_ffd0_d_cc;
  double d_ffd0_d_cb;
  double d_ffd0_d_vto;
  double d_ffd0_d_ss;
  double d_ffd0_d_delta1;
  double d_ffd0_d_delta2;
  double d_ffd0_d_nd;
  double d_ffd0_d_alpha;
  double d_ffd0_d_vel0;
  double d_ffd0_d_mu0;
  double d_ffd0_d_beta;
  double d_ffd0_d_mtheta;
  double d_ffd0_d_vtheta;
  double d_ffd0_d_vtzeta;
  double d_ffd0_d_dibsat;
  double d_ffd0_d_epsilon;
  double d_ffd0_d_vzeta;
  double d_ffd0_d_lambda;
  double d_ffd0_d_ngf;
  double d_ffd0_d_type;
  double etad0;
  double d_etad0_d_vgsin;
  double d_etad0_d_vdsin;
  double d_etad0_d_qcbflag;
  double d_etad0_d_vcin;
  double d_etad0_d_vbin;
  double d_etad0_d_qgsflag;
  double d_etad0_d_tambin;
  double d_etad0_d_tnomin;
  double d_etad0_d_phitin;
  double d_etad0_d_w;
  double d_etad0_d_lin;
  double d_etad0_d_cgin;
  double d_etad0_d_cs;
  double d_etad0_d_cc;
  double d_etad0_d_cb;
  double d_etad0_d_vto;
  double d_etad0_d_ss;
  double d_etad0_d_delta1;
  double d_etad0_d_delta2;
  double d_etad0_d_nd;
  double d_etad0_d_alpha;
  double d_etad0_d_vel0;
  double d_etad0_d_mu0;
  double d_etad0_d_beta;
  double d_etad0_d_mtheta;
  double d_etad0_d_vtheta;
  double d_etad0_d_vtzeta;
  double d_etad0_d_dibsat;
  double d_etad0_d_epsilon;
  double d_etad0_d_vzeta;
  double d_etad0_d_lambda;
  double d_etad0_d_ngf;
  double d_etad0_d_type;
  double qinvd0;
  double d_qinvd0_d_vgsin;
  double d_qinvd0_d_vdsin;
  double d_qinvd0_d_qcbflag;
  double d_qinvd0_d_vcin;
  double d_qinvd0_d_vbin;
  double d_qinvd0_d_qgsflag;
  double d_qinvd0_d_tambin;
  double d_qinvd0_d_tnomin;
  double d_qinvd0_d_phitin;
  double d_qinvd0_d_w;
  double d_qinvd0_d_lin;
  double d_qinvd0_d_cgin;
  double d_qinvd0_d_cs;
  double d_qinvd0_d_cc;
  double d_qinvd0_d_cb;
  double d_qinvd0_d_vto;
  double d_qinvd0_d_ss;
  double d_qinvd0_d_delta1;
  double d_qinvd0_d_delta2;
  double d_qinvd0_d_nd;
  double d_qinvd0_d_alpha;
  double d_qinvd0_d_vel0;
  double d_qinvd0_d_mu0;
  double d_qinvd0_d_beta;
  double d_qinvd0_d_mtheta;
  double d_qinvd0_d_vtheta;
  double d_qinvd0_d_vtzeta;
  double d_qinvd0_d_dibsat;
  double d_qinvd0_d_epsilon;
  double d_qinvd0_d_vzeta;
  double d_qinvd0_d_lambda;
  double d_qinvd0_d_ngf;
  double d_qinvd0_d_type;
  double qs2;
  double d_qs2_d_vgsin;
  double d_qs2_d_vdsin;
  double d_qs2_d_qcbflag;
  double d_qs2_d_vcin;
  double d_qs2_d_vbin;
  double d_qs2_d_qgsflag;
  double d_qs2_d_tambin;
  double d_qs2_d_tnomin;
  double d_qs2_d_phitin;
  double d_qs2_d_w;
  double d_qs2_d_lin;
  double d_qs2_d_cgin;
  double d_qs2_d_cs;
  double d_qs2_d_cc;
  double d_qs2_d_cb;
  double d_qs2_d_vto;
  double d_qs2_d_ss;
  double d_qs2_d_delta1;
  double d_qs2_d_delta2;
  double d_qs2_d_nd;
  double d_qs2_d_alpha;
  double d_qs2_d_vel0;
  double d_qs2_d_mu0;
  double d_qs2_d_beta;
  double d_qs2_d_mtheta;
  double d_qs2_d_vtheta;
  double d_qs2_d_vtzeta;
  double d_qs2_d_dibsat;
  double d_qs2_d_epsilon;
  double d_qs2_d_vzeta;
  double d_qs2_d_lambda;
  double d_qs2_d_ngf;
  double d_qs2_d_type;
  double qs3;
  double d_qs3_d_vgsin;
  double d_qs3_d_vdsin;
  double d_qs3_d_qcbflag;
  double d_qs3_d_vcin;
  double d_qs3_d_vbin;
  double d_qs3_d_qgsflag;
  double d_qs3_d_tambin;
  double d_qs3_d_tnomin;
  double d_qs3_d_phitin;
  double d_qs3_d_w;
  double d_qs3_d_lin;
  double d_qs3_d_cgin;
  double d_qs3_d_cs;
  double d_qs3_d_cc;
  double d_qs3_d_cb;
  double d_qs3_d_vto;
  double d_qs3_d_ss;
  double d_qs3_d_delta1;
  double d_qs3_d_delta2;
  double d_qs3_d_nd;
  double d_qs3_d_alpha;
  double d_qs3_d_vel0;
  double d_qs3_d_mu0;
  double d_qs3_d_beta;
  double d_qs3_d_mtheta;
  double d_qs3_d_vtheta;
  double d_qs3_d_vtzeta;
  double d_qs3_d_dibsat;
  double d_qs3_d_epsilon;
  double d_qs3_d_vzeta;
  double d_qs3_d_lambda;
  double d_qs3_d_ngf;
  double d_qs3_d_type;
  double qd2;
  double d_qd2_d_vgsin;
  double d_qd2_d_vdsin;
  double d_qd2_d_qcbflag;
  double d_qd2_d_vcin;
  double d_qd2_d_vbin;
  double d_qd2_d_qgsflag;
  double d_qd2_d_tambin;
  double d_qd2_d_tnomin;
  double d_qd2_d_phitin;
  double d_qd2_d_w;
  double d_qd2_d_lin;
  double d_qd2_d_cgin;
  double d_qd2_d_cs;
  double d_qd2_d_cc;
  double d_qd2_d_cb;
  double d_qd2_d_vto;
  double d_qd2_d_ss;
  double d_qd2_d_delta1;
  double d_qd2_d_delta2;
  double d_qd2_d_nd;
  double d_qd2_d_alpha;
  double d_qd2_d_vel0;
  double d_qd2_d_mu0;
  double d_qd2_d_beta;
  double d_qd2_d_mtheta;
  double d_qd2_d_vtheta;
  double d_qd2_d_vtzeta;
  double d_qd2_d_dibsat;
  double d_qd2_d_epsilon;
  double d_qd2_d_vzeta;
  double d_qd2_d_lambda;
  double d_qd2_d_ngf;
  double d_qd2_d_type;
  double qd3;
  double d_qd3_d_vgsin;
  double d_qd3_d_vdsin;
  double d_qd3_d_qcbflag;
  double d_qd3_d_vcin;
  double d_qd3_d_vbin;
  double d_qd3_d_qgsflag;
  double d_qd3_d_tambin;
  double d_qd3_d_tnomin;
  double d_qd3_d_phitin;
  double d_qd3_d_w;
  double d_qd3_d_lin;
  double d_qd3_d_cgin;
  double d_qd3_d_cs;
  double d_qd3_d_cc;
  double d_qd3_d_cb;
  double d_qd3_d_vto;
  double d_qd3_d_ss;
  double d_qd3_d_delta1;
  double d_qd3_d_delta2;
  double d_qd3_d_nd;
  double d_qd3_d_alpha;
  double d_qd3_d_vel0;
  double d_qd3_d_mu0;
  double d_qd3_d_beta;
  double d_qd3_d_mtheta;
  double d_qd3_d_vtheta;
  double d_qd3_d_vtzeta;
  double d_qd3_d_dibsat;
  double d_qd3_d_epsilon;
  double d_qd3_d_vzeta;
  double d_qd3_d_lambda;
  double d_qd3_d_ngf;
  double d_qd3_d_type;
  double qsqd;
  double d_qsqd_d_vgsin;
  double d_qsqd_d_vdsin;
  double d_qsqd_d_qcbflag;
  double d_qsqd_d_vcin;
  double d_qsqd_d_vbin;
  double d_qsqd_d_qgsflag;
  double d_qsqd_d_tambin;
  double d_qsqd_d_tnomin;
  double d_qsqd_d_phitin;
  double d_qsqd_d_w;
  double d_qsqd_d_lin;
  double d_qsqd_d_cgin;
  double d_qsqd_d_cs;
  double d_qsqd_d_cc;
  double d_qsqd_d_cb;
  double d_qsqd_d_vto;
  double d_qsqd_d_ss;
  double d_qsqd_d_delta1;
  double d_qsqd_d_delta2;
  double d_qsqd_d_nd;
  double d_qsqd_d_alpha;
  double d_qsqd_d_vel0;
  double d_qsqd_d_mu0;
  double d_qsqd_d_beta;
  double d_qsqd_d_mtheta;
  double d_qsqd_d_vtheta;
  double d_qsqd_d_vtzeta;
  double d_qsqd_d_dibsat;
  double d_qsqd_d_epsilon;
  double d_qsqd_d_vzeta;
  double d_qsqd_d_lambda;
  double d_qsqd_d_ngf;
  double d_qsqd_d_type;
  double qinvdd;
  double d_qinvdd_d_vgsin;
  double d_qinvdd_d_vdsin;
  double d_qinvdd_d_qcbflag;
  double d_qinvdd_d_vcin;
  double d_qinvdd_d_vbin;
  double d_qinvdd_d_qgsflag;
  double d_qinvdd_d_tambin;
  double d_qinvdd_d_tnomin;
  double d_qinvdd_d_phitin;
  double d_qinvdd_d_w;
  double d_qinvdd_d_lin;
  double d_qinvdd_d_cgin;
  double d_qinvdd_d_cs;
  double d_qinvdd_d_cc;
  double d_qinvdd_d_cb;
  double d_qinvdd_d_vto;
  double d_qinvdd_d_ss;
  double d_qinvdd_d_delta1;
  double d_qinvdd_d_delta2;
  double d_qinvdd_d_nd;
  double d_qinvdd_d_alpha;
  double d_qinvdd_d_vel0;
  double d_qinvdd_d_mu0;
  double d_qinvdd_d_beta;
  double d_qinvdd_d_mtheta;
  double d_qinvdd_d_vtheta;
  double d_qinvdd_d_vtzeta;
  double d_qinvdd_d_dibsat;
  double d_qinvdd_d_epsilon;
  double d_qinvdd_d_vzeta;
  double d_qinvdd_d_lambda;
  double d_qinvdd_d_ngf;
  double d_qinvdd_d_type;
  double qd1;
  double d_qd1_d_vgsin;
  double d_qd1_d_vdsin;
  double d_qd1_d_qcbflag;
  double d_qd1_d_vcin;
  double d_qd1_d_vbin;
  double d_qd1_d_qgsflag;
  double d_qd1_d_tambin;
  double d_qd1_d_tnomin;
  double d_qd1_d_phitin;
  double d_qd1_d_w;
  double d_qd1_d_lin;
  double d_qd1_d_cgin;
  double d_qd1_d_cs;
  double d_qd1_d_cc;
  double d_qd1_d_cb;
  double d_qd1_d_vto;
  double d_qd1_d_ss;
  double d_qd1_d_delta1;
  double d_qd1_d_delta2;
  double d_qd1_d_nd;
  double d_qd1_d_alpha;
  double d_qd1_d_vel0;
  double d_qd1_d_mu0;
  double d_qd1_d_beta;
  double d_qd1_d_mtheta;
  double d_qd1_d_vtheta;
  double d_qd1_d_vtzeta;
  double d_qd1_d_dibsat;
  double d_qd1_d_epsilon;
  double d_qd1_d_vzeta;
  double d_qd1_d_lambda;
  double d_qd1_d_ngf;
  double d_qd1_d_type;
  double qs;
  double d_qs_d_vgsin;
  double d_qs_d_vdsin;
  double d_qs_d_qcbflag;
  double d_qs_d_vcin;
  double d_qs_d_vbin;
  double d_qs_d_qgsflag;
  double d_qs_d_tambin;
  double d_qs_d_tnomin;
  double d_qs_d_phitin;
  double d_qs_d_w;
  double d_qs_d_lin;
  double d_qs_d_cgin;
  double d_qs_d_cs;
  double d_qs_d_cc;
  double d_qs_d_cb;
  double d_qs_d_vto;
  double d_qs_d_ss;
  double d_qs_d_delta1;
  double d_qs_d_delta2;
  double d_qs_d_nd;
  double d_qs_d_alpha;
  double d_qs_d_vel0;
  double d_qs_d_mu0;
  double d_qs_d_beta;
  double d_qs_d_mtheta;
  double d_qs_d_vtheta;
  double d_qs_d_vtzeta;
  double d_qs_d_dibsat;
  double d_qs_d_epsilon;
  double d_qs_d_vzeta;
  double d_qs_d_lambda;
  double d_qs_d_ngf;
  double d_qs_d_type;
  double qd;
  double d_qd_d_vgsin;
  double d_qd_d_vdsin;
  double d_qd_d_qcbflag;
  double d_qd_d_vcin;
  double d_qd_d_vbin;
  double d_qd_d_qgsflag;
  double d_qd_d_tambin;
  double d_qd_d_tnomin;
  double d_qd_d_phitin;
  double d_qd_d_w;
  double d_qd_d_lin;
  double d_qd_d_cgin;
  double d_qd_d_cs;
  double d_qd_d_cc;
  double d_qd_d_cb;
  double d_qd_d_vto;
  double d_qd_d_ss;
  double d_qd_d_delta1;
  double d_qd_d_delta2;
  double d_qd_d_nd;
  double d_qd_d_alpha;
  double d_qd_d_vel0;
  double d_qd_d_mu0;
  double d_qd_d_beta;
  double d_qd_d_mtheta;
  double d_qd_d_vtheta;
  double d_qd_d_vtzeta;
  double d_qd_d_dibsat;
  double d_qd_d_epsilon;
  double d_qd_d_vzeta;
  double d_qd_d_lambda;
  double d_qd_d_ngf;
  double d_qd_d_type;
  double etac;
  double d_etac_d_vgsin;
  double d_etac_d_vdsin;
  double d_etac_d_qcbflag;
  double d_etac_d_vcin;
  double d_etac_d_vbin;
  double d_etac_d_qgsflag;
  double d_etac_d_tambin;
  double d_etac_d_tnomin;
  double d_etac_d_phitin;
  double d_etac_d_w;
  double d_etac_d_lin;
  double d_etac_d_cgin;
  double d_etac_d_cs;
  double d_etac_d_cc;
  double d_etac_d_cb;
  double d_etac_d_vto;
  double d_etac_d_ss;
  double d_etac_d_delta1;
  double d_etac_d_delta2;
  double d_etac_d_nd;
  double d_etac_d_alpha;
  double d_etac_d_vel0;
  double d_etac_d_mu0;
  double d_etac_d_beta;
  double d_etac_d_mtheta;
  double d_etac_d_vtheta;
  double d_etac_d_vtzeta;
  double d_etac_d_dibsat;
  double d_etac_d_epsilon;
  double d_etac_d_vzeta;
  double d_etac_d_lambda;
  double d_etac_d_ngf;
  double d_etac_d_type;
  double etab;
  double d_etab_d_vgsin;
  double d_etab_d_vdsin;
  double d_etab_d_qcbflag;
  double d_etab_d_vcin;
  double d_etab_d_vbin;
  double d_etab_d_qgsflag;
  double d_etab_d_tambin;
  double d_etab_d_tnomin;
  double d_etab_d_phitin;
  double d_etab_d_w;
  double d_etab_d_lin;
  double d_etab_d_cgin;
  double d_etab_d_cs;
  double d_etab_d_cc;
  double d_etab_d_cb;
  double d_etab_d_vto;
  double d_etab_d_ss;
  double d_etab_d_delta1;
  double d_etab_d_delta2;
  double d_etab_d_nd;
  double d_etab_d_alpha;
  double d_etab_d_vel0;
  double d_etab_d_mu0;
  double d_etab_d_beta;
  double d_etab_d_mtheta;
  double d_etab_d_vtheta;
  double d_etab_d_vtzeta;
  double d_etab_d_dibsat;
  double d_etab_d_epsilon;
  double d_etab_d_vzeta;
  double d_etab_d_lambda;
  double d_etab_d_ngf;
  double d_etab_d_type;
  double etags;
  double d_etags_d_vgsin;
  double d_etags_d_vdsin;
  double d_etags_d_qcbflag;
  double d_etags_d_vcin;
  double d_etags_d_vbin;
  double d_etags_d_qgsflag;
  double d_etags_d_tambin;
  double d_etags_d_tnomin;
  double d_etags_d_phitin;
  double d_etags_d_w;
  double d_etags_d_lin;
  double d_etags_d_cgin;
  double d_etags_d_cs;
  double d_etags_d_cc;
  double d_etags_d_cb;
  double d_etags_d_vto;
  double d_etags_d_ss;
  double d_etags_d_delta1;
  double d_etags_d_delta2;
  double d_etags_d_nd;
  double d_etags_d_alpha;
  double d_etags_d_vel0;
  double d_etags_d_mu0;
  double d_etags_d_beta;
  double d_etags_d_mtheta;
  double d_etags_d_vtheta;
  double d_etags_d_vtzeta;
  double d_etags_d_dibsat;
  double d_etags_d_epsilon;
  double d_etags_d_vzeta;
  double d_etags_d_lambda;
  double d_etags_d_ngf;
  double d_etags_d_type;
  double exparg;
  double d_exparg_d_vgsin;
  double d_exparg_d_vdsin;
  double d_exparg_d_qcbflag;
  double d_exparg_d_vcin;
  double d_exparg_d_vbin;
  double d_exparg_d_qgsflag;
  double d_exparg_d_tambin;
  double d_exparg_d_tnomin;
  double d_exparg_d_phitin;
  double d_exparg_d_w;
  double d_exparg_d_lin;
  double d_exparg_d_cgin;
  double d_exparg_d_cs;
  double d_exparg_d_cc;
  double d_exparg_d_cb;
  double d_exparg_d_vto;
  double d_exparg_d_ss;
  double d_exparg_d_delta1;
  double d_exparg_d_delta2;
  double d_exparg_d_nd;
  double d_exparg_d_alpha;
  double d_exparg_d_vel0;
  double d_exparg_d_mu0;
  double d_exparg_d_beta;
  double d_exparg_d_mtheta;
  double d_exparg_d_vtheta;
  double d_exparg_d_vtzeta;
  double d_exparg_d_dibsat;
  double d_exparg_d_epsilon;
  double d_exparg_d_vzeta;
  double d_exparg_d_lambda;
  double d_exparg_d_ngf;
  double d_exparg_d_type;
  double myarg;
  double d_myarg_d_vgsin;
  double d_myarg_d_vdsin;
  double d_myarg_d_qcbflag;
  double d_myarg_d_vcin;
  double d_myarg_d_vbin;
  double d_myarg_d_qgsflag;
  double d_myarg_d_tambin;
  double d_myarg_d_tnomin;
  double d_myarg_d_phitin;
  double d_myarg_d_w;
  double d_myarg_d_lin;
  double d_myarg_d_cgin;
  double d_myarg_d_cs;
  double d_myarg_d_cc;
  double d_myarg_d_cb;
  double d_myarg_d_vto;
  double d_myarg_d_ss;
  double d_myarg_d_delta1;
  double d_myarg_d_delta2;
  double d_myarg_d_nd;
  double d_myarg_d_alpha;
  double d_myarg_d_vel0;
  double d_myarg_d_mu0;
  double d_myarg_d_beta;
  double d_myarg_d_mtheta;
  double d_myarg_d_vtheta;
  double d_myarg_d_vtzeta;
  double d_myarg_d_dibsat;
  double d_myarg_d_epsilon;
  double d_myarg_d_vzeta;
  double d_myarg_d_lambda;
  double d_myarg_d_ngf;
  double d_myarg_d_type;
  double absvdsin;
  double d_absvdsin_d_vgsin;
  double d_absvdsin_d_vdsin;
  double d_absvdsin_d_qcbflag;
  double d_absvdsin_d_vcin;
  double d_absvdsin_d_vbin;
  double d_absvdsin_d_qgsflag;
  double d_absvdsin_d_tambin;
  double d_absvdsin_d_tnomin;
  double d_absvdsin_d_phitin;
  double d_absvdsin_d_w;
  double d_absvdsin_d_lin;
  double d_absvdsin_d_cgin;
  double d_absvdsin_d_cs;
  double d_absvdsin_d_cc;
  double d_absvdsin_d_cb;
  double d_absvdsin_d_vto;
  double d_absvdsin_d_ss;
  double d_absvdsin_d_delta1;
  double d_absvdsin_d_delta2;
  double d_absvdsin_d_nd;
  double d_absvdsin_d_alpha;
  double d_absvdsin_d_vel0;
  double d_absvdsin_d_mu0;
  double d_absvdsin_d_beta;
  double d_absvdsin_d_mtheta;
  double d_absvdsin_d_vtheta;
  double d_absvdsin_d_vtzeta;
  double d_absvdsin_d_dibsat;
  double d_absvdsin_d_epsilon;
  double d_absvdsin_d_vzeta;
  double d_absvdsin_d_lambda;
  double d_absvdsin_d_ngf;
  double d_absvdsin_d_type;
  double vgdin;
  double d_vgdin_d_vgsin;
  double d_vgdin_d_vdsin;
  double d_vgdin_d_qcbflag;
  double d_vgdin_d_vcin;
  double d_vgdin_d_vbin;
  double d_vgdin_d_qgsflag;
  double d_vgdin_d_tambin;
  double d_vgdin_d_tnomin;
  double d_vgdin_d_phitin;
  double d_vgdin_d_w;
  double d_vgdin_d_lin;
  double d_vgdin_d_cgin;
  double d_vgdin_d_cs;
  double d_vgdin_d_cc;
  double d_vgdin_d_cb;
  double d_vgdin_d_vto;
  double d_vgdin_d_ss;
  double d_vgdin_d_delta1;
  double d_vgdin_d_delta2;
  double d_vgdin_d_nd;
  double d_vgdin_d_alpha;
  double d_vgdin_d_vel0;
  double d_vgdin_d_mu0;
  double d_vgdin_d_beta;
  double d_vgdin_d_mtheta;
  double d_vgdin_d_vtheta;
  double d_vgdin_d_vtzeta;
  double d_vgdin_d_dibsat;
  double d_vgdin_d_epsilon;
  double d_vgdin_d_vzeta;
  double d_vgdin_d_lambda;
  double d_vgdin_d_ngf;
  double d_vgdin_d_type;
  double exparg0;
  double d_exparg0_d_vgsin;
  double d_exparg0_d_vdsin;
  double d_exparg0_d_qcbflag;
  double d_exparg0_d_vcin;
  double d_exparg0_d_vbin;
  double d_exparg0_d_qgsflag;
  double d_exparg0_d_tambin;
  double d_exparg0_d_tnomin;
  double d_exparg0_d_phitin;
  double d_exparg0_d_w;
  double d_exparg0_d_lin;
  double d_exparg0_d_cgin;
  double d_exparg0_d_cs;
  double d_exparg0_d_cc;
  double d_exparg0_d_cb;
  double d_exparg0_d_vto;
  double d_exparg0_d_ss;
  double d_exparg0_d_delta1;
  double d_exparg0_d_delta2;
  double d_exparg0_d_nd;
  double d_exparg0_d_alpha;
  double d_exparg0_d_vel0;
  double d_exparg0_d_mu0;
  double d_exparg0_d_beta;
  double d_exparg0_d_mtheta;
  double d_exparg0_d_vtheta;
  double d_exparg0_d_vtzeta;
  double d_exparg0_d_dibsat;
  double d_exparg0_d_epsilon;
  double d_exparg0_d_vzeta;
  double d_exparg0_d_lambda;
  double d_exparg0_d_ngf;
  double d_exparg0_d_type;
  double myarg0;
  double d_myarg0_d_vgsin;
  double d_myarg0_d_vdsin;
  double d_myarg0_d_qcbflag;
  double d_myarg0_d_vcin;
  double d_myarg0_d_vbin;
  double d_myarg0_d_qgsflag;
  double d_myarg0_d_tambin;
  double d_myarg0_d_tnomin;
  double d_myarg0_d_phitin;
  double d_myarg0_d_w;
  double d_myarg0_d_lin;
  double d_myarg0_d_cgin;
  double d_myarg0_d_cs;
  double d_myarg0_d_cc;
  double d_myarg0_d_cb;
  double d_myarg0_d_vto;
  double d_myarg0_d_ss;
  double d_myarg0_d_delta1;
  double d_myarg0_d_delta2;
  double d_myarg0_d_nd;
  double d_myarg0_d_alpha;
  double d_myarg0_d_vel0;
  double d_myarg0_d_mu0;
  double d_myarg0_d_beta;
  double d_myarg0_d_mtheta;
  double d_myarg0_d_vtheta;
  double d_myarg0_d_vtzeta;
  double d_myarg0_d_dibsat;
  double d_myarg0_d_epsilon;
  double d_myarg0_d_vzeta;
  double d_myarg0_d_lambda;
  double d_myarg0_d_ngf;
  double d_myarg0_d_type;
{
d_absvdsin_d_vgsin=0.0;
d_absvdsin_d_vdsin=d_absfunc(vdsin,1.0);
d_absvdsin_d_qcbflag=0.0;
d_absvdsin_d_vcin=0.0;
d_absvdsin_d_vbin=0.0;
d_absvdsin_d_qgsflag=0.0;
d_absvdsin_d_tambin=0.0;
d_absvdsin_d_tnomin=0.0;
d_absvdsin_d_phitin=0.0;
d_absvdsin_d_w=0.0;
d_absvdsin_d_lin=0.0;
d_absvdsin_d_cgin=0.0;
d_absvdsin_d_cs=0.0;
d_absvdsin_d_cc=0.0;
d_absvdsin_d_cb=0.0;
d_absvdsin_d_vto=0.0;
d_absvdsin_d_ss=0.0;
d_absvdsin_d_delta1=0.0;
d_absvdsin_d_delta2=0.0;
d_absvdsin_d_nd=0.0;
d_absvdsin_d_alpha=0.0;
d_absvdsin_d_vel0=0.0;
d_absvdsin_d_mu0=0.0;
d_absvdsin_d_beta=0.0;
d_absvdsin_d_mtheta=0.0;
d_absvdsin_d_vtheta=0.0;
d_absvdsin_d_vtzeta=0.0;
d_absvdsin_d_dibsat=0.0;
d_absvdsin_d_epsilon=0.0;
d_absvdsin_d_vzeta=0.0;
d_absvdsin_d_lambda=0.0;
d_absvdsin_d_ngf=0.0;
d_absvdsin_d_type=0.0;
absvdsin=absfunc(vdsin);
d_vgdin_d_vgsin=1.0;
d_vgdin_d_vdsin=(-1.0);
d_vgdin_d_qcbflag=0.0;
d_vgdin_d_vcin=0.0;
d_vgdin_d_vbin=0.0;
d_vgdin_d_qgsflag=0.0;
d_vgdin_d_tambin=0.0;
d_vgdin_d_tnomin=0.0;
d_vgdin_d_phitin=0.0;
d_vgdin_d_w=0.0;
d_vgdin_d_lin=0.0;
d_vgdin_d_cgin=0.0;
d_vgdin_d_cs=0.0;
d_vgdin_d_cc=0.0;
d_vgdin_d_cb=0.0;
d_vgdin_d_vto=0.0;
d_vgdin_d_ss=0.0;
d_vgdin_d_delta1=0.0;
d_vgdin_d_delta2=0.0;
d_vgdin_d_nd=0.0;
d_vgdin_d_alpha=0.0;
d_vgdin_d_vel0=0.0;
d_vgdin_d_mu0=0.0;
d_vgdin_d_beta=0.0;
d_vgdin_d_mtheta=0.0;
d_vgdin_d_vtheta=0.0;
d_vgdin_d_vtzeta=0.0;
d_vgdin_d_dibsat=0.0;
d_vgdin_d_epsilon=0.0;
d_vgdin_d_vzeta=0.0;
d_vgdin_d_lambda=0.0;
d_vgdin_d_ngf=0.0;
d_vgdin_d_type=0.0;
vgdin=(vgsin-vdsin);
d_alpha_phit_d_vgsin=0.0;
d_alpha_phit_d_vdsin=0.0;
d_alpha_phit_d_qcbflag=0.0;
d_alpha_phit_d_vcin=0.0;
d_alpha_phit_d_vbin=0.0;
d_alpha_phit_d_qgsflag=0.0;
d_alpha_phit_d_tambin=0.0;
d_alpha_phit_d_tnomin=0.0;
d_alpha_phit_d_phitin=(alpha);
d_alpha_phit_d_w=0.0;
d_alpha_phit_d_lin=0.0;
d_alpha_phit_d_cgin=0.0;
d_alpha_phit_d_cs=0.0;
d_alpha_phit_d_cc=0.0;
d_alpha_phit_d_cb=0.0;
d_alpha_phit_d_vto=0.0;
d_alpha_phit_d_ss=0.0;
d_alpha_phit_d_delta1=0.0;
d_alpha_phit_d_delta2=0.0;
d_alpha_phit_d_nd=0.0;
d_alpha_phit_d_alpha=(phitin);
d_alpha_phit_d_vel0=0.0;
d_alpha_phit_d_mu0=0.0;
d_alpha_phit_d_beta=0.0;
d_alpha_phit_d_mtheta=0.0;
d_alpha_phit_d_vtheta=0.0;
d_alpha_phit_d_vtzeta=0.0;
d_alpha_phit_d_dibsat=0.0;
d_alpha_phit_d_epsilon=0.0;
d_alpha_phit_d_vzeta=0.0;
d_alpha_phit_d_lambda=0.0;
d_alpha_phit_d_ngf=0.0;
d_alpha_phit_d_type=0.0;
alpha_phit=(alpha*phitin);
d_n_d_vgsin=(nd*d_absvdsin_d_vgsin);
d_n_d_vdsin=(nd*d_absvdsin_d_vdsin);
d_n_d_qcbflag=(nd*d_absvdsin_d_qcbflag);
d_n_d_vcin=(nd*d_absvdsin_d_vcin);
d_n_d_vbin=(nd*d_absvdsin_d_vbin);
d_n_d_qgsflag=(nd*d_absvdsin_d_qgsflag);
d_n_d_tambin=(nd*d_absvdsin_d_tambin);
d_n_d_tnomin=(nd*d_absvdsin_d_tnomin);
d_n_d_phitin=((-ss*(2.30258509299404568401)/(2.30258509299404568401*phitin)/(2.30258509299404568401*phitin))+(nd*d_absvdsin_d_phitin));
d_n_d_w=(nd*d_absvdsin_d_w);
d_n_d_lin=(nd*d_absvdsin_d_lin);
d_n_d_cgin=(nd*d_absvdsin_d_cgin);
d_n_d_cs=(nd*d_absvdsin_d_cs);
d_n_d_cc=(nd*d_absvdsin_d_cc);
d_n_d_cb=(nd*d_absvdsin_d_cb);
d_n_d_vto=(nd*d_absvdsin_d_vto);
d_n_d_ss=((1.0/(2.30258509299404568401*phitin))+(nd*d_absvdsin_d_ss));
d_n_d_delta1=(nd*d_absvdsin_d_delta1);
d_n_d_delta2=(nd*d_absvdsin_d_delta2);
d_n_d_nd=(nd*d_absvdsin_d_nd+absvdsin);
d_n_d_alpha=(nd*d_absvdsin_d_alpha);
d_n_d_vel0=(nd*d_absvdsin_d_vel0);
d_n_d_mu0=(nd*d_absvdsin_d_mu0);
d_n_d_beta=(nd*d_absvdsin_d_beta);
d_n_d_mtheta=(nd*d_absvdsin_d_mtheta);
d_n_d_vtheta=(nd*d_absvdsin_d_vtheta);
d_n_d_vtzeta=(nd*d_absvdsin_d_vtzeta);
d_n_d_dibsat=(nd*d_absvdsin_d_dibsat);
d_n_d_epsilon=(nd*d_absvdsin_d_epsilon);
d_n_d_vzeta=(nd*d_absvdsin_d_vzeta);
d_n_d_lambda=(nd*d_absvdsin_d_lambda);
d_n_d_ngf=(nd*d_absvdsin_d_ngf);
d_n_d_type=(nd*d_absvdsin_d_type);
n=((ss/(2.30258509299404568401*phitin))+(nd*absvdsin));
d_vtof_d_vgsin=0.0;
d_vtof_d_vdsin=0.0;
d_vtof_d_qcbflag=0.0;
d_vtof_d_vcin=0.0;
d_vtof_d_vbin=0.0;
d_vtof_d_qgsflag=0.0;
d_vtof_d_tambin=(vtzeta);
d_vtof_d_tnomin=(vtzeta*(-1.0));
d_vtof_d_phitin=0.0;
d_vtof_d_w=0.0;
d_vtof_d_lin=0.0;
d_vtof_d_cgin=0.0;
d_vtof_d_cs=0.0;
d_vtof_d_cc=0.0;
d_vtof_d_cb=0.0;
d_vtof_d_vto=1.0;
d_vtof_d_ss=0.0;
d_vtof_d_delta1=0.0;
d_vtof_d_delta2=0.0;
d_vtof_d_nd=0.0;
d_vtof_d_alpha=0.0;
d_vtof_d_vel0=0.0;
d_vtof_d_mu0=0.0;
d_vtof_d_beta=0.0;
d_vtof_d_mtheta=0.0;
d_vtof_d_vtheta=0.0;
d_vtof_d_vtzeta=((tambin-tnomin));
d_vtof_d_dibsat=0.0;
d_vtof_d_epsilon=0.0;
d_vtof_d_vzeta=0.0;
d_vtof_d_lambda=0.0;
d_vtof_d_ngf=0.0;
d_vtof_d_type=0.0;
vtof=(vto+(vtzeta*(tambin-tnomin)));
if((dibsat!=0))
{
d_vsatdibl_d_vgsin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vgsin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vgsin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vdsin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vdsin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vdsin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_qcbflag=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_qcbflag-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_qcbflag/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vcin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vcin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vcin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vbin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vbin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vbin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_qgsflag=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_qgsflag-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_qgsflag/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_tambin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_tambin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_tambin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_tnomin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_tnomin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_tnomin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_phitin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_phitin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_phitin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_w=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_w-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_w/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_lin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_lin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_lin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cgin=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cgin-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cgin/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cs=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cs-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cs/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cc=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cc-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cc/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_cb=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_cb-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_cb/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vto=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vto-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vto/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_ss=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_ss-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_ss/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_delta1=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_delta1-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_delta1/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_delta2=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_delta2-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_delta2/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_nd=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_nd-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_nd/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_alpha=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_alpha-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_alpha/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vel0=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vel0-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vel0/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_mu0=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_mu0-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_mu0/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_beta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_beta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_beta/dibsat)+(((absvdsin/dibsat)==0.0)?0.0:(log((absvdsin/dibsat)*pow((absvdsin/dibsat),beta))))+(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(log((1.0+pow((absvdsin/dibsat),beta))*pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)))))*(-1.0/beta/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_mtheta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_mtheta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_mtheta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vtheta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vtheta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vtheta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vtzeta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vtzeta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vtzeta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_dibsat=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_dibsat-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*((dibsat*d_absvdsin_d_dibsat-absvdsin)/dibsat/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_epsilon=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_epsilon-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_epsilon/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_vzeta=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_vzeta-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_vzeta/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_lambda=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_lambda-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_lambda/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_ngf=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_ngf-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_ngf/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
d_vsatdibl_d_type=((pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*d_absvdsin_d_type-absvdsin*(((1.0+pow((absvdsin/dibsat),beta))==0.0)?0.0:(pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow((absvdsin/dibsat),beta))))*(((absvdsin/dibsat)==0.0)?0.0:(pow((absvdsin/dibsat),beta)*beta/(absvdsin/dibsat)))*(d_absvdsin_d_type/dibsat))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta))/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
vsatdibl=(absvdsin/pow((1.0+pow((absvdsin/dibsat),beta)),(1.0/beta)));
}
else
{
d_vsatdibl_d_vgsin=0.0;
d_vsatdibl_d_vdsin=0.0;
d_vsatdibl_d_qcbflag=0.0;
d_vsatdibl_d_vcin=0.0;
d_vsatdibl_d_vbin=0.0;
d_vsatdibl_d_qgsflag=0.0;
d_vsatdibl_d_tambin=0.0;
d_vsatdibl_d_tnomin=0.0;
d_vsatdibl_d_phitin=0.0;
d_vsatdibl_d_w=0.0;
d_vsatdibl_d_lin=0.0;
d_vsatdibl_d_cgin=0.0;
d_vsatdibl_d_cs=0.0;
d_vsatdibl_d_cc=0.0;
d_vsatdibl_d_cb=0.0;
d_vsatdibl_d_vto=0.0;
d_vsatdibl_d_ss=0.0;
d_vsatdibl_d_delta1=0.0;
d_vsatdibl_d_delta2=0.0;
d_vsatdibl_d_nd=0.0;
d_vsatdibl_d_alpha=0.0;
d_vsatdibl_d_vel0=0.0;
d_vsatdibl_d_mu0=0.0;
d_vsatdibl_d_beta=0.0;
d_vsatdibl_d_mtheta=0.0;
d_vsatdibl_d_vtheta=0.0;
d_vsatdibl_d_vtzeta=0.0;
d_vsatdibl_d_dibsat=0.0;
d_vsatdibl_d_epsilon=0.0;
d_vsatdibl_d_vzeta=0.0;
d_vsatdibl_d_lambda=0.0;
d_vsatdibl_d_ngf=0.0;
d_vsatdibl_d_type=0.0;
vsatdibl=0;
}
d_delta_d_vgsin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vgsin)+((-(d_vsatdibl_d_vgsin*delta2))*absvdsin));
d_delta_d_vdsin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vdsin)+((-(d_vsatdibl_d_vdsin*delta2))*absvdsin));
d_delta_d_qcbflag=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_qcbflag)+((-(d_vsatdibl_d_qcbflag*delta2))*absvdsin));
d_delta_d_vcin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vcin)+((-(d_vsatdibl_d_vcin*delta2))*absvdsin));
d_delta_d_vbin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vbin)+((-(d_vsatdibl_d_vbin*delta2))*absvdsin));
d_delta_d_qgsflag=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_qgsflag)+((-(d_vsatdibl_d_qgsflag*delta2))*absvdsin));
d_delta_d_tambin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_tambin)+((-(d_vsatdibl_d_tambin*delta2))*absvdsin));
d_delta_d_tnomin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_tnomin)+((-(d_vsatdibl_d_tnomin*delta2))*absvdsin));
d_delta_d_phitin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_phitin)+((-(d_vsatdibl_d_phitin*delta2))*absvdsin));
d_delta_d_w=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_w)+((-(d_vsatdibl_d_w*delta2))*absvdsin));
d_delta_d_lin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_lin)+((-(d_vsatdibl_d_lin*delta2))*absvdsin));
d_delta_d_cgin=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cgin)+((-(d_vsatdibl_d_cgin*delta2))*absvdsin));
d_delta_d_cs=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cs)+((-(d_vsatdibl_d_cs*delta2))*absvdsin));
d_delta_d_cc=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cc)+((-(d_vsatdibl_d_cc*delta2))*absvdsin));
d_delta_d_cb=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_cb)+((-(d_vsatdibl_d_cb*delta2))*absvdsin));
d_delta_d_vto=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vto)+((-(d_vsatdibl_d_vto*delta2))*absvdsin));
d_delta_d_ss=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_ss)+((-(d_vsatdibl_d_ss*delta2))*absvdsin));
d_delta_d_delta1=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_delta1)+((1.0-(d_vsatdibl_d_delta1*delta2))*absvdsin));
d_delta_d_delta2=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_delta2)+((-(vsatdibl+delta2*d_vsatdibl_d_delta2))*absvdsin));
d_delta_d_nd=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_nd)+((-(d_vsatdibl_d_nd*delta2))*absvdsin));
d_delta_d_alpha=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_alpha)+((-(d_vsatdibl_d_alpha*delta2))*absvdsin));
d_delta_d_vel0=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vel0)+((-(d_vsatdibl_d_vel0*delta2))*absvdsin));
d_delta_d_mu0=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_mu0)+((-(d_vsatdibl_d_mu0*delta2))*absvdsin));
d_delta_d_beta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_beta)+((-(d_vsatdibl_d_beta*delta2))*absvdsin));
d_delta_d_mtheta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_mtheta)+((-(d_vsatdibl_d_mtheta*delta2))*absvdsin));
d_delta_d_vtheta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vtheta)+((-(d_vsatdibl_d_vtheta*delta2))*absvdsin));
d_delta_d_vtzeta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vtzeta)+((-(d_vsatdibl_d_vtzeta*delta2))*absvdsin));
d_delta_d_dibsat=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_dibsat)+((-(d_vsatdibl_d_dibsat*delta2))*absvdsin));
d_delta_d_epsilon=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_epsilon)+((-(d_vsatdibl_d_epsilon*delta2))*absvdsin));
d_delta_d_vzeta=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_vzeta)+((-(d_vsatdibl_d_vzeta*delta2))*absvdsin));
d_delta_d_lambda=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_lambda)+((-(d_vsatdibl_d_lambda*delta2))*absvdsin));
d_delta_d_ngf=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_ngf)+((-(d_vsatdibl_d_ngf*delta2))*absvdsin));
d_delta_d_type=(((delta1-(vsatdibl*delta2))*d_absvdsin_d_type)+((-(d_vsatdibl_d_type*delta2))*absvdsin));
delta=((delta1-(vsatdibl*delta2))*absvdsin);
d_vtdibl_d_vgsin=(d_vtof_d_vgsin-d_delta_d_vgsin);
d_vtdibl_d_vdsin=(d_vtof_d_vdsin-d_delta_d_vdsin);
d_vtdibl_d_qcbflag=(d_vtof_d_qcbflag-d_delta_d_qcbflag);
d_vtdibl_d_vcin=(d_vtof_d_vcin-d_delta_d_vcin);
d_vtdibl_d_vbin=(d_vtof_d_vbin-d_delta_d_vbin);
d_vtdibl_d_qgsflag=(d_vtof_d_qgsflag-d_delta_d_qgsflag);
d_vtdibl_d_tambin=(d_vtof_d_tambin-d_delta_d_tambin);
d_vtdibl_d_tnomin=(d_vtof_d_tnomin-d_delta_d_tnomin);
d_vtdibl_d_phitin=(d_vtof_d_phitin-d_delta_d_phitin);
d_vtdibl_d_w=(d_vtof_d_w-d_delta_d_w);
d_vtdibl_d_lin=(d_vtof_d_lin-d_delta_d_lin);
d_vtdibl_d_cgin=(d_vtof_d_cgin-d_delta_d_cgin);
d_vtdibl_d_cs=(d_vtof_d_cs-d_delta_d_cs);
d_vtdibl_d_cc=(d_vtof_d_cc-d_delta_d_cc);
d_vtdibl_d_cb=(d_vtof_d_cb-d_delta_d_cb);
d_vtdibl_d_vto=(d_vtof_d_vto-d_delta_d_vto);
d_vtdibl_d_ss=(d_vtof_d_ss-d_delta_d_ss);
d_vtdibl_d_delta1=(d_vtof_d_delta1-d_delta_d_delta1);
d_vtdibl_d_delta2=(d_vtof_d_delta2-d_delta_d_delta2);
d_vtdibl_d_nd=(d_vtof_d_nd-d_delta_d_nd);
d_vtdibl_d_alpha=(d_vtof_d_alpha-d_delta_d_alpha);
d_vtdibl_d_vel0=(d_vtof_d_vel0-d_delta_d_vel0);
d_vtdibl_d_mu0=(d_vtof_d_mu0-d_delta_d_mu0);
d_vtdibl_d_beta=(d_vtof_d_beta-d_delta_d_beta);
d_vtdibl_d_mtheta=(d_vtof_d_mtheta-d_delta_d_mtheta);
d_vtdibl_d_vtheta=(d_vtof_d_vtheta-d_delta_d_vtheta);
d_vtdibl_d_vtzeta=(d_vtof_d_vtzeta-d_delta_d_vtzeta);
d_vtdibl_d_dibsat=(d_vtof_d_dibsat-d_delta_d_dibsat);
d_vtdibl_d_epsilon=(d_vtof_d_epsilon-d_delta_d_epsilon);
d_vtdibl_d_vzeta=(d_vtof_d_vzeta-d_delta_d_vzeta);
d_vtdibl_d_lambda=(d_vtof_d_lambda-d_delta_d_lambda);
d_vtdibl_d_ngf=(d_vtof_d_ngf-d_delta_d_ngf);
d_vtdibl_d_type=(d_vtof_d_type-d_delta_d_type);
vtdibl=(vtof-delta);
d_two_n_phit_d_vgsin=((2.0*d_n_d_vgsin)*phitin);
d_two_n_phit_d_vdsin=((2.0*d_n_d_vdsin)*phitin);
d_two_n_phit_d_qcbflag=((2.0*d_n_d_qcbflag)*phitin);
d_two_n_phit_d_vcin=((2.0*d_n_d_vcin)*phitin);
d_two_n_phit_d_vbin=((2.0*d_n_d_vbin)*phitin);
d_two_n_phit_d_qgsflag=((2.0*d_n_d_qgsflag)*phitin);
d_two_n_phit_d_tambin=((2.0*d_n_d_tambin)*phitin);
d_two_n_phit_d_tnomin=((2.0*d_n_d_tnomin)*phitin);
d_two_n_phit_d_phitin=((2.0*n)+phitin*(2.0*d_n_d_phitin));
d_two_n_phit_d_w=((2.0*d_n_d_w)*phitin);
d_two_n_phit_d_lin=((2.0*d_n_d_lin)*phitin);
d_two_n_phit_d_cgin=((2.0*d_n_d_cgin)*phitin);
d_two_n_phit_d_cs=((2.0*d_n_d_cs)*phitin);
d_two_n_phit_d_cc=((2.0*d_n_d_cc)*phitin);
d_two_n_phit_d_cb=((2.0*d_n_d_cb)*phitin);
d_two_n_phit_d_vto=((2.0*d_n_d_vto)*phitin);
d_two_n_phit_d_ss=((2.0*d_n_d_ss)*phitin);
d_two_n_phit_d_delta1=((2.0*d_n_d_delta1)*phitin);
d_two_n_phit_d_delta2=((2.0*d_n_d_delta2)*phitin);
d_two_n_phit_d_nd=((2.0*d_n_d_nd)*phitin);
d_two_n_phit_d_alpha=((2.0*d_n_d_alpha)*phitin);
d_two_n_phit_d_vel0=((2.0*d_n_d_vel0)*phitin);
d_two_n_phit_d_mu0=((2.0*d_n_d_mu0)*phitin);
d_two_n_phit_d_beta=((2.0*d_n_d_beta)*phitin);
d_two_n_phit_d_mtheta=((2.0*d_n_d_mtheta)*phitin);
d_two_n_phit_d_vtheta=((2.0*d_n_d_vtheta)*phitin);
d_two_n_phit_d_vtzeta=((2.0*d_n_d_vtzeta)*phitin);
d_two_n_phit_d_dibsat=((2.0*d_n_d_dibsat)*phitin);
d_two_n_phit_d_epsilon=((2.0*d_n_d_epsilon)*phitin);
d_two_n_phit_d_vzeta=((2.0*d_n_d_vzeta)*phitin);
d_two_n_phit_d_lambda=((2.0*d_n_d_lambda)*phitin);
d_two_n_phit_d_ngf=((2.0*d_n_d_ngf)*phitin);
d_two_n_phit_d_type=((2.0*d_n_d_type)*phitin);
two_n_phit=((2.0*n)*phitin);
d_qref_d_vgsin=(cgin*d_two_n_phit_d_vgsin);
d_qref_d_vdsin=(cgin*d_two_n_phit_d_vdsin);
d_qref_d_qcbflag=(cgin*d_two_n_phit_d_qcbflag);
d_qref_d_vcin=(cgin*d_two_n_phit_d_vcin);
d_qref_d_vbin=(cgin*d_two_n_phit_d_vbin);
d_qref_d_qgsflag=(cgin*d_two_n_phit_d_qgsflag);
d_qref_d_tambin=(cgin*d_two_n_phit_d_tambin);
d_qref_d_tnomin=(cgin*d_two_n_phit_d_tnomin);
d_qref_d_phitin=(cgin*d_two_n_phit_d_phitin);
d_qref_d_w=(cgin*d_two_n_phit_d_w);
d_qref_d_lin=(cgin*d_two_n_phit_d_lin);
d_qref_d_cgin=(cgin*d_two_n_phit_d_cgin+two_n_phit);
d_qref_d_cs=(cgin*d_two_n_phit_d_cs);
d_qref_d_cc=(cgin*d_two_n_phit_d_cc);
d_qref_d_cb=(cgin*d_two_n_phit_d_cb);
d_qref_d_vto=(cgin*d_two_n_phit_d_vto);
d_qref_d_ss=(cgin*d_two_n_phit_d_ss);
d_qref_d_delta1=(cgin*d_two_n_phit_d_delta1);
d_qref_d_delta2=(cgin*d_two_n_phit_d_delta2);
d_qref_d_nd=(cgin*d_two_n_phit_d_nd);
d_qref_d_alpha=(cgin*d_two_n_phit_d_alpha);
d_qref_d_vel0=(cgin*d_two_n_phit_d_vel0);
d_qref_d_mu0=(cgin*d_two_n_phit_d_mu0);
d_qref_d_beta=(cgin*d_two_n_phit_d_beta);
d_qref_d_mtheta=(cgin*d_two_n_phit_d_mtheta);
d_qref_d_vtheta=(cgin*d_two_n_phit_d_vtheta);
d_qref_d_vtzeta=(cgin*d_two_n_phit_d_vtzeta);
d_qref_d_dibsat=(cgin*d_two_n_phit_d_dibsat);
d_qref_d_epsilon=(cgin*d_two_n_phit_d_epsilon);
d_qref_d_vzeta=(cgin*d_two_n_phit_d_vzeta);
d_qref_d_lambda=(cgin*d_two_n_phit_d_lambda);
d_qref_d_ngf=(cgin*d_two_n_phit_d_ngf);
d_qref_d_type=(cgin*d_two_n_phit_d_type);
qref=(cgin*two_n_phit);
d_myarg_d_vgsin=(d_vtdibl_d_vgsin-(d_alpha_phit_d_vgsin/2.0));
d_myarg_d_vdsin=(d_vtdibl_d_vdsin-(d_alpha_phit_d_vdsin/2.0));
d_myarg_d_qcbflag=(d_vtdibl_d_qcbflag-(d_alpha_phit_d_qcbflag/2.0));
d_myarg_d_vcin=(d_vtdibl_d_vcin-(d_alpha_phit_d_vcin/2.0));
d_myarg_d_vbin=(d_vtdibl_d_vbin-(d_alpha_phit_d_vbin/2.0));
d_myarg_d_qgsflag=(d_vtdibl_d_qgsflag-(d_alpha_phit_d_qgsflag/2.0));
d_myarg_d_tambin=(d_vtdibl_d_tambin-(d_alpha_phit_d_tambin/2.0));
d_myarg_d_tnomin=(d_vtdibl_d_tnomin-(d_alpha_phit_d_tnomin/2.0));
d_myarg_d_phitin=(d_vtdibl_d_phitin-(d_alpha_phit_d_phitin/2.0));
d_myarg_d_w=(d_vtdibl_d_w-(d_alpha_phit_d_w/2.0));
d_myarg_d_lin=(d_vtdibl_d_lin-(d_alpha_phit_d_lin/2.0));
d_myarg_d_cgin=(d_vtdibl_d_cgin-(d_alpha_phit_d_cgin/2.0));
d_myarg_d_cs=(d_vtdibl_d_cs-(d_alpha_phit_d_cs/2.0));
d_myarg_d_cc=(d_vtdibl_d_cc-(d_alpha_phit_d_cc/2.0));
d_myarg_d_cb=(d_vtdibl_d_cb-(d_alpha_phit_d_cb/2.0));
d_myarg_d_vto=(d_vtdibl_d_vto-(d_alpha_phit_d_vto/2.0));
d_myarg_d_ss=(d_vtdibl_d_ss-(d_alpha_phit_d_ss/2.0));
d_myarg_d_delta1=(d_vtdibl_d_delta1-(d_alpha_phit_d_delta1/2.0));
d_myarg_d_delta2=(d_vtdibl_d_delta2-(d_alpha_phit_d_delta2/2.0));
d_myarg_d_nd=(d_vtdibl_d_nd-(d_alpha_phit_d_nd/2.0));
d_myarg_d_alpha=(d_vtdibl_d_alpha-(d_alpha_phit_d_alpha/2.0));
d_myarg_d_vel0=(d_vtdibl_d_vel0-(d_alpha_phit_d_vel0/2.0));
d_myarg_d_mu0=(d_vtdibl_d_mu0-(d_alpha_phit_d_mu0/2.0));
d_myarg_d_beta=(d_vtdibl_d_beta-(d_alpha_phit_d_beta/2.0));
d_myarg_d_mtheta=(d_vtdibl_d_mtheta-(d_alpha_phit_d_mtheta/2.0));
d_myarg_d_vtheta=(d_vtdibl_d_vtheta-(d_alpha_phit_d_vtheta/2.0));
d_myarg_d_vtzeta=(d_vtdibl_d_vtzeta-(d_alpha_phit_d_vtzeta/2.0));
d_myarg_d_dibsat=(d_vtdibl_d_dibsat-(d_alpha_phit_d_dibsat/2.0));
d_myarg_d_epsilon=(d_vtdibl_d_epsilon-(d_alpha_phit_d_epsilon/2.0));
d_myarg_d_vzeta=(d_vtdibl_d_vzeta-(d_alpha_phit_d_vzeta/2.0));
d_myarg_d_lambda=(d_vtdibl_d_lambda-(d_alpha_phit_d_lambda/2.0));
d_myarg_d_ngf=(d_vtdibl_d_ngf-(d_alpha_phit_d_ngf/2.0));
d_myarg_d_type=(d_vtdibl_d_type-(d_alpha_phit_d_type/2.0));
myarg=(vtdibl-(alpha_phit/2.0));
d_exparg_d_vgsin=((alpha_phit*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-d_myarg_d_vgsin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg_d_vdsin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-d_myarg_d_vdsin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg_d_qcbflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-d_myarg_d_qcbflag)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg_d_vcin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-d_myarg_d_vcin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg_d_vbin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-d_myarg_d_vbin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg_d_qgsflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-d_myarg_d_qgsflag)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg_d_tambin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-d_myarg_d_tambin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg_d_tnomin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-d_myarg_d_tnomin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg_d_phitin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-d_myarg_d_phitin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg_d_w=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-d_myarg_d_w)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg_d_lin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-d_myarg_d_lin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg_d_cgin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-d_myarg_d_cgin)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg_d_cs=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-d_myarg_d_cs)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg_d_cc=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-d_myarg_d_cc)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg_d_cb=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-d_myarg_d_cb)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg_d_vto=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-d_myarg_d_vto)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg_d_ss=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-d_myarg_d_ss)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg_d_delta1=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-d_myarg_d_delta1)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg_d_delta2=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-d_myarg_d_delta2)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg_d_nd=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-d_myarg_d_nd)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg_d_alpha=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-d_myarg_d_alpha)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg_d_vel0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-d_myarg_d_vel0)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg_d_mu0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-d_myarg_d_mu0)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg_d_beta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-d_myarg_d_beta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg_d_mtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-d_myarg_d_mtheta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-d_myarg_d_vtheta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-d_myarg_d_vtzeta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg_d_dibsat=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-d_myarg_d_dibsat)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg_d_epsilon=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-d_myarg_d_epsilon)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg_d_vzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-d_myarg_d_vzeta)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg_d_lambda=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-d_myarg_d_lambda)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg_d_ngf=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-d_myarg_d_ngf)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg_d_type=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-d_myarg_d_type)-(mmax(vgsin,vgdin)-myarg)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg=((mmax(vgsin,vgdin)-myarg)/alpha_phit);
if((exparg>50.0))
{
d_ff_d_vgsin=0.0;
d_ff_d_vdsin=0.0;
d_ff_d_qcbflag=0.0;
d_ff_d_vcin=0.0;
d_ff_d_vbin=0.0;
d_ff_d_qgsflag=0.0;
d_ff_d_tambin=0.0;
d_ff_d_tnomin=0.0;
d_ff_d_phitin=0.0;
d_ff_d_w=0.0;
d_ff_d_lin=0.0;
d_ff_d_cgin=0.0;
d_ff_d_cs=0.0;
d_ff_d_cc=0.0;
d_ff_d_cb=0.0;
d_ff_d_vto=0.0;
d_ff_d_ss=0.0;
d_ff_d_delta1=0.0;
d_ff_d_delta2=0.0;
d_ff_d_nd=0.0;
d_ff_d_alpha=0.0;
d_ff_d_vel0=0.0;
d_ff_d_mu0=0.0;
d_ff_d_beta=0.0;
d_ff_d_mtheta=0.0;
d_ff_d_vtheta=0.0;
d_ff_d_vtzeta=0.0;
d_ff_d_dibsat=0.0;
d_ff_d_epsilon=0.0;
d_ff_d_vzeta=0.0;
d_ff_d_lambda=0.0;
d_ff_d_ngf=0.0;
d_ff_d_type=0.0;
ff=0.0;
}
else
{
if((exparg<(-50.0)))
{
d_ff_d_vgsin=0.0;
d_ff_d_vdsin=0.0;
d_ff_d_qcbflag=0.0;
d_ff_d_vcin=0.0;
d_ff_d_vbin=0.0;
d_ff_d_qgsflag=0.0;
d_ff_d_tambin=0.0;
d_ff_d_tnomin=0.0;
d_ff_d_phitin=0.0;
d_ff_d_w=0.0;
d_ff_d_lin=0.0;
d_ff_d_cgin=0.0;
d_ff_d_cs=0.0;
d_ff_d_cc=0.0;
d_ff_d_cb=0.0;
d_ff_d_vto=0.0;
d_ff_d_ss=0.0;
d_ff_d_delta1=0.0;
d_ff_d_delta2=0.0;
d_ff_d_nd=0.0;
d_ff_d_alpha=0.0;
d_ff_d_vel0=0.0;
d_ff_d_mu0=0.0;
d_ff_d_beta=0.0;
d_ff_d_mtheta=0.0;
d_ff_d_vtheta=0.0;
d_ff_d_vtzeta=0.0;
d_ff_d_dibsat=0.0;
d_ff_d_epsilon=0.0;
d_ff_d_vzeta=0.0;
d_ff_d_lambda=0.0;
d_ff_d_ngf=0.0;
d_ff_d_type=0.0;
ff=1.0;
}
else
{
d_ff_d_vgsin=(-exp(exparg)*d_exparg_d_vgsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vdsin=(-exp(exparg)*d_exparg_d_vdsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_qcbflag=(-exp(exparg)*d_exparg_d_qcbflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vcin=(-exp(exparg)*d_exparg_d_vcin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vbin=(-exp(exparg)*d_exparg_d_vbin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_qgsflag=(-exp(exparg)*d_exparg_d_qgsflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_tambin=(-exp(exparg)*d_exparg_d_tambin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_tnomin=(-exp(exparg)*d_exparg_d_tnomin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_phitin=(-exp(exparg)*d_exparg_d_phitin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_w=(-exp(exparg)*d_exparg_d_w/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_lin=(-exp(exparg)*d_exparg_d_lin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cgin=(-exp(exparg)*d_exparg_d_cgin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cs=(-exp(exparg)*d_exparg_d_cs/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cc=(-exp(exparg)*d_exparg_d_cc/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_cb=(-exp(exparg)*d_exparg_d_cb/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vto=(-exp(exparg)*d_exparg_d_vto/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_ss=(-exp(exparg)*d_exparg_d_ss/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_delta1=(-exp(exparg)*d_exparg_d_delta1/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_delta2=(-exp(exparg)*d_exparg_d_delta2/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_nd=(-exp(exparg)*d_exparg_d_nd/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_alpha=(-exp(exparg)*d_exparg_d_alpha/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vel0=(-exp(exparg)*d_exparg_d_vel0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_mu0=(-exp(exparg)*d_exparg_d_mu0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_beta=(-exp(exparg)*d_exparg_d_beta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_mtheta=(-exp(exparg)*d_exparg_d_mtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vtheta=(-exp(exparg)*d_exparg_d_vtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vtzeta=(-exp(exparg)*d_exparg_d_vtzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_dibsat=(-exp(exparg)*d_exparg_d_dibsat/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_epsilon=(-exp(exparg)*d_exparg_d_epsilon/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_vzeta=(-exp(exparg)*d_exparg_d_vzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_lambda=(-exp(exparg)*d_exparg_d_lambda/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_ngf=(-exp(exparg)*d_exparg_d_ngf/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ff_d_type=(-exp(exparg)*d_exparg_d_type/(1.0+exp(exparg))/(1.0+exp(exparg)));
ff=(1.0/(1.0+exp(exparg)));
}
}
d_eta_d_vgsin=((two_n_phit*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-(d_vtdibl_d_vgsin-(((0.1*alpha_phit)*d_ff_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vgsin)/two_n_phit/two_n_phit);
d_eta_d_vdsin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-(d_vtdibl_d_vdsin-(((0.1*alpha_phit)*d_ff_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vdsin)/two_n_phit/two_n_phit);
d_eta_d_qcbflag=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-(d_vtdibl_d_qcbflag-(((0.1*alpha_phit)*d_ff_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_qcbflag)/two_n_phit/two_n_phit);
d_eta_d_vcin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-(d_vtdibl_d_vcin-(((0.1*alpha_phit)*d_ff_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vcin)/two_n_phit/two_n_phit);
d_eta_d_vbin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-(d_vtdibl_d_vbin-(((0.1*alpha_phit)*d_ff_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vbin)/two_n_phit/two_n_phit);
d_eta_d_qgsflag=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-(d_vtdibl_d_qgsflag-(((0.1*alpha_phit)*d_ff_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_qgsflag)/two_n_phit/two_n_phit);
d_eta_d_tambin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-(d_vtdibl_d_tambin-(((0.1*alpha_phit)*d_ff_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_tambin)/two_n_phit/two_n_phit);
d_eta_d_tnomin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-(d_vtdibl_d_tnomin-(((0.1*alpha_phit)*d_ff_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_tnomin)/two_n_phit/two_n_phit);
d_eta_d_phitin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-(d_vtdibl_d_phitin-(((0.1*alpha_phit)*d_ff_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_phitin)/two_n_phit/two_n_phit);
d_eta_d_w=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-(d_vtdibl_d_w-(((0.1*alpha_phit)*d_ff_d_w)+((0.1*d_alpha_phit_d_w)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_w)/two_n_phit/two_n_phit);
d_eta_d_lin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-(d_vtdibl_d_lin-(((0.1*alpha_phit)*d_ff_d_lin)+((0.1*d_alpha_phit_d_lin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_lin)/two_n_phit/two_n_phit);
d_eta_d_cgin=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-(d_vtdibl_d_cgin-(((0.1*alpha_phit)*d_ff_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cgin)/two_n_phit/two_n_phit);
d_eta_d_cs=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-(d_vtdibl_d_cs-(((0.1*alpha_phit)*d_ff_d_cs)+((0.1*d_alpha_phit_d_cs)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cs)/two_n_phit/two_n_phit);
d_eta_d_cc=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-(d_vtdibl_d_cc-(((0.1*alpha_phit)*d_ff_d_cc)+((0.1*d_alpha_phit_d_cc)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cc)/two_n_phit/two_n_phit);
d_eta_d_cb=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-(d_vtdibl_d_cb-(((0.1*alpha_phit)*d_ff_d_cb)+((0.1*d_alpha_phit_d_cb)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_cb)/two_n_phit/two_n_phit);
d_eta_d_vto=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-(d_vtdibl_d_vto-(((0.1*alpha_phit)*d_ff_d_vto)+((0.1*d_alpha_phit_d_vto)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vto)/two_n_phit/two_n_phit);
d_eta_d_ss=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-(d_vtdibl_d_ss-(((0.1*alpha_phit)*d_ff_d_ss)+((0.1*d_alpha_phit_d_ss)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_ss)/two_n_phit/two_n_phit);
d_eta_d_delta1=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-(d_vtdibl_d_delta1-(((0.1*alpha_phit)*d_ff_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_delta1)/two_n_phit/two_n_phit);
d_eta_d_delta2=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-(d_vtdibl_d_delta2-(((0.1*alpha_phit)*d_ff_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_delta2)/two_n_phit/two_n_phit);
d_eta_d_nd=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-(d_vtdibl_d_nd-(((0.1*alpha_phit)*d_ff_d_nd)+((0.1*d_alpha_phit_d_nd)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_nd)/two_n_phit/two_n_phit);
d_eta_d_alpha=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-(d_vtdibl_d_alpha-(((0.1*alpha_phit)*d_ff_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_alpha)/two_n_phit/two_n_phit);
d_eta_d_vel0=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-(d_vtdibl_d_vel0-(((0.1*alpha_phit)*d_ff_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vel0)/two_n_phit/two_n_phit);
d_eta_d_mu0=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-(d_vtdibl_d_mu0-(((0.1*alpha_phit)*d_ff_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_mu0)/two_n_phit/two_n_phit);
d_eta_d_beta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-(d_vtdibl_d_beta-(((0.1*alpha_phit)*d_ff_d_beta)+((0.1*d_alpha_phit_d_beta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_beta)/two_n_phit/two_n_phit);
d_eta_d_mtheta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-(d_vtdibl_d_mtheta-(((0.1*alpha_phit)*d_ff_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_mtheta)/two_n_phit/two_n_phit);
d_eta_d_vtheta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-(d_vtdibl_d_vtheta-(((0.1*alpha_phit)*d_ff_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vtheta)/two_n_phit/two_n_phit);
d_eta_d_vtzeta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-(d_vtdibl_d_vtzeta-(((0.1*alpha_phit)*d_ff_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vtzeta)/two_n_phit/two_n_phit);
d_eta_d_dibsat=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-(d_vtdibl_d_dibsat-(((0.1*alpha_phit)*d_ff_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_dibsat)/two_n_phit/two_n_phit);
d_eta_d_epsilon=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-(d_vtdibl_d_epsilon-(((0.1*alpha_phit)*d_ff_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_epsilon)/two_n_phit/two_n_phit);
d_eta_d_vzeta=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-(d_vtdibl_d_vzeta-(((0.1*alpha_phit)*d_ff_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_vzeta)/two_n_phit/two_n_phit);
d_eta_d_lambda=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-(d_vtdibl_d_lambda-(((0.1*alpha_phit)*d_ff_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_lambda)/two_n_phit/two_n_phit);
d_eta_d_ngf=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-(d_vtdibl_d_ngf-(((0.1*alpha_phit)*d_ff_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_ngf)/two_n_phit/two_n_phit);
d_eta_d_type=((two_n_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-(d_vtdibl_d_type-(((0.1*alpha_phit)*d_ff_d_type)+((0.1*d_alpha_phit_d_type)*ff))))-(mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))*d_two_n_phit_d_type)/two_n_phit/two_n_phit);
eta=((mmax(vgsin,vgdin)-(vtdibl-((0.1*alpha_phit)*ff)))/two_n_phit);
if((eta>50.0))
{
d_qinvv_d_vgsin=((qref*d_eta_d_vgsin)+(d_qref_d_vgsin*eta));
d_qinvv_d_vdsin=((qref*d_eta_d_vdsin)+(d_qref_d_vdsin*eta));
d_qinvv_d_qcbflag=((qref*d_eta_d_qcbflag)+(d_qref_d_qcbflag*eta));
d_qinvv_d_vcin=((qref*d_eta_d_vcin)+(d_qref_d_vcin*eta));
d_qinvv_d_vbin=((qref*d_eta_d_vbin)+(d_qref_d_vbin*eta));
d_qinvv_d_qgsflag=((qref*d_eta_d_qgsflag)+(d_qref_d_qgsflag*eta));
d_qinvv_d_tambin=((qref*d_eta_d_tambin)+(d_qref_d_tambin*eta));
d_qinvv_d_tnomin=((qref*d_eta_d_tnomin)+(d_qref_d_tnomin*eta));
d_qinvv_d_phitin=((qref*d_eta_d_phitin)+(d_qref_d_phitin*eta));
d_qinvv_d_w=((qref*d_eta_d_w)+(d_qref_d_w*eta));
d_qinvv_d_lin=((qref*d_eta_d_lin)+(d_qref_d_lin*eta));
d_qinvv_d_cgin=((qref*d_eta_d_cgin)+(d_qref_d_cgin*eta));
d_qinvv_d_cs=((qref*d_eta_d_cs)+(d_qref_d_cs*eta));
d_qinvv_d_cc=((qref*d_eta_d_cc)+(d_qref_d_cc*eta));
d_qinvv_d_cb=((qref*d_eta_d_cb)+(d_qref_d_cb*eta));
d_qinvv_d_vto=((qref*d_eta_d_vto)+(d_qref_d_vto*eta));
d_qinvv_d_ss=((qref*d_eta_d_ss)+(d_qref_d_ss*eta));
d_qinvv_d_delta1=((qref*d_eta_d_delta1)+(d_qref_d_delta1*eta));
d_qinvv_d_delta2=((qref*d_eta_d_delta2)+(d_qref_d_delta2*eta));
d_qinvv_d_nd=((qref*d_eta_d_nd)+(d_qref_d_nd*eta));
d_qinvv_d_alpha=((qref*d_eta_d_alpha)+(d_qref_d_alpha*eta));
d_qinvv_d_vel0=((qref*d_eta_d_vel0)+(d_qref_d_vel0*eta));
d_qinvv_d_mu0=((qref*d_eta_d_mu0)+(d_qref_d_mu0*eta));
d_qinvv_d_beta=((qref*d_eta_d_beta)+(d_qref_d_beta*eta));
d_qinvv_d_mtheta=((qref*d_eta_d_mtheta)+(d_qref_d_mtheta*eta));
d_qinvv_d_vtheta=((qref*d_eta_d_vtheta)+(d_qref_d_vtheta*eta));
d_qinvv_d_vtzeta=((qref*d_eta_d_vtzeta)+(d_qref_d_vtzeta*eta));
d_qinvv_d_dibsat=((qref*d_eta_d_dibsat)+(d_qref_d_dibsat*eta));
d_qinvv_d_epsilon=((qref*d_eta_d_epsilon)+(d_qref_d_epsilon*eta));
d_qinvv_d_vzeta=((qref*d_eta_d_vzeta)+(d_qref_d_vzeta*eta));
d_qinvv_d_lambda=((qref*d_eta_d_lambda)+(d_qref_d_lambda*eta));
d_qinvv_d_ngf=((qref*d_eta_d_ngf)+(d_qref_d_ngf*eta));
d_qinvv_d_type=((qref*d_eta_d_type)+(d_qref_d_type*eta));
qinvv=(qref*eta);
}
else
{
if((eta<(-50.0)))
{
d_qinvv_d_vgsin=0.0;
d_qinvv_d_vdsin=0.0;
d_qinvv_d_qcbflag=0.0;
d_qinvv_d_vcin=0.0;
d_qinvv_d_vbin=0.0;
d_qinvv_d_qgsflag=0.0;
d_qinvv_d_tambin=0.0;
d_qinvv_d_tnomin=0.0;
d_qinvv_d_phitin=0.0;
d_qinvv_d_w=0.0;
d_qinvv_d_lin=0.0;
d_qinvv_d_cgin=0.0;
d_qinvv_d_cs=0.0;
d_qinvv_d_cc=0.0;
d_qinvv_d_cb=0.0;
d_qinvv_d_vto=0.0;
d_qinvv_d_ss=0.0;
d_qinvv_d_delta1=0.0;
d_qinvv_d_delta2=0.0;
d_qinvv_d_nd=0.0;
d_qinvv_d_alpha=0.0;
d_qinvv_d_vel0=0.0;
d_qinvv_d_mu0=0.0;
d_qinvv_d_beta=0.0;
d_qinvv_d_mtheta=0.0;
d_qinvv_d_vtheta=0.0;
d_qinvv_d_vtzeta=0.0;
d_qinvv_d_dibsat=0.0;
d_qinvv_d_epsilon=0.0;
d_qinvv_d_vzeta=0.0;
d_qinvv_d_lambda=0.0;
d_qinvv_d_ngf=0.0;
d_qinvv_d_type=0.0;
qinvv=0;
}
else
{
d_qinvv_d_vgsin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vgsin)+(d_qref_d_vgsin*log((1.0+exp(eta)))));
d_qinvv_d_vdsin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vdsin)+(d_qref_d_vdsin*log((1.0+exp(eta)))));
d_qinvv_d_qcbflag=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_qcbflag)+(d_qref_d_qcbflag*log((1.0+exp(eta)))));
d_qinvv_d_vcin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vcin)+(d_qref_d_vcin*log((1.0+exp(eta)))));
d_qinvv_d_vbin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vbin)+(d_qref_d_vbin*log((1.0+exp(eta)))));
d_qinvv_d_qgsflag=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_qgsflag)+(d_qref_d_qgsflag*log((1.0+exp(eta)))));
d_qinvv_d_tambin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_tambin)+(d_qref_d_tambin*log((1.0+exp(eta)))));
d_qinvv_d_tnomin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_tnomin)+(d_qref_d_tnomin*log((1.0+exp(eta)))));
d_qinvv_d_phitin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_phitin)+(d_qref_d_phitin*log((1.0+exp(eta)))));
d_qinvv_d_w=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_w)+(d_qref_d_w*log((1.0+exp(eta)))));
d_qinvv_d_lin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_lin)+(d_qref_d_lin*log((1.0+exp(eta)))));
d_qinvv_d_cgin=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cgin)+(d_qref_d_cgin*log((1.0+exp(eta)))));
d_qinvv_d_cs=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cs)+(d_qref_d_cs*log((1.0+exp(eta)))));
d_qinvv_d_cc=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cc)+(d_qref_d_cc*log((1.0+exp(eta)))));
d_qinvv_d_cb=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_cb)+(d_qref_d_cb*log((1.0+exp(eta)))));
d_qinvv_d_vto=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vto)+(d_qref_d_vto*log((1.0+exp(eta)))));
d_qinvv_d_ss=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_ss)+(d_qref_d_ss*log((1.0+exp(eta)))));
d_qinvv_d_delta1=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_delta1)+(d_qref_d_delta1*log((1.0+exp(eta)))));
d_qinvv_d_delta2=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_delta2)+(d_qref_d_delta2*log((1.0+exp(eta)))));
d_qinvv_d_nd=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_nd)+(d_qref_d_nd*log((1.0+exp(eta)))));
d_qinvv_d_alpha=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_alpha)+(d_qref_d_alpha*log((1.0+exp(eta)))));
d_qinvv_d_vel0=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vel0)+(d_qref_d_vel0*log((1.0+exp(eta)))));
d_qinvv_d_mu0=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_mu0)+(d_qref_d_mu0*log((1.0+exp(eta)))));
d_qinvv_d_beta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_beta)+(d_qref_d_beta*log((1.0+exp(eta)))));
d_qinvv_d_mtheta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_mtheta)+(d_qref_d_mtheta*log((1.0+exp(eta)))));
d_qinvv_d_vtheta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vtheta)+(d_qref_d_vtheta*log((1.0+exp(eta)))));
d_qinvv_d_vtzeta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vtzeta)+(d_qref_d_vtzeta*log((1.0+exp(eta)))));
d_qinvv_d_dibsat=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_dibsat)+(d_qref_d_dibsat*log((1.0+exp(eta)))));
d_qinvv_d_epsilon=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_epsilon)+(d_qref_d_epsilon*log((1.0+exp(eta)))));
d_qinvv_d_vzeta=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_vzeta)+(d_qref_d_vzeta*log((1.0+exp(eta)))));
d_qinvv_d_lambda=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_lambda)+(d_qref_d_lambda*log((1.0+exp(eta)))));
d_qinvv_d_ngf=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_ngf)+(d_qref_d_ngf*log((1.0+exp(eta)))));
d_qinvv_d_type=((qref*(1.0/(1.0+exp(eta)))*exp(eta)*d_eta_d_type)+(d_qref_d_type*log((1.0+exp(eta)))));
qinvv=(qref*log((1.0+exp(eta))));
}
}
d_muf_d_vgsin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vgsin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vdsin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vdsin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_qcbflag=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_qcbflag)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vcin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vcin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vbin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vbin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_qgsflag=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_qgsflag)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_tambin=(-mu0*((pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_tambin)/cgin))+((((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(1.0/tnomin)*(1.0+((mtheta*qinvv)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_tnomin=(-mu0*((pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_tnomin)/cgin))+((((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(-tambin/tnomin/tnomin)*(1.0+((mtheta*qinvv)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_phitin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_phitin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_w=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_w)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_lin=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_lin)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cgin=(-mu0*(pow((tambin/tnomin),epsilon)*((cgin*(mtheta*d_qinvv_d_cgin)-(mtheta*qinvv))/cgin/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cs=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_cs)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cc=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_cc)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_cb=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_cb)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vto=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vto)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_ss=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_ss)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_delta1=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_delta1)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_delta2=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_delta2)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_nd=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_nd)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_alpha=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_alpha)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vel0=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vel0)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_mu0=(((pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))-(mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_mu0)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_beta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_beta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_mtheta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_mtheta+qinvv)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vtheta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vtheta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vtzeta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vtzeta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_dibsat=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_dibsat)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_epsilon=(-mu0*((pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_epsilon)/cgin))+((((tambin/tnomin)==0.0)?0.0:(log((tambin/tnomin)*pow((tambin/tnomin),epsilon))))*(1.0+((mtheta*qinvv)/cgin))))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_vzeta=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_vzeta)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_lambda=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_lambda)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_ngf=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_ngf)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_muf_d_type=(-mu0*(pow((tambin/tnomin),epsilon)*((mtheta*d_qinvv_d_type)/cgin))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin)))/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
muf=(mu0/(pow((tambin/tnomin),epsilon)*(1.0+((mtheta*qinvv)/cgin))));
d_vx_d_vgsin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vgsin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vgsin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vdsin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vdsin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vdsin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_qcbflag=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_qcbflag)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_qcbflag)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vcin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vcin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vcin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vbin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vbin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vbin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_qgsflag=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_qgsflag)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_qgsflag)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_tambin=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_tambin)/lin))+((vel0*(-(1.0+(vzeta*tnomin))*(vzeta)/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_tambin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_tnomin=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_tnomin)/lin))+((vel0*((vzeta)/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_tnomin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_phitin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_phitin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_phitin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_w=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_w)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_w)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_lin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lin*(lambda*d_absvdsin_d_lin)-(lambda*absvdsin))/lin/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_lin)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cgin=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cgin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((cgin*(vtheta*d_qinvv_d_cgin)-(vtheta*qinvv))/cgin/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cs=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cs)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_cs)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cc=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cc)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_cc)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_cb=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_cb)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_cb)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vto=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vto)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vto)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_ss=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_ss)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_ss)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_delta1=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_delta1)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_delta1)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_delta2=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_delta2)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_delta2)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_nd=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_nd)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_nd)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_alpha=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_alpha)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_alpha)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vel0=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vel0)/lin))+((((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vel0)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_mu0=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_mu0)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_mu0)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_beta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_beta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_beta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_mtheta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_mtheta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_mtheta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vtheta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vtheta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vtheta+qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vtzeta=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vtzeta)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vtzeta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_dibsat=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_dibsat)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_dibsat)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_epsilon=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_epsilon)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_epsilon)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_vzeta=(((1.0+((vtheta*qinvv)/cgin))*(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_vzeta)/lin))+((vel0*(((1.0+(vzeta*tambin))*(tnomin)-(1.0+(vzeta*tnomin))*(tambin))/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin))))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_vzeta)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_lambda=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_lambda+absvdsin)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_lambda)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_ngf=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_ngf)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_ngf)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
d_vx_d_type=(((1.0+((vtheta*qinvv)/cgin))*((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*((lambda*d_absvdsin_d_type)/lin))-((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))*((vtheta*d_qinvv_d_type)/cgin))/(1.0+((vtheta*qinvv)/cgin))/(1.0+((vtheta*qinvv)/cgin)));
vx=(((vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))))*(1.0+((lambda*absvdsin)/lin)))/(1.0+((vtheta*qinvv)/cgin)));
d_vxf_d_vgsin=((((((2.0*ff)*phitin)*d_muf_d_vgsin)+(((2.0*d_ff_d_vgsin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vgsin)+((-d_ff_d_vgsin)*vx)));
d_vxf_d_vdsin=((((((2.0*ff)*phitin)*d_muf_d_vdsin)+(((2.0*d_ff_d_vdsin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vdsin)+((-d_ff_d_vdsin)*vx)));
d_vxf_d_qcbflag=((((((2.0*ff)*phitin)*d_muf_d_qcbflag)+(((2.0*d_ff_d_qcbflag)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_qcbflag)+((-d_ff_d_qcbflag)*vx)));
d_vxf_d_vcin=((((((2.0*ff)*phitin)*d_muf_d_vcin)+(((2.0*d_ff_d_vcin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vcin)+((-d_ff_d_vcin)*vx)));
d_vxf_d_vbin=((((((2.0*ff)*phitin)*d_muf_d_vbin)+(((2.0*d_ff_d_vbin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vbin)+((-d_ff_d_vbin)*vx)));
d_vxf_d_qgsflag=((((((2.0*ff)*phitin)*d_muf_d_qgsflag)+(((2.0*d_ff_d_qgsflag)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_qgsflag)+((-d_ff_d_qgsflag)*vx)));
d_vxf_d_tambin=((((((2.0*ff)*phitin)*d_muf_d_tambin)+(((2.0*d_ff_d_tambin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_tambin)+((-d_ff_d_tambin)*vx)));
d_vxf_d_tnomin=((((((2.0*ff)*phitin)*d_muf_d_tnomin)+(((2.0*d_ff_d_tnomin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_tnomin)+((-d_ff_d_tnomin)*vx)));
d_vxf_d_phitin=((((((2.0*ff)*phitin)*d_muf_d_phitin)+(((2.0*ff)+phitin*(2.0*d_ff_d_phitin))*muf))/lin)+(((1.0-ff)*d_vx_d_phitin)+((-d_ff_d_phitin)*vx)));
d_vxf_d_w=((((((2.0*ff)*phitin)*d_muf_d_w)+(((2.0*d_ff_d_w)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_w)+((-d_ff_d_w)*vx)));
d_vxf_d_lin=(((lin*((((2.0*ff)*phitin)*d_muf_d_lin)+(((2.0*d_ff_d_lin)*phitin)*muf))-(((2.0*ff)*phitin)*muf))/lin/lin)+(((1.0-ff)*d_vx_d_lin)+((-d_ff_d_lin)*vx)));
d_vxf_d_cgin=((((((2.0*ff)*phitin)*d_muf_d_cgin)+(((2.0*d_ff_d_cgin)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cgin)+((-d_ff_d_cgin)*vx)));
d_vxf_d_cs=((((((2.0*ff)*phitin)*d_muf_d_cs)+(((2.0*d_ff_d_cs)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cs)+((-d_ff_d_cs)*vx)));
d_vxf_d_cc=((((((2.0*ff)*phitin)*d_muf_d_cc)+(((2.0*d_ff_d_cc)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cc)+((-d_ff_d_cc)*vx)));
d_vxf_d_cb=((((((2.0*ff)*phitin)*d_muf_d_cb)+(((2.0*d_ff_d_cb)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_cb)+((-d_ff_d_cb)*vx)));
d_vxf_d_vto=((((((2.0*ff)*phitin)*d_muf_d_vto)+(((2.0*d_ff_d_vto)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vto)+((-d_ff_d_vto)*vx)));
d_vxf_d_ss=((((((2.0*ff)*phitin)*d_muf_d_ss)+(((2.0*d_ff_d_ss)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_ss)+((-d_ff_d_ss)*vx)));
d_vxf_d_delta1=((((((2.0*ff)*phitin)*d_muf_d_delta1)+(((2.0*d_ff_d_delta1)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_delta1)+((-d_ff_d_delta1)*vx)));
d_vxf_d_delta2=((((((2.0*ff)*phitin)*d_muf_d_delta2)+(((2.0*d_ff_d_delta2)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_delta2)+((-d_ff_d_delta2)*vx)));
d_vxf_d_nd=((((((2.0*ff)*phitin)*d_muf_d_nd)+(((2.0*d_ff_d_nd)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_nd)+((-d_ff_d_nd)*vx)));
d_vxf_d_alpha=((((((2.0*ff)*phitin)*d_muf_d_alpha)+(((2.0*d_ff_d_alpha)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_alpha)+((-d_ff_d_alpha)*vx)));
d_vxf_d_vel0=((((((2.0*ff)*phitin)*d_muf_d_vel0)+(((2.0*d_ff_d_vel0)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vel0)+((-d_ff_d_vel0)*vx)));
d_vxf_d_mu0=((((((2.0*ff)*phitin)*d_muf_d_mu0)+(((2.0*d_ff_d_mu0)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_mu0)+((-d_ff_d_mu0)*vx)));
d_vxf_d_beta=((((((2.0*ff)*phitin)*d_muf_d_beta)+(((2.0*d_ff_d_beta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_beta)+((-d_ff_d_beta)*vx)));
d_vxf_d_mtheta=((((((2.0*ff)*phitin)*d_muf_d_mtheta)+(((2.0*d_ff_d_mtheta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_mtheta)+((-d_ff_d_mtheta)*vx)));
d_vxf_d_vtheta=((((((2.0*ff)*phitin)*d_muf_d_vtheta)+(((2.0*d_ff_d_vtheta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vtheta)+((-d_ff_d_vtheta)*vx)));
d_vxf_d_vtzeta=((((((2.0*ff)*phitin)*d_muf_d_vtzeta)+(((2.0*d_ff_d_vtzeta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vtzeta)+((-d_ff_d_vtzeta)*vx)));
d_vxf_d_dibsat=((((((2.0*ff)*phitin)*d_muf_d_dibsat)+(((2.0*d_ff_d_dibsat)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_dibsat)+((-d_ff_d_dibsat)*vx)));
d_vxf_d_epsilon=((((((2.0*ff)*phitin)*d_muf_d_epsilon)+(((2.0*d_ff_d_epsilon)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_epsilon)+((-d_ff_d_epsilon)*vx)));
d_vxf_d_vzeta=((((((2.0*ff)*phitin)*d_muf_d_vzeta)+(((2.0*d_ff_d_vzeta)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_vzeta)+((-d_ff_d_vzeta)*vx)));
d_vxf_d_lambda=((((((2.0*ff)*phitin)*d_muf_d_lambda)+(((2.0*d_ff_d_lambda)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_lambda)+((-d_ff_d_lambda)*vx)));
d_vxf_d_ngf=((((((2.0*ff)*phitin)*d_muf_d_ngf)+(((2.0*d_ff_d_ngf)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_ngf)+((-d_ff_d_ngf)*vx)));
d_vxf_d_type=((((((2.0*ff)*phitin)*d_muf_d_type)+(((2.0*d_ff_d_type)*phitin)*muf))/lin)+(((1.0-ff)*d_vx_d_type)+((-d_ff_d_type)*vx)));
vxf=(((((2.0*ff)*phitin)*muf)/lin)+((1.0-ff)*vx));
d_vdsats_d_vgsin=((muf*(d_vx_d_vgsin*lin)-(vx*lin)*d_muf_d_vgsin)/muf/muf);
d_vdsats_d_vdsin=((muf*(d_vx_d_vdsin*lin)-(vx*lin)*d_muf_d_vdsin)/muf/muf);
d_vdsats_d_qcbflag=((muf*(d_vx_d_qcbflag*lin)-(vx*lin)*d_muf_d_qcbflag)/muf/muf);
d_vdsats_d_vcin=((muf*(d_vx_d_vcin*lin)-(vx*lin)*d_muf_d_vcin)/muf/muf);
d_vdsats_d_vbin=((muf*(d_vx_d_vbin*lin)-(vx*lin)*d_muf_d_vbin)/muf/muf);
d_vdsats_d_qgsflag=((muf*(d_vx_d_qgsflag*lin)-(vx*lin)*d_muf_d_qgsflag)/muf/muf);
d_vdsats_d_tambin=((muf*(d_vx_d_tambin*lin)-(vx*lin)*d_muf_d_tambin)/muf/muf);
d_vdsats_d_tnomin=((muf*(d_vx_d_tnomin*lin)-(vx*lin)*d_muf_d_tnomin)/muf/muf);
d_vdsats_d_phitin=((muf*(d_vx_d_phitin*lin)-(vx*lin)*d_muf_d_phitin)/muf/muf);
d_vdsats_d_w=((muf*(d_vx_d_w*lin)-(vx*lin)*d_muf_d_w)/muf/muf);
d_vdsats_d_lin=((muf*(vx+lin*d_vx_d_lin)-(vx*lin)*d_muf_d_lin)/muf/muf);
d_vdsats_d_cgin=((muf*(d_vx_d_cgin*lin)-(vx*lin)*d_muf_d_cgin)/muf/muf);
d_vdsats_d_cs=((muf*(d_vx_d_cs*lin)-(vx*lin)*d_muf_d_cs)/muf/muf);
d_vdsats_d_cc=((muf*(d_vx_d_cc*lin)-(vx*lin)*d_muf_d_cc)/muf/muf);
d_vdsats_d_cb=((muf*(d_vx_d_cb*lin)-(vx*lin)*d_muf_d_cb)/muf/muf);
d_vdsats_d_vto=((muf*(d_vx_d_vto*lin)-(vx*lin)*d_muf_d_vto)/muf/muf);
d_vdsats_d_ss=((muf*(d_vx_d_ss*lin)-(vx*lin)*d_muf_d_ss)/muf/muf);
d_vdsats_d_delta1=((muf*(d_vx_d_delta1*lin)-(vx*lin)*d_muf_d_delta1)/muf/muf);
d_vdsats_d_delta2=((muf*(d_vx_d_delta2*lin)-(vx*lin)*d_muf_d_delta2)/muf/muf);
d_vdsats_d_nd=((muf*(d_vx_d_nd*lin)-(vx*lin)*d_muf_d_nd)/muf/muf);
d_vdsats_d_alpha=((muf*(d_vx_d_alpha*lin)-(vx*lin)*d_muf_d_alpha)/muf/muf);
d_vdsats_d_vel0=((muf*(d_vx_d_vel0*lin)-(vx*lin)*d_muf_d_vel0)/muf/muf);
d_vdsats_d_mu0=((muf*(d_vx_d_mu0*lin)-(vx*lin)*d_muf_d_mu0)/muf/muf);
d_vdsats_d_beta=((muf*(d_vx_d_beta*lin)-(vx*lin)*d_muf_d_beta)/muf/muf);
d_vdsats_d_mtheta=((muf*(d_vx_d_mtheta*lin)-(vx*lin)*d_muf_d_mtheta)/muf/muf);
d_vdsats_d_vtheta=((muf*(d_vx_d_vtheta*lin)-(vx*lin)*d_muf_d_vtheta)/muf/muf);
d_vdsats_d_vtzeta=((muf*(d_vx_d_vtzeta*lin)-(vx*lin)*d_muf_d_vtzeta)/muf/muf);
d_vdsats_d_dibsat=((muf*(d_vx_d_dibsat*lin)-(vx*lin)*d_muf_d_dibsat)/muf/muf);
d_vdsats_d_epsilon=((muf*(d_vx_d_epsilon*lin)-(vx*lin)*d_muf_d_epsilon)/muf/muf);
d_vdsats_d_vzeta=((muf*(d_vx_d_vzeta*lin)-(vx*lin)*d_muf_d_vzeta)/muf/muf);
d_vdsats_d_lambda=((muf*(d_vx_d_lambda*lin)-(vx*lin)*d_muf_d_lambda)/muf/muf);
d_vdsats_d_ngf=((muf*(d_vx_d_ngf*lin)-(vx*lin)*d_muf_d_ngf)/muf/muf);
d_vdsats_d_type=((muf*(d_vx_d_type*lin)-(vx*lin)*d_muf_d_type)/muf/muf);
vdsats=((vx*lin)/muf);
d_vdsats1_d_vgsin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vgsin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vgsin)/vdsats/vdsats))+(d_vdsats_d_vgsin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vgsin);
d_vdsats1_d_vdsin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vdsin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vdsin)/vdsats/vdsats))+(d_vdsats_d_vdsin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vdsin);
d_vdsats1_d_qcbflag=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_qcbflag)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_qcbflag)/vdsats/vdsats))+(d_vdsats_d_qcbflag*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_qcbflag);
d_vdsats1_d_vcin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vcin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vcin)/vdsats/vdsats))+(d_vdsats_d_vcin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vcin);
d_vdsats1_d_vbin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vbin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vbin)/vdsats/vdsats))+(d_vdsats_d_vbin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vbin);
d_vdsats1_d_qgsflag=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_qgsflag)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_qgsflag)/vdsats/vdsats))+(d_vdsats_d_qgsflag*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_qgsflag);
d_vdsats1_d_tambin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_tambin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_tambin)/vdsats/vdsats))+(d_vdsats_d_tambin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_tambin);
d_vdsats1_d_tnomin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_tnomin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_tnomin)/vdsats/vdsats))+(d_vdsats_d_tnomin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_tnomin);
d_vdsats1_d_phitin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_phitin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_phitin)/vdsats/vdsats))+(d_vdsats_d_phitin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_phitin);
d_vdsats1_d_w=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_w)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_w)/vdsats/vdsats))+(d_vdsats_d_w*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_w);
d_vdsats1_d_lin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_lin)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_lin)/vdsats/vdsats))+(d_vdsats_d_lin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_lin);
d_vdsats1_d_cgin=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((cgin*(2.0*d_qinvv_d_cgin)-(2.0*qinvv))/cgin/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cgin)/vdsats/vdsats))+(d_vdsats_d_cgin*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cgin);
d_vdsats1_d_cs=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_cs)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cs)/vdsats/vdsats))+(d_vdsats_d_cs*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cs);
d_vdsats1_d_cc=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_cc)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cc)/vdsats/vdsats))+(d_vdsats_d_cc*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cc);
d_vdsats1_d_cb=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_cb)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_cb)/vdsats/vdsats))+(d_vdsats_d_cb*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_cb);
d_vdsats1_d_vto=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vto)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vto)/vdsats/vdsats))+(d_vdsats_d_vto*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vto);
d_vdsats1_d_ss=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_ss)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_ss)/vdsats/vdsats))+(d_vdsats_d_ss*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_ss);
d_vdsats1_d_delta1=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_delta1)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_delta1)/vdsats/vdsats))+(d_vdsats_d_delta1*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_delta1);
d_vdsats1_d_delta2=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_delta2)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_delta2)/vdsats/vdsats))+(d_vdsats_d_delta2*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_delta2);
d_vdsats1_d_nd=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_nd)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_nd)/vdsats/vdsats))+(d_vdsats_d_nd*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_nd);
d_vdsats1_d_alpha=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_alpha)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_alpha)/vdsats/vdsats))+(d_vdsats_d_alpha*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_alpha);
d_vdsats1_d_vel0=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vel0)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vel0)/vdsats/vdsats))+(d_vdsats_d_vel0*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vel0);
d_vdsats1_d_mu0=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_mu0)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_mu0)/vdsats/vdsats))+(d_vdsats_d_mu0*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_mu0);
d_vdsats1_d_beta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_beta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_beta)/vdsats/vdsats))+(d_vdsats_d_beta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_beta);
d_vdsats1_d_mtheta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_mtheta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_mtheta)/vdsats/vdsats))+(d_vdsats_d_mtheta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_mtheta);
d_vdsats1_d_vtheta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vtheta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vtheta)/vdsats/vdsats))+(d_vdsats_d_vtheta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vtheta);
d_vdsats1_d_vtzeta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vtzeta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vtzeta)/vdsats/vdsats))+(d_vdsats_d_vtzeta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vtzeta);
d_vdsats1_d_dibsat=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_dibsat)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_dibsat)/vdsats/vdsats))+(d_vdsats_d_dibsat*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_dibsat);
d_vdsats1_d_epsilon=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_epsilon)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_epsilon)/vdsats/vdsats))+(d_vdsats_d_epsilon*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_epsilon);
d_vdsats1_d_vzeta=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_vzeta)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_vzeta)/vdsats/vdsats))+(d_vdsats_d_vzeta*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_vzeta);
d_vdsats1_d_lambda=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_lambda)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_lambda)/vdsats/vdsats))+(d_vdsats_d_lambda*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_lambda);
d_vdsats1_d_ngf=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_ngf)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_ngf)/vdsats/vdsats))+(d_vdsats_d_ngf*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_ngf);
d_vdsats1_d_type=(((vdsats*(0.5/sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))*((vdsats*((2.0*d_qinvv_d_type)/cgin)-((2.0*qinvv)/cgin)*d_vdsats_d_type)/vdsats/vdsats))+(d_vdsats_d_type*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats)))))-d_vdsats_d_type);
vdsats1=((vdsats*sqrt((1.0+(((2.0*qinvv)/cgin)/vdsats))))-vdsats);
d_vdsat_d_vgsin=(((vdsats*(-d_ff_d_vgsin))+(d_vdsats_d_vgsin*(1.0-ff)))+((two_n_phit*d_ff_d_vgsin)+(d_two_n_phit_d_vgsin*ff)));
d_vdsat_d_vdsin=(((vdsats*(-d_ff_d_vdsin))+(d_vdsats_d_vdsin*(1.0-ff)))+((two_n_phit*d_ff_d_vdsin)+(d_two_n_phit_d_vdsin*ff)));
d_vdsat_d_qcbflag=(((vdsats*(-d_ff_d_qcbflag))+(d_vdsats_d_qcbflag*(1.0-ff)))+((two_n_phit*d_ff_d_qcbflag)+(d_two_n_phit_d_qcbflag*ff)));
d_vdsat_d_vcin=(((vdsats*(-d_ff_d_vcin))+(d_vdsats_d_vcin*(1.0-ff)))+((two_n_phit*d_ff_d_vcin)+(d_two_n_phit_d_vcin*ff)));
d_vdsat_d_vbin=(((vdsats*(-d_ff_d_vbin))+(d_vdsats_d_vbin*(1.0-ff)))+((two_n_phit*d_ff_d_vbin)+(d_two_n_phit_d_vbin*ff)));
d_vdsat_d_qgsflag=(((vdsats*(-d_ff_d_qgsflag))+(d_vdsats_d_qgsflag*(1.0-ff)))+((two_n_phit*d_ff_d_qgsflag)+(d_two_n_phit_d_qgsflag*ff)));
d_vdsat_d_tambin=(((vdsats*(-d_ff_d_tambin))+(d_vdsats_d_tambin*(1.0-ff)))+((two_n_phit*d_ff_d_tambin)+(d_two_n_phit_d_tambin*ff)));
d_vdsat_d_tnomin=(((vdsats*(-d_ff_d_tnomin))+(d_vdsats_d_tnomin*(1.0-ff)))+((two_n_phit*d_ff_d_tnomin)+(d_two_n_phit_d_tnomin*ff)));
d_vdsat_d_phitin=(((vdsats*(-d_ff_d_phitin))+(d_vdsats_d_phitin*(1.0-ff)))+((two_n_phit*d_ff_d_phitin)+(d_two_n_phit_d_phitin*ff)));
d_vdsat_d_w=(((vdsats*(-d_ff_d_w))+(d_vdsats_d_w*(1.0-ff)))+((two_n_phit*d_ff_d_w)+(d_two_n_phit_d_w*ff)));
d_vdsat_d_lin=(((vdsats*(-d_ff_d_lin))+(d_vdsats_d_lin*(1.0-ff)))+((two_n_phit*d_ff_d_lin)+(d_two_n_phit_d_lin*ff)));
d_vdsat_d_cgin=(((vdsats*(-d_ff_d_cgin))+(d_vdsats_d_cgin*(1.0-ff)))+((two_n_phit*d_ff_d_cgin)+(d_two_n_phit_d_cgin*ff)));
d_vdsat_d_cs=(((vdsats*(-d_ff_d_cs))+(d_vdsats_d_cs*(1.0-ff)))+((two_n_phit*d_ff_d_cs)+(d_two_n_phit_d_cs*ff)));
d_vdsat_d_cc=(((vdsats*(-d_ff_d_cc))+(d_vdsats_d_cc*(1.0-ff)))+((two_n_phit*d_ff_d_cc)+(d_two_n_phit_d_cc*ff)));
d_vdsat_d_cb=(((vdsats*(-d_ff_d_cb))+(d_vdsats_d_cb*(1.0-ff)))+((two_n_phit*d_ff_d_cb)+(d_two_n_phit_d_cb*ff)));
d_vdsat_d_vto=(((vdsats*(-d_ff_d_vto))+(d_vdsats_d_vto*(1.0-ff)))+((two_n_phit*d_ff_d_vto)+(d_two_n_phit_d_vto*ff)));
d_vdsat_d_ss=(((vdsats*(-d_ff_d_ss))+(d_vdsats_d_ss*(1.0-ff)))+((two_n_phit*d_ff_d_ss)+(d_two_n_phit_d_ss*ff)));
d_vdsat_d_delta1=(((vdsats*(-d_ff_d_delta1))+(d_vdsats_d_delta1*(1.0-ff)))+((two_n_phit*d_ff_d_delta1)+(d_two_n_phit_d_delta1*ff)));
d_vdsat_d_delta2=(((vdsats*(-d_ff_d_delta2))+(d_vdsats_d_delta2*(1.0-ff)))+((two_n_phit*d_ff_d_delta2)+(d_two_n_phit_d_delta2*ff)));
d_vdsat_d_nd=(((vdsats*(-d_ff_d_nd))+(d_vdsats_d_nd*(1.0-ff)))+((two_n_phit*d_ff_d_nd)+(d_two_n_phit_d_nd*ff)));
d_vdsat_d_alpha=(((vdsats*(-d_ff_d_alpha))+(d_vdsats_d_alpha*(1.0-ff)))+((two_n_phit*d_ff_d_alpha)+(d_two_n_phit_d_alpha*ff)));
d_vdsat_d_vel0=(((vdsats*(-d_ff_d_vel0))+(d_vdsats_d_vel0*(1.0-ff)))+((two_n_phit*d_ff_d_vel0)+(d_two_n_phit_d_vel0*ff)));
d_vdsat_d_mu0=(((vdsats*(-d_ff_d_mu0))+(d_vdsats_d_mu0*(1.0-ff)))+((two_n_phit*d_ff_d_mu0)+(d_two_n_phit_d_mu0*ff)));
d_vdsat_d_beta=(((vdsats*(-d_ff_d_beta))+(d_vdsats_d_beta*(1.0-ff)))+((two_n_phit*d_ff_d_beta)+(d_two_n_phit_d_beta*ff)));
d_vdsat_d_mtheta=(((vdsats*(-d_ff_d_mtheta))+(d_vdsats_d_mtheta*(1.0-ff)))+((two_n_phit*d_ff_d_mtheta)+(d_two_n_phit_d_mtheta*ff)));
d_vdsat_d_vtheta=(((vdsats*(-d_ff_d_vtheta))+(d_vdsats_d_vtheta*(1.0-ff)))+((two_n_phit*d_ff_d_vtheta)+(d_two_n_phit_d_vtheta*ff)));
d_vdsat_d_vtzeta=(((vdsats*(-d_ff_d_vtzeta))+(d_vdsats_d_vtzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vtzeta)+(d_two_n_phit_d_vtzeta*ff)));
d_vdsat_d_dibsat=(((vdsats*(-d_ff_d_dibsat))+(d_vdsats_d_dibsat*(1.0-ff)))+((two_n_phit*d_ff_d_dibsat)+(d_two_n_phit_d_dibsat*ff)));
d_vdsat_d_epsilon=(((vdsats*(-d_ff_d_epsilon))+(d_vdsats_d_epsilon*(1.0-ff)))+((two_n_phit*d_ff_d_epsilon)+(d_two_n_phit_d_epsilon*ff)));
d_vdsat_d_vzeta=(((vdsats*(-d_ff_d_vzeta))+(d_vdsats_d_vzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vzeta)+(d_two_n_phit_d_vzeta*ff)));
d_vdsat_d_lambda=(((vdsats*(-d_ff_d_lambda))+(d_vdsats_d_lambda*(1.0-ff)))+((two_n_phit*d_ff_d_lambda)+(d_two_n_phit_d_lambda*ff)));
d_vdsat_d_ngf=(((vdsats*(-d_ff_d_ngf))+(d_vdsats_d_ngf*(1.0-ff)))+((two_n_phit*d_ff_d_ngf)+(d_two_n_phit_d_ngf*ff)));
d_vdsat_d_type=(((vdsats*(-d_ff_d_type))+(d_vdsats_d_type*(1.0-ff)))+((two_n_phit*d_ff_d_type)+(d_two_n_phit_d_type*ff)));
vdsat=((vdsats*(1.0-ff))+(two_n_phit*ff));
d_vdsat1_d_vgsin=(((vdsats1*(-d_ff_d_vgsin))+(d_vdsats1_d_vgsin*(1.0-ff)))+((two_n_phit*d_ff_d_vgsin)+(d_two_n_phit_d_vgsin*ff)));
d_vdsat1_d_vdsin=(((vdsats1*(-d_ff_d_vdsin))+(d_vdsats1_d_vdsin*(1.0-ff)))+((two_n_phit*d_ff_d_vdsin)+(d_two_n_phit_d_vdsin*ff)));
d_vdsat1_d_qcbflag=(((vdsats1*(-d_ff_d_qcbflag))+(d_vdsats1_d_qcbflag*(1.0-ff)))+((two_n_phit*d_ff_d_qcbflag)+(d_two_n_phit_d_qcbflag*ff)));
d_vdsat1_d_vcin=(((vdsats1*(-d_ff_d_vcin))+(d_vdsats1_d_vcin*(1.0-ff)))+((two_n_phit*d_ff_d_vcin)+(d_two_n_phit_d_vcin*ff)));
d_vdsat1_d_vbin=(((vdsats1*(-d_ff_d_vbin))+(d_vdsats1_d_vbin*(1.0-ff)))+((two_n_phit*d_ff_d_vbin)+(d_two_n_phit_d_vbin*ff)));
d_vdsat1_d_qgsflag=(((vdsats1*(-d_ff_d_qgsflag))+(d_vdsats1_d_qgsflag*(1.0-ff)))+((two_n_phit*d_ff_d_qgsflag)+(d_two_n_phit_d_qgsflag*ff)));
d_vdsat1_d_tambin=(((vdsats1*(-d_ff_d_tambin))+(d_vdsats1_d_tambin*(1.0-ff)))+((two_n_phit*d_ff_d_tambin)+(d_two_n_phit_d_tambin*ff)));
d_vdsat1_d_tnomin=(((vdsats1*(-d_ff_d_tnomin))+(d_vdsats1_d_tnomin*(1.0-ff)))+((two_n_phit*d_ff_d_tnomin)+(d_two_n_phit_d_tnomin*ff)));
d_vdsat1_d_phitin=(((vdsats1*(-d_ff_d_phitin))+(d_vdsats1_d_phitin*(1.0-ff)))+((two_n_phit*d_ff_d_phitin)+(d_two_n_phit_d_phitin*ff)));
d_vdsat1_d_w=(((vdsats1*(-d_ff_d_w))+(d_vdsats1_d_w*(1.0-ff)))+((two_n_phit*d_ff_d_w)+(d_two_n_phit_d_w*ff)));
d_vdsat1_d_lin=(((vdsats1*(-d_ff_d_lin))+(d_vdsats1_d_lin*(1.0-ff)))+((two_n_phit*d_ff_d_lin)+(d_two_n_phit_d_lin*ff)));
d_vdsat1_d_cgin=(((vdsats1*(-d_ff_d_cgin))+(d_vdsats1_d_cgin*(1.0-ff)))+((two_n_phit*d_ff_d_cgin)+(d_two_n_phit_d_cgin*ff)));
d_vdsat1_d_cs=(((vdsats1*(-d_ff_d_cs))+(d_vdsats1_d_cs*(1.0-ff)))+((two_n_phit*d_ff_d_cs)+(d_two_n_phit_d_cs*ff)));
d_vdsat1_d_cc=(((vdsats1*(-d_ff_d_cc))+(d_vdsats1_d_cc*(1.0-ff)))+((two_n_phit*d_ff_d_cc)+(d_two_n_phit_d_cc*ff)));
d_vdsat1_d_cb=(((vdsats1*(-d_ff_d_cb))+(d_vdsats1_d_cb*(1.0-ff)))+((two_n_phit*d_ff_d_cb)+(d_two_n_phit_d_cb*ff)));
d_vdsat1_d_vto=(((vdsats1*(-d_ff_d_vto))+(d_vdsats1_d_vto*(1.0-ff)))+((two_n_phit*d_ff_d_vto)+(d_two_n_phit_d_vto*ff)));
d_vdsat1_d_ss=(((vdsats1*(-d_ff_d_ss))+(d_vdsats1_d_ss*(1.0-ff)))+((two_n_phit*d_ff_d_ss)+(d_two_n_phit_d_ss*ff)));
d_vdsat1_d_delta1=(((vdsats1*(-d_ff_d_delta1))+(d_vdsats1_d_delta1*(1.0-ff)))+((two_n_phit*d_ff_d_delta1)+(d_two_n_phit_d_delta1*ff)));
d_vdsat1_d_delta2=(((vdsats1*(-d_ff_d_delta2))+(d_vdsats1_d_delta2*(1.0-ff)))+((two_n_phit*d_ff_d_delta2)+(d_two_n_phit_d_delta2*ff)));
d_vdsat1_d_nd=(((vdsats1*(-d_ff_d_nd))+(d_vdsats1_d_nd*(1.0-ff)))+((two_n_phit*d_ff_d_nd)+(d_two_n_phit_d_nd*ff)));
d_vdsat1_d_alpha=(((vdsats1*(-d_ff_d_alpha))+(d_vdsats1_d_alpha*(1.0-ff)))+((two_n_phit*d_ff_d_alpha)+(d_two_n_phit_d_alpha*ff)));
d_vdsat1_d_vel0=(((vdsats1*(-d_ff_d_vel0))+(d_vdsats1_d_vel0*(1.0-ff)))+((two_n_phit*d_ff_d_vel0)+(d_two_n_phit_d_vel0*ff)));
d_vdsat1_d_mu0=(((vdsats1*(-d_ff_d_mu0))+(d_vdsats1_d_mu0*(1.0-ff)))+((two_n_phit*d_ff_d_mu0)+(d_two_n_phit_d_mu0*ff)));
d_vdsat1_d_beta=(((vdsats1*(-d_ff_d_beta))+(d_vdsats1_d_beta*(1.0-ff)))+((two_n_phit*d_ff_d_beta)+(d_two_n_phit_d_beta*ff)));
d_vdsat1_d_mtheta=(((vdsats1*(-d_ff_d_mtheta))+(d_vdsats1_d_mtheta*(1.0-ff)))+((two_n_phit*d_ff_d_mtheta)+(d_two_n_phit_d_mtheta*ff)));
d_vdsat1_d_vtheta=(((vdsats1*(-d_ff_d_vtheta))+(d_vdsats1_d_vtheta*(1.0-ff)))+((two_n_phit*d_ff_d_vtheta)+(d_two_n_phit_d_vtheta*ff)));
d_vdsat1_d_vtzeta=(((vdsats1*(-d_ff_d_vtzeta))+(d_vdsats1_d_vtzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vtzeta)+(d_two_n_phit_d_vtzeta*ff)));
d_vdsat1_d_dibsat=(((vdsats1*(-d_ff_d_dibsat))+(d_vdsats1_d_dibsat*(1.0-ff)))+((two_n_phit*d_ff_d_dibsat)+(d_two_n_phit_d_dibsat*ff)));
d_vdsat1_d_epsilon=(((vdsats1*(-d_ff_d_epsilon))+(d_vdsats1_d_epsilon*(1.0-ff)))+((two_n_phit*d_ff_d_epsilon)+(d_two_n_phit_d_epsilon*ff)));
d_vdsat1_d_vzeta=(((vdsats1*(-d_ff_d_vzeta))+(d_vdsats1_d_vzeta*(1.0-ff)))+((two_n_phit*d_ff_d_vzeta)+(d_two_n_phit_d_vzeta*ff)));
d_vdsat1_d_lambda=(((vdsats1*(-d_ff_d_lambda))+(d_vdsats1_d_lambda*(1.0-ff)))+((two_n_phit*d_ff_d_lambda)+(d_two_n_phit_d_lambda*ff)));
d_vdsat1_d_ngf=(((vdsats1*(-d_ff_d_ngf))+(d_vdsats1_d_ngf*(1.0-ff)))+((two_n_phit*d_ff_d_ngf)+(d_two_n_phit_d_ngf*ff)));
d_vdsat1_d_type=(((vdsats1*(-d_ff_d_type))+(d_vdsats1_d_type*(1.0-ff)))+((two_n_phit*d_ff_d_type)+(d_two_n_phit_d_type*ff)));
vdsat1=((vdsats1*(1.0-ff))+(two_n_phit*ff));
d_fsd_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vgsin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,((vdsat1-(vdsin*d_vdsat1_d_vdsin))/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_qcbflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vcin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vbin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_qgsflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_tambin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_tnomin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_phitin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_w/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_lin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cgin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cs/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cc/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_cb/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vto/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_ss/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_delta1/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_delta2/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_nd/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_alpha/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vel0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_mu0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_beta/vdsat1/vdsat1))+((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(log(mmax( static_cast<double>(0),(vdsin/vdsat1))*pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_mtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vtzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_dibsat/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_epsilon/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_vzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_lambda/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_ngf/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_fsd_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat1))))*d_mmax( static_cast<double>(0),(vdsin/vdsat1),0.0,(-vdsin*d_vdsat1_d_type/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
fsd=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat1)),beta)),(1.0/beta)));
d_vdx_d_vgsin=(vdsin*d_fsd_d_vgsin);
d_vdx_d_vdsin=(vdsin*d_fsd_d_vdsin+fsd);
d_vdx_d_qcbflag=(vdsin*d_fsd_d_qcbflag);
d_vdx_d_vcin=(vdsin*d_fsd_d_vcin);
d_vdx_d_vbin=(vdsin*d_fsd_d_vbin);
d_vdx_d_qgsflag=(vdsin*d_fsd_d_qgsflag);
d_vdx_d_tambin=(vdsin*d_fsd_d_tambin);
d_vdx_d_tnomin=(vdsin*d_fsd_d_tnomin);
d_vdx_d_phitin=(vdsin*d_fsd_d_phitin);
d_vdx_d_w=(vdsin*d_fsd_d_w);
d_vdx_d_lin=(vdsin*d_fsd_d_lin);
d_vdx_d_cgin=(vdsin*d_fsd_d_cgin);
d_vdx_d_cs=(vdsin*d_fsd_d_cs);
d_vdx_d_cc=(vdsin*d_fsd_d_cc);
d_vdx_d_cb=(vdsin*d_fsd_d_cb);
d_vdx_d_vto=(vdsin*d_fsd_d_vto);
d_vdx_d_ss=(vdsin*d_fsd_d_ss);
d_vdx_d_delta1=(vdsin*d_fsd_d_delta1);
d_vdx_d_delta2=(vdsin*d_fsd_d_delta2);
d_vdx_d_nd=(vdsin*d_fsd_d_nd);
d_vdx_d_alpha=(vdsin*d_fsd_d_alpha);
d_vdx_d_vel0=(vdsin*d_fsd_d_vel0);
d_vdx_d_mu0=(vdsin*d_fsd_d_mu0);
d_vdx_d_beta=(vdsin*d_fsd_d_beta);
d_vdx_d_mtheta=(vdsin*d_fsd_d_mtheta);
d_vdx_d_vtheta=(vdsin*d_fsd_d_vtheta);
d_vdx_d_vtzeta=(vdsin*d_fsd_d_vtzeta);
d_vdx_d_dibsat=(vdsin*d_fsd_d_dibsat);
d_vdx_d_epsilon=(vdsin*d_fsd_d_epsilon);
d_vdx_d_vzeta=(vdsin*d_fsd_d_vzeta);
d_vdx_d_lambda=(vdsin*d_fsd_d_lambda);
d_vdx_d_ngf=(vdsin*d_fsd_d_ngf);
d_vdx_d_type=(vdsin*d_fsd_d_type);
vdx=(vdsin*fsd);
d_fds_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vgsin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,((vdsat1*(-1.0)-(-vdsin)*d_vdsat1_d_vdsin)/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_qcbflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vcin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vbin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_qgsflag/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_tambin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_tnomin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_phitin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_w/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_lin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cgin/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cs/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cc/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_cb/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vto/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_ss/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_delta1/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_delta2/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_nd/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_alpha/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vel0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_mu0/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_beta/vdsat1/vdsat1))+((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(log(mmax( static_cast<double>(0),((-vdsin)/vdsat1))*pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_mtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vtheta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vtzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_dibsat/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_epsilon/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_vzeta/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_lambda/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_ngf/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_fds_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat1))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat1))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat1),0.0,(-(-vdsin)*d_vdsat1_d_type/vdsat1/vdsat1))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
fds=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat1)),beta)),(1.0/beta)));
d_vsx_d_vgsin=((-vdsin)*d_fds_d_vgsin);
d_vsx_d_vdsin=(((-vdsin)*d_fds_d_vdsin)+((-1.0)*fds));
d_vsx_d_qcbflag=((-vdsin)*d_fds_d_qcbflag);
d_vsx_d_vcin=((-vdsin)*d_fds_d_vcin);
d_vsx_d_vbin=((-vdsin)*d_fds_d_vbin);
d_vsx_d_qgsflag=((-vdsin)*d_fds_d_qgsflag);
d_vsx_d_tambin=((-vdsin)*d_fds_d_tambin);
d_vsx_d_tnomin=((-vdsin)*d_fds_d_tnomin);
d_vsx_d_phitin=((-vdsin)*d_fds_d_phitin);
d_vsx_d_w=((-vdsin)*d_fds_d_w);
d_vsx_d_lin=((-vdsin)*d_fds_d_lin);
d_vsx_d_cgin=((-vdsin)*d_fds_d_cgin);
d_vsx_d_cs=((-vdsin)*d_fds_d_cs);
d_vsx_d_cc=((-vdsin)*d_fds_d_cc);
d_vsx_d_cb=((-vdsin)*d_fds_d_cb);
d_vsx_d_vto=((-vdsin)*d_fds_d_vto);
d_vsx_d_ss=((-vdsin)*d_fds_d_ss);
d_vsx_d_delta1=((-vdsin)*d_fds_d_delta1);
d_vsx_d_delta2=((-vdsin)*d_fds_d_delta2);
d_vsx_d_nd=((-vdsin)*d_fds_d_nd);
d_vsx_d_alpha=((-vdsin)*d_fds_d_alpha);
d_vsx_d_vel0=((-vdsin)*d_fds_d_vel0);
d_vsx_d_mu0=((-vdsin)*d_fds_d_mu0);
d_vsx_d_beta=((-vdsin)*d_fds_d_beta);
d_vsx_d_mtheta=((-vdsin)*d_fds_d_mtheta);
d_vsx_d_vtheta=((-vdsin)*d_fds_d_vtheta);
d_vsx_d_vtzeta=((-vdsin)*d_fds_d_vtzeta);
d_vsx_d_dibsat=((-vdsin)*d_fds_d_dibsat);
d_vsx_d_epsilon=((-vdsin)*d_fds_d_epsilon);
d_vsx_d_vzeta=((-vdsin)*d_fds_d_vzeta);
d_vsx_d_lambda=((-vdsin)*d_fds_d_lambda);
d_vsx_d_ngf=((-vdsin)*d_fds_d_ngf);
d_vsx_d_type=((-vdsin)*d_fds_d_type);
vsx=((-vdsin)*fds);
d_exparg_d_vgsin=((alpha_phit*(1.0-d_myarg_d_vgsin)-(vgsin-myarg)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg_d_vdsin=((alpha_phit*(-d_myarg_d_vdsin)-(vgsin-myarg)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg_d_qcbflag=((alpha_phit*(-d_myarg_d_qcbflag)-(vgsin-myarg)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg_d_vcin=((alpha_phit*(-d_myarg_d_vcin)-(vgsin-myarg)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg_d_vbin=((alpha_phit*(-d_myarg_d_vbin)-(vgsin-myarg)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg_d_qgsflag=((alpha_phit*(-d_myarg_d_qgsflag)-(vgsin-myarg)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg_d_tambin=((alpha_phit*(-d_myarg_d_tambin)-(vgsin-myarg)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg_d_tnomin=((alpha_phit*(-d_myarg_d_tnomin)-(vgsin-myarg)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg_d_phitin=((alpha_phit*(-d_myarg_d_phitin)-(vgsin-myarg)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg_d_w=((alpha_phit*(-d_myarg_d_w)-(vgsin-myarg)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg_d_lin=((alpha_phit*(-d_myarg_d_lin)-(vgsin-myarg)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg_d_cgin=((alpha_phit*(-d_myarg_d_cgin)-(vgsin-myarg)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg_d_cs=((alpha_phit*(-d_myarg_d_cs)-(vgsin-myarg)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg_d_cc=((alpha_phit*(-d_myarg_d_cc)-(vgsin-myarg)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg_d_cb=((alpha_phit*(-d_myarg_d_cb)-(vgsin-myarg)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg_d_vto=((alpha_phit*(-d_myarg_d_vto)-(vgsin-myarg)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg_d_ss=((alpha_phit*(-d_myarg_d_ss)-(vgsin-myarg)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg_d_delta1=((alpha_phit*(-d_myarg_d_delta1)-(vgsin-myarg)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg_d_delta2=((alpha_phit*(-d_myarg_d_delta2)-(vgsin-myarg)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg_d_nd=((alpha_phit*(-d_myarg_d_nd)-(vgsin-myarg)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg_d_alpha=((alpha_phit*(-d_myarg_d_alpha)-(vgsin-myarg)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg_d_vel0=((alpha_phit*(-d_myarg_d_vel0)-(vgsin-myarg)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg_d_mu0=((alpha_phit*(-d_myarg_d_mu0)-(vgsin-myarg)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg_d_beta=((alpha_phit*(-d_myarg_d_beta)-(vgsin-myarg)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg_d_mtheta=((alpha_phit*(-d_myarg_d_mtheta)-(vgsin-myarg)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtheta=((alpha_phit*(-d_myarg_d_vtheta)-(vgsin-myarg)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtzeta=((alpha_phit*(-d_myarg_d_vtzeta)-(vgsin-myarg)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg_d_dibsat=((alpha_phit*(-d_myarg_d_dibsat)-(vgsin-myarg)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg_d_epsilon=((alpha_phit*(-d_myarg_d_epsilon)-(vgsin-myarg)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg_d_vzeta=((alpha_phit*(-d_myarg_d_vzeta)-(vgsin-myarg)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg_d_lambda=((alpha_phit*(-d_myarg_d_lambda)-(vgsin-myarg)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg_d_ngf=((alpha_phit*(-d_myarg_d_ngf)-(vgsin-myarg)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg_d_type=((alpha_phit*(-d_myarg_d_type)-(vgsin-myarg)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg=((vgsin-myarg)/alpha_phit);
if((exparg>50.0))
{
d_ffs_d_vgsin=0.0;
d_ffs_d_vdsin=0.0;
d_ffs_d_qcbflag=0.0;
d_ffs_d_vcin=0.0;
d_ffs_d_vbin=0.0;
d_ffs_d_qgsflag=0.0;
d_ffs_d_tambin=0.0;
d_ffs_d_tnomin=0.0;
d_ffs_d_phitin=0.0;
d_ffs_d_w=0.0;
d_ffs_d_lin=0.0;
d_ffs_d_cgin=0.0;
d_ffs_d_cs=0.0;
d_ffs_d_cc=0.0;
d_ffs_d_cb=0.0;
d_ffs_d_vto=0.0;
d_ffs_d_ss=0.0;
d_ffs_d_delta1=0.0;
d_ffs_d_delta2=0.0;
d_ffs_d_nd=0.0;
d_ffs_d_alpha=0.0;
d_ffs_d_vel0=0.0;
d_ffs_d_mu0=0.0;
d_ffs_d_beta=0.0;
d_ffs_d_mtheta=0.0;
d_ffs_d_vtheta=0.0;
d_ffs_d_vtzeta=0.0;
d_ffs_d_dibsat=0.0;
d_ffs_d_epsilon=0.0;
d_ffs_d_vzeta=0.0;
d_ffs_d_lambda=0.0;
d_ffs_d_ngf=0.0;
d_ffs_d_type=0.0;
ffs=0.0;
}
else
{
if((exparg<(-50.0)))
{
d_ffs_d_vgsin=0.0;
d_ffs_d_vdsin=0.0;
d_ffs_d_qcbflag=0.0;
d_ffs_d_vcin=0.0;
d_ffs_d_vbin=0.0;
d_ffs_d_qgsflag=0.0;
d_ffs_d_tambin=0.0;
d_ffs_d_tnomin=0.0;
d_ffs_d_phitin=0.0;
d_ffs_d_w=0.0;
d_ffs_d_lin=0.0;
d_ffs_d_cgin=0.0;
d_ffs_d_cs=0.0;
d_ffs_d_cc=0.0;
d_ffs_d_cb=0.0;
d_ffs_d_vto=0.0;
d_ffs_d_ss=0.0;
d_ffs_d_delta1=0.0;
d_ffs_d_delta2=0.0;
d_ffs_d_nd=0.0;
d_ffs_d_alpha=0.0;
d_ffs_d_vel0=0.0;
d_ffs_d_mu0=0.0;
d_ffs_d_beta=0.0;
d_ffs_d_mtheta=0.0;
d_ffs_d_vtheta=0.0;
d_ffs_d_vtzeta=0.0;
d_ffs_d_dibsat=0.0;
d_ffs_d_epsilon=0.0;
d_ffs_d_vzeta=0.0;
d_ffs_d_lambda=0.0;
d_ffs_d_ngf=0.0;
d_ffs_d_type=0.0;
ffs=1.0;
}
else
{
d_ffs_d_vgsin=(-exp(exparg)*d_exparg_d_vgsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vdsin=(-exp(exparg)*d_exparg_d_vdsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_qcbflag=(-exp(exparg)*d_exparg_d_qcbflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vcin=(-exp(exparg)*d_exparg_d_vcin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vbin=(-exp(exparg)*d_exparg_d_vbin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_qgsflag=(-exp(exparg)*d_exparg_d_qgsflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_tambin=(-exp(exparg)*d_exparg_d_tambin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_tnomin=(-exp(exparg)*d_exparg_d_tnomin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_phitin=(-exp(exparg)*d_exparg_d_phitin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_w=(-exp(exparg)*d_exparg_d_w/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_lin=(-exp(exparg)*d_exparg_d_lin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cgin=(-exp(exparg)*d_exparg_d_cgin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cs=(-exp(exparg)*d_exparg_d_cs/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cc=(-exp(exparg)*d_exparg_d_cc/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_cb=(-exp(exparg)*d_exparg_d_cb/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vto=(-exp(exparg)*d_exparg_d_vto/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_ss=(-exp(exparg)*d_exparg_d_ss/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_delta1=(-exp(exparg)*d_exparg_d_delta1/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_delta2=(-exp(exparg)*d_exparg_d_delta2/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_nd=(-exp(exparg)*d_exparg_d_nd/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_alpha=(-exp(exparg)*d_exparg_d_alpha/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vel0=(-exp(exparg)*d_exparg_d_vel0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_mu0=(-exp(exparg)*d_exparg_d_mu0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_beta=(-exp(exparg)*d_exparg_d_beta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_mtheta=(-exp(exparg)*d_exparg_d_mtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vtheta=(-exp(exparg)*d_exparg_d_vtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vtzeta=(-exp(exparg)*d_exparg_d_vtzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_dibsat=(-exp(exparg)*d_exparg_d_dibsat/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_epsilon=(-exp(exparg)*d_exparg_d_epsilon/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_vzeta=(-exp(exparg)*d_exparg_d_vzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_lambda=(-exp(exparg)*d_exparg_d_lambda/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_ngf=(-exp(exparg)*d_exparg_d_ngf/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffs_d_type=(-exp(exparg)*d_exparg_d_type/(1.0+exp(exparg))/(1.0+exp(exparg)));
ffs=(1.0/(1.0+exp(exparg)));
}
}
d_etas_d_vgsin=((two_n_phit*((d_vgdin_d_vgsin-d_vsx_d_vgsin)-(d_vtdibl_d_vgsin-(((0.1*alpha_phit)*d_ffs_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vgsin)/two_n_phit/two_n_phit);
d_etas_d_vdsin=((two_n_phit*((d_vgdin_d_vdsin-d_vsx_d_vdsin)-(d_vtdibl_d_vdsin-(((0.1*alpha_phit)*d_ffs_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vdsin)/two_n_phit/two_n_phit);
d_etas_d_qcbflag=((two_n_phit*((d_vgdin_d_qcbflag-d_vsx_d_qcbflag)-(d_vtdibl_d_qcbflag-(((0.1*alpha_phit)*d_ffs_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_qcbflag)/two_n_phit/two_n_phit);
d_etas_d_vcin=((two_n_phit*((d_vgdin_d_vcin-d_vsx_d_vcin)-(d_vtdibl_d_vcin-(((0.1*alpha_phit)*d_ffs_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vcin)/two_n_phit/two_n_phit);
d_etas_d_vbin=((two_n_phit*((d_vgdin_d_vbin-d_vsx_d_vbin)-(d_vtdibl_d_vbin-(((0.1*alpha_phit)*d_ffs_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vbin)/two_n_phit/two_n_phit);
d_etas_d_qgsflag=((two_n_phit*((d_vgdin_d_qgsflag-d_vsx_d_qgsflag)-(d_vtdibl_d_qgsflag-(((0.1*alpha_phit)*d_ffs_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_qgsflag)/two_n_phit/two_n_phit);
d_etas_d_tambin=((two_n_phit*((d_vgdin_d_tambin-d_vsx_d_tambin)-(d_vtdibl_d_tambin-(((0.1*alpha_phit)*d_ffs_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_tambin)/two_n_phit/two_n_phit);
d_etas_d_tnomin=((two_n_phit*((d_vgdin_d_tnomin-d_vsx_d_tnomin)-(d_vtdibl_d_tnomin-(((0.1*alpha_phit)*d_ffs_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_tnomin)/two_n_phit/two_n_phit);
d_etas_d_phitin=((two_n_phit*((d_vgdin_d_phitin-d_vsx_d_phitin)-(d_vtdibl_d_phitin-(((0.1*alpha_phit)*d_ffs_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_phitin)/two_n_phit/two_n_phit);
d_etas_d_w=((two_n_phit*((d_vgdin_d_w-d_vsx_d_w)-(d_vtdibl_d_w-(((0.1*alpha_phit)*d_ffs_d_w)+((0.1*d_alpha_phit_d_w)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_w)/two_n_phit/two_n_phit);
d_etas_d_lin=((two_n_phit*((d_vgdin_d_lin-d_vsx_d_lin)-(d_vtdibl_d_lin-(((0.1*alpha_phit)*d_ffs_d_lin)+((0.1*d_alpha_phit_d_lin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_lin)/two_n_phit/two_n_phit);
d_etas_d_cgin=((two_n_phit*((d_vgdin_d_cgin-d_vsx_d_cgin)-(d_vtdibl_d_cgin-(((0.1*alpha_phit)*d_ffs_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cgin)/two_n_phit/two_n_phit);
d_etas_d_cs=((two_n_phit*((d_vgdin_d_cs-d_vsx_d_cs)-(d_vtdibl_d_cs-(((0.1*alpha_phit)*d_ffs_d_cs)+((0.1*d_alpha_phit_d_cs)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cs)/two_n_phit/two_n_phit);
d_etas_d_cc=((two_n_phit*((d_vgdin_d_cc-d_vsx_d_cc)-(d_vtdibl_d_cc-(((0.1*alpha_phit)*d_ffs_d_cc)+((0.1*d_alpha_phit_d_cc)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cc)/two_n_phit/two_n_phit);
d_etas_d_cb=((two_n_phit*((d_vgdin_d_cb-d_vsx_d_cb)-(d_vtdibl_d_cb-(((0.1*alpha_phit)*d_ffs_d_cb)+((0.1*d_alpha_phit_d_cb)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_cb)/two_n_phit/two_n_phit);
d_etas_d_vto=((two_n_phit*((d_vgdin_d_vto-d_vsx_d_vto)-(d_vtdibl_d_vto-(((0.1*alpha_phit)*d_ffs_d_vto)+((0.1*d_alpha_phit_d_vto)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vto)/two_n_phit/two_n_phit);
d_etas_d_ss=((two_n_phit*((d_vgdin_d_ss-d_vsx_d_ss)-(d_vtdibl_d_ss-(((0.1*alpha_phit)*d_ffs_d_ss)+((0.1*d_alpha_phit_d_ss)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_ss)/two_n_phit/two_n_phit);
d_etas_d_delta1=((two_n_phit*((d_vgdin_d_delta1-d_vsx_d_delta1)-(d_vtdibl_d_delta1-(((0.1*alpha_phit)*d_ffs_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_delta1)/two_n_phit/two_n_phit);
d_etas_d_delta2=((two_n_phit*((d_vgdin_d_delta2-d_vsx_d_delta2)-(d_vtdibl_d_delta2-(((0.1*alpha_phit)*d_ffs_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_delta2)/two_n_phit/two_n_phit);
d_etas_d_nd=((two_n_phit*((d_vgdin_d_nd-d_vsx_d_nd)-(d_vtdibl_d_nd-(((0.1*alpha_phit)*d_ffs_d_nd)+((0.1*d_alpha_phit_d_nd)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_nd)/two_n_phit/two_n_phit);
d_etas_d_alpha=((two_n_phit*((d_vgdin_d_alpha-d_vsx_d_alpha)-(d_vtdibl_d_alpha-(((0.1*alpha_phit)*d_ffs_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_alpha)/two_n_phit/two_n_phit);
d_etas_d_vel0=((two_n_phit*((d_vgdin_d_vel0-d_vsx_d_vel0)-(d_vtdibl_d_vel0-(((0.1*alpha_phit)*d_ffs_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vel0)/two_n_phit/two_n_phit);
d_etas_d_mu0=((two_n_phit*((d_vgdin_d_mu0-d_vsx_d_mu0)-(d_vtdibl_d_mu0-(((0.1*alpha_phit)*d_ffs_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_mu0)/two_n_phit/two_n_phit);
d_etas_d_beta=((two_n_phit*((d_vgdin_d_beta-d_vsx_d_beta)-(d_vtdibl_d_beta-(((0.1*alpha_phit)*d_ffs_d_beta)+((0.1*d_alpha_phit_d_beta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_beta)/two_n_phit/two_n_phit);
d_etas_d_mtheta=((two_n_phit*((d_vgdin_d_mtheta-d_vsx_d_mtheta)-(d_vtdibl_d_mtheta-(((0.1*alpha_phit)*d_ffs_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_mtheta)/two_n_phit/two_n_phit);
d_etas_d_vtheta=((two_n_phit*((d_vgdin_d_vtheta-d_vsx_d_vtheta)-(d_vtdibl_d_vtheta-(((0.1*alpha_phit)*d_ffs_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vtheta)/two_n_phit/two_n_phit);
d_etas_d_vtzeta=((two_n_phit*((d_vgdin_d_vtzeta-d_vsx_d_vtzeta)-(d_vtdibl_d_vtzeta-(((0.1*alpha_phit)*d_ffs_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vtzeta)/two_n_phit/two_n_phit);
d_etas_d_dibsat=((two_n_phit*((d_vgdin_d_dibsat-d_vsx_d_dibsat)-(d_vtdibl_d_dibsat-(((0.1*alpha_phit)*d_ffs_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_dibsat)/two_n_phit/two_n_phit);
d_etas_d_epsilon=((two_n_phit*((d_vgdin_d_epsilon-d_vsx_d_epsilon)-(d_vtdibl_d_epsilon-(((0.1*alpha_phit)*d_ffs_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_epsilon)/two_n_phit/two_n_phit);
d_etas_d_vzeta=((two_n_phit*((d_vgdin_d_vzeta-d_vsx_d_vzeta)-(d_vtdibl_d_vzeta-(((0.1*alpha_phit)*d_ffs_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_vzeta)/two_n_phit/two_n_phit);
d_etas_d_lambda=((two_n_phit*((d_vgdin_d_lambda-d_vsx_d_lambda)-(d_vtdibl_d_lambda-(((0.1*alpha_phit)*d_ffs_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_lambda)/two_n_phit/two_n_phit);
d_etas_d_ngf=((two_n_phit*((d_vgdin_d_ngf-d_vsx_d_ngf)-(d_vtdibl_d_ngf-(((0.1*alpha_phit)*d_ffs_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_ngf)/two_n_phit/two_n_phit);
d_etas_d_type=((two_n_phit*((d_vgdin_d_type-d_vsx_d_type)-(d_vtdibl_d_type-(((0.1*alpha_phit)*d_ffs_d_type)+((0.1*d_alpha_phit_d_type)*ffs))))-((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))*d_two_n_phit_d_type)/two_n_phit/two_n_phit);
etas=(((vgdin-vsx)-(vtdibl-((0.1*alpha_phit)*ffs)))/two_n_phit);
if((etas>50.0))
{
d_qinvs_d_vgsin=((qref*d_etas_d_vgsin)+(d_qref_d_vgsin*etas));
d_qinvs_d_vdsin=((qref*d_etas_d_vdsin)+(d_qref_d_vdsin*etas));
d_qinvs_d_qcbflag=((qref*d_etas_d_qcbflag)+(d_qref_d_qcbflag*etas));
d_qinvs_d_vcin=((qref*d_etas_d_vcin)+(d_qref_d_vcin*etas));
d_qinvs_d_vbin=((qref*d_etas_d_vbin)+(d_qref_d_vbin*etas));
d_qinvs_d_qgsflag=((qref*d_etas_d_qgsflag)+(d_qref_d_qgsflag*etas));
d_qinvs_d_tambin=((qref*d_etas_d_tambin)+(d_qref_d_tambin*etas));
d_qinvs_d_tnomin=((qref*d_etas_d_tnomin)+(d_qref_d_tnomin*etas));
d_qinvs_d_phitin=((qref*d_etas_d_phitin)+(d_qref_d_phitin*etas));
d_qinvs_d_w=((qref*d_etas_d_w)+(d_qref_d_w*etas));
d_qinvs_d_lin=((qref*d_etas_d_lin)+(d_qref_d_lin*etas));
d_qinvs_d_cgin=((qref*d_etas_d_cgin)+(d_qref_d_cgin*etas));
d_qinvs_d_cs=((qref*d_etas_d_cs)+(d_qref_d_cs*etas));
d_qinvs_d_cc=((qref*d_etas_d_cc)+(d_qref_d_cc*etas));
d_qinvs_d_cb=((qref*d_etas_d_cb)+(d_qref_d_cb*etas));
d_qinvs_d_vto=((qref*d_etas_d_vto)+(d_qref_d_vto*etas));
d_qinvs_d_ss=((qref*d_etas_d_ss)+(d_qref_d_ss*etas));
d_qinvs_d_delta1=((qref*d_etas_d_delta1)+(d_qref_d_delta1*etas));
d_qinvs_d_delta2=((qref*d_etas_d_delta2)+(d_qref_d_delta2*etas));
d_qinvs_d_nd=((qref*d_etas_d_nd)+(d_qref_d_nd*etas));
d_qinvs_d_alpha=((qref*d_etas_d_alpha)+(d_qref_d_alpha*etas));
d_qinvs_d_vel0=((qref*d_etas_d_vel0)+(d_qref_d_vel0*etas));
d_qinvs_d_mu0=((qref*d_etas_d_mu0)+(d_qref_d_mu0*etas));
d_qinvs_d_beta=((qref*d_etas_d_beta)+(d_qref_d_beta*etas));
d_qinvs_d_mtheta=((qref*d_etas_d_mtheta)+(d_qref_d_mtheta*etas));
d_qinvs_d_vtheta=((qref*d_etas_d_vtheta)+(d_qref_d_vtheta*etas));
d_qinvs_d_vtzeta=((qref*d_etas_d_vtzeta)+(d_qref_d_vtzeta*etas));
d_qinvs_d_dibsat=((qref*d_etas_d_dibsat)+(d_qref_d_dibsat*etas));
d_qinvs_d_epsilon=((qref*d_etas_d_epsilon)+(d_qref_d_epsilon*etas));
d_qinvs_d_vzeta=((qref*d_etas_d_vzeta)+(d_qref_d_vzeta*etas));
d_qinvs_d_lambda=((qref*d_etas_d_lambda)+(d_qref_d_lambda*etas));
d_qinvs_d_ngf=((qref*d_etas_d_ngf)+(d_qref_d_ngf*etas));
d_qinvs_d_type=((qref*d_etas_d_type)+(d_qref_d_type*etas));
qinvs=(qref*etas);
}
else
{
if((etas<(-50.0)))
{
d_qinvs_d_vgsin=0.0;
d_qinvs_d_vdsin=0.0;
d_qinvs_d_qcbflag=0.0;
d_qinvs_d_vcin=0.0;
d_qinvs_d_vbin=0.0;
d_qinvs_d_qgsflag=0.0;
d_qinvs_d_tambin=0.0;
d_qinvs_d_tnomin=0.0;
d_qinvs_d_phitin=0.0;
d_qinvs_d_w=0.0;
d_qinvs_d_lin=0.0;
d_qinvs_d_cgin=0.0;
d_qinvs_d_cs=0.0;
d_qinvs_d_cc=0.0;
d_qinvs_d_cb=0.0;
d_qinvs_d_vto=0.0;
d_qinvs_d_ss=0.0;
d_qinvs_d_delta1=0.0;
d_qinvs_d_delta2=0.0;
d_qinvs_d_nd=0.0;
d_qinvs_d_alpha=0.0;
d_qinvs_d_vel0=0.0;
d_qinvs_d_mu0=0.0;
d_qinvs_d_beta=0.0;
d_qinvs_d_mtheta=0.0;
d_qinvs_d_vtheta=0.0;
d_qinvs_d_vtzeta=0.0;
d_qinvs_d_dibsat=0.0;
d_qinvs_d_epsilon=0.0;
d_qinvs_d_vzeta=0.0;
d_qinvs_d_lambda=0.0;
d_qinvs_d_ngf=0.0;
d_qinvs_d_type=0.0;
qinvs=0;
}
else
{
d_qinvs_d_vgsin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vgsin)+(d_qref_d_vgsin*log((1.0+exp(etas)))));
d_qinvs_d_vdsin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vdsin)+(d_qref_d_vdsin*log((1.0+exp(etas)))));
d_qinvs_d_qcbflag=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_qcbflag)+(d_qref_d_qcbflag*log((1.0+exp(etas)))));
d_qinvs_d_vcin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vcin)+(d_qref_d_vcin*log((1.0+exp(etas)))));
d_qinvs_d_vbin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vbin)+(d_qref_d_vbin*log((1.0+exp(etas)))));
d_qinvs_d_qgsflag=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_qgsflag)+(d_qref_d_qgsflag*log((1.0+exp(etas)))));
d_qinvs_d_tambin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_tambin)+(d_qref_d_tambin*log((1.0+exp(etas)))));
d_qinvs_d_tnomin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_tnomin)+(d_qref_d_tnomin*log((1.0+exp(etas)))));
d_qinvs_d_phitin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_phitin)+(d_qref_d_phitin*log((1.0+exp(etas)))));
d_qinvs_d_w=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_w)+(d_qref_d_w*log((1.0+exp(etas)))));
d_qinvs_d_lin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_lin)+(d_qref_d_lin*log((1.0+exp(etas)))));
d_qinvs_d_cgin=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cgin)+(d_qref_d_cgin*log((1.0+exp(etas)))));
d_qinvs_d_cs=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cs)+(d_qref_d_cs*log((1.0+exp(etas)))));
d_qinvs_d_cc=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cc)+(d_qref_d_cc*log((1.0+exp(etas)))));
d_qinvs_d_cb=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_cb)+(d_qref_d_cb*log((1.0+exp(etas)))));
d_qinvs_d_vto=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vto)+(d_qref_d_vto*log((1.0+exp(etas)))));
d_qinvs_d_ss=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_ss)+(d_qref_d_ss*log((1.0+exp(etas)))));
d_qinvs_d_delta1=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_delta1)+(d_qref_d_delta1*log((1.0+exp(etas)))));
d_qinvs_d_delta2=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_delta2)+(d_qref_d_delta2*log((1.0+exp(etas)))));
d_qinvs_d_nd=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_nd)+(d_qref_d_nd*log((1.0+exp(etas)))));
d_qinvs_d_alpha=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_alpha)+(d_qref_d_alpha*log((1.0+exp(etas)))));
d_qinvs_d_vel0=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vel0)+(d_qref_d_vel0*log((1.0+exp(etas)))));
d_qinvs_d_mu0=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_mu0)+(d_qref_d_mu0*log((1.0+exp(etas)))));
d_qinvs_d_beta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_beta)+(d_qref_d_beta*log((1.0+exp(etas)))));
d_qinvs_d_mtheta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_mtheta)+(d_qref_d_mtheta*log((1.0+exp(etas)))));
d_qinvs_d_vtheta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vtheta)+(d_qref_d_vtheta*log((1.0+exp(etas)))));
d_qinvs_d_vtzeta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vtzeta)+(d_qref_d_vtzeta*log((1.0+exp(etas)))));
d_qinvs_d_dibsat=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_dibsat)+(d_qref_d_dibsat*log((1.0+exp(etas)))));
d_qinvs_d_epsilon=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_epsilon)+(d_qref_d_epsilon*log((1.0+exp(etas)))));
d_qinvs_d_vzeta=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_vzeta)+(d_qref_d_vzeta*log((1.0+exp(etas)))));
d_qinvs_d_lambda=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_lambda)+(d_qref_d_lambda*log((1.0+exp(etas)))));
d_qinvs_d_ngf=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_ngf)+(d_qref_d_ngf*log((1.0+exp(etas)))));
d_qinvs_d_type=((qref*(1.0/(1.0+exp(etas)))*exp(etas)*d_etas_d_type)+(d_qref_d_type*log((1.0+exp(etas)))));
qinvs=(qref*log((1.0+exp(etas))));
}
}
d_exparg_d_vgsin=((alpha_phit*(d_vgdin_d_vgsin-d_myarg_d_vgsin)-(vgdin-myarg)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg_d_vdsin=((alpha_phit*(d_vgdin_d_vdsin-d_myarg_d_vdsin)-(vgdin-myarg)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg_d_qcbflag=((alpha_phit*(d_vgdin_d_qcbflag-d_myarg_d_qcbflag)-(vgdin-myarg)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg_d_vcin=((alpha_phit*(d_vgdin_d_vcin-d_myarg_d_vcin)-(vgdin-myarg)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg_d_vbin=((alpha_phit*(d_vgdin_d_vbin-d_myarg_d_vbin)-(vgdin-myarg)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg_d_qgsflag=((alpha_phit*(d_vgdin_d_qgsflag-d_myarg_d_qgsflag)-(vgdin-myarg)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg_d_tambin=((alpha_phit*(d_vgdin_d_tambin-d_myarg_d_tambin)-(vgdin-myarg)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg_d_tnomin=((alpha_phit*(d_vgdin_d_tnomin-d_myarg_d_tnomin)-(vgdin-myarg)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg_d_phitin=((alpha_phit*(d_vgdin_d_phitin-d_myarg_d_phitin)-(vgdin-myarg)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg_d_w=((alpha_phit*(d_vgdin_d_w-d_myarg_d_w)-(vgdin-myarg)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg_d_lin=((alpha_phit*(d_vgdin_d_lin-d_myarg_d_lin)-(vgdin-myarg)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg_d_cgin=((alpha_phit*(d_vgdin_d_cgin-d_myarg_d_cgin)-(vgdin-myarg)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg_d_cs=((alpha_phit*(d_vgdin_d_cs-d_myarg_d_cs)-(vgdin-myarg)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg_d_cc=((alpha_phit*(d_vgdin_d_cc-d_myarg_d_cc)-(vgdin-myarg)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg_d_cb=((alpha_phit*(d_vgdin_d_cb-d_myarg_d_cb)-(vgdin-myarg)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg_d_vto=((alpha_phit*(d_vgdin_d_vto-d_myarg_d_vto)-(vgdin-myarg)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg_d_ss=((alpha_phit*(d_vgdin_d_ss-d_myarg_d_ss)-(vgdin-myarg)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg_d_delta1=((alpha_phit*(d_vgdin_d_delta1-d_myarg_d_delta1)-(vgdin-myarg)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg_d_delta2=((alpha_phit*(d_vgdin_d_delta2-d_myarg_d_delta2)-(vgdin-myarg)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg_d_nd=((alpha_phit*(d_vgdin_d_nd-d_myarg_d_nd)-(vgdin-myarg)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg_d_alpha=((alpha_phit*(d_vgdin_d_alpha-d_myarg_d_alpha)-(vgdin-myarg)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg_d_vel0=((alpha_phit*(d_vgdin_d_vel0-d_myarg_d_vel0)-(vgdin-myarg)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg_d_mu0=((alpha_phit*(d_vgdin_d_mu0-d_myarg_d_mu0)-(vgdin-myarg)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg_d_beta=((alpha_phit*(d_vgdin_d_beta-d_myarg_d_beta)-(vgdin-myarg)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg_d_mtheta=((alpha_phit*(d_vgdin_d_mtheta-d_myarg_d_mtheta)-(vgdin-myarg)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtheta=((alpha_phit*(d_vgdin_d_vtheta-d_myarg_d_vtheta)-(vgdin-myarg)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg_d_vtzeta=((alpha_phit*(d_vgdin_d_vtzeta-d_myarg_d_vtzeta)-(vgdin-myarg)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg_d_dibsat=((alpha_phit*(d_vgdin_d_dibsat-d_myarg_d_dibsat)-(vgdin-myarg)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg_d_epsilon=((alpha_phit*(d_vgdin_d_epsilon-d_myarg_d_epsilon)-(vgdin-myarg)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg_d_vzeta=((alpha_phit*(d_vgdin_d_vzeta-d_myarg_d_vzeta)-(vgdin-myarg)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg_d_lambda=((alpha_phit*(d_vgdin_d_lambda-d_myarg_d_lambda)-(vgdin-myarg)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg_d_ngf=((alpha_phit*(d_vgdin_d_ngf-d_myarg_d_ngf)-(vgdin-myarg)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg_d_type=((alpha_phit*(d_vgdin_d_type-d_myarg_d_type)-(vgdin-myarg)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg=((vgdin-myarg)/alpha_phit);
if((exparg>50.0))
{
d_ffd_d_vgsin=0.0;
d_ffd_d_vdsin=0.0;
d_ffd_d_qcbflag=0.0;
d_ffd_d_vcin=0.0;
d_ffd_d_vbin=0.0;
d_ffd_d_qgsflag=0.0;
d_ffd_d_tambin=0.0;
d_ffd_d_tnomin=0.0;
d_ffd_d_phitin=0.0;
d_ffd_d_w=0.0;
d_ffd_d_lin=0.0;
d_ffd_d_cgin=0.0;
d_ffd_d_cs=0.0;
d_ffd_d_cc=0.0;
d_ffd_d_cb=0.0;
d_ffd_d_vto=0.0;
d_ffd_d_ss=0.0;
d_ffd_d_delta1=0.0;
d_ffd_d_delta2=0.0;
d_ffd_d_nd=0.0;
d_ffd_d_alpha=0.0;
d_ffd_d_vel0=0.0;
d_ffd_d_mu0=0.0;
d_ffd_d_beta=0.0;
d_ffd_d_mtheta=0.0;
d_ffd_d_vtheta=0.0;
d_ffd_d_vtzeta=0.0;
d_ffd_d_dibsat=0.0;
d_ffd_d_epsilon=0.0;
d_ffd_d_vzeta=0.0;
d_ffd_d_lambda=0.0;
d_ffd_d_ngf=0.0;
d_ffd_d_type=0.0;
ffd=0.0;
}
else
{
if((exparg<(-50.0)))
{
d_ffd_d_vgsin=0.0;
d_ffd_d_vdsin=0.0;
d_ffd_d_qcbflag=0.0;
d_ffd_d_vcin=0.0;
d_ffd_d_vbin=0.0;
d_ffd_d_qgsflag=0.0;
d_ffd_d_tambin=0.0;
d_ffd_d_tnomin=0.0;
d_ffd_d_phitin=0.0;
d_ffd_d_w=0.0;
d_ffd_d_lin=0.0;
d_ffd_d_cgin=0.0;
d_ffd_d_cs=0.0;
d_ffd_d_cc=0.0;
d_ffd_d_cb=0.0;
d_ffd_d_vto=0.0;
d_ffd_d_ss=0.0;
d_ffd_d_delta1=0.0;
d_ffd_d_delta2=0.0;
d_ffd_d_nd=0.0;
d_ffd_d_alpha=0.0;
d_ffd_d_vel0=0.0;
d_ffd_d_mu0=0.0;
d_ffd_d_beta=0.0;
d_ffd_d_mtheta=0.0;
d_ffd_d_vtheta=0.0;
d_ffd_d_vtzeta=0.0;
d_ffd_d_dibsat=0.0;
d_ffd_d_epsilon=0.0;
d_ffd_d_vzeta=0.0;
d_ffd_d_lambda=0.0;
d_ffd_d_ngf=0.0;
d_ffd_d_type=0.0;
ffd=1.0;
}
else
{
d_ffd_d_vgsin=(-exp(exparg)*d_exparg_d_vgsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vdsin=(-exp(exparg)*d_exparg_d_vdsin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_qcbflag=(-exp(exparg)*d_exparg_d_qcbflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vcin=(-exp(exparg)*d_exparg_d_vcin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vbin=(-exp(exparg)*d_exparg_d_vbin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_qgsflag=(-exp(exparg)*d_exparg_d_qgsflag/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_tambin=(-exp(exparg)*d_exparg_d_tambin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_tnomin=(-exp(exparg)*d_exparg_d_tnomin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_phitin=(-exp(exparg)*d_exparg_d_phitin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_w=(-exp(exparg)*d_exparg_d_w/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_lin=(-exp(exparg)*d_exparg_d_lin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cgin=(-exp(exparg)*d_exparg_d_cgin/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cs=(-exp(exparg)*d_exparg_d_cs/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cc=(-exp(exparg)*d_exparg_d_cc/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_cb=(-exp(exparg)*d_exparg_d_cb/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vto=(-exp(exparg)*d_exparg_d_vto/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_ss=(-exp(exparg)*d_exparg_d_ss/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_delta1=(-exp(exparg)*d_exparg_d_delta1/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_delta2=(-exp(exparg)*d_exparg_d_delta2/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_nd=(-exp(exparg)*d_exparg_d_nd/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_alpha=(-exp(exparg)*d_exparg_d_alpha/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vel0=(-exp(exparg)*d_exparg_d_vel0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_mu0=(-exp(exparg)*d_exparg_d_mu0/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_beta=(-exp(exparg)*d_exparg_d_beta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_mtheta=(-exp(exparg)*d_exparg_d_mtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vtheta=(-exp(exparg)*d_exparg_d_vtheta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vtzeta=(-exp(exparg)*d_exparg_d_vtzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_dibsat=(-exp(exparg)*d_exparg_d_dibsat/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_epsilon=(-exp(exparg)*d_exparg_d_epsilon/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_vzeta=(-exp(exparg)*d_exparg_d_vzeta/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_lambda=(-exp(exparg)*d_exparg_d_lambda/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_ngf=(-exp(exparg)*d_exparg_d_ngf/(1.0+exp(exparg))/(1.0+exp(exparg)));
d_ffd_d_type=(-exp(exparg)*d_exparg_d_type/(1.0+exp(exparg))/(1.0+exp(exparg)));
ffd=(1.0/(1.0+exp(exparg)));
}
}
d_etad_d_vgsin=((two_n_phit*((1.0-d_vdx_d_vgsin)-(d_vtdibl_d_vgsin-(((0.1*alpha_phit)*d_ffd_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vgsin)/two_n_phit/two_n_phit);
d_etad_d_vdsin=((two_n_phit*((-d_vdx_d_vdsin)-(d_vtdibl_d_vdsin-(((0.1*alpha_phit)*d_ffd_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vdsin)/two_n_phit/two_n_phit);
d_etad_d_qcbflag=((two_n_phit*((-d_vdx_d_qcbflag)-(d_vtdibl_d_qcbflag-(((0.1*alpha_phit)*d_ffd_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_qcbflag)/two_n_phit/two_n_phit);
d_etad_d_vcin=((two_n_phit*((-d_vdx_d_vcin)-(d_vtdibl_d_vcin-(((0.1*alpha_phit)*d_ffd_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vcin)/two_n_phit/two_n_phit);
d_etad_d_vbin=((two_n_phit*((-d_vdx_d_vbin)-(d_vtdibl_d_vbin-(((0.1*alpha_phit)*d_ffd_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vbin)/two_n_phit/two_n_phit);
d_etad_d_qgsflag=((two_n_phit*((-d_vdx_d_qgsflag)-(d_vtdibl_d_qgsflag-(((0.1*alpha_phit)*d_ffd_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_qgsflag)/two_n_phit/two_n_phit);
d_etad_d_tambin=((two_n_phit*((-d_vdx_d_tambin)-(d_vtdibl_d_tambin-(((0.1*alpha_phit)*d_ffd_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_tambin)/two_n_phit/two_n_phit);
d_etad_d_tnomin=((two_n_phit*((-d_vdx_d_tnomin)-(d_vtdibl_d_tnomin-(((0.1*alpha_phit)*d_ffd_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_tnomin)/two_n_phit/two_n_phit);
d_etad_d_phitin=((two_n_phit*((-d_vdx_d_phitin)-(d_vtdibl_d_phitin-(((0.1*alpha_phit)*d_ffd_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_phitin)/two_n_phit/two_n_phit);
d_etad_d_w=((two_n_phit*((-d_vdx_d_w)-(d_vtdibl_d_w-(((0.1*alpha_phit)*d_ffd_d_w)+((0.1*d_alpha_phit_d_w)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_w)/two_n_phit/two_n_phit);
d_etad_d_lin=((two_n_phit*((-d_vdx_d_lin)-(d_vtdibl_d_lin-(((0.1*alpha_phit)*d_ffd_d_lin)+((0.1*d_alpha_phit_d_lin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_lin)/two_n_phit/two_n_phit);
d_etad_d_cgin=((two_n_phit*((-d_vdx_d_cgin)-(d_vtdibl_d_cgin-(((0.1*alpha_phit)*d_ffd_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cgin)/two_n_phit/two_n_phit);
d_etad_d_cs=((two_n_phit*((-d_vdx_d_cs)-(d_vtdibl_d_cs-(((0.1*alpha_phit)*d_ffd_d_cs)+((0.1*d_alpha_phit_d_cs)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cs)/two_n_phit/two_n_phit);
d_etad_d_cc=((two_n_phit*((-d_vdx_d_cc)-(d_vtdibl_d_cc-(((0.1*alpha_phit)*d_ffd_d_cc)+((0.1*d_alpha_phit_d_cc)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cc)/two_n_phit/two_n_phit);
d_etad_d_cb=((two_n_phit*((-d_vdx_d_cb)-(d_vtdibl_d_cb-(((0.1*alpha_phit)*d_ffd_d_cb)+((0.1*d_alpha_phit_d_cb)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_cb)/two_n_phit/two_n_phit);
d_etad_d_vto=((two_n_phit*((-d_vdx_d_vto)-(d_vtdibl_d_vto-(((0.1*alpha_phit)*d_ffd_d_vto)+((0.1*d_alpha_phit_d_vto)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vto)/two_n_phit/two_n_phit);
d_etad_d_ss=((two_n_phit*((-d_vdx_d_ss)-(d_vtdibl_d_ss-(((0.1*alpha_phit)*d_ffd_d_ss)+((0.1*d_alpha_phit_d_ss)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_ss)/two_n_phit/two_n_phit);
d_etad_d_delta1=((two_n_phit*((-d_vdx_d_delta1)-(d_vtdibl_d_delta1-(((0.1*alpha_phit)*d_ffd_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_delta1)/two_n_phit/two_n_phit);
d_etad_d_delta2=((two_n_phit*((-d_vdx_d_delta2)-(d_vtdibl_d_delta2-(((0.1*alpha_phit)*d_ffd_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_delta2)/two_n_phit/two_n_phit);
d_etad_d_nd=((two_n_phit*((-d_vdx_d_nd)-(d_vtdibl_d_nd-(((0.1*alpha_phit)*d_ffd_d_nd)+((0.1*d_alpha_phit_d_nd)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_nd)/two_n_phit/two_n_phit);
d_etad_d_alpha=((two_n_phit*((-d_vdx_d_alpha)-(d_vtdibl_d_alpha-(((0.1*alpha_phit)*d_ffd_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_alpha)/two_n_phit/two_n_phit);
d_etad_d_vel0=((two_n_phit*((-d_vdx_d_vel0)-(d_vtdibl_d_vel0-(((0.1*alpha_phit)*d_ffd_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vel0)/two_n_phit/two_n_phit);
d_etad_d_mu0=((two_n_phit*((-d_vdx_d_mu0)-(d_vtdibl_d_mu0-(((0.1*alpha_phit)*d_ffd_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_mu0)/two_n_phit/two_n_phit);
d_etad_d_beta=((two_n_phit*((-d_vdx_d_beta)-(d_vtdibl_d_beta-(((0.1*alpha_phit)*d_ffd_d_beta)+((0.1*d_alpha_phit_d_beta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_beta)/two_n_phit/two_n_phit);
d_etad_d_mtheta=((two_n_phit*((-d_vdx_d_mtheta)-(d_vtdibl_d_mtheta-(((0.1*alpha_phit)*d_ffd_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_mtheta)/two_n_phit/two_n_phit);
d_etad_d_vtheta=((two_n_phit*((-d_vdx_d_vtheta)-(d_vtdibl_d_vtheta-(((0.1*alpha_phit)*d_ffd_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vtheta)/two_n_phit/two_n_phit);
d_etad_d_vtzeta=((two_n_phit*((-d_vdx_d_vtzeta)-(d_vtdibl_d_vtzeta-(((0.1*alpha_phit)*d_ffd_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vtzeta)/two_n_phit/two_n_phit);
d_etad_d_dibsat=((two_n_phit*((-d_vdx_d_dibsat)-(d_vtdibl_d_dibsat-(((0.1*alpha_phit)*d_ffd_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_dibsat)/two_n_phit/two_n_phit);
d_etad_d_epsilon=((two_n_phit*((-d_vdx_d_epsilon)-(d_vtdibl_d_epsilon-(((0.1*alpha_phit)*d_ffd_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_epsilon)/two_n_phit/two_n_phit);
d_etad_d_vzeta=((two_n_phit*((-d_vdx_d_vzeta)-(d_vtdibl_d_vzeta-(((0.1*alpha_phit)*d_ffd_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_vzeta)/two_n_phit/two_n_phit);
d_etad_d_lambda=((two_n_phit*((-d_vdx_d_lambda)-(d_vtdibl_d_lambda-(((0.1*alpha_phit)*d_ffd_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_lambda)/two_n_phit/two_n_phit);
d_etad_d_ngf=((two_n_phit*((-d_vdx_d_ngf)-(d_vtdibl_d_ngf-(((0.1*alpha_phit)*d_ffd_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_ngf)/two_n_phit/two_n_phit);
d_etad_d_type=((two_n_phit*((-d_vdx_d_type)-(d_vtdibl_d_type-(((0.1*alpha_phit)*d_ffd_d_type)+((0.1*d_alpha_phit_d_type)*ffd))))-((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))*d_two_n_phit_d_type)/two_n_phit/two_n_phit);
etad=(((vgsin-vdx)-(vtdibl-((0.1*alpha_phit)*ffd)))/two_n_phit);
if((etad>50.0))
{
d_qinvd_d_vgsin=((qref*d_etad_d_vgsin)+(d_qref_d_vgsin*etad));
d_qinvd_d_vdsin=((qref*d_etad_d_vdsin)+(d_qref_d_vdsin*etad));
d_qinvd_d_qcbflag=((qref*d_etad_d_qcbflag)+(d_qref_d_qcbflag*etad));
d_qinvd_d_vcin=((qref*d_etad_d_vcin)+(d_qref_d_vcin*etad));
d_qinvd_d_vbin=((qref*d_etad_d_vbin)+(d_qref_d_vbin*etad));
d_qinvd_d_qgsflag=((qref*d_etad_d_qgsflag)+(d_qref_d_qgsflag*etad));
d_qinvd_d_tambin=((qref*d_etad_d_tambin)+(d_qref_d_tambin*etad));
d_qinvd_d_tnomin=((qref*d_etad_d_tnomin)+(d_qref_d_tnomin*etad));
d_qinvd_d_phitin=((qref*d_etad_d_phitin)+(d_qref_d_phitin*etad));
d_qinvd_d_w=((qref*d_etad_d_w)+(d_qref_d_w*etad));
d_qinvd_d_lin=((qref*d_etad_d_lin)+(d_qref_d_lin*etad));
d_qinvd_d_cgin=((qref*d_etad_d_cgin)+(d_qref_d_cgin*etad));
d_qinvd_d_cs=((qref*d_etad_d_cs)+(d_qref_d_cs*etad));
d_qinvd_d_cc=((qref*d_etad_d_cc)+(d_qref_d_cc*etad));
d_qinvd_d_cb=((qref*d_etad_d_cb)+(d_qref_d_cb*etad));
d_qinvd_d_vto=((qref*d_etad_d_vto)+(d_qref_d_vto*etad));
d_qinvd_d_ss=((qref*d_etad_d_ss)+(d_qref_d_ss*etad));
d_qinvd_d_delta1=((qref*d_etad_d_delta1)+(d_qref_d_delta1*etad));
d_qinvd_d_delta2=((qref*d_etad_d_delta2)+(d_qref_d_delta2*etad));
d_qinvd_d_nd=((qref*d_etad_d_nd)+(d_qref_d_nd*etad));
d_qinvd_d_alpha=((qref*d_etad_d_alpha)+(d_qref_d_alpha*etad));
d_qinvd_d_vel0=((qref*d_etad_d_vel0)+(d_qref_d_vel0*etad));
d_qinvd_d_mu0=((qref*d_etad_d_mu0)+(d_qref_d_mu0*etad));
d_qinvd_d_beta=((qref*d_etad_d_beta)+(d_qref_d_beta*etad));
d_qinvd_d_mtheta=((qref*d_etad_d_mtheta)+(d_qref_d_mtheta*etad));
d_qinvd_d_vtheta=((qref*d_etad_d_vtheta)+(d_qref_d_vtheta*etad));
d_qinvd_d_vtzeta=((qref*d_etad_d_vtzeta)+(d_qref_d_vtzeta*etad));
d_qinvd_d_dibsat=((qref*d_etad_d_dibsat)+(d_qref_d_dibsat*etad));
d_qinvd_d_epsilon=((qref*d_etad_d_epsilon)+(d_qref_d_epsilon*etad));
d_qinvd_d_vzeta=((qref*d_etad_d_vzeta)+(d_qref_d_vzeta*etad));
d_qinvd_d_lambda=((qref*d_etad_d_lambda)+(d_qref_d_lambda*etad));
d_qinvd_d_ngf=((qref*d_etad_d_ngf)+(d_qref_d_ngf*etad));
d_qinvd_d_type=((qref*d_etad_d_type)+(d_qref_d_type*etad));
qinvd=(qref*etad);
}
else
{
if((etad<(-50.0)))
{
d_qinvd_d_vgsin=0.0;
d_qinvd_d_vdsin=0.0;
d_qinvd_d_qcbflag=0.0;
d_qinvd_d_vcin=0.0;
d_qinvd_d_vbin=0.0;
d_qinvd_d_qgsflag=0.0;
d_qinvd_d_tambin=0.0;
d_qinvd_d_tnomin=0.0;
d_qinvd_d_phitin=0.0;
d_qinvd_d_w=0.0;
d_qinvd_d_lin=0.0;
d_qinvd_d_cgin=0.0;
d_qinvd_d_cs=0.0;
d_qinvd_d_cc=0.0;
d_qinvd_d_cb=0.0;
d_qinvd_d_vto=0.0;
d_qinvd_d_ss=0.0;
d_qinvd_d_delta1=0.0;
d_qinvd_d_delta2=0.0;
d_qinvd_d_nd=0.0;
d_qinvd_d_alpha=0.0;
d_qinvd_d_vel0=0.0;
d_qinvd_d_mu0=0.0;
d_qinvd_d_beta=0.0;
d_qinvd_d_mtheta=0.0;
d_qinvd_d_vtheta=0.0;
d_qinvd_d_vtzeta=0.0;
d_qinvd_d_dibsat=0.0;
d_qinvd_d_epsilon=0.0;
d_qinvd_d_vzeta=0.0;
d_qinvd_d_lambda=0.0;
d_qinvd_d_ngf=0.0;
d_qinvd_d_type=0.0;
qinvd=0;
}
else
{
d_qinvd_d_vgsin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vgsin)+(d_qref_d_vgsin*log((1.0+exp(etad)))));
d_qinvd_d_vdsin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vdsin)+(d_qref_d_vdsin*log((1.0+exp(etad)))));
d_qinvd_d_qcbflag=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_qcbflag)+(d_qref_d_qcbflag*log((1.0+exp(etad)))));
d_qinvd_d_vcin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vcin)+(d_qref_d_vcin*log((1.0+exp(etad)))));
d_qinvd_d_vbin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vbin)+(d_qref_d_vbin*log((1.0+exp(etad)))));
d_qinvd_d_qgsflag=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_qgsflag)+(d_qref_d_qgsflag*log((1.0+exp(etad)))));
d_qinvd_d_tambin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_tambin)+(d_qref_d_tambin*log((1.0+exp(etad)))));
d_qinvd_d_tnomin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_tnomin)+(d_qref_d_tnomin*log((1.0+exp(etad)))));
d_qinvd_d_phitin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_phitin)+(d_qref_d_phitin*log((1.0+exp(etad)))));
d_qinvd_d_w=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_w)+(d_qref_d_w*log((1.0+exp(etad)))));
d_qinvd_d_lin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_lin)+(d_qref_d_lin*log((1.0+exp(etad)))));
d_qinvd_d_cgin=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cgin)+(d_qref_d_cgin*log((1.0+exp(etad)))));
d_qinvd_d_cs=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cs)+(d_qref_d_cs*log((1.0+exp(etad)))));
d_qinvd_d_cc=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cc)+(d_qref_d_cc*log((1.0+exp(etad)))));
d_qinvd_d_cb=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_cb)+(d_qref_d_cb*log((1.0+exp(etad)))));
d_qinvd_d_vto=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vto)+(d_qref_d_vto*log((1.0+exp(etad)))));
d_qinvd_d_ss=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_ss)+(d_qref_d_ss*log((1.0+exp(etad)))));
d_qinvd_d_delta1=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_delta1)+(d_qref_d_delta1*log((1.0+exp(etad)))));
d_qinvd_d_delta2=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_delta2)+(d_qref_d_delta2*log((1.0+exp(etad)))));
d_qinvd_d_nd=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_nd)+(d_qref_d_nd*log((1.0+exp(etad)))));
d_qinvd_d_alpha=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_alpha)+(d_qref_d_alpha*log((1.0+exp(etad)))));
d_qinvd_d_vel0=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vel0)+(d_qref_d_vel0*log((1.0+exp(etad)))));
d_qinvd_d_mu0=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_mu0)+(d_qref_d_mu0*log((1.0+exp(etad)))));
d_qinvd_d_beta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_beta)+(d_qref_d_beta*log((1.0+exp(etad)))));
d_qinvd_d_mtheta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_mtheta)+(d_qref_d_mtheta*log((1.0+exp(etad)))));
d_qinvd_d_vtheta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vtheta)+(d_qref_d_vtheta*log((1.0+exp(etad)))));
d_qinvd_d_vtzeta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vtzeta)+(d_qref_d_vtzeta*log((1.0+exp(etad)))));
d_qinvd_d_dibsat=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_dibsat)+(d_qref_d_dibsat*log((1.0+exp(etad)))));
d_qinvd_d_epsilon=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_epsilon)+(d_qref_d_epsilon*log((1.0+exp(etad)))));
d_qinvd_d_vzeta=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_vzeta)+(d_qref_d_vzeta*log((1.0+exp(etad)))));
d_qinvd_d_lambda=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_lambda)+(d_qref_d_lambda*log((1.0+exp(etad)))));
d_qinvd_d_ngf=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_ngf)+(d_qref_d_ngf*log((1.0+exp(etad)))));
d_qinvd_d_type=((qref*(1.0/(1.0+exp(etad)))*exp(etad)*d_etad_d_type)+(d_qref_d_type*log((1.0+exp(etad)))));
qinvd=(qref*log((1.0+exp(etad))));
}
}
d_vdsc_d_vgsin=((d_qinvs_d_vgsin-d_qinvd_d_vgsin)/cgin);
d_vdsc_d_vdsin=((d_qinvs_d_vdsin-d_qinvd_d_vdsin)/cgin);
d_vdsc_d_qcbflag=((d_qinvs_d_qcbflag-d_qinvd_d_qcbflag)/cgin);
d_vdsc_d_vcin=((d_qinvs_d_vcin-d_qinvd_d_vcin)/cgin);
d_vdsc_d_vbin=((d_qinvs_d_vbin-d_qinvd_d_vbin)/cgin);
d_vdsc_d_qgsflag=((d_qinvs_d_qgsflag-d_qinvd_d_qgsflag)/cgin);
d_vdsc_d_tambin=((d_qinvs_d_tambin-d_qinvd_d_tambin)/cgin);
d_vdsc_d_tnomin=((d_qinvs_d_tnomin-d_qinvd_d_tnomin)/cgin);
d_vdsc_d_phitin=((d_qinvs_d_phitin-d_qinvd_d_phitin)/cgin);
d_vdsc_d_w=((d_qinvs_d_w-d_qinvd_d_w)/cgin);
d_vdsc_d_lin=((d_qinvs_d_lin-d_qinvd_d_lin)/cgin);
d_vdsc_d_cgin=((cgin*(d_qinvs_d_cgin-d_qinvd_d_cgin)-(qinvs-qinvd))/cgin/cgin);
d_vdsc_d_cs=((d_qinvs_d_cs-d_qinvd_d_cs)/cgin);
d_vdsc_d_cc=((d_qinvs_d_cc-d_qinvd_d_cc)/cgin);
d_vdsc_d_cb=((d_qinvs_d_cb-d_qinvd_d_cb)/cgin);
d_vdsc_d_vto=((d_qinvs_d_vto-d_qinvd_d_vto)/cgin);
d_vdsc_d_ss=((d_qinvs_d_ss-d_qinvd_d_ss)/cgin);
d_vdsc_d_delta1=((d_qinvs_d_delta1-d_qinvd_d_delta1)/cgin);
d_vdsc_d_delta2=((d_qinvs_d_delta2-d_qinvd_d_delta2)/cgin);
d_vdsc_d_nd=((d_qinvs_d_nd-d_qinvd_d_nd)/cgin);
d_vdsc_d_alpha=((d_qinvs_d_alpha-d_qinvd_d_alpha)/cgin);
d_vdsc_d_vel0=((d_qinvs_d_vel0-d_qinvd_d_vel0)/cgin);
d_vdsc_d_mu0=((d_qinvs_d_mu0-d_qinvd_d_mu0)/cgin);
d_vdsc_d_beta=((d_qinvs_d_beta-d_qinvd_d_beta)/cgin);
d_vdsc_d_mtheta=((d_qinvs_d_mtheta-d_qinvd_d_mtheta)/cgin);
d_vdsc_d_vtheta=((d_qinvs_d_vtheta-d_qinvd_d_vtheta)/cgin);
d_vdsc_d_vtzeta=((d_qinvs_d_vtzeta-d_qinvd_d_vtzeta)/cgin);
d_vdsc_d_dibsat=((d_qinvs_d_dibsat-d_qinvd_d_dibsat)/cgin);
d_vdsc_d_epsilon=((d_qinvs_d_epsilon-d_qinvd_d_epsilon)/cgin);
d_vdsc_d_vzeta=((d_qinvs_d_vzeta-d_qinvd_d_vzeta)/cgin);
d_vdsc_d_lambda=((d_qinvs_d_lambda-d_qinvd_d_lambda)/cgin);
d_vdsc_d_ngf=((d_qinvs_d_ngf-d_qinvd_d_ngf)/cgin);
d_vdsc_d_type=((d_qinvs_d_type-d_qinvd_d_type)/cgin);
vdsc=((qinvs-qinvd)/cgin);
d_myarg_d_vgsin=((vdsat*d_vdsc_d_vgsin-vdsc*d_vdsat_d_vgsin)/vdsat/vdsat);
d_myarg_d_vdsin=((vdsat*d_vdsc_d_vdsin-vdsc*d_vdsat_d_vdsin)/vdsat/vdsat);
d_myarg_d_qcbflag=((vdsat*d_vdsc_d_qcbflag-vdsc*d_vdsat_d_qcbflag)/vdsat/vdsat);
d_myarg_d_vcin=((vdsat*d_vdsc_d_vcin-vdsc*d_vdsat_d_vcin)/vdsat/vdsat);
d_myarg_d_vbin=((vdsat*d_vdsc_d_vbin-vdsc*d_vdsat_d_vbin)/vdsat/vdsat);
d_myarg_d_qgsflag=((vdsat*d_vdsc_d_qgsflag-vdsc*d_vdsat_d_qgsflag)/vdsat/vdsat);
d_myarg_d_tambin=((vdsat*d_vdsc_d_tambin-vdsc*d_vdsat_d_tambin)/vdsat/vdsat);
d_myarg_d_tnomin=((vdsat*d_vdsc_d_tnomin-vdsc*d_vdsat_d_tnomin)/vdsat/vdsat);
d_myarg_d_phitin=((vdsat*d_vdsc_d_phitin-vdsc*d_vdsat_d_phitin)/vdsat/vdsat);
d_myarg_d_w=((vdsat*d_vdsc_d_w-vdsc*d_vdsat_d_w)/vdsat/vdsat);
d_myarg_d_lin=((vdsat*d_vdsc_d_lin-vdsc*d_vdsat_d_lin)/vdsat/vdsat);
d_myarg_d_cgin=((vdsat*d_vdsc_d_cgin-vdsc*d_vdsat_d_cgin)/vdsat/vdsat);
d_myarg_d_cs=((vdsat*d_vdsc_d_cs-vdsc*d_vdsat_d_cs)/vdsat/vdsat);
d_myarg_d_cc=((vdsat*d_vdsc_d_cc-vdsc*d_vdsat_d_cc)/vdsat/vdsat);
d_myarg_d_cb=((vdsat*d_vdsc_d_cb-vdsc*d_vdsat_d_cb)/vdsat/vdsat);
d_myarg_d_vto=((vdsat*d_vdsc_d_vto-vdsc*d_vdsat_d_vto)/vdsat/vdsat);
d_myarg_d_ss=((vdsat*d_vdsc_d_ss-vdsc*d_vdsat_d_ss)/vdsat/vdsat);
d_myarg_d_delta1=((vdsat*d_vdsc_d_delta1-vdsc*d_vdsat_d_delta1)/vdsat/vdsat);
d_myarg_d_delta2=((vdsat*d_vdsc_d_delta2-vdsc*d_vdsat_d_delta2)/vdsat/vdsat);
d_myarg_d_nd=((vdsat*d_vdsc_d_nd-vdsc*d_vdsat_d_nd)/vdsat/vdsat);
d_myarg_d_alpha=((vdsat*d_vdsc_d_alpha-vdsc*d_vdsat_d_alpha)/vdsat/vdsat);
d_myarg_d_vel0=((vdsat*d_vdsc_d_vel0-vdsc*d_vdsat_d_vel0)/vdsat/vdsat);
d_myarg_d_mu0=((vdsat*d_vdsc_d_mu0-vdsc*d_vdsat_d_mu0)/vdsat/vdsat);
d_myarg_d_beta=((vdsat*d_vdsc_d_beta-vdsc*d_vdsat_d_beta)/vdsat/vdsat);
d_myarg_d_mtheta=((vdsat*d_vdsc_d_mtheta-vdsc*d_vdsat_d_mtheta)/vdsat/vdsat);
d_myarg_d_vtheta=((vdsat*d_vdsc_d_vtheta-vdsc*d_vdsat_d_vtheta)/vdsat/vdsat);
d_myarg_d_vtzeta=((vdsat*d_vdsc_d_vtzeta-vdsc*d_vdsat_d_vtzeta)/vdsat/vdsat);
d_myarg_d_dibsat=((vdsat*d_vdsc_d_dibsat-vdsc*d_vdsat_d_dibsat)/vdsat/vdsat);
d_myarg_d_epsilon=((vdsat*d_vdsc_d_epsilon-vdsc*d_vdsat_d_epsilon)/vdsat/vdsat);
d_myarg_d_vzeta=((vdsat*d_vdsc_d_vzeta-vdsc*d_vdsat_d_vzeta)/vdsat/vdsat);
d_myarg_d_lambda=((vdsat*d_vdsc_d_lambda-vdsc*d_vdsat_d_lambda)/vdsat/vdsat);
d_myarg_d_ngf=((vdsat*d_vdsc_d_ngf-vdsc*d_vdsat_d_ngf)/vdsat/vdsat);
d_myarg_d_type=((vdsat*d_vdsc_d_type-vdsc*d_vdsat_d_type)/vdsat/vdsat);
myarg=(vdsc/vdsat);
d_fsat_d_vgsin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vgsin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vgsin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vdsin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vdsin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vdsin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_qcbflag=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_qcbflag-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_qcbflag))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vcin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vcin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vcin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vbin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vbin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vbin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_qgsflag=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_qgsflag-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_qgsflag))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_tambin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_tambin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_tambin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_tnomin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_tnomin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_tnomin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_phitin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_phitin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_phitin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_w=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_w-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_w))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_lin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_lin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_lin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cgin=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cgin-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cgin))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cs=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cs-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cs))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cc=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cc-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cc))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_cb=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_cb-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_cb))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vto=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vto-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vto))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_ss=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_ss-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_ss))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_delta1=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_delta1-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_delta1))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_delta2=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_delta2-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_delta2))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_nd=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_nd-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_nd))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_alpha=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_alpha-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_alpha))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vel0=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vel0-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vel0))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_mu0=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_mu0-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_mu0))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_beta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_beta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_beta)+((absfunc(myarg)==0.0)?0.0:(log(absfunc(myarg)*pow(absfunc(myarg),beta))))+(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(log((1.0+pow(absfunc(myarg),beta))*pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)))))*(-1.0/beta/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_mtheta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_mtheta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_mtheta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vtheta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vtheta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vtheta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vtzeta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vtzeta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vtzeta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_dibsat=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_dibsat-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_dibsat))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_epsilon=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_epsilon-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_epsilon))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_vzeta=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_vzeta-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_vzeta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_lambda=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_lambda-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_lambda))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_ngf=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_ngf-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_ngf))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_fsat_d_type=((pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*d_myarg_d_type-myarg*(((1.0+pow(absfunc(myarg),beta))==0.0)?0.0:(pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(absfunc(myarg),beta))))*((absfunc(myarg)==0.0)?0.0:(pow(absfunc(myarg),beta)*beta/absfunc(myarg)))*d_absfunc(myarg,d_myarg_d_type))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta))/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
fsat=(myarg/pow((1.0+pow(absfunc(myarg),beta)),(1.0/beta)));
d_vel_d_vgsin=((vxf*d_fsat_d_vgsin)+(d_vxf_d_vgsin*fsat));
d_vel_d_vdsin=((vxf*d_fsat_d_vdsin)+(d_vxf_d_vdsin*fsat));
d_vel_d_qcbflag=((vxf*d_fsat_d_qcbflag)+(d_vxf_d_qcbflag*fsat));
d_vel_d_vcin=((vxf*d_fsat_d_vcin)+(d_vxf_d_vcin*fsat));
d_vel_d_vbin=((vxf*d_fsat_d_vbin)+(d_vxf_d_vbin*fsat));
d_vel_d_qgsflag=((vxf*d_fsat_d_qgsflag)+(d_vxf_d_qgsflag*fsat));
d_vel_d_tambin=((vxf*d_fsat_d_tambin)+(d_vxf_d_tambin*fsat));
d_vel_d_tnomin=((vxf*d_fsat_d_tnomin)+(d_vxf_d_tnomin*fsat));
d_vel_d_phitin=((vxf*d_fsat_d_phitin)+(d_vxf_d_phitin*fsat));
d_vel_d_w=((vxf*d_fsat_d_w)+(d_vxf_d_w*fsat));
d_vel_d_lin=((vxf*d_fsat_d_lin)+(d_vxf_d_lin*fsat));
d_vel_d_cgin=((vxf*d_fsat_d_cgin)+(d_vxf_d_cgin*fsat));
d_vel_d_cs=((vxf*d_fsat_d_cs)+(d_vxf_d_cs*fsat));
d_vel_d_cc=((vxf*d_fsat_d_cc)+(d_vxf_d_cc*fsat));
d_vel_d_cb=((vxf*d_fsat_d_cb)+(d_vxf_d_cb*fsat));
d_vel_d_vto=((vxf*d_fsat_d_vto)+(d_vxf_d_vto*fsat));
d_vel_d_ss=((vxf*d_fsat_d_ss)+(d_vxf_d_ss*fsat));
d_vel_d_delta1=((vxf*d_fsat_d_delta1)+(d_vxf_d_delta1*fsat));
d_vel_d_delta2=((vxf*d_fsat_d_delta2)+(d_vxf_d_delta2*fsat));
d_vel_d_nd=((vxf*d_fsat_d_nd)+(d_vxf_d_nd*fsat));
d_vel_d_alpha=((vxf*d_fsat_d_alpha)+(d_vxf_d_alpha*fsat));
d_vel_d_vel0=((vxf*d_fsat_d_vel0)+(d_vxf_d_vel0*fsat));
d_vel_d_mu0=((vxf*d_fsat_d_mu0)+(d_vxf_d_mu0*fsat));
d_vel_d_beta=((vxf*d_fsat_d_beta)+(d_vxf_d_beta*fsat));
d_vel_d_mtheta=((vxf*d_fsat_d_mtheta)+(d_vxf_d_mtheta*fsat));
d_vel_d_vtheta=((vxf*d_fsat_d_vtheta)+(d_vxf_d_vtheta*fsat));
d_vel_d_vtzeta=((vxf*d_fsat_d_vtzeta)+(d_vxf_d_vtzeta*fsat));
d_vel_d_dibsat=((vxf*d_fsat_d_dibsat)+(d_vxf_d_dibsat*fsat));
d_vel_d_epsilon=((vxf*d_fsat_d_epsilon)+(d_vxf_d_epsilon*fsat));
d_vel_d_vzeta=((vxf*d_fsat_d_vzeta)+(d_vxf_d_vzeta*fsat));
d_vel_d_lambda=((vxf*d_fsat_d_lambda)+(d_vxf_d_lambda*fsat));
d_vel_d_ngf=((vxf*d_fsat_d_ngf)+(d_vxf_d_ngf*fsat));
d_vel_d_type=((vxf*d_fsat_d_type)+(d_vxf_d_type*fsat));
vel=(vxf*fsat);
d_idsout_d_vgsin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vgsin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vgsin+d_qinvd_d_vgsin))*vel));
d_idsout_d_vdsin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vdsin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vdsin+d_qinvd_d_vdsin))*vel));
d_idsout_d_qcbflag=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_qcbflag)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_qcbflag+d_qinvd_d_qcbflag))*vel));
d_idsout_d_vcin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vcin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vcin+d_qinvd_d_vcin))*vel));
d_idsout_d_vbin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vbin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vbin+d_qinvd_d_vbin))*vel));
d_idsout_d_qgsflag=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_qgsflag)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_qgsflag+d_qinvd_d_qgsflag))*vel));
d_idsout_d_tambin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_tambin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_tambin+d_qinvd_d_tambin))*vel));
d_idsout_d_tnomin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_tnomin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_tnomin+d_qinvd_d_tnomin))*vel));
d_idsout_d_phitin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_phitin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_phitin+d_qinvd_d_phitin))*vel));
d_idsout_d_w=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_w)+((((((type*w)*ngf)*0.5)*(d_qinvs_d_w+d_qinvd_d_w))+((((type)*ngf)*0.5)*(qinvs+qinvd)))*vel));
d_idsout_d_lin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_lin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_lin+d_qinvd_d_lin))*vel));
d_idsout_d_cgin=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cgin)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cgin+d_qinvd_d_cgin))*vel));
d_idsout_d_cs=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cs)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cs+d_qinvd_d_cs))*vel));
d_idsout_d_cc=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cc)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cc+d_qinvd_d_cc))*vel));
d_idsout_d_cb=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_cb)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_cb+d_qinvd_d_cb))*vel));
d_idsout_d_vto=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vto)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vto+d_qinvd_d_vto))*vel));
d_idsout_d_ss=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_ss)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_ss+d_qinvd_d_ss))*vel));
d_idsout_d_delta1=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_delta1)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_delta1+d_qinvd_d_delta1))*vel));
d_idsout_d_delta2=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_delta2)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_delta2+d_qinvd_d_delta2))*vel));
d_idsout_d_nd=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_nd)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_nd+d_qinvd_d_nd))*vel));
d_idsout_d_alpha=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_alpha)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_alpha+d_qinvd_d_alpha))*vel));
d_idsout_d_vel0=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vel0)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vel0+d_qinvd_d_vel0))*vel));
d_idsout_d_mu0=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_mu0)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_mu0+d_qinvd_d_mu0))*vel));
d_idsout_d_beta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_beta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_beta+d_qinvd_d_beta))*vel));
d_idsout_d_mtheta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_mtheta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_mtheta+d_qinvd_d_mtheta))*vel));
d_idsout_d_vtheta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vtheta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vtheta+d_qinvd_d_vtheta))*vel));
d_idsout_d_vtzeta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vtzeta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vtzeta+d_qinvd_d_vtzeta))*vel));
d_idsout_d_dibsat=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_dibsat)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_dibsat+d_qinvd_d_dibsat))*vel));
d_idsout_d_epsilon=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_epsilon)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_epsilon+d_qinvd_d_epsilon))*vel));
d_idsout_d_vzeta=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_vzeta)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_vzeta+d_qinvd_d_vzeta))*vel));
d_idsout_d_lambda=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_lambda)+(((((type*w)*ngf)*0.5)*(d_qinvs_d_lambda+d_qinvd_d_lambda))*vel));
d_idsout_d_ngf=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_ngf)+((((((type*w)*ngf)*0.5)*(d_qinvs_d_ngf+d_qinvd_d_ngf))+((((type*w))*0.5)*(qinvs+qinvd)))*vel));
d_idsout_d_type=((((((type*w)*ngf)*0.5)*(qinvs+qinvd))*d_vel_d_type)+((((((type*w)*ngf)*0.5)*(d_qinvs_d_type+d_qinvd_d_type))+((((w)*ngf)*0.5)*(qinvs+qinvd)))*vel));
idsout=(((((type*w)*ngf)*0.5)*(qinvs+qinvd))*vel);
d_n0_d_vgsin=0.0;
d_n0_d_vdsin=0.0;
d_n0_d_qcbflag=0.0;
d_n0_d_vcin=0.0;
d_n0_d_vbin=0.0;
d_n0_d_qgsflag=0.0;
d_n0_d_tambin=0.0;
d_n0_d_tnomin=0.0;
d_n0_d_phitin=(-ss*(2.30258509299404568401)/(2.30258509299404568401*phitin)/(2.30258509299404568401*phitin));
d_n0_d_w=0.0;
d_n0_d_lin=0.0;
d_n0_d_cgin=0.0;
d_n0_d_cs=0.0;
d_n0_d_cc=0.0;
d_n0_d_cb=0.0;
d_n0_d_vto=0.0;
d_n0_d_ss=(1.0/(2.30258509299404568401*phitin));
d_n0_d_delta1=0.0;
d_n0_d_delta2=0.0;
d_n0_d_nd=0.0;
d_n0_d_alpha=0.0;
d_n0_d_vel0=0.0;
d_n0_d_mu0=0.0;
d_n0_d_beta=0.0;
d_n0_d_mtheta=0.0;
d_n0_d_vtheta=0.0;
d_n0_d_vtzeta=0.0;
d_n0_d_dibsat=0.0;
d_n0_d_epsilon=0.0;
d_n0_d_vzeta=0.0;
d_n0_d_lambda=0.0;
d_n0_d_ngf=0.0;
d_n0_d_type=0.0;
n0=(ss/(2.30258509299404568401*phitin));
d_two_n_phit0_d_vgsin=((2.0*d_n0_d_vgsin)*phitin);
d_two_n_phit0_d_vdsin=((2.0*d_n0_d_vdsin)*phitin);
d_two_n_phit0_d_qcbflag=((2.0*d_n0_d_qcbflag)*phitin);
d_two_n_phit0_d_vcin=((2.0*d_n0_d_vcin)*phitin);
d_two_n_phit0_d_vbin=((2.0*d_n0_d_vbin)*phitin);
d_two_n_phit0_d_qgsflag=((2.0*d_n0_d_qgsflag)*phitin);
d_two_n_phit0_d_tambin=((2.0*d_n0_d_tambin)*phitin);
d_two_n_phit0_d_tnomin=((2.0*d_n0_d_tnomin)*phitin);
d_two_n_phit0_d_phitin=((2.0*n0)+phitin*(2.0*d_n0_d_phitin));
d_two_n_phit0_d_w=((2.0*d_n0_d_w)*phitin);
d_two_n_phit0_d_lin=((2.0*d_n0_d_lin)*phitin);
d_two_n_phit0_d_cgin=((2.0*d_n0_d_cgin)*phitin);
d_two_n_phit0_d_cs=((2.0*d_n0_d_cs)*phitin);
d_two_n_phit0_d_cc=((2.0*d_n0_d_cc)*phitin);
d_two_n_phit0_d_cb=((2.0*d_n0_d_cb)*phitin);
d_two_n_phit0_d_vto=((2.0*d_n0_d_vto)*phitin);
d_two_n_phit0_d_ss=((2.0*d_n0_d_ss)*phitin);
d_two_n_phit0_d_delta1=((2.0*d_n0_d_delta1)*phitin);
d_two_n_phit0_d_delta2=((2.0*d_n0_d_delta2)*phitin);
d_two_n_phit0_d_nd=((2.0*d_n0_d_nd)*phitin);
d_two_n_phit0_d_alpha=((2.0*d_n0_d_alpha)*phitin);
d_two_n_phit0_d_vel0=((2.0*d_n0_d_vel0)*phitin);
d_two_n_phit0_d_mu0=((2.0*d_n0_d_mu0)*phitin);
d_two_n_phit0_d_beta=((2.0*d_n0_d_beta)*phitin);
d_two_n_phit0_d_mtheta=((2.0*d_n0_d_mtheta)*phitin);
d_two_n_phit0_d_vtheta=((2.0*d_n0_d_vtheta)*phitin);
d_two_n_phit0_d_vtzeta=((2.0*d_n0_d_vtzeta)*phitin);
d_two_n_phit0_d_dibsat=((2.0*d_n0_d_dibsat)*phitin);
d_two_n_phit0_d_epsilon=((2.0*d_n0_d_epsilon)*phitin);
d_two_n_phit0_d_vzeta=((2.0*d_n0_d_vzeta)*phitin);
d_two_n_phit0_d_lambda=((2.0*d_n0_d_lambda)*phitin);
d_two_n_phit0_d_ngf=((2.0*d_n0_d_ngf)*phitin);
d_two_n_phit0_d_type=((2.0*d_n0_d_type)*phitin);
two_n_phit0=((2.0*n0)*phitin);
d_qref0_d_vgsin=(cgin*d_two_n_phit0_d_vgsin);
d_qref0_d_vdsin=(cgin*d_two_n_phit0_d_vdsin);
d_qref0_d_qcbflag=(cgin*d_two_n_phit0_d_qcbflag);
d_qref0_d_vcin=(cgin*d_two_n_phit0_d_vcin);
d_qref0_d_vbin=(cgin*d_two_n_phit0_d_vbin);
d_qref0_d_qgsflag=(cgin*d_two_n_phit0_d_qgsflag);
d_qref0_d_tambin=(cgin*d_two_n_phit0_d_tambin);
d_qref0_d_tnomin=(cgin*d_two_n_phit0_d_tnomin);
d_qref0_d_phitin=(cgin*d_two_n_phit0_d_phitin);
d_qref0_d_w=(cgin*d_two_n_phit0_d_w);
d_qref0_d_lin=(cgin*d_two_n_phit0_d_lin);
d_qref0_d_cgin=(cgin*d_two_n_phit0_d_cgin+two_n_phit0);
d_qref0_d_cs=(cgin*d_two_n_phit0_d_cs);
d_qref0_d_cc=(cgin*d_two_n_phit0_d_cc);
d_qref0_d_cb=(cgin*d_two_n_phit0_d_cb);
d_qref0_d_vto=(cgin*d_two_n_phit0_d_vto);
d_qref0_d_ss=(cgin*d_two_n_phit0_d_ss);
d_qref0_d_delta1=(cgin*d_two_n_phit0_d_delta1);
d_qref0_d_delta2=(cgin*d_two_n_phit0_d_delta2);
d_qref0_d_nd=(cgin*d_two_n_phit0_d_nd);
d_qref0_d_alpha=(cgin*d_two_n_phit0_d_alpha);
d_qref0_d_vel0=(cgin*d_two_n_phit0_d_vel0);
d_qref0_d_mu0=(cgin*d_two_n_phit0_d_mu0);
d_qref0_d_beta=(cgin*d_two_n_phit0_d_beta);
d_qref0_d_mtheta=(cgin*d_two_n_phit0_d_mtheta);
d_qref0_d_vtheta=(cgin*d_two_n_phit0_d_vtheta);
d_qref0_d_vtzeta=(cgin*d_two_n_phit0_d_vtzeta);
d_qref0_d_dibsat=(cgin*d_two_n_phit0_d_dibsat);
d_qref0_d_epsilon=(cgin*d_two_n_phit0_d_epsilon);
d_qref0_d_vzeta=(cgin*d_two_n_phit0_d_vzeta);
d_qref0_d_lambda=(cgin*d_two_n_phit0_d_lambda);
d_qref0_d_ngf=(cgin*d_two_n_phit0_d_ngf);
d_qref0_d_type=(cgin*d_two_n_phit0_d_type);
qref0=(cgin*two_n_phit0);
d_myarg0_d_vgsin=(d_vtof_d_vgsin-(d_alpha_phit_d_vgsin/2.0));
d_myarg0_d_vdsin=(d_vtof_d_vdsin-(d_alpha_phit_d_vdsin/2.0));
d_myarg0_d_qcbflag=(d_vtof_d_qcbflag-(d_alpha_phit_d_qcbflag/2.0));
d_myarg0_d_vcin=(d_vtof_d_vcin-(d_alpha_phit_d_vcin/2.0));
d_myarg0_d_vbin=(d_vtof_d_vbin-(d_alpha_phit_d_vbin/2.0));
d_myarg0_d_qgsflag=(d_vtof_d_qgsflag-(d_alpha_phit_d_qgsflag/2.0));
d_myarg0_d_tambin=(d_vtof_d_tambin-(d_alpha_phit_d_tambin/2.0));
d_myarg0_d_tnomin=(d_vtof_d_tnomin-(d_alpha_phit_d_tnomin/2.0));
d_myarg0_d_phitin=(d_vtof_d_phitin-(d_alpha_phit_d_phitin/2.0));
d_myarg0_d_w=(d_vtof_d_w-(d_alpha_phit_d_w/2.0));
d_myarg0_d_lin=(d_vtof_d_lin-(d_alpha_phit_d_lin/2.0));
d_myarg0_d_cgin=(d_vtof_d_cgin-(d_alpha_phit_d_cgin/2.0));
d_myarg0_d_cs=(d_vtof_d_cs-(d_alpha_phit_d_cs/2.0));
d_myarg0_d_cc=(d_vtof_d_cc-(d_alpha_phit_d_cc/2.0));
d_myarg0_d_cb=(d_vtof_d_cb-(d_alpha_phit_d_cb/2.0));
d_myarg0_d_vto=(d_vtof_d_vto-(d_alpha_phit_d_vto/2.0));
d_myarg0_d_ss=(d_vtof_d_ss-(d_alpha_phit_d_ss/2.0));
d_myarg0_d_delta1=(d_vtof_d_delta1-(d_alpha_phit_d_delta1/2.0));
d_myarg0_d_delta2=(d_vtof_d_delta2-(d_alpha_phit_d_delta2/2.0));
d_myarg0_d_nd=(d_vtof_d_nd-(d_alpha_phit_d_nd/2.0));
d_myarg0_d_alpha=(d_vtof_d_alpha-(d_alpha_phit_d_alpha/2.0));
d_myarg0_d_vel0=(d_vtof_d_vel0-(d_alpha_phit_d_vel0/2.0));
d_myarg0_d_mu0=(d_vtof_d_mu0-(d_alpha_phit_d_mu0/2.0));
d_myarg0_d_beta=(d_vtof_d_beta-(d_alpha_phit_d_beta/2.0));
d_myarg0_d_mtheta=(d_vtof_d_mtheta-(d_alpha_phit_d_mtheta/2.0));
d_myarg0_d_vtheta=(d_vtof_d_vtheta-(d_alpha_phit_d_vtheta/2.0));
d_myarg0_d_vtzeta=(d_vtof_d_vtzeta-(d_alpha_phit_d_vtzeta/2.0));
d_myarg0_d_dibsat=(d_vtof_d_dibsat-(d_alpha_phit_d_dibsat/2.0));
d_myarg0_d_epsilon=(d_vtof_d_epsilon-(d_alpha_phit_d_epsilon/2.0));
d_myarg0_d_vzeta=(d_vtof_d_vzeta-(d_alpha_phit_d_vzeta/2.0));
d_myarg0_d_lambda=(d_vtof_d_lambda-(d_alpha_phit_d_lambda/2.0));
d_myarg0_d_ngf=(d_vtof_d_ngf-(d_alpha_phit_d_ngf/2.0));
d_myarg0_d_type=(d_vtof_d_type-(d_alpha_phit_d_type/2.0));
myarg0=(vtof-(alpha_phit/2.0));
d_exparg0_d_vgsin=((alpha_phit*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-d_myarg0_d_vgsin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg0_d_vdsin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-d_myarg0_d_vdsin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg0_d_qcbflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-d_myarg0_d_qcbflag)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg0_d_vcin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-d_myarg0_d_vcin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg0_d_vbin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-d_myarg0_d_vbin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg0_d_qgsflag=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-d_myarg0_d_qgsflag)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg0_d_tambin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-d_myarg0_d_tambin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg0_d_tnomin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-d_myarg0_d_tnomin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg0_d_phitin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-d_myarg0_d_phitin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg0_d_w=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-d_myarg0_d_w)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg0_d_lin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-d_myarg0_d_lin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg0_d_cgin=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-d_myarg0_d_cgin)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg0_d_cs=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-d_myarg0_d_cs)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg0_d_cc=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-d_myarg0_d_cc)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg0_d_cb=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-d_myarg0_d_cb)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg0_d_vto=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-d_myarg0_d_vto)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg0_d_ss=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-d_myarg0_d_ss)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg0_d_delta1=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-d_myarg0_d_delta1)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg0_d_delta2=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-d_myarg0_d_delta2)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg0_d_nd=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-d_myarg0_d_nd)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg0_d_alpha=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-d_myarg0_d_alpha)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg0_d_vel0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-d_myarg0_d_vel0)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg0_d_mu0=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-d_myarg0_d_mu0)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg0_d_beta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-d_myarg0_d_beta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg0_d_mtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-d_myarg0_d_mtheta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtheta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-d_myarg0_d_vtheta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-d_myarg0_d_vtzeta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg0_d_dibsat=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-d_myarg0_d_dibsat)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg0_d_epsilon=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-d_myarg0_d_epsilon)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg0_d_vzeta=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-d_myarg0_d_vzeta)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg0_d_lambda=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-d_myarg0_d_lambda)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg0_d_ngf=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-d_myarg0_d_ngf)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg0_d_type=((alpha_phit*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-d_myarg0_d_type)-(mmax(vgsin,vgdin)-myarg0)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg0=((mmax(vgsin,vgdin)-myarg0)/alpha_phit);
if((exparg0>50.0))
{
d_ff0_d_vgsin=0.0;
d_ff0_d_vdsin=0.0;
d_ff0_d_qcbflag=0.0;
d_ff0_d_vcin=0.0;
d_ff0_d_vbin=0.0;
d_ff0_d_qgsflag=0.0;
d_ff0_d_tambin=0.0;
d_ff0_d_tnomin=0.0;
d_ff0_d_phitin=0.0;
d_ff0_d_w=0.0;
d_ff0_d_lin=0.0;
d_ff0_d_cgin=0.0;
d_ff0_d_cs=0.0;
d_ff0_d_cc=0.0;
d_ff0_d_cb=0.0;
d_ff0_d_vto=0.0;
d_ff0_d_ss=0.0;
d_ff0_d_delta1=0.0;
d_ff0_d_delta2=0.0;
d_ff0_d_nd=0.0;
d_ff0_d_alpha=0.0;
d_ff0_d_vel0=0.0;
d_ff0_d_mu0=0.0;
d_ff0_d_beta=0.0;
d_ff0_d_mtheta=0.0;
d_ff0_d_vtheta=0.0;
d_ff0_d_vtzeta=0.0;
d_ff0_d_dibsat=0.0;
d_ff0_d_epsilon=0.0;
d_ff0_d_vzeta=0.0;
d_ff0_d_lambda=0.0;
d_ff0_d_ngf=0.0;
d_ff0_d_type=0.0;
ff0=0.0;
}
else
{
if((exparg0<(-50.0)))
{
d_ff0_d_vgsin=0.0;
d_ff0_d_vdsin=0.0;
d_ff0_d_qcbflag=0.0;
d_ff0_d_vcin=0.0;
d_ff0_d_vbin=0.0;
d_ff0_d_qgsflag=0.0;
d_ff0_d_tambin=0.0;
d_ff0_d_tnomin=0.0;
d_ff0_d_phitin=0.0;
d_ff0_d_w=0.0;
d_ff0_d_lin=0.0;
d_ff0_d_cgin=0.0;
d_ff0_d_cs=0.0;
d_ff0_d_cc=0.0;
d_ff0_d_cb=0.0;
d_ff0_d_vto=0.0;
d_ff0_d_ss=0.0;
d_ff0_d_delta1=0.0;
d_ff0_d_delta2=0.0;
d_ff0_d_nd=0.0;
d_ff0_d_alpha=0.0;
d_ff0_d_vel0=0.0;
d_ff0_d_mu0=0.0;
d_ff0_d_beta=0.0;
d_ff0_d_mtheta=0.0;
d_ff0_d_vtheta=0.0;
d_ff0_d_vtzeta=0.0;
d_ff0_d_dibsat=0.0;
d_ff0_d_epsilon=0.0;
d_ff0_d_vzeta=0.0;
d_ff0_d_lambda=0.0;
d_ff0_d_ngf=0.0;
d_ff0_d_type=0.0;
ff0=1.0;
}
else
{
d_ff0_d_vgsin=(-exp(exparg0)*d_exparg0_d_vgsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vdsin=(-exp(exparg0)*d_exparg0_d_vdsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_qcbflag=(-exp(exparg0)*d_exparg0_d_qcbflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vcin=(-exp(exparg0)*d_exparg0_d_vcin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vbin=(-exp(exparg0)*d_exparg0_d_vbin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_qgsflag=(-exp(exparg0)*d_exparg0_d_qgsflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_tambin=(-exp(exparg0)*d_exparg0_d_tambin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_tnomin=(-exp(exparg0)*d_exparg0_d_tnomin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_phitin=(-exp(exparg0)*d_exparg0_d_phitin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_w=(-exp(exparg0)*d_exparg0_d_w/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_lin=(-exp(exparg0)*d_exparg0_d_lin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cgin=(-exp(exparg0)*d_exparg0_d_cgin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cs=(-exp(exparg0)*d_exparg0_d_cs/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cc=(-exp(exparg0)*d_exparg0_d_cc/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_cb=(-exp(exparg0)*d_exparg0_d_cb/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vto=(-exp(exparg0)*d_exparg0_d_vto/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_ss=(-exp(exparg0)*d_exparg0_d_ss/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_delta1=(-exp(exparg0)*d_exparg0_d_delta1/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_delta2=(-exp(exparg0)*d_exparg0_d_delta2/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_nd=(-exp(exparg0)*d_exparg0_d_nd/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_alpha=(-exp(exparg0)*d_exparg0_d_alpha/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vel0=(-exp(exparg0)*d_exparg0_d_vel0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_mu0=(-exp(exparg0)*d_exparg0_d_mu0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_beta=(-exp(exparg0)*d_exparg0_d_beta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_mtheta=(-exp(exparg0)*d_exparg0_d_mtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vtheta=(-exp(exparg0)*d_exparg0_d_vtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vtzeta=(-exp(exparg0)*d_exparg0_d_vtzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_dibsat=(-exp(exparg0)*d_exparg0_d_dibsat/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_epsilon=(-exp(exparg0)*d_exparg0_d_epsilon/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_vzeta=(-exp(exparg0)*d_exparg0_d_vzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_lambda=(-exp(exparg0)*d_exparg0_d_lambda/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_ngf=(-exp(exparg0)*d_exparg0_d_ngf/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ff0_d_type=(-exp(exparg0)*d_exparg0_d_type/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
ff0=(1.0/(1.0+exp(exparg0)));
}
}
d_eta0_d_vgsin=((two_n_phit0*(d_mmax(vgsin,vgdin,1.0,d_vgdin_d_vgsin)-(d_vtof_d_vgsin-(((0.1*alpha_phit)*d_ff0_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_eta0_d_vdsin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vdsin)-(d_vtof_d_vdsin-(((0.1*alpha_phit)*d_ff0_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_eta0_d_qcbflag=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qcbflag)-(d_vtof_d_qcbflag-(((0.1*alpha_phit)*d_ff0_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_eta0_d_vcin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vcin)-(d_vtof_d_vcin-(((0.1*alpha_phit)*d_ff0_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_eta0_d_vbin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vbin)-(d_vtof_d_vbin-(((0.1*alpha_phit)*d_ff0_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_eta0_d_qgsflag=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_qgsflag)-(d_vtof_d_qgsflag-(((0.1*alpha_phit)*d_ff0_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_eta0_d_tambin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tambin)-(d_vtof_d_tambin-(((0.1*alpha_phit)*d_ff0_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_eta0_d_tnomin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_tnomin)-(d_vtof_d_tnomin-(((0.1*alpha_phit)*d_ff0_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_eta0_d_phitin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_phitin)-(d_vtof_d_phitin-(((0.1*alpha_phit)*d_ff0_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_eta0_d_w=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_w)-(d_vtof_d_w-(((0.1*alpha_phit)*d_ff0_d_w)+((0.1*d_alpha_phit_d_w)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_eta0_d_lin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lin)-(d_vtof_d_lin-(((0.1*alpha_phit)*d_ff0_d_lin)+((0.1*d_alpha_phit_d_lin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_eta0_d_cgin=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cgin)-(d_vtof_d_cgin-(((0.1*alpha_phit)*d_ff0_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_eta0_d_cs=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cs)-(d_vtof_d_cs-(((0.1*alpha_phit)*d_ff0_d_cs)+((0.1*d_alpha_phit_d_cs)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_eta0_d_cc=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cc)-(d_vtof_d_cc-(((0.1*alpha_phit)*d_ff0_d_cc)+((0.1*d_alpha_phit_d_cc)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_eta0_d_cb=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_cb)-(d_vtof_d_cb-(((0.1*alpha_phit)*d_ff0_d_cb)+((0.1*d_alpha_phit_d_cb)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_eta0_d_vto=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vto)-(d_vtof_d_vto-(((0.1*alpha_phit)*d_ff0_d_vto)+((0.1*d_alpha_phit_d_vto)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_eta0_d_ss=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ss)-(d_vtof_d_ss-(((0.1*alpha_phit)*d_ff0_d_ss)+((0.1*d_alpha_phit_d_ss)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_eta0_d_delta1=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta1)-(d_vtof_d_delta1-(((0.1*alpha_phit)*d_ff0_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_eta0_d_delta2=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_delta2)-(d_vtof_d_delta2-(((0.1*alpha_phit)*d_ff0_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_eta0_d_nd=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_nd)-(d_vtof_d_nd-(((0.1*alpha_phit)*d_ff0_d_nd)+((0.1*d_alpha_phit_d_nd)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_eta0_d_alpha=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_alpha)-(d_vtof_d_alpha-(((0.1*alpha_phit)*d_ff0_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_eta0_d_vel0=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vel0)-(d_vtof_d_vel0-(((0.1*alpha_phit)*d_ff0_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_eta0_d_mu0=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mu0)-(d_vtof_d_mu0-(((0.1*alpha_phit)*d_ff0_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_eta0_d_beta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_beta)-(d_vtof_d_beta-(((0.1*alpha_phit)*d_ff0_d_beta)+((0.1*d_alpha_phit_d_beta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_eta0_d_mtheta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_mtheta)-(d_vtof_d_mtheta-(((0.1*alpha_phit)*d_ff0_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_eta0_d_vtheta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtheta)-(d_vtof_d_vtheta-(((0.1*alpha_phit)*d_ff0_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_eta0_d_vtzeta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vtzeta)-(d_vtof_d_vtzeta-(((0.1*alpha_phit)*d_ff0_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_eta0_d_dibsat=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_dibsat)-(d_vtof_d_dibsat-(((0.1*alpha_phit)*d_ff0_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_eta0_d_epsilon=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_epsilon)-(d_vtof_d_epsilon-(((0.1*alpha_phit)*d_ff0_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_eta0_d_vzeta=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_vzeta)-(d_vtof_d_vzeta-(((0.1*alpha_phit)*d_ff0_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_eta0_d_lambda=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_lambda)-(d_vtof_d_lambda-(((0.1*alpha_phit)*d_ff0_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_eta0_d_ngf=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_ngf)-(d_vtof_d_ngf-(((0.1*alpha_phit)*d_ff0_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_eta0_d_type=((two_n_phit0*(d_mmax(vgsin,vgdin,0.0,d_vgdin_d_type)-(d_vtof_d_type-(((0.1*alpha_phit)*d_ff0_d_type)+((0.1*d_alpha_phit_d_type)*ff0))))-(mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
eta0=((mmax(vgsin,vgdin)-(vtof-((0.1*alpha_phit)*ff0)))/two_n_phit0);
if((eta0>50.0))
{
d_qinvv0_d_vgsin=((qref0*d_eta0_d_vgsin)+(d_qref0_d_vgsin*eta0));
d_qinvv0_d_vdsin=((qref0*d_eta0_d_vdsin)+(d_qref0_d_vdsin*eta0));
d_qinvv0_d_qcbflag=((qref0*d_eta0_d_qcbflag)+(d_qref0_d_qcbflag*eta0));
d_qinvv0_d_vcin=((qref0*d_eta0_d_vcin)+(d_qref0_d_vcin*eta0));
d_qinvv0_d_vbin=((qref0*d_eta0_d_vbin)+(d_qref0_d_vbin*eta0));
d_qinvv0_d_qgsflag=((qref0*d_eta0_d_qgsflag)+(d_qref0_d_qgsflag*eta0));
d_qinvv0_d_tambin=((qref0*d_eta0_d_tambin)+(d_qref0_d_tambin*eta0));
d_qinvv0_d_tnomin=((qref0*d_eta0_d_tnomin)+(d_qref0_d_tnomin*eta0));
d_qinvv0_d_phitin=((qref0*d_eta0_d_phitin)+(d_qref0_d_phitin*eta0));
d_qinvv0_d_w=((qref0*d_eta0_d_w)+(d_qref0_d_w*eta0));
d_qinvv0_d_lin=((qref0*d_eta0_d_lin)+(d_qref0_d_lin*eta0));
d_qinvv0_d_cgin=((qref0*d_eta0_d_cgin)+(d_qref0_d_cgin*eta0));
d_qinvv0_d_cs=((qref0*d_eta0_d_cs)+(d_qref0_d_cs*eta0));
d_qinvv0_d_cc=((qref0*d_eta0_d_cc)+(d_qref0_d_cc*eta0));
d_qinvv0_d_cb=((qref0*d_eta0_d_cb)+(d_qref0_d_cb*eta0));
d_qinvv0_d_vto=((qref0*d_eta0_d_vto)+(d_qref0_d_vto*eta0));
d_qinvv0_d_ss=((qref0*d_eta0_d_ss)+(d_qref0_d_ss*eta0));
d_qinvv0_d_delta1=((qref0*d_eta0_d_delta1)+(d_qref0_d_delta1*eta0));
d_qinvv0_d_delta2=((qref0*d_eta0_d_delta2)+(d_qref0_d_delta2*eta0));
d_qinvv0_d_nd=((qref0*d_eta0_d_nd)+(d_qref0_d_nd*eta0));
d_qinvv0_d_alpha=((qref0*d_eta0_d_alpha)+(d_qref0_d_alpha*eta0));
d_qinvv0_d_vel0=((qref0*d_eta0_d_vel0)+(d_qref0_d_vel0*eta0));
d_qinvv0_d_mu0=((qref0*d_eta0_d_mu0)+(d_qref0_d_mu0*eta0));
d_qinvv0_d_beta=((qref0*d_eta0_d_beta)+(d_qref0_d_beta*eta0));
d_qinvv0_d_mtheta=((qref0*d_eta0_d_mtheta)+(d_qref0_d_mtheta*eta0));
d_qinvv0_d_vtheta=((qref0*d_eta0_d_vtheta)+(d_qref0_d_vtheta*eta0));
d_qinvv0_d_vtzeta=((qref0*d_eta0_d_vtzeta)+(d_qref0_d_vtzeta*eta0));
d_qinvv0_d_dibsat=((qref0*d_eta0_d_dibsat)+(d_qref0_d_dibsat*eta0));
d_qinvv0_d_epsilon=((qref0*d_eta0_d_epsilon)+(d_qref0_d_epsilon*eta0));
d_qinvv0_d_vzeta=((qref0*d_eta0_d_vzeta)+(d_qref0_d_vzeta*eta0));
d_qinvv0_d_lambda=((qref0*d_eta0_d_lambda)+(d_qref0_d_lambda*eta0));
d_qinvv0_d_ngf=((qref0*d_eta0_d_ngf)+(d_qref0_d_ngf*eta0));
d_qinvv0_d_type=((qref0*d_eta0_d_type)+(d_qref0_d_type*eta0));
qinvv0=(qref0*eta0);
}
else
{
if((eta0<(-50.0)))
{
d_qinvv0_d_vgsin=0.0;
d_qinvv0_d_vdsin=0.0;
d_qinvv0_d_qcbflag=0.0;
d_qinvv0_d_vcin=0.0;
d_qinvv0_d_vbin=0.0;
d_qinvv0_d_qgsflag=0.0;
d_qinvv0_d_tambin=0.0;
d_qinvv0_d_tnomin=0.0;
d_qinvv0_d_phitin=0.0;
d_qinvv0_d_w=0.0;
d_qinvv0_d_lin=0.0;
d_qinvv0_d_cgin=0.0;
d_qinvv0_d_cs=0.0;
d_qinvv0_d_cc=0.0;
d_qinvv0_d_cb=0.0;
d_qinvv0_d_vto=0.0;
d_qinvv0_d_ss=0.0;
d_qinvv0_d_delta1=0.0;
d_qinvv0_d_delta2=0.0;
d_qinvv0_d_nd=0.0;
d_qinvv0_d_alpha=0.0;
d_qinvv0_d_vel0=0.0;
d_qinvv0_d_mu0=0.0;
d_qinvv0_d_beta=0.0;
d_qinvv0_d_mtheta=0.0;
d_qinvv0_d_vtheta=0.0;
d_qinvv0_d_vtzeta=0.0;
d_qinvv0_d_dibsat=0.0;
d_qinvv0_d_epsilon=0.0;
d_qinvv0_d_vzeta=0.0;
d_qinvv0_d_lambda=0.0;
d_qinvv0_d_ngf=0.0;
d_qinvv0_d_type=0.0;
qinvv0=0;
}
else
{
d_qinvv0_d_vgsin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vgsin)+(d_qref0_d_vgsin*log((1.0+exp(eta0)))));
d_qinvv0_d_vdsin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vdsin)+(d_qref0_d_vdsin*log((1.0+exp(eta0)))));
d_qinvv0_d_qcbflag=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_qcbflag)+(d_qref0_d_qcbflag*log((1.0+exp(eta0)))));
d_qinvv0_d_vcin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vcin)+(d_qref0_d_vcin*log((1.0+exp(eta0)))));
d_qinvv0_d_vbin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vbin)+(d_qref0_d_vbin*log((1.0+exp(eta0)))));
d_qinvv0_d_qgsflag=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_qgsflag)+(d_qref0_d_qgsflag*log((1.0+exp(eta0)))));
d_qinvv0_d_tambin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_tambin)+(d_qref0_d_tambin*log((1.0+exp(eta0)))));
d_qinvv0_d_tnomin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_tnomin)+(d_qref0_d_tnomin*log((1.0+exp(eta0)))));
d_qinvv0_d_phitin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_phitin)+(d_qref0_d_phitin*log((1.0+exp(eta0)))));
d_qinvv0_d_w=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_w)+(d_qref0_d_w*log((1.0+exp(eta0)))));
d_qinvv0_d_lin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_lin)+(d_qref0_d_lin*log((1.0+exp(eta0)))));
d_qinvv0_d_cgin=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cgin)+(d_qref0_d_cgin*log((1.0+exp(eta0)))));
d_qinvv0_d_cs=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cs)+(d_qref0_d_cs*log((1.0+exp(eta0)))));
d_qinvv0_d_cc=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cc)+(d_qref0_d_cc*log((1.0+exp(eta0)))));
d_qinvv0_d_cb=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_cb)+(d_qref0_d_cb*log((1.0+exp(eta0)))));
d_qinvv0_d_vto=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vto)+(d_qref0_d_vto*log((1.0+exp(eta0)))));
d_qinvv0_d_ss=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_ss)+(d_qref0_d_ss*log((1.0+exp(eta0)))));
d_qinvv0_d_delta1=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_delta1)+(d_qref0_d_delta1*log((1.0+exp(eta0)))));
d_qinvv0_d_delta2=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_delta2)+(d_qref0_d_delta2*log((1.0+exp(eta0)))));
d_qinvv0_d_nd=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_nd)+(d_qref0_d_nd*log((1.0+exp(eta0)))));
d_qinvv0_d_alpha=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_alpha)+(d_qref0_d_alpha*log((1.0+exp(eta0)))));
d_qinvv0_d_vel0=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vel0)+(d_qref0_d_vel0*log((1.0+exp(eta0)))));
d_qinvv0_d_mu0=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_mu0)+(d_qref0_d_mu0*log((1.0+exp(eta0)))));
d_qinvv0_d_beta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_beta)+(d_qref0_d_beta*log((1.0+exp(eta0)))));
d_qinvv0_d_mtheta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_mtheta)+(d_qref0_d_mtheta*log((1.0+exp(eta0)))));
d_qinvv0_d_vtheta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vtheta)+(d_qref0_d_vtheta*log((1.0+exp(eta0)))));
d_qinvv0_d_vtzeta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vtzeta)+(d_qref0_d_vtzeta*log((1.0+exp(eta0)))));
d_qinvv0_d_dibsat=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_dibsat)+(d_qref0_d_dibsat*log((1.0+exp(eta0)))));
d_qinvv0_d_epsilon=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_epsilon)+(d_qref0_d_epsilon*log((1.0+exp(eta0)))));
d_qinvv0_d_vzeta=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_vzeta)+(d_qref0_d_vzeta*log((1.0+exp(eta0)))));
d_qinvv0_d_lambda=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_lambda)+(d_qref0_d_lambda*log((1.0+exp(eta0)))));
d_qinvv0_d_ngf=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_ngf)+(d_qref0_d_ngf*log((1.0+exp(eta0)))));
d_qinvv0_d_type=((qref0*(1.0/(1.0+exp(eta0)))*exp(eta0)*d_eta0_d_type)+(d_qref0_d_type*log((1.0+exp(eta0)))));
qinvv0=(qref0*log((1.0+exp(eta0))));
}
}
d_muf0_d_vgsin=0.0;
d_muf0_d_vdsin=0.0;
d_muf0_d_qcbflag=0.0;
d_muf0_d_vcin=0.0;
d_muf0_d_vbin=0.0;
d_muf0_d_qgsflag=0.0;
d_muf0_d_tambin=(-mu0*(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(1.0/tnomin)/pow((tambin/tnomin),epsilon)/pow((tambin/tnomin),epsilon));
d_muf0_d_tnomin=(-mu0*(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),epsilon)*epsilon/(tambin/tnomin)))*(-tambin/tnomin/tnomin)/pow((tambin/tnomin),epsilon)/pow((tambin/tnomin),epsilon));
d_muf0_d_phitin=0.0;
d_muf0_d_w=0.0;
d_muf0_d_lin=0.0;
d_muf0_d_cgin=0.0;
d_muf0_d_cs=0.0;
d_muf0_d_cc=0.0;
d_muf0_d_cb=0.0;
d_muf0_d_vto=0.0;
d_muf0_d_ss=0.0;
d_muf0_d_delta1=0.0;
d_muf0_d_delta2=0.0;
d_muf0_d_nd=0.0;
d_muf0_d_alpha=0.0;
d_muf0_d_vel0=0.0;
d_muf0_d_mu0=(1.0/pow((tambin/tnomin),epsilon));
d_muf0_d_beta=0.0;
d_muf0_d_mtheta=0.0;
d_muf0_d_vtheta=0.0;
d_muf0_d_vtzeta=0.0;
d_muf0_d_dibsat=0.0;
d_muf0_d_epsilon=(-mu0*(((tambin/tnomin)==0.0)?0.0:(log((tambin/tnomin)*pow((tambin/tnomin),epsilon))))/pow((tambin/tnomin),epsilon)/pow((tambin/tnomin),epsilon));
d_muf0_d_vzeta=0.0;
d_muf0_d_lambda=0.0;
d_muf0_d_ngf=0.0;
d_muf0_d_type=0.0;
muf0=(mu0/pow((tambin/tnomin),epsilon));
d_vx0_d_vgsin=0.0;
d_vx0_d_vdsin=0.0;
d_vx0_d_qcbflag=0.0;
d_vx0_d_vcin=0.0;
d_vx0_d_vbin=0.0;
d_vx0_d_qgsflag=0.0;
d_vx0_d_tambin=(vel0*(-(1.0+(vzeta*tnomin))*(vzeta)/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))));
d_vx0_d_tnomin=(vel0*((vzeta)/(1.0+(vzeta*tambin))));
d_vx0_d_phitin=0.0;
d_vx0_d_w=0.0;
d_vx0_d_lin=0.0;
d_vx0_d_cgin=0.0;
d_vx0_d_cs=0.0;
d_vx0_d_cc=0.0;
d_vx0_d_cb=0.0;
d_vx0_d_vto=0.0;
d_vx0_d_ss=0.0;
d_vx0_d_delta1=0.0;
d_vx0_d_delta2=0.0;
d_vx0_d_nd=0.0;
d_vx0_d_alpha=0.0;
d_vx0_d_vel0=(((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))));
d_vx0_d_mu0=0.0;
d_vx0_d_beta=0.0;
d_vx0_d_mtheta=0.0;
d_vx0_d_vtheta=0.0;
d_vx0_d_vtzeta=0.0;
d_vx0_d_dibsat=0.0;
d_vx0_d_epsilon=0.0;
d_vx0_d_vzeta=(vel0*(((1.0+(vzeta*tambin))*(tnomin)-(1.0+(vzeta*tnomin))*(tambin))/(1.0+(vzeta*tambin))/(1.0+(vzeta*tambin))));
d_vx0_d_lambda=0.0;
d_vx0_d_ngf=0.0;
d_vx0_d_type=0.0;
vx0=(vel0*((1.0+(vzeta*tnomin))/(1.0+(vzeta*tambin))));
d_vdsats0_d_vgsin=((muf0*(d_vx0_d_vgsin*lin)-(vx0*lin)*d_muf0_d_vgsin)/muf0/muf0);
d_vdsats0_d_vdsin=((muf0*(d_vx0_d_vdsin*lin)-(vx0*lin)*d_muf0_d_vdsin)/muf0/muf0);
d_vdsats0_d_qcbflag=((muf0*(d_vx0_d_qcbflag*lin)-(vx0*lin)*d_muf0_d_qcbflag)/muf0/muf0);
d_vdsats0_d_vcin=((muf0*(d_vx0_d_vcin*lin)-(vx0*lin)*d_muf0_d_vcin)/muf0/muf0);
d_vdsats0_d_vbin=((muf0*(d_vx0_d_vbin*lin)-(vx0*lin)*d_muf0_d_vbin)/muf0/muf0);
d_vdsats0_d_qgsflag=((muf0*(d_vx0_d_qgsflag*lin)-(vx0*lin)*d_muf0_d_qgsflag)/muf0/muf0);
d_vdsats0_d_tambin=((muf0*(d_vx0_d_tambin*lin)-(vx0*lin)*d_muf0_d_tambin)/muf0/muf0);
d_vdsats0_d_tnomin=((muf0*(d_vx0_d_tnomin*lin)-(vx0*lin)*d_muf0_d_tnomin)/muf0/muf0);
d_vdsats0_d_phitin=((muf0*(d_vx0_d_phitin*lin)-(vx0*lin)*d_muf0_d_phitin)/muf0/muf0);
d_vdsats0_d_w=((muf0*(d_vx0_d_w*lin)-(vx0*lin)*d_muf0_d_w)/muf0/muf0);
d_vdsats0_d_lin=((muf0*(vx0+lin*d_vx0_d_lin)-(vx0*lin)*d_muf0_d_lin)/muf0/muf0);
d_vdsats0_d_cgin=((muf0*(d_vx0_d_cgin*lin)-(vx0*lin)*d_muf0_d_cgin)/muf0/muf0);
d_vdsats0_d_cs=((muf0*(d_vx0_d_cs*lin)-(vx0*lin)*d_muf0_d_cs)/muf0/muf0);
d_vdsats0_d_cc=((muf0*(d_vx0_d_cc*lin)-(vx0*lin)*d_muf0_d_cc)/muf0/muf0);
d_vdsats0_d_cb=((muf0*(d_vx0_d_cb*lin)-(vx0*lin)*d_muf0_d_cb)/muf0/muf0);
d_vdsats0_d_vto=((muf0*(d_vx0_d_vto*lin)-(vx0*lin)*d_muf0_d_vto)/muf0/muf0);
d_vdsats0_d_ss=((muf0*(d_vx0_d_ss*lin)-(vx0*lin)*d_muf0_d_ss)/muf0/muf0);
d_vdsats0_d_delta1=((muf0*(d_vx0_d_delta1*lin)-(vx0*lin)*d_muf0_d_delta1)/muf0/muf0);
d_vdsats0_d_delta2=((muf0*(d_vx0_d_delta2*lin)-(vx0*lin)*d_muf0_d_delta2)/muf0/muf0);
d_vdsats0_d_nd=((muf0*(d_vx0_d_nd*lin)-(vx0*lin)*d_muf0_d_nd)/muf0/muf0);
d_vdsats0_d_alpha=((muf0*(d_vx0_d_alpha*lin)-(vx0*lin)*d_muf0_d_alpha)/muf0/muf0);
d_vdsats0_d_vel0=((muf0*(d_vx0_d_vel0*lin)-(vx0*lin)*d_muf0_d_vel0)/muf0/muf0);
d_vdsats0_d_mu0=((muf0*(d_vx0_d_mu0*lin)-(vx0*lin)*d_muf0_d_mu0)/muf0/muf0);
d_vdsats0_d_beta=((muf0*(d_vx0_d_beta*lin)-(vx0*lin)*d_muf0_d_beta)/muf0/muf0);
d_vdsats0_d_mtheta=((muf0*(d_vx0_d_mtheta*lin)-(vx0*lin)*d_muf0_d_mtheta)/muf0/muf0);
d_vdsats0_d_vtheta=((muf0*(d_vx0_d_vtheta*lin)-(vx0*lin)*d_muf0_d_vtheta)/muf0/muf0);
d_vdsats0_d_vtzeta=((muf0*(d_vx0_d_vtzeta*lin)-(vx0*lin)*d_muf0_d_vtzeta)/muf0/muf0);
d_vdsats0_d_dibsat=((muf0*(d_vx0_d_dibsat*lin)-(vx0*lin)*d_muf0_d_dibsat)/muf0/muf0);
d_vdsats0_d_epsilon=((muf0*(d_vx0_d_epsilon*lin)-(vx0*lin)*d_muf0_d_epsilon)/muf0/muf0);
d_vdsats0_d_vzeta=((muf0*(d_vx0_d_vzeta*lin)-(vx0*lin)*d_muf0_d_vzeta)/muf0/muf0);
d_vdsats0_d_lambda=((muf0*(d_vx0_d_lambda*lin)-(vx0*lin)*d_muf0_d_lambda)/muf0/muf0);
d_vdsats0_d_ngf=((muf0*(d_vx0_d_ngf*lin)-(vx0*lin)*d_muf0_d_ngf)/muf0/muf0);
d_vdsats0_d_type=((muf0*(d_vx0_d_type*lin)-(vx0*lin)*d_muf0_d_type)/muf0/muf0);
vdsats0=((vx0*lin)/muf0);
d_vdsats10_d_vgsin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vgsin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vgsin)/vdsats0/vdsats0))+(d_vdsats0_d_vgsin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vgsin);
d_vdsats10_d_vdsin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vdsin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vdsin)/vdsats0/vdsats0))+(d_vdsats0_d_vdsin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vdsin);
d_vdsats10_d_qcbflag=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_qcbflag)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_qcbflag)/vdsats0/vdsats0))+(d_vdsats0_d_qcbflag*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_qcbflag);
d_vdsats10_d_vcin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vcin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vcin)/vdsats0/vdsats0))+(d_vdsats0_d_vcin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vcin);
d_vdsats10_d_vbin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vbin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vbin)/vdsats0/vdsats0))+(d_vdsats0_d_vbin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vbin);
d_vdsats10_d_qgsflag=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_qgsflag)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_qgsflag)/vdsats0/vdsats0))+(d_vdsats0_d_qgsflag*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_qgsflag);
d_vdsats10_d_tambin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_tambin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_tambin)/vdsats0/vdsats0))+(d_vdsats0_d_tambin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_tambin);
d_vdsats10_d_tnomin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_tnomin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_tnomin)/vdsats0/vdsats0))+(d_vdsats0_d_tnomin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_tnomin);
d_vdsats10_d_phitin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_phitin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_phitin)/vdsats0/vdsats0))+(d_vdsats0_d_phitin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_phitin);
d_vdsats10_d_w=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_w)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_w)/vdsats0/vdsats0))+(d_vdsats0_d_w*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_w);
d_vdsats10_d_lin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_lin)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_lin)/vdsats0/vdsats0))+(d_vdsats0_d_lin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_lin);
d_vdsats10_d_cgin=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((cgin*(2.0*d_qinvv0_d_cgin)-(2.0*qinvv0))/cgin/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cgin)/vdsats0/vdsats0))+(d_vdsats0_d_cgin*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cgin);
d_vdsats10_d_cs=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_cs)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cs)/vdsats0/vdsats0))+(d_vdsats0_d_cs*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cs);
d_vdsats10_d_cc=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_cc)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cc)/vdsats0/vdsats0))+(d_vdsats0_d_cc*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cc);
d_vdsats10_d_cb=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_cb)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_cb)/vdsats0/vdsats0))+(d_vdsats0_d_cb*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_cb);
d_vdsats10_d_vto=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vto)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vto)/vdsats0/vdsats0))+(d_vdsats0_d_vto*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vto);
d_vdsats10_d_ss=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_ss)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_ss)/vdsats0/vdsats0))+(d_vdsats0_d_ss*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_ss);
d_vdsats10_d_delta1=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_delta1)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_delta1)/vdsats0/vdsats0))+(d_vdsats0_d_delta1*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_delta1);
d_vdsats10_d_delta2=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_delta2)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_delta2)/vdsats0/vdsats0))+(d_vdsats0_d_delta2*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_delta2);
d_vdsats10_d_nd=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_nd)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_nd)/vdsats0/vdsats0))+(d_vdsats0_d_nd*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_nd);
d_vdsats10_d_alpha=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_alpha)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_alpha)/vdsats0/vdsats0))+(d_vdsats0_d_alpha*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_alpha);
d_vdsats10_d_vel0=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vel0)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vel0)/vdsats0/vdsats0))+(d_vdsats0_d_vel0*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vel0);
d_vdsats10_d_mu0=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_mu0)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_mu0)/vdsats0/vdsats0))+(d_vdsats0_d_mu0*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_mu0);
d_vdsats10_d_beta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_beta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_beta)/vdsats0/vdsats0))+(d_vdsats0_d_beta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_beta);
d_vdsats10_d_mtheta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_mtheta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_mtheta)/vdsats0/vdsats0))+(d_vdsats0_d_mtheta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_mtheta);
d_vdsats10_d_vtheta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vtheta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vtheta)/vdsats0/vdsats0))+(d_vdsats0_d_vtheta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vtheta);
d_vdsats10_d_vtzeta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vtzeta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vtzeta)/vdsats0/vdsats0))+(d_vdsats0_d_vtzeta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vtzeta);
d_vdsats10_d_dibsat=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_dibsat)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_dibsat)/vdsats0/vdsats0))+(d_vdsats0_d_dibsat*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_dibsat);
d_vdsats10_d_epsilon=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_epsilon)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_epsilon)/vdsats0/vdsats0))+(d_vdsats0_d_epsilon*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_epsilon);
d_vdsats10_d_vzeta=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_vzeta)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_vzeta)/vdsats0/vdsats0))+(d_vdsats0_d_vzeta*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_vzeta);
d_vdsats10_d_lambda=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_lambda)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_lambda)/vdsats0/vdsats0))+(d_vdsats0_d_lambda*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_lambda);
d_vdsats10_d_ngf=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_ngf)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_ngf)/vdsats0/vdsats0))+(d_vdsats0_d_ngf*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_ngf);
d_vdsats10_d_type=(((vdsats0*(0.5/sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))*((vdsats0*((2.0*d_qinvv0_d_type)/cgin)-((2.0*qinvv0)/cgin)*d_vdsats0_d_type)/vdsats0/vdsats0))+(d_vdsats0_d_type*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0)))))-d_vdsats0_d_type);
vdsats10=((vdsats0*sqrt((1.0+(((2.0*qinvv0)/cgin)/vdsats0))))-vdsats0);
d_vdsat10_d_vgsin=(((vdsats10*(-d_ff0_d_vgsin))+(d_vdsats10_d_vgsin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vgsin)+(d_two_n_phit0_d_vgsin*ff0)));
d_vdsat10_d_vdsin=(((vdsats10*(-d_ff0_d_vdsin))+(d_vdsats10_d_vdsin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vdsin)+(d_two_n_phit0_d_vdsin*ff0)));
d_vdsat10_d_qcbflag=(((vdsats10*(-d_ff0_d_qcbflag))+(d_vdsats10_d_qcbflag*(1.0-ff0)))+((two_n_phit0*d_ff0_d_qcbflag)+(d_two_n_phit0_d_qcbflag*ff0)));
d_vdsat10_d_vcin=(((vdsats10*(-d_ff0_d_vcin))+(d_vdsats10_d_vcin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vcin)+(d_two_n_phit0_d_vcin*ff0)));
d_vdsat10_d_vbin=(((vdsats10*(-d_ff0_d_vbin))+(d_vdsats10_d_vbin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vbin)+(d_two_n_phit0_d_vbin*ff0)));
d_vdsat10_d_qgsflag=(((vdsats10*(-d_ff0_d_qgsflag))+(d_vdsats10_d_qgsflag*(1.0-ff0)))+((two_n_phit0*d_ff0_d_qgsflag)+(d_two_n_phit0_d_qgsflag*ff0)));
d_vdsat10_d_tambin=(((vdsats10*(-d_ff0_d_tambin))+(d_vdsats10_d_tambin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_tambin)+(d_two_n_phit0_d_tambin*ff0)));
d_vdsat10_d_tnomin=(((vdsats10*(-d_ff0_d_tnomin))+(d_vdsats10_d_tnomin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_tnomin)+(d_two_n_phit0_d_tnomin*ff0)));
d_vdsat10_d_phitin=(((vdsats10*(-d_ff0_d_phitin))+(d_vdsats10_d_phitin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_phitin)+(d_two_n_phit0_d_phitin*ff0)));
d_vdsat10_d_w=(((vdsats10*(-d_ff0_d_w))+(d_vdsats10_d_w*(1.0-ff0)))+((two_n_phit0*d_ff0_d_w)+(d_two_n_phit0_d_w*ff0)));
d_vdsat10_d_lin=(((vdsats10*(-d_ff0_d_lin))+(d_vdsats10_d_lin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_lin)+(d_two_n_phit0_d_lin*ff0)));
d_vdsat10_d_cgin=(((vdsats10*(-d_ff0_d_cgin))+(d_vdsats10_d_cgin*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cgin)+(d_two_n_phit0_d_cgin*ff0)));
d_vdsat10_d_cs=(((vdsats10*(-d_ff0_d_cs))+(d_vdsats10_d_cs*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cs)+(d_two_n_phit0_d_cs*ff0)));
d_vdsat10_d_cc=(((vdsats10*(-d_ff0_d_cc))+(d_vdsats10_d_cc*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cc)+(d_two_n_phit0_d_cc*ff0)));
d_vdsat10_d_cb=(((vdsats10*(-d_ff0_d_cb))+(d_vdsats10_d_cb*(1.0-ff0)))+((two_n_phit0*d_ff0_d_cb)+(d_two_n_phit0_d_cb*ff0)));
d_vdsat10_d_vto=(((vdsats10*(-d_ff0_d_vto))+(d_vdsats10_d_vto*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vto)+(d_two_n_phit0_d_vto*ff0)));
d_vdsat10_d_ss=(((vdsats10*(-d_ff0_d_ss))+(d_vdsats10_d_ss*(1.0-ff0)))+((two_n_phit0*d_ff0_d_ss)+(d_two_n_phit0_d_ss*ff0)));
d_vdsat10_d_delta1=(((vdsats10*(-d_ff0_d_delta1))+(d_vdsats10_d_delta1*(1.0-ff0)))+((two_n_phit0*d_ff0_d_delta1)+(d_two_n_phit0_d_delta1*ff0)));
d_vdsat10_d_delta2=(((vdsats10*(-d_ff0_d_delta2))+(d_vdsats10_d_delta2*(1.0-ff0)))+((two_n_phit0*d_ff0_d_delta2)+(d_two_n_phit0_d_delta2*ff0)));
d_vdsat10_d_nd=(((vdsats10*(-d_ff0_d_nd))+(d_vdsats10_d_nd*(1.0-ff0)))+((two_n_phit0*d_ff0_d_nd)+(d_two_n_phit0_d_nd*ff0)));
d_vdsat10_d_alpha=(((vdsats10*(-d_ff0_d_alpha))+(d_vdsats10_d_alpha*(1.0-ff0)))+((two_n_phit0*d_ff0_d_alpha)+(d_two_n_phit0_d_alpha*ff0)));
d_vdsat10_d_vel0=(((vdsats10*(-d_ff0_d_vel0))+(d_vdsats10_d_vel0*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vel0)+(d_two_n_phit0_d_vel0*ff0)));
d_vdsat10_d_mu0=(((vdsats10*(-d_ff0_d_mu0))+(d_vdsats10_d_mu0*(1.0-ff0)))+((two_n_phit0*d_ff0_d_mu0)+(d_two_n_phit0_d_mu0*ff0)));
d_vdsat10_d_beta=(((vdsats10*(-d_ff0_d_beta))+(d_vdsats10_d_beta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_beta)+(d_two_n_phit0_d_beta*ff0)));
d_vdsat10_d_mtheta=(((vdsats10*(-d_ff0_d_mtheta))+(d_vdsats10_d_mtheta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_mtheta)+(d_two_n_phit0_d_mtheta*ff0)));
d_vdsat10_d_vtheta=(((vdsats10*(-d_ff0_d_vtheta))+(d_vdsats10_d_vtheta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vtheta)+(d_two_n_phit0_d_vtheta*ff0)));
d_vdsat10_d_vtzeta=(((vdsats10*(-d_ff0_d_vtzeta))+(d_vdsats10_d_vtzeta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vtzeta)+(d_two_n_phit0_d_vtzeta*ff0)));
d_vdsat10_d_dibsat=(((vdsats10*(-d_ff0_d_dibsat))+(d_vdsats10_d_dibsat*(1.0-ff0)))+((two_n_phit0*d_ff0_d_dibsat)+(d_two_n_phit0_d_dibsat*ff0)));
d_vdsat10_d_epsilon=(((vdsats10*(-d_ff0_d_epsilon))+(d_vdsats10_d_epsilon*(1.0-ff0)))+((two_n_phit0*d_ff0_d_epsilon)+(d_two_n_phit0_d_epsilon*ff0)));
d_vdsat10_d_vzeta=(((vdsats10*(-d_ff0_d_vzeta))+(d_vdsats10_d_vzeta*(1.0-ff0)))+((two_n_phit0*d_ff0_d_vzeta)+(d_two_n_phit0_d_vzeta*ff0)));
d_vdsat10_d_lambda=(((vdsats10*(-d_ff0_d_lambda))+(d_vdsats10_d_lambda*(1.0-ff0)))+((two_n_phit0*d_ff0_d_lambda)+(d_two_n_phit0_d_lambda*ff0)));
d_vdsat10_d_ngf=(((vdsats10*(-d_ff0_d_ngf))+(d_vdsats10_d_ngf*(1.0-ff0)))+((two_n_phit0*d_ff0_d_ngf)+(d_two_n_phit0_d_ngf*ff0)));
d_vdsat10_d_type=(((vdsats10*(-d_ff0_d_type))+(d_vdsats10_d_type*(1.0-ff0)))+((two_n_phit0*d_ff0_d_type)+(d_two_n_phit0_d_type*ff0)));
vdsat10=((vdsats10*(1.0-ff0))+(two_n_phit0*ff0));
d_fsd0_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vgsin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,((vdsat10-(vdsin*d_vdsat10_d_vdsin))/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_qcbflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vcin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vbin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_qgsflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_tambin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_tnomin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_phitin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_w/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_lin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cgin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cs/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cc/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_cb/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vto/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_ss/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_delta1/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_delta2/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_nd/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_alpha/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vel0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_mu0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_beta/vdsat10/vdsat10))+((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(log(mmax( static_cast<double>(0),(vdsin/vdsat10))*pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_mtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vtzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_dibsat/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_epsilon/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_vzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_lambda/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_ngf/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_fsd0_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta))))*((mmax( static_cast<double>(0),(vdsin/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)*beta/mmax( static_cast<double>(0),(vdsin/vdsat10))))*d_mmax( static_cast<double>(0),(vdsin/vdsat10),0.0,(-vdsin*d_vdsat10_d_type/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
fsd0=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),(vdsin/vdsat10)),beta)),(1.0/beta)));
d_vdx0_d_vgsin=(vdsin*d_fsd0_d_vgsin);
d_vdx0_d_vdsin=(vdsin*d_fsd0_d_vdsin+fsd0);
d_vdx0_d_qcbflag=(vdsin*d_fsd0_d_qcbflag);
d_vdx0_d_vcin=(vdsin*d_fsd0_d_vcin);
d_vdx0_d_vbin=(vdsin*d_fsd0_d_vbin);
d_vdx0_d_qgsflag=(vdsin*d_fsd0_d_qgsflag);
d_vdx0_d_tambin=(vdsin*d_fsd0_d_tambin);
d_vdx0_d_tnomin=(vdsin*d_fsd0_d_tnomin);
d_vdx0_d_phitin=(vdsin*d_fsd0_d_phitin);
d_vdx0_d_w=(vdsin*d_fsd0_d_w);
d_vdx0_d_lin=(vdsin*d_fsd0_d_lin);
d_vdx0_d_cgin=(vdsin*d_fsd0_d_cgin);
d_vdx0_d_cs=(vdsin*d_fsd0_d_cs);
d_vdx0_d_cc=(vdsin*d_fsd0_d_cc);
d_vdx0_d_cb=(vdsin*d_fsd0_d_cb);
d_vdx0_d_vto=(vdsin*d_fsd0_d_vto);
d_vdx0_d_ss=(vdsin*d_fsd0_d_ss);
d_vdx0_d_delta1=(vdsin*d_fsd0_d_delta1);
d_vdx0_d_delta2=(vdsin*d_fsd0_d_delta2);
d_vdx0_d_nd=(vdsin*d_fsd0_d_nd);
d_vdx0_d_alpha=(vdsin*d_fsd0_d_alpha);
d_vdx0_d_vel0=(vdsin*d_fsd0_d_vel0);
d_vdx0_d_mu0=(vdsin*d_fsd0_d_mu0);
d_vdx0_d_beta=(vdsin*d_fsd0_d_beta);
d_vdx0_d_mtheta=(vdsin*d_fsd0_d_mtheta);
d_vdx0_d_vtheta=(vdsin*d_fsd0_d_vtheta);
d_vdx0_d_vtzeta=(vdsin*d_fsd0_d_vtzeta);
d_vdx0_d_dibsat=(vdsin*d_fsd0_d_dibsat);
d_vdx0_d_epsilon=(vdsin*d_fsd0_d_epsilon);
d_vdx0_d_vzeta=(vdsin*d_fsd0_d_vzeta);
d_vdx0_d_lambda=(vdsin*d_fsd0_d_lambda);
d_vdx0_d_ngf=(vdsin*d_fsd0_d_ngf);
d_vdx0_d_type=(vdsin*d_fsd0_d_type);
vdx0=(vdsin*fsd0);
d_fds0_d_vgsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vgsin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vdsin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,((vdsat10*(-1.0)-(-vdsin)*d_vdsat10_d_vdsin)/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_qcbflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_qcbflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vcin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vcin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vbin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vbin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_qgsflag=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_qgsflag/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_tambin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_tambin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_tnomin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_tnomin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_phitin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_phitin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_w=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_w/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_lin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_lin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cgin=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cgin/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cs=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cs/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cc=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cc/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_cb=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_cb/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vto=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vto/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_ss=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_ss/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_delta1=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_delta1/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_delta2=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_delta2/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_nd=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_nd/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_alpha=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_alpha/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vel0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vel0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_mu0=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_mu0/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_beta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_beta/vdsat10/vdsat10))+((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(log(mmax( static_cast<double>(0),((-vdsin)/vdsat10))*pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))+(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(log((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))*pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)))))*(-1.0/beta/beta)/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_mtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_mtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vtheta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vtheta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vtzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vtzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_dibsat=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_dibsat/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_epsilon=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_epsilon/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_vzeta=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_vzeta/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_lambda=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_lambda/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_ngf=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_ngf/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_fds0_d_type=(-(((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))==0.0)?0.0:(pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))*(1.0/beta)/(1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta))))*((mmax( static_cast<double>(0),((-vdsin)/vdsat10))==0.0)?0.0:(pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)*beta/mmax( static_cast<double>(0),((-vdsin)/vdsat10))))*d_mmax( static_cast<double>(0),((-vdsin)/vdsat10),0.0,(-(-vdsin)*d_vdsat10_d_type/vdsat10/vdsat10))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta))/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
fds0=(1.0/pow((1.0+pow(mmax( static_cast<double>(0),((-vdsin)/vdsat10)),beta)),(1.0/beta)));
d_vsx0_d_vgsin=((-vdsin)*d_fds0_d_vgsin);
d_vsx0_d_vdsin=(((-vdsin)*d_fds0_d_vdsin)+((-1.0)*fds0));
d_vsx0_d_qcbflag=((-vdsin)*d_fds0_d_qcbflag);
d_vsx0_d_vcin=((-vdsin)*d_fds0_d_vcin);
d_vsx0_d_vbin=((-vdsin)*d_fds0_d_vbin);
d_vsx0_d_qgsflag=((-vdsin)*d_fds0_d_qgsflag);
d_vsx0_d_tambin=((-vdsin)*d_fds0_d_tambin);
d_vsx0_d_tnomin=((-vdsin)*d_fds0_d_tnomin);
d_vsx0_d_phitin=((-vdsin)*d_fds0_d_phitin);
d_vsx0_d_w=((-vdsin)*d_fds0_d_w);
d_vsx0_d_lin=((-vdsin)*d_fds0_d_lin);
d_vsx0_d_cgin=((-vdsin)*d_fds0_d_cgin);
d_vsx0_d_cs=((-vdsin)*d_fds0_d_cs);
d_vsx0_d_cc=((-vdsin)*d_fds0_d_cc);
d_vsx0_d_cb=((-vdsin)*d_fds0_d_cb);
d_vsx0_d_vto=((-vdsin)*d_fds0_d_vto);
d_vsx0_d_ss=((-vdsin)*d_fds0_d_ss);
d_vsx0_d_delta1=((-vdsin)*d_fds0_d_delta1);
d_vsx0_d_delta2=((-vdsin)*d_fds0_d_delta2);
d_vsx0_d_nd=((-vdsin)*d_fds0_d_nd);
d_vsx0_d_alpha=((-vdsin)*d_fds0_d_alpha);
d_vsx0_d_vel0=((-vdsin)*d_fds0_d_vel0);
d_vsx0_d_mu0=((-vdsin)*d_fds0_d_mu0);
d_vsx0_d_beta=((-vdsin)*d_fds0_d_beta);
d_vsx0_d_mtheta=((-vdsin)*d_fds0_d_mtheta);
d_vsx0_d_vtheta=((-vdsin)*d_fds0_d_vtheta);
d_vsx0_d_vtzeta=((-vdsin)*d_fds0_d_vtzeta);
d_vsx0_d_dibsat=((-vdsin)*d_fds0_d_dibsat);
d_vsx0_d_epsilon=((-vdsin)*d_fds0_d_epsilon);
d_vsx0_d_vzeta=((-vdsin)*d_fds0_d_vzeta);
d_vsx0_d_lambda=((-vdsin)*d_fds0_d_lambda);
d_vsx0_d_ngf=((-vdsin)*d_fds0_d_ngf);
d_vsx0_d_type=((-vdsin)*d_fds0_d_type);
vsx0=((-vdsin)*fds0);
d_exparg0_d_vgsin=((alpha_phit*(1.0-d_myarg0_d_vgsin)-(vgsin-myarg0)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg0_d_vdsin=((alpha_phit*(-d_myarg0_d_vdsin)-(vgsin-myarg0)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg0_d_qcbflag=((alpha_phit*(-d_myarg0_d_qcbflag)-(vgsin-myarg0)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg0_d_vcin=((alpha_phit*(-d_myarg0_d_vcin)-(vgsin-myarg0)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg0_d_vbin=((alpha_phit*(-d_myarg0_d_vbin)-(vgsin-myarg0)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg0_d_qgsflag=((alpha_phit*(-d_myarg0_d_qgsflag)-(vgsin-myarg0)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg0_d_tambin=((alpha_phit*(-d_myarg0_d_tambin)-(vgsin-myarg0)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg0_d_tnomin=((alpha_phit*(-d_myarg0_d_tnomin)-(vgsin-myarg0)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg0_d_phitin=((alpha_phit*(-d_myarg0_d_phitin)-(vgsin-myarg0)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg0_d_w=((alpha_phit*(-d_myarg0_d_w)-(vgsin-myarg0)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg0_d_lin=((alpha_phit*(-d_myarg0_d_lin)-(vgsin-myarg0)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg0_d_cgin=((alpha_phit*(-d_myarg0_d_cgin)-(vgsin-myarg0)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg0_d_cs=((alpha_phit*(-d_myarg0_d_cs)-(vgsin-myarg0)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg0_d_cc=((alpha_phit*(-d_myarg0_d_cc)-(vgsin-myarg0)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg0_d_cb=((alpha_phit*(-d_myarg0_d_cb)-(vgsin-myarg0)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg0_d_vto=((alpha_phit*(-d_myarg0_d_vto)-(vgsin-myarg0)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg0_d_ss=((alpha_phit*(-d_myarg0_d_ss)-(vgsin-myarg0)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg0_d_delta1=((alpha_phit*(-d_myarg0_d_delta1)-(vgsin-myarg0)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg0_d_delta2=((alpha_phit*(-d_myarg0_d_delta2)-(vgsin-myarg0)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg0_d_nd=((alpha_phit*(-d_myarg0_d_nd)-(vgsin-myarg0)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg0_d_alpha=((alpha_phit*(-d_myarg0_d_alpha)-(vgsin-myarg0)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg0_d_vel0=((alpha_phit*(-d_myarg0_d_vel0)-(vgsin-myarg0)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg0_d_mu0=((alpha_phit*(-d_myarg0_d_mu0)-(vgsin-myarg0)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg0_d_beta=((alpha_phit*(-d_myarg0_d_beta)-(vgsin-myarg0)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg0_d_mtheta=((alpha_phit*(-d_myarg0_d_mtheta)-(vgsin-myarg0)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtheta=((alpha_phit*(-d_myarg0_d_vtheta)-(vgsin-myarg0)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtzeta=((alpha_phit*(-d_myarg0_d_vtzeta)-(vgsin-myarg0)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg0_d_dibsat=((alpha_phit*(-d_myarg0_d_dibsat)-(vgsin-myarg0)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg0_d_epsilon=((alpha_phit*(-d_myarg0_d_epsilon)-(vgsin-myarg0)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg0_d_vzeta=((alpha_phit*(-d_myarg0_d_vzeta)-(vgsin-myarg0)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg0_d_lambda=((alpha_phit*(-d_myarg0_d_lambda)-(vgsin-myarg0)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg0_d_ngf=((alpha_phit*(-d_myarg0_d_ngf)-(vgsin-myarg0)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg0_d_type=((alpha_phit*(-d_myarg0_d_type)-(vgsin-myarg0)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg0=((vgsin-myarg0)/alpha_phit);
if((exparg0>50.0))
{
d_ffs0_d_vgsin=0.0;
d_ffs0_d_vdsin=0.0;
d_ffs0_d_qcbflag=0.0;
d_ffs0_d_vcin=0.0;
d_ffs0_d_vbin=0.0;
d_ffs0_d_qgsflag=0.0;
d_ffs0_d_tambin=0.0;
d_ffs0_d_tnomin=0.0;
d_ffs0_d_phitin=0.0;
d_ffs0_d_w=0.0;
d_ffs0_d_lin=0.0;
d_ffs0_d_cgin=0.0;
d_ffs0_d_cs=0.0;
d_ffs0_d_cc=0.0;
d_ffs0_d_cb=0.0;
d_ffs0_d_vto=0.0;
d_ffs0_d_ss=0.0;
d_ffs0_d_delta1=0.0;
d_ffs0_d_delta2=0.0;
d_ffs0_d_nd=0.0;
d_ffs0_d_alpha=0.0;
d_ffs0_d_vel0=0.0;
d_ffs0_d_mu0=0.0;
d_ffs0_d_beta=0.0;
d_ffs0_d_mtheta=0.0;
d_ffs0_d_vtheta=0.0;
d_ffs0_d_vtzeta=0.0;
d_ffs0_d_dibsat=0.0;
d_ffs0_d_epsilon=0.0;
d_ffs0_d_vzeta=0.0;
d_ffs0_d_lambda=0.0;
d_ffs0_d_ngf=0.0;
d_ffs0_d_type=0.0;
ffs0=0.0;
}
else
{
if((exparg0<(-50.0)))
{
d_ffs0_d_vgsin=0.0;
d_ffs0_d_vdsin=0.0;
d_ffs0_d_qcbflag=0.0;
d_ffs0_d_vcin=0.0;
d_ffs0_d_vbin=0.0;
d_ffs0_d_qgsflag=0.0;
d_ffs0_d_tambin=0.0;
d_ffs0_d_tnomin=0.0;
d_ffs0_d_phitin=0.0;
d_ffs0_d_w=0.0;
d_ffs0_d_lin=0.0;
d_ffs0_d_cgin=0.0;
d_ffs0_d_cs=0.0;
d_ffs0_d_cc=0.0;
d_ffs0_d_cb=0.0;
d_ffs0_d_vto=0.0;
d_ffs0_d_ss=0.0;
d_ffs0_d_delta1=0.0;
d_ffs0_d_delta2=0.0;
d_ffs0_d_nd=0.0;
d_ffs0_d_alpha=0.0;
d_ffs0_d_vel0=0.0;
d_ffs0_d_mu0=0.0;
d_ffs0_d_beta=0.0;
d_ffs0_d_mtheta=0.0;
d_ffs0_d_vtheta=0.0;
d_ffs0_d_vtzeta=0.0;
d_ffs0_d_dibsat=0.0;
d_ffs0_d_epsilon=0.0;
d_ffs0_d_vzeta=0.0;
d_ffs0_d_lambda=0.0;
d_ffs0_d_ngf=0.0;
d_ffs0_d_type=0.0;
ffs0=1.0;
}
else
{
d_ffs0_d_vgsin=(-exp(exparg0)*d_exparg0_d_vgsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vdsin=(-exp(exparg0)*d_exparg0_d_vdsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_qcbflag=(-exp(exparg0)*d_exparg0_d_qcbflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vcin=(-exp(exparg0)*d_exparg0_d_vcin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vbin=(-exp(exparg0)*d_exparg0_d_vbin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_qgsflag=(-exp(exparg0)*d_exparg0_d_qgsflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_tambin=(-exp(exparg0)*d_exparg0_d_tambin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_tnomin=(-exp(exparg0)*d_exparg0_d_tnomin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_phitin=(-exp(exparg0)*d_exparg0_d_phitin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_w=(-exp(exparg0)*d_exparg0_d_w/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_lin=(-exp(exparg0)*d_exparg0_d_lin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cgin=(-exp(exparg0)*d_exparg0_d_cgin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cs=(-exp(exparg0)*d_exparg0_d_cs/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cc=(-exp(exparg0)*d_exparg0_d_cc/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_cb=(-exp(exparg0)*d_exparg0_d_cb/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vto=(-exp(exparg0)*d_exparg0_d_vto/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_ss=(-exp(exparg0)*d_exparg0_d_ss/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_delta1=(-exp(exparg0)*d_exparg0_d_delta1/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_delta2=(-exp(exparg0)*d_exparg0_d_delta2/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_nd=(-exp(exparg0)*d_exparg0_d_nd/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_alpha=(-exp(exparg0)*d_exparg0_d_alpha/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vel0=(-exp(exparg0)*d_exparg0_d_vel0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_mu0=(-exp(exparg0)*d_exparg0_d_mu0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_beta=(-exp(exparg0)*d_exparg0_d_beta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_mtheta=(-exp(exparg0)*d_exparg0_d_mtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vtheta=(-exp(exparg0)*d_exparg0_d_vtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vtzeta=(-exp(exparg0)*d_exparg0_d_vtzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_dibsat=(-exp(exparg0)*d_exparg0_d_dibsat/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_epsilon=(-exp(exparg0)*d_exparg0_d_epsilon/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_vzeta=(-exp(exparg0)*d_exparg0_d_vzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_lambda=(-exp(exparg0)*d_exparg0_d_lambda/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_ngf=(-exp(exparg0)*d_exparg0_d_ngf/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffs0_d_type=(-exp(exparg0)*d_exparg0_d_type/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
ffs0=(1.0/(1.0+exp(exparg0)));
}
}
d_etas0_d_vgsin=((two_n_phit0*((d_vgdin_d_vgsin-d_vsx0_d_vgsin)-(d_vtof_d_vgsin-(((0.1*alpha_phit)*d_ffs0_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etas0_d_vdsin=((two_n_phit0*((d_vgdin_d_vdsin-d_vsx0_d_vdsin)-(d_vtof_d_vdsin-(((0.1*alpha_phit)*d_ffs0_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etas0_d_qcbflag=((two_n_phit0*((d_vgdin_d_qcbflag-d_vsx0_d_qcbflag)-(d_vtof_d_qcbflag-(((0.1*alpha_phit)*d_ffs0_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etas0_d_vcin=((two_n_phit0*((d_vgdin_d_vcin-d_vsx0_d_vcin)-(d_vtof_d_vcin-(((0.1*alpha_phit)*d_ffs0_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etas0_d_vbin=((two_n_phit0*((d_vgdin_d_vbin-d_vsx0_d_vbin)-(d_vtof_d_vbin-(((0.1*alpha_phit)*d_ffs0_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etas0_d_qgsflag=((two_n_phit0*((d_vgdin_d_qgsflag-d_vsx0_d_qgsflag)-(d_vtof_d_qgsflag-(((0.1*alpha_phit)*d_ffs0_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etas0_d_tambin=((two_n_phit0*((d_vgdin_d_tambin-d_vsx0_d_tambin)-(d_vtof_d_tambin-(((0.1*alpha_phit)*d_ffs0_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etas0_d_tnomin=((two_n_phit0*((d_vgdin_d_tnomin-d_vsx0_d_tnomin)-(d_vtof_d_tnomin-(((0.1*alpha_phit)*d_ffs0_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etas0_d_phitin=((two_n_phit0*((d_vgdin_d_phitin-d_vsx0_d_phitin)-(d_vtof_d_phitin-(((0.1*alpha_phit)*d_ffs0_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etas0_d_w=((two_n_phit0*((d_vgdin_d_w-d_vsx0_d_w)-(d_vtof_d_w-(((0.1*alpha_phit)*d_ffs0_d_w)+((0.1*d_alpha_phit_d_w)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etas0_d_lin=((two_n_phit0*((d_vgdin_d_lin-d_vsx0_d_lin)-(d_vtof_d_lin-(((0.1*alpha_phit)*d_ffs0_d_lin)+((0.1*d_alpha_phit_d_lin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etas0_d_cgin=((two_n_phit0*((d_vgdin_d_cgin-d_vsx0_d_cgin)-(d_vtof_d_cgin-(((0.1*alpha_phit)*d_ffs0_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etas0_d_cs=((two_n_phit0*((d_vgdin_d_cs-d_vsx0_d_cs)-(d_vtof_d_cs-(((0.1*alpha_phit)*d_ffs0_d_cs)+((0.1*d_alpha_phit_d_cs)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etas0_d_cc=((two_n_phit0*((d_vgdin_d_cc-d_vsx0_d_cc)-(d_vtof_d_cc-(((0.1*alpha_phit)*d_ffs0_d_cc)+((0.1*d_alpha_phit_d_cc)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etas0_d_cb=((two_n_phit0*((d_vgdin_d_cb-d_vsx0_d_cb)-(d_vtof_d_cb-(((0.1*alpha_phit)*d_ffs0_d_cb)+((0.1*d_alpha_phit_d_cb)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etas0_d_vto=((two_n_phit0*((d_vgdin_d_vto-d_vsx0_d_vto)-(d_vtof_d_vto-(((0.1*alpha_phit)*d_ffs0_d_vto)+((0.1*d_alpha_phit_d_vto)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etas0_d_ss=((two_n_phit0*((d_vgdin_d_ss-d_vsx0_d_ss)-(d_vtof_d_ss-(((0.1*alpha_phit)*d_ffs0_d_ss)+((0.1*d_alpha_phit_d_ss)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etas0_d_delta1=((two_n_phit0*((d_vgdin_d_delta1-d_vsx0_d_delta1)-(d_vtof_d_delta1-(((0.1*alpha_phit)*d_ffs0_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etas0_d_delta2=((two_n_phit0*((d_vgdin_d_delta2-d_vsx0_d_delta2)-(d_vtof_d_delta2-(((0.1*alpha_phit)*d_ffs0_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etas0_d_nd=((two_n_phit0*((d_vgdin_d_nd-d_vsx0_d_nd)-(d_vtof_d_nd-(((0.1*alpha_phit)*d_ffs0_d_nd)+((0.1*d_alpha_phit_d_nd)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etas0_d_alpha=((two_n_phit0*((d_vgdin_d_alpha-d_vsx0_d_alpha)-(d_vtof_d_alpha-(((0.1*alpha_phit)*d_ffs0_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etas0_d_vel0=((two_n_phit0*((d_vgdin_d_vel0-d_vsx0_d_vel0)-(d_vtof_d_vel0-(((0.1*alpha_phit)*d_ffs0_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etas0_d_mu0=((two_n_phit0*((d_vgdin_d_mu0-d_vsx0_d_mu0)-(d_vtof_d_mu0-(((0.1*alpha_phit)*d_ffs0_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etas0_d_beta=((two_n_phit0*((d_vgdin_d_beta-d_vsx0_d_beta)-(d_vtof_d_beta-(((0.1*alpha_phit)*d_ffs0_d_beta)+((0.1*d_alpha_phit_d_beta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etas0_d_mtheta=((two_n_phit0*((d_vgdin_d_mtheta-d_vsx0_d_mtheta)-(d_vtof_d_mtheta-(((0.1*alpha_phit)*d_ffs0_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etas0_d_vtheta=((two_n_phit0*((d_vgdin_d_vtheta-d_vsx0_d_vtheta)-(d_vtof_d_vtheta-(((0.1*alpha_phit)*d_ffs0_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etas0_d_vtzeta=((two_n_phit0*((d_vgdin_d_vtzeta-d_vsx0_d_vtzeta)-(d_vtof_d_vtzeta-(((0.1*alpha_phit)*d_ffs0_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etas0_d_dibsat=((two_n_phit0*((d_vgdin_d_dibsat-d_vsx0_d_dibsat)-(d_vtof_d_dibsat-(((0.1*alpha_phit)*d_ffs0_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etas0_d_epsilon=((two_n_phit0*((d_vgdin_d_epsilon-d_vsx0_d_epsilon)-(d_vtof_d_epsilon-(((0.1*alpha_phit)*d_ffs0_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etas0_d_vzeta=((two_n_phit0*((d_vgdin_d_vzeta-d_vsx0_d_vzeta)-(d_vtof_d_vzeta-(((0.1*alpha_phit)*d_ffs0_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etas0_d_lambda=((two_n_phit0*((d_vgdin_d_lambda-d_vsx0_d_lambda)-(d_vtof_d_lambda-(((0.1*alpha_phit)*d_ffs0_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etas0_d_ngf=((two_n_phit0*((d_vgdin_d_ngf-d_vsx0_d_ngf)-(d_vtof_d_ngf-(((0.1*alpha_phit)*d_ffs0_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etas0_d_type=((two_n_phit0*((d_vgdin_d_type-d_vsx0_d_type)-(d_vtof_d_type-(((0.1*alpha_phit)*d_ffs0_d_type)+((0.1*d_alpha_phit_d_type)*ffs0))))-((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etas0=(((vgdin-vsx0)-(vtof-((0.1*alpha_phit)*ffs0)))/two_n_phit0);
if((etas0>50.0))
{
d_qinvs0_d_vgsin=((qref0*d_etas0_d_vgsin)+(d_qref0_d_vgsin*etas0));
d_qinvs0_d_vdsin=((qref0*d_etas0_d_vdsin)+(d_qref0_d_vdsin*etas0));
d_qinvs0_d_qcbflag=((qref0*d_etas0_d_qcbflag)+(d_qref0_d_qcbflag*etas0));
d_qinvs0_d_vcin=((qref0*d_etas0_d_vcin)+(d_qref0_d_vcin*etas0));
d_qinvs0_d_vbin=((qref0*d_etas0_d_vbin)+(d_qref0_d_vbin*etas0));
d_qinvs0_d_qgsflag=((qref0*d_etas0_d_qgsflag)+(d_qref0_d_qgsflag*etas0));
d_qinvs0_d_tambin=((qref0*d_etas0_d_tambin)+(d_qref0_d_tambin*etas0));
d_qinvs0_d_tnomin=((qref0*d_etas0_d_tnomin)+(d_qref0_d_tnomin*etas0));
d_qinvs0_d_phitin=((qref0*d_etas0_d_phitin)+(d_qref0_d_phitin*etas0));
d_qinvs0_d_w=((qref0*d_etas0_d_w)+(d_qref0_d_w*etas0));
d_qinvs0_d_lin=((qref0*d_etas0_d_lin)+(d_qref0_d_lin*etas0));
d_qinvs0_d_cgin=((qref0*d_etas0_d_cgin)+(d_qref0_d_cgin*etas0));
d_qinvs0_d_cs=((qref0*d_etas0_d_cs)+(d_qref0_d_cs*etas0));
d_qinvs0_d_cc=((qref0*d_etas0_d_cc)+(d_qref0_d_cc*etas0));
d_qinvs0_d_cb=((qref0*d_etas0_d_cb)+(d_qref0_d_cb*etas0));
d_qinvs0_d_vto=((qref0*d_etas0_d_vto)+(d_qref0_d_vto*etas0));
d_qinvs0_d_ss=((qref0*d_etas0_d_ss)+(d_qref0_d_ss*etas0));
d_qinvs0_d_delta1=((qref0*d_etas0_d_delta1)+(d_qref0_d_delta1*etas0));
d_qinvs0_d_delta2=((qref0*d_etas0_d_delta2)+(d_qref0_d_delta2*etas0));
d_qinvs0_d_nd=((qref0*d_etas0_d_nd)+(d_qref0_d_nd*etas0));
d_qinvs0_d_alpha=((qref0*d_etas0_d_alpha)+(d_qref0_d_alpha*etas0));
d_qinvs0_d_vel0=((qref0*d_etas0_d_vel0)+(d_qref0_d_vel0*etas0));
d_qinvs0_d_mu0=((qref0*d_etas0_d_mu0)+(d_qref0_d_mu0*etas0));
d_qinvs0_d_beta=((qref0*d_etas0_d_beta)+(d_qref0_d_beta*etas0));
d_qinvs0_d_mtheta=((qref0*d_etas0_d_mtheta)+(d_qref0_d_mtheta*etas0));
d_qinvs0_d_vtheta=((qref0*d_etas0_d_vtheta)+(d_qref0_d_vtheta*etas0));
d_qinvs0_d_vtzeta=((qref0*d_etas0_d_vtzeta)+(d_qref0_d_vtzeta*etas0));
d_qinvs0_d_dibsat=((qref0*d_etas0_d_dibsat)+(d_qref0_d_dibsat*etas0));
d_qinvs0_d_epsilon=((qref0*d_etas0_d_epsilon)+(d_qref0_d_epsilon*etas0));
d_qinvs0_d_vzeta=((qref0*d_etas0_d_vzeta)+(d_qref0_d_vzeta*etas0));
d_qinvs0_d_lambda=((qref0*d_etas0_d_lambda)+(d_qref0_d_lambda*etas0));
d_qinvs0_d_ngf=((qref0*d_etas0_d_ngf)+(d_qref0_d_ngf*etas0));
d_qinvs0_d_type=((qref0*d_etas0_d_type)+(d_qref0_d_type*etas0));
qinvs0=(qref0*etas0);
}
else
{
if((etas0<(-50.0)))
{
d_qinvs0_d_vgsin=0.0;
d_qinvs0_d_vdsin=0.0;
d_qinvs0_d_qcbflag=0.0;
d_qinvs0_d_vcin=0.0;
d_qinvs0_d_vbin=0.0;
d_qinvs0_d_qgsflag=0.0;
d_qinvs0_d_tambin=0.0;
d_qinvs0_d_tnomin=0.0;
d_qinvs0_d_phitin=0.0;
d_qinvs0_d_w=0.0;
d_qinvs0_d_lin=0.0;
d_qinvs0_d_cgin=0.0;
d_qinvs0_d_cs=0.0;
d_qinvs0_d_cc=0.0;
d_qinvs0_d_cb=0.0;
d_qinvs0_d_vto=0.0;
d_qinvs0_d_ss=0.0;
d_qinvs0_d_delta1=0.0;
d_qinvs0_d_delta2=0.0;
d_qinvs0_d_nd=0.0;
d_qinvs0_d_alpha=0.0;
d_qinvs0_d_vel0=0.0;
d_qinvs0_d_mu0=0.0;
d_qinvs0_d_beta=0.0;
d_qinvs0_d_mtheta=0.0;
d_qinvs0_d_vtheta=0.0;
d_qinvs0_d_vtzeta=0.0;
d_qinvs0_d_dibsat=0.0;
d_qinvs0_d_epsilon=0.0;
d_qinvs0_d_vzeta=0.0;
d_qinvs0_d_lambda=0.0;
d_qinvs0_d_ngf=0.0;
d_qinvs0_d_type=0.0;
qinvs0=0;
}
else
{
d_qinvs0_d_vgsin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vgsin)+(d_qref0_d_vgsin*log((1.0+exp(etas0)))));
d_qinvs0_d_vdsin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vdsin)+(d_qref0_d_vdsin*log((1.0+exp(etas0)))));
d_qinvs0_d_qcbflag=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_qcbflag)+(d_qref0_d_qcbflag*log((1.0+exp(etas0)))));
d_qinvs0_d_vcin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vcin)+(d_qref0_d_vcin*log((1.0+exp(etas0)))));
d_qinvs0_d_vbin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vbin)+(d_qref0_d_vbin*log((1.0+exp(etas0)))));
d_qinvs0_d_qgsflag=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_qgsflag)+(d_qref0_d_qgsflag*log((1.0+exp(etas0)))));
d_qinvs0_d_tambin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_tambin)+(d_qref0_d_tambin*log((1.0+exp(etas0)))));
d_qinvs0_d_tnomin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_tnomin)+(d_qref0_d_tnomin*log((1.0+exp(etas0)))));
d_qinvs0_d_phitin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_phitin)+(d_qref0_d_phitin*log((1.0+exp(etas0)))));
d_qinvs0_d_w=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_w)+(d_qref0_d_w*log((1.0+exp(etas0)))));
d_qinvs0_d_lin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_lin)+(d_qref0_d_lin*log((1.0+exp(etas0)))));
d_qinvs0_d_cgin=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cgin)+(d_qref0_d_cgin*log((1.0+exp(etas0)))));
d_qinvs0_d_cs=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cs)+(d_qref0_d_cs*log((1.0+exp(etas0)))));
d_qinvs0_d_cc=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cc)+(d_qref0_d_cc*log((1.0+exp(etas0)))));
d_qinvs0_d_cb=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_cb)+(d_qref0_d_cb*log((1.0+exp(etas0)))));
d_qinvs0_d_vto=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vto)+(d_qref0_d_vto*log((1.0+exp(etas0)))));
d_qinvs0_d_ss=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_ss)+(d_qref0_d_ss*log((1.0+exp(etas0)))));
d_qinvs0_d_delta1=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_delta1)+(d_qref0_d_delta1*log((1.0+exp(etas0)))));
d_qinvs0_d_delta2=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_delta2)+(d_qref0_d_delta2*log((1.0+exp(etas0)))));
d_qinvs0_d_nd=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_nd)+(d_qref0_d_nd*log((1.0+exp(etas0)))));
d_qinvs0_d_alpha=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_alpha)+(d_qref0_d_alpha*log((1.0+exp(etas0)))));
d_qinvs0_d_vel0=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vel0)+(d_qref0_d_vel0*log((1.0+exp(etas0)))));
d_qinvs0_d_mu0=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_mu0)+(d_qref0_d_mu0*log((1.0+exp(etas0)))));
d_qinvs0_d_beta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_beta)+(d_qref0_d_beta*log((1.0+exp(etas0)))));
d_qinvs0_d_mtheta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_mtheta)+(d_qref0_d_mtheta*log((1.0+exp(etas0)))));
d_qinvs0_d_vtheta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vtheta)+(d_qref0_d_vtheta*log((1.0+exp(etas0)))));
d_qinvs0_d_vtzeta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vtzeta)+(d_qref0_d_vtzeta*log((1.0+exp(etas0)))));
d_qinvs0_d_dibsat=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_dibsat)+(d_qref0_d_dibsat*log((1.0+exp(etas0)))));
d_qinvs0_d_epsilon=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_epsilon)+(d_qref0_d_epsilon*log((1.0+exp(etas0)))));
d_qinvs0_d_vzeta=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_vzeta)+(d_qref0_d_vzeta*log((1.0+exp(etas0)))));
d_qinvs0_d_lambda=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_lambda)+(d_qref0_d_lambda*log((1.0+exp(etas0)))));
d_qinvs0_d_ngf=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_ngf)+(d_qref0_d_ngf*log((1.0+exp(etas0)))));
d_qinvs0_d_type=((qref0*(1.0/(1.0+exp(etas0)))*exp(etas0)*d_etas0_d_type)+(d_qref0_d_type*log((1.0+exp(etas0)))));
qinvs0=(qref0*log((1.0+exp(etas0))));
}
}
d_exparg0_d_vgsin=((alpha_phit*(d_vgdin_d_vgsin-d_myarg0_d_vgsin)-(vgdin-myarg0)*d_alpha_phit_d_vgsin)/alpha_phit/alpha_phit);
d_exparg0_d_vdsin=((alpha_phit*(d_vgdin_d_vdsin-d_myarg0_d_vdsin)-(vgdin-myarg0)*d_alpha_phit_d_vdsin)/alpha_phit/alpha_phit);
d_exparg0_d_qcbflag=((alpha_phit*(d_vgdin_d_qcbflag-d_myarg0_d_qcbflag)-(vgdin-myarg0)*d_alpha_phit_d_qcbflag)/alpha_phit/alpha_phit);
d_exparg0_d_vcin=((alpha_phit*(d_vgdin_d_vcin-d_myarg0_d_vcin)-(vgdin-myarg0)*d_alpha_phit_d_vcin)/alpha_phit/alpha_phit);
d_exparg0_d_vbin=((alpha_phit*(d_vgdin_d_vbin-d_myarg0_d_vbin)-(vgdin-myarg0)*d_alpha_phit_d_vbin)/alpha_phit/alpha_phit);
d_exparg0_d_qgsflag=((alpha_phit*(d_vgdin_d_qgsflag-d_myarg0_d_qgsflag)-(vgdin-myarg0)*d_alpha_phit_d_qgsflag)/alpha_phit/alpha_phit);
d_exparg0_d_tambin=((alpha_phit*(d_vgdin_d_tambin-d_myarg0_d_tambin)-(vgdin-myarg0)*d_alpha_phit_d_tambin)/alpha_phit/alpha_phit);
d_exparg0_d_tnomin=((alpha_phit*(d_vgdin_d_tnomin-d_myarg0_d_tnomin)-(vgdin-myarg0)*d_alpha_phit_d_tnomin)/alpha_phit/alpha_phit);
d_exparg0_d_phitin=((alpha_phit*(d_vgdin_d_phitin-d_myarg0_d_phitin)-(vgdin-myarg0)*d_alpha_phit_d_phitin)/alpha_phit/alpha_phit);
d_exparg0_d_w=((alpha_phit*(d_vgdin_d_w-d_myarg0_d_w)-(vgdin-myarg0)*d_alpha_phit_d_w)/alpha_phit/alpha_phit);
d_exparg0_d_lin=((alpha_phit*(d_vgdin_d_lin-d_myarg0_d_lin)-(vgdin-myarg0)*d_alpha_phit_d_lin)/alpha_phit/alpha_phit);
d_exparg0_d_cgin=((alpha_phit*(d_vgdin_d_cgin-d_myarg0_d_cgin)-(vgdin-myarg0)*d_alpha_phit_d_cgin)/alpha_phit/alpha_phit);
d_exparg0_d_cs=((alpha_phit*(d_vgdin_d_cs-d_myarg0_d_cs)-(vgdin-myarg0)*d_alpha_phit_d_cs)/alpha_phit/alpha_phit);
d_exparg0_d_cc=((alpha_phit*(d_vgdin_d_cc-d_myarg0_d_cc)-(vgdin-myarg0)*d_alpha_phit_d_cc)/alpha_phit/alpha_phit);
d_exparg0_d_cb=((alpha_phit*(d_vgdin_d_cb-d_myarg0_d_cb)-(vgdin-myarg0)*d_alpha_phit_d_cb)/alpha_phit/alpha_phit);
d_exparg0_d_vto=((alpha_phit*(d_vgdin_d_vto-d_myarg0_d_vto)-(vgdin-myarg0)*d_alpha_phit_d_vto)/alpha_phit/alpha_phit);
d_exparg0_d_ss=((alpha_phit*(d_vgdin_d_ss-d_myarg0_d_ss)-(vgdin-myarg0)*d_alpha_phit_d_ss)/alpha_phit/alpha_phit);
d_exparg0_d_delta1=((alpha_phit*(d_vgdin_d_delta1-d_myarg0_d_delta1)-(vgdin-myarg0)*d_alpha_phit_d_delta1)/alpha_phit/alpha_phit);
d_exparg0_d_delta2=((alpha_phit*(d_vgdin_d_delta2-d_myarg0_d_delta2)-(vgdin-myarg0)*d_alpha_phit_d_delta2)/alpha_phit/alpha_phit);
d_exparg0_d_nd=((alpha_phit*(d_vgdin_d_nd-d_myarg0_d_nd)-(vgdin-myarg0)*d_alpha_phit_d_nd)/alpha_phit/alpha_phit);
d_exparg0_d_alpha=((alpha_phit*(d_vgdin_d_alpha-d_myarg0_d_alpha)-(vgdin-myarg0)*d_alpha_phit_d_alpha)/alpha_phit/alpha_phit);
d_exparg0_d_vel0=((alpha_phit*(d_vgdin_d_vel0-d_myarg0_d_vel0)-(vgdin-myarg0)*d_alpha_phit_d_vel0)/alpha_phit/alpha_phit);
d_exparg0_d_mu0=((alpha_phit*(d_vgdin_d_mu0-d_myarg0_d_mu0)-(vgdin-myarg0)*d_alpha_phit_d_mu0)/alpha_phit/alpha_phit);
d_exparg0_d_beta=((alpha_phit*(d_vgdin_d_beta-d_myarg0_d_beta)-(vgdin-myarg0)*d_alpha_phit_d_beta)/alpha_phit/alpha_phit);
d_exparg0_d_mtheta=((alpha_phit*(d_vgdin_d_mtheta-d_myarg0_d_mtheta)-(vgdin-myarg0)*d_alpha_phit_d_mtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtheta=((alpha_phit*(d_vgdin_d_vtheta-d_myarg0_d_vtheta)-(vgdin-myarg0)*d_alpha_phit_d_vtheta)/alpha_phit/alpha_phit);
d_exparg0_d_vtzeta=((alpha_phit*(d_vgdin_d_vtzeta-d_myarg0_d_vtzeta)-(vgdin-myarg0)*d_alpha_phit_d_vtzeta)/alpha_phit/alpha_phit);
d_exparg0_d_dibsat=((alpha_phit*(d_vgdin_d_dibsat-d_myarg0_d_dibsat)-(vgdin-myarg0)*d_alpha_phit_d_dibsat)/alpha_phit/alpha_phit);
d_exparg0_d_epsilon=((alpha_phit*(d_vgdin_d_epsilon-d_myarg0_d_epsilon)-(vgdin-myarg0)*d_alpha_phit_d_epsilon)/alpha_phit/alpha_phit);
d_exparg0_d_vzeta=((alpha_phit*(d_vgdin_d_vzeta-d_myarg0_d_vzeta)-(vgdin-myarg0)*d_alpha_phit_d_vzeta)/alpha_phit/alpha_phit);
d_exparg0_d_lambda=((alpha_phit*(d_vgdin_d_lambda-d_myarg0_d_lambda)-(vgdin-myarg0)*d_alpha_phit_d_lambda)/alpha_phit/alpha_phit);
d_exparg0_d_ngf=((alpha_phit*(d_vgdin_d_ngf-d_myarg0_d_ngf)-(vgdin-myarg0)*d_alpha_phit_d_ngf)/alpha_phit/alpha_phit);
d_exparg0_d_type=((alpha_phit*(d_vgdin_d_type-d_myarg0_d_type)-(vgdin-myarg0)*d_alpha_phit_d_type)/alpha_phit/alpha_phit);
exparg0=((vgdin-myarg0)/alpha_phit);
if((exparg0>50.0))
{
d_ffd0_d_vgsin=0.0;
d_ffd0_d_vdsin=0.0;
d_ffd0_d_qcbflag=0.0;
d_ffd0_d_vcin=0.0;
d_ffd0_d_vbin=0.0;
d_ffd0_d_qgsflag=0.0;
d_ffd0_d_tambin=0.0;
d_ffd0_d_tnomin=0.0;
d_ffd0_d_phitin=0.0;
d_ffd0_d_w=0.0;
d_ffd0_d_lin=0.0;
d_ffd0_d_cgin=0.0;
d_ffd0_d_cs=0.0;
d_ffd0_d_cc=0.0;
d_ffd0_d_cb=0.0;
d_ffd0_d_vto=0.0;
d_ffd0_d_ss=0.0;
d_ffd0_d_delta1=0.0;
d_ffd0_d_delta2=0.0;
d_ffd0_d_nd=0.0;
d_ffd0_d_alpha=0.0;
d_ffd0_d_vel0=0.0;
d_ffd0_d_mu0=0.0;
d_ffd0_d_beta=0.0;
d_ffd0_d_mtheta=0.0;
d_ffd0_d_vtheta=0.0;
d_ffd0_d_vtzeta=0.0;
d_ffd0_d_dibsat=0.0;
d_ffd0_d_epsilon=0.0;
d_ffd0_d_vzeta=0.0;
d_ffd0_d_lambda=0.0;
d_ffd0_d_ngf=0.0;
d_ffd0_d_type=0.0;
ffd0=0.0;
}
else
{
if((exparg0<(-50.0)))
{
d_ffd0_d_vgsin=0.0;
d_ffd0_d_vdsin=0.0;
d_ffd0_d_qcbflag=0.0;
d_ffd0_d_vcin=0.0;
d_ffd0_d_vbin=0.0;
d_ffd0_d_qgsflag=0.0;
d_ffd0_d_tambin=0.0;
d_ffd0_d_tnomin=0.0;
d_ffd0_d_phitin=0.0;
d_ffd0_d_w=0.0;
d_ffd0_d_lin=0.0;
d_ffd0_d_cgin=0.0;
d_ffd0_d_cs=0.0;
d_ffd0_d_cc=0.0;
d_ffd0_d_cb=0.0;
d_ffd0_d_vto=0.0;
d_ffd0_d_ss=0.0;
d_ffd0_d_delta1=0.0;
d_ffd0_d_delta2=0.0;
d_ffd0_d_nd=0.0;
d_ffd0_d_alpha=0.0;
d_ffd0_d_vel0=0.0;
d_ffd0_d_mu0=0.0;
d_ffd0_d_beta=0.0;
d_ffd0_d_mtheta=0.0;
d_ffd0_d_vtheta=0.0;
d_ffd0_d_vtzeta=0.0;
d_ffd0_d_dibsat=0.0;
d_ffd0_d_epsilon=0.0;
d_ffd0_d_vzeta=0.0;
d_ffd0_d_lambda=0.0;
d_ffd0_d_ngf=0.0;
d_ffd0_d_type=0.0;
ffd0=1.0;
}
else
{
d_ffd0_d_vgsin=(-exp(exparg0)*d_exparg0_d_vgsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vdsin=(-exp(exparg0)*d_exparg0_d_vdsin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_qcbflag=(-exp(exparg0)*d_exparg0_d_qcbflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vcin=(-exp(exparg0)*d_exparg0_d_vcin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vbin=(-exp(exparg0)*d_exparg0_d_vbin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_qgsflag=(-exp(exparg0)*d_exparg0_d_qgsflag/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_tambin=(-exp(exparg0)*d_exparg0_d_tambin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_tnomin=(-exp(exparg0)*d_exparg0_d_tnomin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_phitin=(-exp(exparg0)*d_exparg0_d_phitin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_w=(-exp(exparg0)*d_exparg0_d_w/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_lin=(-exp(exparg0)*d_exparg0_d_lin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cgin=(-exp(exparg0)*d_exparg0_d_cgin/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cs=(-exp(exparg0)*d_exparg0_d_cs/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cc=(-exp(exparg0)*d_exparg0_d_cc/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_cb=(-exp(exparg0)*d_exparg0_d_cb/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vto=(-exp(exparg0)*d_exparg0_d_vto/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_ss=(-exp(exparg0)*d_exparg0_d_ss/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_delta1=(-exp(exparg0)*d_exparg0_d_delta1/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_delta2=(-exp(exparg0)*d_exparg0_d_delta2/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_nd=(-exp(exparg0)*d_exparg0_d_nd/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_alpha=(-exp(exparg0)*d_exparg0_d_alpha/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vel0=(-exp(exparg0)*d_exparg0_d_vel0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_mu0=(-exp(exparg0)*d_exparg0_d_mu0/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_beta=(-exp(exparg0)*d_exparg0_d_beta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_mtheta=(-exp(exparg0)*d_exparg0_d_mtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vtheta=(-exp(exparg0)*d_exparg0_d_vtheta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vtzeta=(-exp(exparg0)*d_exparg0_d_vtzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_dibsat=(-exp(exparg0)*d_exparg0_d_dibsat/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_epsilon=(-exp(exparg0)*d_exparg0_d_epsilon/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_vzeta=(-exp(exparg0)*d_exparg0_d_vzeta/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_lambda=(-exp(exparg0)*d_exparg0_d_lambda/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_ngf=(-exp(exparg0)*d_exparg0_d_ngf/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
d_ffd0_d_type=(-exp(exparg0)*d_exparg0_d_type/(1.0+exp(exparg0))/(1.0+exp(exparg0)));
ffd0=(1.0/(1.0+exp(exparg0)));
}
}
d_etad0_d_vgsin=((two_n_phit0*((1.0-d_vdx0_d_vgsin)-(d_vtof_d_vgsin-(((0.1*alpha_phit)*d_ffd0_d_vgsin)+((0.1*d_alpha_phit_d_vgsin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etad0_d_vdsin=((two_n_phit0*((-d_vdx0_d_vdsin)-(d_vtof_d_vdsin-(((0.1*alpha_phit)*d_ffd0_d_vdsin)+((0.1*d_alpha_phit_d_vdsin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etad0_d_qcbflag=((two_n_phit0*((-d_vdx0_d_qcbflag)-(d_vtof_d_qcbflag-(((0.1*alpha_phit)*d_ffd0_d_qcbflag)+((0.1*d_alpha_phit_d_qcbflag)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etad0_d_vcin=((two_n_phit0*((-d_vdx0_d_vcin)-(d_vtof_d_vcin-(((0.1*alpha_phit)*d_ffd0_d_vcin)+((0.1*d_alpha_phit_d_vcin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etad0_d_vbin=((two_n_phit0*((-d_vdx0_d_vbin)-(d_vtof_d_vbin-(((0.1*alpha_phit)*d_ffd0_d_vbin)+((0.1*d_alpha_phit_d_vbin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etad0_d_qgsflag=((two_n_phit0*((-d_vdx0_d_qgsflag)-(d_vtof_d_qgsflag-(((0.1*alpha_phit)*d_ffd0_d_qgsflag)+((0.1*d_alpha_phit_d_qgsflag)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etad0_d_tambin=((two_n_phit0*((-d_vdx0_d_tambin)-(d_vtof_d_tambin-(((0.1*alpha_phit)*d_ffd0_d_tambin)+((0.1*d_alpha_phit_d_tambin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etad0_d_tnomin=((two_n_phit0*((-d_vdx0_d_tnomin)-(d_vtof_d_tnomin-(((0.1*alpha_phit)*d_ffd0_d_tnomin)+((0.1*d_alpha_phit_d_tnomin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etad0_d_phitin=((two_n_phit0*((-d_vdx0_d_phitin)-(d_vtof_d_phitin-(((0.1*alpha_phit)*d_ffd0_d_phitin)+((0.1*d_alpha_phit_d_phitin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etad0_d_w=((two_n_phit0*((-d_vdx0_d_w)-(d_vtof_d_w-(((0.1*alpha_phit)*d_ffd0_d_w)+((0.1*d_alpha_phit_d_w)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etad0_d_lin=((two_n_phit0*((-d_vdx0_d_lin)-(d_vtof_d_lin-(((0.1*alpha_phit)*d_ffd0_d_lin)+((0.1*d_alpha_phit_d_lin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etad0_d_cgin=((two_n_phit0*((-d_vdx0_d_cgin)-(d_vtof_d_cgin-(((0.1*alpha_phit)*d_ffd0_d_cgin)+((0.1*d_alpha_phit_d_cgin)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etad0_d_cs=((two_n_phit0*((-d_vdx0_d_cs)-(d_vtof_d_cs-(((0.1*alpha_phit)*d_ffd0_d_cs)+((0.1*d_alpha_phit_d_cs)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etad0_d_cc=((two_n_phit0*((-d_vdx0_d_cc)-(d_vtof_d_cc-(((0.1*alpha_phit)*d_ffd0_d_cc)+((0.1*d_alpha_phit_d_cc)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etad0_d_cb=((two_n_phit0*((-d_vdx0_d_cb)-(d_vtof_d_cb-(((0.1*alpha_phit)*d_ffd0_d_cb)+((0.1*d_alpha_phit_d_cb)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etad0_d_vto=((two_n_phit0*((-d_vdx0_d_vto)-(d_vtof_d_vto-(((0.1*alpha_phit)*d_ffd0_d_vto)+((0.1*d_alpha_phit_d_vto)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etad0_d_ss=((two_n_phit0*((-d_vdx0_d_ss)-(d_vtof_d_ss-(((0.1*alpha_phit)*d_ffd0_d_ss)+((0.1*d_alpha_phit_d_ss)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etad0_d_delta1=((two_n_phit0*((-d_vdx0_d_delta1)-(d_vtof_d_delta1-(((0.1*alpha_phit)*d_ffd0_d_delta1)+((0.1*d_alpha_phit_d_delta1)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etad0_d_delta2=((two_n_phit0*((-d_vdx0_d_delta2)-(d_vtof_d_delta2-(((0.1*alpha_phit)*d_ffd0_d_delta2)+((0.1*d_alpha_phit_d_delta2)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etad0_d_nd=((two_n_phit0*((-d_vdx0_d_nd)-(d_vtof_d_nd-(((0.1*alpha_phit)*d_ffd0_d_nd)+((0.1*d_alpha_phit_d_nd)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etad0_d_alpha=((two_n_phit0*((-d_vdx0_d_alpha)-(d_vtof_d_alpha-(((0.1*alpha_phit)*d_ffd0_d_alpha)+((0.1*d_alpha_phit_d_alpha)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etad0_d_vel0=((two_n_phit0*((-d_vdx0_d_vel0)-(d_vtof_d_vel0-(((0.1*alpha_phit)*d_ffd0_d_vel0)+((0.1*d_alpha_phit_d_vel0)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etad0_d_mu0=((two_n_phit0*((-d_vdx0_d_mu0)-(d_vtof_d_mu0-(((0.1*alpha_phit)*d_ffd0_d_mu0)+((0.1*d_alpha_phit_d_mu0)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etad0_d_beta=((two_n_phit0*((-d_vdx0_d_beta)-(d_vtof_d_beta-(((0.1*alpha_phit)*d_ffd0_d_beta)+((0.1*d_alpha_phit_d_beta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etad0_d_mtheta=((two_n_phit0*((-d_vdx0_d_mtheta)-(d_vtof_d_mtheta-(((0.1*alpha_phit)*d_ffd0_d_mtheta)+((0.1*d_alpha_phit_d_mtheta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etad0_d_vtheta=((two_n_phit0*((-d_vdx0_d_vtheta)-(d_vtof_d_vtheta-(((0.1*alpha_phit)*d_ffd0_d_vtheta)+((0.1*d_alpha_phit_d_vtheta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etad0_d_vtzeta=((two_n_phit0*((-d_vdx0_d_vtzeta)-(d_vtof_d_vtzeta-(((0.1*alpha_phit)*d_ffd0_d_vtzeta)+((0.1*d_alpha_phit_d_vtzeta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etad0_d_dibsat=((two_n_phit0*((-d_vdx0_d_dibsat)-(d_vtof_d_dibsat-(((0.1*alpha_phit)*d_ffd0_d_dibsat)+((0.1*d_alpha_phit_d_dibsat)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etad0_d_epsilon=((two_n_phit0*((-d_vdx0_d_epsilon)-(d_vtof_d_epsilon-(((0.1*alpha_phit)*d_ffd0_d_epsilon)+((0.1*d_alpha_phit_d_epsilon)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etad0_d_vzeta=((two_n_phit0*((-d_vdx0_d_vzeta)-(d_vtof_d_vzeta-(((0.1*alpha_phit)*d_ffd0_d_vzeta)+((0.1*d_alpha_phit_d_vzeta)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etad0_d_lambda=((two_n_phit0*((-d_vdx0_d_lambda)-(d_vtof_d_lambda-(((0.1*alpha_phit)*d_ffd0_d_lambda)+((0.1*d_alpha_phit_d_lambda)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etad0_d_ngf=((two_n_phit0*((-d_vdx0_d_ngf)-(d_vtof_d_ngf-(((0.1*alpha_phit)*d_ffd0_d_ngf)+((0.1*d_alpha_phit_d_ngf)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etad0_d_type=((two_n_phit0*((-d_vdx0_d_type)-(d_vtof_d_type-(((0.1*alpha_phit)*d_ffd0_d_type)+((0.1*d_alpha_phit_d_type)*ffd0))))-((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etad0=(((vgsin-vdx0)-(vtof-((0.1*alpha_phit)*ffd0)))/two_n_phit0);
if((etad0>50.0))
{
d_qinvd0_d_vgsin=((qref0*d_etad0_d_vgsin)+(d_qref0_d_vgsin*etad0));
d_qinvd0_d_vdsin=((qref0*d_etad0_d_vdsin)+(d_qref0_d_vdsin*etad0));
d_qinvd0_d_qcbflag=((qref0*d_etad0_d_qcbflag)+(d_qref0_d_qcbflag*etad0));
d_qinvd0_d_vcin=((qref0*d_etad0_d_vcin)+(d_qref0_d_vcin*etad0));
d_qinvd0_d_vbin=((qref0*d_etad0_d_vbin)+(d_qref0_d_vbin*etad0));
d_qinvd0_d_qgsflag=((qref0*d_etad0_d_qgsflag)+(d_qref0_d_qgsflag*etad0));
d_qinvd0_d_tambin=((qref0*d_etad0_d_tambin)+(d_qref0_d_tambin*etad0));
d_qinvd0_d_tnomin=((qref0*d_etad0_d_tnomin)+(d_qref0_d_tnomin*etad0));
d_qinvd0_d_phitin=((qref0*d_etad0_d_phitin)+(d_qref0_d_phitin*etad0));
d_qinvd0_d_w=((qref0*d_etad0_d_w)+(d_qref0_d_w*etad0));
d_qinvd0_d_lin=((qref0*d_etad0_d_lin)+(d_qref0_d_lin*etad0));
d_qinvd0_d_cgin=((qref0*d_etad0_d_cgin)+(d_qref0_d_cgin*etad0));
d_qinvd0_d_cs=((qref0*d_etad0_d_cs)+(d_qref0_d_cs*etad0));
d_qinvd0_d_cc=((qref0*d_etad0_d_cc)+(d_qref0_d_cc*etad0));
d_qinvd0_d_cb=((qref0*d_etad0_d_cb)+(d_qref0_d_cb*etad0));
d_qinvd0_d_vto=((qref0*d_etad0_d_vto)+(d_qref0_d_vto*etad0));
d_qinvd0_d_ss=((qref0*d_etad0_d_ss)+(d_qref0_d_ss*etad0));
d_qinvd0_d_delta1=((qref0*d_etad0_d_delta1)+(d_qref0_d_delta1*etad0));
d_qinvd0_d_delta2=((qref0*d_etad0_d_delta2)+(d_qref0_d_delta2*etad0));
d_qinvd0_d_nd=((qref0*d_etad0_d_nd)+(d_qref0_d_nd*etad0));
d_qinvd0_d_alpha=((qref0*d_etad0_d_alpha)+(d_qref0_d_alpha*etad0));
d_qinvd0_d_vel0=((qref0*d_etad0_d_vel0)+(d_qref0_d_vel0*etad0));
d_qinvd0_d_mu0=((qref0*d_etad0_d_mu0)+(d_qref0_d_mu0*etad0));
d_qinvd0_d_beta=((qref0*d_etad0_d_beta)+(d_qref0_d_beta*etad0));
d_qinvd0_d_mtheta=((qref0*d_etad0_d_mtheta)+(d_qref0_d_mtheta*etad0));
d_qinvd0_d_vtheta=((qref0*d_etad0_d_vtheta)+(d_qref0_d_vtheta*etad0));
d_qinvd0_d_vtzeta=((qref0*d_etad0_d_vtzeta)+(d_qref0_d_vtzeta*etad0));
d_qinvd0_d_dibsat=((qref0*d_etad0_d_dibsat)+(d_qref0_d_dibsat*etad0));
d_qinvd0_d_epsilon=((qref0*d_etad0_d_epsilon)+(d_qref0_d_epsilon*etad0));
d_qinvd0_d_vzeta=((qref0*d_etad0_d_vzeta)+(d_qref0_d_vzeta*etad0));
d_qinvd0_d_lambda=((qref0*d_etad0_d_lambda)+(d_qref0_d_lambda*etad0));
d_qinvd0_d_ngf=((qref0*d_etad0_d_ngf)+(d_qref0_d_ngf*etad0));
d_qinvd0_d_type=((qref0*d_etad0_d_type)+(d_qref0_d_type*etad0));
qinvd0=(qref0*etad0);
}
else
{
if((etad0<(-50.0)))
{
d_qinvd0_d_vgsin=0.0;
d_qinvd0_d_vdsin=0.0;
d_qinvd0_d_qcbflag=0.0;
d_qinvd0_d_vcin=0.0;
d_qinvd0_d_vbin=0.0;
d_qinvd0_d_qgsflag=0.0;
d_qinvd0_d_tambin=0.0;
d_qinvd0_d_tnomin=0.0;
d_qinvd0_d_phitin=0.0;
d_qinvd0_d_w=0.0;
d_qinvd0_d_lin=0.0;
d_qinvd0_d_cgin=0.0;
d_qinvd0_d_cs=0.0;
d_qinvd0_d_cc=0.0;
d_qinvd0_d_cb=0.0;
d_qinvd0_d_vto=0.0;
d_qinvd0_d_ss=0.0;
d_qinvd0_d_delta1=0.0;
d_qinvd0_d_delta2=0.0;
d_qinvd0_d_nd=0.0;
d_qinvd0_d_alpha=0.0;
d_qinvd0_d_vel0=0.0;
d_qinvd0_d_mu0=0.0;
d_qinvd0_d_beta=0.0;
d_qinvd0_d_mtheta=0.0;
d_qinvd0_d_vtheta=0.0;
d_qinvd0_d_vtzeta=0.0;
d_qinvd0_d_dibsat=0.0;
d_qinvd0_d_epsilon=0.0;
d_qinvd0_d_vzeta=0.0;
d_qinvd0_d_lambda=0.0;
d_qinvd0_d_ngf=0.0;
d_qinvd0_d_type=0.0;
qinvd0=0;
}
else
{
d_qinvd0_d_vgsin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vgsin)+(d_qref0_d_vgsin*log((1.0+exp(etad0)))));
d_qinvd0_d_vdsin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vdsin)+(d_qref0_d_vdsin*log((1.0+exp(etad0)))));
d_qinvd0_d_qcbflag=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_qcbflag)+(d_qref0_d_qcbflag*log((1.0+exp(etad0)))));
d_qinvd0_d_vcin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vcin)+(d_qref0_d_vcin*log((1.0+exp(etad0)))));
d_qinvd0_d_vbin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vbin)+(d_qref0_d_vbin*log((1.0+exp(etad0)))));
d_qinvd0_d_qgsflag=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_qgsflag)+(d_qref0_d_qgsflag*log((1.0+exp(etad0)))));
d_qinvd0_d_tambin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_tambin)+(d_qref0_d_tambin*log((1.0+exp(etad0)))));
d_qinvd0_d_tnomin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_tnomin)+(d_qref0_d_tnomin*log((1.0+exp(etad0)))));
d_qinvd0_d_phitin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_phitin)+(d_qref0_d_phitin*log((1.0+exp(etad0)))));
d_qinvd0_d_w=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_w)+(d_qref0_d_w*log((1.0+exp(etad0)))));
d_qinvd0_d_lin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_lin)+(d_qref0_d_lin*log((1.0+exp(etad0)))));
d_qinvd0_d_cgin=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cgin)+(d_qref0_d_cgin*log((1.0+exp(etad0)))));
d_qinvd0_d_cs=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cs)+(d_qref0_d_cs*log((1.0+exp(etad0)))));
d_qinvd0_d_cc=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cc)+(d_qref0_d_cc*log((1.0+exp(etad0)))));
d_qinvd0_d_cb=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_cb)+(d_qref0_d_cb*log((1.0+exp(etad0)))));
d_qinvd0_d_vto=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vto)+(d_qref0_d_vto*log((1.0+exp(etad0)))));
d_qinvd0_d_ss=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_ss)+(d_qref0_d_ss*log((1.0+exp(etad0)))));
d_qinvd0_d_delta1=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_delta1)+(d_qref0_d_delta1*log((1.0+exp(etad0)))));
d_qinvd0_d_delta2=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_delta2)+(d_qref0_d_delta2*log((1.0+exp(etad0)))));
d_qinvd0_d_nd=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_nd)+(d_qref0_d_nd*log((1.0+exp(etad0)))));
d_qinvd0_d_alpha=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_alpha)+(d_qref0_d_alpha*log((1.0+exp(etad0)))));
d_qinvd0_d_vel0=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vel0)+(d_qref0_d_vel0*log((1.0+exp(etad0)))));
d_qinvd0_d_mu0=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_mu0)+(d_qref0_d_mu0*log((1.0+exp(etad0)))));
d_qinvd0_d_beta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_beta)+(d_qref0_d_beta*log((1.0+exp(etad0)))));
d_qinvd0_d_mtheta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_mtheta)+(d_qref0_d_mtheta*log((1.0+exp(etad0)))));
d_qinvd0_d_vtheta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vtheta)+(d_qref0_d_vtheta*log((1.0+exp(etad0)))));
d_qinvd0_d_vtzeta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vtzeta)+(d_qref0_d_vtzeta*log((1.0+exp(etad0)))));
d_qinvd0_d_dibsat=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_dibsat)+(d_qref0_d_dibsat*log((1.0+exp(etad0)))));
d_qinvd0_d_epsilon=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_epsilon)+(d_qref0_d_epsilon*log((1.0+exp(etad0)))));
d_qinvd0_d_vzeta=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_vzeta)+(d_qref0_d_vzeta*log((1.0+exp(etad0)))));
d_qinvd0_d_lambda=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_lambda)+(d_qref0_d_lambda*log((1.0+exp(etad0)))));
d_qinvd0_d_ngf=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_ngf)+(d_qref0_d_ngf*log((1.0+exp(etad0)))));
d_qinvd0_d_type=((qref0*(1.0/(1.0+exp(etad0)))*exp(etad0)*d_etad0_d_type)+(d_qref0_d_type*log((1.0+exp(etad0)))));
qinvd0=(qref0*log((1.0+exp(etad0))));
}
}
d_qs2_d_vgsin=((qinvs0*d_qinvs0_d_vgsin)+(d_qinvs0_d_vgsin*qinvs0));
d_qs2_d_vdsin=((qinvs0*d_qinvs0_d_vdsin)+(d_qinvs0_d_vdsin*qinvs0));
d_qs2_d_qcbflag=((qinvs0*d_qinvs0_d_qcbflag)+(d_qinvs0_d_qcbflag*qinvs0));
d_qs2_d_vcin=((qinvs0*d_qinvs0_d_vcin)+(d_qinvs0_d_vcin*qinvs0));
d_qs2_d_vbin=((qinvs0*d_qinvs0_d_vbin)+(d_qinvs0_d_vbin*qinvs0));
d_qs2_d_qgsflag=((qinvs0*d_qinvs0_d_qgsflag)+(d_qinvs0_d_qgsflag*qinvs0));
d_qs2_d_tambin=((qinvs0*d_qinvs0_d_tambin)+(d_qinvs0_d_tambin*qinvs0));
d_qs2_d_tnomin=((qinvs0*d_qinvs0_d_tnomin)+(d_qinvs0_d_tnomin*qinvs0));
d_qs2_d_phitin=((qinvs0*d_qinvs0_d_phitin)+(d_qinvs0_d_phitin*qinvs0));
d_qs2_d_w=((qinvs0*d_qinvs0_d_w)+(d_qinvs0_d_w*qinvs0));
d_qs2_d_lin=((qinvs0*d_qinvs0_d_lin)+(d_qinvs0_d_lin*qinvs0));
d_qs2_d_cgin=((qinvs0*d_qinvs0_d_cgin)+(d_qinvs0_d_cgin*qinvs0));
d_qs2_d_cs=((qinvs0*d_qinvs0_d_cs)+(d_qinvs0_d_cs*qinvs0));
d_qs2_d_cc=((qinvs0*d_qinvs0_d_cc)+(d_qinvs0_d_cc*qinvs0));
d_qs2_d_cb=((qinvs0*d_qinvs0_d_cb)+(d_qinvs0_d_cb*qinvs0));
d_qs2_d_vto=((qinvs0*d_qinvs0_d_vto)+(d_qinvs0_d_vto*qinvs0));
d_qs2_d_ss=((qinvs0*d_qinvs0_d_ss)+(d_qinvs0_d_ss*qinvs0));
d_qs2_d_delta1=((qinvs0*d_qinvs0_d_delta1)+(d_qinvs0_d_delta1*qinvs0));
d_qs2_d_delta2=((qinvs0*d_qinvs0_d_delta2)+(d_qinvs0_d_delta2*qinvs0));
d_qs2_d_nd=((qinvs0*d_qinvs0_d_nd)+(d_qinvs0_d_nd*qinvs0));
d_qs2_d_alpha=((qinvs0*d_qinvs0_d_alpha)+(d_qinvs0_d_alpha*qinvs0));
d_qs2_d_vel0=((qinvs0*d_qinvs0_d_vel0)+(d_qinvs0_d_vel0*qinvs0));
d_qs2_d_mu0=((qinvs0*d_qinvs0_d_mu0)+(d_qinvs0_d_mu0*qinvs0));
d_qs2_d_beta=((qinvs0*d_qinvs0_d_beta)+(d_qinvs0_d_beta*qinvs0));
d_qs2_d_mtheta=((qinvs0*d_qinvs0_d_mtheta)+(d_qinvs0_d_mtheta*qinvs0));
d_qs2_d_vtheta=((qinvs0*d_qinvs0_d_vtheta)+(d_qinvs0_d_vtheta*qinvs0));
d_qs2_d_vtzeta=((qinvs0*d_qinvs0_d_vtzeta)+(d_qinvs0_d_vtzeta*qinvs0));
d_qs2_d_dibsat=((qinvs0*d_qinvs0_d_dibsat)+(d_qinvs0_d_dibsat*qinvs0));
d_qs2_d_epsilon=((qinvs0*d_qinvs0_d_epsilon)+(d_qinvs0_d_epsilon*qinvs0));
d_qs2_d_vzeta=((qinvs0*d_qinvs0_d_vzeta)+(d_qinvs0_d_vzeta*qinvs0));
d_qs2_d_lambda=((qinvs0*d_qinvs0_d_lambda)+(d_qinvs0_d_lambda*qinvs0));
d_qs2_d_ngf=((qinvs0*d_qinvs0_d_ngf)+(d_qinvs0_d_ngf*qinvs0));
d_qs2_d_type=((qinvs0*d_qinvs0_d_type)+(d_qinvs0_d_type*qinvs0));
qs2=((qinvs0*qinvs0)+1e-38);
d_qs3_d_vgsin=((qs2*d_qinvs0_d_vgsin)+(d_qs2_d_vgsin*qinvs0));
d_qs3_d_vdsin=((qs2*d_qinvs0_d_vdsin)+(d_qs2_d_vdsin*qinvs0));
d_qs3_d_qcbflag=((qs2*d_qinvs0_d_qcbflag)+(d_qs2_d_qcbflag*qinvs0));
d_qs3_d_vcin=((qs2*d_qinvs0_d_vcin)+(d_qs2_d_vcin*qinvs0));
d_qs3_d_vbin=((qs2*d_qinvs0_d_vbin)+(d_qs2_d_vbin*qinvs0));
d_qs3_d_qgsflag=((qs2*d_qinvs0_d_qgsflag)+(d_qs2_d_qgsflag*qinvs0));
d_qs3_d_tambin=((qs2*d_qinvs0_d_tambin)+(d_qs2_d_tambin*qinvs0));
d_qs3_d_tnomin=((qs2*d_qinvs0_d_tnomin)+(d_qs2_d_tnomin*qinvs0));
d_qs3_d_phitin=((qs2*d_qinvs0_d_phitin)+(d_qs2_d_phitin*qinvs0));
d_qs3_d_w=((qs2*d_qinvs0_d_w)+(d_qs2_d_w*qinvs0));
d_qs3_d_lin=((qs2*d_qinvs0_d_lin)+(d_qs2_d_lin*qinvs0));
d_qs3_d_cgin=((qs2*d_qinvs0_d_cgin)+(d_qs2_d_cgin*qinvs0));
d_qs3_d_cs=((qs2*d_qinvs0_d_cs)+(d_qs2_d_cs*qinvs0));
d_qs3_d_cc=((qs2*d_qinvs0_d_cc)+(d_qs2_d_cc*qinvs0));
d_qs3_d_cb=((qs2*d_qinvs0_d_cb)+(d_qs2_d_cb*qinvs0));
d_qs3_d_vto=((qs2*d_qinvs0_d_vto)+(d_qs2_d_vto*qinvs0));
d_qs3_d_ss=((qs2*d_qinvs0_d_ss)+(d_qs2_d_ss*qinvs0));
d_qs3_d_delta1=((qs2*d_qinvs0_d_delta1)+(d_qs2_d_delta1*qinvs0));
d_qs3_d_delta2=((qs2*d_qinvs0_d_delta2)+(d_qs2_d_delta2*qinvs0));
d_qs3_d_nd=((qs2*d_qinvs0_d_nd)+(d_qs2_d_nd*qinvs0));
d_qs3_d_alpha=((qs2*d_qinvs0_d_alpha)+(d_qs2_d_alpha*qinvs0));
d_qs3_d_vel0=((qs2*d_qinvs0_d_vel0)+(d_qs2_d_vel0*qinvs0));
d_qs3_d_mu0=((qs2*d_qinvs0_d_mu0)+(d_qs2_d_mu0*qinvs0));
d_qs3_d_beta=((qs2*d_qinvs0_d_beta)+(d_qs2_d_beta*qinvs0));
d_qs3_d_mtheta=((qs2*d_qinvs0_d_mtheta)+(d_qs2_d_mtheta*qinvs0));
d_qs3_d_vtheta=((qs2*d_qinvs0_d_vtheta)+(d_qs2_d_vtheta*qinvs0));
d_qs3_d_vtzeta=((qs2*d_qinvs0_d_vtzeta)+(d_qs2_d_vtzeta*qinvs0));
d_qs3_d_dibsat=((qs2*d_qinvs0_d_dibsat)+(d_qs2_d_dibsat*qinvs0));
d_qs3_d_epsilon=((qs2*d_qinvs0_d_epsilon)+(d_qs2_d_epsilon*qinvs0));
d_qs3_d_vzeta=((qs2*d_qinvs0_d_vzeta)+(d_qs2_d_vzeta*qinvs0));
d_qs3_d_lambda=((qs2*d_qinvs0_d_lambda)+(d_qs2_d_lambda*qinvs0));
d_qs3_d_ngf=((qs2*d_qinvs0_d_ngf)+(d_qs2_d_ngf*qinvs0));
d_qs3_d_type=((qs2*d_qinvs0_d_type)+(d_qs2_d_type*qinvs0));
qs3=((qs2*qinvs0)+1e-57);
d_qd2_d_vgsin=((qinvd0*d_qinvd0_d_vgsin)+(d_qinvd0_d_vgsin*qinvd0));
d_qd2_d_vdsin=((qinvd0*d_qinvd0_d_vdsin)+(d_qinvd0_d_vdsin*qinvd0));
d_qd2_d_qcbflag=((qinvd0*d_qinvd0_d_qcbflag)+(d_qinvd0_d_qcbflag*qinvd0));
d_qd2_d_vcin=((qinvd0*d_qinvd0_d_vcin)+(d_qinvd0_d_vcin*qinvd0));
d_qd2_d_vbin=((qinvd0*d_qinvd0_d_vbin)+(d_qinvd0_d_vbin*qinvd0));
d_qd2_d_qgsflag=((qinvd0*d_qinvd0_d_qgsflag)+(d_qinvd0_d_qgsflag*qinvd0));
d_qd2_d_tambin=((qinvd0*d_qinvd0_d_tambin)+(d_qinvd0_d_tambin*qinvd0));
d_qd2_d_tnomin=((qinvd0*d_qinvd0_d_tnomin)+(d_qinvd0_d_tnomin*qinvd0));
d_qd2_d_phitin=((qinvd0*d_qinvd0_d_phitin)+(d_qinvd0_d_phitin*qinvd0));
d_qd2_d_w=((qinvd0*d_qinvd0_d_w)+(d_qinvd0_d_w*qinvd0));
d_qd2_d_lin=((qinvd0*d_qinvd0_d_lin)+(d_qinvd0_d_lin*qinvd0));
d_qd2_d_cgin=((qinvd0*d_qinvd0_d_cgin)+(d_qinvd0_d_cgin*qinvd0));
d_qd2_d_cs=((qinvd0*d_qinvd0_d_cs)+(d_qinvd0_d_cs*qinvd0));
d_qd2_d_cc=((qinvd0*d_qinvd0_d_cc)+(d_qinvd0_d_cc*qinvd0));
d_qd2_d_cb=((qinvd0*d_qinvd0_d_cb)+(d_qinvd0_d_cb*qinvd0));
d_qd2_d_vto=((qinvd0*d_qinvd0_d_vto)+(d_qinvd0_d_vto*qinvd0));
d_qd2_d_ss=((qinvd0*d_qinvd0_d_ss)+(d_qinvd0_d_ss*qinvd0));
d_qd2_d_delta1=((qinvd0*d_qinvd0_d_delta1)+(d_qinvd0_d_delta1*qinvd0));
d_qd2_d_delta2=((qinvd0*d_qinvd0_d_delta2)+(d_qinvd0_d_delta2*qinvd0));
d_qd2_d_nd=((qinvd0*d_qinvd0_d_nd)+(d_qinvd0_d_nd*qinvd0));
d_qd2_d_alpha=((qinvd0*d_qinvd0_d_alpha)+(d_qinvd0_d_alpha*qinvd0));
d_qd2_d_vel0=((qinvd0*d_qinvd0_d_vel0)+(d_qinvd0_d_vel0*qinvd0));
d_qd2_d_mu0=((qinvd0*d_qinvd0_d_mu0)+(d_qinvd0_d_mu0*qinvd0));
d_qd2_d_beta=((qinvd0*d_qinvd0_d_beta)+(d_qinvd0_d_beta*qinvd0));
d_qd2_d_mtheta=((qinvd0*d_qinvd0_d_mtheta)+(d_qinvd0_d_mtheta*qinvd0));
d_qd2_d_vtheta=((qinvd0*d_qinvd0_d_vtheta)+(d_qinvd0_d_vtheta*qinvd0));
d_qd2_d_vtzeta=((qinvd0*d_qinvd0_d_vtzeta)+(d_qinvd0_d_vtzeta*qinvd0));
d_qd2_d_dibsat=((qinvd0*d_qinvd0_d_dibsat)+(d_qinvd0_d_dibsat*qinvd0));
d_qd2_d_epsilon=((qinvd0*d_qinvd0_d_epsilon)+(d_qinvd0_d_epsilon*qinvd0));
d_qd2_d_vzeta=((qinvd0*d_qinvd0_d_vzeta)+(d_qinvd0_d_vzeta*qinvd0));
d_qd2_d_lambda=((qinvd0*d_qinvd0_d_lambda)+(d_qinvd0_d_lambda*qinvd0));
d_qd2_d_ngf=((qinvd0*d_qinvd0_d_ngf)+(d_qinvd0_d_ngf*qinvd0));
d_qd2_d_type=((qinvd0*d_qinvd0_d_type)+(d_qinvd0_d_type*qinvd0));
qd2=((qinvd0*qinvd0)+1e-38);
d_qd3_d_vgsin=((qd2*d_qinvd0_d_vgsin)+(d_qd2_d_vgsin*qinvd0));
d_qd3_d_vdsin=((qd2*d_qinvd0_d_vdsin)+(d_qd2_d_vdsin*qinvd0));
d_qd3_d_qcbflag=((qd2*d_qinvd0_d_qcbflag)+(d_qd2_d_qcbflag*qinvd0));
d_qd3_d_vcin=((qd2*d_qinvd0_d_vcin)+(d_qd2_d_vcin*qinvd0));
d_qd3_d_vbin=((qd2*d_qinvd0_d_vbin)+(d_qd2_d_vbin*qinvd0));
d_qd3_d_qgsflag=((qd2*d_qinvd0_d_qgsflag)+(d_qd2_d_qgsflag*qinvd0));
d_qd3_d_tambin=((qd2*d_qinvd0_d_tambin)+(d_qd2_d_tambin*qinvd0));
d_qd3_d_tnomin=((qd2*d_qinvd0_d_tnomin)+(d_qd2_d_tnomin*qinvd0));
d_qd3_d_phitin=((qd2*d_qinvd0_d_phitin)+(d_qd2_d_phitin*qinvd0));
d_qd3_d_w=((qd2*d_qinvd0_d_w)+(d_qd2_d_w*qinvd0));
d_qd3_d_lin=((qd2*d_qinvd0_d_lin)+(d_qd2_d_lin*qinvd0));
d_qd3_d_cgin=((qd2*d_qinvd0_d_cgin)+(d_qd2_d_cgin*qinvd0));
d_qd3_d_cs=((qd2*d_qinvd0_d_cs)+(d_qd2_d_cs*qinvd0));
d_qd3_d_cc=((qd2*d_qinvd0_d_cc)+(d_qd2_d_cc*qinvd0));
d_qd3_d_cb=((qd2*d_qinvd0_d_cb)+(d_qd2_d_cb*qinvd0));
d_qd3_d_vto=((qd2*d_qinvd0_d_vto)+(d_qd2_d_vto*qinvd0));
d_qd3_d_ss=((qd2*d_qinvd0_d_ss)+(d_qd2_d_ss*qinvd0));
d_qd3_d_delta1=((qd2*d_qinvd0_d_delta1)+(d_qd2_d_delta1*qinvd0));
d_qd3_d_delta2=((qd2*d_qinvd0_d_delta2)+(d_qd2_d_delta2*qinvd0));
d_qd3_d_nd=((qd2*d_qinvd0_d_nd)+(d_qd2_d_nd*qinvd0));
d_qd3_d_alpha=((qd2*d_qinvd0_d_alpha)+(d_qd2_d_alpha*qinvd0));
d_qd3_d_vel0=((qd2*d_qinvd0_d_vel0)+(d_qd2_d_vel0*qinvd0));
d_qd3_d_mu0=((qd2*d_qinvd0_d_mu0)+(d_qd2_d_mu0*qinvd0));
d_qd3_d_beta=((qd2*d_qinvd0_d_beta)+(d_qd2_d_beta*qinvd0));
d_qd3_d_mtheta=((qd2*d_qinvd0_d_mtheta)+(d_qd2_d_mtheta*qinvd0));
d_qd3_d_vtheta=((qd2*d_qinvd0_d_vtheta)+(d_qd2_d_vtheta*qinvd0));
d_qd3_d_vtzeta=((qd2*d_qinvd0_d_vtzeta)+(d_qd2_d_vtzeta*qinvd0));
d_qd3_d_dibsat=((qd2*d_qinvd0_d_dibsat)+(d_qd2_d_dibsat*qinvd0));
d_qd3_d_epsilon=((qd2*d_qinvd0_d_epsilon)+(d_qd2_d_epsilon*qinvd0));
d_qd3_d_vzeta=((qd2*d_qinvd0_d_vzeta)+(d_qd2_d_vzeta*qinvd0));
d_qd3_d_lambda=((qd2*d_qinvd0_d_lambda)+(d_qd2_d_lambda*qinvd0));
d_qd3_d_ngf=((qd2*d_qinvd0_d_ngf)+(d_qd2_d_ngf*qinvd0));
d_qd3_d_type=((qd2*d_qinvd0_d_type)+(d_qd2_d_type*qinvd0));
qd3=((qd2*qinvd0)+1e-57);
d_qsqd_d_vgsin=((qinvs0*d_qinvd0_d_vgsin)+(d_qinvs0_d_vgsin*qinvd0));
d_qsqd_d_vdsin=((qinvs0*d_qinvd0_d_vdsin)+(d_qinvs0_d_vdsin*qinvd0));
d_qsqd_d_qcbflag=((qinvs0*d_qinvd0_d_qcbflag)+(d_qinvs0_d_qcbflag*qinvd0));
d_qsqd_d_vcin=((qinvs0*d_qinvd0_d_vcin)+(d_qinvs0_d_vcin*qinvd0));
d_qsqd_d_vbin=((qinvs0*d_qinvd0_d_vbin)+(d_qinvs0_d_vbin*qinvd0));
d_qsqd_d_qgsflag=((qinvs0*d_qinvd0_d_qgsflag)+(d_qinvs0_d_qgsflag*qinvd0));
d_qsqd_d_tambin=((qinvs0*d_qinvd0_d_tambin)+(d_qinvs0_d_tambin*qinvd0));
d_qsqd_d_tnomin=((qinvs0*d_qinvd0_d_tnomin)+(d_qinvs0_d_tnomin*qinvd0));
d_qsqd_d_phitin=((qinvs0*d_qinvd0_d_phitin)+(d_qinvs0_d_phitin*qinvd0));
d_qsqd_d_w=((qinvs0*d_qinvd0_d_w)+(d_qinvs0_d_w*qinvd0));
d_qsqd_d_lin=((qinvs0*d_qinvd0_d_lin)+(d_qinvs0_d_lin*qinvd0));
d_qsqd_d_cgin=((qinvs0*d_qinvd0_d_cgin)+(d_qinvs0_d_cgin*qinvd0));
d_qsqd_d_cs=((qinvs0*d_qinvd0_d_cs)+(d_qinvs0_d_cs*qinvd0));
d_qsqd_d_cc=((qinvs0*d_qinvd0_d_cc)+(d_qinvs0_d_cc*qinvd0));
d_qsqd_d_cb=((qinvs0*d_qinvd0_d_cb)+(d_qinvs0_d_cb*qinvd0));
d_qsqd_d_vto=((qinvs0*d_qinvd0_d_vto)+(d_qinvs0_d_vto*qinvd0));
d_qsqd_d_ss=((qinvs0*d_qinvd0_d_ss)+(d_qinvs0_d_ss*qinvd0));
d_qsqd_d_delta1=((qinvs0*d_qinvd0_d_delta1)+(d_qinvs0_d_delta1*qinvd0));
d_qsqd_d_delta2=((qinvs0*d_qinvd0_d_delta2)+(d_qinvs0_d_delta2*qinvd0));
d_qsqd_d_nd=((qinvs0*d_qinvd0_d_nd)+(d_qinvs0_d_nd*qinvd0));
d_qsqd_d_alpha=((qinvs0*d_qinvd0_d_alpha)+(d_qinvs0_d_alpha*qinvd0));
d_qsqd_d_vel0=((qinvs0*d_qinvd0_d_vel0)+(d_qinvs0_d_vel0*qinvd0));
d_qsqd_d_mu0=((qinvs0*d_qinvd0_d_mu0)+(d_qinvs0_d_mu0*qinvd0));
d_qsqd_d_beta=((qinvs0*d_qinvd0_d_beta)+(d_qinvs0_d_beta*qinvd0));
d_qsqd_d_mtheta=((qinvs0*d_qinvd0_d_mtheta)+(d_qinvs0_d_mtheta*qinvd0));
d_qsqd_d_vtheta=((qinvs0*d_qinvd0_d_vtheta)+(d_qinvs0_d_vtheta*qinvd0));
d_qsqd_d_vtzeta=((qinvs0*d_qinvd0_d_vtzeta)+(d_qinvs0_d_vtzeta*qinvd0));
d_qsqd_d_dibsat=((qinvs0*d_qinvd0_d_dibsat)+(d_qinvs0_d_dibsat*qinvd0));
d_qsqd_d_epsilon=((qinvs0*d_qinvd0_d_epsilon)+(d_qinvs0_d_epsilon*qinvd0));
d_qsqd_d_vzeta=((qinvs0*d_qinvd0_d_vzeta)+(d_qinvs0_d_vzeta*qinvd0));
d_qsqd_d_lambda=((qinvs0*d_qinvd0_d_lambda)+(d_qinvs0_d_lambda*qinvd0));
d_qsqd_d_ngf=((qinvs0*d_qinvd0_d_ngf)+(d_qinvs0_d_ngf*qinvd0));
d_qsqd_d_type=((qinvs0*d_qinvd0_d_type)+(d_qinvs0_d_type*qinvd0));
qsqd=((qinvs0*qinvd0)+1e-38);
d_qinvdd_d_vgsin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vgsin+d_qd2_d_vgsin)+d_qsqd_d_vgsin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vgsin+d_qinvd0_d_vgsin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vdsin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vdsin+d_qd2_d_vdsin)+d_qsqd_d_vdsin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vdsin+d_qinvd0_d_vdsin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_qcbflag=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_qcbflag+d_qd2_d_qcbflag)+d_qsqd_d_qcbflag))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_qcbflag+d_qinvd0_d_qcbflag))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vcin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vcin+d_qd2_d_vcin)+d_qsqd_d_vcin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vcin+d_qinvd0_d_vcin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vbin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vbin+d_qd2_d_vbin)+d_qsqd_d_vbin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vbin+d_qinvd0_d_vbin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_qgsflag=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_qgsflag+d_qd2_d_qgsflag)+d_qsqd_d_qgsflag))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_qgsflag+d_qinvd0_d_qgsflag))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_tambin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_tambin+d_qd2_d_tambin)+d_qsqd_d_tambin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_tambin+d_qinvd0_d_tambin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_tnomin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_tnomin+d_qd2_d_tnomin)+d_qsqd_d_tnomin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_tnomin+d_qinvd0_d_tnomin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_phitin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_phitin+d_qd2_d_phitin)+d_qsqd_d_phitin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_phitin+d_qinvd0_d_phitin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_w=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_w+d_qd2_d_w)+d_qsqd_d_w))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_w+d_qinvd0_d_w))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_lin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_lin+d_qd2_d_lin)+d_qsqd_d_lin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_lin+d_qinvd0_d_lin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cgin=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cgin+d_qd2_d_cgin)+d_qsqd_d_cgin))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cgin+d_qinvd0_d_cgin))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cs=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cs+d_qd2_d_cs)+d_qsqd_d_cs))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cs+d_qinvd0_d_cs))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cc=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cc+d_qd2_d_cc)+d_qsqd_d_cc))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cc+d_qinvd0_d_cc))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_cb=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_cb+d_qd2_d_cb)+d_qsqd_d_cb))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_cb+d_qinvd0_d_cb))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vto=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vto+d_qd2_d_vto)+d_qsqd_d_vto))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vto+d_qinvd0_d_vto))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_ss=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_ss+d_qd2_d_ss)+d_qsqd_d_ss))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_ss+d_qinvd0_d_ss))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_delta1=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_delta1+d_qd2_d_delta1)+d_qsqd_d_delta1))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_delta1+d_qinvd0_d_delta1))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_delta2=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_delta2+d_qd2_d_delta2)+d_qsqd_d_delta2))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_delta2+d_qinvd0_d_delta2))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_nd=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_nd+d_qd2_d_nd)+d_qsqd_d_nd))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_nd+d_qinvd0_d_nd))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_alpha=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_alpha+d_qd2_d_alpha)+d_qsqd_d_alpha))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_alpha+d_qinvd0_d_alpha))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vel0=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vel0+d_qd2_d_vel0)+d_qsqd_d_vel0))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vel0+d_qinvd0_d_vel0))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_mu0=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_mu0+d_qd2_d_mu0)+d_qsqd_d_mu0))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_mu0+d_qinvd0_d_mu0))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_beta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_beta+d_qd2_d_beta)+d_qsqd_d_beta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_beta+d_qinvd0_d_beta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_mtheta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_mtheta+d_qd2_d_mtheta)+d_qsqd_d_mtheta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_mtheta+d_qinvd0_d_mtheta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vtheta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vtheta+d_qd2_d_vtheta)+d_qsqd_d_vtheta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vtheta+d_qinvd0_d_vtheta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vtzeta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vtzeta+d_qd2_d_vtzeta)+d_qsqd_d_vtzeta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vtzeta+d_qinvd0_d_vtzeta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_dibsat=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_dibsat+d_qd2_d_dibsat)+d_qsqd_d_dibsat))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_dibsat+d_qinvd0_d_dibsat))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_epsilon=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_epsilon+d_qd2_d_epsilon)+d_qsqd_d_epsilon))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_epsilon+d_qinvd0_d_epsilon))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_vzeta=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_vzeta+d_qd2_d_vzeta)+d_qsqd_d_vzeta))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_vzeta+d_qinvd0_d_vzeta))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_lambda=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_lambda+d_qd2_d_lambda)+d_qsqd_d_lambda))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_lambda+d_qinvd0_d_lambda))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_ngf=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_ngf+d_qd2_d_ngf)+d_qsqd_d_ngf))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_ngf+d_qinvd0_d_ngf))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
d_qinvdd_d_type=((((qinvs0+qinvd0)+2e-19)*((2.0/3.0)*((d_qs2_d_type+d_qd2_d_type)+d_qsqd_d_type))-((2.0/3.0)*((qs2+qd2)+qsqd))*(d_qinvs0_d_type+d_qinvd0_d_type))/((qinvs0+qinvd0)+2e-19)/((qinvs0+qinvd0)+2e-19));
qinvdd=(((2.0/3.0)*((qs2+qd2)+qsqd))/((qinvs0+qinvd0)+2e-19));
d_qd1_d_vgsin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vgsin)+(3.0*d_qd3_d_vgsin))+(((4.0*qs2)*d_qinvd0_d_vgsin)+((4.0*d_qs2_d_vgsin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vgsin)+((6.0*d_qd2_d_vgsin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vgsin+d_qd2_d_vgsin)+(2.0*d_qsqd_d_vgsin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vdsin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vdsin)+(3.0*d_qd3_d_vdsin))+(((4.0*qs2)*d_qinvd0_d_vdsin)+((4.0*d_qs2_d_vdsin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vdsin)+((6.0*d_qd2_d_vdsin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vdsin+d_qd2_d_vdsin)+(2.0*d_qsqd_d_vdsin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_qcbflag=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_qcbflag)+(3.0*d_qd3_d_qcbflag))+(((4.0*qs2)*d_qinvd0_d_qcbflag)+((4.0*d_qs2_d_qcbflag)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_qcbflag)+((6.0*d_qd2_d_qcbflag)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_qcbflag+d_qd2_d_qcbflag)+(2.0*d_qsqd_d_qcbflag))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vcin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vcin)+(3.0*d_qd3_d_vcin))+(((4.0*qs2)*d_qinvd0_d_vcin)+((4.0*d_qs2_d_vcin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vcin)+((6.0*d_qd2_d_vcin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vcin+d_qd2_d_vcin)+(2.0*d_qsqd_d_vcin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vbin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vbin)+(3.0*d_qd3_d_vbin))+(((4.0*qs2)*d_qinvd0_d_vbin)+((4.0*d_qs2_d_vbin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vbin)+((6.0*d_qd2_d_vbin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vbin+d_qd2_d_vbin)+(2.0*d_qsqd_d_vbin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_qgsflag=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_qgsflag)+(3.0*d_qd3_d_qgsflag))+(((4.0*qs2)*d_qinvd0_d_qgsflag)+((4.0*d_qs2_d_qgsflag)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_qgsflag)+((6.0*d_qd2_d_qgsflag)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_qgsflag+d_qd2_d_qgsflag)+(2.0*d_qsqd_d_qgsflag))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_tambin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_tambin)+(3.0*d_qd3_d_tambin))+(((4.0*qs2)*d_qinvd0_d_tambin)+((4.0*d_qs2_d_tambin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_tambin)+((6.0*d_qd2_d_tambin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_tambin+d_qd2_d_tambin)+(2.0*d_qsqd_d_tambin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_tnomin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_tnomin)+(3.0*d_qd3_d_tnomin))+(((4.0*qs2)*d_qinvd0_d_tnomin)+((4.0*d_qs2_d_tnomin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_tnomin)+((6.0*d_qd2_d_tnomin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_tnomin+d_qd2_d_tnomin)+(2.0*d_qsqd_d_tnomin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_phitin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_phitin)+(3.0*d_qd3_d_phitin))+(((4.0*qs2)*d_qinvd0_d_phitin)+((4.0*d_qs2_d_phitin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_phitin)+((6.0*d_qd2_d_phitin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_phitin+d_qd2_d_phitin)+(2.0*d_qsqd_d_phitin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_w=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_w)+(3.0*d_qd3_d_w))+(((4.0*qs2)*d_qinvd0_d_w)+((4.0*d_qs2_d_w)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_w)+((6.0*d_qd2_d_w)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_w+d_qd2_d_w)+(2.0*d_qsqd_d_w))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_lin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_lin)+(3.0*d_qd3_d_lin))+(((4.0*qs2)*d_qinvd0_d_lin)+((4.0*d_qs2_d_lin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_lin)+((6.0*d_qd2_d_lin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_lin+d_qd2_d_lin)+(2.0*d_qsqd_d_lin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cgin=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cgin)+(3.0*d_qd3_d_cgin))+(((4.0*qs2)*d_qinvd0_d_cgin)+((4.0*d_qs2_d_cgin)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cgin)+((6.0*d_qd2_d_cgin)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cgin+d_qd2_d_cgin)+(2.0*d_qsqd_d_cgin))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cs=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cs)+(3.0*d_qd3_d_cs))+(((4.0*qs2)*d_qinvd0_d_cs)+((4.0*d_qs2_d_cs)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cs)+((6.0*d_qd2_d_cs)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cs+d_qd2_d_cs)+(2.0*d_qsqd_d_cs))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cc=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cc)+(3.0*d_qd3_d_cc))+(((4.0*qs2)*d_qinvd0_d_cc)+((4.0*d_qs2_d_cc)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cc)+((6.0*d_qd2_d_cc)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cc+d_qd2_d_cc)+(2.0*d_qsqd_d_cc))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_cb=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_cb)+(3.0*d_qd3_d_cb))+(((4.0*qs2)*d_qinvd0_d_cb)+((4.0*d_qs2_d_cb)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_cb)+((6.0*d_qd2_d_cb)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_cb+d_qd2_d_cb)+(2.0*d_qsqd_d_cb))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vto=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vto)+(3.0*d_qd3_d_vto))+(((4.0*qs2)*d_qinvd0_d_vto)+((4.0*d_qs2_d_vto)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vto)+((6.0*d_qd2_d_vto)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vto+d_qd2_d_vto)+(2.0*d_qsqd_d_vto))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_ss=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_ss)+(3.0*d_qd3_d_ss))+(((4.0*qs2)*d_qinvd0_d_ss)+((4.0*d_qs2_d_ss)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_ss)+((6.0*d_qd2_d_ss)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_ss+d_qd2_d_ss)+(2.0*d_qsqd_d_ss))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_delta1=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_delta1)+(3.0*d_qd3_d_delta1))+(((4.0*qs2)*d_qinvd0_d_delta1)+((4.0*d_qs2_d_delta1)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_delta1)+((6.0*d_qd2_d_delta1)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_delta1+d_qd2_d_delta1)+(2.0*d_qsqd_d_delta1))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_delta2=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_delta2)+(3.0*d_qd3_d_delta2))+(((4.0*qs2)*d_qinvd0_d_delta2)+((4.0*d_qs2_d_delta2)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_delta2)+((6.0*d_qd2_d_delta2)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_delta2+d_qd2_d_delta2)+(2.0*d_qsqd_d_delta2))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_nd=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_nd)+(3.0*d_qd3_d_nd))+(((4.0*qs2)*d_qinvd0_d_nd)+((4.0*d_qs2_d_nd)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_nd)+((6.0*d_qd2_d_nd)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_nd+d_qd2_d_nd)+(2.0*d_qsqd_d_nd))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_alpha=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_alpha)+(3.0*d_qd3_d_alpha))+(((4.0*qs2)*d_qinvd0_d_alpha)+((4.0*d_qs2_d_alpha)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_alpha)+((6.0*d_qd2_d_alpha)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_alpha+d_qd2_d_alpha)+(2.0*d_qsqd_d_alpha))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vel0=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vel0)+(3.0*d_qd3_d_vel0))+(((4.0*qs2)*d_qinvd0_d_vel0)+((4.0*d_qs2_d_vel0)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vel0)+((6.0*d_qd2_d_vel0)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vel0+d_qd2_d_vel0)+(2.0*d_qsqd_d_vel0))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_mu0=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_mu0)+(3.0*d_qd3_d_mu0))+(((4.0*qs2)*d_qinvd0_d_mu0)+((4.0*d_qs2_d_mu0)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_mu0)+((6.0*d_qd2_d_mu0)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_mu0+d_qd2_d_mu0)+(2.0*d_qsqd_d_mu0))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_beta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_beta)+(3.0*d_qd3_d_beta))+(((4.0*qs2)*d_qinvd0_d_beta)+((4.0*d_qs2_d_beta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_beta)+((6.0*d_qd2_d_beta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_beta+d_qd2_d_beta)+(2.0*d_qsqd_d_beta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_mtheta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_mtheta)+(3.0*d_qd3_d_mtheta))+(((4.0*qs2)*d_qinvd0_d_mtheta)+((4.0*d_qs2_d_mtheta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_mtheta)+((6.0*d_qd2_d_mtheta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_mtheta+d_qd2_d_mtheta)+(2.0*d_qsqd_d_mtheta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vtheta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vtheta)+(3.0*d_qd3_d_vtheta))+(((4.0*qs2)*d_qinvd0_d_vtheta)+((4.0*d_qs2_d_vtheta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vtheta)+((6.0*d_qd2_d_vtheta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vtheta+d_qd2_d_vtheta)+(2.0*d_qsqd_d_vtheta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vtzeta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vtzeta)+(3.0*d_qd3_d_vtzeta))+(((4.0*qs2)*d_qinvd0_d_vtzeta)+((4.0*d_qs2_d_vtzeta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vtzeta)+((6.0*d_qd2_d_vtzeta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vtzeta+d_qd2_d_vtzeta)+(2.0*d_qsqd_d_vtzeta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_dibsat=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_dibsat)+(3.0*d_qd3_d_dibsat))+(((4.0*qs2)*d_qinvd0_d_dibsat)+((4.0*d_qs2_d_dibsat)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_dibsat)+((6.0*d_qd2_d_dibsat)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_dibsat+d_qd2_d_dibsat)+(2.0*d_qsqd_d_dibsat))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_epsilon=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_epsilon)+(3.0*d_qd3_d_epsilon))+(((4.0*qs2)*d_qinvd0_d_epsilon)+((4.0*d_qs2_d_epsilon)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_epsilon)+((6.0*d_qd2_d_epsilon)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_epsilon+d_qd2_d_epsilon)+(2.0*d_qsqd_d_epsilon))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_vzeta=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_vzeta)+(3.0*d_qd3_d_vzeta))+(((4.0*qs2)*d_qinvd0_d_vzeta)+((4.0*d_qs2_d_vzeta)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_vzeta)+((6.0*d_qd2_d_vzeta)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_vzeta+d_qd2_d_vzeta)+(2.0*d_qsqd_d_vzeta))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_lambda=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_lambda)+(3.0*d_qd3_d_lambda))+(((4.0*qs2)*d_qinvd0_d_lambda)+((4.0*d_qs2_d_lambda)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_lambda)+((6.0*d_qd2_d_lambda)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_lambda+d_qd2_d_lambda)+(2.0*d_qsqd_d_lambda))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_ngf=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_ngf)+(3.0*d_qd3_d_ngf))+(((4.0*qs2)*d_qinvd0_d_ngf)+((4.0*d_qs2_d_ngf)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_ngf)+((6.0*d_qd2_d_ngf)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_ngf+d_qd2_d_ngf)+(2.0*d_qsqd_d_ngf))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qd1_d_type=(((15.0*((qs2+qd2)+(2.0*qsqd)))*(2.0*((((2.0*d_qs3_d_type)+(3.0*d_qd3_d_type))+(((4.0*qs2)*d_qinvd0_d_type)+((4.0*d_qs2_d_type)*qinvd0)))+(((6.0*qd2)*d_qinvs0_d_type)+((6.0*d_qd2_d_type)*qinvs0))))-(2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))*(15.0*((d_qs2_d_type+d_qd2_d_type)+(2.0*d_qsqd_d_type))))/(15.0*((qs2+qd2)+(2.0*qsqd)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
qd1=((2.0*((((2.0*qs3)+(3.0*qd3))+((4.0*qs2)*qinvd0))+((6.0*qd2)*qinvs0)))/(15.0*((qs2+qd2)+(2.0*qsqd))));
d_qs_d_vgsin=(d_qinvdd_d_vgsin-d_qd1_d_vgsin);
d_qs_d_vdsin=(d_qinvdd_d_vdsin-d_qd1_d_vdsin);
d_qs_d_qcbflag=(d_qinvdd_d_qcbflag-d_qd1_d_qcbflag);
d_qs_d_vcin=(d_qinvdd_d_vcin-d_qd1_d_vcin);
d_qs_d_vbin=(d_qinvdd_d_vbin-d_qd1_d_vbin);
d_qs_d_qgsflag=(d_qinvdd_d_qgsflag-d_qd1_d_qgsflag);
d_qs_d_tambin=(d_qinvdd_d_tambin-d_qd1_d_tambin);
d_qs_d_tnomin=(d_qinvdd_d_tnomin-d_qd1_d_tnomin);
d_qs_d_phitin=(d_qinvdd_d_phitin-d_qd1_d_phitin);
d_qs_d_w=(d_qinvdd_d_w-d_qd1_d_w);
d_qs_d_lin=(d_qinvdd_d_lin-d_qd1_d_lin);
d_qs_d_cgin=(d_qinvdd_d_cgin-d_qd1_d_cgin);
d_qs_d_cs=(d_qinvdd_d_cs-d_qd1_d_cs);
d_qs_d_cc=(d_qinvdd_d_cc-d_qd1_d_cc);
d_qs_d_cb=(d_qinvdd_d_cb-d_qd1_d_cb);
d_qs_d_vto=(d_qinvdd_d_vto-d_qd1_d_vto);
d_qs_d_ss=(d_qinvdd_d_ss-d_qd1_d_ss);
d_qs_d_delta1=(d_qinvdd_d_delta1-d_qd1_d_delta1);
d_qs_d_delta2=(d_qinvdd_d_delta2-d_qd1_d_delta2);
d_qs_d_nd=(d_qinvdd_d_nd-d_qd1_d_nd);
d_qs_d_alpha=(d_qinvdd_d_alpha-d_qd1_d_alpha);
d_qs_d_vel0=(d_qinvdd_d_vel0-d_qd1_d_vel0);
d_qs_d_mu0=(d_qinvdd_d_mu0-d_qd1_d_mu0);
d_qs_d_beta=(d_qinvdd_d_beta-d_qd1_d_beta);
d_qs_d_mtheta=(d_qinvdd_d_mtheta-d_qd1_d_mtheta);
d_qs_d_vtheta=(d_qinvdd_d_vtheta-d_qd1_d_vtheta);
d_qs_d_vtzeta=(d_qinvdd_d_vtzeta-d_qd1_d_vtzeta);
d_qs_d_dibsat=(d_qinvdd_d_dibsat-d_qd1_d_dibsat);
d_qs_d_epsilon=(d_qinvdd_d_epsilon-d_qd1_d_epsilon);
d_qs_d_vzeta=(d_qinvdd_d_vzeta-d_qd1_d_vzeta);
d_qs_d_lambda=(d_qinvdd_d_lambda-d_qd1_d_lambda);
d_qs_d_ngf=(d_qinvdd_d_ngf-d_qd1_d_ngf);
d_qs_d_type=(d_qinvdd_d_type-d_qd1_d_type);
qs=(qinvdd-qd1);
d_qd_d_vgsin=d_qd1_d_vgsin;
d_qd_d_vdsin=d_qd1_d_vdsin;
d_qd_d_qcbflag=d_qd1_d_qcbflag;
d_qd_d_vcin=d_qd1_d_vcin;
d_qd_d_vbin=d_qd1_d_vbin;
d_qd_d_qgsflag=d_qd1_d_qgsflag;
d_qd_d_tambin=d_qd1_d_tambin;
d_qd_d_tnomin=d_qd1_d_tnomin;
d_qd_d_phitin=d_qd1_d_phitin;
d_qd_d_w=d_qd1_d_w;
d_qd_d_lin=d_qd1_d_lin;
d_qd_d_cgin=d_qd1_d_cgin;
d_qd_d_cs=d_qd1_d_cs;
d_qd_d_cc=d_qd1_d_cc;
d_qd_d_cb=d_qd1_d_cb;
d_qd_d_vto=d_qd1_d_vto;
d_qd_d_ss=d_qd1_d_ss;
d_qd_d_delta1=d_qd1_d_delta1;
d_qd_d_delta2=d_qd1_d_delta2;
d_qd_d_nd=d_qd1_d_nd;
d_qd_d_alpha=d_qd1_d_alpha;
d_qd_d_vel0=d_qd1_d_vel0;
d_qd_d_mu0=d_qd1_d_mu0;
d_qd_d_beta=d_qd1_d_beta;
d_qd_d_mtheta=d_qd1_d_mtheta;
d_qd_d_vtheta=d_qd1_d_vtheta;
d_qd_d_vtzeta=d_qd1_d_vtzeta;
d_qd_d_dibsat=d_qd1_d_dibsat;
d_qd_d_epsilon=d_qd1_d_epsilon;
d_qd_d_vzeta=d_qd1_d_vzeta;
d_qd_d_lambda=d_qd1_d_lambda;
d_qd_d_ngf=d_qd1_d_ngf;
d_qd_d_type=d_qd1_d_type;
qd=qd1;
d_qgsout_d_vgsin=((((w*ngf)*lin)*type)*d_qs_d_vgsin);
d_qgsout_d_vdsin=((((w*ngf)*lin)*type)*d_qs_d_vdsin);
d_qgsout_d_qcbflag=((((w*ngf)*lin)*type)*d_qs_d_qcbflag);
d_qgsout_d_vcin=((((w*ngf)*lin)*type)*d_qs_d_vcin);
d_qgsout_d_vbin=((((w*ngf)*lin)*type)*d_qs_d_vbin);
d_qgsout_d_qgsflag=((((w*ngf)*lin)*type)*d_qs_d_qgsflag);
d_qgsout_d_tambin=((((w*ngf)*lin)*type)*d_qs_d_tambin);
d_qgsout_d_tnomin=((((w*ngf)*lin)*type)*d_qs_d_tnomin);
d_qgsout_d_phitin=((((w*ngf)*lin)*type)*d_qs_d_phitin);
d_qgsout_d_w=(((((w*ngf)*lin)*type)*d_qs_d_w)+((((ngf)*lin)*type)*qs));
d_qgsout_d_lin=(((((w*ngf)*lin)*type)*d_qs_d_lin)+((((w*ngf))*type)*qs));
d_qgsout_d_cgin=((((w*ngf)*lin)*type)*d_qs_d_cgin);
d_qgsout_d_cs=((((w*ngf)*lin)*type)*d_qs_d_cs);
d_qgsout_d_cc=((((w*ngf)*lin)*type)*d_qs_d_cc);
d_qgsout_d_cb=((((w*ngf)*lin)*type)*d_qs_d_cb);
d_qgsout_d_vto=((((w*ngf)*lin)*type)*d_qs_d_vto);
d_qgsout_d_ss=((((w*ngf)*lin)*type)*d_qs_d_ss);
d_qgsout_d_delta1=((((w*ngf)*lin)*type)*d_qs_d_delta1);
d_qgsout_d_delta2=((((w*ngf)*lin)*type)*d_qs_d_delta2);
d_qgsout_d_nd=((((w*ngf)*lin)*type)*d_qs_d_nd);
d_qgsout_d_alpha=((((w*ngf)*lin)*type)*d_qs_d_alpha);
d_qgsout_d_vel0=((((w*ngf)*lin)*type)*d_qs_d_vel0);
d_qgsout_d_mu0=((((w*ngf)*lin)*type)*d_qs_d_mu0);
d_qgsout_d_beta=((((w*ngf)*lin)*type)*d_qs_d_beta);
d_qgsout_d_mtheta=((((w*ngf)*lin)*type)*d_qs_d_mtheta);
d_qgsout_d_vtheta=((((w*ngf)*lin)*type)*d_qs_d_vtheta);
d_qgsout_d_vtzeta=((((w*ngf)*lin)*type)*d_qs_d_vtzeta);
d_qgsout_d_dibsat=((((w*ngf)*lin)*type)*d_qs_d_dibsat);
d_qgsout_d_epsilon=((((w*ngf)*lin)*type)*d_qs_d_epsilon);
d_qgsout_d_vzeta=((((w*ngf)*lin)*type)*d_qs_d_vzeta);
d_qgsout_d_lambda=((((w*ngf)*lin)*type)*d_qs_d_lambda);
d_qgsout_d_ngf=(((((w*ngf)*lin)*type)*d_qs_d_ngf)+((((w)*lin)*type)*qs));
d_qgsout_d_type=(((((w*ngf)*lin)*type)*d_qs_d_type)+((((w*ngf)*lin))*qs));
qgsout=((((w*ngf)*lin)*type)*qs);
d_qgdout_d_vgsin=((((w*ngf)*lin)*type)*d_qd_d_vgsin);
d_qgdout_d_vdsin=((((w*ngf)*lin)*type)*d_qd_d_vdsin);
d_qgdout_d_qcbflag=((((w*ngf)*lin)*type)*d_qd_d_qcbflag);
d_qgdout_d_vcin=((((w*ngf)*lin)*type)*d_qd_d_vcin);
d_qgdout_d_vbin=((((w*ngf)*lin)*type)*d_qd_d_vbin);
d_qgdout_d_qgsflag=((((w*ngf)*lin)*type)*d_qd_d_qgsflag);
d_qgdout_d_tambin=((((w*ngf)*lin)*type)*d_qd_d_tambin);
d_qgdout_d_tnomin=((((w*ngf)*lin)*type)*d_qd_d_tnomin);
d_qgdout_d_phitin=((((w*ngf)*lin)*type)*d_qd_d_phitin);
d_qgdout_d_w=(((((w*ngf)*lin)*type)*d_qd_d_w)+((((ngf)*lin)*type)*qd));
d_qgdout_d_lin=(((((w*ngf)*lin)*type)*d_qd_d_lin)+((((w*ngf))*type)*qd));
d_qgdout_d_cgin=((((w*ngf)*lin)*type)*d_qd_d_cgin);
d_qgdout_d_cs=((((w*ngf)*lin)*type)*d_qd_d_cs);
d_qgdout_d_cc=((((w*ngf)*lin)*type)*d_qd_d_cc);
d_qgdout_d_cb=((((w*ngf)*lin)*type)*d_qd_d_cb);
d_qgdout_d_vto=((((w*ngf)*lin)*type)*d_qd_d_vto);
d_qgdout_d_ss=((((w*ngf)*lin)*type)*d_qd_d_ss);
d_qgdout_d_delta1=((((w*ngf)*lin)*type)*d_qd_d_delta1);
d_qgdout_d_delta2=((((w*ngf)*lin)*type)*d_qd_d_delta2);
d_qgdout_d_nd=((((w*ngf)*lin)*type)*d_qd_d_nd);
d_qgdout_d_alpha=((((w*ngf)*lin)*type)*d_qd_d_alpha);
d_qgdout_d_vel0=((((w*ngf)*lin)*type)*d_qd_d_vel0);
d_qgdout_d_mu0=((((w*ngf)*lin)*type)*d_qd_d_mu0);
d_qgdout_d_beta=((((w*ngf)*lin)*type)*d_qd_d_beta);
d_qgdout_d_mtheta=((((w*ngf)*lin)*type)*d_qd_d_mtheta);
d_qgdout_d_vtheta=((((w*ngf)*lin)*type)*d_qd_d_vtheta);
d_qgdout_d_vtzeta=((((w*ngf)*lin)*type)*d_qd_d_vtzeta);
d_qgdout_d_dibsat=((((w*ngf)*lin)*type)*d_qd_d_dibsat);
d_qgdout_d_epsilon=((((w*ngf)*lin)*type)*d_qd_d_epsilon);
d_qgdout_d_vzeta=((((w*ngf)*lin)*type)*d_qd_d_vzeta);
d_qgdout_d_lambda=((((w*ngf)*lin)*type)*d_qd_d_lambda);
d_qgdout_d_ngf=(((((w*ngf)*lin)*type)*d_qd_d_ngf)+((((w)*lin)*type)*qd));
d_qgdout_d_type=(((((w*ngf)*lin)*type)*d_qd_d_type)+((((w*ngf)*lin))*qd));
qgdout=((((w*ngf)*lin)*type)*qd);
if((qcbflag==1))
{
d_etac_d_vgsin=((two_n_phit0*(-(d_vtof_d_vgsin-(0.5*d_alpha_phit_d_vgsin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etac_d_vdsin=((two_n_phit0*(-(d_vtof_d_vdsin-(0.5*d_alpha_phit_d_vdsin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etac_d_qcbflag=((two_n_phit0*(-(d_vtof_d_qcbflag-(0.5*d_alpha_phit_d_qcbflag)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etac_d_vcin=((two_n_phit0*(1.0-(d_vtof_d_vcin-(0.5*d_alpha_phit_d_vcin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etac_d_vbin=((two_n_phit0*(-(d_vtof_d_vbin-(0.5*d_alpha_phit_d_vbin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etac_d_qgsflag=((two_n_phit0*(-(d_vtof_d_qgsflag-(0.5*d_alpha_phit_d_qgsflag)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etac_d_tambin=((two_n_phit0*(-(d_vtof_d_tambin-(0.5*d_alpha_phit_d_tambin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etac_d_tnomin=((two_n_phit0*(-(d_vtof_d_tnomin-(0.5*d_alpha_phit_d_tnomin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etac_d_phitin=((two_n_phit0*(-(d_vtof_d_phitin-(0.5*d_alpha_phit_d_phitin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etac_d_w=((two_n_phit0*(-(d_vtof_d_w-(0.5*d_alpha_phit_d_w)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etac_d_lin=((two_n_phit0*(-(d_vtof_d_lin-(0.5*d_alpha_phit_d_lin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etac_d_cgin=((two_n_phit0*(-(d_vtof_d_cgin-(0.5*d_alpha_phit_d_cgin)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etac_d_cs=((two_n_phit0*(-(d_vtof_d_cs-(0.5*d_alpha_phit_d_cs)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etac_d_cc=((two_n_phit0*(-(d_vtof_d_cc-(0.5*d_alpha_phit_d_cc)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etac_d_cb=((two_n_phit0*(-(d_vtof_d_cb-(0.5*d_alpha_phit_d_cb)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etac_d_vto=((two_n_phit0*(-(d_vtof_d_vto-(0.5*d_alpha_phit_d_vto)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etac_d_ss=((two_n_phit0*(-(d_vtof_d_ss-(0.5*d_alpha_phit_d_ss)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etac_d_delta1=((two_n_phit0*(-(d_vtof_d_delta1-(0.5*d_alpha_phit_d_delta1)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etac_d_delta2=((two_n_phit0*(-(d_vtof_d_delta2-(0.5*d_alpha_phit_d_delta2)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etac_d_nd=((two_n_phit0*(-(d_vtof_d_nd-(0.5*d_alpha_phit_d_nd)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etac_d_alpha=((two_n_phit0*(-(d_vtof_d_alpha-(0.5*d_alpha_phit_d_alpha)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etac_d_vel0=((two_n_phit0*(-(d_vtof_d_vel0-(0.5*d_alpha_phit_d_vel0)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etac_d_mu0=((two_n_phit0*(-(d_vtof_d_mu0-(0.5*d_alpha_phit_d_mu0)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etac_d_beta=((two_n_phit0*(-(d_vtof_d_beta-(0.5*d_alpha_phit_d_beta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etac_d_mtheta=((two_n_phit0*(-(d_vtof_d_mtheta-(0.5*d_alpha_phit_d_mtheta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etac_d_vtheta=((two_n_phit0*(-(d_vtof_d_vtheta-(0.5*d_alpha_phit_d_vtheta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etac_d_vtzeta=((two_n_phit0*(-(d_vtof_d_vtzeta-(0.5*d_alpha_phit_d_vtzeta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etac_d_dibsat=((two_n_phit0*(-(d_vtof_d_dibsat-(0.5*d_alpha_phit_d_dibsat)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etac_d_epsilon=((two_n_phit0*(-(d_vtof_d_epsilon-(0.5*d_alpha_phit_d_epsilon)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etac_d_vzeta=((two_n_phit0*(-(d_vtof_d_vzeta-(0.5*d_alpha_phit_d_vzeta)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etac_d_lambda=((two_n_phit0*(-(d_vtof_d_lambda-(0.5*d_alpha_phit_d_lambda)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etac_d_ngf=((two_n_phit0*(-(d_vtof_d_ngf-(0.5*d_alpha_phit_d_ngf)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etac_d_type=((two_n_phit0*(-(d_vtof_d_type-(0.5*d_alpha_phit_d_type)))-(vcin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etac=((vcin-(vtof-(0.5*alpha_phit)))/two_n_phit0);
if((etac>50.0))
{
d_exparg_d_vgsin=d_etac_d_vgsin;
d_exparg_d_vdsin=d_etac_d_vdsin;
d_exparg_d_qcbflag=d_etac_d_qcbflag;
d_exparg_d_vcin=d_etac_d_vcin;
d_exparg_d_vbin=d_etac_d_vbin;
d_exparg_d_qgsflag=d_etac_d_qgsflag;
d_exparg_d_tambin=d_etac_d_tambin;
d_exparg_d_tnomin=d_etac_d_tnomin;
d_exparg_d_phitin=d_etac_d_phitin;
d_exparg_d_w=d_etac_d_w;
d_exparg_d_lin=d_etac_d_lin;
d_exparg_d_cgin=d_etac_d_cgin;
d_exparg_d_cs=d_etac_d_cs;
d_exparg_d_cc=d_etac_d_cc;
d_exparg_d_cb=d_etac_d_cb;
d_exparg_d_vto=d_etac_d_vto;
d_exparg_d_ss=d_etac_d_ss;
d_exparg_d_delta1=d_etac_d_delta1;
d_exparg_d_delta2=d_etac_d_delta2;
d_exparg_d_nd=d_etac_d_nd;
d_exparg_d_alpha=d_etac_d_alpha;
d_exparg_d_vel0=d_etac_d_vel0;
d_exparg_d_mu0=d_etac_d_mu0;
d_exparg_d_beta=d_etac_d_beta;
d_exparg_d_mtheta=d_etac_d_mtheta;
d_exparg_d_vtheta=d_etac_d_vtheta;
d_exparg_d_vtzeta=d_etac_d_vtzeta;
d_exparg_d_dibsat=d_etac_d_dibsat;
d_exparg_d_epsilon=d_etac_d_epsilon;
d_exparg_d_vzeta=d_etac_d_vzeta;
d_exparg_d_lambda=d_etac_d_lambda;
d_exparg_d_ngf=d_etac_d_ngf;
d_exparg_d_type=d_etac_d_type;
exparg=etac;
}
else
{
if((etac<(-50.0)))
{
d_exparg_d_vgsin=0.0;
d_exparg_d_vdsin=0.0;
d_exparg_d_qcbflag=0.0;
d_exparg_d_vcin=0.0;
d_exparg_d_vbin=0.0;
d_exparg_d_qgsflag=0.0;
d_exparg_d_tambin=0.0;
d_exparg_d_tnomin=0.0;
d_exparg_d_phitin=0.0;
d_exparg_d_w=0.0;
d_exparg_d_lin=0.0;
d_exparg_d_cgin=0.0;
d_exparg_d_cs=0.0;
d_exparg_d_cc=0.0;
d_exparg_d_cb=0.0;
d_exparg_d_vto=0.0;
d_exparg_d_ss=0.0;
d_exparg_d_delta1=0.0;
d_exparg_d_delta2=0.0;
d_exparg_d_nd=0.0;
d_exparg_d_alpha=0.0;
d_exparg_d_vel0=0.0;
d_exparg_d_mu0=0.0;
d_exparg_d_beta=0.0;
d_exparg_d_mtheta=0.0;
d_exparg_d_vtheta=0.0;
d_exparg_d_vtzeta=0.0;
d_exparg_d_dibsat=0.0;
d_exparg_d_epsilon=0.0;
d_exparg_d_vzeta=0.0;
d_exparg_d_lambda=0.0;
d_exparg_d_ngf=0.0;
d_exparg_d_type=0.0;
exparg=0;
}
else
{
d_exparg_d_vgsin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vgsin;
d_exparg_d_vdsin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vdsin;
d_exparg_d_qcbflag=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_qcbflag;
d_exparg_d_vcin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vcin;
d_exparg_d_vbin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vbin;
d_exparg_d_qgsflag=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_qgsflag;
d_exparg_d_tambin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_tambin;
d_exparg_d_tnomin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_tnomin;
d_exparg_d_phitin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_phitin;
d_exparg_d_w=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_w;
d_exparg_d_lin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_lin;
d_exparg_d_cgin=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cgin;
d_exparg_d_cs=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cs;
d_exparg_d_cc=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cc;
d_exparg_d_cb=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_cb;
d_exparg_d_vto=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vto;
d_exparg_d_ss=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_ss;
d_exparg_d_delta1=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_delta1;
d_exparg_d_delta2=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_delta2;
d_exparg_d_nd=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_nd;
d_exparg_d_alpha=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_alpha;
d_exparg_d_vel0=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vel0;
d_exparg_d_mu0=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_mu0;
d_exparg_d_beta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_beta;
d_exparg_d_mtheta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_mtheta;
d_exparg_d_vtheta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vtheta;
d_exparg_d_vtzeta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vtzeta;
d_exparg_d_dibsat=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_dibsat;
d_exparg_d_epsilon=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_epsilon;
d_exparg_d_vzeta=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_vzeta;
d_exparg_d_lambda=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_lambda;
d_exparg_d_ngf=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_ngf;
d_exparg_d_type=(1.0/(1.0+exp(etac)))*exp(etac)*d_etac_d_type;
exparg=log((1.0+exp(etac)));
}
}
d_qcout_d_vgsin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vgsin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vgsin)*exparg));
d_qcout_d_vdsin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vdsin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vdsin)*exparg));
d_qcout_d_qcbflag=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_qcbflag)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_qcbflag)*exparg));
d_qcout_d_vcin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vcin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vcin)*exparg));
d_qcout_d_vbin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vbin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vbin)*exparg));
d_qcout_d_qgsflag=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_qgsflag)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_qgsflag)*exparg));
d_qcout_d_tambin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_tambin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_tambin)*exparg));
d_qcout_d_tnomin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_tnomin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_tnomin)*exparg));
d_qcout_d_phitin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_phitin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_phitin)*exparg));
d_qcout_d_w=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_w)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_w)+((((ngf)*type)*cc)*two_n_phit0))*exparg));
d_qcout_d_lin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_lin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_lin)*exparg));
d_qcout_d_cgin=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cgin)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_cgin)*exparg));
d_qcout_d_cs=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cs)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_cs)*exparg));
d_qcout_d_cc=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cc)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_cc)+((((w*ngf)*type))*two_n_phit0))*exparg));
d_qcout_d_cb=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_cb)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_cb)*exparg));
d_qcout_d_vto=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vto)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vto)*exparg));
d_qcout_d_ss=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_ss)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_ss)*exparg));
d_qcout_d_delta1=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_delta1)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_delta1)*exparg));
d_qcout_d_delta2=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_delta2)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_delta2)*exparg));
d_qcout_d_nd=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_nd)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_nd)*exparg));
d_qcout_d_alpha=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_alpha)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_alpha)*exparg));
d_qcout_d_vel0=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vel0)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vel0)*exparg));
d_qcout_d_mu0=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_mu0)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_mu0)*exparg));
d_qcout_d_beta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_beta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_beta)*exparg));
d_qcout_d_mtheta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_mtheta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_mtheta)*exparg));
d_qcout_d_vtheta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vtheta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vtheta)*exparg));
d_qcout_d_vtzeta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vtzeta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vtzeta)*exparg));
d_qcout_d_dibsat=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_dibsat)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_dibsat)*exparg));
d_qcout_d_epsilon=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_epsilon)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_epsilon)*exparg));
d_qcout_d_vzeta=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_vzeta)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_vzeta)*exparg));
d_qcout_d_lambda=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_lambda)+(((((w*ngf)*type)*cc)*d_two_n_phit0_d_lambda)*exparg));
d_qcout_d_ngf=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_ngf)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_ngf)+((((w)*type)*cc)*two_n_phit0))*exparg));
d_qcout_d_type=((((((w*ngf)*type)*cc)*two_n_phit0)*d_exparg_d_type)+((((((w*ngf)*type)*cc)*d_two_n_phit0_d_type)+((((w*ngf))*cc)*two_n_phit0))*exparg));
qcout=(((((w*ngf)*type)*cc)*two_n_phit0)*exparg);
d_etab_d_vgsin=((two_n_phit0*(-(d_vtof_d_vgsin-(0.5*d_alpha_phit_d_vgsin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etab_d_vdsin=((two_n_phit0*(-(d_vtof_d_vdsin-(0.5*d_alpha_phit_d_vdsin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etab_d_qcbflag=((two_n_phit0*(-(d_vtof_d_qcbflag-(0.5*d_alpha_phit_d_qcbflag)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etab_d_vcin=((two_n_phit0*(-(d_vtof_d_vcin-(0.5*d_alpha_phit_d_vcin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etab_d_vbin=((two_n_phit0*(1.0-(d_vtof_d_vbin-(0.5*d_alpha_phit_d_vbin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etab_d_qgsflag=((two_n_phit0*(-(d_vtof_d_qgsflag-(0.5*d_alpha_phit_d_qgsflag)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etab_d_tambin=((two_n_phit0*(-(d_vtof_d_tambin-(0.5*d_alpha_phit_d_tambin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etab_d_tnomin=((two_n_phit0*(-(d_vtof_d_tnomin-(0.5*d_alpha_phit_d_tnomin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etab_d_phitin=((two_n_phit0*(-(d_vtof_d_phitin-(0.5*d_alpha_phit_d_phitin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etab_d_w=((two_n_phit0*(-(d_vtof_d_w-(0.5*d_alpha_phit_d_w)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etab_d_lin=((two_n_phit0*(-(d_vtof_d_lin-(0.5*d_alpha_phit_d_lin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etab_d_cgin=((two_n_phit0*(-(d_vtof_d_cgin-(0.5*d_alpha_phit_d_cgin)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etab_d_cs=((two_n_phit0*(-(d_vtof_d_cs-(0.5*d_alpha_phit_d_cs)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etab_d_cc=((two_n_phit0*(-(d_vtof_d_cc-(0.5*d_alpha_phit_d_cc)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etab_d_cb=((two_n_phit0*(-(d_vtof_d_cb-(0.5*d_alpha_phit_d_cb)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etab_d_vto=((two_n_phit0*(-(d_vtof_d_vto-(0.5*d_alpha_phit_d_vto)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etab_d_ss=((two_n_phit0*(-(d_vtof_d_ss-(0.5*d_alpha_phit_d_ss)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etab_d_delta1=((two_n_phit0*(-(d_vtof_d_delta1-(0.5*d_alpha_phit_d_delta1)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etab_d_delta2=((two_n_phit0*(-(d_vtof_d_delta2-(0.5*d_alpha_phit_d_delta2)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etab_d_nd=((two_n_phit0*(-(d_vtof_d_nd-(0.5*d_alpha_phit_d_nd)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etab_d_alpha=((two_n_phit0*(-(d_vtof_d_alpha-(0.5*d_alpha_phit_d_alpha)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etab_d_vel0=((two_n_phit0*(-(d_vtof_d_vel0-(0.5*d_alpha_phit_d_vel0)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etab_d_mu0=((two_n_phit0*(-(d_vtof_d_mu0-(0.5*d_alpha_phit_d_mu0)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etab_d_beta=((two_n_phit0*(-(d_vtof_d_beta-(0.5*d_alpha_phit_d_beta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etab_d_mtheta=((two_n_phit0*(-(d_vtof_d_mtheta-(0.5*d_alpha_phit_d_mtheta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etab_d_vtheta=((two_n_phit0*(-(d_vtof_d_vtheta-(0.5*d_alpha_phit_d_vtheta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etab_d_vtzeta=((two_n_phit0*(-(d_vtof_d_vtzeta-(0.5*d_alpha_phit_d_vtzeta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etab_d_dibsat=((two_n_phit0*(-(d_vtof_d_dibsat-(0.5*d_alpha_phit_d_dibsat)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etab_d_epsilon=((two_n_phit0*(-(d_vtof_d_epsilon-(0.5*d_alpha_phit_d_epsilon)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etab_d_vzeta=((two_n_phit0*(-(d_vtof_d_vzeta-(0.5*d_alpha_phit_d_vzeta)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etab_d_lambda=((two_n_phit0*(-(d_vtof_d_lambda-(0.5*d_alpha_phit_d_lambda)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etab_d_ngf=((two_n_phit0*(-(d_vtof_d_ngf-(0.5*d_alpha_phit_d_ngf)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etab_d_type=((two_n_phit0*(-(d_vtof_d_type-(0.5*d_alpha_phit_d_type)))-(vbin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etab=((vbin-(vtof-(0.5*alpha_phit)))/two_n_phit0);
if((etab>50.0))
{
d_exparg_d_vgsin=d_etab_d_vgsin;
d_exparg_d_vdsin=d_etab_d_vdsin;
d_exparg_d_qcbflag=d_etab_d_qcbflag;
d_exparg_d_vcin=d_etab_d_vcin;
d_exparg_d_vbin=d_etab_d_vbin;
d_exparg_d_qgsflag=d_etab_d_qgsflag;
d_exparg_d_tambin=d_etab_d_tambin;
d_exparg_d_tnomin=d_etab_d_tnomin;
d_exparg_d_phitin=d_etab_d_phitin;
d_exparg_d_w=d_etab_d_w;
d_exparg_d_lin=d_etab_d_lin;
d_exparg_d_cgin=d_etab_d_cgin;
d_exparg_d_cs=d_etab_d_cs;
d_exparg_d_cc=d_etab_d_cc;
d_exparg_d_cb=d_etab_d_cb;
d_exparg_d_vto=d_etab_d_vto;
d_exparg_d_ss=d_etab_d_ss;
d_exparg_d_delta1=d_etab_d_delta1;
d_exparg_d_delta2=d_etab_d_delta2;
d_exparg_d_nd=d_etab_d_nd;
d_exparg_d_alpha=d_etab_d_alpha;
d_exparg_d_vel0=d_etab_d_vel0;
d_exparg_d_mu0=d_etab_d_mu0;
d_exparg_d_beta=d_etab_d_beta;
d_exparg_d_mtheta=d_etab_d_mtheta;
d_exparg_d_vtheta=d_etab_d_vtheta;
d_exparg_d_vtzeta=d_etab_d_vtzeta;
d_exparg_d_dibsat=d_etab_d_dibsat;
d_exparg_d_epsilon=d_etab_d_epsilon;
d_exparg_d_vzeta=d_etab_d_vzeta;
d_exparg_d_lambda=d_etab_d_lambda;
d_exparg_d_ngf=d_etab_d_ngf;
d_exparg_d_type=d_etab_d_type;
exparg=etab;
}
else
{
if((etab<(-50.0)))
{
d_exparg_d_vgsin=0.0;
d_exparg_d_vdsin=0.0;
d_exparg_d_qcbflag=0.0;
d_exparg_d_vcin=0.0;
d_exparg_d_vbin=0.0;
d_exparg_d_qgsflag=0.0;
d_exparg_d_tambin=0.0;
d_exparg_d_tnomin=0.0;
d_exparg_d_phitin=0.0;
d_exparg_d_w=0.0;
d_exparg_d_lin=0.0;
d_exparg_d_cgin=0.0;
d_exparg_d_cs=0.0;
d_exparg_d_cc=0.0;
d_exparg_d_cb=0.0;
d_exparg_d_vto=0.0;
d_exparg_d_ss=0.0;
d_exparg_d_delta1=0.0;
d_exparg_d_delta2=0.0;
d_exparg_d_nd=0.0;
d_exparg_d_alpha=0.0;
d_exparg_d_vel0=0.0;
d_exparg_d_mu0=0.0;
d_exparg_d_beta=0.0;
d_exparg_d_mtheta=0.0;
d_exparg_d_vtheta=0.0;
d_exparg_d_vtzeta=0.0;
d_exparg_d_dibsat=0.0;
d_exparg_d_epsilon=0.0;
d_exparg_d_vzeta=0.0;
d_exparg_d_lambda=0.0;
d_exparg_d_ngf=0.0;
d_exparg_d_type=0.0;
exparg=0;
}
else
{
d_exparg_d_vgsin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vgsin;
d_exparg_d_vdsin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vdsin;
d_exparg_d_qcbflag=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_qcbflag;
d_exparg_d_vcin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vcin;
d_exparg_d_vbin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vbin;
d_exparg_d_qgsflag=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_qgsflag;
d_exparg_d_tambin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_tambin;
d_exparg_d_tnomin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_tnomin;
d_exparg_d_phitin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_phitin;
d_exparg_d_w=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_w;
d_exparg_d_lin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_lin;
d_exparg_d_cgin=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cgin;
d_exparg_d_cs=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cs;
d_exparg_d_cc=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cc;
d_exparg_d_cb=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_cb;
d_exparg_d_vto=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vto;
d_exparg_d_ss=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_ss;
d_exparg_d_delta1=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_delta1;
d_exparg_d_delta2=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_delta2;
d_exparg_d_nd=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_nd;
d_exparg_d_alpha=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_alpha;
d_exparg_d_vel0=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vel0;
d_exparg_d_mu0=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_mu0;
d_exparg_d_beta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_beta;
d_exparg_d_mtheta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_mtheta;
d_exparg_d_vtheta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vtheta;
d_exparg_d_vtzeta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vtzeta;
d_exparg_d_dibsat=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_dibsat;
d_exparg_d_epsilon=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_epsilon;
d_exparg_d_vzeta=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_vzeta;
d_exparg_d_lambda=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_lambda;
d_exparg_d_ngf=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_ngf;
d_exparg_d_type=(1.0/(1.0+exp(etab)))*exp(etab)*d_etab_d_type;
exparg=log((1.0+exp(etab)));
}
}
d_qbout_d_vgsin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vgsin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vgsin)*exparg));
d_qbout_d_vdsin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vdsin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vdsin)*exparg));
d_qbout_d_qcbflag=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_qcbflag)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_qcbflag)*exparg));
d_qbout_d_vcin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vcin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vcin)*exparg));
d_qbout_d_vbin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vbin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vbin)*exparg));
d_qbout_d_qgsflag=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_qgsflag)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_qgsflag)*exparg));
d_qbout_d_tambin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_tambin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_tambin)*exparg));
d_qbout_d_tnomin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_tnomin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_tnomin)*exparg));
d_qbout_d_phitin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_phitin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_phitin)*exparg));
d_qbout_d_w=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_w)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_w)+((((ngf)*type)*cb)*two_n_phit0))*exparg));
d_qbout_d_lin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_lin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_lin)*exparg));
d_qbout_d_cgin=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cgin)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_cgin)*exparg));
d_qbout_d_cs=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cs)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_cs)*exparg));
d_qbout_d_cc=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cc)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_cc)*exparg));
d_qbout_d_cb=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_cb)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_cb)+((((w*ngf)*type))*two_n_phit0))*exparg));
d_qbout_d_vto=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vto)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vto)*exparg));
d_qbout_d_ss=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_ss)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_ss)*exparg));
d_qbout_d_delta1=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_delta1)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_delta1)*exparg));
d_qbout_d_delta2=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_delta2)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_delta2)*exparg));
d_qbout_d_nd=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_nd)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_nd)*exparg));
d_qbout_d_alpha=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_alpha)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_alpha)*exparg));
d_qbout_d_vel0=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vel0)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vel0)*exparg));
d_qbout_d_mu0=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_mu0)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_mu0)*exparg));
d_qbout_d_beta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_beta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_beta)*exparg));
d_qbout_d_mtheta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_mtheta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_mtheta)*exparg));
d_qbout_d_vtheta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vtheta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vtheta)*exparg));
d_qbout_d_vtzeta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vtzeta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vtzeta)*exparg));
d_qbout_d_dibsat=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_dibsat)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_dibsat)*exparg));
d_qbout_d_epsilon=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_epsilon)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_epsilon)*exparg));
d_qbout_d_vzeta=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_vzeta)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_vzeta)*exparg));
d_qbout_d_lambda=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_lambda)+(((((w*ngf)*type)*cb)*d_two_n_phit0_d_lambda)*exparg));
d_qbout_d_ngf=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_ngf)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_ngf)+((((w)*type)*cb)*two_n_phit0))*exparg));
d_qbout_d_type=((((((w*ngf)*type)*cb)*two_n_phit0)*d_exparg_d_type)+((((((w*ngf)*type)*cb)*d_two_n_phit0_d_type)+((((w*ngf))*cb)*two_n_phit0))*exparg));
qbout=(((((w*ngf)*type)*cb)*two_n_phit0)*exparg);
}
else
{
d_qcout_d_vgsin=0.0;
d_qcout_d_vdsin=0.0;
d_qcout_d_qcbflag=0.0;
d_qcout_d_vcin=0.0;
d_qcout_d_vbin=0.0;
d_qcout_d_qgsflag=0.0;
d_qcout_d_tambin=0.0;
d_qcout_d_tnomin=0.0;
d_qcout_d_phitin=0.0;
d_qcout_d_w=0.0;
d_qcout_d_lin=0.0;
d_qcout_d_cgin=0.0;
d_qcout_d_cs=0.0;
d_qcout_d_cc=0.0;
d_qcout_d_cb=0.0;
d_qcout_d_vto=0.0;
d_qcout_d_ss=0.0;
d_qcout_d_delta1=0.0;
d_qcout_d_delta2=0.0;
d_qcout_d_nd=0.0;
d_qcout_d_alpha=0.0;
d_qcout_d_vel0=0.0;
d_qcout_d_mu0=0.0;
d_qcout_d_beta=0.0;
d_qcout_d_mtheta=0.0;
d_qcout_d_vtheta=0.0;
d_qcout_d_vtzeta=0.0;
d_qcout_d_dibsat=0.0;
d_qcout_d_epsilon=0.0;
d_qcout_d_vzeta=0.0;
d_qcout_d_lambda=0.0;
d_qcout_d_ngf=0.0;
d_qcout_d_type=0.0;
qcout=0;
d_qbout_d_vgsin=0.0;
d_qbout_d_vdsin=0.0;
d_qbout_d_qcbflag=0.0;
d_qbout_d_vcin=0.0;
d_qbout_d_vbin=0.0;
d_qbout_d_qgsflag=0.0;
d_qbout_d_tambin=0.0;
d_qbout_d_tnomin=0.0;
d_qbout_d_phitin=0.0;
d_qbout_d_w=0.0;
d_qbout_d_lin=0.0;
d_qbout_d_cgin=0.0;
d_qbout_d_cs=0.0;
d_qbout_d_cc=0.0;
d_qbout_d_cb=0.0;
d_qbout_d_vto=0.0;
d_qbout_d_ss=0.0;
d_qbout_d_delta1=0.0;
d_qbout_d_delta2=0.0;
d_qbout_d_nd=0.0;
d_qbout_d_alpha=0.0;
d_qbout_d_vel0=0.0;
d_qbout_d_mu0=0.0;
d_qbout_d_beta=0.0;
d_qbout_d_mtheta=0.0;
d_qbout_d_vtheta=0.0;
d_qbout_d_vtzeta=0.0;
d_qbout_d_dibsat=0.0;
d_qbout_d_epsilon=0.0;
d_qbout_d_vzeta=0.0;
d_qbout_d_lambda=0.0;
d_qbout_d_ngf=0.0;
d_qbout_d_type=0.0;
qbout=0;
}
if((qgsflag==1))
{
d_etags_d_vgsin=((two_n_phit0*(1.0-(d_vtof_d_vgsin-(0.5*d_alpha_phit_d_vgsin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vgsin)/two_n_phit0/two_n_phit0);
d_etags_d_vdsin=((two_n_phit0*(-(d_vtof_d_vdsin-(0.5*d_alpha_phit_d_vdsin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vdsin)/two_n_phit0/two_n_phit0);
d_etags_d_qcbflag=((two_n_phit0*(-(d_vtof_d_qcbflag-(0.5*d_alpha_phit_d_qcbflag)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qcbflag)/two_n_phit0/two_n_phit0);
d_etags_d_vcin=((two_n_phit0*(-(d_vtof_d_vcin-(0.5*d_alpha_phit_d_vcin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vcin)/two_n_phit0/two_n_phit0);
d_etags_d_vbin=((two_n_phit0*(-(d_vtof_d_vbin-(0.5*d_alpha_phit_d_vbin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vbin)/two_n_phit0/two_n_phit0);
d_etags_d_qgsflag=((two_n_phit0*(-(d_vtof_d_qgsflag-(0.5*d_alpha_phit_d_qgsflag)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_qgsflag)/two_n_phit0/two_n_phit0);
d_etags_d_tambin=((two_n_phit0*(-(d_vtof_d_tambin-(0.5*d_alpha_phit_d_tambin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tambin)/two_n_phit0/two_n_phit0);
d_etags_d_tnomin=((two_n_phit0*(-(d_vtof_d_tnomin-(0.5*d_alpha_phit_d_tnomin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_tnomin)/two_n_phit0/two_n_phit0);
d_etags_d_phitin=((two_n_phit0*(-(d_vtof_d_phitin-(0.5*d_alpha_phit_d_phitin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_phitin)/two_n_phit0/two_n_phit0);
d_etags_d_w=((two_n_phit0*(-(d_vtof_d_w-(0.5*d_alpha_phit_d_w)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_w)/two_n_phit0/two_n_phit0);
d_etags_d_lin=((two_n_phit0*(-(d_vtof_d_lin-(0.5*d_alpha_phit_d_lin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lin)/two_n_phit0/two_n_phit0);
d_etags_d_cgin=((two_n_phit0*(-(d_vtof_d_cgin-(0.5*d_alpha_phit_d_cgin)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cgin)/two_n_phit0/two_n_phit0);
d_etags_d_cs=((two_n_phit0*(-(d_vtof_d_cs-(0.5*d_alpha_phit_d_cs)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cs)/two_n_phit0/two_n_phit0);
d_etags_d_cc=((two_n_phit0*(-(d_vtof_d_cc-(0.5*d_alpha_phit_d_cc)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cc)/two_n_phit0/two_n_phit0);
d_etags_d_cb=((two_n_phit0*(-(d_vtof_d_cb-(0.5*d_alpha_phit_d_cb)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_cb)/two_n_phit0/two_n_phit0);
d_etags_d_vto=((two_n_phit0*(-(d_vtof_d_vto-(0.5*d_alpha_phit_d_vto)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vto)/two_n_phit0/two_n_phit0);
d_etags_d_ss=((two_n_phit0*(-(d_vtof_d_ss-(0.5*d_alpha_phit_d_ss)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ss)/two_n_phit0/two_n_phit0);
d_etags_d_delta1=((two_n_phit0*(-(d_vtof_d_delta1-(0.5*d_alpha_phit_d_delta1)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta1)/two_n_phit0/two_n_phit0);
d_etags_d_delta2=((two_n_phit0*(-(d_vtof_d_delta2-(0.5*d_alpha_phit_d_delta2)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_delta2)/two_n_phit0/two_n_phit0);
d_etags_d_nd=((two_n_phit0*(-(d_vtof_d_nd-(0.5*d_alpha_phit_d_nd)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_nd)/two_n_phit0/two_n_phit0);
d_etags_d_alpha=((two_n_phit0*(-(d_vtof_d_alpha-(0.5*d_alpha_phit_d_alpha)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_alpha)/two_n_phit0/two_n_phit0);
d_etags_d_vel0=((two_n_phit0*(-(d_vtof_d_vel0-(0.5*d_alpha_phit_d_vel0)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vel0)/two_n_phit0/two_n_phit0);
d_etags_d_mu0=((two_n_phit0*(-(d_vtof_d_mu0-(0.5*d_alpha_phit_d_mu0)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mu0)/two_n_phit0/two_n_phit0);
d_etags_d_beta=((two_n_phit0*(-(d_vtof_d_beta-(0.5*d_alpha_phit_d_beta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_beta)/two_n_phit0/two_n_phit0);
d_etags_d_mtheta=((two_n_phit0*(-(d_vtof_d_mtheta-(0.5*d_alpha_phit_d_mtheta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_mtheta)/two_n_phit0/two_n_phit0);
d_etags_d_vtheta=((two_n_phit0*(-(d_vtof_d_vtheta-(0.5*d_alpha_phit_d_vtheta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtheta)/two_n_phit0/two_n_phit0);
d_etags_d_vtzeta=((two_n_phit0*(-(d_vtof_d_vtzeta-(0.5*d_alpha_phit_d_vtzeta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vtzeta)/two_n_phit0/two_n_phit0);
d_etags_d_dibsat=((two_n_phit0*(-(d_vtof_d_dibsat-(0.5*d_alpha_phit_d_dibsat)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_dibsat)/two_n_phit0/two_n_phit0);
d_etags_d_epsilon=((two_n_phit0*(-(d_vtof_d_epsilon-(0.5*d_alpha_phit_d_epsilon)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_epsilon)/two_n_phit0/two_n_phit0);
d_etags_d_vzeta=((two_n_phit0*(-(d_vtof_d_vzeta-(0.5*d_alpha_phit_d_vzeta)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_vzeta)/two_n_phit0/two_n_phit0);
d_etags_d_lambda=((two_n_phit0*(-(d_vtof_d_lambda-(0.5*d_alpha_phit_d_lambda)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_lambda)/two_n_phit0/two_n_phit0);
d_etags_d_ngf=((two_n_phit0*(-(d_vtof_d_ngf-(0.5*d_alpha_phit_d_ngf)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_ngf)/two_n_phit0/two_n_phit0);
d_etags_d_type=((two_n_phit0*(-(d_vtof_d_type-(0.5*d_alpha_phit_d_type)))-(vgsin-(vtof-(0.5*alpha_phit)))*d_two_n_phit0_d_type)/two_n_phit0/two_n_phit0);
etags=((vgsin-(vtof-(0.5*alpha_phit)))/two_n_phit0);
if((etags>50.0))
{
d_exparg_d_vgsin=d_etags_d_vgsin;
d_exparg_d_vdsin=d_etags_d_vdsin;
d_exparg_d_qcbflag=d_etags_d_qcbflag;
d_exparg_d_vcin=d_etags_d_vcin;
d_exparg_d_vbin=d_etags_d_vbin;
d_exparg_d_qgsflag=d_etags_d_qgsflag;
d_exparg_d_tambin=d_etags_d_tambin;
d_exparg_d_tnomin=d_etags_d_tnomin;
d_exparg_d_phitin=d_etags_d_phitin;
d_exparg_d_w=d_etags_d_w;
d_exparg_d_lin=d_etags_d_lin;
d_exparg_d_cgin=d_etags_d_cgin;
d_exparg_d_cs=d_etags_d_cs;
d_exparg_d_cc=d_etags_d_cc;
d_exparg_d_cb=d_etags_d_cb;
d_exparg_d_vto=d_etags_d_vto;
d_exparg_d_ss=d_etags_d_ss;
d_exparg_d_delta1=d_etags_d_delta1;
d_exparg_d_delta2=d_etags_d_delta2;
d_exparg_d_nd=d_etags_d_nd;
d_exparg_d_alpha=d_etags_d_alpha;
d_exparg_d_vel0=d_etags_d_vel0;
d_exparg_d_mu0=d_etags_d_mu0;
d_exparg_d_beta=d_etags_d_beta;
d_exparg_d_mtheta=d_etags_d_mtheta;
d_exparg_d_vtheta=d_etags_d_vtheta;
d_exparg_d_vtzeta=d_etags_d_vtzeta;
d_exparg_d_dibsat=d_etags_d_dibsat;
d_exparg_d_epsilon=d_etags_d_epsilon;
d_exparg_d_vzeta=d_etags_d_vzeta;
d_exparg_d_lambda=d_etags_d_lambda;
d_exparg_d_ngf=d_etags_d_ngf;
d_exparg_d_type=d_etags_d_type;
exparg=etags;
}
else
{
if((etags<(-50.0)))
{
d_exparg_d_vgsin=0.0;
d_exparg_d_vdsin=0.0;
d_exparg_d_qcbflag=0.0;
d_exparg_d_vcin=0.0;
d_exparg_d_vbin=0.0;
d_exparg_d_qgsflag=0.0;
d_exparg_d_tambin=0.0;
d_exparg_d_tnomin=0.0;
d_exparg_d_phitin=0.0;
d_exparg_d_w=0.0;
d_exparg_d_lin=0.0;
d_exparg_d_cgin=0.0;
d_exparg_d_cs=0.0;
d_exparg_d_cc=0.0;
d_exparg_d_cb=0.0;
d_exparg_d_vto=0.0;
d_exparg_d_ss=0.0;
d_exparg_d_delta1=0.0;
d_exparg_d_delta2=0.0;
d_exparg_d_nd=0.0;
d_exparg_d_alpha=0.0;
d_exparg_d_vel0=0.0;
d_exparg_d_mu0=0.0;
d_exparg_d_beta=0.0;
d_exparg_d_mtheta=0.0;
d_exparg_d_vtheta=0.0;
d_exparg_d_vtzeta=0.0;
d_exparg_d_dibsat=0.0;
d_exparg_d_epsilon=0.0;
d_exparg_d_vzeta=0.0;
d_exparg_d_lambda=0.0;
d_exparg_d_ngf=0.0;
d_exparg_d_type=0.0;
exparg=0;
}
else
{
d_exparg_d_vgsin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vgsin;
d_exparg_d_vdsin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vdsin;
d_exparg_d_qcbflag=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_qcbflag;
d_exparg_d_vcin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vcin;
d_exparg_d_vbin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vbin;
d_exparg_d_qgsflag=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_qgsflag;
d_exparg_d_tambin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_tambin;
d_exparg_d_tnomin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_tnomin;
d_exparg_d_phitin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_phitin;
d_exparg_d_w=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_w;
d_exparg_d_lin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_lin;
d_exparg_d_cgin=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cgin;
d_exparg_d_cs=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cs;
d_exparg_d_cc=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cc;
d_exparg_d_cb=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_cb;
d_exparg_d_vto=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vto;
d_exparg_d_ss=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_ss;
d_exparg_d_delta1=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_delta1;
d_exparg_d_delta2=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_delta2;
d_exparg_d_nd=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_nd;
d_exparg_d_alpha=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_alpha;
d_exparg_d_vel0=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vel0;
d_exparg_d_mu0=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_mu0;
d_exparg_d_beta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_beta;
d_exparg_d_mtheta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_mtheta;
d_exparg_d_vtheta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vtheta;
d_exparg_d_vtzeta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vtzeta;
d_exparg_d_dibsat=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_dibsat;
d_exparg_d_epsilon=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_epsilon;
d_exparg_d_vzeta=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_vzeta;
d_exparg_d_lambda=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_lambda;
d_exparg_d_ngf=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_ngf;
d_exparg_d_type=(1.0/(1.0+exp(etags)))*exp(etags)*d_etags_d_type;
exparg=log((1.0+exp(etags)));
}
}
d_qsout_d_vgsin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vgsin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vgsin)*exparg));
d_qsout_d_vdsin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vdsin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vdsin)*exparg));
d_qsout_d_qcbflag=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_qcbflag)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_qcbflag)*exparg));
d_qsout_d_vcin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vcin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vcin)*exparg));
d_qsout_d_vbin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vbin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vbin)*exparg));
d_qsout_d_qgsflag=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_qgsflag)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_qgsflag)*exparg));
d_qsout_d_tambin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_tambin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_tambin)*exparg));
d_qsout_d_tnomin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_tnomin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_tnomin)*exparg));
d_qsout_d_phitin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_phitin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_phitin)*exparg));
d_qsout_d_w=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_w)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_w)+((((ngf)*type)*cs)*two_n_phit0))*exparg));
d_qsout_d_lin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_lin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_lin)*exparg));
d_qsout_d_cgin=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cgin)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_cgin)*exparg));
d_qsout_d_cs=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cs)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_cs)+((((w*ngf)*type))*two_n_phit0))*exparg));
d_qsout_d_cc=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cc)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_cc)*exparg));
d_qsout_d_cb=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_cb)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_cb)*exparg));
d_qsout_d_vto=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vto)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vto)*exparg));
d_qsout_d_ss=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_ss)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_ss)*exparg));
d_qsout_d_delta1=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_delta1)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_delta1)*exparg));
d_qsout_d_delta2=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_delta2)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_delta2)*exparg));
d_qsout_d_nd=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_nd)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_nd)*exparg));
d_qsout_d_alpha=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_alpha)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_alpha)*exparg));
d_qsout_d_vel0=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vel0)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vel0)*exparg));
d_qsout_d_mu0=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_mu0)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_mu0)*exparg));
d_qsout_d_beta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_beta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_beta)*exparg));
d_qsout_d_mtheta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_mtheta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_mtheta)*exparg));
d_qsout_d_vtheta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vtheta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vtheta)*exparg));
d_qsout_d_vtzeta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vtzeta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vtzeta)*exparg));
d_qsout_d_dibsat=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_dibsat)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_dibsat)*exparg));
d_qsout_d_epsilon=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_epsilon)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_epsilon)*exparg));
d_qsout_d_vzeta=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_vzeta)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_vzeta)*exparg));
d_qsout_d_lambda=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_lambda)+(((((w*ngf)*type)*cs)*d_two_n_phit0_d_lambda)*exparg));
d_qsout_d_ngf=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_ngf)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_ngf)+((((w)*type)*cs)*two_n_phit0))*exparg));
d_qsout_d_type=((((((w*ngf)*type)*cs)*two_n_phit0)*d_exparg_d_type)+((((((w*ngf)*type)*cs)*d_two_n_phit0_d_type)+((((w*ngf))*cs)*two_n_phit0))*exparg));
qsout=(((((w*ngf)*type)*cs)*two_n_phit0)*exparg);
}
else
{
d_qsout_d_vgsin=0.0;
d_qsout_d_vdsin=0.0;
d_qsout_d_qcbflag=0.0;
d_qsout_d_vcin=0.0;
d_qsout_d_vbin=0.0;
d_qsout_d_qgsflag=0.0;
d_qsout_d_tambin=0.0;
d_qsout_d_tnomin=0.0;
d_qsout_d_phitin=0.0;
d_qsout_d_w=0.0;
d_qsout_d_lin=0.0;
d_qsout_d_cgin=0.0;
d_qsout_d_cs=0.0;
d_qsout_d_cc=0.0;
d_qsout_d_cb=0.0;
d_qsout_d_vto=0.0;
d_qsout_d_ss=0.0;
d_qsout_d_delta1=0.0;
d_qsout_d_delta2=0.0;
d_qsout_d_nd=0.0;
d_qsout_d_alpha=0.0;
d_qsout_d_vel0=0.0;
d_qsout_d_mu0=0.0;
d_qsout_d_beta=0.0;
d_qsout_d_mtheta=0.0;
d_qsout_d_vtheta=0.0;
d_qsout_d_vtzeta=0.0;
d_qsout_d_dibsat=0.0;
d_qsout_d_epsilon=0.0;
d_qsout_d_vzeta=0.0;
d_qsout_d_lambda=0.0;
d_qsout_d_ngf=0.0;
d_qsout_d_type=0.0;
qsout=0;
}
d_calc_iq_d_vgsin=d_idsout_d_vgsin;
d_calc_iq_d_vdsin=d_idsout_d_vdsin;
d_calc_iq_d_qcbflag=d_idsout_d_qcbflag;
d_calc_iq_d_vcin=d_idsout_d_vcin;
d_calc_iq_d_vbin=d_idsout_d_vbin;
d_calc_iq_d_qgsflag=d_idsout_d_qgsflag;
d_calc_iq_d_tambin=d_idsout_d_tambin;
d_calc_iq_d_tnomin=d_idsout_d_tnomin;
d_calc_iq_d_phitin=d_idsout_d_phitin;
d_calc_iq_d_w=d_idsout_d_w;
d_calc_iq_d_lin=d_idsout_d_lin;
d_calc_iq_d_cgin=d_idsout_d_cgin;
d_calc_iq_d_cs=d_idsout_d_cs;
d_calc_iq_d_cc=d_idsout_d_cc;
d_calc_iq_d_cb=d_idsout_d_cb;
d_calc_iq_d_vto=d_idsout_d_vto;
d_calc_iq_d_ss=d_idsout_d_ss;
d_calc_iq_d_delta1=d_idsout_d_delta1;
d_calc_iq_d_delta2=d_idsout_d_delta2;
d_calc_iq_d_nd=d_idsout_d_nd;
d_calc_iq_d_alpha=d_idsout_d_alpha;
d_calc_iq_d_vel0=d_idsout_d_vel0;
d_calc_iq_d_mu0=d_idsout_d_mu0;
d_calc_iq_d_beta=d_idsout_d_beta;
d_calc_iq_d_mtheta=d_idsout_d_mtheta;
d_calc_iq_d_vtheta=d_idsout_d_vtheta;
d_calc_iq_d_vtzeta=d_idsout_d_vtzeta;
d_calc_iq_d_dibsat=d_idsout_d_dibsat;
d_calc_iq_d_epsilon=d_idsout_d_epsilon;
d_calc_iq_d_vzeta=d_idsout_d_vzeta;
d_calc_iq_d_lambda=d_idsout_d_lambda;
d_calc_iq_d_ngf=d_idsout_d_ngf;
d_calc_iq_d_type=d_idsout_d_type;
calc_iq=idsout;
}
  // now save outputs and derivs into appropriate return vars
  calc_iqReturn.value=calc_iq;
  calc_iqReturn.deriv_WRT_vgsin = d_calc_iq_d_vgsin;
  calc_iqReturn.deriv_WRT_vdsin = d_calc_iq_d_vdsin;
  calc_iqReturn.deriv_WRT_qcbflag = d_calc_iq_d_qcbflag;
  calc_iqReturn.deriv_WRT_vcin = d_calc_iq_d_vcin;
  calc_iqReturn.deriv_WRT_vbin = d_calc_iq_d_vbin;
  calc_iqReturn.deriv_WRT_qgsflag = d_calc_iq_d_qgsflag;
  calc_iqReturn.deriv_WRT_tambin = d_calc_iq_d_tambin;
  calc_iqReturn.deriv_WRT_tnomin = d_calc_iq_d_tnomin;
  calc_iqReturn.deriv_WRT_phitin = d_calc_iq_d_phitin;
  calc_iqReturn.deriv_WRT_w = d_calc_iq_d_w;
  calc_iqReturn.deriv_WRT_lin = d_calc_iq_d_lin;
  calc_iqReturn.deriv_WRT_cgin = d_calc_iq_d_cgin;
  calc_iqReturn.deriv_WRT_cs = d_calc_iq_d_cs;
  calc_iqReturn.deriv_WRT_cc = d_calc_iq_d_cc;
  calc_iqReturn.deriv_WRT_cb = d_calc_iq_d_cb;
  calc_iqReturn.deriv_WRT_vto = d_calc_iq_d_vto;
  calc_iqReturn.deriv_WRT_ss = d_calc_iq_d_ss;
  calc_iqReturn.deriv_WRT_delta1 = d_calc_iq_d_delta1;
  calc_iqReturn.deriv_WRT_delta2 = d_calc_iq_d_delta2;
  calc_iqReturn.deriv_WRT_nd = d_calc_iq_d_nd;
  calc_iqReturn.deriv_WRT_alpha = d_calc_iq_d_alpha;
  calc_iqReturn.deriv_WRT_vel0 = d_calc_iq_d_vel0;
  calc_iqReturn.deriv_WRT_mu0 = d_calc_iq_d_mu0;
  calc_iqReturn.deriv_WRT_beta = d_calc_iq_d_beta;
  calc_iqReturn.deriv_WRT_mtheta = d_calc_iq_d_mtheta;
  calc_iqReturn.deriv_WRT_vtheta = d_calc_iq_d_vtheta;
  calc_iqReturn.deriv_WRT_vtzeta = d_calc_iq_d_vtzeta;
  calc_iqReturn.deriv_WRT_dibsat = d_calc_iq_d_dibsat;
  calc_iqReturn.deriv_WRT_epsilon = d_calc_iq_d_epsilon;
  calc_iqReturn.deriv_WRT_vzeta = d_calc_iq_d_vzeta;
  calc_iqReturn.deriv_WRT_lambda = d_calc_iq_d_lambda;
  calc_iqReturn.deriv_WRT_ngf = d_calc_iq_d_ngf;
  calc_iqReturn.deriv_WRT_type = d_calc_iq_d_type;
  idsoutReturn.value = idsout;
  idsoutReturn.deriv_WRT_vgsin = d_idsout_d_vgsin;
  idsoutReturn.deriv_WRT_vdsin = d_idsout_d_vdsin;
  idsoutReturn.deriv_WRT_qcbflag = d_idsout_d_qcbflag;
  idsoutReturn.deriv_WRT_vcin = d_idsout_d_vcin;
  idsoutReturn.deriv_WRT_vbin = d_idsout_d_vbin;
  idsoutReturn.deriv_WRT_qgsflag = d_idsout_d_qgsflag;
  idsoutReturn.deriv_WRT_tambin = d_idsout_d_tambin;
  idsoutReturn.deriv_WRT_tnomin = d_idsout_d_tnomin;
  idsoutReturn.deriv_WRT_phitin = d_idsout_d_phitin;
  idsoutReturn.deriv_WRT_w = d_idsout_d_w;
  idsoutReturn.deriv_WRT_lin = d_idsout_d_lin;
  idsoutReturn.deriv_WRT_cgin = d_idsout_d_cgin;
  idsoutReturn.deriv_WRT_cs = d_idsout_d_cs;
  idsoutReturn.deriv_WRT_cc = d_idsout_d_cc;
  idsoutReturn.deriv_WRT_cb = d_idsout_d_cb;
  idsoutReturn.deriv_WRT_vto = d_idsout_d_vto;
  idsoutReturn.deriv_WRT_ss = d_idsout_d_ss;
  idsoutReturn.deriv_WRT_delta1 = d_idsout_d_delta1;
  idsoutReturn.deriv_WRT_delta2 = d_idsout_d_delta2;
  idsoutReturn.deriv_WRT_nd = d_idsout_d_nd;
  idsoutReturn.deriv_WRT_alpha = d_idsout_d_alpha;
  idsoutReturn.deriv_WRT_vel0 = d_idsout_d_vel0;
  idsoutReturn.deriv_WRT_mu0 = d_idsout_d_mu0;
  idsoutReturn.deriv_WRT_beta = d_idsout_d_beta;
  idsoutReturn.deriv_WRT_mtheta = d_idsout_d_mtheta;
  idsoutReturn.deriv_WRT_vtheta = d_idsout_d_vtheta;
  idsoutReturn.deriv_WRT_vtzeta = d_idsout_d_vtzeta;
  idsoutReturn.deriv_WRT_dibsat = d_idsout_d_dibsat;
  idsoutReturn.deriv_WRT_epsilon = d_idsout_d_epsilon;
  idsoutReturn.deriv_WRT_vzeta = d_idsout_d_vzeta;
  idsoutReturn.deriv_WRT_lambda = d_idsout_d_lambda;
  idsoutReturn.deriv_WRT_ngf = d_idsout_d_ngf;
  idsoutReturn.deriv_WRT_type = d_idsout_d_type;
  qgsoutReturn.value = qgsout;
  qgsoutReturn.deriv_WRT_vgsin = d_qgsout_d_vgsin;
  qgsoutReturn.deriv_WRT_vdsin = d_qgsout_d_vdsin;
  qgsoutReturn.deriv_WRT_qcbflag = d_qgsout_d_qcbflag;
  qgsoutReturn.deriv_WRT_vcin = d_qgsout_d_vcin;
  qgsoutReturn.deriv_WRT_vbin = d_qgsout_d_vbin;
  qgsoutReturn.deriv_WRT_qgsflag = d_qgsout_d_qgsflag;
  qgsoutReturn.deriv_WRT_tambin = d_qgsout_d_tambin;
  qgsoutReturn.deriv_WRT_tnomin = d_qgsout_d_tnomin;
  qgsoutReturn.deriv_WRT_phitin = d_qgsout_d_phitin;
  qgsoutReturn.deriv_WRT_w = d_qgsout_d_w;
  qgsoutReturn.deriv_WRT_lin = d_qgsout_d_lin;
  qgsoutReturn.deriv_WRT_cgin = d_qgsout_d_cgin;
  qgsoutReturn.deriv_WRT_cs = d_qgsout_d_cs;
  qgsoutReturn.deriv_WRT_cc = d_qgsout_d_cc;
  qgsoutReturn.deriv_WRT_cb = d_qgsout_d_cb;
  qgsoutReturn.deriv_WRT_vto = d_qgsout_d_vto;
  qgsoutReturn.deriv_WRT_ss = d_qgsout_d_ss;
  qgsoutReturn.deriv_WRT_delta1 = d_qgsout_d_delta1;
  qgsoutReturn.deriv_WRT_delta2 = d_qgsout_d_delta2;
  qgsoutReturn.deriv_WRT_nd = d_qgsout_d_nd;
  qgsoutReturn.deriv_WRT_alpha = d_qgsout_d_alpha;
  qgsoutReturn.deriv_WRT_vel0 = d_qgsout_d_vel0;
  qgsoutReturn.deriv_WRT_mu0 = d_qgsout_d_mu0;
  qgsoutReturn.deriv_WRT_beta = d_qgsout_d_beta;
  qgsoutReturn.deriv_WRT_mtheta = d_qgsout_d_mtheta;
  qgsoutReturn.deriv_WRT_vtheta = d_qgsout_d_vtheta;
  qgsoutReturn.deriv_WRT_vtzeta = d_qgsout_d_vtzeta;
  qgsoutReturn.deriv_WRT_dibsat = d_qgsout_d_dibsat;
  qgsoutReturn.deriv_WRT_epsilon = d_qgsout_d_epsilon;
  qgsoutReturn.deriv_WRT_vzeta = d_qgsout_d_vzeta;
  qgsoutReturn.deriv_WRT_lambda = d_qgsout_d_lambda;
  qgsoutReturn.deriv_WRT_ngf = d_qgsout_d_ngf;
  qgsoutReturn.deriv_WRT_type = d_qgsout_d_type;
  qgdoutReturn.value = qgdout;
  qgdoutReturn.deriv_WRT_vgsin = d_qgdout_d_vgsin;
  qgdoutReturn.deriv_WRT_vdsin = d_qgdout_d_vdsin;
  qgdoutReturn.deriv_WRT_qcbflag = d_qgdout_d_qcbflag;
  qgdoutReturn.deriv_WRT_vcin = d_qgdout_d_vcin;
  qgdoutReturn.deriv_WRT_vbin = d_qgdout_d_vbin;
  qgdoutReturn.deriv_WRT_qgsflag = d_qgdout_d_qgsflag;
  qgdoutReturn.deriv_WRT_tambin = d_qgdout_d_tambin;
  qgdoutReturn.deriv_WRT_tnomin = d_qgdout_d_tnomin;
  qgdoutReturn.deriv_WRT_phitin = d_qgdout_d_phitin;
  qgdoutReturn.deriv_WRT_w = d_qgdout_d_w;
  qgdoutReturn.deriv_WRT_lin = d_qgdout_d_lin;
  qgdoutReturn.deriv_WRT_cgin = d_qgdout_d_cgin;
  qgdoutReturn.deriv_WRT_cs = d_qgdout_d_cs;
  qgdoutReturn.deriv_WRT_cc = d_qgdout_d_cc;
  qgdoutReturn.deriv_WRT_cb = d_qgdout_d_cb;
  qgdoutReturn.deriv_WRT_vto = d_qgdout_d_vto;
  qgdoutReturn.deriv_WRT_ss = d_qgdout_d_ss;
  qgdoutReturn.deriv_WRT_delta1 = d_qgdout_d_delta1;
  qgdoutReturn.deriv_WRT_delta2 = d_qgdout_d_delta2;
  qgdoutReturn.deriv_WRT_nd = d_qgdout_d_nd;
  qgdoutReturn.deriv_WRT_alpha = d_qgdout_d_alpha;
  qgdoutReturn.deriv_WRT_vel0 = d_qgdout_d_vel0;
  qgdoutReturn.deriv_WRT_mu0 = d_qgdout_d_mu0;
  qgdoutReturn.deriv_WRT_beta = d_qgdout_d_beta;
  qgdoutReturn.deriv_WRT_mtheta = d_qgdout_d_mtheta;
  qgdoutReturn.deriv_WRT_vtheta = d_qgdout_d_vtheta;
  qgdoutReturn.deriv_WRT_vtzeta = d_qgdout_d_vtzeta;
  qgdoutReturn.deriv_WRT_dibsat = d_qgdout_d_dibsat;
  qgdoutReturn.deriv_WRT_epsilon = d_qgdout_d_epsilon;
  qgdoutReturn.deriv_WRT_vzeta = d_qgdout_d_vzeta;
  qgdoutReturn.deriv_WRT_lambda = d_qgdout_d_lambda;
  qgdoutReturn.deriv_WRT_ngf = d_qgdout_d_ngf;
  qgdoutReturn.deriv_WRT_type = d_qgdout_d_type;
  qcoutReturn.value = qcout;
  qcoutReturn.deriv_WRT_vgsin = d_qcout_d_vgsin;
  qcoutReturn.deriv_WRT_vdsin = d_qcout_d_vdsin;
  qcoutReturn.deriv_WRT_qcbflag = d_qcout_d_qcbflag;
  qcoutReturn.deriv_WRT_vcin = d_qcout_d_vcin;
  qcoutReturn.deriv_WRT_vbin = d_qcout_d_vbin;
  qcoutReturn.deriv_WRT_qgsflag = d_qcout_d_qgsflag;
  qcoutReturn.deriv_WRT_tambin = d_qcout_d_tambin;
  qcoutReturn.deriv_WRT_tnomin = d_qcout_d_tnomin;
  qcoutReturn.deriv_WRT_phitin = d_qcout_d_phitin;
  qcoutReturn.deriv_WRT_w = d_qcout_d_w;
  qcoutReturn.deriv_WRT_lin = d_qcout_d_lin;
  qcoutReturn.deriv_WRT_cgin = d_qcout_d_cgin;
  qcoutReturn.deriv_WRT_cs = d_qcout_d_cs;
  qcoutReturn.deriv_WRT_cc = d_qcout_d_cc;
  qcoutReturn.deriv_WRT_cb = d_qcout_d_cb;
  qcoutReturn.deriv_WRT_vto = d_qcout_d_vto;
  qcoutReturn.deriv_WRT_ss = d_qcout_d_ss;
  qcoutReturn.deriv_WRT_delta1 = d_qcout_d_delta1;
  qcoutReturn.deriv_WRT_delta2 = d_qcout_d_delta2;
  qcoutReturn.deriv_WRT_nd = d_qcout_d_nd;
  qcoutReturn.deriv_WRT_alpha = d_qcout_d_alpha;
  qcoutReturn.deriv_WRT_vel0 = d_qcout_d_vel0;
  qcoutReturn.deriv_WRT_mu0 = d_qcout_d_mu0;
  qcoutReturn.deriv_WRT_beta = d_qcout_d_beta;
  qcoutReturn.deriv_WRT_mtheta = d_qcout_d_mtheta;
  qcoutReturn.deriv_WRT_vtheta = d_qcout_d_vtheta;
  qcoutReturn.deriv_WRT_vtzeta = d_qcout_d_vtzeta;
  qcoutReturn.deriv_WRT_dibsat = d_qcout_d_dibsat;
  qcoutReturn.deriv_WRT_epsilon = d_qcout_d_epsilon;
  qcoutReturn.deriv_WRT_vzeta = d_qcout_d_vzeta;
  qcoutReturn.deriv_WRT_lambda = d_qcout_d_lambda;
  qcoutReturn.deriv_WRT_ngf = d_qcout_d_ngf;
  qcoutReturn.deriv_WRT_type = d_qcout_d_type;
  qboutReturn.value = qbout;
  qboutReturn.deriv_WRT_vgsin = d_qbout_d_vgsin;
  qboutReturn.deriv_WRT_vdsin = d_qbout_d_vdsin;
  qboutReturn.deriv_WRT_qcbflag = d_qbout_d_qcbflag;
  qboutReturn.deriv_WRT_vcin = d_qbout_d_vcin;
  qboutReturn.deriv_WRT_vbin = d_qbout_d_vbin;
  qboutReturn.deriv_WRT_qgsflag = d_qbout_d_qgsflag;
  qboutReturn.deriv_WRT_tambin = d_qbout_d_tambin;
  qboutReturn.deriv_WRT_tnomin = d_qbout_d_tnomin;
  qboutReturn.deriv_WRT_phitin = d_qbout_d_phitin;
  qboutReturn.deriv_WRT_w = d_qbout_d_w;
  qboutReturn.deriv_WRT_lin = d_qbout_d_lin;
  qboutReturn.deriv_WRT_cgin = d_qbout_d_cgin;
  qboutReturn.deriv_WRT_cs = d_qbout_d_cs;
  qboutReturn.deriv_WRT_cc = d_qbout_d_cc;
  qboutReturn.deriv_WRT_cb = d_qbout_d_cb;
  qboutReturn.deriv_WRT_vto = d_qbout_d_vto;
  qboutReturn.deriv_WRT_ss = d_qbout_d_ss;
  qboutReturn.deriv_WRT_delta1 = d_qbout_d_delta1;
  qboutReturn.deriv_WRT_delta2 = d_qbout_d_delta2;
  qboutReturn.deriv_WRT_nd = d_qbout_d_nd;
  qboutReturn.deriv_WRT_alpha = d_qbout_d_alpha;
  qboutReturn.deriv_WRT_vel0 = d_qbout_d_vel0;
  qboutReturn.deriv_WRT_mu0 = d_qbout_d_mu0;
  qboutReturn.deriv_WRT_beta = d_qbout_d_beta;
  qboutReturn.deriv_WRT_mtheta = d_qbout_d_mtheta;
  qboutReturn.deriv_WRT_vtheta = d_qbout_d_vtheta;
  qboutReturn.deriv_WRT_vtzeta = d_qbout_d_vtzeta;
  qboutReturn.deriv_WRT_dibsat = d_qbout_d_dibsat;
  qboutReturn.deriv_WRT_epsilon = d_qbout_d_epsilon;
  qboutReturn.deriv_WRT_vzeta = d_qbout_d_vzeta;
  qboutReturn.deriv_WRT_lambda = d_qbout_d_lambda;
  qboutReturn.deriv_WRT_ngf = d_qbout_d_ngf;
  qboutReturn.deriv_WRT_type = d_qbout_d_type;
  qsoutReturn.value = qsout;
  qsoutReturn.deriv_WRT_vgsin = d_qsout_d_vgsin;
  qsoutReturn.deriv_WRT_vdsin = d_qsout_d_vdsin;
  qsoutReturn.deriv_WRT_qcbflag = d_qsout_d_qcbflag;
  qsoutReturn.deriv_WRT_vcin = d_qsout_d_vcin;
  qsoutReturn.deriv_WRT_vbin = d_qsout_d_vbin;
  qsoutReturn.deriv_WRT_qgsflag = d_qsout_d_qgsflag;
  qsoutReturn.deriv_WRT_tambin = d_qsout_d_tambin;
  qsoutReturn.deriv_WRT_tnomin = d_qsout_d_tnomin;
  qsoutReturn.deriv_WRT_phitin = d_qsout_d_phitin;
  qsoutReturn.deriv_WRT_w = d_qsout_d_w;
  qsoutReturn.deriv_WRT_lin = d_qsout_d_lin;
  qsoutReturn.deriv_WRT_cgin = d_qsout_d_cgin;
  qsoutReturn.deriv_WRT_cs = d_qsout_d_cs;
  qsoutReturn.deriv_WRT_cc = d_qsout_d_cc;
  qsoutReturn.deriv_WRT_cb = d_qsout_d_cb;
  qsoutReturn.deriv_WRT_vto = d_qsout_d_vto;
  qsoutReturn.deriv_WRT_ss = d_qsout_d_ss;
  qsoutReturn.deriv_WRT_delta1 = d_qsout_d_delta1;
  qsoutReturn.deriv_WRT_delta2 = d_qsout_d_delta2;
  qsoutReturn.deriv_WRT_nd = d_qsout_d_nd;
  qsoutReturn.deriv_WRT_alpha = d_qsout_d_alpha;
  qsoutReturn.deriv_WRT_vel0 = d_qsout_d_vel0;
  qsoutReturn.deriv_WRT_mu0 = d_qsout_d_mu0;
  qsoutReturn.deriv_WRT_beta = d_qsout_d_beta;
  qsoutReturn.deriv_WRT_mtheta = d_qsout_d_mtheta;
  qsoutReturn.deriv_WRT_vtheta = d_qsout_d_vtheta;
  qsoutReturn.deriv_WRT_vtzeta = d_qsout_d_vtzeta;
  qsoutReturn.deriv_WRT_dibsat = d_qsout_d_dibsat;
  qsoutReturn.deriv_WRT_epsilon = d_qsout_d_epsilon;
  qsoutReturn.deriv_WRT_vzeta = d_qsout_d_vzeta;
  qsoutReturn.deriv_WRT_lambda = d_qsout_d_lambda;
  qsoutReturn.deriv_WRT_ngf = d_qsout_d_ngf;
  qsoutReturn.deriv_WRT_type = d_qsout_d_type;
  vtdiblReturn.value = vtdibl;
  vtdiblReturn.deriv_WRT_vgsin = d_vtdibl_d_vgsin;
  vtdiblReturn.deriv_WRT_vdsin = d_vtdibl_d_vdsin;
  vtdiblReturn.deriv_WRT_qcbflag = d_vtdibl_d_qcbflag;
  vtdiblReturn.deriv_WRT_vcin = d_vtdibl_d_vcin;
  vtdiblReturn.deriv_WRT_vbin = d_vtdibl_d_vbin;
  vtdiblReturn.deriv_WRT_qgsflag = d_vtdibl_d_qgsflag;
  vtdiblReturn.deriv_WRT_tambin = d_vtdibl_d_tambin;
  vtdiblReturn.deriv_WRT_tnomin = d_vtdibl_d_tnomin;
  vtdiblReturn.deriv_WRT_phitin = d_vtdibl_d_phitin;
  vtdiblReturn.deriv_WRT_w = d_vtdibl_d_w;
  vtdiblReturn.deriv_WRT_lin = d_vtdibl_d_lin;
  vtdiblReturn.deriv_WRT_cgin = d_vtdibl_d_cgin;
  vtdiblReturn.deriv_WRT_cs = d_vtdibl_d_cs;
  vtdiblReturn.deriv_WRT_cc = d_vtdibl_d_cc;
  vtdiblReturn.deriv_WRT_cb = d_vtdibl_d_cb;
  vtdiblReturn.deriv_WRT_vto = d_vtdibl_d_vto;
  vtdiblReturn.deriv_WRT_ss = d_vtdibl_d_ss;
  vtdiblReturn.deriv_WRT_delta1 = d_vtdibl_d_delta1;
  vtdiblReturn.deriv_WRT_delta2 = d_vtdibl_d_delta2;
  vtdiblReturn.deriv_WRT_nd = d_vtdibl_d_nd;
  vtdiblReturn.deriv_WRT_alpha = d_vtdibl_d_alpha;
  vtdiblReturn.deriv_WRT_vel0 = d_vtdibl_d_vel0;
  vtdiblReturn.deriv_WRT_mu0 = d_vtdibl_d_mu0;
  vtdiblReturn.deriv_WRT_beta = d_vtdibl_d_beta;
  vtdiblReturn.deriv_WRT_mtheta = d_vtdibl_d_mtheta;
  vtdiblReturn.deriv_WRT_vtheta = d_vtdibl_d_vtheta;
  vtdiblReturn.deriv_WRT_vtzeta = d_vtdibl_d_vtzeta;
  vtdiblReturn.deriv_WRT_dibsat = d_vtdibl_d_dibsat;
  vtdiblReturn.deriv_WRT_epsilon = d_vtdibl_d_epsilon;
  vtdiblReturn.deriv_WRT_vzeta = d_vtdibl_d_vzeta;
  vtdiblReturn.deriv_WRT_lambda = d_vtdibl_d_lambda;
  vtdiblReturn.deriv_WRT_ngf = d_vtdibl_d_ngf;
  vtdiblReturn.deriv_WRT_type = d_vtdibl_d_type;
  vdsat1Return.value = vdsat1;
  vdsat1Return.deriv_WRT_vgsin = d_vdsat1_d_vgsin;
  vdsat1Return.deriv_WRT_vdsin = d_vdsat1_d_vdsin;
  vdsat1Return.deriv_WRT_qcbflag = d_vdsat1_d_qcbflag;
  vdsat1Return.deriv_WRT_vcin = d_vdsat1_d_vcin;
  vdsat1Return.deriv_WRT_vbin = d_vdsat1_d_vbin;
  vdsat1Return.deriv_WRT_qgsflag = d_vdsat1_d_qgsflag;
  vdsat1Return.deriv_WRT_tambin = d_vdsat1_d_tambin;
  vdsat1Return.deriv_WRT_tnomin = d_vdsat1_d_tnomin;
  vdsat1Return.deriv_WRT_phitin = d_vdsat1_d_phitin;
  vdsat1Return.deriv_WRT_w = d_vdsat1_d_w;
  vdsat1Return.deriv_WRT_lin = d_vdsat1_d_lin;
  vdsat1Return.deriv_WRT_cgin = d_vdsat1_d_cgin;
  vdsat1Return.deriv_WRT_cs = d_vdsat1_d_cs;
  vdsat1Return.deriv_WRT_cc = d_vdsat1_d_cc;
  vdsat1Return.deriv_WRT_cb = d_vdsat1_d_cb;
  vdsat1Return.deriv_WRT_vto = d_vdsat1_d_vto;
  vdsat1Return.deriv_WRT_ss = d_vdsat1_d_ss;
  vdsat1Return.deriv_WRT_delta1 = d_vdsat1_d_delta1;
  vdsat1Return.deriv_WRT_delta2 = d_vdsat1_d_delta2;
  vdsat1Return.deriv_WRT_nd = d_vdsat1_d_nd;
  vdsat1Return.deriv_WRT_alpha = d_vdsat1_d_alpha;
  vdsat1Return.deriv_WRT_vel0 = d_vdsat1_d_vel0;
  vdsat1Return.deriv_WRT_mu0 = d_vdsat1_d_mu0;
  vdsat1Return.deriv_WRT_beta = d_vdsat1_d_beta;
  vdsat1Return.deriv_WRT_mtheta = d_vdsat1_d_mtheta;
  vdsat1Return.deriv_WRT_vtheta = d_vdsat1_d_vtheta;
  vdsat1Return.deriv_WRT_vtzeta = d_vdsat1_d_vtzeta;
  vdsat1Return.deriv_WRT_dibsat = d_vdsat1_d_dibsat;
  vdsat1Return.deriv_WRT_epsilon = d_vdsat1_d_epsilon;
  vdsat1Return.deriv_WRT_vzeta = d_vdsat1_d_vzeta;
  vdsat1Return.deriv_WRT_lambda = d_vdsat1_d_lambda;
  vdsat1Return.deriv_WRT_ngf = d_vdsat1_d_ngf;
  vdsat1Return.deriv_WRT_type = d_vdsat1_d_type;
  return(calc_iqReturn);
  }

// Derivative of Analog Function calc_ig
double d_calc_ig(double isdiodeout , double isrecout , double vgin , double phitin , double vgsatin , double alphagin , double fracin , double pg_paramin , double pbdgin , double vbdgin , double tambin , double tnomin , double w , double ngf , double ijin , double kbdgatein , double vgsatqin , double betarecin , double irecin , double pgsrecin , double pg_param1 , double vjg , double type  , double & d_isdiodeout , double & d_isrecout , double d_vgin , double d_phitin , double d_vgsatin , double d_alphagin , double d_fracin , double d_pg_paramin , double d_pbdgin , double d_vbdgin , double d_tambin , double d_tnomin , double d_w , double d_ngf , double d_ijin , double d_kbdgatein , double d_vgsatqin , double d_betarecin , double d_irecin , double d_pgsrecin , double d_pg_param1 , double d_vjg , double d_type )
{
// Function return variable and total deriv
double calc_ig;
double d_calc_ig;
// Derivatives of return value w.r.t input vars
double d_calc_ig_d_vgin;
double d_calc_ig_d_phitin;
double d_calc_ig_d_vgsatin;
double d_calc_ig_d_alphagin;
double d_calc_ig_d_fracin;
double d_calc_ig_d_pg_paramin;
double d_calc_ig_d_pbdgin;
double d_calc_ig_d_vbdgin;
double d_calc_ig_d_tambin;
double d_calc_ig_d_tnomin;
double d_calc_ig_d_w;
double d_calc_ig_d_ngf;
double d_calc_ig_d_ijin;
double d_calc_ig_d_kbdgatein;
double d_calc_ig_d_vgsatqin;
double d_calc_ig_d_betarecin;
double d_calc_ig_d_irecin;
double d_calc_ig_d_pgsrecin;
double d_calc_ig_d_pg_param1;
double d_calc_ig_d_vjg;
double d_calc_ig_d_type;
// Derivatives of additional output vars w.r.t input vars
double d_isdiodeout_d_vgin;
double d_isrecout_d_vgin;
double d_isdiodeout_d_phitin;
double d_isrecout_d_phitin;
double d_isdiodeout_d_vgsatin;
double d_isrecout_d_vgsatin;
double d_isdiodeout_d_alphagin;
double d_isrecout_d_alphagin;
double d_isdiodeout_d_fracin;
double d_isrecout_d_fracin;
double d_isdiodeout_d_pg_paramin;
double d_isrecout_d_pg_paramin;
double d_isdiodeout_d_pbdgin;
double d_isrecout_d_pbdgin;
double d_isdiodeout_d_vbdgin;
double d_isrecout_d_vbdgin;
double d_isdiodeout_d_tambin;
double d_isrecout_d_tambin;
double d_isdiodeout_d_tnomin;
double d_isrecout_d_tnomin;
double d_isdiodeout_d_w;
double d_isrecout_d_w;
double d_isdiodeout_d_ngf;
double d_isrecout_d_ngf;
double d_isdiodeout_d_ijin;
double d_isrecout_d_ijin;
double d_isdiodeout_d_kbdgatein;
double d_isrecout_d_kbdgatein;
double d_isdiodeout_d_vgsatqin;
double d_isrecout_d_vgsatqin;
double d_isdiodeout_d_betarecin;
double d_isrecout_d_betarecin;
double d_isdiodeout_d_irecin;
double d_isrecout_d_irecin;
double d_isdiodeout_d_pgsrecin;
double d_isrecout_d_pgsrecin;
double d_isdiodeout_d_pg_param1;
double d_isrecout_d_pg_param1;
double d_isdiodeout_d_vjg;
double d_isrecout_d_vjg;
double d_isdiodeout_d_type;
double d_isrecout_d_type;
double igout;
double d_igout_d_vgin;
double d_igout_d_phitin;
double d_igout_d_vgsatin;
double d_igout_d_alphagin;
double d_igout_d_fracin;
double d_igout_d_pg_paramin;
double d_igout_d_pbdgin;
double d_igout_d_vbdgin;
double d_igout_d_tambin;
double d_igout_d_tnomin;
double d_igout_d_w;
double d_igout_d_ngf;
double d_igout_d_ijin;
double d_igout_d_kbdgatein;
double d_igout_d_vgsatqin;
double d_igout_d_betarecin;
double d_igout_d_irecin;
double d_igout_d_pgsrecin;
double d_igout_d_pg_param1;
double d_igout_d_vjg;
double d_igout_d_type;
double alpha_phit;
double d_alpha_phit_d_vgin;
double d_alpha_phit_d_phitin;
double d_alpha_phit_d_vgsatin;
double d_alpha_phit_d_alphagin;
double d_alpha_phit_d_fracin;
double d_alpha_phit_d_pg_paramin;
double d_alpha_phit_d_pbdgin;
double d_alpha_phit_d_vbdgin;
double d_alpha_phit_d_tambin;
double d_alpha_phit_d_tnomin;
double d_alpha_phit_d_w;
double d_alpha_phit_d_ngf;
double d_alpha_phit_d_ijin;
double d_alpha_phit_d_kbdgatein;
double d_alpha_phit_d_vgsatqin;
double d_alpha_phit_d_betarecin;
double d_alpha_phit_d_irecin;
double d_alpha_phit_d_pgsrecin;
double d_alpha_phit_d_pg_param1;
double d_alpha_phit_d_vjg;
double d_alpha_phit_d_type;
double t0;
double d_t0_d_vgin;
double d_t0_d_phitin;
double d_t0_d_vgsatin;
double d_t0_d_alphagin;
double d_t0_d_fracin;
double d_t0_d_pg_paramin;
double d_t0_d_pbdgin;
double d_t0_d_vbdgin;
double d_t0_d_tambin;
double d_t0_d_tnomin;
double d_t0_d_w;
double d_t0_d_ngf;
double d_t0_d_ijin;
double d_t0_d_kbdgatein;
double d_t0_d_vgsatqin;
double d_t0_d_betarecin;
double d_t0_d_irecin;
double d_t0_d_pgsrecin;
double d_t0_d_pg_param1;
double d_t0_d_vjg;
double d_t0_d_type;
double ffvgin;
double d_ffvgin_d_vgin;
double d_ffvgin_d_phitin;
double d_ffvgin_d_vgsatin;
double d_ffvgin_d_alphagin;
double d_ffvgin_d_fracin;
double d_ffvgin_d_pg_paramin;
double d_ffvgin_d_pbdgin;
double d_ffvgin_d_vbdgin;
double d_ffvgin_d_tambin;
double d_ffvgin_d_tnomin;
double d_ffvgin_d_w;
double d_ffvgin_d_ngf;
double d_ffvgin_d_ijin;
double d_ffvgin_d_kbdgatein;
double d_ffvgin_d_vgsatqin;
double d_ffvgin_d_betarecin;
double d_ffvgin_d_irecin;
double d_ffvgin_d_pgsrecin;
double d_ffvgin_d_pg_param1;
double d_ffvgin_d_vjg;
double d_ffvgin_d_type;
double pgin;
double d_pgin_d_vgin;
double d_pgin_d_phitin;
double d_pgin_d_vgsatin;
double d_pgin_d_alphagin;
double d_pgin_d_fracin;
double d_pgin_d_pg_paramin;
double d_pgin_d_pbdgin;
double d_pgin_d_vbdgin;
double d_pgin_d_tambin;
double d_pgin_d_tnomin;
double d_pgin_d_w;
double d_pgin_d_ngf;
double d_pgin_d_ijin;
double d_pgin_d_kbdgatein;
double d_pgin_d_vgsatqin;
double d_pgin_d_betarecin;
double d_pgin_d_irecin;
double d_pgin_d_pgsrecin;
double d_pgin_d_pg_param1;
double d_pgin_d_vjg;
double d_pgin_d_type;
double iginbd;
double d_iginbd_d_vgin;
double d_iginbd_d_phitin;
double d_iginbd_d_vgsatin;
double d_iginbd_d_alphagin;
double d_iginbd_d_fracin;
double d_iginbd_d_pg_paramin;
double d_iginbd_d_pbdgin;
double d_iginbd_d_vbdgin;
double d_iginbd_d_tambin;
double d_iginbd_d_tnomin;
double d_iginbd_d_w;
double d_iginbd_d_ngf;
double d_iginbd_d_ijin;
double d_iginbd_d_kbdgatein;
double d_iginbd_d_vgsatqin;
double d_iginbd_d_betarecin;
double d_iginbd_d_irecin;
double d_iginbd_d_pgsrecin;
double d_iginbd_d_pg_param1;
double d_iginbd_d_vjg;
double d_iginbd_d_type;
double tfacdiode;
double d_tfacdiode_d_vgin;
double d_tfacdiode_d_phitin;
double d_tfacdiode_d_vgsatin;
double d_tfacdiode_d_alphagin;
double d_tfacdiode_d_fracin;
double d_tfacdiode_d_pg_paramin;
double d_tfacdiode_d_pbdgin;
double d_tfacdiode_d_vbdgin;
double d_tfacdiode_d_tambin;
double d_tfacdiode_d_tnomin;
double d_tfacdiode_d_w;
double d_tfacdiode_d_ngf;
double d_tfacdiode_d_ijin;
double d_tfacdiode_d_kbdgatein;
double d_tfacdiode_d_vgsatqin;
double d_tfacdiode_d_betarecin;
double d_tfacdiode_d_irecin;
double d_tfacdiode_d_pgsrecin;
double d_tfacdiode_d_pg_param1;
double d_tfacdiode_d_vjg;
double d_tfacdiode_d_type;
double igindiode;
double d_igindiode_d_vgin;
double d_igindiode_d_phitin;
double d_igindiode_d_vgsatin;
double d_igindiode_d_alphagin;
double d_igindiode_d_fracin;
double d_igindiode_d_pg_paramin;
double d_igindiode_d_pbdgin;
double d_igindiode_d_vbdgin;
double d_igindiode_d_tambin;
double d_igindiode_d_tnomin;
double d_igindiode_d_w;
double d_igindiode_d_ngf;
double d_igindiode_d_ijin;
double d_igindiode_d_kbdgatein;
double d_igindiode_d_vgsatqin;
double d_igindiode_d_betarecin;
double d_igindiode_d_irecin;
double d_igindiode_d_pgsrecin;
double d_igindiode_d_pg_param1;
double d_igindiode_d_vjg;
double d_igindiode_d_type;
double frecgin;
double d_frecgin_d_vgin;
double d_frecgin_d_phitin;
double d_frecgin_d_vgsatin;
double d_frecgin_d_alphagin;
double d_frecgin_d_fracin;
double d_frecgin_d_pg_paramin;
double d_frecgin_d_pbdgin;
double d_frecgin_d_vbdgin;
double d_frecgin_d_tambin;
double d_frecgin_d_tnomin;
double d_frecgin_d_w;
double d_frecgin_d_ngf;
double d_frecgin_d_ijin;
double d_frecgin_d_kbdgatein;
double d_frecgin_d_vgsatqin;
double d_frecgin_d_betarecin;
double d_frecgin_d_irecin;
double d_frecgin_d_pgsrecin;
double d_frecgin_d_pg_param1;
double d_frecgin_d_vjg;
double d_frecgin_d_type;
double iginrec;
double d_iginrec_d_vgin;
double d_iginrec_d_phitin;
double d_iginrec_d_vgsatin;
double d_iginrec_d_alphagin;
double d_iginrec_d_fracin;
double d_iginrec_d_pg_paramin;
double d_iginrec_d_pbdgin;
double d_iginrec_d_vbdgin;
double d_iginrec_d_tambin;
double d_iginrec_d_tnomin;
double d_iginrec_d_w;
double d_iginrec_d_ngf;
double d_iginrec_d_ijin;
double d_iginrec_d_kbdgatein;
double d_iginrec_d_vgsatqin;
double d_iginrec_d_betarecin;
double d_iginrec_d_irecin;
double d_iginrec_d_pgsrecin;
double d_iginrec_d_pg_param1;
double d_iginrec_d_vjg;
double d_iginrec_d_type;
double expbdarg1;
double d_expbdarg1_d_vgin;
double d_expbdarg1_d_phitin;
double d_expbdarg1_d_vgsatin;
double d_expbdarg1_d_alphagin;
double d_expbdarg1_d_fracin;
double d_expbdarg1_d_pg_paramin;
double d_expbdarg1_d_pbdgin;
double d_expbdarg1_d_vbdgin;
double d_expbdarg1_d_tambin;
double d_expbdarg1_d_tnomin;
double d_expbdarg1_d_w;
double d_expbdarg1_d_ngf;
double d_expbdarg1_d_ijin;
double d_expbdarg1_d_kbdgatein;
double d_expbdarg1_d_vgsatqin;
double d_expbdarg1_d_betarecin;
double d_expbdarg1_d_irecin;
double d_expbdarg1_d_pgsrecin;
double d_expbdarg1_d_pg_param1;
double d_expbdarg1_d_vjg;
double d_expbdarg1_d_type;
double expbdarg2;
double d_expbdarg2_d_vgin;
double d_expbdarg2_d_phitin;
double d_expbdarg2_d_vgsatin;
double d_expbdarg2_d_alphagin;
double d_expbdarg2_d_fracin;
double d_expbdarg2_d_pg_paramin;
double d_expbdarg2_d_pbdgin;
double d_expbdarg2_d_vbdgin;
double d_expbdarg2_d_tambin;
double d_expbdarg2_d_tnomin;
double d_expbdarg2_d_w;
double d_expbdarg2_d_ngf;
double d_expbdarg2_d_ijin;
double d_expbdarg2_d_kbdgatein;
double d_expbdarg2_d_vgsatqin;
double d_expbdarg2_d_betarecin;
double d_expbdarg2_d_irecin;
double d_expbdarg2_d_pgsrecin;
double d_expbdarg2_d_pg_param1;
double d_expbdarg2_d_vjg;
double d_expbdarg2_d_type;
double expbd1;
double d_expbd1_d_vgin;
double d_expbd1_d_phitin;
double d_expbd1_d_vgsatin;
double d_expbd1_d_alphagin;
double d_expbd1_d_fracin;
double d_expbd1_d_pg_paramin;
double d_expbd1_d_pbdgin;
double d_expbd1_d_vbdgin;
double d_expbd1_d_tambin;
double d_expbd1_d_tnomin;
double d_expbd1_d_w;
double d_expbd1_d_ngf;
double d_expbd1_d_ijin;
double d_expbd1_d_kbdgatein;
double d_expbd1_d_vgsatqin;
double d_expbd1_d_betarecin;
double d_expbd1_d_irecin;
double d_expbd1_d_pgsrecin;
double d_expbd1_d_pg_param1;
double d_expbd1_d_vjg;
double d_expbd1_d_type;
double expbd2;
double d_expbd2_d_vgin;
double d_expbd2_d_phitin;
double d_expbd2_d_vgsatin;
double d_expbd2_d_alphagin;
double d_expbd2_d_fracin;
double d_expbd2_d_pg_paramin;
double d_expbd2_d_pbdgin;
double d_expbd2_d_vbdgin;
double d_expbd2_d_tambin;
double d_expbd2_d_tnomin;
double d_expbd2_d_w;
double d_expbd2_d_ngf;
double d_expbd2_d_ijin;
double d_expbd2_d_kbdgatein;
double d_expbd2_d_vgsatqin;
double d_expbd2_d_betarecin;
double d_expbd2_d_irecin;
double d_expbd2_d_pgsrecin;
double d_expbd2_d_pg_param1;
double d_expbd2_d_vjg;
double d_expbd2_d_type;
double expphib;
double d_expphib_d_vgin;
double d_expphib_d_phitin;
double d_expphib_d_vgsatin;
double d_expphib_d_alphagin;
double d_expphib_d_fracin;
double d_expphib_d_pg_paramin;
double d_expphib_d_pbdgin;
double d_expphib_d_vbdgin;
double d_expphib_d_tambin;
double d_expphib_d_tnomin;
double d_expphib_d_w;
double d_expphib_d_ngf;
double d_expphib_d_ijin;
double d_expphib_d_kbdgatein;
double d_expphib_d_vgsatqin;
double d_expphib_d_betarecin;
double d_expphib_d_irecin;
double d_expphib_d_pgsrecin;
double d_expphib_d_pg_param1;
double d_expphib_d_vjg;
double d_expphib_d_type;
double expffvarg;
double d_expffvarg_d_vgin;
double d_expffvarg_d_phitin;
double d_expffvarg_d_vgsatin;
double d_expffvarg_d_alphagin;
double d_expffvarg_d_fracin;
double d_expffvarg_d_pg_paramin;
double d_expffvarg_d_pbdgin;
double d_expffvarg_d_vbdgin;
double d_expffvarg_d_tambin;
double d_expffvarg_d_tnomin;
double d_expffvarg_d_w;
double d_expffvarg_d_ngf;
double d_expffvarg_d_ijin;
double d_expffvarg_d_kbdgatein;
double d_expffvarg_d_vgsatqin;
double d_expffvarg_d_betarecin;
double d_expffvarg_d_irecin;
double d_expffvarg_d_pgsrecin;
double d_expffvarg_d_pg_param1;
double d_expffvarg_d_vjg;
double d_expffvarg_d_type;
double expiforarg;
double d_expiforarg_d_vgin;
double d_expiforarg_d_phitin;
double d_expiforarg_d_vgsatin;
double d_expiforarg_d_alphagin;
double d_expiforarg_d_fracin;
double d_expiforarg_d_pg_paramin;
double d_expiforarg_d_pbdgin;
double d_expiforarg_d_vbdgin;
double d_expiforarg_d_tambin;
double d_expiforarg_d_tnomin;
double d_expiforarg_d_w;
double d_expiforarg_d_ngf;
double d_expiforarg_d_ijin;
double d_expiforarg_d_kbdgatein;
double d_expiforarg_d_vgsatqin;
double d_expiforarg_d_betarecin;
double d_expiforarg_d_irecin;
double d_expiforarg_d_pgsrecin;
double d_expiforarg_d_pg_param1;
double d_expiforarg_d_vjg;
double d_expiforarg_d_type;
double expifor;
double d_expifor_d_vgin;
double d_expifor_d_phitin;
double d_expifor_d_vgsatin;
double d_expifor_d_alphagin;
double d_expifor_d_fracin;
double d_expifor_d_pg_paramin;
double d_expifor_d_pbdgin;
double d_expifor_d_vbdgin;
double d_expifor_d_tambin;
double d_expifor_d_tnomin;
double d_expifor_d_w;
double d_expifor_d_ngf;
double d_expifor_d_ijin;
double d_expifor_d_kbdgatein;
double d_expifor_d_vgsatqin;
double d_expifor_d_betarecin;
double d_expifor_d_irecin;
double d_expifor_d_pgsrecin;
double d_expifor_d_pg_param1;
double d_expifor_d_vjg;
double d_expifor_d_type;
double expirevarg;
double d_expirevarg_d_vgin;
double d_expirevarg_d_phitin;
double d_expirevarg_d_vgsatin;
double d_expirevarg_d_alphagin;
double d_expirevarg_d_fracin;
double d_expirevarg_d_pg_paramin;
double d_expirevarg_d_pbdgin;
double d_expirevarg_d_vbdgin;
double d_expirevarg_d_tambin;
double d_expirevarg_d_tnomin;
double d_expirevarg_d_w;
double d_expirevarg_d_ngf;
double d_expirevarg_d_ijin;
double d_expirevarg_d_kbdgatein;
double d_expirevarg_d_vgsatqin;
double d_expirevarg_d_betarecin;
double d_expirevarg_d_irecin;
double d_expirevarg_d_pgsrecin;
double d_expirevarg_d_pg_param1;
double d_expirevarg_d_vjg;
double d_expirevarg_d_type;
double expirev;
double d_expirev_d_vgin;
double d_expirev_d_phitin;
double d_expirev_d_vgsatin;
double d_expirev_d_alphagin;
double d_expirev_d_fracin;
double d_expirev_d_pg_paramin;
double d_expirev_d_pbdgin;
double d_expirev_d_vbdgin;
double d_expirev_d_tambin;
double d_expirev_d_tnomin;
double d_expirev_d_w;
double d_expirev_d_ngf;
double d_expirev_d_ijin;
double d_expirev_d_kbdgatein;
double d_expirev_d_vgsatqin;
double d_expirev_d_betarecin;
double d_expirev_d_irecin;
double d_expirev_d_pgsrecin;
double d_expirev_d_pg_param1;
double d_expirev_d_vjg;
double d_expirev_d_type;
{
d_alpha_phit_d_vgin=0.0;
d_alpha_phit_d_phitin=(alphagin);
d_alpha_phit_d_vgsatin=0.0;
d_alpha_phit_d_alphagin=(phitin);
d_alpha_phit_d_fracin=0.0;
d_alpha_phit_d_pg_paramin=0.0;
d_alpha_phit_d_pbdgin=0.0;
d_alpha_phit_d_vbdgin=0.0;
d_alpha_phit_d_tambin=0.0;
d_alpha_phit_d_tnomin=0.0;
d_alpha_phit_d_w=0.0;
d_alpha_phit_d_ngf=0.0;
d_alpha_phit_d_ijin=0.0;
d_alpha_phit_d_kbdgatein=0.0;
d_alpha_phit_d_vgsatqin=0.0;
d_alpha_phit_d_betarecin=0.0;
d_alpha_phit_d_irecin=0.0;
d_alpha_phit_d_pgsrecin=0.0;
d_alpha_phit_d_pg_param1=0.0;
d_alpha_phit_d_vjg=0.0;
d_alpha_phit_d_type=0.0;
alpha_phit=(alphagin*phitin);
d_expphib_d_vgin=0.0;
d_expphib_d_phitin=((-pg_param1/phitin/phitin)*(-vjg));
d_expphib_d_vgsatin=0.0;
d_expphib_d_alphagin=0.0;
d_expphib_d_fracin=0.0;
d_expphib_d_pg_paramin=0.0;
d_expphib_d_pbdgin=0.0;
d_expphib_d_vbdgin=0.0;
d_expphib_d_tambin=0.0;
d_expphib_d_tnomin=0.0;
d_expphib_d_w=0.0;
d_expphib_d_ngf=0.0;
d_expphib_d_ijin=0.0;
d_expphib_d_kbdgatein=0.0;
d_expphib_d_vgsatqin=0.0;
d_expphib_d_betarecin=0.0;
d_expphib_d_irecin=0.0;
d_expphib_d_pgsrecin=0.0;
d_expphib_d_pg_param1=((1.0/phitin)*(-vjg));
d_expphib_d_vjg=((pg_param1/phitin)*(-1.0));
d_expphib_d_type=0.0;
expphib=((pg_param1/phitin)*(-vjg));
d_t0_d_vgin=d_explim(expphib,d_expphib_d_vgin);
d_t0_d_phitin=d_explim(expphib,d_expphib_d_phitin);
d_t0_d_vgsatin=d_explim(expphib,d_expphib_d_vgsatin);
d_t0_d_alphagin=d_explim(expphib,d_expphib_d_alphagin);
d_t0_d_fracin=d_explim(expphib,d_expphib_d_fracin);
d_t0_d_pg_paramin=d_explim(expphib,d_expphib_d_pg_paramin);
d_t0_d_pbdgin=d_explim(expphib,d_expphib_d_pbdgin);
d_t0_d_vbdgin=d_explim(expphib,d_expphib_d_vbdgin);
d_t0_d_tambin=d_explim(expphib,d_expphib_d_tambin);
d_t0_d_tnomin=d_explim(expphib,d_expphib_d_tnomin);
d_t0_d_w=d_explim(expphib,d_expphib_d_w);
d_t0_d_ngf=d_explim(expphib,d_expphib_d_ngf);
d_t0_d_ijin=d_explim(expphib,d_expphib_d_ijin);
d_t0_d_kbdgatein=d_explim(expphib,d_expphib_d_kbdgatein);
d_t0_d_vgsatqin=d_explim(expphib,d_expphib_d_vgsatqin);
d_t0_d_betarecin=d_explim(expphib,d_expphib_d_betarecin);
d_t0_d_irecin=d_explim(expphib,d_expphib_d_irecin);
d_t0_d_pgsrecin=d_explim(expphib,d_expphib_d_pgsrecin);
d_t0_d_pg_param1=d_explim(expphib,d_expphib_d_pg_param1);
d_t0_d_vjg=d_explim(expphib,d_expphib_d_vjg);
d_t0_d_type=d_explim(expphib,d_expphib_d_type);
t0=explim(expphib);
d_expffvarg_d_vgin=(((alphagin*alpha_phit)*(1.0-(-((alphagin*d_alpha_phit_d_vgin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vgin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_phitin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_phitin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_phitin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vgsatin=(((alphagin*alpha_phit)*(-(1.0-((alphagin*d_alpha_phit_d_vgsatin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vgsatin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_alphagin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_alphagin+alpha_phit)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_alphagin+alpha_phit))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_fracin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_fracin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_fracin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pg_paramin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pg_paramin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pg_paramin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pbdgin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pbdgin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pbdgin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vbdgin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_vbdgin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vbdgin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_tambin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_tambin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_tambin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_tnomin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_tnomin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_tnomin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_w=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_w)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_w))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_ngf=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_ngf)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_ngf))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_ijin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_ijin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_ijin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_kbdgatein=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_kbdgatein)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_kbdgatein))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vgsatqin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_vgsatqin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vgsatqin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_betarecin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_betarecin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_betarecin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_irecin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_irecin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_irecin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pgsrecin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pgsrecin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pgsrecin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pg_param1=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pg_param1)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pg_param1))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vjg=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_vjg)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vjg))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_type=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_type)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_type))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
expffvarg=((vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))/(alphagin*alpha_phit));
if((expffvarg>50.0))
{
d_ffvgin_d_vgin=0.0;
d_ffvgin_d_phitin=0.0;
d_ffvgin_d_vgsatin=0.0;
d_ffvgin_d_alphagin=0.0;
d_ffvgin_d_fracin=0.0;
d_ffvgin_d_pg_paramin=0.0;
d_ffvgin_d_pbdgin=0.0;
d_ffvgin_d_vbdgin=0.0;
d_ffvgin_d_tambin=0.0;
d_ffvgin_d_tnomin=0.0;
d_ffvgin_d_w=0.0;
d_ffvgin_d_ngf=0.0;
d_ffvgin_d_ijin=0.0;
d_ffvgin_d_kbdgatein=0.0;
d_ffvgin_d_vgsatqin=0.0;
d_ffvgin_d_betarecin=0.0;
d_ffvgin_d_irecin=0.0;
d_ffvgin_d_pgsrecin=0.0;
d_ffvgin_d_pg_param1=0.0;
d_ffvgin_d_vjg=0.0;
d_ffvgin_d_type=0.0;
ffvgin=0.0;
}
else
{
if((expffvarg<(-50.0)))
{
d_ffvgin_d_vgin=0.0;
d_ffvgin_d_phitin=0.0;
d_ffvgin_d_vgsatin=0.0;
d_ffvgin_d_alphagin=0.0;
d_ffvgin_d_fracin=0.0;
d_ffvgin_d_pg_paramin=0.0;
d_ffvgin_d_pbdgin=0.0;
d_ffvgin_d_vbdgin=0.0;
d_ffvgin_d_tambin=0.0;
d_ffvgin_d_tnomin=0.0;
d_ffvgin_d_w=0.0;
d_ffvgin_d_ngf=0.0;
d_ffvgin_d_ijin=0.0;
d_ffvgin_d_kbdgatein=0.0;
d_ffvgin_d_vgsatqin=0.0;
d_ffvgin_d_betarecin=0.0;
d_ffvgin_d_irecin=0.0;
d_ffvgin_d_pgsrecin=0.0;
d_ffvgin_d_pg_param1=0.0;
d_ffvgin_d_vjg=0.0;
d_ffvgin_d_type=0.0;
ffvgin=1.0;
}
else
{
d_ffvgin_d_vgin=(-exp(expffvarg)*d_expffvarg_d_vgin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_phitin=(-exp(expffvarg)*d_expffvarg_d_phitin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vgsatin=(-exp(expffvarg)*d_expffvarg_d_vgsatin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_alphagin=(-exp(expffvarg)*d_expffvarg_d_alphagin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_fracin=(-exp(expffvarg)*d_expffvarg_d_fracin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pg_paramin=(-exp(expffvarg)*d_expffvarg_d_pg_paramin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pbdgin=(-exp(expffvarg)*d_expffvarg_d_pbdgin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vbdgin=(-exp(expffvarg)*d_expffvarg_d_vbdgin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_tambin=(-exp(expffvarg)*d_expffvarg_d_tambin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_tnomin=(-exp(expffvarg)*d_expffvarg_d_tnomin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_w=(-exp(expffvarg)*d_expffvarg_d_w/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_ngf=(-exp(expffvarg)*d_expffvarg_d_ngf/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_ijin=(-exp(expffvarg)*d_expffvarg_d_ijin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_kbdgatein=(-exp(expffvarg)*d_expffvarg_d_kbdgatein/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vgsatqin=(-exp(expffvarg)*d_expffvarg_d_vgsatqin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_betarecin=(-exp(expffvarg)*d_expffvarg_d_betarecin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_irecin=(-exp(expffvarg)*d_expffvarg_d_irecin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pgsrecin=(-exp(expffvarg)*d_expffvarg_d_pgsrecin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pg_param1=(-exp(expffvarg)*d_expffvarg_d_pg_param1/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vjg=(-exp(expffvarg)*d_expffvarg_d_vjg/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_type=(-exp(expffvarg)*d_expffvarg_d_type/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
ffvgin=(1.0/(1.0+exp(expffvarg)));
}
}
d_pgin_d_vgin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vgin);
d_pgin_d_phitin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_phitin);
d_pgin_d_vgsatin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vgsatin);
d_pgin_d_alphagin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_alphagin);
d_pgin_d_fracin=((pg_paramin)+((((1.0-fracin)*pg_paramin)*d_ffvgin_d_fracin)+(((-1.0)*pg_paramin)*ffvgin)));
d_pgin_d_pg_paramin=((fracin)+((((1.0-fracin)*pg_paramin)*d_ffvgin_d_pg_paramin)+(((1.0-fracin))*ffvgin)));
d_pgin_d_pbdgin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_pbdgin);
d_pgin_d_vbdgin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vbdgin);
d_pgin_d_tambin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_tambin);
d_pgin_d_tnomin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_tnomin);
d_pgin_d_w=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_w);
d_pgin_d_ngf=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_ngf);
d_pgin_d_ijin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_ijin);
d_pgin_d_kbdgatein=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_kbdgatein);
d_pgin_d_vgsatqin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vgsatqin);
d_pgin_d_betarecin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_betarecin);
d_pgin_d_irecin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_irecin);
d_pgin_d_pgsrecin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_pgsrecin);
d_pgin_d_pg_param1=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_pg_param1);
d_pgin_d_vjg=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vjg);
d_pgin_d_type=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_type);
pgin=((fracin*pg_paramin)+(((1.0-fracin)*pg_paramin)*ffvgin));
d_expbdarg1_d_vgin=((pbdgin*(-1.0))+d_expphib_d_vgin);
d_expbdarg1_d_phitin=d_expphib_d_phitin;
d_expbdarg1_d_vgsatin=d_expphib_d_vgsatin;
d_expbdarg1_d_alphagin=d_expphib_d_alphagin;
d_expbdarg1_d_fracin=d_expphib_d_fracin;
d_expbdarg1_d_pg_paramin=d_expphib_d_pg_paramin;
d_expbdarg1_d_pbdgin=((((-vgin)-vbdgin))+d_expphib_d_pbdgin);
d_expbdarg1_d_vbdgin=((pbdgin*(-1.0))+d_expphib_d_vbdgin);
d_expbdarg1_d_tambin=d_expphib_d_tambin;
d_expbdarg1_d_tnomin=d_expphib_d_tnomin;
d_expbdarg1_d_w=d_expphib_d_w;
d_expbdarg1_d_ngf=d_expphib_d_ngf;
d_expbdarg1_d_ijin=d_expphib_d_ijin;
d_expbdarg1_d_kbdgatein=d_expphib_d_kbdgatein;
d_expbdarg1_d_vgsatqin=d_expphib_d_vgsatqin;
d_expbdarg1_d_betarecin=d_expphib_d_betarecin;
d_expbdarg1_d_irecin=d_expphib_d_irecin;
d_expbdarg1_d_pgsrecin=d_expphib_d_pgsrecin;
d_expbdarg1_d_pg_param1=d_expphib_d_pg_param1;
d_expbdarg1_d_vjg=d_expphib_d_vjg;
d_expbdarg1_d_type=d_expphib_d_type;
expbdarg1=((pbdgin*((-vgin)-vbdgin))+expphib);
d_expbdarg2_d_vgin=d_expphib_d_vgin;
d_expbdarg2_d_phitin=d_expphib_d_phitin;
d_expbdarg2_d_vgsatin=d_expphib_d_vgsatin;
d_expbdarg2_d_alphagin=d_expphib_d_alphagin;
d_expbdarg2_d_fracin=d_expphib_d_fracin;
d_expbdarg2_d_pg_paramin=d_expphib_d_pg_paramin;
d_expbdarg2_d_pbdgin=(((-1.0)*vbdgin)+d_expphib_d_pbdgin);
d_expbdarg2_d_vbdgin=(((-pbdgin))+d_expphib_d_vbdgin);
d_expbdarg2_d_tambin=d_expphib_d_tambin;
d_expbdarg2_d_tnomin=d_expphib_d_tnomin;
d_expbdarg2_d_w=d_expphib_d_w;
d_expbdarg2_d_ngf=d_expphib_d_ngf;
d_expbdarg2_d_ijin=d_expphib_d_ijin;
d_expbdarg2_d_kbdgatein=d_expphib_d_kbdgatein;
d_expbdarg2_d_vgsatqin=d_expphib_d_vgsatqin;
d_expbdarg2_d_betarecin=d_expphib_d_betarecin;
d_expbdarg2_d_irecin=d_expphib_d_irecin;
d_expbdarg2_d_pgsrecin=d_expphib_d_pgsrecin;
d_expbdarg2_d_pg_param1=d_expphib_d_pg_param1;
d_expbdarg2_d_vjg=d_expphib_d_vjg;
d_expbdarg2_d_type=d_expphib_d_type;
expbdarg2=(((-pbdgin)*vbdgin)+expphib);
d_expbd1_d_vgin=d_explim(expbdarg1,d_expbdarg1_d_vgin);
d_expbd1_d_phitin=d_explim(expbdarg1,d_expbdarg1_d_phitin);
d_expbd1_d_vgsatin=d_explim(expbdarg1,d_expbdarg1_d_vgsatin);
d_expbd1_d_alphagin=d_explim(expbdarg1,d_expbdarg1_d_alphagin);
d_expbd1_d_fracin=d_explim(expbdarg1,d_expbdarg1_d_fracin);
d_expbd1_d_pg_paramin=d_explim(expbdarg1,d_expbdarg1_d_pg_paramin);
d_expbd1_d_pbdgin=d_explim(expbdarg1,d_expbdarg1_d_pbdgin);
d_expbd1_d_vbdgin=d_explim(expbdarg1,d_expbdarg1_d_vbdgin);
d_expbd1_d_tambin=d_explim(expbdarg1,d_expbdarg1_d_tambin);
d_expbd1_d_tnomin=d_explim(expbdarg1,d_expbdarg1_d_tnomin);
d_expbd1_d_w=d_explim(expbdarg1,d_expbdarg1_d_w);
d_expbd1_d_ngf=d_explim(expbdarg1,d_expbdarg1_d_ngf);
d_expbd1_d_ijin=d_explim(expbdarg1,d_expbdarg1_d_ijin);
d_expbd1_d_kbdgatein=d_explim(expbdarg1,d_expbdarg1_d_kbdgatein);
d_expbd1_d_vgsatqin=d_explim(expbdarg1,d_expbdarg1_d_vgsatqin);
d_expbd1_d_betarecin=d_explim(expbdarg1,d_expbdarg1_d_betarecin);
d_expbd1_d_irecin=d_explim(expbdarg1,d_expbdarg1_d_irecin);
d_expbd1_d_pgsrecin=d_explim(expbdarg1,d_expbdarg1_d_pgsrecin);
d_expbd1_d_pg_param1=d_explim(expbdarg1,d_expbdarg1_d_pg_param1);
d_expbd1_d_vjg=d_explim(expbdarg1,d_expbdarg1_d_vjg);
d_expbd1_d_type=d_explim(expbdarg1,d_expbdarg1_d_type);
expbd1=explim(expbdarg1);
d_expbd2_d_vgin=d_explim(expbdarg2,d_expbdarg2_d_vgin);
d_expbd2_d_phitin=d_explim(expbdarg2,d_expbdarg2_d_phitin);
d_expbd2_d_vgsatin=d_explim(expbdarg2,d_expbdarg2_d_vgsatin);
d_expbd2_d_alphagin=d_explim(expbdarg2,d_expbdarg2_d_alphagin);
d_expbd2_d_fracin=d_explim(expbdarg2,d_expbdarg2_d_fracin);
d_expbd2_d_pg_paramin=d_explim(expbdarg2,d_expbdarg2_d_pg_paramin);
d_expbd2_d_pbdgin=d_explim(expbdarg2,d_expbdarg2_d_pbdgin);
d_expbd2_d_vbdgin=d_explim(expbdarg2,d_expbdarg2_d_vbdgin);
d_expbd2_d_tambin=d_explim(expbdarg2,d_expbdarg2_d_tambin);
d_expbd2_d_tnomin=d_explim(expbdarg2,d_expbdarg2_d_tnomin);
d_expbd2_d_w=d_explim(expbdarg2,d_expbdarg2_d_w);
d_expbd2_d_ngf=d_explim(expbdarg2,d_expbdarg2_d_ngf);
d_expbd2_d_ijin=d_explim(expbdarg2,d_expbdarg2_d_ijin);
d_expbd2_d_kbdgatein=d_explim(expbdarg2,d_expbdarg2_d_kbdgatein);
d_expbd2_d_vgsatqin=d_explim(expbdarg2,d_expbdarg2_d_vgsatqin);
d_expbd2_d_betarecin=d_explim(expbdarg2,d_expbdarg2_d_betarecin);
d_expbd2_d_irecin=d_explim(expbdarg2,d_expbdarg2_d_irecin);
d_expbd2_d_pgsrecin=d_explim(expbdarg2,d_expbdarg2_d_pgsrecin);
d_expbd2_d_pg_param1=d_explim(expbdarg2,d_expbdarg2_d_pg_param1);
d_expbd2_d_vjg=d_explim(expbdarg2,d_expbdarg2_d_vjg);
d_expbd2_d_type=d_explim(expbdarg2,d_expbdarg2_d_type);
expbd2=explim(expbdarg2);
d_iginbd_d_vgin=(d_expbd1_d_vgin-d_expbd2_d_vgin);
d_iginbd_d_phitin=(d_expbd1_d_phitin-d_expbd2_d_phitin);
d_iginbd_d_vgsatin=(d_expbd1_d_vgsatin-d_expbd2_d_vgsatin);
d_iginbd_d_alphagin=(d_expbd1_d_alphagin-d_expbd2_d_alphagin);
d_iginbd_d_fracin=(d_expbd1_d_fracin-d_expbd2_d_fracin);
d_iginbd_d_pg_paramin=(d_expbd1_d_pg_paramin-d_expbd2_d_pg_paramin);
d_iginbd_d_pbdgin=(d_expbd1_d_pbdgin-d_expbd2_d_pbdgin);
d_iginbd_d_vbdgin=(d_expbd1_d_vbdgin-d_expbd2_d_vbdgin);
d_iginbd_d_tambin=(d_expbd1_d_tambin-d_expbd2_d_tambin);
d_iginbd_d_tnomin=(d_expbd1_d_tnomin-d_expbd2_d_tnomin);
d_iginbd_d_w=(d_expbd1_d_w-d_expbd2_d_w);
d_iginbd_d_ngf=(d_expbd1_d_ngf-d_expbd2_d_ngf);
d_iginbd_d_ijin=(d_expbd1_d_ijin-d_expbd2_d_ijin);
d_iginbd_d_kbdgatein=(d_expbd1_d_kbdgatein-d_expbd2_d_kbdgatein);
d_iginbd_d_vgsatqin=(d_expbd1_d_vgsatqin-d_expbd2_d_vgsatqin);
d_iginbd_d_betarecin=(d_expbd1_d_betarecin-d_expbd2_d_betarecin);
d_iginbd_d_irecin=(d_expbd1_d_irecin-d_expbd2_d_irecin);
d_iginbd_d_pgsrecin=(d_expbd1_d_pgsrecin-d_expbd2_d_pgsrecin);
d_iginbd_d_pg_param1=(d_expbd1_d_pg_param1-d_expbd2_d_pg_param1);
d_iginbd_d_vjg=(d_expbd1_d_vjg-d_expbd2_d_vjg);
d_iginbd_d_type=(d_expbd1_d_type-d_expbd2_d_type);
iginbd=(expbd1-expbd2);
d_tfacdiode_d_vgin=0.0;
d_tfacdiode_d_phitin=0.0;
d_tfacdiode_d_vgsatin=0.0;
d_tfacdiode_d_alphagin=0.0;
d_tfacdiode_d_fracin=0.0;
d_tfacdiode_d_pg_paramin=0.0;
d_tfacdiode_d_pbdgin=0.0;
d_tfacdiode_d_vbdgin=0.0;
d_tfacdiode_d_tambin=(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),3.0)*3.0/(tambin/tnomin)))*(1.0/tnomin);
d_tfacdiode_d_tnomin=(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),3.0)*3.0/(tambin/tnomin)))*(-tambin/tnomin/tnomin);
d_tfacdiode_d_w=0.0;
d_tfacdiode_d_ngf=0.0;
d_tfacdiode_d_ijin=0.0;
d_tfacdiode_d_kbdgatein=0.0;
d_tfacdiode_d_vgsatqin=0.0;
d_tfacdiode_d_betarecin=0.0;
d_tfacdiode_d_irecin=0.0;
d_tfacdiode_d_pgsrecin=0.0;
d_tfacdiode_d_pg_param1=0.0;
d_tfacdiode_d_vjg=0.0;
d_tfacdiode_d_type=0.0;
tfacdiode=pow((tambin/tnomin),3.0);
d_isdiodeout_d_vgin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vgin);
d_isdiodeout_d_phitin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_phitin);
d_isdiodeout_d_vgsatin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vgsatin);
d_isdiodeout_d_alphagin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_alphagin);
d_isdiodeout_d_fracin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_fracin);
d_isdiodeout_d_pg_paramin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pg_paramin);
d_isdiodeout_d_pbdgin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pbdgin);
d_isdiodeout_d_vbdgin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vbdgin);
d_isdiodeout_d_tambin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_tambin);
d_isdiodeout_d_tnomin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_tnomin);
d_isdiodeout_d_w=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_w)+((((type)*ngf)*ijin)*tfacdiode));
d_isdiodeout_d_ngf=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_ngf)+((((type*w))*ijin)*tfacdiode));
d_isdiodeout_d_ijin=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_ijin)+((((type*w)*ngf))*tfacdiode));
d_isdiodeout_d_kbdgatein=((((type*w)*ngf)*ijin)*d_tfacdiode_d_kbdgatein);
d_isdiodeout_d_vgsatqin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vgsatqin);
d_isdiodeout_d_betarecin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_betarecin);
d_isdiodeout_d_irecin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_irecin);
d_isdiodeout_d_pgsrecin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pgsrecin);
d_isdiodeout_d_pg_param1=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pg_param1);
d_isdiodeout_d_vjg=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vjg);
d_isdiodeout_d_type=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_type)+((((w)*ngf)*ijin)*tfacdiode));
isdiodeout=((((type*w)*ngf)*ijin)*tfacdiode);
d_expiforarg_d_vgin=(((pgin/phitin)+vgin*(d_pgin_d_vgin/phitin))+d_expphib_d_vgin);
d_expiforarg_d_phitin=((((phitin*d_pgin_d_phitin-pgin)/phitin/phitin)*vgin)+d_expphib_d_phitin);
d_expiforarg_d_vgsatin=(((d_pgin_d_vgsatin/phitin)*vgin)+d_expphib_d_vgsatin);
d_expiforarg_d_alphagin=(((d_pgin_d_alphagin/phitin)*vgin)+d_expphib_d_alphagin);
d_expiforarg_d_fracin=(((d_pgin_d_fracin/phitin)*vgin)+d_expphib_d_fracin);
d_expiforarg_d_pg_paramin=(((d_pgin_d_pg_paramin/phitin)*vgin)+d_expphib_d_pg_paramin);
d_expiforarg_d_pbdgin=(((d_pgin_d_pbdgin/phitin)*vgin)+d_expphib_d_pbdgin);
d_expiforarg_d_vbdgin=(((d_pgin_d_vbdgin/phitin)*vgin)+d_expphib_d_vbdgin);
d_expiforarg_d_tambin=(((d_pgin_d_tambin/phitin)*vgin)+d_expphib_d_tambin);
d_expiforarg_d_tnomin=(((d_pgin_d_tnomin/phitin)*vgin)+d_expphib_d_tnomin);
d_expiforarg_d_w=(((d_pgin_d_w/phitin)*vgin)+d_expphib_d_w);
d_expiforarg_d_ngf=(((d_pgin_d_ngf/phitin)*vgin)+d_expphib_d_ngf);
d_expiforarg_d_ijin=(((d_pgin_d_ijin/phitin)*vgin)+d_expphib_d_ijin);
d_expiforarg_d_kbdgatein=(((d_pgin_d_kbdgatein/phitin)*vgin)+d_expphib_d_kbdgatein);
d_expiforarg_d_vgsatqin=(((d_pgin_d_vgsatqin/phitin)*vgin)+d_expphib_d_vgsatqin);
d_expiforarg_d_betarecin=(((d_pgin_d_betarecin/phitin)*vgin)+d_expphib_d_betarecin);
d_expiforarg_d_irecin=(((d_pgin_d_irecin/phitin)*vgin)+d_expphib_d_irecin);
d_expiforarg_d_pgsrecin=(((d_pgin_d_pgsrecin/phitin)*vgin)+d_expphib_d_pgsrecin);
d_expiforarg_d_pg_param1=(((d_pgin_d_pg_param1/phitin)*vgin)+d_expphib_d_pg_param1);
d_expiforarg_d_vjg=(((d_pgin_d_vjg/phitin)*vgin)+d_expphib_d_vjg);
d_expiforarg_d_type=(((d_pgin_d_type/phitin)*vgin)+d_expphib_d_type);
expiforarg=(((pgin/phitin)*vgin)+expphib);
d_expifor_d_vgin=d_explim(expiforarg,d_expiforarg_d_vgin);
d_expifor_d_phitin=d_explim(expiforarg,d_expiforarg_d_phitin);
d_expifor_d_vgsatin=d_explim(expiforarg,d_expiforarg_d_vgsatin);
d_expifor_d_alphagin=d_explim(expiforarg,d_expiforarg_d_alphagin);
d_expifor_d_fracin=d_explim(expiforarg,d_expiforarg_d_fracin);
d_expifor_d_pg_paramin=d_explim(expiforarg,d_expiforarg_d_pg_paramin);
d_expifor_d_pbdgin=d_explim(expiforarg,d_expiforarg_d_pbdgin);
d_expifor_d_vbdgin=d_explim(expiforarg,d_expiforarg_d_vbdgin);
d_expifor_d_tambin=d_explim(expiforarg,d_expiforarg_d_tambin);
d_expifor_d_tnomin=d_explim(expiforarg,d_expiforarg_d_tnomin);
d_expifor_d_w=d_explim(expiforarg,d_expiforarg_d_w);
d_expifor_d_ngf=d_explim(expiforarg,d_expiforarg_d_ngf);
d_expifor_d_ijin=d_explim(expiforarg,d_expiforarg_d_ijin);
d_expifor_d_kbdgatein=d_explim(expiforarg,d_expiforarg_d_kbdgatein);
d_expifor_d_vgsatqin=d_explim(expiforarg,d_expiforarg_d_vgsatqin);
d_expifor_d_betarecin=d_explim(expiforarg,d_expiforarg_d_betarecin);
d_expifor_d_irecin=d_explim(expiforarg,d_expiforarg_d_irecin);
d_expifor_d_pgsrecin=d_explim(expiforarg,d_expiforarg_d_pgsrecin);
d_expifor_d_pg_param1=d_explim(expiforarg,d_expiforarg_d_pg_param1);
d_expifor_d_vjg=d_explim(expiforarg,d_expiforarg_d_vjg);
d_expifor_d_type=d_explim(expiforarg,d_expiforarg_d_type);
expifor=explim(expiforarg);
d_igindiode_d_vgin=((isdiodeout*((d_expifor_d_vgin-(kbdgatein*d_iginbd_d_vgin))-d_t0_d_vgin))+(d_isdiodeout_d_vgin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_phitin=((isdiodeout*((d_expifor_d_phitin-(kbdgatein*d_iginbd_d_phitin))-d_t0_d_phitin))+(d_isdiodeout_d_phitin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vgsatin=((isdiodeout*((d_expifor_d_vgsatin-(kbdgatein*d_iginbd_d_vgsatin))-d_t0_d_vgsatin))+(d_isdiodeout_d_vgsatin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_alphagin=((isdiodeout*((d_expifor_d_alphagin-(kbdgatein*d_iginbd_d_alphagin))-d_t0_d_alphagin))+(d_isdiodeout_d_alphagin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_fracin=((isdiodeout*((d_expifor_d_fracin-(kbdgatein*d_iginbd_d_fracin))-d_t0_d_fracin))+(d_isdiodeout_d_fracin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pg_paramin=((isdiodeout*((d_expifor_d_pg_paramin-(kbdgatein*d_iginbd_d_pg_paramin))-d_t0_d_pg_paramin))+(d_isdiodeout_d_pg_paramin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pbdgin=((isdiodeout*((d_expifor_d_pbdgin-(kbdgatein*d_iginbd_d_pbdgin))-d_t0_d_pbdgin))+(d_isdiodeout_d_pbdgin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vbdgin=((isdiodeout*((d_expifor_d_vbdgin-(kbdgatein*d_iginbd_d_vbdgin))-d_t0_d_vbdgin))+(d_isdiodeout_d_vbdgin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_tambin=((isdiodeout*((d_expifor_d_tambin-(kbdgatein*d_iginbd_d_tambin))-d_t0_d_tambin))+(d_isdiodeout_d_tambin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_tnomin=((isdiodeout*((d_expifor_d_tnomin-(kbdgatein*d_iginbd_d_tnomin))-d_t0_d_tnomin))+(d_isdiodeout_d_tnomin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_w=((isdiodeout*((d_expifor_d_w-(kbdgatein*d_iginbd_d_w))-d_t0_d_w))+(d_isdiodeout_d_w*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_ngf=((isdiodeout*((d_expifor_d_ngf-(kbdgatein*d_iginbd_d_ngf))-d_t0_d_ngf))+(d_isdiodeout_d_ngf*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_ijin=((isdiodeout*((d_expifor_d_ijin-(kbdgatein*d_iginbd_d_ijin))-d_t0_d_ijin))+(d_isdiodeout_d_ijin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_kbdgatein=((isdiodeout*((d_expifor_d_kbdgatein-(kbdgatein*d_iginbd_d_kbdgatein+iginbd))-d_t0_d_kbdgatein))+(d_isdiodeout_d_kbdgatein*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vgsatqin=((isdiodeout*((d_expifor_d_vgsatqin-(kbdgatein*d_iginbd_d_vgsatqin))-d_t0_d_vgsatqin))+(d_isdiodeout_d_vgsatqin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_betarecin=((isdiodeout*((d_expifor_d_betarecin-(kbdgatein*d_iginbd_d_betarecin))-d_t0_d_betarecin))+(d_isdiodeout_d_betarecin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_irecin=((isdiodeout*((d_expifor_d_irecin-(kbdgatein*d_iginbd_d_irecin))-d_t0_d_irecin))+(d_isdiodeout_d_irecin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pgsrecin=((isdiodeout*((d_expifor_d_pgsrecin-(kbdgatein*d_iginbd_d_pgsrecin))-d_t0_d_pgsrecin))+(d_isdiodeout_d_pgsrecin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pg_param1=((isdiodeout*((d_expifor_d_pg_param1-(kbdgatein*d_iginbd_d_pg_param1))-d_t0_d_pg_param1))+(d_isdiodeout_d_pg_param1*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vjg=((isdiodeout*((d_expifor_d_vjg-(kbdgatein*d_iginbd_d_vjg))-d_t0_d_vjg))+(d_isdiodeout_d_vjg*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_type=((isdiodeout*((d_expifor_d_type-(kbdgatein*d_iginbd_d_type))-d_t0_d_type))+(d_isdiodeout_d_type*((expifor-(kbdgatein*iginbd))-t0)));
igindiode=(isdiodeout*((expifor-(kbdgatein*iginbd))-t0));
d_frecgin_d_vgin=((pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(-1.0)-(-vgin)*(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(1.0/betarecin)/(1.0+pow(absfunc((vgin/vgsatqin)),betarecin))))*((absfunc((vgin/vgsatqin))==0.0)?0.0:(pow(absfunc((vgin/vgsatqin)),betarecin)*betarecin/absfunc((vgin/vgsatqin))))*d_absfunc((vgin/vgsatqin),(1.0/vgsatqin)))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_frecgin_d_phitin=0.0;
d_frecgin_d_vgsatin=0.0;
d_frecgin_d_alphagin=0.0;
d_frecgin_d_fracin=0.0;
d_frecgin_d_pg_paramin=0.0;
d_frecgin_d_pbdgin=0.0;
d_frecgin_d_vbdgin=0.0;
d_frecgin_d_tambin=0.0;
d_frecgin_d_tnomin=0.0;
d_frecgin_d_w=0.0;
d_frecgin_d_ngf=0.0;
d_frecgin_d_ijin=0.0;
d_frecgin_d_kbdgatein=0.0;
d_frecgin_d_vgsatqin=(-(-vgin)*(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(1.0/betarecin)/(1.0+pow(absfunc((vgin/vgsatqin)),betarecin))))*((absfunc((vgin/vgsatqin))==0.0)?0.0:(pow(absfunc((vgin/vgsatqin)),betarecin)*betarecin/absfunc((vgin/vgsatqin))))*d_absfunc((vgin/vgsatqin),(-vgin/vgsatqin/vgsatqin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_frecgin_d_betarecin=(-(-vgin)*(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(1.0/betarecin)/(1.0+pow(absfunc((vgin/vgsatqin)),betarecin))))*((absfunc((vgin/vgsatqin))==0.0)?0.0:(log(absfunc((vgin/vgsatqin))*pow(absfunc((vgin/vgsatqin)),betarecin))))+(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(log((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))*pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)))))*(-1.0/betarecin/betarecin)/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_frecgin_d_irecin=0.0;
d_frecgin_d_pgsrecin=0.0;
d_frecgin_d_pg_param1=0.0;
d_frecgin_d_vjg=0.0;
d_frecgin_d_type=0.0;
frecgin=((-vgin)/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_isrecout_d_vgin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vgin)*1.0);
d_isrecout_d_phitin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_phitin)*1.0);
d_isrecout_d_vgsatin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vgsatin)*1.0);
d_isrecout_d_alphagin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_alphagin)*1.0);
d_isrecout_d_fracin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_fracin)*1.0);
d_isrecout_d_pg_paramin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pg_paramin)*1.0);
d_isrecout_d_pbdgin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pbdgin)*1.0);
d_isrecout_d_vbdgin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vbdgin)*1.0);
d_isrecout_d_tambin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_tambin)*1.0);
d_isrecout_d_tnomin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_tnomin)*1.0);
d_isrecout_d_w=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_w)+(((((-type))*ngf)*irecin)*tfacdiode))*1.0);
d_isrecout_d_ngf=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_ngf)+(((((-type)*w))*irecin)*tfacdiode))*1.0);
d_isrecout_d_ijin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_ijin)*1.0);
d_isrecout_d_kbdgatein=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_kbdgatein)*1.0);
d_isrecout_d_vgsatqin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vgsatqin)*1.0);
d_isrecout_d_betarecin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_betarecin)*1.0);
d_isrecout_d_irecin=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_irecin)+(((((-type)*w)*ngf))*tfacdiode))*1.0);
d_isrecout_d_pgsrecin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pgsrecin)*1.0);
d_isrecout_d_pg_param1=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pg_param1)*1.0);
d_isrecout_d_vjg=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vjg)*1.0);
d_isrecout_d_type=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_type)+(((((-1.0)*w)*ngf)*irecin)*tfacdiode))*1.0);
isrecout=((((((-type)*w)*ngf)*irecin)*tfacdiode)*1.0);
d_expirevarg_d_vgin=((pgsrecin/phitin)*d_frecgin_d_vgin);
d_expirevarg_d_phitin=(((pgsrecin/phitin)*d_frecgin_d_phitin)+((-pgsrecin/phitin/phitin)*frecgin));
d_expirevarg_d_vgsatin=((pgsrecin/phitin)*d_frecgin_d_vgsatin);
d_expirevarg_d_alphagin=((pgsrecin/phitin)*d_frecgin_d_alphagin);
d_expirevarg_d_fracin=((pgsrecin/phitin)*d_frecgin_d_fracin);
d_expirevarg_d_pg_paramin=((pgsrecin/phitin)*d_frecgin_d_pg_paramin);
d_expirevarg_d_pbdgin=((pgsrecin/phitin)*d_frecgin_d_pbdgin);
d_expirevarg_d_vbdgin=((pgsrecin/phitin)*d_frecgin_d_vbdgin);
d_expirevarg_d_tambin=((pgsrecin/phitin)*d_frecgin_d_tambin);
d_expirevarg_d_tnomin=((pgsrecin/phitin)*d_frecgin_d_tnomin);
d_expirevarg_d_w=((pgsrecin/phitin)*d_frecgin_d_w);
d_expirevarg_d_ngf=((pgsrecin/phitin)*d_frecgin_d_ngf);
d_expirevarg_d_ijin=((pgsrecin/phitin)*d_frecgin_d_ijin);
d_expirevarg_d_kbdgatein=((pgsrecin/phitin)*d_frecgin_d_kbdgatein);
d_expirevarg_d_vgsatqin=((pgsrecin/phitin)*d_frecgin_d_vgsatqin);
d_expirevarg_d_betarecin=((pgsrecin/phitin)*d_frecgin_d_betarecin);
d_expirevarg_d_irecin=((pgsrecin/phitin)*d_frecgin_d_irecin);
d_expirevarg_d_pgsrecin=(((pgsrecin/phitin)*d_frecgin_d_pgsrecin)+((1.0/phitin)*frecgin));
d_expirevarg_d_pg_param1=((pgsrecin/phitin)*d_frecgin_d_pg_param1);
d_expirevarg_d_vjg=((pgsrecin/phitin)*d_frecgin_d_vjg);
d_expirevarg_d_type=((pgsrecin/phitin)*d_frecgin_d_type);
expirevarg=((pgsrecin/phitin)*frecgin);
d_expirev_d_vgin=d_explim(expirevarg,d_expirevarg_d_vgin);
d_expirev_d_phitin=d_explim(expirevarg,d_expirevarg_d_phitin);
d_expirev_d_vgsatin=d_explim(expirevarg,d_expirevarg_d_vgsatin);
d_expirev_d_alphagin=d_explim(expirevarg,d_expirevarg_d_alphagin);
d_expirev_d_fracin=d_explim(expirevarg,d_expirevarg_d_fracin);
d_expirev_d_pg_paramin=d_explim(expirevarg,d_expirevarg_d_pg_paramin);
d_expirev_d_pbdgin=d_explim(expirevarg,d_expirevarg_d_pbdgin);
d_expirev_d_vbdgin=d_explim(expirevarg,d_expirevarg_d_vbdgin);
d_expirev_d_tambin=d_explim(expirevarg,d_expirevarg_d_tambin);
d_expirev_d_tnomin=d_explim(expirevarg,d_expirevarg_d_tnomin);
d_expirev_d_w=d_explim(expirevarg,d_expirevarg_d_w);
d_expirev_d_ngf=d_explim(expirevarg,d_expirevarg_d_ngf);
d_expirev_d_ijin=d_explim(expirevarg,d_expirevarg_d_ijin);
d_expirev_d_kbdgatein=d_explim(expirevarg,d_expirevarg_d_kbdgatein);
d_expirev_d_vgsatqin=d_explim(expirevarg,d_expirevarg_d_vgsatqin);
d_expirev_d_betarecin=d_explim(expirevarg,d_expirevarg_d_betarecin);
d_expirev_d_irecin=d_explim(expirevarg,d_expirevarg_d_irecin);
d_expirev_d_pgsrecin=d_explim(expirevarg,d_expirevarg_d_pgsrecin);
d_expirev_d_pg_param1=d_explim(expirevarg,d_expirevarg_d_pg_param1);
d_expirev_d_vjg=d_explim(expirevarg,d_expirevarg_d_vjg);
d_expirev_d_type=d_explim(expirevarg,d_expirevarg_d_type);
expirev=explim(expirevarg);
d_iginrec_d_vgin=((isrecout*d_expirev_d_vgin)+(d_isrecout_d_vgin*(expirev-1.0)));
d_iginrec_d_phitin=((isrecout*d_expirev_d_phitin)+(d_isrecout_d_phitin*(expirev-1.0)));
d_iginrec_d_vgsatin=((isrecout*d_expirev_d_vgsatin)+(d_isrecout_d_vgsatin*(expirev-1.0)));
d_iginrec_d_alphagin=((isrecout*d_expirev_d_alphagin)+(d_isrecout_d_alphagin*(expirev-1.0)));
d_iginrec_d_fracin=((isrecout*d_expirev_d_fracin)+(d_isrecout_d_fracin*(expirev-1.0)));
d_iginrec_d_pg_paramin=((isrecout*d_expirev_d_pg_paramin)+(d_isrecout_d_pg_paramin*(expirev-1.0)));
d_iginrec_d_pbdgin=((isrecout*d_expirev_d_pbdgin)+(d_isrecout_d_pbdgin*(expirev-1.0)));
d_iginrec_d_vbdgin=((isrecout*d_expirev_d_vbdgin)+(d_isrecout_d_vbdgin*(expirev-1.0)));
d_iginrec_d_tambin=((isrecout*d_expirev_d_tambin)+(d_isrecout_d_tambin*(expirev-1.0)));
d_iginrec_d_tnomin=((isrecout*d_expirev_d_tnomin)+(d_isrecout_d_tnomin*(expirev-1.0)));
d_iginrec_d_w=((isrecout*d_expirev_d_w)+(d_isrecout_d_w*(expirev-1.0)));
d_iginrec_d_ngf=((isrecout*d_expirev_d_ngf)+(d_isrecout_d_ngf*(expirev-1.0)));
d_iginrec_d_ijin=((isrecout*d_expirev_d_ijin)+(d_isrecout_d_ijin*(expirev-1.0)));
d_iginrec_d_kbdgatein=((isrecout*d_expirev_d_kbdgatein)+(d_isrecout_d_kbdgatein*(expirev-1.0)));
d_iginrec_d_vgsatqin=((isrecout*d_expirev_d_vgsatqin)+(d_isrecout_d_vgsatqin*(expirev-1.0)));
d_iginrec_d_betarecin=((isrecout*d_expirev_d_betarecin)+(d_isrecout_d_betarecin*(expirev-1.0)));
d_iginrec_d_irecin=((isrecout*d_expirev_d_irecin)+(d_isrecout_d_irecin*(expirev-1.0)));
d_iginrec_d_pgsrecin=((isrecout*d_expirev_d_pgsrecin)+(d_isrecout_d_pgsrecin*(expirev-1.0)));
d_iginrec_d_pg_param1=((isrecout*d_expirev_d_pg_param1)+(d_isrecout_d_pg_param1*(expirev-1.0)));
d_iginrec_d_vjg=((isrecout*d_expirev_d_vjg)+(d_isrecout_d_vjg*(expirev-1.0)));
d_iginrec_d_type=((isrecout*d_expirev_d_type)+(d_isrecout_d_type*(expirev-1.0)));
iginrec=(isrecout*(expirev-1.0));
d_igout_d_vgin=(d_igindiode_d_vgin+d_iginrec_d_vgin);
d_igout_d_phitin=(d_igindiode_d_phitin+d_iginrec_d_phitin);
d_igout_d_vgsatin=(d_igindiode_d_vgsatin+d_iginrec_d_vgsatin);
d_igout_d_alphagin=(d_igindiode_d_alphagin+d_iginrec_d_alphagin);
d_igout_d_fracin=(d_igindiode_d_fracin+d_iginrec_d_fracin);
d_igout_d_pg_paramin=(d_igindiode_d_pg_paramin+d_iginrec_d_pg_paramin);
d_igout_d_pbdgin=(d_igindiode_d_pbdgin+d_iginrec_d_pbdgin);
d_igout_d_vbdgin=(d_igindiode_d_vbdgin+d_iginrec_d_vbdgin);
d_igout_d_tambin=(d_igindiode_d_tambin+d_iginrec_d_tambin);
d_igout_d_tnomin=(d_igindiode_d_tnomin+d_iginrec_d_tnomin);
d_igout_d_w=(d_igindiode_d_w+d_iginrec_d_w);
d_igout_d_ngf=(d_igindiode_d_ngf+d_iginrec_d_ngf);
d_igout_d_ijin=(d_igindiode_d_ijin+d_iginrec_d_ijin);
d_igout_d_kbdgatein=(d_igindiode_d_kbdgatein+d_iginrec_d_kbdgatein);
d_igout_d_vgsatqin=(d_igindiode_d_vgsatqin+d_iginrec_d_vgsatqin);
d_igout_d_betarecin=(d_igindiode_d_betarecin+d_iginrec_d_betarecin);
d_igout_d_irecin=(d_igindiode_d_irecin+d_iginrec_d_irecin);
d_igout_d_pgsrecin=(d_igindiode_d_pgsrecin+d_iginrec_d_pgsrecin);
d_igout_d_pg_param1=(d_igindiode_d_pg_param1+d_iginrec_d_pg_param1);
d_igout_d_vjg=(d_igindiode_d_vjg+d_iginrec_d_vjg);
d_igout_d_type=(d_igindiode_d_type+d_iginrec_d_type);
igout=(igindiode+iginrec);
d_calc_ig_d_vgin=d_igout_d_vgin;
d_calc_ig_d_phitin=d_igout_d_phitin;
d_calc_ig_d_vgsatin=d_igout_d_vgsatin;
d_calc_ig_d_alphagin=d_igout_d_alphagin;
d_calc_ig_d_fracin=d_igout_d_fracin;
d_calc_ig_d_pg_paramin=d_igout_d_pg_paramin;
d_calc_ig_d_pbdgin=d_igout_d_pbdgin;
d_calc_ig_d_vbdgin=d_igout_d_vbdgin;
d_calc_ig_d_tambin=d_igout_d_tambin;
d_calc_ig_d_tnomin=d_igout_d_tnomin;
d_calc_ig_d_w=d_igout_d_w;
d_calc_ig_d_ngf=d_igout_d_ngf;
d_calc_ig_d_ijin=d_igout_d_ijin;
d_calc_ig_d_kbdgatein=d_igout_d_kbdgatein;
d_calc_ig_d_vgsatqin=d_igout_d_vgsatqin;
d_calc_ig_d_betarecin=d_igout_d_betarecin;
d_calc_ig_d_irecin=d_igout_d_irecin;
d_calc_ig_d_pgsrecin=d_igout_d_pgsrecin;
d_calc_ig_d_pg_param1=d_igout_d_pg_param1;
d_calc_ig_d_vjg=d_igout_d_vjg;
d_calc_ig_d_type=d_igout_d_type;
calc_ig=igout;
}
d_calc_ig = d_calc_ig_d_vgin*d_vgin+d_calc_ig_d_phitin*d_phitin+d_calc_ig_d_vgsatin*d_vgsatin+d_calc_ig_d_alphagin*d_alphagin+d_calc_ig_d_fracin*d_fracin+d_calc_ig_d_pg_paramin*d_pg_paramin+d_calc_ig_d_pbdgin*d_pbdgin+d_calc_ig_d_vbdgin*d_vbdgin+d_calc_ig_d_tambin*d_tambin+d_calc_ig_d_tnomin*d_tnomin+d_calc_ig_d_w*d_w+d_calc_ig_d_ngf*d_ngf+d_calc_ig_d_ijin*d_ijin+d_calc_ig_d_kbdgatein*d_kbdgatein+d_calc_ig_d_vgsatqin*d_vgsatqin+d_calc_ig_d_betarecin*d_betarecin+d_calc_ig_d_irecin*d_irecin+d_calc_ig_d_pgsrecin*d_pgsrecin+d_calc_ig_d_pg_param1*d_pg_param1+d_calc_ig_d_vjg*d_vjg+d_calc_ig_d_type*d_type;
d_isdiodeout = d_isdiodeout_d_vgin*d_vgin+d_isdiodeout_d_phitin*d_phitin+d_isdiodeout_d_vgsatin*d_vgsatin+d_isdiodeout_d_alphagin*d_alphagin+d_isdiodeout_d_fracin*d_fracin+d_isdiodeout_d_pg_paramin*d_pg_paramin+d_isdiodeout_d_pbdgin*d_pbdgin+d_isdiodeout_d_vbdgin*d_vbdgin+d_isdiodeout_d_tambin*d_tambin+d_isdiodeout_d_tnomin*d_tnomin+d_isdiodeout_d_w*d_w+d_isdiodeout_d_ngf*d_ngf+d_isdiodeout_d_ijin*d_ijin+d_isdiodeout_d_kbdgatein*d_kbdgatein+d_isdiodeout_d_vgsatqin*d_vgsatqin+d_isdiodeout_d_betarecin*d_betarecin+d_isdiodeout_d_irecin*d_irecin+d_isdiodeout_d_pgsrecin*d_pgsrecin+d_isdiodeout_d_pg_param1*d_pg_param1+d_isdiodeout_d_vjg*d_vjg+d_isdiodeout_d_type*d_type;
d_isrecout = d_isrecout_d_vgin*d_vgin+d_isrecout_d_phitin*d_phitin+d_isrecout_d_vgsatin*d_vgsatin+d_isrecout_d_alphagin*d_alphagin+d_isrecout_d_fracin*d_fracin+d_isrecout_d_pg_paramin*d_pg_paramin+d_isrecout_d_pbdgin*d_pbdgin+d_isrecout_d_vbdgin*d_vbdgin+d_isrecout_d_tambin*d_tambin+d_isrecout_d_tnomin*d_tnomin+d_isrecout_d_w*d_w+d_isrecout_d_ngf*d_ngf+d_isrecout_d_ijin*d_ijin+d_isrecout_d_kbdgatein*d_kbdgatein+d_isrecout_d_vgsatqin*d_vgsatqin+d_isrecout_d_betarecin*d_betarecin+d_isrecout_d_irecin*d_irecin+d_isrecout_d_pgsrecin*d_pgsrecin+d_isrecout_d_pg_param1*d_pg_param1+d_isrecout_d_vjg*d_vjg+d_isrecout_d_type*d_type;
return(d_calc_ig);
}

// Evaluator class implementations for Analog Function calc_ig
  // Constructor
  calc_igEvaluator::calc_igEvaluator(double isdiodeout, double isrecout, double vgin, double phitin, double vgsatin, double alphagin, double fracin, double pg_paramin, double pbdgin, double vbdgin, double tambin, double tnomin, double w, double ngf, double ijin, double kbdgatein, double vgsatqin, double betarecin, double irecin, double pgsrecin, double pg_param1, double vjg, double type)
  {
    calc_igReturn_ = evaluator_(isdiodeoutReturn_, isrecoutReturn_, vgin, phitin, vgsatin, alphagin, fracin, pg_paramin, pbdgin, vbdgin, tambin, tnomin, w, ngf, ijin, kbdgatein, vgsatqin, betarecin, irecin, pgsrecin, pg_param1, vjg, type);
  }
  // method to get precomputed values into double vars 
  double calc_igEvaluator::getValues(double &  isdiodeout, double &  isrecout, double  vgin, double  phitin, double  vgsatin, double  alphagin, double  fracin, double  pg_paramin, double  pbdgin, double  vbdgin, double  tambin, double  tnomin, double  w, double  ngf, double  ijin, double  kbdgatein, double  vgsatqin, double  betarecin, double  irecin, double  pgsrecin, double  pg_param1, double  vjg, double  type)
  {
    // Silence unused argument warnings
    (void) vgin;
    (void) phitin;
    (void) vgsatin;
    (void) alphagin;
    (void) fracin;
    (void) pg_paramin;
    (void) pbdgin;
    (void) vbdgin;
    (void) tambin;
    (void) tnomin;
    (void) w;
    (void) ngf;
    (void) ijin;
    (void) kbdgatein;
    (void) vgsatqin;
    (void) betarecin;
    (void) irecin;
    (void) pgsrecin;
    (void) pg_param1;
    (void) vjg;
    (void) type;
    // Copy all precomputed values into corresponding output
    isdiodeout = isdiodeoutReturn_.value;
    isrecout = isrecoutReturn_.value;
    return(calc_igReturn_.value);
  }
  // method to get total deriv w.r.t some variable via chain rule 
  // given precomputed derivs of function w.r.t. args and derivs of args
  // w.r.t desired vars
  double calc_igEvaluator::getDerivs(double isdiodeout , double isrecout , double vgin , double phitin , double vgsatin , double alphagin , double fracin , double pg_paramin , double pbdgin , double vbdgin , double tambin , double tnomin , double w , double ngf , double ijin , double kbdgatein , double vgsatqin , double betarecin , double irecin , double pgsrecin , double pg_param1 , double vjg , double type  , double & d_isdiodeout, double & d_isrecout, double d_vgin, double d_phitin, double d_vgsatin, double d_alphagin, double d_fracin, double d_pg_paramin, double d_pbdgin, double d_vbdgin, double d_tambin, double d_tnomin, double d_w, double d_ngf, double d_ijin, double d_kbdgatein, double d_vgsatqin, double d_betarecin, double d_irecin, double d_pgsrecin, double d_pg_param1, double d_vjg, double d_type)
  {
    // Function total deriv
    double d_calc_ig;
    // Silence unused argument warnings
    (void) vgin;
    (void) phitin;
    (void) vgsatin;
    (void) alphagin;
    (void) fracin;
    (void) pg_paramin;
    (void) pbdgin;
    (void) vbdgin;
    (void) tambin;
    (void) tnomin;
    (void) w;
    (void) ngf;
    (void) ijin;
    (void) kbdgatein;
    (void) vgsatqin;
    (void) betarecin;
    (void) irecin;
    (void) pgsrecin;
    (void) pg_param1;
    (void) vjg;
    (void) type;
    d_calc_ig = calc_igReturn_.deriv_WRT_vgin*d_vgin+calc_igReturn_.deriv_WRT_phitin*d_phitin+calc_igReturn_.deriv_WRT_vgsatin*d_vgsatin+calc_igReturn_.deriv_WRT_alphagin*d_alphagin+calc_igReturn_.deriv_WRT_fracin*d_fracin+calc_igReturn_.deriv_WRT_pg_paramin*d_pg_paramin+calc_igReturn_.deriv_WRT_pbdgin*d_pbdgin+calc_igReturn_.deriv_WRT_vbdgin*d_vbdgin+calc_igReturn_.deriv_WRT_tambin*d_tambin+calc_igReturn_.deriv_WRT_tnomin*d_tnomin+calc_igReturn_.deriv_WRT_w*d_w+calc_igReturn_.deriv_WRT_ngf*d_ngf+calc_igReturn_.deriv_WRT_ijin*d_ijin+calc_igReturn_.deriv_WRT_kbdgatein*d_kbdgatein+calc_igReturn_.deriv_WRT_vgsatqin*d_vgsatqin+calc_igReturn_.deriv_WRT_betarecin*d_betarecin+calc_igReturn_.deriv_WRT_irecin*d_irecin+calc_igReturn_.deriv_WRT_pgsrecin*d_pgsrecin+calc_igReturn_.deriv_WRT_pg_param1*d_pg_param1+calc_igReturn_.deriv_WRT_vjg*d_vjg+calc_igReturn_.deriv_WRT_type*d_type;
    d_isdiodeout = isdiodeoutReturn_.deriv_WRT_vgin*d_vgin+isdiodeoutReturn_.deriv_WRT_phitin*d_phitin+isdiodeoutReturn_.deriv_WRT_vgsatin*d_vgsatin+isdiodeoutReturn_.deriv_WRT_alphagin*d_alphagin+isdiodeoutReturn_.deriv_WRT_fracin*d_fracin+isdiodeoutReturn_.deriv_WRT_pg_paramin*d_pg_paramin+isdiodeoutReturn_.deriv_WRT_pbdgin*d_pbdgin+isdiodeoutReturn_.deriv_WRT_vbdgin*d_vbdgin+isdiodeoutReturn_.deriv_WRT_tambin*d_tambin+isdiodeoutReturn_.deriv_WRT_tnomin*d_tnomin+isdiodeoutReturn_.deriv_WRT_w*d_w+isdiodeoutReturn_.deriv_WRT_ngf*d_ngf+isdiodeoutReturn_.deriv_WRT_ijin*d_ijin+isdiodeoutReturn_.deriv_WRT_kbdgatein*d_kbdgatein+isdiodeoutReturn_.deriv_WRT_vgsatqin*d_vgsatqin+isdiodeoutReturn_.deriv_WRT_betarecin*d_betarecin+isdiodeoutReturn_.deriv_WRT_irecin*d_irecin+isdiodeoutReturn_.deriv_WRT_pgsrecin*d_pgsrecin+isdiodeoutReturn_.deriv_WRT_pg_param1*d_pg_param1+isdiodeoutReturn_.deriv_WRT_vjg*d_vjg+isdiodeoutReturn_.deriv_WRT_type*d_type;
    d_isrecout = isrecoutReturn_.deriv_WRT_vgin*d_vgin+isrecoutReturn_.deriv_WRT_phitin*d_phitin+isrecoutReturn_.deriv_WRT_vgsatin*d_vgsatin+isrecoutReturn_.deriv_WRT_alphagin*d_alphagin+isrecoutReturn_.deriv_WRT_fracin*d_fracin+isrecoutReturn_.deriv_WRT_pg_paramin*d_pg_paramin+isrecoutReturn_.deriv_WRT_pbdgin*d_pbdgin+isrecoutReturn_.deriv_WRT_vbdgin*d_vbdgin+isrecoutReturn_.deriv_WRT_tambin*d_tambin+isrecoutReturn_.deriv_WRT_tnomin*d_tnomin+isrecoutReturn_.deriv_WRT_w*d_w+isrecoutReturn_.deriv_WRT_ngf*d_ngf+isrecoutReturn_.deriv_WRT_ijin*d_ijin+isrecoutReturn_.deriv_WRT_kbdgatein*d_kbdgatein+isrecoutReturn_.deriv_WRT_vgsatqin*d_vgsatqin+isrecoutReturn_.deriv_WRT_betarecin*d_betarecin+isrecoutReturn_.deriv_WRT_irecin*d_irecin+isrecoutReturn_.deriv_WRT_pgsrecin*d_pgsrecin+isrecoutReturn_.deriv_WRT_pg_param1*d_pg_param1+isrecoutReturn_.deriv_WRT_vjg*d_vjg+isrecoutReturn_.deriv_WRT_type*d_type;
    return(d_calc_ig);
  }
  // method that actually performs our computations.
  calc_igEvaluator::returnType calc_igEvaluator::evaluator_(calc_igEvaluator::returnType & isdiodeoutReturn, calc_igEvaluator::returnType & isrecoutReturn, double vgin, double phitin, double vgsatin, double alphagin, double fracin, double pg_paramin, double pbdgin, double vbdgin, double tambin, double tnomin, double w, double ngf, double ijin, double kbdgatein, double vgsatqin, double betarecin, double irecin, double pgsrecin, double pg_param1, double vjg, double type)
  {
  // Function value and derivs variables, and a returnType to store everything
  double calc_ig;
  calc_igEvaluator::returnType calc_igReturn;
  // Derivatives of return value w.r.t input vars
  double d_calc_ig_d_vgin;
  double d_calc_ig_d_phitin;
  double d_calc_ig_d_vgsatin;
  double d_calc_ig_d_alphagin;
  double d_calc_ig_d_fracin;
  double d_calc_ig_d_pg_paramin;
  double d_calc_ig_d_pbdgin;
  double d_calc_ig_d_vbdgin;
  double d_calc_ig_d_tambin;
  double d_calc_ig_d_tnomin;
  double d_calc_ig_d_w;
  double d_calc_ig_d_ngf;
  double d_calc_ig_d_ijin;
  double d_calc_ig_d_kbdgatein;
  double d_calc_ig_d_vgsatqin;
  double d_calc_ig_d_betarecin;
  double d_calc_ig_d_irecin;
  double d_calc_ig_d_pgsrecin;
  double d_calc_ig_d_pg_param1;
  double d_calc_ig_d_vjg;
  double d_calc_ig_d_type;
  // additional output vars  and derivs w.r.t input vars
  double isdiodeout;
  double d_isdiodeout_d_vgin;
  double d_isdiodeout_d_phitin;
  double d_isdiodeout_d_vgsatin;
  double d_isdiodeout_d_alphagin;
  double d_isdiodeout_d_fracin;
  double d_isdiodeout_d_pg_paramin;
  double d_isdiodeout_d_pbdgin;
  double d_isdiodeout_d_vbdgin;
  double d_isdiodeout_d_tambin;
  double d_isdiodeout_d_tnomin;
  double d_isdiodeout_d_w;
  double d_isdiodeout_d_ngf;
  double d_isdiodeout_d_ijin;
  double d_isdiodeout_d_kbdgatein;
  double d_isdiodeout_d_vgsatqin;
  double d_isdiodeout_d_betarecin;
  double d_isdiodeout_d_irecin;
  double d_isdiodeout_d_pgsrecin;
  double d_isdiodeout_d_pg_param1;
  double d_isdiodeout_d_vjg;
  double d_isdiodeout_d_type;
  double isrecout;
  double d_isrecout_d_vgin;
  double d_isrecout_d_phitin;
  double d_isrecout_d_vgsatin;
  double d_isrecout_d_alphagin;
  double d_isrecout_d_fracin;
  double d_isrecout_d_pg_paramin;
  double d_isrecout_d_pbdgin;
  double d_isrecout_d_vbdgin;
  double d_isrecout_d_tambin;
  double d_isrecout_d_tnomin;
  double d_isrecout_d_w;
  double d_isrecout_d_ngf;
  double d_isrecout_d_ijin;
  double d_isrecout_d_kbdgatein;
  double d_isrecout_d_vgsatqin;
  double d_isrecout_d_betarecin;
  double d_isrecout_d_irecin;
  double d_isrecout_d_pgsrecin;
  double d_isrecout_d_pg_param1;
  double d_isrecout_d_vjg;
  double d_isrecout_d_type;
  // declared local variables
  double igout;
  double d_igout_d_vgin;
  double d_igout_d_phitin;
  double d_igout_d_vgsatin;
  double d_igout_d_alphagin;
  double d_igout_d_fracin;
  double d_igout_d_pg_paramin;
  double d_igout_d_pbdgin;
  double d_igout_d_vbdgin;
  double d_igout_d_tambin;
  double d_igout_d_tnomin;
  double d_igout_d_w;
  double d_igout_d_ngf;
  double d_igout_d_ijin;
  double d_igout_d_kbdgatein;
  double d_igout_d_vgsatqin;
  double d_igout_d_betarecin;
  double d_igout_d_irecin;
  double d_igout_d_pgsrecin;
  double d_igout_d_pg_param1;
  double d_igout_d_vjg;
  double d_igout_d_type;
  double alpha_phit;
  double d_alpha_phit_d_vgin;
  double d_alpha_phit_d_phitin;
  double d_alpha_phit_d_vgsatin;
  double d_alpha_phit_d_alphagin;
  double d_alpha_phit_d_fracin;
  double d_alpha_phit_d_pg_paramin;
  double d_alpha_phit_d_pbdgin;
  double d_alpha_phit_d_vbdgin;
  double d_alpha_phit_d_tambin;
  double d_alpha_phit_d_tnomin;
  double d_alpha_phit_d_w;
  double d_alpha_phit_d_ngf;
  double d_alpha_phit_d_ijin;
  double d_alpha_phit_d_kbdgatein;
  double d_alpha_phit_d_vgsatqin;
  double d_alpha_phit_d_betarecin;
  double d_alpha_phit_d_irecin;
  double d_alpha_phit_d_pgsrecin;
  double d_alpha_phit_d_pg_param1;
  double d_alpha_phit_d_vjg;
  double d_alpha_phit_d_type;
  double t0;
  double d_t0_d_vgin;
  double d_t0_d_phitin;
  double d_t0_d_vgsatin;
  double d_t0_d_alphagin;
  double d_t0_d_fracin;
  double d_t0_d_pg_paramin;
  double d_t0_d_pbdgin;
  double d_t0_d_vbdgin;
  double d_t0_d_tambin;
  double d_t0_d_tnomin;
  double d_t0_d_w;
  double d_t0_d_ngf;
  double d_t0_d_ijin;
  double d_t0_d_kbdgatein;
  double d_t0_d_vgsatqin;
  double d_t0_d_betarecin;
  double d_t0_d_irecin;
  double d_t0_d_pgsrecin;
  double d_t0_d_pg_param1;
  double d_t0_d_vjg;
  double d_t0_d_type;
  double ffvgin;
  double d_ffvgin_d_vgin;
  double d_ffvgin_d_phitin;
  double d_ffvgin_d_vgsatin;
  double d_ffvgin_d_alphagin;
  double d_ffvgin_d_fracin;
  double d_ffvgin_d_pg_paramin;
  double d_ffvgin_d_pbdgin;
  double d_ffvgin_d_vbdgin;
  double d_ffvgin_d_tambin;
  double d_ffvgin_d_tnomin;
  double d_ffvgin_d_w;
  double d_ffvgin_d_ngf;
  double d_ffvgin_d_ijin;
  double d_ffvgin_d_kbdgatein;
  double d_ffvgin_d_vgsatqin;
  double d_ffvgin_d_betarecin;
  double d_ffvgin_d_irecin;
  double d_ffvgin_d_pgsrecin;
  double d_ffvgin_d_pg_param1;
  double d_ffvgin_d_vjg;
  double d_ffvgin_d_type;
  double pgin;
  double d_pgin_d_vgin;
  double d_pgin_d_phitin;
  double d_pgin_d_vgsatin;
  double d_pgin_d_alphagin;
  double d_pgin_d_fracin;
  double d_pgin_d_pg_paramin;
  double d_pgin_d_pbdgin;
  double d_pgin_d_vbdgin;
  double d_pgin_d_tambin;
  double d_pgin_d_tnomin;
  double d_pgin_d_w;
  double d_pgin_d_ngf;
  double d_pgin_d_ijin;
  double d_pgin_d_kbdgatein;
  double d_pgin_d_vgsatqin;
  double d_pgin_d_betarecin;
  double d_pgin_d_irecin;
  double d_pgin_d_pgsrecin;
  double d_pgin_d_pg_param1;
  double d_pgin_d_vjg;
  double d_pgin_d_type;
  double iginbd;
  double d_iginbd_d_vgin;
  double d_iginbd_d_phitin;
  double d_iginbd_d_vgsatin;
  double d_iginbd_d_alphagin;
  double d_iginbd_d_fracin;
  double d_iginbd_d_pg_paramin;
  double d_iginbd_d_pbdgin;
  double d_iginbd_d_vbdgin;
  double d_iginbd_d_tambin;
  double d_iginbd_d_tnomin;
  double d_iginbd_d_w;
  double d_iginbd_d_ngf;
  double d_iginbd_d_ijin;
  double d_iginbd_d_kbdgatein;
  double d_iginbd_d_vgsatqin;
  double d_iginbd_d_betarecin;
  double d_iginbd_d_irecin;
  double d_iginbd_d_pgsrecin;
  double d_iginbd_d_pg_param1;
  double d_iginbd_d_vjg;
  double d_iginbd_d_type;
  double tfacdiode;
  double d_tfacdiode_d_vgin;
  double d_tfacdiode_d_phitin;
  double d_tfacdiode_d_vgsatin;
  double d_tfacdiode_d_alphagin;
  double d_tfacdiode_d_fracin;
  double d_tfacdiode_d_pg_paramin;
  double d_tfacdiode_d_pbdgin;
  double d_tfacdiode_d_vbdgin;
  double d_tfacdiode_d_tambin;
  double d_tfacdiode_d_tnomin;
  double d_tfacdiode_d_w;
  double d_tfacdiode_d_ngf;
  double d_tfacdiode_d_ijin;
  double d_tfacdiode_d_kbdgatein;
  double d_tfacdiode_d_vgsatqin;
  double d_tfacdiode_d_betarecin;
  double d_tfacdiode_d_irecin;
  double d_tfacdiode_d_pgsrecin;
  double d_tfacdiode_d_pg_param1;
  double d_tfacdiode_d_vjg;
  double d_tfacdiode_d_type;
  double igindiode;
  double d_igindiode_d_vgin;
  double d_igindiode_d_phitin;
  double d_igindiode_d_vgsatin;
  double d_igindiode_d_alphagin;
  double d_igindiode_d_fracin;
  double d_igindiode_d_pg_paramin;
  double d_igindiode_d_pbdgin;
  double d_igindiode_d_vbdgin;
  double d_igindiode_d_tambin;
  double d_igindiode_d_tnomin;
  double d_igindiode_d_w;
  double d_igindiode_d_ngf;
  double d_igindiode_d_ijin;
  double d_igindiode_d_kbdgatein;
  double d_igindiode_d_vgsatqin;
  double d_igindiode_d_betarecin;
  double d_igindiode_d_irecin;
  double d_igindiode_d_pgsrecin;
  double d_igindiode_d_pg_param1;
  double d_igindiode_d_vjg;
  double d_igindiode_d_type;
  double frecgin;
  double d_frecgin_d_vgin;
  double d_frecgin_d_phitin;
  double d_frecgin_d_vgsatin;
  double d_frecgin_d_alphagin;
  double d_frecgin_d_fracin;
  double d_frecgin_d_pg_paramin;
  double d_frecgin_d_pbdgin;
  double d_frecgin_d_vbdgin;
  double d_frecgin_d_tambin;
  double d_frecgin_d_tnomin;
  double d_frecgin_d_w;
  double d_frecgin_d_ngf;
  double d_frecgin_d_ijin;
  double d_frecgin_d_kbdgatein;
  double d_frecgin_d_vgsatqin;
  double d_frecgin_d_betarecin;
  double d_frecgin_d_irecin;
  double d_frecgin_d_pgsrecin;
  double d_frecgin_d_pg_param1;
  double d_frecgin_d_vjg;
  double d_frecgin_d_type;
  double iginrec;
  double d_iginrec_d_vgin;
  double d_iginrec_d_phitin;
  double d_iginrec_d_vgsatin;
  double d_iginrec_d_alphagin;
  double d_iginrec_d_fracin;
  double d_iginrec_d_pg_paramin;
  double d_iginrec_d_pbdgin;
  double d_iginrec_d_vbdgin;
  double d_iginrec_d_tambin;
  double d_iginrec_d_tnomin;
  double d_iginrec_d_w;
  double d_iginrec_d_ngf;
  double d_iginrec_d_ijin;
  double d_iginrec_d_kbdgatein;
  double d_iginrec_d_vgsatqin;
  double d_iginrec_d_betarecin;
  double d_iginrec_d_irecin;
  double d_iginrec_d_pgsrecin;
  double d_iginrec_d_pg_param1;
  double d_iginrec_d_vjg;
  double d_iginrec_d_type;
  double expbdarg1;
  double d_expbdarg1_d_vgin;
  double d_expbdarg1_d_phitin;
  double d_expbdarg1_d_vgsatin;
  double d_expbdarg1_d_alphagin;
  double d_expbdarg1_d_fracin;
  double d_expbdarg1_d_pg_paramin;
  double d_expbdarg1_d_pbdgin;
  double d_expbdarg1_d_vbdgin;
  double d_expbdarg1_d_tambin;
  double d_expbdarg1_d_tnomin;
  double d_expbdarg1_d_w;
  double d_expbdarg1_d_ngf;
  double d_expbdarg1_d_ijin;
  double d_expbdarg1_d_kbdgatein;
  double d_expbdarg1_d_vgsatqin;
  double d_expbdarg1_d_betarecin;
  double d_expbdarg1_d_irecin;
  double d_expbdarg1_d_pgsrecin;
  double d_expbdarg1_d_pg_param1;
  double d_expbdarg1_d_vjg;
  double d_expbdarg1_d_type;
  double expbdarg2;
  double d_expbdarg2_d_vgin;
  double d_expbdarg2_d_phitin;
  double d_expbdarg2_d_vgsatin;
  double d_expbdarg2_d_alphagin;
  double d_expbdarg2_d_fracin;
  double d_expbdarg2_d_pg_paramin;
  double d_expbdarg2_d_pbdgin;
  double d_expbdarg2_d_vbdgin;
  double d_expbdarg2_d_tambin;
  double d_expbdarg2_d_tnomin;
  double d_expbdarg2_d_w;
  double d_expbdarg2_d_ngf;
  double d_expbdarg2_d_ijin;
  double d_expbdarg2_d_kbdgatein;
  double d_expbdarg2_d_vgsatqin;
  double d_expbdarg2_d_betarecin;
  double d_expbdarg2_d_irecin;
  double d_expbdarg2_d_pgsrecin;
  double d_expbdarg2_d_pg_param1;
  double d_expbdarg2_d_vjg;
  double d_expbdarg2_d_type;
  double expbd1;
  double d_expbd1_d_vgin;
  double d_expbd1_d_phitin;
  double d_expbd1_d_vgsatin;
  double d_expbd1_d_alphagin;
  double d_expbd1_d_fracin;
  double d_expbd1_d_pg_paramin;
  double d_expbd1_d_pbdgin;
  double d_expbd1_d_vbdgin;
  double d_expbd1_d_tambin;
  double d_expbd1_d_tnomin;
  double d_expbd1_d_w;
  double d_expbd1_d_ngf;
  double d_expbd1_d_ijin;
  double d_expbd1_d_kbdgatein;
  double d_expbd1_d_vgsatqin;
  double d_expbd1_d_betarecin;
  double d_expbd1_d_irecin;
  double d_expbd1_d_pgsrecin;
  double d_expbd1_d_pg_param1;
  double d_expbd1_d_vjg;
  double d_expbd1_d_type;
  double expbd2;
  double d_expbd2_d_vgin;
  double d_expbd2_d_phitin;
  double d_expbd2_d_vgsatin;
  double d_expbd2_d_alphagin;
  double d_expbd2_d_fracin;
  double d_expbd2_d_pg_paramin;
  double d_expbd2_d_pbdgin;
  double d_expbd2_d_vbdgin;
  double d_expbd2_d_tambin;
  double d_expbd2_d_tnomin;
  double d_expbd2_d_w;
  double d_expbd2_d_ngf;
  double d_expbd2_d_ijin;
  double d_expbd2_d_kbdgatein;
  double d_expbd2_d_vgsatqin;
  double d_expbd2_d_betarecin;
  double d_expbd2_d_irecin;
  double d_expbd2_d_pgsrecin;
  double d_expbd2_d_pg_param1;
  double d_expbd2_d_vjg;
  double d_expbd2_d_type;
  double expphib;
  double d_expphib_d_vgin;
  double d_expphib_d_phitin;
  double d_expphib_d_vgsatin;
  double d_expphib_d_alphagin;
  double d_expphib_d_fracin;
  double d_expphib_d_pg_paramin;
  double d_expphib_d_pbdgin;
  double d_expphib_d_vbdgin;
  double d_expphib_d_tambin;
  double d_expphib_d_tnomin;
  double d_expphib_d_w;
  double d_expphib_d_ngf;
  double d_expphib_d_ijin;
  double d_expphib_d_kbdgatein;
  double d_expphib_d_vgsatqin;
  double d_expphib_d_betarecin;
  double d_expphib_d_irecin;
  double d_expphib_d_pgsrecin;
  double d_expphib_d_pg_param1;
  double d_expphib_d_vjg;
  double d_expphib_d_type;
  double expffvarg;
  double d_expffvarg_d_vgin;
  double d_expffvarg_d_phitin;
  double d_expffvarg_d_vgsatin;
  double d_expffvarg_d_alphagin;
  double d_expffvarg_d_fracin;
  double d_expffvarg_d_pg_paramin;
  double d_expffvarg_d_pbdgin;
  double d_expffvarg_d_vbdgin;
  double d_expffvarg_d_tambin;
  double d_expffvarg_d_tnomin;
  double d_expffvarg_d_w;
  double d_expffvarg_d_ngf;
  double d_expffvarg_d_ijin;
  double d_expffvarg_d_kbdgatein;
  double d_expffvarg_d_vgsatqin;
  double d_expffvarg_d_betarecin;
  double d_expffvarg_d_irecin;
  double d_expffvarg_d_pgsrecin;
  double d_expffvarg_d_pg_param1;
  double d_expffvarg_d_vjg;
  double d_expffvarg_d_type;
  double expiforarg;
  double d_expiforarg_d_vgin;
  double d_expiforarg_d_phitin;
  double d_expiforarg_d_vgsatin;
  double d_expiforarg_d_alphagin;
  double d_expiforarg_d_fracin;
  double d_expiforarg_d_pg_paramin;
  double d_expiforarg_d_pbdgin;
  double d_expiforarg_d_vbdgin;
  double d_expiforarg_d_tambin;
  double d_expiforarg_d_tnomin;
  double d_expiforarg_d_w;
  double d_expiforarg_d_ngf;
  double d_expiforarg_d_ijin;
  double d_expiforarg_d_kbdgatein;
  double d_expiforarg_d_vgsatqin;
  double d_expiforarg_d_betarecin;
  double d_expiforarg_d_irecin;
  double d_expiforarg_d_pgsrecin;
  double d_expiforarg_d_pg_param1;
  double d_expiforarg_d_vjg;
  double d_expiforarg_d_type;
  double expifor;
  double d_expifor_d_vgin;
  double d_expifor_d_phitin;
  double d_expifor_d_vgsatin;
  double d_expifor_d_alphagin;
  double d_expifor_d_fracin;
  double d_expifor_d_pg_paramin;
  double d_expifor_d_pbdgin;
  double d_expifor_d_vbdgin;
  double d_expifor_d_tambin;
  double d_expifor_d_tnomin;
  double d_expifor_d_w;
  double d_expifor_d_ngf;
  double d_expifor_d_ijin;
  double d_expifor_d_kbdgatein;
  double d_expifor_d_vgsatqin;
  double d_expifor_d_betarecin;
  double d_expifor_d_irecin;
  double d_expifor_d_pgsrecin;
  double d_expifor_d_pg_param1;
  double d_expifor_d_vjg;
  double d_expifor_d_type;
  double expirevarg;
  double d_expirevarg_d_vgin;
  double d_expirevarg_d_phitin;
  double d_expirevarg_d_vgsatin;
  double d_expirevarg_d_alphagin;
  double d_expirevarg_d_fracin;
  double d_expirevarg_d_pg_paramin;
  double d_expirevarg_d_pbdgin;
  double d_expirevarg_d_vbdgin;
  double d_expirevarg_d_tambin;
  double d_expirevarg_d_tnomin;
  double d_expirevarg_d_w;
  double d_expirevarg_d_ngf;
  double d_expirevarg_d_ijin;
  double d_expirevarg_d_kbdgatein;
  double d_expirevarg_d_vgsatqin;
  double d_expirevarg_d_betarecin;
  double d_expirevarg_d_irecin;
  double d_expirevarg_d_pgsrecin;
  double d_expirevarg_d_pg_param1;
  double d_expirevarg_d_vjg;
  double d_expirevarg_d_type;
  double expirev;
  double d_expirev_d_vgin;
  double d_expirev_d_phitin;
  double d_expirev_d_vgsatin;
  double d_expirev_d_alphagin;
  double d_expirev_d_fracin;
  double d_expirev_d_pg_paramin;
  double d_expirev_d_pbdgin;
  double d_expirev_d_vbdgin;
  double d_expirev_d_tambin;
  double d_expirev_d_tnomin;
  double d_expirev_d_w;
  double d_expirev_d_ngf;
  double d_expirev_d_ijin;
  double d_expirev_d_kbdgatein;
  double d_expirev_d_vgsatqin;
  double d_expirev_d_betarecin;
  double d_expirev_d_irecin;
  double d_expirev_d_pgsrecin;
  double d_expirev_d_pg_param1;
  double d_expirev_d_vjg;
  double d_expirev_d_type;
{
d_alpha_phit_d_vgin=0.0;
d_alpha_phit_d_phitin=(alphagin);
d_alpha_phit_d_vgsatin=0.0;
d_alpha_phit_d_alphagin=(phitin);
d_alpha_phit_d_fracin=0.0;
d_alpha_phit_d_pg_paramin=0.0;
d_alpha_phit_d_pbdgin=0.0;
d_alpha_phit_d_vbdgin=0.0;
d_alpha_phit_d_tambin=0.0;
d_alpha_phit_d_tnomin=0.0;
d_alpha_phit_d_w=0.0;
d_alpha_phit_d_ngf=0.0;
d_alpha_phit_d_ijin=0.0;
d_alpha_phit_d_kbdgatein=0.0;
d_alpha_phit_d_vgsatqin=0.0;
d_alpha_phit_d_betarecin=0.0;
d_alpha_phit_d_irecin=0.0;
d_alpha_phit_d_pgsrecin=0.0;
d_alpha_phit_d_pg_param1=0.0;
d_alpha_phit_d_vjg=0.0;
d_alpha_phit_d_type=0.0;
alpha_phit=(alphagin*phitin);
d_expphib_d_vgin=0.0;
d_expphib_d_phitin=((-pg_param1/phitin/phitin)*(-vjg));
d_expphib_d_vgsatin=0.0;
d_expphib_d_alphagin=0.0;
d_expphib_d_fracin=0.0;
d_expphib_d_pg_paramin=0.0;
d_expphib_d_pbdgin=0.0;
d_expphib_d_vbdgin=0.0;
d_expphib_d_tambin=0.0;
d_expphib_d_tnomin=0.0;
d_expphib_d_w=0.0;
d_expphib_d_ngf=0.0;
d_expphib_d_ijin=0.0;
d_expphib_d_kbdgatein=0.0;
d_expphib_d_vgsatqin=0.0;
d_expphib_d_betarecin=0.0;
d_expphib_d_irecin=0.0;
d_expphib_d_pgsrecin=0.0;
d_expphib_d_pg_param1=((1.0/phitin)*(-vjg));
d_expphib_d_vjg=((pg_param1/phitin)*(-1.0));
d_expphib_d_type=0.0;
expphib=((pg_param1/phitin)*(-vjg));
d_t0_d_vgin=d_explim(expphib,d_expphib_d_vgin);
d_t0_d_phitin=d_explim(expphib,d_expphib_d_phitin);
d_t0_d_vgsatin=d_explim(expphib,d_expphib_d_vgsatin);
d_t0_d_alphagin=d_explim(expphib,d_expphib_d_alphagin);
d_t0_d_fracin=d_explim(expphib,d_expphib_d_fracin);
d_t0_d_pg_paramin=d_explim(expphib,d_expphib_d_pg_paramin);
d_t0_d_pbdgin=d_explim(expphib,d_expphib_d_pbdgin);
d_t0_d_vbdgin=d_explim(expphib,d_expphib_d_vbdgin);
d_t0_d_tambin=d_explim(expphib,d_expphib_d_tambin);
d_t0_d_tnomin=d_explim(expphib,d_expphib_d_tnomin);
d_t0_d_w=d_explim(expphib,d_expphib_d_w);
d_t0_d_ngf=d_explim(expphib,d_expphib_d_ngf);
d_t0_d_ijin=d_explim(expphib,d_expphib_d_ijin);
d_t0_d_kbdgatein=d_explim(expphib,d_expphib_d_kbdgatein);
d_t0_d_vgsatqin=d_explim(expphib,d_expphib_d_vgsatqin);
d_t0_d_betarecin=d_explim(expphib,d_expphib_d_betarecin);
d_t0_d_irecin=d_explim(expphib,d_expphib_d_irecin);
d_t0_d_pgsrecin=d_explim(expphib,d_expphib_d_pgsrecin);
d_t0_d_pg_param1=d_explim(expphib,d_expphib_d_pg_param1);
d_t0_d_vjg=d_explim(expphib,d_expphib_d_vjg);
d_t0_d_type=d_explim(expphib,d_expphib_d_type);
t0=explim(expphib);
d_expffvarg_d_vgin=(((alphagin*alpha_phit)*(1.0-(-((alphagin*d_alpha_phit_d_vgin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vgin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_phitin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_phitin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_phitin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vgsatin=(((alphagin*alpha_phit)*(-(1.0-((alphagin*d_alpha_phit_d_vgsatin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vgsatin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_alphagin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_alphagin+alpha_phit)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_alphagin+alpha_phit))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_fracin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_fracin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_fracin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pg_paramin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pg_paramin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pg_paramin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pbdgin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pbdgin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pbdgin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vbdgin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_vbdgin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vbdgin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_tambin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_tambin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_tambin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_tnomin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_tnomin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_tnomin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_w=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_w)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_w))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_ngf=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_ngf)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_ngf))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_ijin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_ijin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_ijin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_kbdgatein=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_kbdgatein)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_kbdgatein))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vgsatqin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_vgsatqin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vgsatqin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_betarecin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_betarecin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_betarecin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_irecin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_irecin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_irecin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pgsrecin=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pgsrecin)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pgsrecin))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_pg_param1=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_pg_param1)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_pg_param1))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_vjg=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_vjg)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_vjg))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
d_expffvarg_d_type=(((alphagin*alpha_phit)*(-(-((alphagin*d_alpha_phit_d_type)/2.0)))-(vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))*(alphagin*d_alpha_phit_d_type))/(alphagin*alpha_phit)/(alphagin*alpha_phit));
expffvarg=((vgin-(vgsatin-((alphagin*alpha_phit)/2.0)))/(alphagin*alpha_phit));
if((expffvarg>50.0))
{
d_ffvgin_d_vgin=0.0;
d_ffvgin_d_phitin=0.0;
d_ffvgin_d_vgsatin=0.0;
d_ffvgin_d_alphagin=0.0;
d_ffvgin_d_fracin=0.0;
d_ffvgin_d_pg_paramin=0.0;
d_ffvgin_d_pbdgin=0.0;
d_ffvgin_d_vbdgin=0.0;
d_ffvgin_d_tambin=0.0;
d_ffvgin_d_tnomin=0.0;
d_ffvgin_d_w=0.0;
d_ffvgin_d_ngf=0.0;
d_ffvgin_d_ijin=0.0;
d_ffvgin_d_kbdgatein=0.0;
d_ffvgin_d_vgsatqin=0.0;
d_ffvgin_d_betarecin=0.0;
d_ffvgin_d_irecin=0.0;
d_ffvgin_d_pgsrecin=0.0;
d_ffvgin_d_pg_param1=0.0;
d_ffvgin_d_vjg=0.0;
d_ffvgin_d_type=0.0;
ffvgin=0.0;
}
else
{
if((expffvarg<(-50.0)))
{
d_ffvgin_d_vgin=0.0;
d_ffvgin_d_phitin=0.0;
d_ffvgin_d_vgsatin=0.0;
d_ffvgin_d_alphagin=0.0;
d_ffvgin_d_fracin=0.0;
d_ffvgin_d_pg_paramin=0.0;
d_ffvgin_d_pbdgin=0.0;
d_ffvgin_d_vbdgin=0.0;
d_ffvgin_d_tambin=0.0;
d_ffvgin_d_tnomin=0.0;
d_ffvgin_d_w=0.0;
d_ffvgin_d_ngf=0.0;
d_ffvgin_d_ijin=0.0;
d_ffvgin_d_kbdgatein=0.0;
d_ffvgin_d_vgsatqin=0.0;
d_ffvgin_d_betarecin=0.0;
d_ffvgin_d_irecin=0.0;
d_ffvgin_d_pgsrecin=0.0;
d_ffvgin_d_pg_param1=0.0;
d_ffvgin_d_vjg=0.0;
d_ffvgin_d_type=0.0;
ffvgin=1.0;
}
else
{
d_ffvgin_d_vgin=(-exp(expffvarg)*d_expffvarg_d_vgin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_phitin=(-exp(expffvarg)*d_expffvarg_d_phitin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vgsatin=(-exp(expffvarg)*d_expffvarg_d_vgsatin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_alphagin=(-exp(expffvarg)*d_expffvarg_d_alphagin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_fracin=(-exp(expffvarg)*d_expffvarg_d_fracin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pg_paramin=(-exp(expffvarg)*d_expffvarg_d_pg_paramin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pbdgin=(-exp(expffvarg)*d_expffvarg_d_pbdgin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vbdgin=(-exp(expffvarg)*d_expffvarg_d_vbdgin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_tambin=(-exp(expffvarg)*d_expffvarg_d_tambin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_tnomin=(-exp(expffvarg)*d_expffvarg_d_tnomin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_w=(-exp(expffvarg)*d_expffvarg_d_w/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_ngf=(-exp(expffvarg)*d_expffvarg_d_ngf/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_ijin=(-exp(expffvarg)*d_expffvarg_d_ijin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_kbdgatein=(-exp(expffvarg)*d_expffvarg_d_kbdgatein/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vgsatqin=(-exp(expffvarg)*d_expffvarg_d_vgsatqin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_betarecin=(-exp(expffvarg)*d_expffvarg_d_betarecin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_irecin=(-exp(expffvarg)*d_expffvarg_d_irecin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pgsrecin=(-exp(expffvarg)*d_expffvarg_d_pgsrecin/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_pg_param1=(-exp(expffvarg)*d_expffvarg_d_pg_param1/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_vjg=(-exp(expffvarg)*d_expffvarg_d_vjg/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
d_ffvgin_d_type=(-exp(expffvarg)*d_expffvarg_d_type/(1.0+exp(expffvarg))/(1.0+exp(expffvarg)));
ffvgin=(1.0/(1.0+exp(expffvarg)));
}
}
d_pgin_d_vgin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vgin);
d_pgin_d_phitin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_phitin);
d_pgin_d_vgsatin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vgsatin);
d_pgin_d_alphagin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_alphagin);
d_pgin_d_fracin=((pg_paramin)+((((1.0-fracin)*pg_paramin)*d_ffvgin_d_fracin)+(((-1.0)*pg_paramin)*ffvgin)));
d_pgin_d_pg_paramin=((fracin)+((((1.0-fracin)*pg_paramin)*d_ffvgin_d_pg_paramin)+(((1.0-fracin))*ffvgin)));
d_pgin_d_pbdgin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_pbdgin);
d_pgin_d_vbdgin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vbdgin);
d_pgin_d_tambin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_tambin);
d_pgin_d_tnomin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_tnomin);
d_pgin_d_w=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_w);
d_pgin_d_ngf=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_ngf);
d_pgin_d_ijin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_ijin);
d_pgin_d_kbdgatein=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_kbdgatein);
d_pgin_d_vgsatqin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vgsatqin);
d_pgin_d_betarecin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_betarecin);
d_pgin_d_irecin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_irecin);
d_pgin_d_pgsrecin=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_pgsrecin);
d_pgin_d_pg_param1=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_pg_param1);
d_pgin_d_vjg=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_vjg);
d_pgin_d_type=(((1.0-fracin)*pg_paramin)*d_ffvgin_d_type);
pgin=((fracin*pg_paramin)+(((1.0-fracin)*pg_paramin)*ffvgin));
d_expbdarg1_d_vgin=((pbdgin*(-1.0))+d_expphib_d_vgin);
d_expbdarg1_d_phitin=d_expphib_d_phitin;
d_expbdarg1_d_vgsatin=d_expphib_d_vgsatin;
d_expbdarg1_d_alphagin=d_expphib_d_alphagin;
d_expbdarg1_d_fracin=d_expphib_d_fracin;
d_expbdarg1_d_pg_paramin=d_expphib_d_pg_paramin;
d_expbdarg1_d_pbdgin=((((-vgin)-vbdgin))+d_expphib_d_pbdgin);
d_expbdarg1_d_vbdgin=((pbdgin*(-1.0))+d_expphib_d_vbdgin);
d_expbdarg1_d_tambin=d_expphib_d_tambin;
d_expbdarg1_d_tnomin=d_expphib_d_tnomin;
d_expbdarg1_d_w=d_expphib_d_w;
d_expbdarg1_d_ngf=d_expphib_d_ngf;
d_expbdarg1_d_ijin=d_expphib_d_ijin;
d_expbdarg1_d_kbdgatein=d_expphib_d_kbdgatein;
d_expbdarg1_d_vgsatqin=d_expphib_d_vgsatqin;
d_expbdarg1_d_betarecin=d_expphib_d_betarecin;
d_expbdarg1_d_irecin=d_expphib_d_irecin;
d_expbdarg1_d_pgsrecin=d_expphib_d_pgsrecin;
d_expbdarg1_d_pg_param1=d_expphib_d_pg_param1;
d_expbdarg1_d_vjg=d_expphib_d_vjg;
d_expbdarg1_d_type=d_expphib_d_type;
expbdarg1=((pbdgin*((-vgin)-vbdgin))+expphib);
d_expbdarg2_d_vgin=d_expphib_d_vgin;
d_expbdarg2_d_phitin=d_expphib_d_phitin;
d_expbdarg2_d_vgsatin=d_expphib_d_vgsatin;
d_expbdarg2_d_alphagin=d_expphib_d_alphagin;
d_expbdarg2_d_fracin=d_expphib_d_fracin;
d_expbdarg2_d_pg_paramin=d_expphib_d_pg_paramin;
d_expbdarg2_d_pbdgin=(((-1.0)*vbdgin)+d_expphib_d_pbdgin);
d_expbdarg2_d_vbdgin=(((-pbdgin))+d_expphib_d_vbdgin);
d_expbdarg2_d_tambin=d_expphib_d_tambin;
d_expbdarg2_d_tnomin=d_expphib_d_tnomin;
d_expbdarg2_d_w=d_expphib_d_w;
d_expbdarg2_d_ngf=d_expphib_d_ngf;
d_expbdarg2_d_ijin=d_expphib_d_ijin;
d_expbdarg2_d_kbdgatein=d_expphib_d_kbdgatein;
d_expbdarg2_d_vgsatqin=d_expphib_d_vgsatqin;
d_expbdarg2_d_betarecin=d_expphib_d_betarecin;
d_expbdarg2_d_irecin=d_expphib_d_irecin;
d_expbdarg2_d_pgsrecin=d_expphib_d_pgsrecin;
d_expbdarg2_d_pg_param1=d_expphib_d_pg_param1;
d_expbdarg2_d_vjg=d_expphib_d_vjg;
d_expbdarg2_d_type=d_expphib_d_type;
expbdarg2=(((-pbdgin)*vbdgin)+expphib);
d_expbd1_d_vgin=d_explim(expbdarg1,d_expbdarg1_d_vgin);
d_expbd1_d_phitin=d_explim(expbdarg1,d_expbdarg1_d_phitin);
d_expbd1_d_vgsatin=d_explim(expbdarg1,d_expbdarg1_d_vgsatin);
d_expbd1_d_alphagin=d_explim(expbdarg1,d_expbdarg1_d_alphagin);
d_expbd1_d_fracin=d_explim(expbdarg1,d_expbdarg1_d_fracin);
d_expbd1_d_pg_paramin=d_explim(expbdarg1,d_expbdarg1_d_pg_paramin);
d_expbd1_d_pbdgin=d_explim(expbdarg1,d_expbdarg1_d_pbdgin);
d_expbd1_d_vbdgin=d_explim(expbdarg1,d_expbdarg1_d_vbdgin);
d_expbd1_d_tambin=d_explim(expbdarg1,d_expbdarg1_d_tambin);
d_expbd1_d_tnomin=d_explim(expbdarg1,d_expbdarg1_d_tnomin);
d_expbd1_d_w=d_explim(expbdarg1,d_expbdarg1_d_w);
d_expbd1_d_ngf=d_explim(expbdarg1,d_expbdarg1_d_ngf);
d_expbd1_d_ijin=d_explim(expbdarg1,d_expbdarg1_d_ijin);
d_expbd1_d_kbdgatein=d_explim(expbdarg1,d_expbdarg1_d_kbdgatein);
d_expbd1_d_vgsatqin=d_explim(expbdarg1,d_expbdarg1_d_vgsatqin);
d_expbd1_d_betarecin=d_explim(expbdarg1,d_expbdarg1_d_betarecin);
d_expbd1_d_irecin=d_explim(expbdarg1,d_expbdarg1_d_irecin);
d_expbd1_d_pgsrecin=d_explim(expbdarg1,d_expbdarg1_d_pgsrecin);
d_expbd1_d_pg_param1=d_explim(expbdarg1,d_expbdarg1_d_pg_param1);
d_expbd1_d_vjg=d_explim(expbdarg1,d_expbdarg1_d_vjg);
d_expbd1_d_type=d_explim(expbdarg1,d_expbdarg1_d_type);
expbd1=explim(expbdarg1);
d_expbd2_d_vgin=d_explim(expbdarg2,d_expbdarg2_d_vgin);
d_expbd2_d_phitin=d_explim(expbdarg2,d_expbdarg2_d_phitin);
d_expbd2_d_vgsatin=d_explim(expbdarg2,d_expbdarg2_d_vgsatin);
d_expbd2_d_alphagin=d_explim(expbdarg2,d_expbdarg2_d_alphagin);
d_expbd2_d_fracin=d_explim(expbdarg2,d_expbdarg2_d_fracin);
d_expbd2_d_pg_paramin=d_explim(expbdarg2,d_expbdarg2_d_pg_paramin);
d_expbd2_d_pbdgin=d_explim(expbdarg2,d_expbdarg2_d_pbdgin);
d_expbd2_d_vbdgin=d_explim(expbdarg2,d_expbdarg2_d_vbdgin);
d_expbd2_d_tambin=d_explim(expbdarg2,d_expbdarg2_d_tambin);
d_expbd2_d_tnomin=d_explim(expbdarg2,d_expbdarg2_d_tnomin);
d_expbd2_d_w=d_explim(expbdarg2,d_expbdarg2_d_w);
d_expbd2_d_ngf=d_explim(expbdarg2,d_expbdarg2_d_ngf);
d_expbd2_d_ijin=d_explim(expbdarg2,d_expbdarg2_d_ijin);
d_expbd2_d_kbdgatein=d_explim(expbdarg2,d_expbdarg2_d_kbdgatein);
d_expbd2_d_vgsatqin=d_explim(expbdarg2,d_expbdarg2_d_vgsatqin);
d_expbd2_d_betarecin=d_explim(expbdarg2,d_expbdarg2_d_betarecin);
d_expbd2_d_irecin=d_explim(expbdarg2,d_expbdarg2_d_irecin);
d_expbd2_d_pgsrecin=d_explim(expbdarg2,d_expbdarg2_d_pgsrecin);
d_expbd2_d_pg_param1=d_explim(expbdarg2,d_expbdarg2_d_pg_param1);
d_expbd2_d_vjg=d_explim(expbdarg2,d_expbdarg2_d_vjg);
d_expbd2_d_type=d_explim(expbdarg2,d_expbdarg2_d_type);
expbd2=explim(expbdarg2);
d_iginbd_d_vgin=(d_expbd1_d_vgin-d_expbd2_d_vgin);
d_iginbd_d_phitin=(d_expbd1_d_phitin-d_expbd2_d_phitin);
d_iginbd_d_vgsatin=(d_expbd1_d_vgsatin-d_expbd2_d_vgsatin);
d_iginbd_d_alphagin=(d_expbd1_d_alphagin-d_expbd2_d_alphagin);
d_iginbd_d_fracin=(d_expbd1_d_fracin-d_expbd2_d_fracin);
d_iginbd_d_pg_paramin=(d_expbd1_d_pg_paramin-d_expbd2_d_pg_paramin);
d_iginbd_d_pbdgin=(d_expbd1_d_pbdgin-d_expbd2_d_pbdgin);
d_iginbd_d_vbdgin=(d_expbd1_d_vbdgin-d_expbd2_d_vbdgin);
d_iginbd_d_tambin=(d_expbd1_d_tambin-d_expbd2_d_tambin);
d_iginbd_d_tnomin=(d_expbd1_d_tnomin-d_expbd2_d_tnomin);
d_iginbd_d_w=(d_expbd1_d_w-d_expbd2_d_w);
d_iginbd_d_ngf=(d_expbd1_d_ngf-d_expbd2_d_ngf);
d_iginbd_d_ijin=(d_expbd1_d_ijin-d_expbd2_d_ijin);
d_iginbd_d_kbdgatein=(d_expbd1_d_kbdgatein-d_expbd2_d_kbdgatein);
d_iginbd_d_vgsatqin=(d_expbd1_d_vgsatqin-d_expbd2_d_vgsatqin);
d_iginbd_d_betarecin=(d_expbd1_d_betarecin-d_expbd2_d_betarecin);
d_iginbd_d_irecin=(d_expbd1_d_irecin-d_expbd2_d_irecin);
d_iginbd_d_pgsrecin=(d_expbd1_d_pgsrecin-d_expbd2_d_pgsrecin);
d_iginbd_d_pg_param1=(d_expbd1_d_pg_param1-d_expbd2_d_pg_param1);
d_iginbd_d_vjg=(d_expbd1_d_vjg-d_expbd2_d_vjg);
d_iginbd_d_type=(d_expbd1_d_type-d_expbd2_d_type);
iginbd=(expbd1-expbd2);
d_tfacdiode_d_vgin=0.0;
d_tfacdiode_d_phitin=0.0;
d_tfacdiode_d_vgsatin=0.0;
d_tfacdiode_d_alphagin=0.0;
d_tfacdiode_d_fracin=0.0;
d_tfacdiode_d_pg_paramin=0.0;
d_tfacdiode_d_pbdgin=0.0;
d_tfacdiode_d_vbdgin=0.0;
d_tfacdiode_d_tambin=(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),3.0)*3.0/(tambin/tnomin)))*(1.0/tnomin);
d_tfacdiode_d_tnomin=(((tambin/tnomin)==0.0)?0.0:(pow((tambin/tnomin),3.0)*3.0/(tambin/tnomin)))*(-tambin/tnomin/tnomin);
d_tfacdiode_d_w=0.0;
d_tfacdiode_d_ngf=0.0;
d_tfacdiode_d_ijin=0.0;
d_tfacdiode_d_kbdgatein=0.0;
d_tfacdiode_d_vgsatqin=0.0;
d_tfacdiode_d_betarecin=0.0;
d_tfacdiode_d_irecin=0.0;
d_tfacdiode_d_pgsrecin=0.0;
d_tfacdiode_d_pg_param1=0.0;
d_tfacdiode_d_vjg=0.0;
d_tfacdiode_d_type=0.0;
tfacdiode=pow((tambin/tnomin),3.0);
d_isdiodeout_d_vgin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vgin);
d_isdiodeout_d_phitin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_phitin);
d_isdiodeout_d_vgsatin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vgsatin);
d_isdiodeout_d_alphagin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_alphagin);
d_isdiodeout_d_fracin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_fracin);
d_isdiodeout_d_pg_paramin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pg_paramin);
d_isdiodeout_d_pbdgin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pbdgin);
d_isdiodeout_d_vbdgin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vbdgin);
d_isdiodeout_d_tambin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_tambin);
d_isdiodeout_d_tnomin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_tnomin);
d_isdiodeout_d_w=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_w)+((((type)*ngf)*ijin)*tfacdiode));
d_isdiodeout_d_ngf=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_ngf)+((((type*w))*ijin)*tfacdiode));
d_isdiodeout_d_ijin=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_ijin)+((((type*w)*ngf))*tfacdiode));
d_isdiodeout_d_kbdgatein=((((type*w)*ngf)*ijin)*d_tfacdiode_d_kbdgatein);
d_isdiodeout_d_vgsatqin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vgsatqin);
d_isdiodeout_d_betarecin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_betarecin);
d_isdiodeout_d_irecin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_irecin);
d_isdiodeout_d_pgsrecin=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pgsrecin);
d_isdiodeout_d_pg_param1=((((type*w)*ngf)*ijin)*d_tfacdiode_d_pg_param1);
d_isdiodeout_d_vjg=((((type*w)*ngf)*ijin)*d_tfacdiode_d_vjg);
d_isdiodeout_d_type=(((((type*w)*ngf)*ijin)*d_tfacdiode_d_type)+((((w)*ngf)*ijin)*tfacdiode));
isdiodeout=((((type*w)*ngf)*ijin)*tfacdiode);
d_expiforarg_d_vgin=(((pgin/phitin)+vgin*(d_pgin_d_vgin/phitin))+d_expphib_d_vgin);
d_expiforarg_d_phitin=((((phitin*d_pgin_d_phitin-pgin)/phitin/phitin)*vgin)+d_expphib_d_phitin);
d_expiforarg_d_vgsatin=(((d_pgin_d_vgsatin/phitin)*vgin)+d_expphib_d_vgsatin);
d_expiforarg_d_alphagin=(((d_pgin_d_alphagin/phitin)*vgin)+d_expphib_d_alphagin);
d_expiforarg_d_fracin=(((d_pgin_d_fracin/phitin)*vgin)+d_expphib_d_fracin);
d_expiforarg_d_pg_paramin=(((d_pgin_d_pg_paramin/phitin)*vgin)+d_expphib_d_pg_paramin);
d_expiforarg_d_pbdgin=(((d_pgin_d_pbdgin/phitin)*vgin)+d_expphib_d_pbdgin);
d_expiforarg_d_vbdgin=(((d_pgin_d_vbdgin/phitin)*vgin)+d_expphib_d_vbdgin);
d_expiforarg_d_tambin=(((d_pgin_d_tambin/phitin)*vgin)+d_expphib_d_tambin);
d_expiforarg_d_tnomin=(((d_pgin_d_tnomin/phitin)*vgin)+d_expphib_d_tnomin);
d_expiforarg_d_w=(((d_pgin_d_w/phitin)*vgin)+d_expphib_d_w);
d_expiforarg_d_ngf=(((d_pgin_d_ngf/phitin)*vgin)+d_expphib_d_ngf);
d_expiforarg_d_ijin=(((d_pgin_d_ijin/phitin)*vgin)+d_expphib_d_ijin);
d_expiforarg_d_kbdgatein=(((d_pgin_d_kbdgatein/phitin)*vgin)+d_expphib_d_kbdgatein);
d_expiforarg_d_vgsatqin=(((d_pgin_d_vgsatqin/phitin)*vgin)+d_expphib_d_vgsatqin);
d_expiforarg_d_betarecin=(((d_pgin_d_betarecin/phitin)*vgin)+d_expphib_d_betarecin);
d_expiforarg_d_irecin=(((d_pgin_d_irecin/phitin)*vgin)+d_expphib_d_irecin);
d_expiforarg_d_pgsrecin=(((d_pgin_d_pgsrecin/phitin)*vgin)+d_expphib_d_pgsrecin);
d_expiforarg_d_pg_param1=(((d_pgin_d_pg_param1/phitin)*vgin)+d_expphib_d_pg_param1);
d_expiforarg_d_vjg=(((d_pgin_d_vjg/phitin)*vgin)+d_expphib_d_vjg);
d_expiforarg_d_type=(((d_pgin_d_type/phitin)*vgin)+d_expphib_d_type);
expiforarg=(((pgin/phitin)*vgin)+expphib);
d_expifor_d_vgin=d_explim(expiforarg,d_expiforarg_d_vgin);
d_expifor_d_phitin=d_explim(expiforarg,d_expiforarg_d_phitin);
d_expifor_d_vgsatin=d_explim(expiforarg,d_expiforarg_d_vgsatin);
d_expifor_d_alphagin=d_explim(expiforarg,d_expiforarg_d_alphagin);
d_expifor_d_fracin=d_explim(expiforarg,d_expiforarg_d_fracin);
d_expifor_d_pg_paramin=d_explim(expiforarg,d_expiforarg_d_pg_paramin);
d_expifor_d_pbdgin=d_explim(expiforarg,d_expiforarg_d_pbdgin);
d_expifor_d_vbdgin=d_explim(expiforarg,d_expiforarg_d_vbdgin);
d_expifor_d_tambin=d_explim(expiforarg,d_expiforarg_d_tambin);
d_expifor_d_tnomin=d_explim(expiforarg,d_expiforarg_d_tnomin);
d_expifor_d_w=d_explim(expiforarg,d_expiforarg_d_w);
d_expifor_d_ngf=d_explim(expiforarg,d_expiforarg_d_ngf);
d_expifor_d_ijin=d_explim(expiforarg,d_expiforarg_d_ijin);
d_expifor_d_kbdgatein=d_explim(expiforarg,d_expiforarg_d_kbdgatein);
d_expifor_d_vgsatqin=d_explim(expiforarg,d_expiforarg_d_vgsatqin);
d_expifor_d_betarecin=d_explim(expiforarg,d_expiforarg_d_betarecin);
d_expifor_d_irecin=d_explim(expiforarg,d_expiforarg_d_irecin);
d_expifor_d_pgsrecin=d_explim(expiforarg,d_expiforarg_d_pgsrecin);
d_expifor_d_pg_param1=d_explim(expiforarg,d_expiforarg_d_pg_param1);
d_expifor_d_vjg=d_explim(expiforarg,d_expiforarg_d_vjg);
d_expifor_d_type=d_explim(expiforarg,d_expiforarg_d_type);
expifor=explim(expiforarg);
d_igindiode_d_vgin=((isdiodeout*((d_expifor_d_vgin-(kbdgatein*d_iginbd_d_vgin))-d_t0_d_vgin))+(d_isdiodeout_d_vgin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_phitin=((isdiodeout*((d_expifor_d_phitin-(kbdgatein*d_iginbd_d_phitin))-d_t0_d_phitin))+(d_isdiodeout_d_phitin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vgsatin=((isdiodeout*((d_expifor_d_vgsatin-(kbdgatein*d_iginbd_d_vgsatin))-d_t0_d_vgsatin))+(d_isdiodeout_d_vgsatin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_alphagin=((isdiodeout*((d_expifor_d_alphagin-(kbdgatein*d_iginbd_d_alphagin))-d_t0_d_alphagin))+(d_isdiodeout_d_alphagin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_fracin=((isdiodeout*((d_expifor_d_fracin-(kbdgatein*d_iginbd_d_fracin))-d_t0_d_fracin))+(d_isdiodeout_d_fracin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pg_paramin=((isdiodeout*((d_expifor_d_pg_paramin-(kbdgatein*d_iginbd_d_pg_paramin))-d_t0_d_pg_paramin))+(d_isdiodeout_d_pg_paramin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pbdgin=((isdiodeout*((d_expifor_d_pbdgin-(kbdgatein*d_iginbd_d_pbdgin))-d_t0_d_pbdgin))+(d_isdiodeout_d_pbdgin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vbdgin=((isdiodeout*((d_expifor_d_vbdgin-(kbdgatein*d_iginbd_d_vbdgin))-d_t0_d_vbdgin))+(d_isdiodeout_d_vbdgin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_tambin=((isdiodeout*((d_expifor_d_tambin-(kbdgatein*d_iginbd_d_tambin))-d_t0_d_tambin))+(d_isdiodeout_d_tambin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_tnomin=((isdiodeout*((d_expifor_d_tnomin-(kbdgatein*d_iginbd_d_tnomin))-d_t0_d_tnomin))+(d_isdiodeout_d_tnomin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_w=((isdiodeout*((d_expifor_d_w-(kbdgatein*d_iginbd_d_w))-d_t0_d_w))+(d_isdiodeout_d_w*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_ngf=((isdiodeout*((d_expifor_d_ngf-(kbdgatein*d_iginbd_d_ngf))-d_t0_d_ngf))+(d_isdiodeout_d_ngf*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_ijin=((isdiodeout*((d_expifor_d_ijin-(kbdgatein*d_iginbd_d_ijin))-d_t0_d_ijin))+(d_isdiodeout_d_ijin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_kbdgatein=((isdiodeout*((d_expifor_d_kbdgatein-(kbdgatein*d_iginbd_d_kbdgatein+iginbd))-d_t0_d_kbdgatein))+(d_isdiodeout_d_kbdgatein*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vgsatqin=((isdiodeout*((d_expifor_d_vgsatqin-(kbdgatein*d_iginbd_d_vgsatqin))-d_t0_d_vgsatqin))+(d_isdiodeout_d_vgsatqin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_betarecin=((isdiodeout*((d_expifor_d_betarecin-(kbdgatein*d_iginbd_d_betarecin))-d_t0_d_betarecin))+(d_isdiodeout_d_betarecin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_irecin=((isdiodeout*((d_expifor_d_irecin-(kbdgatein*d_iginbd_d_irecin))-d_t0_d_irecin))+(d_isdiodeout_d_irecin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pgsrecin=((isdiodeout*((d_expifor_d_pgsrecin-(kbdgatein*d_iginbd_d_pgsrecin))-d_t0_d_pgsrecin))+(d_isdiodeout_d_pgsrecin*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_pg_param1=((isdiodeout*((d_expifor_d_pg_param1-(kbdgatein*d_iginbd_d_pg_param1))-d_t0_d_pg_param1))+(d_isdiodeout_d_pg_param1*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_vjg=((isdiodeout*((d_expifor_d_vjg-(kbdgatein*d_iginbd_d_vjg))-d_t0_d_vjg))+(d_isdiodeout_d_vjg*((expifor-(kbdgatein*iginbd))-t0)));
d_igindiode_d_type=((isdiodeout*((d_expifor_d_type-(kbdgatein*d_iginbd_d_type))-d_t0_d_type))+(d_isdiodeout_d_type*((expifor-(kbdgatein*iginbd))-t0)));
igindiode=(isdiodeout*((expifor-(kbdgatein*iginbd))-t0));
d_frecgin_d_vgin=((pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(-1.0)-(-vgin)*(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(1.0/betarecin)/(1.0+pow(absfunc((vgin/vgsatqin)),betarecin))))*((absfunc((vgin/vgsatqin))==0.0)?0.0:(pow(absfunc((vgin/vgsatqin)),betarecin)*betarecin/absfunc((vgin/vgsatqin))))*d_absfunc((vgin/vgsatqin),(1.0/vgsatqin)))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_frecgin_d_phitin=0.0;
d_frecgin_d_vgsatin=0.0;
d_frecgin_d_alphagin=0.0;
d_frecgin_d_fracin=0.0;
d_frecgin_d_pg_paramin=0.0;
d_frecgin_d_pbdgin=0.0;
d_frecgin_d_vbdgin=0.0;
d_frecgin_d_tambin=0.0;
d_frecgin_d_tnomin=0.0;
d_frecgin_d_w=0.0;
d_frecgin_d_ngf=0.0;
d_frecgin_d_ijin=0.0;
d_frecgin_d_kbdgatein=0.0;
d_frecgin_d_vgsatqin=(-(-vgin)*(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(1.0/betarecin)/(1.0+pow(absfunc((vgin/vgsatqin)),betarecin))))*((absfunc((vgin/vgsatqin))==0.0)?0.0:(pow(absfunc((vgin/vgsatqin)),betarecin)*betarecin/absfunc((vgin/vgsatqin))))*d_absfunc((vgin/vgsatqin),(-vgin/vgsatqin/vgsatqin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_frecgin_d_betarecin=(-(-vgin)*(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))*(1.0/betarecin)/(1.0+pow(absfunc((vgin/vgsatqin)),betarecin))))*((absfunc((vgin/vgsatqin))==0.0)?0.0:(log(absfunc((vgin/vgsatqin))*pow(absfunc((vgin/vgsatqin)),betarecin))))+(((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))==0.0)?0.0:(log((1.0+pow(absfunc((vgin/vgsatqin)),betarecin))*pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)))))*(-1.0/betarecin/betarecin)/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin))/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_frecgin_d_irecin=0.0;
d_frecgin_d_pgsrecin=0.0;
d_frecgin_d_pg_param1=0.0;
d_frecgin_d_vjg=0.0;
d_frecgin_d_type=0.0;
frecgin=((-vgin)/pow((1.0+pow(absfunc((vgin/vgsatqin)),betarecin)),(1.0/betarecin)));
d_isrecout_d_vgin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vgin)*1.0);
d_isrecout_d_phitin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_phitin)*1.0);
d_isrecout_d_vgsatin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vgsatin)*1.0);
d_isrecout_d_alphagin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_alphagin)*1.0);
d_isrecout_d_fracin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_fracin)*1.0);
d_isrecout_d_pg_paramin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pg_paramin)*1.0);
d_isrecout_d_pbdgin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pbdgin)*1.0);
d_isrecout_d_vbdgin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vbdgin)*1.0);
d_isrecout_d_tambin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_tambin)*1.0);
d_isrecout_d_tnomin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_tnomin)*1.0);
d_isrecout_d_w=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_w)+(((((-type))*ngf)*irecin)*tfacdiode))*1.0);
d_isrecout_d_ngf=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_ngf)+(((((-type)*w))*irecin)*tfacdiode))*1.0);
d_isrecout_d_ijin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_ijin)*1.0);
d_isrecout_d_kbdgatein=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_kbdgatein)*1.0);
d_isrecout_d_vgsatqin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vgsatqin)*1.0);
d_isrecout_d_betarecin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_betarecin)*1.0);
d_isrecout_d_irecin=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_irecin)+(((((-type)*w)*ngf))*tfacdiode))*1.0);
d_isrecout_d_pgsrecin=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pgsrecin)*1.0);
d_isrecout_d_pg_param1=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_pg_param1)*1.0);
d_isrecout_d_vjg=((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_vjg)*1.0);
d_isrecout_d_type=(((((((-type)*w)*ngf)*irecin)*d_tfacdiode_d_type)+(((((-1.0)*w)*ngf)*irecin)*tfacdiode))*1.0);
isrecout=((((((-type)*w)*ngf)*irecin)*tfacdiode)*1.0);
d_expirevarg_d_vgin=((pgsrecin/phitin)*d_frecgin_d_vgin);
d_expirevarg_d_phitin=(((pgsrecin/phitin)*d_frecgin_d_phitin)+((-pgsrecin/phitin/phitin)*frecgin));
d_expirevarg_d_vgsatin=((pgsrecin/phitin)*d_frecgin_d_vgsatin);
d_expirevarg_d_alphagin=((pgsrecin/phitin)*d_frecgin_d_alphagin);
d_expirevarg_d_fracin=((pgsrecin/phitin)*d_frecgin_d_fracin);
d_expirevarg_d_pg_paramin=((pgsrecin/phitin)*d_frecgin_d_pg_paramin);
d_expirevarg_d_pbdgin=((pgsrecin/phitin)*d_frecgin_d_pbdgin);
d_expirevarg_d_vbdgin=((pgsrecin/phitin)*d_frecgin_d_vbdgin);
d_expirevarg_d_tambin=((pgsrecin/phitin)*d_frecgin_d_tambin);
d_expirevarg_d_tnomin=((pgsrecin/phitin)*d_frecgin_d_tnomin);
d_expirevarg_d_w=((pgsrecin/phitin)*d_frecgin_d_w);
d_expirevarg_d_ngf=((pgsrecin/phitin)*d_frecgin_d_ngf);
d_expirevarg_d_ijin=((pgsrecin/phitin)*d_frecgin_d_ijin);
d_expirevarg_d_kbdgatein=((pgsrecin/phitin)*d_frecgin_d_kbdgatein);
d_expirevarg_d_vgsatqin=((pgsrecin/phitin)*d_frecgin_d_vgsatqin);
d_expirevarg_d_betarecin=((pgsrecin/phitin)*d_frecgin_d_betarecin);
d_expirevarg_d_irecin=((pgsrecin/phitin)*d_frecgin_d_irecin);
d_expirevarg_d_pgsrecin=(((pgsrecin/phitin)*d_frecgin_d_pgsrecin)+((1.0/phitin)*frecgin));
d_expirevarg_d_pg_param1=((pgsrecin/phitin)*d_frecgin_d_pg_param1);
d_expirevarg_d_vjg=((pgsrecin/phitin)*d_frecgin_d_vjg);
d_expirevarg_d_type=((pgsrecin/phitin)*d_frecgin_d_type);
expirevarg=((pgsrecin/phitin)*frecgin);
d_expirev_d_vgin=d_explim(expirevarg,d_expirevarg_d_vgin);
d_expirev_d_phitin=d_explim(expirevarg,d_expirevarg_d_phitin);
d_expirev_d_vgsatin=d_explim(expirevarg,d_expirevarg_d_vgsatin);
d_expirev_d_alphagin=d_explim(expirevarg,d_expirevarg_d_alphagin);
d_expirev_d_fracin=d_explim(expirevarg,d_expirevarg_d_fracin);
d_expirev_d_pg_paramin=d_explim(expirevarg,d_expirevarg_d_pg_paramin);
d_expirev_d_pbdgin=d_explim(expirevarg,d_expirevarg_d_pbdgin);
d_expirev_d_vbdgin=d_explim(expirevarg,d_expirevarg_d_vbdgin);
d_expirev_d_tambin=d_explim(expirevarg,d_expirevarg_d_tambin);
d_expirev_d_tnomin=d_explim(expirevarg,d_expirevarg_d_tnomin);
d_expirev_d_w=d_explim(expirevarg,d_expirevarg_d_w);
d_expirev_d_ngf=d_explim(expirevarg,d_expirevarg_d_ngf);
d_expirev_d_ijin=d_explim(expirevarg,d_expirevarg_d_ijin);
d_expirev_d_kbdgatein=d_explim(expirevarg,d_expirevarg_d_kbdgatein);
d_expirev_d_vgsatqin=d_explim(expirevarg,d_expirevarg_d_vgsatqin);
d_expirev_d_betarecin=d_explim(expirevarg,d_expirevarg_d_betarecin);
d_expirev_d_irecin=d_explim(expirevarg,d_expirevarg_d_irecin);
d_expirev_d_pgsrecin=d_explim(expirevarg,d_expirevarg_d_pgsrecin);
d_expirev_d_pg_param1=d_explim(expirevarg,d_expirevarg_d_pg_param1);
d_expirev_d_vjg=d_explim(expirevarg,d_expirevarg_d_vjg);
d_expirev_d_type=d_explim(expirevarg,d_expirevarg_d_type);
expirev=explim(expirevarg);
d_iginrec_d_vgin=((isrecout*d_expirev_d_vgin)+(d_isrecout_d_vgin*(expirev-1.0)));
d_iginrec_d_phitin=((isrecout*d_expirev_d_phitin)+(d_isrecout_d_phitin*(expirev-1.0)));
d_iginrec_d_vgsatin=((isrecout*d_expirev_d_vgsatin)+(d_isrecout_d_vgsatin*(expirev-1.0)));
d_iginrec_d_alphagin=((isrecout*d_expirev_d_alphagin)+(d_isrecout_d_alphagin*(expirev-1.0)));
d_iginrec_d_fracin=((isrecout*d_expirev_d_fracin)+(d_isrecout_d_fracin*(expirev-1.0)));
d_iginrec_d_pg_paramin=((isrecout*d_expirev_d_pg_paramin)+(d_isrecout_d_pg_paramin*(expirev-1.0)));
d_iginrec_d_pbdgin=((isrecout*d_expirev_d_pbdgin)+(d_isrecout_d_pbdgin*(expirev-1.0)));
d_iginrec_d_vbdgin=((isrecout*d_expirev_d_vbdgin)+(d_isrecout_d_vbdgin*(expirev-1.0)));
d_iginrec_d_tambin=((isrecout*d_expirev_d_tambin)+(d_isrecout_d_tambin*(expirev-1.0)));
d_iginrec_d_tnomin=((isrecout*d_expirev_d_tnomin)+(d_isrecout_d_tnomin*(expirev-1.0)));
d_iginrec_d_w=((isrecout*d_expirev_d_w)+(d_isrecout_d_w*(expirev-1.0)));
d_iginrec_d_ngf=((isrecout*d_expirev_d_ngf)+(d_isrecout_d_ngf*(expirev-1.0)));
d_iginrec_d_ijin=((isrecout*d_expirev_d_ijin)+(d_isrecout_d_ijin*(expirev-1.0)));
d_iginrec_d_kbdgatein=((isrecout*d_expirev_d_kbdgatein)+(d_isrecout_d_kbdgatein*(expirev-1.0)));
d_iginrec_d_vgsatqin=((isrecout*d_expirev_d_vgsatqin)+(d_isrecout_d_vgsatqin*(expirev-1.0)));
d_iginrec_d_betarecin=((isrecout*d_expirev_d_betarecin)+(d_isrecout_d_betarecin*(expirev-1.0)));
d_iginrec_d_irecin=((isrecout*d_expirev_d_irecin)+(d_isrecout_d_irecin*(expirev-1.0)));
d_iginrec_d_pgsrecin=((isrecout*d_expirev_d_pgsrecin)+(d_isrecout_d_pgsrecin*(expirev-1.0)));
d_iginrec_d_pg_param1=((isrecout*d_expirev_d_pg_param1)+(d_isrecout_d_pg_param1*(expirev-1.0)));
d_iginrec_d_vjg=((isrecout*d_expirev_d_vjg)+(d_isrecout_d_vjg*(expirev-1.0)));
d_iginrec_d_type=((isrecout*d_expirev_d_type)+(d_isrecout_d_type*(expirev-1.0)));
iginrec=(isrecout*(expirev-1.0));
d_igout_d_vgin=(d_igindiode_d_vgin+d_iginrec_d_vgin);
d_igout_d_phitin=(d_igindiode_d_phitin+d_iginrec_d_phitin);
d_igout_d_vgsatin=(d_igindiode_d_vgsatin+d_iginrec_d_vgsatin);
d_igout_d_alphagin=(d_igindiode_d_alphagin+d_iginrec_d_alphagin);
d_igout_d_fracin=(d_igindiode_d_fracin+d_iginrec_d_fracin);
d_igout_d_pg_paramin=(d_igindiode_d_pg_paramin+d_iginrec_d_pg_paramin);
d_igout_d_pbdgin=(d_igindiode_d_pbdgin+d_iginrec_d_pbdgin);
d_igout_d_vbdgin=(d_igindiode_d_vbdgin+d_iginrec_d_vbdgin);
d_igout_d_tambin=(d_igindiode_d_tambin+d_iginrec_d_tambin);
d_igout_d_tnomin=(d_igindiode_d_tnomin+d_iginrec_d_tnomin);
d_igout_d_w=(d_igindiode_d_w+d_iginrec_d_w);
d_igout_d_ngf=(d_igindiode_d_ngf+d_iginrec_d_ngf);
d_igout_d_ijin=(d_igindiode_d_ijin+d_iginrec_d_ijin);
d_igout_d_kbdgatein=(d_igindiode_d_kbdgatein+d_iginrec_d_kbdgatein);
d_igout_d_vgsatqin=(d_igindiode_d_vgsatqin+d_iginrec_d_vgsatqin);
d_igout_d_betarecin=(d_igindiode_d_betarecin+d_iginrec_d_betarecin);
d_igout_d_irecin=(d_igindiode_d_irecin+d_iginrec_d_irecin);
d_igout_d_pgsrecin=(d_igindiode_d_pgsrecin+d_iginrec_d_pgsrecin);
d_igout_d_pg_param1=(d_igindiode_d_pg_param1+d_iginrec_d_pg_param1);
d_igout_d_vjg=(d_igindiode_d_vjg+d_iginrec_d_vjg);
d_igout_d_type=(d_igindiode_d_type+d_iginrec_d_type);
igout=(igindiode+iginrec);
d_calc_ig_d_vgin=d_igout_d_vgin;
d_calc_ig_d_phitin=d_igout_d_phitin;
d_calc_ig_d_vgsatin=d_igout_d_vgsatin;
d_calc_ig_d_alphagin=d_igout_d_alphagin;
d_calc_ig_d_fracin=d_igout_d_fracin;
d_calc_ig_d_pg_paramin=d_igout_d_pg_paramin;
d_calc_ig_d_pbdgin=d_igout_d_pbdgin;
d_calc_ig_d_vbdgin=d_igout_d_vbdgin;
d_calc_ig_d_tambin=d_igout_d_tambin;
d_calc_ig_d_tnomin=d_igout_d_tnomin;
d_calc_ig_d_w=d_igout_d_w;
d_calc_ig_d_ngf=d_igout_d_ngf;
d_calc_ig_d_ijin=d_igout_d_ijin;
d_calc_ig_d_kbdgatein=d_igout_d_kbdgatein;
d_calc_ig_d_vgsatqin=d_igout_d_vgsatqin;
d_calc_ig_d_betarecin=d_igout_d_betarecin;
d_calc_ig_d_irecin=d_igout_d_irecin;
d_calc_ig_d_pgsrecin=d_igout_d_pgsrecin;
d_calc_ig_d_pg_param1=d_igout_d_pg_param1;
d_calc_ig_d_vjg=d_igout_d_vjg;
d_calc_ig_d_type=d_igout_d_type;
calc_ig=igout;
}
  // now save outputs and derivs into appropriate return vars
  calc_igReturn.value=calc_ig;
  calc_igReturn.deriv_WRT_vgin = d_calc_ig_d_vgin;
  calc_igReturn.deriv_WRT_phitin = d_calc_ig_d_phitin;
  calc_igReturn.deriv_WRT_vgsatin = d_calc_ig_d_vgsatin;
  calc_igReturn.deriv_WRT_alphagin = d_calc_ig_d_alphagin;
  calc_igReturn.deriv_WRT_fracin = d_calc_ig_d_fracin;
  calc_igReturn.deriv_WRT_pg_paramin = d_calc_ig_d_pg_paramin;
  calc_igReturn.deriv_WRT_pbdgin = d_calc_ig_d_pbdgin;
  calc_igReturn.deriv_WRT_vbdgin = d_calc_ig_d_vbdgin;
  calc_igReturn.deriv_WRT_tambin = d_calc_ig_d_tambin;
  calc_igReturn.deriv_WRT_tnomin = d_calc_ig_d_tnomin;
  calc_igReturn.deriv_WRT_w = d_calc_ig_d_w;
  calc_igReturn.deriv_WRT_ngf = d_calc_ig_d_ngf;
  calc_igReturn.deriv_WRT_ijin = d_calc_ig_d_ijin;
  calc_igReturn.deriv_WRT_kbdgatein = d_calc_ig_d_kbdgatein;
  calc_igReturn.deriv_WRT_vgsatqin = d_calc_ig_d_vgsatqin;
  calc_igReturn.deriv_WRT_betarecin = d_calc_ig_d_betarecin;
  calc_igReturn.deriv_WRT_irecin = d_calc_ig_d_irecin;
  calc_igReturn.deriv_WRT_pgsrecin = d_calc_ig_d_pgsrecin;
  calc_igReturn.deriv_WRT_pg_param1 = d_calc_ig_d_pg_param1;
  calc_igReturn.deriv_WRT_vjg = d_calc_ig_d_vjg;
  calc_igReturn.deriv_WRT_type = d_calc_ig_d_type;
  isdiodeoutReturn.value = isdiodeout;
  isdiodeoutReturn.deriv_WRT_vgin = d_isdiodeout_d_vgin;
  isdiodeoutReturn.deriv_WRT_phitin = d_isdiodeout_d_phitin;
  isdiodeoutReturn.deriv_WRT_vgsatin = d_isdiodeout_d_vgsatin;
  isdiodeoutReturn.deriv_WRT_alphagin = d_isdiodeout_d_alphagin;
  isdiodeoutReturn.deriv_WRT_fracin = d_isdiodeout_d_fracin;
  isdiodeoutReturn.deriv_WRT_pg_paramin = d_isdiodeout_d_pg_paramin;
  isdiodeoutReturn.deriv_WRT_pbdgin = d_isdiodeout_d_pbdgin;
  isdiodeoutReturn.deriv_WRT_vbdgin = d_isdiodeout_d_vbdgin;
  isdiodeoutReturn.deriv_WRT_tambin = d_isdiodeout_d_tambin;
  isdiodeoutReturn.deriv_WRT_tnomin = d_isdiodeout_d_tnomin;
  isdiodeoutReturn.deriv_WRT_w = d_isdiodeout_d_w;
  isdiodeoutReturn.deriv_WRT_ngf = d_isdiodeout_d_ngf;
  isdiodeoutReturn.deriv_WRT_ijin = d_isdiodeout_d_ijin;
  isdiodeoutReturn.deriv_WRT_kbdgatein = d_isdiodeout_d_kbdgatein;
  isdiodeoutReturn.deriv_WRT_vgsatqin = d_isdiodeout_d_vgsatqin;
  isdiodeoutReturn.deriv_WRT_betarecin = d_isdiodeout_d_betarecin;
  isdiodeoutReturn.deriv_WRT_irecin = d_isdiodeout_d_irecin;
  isdiodeoutReturn.deriv_WRT_pgsrecin = d_isdiodeout_d_pgsrecin;
  isdiodeoutReturn.deriv_WRT_pg_param1 = d_isdiodeout_d_pg_param1;
  isdiodeoutReturn.deriv_WRT_vjg = d_isdiodeout_d_vjg;
  isdiodeoutReturn.deriv_WRT_type = d_isdiodeout_d_type;
  isrecoutReturn.value = isrecout;
  isrecoutReturn.deriv_WRT_vgin = d_isrecout_d_vgin;
  isrecoutReturn.deriv_WRT_phitin = d_isrecout_d_phitin;
  isrecoutReturn.deriv_WRT_vgsatin = d_isrecout_d_vgsatin;
  isrecoutReturn.deriv_WRT_alphagin = d_isrecout_d_alphagin;
  isrecoutReturn.deriv_WRT_fracin = d_isrecout_d_fracin;
  isrecoutReturn.deriv_WRT_pg_paramin = d_isrecout_d_pg_paramin;
  isrecoutReturn.deriv_WRT_pbdgin = d_isrecout_d_pbdgin;
  isrecoutReturn.deriv_WRT_vbdgin = d_isrecout_d_vbdgin;
  isrecoutReturn.deriv_WRT_tambin = d_isrecout_d_tambin;
  isrecoutReturn.deriv_WRT_tnomin = d_isrecout_d_tnomin;
  isrecoutReturn.deriv_WRT_w = d_isrecout_d_w;
  isrecoutReturn.deriv_WRT_ngf = d_isrecout_d_ngf;
  isrecoutReturn.deriv_WRT_ijin = d_isrecout_d_ijin;
  isrecoutReturn.deriv_WRT_kbdgatein = d_isrecout_d_kbdgatein;
  isrecoutReturn.deriv_WRT_vgsatqin = d_isrecout_d_vgsatqin;
  isrecoutReturn.deriv_WRT_betarecin = d_isrecout_d_betarecin;
  isrecoutReturn.deriv_WRT_irecin = d_isrecout_d_irecin;
  isrecoutReturn.deriv_WRT_pgsrecin = d_isrecout_d_pgsrecin;
  isrecoutReturn.deriv_WRT_pg_param1 = d_isrecout_d_pg_param1;
  isrecoutReturn.deriv_WRT_vjg = d_isrecout_d_vjg;
  isrecoutReturn.deriv_WRT_type = d_isrecout_d_type;
  return(calc_igReturn);
  }

} // namepace AnalogFunctions


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_d;
    const int Instance::admsNodeID_g;
    const int Instance::admsNodeID_s;
    const int Instance::admsNodeID_b;
    const int Instance::admsNodeID_di;
    const int Instance::admsNodeID_gi;
    const int Instance::admsNodeID_si;
    const int Instance::admsNodeID_fp1;
    const int Instance::admsNodeID_fp2;
    const int Instance::admsNodeID_fp3;
    const int Instance::admsNodeID_fp4;
    const int Instance::admsNodeID_drc;
    const int Instance::admsNodeID_src;
    const int Instance::admsNodeID_tr;
    const int Instance::admsNodeID_tr1;
    const int Instance::admsNodeID_xt1;
    const int Instance::admsNodeID_xt2;
    const int Instance::admsNodeID_dt;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSmvsg_cmc::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSmvsg_cmc::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("W", static_cast<double>(180.0e-6), &ADMSmvsg_cmc::Instance::w)
    .setUnit(U_METER)
    .setDescription("Width per Finger")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("L", static_cast<double>(250.0e-9), &ADMSmvsg_cmc::Instance::l)
    .setUnit(U_METER)
    .setDescription("Effective gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGF", static_cast<int>(2), &ADMSmvsg_cmc::Instance::ngf)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of Fingers");
  p.addPar("DTEMP", static_cast<double>(0.0), &ADMSmvsg_cmc::Instance::dtemp)
    .setUnit(U_DEGK)
    .setDescription("Device temperature offset from ambient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;


}

void Traits::loadModelParameters(ParametricData<ADMSmvsg_cmc::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSmvsg_cmc::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("VERSION", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::version)
    .setUnit(U_UNKNOWN)
    .setDescription("Version number")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOM", static_cast<double>(27.0), &ADMSmvsg_cmc::Model::tnom)
    .setUnit(U_UNKNOWN)
    .setDescription("Reference temperature for the model")
   .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TYPE", static_cast<int>(1), &ADMSmvsg_cmc::Model::type)
    .setUnit(U_UNKNOWN)
    .setDescription("nFET=1 pFET=-1");
  p.addPar("CG", static_cast<double>(4.00e-03), &ADMSmvsg_cmc::Model::cg)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COFSM", static_cast<double>(1.0e-9), &ADMSmvsg_cmc::Model::cofsm)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Source outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COFDM", static_cast<double>(1.0e-10), &ADMSmvsg_cmc::Model::cofdm)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate - Drain outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COFDSM", static_cast<double>(1.0e-10), &ADMSmvsg_cmc::Model::cofdsm)
    .setUnit(U_UNKNOWN)
    .setDescription("Source - Drain outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COFDSUBM", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cofdsubm)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub - Drain outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COFSSUBM", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cofssubm)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub - Source outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COFGSUBM", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cofgsubm)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub - Gate outer fringing cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSH", static_cast<double>(150.0), &ADMSmvsg_cmc::Model::rsh)
    .setUnit(U_UNKNOWN)
    .setDescription("2-DEG Sheet Resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RCS", static_cast<double>(800e-6), &ADMSmvsg_cmc::Model::rcs)
    .setUnit(U_UNKNOWN)
    .setDescription("Source contact resistance * Width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RCD", static_cast<double>(800e-6), &ADMSmvsg_cmc::Model::rcd)
    .setUnit(U_UNKNOWN)
    .setDescription("Drain contact resistance * Width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VX0", static_cast<double>(3.0e5), &ADMSmvsg_cmc::Model::vx0)
    .setUnit(U_UNKNOWN)
    .setDescription("Source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MU0", static_cast<double>(0.135), &ADMSmvsg_cmc::Model::mu0)
    .setUnit(U_UNKNOWN)
    .setDescription("Low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETA", static_cast<double>(1.50), &ADMSmvsg_cmc::Model::beta)
    .setUnit(U_UNKNOWN)
    .setDescription("Linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTO", static_cast<double>((-2.72)), &ADMSmvsg_cmc::Model::vto)
    .setUnit(U_VOLT)
    .setDescription("Threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SS", static_cast<double>(0.120), &ADMSmvsg_cmc::Model::ss)
    .setUnit(U_UNKNOWN)
    .setDescription("Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA1", static_cast<double>(16e-3), &ADMSmvsg_cmc::Model::delta1)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL Coefficient 1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta2)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL Coefficient 2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DIBSAT", static_cast<double>(10.0), &ADMSmvsg_cmc::Model::dibsat)
    .setUnit(U_VOLT)
    .setDescription("DIBL saturation Voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ND", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::nd)
    .setUnit(U_UNKNOWN)
    .setDescription("Punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHA", static_cast<double>(3.5), &ADMSmvsg_cmc::Model::alpha)
    .setUnit(U_UNKNOWN)
    .setDescription("Weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAMBDA", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lambda)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTHETA", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vtheta)
    .setUnit(U_UNKNOWN)
    .setDescription("Scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MTHETA", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mtheta)
    .setUnit(U_UNKNOWN)
    .setDescription("Scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VZETA", static_cast<double>(150e3), &ADMSmvsg_cmc::Model::vzeta)
    .setUnit(U_DEGKM1)
    .setDescription("vx0 dependence on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTZETA", static_cast<double>((-0.4e-3)), &ADMSmvsg_cmc::Model::vtzeta)
    .setUnit(U_VKM1)
    .setDescription("vto dependence on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSILON", static_cast<double>(2.3), &ADMSmvsg_cmc::Model::epsilon)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility dependence on temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RCT1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::rct1)
    .setUnit(U_DEGKM1)
    .setDescription("Linear Rsh and Rc temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RCT2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::rct2)
    .setUnit(U_UNKNOWN)
    .setDescription("Quadratic Rsh and Rc temperature coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGRES", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagres)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter for resistor: resistor is chosen if flagres=1 or implicit transitor is chosen if flagres=0");
  p.addPar("LGS", static_cast<double>(3.0e-6), &ADMSmvsg_cmc::Model::lgs)
    .setUnit(U_METER)
    .setDescription("Source access region (SAR) length parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTORS", static_cast<double>((-650)), &ADMSmvsg_cmc::Model::vtors)
    .setUnit(U_VOLT)
    .setDescription("SAR threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGRS", static_cast<double>(5.0e-3), &ADMSmvsg_cmc::Model::cgrs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VX0RS", static_cast<double>(100e3), &ADMSmvsg_cmc::Model::vx0rs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MU0RS", static_cast<double>(100e-3), &ADMSmvsg_cmc::Model::mu0rs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETARS", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA1RS", static_cast<double>(100e-3), &ADMSmvsg_cmc::Model::delta1rs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SRS", static_cast<double>(0.100), &ADMSmvsg_cmc::Model::srs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDRS", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndrs)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTHETARS", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MTHETARS", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHARS", static_cast<double>(3.5), &ADMSmvsg_cmc::Model::alphars)
    .setUnit(U_UNKNOWN)
    .setDescription("SAR weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LGD", static_cast<double>(4.85e-6), &ADMSmvsg_cmc::Model::lgd)
    .setUnit(U_METER)
    .setDescription("Drain access region (DAR) length parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTORD", static_cast<double>((-650)), &ADMSmvsg_cmc::Model::vtord)
    .setUnit(U_VOLT)
    .setDescription("DAR threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGRD", static_cast<double>(4.3e-3), &ADMSmvsg_cmc::Model::cgrd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VX0RD", static_cast<double>(100e3), &ADMSmvsg_cmc::Model::vx0rd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MU0RD", static_cast<double>(100e-3), &ADMSmvsg_cmc::Model::mu0rd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETARD", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA1RD", static_cast<double>(0.35), &ADMSmvsg_cmc::Model::delta1rd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SRD", static_cast<double>(0.3), &ADMSmvsg_cmc::Model::srd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDRD", static_cast<double>(3.8), &ADMSmvsg_cmc::Model::ndrd)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTHETARD", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MTHETARD", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHARD", static_cast<double>(3.5), &ADMSmvsg_cmc::Model::alphard)
    .setUnit(U_UNKNOWN)
    .setDescription("DAR weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP1", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp1)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTOFP1", static_cast<double>((-44.5)), &ADMSmvsg_cmc::Model::vtofp1)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGFP1", static_cast<double>(2.0e-4), &ADMSmvsg_cmc::Model::cgfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP1S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp1s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP1S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp1s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CCFP1", static_cast<double>(0.9e-10), &ADMSmvsg_cmc::Model::ccfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VX0FP1", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MU0FP1", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETAFP1", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA1FP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SFP1", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTHETAFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MTHETAFP1", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAFP1", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp1)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP2", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp2)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTOFP2", static_cast<double>((-74.5)), &ADMSmvsg_cmc::Model::vtofp2)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGFP2", static_cast<double>(1.0e-4), &ADMSmvsg_cmc::Model::cgfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP2S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp2s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP2S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp2s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CCFP2", static_cast<double>(0.3e-10), &ADMSmvsg_cmc::Model::ccfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VX0FP2", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MU0FP2", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETAFP2", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA1FP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SFP2", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTHETAFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MTHETAFP2", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAFP2", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp2)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP3", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp3)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTOFP3", static_cast<double>((-44.5)), &ADMSmvsg_cmc::Model::vtofp3)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGFP3", static_cast<double>(2.0e-4), &ADMSmvsg_cmc::Model::cgfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP3S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp3s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP3S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp3s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CCFP3", static_cast<double>(0.9e-10), &ADMSmvsg_cmc::Model::ccfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VX0FP3", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MU0FP3", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETAFP3", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA1FP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SFP3", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTHETAFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MTHETAFP3", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAFP3", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp3)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP4", static_cast<int>(0), &ADMSmvsg_cmc::Model::flagfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: GFP=1 or SFP=0");
  p.addPar("LGFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::lgfp4)
    .setUnit(U_METER)
    .setDescription("FP Length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTOFP4", static_cast<double>((-44.5)), &ADMSmvsg_cmc::Model::vtofp4)
    .setUnit(U_VOLT)
    .setDescription("FP threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGFP4", static_cast<double>(2.0e-4), &ADMSmvsg_cmc::Model::cgfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP gate-cap/area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FLAGFP4S", static_cast<int>(1), &ADMSmvsg_cmc::Model::flagfp4s)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter: cfp1s select=1 or cfp1s not select=0");
  p.addPar("CFP4S", static_cast<double>(1e-19), &ADMSmvsg_cmc::Model::cfp4s)
    .setUnit(U_UNKNOWN)
    .setDescription("FP (source-side) to source cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CCFP4", static_cast<double>(0.9e-10), &ADMSmvsg_cmc::Model::ccfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("Source or gate to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::cbfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("Body to drain (under FP) cap/width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VX0FP4", static_cast<double>(1.2e5), &ADMSmvsg_cmc::Model::vx0fp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP source injection velocity")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MU0FP4", static_cast<double>(0.2), &ADMSmvsg_cmc::Model::mu0fp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP low-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETAFP4", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::betafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELTA1FP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::delta1fp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP DIBL Coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SFP4", static_cast<double>(3.2), &ADMSmvsg_cmc::Model::sfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP Sub-threshold slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::ndfp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP punchthrough factor for subth slope")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTHETAFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::vthetafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: velocity reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MTHETAFP4", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::mthetafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP scattering: mobility reduction parameter with Vg")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAFP4", static_cast<double>(1e-2), &ADMSmvsg_cmc::Model::alphafp4)
    .setUnit(U_UNKNOWN)
    .setDescription("FP weak to strong inversion transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGMOD", static_cast<int>(1), &ADMSmvsg_cmc::Model::igmod)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter for gate leakage 0=off, 1=on");
  p.addPar("RGSP", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::rgsp)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate resistance * Width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VJG", static_cast<double>(1.1), &ADMSmvsg_cmc::Model::vjg)
    .setUnit(U_VOLT)
    .setDescription("Gate diode cut in voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PG_PARAM1", static_cast<double>(820e-3), &ADMSmvsg_cmc::Model::pg_param1)
    .setUnit(U_UNKNOWN)
    .setDescription("Something like 1/eta")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PG_PARAMS", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::pg_params)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJS", static_cast<double>(1.00e-12), &ADMSmvsg_cmc::Model::ijs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGSATS", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::vgsats)
    .setUnit(U_VOLT)
    .setDescription("G-S high injection effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FRACS", static_cast<double>(0.5), &ADMSmvsg_cmc::Model::fracs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S fractional change in ideality factor due to high injection")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAGS", static_cast<double>(10.0), &ADMSmvsg_cmc::Model::alphags)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S high injection smoothing parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PG_PARAMD", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::pg_paramd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IJD", static_cast<double>(1.00e-12), &ADMSmvsg_cmc::Model::ijd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGSATD", static_cast<double>(1.00), &ADMSmvsg_cmc::Model::vgsatd)
    .setUnit(U_VOLT)
    .setDescription("G-D high injection effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FRACD", static_cast<double>(0.5), &ADMSmvsg_cmc::Model::fracd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D fractional change in ideality factor due to high injection")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAGD", static_cast<double>(10.0), &ADMSmvsg_cmc::Model::alphagd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D high injection smoothing parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGSRECS", static_cast<double>(0.5), &ADMSmvsg_cmc::Model::pgsrecs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S something like 1/eta for reverse recombination")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IRECS", static_cast<double>(1.0e-18), &ADMSmvsg_cmc::Model::irecs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGSATQS", static_cast<double>(2.00), &ADMSmvsg_cmc::Model::vgsatqs)
    .setUnit(U_VOLT)
    .setDescription("G-S mimics depletion saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBDGS", static_cast<double>(600), &ADMSmvsg_cmc::Model::vbdgs)
    .setUnit(U_VOLT)
    .setDescription("G-S soft breakdown voltage of G-S diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBDGS", static_cast<double>(4.00), &ADMSmvsg_cmc::Model::pbdgs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S fitting parameter for breakdown: Something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETARECS", static_cast<double>(2.00), &ADMSmvsg_cmc::Model::betarecs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KBDGATES", static_cast<double>(00), &ADMSmvsg_cmc::Model::kbdgates)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S fitting parameter to turn on the breakdown of G-S diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGSRECD", static_cast<double>(0.8), &ADMSmvsg_cmc::Model::pgsrecd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D something like 1/eta for reverse recombination")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IRECD", static_cast<double>(2e-5), &ADMSmvsg_cmc::Model::irecd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D reverse leakage current normalized to width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VGSATQD", static_cast<double>(0.8), &ADMSmvsg_cmc::Model::vgsatqd)
    .setUnit(U_VOLT)
    .setDescription("G-D mimics depletion saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBDGD", static_cast<double>(600), &ADMSmvsg_cmc::Model::vbdgd)
    .setUnit(U_VOLT)
    .setDescription("G-D soft breakdown voltage of G-D diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBDGD", static_cast<double>(4.00), &ADMSmvsg_cmc::Model::pbdgd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D fitting parameter for breakdown: Something like 1/eta*Vt")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETARECD", static_cast<double>(0.25), &ADMSmvsg_cmc::Model::betarecd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D linear to saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KBDGATED", static_cast<double>(00), &ADMSmvsg_cmc::Model::kbdgated)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D fitting parameter to turn on the breakdown of G-D diode")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RTH", static_cast<double>(25), &ADMSmvsg_cmc::Model::rth)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTH", static_cast<double>(1e-4), &ADMSmvsg_cmc::Model::cth)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GMDISP", static_cast<int>(0), &ADMSmvsg_cmc::Model::gmdisp)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag parameter for gm-dispersion 0=off, 1=on");
  p.addPar("TAUGMRF", static_cast<double>(1e-3), &ADMSmvsg_cmc::Model::taugmrf)
    .setUnit(U_SECOND)
    .setDescription("gm-dispersion time constant")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TRAPSELECT", static_cast<int>(0), &ADMSmvsg_cmc::Model::trapselect)
    .setUnit(U_UNKNOWN)
    .setDescription("Select knob for charge trapping 0=off, 1=on");
  p.addPar("CTRAP", static_cast<double>(1e-3), &ADMSmvsg_cmc::Model::ctrap)
    .setUnit(U_FARAD)
    .setDescription("DC-block capacitor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VTTRAP", static_cast<double>(230), &ADMSmvsg_cmc::Model::vttrap)
    .setUnit(U_VOLT)
    .setDescription("Trapping stress threshold voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TAUT", static_cast<double>(3e-5), &ADMSmvsg_cmc::Model::taut)
    .setUnit(U_SECOND)
    .setDescription("Trap time constant")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAT1", static_cast<double>(1e-4), &ADMSmvsg_cmc::Model::alphat1)
    .setUnit(U_UNKNOWN)
    .setDescription("Trap coefficient 1 on bias stress")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPHAT2", static_cast<double>(21), &ADMSmvsg_cmc::Model::alphat2)
    .setUnit(U_VOLT)
    .setDescription("Trap coefficient 2 on bias stress")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TEMPT", static_cast<double>(1e-4), &ADMSmvsg_cmc::Model::tempt)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature coefficient for trapping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOISEMOD", static_cast<int>(0), &ADMSmvsg_cmc::Model::noisemod)
    .setUnit(U_UNKNOWN)
    .setDescription("Select knob for noise model 0=off, 1=on");
  p.addPar("SHS", static_cast<double>(3.0), &ADMSmvsg_cmc::Model::shs)
    .setUnit(U_UNKNOWN)
    .setDescription("G-S shot noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SHD", static_cast<double>(3.0), &ADMSmvsg_cmc::Model::shd)
    .setUnit(U_UNKNOWN)
    .setDescription("G-D shot noise parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KF", static_cast<double>(1.0e-4), &ADMSmvsg_cmc::Model::kf)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AF", static_cast<double>(2.0), &ADMSmvsg_cmc::Model::af)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FFE", static_cast<double>(1.2), &ADMSmvsg_cmc::Model::ffe)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise exponent for frequency")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MINR", static_cast<double>(1.0e-3), &ADMSmvsg_cmc::Model::minr)
    .setUnit(U_OHM)
    .setDescription("Minimum resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MINL", static_cast<double>(1.0e-9), &ADMSmvsg_cmc::Model::minl)
    .setUnit(U_METER)
    .setDescription("Minimum length of access or FP regions for modeling them as transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MINC", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::minc)
    .setUnit(U_FARAD)
    .setDescription("Minimum capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMIN", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::LMIN)
    .setUnit(U_METER)
    .setDescription("Minimum length for use of this model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMIN", static_cast<double>(0.0), &ADMSmvsg_cmc::Model::WMIN)
    .setUnit(U_METER)
    .setDescription("Minimum width for use of this model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMAX", static_cast<double>(100.0), &ADMSmvsg_cmc::Model::LMAX)
    .setUnit(U_METER)
    .setDescription("Maximum length for use of this model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMAX", static_cast<double>(100.0), &ADMSmvsg_cmc::Model::WMAX)
    .setUnit(U_METER)
    .setDescription("Maximum width for use of this model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter w : ] 0,  (+inf) [
  if ( (!((w >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter w value " << w << " out of range ] 0,  (+inf) [";
  }

//    Parameter l : ] 0,  (+inf) [
  if ( (!((l >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter l value " << l << " out of range ] 0,  (+inf) [";
  }

//    Parameter ngf : [ 1,  (+inf) [
  if ( (!((ngf >=1))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ngf value " << ngf << " out of range [ 1,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
//Begin block initial_instance
{
if (((model_.flagres)==0))
{
rcs_w = (((model_.rcs)/w)/ngf);
rcd_w = (((model_.rcd)/w)/ngf);
}
else
{
rcs_w = ((((model_.rcs)/w)+(((model_.rsh)*(model_.lgs))/w))/ngf);
rcd_w = ((((model_.rcd)/w)+(((model_.rsh)*(model_.lgd))/w))/ngf);
}
rg = (((model_.rgsp)/w)/ngf);
}
// End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    w(180.0e-6),
    l(250.0e-9),
    ngf(2),
    dtemp(0.0),
    rcs_w(0.0),
    rcd_w(0.0),
    rg(0.0),
    vgisi(0.0),
    vdisi(0.0),
    vti(0.0),
    vdsati(0.0),
    pdc(0.0),
    idisi(0.0),
    igs(0.0),
    igd(0.0),
    qgi(0.0),
d_qgi_dV_gi_si(0.0),
d_qgi_dV_di_si(0.0),
d_qgi_dTemp_dt_GND(0.0),
    qdi(0.0),
d_qdi_dV_gi_si(0.0),
d_qdi_dV_di_si(0.0),
d_qdi_dTemp_dt_GND(0.0),
    qsi(0.0),
d_qsi_dV_gi_si(0.0),
d_qsi_dV_di_si(0.0),
d_qsi_dTemp_dt_GND(0.0),
    qbi(0.0),
    gmi(0.0),
    gdsi(0.0),
    gmbsi(0.0),
    cggi(0.0),
    cgdi(0.0),
    cgsi(0.0),
    cgbi(0.0),
    cdgi(0.0),
    cddi(0.0),
    cdsi(0.0),
    cdbi(0.0),
    csgi(0.0),
    csdi(0.0),
    cssi(0.0),
    csbi(0.0),
    cbgi(0.0),
    cbdi(0.0),
    cbsi(0.0),
    cbbi(0.0),
    cgs(0.0),
    cgd(0.0),
    t_total_k(0.0),
    t_total_c(0.0),
    t_delta_sh(0.0),
    rs(0.0),
    rd(0.0),
    li_d(-1),
    li_g(-1),
    li_s(-1),
    li_b(-1),
    li_di(-1),
    li_gi(-1),
    li_si(-1),
    li_fp1(-1),
    li_fp2(-1),
    li_fp3(-1),
    li_fp4(-1),
    li_drc(-1),
    li_src(-1),
    li_tr(-1),
    li_tr1(-1),
    li_xt1(-1),
    li_xt2(-1),
    li_dt(-1),
    li_branch_id(-1),
    li_branch_ig(-1),
    li_branch_is(-1),
    li_branch_ib(-1),
    f_tr1_Equ_d_Node_Ptr(0),
    f_tr1_Equ_g_Node_Ptr(0),
    f_tr1_Equ_tr1_Node_Ptr(0),
    f_tr1_Equ_tr_Node_Ptr(0),
    f_tr_Equ_tr1_Node_Ptr(0),
    f_tr_Equ_tr_Node_Ptr(0),
    f_fp4_Equ_dt_Node_Ptr(0),
    f_fp3_Equ_dt_Node_Ptr(0),
    f_fp4_Equ_b_Node_Ptr(0),
    f_fp4_Equ_fp3_Node_Ptr(0),
    f_fp3_Equ_b_Node_Ptr(0),
    f_fp3_Equ_fp3_Node_Ptr(0),
    f_fp4_Equ_fp4_Node_Ptr(0),
    f_fp3_Equ_fp4_Node_Ptr(0),
    f_fp4_Equ_gi_Node_Ptr(0),
    f_fp3_Equ_gi_Node_Ptr(0),
    f_fp4_Equ_s_Node_Ptr(0),
    f_fp3_Equ_s_Node_Ptr(0),
    f_gi_Equ_dt_Node_Ptr(0),
    f_gi_Equ_b_Node_Ptr(0),
    f_gi_Equ_fp3_Node_Ptr(0),
    f_gi_Equ_fp4_Node_Ptr(0),
    f_gi_Equ_gi_Node_Ptr(0),
    f_gi_Equ_s_Node_Ptr(0),
    f_s_Equ_dt_Node_Ptr(0),
    f_s_Equ_b_Node_Ptr(0),
    f_s_Equ_fp3_Node_Ptr(0),
    f_s_Equ_fp4_Node_Ptr(0),
    f_s_Equ_gi_Node_Ptr(0),
    f_s_Equ_s_Node_Ptr(0),
    f_gi_Equ_si_Node_Ptr(0),
    f_si_Equ_gi_Node_Ptr(0),
    f_si_Equ_si_Node_Ptr(0),
    f_si_Equ_dt_Node_Ptr(0),
    f_si_Equ_b_Node_Ptr(0),
    f_si_Equ_fp3_Node_Ptr(0),
    f_si_Equ_fp4_Node_Ptr(0),
    f_si_Equ_s_Node_Ptr(0),
    f_b_Equ_dt_Node_Ptr(0),
    f_b_Equ_b_Node_Ptr(0),
    f_b_Equ_fp3_Node_Ptr(0),
    f_b_Equ_fp4_Node_Ptr(0),
    f_b_Equ_gi_Node_Ptr(0),
    f_b_Equ_s_Node_Ptr(0),
    f_fp2_Equ_dt_Node_Ptr(0),
    f_fp3_Equ_fp2_Node_Ptr(0),
    f_fp2_Equ_b_Node_Ptr(0),
    f_fp2_Equ_fp2_Node_Ptr(0),
    f_fp2_Equ_fp3_Node_Ptr(0),
    f_fp2_Equ_gi_Node_Ptr(0),
    f_fp2_Equ_s_Node_Ptr(0),
    f_gi_Equ_fp2_Node_Ptr(0),
    f_s_Equ_fp2_Node_Ptr(0),
    f_si_Equ_fp2_Node_Ptr(0),
    f_b_Equ_fp2_Node_Ptr(0),
    f_fp1_Equ_dt_Node_Ptr(0),
    f_fp2_Equ_fp1_Node_Ptr(0),
    f_fp1_Equ_b_Node_Ptr(0),
    f_fp1_Equ_fp1_Node_Ptr(0),
    f_fp1_Equ_fp2_Node_Ptr(0),
    f_fp1_Equ_gi_Node_Ptr(0),
    f_fp1_Equ_s_Node_Ptr(0),
    f_gi_Equ_fp1_Node_Ptr(0),
    f_s_Equ_fp1_Node_Ptr(0),
    f_si_Equ_fp1_Node_Ptr(0),
    f_b_Equ_fp1_Node_Ptr(0),
    f_di_Equ_dt_Node_Ptr(0),
    f_fp1_Equ_di_Node_Ptr(0),
    f_di_Equ_b_Node_Ptr(0),
    f_di_Equ_di_Node_Ptr(0),
    f_di_Equ_fp1_Node_Ptr(0),
    f_di_Equ_gi_Node_Ptr(0),
    f_di_Equ_s_Node_Ptr(0),
    f_gi_Equ_di_Node_Ptr(0),
    f_s_Equ_di_Node_Ptr(0),
    f_si_Equ_di_Node_Ptr(0),
    f_b_Equ_di_Node_Ptr(0),
    f_src_Equ_dt_Node_Ptr(0),
    f_si_Equ_src_Node_Ptr(0),
    f_src_Equ_si_Node_Ptr(0),
    f_src_Equ_src_Node_Ptr(0),
    f_src_Equ_s_Node_Ptr(0),
    f_si_Equ_d_Node_Ptr(0),
    f_src_Equ_d_Node_Ptr(0),
    f_drc_Equ_drc_Node_Ptr(0),
    f_drc_Equ_fp4_Node_Ptr(0),
    f_fp4_Equ_drc_Node_Ptr(0),
    f_drc_Equ_s_Node_Ptr(0),
    f_drc_Equ_d_Node_Ptr(0),
    f_fp4_Equ_d_Node_Ptr(0),
    f_drc_Equ_dt_Node_Ptr(0),
    f_drc_Equ_tr_Node_Ptr(0),
    f_fp4_Equ_tr_Node_Ptr(0),
    f_di_Equ_si_Node_Ptr(0),
    f_xt1_Equ_xt2_Node_Ptr(0),
    f_xt1_Equ_dt_Node_Ptr(0),
    f_xt1_Equ_di_Node_Ptr(0),
    f_xt1_Equ_si_Node_Ptr(0),
    f_xt1_Equ_gi_Node_Ptr(0),
    f_xt1_Equ_xt1_Node_Ptr(0),
    f_xt2_Equ_xt2_Node_Ptr(0),
    f_xt2_Equ_xt1_Node_Ptr(0),
    f_di_Equ_xt2_Node_Ptr(0),
    f_si_Equ_xt2_Node_Ptr(0),
    f_d_Equ_dt_Node_Ptr(0),
    f_d_Equ_d_Node_Ptr(0),
    f_d_Equ_drc_Node_Ptr(0),
    f_s_Equ_src_Node_Ptr(0),
    f_g_Equ_g_Node_Ptr(0),
    f_g_Equ_gi_Node_Ptr(0),
    f_gi_Equ_g_Node_Ptr(0),
    f_gi_Equ_d_Node_Ptr(0),
    f_d_Equ_gi_Node_Ptr(0),
    f_d_Equ_s_Node_Ptr(0),
    f_s_Equ_d_Node_Ptr(0),
    f_d_Equ_b_Node_Ptr(0),
    f_b_Equ_d_Node_Ptr(0),
    f_dt_Equ_dt_Node_Ptr(0),
    f_dt_Equ_b_Node_Ptr(0),
    f_dt_Equ_fp3_Node_Ptr(0),
    f_dt_Equ_fp4_Node_Ptr(0),
    f_dt_Equ_gi_Node_Ptr(0),
    f_dt_Equ_s_Node_Ptr(0),
    f_dt_Equ_fp2_Node_Ptr(0),
    f_dt_Equ_fp1_Node_Ptr(0),
    f_dt_Equ_di_Node_Ptr(0),
    f_dt_Equ_si_Node_Ptr(0),
    f_dt_Equ_src_Node_Ptr(0),
    f_dt_Equ_d_Node_Ptr(0),
    f_dt_Equ_drc_Node_Ptr(0),
    f_dt_Equ_tr_Node_Ptr(0),
    q_tr1_Equ_d_Node_Ptr(0),
    q_tr1_Equ_g_Node_Ptr(0),
    q_tr1_Equ_tr1_Node_Ptr(0),
    q_tr1_Equ_tr_Node_Ptr(0),
    q_tr_Equ_tr1_Node_Ptr(0),
    q_tr_Equ_tr_Node_Ptr(0),
    q_fp4_Equ_dt_Node_Ptr(0),
    q_fp3_Equ_dt_Node_Ptr(0),
    q_fp4_Equ_b_Node_Ptr(0),
    q_fp4_Equ_fp3_Node_Ptr(0),
    q_fp3_Equ_b_Node_Ptr(0),
    q_fp3_Equ_fp3_Node_Ptr(0),
    q_fp4_Equ_fp4_Node_Ptr(0),
    q_fp3_Equ_fp4_Node_Ptr(0),
    q_fp4_Equ_gi_Node_Ptr(0),
    q_fp3_Equ_gi_Node_Ptr(0),
    q_fp4_Equ_s_Node_Ptr(0),
    q_fp3_Equ_s_Node_Ptr(0),
    q_gi_Equ_dt_Node_Ptr(0),
    q_gi_Equ_b_Node_Ptr(0),
    q_gi_Equ_fp3_Node_Ptr(0),
    q_gi_Equ_fp4_Node_Ptr(0),
    q_gi_Equ_gi_Node_Ptr(0),
    q_gi_Equ_s_Node_Ptr(0),
    q_s_Equ_dt_Node_Ptr(0),
    q_s_Equ_b_Node_Ptr(0),
    q_s_Equ_fp3_Node_Ptr(0),
    q_s_Equ_fp4_Node_Ptr(0),
    q_s_Equ_gi_Node_Ptr(0),
    q_s_Equ_s_Node_Ptr(0),
    q_gi_Equ_si_Node_Ptr(0),
    q_si_Equ_gi_Node_Ptr(0),
    q_si_Equ_si_Node_Ptr(0),
    q_si_Equ_dt_Node_Ptr(0),
    q_si_Equ_b_Node_Ptr(0),
    q_si_Equ_fp3_Node_Ptr(0),
    q_si_Equ_fp4_Node_Ptr(0),
    q_si_Equ_s_Node_Ptr(0),
    q_b_Equ_dt_Node_Ptr(0),
    q_b_Equ_b_Node_Ptr(0),
    q_b_Equ_fp3_Node_Ptr(0),
    q_b_Equ_fp4_Node_Ptr(0),
    q_b_Equ_gi_Node_Ptr(0),
    q_b_Equ_s_Node_Ptr(0),
    q_fp2_Equ_dt_Node_Ptr(0),
    q_fp3_Equ_fp2_Node_Ptr(0),
    q_fp2_Equ_b_Node_Ptr(0),
    q_fp2_Equ_fp2_Node_Ptr(0),
    q_fp2_Equ_fp3_Node_Ptr(0),
    q_fp2_Equ_gi_Node_Ptr(0),
    q_fp2_Equ_s_Node_Ptr(0),
    q_gi_Equ_fp2_Node_Ptr(0),
    q_s_Equ_fp2_Node_Ptr(0),
    q_si_Equ_fp2_Node_Ptr(0),
    q_b_Equ_fp2_Node_Ptr(0),
    q_fp1_Equ_dt_Node_Ptr(0),
    q_fp2_Equ_fp1_Node_Ptr(0),
    q_fp1_Equ_b_Node_Ptr(0),
    q_fp1_Equ_fp1_Node_Ptr(0),
    q_fp1_Equ_fp2_Node_Ptr(0),
    q_fp1_Equ_gi_Node_Ptr(0),
    q_fp1_Equ_s_Node_Ptr(0),
    q_gi_Equ_fp1_Node_Ptr(0),
    q_s_Equ_fp1_Node_Ptr(0),
    q_si_Equ_fp1_Node_Ptr(0),
    q_b_Equ_fp1_Node_Ptr(0),
    q_di_Equ_dt_Node_Ptr(0),
    q_fp1_Equ_di_Node_Ptr(0),
    q_di_Equ_b_Node_Ptr(0),
    q_di_Equ_di_Node_Ptr(0),
    q_di_Equ_fp1_Node_Ptr(0),
    q_di_Equ_gi_Node_Ptr(0),
    q_di_Equ_s_Node_Ptr(0),
    q_gi_Equ_di_Node_Ptr(0),
    q_s_Equ_di_Node_Ptr(0),
    q_si_Equ_di_Node_Ptr(0),
    q_b_Equ_di_Node_Ptr(0),
    q_src_Equ_dt_Node_Ptr(0),
    q_si_Equ_src_Node_Ptr(0),
    q_src_Equ_si_Node_Ptr(0),
    q_src_Equ_src_Node_Ptr(0),
    q_src_Equ_s_Node_Ptr(0),
    q_si_Equ_d_Node_Ptr(0),
    q_src_Equ_d_Node_Ptr(0),
    q_drc_Equ_drc_Node_Ptr(0),
    q_drc_Equ_fp4_Node_Ptr(0),
    q_fp4_Equ_drc_Node_Ptr(0),
    q_drc_Equ_s_Node_Ptr(0),
    q_drc_Equ_d_Node_Ptr(0),
    q_fp4_Equ_d_Node_Ptr(0),
    q_drc_Equ_dt_Node_Ptr(0),
    q_drc_Equ_tr_Node_Ptr(0),
    q_fp4_Equ_tr_Node_Ptr(0),
    q_di_Equ_si_Node_Ptr(0),
    q_xt1_Equ_xt2_Node_Ptr(0),
    q_xt1_Equ_dt_Node_Ptr(0),
    q_xt1_Equ_di_Node_Ptr(0),
    q_xt1_Equ_si_Node_Ptr(0),
    q_xt1_Equ_gi_Node_Ptr(0),
    q_xt1_Equ_xt1_Node_Ptr(0),
    q_xt2_Equ_xt2_Node_Ptr(0),
    q_xt2_Equ_xt1_Node_Ptr(0),
    q_di_Equ_xt2_Node_Ptr(0),
    q_si_Equ_xt2_Node_Ptr(0),
    q_d_Equ_dt_Node_Ptr(0),
    q_d_Equ_d_Node_Ptr(0),
    q_d_Equ_drc_Node_Ptr(0),
    q_s_Equ_src_Node_Ptr(0),
    q_g_Equ_g_Node_Ptr(0),
    q_g_Equ_gi_Node_Ptr(0),
    q_gi_Equ_g_Node_Ptr(0),
    q_gi_Equ_d_Node_Ptr(0),
    q_d_Equ_gi_Node_Ptr(0),
    q_d_Equ_s_Node_Ptr(0),
    q_s_Equ_d_Node_Ptr(0),
    q_d_Equ_b_Node_Ptr(0),
    q_b_Equ_d_Node_Ptr(0),
    q_dt_Equ_dt_Node_Ptr(0),
    q_dt_Equ_b_Node_Ptr(0),
    q_dt_Equ_fp3_Node_Ptr(0),
    q_dt_Equ_fp4_Node_Ptr(0),
    q_dt_Equ_gi_Node_Ptr(0),
    q_dt_Equ_s_Node_Ptr(0),
    q_dt_Equ_fp2_Node_Ptr(0),
    q_dt_Equ_fp1_Node_Ptr(0),
    q_dt_Equ_di_Node_Ptr(0),
    q_dt_Equ_si_Node_Ptr(0),
    q_dt_Equ_src_Node_Ptr(0),
    q_dt_Equ_d_Node_Ptr(0),
    q_dt_Equ_drc_Node_Ptr(0),
    q_dt_Equ_tr_Node_Ptr(0),
    A_tr1_Equ_d_NodeOffset(-1),
    A_tr1_Equ_g_NodeOffset(-1),
    A_tr1_Equ_tr1_NodeOffset(-1),
    A_tr1_Equ_tr_NodeOffset(-1),
    A_tr_Equ_tr1_NodeOffset(-1),
    A_tr_Equ_tr_NodeOffset(-1),
    A_fp4_Equ_dt_NodeOffset(-1),
    A_fp3_Equ_dt_NodeOffset(-1),
    A_fp4_Equ_b_NodeOffset(-1),
    A_fp4_Equ_fp3_NodeOffset(-1),
    A_fp3_Equ_b_NodeOffset(-1),
    A_fp3_Equ_fp3_NodeOffset(-1),
    A_fp4_Equ_fp4_NodeOffset(-1),
    A_fp3_Equ_fp4_NodeOffset(-1),
    A_fp4_Equ_gi_NodeOffset(-1),
    A_fp3_Equ_gi_NodeOffset(-1),
    A_fp4_Equ_s_NodeOffset(-1),
    A_fp3_Equ_s_NodeOffset(-1),
    A_gi_Equ_dt_NodeOffset(-1),
    A_gi_Equ_b_NodeOffset(-1),
    A_gi_Equ_fp3_NodeOffset(-1),
    A_gi_Equ_fp4_NodeOffset(-1),
    A_gi_Equ_gi_NodeOffset(-1),
    A_gi_Equ_s_NodeOffset(-1),
    A_s_Equ_dt_NodeOffset(-1),
    A_s_Equ_b_NodeOffset(-1),
    A_s_Equ_fp3_NodeOffset(-1),
    A_s_Equ_fp4_NodeOffset(-1),
    A_s_Equ_gi_NodeOffset(-1),
    A_s_Equ_s_NodeOffset(-1),
    A_gi_Equ_si_NodeOffset(-1),
    A_si_Equ_gi_NodeOffset(-1),
    A_si_Equ_si_NodeOffset(-1),
    A_si_Equ_dt_NodeOffset(-1),
    A_si_Equ_b_NodeOffset(-1),
    A_si_Equ_fp3_NodeOffset(-1),
    A_si_Equ_fp4_NodeOffset(-1),
    A_si_Equ_s_NodeOffset(-1),
    A_b_Equ_dt_NodeOffset(-1),
    A_b_Equ_b_NodeOffset(-1),
    A_b_Equ_fp3_NodeOffset(-1),
    A_b_Equ_fp4_NodeOffset(-1),
    A_b_Equ_gi_NodeOffset(-1),
    A_b_Equ_s_NodeOffset(-1),
    A_fp2_Equ_dt_NodeOffset(-1),
    A_fp3_Equ_fp2_NodeOffset(-1),
    A_fp2_Equ_b_NodeOffset(-1),
    A_fp2_Equ_fp2_NodeOffset(-1),
    A_fp2_Equ_fp3_NodeOffset(-1),
    A_fp2_Equ_gi_NodeOffset(-1),
    A_fp2_Equ_s_NodeOffset(-1),
    A_gi_Equ_fp2_NodeOffset(-1),
    A_s_Equ_fp2_NodeOffset(-1),
    A_si_Equ_fp2_NodeOffset(-1),
    A_b_Equ_fp2_NodeOffset(-1),
    A_fp1_Equ_dt_NodeOffset(-1),
    A_fp2_Equ_fp1_NodeOffset(-1),
    A_fp1_Equ_b_NodeOffset(-1),
    A_fp1_Equ_fp1_NodeOffset(-1),
    A_fp1_Equ_fp2_NodeOffset(-1),
    A_fp1_Equ_gi_NodeOffset(-1),
    A_fp1_Equ_s_NodeOffset(-1),
    A_gi_Equ_fp1_NodeOffset(-1),
    A_s_Equ_fp1_NodeOffset(-1),
    A_si_Equ_fp1_NodeOffset(-1),
    A_b_Equ_fp1_NodeOffset(-1),
    A_di_Equ_dt_NodeOffset(-1),
    A_fp1_Equ_di_NodeOffset(-1),
    A_di_Equ_b_NodeOffset(-1),
    A_di_Equ_di_NodeOffset(-1),
    A_di_Equ_fp1_NodeOffset(-1),
    A_di_Equ_gi_NodeOffset(-1),
    A_di_Equ_s_NodeOffset(-1),
    A_gi_Equ_di_NodeOffset(-1),
    A_s_Equ_di_NodeOffset(-1),
    A_si_Equ_di_NodeOffset(-1),
    A_b_Equ_di_NodeOffset(-1),
    A_src_Equ_dt_NodeOffset(-1),
    A_si_Equ_src_NodeOffset(-1),
    A_src_Equ_si_NodeOffset(-1),
    A_src_Equ_src_NodeOffset(-1),
    A_src_Equ_s_NodeOffset(-1),
    A_si_Equ_d_NodeOffset(-1),
    A_src_Equ_d_NodeOffset(-1),
    A_drc_Equ_drc_NodeOffset(-1),
    A_drc_Equ_fp4_NodeOffset(-1),
    A_fp4_Equ_drc_NodeOffset(-1),
    A_drc_Equ_s_NodeOffset(-1),
    A_drc_Equ_d_NodeOffset(-1),
    A_fp4_Equ_d_NodeOffset(-1),
    A_drc_Equ_dt_NodeOffset(-1),
    A_drc_Equ_tr_NodeOffset(-1),
    A_fp4_Equ_tr_NodeOffset(-1),
    A_di_Equ_si_NodeOffset(-1),
    A_xt1_Equ_xt2_NodeOffset(-1),
    A_xt1_Equ_dt_NodeOffset(-1),
    A_xt1_Equ_di_NodeOffset(-1),
    A_xt1_Equ_si_NodeOffset(-1),
    A_xt1_Equ_gi_NodeOffset(-1),
    A_xt1_Equ_xt1_NodeOffset(-1),
    A_xt2_Equ_xt2_NodeOffset(-1),
    A_xt2_Equ_xt1_NodeOffset(-1),
    A_di_Equ_xt2_NodeOffset(-1),
    A_si_Equ_xt2_NodeOffset(-1),
    A_d_Equ_dt_NodeOffset(-1),
    A_d_Equ_d_NodeOffset(-1),
    A_d_Equ_drc_NodeOffset(-1),
    A_s_Equ_src_NodeOffset(-1),
    A_g_Equ_g_NodeOffset(-1),
    A_g_Equ_gi_NodeOffset(-1),
    A_gi_Equ_g_NodeOffset(-1),
    A_gi_Equ_d_NodeOffset(-1),
    A_d_Equ_gi_NodeOffset(-1),
    A_d_Equ_s_NodeOffset(-1),
    A_s_Equ_d_NodeOffset(-1),
    A_d_Equ_b_NodeOffset(-1),
    A_b_Equ_d_NodeOffset(-1),
    A_dt_Equ_dt_NodeOffset(-1),
    A_dt_Equ_b_NodeOffset(-1),
    A_dt_Equ_fp3_NodeOffset(-1),
    A_dt_Equ_fp4_NodeOffset(-1),
    A_dt_Equ_gi_NodeOffset(-1),
    A_dt_Equ_s_NodeOffset(-1),
    A_dt_Equ_fp2_NodeOffset(-1),
    A_dt_Equ_fp1_NodeOffset(-1),
    A_dt_Equ_di_NodeOffset(-1),
    A_dt_Equ_si_NodeOffset(-1),
    A_dt_Equ_src_NodeOffset(-1),
    A_dt_Equ_d_NodeOffset(-1),
    A_dt_Equ_drc_NodeOffset(-1),
    A_dt_Equ_tr_NodeOffset(-1),
    li_store_vgisi(-1),
    li_store_vdisi(-1),
    li_store_vti(-1),
    li_store_vdsati(-1),
    li_store_pdc(-1),
    li_store_idisi(-1),
    li_store_igs(-1),
    li_store_igd(-1),
    li_store_qgi(-1),
    li_store_qdi(-1),
    li_store_qsi(-1),
    li_store_qbi(-1),
    li_store_gmi(-1),
    li_store_gdsi(-1),
    li_store_gmbsi(-1),
    li_store_cggi(-1),
    li_store_cgdi(-1),
    li_store_cgsi(-1),
    li_store_cgbi(-1),
    li_store_cdgi(-1),
    li_store_cddi(-1),
    li_store_cdsi(-1),
    li_store_cdbi(-1),
    li_store_csgi(-1),
    li_store_csdi(-1),
    li_store_cssi(-1),
    li_store_csbi(-1),
    li_store_cbgi(-1),
    li_store_cbdi(-1),
    li_store_cbsi(-1),
    li_store_cbbi(-1),
    li_store_cgs(-1),
    li_store_cgd(-1),
    li_store_t_total_k(-1),
    li_store_t_total_c(-1),
    li_store_t_delta_sh(-1),
    li_store_rs(-1),
    li_store_rd(-1),
    collapseNode_di(false),
    collapseNode_gi(false),
    collapseNode_si(false),
    collapseNode_fp1(false),
    collapseNode_fp2(false),
    collapseNode_fp3(false),
    collapseNode_fp4(false),
    collapseNode_drc(false),
    collapseNode_src(false),
    collapseNode_tr(false),
    collapseNode_tr1(false),
    collapseNode_xt1(false),
    collapseNode_xt2(false),
    collapseNode_dt(false),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 14 + 0;
    numExtVars = 4;

  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+38);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_drc));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_d,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_g,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_src));
    jacobianElements.push_back(IntPair(admsNodeID_s,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_b,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_di,admsNodeID_xt2));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_gi,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_src));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_si,admsNodeID_xt2));
    jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_fp1,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_drc));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_fp4,admsNodeID_tr));
    jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_drc));
    jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_drc,admsNodeID_tr));
    jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_src));
    jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_src,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_tr,admsNodeID_tr1));
    jacobianElements.push_back(IntPair(admsNodeID_tr,admsNodeID_tr));
    jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_g));
    jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_tr1));
    jacobianElements.push_back(IntPair(admsNodeID_tr1,admsNodeID_tr));
    jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_xt2));
    jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_xt1,admsNodeID_xt1));
    jacobianElements.push_back(IntPair(admsNodeID_xt2,admsNodeID_xt2));
    jacobianElements.push_back(IntPair(admsNodeID_xt2,admsNodeID_xt1));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_dt));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_b));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp3));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp4));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_gi));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_s));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp2));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_fp1));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_di));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_si));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_src));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_d));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_drc));
    jacobianElements.push_back(IntPair(admsNodeID_dt,admsNodeID_tr));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_di)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_di,admsNodeID_fp1));
  }
  if (collapseNode_gi)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_gi,admsNodeID_g));
  }
  if (collapseNode_si)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_si,admsNodeID_src));
  }
  if (collapseNode_fp1)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_fp1,admsNodeID_fp2));
  }
  if (collapseNode_fp2)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_fp2,admsNodeID_fp3));
  }
  if (collapseNode_fp3)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_fp3,admsNodeID_fp4));
  }
  if (collapseNode_fp4)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_fp4,admsNodeID_drc));
  }
  if (collapseNode_drc)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_drc,admsNodeID_d));
  }
  if (collapseNode_src)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_src,admsNodeID_s));
  }
  if (collapseNode_tr)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_tr,admsNodeID_GND));
  }
  if (collapseNode_tr1)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_tr1,admsNodeID_GND));
  }
  if (collapseNode_xt1)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_xt1,admsNodeID_GND));
  }
  if (collapseNode_xt2)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_xt2,admsNodeID_GND));
  }
  if (collapseNode_dt)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_dt,admsNodeID_GND));
  }

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 18+0;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
collapseNode_di = false;
collapseNode_gi = false;
collapseNode_si = false;
collapseNode_fp1 = false;
collapseNode_fp2 = false;
collapseNode_fp3 = false;
collapseNode_fp4 = false;
collapseNode_drc = false;
collapseNode_src = false;
collapseNode_tr = false;
collapseNode_tr1 = false;
collapseNode_xt1 = false;
collapseNode_xt2 = false;
collapseNode_dt = false;
if (!(((model_.trapselect)!=0)))
{

collapseNode_tr1 = true;

collapseNode_tr = true;

}

if (!(((model_.lgfp4)>(model_.minl))))
{

collapseNode_fp3 = true;

}

if (!(((model_.lgfp3)>(model_.minl))))
{

collapseNode_fp2 = true;

}

if (!(((model_.lgfp2)>(model_.minl))))
{

collapseNode_fp1 = true;

}

if (!(((model_.lgfp1)>(model_.minl))))
{

collapseNode_di = true;

}

if (!((((model_.flagres)==0)&&((model_.lgs)>(model_.minl)))))
{

collapseNode_si = true;

}

if (!((((model_.flagres)==0)&&((model_.lgd)>(model_.minl)))))
{

collapseNode_fp4 = true;

}

if (((model_.gmdisp)==0))
{

collapseNode_xt1 = true;

collapseNode_xt2 = true;

}

if ((rcd_w<=(model_.minr)))
{

collapseNode_drc = true;

}

if ((rcs_w<=(model_.minr)))
{

collapseNode_src = true;

}

if ((rg<=(model_.minr)))
{

collapseNode_gi = true;

}

if (!(((model_.rth)>0)))
{
collapseNode_dt = true;

}


  if (collapseNode_di)
  {
    numIntVars--;
  }
  if (collapseNode_gi)
  {
    numIntVars--;
  }
  if (collapseNode_si)
  {
    numIntVars--;
  }
  if (collapseNode_fp1)
  {
    numIntVars--;
  }
  if (collapseNode_fp2)
  {
    numIntVars--;
  }
  if (collapseNode_fp3)
  {
    numIntVars--;
  }
  if (collapseNode_fp4)
  {
    numIntVars--;
  }
  if (collapseNode_drc)
  {
    numIntVars--;
  }
  if (collapseNode_src)
  {
    numIntVars--;
  }
  if (collapseNode_tr)
  {
    numIntVars--;
  }
  if (collapseNode_tr1)
  {
    numIntVars--;
  }
  if (collapseNode_xt1)
  {
    numIntVars--;
  }
  if (collapseNode_xt2)
  {
    numIntVars--;
  }
  if (collapseNode_dt)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSmvsg_cmc::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_d = localLIDVec[nodeMap[admsNodeID_d]];
  li_g = localLIDVec[nodeMap[admsNodeID_g]];
  li_s = localLIDVec[nodeMap[admsNodeID_s]];
  li_b = localLIDVec[nodeMap[admsNodeID_b]];
  li_di = localLIDVec[nodeMap[admsNodeID_di]];
  li_gi = localLIDVec[nodeMap[admsNodeID_gi]];
  li_si = localLIDVec[nodeMap[admsNodeID_si]];
  li_fp1 = localLIDVec[nodeMap[admsNodeID_fp1]];
  li_fp2 = localLIDVec[nodeMap[admsNodeID_fp2]];
  li_fp3 = localLIDVec[nodeMap[admsNodeID_fp3]];
  li_fp4 = localLIDVec[nodeMap[admsNodeID_fp4]];
  li_drc = localLIDVec[nodeMap[admsNodeID_drc]];
  li_src = localLIDVec[nodeMap[admsNodeID_src]];
  if (collapseNode_tr)
      {
    li_tr = -1;
    }
  else
    {
  li_tr = localLIDVec[nodeMap[admsNodeID_tr]];
    }
  if (collapseNode_tr1)
      {
    li_tr1 = -1;
    }
  else
    {
  li_tr1 = localLIDVec[nodeMap[admsNodeID_tr1]];
    }
  if (collapseNode_xt1)
      {
    li_xt1 = -1;
    }
  else
    {
  li_xt1 = localLIDVec[nodeMap[admsNodeID_xt1]];
    }
  if (collapseNode_xt2)
      {
    li_xt2 = -1;
    }
  else
    {
  li_xt2 = localLIDVec[nodeMap[admsNodeID_xt2]];
    }
  if (collapseNode_dt)
      {
    li_dt = -1;
    }
  else
    {
  li_dt = localLIDVec[nodeMap[admsNodeID_dt]];
    }


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_d = " << li_d << std::endl;
      Xyce::dout() << "\nli_g = " << li_g << std::endl;
      Xyce::dout() << "\nli_s = " << li_s << std::endl;
      Xyce::dout() << "\nli_b = " << li_b << std::endl;
      Xyce::dout() << "\nli_di = " << li_di << std::endl;
      Xyce::dout() << "\nli_gi = " << li_gi << std::endl;
      Xyce::dout() << "\nli_si = " << li_si << std::endl;
      Xyce::dout() << "\nli_fp1 = " << li_fp1 << std::endl;
      Xyce::dout() << "\nli_fp2 = " << li_fp2 << std::endl;
      Xyce::dout() << "\nli_fp3 = " << li_fp3 << std::endl;
      Xyce::dout() << "\nli_fp4 = " << li_fp4 << std::endl;
      Xyce::dout() << "\nli_drc = " << li_drc << std::endl;
      Xyce::dout() << "\nli_src = " << li_src << std::endl;
      Xyce::dout() << "\nli_tr = " << li_tr << std::endl;
      Xyce::dout() << "\nli_tr1 = " << li_tr1 << std::endl;
      Xyce::dout() << "\nli_xt1 = " << li_xt1 << std::endl;
      Xyce::dout() << "\nli_xt2 = " << li_xt2 << std::endl;
      Xyce::dout() << "\nli_dt = " << li_dt << std::endl;

    Xyce::dout() << "\nEnd of ADMSmvsg_cmc::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    if (!collapseNode_di)
    {
    addInternalNode(symbol_table, li_di, getName(), "di");
    }
    if (!collapseNode_gi)
    {
    addInternalNode(symbol_table, li_gi, getName(), "gi");
    }
    if (!collapseNode_si)
    {
    addInternalNode(symbol_table, li_si, getName(), "si");
    }
    if (!collapseNode_fp1)
    {
    addInternalNode(symbol_table, li_fp1, getName(), "fp1");
    }
    if (!collapseNode_fp2)
    {
    addInternalNode(symbol_table, li_fp2, getName(), "fp2");
    }
    if (!collapseNode_fp3)
    {
    addInternalNode(symbol_table, li_fp3, getName(), "fp3");
    }
    if (!collapseNode_fp4)
    {
    addInternalNode(symbol_table, li_fp4, getName(), "fp4");
    }
    if (!collapseNode_drc)
    {
    addInternalNode(symbol_table, li_drc, getName(), "drc");
    }
    if (!collapseNode_src)
    {
    addInternalNode(symbol_table, li_src, getName(), "src");
    }
    if (!collapseNode_tr)
    {
    addInternalNode(symbol_table, li_tr, getName(), "tr");
    }
    if (!collapseNode_tr1)
    {
    addInternalNode(symbol_table, li_tr1, getName(), "tr1");
    }
    if (!collapseNode_xt1)
    {
    addInternalNode(symbol_table, li_xt1, getName(), "xt1");
    }
    if (!collapseNode_xt2)
    {
    addInternalNode(symbol_table, li_xt2, getName(), "xt2");
    }
    if (!collapseNode_dt)
    {
    addInternalNode(symbol_table, li_dt, getName(), "dt");
    }
    addStoreNode(symbol_table, li_store_vgisi, getName().getEncodedName() + ":vgisi");
    addStoreNode(symbol_table, li_store_vdisi, getName().getEncodedName() + ":vdisi");
    addStoreNode(symbol_table, li_store_vti, getName().getEncodedName() + ":vti");
    addStoreNode(symbol_table, li_store_vdsati, getName().getEncodedName() + ":vdsati");
    addStoreNode(symbol_table, li_store_pdc, getName().getEncodedName() + ":pdc");
    addStoreNode(symbol_table, li_store_idisi, getName().getEncodedName() + ":idisi");
    addStoreNode(symbol_table, li_store_igs, getName().getEncodedName() + ":igs");
    addStoreNode(symbol_table, li_store_igd, getName().getEncodedName() + ":igd");
    addStoreNode(symbol_table, li_store_qgi, getName().getEncodedName() + ":qgi");
    addStoreNode(symbol_table, li_store_qdi, getName().getEncodedName() + ":qdi");
    addStoreNode(symbol_table, li_store_qsi, getName().getEncodedName() + ":qsi");
    addStoreNode(symbol_table, li_store_qbi, getName().getEncodedName() + ":qbi");
    addStoreNode(symbol_table, li_store_gmi, getName().getEncodedName() + ":gmi");
    addStoreNode(symbol_table, li_store_gdsi, getName().getEncodedName() + ":gdsi");
    addStoreNode(symbol_table, li_store_gmbsi, getName().getEncodedName() + ":gmbsi");
    addStoreNode(symbol_table, li_store_cggi, getName().getEncodedName() + ":cggi");
    addStoreNode(symbol_table, li_store_cgdi, getName().getEncodedName() + ":cgdi");
    addStoreNode(symbol_table, li_store_cgsi, getName().getEncodedName() + ":cgsi");
    addStoreNode(symbol_table, li_store_cgbi, getName().getEncodedName() + ":cgbi");
    addStoreNode(symbol_table, li_store_cdgi, getName().getEncodedName() + ":cdgi");
    addStoreNode(symbol_table, li_store_cddi, getName().getEncodedName() + ":cddi");
    addStoreNode(symbol_table, li_store_cdsi, getName().getEncodedName() + ":cdsi");
    addStoreNode(symbol_table, li_store_cdbi, getName().getEncodedName() + ":cdbi");
    addStoreNode(symbol_table, li_store_csgi, getName().getEncodedName() + ":csgi");
    addStoreNode(symbol_table, li_store_csdi, getName().getEncodedName() + ":csdi");
    addStoreNode(symbol_table, li_store_cssi, getName().getEncodedName() + ":cssi");
    addStoreNode(symbol_table, li_store_csbi, getName().getEncodedName() + ":csbi");
    addStoreNode(symbol_table, li_store_cbgi, getName().getEncodedName() + ":cbgi");
    addStoreNode(symbol_table, li_store_cbdi, getName().getEncodedName() + ":cbdi");
    addStoreNode(symbol_table, li_store_cbsi, getName().getEncodedName() + ":cbsi");
    addStoreNode(symbol_table, li_store_cbbi, getName().getEncodedName() + ":cbbi");
    addStoreNode(symbol_table, li_store_cgs, getName().getEncodedName() + ":cgs");
    addStoreNode(symbol_table, li_store_cgd, getName().getEncodedName() + ":cgd");
    addStoreNode(symbol_table, li_store_t_total_k, getName().getEncodedName() + ":t_total_k");
    addStoreNode(symbol_table, li_store_t_total_c, getName().getEncodedName() + ":t_total_c");
    addStoreNode(symbol_table, li_store_t_delta_sh, getName().getEncodedName() + ":t_delta_sh");
    addStoreNode(symbol_table, li_store_rs, getName().getEncodedName() + ":rs");
    addStoreNode(symbol_table, li_store_rd, getName().getEncodedName() + ":rd");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_id, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_ig, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_is, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_ib, getName(), "BRANCH_DB");


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_vgisi= stoLIDVec[i++];
      li_store_vdisi= stoLIDVec[i++];
      li_store_vti= stoLIDVec[i++];
      li_store_vdsati= stoLIDVec[i++];
      li_store_pdc= stoLIDVec[i++];
      li_store_idisi= stoLIDVec[i++];
      li_store_igs= stoLIDVec[i++];
      li_store_igd= stoLIDVec[i++];
      li_store_qgi= stoLIDVec[i++];
      li_store_qdi= stoLIDVec[i++];
      li_store_qsi= stoLIDVec[i++];
      li_store_qbi= stoLIDVec[i++];
      li_store_gmi= stoLIDVec[i++];
      li_store_gdsi= stoLIDVec[i++];
      li_store_gmbsi= stoLIDVec[i++];
      li_store_cggi= stoLIDVec[i++];
      li_store_cgdi= stoLIDVec[i++];
      li_store_cgsi= stoLIDVec[i++];
      li_store_cgbi= stoLIDVec[i++];
      li_store_cdgi= stoLIDVec[i++];
      li_store_cddi= stoLIDVec[i++];
      li_store_cdsi= stoLIDVec[i++];
      li_store_cdbi= stoLIDVec[i++];
      li_store_csgi= stoLIDVec[i++];
      li_store_csdi= stoLIDVec[i++];
      li_store_cssi= stoLIDVec[i++];
      li_store_csbi= stoLIDVec[i++];
      li_store_cbgi= stoLIDVec[i++];
      li_store_cbdi= stoLIDVec[i++];
      li_store_cbsi= stoLIDVec[i++];
      li_store_cbbi= stoLIDVec[i++];
      li_store_cgs= stoLIDVec[i++];
      li_store_cgd= stoLIDVec[i++];
      li_store_t_total_k= stoLIDVec[i++];
      li_store_t_total_c= stoLIDVec[i++];
      li_store_t_delta_sh= stoLIDVec[i++];
      li_store_rs= stoLIDVec[i++];
      li_store_rd= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_id = branchLIDVecRef[i++];
    li_branch_ig = branchLIDVecRef[i++];
    li_branch_is = branchLIDVecRef[i++];
    li_branch_ib = branchLIDVecRef[i++];

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_dt)];
    A_d_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_d)];
    A_d_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_drc)];
    A_d_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_gi)];
    A_d_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_s)];
    A_d_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_d,admsNodeID_b)];
    A_d_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_g)];
    A_g_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_g,admsNodeID_gi)];
    A_g_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_dt)];
    A_s_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_b)];
    A_s_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp3)];
    A_s_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp4)];
    A_s_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_gi)];
    A_s_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_s)];
    A_s_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp2)];
    A_s_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_fp1)];
    A_s_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_di)];
    A_s_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_src)];
    A_s_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_s,admsNodeID_d)];
    A_s_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_dt)];
    A_b_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_b)];
    A_b_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp3)];
    A_b_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp4)];
    A_b_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_gi)];
    A_b_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_s)];
    A_b_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp2)];
    A_b_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_fp1)];
    A_b_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_di)];
    A_b_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_b,admsNodeID_d)];
    A_b_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_dt)];
    A_di_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_b)];
    A_di_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_di)];
    A_di_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_fp1)];
    A_di_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_gi)];
    A_di_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_s)];
    A_di_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_si)];
    A_di_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_xt2)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_di,admsNodeID_xt2)];
    A_di_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_dt)];
    A_gi_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_b)];
    A_gi_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp3)];
    A_gi_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp4)];
    A_gi_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_gi)];
    A_gi_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_s)];
    A_gi_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_si)];
    A_gi_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp2)];
    A_gi_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_fp1)];
    A_gi_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_di)];
    A_gi_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_g)];
    A_gi_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_gi,admsNodeID_d)];
    A_gi_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_gi)];
    A_si_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_si)];
    A_si_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_dt)];
    A_si_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_b)];
    A_si_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp3)];
    A_si_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp4)];
    A_si_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_s)];
    A_si_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp2)];
    A_si_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_fp1)];
    A_si_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_di)];
    A_si_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_src)];
    A_si_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_d)];
    A_si_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_xt2)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_si,admsNodeID_xt2)];
    A_si_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_dt)];
    A_fp1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_b)];
    A_fp1_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_fp1)];
    A_fp1_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_fp2)];
    A_fp1_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_gi)];
    A_fp1_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_s)];
    A_fp1_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp1,admsNodeID_di)];
    A_fp1_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_dt)];
    A_fp2_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_b)];
    A_fp2_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_fp2)];
    A_fp2_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_fp3)];
    A_fp2_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_gi)];
    A_fp2_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_s)];
    A_fp2_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp2,admsNodeID_fp1)];
    A_fp2_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_dt)];
    A_fp3_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_b)];
    A_fp3_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_fp3)];
    A_fp3_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_fp4)];
    A_fp3_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_gi)];
    A_fp3_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_s)];
    A_fp3_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp3,admsNodeID_fp2)];
    A_fp3_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_dt)];
    A_fp4_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_b)];
    A_fp4_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_fp3)];
    A_fp4_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_fp4)];
    A_fp4_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_gi)];
    A_fp4_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_s)];
    A_fp4_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_drc)];
    A_fp4_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_d)];
    A_fp4_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_tr)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_fp4,admsNodeID_tr)];
    A_fp4_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_drc)];
    A_drc_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_fp4)];
    A_drc_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_s)];
    A_drc_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_d)];
    A_drc_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_dt)];
    A_drc_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_tr)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_drc,admsNodeID_tr)];
    A_drc_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_dt)];
    A_src_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_si)];
    A_src_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_src)];
    A_src_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_s)];
    A_src_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_src,admsNodeID_d)];
    A_src_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_tr)
{
if (!collapseNode_tr1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr,admsNodeID_tr1)];
    A_tr_Equ_tr1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
}
if (!collapseNode_tr)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr,admsNodeID_tr)];
    A_tr_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_tr1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_d)];
    A_tr1_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_tr1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_g)];
    A_tr1_Equ_g_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_tr1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_tr1)];
    A_tr1_Equ_tr1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_tr1)
{
if (!collapseNode_tr)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_tr1,admsNodeID_tr)];
    A_tr1_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
}
if (!collapseNode_xt1)
{
if (!collapseNode_xt2)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_xt2)];
    A_xt1_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
}
if (!collapseNode_xt1)
{
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_dt)];
    A_xt1_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
}
if (!collapseNode_xt1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_di)];
    A_xt1_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_xt1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_si)];
    A_xt1_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_xt1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_gi)];
    A_xt1_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_xt1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt1,admsNodeID_xt1)];
    A_xt1_Equ_xt1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_xt2)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt2,admsNodeID_xt2)];
    A_xt2_Equ_xt2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_xt2)
{
if (!collapseNode_xt1)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_xt2,admsNodeID_xt1)];
    A_xt2_Equ_xt1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_dt)];
    A_dt_Equ_dt_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_b)];
    A_dt_Equ_b_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp3)];
    A_dt_Equ_fp3_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp4)];
    A_dt_Equ_fp4_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_gi)];
    A_dt_Equ_gi_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_s)];
    A_dt_Equ_s_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp2)];
    A_dt_Equ_fp2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_fp1)];
    A_dt_Equ_fp1_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_di)];
    A_dt_Equ_di_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_si)];
    A_dt_Equ_si_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_src)];
    A_dt_Equ_src_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_d)];
    A_dt_Equ_d_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_drc)];
    A_dt_Equ_drc_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_dt)
{
if (!collapseNode_tr)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_dt,admsNodeID_tr)];
    A_dt_Equ_tr_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
}


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
if (!collapseNode_dt)
{
    f_d_Equ_dt_Node_Ptr = &(dFdx[li_d][A_d_Equ_dt_NodeOffset]);
    q_d_Equ_dt_Node_Ptr = &(dQdx[li_d][A_d_Equ_dt_NodeOffset]);
}
    f_d_Equ_d_Node_Ptr = &(dFdx[li_d][A_d_Equ_d_NodeOffset]);
    q_d_Equ_d_Node_Ptr = &(dQdx[li_d][A_d_Equ_d_NodeOffset]);
    f_d_Equ_drc_Node_Ptr = &(dFdx[li_d][A_d_Equ_drc_NodeOffset]);
    q_d_Equ_drc_Node_Ptr = &(dQdx[li_d][A_d_Equ_drc_NodeOffset]);
    f_d_Equ_gi_Node_Ptr = &(dFdx[li_d][A_d_Equ_gi_NodeOffset]);
    q_d_Equ_gi_Node_Ptr = &(dQdx[li_d][A_d_Equ_gi_NodeOffset]);
    f_d_Equ_s_Node_Ptr = &(dFdx[li_d][A_d_Equ_s_NodeOffset]);
    q_d_Equ_s_Node_Ptr = &(dQdx[li_d][A_d_Equ_s_NodeOffset]);
    f_d_Equ_b_Node_Ptr = &(dFdx[li_d][A_d_Equ_b_NodeOffset]);
    q_d_Equ_b_Node_Ptr = &(dQdx[li_d][A_d_Equ_b_NodeOffset]);
    f_g_Equ_g_Node_Ptr = &(dFdx[li_g][A_g_Equ_g_NodeOffset]);
    q_g_Equ_g_Node_Ptr = &(dQdx[li_g][A_g_Equ_g_NodeOffset]);
    f_g_Equ_gi_Node_Ptr = &(dFdx[li_g][A_g_Equ_gi_NodeOffset]);
    q_g_Equ_gi_Node_Ptr = &(dQdx[li_g][A_g_Equ_gi_NodeOffset]);
if (!collapseNode_dt)
{
    f_s_Equ_dt_Node_Ptr = &(dFdx[li_s][A_s_Equ_dt_NodeOffset]);
    q_s_Equ_dt_Node_Ptr = &(dQdx[li_s][A_s_Equ_dt_NodeOffset]);
}
    f_s_Equ_b_Node_Ptr = &(dFdx[li_s][A_s_Equ_b_NodeOffset]);
    q_s_Equ_b_Node_Ptr = &(dQdx[li_s][A_s_Equ_b_NodeOffset]);
    f_s_Equ_fp3_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp3_NodeOffset]);
    q_s_Equ_fp3_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp3_NodeOffset]);
    f_s_Equ_fp4_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp4_NodeOffset]);
    q_s_Equ_fp4_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp4_NodeOffset]);
    f_s_Equ_gi_Node_Ptr = &(dFdx[li_s][A_s_Equ_gi_NodeOffset]);
    q_s_Equ_gi_Node_Ptr = &(dQdx[li_s][A_s_Equ_gi_NodeOffset]);
    f_s_Equ_s_Node_Ptr = &(dFdx[li_s][A_s_Equ_s_NodeOffset]);
    q_s_Equ_s_Node_Ptr = &(dQdx[li_s][A_s_Equ_s_NodeOffset]);
    f_s_Equ_fp2_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp2_NodeOffset]);
    q_s_Equ_fp2_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp2_NodeOffset]);
    f_s_Equ_fp1_Node_Ptr = &(dFdx[li_s][A_s_Equ_fp1_NodeOffset]);
    q_s_Equ_fp1_Node_Ptr = &(dQdx[li_s][A_s_Equ_fp1_NodeOffset]);
    f_s_Equ_di_Node_Ptr = &(dFdx[li_s][A_s_Equ_di_NodeOffset]);
    q_s_Equ_di_Node_Ptr = &(dQdx[li_s][A_s_Equ_di_NodeOffset]);
    f_s_Equ_src_Node_Ptr = &(dFdx[li_s][A_s_Equ_src_NodeOffset]);
    q_s_Equ_src_Node_Ptr = &(dQdx[li_s][A_s_Equ_src_NodeOffset]);
    f_s_Equ_d_Node_Ptr = &(dFdx[li_s][A_s_Equ_d_NodeOffset]);
    q_s_Equ_d_Node_Ptr = &(dQdx[li_s][A_s_Equ_d_NodeOffset]);
if (!collapseNode_dt)
{
    f_b_Equ_dt_Node_Ptr = &(dFdx[li_b][A_b_Equ_dt_NodeOffset]);
    q_b_Equ_dt_Node_Ptr = &(dQdx[li_b][A_b_Equ_dt_NodeOffset]);
}
    f_b_Equ_b_Node_Ptr = &(dFdx[li_b][A_b_Equ_b_NodeOffset]);
    q_b_Equ_b_Node_Ptr = &(dQdx[li_b][A_b_Equ_b_NodeOffset]);
    f_b_Equ_fp3_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp3_NodeOffset]);
    q_b_Equ_fp3_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp3_NodeOffset]);
    f_b_Equ_fp4_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp4_NodeOffset]);
    q_b_Equ_fp4_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp4_NodeOffset]);
    f_b_Equ_gi_Node_Ptr = &(dFdx[li_b][A_b_Equ_gi_NodeOffset]);
    q_b_Equ_gi_Node_Ptr = &(dQdx[li_b][A_b_Equ_gi_NodeOffset]);
    f_b_Equ_s_Node_Ptr = &(dFdx[li_b][A_b_Equ_s_NodeOffset]);
    q_b_Equ_s_Node_Ptr = &(dQdx[li_b][A_b_Equ_s_NodeOffset]);
    f_b_Equ_fp2_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp2_NodeOffset]);
    q_b_Equ_fp2_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp2_NodeOffset]);
    f_b_Equ_fp1_Node_Ptr = &(dFdx[li_b][A_b_Equ_fp1_NodeOffset]);
    q_b_Equ_fp1_Node_Ptr = &(dQdx[li_b][A_b_Equ_fp1_NodeOffset]);
    f_b_Equ_di_Node_Ptr = &(dFdx[li_b][A_b_Equ_di_NodeOffset]);
    q_b_Equ_di_Node_Ptr = &(dQdx[li_b][A_b_Equ_di_NodeOffset]);
    f_b_Equ_d_Node_Ptr = &(dFdx[li_b][A_b_Equ_d_NodeOffset]);
    q_b_Equ_d_Node_Ptr = &(dQdx[li_b][A_b_Equ_d_NodeOffset]);
if (!collapseNode_dt)
{
    f_di_Equ_dt_Node_Ptr = &(dFdx[li_di][A_di_Equ_dt_NodeOffset]);
    q_di_Equ_dt_Node_Ptr = &(dQdx[li_di][A_di_Equ_dt_NodeOffset]);
}
    f_di_Equ_b_Node_Ptr = &(dFdx[li_di][A_di_Equ_b_NodeOffset]);
    q_di_Equ_b_Node_Ptr = &(dQdx[li_di][A_di_Equ_b_NodeOffset]);
    f_di_Equ_di_Node_Ptr = &(dFdx[li_di][A_di_Equ_di_NodeOffset]);
    q_di_Equ_di_Node_Ptr = &(dQdx[li_di][A_di_Equ_di_NodeOffset]);
    f_di_Equ_fp1_Node_Ptr = &(dFdx[li_di][A_di_Equ_fp1_NodeOffset]);
    q_di_Equ_fp1_Node_Ptr = &(dQdx[li_di][A_di_Equ_fp1_NodeOffset]);
    f_di_Equ_gi_Node_Ptr = &(dFdx[li_di][A_di_Equ_gi_NodeOffset]);
    q_di_Equ_gi_Node_Ptr = &(dQdx[li_di][A_di_Equ_gi_NodeOffset]);
    f_di_Equ_s_Node_Ptr = &(dFdx[li_di][A_di_Equ_s_NodeOffset]);
    q_di_Equ_s_Node_Ptr = &(dQdx[li_di][A_di_Equ_s_NodeOffset]);
    f_di_Equ_si_Node_Ptr = &(dFdx[li_di][A_di_Equ_si_NodeOffset]);
    q_di_Equ_si_Node_Ptr = &(dQdx[li_di][A_di_Equ_si_NodeOffset]);
if (!collapseNode_xt2)
{
    f_di_Equ_xt2_Node_Ptr = &(dFdx[li_di][A_di_Equ_xt2_NodeOffset]);
    q_di_Equ_xt2_Node_Ptr = &(dQdx[li_di][A_di_Equ_xt2_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_gi_Equ_dt_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_dt_NodeOffset]);
    q_gi_Equ_dt_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_dt_NodeOffset]);
}
    f_gi_Equ_b_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_b_NodeOffset]);
    q_gi_Equ_b_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_b_NodeOffset]);
    f_gi_Equ_fp3_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp3_NodeOffset]);
    q_gi_Equ_fp3_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp3_NodeOffset]);
    f_gi_Equ_fp4_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp4_NodeOffset]);
    q_gi_Equ_fp4_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp4_NodeOffset]);
    f_gi_Equ_gi_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_gi_NodeOffset]);
    q_gi_Equ_gi_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_gi_NodeOffset]);
    f_gi_Equ_s_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_s_NodeOffset]);
    q_gi_Equ_s_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_s_NodeOffset]);
    f_gi_Equ_si_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_si_NodeOffset]);
    q_gi_Equ_si_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_si_NodeOffset]);
    f_gi_Equ_fp2_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp2_NodeOffset]);
    q_gi_Equ_fp2_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp2_NodeOffset]);
    f_gi_Equ_fp1_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_fp1_NodeOffset]);
    q_gi_Equ_fp1_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_fp1_NodeOffset]);
    f_gi_Equ_di_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_di_NodeOffset]);
    q_gi_Equ_di_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_di_NodeOffset]);
    f_gi_Equ_g_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_g_NodeOffset]);
    q_gi_Equ_g_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_g_NodeOffset]);
    f_gi_Equ_d_Node_Ptr = &(dFdx[li_gi][A_gi_Equ_d_NodeOffset]);
    q_gi_Equ_d_Node_Ptr = &(dQdx[li_gi][A_gi_Equ_d_NodeOffset]);
    f_si_Equ_gi_Node_Ptr = &(dFdx[li_si][A_si_Equ_gi_NodeOffset]);
    q_si_Equ_gi_Node_Ptr = &(dQdx[li_si][A_si_Equ_gi_NodeOffset]);
    f_si_Equ_si_Node_Ptr = &(dFdx[li_si][A_si_Equ_si_NodeOffset]);
    q_si_Equ_si_Node_Ptr = &(dQdx[li_si][A_si_Equ_si_NodeOffset]);
if (!collapseNode_dt)
{
    f_si_Equ_dt_Node_Ptr = &(dFdx[li_si][A_si_Equ_dt_NodeOffset]);
    q_si_Equ_dt_Node_Ptr = &(dQdx[li_si][A_si_Equ_dt_NodeOffset]);
}
    f_si_Equ_b_Node_Ptr = &(dFdx[li_si][A_si_Equ_b_NodeOffset]);
    q_si_Equ_b_Node_Ptr = &(dQdx[li_si][A_si_Equ_b_NodeOffset]);
    f_si_Equ_fp3_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp3_NodeOffset]);
    q_si_Equ_fp3_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp3_NodeOffset]);
    f_si_Equ_fp4_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp4_NodeOffset]);
    q_si_Equ_fp4_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp4_NodeOffset]);
    f_si_Equ_s_Node_Ptr = &(dFdx[li_si][A_si_Equ_s_NodeOffset]);
    q_si_Equ_s_Node_Ptr = &(dQdx[li_si][A_si_Equ_s_NodeOffset]);
    f_si_Equ_fp2_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp2_NodeOffset]);
    q_si_Equ_fp2_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp2_NodeOffset]);
    f_si_Equ_fp1_Node_Ptr = &(dFdx[li_si][A_si_Equ_fp1_NodeOffset]);
    q_si_Equ_fp1_Node_Ptr = &(dQdx[li_si][A_si_Equ_fp1_NodeOffset]);
    f_si_Equ_di_Node_Ptr = &(dFdx[li_si][A_si_Equ_di_NodeOffset]);
    q_si_Equ_di_Node_Ptr = &(dQdx[li_si][A_si_Equ_di_NodeOffset]);
    f_si_Equ_src_Node_Ptr = &(dFdx[li_si][A_si_Equ_src_NodeOffset]);
    q_si_Equ_src_Node_Ptr = &(dQdx[li_si][A_si_Equ_src_NodeOffset]);
    f_si_Equ_d_Node_Ptr = &(dFdx[li_si][A_si_Equ_d_NodeOffset]);
    q_si_Equ_d_Node_Ptr = &(dQdx[li_si][A_si_Equ_d_NodeOffset]);
if (!collapseNode_xt2)
{
    f_si_Equ_xt2_Node_Ptr = &(dFdx[li_si][A_si_Equ_xt2_NodeOffset]);
    q_si_Equ_xt2_Node_Ptr = &(dQdx[li_si][A_si_Equ_xt2_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_fp1_Equ_dt_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_dt_NodeOffset]);
    q_fp1_Equ_dt_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_dt_NodeOffset]);
}
    f_fp1_Equ_b_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_b_NodeOffset]);
    q_fp1_Equ_b_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_b_NodeOffset]);
    f_fp1_Equ_fp1_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_fp1_NodeOffset]);
    q_fp1_Equ_fp1_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_fp1_NodeOffset]);
    f_fp1_Equ_fp2_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_fp2_NodeOffset]);
    q_fp1_Equ_fp2_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_fp2_NodeOffset]);
    f_fp1_Equ_gi_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_gi_NodeOffset]);
    q_fp1_Equ_gi_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_gi_NodeOffset]);
    f_fp1_Equ_s_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_s_NodeOffset]);
    q_fp1_Equ_s_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_s_NodeOffset]);
    f_fp1_Equ_di_Node_Ptr = &(dFdx[li_fp1][A_fp1_Equ_di_NodeOffset]);
    q_fp1_Equ_di_Node_Ptr = &(dQdx[li_fp1][A_fp1_Equ_di_NodeOffset]);
if (!collapseNode_dt)
{
    f_fp2_Equ_dt_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_dt_NodeOffset]);
    q_fp2_Equ_dt_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_dt_NodeOffset]);
}
    f_fp2_Equ_b_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_b_NodeOffset]);
    q_fp2_Equ_b_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_b_NodeOffset]);
    f_fp2_Equ_fp2_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_fp2_NodeOffset]);
    q_fp2_Equ_fp2_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_fp2_NodeOffset]);
    f_fp2_Equ_fp3_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_fp3_NodeOffset]);
    q_fp2_Equ_fp3_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_fp3_NodeOffset]);
    f_fp2_Equ_gi_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_gi_NodeOffset]);
    q_fp2_Equ_gi_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_gi_NodeOffset]);
    f_fp2_Equ_s_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_s_NodeOffset]);
    q_fp2_Equ_s_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_s_NodeOffset]);
    f_fp2_Equ_fp1_Node_Ptr = &(dFdx[li_fp2][A_fp2_Equ_fp1_NodeOffset]);
    q_fp2_Equ_fp1_Node_Ptr = &(dQdx[li_fp2][A_fp2_Equ_fp1_NodeOffset]);
if (!collapseNode_dt)
{
    f_fp3_Equ_dt_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_dt_NodeOffset]);
    q_fp3_Equ_dt_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_dt_NodeOffset]);
}
    f_fp3_Equ_b_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_b_NodeOffset]);
    q_fp3_Equ_b_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_b_NodeOffset]);
    f_fp3_Equ_fp3_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_fp3_NodeOffset]);
    q_fp3_Equ_fp3_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_fp3_NodeOffset]);
    f_fp3_Equ_fp4_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_fp4_NodeOffset]);
    q_fp3_Equ_fp4_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_fp4_NodeOffset]);
    f_fp3_Equ_gi_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_gi_NodeOffset]);
    q_fp3_Equ_gi_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_gi_NodeOffset]);
    f_fp3_Equ_s_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_s_NodeOffset]);
    q_fp3_Equ_s_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_s_NodeOffset]);
    f_fp3_Equ_fp2_Node_Ptr = &(dFdx[li_fp3][A_fp3_Equ_fp2_NodeOffset]);
    q_fp3_Equ_fp2_Node_Ptr = &(dQdx[li_fp3][A_fp3_Equ_fp2_NodeOffset]);
if (!collapseNode_dt)
{
    f_fp4_Equ_dt_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_dt_NodeOffset]);
    q_fp4_Equ_dt_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_dt_NodeOffset]);
}
    f_fp4_Equ_b_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_b_NodeOffset]);
    q_fp4_Equ_b_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_b_NodeOffset]);
    f_fp4_Equ_fp3_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_fp3_NodeOffset]);
    q_fp4_Equ_fp3_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_fp3_NodeOffset]);
    f_fp4_Equ_fp4_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_fp4_NodeOffset]);
    q_fp4_Equ_fp4_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_fp4_NodeOffset]);
    f_fp4_Equ_gi_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_gi_NodeOffset]);
    q_fp4_Equ_gi_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_gi_NodeOffset]);
    f_fp4_Equ_s_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_s_NodeOffset]);
    q_fp4_Equ_s_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_s_NodeOffset]);
    f_fp4_Equ_drc_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_drc_NodeOffset]);
    q_fp4_Equ_drc_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_drc_NodeOffset]);
    f_fp4_Equ_d_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_d_NodeOffset]);
    q_fp4_Equ_d_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_d_NodeOffset]);
if (!collapseNode_tr)
{
    f_fp4_Equ_tr_Node_Ptr = &(dFdx[li_fp4][A_fp4_Equ_tr_NodeOffset]);
    q_fp4_Equ_tr_Node_Ptr = &(dQdx[li_fp4][A_fp4_Equ_tr_NodeOffset]);
}
    f_drc_Equ_drc_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_drc_NodeOffset]);
    q_drc_Equ_drc_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_drc_NodeOffset]);
    f_drc_Equ_fp4_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_fp4_NodeOffset]);
    q_drc_Equ_fp4_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_fp4_NodeOffset]);
    f_drc_Equ_s_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_s_NodeOffset]);
    q_drc_Equ_s_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_s_NodeOffset]);
    f_drc_Equ_d_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_d_NodeOffset]);
    q_drc_Equ_d_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_d_NodeOffset]);
if (!collapseNode_dt)
{
    f_drc_Equ_dt_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_dt_NodeOffset]);
    q_drc_Equ_dt_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_dt_NodeOffset]);
}
if (!collapseNode_tr)
{
    f_drc_Equ_tr_Node_Ptr = &(dFdx[li_drc][A_drc_Equ_tr_NodeOffset]);
    q_drc_Equ_tr_Node_Ptr = &(dQdx[li_drc][A_drc_Equ_tr_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_src_Equ_dt_Node_Ptr = &(dFdx[li_src][A_src_Equ_dt_NodeOffset]);
    q_src_Equ_dt_Node_Ptr = &(dQdx[li_src][A_src_Equ_dt_NodeOffset]);
}
    f_src_Equ_si_Node_Ptr = &(dFdx[li_src][A_src_Equ_si_NodeOffset]);
    q_src_Equ_si_Node_Ptr = &(dQdx[li_src][A_src_Equ_si_NodeOffset]);
    f_src_Equ_src_Node_Ptr = &(dFdx[li_src][A_src_Equ_src_NodeOffset]);
    q_src_Equ_src_Node_Ptr = &(dQdx[li_src][A_src_Equ_src_NodeOffset]);
    f_src_Equ_s_Node_Ptr = &(dFdx[li_src][A_src_Equ_s_NodeOffset]);
    q_src_Equ_s_Node_Ptr = &(dQdx[li_src][A_src_Equ_s_NodeOffset]);
    f_src_Equ_d_Node_Ptr = &(dFdx[li_src][A_src_Equ_d_NodeOffset]);
    q_src_Equ_d_Node_Ptr = &(dQdx[li_src][A_src_Equ_d_NodeOffset]);
if (!collapseNode_tr)
{
if (!collapseNode_tr1)
{
    f_tr_Equ_tr1_Node_Ptr = &(dFdx[li_tr][A_tr_Equ_tr1_NodeOffset]);
    q_tr_Equ_tr1_Node_Ptr = &(dQdx[li_tr][A_tr_Equ_tr1_NodeOffset]);
}
}
if (!collapseNode_tr)
{
    f_tr_Equ_tr_Node_Ptr = &(dFdx[li_tr][A_tr_Equ_tr_NodeOffset]);
    q_tr_Equ_tr_Node_Ptr = &(dQdx[li_tr][A_tr_Equ_tr_NodeOffset]);
}
if (!collapseNode_tr1)
{
    f_tr1_Equ_d_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_d_NodeOffset]);
    q_tr1_Equ_d_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_d_NodeOffset]);
}
if (!collapseNode_tr1)
{
    f_tr1_Equ_g_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_g_NodeOffset]);
    q_tr1_Equ_g_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_g_NodeOffset]);
}
if (!collapseNode_tr1)
{
    f_tr1_Equ_tr1_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_tr1_NodeOffset]);
    q_tr1_Equ_tr1_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_tr1_NodeOffset]);
}
if (!collapseNode_tr1)
{
if (!collapseNode_tr)
{
    f_tr1_Equ_tr_Node_Ptr = &(dFdx[li_tr1][A_tr1_Equ_tr_NodeOffset]);
    q_tr1_Equ_tr_Node_Ptr = &(dQdx[li_tr1][A_tr1_Equ_tr_NodeOffset]);
}
}
if (!collapseNode_xt1)
{
if (!collapseNode_xt2)
{
    f_xt1_Equ_xt2_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_xt2_NodeOffset]);
    q_xt1_Equ_xt2_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_xt2_NodeOffset]);
}
}
if (!collapseNode_xt1)
{
if (!collapseNode_dt)
{
    f_xt1_Equ_dt_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_dt_NodeOffset]);
    q_xt1_Equ_dt_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_dt_NodeOffset]);
}
}
if (!collapseNode_xt1)
{
    f_xt1_Equ_di_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_di_NodeOffset]);
    q_xt1_Equ_di_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_di_NodeOffset]);
}
if (!collapseNode_xt1)
{
    f_xt1_Equ_si_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_si_NodeOffset]);
    q_xt1_Equ_si_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_si_NodeOffset]);
}
if (!collapseNode_xt1)
{
    f_xt1_Equ_gi_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_gi_NodeOffset]);
    q_xt1_Equ_gi_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_gi_NodeOffset]);
}
if (!collapseNode_xt1)
{
    f_xt1_Equ_xt1_Node_Ptr = &(dFdx[li_xt1][A_xt1_Equ_xt1_NodeOffset]);
    q_xt1_Equ_xt1_Node_Ptr = &(dQdx[li_xt1][A_xt1_Equ_xt1_NodeOffset]);
}
if (!collapseNode_xt2)
{
    f_xt2_Equ_xt2_Node_Ptr = &(dFdx[li_xt2][A_xt2_Equ_xt2_NodeOffset]);
    q_xt2_Equ_xt2_Node_Ptr = &(dQdx[li_xt2][A_xt2_Equ_xt2_NodeOffset]);
}
if (!collapseNode_xt2)
{
if (!collapseNode_xt1)
{
    f_xt2_Equ_xt1_Node_Ptr = &(dFdx[li_xt2][A_xt2_Equ_xt1_NodeOffset]);
    q_xt2_Equ_xt1_Node_Ptr = &(dQdx[li_xt2][A_xt2_Equ_xt1_NodeOffset]);
}
}
if (!collapseNode_dt)
{
    f_dt_Equ_dt_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_dt_NodeOffset]);
    q_dt_Equ_dt_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_dt_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_b_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_b_NodeOffset]);
    q_dt_Equ_b_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_b_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_fp3_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp3_NodeOffset]);
    q_dt_Equ_fp3_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp3_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_fp4_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp4_NodeOffset]);
    q_dt_Equ_fp4_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp4_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_gi_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_gi_NodeOffset]);
    q_dt_Equ_gi_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_gi_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_s_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_s_NodeOffset]);
    q_dt_Equ_s_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_s_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_fp2_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp2_NodeOffset]);
    q_dt_Equ_fp2_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp2_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_fp1_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_fp1_NodeOffset]);
    q_dt_Equ_fp1_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_fp1_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_di_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_di_NodeOffset]);
    q_dt_Equ_di_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_di_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_si_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_si_NodeOffset]);
    q_dt_Equ_si_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_si_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_src_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_src_NodeOffset]);
    q_dt_Equ_src_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_src_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_d_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_d_NodeOffset]);
    q_dt_Equ_d_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_d_NodeOffset]);
}
if (!collapseNode_dt)
{
    f_dt_Equ_drc_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_drc_NodeOffset]);
    q_dt_Equ_drc_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_drc_NodeOffset]);
}
if (!collapseNode_dt)
{
if (!collapseNode_tr)
{
    f_dt_Equ_tr_Node_Ptr = &(dFdx[li_dt][A_dt_Equ_tr_NodeOffset]);
    q_dt_Equ_tr_Node_Ptr = &(dQdx[li_dt][A_dt_Equ_tr_NodeOffset]);
}
}


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_d] += staticContributions[admsNodeID_d];
(*extData.daeFVectorPtr)[li_g] += staticContributions[admsNodeID_g];
(*extData.daeFVectorPtr)[li_s] += staticContributions[admsNodeID_s];
(*extData.daeFVectorPtr)[li_b] += staticContributions[admsNodeID_b];
(*extData.daeFVectorPtr)[li_di] += staticContributions[admsNodeID_di];
(*extData.daeFVectorPtr)[li_gi] += staticContributions[admsNodeID_gi];
(*extData.daeFVectorPtr)[li_si] += staticContributions[admsNodeID_si];
(*extData.daeFVectorPtr)[li_fp1] += staticContributions[admsNodeID_fp1];
(*extData.daeFVectorPtr)[li_fp2] += staticContributions[admsNodeID_fp2];
(*extData.daeFVectorPtr)[li_fp3] += staticContributions[admsNodeID_fp3];
(*extData.daeFVectorPtr)[li_fp4] += staticContributions[admsNodeID_fp4];
(*extData.daeFVectorPtr)[li_drc] += staticContributions[admsNodeID_drc];
(*extData.daeFVectorPtr)[li_src] += staticContributions[admsNodeID_src];
if (!collapseNode_tr)
  (*extData.daeFVectorPtr)[li_tr] += staticContributions[admsNodeID_tr];
if (!collapseNode_tr1)
  (*extData.daeFVectorPtr)[li_tr1] += staticContributions[admsNodeID_tr1];
if (!collapseNode_xt1)
  (*extData.daeFVectorPtr)[li_xt1] += staticContributions[admsNodeID_xt1];
if (!collapseNode_xt2)
  (*extData.daeFVectorPtr)[li_xt2] += staticContributions[admsNodeID_xt2];
if (!collapseNode_dt)
  (*extData.daeFVectorPtr)[li_dt] += staticContributions[admsNodeID_dt];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_id] = leadCurrentF[admsNodeID_d];
    leadF[li_branch_ig] = leadCurrentF[admsNodeID_g];
    leadF[li_branch_is] = leadCurrentF[admsNodeID_s];
    leadF[li_branch_ib] = leadCurrentF[admsNodeID_b];



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_id] = solVec[li_d] - solVec[li_s];
        junctionV[li_branch_ig] = solVec[li_g] - solVec[li_s];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_d] += dynamicContributions[admsNodeID_d];
(*extData.daeQVectorPtr)[li_g] += dynamicContributions[admsNodeID_g];
(*extData.daeQVectorPtr)[li_s] += dynamicContributions[admsNodeID_s];
(*extData.daeQVectorPtr)[li_b] += dynamicContributions[admsNodeID_b];
(*extData.daeQVectorPtr)[li_di] += dynamicContributions[admsNodeID_di];
(*extData.daeQVectorPtr)[li_gi] += dynamicContributions[admsNodeID_gi];
(*extData.daeQVectorPtr)[li_si] += dynamicContributions[admsNodeID_si];
(*extData.daeQVectorPtr)[li_fp1] += dynamicContributions[admsNodeID_fp1];
(*extData.daeQVectorPtr)[li_fp2] += dynamicContributions[admsNodeID_fp2];
(*extData.daeQVectorPtr)[li_fp3] += dynamicContributions[admsNodeID_fp3];
(*extData.daeQVectorPtr)[li_fp4] += dynamicContributions[admsNodeID_fp4];
(*extData.daeQVectorPtr)[li_drc] += dynamicContributions[admsNodeID_drc];
(*extData.daeQVectorPtr)[li_src] += dynamicContributions[admsNodeID_src];
if (!collapseNode_tr)
  (*extData.daeQVectorPtr)[li_tr] += dynamicContributions[admsNodeID_tr];
if (!collapseNode_tr1)
  (*extData.daeQVectorPtr)[li_tr1] += dynamicContributions[admsNodeID_tr1];
if (!collapseNode_xt1)
  (*extData.daeQVectorPtr)[li_xt1] += dynamicContributions[admsNodeID_xt1];
if (!collapseNode_xt2)
  (*extData.daeQVectorPtr)[li_xt2] += dynamicContributions[admsNodeID_xt2];
if (!collapseNode_dt)
  (*extData.daeQVectorPtr)[li_dt] += dynamicContributions[admsNodeID_dt];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_id] = leadCurrentQ[admsNodeID_d];
    leadQ[li_branch_ig] = leadCurrentQ[admsNodeID_g];
    leadQ[li_branch_is] = leadCurrentQ[admsNodeID_s];
    leadQ[li_branch_ib] = leadCurrentQ[admsNodeID_b];


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_vgisi] = vgisi;
  stoVec[li_store_vdisi] = vdisi;
  stoVec[li_store_vti] = vti;
  stoVec[li_store_vdsati] = vdsati;
  stoVec[li_store_pdc] = pdc;
  stoVec[li_store_idisi] = idisi;
  stoVec[li_store_igs] = igs;
  stoVec[li_store_igd] = igd;
  stoVec[li_store_qgi] = qgi;
  stoVec[li_store_qdi] = qdi;
  stoVec[li_store_qsi] = qsi;
  stoVec[li_store_qbi] = qbi;
  stoVec[li_store_gmi] = gmi;
  stoVec[li_store_gdsi] = gdsi;
  stoVec[li_store_gmbsi] = gmbsi;
  stoVec[li_store_cggi] = cggi;
  stoVec[li_store_cgdi] = cgdi;
  stoVec[li_store_cgsi] = cgsi;
  stoVec[li_store_cgbi] = cgbi;
  stoVec[li_store_cdgi] = cdgi;
  stoVec[li_store_cddi] = cddi;
  stoVec[li_store_cdsi] = cdsi;
  stoVec[li_store_cdbi] = cdbi;
  stoVec[li_store_csgi] = csgi;
  stoVec[li_store_csdi] = csdi;
  stoVec[li_store_cssi] = cssi;
  stoVec[li_store_csbi] = csbi;
  stoVec[li_store_cbgi] = cbgi;
  stoVec[li_store_cbdi] = cbdi;
  stoVec[li_store_cbsi] = cbsi;
  stoVec[li_store_cbbi] = cbbi;
  stoVec[li_store_cgs] = cgs;
  stoVec[li_store_cgd] = cgd;
  stoVec[li_store_t_total_k] = t_total_k;
  stoVec[li_store_t_total_c] = t_total_c;
  stoVec[li_store_t_delta_sh] = t_delta_sh;
  stoVec[li_store_rs] = rs;
  stoVec[li_store_rd] = rd;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one mvsg_cmc instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSmvsg_cmc::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double pdiss=0.0;
     double d_pdiss_dV_drc_d=0.0;
     double d_pdiss_dV_gi_si=0.0;
     double d_pdiss_dV_di_si=0.0;
     double d_pdiss_dTemp_dt_GND=0.0;
     double d_pdiss_dV_tr_GND=0.0;
     double d_pdiss_dV_fp4_d=0.0;
     double d_pdiss_dV_fp4_s=0.0;
     double d_pdiss_dV_drc_fp4=0.0;
     double d_pdiss_dV_src_d=0.0;
     double d_pdiss_dV_src_s=0.0;
     double d_pdiss_dV_si_src=0.0;
     double d_pdiss_dV_s_di=0.0;
     double d_pdiss_dV_gi_di=0.0;
     double d_pdiss_dV_fp1_di=0.0;
     double d_pdiss_dV_b_di=0.0;
     double d_pdiss_dV_s_fp1=0.0;
     double d_pdiss_dV_gi_fp1=0.0;
     double d_pdiss_dV_fp2_fp1=0.0;
     double d_pdiss_dV_b_fp1=0.0;
     double d_pdiss_dV_s_fp2=0.0;
     double d_pdiss_dV_gi_fp2=0.0;
     double d_pdiss_dV_fp3_fp2=0.0;
     double d_pdiss_dV_b_fp2=0.0;
     double d_pdiss_dV_s_fp3=0.0;
     double d_pdiss_dV_gi_fp3=0.0;
     double d_pdiss_dV_fp4_fp3=0.0;
     double d_pdiss_dV_b_fp3=0.0;
  double svc=0.0;
  double gm=0.0;
  double qofgsub=0.0;
     double d_qofgsub_dV_gi_b=0.0;
  double qofssub=0.0;
     double d_qofssub_dV_s_b=0.0;
  double qofdsub=0.0;
     double d_qofdsub_dV_d_b=0.0;
  double qofds=0.0;
     double d_qofds_dV_d_s=0.0;
  double qofd=0.0;
     double d_qofd_dV_gi_d=0.0;
  double qofs=0.0;
     double d_qofs_dV_gi_s=0.0;
  double igdrec=0.0;
     double d_igdrec_dV_gi_si=0.0;
     double d_igdrec_dV_di_si=0.0;
     double d_igdrec_dTemp_dt_GND=0.0;
  double igsrec=0.0;
     double d_igsrec_dV_gi_si=0.0;
     double d_igsrec_dTemp_dt_GND=0.0;
  double igdsdio=0.0;
     double d_igdsdio_dV_gi_si=0.0;
     double d_igdsdio_dV_di_si=0.0;
     double d_igdsdio_dTemp_dt_GND=0.0;
  double igssdio=0.0;
     double d_igssdio_dV_gi_si=0.0;
     double d_igssdio_dTemp_dt_GND=0.0;
  double igdi=0.0;
     double d_igdi_dV_gi_si=0.0;
     double d_igdi_dV_di_si=0.0;
     double d_igdi_dTemp_dt_GND=0.0;
  double igsi=0.0;
     double d_igsi_dV_gi_si=0.0;
     double d_igsi_dTemp_dt_GND=0.0;
  double idsrf=0.0;
     double d_idsrf_dV_xt2_GND=0.0;
  double vdsat1i=0.0;
     double d_vdsat1i_dV_gi_si=0.0;
     double d_vdsat1i_dV_di_si=0.0;
     double d_vdsat1i_dTemp_dt_GND=0.0;
  double vtdibli=0.0;
     double d_vtdibli_dV_gi_si=0.0;
     double d_vtdibli_dV_di_si=0.0;
     double d_vtdibli_dTemp_dt_GND=0.0;
  double qs=0.0;
     double d_qs_dV_gi_si=0.0;
     double d_qs_dV_di_si=0.0;
     double d_qs_dTemp_dt_GND=0.0;
  double qb=0.0;
     double d_qb_dV_gi_si=0.0;
     double d_qb_dV_di_si=0.0;
     double d_qb_dTemp_dt_GND=0.0;
  double qc=0.0;
     double d_qc_dV_gi_si=0.0;
     double d_qc_dV_di_si=0.0;
     double d_qc_dTemp_dt_GND=0.0;
  double qgd=0.0;
     double d_qgd_dV_gi_si=0.0;
     double d_qgd_dV_di_si=0.0;
     double d_qgd_dTemp_dt_GND=0.0;
  double qgs=0.0;
     double d_qgs_dV_gi_si=0.0;
     double d_qgs_dV_di_si=0.0;
     double d_qgs_dTemp_dt_GND=0.0;
  double ids=0.0;
     double d_ids_dV_gi_si=0.0;
     double d_ids_dV_di_si=0.0;
     double d_ids_dTemp_dt_GND=0.0;
  double vdsatrd=0.0;
     double d_vdsatrd_dV_tr_GND=0.0;
     double d_vdsatrd_dTemp_dt_GND=0.0;
     double d_vdsatrd_dV_fp4_d=0.0;
     double d_vdsatrd_dV_fp4_s=0.0;
     double d_vdsatrd_dV_drc_fp4=0.0;
  double vtdiblrd=0.0;
     double d_vtdiblrd_dV_tr_GND=0.0;
     double d_vtdiblrd_dTemp_dt_GND=0.0;
     double d_vtdiblrd_dV_fp4_d=0.0;
     double d_vtdiblrd_dV_fp4_s=0.0;
     double d_vtdiblrd_dV_drc_fp4=0.0;
  double qsrd=0.0;
     double d_qsrd_dV_tr_GND=0.0;
     double d_qsrd_dTemp_dt_GND=0.0;
     double d_qsrd_dV_fp4_d=0.0;
     double d_qsrd_dV_fp4_s=0.0;
     double d_qsrd_dV_drc_fp4=0.0;
  double qbrd=0.0;
     double d_qbrd_dV_tr_GND=0.0;
     double d_qbrd_dTemp_dt_GND=0.0;
     double d_qbrd_dV_fp4_d=0.0;
     double d_qbrd_dV_fp4_s=0.0;
     double d_qbrd_dV_drc_fp4=0.0;
  double qcrd=0.0;
     double d_qcrd_dV_tr_GND=0.0;
     double d_qcrd_dTemp_dt_GND=0.0;
     double d_qcrd_dV_fp4_d=0.0;
     double d_qcrd_dV_fp4_s=0.0;
     double d_qcrd_dV_drc_fp4=0.0;
  double qgdrd=0.0;
     double d_qgdrd_dV_tr_GND=0.0;
     double d_qgdrd_dTemp_dt_GND=0.0;
     double d_qgdrd_dV_fp4_d=0.0;
     double d_qgdrd_dV_fp4_s=0.0;
     double d_qgdrd_dV_drc_fp4=0.0;
  double qgsrd=0.0;
     double d_qgsrd_dV_tr_GND=0.0;
     double d_qgsrd_dTemp_dt_GND=0.0;
     double d_qgsrd_dV_fp4_d=0.0;
     double d_qgsrd_dV_fp4_s=0.0;
     double d_qgsrd_dV_drc_fp4=0.0;
  double idsrd=0.0;
     double d_idsrd_dV_tr_GND=0.0;
     double d_idsrd_dTemp_dt_GND=0.0;
     double d_idsrd_dV_fp4_d=0.0;
     double d_idsrd_dV_fp4_s=0.0;
     double d_idsrd_dV_drc_fp4=0.0;
  double vdsatrs=0.0;
     double d_vdsatrs_dV_src_d=0.0;
     double d_vdsatrs_dV_src_s=0.0;
     double d_vdsatrs_dV_si_src=0.0;
     double d_vdsatrs_dTemp_dt_GND=0.0;
  double vtdiblrs=0.0;
     double d_vtdiblrs_dV_src_d=0.0;
     double d_vtdiblrs_dV_src_s=0.0;
     double d_vtdiblrs_dV_si_src=0.0;
     double d_vtdiblrs_dTemp_dt_GND=0.0;
  double qsrs=0.0;
     double d_qsrs_dV_src_d=0.0;
     double d_qsrs_dV_src_s=0.0;
     double d_qsrs_dV_si_src=0.0;
     double d_qsrs_dTemp_dt_GND=0.0;
  double qbrs=0.0;
     double d_qbrs_dV_src_d=0.0;
     double d_qbrs_dV_src_s=0.0;
     double d_qbrs_dV_si_src=0.0;
     double d_qbrs_dTemp_dt_GND=0.0;
  double qcrs=0.0;
     double d_qcrs_dV_src_d=0.0;
     double d_qcrs_dV_src_s=0.0;
     double d_qcrs_dV_si_src=0.0;
     double d_qcrs_dTemp_dt_GND=0.0;
  double qgdrs=0.0;
     double d_qgdrs_dV_src_d=0.0;
     double d_qgdrs_dV_src_s=0.0;
     double d_qgdrs_dV_si_src=0.0;
     double d_qgdrs_dTemp_dt_GND=0.0;
  double qgsrs=0.0;
     double d_qgsrs_dV_src_d=0.0;
     double d_qgsrs_dV_src_s=0.0;
     double d_qgsrs_dV_si_src=0.0;
     double d_qgsrs_dTemp_dt_GND=0.0;
  double idsrs=0.0;
     double d_idsrs_dV_src_d=0.0;
     double d_idsrs_dV_src_s=0.0;
     double d_idsrs_dV_si_src=0.0;
     double d_idsrs_dTemp_dt_GND=0.0;
  double vdsatfp1=0.0;
     double d_vdsatfp1_dV_s_di=0.0;
     double d_vdsatfp1_dV_gi_di=0.0;
     double d_vdsatfp1_dV_fp1_di=0.0;
     double d_vdsatfp1_dV_b_di=0.0;
     double d_vdsatfp1_dTemp_dt_GND=0.0;
  double vtdiblfp1=0.0;
     double d_vtdiblfp1_dV_s_di=0.0;
     double d_vtdiblfp1_dV_gi_di=0.0;
     double d_vtdiblfp1_dV_fp1_di=0.0;
     double d_vtdiblfp1_dV_b_di=0.0;
     double d_vtdiblfp1_dTemp_dt_GND=0.0;
  double qsfp1=0.0;
     double d_qsfp1_dV_s_di=0.0;
     double d_qsfp1_dV_gi_di=0.0;
     double d_qsfp1_dV_fp1_di=0.0;
     double d_qsfp1_dV_b_di=0.0;
     double d_qsfp1_dTemp_dt_GND=0.0;
  double qbfp1=0.0;
     double d_qbfp1_dV_s_di=0.0;
     double d_qbfp1_dV_gi_di=0.0;
     double d_qbfp1_dV_fp1_di=0.0;
     double d_qbfp1_dV_b_di=0.0;
     double d_qbfp1_dTemp_dt_GND=0.0;
  double qcfp1=0.0;
     double d_qcfp1_dV_s_di=0.0;
     double d_qcfp1_dV_gi_di=0.0;
     double d_qcfp1_dV_fp1_di=0.0;
     double d_qcfp1_dV_b_di=0.0;
     double d_qcfp1_dTemp_dt_GND=0.0;
  double qgdfp1=0.0;
     double d_qgdfp1_dV_s_di=0.0;
     double d_qgdfp1_dV_gi_di=0.0;
     double d_qgdfp1_dV_fp1_di=0.0;
     double d_qgdfp1_dV_b_di=0.0;
     double d_qgdfp1_dTemp_dt_GND=0.0;
  double qgsfp1=0.0;
     double d_qgsfp1_dV_s_di=0.0;
     double d_qgsfp1_dV_gi_di=0.0;
     double d_qgsfp1_dV_fp1_di=0.0;
     double d_qgsfp1_dV_b_di=0.0;
     double d_qgsfp1_dTemp_dt_GND=0.0;
  double idsfp1=0.0;
     double d_idsfp1_dV_s_di=0.0;
     double d_idsfp1_dV_gi_di=0.0;
     double d_idsfp1_dV_fp1_di=0.0;
     double d_idsfp1_dV_b_di=0.0;
     double d_idsfp1_dTemp_dt_GND=0.0;
  double vdsatfp2=0.0;
     double d_vdsatfp2_dV_s_fp1=0.0;
     double d_vdsatfp2_dV_gi_fp1=0.0;
     double d_vdsatfp2_dV_fp2_fp1=0.0;
     double d_vdsatfp2_dV_b_fp1=0.0;
     double d_vdsatfp2_dTemp_dt_GND=0.0;
  double vtdiblfp2=0.0;
     double d_vtdiblfp2_dV_s_fp1=0.0;
     double d_vtdiblfp2_dV_gi_fp1=0.0;
     double d_vtdiblfp2_dV_fp2_fp1=0.0;
     double d_vtdiblfp2_dV_b_fp1=0.0;
     double d_vtdiblfp2_dTemp_dt_GND=0.0;
  double qsfp2=0.0;
     double d_qsfp2_dV_s_fp1=0.0;
     double d_qsfp2_dV_gi_fp1=0.0;
     double d_qsfp2_dV_fp2_fp1=0.0;
     double d_qsfp2_dV_b_fp1=0.0;
     double d_qsfp2_dTemp_dt_GND=0.0;
  double qbfp2=0.0;
     double d_qbfp2_dV_s_fp1=0.0;
     double d_qbfp2_dV_gi_fp1=0.0;
     double d_qbfp2_dV_fp2_fp1=0.0;
     double d_qbfp2_dV_b_fp1=0.0;
     double d_qbfp2_dTemp_dt_GND=0.0;
  double qcfp2=0.0;
     double d_qcfp2_dV_s_fp1=0.0;
     double d_qcfp2_dV_gi_fp1=0.0;
     double d_qcfp2_dV_fp2_fp1=0.0;
     double d_qcfp2_dV_b_fp1=0.0;
     double d_qcfp2_dTemp_dt_GND=0.0;
  double qgdfp2=0.0;
     double d_qgdfp2_dV_s_fp1=0.0;
     double d_qgdfp2_dV_gi_fp1=0.0;
     double d_qgdfp2_dV_fp2_fp1=0.0;
     double d_qgdfp2_dV_b_fp1=0.0;
     double d_qgdfp2_dTemp_dt_GND=0.0;
  double qgsfp2=0.0;
     double d_qgsfp2_dV_s_fp1=0.0;
     double d_qgsfp2_dV_gi_fp1=0.0;
     double d_qgsfp2_dV_fp2_fp1=0.0;
     double d_qgsfp2_dV_b_fp1=0.0;
     double d_qgsfp2_dTemp_dt_GND=0.0;
  double idsfp2=0.0;
     double d_idsfp2_dV_s_fp1=0.0;
     double d_idsfp2_dV_gi_fp1=0.0;
     double d_idsfp2_dV_fp2_fp1=0.0;
     double d_idsfp2_dV_b_fp1=0.0;
     double d_idsfp2_dTemp_dt_GND=0.0;
  double vdsatfp3=0.0;
     double d_vdsatfp3_dV_s_fp2=0.0;
     double d_vdsatfp3_dV_gi_fp2=0.0;
     double d_vdsatfp3_dV_fp3_fp2=0.0;
     double d_vdsatfp3_dV_b_fp2=0.0;
     double d_vdsatfp3_dTemp_dt_GND=0.0;
  double vtdiblfp3=0.0;
     double d_vtdiblfp3_dV_s_fp2=0.0;
     double d_vtdiblfp3_dV_gi_fp2=0.0;
     double d_vtdiblfp3_dV_fp3_fp2=0.0;
     double d_vtdiblfp3_dV_b_fp2=0.0;
     double d_vtdiblfp3_dTemp_dt_GND=0.0;
  double qsfp3=0.0;
     double d_qsfp3_dV_s_fp2=0.0;
     double d_qsfp3_dV_gi_fp2=0.0;
     double d_qsfp3_dV_fp3_fp2=0.0;
     double d_qsfp3_dV_b_fp2=0.0;
     double d_qsfp3_dTemp_dt_GND=0.0;
  double qbfp3=0.0;
     double d_qbfp3_dV_s_fp2=0.0;
     double d_qbfp3_dV_gi_fp2=0.0;
     double d_qbfp3_dV_fp3_fp2=0.0;
     double d_qbfp3_dV_b_fp2=0.0;
     double d_qbfp3_dTemp_dt_GND=0.0;
  double qcfp3=0.0;
     double d_qcfp3_dV_s_fp2=0.0;
     double d_qcfp3_dV_gi_fp2=0.0;
     double d_qcfp3_dV_fp3_fp2=0.0;
     double d_qcfp3_dV_b_fp2=0.0;
     double d_qcfp3_dTemp_dt_GND=0.0;
  double qgdfp3=0.0;
     double d_qgdfp3_dV_s_fp2=0.0;
     double d_qgdfp3_dV_gi_fp2=0.0;
     double d_qgdfp3_dV_fp3_fp2=0.0;
     double d_qgdfp3_dV_b_fp2=0.0;
     double d_qgdfp3_dTemp_dt_GND=0.0;
  double qgsfp3=0.0;
     double d_qgsfp3_dV_s_fp2=0.0;
     double d_qgsfp3_dV_gi_fp2=0.0;
     double d_qgsfp3_dV_fp3_fp2=0.0;
     double d_qgsfp3_dV_b_fp2=0.0;
     double d_qgsfp3_dTemp_dt_GND=0.0;
  double idsfp3=0.0;
     double d_idsfp3_dV_s_fp2=0.0;
     double d_idsfp3_dV_gi_fp2=0.0;
     double d_idsfp3_dV_fp3_fp2=0.0;
     double d_idsfp3_dV_b_fp2=0.0;
     double d_idsfp3_dTemp_dt_GND=0.0;
  double vdsatfp4=0.0;
     double d_vdsatfp4_dV_s_fp3=0.0;
     double d_vdsatfp4_dV_gi_fp3=0.0;
     double d_vdsatfp4_dV_fp4_fp3=0.0;
     double d_vdsatfp4_dV_b_fp3=0.0;
     double d_vdsatfp4_dTemp_dt_GND=0.0;
  double vtdiblfp4=0.0;
     double d_vtdiblfp4_dV_s_fp3=0.0;
     double d_vtdiblfp4_dV_gi_fp3=0.0;
     double d_vtdiblfp4_dV_fp4_fp3=0.0;
     double d_vtdiblfp4_dV_b_fp3=0.0;
     double d_vtdiblfp4_dTemp_dt_GND=0.0;
  double qsfp4=0.0;
     double d_qsfp4_dV_s_fp3=0.0;
     double d_qsfp4_dV_gi_fp3=0.0;
     double d_qsfp4_dV_fp4_fp3=0.0;
     double d_qsfp4_dV_b_fp3=0.0;
     double d_qsfp4_dTemp_dt_GND=0.0;
  double qbfp4=0.0;
     double d_qbfp4_dV_s_fp3=0.0;
     double d_qbfp4_dV_gi_fp3=0.0;
     double d_qbfp4_dV_fp4_fp3=0.0;
     double d_qbfp4_dV_b_fp3=0.0;
     double d_qbfp4_dTemp_dt_GND=0.0;
  double qcfp4=0.0;
     double d_qcfp4_dV_s_fp3=0.0;
     double d_qcfp4_dV_gi_fp3=0.0;
     double d_qcfp4_dV_fp4_fp3=0.0;
     double d_qcfp4_dV_b_fp3=0.0;
     double d_qcfp4_dTemp_dt_GND=0.0;
  double qgdfp4=0.0;
     double d_qgdfp4_dV_s_fp3=0.0;
     double d_qgdfp4_dV_gi_fp3=0.0;
     double d_qgdfp4_dV_fp4_fp3=0.0;
     double d_qgdfp4_dV_b_fp3=0.0;
     double d_qgdfp4_dTemp_dt_GND=0.0;
  double qgsfp4=0.0;
     double d_qgsfp4_dV_s_fp3=0.0;
     double d_qgsfp4_dV_gi_fp3=0.0;
     double d_qgsfp4_dV_fp4_fp3=0.0;
     double d_qgsfp4_dV_b_fp3=0.0;
     double d_qgsfp4_dTemp_dt_GND=0.0;
  double idsfp4=0.0;
     double d_idsfp4_dV_s_fp3=0.0;
     double d_idsfp4_dV_gi_fp3=0.0;
     double d_idsfp4_dV_fp4_fp3=0.0;
     double d_idsfp4_dV_b_fp3=0.0;
     double d_idsfp4_dTemp_dt_GND=0.0;
  double vbfp4=0.0;
     double d_vbfp4_dV_b_fp3=0.0;
  double vdsfp4=0.0;
     double d_vdsfp4_dV_fp4_fp3=0.0;
  double vcfp4=0.0;
     double d_vcfp4_dV_gi_fp3=0.0;
     double d_vcfp4_dV_s_fp3=0.0;
  double vgsfp4=0.0;
     double d_vgsfp4_dV_s_fp3=0.0;
     double d_vgsfp4_dV_gi_fp3=0.0;
  double vbfp3=0.0;
     double d_vbfp3_dV_b_fp2=0.0;
  double vdsfp3=0.0;
     double d_vdsfp3_dV_fp3_fp2=0.0;
  double vcfp3=0.0;
     double d_vcfp3_dV_gi_fp2=0.0;
     double d_vcfp3_dV_s_fp2=0.0;
  double vgsfp3=0.0;
     double d_vgsfp3_dV_s_fp2=0.0;
     double d_vgsfp3_dV_gi_fp2=0.0;
  double vbfp2=0.0;
     double d_vbfp2_dV_b_fp1=0.0;
  double vdsfp2=0.0;
     double d_vdsfp2_dV_fp2_fp1=0.0;
  double vcfp2=0.0;
     double d_vcfp2_dV_gi_fp1=0.0;
     double d_vcfp2_dV_s_fp1=0.0;
  double vgsfp2=0.0;
     double d_vgsfp2_dV_s_fp1=0.0;
     double d_vgsfp2_dV_gi_fp1=0.0;
  double vbfp1=0.0;
     double d_vbfp1_dV_b_di=0.0;
  double vdsfp1=0.0;
     double d_vdsfp1_dV_fp1_di=0.0;
  double vcfp1=0.0;
     double d_vcfp1_dV_gi_di=0.0;
     double d_vcfp1_dV_s_di=0.0;
  double vgsfp1=0.0;
     double d_vgsfp1_dV_s_di=0.0;
     double d_vgsfp1_dV_gi_di=0.0;
  double vgsrd=0.0;
     double d_vgsrd_dV_tr_GND=0.0;
     double d_vgsrd_dTemp_dt_GND=0.0;
     double d_vgsrd_dV_fp4_d=0.0;
     double d_vgsrd_dV_fp4_s=0.0;
  double vdsrd=0.0;
     double d_vdsrd_dV_drc_fp4=0.0;
  double vigd=0.0;
     double d_vigd_dV_tr_GND=0.0;
     double d_vigd_dTemp_dt_GND=0.0;
  double vdars=0.0;
     double d_vdars_dV_fp4_d=0.0;
     double d_vdars_dV_fp4_s=0.0;
  double drsht=0.0;
     double d_drsht_dV_tr_GND=0.0;
     double d_drsht_dTemp_dt_GND=0.0;
  double vtcollapse=0.0;
     double d_vtcollapse_dV_tr_GND=0.0;
  double vtcollapse0=0.0;
     double d_vtcollapse0_dV_d_g=0.0;
  double vgsrs=0.0;
     double d_vgsrs_dV_src_d=0.0;
     double d_vgsrs_dV_src_s=0.0;
  double vdsrs=0.0;
     double d_vdsrs_dV_si_src=0.0;
  double vigs=0.0;
  double vsars=0.0;
     double d_vsars_dV_src_d=0.0;
     double d_vsars_dV_src_s=0.0;
  double vgsi=0.0;
     double d_vgsi_dV_gi_si=0.0;
  double vdsi=0.0;
     double d_vdsi_dV_di_si=0.0;
  double ttrapfac=0.0;
     double d_ttrapfac_dTemp_dt_GND=0.0;
  double phit=0.0;
     double d_phit_dTemp_dt_GND=0.0;
  double rdi=0.0;
     double d_rdi_dTemp_dt_GND=0.0;
  double rsi=0.0;
     double d_rsi_dTemp_dt_GND=0.0;
  double tdut=0.0;
     double d_tdut_dTemp_dt_GND=0.0;
  double tsh=0.0;
     double d_tsh_dTemp_dt_GND=0.0;
  double tambk=0.0;
  double tnomk=0.0;
  double gmin=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (45))
  {
    probeVars.resize(45);
    d_probeVars.resize(45);
    for (int i=0;i<45;i++)
    {
      d_probeVars[i].resize(45);
      for (int j=0;j<45;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(18+0);
    d_staticContributions.resize(18+0);
    for (int i=0;i<18+0;i++)
      d_staticContributions[i].resize(45);
    dynamicContributions.resize(18+0);
    d_dynamicContributions.resize(18+0);
    for (int i=0;i<18+0;i++)
      d_dynamicContributions[i].resize(45);
  }


  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 18+0 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<45;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<45;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_si_GND] = (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_si_GND][admsProbeID_V_si_GND] = 1.0;
probeVars[admsProbeID_V_b_GND] = (*solVectorPtr)[li_b];
d_probeVars[admsProbeID_V_b_GND][admsProbeID_V_b_GND] = 1.0;
probeVars[admsProbeID_V_di_GND] = (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_di_GND][admsProbeID_V_di_GND] = 1.0;
probeVars[admsProbeID_V_gi_GND] = (*solVectorPtr)[li_gi];
d_probeVars[admsProbeID_V_gi_GND][admsProbeID_V_gi_GND] = 1.0;
probeVars[admsProbeID_V_drc_d] = (*solVectorPtr)[li_drc] - (*solVectorPtr)[li_d];
d_probeVars[admsProbeID_V_drc_d][admsProbeID_V_drc_d] = 1.0;
probeVars[admsProbeID_V_gi_b] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_b];
d_probeVars[admsProbeID_V_gi_b][admsProbeID_V_gi_b] = 1.0;
probeVars[admsProbeID_V_s_b] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_b];
d_probeVars[admsProbeID_V_s_b][admsProbeID_V_s_b] = 1.0;
probeVars[admsProbeID_V_d_b] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_b];
d_probeVars[admsProbeID_V_d_b][admsProbeID_V_d_b] = 1.0;
probeVars[admsProbeID_V_d_s] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_d_s][admsProbeID_V_d_s] = 1.0;
probeVars[admsProbeID_V_gi_d] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_d];
d_probeVars[admsProbeID_V_gi_d][admsProbeID_V_gi_d] = 1.0;
probeVars[admsProbeID_V_gi_s] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_gi_s][admsProbeID_V_gi_s] = 1.0;
probeVars[admsProbeID_V_g_gi] = (*solVectorPtr)[li_g] - (*solVectorPtr)[li_gi];
d_probeVars[admsProbeID_V_g_gi][admsProbeID_V_g_gi] = 1.0;
probeVars[admsProbeID_V_d_drc] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_drc];
d_probeVars[admsProbeID_V_d_drc][admsProbeID_V_d_drc] = 1.0;
probeVars[admsProbeID_V_xt1_GND] = ((collapseNode_xt1)?(0):((*solVectorPtr)[li_xt1]));
d_probeVars[admsProbeID_V_xt1_GND][admsProbeID_V_xt1_GND] = 1.0;
probeVars[admsProbeID_V_xt2_GND] = ((collapseNode_xt2)?(0):((*solVectorPtr)[li_xt2]));
d_probeVars[admsProbeID_V_xt2_GND][admsProbeID_V_xt2_GND] = 1.0;
probeVars[admsProbeID_V_s_fp4] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp4];
d_probeVars[admsProbeID_V_s_fp4][admsProbeID_V_s_fp4] = 1.0;
probeVars[admsProbeID_V_gi_fp4] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp4];
d_probeVars[admsProbeID_V_gi_fp4][admsProbeID_V_gi_fp4] = 1.0;
probeVars[admsProbeID_V_b_fp3] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_fp3];
d_probeVars[admsProbeID_V_b_fp3][admsProbeID_V_b_fp3] = 1.0;
probeVars[admsProbeID_V_fp4_fp3] = (*solVectorPtr)[li_fp4] - (*solVectorPtr)[li_fp3];
d_probeVars[admsProbeID_V_fp4_fp3][admsProbeID_V_fp4_fp3] = 1.0;
probeVars[admsProbeID_V_s_fp3] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp3];
d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3] = 1.0;
probeVars[admsProbeID_V_gi_fp3] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp3];
d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3] = 1.0;
probeVars[admsProbeID_V_b_fp2] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_fp2];
d_probeVars[admsProbeID_V_b_fp2][admsProbeID_V_b_fp2] = 1.0;
probeVars[admsProbeID_V_fp3_fp2] = (*solVectorPtr)[li_fp3] - (*solVectorPtr)[li_fp2];
d_probeVars[admsProbeID_V_fp3_fp2][admsProbeID_V_fp3_fp2] = 1.0;
probeVars[admsProbeID_V_s_fp2] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp2];
d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2] = 1.0;
probeVars[admsProbeID_V_gi_fp2] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp2];
d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2] = 1.0;
probeVars[admsProbeID_V_b_fp1] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_fp1];
d_probeVars[admsProbeID_V_b_fp1][admsProbeID_V_b_fp1] = 1.0;
probeVars[admsProbeID_V_fp2_fp1] = (*solVectorPtr)[li_fp2] - (*solVectorPtr)[li_fp1];
d_probeVars[admsProbeID_V_fp2_fp1][admsProbeID_V_fp2_fp1] = 1.0;
probeVars[admsProbeID_V_s_fp1] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_fp1];
d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1] = 1.0;
probeVars[admsProbeID_V_gi_fp1] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_fp1];
d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1] = 1.0;
probeVars[admsProbeID_V_b_di] = (*solVectorPtr)[li_b] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_b_di][admsProbeID_V_b_di] = 1.0;
probeVars[admsProbeID_V_fp1_di] = (*solVectorPtr)[li_fp1] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_fp1_di][admsProbeID_V_fp1_di] = 1.0;
probeVars[admsProbeID_V_s_di] = (*solVectorPtr)[li_s] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_s_di][admsProbeID_V_s_di] = 1.0;
probeVars[admsProbeID_V_gi_di] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_di];
d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di] = 1.0;
probeVars[admsProbeID_V_drc_fp4] = (*solVectorPtr)[li_drc] - (*solVectorPtr)[li_fp4];
d_probeVars[admsProbeID_V_drc_fp4][admsProbeID_V_drc_fp4] = 1.0;
probeVars[admsProbeID_V_fp4_s] = (*solVectorPtr)[li_fp4] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_fp4_s][admsProbeID_V_fp4_s] = 1.0;
probeVars[admsProbeID_V_fp4_d] = (*solVectorPtr)[li_fp4] - (*solVectorPtr)[li_d];
d_probeVars[admsProbeID_V_fp4_d][admsProbeID_V_fp4_d] = 1.0;
probeVars[admsProbeID_V_tr_GND] = ((collapseNode_tr)?(0):((*solVectorPtr)[li_tr]));
d_probeVars[admsProbeID_V_tr_GND][admsProbeID_V_tr_GND] = 1.0;
probeVars[admsProbeID_V_tr1_tr] = (collapseNode_tr1)?(0):((*solVectorPtr)[li_tr1]) - ((collapseNode_tr)?(0):((*solVectorPtr)[li_tr]));
d_probeVars[admsProbeID_V_tr1_tr][admsProbeID_V_tr1_tr] = 1.0;
probeVars[admsProbeID_V_d_g] = (*solVectorPtr)[li_d] - (*solVectorPtr)[li_g];
d_probeVars[admsProbeID_V_d_g][admsProbeID_V_d_g] = 1.0;
probeVars[admsProbeID_V_si_src] = (*solVectorPtr)[li_si] - (*solVectorPtr)[li_src];
d_probeVars[admsProbeID_V_si_src][admsProbeID_V_si_src] = 1.0;
probeVars[admsProbeID_V_src_s] = (*solVectorPtr)[li_src] - (*solVectorPtr)[li_s];
d_probeVars[admsProbeID_V_src_s][admsProbeID_V_src_s] = 1.0;
probeVars[admsProbeID_V_src_d] = (*solVectorPtr)[li_src] - (*solVectorPtr)[li_d];
d_probeVars[admsProbeID_V_src_d][admsProbeID_V_src_d] = 1.0;
probeVars[admsProbeID_V_gi_si] = (*solVectorPtr)[li_gi] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si] = 1.0;
probeVars[admsProbeID_V_di_si] = (*solVectorPtr)[li_di] - (*solVectorPtr)[li_si];
d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si] = 1.0;
probeVars[admsProbeID_Temp_dt_GND] = ((collapseNode_dt)?(0):((*solVectorPtr)[li_dt]));
d_probeVars[admsProbeID_Temp_dt_GND][admsProbeID_Temp_dt_GND] = 1.0;
// -- code converted from analog/code block
gmin = getDeviceOptions().gmin;
tnomk = ((model_.tnom)+273.15);
tambk = admsTemperature;

d_tsh_dTemp_dt_GND = d_probeVars[admsProbeID_Temp_dt_GND][admsProbeID_Temp_dt_GND];
tsh = (probeVars[admsProbeID_Temp_dt_GND]);

d_tdut_dTemp_dt_GND = d_tsh_dTemp_dt_GND;
tdut = ((tambk+dtemp)+tsh);
if ((tdut<((-270.0)+273.15)))
{

d_tdut_dTemp_dt_GND =  0.0;
tdut = ((-270.0)+273.15);
}
else
{
if ((tdut>(1500+273.15)))
{

d_tdut_dTemp_dt_GND =  0.0;
tdut = (1500+273.15);
}
}

d_rsi_dTemp_dt_GND =  0.0;
rsi = 0;

d_rdi_dTemp_dt_GND =  0.0;
rdi = 0;
if ((rcs_w>=(model_.minr)))
{

d_rsi_dTemp_dt_GND = rcs_w*((model_.rct1)*d_tdut_dTemp_dt_GND+(((model_.rct2)*(tdut-tnomk))*d_tdut_dTemp_dt_GND+(model_.rct2)*d_tdut_dTemp_dt_GND*(tdut-tnomk)));
rsi = (rcs_w*((1.0+((model_.rct1)*(tdut-tnomk)))+(((model_.rct2)*(tdut-tnomk))*(tdut-tnomk))));
if ((rsi<(0.1*rcs_w)))
{

d_rsi_dTemp_dt_GND =  0.0;
rsi = (0.1*rcs_w);
}
}
else
{

d_rsi_dTemp_dt_GND =  0.0;
rsi = 0;
}
if ((rcd_w>=(model_.minr)))
{

d_rdi_dTemp_dt_GND = rcd_w*((model_.rct1)*d_tdut_dTemp_dt_GND+(((model_.rct2)*(tdut-tnomk))*d_tdut_dTemp_dt_GND+(model_.rct2)*d_tdut_dTemp_dt_GND*(tdut-tnomk)));
rdi = (rcd_w*((1.0+((model_.rct1)*(tdut-tnomk)))+(((model_.rct2)*(tdut-tnomk))*(tdut-tnomk))));
if ((rdi<(0.1*rcd_w)))
{

d_rdi_dTemp_dt_GND =  0.0;
rdi = (0.1*rcd_w);
}
}
else
{

d_rdi_dTemp_dt_GND =  0.0;
rdi = 0;
}

d_phit_dTemp_dt_GND = (1.38062e-23*d_tdut_dTemp_dt_GND/1.60219e-19);
phit = ((1.38062e-23*tdut)/1.60219e-19);

d_ttrapfac_dTemp_dt_GND = (model_.tempt)*d_tdut_dTemp_dt_GND;
ttrapfac = (1.0+((model_.tempt)*(tdut-tnomk)));

d_vdsi_dV_di_si = (model_.type)*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si];
vdsi = ((model_.type)*(probeVars[admsProbeID_V_di_si]));

d_vgsi_dV_gi_si = (model_.type)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si];
vgsi = ((model_.type)*(probeVars[admsProbeID_V_gi_si]));
if ((((model_.type)*(probeVars[admsProbeID_V_src_d]))<=((model_.type)*(probeVars[admsProbeID_V_src_s]))))
{

d_vsars_dV_src_d =  0.0;
d_vsars_dV_src_s = (model_.type)*d_probeVars[admsProbeID_V_src_s][admsProbeID_V_src_s];
vsars = ((model_.type)*(probeVars[admsProbeID_V_src_s]));
}
else
{

d_vsars_dV_src_s =  0.0;
d_vsars_dV_src_d = (model_.type)*d_probeVars[admsProbeID_V_src_d][admsProbeID_V_src_d];
vsars = ((model_.type)*(probeVars[admsProbeID_V_src_d]));
}
vigs = ((model_.vtors)+(1.0/(((model_.rsh)*(model_.cgrs))*(model_.mu0))));

d_vdsrs_dV_si_src = (model_.type)*d_probeVars[admsProbeID_V_si_src][admsProbeID_V_si_src];
vdsrs = ((model_.type)*(probeVars[admsProbeID_V_si_src]));

d_vgsrs_dV_src_s = (-d_vsars_dV_src_s);
d_vgsrs_dV_src_d = (-d_vsars_dV_src_d);
vgsrs = (vigs-vsars);
if (((model_.trapselect)!=0))
{
{
double value_fabs_0 = fabs((probeVars[admsProbeID_V_d_g]));
AnalogFunctions::explimEvaluator evaluator_explim_1((((probeVars[admsProbeID_V_d_g])-(model_.vttrap))/(model_.alphat2)));
double  deriv_fabs_0_d0 = ((((probeVars[admsProbeID_V_d_g]))>=0)?(+1.0):(-1.0));

d_vtcollapse0_dV_d_g = ((model_.alphat1)*(deriv_fabs_0_d0*(d_probeVars[admsProbeID_V_d_g][admsProbeID_V_d_g]))+evaluator_explim_1.getDerivs((((probeVars[admsProbeID_V_d_g])-(model_.vttrap))/(model_.alphat2)),(d_probeVars[admsProbeID_V_d_g][admsProbeID_V_d_g]/(model_.alphat2))));
vtcollapse0 = (((model_.alphat1)*value_fabs_0)+evaluator_explim_1.getValues((((probeVars[admsProbeID_V_d_g])-(model_.vttrap))/(model_.alphat2))));
}
// I(tr1,GND) <+ ((-vtcollapse0))
staticContributions[admsNodeID_tr1] += (-vtcollapse0);
d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_g] += (-d_vtcollapse0_dV_d_g);
// I(tr1,tr) <+ (ddt((ctrap*V(tr1,tr))))
dynamicContributions[admsNodeID_tr1] += (((model_.ctrap)*(probeVars[admsProbeID_V_tr1_tr])));
d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_tr1_tr] += ((model_.ctrap)*d_probeVars[admsProbeID_V_tr1_tr][admsProbeID_V_tr1_tr]);
dynamicContributions[admsNodeID_tr] -= (((model_.ctrap)*(probeVars[admsProbeID_V_tr1_tr])));
d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr1_tr] -= ((model_.ctrap)*d_probeVars[admsProbeID_V_tr1_tr][admsProbeID_V_tr1_tr]);
// I(tr,GND) <+ (ddt((taut*V(tr,GND))))
dynamicContributions[admsNodeID_tr] += (((model_.taut)*(probeVars[admsProbeID_V_tr_GND])));
d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr_GND] += ((model_.taut)*d_probeVars[admsProbeID_V_tr_GND][admsProbeID_V_tr_GND]);
// I(tr,GND) <+ (V(tr,GND))
staticContributions[admsNodeID_tr] += (probeVars[admsProbeID_V_tr_GND]);
d_staticContributions[admsNodeID_tr][admsProbeID_V_tr_GND] += d_probeVars[admsProbeID_V_tr_GND][admsProbeID_V_tr_GND];

d_vtcollapse_dV_tr_GND = d_probeVars[admsProbeID_V_tr_GND][admsProbeID_V_tr_GND];
vtcollapse = (probeVars[admsProbeID_V_tr_GND]);

d_drsht_dTemp_dt_GND = vtcollapse*d_ttrapfac_dTemp_dt_GND;
d_drsht_dV_tr_GND = d_vtcollapse_dV_tr_GND*ttrapfac;
drsht = (1.0+(vtcollapse*ttrapfac));
}
else
{

d_vtcollapse0_dV_d_g =  0.0;
vtcollapse0 = 0;

d_vtcollapse_dV_tr_GND =  0.0;
vtcollapse = 0;
// V(tr1,GND) <+ (0)
// do nothing at all
// V(tr,GND) <+ (0)
// do nothing at all

d_drsht_dV_tr_GND = d_drsht_dTemp_dt_GND =  0.0;
drsht = 1.0;
}
if ((((model_.type)*(probeVars[admsProbeID_V_fp4_d]))<=((model_.type)*(probeVars[admsProbeID_V_fp4_s]))))
{

d_vdars_dV_fp4_d =  0.0;
d_vdars_dV_fp4_s = (model_.type)*d_probeVars[admsProbeID_V_fp4_s][admsProbeID_V_fp4_s];
vdars = ((model_.type)*(probeVars[admsProbeID_V_fp4_s]));
}
else
{

d_vdars_dV_fp4_s =  0.0;
d_vdars_dV_fp4_d = (model_.type)*d_probeVars[admsProbeID_V_fp4_d][admsProbeID_V_fp4_d];
vdars = ((model_.type)*(probeVars[admsProbeID_V_fp4_d]));
}

d_vigd_dTemp_dt_GND = (-d_drsht_dTemp_dt_GND*(model_.rsh)*(model_.cgrd)*(model_.mu0)/(((drsht*(model_.rsh))*(model_.cgrd))*(model_.mu0))/(((drsht*(model_.rsh))*(model_.cgrd))*(model_.mu0)));
d_vigd_dV_tr_GND = (-d_drsht_dV_tr_GND*(model_.rsh)*(model_.cgrd)*(model_.mu0)/(((drsht*(model_.rsh))*(model_.cgrd))*(model_.mu0))/(((drsht*(model_.rsh))*(model_.cgrd))*(model_.mu0)));
vigd = ((model_.vtord)+(1.0/(((drsht*(model_.rsh))*(model_.cgrd))*(model_.mu0))));

d_vdsrd_dV_drc_fp4 = (model_.type)*d_probeVars[admsProbeID_V_drc_fp4][admsProbeID_V_drc_fp4];
vdsrd = ((model_.type)*(probeVars[admsProbeID_V_drc_fp4]));

d_vgsrd_dV_fp4_s = (-d_vdars_dV_fp4_s);
d_vgsrd_dV_fp4_d = (-d_vdars_dV_fp4_d);
d_vgsrd_dTemp_dt_GND = d_vigd_dTemp_dt_GND;
d_vgsrd_dV_tr_GND = d_vigd_dV_tr_GND;
vgsrd = (vigd-vdars);
if (((model_.flagfp1)==1))
{

d_vgsfp1_dV_s_di =  0.0;
d_vgsfp1_dV_gi_di = (model_.type)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di];
vgsfp1 = ((model_.type)*(probeVars[admsProbeID_V_gi_di]));

d_vcfp1_dV_gi_di =  0.0;
d_vcfp1_dV_s_di = (model_.type)*d_probeVars[admsProbeID_V_s_di][admsProbeID_V_s_di];
vcfp1 = ((model_.type)*(probeVars[admsProbeID_V_s_di]));
}
else
{

d_vgsfp1_dV_gi_di =  0.0;
d_vgsfp1_dV_s_di = (model_.type)*d_probeVars[admsProbeID_V_s_di][admsProbeID_V_s_di];
vgsfp1 = ((model_.type)*(probeVars[admsProbeID_V_s_di]));

d_vcfp1_dV_s_di =  0.0;
d_vcfp1_dV_gi_di = (model_.type)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di];
vcfp1 = ((model_.type)*(probeVars[admsProbeID_V_gi_di]));
}

d_vdsfp1_dV_fp1_di = (model_.type)*d_probeVars[admsProbeID_V_fp1_di][admsProbeID_V_fp1_di];
vdsfp1 = ((model_.type)*(probeVars[admsProbeID_V_fp1_di]));

d_vbfp1_dV_b_di = (model_.type)*d_probeVars[admsProbeID_V_b_di][admsProbeID_V_b_di];
vbfp1 = ((model_.type)*(probeVars[admsProbeID_V_b_di]));
if (((model_.flagfp2)==1))
{

d_vgsfp2_dV_s_fp1 =  0.0;
d_vgsfp2_dV_gi_fp1 = (model_.type)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1];
vgsfp2 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp1]));

d_vcfp2_dV_gi_fp1 =  0.0;
d_vcfp2_dV_s_fp1 = (model_.type)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1];
vcfp2 = ((model_.type)*(probeVars[admsProbeID_V_s_fp1]));
}
else
{

d_vgsfp2_dV_gi_fp1 =  0.0;
d_vgsfp2_dV_s_fp1 = (model_.type)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1];
vgsfp2 = ((model_.type)*(probeVars[admsProbeID_V_s_fp1]));

d_vcfp2_dV_s_fp1 =  0.0;
d_vcfp2_dV_gi_fp1 = (model_.type)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1];
vcfp2 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp1]));
}

d_vdsfp2_dV_fp2_fp1 = (model_.type)*d_probeVars[admsProbeID_V_fp2_fp1][admsProbeID_V_fp2_fp1];
vdsfp2 = ((model_.type)*(probeVars[admsProbeID_V_fp2_fp1]));

d_vbfp2_dV_b_fp1 = (model_.type)*d_probeVars[admsProbeID_V_b_fp1][admsProbeID_V_b_fp1];
vbfp2 = ((model_.type)*(probeVars[admsProbeID_V_b_fp1]));
if (((model_.flagfp3)==1))
{

d_vgsfp3_dV_s_fp2 =  0.0;
d_vgsfp3_dV_gi_fp2 = (model_.type)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2];
vgsfp3 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp2]));

d_vcfp3_dV_gi_fp2 =  0.0;
d_vcfp3_dV_s_fp2 = (model_.type)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2];
vcfp3 = ((model_.type)*(probeVars[admsProbeID_V_s_fp2]));
}
else
{

d_vgsfp3_dV_gi_fp2 =  0.0;
d_vgsfp3_dV_s_fp2 = (model_.type)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2];
vgsfp3 = ((model_.type)*(probeVars[admsProbeID_V_s_fp2]));

d_vcfp3_dV_s_fp2 =  0.0;
d_vcfp3_dV_gi_fp2 = (model_.type)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2];
vcfp3 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp2]));
}

d_vdsfp3_dV_fp3_fp2 = (model_.type)*d_probeVars[admsProbeID_V_fp3_fp2][admsProbeID_V_fp3_fp2];
vdsfp3 = ((model_.type)*(probeVars[admsProbeID_V_fp3_fp2]));

d_vbfp3_dV_b_fp2 = (model_.type)*d_probeVars[admsProbeID_V_b_fp2][admsProbeID_V_b_fp2];
vbfp3 = ((model_.type)*(probeVars[admsProbeID_V_b_fp2]));
if (((model_.flagfp4)==1))
{

d_vgsfp4_dV_s_fp3 =  0.0;
d_vgsfp4_dV_gi_fp3 = (model_.type)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3];
vgsfp4 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp3]));

d_vcfp4_dV_gi_fp3 =  0.0;
d_vcfp4_dV_s_fp3 = (model_.type)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3];
vcfp4 = ((model_.type)*(probeVars[admsProbeID_V_s_fp3]));
}
else
{

d_vgsfp4_dV_gi_fp3 =  0.0;
d_vgsfp4_dV_s_fp3 = (model_.type)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3];
vgsfp4 = ((model_.type)*(probeVars[admsProbeID_V_s_fp3]));

d_vcfp4_dV_s_fp3 =  0.0;
d_vcfp4_dV_gi_fp3 = (model_.type)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3];
vcfp4 = ((model_.type)*(probeVars[admsProbeID_V_gi_fp3]));
}

d_vdsfp4_dV_fp4_fp3 = (model_.type)*d_probeVars[admsProbeID_V_fp4_fp3][admsProbeID_V_fp4_fp3];
vdsfp4 = ((model_.type)*(probeVars[admsProbeID_V_fp4_fp3]));

d_vbfp4_dV_b_fp3 = (model_.type)*d_probeVars[admsProbeID_V_b_fp3][admsProbeID_V_b_fp3];
vbfp4 = ((model_.type)*(probeVars[admsProbeID_V_b_fp3]));

d_idsfp4_dV_s_fp3 = d_idsfp4_dV_gi_fp3 = d_idsfp4_dV_fp4_fp3 = d_idsfp4_dV_b_fp3 = d_idsfp4_dTemp_dt_GND =  0.0;
idsfp4 = 0;

d_qgsfp4_dV_s_fp3 = d_qgsfp4_dV_gi_fp3 = d_qgsfp4_dV_fp4_fp3 = d_qgsfp4_dV_b_fp3 = d_qgsfp4_dTemp_dt_GND =  0.0;
qgsfp4 = 0;

d_qgdfp4_dV_s_fp3 = d_qgdfp4_dV_gi_fp3 = d_qgdfp4_dV_fp4_fp3 = d_qgdfp4_dV_b_fp3 = d_qgdfp4_dTemp_dt_GND =  0.0;
qgdfp4 = 0;

d_qcfp4_dV_s_fp3 = d_qcfp4_dV_gi_fp3 = d_qcfp4_dV_fp4_fp3 = d_qcfp4_dV_b_fp3 = d_qcfp4_dTemp_dt_GND =  0.0;
qcfp4 = 0;

d_qbfp4_dV_s_fp3 = d_qbfp4_dV_gi_fp3 = d_qbfp4_dV_fp4_fp3 = d_qbfp4_dV_b_fp3 = d_qbfp4_dTemp_dt_GND =  0.0;
qbfp4 = 0;

d_qsfp4_dV_s_fp3 = d_qsfp4_dV_gi_fp3 = d_qsfp4_dV_fp4_fp3 = d_qsfp4_dV_b_fp3 = d_qsfp4_dTemp_dt_GND =  0.0;
qsfp4 = 0;

d_vtdiblfp4_dV_s_fp3 = d_vtdiblfp4_dV_gi_fp3 = d_vtdiblfp4_dV_fp4_fp3 = d_vtdiblfp4_dV_b_fp3 = d_vtdiblfp4_dTemp_dt_GND =  0.0;
vtdiblfp4 = 0;

d_vdsatfp4_dV_s_fp3 = d_vdsatfp4_dV_gi_fp3 = d_vdsatfp4_dV_fp4_fp3 = d_vdsatfp4_dV_b_fp3 = d_vdsatfp4_dTemp_dt_GND =  0.0;
vdsatfp4 = 0;
if (((model_.lgfp4)>(model_.minl)))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));

d_idsfp4_dTemp_dt_GND = evaluator_calc_iq_0.getDerivs(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp4_dTemp_dt_GND,d_qgsfp4_dTemp_dt_GND,d_qgdfp4_dTemp_dt_GND,d_qcfp4_dTemp_dt_GND,d_qbfp4_dTemp_dt_GND,d_qsfp4_dTemp_dt_GND,d_vtdiblfp4_dTemp_dt_GND,d_vdsatfp4_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp4_dV_b_fp3 = evaluator_calc_iq_0.getDerivs(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp4_dV_b_fp3,d_qgsfp4_dV_b_fp3,d_qgdfp4_dV_b_fp3,d_qcfp4_dV_b_fp3,d_qbfp4_dV_b_fp3,d_qsfp4_dV_b_fp3,d_vtdiblfp4_dV_b_fp3,d_vdsatfp4_dV_b_fp3,0.0,0.0,0.0,0.0,d_vbfp4_dV_b_fp3,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp4_dV_fp4_fp3 = evaluator_calc_iq_0.getDerivs(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp4_dV_fp4_fp3,d_qgsfp4_dV_fp4_fp3,d_qgdfp4_dV_fp4_fp3,d_qcfp4_dV_fp4_fp3,d_qbfp4_dV_fp4_fp3,d_qsfp4_dV_fp4_fp3,d_vtdiblfp4_dV_fp4_fp3,d_vdsatfp4_dV_fp4_fp3,0.0,d_vdsfp4_dV_fp4_fp3,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp4_dV_gi_fp3 = evaluator_calc_iq_0.getDerivs(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp4_dV_gi_fp3,d_qgsfp4_dV_gi_fp3,d_qgdfp4_dV_gi_fp3,d_qcfp4_dV_gi_fp3,d_qbfp4_dV_gi_fp3,d_qsfp4_dV_gi_fp3,d_vtdiblfp4_dV_gi_fp3,d_vdsatfp4_dV_gi_fp3,d_vgsfp4_dV_gi_fp3,0.0,0.0,d_vcfp4_dV_gi_fp3,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp4_dV_s_fp3 = evaluator_calc_iq_0.getDerivs(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp4_dV_s_fp3,d_qgsfp4_dV_s_fp3,d_qgdfp4_dV_s_fp3,d_qcfp4_dV_s_fp3,d_qbfp4_dV_s_fp3,d_qsfp4_dV_s_fp3,d_vtdiblfp4_dV_s_fp3,d_vdsatfp4_dV_s_fp3,d_vgsfp4_dV_s_fp3,0.0,0.0,d_vcfp4_dV_s_fp3,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
idsfp4 = evaluator_calc_iq_0.getValues(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,(model_.flagfp4s),tdut,tnomk,phit,w,(model_.lgfp4),(model_.cgfp4),(model_.cfp4s),(model_.ccfp4),(model_.cbfp4),(model_.vtofp4),(model_.sfp4),(model_.delta1fp4),0.0,(model_.ndfp4),(model_.alphafp4),(model_.vx0fp4),(model_.mu0fp4),(model_.betafp4),(model_.mthetafp4),(model_.vthetafp4),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
}
// I(fp4,fp3) <+ ((idsfp4+(gmin*V(fp4,fp3))))
staticContributions[admsNodeID_fp4] += (idsfp4+(gmin*(probeVars[admsProbeID_V_fp4_fp3])));
d_staticContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND] += d_idsfp4_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp3] += d_idsfp4_dV_b_fp3;
d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] += (d_idsfp4_dV_fp4_fp3+gmin*d_probeVars[admsProbeID_V_fp4_fp3][admsProbeID_V_fp4_fp3]);
d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] += d_idsfp4_dV_gi_fp3;
d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] += d_idsfp4_dV_s_fp3;
staticContributions[admsNodeID_fp3] -= (idsfp4+(gmin*(probeVars[admsProbeID_V_fp4_fp3])));
d_staticContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= d_idsfp4_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] -= d_idsfp4_dV_b_fp3;
d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -= (d_idsfp4_dV_fp4_fp3+gmin*d_probeVars[admsProbeID_V_fp4_fp3][admsProbeID_V_fp4_fp3]);
d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -= d_idsfp4_dV_gi_fp3;
d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -= d_idsfp4_dV_s_fp3;
}
else
{
// V(fp4,fp3) <+ (0)
// do nothing at all
}
if (((model_.flagfp4)==1))
{
// I(gi,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(gi,fp3)))))
dynamicContributions[admsNodeID_gi] += ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgsfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3] += ((d_qgsfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] += ((d_qgsfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] += ((d_qgsfp4_dV_gi_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3] += ((d_qgsfp4_dV_s_fp3)+(0.0));
dynamicContributions[admsNodeID_fp3] -= ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= ((d_qgsfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] -= ((d_qgsfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -= ((d_qgsfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -= ((d_qgsfp4_dV_gi_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3]));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -= ((d_qgsfp4_dV_s_fp3)+(0.0));
// I(gi,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(gi,fp4)))))
dynamicContributions[admsNodeID_gi] += ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp4]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp4] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp4][admsProbeID_V_gi_fp4]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgdfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3] += ((d_qgdfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] += ((d_qgdfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] += ((d_qgdfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3] += ((d_qgdfp4_dV_s_fp3)+(0.0));
dynamicContributions[admsNodeID_fp4] -= ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp4]))));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp4] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp4][admsProbeID_V_gi_fp4]));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND] -= ((d_qgdfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp3] -= ((d_qgdfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -= ((d_qgdfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] -= ((d_qgdfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] -= ((d_qgdfp4_dV_s_fp3)+(0.0));
// I(s,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(s,fp3)))))
dynamicContributions[admsNodeID_s] += ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qcfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3] += ((d_qcfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3] += ((d_qcfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3] += ((d_qcfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3] += ((d_qcfp4_dV_s_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3]));
dynamicContributions[admsNodeID_fp3] -= ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= ((d_qcfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] -= ((d_qcfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -= ((d_qcfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -= ((d_qcfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -= ((d_qcfp4_dV_s_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3]));
// I(s,fp4) <+ (0)
staticContributions[admsNodeID_s] += 0;
staticContributions[admsNodeID_fp4] -= 0;
// I(gi,si) <+ ((ddt(qsfp4)+ddt((minc*V(gi,si)))))
dynamicContributions[admsNodeID_gi] += ((qsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qsfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3] += ((d_qsfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] += ((d_qsfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] += ((d_qsfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3] += ((d_qsfp4_dV_s_fp3)+(0.0));
dynamicContributions[admsNodeID_si] -= ((qsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] -= ((d_qsfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp3] -= ((d_qsfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_fp3] -= ((d_qsfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp3] -= ((d_qsfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp3] -= ((d_qsfp4_dV_s_fp3)+(0.0));
}
else
{
// I(s,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(s,fp3)))))
dynamicContributions[admsNodeID_s] += ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgsfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3] += ((d_qgsfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3] += ((d_qgsfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3] += ((d_qgsfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3] += ((d_qgsfp4_dV_s_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3]));
dynamicContributions[admsNodeID_fp3] -= ((qgsfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= ((d_qgsfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] -= ((d_qgsfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -= ((d_qgsfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -= ((d_qgsfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -= ((d_qgsfp4_dV_s_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3]));
// I(s,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(s,fp4)))))
dynamicContributions[admsNodeID_s] += ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp4]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp4] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp4][admsProbeID_V_s_fp4]));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgdfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3] += ((d_qgdfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3] += ((d_qgdfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3] += ((d_qgdfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3] += ((d_qgdfp4_dV_s_fp3)+(0.0));
dynamicContributions[admsNodeID_fp4] -= ((qgdfp4)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp4]))));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp4] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp4][admsProbeID_V_s_fp4]));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND] -= ((d_qgdfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp3] -= ((d_qgdfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -= ((d_qgdfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] -= ((d_qgdfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] -= ((d_qgdfp4_dV_s_fp3)+(0.0));
// I(gi,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(gi,fp3)))))
dynamicContributions[admsNodeID_gi] += ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qcfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3] += ((d_qcfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] += ((d_qcfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] += ((d_qcfp4_dV_gi_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3] += ((d_qcfp4_dV_s_fp3)+(0.0));
dynamicContributions[admsNodeID_fp3] -= ((qcfp4)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= ((d_qcfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] -= ((d_qcfp4_dV_b_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -= ((d_qcfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -= ((d_qcfp4_dV_gi_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3]));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -= ((d_qcfp4_dV_s_fp3)+(0.0));
// I(gi,fp4) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_fp4] -= 0;
// I(gi,si) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_si] -= 0;
}
// I(b,fp3) <+ ((ddt(qbfp4)+ddt((minc*V(b,fp3)))))
dynamicContributions[admsNodeID_b] += ((qbfp4)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp3]))));
d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_dt_GND] += ((d_qbfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp3] += ((d_qbfp4_dV_b_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_b_fp3][admsProbeID_V_b_fp3]));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_fp3] += ((d_qbfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp3] += ((d_qbfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp3] += ((d_qbfp4_dV_s_fp3)+(0.0));
dynamicContributions[admsNodeID_fp3] -= ((qbfp4)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp3]))));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= ((d_qbfp4_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] -= ((d_qbfp4_dV_b_fp3)+((model_.minc)*d_probeVars[admsProbeID_V_b_fp3][admsProbeID_V_b_fp3]));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -= ((d_qbfp4_dV_fp4_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -= ((d_qbfp4_dV_gi_fp3)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -= ((d_qbfp4_dV_s_fp3)+(0.0));

d_idsfp3_dV_s_fp2 = d_idsfp3_dV_gi_fp2 = d_idsfp3_dV_fp3_fp2 = d_idsfp3_dV_b_fp2 = d_idsfp3_dTemp_dt_GND =  0.0;
idsfp3 = 0;

d_qgsfp3_dV_s_fp2 = d_qgsfp3_dV_gi_fp2 = d_qgsfp3_dV_fp3_fp2 = d_qgsfp3_dV_b_fp2 = d_qgsfp3_dTemp_dt_GND =  0.0;
qgsfp3 = 0;

d_qgdfp3_dV_s_fp2 = d_qgdfp3_dV_gi_fp2 = d_qgdfp3_dV_fp3_fp2 = d_qgdfp3_dV_b_fp2 = d_qgdfp3_dTemp_dt_GND =  0.0;
qgdfp3 = 0;

d_qcfp3_dV_s_fp2 = d_qcfp3_dV_gi_fp2 = d_qcfp3_dV_fp3_fp2 = d_qcfp3_dV_b_fp2 = d_qcfp3_dTemp_dt_GND =  0.0;
qcfp3 = 0;

d_qbfp3_dV_s_fp2 = d_qbfp3_dV_gi_fp2 = d_qbfp3_dV_fp3_fp2 = d_qbfp3_dV_b_fp2 = d_qbfp3_dTemp_dt_GND =  0.0;
qbfp3 = 0;

d_qsfp3_dV_s_fp2 = d_qsfp3_dV_gi_fp2 = d_qsfp3_dV_fp3_fp2 = d_qsfp3_dV_b_fp2 = d_qsfp3_dTemp_dt_GND =  0.0;
qsfp3 = 0;

d_vtdiblfp3_dV_s_fp2 = d_vtdiblfp3_dV_gi_fp2 = d_vtdiblfp3_dV_fp3_fp2 = d_vtdiblfp3_dV_b_fp2 = d_vtdiblfp3_dTemp_dt_GND =  0.0;
vtdiblfp3 = 0;

d_vdsatfp3_dV_s_fp2 = d_vdsatfp3_dV_gi_fp2 = d_vdsatfp3_dV_fp3_fp2 = d_vdsatfp3_dV_b_fp2 = d_vdsatfp3_dTemp_dt_GND =  0.0;
vdsatfp3 = 0;
if (((model_.lgfp3)>(model_.minl)))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));

d_idsfp3_dTemp_dt_GND = evaluator_calc_iq_0.getDerivs(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp3_dTemp_dt_GND,d_qgsfp3_dTemp_dt_GND,d_qgdfp3_dTemp_dt_GND,d_qcfp3_dTemp_dt_GND,d_qbfp3_dTemp_dt_GND,d_qsfp3_dTemp_dt_GND,d_vtdiblfp3_dTemp_dt_GND,d_vdsatfp3_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp3_dV_b_fp2 = evaluator_calc_iq_0.getDerivs(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp3_dV_b_fp2,d_qgsfp3_dV_b_fp2,d_qgdfp3_dV_b_fp2,d_qcfp3_dV_b_fp2,d_qbfp3_dV_b_fp2,d_qsfp3_dV_b_fp2,d_vtdiblfp3_dV_b_fp2,d_vdsatfp3_dV_b_fp2,0.0,0.0,0.0,0.0,d_vbfp3_dV_b_fp2,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp3_dV_fp3_fp2 = evaluator_calc_iq_0.getDerivs(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp3_dV_fp3_fp2,d_qgsfp3_dV_fp3_fp2,d_qgdfp3_dV_fp3_fp2,d_qcfp3_dV_fp3_fp2,d_qbfp3_dV_fp3_fp2,d_qsfp3_dV_fp3_fp2,d_vtdiblfp3_dV_fp3_fp2,d_vdsatfp3_dV_fp3_fp2,0.0,d_vdsfp3_dV_fp3_fp2,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp3_dV_gi_fp2 = evaluator_calc_iq_0.getDerivs(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp3_dV_gi_fp2,d_qgsfp3_dV_gi_fp2,d_qgdfp3_dV_gi_fp2,d_qcfp3_dV_gi_fp2,d_qbfp3_dV_gi_fp2,d_qsfp3_dV_gi_fp2,d_vtdiblfp3_dV_gi_fp2,d_vdsatfp3_dV_gi_fp2,d_vgsfp3_dV_gi_fp2,0.0,0.0,d_vcfp3_dV_gi_fp2,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp3_dV_s_fp2 = evaluator_calc_iq_0.getDerivs(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp3_dV_s_fp2,d_qgsfp3_dV_s_fp2,d_qgdfp3_dV_s_fp2,d_qcfp3_dV_s_fp2,d_qbfp3_dV_s_fp2,d_qsfp3_dV_s_fp2,d_vtdiblfp3_dV_s_fp2,d_vdsatfp3_dV_s_fp2,d_vgsfp3_dV_s_fp2,0.0,0.0,d_vcfp3_dV_s_fp2,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
idsfp3 = evaluator_calc_iq_0.getValues(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,(model_.flagfp3s),tdut,tnomk,phit,w,(model_.lgfp3),(model_.cgfp3),(model_.cfp3s),(model_.ccfp3),(model_.cbfp3),(model_.vtofp3),(model_.sfp3),(model_.delta1fp3),0.0,(model_.ndfp3),(model_.alphafp3),(model_.vx0fp3),(model_.mu0fp3),(model_.betafp3),(model_.mthetafp3),(model_.vthetafp3),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
}
// I(fp3,fp2) <+ ((idsfp3+(gmin*V(fp3,fp2))))
staticContributions[admsNodeID_fp3] += (idsfp3+(gmin*(probeVars[admsProbeID_V_fp3_fp2])));
d_staticContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] += d_idsfp3_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] += d_idsfp3_dV_b_fp2;
d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] += (d_idsfp3_dV_fp3_fp2+gmin*d_probeVars[admsProbeID_V_fp3_fp2][admsProbeID_V_fp3_fp2]);
d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] += d_idsfp3_dV_gi_fp2;
d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] += d_idsfp3_dV_s_fp2;
staticContributions[admsNodeID_fp2] -= (idsfp3+(gmin*(probeVars[admsProbeID_V_fp3_fp2])));
d_staticContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= d_idsfp3_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] -= d_idsfp3_dV_b_fp2;
d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -= (d_idsfp3_dV_fp3_fp2+gmin*d_probeVars[admsProbeID_V_fp3_fp2][admsProbeID_V_fp3_fp2]);
d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -= d_idsfp3_dV_gi_fp2;
d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -= d_idsfp3_dV_s_fp2;
}
else
{
// V(fp3,fp2) <+ (0)
// do nothing at all
}
if (((model_.flagfp3)==1))
{
// I(gi,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(gi,fp2)))))
dynamicContributions[admsNodeID_gi] += ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgsfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2] += ((d_qgsfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] += ((d_qgsfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] += ((d_qgsfp3_dV_gi_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] += ((d_qgsfp3_dV_s_fp2)+(0.0));
dynamicContributions[admsNodeID_fp2] -= ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= ((d_qgsfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] -= ((d_qgsfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -= ((d_qgsfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -= ((d_qgsfp3_dV_gi_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2]));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -= ((d_qgsfp3_dV_s_fp2)+(0.0));
// I(gi,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(gi,fp3)))))
dynamicContributions[admsNodeID_gi] += ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgdfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2] += ((d_qgdfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] += ((d_qgdfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] += ((d_qgdfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] += ((d_qgdfp3_dV_s_fp2)+(0.0));
dynamicContributions[admsNodeID_fp3] -= ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp3]))));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp3][admsProbeID_V_gi_fp3]));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= ((d_qgdfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] -= ((d_qgdfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -= ((d_qgdfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] -= ((d_qgdfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] -= ((d_qgdfp3_dV_s_fp2)+(0.0));
// I(s,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(s,fp2)))))
dynamicContributions[admsNodeID_s] += ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qcfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2] += ((d_qcfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] += ((d_qcfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] += ((d_qcfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] += ((d_qcfp3_dV_s_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2]));
dynamicContributions[admsNodeID_fp2] -= ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= ((d_qcfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] -= ((d_qcfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -= ((d_qcfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -= ((d_qcfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -= ((d_qcfp3_dV_s_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2]));
// I(s,fp3) <+ (0)
staticContributions[admsNodeID_s] += 0;
staticContributions[admsNodeID_fp3] -= 0;
// I(gi,si) <+ ((ddt(qsfp3)+ddt((minc*V(gi,si)))))
dynamicContributions[admsNodeID_gi] += ((qsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qsfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2] += ((d_qsfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] += ((d_qsfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] += ((d_qsfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] += ((d_qsfp3_dV_s_fp2)+(0.0));
dynamicContributions[admsNodeID_si] -= ((qsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] -= ((d_qsfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp2] -= ((d_qsfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp3_fp2] -= ((d_qsfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp2] -= ((d_qsfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp2] -= ((d_qsfp3_dV_s_fp2)+(0.0));
}
else
{
// I(s,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(s,fp2)))))
dynamicContributions[admsNodeID_s] += ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgsfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2] += ((d_qgsfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] += ((d_qgsfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] += ((d_qgsfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] += ((d_qgsfp3_dV_s_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2]));
dynamicContributions[admsNodeID_fp2] -= ((qgsfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= ((d_qgsfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] -= ((d_qgsfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -= ((d_qgsfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -= ((d_qgsfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -= ((d_qgsfp3_dV_s_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2]));
// I(s,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(s,fp3)))))
dynamicContributions[admsNodeID_s] += ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3]));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgdfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2] += ((d_qgdfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] += ((d_qgdfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] += ((d_qgdfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] += ((d_qgdfp3_dV_s_fp2)+(0.0));
dynamicContributions[admsNodeID_fp3] -= ((qgdfp3)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp3]))));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp3][admsProbeID_V_s_fp3]));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] -= ((d_qgdfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] -= ((d_qgdfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -= ((d_qgdfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] -= ((d_qgdfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] -= ((d_qgdfp3_dV_s_fp2)+(0.0));
// I(gi,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(gi,fp2)))))
dynamicContributions[admsNodeID_gi] += ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qcfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2] += ((d_qcfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] += ((d_qcfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] += ((d_qcfp3_dV_gi_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] += ((d_qcfp3_dV_s_fp2)+(0.0));
dynamicContributions[admsNodeID_fp2] -= ((qcfp3)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= ((d_qcfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] -= ((d_qcfp3_dV_b_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -= ((d_qcfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -= ((d_qcfp3_dV_gi_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2]));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -= ((d_qcfp3_dV_s_fp2)+(0.0));
// I(gi,fp3) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_fp3] -= 0;
// I(gi,si) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_si] -= 0;
}
// I(b,fp2) <+ ((ddt(qbfp3)+ddt((minc*V(b,fp2)))))
dynamicContributions[admsNodeID_b] += ((qbfp3)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp2]))));
d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_dt_GND] += ((d_qbfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp2] += ((d_qbfp3_dV_b_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_b_fp2][admsProbeID_V_b_fp2]));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp3_fp2] += ((d_qbfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp2] += ((d_qbfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp2] += ((d_qbfp3_dV_s_fp2)+(0.0));
dynamicContributions[admsNodeID_fp2] -= ((qbfp3)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp2]))));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= ((d_qbfp3_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] -= ((d_qbfp3_dV_b_fp2)+((model_.minc)*d_probeVars[admsProbeID_V_b_fp2][admsProbeID_V_b_fp2]));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -= ((d_qbfp3_dV_fp3_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -= ((d_qbfp3_dV_gi_fp2)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -= ((d_qbfp3_dV_s_fp2)+(0.0));

d_idsfp2_dV_s_fp1 = d_idsfp2_dV_gi_fp1 = d_idsfp2_dV_fp2_fp1 = d_idsfp2_dV_b_fp1 = d_idsfp2_dTemp_dt_GND =  0.0;
idsfp2 = 0;

d_qgsfp2_dV_s_fp1 = d_qgsfp2_dV_gi_fp1 = d_qgsfp2_dV_fp2_fp1 = d_qgsfp2_dV_b_fp1 = d_qgsfp2_dTemp_dt_GND =  0.0;
qgsfp2 = 0;

d_qgdfp2_dV_s_fp1 = d_qgdfp2_dV_gi_fp1 = d_qgdfp2_dV_fp2_fp1 = d_qgdfp2_dV_b_fp1 = d_qgdfp2_dTemp_dt_GND =  0.0;
qgdfp2 = 0;

d_qcfp2_dV_s_fp1 = d_qcfp2_dV_gi_fp1 = d_qcfp2_dV_fp2_fp1 = d_qcfp2_dV_b_fp1 = d_qcfp2_dTemp_dt_GND =  0.0;
qcfp2 = 0;

d_qbfp2_dV_s_fp1 = d_qbfp2_dV_gi_fp1 = d_qbfp2_dV_fp2_fp1 = d_qbfp2_dV_b_fp1 = d_qbfp2_dTemp_dt_GND =  0.0;
qbfp2 = 0;

d_qsfp2_dV_s_fp1 = d_qsfp2_dV_gi_fp1 = d_qsfp2_dV_fp2_fp1 = d_qsfp2_dV_b_fp1 = d_qsfp2_dTemp_dt_GND =  0.0;
qsfp2 = 0;

d_vtdiblfp2_dV_s_fp1 = d_vtdiblfp2_dV_gi_fp1 = d_vtdiblfp2_dV_fp2_fp1 = d_vtdiblfp2_dV_b_fp1 = d_vtdiblfp2_dTemp_dt_GND =  0.0;
vtdiblfp2 = 0;

d_vdsatfp2_dV_s_fp1 = d_vdsatfp2_dV_gi_fp1 = d_vdsatfp2_dV_fp2_fp1 = d_vdsatfp2_dV_b_fp1 = d_vdsatfp2_dTemp_dt_GND =  0.0;
vdsatfp2 = 0;
if (((model_.lgfp2)>(model_.minl)))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));

d_idsfp2_dTemp_dt_GND = evaluator_calc_iq_0.getDerivs(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp2_dTemp_dt_GND,d_qgsfp2_dTemp_dt_GND,d_qgdfp2_dTemp_dt_GND,d_qcfp2_dTemp_dt_GND,d_qbfp2_dTemp_dt_GND,d_qsfp2_dTemp_dt_GND,d_vtdiblfp2_dTemp_dt_GND,d_vdsatfp2_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp2_dV_b_fp1 = evaluator_calc_iq_0.getDerivs(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp2_dV_b_fp1,d_qgsfp2_dV_b_fp1,d_qgdfp2_dV_b_fp1,d_qcfp2_dV_b_fp1,d_qbfp2_dV_b_fp1,d_qsfp2_dV_b_fp1,d_vtdiblfp2_dV_b_fp1,d_vdsatfp2_dV_b_fp1,0.0,0.0,0.0,0.0,d_vbfp2_dV_b_fp1,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp2_dV_fp2_fp1 = evaluator_calc_iq_0.getDerivs(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp2_dV_fp2_fp1,d_qgsfp2_dV_fp2_fp1,d_qgdfp2_dV_fp2_fp1,d_qcfp2_dV_fp2_fp1,d_qbfp2_dV_fp2_fp1,d_qsfp2_dV_fp2_fp1,d_vtdiblfp2_dV_fp2_fp1,d_vdsatfp2_dV_fp2_fp1,0.0,d_vdsfp2_dV_fp2_fp1,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp2_dV_gi_fp1 = evaluator_calc_iq_0.getDerivs(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp2_dV_gi_fp1,d_qgsfp2_dV_gi_fp1,d_qgdfp2_dV_gi_fp1,d_qcfp2_dV_gi_fp1,d_qbfp2_dV_gi_fp1,d_qsfp2_dV_gi_fp1,d_vtdiblfp2_dV_gi_fp1,d_vdsatfp2_dV_gi_fp1,d_vgsfp2_dV_gi_fp1,0.0,0.0,d_vcfp2_dV_gi_fp1,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp2_dV_s_fp1 = evaluator_calc_iq_0.getDerivs(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp2_dV_s_fp1,d_qgsfp2_dV_s_fp1,d_qgdfp2_dV_s_fp1,d_qcfp2_dV_s_fp1,d_qbfp2_dV_s_fp1,d_qsfp2_dV_s_fp1,d_vtdiblfp2_dV_s_fp1,d_vdsatfp2_dV_s_fp1,d_vgsfp2_dV_s_fp1,0.0,0.0,d_vcfp2_dV_s_fp1,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
idsfp2 = evaluator_calc_iq_0.getValues(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,(model_.flagfp2s),tdut,tnomk,phit,w,(model_.lgfp2),(model_.cgfp2),(model_.cfp2s),(model_.ccfp2),(model_.cbfp2),(model_.vtofp2),(model_.sfp2),(model_.delta1fp2),0.0,(model_.ndfp2),(model_.alphafp2),(model_.vx0fp2),(model_.mu0fp2),(model_.betafp2),(model_.mthetafp2),(model_.vthetafp2),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
}
// I(fp2,fp1) <+ ((idsfp2+(gmin*V(fp2,fp1))))
staticContributions[admsNodeID_fp2] += (idsfp2+(gmin*(probeVars[admsProbeID_V_fp2_fp1])));
d_staticContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] += d_idsfp2_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] += d_idsfp2_dV_b_fp1;
d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] += (d_idsfp2_dV_fp2_fp1+gmin*d_probeVars[admsProbeID_V_fp2_fp1][admsProbeID_V_fp2_fp1]);
d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] += d_idsfp2_dV_gi_fp1;
d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] += d_idsfp2_dV_s_fp1;
staticContributions[admsNodeID_fp1] -= (idsfp2+(gmin*(probeVars[admsProbeID_V_fp2_fp1])));
d_staticContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= d_idsfp2_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] -= d_idsfp2_dV_b_fp1;
d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -= (d_idsfp2_dV_fp2_fp1+gmin*d_probeVars[admsProbeID_V_fp2_fp1][admsProbeID_V_fp2_fp1]);
d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -= d_idsfp2_dV_gi_fp1;
d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -= d_idsfp2_dV_s_fp1;
}
else
{
// V(fp2,fp1) <+ (0)
// do nothing at all
}
if (((model_.flagfp2)==1))
{
// I(gi,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(gi,fp1)))))
dynamicContributions[admsNodeID_gi] += ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgsfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1] += ((d_qgsfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] += ((d_qgsfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] += ((d_qgsfp2_dV_gi_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] += ((d_qgsfp2_dV_s_fp1)+(0.0));
dynamicContributions[admsNodeID_fp1] -= ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= ((d_qgsfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] -= ((d_qgsfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -= ((d_qgsfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -= ((d_qgsfp2_dV_gi_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1]));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -= ((d_qgsfp2_dV_s_fp1)+(0.0));
// I(gi,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(gi,fp2)))))
dynamicContributions[admsNodeID_gi] += ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgdfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1] += ((d_qgdfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] += ((d_qgdfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] += ((d_qgdfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] += ((d_qgdfp2_dV_s_fp1)+(0.0));
dynamicContributions[admsNodeID_fp2] -= ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp2]))));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp2][admsProbeID_V_gi_fp2]));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= ((d_qgdfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] -= ((d_qgdfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -= ((d_qgdfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] -= ((d_qgdfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] -= ((d_qgdfp2_dV_s_fp1)+(0.0));
// I(s,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(s,fp1)))))
dynamicContributions[admsNodeID_s] += ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qcfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1] += ((d_qcfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] += ((d_qcfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] += ((d_qcfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] += ((d_qcfp2_dV_s_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1]));
dynamicContributions[admsNodeID_fp1] -= ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= ((d_qcfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] -= ((d_qcfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -= ((d_qcfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -= ((d_qcfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -= ((d_qcfp2_dV_s_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1]));
// I(s,fp2) <+ (0)
staticContributions[admsNodeID_s] += 0;
staticContributions[admsNodeID_fp2] -= 0;
// I(gi,si) <+ ((ddt(qsfp2)+ddt((minc*V(gi,si)))))
dynamicContributions[admsNodeID_gi] += ((qsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qsfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1] += ((d_qsfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] += ((d_qsfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] += ((d_qsfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] += ((d_qsfp2_dV_s_fp1)+(0.0));
dynamicContributions[admsNodeID_si] -= ((qsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] -= ((d_qsfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp1] -= ((d_qsfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp2_fp1] -= ((d_qsfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp1] -= ((d_qsfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp1] -= ((d_qsfp2_dV_s_fp1)+(0.0));
}
else
{
// I(s,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(s,fp1)))))
dynamicContributions[admsNodeID_s] += ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgsfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1] += ((d_qgsfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] += ((d_qgsfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] += ((d_qgsfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] += ((d_qgsfp2_dV_s_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1]));
dynamicContributions[admsNodeID_fp1] -= ((qgsfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= ((d_qgsfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] -= ((d_qgsfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -= ((d_qgsfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -= ((d_qgsfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -= ((d_qgsfp2_dV_s_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1]));
// I(s,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(s,fp2)))))
dynamicContributions[admsNodeID_s] += ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2]));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgdfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1] += ((d_qgdfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] += ((d_qgdfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] += ((d_qgdfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] += ((d_qgdfp2_dV_s_fp1)+(0.0));
dynamicContributions[admsNodeID_fp2] -= ((qgdfp2)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp2]))));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp2][admsProbeID_V_s_fp2]));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] -= ((d_qgdfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] -= ((d_qgdfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -= ((d_qgdfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] -= ((d_qgdfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] -= ((d_qgdfp2_dV_s_fp1)+(0.0));
// I(gi,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(gi,fp1)))))
dynamicContributions[admsNodeID_gi] += ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qcfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1] += ((d_qcfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] += ((d_qcfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] += ((d_qcfp2_dV_gi_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] += ((d_qcfp2_dV_s_fp1)+(0.0));
dynamicContributions[admsNodeID_fp1] -= ((qcfp2)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= ((d_qcfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] -= ((d_qcfp2_dV_b_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -= ((d_qcfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -= ((d_qcfp2_dV_gi_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1]));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -= ((d_qcfp2_dV_s_fp1)+(0.0));
// I(gi,fp2) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_fp2] -= 0;
// I(gi,si) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_si] -= 0;
}
// I(b,fp1) <+ ((ddt(qbfp2)+ddt((minc*V(b,fp1)))))
dynamicContributions[admsNodeID_b] += ((qbfp2)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp1]))));
d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_dt_GND] += ((d_qbfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp1] += ((d_qbfp2_dV_b_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_b_fp1][admsProbeID_V_b_fp1]));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp2_fp1] += ((d_qbfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp1] += ((d_qbfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp1] += ((d_qbfp2_dV_s_fp1)+(0.0));
dynamicContributions[admsNodeID_fp1] -= ((qbfp2)+(((model_.minc)*(probeVars[admsProbeID_V_b_fp1]))));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= ((d_qbfp2_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] -= ((d_qbfp2_dV_b_fp1)+((model_.minc)*d_probeVars[admsProbeID_V_b_fp1][admsProbeID_V_b_fp1]));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -= ((d_qbfp2_dV_fp2_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -= ((d_qbfp2_dV_gi_fp1)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -= ((d_qbfp2_dV_s_fp1)+(0.0));

d_idsfp1_dV_s_di = d_idsfp1_dV_gi_di = d_idsfp1_dV_fp1_di = d_idsfp1_dV_b_di = d_idsfp1_dTemp_dt_GND =  0.0;
idsfp1 = 0;

d_qgsfp1_dV_s_di = d_qgsfp1_dV_gi_di = d_qgsfp1_dV_fp1_di = d_qgsfp1_dV_b_di = d_qgsfp1_dTemp_dt_GND =  0.0;
qgsfp1 = 0;

d_qgdfp1_dV_s_di = d_qgdfp1_dV_gi_di = d_qgdfp1_dV_fp1_di = d_qgdfp1_dV_b_di = d_qgdfp1_dTemp_dt_GND =  0.0;
qgdfp1 = 0;

d_qcfp1_dV_s_di = d_qcfp1_dV_gi_di = d_qcfp1_dV_fp1_di = d_qcfp1_dV_b_di = d_qcfp1_dTemp_dt_GND =  0.0;
qcfp1 = 0;

d_qbfp1_dV_s_di = d_qbfp1_dV_gi_di = d_qbfp1_dV_fp1_di = d_qbfp1_dV_b_di = d_qbfp1_dTemp_dt_GND =  0.0;
qbfp1 = 0;

d_qsfp1_dV_s_di = d_qsfp1_dV_gi_di = d_qsfp1_dV_fp1_di = d_qsfp1_dV_b_di = d_qsfp1_dTemp_dt_GND =  0.0;
qsfp1 = 0;

d_vtdiblfp1_dV_s_di = d_vtdiblfp1_dV_gi_di = d_vtdiblfp1_dV_fp1_di = d_vtdiblfp1_dV_b_di = d_vtdiblfp1_dTemp_dt_GND =  0.0;
vtdiblfp1 = 0;

d_vdsatfp1_dV_s_di = d_vdsatfp1_dV_gi_di = d_vdsatfp1_dV_fp1_di = d_vdsatfp1_dV_b_di = d_vdsatfp1_dTemp_dt_GND =  0.0;
vdsatfp1 = 0;
if (((model_.lgfp1)>(model_.minl)))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));

d_idsfp1_dTemp_dt_GND = evaluator_calc_iq_0.getDerivs(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp1_dTemp_dt_GND,d_qgsfp1_dTemp_dt_GND,d_qgdfp1_dTemp_dt_GND,d_qcfp1_dTemp_dt_GND,d_qbfp1_dTemp_dt_GND,d_qsfp1_dTemp_dt_GND,d_vtdiblfp1_dTemp_dt_GND,d_vdsatfp1_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp1_dV_b_di = evaluator_calc_iq_0.getDerivs(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp1_dV_b_di,d_qgsfp1_dV_b_di,d_qgdfp1_dV_b_di,d_qcfp1_dV_b_di,d_qbfp1_dV_b_di,d_qsfp1_dV_b_di,d_vtdiblfp1_dV_b_di,d_vdsatfp1_dV_b_di,0.0,0.0,0.0,0.0,d_vbfp1_dV_b_di,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp1_dV_fp1_di = evaluator_calc_iq_0.getDerivs(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp1_dV_fp1_di,d_qgsfp1_dV_fp1_di,d_qgdfp1_dV_fp1_di,d_qcfp1_dV_fp1_di,d_qbfp1_dV_fp1_di,d_qsfp1_dV_fp1_di,d_vtdiblfp1_dV_fp1_di,d_vdsatfp1_dV_fp1_di,0.0,d_vdsfp1_dV_fp1_di,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp1_dV_gi_di = evaluator_calc_iq_0.getDerivs(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp1_dV_gi_di,d_qgsfp1_dV_gi_di,d_qgdfp1_dV_gi_di,d_qcfp1_dV_gi_di,d_qbfp1_dV_gi_di,d_qsfp1_dV_gi_di,d_vtdiblfp1_dV_gi_di,d_vdsatfp1_dV_gi_di,d_vgsfp1_dV_gi_di,0.0,0.0,d_vcfp1_dV_gi_di,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsfp1_dV_s_di = evaluator_calc_iq_0.getDerivs(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsfp1_dV_s_di,d_qgsfp1_dV_s_di,d_qgdfp1_dV_s_di,d_qcfp1_dV_s_di,d_qbfp1_dV_s_di,d_qsfp1_dV_s_di,d_vtdiblfp1_dV_s_di,d_vdsatfp1_dV_s_di,d_vgsfp1_dV_s_di,0.0,0.0,d_vcfp1_dV_s_di,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
idsfp1 = evaluator_calc_iq_0.getValues(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,(model_.flagfp1s),tdut,tnomk,phit,w,(model_.lgfp1),(model_.cgfp1),(model_.cfp1s),(model_.ccfp1),(model_.cbfp1),(model_.vtofp1),(model_.sfp1),(model_.delta1fp1),0.0,(model_.ndfp1),(model_.alphafp1),(model_.vx0fp1),(model_.mu0fp1),(model_.betafp1),(model_.mthetafp1),(model_.vthetafp1),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
}
// I(fp1,di) <+ ((idsfp1+(gmin*V(fp1,di))))
staticContributions[admsNodeID_fp1] += (idsfp1+(gmin*(probeVars[admsProbeID_V_fp1_di])));
d_staticContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] += d_idsfp1_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_di] += d_idsfp1_dV_b_di;
d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] += (d_idsfp1_dV_fp1_di+gmin*d_probeVars[admsProbeID_V_fp1_di][admsProbeID_V_fp1_di]);
d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_di] += d_idsfp1_dV_gi_di;
d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_di] += d_idsfp1_dV_s_di;
staticContributions[admsNodeID_di] -= (idsfp1+(gmin*(probeVars[admsProbeID_V_fp1_di])));
d_staticContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= d_idsfp1_dTemp_dt_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_b_di] -= d_idsfp1_dV_b_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_fp1_di] -= (d_idsfp1_dV_fp1_di+gmin*d_probeVars[admsProbeID_V_fp1_di][admsProbeID_V_fp1_di]);
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_di] -= d_idsfp1_dV_gi_di;
d_staticContributions[admsNodeID_di][admsProbeID_V_s_di] -= d_idsfp1_dV_s_di;
}
else
{
// V(fp1,di) <+ (0)
// do nothing at all
}
if (((model_.flagfp1)==1))
{
// I(gi,di) <+ ((ddt(qgsfp1)+ddt((minc*V(gi,di)))))
dynamicContributions[admsNodeID_gi] += ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgsfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di] += ((d_qgsfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] += ((d_qgsfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] += ((d_qgsfp1_dV_gi_di)+((model_.minc)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] += ((d_qgsfp1_dV_s_di)+(0.0));
dynamicContributions[admsNodeID_di] -= ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= ((d_qgsfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di] -= ((d_qgsfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] -= ((d_qgsfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -= ((d_qgsfp1_dV_gi_di)+((model_.minc)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di]));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] -= ((d_qgsfp1_dV_s_di)+(0.0));
// I(gi,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(gi,fp1)))))
dynamicContributions[admsNodeID_gi] += ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgdfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di] += ((d_qgdfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] += ((d_qgdfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] += ((d_qgdfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] += ((d_qgdfp1_dV_s_di)+(0.0));
dynamicContributions[admsNodeID_fp1] -= ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_fp1]))));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_fp1][admsProbeID_V_gi_fp1]));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= ((d_qgdfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_di] -= ((d_qgdfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -= ((d_qgdfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_di] -= ((d_qgdfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_di] -= ((d_qgdfp1_dV_s_di)+(0.0));
// I(s,di) <+ ((ddt(qcfp1)+ddt((minc*V(s,di)))))
dynamicContributions[admsNodeID_s] += ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qcfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di] += ((d_qcfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] += ((d_qcfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] += ((d_qcfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] += ((d_qcfp1_dV_s_di)+((model_.minc)*d_probeVars[admsProbeID_V_s_di][admsProbeID_V_s_di]));
dynamicContributions[admsNodeID_di] -= ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= ((d_qcfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di] -= ((d_qcfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] -= ((d_qcfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -= ((d_qcfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] -= ((d_qcfp1_dV_s_di)+((model_.minc)*d_probeVars[admsProbeID_V_s_di][admsProbeID_V_s_di]));
// I(s,fp1) <+ (0)
staticContributions[admsNodeID_s] += 0;
staticContributions[admsNodeID_fp1] -= 0;
// I(gi,si) <+ ((ddt(qsfp1)+ddt((minc*V(gi,si)))))
dynamicContributions[admsNodeID_gi] += ((qsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qsfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di] += ((d_qsfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] += ((d_qsfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] += ((d_qsfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] += ((d_qsfp1_dV_s_di)+(0.0));
dynamicContributions[admsNodeID_si] -= ((qsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] -= ((d_qsfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_di] -= ((d_qsfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp1_di] -= ((d_qsfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_di] -= ((d_qsfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_di] -= ((d_qsfp1_dV_s_di)+(0.0));
}
else
{
// I(s,di) <+ ((ddt(qgsfp1)+ddt((minc*V(s,di)))))
dynamicContributions[admsNodeID_s] += ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgsfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di] += ((d_qgsfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] += ((d_qgsfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] += ((d_qgsfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] += ((d_qgsfp1_dV_s_di)+((model_.minc)*d_probeVars[admsProbeID_V_s_di][admsProbeID_V_s_di]));
dynamicContributions[admsNodeID_di] -= ((qgsfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_di]))));
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= ((d_qgsfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di] -= ((d_qgsfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] -= ((d_qgsfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -= ((d_qgsfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] -= ((d_qgsfp1_dV_s_di)+((model_.minc)*d_probeVars[admsProbeID_V_s_di][admsProbeID_V_s_di]));
// I(s,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(s,fp1)))))
dynamicContributions[admsNodeID_s] += ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1]));
d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] += ((d_qgdfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di] += ((d_qgdfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] += ((d_qgdfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] += ((d_qgdfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] += ((d_qgdfp1_dV_s_di)+(0.0));
dynamicContributions[admsNodeID_fp1] -= ((qgdfp1)+(((model_.minc)*(probeVars[admsProbeID_V_s_fp1]))));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_s_fp1][admsProbeID_V_s_fp1]));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] -= ((d_qgdfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_di] -= ((d_qgdfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -= ((d_qgdfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_di] -= ((d_qgdfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_di] -= ((d_qgdfp1_dV_s_di)+(0.0));
// I(gi,di) <+ ((ddt(qcfp1)+ddt((minc*V(gi,di)))))
dynamicContributions[admsNodeID_gi] += ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qcfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di] += ((d_qcfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] += ((d_qcfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] += ((d_qcfp1_dV_gi_di)+((model_.minc)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] += ((d_qcfp1_dV_s_di)+(0.0));
dynamicContributions[admsNodeID_di] -= ((qcfp1)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= ((d_qcfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di] -= ((d_qcfp1_dV_b_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] -= ((d_qcfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -= ((d_qcfp1_dV_gi_di)+((model_.minc)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di]));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] -= ((d_qcfp1_dV_s_di)+(0.0));
// I(gi,fp1) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_fp1] -= 0;
// I(gi,si) <+ (0)
staticContributions[admsNodeID_gi] += 0;
staticContributions[admsNodeID_si] -= 0;
}
// I(b,di) <+ ((ddt(qbfp1)+ddt((minc*V(b,di)))))
dynamicContributions[admsNodeID_b] += ((qbfp1)+(((model_.minc)*(probeVars[admsProbeID_V_b_di]))));
d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_dt_GND] += ((d_qbfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_di] += ((d_qbfp1_dV_b_di)+((model_.minc)*d_probeVars[admsProbeID_V_b_di][admsProbeID_V_b_di]));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp1_di] += ((d_qbfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_di] += ((d_qbfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_di] += ((d_qbfp1_dV_s_di)+(0.0));
dynamicContributions[admsNodeID_di] -= ((qbfp1)+(((model_.minc)*(probeVars[admsProbeID_V_b_di]))));
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= ((d_qbfp1_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di] -= ((d_qbfp1_dV_b_di)+((model_.minc)*d_probeVars[admsProbeID_V_b_di][admsProbeID_V_b_di]));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] -= ((d_qbfp1_dV_fp1_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -= ((d_qbfp1_dV_gi_di)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] -= ((d_qbfp1_dV_s_di)+(0.0));

d_idsrs_dV_src_d = d_idsrs_dV_src_s = d_idsrs_dV_si_src = d_idsrs_dTemp_dt_GND =  0.0;
idsrs = 0;
if ((((model_.flagres)==0)&&((model_.lgs)>(model_.minl))))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,w,(model_.lgs),(model_.cgrs),0,0,0,(model_.vtors),(model_.srs),(model_.delta1rs),0.0,(model_.ndrs),(model_.alphars),(model_.vx0rs),(model_.mu0rs),(model_.betars),(model_.mthetars),(model_.vthetars),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));

d_idsrs_dTemp_dt_GND = evaluator_calc_iq_0.getDerivs(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,w,(model_.lgs),(model_.cgrs),0,0,0,(model_.vtors),(model_.srs),(model_.delta1rs),0.0,(model_.ndrs),(model_.alphars),(model_.vx0rs),(model_.mu0rs),(model_.betars),(model_.mthetars),(model_.vthetars),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrs_dTemp_dt_GND,d_qgsrs_dTemp_dt_GND,d_qgdrs_dTemp_dt_GND,d_qcrs_dTemp_dt_GND,d_qbrs_dTemp_dt_GND,d_qsrs_dTemp_dt_GND,d_vtdiblrs_dTemp_dt_GND,d_vdsatrs_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsrs_dV_si_src = evaluator_calc_iq_0.getDerivs(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,w,(model_.lgs),(model_.cgrs),0,0,0,(model_.vtors),(model_.srs),(model_.delta1rs),0.0,(model_.ndrs),(model_.alphars),(model_.vx0rs),(model_.mu0rs),(model_.betars),(model_.mthetars),(model_.vthetars),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrs_dV_si_src,d_qgsrs_dV_si_src,d_qgdrs_dV_si_src,d_qcrs_dV_si_src,d_qbrs_dV_si_src,d_qsrs_dV_si_src,d_vtdiblrs_dV_si_src,d_vdsatrs_dV_si_src,0.0,d_vdsrs_dV_si_src,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsrs_dV_src_s = evaluator_calc_iq_0.getDerivs(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,w,(model_.lgs),(model_.cgrs),0,0,0,(model_.vtors),(model_.srs),(model_.delta1rs),0.0,(model_.ndrs),(model_.alphars),(model_.vx0rs),(model_.mu0rs),(model_.betars),(model_.mthetars),(model_.vthetars),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrs_dV_src_s,d_qgsrs_dV_src_s,d_qgdrs_dV_src_s,d_qcrs_dV_src_s,d_qbrs_dV_src_s,d_qsrs_dV_src_s,d_vtdiblrs_dV_src_s,d_vdsatrs_dV_src_s,d_vgsrs_dV_src_s,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsrs_dV_src_d = evaluator_calc_iq_0.getDerivs(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,w,(model_.lgs),(model_.cgrs),0,0,0,(model_.vtors),(model_.srs),(model_.delta1rs),0.0,(model_.ndrs),(model_.alphars),(model_.vx0rs),(model_.mu0rs),(model_.betars),(model_.mthetars),(model_.vthetars),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrs_dV_src_d,d_qgsrs_dV_src_d,d_qgdrs_dV_src_d,d_qcrs_dV_src_d,d_qbrs_dV_src_d,d_qsrs_dV_src_d,d_vtdiblrs_dV_src_d,d_vdsatrs_dV_src_d,d_vgsrs_dV_src_d,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
idsrs = evaluator_calc_iq_0.getValues(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,w,(model_.lgs),(model_.cgrs),0,0,0,(model_.vtors),(model_.srs),(model_.delta1rs),0.0,(model_.ndrs),(model_.alphars),(model_.vx0rs),(model_.mu0rs),(model_.betars),(model_.mthetars),(model_.vthetars),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
}
// I(si,src) <+ ((idsrs+(gmin*V(si,src))))
staticContributions[admsNodeID_si] += (idsrs+(gmin*(probeVars[admsProbeID_V_si_src])));
d_staticContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] += d_idsrs_dTemp_dt_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_si_src] += (d_idsrs_dV_si_src+gmin*d_probeVars[admsProbeID_V_si_src][admsProbeID_V_si_src]);
d_staticContributions[admsNodeID_si][admsProbeID_V_src_s] += d_idsrs_dV_src_s;
d_staticContributions[admsNodeID_si][admsProbeID_V_src_d] += d_idsrs_dV_src_d;
staticContributions[admsNodeID_src] -= (idsrs+(gmin*(probeVars[admsProbeID_V_si_src])));
d_staticContributions[admsNodeID_src][admsProbeID_Temp_dt_GND] -= d_idsrs_dTemp_dt_GND;
d_staticContributions[admsNodeID_src][admsProbeID_V_si_src] -= (d_idsrs_dV_si_src+gmin*d_probeVars[admsProbeID_V_si_src][admsProbeID_V_si_src]);
d_staticContributions[admsNodeID_src][admsProbeID_V_src_s] -= d_idsrs_dV_src_s;
d_staticContributions[admsNodeID_src][admsProbeID_V_src_d] -= d_idsrs_dV_src_d;
}
else
{
// V(src,si) <+ (0)
// do nothing at all
}

d_idsrd_dV_tr_GND = d_idsrd_dTemp_dt_GND = d_idsrd_dV_fp4_d = d_idsrd_dV_fp4_s = d_idsrd_dV_drc_fp4 =  0.0;
idsrd = 0;
if ((((model_.flagres)==0)&&((model_.lgd)>(model_.minl))))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));

d_idsrd_dV_drc_fp4 = evaluator_calc_iq_0.getDerivs(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrd_dV_drc_fp4,d_qgsrd_dV_drc_fp4,d_qgdrd_dV_drc_fp4,d_qcrd_dV_drc_fp4,d_qbrd_dV_drc_fp4,d_qsrd_dV_drc_fp4,d_vtdiblrd_dV_drc_fp4,d_vdsatrd_dV_drc_fp4,0.0,d_vdsrd_dV_drc_fp4,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsrd_dV_fp4_s = evaluator_calc_iq_0.getDerivs(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrd_dV_fp4_s,d_qgsrd_dV_fp4_s,d_qgdrd_dV_fp4_s,d_qcrd_dV_fp4_s,d_qbrd_dV_fp4_s,d_qsrd_dV_fp4_s,d_vtdiblrd_dV_fp4_s,d_vdsatrd_dV_fp4_s,d_vgsrd_dV_fp4_s,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsrd_dV_fp4_d = evaluator_calc_iq_0.getDerivs(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrd_dV_fp4_d,d_qgsrd_dV_fp4_d,d_qgdrd_dV_fp4_d,d_qcrd_dV_fp4_d,d_qbrd_dV_fp4_d,d_qsrd_dV_fp4_d,d_vtdiblrd_dV_fp4_d,d_vdsatrd_dV_fp4_d,d_vgsrd_dV_fp4_d,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsrd_dTemp_dt_GND = evaluator_calc_iq_0.getDerivs(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrd_dTemp_dt_GND,d_qgsrd_dTemp_dt_GND,d_qgdrd_dTemp_dt_GND,d_qcrd_dTemp_dt_GND,d_qbrd_dTemp_dt_GND,d_qsrd_dTemp_dt_GND,d_vtdiblrd_dTemp_dt_GND,d_vdsatrd_dTemp_dt_GND,d_vgsrd_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_idsrd_dV_tr_GND = evaluator_calc_iq_0.getDerivs(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_idsrd_dV_tr_GND,d_qgsrd_dV_tr_GND,d_qgdrd_dV_tr_GND,d_qcrd_dV_tr_GND,d_qbrd_dV_tr_GND,d_qsrd_dV_tr_GND,d_vtdiblrd_dV_tr_GND,d_vdsatrd_dV_tr_GND,d_vgsrd_dV_tr_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
idsrd = evaluator_calc_iq_0.getValues(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,w,(model_.lgd),(model_.cgrd),0,0,0,(model_.vtord),(model_.srd),(model_.delta1rd),0.0,(model_.ndrd),(model_.alphard),(model_.vx0rd),(model_.mu0rd),(model_.betard),(model_.mthetard),(model_.vthetard),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
}
// I(drc,fp4) <+ ((idsrd+(gmin*V(drc,fp4))))
staticContributions[admsNodeID_drc] += (idsrd+(gmin*(probeVars[admsProbeID_V_drc_fp4])));
d_staticContributions[admsNodeID_drc][admsProbeID_V_drc_fp4] += (d_idsrd_dV_drc_fp4+gmin*d_probeVars[admsProbeID_V_drc_fp4][admsProbeID_V_drc_fp4]);
d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_s] += d_idsrd_dV_fp4_s;
d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_d] += d_idsrd_dV_fp4_d;
d_staticContributions[admsNodeID_drc][admsProbeID_Temp_dt_GND] += d_idsrd_dTemp_dt_GND;
d_staticContributions[admsNodeID_drc][admsProbeID_V_tr_GND] += d_idsrd_dV_tr_GND;
staticContributions[admsNodeID_fp4] -= (idsrd+(gmin*(probeVars[admsProbeID_V_drc_fp4])));
d_staticContributions[admsNodeID_fp4][admsProbeID_V_drc_fp4] -= (d_idsrd_dV_drc_fp4+gmin*d_probeVars[admsProbeID_V_drc_fp4][admsProbeID_V_drc_fp4]);
d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_s] -= d_idsrd_dV_fp4_s;
d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_d] -= d_idsrd_dV_fp4_d;
d_staticContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND] -= d_idsrd_dTemp_dt_GND;
d_staticContributions[admsNodeID_fp4][admsProbeID_V_tr_GND] -= d_idsrd_dV_tr_GND;
}
else
{
// V(drc,fp4) <+ (0)
// do nothing at all
}
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,w,l,(model_.cg),0,0,0,(model_.vto),(model_.ss),(model_.delta1),(model_.delta2),(model_.nd),(model_.alpha),(model_.vx0),(model_.mu0),(model_.beta),(model_.mtheta),(model_.vtheta),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));

d_ids_dTemp_dt_GND = evaluator_calc_iq_0.getDerivs(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,w,l,(model_.cg),0,0,0,(model_.vto),(model_.ss),(model_.delta1),(model_.delta2),(model_.nd),(model_.alpha),(model_.vx0),(model_.mu0),(model_.beta),(model_.mtheta),(model_.vtheta),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_ids_dTemp_dt_GND,d_qgs_dTemp_dt_GND,d_qgd_dTemp_dt_GND,d_qc_dTemp_dt_GND,d_qb_dTemp_dt_GND,d_qs_dTemp_dt_GND,d_vtdibli_dTemp_dt_GND,d_vdsat1i_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_ids_dV_di_si = evaluator_calc_iq_0.getDerivs(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,w,l,(model_.cg),0,0,0,(model_.vto),(model_.ss),(model_.delta1),(model_.delta2),(model_.nd),(model_.alpha),(model_.vx0),(model_.mu0),(model_.beta),(model_.mtheta),(model_.vtheta),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_ids_dV_di_si,d_qgs_dV_di_si,d_qgd_dV_di_si,d_qc_dV_di_si,d_qb_dV_di_si,d_qs_dV_di_si,d_vtdibli_dV_di_si,d_vdsat1i_dV_di_si,0.0,d_vdsi_dV_di_si,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_ids_dV_gi_si = evaluator_calc_iq_0.getDerivs(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,w,l,(model_.cg),0,0,0,(model_.vto),(model_.ss),(model_.delta1),(model_.delta2),(model_.nd),(model_.alpha),(model_.vx0),(model_.mu0),(model_.beta),(model_.mtheta),(model_.vtheta),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type),d_ids_dV_gi_si,d_qgs_dV_gi_si,d_qgd_dV_gi_si,d_qc_dV_gi_si,d_qb_dV_gi_si,d_qs_dV_gi_si,d_vtdibli_dV_gi_si,d_vdsat1i_dV_gi_si,d_vgsi_dV_gi_si,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
ids = evaluator_calc_iq_0.getValues(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,w,l,(model_.cg),0,0,0,(model_.vto),(model_.ss),(model_.delta1),(model_.delta2),(model_.nd),(model_.alpha),(model_.vx0),(model_.mu0),(model_.beta),(model_.mtheta),(model_.vtheta),(model_.vtzeta),(model_.dibsat),(model_.epsilon),(model_.vzeta),(model_.lambda),ngf,(model_.type));
}

d_idsrf_dV_xt2_GND = d_probeVars[admsProbeID_V_xt2_GND][admsProbeID_V_xt2_GND];
idsrf = (probeVars[admsProbeID_V_xt2_GND]);
if (((model_.gmdisp)==0))
{
// V(xt1,GND) <+ (0)
// do nothing at all
// V(xt2,GND) <+ (0)
// do nothing at all
// I(di,si) <+ ((ids+(gmin*V(di,si))))
staticContributions[admsNodeID_di] += (ids+(gmin*(probeVars[admsProbeID_V_di_si])));
d_staticContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] += d_ids_dTemp_dt_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += (d_ids_dV_di_si+gmin*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si]);
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] += d_ids_dV_gi_si;
staticContributions[admsNodeID_si] -= (ids+(gmin*(probeVars[admsProbeID_V_di_si])));
d_staticContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] -= d_ids_dTemp_dt_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= (d_ids_dV_di_si+gmin*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si]);
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si] -= d_ids_dV_gi_si;
}
else
{
// I(xt1,GND) <+ ((ids-V(xt2,GND)))
staticContributions[admsNodeID_xt1] += (ids-(probeVars[admsProbeID_V_xt2_GND]));
d_staticContributions[admsNodeID_xt1][admsProbeID_V_xt2_GND] += (-d_probeVars[admsProbeID_V_xt2_GND][admsProbeID_V_xt2_GND]);
d_staticContributions[admsNodeID_xt1][admsProbeID_Temp_dt_GND] += d_ids_dTemp_dt_GND;
d_staticContributions[admsNodeID_xt1][admsProbeID_V_di_si] += d_ids_dV_di_si;
d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_si] += d_ids_dV_gi_si;
// I(xt1,GND) <+ ((-ddt((taugmrf*V(xt1,GND)))))
dynamicContributions[admsNodeID_xt1] += (-(((model_.taugmrf)*(probeVars[admsProbeID_V_xt1_GND]))));
d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_xt1_GND] += (-((model_.taugmrf)*d_probeVars[admsProbeID_V_xt1_GND][admsProbeID_V_xt1_GND]));
// I(xt2,GND) <+ ((V(xt1,GND)-V(xt2,GND)))
staticContributions[admsNodeID_xt2] += ((probeVars[admsProbeID_V_xt1_GND])-(probeVars[admsProbeID_V_xt2_GND]));
d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND] += (-d_probeVars[admsProbeID_V_xt2_GND][admsProbeID_V_xt2_GND]);
d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt1_GND] += d_probeVars[admsProbeID_V_xt1_GND][admsProbeID_V_xt1_GND];
// I(xt2,GND) <+ ((-ddt(((taugmrf/3.0)*V(xt2,GND)))))
dynamicContributions[admsNodeID_xt2] += (-((((model_.taugmrf)/3.0)*(probeVars[admsProbeID_V_xt2_GND]))));
d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND] += (-(((model_.taugmrf)/3.0)*d_probeVars[admsProbeID_V_xt2_GND][admsProbeID_V_xt2_GND]));
// I(di,si) <+ ((idsrf+(gmin*V(di,si))))
staticContributions[admsNodeID_di] += (idsrf+(gmin*(probeVars[admsProbeID_V_di_si])));
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] += gmin*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si];
d_staticContributions[admsNodeID_di][admsProbeID_V_xt2_GND] += d_idsrf_dV_xt2_GND;
staticContributions[admsNodeID_si] -= (idsrf+(gmin*(probeVars[admsProbeID_V_di_si])));
d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] -= gmin*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si];
d_staticContributions[admsNodeID_si][admsProbeID_V_xt2_GND] -= d_idsrf_dV_xt2_GND;
}
// I(gi,si) <+ ((ddt(qgs)+ddt((minc*V(gi,si)))))
dynamicContributions[admsNodeID_gi] += ((qgs)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgs_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] += ((d_qgs_dV_di_si)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] += ((d_qgs_dV_gi_si)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
dynamicContributions[admsNodeID_si] -= ((qgs)+(((model_.minc)*(probeVars[admsProbeID_V_gi_si]))));
d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] -= ((d_qgs_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -= ((d_qgs_dV_di_si)+(0.0));
d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si] -= ((d_qgs_dV_gi_si)+((model_.minc)*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]));
// I(gi,di) <+ ((ddt(qgd)+ddt((minc*V(gi,di)))))
dynamicContributions[admsNodeID_gi] += ((qgd)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] += ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di]));
d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += ((d_qgd_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] += ((d_qgd_dV_di_si)+(0.0));
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] += ((d_qgd_dV_gi_si)+(0.0));
dynamicContributions[admsNodeID_di] -= ((qgd)+(((model_.minc)*(probeVars[admsProbeID_V_gi_di]))));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -= ((0.0)+((model_.minc)*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di]));
d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= ((d_qgd_dTemp_dt_GND)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -= ((d_qgd_dV_di_si)+(0.0));
d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_si] -= ((d_qgd_dV_gi_si)+(0.0));

d_igsi_dV_gi_si = d_igsi_dTemp_dt_GND =  0.0;
igsi = 0;

d_igdi_dV_gi_si = d_igdi_dV_di_si = d_igdi_dTemp_dt_GND =  0.0;
igdi = 0;

d_igssdio_dV_gi_si = d_igssdio_dTemp_dt_GND =  0.0;
igssdio = 0;

d_igdsdio_dV_gi_si = d_igdsdio_dV_di_si = d_igdsdio_dTemp_dt_GND =  0.0;
igdsdio = 0;

d_igsrec_dV_gi_si = d_igsrec_dTemp_dt_GND =  0.0;
igsrec = 0;

d_igdrec_dV_gi_si = d_igdrec_dV_di_si = d_igdrec_dTemp_dt_GND =  0.0;
igdrec = 0;
if (((model_.igmod)==1))
{
{
AnalogFunctions::calc_igEvaluator evaluator_calc_ig_0(igssdio,igsrec,vgsi,phit,(model_.vgsats),(model_.alphags),(model_.fracs),(model_.pg_params),(model_.pbdgs),(model_.vbdgs),tdut,tnomk,w,ngf,(model_.ijs),(model_.kbdgates),(model_.vgsatqs),(model_.betarecs),(model_.irecs),(model_.pgsrecs),(model_.pg_param1),(model_.vjg),(model_.type));

d_igsi_dTemp_dt_GND = evaluator_calc_ig_0.getDerivs(igssdio,igsrec,vgsi,phit,(model_.vgsats),(model_.alphags),(model_.fracs),(model_.pg_params),(model_.pbdgs),(model_.vbdgs),tdut,tnomk,w,ngf,(model_.ijs),(model_.kbdgates),(model_.vgsatqs),(model_.betarecs),(model_.irecs),(model_.pgsrecs),(model_.pg_param1),(model_.vjg),(model_.type),d_igssdio_dTemp_dt_GND,d_igsrec_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_igsi_dV_gi_si = evaluator_calc_ig_0.getDerivs(igssdio,igsrec,vgsi,phit,(model_.vgsats),(model_.alphags),(model_.fracs),(model_.pg_params),(model_.pbdgs),(model_.vbdgs),tdut,tnomk,w,ngf,(model_.ijs),(model_.kbdgates),(model_.vgsatqs),(model_.betarecs),(model_.irecs),(model_.pgsrecs),(model_.pg_param1),(model_.vjg),(model_.type),d_igssdio_dV_gi_si,d_igsrec_dV_gi_si,d_vgsi_dV_gi_si,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
igsi = evaluator_calc_ig_0.getValues(igssdio,igsrec,vgsi,phit,(model_.vgsats),(model_.alphags),(model_.fracs),(model_.pg_params),(model_.pbdgs),(model_.vbdgs),tdut,tnomk,w,ngf,(model_.ijs),(model_.kbdgates),(model_.vgsatqs),(model_.betarecs),(model_.irecs),(model_.pgsrecs),(model_.pg_param1),(model_.vjg),(model_.type));
}
{
AnalogFunctions::calc_igEvaluator evaluator_calc_ig_0(igdsdio,igdrec,(vgsi-vdsi),phit,(model_.vgsatd),(model_.alphagd),(model_.fracd),(model_.pg_paramd),(model_.pbdgd),(model_.vbdgd),tdut,tnomk,w,ngf,(model_.ijd),(model_.kbdgated),(model_.vgsatqd),(model_.betarecd),(model_.irecd),(model_.pgsrecd),(model_.pg_param1),(model_.vjg),(model_.type));

d_igdi_dTemp_dt_GND = evaluator_calc_ig_0.getDerivs(igdsdio,igdrec,(vgsi-vdsi),phit,(model_.vgsatd),(model_.alphagd),(model_.fracd),(model_.pg_paramd),(model_.pbdgd),(model_.vbdgd),tdut,tnomk,w,ngf,(model_.ijd),(model_.kbdgated),(model_.vgsatqd),(model_.betarecd),(model_.irecd),(model_.pgsrecd),(model_.pg_param1),(model_.vjg),(model_.type),d_igdsdio_dTemp_dt_GND,d_igdrec_dTemp_dt_GND,0.0,d_phit_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,d_tdut_dTemp_dt_GND,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_igdi_dV_di_si = evaluator_calc_ig_0.getDerivs(igdsdio,igdrec,(vgsi-vdsi),phit,(model_.vgsatd),(model_.alphagd),(model_.fracd),(model_.pg_paramd),(model_.pbdgd),(model_.vbdgd),tdut,tnomk,w,ngf,(model_.ijd),(model_.kbdgated),(model_.vgsatqd),(model_.betarecd),(model_.irecd),(model_.pgsrecd),(model_.pg_param1),(model_.vjg),(model_.type),d_igdsdio_dV_di_si,d_igdrec_dV_di_si,(-d_vdsi_dV_di_si),0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
d_igdi_dV_gi_si = evaluator_calc_ig_0.getDerivs(igdsdio,igdrec,(vgsi-vdsi),phit,(model_.vgsatd),(model_.alphagd),(model_.fracd),(model_.pg_paramd),(model_.pbdgd),(model_.vbdgd),tdut,tnomk,w,ngf,(model_.ijd),(model_.kbdgated),(model_.vgsatqd),(model_.betarecd),(model_.irecd),(model_.pgsrecd),(model_.pg_param1),(model_.vjg),(model_.type),d_igdsdio_dV_gi_si,d_igdrec_dV_gi_si,d_vgsi_dV_gi_si,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
igdi = evaluator_calc_ig_0.getValues(igdsdio,igdrec,(vgsi-vdsi),phit,(model_.vgsatd),(model_.alphagd),(model_.fracd),(model_.pg_paramd),(model_.pbdgd),(model_.vbdgd),tdut,tnomk,w,ngf,(model_.ijd),(model_.kbdgated),(model_.vgsatqd),(model_.betarecd),(model_.irecd),(model_.pgsrecd),(model_.pg_param1),(model_.vjg),(model_.type));
}
// I(gi,si) <+ ((igsi+(gmin*V(gi,si))))
staticContributions[admsNodeID_gi] += (igsi+(gmin*(probeVars[admsProbeID_V_gi_si])));
d_staticContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += d_igsi_dTemp_dt_GND;
d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si] += (d_igsi_dV_gi_si+gmin*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]);
staticContributions[admsNodeID_si] -= (igsi+(gmin*(probeVars[admsProbeID_V_gi_si])));
d_staticContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] -= d_igsi_dTemp_dt_GND;
d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si] -= (d_igsi_dV_gi_si+gmin*d_probeVars[admsProbeID_V_gi_si][admsProbeID_V_gi_si]);
// I(gi,di) <+ ((igdi+(gmin*V(gi,di))))
staticContributions[admsNodeID_gi] += (igdi+(gmin*(probeVars[admsProbeID_V_gi_di])));
d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_di] += gmin*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di];
d_staticContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] += d_igdi_dTemp_dt_GND;
d_staticContributions[admsNodeID_gi][admsProbeID_V_di_si] += d_igdi_dV_di_si;
d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si] += d_igdi_dV_gi_si;
staticContributions[admsNodeID_di] -= (igdi+(gmin*(probeVars[admsProbeID_V_gi_di])));
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_di] -= gmin*d_probeVars[admsProbeID_V_gi_di][admsProbeID_V_gi_di];
d_staticContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] -= d_igdi_dTemp_dt_GND;
d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -= d_igdi_dV_di_si;
d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] -= d_igdi_dV_gi_si;
}
if ((rcd_w<=(model_.minr)))
{
// V(d,drc) <+ (0)
// do nothing at all
}
else
{
// I(d,drc) <+ ((V(d,drc)/rdi))
staticContributions[admsNodeID_d] += ((probeVars[admsProbeID_V_d_drc])/rdi);
d_staticContributions[admsNodeID_d][admsProbeID_Temp_dt_GND] += (-(probeVars[admsProbeID_V_d_drc])*d_rdi_dTemp_dt_GND/rdi/rdi);
d_staticContributions[admsNodeID_d][admsProbeID_V_d_drc] += (d_probeVars[admsProbeID_V_d_drc][admsProbeID_V_d_drc]/rdi);
staticContributions[admsNodeID_drc] -= ((probeVars[admsProbeID_V_d_drc])/rdi);
d_staticContributions[admsNodeID_drc][admsProbeID_Temp_dt_GND] -= (-(probeVars[admsProbeID_V_d_drc])*d_rdi_dTemp_dt_GND/rdi/rdi);
d_staticContributions[admsNodeID_drc][admsProbeID_V_d_drc] -= (d_probeVars[admsProbeID_V_d_drc][admsProbeID_V_d_drc]/rdi);
}
if ((rcs_w<=(model_.minr)))
{
// V(src,s) <+ (0)
// do nothing at all
}
else
{
// I(src,s) <+ ((V(src,s)/rsi))
staticContributions[admsNodeID_src] += ((probeVars[admsProbeID_V_src_s])/rsi);
d_staticContributions[admsNodeID_src][admsProbeID_Temp_dt_GND] += (-(probeVars[admsProbeID_V_src_s])*d_rsi_dTemp_dt_GND/rsi/rsi);
d_staticContributions[admsNodeID_src][admsProbeID_V_src_s] += (d_probeVars[admsProbeID_V_src_s][admsProbeID_V_src_s]/rsi);
staticContributions[admsNodeID_s] -= ((probeVars[admsProbeID_V_src_s])/rsi);
d_staticContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] -= (-(probeVars[admsProbeID_V_src_s])*d_rsi_dTemp_dt_GND/rsi/rsi);
d_staticContributions[admsNodeID_s][admsProbeID_V_src_s] -= (d_probeVars[admsProbeID_V_src_s][admsProbeID_V_src_s]/rsi);
}
if ((rg<=(model_.minr)))
{
// V(g,gi) <+ (0)
// do nothing at all
}
else
{
// I(g,gi) <+ ((V(g,gi)/rg))
staticContributions[admsNodeID_g] += ((probeVars[admsProbeID_V_g_gi])/rg);
d_staticContributions[admsNodeID_g][admsProbeID_V_g_gi] += (d_probeVars[admsProbeID_V_g_gi][admsProbeID_V_g_gi]/rg);
staticContributions[admsNodeID_gi] -= ((probeVars[admsProbeID_V_g_gi])/rg);
d_staticContributions[admsNodeID_gi][admsProbeID_V_g_gi] -= (d_probeVars[admsProbeID_V_g_gi][admsProbeID_V_g_gi]/rg);
}

d_qofs_dV_gi_s = ((w*ngf)*(model_.cofsm))*d_probeVars[admsProbeID_V_gi_s][admsProbeID_V_gi_s];
qofs = (((w*ngf)*(model_.cofsm))*(probeVars[admsProbeID_V_gi_s]));
// I(gi,s) <+ (ddt(qofs))
dynamicContributions[admsNodeID_gi] += (qofs);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_s] += (d_qofs_dV_gi_s);
dynamicContributions[admsNodeID_s] -= (qofs);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_s] -= (d_qofs_dV_gi_s);

d_qofd_dV_gi_d = ((w*ngf)*(model_.cofdm))*d_probeVars[admsProbeID_V_gi_d][admsProbeID_V_gi_d];
qofd = (((w*ngf)*(model_.cofdm))*(probeVars[admsProbeID_V_gi_d]));
// I(gi,d) <+ (ddt(qofd))
dynamicContributions[admsNodeID_gi] += (qofd);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_d] += (d_qofd_dV_gi_d);
dynamicContributions[admsNodeID_d] -= (qofd);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_d] -= (d_qofd_dV_gi_d);

d_qofds_dV_d_s = ((w*ngf)*(model_.cofdsm))*d_probeVars[admsProbeID_V_d_s][admsProbeID_V_d_s];
qofds = (((w*ngf)*(model_.cofdsm))*(probeVars[admsProbeID_V_d_s]));
// I(d,s) <+ (ddt(qofds))
dynamicContributions[admsNodeID_d] += (qofds);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s] += (d_qofds_dV_d_s);
dynamicContributions[admsNodeID_s] -= (qofds);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s] -= (d_qofds_dV_d_s);

d_qofdsub_dV_d_b = ((w*ngf)*(model_.cofdsubm))*d_probeVars[admsProbeID_V_d_b][admsProbeID_V_d_b];
qofdsub = (((w*ngf)*(model_.cofdsubm))*(probeVars[admsProbeID_V_d_b]));
// I(d,b) <+ (ddt(qofdsub))
dynamicContributions[admsNodeID_d] += (qofdsub);
d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_b] += (d_qofdsub_dV_d_b);
dynamicContributions[admsNodeID_b] -= (qofdsub);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_b] -= (d_qofdsub_dV_d_b);

d_qofssub_dV_s_b = ((w*ngf)*(model_.cofssubm))*d_probeVars[admsProbeID_V_s_b][admsProbeID_V_s_b];
qofssub = (((w*ngf)*(model_.cofssubm))*(probeVars[admsProbeID_V_s_b]));
// I(s,b) <+ (ddt(qofssub))
dynamicContributions[admsNodeID_s] += (qofssub);
d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_b] += (d_qofssub_dV_s_b);
dynamicContributions[admsNodeID_b] -= (qofssub);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_b] -= (d_qofssub_dV_s_b);

d_qofgsub_dV_gi_b = ((w*ngf)*(model_.cofgsubm))*d_probeVars[admsProbeID_V_gi_b][admsProbeID_V_gi_b];
qofgsub = (((w*ngf)*(model_.cofgsubm))*(probeVars[admsProbeID_V_gi_b]));
// I(gi,b) <+ (ddt(qofgsub))
dynamicContributions[admsNodeID_gi] += (qofgsub);
d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_b] += (d_qofgsub_dV_gi_b);
dynamicContributions[admsNodeID_b] -= (qofgsub);
d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_b] -= (d_qofgsub_dV_gi_b);
gm = 0;
svc = 0;
if (((model_.noisemod)==1))
{
 UserError(*this) << "$finish called." << std::endl; 
}

d_pdiss_dV_drc_d =  0.0;
d_pdiss_dV_b_fp3 = d_idsfp4_dV_b_fp3*(probeVars[admsProbeID_V_fp4_fp3]);
d_pdiss_dV_fp4_fp3 = (idsfp4*d_probeVars[admsProbeID_V_fp4_fp3][admsProbeID_V_fp4_fp3]+d_idsfp4_dV_fp4_fp3*(probeVars[admsProbeID_V_fp4_fp3]));
d_pdiss_dV_gi_fp3 = d_idsfp4_dV_gi_fp3*(probeVars[admsProbeID_V_fp4_fp3]);
d_pdiss_dV_s_fp3 = d_idsfp4_dV_s_fp3*(probeVars[admsProbeID_V_fp4_fp3]);
d_pdiss_dV_b_fp2 = d_idsfp3_dV_b_fp2*(probeVars[admsProbeID_V_fp3_fp2]);
d_pdiss_dV_fp3_fp2 = (idsfp3*d_probeVars[admsProbeID_V_fp3_fp2][admsProbeID_V_fp3_fp2]+d_idsfp3_dV_fp3_fp2*(probeVars[admsProbeID_V_fp3_fp2]));
d_pdiss_dV_gi_fp2 = d_idsfp3_dV_gi_fp2*(probeVars[admsProbeID_V_fp3_fp2]);
d_pdiss_dV_s_fp2 = d_idsfp3_dV_s_fp2*(probeVars[admsProbeID_V_fp3_fp2]);
d_pdiss_dV_b_fp1 = d_idsfp2_dV_b_fp1*(probeVars[admsProbeID_V_fp2_fp1]);
d_pdiss_dV_fp2_fp1 = (idsfp2*d_probeVars[admsProbeID_V_fp2_fp1][admsProbeID_V_fp2_fp1]+d_idsfp2_dV_fp2_fp1*(probeVars[admsProbeID_V_fp2_fp1]));
d_pdiss_dV_gi_fp1 = d_idsfp2_dV_gi_fp1*(probeVars[admsProbeID_V_fp2_fp1]);
d_pdiss_dV_s_fp1 = d_idsfp2_dV_s_fp1*(probeVars[admsProbeID_V_fp2_fp1]);
d_pdiss_dV_b_di = d_idsfp1_dV_b_di*(probeVars[admsProbeID_V_fp1_di]);
d_pdiss_dV_fp1_di = (idsfp1*d_probeVars[admsProbeID_V_fp1_di][admsProbeID_V_fp1_di]+d_idsfp1_dV_fp1_di*(probeVars[admsProbeID_V_fp1_di]));
d_pdiss_dV_gi_di = d_idsfp1_dV_gi_di*(probeVars[admsProbeID_V_fp1_di]);
d_pdiss_dV_s_di = d_idsfp1_dV_s_di*(probeVars[admsProbeID_V_fp1_di]);
d_pdiss_dV_si_src = (idsrs*d_probeVars[admsProbeID_V_si_src][admsProbeID_V_si_src]+d_idsrs_dV_si_src*(probeVars[admsProbeID_V_si_src]));
d_pdiss_dV_src_s = d_idsrs_dV_src_s*(probeVars[admsProbeID_V_si_src]);
d_pdiss_dV_src_d = d_idsrs_dV_src_d*(probeVars[admsProbeID_V_si_src]);
d_pdiss_dV_drc_fp4 = (idsrd*d_probeVars[admsProbeID_V_drc_fp4][admsProbeID_V_drc_fp4]+d_idsrd_dV_drc_fp4*(probeVars[admsProbeID_V_drc_fp4]));
d_pdiss_dV_fp4_s = d_idsrd_dV_fp4_s*(probeVars[admsProbeID_V_drc_fp4]);
d_pdiss_dV_fp4_d = d_idsrd_dV_fp4_d*(probeVars[admsProbeID_V_drc_fp4]);
d_pdiss_dV_tr_GND = d_idsrd_dV_tr_GND*(probeVars[admsProbeID_V_drc_fp4]);
d_pdiss_dTemp_dt_GND = ((((((d_ids_dTemp_dt_GND*(probeVars[admsProbeID_V_di_si])+d_idsrd_dTemp_dt_GND*(probeVars[admsProbeID_V_drc_fp4]))+d_idsrs_dTemp_dt_GND*(probeVars[admsProbeID_V_si_src]))+d_idsfp1_dTemp_dt_GND*(probeVars[admsProbeID_V_fp1_di]))+d_idsfp2_dTemp_dt_GND*(probeVars[admsProbeID_V_fp2_fp1]))+d_idsfp3_dTemp_dt_GND*(probeVars[admsProbeID_V_fp3_fp2]))+d_idsfp4_dTemp_dt_GND*(probeVars[admsProbeID_V_fp4_fp3]));
d_pdiss_dV_di_si = (ids*d_probeVars[admsProbeID_V_di_si][admsProbeID_V_di_si]+d_ids_dV_di_si*(probeVars[admsProbeID_V_di_si]));
d_pdiss_dV_gi_si = d_ids_dV_gi_si*(probeVars[admsProbeID_V_di_si]);
pdiss = (((((((ids*(probeVars[admsProbeID_V_di_si]))+(idsrd*(probeVars[admsProbeID_V_drc_fp4])))+(idsrs*(probeVars[admsProbeID_V_si_src])))+(idsfp1*(probeVars[admsProbeID_V_fp1_di])))+(idsfp2*(probeVars[admsProbeID_V_fp2_fp1])))+(idsfp3*(probeVars[admsProbeID_V_fp3_fp2])))+(idsfp4*(probeVars[admsProbeID_V_fp4_fp3])));
if ((rdi!=0))
{

d_pdiss_dV_drc_d = (d_pdiss_dV_drc_d+(((probeVars[admsProbeID_V_drc_d])*d_probeVars[admsProbeID_V_drc_d][admsProbeID_V_drc_d]+d_probeVars[admsProbeID_V_drc_d][admsProbeID_V_drc_d]*(probeVars[admsProbeID_V_drc_d]))/rdi));
d_pdiss_dTemp_dt_GND = (d_pdiss_dTemp_dt_GND+(-((probeVars[admsProbeID_V_drc_d])*(probeVars[admsProbeID_V_drc_d]))*d_rdi_dTemp_dt_GND/rdi/rdi));
pdiss = (pdiss+(((probeVars[admsProbeID_V_drc_d])*(probeVars[admsProbeID_V_drc_d]))/rdi));
}
if ((rsi!=0))
{

d_pdiss_dV_src_s = (d_pdiss_dV_src_s+(((probeVars[admsProbeID_V_src_s])*d_probeVars[admsProbeID_V_src_s][admsProbeID_V_src_s]+d_probeVars[admsProbeID_V_src_s][admsProbeID_V_src_s]*(probeVars[admsProbeID_V_src_s]))/rsi));
d_pdiss_dTemp_dt_GND = (d_pdiss_dTemp_dt_GND+(-((probeVars[admsProbeID_V_src_s])*(probeVars[admsProbeID_V_src_s]))*d_rsi_dTemp_dt_GND/rsi/rsi));
pdiss = (pdiss+(((probeVars[admsProbeID_V_src_s])*(probeVars[admsProbeID_V_src_s]))/rsi));
}
if (((model_.rth)>0))
{
// Pwr(dt,GND) <+ (ddt((cth*Temp(dt,GND))))
dynamicContributions[admsNodeID_dt] += (((model_.cth)*(probeVars[admsProbeID_Temp_dt_GND])));
d_dynamicContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND] += ((model_.cth)*d_probeVars[admsProbeID_Temp_dt_GND][admsProbeID_Temp_dt_GND]);
// Pwr(dt,GND) <+ ((-pdiss))
staticContributions[admsNodeID_dt] += (-pdiss);
d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp3] += (-d_pdiss_dV_b_fp3);
d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_fp3] += (-d_pdiss_dV_fp4_fp3);
d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp3] += (-d_pdiss_dV_gi_fp3);
d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp3] += (-d_pdiss_dV_s_fp3);
d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp2] += (-d_pdiss_dV_b_fp2);
d_staticContributions[admsNodeID_dt][admsProbeID_V_fp3_fp2] += (-d_pdiss_dV_fp3_fp2);
d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp2] += (-d_pdiss_dV_gi_fp2);
d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp2] += (-d_pdiss_dV_s_fp2);
d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp1] += (-d_pdiss_dV_b_fp1);
d_staticContributions[admsNodeID_dt][admsProbeID_V_fp2_fp1] += (-d_pdiss_dV_fp2_fp1);
d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp1] += (-d_pdiss_dV_gi_fp1);
d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp1] += (-d_pdiss_dV_s_fp1);
d_staticContributions[admsNodeID_dt][admsProbeID_V_b_di] += (-d_pdiss_dV_b_di);
d_staticContributions[admsNodeID_dt][admsProbeID_V_fp1_di] += (-d_pdiss_dV_fp1_di);
d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_di] += (-d_pdiss_dV_gi_di);
d_staticContributions[admsNodeID_dt][admsProbeID_V_s_di] += (-d_pdiss_dV_s_di);
d_staticContributions[admsNodeID_dt][admsProbeID_V_si_src] += (-d_pdiss_dV_si_src);
d_staticContributions[admsNodeID_dt][admsProbeID_V_src_s] += (-d_pdiss_dV_src_s);
d_staticContributions[admsNodeID_dt][admsProbeID_V_src_d] += (-d_pdiss_dV_src_d);
d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_fp4] += (-d_pdiss_dV_drc_fp4);
d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_s] += (-d_pdiss_dV_fp4_s);
d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_d] += (-d_pdiss_dV_fp4_d);
d_staticContributions[admsNodeID_dt][admsProbeID_V_tr_GND] += (-d_pdiss_dV_tr_GND);
d_staticContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND] += (-d_pdiss_dTemp_dt_GND);
d_staticContributions[admsNodeID_dt][admsProbeID_V_di_si] += (-d_pdiss_dV_di_si);
d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_si] += (-d_pdiss_dV_gi_si);
d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_d] += (-d_pdiss_dV_drc_d);
// Pwr(dt,GND) <+ ((Temp(dt,GND)/rth))
staticContributions[admsNodeID_dt] += ((probeVars[admsProbeID_Temp_dt_GND])/(model_.rth));
d_staticContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND] += (d_probeVars[admsProbeID_Temp_dt_GND][admsProbeID_Temp_dt_GND]/(model_.rth));
}
else
{
// Temp(dt,GND) <+ (0.0)
// do nothing at all
}
vgisi = (probeVars[admsProbeID_V_gi_si]);
vdisi = (probeVars[admsProbeID_V_di_si]);
vti = vtdibli;
vdsati = vdsat1i;
pdc = pdiss;
idisi = ids;
igs = igsi;
igd = igdi;

d_qgi_dTemp_dt_GND = (d_qgs_dTemp_dt_GND+d_qgd_dTemp_dt_GND);
d_qgi_dV_di_si = (d_qgs_dV_di_si+d_qgd_dV_di_si);
d_qgi_dV_gi_si = (d_qgs_dV_gi_si+d_qgd_dV_gi_si);
qgi = (qgs+qgd);

d_qdi_dTemp_dt_GND = (-d_qgd_dTemp_dt_GND);
d_qdi_dV_di_si = (-d_qgd_dV_di_si);
d_qdi_dV_gi_si = (-d_qgd_dV_gi_si);
qdi = (-qgd);

d_qsi_dTemp_dt_GND = (-d_qgs_dTemp_dt_GND);
d_qsi_dV_di_si = (-d_qgs_dV_di_si);
d_qsi_dV_gi_si = (-d_qgs_dV_gi_si);
qsi = (-qgs);
qbi = 0;
gmi = (+d_ids_dV_gi_si);
gdsi = (+d_ids_dV_di_si);
gmbsi = 0.0;
cggi = (+d_qgi_dV_gi_si);
cgdi = (+d_qgi_dV_di_si);
cgsi = (-d_qgi_dV_di_si-d_qgi_dV_gi_si);
cgbi = 0.0;
cdgi = (+d_qdi_dV_gi_si);
cddi = (+d_qdi_dV_di_si);
cdsi = (-d_qdi_dV_di_si-d_qdi_dV_gi_si);
cdbi = 0.0;
csgi = (+d_qsi_dV_gi_si);
csdi = (+d_qsi_dV_di_si);
cssi = (-d_qsi_dV_di_si-d_qsi_dV_gi_si);
csbi = 0.0;
cbgi = 0.0;
cbdi = 0.0;
cbsi = 0.0;
cbbi = 0.0;
cgs = ((w*ngf)*(model_.cofsm));
cgd = ((w*ngf)*(model_.cofdm));
t_total_k = tdut;
t_total_c = (tdut-273.15);
t_delta_sh = tsh;
rs = ((((model_.rsh)*(model_.lgs))/w)/ngf);
rd = ((((model_.rsh)*(model_.lgd))/w)/ngf);


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_si_GND] =  "
         <<probeVars[admsProbeID_V_si_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_GND] =  "
         <<probeVars[admsProbeID_V_b_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_GND] =  "
         <<probeVars[admsProbeID_V_di_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_GND] =  "
         <<probeVars[admsProbeID_V_gi_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_drc_d] =  "
         <<probeVars[admsProbeID_V_drc_d] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_b] =  "
         <<probeVars[admsProbeID_V_gi_b] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_b] =  "
         <<probeVars[admsProbeID_V_s_b] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_b] =  "
         <<probeVars[admsProbeID_V_d_b] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_s] =  "
         <<probeVars[admsProbeID_V_d_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_d] =  "
         <<probeVars[admsProbeID_V_gi_d] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_s] =  "
         <<probeVars[admsProbeID_V_gi_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_g_gi] =  "
         <<probeVars[admsProbeID_V_g_gi] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_drc] =  "
         <<probeVars[admsProbeID_V_d_drc] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xt1_GND] =  "
         <<probeVars[admsProbeID_V_xt1_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_xt2_GND] =  "
         <<probeVars[admsProbeID_V_xt2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp4] =  "
         <<probeVars[admsProbeID_V_s_fp4] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp4] =  "
         <<probeVars[admsProbeID_V_gi_fp4] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_fp3] =  "
         <<probeVars[admsProbeID_V_b_fp3] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp4_fp3] =  "
         <<probeVars[admsProbeID_V_fp4_fp3] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp3] =  "
         <<probeVars[admsProbeID_V_s_fp3] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp3] =  "
         <<probeVars[admsProbeID_V_gi_fp3] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_fp2] =  "
         <<probeVars[admsProbeID_V_b_fp2] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp3_fp2] =  "
         <<probeVars[admsProbeID_V_fp3_fp2] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp2] =  "
         <<probeVars[admsProbeID_V_s_fp2] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp2] =  "
         <<probeVars[admsProbeID_V_gi_fp2] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_fp1] =  "
         <<probeVars[admsProbeID_V_b_fp1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp2_fp1] =  "
         <<probeVars[admsProbeID_V_fp2_fp1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_fp1] =  "
         <<probeVars[admsProbeID_V_s_fp1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_fp1] =  "
         <<probeVars[admsProbeID_V_gi_fp1] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_b_di] =  "
         <<probeVars[admsProbeID_V_b_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp1_di] =  "
         <<probeVars[admsProbeID_V_fp1_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_s_di] =  "
         <<probeVars[admsProbeID_V_s_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_di] =  "
         <<probeVars[admsProbeID_V_gi_di] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_drc_fp4] =  "
         <<probeVars[admsProbeID_V_drc_fp4] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp4_s] =  "
         <<probeVars[admsProbeID_V_fp4_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_fp4_d] =  "
         <<probeVars[admsProbeID_V_fp4_d] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_tr_GND] =  "
         <<probeVars[admsProbeID_V_tr_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_tr1_tr] =  "
         <<probeVars[admsProbeID_V_tr1_tr] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_d_g] =  "
         <<probeVars[admsProbeID_V_d_g] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_si_src] =  "
         <<probeVars[admsProbeID_V_si_src] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_src_s] =  "
         <<probeVars[admsProbeID_V_src_s] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_src_d] =  "
         <<probeVars[admsProbeID_V_src_d] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_gi_si] =  "
         <<probeVars[admsProbeID_V_gi_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_di_si] =  "
         <<probeVars[admsProbeID_V_di_si] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_Temp_dt_GND] =  "
         <<probeVars[admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_d] =  "
         <<staticContributions[admsNodeID_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_d][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_d] =  "
         <<dynamicContributions[admsNodeID_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_d].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_d][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_g] =  "
         <<staticContributions[admsNodeID_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_g].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_g][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_g] =  "
         <<dynamicContributions[admsNodeID_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_g].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_g][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_s] =  "
         <<staticContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_s] =  "
         <<dynamicContributions[admsNodeID_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_s].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_b] =  "
         <<staticContributions[admsNodeID_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_b][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_b] =  "
         <<dynamicContributions[admsNodeID_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_b].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_di] =  "
         <<staticContributions[admsNodeID_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_di] =  "
         <<dynamicContributions[admsNodeID_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_di].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_gi] =  "
         <<staticContributions[admsNodeID_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_gi] =  "
         <<dynamicContributions[admsNodeID_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_gi].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_si] =  "
         <<staticContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_si] =  "
         <<dynamicContributions[admsNodeID_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_si].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp1] =  "
         <<staticContributions[admsNodeID_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp1] =  "
         <<dynamicContributions[admsNodeID_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp1].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp2] =  "
         <<staticContributions[admsNodeID_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp2] =  "
         <<dynamicContributions[admsNodeID_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp2].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp3] =  "
         <<staticContributions[admsNodeID_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp3] =  "
         <<dynamicContributions[admsNodeID_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp3].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_fp4] =  "
         <<staticContributions[admsNodeID_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_fp4] =  "
         <<dynamicContributions[admsNodeID_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_fp4].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_drc] =  "
         <<staticContributions[admsNodeID_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_drc][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_drc] =  "
         <<dynamicContributions[admsNodeID_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_drc].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_drc][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_src] =  "
         <<staticContributions[admsNodeID_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_src][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_src] =  "
         <<dynamicContributions[admsNodeID_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_src].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_src][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_tr] =  "
         <<staticContributions[admsNodeID_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_tr][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_tr] =  "
         <<dynamicContributions[admsNodeID_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_tr][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_tr1] =  "
         <<staticContributions[admsNodeID_tr1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_tr1].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_tr1][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_tr1] =  "
         <<dynamicContributions[admsNodeID_tr1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_tr1].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_tr1][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xt1] =  "
         <<staticContributions[admsNodeID_xt1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_xt1][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xt1] =  "
         <<dynamicContributions[admsNodeID_xt1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt1].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_xt1][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_xt2] =  "
         <<staticContributions[admsNodeID_xt2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_xt2].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_xt2][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_xt2] =  "
         <<dynamicContributions[admsNodeID_xt2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_xt2].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_xt2][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_dt] =  "
         <<staticContributions[admsNodeID_dt] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_b) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_b) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_b) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_s) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_d) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_s) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_g_gi) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_drc) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_xt1_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_xt2_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_tr1_tr) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_d_g) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) =  " <<d_staticContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_dt] =  "
         <<dynamicContributions[admsNodeID_dt] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_si_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_di_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_di_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_d) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_drc_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_b) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_b) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_s_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_b) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_d_b] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_s) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_d_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_d) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_s) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_g_gi) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_g_gi] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_drc) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_d_drc] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xt1_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_xt1_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_xt2_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_xt2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp4) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_s_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp4) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp3) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_fp3) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_fp4_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp3) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_s_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp3) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_fp3] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp2) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp3_fp2) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_fp3_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp2) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_s_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp2) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_fp2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_fp1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp2_fp1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_fp2_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_fp1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_s_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_fp1) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_fp1] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_b_di) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_b_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp1_di) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_fp1_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_s_di) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_s_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_di) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_di] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_drc_fp4) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_drc_fp4] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_s) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_fp4_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_fp4_d) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_fp4_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_tr_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_tr_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_tr1_tr) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_tr1_tr] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_d_g) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_d_g] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_si_src) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_si_src] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_s) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_src_s] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_src_d) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_src_d] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_gi_si) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_gi_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_V_di_si) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_V_di_si] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_dt].dx(admsProbeID_Temp_dt_GND) =  " <<d_dynamicContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 18; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
if (!collapseNode_tr1)
{
  (*f_tr1_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_g];
}
if (!collapseNode_tr1)
{
  (*f_tr1_Equ_g_Node_Ptr) +=  -d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_g];
}
if (!collapseNode_tr)
{
  (*f_tr_Equ_tr_Node_Ptr) +=  +d_staticContributions[admsNodeID_tr][admsProbeID_V_tr_GND];
}
if (!collapseNode_dt)
{
  (*f_fp4_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_dt)
{
  (*f_fp3_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND];
}
  (*f_fp4_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  (*f_fp4_Equ_fp3_Node_Ptr) +=  -d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  (*f_fp3_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] +d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  (*f_fp3_Equ_fp3_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  (*f_fp4_Equ_fp4_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_d] +d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_drc_fp4] +d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3];
  (*f_fp3_Equ_fp4_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3];
  (*f_fp4_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3];
  (*f_fp3_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] +d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3];
  (*f_fp4_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_s] +d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp3];
  (*f_fp3_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] +d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  (*f_gi_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND];
}
  (*f_gi_Equ_gi_Node_Ptr) +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_g_gi] +d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_di] +d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si];
if (!collapseNode_dt)
{
  (*f_s_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_Temp_dt_GND];
}
  (*f_s_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_src_s];
  (*f_gi_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si];
  (*f_si_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si];
  (*f_si_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_src];
if (!collapseNode_dt)
{
  (*f_si_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_Temp_dt_GND];
}
  (*f_si_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_src_s];
if (!collapseNode_dt)
{
  (*f_fp2_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND];
}
  (*f_fp3_Equ_fp2_Node_Ptr) +=  -d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp2];
  (*f_fp2_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] +d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  (*f_fp2_Equ_fp2_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  (*f_fp2_Equ_fp3_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2];
  (*f_fp2_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] +d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2];
  (*f_fp2_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] +d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp2];
if (!collapseNode_dt)
{
  (*f_fp1_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND];
}
  (*f_fp2_Equ_fp1_Node_Ptr) +=  -d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp1];
  (*f_fp1_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_di] +d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  (*f_fp1_Equ_fp1_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  (*f_fp1_Equ_fp2_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1];
  (*f_fp1_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_di] +d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1];
  (*f_fp1_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_di] +d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp1];
if (!collapseNode_dt)
{
  (*f_di_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_Temp_dt_GND];
}
  (*f_fp1_Equ_di_Node_Ptr) +=  -d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_di];
  (*f_di_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_b_di];
  (*f_di_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_s_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_gi_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_b_di];
  (*f_di_Equ_fp1_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_fp1_di];
  (*f_di_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_gi_di];
  (*f_di_Equ_s_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_s_di];
  (*f_gi_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_di];
  (*f_si_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_di_si];
if (!collapseNode_dt)
{
  (*f_src_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_src][admsProbeID_Temp_dt_GND];
}
  (*f_si_Equ_src_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_src_d] +d_staticContributions[admsNodeID_si][admsProbeID_V_src_s] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_src];
  (*f_src_Equ_si_Node_Ptr) +=  +d_staticContributions[admsNodeID_src][admsProbeID_V_si_src];
  (*f_src_Equ_src_Node_Ptr) +=  +d_staticContributions[admsNodeID_src][admsProbeID_V_src_d] +d_staticContributions[admsNodeID_src][admsProbeID_V_src_s] -d_staticContributions[admsNodeID_src][admsProbeID_V_si_src];
  (*f_src_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_src][admsProbeID_V_src_s];
  (*f_si_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_src_d];
  (*f_src_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_src][admsProbeID_V_src_d];
  (*f_drc_Equ_drc_Node_Ptr) +=  -d_staticContributions[admsNodeID_drc][admsProbeID_V_d_drc] +d_staticContributions[admsNodeID_drc][admsProbeID_V_drc_fp4];
  (*f_drc_Equ_fp4_Node_Ptr) +=  +d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_d] +d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_drc][admsProbeID_V_drc_fp4];
  (*f_fp4_Equ_drc_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_drc_fp4];
  (*f_drc_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_s];
  (*f_drc_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_drc][admsProbeID_V_d_drc] -d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_d];
  (*f_fp4_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_d];
if (!collapseNode_dt)
{
  (*f_drc_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_drc][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_tr)
{
  (*f_drc_Equ_tr_Node_Ptr) +=  +d_staticContributions[admsNodeID_drc][admsProbeID_V_tr_GND];
}
if (!collapseNode_tr)
{
  (*f_fp4_Equ_tr_Node_Ptr) +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_tr_GND];
}
  (*f_di_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_si];
if (!collapseNode_xt1)
{
if (!collapseNode_xt2)
{
  (*f_xt1_Equ_xt2_Node_Ptr) +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_V_xt2_GND];
}
}
if (!collapseNode_xt1)
{
if (!collapseNode_dt)
{
  (*f_xt1_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_Temp_dt_GND];
}
}
if (!collapseNode_xt1)
{
  (*f_xt1_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_V_di_si];
}
if (!collapseNode_xt1)
{
  (*f_xt1_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_xt1][admsProbeID_V_di_si];
}
if (!collapseNode_xt1)
{
  (*f_xt1_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_si];
}
if (!collapseNode_xt2)
{
  (*f_xt2_Equ_xt2_Node_Ptr) +=  +d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND];
}
if (!collapseNode_xt2)
{
if (!collapseNode_xt1)
{
  (*f_xt2_Equ_xt1_Node_Ptr) +=  +d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt1_GND];
}
}
if (!collapseNode_xt2)
{
  (*f_di_Equ_xt2_Node_Ptr) +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_xt2_GND];
}
if (!collapseNode_xt2)
{
  (*f_si_Equ_xt2_Node_Ptr) +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_xt2_GND];
}
if (!collapseNode_dt)
{
  (*f_d_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_Temp_dt_GND];
}
  (*f_d_Equ_d_Node_Ptr) +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_d_drc];
  (*f_d_Equ_drc_Node_Ptr) +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_d_drc];
  (*f_s_Equ_src_Node_Ptr) +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_src_s];
  (*f_g_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_g_gi];
  (*f_g_Equ_gi_Node_Ptr) +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_g_gi];
  (*f_gi_Equ_g_Node_Ptr) +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_g_gi];
if (!collapseNode_dt)
{
  (*f_dt_Equ_dt_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_b_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_di] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp3];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_fp3_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp3] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp3] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_fp3] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp3];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_fp4_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_d] +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_fp4] +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_fp3];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_gi_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_si] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_di] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp3];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_s_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_dt][admsProbeID_V_src_s] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_di] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp3];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_fp2_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp2];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_fp1_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp1];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_di_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_di];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_si_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_dt][admsProbeID_V_di_si] +d_staticContributions[admsNodeID_dt][admsProbeID_V_si_src];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_src_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_src_d] +d_staticContributions[admsNodeID_dt][admsProbeID_V_src_s] -d_staticContributions[admsNodeID_dt][admsProbeID_V_si_src];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_d_Node_Ptr) +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_d] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_d] -d_staticContributions[admsNodeID_dt][admsProbeID_V_src_d];
}
if (!collapseNode_dt)
{
  (*f_dt_Equ_drc_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_d] +d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_fp4];
}
if (!collapseNode_dt)
{
if (!collapseNode_tr)
{
  (*f_dt_Equ_tr_Node_Ptr) +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_tr_GND];
}
}

#else
  //use the offsets instead of pointers
if (!collapseNode_tr1)
{
  dFdx[li_tr1][A_tr1_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_g];
}
if (!collapseNode_tr1)
{
  dFdx[li_tr1][A_tr1_Equ_g_NodeOffset] +=  -d_staticContributions[admsNodeID_tr1][admsProbeID_V_d_g];
}
if (!collapseNode_tr)
{
  dFdx[li_tr][A_tr_Equ_tr_NodeOffset] +=  +d_staticContributions[admsNodeID_tr][admsProbeID_V_tr_GND];
}
if (!collapseNode_dt)
{
  dFdx[li_fp4][A_fp4_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_dt)
{
  dFdx[li_fp3][A_fp3_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND];
}
  dFdx[li_fp4][A_fp4_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  dFdx[li_fp4][A_fp4_Equ_fp3_NodeOffset] +=  -d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  dFdx[li_fp3][A_fp3_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] +d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  dFdx[li_fp3][A_fp3_Equ_fp3_NodeOffset] +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  dFdx[li_fp4][A_fp4_Equ_fp4_NodeOffset] +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_d] +d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_fp4][admsProbeID_V_drc_fp4] +d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3];
  dFdx[li_fp3][A_fp3_Equ_fp4_NodeOffset] +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3];
  dFdx[li_fp4][A_fp4_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3];
  dFdx[li_fp3][A_fp3_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] +d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3];
  dFdx[li_fp4][A_fp4_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_s] +d_staticContributions[admsNodeID_fp4][admsProbeID_V_s_fp3];
  dFdx[li_fp3][A_fp3_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] +d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  dFdx[li_gi][A_gi_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND];
}
  dFdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_g_gi] +d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_di] +d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si];
if (!collapseNode_dt)
{
  dFdx[li_s][A_s_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_Temp_dt_GND];
}
  dFdx[li_s][A_s_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_s][admsProbeID_V_src_s];
  dFdx[li_gi][A_gi_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_si];
  dFdx[li_si][A_si_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si];
  dFdx[li_si][A_si_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_si][admsProbeID_V_di_si] +d_staticContributions[admsNodeID_si][admsProbeID_V_si_src];
if (!collapseNode_dt)
{
  dFdx[li_si][A_si_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_Temp_dt_GND];
}
  dFdx[li_si][A_si_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_src_s];
if (!collapseNode_dt)
{
  dFdx[li_fp2][A_fp2_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND];
}
  dFdx[li_fp3][A_fp3_Equ_fp2_NodeOffset] +=  -d_staticContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_fp3][admsProbeID_V_b_fp2];
  dFdx[li_fp2][A_fp2_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] +d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  dFdx[li_fp2][A_fp2_Equ_fp2_NodeOffset] +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  dFdx[li_fp2][A_fp2_Equ_fp3_NodeOffset] +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2];
  dFdx[li_fp2][A_fp2_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] +d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2];
  dFdx[li_fp2][A_fp2_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] +d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp2];
if (!collapseNode_dt)
{
  dFdx[li_fp1][A_fp1_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND];
}
  dFdx[li_fp2][A_fp2_Equ_fp1_NodeOffset] +=  -d_staticContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_fp2][admsProbeID_V_b_fp1];
  dFdx[li_fp1][A_fp1_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_di] +d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  dFdx[li_fp1][A_fp1_Equ_fp1_NodeOffset] +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  dFdx[li_fp1][A_fp1_Equ_fp2_NodeOffset] +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1];
  dFdx[li_fp1][A_fp1_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_di] +d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1];
  dFdx[li_fp1][A_fp1_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_di] +d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_fp1];
if (!collapseNode_dt)
{
  dFdx[li_di][A_di_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_Temp_dt_GND];
}
  dFdx[li_fp1][A_fp1_Equ_di_NodeOffset] +=  -d_staticContributions[admsNodeID_fp1][admsProbeID_V_s_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_gi_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_fp1][admsProbeID_V_b_di];
  dFdx[li_di][A_di_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_b_di];
  dFdx[li_di][A_di_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_s_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_gi_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_di][admsProbeID_V_b_di];
  dFdx[li_di][A_di_Equ_fp1_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_fp1_di];
  dFdx[li_di][A_di_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] +d_staticContributions[admsNodeID_di][admsProbeID_V_gi_di];
  dFdx[li_di][A_di_Equ_s_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_s_di];
  dFdx[li_gi][A_gi_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_gi][admsProbeID_V_gi_di];
  dFdx[li_si][A_si_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_di_si];
if (!collapseNode_dt)
{
  dFdx[li_src][A_src_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_src][admsProbeID_Temp_dt_GND];
}
  dFdx[li_si][A_si_Equ_src_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_src_d] +d_staticContributions[admsNodeID_si][admsProbeID_V_src_s] -d_staticContributions[admsNodeID_si][admsProbeID_V_si_src];
  dFdx[li_src][A_src_Equ_si_NodeOffset] +=  +d_staticContributions[admsNodeID_src][admsProbeID_V_si_src];
  dFdx[li_src][A_src_Equ_src_NodeOffset] +=  +d_staticContributions[admsNodeID_src][admsProbeID_V_src_d] +d_staticContributions[admsNodeID_src][admsProbeID_V_src_s] -d_staticContributions[admsNodeID_src][admsProbeID_V_si_src];
  dFdx[li_src][A_src_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_src][admsProbeID_V_src_s];
  dFdx[li_si][A_si_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_si][admsProbeID_V_src_d];
  dFdx[li_src][A_src_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_src][admsProbeID_V_src_d];
  dFdx[li_drc][A_drc_Equ_drc_NodeOffset] +=  -d_staticContributions[admsNodeID_drc][admsProbeID_V_d_drc] +d_staticContributions[admsNodeID_drc][admsProbeID_V_drc_fp4];
  dFdx[li_drc][A_drc_Equ_fp4_NodeOffset] +=  +d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_d] +d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_drc][admsProbeID_V_drc_fp4];
  dFdx[li_fp4][A_fp4_Equ_drc_NodeOffset] +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_drc_fp4];
  dFdx[li_drc][A_drc_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_s];
  dFdx[li_drc][A_drc_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_drc][admsProbeID_V_d_drc] -d_staticContributions[admsNodeID_drc][admsProbeID_V_fp4_d];
  dFdx[li_fp4][A_fp4_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_fp4][admsProbeID_V_fp4_d];
if (!collapseNode_dt)
{
  dFdx[li_drc][A_drc_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_drc][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_tr)
{
  dFdx[li_drc][A_drc_Equ_tr_NodeOffset] +=  +d_staticContributions[admsNodeID_drc][admsProbeID_V_tr_GND];
}
if (!collapseNode_tr)
{
  dFdx[li_fp4][A_fp4_Equ_tr_NodeOffset] +=  +d_staticContributions[admsNodeID_fp4][admsProbeID_V_tr_GND];
}
  dFdx[li_di][A_di_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_di][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_di][admsProbeID_V_di_si];
if (!collapseNode_xt1)
{
if (!collapseNode_xt2)
{
  dFdx[li_xt1][A_xt1_Equ_xt2_NodeOffset] +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_V_xt2_GND];
}
}
if (!collapseNode_xt1)
{
if (!collapseNode_dt)
{
  dFdx[li_xt1][A_xt1_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_Temp_dt_GND];
}
}
if (!collapseNode_xt1)
{
  dFdx[li_xt1][A_xt1_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_V_di_si];
}
if (!collapseNode_xt1)
{
  dFdx[li_xt1][A_xt1_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_xt1][admsProbeID_V_di_si];
}
if (!collapseNode_xt1)
{
  dFdx[li_xt1][A_xt1_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_xt1][admsProbeID_V_gi_si];
}
if (!collapseNode_xt2)
{
  dFdx[li_xt2][A_xt2_Equ_xt2_NodeOffset] +=  +d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND];
}
if (!collapseNode_xt2)
{
if (!collapseNode_xt1)
{
  dFdx[li_xt2][A_xt2_Equ_xt1_NodeOffset] +=  +d_staticContributions[admsNodeID_xt2][admsProbeID_V_xt1_GND];
}
}
if (!collapseNode_xt2)
{
  dFdx[li_di][A_di_Equ_xt2_NodeOffset] +=  +d_staticContributions[admsNodeID_di][admsProbeID_V_xt2_GND];
}
if (!collapseNode_xt2)
{
  dFdx[li_si][A_si_Equ_xt2_NodeOffset] +=  +d_staticContributions[admsNodeID_si][admsProbeID_V_xt2_GND];
}
if (!collapseNode_dt)
{
  dFdx[li_d][A_d_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_Temp_dt_GND];
}
  dFdx[li_d][A_d_Equ_d_NodeOffset] +=  +d_staticContributions[admsNodeID_d][admsProbeID_V_d_drc];
  dFdx[li_d][A_d_Equ_drc_NodeOffset] +=  -d_staticContributions[admsNodeID_d][admsProbeID_V_d_drc];
  dFdx[li_s][A_s_Equ_src_NodeOffset] +=  +d_staticContributions[admsNodeID_s][admsProbeID_V_src_s];
  dFdx[li_g][A_g_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_g][admsProbeID_V_g_gi];
  dFdx[li_g][A_g_Equ_gi_NodeOffset] +=  -d_staticContributions[admsNodeID_g][admsProbeID_V_g_gi];
  dFdx[li_gi][A_gi_Equ_g_NodeOffset] +=  +d_staticContributions[admsNodeID_gi][admsProbeID_V_g_gi];
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_b_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_di] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp3];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_fp3_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp3] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp3] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_fp3] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp3];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_fp4_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_d] +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_fp4] +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_fp3];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_gi_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_si] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_di] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp3];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_s_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_s] -d_staticContributions[admsNodeID_dt][admsProbeID_V_src_s] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_di] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp1] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp2] +d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp3];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_fp2_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp3_fp2] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp2];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_fp1_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp2_fp1] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_fp1];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_di_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_di_si] -d_staticContributions[admsNodeID_dt][admsProbeID_V_s_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp1_di] -d_staticContributions[admsNodeID_dt][admsProbeID_V_b_di];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_si_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_gi_si] -d_staticContributions[admsNodeID_dt][admsProbeID_V_di_si] +d_staticContributions[admsNodeID_dt][admsProbeID_V_si_src];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_src_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_src_d] +d_staticContributions[admsNodeID_dt][admsProbeID_V_src_s] -d_staticContributions[admsNodeID_dt][admsProbeID_V_si_src];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_d_NodeOffset] +=  -d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_d] -d_staticContributions[admsNodeID_dt][admsProbeID_V_fp4_d] -d_staticContributions[admsNodeID_dt][admsProbeID_V_src_d];
}
if (!collapseNode_dt)
{
  dFdx[li_dt][A_dt_Equ_drc_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_d] +d_staticContributions[admsNodeID_dt][admsProbeID_V_drc_fp4];
}
if (!collapseNode_dt)
{
if (!collapseNode_tr)
{
  dFdx[li_dt][A_dt_Equ_tr_NodeOffset] +=  +d_staticContributions[admsNodeID_dt][admsProbeID_V_tr_GND];
}
}

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
if (!collapseNode_tr1)
{
  (*q_tr1_Equ_tr1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_tr1_tr];
}
if (!collapseNode_tr1)
{
if (!collapseNode_tr)
{
  (*q_tr1_Equ_tr_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_tr1_tr];
}
}
if (!collapseNode_tr)
{
if (!collapseNode_tr1)
{
  (*q_tr_Equ_tr1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr1_tr];
}
}
if (!collapseNode_tr)
{
  (*q_tr_Equ_tr_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr_GND] -d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr1_tr];
}
if (!collapseNode_dt)
{
  (*q_fp4_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_dt)
{
  (*q_fp3_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND];
}
  (*q_fp4_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  (*q_fp4_Equ_fp3_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  (*q_fp3_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  (*q_fp3_Equ_fp3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  (*q_fp4_Equ_fp4_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp4];
  (*q_fp3_Equ_fp4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3];
  (*q_fp4_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp4];
  (*q_fp3_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3];
  (*q_fp4_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp3];
  (*q_fp3_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  (*q_gi_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND];
}
  (*q_gi_Equ_b_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_b] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3];
  (*q_gi_Equ_fp3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3];
  (*q_gi_Equ_fp4_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp4] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3];
  (*q_gi_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_b] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_d] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp4] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3];
  (*q_gi_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  (*q_s_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND];
}
  (*q_s_Equ_b_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_b] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3];
  (*q_s_Equ_fp3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3];
  (*q_s_Equ_fp4_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3];
  (*q_s_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3];
  (*q_s_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_b] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3];
  (*q_gi_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si];
  (*q_si_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp3] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si];
  (*q_si_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si];
if (!collapseNode_dt)
{
  (*q_si_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND];
}
  (*q_si_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp3];
  (*q_si_Equ_fp3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp3];
  (*q_si_Equ_fp4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_fp3];
  (*q_si_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  (*q_b_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_dt_GND];
}
  (*q_b_Equ_b_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_b] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_b] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_b] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp3];
  (*q_b_Equ_fp3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp3];
  (*q_b_Equ_fp4_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_fp3];
  (*q_b_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_b] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp3];
  (*q_b_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_b] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  (*q_fp2_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND];
}
  (*q_fp3_Equ_fp2_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp2];
  (*q_fp2_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  (*q_fp2_Equ_fp2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  (*q_fp2_Equ_fp3_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2];
  (*q_fp2_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2];
  (*q_fp2_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2];
  (*q_gi_Equ_fp2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2];
  (*q_s_Equ_fp2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2];
  (*q_si_Equ_fp2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp2];
  (*q_b_Equ_fp2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp2];
if (!collapseNode_dt)
{
  (*q_fp1_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND];
}
  (*q_fp2_Equ_fp1_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp1];
  (*q_fp1_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  (*q_fp1_Equ_fp1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  (*q_fp1_Equ_fp2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1];
  (*q_fp1_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1];
  (*q_fp1_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1];
  (*q_gi_Equ_fp1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1];
  (*q_s_Equ_fp1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1];
  (*q_si_Equ_fp1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp1];
  (*q_b_Equ_fp1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp1];
if (!collapseNode_dt)
{
  (*q_di_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND];
}
  (*q_fp1_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_di];
  (*q_di_Equ_b_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di];
  (*q_di_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di];
  (*q_di_Equ_fp1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di];
  (*q_di_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di];
  (*q_di_Equ_s_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di];
  (*q_gi_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di];
  (*q_s_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di];
  (*q_si_Equ_di_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_di];
  (*q_b_Equ_di_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_di];
  (*q_di_Equ_si_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si];
if (!collapseNode_xt1)
{
  (*q_xt1_Equ_xt1_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_xt1_GND];
}
if (!collapseNode_xt2)
{
  (*q_xt2_Equ_xt2_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND];
}
  (*q_d_Equ_d_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_b] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_d];
  (*q_gi_Equ_d_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_d];
  (*q_d_Equ_gi_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_d];
  (*q_d_Equ_s_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s];
  (*q_s_Equ_d_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s];
  (*q_d_Equ_b_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_b];
  (*q_b_Equ_d_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_b];
if (!collapseNode_dt)
{
  (*q_dt_Equ_dt_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND];
}

#else
  //use the offsets instead of pointers
if (!collapseNode_tr1)
{
  dQdx[li_tr1][A_tr1_Equ_tr1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_tr1_tr];
}
if (!collapseNode_tr1)
{
if (!collapseNode_tr)
{
  dQdx[li_tr1][A_tr1_Equ_tr_NodeOffset] +=  -d_dynamicContributions[admsNodeID_tr1][admsProbeID_V_tr1_tr];
}
}
if (!collapseNode_tr)
{
if (!collapseNode_tr1)
{
  dQdx[li_tr][A_tr_Equ_tr1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr1_tr];
}
}
if (!collapseNode_tr)
{
  dQdx[li_tr][A_tr_Equ_tr_NodeOffset] +=  +d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr_GND] -d_dynamicContributions[admsNodeID_tr][admsProbeID_V_tr1_tr];
}
if (!collapseNode_dt)
{
  dQdx[li_fp4][A_fp4_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_Temp_dt_GND];
}
if (!collapseNode_dt)
{
  dQdx[li_fp3][A_fp3_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_Temp_dt_GND];
}
  dQdx[li_fp4][A_fp4_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  dQdx[li_fp4][A_fp4_Equ_fp3_NodeOffset] +=  -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_b_fp3];
  dQdx[li_fp3][A_fp3_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  dQdx[li_fp3][A_fp3_Equ_fp3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp3];
  dQdx[li_fp4][A_fp4_Equ_fp4_NodeOffset] +=  -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp4];
  dQdx[li_fp3][A_fp3_Equ_fp4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp4_fp3];
  dQdx[li_fp4][A_fp4_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp3] +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_gi_fp4];
  dQdx[li_fp3][A_fp3_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp3];
  dQdx[li_fp4][A_fp4_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_fp4][admsProbeID_V_s_fp3];
  dQdx[li_fp3][A_fp3_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  dQdx[li_gi][A_gi_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_Temp_dt_GND];
}
  dQdx[li_gi][A_gi_Equ_b_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_b] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3];
  dQdx[li_gi][A_gi_Equ_fp3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp3];
  dQdx[li_gi][A_gi_Equ_fp4_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp4] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp4_fp3];
  dQdx[li_gi][A_gi_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_b] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_d] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp4] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp3];
  dQdx[li_gi][A_gi_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  dQdx[li_s][A_s_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_Temp_dt_GND];
}
  dQdx[li_s][A_s_Equ_b_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_b] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3];
  dQdx[li_s][A_s_Equ_fp3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp3];
  dQdx[li_s][A_s_Equ_fp4_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp4_fp3];
  dQdx[li_s][A_s_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp3];
  dQdx[li_s][A_s_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_b] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_s] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp4] +d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp3];
  dQdx[li_gi][A_gi_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_si];
  dQdx[li_si][A_si_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp3] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si];
  dQdx[li_si][A_si_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_si];
if (!collapseNode_dt)
{
  dQdx[li_si][A_si_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_Temp_dt_GND];
}
  dQdx[li_si][A_si_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp3];
  dQdx[li_si][A_si_Equ_fp3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp3];
  dQdx[li_si][A_si_Equ_fp4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp4_fp3];
  dQdx[li_si][A_si_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  dQdx[li_b][A_b_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_Temp_dt_GND];
}
  dQdx[li_b][A_b_Equ_b_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_b] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_b] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_b] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp3];
  dQdx[li_b][A_b_Equ_fp3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp3] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp3] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_fp3] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp3];
  dQdx[li_b][A_b_Equ_fp4_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp4_fp3];
  dQdx[li_b][A_b_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_b] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp3];
  dQdx[li_b][A_b_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_b] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp2] +d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp3];
if (!collapseNode_dt)
{
  dQdx[li_fp2][A_fp2_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_Temp_dt_GND];
}
  dQdx[li_fp3][A_fp3_Equ_fp2_NodeOffset] +=  -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_fp3][admsProbeID_V_b_fp2];
  dQdx[li_fp2][A_fp2_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp1] +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  dQdx[li_fp2][A_fp2_Equ_fp2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp2];
  dQdx[li_fp2][A_fp2_Equ_fp3_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp3_fp2];
  dQdx[li_fp2][A_fp2_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp2];
  dQdx[li_fp2][A_fp2_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] +d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp2];
  dQdx[li_gi][A_gi_Equ_fp2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp2];
  dQdx[li_s][A_s_Equ_fp2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp2];
  dQdx[li_si][A_si_Equ_fp2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp2];
  dQdx[li_b][A_b_Equ_fp2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp3_fp2] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp2];
if (!collapseNode_dt)
{
  dQdx[li_fp1][A_fp1_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_Temp_dt_GND];
}
  dQdx[li_fp2][A_fp2_Equ_fp1_NodeOffset] +=  -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_fp2][admsProbeID_V_b_fp1];
  dQdx[li_fp1][A_fp1_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_di] +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  dQdx[li_fp1][A_fp1_Equ_fp1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_fp1];
  dQdx[li_fp1][A_fp1_Equ_fp2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp2_fp1];
  dQdx[li_fp1][A_fp1_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_di] +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_fp1];
  dQdx[li_fp1][A_fp1_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_di] +d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_fp1];
  dQdx[li_gi][A_gi_Equ_fp1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_fp1];
  dQdx[li_s][A_s_Equ_fp1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_fp1];
  dQdx[li_si][A_si_Equ_fp1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_fp1];
  dQdx[li_b][A_b_Equ_fp1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp2_fp1] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_fp1];
if (!collapseNode_dt)
{
  dQdx[li_di][A_di_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_Temp_dt_GND];
}
  dQdx[li_fp1][A_fp1_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_fp1][admsProbeID_V_b_di];
  dQdx[li_di][A_di_Equ_b_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di];
  dQdx[li_di][A_di_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_b_di];
  dQdx[li_di][A_di_Equ_fp1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_fp1_di];
  dQdx[li_di][A_di_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_si] +d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_di];
  dQdx[li_di][A_di_Equ_s_NodeOffset] +=  +d_dynamicContributions[admsNodeID_di][admsProbeID_V_s_di];
  dQdx[li_gi][A_gi_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_gi][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_b_di];
  dQdx[li_s][A_s_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_s][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_s][admsProbeID_V_b_di];
  dQdx[li_si][A_si_Equ_di_NodeOffset] +=  +d_dynamicContributions[admsNodeID_si][admsProbeID_V_di_si] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_si][admsProbeID_V_b_di];
  dQdx[li_b][A_b_Equ_di_NodeOffset] +=  -d_dynamicContributions[admsNodeID_b][admsProbeID_V_s_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_gi_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_fp1_di] -d_dynamicContributions[admsNodeID_b][admsProbeID_V_b_di];
  dQdx[li_di][A_di_Equ_si_NodeOffset] +=  -d_dynamicContributions[admsNodeID_di][admsProbeID_V_gi_si] -d_dynamicContributions[admsNodeID_di][admsProbeID_V_di_si];
if (!collapseNode_xt1)
{
  dQdx[li_xt1][A_xt1_Equ_xt1_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xt1][admsProbeID_V_xt1_GND];
}
if (!collapseNode_xt2)
{
  dQdx[li_xt2][A_xt2_Equ_xt2_NodeOffset] +=  +d_dynamicContributions[admsNodeID_xt2][admsProbeID_V_xt2_GND];
}
  dQdx[li_d][A_d_Equ_d_NodeOffset] +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_b] +d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s] -d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_d];
  dQdx[li_gi][A_gi_Equ_d_NodeOffset] +=  -d_dynamicContributions[admsNodeID_gi][admsProbeID_V_gi_d];
  dQdx[li_d][A_d_Equ_gi_NodeOffset] +=  +d_dynamicContributions[admsNodeID_d][admsProbeID_V_gi_d];
  dQdx[li_d][A_d_Equ_s_NodeOffset] +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_s];
  dQdx[li_s][A_s_Equ_d_NodeOffset] +=  +d_dynamicContributions[admsNodeID_s][admsProbeID_V_d_s];
  dQdx[li_d][A_d_Equ_b_NodeOffset] +=  -d_dynamicContributions[admsNodeID_d][admsProbeID_V_d_b];
  dQdx[li_b][A_b_Equ_d_NodeOffset] +=  +d_dynamicContributions[admsNodeID_b][admsProbeID_V_d_b];
if (!collapseNode_dt)
{
  dQdx[li_dt][A_dt_Equ_dt_NodeOffset] +=  +d_dynamicContributions[admsNodeID_dt][admsProbeID_Temp_dt_GND];
}


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

// set internal model type based on model card type
if (getType() == "pmos" || getType() == "PMOS")
    type = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter version : [ 0,  (+inf) [
  if ( (!((version >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter version value " << version << " out of range [ 0,  (+inf) [";
  }

//    Parameter tnom : [ (-273.15),  (+inf) [
  if ( (!((tnom >=(-273.15)))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter tnom value " << tnom << " out of range [ (-273.15),  (+inf) [";
  }

//    Parameter type : [ (-1), 1 ]] 0, 0 [
  if ( (!((type >=(-1) && type <=1 )) || (type >0 && type <0 )) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter type value " << type << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

//    Parameter cg : ] 0,  (+inf) [
  if ( (!((cg >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cg value " << cg << " out of range ] 0,  (+inf) [";
  }

//    Parameter cofsm : [ 0,  (+inf) [
  if ( (!((cofsm >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cofsm value " << cofsm << " out of range [ 0,  (+inf) [";
  }

//    Parameter cofdm : [ 0,  (+inf) [
  if ( (!((cofdm >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cofdm value " << cofdm << " out of range [ 0,  (+inf) [";
  }

//    Parameter cofdsm : [ 0,  (+inf) [
  if ( (!((cofdsm >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cofdsm value " << cofdsm << " out of range [ 0,  (+inf) [";
  }

//    Parameter cofdsubm : [ 0,  (+inf) [
  if ( (!((cofdsubm >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cofdsubm value " << cofdsubm << " out of range [ 0,  (+inf) [";
  }

//    Parameter cofssubm : [ 0,  (+inf) [
  if ( (!((cofssubm >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cofssubm value " << cofssubm << " out of range [ 0,  (+inf) [";
  }

//    Parameter cofgsubm : [ 0,  (+inf) [
  if ( (!((cofgsubm >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cofgsubm value " << cofgsubm << " out of range [ 0,  (+inf) [";
  }

//    Parameter rsh : [ 0,  (+inf) [
  if ( (!((rsh >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter rsh value " << rsh << " out of range [ 0,  (+inf) [";
  }

//    Parameter rcs : [ 0,  (+inf) [
  if ( (!((rcs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter rcs value " << rcs << " out of range [ 0,  (+inf) [";
  }

//    Parameter rcd : [ 0,  (+inf) [
  if ( (!((rcd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter rcd value " << rcd << " out of range [ 0,  (+inf) [";
  }

//    Parameter vx0 : ] 0,  (+inf) [
  if ( (!((vx0 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vx0 value " << vx0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter mu0 : ] 0,  (+inf) [
  if ( (!((mu0 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mu0 value " << mu0 << " out of range ] 0,  (+inf) [";
  }

//    Parameter beta : ] 0,  (+inf) [
  if ( (!((beta >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter beta value " << beta << " out of range ] 0,  (+inf) [";
  }

//    Parameter ss : ] 0,  (+inf) [
  if ( (!((ss >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ss value " << ss << " out of range ] 0,  (+inf) [";
  }

//    Parameter delta1 : [ 0,  (+inf) [
  if ( (!((delta1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta1 value " << delta1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter delta2 : [ 0,  (+inf) [
  if ( (!((delta2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta2 value " << delta2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter dibsat : [ 0,  (+inf) [
  if ( (!((dibsat >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter dibsat value " << dibsat << " out of range [ 0,  (+inf) [";
  }

//    Parameter nd : [ 0,  (+inf) [
  if ( (!((nd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter nd value " << nd << " out of range [ 0,  (+inf) [";
  }

//    Parameter alpha : ] 0,  (+inf) [
  if ( (!((alpha >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alpha value " << alpha << " out of range ] 0,  (+inf) [";
  }

//    Parameter lambda : [ 0,  (+inf) [
  if ( (!((lambda >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter lambda value " << lambda << " out of range [ 0,  (+inf) [";
  }

//    Parameter vtheta : [ 0,  (+inf) [
  if ( (!((vtheta >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vtheta value " << vtheta << " out of range [ 0,  (+inf) [";
  }

//    Parameter mtheta : [ 0,  (+inf) [
  if ( (!((mtheta >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mtheta value " << mtheta << " out of range [ 0,  (+inf) [";
  }

//    Parameter vzeta : [ 0,  (+inf) [
  if ( (!((vzeta >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vzeta value " << vzeta << " out of range [ 0,  (+inf) [";
  }

//    Parameter epsilon : [ 0,  (+inf) [
  if ( (!((epsilon >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter epsilon value " << epsilon << " out of range [ 0,  (+inf) [";
  }

//    Parameter flagres : [ 0, 1 ]
  if ( (!((flagres >=0 && flagres <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagres value " << flagres << " out of range [ 0, 1 ]";
  }

//    Parameter lgs : [ 0,  (+inf) [
  if ( (!((lgs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter lgs value " << lgs << " out of range [ 0,  (+inf) [";
  }

//    Parameter cgrs : ] 0,  (+inf) [
  if ( (!((cgrs >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cgrs value " << cgrs << " out of range ] 0,  (+inf) [";
  }

//    Parameter vx0rs : ] 0,  (+inf) [
  if ( (!((vx0rs >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vx0rs value " << vx0rs << " out of range ] 0,  (+inf) [";
  }

//    Parameter mu0rs : ] 0,  (+inf) [
  if ( (!((mu0rs >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mu0rs value " << mu0rs << " out of range ] 0,  (+inf) [";
  }

//    Parameter betars : ] 0,  (+inf) [
  if ( (!((betars >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betars value " << betars << " out of range ] 0,  (+inf) [";
  }

//    Parameter delta1rs : [ 0,  (+inf) [
  if ( (!((delta1rs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta1rs value " << delta1rs << " out of range [ 0,  (+inf) [";
  }

//    Parameter srs : ] 0,  (+inf) [
  if ( (!((srs >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter srs value " << srs << " out of range ] 0,  (+inf) [";
  }

//    Parameter ndrs : [ 0,  (+inf) [
  if ( (!((ndrs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ndrs value " << ndrs << " out of range [ 0,  (+inf) [";
  }

//    Parameter vthetars : [ 0,  (+inf) [
  if ( (!((vthetars >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vthetars value " << vthetars << " out of range [ 0,  (+inf) [";
  }

//    Parameter mthetars : [ 0,  (+inf) [
  if ( (!((mthetars >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mthetars value " << mthetars << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphars : ] 0,  (+inf) [
  if ( (!((alphars >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphars value " << alphars << " out of range ] 0,  (+inf) [";
  }

//    Parameter lgd : [ 0,  (+inf) [
  if ( (!((lgd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter lgd value " << lgd << " out of range [ 0,  (+inf) [";
  }

//    Parameter cgrd : ] 0,  (+inf) [
  if ( (!((cgrd >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cgrd value " << cgrd << " out of range ] 0,  (+inf) [";
  }

//    Parameter vx0rd : ] 0,  (+inf) [
  if ( (!((vx0rd >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vx0rd value " << vx0rd << " out of range ] 0,  (+inf) [";
  }

//    Parameter mu0rd : ] 0,  (+inf) [
  if ( (!((mu0rd >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mu0rd value " << mu0rd << " out of range ] 0,  (+inf) [";
  }

//    Parameter betard : ] 0,  (+inf) [
  if ( (!((betard >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betard value " << betard << " out of range ] 0,  (+inf) [";
  }

//    Parameter delta1rd : [ 0,  (+inf) [
  if ( (!((delta1rd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta1rd value " << delta1rd << " out of range [ 0,  (+inf) [";
  }

//    Parameter srd : ] 0,  (+inf) [
  if ( (!((srd >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter srd value " << srd << " out of range ] 0,  (+inf) [";
  }

//    Parameter ndrd : [ 0,  (+inf) [
  if ( (!((ndrd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ndrd value " << ndrd << " out of range [ 0,  (+inf) [";
  }

//    Parameter vthetard : [ 0,  (+inf) [
  if ( (!((vthetard >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vthetard value " << vthetard << " out of range [ 0,  (+inf) [";
  }

//    Parameter mthetard : [ 0,  (+inf) [
  if ( (!((mthetard >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mthetard value " << mthetard << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphard : ] 0,  (+inf) [
  if ( (!((alphard >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphard value " << alphard << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp1 : [ 0, 1 ]
  if ( (!((flagfp1 >=0 && flagfp1 <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp1 value " << flagfp1 << " out of range [ 0, 1 ]";
  }

//    Parameter lgfp1 : [ 0,  (+inf) [
  if ( (!((lgfp1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter lgfp1 value " << lgfp1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cgfp1 : ] 0,  (+inf) [
  if ( (!((cgfp1 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cgfp1 value " << cgfp1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp1s : [ 0, 1 ]
  if ( (!((flagfp1s >=0 && flagfp1s <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp1s value " << flagfp1s << " out of range [ 0, 1 ]";
  }

//    Parameter cfp1s : [ 0,  (+inf) [
  if ( (!((cfp1s >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cfp1s value " << cfp1s << " out of range [ 0,  (+inf) [";
  }

//    Parameter ccfp1 : [ 0,  (+inf) [
  if ( (!((ccfp1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ccfp1 value " << ccfp1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cbfp1 : [ 0,  (+inf) [
  if ( (!((cbfp1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cbfp1 value " << cbfp1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vx0fp1 : ] 0,  (+inf) [
  if ( (!((vx0fp1 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vx0fp1 value " << vx0fp1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter mu0fp1 : ] 0,  (+inf) [
  if ( (!((mu0fp1 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mu0fp1 value " << mu0fp1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter betafp1 : ] 0,  (+inf) [
  if ( (!((betafp1 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betafp1 value " << betafp1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter delta1fp1 : [ 0,  (+inf) [
  if ( (!((delta1fp1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta1fp1 value " << delta1fp1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter sfp1 : ] 0,  (+inf) [
  if ( (!((sfp1 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter sfp1 value " << sfp1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter ndfp1 : [ 0,  (+inf) [
  if ( (!((ndfp1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ndfp1 value " << ndfp1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vthetafp1 : [ 0,  (+inf) [
  if ( (!((vthetafp1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vthetafp1 value " << vthetafp1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter mthetafp1 : [ 0,  (+inf) [
  if ( (!((mthetafp1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mthetafp1 value " << mthetafp1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphafp1 : ] 0,  (+inf) [
  if ( (!((alphafp1 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphafp1 value " << alphafp1 << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp2 : [ 0, 1 ]
  if ( (!((flagfp2 >=0 && flagfp2 <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp2 value " << flagfp2 << " out of range [ 0, 1 ]";
  }

//    Parameter lgfp2 : [ 0,  (+inf) [
  if ( (!((lgfp2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter lgfp2 value " << lgfp2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cgfp2 : ] 0,  (+inf) [
  if ( (!((cgfp2 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cgfp2 value " << cgfp2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp2s : [ 0, 1 ]
  if ( (!((flagfp2s >=0 && flagfp2s <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp2s value " << flagfp2s << " out of range [ 0, 1 ]";
  }

//    Parameter cfp2s : [ 0,  (+inf) [
  if ( (!((cfp2s >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cfp2s value " << cfp2s << " out of range [ 0,  (+inf) [";
  }

//    Parameter ccfp2 : [ 0,  (+inf) [
  if ( (!((ccfp2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ccfp2 value " << ccfp2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cbfp2 : [ 0,  (+inf) [
  if ( (!((cbfp2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cbfp2 value " << cbfp2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vx0fp2 : ] 0,  (+inf) [
  if ( (!((vx0fp2 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vx0fp2 value " << vx0fp2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter mu0fp2 : ] 0,  (+inf) [
  if ( (!((mu0fp2 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mu0fp2 value " << mu0fp2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter betafp2 : ] 0,  (+inf) [
  if ( (!((betafp2 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betafp2 value " << betafp2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter delta1fp2 : [ 0,  (+inf) [
  if ( (!((delta1fp2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta1fp2 value " << delta1fp2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter sfp2 : ] 0,  (+inf) [
  if ( (!((sfp2 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter sfp2 value " << sfp2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter ndfp2 : [ 0,  (+inf) [
  if ( (!((ndfp2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ndfp2 value " << ndfp2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vthetafp2 : [ 0,  (+inf) [
  if ( (!((vthetafp2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vthetafp2 value " << vthetafp2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter mthetafp2 : [ 0,  (+inf) [
  if ( (!((mthetafp2 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mthetafp2 value " << mthetafp2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphafp2 : ] 0,  (+inf) [
  if ( (!((alphafp2 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphafp2 value " << alphafp2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp3 : [ 0, 1 ]
  if ( (!((flagfp3 >=0 && flagfp3 <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp3 value " << flagfp3 << " out of range [ 0, 1 ]";
  }

//    Parameter lgfp3 : [ 0,  (+inf) [
  if ( (!((lgfp3 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter lgfp3 value " << lgfp3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cgfp3 : ] 0,  (+inf) [
  if ( (!((cgfp3 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cgfp3 value " << cgfp3 << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp3s : [ 0, 1 ]
  if ( (!((flagfp3s >=0 && flagfp3s <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp3s value " << flagfp3s << " out of range [ 0, 1 ]";
  }

//    Parameter cfp3s : [ 0,  (+inf) [
  if ( (!((cfp3s >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cfp3s value " << cfp3s << " out of range [ 0,  (+inf) [";
  }

//    Parameter ccfp3 : [ 0,  (+inf) [
  if ( (!((ccfp3 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ccfp3 value " << ccfp3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cbfp3 : [ 0,  (+inf) [
  if ( (!((cbfp3 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cbfp3 value " << cbfp3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vx0fp3 : ] 0,  (+inf) [
  if ( (!((vx0fp3 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vx0fp3 value " << vx0fp3 << " out of range ] 0,  (+inf) [";
  }

//    Parameter mu0fp3 : ] 0,  (+inf) [
  if ( (!((mu0fp3 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mu0fp3 value " << mu0fp3 << " out of range ] 0,  (+inf) [";
  }

//    Parameter betafp3 : ] 0,  (+inf) [
  if ( (!((betafp3 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betafp3 value " << betafp3 << " out of range ] 0,  (+inf) [";
  }

//    Parameter delta1fp3 : [ 0,  (+inf) [
  if ( (!((delta1fp3 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta1fp3 value " << delta1fp3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter sfp3 : ] 0,  (+inf) [
  if ( (!((sfp3 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter sfp3 value " << sfp3 << " out of range ] 0,  (+inf) [";
  }

//    Parameter ndfp3 : [ 0,  (+inf) [
  if ( (!((ndfp3 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ndfp3 value " << ndfp3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vthetafp3 : [ 0,  (+inf) [
  if ( (!((vthetafp3 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vthetafp3 value " << vthetafp3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter mthetafp3 : [ 0,  (+inf) [
  if ( (!((mthetafp3 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mthetafp3 value " << mthetafp3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphafp3 : ] 0,  (+inf) [
  if ( (!((alphafp3 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphafp3 value " << alphafp3 << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp4 : [ 0, 1 ]
  if ( (!((flagfp4 >=0 && flagfp4 <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp4 value " << flagfp4 << " out of range [ 0, 1 ]";
  }

//    Parameter lgfp4 : [ 0,  (+inf) [
  if ( (!((lgfp4 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter lgfp4 value " << lgfp4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cgfp4 : ] 0,  (+inf) [
  if ( (!((cgfp4 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cgfp4 value " << cgfp4 << " out of range ] 0,  (+inf) [";
  }

//    Parameter flagfp4s : [ 0, 1 ]
  if ( (!((flagfp4s >=0 && flagfp4s <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter flagfp4s value " << flagfp4s << " out of range [ 0, 1 ]";
  }

//    Parameter cfp4s : [ 0,  (+inf) [
  if ( (!((cfp4s >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cfp4s value " << cfp4s << " out of range [ 0,  (+inf) [";
  }

//    Parameter ccfp4 : [ 0,  (+inf) [
  if ( (!((ccfp4 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ccfp4 value " << ccfp4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter cbfp4 : [ 0,  (+inf) [
  if ( (!((cbfp4 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cbfp4 value " << cbfp4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vx0fp4 : ] 0,  (+inf) [
  if ( (!((vx0fp4 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vx0fp4 value " << vx0fp4 << " out of range ] 0,  (+inf) [";
  }

//    Parameter mu0fp4 : ] 0,  (+inf) [
  if ( (!((mu0fp4 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mu0fp4 value " << mu0fp4 << " out of range ] 0,  (+inf) [";
  }

//    Parameter betafp4 : ] 0,  (+inf) [
  if ( (!((betafp4 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betafp4 value " << betafp4 << " out of range ] 0,  (+inf) [";
  }

//    Parameter delta1fp4 : [ 0,  (+inf) [
  if ( (!((delta1fp4 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter delta1fp4 value " << delta1fp4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter sfp4 : ] 0,  (+inf) [
  if ( (!((sfp4 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter sfp4 value " << sfp4 << " out of range ] 0,  (+inf) [";
  }

//    Parameter ndfp4 : [ 0,  (+inf) [
  if ( (!((ndfp4 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ndfp4 value " << ndfp4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter vthetafp4 : [ 0,  (+inf) [
  if ( (!((vthetafp4 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vthetafp4 value " << vthetafp4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter mthetafp4 : [ 0,  (+inf) [
  if ( (!((mthetafp4 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter mthetafp4 value " << mthetafp4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphafp4 : ] 0,  (+inf) [
  if ( (!((alphafp4 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphafp4 value " << alphafp4 << " out of range ] 0,  (+inf) [";
  }

//    Parameter igmod : [ 0, 1 ]
  if ( (!((igmod >=0 && igmod <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter igmod value " << igmod << " out of range [ 0, 1 ]";
  }

//    Parameter rgsp : [ 0,  (+inf) [
  if ( (!((rgsp >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter rgsp value " << rgsp << " out of range [ 0,  (+inf) [";
  }

//    Parameter vjg : ] 0,  (+inf) [
  if ( (!((vjg >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vjg value " << vjg << " out of range ] 0,  (+inf) [";
  }

//    Parameter pg_param1 : [ 0,  (+inf) [
  if ( (!((pg_param1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter pg_param1 value " << pg_param1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter pg_params : [ 0,  (+inf) [
  if ( (!((pg_params >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter pg_params value " << pg_params << " out of range [ 0,  (+inf) [";
  }

//    Parameter ijs : [ 0,  (+inf) [
  if ( (!((ijs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ijs value " << ijs << " out of range [ 0,  (+inf) [";
  }

//    Parameter vgsats : [ 0,  (+inf) [
  if ( (!((vgsats >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vgsats value " << vgsats << " out of range [ 0,  (+inf) [";
  }

//    Parameter fracs : [ 0,  (+inf) [
  if ( (!((fracs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter fracs value " << fracs << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphags : ] 0,  (+inf) [
  if ( (!((alphags >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphags value " << alphags << " out of range ] 0,  (+inf) [";
  }

//    Parameter pg_paramd : [ 0,  (+inf) [
  if ( (!((pg_paramd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter pg_paramd value " << pg_paramd << " out of range [ 0,  (+inf) [";
  }

//    Parameter ijd : [ 0,  (+inf) [
  if ( (!((ijd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ijd value " << ijd << " out of range [ 0,  (+inf) [";
  }

//    Parameter vgsatd : [ 0,  (+inf) [
  if ( (!((vgsatd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vgsatd value " << vgsatd << " out of range [ 0,  (+inf) [";
  }

//    Parameter fracd : [ 0,  (+inf) [
  if ( (!((fracd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter fracd value " << fracd << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphagd : ] 0,  (+inf) [
  if ( (!((alphagd >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphagd value " << alphagd << " out of range ] 0,  (+inf) [";
  }

//    Parameter pgsrecs : [ 0,  (+inf) [
  if ( (!((pgsrecs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter pgsrecs value " << pgsrecs << " out of range [ 0,  (+inf) [";
  }

//    Parameter irecs : [ 0,  (+inf) [
  if ( (!((irecs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter irecs value " << irecs << " out of range [ 0,  (+inf) [";
  }

//    Parameter vgsatqs : ] 0,  (+inf) [
  if ( (!((vgsatqs >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vgsatqs value " << vgsatqs << " out of range ] 0,  (+inf) [";
  }

//    Parameter vbdgs : [ 0,  (+inf) [
  if ( (!((vbdgs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vbdgs value " << vbdgs << " out of range [ 0,  (+inf) [";
  }

//    Parameter pbdgs : [ 0,  (+inf) [
  if ( (!((pbdgs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter pbdgs value " << pbdgs << " out of range [ 0,  (+inf) [";
  }

//    Parameter betarecs : ] 0,  (+inf) [
  if ( (!((betarecs >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betarecs value " << betarecs << " out of range ] 0,  (+inf) [";
  }

//    Parameter kbdgates : [ 0,  (+inf) [
  if ( (!((kbdgates >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter kbdgates value " << kbdgates << " out of range [ 0,  (+inf) [";
  }

//    Parameter pgsrecd : [ 0,  (+inf) [
  if ( (!((pgsrecd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter pgsrecd value " << pgsrecd << " out of range [ 0,  (+inf) [";
  }

//    Parameter irecd : [ 0,  (+inf) [
  if ( (!((irecd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter irecd value " << irecd << " out of range [ 0,  (+inf) [";
  }

//    Parameter vgsatqd : ] 0,  (+inf) [
  if ( (!((vgsatqd >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vgsatqd value " << vgsatqd << " out of range ] 0,  (+inf) [";
  }

//    Parameter vbdgd : [ 0,  (+inf) [
  if ( (!((vbdgd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vbdgd value " << vbdgd << " out of range [ 0,  (+inf) [";
  }

//    Parameter pbdgd : [ 0,  (+inf) [
  if ( (!((pbdgd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter pbdgd value " << pbdgd << " out of range [ 0,  (+inf) [";
  }

//    Parameter betarecd : ] 0,  (+inf) [
  if ( (!((betarecd >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter betarecd value " << betarecd << " out of range ] 0,  (+inf) [";
  }

//    Parameter kbdgated : [ 0,  (+inf) [
  if ( (!((kbdgated >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter kbdgated value " << kbdgated << " out of range [ 0,  (+inf) [";
  }

//    Parameter rth : [ 0,  (+inf) [
  if ( (!((rth >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter rth value " << rth << " out of range [ 0,  (+inf) [";
  }

//    Parameter cth : [ 0,  (+inf) [
  if ( (!((cth >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter cth value " << cth << " out of range [ 0,  (+inf) [";
  }

//    Parameter gmdisp : [ 0, 1 ]
  if ( (!((gmdisp >=0 && gmdisp <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter gmdisp value " << gmdisp << " out of range [ 0, 1 ]";
  }

//    Parameter taugmrf : [ 0,  (+inf) [
  if ( (!((taugmrf >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter taugmrf value " << taugmrf << " out of range [ 0,  (+inf) [";
  }

//    Parameter trapselect : [ 0, 1 ]
  if ( (!((trapselect >=0 && trapselect <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter trapselect value " << trapselect << " out of range [ 0, 1 ]";
  }

//    Parameter ctrap : [ 0,  (+inf) [
  if ( (!((ctrap >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ctrap value " << ctrap << " out of range [ 0,  (+inf) [";
  }

//    Parameter vttrap : [ 0,  (+inf) [
  if ( (!((vttrap >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter vttrap value " << vttrap << " out of range [ 0,  (+inf) [";
  }

//    Parameter taut : [ 0,  (+inf) [
  if ( (!((taut >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter taut value " << taut << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphat1 : [ 0,  (+inf) [
  if ( (!((alphat1 >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphat1 value " << alphat1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter alphat2 : ] 0,  (+inf) [
  if ( (!((alphat2 >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter alphat2 value " << alphat2 << " out of range ] 0,  (+inf) [";
  }

//    Parameter tempt : [ 0,  (+inf) [
  if ( (!((tempt >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter tempt value " << tempt << " out of range [ 0,  (+inf) [";
  }

//    Parameter noisemod : [ 0, 1 ]
  if ( (!((noisemod >=0 && noisemod <=1 ))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter noisemod value " << noisemod << " out of range [ 0, 1 ]";
  }

//    Parameter shs : [ 0,  (+inf) [
  if ( (!((shs >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter shs value " << shs << " out of range [ 0,  (+inf) [";
  }

//    Parameter shd : [ 0,  (+inf) [
  if ( (!((shd >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter shd value " << shd << " out of range [ 0,  (+inf) [";
  }

//    Parameter kf : [ 0,  (+inf) [
  if ( (!((kf >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter kf value " << kf << " out of range [ 0,  (+inf) [";
  }

//    Parameter af : [ 0,  (+inf) [
  if ( (!((af >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter af value " << af << " out of range [ 0,  (+inf) [";
  }

//    Parameter ffe : ] 0,  (+inf) [
  if ( (!((ffe >0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter ffe value " << ffe << " out of range ] 0,  (+inf) [";
  }

//    Parameter minr : [ 0,  (+inf) [
  if ( (!((minr >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter minr value " << minr << " out of range [ 0,  (+inf) [";
  }

//    Parameter minl : [ 0,  (+inf) [
  if ( (!((minl >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter minl value " << minl << " out of range [ 0,  (+inf) [";
  }

//    Parameter minc : [ 0,  (+inf) [
  if ( (!((minc >=0))) )
  {
    UserWarning(*this) << "ADMSmvsg_cmc: Parameter minc value " << minc << " out of range [ 0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    version(1.00),
    tnom(27.0),
    type(1),
    cg(4.00e-03),
    cofsm(1.0e-9),
    cofdm(1.0e-10),
    cofdsm(1.0e-10),
    cofdsubm(0.0),
    cofssubm(0.0),
    cofgsubm(0.0),
    rsh(150.0),
    rcs(800e-6),
    rcd(800e-6),
    vx0(3.0e5),
    mu0(0.135),
    beta(1.50),
    vto((-2.72)),
    ss(0.120),
    delta1(16e-3),
    delta2(0.0),
    dibsat(10.0),
    nd(0.0),
    alpha(3.5),
    lambda(0.0),
    vtheta(0.0),
    mtheta(0.0),
    vzeta(150e3),
    vtzeta((-0.4e-3)),
    epsilon(2.3),
    rct1(0.0),
    rct2(0.0),
    flagres(0),
    lgs(3.0e-6),
    vtors((-650)),
    cgrs(5.0e-3),
    vx0rs(100e3),
    mu0rs(100e-3),
    betars(1.00),
    delta1rs(100e-3),
    srs(0.100),
    ndrs(0.0),
    vthetars(0.0),
    mthetars(0.0),
    alphars(3.5),
    lgd(4.85e-6),
    vtord((-650)),
    cgrd(4.3e-3),
    vx0rd(100e3),
    mu0rd(100e-3),
    betard(1.00),
    delta1rd(0.35),
    srd(0.3),
    ndrd(3.8),
    vthetard(0.0),
    mthetard(0.0),
    alphard(3.5),
    flagfp1(1),
    lgfp1(0.0),
    vtofp1((-44.5)),
    cgfp1(2.0e-4),
    flagfp1s(1),
    cfp1s(1e-19),
    ccfp1(0.9e-10),
    cbfp1(0.0),
    vx0fp1(1.2e5),
    mu0fp1(0.2),
    betafp1(1.00),
    delta1fp1(0.0),
    sfp1(3.2),
    ndfp1(0.0),
    vthetafp1(0.0),
    mthetafp1(0.0),
    alphafp1(1e-2),
    flagfp2(0),
    lgfp2(0.0),
    vtofp2((-74.5)),
    cgfp2(1.0e-4),
    flagfp2s(1),
    cfp2s(1e-19),
    ccfp2(0.3e-10),
    cbfp2(0.0),
    vx0fp2(1.2e5),
    mu0fp2(0.2),
    betafp2(1.00),
    delta1fp2(0.0),
    sfp2(3.2),
    ndfp2(0.0),
    vthetafp2(0.0),
    mthetafp2(0.0),
    alphafp2(1e-2),
    flagfp3(0),
    lgfp3(0.0),
    vtofp3((-44.5)),
    cgfp3(2.0e-4),
    flagfp3s(1),
    cfp3s(1e-19),
    ccfp3(0.9e-10),
    cbfp3(0.0),
    vx0fp3(1.2e5),
    mu0fp3(0.2),
    betafp3(1.00),
    delta1fp3(0.0),
    sfp3(3.2),
    ndfp3(0.0),
    vthetafp3(0.0),
    mthetafp3(0.0),
    alphafp3(1e-2),
    flagfp4(0),
    lgfp4(0.0),
    vtofp4((-44.5)),
    cgfp4(2.0e-4),
    flagfp4s(1),
    cfp4s(1e-19),
    ccfp4(0.9e-10),
    cbfp4(0.0),
    vx0fp4(1.2e5),
    mu0fp4(0.2),
    betafp4(1.00),
    delta1fp4(0.0),
    sfp4(3.2),
    ndfp4(0.0),
    vthetafp4(0.0),
    mthetafp4(0.0),
    alphafp4(1e-2),
    igmod(1),
    rgsp(0.0),
    vjg(1.1),
    pg_param1(820e-3),
    pg_params(1.00),
    ijs(1.00e-12),
    vgsats(1.00),
    fracs(0.5),
    alphags(10.0),
    pg_paramd(1.00),
    ijd(1.00e-12),
    vgsatd(1.00),
    fracd(0.5),
    alphagd(10.0),
    pgsrecs(0.5),
    irecs(1.0e-18),
    vgsatqs(2.00),
    vbdgs(600),
    pbdgs(4.00),
    betarecs(2.00),
    kbdgates(00),
    pgsrecd(0.8),
    irecd(2e-5),
    vgsatqd(0.8),
    vbdgd(600),
    pbdgd(4.00),
    betarecd(0.25),
    kbdgated(00),
    rth(25),
    cth(1e-4),
    gmdisp(0),
    taugmrf(1e-3),
    trapselect(0),
    ctrap(1e-3),
    vttrap(230),
    taut(3e-5),
    alphat1(1e-4),
    alphat2(21),
    tempt(1e-4),
    noisemod(0),
    shs(3.0),
    shd(3.0),
    kf(1.0e-4),
    af(2.0),
    ffe(1.2),
    minr(1.0e-3),
    minl(1.0e-9),
    minc(0.0),
    LMIN(0.0),
    WMIN(0.0),
    LMAX(100.0),
    WMAX(100.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
      os << "W  =  " << (*iter)->w << std::endl;
      os << "L  =  " << (*iter)->l << std::endl;
      os << "NGF  =  " << (*iter)->ngf << std::endl;
      os << "DTEMP  =  " << (*iter)->dtemp << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("M") != deviceMap.end() && (levelSet.find(2002)!=levelSet.end()))))
{
MOSFET1::registerDevice();
  Config<Traits>::addConfiguration()
    .registerDevice("m", 2002)
    .registerModelType("nmos", 2002)
    .registerModelType("pmos", 2002);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
//Begin block initial_instance
{
if ((modelStruct.modelPar_flagres==0))
{
instanceStruct.d_instanceVar_rcs_w_dX = (((instanceStruct.instancePar_w*modelStruct.d_modelPar_rcs_dX-modelStruct.modelPar_rcs*instanceStruct.d_instancePar_w_dX)/instanceStruct.instancePar_w/instanceStruct.instancePar_w)/instanceStruct.instancePar_ngf);
instanceStruct.instanceVar_rcs_w = ((modelStruct.modelPar_rcs/instanceStruct.instancePar_w)/instanceStruct.instancePar_ngf);
instanceStruct.d_instanceVar_rcd_w_dX = (((instanceStruct.instancePar_w*modelStruct.d_modelPar_rcd_dX-modelStruct.modelPar_rcd*instanceStruct.d_instancePar_w_dX)/instanceStruct.instancePar_w/instanceStruct.instancePar_w)/instanceStruct.instancePar_ngf);
instanceStruct.instanceVar_rcd_w = ((modelStruct.modelPar_rcd/instanceStruct.instancePar_w)/instanceStruct.instancePar_ngf);
}
else
{
instanceStruct.d_instanceVar_rcs_w_dX = ((((instanceStruct.instancePar_w*modelStruct.d_modelPar_rcs_dX-modelStruct.modelPar_rcs*instanceStruct.d_instancePar_w_dX)/instanceStruct.instancePar_w/instanceStruct.instancePar_w)+((instanceStruct.instancePar_w*(modelStruct.modelPar_rsh*modelStruct.d_modelPar_lgs_dX+modelStruct.d_modelPar_rsh_dX*modelStruct.modelPar_lgs)-(modelStruct.modelPar_rsh*modelStruct.modelPar_lgs)*instanceStruct.d_instancePar_w_dX)/instanceStruct.instancePar_w/instanceStruct.instancePar_w))/instanceStruct.instancePar_ngf);
instanceStruct.instanceVar_rcs_w = (((modelStruct.modelPar_rcs/instanceStruct.instancePar_w)+((modelStruct.modelPar_rsh*modelStruct.modelPar_lgs)/instanceStruct.instancePar_w))/instanceStruct.instancePar_ngf);
instanceStruct.d_instanceVar_rcd_w_dX = ((((instanceStruct.instancePar_w*modelStruct.d_modelPar_rcd_dX-modelStruct.modelPar_rcd*instanceStruct.d_instancePar_w_dX)/instanceStruct.instancePar_w/instanceStruct.instancePar_w)+((instanceStruct.instancePar_w*(modelStruct.modelPar_rsh*modelStruct.d_modelPar_lgd_dX+modelStruct.d_modelPar_rsh_dX*modelStruct.modelPar_lgd)-(modelStruct.modelPar_rsh*modelStruct.modelPar_lgd)*instanceStruct.d_instancePar_w_dX)/instanceStruct.instancePar_w/instanceStruct.instancePar_w))/instanceStruct.instancePar_ngf);
instanceStruct.instanceVar_rcd_w = (((modelStruct.modelPar_rcd/instanceStruct.instancePar_w)+((modelStruct.modelPar_rsh*modelStruct.modelPar_lgd)/instanceStruct.instancePar_w))/instanceStruct.instancePar_ngf);
}
instanceStruct.d_instanceVar_rg_dX = (((instanceStruct.instancePar_w*modelStruct.d_modelPar_rgsp_dX-modelStruct.modelPar_rgsp*instanceStruct.d_instancePar_w_dX)/instanceStruct.instancePar_w/instanceStruct.instancePar_w)/instanceStruct.instancePar_ngf);
instanceStruct.instanceVar_rg = ((modelStruct.modelPar_rgsp/instanceStruct.instancePar_w)/instanceStruct.instancePar_ngf);
}
// End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_si_GND,
const int admsProbeID_V_b_GND,
const int admsProbeID_V_di_GND,
const int admsProbeID_V_gi_GND,
const int admsProbeID_V_drc_d,
const int admsProbeID_V_gi_b,
const int admsProbeID_V_s_b,
const int admsProbeID_V_d_b,
const int admsProbeID_V_d_s,
const int admsProbeID_V_gi_d,
const int admsProbeID_V_gi_s,
const int admsProbeID_V_g_gi,
const int admsProbeID_V_d_drc,
const int admsProbeID_V_xt1_GND,
const int admsProbeID_V_xt2_GND,
const int admsProbeID_V_s_fp4,
const int admsProbeID_V_gi_fp4,
const int admsProbeID_V_b_fp3,
const int admsProbeID_V_fp4_fp3,
const int admsProbeID_V_s_fp3,
const int admsProbeID_V_gi_fp3,
const int admsProbeID_V_b_fp2,
const int admsProbeID_V_fp3_fp2,
const int admsProbeID_V_s_fp2,
const int admsProbeID_V_gi_fp2,
const int admsProbeID_V_b_fp1,
const int admsProbeID_V_fp2_fp1,
const int admsProbeID_V_s_fp1,
const int admsProbeID_V_gi_fp1,
const int admsProbeID_V_b_di,
const int admsProbeID_V_fp1_di,
const int admsProbeID_V_s_di,
const int admsProbeID_V_gi_di,
const int admsProbeID_V_drc_fp4,
const int admsProbeID_V_fp4_s,
const int admsProbeID_V_fp4_d,
const int admsProbeID_V_tr_GND,
const int admsProbeID_V_tr1_tr,
const int admsProbeID_V_d_g,
const int admsProbeID_V_si_src,
const int admsProbeID_V_src_s,
const int admsProbeID_V_src_d,
const int admsProbeID_V_gi_si,
const int admsProbeID_V_di_si,
const int admsProbeID_Temp_dt_GND,
// node constants
const int admsNodeID_d,
const int admsNodeID_g,
const int admsNodeID_s,
const int admsNodeID_b,
const int admsNodeID_di,
const int admsNodeID_gi,
const int admsNodeID_si,
const int admsNodeID_fp1,
const int admsNodeID_fp2,
const int admsNodeID_fp3,
const int admsNodeID_fp4,
const int admsNodeID_drc,
const int admsNodeID_src,
const int admsNodeID_tr,
const int admsNodeID_tr1,
const int admsNodeID_xt1,
const int admsNodeID_xt2,
const int admsNodeID_dt,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double pdiss=0.0;
double d_pdiss_dX=0.0;
  double svc=0.0;
  double gm=0.0;
  double qofgsub=0.0;
double d_qofgsub_dX=0.0;
  double qofssub=0.0;
double d_qofssub_dX=0.0;
  double qofdsub=0.0;
double d_qofdsub_dX=0.0;
  double qofds=0.0;
double d_qofds_dX=0.0;
  double qofd=0.0;
double d_qofd_dX=0.0;
  double qofs=0.0;
double d_qofs_dX=0.0;
  double igdrec=0.0;
double d_igdrec_dX=0.0;
  double igsrec=0.0;
double d_igsrec_dX=0.0;
  double igdsdio=0.0;
double d_igdsdio_dX=0.0;
  double igssdio=0.0;
double d_igssdio_dX=0.0;
  double igdi=0.0;
double d_igdi_dX=0.0;
  double igsi=0.0;
double d_igsi_dX=0.0;
  double idsrf=0.0;
  double vdsat1i=0.0;
double d_vdsat1i_dX=0.0;
  double vtdibli=0.0;
double d_vtdibli_dX=0.0;
  double qs=0.0;
double d_qs_dX=0.0;
  double qb=0.0;
double d_qb_dX=0.0;
  double qc=0.0;
double d_qc_dX=0.0;
  double qgd=0.0;
double d_qgd_dX=0.0;
  double qgs=0.0;
double d_qgs_dX=0.0;
  double ids=0.0;
double d_ids_dX=0.0;
  double vdsatrd=0.0;
double d_vdsatrd_dX=0.0;
  double vtdiblrd=0.0;
double d_vtdiblrd_dX=0.0;
  double qsrd=0.0;
double d_qsrd_dX=0.0;
  double qbrd=0.0;
double d_qbrd_dX=0.0;
  double qcrd=0.0;
double d_qcrd_dX=0.0;
  double qgdrd=0.0;
double d_qgdrd_dX=0.0;
  double qgsrd=0.0;
double d_qgsrd_dX=0.0;
  double idsrd=0.0;
double d_idsrd_dX=0.0;
  double vdsatrs=0.0;
double d_vdsatrs_dX=0.0;
  double vtdiblrs=0.0;
double d_vtdiblrs_dX=0.0;
  double qsrs=0.0;
double d_qsrs_dX=0.0;
  double qbrs=0.0;
double d_qbrs_dX=0.0;
  double qcrs=0.0;
double d_qcrs_dX=0.0;
  double qgdrs=0.0;
double d_qgdrs_dX=0.0;
  double qgsrs=0.0;
double d_qgsrs_dX=0.0;
  double idsrs=0.0;
double d_idsrs_dX=0.0;
  double vdsatfp1=0.0;
double d_vdsatfp1_dX=0.0;
  double vtdiblfp1=0.0;
double d_vtdiblfp1_dX=0.0;
  double qsfp1=0.0;
double d_qsfp1_dX=0.0;
  double qbfp1=0.0;
double d_qbfp1_dX=0.0;
  double qcfp1=0.0;
double d_qcfp1_dX=0.0;
  double qgdfp1=0.0;
double d_qgdfp1_dX=0.0;
  double qgsfp1=0.0;
double d_qgsfp1_dX=0.0;
  double idsfp1=0.0;
double d_idsfp1_dX=0.0;
  double vdsatfp2=0.0;
double d_vdsatfp2_dX=0.0;
  double vtdiblfp2=0.0;
double d_vtdiblfp2_dX=0.0;
  double qsfp2=0.0;
double d_qsfp2_dX=0.0;
  double qbfp2=0.0;
double d_qbfp2_dX=0.0;
  double qcfp2=0.0;
double d_qcfp2_dX=0.0;
  double qgdfp2=0.0;
double d_qgdfp2_dX=0.0;
  double qgsfp2=0.0;
double d_qgsfp2_dX=0.0;
  double idsfp2=0.0;
double d_idsfp2_dX=0.0;
  double vdsatfp3=0.0;
double d_vdsatfp3_dX=0.0;
  double vtdiblfp3=0.0;
double d_vtdiblfp3_dX=0.0;
  double qsfp3=0.0;
double d_qsfp3_dX=0.0;
  double qbfp3=0.0;
double d_qbfp3_dX=0.0;
  double qcfp3=0.0;
double d_qcfp3_dX=0.0;
  double qgdfp3=0.0;
double d_qgdfp3_dX=0.0;
  double qgsfp3=0.0;
double d_qgsfp3_dX=0.0;
  double idsfp3=0.0;
double d_idsfp3_dX=0.0;
  double vdsatfp4=0.0;
double d_vdsatfp4_dX=0.0;
  double vtdiblfp4=0.0;
double d_vtdiblfp4_dX=0.0;
  double qsfp4=0.0;
double d_qsfp4_dX=0.0;
  double qbfp4=0.0;
double d_qbfp4_dX=0.0;
  double qcfp4=0.0;
double d_qcfp4_dX=0.0;
  double qgdfp4=0.0;
double d_qgdfp4_dX=0.0;
  double qgsfp4=0.0;
double d_qgsfp4_dX=0.0;
  double idsfp4=0.0;
double d_idsfp4_dX=0.0;
  double vbfp4=0.0;
double d_vbfp4_dX=0.0;
  double vdsfp4=0.0;
double d_vdsfp4_dX=0.0;
  double vcfp4=0.0;
double d_vcfp4_dX=0.0;
  double vgsfp4=0.0;
double d_vgsfp4_dX=0.0;
  double vbfp3=0.0;
double d_vbfp3_dX=0.0;
  double vdsfp3=0.0;
double d_vdsfp3_dX=0.0;
  double vcfp3=0.0;
double d_vcfp3_dX=0.0;
  double vgsfp3=0.0;
double d_vgsfp3_dX=0.0;
  double vbfp2=0.0;
double d_vbfp2_dX=0.0;
  double vdsfp2=0.0;
double d_vdsfp2_dX=0.0;
  double vcfp2=0.0;
double d_vcfp2_dX=0.0;
  double vgsfp2=0.0;
double d_vgsfp2_dX=0.0;
  double vbfp1=0.0;
double d_vbfp1_dX=0.0;
  double vdsfp1=0.0;
double d_vdsfp1_dX=0.0;
  double vcfp1=0.0;
double d_vcfp1_dX=0.0;
  double vgsfp1=0.0;
double d_vgsfp1_dX=0.0;
  double vgsrd=0.0;
double d_vgsrd_dX=0.0;
  double vdsrd=0.0;
double d_vdsrd_dX=0.0;
  double vigd=0.0;
double d_vigd_dX=0.0;
  double vdars=0.0;
double d_vdars_dX=0.0;
  double drsht=0.0;
double d_drsht_dX=0.0;
  double vtcollapse=0.0;
  double vtcollapse0=0.0;
double d_vtcollapse0_dX=0.0;
  double vgsrs=0.0;
double d_vgsrs_dX=0.0;
  double vdsrs=0.0;
double d_vdsrs_dX=0.0;
  double vigs=0.0;
double d_vigs_dX=0.0;
  double vsars=0.0;
double d_vsars_dX=0.0;
  double vgsi=0.0;
double d_vgsi_dX=0.0;
  double vdsi=0.0;
double d_vdsi_dX=0.0;
  double ttrapfac=0.0;
double d_ttrapfac_dX=0.0;
  double phit=0.0;
double d_phit_dX=0.0;
  double rdi=0.0;
double d_rdi_dX=0.0;
  double rsi=0.0;
double d_rsi_dX=0.0;
  double tdut=0.0;
double d_tdut_dX=0.0;
  double tsh=0.0;
  double tambk=0.0;
  double tnomk=0.0;
double d_tnomk_dX=0.0;
  double gmin=0.0;


  // -- code converted from analog/code block
gmin = ADMSgmin_arg;
d_tnomk_dX = modelStruct.d_modelPar_tnom_dX;
tnomk = (modelStruct.modelPar_tnom+273.15);
tambk = admsTemperature;
tsh = (probeVars[admsProbeID_Temp_dt_GND]);
d_tdut_dX = instanceStruct.d_instancePar_dtemp_dX;
tdut = ((tambk+instanceStruct.instancePar_dtemp)+tsh);
if ((tdut<((-270.0)+273.15)))
{
d_tdut_dX = 0.0;
tdut = ((-270.0)+273.15);
}
else
{
if ((tdut>(1500+273.15)))
{
d_tdut_dX = 0.0;
tdut = (1500+273.15);
}
}
d_rsi_dX = 0.0;
rsi = 0;
d_rdi_dX = 0.0;
rdi = 0;
if ((instanceStruct.instanceVar_rcs_w>=modelStruct.modelPar_minr))
{
d_rsi_dX = (instanceStruct.instanceVar_rcs_w*((modelStruct.modelPar_rct1*(d_tdut_dX-d_tnomk_dX)+modelStruct.d_modelPar_rct1_dX*(tdut-tnomk))+((modelStruct.modelPar_rct2*(tdut-tnomk))*(d_tdut_dX-d_tnomk_dX)+(modelStruct.modelPar_rct2*(d_tdut_dX-d_tnomk_dX)+modelStruct.d_modelPar_rct2_dX*(tdut-tnomk))*(tdut-tnomk)))+instanceStruct.d_instanceVar_rcs_w_dX*((1.0+(modelStruct.modelPar_rct1*(tdut-tnomk)))+((modelStruct.modelPar_rct2*(tdut-tnomk))*(tdut-tnomk))));
rsi = (instanceStruct.instanceVar_rcs_w*((1.0+(modelStruct.modelPar_rct1*(tdut-tnomk)))+((modelStruct.modelPar_rct2*(tdut-tnomk))*(tdut-tnomk))));
if ((rsi<(0.1*instanceStruct.instanceVar_rcs_w)))
{
d_rsi_dX = 0.1*instanceStruct.d_instanceVar_rcs_w_dX;
rsi = (0.1*instanceStruct.instanceVar_rcs_w);
}
}
else
{
d_rsi_dX = 0.0;
rsi = 0;
}
if ((instanceStruct.instanceVar_rcd_w>=modelStruct.modelPar_minr))
{
d_rdi_dX = (instanceStruct.instanceVar_rcd_w*((modelStruct.modelPar_rct1*(d_tdut_dX-d_tnomk_dX)+modelStruct.d_modelPar_rct1_dX*(tdut-tnomk))+((modelStruct.modelPar_rct2*(tdut-tnomk))*(d_tdut_dX-d_tnomk_dX)+(modelStruct.modelPar_rct2*(d_tdut_dX-d_tnomk_dX)+modelStruct.d_modelPar_rct2_dX*(tdut-tnomk))*(tdut-tnomk)))+instanceStruct.d_instanceVar_rcd_w_dX*((1.0+(modelStruct.modelPar_rct1*(tdut-tnomk)))+((modelStruct.modelPar_rct2*(tdut-tnomk))*(tdut-tnomk))));
rdi = (instanceStruct.instanceVar_rcd_w*((1.0+(modelStruct.modelPar_rct1*(tdut-tnomk)))+((modelStruct.modelPar_rct2*(tdut-tnomk))*(tdut-tnomk))));
if ((rdi<(0.1*instanceStruct.instanceVar_rcd_w)))
{
d_rdi_dX = 0.1*instanceStruct.d_instanceVar_rcd_w_dX;
rdi = (0.1*instanceStruct.instanceVar_rcd_w);
}
}
else
{
d_rdi_dX = 0.0;
rdi = 0;
}
d_phit_dX = (1.38062e-23*d_tdut_dX/1.60219e-19);
phit = ((1.38062e-23*tdut)/1.60219e-19);
d_ttrapfac_dX = (modelStruct.modelPar_tempt*(d_tdut_dX-d_tnomk_dX)+modelStruct.d_modelPar_tempt_dX*(tdut-tnomk));
ttrapfac = (1.0+(modelStruct.modelPar_tempt*(tdut-tnomk)));
d_vdsi_dX = 0.0;
vdsi = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_di_si]));
d_vgsi_dX = 0.0;
vgsi = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_si]));
if (((modelStruct.modelPar_type*(probeVars[admsProbeID_V_src_d]))<=(modelStruct.modelPar_type*(probeVars[admsProbeID_V_src_s]))))
{
d_vsars_dX = 0.0;
vsars = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_src_s]));
}
else
{
d_vsars_dX = 0.0;
vsars = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_src_d]));
}
d_vigs_dX = (modelStruct.d_modelPar_vtors_dX+(-((modelStruct.modelPar_rsh*modelStruct.modelPar_cgrs)*modelStruct.d_modelPar_mu0_dX+(modelStruct.modelPar_rsh*modelStruct.d_modelPar_cgrs_dX+modelStruct.d_modelPar_rsh_dX*modelStruct.modelPar_cgrs)*modelStruct.modelPar_mu0)/((modelStruct.modelPar_rsh*modelStruct.modelPar_cgrs)*modelStruct.modelPar_mu0)/((modelStruct.modelPar_rsh*modelStruct.modelPar_cgrs)*modelStruct.modelPar_mu0)));
vigs = (modelStruct.modelPar_vtors+(1.0/((modelStruct.modelPar_rsh*modelStruct.modelPar_cgrs)*modelStruct.modelPar_mu0)));
d_vdsrs_dX = 0.0;
vdsrs = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_si_src]));
d_vgsrs_dX = (d_vigs_dX-d_vsars_dX);
vgsrs = (vigs-vsars);
if ((modelStruct.modelPar_trapselect!=0))
{
{
double value_fabs_0 = fabs((probeVars[admsProbeID_V_d_g]));
AnalogFunctions::explimEvaluator evaluator_explim_1((((probeVars[admsProbeID_V_d_g])-modelStruct.modelPar_vttrap)/modelStruct.modelPar_alphat2));
double  deriv_fabs_0_d0 = ((((probeVars[admsProbeID_V_d_g]))>=0)?(+1.0):(-1.0));
d_vtcollapse0_dX = (modelStruct.d_modelPar_alphat1_dX*value_fabs_0+evaluator_explim_1.getDerivs((((probeVars[admsProbeID_V_d_g])-modelStruct.modelPar_vttrap)/modelStruct.modelPar_alphat2),((modelStruct.modelPar_alphat2*(-modelStruct.d_modelPar_vttrap_dX)-((probeVars[admsProbeID_V_d_g])-modelStruct.modelPar_vttrap)*modelStruct.d_modelPar_alphat2_dX)/modelStruct.modelPar_alphat2/modelStruct.modelPar_alphat2)));
vtcollapse0 = ((modelStruct.modelPar_alphat1*value_fabs_0)+evaluator_explim_1.getValues((((probeVars[admsProbeID_V_d_g])-modelStruct.modelPar_vttrap)/modelStruct.modelPar_alphat2)));
}
// I(tr1,GND) <+ ((-vtcollapse0))
d_staticContributions_dX[admsNodeID_tr1]+= (-d_vtcollapse0_dX);
// I(tr1,tr) <+ (ddt((ctrap*V(tr1,tr))))
d_dynamicContributions_dX[admsNodeID_tr1]+= (modelStruct.d_modelPar_ctrap_dX*(probeVars[admsProbeID_V_tr1_tr]));
d_dynamicContributions_dX[(admsNodeID_tr)]-= (modelStruct.d_modelPar_ctrap_dX*(probeVars[admsProbeID_V_tr1_tr]));
// I(tr,GND) <+ (ddt((taut*V(tr,GND))))
d_dynamicContributions_dX[admsNodeID_tr]+= (modelStruct.d_modelPar_taut_dX*(probeVars[admsProbeID_V_tr_GND]));
// I(tr,GND) <+ (V(tr,GND))
d_staticContributions_dX[admsNodeID_tr]+= 0.0;
vtcollapse = (probeVars[admsProbeID_V_tr_GND]);
d_drsht_dX = vtcollapse*d_ttrapfac_dX;
drsht = (1.0+(vtcollapse*ttrapfac));
}
else
{
d_vtcollapse0_dX = 0.0;
vtcollapse0 = 0;
vtcollapse = 0;
// V(tr1,GND) <+ (0)
// do nothing at all
// V(tr,GND) <+ (0)
// do nothing at all
d_drsht_dX = 0.0;
drsht = 1.0;
}
if (((modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp4_d]))<=(modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp4_s]))))
{
d_vdars_dX = 0.0;
vdars = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp4_s]));
}
else
{
d_vdars_dX = 0.0;
vdars = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp4_d]));
}
d_vigd_dX = (modelStruct.d_modelPar_vtord_dX+(-(((drsht*modelStruct.modelPar_rsh)*modelStruct.modelPar_cgrd)*modelStruct.d_modelPar_mu0_dX+((drsht*modelStruct.modelPar_rsh)*modelStruct.d_modelPar_cgrd_dX+(drsht*modelStruct.d_modelPar_rsh_dX+d_drsht_dX*modelStruct.modelPar_rsh)*modelStruct.modelPar_cgrd)*modelStruct.modelPar_mu0)/(((drsht*modelStruct.modelPar_rsh)*modelStruct.modelPar_cgrd)*modelStruct.modelPar_mu0)/(((drsht*modelStruct.modelPar_rsh)*modelStruct.modelPar_cgrd)*modelStruct.modelPar_mu0)));
vigd = (modelStruct.modelPar_vtord+(1.0/(((drsht*modelStruct.modelPar_rsh)*modelStruct.modelPar_cgrd)*modelStruct.modelPar_mu0)));
d_vdsrd_dX = 0.0;
vdsrd = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_drc_fp4]));
d_vgsrd_dX = (d_vigd_dX-d_vdars_dX);
vgsrd = (vigd-vdars);
if ((modelStruct.modelPar_flagfp1==1))
{
d_vgsfp1_dX = 0.0;
vgsfp1 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_di]));
d_vcfp1_dX = 0.0;
vcfp1 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_di]));
}
else
{
d_vgsfp1_dX = 0.0;
vgsfp1 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_di]));
d_vcfp1_dX = 0.0;
vcfp1 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_di]));
}
d_vdsfp1_dX = 0.0;
vdsfp1 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp1_di]));
d_vbfp1_dX = 0.0;
vbfp1 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_b_di]));
if ((modelStruct.modelPar_flagfp2==1))
{
d_vgsfp2_dX = 0.0;
vgsfp2 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_fp1]));
d_vcfp2_dX = 0.0;
vcfp2 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_fp1]));
}
else
{
d_vgsfp2_dX = 0.0;
vgsfp2 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_fp1]));
d_vcfp2_dX = 0.0;
vcfp2 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_fp1]));
}
d_vdsfp2_dX = 0.0;
vdsfp2 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp2_fp1]));
d_vbfp2_dX = 0.0;
vbfp2 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_b_fp1]));
if ((modelStruct.modelPar_flagfp3==1))
{
d_vgsfp3_dX = 0.0;
vgsfp3 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_fp2]));
d_vcfp3_dX = 0.0;
vcfp3 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_fp2]));
}
else
{
d_vgsfp3_dX = 0.0;
vgsfp3 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_fp2]));
d_vcfp3_dX = 0.0;
vcfp3 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_fp2]));
}
d_vdsfp3_dX = 0.0;
vdsfp3 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp3_fp2]));
d_vbfp3_dX = 0.0;
vbfp3 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_b_fp2]));
if ((modelStruct.modelPar_flagfp4==1))
{
d_vgsfp4_dX = 0.0;
vgsfp4 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_fp3]));
d_vcfp4_dX = 0.0;
vcfp4 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_fp3]));
}
else
{
d_vgsfp4_dX = 0.0;
vgsfp4 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_s_fp3]));
d_vcfp4_dX = 0.0;
vcfp4 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_gi_fp3]));
}
d_vdsfp4_dX = 0.0;
vdsfp4 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_fp4_fp3]));
d_vbfp4_dX = 0.0;
vbfp4 = (modelStruct.modelPar_type*(probeVars[admsProbeID_V_b_fp3]));
d_idsfp4_dX = 0.0;
idsfp4 = 0;
d_qgsfp4_dX = 0.0;
qgsfp4 = 0;
d_qgdfp4_dX = 0.0;
qgdfp4 = 0;
d_qcfp4_dX = 0.0;
qcfp4 = 0;
d_qbfp4_dX = 0.0;
qbfp4 = 0;
d_qsfp4_dX = 0.0;
qsfp4 = 0;
d_vtdiblfp4_dX = 0.0;
vtdiblfp4 = 0;
d_vdsatfp4_dX = 0.0;
vdsatfp4 = 0;
if ((modelStruct.modelPar_lgfp4>modelStruct.modelPar_minl))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,modelStruct.modelPar_flagfp4s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp4,modelStruct.modelPar_cgfp4,modelStruct.modelPar_cfp4s,modelStruct.modelPar_ccfp4,modelStruct.modelPar_cbfp4,modelStruct.modelPar_vtofp4,modelStruct.modelPar_sfp4,modelStruct.modelPar_delta1fp4,0.0,modelStruct.modelPar_ndfp4,modelStruct.modelPar_alphafp4,modelStruct.modelPar_vx0fp4,modelStruct.modelPar_mu0fp4,modelStruct.modelPar_betafp4,modelStruct.modelPar_mthetafp4,modelStruct.modelPar_vthetafp4,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
d_idsfp4_dX = evaluator_calc_iq_0.getDerivs(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,modelStruct.modelPar_flagfp4s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp4,modelStruct.modelPar_cgfp4,modelStruct.modelPar_cfp4s,modelStruct.modelPar_ccfp4,modelStruct.modelPar_cbfp4,modelStruct.modelPar_vtofp4,modelStruct.modelPar_sfp4,modelStruct.modelPar_delta1fp4,0.0,modelStruct.modelPar_ndfp4,modelStruct.modelPar_alphafp4,modelStruct.modelPar_vx0fp4,modelStruct.modelPar_mu0fp4,modelStruct.modelPar_betafp4,modelStruct.modelPar_mthetafp4,modelStruct.modelPar_vthetafp4,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type,d_idsfp4_dX,d_qgsfp4_dX,d_qgdfp4_dX,d_qcfp4_dX,d_qbfp4_dX,d_qsfp4_dX,d_vtdiblfp4_dX,d_vdsatfp4_dX,d_vgsfp4_dX,d_vdsfp4_dX,0.0,d_vcfp4_dX,d_vbfp4_dX,0.0,d_tdut_dX,d_tnomk_dX,d_phit_dX,instanceStruct.d_instancePar_w_dX,modelStruct.d_modelPar_lgfp4_dX,modelStruct.d_modelPar_cgfp4_dX,modelStruct.d_modelPar_cfp4s_dX,modelStruct.d_modelPar_ccfp4_dX,modelStruct.d_modelPar_cbfp4_dX,modelStruct.d_modelPar_vtofp4_dX,modelStruct.d_modelPar_sfp4_dX,modelStruct.d_modelPar_delta1fp4_dX,0.0,modelStruct.d_modelPar_ndfp4_dX,modelStruct.d_modelPar_alphafp4_dX,modelStruct.d_modelPar_vx0fp4_dX,modelStruct.d_modelPar_mu0fp4_dX,modelStruct.d_modelPar_betafp4_dX,modelStruct.d_modelPar_mthetafp4_dX,modelStruct.d_modelPar_vthetafp4_dX,modelStruct.d_modelPar_vtzeta_dX,modelStruct.d_modelPar_dibsat_dX,modelStruct.d_modelPar_epsilon_dX,modelStruct.d_modelPar_vzeta_dX,modelStruct.d_modelPar_lambda_dX,0.0,0.0);
idsfp4 = evaluator_calc_iq_0.getValues(idsfp4,qgsfp4,qgdfp4,qcfp4,qbfp4,qsfp4,vtdiblfp4,vdsatfp4,vgsfp4,vdsfp4,1,vcfp4,vbfp4,modelStruct.modelPar_flagfp4s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp4,modelStruct.modelPar_cgfp4,modelStruct.modelPar_cfp4s,modelStruct.modelPar_ccfp4,modelStruct.modelPar_cbfp4,modelStruct.modelPar_vtofp4,modelStruct.modelPar_sfp4,modelStruct.modelPar_delta1fp4,0.0,modelStruct.modelPar_ndfp4,modelStruct.modelPar_alphafp4,modelStruct.modelPar_vx0fp4,modelStruct.modelPar_mu0fp4,modelStruct.modelPar_betafp4,modelStruct.modelPar_mthetafp4,modelStruct.modelPar_vthetafp4,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
}
// I(fp4,fp3) <+ ((idsfp4+(gmin*V(fp4,fp3))))
d_staticContributions_dX[admsNodeID_fp4]+= d_idsfp4_dX;
d_staticContributions_dX[(admsNodeID_fp3)]-= d_idsfp4_dX;
}
else
{
// V(fp4,fp3) <+ (0)
// do nothing at all
}
if ((modelStruct.modelPar_flagfp4==1))
{
// I(gi,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(gi,fp3)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgsfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp3])));
d_dynamicContributions_dX[(admsNodeID_fp3)]-= ((d_qgsfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp3])));
// I(gi,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(gi,fp4)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgdfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp4])));
d_dynamicContributions_dX[(admsNodeID_fp4)]-= ((d_qgdfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp4])));
// I(s,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(s,fp3)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qcfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp3])));
d_dynamicContributions_dX[(admsNodeID_fp3)]-= ((d_qcfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp3])));
// I(s,fp4) <+ (0)
d_staticContributions_dX[admsNodeID_s]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp4)]-= 0.0;
// I(gi,si) <+ ((ddt(qsfp4)+ddt((minc*V(gi,si)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qsfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((d_qsfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
}
else
{
// I(s,fp3) <+ ((ddt(qgsfp4)+ddt((minc*V(s,fp3)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgsfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp3])));
d_dynamicContributions_dX[(admsNodeID_fp3)]-= ((d_qgsfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp3])));
// I(s,fp4) <+ ((ddt(qgdfp4)+ddt((minc*V(s,fp4)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgdfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp4])));
d_dynamicContributions_dX[(admsNodeID_fp4)]-= ((d_qgdfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp4])));
// I(gi,fp3) <+ ((ddt(qcfp4)+ddt((minc*V(gi,fp3)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qcfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp3])));
d_dynamicContributions_dX[(admsNodeID_fp3)]-= ((d_qcfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp3])));
// I(gi,fp4) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp4)]-= 0.0;
// I(gi,si) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_si)]-= 0.0;
}
// I(b,fp3) <+ ((ddt(qbfp4)+ddt((minc*V(b,fp3)))))
d_dynamicContributions_dX[admsNodeID_b]+= ((d_qbfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_fp3])));
d_dynamicContributions_dX[(admsNodeID_fp3)]-= ((d_qbfp4_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_fp3])));
d_idsfp3_dX = 0.0;
idsfp3 = 0;
d_qgsfp3_dX = 0.0;
qgsfp3 = 0;
d_qgdfp3_dX = 0.0;
qgdfp3 = 0;
d_qcfp3_dX = 0.0;
qcfp3 = 0;
d_qbfp3_dX = 0.0;
qbfp3 = 0;
d_qsfp3_dX = 0.0;
qsfp3 = 0;
d_vtdiblfp3_dX = 0.0;
vtdiblfp3 = 0;
d_vdsatfp3_dX = 0.0;
vdsatfp3 = 0;
if ((modelStruct.modelPar_lgfp3>modelStruct.modelPar_minl))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,modelStruct.modelPar_flagfp3s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp3,modelStruct.modelPar_cgfp3,modelStruct.modelPar_cfp3s,modelStruct.modelPar_ccfp3,modelStruct.modelPar_cbfp3,modelStruct.modelPar_vtofp3,modelStruct.modelPar_sfp3,modelStruct.modelPar_delta1fp3,0.0,modelStruct.modelPar_ndfp3,modelStruct.modelPar_alphafp3,modelStruct.modelPar_vx0fp3,modelStruct.modelPar_mu0fp3,modelStruct.modelPar_betafp3,modelStruct.modelPar_mthetafp3,modelStruct.modelPar_vthetafp3,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
d_idsfp3_dX = evaluator_calc_iq_0.getDerivs(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,modelStruct.modelPar_flagfp3s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp3,modelStruct.modelPar_cgfp3,modelStruct.modelPar_cfp3s,modelStruct.modelPar_ccfp3,modelStruct.modelPar_cbfp3,modelStruct.modelPar_vtofp3,modelStruct.modelPar_sfp3,modelStruct.modelPar_delta1fp3,0.0,modelStruct.modelPar_ndfp3,modelStruct.modelPar_alphafp3,modelStruct.modelPar_vx0fp3,modelStruct.modelPar_mu0fp3,modelStruct.modelPar_betafp3,modelStruct.modelPar_mthetafp3,modelStruct.modelPar_vthetafp3,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type,d_idsfp3_dX,d_qgsfp3_dX,d_qgdfp3_dX,d_qcfp3_dX,d_qbfp3_dX,d_qsfp3_dX,d_vtdiblfp3_dX,d_vdsatfp3_dX,d_vgsfp3_dX,d_vdsfp3_dX,0.0,d_vcfp3_dX,d_vbfp3_dX,0.0,d_tdut_dX,d_tnomk_dX,d_phit_dX,instanceStruct.d_instancePar_w_dX,modelStruct.d_modelPar_lgfp3_dX,modelStruct.d_modelPar_cgfp3_dX,modelStruct.d_modelPar_cfp3s_dX,modelStruct.d_modelPar_ccfp3_dX,modelStruct.d_modelPar_cbfp3_dX,modelStruct.d_modelPar_vtofp3_dX,modelStruct.d_modelPar_sfp3_dX,modelStruct.d_modelPar_delta1fp3_dX,0.0,modelStruct.d_modelPar_ndfp3_dX,modelStruct.d_modelPar_alphafp3_dX,modelStruct.d_modelPar_vx0fp3_dX,modelStruct.d_modelPar_mu0fp3_dX,modelStruct.d_modelPar_betafp3_dX,modelStruct.d_modelPar_mthetafp3_dX,modelStruct.d_modelPar_vthetafp3_dX,modelStruct.d_modelPar_vtzeta_dX,modelStruct.d_modelPar_dibsat_dX,modelStruct.d_modelPar_epsilon_dX,modelStruct.d_modelPar_vzeta_dX,modelStruct.d_modelPar_lambda_dX,0.0,0.0);
idsfp3 = evaluator_calc_iq_0.getValues(idsfp3,qgsfp3,qgdfp3,qcfp3,qbfp3,qsfp3,vtdiblfp3,vdsatfp3,vgsfp3,vdsfp3,1,vcfp3,vbfp3,modelStruct.modelPar_flagfp3s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp3,modelStruct.modelPar_cgfp3,modelStruct.modelPar_cfp3s,modelStruct.modelPar_ccfp3,modelStruct.modelPar_cbfp3,modelStruct.modelPar_vtofp3,modelStruct.modelPar_sfp3,modelStruct.modelPar_delta1fp3,0.0,modelStruct.modelPar_ndfp3,modelStruct.modelPar_alphafp3,modelStruct.modelPar_vx0fp3,modelStruct.modelPar_mu0fp3,modelStruct.modelPar_betafp3,modelStruct.modelPar_mthetafp3,modelStruct.modelPar_vthetafp3,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
}
// I(fp3,fp2) <+ ((idsfp3+(gmin*V(fp3,fp2))))
d_staticContributions_dX[admsNodeID_fp3]+= d_idsfp3_dX;
d_staticContributions_dX[(admsNodeID_fp2)]-= d_idsfp3_dX;
}
else
{
// V(fp3,fp2) <+ (0)
// do nothing at all
}
if ((modelStruct.modelPar_flagfp3==1))
{
// I(gi,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(gi,fp2)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgsfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp2])));
d_dynamicContributions_dX[(admsNodeID_fp2)]-= ((d_qgsfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp2])));
// I(gi,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(gi,fp3)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgdfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp3])));
d_dynamicContributions_dX[(admsNodeID_fp3)]-= ((d_qgdfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp3])));
// I(s,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(s,fp2)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qcfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp2])));
d_dynamicContributions_dX[(admsNodeID_fp2)]-= ((d_qcfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp2])));
// I(s,fp3) <+ (0)
d_staticContributions_dX[admsNodeID_s]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp3)]-= 0.0;
// I(gi,si) <+ ((ddt(qsfp3)+ddt((minc*V(gi,si)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qsfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((d_qsfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
}
else
{
// I(s,fp2) <+ ((ddt(qgsfp3)+ddt((minc*V(s,fp2)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgsfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp2])));
d_dynamicContributions_dX[(admsNodeID_fp2)]-= ((d_qgsfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp2])));
// I(s,fp3) <+ ((ddt(qgdfp3)+ddt((minc*V(s,fp3)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgdfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp3])));
d_dynamicContributions_dX[(admsNodeID_fp3)]-= ((d_qgdfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp3])));
// I(gi,fp2) <+ ((ddt(qcfp3)+ddt((minc*V(gi,fp2)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qcfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp2])));
d_dynamicContributions_dX[(admsNodeID_fp2)]-= ((d_qcfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp2])));
// I(gi,fp3) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp3)]-= 0.0;
// I(gi,si) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_si)]-= 0.0;
}
// I(b,fp2) <+ ((ddt(qbfp3)+ddt((minc*V(b,fp2)))))
d_dynamicContributions_dX[admsNodeID_b]+= ((d_qbfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_fp2])));
d_dynamicContributions_dX[(admsNodeID_fp2)]-= ((d_qbfp3_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_fp2])));
d_idsfp2_dX = 0.0;
idsfp2 = 0;
d_qgsfp2_dX = 0.0;
qgsfp2 = 0;
d_qgdfp2_dX = 0.0;
qgdfp2 = 0;
d_qcfp2_dX = 0.0;
qcfp2 = 0;
d_qbfp2_dX = 0.0;
qbfp2 = 0;
d_qsfp2_dX = 0.0;
qsfp2 = 0;
d_vtdiblfp2_dX = 0.0;
vtdiblfp2 = 0;
d_vdsatfp2_dX = 0.0;
vdsatfp2 = 0;
if ((modelStruct.modelPar_lgfp2>modelStruct.modelPar_minl))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,modelStruct.modelPar_flagfp2s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp2,modelStruct.modelPar_cgfp2,modelStruct.modelPar_cfp2s,modelStruct.modelPar_ccfp2,modelStruct.modelPar_cbfp2,modelStruct.modelPar_vtofp2,modelStruct.modelPar_sfp2,modelStruct.modelPar_delta1fp2,0.0,modelStruct.modelPar_ndfp2,modelStruct.modelPar_alphafp2,modelStruct.modelPar_vx0fp2,modelStruct.modelPar_mu0fp2,modelStruct.modelPar_betafp2,modelStruct.modelPar_mthetafp2,modelStruct.modelPar_vthetafp2,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
d_idsfp2_dX = evaluator_calc_iq_0.getDerivs(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,modelStruct.modelPar_flagfp2s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp2,modelStruct.modelPar_cgfp2,modelStruct.modelPar_cfp2s,modelStruct.modelPar_ccfp2,modelStruct.modelPar_cbfp2,modelStruct.modelPar_vtofp2,modelStruct.modelPar_sfp2,modelStruct.modelPar_delta1fp2,0.0,modelStruct.modelPar_ndfp2,modelStruct.modelPar_alphafp2,modelStruct.modelPar_vx0fp2,modelStruct.modelPar_mu0fp2,modelStruct.modelPar_betafp2,modelStruct.modelPar_mthetafp2,modelStruct.modelPar_vthetafp2,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type,d_idsfp2_dX,d_qgsfp2_dX,d_qgdfp2_dX,d_qcfp2_dX,d_qbfp2_dX,d_qsfp2_dX,d_vtdiblfp2_dX,d_vdsatfp2_dX,d_vgsfp2_dX,d_vdsfp2_dX,0.0,d_vcfp2_dX,d_vbfp2_dX,0.0,d_tdut_dX,d_tnomk_dX,d_phit_dX,instanceStruct.d_instancePar_w_dX,modelStruct.d_modelPar_lgfp2_dX,modelStruct.d_modelPar_cgfp2_dX,modelStruct.d_modelPar_cfp2s_dX,modelStruct.d_modelPar_ccfp2_dX,modelStruct.d_modelPar_cbfp2_dX,modelStruct.d_modelPar_vtofp2_dX,modelStruct.d_modelPar_sfp2_dX,modelStruct.d_modelPar_delta1fp2_dX,0.0,modelStruct.d_modelPar_ndfp2_dX,modelStruct.d_modelPar_alphafp2_dX,modelStruct.d_modelPar_vx0fp2_dX,modelStruct.d_modelPar_mu0fp2_dX,modelStruct.d_modelPar_betafp2_dX,modelStruct.d_modelPar_mthetafp2_dX,modelStruct.d_modelPar_vthetafp2_dX,modelStruct.d_modelPar_vtzeta_dX,modelStruct.d_modelPar_dibsat_dX,modelStruct.d_modelPar_epsilon_dX,modelStruct.d_modelPar_vzeta_dX,modelStruct.d_modelPar_lambda_dX,0.0,0.0);
idsfp2 = evaluator_calc_iq_0.getValues(idsfp2,qgsfp2,qgdfp2,qcfp2,qbfp2,qsfp2,vtdiblfp2,vdsatfp2,vgsfp2,vdsfp2,1,vcfp2,vbfp2,modelStruct.modelPar_flagfp2s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp2,modelStruct.modelPar_cgfp2,modelStruct.modelPar_cfp2s,modelStruct.modelPar_ccfp2,modelStruct.modelPar_cbfp2,modelStruct.modelPar_vtofp2,modelStruct.modelPar_sfp2,modelStruct.modelPar_delta1fp2,0.0,modelStruct.modelPar_ndfp2,modelStruct.modelPar_alphafp2,modelStruct.modelPar_vx0fp2,modelStruct.modelPar_mu0fp2,modelStruct.modelPar_betafp2,modelStruct.modelPar_mthetafp2,modelStruct.modelPar_vthetafp2,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
}
// I(fp2,fp1) <+ ((idsfp2+(gmin*V(fp2,fp1))))
d_staticContributions_dX[admsNodeID_fp2]+= d_idsfp2_dX;
d_staticContributions_dX[(admsNodeID_fp1)]-= d_idsfp2_dX;
}
else
{
// V(fp2,fp1) <+ (0)
// do nothing at all
}
if ((modelStruct.modelPar_flagfp2==1))
{
// I(gi,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(gi,fp1)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgsfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp1])));
d_dynamicContributions_dX[(admsNodeID_fp1)]-= ((d_qgsfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp1])));
// I(gi,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(gi,fp2)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgdfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp2])));
d_dynamicContributions_dX[(admsNodeID_fp2)]-= ((d_qgdfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp2])));
// I(s,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(s,fp1)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qcfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp1])));
d_dynamicContributions_dX[(admsNodeID_fp1)]-= ((d_qcfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp1])));
// I(s,fp2) <+ (0)
d_staticContributions_dX[admsNodeID_s]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp2)]-= 0.0;
// I(gi,si) <+ ((ddt(qsfp2)+ddt((minc*V(gi,si)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qsfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((d_qsfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
}
else
{
// I(s,fp1) <+ ((ddt(qgsfp2)+ddt((minc*V(s,fp1)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgsfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp1])));
d_dynamicContributions_dX[(admsNodeID_fp1)]-= ((d_qgsfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp1])));
// I(s,fp2) <+ ((ddt(qgdfp2)+ddt((minc*V(s,fp2)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgdfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp2])));
d_dynamicContributions_dX[(admsNodeID_fp2)]-= ((d_qgdfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp2])));
// I(gi,fp1) <+ ((ddt(qcfp2)+ddt((minc*V(gi,fp1)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qcfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp1])));
d_dynamicContributions_dX[(admsNodeID_fp1)]-= ((d_qcfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp1])));
// I(gi,fp2) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp2)]-= 0.0;
// I(gi,si) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_si)]-= 0.0;
}
// I(b,fp1) <+ ((ddt(qbfp2)+ddt((minc*V(b,fp1)))))
d_dynamicContributions_dX[admsNodeID_b]+= ((d_qbfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_fp1])));
d_dynamicContributions_dX[(admsNodeID_fp1)]-= ((d_qbfp2_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_fp1])));
d_idsfp1_dX = 0.0;
idsfp1 = 0;
d_qgsfp1_dX = 0.0;
qgsfp1 = 0;
d_qgdfp1_dX = 0.0;
qgdfp1 = 0;
d_qcfp1_dX = 0.0;
qcfp1 = 0;
d_qbfp1_dX = 0.0;
qbfp1 = 0;
d_qsfp1_dX = 0.0;
qsfp1 = 0;
d_vtdiblfp1_dX = 0.0;
vtdiblfp1 = 0;
d_vdsatfp1_dX = 0.0;
vdsatfp1 = 0;
if ((modelStruct.modelPar_lgfp1>modelStruct.modelPar_minl))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,modelStruct.modelPar_flagfp1s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp1,modelStruct.modelPar_cgfp1,modelStruct.modelPar_cfp1s,modelStruct.modelPar_ccfp1,modelStruct.modelPar_cbfp1,modelStruct.modelPar_vtofp1,modelStruct.modelPar_sfp1,modelStruct.modelPar_delta1fp1,0.0,modelStruct.modelPar_ndfp1,modelStruct.modelPar_alphafp1,modelStruct.modelPar_vx0fp1,modelStruct.modelPar_mu0fp1,modelStruct.modelPar_betafp1,modelStruct.modelPar_mthetafp1,modelStruct.modelPar_vthetafp1,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
d_idsfp1_dX = evaluator_calc_iq_0.getDerivs(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,modelStruct.modelPar_flagfp1s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp1,modelStruct.modelPar_cgfp1,modelStruct.modelPar_cfp1s,modelStruct.modelPar_ccfp1,modelStruct.modelPar_cbfp1,modelStruct.modelPar_vtofp1,modelStruct.modelPar_sfp1,modelStruct.modelPar_delta1fp1,0.0,modelStruct.modelPar_ndfp1,modelStruct.modelPar_alphafp1,modelStruct.modelPar_vx0fp1,modelStruct.modelPar_mu0fp1,modelStruct.modelPar_betafp1,modelStruct.modelPar_mthetafp1,modelStruct.modelPar_vthetafp1,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type,d_idsfp1_dX,d_qgsfp1_dX,d_qgdfp1_dX,d_qcfp1_dX,d_qbfp1_dX,d_qsfp1_dX,d_vtdiblfp1_dX,d_vdsatfp1_dX,d_vgsfp1_dX,d_vdsfp1_dX,0.0,d_vcfp1_dX,d_vbfp1_dX,0.0,d_tdut_dX,d_tnomk_dX,d_phit_dX,instanceStruct.d_instancePar_w_dX,modelStruct.d_modelPar_lgfp1_dX,modelStruct.d_modelPar_cgfp1_dX,modelStruct.d_modelPar_cfp1s_dX,modelStruct.d_modelPar_ccfp1_dX,modelStruct.d_modelPar_cbfp1_dX,modelStruct.d_modelPar_vtofp1_dX,modelStruct.d_modelPar_sfp1_dX,modelStruct.d_modelPar_delta1fp1_dX,0.0,modelStruct.d_modelPar_ndfp1_dX,modelStruct.d_modelPar_alphafp1_dX,modelStruct.d_modelPar_vx0fp1_dX,modelStruct.d_modelPar_mu0fp1_dX,modelStruct.d_modelPar_betafp1_dX,modelStruct.d_modelPar_mthetafp1_dX,modelStruct.d_modelPar_vthetafp1_dX,modelStruct.d_modelPar_vtzeta_dX,modelStruct.d_modelPar_dibsat_dX,modelStruct.d_modelPar_epsilon_dX,modelStruct.d_modelPar_vzeta_dX,modelStruct.d_modelPar_lambda_dX,0.0,0.0);
idsfp1 = evaluator_calc_iq_0.getValues(idsfp1,qgsfp1,qgdfp1,qcfp1,qbfp1,qsfp1,vtdiblfp1,vdsatfp1,vgsfp1,vdsfp1,1,vcfp1,vbfp1,modelStruct.modelPar_flagfp1s,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgfp1,modelStruct.modelPar_cgfp1,modelStruct.modelPar_cfp1s,modelStruct.modelPar_ccfp1,modelStruct.modelPar_cbfp1,modelStruct.modelPar_vtofp1,modelStruct.modelPar_sfp1,modelStruct.modelPar_delta1fp1,0.0,modelStruct.modelPar_ndfp1,modelStruct.modelPar_alphafp1,modelStruct.modelPar_vx0fp1,modelStruct.modelPar_mu0fp1,modelStruct.modelPar_betafp1,modelStruct.modelPar_mthetafp1,modelStruct.modelPar_vthetafp1,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
}
// I(fp1,di) <+ ((idsfp1+(gmin*V(fp1,di))))
d_staticContributions_dX[admsNodeID_fp1]+= d_idsfp1_dX;
d_staticContributions_dX[(admsNodeID_di)]-= d_idsfp1_dX;
}
else
{
// V(fp1,di) <+ (0)
// do nothing at all
}
if ((modelStruct.modelPar_flagfp1==1))
{
// I(gi,di) <+ ((ddt(qgsfp1)+ddt((minc*V(gi,di)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgsfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_di])));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((d_qgsfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_di])));
// I(gi,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(gi,fp1)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgdfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp1])));
d_dynamicContributions_dX[(admsNodeID_fp1)]-= ((d_qgdfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_fp1])));
// I(s,di) <+ ((ddt(qcfp1)+ddt((minc*V(s,di)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qcfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_di])));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((d_qcfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_di])));
// I(s,fp1) <+ (0)
d_staticContributions_dX[admsNodeID_s]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp1)]-= 0.0;
// I(gi,si) <+ ((ddt(qsfp1)+ddt((minc*V(gi,si)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qsfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((d_qsfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
}
else
{
// I(s,di) <+ ((ddt(qgsfp1)+ddt((minc*V(s,di)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgsfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_di])));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((d_qgsfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_di])));
// I(s,fp1) <+ ((ddt(qgdfp1)+ddt((minc*V(s,fp1)))))
d_dynamicContributions_dX[admsNodeID_s]+= ((d_qgdfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp1])));
d_dynamicContributions_dX[(admsNodeID_fp1)]-= ((d_qgdfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_s_fp1])));
// I(gi,di) <+ ((ddt(qcfp1)+ddt((minc*V(gi,di)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qcfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_di])));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((d_qcfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_di])));
// I(gi,fp1) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_fp1)]-= 0.0;
// I(gi,si) <+ (0)
d_staticContributions_dX[admsNodeID_gi]+= 0.0;
d_staticContributions_dX[(admsNodeID_si)]-= 0.0;
}
// I(b,di) <+ ((ddt(qbfp1)+ddt((minc*V(b,di)))))
d_dynamicContributions_dX[admsNodeID_b]+= ((d_qbfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_di])));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((d_qbfp1_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_b_di])));
d_idsrs_dX = 0.0;
idsrs = 0;
if (((modelStruct.modelPar_flagres==0)&&(modelStruct.modelPar_lgs>modelStruct.modelPar_minl)))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgs,modelStruct.modelPar_cgrs,0,0,0,modelStruct.modelPar_vtors,modelStruct.modelPar_srs,modelStruct.modelPar_delta1rs,0.0,modelStruct.modelPar_ndrs,modelStruct.modelPar_alphars,modelStruct.modelPar_vx0rs,modelStruct.modelPar_mu0rs,modelStruct.modelPar_betars,modelStruct.modelPar_mthetars,modelStruct.modelPar_vthetars,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
d_idsrs_dX = evaluator_calc_iq_0.getDerivs(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgs,modelStruct.modelPar_cgrs,0,0,0,modelStruct.modelPar_vtors,modelStruct.modelPar_srs,modelStruct.modelPar_delta1rs,0.0,modelStruct.modelPar_ndrs,modelStruct.modelPar_alphars,modelStruct.modelPar_vx0rs,modelStruct.modelPar_mu0rs,modelStruct.modelPar_betars,modelStruct.modelPar_mthetars,modelStruct.modelPar_vthetars,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type,d_idsrs_dX,d_qgsrs_dX,d_qgdrs_dX,d_qcrs_dX,d_qbrs_dX,d_qsrs_dX,d_vtdiblrs_dX,d_vdsatrs_dX,d_vgsrs_dX,d_vdsrs_dX,0.0,0.0,0.0,0.0,d_tdut_dX,d_tnomk_dX,d_phit_dX,instanceStruct.d_instancePar_w_dX,modelStruct.d_modelPar_lgs_dX,modelStruct.d_modelPar_cgrs_dX,0.0,0.0,0.0,modelStruct.d_modelPar_vtors_dX,modelStruct.d_modelPar_srs_dX,modelStruct.d_modelPar_delta1rs_dX,0.0,modelStruct.d_modelPar_ndrs_dX,modelStruct.d_modelPar_alphars_dX,modelStruct.d_modelPar_vx0rs_dX,modelStruct.d_modelPar_mu0rs_dX,modelStruct.d_modelPar_betars_dX,modelStruct.d_modelPar_mthetars_dX,modelStruct.d_modelPar_vthetars_dX,modelStruct.d_modelPar_vtzeta_dX,modelStruct.d_modelPar_dibsat_dX,modelStruct.d_modelPar_epsilon_dX,modelStruct.d_modelPar_vzeta_dX,modelStruct.d_modelPar_lambda_dX,0.0,0.0);
idsrs = evaluator_calc_iq_0.getValues(idsrs,qgsrs,qgdrs,qcrs,qbrs,qsrs,vtdiblrs,vdsatrs,vgsrs,vdsrs,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgs,modelStruct.modelPar_cgrs,0,0,0,modelStruct.modelPar_vtors,modelStruct.modelPar_srs,modelStruct.modelPar_delta1rs,0.0,modelStruct.modelPar_ndrs,modelStruct.modelPar_alphars,modelStruct.modelPar_vx0rs,modelStruct.modelPar_mu0rs,modelStruct.modelPar_betars,modelStruct.modelPar_mthetars,modelStruct.modelPar_vthetars,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
}
// I(si,src) <+ ((idsrs+(gmin*V(si,src))))
d_staticContributions_dX[admsNodeID_si]+= d_idsrs_dX;
d_staticContributions_dX[(admsNodeID_src)]-= d_idsrs_dX;
}
else
{
// V(src,si) <+ (0)
// do nothing at all
}
d_idsrd_dX = 0.0;
idsrd = 0;
if (((modelStruct.modelPar_flagres==0)&&(modelStruct.modelPar_lgd>modelStruct.modelPar_minl)))
{
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgd,modelStruct.modelPar_cgrd,0,0,0,modelStruct.modelPar_vtord,modelStruct.modelPar_srd,modelStruct.modelPar_delta1rd,0.0,modelStruct.modelPar_ndrd,modelStruct.modelPar_alphard,modelStruct.modelPar_vx0rd,modelStruct.modelPar_mu0rd,modelStruct.modelPar_betard,modelStruct.modelPar_mthetard,modelStruct.modelPar_vthetard,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
d_idsrd_dX = evaluator_calc_iq_0.getDerivs(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgd,modelStruct.modelPar_cgrd,0,0,0,modelStruct.modelPar_vtord,modelStruct.modelPar_srd,modelStruct.modelPar_delta1rd,0.0,modelStruct.modelPar_ndrd,modelStruct.modelPar_alphard,modelStruct.modelPar_vx0rd,modelStruct.modelPar_mu0rd,modelStruct.modelPar_betard,modelStruct.modelPar_mthetard,modelStruct.modelPar_vthetard,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type,d_idsrd_dX,d_qgsrd_dX,d_qgdrd_dX,d_qcrd_dX,d_qbrd_dX,d_qsrd_dX,d_vtdiblrd_dX,d_vdsatrd_dX,d_vgsrd_dX,d_vdsrd_dX,0.0,0.0,0.0,0.0,d_tdut_dX,d_tnomk_dX,d_phit_dX,instanceStruct.d_instancePar_w_dX,modelStruct.d_modelPar_lgd_dX,modelStruct.d_modelPar_cgrd_dX,0.0,0.0,0.0,modelStruct.d_modelPar_vtord_dX,modelStruct.d_modelPar_srd_dX,modelStruct.d_modelPar_delta1rd_dX,0.0,modelStruct.d_modelPar_ndrd_dX,modelStruct.d_modelPar_alphard_dX,modelStruct.d_modelPar_vx0rd_dX,modelStruct.d_modelPar_mu0rd_dX,modelStruct.d_modelPar_betard_dX,modelStruct.d_modelPar_mthetard_dX,modelStruct.d_modelPar_vthetard_dX,modelStruct.d_modelPar_vtzeta_dX,modelStruct.d_modelPar_dibsat_dX,modelStruct.d_modelPar_epsilon_dX,modelStruct.d_modelPar_vzeta_dX,modelStruct.d_modelPar_lambda_dX,0.0,0.0);
idsrd = evaluator_calc_iq_0.getValues(idsrd,qgsrd,qgdrd,qcrd,qbrd,qsrd,vtdiblrd,vdsatrd,vgsrd,vdsrd,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,modelStruct.modelPar_lgd,modelStruct.modelPar_cgrd,0,0,0,modelStruct.modelPar_vtord,modelStruct.modelPar_srd,modelStruct.modelPar_delta1rd,0.0,modelStruct.modelPar_ndrd,modelStruct.modelPar_alphard,modelStruct.modelPar_vx0rd,modelStruct.modelPar_mu0rd,modelStruct.modelPar_betard,modelStruct.modelPar_mthetard,modelStruct.modelPar_vthetard,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
}
// I(drc,fp4) <+ ((idsrd+(gmin*V(drc,fp4))))
d_staticContributions_dX[admsNodeID_drc]+= d_idsrd_dX;
d_staticContributions_dX[(admsNodeID_fp4)]-= d_idsrd_dX;
}
else
{
// V(drc,fp4) <+ (0)
// do nothing at all
}
{
AnalogFunctions::calc_iqEvaluator evaluator_calc_iq_0(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,instanceStruct.instancePar_l,modelStruct.modelPar_cg,0,0,0,modelStruct.modelPar_vto,modelStruct.modelPar_ss,modelStruct.modelPar_delta1,modelStruct.modelPar_delta2,modelStruct.modelPar_nd,modelStruct.modelPar_alpha,modelStruct.modelPar_vx0,modelStruct.modelPar_mu0,modelStruct.modelPar_beta,modelStruct.modelPar_mtheta,modelStruct.modelPar_vtheta,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
d_ids_dX = evaluator_calc_iq_0.getDerivs(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,instanceStruct.instancePar_l,modelStruct.modelPar_cg,0,0,0,modelStruct.modelPar_vto,modelStruct.modelPar_ss,modelStruct.modelPar_delta1,modelStruct.modelPar_delta2,modelStruct.modelPar_nd,modelStruct.modelPar_alpha,modelStruct.modelPar_vx0,modelStruct.modelPar_mu0,modelStruct.modelPar_beta,modelStruct.modelPar_mtheta,modelStruct.modelPar_vtheta,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type,d_ids_dX,d_qgs_dX,d_qgd_dX,d_qc_dX,d_qb_dX,d_qs_dX,d_vtdibli_dX,d_vdsat1i_dX,d_vgsi_dX,d_vdsi_dX,0.0,0.0,0.0,0.0,d_tdut_dX,d_tnomk_dX,d_phit_dX,instanceStruct.d_instancePar_w_dX,instanceStruct.d_instancePar_l_dX,modelStruct.d_modelPar_cg_dX,0.0,0.0,0.0,modelStruct.d_modelPar_vto_dX,modelStruct.d_modelPar_ss_dX,modelStruct.d_modelPar_delta1_dX,modelStruct.d_modelPar_delta2_dX,modelStruct.d_modelPar_nd_dX,modelStruct.d_modelPar_alpha_dX,modelStruct.d_modelPar_vx0_dX,modelStruct.d_modelPar_mu0_dX,modelStruct.d_modelPar_beta_dX,modelStruct.d_modelPar_mtheta_dX,modelStruct.d_modelPar_vtheta_dX,modelStruct.d_modelPar_vtzeta_dX,modelStruct.d_modelPar_dibsat_dX,modelStruct.d_modelPar_epsilon_dX,modelStruct.d_modelPar_vzeta_dX,modelStruct.d_modelPar_lambda_dX,0.0,0.0);
ids = evaluator_calc_iq_0.getValues(ids,qgs,qgd,qc,qb,qs,vtdibli,vdsat1i,vgsi,vdsi,0,0,0,0,tdut,tnomk,phit,instanceStruct.instancePar_w,instanceStruct.instancePar_l,modelStruct.modelPar_cg,0,0,0,modelStruct.modelPar_vto,modelStruct.modelPar_ss,modelStruct.modelPar_delta1,modelStruct.modelPar_delta2,modelStruct.modelPar_nd,modelStruct.modelPar_alpha,modelStruct.modelPar_vx0,modelStruct.modelPar_mu0,modelStruct.modelPar_beta,modelStruct.modelPar_mtheta,modelStruct.modelPar_vtheta,modelStruct.modelPar_vtzeta,modelStruct.modelPar_dibsat,modelStruct.modelPar_epsilon,modelStruct.modelPar_vzeta,modelStruct.modelPar_lambda,instanceStruct.instancePar_ngf,modelStruct.modelPar_type);
}
idsrf = (probeVars[admsProbeID_V_xt2_GND]);
if ((modelStruct.modelPar_gmdisp==0))
{
// V(xt1,GND) <+ (0)
// do nothing at all
// V(xt2,GND) <+ (0)
// do nothing at all
// I(di,si) <+ ((ids+(gmin*V(di,si))))
d_staticContributions_dX[admsNodeID_di]+= d_ids_dX;
d_staticContributions_dX[(admsNodeID_si)]-= d_ids_dX;
}
else
{
// I(xt1,GND) <+ ((ids-V(xt2,GND)))
d_staticContributions_dX[admsNodeID_xt1]+= d_ids_dX;
// I(xt1,GND) <+ ((-ddt((taugmrf*V(xt1,GND)))))
d_dynamicContributions_dX[admsNodeID_xt1]+= (-(modelStruct.d_modelPar_taugmrf_dX*(probeVars[admsProbeID_V_xt1_GND])));
// I(xt2,GND) <+ ((V(xt1,GND)-V(xt2,GND)))
d_staticContributions_dX[admsNodeID_xt2]+= 0.0;
// I(xt2,GND) <+ ((-ddt(((taugmrf/3.0)*V(xt2,GND)))))
d_dynamicContributions_dX[admsNodeID_xt2]+= (-((modelStruct.d_modelPar_taugmrf_dX/3.0)*(probeVars[admsProbeID_V_xt2_GND])));
// I(di,si) <+ ((idsrf+(gmin*V(di,si))))
d_staticContributions_dX[admsNodeID_di]+= 0.0;
d_staticContributions_dX[(admsNodeID_si)]-= 0.0;
}
// I(gi,si) <+ ((ddt(qgs)+ddt((minc*V(gi,si)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgs_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
d_dynamicContributions_dX[(admsNodeID_si)]-= ((d_qgs_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_si])));
// I(gi,di) <+ ((ddt(qgd)+ddt((minc*V(gi,di)))))
d_dynamicContributions_dX[admsNodeID_gi]+= ((d_qgd_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_di])));
d_dynamicContributions_dX[(admsNodeID_di)]-= ((d_qgd_dX)+(modelStruct.d_modelPar_minc_dX*(probeVars[admsProbeID_V_gi_di])));
d_igsi_dX = 0.0;
igsi = 0;
d_igdi_dX = 0.0;
igdi = 0;
d_igssdio_dX = 0.0;
igssdio = 0;
d_igdsdio_dX = 0.0;
igdsdio = 0;
d_igsrec_dX = 0.0;
igsrec = 0;
d_igdrec_dX = 0.0;
igdrec = 0;
if ((modelStruct.modelPar_igmod==1))
{
{
AnalogFunctions::calc_igEvaluator evaluator_calc_ig_0(igssdio,igsrec,vgsi,phit,modelStruct.modelPar_vgsats,modelStruct.modelPar_alphags,modelStruct.modelPar_fracs,modelStruct.modelPar_pg_params,modelStruct.modelPar_pbdgs,modelStruct.modelPar_vbdgs,tdut,tnomk,instanceStruct.instancePar_w,instanceStruct.instancePar_ngf,modelStruct.modelPar_ijs,modelStruct.modelPar_kbdgates,modelStruct.modelPar_vgsatqs,modelStruct.modelPar_betarecs,modelStruct.modelPar_irecs,modelStruct.modelPar_pgsrecs,modelStruct.modelPar_pg_param1,modelStruct.modelPar_vjg,modelStruct.modelPar_type);
d_igsi_dX = evaluator_calc_ig_0.getDerivs(igssdio,igsrec,vgsi,phit,modelStruct.modelPar_vgsats,modelStruct.modelPar_alphags,modelStruct.modelPar_fracs,modelStruct.modelPar_pg_params,modelStruct.modelPar_pbdgs,modelStruct.modelPar_vbdgs,tdut,tnomk,instanceStruct.instancePar_w,instanceStruct.instancePar_ngf,modelStruct.modelPar_ijs,modelStruct.modelPar_kbdgates,modelStruct.modelPar_vgsatqs,modelStruct.modelPar_betarecs,modelStruct.modelPar_irecs,modelStruct.modelPar_pgsrecs,modelStruct.modelPar_pg_param1,modelStruct.modelPar_vjg,modelStruct.modelPar_type,d_igssdio_dX,d_igsrec_dX,d_vgsi_dX,d_phit_dX,modelStruct.d_modelPar_vgsats_dX,modelStruct.d_modelPar_alphags_dX,modelStruct.d_modelPar_fracs_dX,modelStruct.d_modelPar_pg_params_dX,modelStruct.d_modelPar_pbdgs_dX,modelStruct.d_modelPar_vbdgs_dX,d_tdut_dX,d_tnomk_dX,instanceStruct.d_instancePar_w_dX,0.0,modelStruct.d_modelPar_ijs_dX,modelStruct.d_modelPar_kbdgates_dX,modelStruct.d_modelPar_vgsatqs_dX,modelStruct.d_modelPar_betarecs_dX,modelStruct.d_modelPar_irecs_dX,modelStruct.d_modelPar_pgsrecs_dX,modelStruct.d_modelPar_pg_param1_dX,modelStruct.d_modelPar_vjg_dX,0.0);
igsi = evaluator_calc_ig_0.getValues(igssdio,igsrec,vgsi,phit,modelStruct.modelPar_vgsats,modelStruct.modelPar_alphags,modelStruct.modelPar_fracs,modelStruct.modelPar_pg_params,modelStruct.modelPar_pbdgs,modelStruct.modelPar_vbdgs,tdut,tnomk,instanceStruct.instancePar_w,instanceStruct.instancePar_ngf,modelStruct.modelPar_ijs,modelStruct.modelPar_kbdgates,modelStruct.modelPar_vgsatqs,modelStruct.modelPar_betarecs,modelStruct.modelPar_irecs,modelStruct.modelPar_pgsrecs,modelStruct.modelPar_pg_param1,modelStruct.modelPar_vjg,modelStruct.modelPar_type);
}
{
AnalogFunctions::calc_igEvaluator evaluator_calc_ig_0(igdsdio,igdrec,(vgsi-vdsi),phit,modelStruct.modelPar_vgsatd,modelStruct.modelPar_alphagd,modelStruct.modelPar_fracd,modelStruct.modelPar_pg_paramd,modelStruct.modelPar_pbdgd,modelStruct.modelPar_vbdgd,tdut,tnomk,instanceStruct.instancePar_w,instanceStruct.instancePar_ngf,modelStruct.modelPar_ijd,modelStruct.modelPar_kbdgated,modelStruct.modelPar_vgsatqd,modelStruct.modelPar_betarecd,modelStruct.modelPar_irecd,modelStruct.modelPar_pgsrecd,modelStruct.modelPar_pg_param1,modelStruct.modelPar_vjg,modelStruct.modelPar_type);
d_igdi_dX = evaluator_calc_ig_0.getDerivs(igdsdio,igdrec,(vgsi-vdsi),phit,modelStruct.modelPar_vgsatd,modelStruct.modelPar_alphagd,modelStruct.modelPar_fracd,modelStruct.modelPar_pg_paramd,modelStruct.modelPar_pbdgd,modelStruct.modelPar_vbdgd,tdut,tnomk,instanceStruct.instancePar_w,instanceStruct.instancePar_ngf,modelStruct.modelPar_ijd,modelStruct.modelPar_kbdgated,modelStruct.modelPar_vgsatqd,modelStruct.modelPar_betarecd,modelStruct.modelPar_irecd,modelStruct.modelPar_pgsrecd,modelStruct.modelPar_pg_param1,modelStruct.modelPar_vjg,modelStruct.modelPar_type,d_igdsdio_dX,d_igdrec_dX,(d_vgsi_dX-d_vdsi_dX),d_phit_dX,modelStruct.d_modelPar_vgsatd_dX,modelStruct.d_modelPar_alphagd_dX,modelStruct.d_modelPar_fracd_dX,modelStruct.d_modelPar_pg_paramd_dX,modelStruct.d_modelPar_pbdgd_dX,modelStruct.d_modelPar_vbdgd_dX,d_tdut_dX,d_tnomk_dX,instanceStruct.d_instancePar_w_dX,0.0,modelStruct.d_modelPar_ijd_dX,modelStruct.d_modelPar_kbdgated_dX,modelStruct.d_modelPar_vgsatqd_dX,modelStruct.d_modelPar_betarecd_dX,modelStruct.d_modelPar_irecd_dX,modelStruct.d_modelPar_pgsrecd_dX,modelStruct.d_modelPar_pg_param1_dX,modelStruct.d_modelPar_vjg_dX,0.0);
igdi = evaluator_calc_ig_0.getValues(igdsdio,igdrec,(vgsi-vdsi),phit,modelStruct.modelPar_vgsatd,modelStruct.modelPar_alphagd,modelStruct.modelPar_fracd,modelStruct.modelPar_pg_paramd,modelStruct.modelPar_pbdgd,modelStruct.modelPar_vbdgd,tdut,tnomk,instanceStruct.instancePar_w,instanceStruct.instancePar_ngf,modelStruct.modelPar_ijd,modelStruct.modelPar_kbdgated,modelStruct.modelPar_vgsatqd,modelStruct.modelPar_betarecd,modelStruct.modelPar_irecd,modelStruct.modelPar_pgsrecd,modelStruct.modelPar_pg_param1,modelStruct.modelPar_vjg,modelStruct.modelPar_type);
}
// I(gi,si) <+ ((igsi+(gmin*V(gi,si))))
d_staticContributions_dX[admsNodeID_gi]+= d_igsi_dX;
d_staticContributions_dX[(admsNodeID_si)]-= d_igsi_dX;
// I(gi,di) <+ ((igdi+(gmin*V(gi,di))))
d_staticContributions_dX[admsNodeID_gi]+= d_igdi_dX;
d_staticContributions_dX[(admsNodeID_di)]-= d_igdi_dX;
}
if ((instanceStruct.instanceVar_rcd_w<=modelStruct.modelPar_minr))
{
// V(d,drc) <+ (0)
// do nothing at all
}
else
{
// I(d,drc) <+ ((V(d,drc)/rdi))
d_staticContributions_dX[admsNodeID_d]+= (-(probeVars[admsProbeID_V_d_drc])*d_rdi_dX/rdi/rdi);
d_staticContributions_dX[(admsNodeID_drc)]-= (-(probeVars[admsProbeID_V_d_drc])*d_rdi_dX/rdi/rdi);
}
if ((instanceStruct.instanceVar_rcs_w<=modelStruct.modelPar_minr))
{
// V(src,s) <+ (0)
// do nothing at all
}
else
{
// I(src,s) <+ ((V(src,s)/rsi))
d_staticContributions_dX[admsNodeID_src]+= (-(probeVars[admsProbeID_V_src_s])*d_rsi_dX/rsi/rsi);
d_staticContributions_dX[(admsNodeID_s)]-= (-(probeVars[admsProbeID_V_src_s])*d_rsi_dX/rsi/rsi);
}
if ((instanceStruct.instanceVar_rg<=modelStruct.modelPar_minr))
{
// V(g,gi) <+ (0)
// do nothing at all
}
else
{
// I(g,gi) <+ ((V(g,gi)/rg))
d_staticContributions_dX[admsNodeID_g]+= (-(probeVars[admsProbeID_V_g_gi])*instanceStruct.d_instanceVar_rg_dX/instanceStruct.instanceVar_rg/instanceStruct.instanceVar_rg);
d_staticContributions_dX[(admsNodeID_gi)]-= (-(probeVars[admsProbeID_V_g_gi])*instanceStruct.d_instanceVar_rg_dX/instanceStruct.instanceVar_rg/instanceStruct.instanceVar_rg);
}
d_qofs_dX = ((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.d_modelPar_cofsm_dX+instanceStruct.d_instancePar_w_dX*instanceStruct.instancePar_ngf*modelStruct.modelPar_cofsm)*(probeVars[admsProbeID_V_gi_s]);
qofs = (((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.modelPar_cofsm)*(probeVars[admsProbeID_V_gi_s]));
// I(gi,s) <+ (ddt(qofs))
d_dynamicContributions_dX[admsNodeID_gi]+= (d_qofs_dX);
d_dynamicContributions_dX[(admsNodeID_s)]-= (d_qofs_dX);
d_qofd_dX = ((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.d_modelPar_cofdm_dX+instanceStruct.d_instancePar_w_dX*instanceStruct.instancePar_ngf*modelStruct.modelPar_cofdm)*(probeVars[admsProbeID_V_gi_d]);
qofd = (((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.modelPar_cofdm)*(probeVars[admsProbeID_V_gi_d]));
// I(gi,d) <+ (ddt(qofd))
d_dynamicContributions_dX[admsNodeID_gi]+= (d_qofd_dX);
d_dynamicContributions_dX[(admsNodeID_d)]-= (d_qofd_dX);
d_qofds_dX = ((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.d_modelPar_cofdsm_dX+instanceStruct.d_instancePar_w_dX*instanceStruct.instancePar_ngf*modelStruct.modelPar_cofdsm)*(probeVars[admsProbeID_V_d_s]);
qofds = (((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.modelPar_cofdsm)*(probeVars[admsProbeID_V_d_s]));
// I(d,s) <+ (ddt(qofds))
d_dynamicContributions_dX[admsNodeID_d]+= (d_qofds_dX);
d_dynamicContributions_dX[(admsNodeID_s)]-= (d_qofds_dX);
d_qofdsub_dX = ((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.d_modelPar_cofdsubm_dX+instanceStruct.d_instancePar_w_dX*instanceStruct.instancePar_ngf*modelStruct.modelPar_cofdsubm)*(probeVars[admsProbeID_V_d_b]);
qofdsub = (((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.modelPar_cofdsubm)*(probeVars[admsProbeID_V_d_b]));
// I(d,b) <+ (ddt(qofdsub))
d_dynamicContributions_dX[admsNodeID_d]+= (d_qofdsub_dX);
d_dynamicContributions_dX[(admsNodeID_b)]-= (d_qofdsub_dX);
d_qofssub_dX = ((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.d_modelPar_cofssubm_dX+instanceStruct.d_instancePar_w_dX*instanceStruct.instancePar_ngf*modelStruct.modelPar_cofssubm)*(probeVars[admsProbeID_V_s_b]);
qofssub = (((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.modelPar_cofssubm)*(probeVars[admsProbeID_V_s_b]));
// I(s,b) <+ (ddt(qofssub))
d_dynamicContributions_dX[admsNodeID_s]+= (d_qofssub_dX);
d_dynamicContributions_dX[(admsNodeID_b)]-= (d_qofssub_dX);
d_qofgsub_dX = ((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.d_modelPar_cofgsubm_dX+instanceStruct.d_instancePar_w_dX*instanceStruct.instancePar_ngf*modelStruct.modelPar_cofgsubm)*(probeVars[admsProbeID_V_gi_b]);
qofgsub = (((instanceStruct.instancePar_w*instanceStruct.instancePar_ngf)*modelStruct.modelPar_cofgsubm)*(probeVars[admsProbeID_V_gi_b]));
// I(gi,b) <+ (ddt(qofgsub))
d_dynamicContributions_dX[admsNodeID_gi]+= (d_qofgsub_dX);
d_dynamicContributions_dX[(admsNodeID_b)]-= (d_qofgsub_dX);
gm = 0;
svc = 0;
if ((modelStruct.modelPar_noisemod==1))
{
 UserError(theInstance) << "$finish called." << std::endl; 
}
d_pdiss_dX = ((((((d_ids_dX*(probeVars[admsProbeID_V_di_si])+d_idsrd_dX*(probeVars[admsProbeID_V_drc_fp4]))+d_idsrs_dX*(probeVars[admsProbeID_V_si_src]))+d_idsfp1_dX*(probeVars[admsProbeID_V_fp1_di]))+d_idsfp2_dX*(probeVars[admsProbeID_V_fp2_fp1]))+d_idsfp3_dX*(probeVars[admsProbeID_V_fp3_fp2]))+d_idsfp4_dX*(probeVars[admsProbeID_V_fp4_fp3]));
pdiss = (((((((ids*(probeVars[admsProbeID_V_di_si]))+(idsrd*(probeVars[admsProbeID_V_drc_fp4])))+(idsrs*(probeVars[admsProbeID_V_si_src])))+(idsfp1*(probeVars[admsProbeID_V_fp1_di])))+(idsfp2*(probeVars[admsProbeID_V_fp2_fp1])))+(idsfp3*(probeVars[admsProbeID_V_fp3_fp2])))+(idsfp4*(probeVars[admsProbeID_V_fp4_fp3])));
if ((rdi!=0))
{
d_pdiss_dX = (d_pdiss_dX+(-((probeVars[admsProbeID_V_drc_d])*(probeVars[admsProbeID_V_drc_d]))*d_rdi_dX/rdi/rdi));
pdiss = (pdiss+(((probeVars[admsProbeID_V_drc_d])*(probeVars[admsProbeID_V_drc_d]))/rdi));
}
if ((rsi!=0))
{
d_pdiss_dX = (d_pdiss_dX+(-((probeVars[admsProbeID_V_src_s])*(probeVars[admsProbeID_V_src_s]))*d_rsi_dX/rsi/rsi));
pdiss = (pdiss+(((probeVars[admsProbeID_V_src_s])*(probeVars[admsProbeID_V_src_s]))/rsi));
}
if ((modelStruct.modelPar_rth>0))
{
// Pwr(dt,GND) <+ (ddt((cth*Temp(dt,GND))))
d_dynamicContributions_dX[admsNodeID_dt]+= (modelStruct.d_modelPar_cth_dX*(probeVars[admsProbeID_Temp_dt_GND]));
// Pwr(dt,GND) <+ ((-pdiss))
d_staticContributions_dX[admsNodeID_dt]+= (-d_pdiss_dX);
// Pwr(dt,GND) <+ ((Temp(dt,GND)/rth))
d_staticContributions_dX[admsNodeID_dt]+= (-(probeVars[admsProbeID_Temp_dt_GND])*modelStruct.d_modelPar_rth_dX/modelStruct.modelPar_rth/modelStruct.modelPar_rth);
}
else
{
// Temp(dt,GND) <+ (0.0)
// do nothing at all
}
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(18+0);
dqdp.resize(18+0);
Findices.resize(18+0);
Qindices.resize(18+0);

std::vector <double> probeVars(45);
std::vector <double> d_staticContributions_dX(18+0);
std::vector <double> d_dynamicContributions_dX(18+0);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 18+0 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_version=mod.version;
modelStruct.d_modelPar_version_dX=0.0;
modelStruct.modelPar_given_version=mod.given("version");
modelStruct.modelPar_tnom=mod.tnom;
modelStruct.d_modelPar_tnom_dX=0.0;
modelStruct.modelPar_given_tnom=mod.given("tnom");
modelStruct.modelPar_cg=mod.cg;
modelStruct.d_modelPar_cg_dX=0.0;
modelStruct.modelPar_given_cg=mod.given("cg");
modelStruct.modelPar_cofsm=mod.cofsm;
modelStruct.d_modelPar_cofsm_dX=0.0;
modelStruct.modelPar_given_cofsm=mod.given("cofsm");
modelStruct.modelPar_cofdm=mod.cofdm;
modelStruct.d_modelPar_cofdm_dX=0.0;
modelStruct.modelPar_given_cofdm=mod.given("cofdm");
modelStruct.modelPar_cofdsm=mod.cofdsm;
modelStruct.d_modelPar_cofdsm_dX=0.0;
modelStruct.modelPar_given_cofdsm=mod.given("cofdsm");
modelStruct.modelPar_cofdsubm=mod.cofdsubm;
modelStruct.d_modelPar_cofdsubm_dX=0.0;
modelStruct.modelPar_given_cofdsubm=mod.given("cofdsubm");
modelStruct.modelPar_cofssubm=mod.cofssubm;
modelStruct.d_modelPar_cofssubm_dX=0.0;
modelStruct.modelPar_given_cofssubm=mod.given("cofssubm");
modelStruct.modelPar_cofgsubm=mod.cofgsubm;
modelStruct.d_modelPar_cofgsubm_dX=0.0;
modelStruct.modelPar_given_cofgsubm=mod.given("cofgsubm");
modelStruct.modelPar_rsh=mod.rsh;
modelStruct.d_modelPar_rsh_dX=0.0;
modelStruct.modelPar_given_rsh=mod.given("rsh");
modelStruct.modelPar_rcs=mod.rcs;
modelStruct.d_modelPar_rcs_dX=0.0;
modelStruct.modelPar_given_rcs=mod.given("rcs");
modelStruct.modelPar_rcd=mod.rcd;
modelStruct.d_modelPar_rcd_dX=0.0;
modelStruct.modelPar_given_rcd=mod.given("rcd");
modelStruct.modelPar_vx0=mod.vx0;
modelStruct.d_modelPar_vx0_dX=0.0;
modelStruct.modelPar_given_vx0=mod.given("vx0");
modelStruct.modelPar_mu0=mod.mu0;
modelStruct.d_modelPar_mu0_dX=0.0;
modelStruct.modelPar_given_mu0=mod.given("mu0");
modelStruct.modelPar_beta=mod.beta;
modelStruct.d_modelPar_beta_dX=0.0;
modelStruct.modelPar_given_beta=mod.given("beta");
modelStruct.modelPar_vto=mod.vto;
modelStruct.d_modelPar_vto_dX=0.0;
modelStruct.modelPar_given_vto=mod.given("vto");
modelStruct.modelPar_ss=mod.ss;
modelStruct.d_modelPar_ss_dX=0.0;
modelStruct.modelPar_given_ss=mod.given("ss");
modelStruct.modelPar_delta1=mod.delta1;
modelStruct.d_modelPar_delta1_dX=0.0;
modelStruct.modelPar_given_delta1=mod.given("delta1");
modelStruct.modelPar_delta2=mod.delta2;
modelStruct.d_modelPar_delta2_dX=0.0;
modelStruct.modelPar_given_delta2=mod.given("delta2");
modelStruct.modelPar_dibsat=mod.dibsat;
modelStruct.d_modelPar_dibsat_dX=0.0;
modelStruct.modelPar_given_dibsat=mod.given("dibsat");
modelStruct.modelPar_nd=mod.nd;
modelStruct.d_modelPar_nd_dX=0.0;
modelStruct.modelPar_given_nd=mod.given("nd");
modelStruct.modelPar_alpha=mod.alpha;
modelStruct.d_modelPar_alpha_dX=0.0;
modelStruct.modelPar_given_alpha=mod.given("alpha");
modelStruct.modelPar_lambda=mod.lambda;
modelStruct.d_modelPar_lambda_dX=0.0;
modelStruct.modelPar_given_lambda=mod.given("lambda");
modelStruct.modelPar_vtheta=mod.vtheta;
modelStruct.d_modelPar_vtheta_dX=0.0;
modelStruct.modelPar_given_vtheta=mod.given("vtheta");
modelStruct.modelPar_mtheta=mod.mtheta;
modelStruct.d_modelPar_mtheta_dX=0.0;
modelStruct.modelPar_given_mtheta=mod.given("mtheta");
modelStruct.modelPar_vzeta=mod.vzeta;
modelStruct.d_modelPar_vzeta_dX=0.0;
modelStruct.modelPar_given_vzeta=mod.given("vzeta");
modelStruct.modelPar_vtzeta=mod.vtzeta;
modelStruct.d_modelPar_vtzeta_dX=0.0;
modelStruct.modelPar_given_vtzeta=mod.given("vtzeta");
modelStruct.modelPar_epsilon=mod.epsilon;
modelStruct.d_modelPar_epsilon_dX=0.0;
modelStruct.modelPar_given_epsilon=mod.given("epsilon");
modelStruct.modelPar_rct1=mod.rct1;
modelStruct.d_modelPar_rct1_dX=0.0;
modelStruct.modelPar_given_rct1=mod.given("rct1");
modelStruct.modelPar_rct2=mod.rct2;
modelStruct.d_modelPar_rct2_dX=0.0;
modelStruct.modelPar_given_rct2=mod.given("rct2");
modelStruct.modelPar_lgs=mod.lgs;
modelStruct.d_modelPar_lgs_dX=0.0;
modelStruct.modelPar_given_lgs=mod.given("lgs");
modelStruct.modelPar_vtors=mod.vtors;
modelStruct.d_modelPar_vtors_dX=0.0;
modelStruct.modelPar_given_vtors=mod.given("vtors");
modelStruct.modelPar_cgrs=mod.cgrs;
modelStruct.d_modelPar_cgrs_dX=0.0;
modelStruct.modelPar_given_cgrs=mod.given("cgrs");
modelStruct.modelPar_vx0rs=mod.vx0rs;
modelStruct.d_modelPar_vx0rs_dX=0.0;
modelStruct.modelPar_given_vx0rs=mod.given("vx0rs");
modelStruct.modelPar_mu0rs=mod.mu0rs;
modelStruct.d_modelPar_mu0rs_dX=0.0;
modelStruct.modelPar_given_mu0rs=mod.given("mu0rs");
modelStruct.modelPar_betars=mod.betars;
modelStruct.d_modelPar_betars_dX=0.0;
modelStruct.modelPar_given_betars=mod.given("betars");
modelStruct.modelPar_delta1rs=mod.delta1rs;
modelStruct.d_modelPar_delta1rs_dX=0.0;
modelStruct.modelPar_given_delta1rs=mod.given("delta1rs");
modelStruct.modelPar_srs=mod.srs;
modelStruct.d_modelPar_srs_dX=0.0;
modelStruct.modelPar_given_srs=mod.given("srs");
modelStruct.modelPar_ndrs=mod.ndrs;
modelStruct.d_modelPar_ndrs_dX=0.0;
modelStruct.modelPar_given_ndrs=mod.given("ndrs");
modelStruct.modelPar_vthetars=mod.vthetars;
modelStruct.d_modelPar_vthetars_dX=0.0;
modelStruct.modelPar_given_vthetars=mod.given("vthetars");
modelStruct.modelPar_mthetars=mod.mthetars;
modelStruct.d_modelPar_mthetars_dX=0.0;
modelStruct.modelPar_given_mthetars=mod.given("mthetars");
modelStruct.modelPar_alphars=mod.alphars;
modelStruct.d_modelPar_alphars_dX=0.0;
modelStruct.modelPar_given_alphars=mod.given("alphars");
modelStruct.modelPar_lgd=mod.lgd;
modelStruct.d_modelPar_lgd_dX=0.0;
modelStruct.modelPar_given_lgd=mod.given("lgd");
modelStruct.modelPar_vtord=mod.vtord;
modelStruct.d_modelPar_vtord_dX=0.0;
modelStruct.modelPar_given_vtord=mod.given("vtord");
modelStruct.modelPar_cgrd=mod.cgrd;
modelStruct.d_modelPar_cgrd_dX=0.0;
modelStruct.modelPar_given_cgrd=mod.given("cgrd");
modelStruct.modelPar_vx0rd=mod.vx0rd;
modelStruct.d_modelPar_vx0rd_dX=0.0;
modelStruct.modelPar_given_vx0rd=mod.given("vx0rd");
modelStruct.modelPar_mu0rd=mod.mu0rd;
modelStruct.d_modelPar_mu0rd_dX=0.0;
modelStruct.modelPar_given_mu0rd=mod.given("mu0rd");
modelStruct.modelPar_betard=mod.betard;
modelStruct.d_modelPar_betard_dX=0.0;
modelStruct.modelPar_given_betard=mod.given("betard");
modelStruct.modelPar_delta1rd=mod.delta1rd;
modelStruct.d_modelPar_delta1rd_dX=0.0;
modelStruct.modelPar_given_delta1rd=mod.given("delta1rd");
modelStruct.modelPar_srd=mod.srd;
modelStruct.d_modelPar_srd_dX=0.0;
modelStruct.modelPar_given_srd=mod.given("srd");
modelStruct.modelPar_ndrd=mod.ndrd;
modelStruct.d_modelPar_ndrd_dX=0.0;
modelStruct.modelPar_given_ndrd=mod.given("ndrd");
modelStruct.modelPar_vthetard=mod.vthetard;
modelStruct.d_modelPar_vthetard_dX=0.0;
modelStruct.modelPar_given_vthetard=mod.given("vthetard");
modelStruct.modelPar_mthetard=mod.mthetard;
modelStruct.d_modelPar_mthetard_dX=0.0;
modelStruct.modelPar_given_mthetard=mod.given("mthetard");
modelStruct.modelPar_alphard=mod.alphard;
modelStruct.d_modelPar_alphard_dX=0.0;
modelStruct.modelPar_given_alphard=mod.given("alphard");
modelStruct.modelPar_lgfp1=mod.lgfp1;
modelStruct.d_modelPar_lgfp1_dX=0.0;
modelStruct.modelPar_given_lgfp1=mod.given("lgfp1");
modelStruct.modelPar_vtofp1=mod.vtofp1;
modelStruct.d_modelPar_vtofp1_dX=0.0;
modelStruct.modelPar_given_vtofp1=mod.given("vtofp1");
modelStruct.modelPar_cgfp1=mod.cgfp1;
modelStruct.d_modelPar_cgfp1_dX=0.0;
modelStruct.modelPar_given_cgfp1=mod.given("cgfp1");
modelStruct.modelPar_cfp1s=mod.cfp1s;
modelStruct.d_modelPar_cfp1s_dX=0.0;
modelStruct.modelPar_given_cfp1s=mod.given("cfp1s");
modelStruct.modelPar_ccfp1=mod.ccfp1;
modelStruct.d_modelPar_ccfp1_dX=0.0;
modelStruct.modelPar_given_ccfp1=mod.given("ccfp1");
modelStruct.modelPar_cbfp1=mod.cbfp1;
modelStruct.d_modelPar_cbfp1_dX=0.0;
modelStruct.modelPar_given_cbfp1=mod.given("cbfp1");
modelStruct.modelPar_vx0fp1=mod.vx0fp1;
modelStruct.d_modelPar_vx0fp1_dX=0.0;
modelStruct.modelPar_given_vx0fp1=mod.given("vx0fp1");
modelStruct.modelPar_mu0fp1=mod.mu0fp1;
modelStruct.d_modelPar_mu0fp1_dX=0.0;
modelStruct.modelPar_given_mu0fp1=mod.given("mu0fp1");
modelStruct.modelPar_betafp1=mod.betafp1;
modelStruct.d_modelPar_betafp1_dX=0.0;
modelStruct.modelPar_given_betafp1=mod.given("betafp1");
modelStruct.modelPar_delta1fp1=mod.delta1fp1;
modelStruct.d_modelPar_delta1fp1_dX=0.0;
modelStruct.modelPar_given_delta1fp1=mod.given("delta1fp1");
modelStruct.modelPar_sfp1=mod.sfp1;
modelStruct.d_modelPar_sfp1_dX=0.0;
modelStruct.modelPar_given_sfp1=mod.given("sfp1");
modelStruct.modelPar_ndfp1=mod.ndfp1;
modelStruct.d_modelPar_ndfp1_dX=0.0;
modelStruct.modelPar_given_ndfp1=mod.given("ndfp1");
modelStruct.modelPar_vthetafp1=mod.vthetafp1;
modelStruct.d_modelPar_vthetafp1_dX=0.0;
modelStruct.modelPar_given_vthetafp1=mod.given("vthetafp1");
modelStruct.modelPar_mthetafp1=mod.mthetafp1;
modelStruct.d_modelPar_mthetafp1_dX=0.0;
modelStruct.modelPar_given_mthetafp1=mod.given("mthetafp1");
modelStruct.modelPar_alphafp1=mod.alphafp1;
modelStruct.d_modelPar_alphafp1_dX=0.0;
modelStruct.modelPar_given_alphafp1=mod.given("alphafp1");
modelStruct.modelPar_lgfp2=mod.lgfp2;
modelStruct.d_modelPar_lgfp2_dX=0.0;
modelStruct.modelPar_given_lgfp2=mod.given("lgfp2");
modelStruct.modelPar_vtofp2=mod.vtofp2;
modelStruct.d_modelPar_vtofp2_dX=0.0;
modelStruct.modelPar_given_vtofp2=mod.given("vtofp2");
modelStruct.modelPar_cgfp2=mod.cgfp2;
modelStruct.d_modelPar_cgfp2_dX=0.0;
modelStruct.modelPar_given_cgfp2=mod.given("cgfp2");
modelStruct.modelPar_cfp2s=mod.cfp2s;
modelStruct.d_modelPar_cfp2s_dX=0.0;
modelStruct.modelPar_given_cfp2s=mod.given("cfp2s");
modelStruct.modelPar_ccfp2=mod.ccfp2;
modelStruct.d_modelPar_ccfp2_dX=0.0;
modelStruct.modelPar_given_ccfp2=mod.given("ccfp2");
modelStruct.modelPar_cbfp2=mod.cbfp2;
modelStruct.d_modelPar_cbfp2_dX=0.0;
modelStruct.modelPar_given_cbfp2=mod.given("cbfp2");
modelStruct.modelPar_vx0fp2=mod.vx0fp2;
modelStruct.d_modelPar_vx0fp2_dX=0.0;
modelStruct.modelPar_given_vx0fp2=mod.given("vx0fp2");
modelStruct.modelPar_mu0fp2=mod.mu0fp2;
modelStruct.d_modelPar_mu0fp2_dX=0.0;
modelStruct.modelPar_given_mu0fp2=mod.given("mu0fp2");
modelStruct.modelPar_betafp2=mod.betafp2;
modelStruct.d_modelPar_betafp2_dX=0.0;
modelStruct.modelPar_given_betafp2=mod.given("betafp2");
modelStruct.modelPar_delta1fp2=mod.delta1fp2;
modelStruct.d_modelPar_delta1fp2_dX=0.0;
modelStruct.modelPar_given_delta1fp2=mod.given("delta1fp2");
modelStruct.modelPar_sfp2=mod.sfp2;
modelStruct.d_modelPar_sfp2_dX=0.0;
modelStruct.modelPar_given_sfp2=mod.given("sfp2");
modelStruct.modelPar_ndfp2=mod.ndfp2;
modelStruct.d_modelPar_ndfp2_dX=0.0;
modelStruct.modelPar_given_ndfp2=mod.given("ndfp2");
modelStruct.modelPar_vthetafp2=mod.vthetafp2;
modelStruct.d_modelPar_vthetafp2_dX=0.0;
modelStruct.modelPar_given_vthetafp2=mod.given("vthetafp2");
modelStruct.modelPar_mthetafp2=mod.mthetafp2;
modelStruct.d_modelPar_mthetafp2_dX=0.0;
modelStruct.modelPar_given_mthetafp2=mod.given("mthetafp2");
modelStruct.modelPar_alphafp2=mod.alphafp2;
modelStruct.d_modelPar_alphafp2_dX=0.0;
modelStruct.modelPar_given_alphafp2=mod.given("alphafp2");
modelStruct.modelPar_lgfp3=mod.lgfp3;
modelStruct.d_modelPar_lgfp3_dX=0.0;
modelStruct.modelPar_given_lgfp3=mod.given("lgfp3");
modelStruct.modelPar_vtofp3=mod.vtofp3;
modelStruct.d_modelPar_vtofp3_dX=0.0;
modelStruct.modelPar_given_vtofp3=mod.given("vtofp3");
modelStruct.modelPar_cgfp3=mod.cgfp3;
modelStruct.d_modelPar_cgfp3_dX=0.0;
modelStruct.modelPar_given_cgfp3=mod.given("cgfp3");
modelStruct.modelPar_cfp3s=mod.cfp3s;
modelStruct.d_modelPar_cfp3s_dX=0.0;
modelStruct.modelPar_given_cfp3s=mod.given("cfp3s");
modelStruct.modelPar_ccfp3=mod.ccfp3;
modelStruct.d_modelPar_ccfp3_dX=0.0;
modelStruct.modelPar_given_ccfp3=mod.given("ccfp3");
modelStruct.modelPar_cbfp3=mod.cbfp3;
modelStruct.d_modelPar_cbfp3_dX=0.0;
modelStruct.modelPar_given_cbfp3=mod.given("cbfp3");
modelStruct.modelPar_vx0fp3=mod.vx0fp3;
modelStruct.d_modelPar_vx0fp3_dX=0.0;
modelStruct.modelPar_given_vx0fp3=mod.given("vx0fp3");
modelStruct.modelPar_mu0fp3=mod.mu0fp3;
modelStruct.d_modelPar_mu0fp3_dX=0.0;
modelStruct.modelPar_given_mu0fp3=mod.given("mu0fp3");
modelStruct.modelPar_betafp3=mod.betafp3;
modelStruct.d_modelPar_betafp3_dX=0.0;
modelStruct.modelPar_given_betafp3=mod.given("betafp3");
modelStruct.modelPar_delta1fp3=mod.delta1fp3;
modelStruct.d_modelPar_delta1fp3_dX=0.0;
modelStruct.modelPar_given_delta1fp3=mod.given("delta1fp3");
modelStruct.modelPar_sfp3=mod.sfp3;
modelStruct.d_modelPar_sfp3_dX=0.0;
modelStruct.modelPar_given_sfp3=mod.given("sfp3");
modelStruct.modelPar_ndfp3=mod.ndfp3;
modelStruct.d_modelPar_ndfp3_dX=0.0;
modelStruct.modelPar_given_ndfp3=mod.given("ndfp3");
modelStruct.modelPar_vthetafp3=mod.vthetafp3;
modelStruct.d_modelPar_vthetafp3_dX=0.0;
modelStruct.modelPar_given_vthetafp3=mod.given("vthetafp3");
modelStruct.modelPar_mthetafp3=mod.mthetafp3;
modelStruct.d_modelPar_mthetafp3_dX=0.0;
modelStruct.modelPar_given_mthetafp3=mod.given("mthetafp3");
modelStruct.modelPar_alphafp3=mod.alphafp3;
modelStruct.d_modelPar_alphafp3_dX=0.0;
modelStruct.modelPar_given_alphafp3=mod.given("alphafp3");
modelStruct.modelPar_lgfp4=mod.lgfp4;
modelStruct.d_modelPar_lgfp4_dX=0.0;
modelStruct.modelPar_given_lgfp4=mod.given("lgfp4");
modelStruct.modelPar_vtofp4=mod.vtofp4;
modelStruct.d_modelPar_vtofp4_dX=0.0;
modelStruct.modelPar_given_vtofp4=mod.given("vtofp4");
modelStruct.modelPar_cgfp4=mod.cgfp4;
modelStruct.d_modelPar_cgfp4_dX=0.0;
modelStruct.modelPar_given_cgfp4=mod.given("cgfp4");
modelStruct.modelPar_cfp4s=mod.cfp4s;
modelStruct.d_modelPar_cfp4s_dX=0.0;
modelStruct.modelPar_given_cfp4s=mod.given("cfp4s");
modelStruct.modelPar_ccfp4=mod.ccfp4;
modelStruct.d_modelPar_ccfp4_dX=0.0;
modelStruct.modelPar_given_ccfp4=mod.given("ccfp4");
modelStruct.modelPar_cbfp4=mod.cbfp4;
modelStruct.d_modelPar_cbfp4_dX=0.0;
modelStruct.modelPar_given_cbfp4=mod.given("cbfp4");
modelStruct.modelPar_vx0fp4=mod.vx0fp4;
modelStruct.d_modelPar_vx0fp4_dX=0.0;
modelStruct.modelPar_given_vx0fp4=mod.given("vx0fp4");
modelStruct.modelPar_mu0fp4=mod.mu0fp4;
modelStruct.d_modelPar_mu0fp4_dX=0.0;
modelStruct.modelPar_given_mu0fp4=mod.given("mu0fp4");
modelStruct.modelPar_betafp4=mod.betafp4;
modelStruct.d_modelPar_betafp4_dX=0.0;
modelStruct.modelPar_given_betafp4=mod.given("betafp4");
modelStruct.modelPar_delta1fp4=mod.delta1fp4;
modelStruct.d_modelPar_delta1fp4_dX=0.0;
modelStruct.modelPar_given_delta1fp4=mod.given("delta1fp4");
modelStruct.modelPar_sfp4=mod.sfp4;
modelStruct.d_modelPar_sfp4_dX=0.0;
modelStruct.modelPar_given_sfp4=mod.given("sfp4");
modelStruct.modelPar_ndfp4=mod.ndfp4;
modelStruct.d_modelPar_ndfp4_dX=0.0;
modelStruct.modelPar_given_ndfp4=mod.given("ndfp4");
modelStruct.modelPar_vthetafp4=mod.vthetafp4;
modelStruct.d_modelPar_vthetafp4_dX=0.0;
modelStruct.modelPar_given_vthetafp4=mod.given("vthetafp4");
modelStruct.modelPar_mthetafp4=mod.mthetafp4;
modelStruct.d_modelPar_mthetafp4_dX=0.0;
modelStruct.modelPar_given_mthetafp4=mod.given("mthetafp4");
modelStruct.modelPar_alphafp4=mod.alphafp4;
modelStruct.d_modelPar_alphafp4_dX=0.0;
modelStruct.modelPar_given_alphafp4=mod.given("alphafp4");
modelStruct.modelPar_rgsp=mod.rgsp;
modelStruct.d_modelPar_rgsp_dX=0.0;
modelStruct.modelPar_given_rgsp=mod.given("rgsp");
modelStruct.modelPar_vjg=mod.vjg;
modelStruct.d_modelPar_vjg_dX=0.0;
modelStruct.modelPar_given_vjg=mod.given("vjg");
modelStruct.modelPar_pg_param1=mod.pg_param1;
modelStruct.d_modelPar_pg_param1_dX=0.0;
modelStruct.modelPar_given_pg_param1=mod.given("pg_param1");
modelStruct.modelPar_pg_params=mod.pg_params;
modelStruct.d_modelPar_pg_params_dX=0.0;
modelStruct.modelPar_given_pg_params=mod.given("pg_params");
modelStruct.modelPar_ijs=mod.ijs;
modelStruct.d_modelPar_ijs_dX=0.0;
modelStruct.modelPar_given_ijs=mod.given("ijs");
modelStruct.modelPar_vgsats=mod.vgsats;
modelStruct.d_modelPar_vgsats_dX=0.0;
modelStruct.modelPar_given_vgsats=mod.given("vgsats");
modelStruct.modelPar_fracs=mod.fracs;
modelStruct.d_modelPar_fracs_dX=0.0;
modelStruct.modelPar_given_fracs=mod.given("fracs");
modelStruct.modelPar_alphags=mod.alphags;
modelStruct.d_modelPar_alphags_dX=0.0;
modelStruct.modelPar_given_alphags=mod.given("alphags");
modelStruct.modelPar_pg_paramd=mod.pg_paramd;
modelStruct.d_modelPar_pg_paramd_dX=0.0;
modelStruct.modelPar_given_pg_paramd=mod.given("pg_paramd");
modelStruct.modelPar_ijd=mod.ijd;
modelStruct.d_modelPar_ijd_dX=0.0;
modelStruct.modelPar_given_ijd=mod.given("ijd");
modelStruct.modelPar_vgsatd=mod.vgsatd;
modelStruct.d_modelPar_vgsatd_dX=0.0;
modelStruct.modelPar_given_vgsatd=mod.given("vgsatd");
modelStruct.modelPar_fracd=mod.fracd;
modelStruct.d_modelPar_fracd_dX=0.0;
modelStruct.modelPar_given_fracd=mod.given("fracd");
modelStruct.modelPar_alphagd=mod.alphagd;
modelStruct.d_modelPar_alphagd_dX=0.0;
modelStruct.modelPar_given_alphagd=mod.given("alphagd");
modelStruct.modelPar_pgsrecs=mod.pgsrecs;
modelStruct.d_modelPar_pgsrecs_dX=0.0;
modelStruct.modelPar_given_pgsrecs=mod.given("pgsrecs");
modelStruct.modelPar_irecs=mod.irecs;
modelStruct.d_modelPar_irecs_dX=0.0;
modelStruct.modelPar_given_irecs=mod.given("irecs");
modelStruct.modelPar_vgsatqs=mod.vgsatqs;
modelStruct.d_modelPar_vgsatqs_dX=0.0;
modelStruct.modelPar_given_vgsatqs=mod.given("vgsatqs");
modelStruct.modelPar_vbdgs=mod.vbdgs;
modelStruct.d_modelPar_vbdgs_dX=0.0;
modelStruct.modelPar_given_vbdgs=mod.given("vbdgs");
modelStruct.modelPar_pbdgs=mod.pbdgs;
modelStruct.d_modelPar_pbdgs_dX=0.0;
modelStruct.modelPar_given_pbdgs=mod.given("pbdgs");
modelStruct.modelPar_betarecs=mod.betarecs;
modelStruct.d_modelPar_betarecs_dX=0.0;
modelStruct.modelPar_given_betarecs=mod.given("betarecs");
modelStruct.modelPar_kbdgates=mod.kbdgates;
modelStruct.d_modelPar_kbdgates_dX=0.0;
modelStruct.modelPar_given_kbdgates=mod.given("kbdgates");
modelStruct.modelPar_pgsrecd=mod.pgsrecd;
modelStruct.d_modelPar_pgsrecd_dX=0.0;
modelStruct.modelPar_given_pgsrecd=mod.given("pgsrecd");
modelStruct.modelPar_irecd=mod.irecd;
modelStruct.d_modelPar_irecd_dX=0.0;
modelStruct.modelPar_given_irecd=mod.given("irecd");
modelStruct.modelPar_vgsatqd=mod.vgsatqd;
modelStruct.d_modelPar_vgsatqd_dX=0.0;
modelStruct.modelPar_given_vgsatqd=mod.given("vgsatqd");
modelStruct.modelPar_vbdgd=mod.vbdgd;
modelStruct.d_modelPar_vbdgd_dX=0.0;
modelStruct.modelPar_given_vbdgd=mod.given("vbdgd");
modelStruct.modelPar_pbdgd=mod.pbdgd;
modelStruct.d_modelPar_pbdgd_dX=0.0;
modelStruct.modelPar_given_pbdgd=mod.given("pbdgd");
modelStruct.modelPar_betarecd=mod.betarecd;
modelStruct.d_modelPar_betarecd_dX=0.0;
modelStruct.modelPar_given_betarecd=mod.given("betarecd");
modelStruct.modelPar_kbdgated=mod.kbdgated;
modelStruct.d_modelPar_kbdgated_dX=0.0;
modelStruct.modelPar_given_kbdgated=mod.given("kbdgated");
modelStruct.modelPar_rth=mod.rth;
modelStruct.d_modelPar_rth_dX=0.0;
modelStruct.modelPar_given_rth=mod.given("rth");
modelStruct.modelPar_cth=mod.cth;
modelStruct.d_modelPar_cth_dX=0.0;
modelStruct.modelPar_given_cth=mod.given("cth");
modelStruct.modelPar_taugmrf=mod.taugmrf;
modelStruct.d_modelPar_taugmrf_dX=0.0;
modelStruct.modelPar_given_taugmrf=mod.given("taugmrf");
modelStruct.modelPar_ctrap=mod.ctrap;
modelStruct.d_modelPar_ctrap_dX=0.0;
modelStruct.modelPar_given_ctrap=mod.given("ctrap");
modelStruct.modelPar_vttrap=mod.vttrap;
modelStruct.d_modelPar_vttrap_dX=0.0;
modelStruct.modelPar_given_vttrap=mod.given("vttrap");
modelStruct.modelPar_taut=mod.taut;
modelStruct.d_modelPar_taut_dX=0.0;
modelStruct.modelPar_given_taut=mod.given("taut");
modelStruct.modelPar_alphat1=mod.alphat1;
modelStruct.d_modelPar_alphat1_dX=0.0;
modelStruct.modelPar_given_alphat1=mod.given("alphat1");
modelStruct.modelPar_alphat2=mod.alphat2;
modelStruct.d_modelPar_alphat2_dX=0.0;
modelStruct.modelPar_given_alphat2=mod.given("alphat2");
modelStruct.modelPar_tempt=mod.tempt;
modelStruct.d_modelPar_tempt_dX=0.0;
modelStruct.modelPar_given_tempt=mod.given("tempt");
modelStruct.modelPar_shs=mod.shs;
modelStruct.d_modelPar_shs_dX=0.0;
modelStruct.modelPar_given_shs=mod.given("shs");
modelStruct.modelPar_shd=mod.shd;
modelStruct.d_modelPar_shd_dX=0.0;
modelStruct.modelPar_given_shd=mod.given("shd");
modelStruct.modelPar_kf=mod.kf;
modelStruct.d_modelPar_kf_dX=0.0;
modelStruct.modelPar_given_kf=mod.given("kf");
modelStruct.modelPar_af=mod.af;
modelStruct.d_modelPar_af_dX=0.0;
modelStruct.modelPar_given_af=mod.given("af");
modelStruct.modelPar_ffe=mod.ffe;
modelStruct.d_modelPar_ffe_dX=0.0;
modelStruct.modelPar_given_ffe=mod.given("ffe");
modelStruct.modelPar_minr=mod.minr;
modelStruct.d_modelPar_minr_dX=0.0;
modelStruct.modelPar_given_minr=mod.given("minr");
modelStruct.modelPar_minl=mod.minl;
modelStruct.d_modelPar_minl_dX=0.0;
modelStruct.modelPar_given_minl=mod.given("minl");
modelStruct.modelPar_minc=mod.minc;
modelStruct.d_modelPar_minc_dX=0.0;
modelStruct.modelPar_given_minc=mod.given("minc");
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_type=mod.type;
modelStruct.modelPar_given_type=mod.given("type");
modelStruct.modelPar_flagres=mod.flagres;
modelStruct.modelPar_given_flagres=mod.given("flagres");
modelStruct.modelPar_flagfp1=mod.flagfp1;
modelStruct.modelPar_given_flagfp1=mod.given("flagfp1");
modelStruct.modelPar_flagfp1s=mod.flagfp1s;
modelStruct.modelPar_given_flagfp1s=mod.given("flagfp1s");
modelStruct.modelPar_flagfp2=mod.flagfp2;
modelStruct.modelPar_given_flagfp2=mod.given("flagfp2");
modelStruct.modelPar_flagfp2s=mod.flagfp2s;
modelStruct.modelPar_given_flagfp2s=mod.given("flagfp2s");
modelStruct.modelPar_flagfp3=mod.flagfp3;
modelStruct.modelPar_given_flagfp3=mod.given("flagfp3");
modelStruct.modelPar_flagfp3s=mod.flagfp3s;
modelStruct.modelPar_given_flagfp3s=mod.given("flagfp3s");
modelStruct.modelPar_flagfp4=mod.flagfp4;
modelStruct.modelPar_given_flagfp4=mod.given("flagfp4");
modelStruct.modelPar_flagfp4s=mod.flagfp4s;
modelStruct.modelPar_given_flagfp4s=mod.given("flagfp4s");
modelStruct.modelPar_igmod=mod.igmod;
modelStruct.modelPar_given_igmod=mod.given("igmod");
modelStruct.modelPar_gmdisp=mod.gmdisp;
modelStruct.modelPar_given_gmdisp=mod.given("gmdisp");
modelStruct.modelPar_trapselect=mod.trapselect;
modelStruct.modelPar_given_trapselect=mod.given("trapselect");
modelStruct.modelPar_noisemod=mod.noisemod;
modelStruct.modelPar_given_noisemod=mod.given("noisemod");



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals
instanceStruct.instancePar_w=in.w;
instanceStruct.d_instancePar_w_dX=0.0;
instanceStruct.instancePar_given_w=in.given("w");
inParamMap["w"] = &(instanceStruct.d_instancePar_w_dX);
instanceStruct.instancePar_l=in.l;
instanceStruct.d_instancePar_l_dX=0.0;
instanceStruct.instancePar_given_l=in.given("l");
inParamMap["l"] = &(instanceStruct.d_instancePar_l_dX);
instanceStruct.instancePar_dtemp=in.dtemp;
instanceStruct.d_instancePar_dtemp_dX=0.0;
instanceStruct.instancePar_given_dtemp=in.given("dtemp");
inParamMap["dtemp"] = &(instanceStruct.d_instancePar_dtemp_dX);


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_ngf=in.ngf;
instanceStruct.instancePar_given_ngf=in.given("ngf");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals
instanceStruct.instanceVar_rcs_w=in.rcs_w;
instanceStruct.d_instanceVar_rcs_w_dX=0.0;
instanceStruct.instanceVar_rcd_w=in.rcd_w;
instanceStruct.d_instanceVar_rcd_w_dX=0.0;
instanceStruct.instanceVar_rg=in.rg;
instanceStruct.d_instanceVar_rg_dX=0.0;


//non-reals


//make local copies of all model vars
//reals


// non-reals



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_b_GND] = (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_di_GND] = (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_gi_GND] = (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_drc_d] = (*solVectorPtr)[in.li_drc]- (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_gi_b] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_s_b] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_d_b] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_gi_d] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_gi_s] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_g_gi] = (*solVectorPtr)[in.li_g]- (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_d_drc] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_drc];
probeVars[in.admsProbeID_V_xt1_GND] = (in.collapseNode_xt1)?(0):((*solVectorPtr)[in.li_xt1]);
probeVars[in.admsProbeID_V_xt2_GND] = (in.collapseNode_xt2)?(0):((*solVectorPtr)[in.li_xt2]);
probeVars[in.admsProbeID_V_s_fp4] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp4];
probeVars[in.admsProbeID_V_gi_fp4] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp4];
probeVars[in.admsProbeID_V_b_fp3] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_fp4_fp3] = (*solVectorPtr)[in.li_fp4]- (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_s_fp3] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_gi_fp3] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_b_fp2] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_fp3_fp2] = (*solVectorPtr)[in.li_fp3]- (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_s_fp2] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_gi_fp2] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_b_fp1] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_fp2_fp1] = (*solVectorPtr)[in.li_fp2]- (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_s_fp1] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_gi_fp1] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_b_di] = (*solVectorPtr)[in.li_b]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_fp1_di] = (*solVectorPtr)[in.li_fp1]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_s_di] = (*solVectorPtr)[in.li_s]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_gi_di] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_drc_fp4] = (*solVectorPtr)[in.li_drc]- (*solVectorPtr)[in.li_fp4];
probeVars[in.admsProbeID_V_fp4_s] = (*solVectorPtr)[in.li_fp4]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_fp4_d] = (*solVectorPtr)[in.li_fp4]- (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_tr_GND] = (in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]);
probeVars[in.admsProbeID_V_tr1_tr] = (in.collapseNode_tr1)?(0):((*solVectorPtr)[in.li_tr1]) - ((in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]));
probeVars[in.admsProbeID_V_d_g] = (*solVectorPtr)[in.li_d]- (*solVectorPtr)[in.li_g];
probeVars[in.admsProbeID_V_si_src] = (*solVectorPtr)[in.li_si]- (*solVectorPtr)[in.li_src];
probeVars[in.admsProbeID_V_src_s] = (*solVectorPtr)[in.li_src]- (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_src_d] = (*solVectorPtr)[in.li_src]- (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_gi_si] = (*solVectorPtr)[in.li_gi]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di]- (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_Temp_dt_GND] = (in.collapseNode_dt)?(0):((*solVectorPtr)[in.li_dt]);


evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_si_GND,
in.admsProbeID_V_b_GND,
in.admsProbeID_V_di_GND,
in.admsProbeID_V_gi_GND,
in.admsProbeID_V_drc_d,
in.admsProbeID_V_gi_b,
in.admsProbeID_V_s_b,
in.admsProbeID_V_d_b,
in.admsProbeID_V_d_s,
in.admsProbeID_V_gi_d,
in.admsProbeID_V_gi_s,
in.admsProbeID_V_g_gi,
in.admsProbeID_V_d_drc,
in.admsProbeID_V_xt1_GND,
in.admsProbeID_V_xt2_GND,
in.admsProbeID_V_s_fp4,
in.admsProbeID_V_gi_fp4,
in.admsProbeID_V_b_fp3,
in.admsProbeID_V_fp4_fp3,
in.admsProbeID_V_s_fp3,
in.admsProbeID_V_gi_fp3,
in.admsProbeID_V_b_fp2,
in.admsProbeID_V_fp3_fp2,
in.admsProbeID_V_s_fp2,
in.admsProbeID_V_gi_fp2,
in.admsProbeID_V_b_fp1,
in.admsProbeID_V_fp2_fp1,
in.admsProbeID_V_s_fp1,
in.admsProbeID_V_gi_fp1,
in.admsProbeID_V_b_di,
in.admsProbeID_V_fp1_di,
in.admsProbeID_V_s_di,
in.admsProbeID_V_gi_di,
in.admsProbeID_V_drc_fp4,
in.admsProbeID_V_fp4_s,
in.admsProbeID_V_fp4_d,
in.admsProbeID_V_tr_GND,
in.admsProbeID_V_tr1_tr,
in.admsProbeID_V_d_g,
in.admsProbeID_V_si_src,
in.admsProbeID_V_src_s,
in.admsProbeID_V_src_d,
in.admsProbeID_V_gi_si,
in.admsProbeID_V_di_si,
in.admsProbeID_Temp_dt_GND,

// node constants
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_b,
in.admsNodeID_di,
in.admsNodeID_gi,
in.admsNodeID_si,
in.admsNodeID_fp1,
in.admsNodeID_fp2,
in.admsNodeID_fp3,
in.admsNodeID_fp4,
in.admsNodeID_drc,
in.admsNodeID_src,
in.admsNodeID_tr,
in.admsNodeID_tr1,
in.admsNodeID_xt1,
in.admsNodeID_xt2,
in.admsNodeID_dt,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d] += d_staticContributions_dX[in.admsNodeID_d];
    dqdp[in.admsNodeID_d] += d_dynamicContributions_dX[in.admsNodeID_d];
    Findices[in.admsNodeID_d] = in.li_d;
    Qindices[in.admsNodeID_d] = in.li_d;
    dfdp[in.admsNodeID_g] += d_staticContributions_dX[in.admsNodeID_g];
    dqdp[in.admsNodeID_g] += d_dynamicContributions_dX[in.admsNodeID_g];
    Findices[in.admsNodeID_g] = in.li_g;
    Qindices[in.admsNodeID_g] = in.li_g;
    dfdp[in.admsNodeID_s] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s] = in.li_s;
    Qindices[in.admsNodeID_s] = in.li_s;
    dfdp[in.admsNodeID_b] += d_staticContributions_dX[in.admsNodeID_b];
    dqdp[in.admsNodeID_b] += d_dynamicContributions_dX[in.admsNodeID_b];
    Findices[in.admsNodeID_b] = in.li_b;
    Qindices[in.admsNodeID_b] = in.li_b;
    dfdp[in.admsNodeID_di] += d_staticContributions_dX[in.admsNodeID_di];
    dqdp[in.admsNodeID_di] += d_dynamicContributions_dX[in.admsNodeID_di];
    Findices[in.admsNodeID_di] = in.li_di;
    Qindices[in.admsNodeID_di] = in.li_di;
    dfdp[in.admsNodeID_gi] += d_staticContributions_dX[in.admsNodeID_gi];
    dqdp[in.admsNodeID_gi] += d_dynamicContributions_dX[in.admsNodeID_gi];
    Findices[in.admsNodeID_gi] = in.li_gi;
    Qindices[in.admsNodeID_gi] = in.li_gi;
    dfdp[in.admsNodeID_si] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si] = in.li_si;
    Qindices[in.admsNodeID_si] = in.li_si;
    dfdp[in.admsNodeID_fp1] += d_staticContributions_dX[in.admsNodeID_fp1];
    dqdp[in.admsNodeID_fp1] += d_dynamicContributions_dX[in.admsNodeID_fp1];
    Findices[in.admsNodeID_fp1] = in.li_fp1;
    Qindices[in.admsNodeID_fp1] = in.li_fp1;
    dfdp[in.admsNodeID_fp2] += d_staticContributions_dX[in.admsNodeID_fp2];
    dqdp[in.admsNodeID_fp2] += d_dynamicContributions_dX[in.admsNodeID_fp2];
    Findices[in.admsNodeID_fp2] = in.li_fp2;
    Qindices[in.admsNodeID_fp2] = in.li_fp2;
    dfdp[in.admsNodeID_fp3] += d_staticContributions_dX[in.admsNodeID_fp3];
    dqdp[in.admsNodeID_fp3] += d_dynamicContributions_dX[in.admsNodeID_fp3];
    Findices[in.admsNodeID_fp3] = in.li_fp3;
    Qindices[in.admsNodeID_fp3] = in.li_fp3;
    dfdp[in.admsNodeID_fp4] += d_staticContributions_dX[in.admsNodeID_fp4];
    dqdp[in.admsNodeID_fp4] += d_dynamicContributions_dX[in.admsNodeID_fp4];
    Findices[in.admsNodeID_fp4] = in.li_fp4;
    Qindices[in.admsNodeID_fp4] = in.li_fp4;
    dfdp[in.admsNodeID_drc] += d_staticContributions_dX[in.admsNodeID_drc];
    dqdp[in.admsNodeID_drc] += d_dynamicContributions_dX[in.admsNodeID_drc];
    Findices[in.admsNodeID_drc] = in.li_drc;
    Qindices[in.admsNodeID_drc] = in.li_drc;
    dfdp[in.admsNodeID_src] += d_staticContributions_dX[in.admsNodeID_src];
    dqdp[in.admsNodeID_src] += d_dynamicContributions_dX[in.admsNodeID_src];
    Findices[in.admsNodeID_src] = in.li_src;
    Qindices[in.admsNodeID_src] = in.li_src;
    dfdp[in.admsNodeID_tr] += d_staticContributions_dX[in.admsNodeID_tr];
    dqdp[in.admsNodeID_tr] += d_dynamicContributions_dX[in.admsNodeID_tr];
    Findices[in.admsNodeID_tr] = in.li_tr;
    Qindices[in.admsNodeID_tr] = in.li_tr;
    dfdp[in.admsNodeID_tr1] += d_staticContributions_dX[in.admsNodeID_tr1];
    dqdp[in.admsNodeID_tr1] += d_dynamicContributions_dX[in.admsNodeID_tr1];
    Findices[in.admsNodeID_tr1] = in.li_tr1;
    Qindices[in.admsNodeID_tr1] = in.li_tr1;
    dfdp[in.admsNodeID_xt1] += d_staticContributions_dX[in.admsNodeID_xt1];
    dqdp[in.admsNodeID_xt1] += d_dynamicContributions_dX[in.admsNodeID_xt1];
    Findices[in.admsNodeID_xt1] = in.li_xt1;
    Qindices[in.admsNodeID_xt1] = in.li_xt1;
    dfdp[in.admsNodeID_xt2] += d_staticContributions_dX[in.admsNodeID_xt2];
    dqdp[in.admsNodeID_xt2] += d_dynamicContributions_dX[in.admsNodeID_xt2];
    Findices[in.admsNodeID_xt2] = in.li_xt2;
    Qindices[in.admsNodeID_xt2] = in.li_xt2;
    dfdp[in.admsNodeID_dt] += d_staticContributions_dX[in.admsNodeID_dt];
    dqdp[in.admsNodeID_dt] += d_dynamicContributions_dX[in.admsNodeID_dt];
    Findices[in.admsNodeID_dt] = in.li_dt;
    Qindices[in.admsNodeID_dt] = in.li_dt;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((18+0)*sizeInstance);
dqdp.resize((18+0)*sizeInstance);
Findices.resize((18+0)*sizeInstance);
Qindices.resize((18+0)*sizeInstance);

std::vector <double> probeVars(45);
std::vector <double> d_staticContributions_dX(18+0);
std::vector <double> d_dynamicContributions_dX(18+0);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_version=mod.version;
modelStruct.d_modelPar_version_dX=0.0;
modelStruct.modelPar_given_version=mod.given("version");
modParamMap["version"] = &(modelStruct.d_modelPar_version_dX);
modelStruct.modelPar_tnom=mod.tnom;
modelStruct.d_modelPar_tnom_dX=0.0;
modelStruct.modelPar_given_tnom=mod.given("tnom");
modParamMap["tnom"] = &(modelStruct.d_modelPar_tnom_dX);
modelStruct.modelPar_cg=mod.cg;
modelStruct.d_modelPar_cg_dX=0.0;
modelStruct.modelPar_given_cg=mod.given("cg");
modParamMap["cg"] = &(modelStruct.d_modelPar_cg_dX);
modelStruct.modelPar_cofsm=mod.cofsm;
modelStruct.d_modelPar_cofsm_dX=0.0;
modelStruct.modelPar_given_cofsm=mod.given("cofsm");
modParamMap["cofsm"] = &(modelStruct.d_modelPar_cofsm_dX);
modelStruct.modelPar_cofdm=mod.cofdm;
modelStruct.d_modelPar_cofdm_dX=0.0;
modelStruct.modelPar_given_cofdm=mod.given("cofdm");
modParamMap["cofdm"] = &(modelStruct.d_modelPar_cofdm_dX);
modelStruct.modelPar_cofdsm=mod.cofdsm;
modelStruct.d_modelPar_cofdsm_dX=0.0;
modelStruct.modelPar_given_cofdsm=mod.given("cofdsm");
modParamMap["cofdsm"] = &(modelStruct.d_modelPar_cofdsm_dX);
modelStruct.modelPar_cofdsubm=mod.cofdsubm;
modelStruct.d_modelPar_cofdsubm_dX=0.0;
modelStruct.modelPar_given_cofdsubm=mod.given("cofdsubm");
modParamMap["cofdsubm"] = &(modelStruct.d_modelPar_cofdsubm_dX);
modelStruct.modelPar_cofssubm=mod.cofssubm;
modelStruct.d_modelPar_cofssubm_dX=0.0;
modelStruct.modelPar_given_cofssubm=mod.given("cofssubm");
modParamMap["cofssubm"] = &(modelStruct.d_modelPar_cofssubm_dX);
modelStruct.modelPar_cofgsubm=mod.cofgsubm;
modelStruct.d_modelPar_cofgsubm_dX=0.0;
modelStruct.modelPar_given_cofgsubm=mod.given("cofgsubm");
modParamMap["cofgsubm"] = &(modelStruct.d_modelPar_cofgsubm_dX);
modelStruct.modelPar_rsh=mod.rsh;
modelStruct.d_modelPar_rsh_dX=0.0;
modelStruct.modelPar_given_rsh=mod.given("rsh");
modParamMap["rsh"] = &(modelStruct.d_modelPar_rsh_dX);
modelStruct.modelPar_rcs=mod.rcs;
modelStruct.d_modelPar_rcs_dX=0.0;
modelStruct.modelPar_given_rcs=mod.given("rcs");
modParamMap["rcs"] = &(modelStruct.d_modelPar_rcs_dX);
modelStruct.modelPar_rcd=mod.rcd;
modelStruct.d_modelPar_rcd_dX=0.0;
modelStruct.modelPar_given_rcd=mod.given("rcd");
modParamMap["rcd"] = &(modelStruct.d_modelPar_rcd_dX);
modelStruct.modelPar_vx0=mod.vx0;
modelStruct.d_modelPar_vx0_dX=0.0;
modelStruct.modelPar_given_vx0=mod.given("vx0");
modParamMap["vx0"] = &(modelStruct.d_modelPar_vx0_dX);
modelStruct.modelPar_mu0=mod.mu0;
modelStruct.d_modelPar_mu0_dX=0.0;
modelStruct.modelPar_given_mu0=mod.given("mu0");
modParamMap["mu0"] = &(modelStruct.d_modelPar_mu0_dX);
modelStruct.modelPar_beta=mod.beta;
modelStruct.d_modelPar_beta_dX=0.0;
modelStruct.modelPar_given_beta=mod.given("beta");
modParamMap["beta"] = &(modelStruct.d_modelPar_beta_dX);
modelStruct.modelPar_vto=mod.vto;
modelStruct.d_modelPar_vto_dX=0.0;
modelStruct.modelPar_given_vto=mod.given("vto");
modParamMap["vto"] = &(modelStruct.d_modelPar_vto_dX);
modelStruct.modelPar_ss=mod.ss;
modelStruct.d_modelPar_ss_dX=0.0;
modelStruct.modelPar_given_ss=mod.given("ss");
modParamMap["ss"] = &(modelStruct.d_modelPar_ss_dX);
modelStruct.modelPar_delta1=mod.delta1;
modelStruct.d_modelPar_delta1_dX=0.0;
modelStruct.modelPar_given_delta1=mod.given("delta1");
modParamMap["delta1"] = &(modelStruct.d_modelPar_delta1_dX);
modelStruct.modelPar_delta2=mod.delta2;
modelStruct.d_modelPar_delta2_dX=0.0;
modelStruct.modelPar_given_delta2=mod.given("delta2");
modParamMap["delta2"] = &(modelStruct.d_modelPar_delta2_dX);
modelStruct.modelPar_dibsat=mod.dibsat;
modelStruct.d_modelPar_dibsat_dX=0.0;
modelStruct.modelPar_given_dibsat=mod.given("dibsat");
modParamMap["dibsat"] = &(modelStruct.d_modelPar_dibsat_dX);
modelStruct.modelPar_nd=mod.nd;
modelStruct.d_modelPar_nd_dX=0.0;
modelStruct.modelPar_given_nd=mod.given("nd");
modParamMap["nd"] = &(modelStruct.d_modelPar_nd_dX);
modelStruct.modelPar_alpha=mod.alpha;
modelStruct.d_modelPar_alpha_dX=0.0;
modelStruct.modelPar_given_alpha=mod.given("alpha");
modParamMap["alpha"] = &(modelStruct.d_modelPar_alpha_dX);
modelStruct.modelPar_lambda=mod.lambda;
modelStruct.d_modelPar_lambda_dX=0.0;
modelStruct.modelPar_given_lambda=mod.given("lambda");
modParamMap["lambda"] = &(modelStruct.d_modelPar_lambda_dX);
modelStruct.modelPar_vtheta=mod.vtheta;
modelStruct.d_modelPar_vtheta_dX=0.0;
modelStruct.modelPar_given_vtheta=mod.given("vtheta");
modParamMap["vtheta"] = &(modelStruct.d_modelPar_vtheta_dX);
modelStruct.modelPar_mtheta=mod.mtheta;
modelStruct.d_modelPar_mtheta_dX=0.0;
modelStruct.modelPar_given_mtheta=mod.given("mtheta");
modParamMap["mtheta"] = &(modelStruct.d_modelPar_mtheta_dX);
modelStruct.modelPar_vzeta=mod.vzeta;
modelStruct.d_modelPar_vzeta_dX=0.0;
modelStruct.modelPar_given_vzeta=mod.given("vzeta");
modParamMap["vzeta"] = &(modelStruct.d_modelPar_vzeta_dX);
modelStruct.modelPar_vtzeta=mod.vtzeta;
modelStruct.d_modelPar_vtzeta_dX=0.0;
modelStruct.modelPar_given_vtzeta=mod.given("vtzeta");
modParamMap["vtzeta"] = &(modelStruct.d_modelPar_vtzeta_dX);
modelStruct.modelPar_epsilon=mod.epsilon;
modelStruct.d_modelPar_epsilon_dX=0.0;
modelStruct.modelPar_given_epsilon=mod.given("epsilon");
modParamMap["epsilon"] = &(modelStruct.d_modelPar_epsilon_dX);
modelStruct.modelPar_rct1=mod.rct1;
modelStruct.d_modelPar_rct1_dX=0.0;
modelStruct.modelPar_given_rct1=mod.given("rct1");
modParamMap["rct1"] = &(modelStruct.d_modelPar_rct1_dX);
modelStruct.modelPar_rct2=mod.rct2;
modelStruct.d_modelPar_rct2_dX=0.0;
modelStruct.modelPar_given_rct2=mod.given("rct2");
modParamMap["rct2"] = &(modelStruct.d_modelPar_rct2_dX);
modelStruct.modelPar_lgs=mod.lgs;
modelStruct.d_modelPar_lgs_dX=0.0;
modelStruct.modelPar_given_lgs=mod.given("lgs");
modParamMap["lgs"] = &(modelStruct.d_modelPar_lgs_dX);
modelStruct.modelPar_vtors=mod.vtors;
modelStruct.d_modelPar_vtors_dX=0.0;
modelStruct.modelPar_given_vtors=mod.given("vtors");
modParamMap["vtors"] = &(modelStruct.d_modelPar_vtors_dX);
modelStruct.modelPar_cgrs=mod.cgrs;
modelStruct.d_modelPar_cgrs_dX=0.0;
modelStruct.modelPar_given_cgrs=mod.given("cgrs");
modParamMap["cgrs"] = &(modelStruct.d_modelPar_cgrs_dX);
modelStruct.modelPar_vx0rs=mod.vx0rs;
modelStruct.d_modelPar_vx0rs_dX=0.0;
modelStruct.modelPar_given_vx0rs=mod.given("vx0rs");
modParamMap["vx0rs"] = &(modelStruct.d_modelPar_vx0rs_dX);
modelStruct.modelPar_mu0rs=mod.mu0rs;
modelStruct.d_modelPar_mu0rs_dX=0.0;
modelStruct.modelPar_given_mu0rs=mod.given("mu0rs");
modParamMap["mu0rs"] = &(modelStruct.d_modelPar_mu0rs_dX);
modelStruct.modelPar_betars=mod.betars;
modelStruct.d_modelPar_betars_dX=0.0;
modelStruct.modelPar_given_betars=mod.given("betars");
modParamMap["betars"] = &(modelStruct.d_modelPar_betars_dX);
modelStruct.modelPar_delta1rs=mod.delta1rs;
modelStruct.d_modelPar_delta1rs_dX=0.0;
modelStruct.modelPar_given_delta1rs=mod.given("delta1rs");
modParamMap["delta1rs"] = &(modelStruct.d_modelPar_delta1rs_dX);
modelStruct.modelPar_srs=mod.srs;
modelStruct.d_modelPar_srs_dX=0.0;
modelStruct.modelPar_given_srs=mod.given("srs");
modParamMap["srs"] = &(modelStruct.d_modelPar_srs_dX);
modelStruct.modelPar_ndrs=mod.ndrs;
modelStruct.d_modelPar_ndrs_dX=0.0;
modelStruct.modelPar_given_ndrs=mod.given("ndrs");
modParamMap["ndrs"] = &(modelStruct.d_modelPar_ndrs_dX);
modelStruct.modelPar_vthetars=mod.vthetars;
modelStruct.d_modelPar_vthetars_dX=0.0;
modelStruct.modelPar_given_vthetars=mod.given("vthetars");
modParamMap["vthetars"] = &(modelStruct.d_modelPar_vthetars_dX);
modelStruct.modelPar_mthetars=mod.mthetars;
modelStruct.d_modelPar_mthetars_dX=0.0;
modelStruct.modelPar_given_mthetars=mod.given("mthetars");
modParamMap["mthetars"] = &(modelStruct.d_modelPar_mthetars_dX);
modelStruct.modelPar_alphars=mod.alphars;
modelStruct.d_modelPar_alphars_dX=0.0;
modelStruct.modelPar_given_alphars=mod.given("alphars");
modParamMap["alphars"] = &(modelStruct.d_modelPar_alphars_dX);
modelStruct.modelPar_lgd=mod.lgd;
modelStruct.d_modelPar_lgd_dX=0.0;
modelStruct.modelPar_given_lgd=mod.given("lgd");
modParamMap["lgd"] = &(modelStruct.d_modelPar_lgd_dX);
modelStruct.modelPar_vtord=mod.vtord;
modelStruct.d_modelPar_vtord_dX=0.0;
modelStruct.modelPar_given_vtord=mod.given("vtord");
modParamMap["vtord"] = &(modelStruct.d_modelPar_vtord_dX);
modelStruct.modelPar_cgrd=mod.cgrd;
modelStruct.d_modelPar_cgrd_dX=0.0;
modelStruct.modelPar_given_cgrd=mod.given("cgrd");
modParamMap["cgrd"] = &(modelStruct.d_modelPar_cgrd_dX);
modelStruct.modelPar_vx0rd=mod.vx0rd;
modelStruct.d_modelPar_vx0rd_dX=0.0;
modelStruct.modelPar_given_vx0rd=mod.given("vx0rd");
modParamMap["vx0rd"] = &(modelStruct.d_modelPar_vx0rd_dX);
modelStruct.modelPar_mu0rd=mod.mu0rd;
modelStruct.d_modelPar_mu0rd_dX=0.0;
modelStruct.modelPar_given_mu0rd=mod.given("mu0rd");
modParamMap["mu0rd"] = &(modelStruct.d_modelPar_mu0rd_dX);
modelStruct.modelPar_betard=mod.betard;
modelStruct.d_modelPar_betard_dX=0.0;
modelStruct.modelPar_given_betard=mod.given("betard");
modParamMap["betard"] = &(modelStruct.d_modelPar_betard_dX);
modelStruct.modelPar_delta1rd=mod.delta1rd;
modelStruct.d_modelPar_delta1rd_dX=0.0;
modelStruct.modelPar_given_delta1rd=mod.given("delta1rd");
modParamMap["delta1rd"] = &(modelStruct.d_modelPar_delta1rd_dX);
modelStruct.modelPar_srd=mod.srd;
modelStruct.d_modelPar_srd_dX=0.0;
modelStruct.modelPar_given_srd=mod.given("srd");
modParamMap["srd"] = &(modelStruct.d_modelPar_srd_dX);
modelStruct.modelPar_ndrd=mod.ndrd;
modelStruct.d_modelPar_ndrd_dX=0.0;
modelStruct.modelPar_given_ndrd=mod.given("ndrd");
modParamMap["ndrd"] = &(modelStruct.d_modelPar_ndrd_dX);
modelStruct.modelPar_vthetard=mod.vthetard;
modelStruct.d_modelPar_vthetard_dX=0.0;
modelStruct.modelPar_given_vthetard=mod.given("vthetard");
modParamMap["vthetard"] = &(modelStruct.d_modelPar_vthetard_dX);
modelStruct.modelPar_mthetard=mod.mthetard;
modelStruct.d_modelPar_mthetard_dX=0.0;
modelStruct.modelPar_given_mthetard=mod.given("mthetard");
modParamMap["mthetard"] = &(modelStruct.d_modelPar_mthetard_dX);
modelStruct.modelPar_alphard=mod.alphard;
modelStruct.d_modelPar_alphard_dX=0.0;
modelStruct.modelPar_given_alphard=mod.given("alphard");
modParamMap["alphard"] = &(modelStruct.d_modelPar_alphard_dX);
modelStruct.modelPar_lgfp1=mod.lgfp1;
modelStruct.d_modelPar_lgfp1_dX=0.0;
modelStruct.modelPar_given_lgfp1=mod.given("lgfp1");
modParamMap["lgfp1"] = &(modelStruct.d_modelPar_lgfp1_dX);
modelStruct.modelPar_vtofp1=mod.vtofp1;
modelStruct.d_modelPar_vtofp1_dX=0.0;
modelStruct.modelPar_given_vtofp1=mod.given("vtofp1");
modParamMap["vtofp1"] = &(modelStruct.d_modelPar_vtofp1_dX);
modelStruct.modelPar_cgfp1=mod.cgfp1;
modelStruct.d_modelPar_cgfp1_dX=0.0;
modelStruct.modelPar_given_cgfp1=mod.given("cgfp1");
modParamMap["cgfp1"] = &(modelStruct.d_modelPar_cgfp1_dX);
modelStruct.modelPar_cfp1s=mod.cfp1s;
modelStruct.d_modelPar_cfp1s_dX=0.0;
modelStruct.modelPar_given_cfp1s=mod.given("cfp1s");
modParamMap["cfp1s"] = &(modelStruct.d_modelPar_cfp1s_dX);
modelStruct.modelPar_ccfp1=mod.ccfp1;
modelStruct.d_modelPar_ccfp1_dX=0.0;
modelStruct.modelPar_given_ccfp1=mod.given("ccfp1");
modParamMap["ccfp1"] = &(modelStruct.d_modelPar_ccfp1_dX);
modelStruct.modelPar_cbfp1=mod.cbfp1;
modelStruct.d_modelPar_cbfp1_dX=0.0;
modelStruct.modelPar_given_cbfp1=mod.given("cbfp1");
modParamMap["cbfp1"] = &(modelStruct.d_modelPar_cbfp1_dX);
modelStruct.modelPar_vx0fp1=mod.vx0fp1;
modelStruct.d_modelPar_vx0fp1_dX=0.0;
modelStruct.modelPar_given_vx0fp1=mod.given("vx0fp1");
modParamMap["vx0fp1"] = &(modelStruct.d_modelPar_vx0fp1_dX);
modelStruct.modelPar_mu0fp1=mod.mu0fp1;
modelStruct.d_modelPar_mu0fp1_dX=0.0;
modelStruct.modelPar_given_mu0fp1=mod.given("mu0fp1");
modParamMap["mu0fp1"] = &(modelStruct.d_modelPar_mu0fp1_dX);
modelStruct.modelPar_betafp1=mod.betafp1;
modelStruct.d_modelPar_betafp1_dX=0.0;
modelStruct.modelPar_given_betafp1=mod.given("betafp1");
modParamMap["betafp1"] = &(modelStruct.d_modelPar_betafp1_dX);
modelStruct.modelPar_delta1fp1=mod.delta1fp1;
modelStruct.d_modelPar_delta1fp1_dX=0.0;
modelStruct.modelPar_given_delta1fp1=mod.given("delta1fp1");
modParamMap["delta1fp1"] = &(modelStruct.d_modelPar_delta1fp1_dX);
modelStruct.modelPar_sfp1=mod.sfp1;
modelStruct.d_modelPar_sfp1_dX=0.0;
modelStruct.modelPar_given_sfp1=mod.given("sfp1");
modParamMap["sfp1"] = &(modelStruct.d_modelPar_sfp1_dX);
modelStruct.modelPar_ndfp1=mod.ndfp1;
modelStruct.d_modelPar_ndfp1_dX=0.0;
modelStruct.modelPar_given_ndfp1=mod.given("ndfp1");
modParamMap["ndfp1"] = &(modelStruct.d_modelPar_ndfp1_dX);
modelStruct.modelPar_vthetafp1=mod.vthetafp1;
modelStruct.d_modelPar_vthetafp1_dX=0.0;
modelStruct.modelPar_given_vthetafp1=mod.given("vthetafp1");
modParamMap["vthetafp1"] = &(modelStruct.d_modelPar_vthetafp1_dX);
modelStruct.modelPar_mthetafp1=mod.mthetafp1;
modelStruct.d_modelPar_mthetafp1_dX=0.0;
modelStruct.modelPar_given_mthetafp1=mod.given("mthetafp1");
modParamMap["mthetafp1"] = &(modelStruct.d_modelPar_mthetafp1_dX);
modelStruct.modelPar_alphafp1=mod.alphafp1;
modelStruct.d_modelPar_alphafp1_dX=0.0;
modelStruct.modelPar_given_alphafp1=mod.given("alphafp1");
modParamMap["alphafp1"] = &(modelStruct.d_modelPar_alphafp1_dX);
modelStruct.modelPar_lgfp2=mod.lgfp2;
modelStruct.d_modelPar_lgfp2_dX=0.0;
modelStruct.modelPar_given_lgfp2=mod.given("lgfp2");
modParamMap["lgfp2"] = &(modelStruct.d_modelPar_lgfp2_dX);
modelStruct.modelPar_vtofp2=mod.vtofp2;
modelStruct.d_modelPar_vtofp2_dX=0.0;
modelStruct.modelPar_given_vtofp2=mod.given("vtofp2");
modParamMap["vtofp2"] = &(modelStruct.d_modelPar_vtofp2_dX);
modelStruct.modelPar_cgfp2=mod.cgfp2;
modelStruct.d_modelPar_cgfp2_dX=0.0;
modelStruct.modelPar_given_cgfp2=mod.given("cgfp2");
modParamMap["cgfp2"] = &(modelStruct.d_modelPar_cgfp2_dX);
modelStruct.modelPar_cfp2s=mod.cfp2s;
modelStruct.d_modelPar_cfp2s_dX=0.0;
modelStruct.modelPar_given_cfp2s=mod.given("cfp2s");
modParamMap["cfp2s"] = &(modelStruct.d_modelPar_cfp2s_dX);
modelStruct.modelPar_ccfp2=mod.ccfp2;
modelStruct.d_modelPar_ccfp2_dX=0.0;
modelStruct.modelPar_given_ccfp2=mod.given("ccfp2");
modParamMap["ccfp2"] = &(modelStruct.d_modelPar_ccfp2_dX);
modelStruct.modelPar_cbfp2=mod.cbfp2;
modelStruct.d_modelPar_cbfp2_dX=0.0;
modelStruct.modelPar_given_cbfp2=mod.given("cbfp2");
modParamMap["cbfp2"] = &(modelStruct.d_modelPar_cbfp2_dX);
modelStruct.modelPar_vx0fp2=mod.vx0fp2;
modelStruct.d_modelPar_vx0fp2_dX=0.0;
modelStruct.modelPar_given_vx0fp2=mod.given("vx0fp2");
modParamMap["vx0fp2"] = &(modelStruct.d_modelPar_vx0fp2_dX);
modelStruct.modelPar_mu0fp2=mod.mu0fp2;
modelStruct.d_modelPar_mu0fp2_dX=0.0;
modelStruct.modelPar_given_mu0fp2=mod.given("mu0fp2");
modParamMap["mu0fp2"] = &(modelStruct.d_modelPar_mu0fp2_dX);
modelStruct.modelPar_betafp2=mod.betafp2;
modelStruct.d_modelPar_betafp2_dX=0.0;
modelStruct.modelPar_given_betafp2=mod.given("betafp2");
modParamMap["betafp2"] = &(modelStruct.d_modelPar_betafp2_dX);
modelStruct.modelPar_delta1fp2=mod.delta1fp2;
modelStruct.d_modelPar_delta1fp2_dX=0.0;
modelStruct.modelPar_given_delta1fp2=mod.given("delta1fp2");
modParamMap["delta1fp2"] = &(modelStruct.d_modelPar_delta1fp2_dX);
modelStruct.modelPar_sfp2=mod.sfp2;
modelStruct.d_modelPar_sfp2_dX=0.0;
modelStruct.modelPar_given_sfp2=mod.given("sfp2");
modParamMap["sfp2"] = &(modelStruct.d_modelPar_sfp2_dX);
modelStruct.modelPar_ndfp2=mod.ndfp2;
modelStruct.d_modelPar_ndfp2_dX=0.0;
modelStruct.modelPar_given_ndfp2=mod.given("ndfp2");
modParamMap["ndfp2"] = &(modelStruct.d_modelPar_ndfp2_dX);
modelStruct.modelPar_vthetafp2=mod.vthetafp2;
modelStruct.d_modelPar_vthetafp2_dX=0.0;
modelStruct.modelPar_given_vthetafp2=mod.given("vthetafp2");
modParamMap["vthetafp2"] = &(modelStruct.d_modelPar_vthetafp2_dX);
modelStruct.modelPar_mthetafp2=mod.mthetafp2;
modelStruct.d_modelPar_mthetafp2_dX=0.0;
modelStruct.modelPar_given_mthetafp2=mod.given("mthetafp2");
modParamMap["mthetafp2"] = &(modelStruct.d_modelPar_mthetafp2_dX);
modelStruct.modelPar_alphafp2=mod.alphafp2;
modelStruct.d_modelPar_alphafp2_dX=0.0;
modelStruct.modelPar_given_alphafp2=mod.given("alphafp2");
modParamMap["alphafp2"] = &(modelStruct.d_modelPar_alphafp2_dX);
modelStruct.modelPar_lgfp3=mod.lgfp3;
modelStruct.d_modelPar_lgfp3_dX=0.0;
modelStruct.modelPar_given_lgfp3=mod.given("lgfp3");
modParamMap["lgfp3"] = &(modelStruct.d_modelPar_lgfp3_dX);
modelStruct.modelPar_vtofp3=mod.vtofp3;
modelStruct.d_modelPar_vtofp3_dX=0.0;
modelStruct.modelPar_given_vtofp3=mod.given("vtofp3");
modParamMap["vtofp3"] = &(modelStruct.d_modelPar_vtofp3_dX);
modelStruct.modelPar_cgfp3=mod.cgfp3;
modelStruct.d_modelPar_cgfp3_dX=0.0;
modelStruct.modelPar_given_cgfp3=mod.given("cgfp3");
modParamMap["cgfp3"] = &(modelStruct.d_modelPar_cgfp3_dX);
modelStruct.modelPar_cfp3s=mod.cfp3s;
modelStruct.d_modelPar_cfp3s_dX=0.0;
modelStruct.modelPar_given_cfp3s=mod.given("cfp3s");
modParamMap["cfp3s"] = &(modelStruct.d_modelPar_cfp3s_dX);
modelStruct.modelPar_ccfp3=mod.ccfp3;
modelStruct.d_modelPar_ccfp3_dX=0.0;
modelStruct.modelPar_given_ccfp3=mod.given("ccfp3");
modParamMap["ccfp3"] = &(modelStruct.d_modelPar_ccfp3_dX);
modelStruct.modelPar_cbfp3=mod.cbfp3;
modelStruct.d_modelPar_cbfp3_dX=0.0;
modelStruct.modelPar_given_cbfp3=mod.given("cbfp3");
modParamMap["cbfp3"] = &(modelStruct.d_modelPar_cbfp3_dX);
modelStruct.modelPar_vx0fp3=mod.vx0fp3;
modelStruct.d_modelPar_vx0fp3_dX=0.0;
modelStruct.modelPar_given_vx0fp3=mod.given("vx0fp3");
modParamMap["vx0fp3"] = &(modelStruct.d_modelPar_vx0fp3_dX);
modelStruct.modelPar_mu0fp3=mod.mu0fp3;
modelStruct.d_modelPar_mu0fp3_dX=0.0;
modelStruct.modelPar_given_mu0fp3=mod.given("mu0fp3");
modParamMap["mu0fp3"] = &(modelStruct.d_modelPar_mu0fp3_dX);
modelStruct.modelPar_betafp3=mod.betafp3;
modelStruct.d_modelPar_betafp3_dX=0.0;
modelStruct.modelPar_given_betafp3=mod.given("betafp3");
modParamMap["betafp3"] = &(modelStruct.d_modelPar_betafp3_dX);
modelStruct.modelPar_delta1fp3=mod.delta1fp3;
modelStruct.d_modelPar_delta1fp3_dX=0.0;
modelStruct.modelPar_given_delta1fp3=mod.given("delta1fp3");
modParamMap["delta1fp3"] = &(modelStruct.d_modelPar_delta1fp3_dX);
modelStruct.modelPar_sfp3=mod.sfp3;
modelStruct.d_modelPar_sfp3_dX=0.0;
modelStruct.modelPar_given_sfp3=mod.given("sfp3");
modParamMap["sfp3"] = &(modelStruct.d_modelPar_sfp3_dX);
modelStruct.modelPar_ndfp3=mod.ndfp3;
modelStruct.d_modelPar_ndfp3_dX=0.0;
modelStruct.modelPar_given_ndfp3=mod.given("ndfp3");
modParamMap["ndfp3"] = &(modelStruct.d_modelPar_ndfp3_dX);
modelStruct.modelPar_vthetafp3=mod.vthetafp3;
modelStruct.d_modelPar_vthetafp3_dX=0.0;
modelStruct.modelPar_given_vthetafp3=mod.given("vthetafp3");
modParamMap["vthetafp3"] = &(modelStruct.d_modelPar_vthetafp3_dX);
modelStruct.modelPar_mthetafp3=mod.mthetafp3;
modelStruct.d_modelPar_mthetafp3_dX=0.0;
modelStruct.modelPar_given_mthetafp3=mod.given("mthetafp3");
modParamMap["mthetafp3"] = &(modelStruct.d_modelPar_mthetafp3_dX);
modelStruct.modelPar_alphafp3=mod.alphafp3;
modelStruct.d_modelPar_alphafp3_dX=0.0;
modelStruct.modelPar_given_alphafp3=mod.given("alphafp3");
modParamMap["alphafp3"] = &(modelStruct.d_modelPar_alphafp3_dX);
modelStruct.modelPar_lgfp4=mod.lgfp4;
modelStruct.d_modelPar_lgfp4_dX=0.0;
modelStruct.modelPar_given_lgfp4=mod.given("lgfp4");
modParamMap["lgfp4"] = &(modelStruct.d_modelPar_lgfp4_dX);
modelStruct.modelPar_vtofp4=mod.vtofp4;
modelStruct.d_modelPar_vtofp4_dX=0.0;
modelStruct.modelPar_given_vtofp4=mod.given("vtofp4");
modParamMap["vtofp4"] = &(modelStruct.d_modelPar_vtofp4_dX);
modelStruct.modelPar_cgfp4=mod.cgfp4;
modelStruct.d_modelPar_cgfp4_dX=0.0;
modelStruct.modelPar_given_cgfp4=mod.given("cgfp4");
modParamMap["cgfp4"] = &(modelStruct.d_modelPar_cgfp4_dX);
modelStruct.modelPar_cfp4s=mod.cfp4s;
modelStruct.d_modelPar_cfp4s_dX=0.0;
modelStruct.modelPar_given_cfp4s=mod.given("cfp4s");
modParamMap["cfp4s"] = &(modelStruct.d_modelPar_cfp4s_dX);
modelStruct.modelPar_ccfp4=mod.ccfp4;
modelStruct.d_modelPar_ccfp4_dX=0.0;
modelStruct.modelPar_given_ccfp4=mod.given("ccfp4");
modParamMap["ccfp4"] = &(modelStruct.d_modelPar_ccfp4_dX);
modelStruct.modelPar_cbfp4=mod.cbfp4;
modelStruct.d_modelPar_cbfp4_dX=0.0;
modelStruct.modelPar_given_cbfp4=mod.given("cbfp4");
modParamMap["cbfp4"] = &(modelStruct.d_modelPar_cbfp4_dX);
modelStruct.modelPar_vx0fp4=mod.vx0fp4;
modelStruct.d_modelPar_vx0fp4_dX=0.0;
modelStruct.modelPar_given_vx0fp4=mod.given("vx0fp4");
modParamMap["vx0fp4"] = &(modelStruct.d_modelPar_vx0fp4_dX);
modelStruct.modelPar_mu0fp4=mod.mu0fp4;
modelStruct.d_modelPar_mu0fp4_dX=0.0;
modelStruct.modelPar_given_mu0fp4=mod.given("mu0fp4");
modParamMap["mu0fp4"] = &(modelStruct.d_modelPar_mu0fp4_dX);
modelStruct.modelPar_betafp4=mod.betafp4;
modelStruct.d_modelPar_betafp4_dX=0.0;
modelStruct.modelPar_given_betafp4=mod.given("betafp4");
modParamMap["betafp4"] = &(modelStruct.d_modelPar_betafp4_dX);
modelStruct.modelPar_delta1fp4=mod.delta1fp4;
modelStruct.d_modelPar_delta1fp4_dX=0.0;
modelStruct.modelPar_given_delta1fp4=mod.given("delta1fp4");
modParamMap["delta1fp4"] = &(modelStruct.d_modelPar_delta1fp4_dX);
modelStruct.modelPar_sfp4=mod.sfp4;
modelStruct.d_modelPar_sfp4_dX=0.0;
modelStruct.modelPar_given_sfp4=mod.given("sfp4");
modParamMap["sfp4"] = &(modelStruct.d_modelPar_sfp4_dX);
modelStruct.modelPar_ndfp4=mod.ndfp4;
modelStruct.d_modelPar_ndfp4_dX=0.0;
modelStruct.modelPar_given_ndfp4=mod.given("ndfp4");
modParamMap["ndfp4"] = &(modelStruct.d_modelPar_ndfp4_dX);
modelStruct.modelPar_vthetafp4=mod.vthetafp4;
modelStruct.d_modelPar_vthetafp4_dX=0.0;
modelStruct.modelPar_given_vthetafp4=mod.given("vthetafp4");
modParamMap["vthetafp4"] = &(modelStruct.d_modelPar_vthetafp4_dX);
modelStruct.modelPar_mthetafp4=mod.mthetafp4;
modelStruct.d_modelPar_mthetafp4_dX=0.0;
modelStruct.modelPar_given_mthetafp4=mod.given("mthetafp4");
modParamMap["mthetafp4"] = &(modelStruct.d_modelPar_mthetafp4_dX);
modelStruct.modelPar_alphafp4=mod.alphafp4;
modelStruct.d_modelPar_alphafp4_dX=0.0;
modelStruct.modelPar_given_alphafp4=mod.given("alphafp4");
modParamMap["alphafp4"] = &(modelStruct.d_modelPar_alphafp4_dX);
modelStruct.modelPar_rgsp=mod.rgsp;
modelStruct.d_modelPar_rgsp_dX=0.0;
modelStruct.modelPar_given_rgsp=mod.given("rgsp");
modParamMap["rgsp"] = &(modelStruct.d_modelPar_rgsp_dX);
modelStruct.modelPar_vjg=mod.vjg;
modelStruct.d_modelPar_vjg_dX=0.0;
modelStruct.modelPar_given_vjg=mod.given("vjg");
modParamMap["vjg"] = &(modelStruct.d_modelPar_vjg_dX);
modelStruct.modelPar_pg_param1=mod.pg_param1;
modelStruct.d_modelPar_pg_param1_dX=0.0;
modelStruct.modelPar_given_pg_param1=mod.given("pg_param1");
modParamMap["pg_param1"] = &(modelStruct.d_modelPar_pg_param1_dX);
modelStruct.modelPar_pg_params=mod.pg_params;
modelStruct.d_modelPar_pg_params_dX=0.0;
modelStruct.modelPar_given_pg_params=mod.given("pg_params");
modParamMap["pg_params"] = &(modelStruct.d_modelPar_pg_params_dX);
modelStruct.modelPar_ijs=mod.ijs;
modelStruct.d_modelPar_ijs_dX=0.0;
modelStruct.modelPar_given_ijs=mod.given("ijs");
modParamMap["ijs"] = &(modelStruct.d_modelPar_ijs_dX);
modelStruct.modelPar_vgsats=mod.vgsats;
modelStruct.d_modelPar_vgsats_dX=0.0;
modelStruct.modelPar_given_vgsats=mod.given("vgsats");
modParamMap["vgsats"] = &(modelStruct.d_modelPar_vgsats_dX);
modelStruct.modelPar_fracs=mod.fracs;
modelStruct.d_modelPar_fracs_dX=0.0;
modelStruct.modelPar_given_fracs=mod.given("fracs");
modParamMap["fracs"] = &(modelStruct.d_modelPar_fracs_dX);
modelStruct.modelPar_alphags=mod.alphags;
modelStruct.d_modelPar_alphags_dX=0.0;
modelStruct.modelPar_given_alphags=mod.given("alphags");
modParamMap["alphags"] = &(modelStruct.d_modelPar_alphags_dX);
modelStruct.modelPar_pg_paramd=mod.pg_paramd;
modelStruct.d_modelPar_pg_paramd_dX=0.0;
modelStruct.modelPar_given_pg_paramd=mod.given("pg_paramd");
modParamMap["pg_paramd"] = &(modelStruct.d_modelPar_pg_paramd_dX);
modelStruct.modelPar_ijd=mod.ijd;
modelStruct.d_modelPar_ijd_dX=0.0;
modelStruct.modelPar_given_ijd=mod.given("ijd");
modParamMap["ijd"] = &(modelStruct.d_modelPar_ijd_dX);
modelStruct.modelPar_vgsatd=mod.vgsatd;
modelStruct.d_modelPar_vgsatd_dX=0.0;
modelStruct.modelPar_given_vgsatd=mod.given("vgsatd");
modParamMap["vgsatd"] = &(modelStruct.d_modelPar_vgsatd_dX);
modelStruct.modelPar_fracd=mod.fracd;
modelStruct.d_modelPar_fracd_dX=0.0;
modelStruct.modelPar_given_fracd=mod.given("fracd");
modParamMap["fracd"] = &(modelStruct.d_modelPar_fracd_dX);
modelStruct.modelPar_alphagd=mod.alphagd;
modelStruct.d_modelPar_alphagd_dX=0.0;
modelStruct.modelPar_given_alphagd=mod.given("alphagd");
modParamMap["alphagd"] = &(modelStruct.d_modelPar_alphagd_dX);
modelStruct.modelPar_pgsrecs=mod.pgsrecs;
modelStruct.d_modelPar_pgsrecs_dX=0.0;
modelStruct.modelPar_given_pgsrecs=mod.given("pgsrecs");
modParamMap["pgsrecs"] = &(modelStruct.d_modelPar_pgsrecs_dX);
modelStruct.modelPar_irecs=mod.irecs;
modelStruct.d_modelPar_irecs_dX=0.0;
modelStruct.modelPar_given_irecs=mod.given("irecs");
modParamMap["irecs"] = &(modelStruct.d_modelPar_irecs_dX);
modelStruct.modelPar_vgsatqs=mod.vgsatqs;
modelStruct.d_modelPar_vgsatqs_dX=0.0;
modelStruct.modelPar_given_vgsatqs=mod.given("vgsatqs");
modParamMap["vgsatqs"] = &(modelStruct.d_modelPar_vgsatqs_dX);
modelStruct.modelPar_vbdgs=mod.vbdgs;
modelStruct.d_modelPar_vbdgs_dX=0.0;
modelStruct.modelPar_given_vbdgs=mod.given("vbdgs");
modParamMap["vbdgs"] = &(modelStruct.d_modelPar_vbdgs_dX);
modelStruct.modelPar_pbdgs=mod.pbdgs;
modelStruct.d_modelPar_pbdgs_dX=0.0;
modelStruct.modelPar_given_pbdgs=mod.given("pbdgs");
modParamMap["pbdgs"] = &(modelStruct.d_modelPar_pbdgs_dX);
modelStruct.modelPar_betarecs=mod.betarecs;
modelStruct.d_modelPar_betarecs_dX=0.0;
modelStruct.modelPar_given_betarecs=mod.given("betarecs");
modParamMap["betarecs"] = &(modelStruct.d_modelPar_betarecs_dX);
modelStruct.modelPar_kbdgates=mod.kbdgates;
modelStruct.d_modelPar_kbdgates_dX=0.0;
modelStruct.modelPar_given_kbdgates=mod.given("kbdgates");
modParamMap["kbdgates"] = &(modelStruct.d_modelPar_kbdgates_dX);
modelStruct.modelPar_pgsrecd=mod.pgsrecd;
modelStruct.d_modelPar_pgsrecd_dX=0.0;
modelStruct.modelPar_given_pgsrecd=mod.given("pgsrecd");
modParamMap["pgsrecd"] = &(modelStruct.d_modelPar_pgsrecd_dX);
modelStruct.modelPar_irecd=mod.irecd;
modelStruct.d_modelPar_irecd_dX=0.0;
modelStruct.modelPar_given_irecd=mod.given("irecd");
modParamMap["irecd"] = &(modelStruct.d_modelPar_irecd_dX);
modelStruct.modelPar_vgsatqd=mod.vgsatqd;
modelStruct.d_modelPar_vgsatqd_dX=0.0;
modelStruct.modelPar_given_vgsatqd=mod.given("vgsatqd");
modParamMap["vgsatqd"] = &(modelStruct.d_modelPar_vgsatqd_dX);
modelStruct.modelPar_vbdgd=mod.vbdgd;
modelStruct.d_modelPar_vbdgd_dX=0.0;
modelStruct.modelPar_given_vbdgd=mod.given("vbdgd");
modParamMap["vbdgd"] = &(modelStruct.d_modelPar_vbdgd_dX);
modelStruct.modelPar_pbdgd=mod.pbdgd;
modelStruct.d_modelPar_pbdgd_dX=0.0;
modelStruct.modelPar_given_pbdgd=mod.given("pbdgd");
modParamMap["pbdgd"] = &(modelStruct.d_modelPar_pbdgd_dX);
modelStruct.modelPar_betarecd=mod.betarecd;
modelStruct.d_modelPar_betarecd_dX=0.0;
modelStruct.modelPar_given_betarecd=mod.given("betarecd");
modParamMap["betarecd"] = &(modelStruct.d_modelPar_betarecd_dX);
modelStruct.modelPar_kbdgated=mod.kbdgated;
modelStruct.d_modelPar_kbdgated_dX=0.0;
modelStruct.modelPar_given_kbdgated=mod.given("kbdgated");
modParamMap["kbdgated"] = &(modelStruct.d_modelPar_kbdgated_dX);
modelStruct.modelPar_rth=mod.rth;
modelStruct.d_modelPar_rth_dX=0.0;
modelStruct.modelPar_given_rth=mod.given("rth");
modParamMap["rth"] = &(modelStruct.d_modelPar_rth_dX);
modelStruct.modelPar_cth=mod.cth;
modelStruct.d_modelPar_cth_dX=0.0;
modelStruct.modelPar_given_cth=mod.given("cth");
modParamMap["cth"] = &(modelStruct.d_modelPar_cth_dX);
modelStruct.modelPar_taugmrf=mod.taugmrf;
modelStruct.d_modelPar_taugmrf_dX=0.0;
modelStruct.modelPar_given_taugmrf=mod.given("taugmrf");
modParamMap["taugmrf"] = &(modelStruct.d_modelPar_taugmrf_dX);
modelStruct.modelPar_ctrap=mod.ctrap;
modelStruct.d_modelPar_ctrap_dX=0.0;
modelStruct.modelPar_given_ctrap=mod.given("ctrap");
modParamMap["ctrap"] = &(modelStruct.d_modelPar_ctrap_dX);
modelStruct.modelPar_vttrap=mod.vttrap;
modelStruct.d_modelPar_vttrap_dX=0.0;
modelStruct.modelPar_given_vttrap=mod.given("vttrap");
modParamMap["vttrap"] = &(modelStruct.d_modelPar_vttrap_dX);
modelStruct.modelPar_taut=mod.taut;
modelStruct.d_modelPar_taut_dX=0.0;
modelStruct.modelPar_given_taut=mod.given("taut");
modParamMap["taut"] = &(modelStruct.d_modelPar_taut_dX);
modelStruct.modelPar_alphat1=mod.alphat1;
modelStruct.d_modelPar_alphat1_dX=0.0;
modelStruct.modelPar_given_alphat1=mod.given("alphat1");
modParamMap["alphat1"] = &(modelStruct.d_modelPar_alphat1_dX);
modelStruct.modelPar_alphat2=mod.alphat2;
modelStruct.d_modelPar_alphat2_dX=0.0;
modelStruct.modelPar_given_alphat2=mod.given("alphat2");
modParamMap["alphat2"] = &(modelStruct.d_modelPar_alphat2_dX);
modelStruct.modelPar_tempt=mod.tempt;
modelStruct.d_modelPar_tempt_dX=0.0;
modelStruct.modelPar_given_tempt=mod.given("tempt");
modParamMap["tempt"] = &(modelStruct.d_modelPar_tempt_dX);
modelStruct.modelPar_shs=mod.shs;
modelStruct.d_modelPar_shs_dX=0.0;
modelStruct.modelPar_given_shs=mod.given("shs");
modParamMap["shs"] = &(modelStruct.d_modelPar_shs_dX);
modelStruct.modelPar_shd=mod.shd;
modelStruct.d_modelPar_shd_dX=0.0;
modelStruct.modelPar_given_shd=mod.given("shd");
modParamMap["shd"] = &(modelStruct.d_modelPar_shd_dX);
modelStruct.modelPar_kf=mod.kf;
modelStruct.d_modelPar_kf_dX=0.0;
modelStruct.modelPar_given_kf=mod.given("kf");
modParamMap["kf"] = &(modelStruct.d_modelPar_kf_dX);
modelStruct.modelPar_af=mod.af;
modelStruct.d_modelPar_af_dX=0.0;
modelStruct.modelPar_given_af=mod.given("af");
modParamMap["af"] = &(modelStruct.d_modelPar_af_dX);
modelStruct.modelPar_ffe=mod.ffe;
modelStruct.d_modelPar_ffe_dX=0.0;
modelStruct.modelPar_given_ffe=mod.given("ffe");
modParamMap["ffe"] = &(modelStruct.d_modelPar_ffe_dX);
modelStruct.modelPar_minr=mod.minr;
modelStruct.d_modelPar_minr_dX=0.0;
modelStruct.modelPar_given_minr=mod.given("minr");
modParamMap["minr"] = &(modelStruct.d_modelPar_minr_dX);
modelStruct.modelPar_minl=mod.minl;
modelStruct.d_modelPar_minl_dX=0.0;
modelStruct.modelPar_given_minl=mod.given("minl");
modParamMap["minl"] = &(modelStruct.d_modelPar_minl_dX);
modelStruct.modelPar_minc=mod.minc;
modelStruct.d_modelPar_minc_dX=0.0;
modelStruct.modelPar_given_minc=mod.given("minc");
modParamMap["minc"] = &(modelStruct.d_modelPar_minc_dX);
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modParamMap["LMIN"] = &(modelStruct.d_modelPar_LMIN_dX);
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modParamMap["WMIN"] = &(modelStruct.d_modelPar_WMIN_dX);
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modParamMap["LMAX"] = &(modelStruct.d_modelPar_LMAX_dX);
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");
modParamMap["WMAX"] = &(modelStruct.d_modelPar_WMAX_dX);


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_type=mod.type;
modelStruct.modelPar_given_type=mod.given("type");
modelStruct.modelPar_flagres=mod.flagres;
modelStruct.modelPar_given_flagres=mod.given("flagres");
modelStruct.modelPar_flagfp1=mod.flagfp1;
modelStruct.modelPar_given_flagfp1=mod.given("flagfp1");
modelStruct.modelPar_flagfp1s=mod.flagfp1s;
modelStruct.modelPar_given_flagfp1s=mod.given("flagfp1s");
modelStruct.modelPar_flagfp2=mod.flagfp2;
modelStruct.modelPar_given_flagfp2=mod.given("flagfp2");
modelStruct.modelPar_flagfp2s=mod.flagfp2s;
modelStruct.modelPar_given_flagfp2s=mod.given("flagfp2s");
modelStruct.modelPar_flagfp3=mod.flagfp3;
modelStruct.modelPar_given_flagfp3=mod.given("flagfp3");
modelStruct.modelPar_flagfp3s=mod.flagfp3s;
modelStruct.modelPar_given_flagfp3s=mod.given("flagfp3s");
modelStruct.modelPar_flagfp4=mod.flagfp4;
modelStruct.modelPar_given_flagfp4=mod.given("flagfp4");
modelStruct.modelPar_flagfp4s=mod.flagfp4s;
modelStruct.modelPar_given_flagfp4s=mod.given("flagfp4s");
modelStruct.modelPar_igmod=mod.igmod;
modelStruct.modelPar_given_igmod=mod.given("igmod");
modelStruct.modelPar_gmdisp=mod.gmdisp;
modelStruct.modelPar_given_gmdisp=mod.given("gmdisp");
modelStruct.modelPar_trapselect=mod.trapselect;
modelStruct.modelPar_given_trapselect=mod.given("trapselect");
modelStruct.modelPar_noisemod=mod.noisemod;
modelStruct.modelPar_given_noisemod=mod.given("noisemod");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals


// non-reals



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 18+0 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals
instanceStruct.instancePar_w=in.w;
instanceStruct.d_instancePar_w_dX=0.0;
instanceStruct.instancePar_given_w=in.given("w");
instanceStruct.instancePar_l=in.l;
instanceStruct.d_instancePar_l_dX=0.0;
instanceStruct.instancePar_given_l=in.given("l");
instanceStruct.instancePar_dtemp=in.dtemp;
instanceStruct.d_instancePar_dtemp_dX=0.0;
instanceStruct.instancePar_given_dtemp=in.given("dtemp");


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:
instanceStruct.instancePar_ngf=in.ngf;
instanceStruct.instancePar_given_ngf=in.given("ngf");




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.


  //make local copies of all instance vars
  //reals
instanceStruct.instanceVar_rcs_w=in.rcs_w;
instanceStruct.d_instanceVar_rcs_w_dX=0.0;
instanceStruct.instanceVar_rcd_w=in.rcd_w;
instanceStruct.d_instanceVar_rcd_w_dX=0.0;
instanceStruct.instanceVar_rg=in.rg;
instanceStruct.d_instanceVar_rg_dX=0.0;


  //non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_si_GND] = (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_b_GND] = (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_di_GND] = (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_gi_GND] = (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_drc_d] = (*solVectorPtr)[in.li_drc] - (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_gi_b] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_s_b] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_d_b] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_b];
probeVars[in.admsProbeID_V_d_s] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_gi_d] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_gi_s] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_g_gi] = (*solVectorPtr)[in.li_g] - (*solVectorPtr)[in.li_gi];
probeVars[in.admsProbeID_V_d_drc] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_drc];
probeVars[in.admsProbeID_V_xt1_GND] = (in.collapseNode_xt1)?(0):((*solVectorPtr)[in.li_xt1]);
probeVars[in.admsProbeID_V_xt2_GND] = (in.collapseNode_xt2)?(0):((*solVectorPtr)[in.li_xt2]);
probeVars[in.admsProbeID_V_s_fp4] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp4];
probeVars[in.admsProbeID_V_gi_fp4] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp4];
probeVars[in.admsProbeID_V_b_fp3] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_fp4_fp3] = (*solVectorPtr)[in.li_fp4] - (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_s_fp3] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_gi_fp3] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp3];
probeVars[in.admsProbeID_V_b_fp2] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_fp3_fp2] = (*solVectorPtr)[in.li_fp3] - (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_s_fp2] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_gi_fp2] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp2];
probeVars[in.admsProbeID_V_b_fp1] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_fp2_fp1] = (*solVectorPtr)[in.li_fp2] - (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_s_fp1] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_gi_fp1] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_fp1];
probeVars[in.admsProbeID_V_b_di] = (*solVectorPtr)[in.li_b] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_fp1_di] = (*solVectorPtr)[in.li_fp1] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_s_di] = (*solVectorPtr)[in.li_s] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_gi_di] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_di];
probeVars[in.admsProbeID_V_drc_fp4] = (*solVectorPtr)[in.li_drc] - (*solVectorPtr)[in.li_fp4];
probeVars[in.admsProbeID_V_fp4_s] = (*solVectorPtr)[in.li_fp4] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_fp4_d] = (*solVectorPtr)[in.li_fp4] - (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_tr_GND] = (in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]);
probeVars[in.admsProbeID_V_tr1_tr] = (in.collapseNode_tr1)?(0):((*solVectorPtr)[in.li_tr1]) - ((in.collapseNode_tr)?(0):((*solVectorPtr)[in.li_tr]));
probeVars[in.admsProbeID_V_d_g] = (*solVectorPtr)[in.li_d] - (*solVectorPtr)[in.li_g];
probeVars[in.admsProbeID_V_si_src] = (*solVectorPtr)[in.li_si] - (*solVectorPtr)[in.li_src];
probeVars[in.admsProbeID_V_src_s] = (*solVectorPtr)[in.li_src] - (*solVectorPtr)[in.li_s];
probeVars[in.admsProbeID_V_src_d] = (*solVectorPtr)[in.li_src] - (*solVectorPtr)[in.li_d];
probeVars[in.admsProbeID_V_gi_si] = (*solVectorPtr)[in.li_gi] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_V_di_si] = (*solVectorPtr)[in.li_di] - (*solVectorPtr)[in.li_si];
probeVars[in.admsProbeID_Temp_dt_GND] = (in.collapseNode_dt)?(0):((*solVectorPtr)[in.li_dt]);


evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_si_GND,
in.admsProbeID_V_b_GND,
in.admsProbeID_V_di_GND,
in.admsProbeID_V_gi_GND,
in.admsProbeID_V_drc_d,
in.admsProbeID_V_gi_b,
in.admsProbeID_V_s_b,
in.admsProbeID_V_d_b,
in.admsProbeID_V_d_s,
in.admsProbeID_V_gi_d,
in.admsProbeID_V_gi_s,
in.admsProbeID_V_g_gi,
in.admsProbeID_V_d_drc,
in.admsProbeID_V_xt1_GND,
in.admsProbeID_V_xt2_GND,
in.admsProbeID_V_s_fp4,
in.admsProbeID_V_gi_fp4,
in.admsProbeID_V_b_fp3,
in.admsProbeID_V_fp4_fp3,
in.admsProbeID_V_s_fp3,
in.admsProbeID_V_gi_fp3,
in.admsProbeID_V_b_fp2,
in.admsProbeID_V_fp3_fp2,
in.admsProbeID_V_s_fp2,
in.admsProbeID_V_gi_fp2,
in.admsProbeID_V_b_fp1,
in.admsProbeID_V_fp2_fp1,
in.admsProbeID_V_s_fp1,
in.admsProbeID_V_gi_fp1,
in.admsProbeID_V_b_di,
in.admsProbeID_V_fp1_di,
in.admsProbeID_V_s_di,
in.admsProbeID_V_gi_di,
in.admsProbeID_V_drc_fp4,
in.admsProbeID_V_fp4_s,
in.admsProbeID_V_fp4_d,
in.admsProbeID_V_tr_GND,
in.admsProbeID_V_tr1_tr,
in.admsProbeID_V_d_g,
in.admsProbeID_V_si_src,
in.admsProbeID_V_src_s,
in.admsProbeID_V_src_d,
in.admsProbeID_V_gi_si,
in.admsProbeID_V_di_si,
in.admsProbeID_Temp_dt_GND,

// node constants
in.admsNodeID_d,
in.admsNodeID_g,
in.admsNodeID_s,
in.admsNodeID_b,
in.admsNodeID_di,
in.admsNodeID_gi,
in.admsNodeID_si,
in.admsNodeID_fp1,
in.admsNodeID_fp2,
in.admsNodeID_fp3,
in.admsNodeID_fp4,
in.admsNodeID_drc,
in.admsNodeID_src,
in.admsNodeID_tr,
in.admsNodeID_tr1,
in.admsNodeID_xt1,
in.admsNodeID_xt2,
in.admsNodeID_dt,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_d+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_d];
    dqdp[in.admsNodeID_d+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_d];
    Findices[in.admsNodeID_d+inst*(18+0)] = in.li_d;
    Qindices[in.admsNodeID_d+inst*(18+0)] = in.li_d;
    dfdp[in.admsNodeID_g+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_g];
    dqdp[in.admsNodeID_g+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_g];
    Findices[in.admsNodeID_g+inst*(18+0)] = in.li_g;
    Qindices[in.admsNodeID_g+inst*(18+0)] = in.li_g;
    dfdp[in.admsNodeID_s+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_s];
    dqdp[in.admsNodeID_s+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_s];
    Findices[in.admsNodeID_s+inst*(18+0)] = in.li_s;
    Qindices[in.admsNodeID_s+inst*(18+0)] = in.li_s;
    dfdp[in.admsNodeID_b+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_b];
    dqdp[in.admsNodeID_b+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_b];
    Findices[in.admsNodeID_b+inst*(18+0)] = in.li_b;
    Qindices[in.admsNodeID_b+inst*(18+0)] = in.li_b;
    dfdp[in.admsNodeID_di+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_di];
    dqdp[in.admsNodeID_di+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_di];
    Findices[in.admsNodeID_di+inst*(18+0)] = in.li_di;
    Qindices[in.admsNodeID_di+inst*(18+0)] = in.li_di;
    dfdp[in.admsNodeID_gi+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_gi];
    dqdp[in.admsNodeID_gi+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_gi];
    Findices[in.admsNodeID_gi+inst*(18+0)] = in.li_gi;
    Qindices[in.admsNodeID_gi+inst*(18+0)] = in.li_gi;
    dfdp[in.admsNodeID_si+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_si];
    dqdp[in.admsNodeID_si+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_si];
    Findices[in.admsNodeID_si+inst*(18+0)] = in.li_si;
    Qindices[in.admsNodeID_si+inst*(18+0)] = in.li_si;
    dfdp[in.admsNodeID_fp1+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_fp1];
    dqdp[in.admsNodeID_fp1+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_fp1];
    Findices[in.admsNodeID_fp1+inst*(18+0)] = in.li_fp1;
    Qindices[in.admsNodeID_fp1+inst*(18+0)] = in.li_fp1;
    dfdp[in.admsNodeID_fp2+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_fp2];
    dqdp[in.admsNodeID_fp2+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_fp2];
    Findices[in.admsNodeID_fp2+inst*(18+0)] = in.li_fp2;
    Qindices[in.admsNodeID_fp2+inst*(18+0)] = in.li_fp2;
    dfdp[in.admsNodeID_fp3+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_fp3];
    dqdp[in.admsNodeID_fp3+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_fp3];
    Findices[in.admsNodeID_fp3+inst*(18+0)] = in.li_fp3;
    Qindices[in.admsNodeID_fp3+inst*(18+0)] = in.li_fp3;
    dfdp[in.admsNodeID_fp4+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_fp4];
    dqdp[in.admsNodeID_fp4+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_fp4];
    Findices[in.admsNodeID_fp4+inst*(18+0)] = in.li_fp4;
    Qindices[in.admsNodeID_fp4+inst*(18+0)] = in.li_fp4;
    dfdp[in.admsNodeID_drc+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_drc];
    dqdp[in.admsNodeID_drc+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_drc];
    Findices[in.admsNodeID_drc+inst*(18+0)] = in.li_drc;
    Qindices[in.admsNodeID_drc+inst*(18+0)] = in.li_drc;
    dfdp[in.admsNodeID_src+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_src];
    dqdp[in.admsNodeID_src+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_src];
    Findices[in.admsNodeID_src+inst*(18+0)] = in.li_src;
    Qindices[in.admsNodeID_src+inst*(18+0)] = in.li_src;
    dfdp[in.admsNodeID_tr+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_tr];
    dqdp[in.admsNodeID_tr+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_tr];
    Findices[in.admsNodeID_tr+inst*(18+0)] = in.li_tr;
    Qindices[in.admsNodeID_tr+inst*(18+0)] = in.li_tr;
    dfdp[in.admsNodeID_tr1+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_tr1];
    dqdp[in.admsNodeID_tr1+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_tr1];
    Findices[in.admsNodeID_tr1+inst*(18+0)] = in.li_tr1;
    Qindices[in.admsNodeID_tr1+inst*(18+0)] = in.li_tr1;
    dfdp[in.admsNodeID_xt1+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_xt1];
    dqdp[in.admsNodeID_xt1+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_xt1];
    Findices[in.admsNodeID_xt1+inst*(18+0)] = in.li_xt1;
    Qindices[in.admsNodeID_xt1+inst*(18+0)] = in.li_xt1;
    dfdp[in.admsNodeID_xt2+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_xt2];
    dqdp[in.admsNodeID_xt2+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_xt2];
    Findices[in.admsNodeID_xt2+inst*(18+0)] = in.li_xt2;
    Qindices[in.admsNodeID_xt2+inst*(18+0)] = in.li_xt2;
    dfdp[in.admsNodeID_dt+inst*(18+0)] += d_staticContributions_dX[in.admsNodeID_dt];
    dqdp[in.admsNodeID_dt+inst*(18+0)] += d_dynamicContributions_dX[in.admsNodeID_dt];
    Findices[in.admsNodeID_dt+inst*(18+0)] = in.li_dt;
    Qindices[in.admsNodeID_dt+inst*(18+0)] = in.li_dt;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSmvsg_cmc
} // namespace Device
} // namespace Xyce
